CREATE DATABASE  IF NOT EXISTS `scaling` /*!40100 DEFAULT CHARACTER SET latin1 */;
USE `scaling`;
-- MySQL dump 10.13  Distrib 5.7.20, for Linux (x86_64)
--
-- Host: 127.0.0.1    Database: scaling
-- ------------------------------------------------------
-- Server version	5.7.20-0ubuntu0.16.04.1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `animals`
--

DROP TABLE IF EXISTS `animals`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `animals` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `museum_id` varchar(255) NOT NULL COMMENT 'animal ID as assigned by museum',
  `alias_id` varchar(255) DEFAULT NULL COMMENT 'Some animals have another identifier, annoyingly',
  `museum` varchar(255) NOT NULL DEFAULT 'UMZC' COMMENT 'string naming museum / specimen source',
  `class` varchar(255) NOT NULL DEFAULT 'Mammalia',
  `order_` varchar(255) NOT NULL DEFAULT 'Carnivora',
  `family` varchar(255) NOT NULL DEFAULT 'Felidae',
  `genus` varchar(255) NOT NULL DEFAULT 'Panthera',
  `species` varchar(255) NOT NULL DEFAULT 'leo',
  `familiar` varchar(255) NOT NULL DEFAULT 'lion',
  `species_id` int(11) DEFAULT NULL COMMENT 'imported from species.id',
  `body_mass` double DEFAULT NULL COMMENT 'Body mass in kg, known values only',
  `est_body_mass` double DEFAULT NULL COMMENT 'Body mass in kg, estimated from literature',
  `sex` char(1) DEFAULT NULL COMMENT 'Male (M), female (F) or NULL if unknown',
  `died` date DEFAULT NULL COMMENT 'Date deceased if known',
  `born` date DEFAULT NULL COMMENT 'DOB if known',
  `notes` longtext,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=256 DEFAULT CHARSET=latin1 COMMENT='List of animals ';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `animals`
--

LOCK TABLES `animals` WRITE;
/*!40000 ALTER TABLE `animals` DISABLE KEYS */;
INSERT INTO `animals` VALUES (1,'K6682','K6682','UMZC','Mammalia','Carnivora','Felidae','Lynx','canadensis','Canadian lynx',14000152,11,11,NULL,NULL,NULL,NULL),(2,'K6681','K6681','UMZC','Mammalia','Carnivora','Felidae','Lynx','canadensis','Canadian lynx',14000152,11,11,NULL,NULL,NULL,NULL),(3,'K5741','K5741','UMZC','Mammalia','Carnivora','Felidae','Puma','concolor','cougar',14000204,60,60,NULL,NULL,NULL,NULL),(4,'K5466','K5466','UMZC','Mammalia','Carnivora','Felidae','Panthera','leo','lion',14000228,167,167,NULL,NULL,NULL,NULL),(7,'ZD 1940.1.20.17','NHM1940b','NHM','Mammalia','Carnivora','Felidae','Acinonyx','jubatus','cheetah',14000006,52,52,NULL,NULL,NULL,NULL),(8,'ZD 1991.588','NHM1991','NHM','Mammalia','Carnivora','Felidae','Acinonyx','jubatus','cheetah',14000006,52,52,NULL,NULL,NULL,NULL),(11,'ZD 1862.3.19.15_1232.d','NHM1232','NHM','Mammalia','Carnivora','Felidae','Leopardus','pardalis','ocelot',14000103,14,14,NULL,NULL,NULL,NULL),(12,'ZD 1952.1083',NULL,'NHM','Mammalia','Carnivora','Felidae','Leopardus','pardalis','ocelot',14000103,14,14,NULL,NULL,NULL,NULL),(13,'ZD 1880.2.16.1','NHM1880','NHM','Mammalia','Carnivora','Felidae','Panthera','pardus','leopard',14000250,50,50,NULL,NULL,NULL,NULL),(14,'ZD 1940.1.20.18','NHM1940a','NHM','Mammalia','Carnivora','Felidae','Panthera','pardus','leopard',14000250,50,50,NULL,NULL,NULL,NULL),(16,'ZD 1961.8.9.82','nhmele13','NHM','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,4800,4800,NULL,NULL,NULL,'Young adult, some growth plates incompletely closed'),(17,'ZD 1939.5.27.1','nhmele15','NHM','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,5500,5500,NULL,NULL,NULL,'This elephant was very old'),(18,'Cambridge_Asian','camb_ele','zoo','Mammalia','Proboscidea','Elephantidae','Elephas','maximus','Asian elephant',11500004,3400,3400,NULL,NULL,NULL,NULL),(19,'beauty','beauty','zoo','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,4000,4000,NULL,NULL,NULL,'The species of this individual is unknown'),(20,'ZD 133e','NHM133','NHM','Mammalia','Carnivora','Felidae','Leptailurus','serval','serval',14000132,16,16,NULL,NULL,NULL,NULL),(21,'ZD 1966.7.11.1','NHM1966','NHM','Mammalia','Carnivora','Felidae','Leptailurus','serval','serval',14000132,16,16,NULL,NULL,NULL,NULL),(22,'ZD 1851.5.5.2','NHM1851A','NHM','Mammalia','Carnivora','Felidae','Panthera','tigris','tiger',14000259,160,160,NULL,NULL,NULL,NULL),(23,'ZD 78.2460','NHM78','NHM','Mammalia','Carnivora','Felidae','Panthera','tigris','tiger',14000259,160,160,NULL,NULL,NULL,NULL),(25,'RVCfcatus21','RVCfcatus21','RVC','Mammalia','Carnivora','Felidae','Felis','catus','domestic cat',14000031,3,3,NULL,NULL,NULL,'PM and bone cleaning performed by AWC at RVC, July-August 2008'),(26,'ZD 1984.507','nhmele9','NHM','Mammalia','Proboscidea','Elephantidae','Elephant','elephant','unknown elephant 2',11500002,4000,4000,NULL,NULL,NULL,'This elephant is of unknown species	'),(27,'ZD 1918.5.22.2','nhmele5','NHM','Mammalia','Proboscidea','Elephantidae','Elephant','elephant','unknown elephant 3',11500002,4000,4000,NULL,NULL,NULL,'THis elephant is of unknown species'),(28,'E4063C','E4063C','UMZC','Mammalia','Scandentia','Tupaiidae','Tupaia','picta','painted tree shrew',11900041,NULL,0.343,NULL,NULL,NULL,NULL),(29,'K2241','K2241','UMZC','Mammalia','Carnivora','Mustelidae','Martes','americana','American marten',14001204,NULL,0.863,NULL,NULL,NULL,NULL),(30,'K2521','K2521','UMZC','Mammalia','Carnivora','Mustelidae','Mustela','erminea','ermine',14001334,NULL,0.273,'',NULL,NULL,NULL),(31,'E3832','E3832','UMZC','Mammalia','Lagomorpha','Leporidae','Lepus','timidus','mountain hare',13500221,NULL,3.625,NULL,NULL,NULL,NULL),(32,'E5131J','E5131J','UMZC','Mammalia','Erinaceomorpha','Erinaceidae','Erinaceus','europaeus','West European hedgehog',13600020,NULL,0.86,NULL,NULL,NULL,NULL),(33,'E4061C','E4061C','UMZC','Mammalia','Scandentia','Tupaiidae','Tupaia','belangeri','common tree shrew',11900011,NULL,0.135,NULL,NULL,NULL,NULL),(34,'K2266','K2266','UMZC','Mammalia','Carnivora','Mustelidae','Martes','pennanti','fisher',14001254,NULL,3.275,NULL,NULL,NULL,NULL),(35,'K2361','K2361','UMZC','Mammalia','Carnivora','Mustelidae','Mustela','putorius','polecat',14001460,NULL,1.155,NULL,NULL,NULL,NULL),(36,'K3585','K3585','UMZC','Mammalia','Carnivora','Canidae','Vulpes','vulpes','red fox',14000892,NULL,6.125,NULL,NULL,NULL,NULL),(37,'K3668','K3668','UMZC','Mammalia','Carnivora','Canidae','Vulpes','lagopus','Arctic fox',14000873,NULL,3.45,NULL,NULL,NULL,NULL),(38,'K4695','K4695','UMZC','Mammalia','Carnivora','Herpestidae','Herpestes','ichneumon','Egyptian mongoose',14000596,NULL,3.35,NULL,NULL,NULL,NULL),(39,'H15013','H15013','UMZC','Mammalia','Artiodactyla','Tragulidae','Tragulus','javanicus','Java mouse-deer',14200129,1.413,1.413,NULL,NULL,NULL,NULL),(40,'H14975','H14975','UMZC','Mammalia','Artiodactyla','Tragulidae','Tragulus','napu','greater mouse-deer',14200161,5.27367,5.27367,NULL,NULL,NULL,NULL),(41,'A12.52/2','A12.52-2','UMZC','Mammalia','Diprotodontia','Macropodidae','Petrogale','xanthopus','yellow-footed rock-wallaby',11000296,8.49999,8.49999,NULL,NULL,NULL,NULL),(42,'A12.84/2','A12.84-2','UMZC','Mammalia','Diprotodontia','Potoroidae','Potorous','tridactylus','long-nosed potoroo',11000190,1.08,1.08,NULL,NULL,NULL,NULL),(43,'A12.82/3','A12.82-3','UMZC','Mammalia','Diprotodontia','Potoroidae','Bettongia','lesueur','boodie',11000181,1.15,1.15,NULL,NULL,NULL,NULL),(44,'E3369','E3369','UMZC','Mammalia','Rodentia','Myocastoridae','Myocastor','coypus','coypu',13400557,NULL,7.5,NULL,NULL,NULL,NULL),(45,'E1459','E1459','UMZC','Mammalia','Rodentia','Pedetidae','Pedetes','surdaster','East African spring hare',13200004,NULL,2.93,NULL,NULL,NULL,NULL),(46,'E1445','E1445','UMZC','Mammalia','Rodentia','Pedetidae','Pedetes','capensis','South African spring hare',13200003,NULL,3.5,NULL,NULL,NULL,NULL),(47,'E3172','E3172','UMZC','Mammalia','Rodentia','Dipodidae','Jaculus','orientalis','greater Egyptian jerboa',12900052,NULL,0.138,NULL,NULL,NULL,NULL),(48,'E5111.H','E5111.H','UMZC','Mammalia','Erinaceomorpha','Erinaceidae','Echinosorex','gymnura','moonrat',13600055,NULL,0.683,NULL,NULL,NULL,NULL),(49,'A6.36/2','A6.36-2','UMZC','Mammalia','Dasyuromorpha','Dasyuridae','Sminthopsis','macroura','stripe-faced dunnart',10800101,NULL,0.018,'f','1983-11-01','1981-10-26',NULL),(50,'A6.17a/2','A6.17a-2','UMZC','Mammalia','Dasyuromorphia','Dasyuridae','Antechinus','stuartii','brown antechinus',10800061,NULL,0.041,'m','1983-08-25','1982-09-01','Trapped kinglake, north of Melbourne, Vic, Australia.'),(51,'A6.11/1','A6.11-1','UMZC','Mammalia','Dasyuromorphia','Dasyuridae','Dasyurus','viverrinus','eastern quoll',10800025,NULL,1.44,'m','0000-00-00',NULL,NULL),(52,'A7.17/1','A7.17-1','UMZC','Mammalia','Peramelemorphia','Peramelidae','Perameles','gunnii','eastern barred bandicoot',10900025,NULL,0.773,'m',NULL,NULL,NULL),(53,'A9.16/14','A9.16-14','UMZC','Mammalia','Diprotodontia','Phalangeridae','Trichosurus','vulpecula','brush-tailed possum',11000089,NULL,2.95,NULL,NULL,NULL,NULL),(54,'K3782','K3782','UMZC','Mammalia','Carnivora','Canidae','Vulpes','zerda','fennec fox',14000938,NULL,1.3,NULL,NULL,NULL,NULL),(55,'K4493','K4493','UMZC','Mammalia','Carnivora','Nandiniidae','Nandinia','binotata','African palm civet',14000472,NULL,2.255,NULL,NULL,NULL,NULL),(56,'E8099.B','E8099.B','UMZC','Mammalia','Primates','Lemuridae','Lemur','catta','ring-tailed lemur',12100056,NULL,NULL,'f',NULL,NULL,NULL),(57,'E7454.B','E7454.B','UMZC','Mammalia','Primates','Cercopithecidae','Macaca','fascicularis','crab-eating macaque',12100534,NULL,5.3,'m',NULL,NULL,NULL),(58,'E7901.E','E7901.E','UMZC','Mammalia','Primates','Cebidae','Callithrix','jacchus','common marmoset',12100197,NULL,0.297,NULL,NULL,NULL,NULL),(59,'H22281','H22281','UMZC','Mammalia','Artiodactyla','Bovidae','Madoqua','saltiana phillipsi','Salt\'s dikdik',14200592,5.05,5.05,NULL,NULL,NULL,NULL),(60,'JungleFowl1','JungleFowl1','RVC','Aves','Galliformes','Phasianidae','Gallus','gallus','red junglefowl',NULL,NULL,0.7798,NULL,NULL,NULL,'Composite specimen from Heather Paxton (PhD student at RVC).'),(61,'Sheep1','Sheep1','IC','Mammalia','Artiodactyla','Bovidae','Ovis','aries','domestic sheep',14200825,57,57,NULL,'2007-08-01','2007-09-01','Collected from New Zealand lamb exported to London where it was boned / dissected and the remainder roasted by Michael Doube'),(62,'Mouse1','Mouse1','IC','Mammalia','Rodentia','Muridae','Mus','musculus','laboratory mouse strain C57',13001562,0.027,0.027,'F','2008-06-01','2008-01-01',NULL),(63,'chameleon1','chameleon1','RVC','Reptilia','Squamata','Chamaeleonidae','Chameleon','chameleon','unknown chameleon 1',NULL,NULL,NULL,NULL,NULL,NULL,'THis was recovered from a preserved specimen at Bristol University	'),(64,'racepigeon','racepigeon','RVC','Aves','Columbiformes','Columbidae','Columba','livia','domestic pigeon',NULL,NULL,0.355,NULL,NULL,NULL,NULL),(65,'squirrel1','squirrel1','RVC','Mammalia','Rodentia','Sciuridae','Sciurus','vulgaris','Eurasian red squirrel',12400219,NULL,0.318,NULL,NULL,NULL,NULL),(66,'basilisk1','basilisk1','RVC','Reptilia','Squamata','Corytophanidae','Basiliscus','vittatus','brown basilisk',NULL,NULL,0.191,NULL,NULL,NULL,NULL),(67,'hornydevil','hornydevil','RVC','Reptilia','Squamata','Agamidae','Moloch','horridus','thorny devil',NULL,NULL,0.043,NULL,NULL,NULL,NULL),(68,'iguanid1','iguanid1','RVC','Reptilia','Squamata','Iguanidae','Iguanid','iguanid','unknown iguanid',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(69,'iguana1','iguana1','RVC','Reptilia','Squamata','Iguanidae','Iguana','iguana','green iguana',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(70,'varanid1','varanid1','RVC','Reptilia','Squamata','Varanidae','Varanus','exanthematicus','savannah monitor',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71,'gita','gita','RVC','Mammalia','Proboscidea','Elephantidae','Elephas','maximus','Asian elephant',11500004,3400,3400,'F',NULL,NULL,NULL),(75,'swan1','swan1','RVC','Aves','Anseriformes','Anatidae','Cygnus','olor','mute swan',NULL,NULL,10.95,NULL,NULL,NULL,NULL),(73,'rosa','rosa','RVC','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,2500,2500,NULL,NULL,NULL,NULL),(74,'emelia','emelia','RVC','Mammalia','Proboscidea','Elephantidae','Elephas','maximus','Asian elephant',11500004,835,835,NULL,NULL,NULL,NULL),(76,'turkey1','turkey1','RVC','Aves','Galliformes','Phasianidae','Meleagris','gallopavo','wild turkey',NULL,3.7,3.7,NULL,NULL,NULL,NULL),(77,'ostrich1','twinkie','RVC','Aves','Struthioniformes','Struthionidae','Struthio','camelus','ostrich',NULL,65.3,65.3,'f',NULL,NULL,''),(78,'alpaca1','alpaca1','RVC','Mammalia','Artiodactyla','Camelidae','Vicugna','vicugna','alpaca',14200122,45,45,'f',NULL,NULL,NULL),(79,'wolf1','wolf1','RVC','Mammalia','Carnivora','Canidae','Canis','lupus','grey wolf',14000738,35,35,NULL,NULL,NULL,NULL),(80,'crocodile1','crocodile1','RVC','Reptilia','Crocodylia','Crocodylidae','Crocodylus','niloticus','Nile crocodile',NULL,45,45,'f',NULL,NULL,'16 years old, 2m long'),(81,'ab_sjb41','ab_sjb41','Boyde','Mammalia','Primates','Homonidae','Homo','sapiens','human',12100795,NULL,NULL,NULL,NULL,NULL,'67-year old human femoral head scanned by Graham Davis in the MuCat at about 30 micron resolution'),(82,'125000','rhino_a','UCMP','Mammalia','Perissodactyla','Rhinocerotidae','Ceratotherium','simum','white rhinoceros',14100050,3000,3000,'m',NULL,NULL,NULL),(83,'9856','rhino_b','UCMP','Mammalia','Perissodactyla','Rhinocerotidae','Diceros','bicornis','black rhinoceros',14100059,NULL,NULL,NULL,NULL,NULL,NULL),(84,'117330','brontops','UCMP','Mammalia','Perissodactyla','Brontotheriidae','Brontops','robustus','Brontops',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85,'39221','astrap','UCMP','Mammalia','Astrapotheria','Astrapotheriidae','Granastrapotherium','snorki','Astrapothere',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86,'31120','aphelops2','UCMP','Mammalia','Perissodactyla','Rhinocerotidae','Aphelops','aphelops','Aphelops',14100049,NULL,NULL,NULL,NULL,NULL,NULL),(87,'30266','aphelops1','UCMP','Mammalia','Perissodactyla','Rhinocerotidae','Aphelops','aphelops','Aphelops',14100049,NULL,NULL,NULL,NULL,NULL,NULL),(88,'8817','bear_1','UCMP','Mammalia','Carnivora','Ursidae','Ursus','arctos horribilis','grizzly bear',14000953,NULL,180,NULL,NULL,NULL,NULL),(89,'105016','buffalo_1','UCMP','Mammalia','Artiodactyla','Bovidae','Syncerus','caffer','African buffalo',14200707,429.9,429.9,NULL,NULL,NULL,NULL),(90,'r04','rat04','IC','Mammalia','Rodentia','Muridae','Rattus','norvegicus','Sprague Dawley rat',13001766,403.9,403.9,'M','2008-07-24',NULL,'One of Dr Warren Macdonald\'s angiogenesis rats'),(91,'2388','cervus_1','UCMP','Mammalia','Artiodactyla','Cervidae','Cervus','canadensis','Wapiti',14200352,236,236,NULL,NULL,NULL,NULL),(92,'57350','dip_1','UCMP','Mammalia','Diprotodontia','Diprotodontidae','Diprotodon','sp','Diprotodon',NULL,NULL,NULL,NULL,NULL,NULL,'Quaternary,Pleistocene.V5374,Lake Callabonna, South Australia,Australia. http://ucmpdb.berkeley.edu/cgi/ucmp_query2?admin=&query_src=ucmp_index&table=ucmp2&spec_id=V57350&one=T'),(93,'32117','urs_1','UCMP','Mammalia','Carnivora','Ursidae','Ursus','spelaeus','cave bear',14000953,NULL,400,NULL,NULL,NULL,NULL),(94,'105288','giraffe_1','UCMP','Mammalia','Artiodactyla','Giraffidae','Giraffa','camelopardalis','giraffe',14200476,605,605,NULL,NULL,NULL,NULL),(95,'63524','meg_1','UCMP','Mammalia','Artiodactyla','Cervidae','Megaloceros','giganteus','Irish elk',14200206,585,585,NULL,NULL,NULL,NULL),(96,'14377','mor_2','UCMP','Mammalia','Perissodactyla','Chalicotheriidae','Moropus','elatus','moropus',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(97,'14417','mor_1','UCMP','Mammalia','Perissodactyla','Chalicotheriidae','Moropus','elatus','moropus',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98,'77416','pac_1','UCMP','Aves','Struthioniformes','Dinornithidae','Pachyornis','elephantopus','Pachyornis',NULL,NULL,250,NULL,NULL,NULL,NULL),(99,'131947','polar_bear_1','UCMP','Mammalia','Carnivora','Ursidae','Ursus','thibetanus','Asian black bear',14000988,NULL,120,NULL,NULL,NULL,'Misidentified in the spreadsheet as polar bear; \nbinomial is synonymous with Asian black bear.'),(100,'32394','pla_1','UCMP','Reptilia','Therapsida','Kannemeyeriidae','Placerias','gigas','placerias',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(101,'40465','pse_1','UCMP','Mammalia','Pilosa','Mylodontidae','Pseudoprepotherium','confusum','ground sloth',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102,'41137','pse_1','UCMP','Mammalia','Pilosa','Mylodontidae','Pseudoprepotherium','confusum','ground sloth',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103,'32300','tel_2','UCMP','Mammalia','Perissodactyla','Rhinocerotidae','Teleoceras','fossiger','teleoceras',14100049,NULL,NULL,NULL,NULL,NULL,NULL),(104,'22552','tel_1','UCMP','Mammalia','Perissodactyla','Rhinocerotidae','Teleoceras','fossiger','teleoceras',14100049,NULL,NULL,NULL,NULL,NULL,NULL),(105,'32011','tri_1','UCMP','Mammalia','Perissodactyla','Rhinocerotidae','Trigonias','osborni','trigonias',14100049,NULL,NULL,NULL,NULL,NULL,NULL),(106,'47059','tiger_1','UCMP','Mammalia','Carnivora','Felidae','Panthera','tigris','tiger',14000259,NULL,130,NULL,NULL,NULL,NULL),(107,'118562','tric_1','UCMP','Reptilia','Ornithischia','Ceratopsidae','Triceratops','sp','triceratops',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108,'61154','camel_1','UCMP','Mammalia','Artiodactyla','Camelidae','Camelus','dromedarius','dromedary',14200115,414.95,414.95,NULL,NULL,NULL,NULL),(109,'emu_1','emu_1','RVC','Aves','Struthioniformes','Casuariidae','Dromaius','novaehollandiae','emu',NULL,27.2,27.2,NULL,NULL,NULL,'Subadult'),(110,'ZD 1984.516','nhmele10','NHM','Mammalia','Proboscidea','Elephantidae','Elephas','maximus','Asian elephant',11500004,NULL,NULL,NULL,NULL,NULL,NULL),(111,'ZD 1851.11.10.16','nhmele1','NHM','Mammalia','Proboscidea','Elephantidae','Elephas','maximus','Asian elephant',11500004,NULL,NULL,NULL,NULL,NULL,NULL),(112,'ZD 1907.3.18.1','nhmele14','NHM','Mammalia','Proboscidea','Elephantidae','Elephas','maximus','Asian elephant',11500004,NULL,NULL,NULL,NULL,NULL,NULL),(113,'ZD 1929.1.1.36','nhmele12','NHM','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,NULL,NULL,NULL,NULL,NULL,NULL),(114,'ZD 1961.8.9.81','nhmele8','NHM','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,NULL,NULL,NULL,NULL,NULL,NULL),(115,'ZD 1962.7.6.8','nhmele11','NHM','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,NULL,NULL,NULL,NULL,NULL,NULL),(116,'ZD 1962.7.6.9','nhmele6','NHM','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,NULL,NULL,NULL,NULL,NULL,NULL),(117,'ZD 1962.8.17.2','nhmele4','NHM','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,NULL,NULL,NULL,NULL,NULL,NULL),(118,'ZD 1984.512','nhmele7','NHM','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,NULL,NULL,NULL,NULL,NULL,NULL),(119,'ZD 1984.514','nhmele3','NHM','Mammalia','Proboscidea','Elephantidae','Loxodonta','africana','African bush elephant',11500009,NULL,NULL,NULL,NULL,NULL,NULL),(120,'Z1579','grant_elebighumerus','GMZ','Mammalia','Proboscidea','Elephantidae','Elephant','elephant','Unknown elephant 4',11500002,NULL,NULL,NULL,NULL,NULL,'Also contains Z1425, which are suspected to be the epiphyses of this humerus'),(121,'Z1580','grant_elesm','GMZ','Mammalia','Proboscidea','Elephantidae','Elephant','elephant','Unknown elephant 5',11500002,NULL,NULL,NULL,NULL,NULL,NULL),(122,'babyjuv','juvele','Berlin','Mammalia','Proboscidea','Elephantidae','Elephas','maximus','Asian elephant',11500004,NULL,NULL,NULL,'2006-02-01','2006-01-01','Baby juv limbs from a neonatal (~1mo) Asian elephant with no further data; obtained by John R Hutchinson from colleagues in Berlin'),(123,'ZD 1915.5.1.1','nhmele2','NHM','Mammalia','Proboscidea','Elephantidae','Elephas','maximus','Asian elephant',11500004,NULL,NULL,NULL,NULL,NULL,NULL),(124,'Z1578','grant_elebigulna','GMZ','Mammalia','Proboscidea','Elephantidae','Elephant','elephant','Unknown elephant 6',11500002,NULL,NULL,NULL,NULL,NULL,NULL),(125,'hare1','hare1','RVC','Mammalia','Lagomorpha','Leporidae','Lepus','europaeus','European hare',13500156,3.2,3.2,'m',NULL,NULL,'From Sarah Williams, Liverpool'),(126,'french_rhino','french_rhino','RVC','Mammalia','Perissodactyla','Rhinocerotidae','Ceratotherium','simum','white rhinoceros',14100050,NULL,3000,NULL,NULL,NULL,NULL),(127,'rhino_baby','rhino_baby','Berlin','Mammalia','Perissodactyla','Rhinocerotidae','Rhinoceros','unicornis','Indian rhinoceros',14100071,NULL,NULL,NULL,NULL,NULL,'Berlin_rhino baby from JRH'),(132,'hippo1','ben','RVC','Mammalia','Artiodactyla','Hippopotamidae','Hippopotamus','amphibius','hippopotamus',14200106,1600,1600,'m',NULL,NULL,'\"Ben\", euthanased at Whipsnade Zoo due to suspected ostemyelitis of the 5th digit of the right hind limb and pervasive arthritis of limb joints.'),(128,'horse1','horse1','RVC','Mammalia','Perissodactyla','Equidae','Equus','caballus','horse',14100015,500,500,NULL,NULL,NULL,NULL),(129,'test_animal','test_animal','RVC','Mammalia','Perissodactyla','Equidae','Equus','caballus','horse',14100015,NULL,500,NULL,NULL,NULL,NULL),(130,'giraffe06','giraffe06','ZSLW','Mammalia','Artiodactyla','Giraffidae','Giraffa','camelopardalis','giraffe',14200476,605,605,NULL,NULL,NULL,NULL),(131,'ZD scelidosaurus1','scelidosaurus1','NHM','Reptilia','Sauropsida','Thyreophora','Scelidosaurus','harrisonii','scelidosaurus',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133,'ostrich2','ozbert','RVC','Aves','Struthioniformes','Struthionidae','Struthio','camelus','ostrich',NULL,130,130,'m',NULL,NULL,NULL),(134,'ZD scelidosaurus2','scelidosaurus2','NHM','Reptilia','Saurposida','Thyreophora','Scelidosaurus','harrisonii','scelidosaurus',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135,'ZD 1960.10.11.9','1960.10.11.9','NHM','Mammalia','Soricomorpha','Talpidae','Galemys','pyrenaicus','Pyrenean desman',13700680,NULL,0.057,NULL,NULL,NULL,NULL),(136,'ZD 1852.8.12.51','1852.8.12.51','NHM','Mammalia','Soricomorpha','Soricidae','Suncus','varilla','lesser dwarf shrew',13700285,NULL,0.005,NULL,NULL,NULL,NULL),(137,'ZD 1965.3735','1965.3735','NHM','Mammalia','Soricomorpha','Soricidae','Suncus','etruscus','Etruscan shrew',13700270,NULL,0.002,NULL,NULL,NULL,NULL),(138,'ZD 1874.11.21.32','1874.11.21.32','NHM','Mammalia','Lagomorpha','Ochotonidae','Ochotona','rufescens','Afghan pika',13500076,NULL,0.22,NULL,NULL,NULL,NULL),(139,'ZD 1903.9.5.164','1903.9.5.164','NHM','Mammalia','Lagomorpha','Leporidae','Sylvilagus','brasiliensis','tapeti',13500303,NULL,0.85,NULL,NULL,NULL,NULL),(140,'ZD 1938.12.17.1','1938.12.17.1','NHM','Mammalia','Erinaceomorpha','Erinaceidae','Hemiechinus','auritus','long-eared hedgehog',13600028,NULL,0.215,NULL,NULL,NULL,NULL),(141,'ZD 1951.11.12.1','1951.11.12.1','NHM','Mammalia','Erinaceomorpha','Erinaceidae','Paraechinus','aethiopicus','desert hedgehog',13600039,NULL,0.302,NULL,NULL,NULL,NULL),(142,'ZD 1972.929','1972.929','NHM','Mammalia','Soricomorpha','Talpidae','Talpa','europaea','European mole',13700730,NULL,0.096,NULL,NULL,NULL,NULL),(143,'ZD 1989.251','1989.251','NHM','Mammalia','Carnivora','Felidae','Prionailurus','bengalensis','leopard cat',14000181,NULL,3.375,NULL,NULL,NULL,NULL),(144,'ZD 1860.7.22.22','1860.7.22.22','NHM','Mammalia','Carnivora','Felidae','Prionailurus','viverrinus','fishing cat',14000198,NULL,8.9,NULL,NULL,NULL,NULL),(145,'ZD 1855.12.8.4','1855.12.8.4','NHM','Mammalia','Carnivora','Viverridae','Paradoxurus','hermaphroditus','Asian palm civet',14000317,NULL,2.969,NULL,NULL,NULL,NULL),(146,'ZD 1851.11.8.4','1851.11.8.4','NHM','Mammalia','Carnivora','Canidae','Lycalopex','fulvipes','Darwin\'s fox',14000807,NULL,9.95,NULL,NULL,NULL,'Possible Dusicyon, Falkland Islands wolf'),(147,'ZD 1920.7.4.16','1920.7.4.16','NHM','Mammalia','Carnivora','Mustelidae','Mustela','nivalis','least weasel',14001438,NULL,0.096,NULL,NULL,NULL,NULL),(148,'ZD 1893.1.27.5','1893.1.27.5','NHM','Mammalia','Carnivora','Mustelidae','Mustela','sibirica','Siberian weasel',14001468,NULL,1.25,NULL,NULL,NULL,NULL),(149,'cow1','cow1','IC','Mammalia','Artiodactyla','Bovidae','Bos','taurus','cattle',14200687,500,500,NULL,NULL,NULL,NULL),(150,'giraffe2','Curagh','RVC','Mammalia','Artiodactyla','Giraffidae','Giraffa','camelopardalis','giraffe',14200476,605,605,'m',NULL,NULL,'growth plates open, epiphyses not joined to metaphyses. From Whipsnade Zoo'),(151,'cow2','cow2','RVC','Mammalia','Artiodactyla','Bovidae','Bos','taurus','cattle',14200687,500,500,'f',NULL,NULL,'Originally labelled cow1 by JRH (acquired 23/06/2009)'),(152,'goat1','goat1','RVC','Mammalia','Artiodactyla','Bovidae','Capra','hircus','goat',14200776,48,48,NULL,NULL,NULL,NULL),(153,'sheep2','sheep2','RVC','Mammalia','Artiodactyla','Bovidae','Ovis','aries','domestic sheep',14200825,57,57,'f',NULL,NULL,'Originally labelled sheep1 by JRH (acquired 23/06/2009)'),(154,'magpie1','magpie1','RVC','Aves','Passeriformes','Corvidae','Pica','pica','magpie',NULL,0.258,0.258,NULL,NULL,NULL,NULL),(155,'guineafowl1','guineafowl1','RVC','Aves','Galliformes','Numididae','Numida','meleagridis','helmeted guineafowl',NULL,1.88,1.88,'m',NULL,NULL,NULL),(156,'242.AA','242.AA','UMZC','Aves','Anseriformes','Anatidae','Cereopsis','novaehollandiae','Cape Barren goose',NULL,NULL,4.4,NULL,NULL,NULL,NULL),(157,'378.S','378.S','UMZC','Aves','Apterygiformes','Apterygidae','Apteryx','australis','tokoeka',NULL,NULL,2.785,NULL,NULL,NULL,NULL),(158,'242.E','242.E','UMZC','Aves','Anseriformes','Anatidae','Anser','albifrons','greater white-fronted goose',NULL,NULL,2.212,NULL,NULL,NULL,NULL),(159,'246.F','246.F','UMZC','Aves','Anseriformes','Anatidae','Branta','bernicla','brent goose',NULL,NULL,1.335,NULL,NULL,NULL,NULL),(160,'704','704','UMZC','Aves','Anseriformes','Anatidae','Somateria','mollissima','common eider',NULL,NULL,2.044,NULL,NULL,NULL,NULL),(161,'404.E','404.E','UMZC','Aves','Tinamiformes','Tinamidae','Eudromia','elegans','elegant crested tinamou',NULL,NULL,0.784,NULL,NULL,NULL,NULL),(162,'222.a','222.a','UMZC','Aves','Anseriformes','Anatidae','Anas','superciliosa','Pacific black duck',NULL,NULL,1,NULL,NULL,NULL,NULL),(163,'246.G','246.G','UMZC','Aves','Anseriformes','Anatidae','Chenonetta','jubata','Australian wood duck',NULL,NULL,0.823,NULL,NULL,NULL,NULL),(164,'378.p','378.p','UMZC','Aves','Apterygiformes','Apterygidae','Apteryx','haastii','great spotted kiwi',NULL,NULL,1.967,NULL,NULL,NULL,NULL),(165,'378.iii','378.iii','UMZC','Aves','Apterygiformes','Apterygidae','Apteryx','owenii','little spotted kiwi',NULL,NULL,1.14,NULL,NULL,NULL,NULL),(166,'405.A','405.A','UMZC','Aves','Galliformes','Phasianidae','Coturnix','ypsilophora','brown quail',NULL,NULL,0.091,NULL,NULL,NULL,'Previously entered as Synoicus ypsilophorus, Van Diemen\'s Land partridge'),(167,'E.8090.A','E.8090.A','UMZC','Mammalia','Primates','Lemuridae','Varecia','variegata','ruffed lemur',NULL,NULL,2.04,NULL,NULL,NULL,NULL),(168,'E.8093.A','E.8093.A','UMZC','Mammalia','Primates','Lemuridae','Eulemur','macaco','black lemur',NULL,NULL,3,NULL,NULL,NULL,'Not sure if this species ever existed, but that is what is on the label...'),(169,'ZD 1989.291','1989.291','NHM','Mammalia','Primates','Cebidae','Saimiri','sciureus','common squirrel monkey',12100291,NULL,0.87,NULL,NULL,NULL,NULL),(170,'ZD 1872.8.19.11','1972.8.19.11','NHM','Mammalia','Primates','Cheirogaleidae','Cheirogaleus','major','greater dwarf lemur',12100011,NULL,0.45,NULL,NULL,NULL,NULL),(171,'ZD 1948.539','1948.539','NHM','Mammalia','Primates','Galagidae','Euoticus','pallidus','Northern needle-clawed bushbaby',12100129,NULL,0.315,NULL,NULL,NULL,NULL),(172,'ZD 1982.484','1982.484','NHM','Mammalia','Primates','Galagidae','Galago','thomasi','Thomas\'s bushbaby',12100149,NULL,0.06,NULL,NULL,NULL,NULL),(173,'ZD 1972.4270','1972.4279','NHM','Mammalia','Primates','Cheirogaleidae','Microcebus','murinus','mouse lemur',12100019,NULL,0.07,NULL,NULL,NULL,NULL),(175,'wallaby1','wallaby1','Ker','Mammalia','Diprotodontia','Macropodidae','Macropus','rufogriseus','Bennett\'s wallaby',11000268,20,20,NULL,NULL,NULL,'Kind gift of Robert Ker, University of Leeds.  Shot at Whipsnade Zoo.'),(176,'greyhound1','greyhound1','RVC','Mammalia','Carnivora','Canidae','Canis','familiaris','greyhound',NULL,30,30,NULL,NULL,NULL,NULL),(177,'tiger_2','tiger_2','RVC','Mammalia','Carnivora','Felidae','Panthera','tigris','Siberian tiger',14000259,130,130,'f',NULL,NULL,'Acquired by JRH; only head and condyle available at Imperial, measurements on the fresh bone made at RVC.  Not scanned in macroCT.'),(178,'pig1','pig1','RVC','Mammalia','Artiodactyla','Suidae','Sus','scrofa','pig',NULL,44,44,NULL,NULL,NULL,'11 month old miniature pig'),(179,'monitor1','monitor1','RVC','Reptilia','Squamata','Varanidae','Varanus','niloticus','Nile monitor',NULL,17.5,17.5,NULL,NULL,NULL,NULL),(180,'prz_horse1','prz_horse1','RVC','Mammalia','Perissodactyla','Equidae','Equus','caballus','Przewalski\'s horse',14100015,202.2,202.2,NULL,NULL,NULL,'Classified after Wilson & Reeder as E. caballus'),(181,'kent_cheetah','kent_cheetah','RVC','Mammalia','Carnivora','Felidae','Acinonyx','jubatus','cheetah',14000006,45,45,NULL,NULL,NULL,'Known body mass'),(182,'429p','429p','UMZC','Aves','Cuculiformes','Cuculidae','Geococcyx','californianus','greater roadrunner',NULL,NULL,0.376,NULL,NULL,NULL,NULL),(183,'H15052','H15052','UMZC','Mammalia','Artiodactyla','Tragulidae','Tragulus','kanchil','lesser mouse-deer',NULL,1.616,1.616,NULL,NULL,NULL,NULL),(184,'ic_deer1','ic_deer1','IC','Mammalia','Artiodactyla','Cervidae','Cervus','elaphus','red deer',NULL,129.69,129.69,NULL,NULL,NULL,NULL),(185,'2100','YPM2100','YPM','Aves','Galliformes','Phasianidae','Argusianus','argus','great argus',NULL,NULL,1.95,NULL,NULL,NULL,NULL),(186,'13486','YPM13486','YPM','Aves','Apterygiformes','Apterygidae','Apteryx','australis','tokoeka',NULL,NULL,2.3,NULL,NULL,NULL,'Also known as the southern brown kiwi or common kiwi'),(187,'7778','YPM7778','YPM','Aves','Galliformes','Phasianidae','Afropavo','congensis','Congo peafowl',NULL,NULL,1.25,NULL,NULL,NULL,NULL),(188,'379','YPM379','YPM','Aves','Galliformes','Megapodiidae','Alectura','lathami','Australian brush-turkey',NULL,NULL,2.35,NULL,NULL,NULL,NULL),(189,'2118','YPM2118','YPM','Aves','Apterygiformes','Apterygidae','Apteryx','owenii','little spotted kiwi',NULL,NULL,1.2,NULL,NULL,NULL,NULL),(190,'5702','YPM5702','YPM','Aves','Ciconiiformes','Ardeidae','Bubulcus','ibis','cattle egret',NULL,NULL,0.37,NULL,NULL,NULL,NULL),(191,'2123','YPM2123','YPM','Aves','Casuariiformes','Casuariidae','Casuarius','sp.','cassowary',NULL,NULL,44,NULL,NULL,NULL,NULL),(192,'2094','YPM2094','YPM','Aves','Galliformes','Phasianidae','Chrysolophus','pictus','golden pheasant',NULL,NULL,0.5,NULL,NULL,NULL,NULL),(193,'11564','YPM11564','YPM','Aves','Tinamiformes','Tinamidae','Crypturellus','undulatus','undulated tinamou',NULL,NULL,0.565,NULL,NULL,NULL,NULL),(194,'14735','YPM14735','YPM','Aves','Galliformes','Phasianidae','Centrocercus','urophasianus','sage-grouse',NULL,NULL,2.25,NULL,NULL,NULL,NULL),(195,'2128','YPM2128','YPM','Aves','Struthioniformes','Casuariidae','Dromaius','novaehollandiae','emu',NULL,NULL,34.2,NULL,NULL,NULL,NULL),(196,'4007','Diatryma','YPM','Aves','Gastornithiformes','Gastornithidae','Gastornis','sp.','Gastornis',NULL,NULL,187.5,NULL,NULL,NULL,NULL),(197,'11600','YPM11600','YPM','Aves','Galliformes','Tetraonidae','Dendragapus','obscurus','dusky grouse',NULL,NULL,1.05,NULL,NULL,NULL,NULL),(198,'421','YPM421','YPM','Aves','Struthioniformes','Dinornithidae','Dinornis','sp.','giant moa',NULL,NULL,177.77,NULL,NULL,NULL,NULL),(199,'6706','YPM6706','YPM','Aves','Tinamiformes','Tinamidae','Eudromia','elegans','elegant crested tinamou',NULL,NULL,0.695,NULL,NULL,NULL,NULL),(200,'9472','YPM9472','YPM','Aves','Galliformes','Numididae','Guttera','pucherani','crested guineafowl',NULL,NULL,1.15,NULL,NULL,NULL,NULL),(201,'12705','YPM12705','YPM','Aves','Galliformes','Phasianidae','Lagopus','lagopus','willow grouse',NULL,NULL,0.5,NULL,NULL,NULL,NULL),(202,'2090','YPM2090','YPM','Aves','Galliformes','Megapodiidae','Megapodius','cumingii','Phillippine megapode',NULL,NULL,0.7,NULL,NULL,NULL,NULL),(203,'2113','YPM2113','YPM','Aves','Galliformes','Phasianidae','Meleagris','gallopavo','wild turkey',NULL,NULL,6.05,NULL,NULL,NULL,NULL),(204,'7780','YPM7780','YPM','Aves','Galliformes','Numididae','Numida','meleagridis','helmeted guineafowl',NULL,NULL,1.3,NULL,NULL,NULL,NULL),(205,'2040','YPM2040','YPM','Aves','Tinamiformes','Tinamidae','Nothoprocta','perdicaria','Chilean tinamou',NULL,NULL,0.46,NULL,NULL,NULL,NULL),(206,'376','YPM376','YPM','Aves','Galliformes','Cracidae','Penelope','purpurascens','crested guan',NULL,NULL,2.1,NULL,NULL,NULL,NULL),(207,'2103','YPM2103','YPM','Aves','Galliformes','Cracidae','Pauxi','pauxi','northern helmeted curassow',NULL,NULL,3.15,NULL,NULL,NULL,NULL),(208,'6658','YPM6658','YPM','Aves','Galliformes','Phasianidae','Phasianus','colchicus','common pheasant',NULL,NULL,1.1,NULL,NULL,NULL,NULL),(209,'382','YPM382','YPM','Aves','Galliformes','Cracidae','Ortalis','vetula','plain chacalaca',NULL,NULL,0.56,NULL,NULL,NULL,NULL),(210,'4417','YPM4417','YPM','Aves','Galliformes','Cracidae','Ortalis','poliocephala','west Mexican chacalaca',NULL,NULL,0.76,NULL,NULL,NULL,NULL),(211,'1154','YPM1154','YPM','Aves','Columbiformes','Columbidae','Pezophaps','solitaria','Rodrigues solitaire',NULL,NULL,22.5,NULL,NULL,NULL,NULL),(212,'2064','YPM2064','YPM','Aves','Columbiformes','Columbidae','Raphus','cucullatus','dodo',NULL,NULL,20,NULL,NULL,NULL,NULL),(213,'6503','YPM6503','YPM','Aves','Struthioniformes','Rheidae','Rhea','americana','greater rhea',NULL,NULL,23,NULL,NULL,NULL,NULL),(214,'2124','YPM2124','YPM','Aves','Struthioniformes','Struthionidae','Struthio','camelus','ostrich',NULL,NULL,111,NULL,NULL,NULL,NULL),(215,'14510','YPM14510','YPM','Aves','Accipitriformes','Sagittariidae','Sagittarius','serpentarius','secretary bird',NULL,NULL,4.01,NULL,NULL,NULL,NULL),(216,'1797','YPM1797','YPM','Aves','Accipitriformes','Sagittariidae','Sagittarius','serpentarius','secretary bird',NULL,NULL,4.01,NULL,NULL,NULL,NULL),(217,'621.a,b,c','621','UMZC','Aves','Struthioniformes','Dinornithidae','Dinornis','giganteus','South Island giant moa',NULL,NULL,85,NULL,NULL,NULL,'Listed by UMZC as Dinornis robustus'),(218,'609.a,b,c,d','609','UMZC','Aves','Struthioniformes','Dinornithidae','Emeus','crassus','eastern moa',NULL,NULL,60.5,NULL,NULL,NULL,NULL),(219,'372.a','UMZC Casuarius','UMZC','Aves','Casuariiformes','Casuariidae','Casuarius','casuarius','southern cassowary',NULL,NULL,44,NULL,NULL,NULL,NULL),(220,'quail2','quail2','IC','Aves','Galliformes','Phasianidae','Coturnix','coturnix','common quail',NULL,NULL,0.095,NULL,NULL,NULL,NULL),(221,'quail1','quail1','IC','Aves','Galliformes','Phasianidae','Coturnix','coturnix','common quail',NULL,NULL,0.095,NULL,NULL,NULL,NULL),(222,'broiler','broiler','RVC','Aves','Galliformes','Phasianidae','Gallus','gallus','broiler chicken',NULL,NULL,4,NULL,NULL,NULL,NULL),(223,'378.g','UMZC_rhea','UMZC','Aves','Struthioniformes','Rheidae','Rhea','americana','greater rhea',NULL,NULL,23,NULL,NULL,NULL,NULL),(224,'emu_x','emu_x','RVC','Aves','Struthioniformes','Casuariidae','Dromaius','novaehollandiae','emu',NULL,NULL,34.2,NULL,NULL,NULL,NULL),(225,'emu_2','emu_2','RVC','Aves','Struthioniformes','Casuariidae','Dromaius','novaehollandiae','emu',NULL,NULL,34.2,NULL,NULL,NULL,NULL),(226,'ostrich_anon','ostrich_anon','RVC','Aves','Struthioniformes','Struthionidae','Struthio','camelus','ostrich',NULL,NULL,111,NULL,NULL,NULL,'One of ozbert or twinkie - guess from measurements?'),(227,'ZD 277.p','277.p','NHM','Mammalia','Diprotodontia','Potoroidae','Bettongia','lesueur','boodie',NULL,1.44727,1.44727,NULL,NULL,NULL,NULL),(228,'ZD 1858.5.26.23','1858.5.26.23','NHM','Mammalia','Diprotodontia','Potoroidae','Bettongia','penicillata','woylie',NULL,1.18435,1.18435,NULL,NULL,NULL,NULL),(229,'ZD 1984.1002-1003','1984.1002-1003','NHM','Mammalia','Diprotodontia','Macropodidae','Macropus','parma','Parma wallaby',NULL,4.15662,4.15662,NULL,NULL,NULL,NULL),(230,'ZD 1976.184','1976.184','NHM','Mammalia','Diprotodontia','Macropodidae','Macropus','rufogriseus','Bennett\'s wallaby',NULL,16.85,16.85,NULL,NULL,NULL,NULL),(231,'ZD 1970.2189','1970.2189','NHM','Mammalia','Diprotodontia','Macropodidae','Macropus','agilis','agile wallaby',NULL,11.81575,11.81575,NULL,NULL,NULL,NULL),(232,'ZD 1851.4.24.2','1851.4.24.2','NHM','Mammalia','Diprotodontia','Potoroidae','Potorous','tridactylus','long-nosed potoroo',NULL,1.05467,1.05467,NULL,NULL,NULL,NULL),(233,'ZD 2010.8','2010.8','NHM','Mammalia','Diprotodontia','Macropodidae','Macropus','rufus','red kangaroo',NULL,72.5,72.5,'m',NULL,NULL,NULL),(234,'ZD 1962.5.22.1','1962.5.22.1','NHM','Mammalia','Diprotodontia','Macropodidae','Macropus','eugenii','Tammar wallaby',NULL,5.27848,5.27848,NULL,NULL,NULL,NULL),(235,'ZD 1961.12.11.1','1961.12.11.1','NHM','Mammalia','Diprotodontia','Macropodidae','Macropus','fuliginosus','Western grey kangaroo',NULL,25.5647,25.5647,NULL,NULL,NULL,NULL),(236,'H.20302','H20302','UMZC','Mammalia','Artiodactyla','Giraffidae','Okapia','johnstoni','okapi',NULL,230.00114,230.00114,NULL,NULL,NULL,NULL),(237,'ZD 1974.414','1974.414','NHM','Mammalia','Artiodactyla','Bovidae','Antilope','cervicapra','blackbuck',NULL,36.33011,36.3011,NULL,NULL,NULL,NULL),(238,'47','47','NHM','Mammalia','Artiodactyla','Bovidae','Bos','indicus','zebu',NULL,275,275,NULL,NULL,NULL,NULL),(239,'ZD 1863.12.29.1','1863.12.29.1','NHM','Mammalia','Artiodactyla','Bovidae','Cephalophus','dorsalis','Bay duiker',NULL,20,20,NULL,NULL,NULL,NULL),(240,'ZD 1961.8.9.80','1961.8.9.80','NHM','Mammalia','Artiodactyla','Bovidae','Cephalophus','sylvicultor','yellow-backed duiker',NULL,61.3,61.3,NULL,NULL,NULL,NULL),(241,'ZD 1963.10.21.1','1963.10.21.1','NHM','Mammalia','Artiodactyla','Bovidae','Oryx','beisa','beisa',NULL,200.57652,200.57652,NULL,NULL,NULL,NULL),(242,'H.17691','H17691','UMZC','Mammalia','Artiodactyla','Cervidae','Alces','alces','Eurasian elk',NULL,461.90076,461.90076,NULL,NULL,NULL,NULL),(243,'H.16232','H16232','UMZC','Mammalia','Artiodactyla','Cervidae','Elaphurus','davidianus','Pere David\'s deer',NULL,182,182,NULL,NULL,NULL,NULL),(244,'H.15532','H.15532','UMZC','Mammalia','Artiodactyla','Cervidae','Muntiacus','reevesi','Reeves\' muntjac',NULL,13.49994,13.49994,NULL,NULL,NULL,NULL),(245,'ZD 1874.11.2.4','1874.11.2.4','NHM','Mammalia','Artiodactyla','Bovidae','Syncerus','caffer','African buffalo',NULL,592.66598,592.66598,NULL,NULL,NULL,NULL),(246,'H.16634','H16634','UMZC','Mammalia','Artiodactyla','Cervidae','Cervus','elaphus','red deer',NULL,240.867,240.867,NULL,NULL,NULL,NULL),(247,'WindfallLgGiraffe','WindfallLgGiraffe','NAM','Mammalia','Artiodactyla','Giraffidae','Giraffa','camelopardalis','giraffe',14200476,482,482,NULL,NULL,NULL,'From Amsterdam Zoo - Artis'),(248,'A12.17/1','A12.17/1','UMZC','Mammalia','Diprotodontia','Macropodidae','Macropus','giganteus','Eastern grey kangaroo',0,60,60,'m',NULL,NULL,NULL),(249,'H.17535','H17535','UMZC','Mammalia','Artiodactyla','Cervidae','Megaloceros','giganteus','Irish elk',14200206,585,585,NULL,NULL,NULL,NULL),(250,'H.10707-H.10715','H10707','UMZC','Mammalia','Artiodactyla','Hippopotamidae','Hippopotamus','amphibius','hippopotamus',14200106,1536.3104,1536.3104,'f',NULL,NULL,NULL),(251,'A12.79/1','A12.79-1','UMZC','Mammalia','Diprotodontia','Potoroidae','Bettongia','gaimardi','Eastern bettong',NULL,NULL,1.66755,NULL,NULL,NULL,NULL),(252,'A12.50/1','A12.50-1','UMZC','Mammalia','Diprotodontia','Macropodidae','Thylogale','billardierii','Tasmanian pademelon',NULL,5.86586,5.86586,NULL,NULL,NULL,NULL),(253,'A12.17/4','A12.17-4','UMZC','Mammalia','Diprotodontia','Macropodidae','Macropus','giganteus','Eastern grey kangaroo',NULL,60,60,'m',NULL,NULL,NULL),(254,'A12.19/1','A12.19-1','UMZC','Mammalia','Diprotodontia','Macropodidae','Macropus','robustus','wallaroo',NULL,25.97892,25.97892,NULL,NULL,NULL,NULL),(255,'A12.59/2','A12.59-2','UMZC','Mammalia','Diprotodontia','Macropodidae','Onychogalea','fraenata','bridled nail-tail wallaby',NULL,4.95205,4.95205,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `animals` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bones`
--

DROP TABLE IF EXISTS `bones`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bones` (
  `id` int(11) NOT NULL DEFAULT '0',
  `bone_name` varchar(20) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='list of bones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bones`
--

LOCK TABLES `bones` WRITE;
/*!40000 ALTER TABLE `bones` DISABLE KEYS */;
INSERT INTO `bones` VALUES (10,'third metatarsal'),(9,'fibula'),(8,'tibia'),(7,'femur'),(6,'pelvis'),(5,'third metacarpal'),(4,'ulna'),(3,'radius'),(2,'humerus'),(1,'scapula');
/*!40000 ALTER TABLE `bones` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dimensions`
--

DROP TABLE IF EXISTS `dimensions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dimensions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `animal_id` int(11) NOT NULL COMMENT 'id from animal table',
  `bone_code` int(11) NOT NULL COMMENT 'bone code from ImageJ',
  `slice_a` int(11) DEFAULT NULL COMMENT 'first slice occupied by bone in CT scan or cleaned CT scan',
  `slice_b` int(11) DEFAULT NULL COMMENT 'last slice occupied by bone in CT scan or cleaned CT',
  `midslice` int(11) DEFAULT NULL,
  `length_ij` decimal(10,3) DEFAULT NULL COMMENT 'length measured by midpoint macro on CT scan',
  `depth_ij` decimal(10,3) DEFAULT NULL COMMENT 'length determined by n_slices * slice thickness',
  `length_real` decimal(10,3) DEFAULT NULL COMMENT 'length measured with real measuring device on real bone',
  `ml_real` decimal(10,3) DEFAULT NULL COMMENT 'mediolateral width at approximate mid-shaft',
  `cc_real` decimal(10,3) DEFAULT NULL COMMENT 'craniocaudal width at approximate mid-shaft',
  `circum_real` decimal(10,3) DEFAULT NULL COMMENT 'real circumference at approximate mid-shaft',
  `dw_real` decimal(10,3) DEFAULT NULL COMMENT 'distal width (scapula only)',
  `fem_radius` decimal(10,5) DEFAULT NULL COMMENT 'femoral head radius',
  `hum_radius` decimal(10,5) DEFAULT NULL COMMENT 'humeral head radius',
  `glen_radius` decimal(10,5) DEFAULT NULL COMMENT 'glenoid cavity radius',
  `acet_radius` decimal(10,5) DEFAULT NULL COMMENT 'acetabular radius',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=578 DEFAULT CHARSET=latin1 COMMENT='table of basic bone dimensions, e.g. length';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dimensions`
--

LOCK TABLES `dimensions` WRITE;
/*!40000 ALTER TABLE `dimensions` DISABLE KEYS */;
INSERT INTO `dimensions` VALUES (1,14,7,8,119,63,222.091,222.000,235.000,16.300,14.700,55.000,NULL,10.58600,NULL,NULL,NULL),(2,16,7,2,203,102,1017.006,1005.000,NULL,NULL,NULL,NULL,NULL,65.26500,NULL,NULL,NULL),(3,17,7,2,267,134,1344.490,1325.000,NULL,NULL,NULL,NULL,NULL,89.48500,NULL,NULL,NULL),(4,1,7,14,184,99,170.118,170.000,169.700,12.400,10.700,37.000,NULL,7.38100,NULL,NULL,NULL),(5,3,7,11,129,70,236.025,236.000,250.000,17.900,16.000,55.000,NULL,11.35600,NULL,NULL,NULL),(6,4,7,9,184,96,350.078,350.000,360.000,29.000,26.700,91.000,NULL,19.38400,NULL,NULL,NULL),(7,17,2,2,227,114,1125.212,1125.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8,3,2,2,85,43,166.029,166.000,164.300,15.200,20.800,64.000,NULL,NULL,NULL,NULL,NULL),(9,4,2,13,166,89,308.925,306.000,320.200,25.800,38.100,115.000,NULL,NULL,30.82776,NULL,NULL),(10,16,2,2,167,84,825.598,825.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(11,14,2,9,110,59,203.861,202.000,200.200,15.400,18.700,55.000,NULL,NULL,17.31186,NULL,NULL),(12,1,2,17,171,94,154.788,154.000,153.200,11.000,12.900,40.000,NULL,NULL,10.89704,NULL,NULL),(13,14,8,8,111,59,206.713,206.000,204.000,14.400,16.900,55.000,NULL,NULL,NULL,NULL,NULL),(14,1,8,12,189,100,177.675,177.000,176.100,9.700,12.700,41.000,NULL,NULL,NULL,NULL,NULL),(15,3,8,10,119,64,218.243,218.000,226.000,15.500,17.700,57.000,NULL,NULL,NULL,NULL,NULL),(16,16,8,2,149,75,589.389,588.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(17,17,8,1,164,82,817.111,815.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(18,4,8,11,162,86,303.139,302.000,310.000,26.600,28.500,89.000,NULL,NULL,NULL,NULL,NULL),(19,17,4,1,203,102,1011.656,1010.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(21,1,4,13,183,98,170.019,170.000,168.700,5.300,10.400,28.000,NULL,NULL,NULL,NULL,NULL),(22,3,4,20,118,69,197.615,196.000,196.200,12.800,14.000,36.000,NULL,NULL,NULL,NULL,NULL),(23,16,4,2,177,89,702.472,700.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24,4,4,11,174,92,326.331,326.000,340.000,22.900,24.400,74.000,NULL,NULL,NULL,NULL,NULL),(25,21,7,4,100,52,192.299,192.000,NULL,NULL,NULL,NULL,NULL,7.40200,NULL,NULL,NULL),(26,22,7,5,192,98,375.509,374.000,NULL,NULL,NULL,NULL,NULL,19.85900,NULL,NULL,NULL),(27,20,7,10,173,91,163.640,163.000,162.700,10.500,8.600,34.000,NULL,6.70700,NULL,NULL,NULL),(28,23,7,7,182,94,354.024,350.000,348.000,26.600,26.400,85.000,NULL,17.54900,NULL,NULL,NULL),(29,18,7,1,214,107,1075.709,1065.000,NULL,NULL,NULL,NULL,NULL,69.00600,NULL,NULL,NULL),(30,11,7,8,160,84,152.044,152.000,152.000,12.700,10.900,40.000,NULL,6.84200,NULL,NULL,NULL),(31,7,7,6,135,70,258.190,258.000,256.000,19.200,19.200,60.000,NULL,12.34800,NULL,NULL,NULL),(32,7,2,5,122,63,234.507,234.000,235.000,16.400,24.600,66.000,NULL,NULL,17.02505,NULL,NULL),(33,11,2,11,141,76,130.883,130.000,130.300,10.800,13.600,40.000,NULL,NULL,10.67815,NULL,NULL),(34,20,2,9,154,81,145.437,145.000,144.800,9.100,10.600,32.000,NULL,NULL,9.66942,NULL,NULL),(35,23,2,7,156,81,301.108,298.000,300.000,24.700,34.200,100.000,NULL,NULL,28.13075,NULL,NULL),(36,7,8,4,135,69,262.350,262.000,260.000,18.800,20.400,64.000,NULL,NULL,NULL,NULL,NULL),(37,11,8,9,154,81,145.183,145.000,144.800,10.400,11.400,35.000,NULL,NULL,NULL,NULL,NULL),(38,20,8,9,177,93,168.056,168.000,167.000,10.200,12.300,30.000,NULL,NULL,NULL,NULL,NULL),(39,23,8,13,159,86,292.664,292.000,291.000,21.800,28.300,85.000,NULL,NULL,NULL,NULL,NULL),(43,7,4,4,138,71,268.762,268.000,276.000,8.500,13.100,36.000,NULL,NULL,NULL,NULL,NULL),(45,14,4,8,114,61,212.196,212.000,211.000,8.900,15.500,40.000,NULL,NULL,NULL,NULL,NULL),(47,11,4,8,146,77,138.720,138.000,138.100,7.200,11.600,30.000,NULL,NULL,NULL,NULL,NULL),(48,20,4,8,175,91,167.070,167.000,165.900,7.100,9.400,26.000,NULL,NULL,NULL,NULL,NULL),(49,23,4,7,156,81,298.308,298.000,298.000,15.900,31.200,75.000,NULL,NULL,NULL,NULL,NULL),(50,16,3,2,159,80,628.694,628.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(51,17,3,2,182,92,900.253,900.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(52,1,3,34,177,105,143.358,143.000,141.100,8.400,6.000,25.000,NULL,NULL,NULL,NULL,NULL),(53,7,3,20,136,78,232.546,232.000,230.000,11.400,17.800,47.000,NULL,NULL,NULL,NULL,NULL),(54,3,3,39,118,78,159.192,158.000,159.900,13.200,12.900,38.000,NULL,NULL,NULL,NULL,NULL),(55,14,3,11,97,53,174.645,174.000,172.700,9.300,13.800,34.000,NULL,NULL,NULL,NULL,NULL),(56,4,3,8,144,76,273.148,272.000,280.000,26.800,18.000,74.000,NULL,NULL,NULL,NULL,NULL),(57,11,3,27,143,85,116.536,116.000,117.200,5.700,8.900,25.000,NULL,NULL,NULL,NULL,NULL),(58,20,3,24,168,96,144.612,144.000,144.200,5.400,7.900,24.000,NULL,NULL,NULL,NULL,NULL),(59,23,3,40,155,97,231.703,230.000,230.000,15.600,23.200,65.000,NULL,NULL,NULL,NULL,NULL),(60,16,9,15,136,75,484.053,484.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(61,17,9,1,160,80,795.657,795.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62,1,9,23,190,106,167.023,167.000,166.100,3.800,4.700,15.000,NULL,NULL,NULL,NULL,NULL),(63,7,9,6,129,67,246.062,246.000,250.000,3.900,5.500,15.000,NULL,NULL,NULL,NULL,NULL),(64,3,9,20,117,68,194.048,194.000,191.800,3.800,5.700,15.000,NULL,NULL,NULL,NULL,NULL),(65,14,9,13,112,62,198.050,198.000,196.300,5.000,6.500,25.000,NULL,NULL,NULL,NULL,NULL),(66,11,9,20,152,86,132.004,132.000,133.200,6.500,3.400,15.000,NULL,NULL,NULL,NULL,NULL),(67,20,9,16,174,95,158.140,158.000,157.000,2.700,4.300,13.000,NULL,NULL,NULL,NULL,NULL),(68,1,10,15,88,51,73.297,73.000,74.900,6.900,4.900,17.000,NULL,NULL,NULL,NULL,NULL),(69,7,10,8,120,64,112.142,112.000,111.700,13.100,10.800,59.000,NULL,NULL,NULL,NULL,NULL),(70,3,10,59,118,88,88.679,88.500,84.500,6.400,7.000,37.000,NULL,NULL,NULL,NULL,NULL),(71,14,10,12,93,52,81.041,81.000,80.900,9.900,7.700,30.000,NULL,NULL,NULL,NULL,NULL),(72,4,10,18,140,79,122.295,122.000,122.700,17.900,12.800,50.000,NULL,NULL,NULL,NULL,NULL),(73,11,10,20,78,49,58.355,58.000,56.600,5.200,5.000,20.000,NULL,NULL,NULL,NULL,NULL),(74,20,10,9,85,47,76.065,76.000,75.000,5.900,4.800,19.000,NULL,NULL,NULL,NULL,NULL),(75,23,10,20,141,80,121.262,121.000,119.200,14.400,13.000,45.000,NULL,NULL,NULL,NULL,NULL),(76,1,5,38,88,63,52.028,50.000,53.600,5.200,5.000,18.000,NULL,NULL,NULL,NULL,NULL),(77,7,5,36,121,78,85.129,85.000,84.500,9.100,8.700,30.000,NULL,NULL,NULL,NULL,NULL),(78,3,5,127,160,143,67.208,66.000,64.600,8.000,8.100,32.000,NULL,NULL,NULL,NULL,NULL),(79,14,5,27,94,60,67.004,67.000,67.000,7.800,6.900,25.000,NULL,NULL,NULL,NULL,NULL),(80,4,5,18,123,70,105.365,105.000,105.300,13.000,11.700,32.000,NULL,NULL,NULL,NULL,NULL),(81,11,5,8,51,29,43.118,43.000,43.000,4.700,4.500,15.000,NULL,NULL,NULL,NULL,NULL),(82,20,5,29,84,56,55.021,55.000,55.100,4.600,5.000,19.000,NULL,NULL,NULL,NULL,NULL),(83,23,5,34,139,86,105.153,105.000,104.300,13.300,12.100,40.000,NULL,NULL,NULL,NULL,NULL),(84,16,1,2,131,66,650.877,645.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85,1,1,29,139,84,110.588,110.000,102.400,NULL,NULL,NULL,70.400,NULL,NULL,8.80270,NULL),(86,7,1,4,89,46,171.067,170.000,155.600,NULL,NULL,NULL,107.800,NULL,NULL,16.87420,NULL),(87,3,1,2,82,42,160.649,160.000,155.300,NULL,NULL,NULL,99.100,NULL,NULL,NULL,NULL),(88,14,1,2,81,41,158.289,158.000,145.700,NULL,NULL,NULL,97.100,NULL,NULL,13.53940,NULL),(89,4,1,8,130,69,244.882,244.000,240.400,NULL,NULL,NULL,144.100,NULL,NULL,32.06736,NULL),(90,11,1,8,107,57,99.724,99.000,93.400,NULL,NULL,NULL,64.300,NULL,NULL,10.10316,NULL),(91,20,1,9,113,61,105.142,104.000,98.200,NULL,NULL,NULL,67.500,NULL,NULL,8.28430,NULL),(94,23,9,24,159,91,270.065,270.000,270.000,4.100,13.600,40.000,NULL,NULL,NULL,NULL,NULL),(93,23,1,9,121,65,225.737,224.000,225.000,NULL,NULL,NULL,144.100,NULL,NULL,29.97560,NULL),(95,25,7,9,119,64,110.013,110.000,110.800,8.500,7.600,27.000,NULL,4.41100,NULL,NULL,NULL),(96,25,1,7,80,43,73.911,73.000,70.000,NULL,NULL,NULL,NULL,NULL,NULL,6.00000,NULL),(97,25,2,6,104,55,98.526,98.000,99.400,7.000,8.700,27.000,NULL,NULL,6.72202,NULL,NULL),(98,25,3,8,107,57,99.205,99.000,100.100,3.400,6.500,20.000,NULL,NULL,NULL,NULL,NULL),(99,25,4,8,123,65,115.083,115.000,116.400,4.500,6.000,18.000,NULL,NULL,NULL,NULL,NULL),(100,25,9,13,121,67,108.021,108.000,109.300,1.800,3.200,10.000,NULL,NULL,NULL,NULL,NULL),(101,25,8,8,125,66,117.063,117.000,117.100,6.200,8.300,28.000,NULL,NULL,NULL,NULL,NULL),(102,25,5,13,44,28,31.051,31.000,31.600,2.700,2.800,5.000,NULL,NULL,NULL,NULL,NULL),(103,25,10,6,57,31,51.035,51.000,51.700,3.300,4.500,15.000,NULL,NULL,NULL,NULL,NULL),(104,8,1,3,88,45,171.480,170.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,19.51570,NULL),(105,12,1,9,119,64,112.550,110.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,12.20570,NULL),(106,21,1,6,126,66,122.500,120.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,11.19240,NULL),(107,22,1,6,137,71,263.240,262.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,39.60600,NULL),(108,8,2,4,113,58,218.860,218.000,NULL,NULL,NULL,NULL,NULL,NULL,18.40445,NULL,NULL),(109,12,2,11,153,82,143.030,142.000,NULL,NULL,NULL,NULL,NULL,NULL,11.95603,NULL,NULL),(110,21,2,5,90,47,170.310,170.000,NULL,NULL,NULL,NULL,NULL,NULL,11.65501,NULL,NULL),(111,22,2,10,176,93,334.010,332.000,NULL,NULL,NULL,NULL,NULL,NULL,35.86438,NULL,NULL),(112,8,3,18,128,73,220.050,220.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113,12,3,37,157,97,120.590,120.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114,21,3,17,100,58,166.200,166.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115,22,3,23,158,90,271.690,270.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116,8,4,6,137,71,262.280,262.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117,12,4,11,162,86,151.600,151.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118,21,4,4,100,52,192.160,192.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119,22,4,4,171,87,334.200,334.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120,8,5,16,113,64,97.060,97.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121,12,5,17,65,41,48.120,48.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122,21,5,23,90,56,67.020,67.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123,22,5,21,137,79,116.300,116.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124,8,7,5,126,65,242.070,242.000,NULL,NULL,NULL,NULL,NULL,12.82100,NULL,NULL,NULL),(125,12,7,9,170,89,162.200,161.000,NULL,NULL,NULL,NULL,NULL,7.83300,NULL,NULL,NULL),(126,8,8,5,125,65,240.430,240.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127,12,8,7,156,81,149.410,149.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128,21,8,5,102,53,194.060,194.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129,22,8,3,163,83,320.210,320.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130,8,9,7,120,63,226.020,226.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131,12,9,18,155,86,137.360,137.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132,21,9,9,101,55,184.030,184.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133,22,9,156,14,85,284.050,284.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134,8,10,9,116,62,107.060,107.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135,12,10,7,66,36,59.160,59.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136,21,10,9,94,51,85.200,85.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137,22,10,12,137,74,125.840,125.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140,3,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,12.70600),(139,1,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,7.69020),(141,4,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,20.02600),(142,25,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,4.54580),(143,21,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,7.88960),(144,12,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,8.66170),(145,14,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,11.62360),(146,7,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,13.15650),(147,22,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,21.01220),(148,11,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,7.43670),(149,20,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,7.18870),(150,23,6,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,19.26310),(151,26,4,5,111,58,212.190,212.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152,26,8,2,91,46,180.080,178.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153,26,1,1,93,47,184.010,184.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154,26,3,14,112,63,197.610,196.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155,26,2,2,120,61,236.400,236.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156,26,9,11,98,54,174.340,174.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157,26,7,1,150,75,298.340,298.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158,4,2,132,67,525,520.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159,27,8,3,112,57,436.320,436.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160,27,1,2,124,63,491.400,488.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161,27,2,2,150,76,592.100,592.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162,27,9,2,119,60,468.310,468.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163,27,7,2,156,79,774.810,770.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164,30,7,NULL,NULL,NULL,NULL,NULL,39.760,2.990,3.000,NULL,NULL,2.02000,NULL,NULL,NULL),(165,29,7,NULL,NULL,NULL,NULL,NULL,71.430,4.590,4.340,NULL,NULL,3.50600,NULL,NULL,NULL),(166,38,7,NULL,NULL,NULL,NULL,NULL,87.580,7.740,6.960,NULL,NULL,4.73900,NULL,NULL,NULL),(167,35,7,NULL,NULL,NULL,NULL,NULL,52.400,3.690,3.960,NULL,NULL,3.05100,NULL,NULL,NULL),(168,31,7,NULL,NULL,NULL,NULL,NULL,121.410,9.210,7.590,NULL,NULL,4.65300,NULL,NULL,NULL),(169,28,7,NULL,NULL,NULL,NULL,NULL,41.920,3.340,2.890,NULL,NULL,1.85700,NULL,NULL,NULL),(170,33,7,NULL,NULL,NULL,NULL,NULL,36.650,3.110,2.660,NULL,NULL,1.78400,NULL,NULL,NULL),(171,40,7,8,132,70,101.080,100.790,101.170,8.940,8.530,NULL,NULL,4.82500,NULL,NULL,NULL),(172,32,7,NULL,NULL,NULL,NULL,NULL,41.660,6.190,3.230,NULL,NULL,2.83400,NULL,NULL,NULL),(173,39,7,NULL,NULL,NULL,NULL,NULL,81.530,7.350,7.140,NULL,NULL,3.69800,NULL,NULL,NULL),(174,37,7,NULL,NULL,NULL,NULL,NULL,111.610,8.100,7.510,NULL,NULL,4.82500,NULL,NULL,NULL),(175,36,7,NULL,NULL,NULL,NULL,NULL,129.540,8.890,8.180,NULL,NULL,6.22700,NULL,NULL,NULL),(176,34,7,NULL,NULL,NULL,NULL,NULL,105.430,7.770,7.110,NULL,NULL,5.69600,NULL,NULL,NULL),(177,78,7,216,6,111,265.760,262.500,265.000,20.700,23.500,NULL,NULL,12.84000,NULL,NULL,NULL),(178,62,7,NULL,NULL,NULL,NULL,NULL,16.050,1.580,1.330,NULL,NULL,0.77100,NULL,NULL,NULL),(180,76,7,1850,69,959,129.321,128.410,127.190,13.310,12.230,NULL,NULL,5.98000,NULL,NULL,NULL),(181,77,7,221,10,115,264.176,263.750,260.000,40.780,42.050,NULL,NULL,20.09000,NULL,NULL,NULL),(182,49,7,NULL,NULL,NULL,NULL,NULL,17.090,1.000,1.180,NULL,NULL,0.81900,NULL,NULL,NULL),(183,57,7,NULL,NULL,NULL,NULL,NULL,135.870,9.200,9.350,NULL,NULL,6.82200,NULL,NULL,NULL),(184,48,7,NULL,NULL,NULL,NULL,NULL,54.670,5.700,4.320,NULL,NULL,3.71800,NULL,NULL,NULL),(185,47,7,NULL,NULL,NULL,NULL,NULL,40.400,3.020,2.840,NULL,NULL,1.52200,NULL,NULL,NULL),(186,59,7,NULL,NULL,NULL,NULL,NULL,102.710,7.980,7.550,NULL,NULL,4.89100,NULL,NULL,NULL),(187,50,7,NULL,NULL,NULL,NULL,NULL,17.200,1.210,1.180,NULL,NULL,0.98600,NULL,NULL,NULL),(188,42,7,NULL,NULL,NULL,NULL,NULL,82.510,7.080,7.710,NULL,NULL,4.21800,NULL,NULL,NULL),(189,44,7,NULL,NULL,NULL,NULL,NULL,78.100,7.170,7.490,NULL,NULL,5.44500,NULL,NULL,NULL),(190,43,7,NULL,NULL,NULL,NULL,NULL,81.000,6.750,6.630,NULL,NULL,4.11500,NULL,NULL,NULL),(191,55,7,NULL,NULL,NULL,NULL,NULL,98.400,7.040,6.980,NULL,NULL,4.40700,NULL,NULL,NULL),(192,54,7,NULL,NULL,NULL,NULL,NULL,76.100,5.420,4.370,NULL,NULL,3.21000,NULL,NULL,NULL),(193,56,7,NULL,NULL,NULL,NULL,NULL,135.490,7.750,8.060,NULL,NULL,4.90400,NULL,NULL,NULL),(194,58,7,NULL,NULL,NULL,NULL,NULL,52.960,3.260,3.210,NULL,NULL,2.17300,NULL,NULL,NULL),(195,52,7,NULL,NULL,NULL,NULL,NULL,66.430,5.740,5.550,NULL,NULL,3.52600,NULL,NULL,NULL),(196,41,7,10,262,136,157.652,157.500,157.000,12.680,13.730,NULL,NULL,7.24300,NULL,NULL,NULL),(197,51,7,NULL,NULL,NULL,NULL,NULL,70.030,4.960,5.110,NULL,NULL,4.06300,NULL,NULL,NULL),(198,45,7,NULL,NULL,NULL,NULL,NULL,106.510,9.000,8.800,NULL,NULL,6.00400,NULL,NULL,NULL),(199,46,7,NULL,NULL,NULL,NULL,NULL,108.160,9.510,8.260,NULL,NULL,6.36000,NULL,NULL,NULL),(200,53,7,NULL,NULL,NULL,NULL,NULL,85.850,6.240,6.140,NULL,NULL,4.41300,NULL,NULL,NULL),(201,65,7,NULL,NULL,NULL,NULL,NULL,58.000,NULL,NULL,NULL,NULL,3.05700,NULL,NULL,NULL),(202,61,7,NULL,NULL,NULL,NULL,NULL,160.000,NULL,NULL,NULL,NULL,12.00000,NULL,NULL,NULL),(205,71,7,1,192,96,965.111,954.821,965.111,NULL,NULL,NULL,NULL,64.09700,NULL,NULL,NULL),(206,149,7,NULL,NULL,NULL,NULL,NULL,400.000,NULL,NULL,NULL,NULL,30.00000,NULL,NULL,NULL),(207,148,7,NULL,NULL,NULL,NULL,NULL,59.500,4.750,4.700,NULL,NULL,3.22400,NULL,NULL,NULL),(208,147,7,NULL,NULL,NULL,NULL,NULL,20.500,1.550,1.500,NULL,NULL,1.11300,NULL,NULL,NULL),(209,146,7,NULL,NULL,NULL,NULL,NULL,104.850,7.200,6.550,NULL,NULL,4.78700,NULL,NULL,NULL),(210,145,7,NULL,NULL,NULL,NULL,NULL,88.100,7.800,7.000,NULL,NULL,5.37500,NULL,NULL,NULL),(211,143,7,NULL,NULL,NULL,NULL,NULL,92.600,7.900,6.750,NULL,NULL,6.00000,NULL,NULL,NULL),(212,144,7,NULL,NULL,NULL,NULL,NULL,134.900,11.200,10.500,NULL,NULL,6.20400,NULL,NULL,NULL),(213,142,7,NULL,NULL,NULL,NULL,NULL,17.550,2.100,2.200,NULL,NULL,1.19800,NULL,NULL,NULL),(214,141,7,NULL,NULL,NULL,NULL,NULL,29.870,2.700,1.740,NULL,NULL,1.85900,NULL,NULL,NULL),(215,140,7,NULL,NULL,NULL,NULL,NULL,31.800,4.000,2.900,NULL,NULL,1.98900,NULL,NULL,NULL),(216,139,7,NULL,NULL,NULL,NULL,NULL,72.600,5.600,4.550,NULL,NULL,2.68300,NULL,NULL,NULL),(217,138,7,NULL,NULL,NULL,NULL,NULL,28.300,2.350,22.000,NULL,NULL,1.62900,NULL,NULL,NULL),(218,135,7,NULL,NULL,NULL,NULL,NULL,13.600,2.050,1.550,NULL,NULL,1.06100,NULL,NULL,NULL),(219,136,7,NULL,NULL,NULL,NULL,NULL,7.050,0.320,0.320,NULL,NULL,0.40300,NULL,NULL,NULL),(220,137,7,NULL,NULL,NULL,NULL,NULL,5.520,0.200,0.200,NULL,NULL,0.33500,NULL,NULL,NULL),(221,150,7,NULL,NULL,NULL,NULL,NULL,450.000,49.100,58.050,NULL,NULL,30.51500,NULL,NULL,NULL),(222,151,7,4,170,87,415.930,415.000,420.000,48.400,54.700,NULL,NULL,29.74100,NULL,NULL,NULL),(225,152,7,6,179,92,216.493,216.250,215.000,19.500,19.000,NULL,NULL,12.36800,NULL,NULL,NULL),(226,153,7,4,157,80,192.810,191.250,190.000,21.600,22.600,NULL,NULL,12.23300,NULL,NULL,NULL),(227,126,7,1,109,55,550.758,540.000,550.758,NULL,NULL,NULL,NULL,49.34600,NULL,NULL,NULL),(228,169,7,NULL,NULL,NULL,NULL,NULL,85.900,4.650,4.550,NULL,NULL,3.09000,NULL,NULL,NULL),(229,170,7,NULL,NULL,NULL,NULL,NULL,59.300,3.900,4.200,NULL,NULL,2.91500,NULL,NULL,NULL),(230,171,7,NULL,NULL,NULL,NULL,NULL,68.100,3.650,3.950,NULL,NULL,2.22500,NULL,NULL,NULL),(231,172,7,NULL,NULL,NULL,NULL,NULL,41.800,2.300,2.550,NULL,NULL,1.36100,NULL,NULL,NULL),(232,173,7,NULL,NULL,NULL,NULL,NULL,31.000,1.850,1.900,NULL,NULL,1.26800,NULL,NULL,NULL),(234,168,7,NULL,NULL,NULL,NULL,NULL,127.300,7.400,7.200,NULL,NULL,4.96900,NULL,NULL,NULL),(242,125,7,NULL,NULL,NULL,NULL,NULL,118.200,8.900,7.000,NULL,NULL,4.88600,NULL,NULL,NULL),(246,167,7,NULL,NULL,NULL,NULL,NULL,104.650,6.000,5.850,NULL,NULL,4.09900,NULL,NULL,NULL),(248,79,7,NULL,NULL,NULL,NULL,NULL,248.000,16.440,17.110,NULL,NULL,12.92600,NULL,NULL,NULL),(249,80,7,5,132,68,159.917,158.750,163.000,18.370,18.410,NULL,NULL,12.35500,NULL,NULL,NULL),(250,175,7,5,169,87,205.187,205.000,198.000,17.260,17.400,NULL,NULL,9.67100,NULL,NULL,NULL),(251,176,7,NULL,NULL,NULL,241.348,238.750,242.000,15.970,16.150,NULL,NULL,12.27100,NULL,NULL,NULL),(252,177,7,NULL,NULL,NULL,NULL,NULL,390.000,37.000,35.000,NULL,NULL,20.25000,NULL,NULL,NULL),(253,178,7,1,106,53,157.506,157.500,160.000,16.450,18.200,NULL,NULL,10.03100,NULL,NULL,NULL),(254,67,7,93,1851,972,22.366,22.327,NULL,NULL,NULL,NULL,NULL,0.67600,NULL,NULL,NULL),(255,63,7,58,1813,935,30.801,30.713,NULL,NULL,NULL,NULL,NULL,1.06600,NULL,NULL,NULL),(256,66,7,1832,94,963,50.170,50.054,NULL,NULL,NULL,NULL,NULL,1.02100,NULL,NULL,NULL),(257,128,7,153,2,77,456.229,453.000,456.229,NULL,NULL,NULL,NULL,33.58700,NULL,NULL,NULL),(258,69,7,100,1864,982,71.355,71.266,NULL,NULL,NULL,NULL,NULL,2.68800,NULL,NULL,NULL),(259,68,7,1848,65,956,32.619,32.451,NULL,NULL,NULL,NULL,NULL,0.98400,NULL,NULL,NULL),(260,70,7,82,1838,960,64.148,64.094,NULL,NULL,NULL,NULL,NULL,3.87800,NULL,NULL,NULL),(261,180,7,5,222,113,327.812,325.500,300.000,32.390,42.660,NULL,NULL,24.25000,NULL,NULL,NULL),(262,181,7,199,3,101,294.173,294.000,294.000,20.400,23.800,NULL,NULL,12.96900,NULL,NULL,NULL),(264,183,7,2,171,86,78.320,77.870,77.000,NULL,NULL,NULL,NULL,3.60200,NULL,NULL,NULL),(265,184,7,1,156,78,233.824,232.500,235.000,NULL,NULL,NULL,NULL,12.79300,NULL,NULL,NULL),(266,162,7,6,182,94,53.605,53.590,53.000,4.600,5.600,NULL,NULL,2.72400,NULL,NULL,NULL),(267,162,13,9,184,96,46.702,46.526,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(268,162,12,92,1,46,89.805,89.726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(269,158,7,1,88,44,65.199,65.076,65.650,7.400,7.800,NULL,NULL,3.57600,NULL,NULL,NULL),(270,158,13,1,180,90,65.840,65.689,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(271,158,12,179,1,90,112.999,112.664,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(272,157,7,1,89,45,109.613,107.536,109.800,13.000,12.500,NULL,NULL,5.50900,NULL,NULL,NULL),(273,164,7,1,89,45,78.321,78.144,78.400,7.600,7.300,NULL,NULL,3.63000,NULL,NULL,NULL),(274,165,7,89,1,45,80.256,80.256,80.100,7.800,8.150,NULL,NULL,3.44200,NULL,NULL,NULL),(275,165,13,1,87,44,61.768,61.748,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(276,165,12,1,92,46,110.384,110.292,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(277,159,7,1,88,44,62.634,62.466,62.650,6.200,6.700,NULL,NULL,3.71700,NULL,NULL,NULL),(278,159,13,1,87,44,67.276,66.908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(280,159,12,181,1,91,117.874,117.655,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(281,219,7,1,90,45,222.655,222.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(282,219,13,1,76,38,281.562,281.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(283,219,12,1,75,38,373.534,370.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(284,156,7,91,1,46,92.144,92.110,91.800,10.500,11.150,NULL,NULL,5.79700,NULL,NULL,NULL),(285,163,7,1,89,45,51.843,51.393,52.500,4.800,5.450,NULL,NULL,2.83900,NULL,NULL,NULL),(286,163,13,2,87,44,51.004,50.661,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(287,163,12,1,87,44,90.664,90.300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(288,109,7,1,91,46,225.280,225.000,230.000,27.650,22.850,NULL,NULL,13.07200,NULL,NULL,NULL),(289,98,7,1,64,32,315.853,315.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(290,64,7,1,89,45,44.458,43.824,45.000,NULL,NULL,NULL,NULL,2.18000,NULL,NULL,NULL),(291,64,13,1,97,49,34.310,34.272,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(292,64,12,1,89,45,62.895,62.833,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(293,221,7,8,184,96,46.445,46.436,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(294,75,7,1,89,45,105.447,105.422,106.610,14.210,10.460,NULL,NULL,6.51200,NULL,NULL,NULL),(295,75,13,1,94,47,113.570,112.624,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(296,75,12,1,88,44,211.189,210.710,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(297,217,7,1,74,37,365.394,365.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(298,217,13,1,82,41,405.705,405.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(299,217,12,1,80,40,792.854,790.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(300,218,7,1,66,33,246.423,243.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(301,218,12,1,91,46,451.319,450.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(302,218,13,1,85,43,211.270,210.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(303,161,7,1,88,44,58.603,58.291,57.800,5.300,4.800,NULL,NULL,2.61600,NULL,NULL,NULL),(304,161,13,1,88,44,49.143,49.067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(305,161,12,1,88,44,81.103,80.736,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(306,60,7,1,88,44,64.626,64.379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(307,60,13,1,85,43,56.056,55.943,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(308,60,12,1,81,41,83.759,83.521,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(309,182,13,1,179,90,66.081,66.069,55.000,5.350,5.500,NULL,NULL,1.99200,NULL,NULL,NULL),(310,182,12,1,177,89,86.297,86.064,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(311,182,7,1,86,43,54.744,54.740,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(312,76,7,1,89,45,127.726,126.894,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(313,76,13,1,75,38,136.021,135.864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(314,76,12,1,85,43,206.401,205.635,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(315,155,7,1,89,45,97.534,97.503,97.800,9.550,9.000,NULL,NULL,4.62300,NULL,NULL,NULL),(316,155,13,1,80,40,88.531,88.482,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(317,155,12,1,86,43,136.681,136.003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(318,154,7,1,91,46,43.438,43.380,43.250,3.700,3.400,NULL,NULL,1.73800,NULL,NULL,NULL),(319,154,13,1,93,47,51.014,50.876,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(320,154,12,1,89,45,70.723,70.576,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(321,223,7,1,63,32,232.500,232.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(322,223,13,1,70,35,345.052,345.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(323,223,12,1,74,37,368.525,365.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(324,160,7,1,90,45,63.713,63.547,64.700,5.200,6.600,NULL,NULL,3.58300,NULL,NULL,NULL),(325,133,7,1,85,43,340.590,336.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(326,133,13,1,88,44,521.958,521.749,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(327,133,12,1,145,73,580.722,575.929,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(328,166,7,1,89,45,36.661,36.608,37.000,2.350,2.200,NULL,NULL,1.22700,NULL,NULL,NULL),(329,166,13,1,128,64,24.327,24.191,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(330,166,12,1,115,58,43.558,43.548,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(331,206,7,1,88,44,87.276,87.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(332,188,7,1,92,46,90.786,90.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(333,209,7,1,79,40,78.199,78.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(334,198,7,129,2,65,317.562,317.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(335,211,7,1,174,87,173.128,173.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(336,216,7,1,226,113,113.177,112.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(337,205,7,1,109,55,54.157,54.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(338,212,7,141,1,71,140.000,140.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(339,202,7,1,66,33,65.201,65.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(340,192,7,68,1,34,67.359,67.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(341,185,7,1,105,53,103.791,103.505,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(342,207,7,1,72,36,106.917,106.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(343,203,7,6,155,80,150.205,149.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(344,189,7,1,75,38,74.105,74.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(345,191,7,1,197,99,196.873,196.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(346,214,7,122,1,61,309.662,302.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(347,195,7,3,116,59,228.270,226.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(348,210,7,1,72,36,71.167,71.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(349,190,7,1,108,54,53.891,53.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(350,213,7,1,94,47,187.649,186.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(351,208,7,1,114,57,90.889,90.400,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(352,199,7,1,119,60,59.417,59.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(353,187,7,1,110,55,88.358,87.200,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(354,204,7,1,89,45,88.378,88.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(355,200,7,1,86,43,85.260,85.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(356,193,7,1,89,45,54.807,54.560,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(357,197,7,1,74,37,73.232,73.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(358,201,7,1,113,57,56.019,56.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(359,186,7,1,106,53,105.329,104.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(360,215,7,1,74,37,109.937,109.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(361,194,7,1,75,38,74.141,74.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(362,231,7,12,146,79,169.790,169.450,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(363,227,7,13,184,98,56.760,56.260,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(364,228,7,18,182,100,80.141,79.540,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(365,234,7,13,177,95,123.270,123.170,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(366,235,7,16,184,100,189.324,188.670,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(367,229,7,4,132,68,134.186,134.015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(368,232,7,169,13,91,75.175,74.411,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(369,230,7,188,9,98,199.290,197.340,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(370,233,7,2,242,122,300.507,300.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(371,231,2,127,9,68,85.254,85.188,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(372,227,2,83,11,47,22.814,22.515,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(373,228,2,89,11,50,33.600,33.524,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(374,234,2,179,17,98,56.609,56.347,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(375,235,2,170,18,94,82.316,80.964,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(376,229,2,186,12,999,70.068,69.910,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(377,232,2,10,133,71,39.302,39.097,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(378,230,2,179,16,97,126.214,125.930,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(379,233,2,8,176,92,212.252,210.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(380,231,3,163,13,88,108.357,108.120,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(381,227,3,42,143,92,28.450,28.340,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(382,228,3,25,127,76,44.077,43.998,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(383,234,3,44,143,93,74.830,74.298,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(384,235,3,75,268,171,108.950,108.140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(385,229,3,16,163,89,85.205,84.817,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(386,232,3,29,124,76,45.113,45.078,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(387,230,3,15,140,77,138.377,137.740,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(388,233,3,20,144,82,310.810,310.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(389,231,4,186,12,99,126.007,125.415,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(390,227,4,15,141,78,35.579,35.359,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(391,228,4,2,124,63,52.696,52.625,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(392,234,4,26,141,83,86.382,86.306,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(393,235,4,35,263,149,127.950,127.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(394,229,4,177,8,92,98.399,97.744,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(395,232,4,3,120,61,55.571,55.517,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(396,230,4,14,156,85,157.170,156.824,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(397,233,4,3,142,72,348.200,347.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(398,231,10,31,161,96,94.497,93.720,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(399,227,10,46,125,85,38.910,38.710,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(400,228,10,15,171,93,44.417,44.396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(401,234,5,156,313,234,11.964,11.791,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(402,235,5,10,164,87,17.340,17.290,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(403,229,5,24,94,59,14.067,14.044,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(404,232,10,27,122,74,30.293,30.224,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(405,230,5,173,16,94,19.438,19.290,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(406,233,10,50,192,121,179.636,177.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(407,231,8,6,194,100,239.430,238.950,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(408,227,8,177,24,100,75.560,75.190,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(409,228,8,4,177,90,104.435,104.150,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(410,234,8,14,183,98,167.420,166.920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(411,235,8,3,235,119,290.380,290.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(412,229,8,163,2,82,168.470,168.374,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(413,232,8,17,172,94,83.390,82.840,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(414,230,8,11,239,1125,285.077,285.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(415,233,8,5,234,119,572.685,572.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(416,237,7,7,155,81,185.740,185.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(417,238,7,5,180,92,221.752,218.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(418,239,7,8,130,69,152.835,152.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(419,240,7,10,195,102,232.345,231.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(420,241,7,3,126,64,309.390,307.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(421,245,7,3,166,84,411.044,407.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(422,242,7,8,364,186,445.900,445.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(423,91,7,1,75,38,370.461,370.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(424,243,7,5,264,134,327.800,323.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(425,95,7,1,94,47,479.966,465.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(426,244,7,12,160,86,114.730,114.699,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(427,94,7,1,108,54,541.525,535.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(428,236,7,10,140,75,328.390,325.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(429,132,7,1,161,81,487.439,479.873,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(430,237,2,21,142,81,151.421,151.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(431,238,2,12,165,88,178.304,178.246,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(432,239,2,7,103,55,124.222,120.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(433,240,2,2,156,79,193.214,192.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(434,241,2,4,198,101,243.162,242.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(435,245,2,2,141,71,347.846,347.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(436,242,2,6,161,83,387.790,387.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(437,243,2,11,214,112,255.150,253.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(438,95,2,1,80,40,396.695,395.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(439,244,2,166,13,89,93.339,93.023,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(440,236,2,8,134,71,317.504,315.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(441,183,2,188,12,100,68.670,68.640,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(442,40,2,185,16,100,84.720,84.630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(443,242,8,7,204,105,492.730,492.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(444,237,8,4,186,95,227.840,227.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(445,238,8,4,186,95,228.755,227.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(446,91,8,1,85,43,420.610,420.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(447,239,8,9,130,69,151.667,151.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(448,243,8,6,277,141,339.437,338.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(449,240,8,6,200,103,242.590,242.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(450,94,8,1,132,66,656.335,655.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(451,132,8,1,113,57,534.087,523.917,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(452,244,8,176,17,96,123.449,123.224,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(453,241,8,3,132,67,322.639,322.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(454,236,8,7,148,77,353.137,352.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(455,245,8,2,156,79,387.451,385.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(456,40,8,159,16,87,116.740,116.690,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(457,183,8,176,2,89,90.950,90.910,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(458,242,4,4,200,102,491.460,490.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(459,237,4,10,175,92,207.030,206.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(460,238,4,5,188,96,229.090,228.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(461,239,4,3,108,55,132.338,131.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(462,243,4,10,261,135,313.985,313.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(463,240,4,8,183,95,219.550,218.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(464,244,4,182,19,100,99.307,99.102,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(465,241,4,5,274,139,336.489,336.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(466,236,4,5,172,88,417.990,417.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(467,245,4,19,179,99,404.047,400.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(468,183,4,3,1698,850,67.740,67.630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(469,40,4,10,99,54,84.284,83.190,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(470,242,3,44,204,124,401.130,400.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(471,237,3,42,179,110,171.940,171.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(472,238,3,43,192,117,190.516,186.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(473,239,3,26,111,68,106.906,106.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(474,243,3,59,267,163,261.513,260.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(475,240,3,47,187,117,176.685,175.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(476,244,3,145,14,79,80.246,79.650,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(477,241,3,62,280,171,273.164,272.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(478,236,3,36,176,106,350.218,350.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(479,245,3,61,187,124,316.945,315.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(480,183,3,310,1738,1024,57.030,56.980,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(481,40,3,26,101,63,70.162,70.100,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(482,246,7,4,225,114,277.963,276.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(483,246,5,9,194,101,231.598,231.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(484,246,10,7,219,113,265.076,265.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(485,246,4,8,259,133,314.174,313.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(486,246,3,53,266,159,266.860,266.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(487,246,8,8,271,139,329.044,328.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(488,247,2,4,168,86,410.348,410.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(489,247,7,5,188,96,457.897,457.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(490,247,5,6,241,123,587.670,587.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(491,247,10,6,238,122,580.491,580.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(492,247,3,258,7,132,627.976,627.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(493,247,8,5,214,109,525.786,522.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(494,247,4,5,171,88,416.288,415.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(495,245,10,3,175,89,215.965,215.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(496,245,5,5,154,79,187.325,186.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(497,239,5,8,76,42,85.757,85.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(498,239,10,10,88,49,97.754,97.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(499,237,5,8,156,82,185.360,185.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(500,237,10,3,157,80,192.580,192.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(501,249,2,5,327,166,405.080,402.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(502,249,3,98,418,258,402.090,400.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(503,249,4,9,409,209,501.300,500.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(504,249,5,5,272,138,334.870,333.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(505,249,8,8,390,199,477.570,477.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(506,249,10,51,347,199,370.470,370.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(507,242,10,5,329,167,406.350,405.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(508,242,5,66,340,203,342.980,342.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(509,40,10,22,195,108,70.640,70.480,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(510,40,5,100,628,364,49.840,49.630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(511,250,2,6,354,180,453.730,435.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(512,250,3,103,320,211,276.380,271.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(513,250,4,7,309,158,384.940,377.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(514,250,7,4,383,193,474.410,473.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(515,250,8,6,276,141,339.020,337.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(516,183,5,3,208,105,39.340,39.040,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(517,183,10,5,105,55,58.400,58.300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(518,236,5,32,156,94,309.380,309.120,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(519,236,10,10,269,139,324.670,323.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(520,241,5,6,185,95,224.128,223.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(521,241,10,7,193,100,232.858,232.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(522,243,10,42,253,147,263.920,263.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(523,243,5,7,202,104,244.595,243.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(524,244,5,110,12,61,59.633,59.580,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(525,244,10,127,19,73,83.937,83.699,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(526,240,5,4,128,66,155.368,155.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(527,240,10,7,143,75,170.189,170.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(528,251,2,195,248,221,33.306,33.125,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(529,251,3,191,252,221,38.166,18.125,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(530,251,4,183,259,221,47.601,47.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(531,251,10,186,260,223,46.413,46.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(532,251,7,17,152,84,84.377,84.375,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(533,251,8,14,173,93,99.512,99.375,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(534,227,5,18,79,48,6.860,6.820,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(535,228,5,36,149,92,10.060,9.760,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(536,231,5,175,25,100,20.486,20.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(537,252,2,6,131,68,78.278,78.125,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(538,252,3,149,295,222,91.527,91.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(539,252,4,130,302,216,107.503,107.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(540,252,10,155,238,196,52.102,51.875,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(541,252,7,32,247,139,134.689,134.375,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(542,252,8,14,278,146,165.110,165.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(543,234,10,18,121,69,60.130,59.970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(544,235,10,60,141,100,101.440,101.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(545,248,2,61,131,96,175.120,175.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(546,248,3,40,228,134,235.040,235.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(547,248,4,17,230,123,266.360,266.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(548,248,7,3,217,110,267.510,267.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(549,248,8,11,390,200,473.910,473.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(550,248,10,12,145,78,166.290,166.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(551,253,2,4,177,90,216.497,216.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(552,253,3,9,233,121,280.240,280.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(553,253,4,9,270,139,326.630,326.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(554,253,7,4,243,123,299.690,298.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(555,253,8,2,219,110,543.210,542.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(556,253,10,85,232,158,183.795,185.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(557,229,10,10,154,82,57.941,57.781,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(558,254,2,196,352,274,97.797,97.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(559,254,3,166,383,274,135.718,135.625,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(560,254,4,163,418,290,159.461,159.375,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(561,254,7,8,174,91,207.502,207.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(562,254,8,5,266,135,326.436,326.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(563,254,10,140,49,94,113.815,113.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(564,230,10,11,138,74,98.590,98.424,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(565,233,5,24,52,38,36.232,35.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(566,255,2,124,239,181,71.880,71.875,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(567,255,3,268,394,331,79.427,78.750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(568,255,4,254,402,328,92.636,92.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(569,255,7,40,231,135,119.465,119.375,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(570,255,8,6,302,154,185.012,185.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(571,255,10,75,165,120,56.345,56.250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(572,41,2,156,288,222,82.572,82.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(573,41,3,144,291,217,91.904,91.875,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(574,41,4,129,305,217,110.410,110.000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(575,41,8,8,332,170,202.664,202.500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(576,41,10,347,458,402,69.529,69.375,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(577,232,5,22,85,53,11.965,11.965,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `dimensions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `slices_w`
--

DROP TABLE IF EXISTS `slices_w`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `slices_w` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `label` varchar(255) DEFAULT NULL,
  `animal_id` int(11) DEFAULT NULL,
  `bone_code` int(11) DEFAULT NULL,
  `slice` int(11) DEFAULT NULL,
  `csa` double DEFAULT NULL,
  `cx` double DEFAULT NULL,
  `cy` double DEFAULT NULL,
  `density` double DEFAULT NULL COMMENT 'physical density calculated from grey values',
  `wxc` double DEFAULT NULL COMMENT 'x part of centroid weighted by density',
  `wyc` double DEFAULT NULL COMMENT 'y part of centroid weighted by density',
  `theta` double DEFAULT NULL,
  `r1` double DEFAULT NULL,
  `r2` double DEFAULT NULL,
  `imin` double DEFAULT NULL COMMENT 'second moment of area around the maximum principal axis',
  `imax` double DEFAULT NULL COMMENT 'second moment of area around the minimum principal axis',
  `ipm` double DEFAULT NULL COMMENT 'polar moment of inertia',
  `zmax` double DEFAULT NULL COMMENT 'max section modulus',
  `zmin` double DEFAULT NULL COMMENT 'min section modulus',
  `zpol` double DEFAULT NULL COMMENT 'polar modulus',
  `feret_min` double DEFAULT NULL,
  `feret_max` double DEFAULT NULL,
  `feret_angle` double DEFAULT NULL COMMENT 'angle of feret chord',
  `perimeter` double DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=54826 DEFAULT CHARSET=latin1 COMMENT='Results from BoneJ Slice Geometry with partial volume correction applied';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `slices_w`
--

LOCK TABLES `slices_w` WRITE;
/*!40000 ALTER TABLE `slices_w` DISABLE KEYS */;
INSERT INTO `slices_w` VALUES (1,'humerus',245,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2,'humerus',245,2,2,26.162655,76.9289576,109.0930675,1.8,76.8846563,109.397224,0.749105,6.1210497,8.1792495,150.4605231,235.796186,2.022106,28.8285847,24.5808366,47.1332002,11.2916803,15.4367347,2.6167969,42.6785614),(3,'humerus',245,2,3,110.6649809,78.0978956,111.0246028,1.8,79.1937091,111.8075265,0.4959113,8.557773,17.1212669,1266.9916129,4784.0335734,4.1760788,279.4205366,148.051556,338.2393149,15.9470466,30.4400725,2.896614,80.0940419),(4,'humerus',245,2,4,204.1007017,80.583084,111.6677014,1.8,82.1201947,111.478447,0.2723251,12.1794837,20.5072247,4807.5523817,17823.7786185,2.4609689,869.1463069,394.7254662,1076.4610375,22.3006651,38.0353691,2.9931597,115.3441185),(5,'humerus',245,2,5,250.6635243,80.288503,110.606873,1.8,81.8086876,110.3326379,0.1859996,14.6824204,21.4904139,11787.7538168,26166.8724907,1.4287291,1217.6067253,802.8481348,1764.0363252,27.421836,40.227358,2.9836278,111.537255),(6,'humerus',245,2,6,267.2919588,78.1377522,110.2633756,1.8,80.1605311,109.9297913,0.3620203,17.4823011,22.4158886,18264.0468214,30746.313753,5.5878419,1371.6303795,1044.7164077,2165.9265367,30.92637,41.3828945,2.9708574,121.963478),(7,'humerus',245,2,7,293.2537518,75.3816641,109.9016485,1.8,77.2441535,109.4162804,0.664261,19.795893,23.018998,22544.8740472,38020.3368618,18.57491,1651.6938219,1138.8662318,2556.0982054,33.0916643,43.1405396,2.8353048,130.4509355),(8,'humerus',245,2,8,323.5723731,72.7621662,108.6034157,1.8,74.447251,108.0131761,0.874834,18.9405155,25.7549478,25559.5905598,52446.6707894,31.7618467,2036.3726296,1349.4664697,2910.6265758,34.499566,51.2280242,2.2541115,146.772696),(9,'humerus',245,2,9,363.5483614,69.8455155,105.340287,1.8,71.4933332,105.0868383,1.0498503,23.6292757,33.7037011,27925.2597816,84409.4575269,45.5825336,2504.4566282,1181.8076907,3292.7532437,34.7480509,62.1628823,2.1180052,168.6694789),(10,'humerus',245,2,10,383.8400642,68.5558534,102.6011926,1.8,69.2451721,101.4199059,1.1338322,20.9522619,41.7489049,29576.6811622,119976.8444777,52.5163281,2873.772252,1411.6223498,3580.0422419,35.0358205,72.8336011,2.1079046,195.2821897),(11,'humerus',245,2,11,400.3085731,67.6638865,100.0046201,1.8,68.002624,98.487974,1.1084712,59.7166348,61.3427082,36474.3390554,160614.0720805,53.444991,2618.3074876,610.7902625,2409.8333631,35.18311,78.3667894,2.0765876,202.3633991),(12,'humerus',245,2,12,423.7397601,70.9363095,99.5375605,1.8,69.8762568,96.9579726,0.7573941,44.659865,58.5491651,90137.069676,218050.0735941,33.334942,3724.2217429,2018.3014379,4336.3716604,0.351562,0.7861165,2.0344439,1.6974915),(13,'humerus',245,2,13,456.7719468,73.5490436,98.7267014,1.8,71.7071673,95.8695818,0.5464734,33.8786938,66.4370608,118911.733175,316187.2383197,20.5596582,4759.1996758,3509.9267337,6100.6411464,0.351562,0.4971837,2.3561945,0.9943675),(14,'humerus',245,2,14,502.7887754,75.3863238,97.5283985,1.8,74.0521751,95.2216802,0.4814101,31.6227365,68.3463107,138806.2588616,408883.3254915,17.9660078,5982.5222676,4389.4448774,7701.5113353,0.351562,0.7861165,2.0344439,1.6974915),(15,'humerus',245,2,15,582.7762576,78.2583432,97.0809986,1.8,77.632036,95.2702191,0.4535418,33.612568,67.3953691,156402.9585359,518901.4094865,18.646625,7699.3629781,4653.1094704,9766.0341681,48.0704011,95.430791,2.4553447,286.3435455),(16,'humerus',245,2,16,680.4330385,82.5849878,97.5363836,1.8,82.4758607,96.1757046,0.4339114,35.984852,64.4758971,173988.4629323,691458.6149328,20.0450416,10724.2961502,4835.0473371,13195.71613,64.9124524,125.5288047,2.6002125,391.040865),(17,'humerus',245,2,17,778.5306446,86.0835218,97.7211386,1.8,85.8787163,96.5077945,0.4313799,37.725478,64.6511574,194935.4636655,864163.6855397,22.6848602,13366.5617241,5167.2099132,15387.7076776,66.0039866,127.6997851,2.604006,383.2211978),(18,'humerus',245,2,18,833.1857737,86.8813532,97.1029005,1.8,87.6974024,96.2353805,0.4438627,38.2848188,66.4744244,214388.0388515,957522.3795295,25.6081106,14404.3726384,5599.8185581,16695.6275142,67.6852109,129.3920108,2.5927857,388.0930963),(19,'humerus',245,2,19,921.6985599,87.9480874,95.964767,1.8,89.874645,95.4883722,0.4342358,44.3520265,67.7765151,261348.4547234,1092596.702994,27.1905695,16120.5795365,5892.5933137,19081.1953956,74.2293528,130.5938082,2.5984031,432.3278142),(20,'humerus',245,2,20,1047.0110336,90.1011363,94.1579008,1.8,92.0401729,94.1690153,0.3805256,49.448876,68.8152903,354474.8468346,1245873.8817018,24.071531,18104.6083879,7168.5117145,22288.4363552,77.1164001,131.5166142,2.6181362,435.4668874),(21,'humerus',245,2,21,1510.0647951,94.9794855,85.6878387,1.8,96.1348409,86.5436969,0.2636924,49.8723103,69.4910102,786463.8637937,1428230.7794711,17.0981911,20552.7416432,15769.5494698,30944.5578248,84.7919399,132.0123502,2.6386328,442.3128852),(22,'humerus',245,2,22,1936.0275575,95.6996111,80.0158607,1.8,96.4132825,83.7380999,0.2006901,56.2552432,68.2759546,1137505.1714535,1612541.9806859,12.8225341,23618.0070998,20220.429375,39360.2295235,90.8808596,131.7776123,2.6254247,482.3495572),(23,'humerus',245,2,23,1955.6933784,94.7652334,78.1362721,1.8,96.5360255,82.0319862,0.2057913,56.7578567,67.240638,1334682.0361714,1708807.7569984,13.610186,25413.3186126,23515.3706328,44522.9334034,95.5475186,131.2626301,2.6108192,462.0003572),(24,'humerus',245,2,24,1989.276091,94.4740808,76.6936875,1.8,96.509284,80.6086455,0.1336142,57.9835807,65.8811099,1515486.8154622,1786001.1561075,5.8838719,27109.4576228,26136.4820421,45548.2665088,98.788922,130.3816391,2.6224465,450.685768),(25,'humerus',245,2,25,2059.8893531,94.6183838,74.8327557,1.8,96.5888936,79.1159673,-0.1191912,59.2557544,61.6047065,1672665.7630856,1889665.9316249,4.85426,30674.0513504,28227.904291,48339.1250576,101.95298,129.4669727,2.6184048,479.6637605),(26,'humerus',245,2,26,2121.1911668,94.6529078,73.5563307,1.8,96.6289742,78.177506,-0.4475527,63.4837915,76.75316,1738103.0273483,2001737.8981515,66.2100552,26080.2017463,27378.6896971,47031.9508179,103.71079,128.5659879,2.5824136,574.979194),(27,'humerus',245,2,27,2185.8819784,94.6819893,72.6227014,1.8,96.5212489,77.3862247,-0.6582488,73.9337994,66.6584022,1762608.5530394,2171069.6050627,136.3322481,32570.0816766,23840.3621633,53190.2985771,105.7795027,127.5259354,2.5902989,531.5621748),(28,'humerus',245,2,28,2234.1796371,94.7930481,71.5460821,1.8,96.5810889,76.3987277,-0.7269729,65.3505355,68.8639969,1761426.2499502,2352415.877744,164.4756719,34160.3157312,26953.5090381,59364.2617787,0.351562,0.4971837,2.3561945,0.9943675),(29,'humerus',245,2,29,2265.5787108,95.0523278,70.558305,1.8,96.5552236,75.6056793,-0.7688034,83.3220843,70.4555068,1729561.3429419,2471973.8420737,182.5332536,35085.6015795,20757.5381497,50392.3393937,107.0733165,129.621534,0.8256835,545.2980776),(30,'humerus',245,2,30,2288.8924443,95.225128,69.8451844,1.8,96.4623408,75.0137706,-0.8207726,85.0265644,79.2303818,1706821.0258066,2558177.3352477,204.2244927,32287.8329765,20073.973791,50089.1319321,107.4187466,130.7096926,0.8405802,462.056389),(31,'humerus',245,2,31,2291.6813657,95.4176739,69.1662064,1.8,96.5141961,74.4767544,-0.8575225,69.0794715,72.4110978,1649116.4073162,2631700.075074,218.4256762,36343.8775937,23872.7420928,58452.4944838,0.703124,0.9943675,0.7853982,1.988735),(32,'humerus',245,2,32,2258.5211636,95.7561669,68.6528146,1.8,96.7226422,73.972506,-0.8880015,71.8326067,73.5014634,1554654.9300028,2644483.8783802,226.5615757,35978.6561595,21642.74696,56632.6805594,0.351562,0.4971837,2.3561945,0.9943675),(33,'humerus',245,2,33,2216.4615742,96.0485325,68.2511681,1.8,96.9365461,73.542362,-0.9109443,82.9314628,75.1891676,1451292.73815,2650668.4532056,230.5973638,35253.3288757,17499.9052059,48646.9928614,0.351562,0.7861165,2.0344439,1.6974915),(34,'humerus',245,2,34,2172.9937039,96.3682443,67.8727814,1.8,96.9760749,73.126368,-0.9274576,64.0107648,72.0071963,1363599.0256238,2599341.0488263,231.8424521,36098.3510126,21302.6516567,54857.1675982,0.703124,0.9943675,2.3561945,1.988735),(35,'humerus',245,2,35,2116.4305172,96.9083024,67.4338073,1.8,96.8887703,72.6575044,-0.9587022,66.5394261,71.4180674,1257261.0842685,2504145.1121387,236.2835132,35063.1878443,18894.979388,51079.5312553,99.9282925,129.3222621,0.8777984,396.1308284),(36,'humerus',245,2,36,2069.9936875,97.2419802,67.440677,1.8,96.9444176,72.4282392,-0.9838424,57.1495771,70.7555233,1171392.2479808,2423992.1946503,239.1792308,34258.6992548,20496.9539243,50702.3531916,0.351562,0.4971837,2.3561945,0.9943675),(37,'humerus',245,2,37,2016.0848152,97.5748949,67.6607943,1.8,96.9464437,72.3812116,-1.0097985,55.2259748,70.7715306,1095826.1056021,2314004.9980617,240.9028695,32696.8341233,19842.5851123,48179.0973716,94.0761011,126.9182643,0.9189852,384.2630237),(38,'humerus',245,2,38,1963.3904779,97.3740068,68.2420555,1.8,96.7373041,72.7634012,-1.0353366,63.0597346,80.5088438,1024560.0598417,2200362.1750166,242.0398323,27330.6890443,16247.4527665,39534.1378422,91.0531537,125.2612002,0.9508731,387.8079151),(39,'humerus',245,2,39,1908.300666,97.0317173,69.2339703,1.8,96.4486953,73.3606871,-1.0479003,71.8545417,80.0307019,948802.6017498,2079407.6284501,238.7310794,25982.6239148,13204.4903443,36573.145889,87.6474679,123.8336911,0.9875181,388.9022216),(40,'humerus',245,2,40,1818.6890754,96.9238804,70.8889302,1.8,96.3847552,74.6530594,-1.0573236,68.6082719,66.8407202,848179.0838879,1944716.7492698,229.9785413,29094.790477,12362.6358719,38279.5802201,85.283313,122.1595747,1.0195184,456.3339692),(41,'humerus',245,2,41,1695.8157094,96.7681091,73.1837778,1.8,96.1047342,76.4321732,-1.0483993,66.8291108,64.9066901,741979.3051001,1739031.1454686,212.2709222,26792.7873408,11102.6362057,34462.9902762,0.351562,0.4971837,2.3561945,0.9943675),(42,'humerus',245,2,42,1581.7026667,96.7826471,74.9390529,1.8,95.8944115,77.8159012,-1.0114222,64.5179605,62.24037,660644.8524762,1555596.3094124,189.3836851,24993.3654034,10239.7045369,32549.7752103,0.351562,0.4971837,2.3561945,0.9943675),(43,'humerus',245,2,43,1439.4023568,96.3542622,78.8331979,1.8,95.2212335,80.4973959,-0.8820251,45.4051472,73.8942588,567195.5180533,1301416.2795076,142.9870167,17611.8726995,12491.8770781,25048.4016637,77.9442708,116.3877315,1.1341692,471.5200271),(44,'humerus',245,2,44,1325.9635107,95.5815084,82.1301213,1.8,94.1519665,85.2640504,-0.7411934,39.8606726,56.2302496,483263.7368701,1119668.1765539,100.740689,19912.20356,12123.8229265,28494.7760612,68.7009441,100.237102,0.9876575,393.9886338),(45,'humerus',245,2,45,1258.5200325,95.0110087,83.7001136,1.8,93.4304005,86.675139,-0.686497,37.3302673,51.9285376,446262.1443517,1027008.101319,84.2668399,19777.3353239,11954.4320677,27769.1680222,65.928969,96.9807848,0.947597,362.1981453),(46,'humerus',245,2,46,1209.739938,94.8213366,84.9030994,1.8,93.0415704,87.794609,-0.6502895,49.9174995,50.1737927,413766.1583606,955204.7119148,73.9009043,19037.9212195,8289.0001054,26080.2183897,64.0760359,93.5577756,0.8972291,386.1689665),(47,'humerus',245,2,47,1159.6297276,94.9025232,85.960932,1.8,92.8545635,88.9831531,-0.6291446,44.2406472,48.4228256,381436.4164591,890659.0204567,66.9255772,18393.3715142,8621.8543465,24668.5560279,62.4796753,91.363517,0.9026659,364.2928816),(48,'humerus',245,2,48,1118.5385678,94.9532417,86.8797721,1.8,92.7168544,89.9639112,-0.6139693,45.5353948,62.8248425,354239.524155,836939.6701226,61.8757011,13321.7949676,7779.4323658,18646.2461677,59.0106045,89.4447243,0.8856199,317.7721229),(49,'humerus',245,2,49,1089.9027226,95.4153147,87.7967703,1.8,92.7813047,90.816108,-0.6173416,77.1031133,47.4943427,326728.1689852,789830.7390732,60.8692388,16629.9961924,4237.548328,13416.7886131,59.9907355,87.198716,0.9111676,366.3315861),(50,'humerus',245,2,50,1057.4623352,95.9007171,88.4203928,1.8,92.9584031,91.551134,-0.6224265,76.4717015,46.9185507,303013.0265248,745310.7409865,59.9050202,15885.2038261,3962.4203521,12710.5151295,57.8488035,85.6145506,0.8755323,316.3658749),(51,'humerus',245,2,51,1027.9388846,96.2419851,89.090576,1.8,93.3144557,92.2502948,-0.6308055,75.9853988,46.4278127,283620.305781,702763.7232643,59.5962457,15136.6967724,3732.5632346,12053.9225483,56.890167,84.1431167,0.8386023,315.0449301),(52,'humerus',245,2,52,1011.1729591,96.428564,89.5648587,1.8,93.3675016,92.7588943,-0.6304386,75.4811491,45.8833722,270898.8252804,670246.7685023,58.5653143,14607.6178747,3588.960005,11558.9190142,55.975435,82.9157319,0.8423934,316.8630586),(53,'humerus',245,2,53,997.6631473,96.6129049,89.8942839,1.8,93.4534361,92.9982343,-0.6318236,75.1486555,62.5248782,260313.0463426,642847.5004085,58.0022714,10281.4674536,3463.974764,11137.5688587,54.9280685,81.8505498,0.8248913,321.6289559),(54,'humerus',245,2,54,991.821521,96.7385206,90.2822713,1.8,93.7068279,93.2176104,-0.6364619,74.9025009,44.4382237,252232.7641598,620823.3786585,58.3945639,13970.4814132,3367.4812082,10807.7041962,54.469484,80.6679674,0.8408967,340.5926058),(55,'humerus',245,2,55,995.6671119,96.858949,90.5328462,1.8,93.8126869,93.2896779,-0.6398261,74.7309366,44.2302773,247304.2152854,604549.7568468,59.1552124,13668.2334782,3309.2615522,10575.818387,53.7334619,79.8634041,0.8258745,335.5501008),(56,'humerus',245,2,56,999.7815051,96.7020082,90.8996563,1.8,93.8184448,93.5395673,-0.6426626,74.6163068,43.9853244,242094.7166181,596575.6831405,59.8527989,13563.0620156,3244.5282686,10419.4414805,51.9163024,79.2037275,0.6150896,332.1551178),(57,'humerus',245,2,57,1010.4687625,96.5543186,91.2188631,1.8,93.9988693,93.4671931,-0.6488849,74.6376042,43.4072368,236305.2832105,595027.6181976,61.4999006,13708.0280034,3166.0352144,10333.157795,52.7060984,79.407109,0.6187055,357.170276),(58,'humerus',245,2,58,1020.35613,96.3650225,91.6657969,1.8,93.9137615,93.852187,-0.6564861,74.6252233,44.0452291,229950.2162504,597767.2421338,63.3490551,13571.6683445,3081.4007127,10296.6253754,52.3457469,80.1838861,0.6171914,380.4879427),(59,'humerus',245,2,59,1034.3885275,96.1593726,92.1008252,1.8,93.7082647,94.2556215,-0.6640667,74.6337982,44.1092431,225094.2909852,605197.0122175,65.4864226,13720.4125447,3015.9833277,10334.1300356,52.1582726,80.3878628,0.6207579,372.7889125),(60,'humerus',245,2,60,1048.0221599,96.2182956,92.3570605,1.8,93.7570164,94.5307678,-0.6751806,74.7229717,44.6173164,222031.460537,608034.3998281,68.2389723,13627.7671783,2971.3949452,10354.4768525,52.218971,80.6618386,0.6618077,378.8111493),(61,'humerus',245,2,61,1051.5902594,96.578827,92.3653858,1.8,93.9957129,94.5602565,-0.686603,74.8147272,45.8170226,218702.5814866,593249.4447258,70.4296322,12948.2321326,2923.2557495,10168.5974132,51.9261314,80.85926,0.6435011,378.1579947),(62,'humerus',245,2,62,1056.4058904,96.8708329,92.4394784,1.8,94.2834496,94.6048138,-0.7019067,74.9878614,44.9599131,215337.3413954,580534.936035,73.4019046,12912.2788801,2871.6293196,10003.5003859,0.703124,0.9943675,2.3561945,1.988735),(63,'humerus',245,2,63,1062.4126108,97.2410802,92.4785461,1.8,94.663212,94.7636432,-0.7167585,75.1016556,44.7351018,212958.4694236,567190.55868,76.4185821,12678.8704273,2835.6028605,9847.8727712,51.2226209,79.3829799,0.6408439,401.8022387),(64,'humerus',245,2,64,1072.5391176,97.6187466,92.5186751,1.8,95.1387363,94.8238819,-0.7290183,37.8415876,44.8309175,212450.9543954,558228.8065502,79.3213346,12451.8711249,5614.2188545,17166.0502581,50.867859,78.9567867,0.6844764,418.8624569),(65,'humerus',245,2,65,1090.3297649,98.034922,92.6141394,1.8,95.5295116,94.8317884,-0.7437414,48.7171325,45.9843378,211403.0993449,558476.7834496,83.2996241,12144.9347877,4339.3994796,15706.5274833,50.8636075,79.8324463,0.6699267,360.323985),(66,'humerus',245,2,66,1085.4046205,98.8388442,92.2616956,1.8,96.3966968,94.4552111,-0.7555516,29.6773649,46.312506,209750.6287784,526346.2545386,85.0543271,11365.0998467,7067.6971939,15828.1829244,51.0018709,79.4600118,0.6567747,399.5222602),(67,'humerus',245,2,67,1084.9791138,99.5286,91.9597641,1.8,97.2554415,93.9658694,-0.7698658,27.5818458,46.6847231,208667.1248866,499352.885732,87.6066559,10696.2803269,7565.37929,15112.839278,50.9151469,78.9567867,0.6844764,400.3106874),(68,'humerus',245,2,68,1085.5741715,100.3534197,91.5029966,1.8,98.3041461,93.3467572,-0.7852457,27.0299085,45.7845565,208210.4729447,468716.7674627,90.4369362,10237.4425683,7702.9662501,14775.2896843,0.351562,0.4971837,2.3561945,0.9943675),(69,'humerus',245,2,69,1086.9001676,101.2141074,90.9131028,1.8,99.3646226,92.5861333,-0.7941066,27.4683434,44.3321692,208437.0960834,434551.9903648,92.1524709,9802.1819945,7588.2659881,14501.9084973,50.6839107,74.3327116,0.7954313,351.6866191),(70,'humerus',245,2,70,1084.1000103,102.1212146,90.2263043,1.8,100.5866263,91.6635236,-0.7928322,30.1791836,41.9953608,209026.868296,397178.5506514,91.6848246,9457.676837,6926.1936012,14394.9336532,50.9125553,70.9467447,0.8379812,370.8562093),(71,'humerus',245,2,71,1088.6336929,102.7254355,89.7433048,1.8,101.493627,90.8886043,-0.796071,27.3746442,38.8011881,211495.2208622,369870.7302552,92.6558035,9532.4588857,7725.9532413,14924.4108419,0.351562,0.4971837,2.3561945,0.9943675),(72,'humerus',245,2,72,1095.7236747,103.163901,89.4105557,1.8,102.2079237,90.3723045,-0.8046755,45.8367458,37.3944213,212730.5575935,351349.0326027,94.8298787,9395.7606667,4641.0484391,11945.1085586,0.703124,0.9943675,0.7853982,1.988735),(73,'humerus',245,2,73,1118.0457575,103.6758008,89.0431296,1.8,102.6843076,89.9430625,-0.8207802,41.3026185,36.1124187,214222.3113391,336960.2445997,99.7581029,9330.8688897,5186.6520616,12064.6418544,0.351562,0.4971837,2.3561945,0.9943675),(74,'humerus',245,2,74,1124.432741,104.0473638,88.7493836,1.8,103.1525908,89.5426025,-0.8339538,40.9398833,35.16223,214118.2283785,322089.7852221,102.7880167,9160.1068889,5230.0644544,11649.9568778,2.713898,19.3646528,1.6252878,66.6286846),(75,'humerus',245,2,75,1135.0926201,104.4014472,88.4720517,1.8,103.5630036,89.17074,-0.8510548,41.6461114,34.1776713,214115.4804521,308980.5442772,106.9764394,9040.4212108,5141.3078728,11331.3297669,1.9561541,7.1099014,1.4219064,18.2958597),(76,'humerus',245,2,76,1145.3225728,104.7114378,88.2239058,1.8,103.8976901,88.7944796,-0.8737678,27.4611645,32.9661798,214020.0595731,297505.8767296,112.2244932,9024.5784721,7793.5536801,15328.3486808,3.0358272,21.9353278,1.6832235,67.9349936),(77,'humerus',245,2,77,1158.5932829,104.9263977,88.0073369,1.8,104.080527,88.5403421,-0.9098255,27.0552219,32.4441671,213473.7625038,288216.4872944,120.3289971,8883.460817,7890.297981,14964.4641701,3.0606324,22.8623447,1.6015559,62.9278224),(78,'humerus',245,2,78,1165.0750232,105.0954994,87.7650015,1.8,104.3033326,88.1721572,-0.9433401,27.082845,32.8484601,211502.4276491,278356.504219,127.2511182,8473.9589921,7809.4612061,14467.1376887,2.1999707,8.1544198,1.4410938,24.1767615),(79,'humerus',245,2,79,1169.6961219,105.1491387,87.5650674,1.8,104.5171434,87.8687675,-0.9885945,26.8163504,30.9040651,210002.1281183,268365.4166143,136.006255,8683.8225204,7831.1226235,14473.1754794,1.75781,6.4154045,1.735945,19.8727142),(80,'humerus',245,2,80,1177.4103,105.2004431,87.3893351,1.8,104.6989529,87.6723342,-1.0408538,27.0607338,30.3119909,208499.4506903,260551.9065289,146.0942845,8595.671165,7704.870529,14121.2755579,0.703124,1.5722331,2.677945,3.4802862),(81,'humerus',245,2,81,1195.6962296,105.349252,87.0904198,1.8,104.5573566,87.3602732,-1.1097089,28.8139906,48.4559349,207386.7116948,252778.0652772,159.8335408,5216.6585178,7197.4310919,9494.8605996,0.351562,0.7861165,2.0344439,1.6974915),(82,'humerus',245,2,82,1194.521395,105.3532321,86.856766,1.8,104.5825695,87.0882796,-1.206286,26.3021165,29.6305683,203776.5941539,243339.5735803,173.7856583,8212.4504231,7747.5359931,14998.7976884,2.2688774,15.1008054,1.359703,48.8507067),(83,'humerus',245,2,83,1190.7831826,105.2952152,86.5714274,1.8,104.5648719,86.8206919,-1.3479459,26.0635637,31.5303227,199045.5799861,236379.7867801,188.7697701,7496.9034998,7636.9287838,13343.8322996,2.460934,15.8554072,1.6373645,48.5594632),(84,'humerus',245,2,84,1194.9285871,105.2469745,86.2443771,1.8,104.5572336,86.4781214,-1.4885168,26.5321996,28.6551728,194787.4621974,232841.1359835,197.8095415,8125.6231671,7341.5497151,14795.6035355,0.703124,0.9943675,0.7853982,1.988735),(85,'humerus',245,2,85,1200.2071407,105.205772,85.8764955,1.8,104.574115,86.0859055,1.5269227,25.6621182,28.2728551,190851.5623884,231147.9294723,199.6497247,8175.613288,7437.0931051,14819.0993678,0.7457756,1.4915512,0.7853982,2.9831025),(86,'humerus',245,2,86,1205.0325845,105.1585942,85.4699796,1.8,104.6094125,85.6589778,1.413406,30.267944,46.766184,187488.2560539,231054.0477442,195.9045905,4940.6222216,6194.2844809,7513.3352852,3.1408955,20.4782979,1.7782926,57.1322239),(87,'humerus',245,2,87,1211.3231258,105.0877072,85.0204807,1.8,104.5893956,85.1115387,1.3189013,25.5610848,27.399743,184582.1164539,232458.7224115,189.3458729,8483.9745436,7221.2160621,15078.717883,0.4971837,0.9943675,0.7853982,1.988735),(88,'humerus',245,2,88,1215.5623882,104.9825831,84.5752209,1.8,104.5737469,84.5706489,1.2379477,25.580895,27.8345885,181858.4480034,234236.4244086,180.9654679,8415.3004141,7109.1511024,14815.4220815,1.7284681,6.3378741,1.9100889,18.1752227),(89,'humerus',245,2,89,1223.8202757,104.9452257,84.0142731,1.8,104.4322853,83.9696856,1.1543001,29.0116775,27.8754377,178996.1477566,237154.7117647,170.586733,8507.6587686,6169.7965487,14337.2488078,0.703124,0.9943675,2.3561945,1.988735),(90,'humerus',245,2,90,1222.0915819,104.7657752,83.5801958,1.8,104.3167785,83.4723677,1.102719,26.7866874,28.2148584,175780.0810919,241216.6339316,162.2213546,8549.2767845,6562.2179663,14755.7548421,1.6835851,12.6757482,1.6262948,31.0020612),(91,'humerus',245,2,91,1215.6305158,104.5518784,83.1970558,1.8,104.1429061,83.0428526,1.0591896,54.3991064,28.9916713,173037.3785787,245100.924488,154.0431893,8454.1840281,3180.8864129,7161.6028509,3.0080763,15.3765679,1.7547398,50.3069242),(92,'humerus',245,2,92,1211.94912,104.3246608,82.8502727,1.8,103.993042,82.5851468,1.0190304,26.5643723,51.7601903,171091.0653882,249371.0690382,146.4888561,4817.8159282,6440.6214203,7955.0294961,2.6359945,15.35646,1.849096,51.5072319),(93,'humerus',245,2,93,1215.1357204,104.0511237,82.4631621,1.8,103.749835,82.2011445,0.9870328,24.8239261,29.9828257,169858.9890862,257198.1271114,140.9990348,8578.181713,6842.5513616,14175.712435,2.8583171,16.5495734,1.784857,49.5184969),(94,'humerus',245,2,94,1215.8867711,103.7363922,82.0792917,1.8,103.4365275,81.7738254,0.954818,25.3153171,60.9666058,168622.97136,265994.9310745,135.0032426,4362.9611274,6660.9069392,7100.1084241,2.1549559,10.4881027,1.8076451,27.6570477),(95,'humerus',245,2,95,1219.1620609,103.3996498,81.7045444,1.8,103.1289973,81.4195192,0.9263112,25.3243419,29.9525865,168104.0948076,277193.7767965,129.8519427,9254.4187013,6638.0439694,14790.0075468,1.8911472,10.5527177,1.6041173,27.1951977),(96,'humerus',245,2,96,1219.5213877,103.0683137,81.3659165,1.8,102.791449,81.1305547,0.899703,28.0719744,30.5812159,167968.6867705,288926.3837604,124.6578144,9447.8383181,5983.5009996,11659.5495151,0.351562,0.4971837,2.3561945,0.9943675),(97,'humerus',245,2,97,1227.563769,102.7955876,80.9533034,1.8,102.478743,80.6589167,0.8710621,28.2968,31.2144415,168464.2788712,303117.0875726,119.7376861,9710.7964529,5953.4745679,15095.121154,1.8058302,13.9964069,1.773118,37.3448129),(98,'humerus',245,2,98,1226.2215931,102.4517096,80.6450323,1.8,102.0942384,80.3250385,0.8429888,28.1008245,57.0427385,168473.3520308,314622.3958093,113.9289314,5515.5556049,5995.3170368,8383.4127794,1.6678935,8.6971636,1.815775,23.4736375),(99,'humerus',245,2,99,1228.6951204,102.0681644,80.3118118,1.8,101.6219447,79.9474338,0.8123092,26.8147335,70.3020324,169382.3781697,327010.8573629,107.8995152,4651.5135634,6316.7653104,7043.7414601,2.6694298,20.7540719,1.7582254,55.3140954),(100,'humerus',245,2,100,1231.8931815,101.7141278,80.0477717,1.8,101.2635071,79.630644,0.7808171,32.6596785,40.6168039,170616.0761799,339778.2571595,101.7172054,8365.4602082,5224.0586518,9792.8845083,2.5118915,19.9989034,1.7475052,52.6222364),(101,'humerus',245,2,101,1231.6265141,101.3352398,79.8219401,1.8,100.822714,79.4242874,0.745869,24.767066,33.1801591,172298.9779511,352359.7459554,94.5297896,10619.5918103,6956.7779244,15810.7871336,43.7521699,63.2235166,2.5181111,234.4097973),(102,'humerus',245,2,102,1235.4792586,100.9696637,79.6468421,1.8,100.4066833,79.176901,0.7104457,25.3023762,33.8137295,174275.2281181,366505.535249,87.5806338,10838.9562661,6887.7020265,15991.9120171,0.351562,0.4971837,2.3561945,0.9943675),(103,'humerus',245,2,103,1240.5784109,100.567053,79.4529694,1.8,100.0963026,79.0347469,0.6736655,24.3963736,34.2763465,176787.1556246,384142.9423525,80.4711479,11207.2312596,7246.4522125,16364.8890094,44.6095665,65.7571324,2.5194787,280.7745853),(104,'humerus',245,2,104,1243.8836633,100.2234023,79.2951211,1.8,99.7652912,78.9427344,0.6355971,65.593743,34.7269792,179183.4384988,400795.3606145,73.0636462,11541.3252211,2731.7154086,8480.2870926,45.2437211,66.9935499,2.539035,268.1890208),(105,'humerus',245,2,105,1246.9008999,99.9742716,79.0603907,1.8,99.3000052,78.6728735,0.5949512,38.8776824,35.2852829,181641.9666185,419099.969834,65.2803997,11877.4722763,4672.1397876,15307.7280691,45.9580601,68.4607759,2.5721065,267.691837),(106,'humerus',245,2,106,1238.2442848,99.7108101,79.0562578,1.8,98.9534726,78.671691,0.5640797,25.1416525,35.8306097,183358.2668365,432726.4237616,58.9895786,12077.0042044,7293.0077639,17187.7961312,46.5082019,69.716615,2.5535901,317.4162742),(107,'humerus',245,2,107,1243.5860595,99.4114421,79.1952463,1.8,98.6893239,78.7597048,0.5318569,35.7006069,66.4397707,187804.0331348,451831.1832453,53.3053937,6800.6132194,5260.527741,9323.8377045,47.4202764,71.2847765,2.5385433,333.5881262),(108,'humerus',245,2,108,1264.7280643,99.1635054,79.4430388,1.8,98.4102598,78.9992593,0.5033712,33.8501495,37.3665162,194481.7535842,476677.4939939,49.0486345,12756.808566,5745.3735527,17947.3430201,48.4956963,72.8556582,2.5763438,338.0627799),(109,'humerus',245,2,109,1288.3377536,98.8997119,79.717628,1.8,98.0075741,79.1693071,0.4792582,25.6173984,38.135979,202172.9945872,503225.3224009,45.6571026,13195.5527427,7892.0189969,18421.1824105,49.6969666,74.6082156,2.574502,336.1240144),(110,'humerus',245,2,110,1302.1920981,98.541888,79.8846507,1.8,97.6397632,79.4587881,0.4500579,45.8843997,38.9509786,208777.8468375,526939.150848,41.0712248,13528.2647573,4550.083435,14355.0415611,51.1650531,76.3302554,2.5995934,425.0406644),(111,'humerus',245,2,111,1303.5543865,98.1074941,80.0468287,1.8,97.2423826,79.8605508,0.414748,41.0319576,39.6524743,215299.0165232,549365.7868201,35.2777004,13854.5146737,5247.1056518,13660.1264792,51.4143539,77.9619947,2.5911194,308.7728459),(112,'humerus',245,2,112,1309.1520795,97.691557,80.3078423,1.8,96.8109071,80.1240091,0.380283,40.7187625,39.6433685,221858.2192214,577790.7849656,30.061844,14574.7146715,5448.5501388,14710.808681,0.351562,0.4971837,2.3561945,0.9943675),(113,'humerus',245,2,113,1334.2479526,97.2567671,80.6834116,1.8,96.5075413,80.574065,0.348883,43.2505588,40.2502173,231574.8907625,624562.7291817,25.9867548,15517.0026843,5354.2635501,16288.7156298,52.511173,81.0531509,2.5788554,342.5667051),(114,'humerus',245,2,114,1358.4747597,96.8622037,81.3260726,1.8,96.1922345,81.2475126,0.3284461,29.4231802,41.025519,241378.2424866,667456.079874,23.5589088,16269.2903304,8203.676169,21541.5436956,53.9460443,82.7814674,2.6019015,430.9362019),(115,'humerus',245,2,115,1387.9701578,96.7574852,82.2976344,1.8,96.0679124,82.1767815,0.3232256,43.4259237,41.8883082,258671.8785451,722294.2928129,23.3379652,17243.3388734,5956.6235238,19534.8107741,56.656909,84.4810143,2.5847578,376.3398662),(116,'humerus',245,2,116,1433.6551128,96.9310076,83.661065,1.8,96.2085948,83.4530992,0.3289289,54.3102877,73.0627025,284971.5015699,795236.2525385,24.9331914,10884.2983477,5247.0998331,14258.9717053,59.7047479,86.4999708,2.5704994,602.341447),(117,'humerus',245,2,117,1488.6377334,97.2933112,85.4175463,1.8,96.7111558,85.2344821,0.3426708,40.6181711,45.1751566,324614.1152204,884510.993675,28.0108446,19579.5888604,7991.8446916,25471.8319917,0.351562,0.4971837,2.3561945,0.9943675),(118,'humerus',245,2,118,1538.40225,97.5198477,87.137274,1.8,97.1383461,86.9996907,0.358553,39.6015696,71.5232146,373938.8649913,971767.1550674,31.5743085,13586.7376913,9442.526352,18418.2896009,66.5517953,93.009247,2.4633098,560.6072836),(119,'humerus',245,2,119,1570.3340967,97.6801632,88.5941359,1.8,97.4897063,88.4598024,0.3605864,39.5157427,48.2089188,425347.3316164,1046502.4548626,32.580256,21707.6524619,10763.996905,29568.6010144,68.930561,96.0285666,2.4651364,611.0701785),(120,'humerus',245,2,120,1588.268265,97.6417432,89.8086004,1.8,97.7283707,89.6631879,0.3446042,54.2768724,68.7806329,474128.0678883,1114429.6120631,30.2102269,16202.6658631,8735.360888,22532.176357,70.7668929,97.923744,2.5296902,702.5434148),(121,'humerus',245,2,121,1625.4186651,97.497523,91.1871842,1.8,97.4440617,91.0867167,0.3077366,43.3074322,50.8143636,527256.5813323,1222879.1421159,24.8553133,24065.6195614,12174.736629,33962.0361951,73.851297,99.8739318,2.4734486,678.0547118),(122,'humerus',245,2,122,1636.9768611,98.0083364,92.5101782,1.8,97.9027076,92.2544525,0.2972097,44.9650732,52.8212997,564304.2902092,1273005.4740334,23.3987069,24100.2300493,12549.835894,34535.3526606,74.970475,101.3242914,2.4890703,705.320577),(123,'humerus',245,2,123,1741.9248978,97.7248164,94.5104028,1.8,97.0966072,94.4214891,0.2630246,47.3143062,54.2389872,649803.1647805,1329799.747872,19.62603,24517.4148292,13733.7566086,36486.4312002,79.9046482,102.8028846,2.4871481,543.6030972),(124,'humerus',245,2,124,1913.5537888,96.6969488,96.7888179,1.8,96.6748404,95.8332535,0.1943855,50.2129271,54.3706427,755084.8533671,1437368.5106151,11.8998148,26436.481866,15037.6585628,32986.9148068,83.0888098,104.1365574,2.5507811,687.1367809),(125,'humerus',245,2,125,1970.9829704,97.2180775,97.7760932,1.8,96.9157977,96.3742644,0.1790714,51.3261479,55.3150367,811009.2933392,1488080.9365292,10.4216691,26901.9244157,15801.0941008,34139.5567244,85.1781834,105.2163456,2.5656377,752.1033078),(126,'humerus',245,2,126,2031.052983,98.0970187,98.2864091,1.8,96.9957094,96.6499953,0.1761037,52.5922381,56.3352784,860628.3005354,1508723.742186,10.3899319,26781.1535881,16364.1695225,42056.1428653,86.1441331,105.8767939,2.5932007,748.8082638),(127,'humerus',245,2,127,2115.0623113,98.7635233,98.6031474,1.8,96.9681161,96.6712086,0.1592521,52.0170358,57.044623,906945.2194096,1518910.4658414,8.8647726,26626.7070447,17435.5421472,42523.0711791,85.9614963,106.360143,2.5921031,709.8926587),(128,'humerus',245,2,128,2176.8533398,98.9839542,98.6875041,1.8,96.9294887,96.5710787,0.1479812,52.1260969,57.1240949,931448.7709581,1520903.5319887,7.8871161,26624.5536773,17869.1447499,42673.9386738,86.5636424,106.6757525,2.6396157,715.6882571),(129,'humerus',245,2,129,2214.7140789,99.2408534,98.552713,1.8,97.081809,96.3902074,0.1409579,52.5490012,57.0894505,955420.1204306,1503933.1561219,7.2856299,26343.4512287,18181.5086533,35427.3667027,86.5754567,106.8037024,2.5791553,696.3066644),(130,'humerus',245,2,130,2221.2062687,99.4834162,98.2811294,1.8,97.3762247,96.3700757,0.1386219,51.6860009,56.8865148,958052.0652393,1471583.0597959,7.0683482,25868.7505247,18536.0068079,42640.0558432,0.351562,1.1117367,2.8198421,2.1946752),(131,'humerus',245,2,131,2220.0128573,99.7301583,97.6493891,1.8,97.5788453,96.09529,0.1221421,51.554331,56.295041,961778.6408764,1438124.5338137,5.4925535,25546.2028004,18655.632272,42542.4508733,0.351562,0.7861165,2.677945,1.4915512),(132,'humerus',245,2,132,2206.0767896,99.7214362,96.8067786,1.8,97.4969491,95.7161169,0.0993937,49.7424253,55.0212449,953983.6845681,1405619.0737998,3.6203986,25546.842435,19178.4714841,41874.7947034,84.5887089,106.3392241,2.6454121,711.4427528),(133,'humerus',245,2,133,2201.3884998,99.3667846,95.8627828,1.8,97.1927263,95.3489787,0.0160553,48.561367,53.0817666,939617.6249764,1384139.9536393,0.0945697,26075.6195789,19349.0769012,42335.4664209,83.5950705,105.4978928,2.682416,706.8328263),(134,'humerus',245,2,134,2185.4958725,99.1203836,95.0176495,1.8,96.8704222,95.0116884,-0.1330059,45.8089777,54.3307968,892370.7064487,1365369.5692602,6.4058662,25130.674472,19480.2580568,33626.1050121,0.351562,0.4971837,2.3561945,0.9943675),(135,'humerus',245,2,135,2068.8493773,99.6920097,94.7379716,1.8,97.0409451,95.0010698,-0.3188767,44.2568372,48.353863,761940.0284693,1293370.4834525,33.8885493,26748.0280142,17216.3235386,37931.5032456,2.1078943,6.8260993,2.1730837,21.0376882),(136,'humerus',245,2,136,1716.7498484,98.0112221,96.5505965,1.8,96.5388998,96.3326052,-0.3745096,42.9339914,46.9934186,551420.7066811,1075601.5560204,38.2896681,22888.3445628,12843.4531472,30935.4677254,2.047933,8.9837678,2.1045045,24.9298549),(137,'humerus',245,2,137,1078.2827286,91.7821376,101.6950706,1.8,91.9004763,99.7731851,-0.2016165,47.7097561,45.8682572,240384.8194698,638320.4136135,7.2067735,13916.3869065,5038.483511,16094.6079786,47.6762429,93.8005365,2.8838874,454.3038381),(138,'humerus',245,2,138,565.852092,78.8499602,106.4798578,1.8,83.0070896,105.4244257,-0.0131389,51.9065379,54.1507163,55147.0965476,203232.6005796,0.0162801,3753.0916376,1062.4306454,4190.4522379,39.5546994,54.442188,2.3516283,248.4515793),(139,'humerus',245,2,139,330.9002581,69.9562048,107.6430482,1.8,70.321899,107.2573567,0.4250678,19.5241865,26.6871177,20870.5149035,45507.3219985,9.3787833,1705.2168196,1068.9569535,2318.2807475,35.1842328,49.6437413,2.4867606,225.8370366),(140,'humerus',245,2,140,142.532745,63.9267991,107.7543222,1.8,66.7836254,107.6880262,0.6711598,18.4741703,20.6726485,4169.9246302,11101.9040241,9.1874927,537.0334639,225.7164766,645.3328892,0.9474448,5.976554,2.0607537,12.876808),(141,'humerus',245,2,141,15.3619891,62.3544017,110.828466,1.8,62.5959373,110.6221906,0.8479612,26.640342,51.9803502,67.0492178,190.8954352,1.4399301,3.6724538,2.5168302,4.4161454,8.5797498,14.1194933,1.9004207,37.7213597),(142,'humerus',245,2,142,0.0402997,132.6408139,128.7324639,1.8,133.241998,128.6013796,-0.2158872,0.0755186,16.2927001,0.000527,7.6458485,0.0003082,0.4692806,0.0069778,0.4693118,0,0,0,0),(143,'humerus',245,2,143,0.0153933,117.5970613,131.484188,1.8,117.597489,131.484188,0.2940027,0.0510627,0.1686479,0.0001985,0.0005942,0.0002154,0.0035235,0.0038871,0.0044988,0.351562,0.7861165,2.677945,1.4915512),(144,'humerus',245,2,144,0.0078277,143.437296,126.56232,1.8,143.437296,126.56232,0.7853982,0.00000000000001005,0.00000000000003015,0.0000806,0.0000806,0.0006523,2674436863.12437,8023310583.54674,5074387167.1049,0.351562,0.4971837,2.3561945,0.9943675),(145,'humerus',245,2,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(146,'humerus',245,2,146,1.6225138,83.5376591,114.4066628,1.8,83.5291781,114.4041342,-0.8985855,2.5701905,2.9451893,2.6569026,2.8432868,0.1655567,0.9654004,1.0337376,1.8669275,5.4690212,5.9868851,0.7022569,19.1342565),(147,'humerus',245,2,147,39.8828045,83.5804336,114.2669971,1.8,83.6024395,114.2548614,-0.6875067,8.2392838,8.3837426,553.4939451,565.1312726,2.6770182,67.4079939,67.1774342,133.2896168,16.523414,17.2408815,0.6842948,55.0581857),(148,'humerus',245,2,148,88.4898648,83.5911913,114.2457042,1.8,83.5600415,114.2643092,-1.0076402,10.9547832,10.9963751,2275.4738352,2312.7122103,10.5449839,210.3158719,207.7150943,415.6516791,21.796844,22.4339533,1.0088748,72.4449811),(149,'humerus',245,2,149,128.2269011,83.6131991,114.2370487,1.8,83.6034306,114.2490222,-0.9246756,12.5261666,12.7091662,4551.5198654,4609.4348878,13.623751,362.6858623,363.3609556,720.3223809,24.960902,25.8080991,0.9109479,83.0418106),(150,'humerus',245,2,150,300.2626472,96.7123826,113.7629793,1.8,98.6164523,113.0847496,-0.034171,18.7847931,48.0954327,14112.5196407,70018.0015512,0.0584114,1455.813944,751.2736269,1651.4897258,27.070274,27.648513,0.7224185,89.8317766),(151,'humerus',245,2,151,628.3591524,104.2629986,112.6137174,1.8,98.2541854,113.1012521,-0.0843486,15.9645844,54.7757293,31627.607666,133136.3252849,0.7433308,2430.5714772,1981.1106202,2896.1881293,29.1805484,57.3854298,0.1228352,184.2588439),(152,'humerus',245,2,152,631.7456784,104.2669909,112.738689,1.8,98.3611759,113.2970184,-0.0938593,16.8699763,50.4675924,31696.2808869,134140.2578365,0.9248467,2657.9484257,1878.8574621,3116.4938045,29.1805484,57.5241812,0.1410328,180.4519805),(153,'Syncerus-caffer-ulna-cleaned.tif',245,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(154,'Syncerus-caffer-ulna-cleaned.tif',245,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(155,'Syncerus-caffer-ulna-cleaned.tif',245,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(156,'Syncerus-caffer-ulna-cleaned.tif',245,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(157,'Syncerus-caffer-ulna-cleaned.tif',245,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(158,'Syncerus-caffer-ulna-cleaned.tif',245,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(159,'Syncerus-caffer-ulna-cleaned.tif',245,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(160,'Syncerus-caffer-ulna-cleaned.tif',245,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(161,'Syncerus-caffer-ulna-cleaned.tif',245,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(162,'Syncerus-caffer-ulna-cleaned.tif',245,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(163,'Syncerus-caffer-ulna-cleaned.tif',245,4,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(164,'Syncerus-caffer-ulna-cleaned.tif',245,4,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(165,'Syncerus-caffer-ulna-cleaned.tif',245,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(166,'Syncerus-caffer-ulna-cleaned.tif',245,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(167,'Syncerus-caffer-ulna-cleaned.tif',245,4,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(168,'Syncerus-caffer-ulna-cleaned.tif',245,4,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(169,'Syncerus-caffer-ulna-cleaned.tif',245,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(170,'Syncerus-caffer-ulna-cleaned.tif',245,4,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(171,'Syncerus-caffer-ulna-cleaned.tif',245,4,19,2.3093167,120.271694,47.0610156,1.8,120.2723515,47.0689106,1.2077911,2.0589359,3.2958702,2.2125305,5.2538744,0.3363576,1.5940781,1.074599,2.2647887,4.5312511,7.0925299,2.0344439,18.1438684),(172,'Syncerus-caffer-ulna-cleaned.tif',245,4,20,41.2019774,120.3967275,47.0079359,1.8,120.4861157,46.8503232,1.2352367,4.8542333,8.3236262,202.2589512,602.4751548,6.1223601,72.3813327,41.666508,96.670835,10.1757511,17.0810739,1.9513027,44.2885008),(173,'Syncerus-caffer-ulna-cleaned.tif',245,4,21,75.9682808,120.0251747,46.4515737,1.8,120.280901,46.0538778,1.1938106,7.0426625,10.7398129,903.4343754,2181.9103704,10.9456114,203.1609293,128.2802312,286.7097458,14.1028265,21.9613807,1.9513027,58.9628563),(174,'Syncerus-caffer-ulna-cleaned.tif',245,4,22,115.7957805,119.2666867,46.0696624,1.8,119.5392743,45.5175673,1.2322706,8.7102074,13.2126002,2076.1266949,5093.8721765,17.1708092,385.5313955,238.3555982,542.5830286,17.4258159,26.7957519,1.8978944,74.0125929),(175,'Syncerus-caffer-ulna-cleaned.tif',245,4,23,171.9479639,118.3319879,46.1287485,1.8,118.5890802,45.8455782,1.2883619,10.5788665,17.55845,4235.1234609,11618.848339,26.4321102,661.7240335,400.3381122,902.9245151,21.2309806,33.8603028,1.8417432,91.7810801),(176,'Syncerus-caffer-ulna-cleaned.tif',245,4,24,237.7567073,117.0720282,46.5454178,1.8,117.3274115,46.8466362,1.3174236,12.8153369,21.8493395,8180.9175707,23332.6211149,37.1361845,1067.8867946,638.3692918,1441.5193387,25.2804015,40.8441458,1.8750048,110.7667935),(177,'Syncerus-caffer-ulna-cleaned.tif',245,4,25,320.9678901,115.5014563,46.4477145,1.8,116.0030177,46.992545,1.3452764,14.6816411,25.5613349,15998.3422558,41984.8355719,50.8197644,1642.5134191,1089.6835142,2252.7737577,28.8989449,46.952596,1.956679,132.5356628),(178,'Syncerus-caffer-ulna-cleaned.tif',245,4,26,381.1476896,114.4336895,46.116537,1.8,115.1328565,47.1235674,1.3365428,17.5621176,29.2419188,23622.9285942,64306.4259218,60.1020166,2199.1178598,1345.1070743,2991.0800954,31.0785718,52.5976577,1.9689009,142.1290341),(179,'Syncerus-caffer-ulna-cleaned.tif',245,4,27,431.2510761,113.7131201,46.2626828,1.8,114.5285438,47.5384823,1.3251756,17.8386958,32.6036218,30845.3213683,91733.5647885,67.6254834,2813.6004423,1729.1242405,3754.8139224,32.5281865,57.6484853,1.9323269,156.1814377),(180,'Syncerus-caffer-ulna-cleaned.tif',245,4,28,470.0724962,113.4128154,47.0246013,1.8,114.1640104,48.0324796,1.3358543,18.350103,33.3404805,37094.0694112,115962.3674566,74.0999095,3478.1252635,2021.4638301,4576.8071579,33.1464422,59.8982726,1.902116,159.4765989),(181,'Syncerus-caffer-ulna-cleaned.tif',245,4,29,492.9652559,113.3867981,48.4203434,1.8,113.8216205,48.6764547,1.3644324,23.2254991,33.0366007,42865.8798024,130432.3722783,78.7113541,3948.1172271,1845.6386893,5228.2372935,34.8906337,61.4999459,1.8622531,166.0402436),(182,'Syncerus-caffer-ulna-cleaned.tif',245,4,30,514.1217349,113.1780342,49.5139622,1.8,113.4016806,49.2272581,1.4011757,25.0025597,32.6892586,47510.1150233,143836.8970193,83.2451952,4400.1272359,1900.2100385,5816.36171,35.7968839,62.6772117,1.849096,170.0406257),(183,'Syncerus-caffer-ulna-cleaned.tif',245,4,31,534.7621704,112.7891177,50.1735191,1.8,112.9068522,49.6330367,1.4423834,19.8555606,32.9627811,50776.2836681,159568.6757507,87.6653948,4840.8741697,2557.2828007,6351.5029658,36.480948,63.6733499,1.8520285,178.4811761),(184,'Syncerus-caffer-ulna-cleaned.tif',245,4,32,561.1006127,112.504008,50.8131355,1.8,112.4816212,49.9879552,1.4761745,19.9138012,33.5829348,53882.4736263,177897.0544955,92.6819824,5297.2456304,2705.7854571,6842.6682219,36.9426094,65.5153731,1.7939664,183.1867791),(185,'Syncerus-caffer-ulna-cleaned.tif',245,4,33,586.0018607,112.2024755,51.6233734,1.8,112.0939246,50.6192343,1.513128,20.1185732,34.7625556,56100.8977588,198232.1317788,97.342532,5702.4614112,2788.5127403,7154.7076603,37.917251,67.4487043,1.7668744,199.7191763),(186,'Syncerus-caffer-ulna-cleaned.tif',245,4,34,597.2713833,111.8509411,52.7432337,1.8,111.7461883,51.4672515,1.5370364,20.0244302,35.7970933,54543.1307051,217468.4538735,99.4318188,6075.0310613,2723.8293537,7532.5150374,37.8342164,69.6723147,1.760539,193.3754247),(187,'Syncerus-caffer-ulna-cleaned.tif',245,4,35,603.2560326,111.5103698,54.2076631,1.8,111.3857811,52.4661864,1.5426401,20.2629991,38.4235515,50721.1678085,238193.7847317,100.462986,6199.1610758,2503.1421828,7507.6604129,37.4021269,72.1849781,1.7411049,218.1928845),(188,'Syncerus-caffer-ulna-cleaned.tif',245,4,36,617.3523464,111.1181718,55.7823773,1.8,110.9140458,53.804489,1.5441352,19.8262732,39.2894677,48452.0200211,262347.3069967,102.8189378,6677.2934917,2443.8289278,7606.5607123,35.4908298,74.8658134,1.73495,234.1300074),(189,'Syncerus-caffer-ulna-cleaned.tif',245,4,37,635.5416684,110.8014533,57.3065612,1.8,110.7027436,55.1072579,1.5390081,18.7287774,42.8069269,45222.8565465,291834.9362595,105.8166124,6817.4699147,2414.6187262,7872.9468627,34.1294511,78.5162665,1.6922881,225.7538622),(190,'Syncerus-caffer-ulna-cleaned.tif',245,4,38,642.9236919,110.6644243,59.168027,1.8,110.6843185,56.7207673,1.5342223,18.0228821,41.5931456,40952.356675,311145.8184116,107.0106769,7480.69938,2272.2423844,8429.8657464,32.9776748,81.8452336,1.6539376,266.8382846),(191,'Syncerus-caffer-ulna-cleaned.tif',245,4,39,649.4368286,110.5664863,61.2014652,1.8,110.6817389,58.4514053,1.5345643,16.0401705,44.9581278,36704.269327,328240.436678,108.0974416,7301.0254891,2288.2717647,8115.0295718,30.0142465,83.2789226,1.6634267,269.4282249),(192,'Syncerus-caffer-ulna-cleaned.tif',245,4,40,661.4102958,110.5784355,62.7682856,1.8,110.6938268,59.9404861,1.5392757,15.4411591,44.7425037,32909.7845578,362284.1647876,110.1255615,8097.0919107,2131.3027277,8811.412433,28.6223653,85.7855718,1.6289318,276.3217094),(193,'Syncerus-caffer-ulna-cleaned.tif',245,4,41,672.7017817,110.7267013,64.5375585,1.8,110.9350937,62.1825727,1.5441863,19.7267249,71.7509571,28938.6626189,407529.5694197,112.037593,5679.7788653,1466.9775551,6069.5688253,27.1271584,89.8331251,1.6212585,288.5882901),(194,'Syncerus-caffer-ulna-cleaned.tif',245,4,42,684.1063193,110.753523,66.998967,1.8,110.9912703,64.9137325,1.5463939,13.9701517,48.1753388,26346.6492935,448644.2869117,113.9498383,9312.7375565,1885.9243486,9844.0372647,25.2949559,93.0242793,1.6244035,294.2001433),(195,'Syncerus-caffer-ulna-cleaned.tif',245,4,43,705.5399835,110.7830048,70.4012019,1.8,111.0723058,68.5091724,1.5490537,14.3490191,49.2960623,24834.3896438,494990.0545584,117.5344162,10041.1682379,1730.7377928,10528.1416745,24.9218812,96.7239045,1.6364296,300.2784603),(196,'Syncerus-caffer-ulna-cleaned.tif',245,4,44,739.2635603,110.7430675,75.2604668,1.8,111.0518056,73.5460212,1.5536561,14.2323801,55.6855591,24342.073199,557426.0691744,123.1743995,10010.2446385,1710.3304542,10391.9503749,1.8125005,6.4081568,1.7126934,14.5644088),(197,'Syncerus-caffer-ulna-cleaned.tif',245,4,45,817.2953931,110.7046019,81.3301927,1.8,110.9749702,80.3782071,1.5534521,14.5731766,55.0902726,28511.4673696,675830.4083467,136.1749262,12267.6903972,1956.4346262,12777.5888376,25.3750063,103.304576,1.7027681,304.2977062),(198,'Syncerus-caffer-ulna-cleaned.tif',245,4,46,876.9003522,110.3240222,86.814992,1.8,110.5412375,84.5301948,1.5629498,16.3072803,60.0911111,34300.4906367,701206.7457985,146.1410608,11669.0594217,2103.3851178,12237.807819,28.0274879,104.4116682,1.6315909,315.9690125),(199,'Syncerus-caffer-ulna-cleaned.tif',245,4,47,833.9097681,110.1979503,88.4514162,1.8,110.459591,86.9362321,1.5580528,15.0058248,73.0288111,34217.5795702,552528.0144246,138.9623919,7565.890862,2280.2864877,7989.348636,28.8615574,95.6190622,1.5565793,303.1715628),(200,'Syncerus-caffer-ulna-cleaned.tif',245,4,48,768.4900173,110.2114832,87.1209964,1.8,110.4374135,86.3408003,1.5478382,15.730437,72.1303889,31986.3399237,435267.7164721,128.0141727,6034.4568104,2033.4044033,6474.1423788,28.6059163,86.5765463,1.5969684,296.7822698),(201,'Syncerus-caffer-ulna-cleaned.tif',245,4,49,713.279268,110.3619249,86.1339009,1.8,110.7433689,85.3830919,1.533884,14.7448801,70.1021947,29765.6217266,351873.6071675,118.7179755,5019.4378204,2018.7089656,5420.6530714,0.4531251,0.6408157,2.3561945,1.2816314),(202,'Syncerus-caffer-ulna-cleaned.tif',245,4,50,673.6007203,110.3419005,85.6518112,1.8,110.724649,85.1758165,1.5222705,15.1631922,70.5607983,28179.4078198,297708.5472612,112.0026328,4219.1777103,1858.40867,4608.9482125,1.3593753,6.045443,1.3439975,18.1438684),(203,'Syncerus-caffer-ulna-cleaned.tif',245,4,51,641.1064645,110.2215197,85.4647441,1.8,110.6834249,85.1202268,1.5126202,14.9508278,70.7194737,27064.0204357,254667.360626,106.489852,3601.0924206,1810.2021337,3968.192468,0.8110345,1.6337658,0.9827937,3.4695129),(204,'Syncerus-caffer-ulna-cleaned.tif',245,4,52,614.2185671,110.0884342,85.2643173,1.8,110.6400876,85.2373345,1.5031583,50.2360168,71.4979786,26161.7771718,221256.3433764,101.9021433,3094.5818004,520.7772999,2889.7152165,28.145658,67.7721283,1.6578243,271.1496426),(205,'Syncerus-caffer-ulna-cleaned.tif',245,4,53,594.4312772,109.9034859,85.2073554,1.8,110.5661466,85.5159428,1.4927639,14.9508304,70.6806266,25859.3588837,193476.5849424,98.469848,2737.3354519,1729.6269333,3078.8054371,0.8950928,3.2988006,1.849096,7.0945139),(206,'Syncerus-caffer-ulna-cleaned.tif',245,4,54,576.2764867,109.6943881,85.1997834,1.8,110.4285983,85.775279,1.4824271,15.475088,71.2100148,26124.8782896,169996.6861397,95.2979966,2387.2581209,1688.189319,2738.4311916,0.4531251,2.3104938,1.7681919,4.9066323),(207,'Syncerus-caffer-ulna-cleaned.tif',245,4,55,564.5127594,109.5280091,85.395088,1.8,110.2925632,86.5811569,1.4642128,15.9858649,71.5897739,26895.9753837,152036.3068202,93.0206854,2123.7154203,1682.4848402,2475.0604673,28.2166175,60.4306515,1.7593686,238.551312),(208,'Syncerus-caffer-ulna-cleaned.tif',245,4,56,551.2490588,109.4032012,85.7229392,1.8,110.1730394,87.3506634,1.4351389,16.2793513,71.5748376,28399.104241,136392.7669959,90.1944232,1905.5965988,1744.4862327,2263.4677574,30.1619915,59.0107394,1.7561443,263.1944199),(209,'Syncerus-caffer-ulna-cleaned.tif',245,4,57,542.0788019,109.4309817,86.3639182,1.8,110.2177959,87.8166941,1.384715,17.8473186,71.9229471,32090.3560334,124151.8712818,87.2540478,1726.1788656,1798.049145,2163.827025,33.6567023,57.5111992,1.7450121,278.2363428),(210,'Syncerus-caffer-ulna-cleaned.tif',245,4,58,545.3697462,109.3010592,87.364118,1.8,109.9664987,88.7267958,1.3362132,21.4502406,28.0171573,37936.1963694,117765.5897117,85.9841552,4203.3382778,1768.5674083,5153.9755701,38.3671795,56.4299974,1.7729163,272.4878655),(211,'Syncerus-caffer-ulna-cleaned.tif',245,4,59,552.7970028,108.9681648,88.4472042,1.8,109.4901905,89.6170442,1.2924877,26.7628301,28.0510936,45986.765926,113031.0905473,85.1789756,4029.4717936,1718.3072848,5095.6955507,44.3863038,56.0484811,1.815775,265.4577569),(212,'Syncerus-caffer-ulna-cleaned.tif',245,4,60,576.7749223,108.2399064,89.9027395,1.8,108.3354336,91.2537446,1.2871101,29.8172307,27.8781264,59154.7912307,111074.7345612,88.5982015,3984.2969667,1983.9129843,5251.4691993,48.2494228,56.5735369,2.1854593,296.9943493),(213,'Syncerus-caffer-ulna-cleaned.tif',245,4,61,643.2617272,106.9045264,92.3723081,1.8,107.0287856,93.6650873,1.5041646,27.5515762,29.2601659,82336.0957166,118512.7292158,106.7350012,4050.3095465,2988.4350414,5927.8228296,49.2060411,56.9136687,2.2206668,279.7111898),(214,'Syncerus-caffer-ulna-cleaned.tif',245,4,62,636.9740719,106.6433395,92.9464698,1.8,106.5713204,93.9171207,1.4717471,29.0468524,28.43342,85219.5824734,109441.5902999,105.124215,3849.0477124,2933.8663397,5554.9976546,50.34878,58.5093142,3.0095529,273.5873314),(215,'Syncerus-caffer-ulna-cleaned.tif',245,4,63,611.1354962,105.9201311,92.9875625,1.8,105.8927481,93.992259,-1.4245726,32.8902886,27.4055761,79344.4622869,94870.9373614,99.6935729,3461.7384818,2412.3978725,5019.2879185,48.7453527,57.4969169,3.0231027,279.8666778),(216,'Syncerus-caffer-ulna-cleaned.tif',245,4,64,573.4126752,105.1602627,93.0130544,1.8,104.6608107,93.6833531,-1.16211,38.1143596,25.4756675,69106.6745467,84715.3465696,80.475592,3325.3435435,1813.1401182,4034.8266442,0.4531251,1.0132186,2.0344439,2.1878816),(217,'Syncerus-caffer-ulna-cleaned.tif',245,4,65,554.6631343,105.0418082,93.1938331,1.8,105.172408,93.5510683,-1.1703943,38.4633165,24.6752948,62095.0456548,74602.3071454,78.3983826,3023.360319,1614.3965553,3547.406935,43.1160705,60.1479852,3.0359271,295.2007127),(218,'Syncerus-caffer-ulna-cleaned.tif',245,4,66,495.8681409,105.8264492,92.4394232,1.8,106.5784045,92.9070431,1.2168589,31.1383823,28.9878574,50399.8104409,59893.1571223,72.7168078,2066.1463946,1618.5751087,2639.9693428,40.5266378,65.1823271,2.9810154,309.7462577),(219,'Syncerus-caffer-ulna-cleaned.tif',245,4,67,438.7433515,106.3235958,91.7598291,1.8,107.3496237,92.2630627,1.0685259,26.4144974,28.9077505,34984.2490628,51594.9195263,56.1765431,1784.8126765,1324.4336423,2350.4395944,0.4531251,0.6408157,2.3561945,1.2816314),(220,'Syncerus-caffer-ulna-cleaned.tif',245,4,68,404.4740528,106.2375961,91.5826821,1.8,107.0786437,91.999716,1.1265025,25.4128004,24.3697114,27601.9170273,43934.6084792,54.9582134,1802.8366319,1086.142284,2188.0828284,36.707091,52.5253906,2.9594243,235.8891528),(221,'Syncerus-caffer-ulna-cleaned.tif',245,4,69,383.0408863,106.1345535,91.799132,1.8,106.8589348,92.2647634,1.1492051,25.1774373,24.0842049,23051.1245873,39722.6255187,53.1497828,1649.3226861,915.5468977,1871.2689034,0.4531251,0.6408157,2.3561945,1.2816314),(222,'Syncerus-caffer-ulna-cleaned.tif',245,4,70,367.021884,105.9522893,92.1685128,1.8,106.5670839,92.4998061,1.1703189,27.364627,23.7340084,20141.4246628,36525.9517638,51.8730833,1538.9710471,736.0387054,1581.123054,34.9855676,48.272182,2.9718144,256.2397667),(223,'Syncerus-caffer-ulna-cleaned.tif',245,4,71,351.6655752,105.8995666,92.5330192,1.8,107.1303929,92.6866316,1.1664114,27.3615071,23.928034,16950.333207,34169.32678,49.5376326,1428.003937,619.495599,1406.3816803,32.0519002,40.2669932,2.459822,184.9270606),(224,'Syncerus-caffer-ulna-cleaned.tif',245,4,72,344.0468709,105.9658257,93.093678,1.8,107.9370933,93.5353108,1.1160142,29.4029834,85.043649,15671.6690698,33749.2291776,46.2768763,396.8459674,532.9958813,580.9249755,30.3973473,45.2331449,2.4057992,225.8481815),(225,'Syncerus-caffer-ulna-cleaned.tif',245,4,73,336.6112147,105.9606724,93.6877912,1.8,107.9206048,94.1332501,1.0952368,27.1263947,91.5774108,14252.4104483,32678.9763383,44.3421451,356.8453843,525.4074709,510.1146585,30.5209193,45.6758206,2.5040439,270.777498),(226,'Syncerus-caffer-ulna-cleaned.tif',245,4,74,326.4429044,105.7387515,94.1707432,1.8,107.431845,94.6146026,1.1054557,26.5180269,30.6432287,12575.8972315,30568.4323534,43.4519357,997.5591225,474.2395536,1064.6551358,0.4531251,1.0132186,2.0344439,2.1878816),(227,'Syncerus-caffer-ulna-cleaned.tif',245,4,75,318.5729602,105.6174695,94.7491738,1.8,107.303886,95.2882356,1.10594,21.637487,25.5005292,11393.454637,29267.6549153,42.4250081,1147.7273566,526.5608997,1215.8203773,28.964299,43.87833,2.5249446,224.5288224),(228,'Syncerus-caffer-ulna-cleaned.tif',245,4,76,311.1221226,105.4968121,95.2645996,1.8,107.2200398,95.7638519,1.0983521,20.1892309,80.1374727,10333.4298805,28301.9135263,41.1156524,353.1670337,511.8288027,468.2115258,28.0266243,43.6178526,2.5334199,200.4432611),(229,'Syncerus-caffer-ulna-cleaned.tif',245,4,77,310.5548729,105.2630593,95.9839922,1.8,106.0130844,96.9470986,1.1062084,25.2879224,20.6949696,10432.6648692,27714.0109382,41.3683538,1339.1665475,412.5552391,1395.5612369,32.5861369,42.8341065,3.0356083,285.0576084),(230,'Syncerus-caffer-ulna-cleaned.tif',245,4,78,306.3656744,105.1709026,96.5870912,1.8,106.0108947,97.463068,1.1047761,94.9151306,36.537835,9756.0797329,26979.3885044,40.7516666,738.3959262,102.7874026,361.1964888,31.8647937,39.9161819,0.0454233,274.1826057),(231,'Syncerus-caffer-ulna-cleaned.tif',245,4,79,301.0152223,105.0906899,97.1771869,1.8,106.1649032,98.0264489,1.0930627,21.9824946,20.0988133,8787.6049539,26391.2489604,39.5641164,1313.0749822,399.7546732,1285.5345179,31.0224734,41.0322242,3.0309354,229.0600735),(232,'Syncerus-caffer-ulna-cleaned.tif',245,4,80,293.0022992,104.8660025,97.6027049,1.8,105.9149878,98.2706221,1.0935417,24.1015552,94.1919493,8157.252669,24974.1544578,38.5300285,265.1410726,338.4533733,350.4394426,25.6073141,39.7202351,2.534605,239.7151831),(233,'Syncerus-caffer-ulna-cleaned.tif',245,4,81,286.0207164,104.6667508,98.021143,1.8,105.8059223,98.7346028,1.1019523,21.0072014,18.7923513,7676.0253158,22667.9239579,37.937155,1206.2313878,365.3997104,1123.5526762,29.8202028,39.0108881,3.0951145,253.3922055),(234,'Syncerus-caffer-ulna-cleaned.tif',245,4,82,276.3897908,104.369097,98.4080056,1.8,105.2467236,98.9521251,1.1146395,18.9284133,92.7677723,6926.4229213,20975.5287735,37.1264607,226.1079278,365.9272863,300.6673056,29.4381345,38.5822131,0.0587558,235.7792063),(235,'Syncerus-caffer-ulna-cleaned.tif',245,4,83,267.9295759,104.0056593,98.7591187,1.8,104.937263,99.8084414,1.1313753,19.2057361,19.9554722,6642.5754206,18650.5242235,36.5733529,934.6070109,345.864141,1086.3727983,29.6910302,36.8399356,0.0862056,211.4926156),(236,'Syncerus-caffer-ulna-cleaned.tif',245,4,84,253.2835581,103.55455,98.9442611,1.8,104.4709746,99.9889979,1.1685376,18.0607558,19.3598577,5902.6792247,16048.2678783,35.743776,828.9455507,326.8234884,922.4307885,28.9444512,36.5236831,2.2242227,168.5501513),(237,'Syncerus-caffer-ulna-cleaned.tif',245,4,85,240.3591372,103.0196958,99.119696,1.8,103.6688775,99.9882137,1.2482842,18.428492,18.4094523,5055.879934,13403.6076595,36.0355462,728.0829113,274.3512567,789.2670367,27.726036,33.4331418,2.1437625,163.2225966),(238,'Syncerus-caffer-ulna-cleaned.tif',245,4,86,227.6036406,102.5620301,99.3224674,1.8,103.050012,100.070341,1.3212217,21.4807921,16.6473314,4383.8020372,11308.3012819,35.6197826,679.2861282,204.0800924,652.6138538,26.7343817,29.5053697,0.1853479,166.1423766),(239,'Syncerus-caffer-ulna-cleaned.tif',245,4,87,216.4268242,102.230749,99.6144362,1.8,102.5381221,100.2958421,1.3602637,21.6835058,14.6255082,3779.8082585,9932.2966859,34.495804,679.1077991,174.3172107,551.9740611,23.8491867,28.0279036,0.9693416,159.1389455),(240,'Syncerus-caffer-ulna-cleaned.tif',245,4,88,208.3091243,101.9940971,99.9820045,1.8,102.3248659,100.5878067,1.3881259,20.4476253,13.5644416,3416.9670369,8845.2196077,33.5725231,652.0887376,167.1082574,524.7488992,22.6137332,26.6574702,1.0158006,152.4653541),(241,'Syncerus-caffer-ulna-cleaned.tif',245,4,89,201.0270866,101.8553263,100.4039932,1.8,102.1902672,101.0499492,1.4054146,20.8464658,13.1310223,3347.2494754,7886.6462831,32.5964532,600.6117518,160.56676,480.7020988,0.4531251,1.0132186,2.0344439,2.1878816),(242,'Syncerus-caffer-ulna-cleaned.tif',245,4,90,195.1483961,101.717469,100.8875195,1.8,102.0530081,101.5019691,1.4068317,18.1754325,13.7322298,3118.7658194,7225.1375262,31.6581325,526.1445234,171.5923853,454.0817491,24.1393374,28.1083702,0.3625442,165.1717211),(243,'Syncerus-caffer-ulna-cleaned.tif',245,4,91,190.3243781,101.6409605,101.4502345,1.8,102.0590095,101.9967109,1.3935247,19.4572144,12.4979265,3007.0566786,6746.2254159,30.7342968,539.7875719,154.547132,432.867529,0.8610454,2.0264371,2.0344439,4.3757632),(244,'Syncerus-caffer-ulna-cleaned.tif',245,4,92,187.7577241,101.5861416,102.0885826,1.8,102.0307795,102.56823,1.3747505,18.3531759,12.8026164,2831.6006292,6403.4016738,30.1055717,500.1635173,154.2839586,423.016079,23.1093808,28.0095835,0.1624891,148.4005668),(245,'Syncerus-caffer-ulna-cleaned.tif',245,4,93,184.6113143,101.5413391,102.7557204,1.8,101.9185263,103.231987,1.3506284,18.2521031,13.5343854,2692.5774731,6180.2687445,29.3010237,456.6346044,147.5214912,400.8294066,23.3671686,26.5957808,0.2408465,140.3998028),(246,'Syncerus-caffer-ulna-cleaned.tif',245,4,94,182.4411813,101.577944,103.4825362,1.8,102.2091433,103.8727163,1.3047037,16.106486,12.3852253,2576.4834106,6095.6662187,28.3042341,492.1724145,159.9655822,441.3018174,22.6562557,27.6406319,0.1813198,140.8395891),(247,'Syncerus-caffer-ulna-cleaned.tif',245,4,95,187.2991086,101.6928931,104.6309006,1.8,102.13119,105.4708899,1.267845,17.2653984,14.1460152,2459.084761,7038.7719341,28.4380658,497.5798358,142.4284983,445.4102323,23.5059666,27.6554845,1.8873656,157.3908502),(248,'Syncerus-caffer-ulna-cleaned.tif',245,4,96,194.4012093,101.9352053,105.9113108,1.8,102.5407746,106.5534493,1.2254399,16.6228238,13.4729596,2458.8955645,8308.8666217,28.6870097,616.7068593,147.922856,534.1353024,23.088461,28.1521641,2.1498706,161.7477495),(249,'Syncerus-caffer-ulna-cleaned.tif',245,4,97,194.3799927,102.1168136,106.6936878,1.8,103.1928656,107.3906518,1.1802267,17.8959746,13.614454,2709.1928944,8366.0761242,27.7009603,614.4995697,151.3856027,544.4471527,24.2156777,31.3476132,3.0692553,163.4691673),(250,'Syncerus-caffer-ulna-cleaned.tif',245,4,98,193.4195195,102.0087892,107.4896523,1.8,103.1128135,107.9549502,1.2211759,17.3160542,13.8546531,2646.1862117,8378.1249552,28.4541225,604.7156077,152.8169285,543.7084463,0.4531251,0.6408157,2.3561945,1.2816314),(251,'Syncerus-caffer-ulna-cleaned.tif',245,4,99,192.2639279,102.0835052,108.1943005,1.8,103.6391025,108.6243381,1.1654673,16.6733015,13.8788164,2811.0396242,8407.747516,27.061494,605.7971577,168.5952609,571.5393374,22.9297577,30.413439,3.0819619,132.3990387),(252,'Syncerus-caffer-ulna-cleaned.tif',245,4,100,190.2378939,101.6663678,108.907489,1.8,102.8616274,109.1038433,1.2778154,17.4933909,13.9572554,2756.9709767,8094.0315727,29.0617003,579.9157031,157.6007188,552.8672507,0.4531251,0.6408157,2.3561945,1.2816314),(253,'Syncerus-caffer-ulna-cleaned.tif',245,4,101,183.6607962,101.4912995,109.2998259,1.8,102.7361172,109.3943581,1.2787647,18.9112286,13.717967,2610.6100506,7511.197157,28.072996,547.5444829,138.0455026,493.4015933,23.0693645,29.1835088,2.691833,129.6991518),(254,'Syncerus-caffer-ulna-cleaned.tif',245,4,102,178.9456614,101.4761535,109.7180417,1.8,102.9645353,109.8391925,1.236109,16.6970827,13.652709,2560.2658479,7179.5184386,26.6063839,525.8676834,153.3361187,518.3273756,22.7009125,29.3518766,0.1549967,150.0575793),(255,'Syncerus-caffer-ulna-cleaned.tif',245,4,103,172.2617961,101.2142423,110.072295,1.8,102.3568391,110.2548944,1.2629968,17.436985,13.4993457,2304.2554449,6673.6965733,26.0750911,494.3718564,132.147584,458.4853288,22.7918539,26.8263844,2.4879568,134.0560512),(256,'Syncerus-caffer-ulna-cleaned.tif',245,4,104,170.9915972,101.0455835,110.6915726,1.8,102.0654433,110.9645147,1.2951406,18.6045395,13.3189711,2226.0731163,6742.5375049,26.3873986,506.2356139,119.6521479,447.24601,23.1182012,26.1127476,2.4668517,160.9514459),(257,'Syncerus-caffer-ulna-cleaned.tif',245,4,105,166.1542022,101.1663132,111.0324904,1.8,102.6123336,111.3513197,1.2435419,16.0358379,13.2337227,2307.7147539,6489.0996536,24.831012,490.3457494,143.909833,481.2281902,22.4285488,27.1875068,2.4980915,126.6961028),(258,'Syncerus-caffer-ulna-cleaned.tif',245,4,106,159.8997096,101.0841778,111.3223695,1.8,102.4128274,111.5662692,1.2327467,16.1137973,13.0458965,2128.0088033,6087.9570604,23.7187167,466.6568587,132.0612862,448.6351326,22.4408133,28.1266259,3.0932433,137.1046416),(259,'Syncerus-caffer-ulna-cleaned.tif',245,4,107,153.9944516,101.0505018,111.5959335,1.8,102.5051249,111.7655893,1.2078592,16.0208685,13.0053814,2021.9235388,5705.3119889,22.4308238,438.6885569,126.2056136,422.1199627,21.5217493,27.6999944,3.0761126,123.7119175),(260,'Syncerus-caffer-ulna-cleaned.tif',245,4,108,141.2501544,100.8519348,111.4279865,1.8,102.3586088,111.5623675,1.1814425,15.901307,12.3357528,1705.5374647,4774.9189148,20.1495918,387.0796522,107.2576904,349.791249,20.9544633,27.2478565,3.0750245,136.6648553),(261,'Syncerus-caffer-ulna-cleaned.tif',245,4,109,135.5225314,100.8381197,111.6766466,1.8,102.4690022,111.8735139,1.1399631,14.6303632,12.0977623,1578.198055,4591.4027887,18.6476028,379.5249637,107.8714204,337.2339018,20.6948873,27.6851657,2.7732437,138.0564332),(262,'Syncerus-caffer-ulna-cleaned.tif',245,4,110,129.2884466,100.7012245,111.8929203,1.8,102.1700282,112.0720979,1.1427802,14.8755619,11.865171,1397.1091211,4293.4844894,17.8357636,361.8560996,93.9197544,309.5348636,20.0790928,26.9790251,2.6328628,120.0225114),(263,'Syncerus-caffer-ulna-cleaned.tif',245,4,111,123.4279862,100.4093999,112.0932918,1.8,101.4237602,112.481181,1.1844287,16.0922974,11.7775864,1231.2047417,3950.5277829,17.650242,335.4276196,76.5089477,288.8216903,20.5061018,26.0497683,2.4424001,124.443816),(264,'Syncerus-caffer-ulna-cleaned.tif',245,4,112,120.1789153,100.3861615,112.3309866,1.8,101.4141927,112.8188547,1.1453025,14.5837586,12.4502081,1135.1841819,3876.7048905,16.6171469,311.3767133,77.8389313,268.0025889,20.3026657,27.9178027,2.5175696,146.0116559),(265,'Syncerus-caffer-ulna-cleaned.tif',245,4,113,115.5567355,100.4508964,112.4876006,1.8,101.9223023,113.0488889,1.1059655,14.5519685,12.9477145,1174.4175962,3669.2559707,15.3893178,283.3902439,80.7050672,257.7150346,19.8864893,27.9178027,2.5175696,139.9600164),(266,'Syncerus-caffer-ulna-cleaned.tif',245,4,114,111.0460519,100.3545732,112.6226479,1.8,101.855776,113.1568359,1.0899001,14.5094589,13.0785764,1106.5925216,3463.8632681,14.547502,264.8501756,76.266974,242.3720621,19.8153857,27.7740191,2.5535901,122.365881),(267,'Syncerus-caffer-ulna-cleaned.tif',245,4,115,108.8114601,100.3990337,112.9139075,1.8,102.2016722,113.4987784,1.035049,14.4941503,14.5747827,1126.8241866,3487.2572431,13.4093131,239.2664992,77.7433765,232.5616852,19.3992092,28.9184717,2.5231647,137.2601296),(268,'Syncerus-caffer-ulna-cleaned.tif',245,4,116,105.2941013,100.2903158,113.0922904,1.8,102.109215,113.6221088,1.0290606,14.2114445,14.3230179,1041.4958348,3326.3773542,12.8832937,232.2399776,73.2857126,219.4629019,19.2466233,28.7796879,2.5579568,124.443816),(269,'Syncerus-caffer-ulna-cleaned.tif',245,4,117,101.5551188,100.1133832,113.2009579,1.8,102.0279309,113.6759118,1.0336209,14.4037837,14.4931384,980.058777,3164.8529019,12.4938448,218.3690519,68.0417587,206.7368752,19.0312548,28.7796879,2.5579568,137.4611589),(270,'Syncerus-caffer-ulna-cleaned.tif',245,4,118,97.2284787,99.891139,113.2422263,1.8,101.8224191,113.7868503,1.0402185,14.7080539,14.4802899,905.0005508,2957.6990482,12.0552257,204.2568949,61.5309516,190.6921005,18.8763773,28.9149215,2.5796711,139.4935525),(271,'Syncerus-caffer-ulna-cleaned.tif',245,4,119,90.7247372,99.6317094,113.1162451,1.8,101.3309422,113.6520984,1.0536577,15.0571217,14.3064843,682.7687391,2691.3321065,11.4248693,188.1197394,45.3452361,164.2899411,17.0393124,28.5324936,2.5712094,131.913711),(272,'Syncerus-caffer-ulna-cleaned.tif',245,4,120,84.5425429,99.2874586,112.8908108,1.8,100.856816,113.486748,1.0735102,15.1622604,14.3916463,563.0859092,2360.9803791,10.8838776,164.0521399,37.1373327,142.7453474,16.352665,28.6581485,2.536048,123.207726),(273,'Syncerus-caffer-ulna-cleaned.tif',245,4,121,77.7555187,99.1182763,112.4744607,1.8,100.9988115,113.0611607,1.0466767,14.4635181,15.4419704,549.9359533,2057.1058185,9.7135926,133.2152421,38.0222811,124.125211,16.9249116,29.1588739,2.5665204,128.1976273),(274,'Syncerus-caffer-ulna-cleaned.tif',245,4,122,77.1670523,98.9503358,112.6816904,1.8,100.7056886,113.2768018,1.0744443,15.1221441,14.7227142,525.1618311,2087.9454319,9.9444361,141.8179698,34.7280007,124.5619073,16.0883505,28.1521641,2.5625184,119.051856),(275,'Syncerus-caffer-ulna-cleaned.tif',245,4,123,75.2041082,98.8169619,112.691573,1.8,100.7495369,113.3823526,1.0475032,14.8454419,15.3927184,548.1088632,2066.8276023,9.4038304,134.2730728,36.9210205,123.18023,16.8905414,29.5401433,2.5748634,129.6158828),(276,'Syncerus-caffer-ulna-cleaned.tif',245,4,124,71.3368925,98.5805914,112.484453,1.8,100.521932,113.1889085,1.0366696,15.8621279,15.8487922,495.5956503,1925.1339893,8.8080591,121.468814,31.2439576,112.5167637,16.9043434,29.6857475,2.5959376,130.0368053),(277,'Syncerus-caffer-ulna-cleaned.tif',245,4,125,69.2442221,98.3513027,112.3476381,1.8,100.3270117,113.027294,1.0277341,15.2352675,16.2137824,453.8440379,1885.6433182,8.4588633,116.298793,29.789043,107.4461359,15.7789565,29.9234164,2.5829933,125.5055541),(278,'Syncerus-caffer-ulna-cleaned.tif',245,4,126,65.614247,98.1260737,112.0300579,1.8,100.1063138,112.7594808,1.0196898,14.8417608,15.0577711,380.9336122,1796.8892457,7.9372609,119.333016,25.6663355,105.6192389,15.210446,27.9067688,2.5761088,105.4392387),(279,'Syncerus-caffer-ulna-cleaned.tif',245,4,127,63.2669768,97.697146,111.8244074,1.8,98.4723856,112.2268404,1.099148,11.3759172,11.3775695,245.6219389,1674.3613412,8.3677041,147.1633588,21.5913964,121.3399974,14.2561193,23.1049379,2.411693,105.2837508),(280,'Syncerus-caffer-ulna-cleaned.tif',245,4,128,56.8223432,97.241008,111.0716106,1.8,98.2152497,111.5313305,1.0974967,9.6007938,12.0526149,190.947322,1375.839623,7.502661,114.1527905,19.8887014,103.4735911,0.4531251,1.0132186,2.0344439,2.1878816),(281,'Syncerus-caffer-ulna-cleaned.tif',245,4,129,54.3421112,96.9276206,110.624764,1.8,97.8780656,111.1722698,1.0993476,9.096674,11.9868353,184.3733189,1272.7401168,7.1887622,106.1781605,20.2682123,98.4368142,13.5406604,23.1049379,2.411693,99.406463),(282,'Syncerus-caffer-ulna-cleaned.tif',245,4,130,52.1608411,96.5479321,110.2102658,1.8,97.5230362,110.7894884,1.1048212,10.7287365,11.8763297,168.0564332,1168.8573361,6.9385635,98.4190706,15.6641402,83.5321533,10.6309916,22.4377015,2.3847581,91.6711335),(283,'Syncerus-caffer-ulna-cleaned.tif',245,4,131,50.331481,96.1747228,109.7420312,1.8,97.3065733,110.3032485,1.0830341,9.1889322,12.8348406,162.5743445,1099.7717364,6.5461708,85.686435,17.6924088,81.6177679,12.8246181,22.465137,2.2991137,90.4994487),(284,'Syncerus-caffer-ulna-cleaned.tif',245,4,132,50.1818445,95.9078365,109.5188253,1.8,97.0814387,110.0781525,1.0706367,10.6576162,13.5474082,167.7501012,1149.7365645,6.4401438,84.8676403,15.739927,77.3351112,10.8769897,23.078263,2.3284239,70.9640024),(285,'Syncerus-caffer-ulna-cleaned.tif',245,4,133,50.247921,95.6266705,109.2654604,1.8,96.8261996,109.9406073,1.0571452,9.8513083,13.7710613,166.567806,1215.5560522,6.3527181,88.2688726,16.9081913,83.3842121,10.6332751,24.0839301,2.4227627,106.6753287),(286,'Syncerus-caffer-ulna-cleaned.tif',245,4,134,50.4886459,95.4179101,109.0945437,1.8,96.5935969,109.6759785,1.0530475,11.1474699,13.7749282,162.3029539,1330.2492755,6.3535667,96.5703238,14.5596225,84.2276193,0.4531251,1.0132186,2.0344439,2.1878816),(287,'Syncerus-caffer-ulna-cleaned.tif',245,4,135,47.5458786,94.8560643,108.3266605,1.8,95.8976615,108.8457857,1.0555382,9.0975102,13.9700465,137.0522347,1155.9910781,6.0001954,82.7478332,15.0648069,77.5617837,10.8514158,24.3846997,2.4087776,93.5935806),(288,'Syncerus-caffer-ulna-cleaned.tif',245,4,136,47.9236096,94.5376553,107.9870401,1.8,95.5813206,108.5515429,1.0347896,14.6913738,15.0732187,148.4617226,1219.2602647,5.904017,80.8891774,10.1053669,76.3382589,10.5052981,24.7233632,2.4210385,99.5164096),(289,'Syncerus-caffer-ulna-cleaned.tif',245,4,137,47.314051,94.3059863,107.5033157,1.8,95.1692467,108.034664,1.0268929,9.2164629,14.3573637,141.6522825,1268.0485572,5.7740047,88.3204318,15.3694844,85.2675144,9.2675876,23.7188383,2.329174,71.9346579),(290,'Syncerus-caffer-ulna-cleaned.tif',245,4,138,47.3164153,94.1492178,107.1944756,1.8,95.2783035,107.7863512,0.9945643,10.8455949,15.927554,145.9617213,1411.7705287,5.5448416,88.6369951,13.4581572,80.8392366,10.7497167,21.9987459,2.1359458,88.5314603),(291,'Syncerus-caffer-ulna-cleaned.tif',245,4,139,47.9590121,93.9722268,107.0075961,1.8,94.9538497,107.8107454,0.9848765,8.0920982,15.0360423,140.6279932,1577.7003862,5.5490862,104.9279026,17.3784339,103.0369746,0.4531251,1.0132186,2.0344439,2.1878816),(292,'Syncerus-caffer-ulna-cleaned.tif',245,4,140,46.2766131,93.2411138,106.1397609,1.8,93.8454809,106.5731581,1.0104923,10.012083,15.7817592,134.7943021,1310.8234651,5.5344324,83.0594009,13.4631627,77.3482732,11.7978934,24.0498048,2.3162158,91.7355387),(293,'Syncerus-caffer-ulna-cleaned.tif',245,4,141,47.5369191,92.8761553,105.7121246,1.8,93.4516171,106.062089,0.9887681,8.3520447,16.1846159,154.3788707,1401.0902288,5.5286123,86.5692607,18.4839612,85.4062538,11.1538036,24.7233632,2.2913505,81.702381),(294,'Syncerus-caffer-ulna-cleaned.tif',245,4,142,48.7483211,92.6120183,105.3751876,1.8,93.4284037,105.9263701,0.9760747,9.555799,17.1027049,159.9612338,1557.8368224,5.5742755,91.0871604,16.7397027,87.6820466,9.6401081,23.8784467,2.1535358,68.5750915),(295,'Syncerus-caffer-ulna-cleaned.tif',245,4,143,49.4854906,92.0296954,104.644366,1.8,92.5277941,105.096706,0.9799188,9.3216328,17.7447318,173.592171,1581.0123571,5.6879511,89.0975629,18.6225068,87.5369454,10.4055671,25.1351731,2.1637989,69.3713951),(296,'Syncerus-caffer-ulna-cleaned.tif',245,4,144,51.112266,91.6419127,104.0961607,1.8,92.2022466,104.5072076,0.9748341,11.9866161,17.3252288,188.8977557,1751.5357481,5.8347746,101.0974094,15.7590561,100.8395875,11.3035303,26.2734429,2.13488,99.7363028),(297,'Syncerus-caffer-ulna-cleaned.tif',245,4,145,49.5914494,90.9379745,103.033243,1.8,91.6823146,103.6460055,0.9862839,12.9734013,19.2417878,205.7932514,1483.4599514,5.7486795,77.0957441,15.8627061,72.7913044,10.4904602,26.4680925,2.2348425,86.6734185),(298,'Syncerus-caffer-ulna-cleaned.tif',245,4,146,48.1192258,90.3259166,102.3323195,1.8,90.7924819,102.8808928,1.0072618,11.1999375,17.7064654,198.6076186,1284.1155909,5.7314356,72.5224128,17.732922,72.7913492,10.397974,24.7607066,2.1740262,68.3096569),(299,'Syncerus-caffer-ulna-cleaned.tif',245,4,147,47.3366365,89.8839684,101.7341912,1.8,90.5294416,102.4876965,1.0046079,6.962172,15.3151423,199.0226615,1291.9575001,5.6192886,84.358178,28.5862892,92.3605727,10.4528754,25.6526449,2.1930992,70.232104),(300,'Syncerus-caffer-ulna-cleaned.tif',245,4,148,46.0678065,89.2536401,100.9350717,1.8,89.6730791,101.3658013,1.0215629,7.3112166,15.2908734,192.9255205,1161.3329384,5.5855756,75.9494181,26.3876085,85.7694194,10.5148928,25.1351731,2.1637989,69.2159072),(301,'Syncerus-caffer-ulna-cleaned.tif',245,4,149,45.3949713,88.6765644,100.2517543,1.8,89.2291352,100.8240825,1.0580406,8.048864,16.4602587,187.1531919,1094.6117992,5.7449672,66.5002792,23.252125,73.9247226,10.5676778,24.015631,2.1273956,64.0893817),(302,'Syncerus-caffer-ulna-cleaned.tif',245,4,150,43.9325783,88.0904324,99.5974905,1.8,88.2595898,99.7144729,1.0962122,6.3282216,11.3920535,167.009218,979.8503973,5.7930942,86.0117451,26.3911772,94.6473569,10.3542896,22.6245147,2.1421338,64.3548163),(303,'Syncerus-caffer-ulna-cleaned.tif',245,4,151,43.4119305,87.6262852,99.2401466,1.8,87.8060231,99.355701,1.0992069,6.456545,10.2941788,158.539239,940.6331409,5.7420164,91.3752483,24.5548105,93.0072117,9.8836959,21.1372059,2.1112158,60.9952499),(304,'Syncerus-caffer-ulna-cleaned.tif',245,4,152,44.0680288,87.202926,98.9038226,1.8,87.571097,99.1990148,1.0766963,23.9971673,26.6837166,187.7263793,1014.5149248,5.6928322,38.0200007,7.8228558,33.5006428,10.2694943,21.5270199,2.1003859,58.6974217),(305,'Syncerus-caffer-ulna-cleaned.tif',245,4,153,45.2433438,86.7835983,98.4400057,1.8,86.9130583,98.6576951,1.1063484,19.678255,23.9244539,208.5481049,1076.9416641,6.0276153,45.0142631,10.5978963,41.4973644,10.6895636,21.3017003,2.082027,57.4157904),(306,'Syncerus-caffer-ulna-cleaned.tif',245,4,154,47.3117489,86.5525064,98.1025792,1.8,87.0846268,98.6991102,1.052707,22.6208817,29.8444953,274.0485472,1304.5847839,5.9514715,43.712744,12.1148482,42.1546606,10.2865181,21.9192687,2.0899424,54.4771465),(307,'Syncerus-caffer-ulna-cleaned.tif',245,4,155,50.3199705,86.282596,97.9108013,1.8,87.1942182,98.7241176,0.9829253,22.8650639,31.6583769,407.2556467,1638.4349918,5.8071689,51.7536005,17.8112622,54.1585577,11.1011864,23.3919668,2.1211823,57.5712783),(308,'Syncerus-caffer-ulna-cleaned.tif',245,4,156,55.1195364,85.8899479,97.5384428,1.8,86.8107267,98.3038961,1.0002992,21.905498,31.8210992,548.696823,2017.8128495,6.5072785,63.4111612,25.0483611,66.6287744,13.0213546,24.1690326,2.1015698,71.2938422),(309,'Syncerus-caffer-ulna-cleaned.tif',245,4,157,60.6430814,85.6852349,97.4004326,1.8,87.4160489,98.4261942,0.904412,20.2474917,33.9472497,792.2091754,2518.2174504,6.2451579,74.1803084,39.1262872,85.7871172,13.5136666,23.8784467,2.1535358,65.4165545),(310,'Syncerus-caffer-ulna-cleaned.tif',245,4,158,66.0184832,84.8388611,96.8951955,1.8,85.3327739,97.3255905,1.0789129,35.5335501,29.4041197,801.5000549,2129.4897473,8.5487894,72.4214759,22.5561491,63.5486791,14.3442162,24.2580689,2.1432561,70.6530265),(311,'Syncerus-caffer-ulna-cleaned.tif',245,4,159,67.6261574,84.8724899,96.3641015,1.8,85.1366441,96.3529481,1.0798023,24.360019,83.7675423,730.6387258,2462.2421586,8.76531,29.3937495,29.9933561,37.2733555,13.791037,24.4015341,2.1175852,66.5426979),(312,'Syncerus-caffer-ulna-cleaned.tif',245,4,160,62.8265915,84.9276654,95.7225982,1.8,86.0692045,96.360058,0.858125,35.5834137,34.9013768,790.8616643,2280.9261653,5.9943969,65.3534724,22.2255703,65.4520529,13.9835095,24.015631,2.1273956,65.9018822),(313,'Syncerus-caffer-ulna-cleaned.tif',245,4,161,49.5808722,84.1456033,93.5209701,1.8,85.9094381,94.44106,0.6854825,28.5883808,48.3320544,660.9088853,1390.677973,3.3115726,28.7734091,23.1180944,37.2881895,14.0496419,19.7408676,2.1269626,59.0728029),(314,'Syncerus-caffer-ulna-cleaned.tif',245,4,162,50.6611789,83.6796501,93.4145629,1.8,84.0702992,94.1292787,0.9916337,25.0164122,29.1385768,621.2201871,1252.8006431,5.9141623,42.9945721,24.8325053,53.0534485,15.274048,23.0916043,2.863293,69.151502),(315,'Syncerus-caffer-ulna-cleaned.tif',245,4,163,54.2926472,83.5473997,93.4126399,1.8,83.6410409,93.8847233,0.8576131,21.1316117,35.564725,718.7878194,1589.5636261,5.1755749,44.6949505,34.014813,55.7990548,16.3576401,25.0656428,2.9229237,75.5596588),(316,'Syncerus-caffer-ulna-cleaned.tif',245,4,164,40.7245096,81.8436924,90.8198073,1.8,81.97479,91.1997859,-1.0955313,45.4011045,7.9659444,347.267228,635.1746876,5.366309,79.736269,7.6488718,21.4966203,0.4531251,0.6408157,2.3561945,1.2816314),(317,'Syncerus-caffer-ulna-cleaned.tif',245,4,165,38.8219179,81.4922833,89.6158108,1.8,81.6226606,89.9873294,-1.0569985,38.3117111,8.6273694,247.148998,619.7811406,4.9073445,71.8389479,6.4510039,22.2665096,11.5849796,17.3494263,0.7114591,48.7098054),(318,'Syncerus-caffer-ulna-cleaned.tif',245,4,166,43.0584027,81.0753615,89.3458895,1.8,81.2750139,89.5754844,-1.0534252,39.7398949,9.1215677,268.7289437,740.1526662,5.4208647,81.1431422,6.7621956,24.8745149,12.0274932,18.2885248,0.7328151,56.7105695),(319,'Syncerus-caffer-ulna-cleaned.tif',245,4,167,43.9280363,80.8787361,88.8768214,1.8,81.3354809,89.2265355,-1.0873848,52.8217447,15.7295312,338.8302075,823.615186,5.7396272,52.3610763,6.414597,21.3729979,12.0478977,18.2885248,0.7328151,57.8822542),(320,'Syncerus-caffer-ulna-cleaned.tif',245,4,168,43.3760302,80.504494,88.6993638,1.8,80.9510505,88.9539371,-1.1843175,54.3978568,12.3371611,302.5496072,791.8721432,6.2022249,64.1859286,5.5617928,19.8010745,0.9901334,3.0396557,2.0344439,6.5636448),(321,'Syncerus-caffer-ulna-cleaned.tif',245,4,169,58.4841478,79.2754576,90.3724278,1.8,80.2059595,90.6419093,-1.0620457,51.0858045,26.1381214,740.13084,1630.4531535,7.4347655,62.3783604,14.4879942,43.9574051,0.9062502,2.0264371,1.1071487,4.3757632),(322,'Syncerus-caffer-ulna-cleaned.tif',245,4,170,82.1577547,81.0912626,92.5927958,1.8,81.7551228,92.8038073,0.7921768,15.6445261,20.9443776,1732.2375475,3266.3279102,6.9392969,155.9524933,110.7248337,191.20627,19.6055005,26.830211,3.0570489,105.7235371),(323,'Syncerus-caffer-ulna-cleaned.tif',245,4,171,81.5832876,80.0131244,91.3675154,1.8,82.0485075,91.9066401,0.4258192,12.1072387,58.9019669,2023.5158608,3299.2565039,2.3200153,56.0126712,167.1327299,88.5160581,19.0038524,24.1307736,2.1692152,80.9971601),(324,'Syncerus-caffer-ulna-cleaned.tif',245,4,172,90.9201667,80.1764068,91.0713777,1.8,80.8683532,91.4137329,0.9613983,11.6750502,15.0083476,1754.3741823,2501.8585905,10.1889387,166.6978048,150.2669503,255.427589,18.9643599,24.0199054,2.1954317,81.9034103),(325,'Syncerus-caffer-ulna-cleaned.tif',245,4,173,108.5470298,80.7945025,91.0304021,1.8,81.6540274,91.1814147,0.6964696,37.9922489,66.8027217,2106.9633268,3341.5886424,7.4452325,50.021744,55.4577154,70.8979764,18.885375,25.7046179,2.2813346,90.014121),(326,'Syncerus-caffer-ulna-cleaned.tif',245,4,174,141.5586358,80.942545,91.5943374,1.8,82.0807635,91.6245987,0.4736303,12.8306995,33.8361352,3420.9394292,4329.6817038,4.9084371,127.9602908,266.6214295,214.1814972,19.8316628,26.3436824,2.4292351,97.5939626),(327,'Syncerus-caffer-ulna-cleaned.tif',245,4,175,152.7221374,81.6503709,91.4239038,1.8,82.4523653,91.6124507,0.87777,37.2288072,35.1787146,3066.1154344,4994.8741845,15.064696,141.9856935,82.3586804,157.3785979,20.69204,25.7604715,2.4558631,102.7660294),(328,'Syncerus-caffer-ulna-cleaned.tif',245,4,176,145.934491,81.8775719,90.9972657,1.8,82.7111329,91.2993444,0.9779364,37.5264552,29.4651355,2288.8732776,4816.3379954,16.7293228,163.4588782,60.9935914,157.7628979,20.2030278,25.0656428,2.2794226,89.2822226),(329,'Syncerus-caffer-ulna-cleaned.tif',245,4,177,103.1275148,81.0433432,89.5409451,1.8,81.4862087,90.2656067,1.2140863,26.7656296,17.9010669,1045.8763983,2325.2831382,15.0920938,129.896344,39.075352,104.694036,16.2544153,22.3551928,1.8797271,77.8119456),(330,'Syncerus-caffer-ulna-cleaned.tif',245,4,178,58.4934807,80.1783359,88.1462212,1.8,80.5158848,88.3079688,1.5376092,6.4578528,8.8436303,332.5862296,735.4390835,9.7381801,83.1603149,51.5010544,120.5143792,11.3281278,16.4690877,1.7088024,55.0724208),(331,'Syncerus-caffer-ulna-cleaned.tif',245,4,179,20.4094789,79.5523479,87.4637779,1.8,79.6540455,87.4232532,-1.4660852,3.5867838,6.7908823,36.4161278,152.2649632,3.3644196,22.4219707,10.152864,27.6971243,6.9031519,12.760119,1.2827409,32.3328961),(332,'Syncerus-caffer-ulna-cleaned.tif',245,4,180,0.6158427,79.2573871,86.8566405,1.8,79.2515823,86.9396051,1.5693396,0.4950637,2.4090618,0.0786788,0.970991,0.1026402,0.4030577,0.1589266,0.4294433,1.3593753,5.0660928,1.7506498,11.0948959),(333,'Syncerus-caffer-ulna-cleaned.tif',245,4,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(334,'Syncerus-caffer-ulna-cleaned.tif',245,4,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(335,'Syncerus-caffer-ulna-cleaned.tif',245,4,183,406.3749024,125.1366998,123.5561419,1.8,124.0517623,123.5777966,0.1179754,14.2512136,23.6150725,18021.8309426,48047.3087603,0.9383017,2034.6034823,1264.5821905,2712.3419042,33.0781333,44.7883862,0.1934273,160.3106302),(336,'Syncerus-caffer-ulna-cleaned.tif',245,4,184,347.457151,127.5036922,123.7134898,1.8,126.4517726,123.6042333,0.3451646,13.9484153,22.255241,12417.7676059,28209.1533722,6.6295874,1267.5285505,890.2636851,1718.7442628,29.6169147,41.2044981,0.1434523,147.539858),(337,'Syncerus-caffer-ulna-cleaned.tif',245,4,185,215.0447557,130.3576689,125.2455188,1.8,128.9132237,124.0960837,0.7076374,11.9610225,19.2849669,5002.31154,12115.5825425,15.1446086,628.2397366,418.2177169,802.2795318,24.030588,34.6781359,3.0237206,118.4754455),(338,'Syncerus-caffer-ulna-cleaned.tif',245,4,186,75.543699,134.0597779,128.7876305,1.8,133.7193415,128.5245857,-0.8840515,6.740408,9.636065,434.846594,1368.0801454,7.5293714,141.9749806,64.5133932,183.7841505,11.88689,19.958091,0.8818719,52.5546995),(339,'Syncerus-caffer-ulna-cleaned.tif',245,4,187,13.763505,134.7618782,129.2500103,1.8,134.5332368,129.3105792,-0.7429021,2.7657611,6.1027585,15.6826864,98.0969786,1.0495935,16.074203,5.6702969,18.0695575,5.4226996,12.5328214,0.8621701,29.9439852),(340,'Syncerus-caffer-ulna-cleaned.tif',245,4,188,3.5312336,90.8227434,135.5206956,1.8,90.8443698,135.3747353,-0.0014573,2.3028583,5.2378469,3.7701642,20.4233978,0.0000013,3.8991971,1.6371673,4.47677,11.3281278,11.8939948,0.8663023,37.4594215),(341,'Syncerus-caffer-ulna-cleaned.tif',245,4,189,23.0308856,91.0382789,134.1028363,1.8,91.3658463,133.7925819,0.0254305,4.9731103,20.9465679,87.0789935,510.442013,0.0024819,24.3687661,17.5099664,28.3686415,19.0312548,19.6104257,0.7036138,62.5878572),(342,'Syncerus-caffer-ulna-cleaned.tif',245,4,190,153.8674629,112.8901842,132.3367957,1.8,111.0364533,132.1567331,-0.03983,7.3628672,33.746112,1443.6645322,35309.8655728,0.0406618,1046.3387768,196.0736899,1084.3579795,23.5625059,23.9642789,1.3028859,77.2622126),(343,'Syncerus-caffer-ulna-cleaned.tif',245,4,191,252.4553001,116.274877,131.9418591,1.8,109.1674272,131.8984139,-0.0165424,8.1521772,38.413198,2636.7869507,61811.1038976,0.0115131,1609.1111153,323.4457367,1667.4972227,26.2734429,26.7497374,0.8934099,87.0299358),(344,'Syncerus-caffer-ulna-cleaned.tif',245,4,192,263.5804126,115.0393878,131.8728637,1.8,108.0012435,131.7669932,-0.0058774,8.1319625,37.5835607,2811.7216318,68949.7625599,0.0015176,1834.5723838,345.7617577,1894.3150475,27.6406319,28.2903975,1.0138948,91.1858058),(345,'Syncerus-caffer-radius-cleaned.tif',245,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(346,'Syncerus-caffer-radius-cleaned.tif',245,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(347,'Syncerus-caffer-radius-cleaned.tif',245,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(348,'Syncerus-caffer-radius-cleaned.tif',245,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(349,'Syncerus-caffer-radius-cleaned.tif',245,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(350,'Syncerus-caffer-radius-cleaned.tif',245,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(351,'Syncerus-caffer-radius-cleaned.tif',245,3,7,0.0800135,56.7970836,159.953165,1.8,56.8672017,159.953165,0.317657,0.0926657,0.2818377,0.0017314,0.0047205,0.001301,0.016749,0.0186838,0.0217468,17.6718794,221.1324834,0.0081965,478.1767529),(352,'Syncerus-caffer-radius-cleaned.tif',245,3,8,0.0990525,56.7897834,159.953165,1.8,56.8672017,159.953165,0.3232833,0.0965691,0.2882339,0.002148,0.0057323,0.0016661,0.0198878,0.0222433,0.0259239,18.1947891,221.589763,0.0102246,482.3514868),(353,'Syncerus-caffer-radius-cleaned.tif',245,3,9,0.0576147,56.7458464,159.953165,1.8,56.8672017,159.953165,0.3758814,0.1277181,0.3236278,0.00127,0.0028105,0.001294,0.0086844,0.0099437,0.0117283,18.0815191,221.5948592,0.0122693,484.1184458),(354,'Syncerus-caffer-radius-cleaned.tif',245,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(355,'Syncerus-caffer-radius-cleaned.tif',245,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(356,'Syncerus-caffer-radius-cleaned.tif',245,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(357,'Syncerus-caffer-radius-cleaned.tif',245,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(358,'Syncerus-caffer-radius-cleaned.tif',245,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(359,'Syncerus-caffer-radius-cleaned.tif',245,3,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(360,'Syncerus-caffer-radius-cleaned.tif',245,3,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(361,'Syncerus-caffer-radius-cleaned.tif',245,3,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(362,'Syncerus-caffer-radius-cleaned.tif',245,3,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(363,'Syncerus-caffer-radius-cleaned.tif',245,3,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(364,'Syncerus-caffer-radius-cleaned.tif',245,3,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(365,'Syncerus-caffer-radius-cleaned.tif',245,3,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(366,'Syncerus-caffer-radius-cleaned.tif',245,3,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(367,'Syncerus-caffer-radius-cleaned.tif',245,3,23,5.5259716,121.6832531,60.7802788,1.8,121.6857641,61.1364283,0.0102852,2.2205038,4.3335735,4.3574076,16.0943085,0.0000974,3.7138654,1.9623509,4.6157777,21.2309806,33.8603028,1.8417432,91.7810801),(368,'Syncerus-caffer-radius-cleaned.tif',245,3,24,27.3671696,121.0637966,62.3656219,1.8,120.5312801,62.9088699,0.027695,5.1376958,8.3031844,95.751883,277.0532198,0.0034976,33.3671042,18.6371258,43.2372802,25.2804015,40.8441458,1.8750048,110.7667935),(369,'Syncerus-caffer-radius-cleaned.tif',245,3,25,49.8578707,119.7256269,63.8193227,1.8,119.6679885,64.0883683,0.1847337,6.3536514,11.0794263,384.4668279,1105.5678349,0.2803681,99.7856571,60.5111618,132.3354413,28.8989449,46.952596,1.956679,132.5356628),(370,'Syncerus-caffer-radius-cleaned.tif',245,3,26,69.6086382,119.2456656,65.2631503,1.8,119.376719,65.2745096,0.3129661,8.371867,13.6800232,832.7777352,2114.8101072,1.0997157,154.5911196,99.4733592,215.0750819,31.0785718,52.5976577,1.9689009,142.1290341),(371,'Syncerus-caffer-radius-cleaned.tif',245,3,27,91.2876938,118.8251308,66.6416036,1.8,118.8621941,66.4708114,0.4316101,10.7077064,16.5352642,1542.3625896,3736.977178,2.6626053,226.0004514,144.0422932,319.272116,32.5281865,57.6484853,1.9323269,156.1814377),(372,'Syncerus-caffer-radius-cleaned.tif',245,3,28,115.7374814,118.1567203,67.6406835,1.8,118.1638287,67.2115041,0.4660352,12.1325672,17.9931413,2437.804556,5778.0864611,3.8948259,321.1271657,200.9306453,456.5540233,33.1464422,59.8982726,1.902116,159.4765989),(373,'Syncerus-caffer-radius-cleaned.tif',245,3,29,140.1786206,117.3182814,68.2913324,1.8,117.2068308,67.756221,0.4461632,12.7502645,20.3810804,3386.2752901,8144.1884804,4.3501802,399.5955232,265.5847102,565.6600815,34.8906337,61.4999459,1.8622531,166.0402436),(374,'Syncerus-caffer-radius-cleaned.tif',245,3,30,163.360947,116.1413757,68.8563813,1.8,116.0320926,68.2660106,0.4479583,13.5856068,21.1980393,4316.3438158,10513.1594071,5.107706,495.9496129,317.7144667,699.5514375,35.7968839,62.6772117,1.849096,169.7751911),(375,'Syncerus-caffer-radius-cleaned.tif',245,3,31,182.8194723,115.0284433,69.5784508,1.8,114.7799761,68.7901147,0.4951627,14.8681042,21.7271772,5237.4983928,12451.9953412,6.879834,573.1069076,352.2640367,813.8174587,36.480948,63.6733499,1.8520285,178.4811761),(376,'Syncerus-caffer-radius-cleaned.tif',245,3,32,201.464361,114.2204107,70.4374455,1.8,113.8076903,69.5229356,0.5772213,65.2637271,52.9533992,6616.5990066,14235.0607093,9.9988711,268.8224158,101.3824877,249.2408426,36.9426094,65.5153731,1.7939664,183.1867791),(377,'Syncerus-caffer-radius-cleaned.tif',245,3,33,221.9364321,113.4133648,71.3448747,1.8,112.9836266,70.3240165,0.6554251,62.4000575,58.6567952,8378.7704964,16484.8387428,13.7410357,281.0388579,134.2750446,292.9661429,37.917251,67.4487043,1.7668744,199.7191763),(378,'Syncerus-caffer-radius-cleaned.tif',245,3,34,240.4168763,112.7842867,72.3848468,1.8,112.330718,71.0613205,0.7496241,53.9563352,63.9071275,9795.0049182,18572.357348,18.6025141,290.6148044,181.5357711,339.1661173,37.8342164,69.6723147,1.760539,193.3754247),(379,'Syncerus-caffer-radius-cleaned.tif',245,3,35,258.4324831,112.2825686,73.7041593,1.8,111.9570592,72.0635956,0.8997353,19.3565912,22.374122,11235.2741989,21445.6067428,26.4179707,958.5004825,580.4366112,1413.3169344,37.4021269,72.1849781,1.7411049,218.1928845),(380,'Syncerus-caffer-radius-cleaned.tif',245,3,36,280.5056332,111.8015315,75.0717346,1.8,111.5095478,73.286601,1.0506638,19.0910345,22.4146545,12564.5942993,26126.1674305,35.203263,1165.5842138,658.1410917,1615.5790689,1.016669,4.2747738,2.1293956,9.1269075),(381,'Syncerus-caffer-radius-cleaned.tif',245,3,37,301.9391108,111.5194271,76.5597279,1.8,111.3650205,74.5617965,1.1752325,17.9396062,22.4575821,13346.212562,32784.8772116,42.8512953,1459.8578392,743.9523718,1866.5336958,1.0178194,5.2843015,2.1112158,11.3147891),(382,'Syncerus-caffer-radius-cleaned.tif',245,3,38,322.9387982,111.3036739,77.9283351,1.8,111.2560041,75.8669552,1.2507614,17.8992404,22.9920614,13826.4634972,40604.8163646,48.4960973,1766.0363589,772.4609072,2160.6007234,32.9776748,81.8452336,1.6539376,266.8382846),(383,'Syncerus-caffer-radius-cleaned.tif',245,3,39,343.7065958,111.018128,79.3997011,1.8,111.0093153,77.2727466,1.3070468,37.319781,68.6674326,13873.2660568,50155.1462132,53.3910577,730.4066035,371.7402863,819.2639517,30.0142465,83.2789226,1.6634267,269.4282249),(384,'Syncerus-caffer-radius-cleaned.tif',245,3,40,360.7303711,110.8689573,81.1647184,1.8,110.8565157,78.7137119,1.3580172,64.8810624,72.0749151,13652.5751241,59959.6417801,57.4405518,831.9072133,210.4246542,856.3390034,28.6223653,85.7855718,1.6289318,276.3217094),(385,'Syncerus-caffer-radius-cleaned.tif',245,3,41,379.1654577,110.887536,83.2010119,1.8,111.0331414,80.9016059,1.401224,31.1137545,70.530626,13212.902453,73367.2179664,61.3944579,1040.2178755,424.6643546,1171.6669724,27.1271584,89.8331251,1.6212585,288.5882901),(386,'Syncerus-caffer-radius-cleaned.tif',245,3,42,403.6709312,110.8114814,85.2398595,1.8,111.018404,82.8859465,1.4254167,14.1864054,30.0937145,13358.8824532,89619.4855786,65.8665323,2978.0134204,941.6678925,3421.3799651,25.2949559,93.0242793,1.6244035,294.2001433),(387,'Syncerus-caffer-radius-cleaned.tif',245,3,43,442.7918731,110.7561717,87.5963017,1.8,111.075484,85.4684572,1.4518622,14.1374218,32.2633757,14363.3838664,116105.804877,72.7596522,3598.6874347,1015.9832549,4043.8727887,24.9218812,96.7239045,1.6364296,300.2784603),(388,'Syncerus-caffer-radius-cleaned.tif',245,3,44,498.7358099,110.6448441,90.9466106,1.8,110.9833176,88.9931082,1.4824293,13.9495792,33.1927952,16278.0276775,157695.155223,82.4752411,4750.8850701,1166.9189025,5207.2337654,24.015631,100.6029597,1.5572836,331.1742371),(389,'Syncerus-caffer-radius-cleaned.tif',245,3,45,594.0979705,110.5907509,95.4328948,1.8,110.8501029,93.6392949,1.4942294,14.1118423,36.3153691,22150.5032602,224646.6377568,98.4369796,6185.9935087,1569.6393758,6648.3363519,25.3750063,103.304576,1.7027681,304.2977062),(390,'Syncerus-caffer-radius-cleaned.tif',245,3,46,684.636051,110.1514481,98.3431336,1.8,110.4086951,95.1924992,1.5220124,15.75427,38.9508549,29899.2499116,272705.5465889,113.834666,7001.2724348,1897.8505409,7560.4869172,28.0274879,104.4116682,1.6315909,315.703578),(391,'Syncerus-caffer-radius-cleaned.tif',245,3,47,677.7833236,110.0385107,97.4741796,1.8,110.346871,94.7934453,1.5158415,14.8275684,38.098693,30672.4875108,252503.0647527,112.6230759,6627.6043919,2068.6121028,7220.1701737,28.8615574,95.6190622,1.5565793,302.9061282),(392,'Syncerus-caffer-radius-cleaned.tif',245,3,48,629.7655146,110.1037344,95.1188705,1.8,110.3859344,92.925509,1.5019484,39.4651755,58.6332516,29067.8416622,209375.9742753,104.4641863,3570.9425698,736.5440869,3373.6711124,28.6059163,86.5765463,1.5969684,296.5168353),(393,'Syncerus-caffer-radius-cleaned.tif',245,3,49,590.5912511,110.3172094,93.1757431,1.8,110.7444813,91.0386049,1.4848206,14.6988457,34.0360364,27267.7304554,179908.9447379,97.7060751,5285.8371184,1855.0933146,5959.899082,29.1496916,79.4533922,1.6335709,309.8451541),(394,'Syncerus-caffer-radius-cleaned.tif',245,3,50,565.4245151,110.3343327,91.8176307,1.8,110.7537895,89.8890466,1.4730932,15.4134485,32.7584469,26104.330737,162849.9720017,93.3406962,4971.2360503,1693.6074157,5647.9318689,28.8618296,74.6653396,1.6680495,274.8579126),(395,'Syncerus-caffer-radius-cleaned.tif',245,3,51,549.9109792,110.2338819,90.612962,1.8,110.7347537,89.0826233,1.4670246,14.4568899,31.539459,25416.8510177,151620.5770557,90.6684085,4807.3296774,1758.1133414,5529.8610691,28.5744741,71.05834,1.673003,298.0905787),(396,'Syncerus-caffer-radius-cleaned.tif',245,3,52,539.8068788,110.1128249,89.3907995,1.8,110.7114838,88.3660548,1.4642206,14.1886799,30.3266416,24914.6505236,145034.4498009,88.9497866,4782.4105265,1755.9526817,5516.6207131,28.145658,67.7721283,1.6578243,271.1496426),(397,'Syncerus-caffer-radius-cleaned.tif',245,3,53,537.5098815,109.9272054,88.2883387,1.8,110.627851,87.8099504,1.4602133,14.5858972,29.231896,24997.8673266,140150.0876565,88.4939397,4794.4234421,1713.8381675,5561.1680049,0.4531251,1.4329074,1.8925469,3.0941318),(398,'Syncerus-caffer-radius-cleaned.tif',245,3,54,535.0932372,109.7120798,87.3981546,1.8,110.4735741,87.605154,1.4551935,15.1604785,28.2964753,25524.2785669,133642.7511252,87.9956728,4722.9469323,1683.6063907,5554.3976893,28.2167575,62.4261047,1.7311718,247.4127849),(399,'Syncerus-caffer-radius-cleaned.tif',245,3,55,536.8597562,109.5414163,86.8492378,1.8,110.3256219,87.9391469,1.4417134,15.7528423,27.5552711,26473.4574563,128710.024767,87.9939929,4670.9765411,1680.5511659,5523.4028112,1.3593753,3.2040784,1.7126934,7.7353295),(400,'Syncerus-caffer-radius-cleaned.tif',245,3,56,535.0302094,109.4125836,86.5717888,1.8,110.1952661,88.2437745,1.4176382,16.0475307,27.4378954,28098.1230167,123244.538087,87.0962677,4491.7635293,1750.9312501,5301.6954486,30.1619915,59.0107394,1.7561443,263.1944199),(401,'Syncerus-caffer-radius-cleaned.tif',245,3,57,535.8169052,109.4370003,86.6902935,1.8,110.2350681,88.2100398,1.3753969,17.7034066,27.7991209,31932.4244877,119265.8245207,85.9363256,4290.2732484,1803.7446225,5226.3580154,33.6567023,57.5111992,1.7450121,278.2363428),(402,'Syncerus-caffer-radius-cleaned.tif',245,3,58,544.5650069,109.3017158,87.4056792,1.8,109.9694703,88.8047881,1.3345104,21.4571375,27.8016296,37905.357769,117158.1238579,85.7871685,4214.0739837,1766.5617234,5137.5083413,38.3671795,56.4299974,1.7729163,272.4878655),(403,'Syncerus-caffer-radius-cleaned.tif',245,3,59,555.5406697,108.8758462,88.5520469,1.8,109.2797882,89.8476394,1.3072354,27.8128799,71.1664734,47534.1233736,113725.3377712,86.3059536,1598.018454,1709.0687296,2263.4010573,44.3863038,56.0484811,1.815775,265.4577569),(404,'Syncerus-caffer-radius-cleaned.tif',245,3,60,600.5670562,107.5144331,90.6772344,1.8,107.4433216,92.192533,1.4432254,27.3603001,66.7724179,70404.5809315,116792.705875,98.474354,1749.1160216,2573.2386242,2625.3028304,48.5830737,56.5735369,2.1854593,296.6189682),(405,'Syncerus-caffer-radius-cleaned.tif',245,3,61,11.0666268,98.280342,113.8624797,1.8,99.3473638,114.9338523,0.1584729,32.3703063,28.359186,698.9688977,2012.680185,0.0459341,70.971014,21.5929035,74.9647272,4.0446628,12.8882038,2.9648838,29.2387643),(406,'Syncerus-caffer-radius-cleaned.tif',245,3,62,130.1964692,101.1659704,119.1454867,1.8,104.1275354,118.9305019,0.5444898,32.1624516,30.3470363,18851.1465984,32046.3066171,5.822063,1055.9946055,586.1228128,1273.6742241,0.4531251,0.6408157,2.3561945,1.2816314),(407,'Syncerus-caffer-radius-cleaned.tif',245,3,63,374.4023521,103.3947846,121.6510554,1.8,102.297757,122.4502516,0.0418052,29.4222705,40.8231857,60144.5836009,123176.9569257,0.1089919,3017.3283842,2044.1856648,4383.2228018,31.8581673,74.0051948,0.2791407,288.3339057),(408,'Syncerus-caffer-radius-cleaned.tif',245,3,64,795.307234,101.7367963,125.1415322,1.8,103.5122354,125.6201334,-0.0296581,30.1335295,47.5647526,117814.6523304,297478.1596851,0.1165579,6254.1723322,3909.7528343,8642.5153706,48.0870934,79.4016917,3.0902094,340.2477895),(409,'Syncerus-caffer-radius-cleaned.tif',245,3,65,1127.6832705,104.9991341,126.6365431,1.8,107.0845557,126.6178738,0.053834,31.9801338,46.8539396,165513.0004133,442037.0462715,0.5441636,9434.3624018,5175.4943093,12751.9492648,50.7598807,83.7301156,3.0494629,426.0416353),(410,'Syncerus-caffer-radius-cleaned.tif',245,3,66,1297.7339313,108.3319307,127.19197,1.8,109.1853454,126.7585498,0.1684071,27.2931904,45.0305345,194086.7860906,603989.9393657,6.076391,13412.897417,7111.179877,17451.278199,52.4697569,87.8560402,3.0018838,399.8514615),(411,'Syncerus-caffer-radius-cleaned.tif',245,3,67,1429.5154892,112.7191244,128.4004394,1.8,112.3700144,127.9725864,0.244844,32.2328379,48.2898888,211589.4002698,825544.3041277,13.9997661,17095.593415,6564.4049333,21433.9661328,54.4425919,92.5584994,2.7656317,389.0597278),(412,'Syncerus-caffer-radius-cleaned.tif',245,3,68,1578.2936327,116.5453776,129.3989674,1.8,112.3927788,127.391276,0.2875426,37.4063405,54.5988367,219348.7348845,1107186.2543218,21.1562406,20278.5685792,5863.9453073,24267.5299737,54.6438298,97.375522,2.9067717,355.0776329),(413,'Syncerus-caffer-radius-cleaned.tif',245,3,69,1571.6288064,115.6810198,129.1286653,1.8,111.9554566,127.1575128,0.301737,39.1967589,54.8907406,216304.17935,1195806.6957654,23.1331949,21785.2170175,5518.4200246,25721.9020808,53.9369378,98.7188983,2.87212,392.8213529),(414,'Syncerus-caffer-radius-cleaned.tif',245,3,70,1527.1967971,115.2063394,128.8065594,1.8,111.9097778,127.1882703,0.3021451,44.974896,54.1502995,209964.3695635,1142318.9772749,22.5381725,21095.3399533,4668.4792643,22615.4872859,54.3258194,98.1567732,2.812543,375.8224917),(415,'Syncerus-caffer-radius-cleaned.tif',245,3,71,1427.2136388,116.3230031,128.9602599,1.8,112.4197414,127.2713247,0.2972474,42.4066981,54.4597869,195108.2520249,1005631.884603,20.4053976,18465.5860977,4600.8828995,22042.5579893,52.7923928,96.3186684,2.7960371,385.7912442),(416,'Syncerus-caffer-radius-cleaned.tif',245,3,72,1301.5999026,117.3388012,129.2788438,1.8,113.8860116,127.6613967,0.2932541,45.416402,52.492334,178291.5432596,859108.8090905,18.127132,16366.3671247,3925.7082313,19762.8657884,51.5234181,92.2952567,2.8012107,397.8112542),(417,'Syncerus-caffer-radius-cleaned.tif',245,3,73,1221.6394084,118.2302943,129.4537877,1.8,115.2578368,127.9131049,0.2936652,41.1622835,50.702978,163906.2655821,748736.8009011,17.0598879,14767.1168388,3981.9526941,17994.0811406,51.7902806,88.452297,2.8506265,457.5060089),(418,'Syncerus-caffer-radius-cleaned.tif',245,3,74,1175.4327293,118.5806356,129.8020409,1.8,115.9560247,128.4035682,0.3010346,34.6519351,49.1303295,150825.0557974,674833.8599969,17.2234724,13735.585866,4352.572381,16794.825807,49.6818136,85.8513661,2.8415415,406.1229942),(419,'Syncerus-caffer-radius-cleaned.tif',245,3,75,1116.9366977,118.4688496,130.1129582,1.8,116.2244717,128.8139735,0.3148996,45.2278241,49.8166894,136355.8166649,600052.8226539,17.8574207,12045.2167593,3014.8657215,10944.6334863,46.9032908,82.3952918,2.8111467,375.1628122),(420,'Syncerus-caffer-radius-cleaned.tif',245,3,76,1052.3899403,118.2778064,130.4090568,1.8,116.1725955,129.1512151,0.3277858,28.9965819,45.2508879,122514.621011,527414.5013534,18.1800685,11655.3403982,4225.1401063,14165.3362932,48.0105482,79.8593644,2.8539402,315.1193539),(421,'Syncerus-caffer-radius-cleaned.tif',245,3,77,1002.434697,118.2409421,130.6913642,1.8,116.1520523,129.3964027,0.330835,29.1403291,43.2925732,113460.3978096,467347.5928371,17.6288796,10795.0985125,3893.5866955,13398.4325736,48.6914243,77.1165162,2.7938257,367.2075895),(422,'Syncerus-caffer-radius-cleaned.tif',245,3,78,964.7025432,118.3355324,130.8968028,1.8,116.5861808,129.7476209,0.3248591,31.8641625,41.6112587,108304.2401218,411578.8514819,16.3794955,9891.0454638,3398.935718,12265.3060834,0.4531251,1.0132186,2.677945,1.922447),(423,'Syncerus-caffer-radius-cleaned.tif',245,3,79,941.6651868,118.1783521,130.9717115,1.8,116.732398,130.1699395,0.3162695,30.9731313,40.2002435,103855.5566881,371475.1508,15.1820683,9240.6194305,3353.0854729,11570.0269897,0.4531251,0.6408157,2.3561945,1.2816314),(424,'Syncerus-caffer-radius-cleaned.tif',245,3,80,918.7254519,117.9993778,130.9681691,1.8,116.6761044,130.1210649,0.3051964,38.3453428,39.594139,101433.9116553,340962.0674969,13.8250606,8611.4277475,2645.2733059,10682.7912037,45.1191609,69.7945069,2.8383205,285.615155),(425,'Syncerus-caffer-radius-cleaned.tif',245,3,81,904.8809379,117.8760097,130.8711934,1.8,116.2430611,129.9864837,0.2871584,29.8773513,38.720797,100097.3858919,312262.7790803,12.0979793,8064.4718999,3350.2764271,9723.2075185,44.8593862,67.1481884,2.5872852,283.4272735),(426,'Syncerus-caffer-radius-cleaned.tif',245,3,82,893.4569258,117.8011083,131.0376783,1.8,115.9829238,129.8498705,0.2763154,27.3466569,36.552588,97584.1293532,293680.5482151,11.0828514,8034.466632,3568.4116651,9906.1447906,46.4330264,64.9725164,2.6155262,291.8678239),(427,'Syncerus-caffer-radius-cleaned.tif',245,3,83,873.0728321,117.7201101,131.3620532,1.8,115.8351996,130.1411362,0.2614452,27.1261494,36.2117046,92402.8140282,275804.5224798,9.7217096,7616.44683,3406.4110087,9069.8794116,45.6921194,63.8005952,2.6048272,281.0194987),(428,'Syncerus-caffer-radius-cleaned.tif',245,3,84,863.5225422,117.5965244,131.7265216,1.8,115.8163265,130.5215794,0.2463935,27.3980641,35.9159241,87607.5046099,262266.1449324,8.5619831,7302.2246069,3197.5801079,8931.3045705,40.2591841,62.2960519,2.7300152,308.4457625),(429,'Syncerus-caffer-radius-cleaned.tif',245,3,85,859.3138069,117.463772,132.1713067,1.8,115.7951809,131.1543467,0.233602,28.9593404,35.3328796,83554.3074972,250324.8843629,7.6743105,7084.7575242,2885.2282682,8452.0832991,38.8654891,61.2054459,2.7940867,255.8266578),(430,'Syncerus-caffer-radius-cleaned.tif',245,3,86,859.4720918,117.3557206,132.5590376,1.8,115.8662124,131.5423675,0.2229961,31.2107469,34.4144209,80299.7781911,239897.5433456,7.0059073,6970.8435258,2572.8246282,8149.8912057,38.6830809,60.047199,2.8031372,274.5469367),(431,'Syncerus-caffer-radius-cleaned.tif',245,3,87,857.3845855,117.203557,132.943714,1.8,116.0700527,132.1695408,0.2131847,27.2719511,34.0361823,77373.9045743,231139.6787937,6.3965733,6790.9989627,2837.1239125,7953.6267117,36.2753222,59.0281339,2.9170953,233.8834367),(432,'Syncerus-caffer-radius-cleaned.tif',245,3,88,859.2363444,117.1121005,133.2871473,1.8,116.2881523,132.6382465,0.2026918,26.9790611,33.2003493,75393.7267753,223485.0063177,5.8033414,6731.4052713,2794.5274484,7791.4031531,35.7221867,58.201447,2.8493901,260.7599676),(433,'Syncerus-caffer-radius-cleaned.tif',245,3,89,866.386727,116.9782442,133.5516085,1.8,115.9657644,132.7557311,0.1937514,27.0535244,32.2028237,73543.0040699,215853.7295311,5.3531452,6702.9441696,2718.4259948,7268.574545,36.2198109,57.3878976,2.8698005,262.883444),(434,'Syncerus-caffer-radius-cleaned.tif',245,3,90,864.5289951,116.87255,133.8142501,1.8,115.9071933,133.085312,0.1871263,26.9514226,32.2305235,71532.4255844,208545.273149,4.9868088,6470.4277373,2654.1242997,6773.8615515,34.2275839,56.5989363,2.8907888,189.2917736),(435,'Syncerus-caffer-radius-cleaned.tif',245,3,91,860.3465784,116.7944551,134.0389475,1.8,115.8059315,133.2260887,0.1817238,27.8012029,32.3009827,70069.5122804,202606.7895236,4.6833828,6272.4651951,2520.3769942,6518.5760541,35.717155,55.9568237,2.8710793,295.6561264),(436,'Syncerus-caffer-radius-cleaned.tif',245,3,92,860.7793731,116.7480147,134.2385373,1.8,115.8260229,133.3649915,0.1740168,24.6551145,31.6231041,68788.1631223,198393.2581376,4.3006574,6273.6806987,2790.015965,6777.9226073,35.492592,55.3999888,2.8767753,296.1681317),(437,'Syncerus-caffer-radius-cleaned.tif',245,3,93,865.3258325,116.5980895,134.4049202,1.8,115.8523987,133.6325702,0.1715064,24.8423387,31.3872159,67787.0759306,195696.7492921,4.2007511,6234.9190121,2728.6914001,6790.4981848,35.389801,54.9029843,2.8485548,271.6161065),(438,'Syncerus-caffer-radius-cleaned.tif',245,3,94,871.5542555,116.4450219,134.5099367,1.8,115.8422387,133.7469442,0.1703278,25.5630602,31.8920347,67263.5409892,194347.6588702,4.1735952,6093.9247216,2631.2789073,6975.6620192,32.4811681,54.5258461,2.8724252,147.5021303),(439,'Syncerus-caffer-radius-cleaned.tif',245,3,95,885.4973242,116.2496505,134.5322076,1.8,115.7826968,133.6848825,0.1748211,25.8406601,30.5853371,67409.5290835,194625.038446,4.4647269,6363.3445602,2608.6612664,6544.3179101,35.8795087,55.2143688,2.7367009,229.4244045),(440,'Syncerus-caffer-radius-cleaned.tif',245,3,96,906.1989209,116.0495173,134.4285511,1.8,115.7499174,133.4943201,0.1839093,24.0033996,31.0281386,68903.625517,196406.6247749,5.051008,6329.9518885,2870.577782,7150.3047093,38.5156346,54.9478428,2.7702744,278.0431271),(441,'Syncerus-caffer-radius-cleaned.tif',245,3,97,918.0982232,116.0384354,134.3814845,1.8,115.6001008,133.1473632,0.1909568,24.093746,29.973412,70032.9876635,196379.5236362,5.5121723,6551.7907591,2906.6873944,6989.9557618,38.803488,59.9034142,2.5011173,229.5076735),(442,'Syncerus-caffer-radius-cleaned.tif',245,3,98,917.6644952,115.9591009,134.4867305,1.8,115.3928631,133.0888963,0.1898132,26.5556254,29.666975,69538.0416664,194519.3402384,5.4445693,6556.7635516,2618.5804603,7178.0718667,39.5145945,59.4544354,2.485897,225.2607208),(443,'Syncerus-caffer-radius-cleaned.tif',245,3,99,914.0698605,115.8699521,134.5686928,1.8,115.2899681,133.1176185,0.1928618,28.3345209,38.6557888,69179.2835987,193331.6742457,5.596667,5001.3640978,2441.5194363,5477.1679702,39.2635903,59.2693884,2.5026787,203.0520652),(444,'Syncerus-caffer-radius-cleaned.tif',245,3,100,910.1874012,115.7673106,134.6378973,1.8,115.2955611,133.1993431,0.1981382,23.0326365,29.8354488,68668.0734488,192785.6697508,5.8779439,6461.6313029,2981.3379593,7180.0247121,39.5698166,59.7335092,2.5178158,208.3796199),(445,'Syncerus-caffer-radius-cleaned.tif',245,3,101,897.3496512,115.8664252,134.9299597,1.8,115.598171,133.7126891,0.1830183,28.4054145,38.3846134,66359.3337981,189044.9810077,4.9538715,4925.0198031,2336.150874,5348.5661053,38.4654009,57.4469009,2.5754684,193.8152111),(446,'Syncerus-caffer-radius-cleaned.tif',245,3,102,894.9316381,115.7665849,135.0328151,1.8,115.5701745,133.9080895,0.1901689,23.920832,29.209293,65810.1908116,188609.4956819,5.3293734,6457.1742803,2751.1664632,8089.1770702,38.5127389,57.0649872,2.5712094,205.7064106),(447,'Syncerus-caffer-radius-cleaned.tif',245,3,103,887.8802458,115.8039802,135.2047689,1.8,115.5207534,134.0656356,0.1856765,22.7564059,28.6484235,64988.7740212,187092.8517031,5.0433634,6530.6508554,2855.8452639,7838.4195502,38.3517891,56.5608329,2.6492791,211.4093465),(448,'Syncerus-caffer-radius-cleaned.tif',245,3,104,881.6345882,115.7260784,135.2976644,1.8,115.425855,134.1994439,0.1907956,23.0589617,28.0931247,65052.1435104,186159.1054976,5.2844265,6626.5005155,2821.1219688,8240.6359045,36.8764827,56.4281781,2.6204545,201.7971113),(449,'Syncerus-caffer-radius-cleaned.tif',245,3,105,883.4823651,115.7382193,135.2862363,1.8,115.4774719,134.1527681,0.1964513,22.0750323,35.7357666,65722.7829374,184349.0631733,5.6099938,5158.671012,2977.2451495,6247.0404523,38.3046983,56.2039557,2.6274465,224.1612549),(450,'Syncerus-caffer-radius-cleaned.tif',245,3,106,872.2212421,115.7487973,135.4594137,1.8,115.4853203,134.3241582,0.1889375,22.1710616,28.0692055,64405.0219151,179947.373351,5.1278786,6410.8466901,2904.9137538,7638.2503195,37.9537575,55.7638527,2.6415974,197.5312947),(451,'Syncerus-caffer-radius-cleaned.tif',245,3,107,864.4537724,115.6801611,135.5231398,1.8,115.4492548,134.4457714,0.1909561,22.3282968,28.0322731,64250.7308133,176450.2656857,5.1900579,6294.5400548,2877.5473277,7526.9876502,37.9744625,57.3521084,2.5930433,201.5772181),(452,'Syncerus-caffer-radius-cleaned.tif',245,3,108,853.2117506,115.6890625,135.6972723,1.8,115.426299,134.6896454,0.183254,21.8995074,28.151222,63181.1155219,172718.7761626,4.7222122,6135.3917832,2885.0473383,7465.2530565,38.2461591,55.0243913,2.6152965,194.3272163),(453,'Syncerus-caffer-radius-cleaned.tif',245,3,109,844.2029517,115.6883782,135.8459203,1.8,115.4751197,134.845235,0.1751543,21.752321,27.581722,62435.6165902,169160.1767498,4.2725924,6133.0535095,2870.2967628,7796.6735732,0.4531251,0.6408157,2.3561945,1.2816314),(454,'Syncerus-caffer-radius-cleaned.tif',245,3,110,836.6678697,115.6378152,135.9933496,1.8,115.4300351,135.0965594,0.1682677,21.491215,27.5267852,61412.0451768,165772.9156069,3.9111159,6022.2403169,2857.5418023,7474.6438624,0.4531251,1.0132186,2.0344439,2.1878816),(455,'Syncerus-caffer-radius-cleaned.tif',245,3,111,829.3736992,115.58825,136.0996034,1.8,115.3482517,135.2550553,0.1620174,22.9513841,27.2466095,61057.910494,162932.6720528,3.5968231,5979.9246649,2660.3149659,7520.2266929,36.2336143,53.5013938,2.6665819,201.6871647),(456,'Syncerus-caffer-radius-cleaned.tif',245,3,112,820.7015045,115.5455624,136.1629104,1.8,115.2567474,135.3147042,0.1567366,19.8927475,26.9831867,60762.0137494,160175.1218536,3.3328491,5936.1084216,3054.4807213,7310.2604099,35.3437588,53.5013938,2.6665819,191.4985191),(457,'Syncerus-caffer-radius-cleaned.tif',245,3,113,817.7918377,115.5416969,136.1494069,1.8,115.2503863,135.2277562,0.1545153,21.0147873,26.9719216,60908.6777327,157304.1117303,3.2283127,5832.1432924,2898.3723103,7241.6037682,38.5156346,54.6800176,2.5329033,284.295796),(458,'Syncerus-caffer-radius-cleaned.tif',245,3,114,813.7874293,115.4430813,136.1419141,1.8,115.1239686,135.241505,0.1539734,21.0930236,26.9414945,60856.9919932,154782.8807108,3.1901887,5745.1482673,2885.1715716,7157.2816834,0.4531251,0.6408157,2.3561945,1.2816314),(459,'Syncerus-caffer-radius-cleaned.tif',245,3,115,808.5370875,115.3254867,136.1409616,1.8,114.9668215,135.2095861,0.1520492,22.0371675,26.5088422,61012.974657,152072.116199,3.0914878,5736.6562902,2768.6396007,6978.2763266,0.4531251,1.0132186,2.677945,1.922447),(460,'Syncerus-caffer-radius-cleaned.tif',245,3,116,803.9225606,115.2285099,136.1682169,1.8,114.8710958,135.3400049,0.1500256,20.3955859,26.2058307,61279.9246937,149500.472777,2.9931807,5704.8553271,3004.5680039,7116.6557149,36.7031342,53.3014597,2.693153,187.7180302),(461,'Syncerus-caffer-radius-cleaned.tif',245,3,117,798.5743484,115.1437658,136.190921,1.8,114.7814795,135.3762413,0.1483597,20.1626411,28.5592617,61422.6424652,147264.0431236,2.9080863,5156.4373266,3046.3589693,6009.2591918,2.4008177,13.2650394,1.4337302,36.0678436),(462,'Syncerus-caffer-radius-cleaned.tif',245,3,118,790.8294643,115.0526104,136.2184346,1.8,114.6018404,135.4708628,0.1441896,20.2098376,37.1406763,61466.7858932,145207.8225946,2.7213691,3909.670933,3041.4289941,5118.3891908,2.2150911,9.6867085,1.7590178,25.2383822),(463,'Syncerus-caffer-radius-cleaned.tif',245,3,119,784.8290736,114.9689339,136.244661,1.8,114.5795953,135.5515657,0.1390215,19.5458551,25.9374027,61639.45216,144216.2150133,2.5118182,5560.1640824,3153.5817583,7229.9281347,2.2656256,12.267897,1.6447354,33.879962),(464,'Syncerus-caffer-radius-cleaned.tif',245,3,120,775.4238159,114.9012893,136.2593474,1.8,114.6074214,135.6154959,0.1334565,19.6889365,25.8725598,61794.7118088,142784.4706937,2.288166,5518.760879,3138.5500035,7178.0299915,35.3437588,49.5794251,2.8256224,202.3091166),(465,'Syncerus-caffer-radius-cleaned.tif',245,3,121,771.5591512,114.8872391,136.2100529,1.8,114.5835445,135.5221142,0.1268986,19.6815229,25.9661832,62012.7520505,141649.1509863,2.0596783,5455.1394773,3150.8106487,7606.8817965,2.092561,11.8594191,1.4559197,30.1450145),(466,'Syncerus-caffer-radius-cleaned.tif',245,3,122,762.2988635,114.7707783,136.1995149,1.8,114.4063165,135.5117665,0.1233159,20.0782335,25.8452995,61997.7530862,140263.546766,1.9222476,5427.0428065,3087.8091501,7131.6521962,2.085746,12.760119,1.4640607,33.3490929),(467,'Syncerus-caffer-radius-cleaned.tif',245,3,123,753.1118697,114.6286542,136.1696949,1.8,114.1836706,135.4836082,0.11741,19.2383583,25.6933005,62181.1295647,138660.616417,1.7223503,5396.7615487,3232.143236,6889.8369992,2.0471638,13.2107537,1.4677147,33.5045809),(468,'Syncerus-caffer-radius-cleaned.tif',245,3,124,746.4583672,114.4538832,136.1143303,1.8,113.9841834,135.4054769,0.1122981,19.6665536,26.0582235,62508.609994,137894.3529802,1.5623307,5291.7787254,3178.4221757,6779.4023655,2.6584147,14.6128458,1.4464413,38.2557252),(469,'Syncerus-caffer-radius-cleaned.tif',245,3,125,742.8042512,114.2126095,135.9882504,1.8,113.8130991,135.2951716,0.1191426,19.878359,25.8184996,63548.4181305,138550.7505475,1.7490465,5366.3362574,3196.8644031,7419.7470255,35.7968839,49.7468643,2.7881524,177.3550327),(470,'Syncerus-caffer-radius-cleaned.tif',245,3,126,735.8395299,114.0204399,135.9167668,1.8,113.7450388,135.2795664,0.117382,19.8268447,25.5372138,64355.432962,138047.2192725,1.682051,5405.7275227,3245.8736571,7497.0112559,1.9197703,11.8160573,1.4940244,28.8633831),(471,'Syncerus-caffer-radius-cleaned.tif',245,3,127,729.273445,113.836154,135.8271452,1.8,113.5789609,135.2157244,0.1152261,19.0629286,25.9723771,65344.7850445,138040.0488218,1.6066369,5314.8792749,3427.8460846,7589.298901,2.4394525,12.7198281,1.4994889,34.2553431),(472,'Syncerus-caffer-radius-cleaned.tif',245,3,128,727.3012925,113.5872687,135.617659,1.8,113.36565,134.9868013,0.1258656,19.3557457,25.1129505,67567.9725547,139053.2383567,1.9102172,5537.1127582,3490.8483352,7806.2080935,1.9688957,12.7198281,1.4994889,31.802027),(473,'Syncerus-caffer-radius-cleaned.tif',245,3,129,719.4218288,113.5094691,135.5374703,1.8,113.2495263,134.8270638,0.1117706,25.2259404,30.2281654,67991.1001234,138100.2750194,1.4916897,4568.5959757,2695.2850494,5234.5740971,2.4611196,13.6239282,1.5042282,34.8961588),(474,'Syncerus-caffer-radius-cleaned.tif',245,3,130,709.2342929,113.360769,135.5028535,1.8,113.0534743,134.7727542,0.1035939,19.3408152,25.4315306,68254.0784703,137024.0587016,1.264016,5387.9595707,3529.017657,7648.2193199,2.5273284,14.076082,1.5063695,33.3946343),(475,'Syncerus-caffer-radius-cleaned.tif',245,3,131,702.1402184,113.1037448,135.3607973,1.8,112.7991155,134.6135056,0.1072617,21.6391038,26.23153,69775.8066298,137424.2566381,1.3412066,5238.8959653,3224.5238691,6742.4067959,2.6633877,16.984638,1.4100336,44.9293165),(476,'Syncerus-caffer-radius-cleaned.tif',245,3,132,694.3125831,112.9429235,135.2862492,1.8,112.7544544,134.5399331,0.0990279,21.9532512,25.5215814,70588.8978616,137420.1826293,1.1310946,5384.4697273,3215.4188617,6824.545736,0.4531251,0.6408157,2.3561945,1.2816314),(477,'Syncerus-caffer-radius-cleaned.tif',245,3,133,689.0155149,112.7260768,135.2479628,1.8,112.5705663,134.5268876,0.0932643,21.5890926,25.6052655,71661.0962059,137653.2881611,0.995977,5375.9758114,3319.3195044,7015.6029178,2.5185126,12.7198281,1.6421038,32.0674615),(478,'Syncerus-caffer-radius-cleaned.tif',245,3,134,686.8039441,112.5106532,135.1272639,1.8,112.3278324,134.3420252,0.0913318,21.7693286,25.3371322,73368.1575945,138413.5749663,0.9521775,5462.8745642,3370.2535714,7229.2748431,2.4413546,13.7812623,1.4056476,39.6473031),(479,'Syncerus-caffer-radius-cleaned.tif',245,3,135,684.0599662,112.3290123,135.0599912,1.8,112.1387309,134.3318441,0.0869977,20.2809173,25.492962,75176.1548354,139682.1609445,0.8607219,5479.2440709,3706.7433218,7768.6756987,1.8125005,7.9134899,1.801887,23.5358284),(480,'Syncerus-caffer-radius-cleaned.tif',245,3,136,684.8773359,112.1524933,134.9790006,1.8,111.8738691,134.2684794,0.0844281,20.3513311,25.5170037,77010.1692014,141337.4234254,0.8117141,5538.9506232,3784.03598,7954.4363163,1.3593753,3.8715027,1.929567,9.5022886),(481,'Syncerus-caffer-radius-cleaned.tif',245,3,137,687.3717538,112.0836691,134.8111156,1.8,111.8088721,133.8889554,0.0864336,20.4607758,25.7744843,79444.6440839,143003.9958973,0.8537364,5548.2776737,3882.7777014,7093.1924699,2.8910467,17.3138863,1.4659194,47.4925793),(482,'Syncerus-caffer-radius-cleaned.tif',245,3,138,681.6489838,111.9480383,134.6821613,1.8,111.7164995,133.7586836,0.0811744,20.8828475,25.8403177,81021.1926668,143361.7280124,0.7469524,5547.9862703,3879.796223,7052.8256382,1.8125005,2.4401534,1.9513027,6.9390259),(483,'Syncerus-caffer-radius-cleaned.tif',245,3,139,674.9924949,111.8153552,134.6089026,1.8,111.6560898,133.7100982,0.0753915,21.538997,25.992129,82437.1691023,143594.4711884,0.6382187,5524.5367172,3827.3448349,7137.1966678,3.0707458,18.7157677,1.4494443,49.4605677),(484,'Syncerus-caffer-radius-cleaned.tif',245,3,140,672.8399076,111.6024858,134.4842818,1.8,111.4205045,133.7103622,0.0827155,21.1765958,35.5771462,84806.3561182,144934.682424,0.7654969,4073.8141701,4004.7209182,5667.8261992,3.1220235,19.165639,1.4523064,49.3050797),(485,'Syncerus-caffer-radius-cleaned.tif',245,3,141,666.7049997,111.4297878,134.3675061,1.8,111.1276764,133.6469058,0.0788616,21.4142653,26.608174,86353.7014683,145711.1480636,0.6896242,5476.1799201,4032.5315927,8248.6041251,2.4714503,11.4722116,1.7294516,29.9895265),(486,'Syncerus-caffer-radius-cleaned.tif',245,3,142,661.2421803,111.3027945,134.2299298,1.8,110.9475573,133.4869928,0.0838561,21.862672,26.5675337,88344.1431113,146823.0384447,0.7731447,5526.4082903,4040.8666952,7644.0617264,3.0983088,19.5685006,1.47804,57.1048145),(487,'Syncerus-caffer-radius-cleaned.tif',245,3,143,661.1128894,111.1618078,134.145352,1.8,110.7385007,133.6365785,0.0884383,22.097909,26.303687,90781.0550591,149236.4584495,0.8595527,5673.5946769,4108.1287413,8214.0294892,40.4130413,51.0284065,2.9720644,182.7281289),(488,'Syncerus-caffer-radius-cleaned.tif',245,3,144,665.331953,110.9993251,134.0095412,1.8,110.4283152,133.6942896,0.0914884,22.5135766,27.5479154,93246.4184823,152580.4083311,0.9255666,5538.7279317,4141.786085,8192.8208271,1.0031972,2.6421507,2.1112158,5.6573945),(489,'Syncerus-caffer-radius-cleaned.tif',245,3,145,665.7610146,110.8003982,133.7635122,1.8,110.4316753,133.3643876,0.1026296,22.8880931,27.5495348,96081.3338898,155156.8551907,1.1646267,5631.9228663,4197.8741355,8328.1633233,41.488806,54.9478428,2.7702744,249.418501),(490,'Syncerus-caffer-radius-cleaned.tif',245,3,146,664.3267445,110.6207742,133.7412676,1.8,110.2510914,133.4355044,0.1111725,23.0069077,27.2033307,98104.6089623,157185.1310499,1.3628106,5778.1575671,4264.1371185,8433.5125658,41.9305566,53.4188195,2.537121,225.0219638),(491,'Syncerus-caffer-radius-cleaned.tif',245,3,147,662.0812644,110.3569774,133.6810082,1.8,109.9992543,133.2811058,0.1319902,23.5282815,27.6708745,100122.8846528,159926.696265,1.9112601,5779.6039784,4255.4270113,8491.3353332,42.4181259,55.5424935,2.7034869,243.8255117),(492,'Syncerus-caffer-radius-cleaned.tif',245,3,148,661.1966983,110.137279,133.6747222,1.8,109.8404076,133.2830179,0.1427638,23.8397376,27.7853549,102405.2614943,163275.0306938,2.2308127,5876.298179,4295.5699934,8585.0793984,43.3369514,55.0971071,2.5969419,244.6484929),(493,'Syncerus-caffer-radius-cleaned.tif',245,3,149,663.093317,109.9471885,133.6565661,1.8,109.7563436,133.2200325,0.1559009,23.9702782,28.6906282,105476.5638309,167414.7775261,2.6643982,5835.1729422,4400.3062015,8566.7257795,43.642729,57.7623449,2.6954871,251.7618706),(494,'Syncerus-caffer-radius-cleaned.tif',245,3,150,671.6142575,109.7808399,133.5793778,1.8,109.5226652,133.0387273,0.1599661,24.2389771,28.95527,109777.4649325,172714.938501,2.8399914,5964.8878616,4528.964425,8969.3897143,0.8110345,1.6337658,2.1587989,3.4695129),(495,'Syncerus-caffer-radius-cleaned.tif',245,3,151,687.1908212,109.6992945,133.4400299,1.8,109.3222906,132.8655455,0.1611993,24.5946048,30.0729441,115734.9282932,179965.84162,2.9504442,5984.3107129,4705.7039308,9109.8596491,44.6483839,56.965955,2.5888955,234.3687644),(496,'Syncerus-caffer-radius-cleaned.tif',245,3,152,708.2512965,109.5821878,133.1675616,1.8,109.2360236,132.6749288,0.1664841,26.2146062,32.8049831,122736.2086605,188701.8014157,3.2416441,5752.229804,4681.9779614,7424.7910274,45.4936501,57.8369434,2.5231647,248.5577922),(497,'Syncerus-caffer-radius-cleaned.tif',245,3,153,732.7955324,109.561892,132.9214223,1.8,109.1921044,132.2862673,0.183046,25.4074334,31.453518,130743.4912523,198023.3651479,4.0466568,6295.7461663,5145.8755818,9828.2979827,0.4531251,1.0132186,2.0344439,2.1878816),(498,'Syncerus-caffer-radius-cleaned.tif',245,3,154,751.5550284,109.4896881,132.7715355,1.8,108.9751046,131.9316683,0.2123977,25.8146513,32.0337485,136100.8867132,207227.2757391,5.5663267,6469.0298654,5272.2341644,9998.2030071,0.4531251,1.0132186,2.0344439,2.1878816),(499,'Syncerus-caffer-radius-cleaned.tif',245,3,155,768.5196957,109.4420739,132.5408765,1.8,108.770562,131.5306083,0.2414577,26.4377653,33.9514621,141924.9231935,218408.8550502,7.3236778,6432.9734742,5368.2647297,8993.5086683,1.2816314,2.5632627,2.3561945,5.6573945),(500,'Syncerus-caffer-radius-cleaned.tif',245,3,156,792.383879,109.2477384,132.266257,1.8,108.4652545,131.222697,0.2865646,26.2407436,35.6095464,147532.1750314,234469.7397749,10.5513706,6584.4629653,5622.2558897,9387.7784728,48.4604225,64.434646,2.5009045,235.0739853),(501,'Syncerus-caffer-radius-cleaned.tif',245,3,157,814.5522241,109.0230061,131.9367489,1.8,108.2487326,130.7369422,0.3215053,26.7782342,35.5288062,152532.246023,251550.9696109,13.5559021,7080.1976377,5696.1278698,10270.2073861,48.914467,65.8919327,2.482962,262.4091664),(502,'Syncerus-caffer-radius-cleaned.tif',245,3,158,831.8022895,108.8339587,131.6355764,1.8,107.891021,130.4254873,0.3264051,31.054142,40.4571787,156407.4901217,266377.0526095,14.2529352,6584.172721,5036.6063896,9993.2250846,0.8834673,3.8979296,2.1910458,8.2206573),(503,'Syncerus-caffer-radius-cleaned.tif',245,3,159,846.2056536,108.6498493,131.2627564,1.8,107.6021618,130.0886074,0.3322589,30.0042233,40.3962221,160416.3189293,283073.3774719,15.0050441,7007.4220563,5346.4579673,10213.2499186,0.8834673,3.2675317,2.1587989,6.9390259),(504,'Syncerus-caffer-radius-cleaned.tif',245,3,160,857.3680975,108.5077747,130.9841048,1.8,107.2774594,129.8138526,0.3118518,40.8332656,39.1578668,162490.0575892,296514.4258422,13.4520402,7572.2824071,3979.3549458,10711.6824428,1.0031972,3.0396557,2.0344439,6.5636448),(505,'Syncerus-caffer-radius-cleaned.tif',245,3,161,897.8861648,107.7702936,129.6157812,1.8,106.5146806,128.3597597,0.4073767,40.81598,41.7452535,175951.4173472,340724.8807857,23.491107,8162.0029067,4310.8463248,11527.6155405,0.4531251,1.8682827,1.815775,4.000382),(506,'Syncerus-caffer-radius-cleaned.tif',245,3,162,901.6822643,107.7947788,129.3985043,1.8,106.4329262,128.2225907,0.3782975,30.635386,43.2598068,178134.8222793,348250.40895,20.4999284,8050.2072192,5814.675292,11216.5972485,1.0031972,2.2656256,2.2142974,4.7511443),(507,'Syncerus-caffer-radius-cleaned.tif',245,3,163,912.6439278,107.3822187,128.4901156,1.8,105.8732401,127.4512755,0.4067681,27.8873585,45.2177956,185298.2925351,375425.2563957,23.8098946,8302.5997127,6644.5264928,11831.4875143,0.8121848,2.2656256,2.2142974,4.7511443),(508,'Syncerus-caffer-radius-cleaned.tif',245,3,164,917.0235161,107.2022903,127.9940625,1.8,105.6750487,127.0936246,0.3898453,28.0536244,45.8876353,187477.2825155,394048.7990935,22.0749654,8587.2544202,6682.8185904,12136.4867136,0.9612235,1.922447,2.3561945,3.8448941),(509,'Syncerus-caffer-radius-cleaned.tif',245,3,165,926.8126022,107.0156601,127.5056865,1.8,105.6203149,126.7901135,0.3708886,40.4284911,45.629814,190595.8529126,414245.0418922,20.2918674,9078.3855019,4714.3944179,12652.1226704,54.4699693,81.2762976,2.6978925,337.90442),(510,'Syncerus-caffer-radius-cleaned.tif',245,3,166,956.3120135,106.2358931,126.2852728,1.8,105.2747438,126.0179363,0.4057715,41.4503501,45.4211639,201826.2040217,460369.3175453,24.833832,10135.5684904,4869.1073422,14043.3953958,0.8110345,2.0264371,2.0344439,4.3757632),(511,'Syncerus-caffer-radius-cleaned.tif',245,3,167,968.4611869,105.9984658,125.6186145,1.8,105.6092933,125.7799458,0.3914107,37.3925746,44.9729776,208221.9830459,483106.2582544,23.491119,10742.1452663,5568.5382831,14856.0242721,55.1921166,84.2861432,2.8470463,281.7058557),(512,'Syncerus-caffer-radius-cleaned.tif',245,3,168,957.0666043,107.001291,126.0973179,1.8,106.8006203,126.3223616,0.2840873,36.1410274,44.5622314,205000.0533895,470894.8031232,12.5308209,10567.1279998,5672.2253999,14329.7813146,0.4531251,1.0132186,2.0344439,2.1878816),(513,'Syncerus-caffer-radius-cleaned.tif',245,3,169,1012.2186812,106.7802325,125.5697467,1.8,107.7160134,126.06149,0.2586613,41.2794909,43.1742169,215510.9936764,517344.8904619,11.0377007,11982.7278271,5220.776447,15824.458462,54.7119401,87.1886195,2.7803889,284.6256357),(514,'Syncerus-caffer-radius-cleaned.tif',245,3,170,1094.0869313,106.3294793,125.1527452,1.8,108.336085,125.7585204,0.2410059,30.6551843,44.4488518,231905.9013507,555718.8720983,10.3879797,12502.4348176,7564.9814771,17013.4425205,1.3593753,2.4401534,1.9513027,6.5636448),(515,'Syncerus-caffer-radius-cleaned.tif',245,3,171,1150.7429634,107.0818713,125.3234593,1.8,108.9643774,125.5658405,0.2092109,30.6804665,43.9954678,249695.8373028,575806.857081,8.2727561,13087.8675827,8138.5932503,17569.9554736,57.0816132,87.767188,2.7495815,316.0067402),(516,'Syncerus-caffer-radius-cleaned.tif',245,3,172,1185.1214564,108.0310944,124.9060052,1.8,109.304074,124.9939308,0.2239489,30.4213095,44.9925405,271539.0813136,598399.557301,9.7417462,13299.9726412,8925.9498019,17230.3041404,0.4531251,1.0132186,2.0344439,2.1878816),(517,'Syncerus-caffer-radius-cleaned.tif',245,3,173,1222.727928,108.8039775,123.7580655,1.8,109.0584908,124.5806953,0.2511143,31.1136402,44.6577652,278449.7419205,636422.9359194,12.5826901,14251.1147441,8949.4427684,18440.5023014,0.4531251,0.6408157,2.3561945,1.2816314),(518,'Syncerus-caffer-radius-cleaned.tif',245,3,174,1235.6996353,108.1649652,122.591107,1.8,108.8850241,124.2134978,0.2890231,32.3947415,45.6154819,271249.4005253,640396.9763202,16.7301635,14039.0268627,8373.2540476,17911.3733008,57.8447011,86.3949307,2.6380601,353.9970309),(519,'Syncerus-caffer-radius-cleaned.tif',245,3,175,1112.7567076,108.9041904,124.9546144,1.8,109.9899275,125.8026497,0.20889,35.3101605,41.6558709,206860.3296826,509487.7085456,7.9755054,12230.8739956,5858.379768,14802.8293116,0.4531251,0.6408157,2.3561945,1.2816314),(520,'Syncerus-caffer-radius-cleaned.tif',245,3,176,1011.2628122,108.8127671,126.4059278,1.8,109.9329841,126.8623206,0.2019893,38.6770843,41.28332,158277.2504968,438633.8345404,6.7835173,10624.9651064,4092.2746188,12568.7267008,0.4531251,2.7562525,1.735945,5.8128825),(521,'Syncerus-caffer-radius-cleaned.tif',245,3,177,952.877468,110.0780544,127.0961807,1.8,110.9299426,127.1338854,0.1373066,30.1582544,39.1053312,121245.6179607,384868.4656034,2.9753477,9841.8413457,4020.312863,10959.5652686,1.1797479,3.4508981,1.9756881,7.8452761),(522,'Syncerus-caffer-radius-cleaned.tif',245,3,178,918.0993431,110.9157694,127.0023841,1.8,112.3005683,127.0571924,0.1193812,26.0654263,37.9229154,99906.9761205,350509.4798557,2.17043,9242.682853,3832.9308321,9876.9491354,0.4531251,0.6408157,2.3561945,1.2816314),(523,'Syncerus-caffer-radius-cleaned.tif',245,3,179,898.8116087,111.7283528,126.1688577,1.8,113.6313793,125.9280982,0.1370932,23.0398881,37.2317232,85468.073643,316704.626619,2.7978642,8506.3112689,3709.5698251,10662.327394,44.0852833,72.096748,2.8874679,257.0172064),(524,'Syncerus-caffer-radius-cleaned.tif',245,3,180,810.396126,115.0454372,126.1318426,1.8,115.3350582,125.3736737,0.1261064,22.4732195,38.4800872,74912.6329931,238427.7048309,2.1365684,6196.1321404,3333.4179441,8078.2803247,40.6637277,68.9137604,2.8822609,269.3748699),(525,'Syncerus-caffer-radius-cleaned.tif',245,3,181,702.3125026,119.9190045,126.3954101,1.8,119.3710132,125.5603315,0.1787377,20.0566997,41.1355374,63709.1953642,130195.5986214,3.699828,3165.0394507,3176.4545661,4709.5400544,39.5110435,55.9476497,0.1544966,210.1921204),(526,'Syncerus-caffer-radius-cleaned.tif',245,3,182,599.7144706,122.4226177,126.3182982,1.8,121.7081701,125.7250232,0.1599074,19.0776207,24.6074781,46239.3150902,87988.7463416,2.5341111,3575.6913382,2423.7464254,5153.2114447,35.8557858,49.0401968,2.5202691,169.638567),(527,'Syncerus-caffer-radius-cleaned.tif',245,3,183,461.0730924,125.7084617,125.4447737,1.8,124.5912583,125.1377829,0.3225072,16.7825677,24.0900546,28353.753848,52363.6201851,7.7194713,2173.6613319,1689.4765052,3307.2433208,33.0781333,44.7883862,0.1934273,160.3106302),(528,'Syncerus-caffer-radius-cleaned.tif',245,3,184,379.3497501,127.7730187,124.9772231,1.8,126.7688965,124.8469054,0.5580642,15.0564356,37.3674343,16852.1871125,31155.1930235,17.7294175,833.7525326,1119.268038,1246.2528237,29.6169147,41.2044981,0.1434523,147.539858),(529,'Syncerus-caffer-radius-cleaned.tif',245,3,185,222.6041654,130.377563,125.6745088,1.8,128.9953013,124.6865338,0.7869184,11.743296,18.9159441,5598.8566597,12730.194966,18.6067477,672.9875533,476.7704635,853.9554209,24.030588,34.6781359,3.0237206,118.4754455),(530,'Syncerus-caffer-radius-cleaned.tif',245,3,186,75.6711233,134.0534162,128.8019595,1.8,133.6940661,128.5889304,-0.8870258,6.7431225,9.6887439,435.6550423,1378.360683,7.5788324,142.2641267,64.6073151,184.6549368,11.88689,19.958091,0.8818719,52.5546995),(531,'Syncerus-caffer-radius-cleaned.tif',245,3,187,13.763505,134.7618782,129.2500103,1.8,134.5332368,129.3105792,-0.7429021,2.7657611,6.1027585,15.6826864,98.0969786,1.0495935,16.074203,5.6702969,18.0695575,5.4226996,12.5328214,0.8621701,29.9439852),(532,'Syncerus-caffer-radius-cleaned.tif',245,3,188,11.6054424,90.7783301,138.6174671,1.8,90.7826724,138.6138042,-1.1016268,5.5558659,5.5797131,76.8559446,79.3271298,1.5388125,14.2170625,13.8332972,27.6053949,11.3281278,11.8939948,0.8663023,37.4594215),(533,'Syncerus-caffer-radius-cleaned.tif',245,3,189,62.9503449,92.2997618,138.8738941,1.8,93.965975,139.2102921,0.2112052,9.4744023,27.4650249,1152.2928993,3216.817747,0.4610935,117.124152,121.6216979,154.9267634,19.0312548,19.6104257,0.7036138,62.5878572),(534,'Syncerus-caffer-radius-cleaned.tif',245,3,190,400.742101,113.6234772,139.3851932,1.8,110.9689521,138.7694803,0.045909,15.3267798,34.4070473,17974.4807677,90215.6674436,0.1406709,2622.0113185,1172.7499864,3143.1864108,23.5625059,23.9642789,1.3028859,77.2622126),(535,'Syncerus-caffer-radius-cleaned.tif',245,3,191,598.0241075,116.3239076,138.783167,1.8,109.2875443,138.768216,0.0095109,15.238665,38.403097,29094.6298682,147579.7343289,0.0090157,3842.912312,1909.2636982,4596.6635436,26.2734429,26.7497374,0.8934099,87.0299358),(536,'Syncerus-caffer-radius-cleaned.tif',245,3,192,624.4119516,115.2076862,138.8163622,1.8,108.2240484,138.7761973,0.0108341,19.1413035,38.1906379,31204.5197226,163682.9668768,0.0122145,4285.9448222,1630.2191629,5100.8796623,27.6406319,28.2903975,1.0138948,91.1858058),(537,'metacarpus.tif',245,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(538,'metacarpus.tif',245,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(539,'metacarpus.tif',245,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(540,'metacarpus.tif',245,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(541,'metacarpus.tif',245,5,5,4.8514102,57.5930317,53.7322347,1.8,57.5272422,53.3371637,-1.554276,1.3051226,7.8458047,1.4514372,75.9723725,0.8083477,9.6831843,1.1121079,9.8677604,2.728517,15.163363,1.5053163,33.6948586),(542,'metacarpus.tif',245,5,6,52.292494,56.5879675,52.6660214,1.8,56.0902363,52.4441501,1.5412727,4.3839409,11.8200638,131.4000427,1182.6449218,8.7078211,100.0540221,29.9730418,111.0019029,8.3343471,21.6128521,1.7321714,53.20848),(543,'metacarpus.tif',245,5,7,119.2220193,55.350704,52.2022419,1.8,55.1503047,53.2548479,1.3762502,7.564121,20.1266155,907.1527852,4924.6587678,19.1277203,244.6838999,119.9283814,287.571269,14.6347731,32.6443425,1.8637087,92.526328),(544,'metacarpus.tif',245,5,8,373.7802482,60.1528132,59.5291677,1.8,60.1360296,59.8959798,0.8285659,20.5710596,25.5449014,14007.7904919,57181.8435136,33.8342235,2238.4836219,680.9464747,2786.8405139,31.413488,50.5164025,2.4745203,258.2829494),(545,'metacarpus.tif',245,5,9,753.1986544,56.0301023,60.523763,1.8,51.3114674,60.7185029,0.2894241,22.5156945,37.6704633,64815.9203629,185744.1655919,10.2250936,4930.7640346,2878.6995847,6258.8948264,39.4518391,68.2129255,2.8577985,298.3668438),(546,'metacarpus.tif',245,5,10,1066.66664,49.6060837,60.4308378,1.8,49.0886327,61.1093313,0.1588723,33.7496535,37.0432974,110766.0946434,367218.0523806,4.4495572,9913.2117776,3281.9920561,11626.1205665,41.9826612,70.6232984,2.5867163,478.1344699),(547,'metacarpus.tif',245,5,11,1141.698511,47.9190456,60.5636249,1.8,48.952203,61.5990042,0.1885232,33.7630635,39.5872586,131961.8202257,429089.225371,6.6831058,10839.0739896,3908.4670163,13566.6202154,0.744141,1.4463501,1.0303768,3.0969366),(548,'metacarpus.tif',245,5,12,1129.5452628,48.318635,60.8858609,1.8,48.9446484,61.9110694,0.2088612,34.0657206,40.0019574,131951.1126475,438202.7649806,8.0936362,10954.5330539,3873.4279051,13659.3585296,1.5823804,5.7694261,1.1263771,14.9885891),(549,'metacarpus.tif',245,5,13,1139.8162786,48.5193529,61.0907237,1.8,49.0424089,62.185435,0.2168877,24.1167272,40.2547247,131526.61601,448117.6059684,8.7969688,11132.0499571,5453.7506321,13816.1266909,43.7184827,74.9118373,2.7401791,392.7279679),(550,'metacarpus.tif',245,5,14,1158.6783533,48.4116716,61.0718427,1.8,48.8943974,62.2655117,0.2150681,25.2229179,41.8049536,135156.7145819,461504.9153192,8.7954307,11039.4791903,5358.4884592,13946.285845,42.1080076,75.2576402,2.7133285,351.344905),(551,'metacarpus.tif',245,5,15,1147.1388867,48.2103709,61.065246,1.8,48.9065453,62.2871578,0.2089335,25.1298111,41.3438693,138292.7653321,466458.2576702,8.2253101,11282.4045272,5503.1358977,14149.7238687,43.1963585,75.5403921,2.8104966,365.1753508),(552,'metacarpus.tif',245,5,16,1128.1020557,47.9259795,60.9835903,1.8,48.8316471,62.2603092,0.1993618,28.5340023,41.3253434,139452.4104144,457933.4928458,7.3742809,11081.1781649,4887.236244,13996.9477532,0.6530486,2.828171,1.3045443,6.4844784),(553,'metacarpus.tif',245,5,17,1114.1624272,47.584352,60.8088763,1.8,48.7397703,62.1303076,0.1907621,26.1242496,41.4595501,139356.7968806,441467.3751105,6.675856,10648.1467778,5334.3846771,13588.6012658,1.488282,3.068172,1.3258177,8.5290407),(554,'metacarpus.tif',245,5,18,1099.7085236,47.300667,60.6770839,1.8,48.6141135,62.0263557,0.1880239,26.8245692,41.258746,138057.0556272,422393.30547,6.4036651,10237.667068,5146.6644019,13243.323515,0.496094,0.8943462,0.5880026,1.7539572),(555,'metacarpus.tif',245,5,19,1087.8395129,47.3510846,60.5179082,1.8,48.4307181,61.8690844,0.1986434,26.2910234,40.8504749,137397.6839816,405604.7632075,7.0606033,9929.0097446,5226.03026,13026.6930561,44.998878,73.4072462,2.9408837,442.4844425),(556,'metacarpus.tif',245,5,20,1067.3474304,47.5852186,60.3669136,1.8,48.2717343,61.6143503,0.2182895,25.1608363,40.2670978,134441.9072333,388188.3664582,8.3427873,9640.3363372,5343.3004203,12785.5726215,45.1690111,71.9323475,2.8296564,366.9207533),(557,'metacarpus.tif',245,5,21,1033.3655027,47.6635343,60.11319,1.8,48.1747435,61.2877105,0.2252368,26.5204455,39.4790329,128859.7702925,362112.8146251,8.5906292,9172.2817985,4858.8840725,12256.5171672,45.2625063,71.144533,2.8187396,436.8030387),(558,'metacarpus.tif',245,5,22,1002.41827,47.8297958,59.9542635,1.8,48.1446893,61.0045749,0.2231421,28.6586057,38.6911897,121864.2382102,336919.9760682,8.1816441,8707.9249403,4252.2738066,11708.0542781,44.6408965,69.6181815,2.7849071,400.3559858),(559,'metacarpus.tif',245,5,23,970.4136811,47.8634216,60.0522118,1.8,48.1769992,60.9883889,0.2151116,26.6442635,37.8504427,114431.463586,311598.6442995,7.3692663,8232.3645931,4294.7880123,11154.4697269,43.8028124,67.6736594,2.778103,401.7238953),(560,'metacarpus.tif',245,5,24,929.665781,47.8076088,60.3174956,1.8,48.167508,61.1368572,0.1959434,33.63878,37.3145913,104564.9070606,287124.5018505,5.8731547,7694.6977537,3108.4631199,10464.9823775,40.4155901,66.3102524,2.8494193,397.7697469),(561,'metacarpus.tif',245,5,25,893.085853,48.0004067,60.629115,1.8,48.363583,61.3613125,0.1740559,25.0512946,35.9052955,95633.2047464,263860.9636443,4.4640529,7348.8035742,3817.4955189,9937.646311,39.8297551,64.5093907,2.7882225,346.2094551),(562,'metacarpus.tif',245,5,26,861.7530119,48.2018463,60.8962962,1.8,48.5633154,61.5357749,0.1507319,23.3100006,34.6749914,89500.3691864,243393.0168088,3.2385493,7019.2668193,3839.5695773,9543.0760673,39.1914263,62.6734819,2.8235968,256.0767091),(563,'metacarpus.tif',245,5,27,836.3491665,48.3414678,61.2176819,1.8,48.7534229,61.7945427,0.1150288,23.7123726,33.9530974,84391.8178849,227168.5157348,1.836256,6690.6566206,3558.978228,9155.5907293,38.1135004,61.0321652,3.1212702,233.4807548),(564,'metacarpus.tif',245,5,28,815.3290118,48.5747887,61.4581314,1.8,49.0389763,62.0409266,0.0864848,22.0215388,33.3641218,79434.0765856,214829.813042,1.0138613,6438.9470348,3607.1083497,8797.1610771,2.5588281,18.4090318,1.3258177,56.7267207),(565,'metacarpus.tif',245,5,29,794.0926539,48.8198902,61.5241211,1.8,49.2153903,62.1472921,0.0700657,21.4461315,32.8237678,74681.5766561,204029.7414389,0.6486651,6215.9147263,3482.2866074,8457.9759324,0.496094,0.8943462,2.5535901,1.7539572),(566,'metacarpus.tif',245,5,30,775.4648304,49.0573392,61.5270229,1.8,49.4464197,62.2131939,0.0615964,20.09018,32.0198097,70522.674493,194280.5170457,0.489749,6067.5100493,3510.3057479,8208.8124826,2.1549367,11.4344018,1.3521274,32.7731833),(567,'metacarpus.tif',245,5,31,761.9671172,49.3178673,61.5301309,1.8,49.7005171,62.2372624,0.0594227,19.9621953,31.2735873,67181.1134829,186539.5239177,0.4478967,5964.762608,3365.4171063,8053.9842293,1.758599,10.8971427,1.3644724,28.5636861),(568,'metacarpus.tif',245,5,32,750.4316032,49.5422608,61.5155431,1.8,49.8246063,62.1805406,0.0607995,19.5749977,30.6194937,64540.1940876,179986.5594771,0.4617687,5878.1690203,3297.0728849,7904.427966,2.2813665,18.5356016,1.2998495,42.8403659),(569,'metacarpus.tif',245,5,33,742.9526411,49.8192906,61.4503024,1.8,50.0964782,62.149006,0.0693632,20.7697461,30.1664468,61870.4943952,173249.2226875,0.5948002,5743.1100077,2978.8758165,7720.1143318,1.4758759,11.7318628,1.3360737,25.6971683),(570,'metacarpus.tif',245,5,34,732.4164426,49.9394649,61.4329659,1.8,50.1566346,62.1263249,0.0729482,19.6910523,30.0207989,59494.8804832,166504.4023701,0.648434,5546.3015198,3021.4170193,7525.7159521,2.2925959,15.8827577,1.3182421,41.4475265),(571,'metacarpus.tif',245,5,35,721.5461695,50.0394638,61.4115267,1.8,50.2441727,62.1097854,0.072889,19.9121393,28.8898861,57402.158805,160025.2980008,0.6377747,5539.1460329,2882.7720617,7345.184818,0.496094,2.7732498,1.7506498,6.0735006),(572,'metacarpus.tif',245,5,36,710.1395087,50.0923839,61.396361,1.8,50.3286493,62.1016241,0.0694937,20.2285841,28.678287,55654.0669326,152640.3826699,0.5706691,5322.5069709,2751.2586527,7171.9321484,2.0740748,11.9989132,1.4464413,28.9643374),(573,'metacarpus.tif',245,5,37,701.3265225,50.2425399,61.4159454,1.8,50.4570234,62.1134877,0.0719257,18.7156589,28.1460228,54241.6655784,147349.9849462,0.6036536,5235.1973864,2898.1969524,7158.4159891,1.3879764,4.4923223,1.4601391,12.6783516),(574,'metacarpus.tif',245,5,38,694.2127902,50.3209206,61.4354036,1.8,50.5171691,62.1336922,0.0713277,18.8850824,27.3425068,53243.0343759,143033.3406477,0.5876528,5231.1714371,2819.3170308,7139.705601,1.4781227,9.7467007,1.3134726,22.7206043),(575,'metacarpus.tif',245,5,39,689.3396404,50.3942275,61.4743775,1.8,50.6244144,62.1782108,0.0699518,18.4917654,26.9632536,52298.4239369,139670.3721563,0.5612698,5180.0266387,2828.2007062,7018.865515,1.4080029,9.5425587,1.4141944,21.9588351),(576,'metacarpus.tif',245,5,40,683.6298124,50.460182,61.5148559,1.8,50.6494327,62.1914639,0.0677748,20.1880883,26.4790443,51419.9957488,136521.081836,0.5225667,5155.8160543,2547.0463125,6996.0530603,1.2075129,5.0164402,1.4219064,11.9165824),(577,'metacarpus.tif',245,5,41,679.7568357,50.5838006,61.504312,1.8,50.7684656,62.2046179,0.0641104,21.882097,26.4004683,50552.6393963,132969.1062991,0.4650119,5036.6192213,2310.2282802,6854.525748,0.496094,0.8943462,2.1587989,1.8992597),(578,'metacarpus.tif',245,5,42,675.059915,50.609782,61.5579654,1.8,50.8061867,62.2894551,0.0618705,18.1451803,25.9536338,49790.3001192,130124.4172419,0.4301333,5013.7263408,2743.9958892,6731.471628,1.6959856,10.0328803,1.4219064,23.5073034),(579,'metacarpus.tif',245,5,43,671.9012891,50.6233972,61.6160021,1.8,50.8156599,62.3423606,0.0579662,20.7130738,26.3472327,49208.6897972,127711.524657,0.375852,4847.2462344,2375.7309136,6604.851718,2.0677227,13.090209,1.3994172,32.2418329),(580,'metacarpus.tif',245,5,44,668.1605775,50.6353256,61.662987,1.8,50.8471253,62.3584206,0.0526479,17.7061801,25.8893915,48661.6936641,125366.8634937,0.3083826,4842.402854,2748.2886494,6583.3752935,1.7843062,11.2499639,1.3258177,27.5113117),(581,'metacarpus.tif',245,5,45,665.9729086,50.6985413,61.7259209,1.8,50.9481315,62.3806525,0.0486722,17.6388922,26.2513223,48250.0558261,123566.0849612,0.2627388,4707.0423191,2735.4357241,6543.8720879,1.5274553,11.9989132,1.4464413,28.0572657),(582,'metacarpus.tif',245,5,46,662.0107359,50.7793444,61.8024394,1.8,51.0034147,62.4639601,0.046926,17.7188166,25.5973218,47703.1779312,121864.44438,0.2427844,4760.8279197,2692.2327239,6420.3559264,0.248047,0.55465,2.0344439,1.1976769),(583,'metacarpus.tif',245,5,47,658.4563775,50.8408118,61.8587483,1.8,51.083155,62.4499453,0.0427831,17.5983498,25.4521367,47134.1081818,119940.8965409,0.2007504,4712.4097209,2678.3254508,6379.1486857,1.5725335,11.6185597,1.2895641,27.0152177),(584,'metacarpus.tif',245,5,48,654.7257899,50.938675,61.9189649,1.8,51.1475198,62.5075847,0.0422432,17.3629854,25.4445858,46520.3333866,118110.5054471,0.1946098,4641.8718126,2679.2819579,6335.0044228,0.248047,0.3507914,2.3561945,0.7015829),(585,'metacarpus.tif',245,5,49,652.9313551,51.0857867,61.9535228,1.8,51.3357961,62.6013887,0.0395508,17.3829265,25.1944623,45908.4431913,115899.1022131,0.170137,4600.1816072,2641.0077333,6262.653614,1.7433547,8.7240638,1.3120254,25.9980998),(586,'metacarpus.tif',245,5,50,649.6325028,51.1572217,62.0202962,1.8,51.3800174,62.6658991,0.0350897,19.56403,25.1080543,45346.089143,114310.5256891,0.1332591,4552.7432801,2317.8296672,6212.5464654,2.3741386,15.6427022,1.3142797,40.3598959),(587,'metacarpus.tif',245,5,51,647.0633832,51.239887,62.0875863,1.8,51.5022441,62.7111054,0.0301538,17.5776258,24.8969321,44896.5431385,113132.3407581,0.0980275,4544.0273697,2554.1869954,6104.9856138,0.248047,0.3507914,2.3561945,0.7015829),(588,'metacarpus.tif',245,5,52,645.0828748,51.2822483,62.1451384,1.8,51.5338935,62.7297263,0.0244414,17.0995421,25.0029825,44443.0995482,112392.0781076,0.0642136,4495.1468561,2599.081267,6140.7466936,1.7172314,9.7530113,1.4432868,26.6644263),(589,'metacarpus.tif',245,5,53,643.0012566,51.3272656,62.1950525,1.8,51.6054456,62.8006842,0.0192251,17.2432507,25.1441174,44028.9771813,111711.0853652,0.0396048,4442.8318429,2553.4035263,6111.071043,1.240235,5.7266097,1.6575347,12.7883978),(590,'metacarpus.tif',245,5,54,642.4079655,51.362848,62.2447159,1.8,51.6304903,62.7942897,0.0146604,17.6268407,25.1022497,43748.2049154,111212.8428198,0.0230103,4430.3934497,2481.908454,6082.1138986,0.7196906,3.7943895,1.3734008,8.2633655),(591,'metacarpus.tif',245,5,55,641.2863225,51.3976263,62.2727125,1.8,51.6472546,62.7875583,0.0109741,16.8649151,24.8219439,43367.7909218,110810.5305106,0.0128712,4464.2164572,2571.4799482,6028.2627029,0.8349047,7.1029852,1.359703,15.6798456),(592,'metacarpus.tif',245,5,56,640.1803224,51.4284162,62.3095873,1.8,51.6650036,62.7881964,0.0071456,17.1462795,25.2188803,42983.4766436,110380.2288458,0.0054479,4376.8885747,2506.8690089,6081.3035571,0.744141,3.7943895,1.3734008,8.2633655),(593,'metacarpus.tif',245,5,57,639.6570979,51.5423877,62.3149841,1.8,51.8330439,62.856312,0.0041006,27.2519208,24.8546365,42488.9765305,109539.9413346,0.0017925,4407.2236402,1559.1185959,5476.2780905,1.4201163,10.7693542,1.3146449,25.3214469),(594,'metacarpus.tif',245,5,58,636.5406648,51.5972978,62.3744135,1.8,51.8822793,62.9245303,0.0010695,17.2388528,24.5556479,41985.1260479,108924.5854843,0.0001209,4435.8261666,2435.4941982,6075.5109388,1.5429799,10.4327283,1.2565644,25.3214469),(595,'metacarpus.tif',245,5,59,633.2313156,51.6590166,62.438942,1.8,51.9676091,62.982177,-0.001365,17.1732061,24.982311,41583.807086,108329.5983781,0.000197,4336.2520966,2421.4352748,5922.7105741,0.248047,0.3507914,2.3561945,0.7015829),(596,'metacarpus.tif',245,5,60,630.8908538,51.71834,62.4878032,1.8,52.0145469,62.9936948,-0.0040222,17.6036268,24.9139338,41162.439415,108086.2192418,0.001701,4338.3842997,2338.2931165,5920.852758,2.0818845,13.5702341,1.2548261,35.1083507),(597,'metacarpus.tif',245,5,61,628.2058204,51.7821537,62.5367245,1.8,52.0318175,62.9846901,-0.0059951,16.6726522,24.8447645,40736.2856736,108270.7230966,0.0037632,4357.8888906,2443.2996707,5936.1267343,1.6347772,9.5070303,1.3068326,22.9862794),(598,'metacarpus.tif',245,5,62,627.9648757,51.8415234,62.6280396,1.8,52.0672125,63.0615726,-0.0093558,17.001269,25.0136243,40637.5400452,108610.8449138,0.0091611,4342.0674929,2390.2651076,5879.2143378,1.6347772,9.5070303,1.3068326,23.7127923),(599,'metacarpus.tif',245,5,63,628.5114807,51.9177097,62.7130388,1.8,52.1204355,63.0917733,-0.0119943,16.9073458,24.7056956,40633.1784158,109299.8333575,0.0150693,4424.0743177,2403.2854699,6042.8182373,1.4739884,9.7467007,1.3134726,23.627676),(600,'metacarpus.tif',245,5,64,628.1944845,52.026425,62.7907302,1.8,52.2482223,63.1639419,-0.0138348,17.1166787,24.8422267,40500.0383731,109964.0453249,0.0200381,4426.4971358,2366.1154812,5914.0119584,1.2040417,9.7467007,1.3134726,21.8135325),(601,'metacarpus.tif',245,5,65,626.8819204,52.1654276,62.8261714,1.8,52.3832629,63.2854416,-0.015131,16.9667049,24.89658,40070.7483952,109804.3085576,0.0239184,4410.4173592,2361.7283784,5877.3794167,1.5132049,10.6544778,1.359703,24.9104691),(602,'metacarpus.tif',245,5,66,624.1944259,52.2694927,62.8920795,1.8,52.4814198,63.3239597,-0.0170881,16.541857,25.0732083,39742.1626334,109702.359334,0.0303749,4375.2820936,2402.5212372,5917.5232666,1.8406836,11.9269088,1.2753555,33.0036021),(603,'metacarpus.tif',245,5,67,620.3867801,52.3702917,62.9484344,1.8,52.5447451,63.375457,-0.0192892,18.0491933,24.9189611,39419.6455277,109598.1203122,0.038467,4398.1817578,2184.0114895,5839.6425421,1.9126676,12.4740763,1.2679115,33.1489047),(604,'metacarpus.tif',245,5,68,617.746643,52.4513846,62.9980531,1.8,52.5932509,63.4276047,-0.0222177,16.3747197,24.8833989,39231.8151885,109933.3140341,0.0508143,4417.9380136,2395.8770529,5957.1873285,1.83383,11.7920199,1.3156139,31.6004364),(605,'metacarpus.tif',245,5,69,615.5912665,52.5229476,63.0537007,1.8,52.6925333,63.4628514,-0.0245411,16.5893049,24.8188428,39044.4230591,110441.6183464,0.0617793,4449.9100572,2353.5900552,5993.1404736,1.6873404,8.9640768,1.3191064,23.5425597),(606,'metacarpus.tif',245,5,70,614.2815178,52.5397429,63.100194,1.8,52.6893888,63.4752263,-0.0286904,16.5446418,25.3464612,38940.5284506,111509.4439974,0.08425,4399.4087834,2353.6640457,5935.061394,1.9188065,12.7110475,1.2737321,33.1239747),(607,'metacarpus.tif',245,5,71,613.9573807,52.5598152,63.1469484,1.8,52.726727,63.5197654,-0.031508,17.7759679,24.5751063,38818.3096453,112848.5578843,0.1015517,4591.9865689,2183.7522395,6156.898338,0.9033547,4.5737607,1.3521274,10.1626253),(608,'metacarpus.tif',245,5,72,613.5564463,52.5817579,63.2103249,1.8,52.7634127,63.5776505,-0.0348068,16.8904549,24.8590552,38869.511258,114010.0454409,0.1238389,4586.2581862,2301.2708326,5971.5832857,1.1277182,8.7240638,1.3120254,19.3330625),(609,'metacarpus.tif',245,5,73,612.1654256,52.671803,63.2450772,1.8,52.8717151,63.6796986,-0.0362396,16.5415334,25.2610598,38762.452677,114246.5265526,0.1339353,4522.6339526,2343.3409553,6053.9607763,1.7570125,9.2611596,1.2151604,22.9862794),(610,'metacarpus.tif',245,5,74,609.9397962,52.7180963,63.3181753,1.8,52.9389477,63.7657294,-0.0368129,17.1837845,25.1266583,38747.6038976,114638.5798212,0.137702,4562.4284105,2254.893489,6092.1222726,0.496094,0.7015829,2.3561945,1.4031657),(611,'metacarpus.tif',245,5,75,607.2568883,52.7681422,63.3904974,1.8,53.0049737,63.7982868,-0.0374419,17.5706366,25.3076438,38745.0530583,114955.4461492,0.1418191,4542.3211659,2205.1024055,5986.2697036,1.4647478,8.0069634,1.2882414,20.0097154),(612,'metacarpus.tif',245,5,76,604.7999721,52.8141167,63.4698809,1.8,53.0404873,63.8382348,-0.038655,19.0012189,25.510127,38874.1431894,115768.3191963,0.1505414,4538.1318207,2045.8762905,6040.6560297,1.1605864,4.3954041,1.2847449,10.2228116),(613,'metacarpus.tif',245,5,77,602.9151853,52.8713197,63.559099,1.8,53.0618611,63.9187332,-0.0392887,17.0120954,25.445451,39050.6715678,116594.3085539,0.1550302,4582.1278078,2295.465116,6056.123386,1.4095148,8.8639935,1.2578951,20.7362282),(614,'metacarpus.tif',245,5,78,600.1676737,52.9292532,63.6404602,1.8,53.1571293,63.9741545,-0.0402857,17.7312076,25.6364985,39201.2877992,117519.27331,0.162252,4584.0610082,2210.863961,6085.9644893,1.1433867,2.9033157,1.2220253,7.1860612),(615,'metacarpus.tif',245,5,79,598.4289678,52.9712907,63.7079108,1.8,53.155285,64.0170795,-0.0409187,16.7475296,25.5958996,39366.829945,118799.4446718,0.1669019,4641.346714,2350.6051832,6153.1109192,1.0285239,8.5675018,1.1849137,19.4534351),(616,'metacarpus.tif',245,5,80,596.4104616,53.0294161,63.7702952,1.8,53.206526,64.059867,-0.0414221,17.5867459,25.7871907,39548.0612279,120002.6634531,0.1704553,4653.5764575,2248.7424048,6083.1008655,0.9073652,3.017622,1.4056476,7.1860612),(617,'metacarpus.tif',245,5,81,594.3474508,53.0912742,63.8126186,1.8,53.3049354,64.1618461,-0.0422357,16.9170247,25.9209661,39498.5091347,121045.6935885,0.1766,4669.7986989,2334.837822,6145.040047,1.5841132,12.9792831,1.1156955,29.5060141),(618,'metacarpus.tif',245,5,82,592.1757416,53.1381642,63.9026189,1.8,53.3327552,64.2839059,-0.0427328,17.1357514,26.1347543,39515.9874411,122543.2191713,0.1801187,4688.8988382,2306.0551357,6157.4918638,0.9751983,3.7781394,1.1659045,8.3837381),(619,'metacarpus.tif',245,5,83,590.4168435,53.1860177,63.9855822,1.8,53.3785783,64.3802467,-0.0434696,18.1705421,26.3254049,39622.9965596,123990.3207401,0.1858257,4709.9112496,2180.6171964,6171.2392097,1.0873665,8.5423296,1.120135,18.9573411),(620,'metacarpus.tif',245,5,84,589.4812554,53.2150994,64.053395,1.8,53.3812352,64.454736,-0.0445617,17.5638881,26.1475729,39819.7674343,125964.8358317,0.1949645,4817.4580626,2267.1385302,6336.9145939,30.3824576,50.2416126,0.1237426,245.5469171),(621,'metacarpus.tif',245,5,85,588.2669859,53.2423907,64.1068116,1.8,53.4154631,64.4940635,-0.0462516,17.9242133,26.5595104,40026.2465797,128017.2329314,0.2095875,4820.014782,2233.0824798,6280.3294734,27.861978,50.5973325,0.0982052,135.3211112),(622,'metacarpus.tif',245,5,86,587.2543581,53.2637611,64.1588026,1.8,53.4708929,64.5346089,-0.0467092,17.5732446,26.5743674,40291.5946218,130208.3298389,0.2133852,4899.7715764,2292.7806243,6404.883452,0.8808803,3.9219675,1.2490458,8.6743432),(623,'metacarpus.tif',245,5,87,585.9392211,53.2841373,64.2140836,1.8,53.4489606,64.6035316,-0.0485275,17.4188567,26.7658966,40405.1354527,132525.7345596,0.2297926,4951.2906941,2319.6204106,6416.1997933,0.9988669,5.2148896,1.1284221,11.4806747),(624,'metacarpus.tif',245,5,88,584.2853855,53.2878937,64.2678137,1.8,53.4435759,64.6911254,-0.0504027,17.4751957,26.8109016,40503.5905506,134781.478694,0.24718,5027.1147441,2317.7760841,6532.5259168,1.0258558,7.1418586,1.2160907,15.8604045),(625,'metacarpus.tif',245,5,89,584.931385,53.3282088,64.289306,1.8,53.5350164,64.7516807,-0.0526785,17.2148353,27.1732266,40444.8391998,136733.7843373,0.2702838,5031.9303826,2349.4177267,6476.7999739,0.248047,0.3507914,2.3561945,0.7015829),(626,'metacarpus.tif',245,5,90,581.6465722,53.3342963,64.3398232,1.8,53.5562875,64.7941519,-0.0549353,18.3162889,27.3974112,40343.3759605,138182.532056,0.292263,5043.6346321,2202.5955187,6452.2112644,0.7826918,4.706361,1.2490458,10.1626253),(627,'metacarpus.tif',245,5,91,580.7981478,53.3249212,64.4028517,1.8,53.5465556,64.8928406,-0.0584351,19.1696697,27.4572056,40337.284643,140169.5046,0.3301616,5105.0171124,2104.2242957,6500.5757434,1.108244,5.5741631,1.2068174,12.7634679),(628,'metacarpus.tif',245,5,92,579.701731,53.3029632,64.4637402,1.8,53.4949789,64.9342091,-0.0616198,19.1482129,27.7233251,40381.704305,142234.9553597,0.3663899,5130.5157181,2108.9019904,6545.3615186,1.3469924,6.3239825,1.1246908,14.7831002),(629,'metacarpus.tif',245,5,93,578.2354419,53.285556,64.5125001,1.8,53.4753271,64.9496517,-0.0635486,18.810684,27.802439,40401.9318393,144303.0615407,0.3886699,5190.3022424,2147.8183266,6631.5304948,1.0983283,2.48047,0.9272952,5.8430818),(630,'metacarpus.tif',245,5,94,578.2560256,53.2927082,64.5593482,1.8,53.4880211,64.9704726,-0.0655134,17.7842411,28.0108935,40485.3297383,146667.6623365,0.4130543,5236.0936858,2276.4721552,6612.3595119,0.9292004,4.6603801,1.1309537,10.077509),(631,'metacarpus.tif',245,5,95,579.3791787,53.2888241,64.5977946,1.8,53.443747,64.9824274,-0.0663515,17.3282026,28.4285956,40644.0803188,149057.3903918,0.4244985,5243.2203363,2345.5450805,6635.4214769,30.1389865,54.154404,0.1101514,251.9815355),(632,'metacarpus.tif',245,5,96,580.4339807,53.3034205,64.6429932,1.8,53.4610936,65.0052147,-0.0681802,19.8617662,28.4453284,40751.5991748,151508.7122994,0.4489989,5326.3126393,2051.7610983,6706.3925573,0.496094,1.022724,1.815775,2.3953537),(633,'metacarpus.tif',245,5,97,581.5710054,53.3521232,64.6698133,1.8,53.5884367,65.0927523,-0.069736,18.0237676,28.6247914,40665.6601428,153631.6619447,0.4706108,5367.0840688,2256.2241688,6726.0338845,30.599893,55.0653171,0.0947382,287.9367716),(634,'metacarpus.tif',245,5,98,582.2979227,53.3373835,64.7161478,1.8,53.6478446,65.1364745,-0.0699068,18.9730821,28.8550392,40715.3000948,155849.6647354,0.4735063,5401.1246858,2145.9507708,6749.6786173,0.6620288,1.8890697,1.1659045,4.0891246),(635,'metacarpus.tif',245,5,99,584.4906816,53.3179428,64.7751745,1.8,53.5908696,65.1963016,-0.0704857,18.4039434,29.3016658,40765.7841774,158683.8147068,0.4831794,5415.5219689,2215.0570264,6731.1467842,0.496094,1.8058094,1.2924967,3.8836358),(636,'metacarpus.tif',245,5,100,586.7358693,53.2639079,64.8190284,1.8,53.536292,65.1770196,-0.0713771,21.045162,29.4079406,40929.2640163,161593.0167286,0.4973599,5494.8770072,1944.830079,6823.2695,0.6659574,1.6639499,1.1071487,3.5930306),(637,'metacarpus.tif',245,5,101,592.8394722,53.2523524,64.8656688,1.8,53.5182813,65.1975042,-0.070803,19.7955338,29.7073011,41279.2080519,165444.6145038,0.4944974,5569.156688,2085.2788522,6913.5544587,28.2505336,56.9498847,0.1178721,148.3751842),(638,'metacarpus.tif',245,5,102,596.7077131,53.2499932,64.9164595,1.8,53.5450947,65.1962899,-0.0704025,19.8750655,29.9095032,41528.2058676,168956.1661581,0.4921179,5648.9124946,2089.4625922,6984.8969408,0.248047,1.508811,1.735945,3.1820529),(639,'metacarpus.tif',245,5,103,603.6942144,53.2507713,64.9770168,1.8,53.4950994,65.1729695,-0.0699497,19.6544454,30.2140703,41985.1671381,173303.5154875,0.4915054,5735.85465,2136.1664641,7093.4213729,0.248047,0.55465,2.0344439,1.1976769),(640,'metacarpus.tif',245,5,104,610.0612101,53.183867,65.0298219,1.8,53.525472,65.1471195,-0.0700851,23.9139606,30.6921439,42620.4388599,177363.6389804,0.4986109,5778.7960134,1782.2409091,7104.263584,0.496094,0.7015829,0.7853982,1.4031657),(641,'metacarpus.tif',245,5,105,616.8677159,53.1220665,65.06591,1.8,53.4775379,65.2811961,-0.0690404,19.9979942,31.0764582,42955.3953821,181198.4530544,0.4892804,5830.7305204,2147.9851863,7164.1647179,0.5420128,1.6639499,1.1071487,3.5930306),(642,'metacarpus.tif',245,5,106,623.2630515,53.0828745,65.1396157,1.8,53.4136655,65.3561397,-0.0681841,18.6289889,31.3030663,43451.9311477,185538.9044996,0.4821839,5927.1798668,2332.4900429,7240.2228585,0.248047,0.7843935,1.8925469,1.6937709),(643,'metacarpus.tif',245,5,107,630.8121548,53.0656176,65.2196191,1.8,53.3769653,65.4135751,-0.0670686,18.9248715,31.4611839,44117.1574642,189800.3250424,0.4722115,6032.8411545,2331.1734239,7313.220503,0.248047,0.7843935,1.8925469,1.6937709),(644,'metacarpus.tif',245,5,108,639.0584744,53.0677626,65.2855549,1.8,53.4279757,65.4326242,-0.0664122,19.8971217,31.7145958,44899.3142845,194701.9238015,0.4690795,6139.1898218,2256.5733375,7442.212212,29.097509,61.0160332,0.0895557,157.8964129),(645,'metacarpus.tif',245,5,109,644.5864426,53.0103985,65.4116487,1.8,53.3367985,65.4920406,-0.0674917,20.8929974,32.1221866,45644.5392886,199509.1132957,0.4886192,6210.9443492,2184.6812351,7573.8657439,29.1936479,61.6600145,0.0684413,158.8886009),(646,'metacarpus.tif',245,5,110,650.4593927,53.0561568,65.5015271,1.8,53.4188351,65.5928878,-0.0681499,24.6489568,31.9845757,46480.3451297,204215.8762177,0.5027221,6384.8236835,1885.6921802,7827.3891422,29.4360885,62.3708748,0.05969,160.7878606),(647,'metacarpus.tif',245,5,111,657.4449057,53.025451,65.6078678,1.8,53.3206725,65.6555239,-0.0691093,21.9421331,32.0551932,47322.8242435,209663.0940374,0.5225039,6540.6903806,2156.7102918,7944.579786,29.8016848,62.9516707,0.0788873,162.5418178),(648,'metacarpus.tif',245,5,112,659.146136,53.0661012,65.7174941,1.8,53.4094952,65.6819487,-0.0703513,19.8181697,32.2683915,48074.7772686,214847.5908373,0.5428238,6658.1438099,2425.7929911,8063.458541,30.0364101,63.5949171,0.0546331,165.0575442),(649,'metacarpus.tif',245,5,113,667.2659144,53.0922949,65.7764391,1.8,53.4758575,65.7496161,-0.070515,24.8042441,33.3086316,48942.5806586,220425.5612741,0.5520671,6617.6708856,1973.1534814,8041.4460157,0.248047,1.022724,1.815775,2.1898649),(650,'metacarpus.tif',245,5,114,667.3901623,53.1004413,65.905728,1.8,53.3978506,65.803839,-0.0697313,22.3158513,33.7898925,49183.2179902,223952.8934841,0.5399827,6627.8072165,2203.9588482,8035.8958053,30.7307445,65.1415065,0.0685945,175.9217523),(651,'metacarpus.tif',245,5,115,675.6760831,53.1659888,66.0394452,1.8,53.3802896,65.9000006,-0.0689587,20.8942302,33.8049119,50213.2646135,228675.2614251,0.5346595,6764.5572463,2403.2119926,8227.0340506,31.0402201,65.8376743,0.0565434,170.0184842),(652,'metacarpus.tif',245,5,116,679.93038,53.1706693,66.1598143,1.8,53.3440446,65.9574836,-0.0690009,18.6919036,33.825537,50921.8440037,232414.0935442,0.5386828,6870.9653833,2724.2727735,8307.7520688,31.4425349,66.5228578,0.0372961,172.1232328),(653,'metacarpus.tif',245,5,117,684.4885472,53.234729,66.2333887,1.8,53.3359799,65.9965654,-0.0664972,19.997877,34.2338374,51677.9865718,237149.3887225,0.5037115,6927.338757,2584.1736425,8403.856415,31.793795,67.0759638,0.0554985,173.9373763),(654,'metacarpus.tif',245,5,118,687.0065806,53.2584622,66.3026954,1.8,53.313791,66.0218334,-0.0645747,20.8289034,34.235421,52499.2238345,241271.7044662,0.4767936,7047.4291737,2520.4986954,8469.8460828,32.3706812,67.616357,0.0660801,176.5382189),(655,'metacarpus.tif',245,5,119,693.0115533,53.2701805,66.3586996,1.8,53.2797888,65.9932968,-0.0632415,22.3266214,34.552749,53455.6070333,247148.4338513,0.4613333,7152.7864151,2394.2541972,8575.0806884,32.8477054,68.4973611,0.0325971,178.9937589),(656,'metacarpus.tif',245,5,120,700.4761777,53.3417056,66.4191589,1.8,53.2865674,66.0314686,-0.0603869,22.6302964,35.1284574,54702.7560793,253617.2343613,0.4252066,7219.7088299,2417.2355097,8737.5058359,33.5388104,69.0016649,0.0359557,180.3616683),(657,'metacarpus.tif',245,5,121,705.9299776,53.4205632,66.4402035,1.8,53.3499309,66.0585573,-0.0590052,25.5124383,35.1410143,55431.8050586,261175.1840958,0.4091536,7432.2039137,2172.7364677,8877.1347319,34.0058874,69.7545922,0.0391259,183.5187912),(658,'metacarpus.tif',245,5,122,713.6288346,53.4281697,66.4994011,1.8,53.3360008,66.0851,-0.0577402,25.0842157,35.7673486,56210.566058,268838.0669926,0.3960911,7516.2984558,2240.8739742,9030.0657545,34.6974034,70.271326,0.0459041,185.7086561),(659,'metacarpus.tif',245,5,123,724.8886129,53.4076909,66.6489306,1.8,53.313246,66.1902847,-0.0574026,22.802549,36.4690739,57445.2832017,278101.9505126,0.397655,7625.6926991,2519.2483199,9145.156788,35.1346569,71.0038605,0.0419334,187.5477296),(660,'metacarpus.tif',245,5,124,743.6708513,53.4434665,66.7166923,1.8,53.3137577,66.2703484,-0.057024,20.8995622,36.6863402,59059.8784856,289919.0926985,0.4026014,7902.6441765,2825.8907078,9460.7817487,35.6698716,71.4995214,0.0416426,189.882897),(661,'metacarpus.tif',245,5,125,766.0559242,53.4767655,66.800166,1.8,53.2759078,66.4251658,-0.0561419,21.701725,36.3299848,60994.9668335,304625.9978591,0.402001,8384.9745458,2810.6045353,9872.658926,36.0037135,71.9951883,0.0413557,192.6892285),(662,'metacarpus.tif',245,5,126,796.740454,53.5561011,66.9574046,1.8,53.2616445,66.6335899,-0.0561006,23.9981315,37.1001334,63384.0960678,321736.5154955,0.4174883,8672.1120889,2641.20963,10313.5314724,0.248047,0.3507914,2.3561945,0.7015829),(663,'metacarpus.tif',245,5,127,833.2329758,53.5763784,67.1384446,1.8,53.3436673,66.8737056,-0.0565043,22.9307877,36.9626863,65592.9509195,338047.5862803,0.4429102,9145.6444338,2860.4752591,10632.7917291,36.6333025,73.2562213,0.047422,202.5363186),(664,'metacarpus.tif',245,5,128,876.9533537,53.6237951,67.3118861,1.8,53.4138555,67.1584508,-0.0562693,24.7894263,37.6309274,67835.9613327,355976.0946984,0.4622835,9459.6683928,2736.4877454,11085.1094678,37.3430858,74.1764227,3.1248718,277.5248466),(665,'metacarpus.tif',245,5,129,939.3249355,53.820452,67.5222032,1.8,53.4501645,67.6729052,-0.0531873,24.4200657,37.7639009,71578.2670698,378338.2461966,0.4424579,10018.5160309,2931.1250779,11750.3269088,0.248047,0.55465,2.0344439,1.1976769),(666,'metacarpus.tif',245,5,130,1000.9985552,53.7468985,67.7132823,1.8,53.3263531,68.2303988,-0.0543391,24.7840783,38.1140709,77011.9164891,391185.0659841,0.4921296,10263.5340873,3107.3141261,12126.959111,39.9598779,74.6637957,3.1349482,444.7241674),(667,'metacarpus.tif',245,5,131,1001.1433868,53.5844195,67.9274761,1.8,53.1855479,68.6476601,-0.0584229,23.1066236,38.4181054,78122.1515277,386228.3747806,0.5688753,10053.2905282,3380.9418789,11953.0209802,0.248047,0.7843935,1.8925469,1.6937709),(668,'metacarpus.tif',245,5,132,951.4097206,53.5198996,68.1740171,1.8,53.0640847,68.9719686,-0.0612991,21.8580961,38.0768837,75596.7828804,373766.1925599,0.5950859,9816.091984,3458.525506,11567.8055922,38.810758,75.6742581,3.1186459,388.3628418),(669,'metacarpus.tif',245,5,133,946.5517289,53.5234076,68.318042,1.8,53.0478134,69.166817,-0.0591919,22.231145,38.6737575,75868.6830444,375579.3676951,0.5520914,9711.4785905,3412.7204374,11648.6785662,2.728517,6.4682744,1.6475682,19.6941803),(670,'metacarpus.tif',245,5,134,964.4421568,53.396126,68.4563803,1.8,52.9901771,69.3460668,-0.0534599,22.7030007,38.7420461,78644.5640205,384828.7180648,0.4589516,9933.1025767,3464.0603322,11850.5022743,3.224611,7.4785246,1.670465,21.1824623),(671,'metacarpus.tif',245,5,135,972.4543929,53.313653,68.5913708,1.8,52.9281999,69.4432562,-0.0534861,29.9149229,38.2390524,81933.6738722,398107.8475205,0.4632189,10411.0280547,2738.8896849,12091.9567194,3.5068442,9.9713661,1.4711277,28.4287098),(672,'metacarpus.tif',245,5,136,968.9962222,53.2603405,68.4981511,1.8,52.9175474,69.2792337,-0.0526586,30.6561878,38.6999075,84780.7278754,411814.3429401,0.4474136,10641.222915,2765.5339405,12393.3030431,39.7678185,75.9299384,2.9775181,382.0133396),(673,'metacarpus.tif',245,5,137,982.3511362,53.1950351,68.4805537,1.8,52.9465786,69.2394027,-0.051355,31.6385866,39.1159237,87970.4398289,431633.4971757,0.4314187,11034.7259302,2780.4794481,12826.1074294,40.0511233,76.9345678,0.0322469,338.3303656),(674,'metacarpus.tif',245,5,138,998.0867843,53.2492108,68.6205903,1.8,52.9755745,69.3533832,-0.0502599,24.9366987,39.3523688,90627.9719197,453437.3229867,0.4198512,11522.4911974,3634.3211632,13394.0202235,0.248047,0.55465,2.0344439,1.1976769),(675,'metacarpus.tif',245,5,139,1027.5573801,53.2078487,68.7119998,1.8,52.904211,69.3871303,-0.0500891,24.9672054,40.0070833,93520.3542434,480701.8649231,0.4293173,12015.4189016,3745.7277495,14074.6467115,36.2556209,44.2052885,0.7695265,154.9301752),(676,'metacarpus.tif',245,5,140,1055.0218125,53.2677083,68.8079226,1.8,52.9088182,69.3782843,-0.0503641,22.7392586,39.5900923,94829.2830783,504746.1643273,0.4456404,12749.3050801,4170.2891386,14692.8685041,36.5482621,44.2498054,0.7378151,165.8442433),(677,'metacarpus.tif',245,5,141,1072.9705796,53.35796,68.9210141,1.8,52.8997651,69.3189457,-0.050693,22.3698791,39.5026921,94066.9928636,520531.8845034,0.4591541,13177.1243033,4205.0738164,15083.7353273,1.6951711,5.2618715,1.4288993,13.1993756),(678,'metacarpus.tif',245,5,142,1082.8786214,53.5708122,68.9962159,1.8,52.966115,69.2832979,-0.0522752,24.0578014,39.2394435,91174.9329722,528303.8244856,0.4927474,13463.5911488,3789.8281534,15379.614435,1.488282,3.6116189,1.2924967,9.581415),(679,'metacarpus.tif',245,5,143,1075.3801943,53.7610695,69.0464533,1.8,53.1161799,69.2353245,-0.055216,22.4197892,39.5010521,85870.8628713,526318.5390937,0.5458825,13324.165084,3830.1369474,15422.2177083,1.2647048,4.3954041,1.2847449,11.4806747),(680,'metacarpus.tif',245,5,144,1044.5595214,54.0181642,69.0169085,1.8,53.3761637,69.1205389,-0.0569836,23.6409662,40.0938867,78090.7683485,506024.0046251,0.5646915,12620.9765735,3303.1969835,14537.6232719,36.4328108,41.9903354,2.5880027,219.7560779),(681,'metacarpus.tif',245,5,145,975.4357829,54.5795633,68.8663443,1.8,53.8691339,68.9700131,-0.0592595,22.408697,39.5904912,67004.9402894,453561.8495931,0.5702368,11456.332957,2990.1310302,13142.5367411,36.3438593,40.9427857,2.6562682,222.6371993),(682,'metacarpus.tif',245,5,146,879.0238411,55.5044251,68.6715337,1.8,54.5160104,68.7574509,-0.0617379,21.4079177,39.5688253,55573.7374516,373144.4622178,0.5577011,9430.2638324,2595.943161,10823.3489523,35.4958458,38.5296128,0.6022873,203.6901846),(683,'metacarpus.tif',245,5,147,745.4811714,56.8275543,68.3838284,1.8,55.4813809,68.5706318,-0.0635298,17.7708654,38.6670747,44138.9190979,260746.7513215,0.5007895,6743.3793046,2483.7799488,7875.9517614,32.7748971,36.144287,0.6833152,183.3047478),(684,'metacarpus.tif',245,5,148,590.6381554,57.073646,68.0940765,1.8,57.0055227,68.2811707,-0.0664999,17.25965,32.4905502,33761.2855127,145177.0734396,0.434682,4468.2860814,1956.081703,5505.7641852,24.3178053,34.0556881,1.221403,119.6473146),(685,'metacarpus.tif',245,5,149,487.6648847,55.0258199,67.8386626,1.8,54.3267326,68.1039527,-0.0724994,16.4361737,24.8878498,24832.7448474,92451.4291147,0.4264595,3714.7214322,1510.859239,4682.8165752,20.370534,31.2381693,1.2138844,119.551872),(686,'metacarpus.tif',245,5,150,433.4798292,54.9079608,67.5985245,1.8,54.1997932,67.8853837,-0.0623214,15.3514791,22.7797105,16992.9145981,76929.8979355,0.2802395,3377.1236024,1106.9236029,3887.2166265,19.6553185,29.443503,1.1636922,106.5579853),(687,'metacarpus.tif',245,5,151,355.8602312,55.2082613,67.5596143,1.8,54.4708247,67.7486981,-0.0544836,13.7534486,22.441282,9606.9851123,61256.3172835,0.1758856,2729.6264628,698.5146323,3029.2816311,18.9439689,25.9976452,1.0516502,93.6242849),(688,'metacarpus.tif',245,5,152,203.9799045,57.1316006,67.6980081,1.8,55.5866951,67.6428439,-0.0569681,11.5526686,23.5298017,3632.9692596,38485.80129,0.1102124,1635.6194506,314.4701358,1768.0797058,17.6113371,21.5387083,0.8996525,71.4994946),(689,'metacarpus.tif',245,5,153,62.7564258,61.1947178,67.9614835,1.8,58.5417002,68.084834,-0.0578329,8.810309,26.5244438,782.4199708,13914.6355821,0.034944,524.5966955,88.8073242,553.7247941,4.96094,13.723524,1.6794575,32.1214604),(690,'metacarpus.tif',245,5,154,8.8791374,70.5563392,67.5363754,1.8,70.5155168,67.5510199,1.4390072,2.1986959,5.2452036,6.9548742,46.3248525,1.454302,8.8318502,3.1631815,10.1216289,4.216799,10.6544778,1.7818897,25.0557717),(691,'metacarpus.tif',245,5,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(692,'metacarpus.tif',245,5,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(693,'metacarpus.tif',245,5,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(694,'metacarpus.tif',245,5,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(695,'metacarpus.tif',245,5,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(696,'metacarpus.tif',245,5,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(697,'metacarpus.tif',245,5,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(698,'metacarpus.tif',245,5,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(699,'metacarpus.tif',245,5,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(700,'metacarpus.tif',245,5,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(701,'metacarpus.tif',245,5,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(702,'metacarpus.tif',245,5,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(703,'metacarpus.tif',245,5,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(704,'metacarpus.tif',245,5,168,8.9136299,46.1911713,70.8731995,1.8,46.2098904,70.8950217,1.4597432,4.5131347,4.6495606,36.426268,38.5046783,1.4673585,8.2813586,8.071168,16.0816481,8.9296921,9.5811666,1.9416876,30.2325269),(705,'metacarpus.tif',245,5,169,35.1248069,46.2964394,70.9964337,1.8,46.3048209,71.019059,-0.6104366,7.3007407,7.3334267,398.0081492,410.1557358,1.9235938,55.9296158,54.5161327,109.1518842,14.6347731,15.0329581,0.9140947,48.4280989),(706,'metacarpus.tif',245,5,170,66.2215137,49.4001037,72.5214219,1.8,49.9543058,72.7491546,0.4430367,9.0187643,34.7514185,1109.9055702,7594.844135,2.0282632,218.5477447,123.0662571,248.1448443,18.1074311,18.4574306,0.71883,59.788401),(707,'metacarpus.tif',245,5,171,152.8994054,59.4672502,76.4436108,1.8,56.4637944,74.8998532,0.3735525,10.5227494,26.5328656,2586.3598337,40069.2512356,3.3936129,1510.174279,245.7874588,1550.7829682,20.5879012,20.9962666,0.676586,68.1119528),(708,'metacarpus.tif',245,5,172,266.0608723,64.146311,76.8922214,1.8,59.5638541,74.817527,0.2795719,12.0287007,30.02567,5308.9875601,65912.4999619,3.3765437,2195.2049689,441.3600186,2370.6682308,22.8014432,23.169502,0.6563484,75.1527115),(709,'metacarpus.tif',245,5,173,380.9095487,66.5402854,76.1272864,1.8,61.4455492,74.2285214,0.1829246,13.5014955,32.9213802,9746.0742284,84529.8263623,2.1007063,2567.6270547,721.8514573,2859.8298685,24.3086062,24.9098971,0.66541,80.5246292),(710,'metacarpus.tif',245,5,174,490.5629145,67.7568942,74.8387706,1.8,62.5663107,73.4402008,0.104481,14.9832631,34.4503801,17031.4574784,99586.6269268,0.889277,2890.7265059,1136.6988195,3377.5749139,25.7968882,26.1945151,0.6510767,85.7263145),(711,'metacarpus.tif',245,5,175,576.7533421,68.3189365,73.6325869,1.8,62.8757473,73.0033731,0.0482413,16.7105926,35.4173582,26564.6721043,110153.1891955,0.2235315,3110.1469661,1589.690612,3858.7035489,26.7890762,27.321226,0.5123895,89.0536699),(712,'metacarpus.tif',245,5,176,608.3094715,68.3573076,73.3511357,1.8,62.7091176,73.1378043,0.0295463,17.0215728,35.7220404,31366.1784864,115137.7361965,0.0884813,3223.1567613,1842.7309169,4085.9407083,29.9585194,56.796264,3.0101955,186.0551702),(713,'femur.tif',245,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(714,'femur.tif',245,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(715,'femur.tif',245,7,3,17.6061122,166.1364194,152.160707,1.8,166.3620091,152.1922503,0.0811236,5.7096584,9.4640895,54.7854033,397.7167572,0.0192687,42.0237737,9.5952157,44.6821109,10.3813828,18.2772398,2.9617392,64.7655139),(716,'femur.tif',245,7,4,120.4279741,167.2172687,150.5230422,1.8,167.2338676,150.0093106,0.035474,27.1937535,109.1046305,2440.84433,4097.6525115,0.0252473,37.5570908,89.7575367,58.1496818,20.4672857,25.4017836,0.3964413,78.3498377),(717,'femur.tif',245,7,5,203.5508368,170.8612502,144.6201071,1.8,171.5475861,142.2743102,-1.0962881,87.7426369,77.9070803,6416.1319994,26882.9092363,26.8429766,345.0637496,73.1244492,283.7865638,24.132028,35.9235468,1.1818394,105.0576605),(718,'femur.tif',245,7,6,330.5615207,174.9759479,137.0965427,1.8,174.8320787,136.9932153,-1.0916255,12.7960709,33.6945043,10891.7357993,76631.9788183,43.3828294,2274.3168483,851.1781353,2589.295123,25.554572,63.3657842,1.018578,169.7457216),(719,'femur.tif',245,7,7,377.8066534,176.679919,134.0794559,1.8,176.557168,133.7151559,-1.1024157,14.6828265,37.0035792,16008.4618098,117404.4105566,50.1349575,3172.7852555,1090.2847488,3594.3216466,26.3027514,70.9424836,1.1346332,178.4644737),(720,'femur.tif',245,7,8,414.621274,177.7424019,132.1765881,1.8,177.3167153,132.5373477,-1.1149106,16.115396,90.4056543,21554.9438375,152820.093349,55.7094204,1690.3820299,1337.5373338,1928.7419927,28.2186611,74.3673813,1.1399239,189.1759262),(721,'femur.tif',245,7,9,451.2418938,178.6060105,131.5444572,1.8,178.1422081,131.9925673,-1.1191182,33.0132524,58.8465095,28606.9720826,185342.943709,60.8792006,3149.5996172,866.5299534,3224.2475615,30.4645007,76.8030793,1.0754133,203.6857918),(722,'femur.tif',245,7,10,486.870374,179.3532177,131.265476,1.8,178.9958334,131.3953377,-1.1225377,17.6160496,40.628256,35865.5079679,207775.3443427,65.9033575,5114.0601379,2035.956346,5508.1957663,33.1959728,79.021207,1.0670468,208.7610365),(723,'femur.tif',245,7,11,529.8160856,180.1438979,131.1552097,1.8,179.6772907,131.0998871,-1.1165739,19.0931383,76.2739425,46643.0678797,227370.0357477,71.3032177,2980.9660842,2442.923065,3585.239551,35.3415078,80.9369707,1.0800469,215.2453332),(724,'femur.tif',245,7,12,569.9637226,180.6865232,131.0579015,1.8,180.2151803,130.7648699,-1.0998269,19.3554597,42.5188452,57241.0448631,248894.8875244,75.4357028,5853.7546438,2957.3591015,7196.9913786,37.2034172,82.413036,1.0746158,226.5177487),(725,'femur.tif',245,7,13,626.3974386,177.1597865,130.4870774,1.8,174.6266558,129.7983062,-0.4677406,57.8183394,80.6517045,200596.6739378,340895.4411876,21.2228061,4226.7605302,3469.4298754,5628.6297493,39.4581883,83.6788027,1.0605353,239.8830028),(726,'femur.tif',245,7,14,892.4514448,153.5708984,126.9232845,1.8,162.3279973,127.6865123,0.0839869,61.36829,78.8688748,264463.8048583,1722319.0449714,1.0467309,21837.7534682,4309.4537103,25177.1462483,28.0306166,30.8639515,0.8353566,98.495911),(727,'femur.tif',245,7,15,1154.8017095,141.7729465,125.1030282,1.8,154.8905254,126.4546411,0.098065,46.5645259,70.4989452,303324.0704579,2559376.7848759,1.84498,36303.7599632,6514.059025,39434.3005306,35.8345784,39.1472517,0.8938815,125.655162),(728,'femur.tif',245,7,16,1377.1964484,135.5596446,124.0933469,1.8,149.2352811,125.5388174,0.1022373,51.1192279,73.1814499,349098.8640188,3097724.4690726,2.3908358,42329.3672478,6829.1106605,43616.1975978,41.9996671,47.6082239,0.0916962,151.0087003),(729,'femur.tif',245,7,17,1647.13299,130.7843951,122.9465162,1.8,143.8228283,124.5707187,0.1036621,81.5086533,78.8585846,406741.3051153,3579170.8386491,2.9394157,45387.2061766,4990.1610287,37628.9668302,47.5805097,65.426959,0.033321,246.5222051),(730,'femur.tif',245,7,18,1853.2282426,128.5196372,122.4319378,1.8,140.543181,123.9030346,0.1067499,85.2106463,81.7599109,457600.3192278,3822468.9893714,3.5064063,46752.3624494,5370.2247214,39826.8178989,54.7276584,73.2225959,3.0671039,343.4220765),(731,'femur.tif',245,7,19,1972.8947006,127.9071411,122.3682335,1.8,138.8642487,123.7333519,0.1101245,98.9730438,83.3555273,508911.6262416,4019233.1484976,3.971588,48217.9559912,5141.9215447,37486.4066637,56.9929331,77.4268788,3.1063959,301.1145442),(732,'femur.tif',245,7,20,2073.2954218,127.7944778,122.2917791,1.8,137.6641885,123.434366,0.1151388,85.8589639,84.4249524,547629.5978535,4131134.8612529,4.560718,48932.6288604,6378.2460536,44713.3392226,74.0175599,155.4441964,0.1513167,629.0691314),(733,'femur.tif',245,7,21,2145.7292545,127.6466241,122.088776,1.8,136.7047133,123.1892042,0.1178471,84.2410252,85.6059863,582340.122731,4209388.9251958,4.9436767,49171.6655267,6912.7853247,41007.122625,73.5021326,156.7501095,0.1359974,632.6578713),(734,'femur.tif',245,7,22,2098.9855004,127.028865,121.9486713,1.8,136.078863,123.0141644,0.1171807,98.8588604,86.9222147,596041.9882648,4230393.7737438,4.7816889,48668.7297257,6029.2217192,39521.1948152,72.9582362,157.4230545,0.1144798,671.2765255),(735,'femur.tif',245,7,23,2006.3962807,127.1904698,121.91633,1.8,135.5217449,122.7652238,0.1207134,99.5849302,86.9376,594535.981712,4147980.1854304,4.8491512,47712.154315,5970.1400673,37945.4253487,71.976656,157.4230545,0.1144798,596.3378367),(736,'femur.tif',245,7,24,1937.3814871,128.0111455,121.9991887,1.8,135.0720871,122.6094718,0.1295599,101.188033,85.7128216,590538.6173934,4060461.0395211,5.3898147,47372.8546491,5836.0519494,36580.4951884,69.5351328,156.760528,0.1079701,568.4400316),(737,'femur.tif',245,7,25,1868.547107,129.0342769,122.0517569,1.8,134.7620813,122.4146329,0.1359037,99.8435718,84.2351943,572763.6109949,3901933.799788,5.7166234,46321.8946788,5736.6097832,36496.5953897,68.1494673,155.405031,0.0912948,569.4977936),(738,'femur.tif',245,7,26,1790.2443903,130.0725209,122.1408514,1.8,134.4567105,122.2345068,0.1391748,97.6433028,82.7663716,543376.3035417,3677680.5481443,5.7421723,44434.4783376,5564.9111424,36142.9501083,66.6552031,153.831203,0.0460667,516.3465885),(739,'femur.tif',245,7,27,1703.9861112,131.2831606,122.1781931,1.8,133.8196907,122.0075229,0.1422786,83.3275302,83.53097,510422.2701394,3403649.3764637,5.7103362,40747.1549246,6125.4938077,36546.2523309,67.0876095,151.0417256,3.1055072,478.8952312),(740,'femur.tif',245,7,28,1605.4403652,132.2842678,122.2463993,1.8,133.3259464,121.7470208,0.1513249,94.4414527,85.7740768,470948.1251882,3076934.0038198,6.0805995,35872.5400366,4986.6675224,29833.4595083,67.739751,147.6165458,3.0602908,474.5358552),(741,'femur.tif',245,7,29,1512.7673724,134.0997443,122.4570572,1.8,133.4923703,121.5960443,0.1615242,100.6792125,86.8244788,432645.4710124,2771638.5608545,6.5210224,31922.3172824,4297.2671333,27371.313367,67.1115223,145.9943589,3.0218673,498.3027504),(742,'femur.tif',245,7,30,1430.0532971,135.8923975,122.9363674,1.8,134.2831847,121.7768656,0.1694793,103.329007,90.0262652,401585.3948538,2462260.0333009,6.7806601,27350.4629701,3886.4729893,23399.8755964,66.3194186,143.6466506,3.0007686,490.0581119),(743,'femur.tif',245,7,31,1361.9869119,138.4194876,123.6653087,1.8,136.0829234,122.3751944,0.1719263,103.8682745,91.1646373,376981.0931808,2159178.0503539,6.6438957,23684.3815122,3629.4151902,20854.0999261,65.4897056,140.827289,2.9783524,486.6242776),(744,'femur.tif',245,7,32,1336.8210674,140.0656032,124.2375166,1.8,138.3382706,123.1234459,0.1774124,96.8553541,95.5882981,364610.2614753,1957145.6752012,6.9395103,20474.7413029,3764.4822503,19946.3683976,66.8435123,136.2631934,2.9849908,486.4920573),(745,'femur.tif',245,7,33,1307.383696,141.5902238,124.6806305,1.8,141.2497735,123.752898,0.1849064,80.3843148,95.4735528,351938.3688384,1754998.8501265,7.3654669,18382.0419205,4378.1970381,17859.6270273,64.1535584,130.6506625,3.0203416,465.9493233),(746,'femur.tif',245,7,34,1270.5567479,142.4116947,125.0476825,1.8,143.0337296,123.9769529,0.193757,104.2181172,100.3538533,337580.5347418,1589592.4717345,7.8508423,15839.8747947,3239.1732236,16082.7276605,65.4864667,126.3937171,3.0118901,443.9748519),(747,'femur.tif',245,7,35,1245.3735369,142.6565248,125.472555,1.8,143.8682183,124.3919957,0.2116895,78.0958213,102.7573773,327484.1497003,1448357.0053325,9.163263,14094.9199279,4193.3632861,14353.1976131,64.9576608,122.3019148,2.9940246,445.6162623),(748,'femur.tif',245,7,36,1243.4414474,142.7614983,125.8322239,1.8,143.9405411,124.8769578,0.2164695,101.262247,98.2966941,324567.159284,1348363.737535,9.5603377,13717.2846976,3205.2138767,14533.4951548,62.3164273,118.3434614,2.970388,418.3795585),(749,'femur.tif',245,7,37,1231.4502005,142.2559891,126.295614,1.8,143.6730145,125.5268184,0.2257545,77.6432486,99.2335048,323800.1119308,1263747.8285385,10.2836649,12735.0921595,4170.3576021,13793.6828875,61.2778741,114.7859811,2.9311625,468.4255338),(750,'femur.tif',245,7,38,1224.1567244,141.6875513,126.746327,1.8,143.1922006,126.3452787,0.2350379,65.7256766,100.4752754,325508.3353402,1161770.8531013,11.0649576,11562.7536085,4952.5292457,12753.2434873,62.4885041,111.3695811,2.959551,460.5227886),(751,'femur.tif',245,7,39,1213.7811911,141.2666007,127.2002868,1.8,143.1498163,126.942843,0.2478501,106.550515,97.7011051,331630.6458792,1068089.0599561,12.1746412,10932.2106271,3112.4264945,11873.7337706,60.7391328,107.4049434,2.937232,469.5928307),(752,'femur.tif',245,7,40,1205.2682813,140.2409665,127.5797158,1.8,142.5396325,127.7591898,0.2558951,74.7801792,102.7952632,341157.7971651,994938.3373729,12.8693298,9678.8344712,4562.142013,11001.2767312,0.544922,0.7706361,2.3561945,1.5412722),(753,'femur.tif',245,7,41,1204.5653434,139.3515168,128.0678617,1.8,141.7848024,128.793206,0.2572981,107.4127138,101.8422194,352909.5236441,917538.9541312,13.0001164,9009.4163232,3285.5470367,10748.6055809,61.0395533,99.6596656,2.9098758,441.4665593),(754,'femur.tif',245,7,42,1208.2521683,137.9740815,128.6408179,1.8,140.5432681,129.5660055,0.2405928,74.6986101,95.5502875,367547.0985614,850012.3465318,11.4334045,8895.9684858,4920.4007704,10116.8503169,62.1234628,97.0512063,2.9265778,364.7127612),(755,'femur.tif',245,7,43,1161.2973169,136.7388757,128.480842,1.8,139.4824988,130.0068958,0.2062406,109.7829,96.583781,372006.9574272,792064.0272834,8.1166019,8200.7974713,3388.5692346,9472.5252239,62.7207248,94.0949511,3.0021526,364.3935533),(756,'femur.tif',245,7,44,1162.4869665,135.0211096,129.064938,1.8,137.712013,130.7550343,0.1187033,97.9244293,88.1382076,396825.176616,764252.1265641,2.7172014,8671.0649954,4052.3613932,9811.8905492,64.1593508,90.8582896,2.9971511,367.850073),(757,'femur.tif',245,7,45,1173.9686463,133.101523,129.8432898,1.8,135.8698232,131.6639678,-0.0119085,97.700814,85.2331452,423433.714813,747615.4708886,0.027746,8771.4171431,4333.9834896,9255.8487554,65.1873458,88.2201636,3.0363924,354.2884347),(758,'femur.tif',245,7,46,1166.8189611,132.0611527,129.9892858,1.8,134.5841509,132.2617217,-0.089231,102.5653159,90.6081949,428743.1574938,718067.7840187,1.5442978,7924.9761578,4180.1963319,9847.3445606,65.6646369,86.5894617,0.2220819,402.7156849),(759,'femur.tif',245,7,47,1146.8198725,131.179859,129.8647069,1.8,133.4065955,132.3509848,-0.1461497,102.0173538,65.7363305,428251.5422845,684358.4894555,4.053645,10410.6585166,4197.8303346,9835.6287746,65.570623,85.710533,0.2048767,388.4381779),(760,'femur.tif',245,7,48,1125.1560303,130.8486987,129.4859069,1.8,132.5928572,132.6078654,-0.1881468,100.3427413,95.5042149,427240.1065359,648655.4988491,6.5603144,6791.904415,4257.8077995,8919.1190187,65.2084949,83.772787,0.2970642,403.8508998),(761,'femur.tif',245,7,49,1098.539139,131.1132269,128.6307665,1.8,132.2672448,132.1795543,-0.2281846,103.8882263,105.8981482,412701.5129666,600456.8146494,9.3688485,5670.1351708,3972.5532698,7826.4776439,65.5710883,82.4040278,0.3510309,408.0780556),(762,'femur.tif',245,7,50,1064.279912,131.2853073,127.7316794,1.8,132.0943321,131.5309782,-0.2433418,106.5159217,82.4452463,392501.957063,556846.5079289,10.2979001,6754.1372362,3684.9134911,8120.3810941,64.6107948,81.5728407,0.3618981,405.3147191),(763,'femur.tif',245,7,51,1047.2447345,131.3771353,126.8542795,1.8,131.798493,130.6726829,-0.2421218,88.4306605,59.4622968,378116.6328763,519848.7373407,10.0337047,8742.493396,4275.8544484,8665.3518931,64.1275974,78.8104934,0.6628625,344.4023857),(764,'femur.tif',245,7,52,1037.4904356,131.2381389,126.0217318,1.8,131.4764099,129.9535692,-0.2597513,101.7895578,37.9474833,362267.140107,494642.262118,11.4066687,13034.9161173,3558.9813711,8265.7369222,63.2543185,77.7941774,0.6911508,338.0276238),(765,'femur.tif',245,7,53,1026.7756708,131.1257959,125.1959723,1.8,131.4369876,129.0327126,-0.2776442,92.8995634,105.1316757,348613.3852259,467938.858096,12.8562183,4450.9787852,3752.5836759,6746.0037741,62.7533753,76.2968653,0.7752975,337.389208),(766,'femur.tif',245,7,54,1023.8823955,131.0467245,124.5229583,1.8,131.3298032,128.1105948,-0.3311996,104.4026216,53.7459379,340225.5059044,448372.3515097,18.0443089,8342.4416571,3258.7831672,7203.148557,62.9699746,74.1774771,0.7126103,367.3438774),(767,'femur.tif',245,7,55,1025.0356025,131.0038069,123.8441319,1.8,131.3148645,127.4083652,-0.3958876,97.0263335,36.5367818,330937.49852,425379.9344097,25.4052394,11642.5123927,3410.8008278,7678.3180578,1.5522437,2.4369653,1.1071487,5.7136606),(768,'femur.tif',245,7,56,1024.9197959,130.9414744,122.9636876,1.8,131.0422357,126.4049207,-0.4367064,96.1212594,47.3603383,321648.0191758,401785.7473333,30.5584699,8483.5911659,3346.2734591,7460.1717685,0.544922,0.7706361,2.3561945,1.5412722),(769,'femur.tif',245,7,57,1033.4662688,130.7820127,121.8431296,1.8,130.6810344,124.3731196,-0.5086568,108.9837117,35.2519671,310466.0741842,380864.9410282,40.8517851,10804.0762695,2848.738305,6186.4455113,0.544922,1.2184827,2.0344439,2.6311162),(770,'femur.tif',245,7,58,1034.984712,130.5845422,121.0096063,1.8,130.3818375,123.1944695,-0.5937151,92.9839517,34.4582416,298321.8265019,366750.9900971,53.9878718,10643.3460581,3208.3152114,6995.106703,59.4038772,67.204593,0.8542547,295.1364431),(771,'femur.tif',245,7,59,1035.7792514,130.4983984,120.1138114,1.8,130.2429195,121.8984605,-0.6535966,97.2358412,33.5802111,289859.9280042,349070.2122997,63.8246441,10395.1166835,2980.9988217,6529.5153648,59.3964989,65.9558256,0.9025069,307.0699598),(772,'femur.tif',245,7,60,1042.9456732,130.5103435,119.2378167,1.8,130.2972105,120.924777,-0.7045478,98.5031124,117.788235,279312.8537565,336818.2641052,72.9195402,2859.5238245,2835.573892,5219.5966869,57.5242415,64.7380189,0.7973024,301.5753689),(773,'femur.tif',245,7,61,1044.9749431,130.4860571,118.4316575,1.8,130.0167498,119.9799265,-0.7614148,95.0107028,32.4114921,269561.6659269,322861.07209,82.9058392,9961.314669,2837.1715816,6227.9088851,57.2168108,63.3095257,0.8462984,292.956755),(774,'femur.tif',245,7,62,1040.7108848,130.3269385,117.6549453,1.8,129.9712513,119.1432927,-0.8020446,76.8604688,37.7917062,258104.7885216,309962.1835868,89.6127265,8201.8573591,3358.0954217,6632.5026883,56.1269668,62.4595681,0.9464901,282.7514981),(775,'femur.tif',245,7,63,1037.0059735,130.3242321,116.8755288,1.8,129.9710868,118.0684242,-0.8238448,96.6490618,31.1882865,249564.3997093,296390.6143022,93.0555221,9503.267004,2582.1709502,5648.8391854,0.544922,1.2184827,2.0344439,2.6311162),(776,'femur.tif',245,7,64,1034.4486903,130.3019469,116.1633983,1.8,129.9070342,117.1566312,-0.8678126,87.6239553,30.1130328,240979.1831304,284261.3638652,100.3487233,9439.8118431,2750.1518539,5978.9540558,53.372826,59.1660849,0.8701619,242.1174582),(777,'femur.tif',245,7,65,1037.8824864,130.4778521,115.2095802,1.8,130.4027407,116.1160673,-0.9304325,43.090646,29.9210406,231809.7267619,269426.7931016,111.227958,9004.593021,5379.5834603,10557.5453047,51.5839153,59.5188553,0.8631631,246.8187276),(778,'femur.tif',245,7,66,1032.0602129,130.6130633,114.323241,1.8,130.6558864,115.0696663,-0.988951,27.0839611,29.1467095,222955.6871557,253740.3965532,120.0589803,8705.627542,8232.0191733,16241.3862811,51.2226688,58.4693951,0.8844111,246.4768343),(779,'femur.tif',245,7,67,1032.0914366,130.7180619,113.3919607,1.8,130.8917233,113.8746697,-1.0349312,26.8254795,28.0992087,215994.8858163,239839.4925985,127.1713593,8535.4536309,8051.8555572,16158.9076676,50.1328247,56.4540252,0.9292257,213.4943879),(780,'femur.tif',245,7,68,1032.2011245,130.7099476,112.475251,1.8,130.9602809,112.8849391,-1.028933,26.963515,27.6129294,209261.8792027,229385.6435533,126.2759092,8307.182481,7760.9272776,15781.388679,0.544922,1.7231947,1.8925469,3.7209602),(781,'femur.tif',245,7,69,1035.879941,130.6666494,111.6112545,1.8,130.8828236,111.9781516,-1.011988,26.489178,27.5310122,203432.8358763,221356.5225379,124.1179684,8040.2609494,7679.847061,15258.8471262,49.5576951,53.3745474,2.2694562,246.4995197),(782,'femur.tif',245,7,70,1044.3941105,130.6470845,110.8645972,1.8,130.94158,111.2138279,-0.9791345,26.1310441,27.3396889,199133.2936573,215041.9700089,119.9181728,7865.5602467,7620.5639788,15102.9266562,0.544922,3.3146312,1.735945,6.9904923),(783,'femur.tif',245,7,71,1045.8533456,130.5787218,110.0769176,1.8,130.8567994,110.3607878,-0.9422166,26.0830373,26.6031535,194533.5987628,209558.152061,114.043348,7877.1921659,7458.2417998,14836.8896061,0.544922,0.7706361,2.3561945,1.5412722),(784,'femur.tif',245,7,72,1044.6820523,130.5787949,109.319551,1.8,130.8312398,109.5895138,-0.8789416,49.4054566,26.4743402,190716.8201418,204085.7715206,103.2491871,7708.8142829,3860.2379836,7121.3536454,48.4980587,51.8707364,1.0177649,198.3461065),(785,'femur.tif',245,7,73,1055.9992454,130.7274426,108.4350175,1.8,131.0639205,108.7230519,-0.8444957,26.0170364,26.4158857,187672.2251484,199020.3471139,98.3768945,7534.1159911,7213.4359168,14368.9742665,0.544922,1.7231947,1.8925469,3.7209602),(786,'femur.tif',245,7,74,1053.1762458,130.727645,107.7841325,1.8,131.0865422,108.0826313,-0.8429602,25.8205561,26.6513202,183554.8406234,194473.6233859,97.8462069,7296.9602148,7108.8647434,14173.2411815,0.544922,0.7706361,2.3561945,1.5412722),(787,'femur.tif',245,7,75,1046.9717296,130.749963,107.1096736,1.8,131.1090275,107.3758958,-0.8107868,25.6303762,26.099518,179298.8635283,189631.3364843,91.6759374,7265.7026228,6995.5611376,14113.5131692,48.4466245,51.5721973,0.8977055,232.8925105),(788,'femur.tif',245,7,76,1046.7709802,130.8145213,106.4932944,1.8,131.1746989,106.8478039,-0.8360935,25.8696152,86.596085,176755.9113695,186615.8128698,96.0601727,2155.0144307,6832.5682565,4185.384768,47.9531367,51.4424847,0.9357696,253.4352446),(789,'femur.tif',245,7,77,1048.3839043,130.8558318,105.9212271,1.8,131.1494451,106.2352903,-0.8681547,26.2101538,88.622828,173992.3719451,184092.2564099,101.7594972,2077.2554941,6638.3575226,4039.3951389,47.4344001,51.1211198,0.9443511,249.0758685),(790,'femur.tif',245,7,78,1041.9822379,130.9025011,105.357239,1.8,131.1473046,105.4195745,-0.8836817,25.517018,25.6461936,171221.8296139,181392.4255935,103.7904246,7072.8790569,6710.1034074,13555.2910874,47.4082147,51.0717232,0.8760581,250.2431653),(791,'femur.tif',245,7,79,1049.8790421,130.9718218,104.9096758,1.8,131.2644016,104.985523,-0.930581,24.8405958,25.3983443,169929.8871292,179883.6505779,112.5385193,7082.4951593,6840.8136671,13614.876692,0.544922,0.7706361,2.3561945,1.5412722),(792,'femur.tif',245,7,80,1036.1279309,130.9515313,104.3566147,1.8,131.0418968,104.2449932,-0.9528211,24.9743937,25.3412142,167823.2199277,178039.5393919,114.7186626,7025.6909573,6719.8115705,13235.8796738,0.544922,0.7706361,2.3561945,1.5412722),(793,'femur.tif',245,7,81,1046.7815981,131.0749426,103.7676729,1.8,131.3185599,103.9461423,-1.0382094,24.7708025,91.7986945,166149.1643408,177088.0543418,129.4827086,1929.0912065,6707.4598836,3692.9331447,46.3183707,50.5692321,0.9229849,240.6536389),(794,'femur.tif',245,7,82,1039.2281644,131.0893232,103.2983022,1.8,131.3310993,103.5379652,-1.0781405,24.3060511,25.3289907,163276.882666,175060.5736233,134.4590922,6911.4705703,6717.5405122,13279.542855,46.6584425,51.0077272,0.8610113,218.382645),(795,'femur.tif',245,7,83,1035.2298224,131.1071427,102.8834573,1.8,131.3065705,103.0041351,-1.1333379,24.412283,25.6073265,161380.9477541,173692.7184076,141.5729117,6782.9305982,6610.6454574,13072.3140277,0.544922,1.2184827,2.0344439,2.6311162),(796,'femur.tif',245,7,84,1033.8046004,131.1402284,102.4915717,1.8,131.3408778,102.580716,-1.1451142,24.8136739,25.2848087,159484.9452896,172760.69341,142.9198282,6832.5885027,6427.3007621,12913.5150931,0.544922,1.7231947,1.8925469,3.7209602),(797,'femur.tif',245,7,85,1032.8808471,131.1765866,102.1295076,1.8,131.3464885,102.1918278,-1.1678463,24.2328062,25.1613225,157837.5174556,172397.8127058,145.6759855,6851.6991789,6513.3817422,12921.2244054,0.544922,0.7706361,2.3561945,1.5412722),(798,'femur.tif',245,7,86,1030.9392195,131.1881608,101.8118766,1.8,131.3878138,101.8157498,-1.1923024,23.8323558,25.1709753,156049.9628302,172583.2905718,148.361415,6856.4403415,6547.8194527,12858.9684482,0.544922,0.7706361,2.3561945,1.5412722),(799,'femur.tif',245,7,87,1028.4141497,131.2035865,101.4387415,1.8,131.4300128,101.4872701,-1.1789005,23.7101577,25.1424557,154799.7848371,173442.1257641,146.3983459,6898.3765202,6528.8382704,12946.5314175,46.6844095,50.1150524,0.7546386,243.043),(800,'femur.tif',245,7,88,1018.5020228,131.207315,101.057186,1.8,131.404346,101.0955725,-1.1601711,23.8660031,82.7386527,153048.9142798,173559.6266162,142.7011708,2097.6849517,6412.8423138,3849.4983542,46.6347378,49.8059908,0.925107,209.3994523),(801,'femur.tif',245,7,89,1020.9288323,131.2930098,100.5545946,1.8,131.5445842,100.5601543,-1.1685217,24.3316178,26.2455229,152096.3866511,174159.4181721,144.073145,6635.776264,6250.9771424,12375.3559408,0.544922,0.7706361,2.3561945,1.5412722),(802,'femur.tif',245,7,90,1017.3211914,131.2976039,100.2591652,1.8,131.5820812,100.2776483,-1.1574395,23.964993,25.2811944,150793.2349023,173966.8659875,142.1958283,6881.2755865,6292.2294608,12804.5807646,46.8632927,50.3043004,0.877445,220.5075656),(803,'femur.tif',245,7,91,1011.2131357,131.3093794,99.9573073,1.8,131.6025051,99.9495064,-1.1460467,23.5830165,25.5667128,149541.9046496,173354.0159234,139.9147517,6780.457757,6341.0846814,12418.5408866,0.544922,0.7706361,2.3561945,1.5412722),(804,'femur.tif',245,7,92,1005.0105091,131.2944575,99.6555629,1.8,131.5614409,99.5685438,-1.1134911,24.2964501,26.0166421,148030.0441291,173182.5836222,134.8472304,6656.6078228,6092.6614199,12293.5412743,0.544922,0.7706361,2.3561945,1.5412722),(805,'femur.tif',245,7,93,1000.6419819,131.2947649,99.3951814,1.8,131.4683786,99.2957562,-1.0902377,23.619343,25.5828451,146902.9372493,173553.9873544,131.1345001,6783.9986813,6219.603019,12416.2762059,46.6256402,50.9378217,0.967958,228.4009142),(806,'femur.tif',245,7,94,992.8070851,131.2992239,99.0970201,1.8,131.4651384,98.9314657,-1.0607475,23.5673418,25.6180463,145311.7358822,173664.2659991,126.0271528,6778.9816599,6165.8093396,12346.2249018,45.2285267,50.8064895,0.8994055,243.5491956),(807,'femur.tif',245,7,95,984.994234,131.3118304,98.8104535,1.8,131.4658376,98.7379291,-1.018749,101.5982308,25.578027,144388.9762498,174539.6446532,119.0154739,6823.8118735,1421.1760891,3057.6340387,44.974536,50.0171916,1.0584069,231.4286912),(808,'femur.tif',245,7,96,975.5388547,131.3016434,98.5449579,1.8,131.5260481,98.4946798,-0.9934002,23.0690394,25.5233259,143272.0480281,175317.5338254,114.146868,6868.914122,6210.5771216,12331.6437754,0.544922,0.7706361,2.3561945,1.5412722),(809,'femur.tif',245,7,97,977.496679,131.4025591,98.2096943,1.8,131.6537406,98.113625,-0.9731156,23.4620953,26.3378781,143737.5539403,176788.2985226,111.3268611,6712.3212361,6126.3733012,12127.5029755,46.3183707,51.4078394,1.012197,237.0101315),(810,'femur.tif',245,7,98,974.3121326,131.4044407,98.053151,1.8,131.6609546,98.0046792,-0.9622657,59.3134935,27.1210011,144016.4238064,177376.3091763,109.318154,6540.182953,2428.0549891,4927.8301146,0.544922,1.7231947,1.8925469,3.7209602),(811,'femur.tif',245,7,99,968.7277711,131.3969732,97.8544905,1.8,131.6627127,97.7127838,-0.9417062,23.7167147,26.1725262,143755.0387212,178236.6534148,105.5549109,6810.0668704,6061.3386286,12279.4071776,46.3183707,51.8821844,0.942,213.8362812),(812,'femur.tif',245,7,100,965.4627808,131.3686221,97.6332831,1.8,131.645624,97.4879339,-0.9160182,45.5694492,41.3871095,144166.0648778,179743.167864,101.2351091,4342.9746602,3163.6560786,5261.7987347,46.1894583,52.292642,0.9856839,224.4929663),(813,'femur.tif',245,7,101,965.6336563,131.3458698,97.4843022,1.8,131.603476,97.3838466,-0.8976503,24.1102229,25.9856666,144870.1305292,181885.6189868,98.3838335,6999.4594215,6008.6599538,12496.5794094,46.3183707,51.0048164,0.929432,207.1649969),(814,'femur.tif',245,7,102,961.869447,131.2993282,97.3382872,1.8,131.620931,97.2179828,-0.8798122,40.8539316,48.5034146,145068.6920147,183681.9135939,95.2016628,3786.9893282,3550.9114137,5184.0093695,0.544922,0.7706361,2.3561945,1.5412722),(815,'femur.tif',245,7,103,962.6209751,131.2910904,97.1891591,1.8,131.5617784,97.1341949,-0.8551908,23.3925781,26.3065636,146450.8911057,187130.7586173,91.3794054,7113.4626755,6260.5707788,12649.4719783,0.544922,2.778568,1.7681919,5.9006483),(816,'femur.tif',245,7,104,960.3328275,131.3059396,96.9977979,1.8,131.6276981,96.9148675,-0.8229113,23.6894424,25.9143177,147112.8428034,189517.0457278,86.0262804,7313.2176672,6210.0593412,12837.8373846,0.544922,1.2184827,2.0344439,2.6311162),(817,'femur.tif',245,7,105,963.4407994,131.4213563,96.7358072,1.8,131.804549,96.6961178,-0.7911052,23.3776751,26.349893,148266.9698211,192358.2426894,81.2031162,7300.1527028,6342.2461539,12872.3794987,47.0985185,53.0256995,0.8800054,210.0605536),(818,'femur.tif',245,7,106,959.3806399,131.3795279,96.5759442,1.8,131.7871391,96.425086,-0.7632179,23.7196282,26.6537427,147549.3794882,194365.8412214,76.4030023,7292.2532192,6220.5603727,12826.2981715,46.9976745,53.4051369,0.9374989,229.8326515),(819,'femur.tif',245,7,107,953.5864408,131.3524119,96.411872,1.8,131.8402042,96.3188544,-0.7348818,24.3686639,26.6434147,146494.2929949,196998.3142139,71.4505659,7393.8838708,6011.5849473,12718.3140071,47.2760082,53.5023509,0.9884434,246.841413),(820,'femur.tif',245,7,108,949.3597249,131.3161912,96.271491,1.8,131.882104,96.1783944,-0.7196949,23.539633,26.904336,145910.5139049,200927.7331876,68.7471933,7468.2286615,6198.5041923,12839.3672149,46.9759342,54.3885671,0.9132681,231.4286912),(821,'femur.tif',245,7,109,945.4754798,131.2817656,96.0923153,1.8,131.8960761,96.0929624,-0.7142952,48.9964737,41.0975324,145157.7272718,205065.6111927,67.6229949,4989.7305118,2962.6158023,5476.4786208,46.9040458,53.9720423,0.6132073,241.8436211),(822,'femur.tif',245,7,110,942.8804942,131.2282984,95.9451614,1.8,131.851364,96.0083118,-0.7083316,61.9157924,27.4056989,144494.4281142,209888.510963,66.5105039,7658.5717482,2333.7249288,5258.2500146,47.2283379,55.1664573,0.8343102,238.0452081),(823,'femur.tif',245,7,111,939.590669,131.1605855,95.8199582,1.8,131.8461902,95.9553306,-0.6995964,23.5631114,27.2743802,144383.963094,215788.0054528,64.928642,7911.74736,6127.5423643,13012.7915417,46.6234837,54.4404086,0.7216549,206.6588013),(824,'femur.tif',245,7,112,938.8857515,131.0386853,95.725089,1.8,131.694096,95.9375504,-0.7016177,58.0423768,37.9711655,145006.6268534,221933.0004442,65.191686,5844.7771489,2498.2889198,5290.4091796,46.042831,55.5072012,0.7576275,211.1503976),(825,'femur.tif',245,7,113,940.2055148,130.966836,95.4960711,1.8,131.8556069,95.5955029,-0.7023142,58.6531131,38.4566953,145866.862823,228450.1838067,65.3909616,5940.4528178,2486.9415304,5336.992044,46.6234837,56.129612,0.6337927,240.9955322),(826,'femur.tif',245,7,114,936.0841676,130.8692318,95.4594787,1.8,131.8029986,95.5630314,-0.6989938,59.3220513,28.5719227,147239.8201608,233272.1643205,64.5937111,8164.3845487,2482.0419558,5829.5539069,0.544922,2.778568,1.7681919,5.9006483),(827,'femur.tif',245,7,115,932.2641696,130.6899272,95.435375,1.8,131.6621519,95.5419947,-0.7040755,58.3780545,28.9750591,148577.5837196,239380.4269146,65.108617,8261.6027075,2545.0931024,6556.3959104,47.6088174,57.7848617,0.6717954,268.7705136),(828,'femur.tif',245,7,116,933.6165063,130.5455857,95.4578061,1.8,131.5899849,95.5724887,-0.7046516,56.2380732,34.9809417,151387.8489363,249430.9716132,65.2915255,7130.4819057,2691.9103084,6407.8882212,47.7794378,58.4693951,0.6863852,263.2665261),(829,'femur.tif',245,7,117,943.0357129,130.3835207,95.5726679,1.8,131.3827185,95.7888118,-0.7064274,24.6186856,29.8647776,155089.5695807,262356.0414888,66.2258113,8784.7981029,6299.6689503,13550.482915,48.3793362,60.188603,0.8366353,259.1715905),(830,'femur.tif',245,7,118,949.5020761,130.1044405,95.6951083,1.8,131.0992593,95.8986267,-0.7144727,64.9213224,30.7890932,159514.8526615,275323.0798799,67.938799,8942.2276226,2457.0487294,6533.723067,48.4600329,60.838779,0.5358112,272.7332289),(831,'femur.tif',245,7,119,959.5635729,129.9775108,95.9058131,1.8,130.8408483,96.3251684,-0.7205795,58.8435614,39.4452636,164563.9020766,289257.2119218,69.6263696,7333.129146,2796.633961,6928.9930916,47.7298625,61.5207052,0.5708053,235.5236267),(832,'femur.tif',245,7,120,971.2941424,129.8844807,96.1547631,1.8,130.5820904,96.6228372,-0.7309182,64.0556441,59.7047851,170666.6352676,302159.3336182,72.1392772,5060.8897271,2664.349688,6501.3285286,48.2344385,62.1808304,0.8536151,237.4067922),(833,'femur.tif',245,7,121,985.9562296,129.9115868,96.2918643,1.8,130.8073266,96.4389292,-0.7276157,69.8538769,105.2513139,178312.4639095,317158.6198691,72.688975,3013.3459454,2552.6494993,4689.2078474,49.9017017,63.8396541,0.6947383,291.1189603),(834,'femur.tif',245,7,122,982.2320621,130.1533539,96.2272977,1.8,131.1011764,96.1927233,-0.7127419,78.0266746,100.8769973,184008.6842819,318758.2098315,70.0002709,3159.8701214,2358.2792055,4945.6604377,50.3589919,63.9813627,0.7613064,289.4454679),(835,'femur.tif',245,7,123,982.5485282,130.429195,96.2409938,1.8,131.4535164,96.0576492,-0.7091548,81.1253231,103.1462934,189945.8479987,322095.7033833,69.4419077,3122.7074939,2341.3878777,4947.988181,51.0811444,63.8652313,0.6400882,259.4907985),(836,'femur.tif',245,7,124,990.1883443,130.5342965,96.3243904,1.8,131.7055569,95.9335634,-0.7135528,85.9970087,87.0963499,197598.8609689,332099.1353418,70.6997061,3813.0086491,2297.7410956,6046.0376683,51.7584546,64.1921826,0.6468967,281.4425844),(837,'femur.tif',245,7,125,1001.3612965,130.5973594,96.5501373,1.8,131.8054702,95.9693476,-0.7146006,83.1679659,86.1352482,206857.8123718,343849.9075173,71.6705577,3991.9767419,2487.2294303,6363.5793857,52.4032544,64.8067843,0.8329813,268.6062113),(838,'femur.tif',245,7,126,1010.0355436,130.6973429,96.7277245,1.8,132.0455354,95.8950297,-0.7031793,75.360583,102.6990993,216780.9600532,354245.7099061,70.3912528,3449.3555659,2876.5828442,5554.7529826,53.9039391,65.7461444,0.5788075,282.267988),(839,'femur.tif',245,7,127,1022.3490154,130.8771424,96.9739949,1.8,132.2328078,96.1060206,-0.691466,76.6791138,102.2857202,227370.1469977,370233.9556782,69.2844918,3619.6055016,2965.216155,5831.8653372,54.0103461,65.9445693,0.7444853,249.6595169),(840,'femur.tif',245,7,128,1042.4550924,131.015407,97.2263351,1.8,132.2824381,96.254992,-0.6828844,80.4964862,103.8128617,242519.9548157,389147.9091927,69.1847817,3748.5519888,3012.8017538,6068.5098557,54.9320034,66.4827182,0.9190987,251.7844375),(841,'femur.tif',245,7,129,1063.4279642,131.2654507,97.4610498,1.8,132.6217913,96.1237655,-0.6727652,87.6147195,59.8491501,259241.3381032,410209.7563402,68.824569,6854.061511,2958.8788219,7470.7109378,56.2732872,68.7941105,1.0113574,269.2446272),(842,'femur.tif',245,7,130,1074.1429089,131.5105643,97.8634579,1.8,132.9114913,96.4276602,-0.641925,89.8184245,103.7965139,272201.5866297,428402.9126646,64.1778241,4127.334307,3030.5762788,6748.8499454,58.38689,69.9031083,1.0303768,263.2665261),(843,'femur.tif',245,7,131,1095.2004537,131.8131376,98.1998419,1.8,133.2099294,96.4713023,-0.6228314,84.0851438,83.0937619,292901.6729628,451275.3951419,62.1129029,5430.9178579,3483.3938535,8771.080965,0.544922,0.7706361,2.3561945,1.5412722),(844,'femur.tif',245,7,132,1114.5107315,132.1155785,98.9244514,1.8,133.5430457,96.9234578,-0.5925203,85.2029989,81.0378953,313884.7833987,474849.4134965,57.9304687,5859.5970638,3683.9640304,8925.3181611,62.0362056,73.4109254,1.0673027,283.7318073),(845,'femur.tif',245,7,133,1139.8664376,132.5654417,99.5000096,1.8,134.1330539,97.2587106,-0.5674452,86.5469332,97.8001207,338719.6178916,507149.0537413,54.8815425,5185.5667442,3913.710231,8640.0581709,64.7334319,75.2012114,1.168759,333.271587),(846,'femur.tif',245,7,134,1183.1764856,133.3400118,100.2281578,1.8,135.2127411,97.7986279,-0.4947806,79.4305194,106.1050614,377151.4755542,560171.4174182,44.4621354,5279.4033583,4748.1934935,8670.0642568,68.7093263,80.8102986,0.1762347,358.0093949),(847,'femur.tif',245,7,135,1231.8267744,134.3069642,100.8753148,1.8,136.1634838,97.9009832,-0.4354956,89.705472,98.1443745,432808.0469761,631975.2454587,36.5371512,6439.2406478,4824.7675123,10547.9499699,0.544922,0.7706361,2.3561945,1.5412722),(848,'femur.tif',245,7,136,1278.8248171,134.4006041,101.1813573,1.8,136.2123306,98.0735284,-0.5224355,94.1865187,93.5002842,506766.3567222,692671.4265032,53.0697839,7408.228034,5380.455331,12335.9094179,79.1150704,91.9046144,1.2134136,365.8800581),(849,'femur.tif',245,7,137,1343.3584263,134.5039591,101.5582262,1.8,136.4640737,98.5350316,-0.6367906,93.1263536,93.0798802,584891.7649796,780668.5810592,79.1620283,8387.0819275,6280.6256465,14549.1028076,81.814615,97.0160142,1.250822,418.5023822),(850,'femur.tif',245,7,138,1435.9956063,134.1848014,103.1837372,1.8,135.9848219,100.5499553,-0.8240523,100.4567357,94.1770423,670966.8658873,925427.1591798,128.9082772,9826.4623369,6679.1625414,15890.8002367,83.7314968,102.2495001,1.2844441,414.8041074),(851,'femur.tif',245,7,139,1610.2570918,133.5259793,106.485748,1.8,135.4691781,104.0016769,-1.0016614,104.0833528,100.4320042,804294.4768756,1213104.3268907,190.4351684,12078.8620821,7727.4074604,19065.1407463,86.5245759,121.312172,1.3901393,467.2942112),(852,'femur.tif',245,7,140,1812.6953934,134.9015316,110.4006354,1.8,137.0800599,107.5880832,-1.1928924,98.2530261,92.9232933,1106907.8501022,1477022.9688459,260.9854946,15895.077715,11265.8906687,24185.1179406,93.8571214,125.215916,1.9779738,545.7215017),(853,'femur.tif',245,7,141,1952.0024525,135.5983944,112.3927911,1.8,137.9090211,109.5087816,-1.3116062,95.3198542,94.0846046,1303347.3860483,1696293.2565912,303.9630394,18029.4455653,13673.409347,27398.962929,96.9961174,128.8161511,1.9568015,530.6053024),(854,'femur.tif',245,7,142,2086.7333963,135.9973287,114.1121132,1.8,138.4461484,111.0701517,-1.3762652,93.7783106,90.2492426,1465859.5007999,1927855.2679148,334.7929219,21361.4564868,15631.1143984,29651.1701609,101.0453164,131.8891387,1.3879864,600.3365262),(855,'femur.tif',245,7,143,2214.28919,136.2565295,115.8326415,1.8,138.8710278,112.3053109,-1.4004383,93.0643227,92.9981738,1624652.7140066,2119855.8760717,358.4409411,22794.5968044,17457.3098169,32429.3349435,104.0872604,133.4703005,1.9558516,599.5111227),(856,'femur.tif',245,7,144,2316.6162419,136.4381993,117.0917251,1.8,139.3252573,113.1576277,-1.3919835,92.7816136,91.6270638,1773949.2122718,2289591.4293106,373.8884631,24988.1567104,19119.6201884,36451.8554453,106.8682268,134.8910377,1.9603047,647.3774099),(857,'femur.tif',245,7,145,2419.7749058,136.7281182,117.9590609,1.8,139.6832158,113.8227268,-1.3371691,88.3334698,98.2215653,1917385.612854,2451469.3847416,381.6808453,24958.5656419,21706.2186968,38604.2350911,107.8945576,136.9099601,1.9542591,720.6973737),(858,'femur.tif',245,7,146,2462.3590704,136.9956747,118.5315983,1.8,139.9587428,114.0886794,-1.2862373,96.4484624,96.5992264,2004627.468431,2551893.5962752,378.0493995,26417.3295257,20784.4419616,40359.1534488,108.83466,136.817752,1.9631365,719.1881836),(859,'femur.tif',245,7,147,2497.3705454,137.3747447,118.8018232,1.8,140.3527938,114.4347492,-1.2602067,101.9916138,106.6177754,2081439.5732605,2669953.7525475,377.3511719,25042.294715,20407.948214,40286.6913021,109.5293236,136.9500783,1.9756881,785.5497371),(860,'femur.tif',245,7,148,2518.8712506,137.832293,118.8204532,1.8,140.6351398,114.689127,-1.23404,100.430066,105.9404719,2121855.0641574,2763721.8892789,373.975888,26087.4983924,21127.6876489,42523.6962127,109.5293236,136.817752,1.9631365,776.2246511),(861,'femur.tif',245,7,149,2511.9076477,138.3428132,118.7190438,1.8,140.8584065,114.9382418,-1.209565,104.8206686,105.1472614,2130410.5024229,2830731.6664052,366.3574664,26921.5919614,20324.3361282,42806.5746861,109.4555806,136.2348613,1.9735873,740.1823458),(862,'femur.tif',245,7,150,2538.6100218,138.9542596,118.4936582,1.8,141.0391042,115.1469817,-1.1885269,95.7921517,106.4374978,2149648.4433857,2899407.8671465,364.2274166,27240.4737596,22440.7574582,45096.3935064,110.9378711,136.2272324,2.0308661,816.4847157),(863,'femur.tif',245,7,151,2548.9233777,139.2474872,118.4408867,1.8,141.0593217,115.4374439,-1.1606284,106.8763295,104.2445428,2148394.6726367,2916029.7959004,357.2689263,27972.9731335,20101.6883897,44553.6218636,0.9753389,1.9647442,0.9827937,4.1723884),(864,'femur.tif',245,7,152,2560.5342714,139.3684272,118.4662546,1.8,141.0134942,115.7563716,-1.1275949,110.7372905,107.2772603,2139176.1695749,2901818.0044306,348.2760012,27049.7027526,19317.5773075,42437.6634241,1.089844,1.5412722,2.3561945,3.0825444),(865,'femur.tif',245,7,153,2548.6986931,139.5779743,118.27768,1.8,141.1251362,115.8148004,-1.0641302,115.0257999,110.9149012,2097708.5971216,2839465.1392635,324.7543369,25600.3937154,18236.8529381,41034.7696801,0.544922,0.7706361,2.3561945,1.5412722),(866,'femur.tif',245,7,154,2479.1279018,139.6499344,117.8776725,1.8,141.1607183,115.6440287,-1.0139511,111.997074,102.8142266,1995762.5802267,2718240.8063555,297.7748621,26438.3723543,17819.774295,40829.4848943,106.8323261,131.4843848,0.8999389,718.7046734),(867,'femur.tif',245,7,155,2426.9647229,139.6320669,117.4820011,1.8,141.217527,115.3526728,-0.9602374,111.7161953,107.507335,1876418.5371994,2584577.1974241,271.5360445,24040.9382104,16796.2982579,39266.072279,105.5266255,129.8664733,0.8954001,746.2926671),(868,'femur.tif',245,7,156,2370.3902753,139.5925676,116.8240668,1.8,141.1999434,115.0822129,-0.8989179,101.6693545,102.9897866,1743770.0668193,2441031.7056268,241.9958917,23701.6871991,17151.3832773,40249.4670609,0.544922,0.7706361,2.3561945,1.5412722),(869,'femur.tif',245,7,157,2318.4840845,139.8923937,116.0038091,1.8,141.1348441,114.7485604,-0.825336,106.015161,85.3730065,1626469.60311,2257679.2845919,208.6231309,26444.884353,15341.8585379,36214.5664225,102.1185465,125.3770691,0.8777275,683.6105952),(870,'femur.tif',245,7,158,2261.221276,140.0628764,115.2961549,1.8,141.0331771,114.5553446,-0.7443316,99.5633348,104.0024484,1497911.3512209,2059349.2146239,172.975726,19800.968594,15044.8089529,34201.0583089,101.0320213,122.6558798,0.8766269,714.7098761),(871,'femur.tif',245,7,159,2157.5513355,140.0664664,114.5927834,1.8,141.1099342,114.3632025,-0.6811525,93.0290361,102.9130896,1323720.7065975,1816740.4431617,142.5810478,17653.1522935,14229.1134322,30103.1978321,99.1300321,119.5169379,0.8725554,695.8954019),(872,'femur.tif',245,7,160,2004.6295777,140.0498001,113.937688,1.8,141.0251399,114.1151187,-0.5836959,74.5551315,62.8313534,1139965.3991155,1537671.6708279,101.4757035,24472.9993414,15290.2338918,32422.9443767,0.544922,0.7706361,2.3561945,1.5412722),(873,'femur.tif',245,7,161,1798.4993222,140.3116288,112.9191991,1.8,141.0255667,113.6221689,-0.372356,77.4399423,99.6477912,913088.8810085,1214360.8166816,39.6744301,12186.5301977,11790.9292475,20541.460912,0.7706361,1.5412722,0.7853982,3.0825444),(874,'femur.tif',245,7,162,1550.6115649,140.7166072,111.3211504,1.8,141.2210663,112.584706,-0.1347808,61.0279781,51.6499731,657166.2062023,913797.262144,4.6663405,17692.1149654,10768.2775433,24055.000322,82.7517535,104.541267,0.8333319,607.801132),(875,'femur.tif',245,7,163,1079.323612,139.3216806,107.3836992,1.8,141.2673205,109.8052474,0.0559289,42.7716924,46.730955,329692.4273201,479514.917109,0.5621089,10261.1837626,7708.1922312,14519.9092859,59.2075346,91.1991735,2.2800707,432.1641588),(876,'femur.tif',245,7,164,497.811803,136.488155,99.8137779,1.8,137.6987232,100.2359488,-0.0723627,41.2740078,36.2418137,37423.7909045,120354.5705043,0.4336961,3320.8760285,906.7157005,2896.7537375,40.7238799,59.8174468,0.5247958,242.514119),(877,'femur.tif',245,7,165,153.9992001,145.0874896,100.4319072,1.8,140.4041604,100.3329198,-0.0827725,17.1081605,31.9817101,7805.5464567,34136.6487366,0.1754476,1067.3803456,456.2469737,1309.8972297,13.0781282,18.9159376,1.7738415,53.1285197),(878,'femur.tif',245,7,166,29.4130763,154.8165555,100.7180035,1.8,154.4582095,100.687268,-1.2394961,4.1477171,12.1684422,62.7378848,837.1700713,4.3835169,68.7984592,15.1258835,73.9522321,7.5605688,24.6904396,1.1861916,55.3082077),(879,'femur.tif',245,7,167,0.0186262,206.525441,173.8301206,1.8,206.525441,173.8301206,0.7853982,0,0,0.0004609,0.0004609,0.0015522,0,0,0,0.544922,0.7706361,2.3561945,1.5412722),(880,'femur.tif',245,7,168,2.0291799,153.5550396,157.262858,1.8,153.7216052,157.1162013,-0.1485764,1.0148188,5.8488893,0.5457909,15.8115403,0.0074109,2.7033407,0.537821,2.7793661,2.5994853,12.1848265,0.1798535,25.9145013),(881,'femur.tif',245,7,169,113.4166809,150.1067479,152.6765516,1.8,144.970526,149.971679,0.2099003,9.7317121,32.5771682,1267.4620308,13275.1519486,0.8206619,407.4986467,130.2403948,444.9552715,13.6230502,27.2515491,0.2013171,71.5463331),(882,'femur.tif',245,7,170,321.127917,147.6953074,149.1604032,1.8,142.551394,146.994745,0.1376868,13.2794649,33.3590848,7470.893917,53443.8773366,1.0082432,1602.078646,562.5899829,1821.4040464,18.5273483,19.6474424,0.9827937,61.3410762),(883,'femur.tif',245,7,171,521.8654723,146.884025,146.5610048,1.8,141.4135337,145.4197703,0.0563027,16.1671376,34.2751785,21627.1481396,90213.3859063,0.275427,2632.0325624,1337.7227736,3254.972542,23.4316463,24.0569335,2.913096,77.1277734),(884,'femur.tif',245,7,172,600.1837558,146.4558671,146.0940589,1.8,140.6272826,145.883829,0.018521,16.6809816,35.3271101,31251.1630011,106559.8646059,0.0343092,3016.3764936,1873.4606672,3897.1001382,26.1562564,27.4036721,0.3028849,87.6522383),(885,'femur.tif',245,7,173,612.4516967,146.0802403,146.8201969,1.8,140.3808524,146.5976465,0.0255126,23.5747358,70.8782508,32357.4040549,114919.844673,0.0664259,1621.3696507,1372.5457773,1971.6881752,32.7839674,56.8863082,2.9780188,199.2489629),(886,'femur.tif',245,7,174,618.1246004,145.9227125,147.5674019,1.8,140.246745,147.3884226,0.030078,16.807591,35.9765398,32723.9472282,119318.322014,0.0931732,3316.5591411,1946.9742717,4203.7665508,30.8491038,57.6536755,3.01841,189.8143421),(887,'femur.tif',245,7,175,625.3257552,145.8441642,148.2990185,1.8,140.0986404,148.059818,0.0349483,16.8474434,35.941282,33190.2325305,122768.0280225,0.1272422,3415.7943486,1970.0456501,4308.8608673,30.9180632,57.8772847,2.990375,186.2803695),(888,'femur.tif',245,7,176,631.3232232,145.7438876,149.0181272,1.8,139.9391135,148.7315176,0.0399656,16.9493319,35.8472754,33539.7626988,125906.9105191,0.1679737,3512.3146506,1978.825061,4424.0663577,31.0946709,57.8772847,2.990375,185.5097334),(889,'tibia',245,8,1,0.508371,103.8999532,82.8442004,1.8,103.9644386,82.8706946,0.3867539,0.8774658,1.647454,0.0996564,0.3809575,0.0120541,0.2312401,0.113573,0.291604,2.1624909,3.7803176,2.5213432,8.8515219),(890,'tibia',245,8,2,18.900375,104.539823,82.3190615,1.8,104.5727147,82.1366726,0.306219,2.6639033,6.6775182,20.5920073,148.3963762,0.2862637,22.223283,7.730013,25.212053,5.008813,13.6301291,2.7790484,31.6147434),(891,'tibia',245,8,3,54.4518746,104.7006704,81.6908848,1.8,104.8652045,81.5641509,0.274411,4.0018213,9.6229373,126.5859592,963.2708292,0.6664017,100.1015382,31.6320869,113.0808803,7.5011464,19.3209448,2.8414215,44.3459441),(892,'tibia',245,8,4,113.8808925,102.7998779,83.2365812,1.8,100.1444822,85.1572521,-0.4204903,8.4584028,24.8416784,1594.0250741,8181.4469937,3.162735,329.3435683,188.4546191,393.2487474,11.6767118,21.0065889,2.8661665,56.5622936),(893,'tibia',245,8,5,218.6943241,99.8554566,85.8992804,1.8,98.5019806,87.0750675,-0.4760471,11.5191571,23.1731041,5160.6514317,29869.0178583,7.6546964,1288.9519541,448.0059955,1509.2705071,15.8457263,26.4585743,2.5812328,70.9446772),(894,'tibia',245,8,6,375.0752526,98.8495006,87.9584977,1.8,98.3038443,88.733467,-0.4330924,18.4356405,23.7335767,14964.6730846,63908.6586539,11.0103993,2692.7529446,811.7251529,3319.2698306,30.6680897,46.4512423,0.4086185,175.9458521),(895,'tibia',245,8,7,609.6605149,100.0542847,89.8707819,1.8,100.5168543,90.2469121,-0.3462852,53.3207119,27.5670334,42105.4785037,121941.9045446,11.7051088,4423.4685289,789.6645974,3050.8634561,37.8806209,55.2471251,0.5526972,252.2447218),(896,'tibia',245,8,8,925.8826537,104.5783845,90.6580581,1.8,107.3845051,89.7039274,-0.4208756,35.850932,42.6380999,112087.5836343,272869.844325,25.7582294,6399.671767,3126.490091,8938.5791662,57.9611379,76.3915447,0.6630613,435.5782988),(897,'tibia',245,8,9,1310.42249,109.174275,89.162001,1.8,109.9208448,89.2249378,-0.6826021,38.1344053,43.9286215,248473.1367946,610105.2259672,86.90865,13888.5584182,6515.7207684,18302.4282594,65.5754816,87.0261193,0.975791,447.9195721),(898,'tibia',245,8,10,1457.0781243,109.3492908,87.8328284,1.8,110.541698,88.7218494,-0.8406743,48.981158,47.2147837,364296.4631232,858728.2246351,134.819459,18187.6979446,7437.4816323,23678.5286084,69.605804,95.3410476,1.0390723,397.5537878),(899,'tibia',245,8,11,1555.083411,108.7415898,86.5397205,1.8,109.9544484,88.5070093,-0.9776576,42.5815655,53.1118347,487418.3996391,1127590.3632192,178.2012981,21230.4916431,11446.6998616,30022.3285226,72.9176741,102.6713071,1.1473569,428.3779597),(900,'tibia',245,8,12,1751.6732828,107.0793264,86.768262,1.8,107.4619293,89.7971238,-1.0559662,45.6069264,63.7507909,631947.1578603,1581570.7174867,221.1648283,24808.6446418,13856.3855781,34098.9780676,77.1229169,117.0835082,1.1575262,413.8006125),(901,'tibia',245,8,13,1874.8492824,105.6168492,86.8245095,1.8,105.8856854,89.9438721,-1.0904137,48.5206903,82.5043358,786047.0983461,1874382.8373606,245.7447713,22718.5979763,16200.2455791,31086.0990424,81.1937166,119.6450641,1.056206,477.456616),(902,'tibia',245,8,14,1963.9408426,104.6307147,87.0784043,1.8,104.6201591,89.9217845,-1.0881201,83.3203774,83.220199,927706.8178358,1983432.0985532,256.8060636,23833.5418934,11134.212862,33785.9587071,0.439453,0.6214804,2.3561945,1.2429608),(903,'tibia',245,8,15,2033.2670306,103.266193,87.79667,1.8,103.3288027,90.041039,-1.0550899,83.8868167,64.5391504,1053144.8382986,2044268.3844875,256.4639524,31674.857363,12554.354541,36188.2659466,89.1628943,120.8335938,1.0110405,457.2234834),(904,'tibia',245,8,16,2041.4953604,102.3048966,88.3518076,1.8,102.3369384,89.9635087,-1.0034726,83.2019129,65.8940783,1144993.2157338,2025302.67713,241.9940883,30735.7311589,13761.6212915,36656.4586554,0.9837618,2.197265,0.6435011,4.3503627),(905,'tibia',245,8,17,1992.6031459,102.1655084,88.4264331,1.8,101.7977009,89.3761226,-0.9144416,85.6029462,70.2234789,1194993.0401615,1925809.7094767,208.4314927,27424.0145791,13959.7185916,35856.7048539,0.439453,0.6214804,2.3561945,1.2429608),(906,'tibia',245,8,18,1916.365992,102.2060164,88.6066018,1.8,101.6455847,88.9429482,-0.8243773,81.0880898,71.4979944,1182310.9639496,1824458.1220801,172.1342875,25517.6125951,14580.5748628,36708.1481632,97.2023136,119.1314855,0.9531197,510.2259857),(907,'tibia',245,8,19,1854.4795063,102.4794348,89.0410215,1.8,101.7867068,88.8326853,-0.7321835,87.8601388,65.9056426,1171953.5755711,1764691.6447546,138.1234011,26776.0327634,13338.8541334,33265.3154991,98.1345604,117.8692903,0.9952026,486.5655636),(908,'tibia',245,8,20,1786.8967728,103.2588277,89.5065063,1.8,102.1768547,89.073473,-0.6354938,70.1631709,66.7676067,1152431.8322658,1667983.7917876,104.9299458,24981.9317326,16425.0249542,38185.8121702,99.0314627,116.3986487,0.9869822,450.4755335),(909,'tibia',245,8,21,1699.7378065,103.908024,90.2149573,1.8,102.882535,89.9646643,-0.5132128,87.2624522,66.4090752,1106946.6304315,1544748.9909012,68.2898182,23261.1128086,12685.2569792,29785.6108487,99.0584755,114.8183974,3.095648,470.1496477),(910,'tibia',245,8,22,1629.3350097,105.0811223,91.547475,1.8,103.9502716,91.5201644,-0.3342814,83.2038496,67.3529285,1040798.9627228,1456166.7423621,29.2311843,21619.9469816,12509.0241385,28232.2898721,95.9682657,115.3009444,3.0882083,523.924427),(911,'tibia',245,8,23,1594.3760927,106.2185735,92.2901956,1.8,104.9481737,92.3729056,-0.188503,79.0942628,67.1554315,982023.8240421,1431803.6577147,9.3309506,21320.7424439,12415.8667091,25800.7106827,0.439453,0.6214804,2.3561945,1.2429608),(912,'tibia',245,8,24,1569.4113148,107.577785,92.799889,1.8,106.0563245,93.0476205,-0.0637127,74.1565272,71.2078446,933349.4360262,1398697.3966766,1.0603507,19642.4622066,12586.2074608,24571.8465227,0.6214804,1.2429608,0.7853982,2.4859216),(913,'tibia',245,8,25,1525.343504,109.3163722,93.1208965,1.8,107.2973523,93.3343751,0.0346937,71.7093712,71.1607122,869105.3722199,1334686.6008818,0.3058753,18755.9477686,12119.8297787,22974.3271989,0.6214804,2.4859216,0.7853982,4.9718431),(914,'tibia',245,8,26,1457.9936836,110.4081811,93.0887261,1.8,108.71279,92.9553928,0.0740162,64.821764,70.5333576,794824.6539924,1206090.11874,1.3288147,17099.5704726,12261.6942996,20961.6694274,0.439453,0.6214804,2.3561945,1.2429608),(915,'tibia',245,8,27,1397.2155837,111.2861423,92.7733582,1.8,110.4423552,92.6337527,0.1109084,65.1537421,58.7284688,726594.5053707,1088306.9737296,2.8527234,18531.1654938,11151.9995934,23940.5244469,2.5674031,9.3428989,0.8519663,34.2697561),(916,'tibia',245,8,28,1295.9983194,113.5134549,91.6619464,1.8,112.9065863,91.557816,0.3489486,67.5846362,82.9706181,616807.5093592,884547.075009,25.2508891,10660.9676405,9126.4456599,16099.7730231,0.439453,0.6214804,2.3561945,1.2429608),(917,'tibia',245,8,29,1224.8356874,114.3743264,90.565157,1.8,114.1679522,90.8468458,0.4861462,54.4822895,96.8000144,533588.514952,771398.7339659,44.562888,7968.9939962,9793.797585,13434.9361816,75.2794534,92.5525995,3.0655491,421.622432),(918,'tibia',245,8,30,1188.207696,114.4637788,89.7789593,1.8,114.6035802,90.5151045,0.5079294,50.6421753,92.5007944,493650.6047399,699017.8741486,46.8460655,7556.8850893,9747.8159653,12540.9596701,72.6536287,88.4130946,2.0967241,469.4215382),(919,'tibia',245,8,31,1148.4735328,114.6997167,89.2411296,1.8,114.9699279,90.2729885,0.5207164,57.956074,94.1255246,457461.7240908,642309.7118709,47.3760552,6823.9695329,7893.2490203,11487.5735357,71.0046931,85.8273198,2.1815223,439.3696431),(920,'tibia',245,8,32,1115.546461,115.0378746,89.0565279,1.8,115.4332398,90.4083614,0.5213693,60.7764692,61.5180659,426013.7203721,602241.8456537,46.1225804,9789.6745738,7009.5174277,16174.8307682,0.439453,1.3896724,2.8198421,2.7433472),(921,'tibia',245,8,33,1085.3924017,115.5454329,88.6779413,1.8,115.7986146,90.2661572,0.5276607,64.78298,50.1704256,396073.0528914,566599.1581148,45.862524,11293.4891681,6113.8442957,14853.6775968,68.6116953,82.6370305,2.1632237,459.6393651),(922,'tibia',245,8,34,1055.9852445,115.8225616,88.3998206,1.8,116.061036,89.8995625,0.5336685,55.0101137,95.3986728,371024.3570293,537393.20472,45.5430121,5633.1308279,6744.657152,9379.6019601,66.6219044,81.4174895,2.1602959,429.1502365),(923,'tibia',245,8,35,1031.0448698,115.9864848,88.1207232,1.8,116.1542668,89.662798,0.5294761,50.3858086,95.2917103,348544.8831186,507141.5127629,43.8378049,5321.9898283,6917.5208799,8894.2242981,65.4614137,79.9623346,2.1725176,399.3923564),(924,'tibia',245,8,36,1006.2686462,116.1303855,87.7323179,1.8,116.2609364,89.2287378,0.5214769,36.4192838,42.8842998,330133.7939621,475108.6221284,41.6200482,11078.8476057,9064.8074091,18491.3255057,64.3470864,78.1608887,2.1884314,392.0229262),(925,'tibia',245,8,37,984.7998479,116.1260073,87.472372,1.8,116.3012794,88.8762231,0.5110523,35.9011342,95.9109016,314609.9843188,448048.0056176,39.2630349,4671.5023873,8763.2324513,7839.6654178,62.7300851,76.5771284,2.1890445,363.1149406),(926,'tibia',245,8,38,973.7947603,116.0110967,87.1856155,1.8,116.2431102,88.6829066,0.4951771,48.3492441,90.6781568,303292.7465981,425599.8858264,36.6476548,4693.5215827,6272.9573533,7778.1367538,61.2792227,75.2633026,2.3974933,374.8347335),(927,'tibia',245,8,39,957.0562055,115.838068,86.9363225,1.8,116.2159063,88.4243746,0.4840386,52.87571,40.6326336,291466.3140075,402726.0895461,34.5429809,9911.3952004,5512.2912578,12595.9449205,60.4947532,73.8490274,2.2381025,379.7441147),(928,'tibia',245,8,40,948.1122822,115.8166175,86.6862088,1.8,116.1946642,88.0813836,0.4722761,47.9947109,39.7059774,280912.0748987,386054.5261386,32.7015131,9722.8314653,5852.9798314,11758.1605261,59.095888,72.6919556,2.2275977,323.3143229),(929,'tibia',245,8,41,945.6995829,115.6891995,86.3128311,1.8,116.0403047,87.9839082,0.4613909,53.7610857,39.3044981,272545.9185155,369574.3697537,31.2392504,9402.851783,5069.5761632,11745.8107735,58.1579067,72.1345735,2.3906636,394.7479787),(930,'tibia',245,8,42,942.4563552,115.5792995,85.993263,1.8,115.9390937,87.5451524,0.4505497,32.8055666,38.6962274,264511.7872868,354371.1601313,29.7856762,9157.7702436,8063.0153539,15647.8062069,57.8077041,71.5134655,2.3909631,373.8491983),(931,'tibia',245,8,43,941.9351096,115.3801673,85.6734281,1.8,115.796708,87.2848356,0.4349526,32.5788477,38.1110369,258410.7918298,339213.888621,27.8735028,8900.673311,7931.857933,15316.3701329,57.161014,70.5934432,2.3958213,350.8727185),(932,'tibia',245,8,44,942.1607076,115.2236011,85.4470979,1.8,115.6116689,86.9451555,0.4128717,31.5683845,37.6411282,252710.7063313,327734.7697898,25.2804743,8706.8264368,8005.1833732,14978.8500668,0.6214804,1.2429608,2.3561945,2.4859216),(933,'tibia',245,8,45,941.1594152,115.1403944,85.2506716,1.8,115.5199876,86.6198542,0.3826461,31.117559,36.98244,246894.6226185,316837.4101882,21.8678432,8567.2392074,7934.2541705,14870.6351524,55.7777346,67.9718876,2.4385764,342.1095311),(934,'tibia',245,8,46,937.8971681,114.9802264,85.049279,1.8,115.257919,86.3896601,0.3536166,30.313268,36.3363429,241494.6766429,304204.1074801,18.7452444,8371.8966603,7966.6328386,14576.6892831,0.439453,0.9826468,2.0344439,2.1218668),(935,'tibia',245,8,47,937.3790242,114.9252059,84.8489197,1.8,115.4069888,86.0819538,0.3209879,45.3586147,35.6206033,237133.8963964,294152.0986717,15.5515641,8257.9201738,5227.9792516,10641.4900711,54.052719,66.2467199,2.3984229,322.0972346),(936,'tibia',245,8,48,936.9948345,114.8570313,84.7044262,1.8,115.3397695,85.8866572,0.2837271,48.7899156,34.9978663,232401.7852156,285499.7531451,12.2377758,8157.6331188,4763.315989,10224.9746326,53.7911405,65.6552195,2.40828,369.826301),(937,'tibia',245,8,49,941.1513393,114.8464424,84.4589771,1.8,115.160147,85.6349144,0.2377677,61.997038,34.1952921,227601.081913,275930.3503,8.7019041,8069.2496838,3671.1605765,8120.0603082,52.9784799,64.5936118,2.4477255,368.7341367),(938,'tibia',245,8,50,936.0019106,114.7517129,84.2746279,1.8,115.028232,85.3966704,0.1881418,28.1061939,33.554018,221221.1195745,266287.6527425,5.457147,7936.0883953,7870.9027852,13673.4050845,52.6990416,64.2052714,2.4337088,322.781177),(939,'tibia',245,8,51,936.9766345,114.7637197,84.1504982,1.8,115.0331425,85.2053388,0.1461673,28.2708339,32.8968027,215568.0177345,259560.699657,3.3127037,7890.14974,7625.102919,13472.79606,53.0294835,63.4838495,2.4690139,353.3220507),(940,'tibia',245,8,52,939.3617119,114.7713972,84.0294628,1.8,114.9706807,85.0579957,0.1007075,28.0243166,31.8526482,210099.276977,254161.0060822,1.582475,7979.2739478,7497.0347993,13288.2282637,52.5943659,62.9661165,2.4352374,310.9547548),(941,'tibia',245,8,53,938.6118253,114.792662,83.9314401,1.8,115.005608,84.9462045,0.0588215,27.9891613,31.1048285,204393.6972786,248577.442694,0.5406368,7991.6030618,7302.601708,13180.0141523,52.1270627,61.9239021,2.5378433,338.9838344),(942,'tibia',245,8,54,940.1921819,114.7685177,83.8644952,1.8,115.0225742,84.8339655,0.0133945,27.6051932,30.0099226,198526.8270801,243465.0682426,0.0281117,8112.8189209,7191.6478126,13187.3112887,51.5342804,61.0001289,2.5096184,334.5268425),(943,'tibia',245,8,55,945.3684132,114.681503,83.7983182,1.8,114.9583031,84.6948591,-0.0420156,27.7448628,29.460299,193708.7499264,239497.1191009,0.2779813,8129.4870558,6981.787997,13162.1435815,50.3516593,59.6782999,2.5025098,326.3150956),(944,'tibia',245,8,56,947.110346,114.5187588,83.7261128,1.8,114.8216684,84.5643093,-0.1244123,45.0344764,29.4210114,188476.990125,234198.8687555,2.4307159,7960.2589242,4185.171123,9167.5418384,49.7421253,58.5116446,2.5702552,328.3745005),(945,'tibia',245,8,57,953.5135263,114.3886342,83.5450018,1.8,114.5625666,84.3249807,-0.2086992,27.1193865,29.0996429,182506.5540037,227291.4755206,6.8218584,7810.799481,6729.7449416,12898.304836,49.4640821,57.8961607,2.5451692,299.2898459),(946,'tibia',245,8,58,952.4601503,114.2189988,83.4780916,1.8,114.3686596,84.2378647,-0.2687534,26.4557616,29.3554406,177198.3348168,221082.7171293,11.1923736,7531.2348351,6697.9109338,12858.7847181,49.3043094,56.4213842,3.063626,306.7917779),(947,'tibia',245,8,59,950.8652219,114.0131927,83.4522402,1.8,114.0759011,84.2017944,-0.3332475,26.1528299,29.0283041,171371.9653195,214527.6071365,16.9576149,7390.290751,6552.7121136,12678.0426189,49.6318324,56.0108665,2.677945,315.8824307),(948,'tibia',245,8,60,949.0954332,113.8235089,83.4298611,1.8,113.8584882,84.0348385,-0.3955601,25.8984984,28.7996864,166081.0796452,208574.3817566,23.4862309,7242.2448941,6412.7686928,12534.9236995,48.7717395,55.3675902,0.7404846,305.140595),(949,'tibia',245,8,61,948.3779085,113.6735582,83.4253498,1.8,113.6171523,83.9543202,-0.4420628,25.4594275,29.035478,161143.1789443,203764.3061682,28.9282112,7017.7700019,6329.4109517,12194.0853273,48.1815964,55.0720704,0.7345945,317.3386499),(950,'tibia',245,8,62,947.0895711,113.5051836,83.4355316,1.8,113.4034938,83.8917378,-0.48737,25.2249489,90.7590663,156315.6941245,199405.3948787,34.6174513,2197.0851288,6196.8686233,3783.1170804,48.1151186,54.7043973,0.4133304,333.7987329),(951,'tibia',245,8,63,945.9699494,113.3529639,83.4737216,1.8,113.3211445,83.8146139,-0.5208736,25.2499064,28.8321717,152436.1601771,196164.8580735,39.0439093,6803.6795942,6037.0980234,11893.6725398,47.4258245,53.8074264,0.9011574,308.656219),(952,'tibia',245,8,64,941.2985779,113.1670268,83.5197678,1.8,113.1629517,83.849665,-0.5528233,38.5807172,28.6919161,148647.9420042,192294.7012679,43.2560769,6702.0515642,3852.9076871,7316.2662379,46.3935426,53.7391907,0.8896698,290.5266585),(953,'tibia',245,8,65,945.9803662,112.9985943,83.4752672,1.8,112.9293186,83.8817826,-0.5805803,24.9984436,28.3160035,145316.6504476,188440.3529126,47.4349814,6654.9064094,5813.0279094,11640.1983009,46.9392036,53.3496666,0.9256478,294.3180028),(954,'tibia',245,8,66,945.9148228,112.754705,83.5546262,1.8,112.6917837,83.9627631,-0.6117792,24.0242644,28.0431518,141772.5191945,185184.4609144,52.0015147,6603.5537684,5901.2220543,11459.0984402,46.6017571,53.615067,0.9190987,313.1573782),(955,'tibia',245,8,67,947.6606765,112.5012718,83.6487988,1.8,112.4566778,84.0134352,-0.6431062,24.4691814,27.8578299,138589.2210653,182069.5177209,56.7997621,6535.6676602,5663.8274432,11413.8849447,46.572246,53.2899052,0.8612756,287.6949768),(956,'tibia',245,8,68,950.6869088,112.270013,83.7389066,1.8,112.2215783,84.0439495,-0.6667847,24.7331526,27.7845562,135652.8724853,179724.4134357,60.6056524,6468.5004282,5484.6575598,11285.6935267,46.1650253,53.2899052,0.8612756,280.1305829),(957,'tibia',245,8,69,953.5537302,112.0580555,83.8432765,1.8,112.049201,84.1157786,-0.6882469,24.5106147,27.6123021,133137.2447976,177612.3430159,64.1199531,6432.3627276,5431.8198992,11210.1253216,46.0017558,52.7801165,0.8856526,300.3195483),(958,'tibia',245,8,70,952.6702403,111.9243479,83.9202071,1.8,111.8907405,84.2306184,-0.7029564,23.3569468,27.2094551,131024.1296488,175092.8957858,66.3584543,6435.001923,5609.6428618,11120.1002852,45.779725,52.3022922,0.9104901,296.119982),(959,'tibia',245,8,71,955.8055555,111.8152751,84.0408145,1.8,111.7987939,84.2972183,-0.7143318,23.2317731,27.3538703,129824.5032443,174036.0261799,68.3676044,6362.3912958,5588.2305203,11065.5168799,3.8467636,29.9505838,1.3187003,76.1739459),(960,'tibia',245,8,72,957.3767829,111.6919777,84.1878846,1.8,111.7166443,84.4243743,-0.7313076,23.0036513,27.1893885,128054.5413078,172866.7844819,71.1673764,6357.8768723,5566.7050316,11035.3882985,2.5943609,21.3168681,1.4259838,50.3474897),(961,'tibia',245,8,73,963.8565671,111.6532397,84.2337666,1.8,111.6894036,84.5607714,-0.749743,23.0759753,26.8486031,125778.2833769,171414.0043704,74.5984896,6384.4663967,5450.616133,10922.6142918,3.9321261,29.4662986,1.2679115,77.1153138),(962,'tibia',245,8,74,963.9240417,111.5221743,84.3566412,1.8,111.4962902,84.6507652,-0.7685886,22.9931766,26.9774562,123778.9770694,169693.807659,77.6269927,6290.2078881,5383.2917171,10823.3254413,4.0258598,28.9105304,1.2298174,71.8860451),(963,'tibia',245,8,75,964.3156049,111.429922,84.5209291,1.8,111.3752884,84.8606652,-0.7844957,22.6576166,27.1061757,122143.6261833,168072.1097925,80.214587,6200.5098581,5390.8417753,10703.2812193,4.0619327,28.2106921,1.2539718,69.4001235),(964,'tibia',245,8,76,962.8822528,111.3513067,84.7002055,1.8,111.2750244,85.0347354,-0.8048903,22.6320076,26.9185403,120480.6144561,166719.1122835,83.3675082,6193.4678004,5323.4612056,10629.8671551,4.566527,30.0182106,1.2583048,75.464131),(965,'tibia',245,8,77,958.1811526,111.2686577,84.8947334,1.8,111.0861475,85.2136849,-0.8290423,22.5788824,26.6978105,118371.0833593,164843.0697722,86.8094118,6174.4040574,5242.5572297,10521.476957,44.8222196,51.5041916,0.9307082,324.3881925),(966,'tibia',245,8,78,956.4156358,111.1868553,85.1115241,1.8,111.0156173,85.3895907,-0.8457529,22.7499659,26.8225151,116823.5718672,163741.0467836,89.2986519,6104.61198,5135.1097665,10454.143854,4.5469358,32.5373328,1.2832205,81.1457891),(967,'tibia',245,8,79,956.6441014,111.0895496,85.36712,1.8,110.935569,85.5606499,-0.8645652,22.1689234,27.0249988,115741.3877331,163512.6191573,92.290111,6050.4209672,5220.8844563,10330.2186664,43.5998534,50.6287239,0.9394474,347.7028546),(968,'tibia',245,8,80,954.2345037,110.9717802,85.6273669,1.8,110.8372822,85.8308808,-0.888532,21.9431629,26.5645336,114416.3990249,162993.7950968,95.8057921,6135.7672515,5214.2163708,10415.4654177,2.7252527,23.2702709,1.380808,54.9552781),(969,'tibia',245,8,81,957.7482735,110.9055258,85.8124673,1.8,110.714263,86.0018672,-0.919523,22.274318,26.9694922,112734.834998,162368.0450884,100.9661535,6020.4339022,5061.2025448,10169.2435692,43.0560727,50.9613922,1.0067126,301.2609163),(970,'tibia',245,8,82,954.5484098,110.805399,86.033391,1.8,110.5948246,86.1860416,-0.9424443,22.0906954,26.7733427,111110.3818357,160956.9054519,104.1216135,6011.8345118,5029.7367173,10147.0155016,43.4023807,50.5141618,1.0915858,305.203057),(971,'tibia',245,8,83,949.3433862,110.70285,86.2833419,1.8,110.5185775,86.3981326,-0.9633165,21.9020686,26.6439829,109433.7044744,159733.6621353,106.6725493,5995.1120234,4996.500852,10087.5773042,3.9904966,30.4873983,1.3083369,74.5227631),(972,'tibia',245,8,84,947.708254,110.5997147,86.5628632,1.8,110.4391001,86.6747452,-0.9848592,22.0488523,26.6219754,108221.4164482,159556.248339,109.6518392,5993.4037849,4908.2562297,10057.1810273,0.439453,0.6214804,2.3561945,1.2429608),(973,'tibia',245,8,85,947.3436688,110.4976341,86.8534543,1.8,110.3035869,86.9708699,-1.0059933,21.7493849,26.4610971,107168.7853544,159573.8494293,112.6562261,6030.5076923,4927.4398222,10079.3556353,43.0174727,50.2016151,1.1659045,304.0667254),(974,'tibia',245,8,86,945.2101142,110.4193261,87.1354015,1.8,110.257386,87.2621594,-1.0297192,21.6904459,26.4076869,106099.0658027,159345.3314896,115.7431332,6034.051072,4891.5115018,10043.3482865,42.6231703,50.2688902,1.1854199,310.5572496),(975,'tibia',245,8,87,946.7383873,110.3430821,87.4335038,1.8,110.1780505,87.5095618,-1.0518474,21.668195,26.4712381,105595.9066613,160213.2664388,118.975987,6052.3525842,4873.3134736,10032.4307752,42.6662286,50.3667587,1.060308,313.1939676),(976,'tibia',245,8,88,946.813411,110.257753,87.7508495,1.8,110.1207713,87.7845514,-1.0719977,20.9684684,25.8099418,105044.4549206,161523.7641291,121.6909742,6258.1994707,5009.6388988,10264.9285818,40.9887836,48.7812625,1.3804678,196.5613342),(977,'tibia',245,8,89,952.5283271,110.2771341,88.0184738,1.8,110.1631701,88.0750368,-1.0884675,21.5594395,26.4403217,104508.3105912,162547.8442287,124.5985048,6147.725662,4847.4502493,9571.2736336,42.0732659,50.2016151,1.1659045,324.3364474),(978,'tibia',245,8,90,951.1675409,110.2217945,88.3533745,1.8,110.0759948,88.4275168,-1.0986853,21.1646216,25.8817177,103366.5077348,163049.3288545,125.7422321,6299.7877741,4883.9289417,10280.5427163,42.0036656,50.4606105,1.2242575,300.2495085),(979,'tibia',245,8,91,946.3065616,110.1834918,88.723574,1.8,110.0324444,88.8226861,-1.1045791,73.8961011,27.312086,102405.033562,163247.6629556,125.8493662,5977.1217487,1385.7975196,3372.0027267,42.296596,49.0556327,1.3997567,271.0582247),(980,'tibia',245,8,92,943.9253466,110.1671051,89.0761813,1.8,110.0090913,89.1338888,-1.1145416,21.7906017,26.2029545,101622.5626292,163779.7198074,126.7819632,6250.4295121,4663.5959773,10088.4186574,41.9769151,50.9538126,1.3090828,306.6151089),(981,'tibia',245,8,93,941.3380209,110.1477981,89.4448253,1.8,109.9888316,89.4933498,-1.1200266,21.2702083,26.6197202,101066.9868641,164225.8178206,127.1122748,6169.3292302,4751.5748466,9905.4202922,41.6140727,50.8893405,1.2818209,298.1901036),(982,'tibia',245,8,94,937.8738768,110.146988,89.8264584,1.8,109.9453742,89.8537778,-1.1220974,21.3563709,26.6817924,100609.4242181,164397.7576978,126.8979512,6161.4210706,4710.9794471,9908.0550335,42.0589579,50.9538126,1.3090828,310.3622859),(983,'tibia',245,8,95,934.4772073,110.1688516,90.219002,1.8,110.015474,90.2247579,-1.1256433,20.921965,26.296415,100263.5082829,165302.0803481,126.8688425,6286.1070642,4792.2605924,10016.8246378,41.5039587,50.8741587,1.2271913,336.9168517),(984,'tibia',245,8,96,930.2541643,110.1788545,90.6033857,1.8,109.9968659,90.6302853,-1.131398,20.6414303,26.7521925,99867.3716838,166320.882094,126.9857538,6217.0934935,4838.2001728,9912.2567847,40.2575829,50.7658571,1.207973,250.9758885),(985,'tibia',245,8,97,932.2425871,110.3094063,90.9381997,1.8,110.1157924,90.9809071,-1.1404852,20.9442704,28.8831493,99508.3109589,167679.0758601,128.3360661,5805.4291241,4751.099411,8074.0236479,41.7477011,51.5884881,1.2140197,279.5015246),(986,'tibia',245,8,98,927.5190149,110.3345198,91.2945634,1.8,110.1433526,91.3593824,-1.1462739,21.4104208,27.0264579,98821.4663566,168104.4776064,128.3609383,6219.9966491,4615.5779616,9871.7034687,41.6366655,51.4366549,1.2760662,312.2084324),(987,'tibia',245,8,99,920.2610784,110.3604997,91.6668778,1.8,110.1230875,91.7150676,-1.1501469,21.0274114,27.3693238,98063.2497607,168226.2035804,127.8008763,6146.523927,4663.5911479,9641.4748706,41.69831,51.6109439,1.2948358,290.2799496),(988,'tibia',245,8,100,915.4532947,110.3797768,92.0725939,1.8,110.1111112,92.1593513,-1.1535622,35.4596289,29.218826,97805.485143,169308.7312977,127.520486,5794.508347,2758.2207757,5813.5313742,41.657323,51.6931984,1.321694,264.6926244),(989,'tibia',245,8,101,907.5762657,110.4131131,92.5017155,1.8,110.1259179,92.5620841,-1.1550881,20.9666961,26.6081875,97102.5380036,170106.5710747,126.5940146,6393.0161018,4631.2751283,9917.9965023,41.5601714,51.9168666,1.3052867,283.0171486),(990,'tibia',245,8,102,899.0562093,110.4269249,92.9403899,1.8,110.1290513,93.0156934,-1.1576089,20.6349127,27.3808852,96534.9896631,171213.3391557,125.6840417,6253.024241,4678.2359219,9705.1650359,41.0694801,52.2524216,1.2543649,315.5290927),(991,'tibia',245,8,103,893.9129838,110.4443591,93.3537636,1.8,110.1675813,93.3774662,-1.1629941,20.6821079,27.7566432,96575.4675055,173525.5971461,125.5521948,6251.678059,4669.51763,9715.5770755,39.9301678,52.0339075,1.297137,329.3524578),(992,'tibia',245,8,104,888.7517338,110.4555615,93.7991585,1.8,110.2242906,93.8018804,-1.1669544,20.8475873,27.5764739,96490.9908484,175776.5839923,125.2528333,6374.1500955,4628.40086,9862.4783547,40.3968598,50.8589724,1.4582307,264.1777731),(993,'tibia',245,8,105,892.7546212,110.5162207,94.2133509,1.8,110.1920306,94.2533843,-1.1719421,21.2230916,31.2581806,96576.1387835,178406.7047244,126.350728,5707.5204478,4550.5216908,8273.9728036,40.9738436,52.5766535,1.3602868,304.5115367),(994,'tibia',245,8,106,887.4123077,110.5046814,94.634434,1.8,110.1923598,94.6435052,-1.1754832,20.3424704,27.4894988,95910.2200724,179873.7867354,125.9682007,6543.3636404,4714.7774234,9851.6003507,40.7251063,52.8806414,1.3016288,307.1482547),(995,'tibia',245,8,107,882.6164621,110.4988869,95.0728258,1.8,110.1886499,95.0632252,-1.1769855,20.6575441,27.7201435,95713.7049484,181779.9843381,125.4442803,6557.6855445,4633.3535302,9953.5499052,41.4146519,53.0793011,1.3197936,304.5998712),(996,'tibia',245,8,108,877.2373389,110.5024493,95.538628,1.8,110.1522327,95.5665784,-1.1737937,21.0694711,28.1772759,95899.5459313,183961.7941541,124.3479912,6528.7288442,4551.5877143,9913.1673258,41.2640014,53.5429795,1.2101044,309.9357692),(997,'tibia',245,8,109,871.9657186,110.5081916,95.9842927,1.8,110.1059579,95.9921637,-1.1730877,20.6779805,28.1102504,96140.0651657,186391.7395651,123.5275226,6630.7392175,4649.3933547,10004.3405817,40.6994924,53.8666136,1.3654009,306.2068868),(998,'tibia',245,8,110,867.1383303,110.5292503,96.4312569,1.8,110.1014161,96.3661028,-1.172607,20.9930953,27.6658763,96595.4293708,189196.5047796,122.7940113,6838.6232464,4601.2952258,10205.7444019,40.1204273,53.9257358,1.2645085,284.1976475),(999,'tibia',245,8,111,861.176339,110.5478177,96.9214285,1.8,110.1502495,96.9002819,-1.1722195,20.229415,28.415419,96971.4220536,192596.8316894,121.9099723,6777.8987018,4793.5850833,10111.5604614,39.2855384,53.8666136,1.1326906,240.517351),(1000,'tibia',245,8,112,854.3038212,110.5599724,97.4000032,1.8,110.1832763,97.2604346,-1.1705692,20.4345505,28.0631241,97617.7985275,195841.9383139,120.7687193,6978.6221163,4777.0954768,10454.3750069,39.7465486,52.6060301,1.4619841,247.6110609),(1001,'tibia',245,8,113,852.5304041,110.674251,97.8585734,1.8,110.194692,97.8791259,-1.1648881,20.4283089,29.1879426,98051.000994,198789.7111253,119.9355126,6810.6791207,4799.7610241,10070.0068698,41.0703692,54.9333828,1.1680054,296.9913101),(1002,'tibia',245,8,114,842.6860784,110.681876,98.3090039,1.8,110.176079,98.2858217,-1.1595415,20.8167969,28.427097,98018.3649043,200507.7399606,118.0030314,7053.4018943,4708.6189829,10358.6125377,40.9494159,53.304399,1.3038212,264.479366),(1003,'tibia',245,8,115,830.7996077,110.6985249,98.7899338,1.8,110.1681347,98.8184641,-1.1535631,20.7340912,28.4410192,98038.2837908,201769.7482134,115.7285245,7094.3219891,4728.3617479,10405.0224149,41.7296227,55.6042644,1.224051,283.2745742),(1004,'tibia',245,8,116,818.3736329,110.7425544,99.2466983,1.8,110.2930003,99.2772205,-1.1451113,50.0509419,75.8466389,98298.646784,203047.7381409,113.1369621,2677.0828741,1963.9719653,3316.1453502,41.8206693,55.4094297,1.1888172,280.0605431),(1005,'tibia',245,8,117,807.8523375,110.7660016,99.747384,1.8,110.3222109,99.8218307,-1.1401158,21.1351077,29.5457945,98803.9052793,205407.2067063,111.1743096,6952.1639192,4674.871142,10290.6627756,42.011936,54.2150372,1.2234104,225.1311376),(1006,'tibia',245,8,118,798.98613,110.7928829,100.2192747,1.8,110.3644697,100.3074207,-1.1357061,21.1940298,29.422073,99643.357606,208080.3988501,109.5069462,7072.2548687,4701.4823839,10343.3013576,42.0181348,54.481539,1.1468391,243.8197166),(1007,'tibia',245,8,119,789.0258744,110.7989468,100.6927913,1.8,110.4617762,100.7719951,-1.1288479,20.6611648,29.4869184,100884.7694016,211028.5148166,107.4484116,7156.6825746,4882.8210094,10568.5451573,41.6327359,54.7784819,1.2185983,254.6864762),(1008,'tibia',245,8,120,782.1496697,110.7909233,101.1614255,1.8,110.5165324,101.2393764,-1.1200314,21.1642942,29.8658738,102300.9862314,214282.4515063,105.6169808,7174.8261324,4833.6592374,10521.4601024,41.7520036,55.1684192,1.0358413,244.2279387),(1009,'tibia',245,8,121,781.5918486,110.8810087,101.5636215,1.8,110.6783186,101.8077024,-1.1109949,21.1493957,30.8800264,104094.4276953,218191.1166136,104.6119099,7065.7684526,4921.8629838,10417.0715311,42.6597464,57.4524926,1.0592402,269.8152639),(1010,'tibia',245,8,122,771.8528605,110.8611767,101.9877212,1.8,110.6755982,102.2643318,-1.099875,21.2393195,30.8688601,104820.8283585,220005.7016293,102.1610911,7127.1080679,4935.2253643,10513.7297131,42.7351053,56.25685,1.0652153,247.0337478),(1011,'tibia',245,8,123,762.3248402,110.854978,102.4156907,1.8,110.7094764,102.6892628,-1.089583,21.7120716,31.0647465,105811.6298362,222089.7654169,99.8347233,7149.2540776,4873.4009332,10547.2784584,42.8704758,56.6007958,1.0237191,259.5075229),(1012,'tibia',245,8,124,756.4808855,110.8556567,102.821252,1.8,110.7639922,103.1274576,-1.0808217,21.7835561,31.4708322,107350.1159484,225139.1961431,98.1574736,7153.900316,4928.0344937,10549.3470876,1.4929709,4.5244456,1.0636978,10.9733887),(1013,'tibia',245,8,125,750.7952299,110.8291618,103.2807749,1.8,110.8404627,103.532102,-1.076097,21.8157573,31.8494112,109373.4379883,228443.3389184,96.927194,7172.6079268,5013.5063535,10600.3231339,1.450507,4.3281101,1.152572,10.6093339),(1014,'tibia',245,8,126,746.4542672,110.8099101,103.7203713,1.8,110.8402976,104.0056405,-1.0699172,22.3102138,31.6581638,111476.2115604,232449.6149719,95.7216795,7342.4857072,4996.6447084,10860.9161787,43.7517315,58.1889539,0.9408895,259.3384318),(1015,'tibia',245,8,127,748.2876097,110.7798544,104.1395672,1.8,110.726518,104.3214254,-1.0641617,23.8760331,31.401151,114432.6179461,238837.5781591,95.3498913,7606.0134806,4792.7818485,11220.0349078,1.294137,5.1436655,1.2220253,11.4882399),(1016,'tibia',245,8,128,753.7443902,110.7594678,104.5071607,1.8,110.7895872,104.5070792,-1.0621209,21.969267,31.670371,118546.1415654,244628.6134452,95.8273833,7724.2105266,5395.9989472,11432.1669669,1.318359,3.107402,1.7126934,8.4874671),(1017,'tibia',245,8,129,762.8113829,110.8391941,104.8545175,1.8,110.8281244,105.131922,-1.0637416,24.6705858,32.468762,123966.5959994,251222.3570089,97.1552287,7737.3555743,5024.8744404,11452.9440328,2.2174931,18.1191114,1.1722739,49.4868784),(1018,'tibia',245,8,130,763.9283126,110.8681624,105.1704164,1.8,110.850132,105.417134,-1.065233,23.8991701,32.4668693,128063.0480073,255795.2983167,97.4585503,7878.6561064,5358.4725844,11780.6092957,45.7478425,61.3788585,1.062307,289.8168436),(1019,'tibia',245,8,131,771.8409222,110.9027394,105.5546067,1.8,110.8714484,105.8019782,-1.0716448,23.7486139,32.8290841,133906.625459,262733.6571774,99.1641544,8003.0760576,5638.5027763,12053.7085339,0.439453,0.6214804,2.3561945,1.2429608),(1020,'tibia',245,8,132,782.4116092,111.0208476,105.9262885,1.8,110.9474227,106.2168589,-1.0710785,23.6483795,33.084749,140484.3600731,271472.5463542,100.4601603,8205.3681649,5940.5491314,12434.7144281,2.7613254,24.8941494,1.2099595,59.41227),(1021,'tibia',245,8,133,796.1311298,111.0596161,106.4099822,1.8,110.9044792,106.7539569,-1.0657986,24.5714265,33.1770916,147787.8229149,283111.3307998,101.630426,8533.3378264,6014.6212099,12980.6787824,2.588999,23.916904,1.2141762,60.6552308),(1022,'tibia',245,8,134,809.9050163,111.1511422,106.8543867,1.8,110.8798547,107.2534093,-1.0602959,24.9290913,33.7291599,155946.2960267,296122.9318922,102.7575656,8779.4339691,6255.5948968,13399.2299307,3.0488068,28.6286007,1.2587542,74.1587083),(1023,'tibia',245,8,135,824.7546923,111.2537275,107.2986709,1.8,111.0133367,107.8407258,-1.0520112,27.700098,34.2038969,166306.5028238,308205.5709478,103.6657668,9010.832055,6003.8236363,13872.7639034,2.581513,20.428657,1.2422432,58.533364),(1024,'tibia',245,8,136,842.8004282,111.3027814,107.7559148,1.8,111.0616501,108.3528294,-1.0497721,27.5013333,34.7061562,177951.6956944,322589.4698299,105.66277,9294.8774921,6470.6570204,14408.7745309,50.3593328,66.7173023,1.0541012,290.5007859),(1025,'tibia',245,8,137,864.0652813,111.5934184,108.2378251,1.8,111.2476854,109.1194309,-1.0374996,28.4525534,35.658407,189883.8705426,340610.246147,106.791963,9552.0320335,6673.7022751,14856.4539016,0.439453,0.9826468,2.0344439,2.1218668),(1026,'tibia',245,8,138,877.4330913,111.8532483,108.611175,1.8,111.4488226,109.5610962,-1.0358409,27.7197356,35.5427614,198777.7768917,354828.5492793,108.2315543,9983.1452388,7170.9838713,15512.4119432,52.2947835,69.5294643,0.9424647,319.6296078),(1027,'tibia',245,8,139,892.3571474,112.1153683,109.0549,1.8,111.5555622,110.0853487,-1.03869,28.0245563,36.7529263,207868.7873091,373535.5963539,110.443531,10163.4246191,7417.3801375,15761.3164457,53.7280943,71.4688941,0.9469729,341.2306251),(1028,'tibia',245,8,140,917.0723336,112.3265007,109.5800854,1.8,111.6907125,110.8177557,-1.0301013,28.4216936,39.117957,217964.389935,399325.7298181,112.3491521,10208.2460536,7668.9444748,15769.7170556,52.7114709,74.6876199,1.0334041,304.9897986),(1029,'tibia',245,8,141,963.6212546,112.5443056,110.0575809,1.8,111.9093397,111.2927127,-1.0078085,29.3349466,40.2994057,231475.1518593,433686.8902069,114.8552978,10761.6199886,7890.7643734,16491.8427374,55.1839685,77.0485314,1.004942,318.3424797),(1030,'tibia',245,8,142,1068.1471145,112.6292431,110.8282178,1.8,112.2900135,111.6163963,-0.9799297,29.700163,40.3329605,253437.5919718,496993.9144102,122.7765431,12322.2770686,8533.2054282,18531.5559273,56.1220431,78.843551,1.0772325,362.618384),(1031,'tibia',245,8,143,1189.9714571,112.8211164,111.2287342,1.8,112.7849462,111.4030811,-0.964365,32.2252288,40.419295,272575.7688564,571454.2670204,133.9054667,14138.1552173,8458.4587634,20830.5094416,0.439453,0.9826468,2.0344439,2.1218668),(1032,'tibia',245,8,144,1322.3633266,113.1669923,111.3701948,1.8,113.2961063,111.1018034,-0.962532,31.1598505,39.9848503,288095.3688774,643520.4636945,148.4246691,16094.1071048,9245.723717,23150.522293,0.439453,0.6214804,2.3561945,1.2429608),(1033,'tibia',245,8,145,1512.9500083,113.5145375,111.4576155,1.8,113.9536928,110.7674275,-0.9342892,32.985483,40.6376906,317004.4068127,690966.0912364,163.0708813,17003.0846152,9610.4218699,24799.7865297,0.439453,0.6214804,2.3561945,1.2429608),(1034,'tibia',245,8,146,1492.2651558,114.9104654,109.3655244,1.8,114.7940533,109.5876146,-0.8472943,32.2776233,40.8881332,320988.557072,608699.8615844,139.7103938,14886.9565482,9944.615639,22649.0374614,59.1999033,78.4998868,0.996768,391.916297),(1035,'tibia',245,8,147,1434.7374817,116.6211088,106.4579993,1.8,115.8406014,107.6122753,-0.7168757,31.9745131,42.5971305,309076.4715725,500159.1497251,103.2274055,11741.6160175,9666.3386509,18954.1801156,59.3220033,78.0261146,0.5645694,422.0748213),(1036,'tibia',245,8,148,1341.9759594,118.1594202,104.8187037,1.8,117.435854,105.997076,-0.4904703,33.5034677,42.8627843,305404.6291944,374135.4243576,49.6261432,8728.6775904,9115.6125045,15713.2495545,59.6918599,75.7008019,0.5702911,407.0267901),(1037,'tibia',245,8,149,1182.355724,119.4911452,104.1827624,1.8,119.370716,104.8804014,0.4636178,37.882673,31.6197751,232483.5580344,307553.5092404,39.4071532,9726.6191122,6136.936476,12566.4055302,1.318359,3.3467743,1.9756881,8.4874671),(1038,'tibia',245,8,150,972.2551927,120.9729675,103.8592652,1.8,121.0667456,104.6371197,0.5413554,36.7306203,32.5140819,137053.46192,276849.00425,43.0274871,8514.7415649,3731.3135713,10008.910571,50.5732897,63.6949188,2.0591303,285.2273499),(1039,'tibia',245,8,151,735.6292484,122.2537239,103.3684461,1.8,122.514152,104.3996683,0.4648843,28.0362389,32.3577635,94558.1057376,239733.0797555,24.642389,7408.8272433,3372.7100877,10184.43215,47.7149734,62.7449017,2.0751737,365.2109348),(1040,'tibia',245,8,152,542.3788128,122.8960549,103.2402862,1.8,123.5661855,103.9888142,0.4645039,24.9050643,32.6748163,69226.339177,187197.304418,18.1412573,5729.1004332,2779.608933,7750.22842,16.3243381,29.1102371,1.0666304,88.4344627),(1041,'tibia',245,8,153,375.0927504,124.4570781,104.2311792,1.8,124.2251884,104.6073312,0.4944696,22.9205001,33.4259299,47125.0710227,120681.2479388,14.079219,3610.4080986,2056.0228124,5004.4091859,0,0,0,0),(1042,'tibia',245,8,154,247.2752833,126.8880207,105.8632115,1.8,125.8172476,105.7104472,0.5675242,22.442026,34.4297115,32205.5275575,64540.9503794,11.9086009,1874.5713386,1435.0543744,2795.2772118,0,0,0,0),(1043,'tibia',245,8,155,134.1125007,130.5182977,108.9838953,1.8,128.815949,107.8611933,-1.4921642,33.0624276,22.3235706,15548.8598049,19462.036524,22.2141649,871.8155757,470.2879049,913.6206145,0,0,0,0),(1044,'tibia',245,8,156,34.2691313,131.0129173,112.7493057,1.8,131.9663132,111.7119561,-1.0823514,4.9319227,23.4065106,119.0209874,4254.4911469,4.4538528,181.7652881,24.1327763,186.8176203,9.4011326,13.1101432,1.8076451,37.3146961),(1045,'tibia',245,8,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1046,'tibia',245,8,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1047,'tibia',245,8,159,6.4874504,100.37306,119.2719729,1.8,100.371326,119.2821492,-1.3055354,4.5980627,4.5200831,29.405803,29.9886482,1.0069297,6.6345347,6.3952592,12.7064686,9.228513,9.6479702,2.6167969,29.706135),(1048,'tibia',245,8,160,50.2493139,100.357306,119.2559053,1.8,100.3617536,119.2327765,-1.2655086,8.9599035,9.0673165,826.3927752,841.2183977,7.6182912,92.7747919,92.2323298,183.9078983,18.017573,18.6236842,1.2341215,59.1990116),(1049,'metatarsus.tif',245,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1050,'metatarsus.tif',245,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1051,'metatarsus.tif',245,10,3,3.225906,56.3932151,72.4337247,1.8,56.5401038,72.506982,-0.3531774,2.5097111,3.2386197,2.7153463,8.1250832,0.0643211,2.5088106,1.0819358,3.3275122,4.9435585,6.4826069,2.896614,20.8462287),(1052,'metatarsus.tif',245,10,4,29.6030312,57.0602291,72.7440956,1.8,57.3100488,72.7665271,-0.2842645,4.8145954,5.7488075,78.627451,163.1698943,0.3880616,28.3832592,16.3310611,41.1997202,7.7363316,11.094867,0.3729877,31.6593864),(1053,'metatarsus.tif',245,10,5,54.8426949,57.4160046,73.0055122,1.8,57.4273054,73.0128461,-0.2045171,5.6691352,9.8749932,213.119336,759.1799127,0.3770189,76.8790316,37.5929185,98.3506925,8.8274166,17.6971382,0.4182243,46.0662885),(1054,'metatarsus.tif',245,10,6,76.8764335,57.8751208,73.1756817,1.8,57.5878086,73.2556228,-0.1876685,6.1101005,14.0363355,376.2550312,2031.045449,0.4459848,144.6991243,61.579189,171.4570678,10.1417443,23.8720398,0.3455556,60.0239725),(1055,'metatarsus.tif',245,10,7,104.659349,57.4360779,73.1534697,1.8,56.2988511,73.0634864,-0.1001939,8.086155,15.7456308,685.4966963,5040.9669697,0.1745243,320.1502081,84.7741229,359.7877246,12.2981439,28.5562785,0.3366748,80.1259124),(1056,'metatarsus.tif',245,10,8,142.4765207,56.1925392,72.6228901,1.8,55.4647604,72.6292113,-0.0088976,9.5736871,15.8095949,1434.363506,9995.9940149,0.0018798,632.2738871,149.82352,687.1135595,15.7595086,31.8216366,0.3306789,87.5313981),(1057,'metatarsus.tif',245,10,9,176.1656322,55.9437655,72.256221,1.8,55.5141215,72.1883893,-0.0071725,9.8743844,17.9822616,2260.6932594,16338.2697147,0.0015105,908.577024,228.945235,1008.2662981,17.0530954,36.2310428,0.3021452,125.0173952),(1058,'metatarsus.tif',245,10,10,204.4037829,56.4251549,72.0364746,1.8,56.2992604,71.5635063,-0.0332626,10.7068144,21.3952081,3008.8286622,23965.5635695,0.037678,1120.1369682,281.0199714,1249.9514419,16.7182714,40.3227927,0.1678959,157.6880895),(1059,'metatarsus.tif',245,10,11,297.0290078,59.4647627,69.8871467,1.8,59.9991781,69.136284,-0.1461669,14.9844828,24.7988921,7995.0422526,46528.1421027,1.0501487,1876.2185822,533.5547692,2194.2016175,23.9270188,47.7953001,0.1891008,201.1322703),(1060,'metatarsus.tif',245,10,12,479.6951583,63.6986702,65.7997103,1.8,63.5339633,65.0504348,-0.3162909,35.1877199,28.8171882,24110.192302,98368.6701886,7.7349346,3413.5415787,685.1876831,3284.1344073,36.5108562,56.3119489,0.3671738,378.792331),(1061,'metatarsus.tif',245,10,13,740.0826445,62.8022042,60.1222329,1.8,60.9277933,59.3051914,-0.2045273,32.1568734,30.8680004,92809.2785144,194607.617779,5.0882382,6304.5100223,2886.1412439,8178.1219918,52.1169336,62.1745187,2.8484058,489.3499292),(1062,'metatarsus.tif',245,10,14,1096.4283513,60.3388474,55.4018814,1.8,59.5031508,55.8457681,-0.1898709,28.30377,32.6558149,171746.8238715,300971.9000299,6.509095,9216.4872033,6067.9840074,14334.4568022,53.2842217,62.8604361,2.8254918,469.7384829),(1063,'metatarsus.tif',245,10,15,1264.3143966,60.0011018,53.6993455,1.8,59.6092433,54.6995584,-0.0630428,30.1998531,32.3087591,219107.6099557,344740.5752255,0.8363733,10670.1892724,7255.2541736,16788.8987955,0.224609,0.3176451,2.3561945,0.6352902),(1064,'metatarsus.tif',245,10,16,1317.8102046,60.2314428,53.035912,1.8,59.8855582,54.4811694,0.0720612,32.2761024,32.9493173,242093.2590961,372983.0777652,1.1385506,11319.903044,7500.6968441,17900.0268416,54.442861,64.8844098,2.6237346,361.6410989),(1065,'metatarsus.tif',245,10,17,1342.292167,60.3269038,52.3898528,1.8,60.1240821,54.2356076,0.1339032,33.5501829,33.4154946,250299.6656707,382406.2646679,3.987314,11443.9803658,7460.456079,17986.723405,54.8785344,64.9691047,2.6284499,474.8698267),(1066,'metatarsus.tif',245,10,18,1326.2943248,60.3911837,52.3208333,1.8,60.2354216,54.2503132,0.1506522,33.27496,33.5582927,246750.3142103,375573.9107355,4.9791053,11191.68707,7415.4954447,17417.5548932,0.224609,0.7102761,1.8925469,1.5337263),(1067,'metatarsus.tif',245,10,19,1290.5622496,60.4896687,52.4322994,1.8,60.2374688,54.1900036,0.1541731,31.9860374,32.9541848,239180.736733,360521.1368926,5.0722632,10940.0714836,7477.6607596,17321.2682787,55.3638418,64.5077724,2.4994843,424.4787288),(1068,'metatarsus.tif',245,10,20,1254.9822099,60.47874,52.5741675,1.8,60.2454045,54.1815769,0.1671574,31.9092005,32.7856561,230132.1862289,340840.2195778,5.7901352,10396.0164255,7212.0950363,16593.922191,54.4251229,63.0291484,2.421757,483.1511741),(1069,'metatarsus.tif',245,10,21,1213.9265963,60.569044,52.6718432,1.8,60.3957869,54.1444489,0.1822322,31.6607895,32.4381379,216233.5846618,319076.6458881,6.6447483,9836.4661583,6829.6965475,15794.5798928,0.224609,0.3176451,2.3561945,0.6352902),(1070,'metatarsus.tif',245,10,22,1161.2934393,60.5776188,52.7110649,1.8,60.5223312,54.0760489,0.1749982,31.8076961,32.7517998,199164.4952868,294471.7740394,5.8670497,8991.0104327,6261.5190627,14754.8454447,52.5847991,59.4938369,2.881963,301.5571496),(1071,'metatarsus.tif',245,10,23,1092.2836735,60.3770195,52.703873,1.8,60.4792539,53.9831559,0.1695603,31.6199389,31.53484,183802.6561615,269280.247094,5.1840189,8539.1347197,5812.8719584,13689.876959,51.2855502,59.5688353,2.374859,424.9053725),(1072,'metatarsus.tif',245,10,24,1028.5074782,60.1893256,52.6918998,1.8,60.3831399,53.8208349,0.1508967,28.843782,30.8504157,168875.1691853,243664.1056643,3.8736203,7898.2438317,5854.8206144,12923.0637769,0.8984361,2.0707928,1.7894653,5.4225414),(1073,'metatarsus.tif',245,10,25,967.207957,60.1512177,52.5891813,1.8,60.2831715,53.7689945,0.151853,31.2116092,30.3630098,153046.1513184,220459.5052117,3.6887115,7260.7922102,4903.5008138,11887.2623701,0.224609,0.502241,2.677945,0.9529354),(1074,'metatarsus.tif',245,10,26,917.9301463,60.070163,52.5336797,1.8,60.268751,53.621465,0.1545936,28.0318099,29.257825,141225.2291942,201306.0758963,3.6272608,6880.4183492,5038.0346317,11071.9913617,47.0542266,56.0159759,2.7551295,315.6783315),(1075,'metatarsus.tif',245,10,27,882.2177463,60.0216487,52.5799412,1.8,60.1327626,53.6159577,0.1517824,28.5680745,28.4756254,132094.4652877,185614.750631,3.3614757,6518.373109,4623.8490849,10117.0304811,46.0909594,54.9448016,2.7383112,295.9072605),(1076,'metatarsus.tif',245,10,28,847.3356179,60.0073272,52.5864768,1.8,60.2022036,53.5849372,0.1608324,28.8666523,28.3629538,123629.2496518,171303.8858208,3.6216245,6039.7054178,4282.770595,9917.3636306,46.8794337,53.9819165,2.7170313,393.8080758),(1077,'metatarsus.tif',245,10,29,823.0391099,60.0089634,52.6931699,1.8,60.2440867,53.6282513,0.1738836,25.2276431,27.2685681,117543.6123601,159691.806186,4.1058702,5856.2593208,4659.3180394,9544.1277863,2.1998613,20.2260389,1.6041173,59.6705293),(1078,'metatarsus.tif',245,10,30,804.33852,60.0295613,52.8234258,1.8,60.2687503,53.6411723,0.1845229,25.0209858,26.6831326,112666.5864127,149942.9820804,4.512879,5619.3920089,4502.8835989,9227.2798186,2.727527,18.0191876,1.6456562,52.4417652),(1079,'metatarsus.tif',245,10,31,780.6246239,60.0063046,52.89914,1.8,60.2198736,53.6375502,0.1986718,24.3033173,26.0766221,107106.6121843,140588.6902459,5.068065,5391.3689353,4407.0778752,8822.146165,2.2331114,17.5554615,1.6348113,57.1519427),(1080,'metatarsus.tif',245,10,32,757.4656538,60.0323626,52.9731261,1.8,60.2668525,53.6750785,0.2211044,25.4164779,25.6000412,102029.4640924,132317.4912941,6.0718032,5168.6436909,4014.3038186,8532.3806639,2.3474384,16.248099,1.667714,49.3517383),(1081,'metatarsus.tif',245,10,33,740.8620236,60.0997209,52.9738732,1.8,60.3820986,53.7262964,0.2358749,23.8713727,25.2990706,97375.679305,124709.986419,6.7434203,4929.4295589,4079.1822268,8219.9473447,2.8021763,18.8055568,1.7025586,65.0385714),(1082,'metatarsus.tif',245,10,34,724.9032566,60.0384607,53.0039792,1.8,60.2640244,53.7040028,0.2383857,23.1346959,24.5308495,93198.8667754,118137.3284017,6.7366923,4815.8678034,4028.5321824,8099.4664255,2.4051345,19.6079942,1.7434778,54.0074165),(1083,'metatarsus.tif',245,10,35,713.8694639,60.0220744,53.0984222,1.8,60.2671657,53.7467403,0.2555537,23.0213394,24.186293,89757.9606516,113173.9076396,7.6025062,4679.2580993,3898.9026224,8095.4652299,2.2799724,18.5217341,1.815775,52.1241201),(1084,'metatarsus.tif',245,10,36,705.9022341,60.0255774,53.1972021,1.8,60.2635848,53.7424569,0.273845,22.7028687,24.233759,86743.0186059,109392.1771313,8.6043775,4514.040809,3820.7955074,8016.7151263,0.3176451,0.6352902,2.3561945,1.2705805),(1085,'metatarsus.tif',245,10,37,700.3055974,60.0298922,53.297675,1.8,60.2412798,53.8139521,0.294886,22.4985896,23.7004088,84141.4824055,106518.6008173,9.8586984,4494.3782167,3739.8558697,7920.5378757,0.224609,0.3176451,2.3561945,0.6352902),(1086,'metatarsus.tif',245,10,38,695.821962,60.02943,53.3982384,1.8,60.2196019,53.8776085,0.320984,22.3032347,23.471039,81913.2736279,104150.8442397,11.54375,4437.4194278,3672.708224,7885.0303316,2.1038411,15.8600052,1.784857,44.4554886),(1087,'metatarsus.tif',245,10,39,692.7836965,60.0244766,53.4723506,1.8,60.1887384,53.961829,0.340055,22.0573165,23.1805153,79820.14668,102151.4973597,12.8451634,4406.7828603,3618.7605521,7779.3392213,2.1522921,17.0599384,1.7294516,43.9198463),(1088,'metatarsus.tif',245,10,40,689.9438034,60.0072335,53.5263885,1.8,60.164934,53.9651665,0.3546803,21.3144851,22.8842137,78007.5963022,100203.1636186,13.8691052,4378.7024907,3659.8395895,7636.8381172,1.7193822,13.8913006,1.815775,36.6552841),(1089,'metatarsus.tif',245,10,41,689.9618581,60.0678372,53.5530629,1.8,60.2039581,54.0037525,0.3731937,21.3898226,22.9737934,76165.9511273,98061.3494349,15.2857271,4268.4004294,3560.8500537,7449.5054829,3.0145324,21.6837876,1.8007008,69.585251),(1090,'metatarsus.tif',245,10,42,687.9451433,60.0628199,53.6478516,1.8,60.1968624,54.1036234,0.3943614,21.4384959,22.8363887,74930.1039183,96384.9748635,16.926202,4220.6749944,3495.1194526,6982.4930093,0.449218,0.6352902,0.7853982,1.2705805),(1091,'metatarsus.tif',245,10,43,686.1866672,60.0627421,53.7252324,1.8,60.2206647,54.1824097,0.407158,21.2669784,22.701377,73648.3491773,94721.3481131,17.934293,4172.4935127,3463.0377621,7336.7218249,0.6352902,0.8098393,2.1587989,1.9058707),(1092,'metatarsus.tif',245,10,44,685.3486905,60.0450383,53.7973314,1.8,60.2055871,54.2418037,0.4096682,21.0573848,22.6432241,72556.8929937,93564.1751742,18.1214044,4132.1048117,3445.674461,7296.6750294,2.1606831,14.1057324,1.7307094,41.256463),(1093,'metatarsus.tif',245,10,45,684.3251525,60.0207729,53.8525256,1.8,60.1535139,54.2421903,0.4154237,20.9035822,22.4596735,71629.1751512,92569.6323106,18.5765663,4121.5929595,3426.6459497,7242.389358,0.6738271,1.2095566,1.1902899,2.8043068),(1094,'metatarsus.tif',245,10,46,682.8423126,60.0054772,53.9191009,1.8,60.1066849,54.2899569,0.4200838,20.6007408,21.8358283,70687.1975828,91425.2458001,18.9296366,4186.9373921,3431.293965,7097.7977903,2.4698189,18.9751421,1.8588518,56.1445081),(1095,'metatarsus.tif',245,10,47,681.9601394,59.9935424,53.9696947,1.8,60.0922112,54.2903686,0.4247361,20.4260317,22.1238212,69861.7400127,90470.2634274,19.300634,4089.2693249,3420.2306734,7151.8171832,2.000408,14.5649899,1.8681615,40.4351006),(1096,'metatarsus.tif',245,10,48,681.5869222,59.9810057,54.0411429,1.8,60.0801757,54.3333719,0.429016,20.4089444,21.9089292,69099.3562934,89674.3394105,19.6565347,4093.0498532,3385.7388716,7061.9878236,0.224609,0.3176451,2.3561945,0.6352902),(1097,'metatarsus.tif',245,10,49,681.7412051,60.0367984,54.0717317,1.8,60.1655398,54.3598033,0.432901,20.1939743,22.0219645,68062.6476498,88490.8103304,19.9960655,4018.2977388,3370.443415,7063.2941062,0.6738271,1.2095566,1.1902899,3.2535248),(1098,'metatarsus.tif',245,10,50,680.6250239,60.0392575,54.1577097,1.8,60.1899244,54.4372412,0.4323988,20.2096499,21.794569,67224.6590257,87492.9073018,19.9199605,4014.436233,3326.3643518,6982.0801623,2.3926224,16.7841709,1.8417432,51.9380479),(1099,'metatarsus.tif',245,10,51,679.167638,60.0351628,54.2307309,1.8,60.1494585,54.4900632,0.4265159,20.1600498,21.5929193,66508.3896574,86638.3559746,19.3731227,4012.3502932,3299.0191189,7017.5287662,2.7987741,18.5026578,1.7539071,53.1541291),(1100,'metatarsus.tif',245,10,52,679.0337029,60.0406098,54.2968192,1.8,60.1811051,54.5784098,0.4191301,20.1537237,21.8354411,65935.8381979,86137.078548,18.7437403,3944.8288689,3271.6454351,6747.5734134,2.5075828,17.37783,1.8189098,50.876114),(1101,'metatarsus.tif',245,10,53,676.7138189,60.0389978,54.3579891,1.8,60.140098,54.6265814,0.4172104,20.3008992,21.7404029,65365.3213639,85660.2320933,18.5190106,3940.1400403,3219.8239382,6872.4186534,2.2806611,16.2341208,1.8224863,49.6148841),(1102,'metatarsus.tif',245,10,54,674.8066859,60.0280877,54.4131946,1.8,60.1625949,54.6784275,0.4141585,20.1256384,21.8852674,64835.1648845,85018.281716,18.2132138,3884.7266512,3221.5209148,6826.5202265,1.548298,7.4426631,1.6614562,21.4721683),(1103,'metatarsus.tif',245,10,55,673.9047151,60.0184802,54.478395,1.8,60.1233206,54.7301956,0.407507,19.972971,21.5675993,64523.8695844,84558.4980901,17.6418008,3920.6263515,3230.5594265,6750.8689617,2.3784845,16.7856737,1.7865625,47.6545141),(1104,'metatarsus.tif',245,10,56,673.5369557,60.0120062,54.5466607,1.8,60.1258871,54.781757,0.4013115,20.1035999,21.2599902,64222.6896588,84235.6072927,17.1290156,3962.165863,3194.5865343,6807.5514453,1.9691076,15.9614697,1.812362,48.3123787),(1105,'metatarsus.tif',245,10,57,674.3559451,60.0333368,54.5534354,1.8,60.1438133,54.8040099,0.3953723,20.0915028,21.8172744,63569.6916259,83585.2708774,16.6725434,3831.1509265,3164.0088043,6702.8334329,2.3180287,17.7611631,1.8004388,52.8909833),(1106,'metatarsus.tif',245,10,58,673.2688411,60.0176838,54.6061174,1.8,60.1676015,54.8547808,0.3844779,20.0646776,21.2321515,63056.9279774,83059.9543817,15.7860678,3911.9895374,3142.6833402,6690.8738903,2.3535238,17.2247441,1.7809789,46.6470795),(1107,'metatarsus.tif',245,10,59,673.3452945,60.0026172,54.663917,1.8,60.1786792,54.9066527,0.377396,19.9129955,21.6642017,62627.573413,82790.2355422,15.2392573,3821.5225547,3145.0603873,6517.5023938,0.224609,0.3176451,2.3561945,0.6352902),(1108,'metatarsus.tif',245,10,60,673.2469492,59.984544,54.7083149,1.8,60.1425028,54.9631629,0.3729267,20.0291043,21.5843249,62260.0850331,82779.3340182,14.895078,3835.1597537,3108.4807447,6544.266759,0.7941128,1.5067231,2.0344439,3.5711699),(1109,'metatarsus.tif',245,10,61,672.3726032,59.9529362,54.7469831,1.8,60.1129491,54.993823,0.3613718,19.8503411,21.7023787,61948.9694318,82903.3444539,14.0081099,3820.0118874,3120.8012599,6659.3666734,0.8984361,1.2095566,1.9513027,3.439597),(1110,'metatarsus.tif',245,10,62,672.5486251,59.9298797,54.7936485,1.8,60.1094245,55.0322123,0.3470289,19.8507109,21.5321864,61554.6574319,83032.6437265,12.9657998,3856.2105235,3100.8792427,6698.2237267,2.5599613,18.1502988,1.782754,58.7308177),(1111,'metatarsus.tif',245,10,63,673.4141195,59.9065056,54.8306273,1.8,60.0549268,55.0205909,0.3373774,19.3967757,21.2832052,61306.1062951,83258.4177168,12.2976545,3911.9304209,3160.6338786,6632.3542986,0.8040413,1.4381994,2.2455373,3.5711699),(1112,'metatarsus.tif',245,10,64,674.7157397,59.8841802,54.8899401,1.8,60.0241434,55.0903178,0.3289018,20.2305148,21.3670465,61131.3814919,83499.1072526,11.7323492,3907.8450756,3021.7412751,6739.9416854,0.449218,1.0044821,2.0344439,2.1690165),(1113,'metatarsus.tif',245,10,65,676.513826,59.9215866,54.9016949,1.8,60.0856744,55.1077861,0.3196424,19.7065327,21.1875989,60545.1653412,83321.9631108,11.1330125,3932.5816629,3072.3398313,6607.813753,1.2118589,4.5811431,1.7681919,12.8280271),(1114,'metatarsus.tif',245,10,66,675.6160288,59.9240333,54.9465401,1.8,60.1147171,55.171009,0.3116448,19.5565232,33.4408655,60004.5087531,83406.0969284,10.5867497,2494.1369116,3068.2605495,4158.4438258,2.1616799,14.1664025,1.6183794,37.367648),(1115,'metatarsus.tif',245,10,67,676.3380335,59.9154854,54.9962562,1.8,60.0925099,55.2097118,0.3034217,19.8151972,21.4082281,59623.8976312,83516.9211787,10.0632167,3901.1599152,3008.9984508,6600.9304485,2.5064257,16.1374975,1.7245039,47.4684419),(1116,'metatarsus.tif',245,10,68,676.1162404,59.904675,55.0355975,1.8,60.096647,55.2128674,0.2923397,19.3905421,22.4128009,59418.1589385,83778.9415351,9.3591924,3737.9951669,3064.2856072,6377.3949365,1.1230451,5.9085408,1.418147,14.438827),(1117,'metatarsus.tif',245,10,69,676.1111343,59.8794977,55.0871942,1.8,60.0663886,55.2560095,0.2828211,19.2219653,21.3431965,59187.4617033,84146.1225573,8.7756647,3942.5267286,3079.1576577,6605.8268087,2.0697781,13.5064557,1.6373645,32.5258976),(1118,'metatarsus.tif',245,10,70,675.9063869,59.8552164,55.1402877,1.8,60.0576247,55.2887126,0.2713025,19.3031443,21.632557,59031.3325404,84512.9933367,8.0902334,3906.7500622,3058.1200441,6617.3665392,1.7667907,14.5649899,1.8681615,35.0125592),(1119,'metatarsus.tif',245,10,71,676.5984431,59.8369208,55.1889213,1.8,60.0137235,55.3497762,0.2597738,18.7759724,21.3248725,58885.8396188,84997.5915073,7.4401094,3985.8428857,3136.2338169,6632.2829829,0.224609,0.502241,2.0344439,1.0845083),(1120,'metatarsus.tif',245,10,72,677.2626452,59.8174424,55.2313742,1.8,59.9953097,55.3690027,0.2489914,19.3023923,21.3910136,58697.2473482,85359.4201335,6.8545819,3990.433642,3040.9312199,6700.0200815,1.4995776,5.1708879,1.6142472,13.5403909),(1121,'metatarsus.tif',245,10,73,678.115619,59.8372997,55.2373471,1.8,60.0595393,55.3944618,0.240928,20.0937164,21.5291385,58173.1539631,85273.31535,6.4343928,3960.8326859,2895.0918231,6586.6674107,2.5732056,15.601841,1.686223,37.816866),(1122,'metatarsus.tif',245,10,74,675.6969616,59.8097138,55.2844034,1.8,60.0070631,55.4306944,0.2320088,19.8886716,21.7336016,57758.2985114,85080.8051759,5.9539254,3914.7126468,2904.0802562,6494.5189352,0.449218,0.9260867,1.815775,2.1690165),(1123,'metatarsus.tif',245,10,75,672.4899664,59.7825024,55.3359493,1.8,60.027109,55.4808268,0.2217468,19.5210707,21.5521073,57390.222451,84836.7525843,5.421497,3936.3553422,2939.9116059,6513.6719927,1.3125507,11.1130404,1.815775,24.5396209),(1124,'metatarsus.tif',245,10,76,670.7670035,59.760604,55.39658,1.8,60.0062591,55.5402509,0.2127636,19.7594465,21.5765227,57091.5595475,84970.4167503,4.984846,3938.0959488,2889.3299027,6458.9553281,2.681636,17.3995895,1.7656602,42.3409713),(1125,'metatarsus.tif',245,10,77,669.1907868,59.7387868,55.4540888,1.8,59.9677445,55.5965589,0.2051372,20.0420937,21.6345363,56888.5819811,85188.8558518,4.6279334,3937.6326261,2838.4550458,6562.6084667,0.224609,0.502241,2.0344439,1.0845083),(1126,'metatarsus.tif',245,10,78,667.0634506,59.7109975,55.5162697,1.8,59.9137293,55.6648173,0.198545,19.2446828,21.6999758,56702.6583005,85364.3037933,4.3253338,3933.8432738,2946.4064942,6452.1026641,0.449218,1.2095566,1.9513027,2.6182346),(1127,'metatarsus.tif',245,10,79,665.0391378,59.6987192,55.5656695,1.8,59.9208462,55.6867389,0.1945561,20.7938753,21.3556238,56553.8658987,85631.7399624,4.1428472,4009.7981073,2719.7367111,6621.7746998,0.6738271,3.8773528,1.7454685,8.5670676),(1128,'metatarsus.tif',245,10,80,664.14264,59.6885056,55.6290191,1.8,59.8893583,55.7523946,0.1914168,18.8680697,21.8374127,56514.7505251,86041.7368154,4.0064467,3940.1067364,2995.2587272,6521.8718222,0.449218,0.9260867,1.815775,2.1690165),(1129,'metatarsus.tif',245,10,81,663.9499393,59.7257794,55.6644264,1.8,59.9433443,55.8098239,0.1838757,18.9018073,21.5800396,56266.0588775,85985.3083259,3.6994119,3984.4833375,2976.7554975,6577.4411576,0.224609,0.502241,2.0344439,1.0845083),(1130,'metatarsus.tif',245,10,82,662.2211671,59.7199534,55.7267847,1.8,59.9601283,55.8859361,0.1766179,19.8485914,21.9037175,56073.9719698,86053.3510478,3.4072235,3928.7098706,2825.0857154,6475.067216,1.4642032,1.7105713,0.4048918,5.1593955),(1131,'metatarsus.tif',245,10,83,660.5375853,59.7044168,55.7932534,1.8,59.9811545,55.9583233,0.1692116,20.3274497,21.7286553,55952.7057623,86286.951095,3.1221778,3971.1132523,2752.5688965,6505.4046617,0.449218,0.7102761,1.8925469,1.7197985),(1132,'metatarsus.tif',245,10,84,658.2513035,59.6751999,55.8533445,1.8,59.9270805,56.0129276,0.1618736,19.9445384,21.7154768,55908.7397897,86632.4715824,2.8496802,3989.4344729,2803.2105178,6446.7334702,0.224609,0.3176451,2.3561945,0.6352902),(1133,'metatarsus.tif',245,10,85,656.4588583,59.6415119,55.9037992,1.8,59.8971275,56.0525191,0.1540976,19.9828011,21.7284212,55958.455379,86994.960467,2.5775516,4003.7405149,2800.3308937,6540.0519483,1.5287935,7.6828105,1.3045443,18.4047157),(1134,'metatarsus.tif',245,10,86,654.2456667,59.601139,55.9650345,1.8,59.8611542,56.0972847,0.1443764,19.2055621,21.7101844,55962.8035407,87423.4675542,2.25716,4026.8413251,2913.8852269,6587.3122529,32.8777865,40.6784232,2.6087488,126.6639933),(1135,'metatarsus.tif',245,10,87,651.7610125,59.5738907,56.0228394,1.8,59.8000501,56.1680867,0.1371564,19.6006309,21.824545,56038.1804846,88046.2966666,2.0306927,4034.2786865,2858.9988095,6597.0502235,0.9630308,7.2746974,1.4157996,15.8635547),(1136,'metatarsus.tif',245,10,88,648.9958301,59.5555404,56.0729406,1.8,59.8040132,56.17081,0.1306493,19.7615475,21.5242768,56088.2927606,88564.3671826,1.8358278,4114.6268385,2838.2540716,6623.4561462,0.6727556,6.1306331,1.423718,13.059248),(1137,'metatarsus.tif',245,10,89,648.3838965,59.5894702,56.1005943,1.8,59.8876553,56.2484714,0.1223543,19.9349989,22.3651624,56065.5361418,88977.1245832,1.6097245,3978.3804444,2812.4173156,6484.8197915,0.9812636,7.2190051,1.6642731,15.6774825),(1138,'metatarsus.tif',245,10,90,646.3195912,59.561755,56.162418,1.8,59.8472009,56.322843,0.1151876,19.8873048,22.0568866,56145.5711563,89501.5209985,1.4229383,4057.7585924,2823.1865417,6556.3926076,1.2395439,7.6499075,1.6295521,17.2112088),(1139,'metatarsus.tif',245,10,91,644.6782032,59.5322764,56.2359207,1.8,59.8271267,56.3984713,0.1074008,20.1234558,22.3291446,56296.8959999,90273.0717469,1.2346292,4042.8360899,2797.5759484,6563.7097634,2.0441286,13.2823526,1.6384893,30.3794554),(1140,'metatarsus.tif',245,10,92,640.9255922,59.5083447,56.3018172,1.8,59.8066051,56.4565982,0.1028265,19.6109361,22.4622912,56381.3537316,90993.9145324,1.1254739,4050.963171,2874.9955305,6555.526236,0.449218,1.3662433,1.735945,3.0674526),(1141,'metatarsus.tif',245,10,93,636.9947425,59.4868138,56.3603308,1.8,59.7992563,56.4843786,0.1006191,19.2155269,22.2522797,56528.8091415,91867.2965452,1.071222,4128.4442624,2941.829777,6659.2247482,0.449218,0.8098393,2.1587989,1.7197985),(1142,'metatarsus.tif',245,10,94,633.581777,59.4393155,56.4211784,1.8,59.6974286,56.5109805,0.0954592,19.4786194,22.4052086,56635.5246119,92861.5591565,0.9593285,4144.6415783,2907.5738671,6672.2572243,3.2146657,19.8839248,1.3312971,44.34649),(1143,'metatarsus.tif',245,10,95,631.5067551,59.3968665,56.4816573,1.8,59.6863853,56.5732221,0.0904725,19.2449127,22.4628278,56919.9001613,93985.3411591,0.8591611,4184.038715,2957.6595718,6703.4109267,0.449218,4.0678423,1.6814535,8.6441412),(1144,'metatarsus.tif',245,10,96,629.4736672,59.3727162,56.5445642,1.8,59.6947123,56.6356709,0.0851465,19.5333518,22.174999,57132.1749049,94987.8885971,0.7587702,4283.5577339,2924.8526057,6735.3595234,33.0948134,42.0595004,2.8823662,129.5453737),(1145,'metatarsus.tif',245,10,97,628.0955018,59.3801015,56.5913571,1.8,59.7030789,56.7494101,0.0794903,19.7456759,22.4424452,57200.7746983,95754.727636,0.6600663,4266.6798019,2896.8760041,6721.4341986,0.6676422,5.2866684,1.3567356,11.448448),(1146,'metatarsus.tif',245,10,98,624.8733566,59.3185802,56.6647104,1.8,59.6281984,56.8364622,0.0734191,19.5355464,22.8879241,57202.1556651,96625.2266503,0.5603744,4221.668439,2928.1062512,6696.0966231,0.449218,2.5112052,1.7506498,5.3135428),(1147,'metatarsus.tif',245,10,99,622.3523789,59.245654,56.7308615,1.8,59.5950795,56.9272928,0.0699317,20.9133024,23.2814252,57279.8974822,97762.3465541,0.5064356,4199.1564482,2738.9216838,6616.401387,0.224609,0.502241,2.677945,0.9529354),(1148,'metatarsus.tif',245,10,100,619.2539871,59.175211,56.8040597,1.8,59.5387014,56.9455286,0.0630869,20.2030719,23.310546,57425.7783235,99021.5760207,0.410222,4247.9303585,2842.4280469,6711.3446409,4.5301414,22.0128296,0.9374989,52.7461866),(1149,'metatarsus.tif',245,10,101,614.9792421,59.1164365,56.8780139,1.8,59.4505017,56.9798677,0.0581616,19.572543,22.8871806,57498.3142792,100168.5357032,0.3463324,4376.6218917,2937.7027944,6747.5572499,0.5671074,4.9617754,1.6614562,10.4410134),(1150,'metatarsus.tif',245,10,102,610.8635649,59.0634118,56.972985,1.8,59.3900541,57.1132186,0.0532209,19.1657605,23.5156424,57589.6585217,101358.3631404,0.2881017,4310.2527797,3004.8198981,6733.0948801,0.7939599,7.0920986,1.3796119,15.2282645),(1151,'metatarsus.tif',245,10,103,609.7081404,59.0015527,57.0554357,1.8,59.2868335,57.2250913,0.0493295,20.2623558,23.8388176,57846.0152494,102852.4238463,0.247076,4314.4935112,2854.8514163,6729.3375366,33.1306708,43.9252782,2.9251422,133.488688),(1152,'metatarsus.tif',245,10,104,608.5076173,58.9764221,57.1061213,1.8,59.3005585,57.2443457,0.0463283,19.8257317,23.9801101,57980.511871,104399.4838368,0.2175187,4353.5865069,2924.508046,6764.571957,0.449218,1.2095566,1.1902899,2.6182346),(1153,'metatarsus.tif',245,10,105,607.5352776,58.962881,57.1564291,1.8,59.2838493,57.3810689,0.0428551,20.5316528,23.872111,57931.3654347,105613.7719821,0.1858494,4424.1488334,2821.5636625,6831.768448,0.8135716,7.7188417,1.4247841,16.5759186),(1154,'metatarsus.tif',245,10,106,605.6757961,58.9501819,57.2151032,1.8,59.2494441,57.4854454,0.040469,19.9500173,24.2377722,57828.7926157,106952.7809131,0.1652326,4412.6489936,2898.683826,6784.6577204,32.7779274,44.8644916,2.9756209,134.5957706),(1155,'metatarsus.tif',245,10,107,603.8963454,58.9352734,57.27804,1.8,59.3121932,57.5820187,0.0362656,20.0345065,24.4925457,57799.5249685,108238.0104041,0.1323147,4419.2225646,2884.9986917,6750.5484074,0.6738271,4.5145854,1.4711277,9.7286495),(1156,'metatarsus.tif',245,10,108,602.4334406,58.8539848,57.328933,1.8,59.2115521,57.6449152,0.0304445,19.9822224,24.7558614,57840.391199,109826.770186,0.0930346,4436.3946061,2894.5925067,6761.4047374,1.0183371,4.3204407,1.4141944,9.7831488),(1157,'metatarsus.tif',245,10,109,602.8894709,58.8166628,57.371425,1.8,59.1603417,57.6415851,0.0280971,19.3416655,24.7443573,57971.6660136,111674.7917668,0.0793035,4513.1417368,2997.2427165,6824.4068434,1.0922495,8.026434,1.2578951,17.8239247),(1158,'metatarsus.tif',245,10,110,604.2095892,58.7230436,57.4163196,1.8,59.004859,57.7017925,0.0253933,19.7291438,25.0786791,58172.4661556,113548.4337233,0.0649198,4527.6879686,2948.5550229,6845.5181922,0.6738271,3.4358573,1.3734008,7.6686315),(1159,'metatarsus.tif',245,10,111,604.2174317,58.6882836,57.4615247,1.8,58.9219647,57.6645049,0.0245008,20.1947546,24.7342523,58196.3112639,115624.8993813,0.0604386,4674.6874677,2881.7538258,6586.8791161,1.0478101,4.1960427,1.2998495,10.0237203),(1160,'metatarsus.tif',245,10,112,604.9492663,58.5984136,57.527249,1.8,58.7991102,57.6890592,0.0225986,19.5537323,25.3779525,58466.3909131,117184.4932555,0.0514821,4617.5708254,2990.0374083,6906.8532001,0.449218,3.6217116,1.4464413,7.7457052),(1161,'metatarsus.tif',245,10,113,607.3627718,58.5524905,57.5397056,1.8,58.7993747,57.7878624,0.0201453,20.071624,25.9351634,58483.3977132,118672.7296968,0.0410762,4575.7463599,2913.7352143,6819.9400408,0.5630858,3.8773528,1.3961241,8.1949232),(1162,'metatarsus.tif',245,10,114,604.2357004,58.5128852,57.625614,1.8,58.770275,57.8818293,0.0189084,20.7996079,25.9798058,58182.3797835,119890.4645408,0.0360007,4614.7559912,2797.2825316,6836.8900667,0.449218,2.2905715,1.3734008,4.8643248),(1163,'metatarsus.tif',245,10,115,606.4643173,58.4451839,57.7242643,1.8,58.7254608,57.9861427,0.0161207,19.9524064,26.055121,58296.380386,121531.7918501,0.0262652,4664.4109511,2921.7718979,6864.3925153,0.7203485,4.7646768,1.4288993,10.3639397),(1164,'metatarsus.tif',245,10,116,611.0484689,58.4040708,57.8028839,1.8,58.7187137,58.0212462,0.0141097,20.7353931,26.0230377,58426.9771088,124225.9735899,0.0202733,4773.6922508,2817.7414712,6997.8850667,1.3157093,5.4649733,1.4056476,13.3543187),(1165,'metatarsus.tif',245,10,117,612.7216704,58.3389457,57.8944794,1.8,58.6801895,58.1327247,0.0122263,20.1511457,26.3455916,58583.3851897,126586.6803075,0.0152646,4804.8524416,2907.1987316,7002.8298992,0.5593126,2.9966581,1.3439975,6.3980511),(1166,'metatarsus.tif',245,10,118,614.0708352,58.2720821,57.9608713,1.8,58.6356115,58.1668759,0.009754,20.0000366,26.6462716,58596.6598817,128859.6255418,0.0097371,4835.9345515,2929.8276307,7023.4936823,0.5745394,1.5067231,1.1071487,3.2535248),(1167,'metatarsus.tif',245,10,119,616.7070052,58.2057255,58.0251818,1.8,58.5908107,58.181627,0.0058265,19.8306563,26.7099823,58855.8926282,131550.2915798,0.0034896,4925.1358619,2967.9246006,7103.7365442,33.6334247,49.7000428,0.0497327,144.6739902),(1168,'metatarsus.tif',245,10,120,620.512114,58.175164,58.1061348,1.8,58.5293657,58.2549062,0.0058416,19.864354,26.5194352,59151.287811,134348.7423418,0.0035293,5066.0483956,2977.7604514,7185.9645618,0.5745394,2.7782601,1.3258177,5.948833),(1169,'metatarsus.tif',245,10,121,623.4037558,58.1676304,58.1740188,1.8,58.5842878,58.4014309,0.004699,22.2283472,26.7290045,59073.2333808,136555.8934644,0.0022939,5108.9030731,2657.5630155,7231.4798123,0.224609,0.502241,2.0344439,1.0845083),(1170,'metatarsus.tif',245,10,122,630.353532,58.1648497,58.2573079,1.8,58.5713118,58.4705381,0.003027,21.6897782,27.4237253,59228.4599588,139428.6393259,0.0009631,5084.2340963,2730.7084163,7164.3220496,0.449218,1.8521734,1.3258177,3.9658887),(1171,'metatarsus.tif',245,10,123,633.2528787,58.0796295,58.3326758,1.8,58.5975281,58.523789,0.002531,22.2999464,27.0455622,59393.0215319,141905.498103,0.0006758,5246.9050908,2663.3705936,7259.7124975,0.661447,3.4868696,1.3101939,7.4825593),(1172,'metatarsus.tif',245,10,124,634.2924688,58.0524561,58.4290747,1.8,58.5844569,58.5449788,0.0019463,20.4681623,27.0873649,59625.1403231,144845.0403647,0.0004005,5347.3285682,2913.0675933,7330.5538986,0.6738271,2.5609368,1.3045443,5.8717594),(1173,'metatarsus.tif',245,10,125,637.6680255,58.0198344,58.5142171,1.8,58.5113976,58.5708593,0.0000499,20.3236636,27.3318777,59993.3140302,148299.2099134,0.00000009119,5425.8697971,2951.8946546,7394.1386081,34.2710629,52.4898347,3.0644926,151.6076835),(1174,'metatarsus.tif',245,10,126,643.5907781,57.9403319,58.5913982,1.8,58.4421991,58.676161,-0.0000729,20.9201945,27.6357997,60753.4351416,151675.7436851,-0.0000003,5488.3790418,2904.0568934,7523.6899623,34.3651797,52.9739308,3.0566909,152.1339752),(1175,'metatarsus.tif',245,10,127,648.9150961,57.883145,58.6983621,1.8,58.4318293,58.7366794,-0.003324,21.6435081,27.9019177,61532.3286877,155992.4532361,0.0011953,5590.7430791,2842.992384,7618.9678896,34.5478986,53.5931424,3.0702852,154.0943452),(1176,'metatarsus.tif',245,10,128,655.863313,57.7983502,58.7714347,1.8,58.3720679,58.8316426,-0.0021356,21.4204935,28.4527241,62598.2846665,160482.6081888,0.0004985,5640.3248962,2922.3549272,7781.6201452,0.449218,1.0044821,1.1071487,2.1690165),(1177,'metatarsus.tif',245,10,129,660.3332201,57.7738539,58.8364633,1.8,58.3654121,58.939512,-0.0022937,24.2764241,28.6989713,63424.8909404,164798.5330018,0.0005793,5742.3149934,2612.6125783,7874.1674767,1.0658166,6.1100259,1.2722974,14.6793985),(1178,'metatarsus.tif',245,10,130,661.4243754,57.7081149,58.9369188,1.8,58.3044971,59.0212782,-0.0009824,22.6021177,29.2163105,63776.5400264,168890.4178557,0.0001067,5780.6894413,2821.7063907,7950.2318448,35.1794242,55.4547792,3.0564333,158.9360956),(1179,'metatarsus.tif',245,10,131,670.8416684,57.6817807,59.0524093,1.8,58.2839127,59.0743852,-0.0020836,21.5463114,29.6858737,64588.7469819,174190.6619169,0.0004856,5867.7963777,2997.6707252,7922.1873036,0.449218,1.0044821,1.1071487,2.1690165),(1180,'metatarsus.tif',245,10,132,677.7387176,57.5848145,59.1705674,1.8,58.2222656,59.1478373,-0.0003624,21.6889723,33.7823264,65208.5767763,179300.7784926,0.0000139,5307.5320091,3006.5314239,6485.6203791,35.929378,56.7456802,3.0702852,163.0335572),(1181,'metatarsus.tif',245,10,133,681.1647693,57.5438163,59.3092236,1.8,58.1655983,59.195735,0.0034388,20.4616327,29.8257827,65706.6497669,183716.8540289,0.0013422,6159.665805,3211.21246,8229.1047804,36.0527636,57.3743061,3.0828368,197.3976025),(1182,'metatarsus.tif',245,10,134,683.5704476,57.4862921,59.4214495,1.8,58.1057322,59.2243475,0.0042706,21.467279,29.9049951,65875.6993506,188829.3558617,0.0020781,6314.3082011,3068.6562286,8293.3870005,36.4661006,58.0343804,3.0873823,209.1185469),(1183,'metatarsus.tif',245,10,135,686.9005847,57.4663872,59.5216183,1.8,58.0254296,59.2322951,0.0055419,21.7747071,30.3552712,66254.1677759,193668.8591953,0.0035167,6380.0734317,3042.7122418,8480.4019338,36.8782549,58.6466145,3.0495458,170.9972595),(1184,'metatarsus.tif',245,10,136,691.4017244,57.4678438,59.6665123,1.8,57.9847922,59.3431072,0.0085516,22.1573139,30.8299438,66680.4372281,198231.1447697,0.0084283,6429.8250366,3009.409779,8547.2866906,36.8978495,59.3176213,3.0505899,172.5309858),(1185,'metatarsus.tif',245,10,137,695.0337466,57.4339041,59.7591577,1.8,57.9554318,59.4524156,0.0105172,22.9375202,31.3107735,66805.687251,202946.5022176,0.0128121,6481.6828013,2912.5069671,8595.4799322,37.1623768,60.1738415,3.0593814,175.3897919),(1186,'metatarsus.tif',245,10,138,694.8500503,57.3871752,59.8317864,1.8,57.9191318,59.5075961,0.0148528,24.706885,31.3553441,67205.2721515,206822.6742745,0.0255457,6596.0900764,2720.1030096,8587.7698894,37.4145382,60.9750398,3.0826205,177.6903814),(1187,'metatarsus.tif',245,10,139,695.676653,57.3829968,59.9619506,1.8,57.8512473,59.5792203,0.0181157,23.2554634,31.8305489,67450.0150391,210701.7212788,0.0380461,6619.4812392,2900.394364,8608.6648219,37.4204178,61.5547559,3.053906,179.3782549),(1188,'metatarsus.tif',245,10,140,698.1913474,57.3877564,60.1499498,1.8,57.7757801,59.6919272,0.0200248,22.4814209,32.1180555,67611.4159998,215740.8451635,0.0466556,6717.1203801,3007.4351707,8706.9613529,37.8502895,62.4901685,3.048004,182.9494249),(1189,'metatarsus.tif',245,10,141,704.8878992,57.3116958,60.240069,1.8,57.6571741,59.7787827,0.0246153,23.1219089,32.5651781,68039.0590061,222049.1537767,0.0711698,6818.6070668,2942.6229219,8827.1144372,38.0881343,63.5865709,2.9712175,184.9004443),(1190,'metatarsus.tif',245,10,142,712.8693771,57.2490454,60.3601371,1.8,57.5660236,59.8523044,0.026816,23.0657486,32.6687569,69000.6996257,228330.0067965,0.0854175,6989.2468593,2991.4788791,9078.3349479,38.3603092,64.5800728,3.0090411,190.4864835),(1191,'metatarsus.tif',245,10,143,723.2657975,57.1942427,60.4994221,1.8,57.5430382,60.0151848,0.0281836,24.1940819,32.8939844,70079.8464651,235862.5916211,0.0957243,7170.3868074,2896.5697742,9207.2073488,38.5406278,65.4418329,3.0142577,192.0202098),(1192,'metatarsus.tif',245,10,144,737.7032915,57.172264,60.676339,1.8,57.6135527,60.1956869,0.0320183,27.351538,33.3773905,71011.5728752,245059.4704513,0.1260024,7342.0799738,2596.2552043,9339.9878001,39.2118048,66.3129358,3.0500128,196.0499484),(1193,'metatarsus.tif',245,10,145,757.567072,57.2420355,60.8852499,1.8,57.6972264,60.4674855,0.0349745,23.046977,34.5339204,72618.107159,255881.9426131,0.1543805,7409.5828069,3150.8734121,9470.0174274,41.1166963,66.6979115,2.9587271,269.183795),(1194,'metatarsus.tif',245,10,146,779.2503568,57.2343878,61.1319691,1.8,57.7949203,60.6972437,0.0399992,23.3547381,34.1257798,73817.5327025,268496.4180873,0.2076812,7867.8471197,3160.7090756,9867.3933682,40.2050141,67.1821303,0.0267495,203.5963576),(1195,'metatarsus.tif',245,10,147,807.6379748,57.240741,61.3450625,1.8,57.7680341,61.0364239,0.0433841,23.1701137,34.6198295,76108.1685402,282568.0904309,0.253195,8162.0301089,3284.7559422,10213.7055878,40.8349696,67.66102,0.039846,208.0433892),(1196,'metatarsus.tif',245,10,148,845.8487268,57.2785409,61.5574835,1.8,57.7907506,61.3534665,0.0426364,23.8588218,35.0469585,78520.8437231,298109.9890893,0.256117,8506.0159804,3291.0612445,10647.6820081,0.449218,1.8521734,1.3258177,3.9658887),(1197,'metatarsus.tif',245,10,149,884.24822,57.387725,61.7728839,1.8,57.8149778,61.7126657,0.0411987,25.3322983,35.0632394,80737.3317247,311757.1982311,0.2500029,8891.2833986,3187.1301498,11046.4865329,0.8984361,1.2095566,1.1902899,2.990379),(1198,'metatarsus.tif',245,10,150,930.6724857,57.4946764,62.0330531,1.8,57.8706337,62.1771419,0.0413289,30.298657,35.4597635,82936.716111,327481.4791432,0.2647928,9235.2978869,2737.3066734,11505.2467084,41.6118424,69.2320635,0.0389413,212.4810703),(1199,'metatarsus.tif',245,10,151,984.401583,57.631713,62.3691455,1.8,57.843769,62.7297414,0.0397419,24.5235628,35.8873215,84014.6440444,340361.474373,0.2589966,9484.1704651,3425.8743181,11816.9703439,0.449218,0.6352902,0.7853982,1.2705805),(1200,'metatarsus.tif',245,10,152,1017.9565608,57.390077,62.677107,1.8,57.6588906,63.1542558,0.0430436,30.7470696,35.3595316,84965.0613454,344298.7465337,0.3141438,9737.0844889,2763.3547656,12048.9202092,39.7116781,69.2440859,0.2323908,317.2743034),(1201,'metatarsus.tif',245,10,153,983.1638957,57.1534115,62.793363,1.8,57.421662,63.4037321,0.0368637,27.8320003,35.9298495,82532.9189161,334853.1188477,0.2225743,9319.6360035,2965.396595,11577.8719558,3.0218785,10.8418938,1.3408919,31.7458107),(1202,'metatarsus.tif',245,10,154,946.5583765,56.8943031,62.8313386,1.8,57.2049513,63.577665,0.0414105,23.3039954,36.1955165,81192.7754678,330970.1323756,0.2703773,9143.9538474,3484.0710424,11374.4879366,3.2582811,10.3051244,1.2835149,27.9114949),(1203,'metatarsus.tif',245,10,155,950.704155,56.6413418,62.9690789,1.8,57.0016038,63.7505244,0.0623289,21.8917276,36.9431906,83350.5189436,338313.0795054,0.6147667,9157.6573126,3807.3979539,11318.0265276,3.9366716,10.8952739,1.3208177,31.4055912),(1204,'metatarsus.tif',245,10,156,945.0389533,56.2626796,63.0377981,1.8,56.7031176,63.706458,0.0745591,22.4012521,36.2519075,84788.1911752,348311.8827478,0.8739673,9608.0980753,3784.975537,11690.3277907,40.2617611,71.0993095,0.1874826,400.8227159),(1205,'metatarsus.tif',245,10,157,934.9241006,55.7930717,63.056786,1.8,56.504467,63.6670562,0.0849756,22.0468705,37.1660824,84991.4285947,355625.9242285,1.1224542,9568.5609341,3855.0336854,11576.8204194,41.202434,70.8273829,0.0920954,420.8927308),(1206,'metatarsus.tif',245,10,158,934.97669,55.4438346,63.05987,1.8,56.2833396,63.6239215,0.0946367,24.2119758,37.6134984,86170.1464625,363313.9131515,1.3914637,9659.1364542,3558.9886319,11559.49394,40.8702683,71.6009724,2.9202017,344.5637318),(1207,'metatarsus.tif',245,10,159,945.7647493,55.1991134,63.0864851,1.8,56.2516259,63.6355214,0.1004235,26.6158258,38.1487538,87774.2811934,376172.9253677,1.5843193,9860.6871247,3297.8229467,11715.0182846,1.8694517,7.8130369,1.2490458,21.6130918),(1208,'metatarsus.tif',245,10,160,965.5771633,55.1967083,63.0948049,1.8,56.3314988,63.5951077,0.102097,28.5171639,38.3914777,90031.3208859,391076.1509765,1.6716747,10186.5355036,3157.0923763,12084.6913883,0.9354272,1.9058707,0.7853982,4.3925324),(1209,'metatarsus.tif',245,10,161,985.6841854,55.4446395,63.0090316,1.8,56.5855895,63.5053058,0.1007458,28.2931277,38.6264152,91708.1519663,404197.5762961,1.661768,10464.2787574,3241.3578637,12529.003446,1.1230451,1.4381994,2.4668517,3.5711699),(1210,'metatarsus.tif',245,10,162,999.8702436,55.7797106,63.0092762,1.8,56.7113432,63.4725033,0.1016299,23.7688514,37.9019592,91402.4951102,415173.6292331,1.7152998,10953.8830804,3845.4737982,12970.341271,33.9462364,41.8159018,2.2572817,208.1843128),(1211,'metatarsus.tif',245,10,163,1013.3956311,56.1366251,62.9773859,1.8,56.8483509,63.4133102,0.1030617,23.5311055,37.8640773,89241.72564,424145.3904327,1.7876579,11201.7886246,3792.5003426,13308.4574172,34.341394,40.8368597,2.4496713,185.3325654),(1212,'metatarsus.tif',245,10,164,1015.1841627,56.8902609,62.9627487,1.8,57.2077985,63.3490252,0.1024649,23.2314124,37.1044703,84835.5199994,421400.1854598,1.7702056,11357.1271001,3651.7590234,13448.6541994,34.7354672,40.3778051,2.454689,177.4233624),(1213,'metatarsus.tif',245,10,165,991.9946173,57.9023292,62.9305026,1.8,57.8186414,63.2327874,0.1010611,21.2665343,37.0781347,78229.528359,398837.3529068,1.682857,10756.6725304,3678.5273619,12859.3810026,36.5825902,44.3794681,0.5543075,239.3267581),(1214,'metatarsus.tif',245,10,166,941.8746259,59.2929024,62.894066,1.8,58.8054963,63.1581607,0.1000775,23.1639883,37.1632784,69840.2254578,353884.3148515,1.5669832,9522.4191708,3015.0345725,11399.1014966,33.5594272,38.6856024,0.5912232,229.7748302),(1215,'metatarsus.tif',245,10,167,864.0518722,61.0573598,62.8897188,1.8,60.1902821,63.064296,0.0992426,23.6235901,37.1089878,60295.8627047,287724.1347535,1.4137047,7753.489173,2552.3581462,9375.004806,33.8936235,40.3459321,0.4063538,211.9415549),(1216,'metatarsus.tif',245,10,168,761.459565,62.9765694,62.8618826,1.8,62.3456997,63.0846985,0.1009074,25.3332703,35.4610986,49785.308895,213475.2276421,1.2878557,6019.9834782,1965.2144521,7422.5426235,27.8666005,35.1604595,1.092864,156.9718525),(1217,'metatarsus.tif',245,10,169,679.3644663,62.9371464,62.6487715,1.8,63.0710116,62.9831218,0.101847,18.3653815,29.9981872,38108.7532507,175622.3186399,1.1704309,5854.4310576,2075.0319382,7102.0369333,19.8734789,33.367104,1.1402691,117.3168388),(1218,'metatarsus.tif',245,10,170,580.1615358,61.453132,62.4199104,1.8,62.3607,62.8323522,0.1015602,17.2704451,31.1369926,27424.2569376,132636.7342298,0.9939184,4259.7798738,1587.9299472,5137.1113697,0.449218,0.9260867,1.815775,2.1690165),(1219,'metatarsus.tif',245,10,171,456.569072,58.7610841,62.058209,1.8,59.5131299,62.3735474,0.0962528,15.0669259,30.8737031,17838.355886,78190.2303131,0.7028135,2532.5834801,1183.9412999,3108.6905844,0.224609,0.502241,2.0344439,1.0845083),(1220,'metatarsus.tif',245,10,172,357.6519898,59.2056314,62.1491002,1.8,59.1053597,62.2348288,0.0950724,13.7814879,23.0293331,9727.6445854,58981.6110838,0.5371671,2561.1515,705.8486492,2966.7695833,17.9687214,24.4493905,0.8960554,90.9577714),(1221,'metatarsus.tif',245,10,173,207.6625421,62.1801778,62.4961455,1.8,61.703664,62.3866259,0.0956191,11.8160842,24.5538712,3650.8469565,33369.0785474,0.3154807,1359.0149712,308.9726585,1504.462462,7.4120976,16.549585,1.4346574,40.4351006),(1222,'metatarsus.tif',245,10,174,61.4652087,70.7759662,63.3974278,1.8,66.8922994,63.0349673,0.10676,9.4366716,32.125966,904.6484291,5033.8277017,0.1163175,156.6903139,95.8652023,184.8450139,3.5937443,8.4190938,1.4100336,20.2560871),(1223,'metatarsus.tif',245,10,175,14.8512692,74.2458756,63.6487738,1.8,74.1910259,63.7627857,-1.5116541,2.5562225,6.2277173,15.4666244,97.5699559,2.4665638,15.6670497,6.0505783,18.1406064,4.9413984,12.2303683,1.4418856,29.1407998),(1224,'metatarsus.tif',245,10,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1225,'metatarsus.tif',245,10,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1226,'metatarsus.tif',245,10,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1227,'metatarsus.tif',245,10,179,3.7849291,42.1037501,63.3958541,1.8,42.1075115,63.3922449,-1.4907727,3.4823315,3.4061422,9.3485892,9.5634757,0.6267905,2.8077147,2.6845776,5.4308616,6.9202559,7.1909972,0.6747409,22.9062466),(1228,'metatarsus.tif',245,10,180,26.3931161,42.1337437,63.3178158,1.8,42.1318302,63.305304,-0.7519976,6.465847,6.5767648,233.0004692,239.9809434,2.0526115,36.4892086,36.0355682,71.4532062,13.027323,13.4784127,1.1593401,43.216833),(1229,'metatarsus.tif',245,10,181,50.8073084,42.1393645,63.3169977,1.8,42.1369707,63.3264339,-0.6769771,8.4505317,8.5755077,807.999411,832.9995631,3.3230232,97.1370548,95.6152158,190.711118,16.9940139,17.4517015,0.5558708,56.3625052),(1230,'metatarsus.tif',245,10,182,75.5872116,42.166801,63.3046605,1.8,42.1376964,63.311507,-0.7986809,9.7957638,9.9947556,1676.825898,1709.7038161,6.4662483,171.0600917,171.1786785,338.1509154,19.7655935,20.2459832,0.5880026,65.5648631),(1231,'metatarsus.tif',245,10,183,99.1979009,42.1704452,63.2935187,1.8,42.1456762,63.2969842,-0.8592567,10.9851625,11.1091163,2754.9775346,2797.0226748,9.4831584,251.777243,250.7907859,499.3837586,22.0116837,22.4811075,1.1921452,72.9703488),(1232,'metatarsus.tif',245,10,184,119.2001721,42.1727676,63.2907767,1.8,42.1492646,63.2905409,-0.8238186,11.885115,11.9461803,3921.0920846,3969.1176281,10.6958844,332.2499348,329.9162089,655.5115907,23.8085559,24.2951799,0.9827937,79.1597533),(1233,'metatarsus.tif',245,10,185,328.9316974,57.7373907,63.8531834,1.8,58.1934202,64.0452438,0.0329522,14.7869565,28.1498678,14952.6710296,69493.9100447,0.0595065,2468.7117747,1011.2068071,2996.2753973,25.380819,25.7606079,0.7360555,84.024078),(1234,'metatarsus.tif',245,10,186,596.2364736,63.9105209,64.4853338,1.8,58.1822022,64.2793494,0.0334238,17.0115632,34.9772456,28945.0395619,117891.7328777,0.1109733,3370.5264871,1701.4920481,4197.3388505,26.5038641,26.9699225,2.9147938,88.044466),(1235,'metatarsus.tif',245,10,187,606.9841429,63.7567913,64.5698897,1.8,57.9862558,64.4232477,0.0207038,17.2685062,35.2540122,29609.0029449,121792.9257757,0.0433573,3454.7252368,1714.6244533,4293.6933253,27.4023001,27.8958613,0.6998929,90.7942735),(1236,'metatarsus.tif',245,10,188,611.7815112,63.6046976,64.6284304,1.8,57.8196483,64.5410042,0.0113277,17.047194,35.3341037,29951.1126968,124213.901562,0.0130836,3515.411139,1756.9526495,4352.5224693,29.0823326,57.2272746,3.0630146,186.2216509),(1237,'metatarsus.tif',245,10,189,614.5749298,63.5168932,64.6726273,1.8,57.7269289,64.6300481,0.0046104,16.8341596,35.4517122,30124.3288591,125586.6351813,0.0021771,3542.4702365,1789.4762584,4383.0440979,29.1135401,57.4024368,3.0750245,182.0471156),(1238,'metatarsus.tif',245,10,190,615.0337578,63.4723409,64.6969668,1.8,57.6867263,64.6698934,0.0001538,16.6102742,35.3966984,30110.3696555,125916.444319,0.0000021,3557.2934775,1812.7557217,4390.6116885,29.1111815,57.3488007,3.0395857,180.9626074),(1239,'metatarsus.tif',245,10,191,615.0746064,63.4586757,64.7109918,1.8,57.6696829,64.6984681,-0.0030534,16.3977996,35.384369,30029.558109,125824.652514,0.0009555,3555.9388511,1831.3163303,4384.7216276,29.0939455,57.3488007,3.0395857,180.3273171),(1240,'metatarsus.tif',245,10,192,615.3225107,63.4269244,64.7186873,1.8,57.6408613,64.7166497,-0.0048757,16.8488047,35.3535098,30048.1245984,125947.4448521,0.0024383,3562.5160188,1783.3980009,4389.7681536,29.0939455,57.3488007,3.0395857,180.6449623),(1241,'cephalophus_BayDuiker_humerus.tif',239,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1242,'cephalophus_BayDuiker_humerus.tif',239,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1243,'cephalophus_BayDuiker_humerus.tif',239,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1244,'cephalophus_BayDuiker_humerus.tif',239,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1245,'cephalophus_BayDuiker_humerus.tif',239,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1246,'cephalophus_BayDuiker_humerus.tif',239,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1247,'cephalophus_BayDuiker_humerus.tif',239,2,7,4.6415032,55.0678958,17.5376079,1.8,55.2433657,17.5429238,-0.1758671,2.3627948,3.5254935,3.8797594,7.9975102,0.0236807,2.2684796,1.6420213,3.2175751,4.5468729,6.5765041,2.9385474,18.0732455),(1248,'cephalophus_BayDuiker_humerus.tif',239,2,8,13.1150044,56.5423622,17.9351799,1.8,56.5432355,18.0007287,0.1397002,3.2341331,5.3061926,31.2611221,75.6342653,0.0423823,14.2539614,9.6659974,19.260588,6.4414032,10.7321424,2.7807559,29.4483147),(1249,'cephalophus_BayDuiker_humerus.tif',239,2,9,18.34733,57.7706022,18.3157601,1.8,57.23856,18.185324,0.3294615,3.907374,6.7375091,66.6923536,174.9097399,0.3200813,25.9605941,17.0683313,35.8483896,7.6533444,12.6650453,2.7583085,33.4862615),(1250,'cephalophus_BayDuiker_humerus.tif',239,2,10,18.6253007,57.9650292,18.3204288,1.8,57.5486972,18.211366,0.2968934,4.1846841,6.8563111,84.4179358,199.5827709,0.2656776,29.1093518,20.1730727,41.344707,7.8686317,13.1938772,2.7744188,34.4200626),(1251,'cephalophus_BayDuiker_humerus.tif',239,2,11,18.1677481,58.632266,18.7683799,1.8,58.3689053,18.6210284,0.3118438,4.2414976,6.7315984,93.5242224,181.8812778,0.2850364,27.0190327,22.0498115,40.6245978,8.1464805,13.1393568,2.6456982,34.5310417),(1252,'cephalophus_BayDuiker_humerus.tif',239,2,12,20.3830629,59.7331704,19.5018201,1.8,59.6232993,19.3197567,0.4184394,4.2751926,7.7064976,110.5930742,255.2827823,0.5609017,33.1256551,25.8685596,46.6312463,8.6278954,14.8705549,2.546523,38.7068955),(1253,'cephalophus_BayDuiker_humerus.tif',239,2,13,26.0003949,59.6460581,21.1122849,1.8,58.6320143,21.7431894,-0.4650288,11.5315406,15.7798725,331.6967066,701.2671185,0.871473,44.4406074,28.7643011,62.2742002,9.1517459,15.7701872,2.4668517,41.470217),(1254,'cephalophus_BayDuiker_humerus.tif',239,2,14,56.4375212,56.6092361,27.1605254,1.8,55.9247103,28.0907571,-0.9007942,11.1529044,13.0990107,1249.1373882,3735.9227872,5.7789608,285.2064836,112.0010846,368.3374358,12.0627236,21.144181,2.2035452,63.2215442),(1255,'cephalophus_BayDuiker_humerus.tif',239,2,15,78.3546384,56.6796836,28.4964,1.8,55.8392355,29.2354788,-0.9361772,12.7007714,13.8766394,2159.4191798,4901.8547741,8.4688844,353.2450939,170.0226787,502.9289717,22.0494554,27.7669908,1.2943711,111.7609565),(1256,'cephalophus_BayDuiker_humerus.tif',239,2,16,96.3099575,57.2463257,29.2988509,1.8,56.2237623,29.840591,-0.9635312,14.0189154,14.7257195,3140.093862,5692.0810736,10.825057,386.5400988,223.9897865,599.427147,23.3553793,28.9485231,0.9246774,92.0341797),(1257,'cephalophus_BayDuiker_humerus.tif',239,2,17,96.9004645,57.1471786,30.3328062,1.8,56.3893051,30.4407978,-1.0537393,14.492431,14.8506203,3765.7959184,6368.8777989,12.2037053,428.8627447,259.8457031,671.802588,24.1970942,29.7947652,0.8980415,91.9232007),(1258,'cephalophus_BayDuiker_humerus.tif',239,2,18,99.2456339,57.0890061,31.3102663,1.8,56.6306961,30.9504051,-1.1638788,14.4914709,15.7663704,3864.9055988,6870.7217841,13.9499311,435.7833555,266.7020908,676.8085137,24.0525691,30.2680501,1.27874,93.0139499),(1259,'cephalophus_BayDuiker_humerus.tif',239,2,19,100.6969506,57.1715434,32.050437,1.8,56.9398027,31.3329172,-1.2368181,14.1941106,16.3988022,3812.1453507,7262.8741293,14.9794184,442.8905258,268.5723299,673.4067564,23.3437368,30.5777435,1.2098502,94.1506681),(1260,'cephalophus_BayDuiker_humerus.tif',239,2,20,99.034608,57.2844838,32.5072479,1.8,57.203689,31.5369872,-1.297107,13.6174979,16.7409296,3533.276055,7341.8675576,15.2999537,438.5579388,259.4658793,649.4769073,22.7444436,30.7410538,1.270485,94.5755432),(1261,'cephalophus_BayDuiker_humerus.tif',239,2,21,95.0527645,57.3107119,32.6203205,1.8,57.2732706,31.5804462,-1.3575253,12.7308977,16.6742683,3065.4697417,7193.8972177,15.1324149,431.4370546,240.7897547,613.6111174,22.263288,30.6568732,1.3018343,96.9488047),(1262,'cephalophus_BayDuiker_humerus.tif',239,2,22,90.6137818,57.6285383,32.4783138,1.8,57.4999876,31.3686424,-1.4096167,11.8434079,16.2952769,2431.3563958,6838.4217585,14.7133422,419.6566775,205.2919573,565.6841565,21.4838709,30.4642602,1.3258177,95.2302634),(1263,'cephalophus_BayDuiker_humerus.tif',239,2,23,77.8643583,57.8578571,31.6810407,1.8,57.9536399,30.3047229,-1.4360084,11.1053151,15.2099011,1598.7457386,5941.5376093,12.7430469,390.6361765,143.9622129,491.923289,19.9818432,29.9197872,1.3473197,92.7348689),(1264,'cephalophus_BayDuiker_humerus.tif',239,2,24,56.6006143,57.9988782,29.1013443,1.8,58.0315484,28.3731379,-1.3587732,10.7199156,16.4050777,1183.6147842,3274.4532824,9.0156834,199.5999867,110.4126959,268.4323614,18.2346317,29.0969273,1.4270577,90.8022566),(1265,'cephalophus_BayDuiker_humerus.tif',239,2,25,47.1563746,58.4537841,27.0662941,1.8,58.3972903,26.4014109,-1.0371597,10.1430558,10.3200436,989.9219231,1620.1301961,5.8258332,156.9886963,97.5960248,248.9797665,16.7556374,20.8656525,1.2088376,60.9481078),(1266,'cephalophus_BayDuiker_humerus.tif',239,2,26,46.5819213,58.5755682,26.6175831,1.8,58.4565918,26.1327631,-0.9213569,9.2858867,9.365217,945.3123411,1416.587532,4.9244041,151.260514,101.8009776,242.2807686,15.5450566,19.3149205,1.1993972,57.3159951),(1267,'cephalophus_BayDuiker_humerus.tif',239,2,27,44.0179276,58.6401061,26.2498877,1.8,58.3781996,26.0010151,-0.8554595,8.4738391,8.8006845,836.0244483,1217.0622256,4.1804731,138.2917689,98.6594673,219.8358939,14.4506579,18.1884781,1.1864215,53.8139024),(1268,'cephalophus_BayDuiker_humerus.tif',239,2,28,43.333154,58.5278488,26.068153,1.8,58.2559366,25.8706777,-0.8513554,7.8693734,8.2986822,766.757695,1114.3858806,4.0860714,134.2846798,97.435673,211.956538,13.6642797,17.344009,1.1902899,50.7366848),(1269,'cephalophus_BayDuiker_humerus.tif',239,2,29,43.4085173,58.4869956,25.8540168,1.8,58.2274183,25.7659075,-0.8229991,7.3501669,7.9326996,724.9508337,1035.348595,3.8891539,130.5165519,98.630527,204.873697,13.1284256,16.5432751,1.1583859,48.6392374),(1270,'cephalophus_BayDuiker_humerus.tif',239,2,30,43.3395277,58.5448117,25.7353777,1.8,58.3255317,25.7973572,-0.8332249,6.95413,7.8122528,678.1157258,968.1605881,3.9565651,123.9284769,97.5126621,196.7430656,12.726535,15.9320879,1.1284221,47.0776441),(1271,'cephalophus_BayDuiker_humerus.tif',239,2,31,43.3667624,58.5398471,25.7848934,1.8,58.3311407,25.9836896,-0.8412004,6.7228998,7.5281819,644.8318309,908.5470592,4.016387,120.6861197,95.9157283,192.3692421,12.458608,15.4203599,1.1126432,45.8949569),(1272,'cephalophus_BayDuiker_humerus.tif',239,2,32,43.891695,58.6344385,25.8152791,1.8,58.6032328,25.8155252,-0.8272639,6.5109182,7.3777397,630.9952671,861.1492691,3.9635431,116.7226426,96.9134075,190.3969689,12.1906809,14.8814124,1.0216434,44.9801967),(1273,'cephalophus_BayDuiker_humerus.tif',239,2,33,44.21737,58.7186887,25.8537637,1.8,58.6820052,25.8480874,-0.8440288,6.3742203,7.2735118,608.1704423,822.3737225,4.1158735,113.0641905,95.4109545,186.9132101,12.0567174,14.5768076,1.0838971,44.1764156),(1274,'cephalophus_BayDuiker_humerus.tif',239,2,34,44.8864597,58.7109556,25.9572355,1.8,58.6896645,25.9550659,-0.8724222,6.2598141,7.1584185,596.7907098,801.8170159,4.3882896,112.0103571,95.3368102,175.5979899,11.7887903,14.3447353,0.9827937,43.6865305),(1275,'cephalophus_BayDuiker_humerus.tif',239,2,35,45.5520255,58.7465384,26.0714339,1.8,58.7379361,26.0711939,-0.9005858,6.7078928,7.7380057,587.2001641,790.5999638,4.6627921,102.171024,87.5386925,175.443406,11.7887903,14.2405182,0.7100693,43.3726344),(1276,'cephalophus_BayDuiker_humerus.tif',239,2,36,45.4434562,58.7716745,26.2081083,1.8,58.7756795,26.1708395,-0.9286189,6.2550654,7.0992587,572.3757116,775.7354181,4.8569226,109.2699186,91.5059515,170.4092813,11.7887903,14.173569,0.9085808,43.1047073),(1277,'cephalophus_BayDuiker_humerus.tif',239,2,37,46.000779,58.8347029,26.3237148,1.8,58.846394,26.3029245,-0.957378,6.2994501,7.2249519,566.1931088,778.1142672,5.126087,107.6981938,89.8797668,172.531454,11.6548268,14.2631842,0.6913369,42.9477593),(1278,'cephalophus_BayDuiker_humerus.tif',239,2,38,46.5557633,58.8399137,26.4912721,1.8,58.8808811,26.4445843,-0.9987931,6.3001967,7.199953,561.8639835,776.2324833,5.4856299,107.8107716,89.1819743,180.7001649,11.6548268,14.4395034,0.9063009,43.0587383),(1279,'cephalophus_BayDuiker_humerus.tif',239,2,39,47.2544045,58.7806381,26.6998077,1.8,58.8314044,26.6364099,-1.0122379,6.2811966,7.5884853,567.4004705,778.1527309,5.6637388,102.5438804,90.3331808,176.4868078,11.721439,14.4395034,0.9063009,42.8558213),(1280,'cephalophus_BayDuiker_humerus.tif',239,2,40,47.9339574,58.7239507,26.9172207,1.8,58.7402527,26.8269602,-1.0311525,6.2416999,7.3265399,571.0440664,788.863268,5.8797251,107.6720085,91.4885496,180.6567946,11.6971838,14.4742615,0.9246774,42.6988732),(1281,'cephalophus_BayDuiker_humerus.tif',239,2,41,48.025059,58.7219446,27.1446591,1.8,58.7113366,27.0870964,-1.0379539,6.2625437,7.7497074,566.6172146,791.221584,5.9387188,102.0969625,90.4771667,175.1636977,11.6949664,14.6259707,0.9324765,42.8098523),(1282,'cephalophus_BayDuiker_humerus.tif',239,2,42,47.6988618,58.6351153,27.3990099,1.8,58.6432186,27.3536283,-1.0641731,6.2304479,7.1959098,565.7182506,775.6041483,6.0780619,107.7840284,90.7989693,170.9914638,11.6949664,14.5583287,0.9611365,42.2280291),(1283,'cephalophus_BayDuiker_humerus.tif',239,2,43,47.469955,58.5311213,27.6856238,1.8,58.5325209,27.6579382,-1.1184287,6.2830545,7.0179577,570.7031091,748.1910475,6.4001117,106.6109376,90.8321121,180.7425727,11.7794999,14.2405182,0.9938634,41.9601021),(1284,'cephalophus_BayDuiker_humerus.tif',239,2,44,48.1859333,58.4172547,27.9673473,1.8,58.3628587,27.9585644,-1.1342219,6.244076,6.9828702,585.89885,740.4056175,6.5951146,106.0317031,93.8327545,180.6067604,11.8460775,13.9115817,1.0584069,41.673134),(1285,'cephalophus_BayDuiker_humerus.tif',239,2,45,48.4097717,58.2940002,28.2553162,1.8,58.2379336,28.269508,-1.1601123,6.2951347,7.6427274,600.1127561,730.65728,6.7822908,95.6016412,95.3296129,173.6968246,11.8794212,13.7350185,1.1441688,41.451176),(1286,'cephalophus_BayDuiker_humerus.tif',239,2,46,47.9130745,58.1960395,28.5490114,1.8,58.1317767,28.5445563,-1.218203,6.4024289,6.8967532,602.6582753,722.7945533,7.0332024,104.8021486,94.1296321,177.7926112,11.9328373,13.6577113,1.1567973,41.497145),(1287,'cephalophus_BayDuiker_humerus.tif',239,2,47,47.7070301,58.0384614,28.8395604,1.8,57.9872023,28.8366152,-1.2531852,6.4909347,7.5241665,611.7032175,719.020696,7.1756931,95.5615073,94.2396198,174.3362695,12.0567174,13.6155984,1.2006255,41.6540931),(1288,'cephalophus_BayDuiker_humerus.tif',239,2,48,47.9278665,57.8953392,29.1190522,1.8,57.8284239,29.0991586,-1.2818488,6.5356403,6.9224093,624.3782264,714.8355903,7.3394113,103.2639875,95.5343625,184.8775254,12.1258234,13.5482103,1.2136623,41.7650721),(1289,'cephalophus_BayDuiker_humerus.tif',239,2,49,47.7757587,57.8407765,29.4229052,1.8,57.7795377,29.4618549,-1.3231675,6.6330845,7.4423922,620.9461875,711.3143682,7.484257,95.5760392,93.61349,172.7736466,12.1814436,13.4831478,1.2268272,41.6540931),(1290,'cephalophus_BayDuiker_humerus.tif',239,2,50,47.8855461,57.7474773,29.767709,1.8,57.6816893,29.8305528,-1.4251142,6.7799596,7.2064745,617.1875587,707.9220549,7.8127377,98.2341713,91.0311559,181.429288,12.1906809,13.4831478,1.2712643,41.6540931),(1291,'cephalophus_BayDuiker_humerus.tif',239,2,51,48.2924686,57.6385647,30.134736,1.8,57.5668024,30.2013545,-1.4814222,6.4418014,7.317705,613.1291313,709.5081742,7.9846245,96.9577444,95.1797628,178.8430965,12.2125754,13.3775846,1.3567356,41.497145),(1292,'cephalophus_BayDuiker_humerus.tif',239,2,52,48.9425244,57.5377758,30.5133484,1.8,57.4852619,30.5993289,-1.5104524,6.7082206,6.8908374,612.7406834,713.2611341,8.1274203,103.5086288,91.3417615,178.1990038,12.1050038,13.376243,1.2983332,41.497145),(1293,'cephalophus_BayDuiker_humerus.tif',239,2,53,49.5463986,57.4555079,30.8846129,1.8,57.4163078,30.9543181,-1.5075079,6.7432987,8.1416332,610.8466396,719.2904716,8.2247015,88.3471967,90.5857303,163.2817561,11.9355413,13.376243,1.2983332,41.0263009),(1294,'cephalophus_BayDuiker_humerus.tif',239,2,54,49.9701036,57.3454517,31.2689418,1.8,57.261889,31.3226247,-1.5056263,6.5721895,7.3846576,610.2697393,725.8689239,8.293029,98.2941885,92.8563818,176.28138,11.7460882,13.3265095,1.3120254,40.8693529),(1295,'cephalophus_BayDuiker_humerus.tif',239,2,55,50.0701239,57.2269859,31.7052228,1.8,57.1780801,31.729608,-1.4638444,6.7014621,7.4699344,609.0386778,728.9538166,8.2499278,97.5850361,90.8814621,178.1243194,11.7460882,13.376243,1.2983332,40.9803319),(1296,'cephalophus_BayDuiker_humerus.tif',239,2,56,50.3348144,57.0797636,32.1285145,1.8,57.0288162,32.1182019,-1.4301715,5.9889949,6.9197014,610.7533864,733.5272571,8.2243285,106.005623,101.9792793,183.5126737,11.7460882,13.3601335,1.25353,40.9803319),(1297,'cephalophus_BayDuiker_humerus.tif',239,2,57,49.8783277,56.9537678,32.5688423,1.8,56.9112498,32.5096478,-1.4025168,6.6740983,6.7753668,602.350553,725.2689196,8.0798594,107.0449684,90.2519756,177.9951864,11.7460882,13.4284654,1.2847449,40.8233839),(1298,'cephalophus_BayDuiker_humerus.tif',239,2,58,49.5290397,56.7956228,33.0564426,1.8,56.7656708,33.0305776,-1.3375364,6.914973,7.6084513,592.3194194,722.6761749,7.8137798,94.9833482,85.6575168,162.0414781,11.7460882,13.4191071,1.3429393,40.9803319),(1299,'cephalophus_BayDuiker_humerus.tif',239,2,59,49.4732433,56.6014451,33.5345722,1.8,56.5809004,33.4740934,-1.2665223,6.8303989,7.2659134,588.1672301,716.347658,7.5054164,98.5901734,86.1102309,175.1196573,11.5566352,13.4284654,1.2847449,40.8233839),(1300,'cephalophus_BayDuiker_humerus.tif',239,2,60,50.0553645,56.3782541,33.9968218,1.8,56.3751126,33.9292336,-1.2211682,6.6158367,7.4710132,591.3673835,721.505302,7.3636492,96.5739568,89.3866357,175.6525011,11.5566352,13.334587,1.1770981,40.7774149),(1301,'cephalophus_BayDuiker_humerus.tif',239,2,61,50.3771349,56.1806301,34.4807188,1.8,56.1717731,34.4295333,-1.2048047,6.4761614,7.5143766,589.9025643,728.5821762,7.3208487,96.9584319,91.0883051,171.755098,11.5566352,13.3265095,1.3120254,40.8233839),(1302,'cephalophus_BayDuiker_humerus.tif',239,2,62,50.8331213,55.9692724,34.9729071,1.8,55.9558358,34.9186097,-1.20111,6.561864,7.2234728,591.8805636,736.4326859,7.3661066,101.9499497,90.2000652,177.4644549,11.5566352,13.3265095,1.3120254,40.7774149),(1303,'cephalophus_BayDuiker_humerus.tif',239,2,63,50.9495325,55.7689972,35.482382,1.8,55.779597,35.4191747,-1.2147565,6.5061997,7.0421517,589.046897,739.108235,7.4598803,104.9548866,90.5362454,180.9348721,11.5566352,13.2630657,1.1902899,40.8233839),(1304,'cephalophus_BayDuiker_humerus.tif',239,2,64,50.8269978,55.5748242,36.0067878,1.8,55.5668857,35.9421198,-1.232375,6.5583324,6.8652782,586.5633848,736.4314208,7.5374497,107.2689838,89.4378855,178.2039306,11.5566352,13.2630657,1.1902899,40.6664358),(1305,'cephalophus_BayDuiker_humerus.tif',239,2,65,50.5506477,55.4384238,36.5170333,1.8,55.4566195,36.4693353,-1.2677995,6.6824211,7.3811694,578.8684431,727.6931882,7.6750059,98.5877914,86.6255561,167.0938841,11.5566352,13.2468185,1.2807094,40.6014258),(1306,'cephalophus_BayDuiker_humerus.tif',239,2,66,50.620812,55.3062299,37.035719,1.8,55.301889,36.9653372,-1.2829512,6.903443,7.7856984,576.3064332,725.7585963,7.7568664,93.2168909,83.4810154,166.4895575,11.5566352,13.268477,1.3986055,40.6014258),(1307,'cephalophus_BayDuiker_humerus.tif',239,2,67,50.5274916,55.1635526,37.6014598,1.8,55.1416153,37.5498835,-1.2899337,6.2804187,7.3370643,571.4051843,721.98501,7.7742331,98.4024378,90.9820212,174.9716122,11.6842035,13.3103399,1.485291,41.183249),(1308,'cephalophus_BayDuiker_humerus.tif',239,2,68,51.1338674,55.0312928,38.1961966,1.8,55.0440341,38.1730251,-1.3220613,6.6375278,6.9426708,573.1851548,727.2024371,8.0058279,104.7439034,86.3552175,183.63079,11.6677747,13.3480386,1.4570043,40.6933639),(1309,'cephalophus_BayDuiker_humerus.tif',239,2,69,51.8698041,54.8859764,38.7360829,1.8,54.8746917,38.6429543,-1.3586406,6.6518265,6.9642209,579.5438149,727.1745121,8.2616599,104.4157741,87.1255164,178.6240162,11.5566352,13.2955004,1.6421038,40.5364158),(1310,'cephalophus_BayDuiker_humerus.tif',239,2,70,52.8318632,54.7742393,39.2789428,1.8,54.781176,39.2106167,-1.4303722,6.6779025,7.1494712,591.9658074,727.7646716,8.6328176,101.7927978,88.6454701,180.354558,11.7443178,13.2373318,1.4127064,40.5364158),(1311,'cephalophus_BayDuiker_humerus.tif',239,2,71,53.1450195,54.6864554,39.7602663,1.8,54.6936159,39.7311659,-1.5253114,6.7163762,7.4881152,604.4059972,723.2752678,8.8391908,96.589763,89.989896,172.6234624,11.7460882,13.268477,1.7429871,40.4254368),(1312,'cephalophus_BayDuiker_humerus.tif',239,2,72,53.30957,54.639198,40.2613845,1.8,54.6363451,40.2209591,1.4975654,7.4156533,7.0849217,612.7800266,728.462919,8.8373656,102.8187676,82.6333164,176.609822,11.7460882,13.3022476,1.7570192,40.5364158),(1313,'cephalophus_BayDuiker_humerus.tif',239,2,73,52.9094344,54.6360971,40.7810466,1.8,54.6392902,40.7430629,1.3427627,7.0081915,7.3739812,605.0117542,727.6006925,8.3675897,98.671352,86.3292265,172.0480861,11.9064963,13.376243,1.8432595,40.7393329),(1314,'cephalophus_BayDuiker_humerus.tif',239,2,74,52.3550266,54.5953058,41.2875875,1.8,54.6126927,41.2376369,1.2231497,6.7188497,7.3302266,600.1030034,728.0116122,7.7130556,99.3163863,89.3163314,180.1022676,0.189453,0.2679271,2.3561945,0.5358541),(1315,'cephalophus_BayDuiker_humerus.tif',239,2,75,52.3900272,54.5780041,41.770523,1.8,54.5781468,41.7442018,1.0774745,7.8366446,7.465346,602.0741969,736.0900413,6.7735625,98.6009283,76.8280591,170.1550649,11.9227538,13.5482103,1.9279303,40.8043429),(1316,'cephalophus_BayDuiker_humerus.tif',239,2,76,52.2690478,54.5705762,42.2443731,1.8,54.5768445,42.2456967,0.9635113,6.5914285,8.2201864,602.2305032,745.3454943,5.8747794,90.6725779,91.3657035,162.2180772,11.8630715,13.6577113,1.9847953,40.9803319),(1317,'cephalophus_BayDuiker_humerus.tif',239,2,77,52.4032965,54.5797017,42.7274158,1.8,54.5394327,42.7217372,0.8596433,6.8789176,8.1667852,593.4906104,768.1505633,5.0130093,94.0578876,86.2767441,159.1096998,0.189453,0.4236299,2.0344439,0.9147602),(1318,'cephalophus_BayDuiker_humerus.tif',239,2,78,53.7808379,54.6088921,43.2057997,1.8,54.5423507,43.1442562,0.7874542,6.8595285,8.3997598,589.5554181,806.0572012,4.5001656,95.9619344,85.94693,166.1253447,11.5239755,14.1532957,2.0583915,41.359238),(1319,'cephalophus_BayDuiker_humerus.tif',239,2,79,53.7766287,54.5750322,43.5890222,1.8,54.509487,43.5618136,0.7319829,6.8941944,8.2725225,585.6721197,834.1574605,4.0035467,100.834716,84.9514943,161.4145674,11.3539465,14.36099,2.1112158,41.9601021),(1320,'cephalophus_BayDuiker_humerus.tif',239,2,80,54.4231388,54.6337114,43.9493151,1.8,54.5883158,43.9914078,0.6823829,7.905048,8.7235431,572.8318503,884.7124441,3.6074558,101.4166418,72.464057,160.9221405,0.3789061,0.6830826,0.9827937,1.4506143),(1321,'cephalophus_BayDuiker_humerus.tif',239,2,81,53.923766,54.6808812,44.2321053,1.8,54.5982909,44.2494189,0.625047,7.4451619,8.5946146,551.6850423,909.6198073,3.0771005,105.8360209,74.0998047,159.5170751,0.3789061,1.3396353,1.7126934,3.2801346),(1322,'cephalophus_BayDuiker_humerus.tif',239,2,82,54.8775264,54.6962301,44.5725307,1.8,54.6381128,44.6262156,0.571312,7.0982536,8.1652113,537.7819201,960.6409073,2.6743245,117.6504657,75.7625683,175.0912889,10.9047578,15.2377255,2.2416538,43.2077993),(1323,'cephalophus_BayDuiker_humerus.tif',239,2,83,53.3222738,54.5383368,44.7468189,1.8,54.5173329,44.8009172,0.5275874,7.4969892,7.9614277,520.5233481,968.9062959,2.2525296,121.7000684,69.4309856,178.6230283,10.7573836,15.6880384,2.3134854,43.8086634),(1324,'cephalophus_BayDuiker_humerus.tif',239,2,84,51.9674207,54.4831383,44.9534357,1.8,54.460433,44.994584,0.5042604,7.3001768,8.4068249,489.9064946,1021.5310749,2.0219105,121.5121151,67.108853,167.3118275,0.3789061,0.6830826,0.9827937,1.6075623),(1325,'cephalophus_BayDuiker_humerus.tif',239,2,85,51.7342938,54.4989968,45.1989057,1.8,54.5014233,45.2549002,0.4834009,7.3340028,8.4024874,460.0079159,1095.2479788,1.8627156,130.3480651,62.7226265,162.6612572,0.189453,0.5991031,1.8925469,1.2936662),(1326,'cephalophus_BayDuiker_humerus.tif',239,2,86,51.5527759,54.4077356,45.3744815,1.8,54.4866182,45.411668,0.4534197,6.4237165,8.5363995,429.489976,1180.6814587,1.6486666,138.3114112,66.860045,184.3617125,10.4528699,16.7716771,2.3002529,46.644882),(1327,'cephalophus_BayDuiker_humerus.tif',239,2,87,51.5961405,54.4222852,45.5195131,1.8,54.479782,45.4761226,0.4213402,7.4610842,8.7273563,403.7619537,1275.6279539,1.4383951,146.1643037,54.115721,184.5085672,10.3243813,17.1995813,2.4341611,48.4553614),(1328,'cephalophus_BayDuiker_humerus.tif',239,2,88,54.2500176,54.4742717,45.495112,1.8,54.5124788,45.5041508,0.3917755,6.7065859,9.5119196,388.1689807,1382.1182239,1.3182224,145.3038175,57.8787754,185.1690951,10.3548915,17.7014438,2.3107712,51.578548),(1329,'cephalophus_BayDuiker_humerus.tif',239,2,89,54.2819401,54.5914101,45.3552886,1.8,54.5273559,45.3173927,0.3630498,7.3874881,8.8288686,386.1833411,1544.9142366,1.140962,174.9843951,52.2753253,206.7374986,11.0723501,18.2505332,2.4149503,65.4838267),(1330,'cephalophus_BayDuiker_humerus.tif',239,2,90,49.8528658,54.5903242,45.2802862,1.8,54.4738522,45.3171949,0.3278674,7.1580934,9.2680984,393.4913478,1622.8999898,0.8616235,175.1060377,54.9715302,210.3277491,11.7375158,18.6599219,2.4208524,64.7181275),(1331,'cephalophus_BayDuiker_humerus.tif',239,2,91,49.3062564,54.4130744,44.7496026,1.8,54.1949619,44.6885266,0.3374163,7.8204495,10.556137,467.5228416,1754.2009594,0.9006133,166.1783048,59.7820933,197.5157457,12.8600321,19.0972043,2.5040439,70.7156146),(1332,'cephalophus_BayDuiker_humerus.tif',239,2,92,53.1347738,54.3418321,43.8672357,1.8,53.8581096,44.0461424,0.3606216,9.2090755,10.5970677,626.0891458,1953.1694308,1.1026112,184.3122531,67.9861021,232.8072718,14.1744517,19.8238862,2.4713293,76.0281867),(1333,'cephalophus_BayDuiker_humerus.tif',239,2,93,57.949246,54.6496098,43.2777932,1.8,54.087413,43.3221181,0.2755745,9.2029354,10.527793,833.1954513,2239.870473,0.7150774,212.7578384,90.5358361,271.8172111,15.6395972,20.9129036,2.5561026,89.0456332),(1334,'cephalophus_BayDuiker_humerus.tif',239,2,94,74.9540242,55.6271662,42.5328426,1.8,54.6455022,42.6557572,0.0577513,9.696486,11.5819004,1211.2214623,2740.7859716,0.0416183,236.6438898,124.9134438,326.9540768,0.3789061,0.8472597,2.0344439,1.8295204),(1335,'cephalophus_BayDuiker_humerus.tif',239,2,95,81.8911109,55.2372889,42.3984387,1.8,54.6705451,42.6063994,-0.0153214,10.1650786,11.6347658,1529.7880714,2796.1144348,0.0032037,240.3240837,150.4944659,352.2071412,17.5945471,22.5544615,2.9557287,81.5896448),(1336,'cephalophus_BayDuiker_humerus.tif',239,2,96,90.498654,55.275672,42.2237118,1.8,54.8794978,42.5918573,-0.0302357,10.7279021,11.5780299,1833.3104143,3237.134463,0.0137847,279.5928572,170.8917915,363.6307494,17.9634575,22.9551105,2.4204335,81.3978817),(1337,'cephalophus_BayDuiker_humerus.tif',239,2,97,97.288364,55.1660033,42.1527967,1.8,54.8275095,42.5870569,-0.0896327,10.1475771,11.3479809,2057.7445406,3351.6301884,0.1299211,295.3503561,202.7818587,418.6842648,17.9980384,23.3304318,0.5947593,79.8553294),(1338,'cephalophus_BayDuiker_humerus.tif',239,2,98,99.6760496,54.8034611,42.4851114,1.8,54.7423321,42.71887,-0.160625,9.6349484,11.217354,2063.2045236,3388.9489146,0.42494,302.1166063,214.1375778,427.5936491,0.3789061,0.5358541,2.3561945,1.0717082),(1339,'cephalophus_BayDuiker_humerus.tif',239,2,99,99.1080788,54.7057215,42.7757781,1.8,54.7510196,42.7994507,-0.1382407,10.2202542,10.873019,1879.1880063,3308.6494601,0.3136615,304.2990613,183.8690087,413.8860584,0.4018906,0.9472652,2.2142974,1.9864684),(1340,'cephalophus_BayDuiker_humerus.tif',239,2,100,86.1023397,54.9552041,42.7523265,1.8,54.9354329,42.7182831,-0.1534634,8.6985161,10.4228618,1352.1549473,2821.840224,0.3353213,270.7356453,155.4466229,358.9370222,15.966669,23.0487352,0.6747409,89.0029311),(1341,'cephalophus_BayDuiker_humerus.tif',239,2,101,50.8480004,55.3988911,41.7071035,1.8,55.0459223,42.1338329,-0.1599246,8.9018423,9.9499922,363.3613476,1443.8328253,0.2149056,145.1089398,40.8186684,151.0872452,10.3537875,19.9942527,2.921896,61.992888),(1342,'cephalophus_BayDuiker_humerus.tif',239,2,102,7.8883563,58.2989737,41.9766422,1.8,58.2391399,42.1520466,-0.5762368,4.2029641,12.7161527,26.6237843,185.5253431,0.3903235,14.5897386,6.3345258,16.6814873,3.2207016,6.6740193,1.6845883,16.3737452),(1343,'cephalophus_BayDuiker_humerus.tif',239,2,103,0.211896,49.5778037,49.1500611,1.8,49.511737,49.1288,0.6072104,0.5216296,1.1004945,0.012918,0.0434625,0.0114975,0.0394936,0.0247648,0.0512166,1.2056717,2.160097,2.4805495,4.998676),(1344,'cephalophus_BayDuiker_humerus.tif',239,2,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1345,'cephalophus_BayDuiker_humerus.tif',239,2,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1346,'cephalophus_BayDuiker_humerus.tif',239,2,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1347,'cephalophus_BayDuiker_humerus.tif',239,2,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1348,'cephalophus_BayDuiker_humerus.tif',239,2,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1349,'cephalophus_BayDuiker_humerus.tif',239,2,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1350,'cephalophus_BayDuiker_humerus.tif',239,2,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1351,'cephalophus_BayDuiker_humerus.tif',239,2,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1352,'cephalophus_BayDuiker_humerus.tif',239,2,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1353,'cephalophus_BayDuiker_humerus.tif',239,2,113,2.8665779,69.0703982,38.3225925,1.8,68.9076214,38.3099113,1.5700466,1.6259294,5.1676816,1.221657,13.5373424,0.4777627,2.6196162,0.7513592,2.8188777,12.5039004,13.0075756,1.7910451,41.7381441),(1354,'cephalophus_BayDuiker_humerus.tif',239,2,114,10.3190367,68.2467668,38.4033263,1.8,68.0583196,38.3798039,-1.5702712,2.8859372,7.3338998,13.7105405,110.0969648,1.719839,15.012063,4.7508103,16.466215,16.6718672,16.9727083,0.9920814,55.1916197),(1355,'cephalophus_BayDuiker_humerus.tif',239,2,115,71.9459648,54.698096,40.2929157,1.8,51.7926146,39.7968121,-0.2804913,17.0450192,17.5883016,2762.7753161,5647.0855384,0.9189136,321.0705426,162.0869582,431.7670465,22.1331521,28.5923486,1.4110942,116.5534486),(1356,'cephalophus_BayDuiker_humerus.tif',239,2,116,336.6392954,50.2406572,39.5604944,1.8,52.3448433,39.3114106,-1.2683752,21.4374328,16.8562027,16101.6684772,17986.6002385,51.1296679,1067.0612231,751.100591,1495.5098517,28.7968614,29.2813748,1.388628,95.9690345),(1357,'cephalophus_BayDuiker_humerus.tif',239,2,117,353.7738738,50.5399526,39.5122552,1.8,52.9268235,39.2702956,-0.8735006,21.2270399,21.9585466,17866.6004495,19197.9872998,34.6490385,874.2831515,841.6906243,1610.9010502,28.9863145,29.2138793,0.9234042,95.7470765),(1358,'cephalophus_BayDuiker_humerus.tif',239,2,118,361.9241254,50.8255908,39.4968944,1.8,53.3521057,39.214015,-0.5465966,19.2286099,23.1440786,18618.0624039,20375.7549963,16.2970877,880.3873914,968.2479638,1682.069542,28.9863145,29.2347582,0.7395587,95.8580555),(1359,'cephalophus_BayDuiker_humerus.tif',239,2,119,369.4523498,51.0611149,39.4838021,1.8,53.6870569,39.2164536,-0.420823,18.1767954,22.8067491,19177.9328316,21503.5256313,10.2758173,942.8579902,1055.0777721,1745.1654809,28.9863145,29.2329165,2.461791,95.7470765),(1360,'cephalophus_BayDuiker_humerus.tif',239,2,120,374.9548586,51.229643,39.4812115,1.8,53.9184771,39.1975622,-0.361317,17.8749511,22.4549927,19583.3939172,22255.1299071,7.809489,991.0994043,1095.5774817,1787.9997672,28.9863145,29.2255487,0.6149745,95.7470765),(1361,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1362,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1363,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1364,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1365,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,5,2.1924612,71.0219439,28.4670798,1.8,70.971328,28.6007371,1.4910586,1.9135926,2.2938342,1.1172914,1.9138942,0.3630918,0.8343647,0.5838711,1.2667869,6.7929106,14.3287308,1.4659194,35.5652349),(1366,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,6,4.5753415,70.5139672,29.0682088,1.8,70.6017331,29.1754008,1.2745116,2.6877162,3.3278974,5.1228012,8.7659217,0.6975521,2.6340721,1.9060052,4.0986835,7.1773033,16.1783285,1.48958,39.5615555),(1367,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,7,7.6734385,70.038791,29.4336846,1.8,70.1203169,29.5456268,1.4054241,3.0439903,3.9943376,9.8352349,20.2987527,1.2442486,5.0818821,3.2310336,7.5441575,7.8198632,17.3323453,1.4732805,42.6713906),(1368,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,8,10.2984707,69.3046996,29.9508284,1.8,69.4610606,29.9153704,1.3222032,3.4740765,18.6621533,9.3966385,36.095625,1.6125072,1.9341618,2.7047874,2.4364061,8.3622341,18.2656195,1.4782777,45.4328762),(1369,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,9,11.9120256,68.5401188,30.3783508,1.8,68.6383557,30.6989183,1.2936117,2.0368758,20.212344,7.4903242,55.7429022,1.8366683,2.7578643,3.6773592,3.1282867,8.0351746,18.7471885,1.4303137,47.3988666),(1370,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,10,13.0651721,67.8366801,30.4478679,1.8,67.8761798,30.5034306,1.330309,2.4631158,20.1310854,8.0058799,50.6455415,2.0540022,2.5157879,3.2503059,2.9132248,7.4577404,19.019009,1.4024062,47.0427112),(1371,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,11,14.5600373,67.2484383,30.7178874,1.8,67.2734869,30.702585,1.4073056,2.6155716,3.9576262,10.4352344,56.8614816,2.3623857,14.3675727,3.9896574,16.5887533,7.1796972,19.5647974,1.3583643,47.9480414),(1372,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,12,16.8815326,66.754493,31.0747272,1.8,66.7500042,31.0169109,1.490236,2.8250361,4.5502449,13.3373081,81.5752759,2.7953681,17.9276671,4.7211108,20.6968128,6.1595712,20.3780685,1.3481354,47.7472162),(1373,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,13,19.2870834,66.3430289,31.4652023,1.8,66.3969523,31.4329033,1.5478963,2.8558129,5.2841466,16.1938351,118.1236382,3.2128285,22.3543456,5.6704818,25.3624398,5.4210711,21.0334568,1.3734008,48.1410609),(1374,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,14,21.5003187,65.979318,31.9355831,1.8,66.0090027,31.9060377,-1.5580208,2.8465533,5.943461,20.4641674,165.7244419,3.5828016,27.8834912,7.189104,31.2923184,0.1875,0.4192628,2.0344439,0.9053301),(1375,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,15,24.8512318,65.6389025,32.4488131,1.8,65.6807389,32.3789571,-1.5395735,2.9901466,6.5659902,27.1707369,235.8557623,4.1378355,35.9208216,9.0867574,39.9949224,4.9310184,21.3321953,1.3940875,47.5197405),(1376,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,16,28.8072799,65.263818,33.0584303,1.8,65.2864956,33.1062919,-1.5212559,3.3727392,7.2644265,39.4342746,326.455985,4.7894395,44.9389896,11.6920615,50.3669936,4.7613168,21.4546228,1.4128314,47.7394104),(1377,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,17,33.6772414,64.9649234,33.9421446,1.8,64.9860578,34.1714897,-1.5167197,3.6038075,8.5720794,59.3463368,488.5701665,5.5964759,56.995525,16.4676765,63.2557341,5.3545674,22.6122216,1.4711277,51.2320513),(1378,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,18,40.6851081,64.6005482,35.0073161,1.8,64.5865869,35.0024462,-1.5019587,3.9988912,7.9749346,104.4224956,683.2461231,6.7487702,85.6741981,26.1128622,95.8560852,7.1893618,21.9310902,1.4421996,51.5882067),(1379,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,19,36.3506722,64.6320318,34.2856528,1.8,64.5595306,34.5192556,-1.5354569,4.2800719,7.7340723,99.2688128,478.7440837,6.0508822,61.9006474,23.1932583,74.6251478,7.096168,20.4993343,1.41467,47.8382064),(1380,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,20,31.0433562,64.7290495,33.2772278,1.8,64.677106,33.2231684,1.5155681,3.842912,6.1862348,81.6346105,312.9973478,5.1581275,50.5957758,21.2429038,60.9205723,6.9697796,16.7925077,1.4589061,41.2812255),(1381,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,21,29.7869142,64.744153,32.6392635,1.8,64.7355713,32.5720402,1.4657365,3.7156737,5.6242679,70.0532802,256.6438323,4.9098912,45.6315091,18.8534534,55.5944339,6.6912208,14.870536,1.4824195,37.4857301),(1382,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,22,27.250806,64.7619057,32.2523104,1.8,64.757393,32.1654293,1.4176661,3.3767279,5.3028897,56.6879129,223.6654706,4.4361308,42.1780357,16.7878237,51.6588881,5.624001,13.7694473,1.6799498,33.9930892),(1383,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,23,26.2663989,64.7223358,32.1610908,1.8,64.7116483,32.1450203,1.3575944,3.1720433,5.5771696,52.287365,210.581347,4.1817399,37.7577452,16.4838121,46.0041824,5.7242563,12.9809063,1.7596935,32.6484192),(1384,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,24,26.1675459,64.6350161,32.1646142,1.8,64.6344613,32.2210135,1.3175854,3.3725081,5.3219432,53.4672133,218.4962352,4.0875575,41.0557246,15.8538427,48.4389423,6.1896332,12.6905792,1.7942729,32.6750697),(1385,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,25,28.0943004,64.5155604,32.2962084,1.8,64.4822069,32.4276926,1.2897392,7.3955218,5.519132,62.6033831,242.4017187,4.3221446,43.9202609,8.4650393,41.1286829,7.0518837,12.5722917,1.8736812,33.6902348),(1386,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,26,3.1312504,57.0061736,35.5907825,1.8,56.6625035,36.1721614,-0.9745585,3.1331356,6.4262371,3.0580966,9.4047863,0.3573175,1.4634982,0.9760499,1.9376043,2.9168157,4.5350203,2.6224465,11.814787),(1387,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,27,25.4469599,57.2906698,37.355837,1.8,57.7906816,37.7129261,-0.7256957,8.9166252,6.6954755,143.4590391,218.1378617,1.8679737,32.5798912,16.088939,39.5384684,7.9898969,12.9863217,3.0548543,41.3611768),(1388,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,28,52.6872509,59.6666732,39.0959954,1.8,60.3720107,39.3127054,0.2503318,6.6427205,10.7082604,457.7648833,938.7592312,0.5388843,87.6668286,68.9122598,129.7386203,11.1096937,18.4189537,2.7554153,66.1267898),(1389,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,29,74.2669802,61.5882446,40.0459606,1.8,61.8153145,39.9757398,0.4275296,7.6231446,10.2133349,577.0978426,1796.0119883,2.1279108,175.8497113,75.703384,228.6215861,11.3098739,20.1289799,2.6571147,53.3046434),(1390,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,30,63.4194326,62.0778451,40.259899,1.8,61.8934007,40.0377817,0.4877341,6.4122041,10.5855901,489.7936162,1788.1852843,2.3212549,168.9263669,76.3845955,214.008141,11.2957642,19.6517545,2.6224465,53.1493133),(1391,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,31,55.4241866,62.0667434,40.0089668,1.8,62.0333444,39.9750858,0.517955,6.1258378,8.8533615,471.5789141,1271.0037378,2.2643403,143.5617123,76.9819458,190.8814774,10.9070132,17.1723808,2.5899377,48.0923325),(1392,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,32,50.9653615,61.9031908,40.0705242,1.8,61.9657777,40.1096964,0.5570564,6.9652269,8.0200599,405.247302,1029.5178988,2.3742473,128.3678572,58.181493,147.3796315,10.5866486,15.8678636,2.5240904,44.6906819),(1393,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,33,44.5678713,61.8540944,40.674841,1.8,62.0585059,40.6444053,0.5095281,9.0833057,7.4613615,306.3379584,804.5498968,1.767228,107.8288328,33.7253823,120.8727899,9.9125617,14.9307002,2.5257227,44.0050217),(1394,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,34,42.3766672,61.8611974,41.1116662,1.8,62.0406076,40.9623041,0.4830975,8.4254661,7.4361989,278.6448684,692.7340753,1.5240271,93.1570123,33.0717453,115.0064473,9.7254792,14.4082505,2.5319328,41.2890312),(1395,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,35,40.7716031,61.9417734,41.5093707,1.8,62.0411794,41.3448382,0.4661083,6.4104769,7.225581,254.0518164,625.9490715,1.3724551,86.6295833,39.6307201,114.9359324,0.1875,0.2651651,2.3561945,0.5303301),(1396,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,36,37.8317199,61.9685181,41.8560925,1.8,61.9378568,41.6623486,0.4392249,6.4952336,7.2797083,230.2468157,578.1618234,1.1401686,79.4210149,35.4485814,96.2563036,8.9094026,13.7681707,2.6292032,37.6222155),(1397,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,37,38.1640744,62.0492931,42.1757064,1.8,61.9798229,41.9874898,0.4206229,5.8047739,7.5950025,225.80521,552.4034408,1.0605329,72.7324901,38.8999149,92.8691837,9.0053293,13.5934276,2.7149652,38.0882058),(1398,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,38,38.955985,62.0009541,42.5308123,1.8,61.9120092,42.4337926,0.3892879,5.6236516,7.479184,217.5235402,545.230082,0.9352215,72.8996753,38.6801238,101.2956817,8.8341942,13.4229581,2.7091849,36.3418854),(1399,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,39,39.6323061,61.9191548,42.7770535,1.8,61.8277213,42.618417,0.3701719,6.0567983,7.1003342,213.7068355,533.2702733,0.8645236,75.1049541,35.2837959,102.8734512,0.1875,0.2651651,2.3561945,0.5303301),(1400,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,40,39.7121321,61.7517097,43.074886,1.8,61.7022885,42.962568,0.3501837,6.1962571,7.4432804,200.2644043,522.5606601,0.7790014,70.2056932,32.3202219,96.8214626,8.7052872,13.1971241,2.7478944,35.3910601),(1401,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,41,38.6198486,61.5725849,43.3108035,1.8,61.5310561,43.2544529,0.3320263,5.0356737,6.6571268,178.7175209,500.7623814,0.6838898,75.2219979,35.4902901,88.6833292,8.1201421,13.12634,2.7610863,34.86073),(1402,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,42,38.5974658,61.3489227,43.5724135,1.8,61.371735,43.5398171,0.3161521,5.0890018,6.8806612,169.4457523,490.2850067,0.6218444,71.2555074,33.2964616,91.4157731,0.1875,0.2651651,2.3561945,0.5303301),(1403,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,43,38.8826363,61.1275894,43.8507638,1.8,61.1286706,43.8499301,0.3038098,5.9764003,6.3712005,162.1816849,480.7549158,0.5799692,75.4575084,27.1370183,95.5954475,0.375,0.8385255,2.0344439,1.9659904),(1404,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,44,39.3370362,60.9594261,44.0928171,1.8,60.987816,44.0923912,0.29029,7.0807074,6.8729456,159.2785796,474.8716342,0.5371318,69.0928842,22.4947271,88.5326152,0.3360764,0.9375001,2.2142974,1.9659904),(1405,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,45,39.5815,60.7979957,44.365682,1.8,60.832141,44.378691,0.2764266,6.6136898,7.134387,156.2151899,468.9394349,0.4913722,65.7294646,23.6199753,87.5759422,7.4907318,12.689194,2.8104966,33.5992445),(1406,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,46,39.8697919,60.6753635,44.6605299,1.8,60.7112384,44.6310285,0.2554177,6.5137149,6.4284713,152.618572,471.0307061,0.4241602,73.2725849,23.4303426,92.2637925,0.375,0.8385255,2.0344439,1.9659904),(1407,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,47,40.6432934,60.5774052,44.9292326,1.8,60.6070702,44.909264,0.2376513,6.5649465,10.7595491,150.6665154,484.8941845,0.375428,45.0664037,22.9501514,57.9305726,7.3070491,12.6294864,2.8245369,33.7545746),(1408,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,48,41.5366671,60.5070465,45.1780063,1.8,60.5074387,45.1336327,0.2266954,5.8635729,10.2450717,150.6748095,499.3544334,0.3497144,48.740941,25.6967573,62.9561244,7.2889375,12.697503,2.8572079,34.1295746),(1409,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,49,42.285229,60.4862554,45.3959592,1.8,60.5051351,45.3865722,0.2150005,5.951285,9.682831,151.2993538,512.2127808,0.3207853,52.8990727,25.4229725,66.3272071,7.1855196,12.8269743,2.8753406,34.2394096),(1410,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,50,42.8168022,60.4206706,45.6224033,1.8,60.4284146,45.5774016,0.2070867,6.8492616,7.009754,151.3642776,522.941128,0.3016825,74.6019228,22.0993569,84.1014127,7.4119205,12.9157434,2.907177,34.8152348),(1411,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,51,43.6688726,60.33072,45.806091,1.8,60.3149642,45.7250689,0.2045651,6.6906989,6.5338131,157.4561978,535.1470752,0.300343,81.9042526,23.5335951,88.7106203,7.6492259,12.9605781,2.8931052,35.5008951),(1412,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,52,43.3983719,60.2204223,46.0407423,1.8,60.1804865,45.9251526,0.1887293,6.7854071,13.1650318,148.88107,542.3700384,0.2545883,41.1977766,21.9413616,52.0278266,7.0689221,13.0079611,2.8791333,34.3947397),(1413,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,53,43.7077896,60.0959191,46.1866822,1.8,60.0000965,45.9522469,0.1885225,6.400388,9.7642011,151.6087369,548.9171082,0.2558484,56.2173086,23.6874291,62.1132865,7.2522294,13.0565186,2.9244813,35.3910601),(1414,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,54,43.8867562,59.9851966,46.3777166,1.8,59.88429,46.2588771,0.1743313,6.423993,9.3029395,146.1078042,554.9599159,0.2200538,59.6542542,22.744079,62.0116845,0.375,0.6760409,2.1587989,1.4356603),(1415,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,55,44.8610958,59.8750993,46.4727173,1.8,59.8599022,46.3578075,0.1759723,6.7922607,11.6992742,150.2097542,560.4805141,0.2291499,47.9072894,22.1148395,59.4343665,7.1406483,13.0726643,2.9976672,35.2812251),(1416,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,56,45.4374027,59.7610948,46.5525985,1.8,59.7005917,46.4299156,0.1744855,5.0795073,7.4203719,153.7382634,564.4289281,0.2282282,76.0647758,30.2663733,96.7198904,0.4097103,1.9575576,1.8622531,4.2159905),(1417,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,57,44.8495369,59.7046803,46.5885199,1.8,59.6654246,46.4216109,0.1778803,5.1116111,7.3720723,153.0048021,558.5003751,0.2340329,75.7589386,29.9327941,96.4397055,7.277353,13.1651181,2.9553698,35.0803999),(1418,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,58,44.3818628,59.6091894,46.6959053,1.8,59.5638396,46.5271976,0.1766946,5.7924216,8.2194999,148.3244158,557.0839832,0.2285476,67.7758973,25.6066332,85.780032,7.0256886,13.0981877,2.910502,34.6144096),(1419,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,59,44.4572783,59.4935436,46.7538993,1.8,59.4565555,46.5637605,0.1797405,5.8248054,7.2614672,149.5043803,556.4573723,0.2368109,76.6315346,25.6668455,85.8228208,7.1346615,13.1316955,2.9694018,34.7697397),(1420,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,60,43.855286,59.4000854,46.8580872,1.8,59.3276494,46.6655512,0.1772664,5.3669061,7.8854948,142.846409,557.525072,0.2272845,70.7026113,26.616156,83.8283377,0.3562946,1.0097185,1.9513027,2.1856603),(1421,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,61,43.9156376,59.3115644,46.8940599,1.8,59.1794991,46.6898082,0.1800313,5.0382082,9.1373104,143.8749506,559.1672452,0.234675,61.1960438,28.5567695,73.7002931,6.810039,13.1008715,2.9835027,34.5689145),(1422,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,62,44.2975624,59.2229193,46.9031582,1.8,59.0711134,46.6705705,0.1816466,5.4257944,9.9255697,145.1877725,562.6897241,0.2409357,56.6909248,26.7588046,70.7545423,6.8077427,13.0726643,2.9976672,34.6144096),(1423,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,63,44.4337129,59.1564724,46.918183,1.8,59.0621187,46.727929,0.1797661,5.4596479,10.7491854,146.2065708,563.3784933,0.2367519,52.4112734,26.7794874,63.5132499,6.9002088,13.017417,2.9385474,34.6787494),(1424,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,64,44.3855808,59.0980106,46.9179202,1.8,59.0130683,46.7735717,0.1761774,6.9472812,10.1065075,145.9049781,562.5551576,0.2272445,55.6626667,21.0017377,64.8491967,6.8554238,13.0726643,2.9976672,34.7242446),(1425,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,65,43.9200161,59.03661,46.8535989,1.8,58.9893377,46.7258419,0.1709766,8.7364389,7.8479968,144.8241398,556.0943557,0.2119086,70.8581272,16.577022,62.0012611,6.8542188,12.9809063,2.9526955,34.5689145),(1426,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,66,42.8812341,58.9289954,46.8163944,1.8,58.8868155,46.7122184,0.1609692,4.9100318,7.0419733,141.7175218,543.9185352,0.1835894,77.2395051,28.8628519,97.3014011,6.872991,12.9157434,2.9812172,34.5234193),(1427,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,67,41.7167417,58.8309956,46.779247,1.8,58.7564182,46.6924398,0.1529782,5.0713745,7.2122798,139.8608079,531.6051046,0.1614463,73.7083309,27.5784815,93.0151358,6.9966919,12.887131,2.9955804,34.7242446),(1428,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,68,41.2908716,58.7384827,46.70877,1.8,58.7056684,46.6402747,0.1425291,4.8110675,7.3459397,141.4287476,524.7521738,0.1388568,71.4343156,29.3965419,90.3097427,0.1875,0.2651651,2.3561945,0.5303301),(1429,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,69,40.7907473,58.6282581,46.6444176,1.8,58.59984,46.56639,0.1327294,4.7223099,7.2460428,140.8414101,517.8681601,0.1190674,71.4691002,29.8246863,90.2419746,6.98034,12.7624029,2.9643673,34.3037494),(1430,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,70,40.385662,58.5403737,46.5823557,1.8,58.5159283,46.5327769,0.1203887,4.8100272,7.1399209,139.8578736,511.9611562,0.0970842,71.704038,29.0763163,90.5452196,6.9358814,12.6753336,3.0080636,34.4590795),(1431,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,71,40.0167664,58.4692634,46.5030237,1.8,58.4457551,46.4540759,0.1079701,4.7766705,7.0487126,138.6660296,507.0210326,0.0774479,71.9310119,29.0298505,90.8057627,6.8960801,12.6753336,3.0080636,34.0385844),(1432,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,72,40.4591279,58.3971159,46.3517155,1.8,58.3762743,46.3332103,0.0936015,5.625418,6.9660816,147.053551,501.3573921,0.0589063,71.9712199,26.1409111,91.9815426,7.2139259,12.6517361,3.0227523,34.0840795),(1433,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,73,39.0693905,58.3901765,46.2335413,1.8,58.3782694,46.2020248,0.0786434,5.5476806,6.9182104,142.4467477,486.7317723,0.0401897,70.3551558,25.6768114,90.2179288,7.1250004,12.6127733,3.0522787,33.9742445),(1434,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,74,38.1571177,58.3439061,46.1560306,1.8,58.3223721,46.1094044,0.065706,5.5063402,6.8549839,140.4942009,477.961547,0.0274163,69.7246785,25.5149873,89.4599786,7.2152139,12.5974336,3.0671039,34.0840795),(1435,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,75,38.9296071,58.3218653,45.9585505,1.8,58.3186211,45.9359735,0.0507269,5.5337312,6.8087778,153.8634002,475.0555235,0.0166814,69.7710424,27.8046392,91.7349106,8.0242777,12.4895276,3.0060649,34.8795747),(1436,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,76,38.1355019,58.2984371,45.8947306,1.8,58.2952039,45.8993813,0.0318339,4.5579268,6.7848703,149.1883148,471.950894,0.0064389,69.5593101,32.7316174,89.5810287,7.31164,12.4895276,0.1355277,33.9287494),(1437,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,77,38.6984494,58.2783743,45.7168707,1.8,58.259121,45.7002808,0.0127123,5.3781469,6.7268247,159.4790448,471.7136248,0.0010422,70.1242633,29.653159,93.1444968,7.6217328,12.5162402,0.1503714,34.2849047),(1438,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,78,38.6102285,58.2576583,45.6295455,1.8,58.2316635,45.6421135,-0.0067411,4.8082181,6.875727,159.8014556,474.3506863,0.0002924,68.9891683,33.2350677,91.1717568,0.1875,0.2651651,2.3561945,0.5303301),(1439,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,79,39.2746924,58.2470506,45.4573438,1.8,58.2379739,45.4473856,-0.0239663,4.7973448,6.8501276,168.0394085,477.8022405,0.0037591,69.7508527,35.0275861,93.2991084,7.7934509,12.5456985,0.1651487,34.2849047),(1440,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,80,39.4186733,58.2358786,45.3473742,1.8,58.2312092,45.3080605,-0.0397496,4.7517049,6.8267495,169.0559798,480.257552,0.010375,70.3493742,35.5779628,94.1197889,7.6875005,12.5456985,0.1651487,34.1295746),(1441,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,81,38.8764999,58.2924598,45.1119043,1.8,58.2976501,45.0778311,-0.0572398,4.8100777,6.733986,171.2297982,471.0854911,0.021206,69.9564106,35.5981353,90.8823641,7.6875005,12.4669884,0.2121438,34.4402348),(1442,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,82,38.7854878,58.3272253,44.9259723,1.8,58.3576759,44.8885244,-0.0801554,4.8201293,6.74893,178.8065114,466.1236751,0.0414432,69.0663076,37.0957914,95.2315474,0.1875,0.2651651,2.3561945,0.5303301),(1443,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,83,37.8006865,58.3481243,44.7961082,1.8,58.371072,44.7833203,-0.0989175,4.8824832,6.6415535,178.5347464,459.2605722,0.0614437,69.1495709,36.5663824,96.0176255,8.0318251,12.3934529,0.1825599,34.86073),(1444,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,84,37.0879947,58.3712358,44.6071721,1.8,58.3766266,44.5619158,-0.1148034,5.0681866,6.8099667,183.5977846,453.5874966,0.0811116,66.6064196,36.2255377,92.589483,8.2485072,12.399125,0.3552309,34.7053999),(1445,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,85,36.8055408,58.4140523,44.3927172,1.8,58.4267681,44.3813803,-0.1311963,5.0718057,6.4099099,191.9461649,452.0229363,0.1049813,70.5193904,37.8457249,98.8362075,8.4375005,12.3607881,0.3889569,35.1713902),(1446,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,86,37.1968512,58.4506309,44.1248114,1.8,58.4876295,44.1216471,-0.14989,5.1648968,6.4002409,207.1878695,451.8417484,0.1382437,70.597616,40.1146191,101.7611443,8.6250005,12.399125,0.3552309,34.86073),(1447,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,87,37.1525437,58.5119973,43.9160764,1.8,58.5216507,43.9248663,-0.1668157,5.131922,6.4079322,213.2702022,456.9864514,0.1707179,71.3157435,41.5575691,103.4233981,8.700486,12.433103,0.4029116,34.9705649),(1448,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,88,36.8349655,58.5473663,43.694239,1.8,58.6009737,43.7336888,-0.1887167,5.3875119,6.5532984,223.9471126,454.6186385,0.2160567,69.3724914,41.5678175,103.5383937,8.9176857,12.399125,0.3552309,35.2812251),(1449,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,89,36.1265031,58.6478794,43.3280962,1.8,58.7106667,43.3352267,-0.2171161,5.3193196,6.5097271,243.2172863,443.3800796,0.2793984,68.1103945,45.723383,104.9134713,9.3233248,12.4147098,0.4366272,35.2812251),(1450,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,90,34.298527,58.7134374,43.1228526,1.8,58.775196,43.1318104,-0.2383351,5.4937503,6.6560117,244.7704492,433.5299558,0.3186116,65.1335928,44.5543455,101.6179638,9.4850277,12.5078108,0.4167023,35.7017203),(1451,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,91,33.6193295,58.7982241,42.8390871,1.8,58.8309272,42.8437527,-0.2625349,4.8851628,6.7404488,259.1898992,431.5033019,0.377408,64.0169989,53.0565529,102.4142019,9.8254516,12.5848689,0.4303266,36.3418854),(1452,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,92,32.8382747,58.9240952,42.5664512,1.8,58.9234521,42.5311537,-0.2799429,6.0473046,6.8308112,272.6864036,432.722578,0.4178239,63.348637,45.0922222,103.2302939,10.1250006,12.6753336,0.5099721,36.7168854),(1453,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,93,31.7693967,59.0773921,42.2990582,1.8,59.0720675,42.2338114,-0.280463,6.1178155,6.8935596,283.4536213,435.0423125,0.4056875,63.1085158,46.3324892,104.1432537,10.4445387,12.7555143,0.4241944,37.2017204),(1454,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,94,30.8551424,59.2254679,42.0231389,1.8,59.2462717,41.9843026,-0.2947894,6.3254062,6.9633269,297.1941651,437.4507855,0.4340935,62.8220956,46.9842027,104.9547429,0.1875,0.4192628,2.0344439,0.9053301),(1455,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,95,30.0352239,59.4127112,41.673697,1.8,59.4786719,41.6224956,-0.2921616,6.6054032,7.0957735,310.7865798,445.232976,0.4152729,62.7462218,47.0503573,106.3434653,10.6875007,13.1196426,0.5404195,38.9213904),(1456,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,96,28.9206854,59.6119309,41.3099974,1.8,59.7022177,41.2631221,-0.2731389,6.0706247,7.1860713,322.0035368,446.2763285,0.3507498,62.1029644,53.0428993,106.5651858,11.0046451,13.2807729,0.5331557,40.2017206),(1457,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,97,28.1494531,59.8406353,40.8106096,1.8,59.9038812,40.7197694,-0.2265557,6.7731735,7.2658592,342.5929016,447.8919141,0.2367148,61.6433519,50.5808544,108.2033728,11.2808106,13.5208181,0.5880026,41.5918857),(1458,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,98,28.1103444,60.0745266,40.3230734,1.8,60.2017969,40.2792385,-0.1229364,6.5141906,7.2744734,367.8900797,460.4047579,0.0704509,63.2904588,56.4751794,111.8710602,11.6432286,13.7681707,2.0831858,42.7623809),(1459,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,99,29.8485016,60.3613497,39.6364588,1.8,60.4436412,39.6084787,-0.0629115,6.7933648,7.2470632,416.5640642,498.5917066,0.0196634,68.7991389,61.3192542,113.3179912,12.4308733,15.0992818,2.0622146,45.7890315),(1460,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,100,33.7870674,60.5295338,38.7751091,1.8,60.5621522,38.5269011,0.4287249,7.172702,7.3794871,502.9574853,576.3273155,0.9731578,78.0985604,70.1210624,131.4806846,12.9144275,15.7723066,2.066348,48.2398569),(1461,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,101,35.2351429,60.7597189,38.14103,1.8,60.9080979,37.8591855,0.46453,7.5656135,7.8448143,543.8571371,651.3872488,1.1786529,83.0341195,71.8853977,141.8363025,13.4243607,16.2098071,2.0913772,48.6791967),(1462,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,102,38.5644828,61.1585194,37.8125223,1.8,61.2711549,37.4151596,0.3389835,7.5163185,8.2676197,604.9388599,754.1390753,0.7107133,91.2159855,80.4833989,146.7306871,13.9096115,16.9145381,2.1188202,51.2853522),(1463,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,103,49.7533336,61.4980159,37.2872474,1.8,61.7162058,37.2335199,0.3910285,8.4161659,9.0465329,715.4137751,1012.1725106,1.2045891,111.8851304,85.0047138,176.4309072,14.1126318,17.9315114,2.7669115,57.5128282),(1464,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,104,55.5869707,61.9576099,37.0379534,1.8,61.955638,37.2239552,0.1397554,7.36787,9.5040682,763.2540138,1261.118946,0.1797752,132.69254,103.592221,208.547651,13.52656,18.5634481,2.7367009,58.3083234),(1465,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,105,54.6860757,62.0865514,37.2856184,1.8,62.0977265,37.3599283,0.1485354,6.7877221,9.4651506,635.3449188,1305.0722045,0.1996133,137.8818207,93.6020817,197.1110943,12.7725151,18.7143423,2.7182819,58.9029934),(1466,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,106,52.6301912,62.3140401,37.339502,1.8,62.4665429,37.4693213,0.1574596,6.8175124,9.8146573,555.3412066,1279.0436725,0.21569,130.3197481,81.4580415,177.3149692,12.2251183,19.0411778,2.7043706,58.4636535),(1467,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,107,50.5991505,62.6951492,36.9859583,1.8,62.724652,37.1587386,0.1974247,6.3218943,9.3448995,465.4729283,1105.2412566,0.3244482,118.2721393,73.628711,152.6991357,11.8980595,18.5861603,2.6011732,57.9788185),(1468,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,108,45.048223,63.3541318,36.9458803,1.8,63.2909843,37.0273711,0.065631,5.4433004,8.0837079,300.6631563,792.2131985,0.0322939,98.0012148,55.2354512,125.5162446,10.9796181,16.1870184,2.6986675,49.3005171),(1469,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,109,38.0289572,64.707731,37.0311199,1.8,64.593754,37.0034227,-0.1154045,4.6770084,8.0964847,151.0986873,484.0998552,0.0840388,59.7913633,32.3066954,75.0839118,9.0994692,14.6550182,0.064015,41.3533711),(1470,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,110,22.8633693,66.1556111,36.7479963,1.8,65.5486867,36.8171207,-0.0433919,3.9859821,8.2267258,75.987342,173.2846807,0.0071702,21.0636267,19.0636435,30.3001802,7.8388918,13.2330383,0.1278699,35.1070503),(1471,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,111,2.8933065,68.5129931,37.7065924,1.8,68.4101605,37.7218774,-1.0205373,1.1165585,2.9215298,0.4183559,4.7867537,0.3503636,1.6384408,0.3746834,1.7565027,2.1704295,5.7394608,0.9011574,13.4701172),(1472,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1473,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1474,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,114,2.1701743,73.3099568,37.5092187,1.8,73.3165572,37.5032444,1.4943988,2.8010527,3.0431764,3.6317204,3.9647942,0.3595888,1.3028473,1.2965555,2.4818148,5.5684662,6.167582,1.9117753,18.9475932),(1475,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,115,21.1426944,72.783701,37.6467737,1.8,72.5574602,37.6746456,-1.5522749,5.6743347,6.349924,130.8144156,182.8195603,3.5225737,28.7908265,23.0537009,47.7005034,12.5625008,12.887131,1.4247841,41.9291963),(1476,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,116,38.4405836,71.9620757,37.6906549,1.8,71.7584291,37.6895181,-1.5555991,6.9130696,8.2926675,364.0319941,638.9522961,6.4052844,77.0502727,52.6585169,111.4485272,16.687501,17.0057446,0.9736197,55.0431582),(1477,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,117,80.7776202,65.5556797,38.793437,1.8,62.3305634,38.9033809,-0.2423381,14.1707574,20.7470597,1939.2090575,6833.5547667,0.7752909,329.3746127,136.8458304,401.4324945,12.8461502,26.9928393,1.2160907,86.408014),(1478,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,118,234.5337758,57.7742674,38.5945671,1.8,61.9406263,38.3179377,-0.0942709,12.3647283,20.2410566,8415.3061139,19864.7004978,0.3463561,981.4063008,680.5896524,1272.709308,28.8750018,29.2800345,0.9952265,95.5100438),(1479,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,119,250.3242713,58.1301093,38.59487,1.8,62.2060178,38.4300351,-0.0730448,12.1846619,19.7144187,9290.4918852,21315.9900953,0.2222068,1081.2385782,762.4743292,1384.6908962,28.8750018,29.2241491,0.8990614,95.6653739),(1480,'cephalophus_BayDuiker_radius-cleaned.tif',239,3,120,260.2854445,58.4098985,38.6597513,1.8,62.3652891,38.5590876,-0.0500512,12.396364,19.2032073,9917.8965309,22094.8383773,0.1085832,1150.5806327,800.0649654,1461.8872429,28.8750018,29.2241491,2.4698577,95.6653739),(1481,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1482,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1483,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,3,1.7898795,71.7890862,20.3416208,1.8,71.7822875,20.356148,-1.1098657,1.3620958,2.1717644,0.5575272,1.3419451,0.2392977,0.6179055,0.4093157,0.8743108,2.865527,4.5311425,1.1441688,11.3942918),(1484,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,4,12.6154384,71.5808563,20.6617221,1.8,71.567146,20.7363969,-1.3368944,2.4756271,3.5499114,15.5425363,30.6977949,1.9896236,8.647482,6.278222,12.9754475,5.0745951,7.0978104,1.357858,20.3111079),(1485,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,5,25.7481531,71.0364212,22.2292078,1.8,70.9378478,22.8557363,-1.5111129,3.7570542,8.5264348,54.6171906,265.3003627,4.2760907,31.1150404,14.5372379,37.5140704,6.7929106,14.3287308,1.4659194,35.5652349),(1486,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,6,28.0947052,70.4846694,23.0535733,1.8,70.5649755,23.496392,-1.4844004,3.6949555,9.3152471,86.1965519,410.3754502,4.6475867,44.0541669,23.3281705,52.8715615,7.1773033,16.1783285,1.48958,39.5615555),(1487,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,7,31.327408,70.1892188,23.8090649,1.8,70.2377951,23.6962224,-1.480713,4.0514566,9.5160587,113.0321167,560.1396976,5.1789788,58.8625728,27.8991309,70.2764808,7.8198632,17.3323453,1.4732805,42.6713906),(1488,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,8,35.2335023,69.6467405,24.1625366,1.8,69.8012744,23.6938517,-1.4667164,6.1224516,23.3276277,129.8130938,771.7494033,5.8088678,33.0830641,21.2027961,37.3818041,8.3622341,18.2656195,1.4782777,45.4328762),(1489,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,9,32.454134,68.7234728,24.6141278,1.8,68.9599594,23.5943129,-1.474567,7.0013684,22.8367631,92.6098358,887.246043,5.3590888,38.8516551,13.2273908,41.0519318,8.0351746,18.7471885,1.4303137,47.3988666),(1490,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,10,32.9776,68.1518682,24.9087875,1.8,68.352084,23.6447641,-1.4509281,4.0888672,9.4859677,81.9584644,936.6640488,5.4176716,98.7420659,20.044296,104.6856017,7.4577404,19.019009,1.4024062,47.0427112),(1491,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,11,33.4760518,67.6189552,25.5154241,1.8,67.8758554,24.0694523,-1.4485,4.4794862,10.1125706,67.0408121,962.7182214,5.4963104,95.200148,14.9661835,99.4476745,7.1796972,19.5647974,1.3583643,47.9480414),(1492,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,12,34.4830654,67.181227,26.32792,1.8,67.3896154,24.9274825,-1.4432537,3.4866733,10.7520109,55.2718307,1019.8217893,5.6541933,94.8494008,15.8523114,98.038147,6.1595712,20.3780685,1.3481354,47.7472162),(1493,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,13,35.4489888,66.7496004,27.2351639,1.8,66.9714266,25.9980862,-1.4484384,3.1004071,11.2300935,48.2008552,1034.7122006,5.8201515,92.1374522,15.5466212,95.172954,5.4210711,21.0334568,1.3734008,48.1410609),(1494,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,14,36.3131935,66.3312143,28.1934119,1.8,66.5077617,27.2498761,-1.4611412,3.0434328,11.3561178,45.7411295,1024.001403,5.979717,90.1717841,15.0294527,93.456842,5.0443484,21.3000343,1.4027533,48.2508959),(1495,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,15,38.9750439,65.9489248,29.1311143,1.8,66.0736648,28.5882644,-1.4709858,3.2589666,11.1558051,48.9963593,1082.5773102,6.4313428,97.0416122,15.034324,100.4409564,4.9310184,21.3321953,1.3940875,47.5197405),(1496,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,16,41.7467098,65.5566488,30.1496195,1.8,65.6014647,30.0634676,-1.4706334,3.3755003,11.0333757,57.5164885,1180.6745612,6.8882134,107.0093677,17.0393967,111.3174921,4.7613168,21.4546228,1.4128314,47.7394104),(1497,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,17,45.07899,65.2451376,31.4402437,1.8,65.2515646,31.6888284,-1.4709488,3.5185122,11.3779673,74.0236698,1370.1446744,7.4385109,120.4208657,21.0383439,126.0877659,0.1875,0.4192628,2.0344439,0.9053301),(1498,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,18,50.6799247,64.8590255,32.9295107,1.8,64.813901,33.112813,-1.4642061,4.005316,11.9363911,116.0005382,1611.6008857,8.3510506,135.0157577,28.9616446,144.0196316,0.1875,0.5929271,1.8925469,1.2803302),(1499,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,19,45.4150838,64.8473977,32.4095498,1.8,64.7545892,32.9038614,-1.4814503,4.0883469,10.6167729,109.1434809,1143.2994508,7.5089186,107.6880388,26.696238,117.2853918,7.096168,20.4993343,1.41467,47.8382064),(1500,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,20,38.9844402,64.881793,31.6392645,1.8,64.8299416,31.7845101,-1.5262899,3.8548151,9.1966485,91.7980658,732.7454738,6.484545,79.6752723,23.8138698,89.0393168,0.4550707,1.6020008,1.2120257,3.4659905),(1501,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,21,36.8118157,64.8388762,31.2848367,1.8,64.8281808,31.335292,-1.565854,3.7034967,8.0414024,79.0521098,547.6061945,6.1351528,68.0983445,21.3452625,76.9167213,6.6912208,14.870536,1.4824195,37.4857301),(1502,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,22,33.2142868,64.8030445,31.0963435,1.8,64.7963978,31.1011962,1.5240079,3.5876596,7.2637355,64.1792177,427.5026984,5.5236048,58.8543871,17.8888818,66.8640293,5.624001,13.7694473,1.6799498,33.9930892),(1503,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,23,31.1073405,64.7301889,31.2083989,1.8,64.7223665,31.243691,1.4677706,3.1143903,6.8015534,59.0589674,362.2137159,5.1297208,53.2545573,18.9632517,61.321459,5.7242563,12.9809063,1.7596935,32.6484192),(1504,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,24,29.8481713,64.6236408,31.4334166,1.8,64.6259125,31.513901,1.4143674,3.5539247,6.5918607,59.0746194,329.3400748,4.8539541,49.9616254,16.622361,58.0751416,6.1896332,12.6905792,1.7942729,32.6750697),(1505,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,25,30.7710017,64.5011565,31.7849304,1.8,64.4733654,31.9296949,1.3695104,7.4163599,6.4169564,67.3424412,323.7845838,4.9235051,50.4576569,9.0802553,51.4937566,7.0518837,12.5722917,1.8736812,33.6902348),(1506,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,26,33.4902847,64.1016238,32.2101127,1.8,63.8784454,32.4956725,1.3257562,6.7173508,6.322093,107.3134414,318.0239245,5.2532165,50.3035818,15.9755601,63.3132144,9.7644703,12.6461773,1.8409495,41.2890312),(1507,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,27,34.8628595,63.418125,32.4265807,1.8,63.2356357,32.527348,1.1717459,6.7735953,6.7790972,191.7781435,286.3818954,4.9332917,42.2448428,28.3126074,66.680922,2.0515809,7.8234928,0.8023457,20.6672632),(1508,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,28,30.3582779,62.9816078,32.1172569,1.8,62.6231548,32.0107269,0.1700535,5.5113414,7.2877592,168.0503519,174.3157191,0.1449128,23.9189735,30.4917332,45.6560304,2.1587084,7.8504085,0.7008544,22.3947389),(1509,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,29,26.3529365,62.9722263,32.1478366,1.8,63.0121185,32.2352718,0.7667674,4.9367753,9.5199035,121.2154326,137.4076675,2.1142678,14.4337248,24.553565,27.0937879,1.1166145,1.846661,0.4182243,5.6328061),(1510,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,30,22.0892073,63.1157988,32.2055622,1.8,63.0707751,32.2714955,1.0654782,4.8982259,6.3885741,61.8337741,107.0836927,2.8188072,16.7617517,12.6237081,24.5599814,0.375,0.5929271,2.8198421,1.3258253),(1511,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,31,18.6532907,63.0776282,32.2900172,1.8,63.1335596,32.31852,1.1297797,3.6939053,5.8219657,31.3489849,83.7217209,2.5424166,14.3803186,8.486678,17.8546755,0.8012862,3.6933219,1.152572,8.1479713),(1512,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,32,17.9300307,62.9019928,32.716101,1.8,62.8836783,32.7491124,1.2057792,3.8373784,4.6062969,22.629,80.9472612,2.6075517,17.5731748,5.8969946,22.1909706,1.3014516,1.9304308,2.0778948,6.6934663),(1513,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,33,17.1556129,62.8080796,33.1438893,1.8,62.7858151,33.2472126,1.217096,3.8995487,5.4058246,16.9088705,80.3976606,2.5162333,14.8724139,4.3361096,16.2147891,1.3378762,3.1875002,2.0607537,8.8336315),(1514,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,34,16.3000482,62.6331642,33.4905782,1.8,62.6254493,33.7508928,1.2171873,3.8940753,5.9094439,13.5101934,75.203156,2.3909078,12.7259277,3.4694227,13.5429484,0.6629126,0.7954952,2.3561945,2.1213205),(1515,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,35,15.0044017,62.4009202,33.7480687,1.8,62.351225,34.0281191,1.2311264,4.8337469,9.2719642,10.8803847,64.5113984,2.2231368,6.9576842,2.2509215,7.5457111,2.0982166,4.5388947,2.2390857,14.8869327),(1516,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,36,13.7840323,62.1984389,33.9961517,1.8,62.2774429,34.2517059,1.232395,3.3545938,4.9209097,7.9316175,56.8539736,2.0441481,11.5535496,2.3644048,11.9285238,0.6188832,2.4375002,1.9655874,5.587311),(1517,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,37,13.0907829,62.0496751,34.3393968,1.8,62.1749455,34.5730162,1.2158509,3.2084086,4.8639217,6.6384042,53.484413,1.918272,10.99615,2.0690644,11.0757769,0.2651651,0.5303301,2.3561945,1.0606602),(1518,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,38,12.2516564,61.8563697,34.6749494,1.8,61.893999,34.8719385,1.2171382,2.746991,4.3721438,5.6940936,48.0911828,1.7970203,10.9994514,2.0728475,10.5702717,0.5870627,1.6770511,2.0344439,3.6213206),(1519,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,39,11.160012,61.631913,34.964797,1.8,61.6842316,35.2765074,1.2277486,4.2183814,4.7269836,4.7828253,41.9427117,1.6495665,8.8730394,1.1338058,8.8493388,0.1875,0.2651651,2.3561945,0.5303301),(1520,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,40,9.7589181,61.3547361,35.12237,1.8,61.4475485,35.4832611,1.2552301,3.6262522,4.5967818,3.4661494,32.6868856,1.469823,7.1108194,0.955849,6.7207044,0.5303301,1.4644219,2.2655346,3.0266506),(1521,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,41,8.6712369,61.193896,35.2952128,1.8,61.369005,35.5751975,1.2592359,2.4135972,4.246469,2.6880362,25.7947787,1.309401,6.0744064,1.1137054,6.2209841,0.5034006,1.7688716,2.1293956,3.7766507),(1522,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,42,7.9874264,60.9932709,35.555272,1.8,61.1140815,35.8316163,1.2626656,4.1513777,4.2322765,2.4156375,21.4173897,1.2087938,5.0604893,0.5818882,5.1192988,0.4157892,1.4279575,1.9756881,3.0909905),(1523,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,43,7.4571849,60.8081014,35.8398879,1.8,60.8723084,35.9631087,1.2667932,2.1416817,3.9519723,1.9707877,17.9214831,1.1314964,4.53482,0.9202057,4.4727733,0.5034006,1.5116734,2.0899424,3.2463205),(1524,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,44,7.0730868,60.632456,36.1817216,1.8,60.6502231,36.2966031,1.2811911,2.152391,3.2699379,1.7521178,15.5938056,1.0827099,4.7688384,0.8140332,5.0255974,2.4312015,6.2327892,1.8449638,14.769292),(1525,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,45,6.8289639,60.4579258,36.534271,1.8,60.452897,36.6314934,1.2887013,2.1206757,3.3603834,1.6830449,14.1167477,1.0499657,4.2009337,0.7936362,4.0068253,0.5341053,1.846661,1.9890207,3.9963206),(1526,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,46,6.6018013,60.301836,36.9123962,1.8,60.3249654,37.0358535,1.3042887,2.135232,3.1356488,1.5839968,12.9250597,1.0239827,4.1219729,0.7418383,3.8245998,0.375,1.0097185,1.9513027,2.1856603),(1527,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,47,6.4845605,60.1340123,37.3055717,1.8,60.0919392,37.3748007,1.3336509,9.9492913,2.8411872,1.8800934,12.3393825,1.0211112,4.3430375,0.1889676,1.4257818,0.375,1.1858542,1.8925469,2.5606603),(1528,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,48,6.4885022,59.9677794,37.7479693,1.8,59.8848417,37.9259283,1.3835672,9.7169364,2.9639609,2.4050643,12.3247034,1.0439491,4.1581869,0.2475126,1.4815166,0.4746106,1.0933035,2.1112158,2.3409904),(1529,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,49,6.5378488,59.8630306,38.1850829,1.8,59.8296466,38.4096453,1.4155047,8.6166878,3.0782236,1.9431973,12.9641224,1.0635748,4.2115597,0.2255156,1.7084766,0.1875,0.2651651,2.3561945,0.5303301),(1530,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,50,6.7939462,59.7299038,38.7158151,1.8,59.8429725,39.0900024,1.409164,3.5064409,4.0733899,2.3944023,15.3112368,1.1029991,3.7588439,0.6828583,3.333348,0.375,1.5461647,1.815775,3.4659905),(1531,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,51,7.1434419,59.5852653,39.2697844,1.8,59.7304992,39.652195,1.4339755,4.0993527,3.5675239,2.7380508,18.0861028,1.1684249,5.0696515,0.6679227,3.8588196,1.1153755,3.236752,1.7454685,8.3676412),(1532,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,52,7.1528063,59.3998063,39.6685364,1.8,59.3627571,40.0494113,1.4905372,9.7196533,4.3938404,3.6458057,17.8301778,1.1844717,4.0579939,0.3750963,2.0145438,2.2022423,3.3172138,0.8253769,11.3942918),(1533,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,53,7.2878809,59.2758712,40.1074837,1.8,59.3605255,40.3628179,1.4512318,7.5038347,3.3658533,3.6924499,19.7016605,1.1973652,5.8533926,0.4920751,2.9910699,1.5000001,2.4661776,1.7234457,7.087311),(1534,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,54,6.9638894,59.1624232,40.3595808,1.8,59.4020178,40.5215818,1.4714612,6.9986872,3.247137,2.3378787,17.5802457,1.1492332,5.4140758,0.3340453,2.6641975,0.9375001,2.0710053,1.6614562,5.2766508),(1535,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,55,7.1961124,59.0559666,40.8085596,1.8,59.3510012,40.9703891,1.4604175,8.3034139,3.5754412,2.9261352,19.6925517,1.184799,5.5077264,0.3524015,2.6630055,0.5521653,1.1858542,1.8925469,2.7159904),(1536,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,56,7.0661834,58.9738498,41.0805838,1.8,59.4333267,41.281562,1.410109,5.9332885,3.7925838,3.2362594,18.6241108,1.1475494,4.9106657,0.5454411,3.1043519,0.5625,1.1858542,1.8925469,2.7159904),(1537,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,57,6.5310733,58.8951685,41.2031785,1.8,59.5168118,41.4423982,1.3797204,5.5476723,3.7944702,3.3703394,15.8101677,1.0492519,4.1666338,0.6075231,2.853728,0.375,0.6760409,2.1587989,1.4356603),(1538,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,58,6.2422167,58.7561493,41.3672182,1.8,59.1890431,41.6079152,1.3560641,7.802528,3.8972708,3.8170319,14.0617164,0.9931309,3.6080933,0.4892045,2.2185132,1.3258253,2.1378291,2.4805495,6.2729712),(1539,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,59,5.7874759,58.6526748,41.4638561,1.8,59.1841525,41.7235281,1.3173595,5.8695202,4.3983241,3.3194625,11.9903159,0.9039393,2.7261102,0.5655424,2.0873333,0.3977476,0.9375001,2.4980915,1.8561554),(1540,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,60,5.3981896,58.5479101,41.5530802,1.8,59.116151,41.8199389,1.2782036,6.5492455,4.1736487,3.3359089,10.2896431,0.8248477,2.4653831,0.5093577,2.0543203,1.2113149,1.9121324,1.7681919,5.742641),(1541,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,61,5.2504374,58.3361914,41.6759909,1.8,58.3119983,41.9403665,1.2820614,7.4646692,4.0428045,4.3005911,9.0809987,0.8041248,2.2462127,0.5761261,1.7663747,1.6833894,3.5027893,2.8706458,12.4094569),(1542,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,62,5.2105724,58.2467589,41.8362666,1.8,58.1298738,42.0194831,1.1993639,8.7155469,4.2079379,4.9402351,9.1253815,0.7540279,2.1686113,0.5668302,1.5985998,1.6875001,3.5575626,2.8198421,13.4701172),(1543,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,63,4.9225574,58.20787,41.8949027,1.8,58.2341045,42.0416693,1.2381866,8.6193828,4.4029165,3.5625024,8.4097628,0.7329612,1.9100437,0.4133129,1.318027,0.3356004,0.6760409,2.5535901,1.3258253),(1544,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,64,4.6403592,58.1586273,41.9455406,1.8,58.2660808,42.0138692,1.244092,7.5620753,4.2176646,2.7303177,7.6145432,0.69374,1.8053932,0.361054,1.241797,1.4260637,2.7684045,0.4939414,8.1479713),(1545,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,65,4.5033883,58.1802909,41.9960731,1.8,58.4442438,42.0049046,1.1621712,4.6341812,6.3084486,2.7394376,7.928171,0.6320615,1.2567545,0.5911374,1.5028473,0.75,2.3717084,0.3217506,5.9168158),(1546,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,66,4.3309309,58.1422602,42.0795438,1.8,58.4897647,42.2182194,1.1967198,7.1854186,4.1005162,2.7178668,6.6814793,0.6254393,1.6294239,0.3782475,1.2864613,1.3125001,2.6845916,0.4324078,8.3033014),(1547,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,67,4.2959025,58.0911014,42.1301021,1.8,58.3384749,42.2280432,1.1830257,7.1363955,4.1413993,2.6791167,6.458973,0.6136132,1.5596113,0.375416,1.2628241,0.6785714,2.1378291,2.8753406,4.7918158),(1548,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,68,3.8525822,58.0122607,42.0350472,1.8,58.2553125,42.1882266,1.197559,7.3908085,4.1851378,2.6788086,5.224046,0.5567262,1.2482375,0.3624514,1.0328277,2.9682947,5.1005518,2.1995926,13.3979716),(1549,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,69,3.8344714,57.9736222,42.0586392,1.8,58.1355036,42.1605026,1.1453742,7.0375551,4.2705517,2.3565123,5.1404996,0.530227,1.2037085,0.3348481,1.0630937,0.6633522,1.2577883,2.677945,3.0266506),(1550,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,70,3.8095104,57.891783,42.0328772,1.8,57.8740076,42.084415,1.2430957,6.890664,2.6746469,2.2069804,4.6646917,0.569142,1.7440402,0.3202856,0.9827585,0.5625,2.1378291,2.8753406,4.7918158),(1551,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,71,3.6939316,57.9389026,41.9722646,1.8,58.213447,41.9239413,1.2460468,3.422384,2.4039036,1.123275,4.4768248,0.5529775,1.8623146,0.3282142,1.381811,0.5625,0.6760409,2.5535901,1.7008253),(1552,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,72,3.8436439,57.9510359,41.9917785,1.8,58.1718786,41.9253498,1.2076938,3.332224,2.4754787,1.1962199,4.8210001,0.5597946,1.9475022,0.3589854,1.490767,0.375,0.8385255,2.677945,1.7008253),(1553,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,73,3.4150786,57.9370234,41.7530313,1.8,58.1231472,41.737317,1.1764027,4.0460574,2.9669349,1.1053363,3.7312498,0.4851422,1.257611,0.2731885,0.9639822,0.5048359,1.6020008,2.782822,3.5114856),(1554,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,74,3.6104195,57.9906275,41.7746389,1.8,58.1630104,41.7069283,1.0984265,3.4344664,2.6395942,1.3727496,4.2099592,0.4771632,1.5949267,0.3996981,1.2888241,0.7362204,1.5461647,2.896614,4.1971458),(1555,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,75,3.0703662,57.9188697,41.4990851,1.8,58.1612041,41.490411,1.0821144,3.4905042,3.0602765,1.1729059,2.9282528,0.3989454,0.9568589,0.3360276,0.8834743,2.815059,4.4251592,2.2058231,11.8979715),(1556,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,76,3.3251425,58.0014346,41.3766029,1.8,58.2482179,40.4839311,-1.5215629,4.1052832,29.8508184,1.8969401,16.8055973,0.5528482,0.5629861,0.4620729,0.6259573,0.375,1.8843518,3.041924,4.1061556),(1557,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,77,2.8166552,57.9084726,41.066942,1.8,58.0967215,40.0569159,-1.5129936,4.5862027,29.7549456,1.314056,16.2288811,0.4678758,0.5454179,0.2865238,0.589008,2.6580112,4.2756581,2.2318395,11.4131365),(1558,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,78,3.1983136,57.9770272,40.9845472,1.8,58.1213804,39.265401,-1.5452017,4.2975645,30.1322627,1.741571,28.5796829,0.5327032,0.9484745,0.405246,1.0061324,3.0403024,4.6574037,2.2706892,12.9131366),(1559,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,79,3.2827099,57.984084,40.664359,1.8,58.1541132,38.0059955,-1.5272324,5.8186171,30.1500424,1.991292,46.6090986,0.5460806,1.5459049,0.3422277,1.6110905,3.1531427,4.6574037,2.2706892,12.8033017),(1560,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,80,2.9331396,57.9330784,40.3818626,1.8,58.2136736,37.9581305,-1.5185298,4.3759754,29.880469,1.5777628,39.375701,0.4875224,1.3177739,0.3605511,1.3700759,2.9707184,4.2756581,2.2318395,11.8979715),(1561,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,81,3.6698016,58.0483989,40.562686,1.8,58.1586575,39.0160281,-1.5547203,5.539644,30.2625786,2.591043,29.1963694,0.6114755,0.9647681,0.4677273,1.0502271,0.7139458,1.2005859,0.6747409,2.8258254),(1562,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,82,2.5008348,57.9528218,40.2291541,1.8,57.9490777,40.143521,1.1147956,2.9861011,2.3928059,0.7630173,1.7541843,0.3359797,0.7331077,0.2555229,0.6578291,0.7450962,1.846661,0.4182243,4.3069808),(1563,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,83,2.9012539,58.0532701,40.2010825,1.8,58.1405423,40.0732069,1.0736518,3.8617144,2.8621035,1.0402121,2.3211192,0.3735604,0.8109837,0.2693654,0.6992996,0.5303301,0.8385255,0.4636476,1.8561554),(1564,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,84,2.5697411,57.9624766,39.8276926,1.8,57.9662613,39.5509994,1.4877546,4.2069906,21.33418,1.0791448,3.6481897,0.4253435,0.1710021,0.2565123,0.2202918,0.5034006,0.9375001,0.6435011,1.9659904),(1565,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,85,1.4858738,57.8757367,39.088246,1.8,57.7666703,39.0000024,1.3117407,2.4756267,1.5674565,0.1791336,0.5868507,0.2313946,0.3743968,0.0723589,0.2807549,1.5000001,2.8620635,2.1224513,7.1516509),(1566,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,86,1.6437999,57.9308651,38.9178465,1.8,57.8707969,38.8756034,1.2698941,4.3466725,1.6423909,0.2525113,0.7812581,0.2499008,0.4756834,0.058093,0.237752,1.8639036,3.1206221,2.1421338,8.2123111),(1567,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,87,1.8259839,58.0484192,38.7016733,1.8,58.0468786,38.6128496,1.1092407,2.3302312,1.8895019,0.2191265,1.1043445,0.243973,0.5844633,0.0940364,0.4461374,1.8799275,3.5377431,2.1293956,8.8979713),(1568,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,88,2.2036047,58.1395653,38.4837843,1.8,58.1362818,38.3670137,1.0222222,1.7093649,1.9402913,0.3198072,1.6755763,0.2673956,0.8635694,0.1870912,0.9672773,2.3454492,3.9863049,2.2896263,10.5533015),(1569,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,89,2.100778,58.0561044,37.9286643,1.8,58.1074255,37.8837914,1.1142778,1.6858305,1.9012011,0.3039021,1.4320548,0.2820899,0.7532369,0.1802685,0.7277108,2.4645461,4.242641,2.3561945,10.9926414),(1570,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,90,1.8646451,57.9116703,37.3203814,1.8,57.8667799,37.3042786,1.1914361,3.0022389,1.7416241,0.2256635,1.0696765,0.2681541,0.6141833,0.0751651,0.4314572,2.2212101,3.8654118,2.2531129,10.3979714),(1571,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,91,1.872763,57.8143236,36.7443898,1.8,57.7968786,36.6545162,1.214459,2.4876723,1.73224,0.1845501,0.999324,0.2741438,0.576897,0.0741859,0.3905417,1.6160754,3.3541022,2.0344439,8.2578062),(1572,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,92,2.0868113,57.7288589,36.2393935,1.8,57.7926172,36.2343773,1.1845759,2.9154421,2.3439861,0.3030966,1.2336718,0.2984504,0.5263136,0.1039625,0.4108056,1.9331771,3.6933219,1.9890207,9.1631364),(1573,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,93,2.255849,57.631418,35.6712536,1.8,57.6550201,35.6731108,1.1748608,3.0461725,1.8208967,0.4962836,1.3517159,0.3200514,0.7423353,0.1629204,0.6036971,2.3569191,3.8654118,1.9693188,10.1139617),(1574,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,94,2.3588462,57.5538279,35.0979509,1.8,57.6110729,34.9913425,1.170953,1.4061488,9.4142071,0.6982362,2.0360173,0.3335667,0.2162707,0.4965593,0.2890183,2.7551817,4.0388739,1.9513027,11.1746219),(1575,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,95,2.54168,57.4868156,34.586883,1.8,57.601438,34.6106579,1.0973059,1.4844925,2.1430292,0.9987791,1.675146,0.3355306,0.7816721,0.6728084,1.1833684,2.9971865,4.2135387,1.9347753,11.814787),(1576,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,96,2.6988817,57.3730837,34.0688295,1.8,57.5156286,34.1177906,1.0982304,1.6154983,2.3215494,1.4208108,2.0155426,0.3566203,0.8681885,0.8794876,1.4094188,3.2365206,4.4568244,1.959115,12.564787),(1577,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,97,2.9645245,57.2596662,33.3862297,1.8,57.3904357,33.4444465,1.5473209,1.959244,2.4409445,1.8397027,2.6672547,0.4938152,1.0927142,0.938986,1.7738248,3.4412638,4.6309087,1.943784,13.5799521),(1578,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,98,3.3965097,57.1257269,32.8401614,1.8,57.2185381,32.9191831,-1.4416675,2.9022905,2.7351073,2.1555651,3.7537455,0.5566982,1.3724308,0.7427117,1.8123447,3.490982,4.8750003,1.1760052,13.909457),(1579,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,99,4.1601781,57.0733222,32.1626006,1.8,57.1692826,32.315245,-1.5185709,1.9016656,2.7567071,2.6287977,4.8645911,0.6914736,1.7646384,1.3823659,2.6687217,3.5971615,5.3033012,1.7126934,14.8602823),(1580,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,100,3.2219748,56.9719761,31.2502369,1.8,57.1073624,31.2527741,-0.9971094,2.3444932,2.4172341,1.9242492,2.9150259,0.3788191,1.2059344,0.8207527,1.9361641,3.7632685,4.7434168,1.8925469,14.3754473),(1581,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,101,3.2782035,56.8177182,30.5475477,1.8,56.8852775,30.516269,-0.6675714,1.9367076,2.1823079,1.421703,2.8746988,0.2094011,1.3172746,0.7340824,1.9096816,3.3750002,4.5155982,0.844154,13.1139619),(1582,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,102,2.7440522,56.4338988,29.8022022,1.8,56.4808629,29.6976581,-0.7531337,1.4120278,2.2614213,0.4044469,3.092983,0.2139254,1.3677164,0.2864299,1.4169975,2.0967253,4.5388947,0.9025069,10.7996219),(1583,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,103,3.9702597,56.7401489,29.7778681,1.8,56.7793678,29.6492475,-0.0163107,2.2138916,2.1962694,2.6305096,4.6139922,0.000176,2.1008316,1.1881835,2.9363699,3.7500002,4.6875003,0.9272952,14.9512726),(1584,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,104,4.5660304,56.5964182,29.5637718,1.8,56.6102009,29.4558289,-0.1465266,2.4773726,2.2674393,3.9687478,4.7075279,0.0162222,2.0761429,1.6019988,3.1668112,4.0135311,5.5145408,0.9544994,16.1217678),(1585,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,105,5.9972735,56.5590389,29.3248997,1.8,56.6640073,29.1517875,-1.2030953,3.3059063,3.929944,5.9910706,8.839388,0.8703848,2.2492402,1.8122324,3.7504279,4.2020916,6.4653528,1.0552473,17.4209426),(1586,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,106,8.7594258,56.5453463,29.2787654,1.8,56.5917805,29.1946301,-1.041097,2.2683618,3.2223809,8.502631,16.7356484,1.0871882,5.1935661,3.7483575,7.7428931,4.3067779,6.300112,0.9332475,16.5799523),(1587,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,107,5.3357819,56.6261581,28.469872,1.8,56.5137676,28.9655917,-1.1732713,2.0918133,3.2470063,2.6007594,9.8029164,0.7560132,3.0190629,1.2433038,3.6885027,3.7746903,6.3029015,1.0405806,16.6254475),(1588,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,108,0.5540413,56.9512015,27.4116321,1.8,56.9220333,27.4028482,-1.0890969,0.8646674,1.3762441,0.0773632,0.2186152,0.0725209,0.1588491,0.0894716,0.2106443,1.8453262,2.9646355,0.9652517,7.3524761),(1589,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,109,38.0289572,64.707731,37.0311199,1.8,64.593754,37.0034227,-0.1154045,4.6770084,8.0964847,151.0986873,484.0998552,0.0840388,59.7913633,32.3066954,75.0839118,9.0994692,14.6550182,0.064015,41.3533711),(1590,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,110,22.8633693,66.1556111,36.7479963,1.8,65.5486867,36.8171207,-0.0433919,3.9859821,8.2267258,75.987342,173.2846807,0.0071702,21.0636267,19.0636435,30.3001802,7.8388918,13.2330383,0.1278699,35.1070503),(1591,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,111,2.8933065,68.5129931,37.7065924,1.8,68.4101605,37.7218774,-1.0205373,1.1165585,2.9215298,0.4183559,4.7867537,0.3503636,1.6384408,0.3746834,1.7565027,2.1704295,5.7394608,0.9011574,13.4701172),(1592,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1593,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1594,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,114,2.1546523,73.2908417,37.5106516,1.8,73.2895788,37.5051879,1.494555,2.7819189,3.0430978,3.5209239,3.959757,0.3570253,1.3012257,1.2656458,2.4455924,5.5684662,6.167582,1.9117753,18.9475932),(1595,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,115,18.3499774,72.2221447,37.6485353,1.8,71.9625328,37.676948,-1.5596416,5.1068461,6.3519846,86.6188049,162.2495366,3.057949,25.5431251,16.9613109,36.9362537,12.5625008,12.887131,1.4247841,41.9291963),(1596,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,116,33.7387116,71.3309809,37.6973535,1.8,71.1185212,37.695335,-1.5608923,6.2775519,8.2920701,253.5353634,558.8241982,5.622567,67.3926043,40.3876175,89.8754002,16.687501,17.0057446,0.9736197,55.0431582),(1597,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,117,70.5855131,65.5170784,38.409643,1.8,62.706086,38.286342,-0.1742108,13.0367155,18.1755889,1615.3762292,4911.9941895,0.3534406,270.2522717,123.9097556,337.9246858,12.8461502,26.9928393,1.2160907,86.408014),(1598,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,118,192.3966079,58.6711452,37.8480241,1.8,62.5066731,37.6880636,0.0112019,12.8195821,17.1915074,6137.3878169,14056.4007016,0.0040237,817.6363096,478.7510067,998.070848,28.8750018,29.2800345,0.9952265,95.5100438),(1599,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,119,206.4424157,59.0017051,37.7234112,1.8,62.6943827,37.4912526,-0.0146157,13.4968143,16.916937,6867.7545571,15056.4735863,0.0073495,890.0236262,508.8426358,1074.3010751,28.8750018,29.2241491,0.8990614,95.6653739),(1600,'cephalophus_BayDuiker_ulna-cleaned.tif',239,4,120,215.6955951,59.265932,37.6344088,1.8,62.82319,37.3529417,-0.0436424,13.7055769,17.0059641,7403.0488895,15624.9546783,0.0684275,918.7926412,540.1486541,1118.9272949,28.8750018,29.2241491,2.4698577,95.6653739),(1601,'cephalophus_BayDuiker_metacarpus.tif',239,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1602,'cephalophus_BayDuiker_metacarpus.tif',239,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1603,'cephalophus_BayDuiker_metacarpus.tif',239,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1604,'cephalophus_BayDuiker_metacarpus.tif',239,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1605,'cephalophus_BayDuiker_metacarpus.tif',239,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1606,'cephalophus_BayDuiker_metacarpus.tif',239,5,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1607,'cephalophus_BayDuiker_metacarpus.tif',239,5,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1608,'cephalophus_BayDuiker_metacarpus.tif',239,5,8,2.2911864,51.9311904,39.3974258,1.8,51.138942,39.7598946,-0.6754837,4.674027,7.2127609,8.8326639,23.1960566,0.149297,3.2159747,1.8897332,4.0531122,2.1479905,5.8726728,1.8622531,13.7086318),(1609,'cephalophus_BayDuiker_metacarpus.tif',239,5,9,52.7026557,51.4429928,39.767105,1.8,51.1838039,39.7018063,0.0247281,6.3560153,8.1145191,377.2757193,957.6634041,0.00537,118.018504,59.3572702,158.5338453,11.1072503,16.3081901,2.9915657,49.8574977),(1610,'cephalophus_BayDuiker_metacarpus.tif',239,5,10,53.0830144,50.7265181,39.2469869,1.8,51.0448016,39.5647729,0.1753948,7.7063144,9.1886047,520.3207723,1013.3294755,0.269389,110.2811046,67.5187575,160.3358835,11.9575922,16.4199061,3.0271523,49.0620025),(1611,'cephalophus_BayDuiker_metacarpus.tif',239,5,11,46.8186706,50.9097982,39.4746052,1.8,51.108763,39.7116167,0.2163344,7.1119016,8.8488694,476.9886734,864.2525957,0.3595286,97.6681381,67.0690769,148.5311495,11.877097,15.9771575,0.0704713,49.1718375),(1612,'cephalophus_BayDuiker_metacarpus.tif',239,5,12,43.7436596,51.0850118,39.7702209,1.8,51.1014721,39.9274281,0.2242442,6.8977142,8.0170343,424.0007279,741.0678479,0.3605078,92.4366563,61.4697442,140.5226088,11.1435728,15.1515788,2.4262551,46.940682),(1613,'cephalophus_BayDuiker_metacarpus.tif',239,5,13,40.3004986,51.2040842,40.0393729,1.8,51.1941278,40.2371168,0.1837062,7.0138035,7.2653759,352.1977512,630.3595807,0.2241381,86.7621431,50.214944,118.4041805,10.6875007,14.0937162,2.4315234,43.8041964),(1614,'cephalophus_BayDuiker_metacarpus.tif',239,5,14,37.4264322,51.3113585,40.1848666,1.8,51.3112085,40.3468759,0.1570595,6.2291019,6.7312919,299.2106686,542.1395935,0.1526095,80.5401999,48.0343195,116.9380896,10.0420752,13.0605569,2.4578833,41.2890312),(1615,'cephalophus_BayDuiker_metacarpus.tif',239,5,15,36.370072,51.3912981,40.3704207,1.8,51.3625928,40.4956589,0.1552406,5.8746253,6.5553178,267.2830285,490.185738,0.1449146,74.7768077,45.4978854,96.7924059,9.5950795,12.4514691,2.8198421,39.0123807),(1616,'cephalophus_BayDuiker_metacarpus.tif',239,5,16,35.7126288,51.3876777,40.4682525,1.8,51.3337041,40.5709687,0.1571353,5.9522051,6.5034399,243.8908462,449.3411508,0.1457608,69.0928428,40.9748725,98.0490558,9.3668647,12.0962941,2.8100385,37.8873806),(1617,'cephalophus_BayDuiker_metacarpus.tif',239,5,17,35.5019682,51.4769478,40.5487229,1.8,51.4562778,40.6691842,0.1642825,5.6988971,6.1800911,229.215052,411.3900518,0.1582608,66.5669877,40.2209493,90.8270543,9.0163092,11.7468421,2.6422459,35.98573),(1618,'cephalophus_BayDuiker_metacarpus.tif',239,5,18,35.1490314,51.4870833,40.6821058,1.8,51.464999,40.8631582,0.1688432,5.781294,6.7649901,217.4956156,380.5391804,0.165424,56.2512547,37.6205771,86.0281945,8.9036611,11.4758585,3.0598083,35.125895),(1619,'cephalophus_BayDuiker_metacarpus.tif',239,5,19,34.4762472,51.4927525,40.792792,1.8,51.4818043,40.9790846,0.1706994,5.3892607,6.4924534,204.2065252,351.527037,0.1658099,54.1439447,37.8913804,82.4352518,8.5435141,11.2889956,2.9409398,33.8000697),(1620,'cephalophus_BayDuiker_metacarpus.tif',239,5,20,34.2764318,51.5165036,40.9419617,1.8,51.5032523,41.1322675,0.1871774,5.6463952,6.0215676,199.0514234,332.964008,0.1978215,55.2952369,35.2528325,78.8510451,8.4375005,11.0290816,2.8305944,32.8947396),(1621,'cephalophus_BayDuiker_metacarpus.tif',239,5,21,33.7006683,51.5389345,41.0678942,1.8,51.5905205,41.2586233,0.1981256,5.4681286,6.3837502,191.3760256,313.6074085,0.2176099,49.12589,34.9984504,67.5315054,8.5412225,10.8701505,2.8798792,32.3644095),(1622,'cephalophus_BayDuiker_metacarpus.tif',239,5,22,33.367078,51.573376,41.2181641,1.8,51.5913404,41.4092492,0.2089597,5.8083106,6.3211417,183.7082224,299.7077446,0.2393106,47.4135464,31.6285124,72.6885154,8.3566492,10.7383665,2.9304993,31.8795745),(1623,'cephalophus_BayDuiker_metacarpus.tif',239,5,23,33.3668756,51.6239535,41.3987007,1.8,51.6633097,41.5862218,0.2194965,5.4019775,6.2324732,179.506191,291.7653979,0.2636536,46.8137426,33.2297181,72.6853413,8.340292,10.5600965,2.8535372,31.5045745),(1624,'cephalophus_BayDuiker_metacarpus.tif',239,5,24,33.304681,51.6611661,41.5678427,1.8,51.6361081,41.7081088,0.2160609,5.2360979,6.4418867,174.8934657,284.7277333,0.255116,44.1994321,33.4014891,70.5883202,8.2500005,10.5083679,2.8706458,31.5045745),(1625,'cephalophus_BayDuiker_metacarpus.tif',239,5,25,33.0468578,51.7862052,41.693229,1.8,51.8144008,41.8573318,0.2204909,5.2124939,6.46377,170.5018555,274.2957546,0.2634577,42.435878,32.7102265,61.3456415,8.17902,10.4142712,2.9053474,30.8644094),(1626,'cephalophus_BayDuiker_metacarpus.tif',239,5,26,32.7286405,51.8267055,41.865724,1.8,51.846904,42.0700327,0.2201097,5.0906364,6.2190889,166.1919375,265.2906886,0.260034,42.6574846,32.6465935,68.7401001,8.1601902,10.2783532,2.8833404,30.7090793),(1627,'cephalophus_BayDuiker_metacarpus.tif',239,5,27,32.4574259,51.8544273,42.0238412,1.8,51.8539707,42.2155858,0.2176631,5.5320416,6.1562243,161.9834257,257.3124579,0.2522685,41.7971222,29.2809487,66.8357735,8.0901593,10.1492771,2.9369508,30.4439142),(1628,'cephalophus_BayDuiker_metacarpus.tif',239,5,28,32.283754,51.8958506,42.1768387,1.8,51.9309371,42.3678285,0.215971,5.2098875,6.0820636,158.7674383,250.4450457,0.2470933,41.1776433,30.4742544,66.6922903,8.0480355,10.0220466,2.8375917,30.3984191),(1629,'cephalophus_BayDuiker_metacarpus.tif',239,5,29,32.301215,51.9304647,42.3211884,1.8,51.9372575,42.4503221,0.2041869,4.996554,6.0137134,156.2957675,245.8332541,0.2213498,40.8787777,31.280712,65.4729066,7.9925732,9.9073842,2.6271413,30.0689142),(1630,'cephalophus_BayDuiker_metacarpus.tif',239,5,30,32.5143791,51.9658257,42.4951684,1.8,51.9676546,42.6710232,0.2000964,5.0061712,5.3407996,157.3748521,243.2780136,0.2140913,45.5508595,31.4361704,62.4122581,8.1275885,9.8397319,2.6011732,30.0689142),(1631,'cephalophus_BayDuiker_metacarpus.tif',239,5,31,32.632568,52.0054456,42.6519495,1.8,52.0058409,42.8501823,0.1982029,5.5520894,5.8359996,157.2726466,241.3289274,0.2108752,41.3517722,28.3267496,59.7719138,8.0184563,9.8397319,2.6011732,29.758254),(1632,'cephalophus_BayDuiker_metacarpus.tif',239,5,32,32.7088038,52.0628898,42.8019914,1.8,52.0649389,42.9752751,0.2037466,4.8366414,5.3187291,156.8804367,240.265467,0.2231907,45.1734735,32.4358212,64.8667353,8.0278513,9.8164807,2.6437703,29.9135841),(1633,'cephalophus_BayDuiker_metacarpus.tif',239,5,33,32.0704515,52.2046315,42.9192584,1.8,52.2111519,43.1256207,0.2013817,5.4777419,5.0059582,153.8201068,235.1027369,0.2138527,46.9645822,28.0809336,62.416071,7.9643846,9.8236408,2.7291822,29.648419),(1634,'cephalophus_BayDuiker_metacarpus.tif',239,5,34,31.5357248,52.2711511,43.0378208,1.8,52.2839652,43.2272641,0.1905915,5.0391001,5.3606392,150.4570711,231.444105,0.1886226,43.1747219,29.8579244,53.6679234,7.8995848,9.787788,2.7895483,29.648419),(1635,'cephalophus_BayDuiker_metacarpus.tif',239,5,35,31.2401886,52.3179871,43.1561791,1.8,52.3001462,43.3326776,0.1748677,4.9124755,5.3543159,149.0760731,229.372883,0.1575978,42.8388777,30.346426,63.3368478,7.9643846,9.787788,2.7895483,29.8037491),(1636,'cephalophus_BayDuiker_metacarpus.tif',239,5,36,31.5490416,52.3693113,43.2653938,1.8,52.3787091,43.4397929,0.16182,5.3428713,5.233685,149.0657164,232.1097593,0.1364914,44.3492031,27.8999267,53.0499812,7.8805766,9.787788,2.7895483,29.8037491),(1637,'cephalophus_BayDuiker_metacarpus.tif',239,5,37,31.7195175,52.4108908,43.3753758,1.8,52.4066283,43.5285027,0.1499531,5.6931543,5.5565095,148.4554322,233.8297203,0.1179854,42.0821239,26.0761303,61.7468659,7.8291146,9.7500006,2.7468015,29.5385841),(1638,'cephalophus_BayDuiker_metacarpus.tif',239,5,38,31.7103662,52.4502488,43.4807795,1.8,52.4613487,43.6147116,0.1312893,5.7082846,5.4511101,147.5604755,234.5202364,0.0905758,43.022473,25.8502311,59.3415125,7.7530092,9.7788042,2.5748634,29.4930889),(1639,'cephalophus_BayDuiker_metacarpus.tif',239,5,39,31.5659912,52.4846912,43.5885579,1.8,52.4766293,43.7163391,0.1176536,5.6182982,5.7014783,146.6381756,235.2090063,0.0724893,41.2540389,26.1001054,63.8983746,7.7984175,9.787788,2.7895483,29.648419),(1640,'cephalophus_BayDuiker_metacarpus.tif',239,5,40,31.3821772,52.5164418,43.6800821,1.8,52.503075,43.7745335,0.1101615,5.121767,5.5651996,144.8906264,235.4235166,0.0632171,42.3027987,28.2891876,60.7482548,7.7064966,9.787788,2.7895483,29.758254),(1641,'cephalophus_BayDuiker_metacarpus.tif',239,5,41,31.0189492,52.6102018,43.7256795,1.8,52.6149268,43.8505129,0.1097104,6.1606547,5.663839,142.4503038,234.2461138,0.0619767,41.358187,23.1225918,47.8445212,7.6497511,9.794969,3.0457335,29.9590792),(1642,'cephalophus_BayDuiker_metacarpus.tif',239,5,42,30.5580827,52.6516006,43.8076468,1.8,52.6408851,43.9485901,0.1047508,5.392057,5.6006572,140.1406093,232.9738058,0.0556802,41.5975839,25.9901945,62.8232385,7.6791984,9.8379453,3.0077817,29.9135841),(1643,'cephalophus_BayDuiker_metacarpus.tif',239,5,43,30.3833454,52.697213,43.8914358,1.8,52.7114616,44.0033882,0.1002058,5.3030829,5.5893308,137.4899858,234.1173624,0.0506776,41.8864742,25.9264259,64.2713984,7.6168585,9.8682736,2.8920057,29.9135841),(1644,'cephalophus_BayDuiker_metacarpus.tif',239,5,44,30.3108063,52.7174091,43.9736648,1.8,52.7324981,44.0901221,0.0979888,5.328166,5.6136328,135.4705498,236.3038678,0.0483514,42.0946429,25.4253622,58.5054518,7.5531817,10.0062487,2.9147938,29.648419),(1645,'cephalophus_BayDuiker_metacarpus.tif',239,5,45,30.2488355,52.745628,44.0623161,1.8,52.7664507,44.1750807,0.0980834,5.2430316,5.5584989,133.1980062,237.8534555,0.0483454,42.7909512,25.4047691,58.8655743,7.5727855,10.0500706,2.896614,29.758254),(1646,'cephalophus_BayDuiker_metacarpus.tif',239,5,46,30.2936117,52.7664388,44.1593525,1.8,52.8014076,44.269767,0.101102,5.1212806,5.1465816,132.0869553,238.8167993,0.0514326,46.4029948,25.7917822,61.7395003,7.4410434,10.0500706,2.896614,29.9590792),(1647,'cephalophus_BayDuiker_metacarpus.tif',239,5,47,30.2526068,52.7813431,44.2296369,1.8,52.7855598,44.2930681,0.0943654,4.8801093,5.1568215,129.6871415,239.7088053,0.044766,46.4838286,26.5746389,60.9881447,7.4393156,10.0971846,2.8785979,29.4930889),(1648,'cephalophus_BayDuiker_metacarpus.tif',239,5,48,30.2684803,52.7879457,44.3110245,1.8,52.8022281,44.394481,0.0865172,4.9256866,4.9458478,127.5831852,241.1325869,0.037667,48.7545503,25.9016044,60.100206,7.4080525,10.0500706,2.896614,29.648419),(1649,'cephalophus_BayDuiker_metacarpus.tif',239,5,49,29.6687146,52.8682614,44.3388772,1.8,52.8851529,44.4121288,0.0940448,5.3101732,5.4855357,122.7163213,236.8300005,0.043605,43.1735408,23.1096644,47.785218,7.3110769,10.1492771,2.9369508,29.383254),(1650,'cephalophus_BayDuiker_metacarpus.tif',239,5,50,28.8418608,52.886284,44.3940459,1.8,52.9196068,44.447277,0.0955191,4.7112108,5.5092113,118.3625822,230.5892451,0.0437252,41.8552188,25.1236012,61.9797026,7.2030004,10.1492771,2.9369508,29.383254),(1651,'cephalophus_BayDuiker_metacarpus.tif',239,5,51,28.5443644,52.8880797,44.4749376,1.8,52.9153273,44.5182866,0.0892847,4.635226,5.3681773,116.093097,227.5024591,0.0378241,42.3798334,25.045833,54.6776747,7.2590186,10.1128406,2.9551058,29.5385841),(1652,'cephalophus_BayDuiker_metacarpus.tif',239,5,52,27.9284907,52.9051892,44.5531543,1.8,52.9219835,44.6351,0.0913301,4.5765615,5.9458117,112.364958,223.4123213,0.0387183,37.5747387,24.5522667,49.54396,7.186624,10.1128406,2.9551058,29.1180889),(1653,'cephalophus_BayDuiker_metacarpus.tif',239,5,53,27.2410048,52.9453968,44.630504,1.8,52.9782288,44.6877421,0.0916856,4.988769,5.4316382,106.6229155,219.4352729,0.038059,40.3994642,21.3725902,52.0119073,7.0441921,10.1683108,3.0492633,29.4287491),(1654,'cephalophus_BayDuiker_metacarpus.tif',239,5,54,26.6734763,52.963062,44.6938118,1.8,52.9762947,44.7427078,0.0903874,4.5591346,5.1171699,101.5419902,216.9470418,0.0362211,42.3959038,22.272207,52.9920572,6.8818257,10.1492771,2.9369508,28.8529239),(1655,'cephalophus_BayDuiker_metacarpus.tif',239,5,55,26.5219209,52.9642932,44.7569856,1.8,52.9778545,44.8009598,0.0797962,4.9689874,5.497385,99.1273305,217.0666608,0.0280864,39.4854389,19.9492015,50.7173001,6.7435759,10.1890343,2.9189317,28.5422637),(1656,'cephalophus_BayDuiker_metacarpus.tif',239,5,56,26.2741759,52.9820181,44.8109856,1.8,52.9767804,44.8317375,0.0659727,4.4181591,5.0684144,96.0604487,218.844171,0.0190316,43.178034,21.7421886,51.9051519,6.7262575,10.2646624,2.976444,28.6975938),(1657,'cephalophus_BayDuiker_metacarpus.tif',239,5,57,25.3737603,53.0502357,44.8316847,1.8,53.0370744,44.872705,0.0601245,4.4259912,5.9217332,90.0103664,216.4490849,0.0152691,36.5516444,20.3367705,50.2218621,6.7500004,10.3736828,3.0329314,29.008254),(1658,'cephalophus_BayDuiker_metacarpus.tif',239,5,58,24.4766472,53.0817535,44.9072542,1.8,53.0733569,44.9609927,0.0452005,4.1204576,5.7199369,84.504247,213.9733582,0.008329,37.4083422,20.5084617,47.4925375,6.5625004,10.4815693,2.9617392,28.6332539),(1659,'cephalophus_BayDuiker_metacarpus.tif',239,5,59,24.3642538,53.1189364,44.966346,1.8,53.1043255,44.9968934,0.0319834,4.4802422,5.7929053,83.4030444,216.4772204,0.0041524,37.3693695,18.6157445,47.6183607,6.5625004,10.6066024,2.9996956,29.0537491),(1660,'cephalophus_BayDuiker_metacarpus.tif',239,5,60,24.5754044,53.1680875,45.0488751,1.8,53.1695598,45.0700129,0.0205778,5.1081179,5.3477401,83.6271418,221.0378425,0.0017342,41.3329441,16.3714197,47.105963,6.5625004,10.8199042,2.9849908,29.1180889),(1661,'cephalophus_BayDuiker_metacarpus.tif',239,5,61,23.5904433,53.1913811,45.1685371,1.8,53.1824596,45.2016979,0.0130284,5.2289117,6.4688805,83.2519241,225.3875574,0.0006673,34.8418181,15.9214631,43.9610165,6.5625004,11.1195569,3.0402462,29.9590792),(1662,'cephalophus_BayDuiker_metacarpus.tif',239,5,62,22.899772,53.2199186,45.2792609,1.8,53.2297417,45.2724085,0.0099152,5.3399351,6.8819591,86.143335,232.1600826,0.0003752,33.734592,16.1319068,43.2636804,6.7500004,11.1904682,0.1513754,30.2885841),(1663,'cephalophus_BayDuiker_metacarpus.tif',239,5,63,21.8488877,53.2029288,45.3744676,1.8,53.2431517,45.348432,0.0008423,5.0605816,6.8883699,87.5702792,237.6381003,0.0000026,34.4984521,17.3043903,44.4940271,0.1875,0.2651651,2.3561945,0.5303301),(1664,'cephalophus_BayDuiker_metacarpus.tif',239,5,64,21.7949495,53.1665146,45.4729732,1.8,53.2275884,45.4590997,-0.0104354,4.9874815,6.1183098,95.6418757,246.4914683,0.0003956,40.2875101,19.1763871,54.6280735,7.1029262,12.0234154,0.0624188,31.7697395),(1665,'cephalophus_BayDuiker_metacarpus.tif',239,5,65,21.1572576,53.2512212,45.5373601,1.8,53.2554001,45.5068388,-0.0231973,5.0708233,7.1379315,100.697064,258.7124888,0.0018972,36.2447425,19.8581292,47.9434271,7.3001783,12.4655784,0.1206237,33.2053998),(1666,'cephalophus_BayDuiker_metacarpus.tif',239,5,66,20.3274848,53.2731272,45.6667107,1.8,53.218561,45.5943778,-0.0173425,4.9528479,6.6153425,103.9994519,267.7043856,0.0010189,40.4671998,20.9979093,54.5056894,7.8750005,12.8379329,0.1171087,35.1525455),(1667,'cephalophus_BayDuiker_metacarpus.tif',239,5,67,20.9721653,53.2660903,45.841058,1.8,53.1761654,45.7880113,-0.0191364,5.1349805,6.9792747,111.876257,300.0008893,0.0012799,42.9845369,21.7870852,57.9388308,8.4375005,13.5325138,0.0693331,37.539031),(1668,'cephalophus_BayDuiker_metacarpus.tif',239,5,68,24.7893568,53.2078486,46.0314178,1.8,53.0409898,45.9421379,-0.0174954,4.9674173,7.2938319,131.4061482,363.2013968,0.0012645,49.7956905,26.4536155,66.7931309,8.9189754,14.2697241,3.0890096,39.7246913),(1669,'cephalophus_BayDuiker_metacarpus.tif',239,5,69,35.2145392,53.0065238,46.3242649,1.8,52.9952479,46.1127746,-0.0271935,5.0708641,7.5229172,171.4135149,557.8554671,0.0043391,74.1541412,33.8036102,92.5407569,9.3925217,15.2613953,3.0431465,43.9140314),(1670,'cephalophus_BayDuiker_metacarpus.tif',239,5,70,41.0927821,52.9478262,46.6042099,1.8,52.9609777,46.4160515,-0.0520985,5.9205072,7.9452074,205.4535698,692.0159156,0.0185726,87.0985336,34.7020218,110.6527563,9.8333112,15.7823339,0.1671018,48.4218374),(1671,'cephalophus_BayDuiker_metacarpus.tif',239,5,71,43.4908222,52.9482937,46.7333736,1.8,52.8991775,46.859849,-0.0846902,5.8312106,7.7043692,245.8923412,732.8468286,0.051865,95.120938,42.1683177,116.0005097,10.0349443,15.9507308,0.3105986,54.1644785),(1672,'cephalophus_BayDuiker_metacarpus.tif',239,5,72,42.6772852,53.0388551,46.72145,1.8,53.0160633,46.9348829,-0.0566684,6.0614463,7.9536425,313.7216118,744.2940125,0.0228172,93.5790132,51.7568905,122.8244098,10.6826668,15.9507308,0.3105986,65.0394791),(1673,'cephalophus_BayDuiker_metacarpus.tif',239,5,73,44.5046114,53.0468063,46.638319,1.8,52.9607715,46.8511457,-0.0522244,6.1891333,8.2647949,345.33195,769.632245,0.0202119,93.1217597,55.7964957,127.6598977,7.6875005,11.6627419,0.933726,33.8189144),(1674,'cephalophus_BayDuiker_metacarpus.tif',239,5,74,43.3834252,53.1177324,46.6781997,1.8,53.0528734,46.7687592,-0.0272075,5.2405523,7.750314,272.2139022,738.3525571,0.0053511,95.2674373,51.9437433,120.6095479,7.3125005,10.8052728,0.8960554,31.962759),(1675,'cephalophus_BayDuiker_metacarpus.tif',239,5,75,31.0659307,53.8504067,46.655881,1.8,53.3707593,46.7031609,0.0068577,4.4821572,8.2797773,126.0701157,398.02206,0.0002435,48.0715901,28.1271071,62.4202341,7.5032063,9.0506394,0.6973908,31.0197395),(1676,'cephalophus_BayDuiker_metacarpus.tif',239,5,76,9.0646247,53.9546036,46.6577814,1.8,53.4410635,46.6321232,-0.0056727,3.2323183,4.8350095,16.5399528,53.3237907,0.0000486,11.0286837,5.1170558,13.5089185,3.5018844,5.6187469,1.122073,15.254127),(1677,'cephalophus_BayDuiker_metacarpus.tif',239,5,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1678,'cephalophus_BayDuiker_metacarpus.tif',239,5,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1679,'cephalophus_BayDuiker_metacarpus.tif',239,5,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1680,'cephalophus_BayDuiker_metacarpus.tif',239,5,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1681,'cephalophus_BayDuiker_metacarpus.tif',239,5,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1682,'cephalophus_BayDuiker_metacarpus.tif',239,5,82,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1683,'cephalophus_BayDuiker_metacarpus.tif',239,5,83,0.0197621,64.687504,37.986997,1.8,64.687504,37.979169,1.5616505,0.0078835,0.8619586,0.0000584,0.0063871,0.0032934,0.0074099,0.0074112,0.0074774,14.4375009,14.7375486,0.9298397,47.8460122),(1684,'cephalophus_BayDuiker_metacarpus.tif',239,5,84,2.3981999,64.1278526,38.1468774,1.8,64.01559,38.1536807,-1.5699576,1.1288626,5.352654,0.493802,12.2635497,0.3996997,2.2911157,0.4374332,2.3702414,17.8125011,18.2656195,1.0198138,59.3689836),(1685,'cephalophus_BayDuiker_metacarpus.tif',239,5,85,7.0214071,63.5880224,38.1267947,1.8,63.4772224,38.1316443,1.569421,1.9027492,7.3752736,4.3363017,72.629314,1.1702323,9.8476772,2.2789665,10.3194868,20.4375013,20.9337696,1.0349851,67.9562948),(1686,'cephalophus_BayDuiker_metacarpus.tif',239,5,86,12.2372743,63.1519132,38.1357473,1.8,63.0314208,38.151496,1.5688199,2.5907419,8.7422735,14.1033676,184.6250111,2.0395377,21.1186495,5.4437563,22.3966218,22.6716126,22.9593745,1.0303768,74.8239359),(1687,'cephalophus_BayDuiker_metacarpus.tif',239,5,87,17.8425768,62.5542176,38.3181098,1.8,61.88508,38.508791,-1.5522052,7.8521738,9.4565802,57.5697787,326.4940843,2.9727351,34.5255979,7.3316995,34.3771544,1.8739795,11.1904682,1.4194209,26.6029237),(1688,'cephalophus_BayDuiker_metacarpus.tif',239,5,88,201.4455294,50.4663449,40.7462466,1.8,50.8255483,40.6242951,-0.8797001,16.0595349,17.489287,5760.8334342,8792.8738323,19.9345089,502.7577085,358.7173276,811.3133402,28.3125018,29.0776189,1.2082521,94.7600437),(1689,'cephalophus_BayDuiker_metacarpus.tif',239,5,89,270.0716353,49.3181476,40.5616006,1.8,51.053899,40.5419119,-0.9030704,17.4870831,17.9572691,8497.2423898,11905.4551641,27.7538669,662.9880692,485.9153656,1087.8379759,29.035574,29.2451937,0.8579976,95.9305389),(1690,'cephalophus_BayDuiker_metacarpus.tif',239,5,90,274.2538127,49.457258,40.5580521,1.8,51.2534047,40.5619426,-0.8657866,17.6372037,18.053695,8808.4737345,12194.1996936,26.5131468,675.4406618,499.4257514,1126.7891156,29.035574,29.2271564,2.4197452,95.9305389),(1691,'cephalophus_BayDuiker_metacarpus.tif',239,5,91,277.3713095,49.5617754,40.5703834,1.8,51.3734654,40.5973499,-0.848047,17.6226999,18.0732042,9030.5104644,12407.7327937,26.002867,686.5264548,512.4362614,1155.0005078,28.8750018,29.25541,0.9080668,95.8850438),(1692,'cephalophus_BayDuiker_metacarpus.tif',239,5,92,279.5334085,49.6239947,40.5769989,1.8,51.4543197,40.592475,-0.8378716,17.6672003,18.0785822,9163.4503686,12539.5587164,25.7346431,693.6140557,518.6702036,1172.2219926,29.1298653,57.6970166,0.0682975,187.6905825),(1693,'cephalophus_BayDuiker_metacarpus.tif',239,5,93,280.8609833,49.6564146,40.5811376,1.8,51.476019,40.5812087,-0.8349654,17.7577704,18.0714195,9231.9297538,12608.1465066,25.7215328,697.6843478,519.8811301,1181.1536578,29.141163,57.7101156,0.0715389,185.4405824),(1694,'cephalophus_BayDuiker_metacarpus.tif',239,5,94,281.7101773,49.6664477,40.5940394,1.8,51.4699878,40.6078897,-0.8395642,18.6698412,18.0561311,9267.365461,12637.9623914,26.0140652,699.9263761,496.3815905,1173.3001681,29.1248057,57.632087,0.094489,184.5807473),(1695,'cephalophus_BayDuiker_metacarpus.tif',239,5,95,283.0516227,49.6767579,40.6026263,1.8,51.4615637,40.5791489,-0.8445894,17.754248,18.0354711,9303.9775038,12701.6619105,26.3734792,704.2600562,524.0423321,1190.3651009,29.1167779,57.6613601,0.0585649,183.8950871),(1696,'cephalophus_BayDuiker_metacarpus.tif',239,5,96,284.1498722,49.6871642,40.6166161,1.8,51.4605071,40.5862265,-0.8526549,17.6343412,18.005839,9335.985108,12762.1799267,26.854724,708.7800775,529.4206909,1195.3879946,29.1233216,57.6845241,0.0650547,183.8950871),(1697,'cephalophus_BayDuiker_femur.tif',239,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1698,'cephalophus_BayDuiker_femur.tif',239,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1699,'cephalophus_BayDuiker_femur.tif',239,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1700,'cephalophus_BayDuiker_femur.tif',239,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1701,'cephalophus_BayDuiker_femur.tif',239,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1702,'cephalophus_BayDuiker_femur.tif',239,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1703,'cephalophus_BayDuiker_femur.tif',239,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1704,'cephalophus_BayDuiker_femur.tif',239,7,8,1.2486969,70.543159,37.9122957,1.8,70.5734738,37.9553595,-1.3872419,1.0868909,2.562237,0.2834173,1.7700588,0.2011826,0.6908255,0.2607596,0.7978511,2.3231467,5.2800483,1.2827409,12.7389618),(1705,'cephalophus_BayDuiker_femur.tif',239,7,9,14.1375124,70.5494564,37.3553356,1.8,70.5341399,37.1305555,-1.3836573,2.2574682,5.6545225,16.2860788,109.6486445,2.2746926,19.3913183,7.2143114,22.214425,4.649262,11.2812074,1.3016288,27.4172636),(1706,'cephalophus_BayDuiker_femur.tif',239,7,10,16.6891321,70.4603654,37.4808513,1.8,70.5162726,37.1298709,-1.3581711,2.7063757,17.0197135,35.8878315,177.1608536,2.6576545,10.4091561,13.2604764,12.4856578,5.6104997,12.7789202,1.3187003,31.5234192),(1707,'cephalophus_BayDuiker_femur.tif',239,7,11,32.7034345,59.165401,34.696606,1.8,60.0718976,34.8357514,0.2301764,6.759279,15.9502095,256.1687516,4690.2639311,0.2837136,294.0565716,37.8988279,308.8999971,8.0625005,8.7885318,0.1932115,27.2242441),(1708,'cephalophus_BayDuiker_femur.tif',239,7,12,56.9267223,54.9209488,33.5970346,1.8,56.9032067,34.0632161,0.2356683,7.1149247,19.0421907,552.4816025,7019.6019155,0.517264,368.6341562,77.6510825,391.5594259,11.4375007,13.0578648,0.2763273,40.2095263),(1709,'cephalophus_BayDuiker_femur.tif',239,7,13,74.7787593,53.7187038,33.2467271,1.8,55.4666172,33.7460711,0.2433082,7.4519957,20.3627333,927.9871822,8244.1821448,0.7233588,404.8661843,124.5286786,445.6448444,13.6875009,16.510651,2.8773326,49.4824976),(1710,'cephalophus_BayDuiker_femur.tif',239,7,14,86.7279867,53.3830523,33.0315422,1.8,55.1559531,33.5925172,0.2500974,7.9464167,20.8596235,1278.9898352,9176.9190055,0.8854264,439.9369439,160.9517699,492.0368183,15.1226606,20.2256811,2.9551058,58.3161291),(1711,'cephalophus_BayDuiker_femur.tif',239,7,15,100.4612448,53.8324171,32.9028105,1.8,55.2043141,33.4138129,0.2401642,9.3687045,20.4753653,1569.7872367,10415.594316,0.9473225,508.6890595,167.55649,583.915041,16.3666623,35.1541271,2.9483812,104.0785102),(1712,'cephalophus_BayDuiker_femur.tif',239,7,16,104.3068383,53.6878456,32.7583816,1.8,55.1525411,33.2151075,0.2320001,12.8386025,20.6934181,1766.2018028,10813.7885697,0.919035,522.5714059,137.5696309,594.0679365,17.0184104,35.4295648,2.9120171,103.4116947),(1713,'cephalophus_BayDuiker_femur.tif',239,7,17,99.7450693,53.8014581,32.6346621,1.8,55.2596612,32.973522,0.235719,19.1946907,20.6547083,1823.5382906,10688.8363132,0.9067149,517.5011986,95.0022234,495.8032213,17.2419859,35.5291496,2.9234961,108.9346658),(1714,'cephalophus_BayDuiker_femur.tif',239,7,18,91.2074368,54.3911203,32.6985942,1.8,55.2862272,32.8538832,0.2432372,10.6908549,19.7930997,1733.8767323,10339.4389837,0.8817736,522.3759353,162.1831691,577.8804883,17.3217762,35.2360367,2.8501359,111.8059863),(1715,'cephalophus_BayDuiker_femur.tif',239,7,19,82.0869669,55.1240141,32.8564241,1.8,55.4948515,32.8525329,0.2436089,12.7977653,18.5863743,1510.2001813,9312.0824127,0.7959781,501.0166192,118.004991,566.6103969,17.2399895,34.6103894,2.7701404,106.8133454),(1716,'cephalophus_BayDuiker_femur.tif',239,7,20,71.8809891,56.3553572,33.1354762,1.8,55.6783135,32.9268611,0.2382123,10.2808686,17.4856941,1223.797291,7626.3081457,0.6670535,436.1455764,119.0363718,436.3069696,16.9948917,33.6550769,2.6355764,106.5936754),(1717,'cephalophus_BayDuiker_femur.tif',239,7,21,63.8995712,58.0961624,33.5044612,1.8,56.4995108,33.0429662,0.2232118,9.012029,17.5281805,1017.3198891,5977.2741638,0.5218629,341.0093921,112.8846664,392.5073825,16.3432842,32.1057842,2.8937811,122.889618),(1718,'cephalophus_BayDuiker_femur.tif',239,7,22,61.2448479,58.9737094,33.7769196,1.8,57.46649,33.3868789,0.2163716,8.9438072,17.2839084,946.2589612,5052.3097617,0.4704686,292.3129219,105.8004656,318.3085756,15.8480251,30.3778953,2.892123,145.9888618),(1719,'cephalophus_BayDuiker_femur.tif',239,7,23,60.0486084,59.5129061,33.9573968,1.8,58.7706176,33.780871,0.2244519,8.8409757,22.4008883,915.8789045,4419.1358211,0.4957844,197.2750257,103.5947772,223.1183272,15.3247585,27.8018958,2.9309704,118.646977),(1720,'cephalophus_BayDuiker_femur.tif',239,7,24,57.5680044,59.2705267,33.8857144,1.8,59.4629944,33.999873,0.2261474,8.8712104,22.4286908,891.7122065,3827.0883855,0.4823882,170.6336062,100.5175361,200.4841779,14.9726686,25.5640297,2.9197415,123.7682977),(1721,'cephalophus_BayDuiker_femur.tif',239,7,25,54.8957455,58.8302952,33.8952204,1.8,59.9078269,34.1348236,0.2511267,8.5374078,11.9425277,872.7496872,3200.9738288,0.5649686,268.0315169,102.2265435,336.7054403,14.8103631,23.9016555,2.9441971,79.6911305),(1722,'cephalophus_BayDuiker_femur.tif',239,7,26,55.6903408,58.8090294,34.1388634,1.8,59.9606856,34.3536385,0.3003639,7.979432,15.669075,929.8480392,2881.2918778,0.8125016,183.8839797,116.5306052,243.0928199,14.7936479,22.491406,2.6369233,76.8009653),(1723,'cephalophus_BayDuiker_femur.tif',239,7,27,56.7390945,58.6454601,34.425253,1.8,59.8652291,34.6711308,0.3343242,8.3814677,11.6330371,994.0201694,2621.21864,1.0181815,225.3253914,118.5973867,297.422076,14.8851311,21.7055054,2.5967287,72.0734893),(1724,'cephalophus_BayDuiker_femur.tif',239,7,28,57.9656003,58.4820676,34.6786246,1.8,59.5508562,34.9717012,0.362196,11.4590944,20.996331,1118.9145278,2346.2905343,1.212918,111.7476445,97.6442369,151.0909201,0.375,0.6760409,0.9827937,1.4356603),(1725,'cephalophus_BayDuiker_femur.tif',239,7,29,61.4147271,58.2589766,34.9737298,1.8,58.9341341,35.3397039,0.3822415,12.1659347,20.1998252,1272.6376203,2158.5560828,1.4241038,106.8601369,104.6066458,153.9201093,0.1875,0.2651651,2.3561945,0.5303301),(1726,'cephalophus_BayDuiker_femur.tif',239,7,30,62.9566378,57.9421897,35.112744,1.8,58.3738037,35.6378301,0.4247504,12.6131347,17.4909655,1402.5255896,1968.7764158,1.7818924,112.5596194,111.1956405,186.5029835,15.406937,19.5036067,2.4788631,57.7701876),(1727,'cephalophus_BayDuiker_femur.tif',239,7,31,64.5113753,57.627442,35.1201291,1.8,57.7045796,35.7165063,0.4948699,12.77695,18.3241932,1544.5054111,1886.4864617,2.4250503,102.9505876,120.882168,165.8173562,0.5625,0.9375001,0.9272952,2.1213205),(1728,'cephalophus_BayDuiker_femur.tif',239,7,32,66.5569792,57.3361639,35.330342,1.8,57.2582817,36.1714554,1.1785256,11.7206862,9.8630163,1739.5388303,1824.6687788,9.4716809,185.0010916,148.4161252,301.6791522,0.5625,0.8385255,1.1071487,1.9659904),(1729,'cephalophus_BayDuiker_femur.tif',239,7,33,65.2957113,57.2880813,35.290687,1.8,56.9069632,36.2613081,-1.5218714,14.5526532,11.5598513,1613.7712075,1901.1588414,10.8565902,164.4622226,110.8918896,189.125161,0.5625,1.0933035,0.5404195,2.4963205),(1730,'cephalophus_BayDuiker_femur.tif',239,7,34,64.2359952,57.0405821,35.0634342,1.8,56.4170454,36.0298574,-1.5504389,20.9980716,9.5529915,1488.5923207,1898.3151565,10.701563,198.7142098,70.8918586,160.3355129,1.1810876,2.4011717,0.6747409,6.337311),(1731,'cephalophus_BayDuiker_femur.tif',239,7,35,62.5552919,56.924917,34.5918043,1.8,56.2856923,35.6446238,1.4880772,13.2746609,9.5219803,1401.3436276,1763.6919541,10.3547058,185.2232312,105.5653047,212.7918496,14.944854,18.8733455,1.205049,57.5505176),(1732,'cephalophus_BayDuiker_femur.tif',239,7,36,61.2312967,56.9724186,34.3121104,1.8,56.5510298,35.2303863,1.4371006,13.166414,12.6668878,1279.7517386,1672.1640548,10.0238868,132.0106472,97.1982,204.1652862,0.1875,0.2651651,2.3561945,0.5303301),(1733,'cephalophus_BayDuiker_femur.tif',239,7,37,60.8066624,56.9717605,34.0028226,1.8,56.7054587,34.76973,1.3712021,17.1088794,9.255712,1200.0038055,1613.2639124,9.7360421,174.2992782,70.1392402,154.5122831,14.3195849,17.2051057,1.2145767,53.179197),(1734,'cephalophus_BayDuiker_femur.tif',239,7,38,59.9312717,56.8900898,33.6063672,1.8,56.6817679,34.1640085,1.3425506,21.3084635,9.9076777,1125.9275654,1532.5613395,9.4771546,154.6842145,52.8394534,121.1957546,14.0543434,16.8395471,2.2298864,51.7435368),(1735,'cephalophus_BayDuiker_femur.tif',239,7,39,60.9984771,56.7664054,33.3366446,1.8,56.542588,33.8102456,1.3127777,19.2000641,13.34189,1094.2917765,1513.1166988,9.5044845,113.4109713,56.9941732,127.2523279,13.7813029,16.5903079,2.1713375,50.6185367),(1736,'cephalophus_BayDuiker_femur.tif',239,7,40,59.8351992,56.5702785,32.9627956,1.8,56.4566626,33.1825248,1.2971771,20.840749,9.418848,1037.9543733,1452.7534948,9.2443625,154.2389791,49.804082,114.155643,13.6471294,16.4968047,2.1209621,49.6033716),(1737,'cephalophus_BayDuiker_femur.tif',239,7,41,57.0686897,56.4425114,32.4752941,1.8,56.3473442,32.557667,1.2682051,20.7848273,10.0658304,970.8540911,1350.0723742,8.6668234,134.1242916,46.7097503,105.1674263,0.375,2.6516506,1.7126934,5.5606605),(1738,'cephalophus_BayDuiker_femur.tif',239,7,42,56.2090447,56.3687021,32.0783759,1.8,56.3506538,32.142054,1.2057753,7.6882055,8.6594194,930.1636011,1295.6861841,8.1744175,149.6273734,120.9857888,253.9815585,13.4486131,16.0791509,2.1232153,48.3685365),(1739,'cephalophus_BayDuiker_femur.tif',239,7,43,56.752326,56.2748961,31.7867414,1.8,56.2630983,31.8726277,1.185314,17.5283799,8.4232063,916.378159,1275.3803147,8.1214412,151.4126882,52.2796837,118.8503261,13.4457564,15.9198442,2.1293956,47.7738666),(1740,'cephalophus_BayDuiker_femur.tif',239,7,44,56.7510156,56.1499186,31.4565522,1.8,56.1433702,31.5072079,1.1621574,7.6098937,8.3390328,897.8024553,1249.5796794,7.9650472,149.8470756,117.978317,257.1342761,13.5000008,15.6985777,2.0825352,47.1337015),(1741,'cephalophus_BayDuiker_femur.tif',239,7,45,57.074549,55.980168,31.1481656,1.8,55.9773424,31.2072516,1.1707641,7.6232598,8.4126172,900.963795,1218.3006084,8.0696774,144.8182626,118.1861596,249.2714699,13.5019662,15.5183872,2.0074235,46.8041966),(1742,'cephalophus_BayDuiker_femur.tif',239,7,46,57.6744426,55.8421239,30.8780004,1.8,55.8814237,30.9342189,1.1743395,7.7381597,8.4017077,910.8805363,1198.9955349,8.1790653,142.7085507,117.7128123,247.4720162,13.5000008,15.4035568,2.1216539,46.6488665),(1743,'cephalophus_BayDuiker_femur.tif',239,7,47,57.997731,55.7220373,30.603418,1.8,55.7177715,30.6930744,1.1747419,7.6423901,8.138971,925.6080015,1173.8196703,8.2276823,144.222123,121.1149903,251.76422,13.5000008,15.353263,2.0672191,46.2738665),(1744,'cephalophus_BayDuiker_femur.tif',239,7,48,58.0446486,55.6136154,30.3367864,1.8,55.6178053,30.3622686,1.1684812,8.5294662,15.3019489,934.9461528,1148.0658445,8.1909596,75.0274263,109.6136764,119.4929136,13.5000008,15.2106315,2.1006454,46.1640315),(1745,'cephalophus_BayDuiker_femur.tif',239,7,49,57.8259021,55.5618519,30.0306038,1.8,55.5827789,30.1369328,1.1951716,7.4810609,8.3802774,937.7158007,1106.6507755,8.3405992,132.0541939,125.3452969,241.6685893,13.6560006,15.1167342,2.0899424,46.3193616),(1746,'cephalophus_BayDuiker_femur.tif',239,7,50,57.7617899,55.4692293,29.8065232,1.8,55.4812678,29.8983857,1.2345633,7.6724598,8.7060101,940.9562274,1077.6598942,8.5790118,123.7834423,122.6407509,226.9664583,13.5000008,14.954228,2.0961632,45.8988665),(1747,'cephalophus_BayDuiker_femur.tif',239,7,51,58.1128517,55.3731805,29.5923871,1.8,55.3758818,29.6058635,1.3102671,7.7111565,8.2289709,945.7575802,1062.8249556,9.0428089,129.1564843,122.647955,241.158271,13.6807338,14.7280036,2.1199492,45.9443616),(1748,'cephalophus_BayDuiker_femur.tif',239,7,52,58.3120066,55.272234,29.3864382,1.8,55.2773516,29.4294872,1.4023244,7.7393463,8.2846089,950.3517216,1049.8486238,9.4454249,126.7227736,122.7948307,240.3243502,0.1875,0.5929271,1.8925469,1.2803302),(1749,'cephalophus_BayDuiker_femur.tif',239,7,53,58.7493078,55.1873349,29.2099271,1.8,55.2124233,29.2904583,1.4974466,7.7456711,8.0762205,956.2657638,1041.1878804,9.7389654,128.9201906,123.45809,244.6693647,13.6807338,14.5152138,2.0691121,45.5693616),(1750,'cephalophus_BayDuiker_femur.tif',239,7,54,59.058001,55.1246626,29.0021353,1.8,55.1148549,29.0611534,-1.5585277,7.6835402,7.9439669,960.574313,1031.2794504,9.8415187,129.819203,125.0171522,237.681738,13.5000008,14.4094704,2.1335335,45.3041965),(1751,'cephalophus_BayDuiker_femur.tif',239,7,55,59.1838071,55.0577159,28.8110355,1.8,55.0517613,28.8098341,-1.4612722,7.3120063,7.9250329,963.0502146,1021.9417499,9.7461166,128.951105,131.7080674,218.9970483,13.5000008,14.3103173,2.1224513,45.4140315),(1752,'cephalophus_BayDuiker_femur.tif',239,7,56,59.294038,54.9925671,28.6223134,1.8,54.9856745,28.6455231,-1.3592324,7.4774989,7.8534608,962.7518649,1017.1507496,9.4465733,129.5162445,128.7531937,245.7243064,13.578493,14.2129461,2.1112158,45.3496917),(1753,'cephalophus_BayDuiker_femur.tif',239,7,57,58.5860123,54.9979763,28.3752906,1.8,55.0029864,28.3980842,-1.175987,7.3911634,7.7537487,947.8704276,999.9569434,8.3197808,128.9643224,128.243739,230.2944426,13.5014902,14.0937162,2.1477293,45.3041965),(1754,'cephalophus_BayDuiker_femur.tif',239,7,58,58.3463106,54.9306088,28.2079045,1.8,54.9496588,28.2510962,-1.040696,7.3764344,7.834277,936.9844755,996.9906922,7.2383314,127.2600761,127.0240373,240.6852167,13.4187801,14.0625009,0.6435011,45.1943616),(1755,'cephalophus_BayDuiker_femur.tif',239,7,59,57.928569,54.8673548,28.0569653,1.8,54.8796166,28.0948641,-0.9799456,6.7046769,7.7652695,927.3420649,993.5940856,6.6586531,127.9535874,138.3127146,241.0755431,13.4178281,14.1024442,0.6248862,45.3041965),(1756,'cephalophus_BayDuiker_femur.tif',239,7,60,57.6979973,54.7973942,27.9362835,1.8,54.7883606,27.9644303,-0.9609617,7.4117556,7.7239077,926.0415326,996.002669,6.4619657,128.9506179,124.9422656,242.4877513,13.4187801,14.1161486,0.6913369,45.1488664),(1757,'cephalophus_BayDuiker_femur.tif',239,7,61,57.5782742,54.7385319,27.8310926,1.8,54.7110733,27.8866543,-0.9144283,7.4269308,7.7593375,923.1775698,999.1766424,6.0227137,128.7708696,124.3013559,235.8371486,13.4187801,14.1509726,0.5585993,45.1943616),(1758,'cephalophus_BayDuiker_femur.tif',239,7,62,57.2795846,54.7193326,27.7270994,1.8,54.7448157,27.8369336,-0.9262415,7.4235072,7.7261792,923.0198937,998.6058195,6.1001626,129.2496327,124.337442,235.257783,13.4183041,14.7017228,1.673003,47.8915073),(1759,'cephalophus_BayDuiker_femur.tif',239,7,63,57.2401989,54.7128951,27.6269048,1.8,54.71474,27.6971439,-0.8348423,7.3946315,7.7205057,925.4038648,1005.3913889,5.2409465,130.2235157,125.1453657,241.0156055,13.4723636,14.6117738,1.7253969,48.7968374),(1760,'cephalophus_BayDuiker_femur.tif',239,7,64,56.8293928,54.7102194,27.5014922,1.8,54.6957994,27.5241009,-0.7135882,7.6869282,7.7939756,920.490064,1007.6958311,4.0579654,129.2916324,119.7474514,239.5603723,13.4723636,14.2906502,0.6644954,45.4595266),(1761,'cephalophus_BayDuiker_femur.tif',239,7,65,55.8464452,54.7241224,27.3078142,1.8,54.727178,27.3490124,-0.6666672,7.2938517,7.8463304,901.0572765,997.9223808,3.5591103,127.1833234,123.5365508,239.5206432,13.4872475,14.32505,0.6461189,45.6148567),(1762,'cephalophus_BayDuiker_femur.tif',239,7,66,55.0618109,54.6945768,27.1767879,1.8,54.7020259,27.2447554,-0.6368178,7.8491683,7.5213515,887.0528864,992.5767258,3.2449455,131.9678686,113.0123411,237.2654101,13.3125008,14.3740498,0.5337082,45.0390315),(1763,'cephalophus_BayDuiker_femur.tif',239,7,67,54.3573221,54.6572741,27.0420343,1.8,54.6634826,27.0691571,-0.6515113,7.8132456,7.9336297,874.5820927,991.0228826,3.3312652,124.9141836,111.9358256,233.409856,13.4730959,14.4387184,0.6564874,45.1488664),(1764,'cephalophus_BayDuiker_femur.tif',239,7,68,54.3836893,54.6302055,26.9120438,1.8,54.6529786,26.9294036,-0.6677099,7.6806248,8.0075503,875.4847205,995.3804855,3.4750762,124.3052434,113.9861335,231.9724261,13.3125008,14.4751952,0.6383198,44.9935363),(1765,'cephalophus_BayDuiker_femur.tif',239,7,69,54.1003832,54.6019508,26.8164662,1.8,54.5865259,26.8324684,-0.6860883,7.0587887,8.0625505,876.5216279,994.4559905,3.6187909,123.3426055,124.1745098,230.6072579,13.4730959,14.5248987,0.6848212,45.2587014),(1766,'cephalophus_BayDuiker_femur.tif',239,7,70,53.6195309,54.6027906,26.7480715,1.8,54.569056,26.7716069,-0.7270638,7.790823,7.8124211,875.7355684,989.6703384,3.9481656,126.6790821,112.4060402,233.5075541,13.5000008,14.5248987,0.6848212,45.4140315),(1767,'cephalophus_BayDuiker_femur.tif',239,7,71,52.6991721,54.5845004,26.6822645,1.8,54.5312126,26.7450997,-0.7096503,7.628261,7.668949,866.1338804,978.8594874,3.7288313,127.6393275,113.5427693,232.8791428,13.4684034,14.5164248,0.6202495,45.3041965),(1768,'cephalophus_BayDuiker_femur.tif',239,7,72,52.2855428,54.5665168,26.6368421,1.8,54.4668735,26.6722445,-0.669419,7.1972829,7.2298978,861.92611,976.8463516,3.3554949,135.1120555,119.7571538,232.2925916,0.4796163,2.1378291,1.3045443,4.5909905),(1769,'cephalophus_BayDuiker_femur.tif',239,7,73,52.3716223,54.5545202,26.5865854,1.8,54.4462597,26.6359339,-0.654122,7.3948136,8.008305,863.4633036,982.9465734,3.2315635,122.740902,116.7660678,229.1489298,0.6166604,3.5027893,1.2998495,7.681981),(1770,'cephalophus_BayDuiker_femur.tif',239,7,74,52.3284014,54.5040409,26.5483992,1.8,54.4658932,26.58774,-0.6619061,7.2889754,8.0240566,863.4504071,984.1229967,3.2945929,122.6465668,118.4597778,230.2031925,13.3820399,14.510369,0.5736667,45.5238665),(1771,'cephalophus_BayDuiker_femur.tif',239,7,75,52.1633055,54.5031443,26.5032058,1.8,54.4508046,26.5294843,-0.6534318,8.2438201,7.9984394,863.5838376,987.254799,3.2129154,123.4309286,104.7552992,208.6656858,13.4155376,14.5864887,0.7672183,45.6337014),(1772,'cephalophus_BayDuiker_femur.tif',239,7,76,52.2477764,54.5244447,26.4523664,1.8,54.452135,26.4571595,-0.6506438,7.6088496,8.0289941,867.3127111,994.095691,3.1946995,123.8132302,113.9873641,229.6524524,0.375,1.0097185,1.1902899,2.1856603),(1773,'cephalophus_BayDuiker_femur.tif',239,7,77,52.6929079,54.54139,26.3971613,1.8,54.4087836,26.4245459,-0.6330152,7.5556643,8.0109541,876.3420724,1005.141854,3.0734464,125.470929,115.9847816,227.3327605,0.3703832,1.5461647,1.3258177,3.3106604),(1774,'cephalophus_BayDuiker_femur.tif',239,7,78,53.2746586,54.5537915,26.3707173,1.8,54.4029523,26.4155027,-0.6212431,7.5270345,7.8804224,885.9374407,1020.4929907,3.0080478,129.4972458,117.7007287,233.5354055,0.375,1.1858542,1.2490458,2.5606603),(1775,'cephalophus_BayDuiker_femur.tif',239,7,79,53.9321339,54.5603847,26.3361156,1.8,54.395465,26.3997682,-0.6073904,7.8951343,7.6975646,900.9968673,1029.0104655,2.9278748,133.680004,114.1205248,234.7938921,0.50092,2.0194369,1.1902899,4.3713206),(1776,'cephalophus_BayDuiker_femur.tif',239,7,80,54.3174145,54.5565089,26.3191005,1.8,54.4313469,26.3633901,-0.5957276,8.5525886,7.6956011,912.8546609,1030.625444,2.8502674,133.9239683,106.7343124,215.9383935,13.5014902,14.6262028,0.6306813,46.2550218),(1777,'cephalophus_BayDuiker_femur.tif',239,7,81,54.3244564,54.5566275,26.2576863,1.8,54.4295268,26.3042222,-0.6214596,7.5592905,7.9708224,915.0494777,1027.3987164,3.0691782,128.894946,121.0496514,234.6351344,13.5120804,14.6057575,1.0612041,46.0996917),(1778,'cephalophus_BayDuiker_femur.tif',239,7,82,54.4246943,54.5448082,26.2541384,1.8,54.411347,26.3012131,-0.616248,7.5285487,8.0413305,919.9170604,1028.3169309,3.0301659,127.8789541,122.1904908,235.9761293,13.5810631,14.6981354,1.0500679,46.2550218),(1779,'cephalophus_BayDuiker_femur.tif',239,7,83,54.700852,54.5153182,26.2509959,1.8,54.4223609,26.2941673,-0.6418015,7.5669796,8.2836651,921.8381775,1034.7901774,3.267183,124.9193634,121.823795,231.0083782,13.5856283,14.7697176,1.0673969,46.3648568),(1780,'cephalophus_BayDuiker_femur.tif',239,7,84,54.667933,54.4861562,26.2813371,1.8,54.4572056,26.3608454,-0.6904736,7.6985231,8.0791602,918.7748351,1034.3128611,3.6959586,128.0223228,119.3442986,237.6908577,13.5856283,14.6981354,1.0500679,45.9898567),(1781,'cephalophus_BayDuiker_femur.tif',239,7,85,55.108068,54.4422371,26.2976352,1.8,54.3932095,26.3526658,-0.7343282,7.4509265,8.2003149,923.3934436,1040.5676661,4.1240929,126.8936223,123.9300168,237.5896511,13.6692904,14.7065046,1.2329181,46.8951869),(1782,'cephalophus_BayDuiker_femur.tif',239,7,86,55.6426454,54.4229062,26.3323896,1.8,54.4213695,26.3923418,-0.8137778,7.3842654,8.2349634,931.6476463,1050.8363861,4.8999319,127.6066864,126.1665984,237.9457746,13.6875009,14.6550182,1.2854669,46.3648568),(1783,'cephalophus_BayDuiker_femur.tif',239,7,87,55.520568,54.3940172,26.3978183,1.8,54.4119503,26.4908865,-0.8549428,7.572339,8.316371,932.7268046,1050.6526998,5.2681676,126.3354772,123.1755219,238.0635304,13.6875009,14.6885647,1.3258177,46.3648568),(1784,'cephalophus_BayDuiker_femur.tif',239,7,88,56.0238245,54.3833886,26.4551252,1.8,54.3964997,26.4993897,-0.9054152,7.4807287,8.2905279,939.4749692,1067.7244608,5.7785578,128.7884773,125.5860232,239.393602,13.6875009,14.717258,0.9757267,46.3193616),(1785,'cephalophus_BayDuiker_femur.tif',239,7,89,55.7471021,54.4221998,26.4858483,1.8,54.4324211,26.5496595,-0.9903097,7.4730905,7.4844148,942.2137374,1058.7095667,6.4966146,141.4552228,126.0808683,242.8214716,13.6875009,14.717258,0.9757267,46.3193616),(1786,'cephalophus_BayDuiker_femur.tif',239,7,90,56.0492755,54.4409984,26.5712129,1.8,54.4708203,26.6320883,-1.0295039,7.5927092,8.3119201,946.0420793,1064.1122801,6.8615853,128.022439,124.5987511,241.8199309,13.6875009,14.7982536,1.1808785,46.8041966),(1787,'cephalophus_BayDuiker_femur.tif',239,7,91,56.6424574,54.4296664,26.6527087,1.8,54.4916158,26.7408232,-1.0488612,7.7329465,7.5817803,959.6350654,1069.6184574,7.0938954,141.0774802,124.0969481,246.1066616,13.6875009,14.8504271,1.141034,46.8685365),(1788,'cephalophus_BayDuiker_femur.tif',239,7,92,57.192216,54.4080105,26.7745676,1.8,54.4343434,26.824442,-1.0511529,7.7582318,7.6538608,972.3416865,1084.2146432,7.1816034,141.6559135,125.3303216,255.9798681,13.6875009,14.954228,1.0454295,46.8685365),(1789,'cephalophus_BayDuiker_femur.tif',239,7,93,57.80565,54.4378165,26.9257575,1.8,54.4933189,26.9920519,-1.069341,7.9141683,7.7748703,995.9889595,1096.093705,7.4080387,140.9790335,125.848848,255.9482892,13.6844409,14.9859318,1.017502,47.0427112),(1790,'cephalophus_BayDuiker_femur.tif',239,7,94,57.3252025,54.4774438,27.1036877,1.8,54.5274681,27.1528962,-1.114721,7.9043591,8.4101006,1002.3777132,1091.2294776,7.7009069,129.7522495,126.8132809,244.40684,13.6783996,15.0853053,1.006927,47.1525462),(1791,'cephalophus_BayDuiker_femur.tif',239,7,95,57.1953907,54.4774665,27.3124396,1.8,54.4771171,27.5342262,-1.3014601,7.78385,7.8095081,1020.6171105,1090.7452099,8.857614,139.6688756,131.1198335,248.5962351,13.6807338,15.1504186,0.9347208,47.5275462),(1792,'cephalophus_BayDuiker_femur.tif',239,7,96,57.8036578,54.4769714,27.5427573,1.8,54.5050845,27.8308667,-1.3364832,8.0275815,8.2768595,1061.1523488,1109.8070854,9.1146235,134.0855289,132.1882988,253.6030666,13.7793985,15.4911779,2.4763032,48.3873812),(1793,'cephalophus_BayDuiker_femur.tif',239,7,97,58.9862077,54.5517636,27.7519999,1.8,54.5894271,28.0856467,-1.2351566,8.5566911,8.1712396,1112.8533913,1153.9474863,8.7644976,141.2206147,130.0565118,260.7348449,14.02706,15.7153647,0.946386,49.2927114),(1794,'cephalophus_BayDuiker_femur.tif',239,7,98,59.9379407,54.5874132,28.0437367,1.8,54.6680764,28.3999853,-1.0809503,8.6632825,8.1678527,1160.2677696,1200.9559413,7.7783378,147.0344757,133.9293474,272.3201343,14.1891299,16.0507019,0.9179497,49.9328765),(1795,'cephalophus_BayDuiker_femur.tif',239,7,99,60.1402916,54.5953319,28.2802708,1.8,54.749466,28.7328242,-0.9588799,8.8072676,8.5404689,1177.8881516,1255.2804745,6.7158853,146.9802752,133.7404747,274.1309453,14.2963423,16.4626719,0.9227394,50.6828765),(1796,'cephalophus_BayDuiker_femur.tif',239,7,100,60.1709521,54.5699839,28.5807033,1.8,54.849687,29.1011292,-0.9019273,8.8509983,9.1353828,1212.7889339,1323.7126155,6.1723076,144.8995232,137.0228405,277.5918146,14.5941629,17.2876638,0.9316336,52.1828766),(1797,'cephalophus_BayDuiker_femur.tif',239,7,101,61.0837576,54.4934147,28.9962572,1.8,54.6383087,29.6041685,-0.8732388,8.7341681,10.5679718,1254.1233072,1510.885587,5.9799933,142.9683592,143.5881805,261.1776149,15.4937489,19.0937256,0.9528299,55.4746923),(1798,'cephalophus_BayDuiker_femur.tif',239,7,102,62.3919858,54.3637571,29.3958632,1.8,54.3754751,29.8551905,-0.8775118,8.5132176,10.4443884,1275.5652476,1708.6900485,6.1517823,163.5988614,149.8335076,285.5143516,0.1875,0.9560662,1.7681919,2.0303302),(1799,'cephalophus_BayDuiker_femur.tif',239,7,103,62.2135092,54.3805867,29.5665752,1.8,54.448912,30.0095519,-0.9125869,8.4739688,10.2937509,1271.5415156,1768.750289,6.4890922,171.8275785,150.0526547,295.1892784,15.5000203,19.3888068,0.9156903,56.4710127),(1800,'cephalophus_BayDuiker_femur.tif',239,7,104,61.1946277,54.5350056,29.6172507,1.8,54.6545489,30.0080544,-0.9313325,8.5102514,10.0360951,1280.1392917,1730.2856307,6.5669096,172.4062609,150.4232046,298.72387,15.5298507,19.1259203,0.9174916,56.5165078),(1801,'cephalophus_BayDuiker_femur.tif',239,7,105,59.2734662,54.5798101,29.5552089,1.8,54.7594054,29.8775595,-0.9352476,8.8927307,9.6958815,1227.9890457,1678.6380519,6.3977437,173.1289775,138.0890852,298.1212241,15.6450415,18.9773726,0.9114863,56.2701875),(1802,'cephalophus_BayDuiker_femur.tif',239,7,106,57.911172,54.6158169,29.5692958,1.8,54.8978609,29.7741429,-0.9414663,9.486035,9.6712,1200.0194164,1656.8618247,6.3079374,171.3191564,126.5037937,286.0287296,0.1875,0.5929271,1.8925469,1.2803302),(1803,'cephalophus_BayDuiker_femur.tif',239,7,107,57.7524575,54.5479218,29.5677532,1.8,54.803594,29.4611408,-0.9737802,9.3472722,10.0120973,1204.4661071,1655.1046143,6.5833638,165.3104801,128.8574973,282.9279313,15.7737356,19.3552331,0.9505468,60.4218382),(1804,'cephalophus_BayDuiker_femur.tif',239,7,108,58.026868,54.5781482,29.651258,1.8,54.8686167,29.5036807,-0.9918338,9.4971875,10.0119677,1238.2983673,1689.7690246,6.7758023,168.7749173,130.3857976,289.9692674,0.1875,0.2651651,2.3561945,0.5303301),(1805,'cephalophus_BayDuiker_femur.tif',239,7,109,57.9397551,54.6161876,29.6352238,1.8,54.8683694,29.3964947,-1.0431875,9.760596,9.9515213,1286.6172449,1717.5474171,7.2088566,172.5914419,131.8174881,301.7043343,0.1875,0.4192628,2.0344439,0.9053301),(1806,'cephalophus_BayDuiker_femur.tif',239,7,110,57.0925107,54.6205533,29.7688586,1.8,54.8584655,29.4038902,-1.1303795,9.9964701,10.2449073,1303.1504006,1809.5918699,7.7860312,176.6333091,130.361056,302.5770654,16.2381381,20.7727674,1.0303768,60.7324983),(1807,'cephalophus_BayDuiker_femur.tif',239,7,111,55.4089735,54.689408,29.9605123,1.8,54.9485076,29.5501876,-1.202428,10.2101974,10.621561,1304.2941363,1876.2467469,8.0373721,176.6451041,127.7442629,295.2904,16.500001,21.6089188,1.033353,67.5091492),(1808,'cephalophus_BayDuiker_femur.tif',239,7,112,55.4500424,54.6263494,30.2701431,1.8,54.8476035,29.8850273,-1.2450449,10.299881,11.1552373,1333.0286546,2015.9080265,8.2952032,180.7140429,129.4217533,293.1266165,16.8469737,22.4788978,1.017502,67.7476638),(1809,'cephalophus_BayDuiker_femur.tif',239,7,113,56.8779403,54.6930751,30.552614,1.8,54.9333704,30.1275147,-1.3172661,9.8919782,12.0370041,1420.3171081,2271.9475412,8.8832713,188.7469271,143.5827165,296.8217009,17.0311966,24.002931,1.0652153,69.5960135),(1810,'cephalophus_BayDuiker_femur.tif',239,7,114,60.8828876,54.7433936,30.8932689,1.8,55.0470636,30.5290259,-1.3796564,10.8283442,12.6950726,1575.3686016,2775.9929104,9.78092,218.6669591,145.4856412,320.1114118,17.7952289,25.5144736,1.0644116,75.7136546),(1811,'cephalophus_BayDuiker_femur.tif',239,7,115,68.3877571,54.8160084,31.6667663,1.8,55.1112152,31.2455012,-1.437438,11.0059154,13.8924122,1899.5792848,3474.9941473,11.1964519,250.1361254,172.5962095,351.2470764,19.0489299,27.2810906,1.0610276,82.8464608),(1812,'cephalophus_BayDuiker_femur.tif',239,7,116,82.6265835,55.3433477,33.0374099,1.8,55.7310662,32.8202484,1.5008661,10.9323247,16.9406261,2735.5985079,4973.0621847,13.7038631,293.5583457,250.2302658,400.5330396,21.1210845,36.2277972,2.0205559,108.7448796),(1813,'cephalophus_BayDuiker_femur.tif',239,7,117,115.6606146,55.7001895,36.1156268,1.8,55.9531866,35.2264839,1.4248289,11.8221115,20.2270258,4469.5254806,9535.4925459,18.8689578,471.4233648,378.0649068,686.1938607,22.4499765,37.925093,1.9990605,119.4990063),(1814,'cephalophus_BayDuiker_femur.tif',239,7,118,137.9421479,55.4215947,37.5214146,1.8,55.926484,36.233883,1.5108142,13.7756498,21.3048657,5789.5067746,12421.5049517,22.9077412,583.036059,420.2710463,839.458107,24.8248686,38.6713945,2.0062518,130.472803),(1815,'cephalophus_BayDuiker_femur.tif',239,7,119,147.1618969,55.439734,38.3147231,1.8,55.8120306,37.1259933,1.5091244,14.3839933,21.7419328,6697.4159571,13980.4156199,24.4338145,643.0162273,465.6158974,933.5312675,26.2094258,39.0761001,2.0280063,142.4162696),(1816,'cephalophus_BayDuiker_femur.tif',239,7,120,154.9875194,55.0571349,38.6274623,1.8,55.6108374,37.6027375,1.5308103,15.3181588,21.3876763,8044.7769075,15090.1359811,25.7899743,705.5528521,525.1791028,1058.3352345,27.3807399,39.0756502,2.0387358,159.6175423),(1817,'cephalophus_BayDuiker_femur.tif',239,7,121,159.6414511,55.0366792,38.5367582,1.8,55.5263247,37.8057021,1.5164431,15.4026927,20.6301803,8744.7761731,15565.9420513,26.5283816,754.5228331,567.7433368,1150.0396152,0.2651651,0.5303301,0.7853982,1.0606602),(1818,'cephalophus_BayDuiker_femur.tif',239,7,122,160.9228433,55.0285159,38.3362961,1.8,55.4061772,37.9118758,1.5188542,15.2724284,19.4918879,8967.9110819,15065.0589926,26.7481778,772.8886528,587.1961433,1195.7954855,29.085174,37.9547452,2.0874915,139.5527548),(1819,'cephalophus_BayDuiker_femur.tif',239,7,123,160.6591714,55.1271272,38.14962,1.8,55.3935703,37.9881823,1.4852445,14.6140195,18.3470204,8660.7527288,13840.1130393,26.5810259,754.3520811,592.6331725,1180.1685311,29.0601637,36.9151288,2.1094737,127.893298),(1820,'cephalophus_BayDuiker_femur.tif',239,7,124,158.7114509,55.0339345,38.0767241,1.8,55.3849001,38.1071884,1.4453614,14.873924,16.9846085,8143.3667725,12024.1618027,26.0378944,707.9445947,547.4928314,1085.994679,28.8387671,35.5365701,2.1265992,124.8289579),(1821,'cephalophus_BayDuiker_femur.tif',239,7,125,155.7300727,54.9327357,38.0325402,1.8,55.3499545,38.240765,1.3940834,15.1889154,15.6062581,7442.7289388,9830.7604323,25.1529044,629.9242489,490.0105604,946.7350595,28.3113415,34.1651571,1.0604995,120.3556081),(1822,'cephalophus_BayDuiker_femur.tif',239,7,126,135.6995518,55.0041835,37.9349802,1.8,55.2868499,38.2186105,1.0397741,16.5670845,17.1088704,6534.8513542,7410.9271196,16.816427,433.1628544,394.4478795,788.5961091,27.3964612,32.4461714,1.0373143,128.6023754),(1823,'cephalophus_BayDuiker_femur.tif',239,7,127,107.3723252,55.6844347,38.3462069,1.8,55.5495472,38.4599798,0.1915745,15.3505629,13.9540493,4471.0654191,5641.4300959,0.6487793,404.2862365,291.2639387,624.9955902,26.3370157,30.1706105,1.006927,118.745773),(1824,'cephalophus_BayDuiker_femur.tif',239,7,128,68.8348275,57.6217875,39.0344997,1.8,57.1149209,39.3041464,-0.0210298,13.8879552,15.0018259,2252.0715483,3069.4065996,0.005073,204.6022006,162.160053,329.156762,5.9120064,15.0981175,1.3197936,37.0008951),(1825,'cephalophus_BayDuiker_femur.tif',239,7,129,21.9208728,61.0696872,39.0756108,1.8,61.1424314,39.4972584,1.1607615,16.2771286,12.0017946,56.2762137,794.1006668,3.0728868,66.1651608,3.4573797,51.4531142,6.3423363,11.5719563,2.2759077,30.9099045),(1826,'cephalophus_BayDuiker_femur.tif',239,7,130,0.605934,61.9964205,41.3026623,1.8,61.8221724,40.881218,1.1962097,0.9965294,11.1688282,0.1172667,11.8927632,0.0874692,1.0648175,0.1176752,1.0745111,0,0,0,0),(1827,'cephalophus_BayDuiker_femur.tif',239,7,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1828,'cephalophus_BayDuiker_femur.tif',239,7,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1829,'cephalophus_BayDuiker_femur.tif',239,7,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1830,'cephalophus_BayDuiker_femur.tif',239,7,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1831,'cephalophus_BayDuiker_femur.tif',239,7,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1832,'cephalophus_BayDuiker_femur.tif',239,7,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1833,'cephalophus_BayDuiker_femur.tif',239,7,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1834,'cephalophus_BayDuiker_femur.tif',239,7,138,13.7627254,68.9832764,38.2833266,1.8,68.9684963,38.3047351,1.412418,5.0956533,5.2723121,72.9065112,76.6918813,2.2367304,14.5461573,14.3075887,28.1872426,10.3125006,10.7938791,1.8705724,34.375895),(1835,'cephalophus_BayDuiker_femur.tif',239,7,139,38.3968834,68.9963983,38.3455623,1.8,68.9988043,38.3468071,-0.8545372,7.5218608,7.6410721,475.0514868,485.7223003,3.6407854,63.5672968,63.1561128,125.1288252,15.1875009,15.5636304,1.0262446,50.2513424),(1836,'cephalophus_BayDuiker_femur.tif',239,7,140,60.4743613,68.7341935,38.3642141,1.8,68.6196545,38.3566918,-1.5048737,8.9592407,9.3113697,1073.8266742,1203.7160477,10.0353221,129.2737891,119.856884,240.205837,18.5625012,18.8714826,1.0849302,61.6001391),(1837,'cephalophus_BayDuiker_femur.tif',239,7,141,81.4122865,68.3291291,38.3875071,1.8,68.194728,38.362461,-1.552466,9.8403048,10.4811669,1699.2383454,2146.6630452,13.5641558,204.8114552,172.6814747,351.0890483,21.0000013,21.3865114,1.126754,69.5472851),(1838,'cephalophus_BayDuiker_femur.tif',239,7,142,98.6089789,67.9922647,38.3832399,1.8,67.832688,38.3704452,-1.5571351,10.4459764,11.5859865,2344.5736726,3199.0912929,16.4317629,276.1172992,224.447537,454.0201044,23.0625014,23.3661428,0.9449499,76.5247612),(1839,'cephalophus_BayDuiker_femur.tif',239,7,143,112.5307705,67.6851487,38.3879236,1.8,67.521416,38.3708156,-1.5614323,10.8892616,12.3477282,2942.9091282,4258.5131062,18.7534838,344.8823167,270.2579153,547.9174869,24.5625015,24.9931256,1.0870172,81.6005868),(1840,'cephalophus_BayDuiker_femur.tif',239,7,144,124.361681,67.4171155,38.412027,1.8,67.2661082,38.3875082,-1.565683,11.3610445,12.958548,3501.4208918,5281.5401069,20.7264049,407.5719065,308.1953337,631.3295381,26.0625016,26.2720906,1.1518474,86.1272375),(1841,'cephalophus_BayDuiker_femur.tif',239,7,145,266.7707933,56.2143444,39.2234198,1.8,55.711279,38.7738314,-0.1037296,16.0498098,21.8533789,13004.0984241,39673.0239858,0.476688,1815.4183029,810.2338035,2137.8482377,28.5000018,29.0600824,1.8251644,94.7145486),(1842,'cephalophus_BayDuiker_femur.tif',239,7,146,463.0736978,50.9766446,38.8750881,1.8,55.661443,38.779284,-0.0470601,16.2526476,26.0713797,25055.3406206,64587.4550298,0.1707983,2477.3316816,1541.6159411,3166.3714294,28.8750018,29.2259535,2.5571488,95.5100438),(1843,'cephalophus_BayDuiker_femur.tif',239,7,147,472.3203041,51.0469374,38.8564169,1.8,55.7578477,38.7423925,-0.0468761,16.3322864,26.0070445,25865.763378,66006.9495974,0.1728496,2538.0411667,1583.7196772,3243.9601178,28.973087,57.266138,0.052411,184.224592),(1844,'cephalophus_BayDuiker_femur.tif',239,7,148,475.3675204,51.0850471,38.8908358,1.8,55.8358001,38.7601495,-0.0425431,16.3638087,25.9295792,26161.4918295,66282.1373413,0.1433091,2556.2365224,1598.7410002,3256.7723667,29.1065328,57.4191043,0.0391956,182.020087),(1845,'cephalophus_BayDuiker_femur.tif',239,7,149,474.5524492,50.9995654,38.9706314,1.8,55.7190028,38.8998667,-0.028323,16.3440355,25.8557605,26012.2669637,65545.2800296,0.0634298,2535.0358558,1591.5449407,3203.4044007,29.111441,57.3498755,0.0752674,181.1147569),(1846,'cephalophus_BayDuiker_femur.tif',239,7,150,473.565773,50.9454311,39.0191222,1.8,55.6532215,38.9726528,-0.0200005,16.2110777,25.8085849,25871.1073985,65092.0830558,0.0315682,2522.10973,1595.8906524,3174.8107655,29.111441,57.3642795,0.0785267,180.6299219),(1847,'cephalophus_BayDuiker_femur.tif',239,7,151,473.7124598,50.9330613,39.0418314,1.8,55.6664465,38.9990091,-0.0178885,16.3240335,25.7950207,25823.1760674,65030.6948302,0.0252616,2521.0561209,1581.911483,3168.6390101,29.111441,57.3792926,0.0817844,180.8950869),(1848,'cephalophus_BayDuiker_femur.tif',239,7,152,475.1649351,50.9654897,39.0387606,1.8,55.7131484,38.9859946,-0.0214234,15.9530933,25.8066303,25952.2077094,65362.4811405,0.0363413,2532.7786093,1626.7821664,3188.0799633,29.1163491,57.3360811,0.0720064,181.3799219),(1849,'cephalophus_BayDuiker_tibia.tif',239,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1850,'cephalophus_BayDuiker_tibia.tif',239,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1851,'cephalophus_BayDuiker_tibia.tif',239,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1852,'cephalophus_BayDuiker_tibia.tif',239,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1853,'cephalophus_BayDuiker_tibia.tif',239,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1854,'cephalophus_BayDuiker_tibia.tif',239,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1855,'cephalophus_BayDuiker_tibia.tif',239,8,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1856,'cephalophus_BayDuiker_tibia.tif',239,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1857,'cephalophus_BayDuiker_tibia.tif',239,8,9,1.2272516,59.0002826,33.9527107,1.8,58.9879845,33.9110598,1.2370264,0.8219933,2.1883696,0.1453076,1.048372,0.1825892,0.4790653,0.1767747,0.545411,1.8288572,4.3892627,1.9195673,10.0684665),(1858,'cephalophus_BayDuiker_tibia.tif',239,8,10,13.0136522,59.8193015,33.5418474,1.8,60.2408957,33.4725209,0.4872136,5.2882964,10.1326174,24.6416214,108.2884929,0.4753865,10.6871195,4.6596521,11.8088541,0.4752838,1.5116734,1.0516502,3.2463205),(1859,'cephalophus_BayDuiker_tibia.tif',239,8,11,69.2889717,58.3549115,32.9380505,1.8,58.5980011,32.9851091,0.1772273,7.1397214,11.4341345,439.6472962,2163.7852661,0.3589403,189.2390945,61.5776545,221.8670327,12.5151307,21.7014558,2.9679215,73.4792659),(1860,'cephalophus_BayDuiker_tibia.tif',239,8,12,89.8112861,59.3117798,32.8822958,1.8,59.4503954,32.2924351,0.0022106,12.0746023,11.9426006,1392.1639112,3364.6734988,0.0000732,281.7370867,115.2968746,356.8085103,20.0722909,24.4556374,0.9487643,91.4760338),(1861,'cephalophus_BayDuiker_tibia.tif',239,8,13,109.1943567,61.4976999,32.8841881,1.8,61.2655064,31.9793695,-0.0350549,13.6751801,14.1672039,2795.8726481,5529.9046238,0.0223546,390.3314068,204.4486888,516.7890628,21.6204714,28.328019,0.1662368,94.7678495),(1862,'cephalophus_BayDuiker_tibia.tif',239,8,14,132.2271366,63.3336542,33.5001542,1.8,62.8698402,32.4571995,0.0417747,14.848638,15.2344243,4272.7153513,8658.9815033,0.0384363,568.382588,287.7513313,790.4456337,23.7829703,30.4432124,0.1297025,103.7035102),(1863,'cephalophus_BayDuiker_tibia.tif',239,8,15,135.3632556,63.9164589,33.635406,1.8,63.5617421,32.6479946,0.1370877,15.8503216,15.2097588,5736.5016977,8255.0164814,0.421332,542.744734,361.9170531,813.2091044,25.3717694,30.0029314,2.6108192,101.684219),(1864,'cephalophus_BayDuiker_tibia.tif',239,8,16,139.5593569,64.7981829,33.6015333,1.8,64.2805499,32.5678482,0.5327603,15.002048,16.4408804,6422.3689144,8116.2130235,6.0004854,493.6604874,428.0994787,835.4256207,26.5058149,30.9579497,2.0019351,102.7604907),(1865,'cephalophus_BayDuiker_tibia.tif',239,8,17,126.1791742,64.9462656,33.081263,1.8,64.5010567,32.3937657,0.944476,13.5112045,19.0792515,5659.2743627,7773.1255862,13.8041634,407.4125013,418.8578727,703.2153349,25.09454,32.4244936,1.9749288,104.7531315),(1866,'cephalophus_BayDuiker_tibia.tif',239,8,18,110.815891,65.0135162,32.1116409,1.8,64.5808748,31.9425459,1.021503,13.5576052,21.6278058,4445.412467,7435.3832213,13.4350904,343.7881447,327.8906852,493.7792242,24.0428524,32.9728247,1.9555265,110.8896172),(1867,'cephalophus_BayDuiker_tibia.tif',239,8,19,99.1656409,64.9155823,31.519429,1.8,64.527248,31.3559528,1.075273,13.3736227,19.418215,3805.3923916,6954.6104747,12.7908356,358.1488034,284.5446205,554.047896,23.6192876,33.2250867,1.928246,108.7949472),(1868,'cephalophus_BayDuiker_tibia.tif',239,8,20,91.3409667,64.7256175,31.170479,1.8,64.2668197,30.918851,1.1259327,12.9289988,17.9519165,3391.2168349,6505.236539,12.4042859,362.3700305,262.2953949,550.1240144,23.2154058,33.2092111,1.8746916,106.0978015),(1869,'cephalophus_BayDuiker_tibia.tif',239,8,21,81.1070023,64.0117878,30.4111476,1.8,63.6813856,30.2085721,1.2553062,12.0848216,17.4094681,2921.8562246,4991.9533706,12.2164019,286.737845,241.7790126,430.2992473,22.3419604,31.9328539,1.9687491,103.116646),(1870,'cephalophus_BayDuiker_tibia.tif',239,8,22,72.5103287,63.0939715,29.8255006,1.8,62.6976839,29.350088,1.5162553,12.9811892,14.8731416,2312.1143254,3693.4958238,12.0491408,248.3332648,178.1126744,339.1884885,19.4333561,27.0416363,1.9100889,85.2752082),(1871,'cephalophus_BayDuiker_tibia.tif',239,8,23,68.7248097,62.5170969,29.5301869,1.8,62.0331929,29.1842451,-1.4809914,10.4656863,14.630882,1910.0830842,3225.1566021,11.3620064,220.4348722,182.5091092,345.7497013,18.3230401,25.886548,1.0390723,79.6424021),(1872,'cephalophus_BayDuiker_tibia.tif',239,8,24,65.6540601,62.0312023,29.636019,1.8,61.6901568,29.3628082,-1.4472813,10.1867237,14.4783633,1707.2560595,2827.8066633,10.7762546,195.3125918,167.5961876,309.0453405,17.6409367,25.1871914,1.0571903,75.9112466),(1873,'cephalophus_BayDuiker_tibia.tif',239,8,25,61.5043223,61.5864432,29.8229001,1.8,61.3876511,29.511523,-1.4561288,13.6069042,17.2963371,1526.3078046,2338.8832801,10.1165271,135.2241965,112.1715701,175.6340639,17.0070863,24.2803466,1.0449453,71.7141008),(1874,'cephalophus_BayDuiker_tibia.tif',239,8,26,59.6924755,61.1944608,29.9392365,1.8,61.0820687,29.4804874,-1.4519328,10.0335974,13.4974454,1416.2564003,2105.737308,9.8088455,156.0100629,141.1514084,255.3081402,16.5376038,23.5840434,1.06447,69.1534404),(1875,'cephalophus_BayDuiker_tibia.tif',239,8,27,59.2863781,60.8599078,29.9258032,1.8,60.9193927,29.4843907,-1.4450713,9.3464817,13.1262442,1330.7010426,1974.9544829,9.7256965,150.4584601,142.3745412,246.4239924,16.1252962,23.0746933,1.0708011,66.7669549),(1876,'cephalophus_BayDuiker_tibia.tif',239,8,28,59.6984734,60.5203987,29.9573296,1.8,60.5363478,29.5843866,-1.4399673,9.2199039,12.7950224,1272.7249234,1892.5990519,9.7804128,147.9168221,138.0410188,242.0237627,15.8012868,22.5826621,1.0588592,65.3767898),(1877,'cephalophus_BayDuiker_tibia.tif',239,8,29,61.1067051,60.1838182,30.0464196,1.8,60.2114717,29.7018069,-1.4260034,13.8602732,12.7016182,1244.3738474,1829.8186991,9.972422,144.0618571,89.7798934,206.5882999,15.5617595,22.2367425,1.0694308,64.0321198),(1878,'cephalophus_BayDuiker_tibia.tif',239,8,30,62.4139638,59.9079226,30.1093159,1.8,59.9369964,29.9127657,-1.4212084,8.8930724,12.4171533,1217.3570653,1788.5875414,10.1712901,144.0416736,136.8882447,237.7050932,15.3057964,21.8933865,1.0803352,62.3956343),(1879,'cephalophus_BayDuiker_tibia.tif',239,8,31,62.909358,59.63642,30.1816857,1.8,59.6980864,30.0377882,-1.4321262,9.4992042,12.2360359,1188.3897678,1724.2045786,10.2845638,140.912023,125.1041392,234.0872623,15.1074757,21.636559,1.1226514,61.2706342),(1880,'cephalophus_BayDuiker_tibia.tif',239,8,32,64.1992729,59.3593658,30.2594201,1.8,59.4273274,30.1259565,-1.4383875,9.2984053,12.0999325,1170.2650046,1686.5957415,10.5133811,139.3888554,125.8565277,232.1250959,15.0080404,21.3066354,1.1347008,60.5206342),(1881,'cephalophus_BayDuiker_tibia.tif',239,8,33,64.2232964,59.1654754,30.285801,1.8,59.2161182,30.2294724,-1.4627371,10.2070319,11.8416217,1136.7185389,1633.2328339,10.5793813,137.9230714,111.3662174,229.9978286,14.8977855,20.9799024,1.1471274,59.6607991),(1882,'cephalophus_BayDuiker_tibia.tif',239,8,34,64.9882112,58.9136682,30.363091,1.8,58.9721289,30.2985354,-1.4740986,9.1141526,11.5439088,1118.2680247,1610.3305117,10.7304056,139.496122,122.6957765,230.5521267,14.709009,20.7981382,1.1232764,58.6644787),(1883,'cephalophus_BayDuiker_tibia.tif',239,8,35,66.6175971,58.6476912,30.4252358,1.8,58.5762236,30.339722,-1.478283,9.1389259,11.5673765,1111.6099582,1624.206848,11.0081769,140.4127241,121.63464,231.7521595,2.1945694,4.3892627,1.2220253,14.0647871),(1884,'cephalophus_BayDuiker_tibia.tif',239,8,36,68.080598,58.4280707,30.5195775,1.8,58.3408668,30.3771129,-1.4962562,8.8721526,11.4466164,1108.8767917,1637.608036,11.2838378,143.0648132,124.983963,233.1151403,14.6017647,20.6565113,1.1599451,57.9599738),(1885,'cephalophus_BayDuiker_tibia.tif',239,8,37,69.653915,58.2262612,30.5847732,1.8,58.2089629,30.3781135,-1.5011787,9.180656,11.4726929,1097.4787672,1680.3824679,11.5528124,146.4680074,119.5425212,236.6546722,14.5208297,20.5823435,1.1682969,57.5849738),(1886,'cephalophus_BayDuiker_tibia.tif',239,8,38,71.0930096,58.0522533,30.6148173,1.8,58.0242637,30.3927168,-1.4861737,8.9316182,11.9110922,1088.2922235,1749.2071252,11.764188,146.8553085,121.8471498,234.0418021,14.4833428,21.0752015,1.1588953,58.270634),(1887,'cephalophus_BayDuiker_tibia.tif',239,8,39,73.0968841,57.90793,30.6086847,1.8,57.9387096,30.3546055,-1.4705126,9.1951034,12.1399546,1085.578268,1860.6064843,12.0607037,153.2630517,118.0604741,238.7947838,14.46176,21.4193632,1.1659045,59.9714593),(1888,'cephalophus_BayDuiker_tibia.tif',239,8,40,74.4986812,57.7509724,30.678229,1.8,57.8121776,30.3967731,-1.4810139,8.4071698,11.9959613,1083.3660792,1915.2627157,12.3166279,159.6589608,128.8621627,245.4688649,14.4375009,21.346199,1.1739782,59.5509642),(1889,'cephalophus_BayDuiker_tibia.tif',239,8,41,74.0710533,57.6048179,30.829139,1.8,57.6828911,30.5490596,-1.4998502,8.7947281,11.7106179,1063.83848,1878.198677,12.2831421,160.3842505,120.9632036,246.4350143,0.2651651,0.5303301,0.7853982,1.0606602),(1890,'cephalophus_BayDuiker_tibia.tif',239,8,42,74.3789049,57.3914542,31.0140727,1.8,57.4541196,30.7239859,-1.5175118,12.5551673,14.8632043,1056.2618974,1857.0239896,12.3613209,124.9410256,84.1296554,149.734943,14.3610711,20.5207606,1.2259285,59.240304),(1891,'cephalophus_BayDuiker_tibia.tif',239,8,43,74.5664795,57.1962987,31.2615853,1.8,57.2386574,30.9960388,-1.5337936,12.9635604,14.978248,1046.7114136,1824.6436003,12.4107382,121.8195609,80.7425879,144.9510581,0.375,0.8385255,1.1071487,1.8106603),(1892,'cephalophus_BayDuiker_tibia.tif',239,8,44,74.7358794,57.0126983,31.5268357,1.8,57.0541831,31.3156947,-1.5489997,12.881794,13.1648037,1038.8427008,1794.7810795,12.4500631,136.3317764,80.6442564,161.6927684,0.1875,0.2651651,2.3561945,0.5303301),(1893,'cephalophus_BayDuiker_tibia.tif',239,8,45,74.1469162,56.8480469,31.8609371,1.8,56.8695319,31.7130475,1.5607519,8.2007185,11.4280313,1027.8334706,1687.6953676,12.3565726,147.6803243,125.3345639,232.5453381,0.415116,1.4279575,1.1659045,3.0909905),(1894,'cephalophus_BayDuiker_tibia.tif',239,8,46,73.022502,56.6975478,32.2199868,1.8,56.7080607,32.1190472,1.5275974,13.4769435,11.1802618,1010.9749541,1579.9571851,12.1477193,141.3166535,75.0151511,151.5436633,13.858127,19.2404615,1.3045443,55.3538184),(1895,'cephalophus_BayDuiker_tibia.tif',239,8,47,71.4720366,56.5468692,32.6180493,1.8,56.5794663,32.5409164,1.4753369,10.6908431,10.5708599,990.1091424,1451.6002803,11.8037873,137.3209269,92.6128214,181.1184338,13.6711944,18.5700754,1.2841751,53.6341483),(1896,'cephalophus_BayDuiker_tibia.tif',239,8,48,70.3393021,56.4153974,33.0071205,1.8,56.4559091,32.9780395,1.4124582,7.9923637,10.2764156,973.8456181,1346.8365511,11.4317527,131.0609268,121.8470105,217.1007695,13.4976008,17.3850027,1.2865708,51.448488),(1897,'cephalophus_BayDuiker_tibia.tif',239,8,49,69.2051187,56.3428238,33.3687418,1.8,56.3331044,33.5359463,1.3601505,7.9502301,10.2419557,948.9799027,1269.9622905,11.0299205,123.9960729,119.3650859,192.238386,13.2945403,16.7411368,1.2986504,49.9029928),(1898,'cephalophus_BayDuiker_tibia.tif',239,8,50,67.5777996,56.2344132,33.7395088,1.8,56.2280402,33.9102914,1.2836363,7.7361559,10.0640215,921.0521123,1193.5104595,10.359462,118.5918038,119.0581108,187.3733744,13.1238727,16.1837602,1.3961241,47.9370024),(1899,'cephalophus_BayDuiker_tibia.tif',239,8,51,66.2337654,56.1124868,34.0856515,1.8,56.1372734,34.2661612,1.2077671,13.6579358,10.7953316,903.5558996,1122.4175941,9.6469318,103.9724983,66.1561098,144.7088929,12.9196124,15.4457225,1.3876855,46.7021674),(1900,'cephalophus_BayDuiker_tibia.tif',239,8,52,65.4459031,56.0240046,34.4249597,1.8,56.0357259,34.6063166,1.1340812,12.400274,10.8107136,885.4120722,1076.5094519,8.956277,99.5780201,71.4026216,158.0863374,12.7260341,14.8929785,1.380808,45.4218372),(1901,'cephalophus_BayDuiker_tibia.tif',239,8,53,65.2311197,55.9527064,34.7540298,1.8,55.9486955,34.8874399,1.0376431,12.9168016,7.8367422,873.7956723,1042.4726206,8.0634409,133.0237222,67.6479903,147.4364107,12.6957965,14.3728268,1.3068326,44.626342),(1902,'cephalophus_BayDuiker_tibia.tif',239,8,54,64.9526715,55.8715237,35.0827945,1.8,55.8472022,35.3034085,0.9729511,13.7663802,7.4412375,867.2265999,1015.459629,7.3957875,136.463811,62.9959793,136.756218,12.5953403,14.0625009,2.4980915,44.361177),(1903,'cephalophus_BayDuiker_tibia.tif',239,8,55,64.5494718,55.8027363,35.388341,1.8,55.7008963,35.6330261,0.8922343,12.4985014,9.2465182,858.8969118,990.3303712,6.5197666,107.1030578,68.7199914,145.4983971,0.375,0.6760409,2.1587989,1.4356603),(1904,'cephalophus_BayDuiker_tibia.tif',239,8,56,63.8469327,55.7356996,35.6901192,1.8,55.6860377,35.8507351,0.76721,11.4590696,7.623089,838.5566627,964.77106,5.1270771,126.5590701,73.1784249,150.122643,12.5953403,13.8407525,2.5197684,43.5201867),(1905,'cephalophus_BayDuiker_tibia.tif',239,8,57,62.5728381,55.6911207,35.9814271,1.8,55.6643887,36.1178577,0.648265,11.2802622,7.6939592,809.7575625,938.3277465,3.8021298,121.9564241,71.7853491,143.6368615,12.5953403,13.6990542,2.6105625,43.3648566),(1906,'cephalophus_BayDuiker_tibia.tif',239,8,58,62.0418295,55.623345,36.2644359,1.8,55.5975132,36.4048373,0.5755593,10.3597137,7.4309967,788.5438175,925.7640689,3.06349,124.5814123,76.1163714,150.4216468,12.7128383,13.6566442,2.9899872,43.2095265),(1907,'cephalophus_BayDuiker_tibia.tif',239,8,59,62.1317975,55.5815564,36.5560077,1.8,55.5349621,36.7108677,0.5019333,11.2266351,7.6111843,775.897525,921.9146839,2.3970204,121.1263118,69.1122065,127.33982,12.5625008,13.6166841,2.4733032,42.7890313),(1908,'cephalophus_BayDuiker_tibia.tif',239,8,60,62.4765206,55.577211,36.8361658,1.8,55.5362389,36.9260115,0.4309534,14.6399231,7.657827,758.5595149,924.4801305,1.8170708,120.7235586,51.8144467,108.5244501,0.375,1.5116734,1.6951513,3.3106604),(1909,'cephalophus_BayDuiker_tibia.tif',239,8,61,62.8457252,55.5589722,37.1196563,1.8,55.5183978,37.2060602,0.3771613,8.8311355,7.7365052,744.092798,925.6192948,1.4206506,119.6430782,84.2578848,158.9708177,0.375,0.5929271,1.8925469,1.4356603),(1910,'cephalophus_BayDuiker_tibia.tif',239,8,62,63.2783602,55.5361021,37.4014392,1.8,55.5310212,37.4580193,0.3512342,9.1402455,7.3525799,733.9177993,925.373005,1.2484309,125.8569122,80.2951956,146.6142255,12.1875008,13.6347451,2.5917395,42.1033711),(1911,'cephalophus_BayDuiker_tibia.tif',239,8,63,63.7178666,55.5133246,37.6756027,1.8,55.501504,37.7371439,0.316121,11.9503315,7.6419119,718.5999178,929.1245716,1.0263642,121.5827379,60.1322162,116.5787981,12.0000008,13.6153931,2.7457422,41.9025459),(1912,'cephalophus_BayDuiker_tibia.tif',239,8,64,63.7132963,55.4855658,37.9280531,1.8,55.4492249,37.9349211,0.2836587,9.1467023,8.5058469,703.9920125,924.4856011,0.8317475,108.6882489,76.9667567,148.067614,11.8125007,13.5934276,2.7149652,41.5275459),(1913,'cephalophus_BayDuiker_tibia.tif',239,8,65,63.3446137,55.5309227,38.1465688,1.8,55.5395807,38.1761332,0.2626893,7.8572909,8.122128,685.9881921,910.3047801,0.7119187,112.0771286,87.3059435,154.7959324,11.8125007,13.6153931,2.7457422,41.4177109),(1914,'cephalophus_BayDuiker_tibia.tif',239,8,66,62.9902387,55.541858,38.4158975,1.8,55.5512009,38.4615738,0.242029,7.307849,7.9886595,669.5432148,901.0604536,0.6030594,112.7924476,91.6197387,159.2327509,0.1875,0.4192628,2.0344439,0.9053301),(1915,'cephalophus_BayDuiker_tibia.tif',239,8,67,62.6783708,55.5800708,38.6766669,1.8,55.6028693,38.6571366,0.2297643,7.0956754,8.1068162,652.3593858,894.9974289,0.5418457,110.4006071,91.9376031,184.2045845,11.4375007,13.5169173,2.7275937,41.1070507),(1916,'cephalophus_BayDuiker_tibia.tif',239,8,68,62.755054,55.628928,38.9339642,1.8,55.5813441,38.9089396,0.215088,8.0595162,8.9461533,645.3034013,893.2261528,0.4764554,99.8447178,80.0672627,128.3979226,11.4375007,13.5169173,2.7275937,41.2623808),(1917,'cephalophus_BayDuiker_tibia.tif',239,8,69,62.6631364,55.6848341,39.1772422,1.8,55.6153692,39.1529419,0.2101213,7.1168169,7.5110584,633.0252969,887.9697986,0.4543601,118.2216601,88.9478125,190.1034082,11.2500007,13.4752385,2.7714218,40.8873808),(1918,'cephalophus_BayDuiker_tibia.tif',239,8,70,62.3739283,55.7406715,39.4130506,1.8,55.6495703,39.379396,0.2093463,7.5230771,7.6138497,622.4839414,877.1836711,0.4489816,115.208956,82.743262,175.8653465,11.2500007,13.4425871,2.7403639,40.8873808),(1919,'cephalophus_BayDuiker_tibia.tif',239,8,71,62.2722628,55.8182641,39.6553569,1.8,55.7199086,39.615949,0.1949919,7.1693333,7.5385634,612.5332493,872.0928586,0.3896414,115.6842242,85.4379649,164.1964392,11.0625007,13.4425871,2.7403639,40.4668856),(1920,'cephalophus_BayDuiker_tibia.tif',239,8,72,62.2180262,55.8939915,39.8869197,1.8,55.7703523,39.8768352,0.1700761,7.4412199,7.900458,603.7397143,868.299874,0.297071,109.9050052,81.134508,148.2794354,0.5625,1.9121324,1.7681919,4.5266507),(1921,'cephalophus_BayDuiker_tibia.tif',239,8,73,61.4909523,56.0196339,40.0927321,1.8,55.953316,40.11369,0.1537297,7.4578937,7.6827309,586.3426151,849.0227469,0.2402989,110.5105404,78.6204034,159.2419502,0.5603596,2.8681987,1.7681919,6.2463207),(1922,'cephalophus_BayDuiker_tibia.tif',239,8,74,61.3370105,56.0880122,40.3215615,1.8,56.040441,40.3372679,0.1439458,6.8093674,7.4516937,573.8645548,840.3321258,0.2103622,112.7706202,84.275752,171.4090178,0.375,2.0963139,1.7506498,4.5909905),(1923,'cephalophus_BayDuiker_tibia.tif',239,8,75,61.2360268,56.1572077,40.544978,1.8,56.1419708,40.5602794,0.1338019,6.7609012,7.8222463,563.1479253,832.3673143,0.1816299,106.4102662,83.2948013,169.3798999,10.8750007,13.4006771,2.8286914,40.0918856),(1924,'cephalophus_BayDuiker_tibia.tif',239,8,76,61.2483954,56.2411038,40.7746627,1.8,56.1971546,40.7718333,0.1197705,6.6702963,7.3822521,556.2341536,830.7611941,0.1457356,112.5349264,83.3897221,165.5455209,10.6875007,13.4190288,2.8728896,39.7812254),(1925,'cephalophus_BayDuiker_tibia.tif',239,8,77,61.2055368,56.3308224,40.9905222,1.8,56.2791532,40.9923651,0.1119499,7.3515463,11.7854914,548.4863594,828.3227003,0.1273127,70.2832552,74.6082983,107.6022539,10.8032207,13.4006771,2.8286914,39.9820506),(1926,'cephalophus_BayDuiker_tibia.tif',239,8,78,60.9673478,56.4318921,41.1978882,1.8,56.387735,41.1439069,0.1066355,6.9266983,7.2997505,541.7460129,817.9109483,0.1151072,112.0464258,78.2112909,160.2424783,10.8249343,13.3704732,2.8864103,39.8722157),(1927,'cephalophus_BayDuiker_tibia.tif',239,8,79,61.0805936,56.5395651,41.399111,1.8,56.451991,41.32875,0.098508,6.7981162,7.7208337,536.8701324,816.2780348,0.0984668,105.7240788,78.9733686,133.6752568,10.7762281,13.3849271,2.9441971,39.7623807),(1928,'cephalophus_BayDuiker_tibia.tif',239,8,80,61.1661937,56.6472948,41.5979951,1.8,56.5872681,41.5624808,0.086824,6.8413257,12.5346747,531.9073798,814.4010247,0.0766563,64.9718515,77.7491676,98.5077969,10.6875007,13.3704732,2.8864103,39.5615555),(1929,'cephalophus_BayDuiker_tibia.tif',239,8,81,61.1178912,56.786982,41.7391848,1.8,56.7042362,41.7473357,0.0698803,7.1017135,7.716711,519.7635104,813.8185226,0.0496615,105.4618382,73.188465,153.3052339,10.5000007,13.3849271,2.9441971,39.4517205),(1930,'cephalophus_BayDuiker_tibia.tif',239,8,82,61.28222,56.8719097,41.9174818,1.8,56.7684762,41.8683047,0.0551148,6.8296725,8.012069,513.0149806,815.105663,0.0309942,101.7347278,75.1156043,159.773119,0.8500915,1.7787813,1.8925469,4.4168157),(1931,'cephalophus_BayDuiker_tibia.tif',239,8,83,61.264546,56.9585056,42.109521,1.8,56.8334285,42.0885848,0.0432202,7.0179272,7.798514,507.300892,811.9478663,0.0190617,104.1157152,72.2864286,167.1737608,0.75,1.9121324,1.7681919,4.6819808),(1932,'cephalophus_BayDuiker_tibia.tif',239,8,84,60.8266056,57.064461,42.292941,1.8,56.9767108,42.3032585,0.0300923,6.3163576,8.461791,497.1494136,806.9333124,0.0091775,95.3620001,78.7082434,151.8632645,0.7362204,1.7787813,1.8925469,3.9963206),(1933,'cephalophus_BayDuiker_tibia.tif',239,8,85,60.3116837,57.1555692,42.4684913,1.8,57.0994732,42.4563272,0.0149436,6.8011749,8.4228356,490.6418935,794.6786954,0.0022445,94.3481189,72.1407555,151.3312571,10.5000007,13.3967413,3.0293898,39.2775457),(1934,'cephalophus_BayDuiker_tibia.tif',239,8,86,60.183129,57.2627089,42.6567797,1.8,57.2194932,42.6220443,-0.0000111,6.2817804,7.3877006,487.0254607,791.1524408,0.00000001631,107.0904857,77.5298456,168.9987022,10.5000007,13.3849271,2.9441971,39.1222156),(1935,'cephalophus_BayDuiker_tibia.tif',239,8,87,59.5740415,57.3694697,42.8308162,1.8,57.3305212,42.8124128,-0.0079424,6.2695614,7.133492,480.6218175,785.5507178,0.0006263,110.1214835,76.65956,168.7316635,10.5000007,13.4190288,3.0155046,39.2775457),(1936,'cephalophus_BayDuiker_tibia.tif',239,8,88,59.3075145,57.4531331,42.9924973,1.8,57.4225669,42.9553992,-0.0175993,6.2429033,7.3885176,472.845811,780.6931695,0.0030613,105.6630312,75.7413325,168.4197369,0.1875,0.2651651,2.3561945,0.5303301),(1937,'cephalophus_BayDuiker_tibia.tif',239,8,89,58.2239135,57.566894,43.107645,1.8,57.5497133,43.0790802,-0.0160103,6.9313334,7.5067088,460.8352095,764.7100347,0.0024872,101.8702142,66.4857949,163.2496064,0.375,0.6760409,2.1587989,1.4356603),(1938,'cephalophus_BayDuiker_tibia.tif',239,8,90,57.4771414,57.6439598,43.2840622,1.8,57.624981,43.2795663,-0.0158772,6.1566,7.4113373,450.7021743,754.8458319,0.0024147,101.8501523,73.2063434,161.0966617,0.1875,0.5929271,1.8925469,1.2803302),(1939,'cephalophus_BayDuiker_tibia.tif',239,8,91,56.9308132,57.7218044,43.4554357,1.8,57.6790632,43.4475027,-0.0221187,6.2933704,7.4916939,442.143175,744.6903627,0.0046414,99.4021347,70.2553878,157.487176,10.3125006,13.4190288,3.0155046,39.0123807),(1940,'cephalophus_BayDuiker_tibia.tif',239,8,92,56.8904794,57.8033088,43.6214399,1.8,57.7592373,43.6138396,-0.0290319,5.9071949,7.3591767,437.4695594,739.2735338,0.0079894,100.4560108,74.0570725,158.0702945,10.3125006,13.3849271,2.9441971,38.6373806),(1941,'cephalophus_BayDuiker_tibia.tif',239,8,93,56.8148935,57.8634091,43.7758947,1.8,57.8321386,43.7684624,-0.0327822,6.1134204,7.0872394,435.1483628,734.3585666,0.0101726,103.6170122,71.1791983,154.0011091,10.1250006,13.4190288,3.0155046,38.7472156),(1942,'cephalophus_BayDuiker_tibia.tif',239,8,94,56.8336754,57.9105421,43.9322708,1.8,57.8821265,43.9264692,-0.0300518,6.0368217,7.2917963,431.9497305,731.2743837,0.008552,100.2872751,71.5525075,147.2325198,0.3703832,1.3650207,1.849096,2.9356604),(1943,'cephalophus_BayDuiker_tibia.tif',239,8,95,56.9503942,57.9465186,44.0740269,1.8,57.9200848,44.0494741,-0.0311466,5.8798709,7.1593917,429.4880189,733.1519247,0.0092051,102.4042206,73.0437832,158.7165883,10.1250006,13.3494215,2.9579703,38.2623806),(1944,'cephalophus_BayDuiker_tibia.tif',239,8,96,56.9013565,57.997793,44.2107861,1.8,57.9772871,44.2081627,-0.0354477,5.9724659,7.208746,427.7237013,735.0974801,0.0119115,101.9730032,71.6159299,160.2899229,0.1875,0.4192628,2.0344439,0.9053301),(1945,'cephalophus_BayDuiker_tibia.tif',239,8,97,56.4455504,58.1147905,44.2774006,1.8,58.1017511,44.3203241,-0.0367031,5.897513,6.9766589,419.7562219,730.4314387,0.0126674,104.6964532,71.175124,162.408156,9.9375006,13.2860661,2.9857245,38.3267204),(1946,'cephalophus_BayDuiker_tibia.tif',239,8,98,56.1874715,58.1578897,44.3977936,1.8,58.1478867,44.4289128,-0.025175,5.96867,7.1471784,412.2595038,730.1564092,0.0059338,102.1600935,69.070581,159.178409,9.9375006,13.2807729,2.9137356,38.3267204),(1947,'cephalophus_BayDuiker_tibia.tif',239,8,99,55.8468181,58.1816444,44.5196275,1.8,58.1834834,44.5736752,-0.0209945,6.3127305,7.2756656,404.8871406,727.830992,0.004102,100.0363452,64.1381956,154.5919025,9.7500006,13.2807729,2.9137356,38.0160603),(1948,'cephalophus_BayDuiker_tibia.tif',239,8,100,55.726019,58.197895,44.6533194,1.8,58.1785248,44.6935746,-0.0219665,5.8657192,7.4259393,403.4594172,725.4325453,0.0044808,97.6889954,68.7826004,151.9950418,9.7500006,13.2396784,2.927532,38.1258952),(1949,'cephalophus_BayDuiker_tibia.tif',239,8,101,55.2920843,58.2170674,44.7900222,1.8,58.2242392,44.8209966,-0.0228204,5.8162837,7.2437144,401.8931174,721.21669,0.0047982,99.5644849,69.0979226,153.7637535,9.5625006,13.2011194,2.9414116,38.0804001),(1950,'cephalophus_BayDuiker_tibia.tif',239,8,102,54.7504969,58.2118602,44.9244919,1.8,58.2192527,44.9628593,-0.0278697,5.8514607,7.257308,399.0125255,722.8522268,0.0070858,99.6033559,68.1902432,153.0352167,9.5625006,13.1651181,2.9553698,38.0804001),(1951,'cephalophus_BayDuiker_tibia.tif',239,8,103,54.0937994,58.2050027,45.0464943,1.8,58.2027227,45.0683433,-0.0309301,5.9764921,7.2117125,396.747919,725.1713808,0.0086223,100.554671,66.384747,155.5523996,0.1875,0.4192628,2.0344439,0.9053301),(1952,'cephalophus_BayDuiker_tibia.tif',239,8,104,53.494609,58.1924776,45.1661893,1.8,58.1989681,45.2160531,-0.0333501,6.0899841,7.1954376,394.3666086,724.5747815,0.0099127,100.6991956,64.7565908,155.5056103,0.375,0.8385255,2.0344439,1.9659904),(1953,'cephalophus_BayDuiker_tibia.tif',239,8,105,52.5738347,58.2333903,45.2081409,1.8,58.2395058,45.2823489,-0.0275637,5.6568161,7.2662434,390.5154704,721.2422079,0.0066555,99.2592958,69.0344997,151.3039509,9.3750006,13.2396784,2.927532,38.1447399),(1954,'cephalophus_BayDuiker_tibia.tif',239,8,106,51.6602408,58.2001102,45.3079452,1.8,58.203363,45.3894316,-0.0300033,5.8594036,7.4420397,385.421205,721.5131846,0.0077484,96.9509997,65.7782317,148.4575256,9.5364478,13.2807729,2.9137356,38.190235),(1955,'cephalophus_BayDuiker_tibia.tif',239,8,107,51.3300703,58.1788666,45.4155531,1.8,58.1726843,45.4818632,-0.0216161,5.7086468,7.3516079,383.8747545,721.6804918,0.0039968,98.1663476,67.2444399,149.5811463,9.4988782,13.2807729,2.9137356,38.30007),(1956,'cephalophus_BayDuiker_tibia.tif',239,8,108,50.8461179,58.0962315,45.518287,1.8,58.110592,45.5575999,-0.0244247,5.6911239,7.6987365,382.6141286,718.3428176,0.0050545,93.306586,67.2299773,140.2123678,9.3750006,13.2396784,2.927532,38.409905),(1957,'cephalophus_BayDuiker_tibia.tif',239,8,109,50.3511711,57.9953839,45.6155164,1.8,58.0346779,45.676266,-0.0276158,6.1926773,7.1476142,381.6878415,718.6558633,0.0063983,100.544859,61.6353513,148.8812278,9.3902338,13.2807729,2.9137356,38.5197399),(1958,'cephalophus_BayDuiker_tibia.tif',239,8,110,50.5346548,57.9228453,45.7362923,1.8,57.9676657,45.7921697,-0.0382059,5.8596099,7.3642592,386.323218,729.2345192,0.0122882,99.0234725,65.9298526,150.5282486,0.1875,0.4192628,2.0344439,0.9053301),(1959,'cephalophus_BayDuiker_tibia.tif',239,8,111,51.5077053,57.8440327,45.8813854,1.8,57.8645,45.9096423,-0.0506672,5.650073,7.7079134,397.6759159,750.9612595,0.0220193,97.4273093,70.3842086,145.7235513,9.4683727,13.3849271,2.9441971,39.26974),(1960,'cephalophus_BayDuiker_tibia.tif',239,8,112,51.5355533,57.7471544,46.0214184,1.8,57.759723,46.0658447,-0.0521087,5.6525958,8.0150429,401.39475,773.3959147,0.0233015,96.4930479,71.0106939,143.0779754,9.419656,13.4700196,2.8594689,39.3340798),(1961,'cephalophus_BayDuiker_tibia.tif',239,8,113,51.066782,57.6640997,46.0786178,1.8,57.6322507,46.1331741,-0.0482515,5.8626185,8.1025699,408.6098889,799.5434943,0.0198003,98.6777651,69.6975067,146.7088662,9.5785867,13.7182882,2.7636243,40.4590799),(1962,'cephalophus_BayDuiker_tibia.tif',239,8,114,50.8683941,57.5414308,46.1507395,1.8,57.5349214,46.2086296,-0.0539996,6.376573,7.6235039,417.5890741,830.9972233,0.0246976,109.0046307,65.4880093,159.7239982,9.6030604,13.9154824,2.896614,41.099245),(1963,'cephalophus_BayDuiker_tibia.tif',239,8,115,50.9095696,57.4449157,46.1738296,1.8,57.4107381,46.2839718,-0.0561515,5.9777549,7.971742,432.9774888,875.5422234,0.0267248,109.8307279,72.4314555,164.0613859,9.6870121,14.1919055,2.8741819,41.8037499),(1964,'cephalophus_BayDuiker_tibia.tif',239,8,116,50.8400774,57.2671317,46.1981302,1.8,57.2154291,46.3296502,-0.0614879,6.4837382,7.9927111,457.4887475,929.1997756,0.0319954,116.2558944,70.5594108,173.3045797,9.7702358,14.6129767,0.5844439,43.0385849),(1965,'cephalophus_BayDuiker_tibia.tif',239,8,117,50.1357058,57.1485761,46.2080069,1.8,57.0617933,46.2978012,-0.0656475,6.2492867,8.2248413,485.9821586,984.8572559,0.0359591,119.7417947,77.7660203,159.9166862,10.1487215,15.0853053,0.5638694,45.0500704),(1966,'cephalophus_BayDuiker_tibia.tif',239,8,118,49.9173962,57.0786157,46.2078526,1.8,56.9249889,46.2839049,-0.0742066,6.5582101,8.4726326,525.2983908,1069.2703702,0.0457287,126.2028481,80.0978287,169.1608037,0.375,0.7730824,1.815775,1.8106603),(1967,'cephalophus_BayDuiker_tibia.tif',239,8,119,50.1509083,56.8772822,46.1964568,1.8,56.6815465,46.2800566,-0.0320362,6.5937445,8.8704354,568.8445113,1207.5812352,0.0085755,136.1355084,86.2703297,200.1027753,0.1875,0.2651651,2.3561945,0.5303301),(1968,'cephalophus_BayDuiker_tibia.tif',239,8,120,52.6099498,56.3816813,46.2514465,1.8,56.1697253,46.3793093,0.0348394,7.136049,8.963034,637.5574256,1462.1050919,0.0106385,163.1261356,89.3431962,225.2311334,11.6981822,18.2453987,2.7515446,56.6263428),(1969,'cephalophus_BayDuiker_tibia.tif',239,8,121,62.6027422,56.0856417,46.3755361,1.8,55.9665516,46.5259358,0.0594185,8.465504,9.8729699,779.4942132,1895.3429986,0.0367938,191.9729335,92.0788904,235.1701493,12.7924517,19.1543904,2.7392716,60.4218382),(1970,'cephalophus_BayDuiker_tibia.tif',239,8,122,86.4155754,56.0544214,46.4917744,1.8,56.0256532,46.6162387,0.1083106,8.4887387,10.5447548,1013.2506832,2473.1751688,0.1682998,234.5407948,119.3641034,327.3266727,13.7140366,20.0519845,2.6444847,62.4066732),(1971,'cephalophus_BayDuiker_tibia.tif',239,8,123,105.6430743,56.1238867,46.540422,1.8,56.1439335,46.6102651,0.1196207,9.5070178,10.4191689,1319.7946181,2988.5585414,0.2507436,286.8327174,138.823198,409.220678,14.6689533,20.4521176,2.5917395,63.9333238),(1972,'cephalophus_BayDuiker_tibia.tif',239,8,124,88.5708136,55.2848074,45.6768438,1.8,55.7373323,45.9437357,0.0100496,9.4850896,10.5561644,1277.8125507,1950.6882168,0.0014908,184.7913835,134.7180265,290.1744151,15.4680979,20.1839212,2.5278226,81.0436062),(1973,'cephalophus_BayDuiker_tibia.tif',239,8,125,62.759081,54.5133486,44.4428475,1.8,54.7442039,44.6741657,-1.3384848,9.2129298,10.3153351,759.6797278,902.6248115,9.9054255,87.5031983,82.4579961,155.1191532,14.3460316,17.365781,0.9078592,70.2784405),(1974,'cephalophus_BayDuiker_tibia.tif',239,8,126,40.4116137,54.1499594,42.5486072,1.8,54.2006381,43.1129258,0.0995633,11.2973697,7.3150258,330.7807223,509.1599768,0.0665454,69.6046731,29.2794456,73.5582838,7.5317436,13.8153286,0.136139,42.0845264),(1975,'cephalophus_BayDuiker_tibia.tif',239,8,127,26.0744777,53.9594409,41.835032,1.8,54.0191188,41.6837545,0.1267565,3.4353326,7.1052266,41.6095675,360.593665,0.0694509,50.7504809,12.1122386,55.943879,6.4545806,13.4190288,0.1260881,42.4783711),(1976,'cephalophus_BayDuiker_tibia.tif',239,8,128,20.0142745,53.8169429,41.9668092,1.8,53.815287,41.9665986,0.1741436,2.8803664,5.8856448,21.7071901,256.9651993,0.1001404,43.6596514,7.53626,46.1511218,3.1875002,5.3691832,1.359703,13.909457),(1977,'cephalophus_BayDuiker_tibia.tif',239,8,129,12.9228958,53.9858724,41.8988309,1.8,54.0140726,41.9407494,0.2182395,2.0174992,5.7806424,9.0056553,158.5272653,0.1009647,27.4238148,4.4637714,28.9718528,2.8125002,4.0950621,1.2924967,10.9737967),(1978,'cephalophus_BayDuiker_tibia.tif',239,8,130,1.2912466,52.0398552,41.094814,1.8,53.2490658,41.4815651,0.249223,1.2327594,6.3053979,0.3223217,15.233544,0.0130925,2.4159528,0.2614636,2.4667412,2.0583082,2.6648759,0.8850668,7.087311),(1979,'cephalophus_BayDuiker_tibia.tif',239,8,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1980,'cephalophus_BayDuiker_tibia.tif',239,8,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1981,'cephalophus_BayDuiker_tibia.tif',239,8,133,1.5010655,72.2669292,37.979864,1.8,72.261489,37.9827151,-1.2453566,2.3605778,2.4132512,1.9128509,2.0917056,0.2246033,0.8667584,0.8103317,1.5875632,4.6875003,5.2130399,0.9129077,16.2504474),(1982,'cephalophus_BayDuiker_tibia.tif',239,8,134,22.3385078,72.2102758,38.1078026,1.8,72.1959133,38.1351746,-0.9909487,6.1430274,6.1669901,170.1270809,175.0542771,2.6054497,28.3856914,27.6943387,55.5125737,12.1875008,12.605803,1.1737169,40.5578759),(1983,'cephalophus_BayDuiker_tibia.tif',239,8,135,46.0105988,72.0534626,38.1453042,1.8,71.9490809,38.1504962,-1.4163155,8.048734,8.2708797,648.9648016,698.2148568,7.4868822,84.418452,80.6294256,160.9132267,16.312501,16.8541548,1.0074801,54.3120028),(1984,'cephalophus_BayDuiker_tibia.tif',239,8,136,66.5821532,71.5771491,38.1712864,1.8,71.4594851,38.1614755,-1.5432616,8.9930437,9.7257194,1184.582012,1491.4187531,11.0886143,153.347911,131.7220345,264.1613162,19.3125012,19.832503,1.3028859,64.2251393),(1985,'cephalophus_BayDuiker_tibia.tif',239,8,137,85.9856571,71.1963373,38.1036868,1.8,71.0305102,38.0581567,-1.5608179,9.8893652,10.9404992,1785.5843914,2497.2191292,14.329516,228.254588,180.5560178,367.9981609,21.9375014,22.2011416,1.297137,72.5284406),(1986,'cephalophus_BayDuiker_tibia.tif',239,8,138,100.8536312,70.8567093,38.1030401,1.8,70.6749799,38.0784029,-1.5610171,10.4907686,11.8746535,2353.7736539,3509.5222392,16.8073311,295.5473389,224.3661772,461.8717532,23.8125015,24.0292805,1.1700029,78.5550914),(1987,'cephalophus_BayDuiker_tibia.tif',239,8,139,113.4474858,70.5471331,38.1194992,1.8,70.3730183,38.0907443,-1.5631083,10.9280107,12.6375018,2892.2280872,4525.8730171,18.9067967,358.1303562,264.6619003,545.3453045,25.1906807,25.5454574,0.9522533,83.4567422),(1988,'cephalophus_BayDuiker_tibia.tif',239,8,140,124.2197137,70.2895786,38.1299599,1.8,70.1346284,38.089895,-1.5680188,11.2303437,13.2018453,3388.7601122,5491.6266027,20.703126,415.9741686,301.7503471,621.8385018,26.4375017,26.6909411,1.1511455,87.2977327),(1989,'cephalophus_BayDuiker_tibia.tif',239,8,141,194.3261429,63.173145,38.793429,1.8,61.7218272,38.6086984,-0.1305044,16.2738524,21.2500403,9761.1038785,24606.5351394,0.5484833,1157.9523994,599.8029027,1403.4438406,28.3125018,29.1078294,1.8313987,94.7600437),(1990,'cephalophus_BayDuiker_tibia.tif',239,8,142,369.1474467,57.3534198,38.8572964,1.8,61.5495117,38.6718346,-0.0899638,16.2117338,22.8499024,19026.2126469,42863.1406988,0.4966067,1875.8566176,1173.607515,2441.5477357,28.9816951,56.9759442,0.0757623,183.0540968),(1991,'cephalophus_BayDuiker_tibia.tif',239,8,143,376.3540634,57.4010248,38.8422454,1.8,61.6436379,38.6611413,-0.0894295,16.1944415,22.8120219,19602.4025551,43642.784449,0.5003204,1913.1484522,1210.4401689,2490.3181264,29.0356278,57.2412693,0.0918461,181.8192618),(1992,'cephalophus_BayDuiker_tibia.tif',239,8,144,376.0421954,57.3655524,38.9108547,1.8,61.6515908,38.7034587,-0.0752008,16.2228168,22.6914247,19584.8017039,43414.502662,0.353762,1913.2559204,1207.2380494,2474.2148702,29.1248057,57.3949143,0.0850403,180.8495918),(1993,'cephalophus_BayDuiker_metatarsus.tif',239,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1994,'cephalophus_BayDuiker_metatarsus.tif',239,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1995,'cephalophus_BayDuiker_metatarsus.tif',239,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1996,'cephalophus_BayDuiker_metatarsus.tif',239,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1997,'cephalophus_BayDuiker_metatarsus.tif',239,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1998,'cephalophus_BayDuiker_metatarsus.tif',239,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(1999,'cephalophus_BayDuiker_metatarsus.tif',239,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2000,'cephalophus_BayDuiker_metatarsus.tif',239,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2001,'cephalophus_BayDuiker_metatarsus.tif',239,10,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2002,'cephalophus_BayDuiker_metatarsus.tif',239,10,10,1.5689917,51.7939501,43.3083078,1.8,51.9046299,43.3465936,-0.1141384,1.2022606,1.9710022,0.2415494,0.9292152,0.0033919,0.471443,0.2009127,0.5851264,2.2500001,4.0950621,0.2782997,10.1783015),(2003,'cephalophus_BayDuiker_metatarsus.tif',239,10,11,6.8864497,52.2241137,43.4460513,1.8,52.0463295,43.3683022,-0.0695394,2.1408622,4.495894,3.2199557,25.9106204,0.0055412,5.7631743,1.5040462,6.3075217,3.8363533,8.9628144,0.2754261,21.7922633),(2004,'cephalophus_BayDuiker_metatarsus.tif',239,10,12,24.4513347,52.8352412,42.3464825,1.8,53.3867256,41.8189652,-0.1561856,4.1979852,7.4420493,58.9357435,354.2244595,0.098605,47.5977039,14.0390546,52.4958079,7.6235467,14.9342317,0.4973427,42.2775459),(2005,'cephalophus_BayDuiker_metatarsus.tif',239,10,13,54.6514202,52.8656325,39.8898297,1.8,52.6399807,39.2738829,-0.0903503,8.7113145,8.2044638,596.101878,1298.143673,0.0741528,158.2240714,68.4284647,197.6145385,14.6744113,16.9145381,0.6279813,57.6681583),(2006,'cephalophus_BayDuiker_metatarsus.tif',239,10,14,73.1297393,52.6100289,37.8539788,1.8,52.5684009,38.2280094,0.1851939,14.3687141,8.1306245,1134.8608846,1454.7934396,0.413262,178.9276384,78.9813811,172.703952,14.9420868,16.9259658,2.4582014,55.9029932),(2007,'cephalophus_BayDuiker_metatarsus.tif',239,10,15,63.8529199,52.5724271,38.0133844,1.8,52.577898,38.2233674,0.3672949,14.610336,8.3907313,995.5827319,1255.0459895,1.3722749,149.5752804,68.142357,153.4141048,14.76116,16.4936077,2.4366655,64.7099742),(2008,'cephalophus_BayDuiker_metatarsus.tif',239,10,16,57.7072657,52.6371621,38.3519475,1.8,52.5804201,38.4121484,0.4104393,14.6736512,8.2515393,877.1396272,1038.9599345,1.5312691,125.9110441,59.7765078,129.6754913,13.8750009,15.6806519,2.4238875,55.6378281),(2009,'cephalophus_BayDuiker_metatarsus.tif',239,10,17,51.8586499,52.6949774,38.6824978,1.8,52.693367,38.8450322,0.3951686,8.3154152,8.9565887,760.7428508,842.5751556,1.2808837,94.073222,91.4858525,179.0056338,13.1250008,14.8504271,0.6510767,48.9710122),(2010,'cephalophus_BayDuiker_metatarsus.tif',239,10,18,48.5811815,52.6721163,38.912584,1.8,52.6777521,39.0933685,0.1937141,7.9443475,7.2763249,685.0541608,736.0731635,0.3000545,101.1600189,86.2316459,173.1784366,12.5625008,14.4070304,0.6747409,45.8533713),(2011,'cephalophus_BayDuiker_metatarsus.tif',239,10,19,47.1392317,52.7180671,39.1622607,1.8,52.7393956,39.3512551,0.2320779,8.0868291,6.8237945,629.7632711,685.2456909,0.4156116,100.4200369,77.8751803,151.6516568,12.3750008,13.9520673,0.71883,44.5730412),(2012,'cephalophus_BayDuiker_metatarsus.tif',239,10,20,46.8830811,52.7548953,39.3407516,1.8,52.7363699,39.5151963,0.2341894,7.675626,7.0821137,586.2613453,648.4911496,0.4207706,91.5674585,76.3796134,158.5313659,12.1875008,13.5467947,0.7266423,43.292711),(2013,'cephalophus_BayDuiker_metatarsus.tif',239,10,21,47.408763,52.7821367,39.4810537,1.8,52.7920801,39.6245104,0.2643202,7.5645846,7.0972633,554.583401,622.4017564,0.5393001,87.6960218,73.3131334,147.625826,11.8125007,13.2688553,0.7454195,41.8115556),(2014,'cephalophus_BayDuiker_metatarsus.tif',239,10,22,47.9552191,52.8040006,39.5966253,1.8,52.7751709,39.721618,0.3243983,7.599567,6.7016662,525.6645816,598.3798197,0.8119955,89.2882163,69.1703329,142.4831667,11.7570601,13.0039065,0.7446045,41.2168857),(2015,'cephalophus_BayDuiker_metatarsus.tif',239,10,23,48.4764052,52.8584334,39.7380037,1.8,52.8549169,39.8840482,0.4044512,7.045709,6.6184499,499.2082037,582.8595978,1.2511236,88.0658779,70.8527995,153.4969711,11.4375007,12.8625555,2.1062159,40.3115555),(2016,'cephalophus_BayDuiker_metatarsus.tif',239,10,24,49.0529145,52.9157641,39.8525844,1.8,52.9054891,39.9699188,0.4559278,6.9705427,6.7913518,478.6519651,568.9708562,1.5849007,83.7787344,68.6678195,150.2913237,11.2500007,12.7500008,2.0607537,39.8267205),(2017,'cephalophus_BayDuiker_metatarsus.tif',239,10,25,48.4920551,53.0389007,39.9387408,1.8,53.0484091,40.0550859,0.4834003,6.9728368,6.7063179,451.2939771,541.9598298,1.7459734,80.8133221,64.7217177,134.8731261,11.1449927,12.605803,2.1010121,39.4517205),(2018,'cephalophus_BayDuiker_metatarsus.tif',239,10,26,47.9985252,53.0829695,40.0745014,1.8,53.0798763,40.2097058,0.5338698,8.007409,6.4856049,430.3909672,518.6399563,2.0715129,79.9678619,53.7490927,116.0507476,10.8750007,12.5120262,2.0880837,38.8115554),(2019,'cephalophus_BayDuiker_metatarsus.tif',239,10,27,47.3410819,53.1377671,40.2103992,1.8,53.1403214,40.3428452,0.5340292,6.5609612,6.3816234,410.5311977,497.2381633,2.0442414,77.9171905,62.5718066,136.0605748,10.8750007,12.3308881,2.0616481,38.3267204),(2020,'cephalophus_BayDuiker_metatarsus.tif',239,10,28,47.1685925,53.2007916,40.3229286,1.8,53.1939968,40.4426162,0.5491271,6.8543814,6.5530778,398.9232363,484.5399314,2.1416459,73.9408175,58.1997434,125.1842805,10.6875007,12.1875008,2.1033004,37.7963903),(2021,'cephalophus_BayDuiker_metatarsus.tif',239,10,29,47.2760215,53.2592266,40.4318493,1.8,53.2620685,40.5567417,0.5765244,5.9339551,6.7188792,389.389329,475.0732463,2.341334,70.7072167,65.6205387,124.5025257,10.6007545,12.2436216,2.0481417,37.6410602),(2022,'cephalophus_BayDuiker_metatarsus.tif',239,10,30,47.1665577,53.3066878,40.563156,1.8,53.2948042,40.7386087,0.5876088,6.6871667,7.0929357,378.5837425,465.7071439,2.4159408,65.6578828,56.6134751,107.866224,10.5000007,12.1238731,2.1244776,37.5312253),(2023,'cephalophus_BayDuiker_metatarsus.tif',239,10,31,47.0996543,53.3649832,40.6831015,1.8,53.3651542,40.8229145,0.580209,6.5185546,6.2807212,370.1780164,456.1873064,2.3590796,72.6329497,56.7883591,125.830263,10.401786,12.0014655,2.0763774,37.3115553),(2024,'cephalophus_BayDuiker_metatarsus.tif',239,10,32,47.1672183,53.4278141,40.7820803,1.8,53.4193554,40.91274,0.576106,6.4710544,6.3940198,364.5973643,448.4996617,2.3329398,70.1436151,56.3428063,122.1170182,10.3125006,12.0014655,2.0763774,37.0008951),(2025,'cephalophus_BayDuiker_metatarsus.tif',239,10,33,46.4916003,53.5690677,40.8648036,1.8,53.5827355,40.9879421,0.5967837,6.4826234,6.5635573,354.4781619,435.6071204,2.4472184,66.367535,54.6812825,111.6127675,10.2956066,11.9912085,2.0414368,36.9365553),(2026,'cephalophus_BayDuiker_metatarsus.tif',239,10,34,46.1348815,53.6380779,40.9840169,1.8,53.6353213,41.0965012,0.616671,6.5872005,6.5000333,346.4020091,425.0599241,2.5716889,65.3934994,52.587136,111.4312097,10.1725709,11.8377713,2.0840486,36.4062252),(2027,'cephalophus_BayDuiker_metatarsus.tif',239,10,35,45.6777756,53.6925158,41.0957484,1.8,53.6843302,41.2153244,0.6439346,6.8381462,6.4519749,337.6618566,415.0647304,2.7438349,64.3314235,49.3791516,104.980374,10.0717393,11.7692669,2.1057514,36.2508951),(2028,'cephalophus_BayDuiker_metatarsus.tif',239,10,36,45.3862024,53.7488538,41.1943953,1.8,53.7382451,41.3041654,0.644804,6.4943651,6.4238391,330.0791771,405.3320047,2.7326368,63.0980938,50.8254725,106.9881352,9.9686344,11.7468421,2.070143,35.720565),(2029,'cephalophus_BayDuiker_metatarsus.tif',239,10,37,45.2226299,53.8012354,41.296991,1.8,53.785356,41.4221395,0.6619463,6.1716513,6.5759734,323.2719904,399.0102526,2.8475077,60.6769873,52.3801448,103.8429641,9.9375006,11.6747933,2.0919345,35.8758951),(2030,'cephalophus_BayDuiker_metatarsus.tif',239,10,38,45.099924,53.8703007,41.3929088,1.8,53.8398195,41.5326228,0.6791356,6.4553162,6.4903994,318.5463486,389.7704007,2.9655871,60.0533766,49.3463584,106.0919627,9.8718363,11.5476263,2.1362802,35.1902349),(2031,'cephalophus_BayDuiker_metatarsus.tif',239,10,39,45.0283117,53.9285205,41.4666689,1.8,53.9231842,41.5608816,0.6864758,6.4361988,6.4623064,315.3906671,380.7325672,3.0148083,58.9158957,49.0026295,106.5282986,9.7500006,11.4482539,2.1224513,34.9250698),(2032,'cephalophus_BayDuiker_metatarsus.tif',239,10,40,44.8798458,53.9739863,41.5673289,1.8,53.9378065,41.6982931,0.7054946,6.3918585,6.3954458,311.1391579,374.3519086,3.1448513,58.534138,48.6774166,101.0417439,9.7500006,11.4236604,1.9756881,34.7053999),(2033,'cephalophus_BayDuiker_metatarsus.tif',239,10,41,44.101774,54.0991844,41.6133864,1.8,54.0833978,41.7492695,0.7059408,7.0345541,6.9800962,302.4207571,362.3951354,3.0935678,51.9183584,42.99075,85.4938654,9.7500006,11.256249,2.0940746,34.6599047),(2034,'cephalophus_BayDuiker_metatarsus.tif',239,10,42,43.4575196,54.159122,41.6939332,1.8,54.1241688,41.7853327,0.6948657,5.4267816,6.3876716,295.2392392,350.7163518,2.9693179,54.9051944,54.4041125,99.4527627,9.6690571,11.2390579,2.0568283,34.4857299),(2035,'cephalophus_BayDuiker_metatarsus.tif',239,10,43,42.7867916,54.2122149,41.7913993,1.8,54.2153296,41.9176446,0.6867402,7.2989327,6.3939274,290.7245197,338.5198303,2.8665793,52.9439592,39.8311001,82.931068,9.5625006,11.1574324,2.0043778,33.8644096),(2036,'cephalophus_BayDuiker_metatarsus.tif',239,10,44,42.2891175,54.2655991,41.8620246,1.8,54.2549434,41.9339696,0.660307,6.3230234,6.2710183,286.8968028,329.0238322,2.6515959,52.4673689,45.3733578,89.3366963,0.375,0.5303301,2.3561945,1.0606602),(2037,'cephalophus_BayDuiker_metatarsus.tif',239,10,45,42.0259996,54.324808,41.9314727,1.8,54.3162534,41.9862526,0.6561871,6.8367078,5.8427968,283.1323422,323.9692336,2.6071693,55.4476293,41.4135501,87.736034,9.5625006,11.0051486,1.973451,33.9099047),(2038,'cephalophus_BayDuiker_metatarsus.tif',239,10,46,41.8136984,54.3646617,42.0198075,1.8,54.3443516,42.0768262,0.6725154,7.2439725,5.6839467,281.7617538,317.7984715,2.7044663,55.9115858,38.8960278,80.5596646,9.528541,11.0003558,2.0878283,34.0652348),(2039,'cephalophus_BayDuiker_metatarsus.tif',239,10,47,41.7517914,54.4083796,42.0992031,1.8,54.4044593,42.1731172,0.6821669,5.792352,5.7728114,279.8152319,314.219018,2.76606,54.4308477,48.3077049,100.9454619,9.528541,10.9088918,2.0728865,33.9099047),(2040,'cephalophus_BayDuiker_metatarsus.tif',239,10,48,41.438986,54.4601557,42.1778378,1.8,54.4636362,42.2311235,0.6776097,6.0957896,5.9140975,276.77791,310.5628815,2.714561,52.5123029,45.4047676,95.1303215,9.5062333,10.8377602,2.0963801,33.6902348),(2041,'cephalophus_BayDuiker_metatarsus.tif',239,10,49,40.5878424,54.5816066,42.2125728,1.8,54.5812733,42.293468,0.6328596,5.9987252,6.119009,270.1528946,302.1037087,2.3663838,49.3713457,45.0350506,80.4949496,9.480129,10.7726875,2.1201708,33.5349047),(2042,'cephalophus_BayDuiker_metatarsus.tif',239,10,50,39.8144155,54.623182,42.2834218,1.8,54.6208723,42.3382223,0.542787,7.4723185,5.6861026,264.622703,294.8954473,1.7703977,51.862491,35.4137343,74.7149514,9.3701522,10.7449123,2.0812846,33.5803998),(2043,'cephalophus_BayDuiker_metatarsus.tif',239,10,51,39.1008288,54.6645875,42.3696126,1.8,54.6410153,42.4287903,0.4363481,6.4147369,6.2289302,257.9872671,289.0950867,1.1640207,46.4116757,40.217903,78.7290402,9.4155126,10.5866963,1.971037,33.4250697),(2044,'cephalophus_BayDuiker_metatarsus.tif',239,10,52,38.7111696,54.6989219,42.4368278,1.8,54.6776601,42.5094713,0.3453425,6.6633071,5.5691357,254.3993588,286.0801889,0.7393519,51.3688665,38.1791437,79.045643,9.4112658,10.5667528,2.0503156,33.2053998),(2045,'cephalophus_BayDuiker_metatarsus.tif',239,10,53,38.0461305,54.7483284,42.5073539,1.8,54.7447174,42.5663377,0.2804098,6.4106047,5.6326141,248.9824304,282.4732776,0.4856605,50.1495881,38.8391488,76.5130192,9.3738088,10.4193336,2.0988708,33.2053998),(2046,'cephalophus_BayDuiker_metatarsus.tif',239,10,54,37.8065779,54.7637276,42.5795778,1.8,54.7465792,42.6476922,0.2182433,7.1644692,5.6503871,245.0753434,282.2083378,0.2953872,49.9449563,34.2070482,68.4772208,9.2736538,10.3550266,0.8366353,32.9402347),(2047,'cephalophus_BayDuiker_metatarsus.tif',239,10,55,37.5414038,54.7888552,42.6335882,1.8,54.8126104,42.6961713,0.1872973,6.5188244,5.6924281,239.2303104,284.127644,0.2169392,49.9132598,36.6983824,70.7972021,9.2736538,10.2783532,0.669043,32.9857299),(2048,'cephalophus_BayDuiker_metatarsus.tif',239,10,56,37.4392909,54.79631,42.6914893,1.8,54.7879115,42.7673996,0.1862066,5.2626545,5.5757557,235.8181942,286.1000079,0.2138658,51.3114318,44.8097424,87.9539473,9.1924889,10.1959327,2.1332943,32.6107298),(2049,'cephalophus_BayDuiker_metatarsus.tif',239,10,57,36.5998128,54.8616292,42.7173008,1.8,54.8689457,42.7805816,0.1832684,6.1904015,5.784786,229.8915585,281.3868026,0.202598,48.6425603,37.1367766,65.0260966,9.1924889,10.2303553,0.7205541,32.5652347),(2050,'cephalophus_BayDuiker_metatarsus.tif',239,10,58,35.9729875,54.8563954,42.7953239,1.8,54.8499816,42.8745656,0.1680786,5.3126491,5.8116985,223.4485249,277.1570396,0.1677864,47.6895072,42.0597183,83.9658499,9.178286,10.1319427,0.6805212,32.3000696),(2051,'cephalophus_BayDuiker_metatarsus.tif',239,10,59,35.4272878,54.8630996,42.8734434,1.8,54.8610535,42.9360747,0.1619372,5.2849047,5.8982038,217.233178,273.9752871,0.1534902,46.4506305,41.1044646,82.4929147,9.0212753,10.1076246,0.7066142,32.3000696),(2052,'cephalophus_BayDuiker_metatarsus.tif',239,10,60,34.5181045,54.8612118,42.9918169,1.8,54.8777258,43.0437867,0.1421685,5.7162092,5.8716407,209.0122344,269.2372697,0.1154979,45.8538393,36.5648332,80.7314168,0.1875,0.4192628,2.677945,0.7954952),(2053,'cephalophus_BayDuiker_metatarsus.tif',239,10,61,33.7801534,54.8628954,43.1202147,1.8,54.8888402,43.1576012,0.1107676,5.1176821,5.5778396,202.341317,266.9476453,0.0687954,47.8586088,39.5376879,79.713978,8.8471246,10.0500706,0.6397698,31.9250696),(2054,'cephalophus_BayDuiker_metatarsus.tif',239,10,62,33.3792016,54.8895935,43.2387821,1.8,54.9165913,43.2683156,0.0897969,5.2623938,5.7683824,197.5656621,265.7773876,0.0447383,46.0748563,37.5429265,75.3646096,8.7827956,10.0378197,0.5724598,31.9705647),(2055,'cephalophus_BayDuiker_metatarsus.tif',239,10,63,33.2683955,54.9002744,43.3351627,1.8,54.9305723,43.3576748,0.0654889,5.5643678,5.8134558,195.713375,266.776239,0.0237462,45.8894414,35.1726166,78.6609381,8.8341283,10.1406136,0.5880026,31.9705647),(2056,'cephalophus_BayDuiker_metatarsus.tif',239,10,64,33.1237328,54.9093155,43.4042,1.8,54.9605447,43.4406318,0.0200914,5.3253234,5.8000548,193.5656483,264.4748773,0.0022282,45.598686,36.348149,74.1454144,8.7434171,10.1406136,0.5880026,31.5045745),(2057,'cephalophus_BayDuiker_metatarsus.tif',239,10,65,32.3411227,54.9567512,43.4212155,1.8,54.9603782,43.4211578,-0.0195042,5.3690397,5.8504595,185.439223,258.7111479,0.0020502,44.2206547,34.5386201,75.0299761,8.648453,10.147545,0.2808377,31.3947395),(2058,'cephalophus_BayDuiker_metatarsus.tif',239,10,66,31.2054052,54.9849253,43.5132341,1.8,55.002867,43.5641212,-0.0429381,5.276513,5.8941953,178.6934429,250.7863399,0.0095829,42.5480201,33.8658206,72.3960413,8.6250005,10.147545,0.2808377,31.1295744),(2059,'cephalophus_BayDuiker_metatarsus.tif',239,10,67,30.0652559,55.0213424,43.6271669,1.8,55.0430847,43.6351622,-0.084815,6.0207185,5.5981268,175.3863732,243.4941827,0.0359598,43.4956532,29.1304724,68.893492,8.8125006,10.2011035,0.2984989,31.4402346),(2060,'cephalophus_BayDuiker_metatarsus.tif',239,10,68,29.4243148,55.0741099,43.734797,1.8,55.1039196,43.7573843,-0.1059539,5.3018642,5.6688951,173.0896073,242.7095938,0.0548483,42.8142683,32.6469335,68.8944514,8.8125006,10.2320734,0.2405342,31.4402346),(2061,'cephalophus_BayDuiker_metatarsus.tif',239,10,69,29.5059412,55.1607715,43.8466349,1.8,55.2181775,43.8565727,-0.1090524,5.1917824,5.1731045,173.0731848,248.8083867,0.0582514,48.0965318,33.3359858,75.7160271,8.8836948,10.3329349,0.2009543,31.4857298),(2062,'cephalophus_BayDuiker_metatarsus.tif',239,10,70,29.3807636,55.2116828,43.9428104,1.8,55.2452256,43.970948,-0.1157249,4.8850601,6.1896886,174.9912283,258.2964745,0.0652869,41.7301241,35.8217147,69.7428976,8.9727888,10.5267523,0.0713075,32.17139),(2063,'cephalophus_BayDuiker_metatarsus.tif',239,10,71,28.823537,55.240565,44.1069567,1.8,55.2969217,44.1024958,-0.0912413,5.436717,5.407529,179.734011,267.3061817,0.0398817,49.4322236,33.0592912,76.6062046,9.0583549,10.7006505,0.1939591,32.54639),(2064,'cephalophus_BayDuiker_metatarsus.tif',239,10,72,28.1085653,55.2589408,44.2614232,1.8,55.3139569,44.258063,-0.0907111,5.591516,5.6154367,184.943997,278.7419486,0.038443,49.6385171,33.0758236,77.3481638,9.1958575,11.0051486,0.1539447,33.2320502),(2065,'cephalophus_BayDuiker_metatarsus.tif',239,10,73,26.6349749,55.319767,44.3489216,1.8,55.3667834,44.3812941,-0.0861088,4.9561151,5.8541959,185.9984652,282.8086983,0.0328339,48.3087182,37.5290849,80.0549074,9.4113474,11.3758592,2.9927027,34.4025454),(2066,'cephalophus_BayDuiker_metatarsus.tif',239,10,74,25.5972688,55.3367473,44.4507406,1.8,55.3999658,44.4769244,-0.0866161,5.0588074,6.065396,188.874019,293.2687906,0.0319266,48.3511363,37.3356813,79.4418349,9.6313843,11.7468421,2.9974383,35.0427105),(2067,'cephalophus_BayDuiker_metatarsus.tif',239,10,75,24.879996,55.3660053,44.5982212,1.8,55.452248,44.6002094,-0.0962181,5.1861862,7.2739633,196.2419411,304.04517,0.0382712,41.7991069,37.8393553,68.5102625,9.7805159,12.1456018,2.9865959,36.8533708),(2068,'cephalophus_BayDuiker_metatarsus.tif',239,10,76,24.6733412,55.3560025,44.7353866,1.8,55.470995,44.7307517,-0.1011479,5.1697703,6.5070782,208.9145886,320.9782775,0.0419284,49.327558,40.4108067,81.1461981,9.9035064,12.5456985,2.976444,37.914031),(2069,'cephalophus_BayDuiker_metatarsus.tif',239,10,77,24.4435364,55.2861666,44.9306119,1.8,55.4412658,44.9235286,-0.0555112,5.3583794,9.7021757,214.9172809,346.1432771,0.0125409,35.6768717,40.1086344,55.6773872,10.3430568,13.2330383,3.0137227,40.0353515),(2070,'cephalophus_BayDuiker_metatarsus.tif',239,10,78,26.4949571,55.2271379,45.22039,1.8,55.3461404,45.1630053,-0.0357801,6.0930459,8.1582328,235.122244,401.653547,0.0056508,49.2329108,38.5886219,77.9913164,0.1875,0.2651651,2.3561945,0.5303301),(2071,'cephalophus_BayDuiker_metatarsus.tif',239,10,79,34.3987969,55.1548004,45.6038216,1.8,55.2951874,45.3838128,-0.0113899,6.0711645,7.5331096,284.0202746,526.1016698,0.0007437,69.8385794,46.7818448,107.4833234,11.3531351,14.7970657,2.9889433,46.1074974),(2072,'cephalophus_BayDuiker_metatarsus.tif',239,10,80,45.4357088,55.1463046,45.8992088,1.8,55.3465702,45.6285105,0.0336545,6.04594,7.5514612,343.5322626,769.8094699,0.0085737,101.9417891,56.820323,142.3538005,11.7570601,15.4809621,2.9465724,50.5620026),(2073,'cephalophus_BayDuiker_metatarsus.tif',239,10,81,46.5604852,55.3383817,46.2634369,1.8,55.4065663,46.0042437,0.0402297,6.0581941,7.5529995,354.456043,761.7589272,0.0125523,100.8551537,58.5085322,137.4635893,11.9639292,15.5579822,0.2186689,51.933323),(2074,'cephalophus_BayDuiker_metatarsus.tif',239,10,82,47.0909185,55.357442,46.5464577,1.8,55.3651256,46.5160253,0.0279441,5.8634166,8.0793776,373.7926937,758.8718056,0.0061271,93.9270131,63.749981,135.7124188,11.5744536,15.6896174,0.2536741,55.4636533),(2075,'cephalophus_BayDuiker_metatarsus.tif',239,10,83,45.0208863,55.3142645,46.6991868,1.8,55.3015583,46.7143787,0.0697201,6.3741037,8.0062979,407.4792178,757.7341645,0.0364146,94.642265,63.9272971,137.6705117,11.7581183,15.8401448,3.034857,68.3312948),(2076,'cephalophus_BayDuiker_metatarsus.tif',239,10,84,47.3771117,55.2913154,46.5525535,1.8,55.3167208,46.6284034,0.1029293,6.6268922,7.8998169,426.3809941,787.1977106,0.0833607,99.6475889,64.3410189,141.8899094,7.464719,11.7453456,1.2793395,34.3037494),(2077,'cephalophus_BayDuiker_metatarsus.tif',239,10,85,48.0342034,55.4469013,46.4461876,1.8,55.4067297,46.50911,0.0967295,6.495254,7.6804302,363.0685044,792.2374323,0.0746728,103.1501379,55.8975067,140.6654675,7.4414532,10.9731569,1.2220253,33.0234193),(2078,'cephalophus_BayDuiker_metatarsus.tif',239,10,86,37.493847,55.8538833,46.391472,1.8,55.6251242,46.3770556,0.1140464,4.9241906,7.8914413,201.0485964,487.774214,0.080926,61.8105356,40.8287597,85.1757071,7.2593821,9.7247275,1.2368513,31.0385842),(2079,'cephalophus_BayDuiker_metatarsus.tif',239,10,87,17.9267174,55.6588443,46.2603252,1.8,55.5880936,46.2518411,0.0784967,3.9709285,4.3505598,51.7167526,118.0606773,0.0183722,27.1368934,13.023844,32.2773788,3.7658989,7.3866438,1.152572,19.4246224),(2080,'cephalophus_BayDuiker_metatarsus.tif',239,10,88,0.5767969,58.3505044,46.4923875,1.8,58.3078549,46.4674616,-1.523804,1.1789749,1.7038371,0.0734087,0.3567505,0.0959207,0.2093807,0.0622648,0.2510627,2.0625001,3.6405917,1.3633001,8.9434665),(2081,'cephalophus_BayDuiker_metatarsus.tif',239,10,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2082,'cephalophus_BayDuiker_metatarsus.tif',239,10,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2083,'cephalophus_BayDuiker_metatarsus.tif',239,10,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2084,'cephalophus_BayDuiker_metatarsus.tif',239,10,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2085,'cephalophus_BayDuiker_metatarsus.tif',239,10,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2086,'cephalophus_BayDuiker_metatarsus.tif',239,10,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2087,'cephalophus_BayDuiker_metatarsus.tif',239,10,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2088,'cephalophus_BayDuiker_metatarsus.tif',239,10,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2089,'cephalophus_BayDuiker_metatarsus.tif',239,10,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2090,'cephalophus_BayDuiker_metatarsus.tif',239,10,98,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2091,'cephalophus_BayDuiker_metatarsus.tif',239,10,99,120.6727353,51.6216296,40.8048986,1.8,51.3716214,40.3465116,-1.3520037,13.0947522,14.2772851,4023.1805106,5907.2243781,19.1646158,413.7498361,307.2360938,620.6593595,28.6875018,29.0261888,0.2747504,94.8698787),(2092,'cephalophus_BayDuiker_metatarsus.tif',239,10,100,334.9908977,51.4038117,40.3010637,1.8,51.6912811,40.3891532,-1.3829616,14.1391107,14.7405397,11152.131288,15807.3478746,53.8850225,1072.3723989,788.7434764,1646.2253035,29.035574,29.2127184,2.2104464,95.9305389),(2093,'cephalophus_BayDuiker_metatarsus.tif',239,10,101,342.2657601,51.4741515,40.2779547,1.8,51.8898803,40.3557219,-1.3616048,14.3669972,14.9180228,11630.1681997,16113.7277478,54.584176,1080.1517042,809.5058433,1687.87891,29.035574,29.211515,0.7309067,96.085869),(2094,'cephalophus_BayDuiker_metatarsus.tif',239,10,102,344.8360552,51.5413961,40.2770576,1.8,52.0220679,40.3269916,-1.3389425,14.5233573,15.2693925,11918.9769731,16260.291657,54.4381295,1064.8944739,820.6764289,1672.5247952,28.8750018,29.2451937,0.7127987,95.7752088),(2095,'cephalophus_BayDuiker_metatarsus.tif',239,10,103,347.1911514,51.5961684,40.2697515,1.8,52.1347862,40.3061836,-1.3188833,14.6769865,15.2375262,12150.7311409,16397.2234459,54.2700814,1076.1079734,827.8764295,1667.1227981,29.1493417,57.0376145,0.0888742,186.5844271),(2096,'cephalophus_BayDuiker_metatarsus.tif',239,10,104,348.4751856,51.6305366,40.2627566,1.8,52.1898682,40.2703384,-1.3037408,14.7161026,15.5289683,12295.3140003,16459.2605849,54.0346071,1059.906895,835.5006963,1660.5885388,29.1600546,57.2243769,0.0885834,181.9290967),(2097,'blackbuck_humerus.tif',237,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2098,'blackbuck_humerus.tif',237,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2099,'blackbuck_humerus.tif',237,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2100,'blackbuck_humerus.tif',237,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2101,'blackbuck_humerus.tif',237,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2102,'blackbuck_humerus.tif',237,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2103,'blackbuck_humerus.tif',237,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2104,'blackbuck_humerus.tif',237,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2105,'blackbuck_humerus.tif',237,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2106,'blackbuck_humerus.tif',237,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2107,'blackbuck_humerus.tif',237,2,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2108,'blackbuck_humerus.tif',237,2,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2109,'blackbuck_humerus.tif',237,2,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2110,'blackbuck_humerus.tif',237,2,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2111,'blackbuck_humerus.tif',237,2,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2112,'blackbuck_humerus.tif',237,2,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2113,'blackbuck_humerus.tif',237,2,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2114,'blackbuck_humerus.tif',237,2,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2115,'blackbuck_humerus.tif',237,2,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2116,'blackbuck_humerus.tif',237,2,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2117,'blackbuck_humerus.tif',237,2,21,5.1746252,90.1896549,54.2977607,1.8,90.573941,54.3175259,0.3798353,2.2587556,3.8688196,3.652053,16.4336235,0.118558,4.2477099,1.6168429,5.1681111,4.247223,7.7042022,2.786887,20.0066875),(2118,'blackbuck_humerus.tif',237,2,22,26.8446021,90.9991018,54.1185655,1.8,91.2475291,54.1748256,0.2199028,4.098046,6.1750716,75.5648442,198.2418188,0.2128902,32.1035661,18.4392376,44.0225039,7.492184,12.2765534,2.8543112,32.6130092),(2119,'blackbuck_humerus.tif',237,2,23,39.0650984,90.9870324,54.1400606,1.8,91.3175698,54.2489971,0.2018675,5.6026211,7.3240458,214.2531306,473.3759818,0.2617359,64.6331272,38.2415883,92.7671761,10.1679641,14.4813847,2.8607549,40.2350438),(2120,'blackbuck_humerus.tif',237,2,24,47.9942786,90.7187561,54.1792547,1.8,90.9996375,54.2546184,0.1343095,7.227022,8.0570795,388.4683224,781.2177754,0.1434296,96.9604151,53.7521984,141.8607781,11.3450933,16.4293765,2.8610559,45.8082727),(2121,'blackbuck_humerus.tif',237,2,25,53.4751479,90.1748302,54.1825739,1.8,90.5316614,54.2209217,0.1447148,12.9277562,12.4287288,540.8137396,1033.629344,0.18535,83.1645261,41.8335349,87.794806,12.4521359,17.6032976,2.8006137,49.8409589),(2122,'blackbuck_humerus.tif',237,2,26,56.8189258,89.2791462,54.2357038,1.8,89.6173291,54.3707336,0.2568997,7.3314073,9.4660221,662.8113662,1132.1193724,0.6113556,119.5982178,90.4071132,188.7317878,13.0793495,17.9596473,2.711266,50.9112709),(2123,'blackbuck_humerus.tif',237,2,27,61.2961215,88.4575298,54.1898646,1.8,88.6868248,54.3244892,0.4144776,7.6958173,9.2418751,794.4933741,1321.3008196,1.6568016,142.9689112,103.2370371,226.5391452,13.522476,18.8523847,2.5378433,52.6085572),(2124,'blackbuck_humerus.tif',237,2,28,63.151746,87.8167494,54.2478051,1.8,87.8669711,54.3265947,0.5936758,7.7996153,9.650462,894.9682072,1422.4877478,3.293799,147.4010003,114.7451726,240.1134552,13.9531821,19.3194282,2.5036317,54.122207),(2125,'blackbuck_humerus.tif',237,2,29,64.8028173,87.0566386,54.2641778,1.8,87.0251489,54.3286221,0.7354065,7.3140162,10.5301852,929.7544454,1566.0532812,4.8612006,148.7203928,127.1195504,235.9308064,14.1904665,19.9107522,2.4227627,54.4088012),(2126,'blackbuck_humerus.tif',237,2,30,70.2312248,85.9444082,53.8371069,1.8,85.7982606,53.7664654,0.7194076,8.0461035,12.8360672,1032.7189908,2088.4172158,5.0824094,162.6991495,128.3502002,242.6137145,14.5688789,23.6560746,2.4845177,61.4038616),(2127,'blackbuck_humerus.tif',237,2,31,78.6807202,84.901765,53.1672088,1.8,84.8368103,53.1221491,0.6991402,8.2788815,12.9992607,1275.8287751,2714.6748934,5.4311898,208.8330213,154.1064182,305.6791976,15.3257038,24.6433384,2.4176554,64.5879046),(2128,'blackbuck_humerus.tif',237,2,32,87.0277871,84.9146188,52.5716417,1.8,85.3555191,52.4209944,0.3713812,14.7106116,22.6810677,2051.9546143,3611.8434127,1.9102374,159.2448582,139.488056,219.9072323,16.3167892,25.2219768,2.4237607,67.0420158),(2129,'blackbuck_humerus.tif',237,2,33,111.0242213,87.5066454,51.2685813,1.8,88.4881663,50.8925881,-0.1444788,13.5361741,23.7399639,2994.6638011,9792.9371726,0.3835752,412.5085116,221.2341371,538.6049818,17.6555237,25.7431732,2.3267912,70.5015136),(2130,'blackbuck_humerus.tif',237,2,34,151.3978705,89.8887086,49.5121134,1.8,90.9665668,48.5374835,-0.2510726,13.9217704,22.2237977,4755.7316167,16390.2123078,1.5574798,737.5072672,341.6039387,949.3610772,21.7140238,38.0535056,2.9648838,129.3325528),(2131,'blackbuck_humerus.tif',237,2,35,228.549236,91.9638777,46.6338223,1.8,92.5931618,46.242972,-0.4108447,15.161305,20.4280376,9569.0734342,23819.6819383,6.0758848,1166.0288856,631.1510412,1610.1424464,27.038327,39.2109063,0.3995155,127.3486724),(2132,'blackbuck_humerus.tif',237,2,36,257.8618858,92.3575122,45.128386,1.8,92.9620259,45.1021351,-0.4895536,15.2932053,20.0227762,13991.0569736,28702.7059228,9.5029898,1433.5028085,914.854454,2025.3255353,29.3331418,40.3723689,0.4162055,126.435104),(2133,'blackbuck_humerus.tif',237,2,37,275.6395792,92.3569492,44.1352078,1.8,93.1984701,44.2403077,-0.5273144,16.7403791,20.9608744,17959.543866,31613.7234563,11.6331267,1508.2254133,1072.8277873,2314.189855,31.3079891,41.3232621,0.4201967,125.5864608),(2134,'blackbuck_humerus.tif',237,2,38,290.7909716,92.4032171,43.2419219,1.8,93.3544796,43.4409934,-0.5734409,18.0180298,21.5371917,21553.8848305,33922.9106911,14.2649553,1575.085147,1196.2398267,2423.5339816,32.8961236,41.8355446,0.7537345,129.619147),(2135,'blackbuck_humerus.tif',237,2,39,305.1594509,92.2553871,42.5939448,1.8,93.3635209,42.8077085,-0.6425433,19.2011757,22.0235493,24754.7691691,36088.3628469,18.2628129,1638.6261031,1289.2319476,2593.0032499,34.1923787,42.7873875,0.7500147,129.3974782),(2136,'blackbuck_humerus.tif',237,2,40,312.7599678,92.1835676,42.088123,1.8,93.3737286,42.2842283,-0.7413569,33.023043,22.5666206,26769.3581763,37385.5390614,23.7705732,1656.6742414,810.6266346,1920.6207249,35.2116366,43.7986857,0.8502422,131.4731769),(2137,'blackbuck_humerus.tif',237,2,41,317.1713801,92.2495086,41.4772577,1.8,93.4224795,41.6691097,-0.8910698,20.8879588,22.7433346,27327.6446261,38635.0324517,31.9754619,1698.7408877,1308.2965583,2733.5882605,36.1155098,44.6085513,0.8660737,132.32182),(2138,'blackbuck_humerus.tif',237,2,42,320.252133,92.3373381,40.8782914,1.8,93.3541098,41.1093887,-1.0047025,20.8638562,23.5631645,26832.8959463,40413.0243786,38.0214066,1715.0932526,1286.0947511,2821.0925296,36.6246166,44.8127252,0.8699419,133.3003137),(2139,'blackbuck_humerus.tif',237,2,43,325.2930869,92.4640348,40.2798881,1.8,93.1431318,40.5992868,-1.0869481,20.3246621,23.5457926,26586.1866114,41658.7190382,42.4832299,1769.2638202,1308.0752093,2823.5846392,36.1563864,44.7551705,0.8530912,139.0952115),(2140,'blackbuck_humerus.tif',237,2,44,327.3027339,92.3493435,39.9009997,1.8,92.8280821,40.1814846,-1.159829,19.6218654,25.9480787,26084.2975588,42728.0543572,45.8443511,1646.6750721,1329.3485092,2583.4064112,35.2160541,44.7391699,0.9296876,135.0356324),(2141,'blackbuck_humerus.tif',237,2,45,330.4887575,92.4891612,39.461474,1.8,92.6703724,39.8330879,-1.2154764,17.8508439,24.7247011,25542.0977466,43797.7812195,48.4150787,1771.4180283,1430.8622018,2784.1306256,34.0617916,44.7623689,0.9595806,132.4516706),(2142,'blackbuck_humerus.tif',237,2,46,326.809619,92.2627687,39.2592926,1.8,92.5653052,39.5897466,-1.2606568,16.7323752,24.2164456,23415.0101086,44700.6672065,49.3949955,1845.8806012,1399.3835172,2785.0815568,0.267578,0.5983226,2.0344439,1.2919809),(2143,'blackbuck_humerus.tif',237,2,47,325.5969444,92.0193334,38.8953581,1.8,92.3607148,39.2112601,-1.2979651,16.2936392,24.9134889,21844.3471541,45010.2355488,50.3259926,1806.6612738,1340.6671737,2664.181953,31.6251704,44.7431706,1.0375562,139.4578704),(2144,'blackbuck_humerus.tif',237,2,48,320.4928324,92.0910489,38.8978121,1.8,92.4120596,38.9697067,-1.3154802,15.3781899,24.0732843,19483.783567,45305.4042266,50.0085189,1881.9785309,1266.9750939,2676.9165183,30.4151355,44.6077488,1.0427219,150.8371366),(2145,'blackbuck_humerus.tif',237,2,49,319.9748752,92.3359274,38.8448041,1.8,92.5380443,38.8609889,-1.3084814,23.8353148,24.7650387,17628.8653934,44868.0918175,49.7430123,1811.7513271,739.6111852,2106.9278387,1.5577787,3.1319202,1.2220253,10.0872852),(2146,'blackbuck_humerus.tif',237,2,50,311.1023442,92.4839588,38.9833716,1.8,92.4357634,38.8276952,-1.3126857,28.4234294,25.5148031,15067.2930658,43866.2805816,48.4720939,1719.248247,530.1011664,1542.9453117,27.7154511,43.6939392,1.0797583,149.4264445),(2147,'blackbuck_humerus.tif',237,2,51,279.4357261,91.8904974,39.5408176,1.8,91.9584076,39.2044046,-1.3762981,12.925936,26.9470429,10510.9094028,40520.450874,44.8329036,1503.7067706,813.1642765,1892.9203784,25.6670664,43.0077016,1.1544671,159.9950998),(2148,'blackbuck_humerus.tif',237,2,52,229.3747608,91.4168245,41.7944387,1.8,91.4481535,40.6376181,-1.3970329,12.0926805,22.9309494,7686.7943083,33035.7443638,37.086418,1440.6618669,635.6567742,1749.0889249,22.6144505,42.0923245,1.1725822,189.2404294),(2149,'blackbuck_humerus.tif',237,2,53,181.2418207,91.0316917,45.1705018,1.8,90.9476116,44.4269725,-1.3622,11.822384,23.6408532,6164.3254479,21969.1398267,28.9115451,929.2870974,521.4113719,1186.6826566,18.7881327,31.3534745,1.1950443,86.7194626),(2150,'blackbuck_humerus.tif',237,2,54,155.4051881,90.7943635,48.2559912,1.8,90.5550026,47.77298,-1.1945422,11.2999725,24.5745969,5103.4654552,12775.0086083,22.4039472,519.846111,451.6352087,703.7233508,0.7552467,5.4180416,1.2178059,12.1629839),(2151,'blackbuck_humerus.tif',237,2,55,147.7653141,90.5562404,49.33637,1.8,90.2195194,49.6260835,-1.0968602,16.0368544,15.5356868,4629.6578793,10718.6741924,19.497787,689.9388713,288.6886521,709.5865205,1.0224321,7.064262,1.141034,15.4388453),(2152,'blackbuck_humerus.tif',237,2,56,144.3232083,90.3379934,49.9330174,1.8,89.9363571,50.2226572,-1.0560903,21.6353956,14.5028713,4367.7748955,9917.5353343,18.2246882,683.8325417,201.8809814,595.9042232,1.2998694,5.7451433,1.0863184,13.0765524),(2153,'blackbuck_humerus.tif',237,2,57,142.2394682,90.2041707,50.3929728,1.8,89.8485467,50.588887,-1.0218175,10.3927219,14.8575172,4109.5977321,9294.6612394,17.251458,625.5864365,395.4303567,901.9261885,1.536524,8.1380672,1.0924439,20.358207),(2154,'blackbuck_humerus.tif',237,2,58,141.4410422,90.0879526,50.802253,1.8,89.7359915,51.0799675,-0.9953322,10.2550849,14.1518181,3951.3497084,8887.9230478,16.591505,628.0410756,385.3063856,899.536331,1.6687846,9.1015862,1.1466019,21.2717754),(2155,'blackbuck_humerus.tif',237,2,59,138.641409,90.0661396,51.118872,1.8,89.6092202,51.5029554,-0.9847302,10.030706,14.1082488,3790.0149719,8437.5345398,16.0383569,598.0568307,377.8412973,862.0540117,1.7542895,16.0390638,1.0847644,38.7594264),(2156,'blackbuck_humerus.tif',237,2,60,137.4792652,90.128817,51.3361182,1.8,89.7513795,51.7316131,-0.9911232,10.0686323,13.4368356,3645.4702985,7966.5899936,16.0385474,592.8918253,362.0621156,832.1076977,1.6932715,9.2149451,1.120135,24.4558185),(2157,'blackbuck_humerus.tif',237,2,61,136.2216357,90.2467551,51.5286159,1.8,89.9232507,51.9211596,-1.01049,9.9581355,13.1619963,3509.2414125,7480.5102797,16.2913232,568.3416191,352.3994449,804.0094278,1.2566322,16.1657865,1.1441688,35.1969709),(2158,'blackbuck_humerus.tif',237,2,62,134.2736498,90.3805287,51.6683104,1.8,90.0528243,52.0837928,-1.0354361,9.8528574,13.3919578,3372.3668438,6971.9260495,16.5547345,520.605438,342.2729786,772.4137137,1.0012426,10.1890667,1.1659045,22.0554932),(2159,'blackbuck_humerus.tif',237,2,63,132.9720635,90.5649396,51.7456392,1.8,90.3446714,52.0811979,-1.0686221,9.5830067,13.1454979,3266.7633496,6468.9470251,17.0274954,492.1036146,340.8912729,740.4791376,0.267578,0.8461559,1.8925469,1.8271369),(2160,'blackbuck_humerus.tif',237,2,64,131.7139133,90.7352017,51.8106701,1.8,90.6010634,52.1760144,-1.1017786,9.355875,12.5538755,3182.9893315,6015.0036706,17.4671682,479.1352015,340.2128946,727.728003,0.5846904,2.2861874,1.2120257,4.9462547),(2161,'blackbuck_humerus.tif',237,2,65,129.9997924,90.9190566,51.8274608,1.8,90.7843672,52.1470868,-1.1237503,9.503993,12.6127484,3089.4704145,5608.5489556,17.6174303,444.6730211,325.0707806,689.5895041,0.8742438,3.977833,1.2277724,8.8221973),(2162,'blackbuck_humerus.tif',237,2,66,129.3213906,91.0168068,51.8983859,1.8,90.9002053,52.2151086,-1.1468293,9.3049847,12.1893301,3030.9569547,5309.1889992,17.9059896,435.560359,325.7347611,678.1001211,0.910449,6.1775179,1.2627435,13.7684519),(2163,'blackbuck_humerus.tif',237,2,67,129.4338645,91.1097975,51.965479,1.8,91.0214821,52.2747776,-1.1658381,9.4551816,11.9791704,2983.0756689,5062.9639817,18.223845,422.6472975,315.4963923,661.7906363,0.974953,9.3957606,1.2220253,20.3201746),(2164,'blackbuck_humerus.tif',237,2,68,129.2878263,91.2178445,52.0131144,1.8,91.1444963,52.2256203,-1.1752419,9.381907,12.4305101,2951.7196671,4824.1749651,18.3487139,388.0914717,314.618305,624.0213162,0.7375449,4.823831,1.2315037,10.4276653),(2165,'blackbuck_humerus.tif',237,2,69,130.4865068,91.3025581,52.0533195,1.8,91.2528922,52.222355,-1.1790598,9.1924125,11.5352067,2949.6098361,4648.2436991,18.5776549,402.9614571,320.8743974,648.6607465,0.5192596,1.4409516,1.1902899,3.1191178),(2166,'blackbuck_humerus.tif',237,2,70,130.1567655,91.3662386,52.1178852,1.8,91.3210744,52.2894495,-1.1900702,9.101256,11.2810088,2902.1909616,4475.6879693,18.6973961,396.7453667,318.8780726,643.0009184,0.6311055,2.7935964,1.2793395,6.0165667),(2167,'blackbuck_humerus.tif',237,2,71,130.212395,91.4201498,52.179718,1.8,91.3693478,52.3402701,-1.1968446,9.0768235,11.189381,2869.7479676,4338.2715987,18.8061032,387.7132796,316.1621415,629.2813479,0.535156,1.1966452,1.1071487,2.5839618),(2168,'blackbuck_humerus.tif',237,2,72,130.7067032,91.5177199,52.2177749,1.8,91.5083114,52.328223,-1.192612,9.0238182,11.1995293,2858.1343161,4229.7432108,18.8144987,377.6715153,316.732257,621.6285673,0.9793871,8.8016488,1.2298174,19.0281937),(2169,'blackbuck_humerus.tif',237,2,73,129.6813549,91.6922036,52.2074236,1.8,91.734709,52.3434118,-1.191171,9.0227056,11.2912635,2822.0066587,4055.904919,18.6454991,359.207357,312.7672314,598.8038856,0.535156,2.991613,1.3909428,6.3300538),(2170,'blackbuck_humerus.tif',237,2,74,128.5307318,91.7720258,52.2310518,1.8,91.7742937,52.3717018,-1.1931097,9.0533272,10.8832692,2778.7989876,3894.6844056,18.5085932,357.8597869,306.9367687,607.8394494,0.535156,2.991613,1.3909428,6.3300538),(2171,'blackbuck_humerus.tif',237,2,75,127.7998683,91.8629191,52.2337442,1.8,91.8800659,52.3248574,-1.1997154,9.0347048,10.7018174,2747.9949783,3750.4575711,18.499128,350.4505295,304.159909,593.4335792,0.535156,0.8461559,1.8925469,2.0488058),(2172,'blackbuck_humerus.tif',237,2,76,128.9521402,91.9262712,52.2305645,1.8,91.9932394,52.1842035,-1.2067685,9.0627995,10.5883327,2723.9967228,3643.201278,18.7675827,344.0769555,300.5690168,597.7983111,16.2486813,19.2953241,1.2315037,58.1011073),(2173,'blackbuck_humerus.tif',237,2,77,128.3413877,91.9880404,52.2307544,1.8,92.0785051,52.159243,-1.2224688,9.060735,10.6782571,2697.3700263,3516.4824912,18.8981916,329.3124007,297.6988115,570.9081254,0.267578,1.3643855,1.7681919,2.8974489),(2174,'blackbuck_humerus.tif',237,2,78,126.8705698,92.0128932,52.2260271,1.8,92.1011986,52.1846959,-1.2468809,9.0390663,10.2694028,2642.6216522,3394.0618252,19.0030401,330.5023576,292.3556011,580.038339,16.3222581,18.8846385,1.2087089,56.96587),(2175,'blackbuck_humerus.tif',237,2,79,125.5453995,92.0317457,52.1962504,1.8,92.0812251,52.0828201,-1.2920739,9.0324451,10.2333368,2579.8005505,3277.6376247,19.340369,320.2902137,285.614861,563.8531232,0.267578,0.8461559,1.8925469,1.8271369),(2176,'blackbuck_humerus.tif',237,2,80,125.0122115,92.0658009,52.1688292,1.8,92.0780917,52.0821616,-1.3151755,8.9886784,10.0388918,2539.0534526,3187.3171597,19.5033397,317.4969132,282.4723884,561.0659253,16.0546801,18.4841985,1.1849137,55.8306327),(2177,'blackbuck_humerus.tif',237,2,81,123.1267761,92.1641202,52.0457445,1.8,92.1868126,51.9002687,-1.3338185,8.9715832,10.1048855,2486.3608257,3080.3904526,19.3901057,304.8416991,277.1373529,548.6789471,0.267578,0.8461559,1.8925469,1.8271369),(2178,'blackbuck_humerus.tif',237,2,82,122.3476165,92.1871891,51.9905014,1.8,92.2099387,51.8773013,-1.3486243,8.9301089,10.3782369,2442.4848627,3011.2586339,19.4012006,290.1512723,273.5112064,523.1054828,0.535156,0.9647662,2.1587989,2.0488058),(2179,'blackbuck_humerus.tif',237,2,83,121.7133668,92.1903194,51.9127332,1.8,92.1590734,51.7655957,-1.3690849,8.9588576,9.7865632,2408.1757438,2947.3471179,19.4713255,301.1626301,268.8038877,542.3677614,0.535156,3.2220658,1.6539376,6.8652098),(2180,'blackbuck_humerus.tif',237,2,84,121.4924762,92.184446,51.8086043,1.8,92.1433522,51.6646439,-1.3951906,9.1519724,9.6708657,2380.6983669,2905.9000521,19.6307197,300.4798279,260.129541,538.9733504,0.267578,0.8461559,1.8925469,1.8271369),(2181,'blackbuck_humerus.tif',237,2,85,122.0333881,92.1744499,51.6812061,1.8,92.1079933,51.5383227,-1.4248275,8.8757563,9.6278852,2358.1983719,2880.0296774,19.9086084,299.1341952,265.6898511,537.5095966,0.267578,1.3643855,1.7681919,2.8974489),(2182,'blackbuck_humerus.tif',237,2,86,121.850618,92.1742429,51.5472797,1.8,92.1265109,51.4481525,-1.4539186,8.8067265,9.6448232,2331.0540181,2853.819271,20.0322757,295.8912986,264.6901804,529.1899782,0.267578,1.6276134,1.735945,3.4326049),(2183,'blackbuck_humerus.tif',237,2,87,122.9417279,92.1736694,51.4099114,1.8,92.1359157,51.3097802,-1.4854112,8.7291144,9.6421821,2320.1655437,2851.9982872,20.3412638,295.7834922,265.7962127,524.7347935,15.5195241,17.5585003,1.4332096,54.5386518),(2184,'blackbuck_humerus.tif',237,2,88,123.2190942,92.1578284,51.272246,1.8,92.0770521,51.257481,-1.5080207,8.666749,9.5402058,2301.8233817,2847.8417833,20.4556922,298.5094697,265.5924827,536.2069525,0.267578,1.1032524,1.815775,2.3622929),(2185,'blackbuck_humerus.tif',237,2,89,123.4298743,92.190858,51.0739093,1.8,92.1166451,51.0161135,-1.5280957,9.1404455,9.3856204,2270.6097394,2842.4035062,20.5341593,302.8466288,248.4134654,530.4524387,15.2519461,17.5585003,1.4332096,54.1602393),(2186,'blackbuck_humerus.tif',237,2,90,123.3142327,92.1710055,50.9078121,1.8,92.1164116,50.837081,-1.5567934,9.4819311,9.5693641,2246.6739814,2852.2520045,20.5483424,298.0607682,236.9426595,529.7096822,0.267578,0.5983226,2.0344439,1.2919809),(2187,'blackbuck_humerus.tif',237,2,91,123.2059245,92.1391651,50.740242,1.8,92.0502045,50.6639367,1.5536423,9.0252356,9.7431401,2229.2843422,2858.5809673,20.5282788,293.3942178,247.005668,499.3039558,0.267578,0.3784124,2.3561945,0.7568249),(2188,'blackbuck_humerus.tif',237,2,92,123.9204941,92.1158523,50.5625276,1.8,92.080197,50.4857379,1.5228669,8.6989886,9.6794223,2228.9482738,2878.6527931,20.6060063,297.3992342,256.2307395,505.704983,15.5195241,17.6864809,1.7533562,54.0684211),(2189,'blackbuck_humerus.tif',237,2,93,125.1225809,92.0646029,50.380202,1.8,91.999703,50.3235818,1.4870202,8.8328831,9.6533934,2234.6668166,2909.5472803,20.7077445,301.4015025,252.9940445,527.7479093,15.2519461,17.8235874,1.706324,53.9116775),(2190,'blackbuck_humerus.tif',237,2,94,126.3372082,92.0245791,50.1907619,1.8,91.9777064,50.1696779,1.4598644,8.6188467,9.6003981,2251.5285111,2945.7855442,20.798147,306.8399358,261.2331544,517.4057567,15.2519461,17.849679,1.7975952,54.2251646),(2191,'blackbuck_humerus.tif',237,2,95,127.4163851,91.9752301,50.0022392,1.8,91.9169542,49.9713209,1.4295552,9.0353745,9.7698021,2269.1362592,2988.7239409,20.8152343,305.9144802,251.139149,516.2940175,0.267578,0.8461559,1.8925469,1.8271369),(2192,'blackbuck_humerus.tif',237,2,96,129.3497477,91.8780265,49.8135077,1.8,91.8084469,49.8029017,1.3835724,9.2765486,9.9147833,2295.3810829,3049.2377959,20.8114008,307.544572,247.4391277,538.0143621,15.5195241,17.9416986,1.8736812,54.4468335),(2193,'blackbuck_humerus.tif',237,2,97,129.4934861,91.8333455,49.5775437,1.8,91.8070098,49.6175049,1.3367366,8.7163086,9.8546286,2315.4913533,3073.7923683,20.4213213,311.9135679,265.6504564,543.9163912,15.5195241,17.989522,1.9678758,54.4468335),(2194,'blackbuck_humerus.tif',237,2,98,131.0191958,91.7310531,49.4105263,1.8,91.6866394,49.4885514,1.276322,9.5868694,9.9625441,2348.4885734,3119.5774623,19.997079,313.1306051,244.969287,528.4961126,15.6778082,18.1085278,1.9018924,54.825246),(2195,'blackbuck_humerus.tif',237,2,99,132.0070311,91.6394395,49.2333039,1.8,91.5952818,49.3101971,1.2171206,9.4618476,10.0397641,2363.0154693,3182.8769316,19.3619724,317.0270642,249.7414427,548.4723069,15.6784876,18.1834954,2.1465546,54.6035771),(2196,'blackbuck_humerus.tif',237,2,100,133.0009196,91.5550058,49.0942796,1.8,91.5196101,49.1662472,1.161399,9.3258682,9.989861,2386.7235559,3249.9320102,18.6545097,325.3230471,255.9250784,560.471884,15.7041162,18.3305579,2.1587989,55.2036584),(2197,'blackbuck_humerus.tif',237,2,101,134.3345948,91.4421868,48.9620071,1.8,91.3508435,49.0072638,1.0937771,9.1201994,10.0918614,2414.0134076,3321.1618722,17.6694036,329.0930925,264.688664,565.1127604,0.267578,0.5983226,2.0344439,1.2919809),(2198,'blackbuck_humerus.tif',237,2,102,134.7544845,91.3580234,48.8557186,1.8,91.2721092,48.8931318,1.0314954,8.7351979,10.2244009,2423.7859743,3389.7570055,16.5361836,331.5360023,277.4735045,567.3220806,0.267578,1.3643855,1.7681919,2.8974489),(2199,'blackbuck_humerus.tif',237,2,103,135.5780349,91.2486032,48.7612526,1.8,91.1772805,48.7747741,0.9685917,8.8989201,10.1718848,2431.472008,3466.8908308,15.3456779,340.8307222,273.2322565,576.1802571,15.7041162,18.7304601,2.2142974,55.6738891),(2200,'blackbuck_humerus.tif',237,2,104,135.9787016,91.1393575,48.6807498,1.8,91.0228831,48.6626158,0.9092546,8.5413656,10.0760013,2427.8726288,3538.231529,14.1099117,351.1543351,284.2487655,588.1938724,15.6829469,18.9357524,2.3162158,55.9873762),(2201,'blackbuck_humerus.tif',237,2,105,135.2423488,91.08873,48.5491238,1.8,90.9674501,48.4673085,0.8562979,8.7665899,10.4189592,2415.720189,3600.3177725,12.8629527,345.5544562,275.5598501,566.0133669,15.51491,19.0563635,2.4756234,56.0523015),(2202,'blackbuck_humerus.tif',237,2,106,134.8946647,90.9864399,48.4893284,1.8,90.8657919,48.4055416,0.8036934,8.7280195,10.4357251,2401.3202206,3676.0318348,11.6524518,352.2545666,275.1277342,574.062842,15.51491,19.3194282,2.5036317,56.430714),(2203,'blackbuck_humerus.tif',237,2,107,135.133368,90.8995034,48.4500422,1.8,90.7800733,48.3797302,0.760768,8.8232089,10.5958505,2389.0057423,3778.3537782,10.706613,356.5880612,270.7638199,575.8145387,15.51491,19.6665281,2.5498165,56.96587),(2204,'blackbuck_humerus.tif',237,2,108,136.5853101,90.8403187,48.4336475,1.8,90.6624854,48.3199698,0.7265573,8.8694324,10.965777,2378.3460452,3918.0366962,10.045733,357.296769,268.1508727,571.0453427,15.5148181,19.8891648,2.5573214,57.3442824),(2205,'blackbuck_humerus.tif',237,2,109,137.0032905,90.7478125,48.4117431,1.8,90.5319897,48.3064239,0.701881,8.8222791,10.30587,2363.4755561,4043.506079,9.518776,392.3498027,267.8985235,603.4496284,15.4655155,20.2600903,2.5535901,57.7226948),(2206,'blackbuck_humerus.tif',237,2,110,137.5070366,90.6451951,48.3894297,1.8,90.4186439,48.2253485,0.6710146,8.9123458,10.5861052,2357.4263068,4188.283444,8.860302,395.6396951,264.512436,610.0908497,0.5084618,1.4409516,1.9513027,3.1191178),(2207,'blackbuck_humerus.tif',237,2,111,139.8425846,90.5106185,48.3856795,1.8,90.2967104,48.2959877,0.628985,9.1661296,10.8488613,2352.8246897,4409.6760693,8.0671811,406.4644168,256.6868235,615.0826751,0.267578,0.8461559,1.8925469,1.8271369),(2208,'blackbuck_humerus.tif',237,2,112,144.3669699,90.2863963,48.385622,1.8,90.0707408,48.2766905,0.5875738,8.805304,11.2756283,2350.595677,4726.554836,7.3939127,419.1832773,266.9522452,594.1011643,15.0822033,21.6142746,2.5948038,59.5767247),(2209,'blackbuck_humerus.tif',237,2,113,146.6661331,90.0346522,48.2646112,1.8,89.8934584,48.1779257,0.5482437,8.6827144,11.3500525,2335.4099283,5036.5558851,6.6400183,443.7473652,268.9723295,635.794912,14.9198024,22.2669275,2.5702552,60.4902931),(2210,'blackbuck_humerus.tif',237,2,114,149.3285151,89.8232294,48.2439593,1.8,89.7477032,48.1917935,0.5138915,8.9236527,11.5538248,2330.9624828,5401.8264704,6.013979,467.5357788,261.2116982,667.3037245,14.9052306,22.8634403,2.5308667,62.1606864),(2211,'blackbuck_humerus.tif',237,2,115,152.1451148,89.6341152,48.2815081,1.8,89.5590649,48.2729752,0.4831012,9.0443465,11.87882,2340.4231536,5837.3555402,5.4717979,491.4087031,258.7719474,686.1879309,14.8086985,23.3912765,2.5186836,63.4526673),(2212,'blackbuck_humerus.tif',237,2,116,153.5890076,89.4512557,48.3397843,1.8,89.2862512,48.3190494,0.4418922,9.2507561,12.2647535,2321.4923393,6212.2425357,4.6815235,506.5118124,250.9516319,692.6607117,14.8325903,24.0001209,2.6030852,64.3662358),(2213,'blackbuck_humerus.tif',237,2,117,155.2140649,89.2029882,48.3986273,1.8,89.0657262,48.415618,0.3939723,9.1731339,12.5524566,2312.6569611,6646.5211804,3.8117482,529.4996339,252.1119805,713.7357773,0.5676187,1.1352373,2.3561945,2.2704746),(2214,'blackbuck_humerus.tif',237,2,118,157.9143938,88.9808989,48.4767996,1.8,88.8814743,48.5376095,0.3573083,9.6377091,12.8359627,2327.6877804,7165.1269288,3.2195511,558.2072122,241.5187841,739.0747094,0.535156,0.7568249,2.3561945,1.5136498),(2215,'blackbuck_humerus.tif',237,2,119,161.1357174,88.7652144,48.611236,1.8,88.5881752,48.7137329,0.3281115,9.4248763,13.0225857,2376.2395697,7745.9351191,2.7889596,594.8077677,252.1242172,776.8632214,0.535156,0.9647662,2.1587989,2.0488058),(2216,'blackbuck_humerus.tif',237,2,120,165.2121814,88.4882082,48.7924661,1.8,88.3442193,48.928415,0.2977294,9.4555436,13.2498818,2440.9629074,8386.8924746,2.3695387,632.9786639,258.1515142,804.0405387,0.267578,0.5983226,2.0344439,1.2919809),(2217,'blackbuck_humerus.tif',237,2,121,171.9357097,88.1559754,48.9702002,1.8,87.9801032,49.2273777,0.2517975,9.5909998,13.9359377,2586.3934973,9132.4884198,1.7787702,655.319265,269.6688104,818.6350494,17.0481422,27.3152452,2.5726095,108.6719982),(2218,'blackbuck_humerus.tif',237,2,122,182.3685127,87.8498202,49.3980694,1.8,87.7036986,49.7479879,0.2152141,10.0911346,14.1346351,2908.72407,10287.7187391,1.3861961,727.8375889,288.2454938,881.0806922,0.267578,0.3784124,2.3561945,0.7568249),(2219,'blackbuck_humerus.tif',237,2,123,205.8260744,88.1436247,50.4831685,1.8,87.8310536,50.816183,0.2864599,11.0277347,15.2265094,3956.087236,12114.7701367,2.7388286,795.636731,358.7397908,1055.3912374,20.4096757,29.257914,2.4468544,145.5773948),(2220,'blackbuck_humerus.tif',237,2,124,231.6621429,88.5544129,52.0209307,1.8,87.9668679,52.0434743,0.3944714,12.4579196,16.4342017,5688.4040114,13782.9330703,5.7028297,838.6737172,456.6094673,1184.2027415,22.0162111,30.5613439,2.436765,137.8255095),(2221,'blackbuck_humerus.tif',237,2,125,252.3379275,88.3099139,53.3674648,1.8,87.195371,53.7174504,0.363772,13.8849741,16.6139776,7975.552519,15138.8276126,5.3241191,911.2103044,574.4016858,1389.8175025,24.5274234,31.4901908,2.4283581,131.3656051),(2222,'blackbuck_humerus.tif',237,2,126,276.4609383,87.0295265,54.9601252,1.8,86.5223433,55.25957,0.085568,15.4417185,16.604684,11147.878973,17858.6002072,0.3365469,1075.5158099,721.9325341,1741.3684914,27.2426848,32.2450921,2.4266658,188.6292087),(2223,'blackbuck_humerus.tif',237,2,127,279.5950642,86.6185631,55.6933544,1.8,86.2815322,56.14991,-0.045327,14.5655497,17.709756,11946.4481263,19222.0605827,0.0956741,1085.3938677,820.185191,1726.2145891,27.2559667,33.0607754,2.4478906,222.2095721),(2224,'blackbuck_humerus.tif',237,2,128,271.5032984,86.4090001,56.2824156,1.8,85.9245221,56.9488131,-0.1626735,15.1887862,17.3938042,12372.7005566,20227.5329343,1.1869249,1162.9159875,814.5944263,1841.9013136,26.729132,33.514612,2.4693455,129.9595271),(2225,'blackbuck_humerus.tif',237,2,129,266.1035084,86.2924245,56.6630144,1.8,85.847964,57.3128826,-0.2234778,14.7688855,17.5301295,12808.9384398,20790.8195947,2.178342,1186.0049059,867.2921474,1878.7360759,27.1070389,33.8768967,2.5075699,141.4955368),(2226,'blackbuck_humerus.tif',237,2,130,271.6790172,86.1980464,56.8449891,1.8,85.7399926,57.2941326,-0.2316702,15.0125227,16.8789056,13010.1728385,20166.5192673,2.3870502,1194.7764708,866.6213592,1859.505391,27.2191859,34.1379618,2.7727306,164.1353578),(2227,'blackbuck_humerus.tif',237,2,131,268.5661971,86.2767604,57.057664,1.8,85.9141213,57.3587388,-0.2019732,15.2772189,16.8247341,12822.0793376,19347.4494543,1.801251,1149.9408772,839.294077,1780.2183176,2.4969509,5.7885972,2.1587989,15.5418029),(2228,'blackbuck_humerus.tif',237,2,132,263.2783386,86.4210955,57.1302254,1.8,86.0211391,57.3614445,-0.1927993,15.0054099,16.9414904,12419.59003,18657.1332623,1.610968,1101.2687059,827.6741611,1709.6508108,2.7017396,5.6445641,2.1193457,19.261002),(2229,'blackbuck_humerus.tif',237,2,133,258.1356071,86.4369848,57.1253502,1.8,86.0928815,57.3636902,-0.1827538,14.7110074,16.5680253,11643.246118,18232.288636,1.4209839,1100.4503141,791.4649101,1648.038118,26.850647,34.0959897,2.5971355,115.174549),(2230,'blackbuck_humerus.tif',237,2,134,254.0183757,86.2244463,57.1345658,1.8,86.047527,57.2891995,-0.1704768,14.6721636,16.4256422,10682.0549384,18006.8340266,1.2185211,1096.2636224,728.049059,1612.265176,26.4374829,33.7869546,2.6283404,112.3689184),(2231,'blackbuck_humerus.tif',237,2,135,247.2331646,86.0197442,57.0323366,1.8,85.8971878,57.1541995,-0.1811008,14.8442852,16.5071928,9637.8565916,17521.9218777,1.3367283,1061.4719361,649.2637714,1568.6753792,25.6824189,33.3443419,2.7461843,109.8498819),(2232,'blackbuck_humerus.tif',237,2,136,240.6236724,85.7078605,56.8874307,1.8,85.6380874,56.9397866,-0.1876755,13.8331312,16.8757126,8347.0958802,17423.713447,1.3960382,1032.4727536,603.4133372,1487.2626149,24.778928,33.1710395,2.8300458,107.9958521),(2233,'blackbuck_humerus.tif',237,2,137,220.3753278,85.5651982,56.6046776,1.8,85.53247,56.6852947,-0.2184354,13.2201492,16.9473474,6402.0417468,16316.6768254,1.7248027,962.786471,484.2639551,1310.3625814,24.1765356,32.6510953,2.9184793,129.813923),(2234,'blackbuck_humerus.tif',237,2,138,180.9623716,86.1141336,56.2345106,1.8,85.8340115,56.5389043,-0.2910988,12.3325149,17.1419956,4086.0276541,13759.0490794,2.484367,802.6515343,331.3215267,1023.0602573,22.5428624,31.4901908,2.927532,125.1654019),(2235,'blackbuck_humerus.tif',237,2,139,97.6555102,89.5457416,54.4037227,1.8,88.2075299,55.2080869,-0.4119504,10.6914829,20.7034024,1890.4146531,6438.7462994,2.6093232,310.9994278,176.8150095,399.4598921,6.6132848,11.1390893,1.9914597,29.4938914),(2236,'blackbuck_humerus.tif',237,2,140,33.1226607,92.9928621,50.1321785,1.8,92.1806216,51.4114418,-0.4621974,9.1846369,25.0977981,380.7307308,851.9463095,1.0976909,33.9450619,41.4529977,49.0217045,6.7309421,16.5487855,1.9693188,42.6353691),(2237,'blackbuck_humerus.tif',237,2,141,17.5456291,94.1282198,49.0123776,1.8,94.0168271,48.9545865,1.1604063,2.3875047,5.043337,19.1630795,80.8566654,2.4588015,16.032374,8.0264049,19.8298327,4.9073291,9.8168677,1.8753072,24.2341496),(2238,'blackbuck_humerus.tif',237,2,142,1.3531369,94.6477712,49.4674228,1.8,94.6062743,49.3972259,1.1614729,1.3147798,2.9257569,0.3999734,2.0587778,0.1898011,0.7036736,0.3042132,0.8398144,2.7931774,5.5162618,1.9693188,13.5198901),(2239,'blackbuck_humerus.tif',237,2,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2240,'blackbuck_humerus.tif',237,2,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2241,'blackbuck_humerus.tif',237,2,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2242,'blackbuck_humerus.tif',237,2,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2243,'blackbuck_humerus.tif',237,2,147,1.8211056,98.548137,52.9277072,1.8,98.5376127,52.9455429,1.5559676,2.500046,2.6239323,2.693998,2.9529353,0.3034509,1.1253854,1.0775794,2.1154316,5.083982,5.6761866,2.3561945,17.2659821),(2244,'blackbuck_humerus.tif',237,2,148,22.7807654,98.5672572,53.0191014,1.8,98.5819534,53.0500749,-1.2621272,6.153166,6.1733388,178.3536973,181.997174,3.4463921,29.4811575,28.9856795,57.5698749,12.3085881,12.8130474,1.0697829,40.9918687),(2245,'blackbuck_humerus.tif',237,2,149,47.2814013,98.5600382,53.0514895,1.8,98.5691135,53.0544534,-0.9398614,8.2267355,8.3044774,705.100084,721.5971883,5.1380542,86.8925465,85.7083688,171.4277087,16.5898361,16.9336924,1.0222469,54.6685024),(2246,'blackbuck_humerus.tif',237,2,150,71.8063805,98.541336,53.0723901,1.8,98.5584321,53.0459108,-1.111818,9.7098868,9.7626906,1533.6027855,1557.5100389,9.6187312,159.5369662,157.9423964,315.1334207,19.5331941,19.9161454,1.0349851,64.3393428),(2247,'blackbuck_humerus.tif',237,2,151,95.8822017,98.5356371,53.081067,1.8,98.5574195,53.0641936,-1.1752215,10.8912403,10.95573,2589.4559994,2619.4693595,13.6075075,239.0958311,237.755842,474.659257,21.9413961,22.210586,1.0262446,72.4696405),(2248,'blackbuck_humerus.tif',237,2,152,116.4674908,98.5361996,53.0796318,1.8,98.5688236,53.0706079,-1.1777558,11.8362987,11.8396562,3750.1563541,3791.8820575,16.563849,320.2696084,316.8352234,631.3166321,23.5468641,24.1354764,1.5042282,78.5511325),(2249,'blackbuck_humerus.tif',237,2,153,134.8392522,98.5456087,53.0336103,1.8,98.5121746,53.0226615,-0.6673259,13.1780554,23.6185908,5001.7765072,5082.730245,8.6077333,215.2004028,379.5534575,423.5546391,25.1523322,25.6554145,1.0464756,83.5892054),(2250,'blackbuck_humerus.tif',237,2,154,548.8477992,78.2499755,54.323951,1.8,83.332345,53.9903084,-0.0643687,16.2841593,33.4851405,27214.3095996,109252.473359,0.3784856,3262.7150988,1671.2136644,4072.2177134,28.8984242,29.257914,2.4468544,95.7521894),(2251,'blackbuck_humerus.tif',237,2,155,604.7345626,77.9771005,54.1434596,1.8,83.7724057,53.9062477,-0.0564028,16.354639,34.2398628,30566.9535835,121160.6734644,0.320299,3538.5852536,1869.0081503,4429.9835846,28.8984242,29.294598,2.4597192,95.7521894),(2252,'blackbuck_humerus.tif',237,2,156,614.6133708,78.2651444,54.1296666,1.8,84.1305454,53.8657381,-0.0560827,16.3697387,34.2483826,31396.0660095,125762.6010225,0.32185,3672.0741683,1917.9332381,4585.1118036,29.2069471,57.0888813,0.1127276,184.0390876),(2253,'blackbuck_humerus.tif',237,2,157,618.9716704,78.3438499,54.187851,1.8,84.2316824,53.9381403,-0.0487483,16.5739888,34.4028025,31740.5057759,127569.1970595,0.2449593,3708.1048034,1915.0794701,4628.1882013,29.2520667,57.2973167,0.1029214,181.5849765),(2254,'blackbuck_humerus.tif',237,2,158,619.4082229,78.3382466,54.245323,1.8,84.2016432,54.0321826,-0.0422095,16.4586801,34.4365236,31706.0498045,127761.2942563,0.1838177,3710.0520286,1926.4029392,4621.1525765,29.2380628,57.3853449,0.1168363,179.8227649),(2255,'blackbuck_humerus.tif',237,2,159,618.8290602,78.3048198,54.2825864,1.8,84.1898784,54.0780504,-0.0378397,16.4452117,34.461298,31536.2028728,127460.9865805,0.147607,3698.6705048,1917.6525983,4602.5639307,29.2096132,57.3853449,0.1168363,179.7578396),(2256,'blackbuck_humerus.tif',237,2,160,618.4999698,78.3040154,54.3034024,1.8,84.1954303,54.1042719,-0.0361724,16.4328841,34.6487796,31462.2776595,127465.7648818,0.1348192,3678.7952227,1914.5925638,4586.6116041,29.1960509,57.4420859,0.0792728,180.4228462),(2257,'blackbuck_radius.tif',237,3,1,2.3238002,93.7653961,73.9595544,1.8,93.5033713,73.8879226,-0.0049667,0.4168283,7.0861647,0.0874446,20.655032,0.0000096,2.9148394,0.2097855,2.9268462,10.8599099,140.0867533,3.1064509,306.6250816),(2258,'blackbuck_radius.tif',237,3,2,2.536165,93.3488262,73.9413228,1.8,93.1895936,73.8834307,-0.0030643,0.3952008,6.9428731,0.1057899,23.6567161,0.000004,3.4073381,0.2676864,3.4218886,11.043424,140.0966269,3.1045003,307.0781285),(2259,'blackbuck_radius.tif',237,3,3,2.6704988,92.9587492,73.9309401,1.8,92.8103762,73.8811128,-0.0025067,0.3843133,7.099619,0.1167906,26.0390651,0.0000028,3.6676708,0.3038944,3.6832663,11.3096105,140.1070335,3.10255,307.0781285),(2260,'blackbuck_radius.tif',237,3,4,2.6756872,92.6851503,73.92997,1.8,92.6702105,73.878815,-0.0013131,0.3797985,6.825834,0.1173604,25.813627,0.0000008,3.7817543,0.3090072,3.7978682,11.3525571,140.1070335,3.10255,307.5311755),(2261,'blackbuck_radius.tif',237,3,5,2.6132443,92.4575714,73.9321893,1.8,92.4799801,73.8815607,-0.0002218,0.3781602,6.8003895,0.1132942,24.5385722,0.00000002152,3.6084069,0.2995931,3.623921,11.2544554,140.1294451,3.0986503,307.7576989),(2262,'blackbuck_radius.tif',237,3,6,2.5349415,92.2224595,73.9430564,1.8,92.2381431,73.8911784,-0.0002293,0.3889377,6.7620645,0.104376,23.3647481,0.00000002212,3.4552684,0.2683617,3.4697304,11.2639983,140.1294451,3.0986503,307.9842224),(2263,'blackbuck_radius.tif',237,3,7,2.3902987,92.0500265,73.9531882,1.8,92.0733521,73.8959958,0.0004916,0.3997553,6.6611683,0.0938388,20.8611584,0.00000009627,3.1317567,0.2347405,3.1450966,11.0098125,140.1179729,3.1006,306.9179523),(2264,'blackbuck_radius.tif',237,3,8,2.2103789,91.9143333,73.9672023,1.8,91.9636375,73.9086864,0.0010609,0.4146559,6.5234903,0.0813952,18.0646315,0.0000004,2.7691666,0.1962958,2.7811121,11.1781126,140.1294451,3.0986503,307.0781285),(2265,'blackbuck_radius.tif',237,3,9,2.2340555,91.8540938,73.9620027,1.8,91.8646554,73.9018814,0.0021609,0.4125398,6.5838773,0.0843822,18.2243228,0.0000017,2.7680228,0.2045432,2.7803345,10.9473313,140.1294451,3.0986503,306.9179523),(2266,'blackbuck_radius.tif',237,3,10,2.0058761,91.7106283,73.9774232,1.8,91.7149763,73.9083614,0.0019974,0.4267489,6.1804162,0.0689614,15.5307109,0.0000013,2.5128908,0.1615972,2.523635,10.981184,140.1294451,3.0986503,307.0781285),(2267,'blackbuck_radius.tif',237,3,11,1.6494577,91.6401127,74.0026191,1.8,91.6716835,73.9331873,0.0016875,0.4500354,5.9774165,0.0470679,11.7727227,0.0000008,1.9695336,0.104587,1.9771888,10.7269982,140.1294451,3.0986503,306.1720347),(2268,'blackbuck_radius.tif',237,3,12,1.3556181,91.5167442,74.0275379,1.8,91.6017343,73.9915667,0.0012106,0.2040114,5.8272739,0.028488,9.1930384,0.0000003,1.5775882,0.1396393,1.582372,10.7365411,140.1179729,3.1006,305.6526405),(2269,'blackbuck_radius.tif',237,3,13,1.2127879,90.3719171,70.0600263,1.8,89.7326643,67.4526581,1.2950769,5.179139,29.8405843,5.9096343,147.7953829,0.1871505,4.9528314,1.1410457,5.1490511,0,0,0,0),(2270,'blackbuck_radius.tif',237,3,14,1.6996884,87.0132915,57.2496815,1.8,87.6181177,59.5344254,1.3171722,4.7129922,18.630577,4.2793051,466.524379,0.2654467,25.0407907,0.9079805,24.4987491,0,0,0,0),(2271,'blackbuck_radius.tif',237,3,15,1.4875956,85.2904249,51.7595998,1.8,86.1228467,54.7011057,1.3096686,4.1615741,24.2023938,2.5529542,348.9508789,0.2314074,14.4180316,0.6134588,14.3264911,0,0,0,0),(2272,'blackbuck_radius.tif',237,3,16,1.5152372,83.6592303,48.0420575,1.8,85.7446128,55.008595,1.2886328,3.5668529,28.1542023,1.3840233,263.5762288,0.2329612,9.3618788,0.3880236,9.3381704,0,0,0,0),(2273,'blackbuck_radius.tif',237,3,17,1.7085247,82.6146715,46.3295292,1.8,85.3864448,54.5617342,1.2588302,9.2793326,30.1132579,1.3805984,228.1934793,0.2579285,7.577841,0.1487821,7.588777,0,0,0,0),(2274,'blackbuck_radius.tif',237,3,18,2.5591619,80.9831126,43.309253,1.8,82.6770213,48.432708,1.237818,1.8383531,33.1081615,0.9580742,101.3779041,0.3809582,3.0620215,0.5211589,3.0877023,11.2109585,24.5942255,1.715838,61.2406845),(2275,'blackbuck_radius.tif',237,3,19,3.915641,80.0867681,42.4157826,1.8,80.1856972,42.817907,1.0297545,5.7919929,32.5285236,1.6523302,7.4309952,0.4794995,0.2284455,0.2852784,0.2749177,10.616058,24.9788281,1.658483,62.0415659),(2276,'blackbuck_radius.tif',237,3,20,5.8026808,79.6108204,42.6609583,1.8,79.5770242,42.6935176,0.5358449,2.0406918,2.7115099,2.2586508,6.1799429,0.2521065,2.2791519,1.1068064,3.088979,10.4774549,25.2290098,1.646737,62.7486182),(2277,'blackbuck_radius.tif',237,3,21,8.8264033,79.1952459,43.0014073,1.8,79.2502322,43.2339129,0.850644,11.2602325,30.4026938,6.6102782,16.9453376,0.8312425,0.557363,0.5870463,0.7265559,9.6156564,25.726434,1.6133239,63.1627999),(2278,'blackbuck_radius.tif',237,3,22,12.1929954,78.8658484,43.4378965,1.8,78.8272171,43.4576406,0.7461838,3.1546862,4.1689408,12.1184723,23.4119655,0.9364744,5.6158066,3.8414192,8.1361312,9.0349971,26.3197404,1.4980085,63.5769815),(2279,'blackbuck_radius.tif',237,3,23,15.9274931,78.60831,43.869461,1.8,78.5957742,43.8551873,0.924285,3.6854479,4.3914166,20.6197235,41.3518416,1.6912546,9.4165153,5.594903,12.8546698,0.5195972,1.222852,2.0344439,2.640551),(2280,'blackbuck_radius.tif',237,3,24,19.6352101,78.4179806,44.3338058,1.8,78.414713,44.3197989,1.0584264,3.8972839,4.6654432,30.9681529,69.4789107,2.486016,14.8922425,7.9460861,18.7350355,8.5258509,27.6510599,1.5213318,65.9910091),(2281,'blackbuck_radius.tif',237,3,25,23.9807464,78.339228,44.9009549,1.8,78.4050218,44.9677517,1.1657851,4.2062563,31.63319,47.2440484,120.5923638,3.3762536,3.81221,11.2318521,5.3054319,0.273438,0.611426,2.0344439,1.3202755),(2282,'blackbuck_radius.tif',237,3,26,29.2963227,78.1277126,45.5295595,1.8,78.1902508,45.5009805,1.2466876,4.6175047,30.1564007,71.0308434,190.0319672,4.387518,6.3015467,15.3829498,8.6569524,7.6562644,29.2783042,1.5334305,66.8857196),(2283,'blackbuck_radius.tif',237,3,27,34.8251927,77.9156093,46.2572762,1.8,78.0075337,46.111502,1.2826158,4.9404663,6.2712582,104.7690385,292.0111805,5.3353684,46.5634119,21.2063056,58.2547922,7.6562644,29.3204101,1.6361238,66.592849),(2284,'blackbuck_radius.tif',237,3,28,42.094466,77.8309282,46.959325,1.8,78.0267353,46.9921652,1.3033576,5.2135907,7.5556403,157.5694903,453.7321855,6.5258035,60.0521161,30.2228346,79.486781,8.1873628,29.4120685,1.6732402,67.8192954),(2285,'blackbuck_radius.tif',237,3,29,51.2176317,77.7986182,47.8209842,1.8,77.9641198,47.6516847,1.2514339,5.9836556,7.3601905,247.3377023,656.7313389,7.694837,89.227492,41.3355515,117.1323293,8.8450155,28.8162673,1.6563016,67.3387665),(2286,'blackbuck_radius.tif',237,3,30,54.8937874,77.4185332,47.7199529,1.8,77.538598,47.5135905,1.2591485,6.2874227,7.2131779,366.6294078,603.8335628,8.2887753,83.7125569,58.3115575,126.5151903,10.6056635,27.6294195,1.6004906,66.350227),(2287,'blackbuck_radius.tif',237,3,31,47.9266915,77.364589,46.8024491,1.8,77.3222408,46.729877,0.5703448,7.0778301,7.4167989,319.9022165,457.6598451,2.3285669,61.705845,45.1977813,102.8436507,11.317711,24.6473694,1.5152978,62.3230532),(2288,'blackbuck_radius.tif',237,3,32,43.1755936,77.548364,45.8777371,1.8,77.4673004,45.7443107,0.3572794,5.4192462,6.7567906,216.402744,427.0228927,0.8801259,63.1990714,39.9322595,93.7399227,11.4604543,22.1197663,1.7196863,57.6551744),(2289,'blackbuck_radius.tif',237,3,33,37.0865501,77.723551,45.1205197,1.8,77.7054239,45.0248187,0.2706598,4.7264096,6.7395147,141.9705646,364.6381877,0.4418571,54.1045169,30.037719,73.2844458,11.3009112,20.3780126,1.773455,54.1473947),(2290,'blackbuck_radius.tif',237,3,34,33.7980343,77.8268353,44.6618837,1.8,77.8729063,44.621724,0.2172958,4.1686865,6.708783,99.748764,337.6359541,0.2618163,50.3274519,23.9281042,63.2145765,11.1399095,19.2341826,1.8295672,51.7997144),(2291,'blackbuck_radius.tif',237,3,35,32.0490667,78.052056,44.4602409,1.8,78.1682582,44.4823624,0.2170708,4.021429,6.7671287,78.611965,336.8035367,0.2477621,49.7705231,19.5482664,60.8339041,11.2166429,18.3712906,1.8266049,49.8387337),(2292,'blackbuck_radius.tif',237,3,36,31.9288709,78.3424305,44.3670901,1.8,78.4899241,44.3677741,0.2337241,3.8359478,6.9790012,71.6160269,345.2790742,0.2854413,49.4739956,18.6697083,59.4428395,11.418755,17.7313535,1.9169323,48.1981057),(2293,'blackbuck_radius.tif',237,3,37,31.618333,78.635628,44.3863186,1.8,78.729298,44.3605324,0.2567224,3.8711431,7.2743221,70.5016848,352.6416222,0.3397451,48.4775923,18.2121101,58.1550843,11.0415344,17.1635453,1.9631365,47.3308771),(2294,'blackbuck_radius.tif',237,3,38,32.9743363,78.8134726,44.442318,1.8,78.8447993,44.4372922,0.2694731,3.9964814,6.8170085,76.8770657,391.2423635,0.3895093,57.39209,19.2361874,68.1765825,11.1547648,16.9112071,1.9693188,47.1043536),(2295,'blackbuck_radius.tif',237,3,39,33.9634536,78.9083789,44.5398132,1.8,78.9511309,44.508022,0.2832733,4.1900207,7.0557525,87.0704163,445.9473472,0.4422056,63.2033717,20.7804263,75.0567868,11.1618702,16.7691309,1.9906763,48.5848054),(2296,'blackbuck_radius.tif',237,3,40,37.0510011,78.8408863,44.6918669,1.8,78.8680337,44.7578636,0.2956926,4.480968,7.4236547,110.7061037,532.7704478,0.5243669,71.7665986,24.7058458,85.4247521,11.8164281,16.8824447,2.0054665,50.4908222),(2297,'blackbuck_radius.tif',237,3,41,43.8147723,78.5898945,44.9298641,1.8,78.5112492,45.1067183,0.2787285,4.7108274,8.5456587,152.4083922,732.1488563,0.552785,85.6749472,32.3527864,99.7787989,13.6422395,17.0016008,2.0560233,55.1312192),(2298,'blackbuck_radius.tif',237,3,42,11.5690876,74.719239,52.1837284,1.8,74.2547487,52.1384389,-0.5221542,10.8457975,12.319375,299.1198881,447.9261382,0.479635,36.3594855,27.5793354,59.603641,0,0,0,0),(2299,'blackbuck_radius.tif',237,3,43,63.5531627,73.4667693,52.7682164,1.8,73.241624,52.724865,-0.1746828,11.7103955,14.16742,1430.6439404,3120.6539335,0.3199368,220.2697411,122.1687127,320.2801588,8.1627349,13.1534769,0.7559949,38.7685188),(2300,'blackbuck_radius.tif',237,3,44,142.6012497,74.1487711,53.6939192,1.8,74.7896722,54.0311846,0.1276443,11.054046,13.6680371,3074.373831,6912.3459207,0.3851368,505.7306974,278.1220394,666.5254711,17.6216601,28.6079416,2.5191209,99.6613689),(2301,'blackbuck_radius.tif',237,3,45,211.1300193,75.7144208,54.4026592,1.8,75.9097965,54.4144049,0.2961262,11.3186792,16.2118642,3972.5693881,12599.7623005,2.9965443,777.1939197,350.9746441,1018.5233714,18.1617423,31.3453481,2.7286827,90.380575),(2302,'blackbuck_radius.tif',237,3,46,226.3022842,76.2696347,54.5594708,1.8,75.799437,54.2672763,0.3717274,10.9506685,17.1383206,3886.2269014,16447.242905,4.9761114,959.6764655,354.8849,1183.9742225,17.2042985,32.0669467,2.7199051,89.1266467),(2303,'blackbuck_radius.tif',237,3,47,203.54144,76.1785662,54.629249,1.8,75.7023082,54.2424824,0.3873803,10.5421615,16.9456759,3537.9741035,14474.5163489,4.8410894,854.1716733,335.6023443,1059.8779442,16.5904711,31.7941512,2.677945,85.7126962),(2304,'blackbuck_radius.tif',237,3,48,190.1386474,76.2842431,54.5710041,1.8,75.8947688,54.2643717,0.404813,10.557835,16.2500212,3431.4052714,12440.0608243,4.9155721,765.541208,325.0103131,976.5910196,16.2416797,30.3134126,2.7627613,81.4040351),(2305,'blackbuck_radius.tif',237,3,49,170.8759876,76.4940671,54.5615609,1.8,76.2970213,54.2192868,0.4284584,10.1080497,14.9772548,3271.2565317,10074.2338936,4.915947,672.6355433,323.6288536,887.8746399,16.2584597,28.3664758,2.8381327,76.57598),(2306,'blackbuck_radius.tif',237,3,50,146.5666003,77.0150506,54.7682315,1.8,76.6742778,54.3573426,0.4242645,9.8316443,14.0471379,3017.8490168,8478.2298115,4.139437,603.5556777,306.9526252,817.7530131,16.0878786,26.7592313,2.7648813,72.7753297),(2307,'blackbuck_radius.tif',237,3,51,136.8995968,77.5063702,55.1974198,1.8,77.1455124,54.8346436,0.3929222,9.7582907,13.4560724,2712.1163978,7407.3076046,3.3450134,550.4806596,277.9294531,752.0339146,0.273438,0.3866997,2.3561945,0.7733995),(2308,'blackbuck_radius.tif',237,3,52,128.4369755,77.7103637,55.6753844,1.8,77.4004814,55.2497706,0.3833918,9.7478933,12.9155601,2378.7406585,6363.9088347,2.9952999,492.731929,244.0261279,663.2256935,16.7800221,24.4891182,2.8586918,75.7750986),(2309,'blackbuck_radius.tif',237,3,53,121.2119289,77.5992926,56.1065571,1.8,77.3985257,55.7313917,0.3998819,9.5990754,12.2881064,2097.8506833,5437.5687035,3.0618523,442.5066438,218.5471613,602.3926212,15.0190008,23.4408315,2.8456666,63.5334011),(2310,'blackbuck_radius.tif',237,3,54,117.3123064,77.6093532,56.4986587,1.8,77.3314914,56.0817647,0.4117644,10.3108529,12.0326013,1909.8203884,4842.5840838,3.1318778,402.4552918,185.2242887,495.0942629,14.7016316,22.6607371,2.7969453,61.9591202),(2311,'blackbuck_radius.tif',237,3,55,115.5194521,77.7049329,56.8737394,1.8,77.5281024,56.5890299,0.4072454,9.1805955,11.6032778,1756.6897638,4444.4311053,3.0204597,383.0323792,191.3481287,525.5297708,0.273438,0.611426,2.0344439,1.3202755),(2312,'blackbuck_radius.tif',237,3,56,114.7058819,77.7606753,57.1795926,1.8,77.6542255,56.8414178,0.4022275,9.2058078,11.3390938,1661.3422916,4134.1043824,2.9297412,364.5886047,180.4667588,495.1850215,13.7256752,21.5392106,2.7917371,58.1196047),(2313,'blackbuck_radius.tif',237,3,57,109.113776,77.9087881,57.4800089,1.8,77.8423287,57.0802452,0.3746235,9.308132,10.9180349,1541.7501582,3771.7326252,2.4350385,345.4589274,165.634754,441.3820965,0.273438,0.3866997,2.3561945,0.7733995),(2314,'blackbuck_radius.tif',237,3,58,108.2906898,78.0114543,57.7631763,1.8,77.9272124,57.3484701,0.3501627,8.7663233,10.6595727,1472.7247709,3548.4767447,2.1240084,332.8910885,167.9979991,465.6083301,13.3382806,20.5860873,2.8450468,56.1861059),(2315,'blackbuck_radius.tif',237,3,59,107.2778052,78.0552084,58.071445,1.8,77.8935027,57.6060275,0.3348913,9.3538219,10.3704583,1397.8109218,3362.30643,1.9313881,324.2196565,149.4374102,417.6200541,13.2704362,20.2602622,2.7686049,56.1197588),(2316,'blackbuck_radius.tif',237,3,60,105.8162653,78.1318185,58.4606663,1.8,78.1003303,58.1384892,0.3059661,9.4175765,10.0982053,1301.8129022,3208.7854714,1.6001218,317.7579947,138.2322625,427.6758059,12.8983553,19.9759522,2.8068558,54.5729598),(2317,'blackbuck_radius.tif',237,3,61,106.0580389,78.1709346,58.7575727,1.8,78.1021591,58.3736809,0.2870674,8.7702255,9.8529822,1241.0512705,3107.9687715,1.4170901,315.4343225,141.5073395,399.8887723,12.3658985,19.7178955,2.8023,53.2526843),(2318,'blackbuck_radius.tif',237,3,62,105.4843618,78.2205741,59.0379134,1.8,78.2601834,58.9001179,0.272039,8.7075925,10.299983,1187.6258383,3017.4750964,1.2692856,292.959232,136.3896888,401.7668439,12.2699613,19.6285835,2.8154368,53.092508),(2319,'blackbuck_radius.tif',237,3,63,106.3233986,78.264768,59.2840439,1.8,78.1965477,59.1144242,0.2595039,8.4856729,9.7871352,1154.5199833,2949.781472,1.166795,301.3937598,136.0552063,392.4543672,12.1943357,19.3813357,2.8555412,52.4792848),(2320,'blackbuck_radius.tif',237,3,64,106.6057284,78.290743,59.5085126,1.8,78.2993265,59.3710743,0.2601765,8.1517477,10.1508956,1137.5168998,2878.1713405,1.1758282,283.5386611,139.5427026,382.0441121,0.546876,1.222852,2.0344439,2.640551),(2321,'blackbuck_radius.tif',237,3,65,104.773043,78.3722048,59.7267895,1.8,78.4204174,59.5380538,0.2500119,9.0036408,9.950406,1098.8827503,2746.1213071,1.0689372,275.9808293,122.0487099,379.541768,0.6931235,2.0824419,1.9756881,4.734226),(2322,'blackbuck_radius.tif',237,3,66,104.6243446,78.3862007,59.9245605,1.8,78.3989572,59.7709926,0.2465526,8.0963641,9.6722351,1092.9991755,2665.5467815,1.0386827,275.5874687,134.9987673,382.031034,12.2038106,18.7639054,2.8152338,51.3855327),(2323,'blackbuck_radius.tif',237,3,67,107.4971257,78.4163547,60.0013237,1.8,78.5176575,59.7806785,0.2517201,8.3901651,9.9182366,1149.9618625,2639.2993155,1.1114481,266.1057034,137.0606949,380.132666,12.9484571,18.5957953,2.7965905,51.3855327),(2324,'blackbuck_radius.tif',237,3,68,107.4964687,78.4812902,60.2481366,1.8,78.5847522,59.6938504,0.2294042,10.7298034,9.5585371,1131.9424382,2624.527532,0.9264324,274.5741858,105.4951704,303.6115909,0.273438,0.8646869,1.8925469,1.8671515),(2325,'blackbuck_radius.tif',237,3,69,106.5623854,78.5431371,60.5571972,1.8,78.6686603,60.3659016,0.1988452,8.8554496,9.6381196,1050.694329,2609.2026474,0.693029,270.7169822,118.6494615,347.3509423,12.3402533,18.5172255,2.8572079,52.0651031),(2326,'blackbuck_radius.tif',237,3,70,107.6663741,78.5828977,60.7332608,1.8,78.7313542,60.5830107,0.188557,9.0022209,9.5470385,1063.4665634,2626.3701015,0.6304654,275.0978861,118.1337996,371.5940847,12.4044322,18.5051082,2.8104966,51.6784034),(2327,'blackbuck_radius.tif',237,3,71,108.1356247,78.617869,60.9155321,1.8,78.7346629,60.6903978,0.1760383,9.1524011,9.6591405,1055.4581479,2643.7345873,0.5527655,273.7028803,115.3203552,362.390496,13.0169234,18.7320007,2.5535901,64.560806),(2328,'blackbuck_radius.tif',237,3,72,107.6880342,78.674727,61.1583506,1.8,78.8230221,60.9118148,0.1543693,8.4889907,9.629246,1010.2472552,2646.644893,0.4243123,274.8548436,119.006757,343.1398199,12.2449155,18.4484556,2.9325697,51.9987559),(2329,'blackbuck_radius.tif',237,3,73,106.2971391,78.7548611,61.3494104,1.8,78.8944551,61.221911,0.1411538,8.3773858,9.6887609,981.2359108,2627.9952204,0.3506463,271.2416232,117.1291301,352.4322827,11.7537272,18.484895,3.0080636,51.545709),(2330,'blackbuck_radius.tif',237,3,74,106.6368592,78.7899653,61.5274233,1.8,78.9538007,61.3857183,0.129852,8.2278106,9.7209108,972.9427238,2617.7287835,0.2979963,269.2884263,118.2505009,359.7692054,0.273438,0.611426,2.0344439,1.3202755),(2331,'blackbuck_radius.tif',237,3,75,105.4373484,78.8223898,61.7622083,1.8,79.0123894,61.6630087,0.1158527,8.3195194,9.7100442,933.0913791,2611.8507962,0.2348075,268.9844388,112.1568847,340.2572056,0.546876,1.4725088,1.9513027,3.1874271),(2332,'blackbuck_radius.tif',237,3,76,105.3146603,78.8399686,61.9540577,1.8,79.0252007,61.8295401,0.1078046,7.9560229,9.7098441,920.6337551,2608.4693486,0.2032026,268.6417346,115.7153224,338.7231468,0.273438,0.8646869,1.8925469,1.8671515),(2333,'blackbuck_radius.tif',237,3,77,105.0771009,78.838672,62.1701575,1.8,78.9455687,62.0995906,0.1033167,8.0138358,9.7393157,894.8457091,2617.9194723,0.1862741,268.7991191,111.6625957,341.5027291,11.3986671,18.6439814,3.0681953,51.6784034),(2334,'blackbuck_radius.tif',237,3,78,104.2852588,78.8413547,62.3916666,1.8,78.9516148,62.248758,0.0942941,8.5146435,9.7047361,862.0250434,2624.2482355,0.1540826,270.4090271,101.240298,344.2946944,0.273438,0.8646869,1.8925469,1.8671515),(2335,'blackbuck_radius.tif',237,3,79,104.9439,78.8314668,62.5534523,1.8,78.9405892,62.4071758,0.0895267,7.8236553,9.7046138,858.2119904,2635.3121953,0.1398139,271.5525056,109.6945046,354.7061344,11.09407,18.6920433,3.0390128,51.0651802),(2336,'blackbuck_radius.tif',237,3,80,105.5664484,78.8169417,62.698471,1.8,78.9149001,62.538377,0.0875963,7.8057823,9.7084662,858.5511176,2656.828012,0.134659,273.6609428,109.9891184,355.6754269,0.273438,0.611426,2.0344439,1.3202755),(2337,'blackbuck_radius.tif',237,3,81,104.8499184,78.835726,62.8190005,1.8,78.9521446,62.6944059,0.084588,8.3165871,9.7077314,855.377458,2648.7769786,0.1247379,272.8523146,102.8519812,349.9581697,0.273438,0.611426,2.0344439,1.3202755),(2338,'blackbuck_radius.tif',237,3,82,105.6633074,78.8259009,62.9451706,1.8,78.9121157,62.9003438,0.0824995,7.6578042,9.7077746,857.8394651,2662.5973036,0.1195888,274.2747344,112.0215977,353.3017462,0.273438,0.611426,2.0344439,1.3202755),(2339,'blackbuck_radius.tif',237,3,83,105.6372518,78.817848,63.0834506,1.8,78.926527,63.0548807,0.0814519,8.0510406,9.7057304,853.8047985,2676.189931,0.1165486,275.732976,106.0489986,338.4101304,11.0602303,18.9640646,0.1011034,51.1590092),(2340,'blackbuck_radius.tif',237,3,84,108.0969944,78.8150839,63.1630722,1.8,78.8657041,63.094301,0.0821977,8.0634139,9.7010053,872.695357,2710.7252621,0.1214518,279.4272534,108.2290167,357.6170407,12.5816018,18.9936114,0.1154267,62.7211363),(2341,'blackbuck_radius.tif',237,3,85,108.9768366,78.8042209,63.2729758,1.8,78.9615688,63.1826879,0.0810767,8.2206143,9.7044355,889.5346138,2749.2469658,0.1191304,283.2979787,108.2078028,351.2321434,11.7713189,19.0270422,0.1297025,51.9987559),(2342,'blackbuck_radius.tif',237,3,86,110.5318596,78.797586,63.333197,1.8,78.9352385,63.1914396,0.0827799,8.0230345,9.9165301,915.6707878,2774.6531452,0.1259488,279.8008079,114.1302322,355.3114418,11.9640327,19.0270422,0.1297025,53.092508),(2343,'blackbuck_radius.tif',237,3,87,111.8252614,78.8195385,63.4166285,1.8,78.9696804,63.274314,0.0815846,8.1098378,9.9453265,927.4454043,2812.338997,0.1237775,282.7799564,114.3605365,367.4555277,0.546876,0.7733995,2.3561945,1.546799),(2344,'blackbuck_radius.tif',237,3,88,110.5071408,78.8320232,63.5868608,1.8,78.9119863,63.6460337,0.0788401,7.2175634,9.9062622,873.5301133,2815.3648643,0.114244,284.2005193,121.0283944,363.4645078,11.4123061,19.2652556,0.113792,51.6120562),(2345,'blackbuck_radius.tif',237,3,89,110.281431,78.8917427,63.6262991,1.8,79.0132504,63.7314723,0.0801182,7.5206141,9.9903175,882.5391433,2806.6769149,0.1177291,280.939712,117.3493461,363.7579858,11.3239816,19.2982159,0.1278699,51.7722325),(2346,'blackbuck_radius.tif',237,3,90,110.3535484,78.8889381,63.6928344,1.8,79.0126937,63.8141503,0.082218,7.4099026,9.8339245,892.5413407,2795.7467986,0.124048,284.2961431,120.4525065,363.1305962,11.4432104,19.2982159,0.1278699,51.7722325),(2347,'blackbuck_radius.tif',237,3,91,109.1433435,78.8921399,63.8277536,1.8,78.9613201,63.9969986,0.0789236,7.6782013,10.0069938,865.6848765,2778.0476507,0.1130727,277.6106111,112.7457909,359.7765123,11.4517832,19.2108448,0.0855053,51.7722325),(2348,'blackbuck_radius.tif',237,3,92,109.7909733,78.8895807,63.8489964,1.8,78.9495743,63.8863604,0.0799655,7.6697195,10.0060031,882.3229101,2771.6933852,0.1167601,277.0030515,115.0397879,360.6019008,11.5111213,19.2361261,0.0996687,52.0651031),(2349,'blackbuck_radius.tif',237,3,93,109.2224166,78.9068803,63.9471837,1.8,78.9621171,64.0688687,0.077546,7.5582601,9.9757968,862.349803,2755.6271403,0.1092468,276.2312821,114.0936931,361.567337,11.062882,19.2652556,0.113792,51.4518799),(2350,'blackbuck_radius.tif',237,3,94,109.5554983,78.8807519,63.9924773,1.8,78.9014057,64.0985905,0.0794164,7.2751905,10.0614597,871.2589981,2744.9065015,0.1149184,272.8139429,119.7575517,332.3157747,11.119733,19.2361261,0.0996687,51.4518799),(2351,'blackbuck_radius.tif',237,3,95,109.2693394,78.8667125,64.0702133,1.8,78.8134955,64.2392227,0.0801273,7.4362304,9.3290267,861.7324518,2733.7772754,0.1166753,293.0399243,115.8829687,357.7159864,10.8032288,19.0270422,0.1297025,50.7059623),(2352,'blackbuck_radius.tif',237,3,96,110.8339011,78.8476684,64.1005516,1.8,78.7921954,64.2558943,0.080499,7.2950551,9.3228631,869.1146177,2730.3092783,0.1194438,292.8616728,119.1374995,366.6491608,10.8507108,18.9936114,0.1154267,50.7059623),(2353,'blackbuck_radius.tif',237,3,97,110.1571343,78.8672031,64.0884382,1.8,78.8175346,64.2654623,0.0810883,7.5080788,9.3182297,873.2161101,2698.109088,0.1204552,289.5516815,116.3035349,354.9909867,10.8843421,18.9936114,0.1154267,50.7723095),(2354,'blackbuck_radius.tif',237,3,98,110.6334086,78.868576,64.0754401,1.8,78.9220813,64.1612278,0.0791293,7.5942368,10.4053249,904.5163287,2674.5133497,0.1152133,257.0331416,119.1056255,339.2782834,11.3235918,18.9640646,0.1011034,51.4518799),(2355,'blackbuck_radius.tif',237,3,99,109.9930064,78.8526596,64.116071,1.8,78.9106386,64.2839977,0.0838639,7.731118,10.2635367,902.2642211,2655.9552738,0.1286309,258.7758338,116.7055303,346.671439,11.1623076,18.7559343,0.1315881,50.998833),(2356,'blackbuck_radius.tif',237,3,100,109.8550928,78.8340963,64.1270503,1.8,78.8294544,64.2766649,0.0854692,7.5634745,10.2461136,906.8977168,2634.5558657,0.1334229,257.1273321,119.9049085,345.6258163,11.1623076,18.7220194,0.1171087,51.1590092),(2357,'blackbuck_radius.tif',237,3,101,109.8499723,78.8131455,64.1097897,1.8,78.7601425,64.2144988,0.0884435,7.9002295,9.5584382,918.5173903,2617.1604733,0.1428393,273.8062883,116.2646466,352.2822958,11.2121377,18.6660252,0.0880074,50.6121332),(2358,'blackbuck_radius.tif',237,3,102,109.5315045,78.8004887,64.1078976,1.8,78.7588957,64.2150677,0.0894583,7.3362364,9.3206957,922.219911,2599.14704,0.1457037,278.8576217,125.7074961,351.7555409,11.2619678,18.484895,3.0080636,50.2254335),(2359,'blackbuck_radius.tif',237,3,103,109.4323571,78.7880714,64.097603,1.8,78.7155448,64.2139271,0.0897248,7.6632192,9.6560671,930.2282835,2583.8698479,0.1464381,267.5902947,121.3887091,348.031239,11.2619678,18.4504819,3.0227523,50.3856098),(2360,'blackbuck_radius.tif',237,3,104,109.0886719,78.7880265,64.0783792,1.8,78.7152704,64.1744811,0.0881711,7.7364807,9.4753237,932.1695466,2559.8336941,0.1409792,270.157915,120.4901271,347.7970283,11.2734975,18.6118712,3.0975036,50.4519569),(2361,'blackbuck_radius.tif',237,3,105,107.5364357,78.7967518,64.0207836,1.8,78.7175806,64.1700019,0.085104,7.6260644,10.2230811,926.2891754,2530.5073463,0.1294957,247.5288348,121.4635919,337.8574477,11.2136439,18.6118712,3.0975036,50.6121332),(2362,'blackbuck_radius.tif',237,3,106,107.4308991,78.7751316,63.9788561,1.8,78.718649,64.0894089,0.0807387,7.7350815,10.1969087,941.731671,2510.9198142,0.1164657,246.2432385,121.748125,338.4822031,11.4005738,18.6118712,0.0440891,51.0651802),(2363,'blackbuck_radius.tif',237,3,107,105.9795775,78.7614114,63.9558352,1.8,78.7540299,64.0850446,0.0779984,7.7050493,10.1806675,943.1094305,2501.8320033,0.1072412,245.7434145,122.401479,338.259419,11.4362646,18.420064,3.0374927,50.6784804),(2364,'blackbuck_radius.tif',237,3,108,106.879222,78.7170905,63.8808857,1.8,78.6867586,63.9896591,0.0801058,7.8317527,10.1310433,969.6497489,2509.1169624,0.1140621,247.6661958,123.8100566,343.3227413,11.5836851,18.420064,3.0374927,50.4519569),(2365,'blackbuck_radius.tif',237,3,109,106.8182518,78.6984086,63.8515628,1.8,78.6742647,63.9545309,0.0755781,7.6349208,10.1092817,970.974862,2515.0426984,0.1014985,248.7854998,127.1754993,344.7671891,11.5836851,18.420064,3.0374927,50.4519569),(2366,'blackbuck_radius.tif',237,3,110,106.670437,78.6827653,63.8238575,1.8,78.6564974,63.9175279,0.0709355,7.8312279,10.0906856,976.304827,2515.4816954,0.0893082,249.2874915,124.6681663,340.77063,11.524852,18.420064,0.1040999,50.4519569),(2367,'blackbuck_radius.tif',237,3,111,106.505199,78.672013,63.7808464,1.8,78.6301563,63.8571276,0.0679582,7.6936338,10.0763422,978.1831873,2513.6998203,0.081853,249.4655068,127.1418953,346.4700829,11.5368986,18.420064,0.1040999,50.4519569),(2368,'blackbuck_radius.tif',237,3,112,106.6463299,78.6539708,63.7071473,1.8,78.6055334,63.7630339,0.0705407,7.6921622,10.0536496,992.7890006,2514.6872198,0.0882986,250.1268005,129.0650107,337.7935288,11.5584372,18.3936611,0.089314,50.0652572),(2369,'blackbuck_radius.tif',237,3,113,105.0219536,78.686685,63.6034974,1.8,78.657121,63.7233905,0.0688174,7.9855148,10.078958,987.8475322,2487.0271314,0.0827635,246.7543902,123.7049276,344.764608,11.5219316,18.3712906,3.0671039,50.2254335),(2370,'blackbuck_radius.tif',237,3,114,105.3685615,78.6662625,63.5356589,1.8,78.6281103,63.6601358,0.0664117,7.8269772,9.3080808,998.7621748,2465.6952153,0.0773413,264.8983478,127.6050962,358.6892689,11.6299057,18.3712906,0.0744888,50.4519569),(2371,'blackbuck_radius.tif',237,3,115,103.5985908,78.6550265,63.4426728,1.8,78.6323992,63.5650489,0.0706037,7.6227368,9.3875475,1013.1024143,2452.7941459,0.0859281,261.2816766,132.9053385,352.6737462,11.8026822,18.1790014,0.1206237,50.2917807),(2372,'blackbuck_radius.tif',237,3,116,102.9681804,78.6523567,63.3817892,1.8,78.6411384,63.5058477,0.06774,7.6740959,9.6312183,1015.4842234,2448.2096706,0.0786282,254.195222,132.3262363,358.168533,11.8245634,18.2139275,0.1355277,50.4519569),(2373,'blackbuck_radius.tif',237,3,117,102.0419592,78.6684543,63.3322417,1.8,78.7251682,63.5006686,0.0644743,8.4974012,9.7526201,1018.186568,2434.2990933,0.070599,249.6046263,119.8232896,353.6106937,11.6691318,18.2139275,0.1355277,50.2254335),(2374,'blackbuck_radius.tif',237,3,118,102.881585,78.6478155,63.2151367,1.8,78.7242694,63.3815054,0.0703807,7.7715726,9.7401317,1062.4471635,2434.3236667,0.0847961,249.9271823,136.7094172,358.7595822,12.0312726,18.1790014,0.1206237,50.6121332),(2375,'blackbuck_radius.tif',237,3,119,102.3782581,78.6613367,63.1503257,1.8,78.7463817,63.2778332,0.0673509,7.8643638,9.1661478,1066.8146126,2427.9262196,0.0772833,264.8796703,135.6517377,373.6276137,12.0312726,18.1790014,0.1206237,50.2917807),(2376,'blackbuck_radius.tif',237,3,120,101.9514895,78.6704748,63.0598019,1.8,78.6852869,63.1881337,0.069435,7.7743573,9.1995521,1066.7600019,2424.2149327,0.0817901,263.5144529,137.2152021,356.3541149,12.0478858,18.1481285,0.1056656,50.6784804),(2377,'blackbuck_radius.tif',237,3,121,100.1713684,78.7523991,62.9266211,1.8,78.805808,63.0690721,0.0665242,7.6582106,9.0808341,1049.2746703,2390.0353959,0.0737753,263.1955811,137.0130338,347.2843717,11.8861407,18.1213294,0.0906599,50.4519569),(2378,'blackbuck_radius.tif',237,3,122,100.821921,78.7328161,62.7679801,1.8,78.7910454,62.8983457,0.0814829,8.1969241,9.5435873,1089.4822384,2380.7384844,0.1113206,249.4594969,132.9135453,361.9018124,12.149525,17.9825777,0.1526493,50.3856098),(2379,'blackbuck_radius.tif',237,3,123,99.7470014,78.7579068,62.6932832,1.8,78.8330237,62.8398032,0.0775816,8.1457024,9.5279191,1081.4695109,2359.7282963,0.0998607,247.6646035,132.7656547,345.4155331,12.0710964,17.9825777,0.1526493,50.2254335),(2380,'blackbuck_radius.tif',237,3,124,98.9561562,78.7682223,62.6037256,1.8,78.808223,62.7430004,0.0801439,7.9093631,9.4809991,1082.3344632,2351.3020302,0.1057066,248.0015038,136.8421765,356.5152967,12.1284801,17.9430349,0.1375867,50.0652572),(2381,'blackbuck_radius.tif',237,3,125,98.4380795,78.8046098,62.5187604,1.8,78.8521647,62.7093493,0.0755896,7.6499649,8.9413056,1077.1181537,2342.7701732,0.0935638,262.0165648,140.8004054,353.7137747,12.0312726,17.9075805,0.1224611,50.1590863),(2382,'blackbuck_radius.tif',237,3,126,98.2834903,78.83012,62.4320297,1.8,78.8884303,62.6336214,0.0650423,7.8061116,9.0010453,1086.0188,2346.7514051,0.0692004,260.7198736,139.1241698,355.7046465,12.0312726,17.8049934,0.1853479,49.7723865),(2383,'blackbuck_radius.tif',237,3,127,98.7466236,78.8516598,62.3002474,1.8,78.9323937,62.4772748,0.0712117,9.6346148,11.4763537,1110.6312421,2357.6381119,0.0833181,205.4344243,115.2751056,231.4585433,12.2262194,17.8049934,0.1853479,49.8387337),(2384,'blackbuck_radius.tif',237,3,128,98.1316426,78.8916075,62.2119754,1.8,78.9264985,62.3624149,0.0648816,7.9404985,9.4808565,1113.9185718,2354.6618924,0.0687529,248.3596161,140.2832047,352.0677824,12.0312726,17.8762388,0.1072789,50.1590863),(2385,'blackbuck_radius.tif',237,3,129,98.6358758,78.9459406,61.9844139,1.8,79.0552867,62.0697544,0.0740529,7.9378499,9.4198445,1154.5243512,2356.7327627,0.0899858,250.1880739,145.4454751,369.0714458,12.3659854,17.8049934,0.1853479,50.3856098),(2386,'blackbuck_radius.tif',237,3,130,97.9664499,78.9965084,61.8947141,1.8,79.0926562,61.957072,0.0671479,8.0143294,9.4206049,1151.8068582,2353.4373728,0.0735087,249.8180746,143.7184331,364.5047566,12.3551844,17.7566359,0.1702119,50.545786),(2387,'blackbuck_radius.tif',237,3,131,98.4067675,79.0262361,61.7511868,1.8,79.1377394,61.7397813,0.0752945,8.26691,9.4823108,1188.2607543,2365.9915096,0.0928066,249.5163422,143.7369888,370.2740523,12.7798814,17.7081463,0.2337432,50.998833),(2388,'blackbuck_radius.tif',237,3,132,98.285099,79.0772642,61.6776439,1.8,79.1689494,61.6952496,0.0624753,8.2244896,9.3419491,1192.1018484,2382.9494279,0.0638541,255.080541,144.9453886,382.283174,0.273438,0.611426,2.0344439,1.3202755),(2389,'blackbuck_radius.tif',237,3,133,98.5897007,79.1297308,61.5898976,1.8,79.2324748,61.6458909,0.0601436,8.3356648,9.4886377,1210.9368266,2402.0761965,0.0593658,253.1529042,145.2717755,375.0553702,12.6302045,17.7734708,0.24871,51.0263149),(2390,'blackbuck_radius.tif',237,3,134,98.7082198,79.1845355,61.4881217,1.8,79.3157487,61.4611362,0.0513267,8.4950287,9.5557973,1228.5572149,2432.348048,0.043302,254.5416109,144.6207254,377.4285605,12.6933622,17.915929,0.2782997,51.4130146),(2391,'blackbuck_radius.tif',237,3,135,99.4254975,79.2092053,61.322436,1.8,79.3067363,61.2615812,0.0618491,8.5179689,9.4857523,1264.3132891,2477.5318503,0.0633082,261.1845408,148.4289627,394.3427807,12.7361374,17.9929692,0.2929124,51.6395381),(2392,'blackbuck_radius.tif',237,3,136,99.3080206,79.2639658,61.2249387,1.8,79.3202807,61.1729499,0.0522932,8.4884049,9.2355627,1271.3404006,2500.245678,0.0452197,270.7193645,149.7737699,390.4979421,12.7789125,18.08209,0.3552309,51.5731909),(2393,'blackbuck_radius.tif',237,3,137,99.3238579,79.3509585,61.021006,1.8,79.3888053,60.8970989,0.0491891,8.6978092,9.7489232,1300.4301048,2512.348937,0.0400213,257.7052748,149.5123736,388.7548771,12.9768545,18.1584253,0.3217506,52.4129376),(2394,'blackbuck_radius.tif',237,3,138,98.69995,79.3985146,60.9448345,1.8,79.440074,60.8528085,0.0348423,8.5544186,9.4582469,1304.219572,2515.5030023,0.019962,265.958694,152.4615097,398.5101144,13.0524638,18.1790014,0.3693337,52.5731139),(2395,'blackbuck_radius.tif',237,3,139,97.8800358,79.4542839,60.8459418,1.8,79.5241312,60.7234374,0.0213325,8.8587546,9.6754276,1311.9238203,2522.0961364,0.0074227,260.6702496,148.0934822,395.4455657,13.1236264,18.1790014,0.3693337,52.7332901),(2396,'blackbuck_radius.tif',237,3,140,98.4514472,79.4770856,60.7155223,1.8,79.5387355,60.5871974,0.0173418,8.7490249,9.6572987,1348.2685849,2555.0913062,0.0049342,264.57619,154.1050117,399.3175884,13.1907302,18.2794896,0.3832841,52.8934664),(2397,'blackbuck_radius.tif',237,3,141,98.7669696,79.4930257,60.5407142,1.8,79.5752412,60.3538318,0.0252191,8.3610522,9.5340435,1402.5873142,2585.1978114,0.0104672,271.1543954,167.7524884,409.7318789,0.273438,0.611426,2.0344439,1.3202755),(2398,'blackbuck_radius.tif',237,3,142,99.0643211,79.5584237,60.4548744,1.8,79.5580662,60.3685595,0.0058698,8.4657336,9.8554895,1421.927091,2610.4440018,0.0005689,264.8720805,167.9626555,402.5220929,0.273438,1.1274138,1.815775,2.4140276),(2399,'blackbuck_radius.tif',237,3,143,99.1751595,79.6107222,60.3084581,1.8,79.6661963,60.2165567,0.0004503,8.051678,9.3384517,1455.0525221,2643.1137928,0.0000034,283.0355481,180.7141962,402.8158164,13.6339101,18.3834961,0.3970794,54.1199128),(2400,'blackbuck_radius.tif',237,3,144,98.5046687,79.6894623,60.1956475,1.8,79.7659221,60.1229254,-0.0111572,8.1711721,9.7215501,1471.8424082,2662.1129876,0.0020436,273.8362656,180.1262273,410.4433974,0.546876,1.9906588,1.849096,4.2811791),(2401,'blackbuck_radius.tif',237,3,145,98.1763677,79.7961342,59.9526654,1.8,79.8786453,59.8128219,-0.0080186,8.9581941,10.1695895,1510.097214,2671.1406374,0.0010521,262.6596313,168.5716109,374.6566179,0.273438,1.1274138,1.815775,2.4140276),(2402,'blackbuck_radius.tif',237,3,146,97.8286495,79.8485538,59.8129037,1.8,79.9009925,59.6851651,-0.010389,8.5404085,9.5695139,1537.078036,2689.4608861,0.0017598,281.0446718,179.9771093,410.4315819,14.0470144,18.3834961,0.3970794,54.8933123),(2403,'blackbuck_radius.tif',237,3,147,97.3655616,79.8793185,59.6621786,1.8,79.9616865,59.5232742,-0.0066685,8.4289333,9.5514617,1571.9277377,2718.8473359,0.0007216,284.6524881,186.4918941,410.4572998,0.273438,1.9334987,1.7126934,4.0546556),(2404,'blackbuck_radius.tif',237,3,148,97.784944,79.9003585,59.4622514,1.8,79.9865901,59.291388,0.0161585,8.6236003,10.2097216,1637.7158921,2773.805323,0.0042548,271.6827593,189.9109239,422.8251208,0.273438,1.9334987,1.7126934,4.0546556),(2405,'blackbuck_radius.tif',237,3,149,97.4846698,79.9573284,59.326269,1.8,80.0940233,59.1757619,0.012861,8.7570139,9.7085613,1667.8964549,2818.2969638,0.0026873,290.2898669,190.4640638,430.5001988,0.273438,3.2926297,1.6539376,6.7890358),(2406,'blackbuck_radius.tif',237,3,150,97.4861878,79.9774315,59.1531247,1.8,80.1072951,58.9615493,0.0184068,8.933885,10.4586327,1709.9443552,2882.7281659,0.0055042,275.6314575,191.3998628,414.5139104,0.273438,0.8646869,1.8925469,1.8671515),(2407,'blackbuck_radius.tif',237,3,151,97.2226181,80.0073801,58.9990288,1.8,80.1218398,58.8759049,0.0258627,9.6561313,9.6574818,1744.7814003,2944.9853468,0.0108359,304.9433996,180.6915564,410.9015671,0.273438,0.3866997,2.3561945,0.7733995),(2408,'blackbuck_radius.tif',237,3,152,97.5790139,80.0483508,58.8225338,1.8,80.167389,58.5788257,0.0265691,8.9850877,9.8793139,1797.6031901,3022.2112663,0.0114777,305.9130715,200.0651807,435.3892646,0.273438,1.9334987,1.7126934,4.0546556),(2409,'blackbuck_radius.tif',237,3,153,97.1257364,80.1354654,58.6053397,1.8,80.2674356,58.400167,0.0229167,8.9507163,10.3078402,1838.4909973,3069.2259199,0.0084999,297.7564519,205.4015494,435.992304,0.546876,0.9858948,2.1587989,2.093675),(2410,'blackbuck_radius.tif',237,3,154,97.0096189,80.1687641,58.4724198,1.8,80.3189307,58.2915331,0.0158791,9.0534175,10.6917613,1878.5992959,3129.6833631,0.0040765,292.719159,207.5016756,443.724083,0.5438802,4.137868,1.7033479,8.6561873),(2411,'blackbuck_radius.tif',237,3,155,96.3945926,80.2110209,58.3152181,1.8,80.405811,58.1748928,0.0189954,9.2396677,14.553489,1934.2639357,3204.0853929,0.0057963,220.1592611,209.3434521,350.2646555,0.546876,1.7293738,1.8925469,3.9608266),(2412,'blackbuck_radius.tif',237,3,156,97.779529,80.18316,58.0670999,1.8,80.3059878,57.9142203,0.0686051,9.2377581,20.417545,2063.93174,3345.2469235,0.0765824,163.8417804,223.4234455,243.2349469,0.546876,4.6805048,1.6879051,10.4295098),(2413,'blackbuck_radius.tif',237,3,157,97.3618911,80.2550083,57.871007,1.8,80.4058904,57.7327701,0.0691853,9.4114468,10.1974041,2121.0871429,3410.5233545,0.0775483,334.4501511,225.3731208,468.0964946,0.546876,0.7733995,2.3561945,1.546799),(2414,'blackbuck_radius.tif',237,3,158,98.9743951,80.2718322,57.6298387,1.8,80.3323715,57.5069343,0.0962233,9.4222871,20.6203386,2245.261282,3552.9804629,0.1522619,172.3046615,238.2925986,275.3696816,0.546876,0.7733995,2.3561945,1.546799),(2415,'blackbuck_radius.tif',237,3,159,100.2009359,80.3161648,57.3413204,1.8,80.3219407,57.2165475,0.122693,9.6399049,11.0317684,2349.7671151,3702.1772001,0.2501383,335.5923604,243.7541792,489.5488515,0.273438,0.611426,2.0344439,1.3202755),(2416,'blackbuck_radius.tif',237,3,160,103.6430893,80.3273815,56.9947756,1.8,80.16726,56.8912179,0.1651337,10.1207326,17.4886533,2511.2061055,3992.6013817,0.4667771,228.2966743,248.1249325,331.8233339,16.1856535,21.6344598,2.7798634,64.4167282),(2417,'blackbuck_radius.tif',237,3,161,110.5012726,80.2108036,56.3331752,1.8,79.9767152,56.0234682,0.3017068,10.281298,15.4840474,2835.0405352,4514.4190946,1.6261799,291.5529117,275.7473371,456.9542741,0.8102146,3.9150365,1.7818897,8.3358348),(2418,'blackbuck_radius.tif',237,3,162,114.4219887,80.3483365,56.0419744,1.8,79.9236597,55.7061895,0.2981782,10.5541869,15.4138043,3042.212676,4897.0384376,1.6458895,317.7047242,288.246998,492.7744375,0.546876,4.952173,1.6814535,10.5233389),(2419,'blackbuck_radius.tif',237,3,163,122.2716682,80.5430583,55.8832857,1.8,80.2162907,55.7560308,0.250689,10.7510369,15.7236434,3300.0950714,5197.6254607,1.254089,330.5611382,306.9559812,508.3391432,0.7742756,3.6481181,1.7975952,8.0154822),(2420,'blackbuck_radius.tif',237,3,164,126.6115403,80.5916023,55.5761528,1.8,80.2968079,55.3831905,0.2780795,10.9563544,17.0751604,3571.0606472,5770.6050225,1.5901446,337.9531965,325.9351158,530.5567026,0.8078516,5.0419478,1.7894653,10.7498623),(2421,'blackbuck_radius.tif',237,3,165,134.4400807,80.6813889,55.2667355,1.8,80.438377,55.1011189,0.2993747,11.1543196,14.0832917,3864.65289,6636.2818442,1.9489203,471.2166704,346.4714137,691.1194377,0.8865294,4.2448995,1.8313987,9.1092342),(2422,'blackbuck_radius.tif',237,3,166,146.979027,81.113881,55.0314901,1.8,80.9938619,54.9052475,0.2155999,11.0803064,14.4045817,4285.3638585,7587.7386646,1.1211443,526.7586954,386.7549959,757.9675578,0.6654056,3.3822414,1.815775,7.2420827),(2423,'blackbuck_radius.tif',237,3,167,166.009905,81.6292188,54.9196878,1.8,81.3726024,54.824004,0.1130739,11.5918827,14.267076,4866.5708654,8652.2721292,0.3522538,606.4502743,419.8257524,851.731831,0.273438,0.3866997,2.3561945,0.7733995),(2424,'blackbuck_radius.tif',237,3,168,178.7193231,81.6661732,54.8671902,1.8,81.4078039,54.9657508,0.0964013,11.6209296,19.5047066,5172.8994227,9937.0155885,0.2759561,509.4675754,445.1364556,752.8809319,0.820314,2.5940608,1.8925469,5.6014546),(2425,'blackbuck_radius.tif',237,3,169,177.519631,81.4230346,55.3028833,1.8,81.2101513,55.1874567,0.1322822,11.3245057,14.5650137,4727.6598233,9734.7155682,0.5147104,668.3629516,417.4716281,952.9449267,0.7689773,1.9717896,2.5535901,4.2536972),(2426,'blackbuck_radius.tif',237,3,170,164.8761449,81.4179448,55.6437335,1.8,81.3038879,55.3478399,0.1856087,10.6090944,16.5054,4049.1300923,8726.6680575,0.9358592,528.7159397,381.6659499,766.4699646,0.6921418,1.3671901,2.2142974,2.8670745),(2427,'blackbuck_radius.tif',237,3,171,151.4402051,81.7650547,55.3629733,1.8,81.6401535,55.3271954,0.1518629,10.8684643,20.9601222,3512.6158913,7795.2966566,0.5776331,371.9108409,323.1933976,538.3839528,18.8518072,28.2608471,2.6476513,84.9667786),(2428,'blackbuck_radius.tif',237,3,172,148.216919,81.7818469,55.0234622,1.8,81.7459129,55.0404935,0.1583499,10.8020142,16.1574023,3269.7098101,7178.5045536,0.6142558,444.2858103,302.694456,640.7902299,18.2941727,27.9134545,2.6297368,81.9006625),(2429,'blackbuck_radius.tif',237,3,173,149.0588106,81.9348495,54.8588436,1.8,81.8840751,54.7483383,0.1543335,10.5473724,14.3050274,2969.5975831,6521.6512845,0.5870509,455.8992513,281.5485682,620.4561167,17.5785665,26.7983203,2.6414316,78.9786242),(2430,'blackbuck_radius.tif',237,3,174,148.9639227,82.414053,54.9272233,1.8,82.4263621,54.7709865,0.0661481,9.6513052,12.3828107,2547.2434963,5521.7747265,0.1084754,445.9225681,263.9273603,630.2036794,16.7165542,23.970706,2.69325,71.631329),(2431,'blackbuck_radius.tif',237,3,175,128.275929,83.8962214,55.3072757,1.8,83.3115398,54.8951683,-0.1180437,8.3369796,12.7185858,1801.7190759,3738.3462192,0.296525,293.9278217,216.1117288,415.9520536,15.7615682,22.6970022,2.7588491,69.8030428),(2432,'blackbuck_radius.tif',237,3,176,81.5337267,86.9994015,55.0067529,1.8,85.7899485,55.1782238,-0.5635549,7.8900267,12.0955532,1054.3421552,1259.5085051,3.8777986,104.1298801,133.6297326,162.1654113,14.1862238,21.1680585,0.1035247,65.3067236),(2433,'blackbuck_radius.tif',237,3,177,57.6328691,88.4350013,54.0422335,1.8,88.0027853,54.3832803,0.9583679,7.5819678,7.4280009,380.4355292,669.3648082,6.431255,90.1137223,50.1763576,124.5139179,12.7983562,15.3247309,1.2998495,52.6508444),(2434,'blackbuck_radius.tif',237,3,178,27.6470463,89.0854325,53.7959031,1.8,88.7618518,53.6556161,0.822474,4.0586833,5.9581604,65.6473225,233.6898888,2.4746038,39.221819,16.1745367,46.5662763,7.5734902,11.9220228,2.5026787,37.741114),(2435,'blackbuck_radius.tif',237,3,179,3.889676,90.8481121,55.6579861,1.8,90.7814202,55.6262125,-1.0997102,1.5985574,2.5858354,1.1728525,4.3380265,0.5147443,1.6776112,0.7336943,2.1311446,3.1303747,5.3092058,0.968509,13.3629315),(2436,'blackbuck_radius.tif',237,3,180,0.0104449,91.0548582,55.6473047,1.8,91.0548582,55.6446356,1.276707,0.0404042,0.1334037,0.0000815,0.0002438,0.0015945,0.0018279,0.0020166,0.0023339,0.273438,0.611426,2.0344439,1.3202755),(2437,'blackbuck_radius.tif',237,3,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2438,'blackbuck_radius.tif',237,3,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2439,'blackbuck_radius.tif',237,3,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2440,'blackbuck_radius.tif',237,3,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2441,'blackbuck_radius.tif',237,3,185,9.3147766,96.758527,54.9865533,1.8,96.4795843,54.9890946,1.5420872,4.060634,5.2315778,24.6867885,53.7629895,1.5511836,10.2766299,6.0795404,13.9374832,10.273616,10.9375205,2.2142974,34.4209925),(2442,'blackbuck_radius.tif',237,3,186,365.7118544,72.4682407,56.4834257,1.8,74.6878939,56.475008,-0.0937557,16.2907877,27.4801942,19287.4928941,27080.9345779,0.534208,985.4710055,1183.9509084,1647.4237431,28.9844293,29.3739123,2.0760865,95.5953299),(2443,'blackbuck_radius.tif',237,3,187,444.0180354,72.7862184,56.3064425,1.8,75.8935018,56.3083641,-0.080595,16.858023,27.1986124,23099.1992003,36573.9962013,0.4796514,1344.700814,1370.2199373,2106.2507366,28.9844293,29.3089327,2.1096158,95.7555062),(2444,'blackbuck_radius.tif',237,3,188,459.6259052,73.4222973,56.2689198,1.8,76.7826372,56.2321824,-0.0748032,17.1861659,26.6172886,23772.1028977,42588.5733999,0.4278417,1600.0342487,1383.2115374,2349.1188624,28.9844293,29.2783042,2.5354573,95.7555062),(2445,'blackbuck_radius.tif',237,3,189,472.9587327,73.8944434,56.2397515,1.8,77.4548314,56.166647,-0.0750209,16.7018214,26.2283211,24574.5663331,46917.9808841,0.4428138,1788.828982,1471.3704398,2528.7470114,28.9844293,29.3395292,0.6863852,95.7555062),(2446,'blackbuck_radius.tif',237,3,190,483.771006,74.2644732,56.2239099,1.8,77.94611,56.1665075,-0.0758096,16.8546227,25.9285984,25326.9678608,50209.4794068,0.4624927,1936.4517377,1502.6718967,2668.2654623,28.9844293,29.3191351,1.9131929,95.7555062),(2447,'blackbuck_radius.tif',237,3,191,493.1579907,74.5647245,56.2038877,1.8,78.3658388,56.1172908,-0.0750584,16.4349639,25.6601567,25995.6258337,52781.4156311,0.462187,2056.9405024,1581.7269769,2783.8362023,28.9844293,29.312759,2.5018229,95.5953299),(2448,'blackbuck_radius.tif',237,3,192,500.3107159,74.7976232,56.1917545,1.8,78.6530489,56.0897614,-0.0762073,16.6123289,25.4823356,26565.3869417,54755.040203,0.4833268,2148.7449626,1599.1368244,2867.2421828,28.9844293,29.2783042,2.5354573,95.5953299),(2449,'blackbuck_ulna.tif',237,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2450,'blackbuck_ulna.tif',237,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2451,'blackbuck_ulna.tif',237,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2452,'blackbuck_ulna.tif',237,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2453,'blackbuck_ulna.tif',237,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2454,'blackbuck_ulna.tif',237,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2455,'blackbuck_ulna.tif',237,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2456,'blackbuck_ulna.tif',237,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2457,'blackbuck_ulna.tif',237,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2458,'blackbuck_ulna.tif',237,4,10,1.3204543,78.5931272,25.4434681,1.8,78.5510848,25.4209852,1.3080554,1.6421848,1.9628968,0.6374378,0.9441716,0.2052297,0.4810093,0.3881645,0.8041439,3.2812562,4.0649483,1.9138203,11.3356036),(2459,'blackbuck_ulna.tif',237,4,11,34.4536394,78.9534169,29.1585627,1.8,79.2149336,30.3660829,1.3551901,4.2264141,9.4199336,105.9493558,597.2532891,5.4794483,63.4031312,25.06838,73.5340301,8.2050703,17.2092249,1.8774726,44.0771028),(2460,'blackbuck_ulna.tif',237,4,12,56.3413252,78.8934785,29.4307173,1.8,79.440931,30.8542379,1.3229512,4.9367902,11.2758298,301.7136515,1232.1065074,8.8251201,109.2696973,61.1153481,134.338004,9.4144866,20.2454952,1.8583722,51.6784034),(2461,'blackbuck_ulna.tif',237,4,13,62.131454,79.1221771,29.8911619,1.8,79.5771866,31.0697394,1.3335686,5.4553793,12.6153131,414.6747903,1778.1471715,9.7833307,140.9514892,76.0120919,172.8361454,10.4659447,22.5764439,1.8657334,55.8932353),(2462,'blackbuck_ulna.tif',237,4,14,66.8967806,79.194916,30.3748788,1.8,79.4770707,30.9775186,1.361374,5.8931822,12.9438853,505.3214827,2152.0221927,10.6675807,166.2578228,85.746795,203.2843161,11.2438679,23.8142376,1.8380554,60.2132797),(2463,'blackbuck_ulna.tif',237,4,15,71.1936948,79.1456376,30.6503524,1.8,79.2470782,30.6160563,1.4084657,6.2296803,12.8053386,586.1404734,2359.8515433,11.5556791,184.2865398,94.0883709,226.70085,11.975883,24.2266696,1.8568478,61.5999024),(2464,'blackbuck_ulna.tif',237,4,16,74.4658295,79.0011974,30.6770656,1.8,78.9706273,30.248837,1.4789084,6.4111086,12.2569556,631.2259897,2545.9403036,12.3064754,207.7139214,98.4581655,254.1340329,12.0312726,24.0252292,1.7771202,60.920332),(2465,'blackbuck_ulna.tif',237,4,17,75.2283534,78.7262004,30.6196303,1.8,78.6509309,29.9424847,1.5266606,6.3316522,12.1708083,588.2770436,2764.93867,12.513651,227.1778992,92.9105114,268.6387733,12.3047106,24.1401014,1.7415315,60.5336322),(2466,'blackbuck_ulna.tif',237,4,18,74.935556,78.386439,30.8747893,1.8,78.2315011,30.0275898,1.539191,6.1446131,12.4201595,529.9247142,2971.3382123,12.476788,239.2351086,86.242161,275.4356538,11.2109585,24.5942255,1.715838,61.4008608),(2467,'blackbuck_ulna.tif',237,4,19,75.2447571,78.1811622,31.3484488,1.8,78.0555663,30.3267614,1.5508386,5.7154271,12.4541731,503.1231174,3141.4015911,12.5357984,252.2368665,88.0289629,286.8737609,10.616058,24.9788281,1.658483,62.0415659),(2468,'blackbuck_ulna.tif',237,4,20,76.3819383,78.0408663,31.9242405,1.8,77.9950407,30.7393402,1.5630637,5.4268159,12.5021687,478.9952737,3277.3872065,12.7295619,262.1454958,88.2645147,296.9995834,10.4774549,25.2290098,1.646737,62.7486182),(2469,'blackbuck_ulna.tif',237,4,21,78.3287248,77.9651614,32.6183376,1.8,77.9793304,31.4768381,-1.566555,5.7708517,12.9386526,441.8071518,3514.5567197,13.0545526,271.6323581,76.5583963,302.7851796,9.6156564,25.726434,1.6133239,63.1627999),(2470,'blackbuck_ulna.tif',237,4,22,80.3771057,77.9273919,33.403366,1.8,77.987084,32.3941755,-1.5504584,5.7060981,13.2218872,411.9332777,3803.7156084,13.3906439,287.6832606,72.1917625,313.4233316,9.0349971,26.3197404,1.4980085,63.5769815),(2471,'blackbuck_ulna.tif',237,4,23,81.9126662,77.8585273,34.248755,1.8,77.9327259,33.2697778,-1.5432531,5.6179285,13.8054297,392.2827855,4035.6698872,13.6417568,292.3248294,69.8269451,316.9097189,8.8221735,26.8651978,1.4994889,64.6707336),(2472,'blackbuck_ulna.tif',237,4,24,82.1492288,77.8172484,35.0984377,1.8,77.8910507,34.2485087,-1.5501418,5.630444,14.3503042,366.6320595,4191.182518,13.685698,292.0622764,65.1160122,315.9861811,0.273438,0.3866997,2.3561945,0.7733995),(2473,'blackbuck_ulna.tif',237,4,25,82.7555094,77.8422717,36.1898955,1.8,77.9254273,35.4362935,-1.558814,5.4081741,14.8879236,349.6598104,4384.8453351,13.7906047,294.5236324,64.6539487,314.9018839,8.102609,28.4848398,1.5131679,65.7919676),(2474,'blackbuck_ulna.tif',237,4,26,84.6083597,77.7949647,37.3405694,1.8,77.892358,36.7907184,-1.5633833,5.3531219,15.4782651,353.9993474,4658.1879234,14.1006184,300.9502613,66.129514,321.9728538,7.6562644,29.2783042,1.5334305,66.8857196),(2475,'blackbuck_ulna.tif',237,4,27,86.2736547,77.7253547,38.6433875,1.8,77.8058341,38.3147488,-1.5665989,5.2749365,15.4087654,373.4280742,4848.7150882,14.3786891,314.6725239,70.7929041,336.6672936,7.6562644,29.3204101,1.6361238,66.592849),(2476,'blackbuck_ulna.tif',237,4,28,89.8665909,77.7003531,40.0417237,1.8,77.8366081,40.1311188,1.5668988,5.2462332,15.1557236,419.2370387,5163.747866,14.9775376,340.7127242,79.9120096,366.9031598,8.1873628,29.4120685,1.6732402,67.8192954),(2477,'blackbuck_ulna.tif',237,4,29,96.0812453,77.7196364,41.4985398,1.8,77.8397374,41.5778752,1.5569304,5.2779022,15.2403189,518.4680768,5778.2301419,16.0104623,379.1410254,98.2337404,411.4375308,8.8450155,28.8162673,1.6563016,67.3387665),(2478,'blackbuck_ulna.tif',237,4,30,98.1972122,77.5218623,42.0073272,1.8,77.5831858,42.0763327,-1.5514001,5.7315006,14.9526736,614.3917933,5314.4442075,16.3600456,355.4176555,107.1956258,396.1152442,0.273438,1.9334987,1.7126934,4.0546556),(2479,'blackbuck_ulna.tif',237,4,31,90.0312626,77.5231037,41.3365419,1.8,77.4548249,41.6573743,-1.5425279,5.7422185,13.467446,640.1619201,3998.5297758,14.9932229,296.9033454,111.4833788,344.1258371,11.317711,24.6473694,1.5152978,62.3230532),(2480,'blackbuck_ulna.tif',237,4,32,85.2915158,77.6386435,40.7776175,1.8,77.5362031,40.9681257,-1.5613959,5.9825291,12.0739711,623.4810142,3031.348821,14.2139965,251.0647728,104.2169626,302.1595714,11.4604543,22.1197663,1.7196863,57.6551744),(2481,'blackbuck_ulna.tif',237,4,33,78.4976107,77.7647261,40.2636761,1.8,77.7182959,40.5143092,1.5665862,6.4085726,10.7338829,568.6999605,2270.1534446,13.0827032,211.4941505,88.7405033,263.4051833,11.3009112,20.3780126,1.773455,54.1473947),(2482,'blackbuck_ulna.tif',237,4,34,75.1879785,77.8119202,40.0711825,1.8,77.7912632,40.3215681,1.5497514,6.2587189,9.994061,542.4023507,1806.1749901,12.5257806,180.7248314,86.6634791,234.8422044,0.6941052,3.5546942,1.1760052,7.6951296),(2483,'blackbuck_ulna.tif',237,4,35,72.0215843,77.9155001,40.1113924,1.8,77.9363011,40.3453426,1.4973835,6.4043913,9.4797879,527.8463119,1521.3629624,11.9390208,160.4849154,82.4194343,215.9176386,0.7672647,8.1298966,1.2277724,17.5777634),(2484,'blackbuck_ulna.tif',237,4,36,70.1410018,78.0210728,40.2896105,1.8,78.0805388,40.5552574,1.417593,6.6250274,8.8797566,518.6068335,1353.2443165,11.4179241,152.3965559,78.2799528,206.6591209,0.6643591,2.9450175,1.1902899,6.3748541),(2485,'blackbuck_ulna.tif',237,4,37,69.4238827,78.1288776,40.5017246,1.8,78.2214575,40.7594755,1.3275742,6.8160498,8.4386587,502.2208141,1243.6178539,10.8995538,147.3715078,73.6820932,194.2180787,11.0415344,17.1635453,1.9631365,47.3308771),(2486,'blackbuck_ulna.tif',237,4,38,68.324788,78.2024637,40.8431961,1.8,78.2852865,41.1099283,1.2352775,6.5584307,8.4185668,505.6075966,1187.1525828,10.1529322,141.0159954,77.0927711,187.4398666,11.1547648,16.9112071,1.9693188,47.1043536),(2487,'blackbuck_ulna.tif',237,4,39,66.077614,78.2587008,41.2303206,1.8,78.3521549,41.5336237,1.1392221,6.6827983,8.6413594,510.2958761,1140.7444255,9.085937,132.0098343,76.3596111,181.5532241,11.1618702,16.7691309,1.9906763,48.5848054),(2488,'blackbuck_ulna.tif',237,4,40,67.2579343,78.2332419,41.6878854,1.8,78.299017,42.0418096,1.0637974,7.1363075,9.0118983,543.8185034,1157.2024664,8.5668162,128.408292,76.2044663,184.9311857,11.8164281,16.8824447,2.0054665,50.4908222),(2489,'blackbuck_ulna.tif',237,4,41,71.8234935,78.1559736,42.3335516,1.8,78.1420795,42.7440336,0.9551497,8.4892274,9.2803224,665.7331418,1242.8088786,7.9785048,133.9187182,78.4209338,203.4488345,13.6422395,17.0016008,2.0560233,55.1312192),(2490,'blackbuck_ulna.tif',237,4,42,76.2767869,77.3748114,42.6090978,1.8,77.2188337,42.8128202,0.2380403,7.8555495,9.1436329,902.0108381,1191.4591879,0.7068445,130.304793,114.8246642,198.0284566,0.9067615,9.4088109,0.9505468,19.842998),(2491,'blackbuck_ulna.tif',237,4,43,74.8578875,76.6024252,42.6179331,1.8,76.5138947,42.6396569,-0.2865542,7.4518147,10.2642553,700.6043967,1254.0903851,0.9967358,122.1803577,94.017957,179.8797278,1.6633912,11.2209579,0.8198673,25.0966182),(2492,'blackbuck_ulna.tif',237,4,44,69.7929438,76.6459353,42.5645841,1.8,76.5152608,42.5834461,-0.1433292,7.0538952,10.8846205,565.4052873,1082.7233028,0.2373306,99.4727655,80.155045,135.1408598,2.0556618,12.6048696,0.8621701,31.9245193),(2493,'blackbuck_ulna.tif',237,4,45,63.8128128,76.7494664,42.6767496,1.8,76.6961073,42.7193783,-0.0007693,6.582653,10.7469237,475.0014772,937.45784,0.0000063,87.2303433,72.1595804,119.5447067,2.2960766,11.4876513,0.6673061,29.670668),(2494,'blackbuck_ulna.tif',237,4,46,58.1080559,77.078186,42.8595509,1.8,77.0675824,42.9064487,0.2144021,6.2576682,10.7111352,390.5572362,755.1216666,0.4384078,70.4987525,62.412583,103.5388969,2.6771653,10.0838957,0.7086263,25.2842764),(2495,'blackbuck_ulna.tif',237,4,47,51.9634119,77.3308599,43.0165021,1.8,77.114503,43.0177362,0.3658205,5.6574974,10.2046368,295.592813,615.5618687,1.1082106,60.3217811,52.2479803,88.0783619,2.6109609,3.6481181,0.2267988,10.0816753),(2496,'blackbuck_ulna.tif',237,4,48,47.096627,77.7173559,43.3321363,1.8,77.6660639,43.3226957,0.5278518,5.0012362,9.5465612,229.3622571,494.3119529,1.9913414,51.7790586,45.861113,75.7582378,0.820314,1.4725088,1.9513027,3.640474),(2497,'blackbuck_ulna.tif',237,4,49,41.1498019,78.1191477,43.5635898,1.8,77.8031798,43.4763644,0.7230843,5.198476,8.8459262,153.428523,387.6895974,3.0028882,43.8269084,29.5141352,59.5358668,8.8203899,14.9593336,2.8256224,57.5177648),(2498,'blackbuck_ulna.tif',237,4,50,38.4428479,78.1603396,43.9401178,1.8,78.1039802,43.8107086,0.8353091,4.9481309,7.8827196,121.7744658,328.9179619,3.5228266,41.7264573,24.6101948,53.6987847,3.1056588,5.637069,1.3258177,19.0970805),(2499,'blackbuck_ulna.tif',237,4,51,37.6038111,78.1674573,44.4545755,1.8,78.2415468,44.3707526,0.9247245,4.7334272,7.4508706,111.6602234,306.5638038,3.9955945,41.1446959,23.58972,51.2440627,2.4140851,6.0713092,1.4352686,15.776959),(2500,'blackbuck_ulna.tif',237,4,52,35.8584233,78.2315755,44.9301335,1.8,78.3742947,44.8773095,0.9950582,4.5759912,6.9939396,89.0533957,288.7014076,4.2048171,41.2787965,19.4610068,47.1666604,2.3538421,5.7681812,1.4758446,15.6167827),(2501,'blackbuck_ulna.tif',237,4,53,34.3973139,78.3136752,45.3684532,1.8,78.3195005,45.3112223,1.0071958,4.4489062,6.9939673,76.0296261,276.7143756,4.0966903,39.5647225,17.0895099,44.1581525,2.1002859,7.6757708,1.6421038,21.9252897),(2502,'blackbuck_ulna.tif',237,4,54,33.8036079,78.3916266,45.8741385,1.8,78.4132391,45.9365569,1.009773,4.7439132,7.440446,71.7831928,276.6661011,4.0390785,37.184075,15.1316414,41.9156378,1.790958,7.1930311,1.7234457,21.3784137),(2503,'blackbuck_ulna.tif',237,4,55,31.9061685,78.3107771,46.2324259,1.8,78.1329281,46.3582045,1.0419426,5.4351985,7.1137989,64.7239414,244.1268851,3.9639975,34.3173722,11.908294,38.1111079,2.4549474,6.8849932,1.6902253,19.5112621),(2504,'blackbuck_ulna.tif',237,4,56,29.9168773,78.2287175,46.5896567,1.8,78.0245291,46.6981926,1.0970761,5.3524662,6.4075927,54.7898663,218.6485032,3.9484372,34.1233463,10.2363778,37.5266305,0.273438,0.3866997,2.3561945,0.7733995),(2505,'blackbuck_ulna.tif',237,4,57,27.2070912,78.1512663,46.8195668,1.8,77.9620262,46.9836455,1.1369049,5.1973772,6.1014637,45.9898092,181.9624662,3.733084,29.8227563,8.8486572,31.4872436,2.6396055,6.9713288,1.7681919,19.8041328),(2506,'blackbuck_ulna.tif',237,4,58,24.2488476,77.9510461,47.000594,1.8,77.8286233,47.2367356,1.2179199,4.9595496,5.5982657,35.2518767,146.3067219,3.5587679,26.1342942,7.1078786,26.3099101,2.6752963,7.5083509,1.7539071,18.7378626),(2507,'blackbuck_ulna.tif',237,4,59,21.4065855,77.8571026,47.1136939,1.8,77.7926366,47.3358487,1.224157,4.6686801,5.3127396,26.5532175,114.7020998,3.1559638,21.5900096,5.6875213,21.8526352,2.4369924,6.9713288,1.7681919,19.2183915),(2508,'blackbuck_ulna.tif',237,4,60,19.3459472,77.8276748,47.3143888,1.8,77.866987,47.5341113,1.214267,4.0308579,4.8847832,21.0350573,92.7823502,2.8315448,18.9941593,5.2185063,19.7319448,2.0139946,6.4359664,1.784857,18.1246394),(2509,'blackbuck_ulna.tif',237,4,61,17.8037028,77.772499,47.5589533,1.8,77.6959135,47.7005921,1.2157182,3.8287649,4.6703593,16.8095001,76.6933461,2.6086283,16.4212945,4.3903193,16.676862,1.7812729,5.0419478,1.7894653,12.589532),(2510,'blackbuck_ulna.tif',237,4,62,16.8283384,77.7461418,47.8815682,1.8,77.6882967,48.1595955,1.2145989,3.8164306,4.6369297,15.5300936,66.5533461,2.4636668,14.3528908,4.0692718,14.6594029,1.7094822,5.577063,1.7681919,15.776959),(2511,'blackbuck_ulna.tif',237,4,63,15.908733,77.7338867,48.2127672,1.8,77.5999719,48.3746567,1.2015856,3.5941596,4.3319012,13.5515613,57.4064702,2.3061458,13.2520267,3.7704395,14.4045657,1.5751851,5.0419478,1.7894653,14.23016),(2512,'blackbuck_ulna.tif',237,4,64,15.0519104,77.7364123,48.5563485,1.8,77.6713247,48.6641088,1.1873214,3.6675582,3.9843405,12.1457613,49.8529867,2.1574789,12.5122305,3.3116751,14.1281506,1.2778835,3.2926297,2.2974387,7.2146008),(2513,'blackbuck_ulna.tif',237,4,65,13.9227498,77.7842371,48.8852616,1.8,77.6863966,48.9514045,1.1626322,3.3699848,3.8008932,10.8805557,41.1571,1.9548715,10.8282707,3.2286661,12.8891819,1.5257438,3.3822414,1.815775,8.3083529),(2514,'blackbuck_ulna.tif',237,4,66,13.357773,77.7916474,49.2748018,1.8,77.730141,49.4110775,1.1173032,3.1664541,4.0255731,10.8490463,36.5401325,1.798983,9.0770013,3.4262447,10.3879429,1.4595931,3.9813176,1.849096,9.0154052),(2515,'blackbuck_ulna.tif',237,4,67,13.1235895,77.8307646,49.7316001,1.8,77.8566487,49.9112838,1.0649239,3.4884675,4.6706373,10.9976625,35.1494948,1.6736758,7.5256313,3.152577,8.7709496,1.5578024,4.4512484,1.7561443,12.7497082),(2516,'blackbuck_ulna.tif',237,4,68,15.5467636,77.7834206,50.7560103,1.8,77.4670398,50.8738259,1.3636056,4.5395284,3.9523887,15.5530321,54.8705037,2.4814779,13.8828714,3.4261339,15.481911,1.9140661,4.9897755,1.735945,12.2028322),(2517,'blackbuck_ulna.tif',237,4,69,16.6401034,77.8134922,51.3370279,1.8,77.7180781,51.4756597,1.3510547,4.6170447,4.0006887,19.7570636,57.057724,2.641577,14.2619755,4.279158,16.6316354,2.4215145,4.4090555,1.4464413,12.6558791),(2518,'blackbuck_ulna.tif',237,4,70,16.4005728,77.8396006,51.7274416,1.8,77.953472,51.879113,1.2958526,4.2593754,4.0769012,20.9388019,52.8467251,2.5319524,12.9624737,4.9159325,13.875191,2.1875041,3.9150365,1.359703,10.1755044),(2519,'blackbuck_ulna.tif',237,4,71,16.7572631,77.8578772,52.2299893,1.8,77.9670623,52.3229414,1.3290645,4.1771431,4.0955764,20.4999155,56.4209153,2.6328316,13.7760623,4.9076402,15.5257496,2.1875041,3.4587477,1.2490458,10.0153281),(2520,'blackbuck_ulna.tif',237,4,72,17.0844993,77.8929269,52.7203325,1.8,78.1298655,52.8885395,1.3357738,4.5666082,4.2468493,21.9695484,59.8133101,2.6930124,14.0841613,4.8109117,14.3684505,2.1622068,4.1827973,1.3734008,12.9487498),(2521,'blackbuck_ulna.tif',237,4,73,15.7630254,77.9866245,52.9043526,1.8,78.174455,53.0072715,1.2923382,5.2017221,4.0101214,19.078581,51.5574981,2.4286738,12.8568422,3.6677432,12.2496467,2.1875041,3.5965155,1.418147,11.4019508),(2522,'blackbuck_ulna.tif',237,4,74,14.8495374,78.0261083,53.1826192,1.8,78.2344057,53.2588212,1.2533285,5.1500629,3.9627666,16.4503289,46.6151247,2.2337539,11.7632779,3.1941996,11.0888481,1.6406281,3.8669975,1.7126934,9.2419286),(2523,'blackbuck_ulna.tif',237,4,75,14.7239493,78.0279919,53.5588985,1.8,78.1875342,53.6771278,1.2896977,4.3268572,4.0508068,16.1151833,46.8839796,2.2651396,11.5739856,3.7244547,12.5411931,1.9140661,3.8669975,1.7126934,10.0153281),(2524,'blackbuck_ulna.tif',237,4,76,14.1352052,78.0969059,53.8274756,1.8,78.496572,54.0182422,1.2073993,4.7721128,4.0635482,16.0669913,44.3972836,2.0582137,10.925743,3.3668507,9.8055892,1.6406281,4.4090555,1.6951513,10.1091572),(2525,'blackbuck_ulna.tif',237,4,77,14.5326783,78.0894734,54.2853643,1.8,78.2266485,54.2859462,1.3107151,4.2344047,3.9675581,13.5957717,48.8678337,2.2619369,12.3168539,3.210787,13.7603989,1.6406281,3.326517,1.735945,9.0154052),(2526,'blackbuck_ulna.tif',237,4,78,13.7413119,78.0898561,54.5071227,1.8,78.1561271,54.4259506,1.320011,3.9091742,3.9125462,11.4068218,43.3282143,2.1491738,11.0741732,2.917962,12.5586524,1.4838307,3.5965155,1.7234457,10.0153281),(2527,'blackbuck_ulna.tif',237,4,79,12.9792639,78.1137778,54.6922235,1.8,78.2382158,54.5888853,1.3297009,3.6095563,3.7614402,9.8390554,37.4891779,2.0398872,9.9667086,2.7258351,11.8271996,1.3671901,3.5965155,1.7234457,9.0154052),(2528,'blackbuck_ulna.tif',237,4,80,13.5707721,78.1760043,55.1653836,1.8,78.4363796,55.2231861,1.3261535,3.7904733,3.9054208,10.958199,41.726839,2.1291058,10.6843388,2.8909844,12.2824254,1.6246616,3.2926297,1.6539376,9.0154052),(2529,'blackbuck_ulna.tif',237,4,81,12.9896408,78.1955552,55.3154557,1.8,78.391605,55.2447226,1.3159,4.0658773,3.7920393,11.0259396,37.3949883,2.0272994,9.8614454,2.711823,11.4409392,1.6406281,2.8152166,2.0778948,6.8279011),(2530,'blackbuck_ulna.tif',237,4,82,12.3826805,78.2567273,55.5177048,1.8,78.7014317,55.4890588,1.2572692,4.9927818,3.568761,11.4883271,33.1746596,1.8674728,9.295848,2.3009872,7.636726,1.3671901,3.0571299,1.7506498,7.1482536),(2531,'blackbuck_ulna.tif',237,4,83,12.0587296,78.3497973,55.7731668,1.8,79.0902409,55.9010311,1.1121302,5.0228376,4.3190949,12.5531182,32.8915149,1.6158099,7.6153722,2.4992084,6.8601258,1.5578024,3.0571299,1.7506498,8.6950526),(2532,'blackbuck_ulna.tif',237,4,84,11.8926759,78.3377774,56.0330326,1.8,78.9969274,56.1720891,1.0886357,4.4398127,4.3153888,12.447036,31.5405797,1.5559334,7.3088616,2.8035048,7.1974386,1.5485512,3.0202216,1.6614562,7.6951296),(2533,'blackbuck_ulna.tif',237,4,85,11.1279543,78.4451111,56.201743,1.8,79.555456,56.4324372,0.9628262,4.403126,5.2852892,11.1867467,30.1353108,1.2495353,5.7017336,2.5406374,6.0529307,3.3739457,6.6135832,2.0899424,16.4840113),(2534,'blackbuck_ulna.tif',237,4,86,11.1072684,78.3376826,56.3446224,1.8,79.3261473,56.5628372,0.8625932,3.8258312,5.6226315,11.2276139,28.8416433,1.067943,5.1295632,2.9346862,5.9783786,3.7912552,6.522514,2.1471715,16.5503585),(2535,'blackbuck_ulna.tif',237,4,87,11.2283478,78.0768594,56.4861067,1.8,78.889939,56.6362324,0.5570329,2.6929025,7.8237115,12.9224498,30.2059526,0.5230387,3.8608214,4.7987068,5.3138073,1.4682544,2.9576843,0.9827937,8.1481766),(2536,'blackbuck_ulna.tif',237,4,88,12.7533955,77.9380238,56.9624173,1.8,78.8229284,57.0920885,0.4188136,3.5189014,8.9789928,17.4834606,38.554806,0.351539,4.2938898,4.9684428,6.0921228,1.4419215,2.9576843,0.9827937,7.9880003),(2537,'blackbuck_ulna.tif',237,4,89,11.157839,78.114962,56.994376,1.8,79.1278205,57.1506865,0.4421631,2.7077288,9.2505957,11.1470843,37.4064854,0.34049,4.0436839,4.1167655,5.0813358,1.7129635,2.7343801,0.9272952,6.6013776),(2538,'blackbuck_ulna.tif',237,4,90,10.2426744,78.0593452,57.1054368,1.8,79.1198236,57.2501292,0.4131123,2.7422019,7.8199615,8.979299,34.4487405,0.2751379,4.4052315,3.274485,5.4422152,1.7401489,2.5209739,0.7086263,6.5075485),(2539,'blackbuck_ulna.tif',237,4,91,10.7116759,77.9794444,57.4212036,1.8,79.1779458,57.5145988,0.3974862,2.5262787,8.9096074,10.9133082,34.2258098,0.2675202,3.8414498,4.3199147,4.947987,1.4445941,2.5209739,0.7086263,6.1208487),(2540,'blackbuck_ulna.tif',237,4,92,10.0355888,77.8722315,57.5232334,1.8,79.0567776,57.6053284,0.4025199,2.5568595,8.096434,9.3916069,29.0674045,0.2566748,3.590149,3.6731025,4.6019121,1.7122693,2.5209739,0.7086263,6.6677248),(2541,'blackbuck_ulna.tif',237,4,93,9.544542,77.8276065,57.6171932,1.8,78.9496594,57.6473241,0.4188451,2.9403486,9.1745122,8.2503038,25.0011895,0.2631263,2.7250702,2.8058931,3.4966201,3.8669975,5.9969638,2.3239476,15.9096534),(2542,'blackbuck_ulna.tif',237,4,94,9.0671348,77.8264439,57.6957138,1.8,79.0021943,57.7028612,0.3996299,2.4811907,7.4281689,7.1746955,22.9867938,0.2287656,3.0945438,2.891634,3.9634109,3.6736476,5.8133719,2.2896263,15.3627774),(2543,'blackbuck_ulna.tif',237,4,95,8.9308071,77.7172068,57.8054229,1.8,78.8532951,57.8170568,0.343152,2.345603,7.3916188,6.8822336,21.1583673,0.1684995,2.8624809,2.9340999,3.6757231,0.8766137,2.1356192,0.8760581,4.4138735),(2544,'blackbuck_ulna.tif',237,4,96,8.3976862,77.7150245,57.8683579,1.8,78.8200726,57.8603184,0.3456936,2.643503,7.2029203,5.9638606,19.1248608,0.1607021,2.6551538,2.2560446,3.3987019,3.6692477,5.4482138,2.8357138,14.7495542),(2545,'blackbuck_ulna.tif',237,4,97,8.1990516,77.8036191,57.9171778,1.8,79.1799801,57.9274898,0.2730467,2.3119461,7.9926234,5.6371257,22.016884,0.0993725,2.7546505,2.43826,3.4128226,3.5465461,5.4137964,2.3561945,14.3628544),(2546,'blackbuck_ulna.tif',237,4,98,7.7685898,77.7878803,57.9536212,1.8,79.0826234,57.9305359,0.2750668,2.3519673,7.2056875,4.9698236,19.9265656,0.0955183,2.7653941,2.1130496,3.4107811,3.5465461,5.3722046,2.8842689,14.2026781),(2547,'blackbuck_ulna.tif',237,4,99,7.5135165,77.7706665,57.9838813,1.8,79.0984432,57.9470252,0.2400805,2.3667353,8.5795451,4.5840193,20.8653554,0.070802,2.4319886,1.9368534,2.9342505,3.3025312,5.1082436,2.8706458,13.6558021),(2548,'blackbuck_ulna.tif',237,4,100,7.8115476,77.7053645,58.1100702,1.8,78.9245451,58.0323738,0.2601678,2.4487698,7.649536,5.0603087,19.7140099,0.0861533,2.5771511,2.0664697,3.1432141,3.4802977,5.9719763,2.863293,15.1362539),(2549,'blackbuck_ulna.tif',237,4,101,7.6630532,77.6751051,58.1417294,1.8,78.8874157,58.0742806,0.2644585,2.4163701,7.2773304,4.6858572,19.4417211,0.0872604,2.6715458,1.9392133,3.2637812,3.2869478,5.9719763,2.863293,14.9760776),(2550,'blackbuck_ulna.tif',237,4,102,7.4794176,77.665541,58.1650887,1.8,78.8846068,58.1055777,0.2659139,2.4412633,7.27852,4.3059807,19.3442761,0.0860871,2.6577211,1.763833,3.1959617,3.2869478,6.0031944,2.6167969,15.1362539),(2551,'blackbuck_ulna.tif',237,4,103,6.4740552,77.4077185,58.0313969,1.8,78.572819,57.971566,0.1785007,2.135002,6.5684195,3.3027827,12.7418125,0.0340163,1.9398597,1.5469694,2.4378249,3.0078181,4.7832117,2.6011732,12.2691794),(2552,'blackbuck_ulna.tif',237,4,104,6.2691673,77.3529988,58.0409739,1.8,78.4116757,57.9851172,0.1992218,2.1177173,7.1462106,3.0758072,11.2345109,0.0409241,1.5720935,1.4524163,1.9935121,3.0078181,4.7832117,2.6011732,12.2691794),(2553,'blackbuck_ulna.tif',237,4,105,6.5276618,77.490581,58.0239891,1.8,78.9485717,57.9434507,0.1376695,2.4774971,7.8155552,3.3002295,16.617943,0.0204897,2.1262652,1.3320821,2.5413869,3.0078181,5.3092058,2.9340964,13.3629315),(2554,'blackbuck_ulna.tif',237,4,106,6.3759048,77.4368962,58.0322148,1.8,78.7539631,57.9561406,0.1493735,2.0694536,7.0895332,3.1192764,15.1296323,0.0235345,2.1340802,1.5072947,2.5717396,3.0078181,5.577063,2.9441971,13.7496312),(2555,'blackbuck_ulna.tif',237,4,107,6.4699996,77.4688636,58.0177451,1.8,78.9036764,57.8904134,0.130968,2.1848883,8.9260411,3.2102759,18.6973279,0.0183907,2.0946943,1.4693089,2.447391,3.0078181,5.8900351,2.7610863,14.4566835),(2556,'blackbuck_ulna.tif',237,4,108,5.6263408,77.1428583,57.8938644,1.8,78.2234197,57.7213253,0.0824553,1.9877237,7.8982332,2.5861712,10.7368466,0.006361,1.3593985,1.3010717,1.6855944,3.0078181,4.1738501,2.5899377,11.1754274),(2557,'blackbuck_ulna.tif',237,4,109,5.5859658,77.0609972,57.9050753,1.8,77.9819923,57.7333543,0.1123972,1.8483581,7.9657059,2.5452428,9.2885772,0.0117119,1.1660708,1.3770291,1.4819416,3.0078181,4.2799819,2.677945,11.1754274),(2558,'blackbuck_ulna.tif',237,4,110,4.9409189,77.1204559,57.7664102,1.8,78.364617,57.6597549,0.1370263,1.9555375,7.0595692,1.8046618,9.2651028,0.0153654,1.3124176,0.9228469,1.5588279,2.5690982,4.3234346,2.536048,10.7223804),(2559,'blackbuck_ulna.tif',237,4,111,5.00778,77.0332303,57.7535166,1.8,78.063047,57.6340724,0.1755646,1.8465398,6.352888,1.8582062,8.3515137,0.0254625,1.3146011,1.006318,1.5992413,2.5690982,4.8914079,2.677945,12.0426559),(2560,'blackbuck_ulna.tif',237,4,112,5.2128038,77.0437884,57.7361284,1.8,78.2680749,57.6116507,0.152289,1.7749025,7.0859023,2.0068012,10.545465,0.0199939,1.4882318,1.1306543,1.7493875,2.5690982,5.2809652,2.7707014,12.589532),(2561,'blackbuck_ulna.tif',237,4,113,5.7171956,77.1123348,57.7098708,1.8,78.370907,57.5456481,0.1355525,1.6272484,7.9261232,2.440551,14.1784174,0.0174014,1.7888212,1.4998024,2.0918183,2.7939042,5.8900351,2.7610863,14.23016),(2562,'blackbuck_ulna.tif',237,4,114,5.6305097,76.9321771,57.6442475,1.8,77.9833936,57.3966121,0.1135781,2.2593924,7.7889341,2.4795934,12.0456656,0.0120536,1.5465101,1.0974603,1.8541841,2.7939042,5.2809652,2.7707014,13.3629315),(2563,'blackbuck_ulna.tif',237,4,115,4.3958803,76.8671646,57.3666462,1.8,78.1552128,57.1700883,0.0898955,1.998029,7.9207889,1.4111642,10.079879,0.0059047,1.2725852,0.7062781,1.4506066,0.9951123,1.5944039,2.6011732,4.2536972),(2564,'blackbuck_ulna.tif',237,4,116,4.541656,76.8008399,57.364491,1.8,77.9931912,57.2169042,0.1098053,1.7872164,7.7114131,1.4247596,10.6860118,0.00909,1.3857398,0.7971948,1.5697259,2.4215145,4.9294739,2.8023,11.9763087),(2565,'blackbuck_ulna.tif',237,4,117,4.8996831,76.8615624,57.3453911,1.8,78.3080895,57.1758885,0.0985238,2.1820049,8.3907509,1.6697626,13.9000744,0.0079012,1.6565948,0.7652424,1.8418454,2.4224962,5.2809652,2.7707014,12.9098845),(2566,'blackbuck_ulna.tif',237,4,118,4.737549,76.5146339,57.2755684,1.8,77.2471686,57.0648391,0.1374114,1.6278541,6.4933555,1.6214351,7.6926922,0.0148154,1.1847022,0.9960568,1.4064069,0.9120643,1.7508576,0.6747409,3.8006503),(2567,'blackbuck_ulna.tif',237,4,119,5.1135432,76.4962325,57.2460767,1.8,77.2806389,57.0303489,0.1405841,1.9218903,5.9700629,1.8819641,8.7087908,0.0167332,1.4587436,0.9792255,1.738084,0.6636459,1.834278,0.4636476,3.8006503),(2568,'blackbuck_ulna.tif',237,4,120,3.8947965,76.1595141,56.9111049,1.8,76.9341853,56.7686537,0.0507979,1.708817,7.227914,1.0582682,6.254546,0.0016736,0.8653321,0.6192987,1.0101731,0.8561347,2.2045277,0.5191461,4.5740498),(2569,'blackbuck_ulna.tif',237,4,121,4.5705211,76.2034937,56.8317173,1.8,77.1481029,56.6100563,0.0386591,1.88316,6.9075992,1.5932051,8.9471395,0.0011379,1.2952604,0.8460274,1.521965,0.6921418,1.834278,0.4636476,3.8006503),(2570,'blackbuck_ulna.tif',237,4,122,3.7886707,76.1453063,56.5563224,1.8,77.3032048,56.2807587,0.0078975,2.1345897,6.7044011,1.1584376,6.9860026,0.0000394,1.0420025,0.542698,1.2137242,0.820314,1.5944039,0.5404195,3.4139505),(2571,'blackbuck_ulna.tif',237,4,123,3.3381575,76.062915,56.3598126,1.8,77.1972646,56.1568217,0.038695,1.6797124,6.7824993,0.8473484,6.4001897,0.0008326,0.9436329,0.5044604,1.0675608,0.273438,0.3866997,2.3561945,0.7733995),(2572,'blackbuck_ulna.tif',237,4,124,3.7105491,76.0014536,56.320066,1.8,77.1881798,56.1091056,0.0527902,1.6742291,7.099781,1.0719409,7.1970143,0.0017218,1.0136953,0.6402594,1.1599626,0.6121198,1.3671901,0.6435011,2.7068982),(2573,'blackbuck_ulna.tif',237,4,125,3.5004727,75.7797264,56.1601234,1.8,76.8016327,55.953599,0.0528537,1.5118253,6.7834952,0.9191698,6.0405414,0.0016283,0.8904763,0.6079868,1.0235819,0.6121198,1.3671901,0.6435011,2.7068982),(2574,'blackbuck_ulna.tif',237,4,126,3.9821395,75.819625,56.1155284,1.8,77.1645742,55.9556943,0.0600947,1.7100727,10.3567734,1.1704178,9.5804027,0.002394,0.9250374,0.6844257,1.0372279,0.612814,1.9717896,0.5880026,4.0271737),(2575,'blackbuck_ulna.tif',237,4,127,3.7533937,75.5381139,55.9685362,1.8,76.0650356,55.7788912,0.1984559,1.832196,6.275027,1.0557263,4.0977503,0.024316,0.6530251,0.5762082,0.7916724,0.546876,1.222852,0.4636476,2.4803748),(2576,'blackbuck_ulna.tif',237,4,128,4.1226587,75.534037,55.905567,1.8,76.180275,55.6946547,0.1994684,1.9907354,6.2897435,1.3209592,5.1501489,0.0269778,0.818817,0.6635534,0.9940985,0.5800496,1.1600992,0.7853982,2.4803748),(2577,'blackbuck_ulna.tif',237,4,129,3.4246395,75.3698141,55.5222062,1.8,76.2869457,55.3384302,0.051945,1.4983393,6.3645959,0.940961,5.0373075,0.0015387,0.7914576,0.6280026,0.9348892,0.546876,0.7733995,2.3561945,1.546799),(2578,'blackbuck_ulna.tif',237,4,130,3.8501394,75.3952296,55.4655454,1.8,76.5148397,55.2249178,0.0209232,1.9300343,7.1766437,1.2657167,7.1571347,0.0002809,0.9972816,0.6558001,1.1719947,0.5800496,1.3671901,0.6435011,2.7068982),(2579,'blackbuck_ulna.tif',237,4,131,2.9292879,75.3480791,55.112173,1.8,76.6785071,54.9448197,0.042871,1.2840753,8.5830142,0.6205624,5.8289449,0.0008968,0.6791256,0.4832757,0.7500544,0.273438,0.3866997,2.3561945,0.7733995),(2580,'blackbuck_ulna.tif',237,4,132,3.0654342,75.3093117,55.0117722,1.8,76.4858097,54.8729076,0.0935158,2.0646229,8.0491994,0.7374668,6.3810062,0.004455,0.7927504,0.357192,0.8799709,0.6921418,1.222852,2.0344439,2.8670745),(2581,'blackbuck_ulna.tif',237,4,133,3.5696901,75.2741754,54.9605251,1.8,76.27687,54.7739514,0.1458363,1.8741815,8.3087858,1.059409,6.6992637,0.012564,0.8062867,0.5652649,0.9238873,0.7733995,1.3671901,2.4980915,2.8670745),(2582,'blackbuck_ulna.tif',237,4,134,3.7318241,75.0145693,54.8410448,1.8,75.5753629,54.6029093,0.2303894,1.9259544,4.5418053,1.2274547,3.864255,0.0324338,0.8508192,0.6373228,1.0434165,0.546876,0.9858948,2.1587989,2.093675),(2583,'blackbuck_ulna.tif',237,4,135,4.284181,74.9730711,54.7580039,1.8,75.4861159,54.549807,0.2900783,2.297521,5.5388312,1.5831741,4.9224135,0.0584159,0.8887098,0.6890793,1.0849089,0.546876,0.9858948,0.9827937,2.093675),(2584,'blackbuck_ulna.tif',237,4,136,4.1574826,74.7525592,54.5096345,1.8,75.2201077,54.3514083,0.2611856,1.9170064,5.351732,1.6863356,4.3547565,0.046204,0.8137097,0.8796714,1.0691683,0.546876,0.9858948,2.1587989,2.093675),(2585,'blackbuck_ulna.tif',237,4,137,4.7364841,74.8857944,54.3139524,1.8,75.5232045,54.0826678,0.321589,2.2501762,5.341006,2.2686511,6.0717767,0.0788649,1.1368227,1.0082104,1.4390824,0.546876,0.7733995,2.3561945,1.546799),(2586,'blackbuck_ulna.tif',237,4,138,4.0161478,74.8437255,53.9134292,1.8,75.6504714,53.7647492,0.3515381,2.4925871,5.8679185,1.3666859,5.6105536,0.0793668,0.9561403,0.5483001,1.0944039,2.3539858,4.5509155,2.5702552,10.9489039),(2587,'blackbuck_ulna.tif',237,4,139,4.4485127,74.8489881,53.7564543,1.8,75.7211601,53.6679434,0.3385197,2.2661733,5.9470359,1.8251629,7.543952,0.081767,1.268523,0.8053942,1.4721639,2.5222048,5.3930406,2.6098686,12.8160554),(2588,'blackbuck_ulna.tif',237,4,140,4.2326361,74.7145903,53.4166112,1.8,75.6584752,53.3386417,0.3009261,2.3866519,6.257097,1.5598167,6.9763538,0.061977,1.1149506,0.6535586,1.3134759,2.5191003,4.9294739,2.5535901,11.4957799),(2589,'blackbuck_ulna.tif',237,4,141,4.6788672,74.7532439,53.2844525,1.8,75.7405879,53.2402969,0.3222019,2.5322713,12.0165515,1.9003089,8.9642433,0.0781924,0.7459913,0.7504365,0.8847018,0.273438,0.611426,2.677945,1.1600992),(2590,'blackbuck_ulna.tif',237,4,142,4.4196703,74.5796657,52.9497934,1.8,75.4196727,52.9922869,0.344549,2.5437917,12.233382,1.5754431,7.7726005,0.0840401,0.6353599,0.6193287,0.7481392,2.4534289,4.8684254,2.4756234,11.3356036),(2591,'blackbuck_ulna.tif',237,4,143,4.5937446,74.5706693,52.7369182,1.8,75.7496701,52.8285911,0.2787733,1.9073063,12.3661107,1.8737016,10.4535431,0.0579747,0.845338,0.9823811,0.9865193,2.804954,4.4090555,2.6224465,11.4019508),(2592,'blackbuck_ulna.tif',237,4,144,4.5504696,74.476005,52.4113214,1.8,75.5721098,52.6051276,0.2631329,2.4073456,13.0968187,1.7024523,11.6232763,0.0513108,0.8874885,0.7071906,1.0112673,0.273438,0.3866997,2.3561945,0.7733995),(2593,'blackbuck_ulna.tif',237,4,145,4.7810959,74.4980337,52.0431983,1.8,75.6370402,52.1889448,0.280342,2.2448838,9.0935824,1.9983444,10.0945744,0.0610022,1.1100767,0.8901772,1.310353,2.5914862,4.5509155,2.5702552,11.5621271),(2594,'blackbuck_ulna.tif',237,4,146,4.806857,74.4796315,51.7393743,1.8,75.8091699,51.9182831,0.2479488,1.6863352,9.6952285,1.9513818,11.8661578,0.048252,1.2239173,1.1571732,1.4108127,3.1829839,7.7000844,2.8535372,24.604706),(2595,'blackbuck_ulna.tif',237,4,147,5.5132366,74.5688038,51.5782478,1.8,76.2840706,51.8094428,0.2412629,2.1099442,12.4420463,3.008145,18.8751246,0.0524558,1.5170434,1.4256989,1.7497626,0.4894181,0.9858948,0.5880026,1.9334987),(2596,'blackbuck_ulna.tif',237,4,148,5.5225034,74.3482683,51.2343419,1.8,75.4673973,51.3525553,0.3497221,1.8181462,8.6792995,2.8366676,10.6468037,0.1080569,1.2266893,1.5601978,1.5205171,3.093598,4.8376123,2.3162158,12.2691794),(2597,'blackbuck_ulna.tif',237,4,149,6.3158182,74.3843925,51.0498088,1.8,75.8004516,51.234622,0.3502325,2.3627945,9.8981263,3.9790467,14.9985326,0.1239256,1.5152901,1.6840426,1.8648925,3.700478,9.2848212,2.9037567,29.8858081),(2598,'blackbuck_ulna.tif',237,4,150,6.2666977,74.1532109,50.633013,1.8,74.9665978,50.7064045,0.4604422,3.5329186,10.0939658,3.9635511,9.7949149,0.2062181,0.9703733,1.1218914,1.2865142,3.6011396,5.0419478,2.2794226,13.7496312),(2599,'blackbuck_ulna.tif',237,4,151,7.0185953,74.136275,50.3881719,1.8,74.8616983,50.5082902,0.5632081,3.3248545,5.832077,4.9926857,11.718846,0.3334428,2.0093778,1.5016253,2.6372054,3.8543188,5.4687603,2.2142974,14.683207),(2600,'blackbuck_ulna.tif',237,4,152,7.4574402,74.0430526,50.0202741,1.8,74.6329524,50.0938439,0.6841812,3.1890786,5.6223124,5.7414306,11.9395232,0.4965075,2.1235966,1.8003416,2.7435739,3.940105,5.637069,2.2531129,15.5229537),(2601,'blackbuck_ulna.tif',237,4,153,7.5911849,74.0466183,49.5071402,1.8,74.7779063,49.6043652,0.6117476,3.7024239,7.1563164,6.5062061,13.4523256,0.4172866,1.8797835,1.7572829,2.4770606,4.1217263,5.8133719,2.2896263,16.230006),(2602,'blackbuck_ulna.tif',237,4,154,7.8732202,73.9513579,49.1483863,1.8,74.4757014,49.3171444,0.7132852,3.3982974,5.3967194,7.7707152,15.3521068,0.5618025,2.8447109,2.2866495,3.8122606,4.2295925,6.4068575,2.2655346,16.9370583),(2603,'blackbuck_ulna.tif',237,4,155,8.1827838,73.8230711,48.7499589,1.8,74.2993031,48.943268,0.7871591,4.323997,6.5148137,9.652878,17.2231423,0.6843003,2.6436892,2.232397,3.4371868,4.4355995,6.6192334,2.2390857,17.4839343),(2604,'blackbuck_ulna.tif',237,4,156,9.0640307,73.8278075,48.4945832,1.8,74.3511692,48.6914975,0.8051292,7.216874,9.4593493,13.3138061,25.1218377,0.7851352,2.6557681,1.8448162,3.2304272,4.7564438,6.9012634,2.1587989,18.870557),(2605,'blackbuck_ulna.tif',237,4,157,10.0407546,73.7391392,48.1321261,1.8,74.2391758,48.3441428,0.8380412,6.7175763,8.6105975,18.7384593,31.7476284,0.9246629,3.6870413,2.7894673,4.6228452,5.1594604,7.2808487,2.1692152,20.5111851),(2606,'blackbuck_ulna.tif',237,4,158,9.6696317,73.4105263,47.4461595,1.8,73.5853861,47.6522033,1.1657224,5.9680793,4.4878073,17.8518963,26.1892148,1.361316,5.8356371,2.9912297,5.8979783,5.5129426,7.3878883,2.2513176,21.0580611),(2607,'blackbuck_ulna.tif',237,4,159,9.9491294,73.3452576,46.8477642,1.8,73.5396787,47.0664148,1.084815,4.65239,4.7624142,18.4750311,24.8691155,1.2964375,5.2219556,3.9710839,6.5981723,5.7466984,7.3878883,2.2513176,20.8978848),(2608,'blackbuck_ulna.tif',237,4,160,10.6517932,73.3229698,46.7497121,1.8,73.5311126,46.8675718,1.2268935,7.8186088,4.338788,21.1460074,32.2077368,1.5734838,7.4232106,2.7045742,5.9974876,5.8152989,7.5083509,2.1486983,21.2845846),(2609,'blackbuck_ulna.tif',237,4,161,10.6703494,73.0655511,46.3079656,1.8,73.1233307,46.3848865,1.4910125,7.200685,3.688196,20.0551666,28.2781129,1.7670953,7.6671936,2.7851748,6.5011759,5.3829054,6.7534207,2.1251038,19.7377856),(2610,'blackbuck_ulna.tif',237,4,162,11.3235528,72.9231403,46.2736433,1.8,72.9101879,46.3969914,1.4787145,8.1328797,3.9167559,22.8092398,30.9243077,1.8713018,7.8953881,2.8045711,6.4044793,5.4097157,7.130391,2.1375255,21.2845846),(2611,'blackbuck_ulna.tif',237,4,163,6.7069699,72.6232411,44.8872485,1.8,72.8042113,44.987255,-0.4474985,3.2530116,6.01411,7.5787239,9.9853045,0.2093015,1.6603129,2.3297562,2.871541,4.6484462,5.637069,0.2449787,16.3901822),(2612,'blackbuck_ulna.tif',237,4,164,8.6213115,72.6049967,44.8704159,1.8,72.873998,44.8991859,-0.1858832,3.0087268,7.4771965,10.4589897,15.9803067,0.0490789,2.1372057,3.4762178,3.5276508,4.9218842,6.1142598,2.9617392,18.1909866),(2613,'blackbuck_ulna.tif',237,4,165,6.6232294,72.4055028,44.1270453,1.8,72.4610734,44.0894669,-0.3235431,2.5006759,3.806259,5.0966958,10.9953881,0.1115773,2.8887651,2.0381273,3.8491222,4.0464134,7.0300695,0.235545,18.2573338),(2614,'blackbuck_ulna.tif',237,4,166,8.6479789,72.4725843,44.0007568,1.8,72.4545938,43.9496529,-0.2527943,2.6967031,4.4667776,8.2598936,20.4288647,0.0901627,4.5735129,3.0629599,6.3103683,4.3161014,8.2258953,0.2691675,21.2182374),(2615,'blackbuck_ulna.tif',237,4,167,10.380792,72.4211961,43.8905346,1.8,72.6420396,43.7520707,-0.5658497,2.78278,3.8020533,14.1291899,21.0001931,0.4973073,5.523382,5.0773651,7.9530079,5.3465347,6.7034153,0.2053954,19.0970805),(2616,'blackbuck_ulna.tif',237,4,168,12.5796157,72.2133865,43.9252037,1.8,72.2867456,43.7899031,-0.8284254,2.6834633,3.6903962,19.8076188,32.8316739,1.138401,8.8965174,7.3813638,12.3312743,5.3426431,7.0566082,0.9505468,20.0306562),(2617,'blackbuck_ulna.tif',237,4,169,16.6460849,72.3553745,44.085702,1.8,72.4971878,43.9500013,-0.8228773,3.1990719,4.8481339,36.4758134,56.3877595,1.4910565,11.6308172,11.4019987,18.0767658,6.309728,8.4456499,0.5070985,26.4055103),(2618,'blackbuck_ulna.tif',237,4,170,22.7472953,72.7905566,44.2182961,1.8,72.946718,44.2361941,-0.600214,3.8859497,4.9365445,71.839101,94.8423046,1.209476,19.212286,18.4868839,29.3107582,7.4441647,8.8350526,0.3805064,26.7922101),(2619,'blackbuck_ulna.tif',237,4,171,27.5192151,72.8821356,44.4007565,1.8,73.0945446,44.4288012,-0.7976444,5.4640931,5.6189618,104.1723178,136.6573155,2.3494299,24.3207411,19.0648869,39.2173285,8.0506134,10.2930436,0.8794594,29.91329),(2620,'blackbuck_ulna.tif',237,4,172,28.9275788,72.6750443,44.4545472,1.8,73.1427695,44.425322,-0.9590974,6.9444576,5.4163834,90.1306154,156.0928048,3.2313379,28.8186403,12.978784,32.4464077,7.8198308,10.8448425,0.9827937,30.0071191),(2621,'blackbuck_ulna.tif',237,4,173,18.1394806,72.5159201,43.6389711,1.8,72.711397,44.2817124,-1.1413456,8.4793139,4.9496918,28.7447795,83.5100197,2.4991209,16.8717615,3.3899888,13.1375176,7.8839696,10.0876023,0.9978302,33.1281989),(2622,'blackbuck_ulna.tif',237,4,174,6.2926174,72.6509086,42.2254697,1.8,72.6164698,42.3739268,-1.0610592,7.1915197,3.3120931,2.7232007,11.807493,0.7990648,3.5649641,0.3786683,1.9787496,3.2726201,6.6135832,1.0516502,15.9096534),(2623,'blackbuck_ulna.tif',237,4,175,0.3640992,72.8059252,41.8556518,1.8,72.7709698,41.8967799,-1.1993949,0.6907137,1.5793049,0.0444851,0.1685095,0.0526905,0.1066985,0.0644046,0.1318131,1.7122693,3.1888078,1.0303768,7.3747771),(2624,'blackbuck_ulna.tif',237,4,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2625,'blackbuck_ulna.tif',237,4,177,57.6328691,88.4350013,54.0422335,1.8,88.0027853,54.3832803,0.9583679,7.5819678,7.4280009,380.4355292,669.3648082,6.431255,90.1137223,50.1763576,124.5139179,12.7983562,15.3247309,1.2998495,52.6508444),(2626,'blackbuck_ulna.tif',237,4,178,27.6470463,89.0854325,53.7959031,1.8,88.7618518,53.6556161,0.822474,4.0586833,5.9581604,65.6473225,233.6898888,2.4746038,39.221819,16.1745367,46.5662763,7.5734902,11.9220228,2.5026787,37.741114),(2627,'blackbuck_ulna.tif',237,4,179,3.889676,90.8481121,55.6579861,1.8,90.7814202,55.6262125,-1.0997102,1.5985574,2.5858354,1.1728525,4.3380265,0.5147443,1.6776112,0.7336943,2.1311446,3.1303747,5.3092058,0.968509,13.3629315),(2628,'blackbuck_ulna.tif',237,4,180,0.0104449,91.0548582,55.6473047,1.8,91.0548582,55.6446356,1.276707,0.0404042,0.1334037,0.0000815,0.0002438,0.0015945,0.0018279,0.0020166,0.0023339,0.273438,0.611426,2.0344439,1.3202755),(2629,'blackbuck_ulna.tif',237,4,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2630,'blackbuck_ulna.tif',237,4,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2631,'blackbuck_ulna.tif',237,4,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2632,'blackbuck_ulna.tif',237,4,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2633,'blackbuck_ulna.tif',237,4,185,3.2684416,94.9091672,54.9309003,1.8,94.7179117,54.9178661,1.5694679,2.2137189,4.6800005,2.2125895,14.5653257,0.5447393,3.1122488,0.9994898,3.4962422,10.273616,10.9375205,2.2142974,34.4209925),(2634,'blackbuck_ulna.tif',237,4,186,309.7869209,73.1777571,56.5157347,1.8,74.5673868,56.4802696,-1.4374778,23.3713709,16.1401204,14343.0842819,17008.5017193,50.7188945,1053.8026548,613.7031653,1285.4408922,28.9844293,29.3739123,2.0760865,95.5953299),(2635,'blackbuck_ulna.tif',237,4,187,374.1578681,73.481435,56.3266266,1.8,75.6796087,56.2755268,-0.8482097,21.9380324,22.4644465,19507.1696851,20656.2086097,35.0864306,919.5066812,889.1941315,1628.3523526,28.9844293,29.3089327,2.1096158,95.7555062),(2636,'blackbuck_ulna.tif',237,4,188,386.0431578,73.9881774,56.292156,1.8,76.4931049,56.2126121,-0.247673,16.5314026,24.1241356,20411.8650142,23753.5615314,3.866727,984.6388677,1234.7327966,1781.5577557,28.9844293,29.2783042,2.5354573,95.7555062),(2637,'blackbuck_ulna.tif',237,4,189,396.8317091,74.3976058,56.2650869,1.8,77.1271779,56.154689,-0.1850904,16.2339548,23.5137605,21007.820982,26466.1701092,2.2400504,1125.5609292,1294.0667425,1903.0984529,28.9844293,29.3395292,0.6863852,95.7555062),(2638,'blackbuck_ulna.tif',237,4,190,405.6713668,74.725734,56.2466797,1.8,77.6094889,56.1263587,-0.1639421,16.5606944,23.1395018,21524.9458185,28585.2205668,1.8009837,1235.3429574,1299.7610699,1998.1097472,28.9844293,29.3191351,1.9131929,95.7555062),(2639,'blackbuck_ulna.tif',237,4,191,413.6208054,74.9919957,56.2269179,1.8,77.9947638,56.0908863,-0.1540418,16.1746087,22.8604009,22014.740223,30271.4672607,1.6228944,1324.1879444,1361.0678687,2079.806261,28.9844293,29.312759,2.5018229,95.5953299),(2640,'blackbuck_ulna.tif',237,4,192,419.6630168,75.2012764,56.2161701,1.8,78.2713017,56.0742336,-0.1500416,16.0681391,22.6915852,22424.7637595,31565.1618963,1.5628277,1391.0514266,1395.6042855,2136.7971146,28.9844293,29.2783042,2.5354573,95.5953299),(2641,'blackbuck_metacarpus.tif',237,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2642,'blackbuck_metacarpus.tif',237,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2643,'blackbuck_metacarpus.tif',237,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2644,'blackbuck_metacarpus.tif',237,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2645,'blackbuck_metacarpus.tif',237,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2646,'blackbuck_metacarpus.tif',237,5,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2647,'blackbuck_metacarpus.tif',237,5,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2648,'blackbuck_metacarpus.tif',237,5,8,1.1053659,51.3667032,29.6631137,1.8,50.7940269,30.1703942,-0.3179653,4.6534016,14.4515583,3.7239252,30.495342,0.0180065,2.1101767,0.8002587,2.3616806,2.5302855,8.4894241,1.4601391,20.2012729),(2649,'blackbuck_metacarpus.tif',237,5,9,66.5426077,49.6886721,32.3002302,1.8,49.8719748,33.0822764,-0.0789316,9.2967029,13.2883217,1008.7503092,2652.142963,0.0689522,199.5844947,108.5062431,273.6847519,15.25544,24.2339685,2.9548188,103.5371411),(2650,'blackbuck_metacarpus.tif',237,5,10,178.5173448,48.8015608,32.7508001,1.8,48.5141379,33.2562166,0.2481924,10.3988539,12.3991056,3212.1691775,7133.1590712,1.7954373,575.2962611,308.8964621,787.2238231,16.5876778,24.476473,2.9877785,72.3087707),(2651,'blackbuck_metacarpus.tif',237,5,11,177.1084312,48.3253519,32.7964953,1.8,48.2259258,33.3597272,0.2259672,11.0189418,14.6749386,3478.22731,7258.4856829,1.481748,494.6177889,315.6589251,635.3698546,16.7599541,24.9092901,3.0284417,72.5927805),(2652,'blackbuck_metacarpus.tif',237,5,12,157.111085,48.374207,32.8974694,1.8,48.3671193,33.426038,0.2033282,10.9101964,12.4236083,3338.619849,6445.3296802,1.067721,518.7969171,306.0091439,712.6380497,17.2195868,24.4218315,3.0029529,72.1534406),(2653,'blackbuck_metacarpus.tif',237,5,13,145.4257,48.3638173,32.8695533,1.8,48.4049636,33.3897011,0.1868201,10.1636735,12.3487991,3106.9952025,5588.4866424,0.8361397,452.5530443,305.6960844,684.7181613,17.2801237,23.6130937,2.9660005,70.8731104),(2654,'blackbuck_metacarpus.tif',237,5,14,137.5080321,48.3396423,32.9005981,1.8,48.3164924,33.3859011,0.1324496,10.1296043,11.9427865,2765.0989088,4816.2145607,0.3997024,403.27394,272.9720545,612.4257114,16.7808058,22.5281089,3.0916343,68.2936054),(2655,'blackbuck_metacarpus.tif',237,5,15,132.5350627,48.3905272,33.047332,1.8,48.3664094,33.525575,0.0720981,9.77729,11.1229212,2452.8998795,4226.5698379,0.1146236,379.9873951,250.8772746,543.4236062,16.125001,21.2876518,3.0445533,65.0017897),(2656,'blackbuck_metacarpus.tif',237,5,16,126.9776473,48.4912992,33.2017933,1.8,48.4472687,33.6075141,0.0507652,9.1935505,10.6044326,2148.8640397,3804.9000578,0.0544923,358.8027946,233.7360349,511.3766447,15.562501,20.3201921,3.0584514,65.1571198),(2657,'blackbuck_metacarpus.tif',237,5,17,124.3785773,48.7251772,33.2603766,1.8,48.7074896,33.7028669,0.0790175,9.0266938,10.3742402,1947.3030558,3426.894245,0.1291625,330.327251,215.7271647,478.2442216,15.2002603,19.4223225,0.1063929,61.4259643),(2658,'blackbuck_metacarpus.tif',237,5,18,121.1685024,48.7696357,33.3603603,1.8,48.7729662,33.8689987,0.0844873,9.0060455,9.9311948,1814.7479546,3164.7822832,0.1438097,318.670851,201.5033079,463.7815481,14.8320324,18.843518,0.0996687,58.9751389),(2659,'blackbuck_metacarpus.tif',237,5,19,116.7686971,48.7710973,33.4490164,1.8,48.7107148,33.9034656,0.0710321,8.5151687,10.0192202,1696.1945779,2915.756921,0.0980289,291.0163517,199.1968265,425.6705551,0.375,0.5303301,0.7853982,1.0606602),(2660,'blackbuck_metacarpus.tif',237,5,20,112.953615,48.7846028,33.5515033,1.8,48.7263633,34.0221761,0.053153,8.4227243,9.7819562,1605.8334676,2696.0882908,0.0531368,275.6185196,190.6548765,416.6591165,14.1947578,17.9775262,0.2854629,55.5279932),(2661,'blackbuck_metacarpus.tif',237,5,21,109.6805357,48.786269,33.6620878,1.8,48.7524463,34.1135263,0.0150906,8.8377022,9.5689174,1529.4015934,2518.4679471,0.0041626,263.1925671,173.0542127,400.210614,13.9841467,17.6220088,0.3587707,54.622663),(2662,'blackbuck_metacarpus.tif',237,5,22,106.4782484,48.7931114,33.7938333,1.8,48.7536066,34.2612002,-0.0115522,9.3322148,9.1486203,1465.9807813,2373.3230561,0.0023682,259.4186846,157.088196,375.7673589,13.6875009,17.3809578,0.3524576,53.7816727),(2663,'blackbuck_metacarpus.tif',237,5,23,105.2586779,48.844694,33.9443315,1.8,48.8447294,34.3756265,-0.0329825,8.2430956,9.057174,1438.4077678,2268.008225,0.0190773,250.410143,174.4984943,364.9389251,0.3356004,0.8385255,1.1071487,1.8106603),(2664,'blackbuck_metacarpus.tif',237,5,24,104.5252119,48.8836673,34.1013612,1.8,48.921778,34.5471773,-0.059909,8.2544777,8.8602408,1423.4949819,2185.0002503,0.0624503,246.6073214,172.451249,357.9086897,0.1875,0.4192628,2.677945,0.7954952),(2665,'blackbuck_metacarpus.tif',237,5,25,103.5569767,48.9718406,34.2010405,1.8,48.9696425,34.7084541,-0.1037346,8.4953585,8.7796535,1408.8121523,2093.5469413,0.1850619,238.454393,165.8331608,353.8475032,0.5885892,1.6770511,1.1071487,3.6213206),(2666,'blackbuck_metacarpus.tif',237,5,26,103.2019625,49.0053115,34.3404515,1.8,49.0174704,34.8997596,-0.1511895,8.77117,8.9565593,1402.590454,2032.1634247,0.390183,226.8910801,159.9091626,344.3746977,0.7954952,1.2577883,1.1071487,3.1364856),(2667,'blackbuck_metacarpus.tif',237,5,27,103.4468737,49.0359148,34.4835473,1.8,49.0370211,35.0380474,-0.1944123,8.6655801,8.7042944,1403.6585324,1989.8688351,0.6434802,228.6077123,161.9809085,342.9710768,0.572549,1.0606602,0.7853982,2.2311554),(2668,'blackbuck_metacarpus.tif',237,5,28,104.0699491,49.0717471,34.612047,1.8,49.0747666,35.1110628,-0.2284347,8.7197692,8.697138,1396.8887964,1959.3911001,0.8894691,225.2914808,160.1979103,335.0295794,13.6101527,16.5606141,0.5345943,51.2210124),(2669,'blackbuck_metacarpus.tif',237,5,29,104.7263377,49.1144061,34.7467671,1.8,49.106944,35.2262899,-0.2444021,8.8564085,8.7506136,1405.7961456,1942.3026357,1.0219983,221.9618793,158.7320801,337.1619058,0.5870627,1.846661,1.152572,4.1516507),(2670,'blackbuck_metacarpus.tif',237,5,30,104.988305,49.1513004,34.8751307,1.8,49.1749253,35.3450596,-0.257208,8.5630608,9.2157551,1411.6415208,1926.8414775,1.1322973,209.0812374,164.8524458,353.1351455,13.613425,16.3995532,0.5404195,50.9103522),(2671,'blackbuck_metacarpus.tif',237,5,31,105.5177476,49.1886512,34.9922301,1.8,49.2000437,35.4692736,-0.2789533,8.4729249,9.0432958,1409.7666083,1918.4219663,1.3333463,212.1374785,166.3848815,345.2248857,0.5341053,1.4279575,1.1659045,3.2463205),(2672,'blackbuck_metacarpus.tif',237,5,32,105.7588769,49.2270348,35.1049632,1.8,49.244145,35.5804478,-0.2926106,8.6623058,8.9237513,1407.9469868,1909.3347641,1.4666122,213.9610024,162.5372064,326.3855289,0.5915293,2.4375002,1.1760052,5.2766508),(2673,'blackbuck_metacarpus.tif',237,5,33,105.810173,49.3420561,35.1675589,1.8,49.3652874,35.668124,-0.3051934,8.9820743,8.9430863,1407.9251491,1895.7903661,1.5922108,211.9839057,156.7483296,324.2254373,0.7904415,5.6187469,1.122073,12.4549521),(2674,'blackbuck_metacarpus.tif',237,5,34,106.4039196,49.3792846,35.2677343,1.8,49.3962747,35.7846557,-0.3162699,8.9047178,9.1071805,1399.8264982,1884.3073403,1.7155101,206.9034812,157.200545,328.7797821,0.5584102,1.9304308,1.0636978,4.4623109),(2675,'blackbuck_metacarpus.tif',237,5,35,106.131384,49.4273446,35.3560892,1.8,49.4606393,35.8971847,-0.3226304,8.817892,8.9712698,1392.7970044,1868.3434366,1.7782051,208.2585282,157.9512437,336.5810345,0.1875,0.2651651,2.3561945,0.5303301),(2676,'blackbuck_metacarpus.tif',237,5,36,106.2988556,49.4559292,35.4387799,1.8,49.4449494,35.9418513,-0.3277467,8.5126594,9.1179273,1386.4827955,1863.083232,1.8358945,204.3318808,162.8730495,315.0757981,13.5286587,16.4626719,0.6480569,50.7095269),(2677,'blackbuck_metacarpus.tif',237,5,37,106.5782093,49.4955485,35.5247298,1.8,49.4961869,36.0617624,-0.3265831,8.4717624,8.9904994,1384.399141,1859.5958858,1.8281392,206.8401094,163.4133588,328.3682189,0.7610511,7.4671159,1.0734536,16.2316027),(2678,'blackbuck_metacarpus.tif',237,5,38,106.4248428,49.5270999,35.5959253,1.8,49.5367693,36.129894,-0.3227843,8.855857,9.1048005,1381.3501817,1854.4684375,1.7847647,203.6802945,155.9815368,317.8653797,0.6740569,3.6066347,1.0838971,7.9283014),(2679,'blackbuck_metacarpus.tif',237,5,39,105.7503541,49.5445456,35.6603464,1.8,49.5430014,36.1979077,-0.3224532,8.4935098,8.9872847,1372.386559,1846.0078849,1.7699431,205.4021822,161.580617,323.392045,0.7838291,5.6187469,1.122073,12.299622),(2680,'blackbuck_metacarpus.tif',237,5,40,106.1589231,49.5738731,35.7267403,1.8,49.5377542,36.2092942,-0.32349,8.3649869,8.9357167,1374.277497,1851.6596405,1.7878236,207.2200478,164.2892594,325.0646078,0.8095418,7.1274671,1.1071487,15.8566027),(2681,'blackbuck_metacarpus.tif',237,5,41,106.1667107,49.6802692,35.7502021,1.8,49.6684333,36.2718929,-0.3264423,8.7775403,9.0494431,1375.5142938,1840.4449198,1.8195671,203.3765953,156.7083993,309.3298165,1.1819715,10.0009771,1.0400228,21.4439137),(2682,'blackbuck_metacarpus.tif',237,5,42,105.9067036,49.707328,35.8018033,1.8,49.7011827,36.3221546,-0.3294004,8.9761519,9.0082682,1366.162468,1832.1586107,1.846952,203.3863305,152.1991255,312.9037544,1.0735642,9.5826999,1.0370881,20.6484185),(2683,'blackbuck_metacarpus.tif',237,5,43,105.71882,49.722483,35.856777,1.8,49.7055693,36.397925,-0.3354957,9.1111201,8.9522671,1364.2016928,1825.8991808,1.9099371,203.9594165,149.7293063,320.431807,0.1875,0.2651651,2.3561945,0.5303301),(2684,'blackbuck_metacarpus.tif',237,5,44,105.3856027,49.7400231,35.9035484,1.8,49.7381501,36.4358651,-0.3385532,8.64236,8.8994897,1358.8793397,1821.3873387,1.9374362,204.6619966,157.2347535,316.1872418,0.9832861,8.4707683,1.0873493,18.2619329),(2685,'blackbuck_metacarpus.tif',237,5,45,105.3662028,49.7602888,35.9534784,1.8,49.759949,36.4576174,-0.3435084,9.126339,9.2530474,1364.0870578,1821.6021208,1.9919349,196.8651024,149.4670591,317.4508416,0.9245672,5.1995346,1.1232764,11.3942918),(2686,'blackbuck_metacarpus.tif',237,5,46,105.1967923,49.7746083,35.9978377,1.8,49.7654252,36.54691,-0.3474665,9.085373,9.0955706,1363.935957,1822.094069,2.032958,200.3276257,150.1243762,307.3324763,0.8762266,8.3957305,1.0571903,18.042263),(2687,'blackbuck_metacarpus.tif',237,5,47,105.5459365,49.7826726,36.0261719,1.8,49.7778327,36.550901,-0.3483509,8.9607599,9.097442,1363.9751161,1819.1615203,2.0496773,199.9640689,152.2164562,314.3326044,0.8065656,7.0481052,1.0714496,15.1709425),(2688,'blackbuck_metacarpus.tif',237,5,48,106.1746688,49.7899824,36.065298,1.8,49.7874604,36.6075551,-0.3483453,9.0179461,9.1549346,1365.6508652,1819.7401293,2.0618244,198.7715059,151.4370178,311.1051623,0.6211565,3.1875002,1.080839,6.8676411),(2689,'blackbuck_metacarpus.tif',237,5,49,105.5629393,49.8559404,36.0879518,1.8,49.8464824,36.6450869,-0.3508548,8.647169,9.6153366,1363.1012115,1802.5955185,2.0783604,187.4708698,157.6355472,306.0151182,0.6259707,1.6770511,1.1071487,3.6213206),(2690,'blackbuck_metacarpus.tif',237,5,50,104.1366075,49.8692327,36.139855,1.8,49.8641624,36.7067206,-0.3533812,8.9275238,9.0231602,1357.32938,1791.8919535,2.0786688,198.5880675,152.0387292,297.784007,1.3928992,5.450416,1.1071487,13.7807774),(2691,'blackbuck_metacarpus.tif',237,5,51,103.3771791,49.8998708,36.1952062,1.8,49.9075026,36.7797832,-0.348731,9.0670534,8.7670971,1353.3141205,1781.2005826,2.0117648,203.1687973,149.2562202,304.6838093,0.7143081,4.4568244,1.1824776,9.8033015),(2692,'blackbuck_metacarpus.tif',237,5,52,103.9956842,49.9244788,36.2348077,1.8,49.9275951,36.7995562,-0.3395426,8.8630625,8.7271918,1351.6236468,1775.4786342,1.9226411,203.442147,152.5007465,304.425035,0.6690179,4.1121963,1.1479424,8.8979713),(2693,'blackbuck_metacarpus.tif',237,5,53,104.0473532,49.956636,36.2567387,1.8,49.9684642,36.7764224,-0.328749,8.7537166,8.7562463,1350.4187236,1765.1619201,1.8076168,201.5888847,154.2680424,289.5907537,0.6959601,3.2745469,1.1583859,7.2426411),(2694,'blackbuck_metacarpus.tif',237,5,54,103.6029568,49.9915883,36.28121,1.8,49.9910112,36.8021665,-0.317026,9.0634843,9.3789288,1342.9252706,1745.7153091,1.6780767,186.1316312,148.1687646,300.5026906,0.7911007,3.6933219,1.152572,8.3033014),(2695,'blackbuck_metacarpus.tif',237,5,55,103.1841287,50.0290312,36.2990624,1.8,50.0430978,36.8246641,-0.3195528,9.0327908,8.5247349,1332.5588159,1727.3408558,1.6971244,202.6269293,147.5245967,305.2491278,0.8839446,5.2096668,1.0427219,11.1746219),(2696,'blackbuck_metacarpus.tif',237,5,56,102.6842067,50.0569953,36.3235262,1.8,50.0520985,36.8065341,-0.3149893,8.9944238,8.5598908,1319.1075142,1714.4377611,1.6426036,200.2873404,146.6583677,288.8700948,0.6290942,4.2838726,1.1659045,9.4283014),(2697,'blackbuck_metacarpus.tif',237,5,57,101.9138799,50.1493272,36.3113063,1.8,50.1551667,36.8353806,-0.3211729,8.6888055,9.2328143,1308.0866139,1696.9162549,1.6926825,183.7918762,150.5484973,297.7787843,0.8659804,5.6187469,1.122073,12.1442919),(2698,'blackbuck_metacarpus.tif',237,5,58,101.3955489,50.1684085,36.3349968,1.8,50.2009262,36.8414234,-0.3226064,8.7224713,8.416639,1293.2679544,1684.7274199,1.698614,200.1662913,148.2685256,303.2169247,13.6597258,16.165285,0.9087359,50.114857),(2699,'blackbuck_metacarpus.tif',237,5,59,101.0788443,50.1931927,36.3668293,1.8,50.2224779,36.9058104,-0.324926,9.2807694,8.8445158,1284.888166,1680.7633865,1.7168802,190.0345279,138.446298,298.5168634,0.6823615,1.6770511,1.1071487,3.7766507),(2700,'blackbuck_metacarpus.tif',237,5,60,100.6618805,50.2169865,36.3874279,1.8,50.2373492,36.8945389,-0.3144321,8.52677,8.3641379,1270.9809354,1673.7779091,1.6047506,200.1136203,149.057725,300.1037801,0.8165039,6.2073549,1.1341692,13.7352822),(2701,'blackbuck_metacarpus.tif',237,5,61,100.707786,50.2488951,36.426151,1.8,50.2607592,36.9542388,-0.2964779,8.314343,9.2983106,1265.1594913,1672.6453929,1.4326309,179.8870217,152.1659005,304.8972179,0.7420737,5.450416,1.1071487,11.9246219),(2702,'blackbuck_metacarpus.tif',237,5,62,100.4722285,50.2784277,36.4506189,1.8,50.2906606,36.9519919,-0.2801597,8.5218066,8.4896971,1257.0656612,1671.564641,1.2803062,196.8933195,147.5116386,278.0673024,0.7209635,3.2040016,1.2120257,7.087311),(2703,'blackbuck_metacarpus.tif',237,5,63,100.1917135,50.3040839,36.4685732,1.8,50.3422206,36.9859318,-0.2658194,8.4790448,9.0383323,1245.7447121,1672.1038382,1.1523927,185.0013683,146.9204076,300.4426759,0.5625,1.2577883,1.1071487,2.8713205),(2704,'blackbuck_metacarpus.tif',237,5,64,100.0966425,50.3286475,36.4917704,1.8,50.3478101,36.9765281,-0.2616548,8.540876,8.9978984,1239.3920581,1673.6562239,1.1163281,186.0052365,145.11299,291.1817068,0.4157892,1.6020008,1.2120257,3.4659905),(2705,'blackbuck_metacarpus.tif',237,5,65,99.3777717,50.4083692,36.485864,1.8,50.4306136,36.9928802,-0.2565443,8.8019871,8.8365768,1231.7999935,1659.550496,1.0663848,187.8046815,139.9456708,289.5800294,0.7775499,5.0311533,1.1071487,10.8639617),(2706,'blackbuck_metacarpus.tif',237,5,66,99.0744264,50.4356503,36.5219215,1.8,50.4749772,37.0081181,-0.2531439,8.5027271,8.1461704,1223.899535,1656.7734198,1.0357347,203.3806484,143.9419995,296.5079668,0.8077654,5.0311533,1.1071487,11.1746219),(2707,'blackbuck_metacarpus.tif',237,5,67,99.2675302,50.4698975,36.5605728,1.8,50.4980474,37.0617533,-0.2461198,8.7728592,8.6280368,1211.5475009,1650.6585349,0.9821149,191.31334,138.1017841,304.6191952,0.6530945,1.6020008,1.2120257,3.7766507),(2708,'blackbuck_metacarpus.tif',237,5,68,98.9586026,50.5076339,36.5861795,1.8,50.5051698,37.0770023,-0.2410687,8.3655094,8.8766153,1209.2227577,1647.677191,0.9400584,185.6199839,144.5486102,284.5523182,0.7586914,4.1926277,1.1071487,9.2086315),(2709,'blackbuck_metacarpus.tif',237,5,69,99.0624414,50.5548427,36.6148575,1.8,50.5745256,37.0684574,-0.2314134,8.6727877,8.6473988,1202.1996557,1648.3294425,0.8684975,190.6156394,138.6174434,273.3037447,0.71763,5.3724561,1.060308,11.5496219),(2710,'blackbuck_metacarpus.tif',237,5,70,98.7813405,50.5975707,36.6323992,1.8,50.6404229,37.0715219,-0.2193661,8.0554627,8.7249472,1191.9964851,1643.3554801,0.7796237,188.3513378,147.9736834,289.4206097,0.5420688,3.3541022,1.1071487,7.2426411),(2711,'blackbuck_metacarpus.tif',237,5,71,98.6171075,50.6347246,36.6501258,1.8,50.6677025,37.07211,-0.2126647,7.9556843,8.5446471,1180.909918,1642.3685213,0.7322086,192.2102227,148.4359955,296.6054008,0.5619099,3.941962,1.1284221,8.6783014),(2712,'blackbuck_metacarpus.tif',237,5,72,98.2895258,50.6770769,36.6604442,1.8,50.6938896,37.0524146,-0.1961501,8.3486333,8.7072801,1166.4004494,1640.1091864,0.6222373,188.3606774,139.7115438,285.645308,0.6037463,3.941962,1.1284221,8.6783014),(2713,'blackbuck_metacarpus.tif',237,5,73,97.2442345,50.7756626,36.6311207,1.8,50.8128478,37.0528803,-0.1806346,8.3099832,8.0848645,1149.6161798,1622.5468812,0.5231016,200.6894329,138.3415765,288.0084349,13.2361748,15.6537246,0.7515128,49.8763424),(2714,'blackbuck_metacarpus.tif',237,5,74,96.6630803,50.8209382,36.6559782,1.8,50.8262498,37.1109569,-0.1648518,8.3515818,8.2231045,1140.7506154,1615.5047942,0.4338697,196.459231,136.5909654,286.0217928,0.7244712,4.9536921,1.056345,10.6442918),(2715,'blackbuck_metacarpus.tif',237,5,75,96.1183075,50.884483,36.6709777,1.8,50.9139677,37.1037606,-0.1418638,8.2615543,8.6206532,1129.7026497,1604.9170943,0.3202453,186.1711699,136.7421435,285.6850255,12.992676,15.5579822,0.7086263,49.145187),(2716,'blackbuck_metacarpus.tif',237,5,76,96.1222599,50.9395391,36.7010652,1.8,50.9736694,37.1618525,-0.1289131,8.6717255,8.6512771,1122.8673776,1607.4467637,0.2647644,185.8045637,129.4860385,281.9978802,12.9861323,15.5805628,0.6916566,48.9898569),(2717,'blackbuck_metacarpus.tif',237,5,77,96.1859566,50.9922925,36.7245927,1.8,51.0224772,37.1750601,-0.1095798,8.0570898,8.8055402,1114.044605,1609.4751533,0.1917268,182.7798313,138.268858,288.6527969,12.8249211,15.5805628,0.6916566,49.0996919),(2718,'blackbuck_metacarpus.tif',237,5,78,96.2063259,51.0522035,36.744114,1.8,51.0837373,37.1572445,-0.0974683,7.8848507,8.7546412,1106.7257651,1609.3234649,0.1518459,183.8251766,140.3610305,283.3032821,12.8766285,15.4991189,0.6047796,49.0996919),(2719,'blackbuck_metacarpus.tif',237,5,79,96.1465177,51.1108654,36.7595373,1.8,51.1163475,37.1480155,-0.0839708,7.5395521,8.3796548,1093.5801357,1605.0013712,0.1127244,191.5355004,145.0457687,301.4924153,12.8700838,15.4616471,0.6823166,48.7246919),(2720,'blackbuck_metacarpus.tif',237,5,80,95.9821143,51.1659892,36.7703534,1.8,51.1661515,37.1512882,-0.0719617,7.8780325,8.5194718,1078.5990624,1600.3370404,0.0826973,187.8446323,136.9122378,289.4583437,12.6858847,15.3932828,0.5947593,48.6148569),(2721,'blackbuck_metacarpus.tif',237,5,81,95.4193692,51.2704792,36.7550911,1.8,51.303583,37.1542758,-0.0620494,7.6613716,8.7246674,1069.1358449,1586.4309348,0.0611509,181.8328263,139.5488829,284.2734709,12.5049579,15.3452466,0.611727,48.1488666),(2722,'blackbuck_metacarpus.tif',237,5,82,95.1445858,51.3372701,36.7879511,1.8,51.3886951,37.2126913,-0.053013,7.6492059,8.317943,1064.5425261,1576.3440696,0.0445237,189.5112861,139.1703318,282.1224556,12.5625008,15.316582,0.6900361,48.0390317),(2723,'blackbuck_metacarpus.tif',237,5,83,94.6445147,51.4008048,36.8011891,1.8,51.4126339,37.2061434,-0.0395128,7.9796358,8.3562014,1051.0468912,1562.9092339,0.0246147,187.0358509,131.7161474,280.5480767,12.5625008,15.262547,0.6459581,48.1943617),(2724,'blackbuck_metacarpus.tif',237,5,84,94.1678065,51.4656293,36.823875,1.8,51.4880291,37.2032647,-0.0314866,7.6778341,8.4040905,1044.0538833,1553.7358535,0.0155547,184.8785241,135.9828649,257.4927158,12.5625008,15.1921299,0.6188148,47.9746918),(2725,'blackbuck_metacarpus.tif',237,5,85,94.4571851,51.536376,36.8434432,1.8,51.5546132,37.1791247,-0.0221377,7.650884,8.317673,1035.6565772,1547.6952829,0.007714,186.0731089,135.364303,276.1221336,12.5016856,15.1504186,0.6360755,47.6640316),(2726,'blackbuck_metacarpus.tif',237,5,86,94.6362689,51.5978124,36.8736189,1.8,51.6272479,37.2132506,-0.0135902,7.8036979,8.3210858,1035.2804956,1547.007344,0.0029129,185.9141197,132.6653733,283.7659878,12.3338481,15.145777,0.5467888,47.3988666),(2727,'blackbuck_metacarpus.tif',237,5,87,93.8565884,51.6483103,36.8928085,1.8,51.6314254,37.2058847,-0.0073525,7.7478975,8.3649249,1020.8384654,1542.8408506,0.0008457,184.4416849,131.7568366,280.9495248,12.3305758,15.0853053,0.5638694,47.2435365),(2728,'blackbuck_metacarpus.tif',237,5,88,93.965722,51.7163228,36.8949346,1.8,51.7046751,37.1733096,0.0000184,7.7300503,8.8461748,1005.6545455,1534.7504611,0.000000007819,173.4931193,130.0967665,281.1903752,12.3273034,15.0292693,0.5810823,47.1337015),(2729,'blackbuck_metacarpus.tif',237,5,89,92.9089889,51.8395399,36.868175,1.8,51.8793855,37.1985335,0.0089657,7.7825346,8.3600173,988.7608987,1514.7349963,0.0012447,181.1880225,127.0487,273.1942142,12.2693074,14.9859318,0.5532943,46.8685365),(2730,'blackbuck_metacarpus.tif',237,5,90,92.4141593,51.9013611,36.8877528,1.8,51.9102921,37.2120962,0.0126003,7.3942849,8.454697,977.647292,1500.7110553,0.0024452,177.5002764,132.2166109,277.3811038,12.2502957,14.9024179,0.3734971,47.0238665),(2731,'blackbuck_metacarpus.tif',237,5,91,92.171645,51.9684453,36.9108673,1.8,52.0007421,37.2468208,0.0229158,7.5984059,8.9673139,969.0805198,1490.9178565,0.0080657,166.2613652,127.5373454,263.3020573,12.1038674,14.9024179,0.3734971,46.6033714),(2732,'blackbuck_metacarpus.tif',237,5,92,92.2320073,52.0297348,36.9375868,1.8,52.0417558,37.2438039,0.0326391,7.5456001,8.2207276,962.985134,1485.9125041,0.0163702,180.7519458,127.6220742,276.3549459,12.0875101,14.8267346,0.1651487,46.4935364),(2733,'blackbuck_metacarpus.tif',237,5,93,92.1856543,52.0928484,36.9530791,1.8,52.0948884,37.2290146,0.0356072,7.4117854,8.1864914,949.6632004,1483.4425397,0.0194717,181.2061442,128.1288044,274.2082108,12.1687733,14.8267346,0.2296424,46.6488665),(2734,'blackbuck_metacarpus.tif',237,5,94,92.2582253,52.1536364,36.9603513,1.8,52.1678379,37.2363724,0.0392847,7.479871,8.2141268,943.7260588,1480.4025896,0.0237179,180.2264104,126.1687605,271.9281901,12.1458801,14.7851814,0.2172934,46.5390316),(2735,'blackbuck_metacarpus.tif',237,5,95,92.2170499,52.2061364,36.9588445,1.8,52.209115,37.2050707,0.0388483,8.0819356,8.2201328,927.3733011,1476.362924,0.0231838,179.603293,114.7464349,272.7376645,11.8860455,14.7697176,0.1401017,45.9632063),(2736,'blackbuck_metacarpus.tif',237,5,96,92.0000719,52.2631275,36.9753202,1.8,52.2825262,37.2120695,0.040691,7.2132601,8.1267279,911.8365223,1463.0890698,0.0253742,180.0342142,126.411153,268.4854784,11.8631523,14.7220348,3.026716,45.8533713),(2737,'blackbuck_metacarpus.tif',237,5,97,90.949571,52.3473458,36.9329227,1.8,52.3594019,37.1623134,0.0423811,7.8216985,8.0581017,893.2901017,1437.663024,0.0272103,178.4121211,114.2066655,266.1765568,11.8402591,14.7088949,2.9491971,45.6337014),(2738,'blackbuck_metacarpus.tif',237,5,98,90.16385,52.3985575,36.9451502,1.8,52.4323327,37.1506834,0.0446234,7.56401,8.1889347,877.6062737,1420.7903719,0.0299033,173.5012456,116.0239443,264.6181997,11.676002,14.7220348,3.026716,45.5882063),(2739,'blackbuck_metacarpus.tif',237,5,99,89.4337718,52.4469219,36.9717969,1.8,52.4631211,37.206115,0.0491563,7.5768615,8.1870116,863.6741442,1405.9246696,0.0359881,171.726235,113.9883768,240.7130846,0.375,0.7730824,1.815775,1.8106603),(2740,'blackbuck_metacarpus.tif',237,5,100,87.733381,52.492534,36.9852407,1.8,52.4891519,37.1927715,0.0534897,7.4712779,8.3802166,847.2241294,1393.0196567,0.0417964,166.2271665,113.3974855,259.5280628,11.4659585,14.674197,2.9617392,44.7927111),(2741,'blackbuck_metacarpus.tif',237,5,101,87.3358703,52.5359802,36.9864354,1.8,52.5344108,37.1437365,0.0527128,7.1170668,8.2296733,836.4124893,1388.8169247,0.0404084,168.7572363,117.5220802,248.873076,11.4430653,14.7458955,2.9367159,44.6828761),(2742,'blackbuck_metacarpus.tif',237,5,102,86.9614881,52.5840638,36.9952775,1.8,52.5657834,37.1397627,0.0518496,7.1813102,8.1811239,826.2223047,1382.0184769,0.0389294,168.9277039,115.0517504,258.2460179,0.1875,0.2651651,2.3561945,0.5303301),(2743,'blackbuck_metacarpus.tif',237,5,103,86.6135691,52.6278956,37.002751,1.8,52.6089215,37.1434538,0.0507075,7.4982029,8.933426,814.2272497,1376.6830602,0.0370857,154.1047147,108.5896529,243.7765841,11.3433984,14.7697176,3.0014909,44.3078761),(2744,'blackbuck_metacarpus.tif',237,5,104,86.1008843,52.6609798,37.005335,1.8,52.6527185,37.1557525,0.0463844,7.8410106,8.2992527,801.0189656,1367.513867,0.0308524,164.7755436,102.1576177,237.4707397,11.2788461,14.7458955,2.9367159,44.3078761),(2745,'blackbuck_metacarpus.tif',237,5,105,84.8886221,52.7249835,36.9628705,1.8,52.678131,37.1309616,0.0429225,7.5900387,8.2601863,789.0098998,1343.5113246,0.0260496,162.649034,103.9533434,231.5878928,0.375,1.0097185,1.1902899,2.1856603),(2746,'blackbuck_metacarpus.tif',237,5,106,83.9025105,52.7510355,36.9885773,1.8,52.7474512,37.1479715,0.038,7.7921978,8.228481,778.8663942,1322.5942054,0.0201828,160.7337002,99.9546482,231.7730528,0.1875,0.5929271,1.8925469,1.2803302),(2747,'blackbuck_metacarpus.tif',237,5,107,83.1536823,52.7674708,37.0148109,1.8,52.7601365,37.215061,0.0330204,7.6520149,8.2063585,770.1224553,1303.9845803,0.0151056,158.8992959,100.6430942,227.1431265,11.2500007,14.7220348,3.026716,43.9328761),(2748,'blackbuck_metacarpus.tif',237,5,108,83.9128869,52.7871093,37.0337097,1.8,52.7954,37.2371706,0.0345342,6.9118658,8.3037058,758.0510407,1291.1141567,0.0166726,155.4865008,109.673866,228.0734322,0.1875,0.5929271,1.8925469,1.2803302),(2749,'blackbuck_metacarpus.tif',237,5,109,83.2473897,52.7962702,37.0431427,1.8,52.813757,37.2041905,0.0309303,6.7137742,8.1572667,749.5884205,1275.1467765,0.0132693,156.3203487,111.6493341,219.7483067,11.216179,14.6418182,2.9743387,43.777546),(2750,'blackbuck_metacarpus.tif',237,5,110,82.0541225,52.8023697,37.0646417,1.8,52.8287344,37.2497788,0.02578,7.2246001,8.1484865,737.7600723,1258.2563565,0.0090869,154.4159589,102.1177724,216.8315329,0.375,0.8385255,1.1071487,1.8106603),(2751,'blackbuck_metacarpus.tif',237,5,111,81.4069917,52.7987111,37.0805095,1.8,52.8132719,37.2516094,0.0223248,6.8203959,8.1503144,728.9556704,1241.077336,0.0067611,152.2735527,106.8787911,214.3039033,11.0625007,14.5840783,2.9996956,43.402546),(2752,'blackbuck_metacarpus.tif',237,5,112,79.433,52.7911482,37.0862616,1.8,52.7745506,37.2006345,0.0113208,6.8022151,8.15264,716.1463405,1222.2432468,0.0016966,149.9199332,105.2813435,237.3001845,11.0625007,14.5587451,3.0124454,43.292711),(2753,'blackbuck_metacarpus.tif',237,5,113,77.7135609,52.8417358,37.0282862,1.8,52.8470853,37.1693635,0.0013396,6.6550811,8.0966438,695.8700778,1195.8633713,0.0000232,147.6986512,104.5622235,232.898595,0.375,1.0097185,1.1902899,2.1856603),(2754,'blackbuck_metacarpus.tif',237,5,114,76.6042212,52.8496947,37.0270786,1.8,52.8775244,37.1483372,-0.0071659,7.5992541,8.0842126,678.1020727,1181.6283995,0.0006556,146.1649342,89.2327151,229.1796348,0.2651651,0.5303301,0.7853982,1.0606602),(2755,'blackbuck_metacarpus.tif',237,5,115,75.6270372,52.8544458,37.0243316,1.8,52.8679301,37.1458684,-0.0123109,6.4841693,8.0765897,661.0684385,1172.4665222,0.0019103,145.168514,101.9511372,199.3776816,0.1875,0.5929271,1.8925469,1.2803302),(2756,'blackbuck_metacarpus.tif',237,5,116,74.8254639,52.8602143,37.0175643,1.8,52.8825176,37.131145,-0.01357,6.8620963,8.075088,642.8995727,1164.5739143,0.0022963,144.2181086,93.6885087,223.0065399,0.375,1.0097185,1.1902899,2.1856603),(2757,'blackbuck_metacarpus.tif',237,5,117,74.2615576,52.8765266,37.0126514,1.8,52.8982446,37.1408185,-0.0171703,7.0681017,7.8736069,628.8877761,1156.8678386,0.0036486,146.929845,88.9754849,196.9040818,10.6875007,14.5840783,0.1418971,42.542711),(2758,'blackbuck_metacarpus.tif',237,5,118,73.6832905,52.9025654,37.0006733,1.8,52.9246213,37.0946463,-0.0175719,6.441834,8.2091007,611.9092641,1150.5092755,0.0037915,140.150464,94.9899144,196.9919818,10.6875007,14.6682063,0.0767719,42.542711),(2759,'blackbuck_metacarpus.tif',237,5,119,73.3754495,52.9326187,36.9946872,1.8,52.9774396,37.0886439,-0.0159965,6.7270282,8.1802548,596.102889,1147.9368674,0.0031291,140.3302085,88.6131104,211.6669569,10.5000007,14.7017228,0.1022067,42.1222158),(2760,'blackbuck_metacarpus.tif',237,5,120,73.0519907,52.9495961,36.9927255,1.8,52.9923246,37.0831468,-0.0153037,6.2632194,8.1609488,579.8181158,1148.2441055,0.0028513,140.6998298,92.5750927,210.1529982,10.5000007,14.7017228,3.0393859,42.2775459),(2761,'blackbuck_metacarpus.tif',237,5,121,72.0461702,53.0256959,36.9340487,1.8,53.0401404,37.0424026,-0.0170478,6.5880015,8.1012969,561.2775552,1136.1594185,0.0034894,140.2441402,85.1969377,184.446447,0.3562946,0.8385255,1.1071487,1.8106603),(2762,'blackbuck_metacarpus.tif',237,5,122,71.4436346,53.0374608,36.9348123,1.8,53.0523246,37.0166359,-0.0243442,6.2188809,8.14468,547.4246897,1132.7268389,0.0070553,139.075671,88.0262377,182.3722196,10.3125006,14.870536,3.0532159,42.432876),(2763,'blackbuck_metacarpus.tif',237,5,123,70.9454918,53.0580838,36.941528,1.8,53.0917459,37.0538517,-0.0305251,6.2113971,8.2335299,533.5111151,1136.9093927,0.0110142,138.0828652,85.8922891,181.0266534,10.3125006,14.9307002,3.01568,42.1222158),(2764,'blackbuck_metacarpus.tif',237,5,124,72.1568485,53.0710688,36.9642213,1.8,53.0759246,37.1197703,-0.035644,6.5780976,8.2171069,526.1130893,1145.4704705,0.0152726,139.4007023,79.97952,201.049387,9.9375006,14.9554034,0.138351,41.8115556),(2765,'blackbuck_metacarpus.tif',237,5,125,72.2003997,53.0956941,36.9815742,1.8,53.1348727,37.1194223,-0.0374969,6.9716869,8.257045,523.616895,1159.6563503,0.0169113,140.4444752,75.1061973,182.1533193,9.9375006,15.0748144,3.041924,41.9668857),(2766,'blackbuck_metacarpus.tif',237,5,126,72.4825765,53.1035859,37.0150001,1.8,53.108438,37.1382812,-0.039206,6.3571962,8.3415586,523.2488291,1186.3548893,0.0185594,142.2222094,82.3081143,200.7504533,10.1250006,15.1411339,3.0049495,42.3418857),(2767,'blackbuck_metacarpus.tif',237,5,127,73.705375,53.1145951,37.074121,1.8,53.1153791,37.2128804,-0.0403503,6.479059,8.3462762,527.0526325,1219.9572557,0.0199897,146.1678501,81.3470953,206.353048,10.113416,15.4309206,3.0564333,42.7623809),(2768,'blackbuck_metacarpus.tif',237,5,128,73.5440504,53.1187616,37.1187237,1.8,53.1515583,37.1983875,-0.0408542,6.6219712,8.5000717,530.9905138,1258.5527156,0.0204469,148.063777,80.1861711,205.691609,0.1875,0.2651651,2.3561945,0.5303301),(2769,'blackbuck_metacarpus.tif',237,5,129,74.3707976,53.1516332,37.1101284,1.8,53.1742019,37.2245126,-0.0448025,6.7792871,8.1856059,538.9250353,1298.3697733,0.0248636,158.6162087,79.4958268,212.530521,10.1250006,15.6750458,3.0216887,43.3570508),(2770,'blackbuck_metacarpus.tif',237,5,130,74.930954,53.1500182,37.1566667,1.8,53.1707053,37.2435195,-0.0475103,6.5994538,8.3865915,552.3842347,1353.6356073,0.0281682,161.4047379,83.7015074,214.1035789,0.1875,0.2651651,2.3561945,0.5303301),(2771,'blackbuck_metacarpus.tif',237,5,131,75.6339086,53.1571747,37.2063897,1.8,53.1429586,37.3159912,-0.0472811,7.2805908,8.7119333,569.5078537,1417.1703719,0.0281589,162.6700217,78.2227525,224.7462899,10.3081807,16.21306,0.1042716,44.4632062),(2772,'blackbuck_metacarpus.tif',237,5,132,76.7464549,53.1299714,37.2783846,1.8,53.1128749,37.3909499,-0.0515377,7.9530953,8.2502282,595.1929861,1503.5166347,0.0339447,182.2393991,74.8379042,245.3515036,10.3125006,16.442372,0.1257694,45.0578762),(2773,'blackbuck_metacarpus.tif',237,5,133,77.7292959,53.100184,37.3490597,1.8,53.1127366,37.4759665,-0.0533372,6.8018469,8.4012039,621.1018763,1609.9826054,0.0368199,191.637131,91.3137099,258.1151404,10.6875007,16.8144758,0.1229719,46.4291966),(2774,'blackbuck_metacarpus.tif',237,5,134,79.3945305,53.1226547,37.3939984,1.8,53.1842253,37.4989487,-0.051888,6.5312031,8.9806672,657.160176,1724.6368228,0.0355946,192.0388298,100.6185488,264.710694,10.8750007,17.1867056,0.1202955,47.6451869),(2775,'blackbuck_metacarpus.tif',237,5,135,81.8087744,53.1361692,37.4113009,1.8,53.1937435,37.5314804,-0.0532743,6.7951242,9.0155955,702.7751899,1855.7206299,0.038661,205.8345044,103.4234498,280.7436701,11.0625007,17.5820632,0.1283232,49.9406822),(2776,'blackbuck_metacarpus.tif',237,5,136,83.3332881,53.1256154,37.4500399,1.8,53.132028,37.5385416,-0.056131,6.8151318,9.1862514,754.6704357,2006.275902,0.0437136,218.3998472,110.7345322,296.4656912,11.2500007,17.9785039,0.1359974,50.2513424),(2777,'blackbuck_metacarpus.tif',237,5,137,87.2666657,53.1944488,37.4481875,1.8,53.1844626,37.5770429,-0.0575813,8.5755576,9.4294285,830.4512616,2197.5884588,0.0481704,233.0563784,96.8393316,316.4979778,11.4375007,18.4979951,0.18348,50.489857),(2778,'blackbuck_metacarpus.tif',237,5,138,87.333388,53.1676662,37.6310327,1.8,53.1224492,37.6759065,-0.0538929,8.2584454,9.585969,863.5504486,2409.8867875,0.0422348,251.3973067,104.5657396,335.7745422,11.6250007,19.1185663,0.1377362,52.0996921),(2779,'blackbuck_metacarpus.tif',237,5,139,88.9014422,53.1551362,37.7824006,1.8,53.0958417,37.7693431,-0.0481641,7.5567322,10.1741337,913.3141318,2668.4920823,0.0343454,262.2819947,120.8609899,349.8281243,12.0000008,19.9182914,3.0756507,53.8005174),(2780,'blackbuck_metacarpus.tif',237,5,140,94.9984423,53.0756903,37.9484988,1.8,52.9922529,37.9652581,-0.0462078,7.713257,10.2570717,1015.9198209,3039.8984834,0.0337821,296.3709888,131.7108738,372.3935117,12.4765934,20.7100532,0.0906599,56.2058476),(2781,'blackbuck_metacarpus.tif',237,5,141,115.0801209,52.9416958,38.0938053,1.8,53.0137104,38.1903633,-0.0392705,8.0043425,10.7791201,1244.1386525,3775.8900528,0.0295639,350.2966864,155.4329613,428.8970326,12.6940716,21.5355824,0.1221952,58.8308478),(2782,'blackbuck_metacarpus.tif',237,5,142,134.5311283,53.1890446,38.177777,1.8,53.0096818,38.3794312,-0.0401258,8.2885762,12.0294196,1472.7853863,4651.8713806,0.0360816,386.7078832,177.6885864,497.1094101,12.8813146,22.4452473,0.1088122,62.3800228),(2783,'blackbuck_metacarpus.tif',237,5,143,134.2059969,53.1647548,38.3976184,1.8,53.0526196,38.6491951,-0.0331772,9.3192375,12.1280131,1468.4000093,4750.980927,0.0246116,391.7361299,157.5665394,490.7143269,13.4658077,23.0472525,0.1223368,65.8271686),(2784,'blackbuck_metacarpus.tif',237,5,144,137.2516258,53.180184,38.54226,1.8,53.0124858,38.793162,-0.0207499,8.9616365,12.9172024,1483.9585065,4870.3655668,0.0098476,377.0449222,165.5901251,484.612912,0.375,0.5303301,0.7853982,1.0606602),(2785,'blackbuck_metacarpus.tif',237,5,145,138.621452,52.9963614,38.4768706,1.8,52.8497796,38.7585511,-0.0131317,9.8513672,12.6502407,1707.9206104,4808.8391253,0.0039839,380.1381512,173.3688921,476.6682312,0.375,0.8385255,1.1071487,1.8106603),(2786,'blackbuck_metacarpus.tif',237,5,146,141.9584943,52.8788387,38.3441909,1.8,52.7537286,38.7619614,-0.0296981,9.8926534,12.021704,2200.2512074,4985.2873866,0.0208612,414.6905786,222.4126445,530.4206278,0.5625,1.3650207,1.849096,3.2463205),(2787,'blackbuck_metacarpus.tif',237,5,147,139.8930111,52.939757,38.2893869,1.8,52.8267956,38.820223,-0.0319848,9.9884449,12.0873049,2587.6386772,5097.2873664,0.0238443,421.7058661,259.0632169,601.5381067,0.5625,0.8385255,2.0344439,1.9659904),(2788,'blackbuck_metacarpus.tif',237,5,148,135.3912953,52.9506086,38.323578,1.8,52.8604729,38.8447947,-0.0167273,10.0895252,11.8894594,2787.3021992,5071.4783412,0.0063132,426.5524752,276.2570227,609.9230094,10.4870607,17.6409513,1.6133239,55.6111777),(2789,'blackbuck_metacarpus.tif',237,5,149,132.4508156,52.8561297,38.4328136,1.8,52.8173182,38.8249103,-0.0252185,9.9064083,11.5549502,2820.0223961,5056.5171838,0.0140362,437.6061412,284.6664825,612.5741419,10.6482719,17.6309841,0.9975419,54.6603524),(2790,'blackbuck_metacarpus.tif',237,5,150,133.898891,52.8333984,38.6203779,1.8,52.8341179,38.9097798,-0.0353255,9.8162303,11.4286824,2695.5003914,5230.7491313,0.0278369,457.6861053,274.5962857,612.5363281,10.6789302,17.3171259,0.9857967,52.5123815),(2791,'blackbuck_metacarpus.tif',237,5,151,135.4727726,52.9815792,38.7676408,1.8,52.9884763,38.9209434,-0.0203702,9.3199357,11.7567905,2375.2043506,5385.4703386,0.0093677,458.0731724,254.8520106,616.5362725,10.6875007,16.5903079,0.9702552,50.5918863),(2792,'blackbuck_metacarpus.tif',237,5,152,132.5634541,53.2130585,38.8606265,1.8,53.2339612,38.8510291,-0.0137829,8.8054006,11.6459958,1853.0926536,5310.4132238,0.0041969,455.9861861,210.4495557,586.7955251,10.6875007,15.4616471,0.8884798,48.0767211),(2793,'blackbuck_metacarpus.tif',237,5,153,112.8840589,54.1038709,38.7998531,1.8,53.7147378,38.7894168,-0.0053707,8.475652,12.1208806,1163.6785779,3944.8895649,0.0005426,325.4622911,137.2966439,408.0401694,10.5000007,13.811511,0.7277697,45.3418859),(2794,'blackbuck_metacarpus.tif',237,5,154,74.6687735,54.4957787,38.7319459,1.8,54.7791922,38.6700612,0.0011097,6.4859671,9.8193054,502.5257147,1814.7278344,0.0000154,184.8122402,77.4789187,229.6680267,6.4915371,11.4620645,1.5053163,36.6258951),(2795,'blackbuck_metacarpus.tif',237,5,155,25.6138349,55.2431481,38.6208389,1.8,54.5020607,38.5886091,-0.0174903,5.1261287,8.7681149,103.1467917,423.748316,0.0013058,48.3283259,20.1217718,58.5378663,2.6250002,7.883924,1.5232132,17.9246223),(2796,'blackbuck_metacarpus.tif',237,5,156,2.5870209,58.2182452,38.5974567,1.8,58.2219376,38.5952854,1.469175,0.9131934,3.0595314,0.3802262,4.7789593,0.4267328,1.5619906,0.4163698,1.683974,1.8750001,6.2889416,1.7506498,14.2578066),(2797,'blackbuck_metacarpus.tif',237,5,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2798,'blackbuck_metacarpus.tif',237,5,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2799,'blackbuck_metacarpus.tif',237,5,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2800,'blackbuck_metacarpus.tif',237,5,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2801,'blackbuck_metacarpus.tif',237,5,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2802,'blackbuck_metacarpus.tif',237,5,162,1.7094782,67.5626425,33.307705,1.8,67.4555222,33.2927949,-1.5705788,1.0004908,4.8078119,0.3010875,7.1619833,0.284913,1.4896555,0.3009398,1.5439924,16.125001,16.5733465,1.1881891,53.8271678),(2803,'blackbuck_metacarpus.tif',237,5,163,6.5336301,66.97323,33.3039392,1.8,66.8433439,33.2773544,1.570088,2.0984086,7.0531643,4.0242031,61.9612972,1.0889378,8.7848936,1.9177405,9.2448449,19.3125012,19.6168387,0.9483246,64.0509645),(2804,'blackbuck_metacarpus.tif',237,5,164,12.2384887,66.4800919,33.3075166,1.8,66.3456425,33.2892321,1.5693368,2.7310045,8.5551964,14.9569587,179.0806997,2.0397438,20.9323891,5.4767243,22.2965385,21.719892,21.9983145,1.2409597,71.9337707),(2805,'blackbuck_metacarpus.tif',237,5,165,224.3866367,45.5406878,34.3403367,1.8,48.4392628,34.4356209,-0.0572487,14.2811287,23.0980236,10901.9890783,17449.224421,0.1224339,755.4423155,763.3842734,1136.7338365,28.5000018,29.2313661,2.1783694,94.7600437),(2806,'blackbuck_metacarpus.tif',237,5,166,465.6677606,47.4926185,34.530281,1.8,49.0647842,34.4414295,-0.0729573,14.3095674,21.3784171,23098.3496346,30463.0147877,0.4123749,1424.9424879,1614.1892344,2256.597725,28.8750018,29.2944392,2.1925339,95.6653739),(2807,'blackbuck_metacarpus.tif',237,5,167,475.4365758,47.6611159,34.5128317,1.8,49.3660359,34.4154055,-0.0773684,14.2671677,21.3123221,23534.8440656,32132.1608062,0.473372,1507.6799567,1649.5806685,2322.7765476,28.8750018,29.1982734,2.3107712,95.7752088),(2808,'blackbuck_metacarpus.tif',237,5,168,480.3473399,47.7720957,34.5003731,1.8,49.5780623,34.3819644,-0.0787596,14.3068678,21.2601899,23814.9386768,33302.0157027,0.4955789,1566.4025548,1664.5808893,2363.5648317,28.8750018,29.2313661,2.5340196,95.7297137),(2809,'blackbuck_femur.tif',237,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2810,'blackbuck_femur.tif',237,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2811,'blackbuck_femur.tif',237,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2812,'blackbuck_femur.tif',237,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2813,'blackbuck_femur.tif',237,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2814,'blackbuck_femur.tif',237,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2815,'blackbuck_femur.tif',237,7,7,6.2545342,90.140609,51.4225467,1.8,89.8737968,51.705676,-0.9711602,2.3024976,4.6428854,3.8618237,25.2475981,0.7104296,5.4379111,1.6772325,6.2556572,4.323867,9.4123751,0.9964915,25.811356),(2816,'blackbuck_femur.tif',237,7,8,28.3440667,90.5326286,50.4206786,1.8,90.9415286,49.6060666,-1.0235459,3.0815484,10.0840418,46.0497689,422.3050454,3.4449616,41.8785496,14.9437108,46.2840272,6.0113955,17.2556733,1.0951011,41.0344125),(2817,'blackbuck_femur.tif',237,7,9,63.3896422,80.1274259,45.4346557,1.8,78.9106623,44.8537455,0.2834365,10.2158967,26.7318363,1012.2506559,16738.0218663,0.8262615,626.1456065,99.0858355,663.866098,7.2783162,19.8703851,1.1490091,47.9837141),(2818,'blackbuck_femur.tif',237,7,10,127.6575841,72.8020169,42.7408429,1.8,74.1821565,42.9679855,0.2687326,10.5526841,24.9119539,1984.0419693,32538.0517714,1.4998796,1306.1220284,188.0130159,1351.682024,12.526603,21.4849,3.0440769,62.1312569),(2819,'blackbuck_femur.tif',237,7,11,187.6504157,71.3397638,42.0421453,1.8,72.7470669,42.3315144,0.2568939,30.5821964,26.2009436,3504.2064908,40006.1483425,2.018975,1526.8972363,114.5832183,1202.3402405,15.9715687,24.9569758,3.057678,80.6315815),(2820,'blackbuck_femur.tif',237,7,12,221.5066836,70.9113209,41.8012713,1.8,72.0954367,42.0694721,0.2528155,13.1960805,27.6078199,5020.0405417,47400.0620182,2.3097792,1716.9071034,380.4190612,1835.0525434,17.1698045,26.8565651,2.7321554,76.2360884),(2821,'blackbuck_femur.tif',237,7,13,250.2344069,70.5643157,41.6949019,1.8,71.5312327,41.9107214,0.2547268,12.7258747,28.2398465,6386.3825316,53643.6964399,2.6480828,1899.5746437,501.8423237,2059.6985631,18.7591463,28.0085432,2.9832652,81.3824087),(2822,'blackbuck_femur.tif',237,7,14,265.2427517,70.4438286,41.6825734,1.8,71.3169668,41.850591,0.2563948,12.6645627,28.0005122,7457.3194692,58737.9444223,2.8429762,2097.7453556,588.8335537,2288.8516127,19.9087604,29.7826872,0.0468407,86.23307),(2823,'blackbuck_femur.tif',237,7,15,273.122666,70.7549686,41.7720314,1.8,71.3773524,41.8358417,0.25697,29.3130731,27.7948221,8159.1954816,62586.8384784,2.9402956,2251.7445249,278.3466427,2112.6448903,20.6544695,32.146581,3.0037856,90.7453611),(2824,'blackbuck_femur.tif',237,7,16,285.3795101,71.5092491,41.829398,1.8,71.813401,41.8193999,0.254458,30.3154946,27.6898737,8474.5884613,65640.5920651,3.0137688,2370.5630721,279.5464353,2051.0904763,22.8174997,51.7315279,3.069645,155.6423229),(2825,'blackbuck_femur.tif',237,7,17,290.1271973,72.4308899,41.8163414,1.8,72.4113838,41.7586216,0.2538271,30.1822252,27.142347,8549.2848194,66234.4863785,3.0490607,2440.2637818,283.255617,2006.8052521,22.4473926,51.9472353,3.0744293,158.4080277),(2826,'blackbuck_femur.tif',237,7,18,284.8248065,72.9424599,41.8174217,1.8,72.7806024,41.6590648,0.2564574,26.8011107,27.2078554,8531.8452325,64129.2338674,3.0543224,2357.011715,318.3392408,2327.8732249,21.9448807,52.1050606,3.038817,151.233146),(2827,'blackbuck_femur.tif',237,7,19,270.1253252,73.4935527,42.0415651,1.8,73.178686,41.7167849,0.2584352,15.3079391,28.0532861,7963.0370498,59012.8692215,2.9405399,2103.5991616,520.1900142,2375.4784738,21.8198858,52.0666866,3.0072712,170.7525893),(2828,'blackbuck_femur.tif',237,7,20,254.1735291,74.0975653,42.3146366,1.8,73.6503334,41.9149995,0.2525209,16.3751607,26.5887145,7239.5912113,52791.3061304,2.6443733,1985.4779383,442.1081023,2233.8657,22.2423397,51.637984,3.0016052,154.9615745),(2829,'blackbuck_femur.tif',237,7,21,237.1193649,74.7111529,42.652149,1.8,74.1286796,42.1461041,0.2439411,22.3206358,25.8038912,6641.8241328,45331.847342,2.305441,1756.7833886,297.5642893,1593.8694436,22.3494205,50.6429433,2.9522977,198.047908),(2830,'blackbuck_femur.tif',237,7,22,224.6511061,75.5864608,42.9379511,1.8,75.3217075,42.6434987,0.246167,22.1564758,24.3162524,6325.3082191,38241.5655629,2.2234468,1572.6751351,285.4834978,1825.2555506,22.5366985,48.6828472,2.9882174,149.5759903),(2831,'blackbuck_femur.tif',237,7,23,218.2838011,76.5577529,43.2419134,1.8,76.6695318,43.0641862,0.2478148,16.9103602,23.8745968,6260.0490966,32636.7021541,2.1888499,1367.0053744,370.190168,1625.0311731,22.560302,46.2753386,2.9648838,142.255283),(2832,'blackbuck_femur.tif',237,7,24,208.2221989,77.6195407,43.6613478,1.8,78.1410115,43.6624196,0.2620329,19.1282508,21.4013854,6220.0739677,26251.367754,2.32876,1226.6200213,325.1773539,1496.1313192,22.5817996,42.0073498,3.0028255,134.2071082),(2833,'blackbuck_femur.tif',237,7,25,209.6514045,77.9615378,43.9787862,1.8,78.3844224,44.083833,0.2816038,30.1615249,27.2579835,6230.5443328,23108.7045859,2.6984429,847.7774797,206.5725903,766.2954925,22.3536332,39.7774547,2.9831682,142.3583973),(2834,'blackbuck_femur.tif',237,7,26,204.2562303,77.9151849,44.2212315,1.8,78.2993592,44.3607717,0.3000374,28.2578695,23.9149643,6073.5471561,20416.2859399,2.9737435,853.7033839,214.932947,715.5671008,21.8578541,37.9424972,2.9754369,133.6391499),(2835,'blackbuck_femur.tif',237,7,27,195.2177179,77.7227194,44.4421535,1.8,78.1627257,44.670595,0.3243758,14.304429,18.3271591,5887.2709598,17805.9271863,3.3050581,971.55959,411.5697993,1273.3394126,21.4739289,36.0321629,2.9796253,157.8400694),(2836,'blackbuck_femur.tif',237,7,28,187.3462668,77.3668059,44.591682,1.8,77.9108108,44.9302861,0.3316715,14.8575681,17.4338053,5881.5610908,15929.7774026,3.3107491,913.729223,395.862975,1228.5256447,21.1060549,34.4674907,2.965358,117.4066506),(2837,'blackbuck_femur.tif',237,7,29,183.3308617,76.9725989,44.8010003,1.8,77.6138827,45.2552245,0.3354738,13.4179971,16.6834189,5880.3990515,14369.3781641,3.3116762,861.29697,438.2471535,1198.3312007,21.0329818,33.282641,2.9661114,122.370102),(2838,'blackbuck_femur.tif',237,7,30,190.282434,76.6819084,45.168537,1.8,77.1416608,45.7085141,0.3306817,19.4290327,16.8867958,6193.8758035,13615.8327952,3.3433334,806.3005545,318.7948615,990.749853,20.9612438,32.146581,3.0037856,104.245191),(2839,'blackbuck_femur.tif',237,7,31,195.0917694,76.2006133,45.4536367,1.8,76.3468212,45.9157371,0.2999643,16.586489,16.2363381,6660.4337982,13082.5682299,2.8389761,805.758547,401.557786,1030.0800278,21.3238234,31.5006896,3.0529368,117.8110918),(2840,'blackbuck_femur.tif',237,7,32,191.141614,75.7060978,45.4577125,1.8,75.7474488,45.8674662,0.2426153,19.877204,31.1970798,6902.4780748,12488.197255,1.8386645,400.3001997,347.2559852,620.8206149,21.4593778,30.954916,0.0525831,105.3303805),(2841,'blackbuck_femur.tif',237,7,33,186.0644212,75.4168902,45.2702215,1.8,75.1038405,45.573762,0.1760178,19.236635,15.2348661,6956.2437848,11773.5293601,0.9509013,772.8016322,361.6143766,942.8155848,21.8728319,30.7860514,0.0831412,106.0111289),(2842,'blackbuck_femur.tif',237,7,34,176.6968942,75.0191768,45.1257648,1.8,74.5350213,45.4169782,0.0899511,15.0911702,29.0980191,6962.1793811,11204.4341803,0.2376397,385.058314,461.3412527,613.886123,21.8476715,30.3059087,0.1462354,84.1110702),(2843,'blackbuck_femur.tif',237,7,35,176.4726457,74.4221989,45.0437799,1.8,73.7660821,45.3425524,-0.063089,12.0774846,21.8470036,7059.4818506,11019.8511721,0.1169113,504.4101866,584.5159073,757.4754991,21.8476715,30.2773754,0.2244974,84.8248541),(2844,'blackbuck_femur.tif',237,7,36,176.4755268,73.9002319,44.9862207,1.8,73.1522872,45.2996174,-0.2277521,20.1915424,16.1284369,7094.9791946,11364.4194243,1.4994634,704.6200142,351.383716,908.594218,0.7567348,2.4265573,1.2793395,5.4186196),(2845,'blackbuck_femur.tif',237,7,37,179.1664432,73.254654,44.9950352,1.8,72.4280539,45.4597556,-0.377887,15.0543197,16.170122,7038.1306133,11579.520662,4.0649745,716.1059571,467.5156865,1147.2207301,1.0713626,1.5591344,1.1071487,4.2166321),(2846,'blackbuck_femur.tif',237,7,38,177.7180032,72.8537173,44.9366717,1.8,71.6356925,45.7831157,-0.4731829,18.0772364,30.8055934,6814.6834857,11396.5534302,6.1514822,369.9507841,376.9759564,589.5499513,1.1621102,1.8152741,0.6947383,5.0101706),(2847,'blackbuck_femur.tif',237,7,39,177.6465822,72.6770849,44.5756316,1.8,71.4003012,45.3948532,-0.4808439,18.1187207,32.0518608,6521.4452252,11221.600928,6.3340398,350.107627,359.92857,552.7751393,0.232422,0.3286944,2.3561945,0.6573888),(2848,'blackbuck_femur.tif',237,7,40,176.6045855,72.6464923,44.1882216,1.8,71.5263732,44.928933,-0.5004928,17.9154115,30.2207883,6191.5370313,10769.9777824,6.7776035,356.3764677,345.5983708,556.133752,0.4648441,1.4137681,2.976444,3.0380042),(2849,'blackbuck_femur.tif',237,7,41,174.5176127,72.6445097,43.7946974,1.8,71.6621508,44.3972038,-0.5097902,16.3365301,32.3412313,5827.9628302,10178.7606061,6.926553,314.7301513,356.7442284,494.0332191,1.7566075,11.8009986,1.0101093,27.4314684),(2850,'blackbuck_femur.tif',237,7,42,171.10512,72.6748945,43.3544058,1.8,71.8296462,43.8313356,-0.5089538,14.63482,25.0196538,5467.3491347,9377.5119039,6.770805,374.8058221,373.5849944,512.147279,0.232422,0.3286944,2.3561945,0.6573888),(2851,'blackbuck_femur.tif',237,7,43,165.8034822,72.8667469,42.7642085,1.8,71.9678487,43.1211522,-0.4910196,11.6363042,27.5116893,5168.4417042,8390.4075134,6.1440168,304.9760933,444.1652262,483.3302049,1.7479169,2.9122398,0.4993467,8.7055636),(2852,'blackbuck_femur.tif',237,7,44,162.9766318,72.9356609,42.2374418,1.8,72.0447366,42.479913,-0.46789,13.898976,14.6363366,4918.1624539,7724.0282471,5.525034,527.7296117,353.8507051,682.1500406,3.8651393,13.067411,0.8988332,53.1300343),(2853,'blackbuck_femur.tif',237,7,45,160.0839752,73.0250549,41.7464804,1.8,72.1004524,41.9426515,-0.4603963,15.067125,33.0244592,4706.6396824,7166.6242162,5.2669051,217.0095859,312.3780876,359.0961643,3.6409283,15.0195717,1.1902899,46.7253315),(2854,'blackbuck_femur.tif',237,7,46,155.5490287,73.2059886,41.2221452,1.8,72.5410787,41.3534114,-0.4733346,12.9923371,27.3882028,4491.7872429,6503.7598494,5.3873209,237.4657402,345.725884,399.3665788,0.6972661,1.5591344,1.1071487,3.5592433),(2855,'blackbuck_femur.tif',237,7,47,151.1006451,73.4310705,40.6915757,1.8,73.0943502,40.8776021,-0.4998809,11.8443691,15.0971831,4315.5331659,5852.1009966,5.785861,387.6286694,364.3531479,671.9962201,2.6578317,10.2897622,1.2490458,28.4409112),(2856,'blackbuck_femur.tif',237,7,48,147.7811486,73.6138327,40.1408155,1.8,73.2767249,40.2465387,-0.5071227,12.8672488,28.7150956,4188.5455904,5318.0362741,5.8095135,185.2000196,325.5199035,325.3726605,0.4648441,0.8380096,2.5535901,1.7796217),(2857,'blackbuck_femur.tif',237,7,49,144.2141095,73.8109004,39.5344128,1.8,73.4156781,39.61326,-0.5010058,11.480333,23.2290552,4040.3595089,4855.5078397,5.544931,209.0273498,351.937485,375.0505404,2.531627,9.9372313,1.3825748,30.4597968),(2858,'blackbuck_femur.tif',237,7,50,143.2028878,73.9164316,39.0616469,1.8,73.5540915,39.142352,-0.4935608,12.9458277,26.8235692,3930.4023654,4548.134997,5.3570525,169.5574129,303.6037915,296.4287368,2.4335835,8.9716111,1.2818209,29.6428987),(2859,'blackbuck_femur.tif',237,7,51,142.853673,73.9810916,38.6461853,1.8,73.626304,38.738475,-0.4931172,10.9045346,29.0229225,3823.0489068,4319.1720006,5.3351779,148.8193343,350.5925776,274.2951772,1.8133411,10.2687413,1.4801364,28.0227863),(2860,'blackbuck_femur.tif',237,7,52,143.7258014,74.0598447,38.2063762,1.8,73.7148875,38.3620614,-0.5523075,11.5316758,32.6938317,3751.0989434,4171.0801007,6.593679,127.5800323,325.2865425,241.2641989,0.6972661,1.3552417,2.1112158,3.0380042),(2861,'blackbuck_femur.tif',237,7,53,143.6201678,74.1272371,37.7616819,1.8,73.8498209,37.9777135,-0.5721049,11.8024221,33.7623009,3676.2829541,4054.5212998,7.0162561,120.0901949,311.4854673,227.858903,1.6505423,8.908164,1.4399689,20.9373351),(2862,'blackbuck_femur.tif',237,7,54,142.4290758,74.152702,37.3657134,1.8,73.8841369,37.5344809,-0.5728941,12.8546796,32.3325201,3602.2268175,3894.0306136,6.9751291,120.4369656,280.2268838,230.1631308,0.4648441,3.2621988,1.6421038,6.8929065),(2863,'blackbuck_femur.tif',237,7,55,140.1864108,74.175241,37.0166364,1.8,74.0131579,37.1906028,-0.5073532,9.9347145,32.4385069,3518.9472595,3722.2289633,5.5155247,114.7472348,354.2071856,223.1954825,0.6972661,1.251631,1.9513027,2.9018545),(2864,'blackbuck_femur.tif',237,7,56,139.4028425,74.1654874,36.6830225,1.8,73.888141,36.9691356,-0.4654914,14.8464007,31.3347704,3457.5462459,3643.7483083,4.6810798,116.2845062,232.8878433,223.3673258,1.4936104,10.4615738,1.5930149,24.463543),(2865,'blackbuck_femur.tif',237,7,57,137.5825975,74.2751846,36.2172156,1.8,74.1751544,36.376607,-0.5036112,12.5578738,36.4074759,3378.8909077,3475.0319543,5.3403744,95.4483075,269.0655251,188.0397907,0.8286309,4.7004448,1.7196863,10.6446945),(2866,'blackbuck_femur.tif',237,7,58,137.1328073,74.3152609,35.8574205,1.8,74.2023835,36.0994425,-0.6175657,9.7398769,36.610901,3337.3761013,3400.7118738,7.6634724,92.8879591,342.6507471,183.7338128,0.6972661,5.1606067,1.4352686,11.1328982),(2867,'blackbuck_femur.tif',237,7,59,136.7030864,74.3520396,35.4807801,1.8,74.2823878,35.6617043,-0.5668625,11.3441675,33.1260712,3290.0157406,3321.5296812,6.5698592,100.2693516,290.0182627,199.4662178,0.9174618,2.9122398,2.070143,6.9259419),(2868,'blackbuck_femur.tif',237,7,60,136.6738501,74.3810235,35.1272151,1.8,74.2699987,35.2742512,-0.209223,15.175697,29.7795255,3248.4385043,3270.1359193,0.9826685,109.8115523,214.0553089,201.4634134,1.3122483,5.1448811,1.8925469,11.6871728),(2869,'blackbuck_femur.tif',237,7,61,136.6087478,74.3998263,34.797624,1.8,74.1068916,35.0785954,-0.3549337,18.7283327,35.0650261,3213.8764317,3302.882341,2.7498399,94.1930667,171.6050476,184.0444971,0.4648441,0.8380096,2.5535901,1.7796217),(2870,'blackbuck_femur.tif',237,7,62,136.7399673,74.4397741,34.4662787,1.8,74.1997086,34.7549728,-0.2686251,15.5506968,35.2045423,3188.8193715,3283.1410151,1.6053359,93.259017,205.0595816,168.1633493,0.4648441,0.8380096,2.1587989,1.7796217),(2871,'blackbuck_femur.tif',237,7,63,136.7677958,74.4962014,34.1241599,1.8,74.4435029,34.3016968,0.4541641,30.818313,16.7777989,3132.5732243,3194.8164825,4.3872283,190.4192855,101.646486,183.7774637,0.232422,0.9583006,1.815775,2.051921),(2872,'blackbuck_femur.tif',237,7,64,136.9103431,74.5287435,33.8154534,1.8,74.4105306,34.0557936,0.3861257,33.6759762,23.7257062,3120.6846715,3184.2554309,3.2363149,134.2111968,92.6679794,164.4236778,16.9630157,17.700735,1.9756881,56.3509074),(2873,'blackbuck_femur.tif',237,7,65,136.0288185,74.6166072,33.4299915,1.8,74.5537323,33.6049108,0.5389694,27.7020894,9.5808962,3049.269723,3147.6290619,5.9722859,328.5318001,110.0736367,223.5929332,16.9668087,17.7890185,2.0753568,56.4870571),(2874,'blackbuck_femur.tif',237,7,66,135.5137624,74.6503119,33.1265962,1.8,74.600749,33.1973839,0.4667788,28.3907589,9.468862,3000.5159129,3132.9446815,4.5738344,330.8681319,105.6863582,216.0238294,0.8378545,3.455202,1.9138203,7.4705407),(2875,'blackbuck_femur.tif',237,7,67,134.9714343,74.6809974,32.8380522,1.8,74.506663,32.9131375,0.4330472,25.2409699,10.3843635,2967.1772785,3135.2414991,3.9613355,301.9194664,117.5540122,233.6210617,1.2276836,5.4408604,1.9195673,11.9594721),(2876,'blackbuck_femur.tif',237,7,68,134.6964888,74.7126487,32.5769473,1.8,74.562316,32.6481594,0.4921271,24.066045,19.3904914,2952.500495,3122.420117,5.0120066,161.0284161,122.6832452,196.5627651,0.8573455,2.9399321,1.8925469,7.0056966),(2877,'blackbuck_femur.tif',237,7,69,135.0984631,74.7338211,32.3366455,1.8,74.5327535,32.528697,0.5314305,34.1372033,16.0546111,2987.5829242,3133.1432946,5.7825031,195.1553525,87.516921,162.4654779,0.8222808,2.1046711,1.6814535,4.9537756),(2878,'blackbuck_femur.tif',237,7,70,135.0007033,74.7704331,32.0765148,1.8,74.5916488,32.2480016,0.5842833,35.4906905,18.0820551,2995.6370769,3146.198935,6.8459858,173.9956499,84.4062776,160.8835191,0.6972661,3.0304126,1.6475682,6.8131519),(2879,'blackbuck_femur.tif',237,7,71,134.3537892,74.8122326,31.8334721,1.8,74.6949547,31.9892732,0.6638434,28.5167684,12.1832672,2957.6719686,3146.5902086,8.5009914,258.2714599,103.7169405,201.0756031,0.9571581,5.9256225,1.3734008,12.9689149),(2880,'blackbuck_femur.tif',237,7,72,134.5665789,74.8397616,31.6367377,1.8,74.7487399,31.8674322,0.7339259,17.4310905,14.0973829,2979.8249146,3160.6778354,10.0615112,224.2031623,170.9488523,281.2684781,0.6145029,3.9784244,1.4536876,8.6725282),(2881,'blackbuck_femur.tif',237,7,73,133.2342492,74.8977532,31.3624665,1.8,74.833145,31.4983641,0.7194188,15.2198573,9.653718,2952.848999,3148.95417,9.6419842,326.1908164,194.0129229,379.2077051,0.4648441,2.5985574,1.3909428,5.4983743),(2882,'blackbuck_femur.tif',237,7,74,132.4193165,74.9045807,31.172965,1.8,74.7714297,31.3381948,0.7438749,38.0976407,17.8948504,2951.1544787,3161.8066993,10.1195816,176.6880766,77.4629196,160.2752211,0.232422,0.734983,1.8925469,1.5870769),(2883,'blackbuck_femur.tif',237,7,75,132.1803025,74.8895731,30.9787443,1.8,74.6416762,31.2004335,0.766304,17.5044961,9.7644969,2948.110612,3189.115877,10.5944817,326.6031952,168.4201926,337.911115,0.992238,2.8275361,1.735945,7.0056966),(2884,'blackbuck_femur.tif',237,7,76,131.9275871,74.9042207,30.7654886,1.8,74.7725872,30.8784765,0.8308265,16.1685986,10.1917099,2950.9578521,3200.4778571,11.9914668,314.0275666,182.5116647,355.3605209,0.5504432,3.0570346,1.418147,6.6206071),(2885,'blackbuck_femur.tif',237,7,77,131.3031486,74.9261354,30.5947192,1.8,74.8930948,30.5980936,0.8226378,10.851257,10.3717151,2931.4872032,3207.1463645,11.7561217,309.2204464,270.1518549,456.3417022,0.4648441,2.370249,1.3734008,5.0335302),(2886,'blackbuck_femur.tif',237,7,78,130.9727426,74.9291815,30.4719592,1.8,74.8239631,30.5377065,0.8108767,28.3501505,13.2871917,2958.0709466,3213.4779734,11.4703198,241.8477912,104.3405729,200.1810383,0.4648441,2.370249,1.3734008,5.0335302),(2887,'blackbuck_femur.tif',237,7,79,131.3820015,74.9513939,30.333341,1.8,74.9242034,30.29476,0.8102127,28.4451733,13.0333881,2942.0470559,3240.8870965,11.4916417,248.6603686,103.4286914,198.0279679,0.4648441,1.039423,1.1071487,2.2444657),(2888,'blackbuck_femur.tif',237,7,80,131.644817,74.9748996,30.2004526,1.8,74.9945923,30.1362465,0.8316879,9.3943286,9.9265448,2957.3632625,3271.6213865,11.9845859,329.5830967,314.8030467,589.81436,0.4648441,2.1428253,1.3521274,4.5686861),(2889,'blackbuck_femur.tif',237,7,81,130.4450982,75.0298696,30.0354292,1.8,75.0899013,29.9777944,0.8345096,21.9292296,19.9987044,2952.8095741,3272.3407475,11.9364343,163.6276368,134.6517696,227.393839,0.5361201,3.1008967,1.3439975,6.6206071),(2890,'blackbuck_femur.tif',237,7,82,129.3803639,75.0418586,29.9495481,1.8,74.9853873,29.8964554,0.8105697,27.2156763,9.8085598,2943.0771578,3268.7516312,11.324252,333.2550026,108.1390419,226.5923469,0.6354186,3.7835567,1.3854484,8.2076841),(2891,'blackbuck_femur.tif',237,7,83,129.545174,75.0750313,29.8690294,1.8,75.0528608,29.8815578,0.8517894,10.2438179,10.0539353,2953.5522838,3289.7879898,12.2246658,327.2139601,288.3253401,607.8054533,0.7190949,4.0122264,1.3961241,8.8650729),(2892,'blackbuck_femur.tif',237,7,84,129.0153196,75.1156267,29.764188,1.8,75.080373,29.796698,0.8673388,23.5550405,21.5221994,2965.9792731,3312.4999364,12.5053344,153.9108466,125.9169678,196.7754765,0.232422,1.643472,1.7126934,3.4464532),(2893,'blackbuck_femur.tif',237,7,85,129.8453288,75.15347,29.6642858,1.8,75.0770656,29.659073,0.9009216,10.2763431,9.7548805,2987.4662836,3372.3351226,13.298291,345.7074759,290.7129764,607.3727472,0.6718678,2.4265573,1.2793395,5.4186196),(2894,'blackbuck_femur.tif',237,7,86,130.4896565,75.171336,29.568746,1.8,75.1235917,29.5861246,0.9289324,10.4606507,9.9921052,3003.704765,3429.5093597,13.9530625,343.2219042,287.1432037,609.5281853,0.4591211,2.370249,1.3734008,5.0335302),(2895,'blackbuck_femur.tif',237,7,87,131.8384869,75.1518482,29.4493831,1.8,75.0598074,29.4902141,0.9332791,33.2793192,20.4389895,3046.2719011,3536.9386451,14.1887742,173.048606,91.5364851,197.2051629,0.4648441,1.8738464,1.6951513,4.103842),(2896,'blackbuck_femur.tif',237,7,88,132.4101167,75.1585482,29.3783934,1.8,75.1314002,29.4065496,0.9500685,25.3770921,19.4023159,3063.5848477,3570.5118238,14.60284,184.0250334,120.7224547,207.6761581,0.232422,1.4137681,1.735945,2.9816092),(2897,'blackbuck_femur.tif',237,7,89,132.2025817,75.189464,29.2577258,1.8,75.2217905,29.2591786,0.9527758,9.5946766,10.3849413,3086.8001578,3586.2409945,14.6363462,345.3308889,321.720084,641.1856185,17.1992308,19.0940044,2.1216539,58.4825831),(2898,'blackbuck_femur.tif',237,7,90,132.3205581,75.1696387,29.207056,1.8,75.1654768,29.2199521,0.9377864,24.37232,20.3804038,3112.8214841,3614.3932321,14.3356094,177.3464978,127.7195392,211.7434145,17.1992308,19.1462723,2.1486983,58.6187328),(2899,'blackbuck_femur.tif',237,7,91,133.145329,75.1358689,29.1544012,1.8,75.1615056,29.1528318,0.9387583,9.61233,10.4391709,3150.8358628,3664.9901019,14.4455312,351.0805732,327.7910632,643.6121839,0.232422,0.5197115,2.0344439,1.1222329),(2900,'blackbuck_femur.tif',237,7,92,134.1027107,75.0891656,29.1119098,1.8,75.1084431,29.136493,0.9273689,9.6468521,10.4016431,3194.261741,3720.3208558,14.3058704,357.6666509,331.1195941,657.0463007,0.627403,3.8332024,1.3258177,8.2076841),(2901,'blackbuck_femur.tif',237,7,93,135.09735,75.0520882,29.0875648,1.8,75.1216739,29.1052862,0.9293794,10.2626158,10.8180594,3238.4642284,3776.1854102,14.455407,349.0631057,315.5593355,643.1976089,0.232422,0.734983,1.8925469,1.5870769),(2902,'blackbuck_femur.tif',237,7,94,136.314257,75.007337,29.0751764,1.8,75.0696518,29.1333936,0.9652712,10.4587491,10.5288074,3284.1235194,3848.1076644,15.358488,365.4837181,314.0072962,673.7734222,17.4208031,19.4624835,2.2716507,59.6048159),(2903,'blackbuck_femur.tif',237,7,95,136.4089229,74.9775053,29.0895702,1.8,74.9788181,29.228665,0.9688329,9.8844852,10.4016594,3330.4413171,3894.1580817,15.4448429,374.3785416,336.9362436,694.5610893,17.4651266,19.5358984,2.1785983,59.9335103),(2904,'blackbuck_femur.tif',237,7,96,136.5994335,74.9645394,29.0982841,1.8,75.0330599,29.1733906,0.9570339,9.7916155,10.6692242,3364.619562,3945.6489615,15.214554,369.815919,343.622517,684.9178746,17.4208031,19.5966376,2.1620884,59.7973607),(2905,'blackbuck_femur.tif',237,7,97,136.1819079,74.9814777,29.0103935,1.8,75.0868607,29.0874232,0.9699166,10.4200959,10.4646953,3392.6599475,3998.8001237,15.4420909,382.122938,325.5881678,690.5001146,17.5682427,19.7463006,2.3062361,60.3983544),(2906,'blackbuck_femur.tif',237,7,98,135.8085315,74.960189,29.0252986,1.8,75.074371,29.1031139,0.9590187,10.0924363,11.2080313,3417.5147579,4032.7690445,15.168736,359.8106528,338.6213848,659.8933246,0.4648441,1.469966,1.8925469,3.1741539),(2907,'blackbuck_femur.tif',237,7,99,135.832906,74.924657,29.0634699,1.8,75.0337503,29.1867907,0.9289755,11.0299875,11.2795734,3463.7279308,4078.1081322,14.5253443,361.5480833,314.0282721,658.5154874,0.5846167,3.5171836,1.7033479,7.74284),(2908,'blackbuck_femur.tif',237,7,100,137.0367172,74.8915196,29.1070754,1.8,74.9898215,29.2326903,0.9050635,10.1112795,10.472708,3524.4230495,4191.2981208,14.1268006,400.2114958,348.5635088,701.3550384,0.6972661,0.9583006,1.815775,2.4370105),(2909,'blackbuck_femur.tif',237,7,101,138.7717251,74.8739422,29.1883506,1.8,75.006841,29.3352292,0.8692842,10.1871108,11.5158404,3584.3037069,4302.31898,13.4953903,373.6000882,351.8469355,682.7588374,0.232422,0.734983,1.8925469,1.5870769),(2910,'blackbuck_femur.tif',237,7,102,138.9088868,74.8644987,29.2145232,1.8,74.9969874,29.3385701,0.8207502,10.7404581,11.5320391,3639.7641866,4360.3783557,12.3935097,378.109918,338.8835138,693.4297077,17.915791,20.2687475,2.2831539,62.5066705),(2911,'blackbuck_femur.tif',237,7,103,139.9509491,74.8781498,29.2896412,1.8,75.0532803,29.4068448,0.7779512,11.3425035,10.8284697,3707.379213,4439.3460656,11.4888845,409.9698476,326.8572242,695.7357013,17.9830676,20.4742577,2.2597207,62.6428202),(2912,'blackbuck_femur.tif',237,7,104,141.6317897,74.9021505,29.399263,1.8,75.0943741,29.5044393,0.7458329,10.5204409,10.9657102,3768.6527398,4578.6320055,10.8696748,417.5408534,358.2219393,733.4041769,18.0820726,20.5965795,2.2843185,63.1640593),(2913,'blackbuck_femur.tif',237,7,105,142.1261873,74.9493183,29.4448492,1.8,75.1499129,29.5419339,0.7374065,10.8041635,11.0518183,3816.3551132,4662.0778034,10.7087825,421.8380798,353.2300401,733.1704187,0.232422,1.8738464,1.6951513,3.9112973),(2914,'blackbuck_femur.tif',237,7,106,142.7491198,74.9253187,29.5768458,1.8,75.1485025,29.6477075,0.7491922,10.708208,11.3462721,3870.0636749,4749.1169661,11.0351171,418.5618783,361.4109552,750.8196003,0.4648441,1.692058,1.2924967,3.638998),(2915,'blackbuck_femur.tif',237,7,107,143.8576921,74.8948995,29.7352671,1.8,75.0975596,29.8172528,0.7665891,10.1808671,10.9397476,3939.1495679,4855.142608,11.5372763,443.8075516,386.9169037,779.2933211,0.4648441,2.5671853,1.6614562,5.8834637),(2916,'blackbuck_femur.tif',237,7,108,145.5281052,74.8287197,29.9125155,1.8,75.0193967,30.0107143,0.7977917,10.5867573,11.0947544,4055.8478298,4957.623827,12.427912,446.8439468,383.1057739,799.0048219,0.4648441,2.1046711,1.6814535,4.5686861),(2917,'blackbuck_femur.tif',237,7,109,147.8986503,74.7347341,30.1103259,1.8,74.8593992,30.2363876,0.8234213,10.616996,11.3531739,4233.0661776,5045.1770127,13.2612451,444.3847225,398.7065802,816.2649604,0.4648441,4.4404168,1.6756733,9.6022163),(2918,'blackbuck_femur.tif',237,7,110,151.6484897,74.6028937,30.3866743,1.8,74.7328441,30.5476726,0.8876185,10.9717236,11.3264488,4539.4512183,5144.5196257,15.2030089,454.2041107,413.7409382,830.4420929,0.5989983,5.1343706,1.6614562,10.8042038),(2919,'blackbuck_femur.tif',237,7,111,155.9903884,74.3956247,30.6810322,1.8,74.4641135,30.9160602,1.0918986,11.0374208,11.4350519,4947.5338099,5248.7150524,20.4779566,459.0022935,448.2508992,877.145287,0.6266114,6.5243975,1.4994889,13.5932683),(2920,'blackbuck_femur.tif',237,7,112,159.2424909,74.2038375,30.9448012,1.8,74.2647064,31.2069036,-1.4076743,10.9367283,11.6778552,5189.8323078,5394.5569741,25.840448,461.9475808,474.532435,904.2115184,0.6972661,5.829115,1.4909663,12.9689149),(2921,'blackbuck_femur.tif',237,7,113,157.8358427,74.1104746,30.9710126,1.8,74.1480574,31.1512043,-1.0047406,10.7256321,11.4294161,5120.4908869,5408.3289999,18.7397084,473.1938149,477.406911,876.8668914,1.4073482,6.3820908,1.3876855,15.7910148),(2922,'blackbuck_femur.tif',237,7,114,155.5830449,73.9563287,31.0696034,1.8,74.0550289,31.2207209,-0.9680603,10.9694901,11.2566961,4975.0651582,5403.6150915,17.5971196,480.035618,453.5365908,901.2341127,1.2697172,9.7561901,1.3547114,22.6275263),(2923,'blackbuck_femur.tif',237,7,115,153.239739,73.8393409,31.0924341,1.8,73.9747273,31.1824385,-0.95537,10.8341596,11.1044302,4840.2275679,5344.6706795,17.0279234,481.3097653,446.7561624,868.3588551,1.0806245,10.0909715,1.3146449,21.8339878),(2924,'blackbuck_femur.tif',237,7,116,151.8552227,73.7229096,31.1463111,1.8,73.8716372,31.228123,-0.9920116,10.8549257,11.7393978,4755.487032,5337.9235999,17.7362674,454.7016531,438.0948498,849.6083901,0.7279236,3.8332024,1.3258177,8.4002288),(2925,'blackbuck_femur.tif',237,7,117,148.7555712,73.5829061,31.1354964,1.8,73.7193359,31.2278212,-1.0487458,10.896527,11.0876692,4645.5637791,5347.7906053,18.6276582,482.3187356,426.3343503,852.3230115,1.1062576,8.3800957,1.2315037,18.5003246),(2926,'blackbuck_femur.tif',237,7,118,146.9157972,73.4880875,31.1644069,1.8,73.6945534,31.2771067,-1.0807408,10.7811461,11.377366,4576.7099106,5426.5060401,19.0614713,476.9562686,424.5105171,846.2426647,0.6209325,3.8961033,1.2679115,8.4002288),(2927,'blackbuck_femur.tif',237,7,119,144.8890485,73.3914417,31.2362717,1.8,73.6242488,31.2882332,-1.0927232,10.6671404,11.226786,4512.1472874,5566.3353922,19.036884,495.8084512,422.9950201,861.2870895,0.4416571,1.251631,1.1902899,2.7093098),(2928,'blackbuck_femur.tif',237,7,120,143.1434003,73.2907941,31.3607591,1.8,73.5317622,31.403105,-1.0780087,11.1328283,11.6504397,4498.7384183,5767.1565087,18.5177896,495.016209,404.0966326,868.324727,0.6273576,3.3841159,1.2924967,7.2779959),(2929,'blackbuck_femur.tif',237,7,121,142.1057088,73.2584717,31.4432771,1.8,73.5479748,31.4611876,-1.06949,10.8735464,11.5931062,4567.4735041,5986.9957523,18.2144234,516.4272341,420.0537083,861.2578463,0.4416571,1.039423,1.1071487,2.2444657),(2930,'blackbuck_femur.tif',237,7,122,140.5360839,73.1993758,31.5276356,1.8,73.5106238,31.5156876,-1.0773582,11.4792539,12.1564181,4727.6373615,6196.6259736,18.1677863,509.7411026,411.8418688,878.8449768,19.8550898,23.3442454,1.3499676,70.6442758),(2931,'blackbuck_femur.tif',237,7,123,141.0468185,73.1665073,31.6018768,1.8,73.5370508,31.5489967,-1.0792724,11.5978789,12.380515,4972.0678796,6533.286537,18.2713084,527.7071687,428.7049313,903.3456214,0.4648441,0.734983,1.8925469,1.7796217),(2932,'blackbuck_femur.tif',237,7,124,143.4236332,73.1711619,31.7457681,1.8,73.5245147,31.6663921,-1.090924,11.3809553,13.0316955,5379.0918118,6970.628279,18.8091624,534.8980315,472.639744,932.9489782,0.8562889,7.3498302,1.2490458,15.8707695),(2933,'blackbuck_femur.tif',237,7,125,146.6653736,73.144198,31.8908462,1.8,73.5863066,31.7366771,-1.114709,11.8080561,13.4496064,5823.9463801,7504.8427168,19.7023829,557.9971989,493.2180461,984.9343474,0.8090136,5.8798641,1.2490458,12.6966156),(2934,'blackbuck_femur.tif',237,7,126,150.3425971,73.1483888,32.0985094,1.8,73.6146978,31.9191291,-1.127393,12.2718825,13.9115674,6408.0978031,8119.2421599,20.4452183,583.6324504,522.1772446,1037.9833678,0.4648441,1.9166012,1.3258177,4.103842),(2935,'blackbuck_femur.tif',237,7,127,156.6765407,73.1664393,32.3150656,1.8,73.6898874,32.2115605,-1.1903051,12.8584629,14.0450043,7169.5372185,8952.376548,22.5112708,637.4064675,557.5734258,1135.7171873,1.2531386,4.342002,1.2998495,10.3160001),(2936,'blackbuck_femur.tif',237,7,128,162.0719768,73.1383385,32.6929191,1.8,73.7582101,32.5091132,-1.2756266,13.4830272,14.1003778,7933.8043614,9954.9340637,24.7261306,706.0047761,588.42901,1238.6364484,0.8027856,2.9399321,1.2490458,6.5408525),(2937,'blackbuck_femur.tif',237,7,129,169.5030503,73.2488616,33.0087657,1.8,73.8914131,32.7621485,-1.3417646,14.4421373,15.3204913,8954.2571853,11320.3280008,26.7943434,738.9011085,620.0091446,1300.3909721,1.3701203,9.9290738,1.2860659,22.6041667),(2938,'blackbuck_femur.tif',237,7,130,179.7510379,73.3086393,33.5020729,1.8,73.9325155,33.236863,-1.4428347,15.0465673,16.0751174,10151.216526,13095.2570727,29.4706319,814.6290181,674.6533158,1407.4109125,1.6072425,9.1946346,1.2890245,21.8670232),(2939,'blackbuck_femur.tif',237,7,131,191.5177569,73.3522093,34.1196837,1.8,74.0832615,33.8914676,-1.5020252,14.8312899,17.4706762,11553.5325563,15294.9083933,31.7689012,875.4617303,778.9971513,1499.9962624,1.466777,8.4602899,1.2055949,21.4021792),(2940,'blackbuck_femur.tif',237,7,132,207.9313421,73.5563943,35.0114355,1.8,74.3997103,34.7553184,1.5355856,15.9164318,20.0019412,13850.1249288,18147.7840458,34.6122762,907.3011379,870.1777596,1588.0647635,1.4925173,13.7600913,1.297137,33.554196),(2941,'blackbuck_femur.tif',237,7,133,226.6048296,73.8141198,36.0470528,1.8,74.6637673,35.4122315,1.4347783,15.752216,23.707444,16521.4122951,22033.8465498,37.0730382,929.4062485,1048.8309906,1626.2885974,1.4879105,11.4666773,1.2618656,29.2578093),(2942,'blackbuck_femur.tif',237,7,134,259.8720829,74.3273187,38.1042499,1.8,75.4430277,38.068128,1.2880191,16.6836362,26.4270132,20251.3055788,32892.0523635,39.9399918,1244.6375282,1213.8424368,1996.9922826,1.7029842,13.2296943,1.2490458,35.0615183),(2943,'blackbuck_femur.tif',237,7,135,303.1002812,74.468595,40.6593045,1.8,75.4656042,39.9008385,1.4024503,17.3622904,29.7636698,26533.2465656,49018.7197144,49.0985244,1646.9313112,1528.2111919,2537.0878093,32.0267706,53.9989977,1.936116,155.9049464),(2944,'blackbuck_femur.tif',237,7,136,349.1568031,73.9307113,42.2109229,1.8,75.1200286,41.0005401,1.5296606,19.701521,31.665735,32389.1222339,61083.2167025,58.0943853,1929.0004364,1643.9909486,2939.5068497,34.8957394,55.6848473,1.9334751,196.9860781),(2945,'blackbuck_femur.tif',237,7,137,406.5743047,73.6748222,43.0707654,1.8,74.9917685,41.4352842,-1.5438693,22.3746669,32.5374546,37967.6749144,72816.0337765,67.7132647,2237.9142618,1696.9045884,3366.3642177,36.7006563,56.8023483,1.9391452,228.0001494),(2946,'blackbuck_femur.tif',237,7,138,451.1458495,73.5543919,43.1105546,1.8,74.8399707,41.4999849,-1.5278412,22.262697,32.7391827,42519.7461077,83125.5082106,75.0523223,2539.0220971,1909.9099284,3792.0689596,0.879507,3.7835567,1.3854484,8.4002288),(2947,'blackbuck_femur.tif',237,7,139,465.5705,73.6564226,43.5279038,1.8,74.8010123,41.8584606,-1.5073811,22.6899823,33.0589993,46599.182201,88569.8686827,77.2834532,2679.1454821,2053.7337364,4030.9976406,0.9431933,4.4404168,1.4659194,10.5649399),(2948,'blackbuck_femur.tif',237,7,140,469.1977468,73.8723956,43.6824492,1.8,74.8077521,42.054658,-1.5074769,22.4929043,32.9680793,48997.5077841,92219.8014133,77.8865146,2797.2451914,2178.3539904,4214.0964384,0.6963863,4.6309763,1.2649175,9.9873057),(2949,'blackbuck_femur.tif',237,7,141,475.1761079,74.0169462,43.7282623,1.8,74.832606,42.2238117,-1.5058439,22.4981431,32.7490561,50555.1002573,94224.9359594,78.8623747,2877.1802051,2247.0787906,4341.88208,39.8569248,57.9705479,1.9356673,186.2986722),(2950,'blackbuck_femur.tif',237,7,142,477.3152836,74.1704292,43.5910892,1.8,74.8488234,42.2973416,-1.5030268,22.0412633,32.0909312,50869.6743729,93839.9052764,79.1877455,2924.187667,2307.9291643,4420.2550997,39.7441684,57.5750249,1.9513027,185.3689841),(2951,'blackbuck_femur.tif',237,7,143,467.7687049,74.1997234,43.4255652,1.8,74.8525805,42.2817842,-1.4959155,21.8368315,31.1663186,49183.7066941,90230.4871327,77.5251271,2895.1281745,2252.3279866,4367.5066157,39.9573091,56.8413266,1.952062,184.3361817),(2952,'blackbuck_femur.tif',237,7,144,450.8822319,74.2097134,43.2921353,1.8,74.8019479,42.229389,-1.4789611,21.780482,29.9479191,46463.4766155,84013.856366,74.5150503,2805.3320175,2133.2620925,4210.9345224,39.4890558,55.9422994,1.967505,206.8702696),(2953,'blackbuck_femur.tif',237,7,145,424.0894233,74.2437598,42.8062479,1.8,74.8429502,41.9983329,-1.4775963,21.5295769,28.3152804,42950.4575106,75717.3847498,70.0693884,2674.0821102,1994.9513023,4021.5920903,0.8323034,1.6760191,2.5535901,3.8879377),(2954,'blackbuck_femur.tif',237,7,146,401.0611214,74.2466496,42.400635,1.8,74.9188695,41.7492975,-1.4892403,21.0073551,26.815322,39584.9725968,67547.1277864,66.3999042,2518.9750721,1884.3387147,3822.2096556,1.8714322,2.7204302,1.2220253,8.8981083),(2955,'blackbuck_femur.tif',237,7,147,379.9953171,74.1892719,42.0065709,1.8,74.909518,41.5528186,-1.4994733,20.7235085,25.0886163,36205.6612378,58618.9618666,63.0109279,2336.476477,1747.0816404,3600.9313539,1.3448603,3.5553735,1.7681919,8.7853182),(2956,'blackbuck_femur.tif',237,7,148,356.4242943,74.1997007,41.6052602,1.8,74.8413754,41.345114,-1.5464107,19.7325763,23.3376243,32717.9230992,48791.3058813,59.3687313,2090.6714938,1658.0664666,3215.9822919,36.4456705,49.3753254,2.023918,187.2243525),(2957,'blackbuck_femur.tif',237,7,149,330.8849625,74.2468563,41.2800998,1.8,74.7239252,41.1916856,1.5219401,19.1176727,21.6006602,29336.6495193,38378.8405529,55.0159652,1776.7438644,1534.530378,2730.7196897,35.3951131,46.9498269,0.9223448,174.6074916),(2958,'blackbuck_femur.tif',237,7,150,298.5783813,74.4847755,41.1387511,1.8,74.7055251,41.1829968,1.1520191,22.3100285,23.1323183,24935.8643941,28168.2297732,41.5342897,1217.7002522,1117.6975578,2232.8664377,34.2651202,44.5820366,0.9147828,168.7240279),(2959,'blackbuck_femur.tif',237,7,151,225.5787278,74.6554651,40.9469551,1.8,74.7539835,41.2412894,0.6141003,21.1466175,21.6812849,15058.7962741,19535.981934,12.4832818,901.0527738,712.1137104,1538.5944798,32.887595,41.4552575,0.8846723,153.4308926),(2960,'blackbuck_femur.tif',237,7,152,113.7908293,76.9187278,40.4402121,1.8,76.5290801,41.1501245,0.7118451,20.0990148,19.109604,4695.7187607,10242.7426732,8.0926508,535.9997337,233.6293001,724.5386701,8.3655644,17.0240218,1.6528038,43.2692024),(2961,'blackbuck_femur.tif',237,7,153,38.5703971,80.5073161,38.8995158,1.8,79.344252,40.4827083,1.2926339,17.3028881,17.3568853,718.6731416,2145.1480099,5.9437032,123.590608,41.5348662,161.0485973,3.648029,8.1645995,1.485291,19.9512519),(2962,'blackbuck_femur.tif',237,7,154,13.0282334,81.0374849,35.5903258,1.8,81.009041,35.9150549,-1.4402098,1.8493939,7.4556076,7.1610706,147.2597433,2.1345542,19.7515415,3.8721176,20.7093549,3.6958901,15.1342266,1.3854484,33.5445202),(2963,'blackbuck_femur.tif',237,7,155,1.3074969,81.3128817,35.012915,1.8,81.3167235,35.067837,-1.4486128,0.7323855,3.4390445,0.1356519,3.3509536,0.2146791,0.9743851,0.1852192,1.0135477,1.6423364,7.0688403,1.4056476,15.48568),(2964,'blackbuck_femur.tif',237,7,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2965,'blackbuck_femur.tif',237,7,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2966,'blackbuck_femur.tif',237,7,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2967,'blackbuck_femur.tif',237,7,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2968,'blackbuck_femur.tif',237,7,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2969,'blackbuck_femur.tif',237,7,161,2.3220089,92.4600223,49.2953676,1.8,92.469538,49.3002531,1.4093271,2.7996818,3.0423704,4.0141224,4.691301,0.3769988,1.5419888,1.4337781,2.7792048,5.6941807,6.3947746,1.237552,20.1437966),(2970,'blackbuck_femur.tif',237,7,162,23.3139204,92.4133047,49.4056072,1.8,92.4003246,49.4232393,-1.4111417,6.2009791,6.3326875,186.9793174,192.3745091,3.7874483,30.3780202,30.1531927,59.494104,12.55079,12.9698994,0.9380475,41.6821255),(2971,'blackbuck_femur.tif',237,7,163,47.7179481,92.4198048,49.4418394,1.8,92.4450128,49.4420805,-1.1435264,14.1692851,8.401678,728.1986671,738.0228274,6.5873262,87.8423123,51.3927598,90.3257756,16.5990671,17.0493882,1.0888581,55.0127702),(2972,'blackbuck_femur.tif',237,7,164,72.1920544,92.3891873,49.4543072,1.8,92.4095821,49.4231576,-0.9698995,9.724599,9.8256158,1551.6960001,1576.7060534,8.1858901,160.4689298,159.5640087,317.7006658,19.5234512,19.9314602,1.0183774,64.4788369),(2973,'blackbuck_femur.tif',237,7,165,96.2145372,92.3827382,49.4632963,1.8,92.4106411,49.4427158,-1.0378535,10.9317083,10.9846221,2612.0475184,2642.9168892,11.8963608,240.6015305,238.9422996,476.8234556,21.8476715,22.2470509,1.0088748,72.334467),(2974,'blackbuck_femur.tif',237,7,166,116.4996706,92.3564849,49.4614791,1.8,92.3435706,49.4424646,-1.2996293,11.8364246,11.9030733,3749.5372638,3812.6117422,18.0235311,320.3048205,316.7795504,634.0851684,23.7070478,24.0834544,1.1849137,78.3540803),(2975,'blackbuck_femur.tif',237,7,167,132.6442361,92.2138409,49.4775672,1.8,92.181164,49.4656518,-1.4862674,12.3910994,12.6199857,4729.3854632,4986.3710992,21.9497882,395.1170173,381.6760168,760.6993003,25.1015801,25.5980984,1.0054599,83.3078559),(2976,'blackbuck_femur.tif',237,7,168,337.7906834,75.8287015,50.4661759,1.8,76.3533959,50.3640292,-0.0596784,15.2919059,28.2412628,16295.893039,82252.4348553,0.200269,2912.4913891,1065.6548099,3412.6706201,28.8032356,29.2196194,2.0059819,95.1311784),(2977,'blackbuck_femur.tif',237,7,169,612.52565,70.8317467,50.589406,1.8,76.4401495,50.356022,-0.0565885,16.3206277,33.2710129,30724.6420536,123211.6061011,0.3265656,3703.2718721,1882.5649696,4530.8067921,28.8203327,29.2611868,0.5240722,95.5960224),(2978,'blackbuck_femur.tif',237,7,170,619.699883,70.9861,50.6024738,1.8,76.6463492,50.3402632,-0.0529749,16.206814,33.1294004,31345.3728661,125653.4193237,0.2895817,3792.8069322,1934.0860469,4615.2931101,28.8203327,29.2565712,2.4631296,95.4034777),(2979,'blackbuck_femur.tif',237,7,171,620.6969285,70.9925437,50.6713117,1.8,76.5955958,50.463148,-0.0436015,16.3062288,33.0622734,31488.9880224,125669.8295687,0.1965474,3801.0038844,1931.1018145,4609.3109924,29.0527547,29.283332,2.3112809,95.9247168),(2980,'blackbuck_femur.tif',237,7,172,620.3557022,70.9629234,50.7166254,1.8,76.5430063,50.5321995,-0.0366312,16.3459562,33.0431672,31448.4492679,125278.1257477,0.1386802,3791.347395,1923.9283945,4582.0001355,29.0796807,57.8095798,0.0764635,187.2807475),(2981,'blackbuck_femur.tif',237,7,173,619.2288449,70.923668,50.7490872,1.8,76.5095041,50.5982875,-0.0323417,16.2833988,33.0452346,31296.0881654,124690.9496575,0.1079182,3773.3413342,1921.9628847,4554.1133808,29.1040088,57.8095798,0.0764635,187.1445979),(2982,'blackbuck_femur.tif',237,7,174,618.3384479,70.9121466,50.7649918,1.8,76.4975591,50.6230716,-0.0306861,16.2610462,33.0422737,31179.5297361,124392.8767335,0.0970164,3764.6585088,1917.4368863,4539.9281154,29.0796807,57.8095798,0.0764635,187.6094419),(2983,'blackbuck_femur.tif',237,7,175,619.4598868,70.9121915,50.7595227,1.8,76.5426986,50.5842303,-0.0304191,16.2254161,33.0396364,31224.089234,124611.3554505,0.0955086,3771.5716286,1924.3937403,4547.8235109,29.0918448,57.8095798,0.0764635,187.1445979),(2984,'blackbuck_femur.tif',237,7,176,621.1928977,70.9388965,50.7426038,1.8,76.6118519,50.5341412,-0.0322763,16.2221791,33.0292152,31354.6973868,125233.3713306,0.107823,3791.5939137,1932.8289499,4573.8590002,0.232422,0.734983,1.8925469,1.5870769),(2985,'blackbluck_tibia.tif',237,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2986,'blackbluck_tibia.tif',237,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2987,'blackbluck_tibia.tif',237,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2988,'blackbluck_tibia.tif',237,8,4,2.3284451,45.2130288,41.8203987,1.8,45.1854749,41.8470316,1.1625507,1.0469634,2.3521581,0.452244,2.5154026,0.3269103,1.069402,0.4319579,1.2602642,2.2733658,4.8382263,1.9513027,11.7980181),(2989,'blackbluck_tibia.tif',237,8,5,15.6700293,47.395847,42.1427678,1.8,48.2118641,42.1652663,0.2451737,3.5141524,8.351678,35.4908202,274.3754058,0.1538676,32.8527282,10.0993968,36.9135127,4.5213068,8.5528566,1.9756881,20.9233023),(2990,'blackbluck_tibia.tif',237,8,6,59.8360661,48.7999451,40.8101389,1.8,49.1473009,40.0828146,0.3860361,9.0760408,8.2747951,462.1072605,1049.3001099,1.4137934,126.8067778,50.9150706,160.3608011,13.2226708,17.0466259,1.8925469,56.7891489),(2991,'blackbluck_tibia.tif',237,8,7,129.2392593,48.4198629,38.8601504,1.8,47.0731777,37.5978104,0.1631452,15.9617169,16.788872,2855.8270737,3796.8138788,0.5682445,226.1506236,178.9172866,385.6221404,23.832601,30.8639271,0.6304014,123.8425896),(2992,'blackbluck_tibia.tif',237,8,8,232.7307855,45.6081568,38.1985373,1.8,46.4791021,37.1308192,-0.2410263,15.5684168,16.9887166,7347.5430293,16320.8930908,2.2100656,960.690172,471.9518435,1190.6201203,26.256222,37.1861919,0.7512234,146.8446111),(2993,'blackbluck_tibia.tif',237,8,9,346.2196177,48.2231664,38.4364996,1.8,49.1561307,37.4607882,-0.1285442,31.0438046,26.6301785,15294.8274912,40887.0463138,0.9482271,1535.3650876,492.6853427,1373.6094793,0.224609,0.502241,2.0344439,1.0845083),(2994,'blackbluck_tibia.tif',237,8,10,380.549954,49.1753482,38.8330791,1.8,49.6545983,37.8270062,-0.0996295,28.9001457,24.0381156,23023.8691569,49555.9660726,0.6274784,2061.5578532,796.6696564,1984.742958,34.4580356,43.0710852,0.5243207,198.7958827),(2995,'blackbluck_tibia.tif',237,8,11,391.2822745,49.4201234,39.0935662,1.8,49.9509698,38.105389,-0.0614598,26.3349583,21.9371173,29157.4620298,51608.0773833,0.246022,2352.545992,1107.1770743,2556.1398712,37.4736665,43.801062,1.0910951,199.3540993),(2996,'blackbluck_tibia.tif',237,8,12,408.9343463,49.3528041,39.3333026,1.8,50.0713279,38.4524357,-0.0452485,25.9134753,22.1141678,35222.4856461,52831.7538054,0.1394483,2389.0455286,1359.2343449,2894.1610294,39.8063208,44.4215086,1.1818394,193.7548364),(2997,'blackbluck_tibia.tif',237,8,13,402.9969022,49.4842149,39.420458,1.8,49.9572403,38.6144363,0.0643364,27.3507414,23.0301727,39215.9646081,49354.1160191,0.2776292,2143.0197922,1433.8172406,2879.8964919,41.2520388,45.0076344,1.2032642,194.2943518),(2998,'blackbluck_tibia.tif',237,8,14,395.7080156,49.9336058,39.2825338,1.8,49.6235686,38.5118825,0.4930949,31.6024215,24.6076559,40274.8893736,48162.7438057,14.7773458,1957.2259971,1274.424156,2783.8387089,0.224609,0.3176451,2.3561945,0.6352902),(2999,'blackbluck_tibia.tif',237,8,15,371.3634279,49.5696775,38.9355081,1.8,49.6121713,38.3036628,0.7588104,31.036883,37.2852372,38243.9085853,46823.2279849,29.3021078,1255.8114543,1232.2084213,2279.2054775,39.6535169,47.1154557,2.0195197,152.9195396),(3000,'blackbluck_tibia.tif',237,8,16,348.034979,49.4533154,38.5253736,1.8,49.6905038,38.0357865,0.9821787,31.1226024,37.3866578,34139.1197237,47241.9734751,40.1249434,1263.6051528,1096.9236871,2140.9803084,37.380508,48.5763413,1.9847953,167.7398616),(3001,'blackbluck_tibia.tif',237,8,17,323.5036376,49.7183794,37.7690359,1.8,49.9390957,37.4443824,1.1046813,26.6155545,37.8339561,28751.4351992,48035.4572895,43.0271934,1269.6387657,1080.2493398,1922.3954665,0.449218,0.8098393,0.9827937,1.7197985),(3002,'blackbluck_tibia.tif',237,8,18,302.2958136,49.7957941,37.2342795,1.8,50.0656373,37.0048437,1.1577389,27.2748148,31.3631788,25586.4488655,48671.0951458,42.2644223,1551.8546602,938.0979873,2061.457827,0.5994737,1.6351783,1.2924967,3.7027429),(3003,'blackbluck_tibia.tif',237,8,19,290.2877702,50.0403295,37.0353704,1.8,50.0438775,36.5223929,1.1516818,25.0026813,25.4056051,23014.1988591,49274.7842481,40.3688813,1939.5241319,920.4692338,2241.8357318,32.3492458,50.7208739,1.909352,193.7003371),(3004,'blackbluck_tibia.tif',237,8,20,266.2055337,49.5372467,36.3024092,1.8,49.57762,35.7286023,1.1978662,23.3889582,31.6801668,20294.9779654,42283.3390962,38.4778888,1334.6943338,867.7162012,1720.6453957,0.224609,0.502241,2.0344439,1.0845083),(3005,'blackbluck_tibia.tif',237,8,21,244.8192572,48.7541412,35.5795901,1.8,48.8843116,35.0031002,1.295418,29.6931147,25.3625306,17563.1353825,34987.5130119,37.7864005,1379.4961379,591.4884839,1393.2695935,30.8909677,45.5779239,2.0917762,144.1983247),(3006,'blackbluck_tibia.tif',237,8,22,222.6418606,47.8856609,34.9057356,1.8,47.907869,34.1766664,1.4427002,26.5198754,28.4871436,14044.5944068,28991.4110176,36.5014254,1017.7015781,529.5874955,1116.5338997,0.8528146,3.1284416,1.2036225,7.2739128),(3007,'blackbluck_tibia.tif',237,8,23,211.2428308,47.5859196,34.7232921,1.8,47.5194409,33.911417,1.4796238,25.1873692,29.4258676,12207.8007977,26438.8282229,34.9152918,898.4893348,484.679471,1003.3794202,0.6047417,2.8143429,1.0714496,6.0578316),(3008,'blackbluck_tibia.tif',237,8,24,201.858024,47.3318535,34.665418,1.8,47.2459363,33.8186838,1.5025646,24.262787,30.3722641,10858.8436016,24238.0867224,33.4866197,798.0335821,447.5513719,913.5944665,0.7451507,3.9226279,1.1583859,8.8621384),(3009,'blackbluck_tibia.tif',237,8,25,190.9313365,47.2305066,34.658671,1.8,47.3158105,34.0251084,1.5000537,28.8623094,33.5002658,9562.2532201,21590.6004009,31.6629015,644.4904201,331.305894,704.5163152,0.9446139,3.9800819,1.2847449,9.2568571),(3010,'blackbluck_tibia.tif',237,8,26,183.2748585,47.092185,34.7314243,1.8,47.162944,34.0464046,1.4986383,28.0970414,30.6606516,8536.0349448,19581.8258544,30.3870401,638.6630692,303.8054732,684.2451186,0.449218,0.8098393,0.9827937,1.7197985),(3011,'blackbluck_tibia.tif',237,8,27,177.4103518,46.9352573,34.7662572,1.8,46.9615816,34.1351742,1.5000912,28.7474213,29.7803537,7770.879083,18111.3524361,29.4208196,608.1644493,270.3156919,625.2980523,0.8906916,8.4549708,1.2742505,18.2186435),(3012,'blackbluck_tibia.tif',237,8,28,173.3833888,46.7893339,34.798354,1.8,46.8553317,34.2821705,1.5051153,27.1924263,30.3916628,7153.2330211,17082.9742887,28.7727481,562.0940984,263.059756,594.30301,0.8769654,6.0477829,1.3078016,13.989609),(3013,'blackbluck_tibia.tif',237,8,29,170.1005516,46.6651094,34.9048547,1.8,46.7037572,34.4797393,1.5106506,23.3412263,29.8080203,6658.6231798,16202.3627141,28.2476589,543.5571546,285.2730661,604.178998,1.0380481,7.5302665,1.2679115,17.1115609),(3014,'blackbluck_tibia.tif',237,8,30,169.2032589,46.5210558,34.9769892,1.8,46.6352022,34.574079,1.5127105,26.2092894,28.5848416,6253.2947677,15583.2793191,28.1055024,545.1588487,238.5907783,563.0639138,0.8480721,6.756962,1.3016288,15.0741172),(3015,'blackbluck_tibia.tif',237,8,31,168.2062144,46.3713361,35.1044135,1.8,46.4893475,34.6942092,1.5145656,12.5678632,20.0645416,5928.4716152,14982.029716,27.9458209,746.6918512,471.716752,1007.7355799,0.6689278,1.9190603,1.2120257,4.3380331),(3016,'blackbluck_tibia.tif',237,8,32,167.3752547,46.2435139,35.2826048,1.8,46.3922291,34.9217079,1.5162953,12.6800941,19.8190088,5666.6560032,14396.4151722,27.813097,726.3943059,446.8938449,980.3768091,0.5717687,3.5513804,1.2490458,7.8547037),(3017,'blackbluck_tibia.tif',237,8,33,165.59293,46.2006355,35.4919416,1.8,46.4011224,35.2606316,1.513842,30.0508941,31.9550535,5410.6429088,13765.1945662,27.5093936,430.7673766,180.0493152,447.8074171,0.8210925,7.6828105,1.3045443,16.498845),(3018,'blackbluck_tibia.tif',237,8,34,166.0933555,46.0906697,35.6707593,1.8,46.2733228,35.4488278,1.5172285,12.4116376,19.5172897,5187.9483462,13326.6985051,27.6028673,682.8150167,417.9906394,913.4433866,0.9125297,15.7738869,1.2220253,34.3001954),(3019,'blackbluck_tibia.tif',237,8,35,165.8783196,45.9993276,35.8698732,1.8,46.2256873,35.6051602,1.5176076,28.356107,30.1430561,5051.0830928,13021.4131902,27.5682477,431.9871604,178.1303439,436.6977608,21.0511086,33.9538711,1.2615974,95.2958045),(3020,'blackbluck_tibia.tif',237,8,36,166.914577,45.8986732,36.0976254,1.8,46.0985124,35.8323512,1.5227746,12.3938417,19.4989268,4937.3059802,12831.488328,27.7549922,658.061261,398.3676812,880.0994273,1.4580451,12.7236597,1.2099595,29.808015),(3021,'blackbluck_tibia.tif',237,8,37,167.0746233,45.7951222,36.2537356,1.8,45.9775262,35.7984278,1.524259,12.3221702,19.4326124,4847.0488792,12627.7879177,27.7855078,649.8245148,393.3600002,871.5754661,0.6389065,6.3924847,1.2490458,14.1756812),(3022,'blackbluck_tibia.tif',237,8,38,168.6227567,45.6687682,36.3961483,1.8,45.8239704,35.8555176,1.5262069,12.2426642,19.3540863,4777.1698805,12506.2563691,28.0479533,646.1817005,390.2067247,864.3720534,1.059519,4.0491966,1.2315037,9.7605745),(3023,'blackbluck_tibia.tif',237,8,39,169.6784752,45.5666078,36.6056328,1.8,45.7535448,36.1327854,1.5270148,12.3293746,19.1435049,4727.6240448,12400.5580436,28.2255733,647.7684256,383.4439463,865.805001,0.8221123,8.3105336,1.240499,18.3276421),(3024,'blackbluck_tibia.tif',237,8,40,169.3039127,45.4454787,36.7298227,1.8,45.662451,36.1847433,1.5283074,12.0440201,19.0339556,4661.6593552,12244.5729395,28.1664086,643.3015408,387.0517752,859.8159047,0.59861,4.412867,1.3134726,9.6515759),(3025,'blackbluck_tibia.tif',237,8,41,168.3707705,45.3905263,36.8325839,1.8,45.6670429,36.2112991,1.5256928,11.8639925,18.6835222,4557.4856293,11927.5737162,28.004747,638.4007051,384.1443456,852.545938,1.1451503,15.2005719,1.2397003,33.0296149),(3026,'blackbluck_tibia.tif',237,8,42,167.6158822,45.2789839,37.0304835,1.8,45.5639855,36.386465,1.5187055,11.9338055,18.3953889,4475.398356,11621.8420206,27.8602458,631.7801755,375.0185424,848.3851737,1.5755028,14.4187793,1.2539718,33.9599759),(3027,'blackbluck_tibia.tif',237,8,43,166.6434965,45.1503674,37.2104772,1.8,45.4648916,36.591657,1.5127047,11.9983627,17.9058089,4418.9035647,11264.6176452,27.6802945,629.1040931,368.2922145,844.860774,0.224609,0.502241,2.0344439,1.0845083),(3028,'blackbluck_tibia.tif',237,8,44,167.289491,45.0527423,37.4309927,1.8,45.3890332,36.8389802,1.5030005,11.8391811,17.659974,4383.1266575,11002.0645896,27.7536268,622.9943811,370.2221127,840.1361098,0.858433,2.9966581,1.3439975,6.7701955),(3029,'blackbluck_tibia.tif',237,8,45,167.195044,44.9759536,37.714498,1.8,45.3133246,37.1393813,1.4921348,11.4942296,17.4266449,4324.8909927,10723.069314,27.6937723,615.326094,376.2662786,830.4797536,1.3834544,14.4187793,1.2539718,32.2401774),(3030,'blackbluck_tibia.tif',237,8,46,167.2987554,44.9091586,38.0077897,1.8,45.2183496,37.4344543,1.4806185,11.6515974,17.2328904,4260.5024509,10450.9790616,27.6569932,606.455378,365.6582288,820.2801029,0.6733051,5.5565202,1.3258177,12.0837383),(3031,'blackbluck_tibia.tif',237,8,47,165.9152545,44.861289,38.3183965,1.8,45.1503403,37.7517338,1.4710035,11.4487806,17.0684866,4200.5847157,10144.6937522,27.3780744,594.3522703,366.9023691,805.5204681,1.1230451,4.7381324,1.4758446,11.5574466),(3032,'blackbluck_tibia.tif',237,8,48,166.0312419,44.8028326,38.6426242,1.8,45.113451,38.1023278,1.4587869,11.2990092,16.9068657,4172.5000649,9840.4677601,27.3261485,582.0397417,369.280173,793.8092677,1.0609781,11.6493938,1.2368513,25.1749112),(3033,'blackbluck_tibia.tif',237,8,49,164.6377124,44.7986626,38.9105376,1.8,45.1699518,38.3162508,1.4414062,11.2183291,16.6456424,4135.2537712,9464.2987532,26.982788,568.5751575,368.6158375,780.1281742,1.2556284,9.8674706,1.3644724,23.378039),(3034,'blackbluck_tibia.tif',237,8,50,163.6609851,44.7293304,39.2564982,1.8,45.0984248,38.6005509,1.4185538,11.0283331,16.1293198,4106.9537828,9055.3880221,26.6494835,561.4240489,372.4002315,770.5594019,0.7328243,2.9542704,1.418147,6.7701955),(3035,'blackbluck_tibia.tif',237,8,51,163.2640874,44.6847778,39.5962774,1.8,45.0922283,39.0436967,1.3922584,19.0994266,23.2371478,4079.1796757,8746.7390003,26.3524961,376.4119025,213.5760286,426.406125,1.6814298,12.0055568,1.2667954,27.9021443),(3036,'blackbluck_tibia.tif',237,8,52,163.2116966,44.6223645,39.9441321,1.8,44.9951271,39.363036,1.3660888,11.0823947,15.6381116,4052.6505964,8446.386107,26.0778814,540.115478,365.6836547,759.0398651,1.5070895,12.0746933,1.2490458,27.3213534),(3037,'blackbluck_tibia.tif',237,8,53,162.7725898,44.5735652,40.333282,1.8,44.9061582,39.7850121,1.3337358,10.8175808,15.1148121,4038.4010941,8080.3233506,25.6325372,534.5963468,373.3183209,762.1911658,1.7041148,12.5720872,1.2433961,28.8005804),(3038,'blackbluck_tibia.tif',237,8,54,161.8495374,44.5419166,40.6830552,1.8,44.8665623,40.1363959,1.3014372,10.6840643,14.6121742,4021.6719468,7750.7613487,25.0646527,530.4317646,376.417797,780.6398605,1.2035161,13.0215129,1.3090828,28.6915818),(3039,'blackbluck_tibia.tif',237,8,55,162.0156987,44.5138907,41.0635715,1.8,44.7939416,40.5807653,1.272347,10.583798,14.3244825,4017.2797584,7487.5206162,24.6680078,522.7079297,379.5688225,786.6095033,0.786509,6.756962,1.3016288,14.7019728),(3040,'blackbluck_tibia.tif',237,8,56,161.5807654,44.5081821,41.4688752,1.8,44.760493,41.0394657,1.2401721,10.3425908,13.9662214,4016.5122744,7201.0521988,24.0920447,515.6049002,388.3468227,781.2778474,1.362034,11.7249349,1.2793395,26.2594194),(3041,'blackbluck_tibia.tif',237,8,57,159.5683158,44.5776001,41.8575284,1.8,44.8763826,41.4874182,1.2059286,10.3910797,13.5032965,3988.131363,6837.5202438,23.2085578,506.3593354,383.8033649,783.4521686,1.7509007,12.3718594,1.2949904,29.2497984),(3042,'blackbluck_tibia.tif',237,8,58,157.9377209,44.5976755,42.2553528,1.8,44.8733727,41.900867,1.1721665,10.4421185,13.247063,3972.4531002,6535.9926006,22.357004,493.3918271,380.4259734,776.5574114,2.0490883,14.7645196,1.3405767,33.8735517),(3043,'blackbluck_tibia.tif',237,8,59,156.1177274,44.6384022,42.6604514,1.8,44.8873805,42.3588915,1.1354559,10.9980038,13.0049719,3952.8686046,6257.4985663,21.392109,481.1620217,359.4169148,766.3770032,1.8481195,12.1143202,1.3843094,31.1782435),(3044,'blackbluck_tibia.tif',237,8,60,156.7949851,44.6643312,43.0240851,1.8,44.9067002,42.7508601,1.0946725,10.2732117,12.6186542,3962.0112705,6051.0625779,20.6427569,479.5331167,385.6643259,771.5476974,1.6192456,11.673188,1.3771743,29.8850886),(3045,'blackbluck_tibia.tif',237,8,61,156.5002853,44.7008854,43.3506221,1.8,44.9328119,43.052928,1.0622295,10.7127505,12.2597085,3962.557633,5860.4232078,19.8990923,478.0230447,369.8917116,773.7195676,1.3167505,11.3310741,1.3306253,25.1204119),(3046,'blackbluck_tibia.tif',237,8,62,156.0683636,44.7437632,43.6900944,1.8,44.9598172,43.5055028,1.0229653,10.368688,12.0076388,3946.1311892,5671.317219,18.9552543,472.3091139,380.5815352,773.3185759,1.2958026,11.3865917,1.3114646,24.988839),(3047,'blackbluck_tibia.tif',237,8,63,155.9608915,44.7814924,43.9965482,1.8,44.9542889,43.7616253,0.980058,9.7459732,11.7288282,3929.5518106,5515.3843698,17.9297718,470.2417237,403.1974793,777.1172935,1.0012556,9.8674706,1.3644724,21.5492419),(3048,'blackbluck_tibia.tif',237,8,64,155.4685836,44.8324651,44.3303791,1.8,45.0028321,44.1517083,0.9393151,10.5380048,11.4165028,3900.8714035,5363.6864955,16.8812337,469.8187001,370.1717241,777.7761304,0.449218,2.0339212,1.6814535,4.4151067),(3049,'blackbluck_tibia.tif',237,8,65,153.2665214,44.9221955,44.6243781,1.8,45.0969537,44.5498151,0.8857699,13.7718317,31.0685774,3828.1875941,5181.9075409,15.3189616,166.7893405,277.9722892,265.126692,0.9094231,8.6787483,1.388628,19.1170796),(3050,'blackbluck_tibia.tif',237,8,66,151.6279463,44.969243,44.932004,1.8,45.1767245,44.8533135,0.8426862,9.724216,11.2278132,3778.7372838,5027.7834854,14.0802405,447.7972139,388.5904319,762.5104551,1.736635,12.9281954,1.4313563,29.1088749),(3051,'blackbluck_tibia.tif',237,8,67,150.7182401,45.0152008,45.2325949,1.8,45.1780092,45.1374282,0.7936893,10.6324151,22.188584,3747.9296392,4921.9126535,12.7681156,221.8218457,352.5003103,358.9049233,1.1536776,10.1869537,1.3258177,22.3706044),(3052,'blackbluck_tibia.tif',237,8,68,151.5249688,45.0834593,45.5090765,1.8,45.2155454,45.3426294,0.751623,9.7618951,11.3804275,3722.9428409,4849.3457845,11.774765,426.1127971,381.3750117,734.4956474,1.5461428,12.0391271,1.4209839,27.6841472),(3053,'blackbluck_tibia.tif',237,8,69,151.5226451,45.1653287,45.8071662,1.8,45.2740166,45.6659541,0.698383,10.2799936,11.1734614,3708.2233013,4783.6490902,10.4405009,428.1259771,360.7223342,741.3105323,1.1776865,10.6730651,1.422947,23.7182585),(3054,'blackbluck_tibia.tif',237,8,70,151.2812227,45.2524578,46.0896213,1.8,45.3865031,46.0090947,0.6511579,10.0249507,11.271973,3668.3442836,4727.0614943,9.2626133,419.3641619,365.9214279,717.2191973,1.2205633,10.3710037,1.484058,23.0829682),(3055,'blackbluck_tibia.tif',237,8,71,151.2312015,45.324486,46.3491729,1.8,45.3655829,46.2113103,0.6046374,10.5621006,12.2229265,3633.3707597,4674.5013153,8.145088,382.4371609,344.0007718,677.3740205,0.449218,3.6217116,1.4464413,7.9317774),(3056,'blackbluck_tibia.tif',237,8,72,151.0956002,45.429027,46.6088393,1.8,45.4486654,46.518983,0.553351,10.0833711,11.0132516,3589.8684714,4629.8312308,6.955269,420.3873129,356.0186803,744.0501193,0.224609,2.4808877,1.6614562,5.1274706),(3057,'blackbluck_tibia.tif',237,8,73,149.4358364,45.5727838,46.8152501,1.8,45.6445103,46.7395503,0.5029065,10.246507,11.1028038,3509.4670405,4548.6529674,5.7856355,409.6850716,342.5037479,710.242233,0.7928183,7.4663497,1.4501727,16.3127728),(3058,'blackbluck_tibia.tif',237,8,74,148.1715792,45.6834586,47.0553772,1.8,45.7692251,47.0166666,0.4631908,10.2850788,12.3274697,3443.3223611,4488.0154945,4.9300302,364.0662356,334.7881354,640.0488691,1.2121375,8.1139522,1.4876551,18.6678615),(3059,'blackbluck_tibia.tif',237,8,75,147.543884,45.7874896,47.2816302,1.8,45.8213317,47.2389843,0.4220722,10.123867,12.1812883,3386.804843,4444.8142753,4.1266664,364.8886853,334.536678,641.1092547,0.9887079,4.7646768,1.7126934,11.3713744),(3060,'blackbluck_tibia.tif',237,8,76,147.7092351,45.9202502,47.5196032,1.8,46.0564842,47.5681798,0.3996062,10.1710478,11.3400814,3345.2190666,4416.1192172,3.7263165,389.4257074,328.8962095,676.3413573,0.449218,1.4205522,1.8925469,3.2535248),(3061,'blackbluck_tibia.tif',237,8,77,147.8756869,46.0457559,47.7529484,1.8,46.1823441,47.8392199,0.3734166,10.2312876,12.0448639,3310.8426685,4396.9810368,3.2798362,365.0502881,323.599805,639.9225788,0.8984361,4.4977921,1.6207547,11.2943008),(3062,'blackbluck_tibia.tif',237,8,78,148.3045664,46.1712428,47.9723439,1.8,46.296659,48.0786414,0.3554429,11.3815868,11.1461637,3287.023936,4378.9034112,2.9934759,392.8619333,288.801905,667.7889743,0.8984361,6.9665013,1.6030432,15.6004089),(3063,'blackbluck_tibia.tif',237,8,79,148.3271615,46.3102028,48.1843858,1.8,46.4250183,48.2740675,0.3294704,9.8560116,10.8677557,3237.8041648,4356.3132763,2.5877992,400.8475529,328.5105881,697.453563,0.5630858,3.3989512,1.4382448,7.4825593),(3064,'blackbluck_tibia.tif',237,8,80,148.6013759,46.4421049,48.3781418,1.8,46.5419644,48.4164939,0.3070272,10.0789779,11.1252886,3202.2203993,4340.0475222,2.2622253,390.1065124,317.7128099,671.8747683,17.0778947,19.5706517,2.5854264,60.2738946),(3065,'blackbluck_tibia.tif',237,8,81,147.4134499,46.6367881,48.5616974,1.8,46.7603353,48.6505271,0.2850627,10.274895,11.2849879,3139.11698,4287.31412,1.9429917,379.9130448,305.5132913,650.5957829,0.8139651,5.6331655,1.4909663,13.2772451),(3066,'blackbluck_tibia.tif',237,8,82,146.7693663,46.7791501,48.7518505,1.8,46.9240616,48.8248349,0.268087,10.4483595,10.8915718,3089.1239623,4244.3725945,1.7163511,389.6933021,295.6563625,673.3168358,1.1271903,5.8785806,1.4559197,14.0666826),(3067,'blackbluck_tibia.tif',237,8,83,146.7401058,46.9146203,48.9439913,1.8,47.0099251,49.0393666,0.2580301,10.2109448,11.3291416,3058.6025089,4221.176994,1.5924959,372.594601,299.5415764,606.9178157,0.6638226,4.5811431,1.7681919,9.7286495),(3068,'blackbluck_tibia.tif',237,8,84,147.0174694,47.0704308,49.1412182,1.8,47.1564472,49.2320829,0.2422473,10.2591077,11.0600567,3028.3035304,4200.9417096,1.4100145,379.8300347,295.1819606,615.5724819,0.7971374,3.8773528,1.7454685,9.1252842),(3069,'blackbluck_tibia.tif',237,8,85,146.7900199,47.2197448,49.3337674,1.8,47.3160865,49.4346708,0.2200863,10.2763342,10.9294039,2996.4465844,4166.157184,1.1660249,381.1879623,291.5871099,642.3316685,0.449218,3.8249537,1.6295521,8.3809954),(3070,'blackbluck_tibia.tif',237,8,86,147.0499709,47.3488067,49.496399,1.8,47.3730606,49.565588,0.2018741,10.1831886,10.9938958,2966.6501238,4134.9335548,0.985297,376.1117662,291.3282103,642.686259,0.810348,6.0810584,1.6447354,13.989609),(3071,'blackbluck_tibia.tif',237,8,87,147.538625,47.5025847,49.6638214,1.8,47.5282738,49.7679945,0.1860394,10.7854877,10.2665799,2933.2220431,4114.7271996,0.8412948,400.7885024,271.9600746,653.0868766,0.4020207,0.8098393,0.9827937,1.7197985),(3072,'blackbluck_tibia.tif',237,8,88,147.3355593,47.6598334,49.8457,1.8,47.6654568,49.9342742,0.1643541,9.9932856,10.3350767,2888.8151671,4079.0095378,0.6573602,394.6762727,289.0756136,659.7512417,0.449218,3.1525378,1.6421038,7.2194135),(3073,'blackbluck_tibia.tif',237,8,89,145.1107797,47.8528026,49.992057,1.8,47.9393328,50.1309876,0.1481891,10.0729839,10.9878848,2837.7226926,4001.0279509,0.5272292,364.1308598,281.7161953,615.8996839,0.8984361,4.9617754,1.6614562,11.6890195),(3074,'blackbluck_tibia.tif',237,8,90,145.1725724,47.9848398,50.1274905,1.8,48.0566497,50.1963692,0.1342537,10.1945978,10.8799198,2808.2960338,3945.2715115,0.4334861,362.6195415,275.4690378,605.3485697,0.6738271,3.8446871,1.6879051,8.7531398),(3075,'blackbluck_tibia.tif',237,8,91,144.2050482,48.1257901,50.2992666,1.8,48.2280899,50.3811968,0.1100373,10.1386153,10.6077797,2770.6060262,3877.8412237,0.2898381,365.5657765,273.2726252,624.406112,0.664099,4.1415856,1.7894653,9.0162856),(3076,'blackbluck_tibia.tif',237,8,92,144.0758371,48.2786104,50.466527,1.8,48.402558,50.5458006,0.0892901,10.303289,10.6733363,2745.9992041,3838.7570471,0.1909378,359.6585871,266.5167611,593.9652714,0.5866856,2.9966581,1.7975952,6.7701955),(3077,'blackbluck_tibia.tif',237,8,93,144.0723362,48.4350789,50.630382,1.8,48.5607995,50.7244689,0.0621568,9.9887724,10.153836,2726.1488428,3805.3503914,0.0926502,374.7697321,272.9213093,598.9871925,16.1718493,18.8564588,2.9255077,57.9188059),(3078,'blackbluck_tibia.tif',237,8,94,143.7511123,48.5979994,50.7940104,1.8,48.731054,50.8646722,0.0355733,9.4410532,10.7068379,2690.282816,3770.3270423,0.0303057,352.1419733,284.9557932,594.9429724,0.449218,1.0044821,1.1071487,2.1690165),(3079,'blackbluck_tibia.tif',237,8,95,145.0879094,48.740711,50.9362381,1.8,48.787118,51.0339247,0.0182673,9.7271009,10.0766408,2672.8286742,3752.791099,0.0080682,372.4248172,274.7816348,537.7876988,15.9472402,18.6965928,2.8616428,57.2835156),(3080,'blackbluck_tibia.tif',237,8,96,144.9500149,48.8728192,51.0667827,1.8,48.8927904,51.1388806,-0.002543,9.3532466,10.6481696,2649.8479202,3720.3213498,0.0001562,349.3859961,283.3078219,552.1585142,0.4436874,1.6351783,1.849096,3.5166706),(3081,'blackbluck_tibia.tif',237,8,97,144.8182507,49.0630078,51.1620339,1.8,49.0755933,51.2874397,-0.0215255,9.6543021,10.0184529,2619.7137951,3661.4097347,0.0111818,365.4665817,271.3519587,592.242096,0.449218,2.2572927,1.670465,5.050397),(3082,'blackbluck_tibia.tif',237,8,98,144.8357551,49.2202791,51.2908854,1.8,49.2863651,51.3909885,-0.0327387,9.6455352,10.5226987,2592.3507694,3620.7753357,0.0258639,344.0918937,268.7617356,578.0941777,0.6738271,4.4977921,1.6207547,9.9147217),(3083,'blackbluck_tibia.tif',237,8,99,144.6348296,49.3776579,51.4109105,1.8,49.4310462,51.4959789,-0.0440054,9.8400732,9.9467078,2555.1582748,3573.0228631,0.0466502,359.2166303,259.6686235,584.4310997,0.449218,2.4808877,1.6614562,5.499615),(3084,'blackbluck_tibia.tif',237,8,100,144.8590993,49.5476693,51.5350041,1.8,49.6170836,51.654848,-0.0581791,10.4730051,10.4241516,2528.1599138,3540.6249587,0.081628,339.6559363,241.3977548,543.1449251,15.5847409,18.426155,2.9824559,56.2535066),(3085,'blackbluck_tibia.tif',237,8,101,144.6920818,49.7175782,51.6470888,1.8,49.7939242,51.7599498,-0.0668803,10.3155398,10.3793466,2490.2133212,3497.9935827,0.1077064,337.0148156,241.4040738,538.6128649,0.4268105,1.0044821,1.1071487,2.1690165),(3086,'blackbluck_tibia.tif',237,8,102,145.1685517,49.8958236,51.7504477,1.8,49.9741138,51.8449273,-0.0733173,9.7080312,10.4264205,2459.561057,3470.0191189,0.1298242,332.8102039,253.3532293,552.5257059,15.2734132,18.2818495,2.9562447,55.7497893),(3087,'blackbluck_tibia.tif',237,8,103,144.2792086,50.0726363,51.8482015,1.8,50.1313763,51.9588822,-0.0830643,9.5508974,10.308487,2420.3563533,3426.4175595,0.165532,332.3880176,253.4166437,509.6666603,0.224609,1.1452858,1.7681919,2.4321624),(3088,'blackbluck_tibia.tif',237,8,104,144.7500373,50.2536328,51.9357495,1.8,50.3291885,51.9663386,-0.0883081,10.628278,10.3291731,2392.2562826,3390.0202062,0.1876461,328.1986067,225.0840901,542.0111839,0.449218,2.2572927,1.670465,5.050397),(3089,'blackbluck_tibia.tif',237,8,105,142.9143128,50.4774267,51.9661185,1.8,50.5569461,52.0852207,-0.097352,11.0967891,10.3450991,2344.655449,3330.3482606,0.2250308,321.9252154,211.2913418,468.9718008,0.224609,0.7102761,1.8925469,1.5337263),(3090,'blackbluck_tibia.tif',237,8,106,142.0617364,50.654788,52.0531135,1.8,50.7480683,52.1868492,-0.101707,10.8150606,10.1329628,2307.5509707,3273.1918151,0.2440783,323.0241631,213.3645902,489.8248619,0.224609,0.502241,2.0344439,1.0845083),(3091,'blackbluck_tibia.tif',237,8,107,141.6197861,50.8290903,52.1380538,1.8,50.9084116,52.2957948,-0.1115074,10.38345,9.9558071,2275.8289138,3227.4377663,0.2922664,324.1764064,219.1784922,459.8373105,0.4358743,1.2095566,1.9513027,2.6182346),(3092,'blackbluck_tibia.tif',237,8,108,140.5394697,50.9972268,52.2062639,1.8,51.092351,52.2927575,-0.1154625,9.7291757,10.143877,2241.1533651,3187.0060896,0.310884,314.1802768,230.3538795,458.5602572,14.8376142,17.982754,2.9784974,54.4021352),(3093,'blackbluck_tibia.tif',237,8,109,140.430423,51.1660375,52.2713951,1.8,51.2699513,52.358903,-0.1201789,10.4519999,10.3138595,2211.9671902,3160.0379788,0.3364143,306.3875338,211.6310005,492.165898,0.4272317,1.4205522,1.8925469,3.0674526),(3094,'blackbluck_tibia.tif',237,8,110,140.682562,51.3367336,52.3345376,1.8,51.4579028,52.4198932,-0.1299237,9.8799468,10.1593842,2185.7272347,3132.4051507,0.393569,308.3262828,221.2286436,511.6930984,14.7048169,17.8588888,3.0281577,53.9529172),(3095,'blackbluck_tibia.tif',237,8,111,140.615327,51.4989221,52.3895466,1.8,51.5880384,52.4950349,-0.1347515,10.1445114,10.3036459,2153.5410414,3118.9641427,0.4229785,302.7049047,212.2863251,474.7588883,14.6597583,17.8857051,3.01568,53.8213443),(3096,'blackbluck_tibia.tif',237,8,112,140.4007038,51.6645564,52.4338601,1.8,51.7592459,52.5350127,-0.1383088,9.7140668,9.755399,2119.1193216,3104.2101566,0.4447814,318.2043247,218.149553,481.5771289,0.449218,1.3662433,1.735945,3.0674526),(3097,'blackbluck_tibia.tif',237,8,113,138.6793615,51.8681189,52.4363519,1.8,51.9398036,52.5607503,-0.1452467,9.99421,10.1622318,2089.6395899,3061.811479,0.484191,301.2932139,209.0850196,500.7601361,0.224609,0.7102761,1.8925469,1.5337263),(3098,'blackbluck_tibia.tif',237,8,114,137.4693448,52.0208884,52.4977646,1.8,52.104111,52.6597166,-0.1460764,9.9158964,10.7123373,2052.1726144,3033.0754586,0.4854265,283.1385332,206.9578523,467.6786221,14.3983193,17.8136334,3.0532159,53.6897714),(3099,'blackbluck_tibia.tif',237,8,115,136.8536962,52.1781326,52.5289139,1.8,52.2505607,52.6536325,-0.1404697,9.7062458,10.0613336,2003.2403753,3005.523985,0.4471075,298.7202402,206.3867343,489.2157802,0.224609,1.5882256,1.7126934,3.3305984),(3100,'blackbluck_tibia.tif',237,8,116,136.5783047,52.3416352,52.5556419,1.8,52.450102,52.6587212,-0.1323554,9.6354874,10.61961,1965.6567052,2983.9300883,0.396439,280.983019,204.0017928,459.0184564,0.224609,0.502241,2.0344439,1.0845083),(3101,'blackbluck_tibia.tif',237,8,117,135.9869177,52.4975673,52.5984421,1.8,52.6020717,52.7604882,-0.1296862,10.2135367,9.8944485,1934.9950361,2959.9977016,0.3790505,299.1574221,189.4539668,474.0345225,14.0984779,17.7256223,2.9889433,52.6823367),(3102,'blackbluck_tibia.tif',237,8,118,135.4489609,52.6347414,52.6393799,1.8,52.7017287,52.779918,-0.1270042,9.684875,9.9606246,1909.9028088,2947.6840398,0.3621797,295.9336538,197.204694,474.7445489,14.0322436,17.6928616,3.0014909,52.5507638),(3103,'blackbluck_tibia.tif',237,8,119,136.7017371,52.7701903,52.6743093,1.8,52.7917601,52.7721626,-0.124222,9.3867304,9.6663608,1876.5607959,2929.8328716,0.3497716,303.0957505,199.9163415,474.5994536,0.224609,0.9260867,1.815775,1.9829443),(3104,'blackbluck_tibia.tif',237,8,120,136.0210855,52.9180413,52.7101157,1.8,52.9407464,52.8192644,-0.121765,9.3379594,9.7167059,1856.3847426,2909.168814,0.3344662,299.3986695,198.7998311,463.3844824,13.8477861,17.6200012,2.9491971,52.5507638),(3105,'blackbluck_tibia.tif',237,8,121,134.7115157,53.1027864,52.6742268,1.8,53.1427719,52.8182438,-0.1170821,9.8334659,9.9310799,1834.3184274,2869.5023829,0.3063722,288.9416262,186.5383417,449.3205339,13.7736437,17.6357417,3.026716,52.2331187),(3106,'blackbluck_tibia.tif',237,8,122,133.6649086,53.2310702,52.7035341,1.8,53.2479427,52.8627633,-0.1110011,10.0746761,9.591891,1808.5465114,2832.3964566,0.2733606,295.2907266,179.5141103,455.135639,0.6284132,2.7782601,1.815775,5.948833),(3107,'blackbluck_tibia.tif',237,8,123,132.7308492,53.3563136,52.7231458,1.8,53.3817786,52.8401928,-0.1064898,9.4435492,9.6971652,1791.1949516,2795.6905084,0.2499162,288.2997703,189.6739161,425.4745826,0.449218,1.4205522,1.8925469,3.0674526),(3108,'blackbluck_tibia.tif',237,8,124,132.238633,53.4773404,52.7434148,1.8,53.4985529,52.883244,-0.0997551,9.1788808,9.6082946,1777.3470985,2766.3690095,0.2185931,287.9146741,193.6344018,422.4373413,13.6537697,17.4126321,3.0252375,51.7294014),(3109,'blackbluck_tibia.tif',237,8,125,131.6672575,53.588393,52.7551375,1.8,53.6133051,52.8755649,-0.0971537,9.2024294,9.6808639,1758.1459938,2734.7199055,0.2064802,282.4871757,191.0523759,458.0255556,13.6140175,17.3574965,2.9594243,51.4117562),(3110,'blackbluck_tibia.tif',237,8,126,131.0691133,53.6922201,52.7726661,1.8,53.7062817,52.9062343,-0.0956905,9.3998078,9.5809281,1745.7389299,2705.4891509,0.1994162,282.3827854,185.7207039,442.4133088,0.224609,0.502241,2.0344439,1.0845083),(3111,'blackbluck_tibia.tif',237,8,127,129.601928,53.797107,52.7891377,1.8,53.822311,52.9324501,-0.0896595,9.8645003,9.5048448,1736.7824483,2674.7214343,0.1731762,281.4061138,176.0639064,399.6317421,0.224609,0.502241,2.0344439,1.0845083),(3112,'blackbluck_tibia.tif',237,8,128,129.0513589,53.8987486,52.7984882,1.8,53.9477908,52.933961,-0.0829415,8.9201654,9.4656367,1725.8896319,2638.1357179,0.1476248,278.7066316,193.4817975,436.8006937,0.224609,0.7102761,1.8925469,1.5337263),(3113,'blackbluck_tibia.tif',237,8,129,127.6467,54.0327024,52.7478369,1.8,54.0688546,52.8886397,-0.0772579,8.8457105,9.3285621,1718.9284503,2584.1436359,0.12673,277.0141438,194.3233895,438.2842708,0.4268105,1.0044821,2.0344439,2.1690165),(3114,'blackbluck_tibia.tif',237,8,130,126.4919481,54.1158779,52.7582239,1.8,54.1598686,52.9257545,-0.0740719,10.1388639,9.3874792,1715.3352139,2535.0056708,0.1154581,270.0411486,169.1841647,407.3550274,13.4715636,16.906958,2.803037,51.0941111),(3115,'blackbluck_tibia.tif',237,8,131,125.5360579,54.1917212,52.7632806,1.8,54.2430777,52.9090955,-0.0658809,10.1160489,9.3214186,1717.6011839,2498.2790403,0.0906792,268.014897,169.7897265,385.6521496,0.6578547,2.9966581,1.7975952,6.5841233),(3116,'blackbluck_tibia.tif',237,8,132,124.8440629,54.2595972,52.767248,1.8,54.3214556,52.9553524,-0.0561428,10.1127015,9.2639965,1719.9643701,2459.4121667,0.0655162,265.4806873,170.0796136,384.0625471,13.5521151,16.7254559,2.8835854,50.9625382),(3117,'blackbluck_tibia.tif',237,8,133,124.6254496,54.3207987,52.7635716,1.8,54.3675131,52.9172467,-0.0514596,10.1153266,9.2072053,1727.3771914,2429.0587777,0.0549546,263.8215075,170.768306,410.4306205,0.224609,0.3176451,2.3561945,0.6352902),(3118,'blackbluck_tibia.tif',237,8,134,124.4267715,54.3841124,52.7747034,1.8,54.4437159,53.0084202,-0.0410462,10.2752415,9.1537284,1742.0156337,2402.3026503,0.0349191,262.4397999,169.5352494,373.0749919,0.6826824,2.8411043,1.8925469,6.5070496),(3119,'blackbluck_tibia.tif',237,8,135,124.2234917,54.4417966,52.7840933,1.8,54.4961601,52.9970506,-0.030743,9.6361859,9.1044664,1744.9457267,2374.8791355,0.0195618,260.8477003,181.0826131,400.1041108,13.7615444,16.604365,2.7384771,50.776466),(3120,'blackbluck_tibia.tif',237,8,136,124.6440241,54.4994994,52.7926787,1.8,54.5553257,52.9965829,-0.0172309,9.8847684,9.4741228,1744.345492,2351.6693115,0.0061672,248.2202701,176.4680181,353.527673,0.224609,0.502241,2.0344439,1.0845083),(3121,'blackbluck_tibia.tif',237,8,137,123.2866958,54.6110448,52.738608,1.8,54.66466,52.9650901,-0.0045834,9.4737301,9.1734978,1739.9118775,2310.5529243,0.0004316,251.8726194,183.6564759,406.1217632,13.9111353,16.4839149,2.7939858,50.6448931),(3122,'blackbluck_tibia.tif',237,8,138,122.3902744,54.6837991,52.7503166,1.8,54.7573998,52.9793958,0.0184906,9.9531999,9.1291294,1736.8223967,2286.8814436,0.0069735,250.5037827,174.4988966,396.7834035,14.0005593,16.4839149,2.7939858,50.6993924),(3123,'blackbluck_tibia.tif',237,8,139,121.5907615,54.7462509,52.7622828,1.8,54.8176603,53.0225937,0.0336206,9.9715756,10.1531607,1738.0983243,2264.5966066,0.0228979,223.0435112,174.3052845,393.3986112,0.5734908,2.0707928,1.7894653,4.6011789),(3124,'blackbluck_tibia.tif',237,8,140,121.0783351,54.8019977,52.7759301,1.8,54.8407456,53.0371038,0.0494825,12.1544216,9.0429768,1735.8757213,2250.5618632,0.0493701,248.874007,142.818456,327.9770424,0.449218,2.2905715,1.7681919,4.8643248),(3125,'blackbluck_tibia.tif',237,8,141,120.6402372,54.866082,52.7901754,1.8,54.9386164,53.0326642,0.0594,10.1528555,9.7769068,1727.4960108,2243.5491342,0.0708603,229.4743308,170.1487842,390.483073,0.449218,1.1452858,1.7681919,2.8043068),(3126,'blackbluck_tibia.tif',237,8,142,120.3004694,54.9290084,52.7973843,1.8,55.0025255,53.0393692,0.0772818,9.8154927,9.1950723,1732.8170809,2243.7813894,0.1195103,244.0199829,176.538981,349.3813315,0.6231797,2.5112052,1.7506498,6.0578316),(3127,'blackbluck_tibia.tif',237,8,143,119.8568068,54.9927081,52.8099715,1.8,55.0369416,53.0446578,0.0847802,9.912552,9.3085413,1727.1925066,2243.8690665,0.1432384,241.0548556,174.2429711,400.4840339,0.6185895,1.8521734,1.815775,4.3380331),(3128,'blackbluck_tibia.tif',237,8,144,119.6963783,55.0607202,52.8268001,1.8,55.1136469,53.1032009,0.0907292,10.1472909,9.0748736,1729.976007,2250.5254199,0.1637691,247.9952371,170.4864905,382.8298837,0.449218,1.6351783,1.849096,3.8888151),(3129,'blackbluck_tibia.tif',237,8,145,117.774829,55.168045,52.7686917,1.8,55.183817,52.9866891,0.1025277,10.4442489,9.0074454,1726.0918358,2243.0781829,0.2056181,249.0248983,165.2672069,355.9004461,0.449218,1.1452858,1.7681919,2.6182346),(3130,'blackbluck_tibia.tif',237,8,146,116.4732088,55.2277957,52.7789712,1.8,55.2023468,52.9910276,0.1130535,10.444615,9.206719,1726.2783808,2239.4305467,0.2470537,243.2387196,165.2792733,379.4509078,0.224609,1.1452858,1.7681919,2.4321624),(3131,'blackbluck_tibia.tif',237,8,147,115.5384614,55.2903417,52.791889,1.8,55.2756097,52.9590913,0.1246751,9.8577889,9.6570346,1728.3409207,2247.5724905,0.2977717,232.7394057,175.3274421,384.0484347,0.449218,0.9260867,1.815775,2.1690165),(3132,'blackbluck_tibia.tif',237,8,148,115.5727057,55.3593587,52.830951,1.8,55.3911008,53.0117734,0.1305265,10.9954694,9.7170949,1740.6025845,2270.3555622,0.3263122,233.6455068,158.3017983,364.5031219,14.2882457,16.561774,2.7812347,50.8309653),(3133,'blackbluck_tibia.tif',237,8,149,115.3513865,55.4164182,52.8702471,1.8,55.4310836,53.0506273,0.1412119,9.7199608,9.0694215,1756.7878277,2295.487524,0.3808252,253.1018691,180.7402168,390.4225521,14.2975999,16.604365,2.7384771,50.9625382),(3134,'blackbluck_tibia.tif',237,8,150,115.6851616,55.4858615,52.90973,1.8,55.5285456,53.085039,0.1444336,9.9142978,9.4027289,1785.3503446,2340.0138394,0.3994303,248.8653943,180.0783456,408.1586162,14.2975999,16.7254559,2.7560988,51.225684),(3135,'blackbluck_tibia.tif',237,8,151,116.1698256,55.5435439,52.9516076,1.8,55.5597314,53.108016,0.1469709,9.7345683,9.2260133,1824.98427,2378.2762921,0.4152176,257.7794125,187.4745963,404.3580217,14.4029554,16.811201,2.7437183,51.4117562),(3136,'blackbluck_tibia.tif',237,8,152,116.6291886,55.6057672,52.984707,1.8,55.6354053,53.1401882,0.1439648,9.7571626,9.7222875,1863.5772336,2418.0847473,0.4000976,248.7156182,190.9958164,424.545408,14.4753008,16.9114333,2.6125622,51.7294014),(3137,'blackbluck_tibia.tif',237,8,153,114.7775803,55.6844794,52.9308435,1.8,55.706272,53.1314249,0.1393482,10.0205985,9.3795239,1896.351771,2430.6458112,0.369059,259.1438381,189.2453595,416.5940962,14.5394425,16.994756,2.6306431,52.1015458),(3138,'blackbluck_tibia.tif',237,8,154,114.1442898,55.7431413,52.9383221,1.8,55.7697715,53.1217709,0.1270238,10.2373384,9.2745108,1921.2801683,2459.1816167,0.3053065,265.1548592,187.6737966,420.3612374,14.5903712,17.0835794,2.6485418,52.5507638),(3139,'blackbluck_tibia.tif',237,8,155,113.7252097,55.7916583,52.9352818,1.8,55.8161196,53.1174256,0.1115485,10.4728633,9.6913621,1948.3943875,2484.9167482,0.2348716,256.4053157,186.0421861,415.3504481,14.715874,17.1057131,2.6191892,52.736836),(3140,'blackbluck_tibia.tif',237,8,156,113.5715231,55.8299606,52.9337428,1.8,55.8460315,53.124544,0.1015097,10.5473821,9.8000374,1974.6761787,2524.9912204,0.1943752,257.6511829,187.2195544,425.2054993,0.449218,2.4808877,1.6614562,5.8717594),(3141,'blackbluck_tibia.tif',237,8,157,113.6197709,55.8679321,52.9320911,1.8,55.8999949,53.1309294,0.0902173,10.7061563,9.4199287,2006.1324488,2575.0922333,0.1537108,273.3664239,187.3812037,419.483611,0.449218,1.1452858,1.7681919,2.8043068),(3142,'blackbluck_tibia.tif',237,8,158,113.6241431,55.9043109,52.9276398,1.8,55.9695705,53.0879358,0.0800616,10.5289208,9.4246965,2038.3794184,2621.8409015,0.1211267,278.1883645,193.5981342,436.490097,14.9272316,17.4010391,2.7299213,53.8758436),(3143,'blackbluck_tibia.tif',237,8,159,114.1634452,55.9501972,52.9274188,1.8,56.0414208,53.1216404,0.0621344,10.772248,9.6927876,2088.4824072,2689.2260202,0.0733636,277.4460886,193.8761906,437.6332673,15.000042,17.5195034,2.7468015,54.0074165),(3144,'blackbluck_tibia.tif',237,8,160,114.6681666,55.996207,52.9099256,1.8,56.0557287,53.0580147,0.0322143,10.4049111,10.2395752,2145.0667664,2760.3050867,0.0198261,269.5722275,206.1590662,469.5319686,0.449218,1.1452858,1.7681919,2.8043068),(3145,'blackbluck_tibia.tif',237,8,161,114.538558,56.081977,52.8449122,1.8,56.1630878,53.0733344,0.0094823,10.9599286,9.7189227,2214.8716489,2816.4167849,0.0017164,289.7869321,202.0881462,454.1115724,0.224609,0.502241,2.0344439,1.0845083),(3146,'blackbluck_tibia.tif',237,8,162,114.8561434,56.1272141,52.8184757,1.8,56.2363754,53.0242484,-0.0095269,11.1798463,9.7023835,2297.8222879,2893.8466125,0.0017374,298.2614122,205.5325465,459.3785073,0.449218,2.0339212,1.6814535,4.9733233),(3147,'blackbluck_tibia.tif',237,8,163,115.3928772,56.1644944,52.8041636,1.8,56.259577,53.0577425,-0.0013323,11.6571015,10.5458987,2394.7056154,2986.7976315,0.0000342,283.2188824,205.4289065,459.4168662,0.4358743,1.4205522,1.2490458,3.0674526),(3148,'blackbluck_tibia.tif',237,8,164,116.8972574,56.2106914,52.7769468,1.8,56.3057862,52.9943692,-0.0014853,11.2345223,10.7237757,2515.0842769,3130.391834,0.000043,291.9113504,223.8710479,498.5295001,0.224609,1.1452858,1.7681919,2.4321624),(3149,'blackbluck_tibia.tif',237,8,165,119.1000992,56.2663671,52.7414851,1.8,56.3902775,52.9608098,-0.001729,11.7195346,10.4459187,2666.1621954,3319.8757773,0.0000593,317.815585,227.4972753,508.802398,0.449218,1.8521734,1.3258177,4.1519609),(3150,'blackbluck_tibia.tif',237,8,166,120.9656193,56.2974304,52.7548908,1.8,56.4205953,53.0263126,0.0191508,11.2809006,10.4659944,2784.1030482,3534.875764,0.0073931,337.748677,246.7979426,557.7267661,0.224609,0.7102761,1.8925469,1.5337263),(3151,'blackbluck_tibia.tif',237,8,167,122.5539745,56.312973,52.8034266,1.8,56.4621479,53.0531362,0.0541895,11.251055,10.5620276,2880.4021049,3780.5989221,0.0599213,357.942534,256.0117336,589.6623534,16.4035167,19.9535754,2.5973122,60.296469),(3152,'blackbluck_tibia.tif',237,8,168,124.1413512,56.3058019,52.8641554,1.8,56.4273826,53.1135102,0.0914737,11.9519744,11.0252097,2979.6240046,4074.584392,0.172642,369.5697853,249.2997302,588.6828438,16.5828121,20.5329991,2.6143056,61.6441231),(3153,'blackbluck_tibia.tif',237,8,169,123.9192677,56.3276664,52.8679933,1.8,56.4452858,53.168968,0.1253989,12.1137306,11.3509054,3066.5577432,4382.4228638,0.3230708,386.0857536,253.1472632,609.6729812,16.8884152,21.2988099,2.6590794,62.9917772),(3154,'blackbluck_tibia.tif',237,8,170,125.2209032,56.3086029,52.9054148,1.8,56.3765271,53.2223059,0.1531513,12.694391,11.2506006,3191.8788689,4769.5700717,0.4857008,423.9391504,251.4400948,619.0470875,17.1999543,22.0128296,2.6414316,64.7886493),(3155,'blackbluck_tibia.tif',237,8,171,128.2335772,56.2963897,52.946303,1.8,56.3403789,53.3000261,0.169835,11.5270087,11.4179134,3369.0592655,5307.7284399,0.6105558,464.8597564,292.2752438,750.2634155,17.6234302,22.7731835,2.7574233,66.6400207),(3156,'blackbluck_tibia.tif',237,8,172,132.5940554,56.3698717,52.9796389,1.8,56.3598613,53.3544292,0.1623506,12.355214,11.7878372,3593.0546216,6011.557396,0.5773795,509.9796767,290.8128199,767.3829596,17.9687214,23.6085341,2.7716866,68.4913922),(3157,'blackbluck_tibia.tif',237,8,173,144.5496928,56.6185656,53.0611801,1.8,56.5805626,53.3656522,0.1659213,12.100016,12.6546872,3974.5178344,6958.8579973,0.6571756,549.9035975,328.4721126,862.7776194,18.6352004,24.7376015,2.7796339,72.1170614),(3158,'blackbluck_tibia.tif',237,8,174,157.9226167,56.8037424,53.1550633,1.8,56.7333757,53.5044858,0.1651389,12.4425734,12.7370979,4439.0168115,8196.4803512,0.7112794,643.512394,356.7603487,978.113495,18.8671575,25.7831195,2.8225969,75.3386613),(3159,'blackbluck_tibia.tif',237,8,175,189.9251194,56.9018068,53.2660855,1.8,56.6829538,53.5663681,0.1583607,12.6641506,13.5912924,5154.5619164,10158.5946439,0.7872132,747.4340424,407.0199471,1114.6640562,19.993222,27.3884887,2.6082054,80.5525561),(3160,'blackbluck_tibia.tif',237,8,176,220.4935039,57.132918,53.3839787,1.8,56.742307,53.6554991,0.1683851,13.2764141,13.8902426,5910.7264733,12235.3927243,1.0321512,880.8624197,445.2050402,1267.8651166,0.224609,0.502241,2.0344439,1.0845083),(3161,'blackbluck_tibia.tif',237,8,177,245.6175777,56.5815882,53.3987307,1.8,56.5486877,53.5738942,0.1103395,12.9530144,14.4868643,6669.1526521,12963.356316,0.4963717,894.835216,514.8726352,1355.1897627,0.4268105,1.0044821,2.0344439,2.1690165),(3162,'blackbluck_tibia.tif',237,8,178,201.8385017,54.3738692,52.9518392,1.8,55.5659131,53.132867,0.1125239,13.1286506,16.4067732,6056.3154977,7533.2407147,0.4241395,459.154315,461.3052527,827.6046411,0.224609,1.3662433,1.735945,2.8813804),(3163,'blackbluck_tibia.tif',237,8,179,154.4189801,53.2809806,52.1163311,1.8,53.4380255,52.525362,-1.5613557,14.6138401,13.0095609,3707.8180494,4872.2866428,25.734203,374.5158416,253.7196255,535.1711935,0.224609,0.502241,2.0344439,1.0845083),(3164,'blackbluck_tibia.tif',237,8,180,112.676707,52.9432453,50.6894454,1.8,53.2236526,51.1627809,1.5099221,9.7357013,13.7927471,2602.0568367,3284.9249048,18.7099467,238.1632092,267.2695836,412.6185627,17.7934411,23.6725544,0.9880568,153.5641804),(3165,'blackbluck_tibia.tif',237,8,181,82.1278295,52.5671717,48.8823076,1.8,52.7043862,49.2324114,0.0056366,15.138667,9.8643149,1577.7594136,2134.741321,0.0004349,216.4105,104.2204981,244.3732352,10.474641,19.1906029,0.2847304,61.676048),(3166,'blackbluck_tibia.tif',237,8,182,58.6817881,52.5694781,47.7111051,1.8,52.7440362,47.7008103,-0.0611577,15.543837,9.9414857,222.3549818,1738.0971624,0.0365353,174.832737,14.3050253,125.2279077,4.4275156,10.3051244,1.2145767,25.5470556),(3167,'blackbluck_tibia.tif',237,8,183,47.3500087,52.3993762,47.5923901,1.8,52.5636457,47.5163624,-0.0739148,4.4599485,9.0254019,124.0422386,1309.5610099,0.0430369,145.097251,27.812482,157.6559114,4.0429623,9.2089697,1.3494819,22.0848842),(3168,'blackbluck_tibia.tif',237,8,184,36.9597186,52.2920811,47.5669033,1.8,52.3164293,47.5639199,-0.0650579,3.7326529,8.1763741,73.7379538,908.7440145,0.0260354,111.1426655,19.7548384,116.3121381,3.7898919,7.7547056,1.3961241,18.6997865),(3169,'blackbluck_tibia.tif',237,8,185,23.0671678,53.0316849,47.5909561,1.8,52.8010661,47.5284646,-0.0505504,2.9097138,8.2256851,28.2003665,501.8628009,0.0098157,61.0116723,9.6918007,62.4666082,2.9199172,5.9933161,1.3439975,14.3617534),(3170,'blackbluck_tibia.tif',237,8,186,4.5903125,55.5571788,47.6807027,1.8,54.6779661,47.7430794,-0.0997587,2.2621154,9.6152908,2.178928,41.2902412,0.0075884,4.294227,0.9632259,4.5133577,1.5255602,3.6563699,1.3854484,9.0482106),(3171,'blackbluck_tibia.tif',237,8,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3172,'blackbluck_tibia.tif',237,8,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3173,'blackbluck_tibia.tif',237,8,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3174,'blackbluck_tibia.tif',237,8,190,2.2140477,71.4090513,48.6142867,1.8,71.4114285,48.6188955,-1.206469,2.7781538,2.9004166,3.7063345,4.1067217,0.322157,1.4159075,1.3340998,2.6343244,5.6715306,6.0268924,1.1071487,19.1264302),(3175,'blackbluck_tibia.tif',237,8,191,23.71729,71.4174,48.7195039,1.8,71.4093424,48.7238316,-1.1171309,6.2499772,6.3119786,190.1438016,194.0511582,3.1936337,30.7433168,30.4231191,60.5298494,12.578105,12.8714882,1.060308,41.5515338),(3176,'blackbluck_tibia.tif',237,8,192,47.6440817,71.3337598,48.7621002,1.8,71.2575993,48.7765466,-1.3861561,8.1920591,8.3580566,698.1179029,740.6764949,7.6730291,88.6182677,85.2188563,170.776372,16.3964583,17.0184876,1.1780357,54.7742796),(3177,'blackbluck_tibia.tif',237,8,193,69.6632054,70.8949468,48.7195911,1.8,70.7722195,48.6803011,-1.5390984,9.1862961,9.923926,1296.6345036,1616.3406242,11.5988723,162.873104,141.1487811,283.4228999,19.7655935,20.1898396,1.0074801,65.4332902),(3178,'blackbluck_tibia.tif',237,8,194,146.1124717,62.1755854,48.9717222,1.8,58.4206263,48.9013276,-0.0411459,14.7415144,23.3852349,5126.4490139,18381.1242811,0.0412046,786.0140975,347.755928,893.2873543,17.5195034,28.1846283,1.4830224,101.7125567),(3179,'blackbluck_tibia.tif',237,8,195,531.0376564,48.2211165,48.8302127,1.8,52.5758695,48.8817022,-0.0087171,16.9664875,30.4739026,25997.8308788,84852.2011289,0.0067249,2784.4218793,1532.3048356,3480.458073,28.9745633,29.3336281,0.6986598,95.7675968),(3180,'blackbluck_tibia.tif',237,8,196,572.0600194,48.1059524,48.7749905,1.8,53.0794208,48.8245269,-0.0026836,17.2418095,30.534914,28228.7758284,94934.5543864,0.0006873,3109.0493471,1637.2281455,3822.513807,28.9745633,29.2664774,2.3019001,95.7675968),(3181,'blackbluck_tibia.tif',237,8,197,584.2146407,48.474001,48.7806571,1.8,53.4862684,48.8353054,-0.0026743,16.7950156,30.1685884,29304.7760041,99012.465109,0.0006964,3281.9720947,1744.8495818,3997.4599656,0.449218,1.3662433,1.735945,3.0674526),(3182,'blackbluck_tibia.tif',237,8,198,593.9508797,48.7568403,48.7835706,1.8,53.7663508,48.8385469,-0.0033287,16.78417,29.8951734,30258.9998602,102120.6149644,0.0010974,3415.9565971,1802.8296862,4127.1404416,28.9745633,29.3138433,0.5391054,95.953669),(3183,'blackbluck_tibia.tif',237,8,199,600.962892,48.9633898,48.7803377,1.8,54.001077,48.8115232,-0.0035076,16.3412128,29.6914799,30950.6779797,104169.6785192,0.0012321,3508.4030456,1894.025759,4227.0983439,0.224609,0.7102761,1.8925469,1.5337263),(3184,'blackbluck_tibia.tif',237,8,200,604.5504577,49.1173241,48.7880331,1.8,54.1947056,48.8361789,-0.00393,16.6958957,29.5443415,31349.3412355,105252.7392676,0.0015563,3562.5346111,1877.6675268,4269.2358294,0.224609,0.3176451,2.3561945,0.6352902),(3185,'blackbuk_metatarsus.tif',237,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3186,'blackbuk_metatarsus.tif',237,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3187,'blackbuk_metatarsus.tif',237,10,3,0.0612229,51.7805049,44.2971172,1.8,51.7725032,44.2950028,-0.5353584,0.313002,0.677303,0.0019715,0.0087807,0.0026556,0.0129642,0.0062985,0.0158325,0.839477,1.6129361,0.6202495,3.6668157),(3188,'blackbuk_metatarsus.tif',237,10,4,3.4793647,52.2729439,44.3293875,1.8,52.3902958,44.2972102,-0.4286429,1.4011406,2.6756164,0.9929898,4.0888151,0.100179,1.5281769,0.708701,1.8978509,2.8089727,5.0485923,0.3805064,12.564787),(3189,'blackbuk_metatarsus.tif',237,10,5,9.9818253,52.6717572,44.2553128,1.8,52.4771092,44.1123482,-0.2324172,2.7859503,3.7092894,8.0642803,24.1109153,0.0882595,6.5001441,2.8946246,8.156624,4.6115891,7.3125005,0.3947911,19.6066029),(3190,'blackbuk_metatarsus.tif',237,10,6,29.8823666,50.3249709,42.9232471,1.8,49.5508885,42.0884925,0.1402402,7.7140845,11.3318533,163.4193644,342.3099824,0.0973105,30.2077669,21.1845441,38.651428,8.4406514,12.5778832,0.1798535,35.0882056),(3191,'blackbuk_metatarsus.tif',237,10,7,79.7329384,48.7370897,40.0324762,1.8,49.2448572,39.54928,0.0643113,14.5692011,11.0527759,1158.1897165,2059.3666615,0.0548862,186.321217,79.4957603,216.2484429,1.5428212,3.2745469,1.9832068,7.9737965),(3192,'blackbuk_metatarsus.tif',237,10,8,149.4876093,49.79306,37.2211917,1.8,49.8814464,36.3787545,-0.4458806,12.0020487,11.0294225,3875.4394817,5050.2038492,4.6335871,457.8847051,322.8981633,702.7185481,21.1206757,24.0599851,1.3428293,83.6653731),(3193,'blackbuk_metatarsus.tif',237,10,9,197.0613127,49.7602691,34.9721454,1.8,49.7554311,35.7619784,-0.746445,14.0049744,14.7531488,6134.2457543,6438.9745761,15.14371,436.4474768,438.0047806,841.961069,0.375,1.0097185,1.9513027,2.1856603),(3194,'blackbuk_metatarsus.tif',237,10,10,183.0840284,49.6823823,34.8179499,1.8,49.7846872,35.6438896,0.8499944,14.1174552,14.6130897,5829.6815605,6059.0417474,17.2226133,414.631121,412.9413884,808.0074129,21.177555,23.8655919,1.3811048,75.4719067),(3195,'blackbuk_metatarsus.tif',237,10,11,168.880716,49.8344531,34.8482515,1.8,49.9384557,35.5215972,0.911652,12.0286614,13.5659877,5042.5260025,5768.0939871,17.5893907,425.1879109,419.2092407,793.7483699,20.4382154,23.8154541,2.0450069,75.5362465),(3196,'blackbuk_metatarsus.tif',237,10,12,160.2517467,49.8605371,35.045261,1.8,49.9667086,35.69542,1.0448873,12.3603481,13.454537,4476.6920963,5311.8404133,19.9779609,394.799198,362.1817176,720.5466685,19.3024006,23.4936841,2.070143,72.5017902),(3197,'blackbuk_metatarsus.tif',237,10,13,149.7812818,49.8293229,35.4358578,1.8,49.9220581,36.0361032,1.2361571,10.6139114,12.2435949,3936.5790335,4862.7474933,22.2708486,397.1666441,370.8886264,687.3625329,0.1875,0.5929271,1.8925469,1.2803302),(3198,'blackbuk_metatarsus.tif',237,10,14,142.407079,49.752553,35.8709684,1.8,49.8055595,36.477548,1.3540368,10.218553,14.6684571,3422.8610356,4461.805009,22.6367103,304.176845,334.9653357,470.5940284,0.375,0.9560662,1.7681919,2.1856603),(3199,'blackbuk_metatarsus.tif',237,10,15,135.8237307,49.6794046,36.1479782,1.8,49.7389687,36.6140192,1.3930974,9.6351125,13.9906198,3042.0186002,4170.3722937,21.9299653,298.0834563,315.7221669,456.266603,0.375,1.0097185,1.9513027,2.1856603),(3200,'blackbuk_metatarsus.tif',237,10,16,132.6382926,49.5858404,36.3570384,1.8,49.6732002,36.8624652,1.420466,9.6367199,14.9425936,2760.4213439,3970.2320117,21.6105477,265.6989895,286.4482276,423.7615995,0.1875,0.2651651,2.3561945,0.5303301),(3201,'blackbuk_metatarsus.tif',237,10,17,126.6835347,49.599865,36.4837379,1.8,49.6768469,36.9521651,1.444767,9.4955284,13.987926,2504.3525973,3738.1563152,20.7803336,267.2416424,263.7402052,419.415199,0.703679,5.4889808,1.7078625,12.2729715),(3202,'blackbuk_metatarsus.tif',237,10,18,123.2556484,49.5741853,36.6832813,1.8,49.6502582,37.1108,1.4496085,8.9512606,14.1896596,2325.8988087,3546.343884,20.2423834,249.9245209,259.840363,390.1970854,0.375,1.1858542,1.8925469,2.7159904),(3203,'blackbuk_metatarsus.tif',237,10,19,119.9590043,49.5438074,36.8050482,1.8,49.6371917,37.2190967,1.4543022,9.2624667,13.1308037,2185.817976,3400.4856285,19.7230674,258.9701054,235.9865947,411.3266287,0.7006613,7.3221095,1.6220335,15.7123116),(3204,'blackbuk_metatarsus.tif',237,10,20,119.326006,49.4990556,36.9875322,1.8,49.598681,37.3867043,1.452236,8.824029,10.9265152,2079.2904615,3282.8903412,19.6094229,300.4517245,235.6395784,461.8089547,0.5625,1.3258253,1.7126934,3.0909905),(3205,'blackbuk_metatarsus.tif',237,10,21,116.6501136,49.4871391,37.1234459,1.8,49.5717098,37.4836291,1.4460174,8.8505378,11.4683988,1992.5222333,3191.9491083,19.1405507,278.3256119,225.130074,448.3432609,0.6579771,3.8242649,1.3734008,8.8979713),(3206,'blackbuk_metatarsus.tif',237,10,22,116.3335119,49.4769553,37.2831652,1.8,49.5652543,37.6397553,1.4393784,9.0151091,12.8089063,1927.940516,3121.2006508,19.0559826,243.6742519,213.8565938,389.2454221,0.5742092,4.3490303,1.7004989,9.5569811),(3207,'blackbuk_metatarsus.tif',237,10,23,115.6603629,49.47336,37.428832,1.8,49.5895095,37.6961527,1.4325483,9.1939403,11.68028,1876.4060884,3065.4527353,18.9106417,262.4468536,204.0916116,385.7316098,0.5457914,1.5116734,1.6951513,3.4659905),(3208,'blackbuk_metatarsus.tif',237,10,24,115.3654003,49.4747512,37.601605,1.8,49.585832,37.8792804,1.428697,8.0474462,11.3845425,1827.3215014,3020.5440684,18.8419255,265.3197583,227.0684954,425.4713219,0.375,2.4447011,1.6475682,5.3409906),(3209,'blackbuk_metatarsus.tif',237,10,25,114.789256,49.5425633,37.7420854,1.8,49.6280063,38.0264636,1.4231752,8.3592315,12.2904723,1777.8434316,2956.8579305,18.717648,240.5813102,212.6802482,383.6651798,0.375,4.1420106,1.6614562,9.026651),(3210,'blackbuk_metatarsus.tif',237,10,26,114.2980849,49.5495155,37.8845291,1.8,49.6787181,38.1365518,1.4171647,8.1496098,10.8733858,1743.5535906,2912.1034139,18.6035838,267.8193769,213.9431992,427.05792,0.8612651,7.5839061,1.4219064,16.8639621),(3211,'blackbuk_metatarsus.tif',237,10,27,114.3502476,49.5553611,38.0155288,1.8,49.6944439,38.2507227,1.4136975,8.4860961,12.201671,1723.1278045,2882.1628143,18.5918699,236.2105009,203.0530634,370.5151182,0.9604925,8.3537516,1.4130276,18.2086321),(3212,'blackbuk_metatarsus.tif',237,10,28,114.7565823,49.5563611,38.1390071,1.8,49.681475,38.4053416,1.4109306,8.1285682,11.8876198,1710.4032296,2855.1234285,18.6414402,240.1762073,210.4187575,368.1353178,0.375,4.8786047,1.6092389,10.8373113),(3213,'blackbuk_metatarsus.tif',237,10,29,115.5028488,49.5487341,38.2476861,1.8,49.6671859,38.5032995,1.4110712,8.2829295,12.1276311,1710.2578286,2831.2835751,18.7635168,233.4572646,206.4798242,368.5975236,0.5625,2.6316881,1.6421038,5.8713207),(3214,'blackbuk_metatarsus.tif',237,10,30,116.0745949,49.5469923,38.3492366,1.8,49.6663976,38.6037627,1.4065919,8.4132395,13.4547982,1709.5581974,2813.900909,18.8288158,209.1373544,203.198566,329.7924745,0.5625,6.3777572,1.6001996,14.3033018),(3215,'blackbuk_metatarsus.tif',237,10,31,116.6575026,49.5466246,38.45414,1.8,49.6663891,38.6841013,1.4043015,8.4914096,11.5628727,1710.8748597,2787.5478665,18.9089109,241.0774496,201.4830221,376.2708611,0.375,3.1930101,1.6295521,6.6856606),(3216,'blackbuk_metatarsus.tif',237,10,32,116.9168105,49.5474329,38.5569955,1.8,49.6472392,38.7744565,1.4020021,7.9555728,11.6573279,1711.1176114,2758.1681737,18.936199,236.6038072,215.0841503,377.0310538,0.5625,2.2577991,1.6539376,5.1213207),(3217,'blackbuk_metatarsus.tif',237,10,33,116.7273166,49.6187231,38.6293322,1.8,49.7049326,38.9335442,1.3948102,8.2115169,11.7733906,1705.036158,2726.354023,18.8582179,231.5691483,207.6396093,371.2009666,0.5625,6.5651784,1.59936,13.5909911),(3218,'blackbuk_metatarsus.tif',237,10,34,116.6539449,49.6290276,38.7392413,1.8,49.7253975,39.0638609,1.388256,8.4548972,11.491747,1698.6623288,2711.4161175,18.8016505,235.94464,200.9086921,364.8245555,1.1721254,9.9657623,1.4954674,21.5836323),(3219,'blackbuk_metatarsus.tif',237,10,35,116.2681937,49.645221,38.82644,1.8,49.7614226,39.1541991,1.3833981,8.3853681,11.4123573,1697.1164479,2690.8894322,18.7054415,235.7873447,202.3902136,379.3472469,0.8850001,9.0078097,1.5291537,19.7086322),(3220,'blackbuk_metatarsus.tif',237,10,36,117.1082689,49.6461605,38.9402635,1.8,49.7270247,39.3120474,1.3834398,8.5554747,11.1160531,1700.1338988,2679.8542856,18.8408926,241.0796576,198.7188276,347.0103093,0.6764656,5.8396547,1.4743226,12.2463211),(3221,'blackbuk_metatarsus.tif',237,10,37,116.7891455,49.6592901,39.0223729,1.8,49.7601606,39.2969753,1.3742663,8.6358033,11.2342013,1703.6282908,2658.0551762,18.7226754,236.6038403,197.2750215,347.4675563,1.0620772,9.2352083,1.4691075,20.0836322),(3222,'blackbuk_metatarsus.tif',237,10,38,117.2121543,49.6620908,39.1242576,1.8,49.764106,39.4354432,1.3709023,8.6240832,11.1398038,1706.9219428,2644.1542908,18.7651143,237.3609392,197.9250326,370.852371,0.9666279,7.8950642,1.4994889,17.8336321),(3223,'blackbuk_metatarsus.tif',237,10,39,117.52902,49.6632023,39.2112069,1.8,49.7615438,39.5422021,1.3682765,8.2231064,10.8753924,1709.6864517,2627.1714685,18.7956992,241.5702696,207.9124804,378.9369518,0.5359828,5.6281245,1.6041173,11.8713211),(3224,'blackbuk_metatarsus.tif',237,10,40,117.7136856,49.6668404,39.2961582,1.8,49.7712218,39.6139171,1.368071,8.3700584,11.0306007,1715.1663768,2605.9716188,18.8236423,236.2492922,204.9168954,379.2483941,0.6500461,4.3490303,1.7004989,10.1783015),(3225,'blackbuk_metatarsus.tif',237,10,41,116.7318614,49.7402749,39.3454151,1.8,49.8120785,39.6843289,1.36085,8.4392382,10.8704489,1705.2984564,2570.6466948,18.6102955,236.480271,202.0678185,370.2552575,0.5625,0.9375001,0.9272952,2.3864855),(3226,'blackbuk_metatarsus.tif',237,10,42,116.0489778,49.7501474,39.4388872,1.8,49.8261133,39.7879238,1.355418,8.6930687,10.7941904,1698.905235,2540.0971549,18.4580737,235.3207652,195.4321652,351.9032982,0.375,0.6760409,0.5880026,1.3258253),(3227,'blackbuk_metatarsus.tif',237,10,43,115.7533701,49.7662935,39.5417371,1.8,49.8519139,39.9668284,1.3508123,8.7054181,11.9855155,1695.1522261,2521.3207175,18.3735829,210.3639771,194.7238158,342.5033442,0.375,0.5929271,1.8925469,1.5909904),(3228,'blackbuk_metatarsus.tif',237,10,44,115.7573774,49.7723308,39.624331,1.8,49.8244021,40.0482193,1.3457077,8.4874147,10.6692105,1696.2762457,2505.7744857,18.3318206,234.8603481,199.8578262,363.1027697,0.5625,0.8385255,1.1071487,2.3864855),(3229,'blackbuk_metatarsus.tif',237,10,45,115.9469885,49.7850136,39.6963082,1.8,49.8534845,40.1057967,1.3410533,8.6837147,11.4924575,1701.3954335,2498.4005853,18.3223352,217.3948079,195.9294488,350.0205081,1.396313,6.6291265,1.4288993,16.0041271),(3230,'blackbuk_metatarsus.tif',237,10,46,115.8822568,49.7944779,39.7684439,1.8,49.8708289,40.1888034,1.328928,8.6482182,10.7298552,1696.1876265,2483.4955306,18.205713,231.4565743,196.1314562,376.6890799,0.6601083,5.2800483,1.4640607,11.8979715),(3231,'blackbuk_metatarsus.tif',237,10,47,116.0746926,49.8035118,39.8461579,1.8,49.9059183,40.2811107,1.318157,8.6447373,10.6775562,1693.7852552,2478.768562,18.137054,232.1475541,195.9325308,378.5184044,0.5625,2.4661776,1.7234457,5.4963207),(3232,'blackbuk_metatarsus.tif',237,10,48,115.9421212,49.8073719,39.9074242,1.8,49.8958441,40.326362,1.3087648,8.4540366,10.8237395,1685.7950329,2462.6960685,18.0270018,227.5272862,199.4071142,371.8432321,0.6710193,5.450416,1.5019398,11.8069813),(3233,'blackbuk_metatarsus.tif',237,10,49,114.9640306,49.8817855,39.9259528,1.8,50.0064864,40.3587429,1.296111,8.3194768,11.0770124,1668.8600372,2438.2394526,17.7509568,220.1170643,200.5967536,350.7224423,0.5625,6.1988536,1.5102643,13.6176415),(3234,'blackbuk_metatarsus.tif',237,10,50,114.0900893,49.8881081,39.9906417,1.8,50.0078785,40.4805256,1.2921768,8.9871924,10.9434776,1652.6462741,2423.1340634,17.5767042,221.4226727,183.8890508,364.365756,0.75,5.8245846,1.5063695,13.0229716),(3235,'blackbuk_metatarsus.tif',237,10,51,113.3491006,49.8884041,40.0414821,1.8,49.9607715,40.4891654,1.2846616,8.3954839,12.6257572,1641.6312292,2403.4291838,17.3865635,190.3592118,195.5374153,319.7925301,1.0157097,7.6966414,1.6195382,17.8336321),(3236,'blackbuk_metatarsus.tif',237,10,52,112.9655779,49.900202,40.0925763,1.8,49.9869881,40.5319137,1.2790762,8.6898532,10.8717785,1634.1887564,2389.0695389,17.2702934,219.7496521,188.0571193,362.7732076,0.6971939,6.0263099,1.4773195,13.2426415),(3237,'blackbuk_metatarsus.tif',237,10,53,112.6769291,49.9109739,40.1512299,1.8,49.9844017,40.5783866,1.2695959,9.2036139,11.1353416,1631.6845085,2379.5280666,17.1266828,213.6915192,177.2873698,355.5860368,0.75,4.1420106,1.4801364,9.1819811),(3238,'blackbuk_metatarsus.tif',237,10,54,113.2924225,49.9242568,40.2079822,1.8,50.0109558,40.6178057,1.2617784,8.9360733,11.0910022,1628.871487,2373.7617156,17.1356501,214.0258984,182.2804519,356.6185345,0.5425264,5.8396547,1.4743226,12.2463211),(3239,'blackbuk_metatarsus.tif',237,10,55,113.0889131,49.9328717,40.2562689,1.8,49.9934512,40.6560189,1.2603603,9.0094769,12.2440179,1623.8675184,2356.8662143,17.0893507,192.4912418,180.2399345,324.8006257,0.638301,5.8396547,1.4743226,12.7123114),(3240,'blackbuk_metatarsus.tif',237,10,56,112.631354,49.9389994,40.306957,1.8,50.0056566,40.6947167,1.2612368,8.273154,11.0220846,1613.3194158,2328.1827574,17.0297666,211.2288965,195.006574,350.050048,13.5892866,18.2058553,2.1359458,53.0882068),(3241,'blackbuk_metatarsus.tif',237,10,57,111.3693354,49.9832122,40.3214831,1.8,50.0299258,40.739338,1.2571528,8.5165635,11.2667451,1593.5600939,2289.2003934,16.7947075,203.1820526,187.1130409,339.5817356,0.75,6.9476282,1.5167948,15.4283018),(3242,'blackbuk_metatarsus.tif',237,10,58,110.4047033,49.9954773,40.366279,1.8,50.073139,40.7688498,1.2608158,8.4629064,11.1266553,1576.0733106,2257.8953634,16.6886014,202.9266937,186.2331029,343.8213408,0.8977595,7.9106342,1.4758446,17.458632),(3243,'blackbuk_metatarsus.tif',237,10,59,109.7341541,50.0059034,40.4205821,1.8,50.0672543,40.8473905,1.2610614,8.5586833,11.3363221,1565.5618113,2227.28906,16.5898506,196.473693,182.920871,329.7629881,1.3125001,5.8245846,1.6352232,15.4549523),(3244,'blackbuk_metatarsus.tif',237,10,60,109.2722848,50.0202391,40.4704039,1.8,50.1028819,40.9114715,1.2572836,8.5685178,10.8772233,1552.3218412,2210.3800309,16.4798666,203.2117921,181.1657378,341.0797858,0.1875,0.2651651,2.3561945,0.5303301),(3245,'blackbuk_metatarsus.tif',237,10,61,108.9834699,50.0307811,40.5113346,1.8,50.1112126,40.9359767,1.2566761,8.6376501,10.8361538,1543.7982677,2188.8160825,16.4298294,201.9919735,178.7289656,328.1728677,0.375,0.5303301,0.7853982,1.0606602),(3246,'blackbuk_metatarsus.tif',237,10,62,108.6541622,50.0475217,40.5590279,1.8,50.1129758,40.989426,1.2508113,8.5651654,10.7961965,1534.7781838,2171.6328099,16.3172618,201.1479514,179.1883884,337.7869127,0.8086463,6.9602671,1.4898922,15.4283018),(3247,'blackbuk_metatarsus.tif',237,10,63,108.5765683,50.0630114,40.5959961,1.8,50.1351399,41.0225116,1.2512218,8.6290329,10.5774989,1528.299189,2161.7166832,16.3100427,204.3693598,177.1112943,325.5687158,13.5000008,17.9471893,2.1327179,52.4935368),(3248,'blackbuk_metatarsus.tif',237,10,64,108.270571,50.0707205,40.6207276,1.8,50.1276128,41.0163907,1.2493037,8.5683171,10.5550924,1516.6885254,2141.8759108,16.2433769,202.9234641,177.0112497,339.5616157,0.5625,3.236752,1.3961241,7.306981),(3249,'blackbuk_metatarsus.tif',237,10,65,107.2086606,50.1190287,40.5974325,1.8,50.1952042,40.9616398,1.2404299,8.4055623,10.8710178,1495.5366704,2106.8268384,15.9878729,193.8021694,177.9222628,320.1581384,1.2785363,5.0763702,1.4968573,12.6934667),(3250,'blackbuk_metatarsus.tif',237,10,66,106.3954242,50.1179382,40.6346534,1.8,50.1748747,41.0463781,1.2390501,8.3038604,11.3639591,1476.3653428,2081.3585949,15.8515541,183.1543553,177.792649,312.6526455,1.1250001,9.1894136,1.5912017,19.772972),(3251,'blackbuk_metatarsus.tif',237,10,67,105.7235263,50.1238998,40.652841,1.8,50.2080063,41.0806547,1.2285031,8.565605,10.365772,1458.7402155,2056.9319733,15.6354576,198.4350012,170.3020645,323.9332706,0.8390152,7.5210646,1.6456562,16.2426417),(3252,'blackbuk_metatarsus.tif',237,10,68,105.6011196,50.1219871,40.6694926,1.8,50.1857257,41.1004421,1.2180263,8.4572881,10.7190707,1450.9355918,2043.7687797,15.4992657,190.6666015,171.5603839,323.3393932,0.375,1.1858542,1.8925469,2.5606603),(3253,'blackbuk_metatarsus.tif',237,10,69,105.3063329,50.1218367,40.6869281,1.8,50.1699886,41.1379386,1.2046548,9.87515,10.7204039,1441.8683278,2028.7468457,15.3014484,189.2416427,146.0097648,283.1780808,0.8979134,7.1471699,1.6495803,16.0229718),(3254,'blackbuk_metatarsus.tif',237,10,70,105.2457551,50.1277854,40.7085333,1.8,50.180379,41.1120309,1.1911282,8.1665985,10.9928355,1435.7749479,2021.200523,15.131648,183.8652575,175.8106447,313.6622178,0.5625,5.0763702,1.4968573,10.9016511),(3255,'blackbuk_metatarsus.tif',237,10,71,105.313282,50.1418087,40.7248797,1.8,50.2124736,41.1569162,1.1810538,8.3256702,10.3572937,1429.2505529,2012.8754209,15.0183373,194.3437622,171.6679283,330.3679165,0.375,3.7546848,1.6207547,8.1213209),(3256,'blackbuk_metatarsus.tif',237,10,72,105.0950337,50.1464902,40.7336572,1.8,50.2151133,41.1153047,1.171936,9.3294116,11.148377,1418.9743026,1995.9518253,14.8739254,179.0351934,152.0968697,306.0075998,0.375,4.1292594,1.6162196,8.8713209),(3257,'blackbuk_metatarsus.tif',237,10,73,103.8776128,50.1977094,40.7074266,1.8,50.2482612,41.1162805,1.1655742,8.3390446,10.5399064,1398.1995373,1959.7615842,14.6223029,185.9372847,167.669033,317.5873139,0.75,5.0763702,1.4968573,11.6328065),(3258,'blackbuk_metatarsus.tif',237,10,74,103.1087787,50.2065039,40.7238359,1.8,50.2740673,41.1324298,1.1710382,8.3567142,10.8085164,1381.1319681,1933.2418794,14.5817604,178.8628352,165.2721312,303.3917438,0.7252022,6.573206,1.6278771,14.2123115),(3259,'blackbuk_metatarsus.tif',237,10,75,102.4893757,50.2137514,40.7291798,1.8,50.2768368,41.1247417,1.1764603,8.199603,10.1867049,1366.3908483,1907.8467677,14.5602221,187.28792,166.641099,316.4792999,0.6764656,6.0263099,1.6642731,12.9319813),(3260,'blackbuk_metatarsus.tif',237,10,76,102.1213737,50.2186647,40.7384409,1.8,50.2742962,41.1441813,1.1721145,8.2250754,10.5246872,1352.8065742,1883.0567548,14.4552414,178.9180738,164.4734548,296.7232879,0.5625,4.8786047,1.6092389,10.5266511),(3261,'blackbuk_metatarsus.tif',237,10,77,101.7550234,50.2224333,40.7496789,1.8,50.2620657,41.1066559,1.1666497,8.9560768,11.0097382,1340.4637247,1855.1410328,14.3367196,168.5000136,149.6708614,284.4676676,13.2873243,17.2194033,2.1859826,50.3533716),(3262,'blackbuk_metatarsus.tif',237,10,78,101.2799693,50.2275878,40.7825393,1.8,50.2824735,41.1538949,1.1586916,8.2290215,10.0572431,1324.5731938,1825.7784357,14.1719153,181.5386599,160.9636333,311.392434,0.375,3.0233468,1.4464413,6.4659907),(3263,'blackbuk_metatarsus.tif',237,10,79,101.0978448,50.2315376,40.8089324,1.8,50.2693595,41.1421823,1.1535286,8.2359255,9.3966107,1310.5960995,1798.8526901,14.0822722,191.4363329,159.1316123,307.1411477,0.375,1.7286647,1.7894653,3.6856604),(3264,'blackbuk_metatarsus.tif',237,10,80,100.8418502,50.2354087,40.8286306,1.8,50.2759622,41.1420841,1.1475516,7.8805569,9.6310371,1294.2812707,1771.6033511,13.971777,183.9473083,164.2372847,303.7403666,0.5625,3.7546848,1.6207547,8.2766509),(3265,'blackbuk_metatarsus.tif',237,10,81,99.7842207,50.2784406,40.7974272,1.8,50.3372572,41.1389234,1.1411157,8.5663284,10.4418532,1272.8320094,1739.0019012,13.744623,166.5415002,148.5854785,288.0446085,0.5611298,3.3957696,1.6814535,7.5266509),(3266,'blackbuk_metatarsus.tif',237,10,82,98.9252821,50.282051,40.8313309,1.8,50.3500897,41.1750262,1.1333622,7.9753144,10.0493614,1249.3883115,1711.0618817,13.5288403,170.2657325,156.6569346,287.0589988,0.375,2.8187432,1.6373645,6.0909906),(3267,'blackbuk_metatarsus.tif',237,10,83,98.235596,50.2869789,40.8602915,1.8,50.3324937,41.2147624,1.1222148,8.5740014,9.6581182,1231.7346976,1679.2232316,13.2931571,173.8665016,143.6592607,292.5299473,0.5224772,4.3287739,1.484058,9.401651),(3268,'blackbuk_metatarsus.tif',237,10,84,97.7494584,50.3013495,40.8818045,1.8,50.3751225,41.2198466,1.1116807,8.5905674,9.5348013,1217.0572416,1659.957825,13.0921261,174.0946432,141.6736739,284.4078136,0.375,2.2577991,1.6539376,4.9659906),(3269,'blackbuk_metatarsus.tif',237,10,85,97.3441596,50.3016326,40.9035006,1.8,50.3457771,41.2034109,1.0996716,7.9262751,9.7484809,1202.6681619,1636.8251347,12.881634,167.9056612,151.7318214,286.0747321,13.1250008,16.4850795,2.1619535,48.2132064),(3270,'blackbuk_metatarsus.tif',237,10,86,96.9955879,50.3058515,40.9190189,1.8,50.3548726,41.2005466,1.094916,8.6717995,10.1788953,1194.2801822,1614.4834164,12.7731066,158.6108679,137.7199956,241.6249817,0.5555357,1.3650207,1.849096,3.0909905),(3271,'blackbuk_metatarsus.tif',237,10,87,96.6767284,50.3102264,40.9345094,1.8,50.3568027,41.2008284,1.0805656,7.856306,10.0104586,1182.2541854,1592.8913047,12.5408991,159.1227103,150.4847423,265.7311722,0.375,2.4661776,1.418147,5.3409906),(3272,'blackbuk_metatarsus.tif',237,10,88,96.5198105,50.3184662,40.9544272,1.8,50.3732931,41.2000054,1.0693328,7.7910073,9.2473428,1175.7836609,1573.4865069,12.3693114,170.1555284,150.9154867,294.4148203,0.5614509,3.2094832,1.6879051,6.9963208),(3273,'blackbuk_metatarsus.tif',237,10,89,95.4848463,50.3695775,40.9282269,1.8,50.4149781,41.1719158,1.0573486,8.0427438,10.9074474,1157.9224703,1547.1850054,12.0746787,141.8466623,143.9710742,244.3573977,0.5625,0.8385255,1.1071487,1.9659904),(3274,'blackbuk_metatarsus.tif',237,10,90,94.6226238,50.3774836,40.9530625,1.8,50.3926989,41.1956602,1.0475523,8.679115,9.7756844,1144.3357677,1521.8414763,11.8326715,155.6762075,131.849361,232.5977838,0.1875,1.140518,1.735945,2.4053302),(3275,'blackbuk_metatarsus.tif',237,10,91,93.8205686,50.3909201,40.9735294,1.8,50.4269185,41.2278252,1.0394115,7.7811276,9.312815,1134.7324949,1495.425037,11.6216641,160.5771231,145.8313704,277.713098,0.1875,1.140518,1.735945,2.4053302),(3276,'blackbuk_metatarsus.tif',237,10,92,93.2346896,50.4029014,40.9973993,1.8,50.4715252,41.262845,1.016452,7.7939033,11.0587404,1122.9531081,1473.7287681,11.2335034,133.2637094,144.080965,233.068548,0.375,2.83739,1.4382448,5.9356605),(3277,'blackbuk_metatarsus.tif',237,10,93,92.678435,50.4065665,41.0172038,1.8,50.4542923,41.2340251,0.9917973,7.73066,9.2295006,1109.5174813,1450.0886201,10.8215524,157.1145276,143.5217021,251.0479182,0.1875,0.7730824,1.815775,1.6553302),(3278,'blackbuk_metatarsus.tif',237,10,94,92.0482516,50.4127612,41.0521045,1.8,50.4673693,41.2918673,0.9588001,7.5793157,11.2213931,1094.1558586,1428.2033174,10.277906,127.2750452,144.3607706,224.4280466,0.1875,0.7730824,1.815775,1.6553302),(3279,'blackbuk_metatarsus.tif',237,10,95,91.6234737,50.4236986,41.0790204,1.8,50.4653497,41.3201935,0.940291,7.7900944,8.9921153,1082.221747,1409.6435555,9.9629419,156.7644001,138.922803,266.2126731,0.375,0.8385255,1.1071487,1.8106603),(3280,'blackbuk_metatarsus.tif',237,10,96,91.2062314,50.4387898,41.091946,1.8,50.4881983,41.2585866,0.9054902,7.9213753,9.1399804,1073.181572,1388.5655549,9.408541,151.9221583,135.4791985,256.8603955,13.2500279,15.4673304,2.1049789,46.1185364),(3281,'blackbuk_metatarsus.tif',237,10,97,90.0867046,50.5010083,41.0463171,1.8,50.5485537,41.2406342,0.8791322,9.315085,9.6294118,1059.5917749,1359.9910244,8.9063621,141.2330325,113.7500915,243.1048765,0.375,0.6760409,0.9827937,1.4356603),(3282,'blackbuk_metatarsus.tif',237,10,98,89.1394307,50.5221482,41.0677279,1.8,50.5716657,41.2710277,0.8506729,9.7664933,9.2332775,1043.6253591,1332.6244447,8.3952925,144.3284303,106.8577352,225.9858147,0.1875,1.5116734,1.6951513,3.1553303),(3283,'blackbuk_metatarsus.tif',237,10,99,88.3954219,50.5444875,41.0835802,1.8,50.5968227,41.3204316,0.8134471,9.5310818,9.1264299,1029.5809663,1307.2038413,7.779302,143.2327706,108.0235155,233.2344002,0.375,0.8385255,1.1071487,1.8106603),(3284,'blackbuk_metatarsus.tif',237,10,100,87.8826704,50.5634619,41.1028758,1.8,50.6066182,41.292991,0.7811135,8.5611236,9.1514578,1015.4707902,1284.7905694,7.2607986,140.3919026,118.6141957,240.2804769,0.1875,0.7730824,1.815775,1.6553302),(3285,'blackbuk_metatarsus.tif',237,10,101,87.5688053,50.5848563,41.1228057,1.8,50.5985626,41.2892075,0.7535414,8.6560644,8.4521018,1006.5036399,1264.418441,6.8327714,149.5981085,116.2772812,243.6424941,0.5347785,1.1858542,1.2490458,2.8713205),(3286,'blackbuk_metatarsus.tif',237,10,102,87.2151609,50.6147559,41.1406708,1.8,50.6492489,41.3065759,0.7328972,8.0877631,8.4010799,996.7217628,1244.2418021,6.5061846,148.1049835,123.2382487,240.8606168,0.375,0.9560662,1.7681919,2.1856603),(3287,'blackbuk_metatarsus.tif',237,10,103,86.9596452,50.6455568,41.1628447,1.8,50.6839746,41.2995592,0.7150333,8.7859283,8.3456905,987.7181967,1225.3809664,6.2301833,146.8279905,112.4204706,239.3300915,12.9609559,14.817247,2.2396085,44.637381),(3288,'blackbuk_metatarsus.tif',237,10,104,86.6002539,50.6729481,41.1925424,1.8,50.7111798,41.3492092,0.7047781,8.496497,8.2942419,980.6587741,1207.2756446,6.058104,145.5558752,115.4191864,246.38794,12.9155956,14.717258,2.165866,44.5730412),(3289,'blackbuk_metatarsus.tif',237,10,105,85.3494457,50.7450705,41.1593203,1.8,50.7721034,41.271399,0.7009351,9.5866862,8.2560916,960.7007679,1176.2757822,5.9166801,142.473683,100.2119766,212.5717755,12.8658568,14.6262028,2.2014776,44.5730412),(3290,'blackbuk_metatarsus.tif',237,10,106,83.0883034,50.7742155,41.1947355,1.8,50.826745,41.3043571,0.6892302,8.9146115,8.2201061,938.9873169,1144.9917308,5.6004817,139.2915992,105.3312662,224.8468864,12.8439669,14.5164248,2.1910458,44.152546),(3291,'blackbuk_metatarsus.tif',237,10,107,82.1863505,50.7929719,41.2322998,1.8,50.8149182,41.3769723,0.6855562,8.9066675,8.271352,923.0907995,1123.1401411,5.4903258,135.7867657,103.6404244,221.4156265,0.375,0.7730824,1.815775,1.8106603),(3292,'blackbuk_metatarsus.tif',237,10,108,81.7850003,50.8103476,41.2731393,1.8,50.8156195,41.4090919,0.671936,7.710958,8.1946709,913.4530722,1108.1257357,5.282072,135.2251667,118.4616844,217.6863375,0.1875,1.5116734,1.6951513,3.1553303),(3293,'blackbuk_metatarsus.tif',237,10,109,81.5171892,50.8219447,41.3102867,1.8,50.8329224,41.438185,0.6586527,8.341804,8.1524284,902.7613824,1095.6111295,5.0894933,134.3907699,108.2213607,222.0780068,12.6333108,14.2795755,2.0931998,43.667711),(3294,'blackbuk_metatarsus.tif',237,10,110,80.9702685,50.8369668,41.3457452,1.8,50.8587229,41.4538186,0.6530664,8.7428653,8.6053033,892.2220789,1079.7044815,4.9824749,125.4696609,102.0514497,198.0019695,12.6479831,14.2129461,2.1112158,43.8230411),(3295,'blackbuk_metatarsus.tif',237,10,111,80.3998224,50.8553699,41.3829005,1.8,50.8756617,41.4545131,0.6381654,8.5267818,8.0514793,881.1269746,1061.1390089,4.7554588,131.794291,103.3364044,208.9323061,12.6012757,14.1472455,2.1771792,43.5123809),(3296,'blackbuk_metatarsus.tif',237,10,112,79.8728891,50.8794259,41.4335331,1.8,50.9246393,41.5146858,0.6213817,8.3215196,7.8619476,873.3837453,1041.7846048,4.5116106,132.5097357,104.954838,214.0563742,12.5448934,14.0625009,2.2142974,43.2472159),(3297,'blackbuk_metatarsus.tif',237,10,113,78.352491,50.9330614,41.4220871,1.8,50.9906582,41.5387668,0.5884496,8.5554396,7.9706924,856.779749,1010.0999203,4.0234658,126.7267464,100.1444453,205.1329043,12.5352184,13.9129557,2.2223835,43.292711),(3298,'blackbuk_metatarsus.tif',237,10,114,76.9626803,50.9478073,41.474387,1.8,50.9613348,41.5550657,0.5456676,8.1209643,7.627546,838.2596727,979.9524569,3.454976,128.4754561,103.2216911,201.872578,12.5044295,13.8000518,2.2115801,42.8722159),(3299,'blackbuk_metatarsus.tif',237,10,115,76.0558699,50.960745,41.5231104,1.8,50.9693977,41.6117992,0.5104604,8.3804423,7.5832588,825.7471583,959.4329829,3.0258763,126.5198791,98.5326464,195.1846792,12.4429918,13.688785,2.2005997,42.7168858),(3300,'blackbuk_metatarsus.tif',237,10,116,75.1916046,50.9725007,41.5587948,1.8,50.9826484,41.6078747,0.4586652,8.2683965,7.835035,812.3879241,942.581459,2.4566225,120.3034144,98.2521729,204.2789539,12.3750008,13.6166841,2.2390857,42.3418857),(3301,'blackbuk_metatarsus.tif',237,10,117,74.8751495,50.986931,41.5951843,1.8,50.999378,41.6889424,0.4128661,8.2673318,7.5282709,803.8846963,928.6028214,2.0090314,123.3487526,97.2362926,200.6388879,12.3257852,13.5377086,2.1088405,42.2320508),(3302,'blackbuk_metatarsus.tif',237,10,118,74.3146628,51.0033644,41.631068,1.8,51.0160318,41.7210012,0.3386864,9.2618064,7.3179407,794.3271675,917.6141301,1.3672534,125.3923982,85.763741,183.9420672,12.2687626,13.4229581,2.2869982,42.3873809),(3303,'blackbuk_metatarsus.tif',237,10,119,74.0820373,51.0157437,41.6670252,1.8,51.0115945,41.7410907,0.2680742,9.8620458,7.4898388,786.4150473,912.0769258,0.8662501,121.775241,79.7415729,171.7316138,12.1883628,13.3243793,2.2565258,42.2775459),(3304,'blackbuk_metatarsus.tif',237,10,120,73.9100189,51.0291076,41.6991816,1.8,51.0477379,41.7655256,0.191953,8.7622346,7.4983833,776.5023884,906.4622363,0.4483336,120.88769,88.6192188,191.4282657,12.1430024,13.1651181,2.1943571,42.057876),(3305,'blackbuk_metatarsus.tif',237,10,121,72.992037,51.0941201,41.6562231,1.8,51.1135726,41.7363053,0.1258009,10.7507418,8.252193,757.7424846,897.5172037,0.1915134,108.7610535,70.482809,152.3507454,12.0976421,13.210437,3.0278006,42.057876),(3306,'blackbuk_metatarsus.tif',237,10,122,72.4481169,51.0940483,41.6805422,1.8,51.1223716,41.7817944,0.063496,8.8047689,7.6460139,743.8805444,894.4088644,0.0486165,116.9771435,84.4860952,185.7995912,12.0000008,13.2330383,3.0137227,41.9025459),(3307,'blackbuk_metatarsus.tif',237,10,123,72.0473434,51.0926153,41.7060277,1.8,51.1146186,41.7987464,0.0234235,8.7532069,7.6172563,731.0805199,900.2202995,0.0065871,118.1817002,83.5214482,169.4496493,11.9751958,13.3164615,2.9718144,41.7927109),(3308,'blackbuk_metatarsus.tif',237,10,124,71.9113316,51.106588,41.7175276,1.8,51.1299985,41.7646402,-0.0003252,8.3434163,7.5808234,717.8461169,909.7138597,0.0000012,120.0019856,86.0374329,169.1142606,11.9320004,13.3967413,3.0293898,41.948041),(3309,'blackbuk_metatarsus.tif',237,10,125,71.8437557,51.1174946,41.7393195,1.8,51.1309082,41.8339011,-0.0151376,8.8715344,8.1134405,705.5825939,923.8434863,0.0027436,113.8658118,79.533321,182.5088536,11.8476438,13.4713246,0.1537075,41.948041),(3310,'blackbuk_metatarsus.tif',237,10,126,71.8228105,51.1286217,41.7703981,1.8,51.1478814,41.8708802,-0.0223549,9.5658007,7.7309317,698.7296846,946.193953,0.0059812,122.390676,73.044558,166.7315589,11.7654403,13.5830786,0.1106572,42.057876),(3311,'blackbuk_metatarsus.tif',237,10,127,72.1561939,51.1378666,41.8211364,1.8,51.1779195,41.9076931,-0.0301063,7.9444735,7.6943822,702.1022469,975.4287873,0.010897,126.7715539,88.3761828,190.9184526,11.7146837,13.7911325,0.1226687,42.1033711),(3312,'blackbuk_metatarsus.tif',237,10,128,73.0121416,51.1504978,41.8778902,1.8,51.2012578,41.9405528,-0.030444,8.1477025,7.881793,711.5613164,1012.4224737,0.0112749,128.4507812,87.3327565,201.5458699,0.1875,0.2651651,2.3561945,0.5303301),(3313,'blackbuk_metatarsus.tif',237,10,129,73.1163789,51.1942044,41.8907993,1.8,51.1985326,42.0531644,-0.0467683,10.7670535,7.8957206,720.7756997,1046.1238282,0.0266348,132.4925081,66.9427063,163.5495761,11.7842736,14.2129461,0.1456284,43.1640313),(3314,'blackbuk_metatarsus.tif',237,10,130,73.0163248,51.2227167,41.9584773,1.8,51.2680498,42.0591143,-0.0518181,9.137122,8.1181302,730.7715965,1095.6606101,0.032647,134.9646506,79.9783123,190.7695602,0.375,0.8385255,1.1071487,2.1213205),(3315,'blackbuk_metatarsus.tif',237,10,131,73.863183,51.2433905,42.0385713,1.8,51.2772189,42.1526102,-0.0585179,8.8660633,8.1351335,753.0848991,1156.3181294,0.0421075,142.1388013,84.9401674,191.5252798,11.980489,14.7697176,0.1401017,44.3800217),(3316,'blackbuk_metatarsus.tif',237,10,132,74.552918,51.2533812,42.1186166,1.8,51.2714373,42.2146408,-0.0699638,9.3339959,8.3396721,784.3102625,1235.1737279,0.0607228,148.1081891,84.0272771,215.5996426,0.375,0.8385255,1.1071487,2.1213205),(3317,'blackbuk_metatarsus.tif',237,10,133,75.5925638,51.2762755,42.1988661,1.8,51.3341178,42.2893776,-0.0649471,8.8863413,8.4824616,821.5544738,1328.5856407,0.0530685,156.627369,92.4513756,223.8200953,12.4042072,15.4126834,0.1711486,46.455847),(3318,'blackbuk_metatarsus.tif',237,10,134,75.7679052,51.2831777,42.2734935,1.8,51.3086122,42.3303945,-0.0687305,8.6031031,8.7456872,867.7547767,1436.538094,0.0595592,164.2567429,100.8653235,231.150242,12.7579883,15.8490201,0.1904351,47.9370024),(3319,'blackbuk_metatarsus.tif',237,10,135,76.2963633,51.3113894,42.3423464,1.8,51.3380722,42.425382,-0.0631258,8.3271888,9.0722895,918.8128248,1569.5913425,0.0506045,173.0093979,110.3388968,264.4344183,13.1074441,16.3081901,0.150027,49.8574977),(3320,'blackbuk_metatarsus.tif',237,10,136,77.3675881,51.3635266,42.3953033,1.8,51.4054588,42.4893992,-0.0521353,10.9187169,9.8219434,975.9638263,1720.9855152,0.035017,175.2184311,89.3844791,246.0848511,13.3958032,16.8050645,0.1908311,51.073488),(3321,'blackbuk_metatarsus.tif',237,10,137,78.2060702,51.4620306,42.3270918,1.8,51.4764876,42.406737,-0.058167,10.1724478,9.525112,1043.1320163,1895.4219554,0.0440507,198.9920918,102.5448381,272.0543637,14.0336182,17.3576813,0.1846844,53.7439833),(3322,'blackbuk_metatarsus.tif',237,10,138,80.3989428,51.5206654,42.3584023,1.8,51.5544524,42.3566134,-0.0661706,9.4358037,9.7736793,1134.0588406,2093.8022189,0.0585861,214.2286609,120.186777,298.6727867,14.4049116,17.9785039,0.1359974,57.3653039),(3323,'blackbuk_metatarsus.tif',237,10,139,83.4307274,51.5935776,42.4954034,1.8,51.5312855,42.5046705,-0.0760317,9.2967138,10.288495,1226.2799324,2359.2472819,0.0802281,229.3092706,131.9046662,340.6676013,14.7727265,18.6182885,0.1618374,58.865304),(3324,'blackbuk_metatarsus.tif',237,10,140,86.0085595,51.63735,42.7376391,1.8,51.7815882,42.6733014,-0.0627421,8.7773504,10.5087612,1271.6806364,2666.4861809,0.0563558,253.7393439,144.8820627,350.5088654,15.091282,19.3588655,0.1555948,60.5206342),(3325,'blackbuk_metatarsus.tif',237,10,141,89.5592826,51.642247,43.0054674,1.8,51.934362,42.9677841,-0.045895,8.9037151,10.8990274,1336.9800503,3028.6393069,0.0314184,277.8816126,150.1597963,389.4382508,15.1875009,20.354765,0.1015018,62.0206342),(3326,'blackbuk_metatarsus.tif',237,10,142,104.986496,51.7246515,43.3242978,1.8,51.8255865,43.3051986,-0.0266914,9.1581017,10.5319262,1451.4308382,3692.826379,0.012463,350.6316236,158.4859933,461.5111819,15.3156659,21.3733565,0.1319718,64.4714596),(3327,'blackbuk_metatarsus.tif',237,10,143,123.7009609,51.5836222,43.5368069,1.8,51.7739045,43.6364696,-0.0057842,8.6769655,11.2609574,1614.3216259,4502.6141445,0.0006898,399.842926,186.0467947,532.7114083,14.8110307,22.4663825,3.0244839,65.5509646),(3328,'blackbuk_metatarsus.tif',237,10,144,124.5715693,51.479152,43.7701726,1.8,51.7974261,43.8777851,0.0042746,9.0957675,11.9050078,1587.2841297,4757.2287291,0.0003793,399.5989606,174.5079928,524.7008886,14.9212634,23.5639106,0.1036275,68.3312948),(3329,'blackbuk_metatarsus.tif',237,10,145,128.2394604,51.8040231,43.8426694,1.8,51.9035381,44.1376602,0.0098935,10.0496453,12.4299474,1618.3537137,4810.3407685,0.002092,386.9960671,161.0359031,500.0559018,0.375,0.6760409,0.9827937,1.4356603),(3330,'blackbuk_metatarsus.tif',237,10,146,130.9407352,51.9942305,43.9487346,1.8,51.9615718,44.3016152,0.0247994,9.4160507,12.9734631,1757.7627581,4880.4732941,0.0134189,376.1889358,186.6772821,510.1699181,0.6712008,1.2577883,2.0344439,3.0266506),(3331,'blackbuk_metatarsus.tif',237,10,147,132.8821971,51.9015675,43.9625394,1.8,51.9008687,44.3312311,0.024875,10.154718,13.0592115,2163.4655449,5222.0147805,0.013701,399.8721352,213.0502825,562.4839987,1.3873392,2.3717084,1.2490458,6.8033013),(3332,'blackbuk_metatarsus.tif',237,10,148,129.8872106,51.7054345,43.8955395,1.8,51.7979546,44.2729192,0.023778,10.3194136,12.1744149,2527.665367,5353.5614928,0.0122372,439.7387083,244.9427336,593.2585856,1.7516155,3.2745469,1.3397057,10.2049519),(3333,'blackbuk_metatarsus.tif',237,10,149,127.5293959,51.6582925,43.9297523,1.8,51.7478652,44.3242119,0.0334335,10.2295169,12.7518591,2742.805687,5521.6302816,0.0237498,433.0059052,268.1266101,601.833334,1.5927926,4.2301931,1.3473197,11.0192918),(3334,'blackbuk_metatarsus.tif',237,10,150,127.3241272,51.7047839,44.0207151,1.8,51.7631352,44.3124951,0.0339509,10.4804423,12.7928099,2764.3658895,5712.6970553,0.0244508,446.5552985,263.7642399,613.271046,0.75,2.2577991,1.6539376,5.8069809),(3335,'blackbuk_metatarsus.tif',237,10,151,130.5716483,51.8126812,44.0925744,1.8,51.7874618,44.2526242,0.0265722,10.2754827,12.6340989,2597.9505299,6028.7937472,0.0153621,477.1843096,252.8300228,636.8496359,0.1875,0.4192628,2.0344439,0.9053301),(3336,'blackbuk_metatarsus.tif',237,10,152,132.0116668,51.9193896,44.0936465,1.8,51.8181337,44.1508933,0.01602,10.3308091,12.466116,2215.6929506,6120.3362685,0.0056462,490.9577516,214.4742896,629.6573378,0.1875,0.2651651,2.3561945,0.5303301),(3337,'blackbuk_metatarsus.tif',237,10,153,124.3240877,51.9390622,43.9459588,1.8,51.8846786,44.0014101,0.0137792,9.4467452,12.4203764,1621.410439,5490.099235,0.0039339,442.0235808,171.6369401,553.1394691,11.6179191,16.21306,1.4665247,51.3873814),(3338,'blackbuk_metatarsus.tif',237,10,154,92.6342967,51.8336785,43.7944568,1.8,51.9103683,43.8146376,0.0193682,8.5639133,12.1466909,931.7671262,2954.6248277,0.0057909,243.2452463,108.8015596,315.2964348,11.3847277,14.7220348,1.4559197,48.0312259),(3339,'blackbuk_metatarsus.tif',237,10,155,56.195401,51.9164718,43.6289218,1.8,51.9819699,43.6959389,0.0181376,6.5307596,7.7253296,367.3257077,1120.0779378,0.0030808,144.987722,56.2454803,164.914658,6.3750004,12.7995369,1.482789,34.8074291),(3340,'blackbuk_metatarsus.tif',237,10,156,14.5388558,49.9502541,43.4831621,1.8,50.5530043,43.4801789,0.0103406,4.9272564,9.1371413,45.5015064,309.45298,0.0002591,33.8675925,9.2346536,37.4323455,5.8125004,9.5918673,1.4925252,27.9475937),(3341,'blackbuk_metatarsus.tif',237,10,157,0.1782736,46.6571061,43.4171491,1.8,46.6616408,43.4127182,-1.532121,0.4227969,1.2371521,0.0095949,0.0695246,0.0296678,0.0561973,0.0226938,0.0633562,0.9375001,2.6845916,1.359703,6.0266508),(3342,'blackbuk_metatarsus.tif',237,10,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3343,'blackbuk_metatarsus.tif',237,10,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3344,'blackbuk_metatarsus.tif',237,10,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3345,'blackbuk_metatarsus.tif',237,10,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3346,'blackbuk_metatarsus.tif',237,10,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3347,'blackbuk_metatarsus.tif',237,10,163,0.7242071,70.0958812,38.4951717,1.8,70.0609958,38.4931059,-1.5222293,1.6774267,2.1463916,0.3943834,0.8196089,0.1204167,0.3818543,0.2351122,0.5515221,4.3017882,4.4725729,0.5763752,14.1102823),(3348,'blackbuk_metatarsus.tif',237,10,164,11.5692421,68.6808352,38.6580406,1.8,68.4053671,38.6770529,-1.5626113,4.1840309,6.049261,32.5051591,89.8209692,1.9280778,14.8482549,7.7688622,19.1577192,12.0650102,12.3693176,1.3258177,39.853371),(3349,'blackbuk_metatarsus.tif',237,10,165,40.2400521,61.0088837,39.0886909,1.8,57.6648534,39.1958667,-0.0722737,13.077749,15.0112659,870.021676,2798.7590323,0.0349713,186.4439043,66.5268678,193.3414714,9.9375006,25.1592599,1.6229877,77.4645475),(3350,'blackbuk_metatarsus.tif',237,10,166,355.8594846,46.4610035,39.5667346,1.8,48.9938626,39.4609149,-0.0818421,15.7048412,25.5494282,18364.9268537,27876.8085988,0.3963794,1091.0932475,1169.3799762,1722.2163734,28.8750018,29.211515,0.8398896,95.6198787),(3351,'blackbuk_metatarsus.tif',237,10,167,401.3543656,46.3965879,39.478643,1.8,49.746588,39.3798289,-0.0598278,16.1217912,25.4990194,20994.6109251,35024.304841,0.2391469,1373.5549708,1302.2505142,2044.3086444,28.8750018,29.2271564,0.8489488,95.7752088),(3352,'blackbuk_metatarsus.tif',237,10,168,413.0946585,46.8314514,39.4615085,1.8,50.3646689,39.3537301,-0.0588876,15.7958791,25.1096313,21699.0119669,38325.7878592,0.2384762,1526.3381398,1373.7134777,2189.5273285,28.8750018,29.2241491,2.2425313,95.7752088),(5406,'radius-cleaned.tif',183,3,792,8.8051933,4.6358894,5.9905893,1.8,4.6410689,6.0090815,-0.101602,1.4911945,2.648583,5.687822,19.309451,0.0150972,7.2904835,3.8142724,9.3762103,2.9329184,5.321679,0.0750468,15.1826211),(5405,'radius-cleaned.tif',183,3,791,8.8099305,4.6368729,5.9912251,1.8,4.642789,6.0096615,-0.1014124,1.4952637,2.6477266,5.6910416,19.2842324,0.0150492,7.2833171,3.8060454,9.3714443,2.9300592,5.321679,0.0750468,15.2156754),(5404,'radius-cleaned.tif',183,3,790,8.8000512,4.6370841,5.9925756,1.8,4.6446477,6.0106267,-0.10095,1.4892592,2.6558346,5.6858996,19.2797742,0.0148961,7.2594031,3.8179381,9.3678458,2.9329184,5.3282564,0.0899819,14.9762754),(5403,'radius-cleaned.tif',183,3,789,8.7938422,4.6350176,5.9943484,1.8,4.6401462,6.013766,-0.1004223,1.4908272,2.658185,5.6769259,19.2726244,0.0147308,7.2502947,3.8079033,9.3544303,2.9294186,5.3360191,0.1048769,14.8110042),(5402,'radius-cleaned.tif',183,3,788,8.7954216,4.6337031,5.993814,1.8,4.6378932,6.0099896,-0.0996751,1.4941521,2.6397524,5.6699416,19.2815725,0.0145158,7.3043109,3.7947552,9.4478991,2.9300592,5.3210807,0.1429575,15.1495669),(5401,'radius-cleaned.tif',183,3,787,8.7867442,4.632684,5.99679,1.8,4.6376603,6.0162144,-0.0989717,1.497001,2.6489553,5.6550387,19.2579929,0.0142982,7.2700332,3.7775784,9.4016084,2.9189532,5.3330348,0.1577687,15.1455567),(5400,'radius-cleaned.tif',183,3,786,8.7939447,4.6321496,5.9981967,1.8,4.6370527,6.0170159,-0.0985437,1.4983413,2.6417444,5.6593926,19.2164811,0.0141868,7.2741637,3.777105,9.4164212,2.9509629,5.3102989,0.1280828,15.2253567),(5399,'radius-cleaned.tif',183,3,785,8.8024171,4.6313743,5.9993915,1.8,4.6327993,6.019271,-0.097631,1.4955503,2.642638,5.654135,19.2276648,0.0139395,7.2759358,3.7806385,9.4155058,2.9467922,5.3210807,0.1429575,15.1923025),(5398,'radius-cleaned.tif',183,3,784,8.8005601,4.6313792,5.9999275,1.8,4.635496,6.0198075,-0.0975676,1.4960858,2.6426856,5.6528447,19.2248386,0.0139185,7.2747355,3.7784229,9.413782,2.9491863,5.3210807,0.1429575,15.2213466),(5397,'radius-cleaned.tif',183,3,783,8.7978867,4.630416,6.0011037,1.8,4.6337942,6.0224449,-0.096557,1.5010329,2.6437595,5.6519066,19.2352799,0.0136284,7.2757298,3.7653449,9.4135588,2.9509629,5.3210807,0.1429575,15.0093296),(5396,'radius-cleaned.tif',183,3,782,8.7906218,4.6308652,6.0016033,1.8,4.6371752,6.0209372,-0.0951729,1.5015479,2.6433564,5.6441855,19.2021403,0.0132307,7.2643024,3.7589114,9.3995211,2.9572121,5.3102989,0.1280828,14.9802855),(5395,'radius-cleaned.tif',183,3,781,8.7865499,4.6292919,6.0021182,1.8,4.6323399,6.0217961,-0.0940171,1.4808944,2.6374723,5.6270416,19.2091993,0.0129063,7.2831853,3.799759,9.4132539,2.9328323,5.3102989,0.1280828,14.9335398),(5394,'radius-cleaned.tif',183,3,780,8.7867137,4.6268559,6.0027673,1.8,4.6281677,6.0215652,-0.0945182,1.4985497,2.647454,5.6222403,19.2056773,0.0130441,7.2543952,3.7517878,9.3779995,2.9526953,5.3210807,0.1429575,15.2874551),(5393,'radius-cleaned.tif',183,3,779,8.784048,4.6248648,6.0041778,1.8,4.6258041,6.0240975,-0.0932165,1.4860687,2.642128,5.6100503,19.1572763,0.0126844,7.2506996,3.7750948,9.3705821,2.9360592,5.3102989,0.1280828,15.5655805),(5392,'radius-cleaned.tif',183,3,778,8.7865617,4.625337,6.0043855,1.8,4.627937,6.0231352,-0.0936456,1.5037696,2.6341861,5.6050146,19.148838,0.0128048,7.2693566,3.7273095,9.3824007,2.9534273,5.2922805,0.0981683,15.1592483),(5391,'radius-cleaned.tif',183,3,777,8.7871277,4.6237984,6.0047105,1.8,4.6259696,6.0214575,-0.0915211,1.4897084,2.6433492,5.6005511,19.1530064,0.0122328,7.2457345,3.7594949,9.3618479,2.9404807,5.3102989,0.1280828,15.1552381),(5390,'radius-cleaned.tif',183,3,776,8.7597594,4.6235353,6.0062417,1.8,4.6249787,6.0249693,-0.0914489,1.4729689,2.6437556,5.5868295,19.0997504,0.0121755,7.2244767,3.792904,9.3352219,2.9381569,5.3102989,0.1280828,14.8811228),(5389,'radius-cleaned.tif',183,3,775,8.7669193,4.6216163,6.0068398,1.8,4.6229931,6.024229,-0.0907625,1.5022077,2.6312962,5.5817371,19.0875764,0.0120037,7.2540585,3.7156894,9.3434663,2.9682896,5.2922805,0.0981683,15.4003093),(5388,'radius-cleaned.tif',183,3,774,8.7716353,4.620156,6.0085036,1.8,4.6206519,6.0277502,-0.0903321,1.4784029,2.6401927,5.5830218,19.1178654,0.0118968,7.241087,3.7763871,9.3434315,2.9213595,5.3006967,0.113151,15.0794483),(5387,'radius-cleaned.tif',183,3,773,8.7574555,4.6204711,6.0093888,1.8,4.6222534,6.02706,-0.0884204,1.4870793,2.6472578,5.561676,19.1056196,0.0113815,7.217136,3.7399997,9.3163959,2.9086135,5.3102989,0.1280828,14.9529025),(5386,'radius-cleaned.tif',183,3,772,8.7347416,4.6188621,6.0096846,1.8,4.6200021,6.0266682,-0.0875707,1.4804403,2.648928,5.5571134,19.040231,0.0111354,7.1879005,3.7536897,9.2842762,2.905577,5.3102989,0.1280828,14.6223601),(5385,'radius-cleaned.tif',183,3,771,8.7232245,4.6188171,6.0122777,1.8,4.6219577,6.0297936,-0.0880531,1.478217,2.6351425,5.5570469,18.9957379,0.0112433,7.2086188,3.7592904,9.2893054,2.9175686,5.2922805,0.0981683,15.2447195),(5384,'radius-cleaned.tif',183,3,770,8.7042077,4.6205145,6.0134227,1.8,4.6259044,6.0311173,-0.0875197,1.4864275,2.6406359,5.5581522,18.9751196,0.0110836,7.1858143,3.739269,9.2805955,2.9237935,5.3006967,0.113151,15.4801093),(5383,'radius-cleaned.tif',183,3,769,8.705366,4.6188874,6.0147515,1.8,4.621656,6.0313588,-0.0867524,1.4840131,2.6424657,5.5499273,18.9694292,0.010892,7.1786851,3.7398102,9.2694391,2.9175686,5.2922805,0.0981683,15.1181737),(5382,'radius-cleaned.tif',183,3,768,8.7012087,4.6174665,6.0169693,1.8,4.6192306,6.0350801,-0.0854851,1.4859207,2.6214997,5.5473919,18.9534023,0.0105719,7.2299844,3.7333029,9.3408651,2.9062789,5.2760114,0.1365495,15.2737636),(5381,'radius-cleaned.tif',183,3,767,8.6860652,4.6155825,6.0176588,1.8,4.6177393,6.0331749,-0.0853662,1.4830282,2.6166213,5.5383881,18.8922028,0.0105242,7.2200753,3.7345131,9.3366371,2.9013002,5.2657421,0.1215355,15.231028),(5380,'radius-cleaned.tif',183,3,766,8.6839578,4.615711,6.0211066,1.8,4.6182195,6.0391096,-0.0849148,1.4864289,2.6167813,5.5291574,18.8871242,0.0104109,7.217693,3.7197592,9.3245162,2.9175686,5.2760114,0.1365495,15.4043195),(5379,'radius-cleaned.tif',183,3,765,8.7061728,4.6139808,6.0240837,1.8,4.615362,6.0426391,-0.084464,1.4757393,2.61875,5.5309467,18.9007251,0.0103273,7.2174606,3.7479159,9.329303,2.8965537,5.2657421,0.1215355,15.2680923),(5378,'radius-cleaned.tif',183,3,764,8.6993578,4.6140696,6.0241918,1.8,4.6154984,6.0412275,-0.0833879,1.492534,2.61865,5.5299675,18.8841048,0.0100585,7.2113895,3.7050865,9.3228623,2.9062789,5.2657421,0.1215355,15.4430449),(5377,'radius-cleaned.tif',183,3,763,8.6985844,4.6141669,6.0256396,1.8,4.6179986,6.0424503,-0.0824977,1.480707,2.6186529,5.533309,18.8788694,0.0098445,7.2093822,3.7369372,9.3220128,2.896503,5.2760114,0.1365495,15.2544008),(5376,'radius-cleaned.tif',183,3,762,8.6879034,4.6131814,6.026619,1.8,4.6167408,6.0427343,-0.0828204,1.4716938,2.6131222,5.5204031,18.8499083,0.0099093,7.2135578,3.7510542,9.3191328,2.8898868,5.2657421,0.1215355,15.1882923),(5375,'radius-cleaned.tif',183,3,761,8.6867679,4.6131948,6.0288747,1.8,4.61994,6.0461942,-0.0821473,1.4936791,2.6198784,5.5287856,18.8540391,0.009748,7.196532,3.7014548,9.3063029,2.9021182,5.2760114,0.1365495,15.499472),(5374,'radius-cleaned.tif',183,3,760,8.6650503,4.6132717,6.0303847,1.8,4.6210552,6.0473904,-0.0809095,1.4789391,2.6198866,5.5257908,18.8003652,0.0094335,7.1760226,3.7363206,9.2844466,2.8939768,5.2657421,0.1215355,15.2874551),(5373,'radius-cleaned.tif',183,3,759,8.6680317,4.6110532,6.03223,1.8,4.616789,6.0487621,-0.0802533,1.4742654,2.6094287,5.5263655,18.7818533,0.0092846,7.1976878,3.7485553,9.3018611,2.8966242,5.2487841,0.0913481,15.0230211),(5372,'radius-cleaned.tif',183,3,758,8.6571767,4.6112183,6.0328637,1.8,4.6203021,6.0488991,-0.0793783,1.4750637,2.6157483,5.5272166,18.7527083,0.0090723,7.1691563,3.7471037,9.2811261,2.9005091,5.2657421,0.1215355,15.1084923),(5371,'radius-cleaned.tif',183,3,757,8.6440912,4.6104273,6.0349314,1.8,4.6203559,6.0512624,-0.0798349,1.4801638,2.607137,5.5193847,18.7410982,0.0091629,7.1883825,3.7289012,9.2882641,2.8945987,5.2525741,0.0989128,15.0697669),(5370,'radius-cleaned.tif',183,3,756,8.6342554,4.6093595,6.0361781,1.8,4.6180233,6.0519352,-0.0790317,1.4814315,2.6242092,5.5149353,18.7255783,0.0089696,7.1357033,3.722707,9.2369682,2.9005091,5.279028,0.0680765,14.9529025),(5369,'radius-cleaned.tif',183,3,755,8.6317382,4.6062915,6.0375629,1.8,4.6134521,6.052992,-0.0780312,1.4740329,2.6210202,5.5120822,18.7139724,0.0087418,7.1399574,3.7394567,9.2426464,2.8939768,5.279028,0.0680765,14.9432211),(5368,'radius-cleaned.tif',183,3,754,8.6219599,4.6049893,6.0392718,1.8,4.6138186,6.0556256,-0.0775584,1.4755114,2.6225235,5.5025578,18.7024224,0.0086266,7.1314603,3.7292547,9.2290759,2.9005091,5.2657421,0.1215355,14.8440584),(5367,'radius-cleaned.tif',183,3,753,8.6091909,4.6056625,6.0410112,1.8,4.6164101,6.0568305,-0.0767017,1.464879,2.6262114,5.4884504,18.6648686,0.008425,7.1071462,3.7466918,9.1900705,2.8804264,5.2818921,0.0756131,14.9004855),(5366,'radius-cleaned.tif',183,3,752,8.6164763,4.6062742,6.0442393,1.8,4.6188814,6.060976,-0.0767719,1.477296,2.6204605,5.4864779,18.6659849,0.0084475,7.1231697,3.7138649,9.2166315,2.8914755,5.276464,0.060532,14.8771126),(5365,'radius-cleaned.tif',183,3,751,8.6360682,4.6052329,6.0451643,1.8,4.61865,6.0598549,-0.0754409,1.472518,2.6193247,5.4847281,18.6863256,0.0081762,7.1340242,3.7247275,9.2276526,2.8909897,5.276464,0.060532,15.1084923),(5364,'radius-cleaned.tif',183,3,750,8.6351858,4.604163,6.0482712,1.8,4.6192224,6.0642325,-0.0747806,1.4777283,2.6151483,5.4779208,18.6762059,0.0080332,7.1415475,3.7069878,9.2244073,2.8884026,5.2525741,0.0989128,14.8440584),(5363,'radius-cleaned.tif',183,3,749,8.6489046,4.6049561,6.047973,1.8,4.6220664,6.0615381,-0.0735994,1.4772696,2.6246654,5.4812787,18.6751565,0.0077942,7.1152522,3.7104119,9.1964898,2.8974859,5.2818921,0.0756131,15.2640822),(5362,'radius-cleaned.tif',183,3,748,8.667667,4.60608,6.0505746,1.8,4.626319,6.0652353,-0.0734172,1.4652788,2.6255766,5.4775963,18.6651852,0.0077726,7.1089852,3.7382621,9.1884063,2.8684057,5.2818921,0.0756131,14.8771126),(5361,'radius-cleaned.tif',183,3,747,8.7127746,4.6078242,6.0526516,1.8,4.6312199,6.0680556,-0.0728568,1.4791004,2.621299,5.4823206,18.6898488,0.0076944,7.129995,3.7065237,9.2211539,2.9071108,5.276464,0.060532,15.3011466),(5360,'radius-cleaned.tif',183,3,746,8.7336836,4.6074859,6.0543548,1.8,4.6300412,6.0697544,-0.0716131,1.4663109,2.5952886,5.4874834,18.7044752,0.0074523,7.2070888,3.7423736,9.2868646,2.8774393,5.2364856,0.1375867,14.9529025),(5359,'radius-cleaned.tif',183,3,745,8.7325526,4.606313,6.0573268,1.8,4.627769,6.0738579,-0.0702977,1.4692526,2.6250063,5.481049,18.6995903,0.0071805,7.1236364,3.7305015,9.2046155,2.8925186,5.276464,0.060532,15.0286923),(5358,'radius-cleaned.tif',183,3,744,8.7387682,4.6042833,6.0599114,1.8,4.6264696,6.0760504,-0.0701513,1.474492,2.6227853,5.4715275,18.6703145,0.0071558,7.1185065,3.7107882,9.1978952,2.8939925,5.2610538,0.1140073,15.1746008),(5357,'radius-cleaned.tif',183,3,743,8.7513083,4.603806,6.0613827,1.8,4.6258257,6.075663,-0.0691522,1.4759339,2.6165917,5.4779687,18.6623909,0.0069637,7.1323282,3.7115271,9.2255482,2.8901682,5.2525741,0.0989128,15.0327025),(5356,'radius-cleaned.tif',183,3,742,8.7556987,4.6011886,6.063498,1.8,4.6217573,6.0780307,-0.0686251,1.4778681,2.6138234,5.4767533,18.6662876,0.0068616,7.1413729,3.7058471,9.2363605,2.8914755,5.2525741,0.0989128,15.151228),(5355,'radius-cleaned.tif',183,3,741,8.7561497,4.6013078,6.0658111,1.8,4.6247111,6.0812997,-0.0680752,1.4774745,2.6192009,5.4734009,18.6533084,0.0067526,7.1217556,3.7045654,9.204723,2.8820867,5.2610538,0.1140073,14.8964754),(5354,'radius-cleaned.tif',183,3,740,8.7316959,4.6025186,6.0670843,1.8,4.629107,6.0818334,-0.0666877,1.4788906,2.6201824,5.4603898,18.6086094,0.0064624,7.1020282,3.6922201,9.1789615,2.8954663,5.2525741,0.0989128,14.834377),(5353,'radius-cleaned.tif',183,3,739,8.7373031,4.6013627,6.0697169,1.8,4.6267742,6.0851336,-0.0668804,1.4654322,2.6135398,5.4599592,18.5765636,0.0065039,7.1078174,3.7258354,9.1966542,2.8716001,5.2452949,0.0837729,14.8440584),(5352,'radius-cleaned.tif',183,3,738,8.7352928,4.5995589,6.0710671,1.8,4.6247183,6.0842938,-0.0650319,1.4853376,2.6116108,5.4541352,18.5812544,0.0061485,7.1148637,3.6719834,9.2029071,2.9105534,5.2452949,0.0837729,14.9529025),(5351,'radius-cleaned.tif',183,3,737,8.7121278,4.5981287,6.0733913,1.8,4.6257652,6.0871789,-0.0643015,1.4721858,2.615144,5.4528769,18.5567765,0.0059954,7.095891,3.7039326,9.1739102,2.8842319,5.2610538,0.1140073,14.834377),(5350,'radius-cleaned.tif',183,3,736,8.6864621,4.5954129,6.0753526,1.8,4.6219483,6.0894559,-0.0626528,1.4595356,2.6121375,5.437604,18.4881579,0.0056755,7.077789,3.7255714,9.1520096,2.8772216,5.2452949,0.0837729,14.886794),(5349,'radius-cleaned.tif',183,3,735,8.6812782,4.5928456,6.0774601,1.8,4.617163,6.0909479,-0.0624378,1.471404,2.609421,5.4521297,18.480581,0.0056333,7.0822536,3.7053928,9.1643769,2.9021029,5.2525741,0.0989128,14.9802855),(5348,'radius-cleaned.tif',183,3,734,8.6766577,4.5910333,6.0794377,1.8,4.6141943,6.0921285,-0.0613539,1.4606951,2.6024836,5.4477364,18.4706152,0.0054368,7.0973033,3.7295505,9.1901514,2.8805165,5.2392211,0.0685945,15.0230211),(5347,'radius-cleaned.tif',183,3,733,8.6642015,4.5896257,6.0812344,1.8,4.6126524,6.0944086,-0.0603284,1.4622874,2.5910549,5.4432902,18.4254323,0.0052492,7.1111701,3.722449,9.1932733,2.883647,5.2090517,0.0920468,15.046394),(5346,'radius-cleaned.tif',183,3,732,8.6417241,4.5866478,6.0834959,1.8,4.6068642,6.0959824,-0.0596472,1.4619117,2.602574,5.4414895,18.3955426,0.0051182,7.0682113,3.7221739,9.151485,2.8777603,5.2452949,0.0837729,14.8674313),(5345,'radius-cleaned.tif',183,3,731,8.635361,4.5867077,6.0867212,1.8,4.6075681,6.1018889,-0.0593293,1.4651124,2.6024088,5.4431519,18.3766227,0.0050601,7.0613897,3.7151772,9.1457763,2.8812378,5.234357,0.0533843,14.914177),(5344,'radius-cleaned.tif',183,3,730,8.6373058,4.5842152,6.0890378,1.8,4.6018768,6.1026231,-0.057558,1.4671535,2.5950096,5.4412894,18.3748013,0.0047639,7.0808221,3.7087389,9.1771889,2.8939215,5.2090517,0.0920468,14.9004855),(5343,'radius-cleaned.tif',183,3,729,8.6406823,4.5828724,6.0915927,1.8,4.6009204,6.1059608,-0.057536,1.4719199,2.598662,5.446792,18.3621779,0.0047621,7.0660124,3.7004677,9.157355,2.9019848,5.234357,0.0533843,14.8013228),(5342,'radius-cleaned.tif',183,3,728,8.6351816,4.5824993,6.0945349,1.8,4.6006123,6.1093439,-0.0568639,1.4747623,2.58843,5.4389698,18.3054279,0.0046486,7.0720196,3.6880315,9.1710398,2.904768,5.1968124,0.061461,14.9101669),(5341,'radius-cleaned.tif',183,3,727,8.6190613,4.5818708,6.0955066,1.8,4.5994131,6.1107955,-0.0565943,1.4576119,2.5714087,5.4310469,18.2757521,0.0045961,7.1072918,3.7259897,9.208533,2.8825018,5.1916019,0.1310279,14.5465702),(5340,'radius-cleaned.tif',183,3,726,8.599548,4.5797693,6.0973759,1.8,4.5979546,6.111347,-0.0556279,1.4750917,2.5900519,5.4222584,18.2541505,0.0044306,7.0477932,3.6758789,9.1409282,2.9077714,5.1994157,0.0691205,14.6884685),(5339,'radius-cleaned.tif',183,3,725,8.6055003,4.5793027,6.0981692,1.8,4.5975357,6.1113616,-0.0554198,1.4625829,2.5895373,5.4288255,18.2671496,0.0044006,7.0542138,3.7118071,9.1503076,2.8825018,5.2023237,0.0767719,14.6223601),(5338,'radius-cleaned.tif',183,3,724,8.6019384,4.5787305,6.1015612,1.8,4.5991044,6.1142203,-0.0546482,1.4682489,2.5702684,5.4256541,18.2442301,0.0042773,7.0981808,3.6953231,9.2069205,2.8820867,5.1817798,0.1157592,14.6554143),(5337,'radius-cleaned.tif',183,3,723,8.5966909,4.5763337,6.1042207,1.8,4.59406,6.1185062,-0.0542396,1.4708276,2.5905421,5.4399459,18.2251776,0.004211,7.0352757,3.6985613,9.128459,2.8952494,5.2055359,0.0844143,14.8634211),(5336,'radius-cleaned.tif',183,3,722,8.583564,4.5752271,6.1056628,1.8,4.5943783,6.1176095,-0.0537699,1.4594036,2.5893125,5.4428378,18.1706555,0.0041322,7.0175599,3.7294946,9.1128845,2.8805165,5.2055359,0.0844143,14.8303669),(5335,'radius-cleaned.tif',183,3,721,8.5748829,4.5762354,6.1083789,1.8,4.5953509,6.1212436,-0.0522585,1.4562297,2.585856,5.4481791,18.1547559,0.0038994,7.0207915,3.7412911,9.1274091,2.8900148,5.1994157,0.0691205,14.8206855),(5334,'radius-cleaned.tif',183,3,720,8.5802219,4.5732733,6.1111617,1.8,4.5907088,6.1228388,-0.0503241,1.4563257,2.569914,5.4534721,18.126056,0.0036185,7.0531762,3.744679,9.1739328,2.896172,5.1693219,0.0927563,14.8577499),(5333,'radius-cleaned.tif',183,3,719,8.5957572,4.570869,6.1139449,1.8,4.585675,6.1273757,-0.0497208,1.4588463,2.5761922,5.4507188,18.1284076,0.0035388,7.0369002,3.7363215,9.1504215,2.9024437,5.1908353,0.0384426,14.8811228),(5332,'radius-cleaned.tif',183,3,718,8.5656105,4.5689048,6.1171733,1.8,4.5825085,6.13072,-0.0488578,1.4578791,2.581916,5.4489796,18.0581005,0.0034051,6.9940696,3.7376073,9.0975586,2.8979124,5.1994157,0.0691205,14.9295296),(5331,'radius-cleaned.tif',183,3,717,8.5260748,4.5665241,6.1201768,1.8,4.5759334,6.1353521,-0.0483894,1.4626241,2.5771699,5.4270531,18.012764,0.0033248,6.9893584,3.7104908,9.0945849,2.9043625,5.1945143,0.0537942,14.754577),(5330,'radius-cleaned.tif',183,3,716,8.5356804,4.5619528,6.1234282,1.8,4.56951,6.1380918,-0.0470446,1.4654044,2.5819262,5.4341568,18.0172918,0.0031462,6.9782364,3.7082985,9.0825696,2.9024437,5.1945143,0.0537942,14.9859567),(5329,'radius-cleaned.tif',183,3,715,8.5377334,4.5615912,6.1259393,1.8,4.570928,6.1421311,-0.0460857,1.4585282,2.5787475,5.4357471,18.002797,0.0030201,6.9812173,3.7268716,9.0826077,2.8942641,5.1883811,0.0230728,15.019011),(5328,'radius-cleaned.tif',183,3,714,8.5289341,4.5574742,6.1282844,1.8,4.5643288,6.1440407,-0.0456877,1.4716222,2.5866507,5.4387768,17.9387353,0.0029651,6.935121,3.6957698,9.0376066,2.917163,5.1994157,0.0691205,14.9004855),(5327,'radius-cleaned.tif',183,3,713,8.5173395,4.5540039,6.1319444,1.8,4.5577201,6.1496577,-0.044825,1.4606283,2.5902933,5.4459528,17.8974703,0.0028504,6.9094379,3.7285,9.0118295,2.8944316,5.1945143,0.0537942,15.0093296),(5326,'radius-cleaned.tif',183,3,712,8.5034366,4.5524697,6.134343,1.8,4.5559288,6.1499623,-0.0443446,1.4647732,2.5609194,5.4388054,17.8815992,0.0027851,6.982492,3.71307,9.0798141,2.9019848,5.1693219,0.0927563,15.2213466),(5325,'radius-cleaned.tif',183,3,711,8.4820803,4.5531741,6.1365982,1.8,4.5559789,6.1513688,-0.0420921,1.46719,2.5879752,5.440351,17.8562953,0.0025032,6.8997166,3.7080072,8.9978925,2.8944316,5.1625421,0.0773647,14.6223601),(5324,'radius-cleaned.tif',183,3,710,8.464036,4.5513642,6.1405522,1.8,4.5531532,6.157475,-0.0421206,1.460982,2.5584838,5.4499783,17.8186523,0.0025013,6.964536,3.7303528,9.0833823,2.9145748,5.1569883,0.0619362,14.8771126),(5323,'radius-cleaned.tif',183,3,709,8.4379898,4.5499951,6.1435186,1.8,4.551473,6.1604139,-0.0413845,1.4756638,2.561106,5.4375997,17.7785833,0.0024072,6.9417601,3.6848499,9.0571188,2.9075513,5.1693219,0.0927563,14.5989872),(5322,'radius-cleaned.tif',183,3,708,8.4288598,4.5485646,6.1481985,1.8,4.5488183,6.1660354,-0.0405776,1.4673485,2.5613912,5.4467741,17.7219945,0.0023118,6.9188942,3.7119839,9.0320556,2.9139547,5.1569883,3.0796565,14.7642584),(5321,'radius-cleaned.tif',183,3,707,8.4364415,4.5460003,6.1512828,1.8,4.5425803,6.1683725,-0.0390483,1.4558998,2.5607427,5.4485914,17.6961339,0.0021429,6.9105473,3.742422,9.0352522,2.9066145,5.1334728,0.1012154,14.9472313),(5320,'radius-cleaned.tif',183,3,706,8.4666826,4.5472668,6.154908,1.8,4.5488597,6.1722598,-0.0385703,1.4563505,2.559585,5.4532175,17.6998118,0.0020982,6.9151101,3.7444401,9.0421149,2.8956083,5.1334728,0.1012154,14.5038346),(5319,'radius-cleaned.tif',183,3,705,8.4659479,4.5468629,6.1569761,1.8,4.5482078,6.1736218,-0.0381208,1.4567811,2.560035,5.4504467,17.6883233,0.0020495,6.9094067,3.7414315,9.0308933,2.9039633,5.1625421,0.0773647,15.0327025),(5318,'radius-cleaned.tif',183,3,704,8.4489544,4.5441164,6.1597489,1.8,4.544492,6.1764935,-0.0377227,1.4623852,2.5598448,5.4544313,17.6618932,0.0020029,6.8995952,3.7298184,9.0132033,2.9067483,5.1295948,3.0481159,15.046394),(5317,'radius-cleaned.tif',183,3,703,8.4385836,4.5411477,6.1624776,1.8,4.5398332,6.1802918,-0.0363416,1.4573956,2.5629105,5.4556358,17.6574959,0.0018567,6.8896265,3.7434144,9.0177323,2.8983933,5.1526646,0.0464781,15.1592483),(5316,'radius-cleaned.tif',183,3,702,8.4263013,4.5411387,6.1650371,1.8,4.5411121,6.1840541,-0.0352412,1.459887,2.5658147,5.4494899,17.6112834,0.0017434,6.8638174,3.7328163,8.9822144,2.8996528,5.150965,0.0387403,14.9529025),(5315,'radius-cleaned.tif',183,3,701,8.421931,4.5376635,6.1673158,1.8,4.537272,6.1863341,-0.0346255,1.4633876,2.5637859,5.4516913,17.5904518,0.0016822,6.8611236,3.7253912,8.9636425,2.9025708,5.1526646,3.0951145,14.7779499),(5314,'radius-cleaned.tif',183,3,700,8.3951926,4.534678,6.1684222,1.8,4.5311799,6.1855505,-0.0340696,1.464337,2.5441883,5.4314203,17.5185022,0.0016235,6.885694,3.7091328,9.0150058,2.9011783,5.1295948,0.0934768,14.9956381),(5313,'radius-cleaned.tif',183,3,699,8.3900901,4.5313841,6.1712424,1.8,4.5276058,6.1879789,-0.033307,1.4669724,2.56762,5.4326141,17.5200761,0.0015507,6.8234692,3.7032832,8.9223294,2.9011783,5.1227624,3.063626,14.7973126),(5312,'radius-cleaned.tif',183,3,698,8.3937101,4.5279009,6.175204,1.8,4.5202167,6.1931536,-0.0329697,1.4576328,2.5419223,5.4379804,17.4978534,0.0015201,6.883709,3.730693,8.9747367,2.8874699,5.1227624,3.063626,14.6981499),(5311,'radius-cleaned.tif',183,3,697,8.4009104,4.5239486,6.1786475,1.8,4.51257,6.1967961,-0.0320519,1.472738,2.5458108,5.4386431,17.4724812,0.0014379,6.8632284,3.6928788,8.9695659,2.9012258,5.1198092,3.0713957,14.6924787),(5310,'radius-cleaned.tif',183,3,696,8.415559,4.5223122,6.1833027,1.8,4.5105871,6.2035795,-0.0310505,1.4698593,2.5473974,5.4479378,17.465263,0.0013518,6.8561202,3.7064349,8.9673975,2.8966718,5.1025222,0.1175656,14.4530787),(5309,'radius-cleaned.tif',183,3,695,8.4357088,4.5190591,6.1858607,1.8,4.5062915,6.2064679,-0.0312703,1.4810045,2.5794258,5.4601837,17.4605491,0.0013743,6.7691612,3.6868111,8.869114,2.9368765,5.1198092,3.0713957,14.754577),(5308,'radius-cleaned.tif',183,3,694,8.4266205,4.5151606,6.1879235,1.8,4.4991787,6.2085312,-0.0308037,1.473076,2.5521811,5.4672235,17.4716992,0.0013322,6.8457914,3.7114335,8.9673572,2.9000383,5.0979961,3.0317997,14.8674313),(5307,'radius-cleaned.tif',183,3,693,8.4331027,4.5127594,6.1908383,1.8,4.4978051,6.2130191,-0.0291272,1.4844515,2.554454,5.4755665,17.4839638,0.0011921,6.8445012,3.6886126,8.9383117,2.9340916,5.0979961,3.0317997,14.6650957),(5306,'radius-cleaned.tif',183,3,692,8.4498616,4.5112253,6.1933353,1.8,4.4956055,6.2158255,-0.0276965,1.4580102,2.5558659,5.481837,17.5086441,0.00108,6.8503767,3.759807,8.9754929,2.9072673,5.1171654,3.0791738,14.886794),(5305,'radius-cleaned.tif',183,3,691,8.4374447,4.510178,6.195964,1.8,4.4971785,6.2181506,-0.0268646,1.4904821,2.5568681,5.4919762,17.4723809,0.0010147,6.8335089,3.684698,8.9624671,2.9377744,5.0979961,0.1097929,14.7973126),(5304,'radius-cleaned.tif',183,3,690,8.4018297,4.509736,6.1983093,1.8,4.4976888,6.2201978,-0.0256785,1.4600023,2.5571996,5.4928405,17.4176087,0.0009231,6.8112043,3.7622136,8.9406161,2.9127001,5.0979961,3.0317997,15.1084923),(5303,'radius-cleaned.tif',183,3,689,8.3938249,4.5076281,6.2019768,1.8,4.4939535,6.2236864,-0.0248285,1.4583548,2.5572903,5.4961145,17.4213402,0.0008622,6.8124218,3.7687087,8.9578959,2.8997858,5.0898703,0.0942085,14.6320414),(5302,'radius-cleaned.tif',183,3,688,8.4029194,4.5069586,6.2054119,1.8,4.4921471,6.2287686,-0.0241125,1.4616561,2.5579889,5.5021841,17.4200447,0.0008141,6.8100547,3.7643492,8.9567689,2.9081874,5.1110951,3.10255,15.1221839),(5301,'radius-cleaned.tif',183,3,687,8.3966186,4.5092656,6.2077307,1.8,4.4984301,6.2299887,-0.0227183,1.4647051,2.5556226,5.509389,17.3793744,0.0007222,6.8004463,3.7614322,8.933351,2.9127001,5.0898703,3.0473842,14.7739398),(5300,'radius-cleaned.tif',183,3,686,8.3426787,4.5124688,6.2096108,1.8,4.5083272,6.2299679,-0.020279,1.466141,2.5506254,5.4877366,17.2882079,0.0005717,6.7780271,3.7429801,8.900956,2.9016164,5.112808,3.0947519,14.8964754),(5299,'radius-cleaned.tif',183,3,685,8.3318535,4.5114123,6.2135564,1.8,4.5079731,6.2349509,-0.019755,1.469953,2.5533286,5.4794887,17.2525085,0.0005419,6.7568696,3.7276626,8.8962919,2.9190039,5.1110951,0.0390426,15.1609093),(5298,'radius-cleaned.tif',183,3,684,8.318431,4.5086748,6.2155814,1.8,4.5036441,6.2356472,-0.0178621,1.4658214,2.5516351,5.4676078,17.2132566,0.0004423,6.7459709,3.7300642,8.8764859,2.8992015,5.0800082,3.0708448,14.7255329),(5297,'radius-cleaned.tif',183,3,683,8.3194414,4.5064907,6.2203563,1.8,4.5004538,6.2432663,-0.0163922,1.4713681,2.5200833,5.4721577,17.2049177,0.0003725,6.8271225,3.7190949,8.9399857,2.9019848,5.0862721,3.0551941,14.9004855),(5296,'radius-cleaned.tif',183,3,682,8.3159339,4.5047286,6.223807,1.8,4.499439,6.246614,-0.0163517,1.4747923,2.5585247,5.468214,17.1739031,0.0003705,6.7124241,3.7077858,8.8487326,2.9186299,5.1086027,0.0234332,14.9158381),(5295,'radius-cleaned.tif',183,3,681,8.3128241,4.5023054,6.2286898,1.8,4.4955499,6.2525369,-0.0158998,1.4486528,2.5230163,5.4667683,17.1408213,0.0003502,6.7937813,3.7736912,8.9321406,2.9066201,5.0749915,3.0865303,14.7408855),(5294,'radius-cleaned.tif',183,3,680,8.3198684,4.5027086,6.2329008,1.8,4.4992897,6.2580628,-0.0148307,1.4511619,2.5224991,5.4627538,17.128004,0.000305,6.7900931,3.7644,8.9282745,2.9097031,5.0540876,3.0387818,14.6650957),(5293,'radius-cleaned.tif',183,3,679,8.3435141,4.5016429,6.235719,1.8,4.4980199,6.2592555,-0.0144962,1.4520915,2.5223916,5.4564668,17.1433164,0.0002922,6.7964531,3.7576604,8.8993404,2.9127001,5.0862721,3.0551941,14.4200244),(5292,'radius-cleaned.tif',183,3,678,8.3558248,4.5019868,6.2383795,1.8,4.5008112,6.2612256,-0.0126866,1.454227,2.5219064,5.4619481,17.1161487,0.0002241,6.7869881,3.7559118,8.893121,2.9127001,5.0628998,3.0231027,14.7175126),(5291,'radius-cleaned.tif',183,3,677,8.3693208,4.4990049,6.2412836,1.8,4.495917,6.2632034,-0.0128673,1.455092,2.5249438,5.4560038,17.1256425,0.0002309,6.7825836,3.7495938,8.914322,2.9127001,5.0749915,3.0865303,14.7973126),(5290,'radius-cleaned.tif',183,3,676,8.4131771,4.4980042,6.2455467,1.8,4.4943989,6.2682945,-0.0124307,1.4617648,2.5249598,5.4630123,17.1085064,0.0002167,6.775754,3.7372718,8.9081223,2.9127001,5.0749915,3.0865303,14.8166754),(5289,'radius-cleaned.tif',183,3,675,8.4344964,4.4952208,6.2509249,1.8,4.4878464,6.2757762,-0.0125741,1.4641447,2.5288181,5.4640754,17.1209797,0.0002222,6.7703483,3.731923,8.8775276,2.9127001,5.0862721,3.0551941,14.8771126),(5288,'radius-cleaned.tif',183,3,674,8.3768339,4.4934274,6.2546263,1.8,4.4838602,6.2804615,-0.010893,1.4672421,2.5304559,5.4682354,17.0964446,0.0001657,6.7562706,3.7268802,8.9068306,2.9127001,5.0465221,3.0545118,14.3345532),(5287,'radius-cleaned.tif',183,3,673,8.3478092,4.4918132,6.2585464,1.8,4.4820642,6.2850586,-0.0106281,1.4711318,2.5308069,5.4729386,17.07755,0.0001572,6.7478676,3.7202231,8.8820012,2.9065894,5.0465221,3.0545118,14.6650957),(5286,'radius-cleaned.tif',183,3,672,8.3355205,4.490224,6.2596064,1.8,4.4809248,6.2828658,-0.0096721,1.4713588,2.5327842,5.467127,17.0454133,0.00013,6.7299115,3.7156995,8.8618235,2.9127001,5.0749915,3.0865303,14.7175126),(5285,'radius-cleaned.tif',183,3,671,8.3145958,4.4900223,6.2629644,1.8,4.4822948,6.2860982,-0.0093503,1.4393038,2.5330009,5.4671334,16.9970425,0.0001212,6.7102395,3.7984569,8.8606686,2.9024437,5.0465221,3.0545118,14.754577),(5284,'radius-cleaned.tif',183,3,670,8.2909179,4.4901264,6.2634756,1.8,4.4852573,6.2835607,-0.008134,1.4392714,2.5325078,5.4757537,16.964728,0.0000914,6.698786,3.8045316,8.8517709,2.9127001,5.0749915,3.0865303,14.9198482),(5283,'radius-cleaned.tif',183,3,669,8.2949738,4.4899693,6.2666071,1.8,4.487934,6.285578,-0.0069513,1.4415929,2.532663,5.4876544,16.9765363,0.0000668,6.7030379,3.8066602,8.843833,2.9039793,5.0712258,3.1022429,14.9529025),(5282,'radius-cleaned.tif',183,3,668,8.2757489,4.4895996,6.2703363,1.8,4.4896936,6.2895923,-0.0047517,1.4444146,2.5329903,5.494002,16.933187,0.0000311,6.6850581,3.8036183,8.8289814,2.9127001,5.0749915,3.0865303,15.2173364),(5281,'radius-cleaned.tif',183,3,667,8.2617707,4.4878652,6.2744131,1.8,4.4874924,6.2948703,-0.0037134,1.4473146,2.5347033,5.4831842,16.9101877,0.000019,6.6714664,3.7885227,8.8270508,2.9127001,5.0465221,3.0545118,14.7836211),(5280,'radius-cleaned.tif',183,3,666,8.2474529,4.4874747,6.2773044,1.8,4.486219,6.2946076,-0.0030345,1.4500597,2.5350744,5.4827178,16.9034837,0.0000127,6.6678453,3.7810291,8.823296,2.9127001,5.0749915,3.0865303,14.7836211),(5279,'radius-cleaned.tif',183,3,665,8.241637,4.4860744,6.2805831,1.8,4.4831331,6.2971748,-0.0016119,1.4530305,2.5362844,5.4927286,16.8777456,0.0000036,6.6545161,3.7801881,8.8196495,2.9127001,5.0674572,3.1337188,14.9819466),(5278,'radius-cleaned.tif',183,3,664,8.2399578,4.4842368,6.2839042,1.8,4.4788966,6.2993292,-0.0011639,1.4559282,2.5382309,5.4823253,16.8710732,0.0000019,6.6467842,3.765519,8.7848811,2.9019848,5.0749915,3.0865303,14.8771126),(5277,'radius-cleaned.tif',183,3,663,8.2410468,4.4821141,6.2890398,1.8,4.4769994,6.3058282,-0.0000232,1.4611437,2.5402876,5.4969093,16.8484147,-0.000000001517,6.6324832,3.7620593,8.7902413,2.9155264,5.0712258,3.1022429,15.0286923),(5276,'radius-cleaned.tif',183,3,662,8.2364489,4.4801761,6.2931138,1.8,4.4733242,6.3106076,0.0008749,1.4654824,2.5025423,5.4947013,16.8491811,0.0000011,6.7328257,3.7494147,8.8783966,2.9120489,5.0465221,3.0545118,14.8537398),(5275,'radius-cleaned.tif',183,3,661,8.2240401,4.4804389,6.2978881,1.8,4.4751648,6.3162488,0.0019966,1.444007,2.5027062,5.4903121,16.8323022,0.0000055,6.7256406,3.8021366,8.8471335,2.9127001,5.0402088,3.0702852,14.6554143),(5274,'radius-cleaned.tif',183,3,660,8.2298478,4.48047,6.3015107,1.8,4.4769109,6.3196754,0.0034278,1.4413094,2.5031188,5.5077826,16.8625843,0.0000161,6.7366296,3.8213744,8.8678012,2.9127001,5.0465221,3.0545118,14.9956381),(5273,'radius-cleaned.tif',183,3,659,8.2248676,4.4794233,6.3062084,1.8,4.4764612,6.3257677,0.0034904,1.44073,2.5432329,5.4950269,16.8388731,0.0000167,6.6210503,3.8140574,8.7784743,2.9127001,5.0712258,3.1022429,14.7642584),(5272,'radius-cleaned.tif',183,3,658,8.2431769,4.4796724,6.310095,1.8,4.4796149,6.3295839,0.004502,1.4443869,2.5038536,5.5128356,16.8524293,0.0000278,6.7305969,3.8167305,8.89736,2.9127001,5.0351525,3.0860941,14.5989872),(5271,'radius-cleaned.tif',183,3,657,8.2444553,4.4751992,6.3142261,1.8,4.4708073,6.3342091,0.0051148,1.4486192,2.5088496,5.5077542,16.8284426,0.0000359,6.7076332,3.8020717,8.8414975,2.9127001,5.0540876,3.0387818,14.9625839),(5270,'radius-cleaned.tif',183,3,656,8.2660175,4.4752012,6.3184035,1.8,4.4746264,6.3381495,0.0058142,1.4530935,2.5090299,5.5114808,16.8282311,0.0000466,6.7070668,3.7929292,8.844674,2.9127001,5.0465221,3.0545118,14.9101669),(5269,'radius-cleaned.tif',183,3,655,8.2779398,4.472836,6.3229232,1.8,4.4708981,6.3438917,0.0071292,1.4581863,2.5117426,5.5210896,16.8135943,0.0000701,6.6939958,3.7862718,8.8363627,2.9127001,5.0465221,3.0545118,14.7739398),(5268,'radius-cleaned.tif',183,3,654,8.2757516,4.4719705,6.3256374,1.8,4.4703922,6.3447396,0.0079391,1.4596668,2.512181,5.5219134,16.8081839,0.0000869,6.6906739,3.7829959,8.8612424,2.9127001,5.0351525,3.0860941,14.5852957),(5267,'radius-cleaned.tif',183,3,653,8.2963603,4.4708712,6.3293222,1.8,4.47006,6.3482694,0.0087397,1.4631917,2.5141031,5.5328201,16.850747,0.0001056,6.7024884,3.7813363,8.8515049,2.9324779,5.0540876,3.0387818,14.5893058),(5266,'radius-cleaned.tif',183,3,652,8.3205836,4.4703268,6.3331067,1.8,4.4718887,6.3522352,0.0091134,1.4670499,2.5147146,5.5388617,16.8596898,0.0001152,6.7044149,3.7755101,8.8570679,2.9222361,5.0465221,3.0545118,14.6086685),(5265,'radius-cleaned.tif',183,3,651,8.3596495,4.4681809,6.3373666,1.8,4.4674569,6.3560548,0.0093423,1.4665261,2.5168817,5.5475954,16.8563339,0.0001216,6.6973088,3.7828139,8.8534296,2.9504796,5.0465221,3.0545118,14.7175126),(5264,'radius-cleaned.tif',183,3,650,8.3844516,4.4654115,6.3421459,1.8,4.4615277,6.3615985,0.0102105,1.4435408,2.5190143,5.5611017,16.8687134,0.0001457,6.6965531,3.8524035,8.8826116,2.9127001,5.0402088,3.0702852,14.4764516),(5263,'radius-cleaned.tif',183,3,649,8.3925926,4.4630955,6.3469035,1.8,4.4601138,6.3672489,0.011486,1.4465065,2.5214977,5.5599258,16.8926689,0.0001845,6.6994584,3.8436923,8.8848283,2.9127001,5.0465221,3.0545118,14.8400482),(5262,'radius-cleaned.tif',183,3,648,8.405917,4.4629534,6.351595,1.8,4.4617567,6.3716663,0.013248,1.44966,2.5229265,5.568517,16.8866759,0.0002459,6.6932889,3.8412571,8.8609816,2.9127001,5.0465221,3.0545118,14.7408855),(5261,'radius-cleaned.tif',183,3,647,8.4058099,4.4608874,6.3562886,1.8,4.4598131,6.3771095,0.0140586,1.4530439,2.5239969,5.5757741,16.8576331,0.0002769,6.6789437,3.8373059,8.8720083,2.9127001,5.0402088,3.0702852,15.0053195),(5260,'radius-cleaned.tif',183,3,646,8.4042686,4.4606678,6.3587622,1.8,4.4621903,6.3771999,0.0150984,1.4570434,2.5243356,5.5751286,16.8345736,0.0003193,6.6689126,3.8263297,8.8625038,2.9127001,5.0402088,3.0702852,15.0383737),(5259,'radius-cleaned.tif',183,3,645,8.4016124,4.4596801,6.3618804,1.8,4.4605645,6.3792432,0.0168006,1.4601611,2.5255169,5.5925706,16.8372847,0.0003952,6.6668668,3.8301052,8.8678118,2.9127001,5.0465221,3.0545118,14.7642584),(5258,'radius-cleaned.tif',183,3,644,8.4026931,4.4574602,6.3647629,1.8,4.4572062,6.3810873,0.0174349,1.4632995,2.5291653,5.6056266,16.8286437,0.0004257,6.6538331,3.8308128,8.8384746,2.9127001,5.0540876,3.0387818,14.9335398),(5257,'radius-cleaned.tif',183,3,643,8.4197142,4.4565577,6.3677106,1.8,4.4579535,6.3826412,0.0182816,1.4665548,2.5301946,5.6162131,16.8577238,0.0004689,6.6626196,3.8295282,8.8520121,2.9424465,5.0465221,3.0545118,14.834377),(5256,'radius-cleaned.tif',183,3,642,8.4264649,4.4568881,6.3716658,1.8,4.4600546,6.3873843,0.0175899,1.4695631,2.5282455,5.6202778,16.8764077,0.0004345,6.6751458,3.8244548,8.8868504,2.9323857,5.0402088,3.0702852,14.5522414),(5255,'radius-cleaned.tif',183,3,641,8.4305168,4.4600844,6.376676,1.8,4.4682435,6.3927607,0.0181042,1.4746715,2.5250243,5.6258837,16.8712939,0.0004605,6.6816363,3.8150081,8.8994359,2.9495287,5.0465221,3.0545118,14.886794),(5254,'radius-cleaned.tif',183,3,640,8.4480216,4.4624997,6.3796372,1.8,4.4737994,6.3936332,0.0188917,1.4524466,2.5241556,5.6382907,16.9070596,0.0005024,6.6981052,3.8819263,8.9050012,2.9127001,5.0540876,3.0387818,14.5699431),(5253,'radius-cleaned.tif',183,3,639,8.4675282,4.4634371,6.382751,1.8,4.4751196,6.3955221,0.0186972,1.4529631,2.4862128,5.64574,16.9449314,0.0004933,6.8155594,3.8856734,8.9957359,2.9127001,5.0232818,3.0221637,14.8964754),(5252,'radius-cleaned.tif',183,3,638,8.4678205,4.4661404,6.3864635,1.8,4.4833714,6.3992489,0.0185113,1.4491516,2.5188373,5.6445516,16.9372419,0.0004836,6.7242302,3.8950732,8.9544398,2.9127001,5.057394,2.975147,14.8303669),(5251,'radius-cleaned.tif',183,3,637,8.4715662,4.465623,6.3911172,1.8,4.4845735,6.4048018,0.0190657,1.4779835,2.5193267,5.6445375,16.9203154,0.0005132,6.7162053,3.8190802,8.9490086,2.9526001,5.0465221,3.0545118,14.8634211),(5250,'radius-cleaned.tif',183,3,636,8.5035363,4.4658082,6.3948433,1.8,4.4880761,6.4074693,0.0196142,1.4556316,2.4839284,5.6541919,16.940121,0.0005452,6.8198909,3.8843564,9.0124077,2.9127001,5.0334132,3.006422,14.8166754),(5249,'radius-cleaned.tif',183,3,635,8.5215359,4.466804,6.3998104,1.8,4.4926783,6.4144119,0.0202231,1.4706398,2.4830387,5.6553386,16.9568136,0.0005808,6.8290574,3.8454954,8.9937716,2.9349137,5.0245493,2.9255077,14.353916),(5248,'radius-cleaned.tif',183,3,634,8.5381622,4.4654922,6.4036402,1.8,4.4920695,6.418535,0.0213401,1.467326,2.5194214,5.6678531,16.9516675,0.0006479,6.7283971,3.8627088,8.972809,2.9475484,5.0402088,3.0702852,14.754577),(5247,'radius-cleaned.tif',183,3,633,8.5249562,4.4616747,6.4068689,1.8,4.4872302,6.4203547,0.022426,1.469011,2.4869466,5.663436,16.9418914,0.0007144,6.812326,3.8552712,9.0429345,2.9412553,5.0245493,2.9255077,15.0093296),(5246,'radius-cleaned.tif',183,3,632,8.5011586,4.4570498,6.4117336,1.8,4.4785131,6.4271316,0.0230047,1.4686054,2.4934328,5.6751445,16.9222768,0.0007497,6.7867386,3.8643086,8.9917603,2.9506418,5.0394191,2.9504082,14.674777),(5245,'radius-cleaned.tif',183,3,631,8.4533608,4.4500393,6.4162113,1.8,4.4671368,6.4331267,0.0230845,1.4787838,2.5003632,5.6675251,16.8877362,0.0007507,6.7541132,3.8325582,8.9526197,2.9526001,5.0334132,3.006422,15.0948008),(5244,'radius-cleaned.tif',183,3,630,8.4336869,4.4471829,6.4194823,1.8,4.4624755,6.4367073,0.0233229,1.471986,2.5032161,5.6630185,16.8685424,0.0007645,6.7387479,3.8471959,8.93487,2.9526001,5.0232818,3.0221637,14.8303669),(5243,'radius-cleaned.tif',183,3,629,8.4227157,4.4449705,6.4238473,1.8,4.4596109,6.4419997,0.0242668,1.4548148,2.5075452,5.6625992,16.8980298,0.0008265,6.7388733,3.8923161,8.896467,2.9127001,5.0641574,2.9673769,14.9295296),(5242,'radius-cleaned.tif',183,3,628,8.4143601,4.4443789,6.42767,1.8,4.4581389,6.4463534,0.0254486,1.4791968,2.5084846,5.6652425,16.8933031,0.000908,6.7344656,3.8299451,8.8959123,2.9526001,5.0447867,2.9907473,14.9295296),(5241,'radius-cleaned.tif',183,3,627,8.4098015,4.4425652,6.4331225,1.8,4.4554768,6.4538315,0.026206,1.481569,2.5083444,5.6642069,16.8774535,0.0009624,6.7285233,3.8231137,8.9295166,2.9515303,5.0334132,3.006422,14.674777),(5240,'radius-cleaned.tif',183,3,626,8.4154157,4.4401795,6.4369452,1.8,4.4525941,6.4580811,0.027007,1.4716456,2.5108529,5.6684856,16.8830393,0.0010228,6.7240257,3.8518008,8.9095651,2.9526001,5.0245493,2.9255077,14.9859567),(5239,'radius-cleaned.tif',183,3,625,8.4071456,4.4402358,6.4414828,1.8,4.4535092,6.462897,0.0267629,1.4745141,2.5127426,5.6708065,16.8637099,0.0010034,6.7112763,3.8458815,8.8803014,2.9429957,5.0641574,2.9673769,15.0423839),(5238,'radius-cleaned.tif',183,3,624,8.4070776,4.4398341,6.4451403,1.8,4.4536656,6.466985,0.0281039,1.4679694,2.5135141,5.6761158,16.8992348,0.0011064,6.7233499,3.8666446,8.8971241,2.9495287,5.0447867,2.9907473,14.8634211),(5237,'radius-cleaned.tif',183,3,623,8.3970203,4.4365582,6.4485198,1.8,4.4473351,6.4699367,0.0269815,1.4728872,2.5141535,5.6863057,16.8984123,0.0010186,6.7213128,3.8606524,8.9328922,2.9526001,5.0334132,3.006422,15.0851195),(5236,'radius-cleaned.tif',183,3,622,8.3889873,4.437838,6.4522537,1.8,4.4489492,6.4728593,0.0279774,1.4739757,2.5130342,5.690284,16.9087789,0.0010941,6.7284317,3.8605005,8.9326365,2.9526001,5.0245493,2.9255077,14.5893058),(5235,'radius-cleaned.tif',183,3,621,8.383954,4.4384376,6.4559938,1.8,4.4495528,6.4756692,0.0286707,1.477911,2.5147952,5.6966898,16.8786015,0.0011483,6.71172,3.8545554,8.8984527,2.9526001,5.0334132,3.006422,15.0423839),(5234,'radius-cleaned.tif',183,3,620,8.3778746,4.4376744,6.4586866,1.8,4.4493974,6.4763917,0.0288605,1.4749261,2.5155439,5.6922197,16.8757338,0.0011627,6.7085824,3.8593254,8.8944277,2.9509743,5.0641574,2.9673769,14.6223601),(5233,'radius-cleaned.tif',183,3,619,8.3722711,4.4380047,6.4623008,1.8,4.4506556,6.4797678,0.030088,1.4702583,2.5131096,5.690392,16.8603528,0.0012628,6.7089604,3.870335,8.930833,2.9526001,5.0334132,3.006422,14.6650957),(5232,'radius-cleaned.tif',183,3,618,8.39835,4.4401604,6.4652422,1.8,4.4560156,6.482592,0.031924,1.4804504,2.5113071,5.7084537,16.8992854,0.001426,6.7292787,3.8558899,8.9484383,2.9526001,5.0334132,3.006422,14.7118414),(5231,'radius-cleaned.tif',183,3,617,8.4047874,4.4418037,6.470128,1.8,4.4606179,6.4871006,0.0330768,1.4920268,2.5097755,5.7028523,16.9078372,0.001532,6.7367927,3.8222185,8.9650055,2.9515303,5.0332551,2.9177647,14.9198482),(5230,'radius-cleaned.tif',183,3,616,8.4110666,4.4408311,6.4747085,1.8,4.4586981,6.4930585,0.035331,1.4804022,2.5139166,5.7015905,16.900992,0.0017492,6.7229724,3.8513794,8.9278568,2.9526001,5.0641574,2.9673769,14.834377),(5229,'radius-cleaned.tif',183,3,615,8.425512,4.4391706,6.4788342,1.8,4.4549304,6.4954897,0.0361042,1.4866088,2.5156579,5.7102744,16.9203343,0.0018297,6.7260077,3.8411412,8.9055738,2.9526001,5.05519,2.9349094,14.8674313),(5228,'radius-cleaned.tif',183,3,614,8.4405775,4.4387807,6.4844904,1.8,4.4538329,6.502595,0.0370638,1.4756753,2.5131613,5.7236933,16.935674,0.0019316,6.7387932,3.8786941,8.9535701,2.9526001,5.0583383,3.0309354,14.8440584),(5227,'radius-cleaned.tif',183,3,613,8.4525481,4.4389217,6.4890275,1.8,4.4522181,6.5072193,0.0395238,1.4805856,2.5133391,5.7390555,16.9571903,0.0021995,6.7468771,3.8762065,9.0029045,2.9526001,5.0394191,2.9504082,14.8731025),(5226,'radius-cleaned.tif',183,3,612,8.4633232,4.4381875,6.4919837,1.8,4.450537,6.5081544,0.041254,1.476119,2.5175752,5.7372231,16.9854636,0.0023993,6.7467552,3.8866942,8.9752103,2.9526001,5.0641574,2.9673769,14.674777),(5225,'radius-cleaned.tif',183,3,611,8.4914576,4.4346895,6.4953618,1.8,4.443288,6.5113426,0.0413532,1.4796635,2.5209571,5.7439169,17.0023387,0.0024188,6.7443983,3.8819075,8.9739976,2.9526001,5.0677714,3.0152845,14.7739398),(5224,'radius-cleaned.tif',183,3,610,8.532703,4.4293694,6.4987742,1.8,4.4333765,6.5143586,0.0416131,1.4817,2.5145797,5.7493666,17.0248965,0.0024612,6.7704739,3.8802502,8.9455485,2.9526001,5.0641574,2.9673769,14.674777),(5223,'radius-cleaned.tif',183,3,609,8.5450503,4.4299961,6.5046043,1.8,4.4356718,6.522678,0.0424334,1.4927328,2.5289224,5.7607908,17.0301709,0.0025628,6.7341611,3.8592244,8.9359009,2.975187,5.0641574,2.9673769,14.6086685),(5222,'radius-cleaned.tif',183,3,608,8.5458013,4.4288392,6.5084839,1.8,4.4336389,6.5270757,0.0437032,1.4901314,2.5268406,5.7763411,17.0329431,0.0027186,6.7408064,3.8763971,8.9849547,2.9820468,5.0394191,2.9504082,14.9432211),(5221,'radius-cleaned.tif',183,3,607,8.5075759,4.4258426,6.5113338,1.8,4.4293623,6.5285707,0.0437524,1.4931183,2.5297216,5.7667257,17.0355837,0.0027126,6.7341732,3.8622029,8.9731175,2.9652593,5.0677714,3.0152845,14.8110042),(5220,'radius-cleaned.tif',183,3,606,8.4746995,4.4274103,6.5164003,1.8,4.4356793,6.535872,0.0434617,1.4864232,2.4984043,5.7692798,17.0105983,0.0026663,6.8085852,3.8813172,8.9555409,2.9526001,5.0641574,2.9673769,15.0133398),(5219,'radius-cleaned.tif',183,3,605,8.4373784,4.429064,6.5193677,1.8,4.4409652,6.5365851,0.0451934,1.4897927,2.5300905,5.7635238,16.9972778,0.0028702,6.7180513,3.868675,8.9295889,2.9526001,5.0641574,2.9673769,14.8013228),(5218,'radius-cleaned.tif',183,3,604,8.4294369,4.4292396,6.5237021,1.8,4.4420348,6.5414529,0.0453163,1.485546,2.4953203,5.7726788,16.977385,0.0028831,6.8036898,3.8858971,8.9870703,2.9526001,5.0422615,2.9100489,14.5893058),(5217,'radius-cleaned.tif',183,3,603,8.467981,4.429688,6.5285445,1.8,4.4454698,6.5464497,0.0460097,1.4866588,2.5256264,5.7945473,16.9979172,0.0029855,6.7301787,3.8976983,8.969173,2.9526001,5.0533001,2.8698005,14.4998245),(5216,'radius-cleaned.tif',183,3,602,8.4998726,4.4307202,6.5306468,1.8,4.4484036,6.5456879,0.0470884,1.4853952,2.5247305,5.7881481,17.0394246,0.0031388,6.7490074,3.8967058,8.9886279,2.9526001,5.05519,2.9349094,14.4570888),(5215,'radius-cleaned.tif',183,3,601,8.5649607,4.4307948,6.5331288,1.8,4.4491466,6.5448648,0.0476034,1.5098599,2.4961847,5.8078147,17.0978335,0.0032324,6.8495868,3.8465917,9.0301862,2.9779339,5.0641574,2.9673769,14.7448957),(5214,'radius-cleaned.tif',183,3,600,8.5969534,4.4322843,6.5367674,1.8,4.4535409,6.5479033,0.0478631,1.5025953,2.4946397,5.8118328,17.1112304,0.0032799,6.859199,3.8678629,9.0451316,2.9925001,5.05519,2.9349094,14.7118414),(5213,'radius-cleaned.tif',183,3,599,8.6233517,4.4336868,6.5400628,1.8,4.457915,6.549488,0.0482213,1.5052739,2.5215537,5.81595,17.1646672,0.0033394,6.8071788,3.8637155,9.0081214,2.9925001,5.0710688,2.8870723,14.7118414),(5212,'radius-cleaned.tif',183,3,598,8.5940791,4.4320764,6.5452677,1.8,4.4582729,6.5557285,0.0479004,1.4998401,2.5228483,5.8168035,17.1581889,0.0032839,6.801118,3.8782824,9.0662094,2.9811127,5.05519,2.9349094,14.9432211),(5211,'radius-cleaned.tif',183,3,597,8.5462787,4.4260889,6.5494027,1.8,4.4470536,6.5590864,0.0491782,1.5019256,2.5288749,5.8052461,17.1666055,0.0034421,6.7882384,3.8652021,9.0486152,2.9925001,5.0677714,3.0152845,14.7876313),(5210,'radius-cleaned.tif',183,3,596,8.5238296,4.4235449,6.553668,1.8,4.4432938,6.5644701,0.0505813,1.4983808,2.5354978,5.8089759,17.1546456,0.0036316,6.7657899,3.8768355,9.0092166,2.9779339,5.0677714,3.0152845,14.5893058),(5209,'radius-cleaned.tif',183,3,595,8.4868132,4.4195328,6.5584829,1.8,4.437786,6.5705797,0.0508782,1.4955748,2.5076055,5.8067538,17.1282639,0.0036583,6.8305256,3.8826233,9.0224409,2.9526001,5.0509367,2.9829374,15.0367126),(5208,'radius-cleaned.tif',183,3,594,8.4560406,4.4168057,6.5622743,1.8,4.4332406,6.5743203,0.0517423,1.5025123,2.5146192,5.8031622,17.10048,0.0037698,6.8004252,3.8623059,8.9398277,2.9526001,5.0641574,2.9673769,14.9044957),(5207,'radius-cleaned.tif',183,3,593,8.4472043,4.4117236,6.5665077,1.8,4.4236603,6.5789519,0.053241,1.513619,2.520201,5.8237145,17.0839349,0.003987,6.7787987,3.8475433,8.927757,2.9915453,5.0721675,2.9195108,14.9762754),(5206,'radius-cleaned.tif',183,3,592,8.4304518,4.4086215,6.5692752,1.8,4.4198376,6.5811939,0.0530843,1.506403,2.5502176,5.8095466,17.0817356,0.0039557,6.6981482,3.8565686,8.9372584,2.9925001,5.0677714,3.0152845,14.9101669),(5205,'radius-cleaned.tif',183,3,591,8.4435885,4.4042769,6.573989,1.8,4.413999,6.586253,0.053984,1.512459,2.5545149,5.8230234,17.0877627,0.0040972,6.6892398,3.8500373,8.9322609,2.9915453,5.0677714,3.0152845,14.8206855),(5204,'radius-cleaned.tif',183,3,590,8.4898748,4.4012836,6.5778873,1.8,4.4079472,6.590462,0.0547462,1.5240306,2.5307254,5.8397917,17.1135226,0.0042367,6.7622994,3.8318075,8.9196864,2.9925001,5.0641574,2.9673769,14.7973126),(5203,'radius-cleaned.tif',183,3,589,8.5524027,4.393983,6.5824536,1.8,4.391823,6.5943585,0.0532485,1.51799,2.5370712,5.8615252,17.1415727,0.0040378,6.7564413,3.8613727,8.9181284,2.9925001,5.0635286,2.9271972,15.0286923),(5202,'radius-cleaned.tif',183,3,588,8.5653666,4.3917306,6.5860506,1.8,4.3904157,6.597524,0.0541697,1.5171023,2.539553,5.8724645,17.1645299,0.0041849,6.7588783,3.8708427,8.9265709,2.9925001,5.0785978,2.9519011,14.5796245),(5201,'radius-cleaned.tif',183,3,587,8.5450396,4.3905884,6.5894976,1.8,4.3918862,6.5993495,0.0546115,1.5095778,2.567481,5.8654735,17.1200863,0.0042433,6.6680478,3.885506,8.8950517,2.9925001,5.0721675,2.9195108,15.0423839),(5200,'radius-cleaned.tif',183,3,586,8.5028216,4.3874492,6.5928916,1.8,4.3884663,6.6017215,0.0567887,1.5074843,2.5708808,5.8661406,17.1045203,0.0045653,6.6531751,3.8913445,8.8823467,2.9925001,5.0677714,3.0152845,14.5368888),(5199,'radius-cleaned.tif',183,3,585,8.4496505,4.3850781,6.5989383,1.8,4.385801,6.6104317,0.0584668,1.5259463,2.5778964,5.8685714,17.0833379,0.0048085,6.6268519,3.845857,8.8537335,2.9925001,5.0641574,2.9673769,14.7876313),(5198,'radius-cleaned.tif',183,3,584,8.4119707,4.3823726,6.6036477,1.8,4.382595,6.6156248,0.0586138,1.53283,2.5498795,5.8624711,17.0613939,0.0048111,6.691059,3.8246061,8.8651692,3.0158266,5.0785978,2.9519011,14.8537398),(5197,'radius-cleaned.tif',183,3,583,8.3971567,4.3813538,6.6079185,1.8,4.3828803,6.6193617,0.0591897,1.5288419,2.5765592,5.8700682,17.0759451,0.0048974,6.6274219,3.8395522,8.8092789,2.9925001,5.0903395,2.9042184,14.6029973),(5196,'radius-cleaned.tif',183,3,582,8.3748281,4.3802768,6.6129784,1.8,4.3832565,6.6257824,0.0606824,1.5270117,2.5775971,5.8791479,17.0695353,0.0051335,6.6222667,3.8501002,8.8438301,2.9925001,5.0712258,2.959628,15.098811),(5195,'radius-cleaned.tif',183,3,581,8.3559566,4.3784462,6.6163816,1.8,4.3801418,6.6273046,0.060467,1.5233709,2.5791813,5.8798048,17.0692647,0.0050857,6.6180942,3.8597329,8.8673512,2.9925001,5.0677714,3.0152845,14.6554143),(5194,'radius-cleaned.tif',183,3,580,8.3369783,4.3773223,6.6217459,1.8,4.3796303,6.6332717,0.0606482,1.5204784,2.5848456,5.885845,17.084988,0.0051046,6.6096746,3.8710481,8.8472636,2.9925001,5.0677714,3.0152845,14.8110042),(5193,'radius-cleaned.tif',183,3,579,8.3145531,4.3766181,6.6260781,1.8,4.3820456,6.637391,0.0612735,1.5270265,2.5602701,5.8936627,17.0745732,0.0051962,6.6690515,3.8595679,8.8174956,3.0278159,5.0811049,2.9118509,15.0093296),(5192,'radius-cleaned.tif',183,3,578,8.3301489,4.3738387,6.6295863,1.8,4.3777567,6.6411767,0.0620553,1.540809,2.563201,5.9062344,17.0959523,0.0053395,6.6697666,3.8332033,8.8242878,3.0243384,5.0903395,2.9042184,14.834377),(5191,'radius-cleaned.tif',183,3,577,8.306242,4.3709789,6.6349402,1.8,4.3741602,6.6481648,0.0625017,1.5354871,2.56344,5.9113359,17.0678429,0.005401,6.6581793,3.8498115,8.8419824,3.0261827,5.0712258,2.959628,14.966594),(5190,'radius-cleaned.tif',183,3,576,8.2975032,4.3693949,6.6391977,1.8,4.3733794,6.6532089,0.0627047,1.5437305,2.592161,5.9142599,17.0334166,0.0054303,6.571126,3.8311479,8.820662,3.0324001,5.0677714,3.0152845,14.9996483),(5189,'radius-cleaned.tif',183,3,575,8.2705505,4.3661424,6.6438642,1.8,4.3712359,6.6580884,0.0643915,1.5399469,2.5954759,5.9156939,17.0342701,0.0057074,6.5630622,3.8414922,8.7765096,3.0324001,5.0903395,2.9042184,14.9004855),(5188,'radius-cleaned.tif',183,3,574,8.2664841,4.3645427,6.6467325,1.8,4.3695401,6.6602528,0.0660101,1.540641,2.5972227,5.9378647,17.0357561,0.0059946,6.5592204,3.8541522,8.7966982,3.0324001,5.0903395,2.9042184,14.966594),(5187,'radius-cleaned.tif',183,3,573,8.257029,4.3625499,6.6498226,1.8,4.3672785,6.6620221,0.0661795,1.5375399,2.6043186,5.933542,17.0341874,0.0060185,6.5407463,3.8591142,8.768286,2.9925001,5.0903395,2.9841758,14.914177),(5186,'radius-cleaned.tif',183,3,572,8.2370473,4.3603562,6.6533858,1.8,4.3669337,6.6652767,0.0672421,1.5372308,2.6012029,5.9470546,17.021889,0.0061979,6.5438527,3.8686805,8.7864547,3.0324001,5.0785978,2.9519011,14.8617601),(5185,'radius-cleaned.tif',183,3,571,8.2117918,4.3594085,6.6585619,1.8,4.3686634,6.6729892,0.0678881,1.5452007,2.6019226,5.9539618,17.0272334,0.0062981,6.5440968,3.8531964,8.7813733,3.0324001,5.0942474,2.9365168,15.1221839),(5184,'radius-cleaned.tif',183,3,570,8.1737101,4.3570499,6.6628486,1.8,4.3668808,6.6775557,0.0671663,1.5539342,2.603852,5.9458986,16.9785251,0.0061365,6.5205416,3.8263516,8.7562977,3.0324001,5.0785978,2.9519011,14.9762754),(5183,'radius-cleaned.tif',183,3,569,8.1853044,4.3535789,6.6678902,1.8,4.3625179,6.6837482,0.0673648,1.5487703,2.6123841,5.9732046,17.0070782,0.0061815,6.5101752,3.8567402,8.7537383,3.0324001,5.0903395,2.9841758,14.914177),(5182,'radius-cleaned.tif',183,3,568,8.1873697,4.350383,6.6730894,1.8,4.3604304,6.6903412,0.0676722,1.5462185,2.5862842,5.9913849,17.0316468,0.0062395,6.5853733,3.874863,8.7896555,3.0324001,5.0785978,2.9519011,15.1649195),(5181,'radius-cleaned.tif',183,3,567,8.19171,4.3481129,6.6775728,1.8,4.3595464,6.6942608,0.0679817,1.5417571,2.6119183,6.0033191,17.0776278,0.0063,6.5383469,3.8938163,8.7445091,3.0324001,5.0903395,2.9042184,15.2914652),(5180,'radius-cleaned.tif',183,3,566,8.1953646,4.3467981,6.6819558,1.8,4.361381,6.6995991,0.069567,1.5520053,2.613188,6.0204928,17.068111,0.0065997,6.5315282,3.8791701,8.8043389,3.0324001,5.0753052,2.8546539,15.0697669),(5179,'radius-cleaned.tif',183,3,565,8.1768471,4.3456155,6.6845607,1.8,4.3617133,6.6998046,0.068652,1.5486573,2.6195164,6.015055,17.0794603,0.006413,6.5200815,3.8840453,8.7800092,3.0324001,5.0903395,2.9841758,15.098811),(5178,'radius-cleaned.tif',183,3,564,8.1501124,4.3438851,6.6889582,1.8,4.3618267,6.704985,0.0702293,1.5599016,2.5927047,6.0155606,17.06611,0.0066886,6.5823577,3.8563718,8.7608903,3.0495188,5.0785978,2.9519011,14.5602617),(5177,'radius-cleaned.tif',183,3,563,8.1413062,4.341342,6.6932611,1.8,4.35885,6.7098145,0.0718351,1.5448518,2.6012858,6.0276159,17.0682912,0.0069899,6.5614826,3.9017438,8.7413668,3.0324001,5.0903395,2.9042184,14.9238584),(5176,'radius-cleaned.tif',183,3,562,8.1276605,4.3392087,6.6971276,1.8,4.3566979,6.7138267,0.0714389,1.5717956,2.6029541,6.0269919,17.0631031,0.0069015,6.5552838,3.834463,8.7354549,3.0324001,5.0812616,2.8794728,14.9569126),(5175,'radius-cleaned.tif',183,3,561,8.1176929,4.3372565,6.7014468,1.8,4.357032,6.7176389,0.0717947,1.5504013,2.6047549,6.0395001,17.0629452,0.0069618,6.5506914,3.8954432,8.7373365,3.0616979,5.0785978,2.9519011,14.7198617),(5174,'radius-cleaned.tif',183,3,560,8.093253,4.335053,6.7071371,1.8,4.3546358,6.7256762,0.0717677,1.5645844,2.6291632,6.0442761,17.053673,0.0069356,6.48635,3.8631831,8.7177332,3.0324001,5.0942474,2.9365168,15.4140008),(5173,'radius-cleaned.tif',183,3,559,8.0686147,4.3327593,6.7111534,1.8,4.3528339,6.7292316,0.0711017,1.5599665,2.6310274,6.0527344,17.0658873,0.006787,6.4863967,3.8800413,8.7222815,3.0324001,5.0942474,2.9365168,15.310828),(5172,'radius-cleaned.tif',183,3,558,8.0605558,4.3300179,6.7181062,1.8,4.3506911,6.7393835,0.0713606,1.5558549,2.6105897,6.0701416,17.0706317,0.0068296,6.5389944,3.9014831,8.7288117,3.0324001,5.0917467,2.8719042,14.7916414),(5171,'radius-cleaned.tif',183,3,557,8.0663712,4.3284545,6.7218986,1.8,4.3502864,6.7426388,0.072507,1.5527717,2.6406084,6.0846205,17.0755667,0.0070555,6.4665275,3.9185544,8.7254467,3.0723001,5.0903395,2.9841758,15.2116652),(5170,'radius-cleaned.tif',183,3,556,8.0666636,4.3262541,6.7272809,1.8,4.3492784,6.7488455,0.0734534,1.5730621,2.6426618,6.0987543,17.0985259,0.0072408,6.4701908,3.8769951,8.693624,3.0616979,5.0917467,2.8719042,14.8053329),(5169,'radius-cleaned.tif',183,3,555,8.063096,4.3260076,6.732465,1.8,4.3501452,6.7548215,0.0741357,1.588903,2.6486121,6.121562,17.1115834,0.0073724,6.460585,3.8526971,8.7028634,3.0723001,5.1177876,2.9533711,15.1689296),(5168,'radius-cleaned.tif',183,3,554,8.0595332,4.3270046,6.736682,1.8,4.3535106,6.758888,0.0756316,1.585937,2.647796,6.1438582,17.1188135,0.007669,6.4653068,3.8739611,8.7198374,3.0723001,5.1110951,2.9212302,15.0036584),(5167,'radius-cleaned.tif',183,3,553,8.0605399,4.3268932,6.7414018,1.8,4.3544941,6.7641078,0.0761787,1.5846844,2.6477259,6.1623087,17.1283739,0.0077811,6.4690888,3.8886662,8.6726554,3.0723001,5.1110951,2.9212302,14.8811228),(5166,'radius-cleaned.tif',183,3,552,8.0652101,4.3237635,6.7459743,1.8,4.3496476,6.7688317,0.0765516,1.5801905,2.6567187,6.1892159,17.1322671,0.0078618,6.4486569,3.9167531,8.6835221,3.0723001,5.1177876,2.9533711,15.1689296),(5165,'radius-cleaned.tif',183,3,551,8.0790513,4.3248891,6.7505562,1.8,4.3521582,6.7736224,0.077212,1.5793239,2.6431916,6.2124026,17.1829061,0.0080115,6.5008175,3.9335837,8.7612249,3.0723001,5.0984645,2.8396415,15.0407228),(5164,'radius-cleaned.tif',183,3,550,8.0723071,4.3262418,6.7563399,1.8,4.3560501,6.7809835,0.0784657,1.5769798,2.6479288,6.2307846,17.1890344,0.0082664,6.4915016,3.9510872,8.7805296,3.108831,5.1034581,2.968732,14.9746143),(5163,'radius-cleaned.tif',183,3,549,8.0854936,4.3274051,6.7617393,1.8,4.3598721,6.7872854,0.0798446,1.580167,2.6467481,6.2506034,17.226366,0.0085728,6.5085023,3.9556599,8.7621697,3.0723001,5.1110951,2.9212302,15.1826211),(5162,'radius-cleaned.tif',183,3,548,8.0908835,4.3253313,6.7663148,1.8,4.3566771,6.7918292,0.0805904,1.5761645,2.6550865,6.2627695,17.2601374,0.0087392,6.5007816,3.9734238,8.7769065,3.0723001,5.1179431,3.0007981,15.2954754),(5161,'radius-cleaned.tif',183,3,547,8.0922115,4.3231468,6.771345,1.8,4.3507201,6.7974756,0.0825103,1.6027291,2.6575404,6.288718,17.268221,0.0091611,6.4978206,3.923756,8.7872212,3.0723001,5.1179431,3.0007981,15.0270313),(5160,'radius-cleaned.tif',183,3,546,8.0876658,4.322571,6.7748321,1.8,4.3514058,6.7990943,0.0820021,1.5857054,2.6576492,6.3038393,17.2842695,0.0090437,6.5035933,3.9754165,8.7261838,3.0723001,5.1483372,2.890975,15.2817839),(5159,'radius-cleaned.tif',183,3,545,8.0959051,4.3227007,6.7806612,1.8,4.3519965,6.8057232,0.0833328,1.5841369,2.6641407,6.3150368,17.3277859,0.0093485,6.5040805,3.986421,8.7524361,3.0723001,5.1333177,2.9380996,15.1592483),(5158,'radius-cleaned.tif',183,3,544,8.0927338,4.3212148,6.7869562,1.8,4.3507645,6.8124132,0.084741,1.578754,2.665678,6.3199315,17.3550703,0.0096625,6.5105652,4.0031135,8.7780486,3.0723001,5.1333177,2.9380996,14.9842957),(5157,'radius-cleaned.tif',183,3,543,8.0910044,4.3204995,6.7927621,1.8,4.3498413,6.8185116,0.0860606,1.5964598,2.6595715,6.3291811,17.365362,0.0099629,6.5293835,3.9645102,8.8201613,3.1024558,5.1179431,3.0007981,15.3148381),(5156,'radius-cleaned.tif',183,3,542,8.0894943,4.3195007,6.7983206,1.8,4.347988,6.8248253,0.0871609,1.5914004,2.6604347,6.3467161,17.4230492,0.0102168,6.5489482,3.9881328,8.8063311,3.1109784,5.1483372,2.890975,15.2293669),(5155,'radius-cleaned.tif',183,3,541,8.0953114,4.3200299,6.8031321,1.8,4.350333,6.8298887,0.087491,1.6042547,2.6595903,6.3678083,17.4498026,0.0103015,6.5610867,3.9693249,8.8302662,3.1122001,5.1333177,2.9380996,15.2293669),(5154,'radius-cleaned.tif',183,3,540,8.1126903,4.319616,6.807543,1.8,4.3522812,6.8345708,0.0893921,1.6011738,2.667312,6.385621,17.5322755,0.0107759,6.5730126,3.9880874,8.8703152,3.1122001,5.1427681,2.9700665,15.0504042),(5153,'radius-cleaned.tif',183,3,539,8.1252798,4.3215181,6.8141346,1.8,4.3569536,6.8424856,0.0906462,1.6101217,2.665292,6.4115712,17.5780928,0.0110968,6.5951845,3.9820413,8.8311102,3.1316958,5.1518921,2.8590377,14.9415601),(5152,'radius-cleaned.tif',183,3,538,8.1472953,4.3246176,6.8189922,1.8,4.3639904,6.8470816,0.0925862,1.6248412,2.6698425,6.4443536,17.649993,0.0116068,6.6108743,3.9661436,8.8842216,3.1438787,5.1687059,2.8760177,15.4220211),(5151,'radius-cleaned.tif',183,3,537,8.1900563,4.325454,6.8256494,1.8,4.3672648,6.8545533,0.0924482,1.6182032,2.6683347,6.48041,17.727262,0.0116331,6.6435676,4.0046948,8.935413,3.1521001,5.1569883,2.9548188,15.4317025),(5150,'radius-cleaned.tif',183,3,536,8.2144304,4.3244775,6.8322227,1.8,4.3656329,6.8615547,0.0935209,1.6159658,2.669154,6.4910467,17.8084103,0.0119392,6.6719306,4.0168217,8.9729002,3.1122001,5.1569883,2.9548188,15.3752754),(5149,'radius-cleaned.tif',183,3,535,8.2247732,4.3237157,6.8369105,1.8,4.3652594,6.8647744,0.0938268,1.6114308,2.6770785,6.5265877,17.8479445,0.0120324,6.6669486,4.0501819,8.9528639,3.1122001,5.1687059,2.8760177,15.3188483),(5148,'radius-cleaned.tif',183,3,534,8.2458772,4.3237543,6.8426406,1.8,4.3653111,6.8707112,0.0935652,1.6266419,2.676375,6.5450399,17.9452491,0.0119963,6.7050579,4.0236513,9.0006637,3.1460024,5.1870001,2.8928827,15.3188483),(5147,'radius-cleaned.tif',183,3,533,8.2587326,4.3228217,6.8485576,1.8,4.3643466,6.8755494,0.0944533,1.6210739,2.6771799,6.5699687,17.9957134,0.0122435,6.7218918,4.0528496,9.0307004,3.1521001,5.1870001,2.8928827,15.4413839),(5146,'radius-cleaned.tif',183,3,532,8.2663805,4.3220397,6.8548179,1.8,4.3627544,6.8818749,0.094575,1.6261277,2.6698901,6.5801691,18.0071728,0.0122863,6.7445372,4.0465267,9.0114811,3.1473596,5.1747086,2.8442275,15.2293669),(5145,'radius-cleaned.tif',183,3,531,8.269123,4.3197637,6.8609699,1.8,4.3579932,6.8865526,0.0949402,1.6199993,2.6792818,6.6151758,18.0389427,0.0123852,6.7327529,4.0834435,9.0354145,3.1521001,5.1747086,2.8442275,15.4744381),(5144,'radius-cleaned.tif',183,3,530,8.2589672,4.319808,6.8682302,1.8,4.3568478,6.8964342,0.0965023,1.6341697,2.6792663,6.6294153,18.0548387,0.0127791,6.738725,4.0567485,9.0543358,3.1839083,5.1889947,2.9245918,15.4083296),(5143,'radius-cleaned.tif',183,3,529,8.2665939,4.3191858,6.8744786,1.8,4.3531415,6.9025999,0.0966367,1.6279406,2.6908935,6.6522312,18.1161802,0.0128265,6.7324034,4.0862861,9.00264,3.1884822,5.2177547,2.8706458,15.4357127),(5142,'radius-cleaned.tif',183,3,528,8.2744826,4.3189101,6.8804522,1.8,4.3522939,6.9087127,0.0988039,1.6424536,2.7157679,6.6753698,18.1812258,0.0134191,6.6946907,4.0642668,9.0405712,3.1920001,5.2122598,2.7980538,15.5969737),(5141,'radius-cleaned.tif',183,3,527,8.2771346,4.3165911,6.8863152,1.8,4.346536,6.9153143,0.0993089,1.6366765,2.717693,6.7095549,18.2205142,0.0135605,6.7044048,4.0994998,9.0666938,3.1920001,5.2037006,2.9487083,15.6106652),(5140,'radius-cleaned.tif',183,3,526,8.2493723,4.3130171,6.8913445,1.8,4.338204,6.9211359,0.0986846,1.6352916,2.7205119,6.7217907,18.207397,0.0133462,6.6926364,4.1104539,8.9807624,3.1920001,5.2246153,2.8391634,15.4590855),(5139,'radius-cleaned.tif',183,3,525,8.2402778,4.3150281,6.8962052,1.8,4.3418634,6.9251688,0.0999051,1.6508947,2.7264514,6.7378837,18.2419231,0.0136622,6.69072,4.0813529,9.0102264,3.1920001,5.225834,2.7908647,15.4317025),(5138,'radius-cleaned.tif',183,3,524,8.2472385,4.3172443,6.9035392,1.8,4.3459828,6.9345356,0.0996963,1.6515815,2.7234212,6.7662644,18.2962435,0.0136168,6.71811,4.0968395,9.0545337,3.1920001,5.2366376,2.8077945,15.4026584),(5137,'radius-cleaned.tif',183,3,523,8.2348533,4.315176,6.9085028,1.8,4.3411632,6.9370241,0.1001726,1.6666176,2.7251961,6.792469,18.283522,0.0137262,6.7090665,4.0756014,9.0581142,3.1920001,5.2195851,2.9337027,15.6340381),(5136,'radius-cleaned.tif',183,3,522,8.2356263,4.3145896,6.9141963,1.8,4.3403101,6.942866,0.100662,1.6612269,2.7334427,6.8196534,18.3182023,0.0138615,6.7015132,4.1051909,9.0377554,3.2319001,5.2396769,2.8559709,15.5211839),(5135,'radius-cleaned.tif',183,3,521,8.2556294,4.3178783,6.9195997,1.8,4.345761,6.9476372,0.101071,1.6840795,2.7298357,6.839103,18.4103147,0.0140079,6.7441108,4.0610334,9.0931623,3.2319001,5.2396769,2.8559709,15.5445567),(5134,'radius-cleaned.tif',183,3,520,8.2850178,4.322854,6.9258327,1.8,4.357145,6.9557027,0.1014678,1.6786045,2.7244557,6.8624818,18.5015972,0.014168,6.7909334,4.0882064,9.155969,3.2319001,5.2562099,2.8726775,15.6477296),(5133,'radius-cleaned.tif',183,3,519,8.3033105,4.3265151,6.9308127,1.8,4.3642224,6.9611354,0.10292,1.6789446,2.7292263,6.8827367,18.5780721,0.0146072,6.8070839,4.0994423,9.1303572,3.2319001,5.2562099,2.8726775,15.657411),(5132,'radius-cleaned.tif',183,3,518,8.3097876,4.3256032,6.9357095,1.8,4.3605577,6.9666306,0.1034698,1.6743128,2.7216996,6.911214,18.6316002,0.0147746,6.8455756,4.1277913,9.1859401,3.2319001,5.2498456,2.8006137,15.6146754),(5131,'radius-cleaned.tif',183,3,517,8.2980239,4.322855,6.9430306,1.8,4.3543145,6.9754338,0.1037127,1.6941869,2.7237932,6.9424412,18.6208312,0.0148228,6.8363602,4.0978012,9.2097041,3.2582636,5.2489357,2.8246498,15.5445567),(5130,'radius-cleaned.tif',183,3,516,8.304023,4.3229893,6.9495271,1.8,4.3534113,6.9827797,0.1040656,1.6879085,2.7231534,6.976774,18.6720525,0.0149343,6.856776,4.133384,9.158195,3.2631398,5.2743515,2.810273,15.9161737),(5129,'radius-cleaned.tif',183,3,515,8.3213143,4.3228719,6.9553564,1.8,4.3503628,6.9888201,0.1044213,1.7030634,2.7375594,7.0235829,18.71797,0.0150674,6.8374662,4.1240879,9.1976968,3.2714926,5.2633229,2.7934693,15.8791093),(5128,'radius-cleaned.tif',183,3,514,8.3147545,4.3225842,6.9606536,1.8,4.3472981,6.9936046,0.1049215,1.7022826,2.7541161,7.0517579,18.7434991,0.0151996,6.8056314,4.1425307,9.2221251,3.2718001,5.2633229,2.7934693,15.4163499),(5127,'radius-cleaned.tif',183,3,513,8.3078644,4.3219416,6.9670212,1.8,4.345869,6.9989732,0.1068853,1.7199332,2.7548046,7.1008938,18.7515895,0.0157587,6.8068672,4.128587,9.2014085,3.2983607,5.2770674,2.7863618,15.8363737),(5126,'radius-cleaned.tif',183,3,512,8.2948844,4.3254804,6.9736233,1.8,4.3475705,7.0065051,0.1089713,1.7192392,2.7513181,7.1172445,18.7819378,0.0163517,6.8265235,4.1397639,9.1889549,3.2718001,5.3008469,2.7960371,15.7235195),(5125,'radius-cleaned.tif',183,3,511,8.2980305,4.3306711,6.9798832,1.8,4.3542614,7.0122023,0.1107365,1.7146317,2.7548999,7.1494858,18.8600204,0.01689,6.8459912,4.1696918,9.2515371,3.2718001,5.2868631,2.8270019,15.3696042),(5124,'radius-cleaned.tif',183,3,510,8.3165384,4.335933,6.9861779,1.8,4.3611935,7.0184331,0.1124551,1.7362006,2.7496808,7.1774005,18.9344354,0.0174549,6.8860484,4.1339696,9.2624408,3.3117001,5.299345,2.8198421,15.6477296),(5123,'radius-cleaned.tif',183,3,509,8.3204957,4.3375709,6.9911073,1.8,4.3597096,7.0219297,0.1126239,1.7315663,2.7475681,7.2065331,18.9915465,0.0175155,6.9121294,4.161858,9.3042188,3.3117001,5.3008469,2.7960371,15.8363737),(5122,'radius-cleaned.tif',183,3,508,8.3279588,4.3396205,6.997855,1.8,4.3600336,7.031,0.1128029,1.7386511,2.7762833,7.2497193,19.0344797,0.0175867,6.8561013,4.1697377,9.20023,3.3117001,5.3519572,2.7915478,15.5058313),(5121,'radius-cleaned.tif',183,3,507,8.3348975,4.3424645,7.0055923,1.8,4.3625295,7.0395213,0.1139982,1.7456155,2.7733812,7.3051859,19.0985558,0.0179748,6.8863796,4.1848768,9.2593275,3.3516001,5.3437707,2.8694468,15.9258551),(5120,'radius-cleaned.tif',183,3,506,8.3446664,4.3454502,7.0145758,1.8,4.3632614,7.0510118,0.1141711,1.7495216,2.7695061,7.3720304,19.1506789,0.0180502,6.9148355,4.2137408,9.3202203,3.3516001,5.3507672,2.8387078,15.7839568),(5119,'radius-cleaned.tif',183,3,505,8.3564897,4.3522593,7.0214352,1.8,4.3727652,7.0572751,0.1161873,1.7702136,2.7843903,7.4306925,19.219612,0.0187169,6.9026287,4.1976249,9.3938738,3.3915001,5.3507672,2.8387078,15.604994),(5118,'radius-cleaned.tif',183,3,504,8.3797616,4.3580177,7.0273722,1.8,4.3807784,7.0622391,0.1172578,1.7653743,2.7878241,7.4812778,19.2847847,0.0191149,6.917504,4.2377857,9.4139114,3.3915001,5.3657714,2.7845626,15.8734381),(5117,'radius-cleaned.tif',183,3,503,8.3915037,4.3618115,7.0338334,1.8,4.3824161,7.0679584,0.1184915,1.7834376,2.7839701,7.5306945,19.3720757,0.0195447,6.9584353,4.2225724,9.4344361,3.3778667,5.3894549,2.7940867,15.896811),(5116,'radius-cleaned.tif',183,3,502,8.396221,4.3632349,7.038136,1.8,4.3810201,7.0693753,0.119672,1.7800002,2.78268,7.5647196,19.4383502,0.0199454,6.9854781,4.2498419,9.4309861,3.3915001,5.3876822,2.8175002,15.8928008),(5115,'radius-cleaned.tif',183,3,501,8.4027409,4.3665632,7.0450295,1.8,4.3841564,7.0780543,0.1208183,1.7993856,2.7887729,7.6065247,19.5160009,0.0203433,6.9980602,4.22729,9.4914102,3.4203246,5.3888641,2.8409163,16.1612449),(5114,'radius-cleaned.tif',183,3,500,8.4136647,4.3677466,7.0503203,1.8,4.3842222,7.0843073,0.1220101,1.8190845,2.8078502,7.6443836,19.6133714,0.0207716,6.9851914,4.2023246,9.5489219,3.4314001,5.3894549,2.7940867,16.2507263),(5113,'radius-cleaned.tif',183,3,499,8.4269999,4.369743,7.0564619,1.8,4.3865503,7.0920766,0.1238748,1.8144267,2.80591,7.687891,19.7004157,0.021442,7.0210432,4.2370909,9.5316005,3.4314001,5.4388546,2.836082,15.8871296),(5112,'radius-cleaned.tif',183,3,498,8.432703,4.3735898,7.0624723,1.8,4.392472,7.099166,0.1255367,1.815001,2.822019,7.7050648,19.8408295,0.022033,7.0307215,4.2452125,9.5687168,3.4538681,5.4512806,2.8059541,16.2547365),(5111,'radius-cleaned.tif',183,3,497,8.4244795,4.3732848,7.0667126,1.8,4.392287,7.1011888,0.1268904,1.8116756,2.8225522,7.7314265,19.923922,0.0224863,7.058832,4.2675557,9.6005451,3.4713001,5.4388546,2.836082,15.976611),(5110,'radius-cleaned.tif',183,3,496,8.4123447,4.3730463,7.0720048,1.8,4.3897668,7.1063236,0.1286962,1.8318257,2.842204,7.7385697,20.016184,0.023094,7.0424869,4.2245119,9.5626371,3.4314001,5.4651351,2.8452408,16.0951365),(5109,'radius-cleaned.tif',183,3,495,8.4070436,4.3723957,7.0782199,1.8,4.3867039,7.1138082,0.1314118,1.8270699,2.8535311,7.7608226,20.1021555,0.024058,7.0446597,4.2476879,9.6048789,3.4713001,5.4769201,2.8382732,16.1458924),(5108,'radius-cleaned.tif',183,3,494,8.390288,4.3733127,7.0843083,1.8,4.3864388,7.1216525,0.1326534,1.8349963,2.8523758,7.7725358,20.1198094,0.0244632,7.0537022,4.2357229,9.6246837,3.4713001,5.4889699,2.8083484,16.2079907),(5107,'radius-cleaned.tif',183,3,493,8.390309,4.3751365,7.0908608,1.8,4.3846881,7.1289821,0.1349933,1.8383388,2.8507143,7.8068306,20.2185507,0.0253286,7.0924507,4.2466768,9.5919243,3.4713001,5.5012827,2.8244292,16.108828),(5106,'radius-cleaned.tif',183,3,492,8.3905708,4.3774245,7.0984087,1.8,4.3855382,7.1388323,0.1365496,1.8609297,2.8589481,7.8507483,20.3232262,0.0259131,7.1086376,4.2187238,9.6587755,3.4713001,5.5012827,2.8244292,16.3869534),(5105,'radius-cleaned.tif',183,3,491,8.3994523,4.3823273,7.1060423,1.8,4.393654,7.1479705,0.1378099,1.8603015,2.8536673,7.8894792,20.4431138,0.0264186,7.1638042,4.240968,9.6404647,3.4713001,5.5292822,2.7878895,16.589289),(5104,'radius-cleaned.tif',183,3,490,8.4223604,4.3850472,7.1117031,1.8,4.3955157,7.1538079,0.1389536,1.8558276,2.8673234,7.9409212,20.5538871,0.0269293,7.1683184,4.2789111,9.7110537,3.5112001,5.5415054,2.8494462,16.3345365),(5103,'radius-cleaned.tif',183,3,489,8.3977236,4.3886897,7.1159227,1.8,4.4013115,7.1578072,0.1408919,1.8649327,2.8813681,7.9500666,20.6046569,0.0275998,7.1509979,4.2629242,9.7479666,3.5112001,5.5432289,2.7811371,16.0604212),(5102,'radius-cleaned.tif',183,3,488,8.3949479,4.3911764,7.1216262,1.8,4.4032549,7.1633188,0.1424157,1.8603395,2.8787394,7.9789703,20.692412,0.0281867,7.1880115,4.2889861,9.7279593,3.5112001,5.5516948,2.8198421,15.9903025),(5101,'radius-cleaned.tif',183,3,487,8.3977169,4.3945244,7.1285078,1.8,4.4060681,7.1706658,0.1446525,1.8722935,2.8868565,8.0128081,20.7977718,0.0290824,7.2042971,4.2796752,9.793764,3.5112001,5.5650132,2.8357138,16.2120009),(5100,'radius-cleaned.tif',183,3,486,8.4114839,4.3940313,7.1346455,1.8,4.4013908,7.1769425,0.1467681,1.8673716,2.8874563,8.0530106,20.9274403,0.0299823,7.2477079,4.3124842,9.8572939,3.5112001,5.5650132,2.8357138,16.4901263),(5099,'radius-cleaned.tif',183,3,485,8.4237356,4.3978357,7.1411413,1.8,4.4069307,7.1841129,0.1500681,1.8693737,2.9081133,8.0931171,21.0609246,0.0313811,7.2421265,4.3293202,9.8112489,3.5112001,5.6151367,2.8086066,16.5368721),(5098,'radius-cleaned.tif',183,3,484,8.4397155,4.4012895,7.1474871,1.8,4.4099261,7.1907574,0.1526535,1.8652081,2.9053032,8.1352824,21.2098246,0.0325247,7.3003825,4.361595,9.8936937,3.5363169,5.6151367,2.8086066,16.4707636),(5097,'radius-cleaned.tif',183,3,483,8.4405969,4.4047441,7.153702,1.8,4.4146184,7.1975475,0.1529071,1.8779792,2.9162192,8.1615589,21.316179,0.0326355,7.3095257,4.3459261,9.8613133,3.5511001,5.6274563,2.8243264,16.5465534),(5096,'radius-cleaned.tif',183,3,482,8.4402437,4.4055902,7.1597437,1.8,4.4132774,7.2023163,0.1527611,1.8932501,2.9144012,8.1961837,21.440466,0.0325723,7.3567311,4.3291605,9.924488,3.5511001,5.6283049,2.8019068,16.669089),(5095,'radius-cleaned.tif',183,3,481,8.4379307,4.4077939,7.1651325,1.8,4.4135346,7.2062404,0.1557903,1.890118,2.9250336,8.2318997,21.5450107,0.0338571,7.365731,4.3552306,9.9849329,3.5511001,5.6411603,2.8399736,16.480445),(5094,'radius-cleaned.tif',183,3,480,8.4391926,4.4112732,7.1732453,1.8,4.4172571,7.2167068,0.158211,1.8841276,2.9466342,8.2649503,21.6547586,0.0349137,7.348981,4.3866193,9.9296748,3.5112001,5.6906131,2.8131903,16.6537365),(5093,'radius-cleaned.tif',183,3,479,8.4515516,4.4157994,7.1789269,1.8,4.422697,7.2223021,0.1613001,1.8875326,2.9633434,8.3018971,21.8189096,0.0363316,7.3629367,4.3982801,10.0172513,3.5794693,5.6676263,2.8487872,16.4650924),(5092,'radius-cleaned.tif',183,3,478,8.4434295,4.4198607,7.1860029,1.8,4.4284367,7.2303616,0.1625082,1.9019981,2.9587819,8.3120028,21.9277649,0.0368376,7.4110784,4.3701425,9.9800351,3.5511001,5.6928507,2.7910252,16.4320381),(5091,'radius-cleaned.tif',183,3,477,8.4493755,4.4193434,7.191856,1.8,4.4243887,7.2355066,0.1650916,1.8843691,2.9726781,8.3456727,22.0589028,0.0380342,7.4205488,4.4288949,10.0402052,3.5511001,5.7066766,2.7844586,16.3619195),(5090,'radius-cleaned.tif',183,3,476,8.4706137,4.4213291,7.1974357,1.8,4.427544,7.2408495,0.1673156,1.9001311,2.9709989,8.3837713,22.2236391,0.0391544,7.480191,4.4122068,10.069484,3.5910001,5.7303403,2.7934165,16.7625806),(5089,'radius-cleaned.tif',183,3,475,8.4840489,4.4252294,7.20501,1.8,4.4316863,7.2512566,0.168448,1.8939526,3.0058227,8.436879,22.3717027,0.0397441,7.4427885,4.454641,10.085037,3.5511001,5.75446,2.8023,16.8093263),(5088,'radius-cleaned.tif',183,3,474,8.4801982,4.4297271,7.2117246,1.8,4.4346861,7.2587672,0.1698868,1.8968015,3.0009964,8.4644873,22.5280362,0.040401,7.5068521,4.4625057,10.134865,3.5511001,5.744076,2.8527972,16.1014957),(5087,'radius-cleaned.tif',183,3,473,8.473149,4.4347325,7.220549,1.8,4.4404152,7.2696739,0.1717151,1.8905119,2.9970735,8.4920558,22.6559505,0.0412323,7.5593576,4.4919345,10.0921706,3.5910001,5.7815088,2.7892839,16.3659296),(5086,'radius-cleaned.tif',183,3,472,8.4973325,4.4393114,7.2263596,1.8,4.4443284,7.2745523,0.1744745,1.9064449,3.0051668,8.5385486,22.8642544,0.042676,7.6083147,4.4787808,10.1962782,3.5910001,5.7953979,2.782822,16.7295263),(5085,'radius-cleaned.tif',183,3,471,8.5110464,4.4442963,7.233989,1.8,4.4511707,7.2831295,0.1776713,1.9021339,3.0288931,8.5792732,23.0553531,0.044309,7.6118081,4.5103414,10.1756835,3.5910001,5.8430006,2.8004061,16.8560721),(5084,'radius-cleaned.tif',183,3,470,8.5042977,4.4467605,7.2389298,1.8,4.4521272,7.2860534,0.1796603,1.9170253,3.037711,8.6108113,23.1945167,0.0452599,7.6355244,4.4917568,10.2444629,3.5910001,5.8430006,2.8004061,16.8326992),(5083,'radius-cleaned.tif',183,3,469,8.5128737,4.4498148,7.2457747,1.8,4.4539561,7.2934548,0.1825708,1.9125946,3.0349825,8.6512241,23.3877167,0.0467688,7.7060466,4.5232921,10.3380036,3.6309001,5.829498,2.8284999,16.747228),(5082,'radius-cleaned.tif',183,3,468,8.5050895,4.4510631,7.252796,1.8,4.4511031,7.3006361,0.1850653,1.9246098,3.0802893,8.6887373,23.5616842,0.047997,7.6491789,4.5145449,10.2969503,3.6309001,5.8816987,2.8455875,17.2139975),(5081,'radius-cleaned.tif',183,3,467,8.5058345,4.4535407,7.2607603,1.8,4.4526151,7.309129,0.1865031,1.9179226,3.0771345,8.7316542,23.7382103,0.0487412,7.7143882,4.5526624,10.3847423,3.6309001,5.8972417,2.8605049,16.8971466),(5080,'radius-cleaned.tif',183,3,466,8.5319111,4.4583153,7.2700899,1.8,4.4585117,7.3196043,0.1877945,1.9177096,3.086265,8.8118656,23.9334991,0.0495621,7.7548426,4.5949947,10.3953799,3.6610579,5.9214882,2.7836106,17.0584077),(5079,'radius-cleaned.tif',183,3,465,8.5401755,4.4635337,7.2758958,1.8,4.4650164,7.3244022,0.1905047,1.9143948,3.0891652,8.8558514,24.1096164,0.0510348,7.8045734,4.6259274,10.4698236,3.6568872,5.9429575,2.8134728,17.039045),(5078,'radius-cleaned.tif',183,3,464,8.5542649,4.4648269,7.282291,1.8,4.4637861,7.3313247,0.1915269,1.916488,3.1036837,8.9073949,24.2859431,0.0516624,7.824877,4.6477697,10.4521735,3.6610579,5.9434932,2.834703,17.1422178),(5077,'radius-cleaned.tif',183,3,463,8.558336,4.4680467,7.2880606,1.8,4.4673926,7.3371714,0.1944553,1.9130784,3.1162063,8.9423643,24.4893508,0.0532595,7.8587064,4.6743323,10.5446244,3.6853793,5.9580736,2.8494944,17.2180077),(5076,'radius-cleaned.tif',183,3,462,8.5702784,4.4707944,7.2944822,1.8,4.4662083,7.3444036,0.1957912,1.9239084,3.1598789,8.9924289,24.6963872,0.0540597,7.815612,4.674042,10.4976781,3.6920644,6.0185551,2.8177457,17.1051535),(5075,'radius-cleaned.tif',183,3,461,8.5878106,4.4770341,7.3007995,1.8,4.4736977,7.3499324,0.1982361,1.9203411,3.1538777,9.0313805,24.9272177,0.0555137,7.903673,4.7030085,10.5801781,3.6882272,6.0233145,2.8596533,17.519506),(5074,'radius-cleaned.tif',183,3,460,8.6060008,4.4830342,7.3087343,1.8,4.4799929,7.3585262,0.1999982,1.9305641,3.1547781,9.074355,25.1448424,0.0566114,7.9703996,4.7003647,10.6902112,3.6998013,6.0316345,2.8323937,17.3308619),(5073,'radius-cleaned.tif',183,3,459,8.6113676,4.4888147,7.3147591,1.8,4.4833567,7.3645562,0.2018665,1.9511666,3.1805945,9.1101603,25.404787,0.0576956,7.9874336,4.6690838,10.6858386,3.7107001,6.0616493,2.8614847,17.2083263),(5072,'radius-cleaned.tif',183,3,458,8.603446,4.4956471,7.3210766,1.8,4.4881505,7.3721685,0.2044372,1.9485281,3.1739399,9.1561421,25.5449531,0.0590993,8.0483418,4.6990043,10.7201518,3.7024914,6.071228,2.7928217,17.1228551),(5071,'radius-cleaned.tif',183,3,457,8.602689,4.5030629,7.327895,1.8,4.4950494,7.3786921,0.207528,1.9542102,3.1914836,9.1788396,25.7605457,0.0608685,8.0716522,4.6969562,10.7554993,3.7107001,6.1069164,2.8157099,17.519506),(5070,'radius-cleaned.tif',183,3,456,8.6104824,4.5116962,7.3351667,1.8,4.5033704,7.3868357,0.2106268,1.9516451,3.1973757,9.2275842,25.9841034,0.0627295,8.126697,4.7281055,10.8234464,3.7313549,6.119807,2.8095332,17.5041535),(5069,'radius-cleaned.tif',183,3,455,8.5971944,4.5198204,7.343524,1.8,4.5128566,7.3968222,0.2127793,1.9492729,3.2139422,9.240343,26.1702787,0.0638999,8.1427348,4.7404051,10.8490451,3.7506001,6.1577996,2.8321366,17.5565704),(5068,'radius-cleaned.tif',183,3,454,8.6157039,4.5278569,7.3501302,1.8,4.5195613,7.4024323,0.2162029,1.9634634,3.2284573,9.2968442,26.4343979,0.0660823,8.1879347,4.734921,10.9294161,3.7404207,6.1493915,2.8588367,17.4944721),(5067,'radius-cleaned.tif',183,3,453,8.6401142,4.5350763,7.3570305,1.8,4.5241072,7.4099952,0.2182922,1.9595598,3.2381649,9.3405187,26.6763496,0.067536,8.2381071,4.7666414,10.9750206,3.7506001,6.1825692,2.8198421,17.7355332),(5066,'radius-cleaned.tif',183,3,452,8.7040643,4.5483329,7.36576,1.8,4.5421438,7.4207133,0.2206777,1.9943355,3.2333147,9.425079,26.9607503,0.0695067,8.3384245,4.7259246,11.0892326,3.7506001,6.1953023,2.8137322,17.517845),(5065,'radius-cleaned.tif',183,3,451,8.8233967,4.5620919,7.3747908,1.8,4.5588608,7.4295101,0.2241874,1.9907375,3.2498636,9.5180771,27.2935599,0.0726807,8.3983709,4.7811814,11.1677547,3.7506001,6.2214581,2.8015885,17.8290247),(5064,'radius-cleaned.tif',183,3,450,8.8724106,4.5707673,7.3816808,1.8,4.5665833,7.4368893,0.2253361,1.9866753,3.243664,9.5731105,27.5042554,0.0738225,8.4793788,4.8186587,11.2850394,3.7630912,6.2103169,2.8482897,17.7104992),(5063,'radius-cleaned.tif',183,3,449,8.8798607,4.5771728,7.3872452,1.8,4.575415,7.4424698,0.2265966,1.9924509,3.2425138,9.6211687,27.701326,0.0746992,8.5431635,4.8288109,11.3673935,3.7865592,6.2219699,2.8421508,17.6403806),(5062,'radius-cleaned.tif',183,3,448,8.8200733,4.5798127,7.391824,1.8,4.5796708,7.4461258,0.2271047,2.0008512,3.2690641,9.648136,27.8954551,0.0745236,8.5331625,4.8220158,11.3431312,3.7905001,6.2485236,2.8501359,17.8620789),(5061,'radius-cleaned.tif',183,3,447,8.7429619,4.5806485,7.3959952,1.8,4.5752795,7.4494629,0.2301559,2.0095466,3.2686948,9.6926054,28.0959156,0.075835,8.595454,4.8232797,11.3707548,3.7788261,6.2724274,2.7977129,17.809662),(5060,'radius-cleaned.tif',183,3,446,8.7146105,4.5850237,7.4023713,1.8,4.5807413,7.459265,0.2322767,2.0067182,3.2914676,9.7333552,28.3547162,0.0769633,8.6146119,4.8503848,11.4118145,3.7696296,6.2709043,2.81783,17.7104992),(5059,'radius-cleaned.tif',183,3,445,8.7083375,4.5911725,7.409236,1.8,4.5893223,7.4675353,0.234083,2.0145354,3.3051899,9.8063075,28.6543277,0.0780867,8.6694952,4.8677763,11.5277532,3.7865592,6.292067,2.8720036,18.1579061),(5058,'radius-cleaned.tif',183,3,444,8.696727,4.5970415,7.4172635,1.8,4.5960783,7.4774124,0.2354238,2.009436,3.3168311,9.871732,28.8903863,0.0788618,8.7102375,4.9126879,11.5445815,3.8274438,6.3219786,2.8338132,18.0273501),(5057,'radius-cleaned.tif',183,3,443,8.698069,4.6019265,7.4254226,1.8,4.6030903,7.4867987,0.2382894,2.0149471,3.31274,9.9417605,29.1525298,0.0807691,8.8001263,4.9340057,11.6700095,3.8114339,6.2982629,2.8458883,17.9555704),(5056,'radius-cleaned.tif',183,3,442,8.6888143,4.6050018,7.4324619,1.8,4.6046846,7.4939384,0.2399648,2.0105861,3.3465781,9.9771544,29.3845663,0.0817998,8.7804813,4.9623115,11.6405536,3.7905001,6.3466091,2.8218302,18.0216789),(5055,'radius-cleaned.tif',183,3,441,8.7113139,4.6109678,7.441173,1.8,4.6110959,7.5013825,0.2441377,2.0175627,3.3406749,10.0831008,29.6907903,0.0848314,8.8876623,4.9976642,11.7930948,3.8164366,6.3466091,2.8218302,18.128862),(5054,'radius-cleaned.tif',183,3,440,8.7232378,4.6155779,7.4469592,1.8,4.616512,7.5065103,0.2472285,2.0258127,3.3362048,10.1503286,29.9517665,0.0870677,8.977796,5.010497,11.91313,3.8315093,6.3600151,2.8357138,18.4537332),(5053,'radius-cleaned.tif',183,3,439,8.7498233,4.6217765,7.4524239,1.8,4.6251378,7.5115752,0.2499414,2.0460108,3.3497898,10.2511934,30.248523,0.08922,9.0299765,5.0103319,11.9509202,3.8379351,6.3844989,2.8237946,18.6947943),(5052,'radius-cleaned.tif',183,3,438,8.76299,4.6253803,7.4590266,1.8,4.6282081,7.5193571,0.252862,2.0444978,3.3747818,10.334818,30.5492603,0.0914097,9.0522181,5.0549421,12.0087362,3.8445205,6.3862441,2.8435531,18.2143332),(5051,'radius-cleaned.tif',183,3,437,8.787387,4.628636,7.4679014,1.8,4.6287037,7.5309818,0.2560505,2.0695705,3.3809044,10.4500279,30.8435266,0.0939394,9.1228627,5.0493703,12.0978444,3.8463141,6.4098827,2.8119682,18.128862),(5050,'radius-cleaned.tif',183,3,436,8.8173897,4.6327075,7.4753074,1.8,4.6336047,7.5388665,0.2582002,2.0742837,3.3862657,10.5563901,31.1573155,0.0958141,9.2010842,5.0891738,12.1893042,3.8645095,6.4229088,2.8060905,18.288462),(5049,'radius-cleaned.tif',183,3,435,8.853429,4.635965,7.4804645,1.8,4.6380413,7.5420421,0.2611653,2.0763244,3.3832378,10.6857314,31.4205802,0.0983773,9.2871332,5.1464652,12.3220967,3.8609872,6.4025516,2.7784456,18.5956315),(5048,'radius-cleaned.tif',183,3,434,8.8983792,4.6399805,7.4878155,1.8,4.6437463,7.5501651,0.2650662,2.0826913,3.4144861,10.8106745,31.7789983,0.1017825,9.3071101,5.1907234,12.3718152,3.8870803,6.4398651,2.7806465,18.5665874),(5047,'radius-cleaned.tif',183,3,433,8.9112171,4.6416182,7.495768,1.8,4.6451612,7.5591708,0.2671675,2.1023224,3.4150505,10.8886359,32.0611304,0.1035131,9.3881863,5.1793368,12.4753392,3.8887051,6.4605975,2.8081239,18.8350315),(5046,'radius-cleaned.tif',183,3,432,8.9477143,4.6421462,7.5047822,1.8,4.6443851,7.5697199,0.2691141,2.103676,3.4342041,11.0155971,32.3997148,0.1054203,9.4344172,5.2363563,12.5112956,3.8991464,6.4871561,2.7965,18.8019773),(5045,'radius-cleaned.tif',183,3,431,8.9535097,4.6441863,7.5126603,1.8,4.6466322,7.5773038,0.2707437,2.1223452,3.4480421,11.1136612,32.6073019,0.1067385,9.4567585,5.2365002,12.5964899,3.9127082,6.5056582,2.7713365,18.6463874),(5044,'radius-cleaned.tif',183,3,430,8.9624065,4.6458415,7.5210868,1.8,4.644398,7.5854426,0.2729158,2.1171154,3.4665416,11.2317599,32.8602316,0.1085228,9.479255,5.3052186,12.6091377,3.9102296,6.5106728,2.823718,19.008323),(5043,'radius-cleaned.tif',183,3,429,8.9785729,4.6506254,7.5291674,1.8,4.652189,7.5934639,0.2735681,2.1221406,3.4600514,11.3278547,33.1431907,0.1092259,9.5788146,5.337938,12.7451435,3.9285079,6.5129954,2.7519853,19.0373671),(5042,'radius-cleaned.tif',183,3,428,8.9949548,4.6510258,7.5360082,1.8,4.653061,7.6020514,0.2759529,2.1184473,3.5030336,11.4640805,33.3517029,0.1112924,9.520806,5.4115486,12.7471182,3.9471692,6.5505303,2.844885,18.5512349),(5041,'radius-cleaned.tif',183,3,427,8.9948839,4.6550961,7.5421962,1.8,4.6567162,7.609622,0.2769103,2.1256305,3.4977112,11.5473657,33.5246871,0.1120453,9.58475,5.4324426,12.8161029,3.9695266,6.5573318,2.7678658,19.3154926),(5040,'radius-cleaned.tif',183,3,426,9.0056203,4.6608014,7.5464404,1.8,4.6640448,7.6122026,0.2785373,2.12508,3.4970468,11.637863,33.7507576,0.1134668,9.6512171,5.4764352,12.8744406,3.9718333,6.5868848,2.7565869,19.0937943),(5039,'radius-cleaned.tif',183,3,425,9.0103502,4.6611898,7.5508516,1.8,4.6610906,7.6146218,0.2793192,2.1328932,3.5231588,11.7256616,33.9889652,0.114148,9.6472987,5.4975381,12.8964307,3.9774974,6.5894221,2.7892004,18.899479),(5038,'radius-cleaned.tif',183,3,424,9.0154092,4.6612638,7.555298,1.8,4.6568926,7.6172845,0.2801737,2.1459846,3.5332239,11.8035827,34.2275101,0.1148935,9.6873311,5.5003111,12.9362448,4.0088279,6.6132973,2.7969453,19.1679231),(5037,'radius-cleaned.tif',183,3,423,9.0490167,4.6618909,7.5608395,1.8,4.6580495,7.6214331,0.2806453,2.1745346,3.5475213,11.9312888,34.5455599,0.1157001,9.737943,5.4868242,12.9668636,4.015076,6.6406836,2.7856349,19.8330181),(5036,'radius-cleaned.tif',183,3,422,9.044125,4.6602416,7.5674423,1.8,4.6544657,7.6323897,0.2795275,2.1716306,3.5579254,12.0266675,34.6966222,0.1147423,9.7519252,5.5380816,13.0291311,4.0076716,6.6609105,2.7610863,19.4694214),(5035,'radius-cleaned.tif',183,3,421,9.0516299,4.6560751,7.5689234,1.8,4.6472551,7.6312246,0.2795039,2.1906957,3.5998646,12.1145029,34.9515697,0.1148186,9.7091345,5.5299798,12.9937222,4.0340496,6.6920284,2.7821241,19.6483841),(5034,'radius-cleaned.tif',183,3,420,9.105394,4.6550354,7.5727121,1.8,4.642996,7.6341744,0.2801907,2.1874094,3.6163313,12.2504384,35.3997776,0.1160539,9.7888648,5.6004324,13.1437409,4.0309191,6.7004684,2.833024,19.6854485),(5033,'radius-cleaned.tif',183,3,419,9.1365922,4.660338,7.5778672,1.8,4.6497027,7.6388765,0.281924,2.1905732,3.6324412,12.3550809,35.7974431,0.1178583,9.8549271,5.6401133,13.1894877,4.0607053,6.7293927,2.7842099,19.7225129),(5032,'radius-cleaned.tif',183,3,418,9.1648866,4.6663658,7.5829759,1.8,4.6532045,7.6448738,0.2845868,2.2202598,3.6325802,12.4374676,36.2260407,0.1204062,9.972537,5.6018074,13.2840344,4.0515239,6.7637269,2.8049178,19.8079841),(5031,'radius-cleaned.tif',183,3,417,9.2009109,4.6739394,7.5881672,1.8,4.6633942,7.6506292,0.2864201,2.2287936,3.6472556,12.5010253,36.6018081,0.122399,10.0354381,5.6088752,13.3174962,4.0564852,6.7905066,2.7938257,20.2730926),(5030,'radius-cleaned.tif',183,3,416,9.2545711,4.6783025,7.5915649,1.8,4.6719547,7.6535761,0.2866206,2.2269878,3.6579301,12.5928789,37.0541256,0.1232805,10.129807,5.6546689,13.4709024,4.0821525,6.8181152,2.782822,20.0143299),(5029,'radius-cleaned.tif',183,3,415,9.2870619,4.6839297,7.5960647,1.8,4.6804105,7.6580227,0.2867825,2.228853,3.6940143,12.6955534,37.4785507,0.1238492,10.1457515,5.6960031,13.5204854,4.0771604,6.8522371,2.803269,19.9054858),(5028,'radius-cleaned.tif',183,3,414,9.3266567,4.6939081,7.5992599,1.8,4.6943433,7.6607608,0.2856604,2.2274966,3.6831905,12.793546,38.0526577,0.1234325,10.3314388,5.7434638,13.7245334,4.0940615,6.8757786,2.7610863,20.3375401),(5027,'radius-cleaned.tif',183,3,413,9.3193712,4.6977181,7.6018128,1.8,4.6990436,7.6621167,0.283647,2.2352718,3.6957066,12.8700735,38.3849282,0.1216503,10.3863571,5.7577219,13.6776917,4.0801837,6.899932,2.7374602,20.7752655),(5026,'radius-cleaned.tif',183,3,412,9.3208286,4.6993694,7.6082044,1.8,4.6935314,7.6697942,0.2817965,2.233716,3.7125461,12.9824072,38.8657162,0.1201291,10.4687498,5.8120223,13.8454429,4.095825,6.9211265,2.7450277,20.5455469),(5025,'radius-cleaned.tif',183,3,411,9.3328859,4.707864,7.613038,1.8,4.702339,7.6732239,0.282876,2.2229465,3.7158378,13.0453522,39.3353164,0.121183,10.585854,5.8684959,13.8972022,4.0995109,6.957947,2.7472426,20.9662587),(5024,'radius-cleaned.tif',183,3,410,9.3626782,4.7117618,7.6158635,1.8,4.703996,7.6732613,0.2807353,2.2292089,3.7365247,13.1559597,39.7373215,0.1197853,10.6348345,5.901627,14.042738,4.1119944,6.9725751,2.7727754,21.0049842),(5023,'radius-cleaned.tif',183,3,409,9.3824478,4.7182553,7.6222805,1.8,4.7107337,7.6822942,0.280387,2.2243097,3.7342287,13.2523487,40.1603215,0.1197484,10.7546496,5.9579601,14.1964607,4.1054085,6.9870587,2.7674489,21.2911299),(5022,'radius-cleaned.tif',183,3,408,9.4273212,4.7186094,7.6230183,1.8,4.7061851,7.6826326,0.2778637,2.2199587,3.7764197,13.3489724,40.6207644,0.118221,10.756422,6.0131626,14.2259178,4.1066596,7.032934,2.782158,21.1412113),(5021,'radius-cleaned.tif',183,3,407,9.4406594,4.7190259,7.6259115,1.8,4.7080846,7.6865358,0.275567,2.2027731,3.7845236,13.4196302,41.0281464,0.1164889,10.8410333,6.0921527,14.1691101,4.1014893,7.0533903,2.7159015,21.1412113),(5020,'radius-cleaned.tif',183,3,406,9.4600554,4.7212863,7.6328745,1.8,4.7121733,7.697906,0.2729,2.1988217,3.8079178,13.5551078,41.5472879,0.1145358,10.9107629,6.1647143,14.3494176,4.1122383,7.0734499,2.7233683,20.8824485),(5019,'radius-cleaned.tif',183,3,405,9.5011853,4.7218035,7.6361424,1.8,4.7065584,7.6977737,0.2706374,2.196888,3.8057882,13.6826558,42.1367206,0.1131808,11.0717461,6.2281992,14.5331119,4.1102009,7.0780623,2.7359607,20.9993129),(5018,'radius-cleaned.tif',183,3,404,9.5355587,4.7203024,7.6402666,1.8,4.7009894,7.7014998,0.2677237,2.1947789,3.8436278,13.8180898,42.5775119,0.111216,11.0774285,6.2958915,14.5562952,4.1184966,7.1229046,2.7080112,21.6256825),(5017,'radius-cleaned.tif',183,3,403,9.5777569,4.721775,7.646093,1.8,4.6977555,7.7081298,0.2651673,2.1925014,3.8640521,13.973196,43.0207597,0.1096351,11.1335869,6.3731756,14.5872898,4.124736,7.1648004,2.7652228,21.2580757),(5016,'radius-cleaned.tif',183,3,402,9.6676991,4.7227989,7.6541069,1.8,4.6985565,7.7203846,0.2622733,2.1827249,3.8846407,14.1895725,43.685557,0.1083176,11.2457137,6.5008523,14.7757552,4.1404849,7.1625781,2.7228027,21.9545639),(5015,'radius-cleaned.tif',183,3,401,9.7296767,4.7174063,7.658701,1.8,4.6920533,7.722498,0.2613061,2.1929373,3.9116066,14.3632068,44.2089796,0.1082279,11.3020004,6.5497572,14.7961524,4.1614768,7.2120838,2.7076393,21.0887943),(5014,'radius-cleaned.tif',183,3,400,9.7648293,4.7138925,7.6640005,1.8,4.6887676,7.7274954,0.2592683,2.1965258,3.9462618,14.5470613,44.7000244,0.1069694,11.3271817,6.6227592,14.9113168,4.1801578,7.2289509,2.7026314,21.0500689),(5013,'radius-cleaned.tif',183,3,399,9.7590732,4.7153018,7.6679643,1.8,4.6921606,7.7295786,0.2576436,2.3711139,3.9820267,14.6473626,45.0406909,0.1056003,11.3109968,6.1774185,14.8982835,4.2003998,7.2842367,2.8527591,22.0126521),(5012,'radius-cleaned.tif',183,3,398,9.747662,4.7197238,7.6751774,1.8,4.6997242,7.734117,0.2576134,2.3652529,3.9941574,14.7352343,45.4876738,0.1054526,11.3885533,6.2298768,14.9941233,4.2197319,7.3112873,2.8595449,21.7248452),(5011,'radius-cleaned.tif',183,3,397,9.7863006,4.7192472,7.6867378,1.8,4.6988268,7.7437157,0.2552586,2.3630251,4.0215104,14.8433714,46.0938574,0.1039861,11.4618272,6.2815123,15.0430294,4.2583159,7.3721123,2.8506543,21.7385368),(5010,'radius-cleaned.tif',183,3,396,9.8201309,4.7149211,7.6983188,1.8,4.6918639,7.7531124,0.2530653,2.3497,4.0408147,14.9969754,46.6285005,0.1025984,11.5393811,6.3825065,15.2157369,4.2522585,7.3879676,2.8625512,21.2483943),(5009,'radius-cleaned.tif',183,3,395,9.8587106,4.7161784,7.7113683,1.8,4.6961924,7.7635335,0.2504536,2.2273717,4.0744975,15.101449,47.2924294,0.1009308,11.6069355,6.7799411,15.2916082,4.2675848,7.4335105,2.8419098,21.6587367),(5008,'radius-cleaned.tif',183,3,394,9.909907,4.719863,7.7228945,1.8,4.6972939,7.7716749,0.2461643,2.2092333,4.0674913,15.1968551,47.8913444,0.0980795,11.7741725,6.8787914,15.4519746,4.2675848,7.4716414,2.8434863,21.8417096),(5007,'radius-cleaned.tif',183,3,393,9.9660815,4.7258924,7.7326478,1.8,4.7027705,7.7790357,0.2430881,2.2438688,4.0972216,15.3323466,48.368947,0.0962342,11.8053041,6.8329961,15.5317377,4.2979905,7.481862,2.8772115,21.9021469),(5006,'radius-cleaned.tif',183,3,392,10.0546545,4.727091,7.741051,1.8,4.6977905,7.7874582,0.2385724,2.2473541,4.0931973,15.4578231,49.1587018,0.0935839,12.009854,6.8782321,15.7298395,4.3069638,7.5031101,2.8669453,22.3922893),(5005,'radius-cleaned.tif',183,3,391,10.1367935,4.7297691,7.7471189,1.8,4.699543,7.7955658,0.234126,2.2432438,4.1160471,15.5716861,49.9325896,0.0909282,12.1311997,6.9415932,15.8621805,4.3126735,7.5634449,2.8582206,22.2891165),(5004,'radius-cleaned.tif',183,3,390,10.2143301,4.7320138,7.7514569,1.8,4.6990613,7.8003803,0.229141,2.2573866,4.134545,15.6487653,50.7650443,0.0878314,12.2782663,6.9322487,16.0429326,4.3344436,7.5799501,2.8698005,21.9529028),(5003,'radius-cleaned.tif',183,3,389,10.3149683,4.7316096,7.7504744,1.8,4.6934586,7.7944124,0.2264473,2.2738302,4.1497706,15.6928412,51.5195764,0.0866592,12.4150422,6.9015008,16.1412894,4.340093,7.618393,2.8712065,21.7038214),(5002,'radius-cleaned.tif',183,3,388,10.4744939,4.7312996,7.7524121,1.8,4.6951845,7.7971736,0.2229524,2.2776078,4.1520401,15.7874482,52.3598869,0.0853489,12.6106408,6.931592,16.3669676,4.3415726,7.6243463,2.8496346,22.8300148),(5001,'radius-cleaned.tif',183,3,387,10.6501867,4.7288462,7.7593635,1.8,4.694339,7.8082109,0.219477,2.2727122,4.1522286,15.8493712,52.9610622,0.0841394,12.7548521,6.9737697,16.525303,4.3221527,7.6243463,2.8496346,22.3068181),(5000,'radius-cleaned.tif',183,3,386,10.845499,4.7291198,7.7687526,1.8,4.6929195,7.8191088,0.2176411,2.2602137,4.1622956,15.8746835,53.5308292,0.0842776,12.8608909,7.0235321,16.5823886,4.330817,7.6718064,2.8297102,22.2310283),(4999,'radius-cleaned.tif',183,3,385,11.0658602,4.7344475,7.779632,1.8,4.7005502,7.8287681,0.2148215,2.253998,4.1584742,15.9547147,54.1465879,0.0838105,13.0207825,7.0784069,16.8199465,4.3163338,7.6625664,2.8511334,21.9625842),(4998,'radius-cleaned.tif',183,3,384,11.18454,4.7303296,7.783995,1.8,4.6915988,7.8311823,0.2121703,2.2438107,4.1662261,16.0156667,54.7360073,0.0826627,13.1380309,7.1377086,16.9648135,4.323434,7.6625664,2.8511334,22.2737639),(4997,'radius-cleaned.tif',183,3,383,11.2325049,4.7333594,7.7893019,1.8,4.6958922,7.8357239,0.2086183,2.2407236,4.1617126,16.0767707,55.2864972,0.0803009,13.2845542,7.1748121,17.1294404,4.3091247,7.6625664,2.8511334,22.0988113),(4996,'radius-cleaned.tif',183,3,382,11.3174058,4.7353411,7.790581,1.8,4.701724,7.8359871,0.2053342,2.2806316,4.1590638,16.0876476,55.8788659,0.0784162,13.4354433,7.0540319,17.2469494,4.3462288,7.6734663,2.7968199,22.6026453),(4995,'radius-cleaned.tif',183,3,381,11.4555667,4.7338842,7.7840723,1.8,4.7051583,7.8322387,0.2029856,2.2889201,4.1775442,16.2006625,56.6186369,0.077593,13.553091,7.0778627,17.4032807,4.3377172,7.6953232,2.8739763,22.6590724),(4994,'radius-cleaned.tif',183,3,380,11.5728607,4.7236938,7.7657379,1.8,4.6996442,7.8160343,0.2000542,2.3232581,4.1672177,16.3457725,57.3631563,0.0761699,13.7653371,7.035711,17.6254854,4.353902,7.6858008,2.8411853,22.6864554),(4993,'radius-cleaned.tif',183,3,379,11.6766781,4.7064728,7.7471893,1.8,4.6902516,7.8030211,0.1965353,2.331222,4.1944355,16.4577675,58.1191224,0.0742079,13.856244,7.0597171,17.7564495,4.3504245,7.6949094,2.9167371,22.8186724),(4992,'radius-cleaned.tif',183,3,378,11.8441311,4.6883242,7.729174,1.8,4.6826895,7.787967,0.1931233,2.3703061,4.1996277,16.6729866,58.7120046,0.0727136,13.9802881,7.034107,17.9312898,4.3621974,7.6953232,2.8739763,23.0073165),(4991,'radius-cleaned.tif',183,3,377,12.1949189,4.6605934,7.7124119,1.8,4.6621396,7.7748905,0.1917652,2.4017419,4.2134606,16.9485237,59.7142698,0.0738308,14.1722624,7.0567631,18.1462898,4.385549,7.7131976,2.8853221,23.100808),(4990,'radius-cleaned.tif',183,3,376,12.6463646,4.6261464,7.6990423,1.8,4.6383499,7.7640994,0.1867522,2.4399764,4.2163956,17.2765311,60.8395568,0.0726593,14.4292809,7.0806139,18.4509559,4.3226703,7.6920124,2.9431798,22.6163368),(4989,'radius-cleaned.tif',183,3,375,13.0318606,4.5873378,7.6952947,1.8,4.6088251,7.764242,0.1792259,2.3878163,4.220104,17.5447259,61.8974675,0.0690242,14.6672847,7.3476029,18.6599178,4.3677536,7.6775109,2.9268696,23.2386962),(4988,'radius-cleaned.tif',183,3,374,13.3164991,4.5449575,7.6965673,1.8,4.5760637,7.7665352,0.1687252,2.4307133,4.256633,17.7438282,62.9219556,0.0625855,14.7820955,7.299844,18.8245981,4.4188299,7.6949094,2.9167371,22.7525639),(4987,'radius-cleaned.tif',183,3,373,13.4615426,4.5086387,7.7017658,1.8,4.5608844,7.7693866,0.1607976,2.4047131,4.2748298,17.7677232,63.6447909,0.0575117,14.888263,7.3887083,18.8137975,4.4209188,7.6999766,2.9380996,23.2934622),(4986,'radius-cleaned.tif',183,3,372,13.426595,4.4818289,7.7038307,1.8,4.5521475,7.7731552,0.1550297,2.3938482,4.2713059,17.6848054,64.0919833,0.0533535,15.005243,7.3876052,18.9543437,4.4209188,7.7158803,2.9543387,23.0387097),(4985,'radius-cleaned.tif',183,3,371,13.1995603,4.4693453,7.6971517,1.8,4.5417104,7.7727693,0.1520346,2.3928563,4.2709324,17.3692249,64.3386203,0.0504596,15.0643032,7.2587832,18.8473884,4.4364561,7.740703,2.9654275,23.3031436),(4984,'radius-cleaned.tif',183,3,370,12.9089481,4.4651214,7.6793941,1.8,4.540428,7.7541956,0.1502914,2.4124494,4.259003,17.0158327,64.4886876,0.048232,15.1417335,7.0533427,18.8386765,4.4308861,7.7250565,2.9229237,23.6964724),(4983,'radius-cleaned.tif',183,3,369,12.7980472,4.4512359,7.6647516,1.8,4.534963,7.7370461,0.145958,2.4165254,4.2568966,16.8763225,64.6656991,0.0451192,15.1908081,6.9837142,18.8107016,4.4308861,7.7234077,2.9492629,23.951225),(4982,'radius-cleaned.tif',183,3,368,12.7144087,4.4170325,7.642372,1.8,4.4988734,7.7075463,0.1327717,2.4085773,4.2751784,16.6487696,64.0299386,0.0371366,14.9771385,6.9122838,18.4415582,4.2845487,7.7311336,2.9441971,22.4590859),(4981,'radius-cleaned.tif',183,3,367,12.8311106,4.4076747,7.6275376,1.8,4.4948616,7.691507,0.1228229,2.4029272,4.2803538,16.6930345,63.9960216,0.0320987,14.9511055,6.9469582,18.4792155,4.28977,7.7254687,3.0121128,23.2120012),(4980,'radius-cleaned.tif',183,3,366,12.9981392,4.4058663,7.6100044,1.8,4.4863722,7.6759133,0.1095317,2.3942496,4.2665827,16.813976,63.7188545,0.0258864,14.9344004,7.0226497,18.5212242,4.383262,7.7204182,3.0172377,23.0878045),(4979,'radius-cleaned.tif',183,3,365,13.2408296,4.421484,7.5942773,1.8,4.4858869,7.6619006,0.0983226,2.3932151,4.221804,16.9391471,63.5263697,0.0212653,15.0472095,7.0779877,18.5555527,4.4200268,7.723923,3.0640284,23.4570724),(4978,'radius-cleaned.tif',183,3,364,13.4133199,4.4461395,7.5858136,1.8,4.4933075,7.6541538,0.0864031,2.3792681,4.1991665,17.0527827,62.9500924,0.016648,14.9910921,7.1672389,18.5626897,4.3836102,7.7305158,3.0537365,23.1966486),(4977,'radius-cleaned.tif',183,3,363,13.5143324,4.4886214,7.5898842,1.8,4.5197612,7.6595156,0.0767046,2.5203725,4.1444376,17.2837945,61.7398138,0.0132262,14.8970306,6.857635,18.6011199,4.4897064,7.7181496,3.0743367,24.083442),(4976,'radius-cleaned.tif',183,3,362,13.5656465,4.5361913,7.5957855,1.8,4.555463,7.6626952,0.0634446,2.515868,4.0863632,17.3403517,60.0750319,0.0090886,14.7013442,6.8923933,18.3315015,4.4897064,7.7471788,3.1003789,24.5856149),(4975,'radius-cleaned.tif',183,3,361,13.5948025,4.5938388,7.6034564,1.8,4.6031373,7.6659627,0.0514116,2.5087308,4.0089989,17.3919245,58.1407878,0.0059836,14.5025703,6.9325592,18.143469,4.486921,7.7422454,0.0206156,24.8620793),(4974,'radius-cleaned.tif',183,3,360,13.6337943,4.6551497,7.6204807,1.8,4.658061,7.6827421,0.0394902,2.2950804,3.9392113,17.5370105,56.0570894,0.0035418,14.2305362,7.6411311,18.0691827,4.5031741,7.7422454,0.0206156,25.8777675),(4973,'radius-cleaned.tif',183,3,359,13.6788726,4.713562,7.6361012,1.8,4.7120381,7.6968502,0.0279459,2.252181,3.8763831,17.6686183,54.1001004,0.00178,13.956335,7.8451148,17.9074604,4.5031741,7.7131976,0.0569332,25.2747708),(4972,'radius-cleaned.tif',183,3,358,13.7733235,4.7735884,7.6557571,1.8,4.7668724,7.7150949,0.0151052,2.2481221,3.8439215,17.9404054,52.2557755,0.0005237,13.5943919,7.9801738,17.7849097,4.5073519,7.7209337,0.072412,25.2223538),(4971,'radius-cleaned.tif',183,3,357,13.8915051,4.8335149,7.689927,1.8,4.8231634,7.7521323,0.0057143,2.2949212,3.9115854,18.3900299,50.6224419,0.0000756,12.9416686,8.0133602,17.2938213,4.5219805,7.7181496,0.0672559,25.7786047),(4970,'radius-cleaned.tif',183,3,356,13.8328547,4.8801887,7.7123862,1.8,4.8652088,7.7663881,-0.0045915,2.3746115,3.9267072,18.6078821,48.7394606,0.0000486,12.412298,7.8361794,16.7286772,4.5479192,7.698219,0.0986372,24.6306996),(4969,'radius-cleaned.tif',183,3,355,13.670697,4.922398,7.7360727,1.8,4.9071205,7.7865284,-0.0141138,2.3793914,3.9380859,18.6879502,46.8638313,0.0004538,11.9001547,7.8540883,16.2212597,4.52024,7.6759555,0.1198418,25.0627538),(4968,'radius-cleaned.tif',183,3,354,13.478006,4.9546416,7.757064,1.8,4.9332718,7.804668,-0.0216611,2.4523972,3.9765977,18.7254298,45.2611637,0.0010538,11.3818816,7.6355617,15.7311132,4.5496596,7.7022506,0.1037923,25.0490623),(4967,'radius-cleaned.tif',183,3,353,13.2458705,4.996204,7.7747726,1.8,4.9764451,7.8209242,-0.0300851,2.4885465,3.98599,18.698674,43.6643848,0.0019976,10.9544643,7.5138938,15.3063514,4.5461788,7.6668244,0.1095078,24.7589064),(4966,'radius-cleaned.tif',183,3,352,13.0199899,5.0350719,7.7949679,1.8,5.0059069,7.8389411,-0.038765,2.5272351,3.9944426,18.7588911,42.4992855,0.0032593,10.6396036,7.4226933,14.9855024,4.582034,7.6363432,0.1204665,24.8330352),(4965,'radius-cleaned.tif',183,3,351,12.7262578,5.0777057,7.8141021,1.8,5.0437802,7.854804,-0.0469183,2.5569709,4.0050978,18.6266001,41.213575,0.0046657,10.2902792,7.2846352,14.6104215,4.6050126,7.6158849,0.1737617,24.9418793),(4964,'radius-cleaned.tif',183,3,350,12.4457697,5.1124841,7.8404866,1.8,5.0789939,7.8811433,-0.0591843,2.6149165,4.0133527,18.5085593,40.1361453,0.0072573,10.0006523,7.0780688,14.2871408,4.6083195,7.6024947,0.1634231,24.3622555),(4963,'radius-cleaned.tif',183,3,349,12.087372,5.142945,7.8608482,1.8,5.1112772,7.897798,-0.0718835,2.656472,4.0130886,18.0502196,39.0061431,0.0103918,9.7197313,6.7948089,13.9494701,4.6180628,7.5765889,0.1746722,24.6734352),(4962,'radius-cleaned.tif',183,3,348,11.7492789,5.173906,7.8888631,1.8,5.1472372,7.9223307,-0.0840226,2.7130176,3.9814173,17.5542421,38.1246772,0.0137921,9.5756546,6.4703754,13.6853728,4.6316244,7.5199594,0.1921927,24.988625),(4961,'radius-cleaned.tif',183,3,347,11.4141627,5.2071102,7.9196177,1.8,5.1847131,7.9439014,-0.0949534,2.7676129,3.9807496,17.0081931,37.2145717,0.0171005,9.3486341,6.145438,13.3772856,4.6316244,7.4965296,0.2036585,24.9959573),(4960,'radius-cleaned.tif',183,3,346,11.0674674,5.2263005,7.9580937,1.8,5.2038928,7.9782428,-0.1053878,2.7923059,3.9367724,16.4555423,36.2435253,0.0204112,9.2064061,5.8931733,13.1121807,4.6179673,7.4437834,0.2215759,33.5154798),(4959,'radius-cleaned.tif',183,3,345,10.6671718,5.2494352,7.9905002,1.8,5.2305495,8.0061017,-0.117435,2.8271248,3.9211143,15.7782333,35.1108001,0.024406,8.9542915,5.5810177,12.7807328,4.6179673,7.413781,0.228009,32.4957814),(4958,'radius-cleaned.tif',183,3,344,10.3608952,5.2669756,8.0326124,1.8,5.2512754,8.0468996,-0.1377606,2.8774262,3.8723941,15.2953251,34.4285282,0.0325647,8.8907605,5.3156273,12.6798959,4.608845,7.3452857,0.2357563,32.4433644),(4957,'radius-cleaned.tif',183,3,343,9.984281,5.2973087,8.0625763,1.8,5.2896528,8.071985,-0.1526602,2.9195999,3.8610992,14.634985,33.4402406,0.0384805,8.6608085,5.012668,12.3508596,4.5855287,7.3002828,0.2767982,31.5034661),(4956,'radius-cleaned.tif',183,3,342,9.6124607,5.3351429,8.0984124,1.8,5.3359004,8.1061047,-0.1661726,2.969901,3.8464936,14.0102053,32.480284,0.043833,8.444128,4.7173981,11.9559485,4.6011494,7.2803016,0.3234837,31.3809305),(4955,'radius-cleaned.tif',183,3,341,9.1975622,5.3879391,8.1236939,1.8,5.3961807,8.1265203,-0.1764848,2.959626,3.8604229,13.3304729,31.5383466,0.0472522,8.169661,4.5041073,11.5253332,4.5898009,7.2510499,0.2730087,31.1141474),(4954,'radius-cleaned.tif',183,3,340,8.8112212,5.4417853,8.1642066,1.8,5.4512697,8.1647995,-0.1946154,3.0048976,3.8433262,12.674529,31.0864386,0.0549224,8.0884206,4.2179571,11.3131955,4.6056662,7.2077781,0.291987,31.7445271),(4953,'radius-cleaned.tif',183,3,339,8.3513389,5.5193046,8.2070586,1.8,5.5359708,8.2105698,-0.2065017,3.0779029,3.8926492,11.8877556,30.5208391,0.0585154,7.8406343,3.8622907,10.8316283,3.2916077,7.193075,0.3042085,23.2740995),(4952,'radius-cleaned.tif',183,3,338,8.035943,5.6117044,8.2514635,1.8,5.6388531,8.2591147,-0.2139565,3.1083499,3.9544911,11.2695289,30.1824248,0.0603809,7.6324421,3.6255664,10.4251237,3.269674,7.2307125,0.3374561,23.4917877),(4951,'radius-cleaned.tif',183,3,337,7.7307966,5.6886938,8.2817387,1.8,5.7173037,8.2900739,-0.2222152,3.1344309,4.0086166,10.6000957,29.7319335,0.0625836,7.417006,3.3818247,10.0406344,2.1929362,3.7320901,3.0344773,10.5822921),(4950,'radius-cleaned.tif',183,3,336,7.4554575,5.7595695,8.3131406,1.8,5.7862962,8.3200451,-0.2333388,3.1769481,4.0229677,9.8862765,29.3114284,0.0664355,7.2860213,3.1118785,9.7163403,2.0454489,3.6227795,3.0090411,10.0043293),(4949,'radius-cleaned.tif',183,3,335,7.2881831,5.8323759,8.35277,1.8,5.8656478,8.3619706,-0.2447827,3.2275442,4.0871797,9.3435926,29.331773,0.0713408,7.1765314,2.8949542,9.4514372,1.9810352,3.5692107,3.0408117,9.9672649),(4948,'radius-cleaned.tif',183,3,334,7.0659222,5.9085125,8.3742685,1.8,5.943617,8.3805979,-0.2603451,3.2369853,4.119259,8.6132023,28.9712865,0.0780336,7.0331306,2.6608716,9.1211262,1.8915019,3.4941559,3.0271523,9.4827937),(4947,'radius-cleaned.tif',183,3,333,6.8191797,5.972249,8.4031428,1.8,6.0018986,8.4116445,-0.2721396,3.2739873,4.1738408,7.8646588,28.4862319,0.0821139,6.8249446,2.4021653,8.7091854,1.8019686,3.4593554,3.0143764,9.0080039),(4946,'radius-cleaned.tif',183,3,332,6.5313761,6.0315,8.441289,1.8,6.0648863,8.4517325,-0.2817311,3.2881105,4.1766935,7.0457971,27.5788193,0.0841399,6.6030268,2.1428103,8.2892268,1.757202,3.3461331,2.9980093,8.7822954),(4945,'radius-cleaned.tif',183,3,331,6.3946342,6.0561426,8.5150602,1.8,6.0785937,8.5345271,-0.2908184,3.3527424,4.1794803,6.5856184,27.1299481,0.0876254,6.4912252,1.9642483,8.0660914,1.6850796,3.2960396,3.0202407,8.8620954),(4944,'radius-cleaned.tif',183,3,330,6.0545712,6.1060939,8.5577443,1.8,6.1448191,8.566514,-0.2934632,3.3111768,4.1881227,5.8222109,25.812752,0.0844377,6.1633227,1.7583509,7.5522243,1.6388572,3.2615658,3.0066159,8.8153496),(4943,'radius-cleaned.tif',183,3,329,5.6995468,6.1403863,8.6136113,1.8,6.1884834,8.6141175,-0.2931103,3.336032,4.1666395,4.9954989,24.5803976,0.0793009,5.899334,1.4974374,7.0949557,1.5787777,3.1825097,3.0032417,8.825031),(4942,'radius-cleaned.tif',183,3,328,5.3387304,6.1836325,8.6629035,1.8,6.2391321,8.6570306,-0.2929229,3.29972,4.193834,4.2266682,23.2220242,0.0741884,5.5371825,1.2809172,6.5385766,1.5394839,3.1328489,3.026716,8.2373869),(4941,'radius-cleaned.tif',183,3,327,5.0201225,6.2234243,8.7109353,1.8,6.2874158,8.701442,-0.296092,3.3101043,4.1674626,3.5201579,22.1525912,0.071234,5.3156065,1.0634583,6.1460813,1.4863329,3.063998,2.997854,8.0681055),(4940,'radius-cleaned.tif',183,3,326,4.7096296,6.2535677,8.7578974,1.8,6.3196749,8.7429619,-0.300145,3.2555715,4.1285516,2.8813099,21.0881045,0.0686146,5.1078699,0.8850397,5.7947853,1.4008167,2.9585252,2.965358,7.6731156),(4939,'radius-cleaned.tif',183,3,325,4.3905402,6.3140578,8.8007738,1.8,6.3958514,8.7810813,-0.3047569,3.2559736,4.1580555,2.2972666,19.6222946,0.065885,4.7191036,0.7055544,5.262514,1.3106495,2.8799952,2.9605,7.5893055),(4938,'radius-cleaned.tif',183,3,324,4.0926049,6.3389601,8.8337441,1.8,6.4258229,8.8231489,-0.3066661,3.2239852,4.1212853,1.933346,18.3964471,0.0621617,4.4637645,0.5996758,4.9183323,2.05002,3.8114422,1.0321722,11.4464006),(4937,'radius-cleaned.tif',183,3,323,3.7573904,6.3440988,8.8568537,1.8,6.428365,8.8543213,-0.3070001,1.7450383,4.0810594,1.7446804,16.8937301,0.0571907,4.1395453,0.9997949,4.5521863,1.2456379,2.7423814,2.9955804,7.2934784),(4936,'radius-cleaned.tif',183,3,322,3.3562576,6.3196105,8.8955956,1.8,6.4103745,8.8956319,-0.3005631,1.7759358,3.960204,1.5775377,14.9687731,0.0490296,3.7797985,0.8882853,4.1621029,1.1938401,2.6373267,2.9590328,6.9686071),(4935,'radius-cleaned.tif',183,3,321,2.9110681,6.2722482,8.9565534,1.8,6.3651772,8.9556478,-0.2822389,1.8207821,3.8268083,1.4064039,12.7432382,0.0376333,3.3299912,0.7724175,3.6863031,1.1233449,2.527595,2.9349094,6.3632614),(4934,'radius-cleaned.tif',183,3,320,2.67497,6.3281558,9.0805511,1.8,6.4216544,9.0946623,-0.2378327,1.9788388,3.8226328,1.457486,10.6200336,0.0247461,2.7781987,0.736536,3.1525978,1.0142762,2.2965908,3.0021526,6.1706071),(4933,'radius-cleaned.tif',183,3,319,2.2747419,6.3405346,9.1177306,1.8,6.4374582,9.1308884,-0.2186791,2.0273295,3.6966279,1.1712923,8.6644987,0.0178427,2.3438926,0.5777513,2.6536614,0.9068866,2.1293296,2.9147938,5.4701088),(4932,'radius-cleaned.tif',183,3,318,1.9088727,6.2905609,9.1647294,1.8,6.3688296,9.1750372,-0.1907262,2.0574471,3.5664087,0.8690343,7.1847378,0.0114334,2.0145581,0.4223848,2.2550847,0.8429714,2.0227372,2.8822609,5.1879732),(4931,'radius-cleaned.tif',183,3,317,1.5465935,6.2520677,9.2267667,1.8,6.3271992,9.2217892,-0.1501043,2.1698239,3.444879,0.566243,5.6555799,0.0057643,1.6417354,0.2609627,1.8055308,0.7494859,1.8871477,2.90687,4.8357189),(4930,'radius-cleaned.tif',183,3,316,1.2262757,6.2221615,9.3065786,1.8,6.314719,9.2852724,-0.0956205,2.2647856,3.3238757,0.2838742,4.3632178,0.001863,1.3126898,0.1253426,1.3689745,0.6898701,1.655249,2.8732264,4.3045019),(4929,'radius-cleaned.tif',183,3,315,0.9411638,6.1332835,9.3809261,1.8,6.1927987,9.3804819,-0.0452124,2.3886206,3.1880532,0.0537927,3.3704529,0.0003204,1.0572135,0.0225204,0.983258,0.6234776,1.5349837,2.9849908,4.0981562),(4928,'radius-cleaned.tif',183,3,314,0.6884839,6.1211582,9.3920922,1.8,6.2110634,9.3974973,-0.0336192,0.4004304,3.0931945,0.0133476,2.4680473,0.0001296,0.7978959,0.0333331,0.801943,0.521095,1.3548386,2.9037567,3.4444036),(4927,'radius-cleaned.tif',183,3,313,0.4026174,5.8363737,9.3930353,1.8,6.0176382,9.3924929,-0.0368871,0.3151541,2.7275965,0.0051366,1.5190215,0.0000913,0.5569084,0.0162986,0.5587238,0.4662078,1.181606,2.9375747,2.9091764),(4926,'radius-cleaned.tif',183,3,312,0.1191877,4.6080554,9.4092157,1.8,4.8665375,9.3992281,-0.0517989,0.4667084,3.9978011,0.0009997,0.3533528,0.0000533,0.0883868,0.0021421,0.0881407,0.3143639,0.9650523,3.0172377,2.3215323),(4925,'radius-cleaned.tif',183,3,311,0.0295226,3.8167028,9.4183523,1.8,3.8585115,9.4136798,-0.1324814,0.1237961,4.7703775,0.0001034,0.0256798,0.0000859,0.0053832,0.0008354,0.0054046,0.1931504,0.6103527,2.9441971,1.4050069),(4924,'radius-cleaned.tif',183,3,310,0.0005378,3.6708001,9.4563002,1.8,3.6708001,9.4563002,0.7853982,0,0,0.00000007135,0.00000007135,0.0000448,0,0,0,0.0399,0.0564271,2.3561945,0.1128542),(4923,'radius-cleaned.tif',183,3,309,6.059943,4.3802845,11.3061783,1.8,4.3185879,11.2776381,0.7376958,1.6724851,2.4887092,3.4316422,9.0245652,0.4568894,3.6262032,2.0518223,4.8783701,3.3030695,5.5151559,2.2331085,16.2176721),(4922,'radius-cleaned.tif',183,3,308,6.0644988,4.3685438,11.3001776,1.8,4.3067078,11.2742699,0.7537388,1.6493226,2.4647767,3.3983971,9.0540062,0.4733966,3.6733576,2.0604806,4.9305705,3.2343216,5.5151559,2.2331085,16.0056551),(4921,'radius-cleaned.tif',183,3,307,6.0767245,4.3572258,11.2949802,1.8,4.2953636,11.2704885,0.7659996,1.6324833,2.4460796,3.3722207,9.1179339,0.486752,3.7275704,2.0656999,4.9698947,3.1521986,5.5223677,2.2229677,15.9548992),(4920,'radius-cleaned.tif',183,3,306,6.072437,4.3476486,11.2941573,1.8,4.2850687,11.2726132,0.7743196,1.6453919,2.4509359,3.3401704,9.1614718,0.4948251,3.7379484,2.0300151,4.9916612,3.1295727,5.5334555,2.2489156,15.709828),(4919,'radius-cleaned.tif',183,3,305,6.0618274,4.3387357,11.2946047,1.8,4.2790788,11.2741851,0.7817583,1.6309148,2.4589485,3.3071001,9.1629203,0.5014749,3.7263572,2.0277577,5.0345978,3.0435431,5.5063447,2.2070512,15.8049805),(4918,'radius-cleaned.tif',183,3,304,6.0537073,4.3296095,11.2981183,1.8,4.2703781,11.280252,0.7859964,1.617453,2.4639641,3.2731715,9.1899374,0.5050792,3.7297367,2.0236579,5.0354722,3.0242124,5.4837468,2.2375829,15.3809466),(4917,'radius-cleaned.tif',183,3,303,6.0307703,4.3221214,11.3022548,1.8,4.2659923,11.2867939,0.7881884,1.6069739,2.4668183,3.2259554,9.1895522,0.5053687,3.7252651,2.0074722,5.0130175,2.9903953,5.4773561,2.2478126,15.8944619),(4916,'radius-cleaned.tif',183,3,302,5.9961681,4.3159507,11.3075243,1.8,4.2632677,11.2933498,0.791312,1.5956501,2.4680845,3.1752172,9.1607524,0.5055906,3.7116851,1.9899208,4.981093,2.9903953,5.4664458,2.2215966,15.6647433),(4915,'radius-cleaned.tif',183,3,301,5.9547539,4.3119021,11.3141169,1.8,4.2620974,11.2993286,0.7927402,1.5866558,2.4665202,3.1216604,9.1271973,0.5035159,3.7004349,1.9674465,4.9508107,2.9523152,5.4773561,2.2478126,15.5034822),(4914,'radius-cleaned.tif',183,3,300,5.9114063,4.3079124,11.3207202,1.8,4.2572016,11.3053909,0.7959908,1.6043144,2.4652094,3.0792461,9.0872293,0.5030526,3.6861896,1.9193533,4.9224303,2.9142706,5.4837468,2.2375829,15.7816077),(4913,'radius-cleaned.tif',183,3,299,5.8497088,4.305623,11.3270596,1.8,4.2551658,11.3123128,0.7967759,1.5974499,2.4624155,3.0289761,9.01089,0.4985676,3.6593703,1.8961321,4.8778196,2.9213947,5.4837468,2.2375829,15.8420449),(4912,'radius-cleaned.tif',183,3,298,5.80157,4.3027984,11.3318794,1.8,4.2544026,11.3168842,0.8001241,2.8270434,2.4614812,2.9928128,8.9356228,0.4977011,3.6301813,1.058637,3.5183828,2.8928719,5.4463136,2.2524021,15.338211),(4911,'radius-cleaned.tif',183,3,297,5.7633354,4.2966715,11.3344547,1.8,4.249777,11.3193393,0.8027767,2.884684,2.4642918,2.9708405,8.86365,0.4969676,3.5968346,1.0298669,3.438424,2.8873743,5.4463136,2.2524021,15.470428),(4910,'radius-cleaned.tif',183,3,296,5.7277076,4.2922141,11.3381358,1.8,4.2457422,11.3233667,0.8052015,2.8305889,2.4650682,2.9402397,8.7994854,0.4962087,3.5696723,1.0387378,3.4541774,2.8632065,5.4463136,2.2524021,15.1923025),(4909,'radius-cleaned.tif',183,3,295,5.680865,4.2895087,11.3445751,1.8,4.2429661,11.3302059,0.8051582,1.5928105,2.4622949,2.9019337,8.7054179,0.4921095,3.5354895,1.8218952,4.7079006,2.871594,5.4463136,2.2524021,15.6590721),(4908,'radius-cleaned.tif',183,3,294,5.6288909,4.2875941,11.3514646,1.8,4.2412041,11.3391281,0.8061431,1.5867929,2.4587714,2.8664647,8.610968,0.4885305,3.5021425,1.8064516,4.662661,2.859231,5.4347551,2.2260443,15.5228449),(4907,'radius-cleaned.tif',183,3,293,5.5712171,4.2844699,11.3570373,1.8,4.2355379,11.3429771,0.8075245,1.579309,2.457064,2.8186651,8.532856,0.4848065,3.4727855,1.7847458,4.6155227,2.8464976,5.4347551,2.2260443,15.8106518),(4906,'radius-cleaned.tif',183,3,292,5.5373241,4.2800103,11.3595706,1.8,4.2312329,11.3455829,0.809651,1.5722155,2.4585292,2.7884182,8.4821249,0.4838175,3.450081,1.7735598,4.5806629,2.8368612,5.4463136,2.2524021,15.5695907),(4905,'radius-cleaned.tif',183,3,291,5.5138215,4.2736037,11.3606588,1.8,4.2267983,11.3481965,0.8101975,1.5676775,2.4622102,2.7599848,8.4615826,0.4822657,3.4365801,1.7605565,4.5544256,2.8355024,5.4463136,2.2524021,15.5462178),(4904,'radius-cleaned.tif',183,3,290,5.5064739,4.265596,11.3579473,1.8,4.2179396,11.3449464,0.8123157,1.5876465,2.4698731,2.7338301,8.4755888,0.4835644,3.4315888,1.7219388,4.5359854,2.8355024,5.4277202,2.2363527,15.1028211),(4903,'radius-cleaned.tif',183,3,289,5.4777024,4.2611507,11.3574217,1.8,4.2132611,11.3455927,0.8133265,1.6127134,2.4733904,2.7068536,8.447545,0.4819591,3.4153706,1.6784468,4.5076207,2.8319291,5.4463136,2.2524021,15.5131636),(4902,'radius-cleaned.tif',183,3,288,5.440673,4.2587209,11.35761,1.8,4.2105226,11.3470511,0.8161993,1.607876,2.5024577,2.680538,8.4147997,0.4813016,3.3626142,1.6671298,4.4332612,2.8204857,5.4347551,2.2260443,15.2680923),(4901,'radius-cleaned.tif',183,3,287,5.4087899,4.2597514,11.3586448,1.8,4.2113728,11.3482611,0.8203974,1.6036003,2.5011362,2.6637489,8.3548536,0.4822573,3.3404232,1.6611052,4.4051688,2.8204857,5.4347551,2.2260443,15.3011466),(4900,'radius-cleaned.tif',183,3,286,5.3714494,4.2597845,11.3591747,1.8,4.2109983,11.3501609,0.8248752,1.5986286,2.4737453,2.6372411,8.298917,0.4829255,3.3547984,1.6496896,4.4201445,2.8272376,5.4463136,2.2524021,15.630028),(4899,'radius-cleaned.tif',183,3,285,5.3407157,4.2620216,11.3606817,1.8,4.2159966,11.355613,0.8306243,1.5932666,2.4713444,2.6095843,8.2424484,0.4852614,3.3352083,1.6378831,4.3907803,2.8332066,5.4347551,2.2260443,15.6260178),(4898,'radius-cleaned.tif',183,3,284,5.3176405,4.2595688,11.3579772,1.8,4.2111323,11.3530272,0.8360596,1.5875553,2.4751323,2.592362,8.1790634,0.4879598,3.3044955,1.632927,4.3517378,2.792705,5.4100929,2.2674232,15.3575737),(4897,'radius-cleaned.tif',183,3,283,5.2993564,4.2652449,11.3599425,1.8,4.2188378,11.3580957,0.8422876,1.6136378,2.4965174,2.5795921,8.1218137,0.4917509,3.2532574,1.598619,4.2863384,2.8030769,5.42596,2.0114217,15.3575737),(4896,'radius-cleaned.tif',183,3,282,5.2853883,4.2679055,11.3599679,1.8,4.2192653,11.3581343,0.8472822,1.6104231,2.4945868,2.5615972,8.0876644,0.4948234,3.2420858,1.5906362,4.2685442,2.7969543,5.4287467,1.9949907,15.2156754),(4895,'radius-cleaned.tif',183,3,281,5.2795947,4.2644135,11.3563446,1.8,4.2165329,11.3540795,0.850188,1.6071559,2.4995033,2.5493667,8.0775232,0.4968175,3.2316514,1.5862598,4.2510063,2.7969543,5.4294798,2.0771811,15.709828),(4894,'radius-cleaned.tif',183,3,280,5.2600724,4.2586364,11.3525556,1.8,4.2129728,11.3517185,0.8530843,1.6022437,2.5060254,2.525759,8.0346169,0.4974973,3.2061195,1.5763888,4.213125,2.7989076,5.4430972,2.0508359,15.7856178),(4893,'radius-cleaned.tif',183,3,279,5.2431164,4.2552841,11.3526916,1.8,4.2119473,11.3531179,0.8541016,1.5985447,2.508072,2.5047109,8.0022675,0.4967743,3.1906052,1.5668695,4.1882188,2.7922325,5.4430972,2.0508359,15.5929636),(4892,'radius-cleaned.tif',183,3,278,5.2343116,4.2518774,11.3540193,1.8,4.2069774,11.3516368,0.8565941,1.5924377,2.4830176,2.4846424,7.9851852,0.4980933,3.2159197,1.5602761,4.2161405,2.8014913,5.4294798,2.0771811,15.2817839),(4891,'radius-cleaned.tif',183,3,277,5.2380404,4.2481189,11.3552888,1.8,4.2017945,11.3520667,0.8570306,1.5882975,2.4845028,2.477351,7.9902077,0.4988253,3.2160188,1.5597525,4.2125843,2.7800232,5.4430972,2.018052,15.5171737),(4890,'radius-cleaned.tif',183,3,276,5.2251623,4.2480445,11.3564798,1.8,4.2060061,11.3548397,0.8612575,1.6131823,2.4834548,2.4651168,7.9381682,0.50124,3.1964214,1.528108,4.1881298,2.7651283,5.4620755,2.0083061,15.6026449),(4889,'radius-cleaned.tif',183,3,275,5.2315281,4.2462151,11.3546336,1.8,4.2053675,11.3517637,0.8655125,1.6130035,2.485804,2.4551441,7.9269443,0.5055156,3.1888855,1.5220947,4.1752334,2.7575474,5.4540543,2.099924,15.4470551),(4888,'radius-cleaned.tif',183,3,274,5.2402174,4.2435288,11.3493171,1.8,4.2005573,11.3427752,0.8666686,1.6132326,2.4915212,2.4487143,7.9410275,0.5073518,3.1872205,1.5178929,4.1686668,2.7640946,5.4780827,2.0311866,15.5131636),(4887,'radius-cleaned.tif',183,3,273,5.2332207,4.2442614,11.3472813,1.8,4.2025555,11.342282,0.8707669,1.6109327,2.4923233,2.4432284,7.9298822,0.5101994,3.1817229,1.5166545,4.1602752,2.7413215,5.4785186,2.0474725,15.7251805),(4886,'radius-cleaned.tif',183,3,272,5.2180481,4.2486279,11.3494587,1.8,4.208825,11.3457972,0.8763903,1.6071203,2.48741,2.4455165,7.8809018,0.5135349,3.1683163,1.5216761,4.14909,2.7391504,5.4696484,1.9756881,15.4841195),(4885,'radius-cleaned.tif',183,3,271,5.2012086,4.248987,11.3461619,1.8,4.2077823,11.3397217,0.8806949,1.6050608,2.4893378,2.4407744,7.8680307,0.5155445,3.1606922,1.5206741,4.1383174,2.7421314,5.4959264,2.0376907,15.2293669),(4884,'radius-cleaned.tif',183,3,270,5.1970249,4.2493399,11.3422211,1.8,4.2087981,11.3377311,0.8843667,1.6040162,2.5170932,2.4424861,7.8568333,0.5182504,3.1213915,1.5227315,4.0863135,2.7421314,5.4982433,2.0052315,15.9081534),(4883,'radius-cleaned.tif',183,3,269,5.1900534,4.2499606,11.3378985,1.8,4.2122209,11.3369966,0.8894927,1.6269732,2.5193609,2.442041,7.8564368,0.5218981,3.1184245,1.5009719,4.0814737,2.7450924,5.5178975,1.9956285,15.6767737),(4882,'radius-cleaned.tif',183,3,268,5.196701,4.2469375,11.3282029,1.8,4.2103447,11.3291752,0.8952692,1.6243706,2.5279691,2.4483776,7.8886418,0.5274556,3.1205452,1.5072778,4.0818391,2.7494598,5.5186187,2.0764903,15.6767737),(4881,'radius-cleaned.tif',183,3,267,5.1985476,4.2454591,11.3213969,1.8,4.2121807,11.3265026,0.9013487,1.6206819,2.5332622,2.4462908,7.868668,0.5327767,3.1061404,1.5094207,4.0634321,2.7320075,5.5220794,1.9794832,15.5832822),(4880,'radius-cleaned.tif',183,3,266,5.2192575,4.2437863,11.3125537,1.8,4.2117751,11.3207382,0.9077325,1.6244974,2.5401708,2.4531724,7.8888364,0.5402953,3.1056323,1.5101116,4.061779,2.7498108,5.5344624,2.0021971,15.709828),(4879,'radius-cleaned.tif',183,3,265,5.227113,4.2445017,11.3041033,1.8,4.2145018,11.3149445,0.9137034,1.6237226,2.5453356,2.4519077,7.8711259,0.5461477,3.0923725,1.5100534,4.0450859,2.7290226,5.558716,1.9766306,15.418011),(4878,'radius-cleaned.tif',183,3,264,5.2291107,4.2443537,11.2939741,1.8,4.215648,11.3054524,0.9205387,1.622179,2.5521687,2.4566328,7.8860207,0.5521079,3.0899293,1.5144031,4.0406462,2.7489406,5.5907007,1.9897453,15.7195093),(4877,'radius-cleaned.tif',183,3,263,5.2015731,4.2455269,11.2875087,1.8,4.2179872,11.301061,0.925873,1.6289093,2.5555506,2.4552652,7.8665869,0.5536503,3.0782357,1.5073063,4.0261373,2.755598,5.5907007,1.9897453,16.1338619),(4876,'radius-cleaned.tif',183,3,262,5.1808042,4.2471583,11.2800746,1.8,4.2199061,11.2932736,0.9307675,1.6293685,2.559508,2.462695,7.8681435,0.5554944,3.0740844,1.5114414,4.022595,2.7786023,5.6215123,2.0185723,15.7428822),(4875,'radius-cleaned.tif',183,3,261,5.1668221,4.2468407,11.273391,1.8,4.2213211,11.2901259,0.9342393,1.6209257,2.5643229,2.4608342,7.8784404,0.5568565,3.0723277,1.518166,4.0177014,2.7524652,5.6236359,2.0027086,15.630028),(4874,'radius-cleaned.tif',183,3,260,5.1552229,4.2465791,11.2649219,1.8,4.2210412,11.2826142,0.9399702,1.627742,2.5700345,2.4707459,7.8840993,0.5603054,3.0677017,1.5178978,4.0135499,2.7690114,5.6462379,1.9394922,16.0153365),(4873,'radius-cleaned.tif',183,3,259,5.1591805,4.2488718,11.2567583,1.8,4.2234933,11.2734258,0.9474124,1.6725966,2.5735694,2.4846568,7.9145178,0.5668168,3.0753077,1.4855087,4.0234878,2.769978,5.653564,1.9617872,15.8831195),(4872,'radius-cleaned.tif',183,3,258,5.1609258,4.2512813,11.2490069,1.8,4.2272658,11.2688748,0.9536642,1.638977,2.576954,2.486856,7.9552726,0.5720953,3.0870837,1.517322,4.0334332,2.769978,5.6598964,1.9997575,15.8073296),(4871,'radius-cleaned.tif',183,3,257,5.179436,4.2544079,11.241707,1.8,4.2349452,11.2675914,0.9592994,1.6713966,2.5796957,2.4833859,7.9955902,0.5787298,3.0994316,1.4858149,4.042225,2.782214,5.684455,1.9747665,15.6146754),(4870,'radius-cleaned.tif',183,3,256,5.2182005,4.2546304,11.2319514,1.8,4.2366307,11.2598401,0.9664209,1.6683343,2.5857074,2.4865192,8.0385033,0.5888686,3.1088218,1.4904203,4.0486513,2.7556641,5.7162931,1.9876032,16.1378721),(4869,'radius-cleaned.tif',183,3,255,5.253879,4.2551735,11.2198166,1.8,4.237204,11.2469872,0.9733309,1.6669464,2.6159614,2.4986544,8.0723782,0.5985384,3.0858171,1.4989411,4.0124773,2.7601586,5.7490626,2.0002957,15.8500652),(4868,'radius-cleaned.tif',183,3,254,5.2796929,4.2550945,11.207605,1.8,4.2347663,11.2341266,0.9810262,1.663856,2.6014819,2.5113419,8.1194354,0.6077586,3.1210808,1.5093505,4.0608329,2.7518052,5.7645491,2.0530177,16.0911263),(4867,'radius-cleaned.tif',183,3,253,5.2973079,4.2566522,11.1946134,1.8,4.2382677,11.223632,0.9868393,1.6647786,2.6097172,2.5111585,8.1931766,0.6145192,3.1394883,1.5084039,4.0750249,2.773853,5.8054159,1.9883228,16.1378721),(4866,'radius-cleaned.tif',183,3,252,5.2979223,4.254764,11.1761275,1.8,4.2366695,11.2066135,0.9934018,1.6646421,2.6242171,2.5143976,8.2382446,0.6199061,3.1393152,1.5104734,4.0695636,2.773853,5.8163747,1.957672,16.5151603),(4865,'radius-cleaned.tif',183,3,251,5.2802856,4.2554166,11.1618722,1.8,4.2379305,11.1938249,0.9989649,1.6654293,2.6340984,2.5195294,8.2506796,0.6223096,3.1322594,1.5128408,4.0599911,2.768147,5.8385032,1.9487646,16.4627433),(4864,'radius-cleaned.tif',183,3,250,5.2818382,4.2555905,11.1470041,1.8,4.2374966,11.1759243,1.0028657,1.6682551,2.6452933,2.5312898,8.2927773,0.6256124,3.1349179,1.5173278,4.0628824,2.7767991,5.8701838,1.9247938,16.4200077),(4863,'radius-cleaned.tif',183,3,249,5.314738,4.2544129,11.1324962,1.8,4.2364852,11.1606354,1.0075216,1.6685673,2.6566875,2.5449542,8.3530918,0.6332413,3.1441756,1.5252332,4.0723429,2.7704984,5.8992661,1.9739119,16.589289),(4862,'radius-cleaned.tif',183,3,248,5.3584845,4.2528413,11.1195324,1.8,4.2365576,11.1465988,1.0129007,1.7003938,2.6667479,2.5517426,8.4280534,0.6427801,3.1604238,1.5006774,4.0860179,2.7799251,5.9516573,1.9774487,16.6884518),(4861,'radius-cleaned.tif',183,3,247,5.3889786,4.2475596,11.102849,1.8,4.2334472,11.1314382,1.0169653,1.665039,2.6823495,2.5643508,8.5052069,0.6497107,3.1708049,1.5401146,4.0945946,2.7652999,5.9727516,1.9686707,16.8480518),(4860,'radius-cleaned.tif',183,3,246,5.403209,4.2431776,11.0851707,1.8,4.2307475,11.1152211,1.0201495,1.6999497,2.6986203,2.5824036,8.6054189,0.6539877,3.1888216,1.5191059,4.1132042,2.7925931,6.0163063,1.9513027,16.7351975),(4859,'radius-cleaned.tif',183,3,245,5.4135656,4.239359,11.0642702,1.8,4.2290866,11.0928438,1.02319,1.7031669,2.717406,2.5946752,8.6889603,0.6576839,3.1975201,1.5234416,4.1200866,2.7956358,6.0387567,1.942714,17.2760959),(4858,'radius-cleaned.tif',183,3,244,5.4248082,4.2345875,11.0437882,1.8,4.2265566,11.0718846,1.0271854,1.7037864,2.7360202,2.6086003,8.7931432,0.6622546,3.2138444,1.5310607,4.1345123,2.7762594,6.0617807,1.9696381,17.6847773),(4857,'radius-cleaned.tif',183,3,243,5.4486136,4.2284815,11.0195378,1.8,4.2233556,11.0493269,1.0322461,1.7033809,2.7581882,2.6389757,8.9663691,0.6692185,3.2508185,1.5492575,4.1737922,2.7880053,6.1052217,1.9525163,17.8033027),(4856,'radius-cleaned.tif',183,3,242,5.4666388,4.2190214,10.9946704,1.8,4.2131773,11.0270576,1.0365225,1.7013422,2.7828778,2.6621493,9.1339628,0.6748555,3.2822004,1.5647348,4.2039761,2.8247684,6.1647761,1.9416876,17.172923),(4855,'radius-cleaned.tif',183,3,241,5.4829029,4.2115064,10.9686159,1.8,4.2076306,11.0043073,1.0409813,1.7010352,2.8075296,2.6920802,9.3052437,0.6804259,3.3143884,1.5826129,4.2376537,2.8119208,6.1941459,1.953695,17.1672518),(4854,'radius-cleaned.tif',183,3,240,5.5048656,4.2019639,10.9402027,1.8,4.1977735,10.9764286,1.0431981,1.7035494,2.836068,2.727933,9.5051107,0.6849231,3.3515101,1.6013231,4.2781139,2.8252084,6.2110859,1.9250557,17.4300247),(4853,'radius-cleaned.tif',183,3,239,5.5385,4.1949186,10.9131648,1.8,4.1952262,10.9526932,1.045016,1.7080582,2.8623219,2.7570426,9.6890294,0.6905663,3.3850244,1.6141386,4.3137694,2.849868,6.2459753,1.9026475,17.0720992),(4852,'radius-cleaned.tif',183,3,238,5.5809374,4.1888264,10.8855649,1.8,4.1913937,10.9261572,1.0514656,1.70572,2.8869082,2.7831393,9.8545261,0.7010467,3.4135225,1.6316507,4.3415599,2.8612399,6.2830784,1.9548404,17.4493874),(4851,'radius-cleaned.tif',183,3,237,5.6028384,4.1873749,10.8610149,1.8,4.1898986,10.9015774,1.0575295,1.7061777,2.9066949,2.8062854,10.0382042,0.7086598,3.4534771,1.644779,4.3817752,2.8461175,6.3371955,1.9244086,17.731523),(4850,'radius-cleaned.tif',183,3,236,5.6232518,4.188542,10.8410882,1.8,4.1855495,10.8758311,1.0656497,1.7027287,2.9203918,2.8324056,10.2179623,0.7177202,3.4988327,1.6634508,4.4289296,2.8595554,6.398572,1.9142397,17.6694247),(4849,'radius-cleaned.tif',183,3,235,5.6296557,4.1958465,10.8256922,1.8,4.1904982,10.857783,1.0737497,1.702164,2.9271687,2.8526448,10.3410054,0.7249416,3.5327671,1.675893,4.4653636,2.8828867,6.4511034,1.859291,17.4670891),(4848,'radius-cleaned.tif',183,3,234,5.6667808,4.1985029,10.8079303,1.8,4.1888164,10.8372338,1.0841666,1.6941255,2.9372785,2.8728545,10.5351622,0.7379131,3.5867087,1.6957743,4.5183889,2.874977,6.4871561,1.9158889,18.0563942),(4847,'radius-cleaned.tif',183,3,233,5.7589409,4.2029588,10.7868108,1.8,4.1906223,10.8089913,1.0942228,1.6894084,2.9496089,2.8956458,10.8250852,0.7578384,3.670007,1.7139999,4.6012964,2.874977,6.562307,1.8733185,18.4417027),(4846,'radius-cleaned.tif',183,3,232,5.8904731,4.2066691,10.7708466,1.8,4.1937542,10.794097,1.1036343,1.6824119,2.9579403,2.9237621,11.1685126,0.7826289,3.7757735,1.7378396,4.7088182,2.874977,6.6385257,1.8697371,18.2917841),(4845,'radius-cleaned.tif',183,3,231,6.0196045,4.2081327,10.7529575,1.8,4.1927408,10.7698233,1.1106239,1.6784877,2.9700654,2.9539532,11.4839547,0.8053959,3.8665663,1.7598896,4.8022713,2.8788952,6.6775009,1.8244704,18.1402044),(4844,'radius-cleaned.tif',183,3,230,6.1682742,4.2074142,10.7296073,1.8,4.1902014,10.7364075,1.116447,1.6769576,2.9885953,2.9948402,11.9539691,0.8300301,3.9998621,1.7858771,4.9401606,2.8944876,6.7770125,1.9130282,18.8270112),(4843,'radius-cleaned.tif',183,3,229,6.3014624,4.2077663,10.7102327,1.8,4.1927222,10.7120897,1.1237859,1.6713831,3.0023539,3.0566044,12.4106813,0.8539965,4.1336504,1.8287874,5.0851509,2.9253743,6.8239501,1.8370484,18.0861264),(4842,'radius-cleaned.tif',183,3,228,6.4348115,4.1993991,10.6820961,1.8,4.1821938,10.6759909,1.1279389,1.6676947,3.0293116,3.1139452,12.8986155,0.8755291,4.2579362,1.8672154,5.2165904,2.9952375,6.9017776,1.894375,18.8543943),(4841,'radius-cleaned.tif',183,3,227,6.540445,4.1906597,10.6470731,1.8,4.172007,10.6338955,1.1342927,1.6618188,3.061537,3.1671797,13.4595487,0.8952371,4.3963371,1.9058514,5.3576722,2.9970664,7.0320285,1.8584488,19.0196655),(4840,'radius-cleaned.tif',183,3,226,6.6004851,4.1846105,10.6146765,1.8,4.1646362,10.5957443,1.1394556,1.6230198,3.0908332,3.2089183,13.9142525,0.9077884,4.5017804,1.9771283,5.4645161,2.9970664,7.0789619,1.8800698,20.1482079),(4839,'radius-cleaned.tif',183,3,225,6.6698506,4.1746148,10.5703628,1.8,4.1541631,10.5415466,1.1483001,1.6133782,3.1306692,3.2759415,14.4927699,0.9247397,4.6292881,2.0304858,5.5949673,2.965078,7.2346745,1.8559141,20.4907808),(4838,'radius-cleaned.tif',183,3,224,6.7450716,4.1646961,10.5209281,1.8,4.1433325,10.4852614,1.1582195,1.6025553,3.1744849,3.3570546,15.1677433,0.9434354,4.7780171,2.0948136,5.7486407,2.9715384,7.3841956,1.82757,20.4907808),(4837,'radius-cleaned.tif',183,3,223,6.7960524,4.1539747,10.4629041,1.8,4.1324262,10.4285721,1.1691786,1.5908285,3.225821,3.439014,15.9592476,0.9595924,4.9473445,2.1617755,5.9198169,2.9929263,7.4885616,1.7692368,20.123174),(4836,'radius-cleaned.tif',183,3,222,6.8867336,4.138954,10.3813717,1.8,4.1144398,10.3364403,1.1825048,1.6138593,3.2990094,3.5480188,17.1326251,0.9832605,5.1932636,2.1984684,6.1669346,3.0081801,7.8172442,1.7711949,21.3919537),(4835,'radius-cleaned.tif',183,3,221,7.0167458,4.1199812,10.2838152,1.8,4.0906034,10.2324116,1.1980372,1.5572019,3.38993,3.6459031,18.7146155,1.0143504,5.5206495,2.3413168,6.4886774,3.0260668,8.1623544,1.7825725,22.1956249),(4834,'radius-cleaned.tif',183,3,220,7.1957973,4.1024384,10.1766013,1.8,4.0750106,10.1296276,1.2134342,1.5391385,3.6282654,3.7579512,20.6518393,1.0525496,5.6919318,2.4415939,6.7161579,3.0467205,8.3742489,1.7868813,22.6139877),(4833,'radius-cleaned.tif',183,3,219,7.4356878,4.0819828,10.0634589,1.8,4.0565753,10.0277783,1.226657,1.5227496,3.6328552,3.8786353,22.7878534,1.0982142,6.2727117,2.5471261,7.2569735,3.0542803,8.6132264,1.8045395,22.8300148),(4832,'radius-cleaned.tif',183,3,218,7.6916806,4.0676237,9.9687298,1.8,4.0475941,9.9519798,1.2366198,1.5123491,3.6748333,4.0079468,24.6716962,1.1440371,6.7136912,2.6501466,7.6620388,3.0663523,8.7001218,1.8068764,22.8670792),(4831,'radius-cleaned.tif',183,3,217,7.9589846,4.0599844,9.8990827,1.8,4.044113,9.8986612,1.2455339,1.5014319,3.7367813,4.1649862,26.454315,1.1910395,7.079439,2.7740094,8.0423208,3.0676839,8.7297154,1.8013636,23.5208318),(4830,'radius-cleaned.tif',183,3,216,8.2427416,4.0558231,9.8484472,1.8,4.0432052,9.8620437,1.2520808,1.4937752,3.7938189,4.338678,28.1964458,1.2389028,7.4322065,2.9045052,8.400272,3.06767,8.7578457,1.81467,23.2620691),(4829,'radius-cleaned.tif',183,3,215,8.524642,4.0524549,9.8091454,1.8,4.0438938,9.8330311,1.2573404,1.496591,3.8280911,4.5255738,29.784804,1.2856886,7.7805891,3.0239215,8.7775106,3.1070449,8.7875167,1.8278889,23.8303504),(4828,'radius-cleaned.tif',183,3,214,8.7499249,4.0483375,9.7779021,1.8,4.0415532,9.8051588,1.2612572,1.492983,3.8559774,4.7165011,31.0263409,1.3229986,8.0462974,3.1591123,9.0761468,3.0877395,8.8160946,1.8223611,23.5054792),(4827,'radius-cleaned.tif',183,3,213,8.8859607,4.0428219,9.7494132,1.8,4.0346955,9.7752023,1.2628579,1.4962572,3.8835124,4.8957698,31.8712443,1.3449399,8.206809,3.2720109,9.2714029,3.0875314,8.8258405,1.8080997,23.552225),(4826,'radius-cleaned.tif',183,3,212,8.9374504,4.0424027,9.729306,1.8,4.0346006,9.7522276,1.2633515,1.5121972,3.9024069,5.0758424,32.3279003,1.3531576,8.2840926,3.3566009,9.3899417,3.1239735,8.8362964,1.8311079,23.6884521),(4825,'radius-cleaned.tif',183,3,211,8.931667,4.0429891,9.7107566,1.8,4.0355492,9.7340988,1.2625198,1.5527829,3.9205672,5.2418445,32.3648705,1.3515669,8.2551501,3.3757743,9.4033162,3.1317483,8.8547443,1.8212394,23.5755979),(4824,'radius-cleaned.tif',183,3,210,8.9087057,4.0437059,9.6905097,1.8,4.0360154,9.7155609,1.2632437,1.5614021,3.9390743,5.3978523,32.197324,1.3487133,8.17383,3.4570547,9.3597904,3.169993,8.8571712,1.8398141,23.764242),(4823,'radius-cleaned.tif',183,3,209,8.8937677,4.0458389,9.6704124,1.8,4.0405895,9.7053475,1.2619424,1.5589895,3.9585914,5.5208625,32.0739646,1.3453366,8.1023681,3.5413082,9.3212277,3.1610174,8.84665,1.8354661,23.9101504),(4822,'radius-cleaned.tif',183,3,208,8.9008796,4.0447602,9.6482424,1.8,4.039468,9.6879874,1.2600524,1.5801708,3.9814823,5.6447646,32.0383002,1.3447842,8.0468272,3.5722496,9.2970729,3.1789685,8.8571712,1.8398141,23.7956351),(4821,'radius-cleaned.tif',183,3,207,8.9287672,4.046696,9.6341593,1.8,4.041774,9.67788,1.2581017,1.6141397,3.9957604,5.7277149,32.0128882,1.3473028,8.0117137,3.548463,9.2850464,3.1942454,8.8571712,1.8398141,23.711825),(4820,'radius-cleaned.tif',183,3,206,8.9420376,4.0483813,9.6263599,1.8,4.0424117,9.6749768,1.2572416,1.6576145,4.0032992,5.8063612,31.884401,1.348554,7.9645312,3.5028417,9.2589912,3.1854245,8.8571712,1.8398141,23.8343606),(4819,'radius-cleaned.tif',183,3,205,8.9245802,4.0526044,9.629203,1.8,4.0450673,9.6799349,1.2556727,1.6663866,4.0128061,5.8548111,31.8117935,1.3445489,7.927568,3.5134771,9.2199807,3.2117022,8.8403493,1.8497159,23.5602453),(4818,'radius-cleaned.tif',183,3,204,8.8414601,4.0618828,9.6405371,1.8,4.05422,9.6932779,1.2550438,1.6888071,3.9872421,5.8619011,31.7651051,1.3314796,7.9666858,3.4710306,9.2864224,3.219345,8.8362964,1.8311079,23.7351979),(4817,'radius-cleaned.tif',183,3,203,8.6914814,4.0755815,9.658901,1.8,4.0676819,9.7147839,1.2553146,1.6928612,3.9653388,5.817029,31.4982889,1.3091251,7.9434042,3.4362114,9.2613007,3.2285855,8.8081455,1.8366511,23.8867776),(4816,'radius-cleaned.tif',183,3,202,8.5079056,4.0893082,9.6793333,1.8,4.0795911,9.7357743,1.2561649,1.6994573,3.9410528,5.7210428,30.9799002,1.282185,7.8608184,3.366394,9.1645375,3.21595,8.7910487,1.8466022,23.9004691),(4815,'radius-cleaned.tif',183,3,201,8.2720898,4.0996161,9.6996331,1.8,4.0920076,9.7627876,1.2574174,1.6949405,3.9176704,5.5793966,30.201974,1.247661,7.7091666,3.2917949,8.9859847,3.2008626,8.7977467,1.8322751,23.7078148),(4814,'radius-cleaned.tif',183,3,200,8.0388905,4.1034481,9.7056419,1.8,4.0967802,9.772728,1.2563331,1.6940183,3.9238824,5.4372976,29.1969418,1.2116346,7.44083,3.2097042,8.6719063,3.2001877,8.7696535,1.8378465,23.6747606),(4813,'radius-cleaned.tif',183,3,199,7.8088474,4.1082793,9.7093264,1.8,4.1029802,9.7783656,1.2547948,1.6918032,3.9200192,5.2668211,27.995769,1.1757819,7.1417428,3.1131406,8.3400626,3.191558,8.7311742,1.8390524,23.4861165),(4812,'radius-cleaned.tif',183,3,198,7.6028479,4.1114054,9.7146963,1.8,4.1021522,9.78312,1.2533997,1.6916299,3.9149632,5.0854672,26.9287567,1.1437182,6.8784189,3.0062529,8.0395758,3.1768327,8.7191317,1.815775,23.2410453),(4811,'radius-cleaned.tif',183,3,197,7.4216974,4.1231889,9.7329983,1.8,4.1112552,9.8038758,1.2558964,1.6840711,3.8920817,4.9202326,25.8899153,1.1182924,6.6519455,2.92163,7.7796208,3.1757758,8.6927077,1.840269,23.3168351),(4810,'radius-cleaned.tif',183,3,196,7.2641857,4.1339665,9.7547846,1.8,4.1202759,9.8294226,1.2587955,1.6535823,3.8658996,4.7472407,24.9945989,1.0966178,6.465403,2.8708826,7.5562063,3.1485806,8.6718042,1.8313987,23.5715877),(4809,'radius-cleaned.tif',183,3,195,7.1208822,4.1384343,9.7737041,1.8,4.1225024,9.8470005,1.2579146,1.6324035,3.8471739,4.5664509,24.2397477,1.0743727,6.3006635,2.7973788,7.353501,3.1474801,8.6429334,1.7989793,23.6006318),(4808,'radius-cleaned.tif',183,3,194,7.0092364,4.1396256,9.8026681,1.8,4.1256864,9.8828097,1.2574517,1.6091967,3.8195942,4.3754801,23.7436809,1.0572111,6.2162836,2.7190461,7.2259603,3.0920467,8.6030546,1.8191496,23.3749233),(4807,'radius-cleaned.tif',183,3,193,6.9189671,4.1349963,9.8209684,1.8,4.1220257,9.9003237,1.2534295,1.6113709,3.8066147,4.1971997,23.2737747,1.0408604,6.1140347,2.6047384,7.0844147,3.0397918,8.5652209,1.8010868,23.3555606),(4806,'radius-cleaned.tif',183,3,192,6.8557696,4.1275817,9.8374922,1.8,4.1148267,9.9216507,1.2484538,1.6141829,3.7969201,4.0280916,22.845126,1.0279593,6.0167518,2.4954369,6.9495941,2.9860176,8.5528516,1.7727664,23.4313504),(4805,'radius-cleaned.tif',183,3,191,6.8057173,4.1196177,9.8548752,1.8,4.1091662,9.9494412,1.246084,1.595496,3.7847108,3.8673083,22.488655,1.0188339,5.9419744,2.4238909,6.8356417,2.8892353,8.5218967,1.7782926,23.0033063),(4804,'radius-cleaned.tif',183,3,190,6.7418023,4.1091933,9.8593158,1.8,4.0990786,9.954034,1.2413251,1.5734081,3.787343,3.7295234,22.0327334,1.0060118,5.8174646,2.3703471,6.6793945,2.8603462,8.5062835,1.812362,22.9565606),(4803,'radius-cleaned.tif',183,3,189,6.6747347,4.1004055,9.8642413,1.8,4.0915463,9.9634699,1.2356231,1.5805686,3.7896805,3.581221,21.7058823,0.9920917,5.7276285,2.2657802,6.5560263,2.850517,8.5084355,1.7930258,22.8163233),(4802,'radius-cleaned.tif',183,3,188,6.6298929,4.0948904,9.8733532,1.8,4.0886178,9.980385,1.2318573,1.5835829,3.7855973,3.466251,21.4298268,0.9828293,5.6608839,2.1888661,6.4632499,2.850517,8.4997304,1.7884469,22.674425),(4801,'radius-cleaned.tif',183,3,187,6.5772907,4.092485,9.8858117,1.8,4.0886463,9.9993036,1.2299362,1.5828662,3.7760203,3.3480273,21.1538208,0.9737075,5.602147,2.1151676,6.376743,2.8336149,8.4875471,1.8032329,22.7929504),(4800,'radius-cleaned.tif',183,3,186,6.5271051,4.0930809,9.9036902,1.8,4.0906112,10.0230709,1.228993,1.5802281,3.7596452,3.22884,20.9175942,0.9656307,5.563715,2.0432747,6.3100988,2.850517,8.4438245,1.7802395,22.8026318),(4799,'radius-cleaned.tif',183,3,185,6.4818983,4.0925561,9.9231699,1.8,4.089564,10.0464601,1.2275904,1.5773064,3.7290477,3.123086,20.6593287,0.9579841,5.5401085,1.9800123,6.2750151,2.8289639,8.4132253,1.7858645,22.2640825),(4798,'radius-cleaned.tif',183,3,184,6.4576369,4.0926475,9.9445752,1.8,4.0902354,10.0688901,1.2277633,1.5696874,3.7087416,3.0301595,20.4759518,0.9545163,5.5209971,1.9304223,6.2326612,2.83817,8.4046111,1.7570192,22.3318521),(4797,'radius-cleaned.tif',183,3,183,6.4503936,4.0923048,9.9673835,1.8,4.0923622,10.0968843,1.2262405,1.5660803,3.6884281,2.9391659,20.4194866,0.9524067,5.5360945,1.8767657,6.2258171,2.83817,8.372918,1.7625845,22.1665809),(4796,'radius-cleaned.tif',183,3,182,6.4983976,4.0871445,9.9804583,1.8,4.0886188,10.1108469,1.2253504,1.5833923,3.6784833,2.8747342,20.5441669,0.9588808,5.5849559,1.815554,6.2563321,2.8407848,8.3575026,1.7775549,22.2133266),(4795,'radius-cleaned.tif',183,3,181,6.5073533,4.081907,9.9878307,1.8,4.0848833,10.1207058,1.222544,1.5599635,3.6752718,2.8094458,20.3796819,0.9582562,5.5450816,1.800969,6.2010613,2.8407848,8.343967,1.7925773,21.9215096),(4794,'radius-cleaned.tif',183,3,180,6.4595012,4.0820323,10.0053656,1.8,4.0863716,10.1415142,1.2200381,1.5612137,3.6604798,2.7342371,19.999103,0.9494737,5.4635196,1.7513536,6.1039031,2.8475298,8.3050489,1.7936341,21.559574),(4793,'radius-cleaned.tif',183,3,179,6.3763463,4.0857374,10.0281353,1.8,4.08956,10.1609491,1.2188512,1.5976639,3.6386414,2.6612506,19.5422628,0.9364356,5.370758,1.6657137,5.9961891,2.8562813,8.2945951,1.7644183,21.4700927),(4792,'radius-cleaned.tif',183,3,178,6.2798652,4.0874778,10.051511,1.8,4.0902566,10.182794,1.2182896,1.5790232,3.6164875,2.5817609,19.1515566,0.9218857,5.2956236,1.6350367,5.902596,2.8542748,8.2712423,1.7748143,21.6353639),(4791,'radius-cleaned.tif',183,3,177,6.1979103,4.0869801,10.0751994,1.8,4.0910578,10.2097397,1.2183685,1.5464884,3.5943723,2.513101,18.8079581,0.9099075,5.2326127,1.6250371,5.8222907,2.858848,8.2554442,1.7653483,21.9231707),(4790,'radius-cleaned.tif',183,3,176,6.1398609,4.0880985,10.1037728,1.8,4.0950031,10.2431268,1.2191388,1.5355634,3.5666217,2.4611763,18.5917051,0.9018956,5.2126934,1.6027839,5.7885585,2.858848,8.2331407,1.7510833,21.5555639),(4789,'radius-cleaned.tif',183,3,175,6.1091566,4.0853911,10.1289994,1.8,4.0934988,10.2710761,1.2201931,1.5214644,3.5431071,2.4150249,18.4759774,0.8980788,5.2146258,1.5873029,5.7759362,2.858848,8.2011732,1.756742,21.5225096),(4788,'radius-cleaned.tif',183,3,174,6.1088933,4.0797033,10.1452473,1.8,4.0902166,10.2899376,1.2208516,1.5087588,3.515635,2.3643128,18.3838369,0.8984723,5.2291654,1.5670582,5.7872193,2.8592147,8.1867957,1.7471625,21.4467198),(4787,'radius-cleaned.tif',183,3,173,6.0998847,4.0742891,10.15259,1.8,4.0850958,10.2959222,1.2210396,1.5006472,3.4967875,2.3090422,18.1587274,0.8972704,5.1929742,1.5386976,5.747685,2.8650898,8.1546466,1.752838,21.7675808),(4786,'radius-cleaned.tif',183,3,172,6.0652068,4.0702142,10.1657043,1.8,4.0847708,10.3192313,1.2190482,1.4976845,3.4872142,2.2537595,17.9176558,0.8908703,5.1381001,1.5048293,5.6790374,2.8775733,8.1546466,1.752838,21.3685808),(4785,'radius-cleaned.tif',183,3,171,5.9937591,4.0669581,10.180148,1.8,4.0839786,10.3385688,1.2184718,1.5286436,3.4751697,2.2056478,17.5611327,0.8800032,5.0533165,1.4428791,5.5818849,2.8562496,8.1338283,1.7383644,21.5088181),(4784,'radius-cleaned.tif',183,3,170,5.9165981,4.0631667,10.2007735,1.8,4.0810133,10.3647144,1.2192149,1.5160019,3.4566047,2.1509781,17.2945494,0.8691486,5.0033344,1.4188493,5.5155162,2.8811506,8.1029427,1.7140861,21.425008),(4783,'radius-cleaned.tif',183,3,169,5.8561205,4.0631163,10.225925,1.8,4.0852133,10.3894437,1.2219132,1.4865718,3.4174605,2.1150401,17.0950221,0.861962,5.0022589,1.4227635,5.5147438,2.891616,8.0878985,1.7343229,21.212991),(4782,'radius-cleaned.tif',183,3,168,5.8041118,4.0596974,10.2509731,1.8,4.0823168,10.4116119,1.2223968,1.4496738,3.4083796,2.0771071,16.9445282,0.8546073,4.9714323,1.4328099,5.4585581,2.8593643,8.0689799,1.7497653,21.452391),(4781,'radius-cleaned.tif',183,3,167,5.7489545,4.0569439,10.2709257,1.8,4.0811668,10.4303836,1.2227881,1.4767645,3.3902778,2.0323056,16.7044397,0.8467263,4.9271595,1.376188,5.4007378,2.8687633,8.055157,1.7400166,21.2540655),(4780,'radius-cleaned.tif',183,3,166,5.6897818,4.0532127,10.284041,1.8,4.0766423,10.4404532,1.2215177,1.4720561,3.3665093,1.9849411,16.4035075,0.8372376,4.8725567,1.3484141,5.347023,2.8677258,8.0206942,1.7711187,21.0574011),(4779,'radius-cleaned.tif',183,3,165,5.6525667,4.0524258,10.303449,1.8,4.0764039,10.4536419,1.2183198,1.4590687,3.3507952,1.9367937,16.1914099,0.8298166,4.8321097,1.3274177,5.2960859,2.8677258,8.0128501,1.7056512,21.5572249),(4778,'radius-cleaned.tif',183,3,164,5.6177159,4.0511034,10.3239442,1.8,4.0734767,10.4722549,1.2165315,1.4690542,3.3332763,1.8954164,16.0394087,0.8236131,4.811905,1.2902291,5.2652228,2.8764787,7.9903675,1.7211678,20.9912926),(4777,'radius-cleaned.tif',183,3,163,5.5730401,4.0480318,10.3385438,1.8,4.0680132,10.482367,1.2142992,1.4667256,3.322224,1.8501974,15.865528,0.8157104,4.7755744,1.2614475,5.2172968,2.8691654,7.996442,1.7261012,21.2557266),(4776,'radius-cleaned.tif',183,3,162,5.5256799,4.0469952,10.3540194,1.8,4.0691919,10.5012018,1.2117512,1.4667198,3.3098774,1.8137321,15.6705163,0.807239,4.7344703,1.2365907,5.1681604,2.8896868,7.996442,1.7261012,21.1428723),(4775,'radius-cleaned.tif',183,3,161,5.4878829,4.0430607,10.3624921,1.8,4.0645192,10.5083531,1.2087833,1.4674432,3.30541,1.7712864,15.5165374,0.7999252,4.6942853,1.2070562,5.1176948,2.8896868,7.9580249,1.69142,20.6527299),(4774,'radius-cleaned.tif',183,3,160,5.4440775,4.0442886,10.3780658,1.8,4.0682254,10.529516,1.205634,1.4938708,3.2926025,1.7294916,15.3803505,0.7916405,4.6711835,1.157725,5.0857349,2.8896868,7.9392982,1.7119826,20.973591),(4773,'radius-cleaned.tif',183,3,159,5.4075694,4.0431408,10.3921356,1.8,4.0655024,10.5451405,1.2025071,1.4952778,3.2820333,1.6904577,15.3169199,0.7844451,4.6668996,1.1305308,5.0721613,2.8896868,7.9392982,1.7119826,21.0066452),(4772,'radius-cleaned.tif',183,3,158,5.3741928,4.0445875,10.4055344,1.8,4.0669016,10.5551817,1.1994428,1.4764013,3.2711113,1.6519447,15.232966,0.7777534,4.6568167,1.1188995,5.0537668,2.8916405,7.911477,1.7226788,21.1622351),(4771,'radius-cleaned.tif',183,3,157,5.3362644,4.0445092,10.4230709,1.8,4.0656163,10.5735668,1.1977834,1.5482825,3.2559332,1.6156684,15.0966931,0.7712646,4.6366717,1.043523,5.0241476,2.8896868,7.9233406,1.6970251,20.8550655),(4770,'radius-cleaned.tif',183,3,156,5.2765299,4.0399238,10.4234979,1.8,4.0592983,10.5672548,1.195572,1.5120029,3.2587147,1.5694359,14.8541604,0.7613078,4.5582881,1.0379847,4.9341409,2.8828915,7.911477,1.7226788,20.8744282),(4769,'radius-cleaned.tif',183,3,155,5.2044594,4.0342466,10.421535,1.8,4.0538589,10.5675148,1.191825,1.5164218,3.2651573,1.5236416,14.4919764,0.748684,4.43837,1.0047611,4.8047058,2.9099923,7.8997972,1.7126934,20.9171639),(4768,'radius-cleaned.tif',183,3,154,5.1620329,4.0273409,10.4204732,1.8,4.0470442,10.5672287,1.1907418,1.5500483,3.2694298,1.4951313,14.2295105,0.7419393,4.3522911,0.9645708,4.7107918,2.9015138,7.8889073,1.7026794,20.8744282),(4767,'radius-cleaned.tif',183,3,153,5.1232942,4.0174827,10.4215038,1.8,4.0367744,10.5652201,1.1906551,1.5407178,3.272189,1.4694634,13.9662621,0.7363204,4.2681709,0.9537525,4.617903,2.9035324,7.8997972,1.7126934,21.3081436),(4766,'radius-cleaned.tif',183,3,152,5.0917502,4.0088339,10.4283928,1.8,4.0311089,10.5745786,1.190664,1.5004997,3.2689948,1.4445625,13.7369773,0.7317921,4.2022022,0.962721,4.5431377,2.9015138,7.8651596,1.677532,21.1001367),(4765,'radius-cleaned.tif',183,3,151,5.1057215,4.0005393,10.434458,1.8,4.0238771,10.578669,1.1915256,1.5181066,3.2510606,1.4335583,13.6080404,0.7343049,4.1857234,0.9443067,4.5318041,2.9080492,7.8720386,1.7234457,21.0961266),(4764,'radius-cleaned.tif',183,3,150,5.1005234,3.9912791,10.4364998,1.8,4.0162744,10.5834256,1.1912501,1.5094044,3.2527791,1.4089188,13.4263879,0.7333961,4.1276667,0.933427,4.4650808,2.8965044,7.8392079,1.6932574,20.6624113),(4763,'radius-cleaned.tif',183,3,149,5.0905253,3.98208,10.4383983,1.8,4.0097252,10.5915643,1.1917373,1.4989955,3.268854,1.3854399,13.2398108,0.7322429,4.0502913,0.9242455,4.3679613,2.9131871,7.8266067,1.7191821,20.6664214),(4762,'radius-cleaned.tif',183,3,148,5.0770009,3.9725461,10.4355167,1.8,4.002315,10.5879211,1.1912266,1.4553647,3.2606491,1.3559877,13.0201888,0.7300002,3.9931279,0.9317167,4.3123631,2.9090164,7.8266067,1.7191821,20.5729299),(4761,'radius-cleaned.tif',183,3,147,5.0655595,3.9655297,10.4395122,1.8,3.9981484,10.5988565,1.1913756,1.454515,3.2594331,1.3380889,12.8620687,0.7284417,3.9461061,0.9199554,4.2588124,2.9049068,7.8263015,1.7501938,20.9502181),(4760,'radius-cleaned.tif',183,3,146,5.0351475,3.9622973,10.446721,1.8,3.9952614,10.6085317,1.1901595,1.4812949,3.2547931,1.3091207,12.6700325,0.7233652,3.8927305,0.8837678,4.1977845,2.9048679,7.8124569,1.7401431,21.0203367),(4759,'radius-cleaned.tif',183,3,145,4.9870616,3.9646701,10.4638342,1.8,3.9961,10.621287,1.187709,1.4829272,3.2397496,1.2815452,12.4718151,0.7150484,3.8496232,0.8641997,4.149298,2.9178145,7.7942995,1.7561443,20.8744282),(4758,'radius-cleaned.tif',183,3,144,4.938969,3.9682499,10.4819683,1.8,3.9994326,10.6405022,1.185585,1.4844397,3.22308,1.2561771,12.3163781,0.7069378,3.821307,0.8462298,4.1158706,2.9086922,7.7994042,1.7300578,20.7655842),(4757,'radius-cleaned.tif',183,3,143,4.8835598,3.9705754,10.4969905,1.8,4.0023748,10.6608666,1.181109,1.5282448,3.2113887,1.2265943,12.1812605,0.6964579,3.7931442,0.8026163,4.0829083,2.9185535,7.8098073,1.7040231,21.1839469),(4756,'radius-cleaned.tif',183,3,142,4.8297722,3.971937,10.5092916,1.8,4.0033182,10.6694122,1.1778709,1.5322384,3.201709,1.2029256,12.0555299,0.6869492,3.7653422,0.7850773,4.0508781,2.9234544,7.793176,1.7250027,20.8316926),(4755,'radius-cleaned.tif',183,3,141,4.7726492,3.968922,10.5161681,1.8,3.9991227,10.6746534,1.1770444,1.528704,3.1970758,1.1910021,11.8960646,0.678359,3.7209205,0.7790927,4.0033498,2.9249499,7.793176,1.7250027,20.7365401),(4754,'radius-cleaned.tif',183,3,140,4.7249075,3.9663916,10.5280388,1.8,3.9967945,10.6873093,1.1752417,1.5259001,3.1729469,1.1759418,11.7432552,0.6705655,3.7010564,0.7706545,3.9897151,2.9353825,7.8124569,1.7401431,20.7752655),(4753,'radius-cleaned.tif',183,3,139,4.7096018,3.9638836,10.5410444,1.8,3.9931078,10.6967519,1.175217,1.5186301,3.161928,1.1725229,11.6943073,0.6683796,3.6984736,0.7720925,3.9850336,2.9214724,7.8124569,1.7401431,20.6236858),(4752,'radius-cleaned.tif',183,3,138,4.6726777,3.9633781,10.5583799,1.8,3.9912607,10.7115582,1.1750844,1.5117806,3.1462137,1.1635698,11.5815155,0.6630659,3.6810963,0.7696684,3.9645321,2.9236183,7.8058313,1.7351047,20.8026485),(4751,'radius-cleaned.tif',183,3,137,4.6576686,3.9623552,10.5767178,1.8,3.9880667,10.7251053,1.1754531,1.5397708,3.1294405,1.1577419,11.5282066,0.6611396,3.6837916,0.7518924,3.9640265,2.9368658,7.8124569,1.7401431,20.7695943),(4750,'radius-cleaned.tif',183,3,136,4.6493906,3.9645255,10.5992019,1.8,3.9898415,10.7457906,1.1764167,1.5310076,3.1072019,1.1522347,11.5221076,0.6604948,3.7081941,0.7525989,3.9849252,2.9493879,7.8098073,1.7040231,20.7929672),(4749,'radius-cleaned.tif',183,3,135,4.6253645,3.9650356,10.6162719,1.8,3.9899345,10.7594534,1.1765848,1.5245544,3.091131,1.1437626,11.4656194,0.6571736,3.7091988,0.7502275,3.982373,2.9431269,7.8046075,1.698956,20.5906316),(4748,'radius-cleaned.tif',183,3,134,4.6012623,3.9654862,10.6332523,1.8,3.9914449,10.7784979,1.1771195,1.5388387,3.0749096,1.1428731,11.4308803,0.6540398,3.7174687,0.7426855,3.988932,2.9547292,7.7994042,1.7300578,20.6373773),(4747,'radius-cleaned.tif',183,3,133,4.5661727,3.9651048,10.6456029,1.8,3.9905185,10.7909284,1.1772928,1.5333861,3.0635289,1.1364478,11.3480537,0.6491454,3.7042424,0.7411361,3.9730387,2.9568136,7.7994042,1.7300578,20.8300316),(4746,'radius-cleaned.tif',183,3,132,4.5421021,3.9627178,10.6527543,1.8,3.9864336,10.798173,1.1755828,1.5105448,3.0590389,1.1276903,11.2980508,0.6448051,3.6933335,0.7465454,3.9599348,2.9604523,7.8058313,1.7351047,20.9445469),(4745,'radius-cleaned.tif',183,3,131,4.512944,3.9606986,10.6563352,1.8,3.9841114,10.8018872,1.1750653,1.5298426,3.0568744,1.1218712,11.2384424,0.640389,3.6764489,0.7333246,3.9412688,2.9974532,7.8266067,1.7191821,20.9114926),(4744,'radius-cleaned.tif',183,3,130,4.4908939,3.9584303,10.6611497,1.8,3.980487,10.804401,1.1729257,1.5457964,3.0548068,1.1184618,11.1599691,0.6361184,3.6532488,0.7235506,3.9183982,2.9822883,7.8266067,1.7191821,21.133191),(4743,'radius-cleaned.tif',183,3,129,4.4813703,3.9554605,10.6657678,1.8,3.9765516,10.8088818,1.1717509,1.5437454,3.0525233,1.1191548,11.1426742,0.6341419,3.6503158,0.7249607,3.9156193,2.9774166,7.8266067,1.7191821,20.9155028),(4742,'radius-cleaned.tif',183,3,128,4.4725849,3.9512241,10.6724711,1.8,3.9710576,10.8138412,1.1728234,1.5349818,3.031771,1.126808,11.1310556,0.6334705,3.6714697,0.7340855,3.9473539,2.9774166,7.8388018,1.7292505,20.9719299),(4741,'radius-cleaned.tif',183,3,127,4.455721,3.9480563,10.6808855,1.8,3.9663397,10.820369,1.1729331,1.5498946,3.0406268,1.1254302,11.0999528,0.6311403,3.6505476,0.7261334,3.9138611,2.9798524,7.8266067,1.7191821,21.2968011),(4740,'radius-cleaned.tif',183,3,126,4.4545391,3.9479505,10.694451,1.8,3.9643569,10.8290229,1.1723449,1.5244432,3.0285852,1.1222183,11.1310781,0.6306607,3.6753393,0.7361496,3.936531,3.0095724,7.851789,1.7392867,21.1799367),(4739,'radius-cleaned.tif',183,3,125,4.4532682,3.9490599,10.7151583,1.8,3.9636487,10.8472259,1.1735031,1.5363931,2.9927887,1.1288005,11.168777,0.6310948,3.7318963,0.7347081,4.0032977,3.0144441,7.8603002,1.7134113,21.212991),(4738,'radius-cleaned.tif',183,3,124,4.4204662,3.9477523,10.7244894,1.8,3.9629605,10.8568625,1.1724852,1.5490937,2.9853985,1.1155414,11.0475504,0.6259107,3.7005278,0.7201252,3.9682986,3.0095724,7.8403248,1.6421038,21.1468825),(4737,'radius-cleaned.tif',183,3,123,4.3601256,3.9394465,10.7142183,1.8,3.958053,10.8516185,1.1715236,1.5473965,3.0142679,1.1093534,10.7894181,0.6168667,3.579449,0.7169161,3.8360433,3.0186504,7.851789,1.7392867,20.8397129),(4736,'radius-cleaned.tif',183,3,122,4.2521843,3.9270271,10.6876606,1.8,3.9472238,10.8206235,1.1693724,1.5874812,3.0139542,1.0961831,10.3637485,0.6005009,3.4385886,0.6905172,3.7160892,3.0323472,7.8603002,1.7134113,21.3959639),(4735,'radius-cleaned.tif',183,3,121,4.1574618,3.9156584,10.6695187,1.8,3.9377927,10.8032657,1.1691725,1.5845215,3.0508246,1.1006617,9.98733,0.5870244,3.2736494,0.6946335,3.544282,3.0120083,7.8547284,1.7083831,20.7832858),(4734,'radius-cleaned.tif',183,3,120,4.0829592,3.901953,10.6512684,1.8,3.9214764,10.7815657,1.1708549,1.5754956,3.056266,1.1103663,9.6519059,0.5773273,3.1580713,0.7047727,3.4405583,3.0355255,7.8603002,1.7134113,20.9719299),(4733,'radius-cleaned.tif',183,3,119,4.04191,3.8957061,10.6465677,1.8,3.9162194,10.7749963,1.1718756,1.6061792,3.0623425,1.1207772,9.4666739,0.5720157,3.0913178,0.6977909,3.3766351,3.0397019,7.8660704,1.7184322,21.1218486),(4732,'radius-cleaned.tif',183,3,118,4.0226654,3.8952676,10.6640832,1.8,3.9187657,10.7997496,1.1760173,1.5534897,3.0435277,1.146305,9.3998743,0.5712718,3.08848,0.7378904,3.3785921,3.0446111,7.8845673,1.7334492,21.1839469),(4731,'radius-cleaned.tif',183,3,117,4.0223266,3.8899258,10.6746542,1.8,3.9114489,10.8055842,1.1802593,1.5724678,3.0328182,1.1696825,9.3979679,0.5732344,3.0987574,0.7438515,3.3914415,3.0508757,7.8997972,1.7126934,21.2210113),(4730,'radius-cleaned.tif',183,3,116,4.027121,3.8878081,10.6815096,1.8,3.909588,10.804497,1.181146,1.56605,3.0266459,1.1804598,9.4195523,0.5743363,3.1122082,0.7537817,3.406563,3.0761036,7.8997972,1.7126934,20.8534045),(4729,'radius-cleaned.tif',183,3,115,4.0245239,3.8837691,10.6883064,1.8,3.9056792,10.8105465,1.1806772,1.5607077,3.022234,1.1861456,9.4018167,0.5737449,3.1108831,0.760005,3.4061366,3.0592285,7.911477,1.7226788,21.2347028),(4728,'radius-cleaned.tif',183,3,114,4.018856,3.8770755,10.6914609,1.8,3.8974707,10.8128173,1.1798092,1.5551232,3.0224986,1.1925455,9.4113455,0.5725275,3.1137634,0.7668495,3.4097516,3.0761036,7.9392982,1.7119826,21.4620723),(4727,'radius-cleaned.tif',183,3,113,3.9920726,3.8713649,10.6863007,1.8,3.8916148,10.81065,1.175968,1.559814,3.0322479,1.1881013,9.3642737,0.566904,3.0882283,0.7616942,3.3849878,3.0781918,7.945011,1.7169547,21.6780995),(4726,'radius-cleaned.tif',183,3,112,3.9679989,3.8689847,10.677655,1.8,3.8908667,10.8073406,1.1682263,1.5770726,3.0310141,1.1755488,9.3414085,0.5598219,3.0819416,0.7453993,3.3898118,3.0781918,7.9657232,1.6510258,21.5789367),(4725,'radius-cleaned.tif',183,3,111,3.9698382,3.8695335,10.6785281,1.8,3.8902866,10.8092616,1.1624512,1.5892007,3.0337689,1.1651475,9.4168347,0.5573115,3.1040053,0.7331657,3.4119028,3.0969856,7.9657232,1.6510258,21.1024858),(4724,'radius-cleaned.tif',183,3,110,3.9807778,3.8756781,10.6868449,1.8,3.8960591,10.8209571,1.1552275,1.6428607,3.0443645,1.152648,9.5621495,0.5553304,3.1409345,0.7016103,3.4403744,3.1084005,7.945011,1.7169547,21.4660825),(4723,'radius-cleaned.tif',183,3,109,3.9766614,3.8764021,10.6827057,1.8,3.8936141,10.8129731,1.149746,1.6563134,3.0350933,1.1389105,9.6389277,0.5520591,3.1758259,0.6876178,3.4833427,3.1200154,7.9733142,1.706324,21.3008113),(4722,'radius-cleaned.tif',183,3,108,3.9535772,3.8746045,10.6746603,1.8,3.8925262,10.8059251,1.1457125,1.6661441,3.0455653,1.1330766,9.5341803,0.5468644,3.1305125,0.6800592,3.4391505,3.1320308,7.9690202,1.6560166,21.187957),(4721,'radius-cleaned.tif',183,3,107,3.9256882,3.8672585,10.6652061,1.8,3.8846088,10.794785,1.144847,1.6651131,3.0577173,1.135985,9.3015762,0.542581,3.0420001,0.6822269,3.3521696,3.1407329,7.9801,1.6709625,21.5088181),(4720,'radius-cleaned.tif',183,3,106,3.8980603,3.8550994,10.6590835,1.8,3.868661,10.7846647,1.1449541,1.6926876,3.0682529,1.1471625,9.0364904,0.5388148,2.9451583,0.6777166,3.2580379,3.1546562,7.9364903,1.666463,21.4039842),(4719,'radius-cleaned.tif',183,3,105,3.8559069,3.845301,10.6576806,1.8,3.8556395,10.775864,1.1451799,1.6674103,3.0734415,1.1419619,8.7555111,0.5330973,2.8487646,0.6848716,3.159579,3.1511754,7.9884745,1.680902,21.7111537),(4718,'radius-cleaned.tif',183,3,104,3.8337866,3.8390488,10.6658223,1.8,3.8479711,10.7791974,1.1463158,1.6725205,3.0679074,1.1502571,8.6189084,0.5305844,2.809377,0.6877387,3.1215856,3.1788545,7.9788031,1.711279,21.2443842),(4717,'radius-cleaned.tif',183,3,103,3.8330029,3.836334,10.6810654,1.8,3.8452888,10.7912489,1.1500603,1.6561938,3.0527665,1.1670876,8.6195471,0.5322655,2.8235199,0.7046806,3.1379689,3.1592938,7.996442,1.7261012,21.7345266),(4716,'radius-cleaned.tif',183,3,102,3.8383403,3.8335738,10.6941744,1.8,3.8396958,10.8029841,1.1510987,1.6462266,3.0412556,1.18252,8.640974,0.5335015,2.8412522,0.7183215,3.1588846,3.1606863,7.9788031,1.711279,21.3241842),(4715,'radius-cleaned.tif',183,3,101,3.8411181,3.8376241,10.7113005,1.8,3.8434653,10.8175649,1.1477978,1.6859218,3.0424817,1.1819773,8.6970922,0.5323102,2.858552,0.7010867,3.1690837,3.1882836,7.9844877,1.7162269,21.3766011),(4714,'radius-cleaned.tif',183,3,100,3.8472671,3.8377102,10.7257346,1.8,3.8416061,10.8333703,1.1463858,1.6828477,3.0302485,1.1874382,8.773335,0.5324837,2.8952526,0.7056124,3.2072226,3.1938536,7.95092,1.7219195,21.5555639),(4713,'radius-cleaned.tif',183,3,99,3.8702817,3.8377074,10.7341247,1.8,3.8415306,10.841565,1.1414633,1.6889914,3.0093254,1.1813005,8.9185419,0.5332757,2.9636349,0.6994118,3.2843422,3.2267669,7.9903675,1.7211678,21.7071436),(4712,'radius-cleaned.tif',183,3,98,3.871893,3.8339005,10.7430557,1.8,3.8375673,10.8631331,1.137666,1.6891663,3.0051984,1.1696455,9.037824,0.5316368,3.0073968,0.6924395,3.3246464,3.2281593,7.9903675,1.7211678,21.6216724),(4711,'radius-cleaned.tif',183,3,97,3.8357489,3.8354461,10.7443701,1.8,3.8412532,10.8676296,1.1287075,1.7091768,3.0088599,1.1290163,9.0770262,0.5222774,3.0167659,0.6605614,3.3263235,3.2483516,8.0027109,1.731027,21.347557),(4710,'radius-cleaned.tif',183,3,96,3.7956312,3.8321161,10.7444715,1.8,3.8397915,10.8720924,1.1224755,1.7174855,3.013898,1.0923509,9.087177,0.5137504,3.0150911,0.6360175,3.315622,3.2582876,7.9903675,1.7211678,21.3766011),(4709,'radius-cleaned.tif',183,3,95,3.7632016,3.8291965,10.7494621,1.8,3.8426967,10.8836374,1.1191152,1.7177116,3.0126314,1.070101,9.1291023,0.50771,3.0302752,0.6229806,3.3244716,3.2788378,7.9788031,1.711279,21.240374),(4708,'radius-cleaned.tif',183,3,94,3.7281671,3.8238404,10.7642233,1.8,3.8420345,10.9077121,1.1192899,1.7420217,3.0015851,1.0632671,9.1823891,0.5030686,3.05918,0.6103639,3.3489893,3.2830156,8.0027109,1.731027,21.8159877),(4707,'radius-cleaned.tif',183,3,93,3.6889165,3.8215043,10.7743667,1.8,3.8382282,10.9139496,1.116237,1.7411698,2.9952894,1.0479045,9.2337311,0.4962949,3.0827509,0.6018393,3.3681062,3.2525294,7.9904671,1.7515431,21.3959639),(4706,'radius-cleaned.tif',183,3,92,3.6260848,3.8132587,10.7681695,1.8,3.8234813,10.8920139,1.1134864,1.7774079,3.0060993,1.0175816,9.1305022,0.4865275,3.0373256,0.5725088,3.3135873,3.286149,7.996442,1.7261012,21.6353639),(4705,'radius-cleaned.tif',183,3,91,3.5774727,3.799684,10.7610665,1.8,3.8109066,10.8858248,1.1123762,1.7704236,3.0191242,1.0078344,8.8875446,0.47948,2.9437492,0.5692617,3.2165015,3.286149,7.9788031,1.711279,21.7772622),(4704,'radius-cleaned.tif',183,3,90,3.5423705,3.7738187,10.7332695,1.8,3.7883481,10.8632717,1.114179,1.7919315,3.0544072,1.0047414,8.5859776,0.475619,2.8110127,0.560703,3.0796414,3.2945047,7.9904671,1.7515431,21.7208351),(4703,'radius-cleaned.tif',183,3,89,3.5022408,3.7518405,10.7029659,1.8,3.773315,10.8432692,1.1142199,1.7854882,3.0736805,0.986358,8.2089707,0.4702498,2.67073,0.5524304,2.9400733,3.3176796,7.9765082,1.7417015,21.8901165),(4702,'radius-cleaned.tif',183,3,88,3.4945166,3.7346233,10.6893814,1.8,3.7555102,10.8310428,1.1143423,1.7399721,3.0933923,0.9926944,7.9614908,0.4692691,2.5737088,0.5705232,2.8436979,3.3260353,7.9765082,1.7417015,21.7248452),(4701,'radius-cleaned.tif',183,3,87,3.5041663,3.7255769,10.6952292,1.8,3.7456619,10.831954,1.114695,1.7285867,3.0919192,1.0022726,7.876903,0.4707279,2.5475772,0.579822,2.8191808,3.2945047,7.9765082,1.7417015,21.4700927),(4700,'radius-cleaned.tif',183,3,86,3.5502725,3.7198544,10.707415,1.8,3.740383,10.8439299,1.1173747,1.7487422,3.081853,1.0194501,7.9041536,0.4781729,2.5647406,0.5829619,2.8389137,3.3171703,7.9904671,1.7515431,21.7909537),(4699,'radius-cleaned.tif',183,3,85,3.5709297,3.7128224,10.7198637,1.8,3.7323325,10.8493689,1.1190945,1.7336628,3.0552378,1.0357323,7.8705483,0.4817601,2.5760837,0.5974243,2.8604976,3.3157776,7.9896701,1.7770065,21.6023096),(4698,'radius-cleaned.tif',183,3,84,3.5491462,3.7054688,10.7297194,1.8,3.7273204,10.8571729,1.120572,1.7199096,3.0486748,1.0512263,7.8180567,0.479507,2.5644115,0.6112102,2.8517528,3.320813,7.9765082,1.7417015,21.6684181),(4697,'radius-cleaned.tif',183,3,83,3.5192958,3.6939314,10.7398231,1.8,3.7126156,10.8597565,1.1256805,1.6953152,3.0413409,1.0864967,7.7949067,0.4778124,2.5629836,0.6408818,2.8565995,3.3187241,8.0051972,1.7613494,21.9795978),(4696,'radius-cleaned.tif',183,3,82,3.5004137,3.6876359,10.7536373,1.8,3.7080865,10.8735187,1.1272048,1.7168026,3.0305782,1.1066588,7.7724227,0.4759392,2.5646666,0.6446046,2.8623907,3.3129922,7.9737135,1.7672105,21.8393605),(4695,'radius-cleaned.tif',183,3,81,3.4885844,3.6726275,10.7583,1.8,3.68912,10.8750233,1.1309501,1.6941081,3.0132609,1.1276317,7.7330575,0.4760139,2.5663419,0.6656197,2.8739488,3.3109032,8.0206942,1.7711187,21.7265063),(4694,'radius-cleaned.tif',183,3,80,3.4816563,3.663319,10.7658567,1.8,3.6792043,10.8766139,1.1338767,1.6961503,3.0084303,1.1493049,7.7084757,0.476374,2.5622916,0.6775961,2.8733054,3.2772764,8.0027109,1.731027,22.0690792),(4693,'radius-cleaned.tif',183,3,79,3.4633971,3.6525975,10.7786097,1.8,3.6676634,10.8836612,1.137944,1.690234,2.9818522,1.1617789,7.6634344,0.4756698,2.5700249,0.6873479,2.8888676,3.3082084,8.0051972,1.7613494,21.7248452),(4692,'radius-cleaned.tif',183,3,78,3.4164925,3.6476089,10.7950058,1.8,3.6618061,10.8980535,1.1389957,1.6768485,2.9977782,1.1564299,7.6628078,0.4696835,2.5561623,0.6896449,2.8963683,3.3074214,8.0297203,1.7506498,22.1214962),(4691,'radius-cleaned.tif',183,3,77,3.4040736,3.6504837,10.8108708,1.8,3.6623158,10.9067499,1.1380262,1.6746296,2.9936829,1.1573284,7.6430429,0.4675577,2.5530569,0.6910952,2.92726,3.2710093,8.0051972,1.7613494,21.8046452),(4690,'radius-cleaned.tif',183,3,76,3.4562036,3.6565335,10.842018,1.8,3.6638212,10.936714,1.1391135,1.7013025,3.0275435,1.1952479,7.6965504,0.4751943,2.5421766,0.7025487,2.9255118,3.2352934,8.0239686,1.7155063,21.9408724),(4689,'radius-cleaned.tif',183,3,75,3.4944267,3.6611907,10.8721458,1.8,3.6655495,10.9592963,1.1410143,1.7257914,3.0709806,1.2209922,7.7086201,0.4812896,2.5101494,0.707497,2.9044897,3.232508,8.0226788,1.7457566,21.9972995),(4688,'radius-cleaned.tif',183,3,74,3.5284766,3.6595876,10.903438,1.8,3.6612881,10.9847629,1.1466925,1.7013339,3.0996165,1.2563886,7.741133,0.4884966,2.4974486,0.7384727,2.8997348,3.2648327,8.0158298,1.7408549,22.0029707),(4687,'radius-cleaned.tif',183,3,73,3.5486936,3.6535287,10.9386431,1.8,3.6535213,11.0191138,1.1547071,1.6674087,3.1346507,1.2915822,7.7814936,0.4948259,2.4824117,0.7746044,2.8869349,3.2284205,8.0226788,1.7457566,22.1859436),(4686,'radius-cleaned.tif',183,3,72,3.5303325,3.6483114,10.9767057,1.8,3.6503922,11.0641286,1.161161,1.6727784,3.1799559,1.3030056,7.822971,0.4950569,2.4600879,0.7789469,2.8684178,3.2270278,8.0239686,1.7155063,22.9782724),(4685,'radius-cleaned.tif',183,3,71,3.4989975,3.6374462,10.9860471,1.8,3.6366187,11.0743594,1.1610774,1.6592341,3.1889967,1.2831696,7.9234286,0.4906271,2.4846149,0.7733505,2.8811389,3.1906157,8.0226788,1.7457566,22.4293537),(4684,'radius-cleaned.tif',183,3,70,3.4642051,3.6324701,10.9966387,1.8,3.6318623,11.0905164,1.1556441,1.6596243,3.1794369,1.2528158,7.9617474,0.4834446,2.5041376,0.7548792,2.8880859,3.2103325,8.0239686,1.7155063,21.6530655),(4683,'radius-cleaned.tif',183,3,69,3.4395594,3.6285807,10.9977576,1.8,3.6259305,11.0790586,1.1468103,1.7067966,3.2092124,1.226452,7.9561036,0.4762372,2.4791452,0.7185695,2.8542841,3.209288,8.0239686,1.7155063,21.5635842),(4682,'radius-cleaned.tif',183,3,68,3.4504917,3.6254506,11.0196406,1.8,3.6218199,11.0907863,1.1449322,1.6980083,3.210936,1.228607,8.0101777,0.4769395,2.4946551,0.7235577,2.8664415,3.2585655,8.0358642,1.7253332,21.5539028),(4681,'radius-cleaned.tif',183,3,67,3.4375396,3.6215474,11.0202826,1.8,3.6194063,11.0784478,1.1407523,1.7009976,3.241965,1.2142578,8.0383037,0.4733408,2.4794542,0.7138504,2.8471926,3.2221534,8.0297203,1.7506498,22.4116521),(4680,'radius-cleaned.tif',183,3,66,3.4090649,3.6186089,11.0275419,1.8,3.6189424,11.091821,1.1361779,1.7388838,3.2488418,1.2118715,7.9991569,0.4674424,2.4621565,0.696925,2.8203067,3.1934011,8.0578247,1.7098923,22.5575606),(4679,'radius-cleaned.tif',183,3,65,3.3830048,3.621297,11.0315964,1.8,3.6245425,11.0962897,1.1297623,1.7327519,3.266461,1.2029115,8.0348361,0.4610911,2.4597986,0.6942203,2.8211433,3.1934011,8.0358642,1.7253332,22.1238452),(4678,'radius-cleaned.tif',183,3,64,3.3824056,3.626091,11.0403845,1.8,3.6262527,11.1030292,1.1234997,1.7601629,3.2764194,1.1938698,8.1711756,0.4582698,2.4939345,0.6782723,2.8432268,3.1885266,8.0619727,1.7448951,22.8009707),(4677,'radius-cleaned.tif',183,3,63,3.4051568,3.626381,11.0410161,1.8,3.6185655,11.0916971,1.120196,1.7652881,3.2921924,1.1945196,8.4521547,0.459886,2.5673331,0.6766712,2.9234251,3.1885266,8.0634536,1.7147927,22.6316893),(4676,'radius-cleaned.tif',183,3,62,3.4183908,3.6146425,11.041662,1.8,3.6056536,11.0919206,1.1225684,1.7507423,3.2895846,1.2123131,8.5600539,0.4627311,2.6021687,0.6924566,2.9570894,3.1568983,8.0619727,1.7448951,21.9158384),(4675,'radius-cleaned.tif',183,3,61,3.4483417,3.5956539,11.0426182,1.8,3.5933354,11.0967492,1.128888,1.7422742,3.2993837,1.2454764,8.6887769,0.4696081,2.6334545,0.7148567,3.0060925,3.1555056,8.075291,1.7245726,22.5051436),(4674,'radius-cleaned.tif',183,3,60,3.4633437,3.5727784,11.0403926,1.8,3.5756743,11.0960345,1.1368517,1.7270243,3.2917845,1.269843,8.7636232,0.4751819,2.6622713,0.735278,3.0378154,3.2298132,8.0619727,1.7448951,22.5381978),(4673,'radius-cleaned.tif',183,3,59,3.4648026,3.5556929,11.0449617,1.8,3.5595077,11.1076308,1.1417178,1.7018415,3.2839399,1.2858279,8.7666103,0.4775171,2.6695404,0.7555509,3.0573515,3.1940974,8.055157,1.7400166,22.170591),(4672,'radius-cleaned.tif',183,3,58,3.487023,3.5437416,11.0464526,1.8,3.5496178,11.1169813,1.1435293,1.7237606,3.2805079,1.3044279,8.8329355,0.4813748,2.6925512,0.7567338,3.0855301,3.1934011,8.0485334,1.73513,21.9859571),(4671,'radius-cleaned.tif',183,3,57,3.4867112,3.5363652,11.0555096,1.8,3.543043,11.128435,1.1428046,1.7507427,3.3021742,1.3066661,8.8789449,0.4810139,2.6888178,0.7463496,3.0837131,3.158291,8.0443785,1.7604099,22.1238452),(4670,'radius-cleaned.tif',183,3,56,3.481654,3.5248871,11.0582369,1.8,3.5311006,11.1295179,1.1436485,1.7378438,3.3032196,1.3023178,8.8969198,0.4806858,2.6934085,0.7493871,3.0834234,3.1871339,8.0619727,1.7448951,21.8497299),(4669,'radius-cleaned.tif',183,3,55,3.4584084,3.5119117,11.0539759,1.8,3.5155426,11.1168187,1.1439127,1.7637016,3.3270545,1.2852132,8.9367484,0.4775913,2.6860841,0.7287022,3.0707019,3.149329,8.0443785,1.7604099,21.5756146),(4668,'radius-cleaned.tif',183,3,54,3.3999688,3.5016437,11.0534965,1.8,3.5031144,11.110857,1.1408776,1.7593033,3.324999,1.2571778,8.8414767,0.4682212,2.6590916,0.7145884,3.0306674,3.1465436,8.0761781,1.7546268,21.8731028),(4667,'radius-cleaned.tif',183,3,53,3.3402555,3.4947095,11.0559697,1.8,3.4960077,11.1178843,1.1389296,1.7550106,3.340612,1.238484,8.7209859,0.4591748,2.6105953,0.7056846,2.976221,3.14724,8.0835669,1.7594796,22.6921266),(4666,'radius-cleaned.tif',183,3,52,3.2949123,3.487615,11.0499528,1.8,3.4871748,11.1161334,1.135519,1.792603,3.3651259,1.2116081,8.6867609,0.4515135,2.5814074,0.6758931,2.9389579,3.1541129,8.098914,1.7691581,22.9742622),(4665,'radius-cleaned.tif',183,3,51,3.2911638,3.4803249,11.0469069,1.8,3.475105,11.1114332,1.1368893,1.78515,3.3621374,1.2059454,8.7212539,0.4515739,2.5939612,0.6755429,2.9458396,3.1129169,8.0929163,1.7894653,22.9315266),(4664,'radius-cleaned.tif',183,3,50,3.324375,3.4877113,11.0621426,1.8,3.4802787,11.1203845,1.1350042,1.7883398,3.381115,1.2084681,8.8680515,0.4553327,2.6228186,0.6757486,2.9666518,3.1218788,8.1154091,1.7537281,22.8847809),(4663,'radius-cleaned.tif',183,3,49,3.3639338,3.4877168,11.0815477,1.8,3.4698609,11.1225021,1.1382082,1.794786,3.4137117,1.2294468,9.0144838,0.4621221,2.6406693,0.6850102,2.9890197,3.1204861,8.1338283,1.7383644,22.2737639),(4662,'radius-cleaned.tif',183,3,48,3.363948,3.4931884,11.1156556,1.8,3.4684877,11.1433958,1.1385036,1.7655176,3.4832615,1.2321943,9.0053613,0.46225,2.5853245,0.6979224,2.9331819,3.1676361,8.1154091,1.7537281,22.6066554),(4661,'radius-cleaned.tif',183,3,47,3.382355,3.4890871,11.146558,1.8,3.4592711,11.1684824,1.1424687,1.7793311,3.5136676,1.2683052,9.0213925,0.4664743,2.5675145,0.7127989,2.9169441,3.2387408,8.1459543,1.7729949,22.6437198),(4660,'radius-cleaned.tif',183,3,46,3.377588,3.4765026,11.16034,1.8,3.4434996,11.1757381,1.144448,1.7592952,3.5381243,1.2798001,8.9810318,0.4666574,2.5383596,0.7274505,2.8906058,3.2394372,8.1459543,1.7729949,22.861408),(4659,'radius-cleaned.tif',183,3,45,3.3754336,3.4578022,11.163762,1.8,3.4251301,11.1763323,1.1498447,1.7329852,3.5389096,1.2836942,8.9125522,0.4686352,2.5184458,0.7407416,2.8651295,3.0723266,8.1380354,1.7681919,22.3632453),(4658,'radius-cleaned.tif',183,3,44,3.4022853,3.4327103,11.1570486,1.8,3.4032115,11.1735249,1.156631,1.7232201,3.5572441,1.2965765,8.911806,0.4752161,2.5052556,0.7524149,2.8597048,3.0723266,8.1623544,1.7825725,22.6276792),(4657,'radius-cleaned.tif',183,3,43,3.4714396,3.412279,11.1662324,1.8,3.3845864,11.1860931,1.162631,1.7079999,3.5642373,1.3174083,8.9372507,0.4874189,2.5074791,0.7713164,2.8601597,3.0413375,8.1623544,1.7825725,22.3866181),(4656,'radius-cleaned.tif',183,3,42,3.541954,3.4060167,11.1795881,1.8,3.3752992,11.1996058,1.1631267,1.6962196,3.5850353,1.321782,8.9796887,0.4975328,2.50477,0.7792517,2.8652269,3.0406411,8.1546466,1.752838,25.2861132),(4655,'radius-cleaned.tif',183,3,41,3.5831531,3.4029956,11.1835088,1.8,3.3644933,11.1921069,1.1612653,1.7312317,3.5917421,1.2772926,9.0334051,0.5025094,2.5150483,0.7377941,2.8553827,3.0406411,8.1546466,1.752838,26.8563913),(4654,'radius-cleaned.tif',183,3,40,3.6061574,3.3933863,11.1917336,1.8,3.3497119,11.1970754,1.1634118,1.752659,3.5804683,1.2348915,9.0125514,0.5066761,2.5171432,0.7045818,2.8431752,3.0399448,8.1546466,1.752838,26.5315201),(4653,'radius-cleaned.tif',183,3,39,3.596642,3.3751447,11.1813204,1.8,3.3295254,11.1803246,1.1690216,1.731845,3.5972182,1.196855,9.0944249,0.5077728,2.5281827,0.6910867,2.848769,3.0382038,8.1459543,1.7729949,23.5465538),(4652,'radius-cleaned.tif',183,3,38,3.5902715,3.3473377,11.162995,1.8,3.2996864,11.1619542,1.1805521,1.6960931,3.579828,1.1614965,9.1883502,0.5117842,2.5667016,0.6848071,2.8734052,3.0087567,8.1694704,1.7624448,23.6941233),(4651,'radius-cleaned.tif',183,3,37,3.5246558,3.3248961,11.1492303,1.8,3.2785431,11.1568508,1.1916744,1.7004802,3.5481791,1.0926135,9.047785,0.5069761,2.5499798,0.6425324,2.8388859,3.0395966,8.1380354,1.7681919,23.8400318),(4650,'radius-cleaned.tif',183,3,36,3.436235,3.3043508,11.1426867,1.8,3.2601411,11.1492101,1.2052427,1.6626145,3.5399805,1.0365324,8.9374711,0.4995242,2.5247233,0.6234352,2.8014201,3.0395966,8.1303045,1.7633796,23.8343606),(4649,'radius-cleaned.tif',183,3,35,3.3152373,3.2798973,11.1526227,1.8,3.2353562,11.1482128,1.216245,1.6562343,3.5350635,0.9821792,8.6679326,0.4859437,2.4519878,0.5930194,2.7152212,3.0395966,8.098914,1.7691581,21.9448825),(4648,'radius-cleaned.tif',183,3,34,3.1999898,3.2651048,11.1901403,1.8,3.2259781,11.1803204,1.2275147,1.6117957,3.5683321,0.9514836,8.3736234,0.4729129,2.3466491,0.5903252,2.5996423,3.0354183,8.0598002,1.7701336,22.1472181),(4647,'radius-cleaned.tif',183,3,33,3.0701264,3.24694,11.2147025,1.8,3.2097376,11.1993462,1.2371199,1.6091752,3.5995402,0.9070397,8.1033948,0.4567997,2.2512306,0.5636674,2.483065,3.0382038,8.075291,1.7245726,21.6337028),(4646,'radius-cleaned.tif',183,3,32,2.9805299,3.2280703,11.2334056,1.8,3.2038166,11.225626,1.2474804,1.5565123,3.6146603,0.8913517,7.9129179,0.446612,2.189118,0.5726596,2.4165464,3.0324001,8.0619727,1.7448951,22.0714283),(4645,'radius-cleaned.tif',183,3,31,2.9051967,3.2044779,11.2445344,1.8,3.1887834,11.2402465,1.2586699,1.5258157,3.6214898,0.8671758,7.8351323,0.4385394,2.1635108,0.5683359,2.3938141,2.9925001,8.0369537,1.7555343,22.3745877),(4644,'radius-cleaned.tif',183,3,30,2.8477029,3.1792526,11.263397,1.8,3.1708797,11.2635176,1.2694187,1.5054262,3.6233681,0.857912,7.7112967,0.4327979,2.1282123,0.5698798,2.3542884,2.9925001,7.997736,1.7564507,22.5906148),(4643,'radius-cleaned.tif',183,3,29,2.7571636,3.1506409,11.2671189,1.8,3.141439,11.2562595,1.2787861,1.4625986,3.6217758,0.8249319,7.5977148,0.4214445,2.0977872,0.564018,2.3153596,2.9526001,7.9737135,1.7672105,22.4664181),(4642,'radius-cleaned.tif',183,3,28,2.6329668,3.1215582,11.2793608,1.8,3.1052473,11.2643611,1.2895247,1.4256693,3.6016526,0.7887119,7.3836511,0.4050164,2.0500731,0.5532222,2.2620715,2.9127001,7.9115776,1.7790718,22.649391),(4641,'radius-cleaned.tif',183,3,27,2.4858897,3.0978539,11.2804994,1.8,3.075318,11.2634928,1.2969285,1.4075271,3.5659629,0.7516058,7.1378996,0.384009,2.0016752,0.5339903,2.1989973,2.8728001,7.8660704,1.7184322,22.6179978),(4640,'radius-cleaned.tif',183,3,26,2.3966159,3.0773357,11.2746193,1.8,3.0576358,11.2545814,1.3065614,1.3536824,3.5585676,0.7302263,6.9464585,0.3721904,1.9520378,0.539437,2.1451142,2.7930001,7.8152074,1.7090833,21.6861198),(4639,'radius-cleaned.tif',183,3,25,2.3531318,3.0509731,11.2729024,1.8,3.0283631,11.2575721,1.3155155,1.3556914,3.5333487,0.7286954,6.8436015,0.3671808,1.9368599,0.5375083,2.125973,2.7531001,7.755189,1.6894079,21.2734283),(4638,'radius-cleaned.tif',183,3,24,2.3357266,3.0274314,11.2532056,1.8,3.0057401,11.2351603,1.327336,1.2988168,3.4845169,0.7262874,6.766436,0.3666658,1.9418577,0.5591916,2.1377961,2.7083575,7.7155708,1.6900199,20.6994757),(4637,'radius-cleaned.tif',183,3,23,2.3053703,3.00983,11.2392942,1.8,2.9903101,11.2252888,1.3355034,1.2422664,3.4605488,0.7101911,6.6381526,0.3633461,1.9182369,0.5716899,2.1093137,2.6330948,7.6528992,1.7702369,21.1291808),(4636,'radius-cleaned.tif',183,3,22,2.3056352,2.9848366,11.2032643,1.8,2.9636235,11.1797416,1.3490622,1.172707,3.3948815,0.6856694,6.5857868,0.365687,1.9399166,0.5846894,2.132242,2.5137001,7.6218402,1.7764053,20.4737672),(4635,'radius-cleaned.tif',183,3,21,2.3312289,2.9638402,11.1671588,1.8,2.9448071,11.1467018,1.3630278,1.1463867,3.3203632,0.6695113,6.6461209,0.3720058,2.0016247,0.5840188,2.1954308,2.4486208,7.5437386,1.778565,20.4560655),(4634,'radius-cleaned.tif',183,3,20,2.3883391,2.9430672,11.1103365,1.8,2.9289145,11.1026342,1.370168,1.1323178,3.2154095,0.6360049,6.8003441,0.3822479,2.1149232,0.5616841,2.3029075,2.362302,7.426118,1.7218117,19.8160044),(4633,'radius-cleaned.tif',183,3,19,2.4636671,2.921718,11.0486258,1.8,2.9108778,11.0651672,1.3749427,1.1130256,3.1052044,0.5933909,6.8956987,0.3950611,2.2206908,0.5331332,2.3989131,2.29128,7.3556818,1.761809,19.831357),(4632,'radius-cleaned.tif',183,3,18,2.4855099,2.9121633,11.0600964,1.8,2.9062133,11.105511,1.3754734,1.0712374,3.0597221,0.5447249,6.6481928,0.3986475,2.1728094,0.5085006,2.3458757,2.2123294,7.2793175,1.7918434,19.3081603),(4631,'radius-cleaned.tif',183,3,17,2.4307231,2.9143821,11.168409,1.8,2.9097113,11.1926892,1.3681161,1.0191063,3.0624545,0.4970198,6.0153293,0.3887051,1.9642184,0.4877016,2.1133384,2.1215187,7.1439946,1.7221718,19.0220146),(4630,'radius-cleaned.tif',183,3,16,2.3165087,2.9236236,11.3184479,1.8,2.9137058,11.2906946,1.3584962,0.9511799,3.1380346,0.4367858,5.1667198,0.3689433,1.6464827,0.4592042,1.7753628,2.0657143,7.0450342,1.7415315,18.768923),(4629,'radius-cleaned.tif',183,3,15,2.1231846,2.9397658,11.5359934,1.8,2.919738,11.4334007,1.3431057,0.8971911,3.1745311,0.3644587,3.9558093,0.3358336,1.2461082,0.4062219,1.3467257,1.9866909,6.8743892,1.7340366,18.8310214),(4628,'radius-cleaned.tif',183,3,14,1.8751333,2.9637712,11.8660333,1.8,2.9411249,11.7488553,1.2964894,0.8323212,3.3861303,0.2831897,2.359812,0.2895906,0.6969053,0.3402408,0.764707,1.9477106,5.5655853,1.7949085,16.3652416),(4627,'radius-cleaned.tif',183,3,13,1.700822,2.9895022,12.1452309,1.8,2.9759881,12.0920488,1.1984061,0.8806743,3.0139809,0.1946062,1.1973694,0.2459441,0.3972717,0.2209741,0.4433028,1.7760392,5.3128466,1.8212394,15.2931263),(4626,'radius-cleaned.tif',183,3,12,1.4577586,3.0320952,12.3106525,1.8,3.0169044,12.2595437,1.15818,0.7451878,2.2013069,0.1300821,0.6661814,0.2038901,0.30263,0.1745628,0.3559598,1.7217057,4.8997461,1.8513331,14.1372008),(4625,'radius-cleaned.tif',183,3,11,1.0923451,3.1019448,12.4859935,1.8,3.0959271,12.4787253,1.1065221,0.6703423,1.9556401,0.0749815,0.2553579,0.1455547,0.1305751,0.1118556,0.1672488,1.6144256,3.6846522,1.8788491,11.8584041),(4624,'radius-cleaned.tif',183,3,10,0.7049979,3.1275751,12.5491508,1.8,3.1230005,12.5691159,1.1405289,0.5784364,0.9530479,0.0326286,0.1119465,0.0970566,0.1174616,0.0564082,0.1516689,1.5284771,3.3311125,1.9001225,12.7128312),(4623,'radius-cleaned.tif',183,3,9,0.2674539,3.1338001,12.5978684,1.8,3.1315249,12.6128337,1.406366,0.3972335,0.6691251,0.0087953,0.0251665,0.0433813,0.0376111,0.0221413,0.0449433,0.7852871,1.3548386,1.3329604,4.6624274),(4622,'radius-cleaned.tif',183,3,8,0.0321958,3.0622122,12.9552362,1.8,3.0640189,12.9449154,-1.3729267,0.1998728,0.5611894,0.0001497,0.0015582,0.0051586,0.0027767,0.0007487,0.0030414,0.2271719,0.3038694,1.1659045,0.8036712),(4618,'radius-cleaned.tif',183,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4619,'radius-cleaned.tif',183,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4620,'radius-cleaned.tif',183,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4621,'radius-cleaned.tif',183,3,7,0.0039499,3.1131394,12.9149719,1.8,3.1122001,12.9162003,-1.3561027,0.0357751,0.2244597,0.0000028,0.0000635,0.0006284,0.0002829,0.0000789,0.0002923,0,0,0,0),(4614,'humerus.tif',183,2,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4615,'radius-cleaned.tif',183,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4616,'radius-cleaned.tif',183,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4617,'radius-cleaned.tif',183,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4610,'humerus.tif',183,2,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4611,'humerus.tif',183,2,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4612,'humerus.tif',183,2,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4613,'humerus.tif',183,2,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4606,'humerus.tif',183,2,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4607,'humerus.tif',183,2,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4608,'humerus.tif',183,2,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4609,'humerus.tif',183,2,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4603,'humerus.tif',183,2,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4604,'humerus.tif',183,2,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4605,'humerus.tif',183,2,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4602,'humerus.tif',183,2,188,1.1680101,16.1661487,13.4154788,1.8,16.1645197,13.4161828,1.425895,0.4067538,1.1947652,0.033848,0.4041329,0.1906095,0.338253,0.0832149,0.3657399,0.8081424,2.3942952,1.784165,5.7311796),(4601,'humerus.tif',183,2,187,5.5841813,16.028097,13.5897413,1.8,16.0287938,13.5847676,1.250942,0.9053549,2.635125,1.0534483,9.1949701,0.8386834,3.4893867,1.163575,3.8884529,1.7992556,4.9209595,1.8850282,11.9019702),(4600,'humerus.tif',183,2,186,6.811504,16.0867935,13.9205758,1.8,16.0875754,13.9074857,1.2751074,1.1916889,2.9879867,2.7561574,18.7554985,1.0388527,6.2769685,2.3128161,7.1984854,2.315307,6.0106834,1.8535523,14.7266001),(4599,'humerus.tif',183,2,185,7.6725546,16.0106567,13.5663647,1.8,16.0203856,13.5703627,1.2781427,1.3913827,3.8594805,4.2246972,34.2781725,1.1723295,8.8815509,3.0363302,9.9712493,2.6369471,7.6729962,1.8700426,18.1523844),(4598,'humerus.tif',183,2,184,7.8331811,16.0496239,13.2294481,1.8,16.0666756,13.3091876,1.2548461,1.4501099,4.3169782,4.9685785,44.833386,1.1794854,10.3853631,3.4263463,11.4746305,2.7787934,8.4280617,1.8090411,20.210397),(4597,'humerus.tif',183,2,183,8.0056839,16.0656748,12.9096978,1.8,16.0884357,13.0158339,1.251736,1.510152,4.7619364,5.7479888,51.9437476,1.2029985,10.9081146,3.806232,12.0482239,2.9020763,8.8255546,1.825421,21.6695514),(4596,'humerus.tif',183,2,182,8.6764743,16.1372781,12.6145275,1.8,16.1548283,12.7222155,1.2507616,1.5451425,5.0434279,7.1982233,60.4866081,1.3029565,11.9931541,4.6586145,13.3622975,3.0518901,9.0855774,1.849096,22.4094034),(4595,'humerus.tif',183,2,181,8.6384755,16.1206345,12.3907848,1.8,16.148642,12.507131,1.2403847,1.6593921,5.1973868,8.5969576,63.1247395,1.2882034,12.1454764,5.1807873,13.7399774,3.2519992,9.2732293,1.843319,22.8734837),(4594,'humerus.tif',183,2,180,9.0125473,16.0680126,12.0832149,1.8,16.0865306,12.1791556,1.2194512,1.7586882,5.3279052,10.6847591,68.490669,1.3241733,12.855084,6.0754142,14.8565008,3.5361306,9.2991084,1.9442935,22.9609467),(4593,'humerus.tif',183,2,179,11.8469984,14.9405332,12.6114704,1.8,14.9281911,12.6564742,-1.108991,4.9930229,6.4044159,68.992626,103.0731288,1.5825058,16.0940718,13.817807,26.1399408,1.2256727,1.3738854,0.967047,4.1790189),(4592,'humerus.tif',183,2,178,19.2041891,13.249223,12.790269,1.8,13.2084495,12.8436387,-0.4656707,5.6636464,4.8771966,121.2352029,193.2377663,0.6453276,39.6206638,21.4058567,48.2848329,3.9390001,4.6929821,1.3016288,14.1672174),(4591,'humerus.tif',183,2,177,22.4521938,12.8493648,12.7489456,1.8,12.7915479,12.8120428,-0.4342865,5.6441447,5.3676084,154.5137205,238.0532021,0.6624956,44.3499567,27.3759319,56.9292245,5.4338149,9.0052007,1.9995744,26.5371877),(4590,'humerus.tif',183,2,176,23.3161498,12.6591787,12.4332533,1.8,12.6218421,12.5265498,-0.3574636,6.3210062,5.6415525,183.9157108,253.1681557,0.4757641,44.8756178,29.0959549,60.3734627,10.3756194,12.4856662,2.7674667,52.3439863),(4589,'humerus.tif',183,2,175,22.9161231,12.5320068,12.2402378,1.8,12.5168813,12.3302129,-0.1946074,6.7390144,6.1812034,199.6327294,269.123596,0.14283,43.5390294,29.6234312,62.8635269,10.6167775,12.9260148,2.8064841,115.2893632),(4588,'humerus.tif',183,2,174,23.0204445,12.3383976,12.1671979,1.8,12.3208696,12.2641791,0.0120412,6.4434925,7.0412634,217.782146,298.2252814,0.0005563,42.3539451,33.7987741,67.3121226,10.9904346,13.2802878,2.8588558,165.1722328),(4587,'humerus.tif',183,2,173,23.5966403,12.183128,12.1743132,1.8,12.1614481,12.251991,0.1247931,6.4195494,7.5555749,232.4649615,321.8497925,0.060929,42.5976577,36.2120373,70.6645583,11.025051,13.6071445,2.8688047,56.2416903),(4586,'humerus.tif',183,2,172,23.0511651,11.9525536,12.029129,1.8,11.9367122,12.1187061,0.1530491,6.4319946,7.920372,217.2223769,342.6655569,0.0892914,43.2638208,33.7721639,68.8581018,11.1150003,13.8702449,2.8741076,42.8616398),(4585,'humerus.tif',183,2,171,23.3686329,11.8260734,12.0619406,1.8,11.8242757,12.1268668,0.159536,6.2306096,8.0655182,213.8180126,373.3105514,0.0982906,46.2847574,34.3173504,71.4050035,11.1399622,14.0310058,2.8743655,158.5719666),(4584,'humerus.tif',183,2,170,23.3446896,11.6716201,12.0425174,1.8,11.725326,12.0913792,0.1488296,6.0517508,8.2462621,216.0543442,387.8965828,0.0855474,47.0390798,35.7011301,72.1807151,11.0370003,14.1715507,2.9139687,43.3084177),(4583,'humerus.tif',183,2,169,22.8793676,11.7759224,11.9493139,1.8,11.8210076,11.9625057,0.1185744,6.0083523,8.1772016,204.2319341,388.1604954,0.0533628,47.4686226,33.9913382,71.0764947,7.8949081,12.3312181,2.1649392,103.0567456),(4582,'humerus.tif',183,2,168,23.245869,11.6633985,11.8676104,1.8,11.729756,11.8833222,0.0920025,5.8921668,8.3137231,191.1181177,410.957052,0.0327015,49.4311691,32.4359651,70.9029303,10.7250003,14.3996116,2.9176359,194.9863716),(4581,'humerus.tif',183,2,167,22.9160258,11.7241432,11.7436044,1.8,11.7610729,11.7771717,0.114729,5.8454483,8.3616654,183.38399,400.1335717,0.0500528,47.8533347,31.3721003,68.6647298,9.9858833,11.6867978,2.1301031,109.3417646),(4580,'humerus.tif',183,2,166,22.88859,12.0241715,11.7966206,1.8,12.0286223,11.8290821,0.1234569,5.5413037,8.1113168,168.9564936,397.9059034,0.0578484,49.0556483,30.4903866,68.9496183,6.6026406,11.6619785,2.175495,88.0322006),(4579,'humerus.tif',183,2,165,21.6727876,12.3057774,11.7165299,1.8,12.3314105,11.7429717,0.1392271,5.2662517,7.8942889,142.901526,380.5790901,0.0695669,48.2094199,27.1353391,65.5051572,9.5088836,14.4404317,2.9431378,123.2867411),(4578,'humerus.tif',183,2,164,21.1086491,12.5926616,11.5798569,1.8,12.6161241,11.6114,0.1721021,5.1845446,7.6743337,129.1415987,359.2662833,0.1031786,46.8140033,24.9089571,62.895651,9.4242056,14.3444209,2.9223339,62.0227595),(4577,'humerus.tif',183,2,163,20.9983228,13.0779032,11.6501038,1.8,13.069357,11.6836236,0.1831619,4.8704499,7.1959323,120.6403947,336.191601,0.1161025,46.7196729,24.7698668,62.8181426,8.9085147,14.1713897,2.8799266,45.9424429),(4576,'humerus.tif',183,2,162,19.7689666,13.4874619,11.8346673,1.8,13.5359549,11.8566416,0.1916052,4.5054692,7.087855,104.7468055,287.9230317,0.1194886,40.622026,23.2488116,55.3963294,2.1106571,3.4055287,1.3397057,9.2098221),(4575,'humerus.tif',183,2,161,16.6675079,14.6607595,12.0461986,1.8,14.7512223,12.0561826,0.1499606,4.2433585,7.801229,91.5802863,168.4995302,0.0620035,21.5991005,21.582029,33.1781989,7.6544114,10.2166605,2.8512328,29.6486758),(4574,'humerus.tif',183,2,160,15.9431782,15.1643065,12.0991387,1.8,15.2515402,12.1130547,0.0991125,4.0106846,4.9299364,84.7543611,129.7233967,0.026017,26.3134017,21.1321429,43.1143839,7.3636261,9.6114234,2.9123607,28.1745152),(4573,'humerus.tif',183,2,159,15.4622924,15.4917359,12.0767352,1.8,15.5504097,12.0943577,0.0455716,3.8476714,4.5627048,80.6803376,114.9747157,0.0053482,25.1988064,20.9686142,42.0040968,7.1307557,9.2139101,2.9109867,27.1360459),(4572,'humerus.tif',183,2,158,15.1530911,15.6139118,12.1115618,1.8,15.673306,12.1299307,0.0405315,3.6562318,4.459181,72.0721502,106.5236136,0.0041466,23.8886052,19.7121391,39.4815836,6.9159475,8.8748785,2.9200638,26.2268112),(4571,'humerus.tif',183,2,157,14.8335841,15.7879756,12.1491389,1.8,15.8602291,12.158451,0.039927,3.5540198,4.2974666,69.1259398,98.8222156,0.0039391,22.9954587,19.4500717,38.8309097,6.7359813,8.5797343,2.9076389,25.5610396),(4570,'humerus.tif',183,2,156,14.3203589,15.9202588,12.051155,1.8,15.9754794,12.0544112,0.0770312,3.4337419,4.1913957,62.6008035,92.2324057,0.0141344,22.0051772,18.2310741,36.747795,6.550479,8.333416,2.8909387,24.9220333),(4569,'humerus.tif',183,2,155,14.4661764,16.000614,11.9875846,1.8,16.045201,11.98567,0.0217442,3.376152,4.0958232,59.2616486,88.110012,0.0011398,21.512162,17.5530158,35.6891096,6.4017987,8.1078742,3.0064982,24.29249),(4568,'humerus.tif',183,2,154,14.2040019,16.0940835,12.0405146,1.8,16.1327997,12.0399868,0.0209253,3.2205439,4.0349663,56.4366522,82.3851375,0.0010364,20.4178006,17.5239506,34.3628871,6.2524744,7.9204576,3.0380044,23.805564),(4567,'humerus.tif',183,2,153,14.1435181,16.2607379,11.9926474,1.8,16.3000186,11.9925357,-0.0347691,3.1805779,3.8992314,54.3978729,78.5390333,0.0028485,20.1421834,17.1031412,34.0662035,6.1103003,7.770793,3.0913836,23.406101),(4566,'humerus.tif',183,2,152,14.757175,16.3870118,12.0238624,1.8,16.4245884,12.0310122,-0.0008765,3.0690623,3.7901364,52.5397998,76.1713834,0.0000019,20.0972672,17.1191701,33.8893985,5.9657657,7.6218815,0.0665682,23.0294837),(4565,'humerus.tif',183,2,151,14.1044192,16.5033906,11.9825808,1.8,16.5353666,11.9753404,-0.0105201,3.0309537,3.7517231,49.6465188,72.1626135,0.0002602,19.2345254,16.3798338,32.4543305,5.8458478,7.5002792,0.0572291,22.6300207),(4564,'humerus.tif',183,2,150,13.5867707,16.5621342,11.9646835,1.8,16.5872354,11.9632472,-0.0329202,2.9711299,3.6629812,46.3963327,68.1156633,0.0024532,18.5956901,15.6157202,31.1956989,5.735304,7.3733728,0.1059844,22.1793231),(4563,'humerus.tif',183,2,149,13.6821703,16.6637367,11.9471269,1.8,16.6825767,11.9465997,-0.0136954,2.9493815,3.6420224,45.7399554,65.3422771,0.0004277,17.9412069,15.5083214,30.4052194,5.6626333,7.2805805,0.1343214,21.8121687),(4562,'humerus.tif',183,2,148,13.3324825,16.7300581,11.9678524,1.8,16.7465084,11.9675256,0.0022547,2.8537214,3.6262128,43.3991928,63.1553275,0.0000113,17.4163323,15.2079291,29.3567992,5.5988899,7.2141569,0.1028962,21.555323),(4561,'humerus.tif',183,2,147,13.8940537,16.8238578,11.9594624,1.8,16.8418323,11.9594718,-0.0429975,2.8283499,3.6101678,42.443385,62.555785,0.0042786,17.327667,15.0064126,29.0747606,5.5308402,7.1288972,0.0931364,21.23386),(4560,'humerus.tif',183,2,146,13.3866881,16.8782597,11.91396,1.8,16.892278,11.911496,-0.0535516,2.8508731,3.5529571,40.9653825,59.7584008,0.0063922,16.8193423,14.3694162,28.3266461,5.4890351,7.0335288,0.1222917,20.990397),(4559,'humerus.tif',183,2,145,13.405368,16.9442727,11.8764274,1.8,16.9542516,11.875513,-0.0802744,2.8517525,3.5340365,39.9469428,57.6312566,0.0143664,16.3074879,14.0078574,27.605556,5.4541073,6.9561178,0.1236596,20.7012427),(4558,'humerus.tif',183,2,144,13.3244268,17.0049628,11.8576245,1.8,17.0125203,11.8560003,-0.0685741,2.8306056,3.5132886,38.5916226,55.5304706,0.0104265,15.8058379,13.6336983,26.7821831,5.4061025,6.888884,0.0850218,20.4767057),(4557,'humerus.tif',183,2,143,13.0609884,17.0399614,11.8642559,1.8,17.0425195,11.8689639,-0.0875302,2.7824732,3.4423868,37.2206475,53.2909095,0.0166354,15.4808025,13.3768216,26.2932474,5.3601389,6.8227712,0.1491726,20.132397),(4556,'humerus.tif',183,2,142,12.8431494,17.0830687,11.8533078,1.8,17.0882931,11.8551797,-0.094456,2.7555583,3.4364104,35.77505,51.940316,0.0190409,15.1147011,12.982868,25.5078798,5.3149469,6.7842068,0.150027,20.054397),(4555,'humerus.tif',183,2,141,12.7340434,17.1157144,11.8257437,1.8,17.1198881,11.8274708,-0.1007216,2.7271913,3.3853515,34.5788425,50.6487949,0.0214581,14.9611626,12.6792874,25.1341267,5.2577864,6.7290543,0.1337005,19.820397),(4554,'humerus.tif',183,2,140,12.7508286,17.1709241,11.8212736,1.8,17.1731796,11.8222846,-0.1157883,2.6602753,3.3554155,33.8656768,49.71017,0.0283645,14.8149072,12.73014,24.8234419,5.2310424,6.6627253,0.1468639,19.6226254),(4553,'humerus.tif',183,2,139,12.5908404,17.199522,11.8064975,1.8,17.2008079,11.8064392,-0.1113661,2.6548702,3.3178214,32.7257619,48.5607156,0.0259187,14.6363259,12.3266901,24.4699907,5.2179369,6.6241476,0.1477255,19.5217797),(4552,'humerus.tif',183,2,138,12.6944726,17.229897,11.795501,1.8,17.231731,11.7942998,-0.1117929,2.6537647,3.301705,32.1879922,48.2781926,0.0263319,14.6222006,12.1291808,24.3115259,5.1870001,6.5914617,0.1544487,19.3886254),(4551,'humerus.tif',183,2,137,12.7884187,17.2610501,11.7848184,1.8,17.2639914,11.783725,-0.1107073,2.6522948,3.2651918,31.978824,47.4875175,0.0260162,14.5435615,12.0570398,24.1697187,5.1870001,6.540499,0.1798535,19.255471),(4550,'humerus.tif',183,2,136,12.8381915,17.2925085,11.7644206,1.8,17.2932137,11.7634011,-0.1057963,2.6432033,3.2522302,31.420642,46.7661033,0.0238601,14.3797028,11.8873346,23.8430946,5.1480001,6.5092626,0.1868202,19.099471),(4549,'humerus.tif',183,2,135,12.8010413,17.3096577,11.7477812,1.8,17.3119417,11.7470366,-0.0814971,2.6048444,3.2287444,30.6017765,45.8948665,0.0141389,14.2144625,11.7480246,23.260826,5.0700001,6.4821005,0.1206237,18.9663167),(4548,'humerus.tif',183,2,134,12.7497668,17.3425154,11.7240228,1.8,17.3448761,11.7226692,-0.0718034,2.5862715,3.2172808,29.8813606,45.2172539,0.0109369,14.0544941,11.5538373,22.9463194,5.0310001,6.4556489,0.2068739,18.8331624),(4547,'humerus.tif',183,2,133,12.6823052,17.3532495,11.699587,1.8,17.3555316,11.6971222,-0.0688411,2.5804994,3.1988416,29.3280916,44.5251938,0.0100013,13.9191618,11.3652774,22.6493176,5.0310001,6.4320449,0.2449787,18.7323167),(4546,'humerus.tif',183,2,132,12.507489,17.3659493,11.6802722,1.8,17.3679251,11.6783362,-0.0636236,2.5644942,3.1900204,28.5856482,43.623706,0.0084269,13.6750556,11.1467003,22.2051471,4.9920001,6.4255387,0.1461889,18.631471),(4545,'humerus.tif',183,2,131,12.4548753,17.3803378,11.6622496,1.8,17.3825773,11.6606803,-0.0699286,2.5495581,3.2058709,28.0959526,43.2136044,0.0101342,13.4795211,11.0199305,21.8946379,4.9530001,6.425657,0.2140607,18.553471),(4544,'humerus.tif',183,2,130,12.4635733,17.4008238,11.6388682,1.8,17.4027514,11.6383875,-0.0747158,2.5571767,3.1912207,27.7625398,42.7878053,0.0115746,13.4079742,10.8567153,21.758584,4.9647441,6.4199735,0.1401788,18.5400883),(4543,'humerus.tif',183,2,129,12.3602392,17.4142307,11.6203696,1.8,17.4162442,11.6198538,-0.0657698,2.5421646,3.1780136,27.2366087,42.2668686,0.0088982,13.2997759,10.7139437,21.4761627,4.9530001,6.3988532,0.1591367,18.406934),(4542,'humerus.tif',183,2,128,12.3167732,17.4175543,11.6027156,1.8,17.4190538,11.6025143,-0.0587659,2.5164378,3.1747121,26.7321937,42.1852369,0.007081,13.2878937,10.6230296,21.3534102,4.9140001,6.392789,0.1531132,18.3746253),(4541,'humerus.tif',183,2,127,12.3271233,17.4311568,11.5817489,1.8,17.4340588,11.5806963,-0.0504962,2.4945814,3.1862793,26.4246558,41.9619421,0.0052343,13.1695745,10.5928217,21.2545233,4.9086264,6.3869572,0.1470784,18.2832427),(4540,'humerus.tif',183,2,126,12.2915597,17.4494287,11.5602047,1.8,17.4508175,11.558771,-0.0361856,2.468233,3.1650867,25.9707787,41.6095579,0.0026813,13.1464197,10.5220125,21.0194568,4.8750001,6.3869572,0.1470784,18.2052426),(4539,'humerus.tif',183,2,125,12.2429299,17.4716386,11.5466523,1.8,17.4728641,11.5445855,-0.0327786,2.4409034,3.1730894,25.5109779,41.3737751,0.0021916,13.0389567,10.4514494,20.9084358,4.8360001,6.3875525,0.0978461,18.182397),(4538,'humerus.tif',183,2,124,12.24711,17.4858369,11.5345514,1.8,17.4873436,11.5332601,-0.0274289,2.4112335,3.1565566,25.0503529,41.3073839,0.0015353,13.0862168,10.3890201,20.8512598,4.8296609,6.3613054,0.1167506,18.104397),(4537,'humerus.tif',183,2,123,12.3120784,17.4979964,11.5143487,1.8,17.4993394,11.5121142,-0.0230471,2.3937058,3.1512364,24.841428,41.2954562,0.0010898,13.1045249,10.3778115,20.8688991,4.7970001,6.3659662,0.1228352,18.026397),(4536,'humerus.tif',183,2,122,12.3074949,17.506413,11.4976869,1.8,17.5082412,11.4977427,-0.0186604,2.379193,3.1590939,24.5240852,40.9520101,0.0007142,12.9632139,10.3077327,20.6755103,4.7580001,6.3483808,0.1479786,17.938934),(4535,'humerus.tif',183,2,121,12.3355737,17.4997247,11.4811519,1.8,17.5032201,11.4787125,-0.0151099,2.3966543,3.151261,24.2385406,41.0428114,0.0004694,13.0242503,10.1134904,20.6043323,4.7580001,6.3659662,0.1228352,17.948397),(4534,'humerus.tif',183,2,120,12.3426595,17.4961531,11.4586052,1.8,17.4986388,11.4558909,-0.0144406,2.3767749,3.1823645,23.9561478,41.0843009,0.0004289,12.9099922,10.0792664,20.4317066,4.7190001,6.3714592,0.0673825,17.948397),(4533,'humerus.tif',183,2,119,12.3236335,17.4862499,11.4423413,1.8,17.4882997,11.4428021,-0.0122218,2.3615356,3.1494697,23.7358205,40.6743088,0.0003068,12.9146533,10.0510109,20.3137432,4.6800001,6.3568805,0.1106572,17.8152426),(4532,'humerus.tif',183,2,118,12.315387,17.4740184,11.4185071,1.8,17.4759464,11.4179415,-0.0039135,2.3717176,3.1581458,23.5645805,40.3660461,0.0000314,12.7815653,9.9356604,20.1576108,4.7155117,6.3450257,0.0923293,17.8247056),(4531,'humerus.tif',183,2,117,12.3394402,17.460743,11.3991113,1.8,17.4618633,11.4001395,0.0014779,2.3517591,3.1701224,23.4311781,40.132674,0.0000045,12.6596607,9.9632559,19.9903997,4.6800001,6.3353098,0.073939,17.8152426),(4530,'humerus.tif',183,2,116,12.3216771,17.4565163,11.3766133,1.8,17.4576128,11.3760973,0.0101609,2.3700258,3.1736435,23.2102141,40.0037933,0.000212,12.6050055,9.7932325,19.8799324,4.6791867,6.3325482,0.0677972,17.7695513),(4529,'humerus.tif',183,2,115,12.3172503,17.4501112,11.3635899,1.8,17.4540044,11.3641571,0.0257397,2.3644105,3.1784564,23.0274496,39.7652122,0.0013598,12.5108565,9.7391929,19.7122723,4.6410001,6.3300258,0.0616502,17.7372426),(4528,'humerus.tif',183,2,114,12.3096005,17.4445546,11.33815,1.8,17.4473911,11.3375789,0.0354241,2.3731611,3.1486181,22.8261965,39.6870151,0.0025734,12.604582,9.6184774,19.7712733,4.6410001,6.2994358,0.0805705,17.6820883),(4527,'humerus.tif',183,2,113,12.3746349,17.4486309,11.3143128,1.8,17.4507243,11.3142947,0.0450652,2.3570408,3.1807014,22.7111716,39.8329909,0.0041857,12.5233357,9.6354596,19.6467597,4.6020001,6.3300258,3.0799425,17.6820883),(4526,'humerus.tif',183,2,112,12.3387713,17.4470274,11.2932716,1.8,17.4480924,11.2924899,0.0496274,2.3429312,3.1828176,22.3803748,39.8733357,0.0050607,12.5276847,9.5522968,19.5492154,4.5630001,6.3325482,3.0737955,17.626934),(4525,'humerus.tif',183,2,111,12.2394187,17.4385358,11.2757753,1.8,17.4394847,11.2743628,0.0560056,2.3560704,3.1613516,22.1224609,39.6593883,0.0063917,12.5450737,9.3895586,19.540181,4.6020001,6.3325482,3.0737955,17.6915513),(4524,'humerus.tif',183,2,110,12.2286553,17.42731,11.2551033,1.8,17.4273865,11.2543474,0.0646076,2.344801,3.1742219,21.9261033,39.4842123,0.0084955,12.4390208,9.3509441,19.3446243,4.5630001,6.3383101,3.0615173,17.6040883),(4523,'humerus.tif',183,2,109,12.1408784,17.4185675,11.2338653,1.8,17.4188346,11.2323905,0.0720662,2.3452501,3.1819105,21.7021647,39.1921736,0.0104908,12.3171827,9.2536677,19.1376564,4.5630001,6.3450257,3.0492633,17.626934),(4522,'humerus.tif',183,2,108,12.023725,17.419398,11.2082416,1.8,17.4206394,11.2068939,0.08297,2.3384898,3.1506488,21.5108146,38.6288132,0.0137636,12.2605902,9.1985923,19.0826216,4.5630001,6.3181205,3.0302538,17.5717796),(4521,'humerus.tif',183,2,107,11.9083276,17.402199,11.1840512,1.8,17.4017694,11.1842905,0.0934207,2.3249489,3.167002,21.2681809,38.3314233,0.0172712,12.1033783,9.1478057,18.8183187,4.5240001,6.3415489,3.0553871,17.5717796),(4520,'humerus.tif',183,2,106,11.7676363,17.3876951,11.1594817,1.8,17.3878769,11.1597653,0.1040714,2.3230174,3.1574385,20.950103,37.9932213,0.0211657,12.0329253,9.0184872,18.6509815,4.5240001,6.3272619,3.0180022,17.539471),(4519,'humerus.tif',183,2,105,11.7041734,17.3736078,11.1363195,1.8,17.3722998,11.1364789,0.1137647,2.3195742,3.1707994,20.7319777,37.8449382,0.0251379,11.9354563,8.9378376,18.4668658,4.5240001,6.3272619,3.0180022,17.539471),(4518,'humerus.tif',183,2,104,11.5664888,17.3632909,11.1169354,1.8,17.3652336,11.1171528,0.1211015,2.3133358,3.1452233,20.486421,37.3013219,0.0281336,11.8596737,8.855792,18.3661938,4.5133574,6.2935175,3.0110886,17.5071623),(4517,'humerus.tif',183,2,103,11.3748073,17.3517737,11.0881396,1.8,17.3515431,11.0879003,0.1264516,2.3055735,3.1029958,20.1531434,36.7290951,0.0301526,11.8366563,8.7410543,18.2665866,4.4850001,6.2513243,2.9723414,17.3873907),(4516,'humerus.tif',183,2,102,11.2636761,17.3378827,11.0699804,1.8,17.3361873,11.0696592,0.1296639,2.304811,3.1012702,19.8923467,36.3603018,0.0313857,11.7243258,8.6307929,18.0956289,4.4460001,6.2214476,3.0032417,17.355082),(4515,'humerus.tif',183,2,101,11.2729615,17.3140654,11.0606085,1.8,17.3130474,11.0608178,0.1376486,2.3177686,3.0959916,19.9256951,36.2513538,0.0353742,11.7091253,8.5969301,18.1374189,4.4850001,6.2001416,2.9836827,17.423619),(4514,'humerus.tif',183,2,100,11.1347859,17.2931644,11.0426948,1.8,17.2930123,11.0422649,0.1395979,2.3139318,3.0834732,19.5867174,35.7590176,0.0359307,11.5969932,8.4646907,17.9480832,4.4460001,6.1616299,2.9826874,17.3133104),(4513,'humerus.tif',183,2,99,10.9744363,17.2669909,11.0226877,1.8,17.2649903,11.0214413,0.14642,2.3091997,3.0701819,19.2650394,35.2490844,0.0389337,11.4811062,8.3427343,17.7060692,4.4460001,6.1231244,2.9816795,17.3038474),(4512,'humerus.tif',183,2,98,10.9649922,17.2490556,11.011917,1.8,17.2470689,11.0125108,0.1538684,2.3190605,3.0609586,19.1968415,35.0177159,0.0429266,11.4401141,8.2778528,17.6795784,4.4460001,6.0919949,2.9090357,17.2486931),(4511,'humerus.tif',183,2,97,10.9304954,17.2335783,10.9970847,1.8,17.2325037,10.996374,0.1570886,2.3132522,3.0610457,19.0542492,34.708906,0.0445864,11.3389048,8.2369961,17.5559148,4.4460001,6.0660988,2.9278051,17.2163844),(4510,'humerus.tif',183,2,96,10.8576358,17.2179051,10.9830295,1.8,17.2172483,10.9821451,0.1616034,2.3159532,3.0554238,18.9081975,34.2274971,0.0468491,11.2022093,8.1643264,17.3891897,4.4434256,6.0444969,2.8872246,17.1840757),(4509,'humerus.tif',183,2,95,10.785097,17.1953742,10.9642911,1.8,17.1950555,10.9631058,0.1665564,2.3141047,3.0363327,18.7412682,33.8397415,0.0494056,11.1449387,8.0987123,17.316401,4.4346723,6.0106834,2.8588367,17.1289214),(4508,'humerus.tif',183,2,94,10.6877967,17.170377,10.9382135,1.8,17.1689229,10.9366483,0.1651231,2.3051877,3.0266674,18.5338897,33.415216,0.0481284,11.0402668,8.0400784,17.1369142,4.4070001,5.9843084,2.8507601,17.1194584),(4507,'humerus.tif',183,2,93,10.654813,17.1533335,10.9212515,1.8,17.1534797,10.9215438,0.1677778,2.3042241,3.0261079,18.4084666,33.1292343,0.0495204,10.9478035,7.9890087,17.0256288,4.4070001,5.9583272,2.8426125,17.0643041),(4506,'humerus.tif',183,2,92,10.6183636,17.1244965,10.8973943,1.8,17.1251383,10.8961398,0.1748894,2.2928432,3.0065135,18.2550628,32.8780883,0.0535798,10.9356197,7.9617581,17.006002,4.4070001,5.934283,2.7928217,16.9996868),(4505,'humerus.tif',183,2,91,10.5977649,17.0988985,10.8736768,1.8,17.0996312,10.8728433,0.181448,2.2888567,3.0010175,18.1545659,32.5903606,0.0575169,10.8597703,7.9317179,16.8848022,4.4049605,5.9111703,2.7843664,16.9768411),(4504,'humerus.tif',183,2,90,10.6140938,17.0675835,10.8467225,1.8,17.0691001,10.8449944,0.1828536,2.2783044,2.9934598,18.1405978,32.2004398,0.0584915,10.7569307,7.9623239,16.8159769,4.3979155,5.8837031,2.886968,16.9216868),(4503,'humerus.tif',183,2,89,10.6009979,17.0331699,10.8232306,1.8,17.0350001,10.822337,0.185886,2.2761929,2.9695988,18.0415495,31.8563943,0.0603505,10.7275078,7.9261955,16.8026257,4.3960518,5.8610397,2.7882736,16.8665324),(4502,'humerus.tif',183,2,88,10.5421845,16.9997203,10.8065005,1.8,17.0008275,10.8060583,0.1895626,2.2756079,2.9572448,17.8933405,31.4512938,0.0623845,10.6353366,7.8631037,16.6787509,4.390624,5.8345096,2.8008169,16.8436868),(4501,'humerus.tif',183,2,87,10.5234743,16.9710974,10.7831295,1.8,16.9721277,10.7819307,0.1966332,2.2661548,2.9467746,17.7901964,31.1296122,0.0669448,10.5639612,7.8503889,16.601026,4.3797685,5.8125704,2.8559199,16.7885324),(4500,'humerus.tif',183,2,86,10.5433943,16.9314054,10.753196,1.8,16.9335589,10.7527091,0.1981092,2.2524384,2.9325097,17.78088,30.8375887,0.068069,10.5157669,7.8940581,16.5725626,4.3680001,5.797767,2.8411155,16.7333781),(4499,'humerus.tif',183,2,85,10.5128318,16.8946495,10.7273525,1.8,16.8962569,10.7264041,0.1964341,2.241766,2.9143862,17.667877,30.3570841,0.0667435,10.4162873,7.8812314,16.4782383,4.3663393,5.7806895,2.8753406,16.6553781),(4498,'humerus.tif',183,2,84,10.465,16.8578664,10.7080948,1.8,16.8593006,10.7080169,0.1965973,2.2376925,2.8975658,17.5744498,29.8719356,0.0665488,10.309321,7.8538272,16.3687304,4.3663393,5.7605259,2.8391117,16.6002238),(4497,'humerus.tif',183,2,83,10.4682944,16.8241922,10.6881217,1.8,16.8234173,10.6875384,0.1969374,2.2324642,2.8835009,17.4746958,29.5982777,0.0667973,10.264702,7.8275367,16.3244018,4.3290001,5.7377737,2.852089,16.6002238),(4496,'humerus.tif',183,2,82,10.4546838,16.7962282,10.6632216,1.8,16.7967674,10.6618984,0.2007088,2.229235,2.8667522,17.4499242,29.3378279,0.0692553,10.2338208,7.8277634,16.3081253,4.3664345,5.7233083,2.8370818,16.4993781),(4495,'humerus.tif',183,2,81,10.4633216,16.7543175,10.6431747,1.8,16.7543817,10.6425622,0.2009733,2.2179887,2.8521313,17.4109765,29.0687229,0.0694928,10.19193,7.849894,16.2963335,4.3558906,5.7012079,2.7852239,16.4670694),(4494,'humerus.tif',183,2,80,10.4753322,16.7210157,10.6260056,1.8,16.7217883,10.6250046,0.2125508,2.223389,2.8405873,17.429575,28.7876318,0.0776948,10.1343944,7.8391927,16.263249,4.3680001,5.6982725,2.8068558,16.4442238),(4493,'humerus.tif',183,2,79,10.4694651,16.6883035,10.6074851,1.8,16.688838,10.6072413,0.2171831,2.2209596,2.8218172,17.4075936,28.5257195,0.0810189,10.1089893,7.8378706,16.2591504,4.3680001,5.6855795,2.8133346,16.3662238),(4492,'humerus.tif',183,2,78,10.4929681,16.6609632,10.5847296,1.8,16.6629149,10.5836691,0.2316023,2.2154344,2.8117007,17.317802,28.4687234,0.0921411,10.1250904,7.8168878,16.2727308,4.3663393,5.6562104,2.7674882,16.3433781),(4491,'humerus.tif',183,2,77,10.5169374,16.6272818,10.5678225,1.8,16.62823,10.5685843,0.2401385,2.2090057,2.7933638,17.3491032,28.3154866,0.0991511,10.1366986,7.8538064,16.2170576,4.3680001,5.642075,2.7739225,16.3433781),(4490,'humerus.tif',183,2,76,10.5408157,16.6024094,10.5482269,1.8,16.6036088,10.5477419,0.2494122,2.2064702,2.7891713,17.4061934,28.208511,0.107037,10.1135815,7.8887053,16.2258336,4.3762264,5.6377601,2.7957767,16.3205324),(4489,'humerus.tif',183,2,75,10.5520626,16.5616602,10.529583,1.8,16.5633577,10.5276368,0.2626336,2.2089761,2.7996498,17.4641371,27.9971284,0.1185436,10.0002251,7.9059874,16.1471228,4.3680001,5.6246601,2.8023,16.2787608),(4488,'humerus.tif',183,2,74,10.5936574,16.5279833,10.5083908,1.8,16.5280862,10.5081342,0.2725244,2.2090732,2.8091041,17.6153436,27.8782867,0.1279167,9.9242627,7.9740877,16.1428306,4.3884097,5.6145104,2.786887,16.3205324),(4487,'humerus.tif',183,2,73,10.6525347,16.482171,10.4902483,1.8,16.483271,10.4900601,0.282521,2.2107506,2.8222503,17.7640565,27.7694548,0.1379804,9.8394727,8.0353055,16.0258762,4.3982952,5.6130202,2.7494739,16.2653781),(4486,'humerus.tif',183,2,72,10.7743733,16.4380782,10.462983,1.8,16.440137,10.4625899,0.2881251,2.2043986,2.8467937,17.8796524,27.9804828,0.1449945,9.8287709,8.110898,16.0506413,4.4048045,5.6074624,2.7339611,16.3110694),(4485,'humerus.tif',183,2,71,10.8183106,16.4045142,10.4389006,1.8,16.403845,10.4387432,0.300911,2.1996602,2.8510952,17.9808786,28.0494017,0.1583932,9.8381147,8.1743891,16.0620882,4.4070001,5.5982325,2.7559117,16.2559151),(4484,'humerus.tif',183,2,70,10.7293278,16.3908346,10.4292661,1.8,16.3900689,10.42802,0.3186847,2.2071439,2.8333841,18.088992,27.710616,0.1755461,9.780042,8.1956558,16.0899884,4.4268492,5.592116,2.7403639,16.3110694),(4483,'humerus.tif',183,2,69,10.5251347,16.384081,10.4382681,1.8,16.3855664,10.4397748,0.3202065,2.218064,2.812267,18.1740729,27.2818808,0.1737971,9.7010279,8.193665,16.1272686,4.4268492,5.5873542,2.7247858,16.3110694),(4482,'humerus.tif',183,2,68,10.4911812,16.3654976,10.4236365,1.8,16.3663422,10.4248648,0.3376108,2.2254731,2.8005628,18.2859356,27.2670155,0.1918413,9.7362628,8.2166507,16.2381882,4.4363859,5.5839504,2.7091849,16.3110694),(4481,'humerus.tif',183,2,67,10.4189407,16.3360337,10.4019433,1.8,16.3360798,10.4016718,0.3516209,2.2236912,2.8108383,18.328057,27.2447058,0.2059914,9.6927331,8.2421771,16.2094539,4.4520286,5.5770001,2.7468015,16.3339151),(4480,'humerus.tif',183,2,66,10.4031394,16.3015,10.3862002,1.8,16.3023109,10.3881145,0.3771611,2.2273361,2.8199465,18.3942689,27.4131071,0.2351666,9.7211446,8.2584165,16.2272777,4.4646907,5.5839504,2.7091849,16.3890694),(4479,'humerus.tif',183,2,65,10.4139882,16.2739393,10.3697269,1.8,16.2746373,10.3699442,0.4008055,2.2340019,2.8235623,18.6087835,27.5582809,0.2642115,9.7601109,8.3297974,16.3506102,4.4896147,5.5873542,2.6311043,16.4119151),(4478,'humerus.tif',183,2,64,10.4451524,16.2501615,10.3447002,1.8,16.2510004,10.3445352,0.4344192,2.2522019,2.8184963,18.895217,27.7230209,0.308381,9.8361032,8.3896639,16.5347734,4.5021296,5.5982325,2.5999784,16.4670694),(4477,'humerus.tif',183,2,63,10.5588047,16.2137253,10.3242944,1.8,16.2159136,10.3252503,0.4676496,2.2564435,2.839401,19.1221054,28.2348262,0.3576112,9.9439374,8.4744447,16.6779064,4.5350401,5.6214142,2.6344941,16.5127608),(4476,'humerus.tif',183,2,62,10.657816,16.1901993,10.3101849,1.8,16.1913345,10.3103075,0.4914594,2.2796985,2.8358951,19.4840642,28.4957008,0.395586,10.048221,8.5467725,16.9076604,4.5499105,5.6388391,2.5881253,16.5356065),(4475,'humerus.tif',183,2,61,10.6317894,16.1756076,10.3015972,1.8,16.1765791,10.3009091,0.5240253,2.2889965,2.8351507,19.7885385,28.579936,0.443646,10.0805702,8.6450717,17.0597045,4.5700415,5.6594363,2.5822629,16.6687608),(4474,'humerus.tif',183,2,60,10.7081416,16.1526701,10.2809833,1.8,16.1554626,10.2817074,0.5681814,2.3104274,2.8498959,20.0698843,29.1241118,0.5167601,10.21936,8.6866545,17.2531592,4.5881936,5.7033418,2.5213432,16.7144521),(4473,'humerus.tif',183,2,59,10.9767151,16.1091316,10.2491093,1.8,16.1122092,10.2502672,0.6051734,2.3360971,2.8812138,20.4610839,30.1918756,0.592107,10.4788737,8.7586616,17.5560424,4.6251783,5.7377737,2.4572979,16.7601435),(4472,'humerus.tif',183,2,58,11.2910462,16.0851402,10.2298173,1.8,16.0877685,10.231911,0.6451817,2.3488979,2.9041953,20.8412004,31.5018695,0.6805004,10.8470215,8.872757,17.9830962,4.6398464,5.7784526,2.427842,16.9027608),(4471,'humerus.tif',183,2,57,11.3173923,16.0762027,10.2298221,1.8,16.0790131,10.2308764,0.6798618,2.3660242,2.9105347,21.1704777,32.0023461,0.7455248,10.9953496,8.9477013,18.2481883,4.6745378,5.8298153,2.4177281,17.0036065),(4470,'humerus.tif',183,2,56,11.3590351,16.0611019,10.2264053,1.8,16.0641004,10.2263581,0.709611,2.3706616,2.9312497,21.5349379,32.4485426,0.8036568,11.0698664,9.0839359,18.4164438,4.7095523,5.8884836,2.285888,17.0492978),(4469,'humerus.tif',183,2,55,11.3847503,16.0575,10.2357638,1.8,16.0590125,10.2359964,0.7483398,2.3804691,2.9561878,21.9261753,32.8643444,0.8784769,11.1171368,9.2108631,18.4261222,4.727152,5.957306,2.2588289,17.1501435),(4468,'humerus.tif',183,2,54,11.6677704,16.0326306,10.206792,1.8,16.0332338,10.205542,0.7951233,2.3851821,2.9863352,22.3570339,34.3393442,0.9912247,11.4988246,9.3733027,18.9152276,4.7708496,6.0423576,2.2556176,17.3707608),(4467,'humerus.tif',183,2,53,11.9605887,15.9952666,10.1701921,1.8,15.9990163,10.171638,0.8140029,2.3915846,3.0712772,22.7002486,35.8124578,1.0537063,11.6604445,9.491719,19.0004186,4.7708496,6.1159164,2.2296024,17.4164522),(4466,'humerus.tif',183,2,52,12.1353977,15.9681496,10.1462802,1.8,15.9712082,10.1486648,0.8355746,2.4143828,3.1402773,23.0416925,36.9836752,1.112598,11.7772004,9.5435127,19.0828807,4.7984267,6.2014907,2.2268754,17.5724522),(4465,'humerus.tif',183,2,51,12.1004583,15.9743471,10.1667825,1.8,15.9769164,10.1663155,0.8653745,2.4161897,3.1587573,23.3773969,37.2886822,1.1689764,11.8048582,9.6753151,19.1812777,4.7967589,6.294605,2.2155366,17.7284522),(4464,'humerus.tif',183,2,50,12.1946335,16.0154853,10.2260181,1.8,16.018679,10.2271387,0.9167571,2.4243453,3.1963742,23.730323,37.9022229,1.2801379,11.8578805,9.7883429,19.2377107,4.7932571,6.3836223,2.1825233,17.8198349),(4463,'humerus.tif',183,2,49,13.4005633,16.0423505,10.2654846,1.8,16.0483531,10.2707888,0.956118,2.4368754,3.3020118,24.3341128,42.0265935,1.4906384,12.7275723,9.9857846,20.0786882,4.7732321,6.4922996,2.1854593,18.0727608),(4462,'humerus.tif',183,2,48,13.4757208,15.9492088,10.1267688,1.8,15.9531645,10.1309513,0.9464298,2.4496223,3.3894598,24.6596987,42.8445437,1.4784262,12.6405229,10.0667352,19.9158141,4.7486548,6.6203579,2.1718701,18.1641435),(4461,'humerus.tif',183,2,47,12.7510873,15.9358336,10.0857555,1.8,15.9380034,10.0881337,0.9635252,2.4725896,3.4718795,23.9139081,42.3486056,1.433186,12.1976024,9.6716042,19.0851878,4.7378883,6.7066396,2.1491218,18.3524522),(4460,'humerus.tif',183,2,46,12.112845,15.993483,10.1269275,1.8,15.9964114,10.1282884,0.9960201,2.4985012,3.4471864,23.4439455,41.4942543,1.4221449,12.0371367,9.3832036,18.8240652,4.703943,6.7932807,2.1476529,18.5730695),(4459,'humerus.tif',183,2,45,12.2664254,16.0038944,10.0844162,1.8,16.0066574,10.086338,1.0398574,2.5276083,3.528684,23.1002833,43.7969838,1.5202527,12.4117045,9.1391864,18.8633782,4.6638012,6.8916434,2.1792043,18.7424522),(4458,'humerus.tif',183,2,44,13.0281174,15.9879827,10.011179,1.8,15.9920087,10.0188126,1.0667661,2.5449562,3.6909111,22.9173481,47.5547026,1.6648873,12.8842721,9.0050069,18.688429,4.6326998,7.0594311,2.2032482,19.0221435),(4457,'humerus.tif',183,2,43,12.5125065,16.0456059,10.0934829,1.8,16.0487637,10.0955715,1.0910014,2.54968,3.5880911,22.5141551,46.0873775,1.6410736,12.8445395,8.8301885,18.6654107,4.595091,7.0909252,2.199997,19.1647609),(4456,'humerus.tif',183,2,42,12.0296817,16.1055688,10.1328931,1.8,16.1071513,10.1322257,1.1470902,2.560662,3.4807279,21.876943,44.8099338,1.6660358,12.8737249,8.5434714,18.4899501,4.5518828,7.1185419,2.177034,19.3491498),(4455,'humerus.tif',183,2,41,12.0670915,16.1368707,10.1162103,1.8,16.1391556,10.113001,1.202843,2.5678792,3.5112717,21.6016782,45.0583721,1.7509575,12.8324938,8.4122643,18.8049079,4.5181506,7.0963929,2.1725176,19.3719955),(4454,'humerus.tif',183,2,40,12.8800099,16.1346253,10.0691255,1.8,16.1360534,10.0666756,1.2495546,2.5396689,3.4808158,21.4566782,46.4115592,1.9326564,13.3335291,8.4486123,19.1042622,4.4840998,7.1066735,2.1648871,19.5926128),(4453,'humerus.tif',183,2,39,12.8328225,16.1297666,10.0129118,1.8,16.1349379,10.0142725,1.2821874,2.522059,3.484347,20.8129917,49.4240215,1.9655437,14.1845867,8.2523811,19.6799466,4.450818,7.1072085,2.1451012,19.8132301),(4452,'humerus.tif',183,2,38,12.8553167,16.1405695,9.9656929,1.8,16.1456282,9.9679922,1.3226427,2.4798211,3.5109896,20.0574929,51.9548258,2.0133,14.7977724,8.0882823,20.223738,4.4167422,7.1437101,2.1224513,19.9692301),(4451,'humerus.tif',183,2,37,12.8414493,16.1603298,9.9493765,1.8,16.1662191,9.9534757,1.3674692,2.4356688,3.5598457,19.3639237,53.2601855,2.0529725,14.9613747,7.9501463,20.0843171,4.376788,7.207407,2.0005586,20.3096191),(4450,'humerus.tif',183,2,36,12.8155481,16.1680787,9.9187522,1.8,16.1765324,9.9232415,1.4132546,2.3725573,3.6013557,18.5088794,55.7760224,2.0833495,15.487507,7.801236,20.2004891,4.3474874,7.3336596,1.9868608,20.6633908),(4449,'humerus.tif',183,2,35,13.0019888,16.1892066,9.8833178,1.8,16.1986131,9.8852448,1.4501047,2.3299726,3.6467343,17.7245711,59.7884304,2.1355856,16.3950605,7.6072015,20.7675859,4.3219419,7.4612414,1.9736291,21.1503167),(4448,'humerus.tif',183,2,34,13.4207305,16.2345188,9.852489,1.8,16.2451935,9.8549732,1.4780497,2.3164602,3.702683,17.150017,65.3155475,2.2176028,17.6400592,7.4035448,21.7431672,4.3125489,7.5900856,1.9608444,21.7664774),(4447,'humerus.tif',183,2,33,13.8856872,16.2890147,9.818793,1.8,16.3001261,9.815122,1.4972108,2.3194003,3.7651194,16.5926764,70.8696168,2.3017724,18.8226742,7.1538648,22.7169759,4.3268398,7.7281038,1.9372455,22.529175),(4446,'humerus.tif',183,2,32,14.0212246,16.3426645,9.8392743,1.8,16.353432,9.8350608,1.5116217,2.3489873,3.8889377,16.2387231,76.9281063,2.3286974,19.7812648,6.913074,23.4339827,4.3845461,7.8823431,1.8722054,25.7036569),(4445,'humerus.tif',183,2,31,14.3739013,16.4294292,9.8622707,1.8,16.4449623,9.8534587,1.5274758,2.3787131,4.0427374,16.1994624,82.8863639,2.3911572,20.5025346,6.8101793,24.1483675,4.4591603,8.031444,1.8664391,24.7219655),(4444,'humerus.tif',183,2,30,14.4800617,16.5189035,9.8877695,1.8,16.5365898,9.8851067,1.5500597,2.4331118,4.1713123,16.7822706,90.920783,2.412306,21.7966854,6.8974514,25.4075817,4.5670172,8.1856348,1.8458237,26.0685151),(4443,'humerus.tif',183,2,29,14.5788585,16.594543,9.8869551,1.8,16.6079309,9.888795,-1.5523571,2.4549169,4.3002329,17.6208218,102.6604568,2.4289837,23.8732319,7.1777672,27.6017848,0,0,0,0),(4442,'humerus.tif',183,2,28,14.9153904,16.7140564,9.9859158,1.8,16.7227778,10.0010682,-1.5259608,2.544589,4.5098909,19.5239431,117.1105702,2.4809045,25.9674954,7.6727295,29.8864101,0,0,0,0),(4441,'humerus.tif',183,2,27,16.0208885,17.0527386,9.9479289,1.8,17.077714,9.9819176,-1.5135119,2.863106,4.5834206,27.0075239,133.4721586,2.6613956,29.120644,9.432946,34.2985366,0,0,0,0),(4440,'humerus.tif',183,2,26,19.1217127,17.8005986,9.7339492,1.8,17.849006,9.7334981,-1.3885038,3.6936411,4.6091259,51.0485205,162.4931056,3.0822158,35.2546465,13.8206501,44.7184274,4.3266831,5.8546783,3.101614,19.976397),(4439,'humerus.tif',183,2,25,20.7698563,18.2770034,9.6641785,1.8,18.3830571,9.6208374,-1.2398524,3.7088728,4.6834484,63.8181095,174.7543752,3.0961511,37.3131847,17.2068747,50.0082042,7.0866146,9.2433293,1.2130133,35.5609972),(4438,'humerus.tif',183,2,24,20.9796364,18.4492096,9.7424017,1.8,18.52556,9.7237802,-1.1763158,3.9313289,4.7082738,69.8783808,175.0763301,2.9801276,37.1848235,17.7747483,50.188517,7.2771662,9.2995173,1.2596555,35.0055342),(4437,'humerus.tif',183,2,23,19.4625538,18.5270957,9.9614657,1.8,18.575386,9.9332395,-1.1642089,3.981622,4.8933816,70.7868985,159.4254533,2.7364278,32.5798123,17.7784077,45.3963368,7.4009741,9.3866124,0.738374,34.6060712),(4436,'humerus.tif',183,2,22,18.0745318,18.5712772,10.1730549,1.8,18.6188363,10.1434347,-1.1152698,4.0812505,4.9712816,72.9957974,148.5713576,2.4293889,29.8859267,17.8856448,42.2699395,7.4052252,9.8753208,0.6537693,34.9298303),(4435,'humerus.tif',183,2,21,17.6126562,18.5882629,10.2172417,1.8,18.6201363,10.158401,-1.1497233,3.8593966,5.0565457,71.5347745,140.1399802,2.445023,27.7145682,18.5352226,39.6807805,7.3233545,10.0291443,0.608496,32.848972),(4434,'humerus.tif',183,2,20,16.8943804,18.5764097,10.1873979,1.8,18.5769238,10.1780215,-1.1824135,3.7340846,5.0565457,70.6570231,132.213876,2.4119324,26.1470742,18.9221808,38.4941243,7.204214,9.9627256,0.5988599,32.4645153),(4433,'humerus.tif',183,2,19,17.5737854,18.5710912,10.0563399,1.8,18.5858817,10.0518538,-1.2033198,3.6859125,4.8894081,70.7074041,130.3809145,2.550926,26.6659912,19.1831478,39.3093285,6.9894553,9.847172,0.6165663,32.0382869),(4432,'humerus.tif',183,2,18,18.2500682,18.5891576,9.9075226,1.8,18.5980272,9.8810214,-1.2559917,3.7042169,5.073921,65.304186,131.2506336,2.7500687,25.8676935,17.6296872,38.7019126,6.7266349,9.9242551,1.1018764,32.4070649),(4431,'humerus.tif',183,2,17,17.7544963,18.5899025,10.0353814,1.8,18.590467,10.0106729,-1.1626713,3.46134,5.0026716,54.3149889,121.7677485,2.4929653,24.3405441,15.6918967,35.1690861,6.3782387,9.8076279,1.0733538,31.8917499),(4430,'humerus.tif',183,2,16,15.6610585,18.4087291,10.5849872,1.8,18.4155165,10.5712298,-1.0063806,3.1165247,4.3042339,35.7477757,78.1162119,1.8632957,18.148691,11.4703969,26.2044924,6.0800013,8.4748537,1.0185384,27.3857247),(4429,'humerus.tif',183,2,15,14.9436919,18.0831628,10.99572,1.8,18.1131282,10.9876458,-0.8625528,2.9887966,3.9236803,27.7582756,64.17948,1.4367085,16.3569594,9.2874423,23.2268427,5.731783,7.6963515,0.3089307,26.2669593),(4428,'humerus.tif',183,2,14,12.105005,17.7312632,11.1912424,1.8,17.6986562,11.2238362,-0.670522,2.9780998,3.975682,18.596887,47.0124687,0.7790213,11.8250073,6.2445479,16.4777905,3.3422287,5.4411641,2.5655179,15.7650694),(4427,'humerus.tif',183,2,13,5.6192983,17.4527084,11.8747057,1.8,17.4306826,11.8436134,0.128339,3.786669,2.841787,5.0666658,11.1698829,0.0153413,3.9305841,1.3380271,3.8058255,2.4033291,4.8625041,2.6025487,14.5493781),(4426,'humerus.tif',183,2,12,1.1955367,17.9143377,12.4320925,1.8,17.9193589,12.4278605,1.1769018,0.5062329,0.8940986,0.0643097,0.2073682,0.1699071,0.23193,0.1270357,0.3038501,1.0237547,1.782091,1.9756881,4.4681733),(4422,'humerus.tif',183,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4423,'humerus.tif',183,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4424,'humerus.tif',183,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4425,'humerus.tif',183,2,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4419,'humerus.tif',183,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4420,'humerus.tif',183,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4421,'humerus.tif',183,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4415,'humerus.tif',183,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4416,'humerus.tif',183,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4417,'humerus.tif',183,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4418,'humerus.tif',183,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(5407,'radius-cleaned.tif',183,3,793,8.8346409,4.6378402,5.9893315,1.8,4.6448999,6.0083002,-0.1023684,1.5023864,2.6544344,5.7163988,19.3169165,0.0153763,7.2772249,3.8048791,9.396089,2.9418059,5.321679,0.0750468,14.9335398),(5408,'radius-cleaned.tif',183,3,794,8.8351908,4.6380111,5.9875968,1.8,4.6456002,6.0061609,-0.1035373,1.492589,2.6538167,5.7035991,19.3182798,0.0157292,7.2794327,3.821279,9.3924981,2.9349716,5.321679,0.0750468,15.0327025),(5409,'radius-cleaned.tif',183,3,795,8.8674715,4.6381982,5.9855874,1.8,4.64477,6.0033386,-0.1044982,1.4948243,2.6448721,5.7220424,19.3703669,0.0160799,7.3237444,3.827903,9.4198076,2.938816,5.321679,0.0750468,14.8577499),(5410,'radius-cleaned.tif',183,3,796,8.8622914,4.6396379,5.983919,1.8,4.6468323,6.0004774,-0.1040132,1.5122398,2.6517056,5.7136031,19.3670724,0.0159223,7.3036284,3.7782388,9.4204046,2.9467183,5.3162915,0.060078,15.258411),(5411,'radius-cleaned.tif',183,3,797,8.8603147,4.6400362,5.9839147,1.8,4.6455446,6.0034026,-0.1058761,1.4892664,2.6508615,5.7189984,19.3447656,0.0164919,7.2975392,3.8401446,9.4155759,2.9406374,5.321679,0.0750468,15.0931398),(5412,'radius-cleaned.tif',183,3,798,8.8614951,4.6409102,5.9834709,1.8,4.6465348,6.0032902,-0.1062223,1.5143182,2.6540915,5.7145593,19.3616153,0.0166017,7.2950067,3.7736845,9.4145679,2.95963,5.3248192,0.082519,15.3575737),(5413,'radius-cleaned.tif',183,3,799,8.8755396,4.6432575,5.9813226,1.8,4.6517825,6.0009973,-0.1065358,1.4898206,2.6472221,5.7197749,19.4029807,0.016726,7.3295628,3.8392374,9.4489083,2.95963,5.3282564,0.0899819,15.4317025),(5414,'radius-cleaned.tif',183,3,800,8.8844884,4.6446345,5.9790091,1.8,4.6537534,5.9952945,-0.1069352,1.506229,2.6455074,5.7188553,19.3870623,0.0168681,7.3282965,3.7968034,9.447329,2.9522713,5.3162915,0.060078,14.8908042),(5415,'radius-cleaned.tif',183,3,801,8.9017434,4.6463954,5.9788302,1.8,4.6557063,5.9964642,-0.108617,1.5074074,2.6562893,5.7322729,19.4003807,0.0174346,7.3035647,3.8027363,9.4493116,2.951911,5.3155428,0.1355277,14.7819601),(5416,'radius-cleaned.tif',183,3,802,8.9067156,4.6465096,5.9780721,1.8,4.6561049,5.9939241,-0.1092143,1.5017324,2.6473139,5.7480881,19.4222255,0.0176359,7.3365781,3.8276381,9.4689016,2.9506111,5.3248192,0.082519,14.8110042),(5417,'radius-cleaned.tif',183,3,803,8.9142804,4.6495554,5.9774171,1.8,4.6616685,5.9943887,-0.1087801,1.509982,2.6433419,5.7493094,19.4363904,0.0175114,7.3529613,3.807535,9.4948303,2.9755014,5.3330348,0.1577687,15.2544008),(5418,'radius-cleaned.tif',183,3,804,8.9265136,4.6469225,5.9770477,1.8,4.6539457,5.9941354,-0.1087954,1.4963363,2.6555477,5.7529805,19.4414573,0.0175403,7.3210726,3.8447109,9.4747796,2.9418059,5.3155428,0.1355277,15.1689296),(5419,'radius-cleaned.tif',183,3,805,8.9483506,4.6447737,5.9769641,1.8,4.64512,5.9945231,-0.1089455,1.5053412,2.657654,5.7549217,19.4860683,0.0176316,7.3320562,3.8230015,9.4846513,2.9546873,5.3155428,0.1355277,15.178611),(5420,'radius-cleaned.tif',183,3,806,8.9648586,4.6446652,5.9774036,1.8,4.6420909,5.9963342,-0.1101348,1.5056365,2.6532583,5.7726109,19.5029813,0.0180503,7.3505776,3.8340004,9.5018073,2.9559023,5.3006967,0.113151,14.9609228),(5421,'radius-cleaned.tif',183,3,807,8.9817592,4.6464375,5.9767654,1.8,4.6457719,5.9955069,-0.1101902,1.5095787,2.6514166,5.7729352,19.528638,0.0181024,7.36536,3.8242029,9.5204549,2.9755014,5.3006967,0.113151,14.9569126),(5422,'radius-cleaned.tif',183,3,808,8.9994029,4.6456378,5.9763649,1.8,4.641089,5.9964002,-0.1107866,1.5090511,2.6564699,5.784002,19.546708,0.0183341,7.3581516,3.8328736,9.5215736,2.9624063,5.3155428,0.1355277,15.0794483),(5423,'radius-cleaned.tif',183,3,809,9.0061841,4.6458532,5.9750733,1.8,4.6369095,5.9934068,-0.1107729,1.5034232,2.6561151,5.7816109,19.5454001,0.0183434,7.3586421,3.8456311,9.5212137,2.9503493,5.30535,0.1206237,14.9762754),(5424,'radius-cleaned.tif',183,3,810,9.0059837,4.6494984,5.9733954,1.8,4.6413351,5.9916007,-0.1111759,1.5022614,2.6478208,5.7735232,19.5334238,0.0184761,7.3771698,3.8432214,9.5301911,2.9637062,5.3006967,0.113151,14.9472313),(5425,'radius-cleaned.tif',183,3,811,9.0080002,4.6502653,5.9730432,1.8,4.6429389,5.9915311,-0.1127122,1.5068753,2.6512167,5.7792881,19.5401526,0.0189924,7.3702586,3.8352796,9.5345647,2.9506111,5.30535,0.1206237,14.7916414),(5426,'radius-cleaned.tif',183,3,812,9.0312672,4.6512476,5.9722247,1.8,4.6432339,5.991354,-0.1125124,1.5061137,2.6591385,5.7831013,19.5663971,0.0189743,7.3581715,3.8397508,9.5294437,2.9664825,5.3155428,0.1355277,14.966594),(5427,'radius-cleaned.tif',183,3,813,9.0490788,4.6540569,5.9698039,1.8,4.6482962,5.9858816,-0.1131371,1.5033132,2.6470191,5.7906144,19.5791646,0.0192225,7.3966844,3.8519015,9.567803,2.9411652,5.29634,0.1056656,14.8246957),(5428,'radius-cleaned.tif',183,3,814,9.0549948,4.6544688,5.9703546,1.8,4.6469613,5.9879817,-0.1137114,1.5265063,2.6465825,5.7984887,19.5795684,0.01943,7.398057,3.7985357,9.5723015,2.9854752,5.29634,0.1056656,14.7916414),(5429,'radius-cleaned.tif',183,3,815,9.0355671,4.65806,5.9709151,1.8,4.652456,5.990183,-0.1140264,1.5014921,2.6521087,5.8058251,19.561654,0.0194954,7.375887,3.8667038,9.5609998,2.9467183,5.3155428,0.1355277,14.7021601),(5430,'radius-cleaned.tif',183,3,816,9.0173218,4.662964,5.9708792,1.8,4.661939,5.9915072,-0.1144887,1.5235428,2.6471968,5.8092655,19.5542871,0.0196134,7.38679,3.8129979,9.5771686,2.9669159,5.293634,0.158953,14.914177),(5431,'radius-cleaned.tif',183,3,817,9.0255687,4.663795,5.9710108,1.8,4.6615417,5.9925,-0.1145519,1.5069395,2.6372601,5.8254068,19.5631931,0.0196529,7.4179991,3.8657205,9.5931652,2.9467183,5.29634,0.1056656,15.0367126),(5432,'radius-cleaned.tif',183,3,818,9.0576169,4.6649214,5.9688184,1.8,4.6620516,5.9881818,-0.1149297,1.5171886,2.6449815,5.8301468,19.5732793,0.0198524,7.4001573,3.8427304,9.5999273,2.9755014,5.2874653,0.1515019,14.8674313),(5433,'radius-cleaned.tif',183,3,819,9.0838651,4.6649793,5.9699145,1.8,4.6608481,5.9920442,-0.115753,1.5017431,2.6541998,5.8370176,19.5959006,0.020195,7.3829787,3.8868282,9.5821375,2.9565087,5.3068501,0.1738011,14.8908042),(5434,'radius-cleaned.tif',183,3,820,9.1029562,4.6656647,5.9688672,1.8,4.6625506,5.9900205,-0.1159344,1.5127697,2.6441665,5.8379827,19.6120658,0.0203006,7.417107,3.8591352,9.6202235,2.9447136,5.293634,0.158953,14.6827973),(5435,'radius-cleaned.tif',183,3,821,9.0963122,4.6679494,5.9677328,1.8,4.6662566,5.9881703,-0.1158217,1.5211263,2.6417754,5.8412812,19.6057884,0.0202466,7.4214442,3.8401027,9.6277304,2.97368,5.2874653,0.1515019,15.1455567),(5436,'radius-cleaned.tif',183,3,822,9.0737509,4.6704316,5.9663555,1.8,4.668083,5.9849217,-0.1166303,1.5083597,2.6554952,5.8460993,19.5854309,0.020478,7.3754346,3.8757992,9.5204492,2.9533397,5.3006967,0.113151,14.834377),(5437,'radius-cleaned.tif',183,3,823,9.0465612,4.673429,5.9680049,1.8,4.6721218,5.9892532,-0.1165677,1.5267514,2.6455824,5.8425035,19.5371845,0.0203949,7.384833,3.826755,9.5932119,2.9882514,5.293634,0.158953,15.0327025),(5438,'radius-cleaned.tif',183,3,824,9.0355675,4.6750536,5.9660242,1.8,4.6750965,5.9864583,-0.1168376,1.5039904,2.6437364,5.8484037,19.5560325,0.0204641,7.3971188,3.8885912,9.6092481,2.9637062,5.2976925,0.2047809,14.9238584),(5439,'radius-cleaned.tif',183,3,825,9.0321352,4.6769553,5.966057,1.8,4.6789625,5.9860328,-0.117139,1.52065,2.6325228,5.8704781,19.5538591,0.0205615,7.4278023,3.8605057,9.6524158,2.97368,5.2760114,0.1365495,15.2019839),(5440,'radius-cleaned.tif',183,3,826,9.0189683,4.6783421,5.9659879,1.8,4.6804892,5.9853439,-0.117943,1.5046856,2.6472137,5.8774048,19.5401591,0.020813,7.381406,3.9060683,9.543492,2.9512748,5.29634,0.1056656,14.9335398),(5441,'radius-cleaned.tif',183,3,827,9.0191317,4.68134,5.9660351,1.8,4.6866782,5.985694,-0.1175077,1.5258609,2.6443692,5.8803185,19.5221888,0.0206608,7.3825505,3.853771,9.5485851,2.9872984,5.2922805,0.0981683,15.231028),(5442,'radius-cleaned.tif',183,3,828,9.0078185,4.6820594,5.9651015,1.8,4.6859179,5.9849386,-0.1175632,1.508802,2.6366643,5.8828764,19.5222158,0.0206543,7.404134,3.899038,9.6352458,2.9616908,5.2874653,0.1515019,15.126194),(5443,'radius-cleaned.tif',183,3,829,9.0112576,4.6837264,5.9641947,1.8,4.6881578,5.9830242,-0.1172314,1.5196027,2.6511979,5.8925881,19.5320947,0.0205462,7.3672715,3.8777163,9.5589521,2.9872984,5.2922805,0.0981683,14.966594),(5444,'radius-cleaned.tif',183,3,830,9.0074624,4.6863508,5.9639223,1.8,4.6928009,5.981993,-0.1180718,1.5264611,2.64838,5.9080452,19.5141682,0.0208317,7.3683415,3.8704197,9.5677249,2.9764052,5.3006967,0.113151,15.1979737),(5445,'radius-cleaned.tif',183,3,831,8.99672,4.6874651,5.9638687,1.8,4.6935509,5.9826112,-0.1184908,1.5151513,2.6377434,5.9063805,19.4858494,0.0209541,7.387318,3.8982116,9.5449415,2.9783122,5.2922805,0.0981683,15.0657567),(5446,'radius-cleaned.tif',183,3,832,8.9890414,4.689985,5.9637674,1.8,4.6957887,5.9835681,-0.1180981,1.5247184,2.628631,5.9173857,19.5008597,0.0207983,7.4186373,3.8809694,9.5789972,2.9900729,5.2820429,0.1899883,15.2213466),(5447,'radius-cleaned.tif',183,3,833,8.9894815,4.6907106,5.9628337,1.8,4.6944039,5.9820598,-0.1188128,1.5127512,2.643762,5.9188002,19.5010484,0.0210506,7.3762497,3.9126065,9.5820907,2.9800991,5.2922805,0.0981683,14.834377),(5448,'radius-cleaned.tif',183,3,834,8.9985755,4.6929137,5.9625548,1.8,4.6976145,5.9802144,-0.1193823,1.5288227,2.6414171,5.9229066,19.5041494,0.0212735,7.3839718,3.874162,9.5772795,2.9900729,5.2760114,0.1365495,15.6083161),(5449,'radius-cleaned.tif',183,3,835,8.995332,4.6938091,5.9625335,1.8,4.6970524,5.9812326,-0.1206163,1.5255604,2.6306516,5.9247378,19.4892815,0.0217056,7.4085376,3.8836469,9.5755859,2.9705587,5.2675558,0.175111,14.8246957),(5450,'radius-cleaned.tif',183,3,836,9.0040847,4.6947252,5.9629813,1.8,4.7004179,5.9811863,-0.1207557,1.5345481,2.6297541,5.9348766,19.5179283,0.0217767,7.4219593,3.8675078,9.609065,3.0035296,5.2820429,0.1899883,15.2407093),(5451,'radius-cleaned.tif',183,3,837,8.9978903,4.6952973,5.9625247,1.8,4.699383,5.9815327,-0.1207626,1.5209008,2.648356,5.925564,19.5068172,0.0217642,7.3656326,3.8960883,9.5891017,2.9696038,5.2760114,0.1365495,15.0657567),(5452,'radius-cleaned.tif',183,3,838,8.9810584,4.6971342,5.9618993,1.8,4.7003295,5.980095,-0.1207984,1.5289665,2.6368358,5.9247309,19.4777186,0.0217363,7.3867773,3.8749907,9.5830464,2.9984044,5.2657421,0.1215355,15.1649195),(5453,'radius-cleaned.tif',183,3,839,8.9808856,4.7005825,5.9624722,1.8,4.7041517,5.9825748,-0.1215329,1.5261741,2.6236436,5.9338814,19.4667327,0.0219997,7.4197323,3.8880763,9.594949,2.9782777,5.2675558,0.175111,15.0754381),(5454,'radius-cleaned.tif',183,3,840,8.983597,4.7042602,5.9619594,1.8,4.7117806,5.9809667,-0.1216848,1.5260881,2.6295712,5.9481175,19.4440819,0.0220611,7.3943926,3.8976238,9.6206468,2.9984044,5.2566642,0.1064661,15.1318652),(5455,'radius-cleaned.tif',183,3,841,8.9871684,4.7058864,5.9611656,1.8,4.7127631,5.9804496,-0.1222151,1.5247302,2.6374696,5.9503686,19.4599364,0.0222617,7.37826,3.9025714,9.6194271,2.9868706,5.2760114,0.1365495,15.1649195),(5456,'radius-cleaned.tif',183,3,842,8.9911129,4.7075805,5.9608415,1.8,4.7128899,5.9789457,-0.1227771,1.519826,2.6258925,5.9625398,19.4461788,0.0224757,7.4055501,3.9231726,9.6320116,2.9872984,5.2566642,0.1064661,15.3011466),(5457,'radius-cleaned.tif',183,3,843,8.9862909,4.708736,5.9610135,1.8,4.7130804,5.9806918,-0.1239063,1.5301517,2.6245084,5.9622664,19.4510662,0.0228767,7.4113181,3.8965198,9.6289719,2.9900729,5.2542408,0.160155,15.0036584),(5458,'radius-cleaned.tif',183,3,844,9.0005932,4.7106308,5.9606306,1.8,4.7159435,5.9794931,-0.1247283,1.5250974,2.6323179,5.9589018,19.4649153,0.0232165,7.3945915,3.9072269,9.639751,2.9823861,5.2675558,0.175111,15.2350381),(5459,'radius-cleaned.tif',183,3,845,9.0067333,4.7108957,5.9618693,1.8,4.7143867,5.9826964,-0.1253059,1.5265794,2.6321207,5.9826462,19.4536783,0.0234469,7.3908761,3.918988,9.6473595,2.9900729,5.2675558,0.175111,15.1552381),(5460,'radius-cleaned.tif',183,3,846,9.0063642,4.7133144,5.9607992,1.8,4.7179659,5.9790353,-0.1259578,1.5204056,2.6194611,5.989644,19.4513345,0.0236892,7.4257009,3.9395041,9.6561022,2.9866229,5.242107,0.1451263,15.0931398),(5461,'radius-cleaned.tif',183,3,847,9.0167204,4.7138196,5.9625104,1.8,4.7167289,5.9815763,-0.1273305,1.5329992,2.6188516,6.0090373,19.4586075,0.0242334,7.4302064,3.9197917,9.6685092,3.0000466,5.2542408,0.160155,15.2721025),(5462,'radius-cleaned.tif',183,3,848,9.0292633,4.7163955,5.9638215,1.8,4.7206152,5.9833333,-0.1275145,1.5285756,2.6265677,6.0000397,19.4617916,0.0243369,7.4095907,3.9252488,9.6760739,2.9875112,5.2480258,0.1526493,14.9609228),(5463,'radius-cleaned.tif',183,3,849,9.0317258,4.7181394,5.963876,1.8,4.7221571,5.9831528,-0.1278972,1.5401134,2.6247848,6.0150241,19.4635078,0.0244891,7.4152776,3.9055721,9.6894307,3.0118418,5.2428662,0.1914255,15.0697669),(5464,'radius-cleaned.tif',183,3,850,9.0297488,4.7199335,5.963969,1.8,4.7222501,5.9840853,-0.1284147,1.5341513,2.6229354,6.0216314,19.4468787,0.0246812,7.4141661,3.9250571,9.6670451,2.9875112,5.2542408,0.160155,15.0367126),(5465,'radius-cleaned.tif',183,3,851,9.0347218,4.7214989,5.9635803,1.8,4.724587,5.9825195,-0.127857,1.5351507,2.6112461,6.0376772,19.4304472,0.0244819,7.4410631,3.9329542,9.6971662,3.0035296,5.2282706,0.1764405,14.9979872),(5466,'radius-cleaned.tif',183,3,852,9.0525661,4.7255821,5.9645581,1.8,4.7306539,5.9855737,-0.1289854,1.5302692,2.6173185,6.0459752,19.4661909,0.0249627,7.4374559,3.9509225,9.7292749,2.9875112,5.2428662,0.1914255,15.0036584),(5467,'radius-cleaned.tif',183,3,853,9.0755806,4.7277167,5.9645663,1.8,4.7317852,5.9839195,-0.1288235,1.5320118,2.6152283,6.0584015,19.4653581,0.0249637,7.4430817,3.9545398,9.7416096,2.9984044,5.2428662,0.1914255,15.0560754),(5468,'radius-cleaned.tif',183,3,854,9.0891822,4.7287347,5.9646169,1.8,4.7309765,5.9843503,-0.1291694,1.5358472,2.6141704,6.0714483,19.47558,0.0251349,7.4500041,3.9531589,9.7294284,2.9875112,5.2428662,0.1914255,15.1125025),(5469,'radius-cleaned.tif',183,3,855,9.0980631,4.7302277,5.965481,1.8,4.7325348,5.9848347,-0.1293034,1.5368835,2.61278,6.0890446,19.4471331,0.0252113,7.4430809,3.9619429,9.7556902,2.9986173,5.2428662,0.1914255,15.2253567),(5470,'radius-cleaned.tif',183,3,856,9.1036006,4.7330566,5.9669401,1.8,4.7359614,5.9870182,-0.1303458,1.5405228,2.6099984,6.1033827,19.4638339,0.0256327,7.4574123,3.9618904,9.7717925,2.9900729,5.2455984,0.2302196,14.914177),(5471,'radius-cleaned.tif',183,3,857,9.1175699,4.7351605,5.9685331,1.8,4.7367839,5.9887946,-0.1301613,1.5352873,2.6185059,6.1129324,19.4728182,0.0255999,7.4366141,3.9816212,9.7668277,2.9875112,5.2586324,0.2063239,14.9899669),(5472,'radius-cleaned.tif',183,3,858,9.1237825,4.7366732,5.9695933,1.8,4.7379968,5.9898471,-0.1312722,1.5520553,2.6066116,6.1224546,19.4754492,0.0260539,7.4715578,3.94474,9.7735503,3.0000466,5.2428662,0.1914255,15.0931398),(5473,'radius-cleaned.tif',183,3,859,9.1212889,4.7382027,5.9704308,1.8,4.7394518,5.9906005,-0.1317176,1.5425987,2.6051346,6.1197298,19.4465072,0.0262228,7.4646844,3.9671561,9.7956527,2.9934921,5.2282706,0.1764405,15.4373737),(5474,'radius-cleaned.tif',183,3,860,9.1201862,4.7393049,5.9707613,1.8,4.7395199,5.9904141,-0.1314641,1.5453814,2.6145859,6.129553,19.4679007,0.0261194,7.4458829,3.966369,9.7652876,2.9924236,5.2586324,0.2063239,15.1455567),(5475,'radius-cleaned.tif',183,3,861,9.1116099,4.7407791,5.97103,1.8,4.7403789,5.9912495,-0.1319969,1.5382542,2.6131178,6.1300337,19.4661288,0.0263056,7.4493883,3.9850589,9.7907527,2.9723801,5.2480258,0.1526493,15.0560754),(5476,'radius-cleaned.tif',183,3,862,9.1142149,4.7423211,5.971383,1.8,4.7413898,5.9904285,-0.1321211,1.5518019,2.6011132,6.1407934,19.448577,0.0263624,7.4770206,3.9572019,9.7984829,2.9984044,5.2282706,0.1764405,14.9004855),(5477,'radius-cleaned.tif',183,3,863,9.1288259,4.7422671,5.9730071,1.8,4.7373802,5.9933889,-0.1325902,1.5456075,2.601307,6.1412391,19.4670193,0.0265913,7.4835532,3.9733497,9.8061023,2.9934921,5.2282706,0.1764405,15.4470551),(5478,'radius-cleaned.tif',183,3,864,9.1413493,4.7441623,5.9725989,1.8,4.7404646,5.9915056,-0.1317487,1.5479065,2.6099896,6.1530975,19.4788691,0.0262929,7.463198,3.9751094,9.7631746,2.9984044,5.2586324,0.2063239,14.9996483),(5479,'radius-cleaned.tif',183,3,865,9.140664,4.7465895,5.972612,1.8,4.7433546,5.9919077,-0.131442,1.5481658,2.6076085,6.1670782,19.4626168,0.0261693,7.4637803,3.9834739,9.7537031,2.9928514,5.2586324,0.2063239,15.2116652),(5480,'radius-cleaned.tif',183,3,866,9.1295167,4.748061,5.9724325,1.8,4.7455792,5.9907028,-0.1310431,1.542872,2.5957287,6.1658572,19.433769,0.0259799,7.486826,3.9963504,9.8200493,2.9872984,5.2282706,0.1764405,14.9198482),(5481,'radius-cleaned.tif',183,3,867,9.1260484,4.7503739,5.973066,1.8,4.7467072,5.9920564,-0.1315021,1.5468272,2.6039117,6.1710287,19.4071348,0.0261512,7.4530695,3.9894751,9.8040589,2.9866229,5.2428662,0.1914255,15.3438822),(5482,'radius-cleaned.tif',183,3,868,9.1177736,4.7528408,5.974207,1.8,4.7485101,5.9933902,-0.1324182,1.5482086,2.6015475,6.1728476,19.3881897,0.0264907,7.4525602,3.9870903,9.8211696,2.9992579,5.2364856,0.1375867,15.0423839),(5483,'radius-cleaned.tif',183,3,869,9.1186674,4.7553989,5.9748599,1.8,4.7493483,5.993444,-0.1327645,1.5544481,2.599072,6.1896357,19.3525633,0.0266312,7.4459513,3.9818864,9.8232805,3.0035296,5.2282706,0.1764405,15.0093296),(5484,'radius-cleaned.tif',183,3,870,9.1194545,4.7582384,5.9767757,1.8,4.7531258,5.9965984,-0.1337047,1.54605,2.596441,6.2017085,19.326201,0.0270098,7.443343,4.0113248,9.8196158,2.9923276,5.2282706,0.1764405,14.6884685),(5485,'radius-cleaned.tif',183,3,871,9.1229082,4.7604592,5.9772335,1.8,4.7559263,5.9963365,-0.1356504,1.5519688,2.5833586,6.2139743,19.2960705,0.0278073,7.4693736,4.00393,9.8054568,2.9918309,5.2072177,0.2635639,15.2253567),(5486,'radius-cleaned.tif',183,3,872,9.1168046,4.7628627,5.9795396,1.8,4.7597045,6.0009271,-0.1361117,1.5545432,2.6045052,6.2157741,19.2809142,0.0279768,7.4029086,3.9984569,9.7327028,2.9992579,5.2261386,0.1224611,15.2019839),(5487,'radius-cleaned.tif',183,3,873,9.1192986,4.7650469,5.9790061,1.8,4.7600726,5.9990922,-0.1357274,1.5543397,2.5898385,6.2193925,19.2448328,0.0278277,7.4309007,4.0013084,9.773898,2.9982252,5.2148553,0.1613751,15.1552381),(5488,'radius-cleaned.tif',183,3,874,9.1216673,4.7686327,5.9807753,1.8,4.7664245,6.0003416,-0.1354417,1.5512105,2.5865466,6.2275392,19.2229668,0.0277185,7.4319045,4.0146318,9.7582398,2.9992579,5.2148553,0.1613751,14.8908042),(5489,'radius-cleaned.tif',183,3,875,9.1092749,4.7711688,5.9815348,1.8,4.7676309,6.0003261,-0.1362613,1.5560467,2.5748249,6.2291203,19.1908974,0.0280148,7.4532825,4.0031706,9.7332833,2.9887282,5.2072177,0.2635639,15.5131636),(5490,'radius-cleaned.tif',183,3,876,9.1178727,4.7714556,5.984428,1.8,4.7647902,6.005817,-0.1369408,1.5826322,2.5964256,6.2506458,19.2232171,0.0283199,7.4037233,3.9495253,9.7554407,2.9992579,5.2148553,0.1613751,15.258411),(5491,'radius-cleaned.tif',183,3,877,9.1154186,4.7709513,5.9874294,1.8,4.7621595,6.0103583,-0.1394271,1.5770213,2.5855531,6.2634737,19.2095969,0.0293429,7.429589,3.9717115,9.757741,2.9934921,5.2169919,0.1072789,15.126194),(5492,'radius-cleaned.tif',183,3,878,9.1300496,4.7728948,5.989272,1.8,4.7647947,6.0138029,-0.1397834,1.614048,2.5831604,6.2862809,19.2088858,0.0295395,7.4361955,3.8947298,9.771038,3.0045981,5.2114961,0.2003986,14.8714414),(5493,'radius-cleaned.tif',183,3,879,9.1400021,4.7744467,5.9878453,1.8,4.7671825,6.0081477,-0.1390628,1.576522,2.5814806,6.2979575,19.1985195,0.0292695,7.4370186,3.9948427,9.7642801,3.0127137,5.2114961,0.2003986,15.310828),(5494,'radius-cleaned.tif',183,3,880,9.1325213,4.7766179,5.9883828,1.8,4.7702431,6.0082199,-0.1385063,1.576298,2.5794466,6.2947969,19.1709301,0.0290135,7.4321873,3.9934053,9.7455401,2.9992579,5.2114961,0.2003986,15.0230211),(5495,'radius-cleaned.tif',183,3,881,9.1254459,4.7771524,5.990328,1.8,4.7704692,6.0116591,-0.1395562,1.584248,2.5791086,6.2946651,19.1553051,0.0294293,7.4271031,3.9732828,9.7400559,3.0097233,5.2072177,0.2635639,15.0327025),(5496,'radius-cleaned.tif',183,3,882,9.1257735,4.7802593,5.9911574,1.8,4.7749828,6.0127002,-0.139838,1.5827068,2.5767073,6.3006469,19.1646225,0.0295486,7.4376405,3.9809312,9.7360283,3.0484963,5.2072177,0.2635639,15.178611),(5497,'radius-cleaned.tif',183,3,883,9.1244644,4.7815539,5.9914639,1.8,4.7788596,6.0117141,-0.1402646,1.5817867,2.5821346,6.3053175,19.1552117,0.0297236,7.418363,3.9861997,9.7687753,3.0103639,5.2114961,0.2003986,15.0327025),(5498,'radius-cleaned.tif',183,3,884,9.1120274,4.7844226,5.9909301,1.8,4.782433,6.0088227,-0.1403426,1.5684971,2.5739147,6.3054886,19.1034467,0.0297159,7.4219423,4.0200831,9.7480589,2.9992579,5.1969656,0.2561514,14.8674313),(5499,'radius-cleaned.tif',183,3,885,9.1041331,4.7850435,5.9922554,1.8,4.7820307,6.0100042,-0.1398673,1.5520933,2.5832375,6.3007086,19.1032587,0.0294908,7.3950841,4.0594908,9.7785958,2.9866578,5.2026297,0.1462354,15.2777737),(5500,'radius-cleaned.tif',183,3,886,9.0881938,4.7872087,5.992047,1.8,4.7865071,6.0087964,-0.1403998,1.5644057,2.5765328,6.2935139,19.0548168,0.0296622,7.3955265,4.0229423,9.7440357,3.0417596,5.1961997,0.1853479,15.2954754),(5501,'radius-cleaned.tif',183,3,887,9.0852813,4.7877015,5.9942788,1.8,4.788209,6.0127447,-0.1395211,1.5778701,2.5920798,6.3053547,19.0690962,0.0292851,7.356678,3.9961176,9.727209,3.0163447,5.2114961,0.2003986,15.3301907),(5502,'radius-cleaned.tif',183,3,888,9.0966075,4.7886693,5.9942263,1.8,4.7871608,6.0110856,-0.1399787,1.6011598,2.5798915,6.3218136,19.065191,0.029513,7.3899198,3.9482714,9.7696883,2.9990918,5.1916019,0.1310279,14.8908042),(5503,'radius-cleaned.tif',183,3,889,9.090382,4.7876482,5.9957692,1.8,4.7827059,6.0122382,-0.1404665,1.6047987,2.5809848,6.3076497,19.0400776,0.0296974,7.3770592,3.9304929,9.7601917,3.0090826,5.1889947,0.1777902,15.2253567),(5504,'radius-cleaned.tif',183,3,890,9.0840709,4.7889036,5.9963678,1.8,4.7826326,6.0136063,-0.1412112,1.568646,2.5683905,6.3191676,19.0068501,0.0299902,7.4002961,4.0284217,9.7429734,3.0018681,5.1889947,0.2170009,15.1165126),(5505,'radius-cleaned.tif',183,3,891,9.0797798,4.7885281,5.998398,1.8,4.7789968,6.0185166,-0.1421674,1.5820054,2.591324,6.3426863,19.0226369,0.0303806,7.3408947,4.0092698,9.7606361,3.0371654,5.2037006,0.1928843,15.7856178),(5506,'radius-cleaned.tif',183,3,892,9.0818506,4.7906743,6.0007645,1.8,4.7826056,6.0216438,-0.1442815,1.5722146,2.58912,6.3801087,19.0361346,0.0312916,7.352357,4.0580395,9.7824399,3.1019959,5.2037006,0.1928843,16.2627568),(5507,'radius-cleaned.tif',183,3,893,9.0831503,4.7909324,6.0028029,1.8,4.7794514,6.0253055,-0.1453871,1.5808449,2.5773773,6.3844751,19.0346265,0.0317742,7.3852697,4.0386473,9.7852907,3.1052718,5.1916019,0.1310279,16.4200077),(5508,'radius-cleaned.tif',183,3,894,9.0838483,4.7933891,6.0055064,1.8,4.7836609,6.0313261,-0.1465073,1.6095728,2.5661309,6.4024515,19.0416408,0.0322647,7.42037,3.9777335,9.7928011,3.1313657,5.1889947,0.2170009,16.8640924),(5509,'radius-cleaned.tif',183,3,895,9.0866154,4.7940524,6.0058879,1.8,4.7834632,6.0316074,-0.146956,1.6143792,2.5669137,6.415416,19.0243838,0.0324711,7.4113843,3.9739215,9.7891943,3.1489903,5.1889947,0.2170009,16.5739365),(5510,'radius-cleaned.tif',183,3,896,9.1101563,4.7966514,6.0084211,1.8,4.7864948,6.0341941,-0.1469408,1.6115112,2.58379,6.439214,19.0345698,0.0325485,7.3669184,3.9957614,9.7957707,3.1462916,5.2037006,0.1928843,16.5368721),(5511,'radius-cleaned.tif',183,3,897,9.1051786,4.7987665,6.0091396,1.8,4.7885923,6.0336237,-0.1466522,1.6386526,2.5709786,6.4413726,18.9710633,0.032404,7.3789269,3.9308958,9.7654005,3.1549963,5.1889947,0.1777902,17.0914619),(5512,'radius-cleaned.tif',183,3,898,9.1094227,4.8002885,6.0119675,1.8,4.7910881,6.0383019,-0.1478467,1.6063661,2.5725464,6.451613,18.9781975,0.0329455,7.3772031,4.0162782,9.7697713,3.0830081,5.1889947,0.1777902,15.2019839),(5513,'radius-cleaned.tif',183,3,899,9.1177763,4.8022544,6.0118026,1.8,4.7954856,6.0374957,-0.1483737,1.6332603,2.5629269,6.4673193,18.9839995,0.0332095,7.4071562,3.9597603,9.8456916,3.0367321,5.1724007,0.2019341,15.3148381),(5514,'radius-cleaned.tif',183,3,900,9.1150743,4.8027983,6.0138296,1.8,4.7953145,6.0416989,-0.1492354,1.6300477,2.5634346,6.4810555,18.9824459,0.0335835,7.4050829,3.9759913,9.8607247,3.0698373,5.1724007,0.2019341,15.7251805),(5515,'radius-cleaned.tif',183,3,901,9.1114419,4.8049223,6.0158022,1.8,4.7956408,6.0430315,-0.151579,1.6247045,2.5659599,6.4827514,18.9712544,0.0346246,7.3934337,3.9901111,9.8512431,3.1598445,5.1754777,0.1626138,16.9221806),(5516,'radius-cleaned.tif',183,3,902,9.110521,4.8057395,6.017936,1.8,4.7976912,6.0458883,-0.1524143,1.6213726,2.5666962,6.4902011,18.9621378,0.0350008,7.3877609,4.0029055,9.8497553,3.0421964,5.1754777,0.1626138,15.1746008),(5517,'radius-cleaned.tif',183,3,903,9.116877,4.8077458,6.0190522,1.8,4.8016333,6.0455114,-0.1529834,1.6009733,2.5686788,6.4997824,18.970013,0.0352852,7.3851246,4.0598943,9.850263,3.0312947,5.1724007,0.2019341,15.1358754),(5518,'radius-cleaned.tif',183,3,904,9.122363,4.811217,6.0201504,1.8,4.8080141,6.0465763,-0.1542199,1.5975762,2.5723043,6.5087911,18.9399732,0.0358749,7.3630374,4.0741663,9.8305044,3.0830081,5.1889947,0.1777902,15.4236822),(5519,'radius-cleaned.tif',183,3,905,9.1153504,4.8119484,6.0218615,1.8,4.806132,6.0481569,-0.1536632,1.5993636,2.5726026,6.5076581,18.9021076,0.0355911,7.347465,4.0689046,9.8144744,3.041016,5.1889947,0.1777902,15.0560754),(5520,'radius-cleaned.tif',183,3,906,9.1302065,4.8117517,6.0231414,1.8,4.8044742,6.0501977,-0.1554496,1.6345357,2.5727259,6.5238739,18.9342387,0.0364761,7.359602,3.9912703,9.8351476,3.0857045,5.1754777,0.1626138,15.4293534),(5521,'radius-cleaned.tif',183,3,907,9.1329293,4.8136127,6.0255143,1.8,4.8072699,6.0534921,-0.1552611,1.644563,2.5741437,6.5324302,18.9296886,0.0363992,7.3537809,3.9721373,9.8322373,3.036207,5.1724007,0.2019341,14.6787872),(5522,'radius-cleaned.tif',183,3,908,9.1543134,4.8145199,6.0270625,1.8,4.806982,6.0560602,-0.1576736,1.638988,2.5754718,6.5604097,18.9375398,0.0376176,7.353037,4.0027198,9.844283,3.1644635,5.1805507,0.2094796,16.8190077),(5523,'radius-cleaned.tif',183,3,909,9.1499701,4.8140615,6.028266,1.8,4.8046281,6.0572442,-0.1584824,1.6365606,2.575051,6.5588815,18.9146598,0.0379832,7.3453534,4.007723,9.8377324,3.1503008,5.1889947,0.1777902,16.4610822),(5524,'radius-cleaned.tif',183,3,910,9.1551626,4.8158268,6.0302909,1.8,4.8064062,6.061453,-0.1584245,1.6343765,2.576459,6.5750282,18.9237471,0.0379772,7.3448665,4.0229582,9.8430013,3.1503008,5.1805507,0.2094796,16.4473907),(5525,'radius-cleaned.tif',183,3,911,9.1501938,4.8170757,6.0310207,1.8,4.8074003,6.060589,-0.1596719,1.631432,2.5779105,6.5783223,18.9356869,0.0385516,7.3453625,4.032238,9.8450182,3.1489903,5.1805507,0.2094796,16.2627568),(5526,'radius-cleaned.tif',183,3,912,9.1540533,4.817996,6.0322193,1.8,4.808065,6.0626305,-0.160287,1.6291015,2.5787906,6.5971603,18.9310774,0.038863,7.341068,4.0495697,9.8483108,3.1580756,5.1805507,0.2094796,16.7722619),(5527,'radius-cleaned.tif',183,3,913,9.1448806,4.8178671,6.032294,1.8,4.8077956,6.0607574,-0.1596965,1.630009,2.5784959,6.5960861,18.9317388,0.038541,7.3421636,4.0466563,9.8486981,3.1565359,5.1805507,0.2094796,16.4143365),(5528,'radius-cleaned.tif',183,3,914,9.144847,4.8190809,6.0337302,1.8,4.8091746,6.0623572,-0.160159,1.6479454,2.5795871,6.6023532,18.926508,0.0387625,7.3370299,4.0064152,9.846054,3.1637122,5.1805507,0.2094796,16.1458924),(5529,'radius-cleaned.tif',183,3,915,9.1607249,4.8217671,6.0352108,1.8,4.8131342,6.064165,-0.1609105,1.6245293,2.5694117,6.6177589,18.9330835,0.0391919,7.3686452,4.073647,9.8639146,3.1598445,5.1679359,0.2337432,16.3909636),(5530,'radius-cleaned.tif',183,3,916,9.1749354,4.824151,6.0361867,1.8,4.8163417,6.0636491,-0.1607816,1.6233948,2.5715856,6.6262847,18.9519953,0.0391903,7.3697704,4.0817456,9.8669846,3.1613841,5.1679359,0.2337432,16.8190077),(5531,'radius-cleaned.tif',183,3,917,9.1761683,4.8250803,6.0365881,1.8,4.8186674,6.0633728,-0.1587893,1.6465739,2.5720804,6.6094749,18.949644,0.0382384,7.3674384,4.0140772,9.8566889,3.1626947,5.1679359,0.2337432,16.7528992),(5532,'radius-cleaned.tif',183,3,918,9.1878474,4.8257588,6.0371313,1.8,4.8178487,6.063031,-0.1578401,1.6475969,2.5724908,6.6145863,18.9480102,0.0378344,7.3656281,4.0146872,9.8561983,3.1722383,5.1754777,0.1626138,16.7101636),(5533,'radius-cleaned.tif',183,3,919,9.1753871,4.8282822,6.0377073,1.8,4.8217857,6.0635845,-0.157343,1.626854,2.5748008,6.6037785,18.9064366,0.0375475,7.3428735,4.0592324,9.8275494,3.1536094,5.1679359,0.2337432,16.3151737),(5534,'radius-cleaned.tif',183,3,920,9.1762196,4.8298213,6.0376831,1.8,4.8240388,6.0602953,-0.1563185,1.6283095,2.5761345,6.6062418,18.8913528,0.0370675,7.3332167,4.0571169,9.8171116,3.0757605,5.1679359,0.2337432,15.2503907),(5535,'radius-cleaned.tif',183,3,921,9.1867213,4.8306145,6.0395234,1.8,4.8246556,6.0635887,-0.1564977,1.6260755,2.5683463,6.6200261,18.9007507,0.0371943,7.3591131,4.0711677,9.8252788,3.0762088,5.1679359,0.2337432,15.0036584),(5536,'radius-cleaned.tif',183,3,922,9.1805634,4.8330848,6.0388332,1.8,4.8301405,6.0607038,-0.1541448,1.6012219,2.5787704,6.6121351,18.8714377,0.036069,7.3179984,4.1294308,9.8012824,3.1431785,5.1679359,0.2337432,15.8831195),(5537,'radius-cleaned.tif',183,3,923,9.174155,4.8338641,6.0381477,1.8,4.8293247,6.0580981,-0.1544737,1.6216984,2.5797085,6.6205071,18.8454342,0.0361965,7.3052572,4.0824528,9.8447987,3.1257408,5.1645461,0.1943653,15.1826211),(5538,'radius-cleaned.tif',183,3,924,9.1599306,4.8352678,6.0387765,1.8,4.8306955,6.0593781,-0.1563618,1.6016781,2.5730064,6.6250752,18.8360092,0.037022,7.3206228,4.1363337,9.7847359,3.1081085,5.1870001,0.24871,14.9762754),(5539,'radius-cleaned.tif',183,3,925,9.1465442,4.8344775,6.0409966,1.8,4.8269586,6.0619997,-0.1579885,1.6227038,2.5725047,6.646001,18.8284277,0.0377346,7.3191033,4.095634,9.7952163,3.1255268,5.1889947,0.2170009,15.178611),(5540,'radius-cleaned.tif',183,3,926,9.1208642,4.8354815,6.0437395,1.8,4.8284407,6.065444,-0.1577831,1.612992,2.5729867,6.6358041,18.789049,0.0375317,7.3024275,4.1139722,9.7756486,3.1499035,5.1724007,0.2019341,16.4433806),(5541,'radius-cleaned.tif',183,3,927,9.1103102,4.8362706,6.0456071,1.8,4.8287586,6.0676619,-0.1579105,1.6212495,2.5815519,6.6341992,18.7864119,0.0375484,7.2771778,4.0920286,9.8247368,3.1477346,5.1754777,0.1626138,15.7879669),(5542,'radius-cleaned.tif',183,3,928,9.104563,4.8373271,6.0458318,1.8,4.8289421,6.0668293,-0.1581776,1.6091089,2.5826062,6.6220028,18.7643831,0.0376507,7.2656772,4.115323,9.7565991,3.1540833,5.1754777,0.1626138,16.1709263),(5543,'radius-cleaned.tif',183,3,929,9.1000602,4.8386834,6.0476665,1.8,4.8316693,6.0671422,-0.1587742,1.6174886,2.5759025,6.6356462,18.7297018,0.037914,7.2711223,4.1024377,9.7457144,3.1426236,5.1724007,0.2019341,15.6243568),(5544,'radius-cleaned.tif',183,3,930,9.0776431,4.8420552,6.0496315,1.8,4.8383104,6.0702628,-0.1584263,1.6056995,2.5787922,6.6160404,18.6970316,0.0376565,7.2503057,4.1203478,9.715793,3.129962,5.1889947,0.1777902,16.2740992),(5545,'radius-cleaned.tif',183,3,931,9.0629346,4.8453237,6.0471908,1.8,4.8448699,6.0627682,-0.1560473,1.6115284,2.5691081,6.5968742,18.6450902,0.036484,7.2574174,4.0935514,9.7587534,3.1031341,5.1754777,0.1626138,14.9569126),(5546,'radius-cleaned.tif',183,3,932,9.0535619,4.8466313,6.0477649,1.8,4.8460999,6.0625406,-0.1562666,1.6082641,2.5703763,6.5907626,18.6089192,0.0365479,7.2397646,4.0980599,9.738246,3.1064901,5.1631588,0.1473615,15.260072),(5547,'radius-cleaned.tif',183,3,933,9.0526434,4.8497038,6.0495621,1.8,4.8526486,6.0624055,-0.1570039,1.6083994,2.5858271,6.5923649,18.587781,0.036887,7.1883308,4.0987114,9.6376743,3.1018391,5.1679359,0.2337432,14.9004855),(5548,'radius-cleaned.tif',183,3,934,9.0570845,4.8509118,6.0503703,1.8,4.8535933,6.0630482,-0.1553859,1.6054958,2.5739377,6.5964799,18.6040403,0.0361545,7.2278518,4.108687,9.7256953,3.1109844,5.1631588,0.1473615,15.0423839),(5549,'radius-cleaned.tif',183,3,935,9.0554885,4.8514454,6.0528214,1.8,4.852092,6.0654732,-0.155065,1.6179505,2.5739906,6.6059914,18.5990515,0.0360002,7.2257651,4.082938,9.727966,3.1284027,5.1631588,0.1473615,14.9238584),(5550,'radius-cleaned.tif',183,3,936,9.0382566,4.8516012,6.0541004,1.8,4.8509887,6.0663617,-0.1567183,1.6069363,2.5744312,6.6012469,18.5326711,0.0366956,7.198744,4.1079705,9.7012276,3.1211315,5.1631588,0.1473615,15.4897907),(5551,'radius-cleaned.tif',183,3,937,9.0390467,4.852697,6.0567175,1.8,4.8518414,6.0697938,-0.1561841,1.6158915,2.5873637,6.6081477,18.5468813,0.0364511,7.1682544,4.0894748,9.6252885,3.1284027,5.1754777,0.1626138,15.1689296),(5552,'radius-cleaned.tif',183,3,938,9.0290004,4.8530339,6.057657,1.8,4.8534934,6.0702884,-0.1564159,1.6127883,2.5752043,6.6184888,18.539785,0.0365179,7.1993453,4.1037556,9.7089869,3.1167362,5.1520466,0.1320398,14.9529025),(5553,'radius-cleaned.tif',183,3,939,9.0192714,4.8537807,6.0594385,1.8,4.8549436,6.0724221,-0.1564877,1.6125459,2.5632481,6.6200577,18.5204298,0.0365117,7.2253753,4.1053452,9.6529272,3.1180697,5.1427681,0.1715261,14.7779499),(5554,'radius-cleaned.tif',183,3,940,9.0005419,4.8555394,6.0606248,1.8,4.8575316,6.0735759,-0.1563892,1.6139903,2.5772093,6.6059834,18.4963953,0.0363904,7.1769085,4.0929511,9.6813127,3.1155427,5.1500377,0.2186689,15.2777737),(5555,'radius-cleaned.tif',183,3,941,9.0026019,4.8550148,6.063109,1.8,4.8562396,6.077865,-0.1569657,1.6143848,2.588941,6.6272824,18.5245208,0.0366654,7.1552504,4.1051441,9.6227617,3.1263364,5.1754777,0.1626138,15.2350381),(5556,'radius-cleaned.tif',183,3,942,8.9957818,4.8537539,6.064598,1.8,4.8529189,6.0778814,-0.1570721,1.6238871,2.575018,6.6349157,18.5030007,0.0366869,7.1855811,4.0858232,9.6590907,3.1409673,5.1500377,0.2186689,15.4527263),(5557,'radius-cleaned.tif',183,3,943,8.9991963,4.8548754,6.0671288,1.8,4.8569677,6.0812299,-0.1581663,1.6140496,2.5634616,6.6387318,18.4870604,0.0372097,7.2117563,4.1130903,9.6540138,3.133354,5.1409104,0.2751014,14.8577499),(5558,'radius-cleaned.tif',183,3,944,9.0007021,4.8546359,6.0687676,1.8,4.8563091,6.0827548,-0.1585744,1.6345202,2.5756469,6.6409788,18.5021406,0.0374066,7.1834927,4.0629529,9.6637305,3.1561939,5.1569883,0.1867738,15.1415466),(5559,'radius-cleaned.tif',183,3,945,9.0071259,4.8564064,6.0706673,1.8,4.857847,6.084351,-0.1595738,1.6114052,2.5773626,6.648842,18.5087732,0.0379026,7.1812841,4.1261144,9.6657648,3.1289463,5.1631588,0.1473615,14.7352143),(5560,'radius-cleaned.tif',183,3,946,9.006807,4.856986,6.0717988,1.8,4.8584643,6.0849372,-0.1604762,1.6189276,2.5779932,6.6531666,18.4814667,0.0383274,7.1689353,4.1096133,9.6564673,3.1442999,5.1569883,0.1867738,15.3672551),(5561,'radius-cleaned.tif',183,3,947,9.0230701,4.856994,6.0757587,1.8,4.8585102,6.0913152,-0.1604671,1.6228381,2.5646156,6.6606309,18.5135816,0.0383923,7.2188524,4.1043101,9.6770126,3.1372243,5.1427681,0.1715261,14.7312042),(5562,'radius-cleaned.tif',183,3,948,9.0304184,4.8581525,6.0766786,1.8,4.860201,6.0906806,-0.1607525,1.6175362,2.5784362,6.6645423,18.5274344,0.0385592,7.1855315,4.1201811,9.6810697,3.1365494,5.1497285,0.1791605,14.8440584),(5563,'radius-cleaned.tif',183,3,949,9.0279249,4.859201,6.0801042,1.8,4.8614251,6.0947593,-0.1610955,1.6210616,2.5790095,6.6825861,18.4820819,0.0387118,7.1663488,4.1223517,9.7110268,3.1767885,5.1497285,0.1791605,14.8577499),(5564,'radius-cleaned.tif',183,3,950,9.0250227,4.8615517,6.0804916,1.8,4.8648823,6.0930039,-0.1618461,1.6281992,2.561366,6.6900614,18.488094,0.0390577,7.2180603,4.1088715,9.7265765,3.1681526,5.1500377,0.2186689,15.2447195),(5565,'radius-cleaned.tif',183,3,951,9.013503,4.8631957,6.0848272,1.8,4.8689824,6.1000331,-0.1614817,1.6327534,2.56946,6.6771343,18.4850118,0.0388339,7.1941231,4.0894934,9.7194119,3.1397764,5.1500377,0.2186689,14.6223601),(5566,'radius-cleaned.tif',183,3,952,9.0100866,4.8646337,6.0846591,1.8,4.8696381,6.0977719,-0.1615267,1.6264006,2.5709139,6.6826512,18.4986036,0.0388406,7.1953416,4.1088593,9.7214529,3.1451791,5.1500377,0.2186689,15.1552381),(5567,'radius-cleaned.tif',183,3,953,8.9968172,4.8637783,6.0878141,1.8,4.866919,6.1014944,-0.1621917,1.6293317,2.5825572,6.6810678,18.4755223,0.0391006,7.1539645,4.1004957,9.6986771,3.132798,5.1497285,0.1791605,14.5989872);
INSERT INTO `slices_w` VALUES (5568,'radius-cleaned.tif',183,3,954,8.9806502,4.8651716,6.08874,1.8,4.8685281,6.1006963,-0.1627598,1.6239665,2.5639425,6.6802216,18.4346963,0.0393018,7.1899805,4.1135219,9.6985005,3.1474801,5.1333177,0.203493,14.8537398),(5569,'radius-cleaned.tif',183,3,955,8.9802978,4.8642305,6.0911492,1.8,4.8649174,6.1038604,-0.162898,1.6202516,2.5696905,6.6828984,18.4240657,0.0393664,7.1697607,4.1246053,9.7014886,3.1289463,5.1376577,0.108942,14.9198482),(5570,'radius-cleaned.tif',183,3,956,8.9719657,4.8652771,6.091881,1.8,4.8668022,6.1046248,-0.1628258,1.6265122,2.5705932,6.6867077,18.4391925,0.0392954,7.1731273,4.1110714,9.7058765,3.1473404,5.1500377,0.2186689,15.0520652),(5571,'radius-cleaned.tif',183,3,957,8.9720283,4.865226,6.093588,1.8,4.8655106,6.1052459,-0.1636355,1.6282965,2.5833908,6.6992654,18.4299334,0.0396839,7.1340091,4.1142785,9.6883078,3.1270174,5.1497285,0.1791605,14.7215228),(5572,'radius-cleaned.tif',183,3,958,8.9658537,4.8682129,6.0955784,1.8,4.8722802,6.1075906,-0.1641215,1.6242935,2.5663182,6.691044,18.4122995,0.0398904,7.1745974,4.1193564,9.6892266,3.1530921,5.1361082,0.1638715,15.231028),(5573,'radius-cleaned.tif',183,3,959,8.9794315,4.8679078,6.0978279,1.8,4.870367,6.1113178,-0.1642327,1.6332193,2.5656885,6.7165295,18.3972311,0.0400045,7.1704851,4.1124482,9.6983833,3.1398668,5.1361082,0.1638715,14.754577),(5574,'radius-cleaned.tif',183,3,960,8.9748478,4.8676873,6.0987696,1.8,4.8682261,6.1105004,-0.1645646,1.6339341,2.5654328,6.7169256,18.3778914,0.0401444,7.1636611,4.1108914,9.6928968,3.1676345,5.1333177,0.203493,15.2544008),(5575,'radius-cleaned.tif',183,3,961,8.9624626,4.8688497,6.1013213,1.8,4.8709148,6.1139624,-0.1648381,1.6237345,2.5859732,6.7167254,18.368795,0.0402211,7.1032425,4.1365909,9.6655605,3.132798,5.1497285,0.1791605,14.9529025),(5576,'radius-cleaned.tif',183,3,962,8.957746,4.8703203,6.1041828,1.8,4.8728771,6.1186193,-0.165507,1.6332582,2.5674653,6.7160933,18.3685313,0.0405239,7.1543446,4.112083,9.6854992,3.1530921,5.1361082,0.1638715,15.0754381),(5577,'radius-cleaned.tif',183,3,963,8.9555203,4.8696012,6.1051271,1.8,4.8711853,6.1172549,-0.1658838,1.6341059,2.5667282,6.7303323,18.3740813,0.0406968,7.1585614,4.1186634,9.6967494,3.1539928,5.1361082,0.1638715,14.834377),(5578,'radius-cleaned.tif',183,3,964,8.9570799,4.8711336,6.1076909,1.8,4.8712991,6.1212483,-0.1663599,1.6303247,2.5547614,6.7197948,18.3593713,0.0409357,7.1863351,4.1217525,9.7190833,3.1502163,5.1236946,0.1485049,15.0327025),(5579,'radius-cleaned.tif',183,3,965,8.9617734,4.871407,6.1096138,1.8,4.8696974,6.1223897,-0.166835,1.6322914,2.5548329,6.7293094,18.3492023,0.0411893,7.1821536,4.1226151,9.7205501,3.1400692,5.1177876,0.1882215,14.9375499),(5580,'radius-cleaned.tif',183,3,966,8.9548848,4.8719533,6.1130546,1.8,4.8698437,6.1284145,-0.1670264,1.6291518,2.5681147,6.7350367,18.3439284,0.0412512,7.1429553,4.1340756,9.6871357,3.1502163,5.1333177,0.203493,15.1221839),(5581,'radius-cleaned.tif',183,3,967,8.9550739,4.8722509,6.1156,1.8,4.8705153,6.1304474,-0.1690149,1.6317332,2.5686257,6.758757,18.3349094,0.0422308,7.138023,4.1420723,9.6945035,3.152459,5.1361082,0.1638715,14.7779499),(5582,'radius-cleaned.tif',183,3,968,8.9562066,4.8742168,6.118131,1.8,4.8750268,6.1355622,-0.1695393,1.6345643,2.5703037,6.7665895,18.3270479,0.0424961,7.1303045,4.13969,9.6901746,3.1703199,5.1361082,0.1638715,15.2544008),(5583,'radius-cleaned.tif',183,3,969,8.9452961,4.8729812,6.1203919,1.8,4.8716933,6.1362478,-0.1692794,1.6433041,2.5551786,6.7715633,18.2890692,0.0423155,7.1576481,4.1207001,9.7230241,3.1827673,5.0903395,0.1574169,14.8440584),(5584,'radius-cleaned.tif',183,3,970,8.9492865,4.8741844,6.1220918,1.8,4.8722355,6.1382325,-0.1691761,1.6327189,2.5694901,6.7897969,18.302182,0.0422832,7.1228849,4.158583,9.6939037,3.1748845,5.1177876,0.1882215,14.8440584),(5585,'radius-cleaned.tif',183,3,971,8.938671,4.8749564,6.1249167,1.8,4.8747207,6.1413664,-0.1695113,1.6413773,2.5698791,6.7922769,18.2782106,0.042399,7.1124788,4.138157,9.6858515,3.1683685,5.1177876,0.1882215,14.9996483),(5586,'radius-cleaned.tif',183,3,972,8.9382019,4.8757399,6.1282026,1.8,4.8766996,6.14577,-0.1697602,1.6368905,2.5701729,6.8026473,18.2663643,0.0425202,7.1070567,4.1558354,9.6859685,3.1971197,5.1177876,0.1882215,14.806994),(5587,'radius-cleaned.tif',183,3,973,8.9424984,4.8760215,6.129675,1.8,4.8753756,6.1450524,-0.1698018,1.6529925,2.5567292,6.8082453,18.2608784,0.0425613,7.1422811,4.1187395,9.7283716,3.2113323,5.0903395,0.1574169,15.098811),(5588,'radius-cleaned.tif',183,3,974,8.964,4.8753648,6.1309622,1.8,4.8736551,6.1438956,-0.1710071,1.632415,2.5697117,6.8125545,18.2567901,0.0432654,7.1046063,4.1732983,9.6903713,3.1827673,5.1034581,0.1728606,15.0053195),(5589,'radius-cleaned.tif',183,3,975,8.9603294,4.8763649,6.1333647,1.8,4.8759485,6.1461276,-0.1708505,1.6499532,2.5702419,6.8177665,18.2362441,0.0431693,7.095147,4.1320968,9.6833928,3.1969083,5.1025222,0.2127318,15.1552381),(5590,'radius-cleaned.tif',183,3,976,8.9423692,4.8762573,6.1385816,1.8,4.876577,6.1556699,-0.1710891,1.6429328,2.5421456,6.8166143,18.2299776,0.0432021,7.1710988,4.1490524,9.7309184,3.1982859,5.0903395,0.1574169,15.2640822),(5591,'radius-cleaned.tif',183,3,977,8.9317397,4.877788,6.1398655,1.8,4.8785197,6.1554517,-0.171512,1.6497963,2.5571107,6.8208329,18.2231255,0.0433622,7.1264514,4.1343485,9.7262353,3.1969083,5.1034581,0.1728606,15.178611),(5592,'radius-cleaned.tif',183,3,978,8.9344586,4.8792015,6.1420423,1.8,4.8812484,6.156463,-0.1734894,1.6432047,2.5585371,6.8325766,18.2111755,0.0443712,7.1178079,4.1580799,9.7241117,3.1842781,5.0942474,0.2050759,15.5558992),(5593,'radius-cleaned.tif',183,3,979,8.9295281,4.8790244,6.1448828,1.8,4.8804117,6.1600806,-0.1743624,1.6479303,2.5718892,6.8182443,18.1932656,0.0447896,7.0738916,4.1374593,9.6694656,3.1842781,5.1110951,0.2203624,14.9238584),(5594,'radius-cleaned.tif',183,3,980,8.9353295,4.8795665,6.1477541,1.8,4.8804768,6.1633453,-0.1729599,1.6421949,2.5528352,6.8294598,18.2112411,0.0441078,7.1337317,4.1587389,9.6899269,3.1703199,5.0998695,0.2449787,15.1842822),(5595,'radius-cleaned.tif',183,3,981,8.9240269,4.8816807,6.1492069,1.8,4.8855034,6.1620013,-0.1735911,1.645815,2.545979,6.8444614,18.1842307,0.0443708,7.1423334,4.1587064,9.7191449,3.1827673,5.0812616,0.2621198,14.8440584),(5596,'radius-cleaned.tif',183,3,982,8.908078,4.880999,6.1534307,1.8,4.8832449,6.1685313,-0.174448,1.6544277,2.5585235,6.8355344,18.1600861,0.0447255,7.0978774,4.1316609,9.7143465,3.1801343,5.0942474,0.2050759,15.151228),(5597,'radius-cleaned.tif',183,3,983,8.911555,4.8800302,6.1551004,1.8,4.8801924,6.1685339,-0.1745385,1.653504,2.571154,6.8483933,18.1537434,0.0447889,7.0605431,4.1417459,9.6727595,3.1995128,5.1110951,0.2203624,14.9722652),(5598,'radius-cleaned.tif',183,3,984,8.9130473,4.8782776,6.1561129,1.8,4.8756353,6.1668018,-0.17519,1.6448858,2.5509979,6.848738,18.1526639,0.045128,7.115907,4.1636555,9.6893759,3.1764252,5.0998695,0.2449787,14.8964754),(5599,'radius-cleaned.tif',183,3,985,8.9200849,4.8808559,6.1582,1.8,4.8807736,6.1675141,-0.1745753,1.6544167,2.5437176,6.8651206,18.1423014,0.0448505,7.1321995,4.1495715,9.7257927,3.1842781,5.0641574,0.1742158,14.754577),(5600,'radius-cleaned.tif',183,3,986,8.904344,4.8798007,6.1621682,1.8,4.8800397,6.1755304,-0.1759836,1.6579733,2.5561001,6.8583272,18.129782,0.0454891,7.0927511,4.1365729,9.7272888,3.1894481,5.0842372,0.149666,14.6086685),(5601,'radius-cleaned.tif',183,3,987,8.9014922,4.879678,6.1629156,1.8,4.8801265,6.1738896,-0.1759135,1.647343,2.5558362,6.8686842,18.1155718,0.0454387,7.0879236,4.1695531,9.7272153,3.1836032,5.0903395,0.1574169,14.6183499),(5602,'radius-cleaned.tif',183,3,988,8.9137819,4.8782415,6.1661964,1.8,4.875559,6.1787768,-0.1761147,1.6546594,2.549553,6.8902753,18.1356901,0.0456045,7.1132821,4.1641653,9.7111123,3.186647,5.0811049,0.2297417,14.7739398),(5603,'radius-cleaned.tif',183,3,989,8.8837274,4.880319,6.1686586,1.8,4.8816888,6.1801576,-0.1777018,1.6571904,2.5376492,6.8765758,18.0931615,0.0462649,7.1298908,4.1495388,9.7268811,3.1801343,5.0812616,0.2621198,14.966594),(5604,'radius-cleaned.tif',183,3,990,8.8953331,4.8789558,6.1719863,1.8,4.8792344,6.1849424,-0.1774335,1.6673115,2.5537881,6.9007958,18.1084847,0.046187,7.0908328,4.1388762,9.7515349,3.1953608,5.0842372,0.149666,15.3438822),(5605,'radius-cleaned.tif',183,3,991,8.8895279,4.8795999,6.173807,1.8,4.8804214,6.1860683,-0.1774475,1.6581143,2.5359587,6.9034344,18.0950081,0.0461641,7.1353717,4.1634249,9.7474127,3.186647,5.0712258,0.1819647,14.9706042),(5606,'radius-cleaned.tif',183,3,992,8.892633,4.8793775,6.1782866,1.8,4.8789628,6.1923399,-0.1804591,1.6660365,2.5501075,6.9219177,18.087148,0.0477438,7.0927002,4.1547215,9.7148271,3.1894481,5.0811049,0.2297417,15.6944754),(5607,'radius-cleaned.tif',183,3,993,8.8934721,4.8788078,6.1814661,1.8,4.8793852,6.1970965,-0.180056,1.6584582,2.5345445,6.9175791,18.0882361,0.0475376,7.1366811,4.1710905,9.7631819,3.1969083,5.0641574,0.1742158,15.3696042),(5608,'radius-cleaned.tif',183,3,994,8.8937769,4.8804431,6.1837402,1.8,4.8829788,6.1996473,-0.1805965,1.6787361,2.5358912,6.942309,18.1004763,0.0478219,7.137718,4.1354378,9.7747357,3.2067926,5.0641574,0.1742158,15.7235195),(5609,'radius-cleaned.tif',183,3,995,8.8983967,4.8802908,6.185717,1.8,4.8811359,6.2010579,-0.1807102,1.6700728,2.5354166,6.9441029,18.1082062,0.0479064,7.1421029,4.1579643,9.7815847,3.2134997,5.0641574,0.1742158,15.5679296),(5610,'radius-cleaned.tif',183,3,996,8.8968283,4.8802452,6.1881889,1.8,4.880972,6.2031172,-0.1811572,1.6901911,2.5494222,6.939447,18.0850711,0.0481326,7.093792,4.1057174,9.7293368,3.2227022,5.0811049,0.2297417,15.6437195),(5611,'radius-cleaned.tif',183,3,997,8.9027264,4.8819783,6.1897654,1.8,4.8853131,6.2041479,-0.1807051,1.6600165,2.5363477,6.9470836,18.106567,0.047927,7.1388348,4.1849487,9.7813305,3.1942603,5.0641574,0.1742158,15.4881296),(5612,'radius-cleaned.tif',183,3,998,8.8976129,4.8816968,6.1919023,1.8,4.8831138,6.2051053,-0.1810078,1.6692367,2.5357651,6.9603762,18.0958145,0.0480583,7.1362346,4.1697957,9.7861117,3.2018736,5.0641574,0.1742158,15.4510652),(5613,'radius-cleaned.tif',183,3,999,8.8836555,4.8814045,6.1935626,1.8,4.8804743,6.2059862,-0.1827941,1.6708003,2.5356336,6.9609898,18.083051,0.048924,7.1315711,4.1662609,9.7845724,3.2157427,5.0641574,0.1742158,14.9996483),(5614,'radius-cleaned.tif',183,3,1000,8.8722253,4.8819754,6.198001,1.8,4.8830883,6.213758,-0.1833357,1.6825364,2.5355221,6.9588714,18.0631901,0.0491478,7.1240515,4.1359411,9.7796749,3.2329718,5.0712258,0.1819647,15.4550754),(5615,'radius-cleaned.tif',183,3,1001,8.8816038,4.8815894,6.1986274,1.8,4.8803167,6.2123449,-0.1833553,1.6685326,2.5350332,6.9743832,18.0794606,0.0492102,7.1318438,4.1799503,9.7942975,3.2157427,5.0641574,0.1742158,15.0053195),(5616,'radius-cleaned.tif',183,3,1002,8.8680891,4.8817726,6.2013517,1.8,4.8802487,6.2146391,-0.1833338,1.6785198,2.5245764,6.9772424,18.0572122,0.0491239,7.152571,4.1567829,9.7895728,3.2329718,5.0721675,0.2220819,15.1746008),(5617,'radius-cleaned.tif',183,3,1003,8.8612459,4.8822312,6.2032405,1.8,4.8808231,6.2163948,-0.1840962,1.6658422,2.5350012,6.9747513,18.0418778,0.0494905,7.1171081,4.186922,9.7833801,3.219345,5.0785978,0.1896916,15.0851195),(5618,'radius-cleaned.tif',183,3,1004,8.8639496,4.8829474,6.2053001,1.8,4.8837386,6.2177639,-0.1855344,1.689945,2.535667,6.9893812,18.0360001,0.0502731,7.1129214,4.1358631,9.7868656,3.2359364,5.0641574,0.1742158,15.0891296),(5619,'radius-cleaned.tif',183,3,1005,8.8576659,4.8827046,6.2068425,1.8,4.882212,6.2184696,-0.185068,1.6668711,2.5350353,6.995148,18.0237658,0.0499881,7.1098679,4.196574,9.8277041,3.2154223,5.0641574,0.1742158,15.0617466),(5620,'radius-cleaned.tif',183,3,1006,8.8455368,4.8838288,6.2089769,1.8,4.8850007,6.2204552,-0.185104,1.6863676,2.5357558,7.0014042,17.9942336,0.0499389,7.0962012,4.1517663,9.8166366,3.2386118,5.0785978,0.1896916,15.1746008),(5621,'radius-cleaned.tif',183,3,1007,8.8359164,4.8855014,6.2128889,1.8,4.8878615,6.2270423,-0.1852682,1.680701,2.5220171,6.9799373,17.9898633,0.0499721,7.133125,4.1529917,9.8154188,3.230091,5.0641574,0.1742158,15.0714279),(5622,'radius-cleaned.tif',183,3,1008,8.8360012,4.8880253,6.2146513,1.8,4.8904246,6.2292778,-0.1863805,1.6853069,2.5391209,7.0053074,18.0081162,0.0505674,7.0922641,4.1566954,9.8139848,3.2227022,5.0785978,0.1896916,15.2640822),(5623,'radius-cleaned.tif',183,3,1009,8.8268233,4.8871992,6.217502,1.8,4.8895446,6.2318396,-0.1867608,1.6752807,2.5378638,7.0122801,17.9941611,0.0507188,7.0902785,4.1857343,9.7605822,3.2033144,5.0641574,0.1742158,15.2544008),(5624,'radius-cleaned.tif',183,3,1010,8.8193004,4.8880994,6.2196332,1.8,4.8900065,6.2340448,-0.1876013,1.682707,2.52365,7.0111621,17.9902385,0.0511274,7.1286584,4.166597,9.7584901,3.2233771,5.0641574,0.1742158,14.9295296),(5625,'radius-cleaned.tif',183,3,1011,8.8171884,4.8892439,6.2222158,1.8,4.8930344,6.2368386,-0.1877604,1.6725074,2.5243137,7.0088952,17.9735545,0.0512009,7.1201746,4.1906511,9.7507425,3.2057647,5.0641574,0.1742158,15.0617466),(5626,'radius-cleaned.tif',183,3,1012,8.8264494,4.8886445,6.2235897,1.8,4.8904383,6.2365782,-0.1880709,1.6791907,2.5384286,7.0395418,17.9880534,0.0514223,7.0862947,4.1922229,9.7724448,3.2227022,5.0785978,0.1896916,15.0053195),(5627,'radius-cleaned.tif',183,3,1013,8.8106713,4.8853986,6.2261351,1.8,4.882757,6.2386871,-0.1891541,1.6700764,2.534986,7.0295815,17.9594585,0.0519163,7.084638,4.2091377,9.7725098,3.2160972,5.0641574,0.1742158,15.2544008),(5628,'radius-cleaned.tif',183,3,1014,8.8008632,4.88851,6.228191,1.8,4.8911375,6.2411611,-0.1887159,1.6761119,2.537567,7.0350648,17.9448893,0.0516213,7.0716908,4.1972524,9.7608677,3.2193012,5.0641574,0.1742158,14.9529025),(5629,'radius-cleaned.tif',183,3,1015,8.809674,4.8863867,6.2292824,1.8,4.8847461,6.2406829,-0.1885471,1.6768159,2.5202856,7.0530801,17.9255421,0.0515817,7.1125044,4.206234,9.7694215,3.2168948,5.0509367,0.1586553,15.1084923),(5630,'radius-cleaned.tif',183,3,1016,8.8219453,4.8867357,6.2314815,1.8,4.886571,6.2410162,-0.1882419,1.6847003,2.5351123,7.0783031,17.94377,0.0514885,7.0780967,4.2015206,9.788309,3.2386118,5.0785978,0.1896916,15.019011),(5631,'radius-cleaned.tif',183,3,1017,8.7955731,4.8863629,6.2356668,1.8,4.8848992,6.2483914,-0.1887931,1.67555,2.5340707,7.062843,17.8874576,0.051632,7.0587841,4.2152385,9.7674906,3.2276407,5.0641574,0.1742158,15.1649195),(5632,'radius-cleaned.tif',183,3,1018,8.7950507,4.8875272,6.2383223,1.8,4.8883135,6.2504389,-0.1886135,1.6841107,2.5179324,7.0710905,17.8866399,0.0515319,7.1037014,4.1987088,9.7700194,3.2597484,5.047153,0.1989459,14.806994),(5633,'radius-cleaned.tif',183,3,1019,8.802198,4.8874992,6.2401101,1.8,4.8880343,6.2514088,-0.189651,1.6874604,2.5194717,7.094193,17.8906554,0.0521359,7.1009552,4.2040649,9.783262,3.2636905,5.0509367,0.1586553,15.2640822),(5634,'radius-cleaned.tif',183,3,1020,8.7900749,4.8868966,6.2428817,1.8,4.886154,6.253783,-0.1892345,1.6901448,2.5183125,7.0944986,17.8715925,0.0518384,7.0966541,4.1975685,9.781974,3.2574554,5.0509367,0.1586553,14.7312042),(5635,'radius-cleaned.tif',183,3,1021,8.7827691,4.888741,6.2455077,1.8,4.8899035,6.2579776,-0.1899561,1.685406,2.5347728,7.1084456,17.8477531,0.0521863,7.0411648,4.217646,9.775223,3.2479478,5.0641574,0.1742158,14.9295296),(5636,'radius-cleaned.tif',183,3,1022,8.7781289,4.887821,6.2481571,1.8,4.8875037,6.2618996,-0.1902829,1.6877611,2.5168875,7.1115041,17.8525182,0.0523362,7.0930936,4.2135728,9.7852895,3.2574554,5.047153,0.1989459,14.8400482),(5637,'radius-cleaned.tif',183,3,1023,8.7823574,4.8862705,6.250603,1.8,4.8821168,6.2626121,-0.1908157,1.6973167,2.5164014,7.1278042,17.8742713,0.0526515,7.1031083,4.1994546,9.8091933,3.2628737,5.0389452,0.1430169,14.9762754),(5638,'radius-cleaned.tif',183,3,1024,8.7691624,4.887025,6.2540358,1.8,4.8860315,6.2665126,-0.1912586,1.6843291,2.5165321,7.1288194,17.8469742,0.0528137,7.091892,4.2324386,9.8009959,3.2538981,5.0509367,0.1586553,14.9529025),(5639,'radius-cleaned.tif',183,3,1025,8.7576039,4.8876439,6.2576196,1.8,4.8889558,6.2686342,-0.1930702,1.6963844,2.5319262,7.1285525,17.8229692,0.0537355,7.0392925,4.2022035,9.794262,3.2628737,5.0641574,0.1742158,15.0851195),(5640,'radius-cleaned.tif',183,3,1026,8.7440614,4.887884,6.260616,1.8,4.8880116,6.2736117,-0.1929086,1.6908462,2.5153495,7.1361058,17.8113986,0.0535638,7.0810831,4.2204347,9.7959992,3.2597484,5.047153,0.1989459,14.7602482),(5641,'radius-cleaned.tif',183,3,1027,8.7449789,4.8862275,6.2641951,1.8,4.8831473,6.2784861,-0.1935814,1.7101225,2.5132264,7.1484304,17.8240164,0.053939,7.0920854,4.1800691,9.8167318,3.2810013,5.047153,0.1989459,15.1609093),(5642,'radius-cleaned.tif',183,3,1028,8.7395834,4.8850945,6.2669873,1.8,4.8803287,6.2811665,-0.1950703,1.6964096,2.5124608,7.1505605,17.8165433,0.0547276,7.0912721,4.2151145,9.8225978,3.2625931,5.0389452,0.1430169,14.8303669),(5643,'radius-cleaned.tif',183,3,1029,8.731219,4.8870958,6.2695857,1.8,4.8858341,6.2832663,-0.1945238,1.6916731,2.5293086,7.1460831,17.8101655,0.0543731,7.0415153,4.2242695,9.8147218,3.2606876,5.0641574,0.1742158,14.8964754),(5644,'radius-cleaned.tif',183,3,1030,8.7257646,4.8877457,6.2711787,1.8,4.8869382,6.2825583,-0.1944324,1.6933717,2.5296251,7.1421257,17.7885464,0.0542888,7.0320881,4.2176953,9.8045259,3.2583731,5.0641574,0.1742158,14.9488923),(5645,'radius-cleaned.tif',183,3,1031,8.7280332,4.8890526,6.2739895,1.8,4.8890103,6.2855427,-0.1952496,1.7040334,2.5145612,7.1439842,17.7861667,0.0547545,7.0732685,4.1923968,9.803491,3.2583731,5.047153,0.1989459,14.8634211),(5646,'radius-cleaned.tif',183,3,1032,8.717809,4.8883805,6.2770896,1.8,4.8884401,6.2886587,-0.1962463,1.6988572,2.5137948,7.1437453,17.7514778,0.0552429,7.0616256,4.2050299,9.7964336,3.2675584,5.0389452,0.1430169,14.9295296),(5647,'radius-cleaned.tif',183,3,1033,8.7210646,4.8879297,6.27882,1.8,4.8857913,6.2891762,-0.1960052,1.7007277,2.5046656,7.1537419,17.7493778,0.0551296,7.086526,4.2062829,9.8035414,3.2718492,5.0245493,0.216085,14.9198482),(5648,'radius-cleaned.tif',183,3,1034,8.7089381,4.8869355,6.2805908,1.8,4.8844872,6.2891785,-0.1953633,1.6941856,2.5271375,7.1455728,17.7491359,0.0546975,7.0234152,4.2177037,9.806247,3.2666688,5.0641574,0.1742158,14.8303669),(5649,'radius-cleaned.tif',183,3,1035,8.7247528,4.8888279,6.2840603,1.8,4.8888307,6.2949106,-0.1950057,1.7138871,2.5123244,7.1647601,17.7663494,0.054599,7.071678,4.1804154,9.8184964,3.2725142,5.047153,0.1989459,14.886794),(5650,'radius-cleaned.tif',183,3,1036,8.7222864,4.8892317,6.2863162,1.8,4.8893215,6.296579,-0.1957985,1.7080326,2.5124841,7.175955,17.7397083,0.0550226,7.060625,4.2012987,9.8140328,3.2806048,5.0319897,0.1833996,14.8964754),(5651,'radius-cleaned.tif',183,3,1037,8.709082,4.8896726,6.28744,1.8,4.8899035,6.2951529,-0.1946812,1.7096712,2.5124161,7.1808342,17.7243015,0.054322,7.0546839,4.2001258,9.8098227,3.2672295,5.0319897,0.1833996,14.727194),(5652,'radius-cleaned.tif',183,3,1038,8.7009318,4.8891104,6.2921024,1.8,4.8880713,6.3039406,-0.1955404,1.7059093,2.527058,7.1754638,17.7249031,0.0547451,7.0140467,4.20624,9.8163177,3.2806048,5.0509367,0.1586553,14.7836211),(5653,'radius-cleaned.tif',183,3,1039,8.7097384,4.8898647,6.2956986,1.8,4.8914359,6.3074038,-0.1948285,1.7100698,2.511043,7.1889841,17.7305945,0.0544073,7.0610477,4.2039127,9.8260322,3.271414,5.0319897,0.1833996,14.7078313),(5654,'radius-cleaned.tif',183,3,1040,8.7133727,4.888731,6.2977069,1.8,4.8883511,6.3090019,-0.1954782,1.7035802,2.5096996,7.1881128,17.7288954,0.0547889,7.0641503,4.2194155,9.8318557,3.2776995,5.047153,0.1989459,14.9859567),(5655,'radius-cleaned.tif',183,3,1041,8.7147896,4.8872563,6.3001998,1.8,4.8862314,6.3116552,-0.1959777,1.7057427,2.5078882,7.1994685,17.7227455,0.0550747,7.0668005,4.2207236,9.842653,3.2749645,5.0319897,0.1833996,14.8964754),(5656,'radius-cleaned.tif',183,3,1042,8.7000872,4.8867885,6.3033098,1.8,4.8845702,6.317677,-0.1973294,1.7008722,2.5071397,7.2132998,17.7181814,0.0557329,7.0670898,4.2409417,9.8522278,3.2823195,5.0245493,0.216085,15.0560754),(5657,'radius-cleaned.tif',183,3,1043,8.6853264,4.8856627,6.3060427,1.8,4.8833045,6.3190815,-0.196601,1.7035333,2.5053321,7.2149879,17.7072763,0.0552336,7.067836,4.2353078,9.8563899,3.268874,5.0319897,0.1833996,14.9158381),(5658,'radius-cleaned.tif',183,3,1044,8.684086,4.8833628,6.3082174,1.8,4.8800352,6.3200254,-0.1968093,1.6971257,2.5026995,7.2171977,17.6891461,0.0553413,7.0680264,4.2526006,9.861445,3.2675584,5.047153,0.1989459,14.966594),(5659,'radius-cleaned.tif',183,3,1045,8.6729341,4.8831643,6.3118183,1.8,4.8806168,6.3239819,-0.1966708,1.7008959,2.5017694,7.2208177,17.6608124,0.0551935,7.0593287,4.2453025,9.9052499,3.2718992,5.0319897,0.1833996,14.9295296),(5660,'radius-cleaned.tif',183,3,1046,8.6607798,4.8839927,6.3146027,1.8,4.8821517,6.3261786,-0.196267,1.7039023,2.5019474,7.2258759,17.658628,0.054893,7.0579534,4.2407805,9.9063601,3.268874,5.0319897,0.1833996,15.0423839),(5661,'radius-cleaned.tif',183,3,1047,8.6452029,4.8838534,6.3176356,1.8,4.882484,6.3299377,-0.1966021,1.6989612,2.5012933,7.229643,17.6254784,0.0549791,7.0465461,4.2553313,9.8985509,3.2719688,5.0319897,0.1833996,14.8634211),(5662,'radius-cleaned.tif',183,3,1048,8.6483533,4.8844347,6.3194322,1.8,4.8848285,6.3295508,-0.1966113,1.708309,2.5015145,7.242866,17.6468949,0.0550042,7.0544844,4.2397869,9.840356,3.2749645,5.0422615,0.2315438,14.9101669),(5663,'radius-cleaned.tif',183,3,1049,8.6558412,4.8825838,6.3227403,1.8,4.882045,6.3341106,-0.1972033,1.6957068,2.4991803,7.2561544,17.6568694,0.0553795,7.0650642,4.2791328,9.8612071,3.2718492,5.0319897,0.1833996,14.5522414),(5664,'radius-cleaned.tif',183,3,1050,8.6424926,4.8824534,6.3258708,1.8,4.8830231,6.3376477,-0.198163,1.7065671,2.4986405,7.2542417,17.6388943,0.0558265,7.0593966,4.2507801,9.8585317,3.2868251,5.0319897,0.1833996,15.0423839),(5665,'radius-cleaned.tif',183,3,1051,8.6451944,4.8814468,6.3275649,1.8,4.8802884,6.3387546,-0.1989246,1.7077777,2.4974772,7.2715017,17.6443269,0.0562684,7.0648601,4.2578736,9.8737082,3.2850152,5.0245493,0.216085,14.9295296),(5666,'radius-cleaned.tif',183,3,1052,8.6435516,4.8806885,6.3312651,1.8,4.8783371,6.3427879,-0.198875,1.7036795,2.4959926,7.2725412,17.6466037,0.05623,7.0699744,4.2687262,9.883349,3.2806048,5.0245493,0.216085,14.5852957),(5667,'radius-cleaned.tif',183,3,1053,8.6455353,4.8808042,6.333777,1.8,4.8796961,6.3449893,-0.1983468,1.7216767,2.5112285,7.2922387,17.6544997,0.0559485,7.0302242,4.2355449,9.8733029,3.3153335,5.047153,0.1989459,14.8827839),(5668,'radius-cleaned.tif',183,3,1054,8.624715,4.8809113,6.3391895,1.8,4.8818871,6.3535762,-0.1994965,1.7110856,2.4947657,7.2834003,17.6207642,0.056454,7.0630939,4.2565962,9.8885203,3.2894257,5.0319897,0.1833996,15.0657567),(5669,'radius-cleaned.tif',183,3,1055,8.6141918,4.8829978,6.3406734,1.8,4.8846693,6.35261,-0.1998263,1.7208182,2.4965794,7.3041187,17.5985954,0.0565692,7.049083,4.2445615,9.8826004,3.3137018,5.0245493,0.216085,14.8537398),(5670,'radius-cleaned.tif',183,3,1056,8.6156372,4.8847104,6.3428172,1.8,4.8864875,6.3538093,-0.1989925,1.7079154,2.4976752,7.3106115,17.5949345,0.0561138,7.0445246,4.2804294,9.8807169,3.3076014,5.0248662,0.1755922,14.9859567),(5671,'radius-cleaned.tif',183,3,1057,8.6102496,4.8851005,6.3455141,1.8,4.8855154,6.3578019,-0.1999757,1.7185597,2.5135589,7.3107435,17.5901771,0.0566268,6.9981161,4.2539945,9.8530087,3.3165769,5.047153,0.1989459,14.8537398),(5672,'radius-cleaned.tif',183,3,1058,8.5963539,4.8841756,6.3472442,1.8,4.8832461,6.3593179,-0.2002726,1.7194965,2.4965111,7.3024262,17.5445016,0.0567011,7.0276082,4.2468399,9.8659772,3.311879,5.0319897,0.1833996,15.1084923),(5673,'radius-cleaned.tif',183,3,1059,8.5737731,4.8855888,6.3480008,1.8,4.8879169,6.3583618,-0.1996589,1.7131689,2.4976338,7.3089412,17.5228076,0.0562108,7.0157633,4.2663284,9.8559534,3.3133423,5.0319897,0.1833996,14.8634211),(5674,'radius-cleaned.tif',183,3,1060,8.5418369,4.8865068,6.3514311,1.8,4.890431,6.3634614,-0.2002819,1.7167111,2.4979644,7.2957615,17.4798081,0.0563467,6.997621,4.2498481,9.8353974,3.3076014,5.0248662,0.1755922,14.8964754),(5675,'radius-cleaned.tif',183,3,1061,8.5215853,4.8855628,6.3540759,1.8,4.8869629,6.3664381,-0.1997095,1.7112024,2.5122434,7.2873477,17.4399415,0.0558965,6.9419791,4.2586124,9.7924758,3.301751,5.0422615,0.2315438,15.0480551),(5676,'radius-cleaned.tif',183,3,1062,8.5043781,4.8860382,6.3570633,1.8,4.8897626,6.3689311,-0.199622,1.7142286,2.5120947,7.2924186,17.4143961,0.0557355,6.9322211,4.2540527,9.7846423,3.3076014,5.047153,0.1989459,14.8166754),(5677,'radius-cleaned.tif',183,3,1063,8.512702,4.8859153,6.361633,1.8,4.8912143,6.3733251,-0.1995989,1.7265953,2.5110625,7.3108529,17.4308857,0.0557773,6.9416376,4.2342597,9.8049849,3.3148819,5.047153,0.1989459,15.4664178),(5678,'radius-cleaned.tif',183,3,1064,8.5038481,4.8852856,6.3662133,1.8,4.8925114,6.3780379,-0.1994496,1.7234734,2.5095007,7.2982144,17.4020228,0.0556371,6.9344563,4.2345966,9.7966389,3.3280904,5.0422615,0.2315438,15.4099907),(5679,'radius-cleaned.tif',183,3,1065,8.4891915,4.8831933,6.3699121,1.8,4.886819,6.382369,-0.1982077,1.726325,2.490703,7.3125113,17.3497237,0.0548607,6.9657939,4.2358833,9.793557,3.3133423,5.0248662,0.1755922,15.0093296),(5680,'radius-cleaned.tif',183,3,1066,8.4805759,4.8809975,6.3732095,1.8,4.8823206,6.3846479,-0.1996205,1.7215952,2.5039521,7.3204141,17.3234137,0.0555786,6.9184287,4.2521112,9.7981174,3.3280904,5.0394191,0.1911845,15.3245195),(5681,'radius-cleaned.tif',183,3,1067,8.4682173,4.8809812,6.3764474,1.8,4.8837787,6.3883694,-0.1983961,1.7246268,2.5030056,7.309762,17.3080382,0.0548279,6.914902,4.2384602,9.7889538,3.319508,5.0394191,0.1911845,15.1649195),(5682,'radius-cleaned.tif',183,3,1068,8.4626749,4.881035,6.3788238,1.8,4.8835042,6.3912125,-0.198622,1.7191199,2.5026429,7.3151614,17.3226249,0.0549152,6.9217325,4.2551782,9.8005545,3.3280904,5.0394191,0.1911845,15.2737636),(5683,'radius-cleaned.tif',183,3,1069,8.4641879,4.8806495,6.3807535,1.8,4.8840633,6.3924594,-0.1985928,1.7209334,2.4904157,7.3336527,17.3116636,0.0549091,6.9513147,4.2614391,9.8080389,3.319508,5.0248662,0.1755922,15.1552381),(5684,'radius-cleaned.tif',183,3,1070,8.4417528,4.8793491,6.3851197,1.8,4.8822856,6.3981001,-0.1989499,1.7174131,2.4998225,7.3262324,17.2812824,0.054958,6.9130037,4.2658533,9.803084,3.321117,5.0394191,0.1911845,15.2076551),(5685,'radius-cleaned.tif',183,3,1071,8.4277118,4.879514,6.3887571,1.8,4.8859389,6.4021056,-0.1998122,1.7207215,2.4994575,7.3287645,17.2585983,0.0553369,6.9049377,4.259123,9.7842049,3.3467392,5.0394191,0.1911845,15.0520652),(5686,'radius-cleaned.tif',183,3,1072,8.4215875,4.8803209,6.3922431,1.8,4.8870555,6.405867,-0.199454,1.7238687,2.4994781,7.3325605,17.2441394,0.0551013,6.899096,4.2535494,9.7843481,3.3291606,5.0394191,0.1911845,14.9762754),(5687,'radius-cleaned.tif',183,3,1073,8.4208763,4.8809629,6.3957595,1.8,4.8886213,6.4094141,-0.19998,1.719951,2.4841972,7.3500731,17.2384656,0.0553837,6.9392501,4.27342,9.7928059,3.3335109,5.0128123,0.2411177,15.1084923),(5688,'radius-cleaned.tif',183,3,1074,8.4174124,4.882022,6.399077,1.8,4.8914372,6.4136766,-0.2022262,1.7163569,2.4853245,7.3427562,17.237226,0.0565945,6.9356038,4.2781058,9.803809,3.3291606,5.0128123,0.2411177,15.0383737),(5689,'radius-cleaned.tif',183,3,1075,8.41044,4.8794121,6.4014504,1.8,4.8848362,6.4145477,-0.2033258,1.7171133,2.4975583,7.3439395,17.2217378,0.0571557,6.8954298,4.2769104,9.7796692,3.319612,5.0394191,0.1911845,15.0520652),(5690,'radius-cleaned.tif',183,3,1076,8.4082305,4.881923,6.4049486,1.8,4.8904628,6.4193022,-0.2017533,1.7202445,2.4989987,7.3627694,17.2230759,0.0562722,6.8919907,4.2800713,9.7964764,3.3291606,5.0394191,0.1911845,15.0480551),(5691,'radius-cleaned.tif',183,3,1077,8.4016687,4.8823689,6.4084901,1.8,4.8900544,6.4216494,-0.2033391,1.7165468,2.4990352,7.3651104,17.2288672,0.0571034,6.8942074,4.2906552,9.8017208,3.321117,5.0394191,0.1911845,15.0093296),(5692,'radius-cleaned.tif',183,3,1078,8.3854891,4.8824163,6.41267,1.8,4.8902674,6.4287266,-0.2058107,1.7204091,2.484101,7.3623116,17.1817672,0.0583677,6.9166943,4.2793959,9.7892473,3.3267589,5.0115418,0.1599131,15.2213466),(5693,'radius-cleaned.tif',183,3,1079,8.384854,4.8814079,6.4147252,1.8,4.8886819,6.4279961,-0.2063122,1.7303375,2.4973801,7.370117,17.1807225,0.058644,6.8794983,4.2593523,9.7985785,3.3335109,5.0115418,0.1599131,14.9569126),(5694,'radius-cleaned.tif',183,3,1080,8.3915145,4.8829678,6.4179598,1.8,4.8911764,6.4318014,-0.2046657,1.7177042,2.4979509,7.3796935,17.1831364,0.0577706,6.8788927,4.2962539,9.7978382,3.3267589,5.0248662,0.1755922,15.0383737),(5695,'radius-cleaned.tif',183,3,1081,8.394631,4.8813938,6.4214988,1.8,4.8875166,6.4358235,-0.2059823,1.728825,2.4959216,7.3761993,17.1906932,0.0585274,6.8875134,4.2665969,9.7824837,3.3267589,5.0394191,0.1911845,15.0851195),(5696,'radius-cleaned.tif',183,3,1082,8.3846412,4.8826827,6.4243372,1.8,4.8905189,6.439804,-0.2063001,1.7318345,2.4966568,7.3741483,17.1805258,0.0586357,6.8814127,4.2579983,9.8064262,3.3292647,5.0248662,0.1755922,14.9859567),(5697,'radius-cleaned.tif',183,3,1083,8.3763353,4.8825178,6.4272561,1.8,4.8899348,6.4413841,-0.2057375,1.7265645,2.495803,7.381383,17.171284,0.0582631,6.8800638,4.2751853,9.8042432,3.3334236,5.0248662,0.1755922,15.0657567),(5698,'radius-cleaned.tif',183,3,1084,8.3663506,4.8809254,6.4311769,1.8,4.8842003,6.446588,-0.2064719,1.7299712,2.4935639,7.3832833,17.1504268,0.0586039,6.8778775,4.2678649,9.7829687,3.3267589,5.0115418,0.1599131,14.9432211),(5699,'radius-cleaned.tif',183,3,1085,8.3712765,4.8841476,6.4327827,1.8,4.8907016,6.4475454,-0.2073707,1.7402897,2.4985615,7.390668,17.1643921,0.0591427,6.8697095,4.2468032,9.7149097,3.3482257,5.0248662,0.1755922,15.180272),(5700,'radius-cleaned.tif',183,3,1086,8.3699273,4.8832788,6.4368745,1.8,4.8876565,6.4527012,-0.2057722,1.727978,2.4970836,7.3923483,17.1643445,0.0582379,6.8737564,4.2780338,9.7252317,3.3406659,5.0422615,0.2315438,15.2076551),(5701,'radius-cleaned.tif',183,3,1087,8.3607297,4.88528,6.4383088,1.8,4.8904535,6.4537245,-0.2057476,1.7379469,2.4816468,7.4061564,17.1464277,0.0581602,6.9092941,4.2614399,9.7189428,3.3553978,5.0115418,0.1599131,15.0423839),(5702,'radius-cleaned.tif',183,3,1088,8.3560372,4.8853149,6.4420125,1.8,4.8914943,6.4577759,-0.2056429,1.7205079,2.495512,7.4011658,17.1440423,0.0580692,6.8699498,4.3017331,9.7218896,3.3388133,5.0115418,0.1599131,14.8206855),(5703,'radius-cleaned.tif',183,3,1089,8.3641066,4.8863001,6.4442607,1.8,4.8919369,6.4602124,-0.2050819,1.7375136,2.4974959,7.4183993,17.1633898,0.0578131,6.8722394,4.2695488,9.7365622,3.3667195,5.0148762,0.2739281,15.1609093),(5704,'radius-cleaned.tif',183,3,1090,8.3678044,4.886779,6.4465479,1.8,4.8907931,6.4612788,-0.2052349,1.7333175,2.497553,7.42791,17.1669926,0.0579237,6.8735248,4.2853717,9.7437696,3.3581187,5.0148762,0.2739281,14.6844584),(5705,'radius-cleaned.tif',183,3,1091,8.379615,4.8882214,6.4497248,1.8,4.8931922,6.4640938,-0.2072423,1.7350946,2.4990156,7.4326203,17.1971413,0.0591293,6.8815661,4.2836975,9.7576356,3.3534039,5.0245493,0.216085,14.9198482),(5706,'radius-cleaned.tif',183,3,1092,8.3917057,4.8917621,6.4527113,1.8,4.8982245,6.4685213,-0.2062769,1.732394,2.5015352,7.4512314,17.2115966,0.0586721,6.8804136,4.3011182,9.7630841,3.3581187,5.0080462,0.2005205,14.8577499),(5707,'radius-cleaned.tif',183,3,1093,8.3746436,4.8926127,6.4554868,1.8,4.8973316,6.4696274,-0.2055959,1.733513,2.4852752,7.4535467,17.203917,0.0581723,6.9223388,4.2996773,9.7624155,3.3467392,4.9994558,0.1441544,15.1084923),(5708,'radius-cleaned.tif',183,3,1094,8.3865303,4.8934899,6.4603303,1.8,4.89762,6.4767174,-0.2066201,1.7320716,2.5017811,7.4671556,17.2323834,0.0588284,6.8880461,4.3111126,9.7643115,3.3521398,5.0148762,0.2739281,15.2447195),(5709,'radius-cleaned.tif',183,3,1095,8.3930989,4.8929238,6.4629839,1.8,4.8957088,6.4786977,-0.2075918,1.7325848,2.5010048,7.4641702,17.265908,0.0594215,6.9035885,4.3081125,9.7823044,3.348466,5.0245493,0.216085,15.1278551),(5710,'radius-cleaned.tif',183,3,1096,8.4069229,4.8938911,6.4658152,1.8,4.8983354,6.4819111,-0.2071361,1.7293733,2.5012183,7.4864503,17.2871075,0.0592621,6.9114748,4.3289961,9.8001877,3.3467392,5.0245493,0.216085,15.0794483),(5711,'radius-cleaned.tif',183,3,1097,8.4181234,4.8932131,6.4686894,1.8,4.8953139,6.4840124,-0.2080297,1.7260311,2.5002539,7.506102,17.2923788,0.0598468,6.916249,4.3487641,9.8166993,3.348466,5.0080462,0.2005205,15.1181737),(5712,'radius-cleaned.tif',183,3,1098,8.412125,4.8957107,6.4720152,1.8,4.9012876,6.4880185,-0.2088218,1.7276614,2.5022634,7.5005228,17.2978678,0.0602538,6.9128886,4.341431,9.8125381,3.3335109,5.0034347,0.2333738,14.9101669),(5713,'radius-cleaned.tif',183,3,1099,8.4124892,4.8962658,6.4748785,1.8,4.9016222,6.4912643,-0.2104835,1.7279615,2.5027326,7.5070782,17.2939524,0.0612049,6.9100279,4.3444709,9.8157563,3.3319712,5.0034347,0.2333738,15.1278551),(5714,'radius-cleaned.tif',183,3,1100,8.4223999,4.8961947,6.4801207,1.8,4.9013963,6.4977092,-0.2107729,1.7330215,2.5016562,7.5430866,17.325007,0.0614431,6.9254149,4.3525638,9.8501934,3.3350506,5.0080462,0.2005205,15.205994),(5715,'radius-cleaned.tif',183,3,1101,8.4352407,4.8961352,6.4829865,1.8,4.8987797,6.4996677,-0.2122262,1.7271448,2.5014349,7.561083,17.3455647,0.0623755,6.9342458,4.3777933,9.8698522,3.3319712,5.0080462,0.2005205,14.966594),(5716,'radius-cleaned.tif',183,3,1102,8.4266466,4.8981424,6.4861236,1.8,4.9044477,6.5008335,-0.2116692,1.7307562,2.5025716,7.540149,17.3292494,0.0619902,6.9245769,4.3565633,9.8523608,3.3387093,5.0224894,0.2488322,14.8964754),(5717,'radius-cleaned.tif',183,3,1103,8.4434929,4.8979107,6.4905952,1.8,4.9038228,6.5071599,-0.2126309,1.7432876,2.5016853,7.5650348,17.3702549,0.0626713,6.9434212,4.3395219,9.8857837,3.3390215,5.0224894,0.2488322,15.3148381),(5718,'radius-cleaned.tif',183,3,1104,8.4494875,4.8995115,6.492269,1.8,4.9043586,6.5057382,-0.2112006,1.7455187,2.5024828,7.5631912,17.3826614,0.0618874,6.9461662,4.3329192,9.8537348,3.3404783,5.0224894,0.2488322,15.2253567),(5719,'radius-cleaned.tif',183,3,1105,8.4487574,4.8996671,6.4960099,1.8,4.904154,6.5097338,-0.2115452,1.7407694,2.5019497,7.5637546,17.3941912,0.0620812,6.9522546,4.3450641,9.8644583,3.3375032,5.0080462,0.2005205,15.0286923),(5720,'radius-cleaned.tif',183,3,1106,8.4429753,4.8989506,6.4997865,1.8,4.9028877,6.5149447,-0.2112941,1.7388262,2.5003851,7.555862,17.3741581,0.0618937,6.948593,4.3453809,9.8624604,3.334528,5.0080462,0.2005205,15.098811),(5721,'radius-cleaned.tif',183,3,1107,8.4483299,4.898727,6.5038632,1.8,4.9031598,6.5190933,-0.2106192,1.742803,2.4991219,7.5753085,17.3784159,0.0615438,6.9538087,4.3466234,9.8715935,3.3491368,5.0034347,0.2333738,15.0286923),(5722,'radius-cleaned.tif',183,3,1108,8.4555022,4.898014,6.505779,1.8,4.8991719,6.5190285,-0.2100463,1.7388139,2.4978634,7.5742557,17.3872199,0.0612663,6.960837,4.3559898,9.8802723,3.3521398,5.0034347,0.2333738,14.966594),(5723,'radius-cleaned.tif',183,3,1109,8.456626,4.8992482,6.5098942,1.8,4.9040747,6.5244426,-0.2103922,1.7404895,2.4983081,7.5751868,17.3655189,0.0614735,6.9509116,4.3523311,9.874228,3.344365,5.0034347,0.2333738,15.1318652),(5724,'radius-cleaned.tif',183,3,1110,8.4682385,4.8982539,6.5103976,1.8,4.900149,6.5217361,-0.2098071,1.735045,2.4970688,7.5874186,17.3929908,0.061221,6.9653632,4.3730384,9.8943077,3.3521398,5.0080462,0.2005205,14.834377),(5725,'radius-cleaned.tif',183,3,1111,8.4576423,4.8972222,6.5134841,1.8,4.8978124,6.5240945,-0.2096002,1.7519558,2.49536,7.5860047,17.3833956,0.0610256,6.9662875,4.3300207,9.8985754,3.362994,5.0034347,0.2333738,15.1882923),(5726,'radius-cleaned.tif',183,3,1112,8.4467088,4.8967533,6.5185711,1.8,4.8954207,6.533254,-0.2122307,1.7512873,2.494545,7.5855688,17.3907801,0.0624629,6.971524,4.3314245,9.9111393,3.3776322,5.0034347,0.2333738,15.1084923),(5727,'radius-cleaned.tif',183,3,1113,8.4273721,4.8985027,6.5223543,1.8,4.8999309,6.5392184,-0.2116314,1.7385302,2.4981984,7.5887758,17.3697348,0.0619737,6.9529046,4.3650527,9.8222981,3.3485701,5.0148762,0.2739281,15.4430449),(5728,'radius-cleaned.tif',183,3,1114,8.4283551,4.8988927,6.5243914,1.8,4.901336,6.5386863,-0.2119369,1.7490044,2.5007694,7.604628,17.3903864,0.0621573,6.9540143,4.3479753,9.8383054,3.3667195,5.0148762,0.2739281,14.9295296),(5729,'radius-cleaned.tif',183,3,1115,8.4192985,4.8971823,6.529832,1.8,4.8962963,6.5483263,-0.2125965,1.7371655,2.4957771,7.6091552,17.384029,0.0624718,6.9653774,4.3802131,9.8518048,3.3536795,5.0148762,0.2739281,15.2213466),(5730,'radius-cleaned.tif',183,3,1116,8.4146981,4.8995749,6.5327169,1.8,4.9004854,6.5513264,-0.2133112,1.7489247,2.503038,7.6157806,17.3843632,0.0628518,6.9453053,4.3545504,9.8502455,3.3583268,5.0148762,0.2739281,15.2503907),(5731,'radius-cleaned.tif',183,3,1117,8.3993584,4.9005222,6.5357159,1.8,4.9019954,6.5538754,-0.2126467,1.7352001,2.5031408,7.6209133,17.3777153,0.0623528,6.9423643,4.3919507,9.8506842,3.3467392,5.0148762,0.2739281,15.0327025),(5732,'radius-cleaned.tif',183,3,1118,8.3996347,4.8991536,6.5399874,1.8,4.8991711,6.5580796,-0.2125536,1.7475091,2.5008755,7.6200314,17.381461,0.0623011,6.9501506,4.3605104,9.8630386,3.3583268,5.0148762,0.2739281,14.9198482),(5733,'radius-cleaned.tif',183,3,1119,8.3966718,4.9014787,6.5411527,1.8,4.9052243,6.5582549,-0.213719,1.732193,2.4980838,7.6263786,17.3603377,0.0629535,6.9494618,4.4027304,9.850563,3.3581187,5.0034347,0.2333738,14.966594),(5734,'radius-cleaned.tif',183,3,1120,8.4016049,4.9001513,6.5440579,1.8,4.9027309,6.5616742,-0.2131111,1.743249,2.5148262,7.6408009,17.3762761,0.0626381,6.9095336,4.3830806,9.8715892,3.3583268,5.0248662,0.1755922,14.9529025),(5735,'radius-cleaned.tif',183,3,1121,8.4041,4.9011992,6.5479903,1.8,4.9027143,6.5659434,-0.2142832,1.7302754,2.5016536,7.6534432,17.3962209,0.0633372,6.9538888,4.4232513,9.8467815,3.3581187,5.0148762,0.2739281,14.8908042),(5736,'radius-cleaned.tif',183,3,1122,8.408241,4.8999726,6.5495391,1.8,4.900211,6.5653312,-0.214107,1.7400303,2.5000787,7.6530826,17.4078562,0.0632658,6.9629233,4.3982467,9.8581698,3.3553978,5.0148762,0.2739281,14.8110042),(5737,'radius-cleaned.tif',183,3,1123,8.4008623,4.8999031,6.5522477,1.8,4.9016434,6.5663394,-0.214632,1.7391024,2.4995738,7.6532701,17.3878994,0.0635159,6.9563457,4.4007011,9.8553839,3.3667195,5.0148762,0.2739281,15.2487296),(5738,'radius-cleaned.tif',183,3,1124,8.4084901,4.8988999,6.5557117,1.8,4.9004528,6.5706219,-0.2155025,1.7371567,2.498081,7.6688867,17.4011543,0.0640823,6.9658088,4.4146199,9.8763059,3.3553978,5.0080462,0.2005205,15.1438957),(5739,'radius-cleaned.tif',183,3,1125,8.3929995,4.9000541,6.5582839,1.8,4.9027434,6.5708722,-0.2155734,1.7532778,2.5120483,7.6665204,17.3915164,0.0640056,6.9232412,4.3726786,9.8720765,3.3827052,5.0248662,0.1755922,15.4333636),(5740,'radius-cleaned.tif',183,3,1126,8.3812909,4.8974488,6.5625523,1.8,4.8966642,6.5764876,-0.2173382,1.7432559,2.5128652,7.6656316,17.3742415,0.0649505,6.9141161,4.3973071,9.876083,3.365388,5.0245493,0.216085,15.1746008),(5741,'radius-cleaned.tif',183,3,1127,8.3858564,4.8974743,6.5652722,1.8,4.8983753,6.5795627,-0.2149874,1.7377551,2.5115397,7.6586013,17.3809319,0.0636093,6.920429,4.4071811,9.8802785,3.3740466,5.0422615,0.2315438,15.4333636),(5742,'radius-cleaned.tif',183,3,1128,8.3929119,4.8971323,6.5666578,1.8,4.8990075,6.5780391,-0.2146463,1.7341099,2.4938009,7.6776067,17.3763648,0.0634641,6.9678236,4.4274048,9.88944,3.3679795,5.0080462,0.2005205,14.7682685),(5743,'radius-cleaned.tif',183,3,1129,8.382159,4.8963262,6.5708556,1.8,4.8982068,6.5835533,-0.216542,1.7512432,2.5058304,7.6808031,17.3678514,0.0644897,6.9309763,4.3859147,9.8970195,3.387493,5.0248662,0.1755922,15.2407093),(5744,'radius-cleaned.tif',183,3,1130,8.3658529,4.8962916,6.575308,1.8,4.9004801,6.5882802,-0.2169825,1.7337319,2.5048887,7.6715036,17.3361362,0.0646222,6.9209208,4.42485,9.8881414,3.3679795,5.0248662,0.1755922,14.9335398),(5745,'radius-cleaned.tif',183,3,1131,8.365907,4.8962609,6.5795763,1.8,4.9002589,6.5941553,-0.218144,1.7508626,2.5082819,7.6958195,17.3425467,0.0653053,6.9141139,4.3954446,9.9073016,3.3831626,5.0245493,0.216085,15.2777737),(5746,'radius-cleaned.tif',183,3,1132,8.3640298,4.8982701,6.5829551,1.8,4.9050508,6.597274,-0.2188024,1.750162,2.5097108,7.7072512,17.3500019,0.065679,6.9131478,4.4037358,9.9130431,3.3831626,5.0245493,0.216085,15.1455567),(5747,'radius-cleaned.tif',183,3,1133,8.3511954,4.8981924,6.5872242,1.8,4.9047096,6.6041459,-0.2176518,1.7543481,2.5083653,7.6945061,17.3379182,0.0649013,6.9120388,4.3859632,9.9091479,3.3926953,5.0248662,0.1755922,15.3769364),(5748,'radius-cleaned.tif',183,3,1134,8.3477132,4.895772,6.5894353,1.8,4.8996773,6.6043234,-0.2186156,1.7646054,2.5058106,7.7103194,17.2941901,0.0654408,6.9016351,4.3694298,9.909923,3.3940269,5.0148762,0.2739281,14.8110042),(5749,'radius-cleaned.tif',183,3,1135,8.3645756,4.8960461,6.5926177,1.8,4.9013143,6.6065266,-0.2191434,1.7504254,2.5184656,7.7240561,17.3375976,0.0658849,6.8841906,4.4126736,9.9003593,3.3933646,5.0447867,0.1508454,15.0754381),(5750,'radius-cleaned.tif',183,3,1136,8.3731065,4.8961735,6.5968214,1.8,4.9004051,6.6133638,-0.2205017,1.7631789,2.5051399,7.7330339,17.3534538,0.0667589,6.9271397,4.3858477,9.8867571,3.3940269,5.0245493,0.216085,15.1358754),(5751,'radius-cleaned.tif',183,3,1137,8.3792979,4.8976696,6.5997763,1.8,4.9058093,6.6159098,-0.220102,1.7448899,2.5058412,7.7419661,17.3809785,0.0665702,6.9361851,4.4369368,9.9015625,3.3933646,5.0245493,0.216085,14.9569126),(5752,'radius-cleaned.tif',183,3,1138,8.3838669,4.8970307,6.603685,1.8,4.9032299,6.6205682,-0.2204299,1.7613426,2.5044552,7.7536727,17.3731715,0.0668019,6.9369065,4.4021377,9.9126267,3.4084,5.0115418,0.1599131,14.966594),(5753,'radius-cleaned.tif',183,3,1139,8.372863,4.8970428,6.6071695,1.8,4.9031565,6.6229072,-0.2203974,1.7479381,2.5164626,7.7454705,17.3716158,0.0666949,6.9031886,4.4312042,9.9152707,3.384706,5.0248662,0.1755922,14.9569126),(5754,'radius-cleaned.tif',183,3,1140,8.3795409,4.8995041,6.6125128,1.8,4.9064485,6.6314228,-0.2202494,1.7490096,2.5176751,7.7597965,17.4052899,0.0666599,6.913239,4.4366804,9.8691876,3.4026272,5.0248662,0.1755922,15.2777737),(5755,'radius-cleaned.tif',183,3,1141,8.3910361,4.9004973,6.6159585,1.8,4.9084971,6.6337869,-0.2192612,1.7483488,2.504844,7.7742104,17.410263,0.0661633,6.9506376,4.4466014,9.8789985,3.3967294,5.0245493,0.216085,15.4003093),(5756,'radius-cleaned.tif',183,3,1142,8.4107548,4.9014091,6.6181765,1.8,4.9112269,6.6321411,-0.2199446,1.7462445,2.5054318,7.7932871,17.43981,0.0667262,6.9608001,4.4628843,9.8985282,3.3871808,5.0248662,0.1755922,15.3438822),(5757,'radius-cleaned.tif',183,3,1143,8.4161507,4.8992473,6.622367,1.8,4.9080371,6.6377243,-0.2196228,1.7457016,2.5023242,7.7967996,17.450384,0.0665768,6.9736703,4.4662841,9.918587,3.3893977,5.0115418,0.1599131,15.2874551),(5758,'radius-cleaned.tif',183,3,1144,8.4293079,4.8987188,6.6245198,1.8,4.9075156,6.6371638,-0.2202302,1.7471932,2.5014958,7.833038,17.438074,0.0670443,6.9710587,4.4832121,9.9334123,3.3873889,5.0080462,0.2005205,14.914177),(5759,'radius-cleaned.tif',183,3,1145,8.444822,4.895597,6.6284441,1.8,4.8989494,6.640593,-0.2190579,1.7420942,2.5146345,7.8472149,17.4590827,0.0664659,6.9429902,4.5044723,9.9648214,3.3913565,5.0245493,0.216085,14.8440584),(5760,'radius-cleaned.tif',183,3,1146,8.4468051,4.8958564,6.6319776,1.8,4.8990413,6.6434618,-0.2208324,1.7449603,2.5147029,7.8513852,17.4777751,0.0675454,6.9502345,4.4994636,9.9787536,3.3875971,5.0245493,0.216085,15.1125025),(5761,'radius-cleaned.tif',183,3,1147,8.438929,4.8975534,6.6365811,1.8,4.9037588,6.6500616,-0.2221802,1.7582362,2.5157813,7.8539338,17.4945838,0.068295,6.9539367,4.4669388,9.9331498,3.3970416,5.0245493,0.216085,14.966594),(5762,'radius-cleaned.tif',183,3,1148,8.4294572,4.8965739,6.6416405,1.8,4.9018397,6.6552924,-0.2245418,1.7501234,2.514444,7.8581265,17.5061396,0.0696517,6.9622308,4.4900414,9.9281467,3.3894741,5.0245493,0.216085,15.2487296),(5763,'radius-cleaned.tif',183,3,1149,8.4350217,4.8942544,6.6469755,1.8,4.8958108,6.6624934,-0.2236249,1.7584374,2.5107162,7.8723191,17.5170828,0.0691391,6.9769265,4.4768834,9.9560844,3.3970416,5.0148762,0.2739281,15.0367126),(5764,'radius-cleaned.tif',183,3,1150,8.4465857,4.8958141,6.6500392,1.8,4.9002878,6.6639536,-0.2249758,1.7580867,2.511963,7.8953355,17.535548,0.0700587,6.9808147,4.4908682,9.9729175,3.4074199,5.0148762,0.2739281,15.2817839),(5765,'radius-cleaned.tif',183,3,1151,8.4619902,4.8967318,6.6534944,1.8,4.9031789,6.6675643,-0.2251742,1.7616341,2.5121452,7.9000129,17.5528636,0.0703082,6.9872012,4.4844799,9.9850341,3.4066943,5.0245493,0.216085,15.2019839),(5766,'radius-cleaned.tif',183,3,1152,8.4927194,4.8921598,6.660192,1.8,4.8940703,6.6773035,-0.227248,1.7578705,2.5067865,7.9333679,17.6201186,0.0718467,7.0289666,4.513056,10.0531388,3.4074199,5.0245493,0.216085,15.8791093),(5767,'radius-cleaned.tif',183,3,1153,8.487017,4.8921081,6.6629827,1.8,4.8937604,6.6803485,-0.2294757,1.7601782,2.5067268,7.9321426,17.6185335,0.0731881,7.0285017,4.5064429,10.0575939,3.401343,5.0080462,0.2005205,15.1923025),(5768,'radius-cleaned.tif',183,3,1154,8.4848233,4.8938136,6.6670159,1.8,4.897179,6.6865532,-0.228825,1.7736614,2.5072933,7.9343513,17.6262952,0.0727621,7.0300092,4.4734307,10.063384,3.430353,5.0034347,0.2333738,15.7799466),(5769,'radius-cleaned.tif',183,3,1155,8.4876784,4.8954002,6.6712922,1.8,4.8987377,6.6916997,-0.2284924,1.7601571,2.5077792,7.9352362,17.630474,0.0725788,7.0303135,4.5082545,10.0680937,3.4084,5.0080462,0.2005205,15.3575737),(5770,'radius-cleaned.tif',183,3,1156,8.4993942,4.8954664,6.6736117,1.8,4.9004193,6.6911574,-0.2288458,1.7714057,2.5074124,7.942727,17.6552339,0.0729001,7.0412166,4.4838553,9.9830854,3.4151975,5.0080462,0.2005205,15.1592483),(5771,'radius-cleaned.tif',183,3,1157,8.5196476,4.8957335,6.676502,1.8,4.901361,6.6935284,-0.2279818,1.762622,2.5095849,7.9488287,17.6802905,0.0725326,7.0451056,4.5096615,10.000264,3.4205138,5.0180498,0.1677631,15.6767737),(5772,'radius-cleaned.tif',183,3,1158,8.5282111,4.8969592,6.6779552,1.8,4.9046866,6.6936899,-0.2271778,1.7733423,2.5074419,7.9601719,17.6967505,0.0721032,7.0576911,4.4887961,10.0100079,3.4280736,5.0080462,0.2005205,15.4607466),(5773,'radius-cleaned.tif',183,3,1159,8.5236773,4.8960454,6.6820366,1.8,4.9023213,6.6985011,-0.2279357,1.7590703,2.5148459,7.9623819,17.6945626,0.0725381,7.0360425,4.5264717,10.0214086,3.4140072,5.0128123,0.2411177,15.6630822),(5774,'radius-cleaned.tif',183,3,1160,8.5253028,4.8963017,6.6856171,1.8,4.9031026,6.7022453,-0.2265294,1.7717064,2.5138692,7.9775327,17.7087146,0.0716747,7.0444058,4.5027397,10.0393263,3.4280736,5.0161459,0.2083156,15.2213466),(5775,'radius-cleaned.tif',183,3,1161,8.5335321,4.8958462,6.6893776,1.8,4.9030317,6.7078816,-0.22615,1.772191,2.5124687,7.9766085,17.7563124,0.071508,7.0672772,4.5009868,10.0281152,3.4339875,5.0161459,0.2083156,15.550228),(5776,'radius-cleaned.tif',183,3,1162,8.5462383,4.8965295,6.6899711,1.8,4.903282,6.7037589,-0.2268784,1.767007,2.5132158,8.0018149,17.7729877,0.0720685,7.0718111,4.5284569,10.043174,3.4280736,5.0180498,0.1677631,15.5171737),(5777,'radius-cleaned.tif',183,3,1163,8.5359919,4.8965997,6.6932186,1.8,4.902464,6.7076994,-0.2254747,1.7671066,2.5242729,7.9976672,17.7554857,0.0711092,7.0339011,4.5258543,10.0404808,3.4258956,5.0245493,0.216085,15.2527398),(5778,'radius-cleaned.tif',183,3,1164,8.5303321,4.8981226,6.6967978,1.8,4.9054925,6.7115799,-0.225911,1.7530937,2.5250284,8.0028641,17.7659028,0.0713327,7.0359219,4.5649952,10.0478908,3.4232809,5.0248662,0.1755922,14.9278686),(5779,'radius-cleaned.tif',183,3,1165,8.5224482,4.8967019,6.7006831,1.8,4.9005374,6.7174994,-0.2243139,1.7654439,2.5279911,8.0160745,17.7641734,0.0702796,7.026992,4.5405433,10.0644401,3.4468489,5.0324642,0.2565166,15.4413839),(5780,'radius-cleaned.tif',183,3,1166,8.5377688,4.8979992,6.7035637,1.8,4.9031151,6.7203646,-0.2235532,1.764988,2.5283376,8.0340424,17.8107027,0.0699372,7.0444322,4.5518963,10.09041,3.459466,5.0324642,0.2565166,15.418011),(5781,'radius-cleaned.tif',183,3,1167,8.5427561,4.8969783,6.7070407,1.8,4.9003541,6.725271,-0.2233131,1.7628315,2.5088115,8.0409833,17.8155757,0.0698303,7.1012014,4.5614021,10.1049869,3.4417234,5.0148762,0.2739281,15.6106652),(5782,'radius-cleaned.tif',183,3,1168,8.5483381,4.8970686,6.7090146,1.8,4.8992902,6.726045,-0.2235869,1.7612567,2.5209058,8.0474301,17.8064216,0.0700445,7.0635015,4.5691409,10.1072469,3.4439347,5.0248662,0.1755922,15.338211),(5783,'radius-cleaned.tif',183,3,1169,8.5585182,4.8967793,6.71066,1.8,4.8973893,6.7263197,-0.2223144,1.7612499,2.5376536,8.0575589,17.8485467,0.0693451,7.0334844,4.5749094,10.1317222,3.4414466,5.0422615,0.2315438,15.3519025),(5784,'radius-cleaned.tif',183,3,1170,8.5537149,4.8981752,6.713864,1.8,4.9017396,6.7300877,-0.221074,1.7561855,2.5253357,8.0602763,17.8335235,0.0685476,7.0618426,4.5896497,10.0527216,3.4524445,5.0370492,0.2891806,15.2874551),(5785,'radius-cleaned.tif',183,3,1171,8.5675633,4.8982085,6.7173702,1.8,4.9032472,6.7343835,-0.2214999,1.7595107,2.5247519,8.0733136,17.8803336,0.068919,7.0820161,4.5883856,10.0815124,3.4530054,5.0245493,0.216085,15.2914652),(5786,'radius-cleaned.tif',183,3,1172,8.5676471,4.8980156,6.7200363,1.8,4.9015084,6.7364774,-0.2229248,1.7705422,2.5244813,8.0861768,17.9028405,0.0697945,7.0916906,4.5670623,10.0577932,3.4631656,5.0248662,0.1755922,15.4857805),(5787,'radius-cleaned.tif',183,3,1173,8.5647775,4.8967298,6.7255683,1.8,4.8982727,6.7452446,-0.2218973,1.7758671,2.5216471,8.0834593,17.9217819,0.06914,7.1071728,4.551838,10.0798231,3.4535518,5.0248662,0.1755922,15.6083161),(5788,'radius-cleaned.tif',183,3,1174,8.5739681,4.8988537,6.7279729,1.8,4.9017429,6.7455209,-0.2220077,1.7698719,2.5357922,8.1045427,17.9605696,0.0692819,7.082824,4.579169,10.1009983,3.4411697,5.0394191,0.1911845,15.4664178),(5789,'radius-cleaned.tif',183,3,1175,8.5756839,4.8982301,6.7328505,1.8,4.9000818,6.7512995,-0.2233586,1.7741577,2.5343989,8.1025527,17.9591156,0.0701275,7.0861441,4.5669856,10.1118831,3.4538286,5.0394191,0.1911845,15.1552381),(5790,'radius-cleaned.tif',183,3,1176,8.5944537,4.8998436,6.7346125,1.8,4.9037394,6.7507485,-0.2227285,1.772729,2.5354491,8.1441622,17.9831525,0.0698916,7.0926892,4.5941383,10.1356448,3.4580819,5.0394191,0.1911845,15.0270313),(5791,'radius-cleaned.tif',183,3,1177,8.5991218,4.9001031,6.7390107,1.8,4.9052678,6.7559384,-0.2234033,1.7593398,2.53487,8.1481255,17.9963679,0.0703469,7.0995231,4.6313539,10.1506026,3.4468489,5.0394191,0.1911845,15.1866313),(5792,'radius-cleaned.tif',183,3,1178,8.6043024,4.8993539,6.7416409,1.8,4.9029017,6.7567227,-0.2239534,1.7705098,2.5336682,8.1569917,18.0025292,0.0707305,7.1053224,4.6071429,10.164428,3.4714095,5.0394191,0.1911845,15.0036584),(5793,'radius-cleaned.tif',183,3,1179,8.6147869,4.8996528,6.7451837,1.8,4.9048959,6.7613437,-0.2232381,1.7564532,2.5330302,8.1751655,18.0219382,0.0703726,7.1147742,4.6543599,10.1569656,3.4885513,5.0394191,0.1911845,15.2019839),(5794,'radius-cleaned.tif',183,3,1180,8.6315471,4.8982422,6.7484809,1.8,4.902682,6.7638435,-0.2234235,1.7681591,2.5486425,8.1988646,18.0673537,0.0706247,7.0890107,4.6369497,10.1945796,3.4891008,5.05519,0.2066832,15.5558992),(5795,'radius-cleaned.tif',183,3,1181,8.618272,4.8998601,6.7515444,1.8,4.9042005,6.7658706,-0.2226362,1.767959,2.549327,8.2026703,18.0209313,0.0700282,7.0688975,4.6396271,10.1777221,3.4784815,5.0394191,0.1911845,15.338211),(5796,'radius-cleaned.tif',183,3,1182,8.6119798,4.9007897,6.7569221,1.8,4.9066237,6.7730916,-0.2246869,1.7734066,2.5495901,8.2098722,18.0403713,0.0712503,7.0757927,4.6294361,10.1942345,3.4798009,5.0447867,0.1508454,15.4236822),(5797,'radius-cleaned.tif',183,3,1183,8.6258191,4.8989695,6.7604014,1.8,4.9015671,6.7770029,-0.2235738,1.7852446,2.5343824,8.2371332,18.0481814,0.0706713,7.1213331,4.6140083,10.220455,3.4980055,5.0334132,0.1351707,15.1689296),(5798,'radius-cleaned.tif',183,3,1184,8.6281896,4.8986026,6.7635358,1.8,4.9014419,6.7780014,-0.2231612,1.7829638,2.5331706,8.2507019,18.0474291,0.0704343,7.1244429,4.6275206,10.2322682,3.4854383,5.0334132,0.1351707,15.3148381),(5799,'radius-cleaned.tif',183,3,1185,8.6257284,4.9004803,6.7679534,1.8,4.9062592,6.7845316,-0.2250155,1.7840897,2.5347269,8.2596493,18.0592216,0.0715694,7.1247208,4.6296156,10.1422549,3.4854383,5.0422615,0.2315438,15.4567364),(5800,'radius-cleaned.tif',183,3,1186,8.6238502,4.9002614,6.7712727,1.8,4.9056883,6.787703,-0.2244493,1.7817769,2.533561,8.2806005,18.0554083,0.0712002,7.1264944,4.6473834,10.1562561,3.4854383,5.0248662,0.1755922,15.1923025),(5801,'radius-cleaned.tif',183,3,1187,8.6117939,4.9012008,6.7749378,1.8,4.9043481,6.7915002,-0.2254302,1.7821369,2.5372397,8.2838513,18.0353488,0.0717129,7.1082557,4.6482689,10.1539571,3.4977649,5.0180498,0.1677631,15.1592483),(5802,'radius-cleaned.tif',183,3,1188,8.6206892,4.8980529,6.7805371,1.8,4.8971698,6.8003888,-0.2277843,1.7687448,2.5305538,8.3036966,18.070417,0.073268,7.1408942,4.6946832,10.1970377,3.4811851,5.0248662,0.1755922,15.630028),(5803,'radius-cleaned.tif',183,3,1189,8.6239903,4.8987358,6.7848131,1.8,4.9002116,6.8056409,-0.2281288,1.7820421,2.5303752,8.315785,18.089879,0.073514,7.1490896,4.6664357,10.2155171,3.4977649,5.0248662,0.1755922,15.178611),(5804,'radius-cleaned.tif',183,3,1190,8.6388893,4.8995692,6.7867283,1.8,4.9016802,6.8066204,-0.2272277,1.7781124,2.5484139,8.3384018,18.1204216,0.0730705,7.1104703,4.6894682,10.1901575,3.5128026,5.0422615,0.2315438,15.5599093),(5805,'radius-cleaned.tif',183,3,1191,8.6458994,4.8981836,6.7909594,1.8,4.897247,6.8115491,-0.2283263,1.7815931,2.5465783,8.3504291,18.1341612,0.0738262,7.1209911,4.6870574,10.212562,3.4999516,5.0422615,0.2315438,15.390628),(5806,'radius-cleaned.tif',183,3,1192,8.6497699,4.8972014,6.7944363,1.8,4.8957798,6.8138082,-0.2274432,1.7760271,2.5444618,8.3623194,18.1259761,0.0732989,7.1236974,4.7084413,10.2237112,3.5017968,5.0370492,0.2891806,15.5228449),(5807,'radius-cleaned.tif',183,3,1193,8.6552328,4.8977504,6.7978905,1.8,4.8961508,6.81719,-0.2272726,1.7795741,2.5470588,8.3789203,18.1328105,0.0732371,7.1191173,4.7083852,10.2370648,3.4784815,5.0370492,0.2891806,15.2156754),(5808,'radius-cleaned.tif',183,3,1194,8.6585917,4.8985907,6.8020962,1.8,4.8969926,6.8208606,-0.2282636,1.7807735,2.5471778,8.3956798,18.1226122,0.0738947,7.1147811,4.7146252,10.2442215,3.4999516,5.0370492,0.2891806,15.3946381),(5809,'radius-cleaned.tif',183,3,1195,8.6444387,4.9012662,6.8063333,1.8,4.9026599,6.8273566,-0.227347,1.79756,2.5456998,8.3997708,18.1240322,0.0731928,7.1194696,4.6728736,10.2445327,3.5147768,5.0422615,0.2315438,15.5228449),(5810,'radius-cleaned.tif',183,3,1196,8.6572414,4.9001049,6.8101387,1.8,4.8986202,6.831825,-0.2291571,1.7861879,2.5444441,8.4211634,18.1478149,0.0744526,7.1323298,4.7146011,10.2688461,3.5094306,5.0245493,0.216085,15.4881296),(5811,'radius-cleaned.tif',183,3,1197,8.6648773,4.9002721,6.8128699,1.8,4.8984562,6.8334933,-0.2293195,1.7823893,2.5440514,8.4398012,18.1747506,0.074622,7.1440185,4.7351054,10.2670783,3.4940739,5.0245493,0.216085,15.285794),(5812,'radius-cleaned.tif',183,3,1198,8.6683195,4.8992525,6.8157667,1.8,4.8984394,6.8355596,-0.2290744,1.7940929,2.544919,8.4465275,18.1726029,0.074495,7.1407393,4.7079656,10.2464579,3.5146065,5.0245493,0.216085,15.4413839),(5813,'radius-cleaned.tif',183,3,1199,8.6812719,4.898561,6.8187131,1.8,4.898967,6.8374104,-0.2301008,1.796617,2.5438118,8.4709661,18.2144391,0.0752645,7.1602934,4.7149538,10.2805679,3.5167384,5.0319897,0.1833996,15.2914652),(5814,'radius-cleaned.tif',183,3,1200,8.67906,4.8969363,6.8215146,1.8,4.8956749,6.8395145,-0.2303469,1.8080379,2.5416465,8.4674845,18.2217671,0.0754035,7.1692767,4.6832451,10.2671057,3.5128308,5.0319897,0.1833996,15.5599093),(5815,'radius-cleaned.tif',183,3,1201,8.6884366,4.8956706,6.8248548,1.8,4.8955218,6.8422316,-0.2283459,1.7904976,2.5392022,8.4760982,18.2297655,0.074202,7.1793281,4.7339345,10.2843505,3.5071573,5.0319897,0.1833996,15.3011466),(5816,'radius-cleaned.tif',183,3,1202,8.6849162,4.8957786,6.8285462,1.8,4.8956141,6.8473416,-0.2286809,1.8058233,2.5385465,8.4831594,18.2165135,0.0743859,7.1759622,4.6976686,10.2737456,3.5159904,5.0245493,0.216085,15.4801093),(5817,'radius-cleaned.tif',183,3,1203,8.6716661,4.8968492,6.8314911,1.8,4.8995964,6.8493112,-0.2289918,1.788132,2.5389898,8.4725587,18.2189737,0.074471,7.1756782,4.7382176,10.2737047,3.5071573,5.0245493,0.216085,14.9706042),(5818,'radius-cleaned.tif',183,3,1204,8.6842836,4.8957469,6.8368248,1.8,4.8950365,6.8577283,-0.2298405,1.8045691,2.5550663,8.5086721,18.2465718,0.0751233,7.14133,4.7150713,10.313789,3.5159904,5.0422615,0.2315438,15.550228),(5819,'radius-cleaned.tif',183,3,1205,8.6930668,4.8938781,6.8392255,1.8,4.8921571,6.8603626,-0.229811,1.7858147,2.5526912,8.5120895,18.2723734,0.0751803,7.1580821,4.7665021,10.287825,3.5071573,5.0422615,0.2315438,15.3422211),(5820,'radius-cleaned.tif',183,3,1206,8.6968728,4.8957417,6.8420356,1.8,4.8965497,6.8616761,-0.2297273,1.7889874,2.5422472,8.529757,18.2902689,0.0751595,7.194528,4.7679246,10.2997201,3.5237926,5.0370492,0.2891806,15.1592483),(5821,'radius-cleaned.tif',183,3,1207,8.6932837,4.8948485,6.8470212,1.8,4.8952796,6.8691906,-0.230239,1.7911391,2.5404495,8.535208,18.2649184,0.0754576,7.1896405,4.7652403,10.2632757,3.5237926,5.0370492,0.2891806,15.2293669),(5822,'radius-cleaned.tif',183,3,1208,8.7047789,4.8929697,6.8500702,1.8,4.8913879,6.8694652,-0.2308883,1.7868755,2.5496335,8.5553048,18.3102815,0.0759765,7.1815348,4.7878572,10.2475942,3.5237926,5.0422615,0.2315438,15.2390483),(5823,'radius-cleaned.tif',183,3,1209,8.7262121,4.892544,6.8528372,1.8,4.8910751,6.8706779,-0.2308269,1.7871553,2.5485692,8.5663769,18.3460741,0.0761238,7.1985779,4.7933031,10.2724021,3.5192626,5.0422615,0.2315438,15.418011),(5824,'radius-cleaned.tif',183,3,1210,8.7345467,4.8926794,6.8576742,1.8,4.893664,6.8759236,-0.2317839,1.789698,2.5661801,8.5876395,18.3692922,0.0768182,7.158224,4.7983737,10.2985363,3.5237926,5.047153,0.1989459,15.5034822),(5825,'radius-cleaned.tif',183,3,1211,8.7440581,4.8929278,6.8601019,1.8,4.8918192,6.8768379,-0.231901,1.785115,2.5659041,8.6093297,18.3736588,0.0769782,7.160696,4.8228433,10.3124724,3.5167384,5.047153,0.1989459,15.3519025),(5826,'radius-cleaned.tif',183,3,1212,8.735155,4.8917085,6.8634546,1.8,4.8913434,6.8794065,-0.2309723,1.7927699,2.556803,8.6018202,18.3476783,0.0762961,7.1760234,4.7980615,10.3104802,3.5237926,5.0447867,0.1508454,15.7154992),(5827,'radius-cleaned.tif',183,3,1213,8.7431244,4.8895241,6.8680294,1.8,4.8872586,6.8850612,-0.2329201,1.7959402,2.5499139,8.6218853,18.355271,0.0776357,7.1983884,4.8007642,10.3376298,3.5020736,5.0345201,0.3142319,15.1729398),(5828,'radius-cleaned.tif',183,3,1214,8.7452759,4.8899167,6.8710654,1.8,4.8883978,6.888158,-0.2310342,1.7860192,2.560167,8.6317788,18.3638257,0.0764247,7.1729014,4.8329708,10.2983668,3.5026273,5.0485722,0.3467453,15.4938008),(5829,'radius-cleaned.tif',183,3,1215,8.7453041,4.888125,6.8743372,1.8,4.8821787,6.8914871,-0.2298044,1.7980201,2.5572669,8.6458105,18.3697389,0.0756279,7.1833483,4.8085172,10.3697278,3.5195394,5.0422615,0.2315438,15.2954754),(5830,'radius-cleaned.tif',183,3,1216,8.7459936,4.8881879,6.8777216,1.8,4.8816144,6.89535,-0.2316109,1.7989966,2.5754653,8.6563108,18.3798192,0.0768062,7.1365043,4.8117438,10.2728973,3.5246231,5.06117,0.2468907,15.2954754),(5831,'radius-cleaned.tif',183,3,1217,8.738213,4.8871249,6.8791732,1.8,4.8814175,6.8946933,-0.2300283,1.7958466,2.5734597,8.6654523,18.3591792,0.0757113,7.1340458,4.8252742,10.2498729,3.5085415,5.06117,0.2468907,15.390628),(5832,'radius-cleaned.tif',183,3,1218,8.7358728,4.8851678,6.8830333,1.8,4.8779336,6.8999348,-0.229937,1.79671,2.5706373,8.6807292,18.3564574,0.0756319,7.1408197,4.8314583,10.2686758,3.5154814,5.0721675,0.2220819,15.4801093),(5833,'radius-cleaned.tif',183,3,1219,8.7500176,4.8842341,6.8870573,1.8,4.8740974,6.9048609,-0.2296369,1.7938921,2.5686914,8.7040946,18.3866875,0.0755603,7.1579978,4.8520726,10.2999545,3.5153418,5.0721675,0.2220819,15.5405466),(5834,'radius-cleaned.tif',183,3,1220,8.7485729,4.8841837,6.8914388,1.8,4.8746503,6.9107454,-0.2311854,1.8067894,2.5682532,8.7246199,18.3968022,0.0765519,7.1631574,4.8287974,10.3202134,3.5291532,5.05519,0.2066832,15.2527398),(5835,'radius-cleaned.tif',183,3,1221,8.7592703,4.883283,6.8965654,1.8,4.8748334,6.9168753,-0.2340529,1.8107411,2.5580444,8.7485995,18.4436495,0.0785235,7.2100583,4.831502,10.3601529,3.5361352,5.047153,0.1989459,15.7993093),(5836,'radius-cleaned.tif',183,3,1222,8.7624966,4.8829413,6.9005186,1.8,4.8756907,6.9208818,-0.2334594,1.8239122,2.5731616,8.7600251,18.4552213,0.0781618,7.1721967,4.8028766,10.31796,3.5508722,5.0753052,0.2869388,16.0443805),(5837,'radius-cleaned.tif',183,3,1223,8.7660262,4.8833725,6.9048262,1.8,4.8759267,6.9262386,-0.2341723,1.8077262,2.5729941,8.7853381,18.4490418,0.0786628,7.1702619,4.8598831,10.3311001,3.5508722,5.0753052,0.2869388,15.8033195),(5838,'radius-cleaned.tif',183,3,1224,8.7719658,4.8834381,6.9077647,1.8,4.87663,6.925998,-0.2343235,1.8215911,2.5724623,8.7920981,18.4528148,0.0788159,7.1732109,4.8266036,10.2461676,3.5508722,5.06117,0.2468907,15.418011),(5839,'radius-cleaned.tif',183,3,1225,8.7783823,4.881308,6.9125276,1.8,4.8739195,6.9341757,-0.2351935,1.795965,2.5713859,8.8146304,18.4730592,0.0794495,7.1840866,4.908019,10.2786976,3.5457885,5.0635286,0.2143955,15.2994855),(5840,'radius-cleaned.tif',183,3,1226,8.7839621,4.8808368,6.9151166,1.8,4.8726709,6.9335571,-0.2348868,1.8077367,2.5702025,8.8359433,18.4677002,0.0792966,7.1853094,4.8878487,10.2913697,3.5457885,5.0603836,0.304296,15.4083296),(5841,'radius-cleaned.tif',183,3,1227,8.7816548,4.8818997,6.9186713,1.8,4.8760766,6.9360414,-0.2340059,1.7931251,2.5700608,8.8385341,18.4441167,0.0786932,7.1765294,4.929123,10.2868775,3.5333681,5.0603836,0.304296,15.3712652),(5842,'radius-cleaned.tif',183,3,1228,8.7827889,4.881904,6.9225914,1.8,4.8767099,6.9387018,-0.2320661,1.8066766,2.5662654,8.8506958,18.4264358,0.0774273,7.1802535,4.8988823,10.3461943,3.5540219,5.0603836,0.304296,15.390628),(5843,'radius-cleaned.tif',183,3,1229,8.7803962,4.8806692,6.9276373,1.8,4.8763651,6.9441551,-0.2323423,1.809155,2.5774019,8.8682249,18.4418249,0.0775873,7.1551995,4.9018601,10.3189352,3.5540219,5.0641574,0.1742158,15.4276924),(5844,'radius-cleaned.tif',183,3,1230,8.781452,4.880203,6.9322823,1.8,4.87546,6.9497179,-0.2319194,1.8136051,2.5757676,8.8809837,18.4488317,0.0773195,7.1624598,4.8968674,10.3370952,3.5517968,5.0641574,0.1742158,15.3422211),(5845,'radius-cleaned.tif',183,3,1231,8.7758525,4.8821664,6.9343201,1.8,4.8802509,6.9495152,-0.2322054,1.8251969,2.5660013,8.8946984,18.4008976,0.0774574,7.17104,4.8732816,10.3215102,3.5807548,5.0603836,0.304296,15.2487296),(5846,'radius-cleaned.tif',183,3,1232,8.7736009,4.8815941,6.9377832,1.8,4.8791098,6.9513235,-0.2307454,1.8102547,2.5640862,8.9133653,18.3836883,0.0764841,7.1696843,4.9238184,10.3307689,3.5517968,5.0603836,0.304296,15.497811),(5847,'radius-cleaned.tif',183,3,1233,8.7857224,4.8781327,6.9452111,1.8,4.8708757,6.9626966,-0.2323298,1.8256738,2.5596163,8.9414773,18.4270955,0.0776261,7.1991632,4.8976315,10.3841988,3.5746756,5.0603836,0.304296,15.6888042),(5848,'radius-cleaned.tif',183,3,1234,8.7717188,4.8768023,6.9487688,1.8,4.8699759,6.966585,-0.2332792,1.8102908,2.5690034,8.9379771,18.4007976,0.0781256,7.162621,4.9373157,10.3844212,3.5601375,5.0533001,0.371709,15.6283669),(5849,'radius-cleaned.tif',183,3,1235,8.7755278,4.8756754,6.9533057,1.8,4.8683746,6.9724981,-0.2330471,1.8237,2.5852316,8.9587738,18.4223411,0.0780069,7.1259924,4.9124165,10.3345152,3.5746756,5.0635286,0.2143955,15.7195093),(5850,'radius-cleaned.tif',183,3,1236,8.7679741,4.8748438,6.9574697,1.8,4.8677361,6.9754214,-0.2341249,1.8088951,2.5837986,8.9690278,18.3953574,0.078649,7.1195013,4.9582908,10.2820345,3.5517968,5.0622709,0.3541582,15.7235195),(5851,'radius-cleaned.tif',183,3,1237,8.758789,4.873721,6.9610537,1.8,4.8669085,6.9794916,-0.2341983,1.8213639,2.5818976,8.9705675,18.366267,0.078615,7.1134763,4.9251924,10.2822346,3.5778514,5.0622709,0.3541582,15.5913025),(5852,'radius-cleaned.tif',183,3,1238,8.761905,4.8733596,6.9659604,1.8,4.8671909,6.9867198,-0.2351842,1.8181843,2.5697968,8.9983532,18.4021697,0.0792943,7.1609435,4.9490874,10.3166988,3.5713103,5.0622709,0.3541582,15.6590721),(5853,'radius-cleaned.tif',183,3,1239,8.7706891,4.8732299,6.9684189,1.8,4.8702007,6.9868083,-0.2353084,1.8204965,2.5691505,9.0211515,18.4046815,0.079456,7.1637225,4.9553248,10.3313228,3.5746756,5.0622709,0.3541582,15.2390483),(5854,'radius-cleaned.tif',183,3,1240,8.7717409,4.8717363,6.9727399,1.8,4.8667377,6.9906735,-0.2367023,1.8224401,2.5779922,9.0374623,18.3902622,0.0803921,7.1335599,4.95899,10.3453032,3.5765199,5.06117,0.2468907,15.7138381),(5855,'radius-cleaned.tif',183,3,1241,8.7764258,4.8710982,6.9776747,1.8,4.8660525,6.996404,-0.2361039,1.8178929,2.5839161,9.0513841,18.4001366,0.0800365,7.1210271,4.9790524,10.3658112,3.5746756,5.0753052,0.2869388,15.7332008),(5856,'radius-cleaned.tif',183,3,1242,8.8023899,4.8692499,6.9833165,1.8,4.8628039,7.0020651,-0.2377522,1.8330796,2.5815974,9.1111647,18.4420476,0.0813767,7.1436575,4.9704142,10.4213075,3.590057,5.0753052,0.2869388,15.7001466),(5857,'radius-cleaned.tif',183,3,1243,8.8061761,4.8684547,6.9866605,1.8,4.8610357,7.0029779,-0.2384248,1.8242909,2.5803586,9.1198014,18.4453322,0.0818642,7.1483601,4.9990937,10.4349295,3.5877696,5.0753052,0.2869388,16.0193466),(5858,'radius-cleaned.tif',183,3,1244,8.8036264,4.8682355,6.9930311,1.8,4.8622413,7.012736,-0.2390955,1.8293835,2.5789564,9.1284856,18.4155273,0.0822928,7.1406896,4.9899245,10.4398002,3.5978318,5.0622709,0.3541582,15.8928008),(5859,'radius-cleaned.tif',183,3,1245,8.8203551,4.867364,6.9978032,1.8,4.85936,7.0157587,-0.2401924,1.8259451,2.577488,9.1670646,18.4779288,0.0831928,7.168968,5.0204491,10.3909734,3.6002683,5.0622709,0.3541582,16.0911263),(5860,'radius-cleaned.tif',183,3,1246,8.8227913,4.8664848,7.0021359,1.8,4.8585225,7.0198457,-0.2389818,1.8397829,2.5750468,9.1657121,18.4818097,0.082395,7.1772713,4.9819532,10.4036504,3.6114992,5.0622709,0.3541582,16.3071534),(5861,'radius-cleaned.tif',183,3,1247,8.8362428,4.8650495,7.0073529,1.8,4.8545001,7.0255084,-0.2391031,1.8246111,2.591372,9.2050936,18.5018972,0.0826028,7.1398076,5.044962,10.4414614,3.6001642,5.0861156,0.3440793,15.7993093),(5862,'radius-cleaned.tif',183,3,1248,8.8334266,4.8675231,7.0097743,1.8,4.8614761,7.0249844,-0.2391643,1.8379457,2.5743302,9.2155416,18.4675677,0.0826179,7.1737369,5.0140444,10.4290506,3.607246,5.0622709,0.3541582,16.1846178),(5863,'radius-cleaned.tif',183,3,1249,8.8446481,4.865804,7.015285,1.8,4.8583345,7.0312015,-0.24004,1.8417918,2.5725585,9.2551326,18.482135,0.083318,7.1843399,5.02507,10.466458,3.628744,5.0635286,0.2143955,15.3325398),(5864,'radius-cleaned.tif',183,3,1250,8.8520526,4.8658927,7.0192594,1.8,4.8581556,7.0343025,-0.2389698,1.8458501,2.5704128,9.2706796,18.4955993,0.0826601,7.1955753,5.0224444,10.4851873,3.6278577,5.0533001,0.2717922,15.5969737),(5865,'radius-cleaned.tif',183,3,1251,8.8500108,4.8644282,7.0241319,1.8,4.8557978,7.040296,-0.2407461,1.8404251,2.5686149,9.292025,18.5065038,0.0838503,7.2048574,5.0488472,10.4554016,3.6242279,5.06117,0.2468907,15.8130008),(5866,'radius-cleaned.tif',183,3,1252,8.8508084,4.862701,7.0289196,1.8,4.8525139,7.0458931,-0.2433924,1.8438355,2.5861606,9.2917406,18.5148635,0.0856748,7.1592088,5.0393545,10.4736721,3.6334951,5.0812616,0.2621198,16.1652551),(5867,'radius-cleaned.tif',183,3,1253,8.8468169,4.864055,7.033211,1.8,4.856965,7.0505574,-0.2423923,1.8583799,2.5859413,9.3090547,18.5017296,0.0849476,7.1547369,5.0092311,10.4789429,3.6424564,5.0812616,0.2621198,15.5969737),(5868,'radius-cleaned.tif',183,3,1254,8.8411942,4.8657095,7.0373456,1.8,4.8608555,7.0542362,-0.2434262,1.8431193,2.5870664,9.3093,18.4847504,0.085605,7.1450622,5.0508395,10.4863639,3.6377924,5.0622709,0.3541582,15.7759365),(5869,'radius-cleaned.tif',183,3,1255,8.832787,4.8629202,7.0397172,1.8,4.8558549,7.056035,-0.2446797,1.8446305,2.5844511,9.3061797,18.4706282,0.0863889,7.1468284,5.0450101,10.4939869,3.6364609,5.0635286,0.2143955,15.4938008),(5870,'radius-cleaned.tif',183,3,1256,8.8139033,4.862055,7.0455562,1.8,4.8571474,7.0643925,-0.2432955,1.8309955,2.581754,9.3090809,18.4341877,0.085251,7.1401798,5.0841636,10.4950104,3.6281346,5.0622709,0.3541582,15.4276924),(5871,'radius-cleaned.tif',183,3,1257,8.8132418,4.8601204,7.0491246,1.8,4.8553732,7.0669523,-0.2454796,1.843302,2.5797897,9.3476945,18.4241361,0.0867509,7.1417202,5.0711683,10.430956,3.6501304,5.0691848,0.4390047,15.4043195),(5872,'radius-cleaned.tif',183,3,1258,8.8071287,4.8595973,7.0542325,1.8,4.8562043,7.0713716,-0.2466651,1.8482369,2.5785999,9.3546631,18.4132206,0.087513,7.1407824,5.0613983,10.4412437,3.6718495,5.0691848,0.4390047,15.6066551),(5873,'radius-cleaned.tif',183,3,1259,8.7935392,4.858246,7.0587886,1.8,4.8541424,7.0770247,-0.2455859,1.8425046,2.5755729,9.3683899,18.3780579,0.0866305,7.1355224,5.0845951,10.4210536,3.6504073,5.0622709,0.3541582,15.6397093),(5874,'radius-cleaned.tif',183,3,1260,8.7741684,4.8556483,7.0630478,1.8,4.8496259,7.080686,-0.2457849,1.8460998,2.5720773,9.3759327,18.3195228,0.0865769,7.1224619,5.0787789,10.4193091,3.6523277,5.0622709,0.3541582,15.8831195),(5875,'radius-cleaned.tif',183,3,1261,8.7776633,4.8538907,7.067322,1.8,4.8477348,7.0844989,-0.2467291,1.8397597,2.5891011,9.3984838,18.3087032,0.0872645,7.0714516,5.1085387,10.438405,3.6500696,5.0753052,0.2869388,15.4276924),(5876,'radius-cleaned.tif',183,3,1262,8.7919383,4.851244,7.073698,1.8,4.8442307,7.0936324,-0.2486291,1.845447,2.5856678,9.4316232,18.3429713,0.0887299,7.0940942,5.1107527,10.4491447,3.6504073,5.0861156,0.3440793,15.6106652),(5877,'radius-cleaned.tif',183,3,1263,8.7944615,4.8499776,7.076661,1.8,4.8435354,7.0932511,-0.249139,1.8486527,2.5754243,9.4522669,18.3555224,0.0891122,7.1271837,5.113057,10.4715745,3.6724031,5.0861156,0.3440793,15.5308652),(5878,'radius-cleaned.tif',183,3,1264,8.789967,4.8502357,7.0828151,1.8,4.8448886,7.1021554,-0.2502961,1.8440216,2.5748975,9.473128,18.3338299,0.0898785,7.1202175,5.1372109,10.4818904,3.6657364,5.0828279,0.3863372,15.3752754),(5879,'radius-cleaned.tif',183,3,1265,8.7860802,4.8491204,7.0866683,1.8,4.8433104,7.1032767,-0.25056,1.8564213,2.5810867,9.487988,18.3399142,0.0900244,7.105501,5.1109023,10.5008902,3.6724031,5.0828279,0.3863372,15.5542381),(5880,'radius-cleaned.tif',183,3,1266,8.7864297,4.8482705,7.0914621,1.8,4.8435422,7.1083352,-0.2504652,1.8527941,2.5790426,9.5121759,18.3167017,0.0899613,7.1021324,5.1339627,10.5132067,3.6830083,5.0622709,0.3541582,15.4647567),(5881,'radius-cleaned.tif',183,3,1267,8.7906996,4.8460292,7.0953779,1.8,4.8403533,7.111652,-0.2516581,1.8538787,2.5961711,9.5423848,18.3270494,0.0908461,7.059261,5.1472541,10.5437496,3.6887572,5.0753052,0.2869388,15.7952992),(5882,'radius-cleaned.tif',183,3,1268,8.7867739,4.8460463,7.1018791,1.8,4.84228,7.1194804,-0.2511234,1.8613476,2.5943522,9.5485959,18.331157,0.0904282,7.0657935,5.1299369,10.5597891,3.694399,5.0753052,0.2869388,15.7525636),(5883,'radius-cleaned.tif',183,3,1269,8.7933941,4.8441992,7.1074762,1.8,4.8362499,7.1292651,-0.2519521,1.8551057,2.5716097,9.5838138,18.3358488,0.0910819,7.1301055,5.1661821,10.5919615,3.6887572,5.06117,0.2468907,15.3752754),(5884,'radius-cleaned.tif',183,3,1270,8.7914837,4.8433875,7.111202,1.8,4.8361007,7.1312516,-0.2508096,1.8598567,2.5695299,9.6008618,18.3247139,0.0902555,7.1315432,5.1621514,10.6040884,3.694399,5.0559772,0.4142179,15.709828),(5885,'radius-cleaned.tif',183,3,1271,8.8083208,4.8434847,7.1150451,1.8,4.8367647,7.1342057,-0.2513203,1.8723942,2.5886768,9.6458711,18.3753048,0.0907892,7.0983387,5.1516242,10.5539473,3.7106947,5.0753052,0.2869388,15.3792855),(5886,'radius-cleaned.tif',183,3,1272,8.8107467,4.8419246,7.1205507,1.8,4.8334183,7.1394274,-0.2515545,1.8584867,2.5858874,9.6448848,18.3781764,0.0909799,7.1071061,5.1896443,10.5419324,3.7106947,5.0753052,0.2869388,15.2898042),(5887,'radius-cleaned.tif',183,3,1273,8.821554,4.8416338,7.1244079,1.8,4.8327722,7.1419728,-0.2527428,1.8705908,2.5851001,9.6719611,18.3902176,0.0919357,7.1139286,5.1705381,10.565797,3.7107001,5.0753052,0.2869388,15.4881296),(5888,'radius-cleaned.tif',183,3,1274,8.8171078,4.8403881,7.1292996,1.8,4.8295153,7.147367,-0.2532537,1.8675632,2.5828627,9.6899927,18.3811059,0.0922533,7.1165632,5.1885754,10.5837275,3.7306131,5.0679284,0.3790444,15.4881296),(5889,'radius-cleaned.tif',183,3,1275,8.8189791,4.8394949,7.1347893,1.8,4.8297746,7.1517532,-0.2541072,1.8610698,2.5809374,9.7110022,18.3807732,0.0928824,7.121743,5.2179677,10.6062007,3.7230878,5.0679284,0.3790444,15.657411),(5890,'radius-cleaned.tif',183,3,1276,8.8213653,4.8404224,7.1393886,1.8,4.8338068,7.1579977,-0.2542534,1.8672415,2.580732,9.7300485,18.3928997,0.0930122,7.1270089,5.2109213,10.6245793,3.7324765,5.0679284,0.3790444,15.7001466),(5891,'radius-cleaned.tif',183,3,1277,8.8139714,4.8410742,7.1440131,1.8,4.8338077,7.1615754,-0.2547885,1.8601563,2.580391,9.7475811,18.3788526,0.0933172,7.122507,5.2401947,10.6334796,3.7110343,5.0679284,0.3790444,15.869428),(5892,'radius-cleaned.tif',183,3,1278,8.8261138,4.8386586,7.1502755,1.8,4.8308286,7.1679929,-0.2593795,1.8665346,2.5780606,9.7854562,18.3972438,0.0967672,7.1360789,5.2425797,10.6527882,3.7324765,5.0679284,0.3790444,15.5018211),(5893,'radius-cleaned.tif',183,3,1279,8.8132766,4.8362198,7.1552985,1.8,4.828174,7.175019,-0.2590058,1.8731303,2.5868163,9.7931089,18.3473661,0.0963545,7.0926435,5.2282049,10.6494857,3.7363107,5.0861156,0.3440793,15.4550754),(5894,'radius-cleaned.tif',183,3,1280,8.8221369,4.8349491,7.1577967,1.8,4.8287254,7.1738361,-0.256966,1.8833725,2.5838471,9.8200104,18.3288293,0.0949716,7.0936198,5.2140563,10.6617486,3.7414638,5.0861156,0.3440793,15.6106652),(5895,'radius-cleaned.tif',183,3,1281,8.8310724,4.8305284,7.1619612,1.8,4.8188625,7.1790869,-0.2576746,1.8679431,2.5788948,9.8433351,18.3332695,0.0955812,7.1089636,5.269612,10.6958278,3.7324765,5.0861156,0.3440793,15.3325398),(5896,'radius-cleaned.tif',183,3,1282,8.8506722,4.8304348,7.1669844,1.8,4.8205126,7.1834626,-0.2617872,1.8801698,2.5796939,9.8971526,18.3645721,0.0988048,7.1188958,5.2639675,10.6324453,3.7488384,5.0886191,0.4285743,15.6437195),(5897,'radius-cleaned.tif',183,3,1283,8.8489285,4.8318443,7.1723854,1.8,4.8243619,7.1916988,-0.26247,1.8724044,2.5800098,9.9124966,18.362244,0.0992894,7.1171219,5.2939934,10.643646,3.7506001,5.0691848,0.4390047,15.445394),(5898,'radius-cleaned.tif',183,3,1284,8.8400965,4.8315165,7.1760772,1.8,4.8225298,7.1947951,-0.261732,1.8789179,2.5783572,9.9364704,18.3492797,0.0986461,7.1166555,5.2884004,10.6565278,3.7544723,5.0677714,0.4566055,15.4921398),(5899,'radius-cleaned.tif',183,3,1285,8.8418169,4.832376,7.1809115,1.8,4.8243207,7.1998912,-0.2614519,1.8865789,2.5826875,9.9489599,18.3822563,0.098459,7.1174914,5.2735456,10.6806587,3.776862,5.0677714,0.4566055,15.4921398),(5900,'radius-cleaned.tif',183,3,1286,8.8329698,4.8329353,7.185918,1.8,4.82558,7.2068924,-0.2632188,1.8780924,2.577927,9.9578617,18.3558406,0.0996635,7.1203882,5.3021148,10.6824248,3.7720722,5.0679284,0.3790444,15.365594),(5901,'radius-cleaned.tif',183,3,1287,8.8480343,4.8334815,7.1884423,1.8,4.8280904,7.2052731,-0.2630504,1.8836874,2.5954911,9.9843738,18.3734496,0.0997087,7.0789876,5.300441,10.7023718,3.7720264,5.0727952,0.3366748,15.5872924),(5902,'radius-cleaned.tif',183,3,1288,8.8656947,4.8307584,7.1944431,1.8,4.8216051,7.2125398,-0.2644793,1.8886396,2.5918774,10.0283812,18.3905534,0.1009706,7.0954566,5.3098437,10.7473306,3.783,5.0727952,0.3366748,15.6340381),(5903,'radius-cleaned.tif',183,3,1289,8.8729164,4.8292936,7.2012508,1.8,4.8198419,7.2212003,-0.2643818,1.8771764,2.5918372,10.0446076,18.4311216,0.1009801,7.111219,5.350913,10.7390459,3.7734431,5.0861156,0.3440793,15.8130008),(5904,'radius-cleaned.tif',183,3,1290,8.868447,4.8306302,7.2049532,1.8,4.8220574,7.2251061,-0.2653613,1.8881995,2.5927031,10.0800279,18.4101943,0.1016608,7.1007722,5.3384338,10.7465784,3.7934637,5.0861156,0.3440793,15.5115025),(5905,'radius-cleaned.tif',183,3,1291,8.8700725,4.8289947,7.2095062,1.8,4.8194273,7.2285913,-0.264156,1.8954874,2.593375,10.0876263,18.4312447,0.1007794,7.1070495,5.3219168,10.7717549,3.7836914,5.0861156,0.3440793,15.7799466),(5906,'radius-cleaned.tif',183,3,1292,8.8630496,4.8307028,7.2133975,1.8,4.8247155,7.2311313,-0.26409,1.8861289,2.5939909,10.1007181,18.4064874,0.1006505,7.0958181,5.3552638,10.7683846,3.7934637,5.0861156,0.3440793,15.6477296),(5907,'radius-cleaned.tif',183,3,1293,8.8606882,4.8282744,7.2192037,1.8,4.818861,7.2391106,-0.2631635,1.8942577,2.585499,10.111848,18.416284,0.0999353,7.1229127,5.3381585,10.7892908,3.7899862,5.0861156,0.3440793,15.3559127),(5908,'radius-cleaned.tif',183,3,1294,8.8587923,4.8267862,7.2249065,1.8,4.8190701,7.2464584,-0.2649334,1.8856138,2.5835315,10.1374985,18.4140568,0.1012306,7.1274752,5.3762327,10.8207567,3.7967614,5.0622709,0.3541582,15.869428),(5909,'radius-cleaned.tif',183,3,1295,8.8390684,4.8268802,7.2289193,1.8,4.820069,7.2498658,-0.2644636,1.8928217,2.5863401,10.1471666,18.3643108,0.1006557,7.100501,5.3608678,10.8126547,3.7867168,5.0622709,0.3541582,15.737211),(5910,'radius-cleaned.tif',183,3,1296,8.8378346,4.8262953,7.2328069,1.8,4.8201831,7.2515171,-0.2659307,1.8823978,2.585108,10.1709598,18.3358238,0.1017348,7.0928658,5.4031937,10.7611807,3.7905001,5.0622709,0.3541582,15.869428),(5911,'radius-cleaned.tif',183,3,1297,8.8464672,4.8255146,7.2366054,1.8,4.821423,7.2554243,-0.2650052,1.8893992,2.5968852,10.2031489,18.3041971,0.1011433,7.0485201,5.4002082,10.7723751,3.7984641,5.0727952,0.3366748,15.5679296),(5912,'radius-cleaned.tif',183,3,1298,8.8405303,4.8229544,7.2384178,1.8,4.8158668,7.2517175,-0.2657437,1.8938157,2.5733037,10.2016621,18.2621369,0.1016261,7.0967672,5.3868293,10.8830528,3.8085069,5.0622709,0.3541582,15.6203466),(5913,'radius-cleaned.tif',183,3,1299,8.8448542,4.8221873,7.2448427,1.8,4.815733,7.2611621,-0.2653529,1.8859763,2.5707385,10.2349951,18.252518,0.1013841,7.1001068,5.4268948,10.9081954,3.7981035,5.0622709,0.3541582,15.445394),(5914,'radius-cleaned.tif',183,3,1300,8.824188,4.822403,7.2505671,1.8,4.8164901,7.2679787,-0.2645794,1.894895,2.5763859,10.2322542,18.2391025,0.1005722,7.0793365,5.3999058,10.9130556,3.8040964,5.0622709,0.3541582,15.8323636),(5915,'radius-cleaned.tif',183,3,1301,8.8327018,4.8175833,7.2582176,1.8,4.8055827,7.2779313,-0.2689277,1.8865107,2.591855,10.2796838,18.2801363,0.1039246,7.0529164,5.4490462,10.9119449,3.7981872,5.0861156,0.3440793,15.8363737),(5916,'radius-cleaned.tif',183,3,1302,8.8307845,4.8178527,7.2633493,1.8,4.8073832,7.2842237,-0.2702206,1.8977992,2.591108,10.2980608,18.2721381,0.104879,7.0518627,5.4263175,10.9649669,3.828358,5.0848634,0.3192692,15.8597466),(5917,'radius-cleaned.tif',183,3,1303,8.8141354,4.8162345,7.2676487,1.8,4.8060874,7.2890995,-0.2700373,1.9056616,2.5605412,10.2904482,18.2496035,0.1045428,7.1272448,5.3999346,10.9566163,3.8236551,5.0485722,0.2967558,15.3986483),(5918,'radius-cleaned.tif',183,3,1304,8.8143893,4.8177489,7.2716216,1.8,4.809267,7.2930675,-0.2702871,1.8950362,2.5675102,10.3205116,18.2466538,0.1047345,7.1067502,5.4460763,10.8698952,3.8109947,5.0389452,0.3643313,15.9161737),(5919,'radius-cleaned.tif',183,3,1305,8.7859051,4.8199865,7.2746499,1.8,4.814739,7.2941612,-0.2718549,1.9023927,2.5691461,10.308749,18.1826823,0.1055807,7.077325,5.4188333,10.8669344,3.8175133,5.0389452,0.3643313,15.6437195),(5920,'radius-cleaned.tif',183,3,1306,8.7931587,4.8204284,7.2784193,1.8,4.8155971,7.2973989,-0.2713095,1.8998936,2.5834863,10.3295867,18.2210235,0.1052547,7.0528817,5.4369289,10.8980155,3.8357426,5.0622709,0.3541582,15.497811),(5921,'radius-cleaned.tif',183,3,1307,8.8090589,4.8183951,7.2858308,1.8,4.8124437,7.3076406,-0.2741212,1.90145,2.5805874,10.3739885,18.2432669,0.1075866,7.069424,5.4558303,10.8442497,3.8363156,5.0597544,0.3292317,16.1846178),(5922,'radius-cleaned.tif',183,3,1308,8.8032456,4.8175996,7.28914,1.8,4.8114977,7.3099365,-0.2728011,1.9047567,2.578441,10.3798399,18.2535442,0.1065083,7.0792948,5.4494308,10.90909,3.8361723,5.0597544,0.3292317,16.0250178),(5923,'radius-cleaned.tif',183,3,1309,8.7945634,4.8191162,7.2936848,1.8,4.8148002,7.3159493,-0.2747096,1.9139455,2.5793673,10.3841833,18.2479258,0.1078595,7.0745745,5.4255376,10.9148265,3.8485463,5.0597544,0.3292317,15.7235195),(5924,'radius-cleaned.tif',183,3,1310,8.7803328,4.8185715,7.2981846,1.8,4.8142392,7.3200323,-0.2752946,1.9032327,2.5778295,10.3814135,18.2430893,0.1081324,7.0769184,5.4546213,10.9249136,3.8447333,5.0597544,0.3292317,15.8089907),(5925,'radius-cleaned.tif',183,3,1311,8.7803886,4.818346,7.3006648,1.8,4.8145895,7.3206578,-0.275582,1.9116723,2.5770392,10.3975937,18.2540352,0.1083532,7.0833364,5.4390042,10.942186,3.8486896,5.0622709,0.3541582,15.5872924),(5926,'radius-cleaned.tif',183,3,1312,8.7712834,4.8168715,7.3073946,1.8,4.8112105,7.3302258,-0.2747482,1.9058293,2.5735011,10.3993835,18.2346436,0.1076034,7.0855394,5.4566185,10.9641609,3.8447333,5.0622709,0.3541582,15.577611),(5927,'radius-cleaned.tif',183,3,1313,8.7752189,4.8141477,7.3115022,1.8,4.8060601,7.3335329,-0.2784226,1.9289951,2.5710091,10.4289489,18.2324101,0.1104752,7.0915385,5.4064155,10.8529428,3.8738672,5.0389452,0.3643313,16.2604077),(5928,'radius-cleaned.tif',183,3,1314,8.7773397,4.8134106,7.3171828,1.8,4.8057477,7.3418951,-0.2796874,1.9181506,2.5911818,10.452343,18.256174,0.1114817,7.045501,5.4491775,10.8496113,3.8686675,5.0622709,0.3541582,15.6807839),(5929,'radius-cleaned.tif',183,3,1315,8.7727867,4.8121793,7.3207185,1.8,4.8051826,7.3427675,-0.2787409,1.9097209,2.5886435,10.463203,18.2920184,0.1106906,7.0662562,5.4789172,10.8803237,3.8582656,5.0597544,0.3292317,15.789628),(5930,'radius-cleaned.tif',183,3,1316,8.7671074,4.8103394,7.3267803,1.8,4.8024011,7.3511366,-0.2818284,1.9153579,2.5864174,10.4751932,18.2640689,0.1130175,7.0615318,5.4690527,10.8958517,3.8692076,5.0597544,0.3292317,15.3792855),(5931,'radius-cleaned.tif',183,3,1317,8.7668957,4.8090693,7.3313991,1.8,4.803231,7.3547609,-0.2809903,1.9112156,2.5835901,10.4850558,18.2686134,0.1123614,7.0710185,5.4860664,10.9173723,3.8582656,5.0603836,0.304296,15.6380483),(5932,'radius-cleaned.tif',183,3,1318,8.7684972,4.8081335,7.3351735,1.8,4.8035514,7.3564125,-0.2839688,1.9236905,2.5827731,10.51411,18.2496783,0.1147123,7.0659239,5.4655933,10.9340361,3.8687023,5.0603836,0.304296,15.7839568),(5933,'radius-cleaned.tif',183,3,1319,8.776331,4.8056657,7.3403452,1.8,4.7983405,7.3611912,-0.2832231,1.9146473,2.5786779,10.5228004,18.2669122,0.1142287,7.0838285,5.4959472,10.9653797,3.86135,5.0533001,0.371709,15.657411),(5934,'radius-cleaned.tif',183,3,1320,8.7803458,4.8049401,7.3457142,1.8,4.8006385,7.3691051,-0.2850797,1.9209284,2.5771594,10.5457834,18.2802323,0.1157433,7.0931711,5.489941,10.995592,3.8740105,5.0523549,0.4318562,15.5445567),(5935,'radius-cleaned.tif',183,3,1321,8.7910485,4.800697,7.3497905,1.8,4.7931,7.3721738,-0.2857191,1.9182404,2.572171,10.5797525,18.2902643,0.1163905,7.1108275,5.5153425,10.9063248,3.8638622,5.0523549,0.4318562,15.8597466),(5936,'radius-cleaned.tif',183,3,1322,8.7935426,4.7984712,7.35262,1.8,4.7912138,7.3718975,-0.2863957,1.9319179,2.5694787,10.5954054,18.2822307,0.1169604,7.1151518,5.4843973,10.9236257,3.8776898,5.0559772,0.4142179,15.6243568),(5937,'radius-cleaned.tif',183,3,1323,8.7899958,4.7960975,7.3561898,1.8,4.7883691,7.3733891,-0.2886315,1.9476154,2.566974,10.6113932,18.2429933,0.1186946,7.1068088,5.4484029,10.9581411,3.8780467,5.0559772,0.4142179,15.9161737),(5938,'radius-cleaned.tif',183,3,1324,8.8064853,4.7914381,7.3606378,1.8,4.7804299,7.3785151,-0.2897636,1.9603025,2.5616284,10.6400661,18.2504333,0.1198257,7.1245435,5.4277675,10.9719674,3.8716032,5.0357848,0.4246603,15.5913025),(5939,'radius-cleaned.tif',183,3,1325,8.8118881,4.7877247,7.3637565,1.8,4.7743342,7.3787052,-0.2906918,1.9545324,2.5728461,10.6637209,18.2465362,0.1206468,7.0919657,5.4558937,10.9680411,3.8996188,5.0433664,0.5309218,15.7001466),(5940,'radius-cleaned.tif',183,3,1326,8.8208094,4.7863796,7.3703008,1.8,4.7722587,7.3869714,-0.2949623,1.964506,2.5706938,10.7103049,18.2353822,0.1242392,7.0935645,5.4519075,11.0345068,3.8703001,5.0389452,0.3643313,15.5872924),(5941,'radius-cleaned.tif',183,3,1327,8.8093233,4.7846708,7.3773686,1.8,4.7709397,7.3958725,-0.2948668,1.9548373,2.5669825,10.7219697,18.2040052,0.1239994,7.0915969,5.4848398,10.9726821,3.9242482,5.0389452,0.3643313,15.7428822),(5942,'radius-cleaned.tif',183,3,1328,8.8226232,4.7832841,7.3806471,1.8,4.7699858,7.3953858,-0.2969247,1.9674116,2.5651559,10.7668676,18.2252762,0.1258747,7.1049389,5.4726057,11.0893246,3.923414,5.0389452,0.3643313,15.7565737),(5943,'radius-cleaned.tif',183,3,1329,8.8436664,4.7808207,7.3858574,1.8,4.7658805,7.3982596,-0.2964964,1.9779259,2.5643704,10.805428,18.2400839,0.1258219,7.1128898,5.4630096,11.131587,3.9462441,5.0400509,0.4069708,16.1338619),(5944,'radius-cleaned.tif',183,3,1330,8.8436102,4.7801227,7.3904826,1.8,4.7680564,7.4015062,-0.3001425,1.9857555,2.5626405,10.8076775,18.2173491,0.1288406,7.1088197,5.4426025,11.152361,3.9346572,5.0357848,0.4246603,15.7041568),(5945,'radius-cleaned.tif',183,3,1331,8.8481789,4.7773083,7.3972078,1.8,4.7640452,7.4099272,-0.3012188,1.9802785,2.5791214,10.8368529,18.2301698,0.1298052,7.0683645,5.4723882,11.0105903,3.9429496,5.0559772,0.4142179,15.7605839),(5946,'radius-cleaned.tif',183,3,1332,8.8752117,4.7766916,7.4045357,1.8,4.7662579,7.4190353,-0.3033547,1.9879319,2.5769116,10.9136644,18.2749433,0.1319976,7.0918006,5.4899588,11.0766639,3.955681,5.0559772,0.4142179,16.1281907),(5947,'radius-cleaned.tif',183,3,1333,8.8759466,4.774588,7.4106146,1.8,4.7606978,7.4240276,-0.3036248,1.9873382,2.5731559,10.9304132,18.28071,0.1322364,7.1043926,5.5000266,11.1073156,3.9494002,5.0381553,0.5132523,15.8033195),(5948,'radius-cleaned.tif',183,3,1334,8.880937,4.7756885,7.4170042,1.8,4.7643784,7.4333318,-0.3043784,2.0188028,2.5724788,10.9777985,18.2834361,0.1329479,7.1073223,5.4377766,11.1382606,3.9580278,5.0381553,0.5132523,15.8186721),(5949,'radius-cleaned.tif',183,3,1335,8.8795845,4.7753018,7.4228023,1.8,4.7641582,7.4376507,-0.3044755,2.0133635,2.5540743,11.0287435,18.2606889,0.1330099,7.1496311,5.4777707,11.1310781,3.9789429,5.0357848,0.4246603,16.0153365),(5950,'radius-cleaned.tif',183,3,1336,8.8747394,4.7735632,7.4300668,1.8,4.7621331,7.446969,-0.3046908,1.9949329,2.5666081,11.052656,18.2336585,0.1331195,7.1041848,5.5403648,11.311868,3.9742009,5.0357848,0.4246603,15.8033195),(5951,'radius-cleaned.tif',183,3,1337,8.8656406,4.7723746,7.4361766,1.8,4.761614,7.4555308,-0.302404,2.0138497,2.5631225,11.0666705,18.2267961,0.1310554,7.1111686,5.4952812,11.2092563,3.9789429,5.0308823,0.3819791,16.0387093),(5952,'radius-cleaned.tif',183,3,1338,8.8720825,4.7706666,7.4399259,1.8,4.7594308,7.4561945,-0.3039586,2.0246665,2.584609,11.0950862,18.2369947,0.1324606,7.0559976,5.4799575,11.2393048,3.9850073,5.0533001,0.371709,15.7468924),(5953,'radius-cleaned.tif',183,3,1339,8.8690573,4.7676771,7.4471595,1.8,4.7536917,7.4667301,-0.3043221,2.0044034,2.5796978,11.0989515,18.2757606,0.1327225,7.0844581,5.5372843,11.28416,3.9868198,5.0533001,0.371709,15.9121636),(5954,'radius-cleaned.tif',183,3,1340,8.8708856,4.7665349,7.4546082,1.8,4.7531886,7.4772739,-0.3098498,2.0164043,2.5779132,11.148911,18.2786376,0.1374596,7.0904782,5.5291049,11.3219347,3.9848752,5.0533001,0.371709,15.949228),(5955,'radius-cleaned.tif',183,3,1341,8.8749376,4.7643288,7.4606266,1.8,4.7502409,7.4828387,-0.3098188,2.0158535,2.5739688,11.1978313,18.2795915,0.1374958,7.1017146,5.5548835,11.3631225,4.000042,5.0458911,0.3893167,15.764594),(5956,'radius-cleaned.tif',183,3,1342,8.8882773,4.7629695,7.462476,1.8,4.7474071,7.4805324,-0.3102236,2.0524548,2.5707629,11.2276976,18.2896154,0.1380508,7.1144699,5.470375,11.3522036,4.0299001,5.0559772,0.4142179,15.9862924),(5957,'radius-cleaned.tif',183,3,1343,8.8737273,4.7638696,7.4687304,1.8,4.7512815,7.4869183,-0.3081766,2.0602968,2.5689202,11.2453204,18.2463752,0.1360697,7.102741,5.4581071,11.3492923,4.0391181,5.0559772,0.4142179,15.6243568),(5958,'radius-cleaned.tif',183,3,1344,8.8684967,4.763762,7.4735998,1.8,4.751393,7.4907685,-0.3104265,2.0537825,2.5681985,11.2555199,18.2400164,0.137918,7.102261,5.4803855,11.2669237,4.0383734,5.0381553,0.5132523,15.9258551),(5959,'radius-cleaned.tif',183,3,1345,8.8705491,4.7600604,7.4808465,1.8,4.7472169,7.4994462,-0.3120393,2.0613511,2.563058,11.2820878,18.2577618,0.1393402,7.123429,5.4731519,11.3146159,4.0299001,5.0381553,0.5132523,15.7565737),(5960,'radius-cleaned.tif',183,3,1346,8.8765434,4.7582971,7.4871031,1.8,4.7443599,7.5049032,-0.3141146,2.0546156,2.5744619,11.3193763,18.2789503,0.1412335,7.1001051,5.5092429,11.3427392,4.0299001,5.0509367,0.4848458,16.1144992),(5961,'radius-cleaned.tif',183,3,1347,8.874891,4.7570499,7.4938134,1.8,4.7438628,7.5129987,-0.3140503,2.0372679,2.5711937,11.3406096,18.2800593,0.1411514,7.1095614,5.5665776,11.3708663,4.0255062,5.0509367,0.4848458,15.9822822),(5962,'radius-cleaned.tif',183,3,1348,8.8629395,4.7560856,7.499793,1.8,4.7444264,7.5186771,-0.309966,2.0404165,2.5663814,11.336623,18.2808308,0.1374362,7.1231934,5.5560338,11.2104454,3.9900001,5.0509367,0.4848458,16.0483907),(5963,'radius-cleaned.tif',183,3,1349,8.8717109,4.7531806,7.5037576,1.8,4.7409825,7.5203694,-0.3093371,2.0510999,2.5728181,11.3750537,18.3071171,0.1370324,7.1155894,5.5458312,11.3524677,3.9900001,5.0559772,0.4142179,15.9064924),(5964,'radius-cleaned.tif',183,3,1350,8.8619223,4.7512687,7.5106819,1.8,4.7367935,7.5295446,-0.3078393,2.0431206,2.5682486,11.3580352,18.3072825,0.1356009,7.1283141,5.5591604,11.2720414,3.9900001,5.0559772,0.4142179,16.0717636),(5965,'radius-cleaned.tif',183,3,1351,8.8777081,4.7503161,7.5167026,1.8,4.7370436,7.536923,-0.3110886,2.0520995,2.5804393,11.4181387,18.3458984,0.1386317,7.1096028,5.5641253,11.3230965,3.988727,5.0677714,0.4566055,15.9685907),(5966,'radius-cleaned.tif',183,3,1352,8.9117163,4.749615,7.5228953,1.8,4.7352184,7.5426566,-0.313141,2.0601585,2.5796179,11.4968407,18.3934449,0.1409445,7.1302983,5.5805612,11.3877841,4.0138816,5.0536151,0.5024973,16.1241806),(5967,'radius-cleaned.tif',183,3,1353,8.9036583,4.7500638,7.5274135,1.8,4.7375901,7.5448318,-0.3114902,2.069098,2.5783424,11.5235188,18.373097,0.1393845,7.1259337,5.569344,11.3987995,4.0277886,5.0536151,0.5024973,16.1144992),(5968,'radius-cleaned.tif',183,3,1354,8.9024489,4.7490191,7.5351821,1.8,4.7356718,7.5575129,-0.3139814,2.0856972,2.5754154,11.5480284,18.3734695,0.1415296,7.1341771,5.5367712,11.4298252,4.0672306,5.0536151,0.5024973,15.657411),(5969,'radius-cleaned.tif',183,3,1355,8.9037099,4.7471122,7.5382137,1.8,4.7326222,7.5566398,-0.3134084,2.072036,2.5971676,11.5899475,18.3683771,0.1410505,7.072465,5.5935068,11.3235964,4.0698001,5.077814,0.5269432,15.7138381),(5970,'radius-cleaned.tif',183,3,1356,8.9119926,4.7481916,7.5467989,1.8,4.7355848,7.5685526,-0.3144547,2.1015248,2.5711188,11.6506872,18.3695347,0.1420946,7.1445687,5.5439208,11.363717,4.0698001,5.077814,0.5269432,16.1322009),(5971,'radius-cleaned.tif',183,3,1357,8.9126523,4.7455423,7.5520156,1.8,4.7300708,7.5735394,-0.3158226,2.0966797,2.5672032,11.6713016,18.3655402,0.1433027,7.1539098,5.566564,11.3920148,4.0698001,5.077814,0.5269432,16.0427195),(5972,'radius-cleaned.tif',183,3,1358,8.9137361,4.7455855,7.5576591,1.8,4.7324218,7.5809387,-0.3150449,2.0796605,2.5892534,11.7045307,18.3510226,0.1426386,7.08738,5.628097,11.4125137,4.0672306,5.077814,0.5269432,15.7275296),(5973,'radius-cleaned.tif',183,3,1359,8.9098129,4.7442803,7.5607459,1.8,4.7314833,7.5822879,-0.3156243,2.0902871,2.5872601,11.7263568,18.3296334,0.1430832,7.0845731,5.6099263,11.4248121,4.0698001,5.077814,0.5269432,15.9726009),(5974,'radius-cleaned.tif',183,3,1360,8.9127292,4.7410214,7.5677901,1.8,4.7256322,7.5922465,-0.3159405,2.1225004,2.5820849,11.7717796,18.3131408,0.1434074,7.0923853,5.5461848,11.4646192,4.1097001,5.0559772,0.4142179,16.3579093),(5975,'radius-cleaned.tif',183,3,1361,8.9164511,4.7393838,7.5720432,1.8,4.725026,7.5952739,-0.3139014,2.1068377,2.5785048,11.7833033,18.3364846,0.1416824,7.1112858,5.5928862,11.4745286,4.1052556,5.0677714,0.4566055,15.8033195),(5976,'radius-cleaned.tif',183,3,1362,8.9248956,4.7356748,7.5788263,1.8,4.7198524,7.6049672,-0.3159307,2.1136726,2.5735705,11.8416368,18.3465464,0.1435945,7.1288298,5.6023989,11.5296794,4.0698001,5.0691848,0.4390047,15.7275296),(5977,'radius-cleaned.tif',183,3,1363,8.9231961,4.7369315,7.5854224,1.8,4.7235623,7.6136518,-0.3172988,2.1317861,2.5861749,11.8996347,18.3388771,0.1447712,7.0911203,5.5820023,11.5587425,4.0698001,5.0509367,0.4848458,16.0387093),(5978,'radius-cleaned.tif',183,3,1364,8.9200751,4.7374696,7.5915428,1.8,4.7257657,7.6204031,-0.3158449,2.1506103,2.5960852,11.9531381,18.3219533,0.1434416,7.0575316,5.5580215,11.5259221,4.0698001,5.0691848,0.4390047,15.9105025),(5979,'radius-cleaned.tif',183,3,1365,8.9121874,4.7366863,7.5973072,1.8,4.7262593,7.6264649,-0.3149011,2.1576685,2.5931765,11.9880804,18.2891241,0.1424881,7.0527879,5.5560344,11.5412184,4.0698001,5.0691848,0.4390047,15.8500652),(5980,'radius-cleaned.tif',183,3,1366,8.9244874,4.7346388,7.6050135,1.8,4.7216635,7.6377892,-0.3174458,2.1642479,2.5898278,12.0647204,18.293557,0.1449218,7.063619,5.5745556,11.5955039,4.1097001,5.0677714,0.4566055,15.8831195),(5981,'radius-cleaned.tif',183,3,1367,8.9192861,4.7332139,7.6125056,1.8,4.7200683,7.6459374,-0.3214191,2.1702452,2.5876134,12.1048541,18.2952425,0.1483593,7.0703152,5.5776435,11.5589158,4.1097001,5.0677714,0.4566055,15.8734381),(5982,'radius-cleaned.tif',183,3,1368,8.9014148,4.7325661,7.6168835,1.8,4.719784,7.6487421,-0.3217105,2.1663113,2.5857214,12.1178852,18.2557165,0.1483213,7.0602024,5.5937876,11.4513336,4.1097001,5.0698129,0.6120155,16.3111636),(5983,'radius-cleaned.tif',183,3,1369,8.9000321,4.7307669,7.6254529,1.8,4.7176925,7.6614457,-0.3205864,2.1712597,2.593625,12.1625845,18.2760214,0.1472994,7.0465165,5.6016259,11.5694076,4.1097001,5.0886191,0.4987209,16.5699263),(5984,'radius-cleaned.tif',183,3,1370,8.8965372,4.7299053,7.6300764,1.8,4.7151606,7.663352,-0.3232057,2.1927387,2.5920357,12.2048891,18.2790192,0.1495727,7.0519935,5.5660481,11.600351,4.1097001,5.077814,0.5269432,16.1281907),(5985,'radius-cleaned.tif',183,3,1371,8.8794534,4.7291414,7.6383981,1.8,4.7160911,7.6743391,-0.3221909,2.1849151,2.5884682,12.2172974,18.2363937,0.1483821,7.0452454,5.5916579,11.6105643,4.1097001,5.0536151,0.5024973,15.7178483),(5986,'radius-cleaned.tif',183,3,1372,8.8775082,4.7269761,7.6463664,1.8,4.7134801,7.6838575,-0.3278802,2.1918723,2.5859688,12.2855785,18.2581634,0.1534444,7.0604731,5.6050614,11.6712546,4.1496001,5.0536151,0.5024973,15.817011),(5987,'radius-cleaned.tif',183,3,1373,8.8629375,4.7286705,7.652818,1.8,4.7206421,7.6930149,-0.3256436,2.1970296,2.5847034,12.3033621,18.242543,0.1511839,7.0578865,5.5999984,11.6801817,4.1097001,5.0536151,0.5024973,16.3732619),(5988,'radius-cleaned.tif',183,3,1374,8.8683528,4.7279914,7.6580555,1.8,4.7198343,7.6980555,-0.3230678,2.2172946,2.5814686,12.3361044,18.2583057,0.1489761,7.0728366,5.5635839,11.7327882,4.1097001,5.0509367,0.4848458,16.0660924),(5989,'radius-cleaned.tif',183,3,1375,8.8726139,4.7270021,7.6659013,1.8,4.7210242,7.7078633,-0.3239042,2.2481671,2.6034592,12.3984371,18.2608565,0.1497932,7.0140744,5.514909,11.6994402,4.1414862,5.0677714,0.4566055,16.108828),(5990,'radius-cleaned.tif',183,3,1376,8.8464135,4.7256001,7.6717218,1.8,4.7181923,7.7169117,-0.3239882,2.2179901,2.6003023,12.3897633,18.2349955,0.1494256,7.0126445,5.5860319,11.7029431,4.1097001,5.0677714,0.4566055,16.2587466),(5991,'radius-cleaned.tif',183,3,1377,8.8318415,4.7250828,7.6755753,1.8,4.7185315,7.7191837,-0.3229134,2.2394094,2.5982716,12.3953453,18.2152869,0.1482259,7.0105399,5.5350956,11.6797319,4.139398,5.0729521,0.5093903,16.0894652),(5992,'radius-cleaned.tif',183,3,1378,8.8617604,4.7223288,7.68488,1.8,4.7112066,7.7326389,-0.327339,2.2323499,2.5939437,12.4825824,18.3036689,0.1526852,7.0563093,5.5916783,11.7135296,4.1496001,5.0886191,0.4987209,16.3248551),(5993,'radius-cleaned.tif',183,3,1379,8.86699,4.7189372,7.6897092,1.8,4.7047022,7.7342443,-0.3289821,2.2291949,2.5896199,12.5115471,18.3045215,0.154257,7.0684201,5.6125856,11.7486863,4.1496001,5.0886191,0.4987209,15.7315398),(5994,'radius-cleaned.tif',183,3,1380,8.8521242,4.7208069,7.695035,1.8,4.7099656,7.7418416,-0.3290472,2.2364568,2.5906063,12.5188667,18.2823946,0.1540571,7.0571876,5.597634,11.7474305,4.1496001,5.077814,0.5269432,16.0660924),(5995,'radius-cleaned.tif',183,3,1381,8.8326823,4.7197956,7.7007286,1.8,4.7093607,7.7483794,-0.335127,2.2327994,2.6146367,12.5433708,18.2280222,0.1592357,6.9715314,5.6177778,11.6845928,4.1496001,5.0677714,0.4566055,16.0701025),(5996,'radius-cleaned.tif',183,3,1382,8.8392639,4.7190013,7.7044754,1.8,4.7094388,7.7484513,-0.3325674,2.2536238,2.6118488,12.5903922,18.2386256,0.1570195,6.9830327,5.586732,11.7169656,4.1625376,5.0677714,0.4566055,16.2216822),(5997,'radius-cleaned.tif',183,3,1383,8.8419361,4.7176166,7.7126939,1.8,4.7075308,7.7600592,-0.3336138,2.2465001,2.6081806,12.6130213,18.2628563,0.1580199,7.0021442,5.6145208,11.7563937,4.1425048,5.0677714,0.4566055,16.1555737),(5998,'radius-cleaned.tif',183,3,1384,8.8514527,4.7170203,7.7187746,1.8,4.7105094,7.7669755,-0.33475,2.2673759,2.6059679,12.6795497,18.2553682,0.1592287,7.005216,5.5921692,11.7931659,4.1496001,5.0677714,0.4566055,16.3345365),(5999,'radius-cleaned.tif',183,3,1385,8.8472804,4.7143758,7.7220759,1.8,4.7070755,7.7701659,-0.3344348,2.2666445,2.6022918,12.68115,18.2728117,0.1588654,7.021815,5.5946798,11.8176133,4.1496001,5.0509367,0.4848458,15.9903025),(6000,'radius-cleaned.tif',183,3,1386,8.8428216,4.7124526,7.7249516,1.8,4.7079188,7.7726927,-0.3346624,2.2761244,2.6012277,12.679479,18.2555359,0.1589933,7.0180462,5.5706441,11.7200332,4.1496001,5.0842372,0.5444572,16.1749365),(6001,'radius-cleaned.tif',183,3,1387,8.8591143,4.7109343,7.7295649,1.8,4.7064136,7.7752777,-0.3406222,2.2764258,2.6007216,12.7254311,18.2822283,0.1647872,7.0296752,5.5900927,11.7637666,4.1496001,5.0842372,0.5444572,16.4103263),(6002,'radius-cleaned.tif',183,3,1388,8.8567093,4.7082642,7.7340828,1.8,4.7036415,7.7802947,-0.3415309,2.2843099,2.597057,12.7450089,18.2739956,0.1655881,7.0364246,5.5793694,11.8071032,4.166714,5.0800082,0.5727532,16.3619195),(6003,'radius-cleaned.tif',183,3,1389,8.8634147,4.7059333,7.7403979,1.8,4.7011253,7.7870217,-0.3463481,2.2911718,2.5946005,12.7909263,18.2865985,0.1702314,7.0479438,5.5827006,11.8521087,4.1736647,5.0800082,0.5727532,16.1652551),(6004,'radius-cleaned.tif',183,3,1390,8.8407644,4.7074173,7.7456326,1.8,4.7060718,7.7925065,-0.3446615,2.2853423,2.593586,12.7939102,18.2387376,0.1682127,7.0322471,5.5982467,11.8358549,4.1459856,5.0698129,0.6120155,16.3716009),(6005,'radius-cleaned.tif',183,3,1391,8.8598483,4.7058826,7.75422,1.8,4.7017184,7.8023324,-0.3473447,2.2920086,2.6005771,12.8804566,18.2699725,0.171104,7.0253531,5.6197244,11.9094411,4.1895001,5.0509367,0.4848458,16.4473907),(6006,'radius-cleaned.tif',183,3,1392,8.8601189,4.7057888,7.7587278,1.8,4.7016334,7.8045989,-0.3465685,2.2740328,2.5987438,12.9202508,18.2577085,0.1703761,7.02559,5.6816467,11.9301123,4.1496001,5.0509367,0.4848458,16.4086653),(6007,'radius-cleaned.tif',183,3,1393,8.8713153,4.7035793,7.7645905,1.8,4.6971099,7.8081448,-0.3463404,2.2963018,2.5946131,12.9752288,18.2746962,0.170376,7.0433222,5.6504894,11.9791262,4.1496001,5.0433664,0.6450834,16.136211),(6008,'radius-cleaned.tif',183,3,1394,8.8694507,4.7031503,7.7735897,1.8,4.6972117,7.8197828,-0.3506907,2.2930256,2.5922611,12.9958555,18.2638137,0.1744684,7.0455146,5.6675579,11.8991097,4.1496001,5.0636858,0.5377168,16.1829568),(6009,'radius-cleaned.tif',183,3,1395,8.8632854,4.700484,7.777676,1.8,4.6941152,7.8208249,-0.3515189,2.3004549,2.60605,13.0104201,18.2537942,0.1751373,7.0043915,5.6555857,11.8529635,4.178886,5.077814,0.5269432,16.0894652),(6010,'radius-cleaned.tif',183,3,1396,8.8726964,4.7007598,7.7831346,1.8,4.6963491,7.8252141,-0.3534316,2.3057256,2.6051934,13.067324,18.2621038,0.1771561,7.009884,5.667337,11.8885157,4.1771455,5.077814,0.5269432,16.3248551),(6011,'radius-cleaned.tif',183,3,1397,8.8832784,4.6980353,7.7901269,1.8,4.6917667,7.8310245,-0.3574197,2.3056586,2.6112171,13.1260013,18.2640909,0.1812199,6.9944744,5.6929509,11.9376345,4.1895001,5.077814,0.5269432,16.2877907),(6012,'radius-cleaned.tif',183,3,1398,8.8823623,4.6966887,7.7981999,1.8,4.6915108,7.8412649,-0.3585575,2.4109503,2.6074539,13.1628418,18.2686495,0.1823068,7.0063172,5.4596072,11.9764363,4.1895001,5.077814,0.5269432,16.2353737),(6013,'radius-cleaned.tif',183,3,1399,8.8953515,4.6949658,7.8057139,1.8,4.6900875,7.8520136,-0.36225,2.4314782,2.6273752,13.2089803,18.3394082,0.1861865,6.9801252,5.4324897,11.9676644,4.1895001,5.0886191,0.4987209,16.3385466),(6014,'radius-cleaned.tif',183,3,1400,8.9043187,4.6941337,7.8119539,1.8,4.688523,7.8600645,-0.3608946,2.4246168,2.6240999,13.2471211,18.3569223,0.185043,6.9955121,5.4635936,12.0043757,4.1496001,5.077814,0.5269432,16.348228),(6015,'radius-cleaned.tif',183,3,1401,8.9214003,4.6906938,7.8151186,1.8,4.6843034,7.8588611,-0.3622264,2.4473467,2.6200428,13.289042,18.3691272,0.1867084,7.0110026,5.4299793,12.0453507,4.1895001,5.0536151,0.5024973,16.0370483),(6016,'radius-cleaned.tif',183,3,1402,8.9115643,4.6876944,7.818932,1.8,4.6803531,7.8604055,-0.3644242,2.4468822,2.6163309,13.2815105,18.3640985,0.1886713,7.0190274,5.4279322,12.0516421,4.1827705,5.0636858,0.5377168,15.9943127),(6017,'radius-cleaned.tif',183,3,1403,8.911785,4.6890494,7.8261289,1.8,4.6847754,7.8701978,-0.367769,2.4427591,2.621464,13.3194446,18.3563788,0.1919971,7.0023387,5.4526231,11.9999925,4.1895001,5.0837675,0.6293733,16.2724381),(6018,'radius-cleaned.tif',183,3,1404,8.9241888,4.6891675,7.8299049,1.8,4.6835578,7.8727264,-0.3694731,2.313447,2.6207339,13.3650365,18.3811081,0.1939682,7.0137255,5.7771095,12.0341758,4.1895001,5.0837675,0.6293733,15.9709398),(6019,'radius-cleaned.tif',183,3,1405,8.9238044,4.6880928,7.834652,1.8,4.6820781,7.875024,-0.3709942,2.4381105,2.6184666,13.4014613,18.3603958,0.195486,7.0118885,5.4966586,12.0545598,4.1895001,5.0837675,0.6293733,16.1966483),(6020,'radius-cleaned.tif',183,3,1406,8.926937,4.6872185,7.8383686,1.8,4.6800068,7.8786003,-0.3713616,2.3151754,2.6164109,13.4136628,18.3781193,0.1959243,7.0241718,5.7937999,12.0773649,4.1895001,5.0837675,0.6293733,16.507828),(6021,'radius-cleaned.tif',183,3,1407,8.9088836,4.687379,7.8439093,1.8,4.6812299,7.8846832,-0.3700192,2.3095776,2.6141662,13.3897668,18.3858228,0.194182,7.0331499,5.7974959,12.0823153,4.1895001,5.0837675,0.6293733,16.3522381),(6022,'radius-cleaned.tif',183,3,1408,8.9124958,4.6859341,7.8462898,1.8,4.680272,7.884027,-0.3659338,2.3122734,2.6107689,13.4268592,18.3670391,0.190187,7.0351073,5.8067783,12.1002267,4.1895001,5.0837675,0.6293733,16.3659296),(6023,'radius-cleaned.tif',183,3,1409,8.9141357,4.6862765,7.8510205,1.8,4.6824112,7.8919527,-0.3674063,2.3169243,2.6098229,13.4852037,18.3590865,0.1916863,7.0346101,5.820304,12.1280494,4.1895001,5.0837675,0.6293733,16.4981466),(6024,'radius-cleaned.tif',183,3,1410,8.9067689,4.6849532,7.8550233,1.8,4.6793731,7.898395,-0.3699646,2.3228505,2.6078702,13.4984796,18.3662988,0.1940812,7.0426431,5.8111702,12.1497932,4.2294001,5.0837675,0.6293733,16.428028),(6025,'radius-cleaned.tif',183,3,1411,8.9175082,4.6847315,7.8593357,1.8,4.6800117,7.903156,-0.3703627,2.325136,2.6123444,13.5035615,18.4228652,0.1947144,7.0522346,5.8076437,12.0811375,4.1895001,5.0698129,0.6120155,16.5175093),(6026,'radius-cleaned.tif',183,3,1412,8.9303921,4.6820308,7.8644186,1.8,4.674107,7.9071635,-0.3730506,2.3304281,2.6316542,13.5403593,18.4649547,0.1977034,7.016482,5.8102456,12.0633304,4.1895001,5.0837675,0.6293733,16.4417195),(6027,'radius-cleaned.tif',183,3,1413,8.9403657,4.6808514,7.8685728,1.8,4.6716323,7.9110237,-0.3706637,2.4749109,2.628239,13.5879104,18.489802,0.1955162,7.0350536,5.4902626,12.0276171,4.1895001,5.0837675,0.6293733,16.5932992),(6028,'radius-cleaned.tif',183,3,1414,8.9501382,4.6797894,7.8722835,1.8,4.6711396,7.9131963,-0.3692056,2.3372343,2.6254116,13.6253503,18.5192242,0.1942636,7.0538366,5.8296895,12.1420574,4.1895001,5.0837675,0.6293733,16.3288653),(6029,'radius-cleaned.tif',183,3,1415,8.9477485,4.6794774,7.8805397,1.8,4.672741,7.9235132,-0.3688713,2.5081183,2.6304729,13.6884727,18.5026434,0.1938763,7.0339608,5.4576662,12.0795218,4.2294001,5.0917467,0.6576068,16.5642551),(6030,'radius-cleaned.tif',183,3,1416,8.9515998,4.6778176,7.8865257,1.8,4.6709273,7.9301083,-0.3720747,2.3401091,2.6193625,13.7322931,18.536975,0.1971856,7.0769033,5.8682278,12.2284724,4.2294001,5.0917467,0.6576068,16.2490653),(6031,'radius-cleaned.tif',183,3,1417,8.948987,4.6765674,7.8905295,1.8,4.6696112,7.9331506,-0.3681664,2.3412474,2.6154835,13.7619269,18.5464933,0.1931964,7.0910382,5.878032,12.2572286,4.2294001,5.0917467,0.6576068,16.3425568),(6032,'radius-cleaned.tif',183,3,1418,8.9822341,4.6760558,7.8972298,1.8,4.6688979,7.9431868,-0.36983,2.5318581,2.6214833,13.9000571,18.5838129,0.1955898,7.0890449,5.4900618,12.0994077,4.2693001,5.0917467,0.6576068,17.1655907),(6033,'radius-cleaned.tif',183,3,1419,8.9895555,4.6745762,7.9036756,1.8,4.6661061,7.9514845,-0.3637008,2.3627766,2.6163613,13.9149535,18.6289197,0.1896012,7.1201632,5.8892379,12.2724314,4.2693001,5.1025222,0.6075229,16.7569094),(6034,'radius-cleaned.tif',183,3,1420,8.999682,4.6752735,7.9094619,1.8,4.6683001,7.9580546,-0.3623611,2.5281007,2.619763,13.9978651,18.6590507,0.1884806,7.1224194,5.5369097,12.0851798,4.2294001,5.1025222,0.6075229,17.146228),(6035,'radius-cleaned.tif',183,3,1421,8.9876333,4.6740389,7.9145865,1.8,4.6667934,7.9608951,-0.3535429,2.5152068,2.6135328,13.9977911,18.6664423,0.1795593,7.142226,5.5652644,12.1014161,4.2294001,5.0917467,0.6576068,16.9011568),(6036,'radius-cleaned.tif',183,3,1422,9.0042209,4.6729598,7.921329,1.8,4.6670977,7.9677691,-0.3619498,2.5315575,2.6132477,14.0646474,18.7069059,0.1881667,7.1584892,5.555729,12.0414624,4.2693001,5.0917467,0.6576068,16.6867907),(6037,'radius-cleaned.tif',183,3,1423,9.0079399,4.6707044,7.9263134,1.8,4.6648329,7.9734909,-0.3616623,2.5274062,2.6133217,14.0997223,18.7048671,0.1879586,7.1575066,5.5787322,12.063203,4.2693001,5.0917467,0.6576068,17.3776077),(6038,'radius-cleaned.tif',183,3,1424,9.0145862,4.6673384,7.9280219,1.8,4.6577207,7.969851,-0.3598316,2.5018556,2.6281709,14.1195707,18.6936917,0.1862806,7.1128145,5.6436394,12.0704322,4.2693001,5.0917467,0.6576068,16.4884653),(6039,'radius-cleaned.tif',183,3,1425,9.0182002,4.6644317,7.9301062,1.8,4.6531471,7.967908,-0.3611716,2.5023556,2.6251189,14.1361786,18.6836974,0.1876848,7.1172768,5.6491485,12.0706439,4.2693001,5.0917467,0.6576068,16.8600822),(6040,'radius-cleaned.tif',183,3,1426,9.0211501,4.664245,7.935606,1.8,4.6555299,7.9740049,-0.3603102,2.5428989,2.622747,14.1835446,18.6905355,0.1868908,7.1263205,5.5777068,12.0867717,4.2693001,5.0848634,0.6686136,16.5312009),(6041,'radius-cleaned.tif',183,3,1427,9.0280225,4.6630027,7.9413246,1.8,4.6549881,7.9819131,-0.3617468,2.5393739,2.6290592,14.2720058,18.7001232,0.1884619,7.1128575,5.6202854,12.1382707,4.3078474,5.0753052,0.6403565,16.7609195),(6042,'radius-cleaned.tif',183,3,1428,9.0275604,4.6603814,7.9468907,1.8,4.6503343,7.9874181,-0.3610246,2.5111614,2.6435449,14.3042182,18.70162,0.1877334,7.0744476,5.696256,12.173723,4.3092001,5.112808,0.5966604,17.0624178),(6043,'radius-cleaned.tif',183,3,1429,9.0452037,4.6571651,7.9516894,1.8,4.6455224,7.9917857,-0.3625621,2.4862292,2.6393851,14.3711358,18.743128,0.1896349,7.1013236,5.780294,12.2261364,4.3092001,5.1160764,0.6247825,17.1171839),(6044,'radius-cleaned.tif',183,3,1430,9.0506211,4.6549766,7.9555402,1.8,4.6438244,7.9947758,-0.3612541,2.481993,2.6396507,14.4069467,18.7374274,0.1884419,7.0984495,5.804588,12.2428386,4.2693001,5.0917467,0.6576068,16.8504009),(6045,'radius-cleaned.tif',183,3,1431,9.0724804,4.6533607,7.9574601,1.8,4.642598,7.9923485,-0.3618869,2.5278322,2.6426092,14.4813033,18.7853695,0.1895301,7.1086446,5.728744,12.2721336,4.2693001,5.0917467,0.6576068,16.4457297),(6046,'radius-cleaned.tif',183,3,1432,9.0924536,4.6519916,7.9620502,1.8,4.6413822,7.9965467,-0.3647752,2.5038084,2.6404355,14.5526371,18.8288134,0.1928554,7.1309501,5.8122007,12.3366636,4.3092001,5.0917467,0.6576068,17.2510619),(6047,'radius-cleaned.tif',183,3,1433,9.0906612,4.6501117,7.9678238,1.8,4.6392874,8.0022883,-0.3664714,2.5380791,2.6599845,14.5729442,18.8541828,0.1945336,7.0880801,5.7417219,12.2348124,4.3092001,5.1037701,0.6857295,16.694811),(6048,'radius-cleaned.tif',183,3,1434,9.1123345,4.6486684,7.9743208,1.8,4.639136,8.0098658,-0.3626223,2.5749085,2.6555839,14.6588774,18.9216998,0.1911029,7.1252501,5.6929701,12.2784042,4.3092001,5.1037701,0.6857295,17.0100009),(6049,'radius-cleaned.tif',183,3,1435,9.1372873,4.6467696,7.9768891,1.8,4.6367656,8.0089098,-0.3605875,2.5480381,2.652502,14.7293566,18.9493181,0.1895756,7.1439411,5.7806657,12.334699,4.3092001,5.1160764,0.6247825,16.8971466),(6050,'radius-cleaned.tif',183,3,1436,9.1415849,4.643691,7.9823497,1.8,4.6336941,8.015392,-0.3577147,2.5645759,2.6516659,14.796758,18.9736998,0.1867841,7.1553885,5.7696705,12.3607672,4.3092001,5.1311463,0.6419459,17.2647535),(6051,'radius-cleaned.tif',183,3,1437,9.1467481,4.6419139,7.9879325,1.8,4.6319561,8.0210973,-0.3509606,2.567242,2.6458101,14.8669535,18.9987433,0.1801886,7.1806906,5.7910214,12.2914877,4.3491001,5.1233839,0.6528466,17.0196822),(6052,'radius-cleaned.tif',183,3,1438,9.1262754,4.6416357,7.9939523,1.8,4.6343516,8.0272507,-0.3499247,2.5231629,2.6431313,14.8602925,18.9984529,0.1787691,7.1878582,5.8895494,12.4429277,4.3467011,5.1037701,0.6857295,16.986628),(6053,'radius-cleaned.tif',183,3,1439,9.1399097,4.640128,8.0017013,1.8,4.6324682,8.039324,-0.3575,2.5988321,2.6509388,14.947707,19.0683466,0.1865355,7.1930542,5.7517018,12.2534237,4.3491001,5.0917467,0.6576068,17.6540721),(6054,'radius-cleaned.tif',183,3,1440,9.1337356,4.6377697,8.0083303,1.8,4.6305631,8.0485348,-0.356993,2.5929499,2.6462998,14.9898546,19.0693734,0.1859038,7.2060517,5.7810043,12.2842072,4.343424,5.0917467,0.6576068,16.9963094),(6055,'radius-cleaned.tif',183,3,1441,9.1512977,4.6358004,8.0130009,1.8,4.6277446,8.0523943,-0.3584326,2.5906777,2.6431279,15.0750515,19.1338833,0.1877014,7.239106,5.8189606,12.3480618,4.3491001,5.0848634,0.6686136,17.5742721),(6056,'radius-cleaned.tif',183,3,1442,9.1553606,4.6326843,8.0205459,1.8,4.6225212,8.0634871,-0.3605479,2.5867877,2.6569594,15.111026,19.1913103,0.1899106,7.2230349,5.8416182,12.3979024,4.3778611,5.1160764,0.6247825,16.7141737),(6057,'radius-cleaned.tif',183,3,1443,9.17107,4.6307798,8.0234843,1.8,4.6211525,8.0641582,-0.3656069,2.6039223,2.6591294,15.1777757,19.2384046,0.195371,7.2348508,5.8288128,12.3247341,4.3890001,5.107356,0.6356888,16.934211),(6058,'radius-cleaned.tif',183,3,1444,9.182738,4.6290516,8.0312347,1.8,4.6202037,8.0760754,-0.3638938,2.618649,2.6598421,15.2578113,19.2526637,0.1938721,7.2382731,5.8265965,12.3643045,4.3890001,5.1037701,0.6857295,17.1849535),(6059,'radius-cleaned.tif',183,3,1445,9.1814905,4.6279639,8.0343686,1.8,4.6215453,8.0787655,-0.3638977,2.6303125,2.6807973,15.3083515,19.3061003,0.1938498,7.2016264,5.8199745,12.2924484,4.3889121,5.1037701,0.6857295,17.0801195),(6060,'radius-cleaned.tif',183,3,1446,9.1682005,4.6274874,8.0399475,1.8,4.6224066,8.086042,-0.3627778,2.624138,2.6781443,15.3326048,19.3146975,0.1924322,7.2119703,5.8429109,12.3209192,4.3491001,5.1037701,0.6857295,17.1365466),(6061,'radius-cleaned.tif',183,3,1447,9.1809511,4.6261786,8.04373,1.8,4.6219375,8.0860039,-0.3574951,2.6296387,2.6745027,15.4231815,19.3469608,0.1873681,7.2338535,5.8651334,12.2562018,4.4224794,5.1037701,0.6857295,17.1034924),(6062,'radius-cleaned.tif',183,3,1448,9.1736531,4.6253422,8.0485117,1.8,4.6219479,8.0891924,-0.3516629,2.6191845,2.670796,15.4569594,19.3482913,0.1814125,7.2443913,5.9014398,12.2813752,4.4108713,5.1037701,0.6857295,18.2280247),(6063,'radius-cleaned.tif',183,3,1449,9.1915879,4.6255534,8.0531709,1.8,4.6247183,8.0944951,-0.3533502,2.6165625,2.6697528,15.5666673,19.3941727,0.1834422,7.2644076,5.9492816,12.3518402,4.4183778,5.116232,0.6637791,17.5372077),(6064,'radius-cleaned.tif',183,3,1450,9.2022417,4.6252721,8.0583856,1.8,4.6247643,8.0995945,-0.3454775,2.6166852,2.67648,15.6183236,19.4662322,0.1758872,7.2730721,5.9687437,12.2931106,4.3890001,5.116232,0.6637791,17.1792822),(6065,'radius-cleaned.tif',183,3,1451,9.211644,4.624894,8.0623343,1.8,4.624416,8.1006787,-0.3417993,2.6197273,2.6742644,15.709564,19.4782626,0.1724843,7.2835965,5.9966409,12.3405876,4.4289001,5.116232,0.6637791,17.2026551),(6066,'radius-cleaned.tif',183,3,1452,9.2212975,4.6224482,8.0695115,1.8,4.6213786,8.1108411,-0.3423993,2.627821,2.6722438,15.7833577,19.5391339,0.1732478,7.311883,6.0062529,12.2840221,4.4289001,5.1241606,0.7027142,17.2357094),(6067,'radius-cleaned.tif',183,3,1453,9.2300074,4.6193543,8.0747014,1.8,4.6179096,8.1155118,-0.3365846,2.6174868,2.6905034,15.8562816,19.606765,0.1677941,7.2873965,6.0578267,12.339633,4.4289001,5.2218721,2.2479239,18.6600789),(6068,'radius-cleaned.tif',183,3,1454,9.2229352,4.616776,8.0808406,1.8,4.6162429,8.1226573,-0.3337408,2.6223979,2.6854015,15.8791496,19.6128573,0.1649499,7.3035102,6.0552022,12.3556715,4.4289001,5.1037701,0.6857295,17.8330348),(6069,'radius-cleaned.tif',183,3,1455,9.2182434,4.6131062,8.0850173,1.8,4.6111873,8.1248907,-0.331785,2.6303431,2.6801181,15.9189558,19.620463,0.1630105,7.3207457,6.0520455,12.2569974,4.4289001,5.2414996,2.2645599,18.3448891),(6070,'radius-cleaned.tif',183,3,1456,9.2117146,4.6102926,8.0897741,1.8,4.6065848,8.1283207,-0.3345634,2.6301535,2.6880166,15.9418347,19.6137849,0.1655317,7.2967499,6.0611804,12.2688147,4.3890001,5.0862721,0.7298997,17.3155094),(6071,'radius-cleaned.tif',183,3,1457,9.2292398,4.6071946,8.0928555,1.8,4.6027689,8.1275899,-0.3389739,2.6314464,2.7000674,16.0154159,19.6679039,0.1700784,7.2842269,6.0861647,12.4316064,4.403163,5.1037701,0.6857295,17.146228),(6072,'radius-cleaned.tif',183,3,1458,9.2327238,4.6041379,8.0985272,1.8,4.5986938,8.1340602,-0.3387146,2.6400894,2.706344,16.0571443,19.7320655,0.1698924,7.2910412,6.0820456,12.468948,4.4289001,5.1037701,0.6857295,17.2453907),(6073,'radius-cleaned.tif',183,3,1459,9.226207,4.602868,8.1049429,1.8,4.5988979,8.1412561,-0.3390197,2.6480739,2.7030706,16.1023755,19.7728447,0.1700666,7.3149568,6.0807877,12.39828,4.4289001,5.1037701,0.6857295,17.3251907),(6074,'radius-cleaned.tif',183,3,1460,9.2186354,4.6008167,8.1127666,1.8,4.5968317,8.1510781,-0.3387788,2.6278354,2.6984915,16.1587874,19.8021741,0.169695,7.3382386,6.1490867,12.5648016,4.4644158,5.1037701,0.6857295,17.2881263),(6075,'radius-cleaned.tif',183,3,1461,9.2147052,4.6006113,8.1202855,1.8,4.5990928,8.1605332,-0.3370862,2.6188845,2.6955065,16.2274616,19.8544532,0.1679965,7.3657597,6.1963258,12.6307926,4.4289001,5.0897139,0.71883,17.1502382),(6076,'radius-cleaned.tif',183,3,1462,9.2098838,4.5970842,8.126465,1.8,4.5922701,8.1672491,-0.3381139,2.6153961,2.6903078,16.2781103,19.8857371,0.1688946,7.3916215,6.223956,12.6688883,4.4726601,5.0897139,0.71883,17.1696009),(6077,'radius-cleaned.tif',183,3,1463,9.2229858,4.5959964,8.1321895,1.8,4.5928572,8.172557,-0.3317428,2.6159934,2.6875531,16.3702418,19.9416745,0.1630544,7.4200115,6.2577536,12.6148663,4.4726601,5.1104721,0.7467434,17.3485636),(6078,'radius-cleaned.tif',183,3,1464,9.2334812,4.5925075,8.1365762,1.8,4.5873603,8.1740758,-0.3259941,2.6060078,2.7060609,16.425647,19.9858056,0.1578318,7.3855713,6.3029923,12.6527813,4.4959936,5.1037701,0.6857295,17.5138348),(6079,'radius-cleaned.tif',183,3,1465,9.2061713,4.5914045,8.1421484,1.8,4.5892115,8.1799235,-0.3179058,2.5786291,2.7010176,16.4448214,19.9990524,0.1499148,7.4042658,6.3773504,12.6808595,4.4688001,5.0917467,0.6576068,17.3816179),(6080,'radius-cleaned.tif',183,3,1466,9.1898662,4.5878504,8.1479523,1.8,4.585347,8.1852878,-0.3151757,2.5709089,2.7082503,16.4771879,20.0289525,0.1471753,7.3955324,6.4090905,12.8307807,4.5019757,5.0975277,0.326701,17.3679263),(6081,'radius-cleaned.tif',183,3,1467,9.173948,4.5878626,8.155105,1.8,4.5879923,8.1957448,-0.3154645,2.5389056,2.7061001,16.5260376,20.0406985,0.1471808,7.4057492,6.5091186,12.8796625,4.4777134,5.0992451,0.9241653,17.438045),(6082,'radius-cleaned.tif',183,3,1468,9.1640866,4.5859619,8.161736,1.8,4.587271,8.2022867,-0.3169208,2.5729578,2.7143291,16.5666714,20.0783743,0.1483373,7.3971777,6.4387653,12.7942048,4.4818912,5.1135864,0.3587707,17.6968077),(6083,'radius-cleaned.tif',183,3,1469,9.1707055,4.5808649,8.1645581,1.8,4.5795713,8.2010894,-0.317416,2.5600371,2.7223241,16.6149841,20.0995403,0.1488931,7.3832282,6.4901342,12.8120392,4.4798023,5.1236946,0.3414524,17.7201806),(6084,'radius-cleaned.tif',183,3,1470,9.1724967,4.576521,8.1713542,1.8,4.5717709,8.2092124,-0.3111372,2.5471558,2.7152425,16.6821422,20.1247554,0.1432783,7.4117708,6.5493215,12.9780176,4.5087001,5.1254032,0.9568816,17.5549094),(6085,'radius-cleaned.tif',183,3,1471,9.1676507,4.5742318,8.1758824,1.8,4.5684621,8.2130829,-0.3113133,2.5559878,2.7117012,16.7250567,20.152237,0.1433595,7.4315848,6.5434806,12.8838341,4.5158752,5.1236946,1.0758001,17.2824551),(6086,'radius-cleaned.tif',183,3,1472,9.1622853,4.5747951,8.1844066,1.8,4.5703333,8.2251346,-0.3112568,2.5476278,2.7096191,16.8180912,20.1852783,0.1432253,7.4494892,6.601471,12.9559494,4.5207331,5.1323872,1.0410431,17.5468891),(6087,'radius-cleaned.tif',183,3,1473,9.1480234,4.5751566,8.1909656,1.8,4.5719286,8.2331911,-0.3065319,2.5091396,2.7193844,16.8771241,20.1892877,0.1388296,7.4242124,6.7262596,12.9999888,4.521813,5.1620795,1.0621963,17.9088247),(6088,'radius-cleaned.tif',183,3,1474,9.1528995,4.5741882,8.1971119,1.8,4.5710431,8.2372276,-0.3015643,2.4968001,2.7250427,16.9642837,20.2620505,0.1345743,7.4354983,6.7944101,13.0652903,4.5268409,5.1668576,2.3179618,17.7766077),(6089,'radius-cleaned.tif',183,3,1475,9.1459631,4.572909,8.2031474,1.8,4.5707602,8.2419959,-0.297812,2.4280832,2.7354604,17.0124054,20.3023869,0.1312456,7.4219269,7.0065168,13.5787382,4.5282334,5.1620795,1.0621963,17.8523976),(6090,'radius-cleaned.tif',183,3,1476,9.1384099,4.5726669,8.2098002,1.8,4.5713546,8.2474802,-0.2875328,2.4289764,2.7348149,17.0866885,20.2899047,0.1224877,7.4191145,7.0345221,13.6015156,4.5282334,5.1668576,1.0449453,17.6580823),(6091,'radius-cleaned.tif',183,3,1477,9.1509223,4.5672087,8.2177714,1.8,4.5613472,8.2548708,-0.2899759,2.421953,2.7276837,17.1795798,20.3724928,0.1246896,7.4687884,7.0932754,13.6681634,4.5599346,5.2014055,1.0487958,17.7532348),(6092,'radius-cleaned.tif',183,3,1478,9.1539187,4.5654197,8.2240878,1.8,4.5590336,8.26124,-0.2766238,2.4174968,2.7438463,17.2558786,20.4110738,0.1137965,7.4388545,7.1379117,13.6263429,4.5461744,5.1969656,1.065935,17.6347094),(6093,'radius-cleaned.tif',183,3,1479,9.1684522,4.5612101,8.2327351,1.8,4.5556816,8.2737678,-0.281527,2.4142008,2.7607782,17.3650674,20.4997066,0.1179454,7.4253364,7.1928844,13.5889547,4.5620386,5.2559071,1.0460006,18.1248518),(6094,'radius-cleaned.tif',183,3,1480,9.159002,4.5597665,8.2375526,1.8,4.5579608,8.2762268,-0.2768392,2.4228299,2.7565933,17.4115903,20.5414428,0.1140326,7.4517494,7.1864683,13.6018657,4.5556339,5.2214148,2.329174,17.889462),(6095,'radius-cleaned.tif',183,3,1481,9.1559156,4.5557081,8.2432361,1.8,4.5525121,8.2802326,-0.2693306,2.4236466,2.7659328,17.4605841,20.6151148,0.1080427,7.4532233,7.2042617,13.6130275,4.5919046,5.2287273,2.296805,17.9612417),(6096,'radius-cleaned.tif',183,3,1482,9.1440007,4.5548766,8.2505549,1.8,4.5531047,8.2882564,-0.2616993,2.4108276,2.7819199,17.5255912,20.6848473,0.1020124,7.4354577,7.2695332,13.561875,4.5864968,5.2586324,2.2917677,17.944228),(6097,'radius-cleaned.tif',183,3,1483,9.1538507,4.5533213,8.2582351,1.8,4.5513601,8.2964754,-0.2593691,2.4200467,2.7776519,17.6232961,20.7609022,0.1003526,7.4742634,7.2822131,13.6024707,4.590321,5.2625666,2.2810673,17.7145094),(6098,'radius-cleaned.tif',183,3,1484,9.1555349,4.5527167,8.2659864,1.8,4.551162,8.3027236,-0.2628686,2.4330001,2.7762174,17.7219348,20.8227914,0.1030347,7.5004182,7.2839844,13.654293,4.6170908,5.2886695,2.2867874,17.9128348),(6099,'radius-cleaned.tif',183,3,1485,9.1534253,4.5536764,8.2729367,1.8,4.5522242,8.309405,-0.2533194,2.4113538,2.7722194,17.7988782,20.8931301,0.0958208,7.5366077,7.3812802,13.5993179,4.6246977,5.2886695,2.2867874,18.1715976),(6100,'radius-cleaned.tif',183,3,1486,9.1441453,4.5524106,8.2810185,1.8,4.5516049,8.3208371,-0.2434072,2.4059213,2.7657969,17.8561886,20.9110893,0.0885248,7.5606018,7.4217675,13.6851948,4.6147404,5.2886695,2.2867874,17.8410551),(6101,'radius-cleaned.tif',183,3,1487,9.1318736,4.5502171,8.2845965,1.8,4.5476435,8.3222928,-0.2338181,2.4093711,2.7700793,17.8746016,20.9714946,0.0817026,7.5707199,7.418783,13.633196,4.641399,5.3342287,2.3297456,17.9829535),(6102,'radius-cleaned.tif',183,3,1488,9.1430852,4.5467739,8.2876444,1.8,4.5428567,8.3214902,-0.2334743,2.4143301,2.7751668,17.9749732,21.0133716,0.0815669,7.5719311,7.4451184,13.6451699,4.64267,5.3360191,2.3191744,18.0023162),(6103,'radius-cleaned.tif',183,3,1489,9.1389272,4.5424737,8.2954395,1.8,4.5367703,8.3294261,-0.2407491,2.4122104,2.8004421,18.0393713,21.0786859,0.0865897,7.5269137,7.4783572,13.6966692,4.6476238,5.3679961,2.3036114,18.4594044),(6104,'radius-cleaned.tif',183,3,1490,9.1365542,4.5379251,8.2984625,1.8,4.5312135,8.3271028,-0.2369463,2.416064,2.7944534,18.103861,21.125025,0.0839051,7.5596269,7.4931216,13.6861231,4.6415101,5.3653263,2.3141141,18.128862),(6105,'radius-cleaned.tif',183,3,1491,9.1368476,4.5350668,8.3069653,1.8,4.5288102,8.339141,-0.2265041,2.4297083,2.7872152,18.1762402,21.1736785,0.0767993,7.5967147,7.4808323,13.6944799,4.6735779,5.3977196,2.2986664,18.0530721),(6106,'radius-cleaned.tif',183,3,1492,9.1399072,4.530578,8.3091946,1.8,4.5217579,8.334455,-0.2175367,2.406992,2.7799927,18.2148534,21.2238637,0.0709568,7.6345035,7.5674758,13.7137438,4.6431395,5.3977196,2.2986664,18.2707603),(6107,'radius-cleaned.tif',183,3,1493,9.1392602,4.5287908,8.3171241,1.8,4.5201714,8.3428795,-0.20934,2.4170519,2.7742552,18.2689262,21.3110901,0.0657826,7.681734,7.5583509,13.6947596,4.6774022,5.4275735,2.2937757,18.1715976),(6108,'radius-cleaned.tif',183,3,1494,9.132481,4.5266262,8.3252753,1.8,4.5178792,8.352179,-0.2129051,2.4271515,2.779863,18.3615139,21.3692227,0.0679575,7.6871497,7.5650465,13.7053568,4.6874691,5.4243461,2.3041582,18.4674247),(6109,'radius-cleaned.tif',183,3,1495,9.1300078,4.5229657,8.3322052,1.8,4.5144534,8.3593938,-0.2077718,2.4376886,2.7732172,18.4292747,21.4276029,0.0647492,7.7266226,7.560143,13.6693433,4.6554683,5.4511346,2.3095961,18.2223535),(6110,'radius-cleaned.tif',183,3,1496,9.1330409,4.5195987,8.3382572,1.8,4.5126087,8.3621096,-0.2022472,2.4386788,2.7829253,18.5105475,21.5001656,0.0614186,7.7257431,7.5904001,13.6977645,4.7132942,5.4745942,2.3355789,18.4246891),(6111,'radius-cleaned.tif',183,3,1497,9.1395311,4.5139341,8.3473526,1.8,4.5039432,8.3702347,-0.2016309,2.4539689,2.7753021,18.5633384,21.5774206,0.0610933,7.7748006,7.5646186,13.7115055,4.6847419,5.4838919,2.2944175,18.4343705),(6112,'radius-cleaned.tif',183,3,1498,9.1462873,4.5103998,8.3559018,1.8,4.5026703,8.3784852,-0.1983409,2.4432619,2.768816,18.6523742,21.6464501,0.0591856,7.8179446,7.6342099,13.7343153,4.7211231,5.4838919,2.2944175,18.5101603),(6113,'radius-cleaned.tif',183,3,1499,9.1363207,4.5047735,8.3646845,1.8,4.4947082,8.3895014,-0.2010668,2.4606979,2.7626376,18.6807212,21.7149308,0.0607352,7.8602169,7.5916355,13.850452,4.6936945,5.4806976,2.3046937,18.1796179),(6114,'radius-cleaned.tif',183,3,1500,9.1259793,4.5024588,8.3713994,1.8,4.4949455,8.3951053,-0.1963595,2.4476735,2.7729796,18.7093763,21.7590667,0.0578953,7.8468181,7.6437387,13.847224,4.6916455,5.4780827,2.3149807,18.3448891),(6115,'radius-cleaned.tif',183,3,1501,9.1410865,4.4978219,8.3774446,1.8,4.4886143,8.3994038,-0.1952182,2.459659,2.7669484,18.8169756,21.8628885,0.0573275,7.9014441,7.6502374,13.9186605,4.7155996,5.5051881,2.3203125,18.3545705),(6116,'radius-cleaned.tif',183,3,1502,9.1465347,4.4914376,8.3834183,1.8,4.4777027,8.4050036,-0.1938127,2.4632732,2.7822083,18.8616641,21.941172,0.0565491,7.8862435,7.6571549,13.9527691,4.7093389,5.5034527,2.3305591,18.7592417),(6117,'radius-cleaned.tif',183,3,1503,9.1342664,4.4893684,8.3910176,1.8,4.4789357,8.4162159,-0.1956299,2.4716273,2.7793957,18.9307613,21.9896597,0.0575235,7.9116695,7.6592296,13.9599639,4.7263443,5.5034527,2.3305591,18.4577433),(6118,'radius-cleaned.tif',183,3,1504,9.1274835,4.4831133,8.3987985,1.8,4.470258,8.4257267,-0.1980571,2.4718923,2.7726279,18.9741307,22.0387907,0.0588972,7.9487012,7.6759535,13.9967776,4.7286484,5.5344624,2.3154008,18.5528959),(6119,'radius-cleaned.tif',183,3,1505,9.11182,4.4843721,8.4063234,1.8,4.4768462,8.4340881,-0.1899313,2.4740912,2.7709502,19.0170229,22.0732145,0.0541276,7.9659368,7.6864679,14.0155965,4.7428549,5.5051881,2.3203125,18.1892992),(6120,'radius-cleaned.tif',183,3,1506,9.0877109,4.4829912,8.4141852,1.8,4.4742829,8.4418509,-0.1771588,2.4797587,2.7657978,19.0358265,22.0839635,0.0470414,7.9846631,7.6764834,14.065461,4.7592447,5.5034527,2.3305591,18.4771061),(6121,'radius-cleaned.tif',183,3,1507,9.0681988,4.4835672,8.4207041,1.8,4.4749803,8.4454944,-0.1683805,2.4796383,2.7767957,19.0512408,22.1178625,0.0424468,7.9652465,7.6830726,14.0400257,4.7559253,5.5301459,2.3459908,18.6270247),(6122,'radius-cleaned.tif',183,3,1508,9.0537927,4.4835458,8.4304367,1.8,4.4747259,8.4568405,-0.1650484,2.4801095,2.7544857,19.1145135,22.1252259,0.0407338,8.0324344,7.7071247,14.1701286,4.7246039,5.5344624,2.3154008,18.4383806),(6123,'radius-cleaned.tif',183,3,1509,9.0404298,4.4824658,8.4414784,1.8,4.471671,8.4709663,-0.1623434,2.4752567,2.7576205,19.1804008,22.1307768,0.039363,8.0253162,7.7488532,14.1854148,4.7592447,5.5051881,2.3203125,18.6794417),(6124,'radius-cleaned.tif',183,3,1510,9.0249477,4.4816637,8.4505553,1.8,4.471427,8.4777556,-0.1527049,2.4752948,2.753268,19.2112352,22.1584627,0.0348033,8.0480589,7.7611908,14.1249334,4.7491159,5.5324484,2.3255918,18.9108214),(6125,'radius-cleaned.tif',183,3,1511,9.0130086,4.4818709,8.4597627,1.8,4.472355,8.4861674,-0.141772,2.4685527,2.7720385,19.2509777,22.1987786,0.0299908,8.0081063,7.7984875,14.1679212,4.7592447,5.5598615,2.3308192,18.6463874),(6126,'radius-cleaned.tif',183,3,1512,9.000049,4.4826104,8.4696328,1.8,4.4753953,8.4957312,-0.1238243,2.4617041,2.7637583,19.2775971,22.229519,0.0228815,8.0432212,7.830997,14.1770088,4.7585075,5.558716,2.3409672,18.9478858),(6127,'radius-cleaned.tif',183,3,1513,8.9867919,4.4829003,8.4765451,1.8,4.4755167,8.4993813,-0.1148547,2.4553758,2.7682585,19.3314899,22.2587546,0.0196716,8.0407067,7.8731289,14.1133452,4.7916184,5.5862851,2.3561945,18.5141705),(6128,'radius-cleaned.tif',183,3,1514,8.9971468,4.4806895,8.4893249,1.8,4.472378,8.5162153,-0.1186866,2.4713719,2.7666234,19.4329832,22.3746608,0.0210241,8.0873532,7.863237,14.3300298,4.7627255,5.5598615,2.3308192,18.5335332),(6129,'radius-cleaned.tif',183,3,1515,9.0066669,4.4777616,8.4967079,1.8,4.4691794,8.5211801,-0.1093476,2.4653119,2.7888522,19.4755287,22.4905899,0.0178772,8.0644609,7.8998234,14.3196505,4.7795014,5.587425,2.3359952,18.5705976),(6130,'radius-cleaned.tif',183,3,1516,8.9974743,4.4781899,8.505021,1.8,4.4729447,8.5301941,-0.0928938,2.4584477,2.7879888,19.515169,22.5401173,0.0129031,8.084723,7.9380044,14.333782,4.7662064,5.5888494,2.3259007,18.5762688),(6131,'radius-cleaned.tif',183,3,1517,9.0096999,4.4748292,8.5112326,1.8,4.4689341,8.533194,-0.0877837,2.4559943,2.7811195,19.6100529,22.6428201,0.0115417,8.1416207,7.9845677,14.4054423,4.7644659,5.6452509,2.3262035,18.928523),(6132,'radius-cleaned.tif',183,3,1518,9.0048091,4.4707687,8.522293,1.8,4.4639632,8.547302,-0.0813538,2.450191,2.7788473,19.6271496,22.7682575,0.0099111,8.193418,8.010457,14.4198064,4.7730855,5.6472246,2.3162158,18.6503976),(6133,'radius-cleaned.tif',183,3,1519,8.9922507,4.4696951,8.5344666,1.8,4.4635613,8.5636637,-0.0938761,2.4818291,2.8170594,19.6779303,22.827073,0.0131689,8.1031563,7.9288015,14.4307235,4.7782173,5.6743637,2.3213827,18.9946315),(6134,'radius-cleaned.tif',183,3,1520,8.9859032,4.4660157,8.5468666,1.8,4.4582366,8.5793218,-0.0980098,2.4991213,2.822203,19.7171818,22.9462109,0.0143403,8.1306026,7.8896457,14.5425522,4.8008471,5.6726801,2.331324,18.848723),(6135,'radius-cleaned.tif',183,3,1521,8.9991582,4.4635874,8.5594729,1.8,4.4551477,8.5940524,-0.0912857,2.5389209,2.8218373,19.8252824,23.1199695,0.0124638,8.1932328,7.8085468,14.5582607,4.8304342,5.7036071,2.3166112,19.2437129),(6136,'radius-cleaned.tif',183,3,1522,9.0000341,4.4625794,8.5701384,1.8,4.4568185,8.6074931,-0.0953569,2.5185691,2.8225729,19.8064509,23.2632786,0.0135982,8.2418699,7.864168,14.5544861,4.8060684,5.7002566,2.3363951,18.7632518),(6137,'radius-cleaned.tif',183,3,1523,9.0198089,4.4554144,8.5803375,1.8,4.4464047,8.6200613,-0.1142788,2.5470265,2.8659198,19.9154061,23.4268115,0.0195473,8.1742732,7.819081,14.5661809,4.8156071,5.7016529,2.3265003,19.0026518),(6138,'radius-cleaned.tif',183,3,1524,8.9969305,4.4489478,8.5859515,1.8,4.4406927,8.6241284,-0.1212368,2.5647926,2.8628778,19.8809515,23.5244234,0.0219323,8.2170546,7.7514851,14.5823615,4.8204788,5.7036071,2.3166112,18.9518959),(6139,'radius-cleaned.tif',183,3,1525,9.020711,4.4430671,8.5977286,1.8,4.4348581,8.641703,-0.1274194,2.5729251,2.8691469,20.0157014,23.7146256,0.0242778,8.2653925,7.7793565,14.7325408,4.8529968,5.7036071,2.3166112,19.4129943),(6140,'radius-cleaned.tif',183,3,1526,9.0082159,4.4387375,8.6052397,1.8,4.432268,8.6479829,-0.139072,2.5638672,2.8937538,20.0401275,23.805962,0.0288513,8.2266715,7.8163672,14.7218901,4.8229146,5.7016529,2.3265003,18.8140077),(6141,'radius-cleaned.tif',183,3,1527,9.021274,4.4335663,8.6203676,1.8,4.4258358,8.6686568,-0.1458708,2.5799863,2.8894604,20.1691249,23.945603,0.0317666,8.287223,7.8175316,14.7770063,4.8778346,5.7036071,2.3166112,19.6153299),(6142,'radius-cleaned.tif',183,3,1528,9.0304802,4.4274688,8.6309057,1.8,4.416253,8.6790572,-0.1425053,2.6197396,2.8804968,20.2146298,24.0834878,0.0303585,8.3608799,7.7162745,14.7983198,4.8892733,5.7279783,2.3414172,19.2807773),(6143,'radius-cleaned.tif',183,3,1529,9.0436063,4.4241076,8.6404362,1.8,4.4130546,8.6867512,-0.1378926,2.5953702,2.8903405,20.2681837,24.2556883,0.0284785,8.3919831,7.8093612,14.7909791,4.8676119,5.7580554,2.3267912,19.2807773),(6144,'radius-cleaned.tif',183,3,1530,9.0472731,4.4206695,8.6543936,1.8,4.4073922,8.7048312,-0.136553,2.6072198,2.8951669,20.349026,24.3878998,0.0279427,8.4236595,7.8048756,14.8779757,4.9001299,5.7566728,2.3365892,19.4871231),(6145,'radius-cleaned.tif',183,3,1531,9.0364148,4.4184875,8.6681096,1.8,4.4030616,8.7237931,-0.1345178,2.612876,2.8919935,20.350583,24.5299623,0.0270884,8.4820253,7.7885758,14.9474691,4.9001299,5.7357553,2.3020602,19.6797773),(6146,'radius-cleaned.tif',183,3,1532,9.0363987,4.4168414,8.6793447,1.8,4.3985649,8.7361291,-0.1344382,2.6023109,2.9102224,20.3905065,24.6720167,0.0270565,8.4777084,7.8355381,14.9684684,4.9479449,5.7580554,2.3267912,21.7151639),(6147,'radius-cleaned.tif',183,3,1533,9.0362755,4.4150203,8.691981,1.8,4.3950261,8.7506358,-0.1393086,2.6135022,2.9089234,20.4493543,24.7852665,0.0290391,8.520426,7.8245024,15.0508108,4.9618682,5.7580554,2.3267912,21.4467198),(6148,'radius-cleaned.tif',183,3,1534,9.0647083,4.4095885,8.7060538,1.8,4.3889945,8.7665056,-0.1377131,2.625307,2.9008982,20.586346,25.0237037,0.0284712,8.6261917,7.8415004,15.118011,4.9601278,5.7580554,2.3267912,20.3432113),(6149,'radius-cleaned.tif',183,3,1535,9.0926496,4.4045356,8.7189694,1.8,4.3838452,8.7806621,-0.1418936,2.6466156,2.9015093,20.7162813,25.2443071,0.0303074,8.7004055,7.8274614,15.144154,4.9982494,5.7855001,2.3318091,20.6430485),(6150,'radius-cleaned.tif',183,3,1536,9.1194421,4.4016898,8.7313376,1.8,4.3809575,8.7933756,-0.149458,2.6493662,2.9120662,20.8688047,25.3890424,0.0336992,8.7185664,7.8769046,15.1862548,4.9863571,5.7838489,2.3513165,20.709157),(6151,'radius-cleaned.tif',183,3,1537,9.1187039,4.4021832,8.7431884,1.8,4.3823818,8.8068175,-0.1416399,2.6644023,2.9182497,20.9257632,25.5120589,0.0302863,8.7422467,7.8538301,15.4248064,5.0108581,5.7580554,2.3267912,21.5418724),(6152,'radius-cleaned.tif',183,3,1538,9.1139391,4.4011132,8.7569416,1.8,4.382294,8.8253184,-0.1288481,2.6375937,2.9112915,20.9704448,25.6429581,0.0250788,8.8081038,7.950597,15.4090836,5.0226152,5.7599905,2.3953901,22.2834452),(6153,'radius-cleaned.tif',183,3,1539,9.1245616,4.4000802,8.7715394,1.8,4.3821676,8.8448671,-0.1310205,2.6540062,2.9194914,21.0854695,25.7836213,0.0259569,8.8315455,7.9447701,15.4865014,5.0589964,5.7855001,2.3318091,20.6487198),(6154,'radius-cleaned.tif',183,3,1540,9.1135849,4.3991179,8.7804996,1.8,4.3800346,8.8532476,-0.130062,2.6670297,2.9377029,21.1291645,25.8519754,0.0255499,8.8000648,7.9223581,15.5326647,5.0589964,5.8130892,2.3367795,20.841374),(6155,'radius-cleaned.tif',183,3,1541,9.1117599,4.3982415,8.7907185,1.8,4.3791826,8.8657668,-0.1311259,2.6594076,2.9360693,21.1585979,25.9671292,0.025962,8.8441812,7.9561321,15.6071031,5.036371,5.8130892,2.3367795,20.3665841),(6156,'radius-cleaned.tif',183,3,1542,9.1007502,4.3987437,8.7994859,1.8,4.3798353,8.8734021,-0.119583,2.670563,2.9292596,21.225514,25.9866985,0.0215871,8.871422,7.9479547,15.6162751,5.0678659,5.8419107,2.3320446,22.2697537),(6157,'radius-cleaned.tif',183,3,1543,9.1115509,4.3983144,8.8113535,1.8,4.3804688,8.8860565,-0.1145742,2.6637025,2.9460736,21.2995485,26.1297403,0.0198478,8.8693439,7.9962191,15.6616587,5.0797138,5.8684207,2.3561945,21.9956384),(6158,'radius-cleaned.tif',183,3,1544,9.1107816,4.3950519,8.8208995,1.8,4.3748068,8.8959302,-0.1060799,2.6738333,2.9468448,21.3414991,26.23961,0.0170232,8.9043067,7.9816117,15.6593585,5.0895863,5.868692,2.3658096,22.6470419),(6159,'radius-cleaned.tif',183,3,1545,9.1223713,4.3956568,8.8319863,1.8,4.3763373,8.9066338,-0.1026339,2.6734057,2.9446194,21.4583233,26.3632532,0.0159593,8.9530258,8.026587,15.7002425,5.097942,5.8708618,2.3273563,22.4293537),(6160,'radius-cleaned.tif',183,3,1546,9.1068522,4.3929489,8.8443713,1.8,4.3723654,8.9207329,-0.1103369,2.6877194,2.952998,21.5218398,26.4218859,0.0184033,8.9474784,8.0074728,15.7605807,5.0915566,5.8708618,2.3850326,22.0714283),(6161,'radius-cleaned.tif',183,3,1547,9.1038005,4.3880703,8.8551674,1.8,4.3669405,8.9311994,-0.1126507,2.6827074,2.9481538,21.6048796,26.5182574,0.0191735,8.9948692,8.0533864,15.7474272,5.1216512,5.8695058,2.3369661,21.8360384),(6162,'radius-cleaned.tif',183,3,1548,9.1104751,4.3815994,8.8654675,1.8,4.3597059,8.9412385,-0.1078862,2.7098402,2.9477305,21.6809831,26.685867,0.017605,9.0530213,8.0008346,15.8707963,5.1294726,5.8695058,2.3754229,20.310157),(6163,'radius-cleaned.tif',183,3,1549,9.1121644,4.3775809,8.8761122,1.8,4.3627249,8.9562511,-0.092771,2.6780748,2.9462487,21.7619729,26.8153505,0.0130331,9.1015232,8.1259764,15.8489,5.1489954,5.9272657,2.3276308,20.1118316),(6164,'radius-cleaned.tif',183,3,1550,9.1212111,4.3726574,8.8855111,1.8,4.3576489,8.9663155,-0.0805176,2.6775366,2.939301,21.8844847,26.943575,0.0098343,9.1666606,8.1733653,15.8804812,5.1315615,5.9531283,2.3514552,21.532191),(6165,'radius-cleaned.tif',183,3,1551,9.1466085,4.3666736,8.8963921,1.8,4.3516618,8.9778498,-0.0756557,2.6826103,2.9364886,22.0080233,27.1377365,0.0087089,9.2415603,8.2039583,15.925724,5.1471001,5.9531283,2.3514552,23.0460419),(6166,'radius-cleaned.tif',183,3,1552,9.1709323,4.3652643,8.9109687,1.8,4.3551221,8.9972488,-0.0738613,2.69213,2.9389961,22.2007046,27.2823352,0.0083235,9.2828757,8.2465204,15.959004,5.1792466,5.9823396,2.3373288,20.4230113),(6167,'radius-cleaned.tif',183,3,1553,9.1889795,4.3588832,8.9210522,1.8,4.3476776,9.0071443,-0.0733635,2.6789468,2.9626282,22.2747342,27.5285245,0.0082281,9.2919269,8.3147354,15.9952876,5.1713079,5.9536631,2.3704115,23.2700894),(6168,'radius-cleaned.tif',183,3,1554,9.2084091,4.3527164,8.9294733,1.8,4.3410693,9.01185,-0.0691252,2.7074421,2.9279821,22.3325624,27.7035135,0.0073217,9.4616403,8.2485836,16.0943316,5.1471001,5.981275,2.3561945,23.1435436),(6169,'radius-cleaned.tif',183,3,1555,9.2448172,4.3461433,8.9438294,1.8,4.3304468,9.0304855,-0.0687619,2.6865914,2.9408192,22.5335549,27.9134634,0.0072737,9.4917305,8.3874141,16.1481786,5.1315615,5.9547326,2.3798867,21.5966384),(6170,'radius-cleaned.tif',183,3,1556,9.2570297,4.3467372,8.9522544,1.8,4.3383673,9.0344319,-0.056368,2.680307,2.9408555,22.6283511,28.0452509,0.004897,9.5364261,8.4424474,16.1482339,5.1315615,5.9823396,2.3373288,21.5418724),(6171,'radius-cleaned.tif',183,3,1557,9.2827326,4.3424622,8.963329,1.8,4.3329001,9.0455574,-0.0445025,2.6784676,2.9357665,22.7331587,28.2743667,0.003062,9.6309997,8.4873749,16.1638217,5.1456199,6.0377021,2.3561945,21.6200113),(6172,'radius-cleaned.tif',183,3,1558,9.2899988,4.3404434,8.9741771,1.8,4.3316941,9.0597049,-0.0341362,2.6704642,2.9269768,22.7941391,28.4249581,0.0018035,9.7113713,8.5356468,16.2493859,5.1704034,6.0387567,2.3375051,21.3435469),(6173,'radius-cleaned.tif',183,3,1559,9.2920887,4.3392469,8.9819411,1.8,4.3325573,9.0685824,-0.0182832,2.6676303,2.9531157,22.8386052,28.6142377,0.0005176,9.6895079,8.5613831,16.227591,5.1252948,6.0665062,2.3422419,21.080774),(6174,'radius-cleaned.tif',183,3,1560,9.330124,4.3366544,8.9911381,1.8,4.3316077,9.0823965,-0.009002,2.6820478,2.9453001,22.9588088,28.8879766,0.000126,9.8081607,8.560179,16.3057572,5.1458495,6.0665062,2.3422419,21.4894554),(6175,'radius-cleaned.tif',183,3,1561,9.3545405,4.3310678,8.9963075,1.8,4.3301957,9.0843996,-0.0000886,2.6920562,2.9346332,23.0443604,29.1426245,0.00000001584,9.9305849,8.5601335,16.3361706,5.248199,6.0675558,2.3794461,22.861408),(6176,'radius-cleaned.tif',183,3,1562,9.3657717,4.3248786,9.0065946,1.8,4.3264353,9.0964178,0.0009439,2.703094,2.9281788,23.1107806,29.3184019,0.0000014,10.0125041,8.549751,16.3701816,5.1804903,6.0675558,2.3794461,20.4367028),(6177,'radius-cleaned.tif',183,3,1563,9.3958965,4.3180602,9.0191585,1.8,4.3202266,9.1116239,-0.0046687,2.7119896,2.9250595,23.274591,29.49038,0.0000341,10.0819762,8.5821091,16.4801631,5.1822307,6.0941292,2.3561945,20.8453842),(6178,'radius-cleaned.tif',183,3,1564,9.4349376,4.3121909,9.0279187,1.8,4.3201118,9.1203648,0.0000297,2.6838446,2.9156817,23.4569119,29.6681993,0.000000004506,10.1753902,8.7400412,16.4176526,5.2583381,6.1239678,2.3792319,22.1802724),(6179,'radius-cleaned.tif',183,3,1565,9.476566,4.303402,9.0395349,1.8,4.3157617,9.1391764,0.0045371,2.6995969,2.9436135,23.6693934,29.9065484,0.0000325,10.1598081,8.7677508,16.5042324,5.2942402,6.1508152,2.3653685,21.7482181),(6180,'radius-cleaned.tif',183,3,1566,9.5208234,4.2931467,9.0449517,1.8,4.3054882,9.143247,0.0063707,2.7057286,2.9363984,23.864781,30.1121183,0.0000644,10.2547796,8.8200942,16.4699815,5.2952847,6.1528855,2.3837105,21.7014724),(6181,'radius-cleaned.tif',183,3,1567,9.5337436,4.2876977,9.0500951,1.8,4.2989543,9.1487081,0.0091791,2.7123043,2.9458647,23.9820863,30.2610663,0.0001339,10.2723884,8.8419599,16.5606958,5.3209614,6.1793496,2.3424967,21.7425469),(6182,'radius-cleaned.tif',183,3,1568,9.571057,4.2850436,9.0584469,1.8,4.293763,9.1540211,0.012457,2.7233835,2.9525192,24.1202155,30.4673406,0.0002475,10.3191,8.8567093,16.6171889,5.3309932,6.1528855,2.3837105,21.1839469),(6183,'radius-cleaned.tif',183,3,1569,9.6075426,4.2824316,9.0679329,1.8,4.287316,9.162985,0.0206809,2.7370056,2.9999644,24.2562766,30.6676562,0.0006848,10.2226733,8.862341,16.7340766,5.3154052,6.20724,2.3471038,21.5555639),(6184,'radius-cleaned.tif',183,3,1570,9.666485,4.2767205,9.0781328,1.8,4.2810148,9.1739158,0.0239033,2.7492864,3.008524,24.4800216,30.9485676,0.0009204,10.2869606,8.9041366,16.7819867,5.3608234,6.2069835,2.3561945,22.2520521),(6185,'radius-cleaned.tif',183,3,1571,9.7089781,4.272614,9.086288,1.8,4.2792033,9.1762594,0.0306897,2.7603841,3.0223946,24.5738475,31.1589448,0.0015236,10.3093568,8.902329,16.8134353,5.3538617,6.20724,2.3652851,22.594625),(6186,'radius-cleaned.tif',183,3,1572,9.7394671,4.269052,9.0978701,1.8,4.2806377,9.1821792,0.0356559,2.743446,3.0334932,24.6094252,31.4255139,0.0020628,10.3595135,8.9702605,16.848924,5.3362155,6.2080093,2.3743743,22.0497165),(6187,'radius-cleaned.tif',183,3,1573,9.7656337,4.2648961,9.1070415,1.8,4.2753513,9.1862494,0.0439821,2.7574424,3.0462029,24.7046158,31.575803,0.0031465,10.3656271,8.9592499,16.9278987,5.3750573,6.2367926,2.3788151,22.3495537),(6188,'radius-cleaned.tif',183,3,1574,9.7826663,4.2618276,9.1156522,1.8,4.2745261,9.1931997,0.0414486,2.7643354,3.0462312,24.8719964,31.7522857,0.0027995,10.4234656,8.9974598,17.0069733,5.3773235,6.2636648,2.3652033,22.1375368),(6189,'radius-cleaned.tif',183,3,1575,9.7987406,4.2572313,9.1193774,1.8,4.2725195,9.1980373,0.049505,2.7721121,3.0870282,24.9811381,31.9087667,0.0039991,10.3364027,9.0115901,17.0765861,5.3625638,6.2644272,2.3742106,21.6804486),(6190,'radius-cleaned.tif',183,3,1576,9.8232116,4.2500186,9.1221671,1.8,4.2691531,9.2035512,0.0419257,2.7700158,3.0914345,25.141102,32.1244871,0.0028761,10.3914501,9.0761583,17.0583501,5.4022072,6.2921935,2.3696466,21.7014724),(6191,'radius-cleaned.tif',183,3,1577,9.7928779,4.2406513,9.1246435,1.8,4.2593706,9.2075218,0.0354157,2.7625438,3.0977158,25.1429476,32.2068355,0.0020463,10.3969626,9.1013752,16.9818671,5.4008147,6.2932054,2.3786123,21.5692554),(6192,'radius-cleaned.tif',183,3,1578,9.7868646,4.2353437,9.1285413,1.8,4.2572216,9.2129461,0.0233729,2.7623024,3.0899638,25.1788451,32.3233897,0.0008909,10.4607663,9.115166,16.9113319,5.3994222,6.3208453,2.3740497,22.3358622),(6193,'radius-cleaned.tif',183,3,1579,9.8034769,4.2272687,9.1324649,1.8,4.2485558,9.2193589,0.0235192,2.7665214,3.0990252,25.269427,32.5021217,0.0009036,10.4878534,9.1340076,16.9662081,5.3029609,6.3486155,2.369527,20.9759401),(6194,'radius-cleaned.tif',183,3,1580,9.8342479,4.2174281,9.1411667,1.8,4.2347247,9.2298459,0.0221601,2.7371993,3.1108322,25.4358492,32.7044162,0.0008047,10.5130762,9.2926553,16.9841289,5.3304661,6.3221045,2.3829738,21.664408),(6195,'radius-cleaned.tif',183,3,1581,9.8819749,4.2107824,9.1496344,1.8,4.2322269,9.2358829,0.0251818,2.7484458,3.1566352,25.6990279,32.9260913,0.0010442,10.4307561,9.3503855,17.087013,5.4130394,6.3486155,2.369527,21.9174995),(6196,'radius-cleaned.tif',183,3,1582,9.9437807,4.2050531,9.1644064,1.8,4.2276258,9.2543383,0.0307887,2.7632942,3.1649269,25.9841419,33.1801355,0.0015705,10.4836973,9.403321,17.1875825,5.4536296,6.3496185,2.3784131,22.0206724),(6197,'radius-cleaned.tif',183,3,1583,9.9913233,4.2034181,9.1727231,1.8,4.2221773,9.2618385,0.0281745,2.7709442,3.1662816,26.2086415,33.364796,0.0013215,10.5375329,9.4583794,17.2449355,5.4536296,6.3288999,2.4097148,21.5168384),(6198,'radius-cleaned.tif',183,3,1584,10.0377306,4.2095096,9.1828863,1.8,4.2269417,9.2710322,0.0283289,2.7787856,3.1988054,26.400734,33.5420429,0.0013422,10.4858029,9.5008172,17.3054596,5.4536296,6.3785116,2.3827369,21.8924655),(6199,'radius-cleaned.tif',183,3,1585,10.0910834,4.2149988,9.1891685,1.8,4.2271011,9.2728367,0.0270993,2.7851847,3.1920373,26.6129069,33.794957,0.0012348,10.587269,9.5551677,17.5537134,5.3966372,6.3556331,2.4050445,21.8320283),(6200,'radius-cleaned.tif',183,3,1586,10.167946,4.2233134,9.2032933,1.8,4.2334494,9.2875507,0.0410513,2.8051386,3.1970216,26.8228824,34.2472248,0.0028542,10.7122281,9.5620524,17.7153122,5.4351204,6.3825037,2.4004134,22.0440452),(6201,'radius-cleaned.tif',183,3,1587,10.2248487,4.224013,9.2130083,1.8,4.2295532,9.2931333,0.0480725,2.8206572,3.2115471,26.9581956,34.5638065,0.0039352,10.7623539,9.5574165,17.8012159,5.4722111,6.4075228,2.3870217,21.8223469),(6202,'radius-cleaned.tif',183,3,1588,10.2821622,4.2263162,9.2217986,1.8,4.2339038,9.2970605,0.0594989,2.8007535,3.2157425,27.0605798,34.9264644,0.0060595,10.8610885,9.6618925,17.8654968,5.4172175,6.434919,2.3825042,22.5575606),(6203,'radius-cleaned.tif',183,3,1589,10.3509029,4.2250639,9.2226863,1.8,4.2328625,9.2918639,0.0672906,2.8065912,3.258468,27.1862176,35.2636917,0.0077997,10.8221691,9.6865611,17.9956148,5.4095576,6.4639233,2.3867527,22.0593978),(6204,'radius-cleaned.tif',183,3,1590,10.3962546,4.2225067,9.2242765,1.8,4.2333487,9.2918272,0.0703213,2.8074048,3.2633602,27.2808592,35.5497003,0.0085543,10.8935875,9.7174656,18.0211039,5.4475188,6.4415954,2.4087776,21.639374),(6205,'radius-cleaned.tif',183,3,1591,10.4485946,4.2175482,9.2276293,1.8,4.2294137,9.2979374,0.0658882,2.8085261,3.2671238,27.4986834,35.8519664,0.0075491,10.9735561,9.791144,17.9766665,5.4466661,6.4713078,2.4129022,22.1956249),(6206,'radius-cleaned.tif',183,3,1592,10.501347,4.2092025,9.2335682,1.8,4.2192875,9.3016961,0.0607198,2.7817512,3.2803248,27.652896,36.2191772,0.006445,11.0413388,9.9408229,18.0783399,5.4264001,6.5222773,2.3951358,21.9739266),(6207,'radius-cleaned.tif',183,3,1593,10.5313502,4.203909,9.2465797,1.8,4.2169839,9.3148508,0.0638885,2.8143935,3.3099886,27.7964854,36.5456674,0.0071546,11.041025,9.8765454,18.1442766,5.4680337,6.5247177,2.4037776,21.6296927),(6208,'radius-cleaned.tif',183,3,1594,10.562923,4.1942684,9.2682833,1.8,4.2024707,9.3283446,0.056224,2.8115162,3.3150358,27.8814749,36.8970101,0.0055593,11.1301997,9.9168821,18.1947334,5.4886491,6.5247177,2.4037776,21.9271808),(6209,'radius-cleaned.tif',183,3,1595,10.6436695,4.1850138,9.2952713,1.8,4.1925361,9.350937,0.0494625,2.8357248,3.319696,28.0300707,37.4004495,0.0043365,11.2662272,9.8846231,18.4002174,5.4879527,6.5011294,2.416989,22.0400351),(6210,'radius-cleaned.tif',183,3,1596,10.7057621,4.1727415,9.3115391,1.8,4.1784346,9.3615356,0.0405322,2.8450148,3.3321434,28.1143577,37.8315352,0.0029297,11.3535135,9.8819723,18.4321079,5.4886491,6.5505303,2.844885,22.0537266),(6211,'radius-cleaned.tif',183,3,1597,10.7391908,4.1633265,9.3228503,1.8,4.1696948,9.3761504,0.03,2.8461935,3.3631142,28.2000593,38.2027671,0.0016104,11.3593428,9.9079907,18.3607933,5.5257576,6.5743047,2.833277,22.2383605),(6212,'radius-cleaned.tif',183,3,1598,10.8053586,4.1594838,9.3354014,1.8,4.1640164,9.3904936,0.0189675,2.8491666,3.3577867,28.3493348,38.6883612,0.0006478,11.5219829,9.9500445,18.5324274,5.528543,6.5810815,2.9525203,22.304469),(6213,'radius-cleaned.tif',183,3,1599,10.8484702,4.1581434,9.3559515,1.8,4.1591354,9.4094246,0.0084003,2.8604581,3.315614,28.4518127,39.1850751,0.0001276,11.8183464,9.9465929,18.568934,5.5670442,6.621477,2.9229237,22.3689165),(6214,'radius-cleaned.tif',183,3,1600,10.8663368,4.1603328,9.3772178,1.8,4.1624027,9.4239713,-0.0019559,2.8723625,3.3393797,28.4293761,39.6839231,0.0000069,11.8836212,9.8975585,18.6649719,5.5477851,6.6670024,2.4069982,22.6704148),(6215,'radius-cleaned.tif',183,3,1601,10.8593428,4.1526605,9.3975546,1.8,4.1531811,9.4441029,-0.0138555,2.8842212,3.3380065,28.3334746,40.0835658,0.0003474,12.0082348,9.8236135,18.6709271,5.6062418,6.6747586,2.8255131,22.3729266),(6216,'radius-cleaned.tif',183,3,1602,10.8244334,4.1451149,9.4121235,1.8,4.1415858,9.4591951,-0.0196886,2.8944174,3.3693206,28.2213588,40.3163167,0.0006992,11.9657111,9.7502727,18.6136707,5.6247515,6.7193308,2.8649243,22.5575606),(6217,'radius-cleaned.tif',183,3,1603,10.7467436,4.1412946,9.4232336,1.8,4.1330216,9.4762314,-0.021424,2.9033,3.3709649,28.0868603,40.3605016,0.000822,11.9729819,9.6741158,18.4998325,5.6219665,6.7415654,2.8535372,22.9702521),(6218,'radius-cleaned.tif',183,3,1604,10.6945648,4.1393195,9.433312,1.8,4.1290362,9.4908026,-0.0109043,2.8833369,3.3939315,28.0707555,40.3676305,0.0002119,11.8940616,9.7355102,18.4096739,5.6090272,6.7699615,2.9638477,22.277774),(6219,'radius-cleaned.tif',183,3,1605,10.6138309,4.1450152,9.4378025,1.8,4.1344528,9.4993754,0.0037984,2.936675,3.4018899,27.9410148,40.2208373,0.0000255,11.8230862,9.514507,18.2136467,5.6715896,6.8009315,2.8254079,23.5208318),(6220,'radius-cleaned.tif',183,3,1606,10.5607072,4.1496185,9.4390829,1.8,4.1357815,9.5018312,0.0201718,2.9158181,3.4608084,27.8218967,40.2206792,0.0007161,11.6217584,9.5417121,18.114045,5.6895114,6.8485187,2.965908,22.9719131),(6221,'radius-cleaned.tif',183,3,1607,10.4968547,4.1473155,9.445898,1.8,4.1310296,9.5138426,0.0289448,2.9311715,3.4752728,27.6990825,40.2420042,0.0014653,11.5795239,9.4498335,18.0118885,5.7256786,6.8908122,2.8418166,22.861408),(6222,'radius-cleaned.tif',183,3,1608,10.5081531,4.1394746,9.4564155,1.8,4.135971,9.5223535,0.0331569,2.9406498,3.5258033,27.8037281,40.4519543,0.0019247,11.473117,9.4549606,17.9976247,5.7645205,6.9634362,3.0094198,23.0363606),(6223,'radius-cleaned.tif',183,3,1609,10.5942669,4.1206764,9.4675854,1.8,4.1257749,9.5296928,0.0301902,2.9512272,3.5404424,27.9989987,40.9863438,0.0016089,11.5766165,9.4872392,18.0461243,5.7655649,6.9929803,3.0214839,23.2386962),(6224,'radius-cleaned.tif',183,3,1610,10.6575157,4.0939017,9.479625,1.8,4.0990979,9.5401863,0.0266969,2.9588321,3.5677223,28.0739167,41.5397906,0.0012657,11.6432241,9.4881751,17.9599496,5.8043187,7.0450342,2.9708574,23.4877776),(6225,'radius-cleaned.tif',183,3,1611,10.7284055,4.0707814,9.4953218,1.8,4.0794245,9.5593715,0.0290868,2.9782941,3.5938983,28.2298661,42.0960555,0.0015124,11.7132016,9.4785353,17.9167183,5.8334421,7.0866041,2.8679333,23.1064792),(6226,'radius-cleaned.tif',183,3,1612,10.7974588,4.0488003,9.5118759,1.8,4.0605462,9.5795995,0.031528,2.9951333,3.6562478,28.3055135,42.6438208,0.0017882,11.6632743,9.4505022,17.9378957,5.8200231,7.1358561,2.864061,23.6957844),(6227,'radius-cleaned.tif',183,3,1613,10.8131948,4.0297732,9.5259444,1.8,4.0435656,9.5933784,0.0312477,3.0095637,3.6769419,28.2178175,43.1215836,0.0017591,11.7275674,9.3760492,17.8270042,5.8200231,7.2019226,2.8724252,23.7038047),(6228,'radius-cleaned.tif',183,3,1614,10.8199393,4.017055,9.5434489,1.8,4.0255493,9.6102561,0.0308095,3.0234029,3.6909538,28.2372354,43.4626778,0.0017112,11.7754598,9.3395544,17.9003359,5.8217636,7.2126357,2.8670924,23.3048047),(6229,'radius-cleaned.tif',183,3,1615,10.7883873,4.016304,9.5608013,1.8,4.0218004,9.623569,0.0249413,3.0345128,3.7164662,28.3321353,43.5558691,0.0011183,11.7197001,9.3366341,17.9000737,5.823504,7.2793175,2.9205456,23.9488759),(6230,'radius-cleaned.tif',183,3,1616,10.7766139,4.0177832,9.5848956,1.8,4.0190893,9.6486355,0.0231607,3.0583169,3.7159123,28.5664171,43.7566109,0.0009633,11.7754693,9.3405679,17.9012187,5.8616256,7.2972291,2.9098758,24.0286759),(6231,'radius-cleaned.tif',183,3,1617,10.8383982,4.021583,9.6047981,1.8,4.0229524,9.6650337,0.0198683,3.0390988,3.746248,28.9347096,44.1752555,0.000713,11.7918662,9.520819,18.1498993,5.8269149,7.327926,2.8715202,24.2600556),(6232,'radius-cleaned.tif',183,3,1618,10.8721226,4.0212328,9.6314354,1.8,4.0145801,9.6860378,0.0155589,3.0638413,3.7416442,29.2336875,44.4904779,0.0004386,11.8906224,9.5415149,18.2750688,5.8269149,7.3712485,2.9399508,23.7699132),(6233,'radius-cleaned.tif',183,3,1619,10.905877,4.0248378,9.6588545,1.8,4.0135154,9.7070387,0.0058344,3.0804529,3.7240618,29.4920352,44.7471814,0.0000619,12.0156925,9.5739284,18.3825531,5.8269149,7.3876444,2.9293677,24.3575573),(6234,'radius-cleaned.tif',183,3,1620,10.946498,4.0188193,9.6857883,1.8,4.0018002,9.7343681,0.0016164,3.1035919,3.7241783,29.623634,45.1105465,0.0000048,12.1128857,9.5449514,18.4554881,5.8200231,7.4128146,2.8913921,24.1221674),(6235,'radius-cleaned.tif',183,3,1621,11.0225046,4.0118617,9.7078448,1.8,3.9954424,9.7575644,-0.0002626,3.1241198,3.7683168,29.8506943,45.607299,0.0000001,12.1028304,9.5549135,18.406802,5.8723606,7.4710022,2.9043859,24.4607302),(6236,'radius-cleaned.tif',183,3,1622,11.0551213,4.0088935,9.7209436,1.8,3.9905753,9.772373,0.0037063,3.1403095,3.7766631,29.9542049,46.1827979,0.0000253,12.2284665,9.5386156,18.5847777,5.8931003,7.482713,2.9211886,25.5545573),(6237,'radius-cleaned.tif',183,3,1623,11.1424546,4.0065428,9.7249438,1.8,3.983997,9.7780816,0.0144595,3.1148262,3.7979474,30.3782579,46.7802234,0.0003882,12.3172383,9.7527939,18.6660387,5.9119301,7.5216529,2.9223483,25.8366929),(6238,'radius-cleaned.tif',183,3,1624,11.318449,4.0067338,9.7273772,1.8,3.9763589,9.7806855,0.0284493,3.1283494,3.8486762,31.1619545,47.4897896,0.0015264,12.3392529,9.9611489,19.0326576,5.9205912,7.5394111,2.9120171,25.4981302),(6239,'radius-cleaned.tif',183,3,1625,11.469907,4.0217838,9.7401483,1.8,3.9937563,9.7948729,0.048749,3.1562158,3.8697103,31.8810446,48.1682876,0.0045394,12.4475177,10.1010344,19.3829217,5.9205912,7.55207,2.9286543,25.3949573),(6240,'radius-cleaned.tif',183,3,1626,11.651331,4.032256,9.7632133,1.8,4.0083435,9.8121295,0.0676202,3.1944861,3.9117896,32.4708606,48.9783673,0.0088658,12.5207059,10.1646587,19.7338768,5.9233762,7.5872976,2.8864103,26.4203269),(6241,'radius-cleaned.tif',183,3,1627,11.8227495,4.0354637,9.7966734,1.8,4.0156101,9.8360351,0.0721145,3.1967002,3.9312396,32.8370221,49.7761863,0.0102296,12.6617026,10.272162,19.8985857,5.9337494,7.6360305,2.8826732,24.8967946),(6242,'radius-cleaned.tif',183,3,1628,11.996111,4.0380924,9.8373196,1.8,4.0172801,9.8681818,0.0717159,3.2679694,3.9280318,33.219148,50.6171696,0.0102654,12.8861406,10.1650731,20.2063885,5.946542,7.6471764,2.92066,25.5755811),(6243,'radius-cleaned.tif',183,3,1629,12.2440582,4.0427403,9.8729949,1.8,4.0251197,9.8995417,0.0699453,3.262297,3.9185303,33.5293246,51.4594143,0.0099674,13.1323251,10.2778271,20.5736164,5.9507195,7.6746073,2.8840043,25.1595674),(6244,'radius-cleaned.tif',183,3,1630,12.7826867,4.0516489,9.8971061,1.8,4.0404147,9.9158493,0.0720932,3.2870679,3.9107078,34.0772224,52.485623,0.0110537,13.4210036,10.3670578,21.0433117,5.9587538,7.6746073,2.8840043,25.1458759),(6245,'radius-cleaned.tif',183,3,1631,13.4280577,4.0537141,9.9183241,1.8,4.044281,9.9357255,0.0748402,3.3037986,3.9473568,34.5232554,53.6593372,0.0125118,13.5937389,10.4495643,21.3718796,5.9660369,7.7039039,2.9116882,25.09512),(6246,'radius-cleaned.tif',183,3,1632,14.0719043,4.0611348,9.940823,1.8,4.0577696,9.9522145,0.071234,3.3266242,3.9339958,35.2047631,54.8637532,0.0118807,13.946063,10.5827291,21.9086966,5.9580041,7.7131976,2.8853221,25.5021403),(6247,'radius-cleaned.tif',183,3,1633,14.6994958,4.061389,9.9548256,1.8,4.0608907,9.954187,0.0702562,3.3344124,3.96579,35.9898733,55.9272109,0.0120727,14.1024136,10.793468,22.3089812,5.9899137,7.7427594,2.9128626,24.6477132),(6248,'radius-cleaned.tif',183,3,1634,15.3025248,4.0587164,9.9629296,1.8,4.0571413,9.9578062,0.0686094,3.3445982,3.9688175,36.9748157,56.8950717,0.0119866,14.3355225,11.0550845,22.7050317,5.9672609,7.7338101,2.8753406,24.8790929),(6249,'radius-cleaned.tif',183,3,1635,15.7380193,4.0552126,9.9685165,1.8,4.0554573,9.9724437,0.0714707,3.3462573,3.9780058,37.9171579,58.2077567,0.0133756,14.6323961,11.331214,23.195134,5.9707027,7.7418341,2.891614,24.7331844),(6250,'radius-cleaned.tif',183,3,1636,15.8164179,4.0445078,9.9595589,1.8,4.0492441,9.969624,0.0677927,3.3390518,4.0193955,38.2147297,59.1180149,0.0120964,14.7081855,11.4447848,23.3534791,5.9512108,7.7805002,2.8928827,24.803303),(6251,'radius-cleaned.tif',183,3,1637,15.7700388,4.0330366,9.9449317,1.8,4.04312,9.9540628,0.0635382,3.2881938,4.0219794,38.2355477,59.6057165,0.0105966,14.8199956,11.6281307,23.5231752,5.9721325,7.7418341,2.891614,24.9685743),(6252,'radius-cleaned.tif',183,3,1638,15.7154759,4.0192681,9.9397182,1.8,4.0351718,9.9420772,0.0570351,3.2796251,4.0290859,38.2380632,60.3324098,0.0085112,14.9742178,11.6592787,23.5839293,5.9475631,7.7338101,2.9178874,24.987937),(6253,'radius-cleaned.tif',183,3,1639,15.6555538,4.0000605,9.9416797,1.8,4.0154961,9.9457097,0.0451366,3.265333,4.0313998,38.392172,61.0347041,0.0053123,15.1398291,11.7575058,23.6436025,5.9740411,7.7338101,2.8753406,25.7254997),(6254,'radius-cleaned.tif',183,3,1640,15.6201021,3.994373,9.9384476,1.8,4.0199218,9.9409205,0.0461866,3.2377928,4.0383302,38.8293004,61.7521825,0.0055495,15.2915138,11.9925218,23.8814886,5.9874084,7.7619604,2.8816525,26.2236625),(6255,'radius-cleaned.tif',183,3,1641,15.6297564,4.0011313,9.9288681,1.8,4.0332566,9.9308529,0.0565542,3.227407,4.0427746,39.1973715,62.4797996,0.0083228,15.4546829,12.1451591,24.2695548,5.983232,7.7131976,2.8853221,25.65372),(6256,'radius-cleaned.tif',183,3,1642,15.7249319,4.0193199,9.9117365,1.8,4.0470411,9.9183478,0.0728624,3.2219967,4.0361068,39.4470455,63.1590513,0.0138892,15.6485083,12.2430435,24.5468048,5.9770042,7.7131976,2.8853221,25.6867743),(6257,'radius-cleaned.tif',183,3,1643,15.9183933,4.0473126,9.893882,1.8,4.0667415,9.9059731,0.0961559,3.2073388,4.0295688,39.6244162,63.8571306,0.0244546,15.8471375,12.354297,24.86291,6.0054941,7.6775109,2.9268696,25.2039641),(6258,'radius-cleaned.tif',183,3,1644,16.1070062,4.0753684,9.8808395,1.8,4.0883974,9.8952873,0.119479,3.205068,4.0005912,39.4755066,64.7497943,0.0381399,16.1850564,12.3165895,25.1616734,5.9155922,7.6784439,2.8625792,24.5114861),(6259,'radius-cleaned.tif',183,3,1645,16.2243358,4.1029056,9.8733453,1.8,4.1127942,9.8874702,0.1331687,3.1881964,3.9862456,39.0433795,65.6949216,0.0476707,16.4803998,12.2462279,25.4183898,5.9348739,7.6746073,2.8840043,24.4373573),(6260,'radius-cleaned.tif',183,3,1646,16.356947,4.1239149,9.8698822,1.8,4.1277072,9.8843824,0.1435495,3.1672577,3.9632109,38.6664952,66.5650927,0.0557917,16.7957483,12.2081935,25.6466639,5.9999275,7.6784439,2.8625792,25.5328455),(6261,'radius-cleaned.tif',183,3,1647,16.4803672,4.1405406,9.8568833,1.8,4.1391914,9.8642589,0.1546037,3.1492094,3.9567539,38.2839778,67.1047666,0.0651317,16.9595504,12.1566948,25.7432653,5.8813559,7.6625664,2.8511334,24.5598929),(6262,'radius-cleaned.tif',183,3,1648,16.6856557,4.1497593,9.8403702,1.8,4.1409751,9.8458835,0.1672264,3.1081761,3.9591138,38.0214308,67.7204163,0.0770459,17.1049433,12.2327145,26.0565809,5.8794443,7.656019,2.9155751,24.4099742),(6263,'radius-cleaned.tif',183,3,1649,16.9206082,4.1471045,9.8144339,1.8,4.1277771,9.816035,0.1806088,3.1044163,3.9645761,37.9361543,68.0434598,0.0909945,17.1628589,12.2200604,26.0284352,5.8345905,7.6360305,2.8826732,24.4744217),(6264,'radius-cleaned.tif',183,3,1650,17.165536,4.1420702,9.7911308,1.8,4.1220958,9.8017105,0.1971488,3.2223287,3.9714388,37.8886801,68.6135505,0.1097641,17.2767488,11.7581673,26.0630876,5.868123,7.6476968,2.8396415,24.6106488),(6265,'radius-cleaned.tif',183,3,1651,17.3126364,4.1392715,9.772206,1.8,4.1249495,9.795958,0.2115246,3.2121675,3.9877469,37.6492392,68.9898312,0.1271882,17.3004538,11.7208208,26.0278301,5.8396673,7.6359262,2.8446304,24.8597302),(6266,'radius-cleaned.tif',183,3,1652,17.329221,4.1331045,9.7663991,1.8,4.1112504,9.8008171,0.2153717,3.2539893,3.9975105,37.3863481,68.8524829,0.1319106,17.2238405,11.4893889,26.0768535,5.8600478,7.618393,2.8712065,25.2450387),(6267,'radius-cleaned.tif',183,3,1653,17.1875889,4.1290482,9.7677704,1.8,4.0990762,9.8078102,0.2076968,3.3224034,3.9899892,36.727505,68.5529946,0.1218062,17.1812483,11.0544989,25.8216087,5.8454145,7.618393,2.8712065,25.626337),(6268,'radius-cleaned.tif',183,3,1654,16.8951932,4.1310806,9.7688047,1.8,4.0999982,9.8162867,0.194058,3.3310645,3.9689678,35.7502885,67.5640619,0.1047169,17.0230814,10.7323915,25.3833864,5.5822222,7.5995625,2.9246321,24.6260014),(6269,'radius-cleaned.tif',183,3,1655,16.5486226,4.1354243,9.7651448,1.8,4.1098282,9.8194287,0.1799108,3.3124233,3.9450595,34.5779249,66.399745,0.0883149,16.8311136,10.4388605,24.8231345,5.4285981,7.5782697,2.9132153,24.2116488),(6270,'radius-cleaned.tif',183,3,1656,16.2853979,4.1311076,9.7554523,1.8,4.1057345,9.8130328,0.168981,3.3145348,3.9411498,33.6144859,65.4149956,0.0767689,16.5979472,10.1415397,24.2953818,5.4186881,7.5606028,2.9234961,24.9041268),(6271,'radius-cleaned.tif',183,3,1657,16.0426985,4.1331625,9.7418685,1.8,4.1096077,9.799494,0.162022,3.3442874,3.9018289,32.7383715,64.323652,0.0695778,16.4855132,9.7893416,23.9975323,5.3525794,7.5304315,2.9171766,23.6223436),(6272,'radius-cleaned.tif',183,3,1658,15.7938326,4.1349626,9.726391,1.8,4.1101382,9.782407,0.1616004,3.392096,3.902115,31.9345053,63.1206711,0.0681456,16.1760151,9.4143871,23.5521608,5.3058761,7.5005635,2.9108066,25.01532),(6273,'radius-cleaned.tif',183,3,1659,15.5755687,4.1343177,9.7060275,1.8,4.1130154,9.7574002,0.1630208,3.4144331,3.8816133,31.037927,62.0291744,0.0683799,15.980256,9.0902139,23.1247006,5.278056,7.465673,2.9316191,23.7271776),(6274,'radius-cleaned.tif',183,3,1660,15.3533205,4.1252931,9.6922332,1.8,4.1066701,9.7481279,0.1631728,3.4333101,3.8928938,30.3542796,60.7850049,0.0675288,15.6143496,8.841112,22.657394,5.2482539,7.4647133,2.8654956,23.6199945),(6275,'radius-cleaned.tif',183,3,1661,15.1240905,4.1117288,9.6792471,1.8,4.101015,9.7383747,0.1617477,3.4278757,3.8942357,29.7202545,59.5519318,0.0653738,15.2923285,8.6701668,22.0957191,5.1975384,7.4614069,2.8875351,23.8086386),(6276,'radius-cleaned.tif',183,3,1662,14.8720007,4.0926422,9.6731195,1.8,4.084701,9.738131,0.1565097,3.4545245,3.8950732,29.1731839,58.1768202,0.0602215,14.9360018,8.4449203,21.5235459,5.2129239,7.4229017,2.9083475,24.5268386),(6277,'radius-cleaned.tif',183,3,1663,14.5959222,4.0753941,9.6685918,1.8,4.0692426,9.7327084,0.1505471,3.4517209,3.9066306,28.6086709,56.4222164,0.0547194,14.4426803,8.2882341,20.8626079,5.1815839,7.413781,2.9135836,23.1919504),(6278,'radius-cleaned.tif',183,3,1664,14.1864277,4.0632214,9.6710665,1.8,4.0599218,9.735571,0.1352926,3.4463304,3.8803745,27.9083229,54.3852973,0.0430149,14.0154763,8.0979825,20.4082477,5.1922931,7.3712485,2.9399508,23.1822691),(6279,'radius-cleaned.tif',183,3,1665,13.647851,4.055299,9.6795773,1.8,4.0471625,9.7459516,0.1136217,3.431147,3.8658643,27.1457195,52.199261,0.0292392,13.5026107,7.9115584,19.4061397,5.204438,7.3970125,3.0768185,24.2406929),(6280,'radius-cleaned.tif',183,3,1666,13.0304277,4.0580605,9.6977843,1.8,4.0467326,9.770092,0.0826786,3.3790522,3.801593,26.4027509,49.7863299,0.0148117,13.0961756,7.8136559,18.683072,5.2273365,7.3728681,3.0494629,26.0657235),(6281,'radius-cleaned.tif',183,3,1667,12.4325317,4.0604793,9.7194296,1.8,4.0496456,9.7988908,0.0563237,3.3019819,3.7583022,25.6526189,47.7861028,0.0065665,12.7148111,7.768855,18.061115,5.2425284,7.3815002,2.8283889,25.4780794),(6282,'radius-cleaned.tif',183,3,1668,11.9273587,4.0471762,9.7438942,1.8,4.0345381,9.8263253,0.0294257,3.2544451,3.735016,25.0945072,45.9956518,0.0017208,12.3147134,7.7108405,17.6929626,5.2687922,7.4383277,3.017903,25.6730828),(6283,'radius-cleaned.tif',183,3,1669,11.6683085,4.0155158,9.7722619,1.8,4.0036751,9.854352,0.0063672,2.9701676,3.7341752,24.8195883,45.156122,0.0000788,12.0926628,8.3562921,17.5076803,5.2393272,7.4383277,3.017903,23.9916115),(6284,'radius-cleaned.tif',183,3,1670,11.5110493,3.9807205,9.8002269,1.8,3.9731451,9.880196,-0.0109088,2.9884446,3.7065352,24.7020075,44.5589909,0.0002283,12.0217369,8.2658409,17.3277348,5.3329898,7.3938911,3.0225924,24.2156589),(6285,'radius-cleaned.tif',183,3,1671,11.4379826,3.9473716,9.8246297,1.8,3.9442048,9.8956144,-0.0237306,2.9018959,3.7240879,24.5023856,44.3281915,0.0010733,11.9031001,8.4435784,17.2008443,5.2857827,7.3591439,3.0165652,24.1665641),(6286,'radius-cleaned.tif',183,3,1672,11.4736852,3.914167,9.8501481,1.8,3.9162824,9.9132141,-0.0275436,2.9092706,3.7143024,24.3961722,44.273743,0.0014504,11.9198003,8.3856662,17.1664654,5.2821815,7.3355259,2.9996956,26.9612252),(6287,'radius-cleaned.tif',183,3,1673,11.5792517,3.8766248,9.8719259,1.8,3.8718532,9.9296585,-0.030397,2.8737933,3.7586795,24.3245262,44.4753896,0.0017826,11.8327167,8.4642574,17.1382242,5.2361507,7.3369365,3.0435474,25.0113099),(6288,'radius-cleaned.tif',183,3,1674,11.6953923,3.853596,9.8935314,1.8,3.8502984,9.9493839,-0.0362057,2.8807229,3.7743186,24.2169131,44.5359015,0.002554,11.7997197,8.4065404,17.083109,5.2019525,7.2972291,3.0430121,23.4684148),(6289,'radius-cleaned.tif',183,3,1675,11.7705491,3.834824,9.9128733,1.8,3.8268599,9.962991,-0.0400983,2.8524159,3.7900198,24.0057916,44.6006721,0.0031526,11.7679258,8.4159508,17.1947788,5.1538405,7.2972291,3.0430121,25.3829268),(6290,'radius-cleaned.tif',183,3,1676,11.8271178,3.8265012,9.94038,1.8,3.8117031,9.9879999,-0.041874,2.8580452,3.8326075,23.796796,44.7389731,0.0034543,11.6732469,8.3262491,17.0496242,5.1460657,7.3524346,3.0872982,25.120154),(6291,'radius-cleaned.tif',183,3,1677,11.8716659,3.8180239,9.9643607,1.8,3.787434,10.0047955,-0.039454,2.839715,3.8446114,23.5436991,44.6427255,0.0030783,11.6117654,8.2908669,16.9103983,5.1368142,7.3628206,3.065652,27.274754),(6292,'radius-cleaned.tif',183,3,1678,12.0516563,3.8043259,9.9807428,1.8,3.7580827,10.0153718,-0.0364109,2.8289988,3.8605939,23.350679,44.709883,0.0026617,11.5810893,8.2540434,16.8858,5.1323291,7.3547078,3.0818811,27.0313439),(6293,'radius-cleaned.tif',183,3,1679,12.3567605,3.7732853,9.9829763,1.8,3.7182307,10.0132204,-0.0361783,2.8370588,3.8876102,23.1152569,44.9313972,0.0026944,11.557588,8.1476129,16.7599032,5.1076987,7.3433348,3.1198569,27.0780896),(6294,'radius-cleaned.tif',183,3,1680,12.6999658,3.7453693,9.9881649,1.8,3.7020842,10.0236914,-0.0398614,2.8274785,3.9113723,22.8213945,45.2470085,0.0033614,11.5680649,8.0712886,16.5931052,5.0790598,7.0415307,3.0678629,26.2760794),(6295,'radius-cleaned.tif',183,3,1681,12.9944309,3.7141096,9.9957035,1.8,3.6766089,10.0360706,-0.0512386,2.8001551,3.9211131,22.4779661,45.413903,0.0056809,11.5818905,8.0274003,16.2428719,5.0487978,7.0153688,3.0447536,25.5932828),(6296,'radius-cleaned.tif',183,3,1682,13.2204926,3.6931869,10.0016902,1.8,3.6668098,10.0417724,-0.0613537,2.8064944,3.9331081,22.1675231,45.2345974,0.0082839,11.5009799,7.8986521,16.0099197,5.0200529,6.9590909,3.0727362,25.0209912),(6297,'radius-cleaned.tif',183,3,1683,13.3919558,3.6698741,10.009002,1.8,3.6452632,10.0532505,-0.0751486,2.7478232,3.9231475,21.8531697,44.7599934,0.0125811,11.4092049,7.9529023,15.7478041,4.9983513,6.9137618,0.1214917,25.1515471),(6298,'radius-cleaned.tif',183,3,1684,13.5149637,3.6435928,10.0101378,1.8,3.6137055,10.0551248,-0.0894169,2.7479026,3.778185,21.5753444,43.9152733,0.0179616,11.6233782,7.8515681,16.0103712,4.9203538,6.945466,0.0287277,25.1942827),(6299,'radius-cleaned.tif',183,3,1685,13.6870726,3.6108482,10.0090101,1.8,3.5768949,10.0578959,-0.1026151,2.6980278,3.7863593,21.3978901,43.5132498,0.0239363,11.4921078,7.9309376,15.7926582,4.9121346,6.9883118,0.1144403,25.5852625),(6300,'radius-cleaned.tif',183,3,1686,13.8955194,3.5723172,10.0095364,1.8,3.5434692,10.0664272,-0.1171082,2.6694936,3.6029809,21.2494278,43.3587326,0.0316164,12.0341279,7.9600968,16.2793572,4.8812918,6.9929803,0.1201087,25.5562184),(6301,'radius-cleaned.tif',183,3,1687,14.062668,3.548541,10.0101777,1.8,3.5297162,10.0708525,-0.1197822,2.6664945,3.6222797,20.8618236,42.9909829,0.0334675,11.8684878,7.823689,16.0479604,4.8458832,7.0445822,0.0793783,25.147537),(6302,'radius-cleaned.tif',183,3,1688,14.2540939,3.5333038,10.0159352,1.8,3.5158681,10.077067,-0.1243689,2.6587598,3.6750653,20.4288736,42.8494765,0.0365571,11.6595142,7.6836102,15.7483389,4.8166542,7.0843573,0.0789317,24.2640658),(6303,'radius-cleaned.tif',183,3,1689,14.4145709,3.522103,10.020887,1.8,3.4994653,10.0775855,-0.1241825,2.6555843,3.6326212,19.948036,42.6816926,0.0368585,11.7495576,7.5117314,15.9424259,4.7552285,6.9862612,0.1548204,23.9351844),(6304,'radius-cleaned.tif',183,3,1690,14.4727102,3.5140963,10.0289134,1.8,3.4943366,10.0867811,-0.1167808,2.6273378,3.6518635,19.3684874,42.1595293,0.0327466,11.5446619,7.3719062,15.6822207,4.6926425,7.0279522,0.113792,24.5946082),(6305,'radius-cleaned.tif',183,3,1691,14.4604838,3.5070812,10.0341651,1.8,3.4908528,10.0933854,-0.1138777,2.588483,3.6634163,18.7332124,41.5082717,0.0311194,11.3304819,7.2371395,15.3728901,4.6306677,7.0632018,0.1075381,22.8767606),(6306,'radius-cleaned.tif',183,3,1692,14.3337086,3.4967179,10.0410341,1.8,3.479561,10.1013295,-0.1149386,2.5504755,3.6730505,17.9975876,40.6007398,0.0314214,11.0536841,7.0565615,14.9587195,4.5568563,7.0632018,0.1075381,23.0654047),(6307,'radius-cleaned.tif',183,3,1693,14.194816,3.4823268,10.0473248,1.8,3.4655143,10.1087708,-0.1190865,2.5087885,3.6173934,17.2651156,39.7179096,0.0333926,10.9797042,6.8818538,14.8627986,4.5199248,6.9978733,0.1257694,22.5301775),(6308,'radius-cleaned.tif',183,3,1694,14.0447003,3.4628113,10.0541282,1.8,3.449803,10.1159244,-0.1302816,2.4521622,3.6234737,16.5798,38.7317033,0.0395066,10.6891083,6.7612983,14.3928039,4.5026395,7.0029901,0.131422,22.2480419),(6309,'radius-cleaned.tif',183,3,1695,13.8884729,3.4355653,10.0602404,1.8,3.422229,10.1255897,-0.1489298,2.3811825,3.5538256,15.9454044,37.4911416,0.0509628,10.5495165,6.6964226,14.1284981,4.4263589,6.9407655,0.150027,21.664408),(6310,'radius-cleaned.tif',183,3,1696,13.7038792,3.4107502,10.0664947,1.8,3.4021695,10.1330888,-0.1674611,2.342965,3.5287013,15.3319419,36.3312404,0.0634537,10.2959241,6.5438202,13.7458714,4.3828173,6.8743892,0.1632403,21.5475436),(6311,'radius-cleaned.tif',183,3,1697,13.5109087,3.3807559,10.0765895,1.8,3.3713575,10.1468486,-0.1897658,2.3062042,3.4991441,14.7752784,35.3025402,0.0801217,10.0889071,6.4067521,13.4155308,4.3323704,6.8416577,0.1699425,21.212991),(6312,'radius-cleaned.tif',183,3,1698,13.2399187,3.3541703,10.0837093,1.8,3.3484234,10.156294,-0.2093948,2.2641026,3.4779986,14.1323339,34.1824456,0.0953475,9.8281941,6.2419141,13.0151735,4.284434,6.8350227,0.164189,22.4213334),(6313,'radius-cleaned.tif',183,3,1699,12.9797708,3.3211015,10.0924282,1.8,3.3158845,10.1647935,-0.2263179,2.2376404,3.4900114,13.544841,33.2594022,0.1089246,9.5298836,6.0531804,12.5219253,4.2725564,6.8743892,0.1632403,21.586269),(6314,'radius-cleaned.tif',183,3,1700,12.7186734,3.2890072,10.1009732,1.8,3.2848486,10.1709303,-0.2411942,2.2198169,3.434965,12.966037,32.3726731,0.1209446,9.424455,5.841039,12.3068485,4.2392707,6.8237168,0.1882215,20.9445469),(6315,'radius-cleaned.tif',183,3,1701,12.4021661,3.2613209,10.1104722,1.8,3.259994,10.1767247,-0.2531218,2.2038107,3.4293771,12.3352202,31.3647507,0.1296315,9.145903,5.5972231,11.9207296,4.1744547,6.831295,0.1939591,21.5475436),(6316,'radius-cleaned.tif',183,3,1702,12.0872102,3.237357,10.1217956,1.8,3.236821,10.1847059,-0.2637518,2.1869242,3.4135154,11.7689636,30.4466817,0.1369215,8.9194504,5.3815143,11.5957509,4.1292895,6.7999951,0.2008478,21.3976249),(6317,'radius-cleaned.tif',183,3,1703,11.6893784,3.2163002,10.1359954,1.8,3.2152528,10.1953964,-0.274876,2.1553986,3.4066031,11.1473093,29.4638818,0.1435318,8.6490504,5.1718087,11.2269625,4.0817831,6.7947253,0.2250383,21.4580622),(6318,'radius-cleaned.tif',183,3,1704,11.2080919,3.1967755,10.1553899,1.8,3.1935634,10.2111851,-0.2839154,2.1044414,3.4197202,10.4308852,28.5317261,0.1465742,8.3432925,4.9566051,10.725499,4.0506715,6.7947253,0.2250383,21.4290181),(6319,'radius-cleaned.tif',183,3,1705,10.5912169,3.1842008,10.1705693,1.8,3.1808754,10.2241205,-0.2863701,2.0747214,3.3850543,9.4728251,27.1405949,0.1408463,8.0177725,4.56583,10.1833496,3.9924885,6.7260799,0.2334684,22.4196724),(6320,'radius-cleaned.tif',183,3,1706,10.0461656,3.1666221,10.1891182,1.8,3.1571404,10.2463947,-0.2900217,2.027937,3.4511825,8.6299882,26.0615981,0.1369302,7.5514981,4.2555505,9.3813166,3.9079365,6.7558373,0.2263562,20.4463841),(6321,'radius-cleaned.tif',183,3,1707,9.5773728,3.1520166,10.2080837,1.8,3.1382966,10.2640346,-0.2960389,2.0088209,3.4512493,7.9612765,24.9690456,0.1358527,7.2347846,3.963159,8.9018599,3.8370272,6.7260799,0.2334684,21.0670825),(6322,'radius-cleaned.tif',183,3,1708,9.1755517,3.1327681,10.2271721,1.8,3.1137866,10.2808639,-0.2998795,2.007501,3.4794567,7.4024748,23.9449799,0.1334495,6.8818157,3.6874078,8.2045412,0.0399,0.0564271,2.3561945,0.1128542),(6323,'radius-cleaned.tif',183,3,1709,8.7539787,3.1118512,10.2403902,1.8,3.0850316,10.2884203,-0.2977234,2.0134881,3.4758389,6.8459783,22.855945,0.1255481,6.5756629,3.400059,7.8163829,3.7328412,6.7260799,0.3386345,21.5692554),(6324,'radius-cleaned.tif',183,3,1710,8.295969,3.0906208,10.2537236,1.8,3.0580579,10.299102,-0.2940077,1.966028,3.3765499,6.2441988,21.6995783,0.1161137,6.4265534,3.1760477,7.7133384,3.626888,6.7155388,0.3518167,21.2306926),(6325,'radius-cleaned.tif',183,3,1711,7.8032409,3.0687196,10.2609679,1.8,3.0366796,10.3019697,-0.2908908,1.9504073,3.3765831,5.725243,20.3231384,0.1069792,6.0188475,2.9354088,7.4876283,3.5589747,6.7384948,0.3067704,21.2170011),(6326,'radius-cleaned.tif',183,3,1712,7.1871816,3.0489371,10.2585739,1.8,3.019299,10.2934003,-0.280097,1.9385274,3.3874896,5.0952174,18.611173,0.0915455,5.4940901,2.6283959,6.8449387,3.5032984,6.680957,0.2782997,21.0203367),(6327,'radius-cleaned.tif',183,3,1713,6.6040974,3.0152033,10.2680555,1.8,2.9859266,10.3037915,-0.2706372,1.9030292,3.384304,4.4588884,17.1763749,0.0786698,5.0753049,2.3430478,6.3094442,3.4158749,6.6624639,0.3103874,20.5398757),(6328,'radius-cleaned.tif',183,3,1714,5.8551787,2.9906648,10.2645254,1.8,2.9712702,10.2911021,-0.2554183,1.8693659,3.3950019,3.7579907,15.4777746,0.0622914,4.5589885,2.0103024,5.5829932,1.7844824,4.350747,0.8372996,12.0711091),(6329,'radius-cleaned.tif',183,3,1715,5.294727,2.9297103,10.2846048,1.8,2.9157103,10.3121261,-0.2513034,1.863021,3.4326978,3.2721541,14.0195952,0.0545667,4.0841333,1.75637,4.9804483,1.7885122,4.4070992,0.8366353,12.8046617),(6330,'radius-cleaned.tif',183,3,1716,4.6879962,2.8544483,10.2854718,1.8,2.8553399,10.3158679,-0.2403026,1.8070313,3.4727675,2.7085425,12.5698776,0.0442565,3.6195564,1.4988908,4.3563051,1.7519937,4.4368012,0.8426603,14.0734414),(6331,'radius-cleaned.tif',183,3,1717,4.0023355,2.8004064,10.246219,1.8,2.8577573,10.2547661,-0.2136725,1.734731,3.4764758,2.1597787,10.629394,0.0299944,3.0575199,1.2450223,3.663908,1.6162171,4.3753767,0.817645,13.4156787),(6332,'radius-cleaned.tif',183,3,1718,3.4991623,2.6603985,10.2361608,1.8,2.7600214,10.2395014,-0.2141131,1.7885218,3.572022,1.7486368,9.2365385,0.0263301,2.5858011,0.9776995,3.0610008,1.6269896,4.843045,0.8728935,16.1128381),(6333,'radius-cleaned.tif',183,3,1719,2.9031812,2.4646072,10.2251187,1.8,2.6212211,10.2257084,-0.2189356,1.8567327,3.7287491,1.2545177,7.5562231,0.0228247,2.0264767,0.6756587,2.3514328,1.5884191,4.486045,0.7916874,12.9078346),(6334,'radius-cleaned.tif',183,3,1720,2.4484017,2.2298413,10.261991,1.8,2.4218115,10.2678238,-0.240259,1.8609686,3.8302966,1.0119632,5.7748881,0.0231057,1.5076869,0.5437831,1.7659523,1.5232721,4.3452548,0.7724119,12.6216888),(6335,'radius-cleaned.tif',183,3,1721,1.9332584,1.8319367,10.2663614,1.8,1.9950411,10.2310287,-0.3327385,1.7225209,4.0520526,0.572758,3.4256021,0.0343762,0.8453992,0.3325115,0.9792909,1.40586,3.8074721,0.6665578,11.0433904),(6336,'radius-cleaned.tif',183,3,1722,1.6191832,1.4455509,10.3631754,1.8,1.52494,10.3587496,-0.5958631,1.6036671,4.0478261,0.353303,1.1117648,0.0849994,0.2746573,0.2203094,0.3418488,1.3679305,2.9536783,0.9002748,10.5041531),(6337,'radius-cleaned.tif',183,3,1723,1.4140754,1.3180461,10.387491,1.8,1.3205994,10.4066155,-1.0033005,1.7584885,2.5427688,0.1289747,0.5942873,0.1675844,0.2337166,0.073344,0.2348676,1.285619,2.8730771,0.9134072,8.9338751),(6338,'radius-cleaned.tif',183,3,1724,1.2982547,1.2850641,10.4025933,1.8,1.2617208,10.4285458,-1.0414493,1.1446678,2.376201,0.0889893,0.5137065,0.1612011,0.2161881,0.0777424,0.2465715,1.2138654,3.7567498,1.0358413,10.4380447),(6339,'radius-cleaned.tif',183,3,1725,1.2121377,1.2842908,10.4162761,1.8,1.2598782,10.4456778,-1.0522082,1.0030777,2.5565866,0.0761439,0.4473785,0.1523913,0.1749905,0.0759102,0.1976699,1.168456,2.9439604,0.9978302,9.0524005),(6340,'radius-cleaned.tif',183,3,1726,1.1253401,1.2774556,10.4446225,1.8,1.2454224,10.4910274,-1.0872059,0.7841305,2.5405455,0.0624713,0.3507341,0.1470091,0.1380546,0.0796695,0.1561858,1.1298178,2.634911,1.012197,7.9939767),(6341,'radius-cleaned.tif',183,3,1727,1.0073019,1.2458984,10.4667059,1.8,1.1859809,10.528846,-1.1138571,0.5696684,1.3106471,0.0434993,0.27271,0.1352033,0.2080728,0.0763589,0.2333663,1.0877074,2.5010013,0.978369,7.0774512),(6342,'radius-cleaned.tif',183,3,1728,0.9202285,1.2384364,10.4789348,1.8,1.1758967,10.5421888,-1.1052598,0.5295528,1.2992772,0.0339639,0.2403461,0.122465,0.1849845,0.064137,0.2045772,1.0095417,2.4789431,0.9917221,6.8751156),(6343,'radius-cleaned.tif',183,3,1729,0.8634731,1.2314889,10.5004661,1.8,1.1705027,10.5640516,-1.0867612,0.5113571,1.3014607,0.0298392,0.2227665,0.1127473,0.1711665,0.0583529,0.1875622,0.1388353,0.2676573,1.1071487,0.611017),(6344,'radius-cleaned.tif',183,3,1730,0.792486,1.2229628,10.5223114,1.8,1.163052,10.5851286,-1.0725019,0.5111746,1.2639353,0.0247884,0.1965777,0.1019117,0.1555283,0.048493,0.1705338,0.1606348,0.3764159,1.012197,0.8600984),(6345,'radius-cleaned.tif',183,3,1731,0.7134279,1.2148654,10.5470555,1.8,1.1571,10.6124907,-1.0638191,0.514353,1.2408923,0.0194593,0.1736762,0.0908733,0.1399607,0.0378326,0.1515666,0.1452065,0.3038694,1.1659045,0.7569255),(6346,'radius-cleaned.tif',183,3,1732,0.6404894,1.2127942,10.5602878,1.8,1.1549791,10.627584,-1.0514761,0.4970714,1.231858,0.0156648,0.1520471,0.0804557,0.1234291,0.0315142,0.1327792,0.1197,0.2523498,1.8925469,0.690817),(6347,'radius-cleaned.tif',183,3,1733,0.566083,1.2089397,10.5744465,1.8,1.1498323,10.6435615,-1.0414893,0.4786502,1.2204167,0.0124261,0.1312973,0.0702924,0.107584,0.0259606,0.1149727,0.1197,0.2821356,1.7126934,0.690817),(6348,'radius-cleaned.tif',183,3,1734,0.4894123,1.2013182,10.5920404,1.8,1.1412036,10.6549694,-1.0287206,0.4781882,1.1841841,0.0103013,0.1097434,0.0598577,0.0926743,0.0215423,0.0996161,0.1596,0.3409058,1.2120257,0.850417),(6349,'radius-cleaned.tif',183,3,1735,0.4122934,1.1942562,10.6134071,1.8,1.138079,10.6676324,-1.0252109,0.46176,1.1837365,0.0082329,0.0895408,0.0502121,0.0756425,0.0178293,0.0806971,0.1596,0.3409058,1.2120257,0.8367255),(6350,'radius-cleaned.tif',183,3,1736,0.3194209,1.1854001,10.6490183,1.8,1.1309992,10.7072134,-0.9975713,0.4453606,1.1340641,0.0052337,0.0647291,0.0375779,0.0570771,0.0117516,0.0607181,0.1596,0.2904764,1.849096,0.7802984),(6351,'radius-cleaned.tif',183,3,1737,0.2494376,1.1756861,10.6726773,1.8,1.1331357,10.7077978,-0.9505553,0.4391958,1.1174978,0.0043649,0.0473571,0.0275284,0.0423778,0.0099385,0.0458378,0.1856749,0.45493,1.3045443,1.1656068),(6352,'radius-cleaned.tif',183,3,1738,0.1611637,1.1175078,10.7447357,1.8,1.0888193,10.7659886,-0.9402724,0.3983082,1.0265427,0.0027633,0.0291068,0.0175241,0.0283542,0.0069376,0.0307602,0.1995,0.45493,1.3045443,1.1325526),(6353,'radius-cleaned.tif',183,3,1739,0.1034129,0.9779133,10.8751836,1.8,0.9702,10.8677336,-1.0004082,0.314328,0.8924509,0.0022013,0.0142696,0.0122104,0.0159892,0.0070033,0.0184514,0.2505035,0.6446042,1.1902899,1.6073425),(6354,'radius-cleaned.tif',183,3,1740,0.0701092,0.930368,10.9427897,1.8,0.9268297,10.934291,-1.1370271,0.2276753,0.9707894,0.0012033,0.0076792,0.0096208,0.0079102,0.0052853,0.0090897,0.2247655,0.4460956,1.1071487,1.0858068),(6355,'radius-cleaned.tif',183,3,1741,0.0479188,0.9375549,10.9604103,1.8,0.9383711,10.9513485,-1.1070996,0.2017871,1.2650652,0.0005157,0.0077621,0.0063889,0.0061357,0.0025559,0.0065363,0.2539221,0.4804596,0.844154,1.1752882),(6356,'radius-cleaned.tif',183,3,1742,0.0264071,0.8692303,11.0937585,1.8,0.86716,11.0922003,-1.2326539,0.1744309,0.4403421,0.0002064,0.0011625,0.0039168,0.0026401,0.0011834,0.0028903,0.224472,0.5109693,0.8960554,1.1656068),(6357,'radius-cleaned.tif',183,3,1743,10.4611439,3.8045116,11.4648026,1.8,3.7819813,11.4699252,0.0898504,2.1946149,3.6358189,10.4231853,37.0546827,0.0140378,10.1915645,4.749437,11.9652259,6.1459579,8.0698677,2.3422094,52.6239386),(6358,'radius-cleaned.tif',183,3,1744,10.0139342,3.8606019,11.5350787,1.8,3.832819,11.5339458,0.0619191,2.1677065,3.5873496,9.5440851,35.463166,0.0063907,9.8856174,4.4028492,11.2842696,6.1137967,7.9284625,2.3668702,50.9698503),(6359,'radius-cleaned.tif',183,3,1745,9.550279,3.9375227,11.6114786,1.8,3.907886,11.6044179,0.0339765,2.1806847,3.6743216,8.659953,33.6803065,0.0018368,9.1664014,3.9712082,10.5125542,6.102972,7.8636414,2.4280132,45.4924093),(6360,'radius-cleaned.tif',183,3,1746,9.1445752,4.0102481,11.6829086,1.8,3.9785535,11.6738813,0.0071578,2.1049959,3.7664118,7.8826196,31.9025017,0.0000781,8.4702638,3.7447198,9.7820233,0.1631152,0.5426987,0.942,1.142234),(6361,'radius-cleaned.tif',183,3,1747,8.7619783,4.0869731,11.7570182,1.8,4.0460028,11.7419035,-0.0206606,2.1060701,3.8767052,7.0667817,30.3430193,0.0006233,7.8270122,3.3554352,9.098405,0.1428315,0.4107957,1.0636978,0.8834712),(6362,'radius-cleaned.tif',183,3,1748,8.4856316,4.1651544,11.8260557,1.8,4.1373897,11.8168902,-0.0391553,2.0941477,3.9767989,6.4222095,28.9336755,0.0021672,7.2756194,3.0667414,8.495899,3.0515957,5.6587711,1.0787652,21.0567131),(6363,'radius-cleaned.tif',183,3,1749,8.1478375,4.2564683,11.8877789,1.8,4.2315639,11.8826408,-0.0575445,2.0727999,4.0862854,5.826486,27.1225481,0.0044918,6.637458,2.8109254,7.7928506,3.0515957,5.5292822,1.2170932,20.7535537),(6364,'radius-cleaned.tif',183,3,1750,7.7712283,4.3739608,11.9403948,1.8,4.3486904,11.9414317,-0.0761155,2.0381293,4.2188973,5.316662,24.7060729,0.0074894,5.8560499,2.608599,6.9429713,3.0417457,5.4976642,1.1916377,18.4804282),(6365,'radius-cleaned.tif',183,3,1751,7.4305764,4.4776785,11.9804907,1.8,4.4369831,11.9814686,-0.0871426,1.9882355,4.3289336,4.8984361,22.3859502,0.0093807,5.171239,2.4637102,6.1839181,2.8420263,5.2827963,1.022605,25.7037879),(6366,'radius-cleaned.tif',183,3,1752,7.122329,4.5696412,12.019444,1.8,4.519304,12.0284571,-0.0906273,1.7995405,4.4199393,4.4948792,20.2462511,0.009723,4.5806627,2.4977928,5.5101454,2.6771985,5.1903752,0.9934543,23.4894386),(6367,'radius-cleaned.tif',183,3,1753,6.8034756,4.658449,12.0556759,1.8,4.5947155,12.0616095,-0.0906342,1.8328379,4.5051086,4.0754652,18.1812106,0.0092891,4.0356875,2.2235819,4.873857,2.4995979,5.0243909,0.971781,17.2156586),(6368,'radius-cleaned.tif',183,3,1754,6.3725524,4.7726796,12.0937326,1.8,4.6953718,12.0995833,-0.0812225,1.8427587,4.568881,3.5525812,15.4136971,0.0069913,3.3736263,1.9278602,4.0970858,5.5687891,7.2465476,2.7518841,36.9358224),(6369,'radius-cleaned.tif',183,3,1755,5.8268626,4.9166509,12.1327689,1.8,4.8212462,12.1393447,-0.066057,1.6999081,4.3796354,3.0060623,12.3390653,0.0042314,2.8173727,1.7683675,3.4485448,2.2619435,4.6684706,0.9187484,18.1225027),(6370,'radius-cleaned.tif',183,3,1756,5.3027049,5.0535759,12.17775,1.8,4.9490307,12.185581,-0.0584068,1.6640732,4.1888986,2.5185522,9.9562375,0.0030115,2.3768151,1.5134864,2.9269822,2.3853578,4.373921,0.9473655,18.0193298),(6371,'radius-cleaned.tif',183,3,1757,4.7879756,5.1885757,12.2293406,1.8,5.0836428,12.233662,-0.064793,1.5945676,3.5930151,2.0863389,8.0729576,0.0033454,2.2468477,1.3084042,2.7998217,2.1400829,4.157649,0.9215371,16.1492145),(6372,'radius-cleaned.tif',183,3,1758,4.3610003,5.2928275,12.2833891,1.8,5.1916979,12.2844086,-0.0771891,1.5199887,3.6376904,1.7211232,6.8258375,0.004322,1.8764207,1.1323263,2.3134805,1.9708973,3.7072662,0.9768236,16.82634),(6373,'radius-cleaned.tif',183,3,1759,3.945548,5.4072768,12.3283373,1.8,5.3245679,12.3232258,-0.0701381,1.4481992,3.5450612,1.3989041,5.4377722,0.0032296,1.5339008,0.9659611,1.8986027,3.9733729,5.4512806,1.7251151,22.5866046),(6374,'radius-cleaned.tif',183,3,1760,3.5056697,5.5409595,12.3833311,1.8,5.4650512,12.3754159,-0.0575185,1.3898524,3.3484356,1.0899975,4.077336,0.0019309,1.2176838,0.7842542,1.5164232,3.9034002,5.2922805,1.6689646,20.5198249),(6375,'radius-cleaned.tif',183,3,1761,3.0678174,5.6779303,12.4499105,1.8,5.59934,12.4371803,-0.0738719,1.3313441,3.1716787,0.8148993,3.0629237,0.0027851,0.9657106,0.6120877,1.206268,3.8773411,5.1421489,1.6874518,27.433666),(6376,'radius-cleaned.tif',183,3,1762,2.6833502,5.8216731,12.5057752,1.8,5.7330782,12.4910684,-0.0921858,1.2623268,2.6249538,0.6039008,2.0798426,0.0037899,0.7923349,0.4784029,1.0173761,3.984455,5.0104298,1.666503,23.4894386),(6377,'radius-cleaned.tif',183,3,1763,2.4151697,5.8980601,12.5564699,1.8,5.8152445,12.5393646,-0.0945632,1.1526291,2.5454741,0.4455653,1.5655458,0.0035888,0.6150311,0.3865643,0.7849367,4.295273,6.6752356,0.3349823,40.6413378),(6378,'radius-cleaned.tif',183,3,1764,2.1833921,5.9524299,12.6041676,1.8,5.8794024,12.586297,-0.0983512,1.0730475,2.4489092,0.3240916,1.2431846,0.0035086,0.5076483,0.3020291,0.6330339,4.1131414,6.6770241,0.4315731,29.6640559),(6379,'radius-cleaned.tif',183,3,1765,1.9076718,6.019368,12.6517514,1.8,5.9604976,12.6414899,-0.0989267,0.9600441,2.233095,0.2247814,0.9651494,0.0031014,0.4322026,0.2341365,0.5269221,3.8903491,6.6736852,0.4583001,29.9809068),(6380,'radius-cleaned.tif',183,3,1766,1.6023148,6.1091308,12.6982976,1.8,6.045789,12.6956522,-0.1467784,0.8601145,1.736548,0.1558741,0.7568603,0.0057122,0.4358419,0.1812248,0.5199224,3.9355243,6.4262541,1.0793781,31.3488493),(6381,'radius-cleaned.tif',183,3,1767,1.2747017,6.2501304,12.7223539,1.8,6.1698392,12.7353751,-0.1998174,0.718239,1.8420646,0.1096392,0.4837482,0.0083702,0.262612,0.15265,0.3214352,3.7599156,6.3596396,1.0594322,29.401283),(6382,'radius-cleaned.tif',183,3,1768,0.9908214,6.3656448,12.7526038,1.8,6.3179002,12.7812503,-0.2520771,0.6335995,1.6410943,0.0698709,0.2967765,0.0102729,0.1808406,0.1102761,0.2233269,0.0714158,0.1438615,0.5880026,0.2821356),(6383,'radius-cleaned.tif',183,3,1769,0.710354,6.4784205,12.7897495,1.8,6.4459355,12.8237491,-0.2664602,0.5771881,1.4326721,0.0376038,0.1599359,0.0082089,0.1116347,0.06515,0.1378246,3.0047366,6.276487,1.0074801,23.686103),(6384,'radius-cleaned.tif',183,3,1770,0.464393,6.6027474,12.831076,1.8,6.5752974,12.8707884,-0.292058,0.5037137,1.2347417,0.0176462,0.0708575,0.0064164,0.0573865,0.0350321,0.0716673,2.9023069,6.2192827,0.9863524,21.4871063),(6385,'radius-cleaned.tif',183,3,1771,0.2666009,6.7285091,12.877357,1.8,6.7083325,12.9181634,-0.3189812,0.4301089,0.9987838,0.0067857,0.0225185,0.0043698,0.0225459,0.0157767,0.0293355,2.3817457,6.0773871,1.0483929,17.7218417),(6386,'radius-cleaned.tif',183,3,1772,0.1325693,6.8267693,12.9477784,1.8,6.8036576,12.9878748,-0.40626,0.3311071,0.7656954,0.0021416,0.0060696,0.0034504,0.007927,0.0064679,0.0107034,2.2642688,6.0210675,0.9644134,16.3071534),(6387,'radius-cleaned.tif',183,3,1773,0.0541869,6.8778375,13.0568258,1.8,6.8606434,13.0774949,-0.5010443,0.2202327,0.4702271,0.0004674,0.0014119,0.0020837,0.0030025,0.0021221,0.0039306,2.1281611,5.9000756,1.0071791,16.7351975),(6388,'radius-cleaned.tif',183,3,1774,0.0152232,6.9272139,13.155263,1.8,6.9235176,13.1565916,-0.3532442,0.0821706,0.1906093,0.0000277,0.0000955,0.0003036,0.0005008,0.0003372,0.0006441,2.0395631,5.75363,0.9231344,15.4333636),(6389,'radius-cleaned.tif',183,3,1775,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6390,'radius-cleaned.tif',183,3,1776,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6391,'radius-cleaned.tif',183,3,1777,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6392,'radius-cleaned.tif',183,3,1778,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6393,'radius-cleaned.tif',183,3,1779,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6394,'radius-cleaned.tif',183,3,1780,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6395,'radius-cleaned.tif',183,3,1781,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6396,'radius-cleaned.tif',183,3,1782,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6397,'radius-cleaned.tif',183,3,1783,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6398,'radius-cleaned.tif',183,3,1784,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6399,'radius-cleaned.tif',183,3,1785,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6400,'radius-cleaned.tif',183,3,1786,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6401,'radius-cleaned.tif',183,3,1787,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6402,'radius-cleaned.tif',183,3,1788,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6403,'radius-cleaned.tif',183,3,1789,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6404,'radius-cleaned.tif',183,3,1790,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6405,'radius-cleaned.tif',183,3,1791,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6406,'radius-cleaned.tif',183,3,1792,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6407,'radius-cleaned.tif',183,3,1793,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6408,'radius-cleaned.tif',183,3,1794,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6409,'radius-cleaned.tif',183,3,1795,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6410,'radius-cleaned.tif',183,3,1796,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6411,'radius-cleaned.tif',183,3,1797,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6412,'radius-cleaned.tif',183,3,1798,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6413,'radius-cleaned.tif',183,3,1799,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6414,'radius-cleaned.tif',183,3,1800,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6415,'radius-cleaned.tif',183,3,1801,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6416,'radius-cleaned.tif',183,3,1802,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6417,'radius-cleaned.tif',183,3,1803,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6418,'radius-cleaned.tif',183,3,1804,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6419,'radius-cleaned.tif',183,3,1805,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6420,'radius-cleaned.tif',183,3,1806,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6421,'radius-cleaned.tif',183,3,1807,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6422,'radius-cleaned.tif',183,3,1808,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6423,'radius-cleaned.tif',183,3,1809,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6424,'radius-cleaned.tif',183,3,1810,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6425,'radius-cleaned.tif',183,3,1811,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6426,'radius-cleaned.tif',183,3,1812,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6427,'radius-cleaned.tif',183,3,1813,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6428,'radius-cleaned.tif',183,3,1814,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6429,'radius-cleaned.tif',183,3,1815,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6430,'radius-cleaned.tif',183,3,1816,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6431,'radius-cleaned.tif',183,3,1817,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6432,'radius-cleaned.tif',183,3,1818,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6433,'radius-cleaned.tif',183,3,1819,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6434,'radius-cleaned.tif',183,3,1820,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6435,'radius-cleaned.tif',183,3,1821,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6436,'radius-cleaned.tif',183,3,1822,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6437,'radius-cleaned.tif',183,3,1823,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6438,'radius-cleaned.tif',183,3,1824,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6439,'radius-cleaned.tif',183,3,1825,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6440,'radius-cleaned.tif',183,3,1826,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6441,'radius-cleaned.tif',183,3,1827,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6442,'radius-cleaned.tif',183,3,1828,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6443,'radius-cleaned.tif',183,3,1829,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6444,'radius-cleaned.tif',183,3,1830,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6445,'radius-cleaned.tif',183,3,1831,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6446,'radius-cleaned.tif',183,3,1832,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6447,'radius-cleaned.tif',183,3,1833,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6448,'radius-cleaned.tif',183,3,1834,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6449,'radius-cleaned.tif',183,3,1835,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6450,'radius-cleaned.tif',183,3,1836,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6451,'radius-cleaned.tif',183,3,1837,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6452,'radius-cleaned.tif',183,3,1838,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6453,'radius-cleaned.tif',183,3,1839,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6454,'radius-cleaned.tif',183,3,1840,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6455,'radius-cleaned.tif',183,3,1841,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6456,'radius-cleaned.tif',183,3,1842,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6457,'radius-cleaned.tif',183,3,1843,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6458,'radius-cleaned.tif',183,3,1844,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6459,'radius-cleaned.tif',183,3,1845,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6460,'radius-cleaned.tif',183,3,1846,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6461,'radius-cleaned.tif',183,3,1847,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6462,'radius-cleaned.tif',183,3,1848,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6463,'radius-cleaned.tif',183,3,1849,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6464,'radius-cleaned.tif',183,3,1850,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6465,'radius-cleaned.tif',183,3,1851,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6466,'radius-cleaned.tif',183,3,1852,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6467,'radius-cleaned.tif',183,3,1853,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6468,'radius-cleaned.tif',183,3,1854,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6469,'radius-cleaned.tif',183,3,1855,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6470,'radius-cleaned.tif',183,3,1856,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6471,'radius-cleaned.tif',183,3,1857,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6472,'radius-cleaned.tif',183,3,1858,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6473,'radius-cleaned.tif',183,3,1859,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6474,'radius-cleaned.tif',183,3,1860,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6475,'radius-cleaned.tif',183,3,1861,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6476,'radius-cleaned.tif',183,3,1862,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6477,'ulna-cleaned.tif',183,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6478,'ulna-cleaned.tif',183,4,2,0.0059683,3.2127391,14.2298997,1.8,3.2119501,14.2293379,-0.1822669,0.049642,0.1019437,0.0000047,0.0000179,0.0000327,0.0001753,0.0000952,0.0002211,0.1197,0.2148681,0.3805064,0.531217),(6479,'ulna-cleaned.tif',183,4,3,0.086909,3.3412446,14.2292674,1.8,3.3392905,14.2341131,0.176274,0.2157092,0.3154163,0.0008662,0.0017353,0.0004454,0.0055015,0.0040156,0.0081433,0.4389,0.6818115,2.782822,2.9285392),(6480,'ulna-cleaned.tif',183,4,4,0.2747322,3.3590196,14.2140967,1.8,3.3592001,14.2230549,0.3798828,0.3420407,0.4488408,0.0055373,0.0094659,0.006296,0.0210896,0.016189,0.0330479,0.6783,0.8921911,2.677945,2.5939866),(6481,'ulna-cleaned.tif',183,4,5,0.4927535,3.3645208,14.2208694,1.8,3.3723945,14.2317393,0.5037553,0.3990298,0.690336,0.0163524,0.0272512,0.0191366,0.0394752,0.0409804,0.0621371,0.8153715,1.2207053,2.9441971,3.7031663),(6482,'ulna-cleaned.tif',183,4,6,0.7007033,3.363869,14.2210565,1.8,3.3778624,14.2312861,0.4372983,0.4552957,0.7361836,0.033145,0.052658,0.0209448,0.0715283,0.0727989,0.1129871,0.9463826,1.3936471,2.910502,4.5495731),(6483,'ulna-cleaned.tif',183,4,7,0.9257815,3.3562611,14.2065577,1.8,3.3631975,14.2032586,0.6993563,0.9389084,1.0871204,0.064107,0.0878219,0.0639379,0.0807839,0.0682782,0.1070079,1.0853611,1.3965,2.4980915,4.5262003),(6484,'ulna-cleaned.tif',183,4,8,1.1822333,3.3420007,14.1410151,1.8,3.3345742,14.0928124,1.1531555,0.679879,1.6602614,0.1057555,0.1927716,0.1646229,0.1161092,0.1555505,0.1713218,1.1856965,1.4719802,2.5686265,5.0340444),(6485,'ulna-cleaned.tif',183,4,9,1.7017697,3.3062396,13.8401341,1.8,3.2908596,13.7338803,1.3975736,0.7186771,1.9492786,0.1649903,0.9317295,0.2752025,0.4779868,0.229575,0.5623759,1.2618913,1.6143483,2.4436898,5.1936444),(6486,'ulna-cleaned.tif',183,4,10,2.5487379,3.2751987,13.5502807,1.8,3.2698795,13.5099375,1.3938315,0.7791811,1.9294742,0.256811,1.9287214,0.411625,0.9996098,0.329591,1.1250274,1.5284771,3.3442295,1.8736812,12.9111567),(6487,'ulna-cleaned.tif',183,4,11,3.3698938,3.2560388,13.403459,1.8,3.2498061,13.3722607,1.3708992,0.831647,2.8898283,0.3929909,2.8623438,0.5395035,0.9904892,0.4725453,1.123443,1.6144256,3.7109146,1.8653427,11.9478854),(6488,'ulna-cleaned.tif',183,4,12,4.1379793,3.2186532,13.2523894,1.8,3.2058382,13.1902477,1.3351133,0.9077661,3.1962097,0.5610818,4.6280072,0.6520589,1.4479673,0.6180907,1.6233694,1.7577407,4.8997461,1.8513331,14.382272),(6489,'ulna-cleaned.tif',183,4,13,4.7323208,3.2016808,13.1517423,1.8,3.1872116,13.0739243,1.3234657,0.9610837,4.1476561,0.7562368,6.7123401,0.741448,1.6183454,0.7868584,1.7896456,1.8469574,5.3128466,1.8212394,15.3689161),(6490,'ulna-cleaned.tif',183,4,14,5.2321064,3.1923002,13.0024139,1.8,3.1694973,12.8595082,1.3483112,1.244829,4.5762551,0.9781754,10.6499631,0.8295607,2.3272223,0.785791,2.523202,1.9886777,5.595824,1.7863717,16.9722484),(6491,'ulna-cleaned.tif',183,4,15,5.7912988,3.1760377,12.8077168,1.8,3.1535566,12.6602684,1.3698216,1.2391697,4.4790331,1.1988505,15.9998691,0.9267526,3.5721703,0.9674627,3.8246509,2.0169831,6.8743892,1.7340366,19.165574),(6492,'ulna-cleaned.tif',183,4,16,6.2420271,3.1671219,12.6998032,1.8,3.1522268,12.606327,1.37944,1.2495548,4.5468922,1.4180015,20.0980596,1.0027063,4.4201751,1.1348054,4.7220033,2.0961112,7.0450342,1.7415315,18.8116586),(6493,'ulna-cleaned.tif',183,4,17,6.5840306,3.1662509,12.6469497,1.8,3.153213,12.573435,1.3853897,1.2691129,4.5675449,1.628782,23.3062093,1.060047,5.1025682,1.283402,5.4462679,2.1727402,7.1439946,1.7221718,19.3235129),(6494,'ulna-cleaned.tif',183,4,18,6.8276071,3.1724863,12.6301852,1.8,3.1568649,12.5468474,1.389764,1.2836303,4.6535565,1.8190583,25.690019,1.1010469,5.5205129,1.4171201,5.9068915,2.2335858,7.2793175,1.7918434,19.3645875),(6495,'ulna-cleaned.tif',183,4,19,6.9832542,3.1851243,12.6721686,1.8,3.163078,12.5565135,1.3914247,1.2949065,4.7545809,2.0315342,26.6625757,1.1268288,5.6077657,1.5688655,6.022957,2.3010498,7.3556818,1.761809,19.7846112),(6496,'ulna-cleaned.tif',183,4,20,7.0088678,3.2044117,12.7521854,1.8,3.1782385,12.6207375,1.3910145,1.3461596,4.8830246,2.243088,26.0568571,1.1307935,5.3362126,1.6662869,5.7869622,2.3657828,7.426118,1.7218117,19.9619129),(6497,'ulna-cleaned.tif',183,4,21,6.977203,3.2243817,12.8041895,1.8,3.1964765,12.6690373,1.3879356,1.3576276,4.9979507,2.4313745,25.4413071,1.1244146,5.0903478,1.7908994,5.5739327,2.4700597,7.5606028,1.7888929,20.4286825),(6498,'ulna-cleaned.tif',183,4,22,6.9014542,3.241725,12.8356442,1.8,3.2142724,12.7106867,1.3846719,1.3381954,5.0559634,2.5891639,25.0484399,1.1108533,4.9542368,1.9348175,5.4595692,2.5137001,7.6218402,1.7764053,20.6390384),(6499,'ulna-cleaned.tif',183,4,23,6.7964012,3.2609032,12.8483192,1.8,3.2332184,12.7331338,1.3810242,1.3635035,5.1027333,2.7602458,24.9739198,1.0924272,4.894224,2.0243776,5.4257556,2.7253566,7.6528992,1.7702369,21.664408),(6500,'ulna-cleaned.tif',183,4,24,6.7505623,3.2802818,12.8503783,1.8,3.2532094,12.7389269,1.37796,1.389435,5.1151698,2.8916663,25.2748052,1.0837722,4.9411469,2.0811814,5.4994464,2.7083575,7.7155708,1.6900199,20.6761028),(6501,'ulna-cleaned.tif',183,4,25,6.6964096,3.3018063,12.8455249,1.8,3.2741457,12.7340165,1.3749682,1.4191646,5.1451751,3.0206673,25.4226925,1.0738129,4.9410743,2.1284828,5.5188792,2.7531001,7.755189,1.6894079,21.479774),(6502,'ulna-cleaned.tif',183,4,26,6.6645419,3.3204844,12.8308446,1.8,3.2963858,12.7198971,1.37366,1.4359294,5.1496723,3.1071998,25.6997047,1.0681463,4.9905515,2.1638946,5.5894668,2.7930001,7.8152074,1.7090833,22.0150012),(6503,'ulna-cleaned.tif',183,4,27,6.7239222,3.3322599,12.8070471,1.8,3.3070318,12.6976701,1.3726528,1.4578973,5.1284484,3.2115281,26.3840181,1.0772287,5.1446394,2.2028493,5.7666998,2.8728001,7.8660704,1.7184322,22.3592351),(6504,'ulna-cleaned.tif',183,4,28,6.8689548,3.3455836,12.7684313,1.8,3.3239122,12.6573943,1.3723381,1.4917744,5.1167558,3.3367337,27.4449088,1.1003249,5.3637324,2.2367549,6.0149424,2.9127001,7.9115776,1.7790718,22.5074927),(6505,'ulna-cleaned.tif',183,4,29,7.0203696,3.3643157,12.733444,1.8,3.3464544,12.624624,1.3731559,1.5142386,5.1174624,3.4647329,28.3912873,1.124949,5.547923,2.2881024,6.2242795,2.9526001,7.9737135,1.7672105,22.5832825),(6506,'ulna-cleaned.tif',183,4,30,7.1166798,3.3864736,12.7085893,1.8,3.3699901,12.6108817,1.3733558,1.5326572,5.0974522,3.5463416,28.9578288,1.140473,5.6808436,2.3138518,6.3762663,3.0324001,7.997736,1.7564507,22.6043063),(6507,'ulna-cleaned.tif',183,4,31,7.1468313,3.409451,12.679497,1.8,3.3932961,12.5886,1.3724161,1.5464972,5.0812748,3.5748654,29.555504,1.1448734,5.816553,2.3115887,6.5200643,2.9925001,8.0369537,1.7555343,22.6276792),(6508,'ulna-cleaned.tif',183,4,32,7.2095978,3.4237657,12.6515416,1.8,3.4035777,12.5744056,1.3718839,1.5667591,5.0721663,3.6110104,30.0544076,1.1546807,5.9253593,2.3047643,6.6361448,3.0324001,8.0814987,1.7294516,22.3068181),(6509,'ulna-cleaned.tif',183,4,33,7.2940075,3.4412897,12.6166455,1.8,3.4202743,12.5516797,1.3712501,1.6070886,5.0413757,3.6520016,30.6574749,1.1679007,6.0811724,2.2724333,6.8048611,3.0382038,8.075291,1.7245726,21.6046587),(6510,'ulna-cleaned.tif',183,4,34,7.4400086,3.4483143,12.5667833,1.8,3.4238495,12.5143834,1.3698443,1.6256859,4.9706423,3.709324,31.7186225,1.1905984,6.3811919,2.2816978,7.1273639,3.0389002,8.0598002,1.7701336,22.2366995),(6511,'ulna-cleaned.tif',183,4,35,7.5352974,3.4559459,12.5078623,1.8,3.4305295,12.4698124,1.3689446,1.6621422,4.914466,3.7690373,32.6295582,1.2054043,6.6394921,2.2675781,7.4062032,3.040293,8.098914,1.7691581,22.3922893),(6512,'ulna-cleaned.tif',183,4,36,7.609321,3.4689558,12.4619972,1.8,3.4393608,12.4301725,1.3672763,1.686541,4.8802974,3.8123613,33.0146759,1.2164112,6.7648902,2.2604616,7.5447691,3.0395966,8.1303045,1.7633796,24.003642),(6513,'ulna-cleaned.tif',183,4,37,7.6680503,3.4822201,12.433976,1.8,3.4503167,12.4023712,1.3645824,1.7092205,4.8558117,3.8982411,33.0062069,1.2244281,6.7972584,2.2807128,7.5985727,3.0395966,8.1380354,1.7681919,23.764242),(6514,'ulna-cleaned.tif',183,4,38,7.7280466,3.4956474,12.419092,1.8,3.4629777,12.3869036,1.3636457,1.7123908,4.8523016,4.0356279,33.133686,1.2335236,6.8284474,2.3567214,7.6566425,3.0395966,8.1694704,1.7624448,23.5949606),(6515,'ulna-cleaned.tif',183,4,39,7.6917554,3.5065781,12.4131749,1.8,3.4727829,12.3836725,1.3665055,1.7358225,4.8254046,4.1310205,32.7339994,1.2291971,6.7836797,2.3798634,7.628821,3.0395966,8.1459543,1.7729949,23.4240182),(6516,'ulna-cleaned.tif',183,4,40,7.6571836,3.5170886,12.4097162,1.8,3.4848204,12.3890144,1.3702112,1.7636478,4.8383683,4.206737,32.5252326,1.2255352,6.7223557,2.3852478,7.58754,3.0406411,8.1867957,1.7471625,26.6734184),(6517,'ulna-cleaned.tif',183,4,41,7.5589342,3.5220621,12.399272,1.8,3.493466,12.3767117,1.3739287,1.7644754,4.8049412,4.2564771,32.3514582,1.2116231,6.7329561,2.4123188,7.6065157,3.0413375,8.1546466,1.752838,26.5919573),(6518,'ulna-cleaned.tif',183,4,42,7.4781408,3.5209286,12.401522,1.8,3.4966331,12.3819373,1.377782,1.7565545,4.7905361,4.3226371,32.3952554,1.2004981,6.7623445,2.4608614,7.6547126,3.0413375,8.1546466,1.752838,25.3989674),(6519,'ulna-cleaned.tif',183,4,43,7.3540853,3.5234504,12.4103556,1.8,3.5023798,12.3913919,1.380628,1.7677243,4.8066066,4.3381594,32.3024177,1.1818871,6.7204206,2.4540927,7.6113526,3.0420339,8.1694704,1.7624448,22.1415469),(6520,'ulna-cleaned.tif',183,4,44,7.2218445,3.5347873,12.4147342,1.8,3.5135721,12.3952982,1.383827,1.7481334,4.7877708,4.3779977,32.2524896,1.1620525,6.7364314,2.5043841,7.6272224,3.0723266,8.1623544,1.7825725,22.4390351),(6521,'ulna-cleaned.tif',183,4,45,7.1362956,3.5486942,12.4134969,1.8,3.5252341,12.3983051,1.385106,1.7597062,4.773903,4.4048095,32.0280966,1.1488408,6.7089961,2.5031505,7.6147327,3.0723266,8.1694704,1.7624448,22.3495537),(6522,'ulna-cleaned.tif',183,4,46,7.067663,3.5627042,12.3950591,1.8,3.5426072,12.3839979,1.3851395,1.8013021,4.7509922,4.4032169,31.984886,1.1378063,6.7322539,2.4444633,7.6441507,3.2394372,8.1459543,1.7729949,23.2056419),(6523,'ulna-cleaned.tif',183,4,47,7.0239304,3.569799,12.3723007,1.8,3.5516997,12.369311,1.3878799,1.8076261,4.704354,4.3748642,32.1008196,1.1319217,6.8236403,2.4202263,7.7247918,3.2387408,8.1459543,1.7729949,22.7154995),(6524,'ulna-cleaned.tif',183,4,48,6.9910266,3.5699456,12.3673716,1.8,3.5539278,12.3740087,1.3916054,1.7698841,4.6766477,4.3323983,32.4377366,1.1281569,6.9361087,2.4478429,7.8221274,3.1676361,8.1154091,1.7537281,22.596974),(6525,'ulna-cleaned.tif',183,4,49,7.0116936,3.5661664,12.3515069,1.8,3.5553846,12.3591351,1.3940275,1.7533029,4.6596073,4.3202974,33.0258518,1.1324784,7.08769,2.4640907,7.9962907,3.1204861,8.1338283,1.7383644,22.2407096),(6526,'ulna-cleaned.tif',183,4,50,6.9799167,3.5639723,12.3534038,1.8,3.5567846,12.3673101,1.3965451,1.745735,4.6417368,4.3275121,33.1762385,1.1283531,7.1473761,2.4789055,8.0416648,3.1218788,8.1227622,1.7585583,23.1298521),(6527,'ulna-cleaned.tif',183,4,51,6.9456784,3.5623,12.3637156,1.8,3.5598521,12.3830805,1.3989544,1.7374574,4.6180191,4.3519414,33.0560363,1.1237643,7.1580553,2.5047758,8.0522871,3.1129169,8.0929163,1.7894653,22.7896283),(6528,'ulna-cleaned.tif',183,4,52,6.9732109,3.5662203,12.3662355,1.8,3.5673339,12.3832927,1.4000118,1.7387638,4.6070687,4.4197369,33.0535312,1.1286318,7.1745253,2.5418846,8.0869059,3.1575946,8.098914,1.7691581,22.9548995),(6529,'ulna-cleaned.tif',183,4,53,7.0298987,3.5695361,12.3507351,1.8,3.5714926,12.361193,1.4016789,1.7412866,4.5848995,4.4850329,33.226342,1.138458,7.2469074,2.5757007,8.1924848,3.149329,8.0835669,1.7594796,22.7154995),(6530,'ulna-cleaned.tif',183,4,54,7.084069,3.5756743,12.3296535,1.8,3.5793429,12.3447748,1.4016337,1.7452349,4.5517359,4.5075727,33.4702474,1.1472129,7.353293,2.5827886,8.3153041,3.1589873,8.0878985,1.7343229,22.0988113),(6531,'ulna-cleaned.tif',183,4,55,7.1249839,3.5814895,12.3132221,1.8,3.5834921,12.333849,1.4038065,1.7549894,4.5096682,4.5229604,33.7120322,1.1546899,7.4755017,2.577201,8.4259217,3.149329,8.055157,1.7400166,21.9101672),(6532,'ulna-cleaned.tif',183,4,56,7.1386004,3.5952334,12.3044757,1.8,3.5973106,12.3319255,1.404345,1.7695114,4.5096909,4.5464494,33.7208056,1.1571063,7.4774095,2.5693247,8.4337024,3.1871339,8.0761781,1.7546268,21.9158384),(6533,'ulna-cleaned.tif',183,4,57,7.14586,3.6087786,12.3076854,1.8,3.6094919,12.3428166,1.4055071,1.8187241,4.4882401,4.5825427,33.7556302,1.1587338,7.5209056,2.519647,8.5084505,3.158291,8.0443785,1.7604099,22.223008),(6534,'ulna-cleaned.tif',183,4,58,7.1085001,3.6194347,12.2935227,1.8,3.619013,12.3183784,1.4051556,1.8652408,4.482734,4.5547882,33.7494645,1.1525404,7.528768,2.4419304,8.5089544,3.1934011,8.0485334,1.73513,21.9625842),(6535,'ulna-cleaned.tif',183,4,59,7.0978732,3.6307691,12.303521,1.8,3.6290246,12.3274468,1.4067985,1.8771697,4.4937655,4.5551548,33.8950671,1.1514465,7.542687,2.4266079,8.5176124,3.2319023,8.0598002,1.7701336,22.0480554),(6536,'ulna-cleaned.tif',183,4,60,7.0952346,3.6430778,12.310723,1.8,3.6416953,12.3278037,1.4094027,1.8751118,4.5081309,4.5968031,34.0054446,1.152003,7.543136,2.4514822,8.5124387,3.2298132,8.0619727,1.7448951,22.4156622),(6537,'ulna-cleaned.tif',183,4,61,7.1082469,3.6622958,12.3281834,1.8,3.6605803,12.3372261,1.4100163,1.8173675,4.5153655,4.6301708,34.0735755,1.1543458,7.546139,2.5477351,8.5237159,3.1555056,8.075291,1.7245726,22.2407096),(6538,'ulna-cleaned.tif',183,4,62,7.1276512,3.6791123,12.3557904,1.8,3.6734354,12.3673337,1.413583,1.8537596,4.5499448,4.6810538,34.1800695,1.1588218,7.5121943,2.5251677,8.4900835,3.1919178,8.0619727,1.7448951,21.8827842),(6539,'ulna-cleaned.tif',183,4,63,7.1467704,3.6894226,12.3664726,1.8,3.6847314,12.3684683,1.4153248,1.8371086,4.5488617,4.7059289,34.2241805,1.1625684,7.5236801,2.5615953,8.5116249,3.1885266,8.0634536,1.7147927,22.6977978),(6540,'ulna-cleaned.tif',183,4,64,7.1175537,3.6929933,12.3751231,1.8,3.6932852,12.3808544,1.4184819,1.8403332,4.5626063,4.6943116,33.9639041,1.1589503,7.4439699,2.5507944,8.4238567,3.1885266,8.0619727,1.7448951,22.8904521),(6541,'ulna-cleaned.tif',183,4,65,7.1784719,3.6977891,12.3793045,1.8,3.7019816,12.3843173,1.4194968,1.8600735,4.5395439,4.7213842,34.1327398,1.1692326,7.5189801,2.5382782,8.4885146,3.1934011,8.0358642,1.7253332,22.3689165),(6542,'ulna-cleaned.tif',183,4,66,7.251609,3.6981328,12.3894144,1.8,3.70113,12.3995326,1.4222763,1.8519869,4.5696942,4.772447,34.4226726,1.1821374,7.5328176,2.5769335,8.5315002,3.2228497,8.0578247,1.7098923,22.4213334),(6543,'ulna-cleaned.tif',183,4,67,7.3550751,3.7000114,12.3976869,1.8,3.7027187,12.4040147,1.425691,1.84415,4.5485659,4.8444701,34.9187675,1.2002156,7.676874,2.6269393,8.6730136,3.2221534,8.0297203,1.7506498,22.3882792),(6544,'ulna-cleaned.tif',183,4,68,7.5046016,3.6990302,12.4351368,1.8,3.6976787,12.4468727,1.4330121,1.8198004,4.5702375,4.966301,35.5663773,1.2271717,7.7821727,2.7290361,8.8113993,3.2620473,8.0358642,1.7253332,21.5966384),(6545,'ulna-cleaned.tif',183,4,69,7.6008517,3.6932518,12.4590259,1.8,3.689958,12.4609528,1.4411243,1.790963,4.593948,5.060484,36.2738545,1.2456266,7.896009,2.8255659,8.9241495,3.246401,8.0239686,1.7155063,21.7288554),(6546,'ulna-cleaned.tif',183,4,70,7.6715449,3.6990279,12.4621925,1.8,3.6971091,12.468542,1.4435602,1.7751233,4.5862439,5.0412352,36.6147128,1.2580031,7.9835947,2.8399353,9.0232393,3.2103325,8.0297203,1.7506498,21.6200113),(6547,'ulna-cleaned.tif',183,4,71,7.6523321,3.7123615,12.4269885,1.8,3.7075644,12.4375664,1.4401167,1.7873932,4.5600673,4.9669591,36.324332,1.2537324,7.9657447,2.7788844,8.9851972,3.1920084,8.0239686,1.7155063,22.2794351),(6548,'ulna-cleaned.tif',183,4,72,7.6179272,3.7327448,12.3803124,1.8,3.7308009,12.3985181,1.4353273,1.8153749,4.508469,4.9170915,36.0436286,1.2464962,7.9946493,2.7085819,9.0251331,3.2270278,8.0239686,1.7155063,21.7949639),(6549,'ulna-cleaned.tif',183,4,73,7.6007241,3.7475789,12.3414054,1.8,3.7466578,12.3673818,1.4306951,1.8471492,4.479831,4.9359537,36.199599,1.2420846,8.0805724,2.6722009,9.1179055,3.2298132,8.0226788,1.7457566,22.0964622),(6550,'ulna-cleaned.tif',183,4,74,7.577185,3.7604051,12.3162777,1.8,3.7589951,12.3407496,1.4264443,1.8742696,4.4475587,4.9621243,36.4932255,1.2367315,8.2052263,2.6474976,9.266656,3.2648327,8.0158298,1.7408549,21.9602351),(6551,'ulna-cleaned.tif',183,4,75,7.5720469,3.7715508,12.3130665,1.8,3.7708369,12.3435137,1.4234021,1.8935542,4.4532335,5.0205849,36.8559164,1.2347886,8.2762147,2.6514081,9.3473284,3.265529,8.0239686,1.7155063,21.9271808),(6552,'ulna-cleaned.tif',183,4,76,7.5824986,3.7802654,12.3237306,1.8,3.7798426,12.3477594,1.4201424,1.887417,4.4666565,5.0747558,37.4060292,1.2352833,8.3745031,2.6887306,9.4557615,3.2717056,8.0239686,1.7155063,22.1528893),(6553,'ulna-cleaned.tif',183,4,77,7.5742779,3.7855526,12.3379897,1.8,3.7866711,12.3607064,1.4179558,1.8962943,4.4553119,5.1118972,37.8897267,1.2331191,8.5043938,2.6957299,9.5763669,3.2730983,8.0051972,1.7613494,21.8046452),(6554,'ulna-cleaned.tif',183,4,78,7.6256166,3.7900163,12.3341929,1.8,3.7954026,12.3603536,1.4169582,1.9039259,4.4861153,5.1578673,38.2934415,1.2410944,8.5359913,2.7090693,9.622488,3.3074214,8.0358642,1.7253332,22.2480419),(6555,'ulna-cleaned.tif',183,4,79,7.6830476,3.7944582,12.3157884,1.8,3.800152,12.3453147,1.4184576,1.907138,4.4283826,5.1944559,38.7187958,1.2510202,8.7433266,2.7236916,9.8446952,3.3082084,8.0051972,1.7613494,21.744208),(6556,'ulna-cleaned.tif',183,4,80,7.7081687,3.8011272,12.3055376,1.8,3.8094898,12.3418432,1.4205988,1.8820398,4.4180891,5.2049934,38.909361,1.2559302,8.8068302,2.7656128,9.9076982,3.2786691,8.0027109,1.731027,22.1351877),(6557,'ulna-cleaned.tif',183,4,81,7.6808655,3.8012564,12.2989378,1.8,3.8100581,12.3408797,1.4245187,1.8722741,4.4151936,5.1469344,39.0657535,1.2529476,8.8480274,2.7490282,9.919342,3.3109032,8.0206942,1.7711187,21.8764249),(6558,'ulna-cleaned.tif',183,4,82,7.6422096,3.8057614,12.2830126,1.8,3.8176584,12.3225023,1.4275047,1.8706995,4.3587409,5.0774875,38.9546908,1.2477278,8.937143,2.7142186,9.9961071,3.3143849,7.9737135,1.7672105,21.7401978),(6559,'ulna-cleaned.tif',183,4,83,7.6872865,3.8119574,12.280769,1.8,3.8240263,12.3283592,1.4286935,1.8399737,4.3904849,5.0683856,39.429221,1.2555162,8.9806074,2.7545967,10.0408362,3.3187241,8.0051972,1.7613494,21.7248452),(6560,'ulna-cleaned.tif',183,4,84,7.7243896,3.8201047,12.2709493,1.8,3.8320789,12.3196613,1.4296219,1.846776,4.3530731,5.0442695,39.673487,1.2619101,9.1139033,2.7313922,10.1420707,3.320813,7.9765082,1.7417015,21.6587367),(6561,'ulna-cleaned.tif',183,4,85,7.7730711,3.8269287,12.2726761,1.8,3.8371697,12.3244374,1.4305315,1.8506901,4.3890276,5.0631324,40.2081139,1.2701904,9.1610528,2.7358079,10.1978126,3.3157776,8.0206942,1.7711187,21.6353639),(6562,'ulna-cleaned.tif',183,4,86,7.7167434,3.8262872,12.271067,1.8,3.8353051,12.3232588,1.4349985,1.8374864,4.3447938,5.0847302,40.2606855,1.2625519,9.2664203,2.7672206,10.3072403,3.3171703,7.9904671,1.7515431,21.8103164),(6563,'ulna-cleaned.tif',183,4,87,7.681339,3.8205412,12.2786166,1.8,3.8261777,12.3261277,1.4399367,1.7874729,4.3480645,5.1257151,40.3678144,1.2584252,9.2840881,2.8675765,10.3278285,3.2945047,7.9765082,1.7417015,21.5926283),(6564,'ulna-cleaned.tif',183,4,88,7.7070858,3.8273969,12.29072,1.8,3.835891,12.3420759,1.4415872,1.7878327,4.364921,5.2124683,40.5977158,1.2631884,9.3009051,2.9155235,10.3404827,3.3281242,7.9904671,1.7515431,21.8901165),(6565,'ulna-cleaned.tif',183,4,89,7.7017555,3.8400477,12.2927592,1.8,3.8514118,12.3452606,1.4404796,1.768995,4.3590534,5.2610664,40.691572,1.2619499,9.334956,2.9740425,10.41375,3.320813,7.9765082,1.7417015,21.9328521),(6566,'ulna-cleaned.tif',183,4,90,7.7078682,3.8500848,12.2910667,1.8,3.8586564,12.3359227,1.4400779,1.7751649,4.3641596,5.3027881,40.6938623,1.2628183,9.3245586,2.9872087,10.3936979,3.2945047,7.9904671,1.7515431,21.5886181),(6567,'ulna-cleaned.tif',183,4,91,7.7363114,3.8582822,12.2994292,1.8,3.8660446,12.3448882,1.4424453,1.7407854,4.3615387,5.3328968,40.9430754,1.2682603,9.3873007,3.0635005,10.4862246,3.286149,7.9904671,1.7515431,21.4991367),(6568,'ulna-cleaned.tif',183,4,92,7.7880348,3.8657427,12.3009307,1.8,3.8759574,12.3469886,1.444029,1.7432689,4.3679459,5.3479746,41.3432545,1.2772584,9.465148,3.0677853,10.5449164,3.286149,7.996442,1.7261012,21.5692554),(6569,'ulna-cleaned.tif',183,4,93,7.8696345,3.8706935,12.2960748,1.8,3.8828409,12.3428721,1.4449992,1.7208638,4.3630432,5.3493113,41.7077713,1.290959,9.5593303,3.1085036,10.6352869,3.2851045,7.9904671,1.7515431,21.3298554),(6570,'ulna-cleaned.tif',183,4,94,7.9662001,3.879029,12.2976194,1.8,3.8913238,12.3464297,1.4454906,1.7175956,4.3652555,5.375282,42.2895933,1.306962,9.6877705,3.1295388,10.763187,3.2830156,8.0027109,1.731027,21.6039707),(6571,'ulna-cleaned.tif',183,4,95,8.0378907,3.8896127,12.2998912,1.8,3.8992294,12.3466808,1.446117,1.7212586,4.363396,5.3897041,42.6057284,1.3189314,9.7643506,3.1312576,10.8531296,3.2788378,7.9904671,1.7515431,21.3064825),(6572,'ulna-cleaned.tif',183,4,96,8.1380775,3.8997559,12.3005787,1.8,3.9089207,12.3422237,1.4449758,1.7000694,4.3661688,5.3958163,42.9067044,1.3349873,9.8270833,3.17388,10.913808,3.2582876,7.9903675,1.7211678,21.4660825),(6573,'ulna-cleaned.tif',183,4,97,8.2253904,3.9071002,12.3021832,1.8,3.9168917,12.351775,1.4456732,2.2341306,4.3731506,5.410368,43.1248574,1.3495477,9.8612789,2.4216884,10.9286524,3.2483516,8.0027109,1.731027,21.3806113),(6574,'ulna-cleaned.tif',183,4,98,8.2984905,3.9113094,12.287706,1.8,3.9186705,12.337444,1.4451638,2.2859487,4.3497095,5.4159,43.1575418,1.3613664,9.9219367,2.3692132,11.0258,3.2281593,7.9903675,1.7211678,21.5789367),(6575,'ulna-cleaned.tif',183,4,99,8.2719383,3.9167233,12.2676896,1.8,3.9224221,12.311469,1.4457672,2.2923149,4.3350778,5.3650418,42.8723082,1.3572169,9.8896283,2.3404471,10.9649453,3.2295518,7.9903675,1.7211678,21.6740893),(6576,'ulna-cleaned.tif',183,4,100,8.2147332,3.9219617,12.2546832,1.8,3.9275496,12.3054091,1.4452179,2.2955211,4.2836547,5.3017803,42.4312404,1.3476445,9.9053831,2.3096195,10.9725936,3.2295518,7.95092,1.7219195,21.399974),(6577,'ulna-cleaned.tif',183,4,101,8.1351618,3.9247766,12.2259274,1.8,3.9305454,12.2749508,1.4437088,2.3006403,4.2911476,5.2051215,42.015751,1.3340791,9.791262,2.2624664,10.8552842,3.1882836,7.9844877,1.7162269,21.4233469),(6578,'ulna-cleaned.tif',183,4,102,8.0987976,3.9291796,12.2082539,1.8,3.93564,12.2594264,1.4410642,2.2501594,4.2760639,5.1313915,41.9584736,1.3272091,9.8124058,2.2804569,10.8642528,3.1662562,7.9788031,1.711279,21.0928045),(6579,'ulna-cleaned.tif',183,4,103,8.0732884,3.9353781,12.1949141,1.8,3.9423112,12.2499395,1.4392167,1.687565,4.2701894,5.0836135,41.9598811,1.3223865,9.8262342,3.0123957,10.8514141,3.1592938,7.996442,1.7261012,21.6353639),(6580,'ulna-cleaned.tif',183,4,104,8.0705746,3.943149,12.1823433,1.8,3.9510023,12.2407856,1.4368092,1.6724999,4.2498979,5.0881108,42.0869149,1.3210921,9.9030413,3.042219,10.9655599,3.189422,7.9788031,1.711279,21.3766011),(6581,'ulna-cleaned.tif',183,4,105,8.0977216,3.9517179,12.1748619,1.8,3.959439,12.2404927,1.4352404,1.6739786,4.2500785,5.0996928,42.4482696,1.324972,9.9876437,3.0464504,11.0343906,3.1537238,7.9884745,1.680902,21.7345266),(6582,'ulna-cleaned.tif',183,4,106,8.1606496,3.961224,12.1669364,1.8,3.9691527,12.2327512,1.4330647,1.6748077,4.2055469,5.1641405,42.7787563,1.3344698,10.1719842,3.0834229,11.2376308,3.1546562,7.9364903,1.666463,21.3008113),(6583,'ulna-cleaned.tif',183,4,107,8.2150338,3.9748954,12.171557,1.8,3.9842604,12.2440389,1.4312033,1.681518,4.2473129,5.2138824,43.061054,1.3426652,10.1384229,3.1006998,11.2241744,3.1407329,7.9801,1.6709625,21.6410351),(6584,'ulna-cleaned.tif',183,4,108,8.2611231,3.983236,12.1723374,1.8,3.99207,12.2450063,1.4289456,1.6855726,4.2395013,5.2015529,43.2026775,1.3493346,10.1905094,3.0859265,11.28171,3.1320308,7.9690202,1.6560166,21.3338655),(6585,'ulna-cleaned.tif',183,4,109,8.2800525,3.9823309,12.1781062,1.8,3.9893724,12.2506263,1.4309885,1.6775323,4.2494196,5.1389842,43.1188974,1.3532101,10.1470087,3.0634188,11.2283963,3.1200154,7.9733142,1.706324,21.5555639),(6586,'ulna-cleaned.tif',183,4,110,8.3184523,3.9787215,12.1861712,1.8,3.9863201,12.2548236,1.4340159,1.6402601,4.2495095,5.0606128,43.1920766,1.3606319,10.1640147,3.0852502,11.2389312,3.1084005,7.9657232,1.6510258,21.4991367),(6587,'ulna-cleaned.tif',183,4,111,8.3787661,3.976672,12.2027094,1.8,3.9880769,12.2777687,1.436383,1.6123426,4.2641633,5.0248907,43.4842621,1.3713828,10.1976072,3.1165154,11.258456,3.101162,7.9657232,1.6510258,21.0363773),(6588,'ulna-cleaned.tif',183,4,112,8.4094902,3.9773058,12.2102876,1.8,3.9873506,12.2873349,1.4378785,1.5994678,4.27083,4.9791976,43.6003946,1.3769652,10.2088809,3.113034,11.2553143,3.0781918,7.9657232,1.6510258,21.5362011),(6589,'ulna-cleaned.tif',183,4,113,8.4701447,3.9819987,12.2140747,1.8,3.9901634,12.2877051,1.4383102,1.595912,4.2696633,4.918419,43.6814544,1.3870566,10.2306554,3.0818861,11.2753674,3.0781918,7.945011,1.7169547,21.5789367),(6590,'ulna-cleaned.tif',183,4,114,8.5276981,3.9891021,12.2211394,1.8,3.9977217,12.2973089,1.4383364,1.5951097,4.2775889,4.8874566,43.9482817,1.3964912,10.274078,3.0640255,11.3072512,3.0761036,7.9392982,1.7119826,21.4620723),(6591,'ulna-cleaned.tif',183,4,115,8.5739329,3.9968985,12.2269493,1.8,4.0066819,12.3027752,1.4392231,1.5997889,4.2547549,4.842073,44.1775064,1.4043933,10.3830908,3.0266949,11.3718854,3.0592285,7.9239433,1.7326338,21.5652452),(6592,'ulna-cleaned.tif',183,4,116,8.627997,4.0061615,12.24311,1.8,4.0188041,12.3205516,1.4379827,1.6254726,4.2675708,4.8058228,44.6617492,1.4127828,10.4653797,2.9565696,11.4578263,3.0761036,7.8997972,1.7126934,20.9195129),(6593,'ulna-cleaned.tif',183,4,117,8.6898888,4.0175587,12.263041,1.8,4.0296174,12.3391045,1.4356592,1.603158,4.2903631,4.7754498,45.0772417,1.4220262,10.5066262,2.9787767,11.4876033,3.0508757,7.8997972,1.7126934,21.2113299),(6594,'ulna-cleaned.tif',183,4,118,8.7108632,4.0299556,12.2615784,1.8,4.0420463,12.3357779,1.4311421,1.584647,4.2879898,4.7408311,45.3375243,1.4236791,10.5731417,2.9917269,11.5638144,3.0446111,7.8845673,1.7334492,21.0847842),(6595,'ulna-cleaned.tif',183,4,119,8.6667316,4.0329006,12.2329289,1.8,4.0437005,12.3166289,1.4281815,1.5625504,4.2504833,4.6996011,45.2954137,1.4152751,10.6565326,3.0076477,11.6572929,3.0397019,7.8660704,1.7184322,21.1452214),(6596,'ulna-cleaned.tif',183,4,120,8.6201901,4.0375694,12.1998162,1.8,4.0491581,12.2889964,1.4245161,1.5608319,4.2144714,4.6774551,44.8929563,1.4061747,10.6520966,2.9967707,11.6402194,3.0355255,7.8603002,1.7134113,20.9058214),(6597,'ulna-cleaned.tif',183,4,121,8.7067728,4.0497334,12.1961636,1.8,4.0607894,12.2882053,1.4208601,1.5576466,4.2143879,4.7144752,45.2681062,1.4187499,10.7413241,3.0266655,11.7364401,3.0120083,7.8547284,1.7083831,20.8300316),(6598,'ulna-cleaned.tif',183,4,122,8.8487446,4.059115,12.1929589,1.8,4.0669947,12.2763972,1.4181513,1.5754347,4.2199795,4.7622898,45.7120723,1.4406935,10.8322973,3.0228418,11.8741729,3.0372188,7.8603002,1.7134113,21.2500554),(6599,'ulna-cleaned.tif',183,4,123,8.9823794,4.0686324,12.1909723,1.8,4.0757818,12.2721515,1.415132,1.5778294,4.2210151,4.8073502,46.0378238,1.4610794,10.9068133,3.0468125,11.9595365,3.0193158,7.851789,1.7392867,20.8864587),(6600,'ulna-cleaned.tif',183,4,124,9.0217677,4.0734423,12.1758706,1.8,4.0783561,12.2565,1.4135872,1.5807825,4.207632,4.8192117,46.0160913,1.4667714,10.9363394,3.0486241,11.9704358,3.0095724,7.8547284,1.7083831,21.0049842),(6601,'ulna-cleaned.tif',183,4,125,8.9944922,4.068722,12.1466433,1.8,4.0743543,12.2344065,1.4148243,1.5856035,4.1835923,4.8011175,45.8899687,1.4629082,10.9690346,3.0279433,12.0122481,3.0144441,7.8603002,1.7134113,21.3822723),(6602,'ulna-cleaned.tif',183,4,126,8.9457813,4.063967,12.1185894,1.8,4.0709229,12.2091481,1.4160786,1.5609366,4.1544441,4.7537688,45.7891743,1.4555573,11.0217331,3.0454593,12.0578627,3.0095724,7.851789,1.7392867,21.1041469),(6603,'ulna-cleaned.tif',183,4,127,8.9259489,4.0603514,12.1030181,1.8,4.0678117,12.1925413,1.4180379,1.5421074,4.131332,4.7134918,45.683993,1.4532126,11.0579331,3.0565262,12.1014808,2.9819261,7.8388018,1.7292505,20.8727672),(6604,'ulna-cleaned.tif',183,4,128,8.9186081,4.0598244,12.0867158,1.8,4.0676972,12.169591,1.4194397,1.5402073,4.1143965,4.6735429,45.5920214,1.4526414,11.0810957,3.0343598,12.0894795,2.9822883,7.8388018,1.7292505,20.7365401),(6605,'ulna-cleaned.tif',183,4,129,8.8986407,4.0592855,12.0729068,1.8,4.0670628,12.1546911,1.4207507,1.5373063,4.1059243,4.6496945,45.4245908,1.4499664,11.0631826,3.0245726,12.0760474,2.9822883,7.8266067,1.7191821,20.9856214),(6606,'ulna-cleaned.tif',183,4,130,8.9139777,4.0598748,12.0638032,1.8,4.0667397,12.1431326,1.4218773,1.5487656,4.0963539,4.6291321,45.3573302,1.4529584,11.0726104,2.9889172,12.0797844,2.9822883,7.8266067,1.7191821,21.4346893),(6607,'ulna-cleaned.tif',183,4,131,8.9334159,4.0610516,12.0526395,1.8,4.0685411,12.1293885,1.4228084,1.535406,4.0908216,4.632914,45.3895588,1.4565324,11.0954627,3.017387,12.0846673,2.9974532,7.8266067,1.7191821,20.8123299),(6608,'ulna-cleaned.tif',183,4,132,8.9418779,4.0641595,12.041691,1.8,4.072537,12.1209528,1.4217418,1.5410676,4.0811276,4.6049624,45.2897776,1.4574468,11.0973686,2.9881639,12.0816208,2.9660003,7.8152074,1.7090833,21.1001367),(6609,'ulna-cleaned.tif',183,4,133,8.9542,4.0660466,12.0247525,1.8,4.0750487,12.1052755,1.422001,1.5370346,4.0585771,4.5940606,45.2615734,1.4595687,11.1520793,2.9889117,12.1527293,2.9568136,7.8098073,1.7040231,20.9719299),(6610,'ulna-cleaned.tif',183,4,134,8.9812027,4.068876,12.0025995,1.8,4.0786086,12.0817799,1.419982,1.5281901,4.0477736,4.5911202,45.3192409,1.4630783,11.1960907,3.0042861,12.2267559,2.9547292,7.8098073,1.7040231,20.5946417),(6611,'ulna-cleaned.tif',183,4,135,8.9936714,4.0685825,11.9829575,1.8,4.0773221,12.0625785,1.4195751,1.524964,4.0525141,4.5755496,45.4067247,1.4649281,11.2045814,3.0004313,12.2209236,2.9431269,7.8266067,1.7191821,20.8357028),(6612,'ulna-cleaned.tif',183,4,136,9.0011276,4.0702981,11.962437,1.8,4.0800643,12.0421113,1.4180174,1.5240509,4.0151316,4.5642684,45.534018,1.465443,11.3406041,2.9948268,12.3513658,2.9493879,7.8098073,1.7040231,21.000974),(6613,'ulna-cleaned.tif',183,4,137,8.9979838,4.0722657,11.9409191,1.8,4.0824958,12.0185432,1.4166428,1.5169144,4.0192665,4.55956,45.5428899,1.4643084,11.3311447,3.0058123,12.3336971,2.9368658,7.8124569,1.7401431,20.5575773),(6614,'ulna-cleaned.tif',183,4,138,8.9912143,4.0754905,11.9210826,1.8,4.0862497,11.9983526,1.4151356,1.529408,4.0010534,4.5404175,45.642774,1.4625181,11.4076893,2.9687418,12.4085255,2.9392709,7.8058313,1.7351047,20.8590757),(6615,'ulna-cleaned.tif',183,4,139,9.0102353,4.0761997,11.8988572,1.8,4.087214,11.9762139,1.4139397,1.5276114,3.9861467,4.5243187,45.9008656,1.4650599,11.5150968,2.9616948,12.4958244,2.9214724,7.8124569,1.7401431,20.6897943),(6616,'ulna-cleaned.tif',183,4,140,9.0133582,4.0796829,11.8812623,1.8,4.0902266,11.9577102,1.4131104,1.5284206,3.9904449,4.508608,45.9480819,1.4651823,11.514526,2.9498476,12.543643,2.9353825,7.8124569,1.7401431,20.7792757),(6617,'ulna-cleaned.tif',183,4,141,9.0735828,4.083877,11.8620695,1.8,4.0928261,11.935157,1.4120202,1.5196036,3.9727067,4.5292235,46.2460514,1.4744591,11.6409429,2.9805296,12.6771702,2.9249499,7.8058313,1.7351047,20.948557),(6618,'ulna-cleaned.tif',183,4,142,9.147126,4.0896706,11.8454632,1.8,4.0989392,11.9182391,1.4095091,1.5330155,3.9713283,4.5460946,46.5034238,1.4852055,11.7097907,2.965459,12.716482,2.931905,7.8192805,1.7451729,20.9114926),(6619,'ulna-cleaned.tif',183,4,143,9.2503804,4.0958102,11.8298796,1.8,4.106094,11.9042897,1.4062705,1.506839,3.9653751,4.5703415,46.9213107,1.5003725,11.8327547,3.0330655,12.8285371,2.9185535,7.8124569,1.7401431,20.9388757),(6620,'ulna-cleaned.tif',183,4,144,9.3343281,4.0993843,11.8092209,1.8,4.1083864,11.8753924,1.4041332,1.5099499,3.9531672,4.5854149,47.296593,1.5129073,11.9642279,3.0367994,12.9855521,2.9163406,7.8152074,1.7090833,20.5342044),(6621,'ulna-cleaned.tif',183,4,145,9.4323027,4.1020838,11.7953754,1.8,4.1089138,11.8560172,1.4017105,1.5149223,3.9419275,4.6065435,47.9005291,1.5275322,12.15155,3.0407787,13.1399503,2.9178145,7.7942995,1.7561443,20.709157),(6622,'ulna-cleaned.tif',183,4,146,9.5034227,4.1026197,11.7763938,1.8,4.1084707,11.8346944,1.3996073,1.4946884,3.9572033,4.6270573,48.4276289,1.537938,12.237842,3.0956668,13.2534075,2.9048679,7.8263015,1.7501938,20.8647469),(6623,'ulna-cleaned.tif',183,4,147,9.4930172,4.1040227,11.7534556,1.8,4.1105744,11.8062945,1.3993833,1.5026766,3.9538733,4.6320164,48.3984386,1.5361351,12.2407662,3.0825105,13.3128715,2.9049068,7.8263015,1.7501938,20.9074825),(6624,'ulna-cleaned.tif',183,4,148,9.4364484,4.1029153,11.729544,1.8,4.1077607,11.7764374,1.4008211,1.5017507,3.9294189,4.6349186,48.2188088,1.5277383,12.2712315,3.0863435,13.3462587,2.9090164,7.8266067,1.7191821,20.5963028),(6625,'ulna-cleaned.tif',183,4,149,9.3625135,4.1020949,11.7089631,1.8,4.1065792,11.7515646,1.403172,1.5152033,3.9078204,4.6247181,47.8758245,1.5169835,12.2512859,3.0522096,13.2842996,2.9131871,7.8266067,1.7191821,20.8220113),(6626,'ulna-cleaned.tif',183,4,150,9.3176462,4.1050884,11.6983234,1.8,4.1081787,11.7355086,1.4045363,1.5126905,3.9100675,4.6339882,47.7428719,1.5104081,12.2102423,3.0634081,13.2617706,2.8965044,7.8493555,1.7033479,20.6857841),(6627,'ulna-cleaned.tif',183,4,151,9.2851597,4.1079992,11.6872953,1.8,4.1079184,11.71868,1.4054371,1.5225999,3.9256229,4.6372451,47.7848424,1.5055958,12.1725505,3.0456098,13.2357475,2.9131871,7.8720386,1.7234457,21.2517164),(6628,'ulna-cleaned.tif',183,4,152,9.219052,4.110986,11.6726262,1.8,4.1098592,11.7056444,1.4060122,1.5181395,3.9179785,4.6279333,47.5656724,1.4951629,12.1403608,3.0484243,13.1362476,2.9035324,7.8695103,1.6825734,20.9679198),(6629,'ulna-cleaned.tif',183,4,153,9.2022212,4.1130969,11.6498439,1.8,4.1102023,11.6804298,1.4069224,1.513764,3.9304249,4.6435905,47.6065606,1.4928838,12.1123191,3.0675788,13.0752511,2.9035324,7.8997972,1.7126934,21.3508792),(6630,'ulna-cleaned.tif',183,4,154,9.2125103,4.1173091,11.6322344,1.8,4.1149316,11.6639677,1.4066797,1.5193842,3.9404222,4.6631837,47.6045184,1.494433,12.0810706,3.0691274,13.0276737,2.912566,7.8997972,1.7126934,20.841374),(6631,'ulna-cleaned.tif',183,4,155,9.2446078,4.1206179,11.6192706,1.8,4.1178524,11.6510509,1.4061468,1.513183,3.9391931,4.698972,47.5865128,1.4993747,12.0802692,3.1053561,12.9897203,2.9099923,7.9184163,1.6920263,20.973591),(6632,'ulna-cleaned.tif',183,4,156,9.3247567,4.1234111,11.6029606,1.8,4.120171,11.6293427,1.4061628,1.5275218,3.9481737,4.7421655,47.8870644,1.512382,12.1289153,3.1044829,13.1567644,2.9222198,7.9233406,1.6970251,20.9405367),(6633,'ulna-cleaned.tif',183,4,157,9.4004566,4.1264078,11.5934631,1.8,4.1236675,11.6260161,1.4062826,1.5165224,3.9440585,4.795362,48.1517159,1.5247204,12.2086717,3.1620779,13.2045562,2.8972049,7.9233406,1.6970251,20.7559028),(6634,'ulna-cleaned.tif',183,4,158,9.4396259,4.1278545,11.5722491,1.8,4.1262611,11.6033126,1.4064883,1.5119303,3.9583702,4.8187873,48.3989025,1.531178,12.2269774,3.1871756,13.2058999,2.8916405,7.9284625,1.7020176,21.1856079),(6635,'ulna-cleaned.tif',183,4,159,9.451265,4.1284098,11.5520974,1.8,4.1275826,11.5818646,1.4062013,1.5143211,3.9581939,4.811782,48.462751,1.53292,12.2436527,3.1775176,13.2876353,2.8896868,7.9392982,1.7119826,21.053391),(6636,'ulna-cleaned.tif',183,4,160,9.4871791,4.129252,11.5316529,1.8,4.1287634,11.5606658,1.4061098,1.5099806,3.9781656,4.8313618,48.6545318,1.5386982,12.2303939,3.1996184,13.2726384,2.8896868,7.9392982,1.7119826,21.0727537),(6637,'ulna-cleaned.tif',183,4,161,9.5298678,4.1313369,11.5096832,1.8,4.1303757,11.5332025,1.4050301,1.5091458,4.00538,4.8461138,48.8720954,1.5450653,12.2016126,3.2111634,13.2580766,2.8896868,7.9680212,1.7013624,20.6897943),(6638,'ulna-cleaned.tif',183,4,162,9.5798765,4.1356799,11.4963249,1.8,4.1352002,11.5229491,1.4047083,1.5021752,4.0176395,4.8643299,49.1781771,1.5530057,12.2405648,3.2381908,13.2944858,2.8896868,7.996442,1.7261012,20.9969639),(6639,'ulna-cleaned.tif',183,4,163,9.6368648,4.1382047,11.4765624,1.8,4.1356691,11.4985296,1.4037562,1.4949701,4.0166733,4.8958559,49.5998219,1.5617441,12.3484829,3.2748854,13.4618687,2.8691654,7.996442,1.7261012,21.1372011),(6640,'ulna-cleaned.tif',183,4,164,9.686393,4.1420277,11.4584912,1.8,4.1407217,11.483835,1.4036486,1.5013065,4.0271643,4.9253731,49.968533,1.5697136,12.4078706,3.2807245,13.5053572,2.8764787,7.9903675,1.7211678,20.6938045),(6641,'ulna-cleaned.tif',183,4,165,9.7499346,4.1445873,11.4368126,1.8,4.1440162,11.4600357,1.402965,1.4941633,4.0610636,4.9705562,50.5134996,1.5796456,12.43849,3.3266486,13.567758,2.8743734,8.0239686,1.7155063,21.5942893),(6642,'ulna-cleaned.tif',183,4,166,9.8080419,4.1466334,11.4193125,1.8,4.146625,11.4459358,1.4022805,1.4881963,4.0449999,5.0040632,51.1041678,1.5886906,12.6339106,3.3625021,13.7888135,2.8743734,8.0206942,1.7711187,21.0614113),(6643,'ulna-cleaned.tif',183,4,167,9.898036,4.1499814,11.4042438,1.8,4.1504221,11.4364808,1.4021141,1.4821165,4.0851557,5.0649589,51.7472765,1.6031769,12.6671492,3.4173824,13.7895973,2.8687633,8.0878985,1.7343229,21.3862825),(6644,'ulna-cleaned.tif',183,4,168,9.9843032,4.1531505,11.3776856,1.8,4.1520252,11.4035444,1.39994,1.4751956,4.0770822,5.1270851,52.3038107,1.6159446,12.8287357,3.4755289,13.9796085,2.8711109,8.0689799,1.7497653,21.399974),(6645,'ulna-cleaned.tif',183,4,169,10.0695118,4.157503,11.3538287,1.8,4.1561844,11.3815823,1.3991528,1.4925258,4.0858167,5.1882992,53.0055375,1.6292918,12.9730581,3.4761874,14.0943206,2.893323,8.0878985,1.7343229,21.1468825),(6646,'ulna-cleaned.tif',183,4,170,10.1620466,4.1601144,11.3281048,1.8,4.1570685,11.3559951,1.3967287,1.4671747,4.1023354,5.2500543,53.7723083,1.6428731,13.1077307,3.5783431,14.2096778,2.8811506,8.1029427,1.7140861,21.5144893),(6647,'ulna-cleaned.tif',183,4,171,10.2766322,4.1650614,11.3031795,1.8,4.1616412,11.3282868,1.394688,1.4539283,4.1246714,5.3269154,54.6379657,1.6601988,13.2466228,3.6638089,14.3507594,2.8562496,8.1338283,1.7383644,21.6313537),(6648,'ulna-cleaned.tif',183,4,172,10.3998009,4.1705468,11.2823624,1.8,4.165953,11.3011638,1.3925632,1.4689037,4.1388578,5.4012738,55.4166561,1.6788189,13.3893596,3.6770782,14.595294,2.8775733,8.1546466,1.752838,21.3355266),(6649,'ulna-cleaned.tif',183,4,173,10.4627484,4.176669,11.2708898,1.8,4.1701093,11.282429,1.3914978,1.4551746,4.1271904,5.4874859,56.0111317,1.6883302,13.5712499,3.7710156,14.7389775,2.8688231,8.1546466,1.752838,21.6547266),(6650,'ulna-cleaned.tif',183,4,174,10.4887532,4.1810392,11.2586156,1.8,4.1727729,11.2656814,1.390357,1.4467738,4.1377787,5.5706594,56.4388112,1.6918245,13.6398817,3.8504012,14.8183248,2.8611731,8.1867957,1.7471625,21.3145028),(6651,'ulna-cleaned.tif',183,4,175,10.5014566,4.1878457,11.2468261,1.8,4.1788116,11.2527641,1.3893651,1.4283849,4.1298782,5.6426192,56.7377387,1.6932589,13.7383563,3.9503493,14.9896517,2.858848,8.2011732,1.756742,21.5458825),(6652,'ulna-cleaned.tif',183,4,176,10.5549654,4.1902875,11.224534,1.8,4.1804646,11.2332622,1.3889433,1.4323047,4.1439286,5.7144275,57.3164709,1.701623,13.8314329,3.989673,15.0734264,2.8631314,8.2331407,1.7510833,21.6547266),(6653,'ulna-cleaned.tif',183,4,177,10.6555055,4.1917115,11.1989824,1.8,4.1816468,11.2095949,1.3879329,1.4234171,4.1682273,5.7825794,58.2679585,1.7171916,13.9790741,4.0624631,15.2245854,2.858848,8.2554442,1.7653483,21.8997978),(6654,'ulna-cleaned.tif',183,4,178,10.7794994,4.1917873,11.1689651,1.8,4.1809888,11.1786494,1.3865739,1.4161124,4.196944,5.8815411,59.3003538,1.7362976,14.1294126,4.1533011,15.3838739,2.8542748,8.2870103,1.7596935,21.5362011),(6655,'ulna-cleaned.tif',183,4,179,10.9178556,4.1921696,11.1421438,1.8,4.1834899,11.1544996,1.3848609,1.4290688,4.2051464,5.9854808,60.4283032,1.7574556,14.3700829,4.1883784,15.6961579,2.8769649,8.2945951,1.7644183,21.6684181),(6656,'ulna-cleaned.tif',183,4,180,11.0313994,4.1909636,11.1150883,1.8,4.183008,11.1305146,1.3836341,1.4218107,4.2239511,6.0687774,61.4088436,1.7749106,14.5382468,4.2683443,15.8565983,2.8475298,8.3103187,1.7738415,21.9134893),(6657,'ulna-cleaned.tif',183,4,181,11.1244108,4.1910769,11.093971,1.8,4.181937,11.1065264,1.3830835,1.4126207,4.2443909,6.1466192,62.4476958,1.789502,14.7129936,4.3512169,16.0396133,2.8473702,8.3575026,1.7775549,22.2326893),(6658,'ulna-cleaned.tif',183,4,182,11.1384357,4.1962669,11.0872294,1.8,4.1851192,11.0925045,1.3835605,1.4175732,4.2333767,6.2049498,62.9030098,1.7920824,14.8588266,4.3771636,16.251142,2.8407848,8.3575026,1.7775549,21.9779368),(6659,'ulna-cleaned.tif',183,4,183,11.1004337,4.2024596,11.0810407,1.8,4.1906131,11.0836978,1.3843566,1.4106071,4.2164418,6.281423,62.983555,1.7865059,14.9376082,4.4529926,16.3018014,2.83817,8.372918,1.7625845,22.1996351),(6660,'ulna-cleaned.tif',183,4,184,11.1331232,4.203751,11.0632102,1.8,4.1906729,11.060621,1.38482,1.4136354,4.2339685,6.3983812,63.5640893,1.7920798,15.0128865,4.526189,16.3975919,2.83817,8.4046111,1.7570192,22.3221707),(6661,'ulna-cleaned.tif',183,4,185,11.195295,4.2035342,11.0400583,1.8,4.1887663,11.0352577,1.384577,1.4134061,4.2543583,6.5200698,64.4129352,1.8019226,15.1404584,4.6130195,16.5516414,2.8358925,8.4306162,1.795112,22.3342012),(6662,'ulna-cleaned.tif',183,4,186,11.2938839,4.204987,11.0173102,1.8,4.1907955,11.0101916,1.3835948,1.4147011,4.2686881,6.6502235,65.3587475,1.8171164,15.3112026,4.7007976,16.8034861,2.850517,8.4438245,1.7802395,22.623669),(6663,'ulna-cleaned.tif',183,4,187,11.3699222,4.2056922,10.9960148,1.8,4.1912953,10.9840776,1.383291,1.4203048,4.2893638,6.783703,66.1599786,1.8291397,15.4241938,4.7762303,16.9381157,2.8366599,8.4875471,1.8032329,22.8260047),(6664,'ulna-cleaned.tif',183,4,188,11.4912519,4.2077087,10.981034,1.8,4.1921107,10.9704411,1.3837454,1.4088152,4.2890424,6.9545192,67.0869452,1.8489771,15.6414741,4.9364312,17.1624467,2.8539425,8.4997304,1.7884469,22.6276792),(6665,'ulna-cleaned.tif',183,4,189,11.5978148,4.2137729,10.9711541,1.8,4.1981377,10.9581654,1.3849559,1.412902,4.2810955,7.09569,67.8729793,1.8669758,15.8541146,5.0220682,17.4558216,2.8539425,8.5084355,1.7930258,22.8300148),(6666,'ulna-cleaned.tif',183,4,190,11.7147927,4.2216494,10.9570592,1.8,4.2045109,10.9376851,1.3863111,1.4151311,4.2620628,7.2685599,68.5520475,1.8867641,16.0842417,5.1363156,17.6661284,2.8603462,8.5062835,1.812362,22.9565606),(6667,'ulna-cleaned.tif',183,4,191,11.8177057,4.2286837,10.9448546,1.8,4.2094761,10.9225154,1.3882617,1.4419782,4.2691462,7.4308025,69.3538986,1.9047178,16.2453792,5.1532004,17.8417646,2.8938863,8.5218967,1.7782926,22.8573978),(6668,'ulna-cleaned.tif',183,4,192,11.9013738,4.2375596,10.9258833,1.8,4.2175661,10.8982703,1.3893651,1.5136893,4.2868021,7.6424188,70.1739481,1.9189821,16.3697663,5.0488688,18.0042648,2.9860176,8.5528516,1.7727664,23.2290148),(6669,'ulna-cleaned.tif',183,4,193,11.9856472,4.2434367,10.8992669,1.8,4.2222518,10.8668081,1.391048,1.5538721,4.3021371,7.8451629,71.1207005,1.9337584,16.5314817,5.0487828,18.2798933,3.0397918,8.5652209,1.8010868,23.3361979),(6670,'ulna-cleaned.tif',183,4,194,12.1303043,4.2465984,10.8693714,1.8,4.2244878,10.835194,1.3920542,1.5933802,4.3313849,8.0778544,72.2279549,1.957811,16.6754876,5.069634,18.4639939,3.1037132,8.6132264,1.8045395,23.4216691),(6671,'ulna-cleaned.tif',183,4,195,12.288095,4.2449343,10.8313058,1.8,4.222053,10.793403,1.3917838,1.6209272,4.3690317,8.3067403,73.5345027,1.9830842,16.8308469,5.1246844,18.6537656,3.1474801,8.6520464,1.8034714,23.8126488),(6672,'ulna-cleaned.tif',183,4,196,12.4859521,4.2398958,10.8000723,1.8,4.218739,10.7676764,1.3902675,1.6231162,4.3822899,8.5417035,75.1058465,2.0139047,17.1384935,5.2625336,19.0478917,3.1485806,8.6718042,1.8313987,23.5578962),(6673,'ulna-cleaned.tif',183,4,197,12.6926574,4.2305005,10.7613951,1.8,4.2116487,10.7305757,1.3852419,1.6467563,4.4131965,8.7718348,76.8187402,2.0434394,17.4065985,5.3267353,19.3361348,3.1757758,8.6927077,1.840269,23.0814453),(6674,'ulna-cleaned.tif',183,4,198,12.9347797,4.2209287,10.7231879,1.8,4.2050435,10.6909223,1.3807825,1.6672111,4.4509533,8.9876905,78.7010778,2.0788933,17.6818477,5.3908535,19.6370414,3.1855465,8.7191317,1.815775,23.340208),(6675,'ulna-cleaned.tif',183,4,199,13.1942633,4.2160317,10.6941896,1.8,4.2014353,10.6626106,1.3780762,1.6715001,4.4631271,9.2089952,80.3170908,2.1183752,17.9956987,5.5094193,19.9951668,3.2074675,8.7526634,1.8478436,23.5949606),(6676,'ulna-cleaned.tif',183,4,200,13.4887981,4.2109981,10.6668562,1.8,4.1962458,10.6415067,1.3754833,1.6677039,4.4825174,9.4043428,82.0961577,2.163458,18.3147439,5.6390961,20.3109154,3.2001877,8.7696535,1.8378465,23.6086521),(6677,'ulna-cleaned.tif',183,4,201,13.7966136,4.2057627,10.6349579,1.8,4.1910843,10.6115057,1.3724244,1.6882694,4.5138875,9.5844749,83.7274996,2.2101302,18.5488673,5.6771006,20.5661315,3.2320068,8.7977467,1.8322751,23.8964589),(6678,'ulna-cleaned.tif',183,4,202,14.1195868,4.195957,10.5930636,1.8,4.1807977,10.5694288,1.368909,1.6805027,4.5406796,9.7777209,85.5318355,2.258645,18.8367914,5.8183309,20.9488345,3.21595,8.8131145,1.8553148,23.8343606),(6679,'ulna-cleaned.tif',183,4,203,14.3805357,4.1831293,10.5549749,1.8,4.1707542,10.5387157,1.3656518,1.6898252,4.555514,9.907713,86.880036,2.2972972,19.0714014,5.8631585,21.1092816,3.2285855,8.8081455,1.8366511,23.7876148),(6680,'ulna-cleaned.tif',183,4,204,14.5945145,4.1700036,10.5208236,1.8,4.1590007,10.5071519,1.3631649,1.670933,4.5908027,9.9611477,87.917686,2.3290538,19.1508307,5.9614286,21.1846602,3.219345,8.8362964,1.8311079,23.6126623),(6681,'ulna-cleaned.tif',183,4,205,14.7229382,4.1631135,10.49976,1.8,4.1532116,10.4853738,1.361012,1.6696748,4.6121062,9.9391545,88.4201638,2.3474065,19.1713199,5.9527486,21.2675667,3.2117022,8.8403493,1.8497159,23.4941368),(6682,'ulna-cleaned.tif',183,4,206,14.7918975,4.1603479,10.4952108,1.8,4.1514376,10.4832889,1.3607362,1.6436357,4.6253573,9.8677858,88.7922769,2.3581242,19.1968472,6.0036331,21.284458,3.1856094,8.8748581,1.8299507,23.7876148),(6683,'ulna-cleaned.tif',183,4,207,14.7793597,4.1590681,10.497771,1.8,4.1500983,10.4826282,1.3596943,1.6385689,4.6060821,9.7460198,88.8799861,2.3550762,19.2962227,5.9478852,21.3378499,3.1942454,8.8571712,1.8398141,23.632025),(6684,'ulna-cleaned.tif',183,4,208,14.783497,4.1587968,10.5048669,1.8,4.1509587,10.4881933,1.3585269,1.6221331,4.5903444,9.6157064,88.6805954,2.3545537,19.3189417,5.9278158,21.3215425,3.1789685,8.8571712,1.8398141,23.8617436),(6685,'ulna-cleaned.tif',183,4,209,14.7755338,4.1597142,10.5164378,1.8,4.1520836,10.4983529,1.3572851,1.6081828,4.5783077,9.421138,88.2464733,2.3520224,19.2749111,5.8582507,21.2386021,3.1610174,8.8547443,1.8212394,23.844042),(6686,'ulna-cleaned.tif',183,4,210,14.8078142,4.1580797,10.5276149,1.8,4.1491369,10.5047404,1.3558258,1.613713,4.5536547,9.2214753,88.0874133,2.3556645,19.3443332,5.7144457,21.3204808,3.169993,8.8571712,1.8398141,23.6884521),(6687,'ulna-cleaned.tif',183,4,211,14.8276327,4.1571476,10.5381857,1.8,4.1472521,10.5154103,1.35411,1.584418,4.5344168,8.9901994,87.7924109,2.3570432,19.3613454,5.6741337,21.2798872,3.1317483,8.8547443,1.8212394,23.4667538),(6688,'ulna-cleaned.tif',183,4,212,14.8595265,4.1576593,10.5508193,1.8,4.1482491,10.5295015,1.3523136,1.5667248,4.5213326,8.7546909,87.4287108,2.3602377,19.336934,5.5878933,21.2068057,3.1239735,8.8362964,1.8311079,23.499808),(6689,'ulna-cleaned.tif',183,4,213,14.7843746,4.1601848,10.5699152,1.8,4.1519365,10.5546088,1.3503728,1.5528932,4.5014429,8.4894706,86.2577693,2.3462686,19.162249,5.4668733,20.9792524,3.0972881,8.8258405,1.8080997,23.4917877),(6690,'ulna-cleaned.tif',183,4,214,14.5981924,4.1662924,10.6016623,1.8,4.1583753,10.587024,1.3496073,1.5546314,4.4561814,8.2288017,84.2847559,2.3159256,18.9141213,5.2930885,20.7301456,3.0972881,8.8160946,1.8223611,23.7271776),(6691,'ulna-cleaned.tif',183,4,215,14.3110149,4.1717098,10.640801,1.8,4.1618041,10.62165,1.3482542,1.5542057,4.4076743,7.9632518,81.7961597,2.2689809,18.5576689,5.1236793,20.3222883,3.1070449,8.8062475,1.8179728,23.8029674),(6692,'ulna-cleaned.tif',183,4,216,13.9204473,4.1766084,10.6872257,1.8,4.1631144,10.6560105,1.3465815,1.5290545,4.3741533,7.6967734,78.4759727,2.2053805,17.9408373,5.0336816,19.5496217,3.06767,8.7875167,1.8278889,23.4119877),(6693,'ulna-cleaned.tif',183,4,217,13.5270355,4.1827265,10.7426553,1.8,4.1670989,10.6979859,1.3438823,1.5280537,4.4040627,7.4410197,74.8159971,2.1404003,16.98795,4.8696061,18.5973365,3.0676839,8.7297154,1.8013636,23.5732488),(6694,'ulna-cleaned.tif',183,4,218,13.1764089,4.192054,10.8155674,1.8,4.1744084,10.7608183,1.3403889,1.5375636,4.4123996,7.2231139,70.9131245,2.0815327,16.0713286,4.6977659,17.673025,3.0663523,8.7297154,1.8013636,23.0887775),(6695,'ulna-cleaned.tif',183,4,219,12.8193209,4.2050399,10.905264,1.8,4.1821523,10.8298749,1.3370471,1.5293054,4.4647577,7.0326279,66.2542682,2.0219257,14.8393871,4.5985765,16.385605,3.0650045,8.6520464,1.8034714,22.8066419),(6696,'ulna-cleaned.tif',183,4,220,12.4887588,4.2245161,11.0142877,1.8,4.1996938,10.9291905,1.3335786,1.538182,4.4705043,6.8767224,61.0344067,1.966512,13.6526895,4.4706819,15.182879,3.0467205,8.3806151,1.7672582,22.7639063),(6697,'ulna-cleaned.tif',183,4,221,12.2247752,4.2422004,11.1117511,1.8,4.2167951,11.0209496,1.3297329,1.5280541,4.2510466,6.7336469,56.2489427,1.9213382,13.2317868,4.4066808,14.8157752,3.0260668,8.1850454,1.772016,22.5068046),(6698,'ulna-cleaned.tif',183,4,222,12.0451516,4.2593831,11.2005238,1.8,4.2380574,11.1218892,1.3251028,1.5267488,4.0025367,6.607813,52.2808015,1.8887593,13.0619167,4.3280291,14.7107135,3.0157399,7.8485442,1.7652009,21.1098181),(6699,'ulna-cleaned.tif',183,4,223,11.9238448,4.273882,11.2739709,1.8,4.2563328,11.2109588,1.3216292,1.5237342,3.7283321,6.4717184,49.2737208,1.8664592,13.2160225,4.2472751,14.9378001,3.005413,7.4885616,1.7692368,20.282774),(6700,'ulna-cleaned.tif',183,4,224,11.8451264,4.2834477,11.3220441,1.8,4.2650541,11.2582576,1.3180513,1.5094955,3.6919807,6.3567183,47.1809848,1.850739,12.7793153,4.2111542,14.491745,2.9845216,7.3841956,1.82757,20.4440351),(6701,'ulna-cleaned.tif',183,4,225,11.7350752,4.2948983,11.3685246,1.8,4.2786533,11.3120906,1.3149353,1.5126518,3.6071407,6.2474299,45.3068479,1.8305764,12.5603217,4.1301177,14.2902404,2.9901538,7.2346745,1.8559141,20.4730791),(6702,'ulna-cleaned.tif',183,4,226,11.6388826,4.3044016,11.4094248,1.8,4.2871323,11.3604468,1.3117948,1.5449167,3.5630377,6.1452713,43.7243454,1.8125713,12.2716482,3.9777363,13.9892757,2.9970664,7.0816601,1.8622531,20.0256723),(6703,'ulna-cleaned.tif',183,4,227,11.5671365,4.3124464,11.4420744,1.8,4.2973519,11.4005978,1.3105665,1.5465581,3.5215178,6.0781925,42.4996556,1.800223,12.0685618,3.9301416,13.7908945,2.9970664,7.0320285,1.8584488,19.2977909),(6704,'ulna-cleaned.tif',183,4,228,11.4037992,4.3221439,11.4773009,1.8,4.3077748,11.4397619,1.3098407,1.5469003,3.4617704,5.9858695,40.9372084,1.7741156,11.8255124,3.8695898,13.4966269,2.9952375,6.9017776,1.894375,18.7181671),(6705,'ulna-cleaned.tif',183,4,229,11.220865,4.3298622,11.5099849,1.8,4.3151864,11.4785427,1.3094802,1.4993565,3.4411125,5.8947223,39.6162495,1.7453198,11.5126285,3.9315014,13.2250485,2.9363722,6.8453798,1.8482953,18.2844518),(6706,'ulna-cleaned.tif',183,4,230,11.0158144,4.3338442,11.5375361,1.8,4.3174878,11.5077079,1.3076096,1.5117431,3.403026,5.7852716,38.4013093,1.7117059,11.2844597,3.826888,12.9813749,2.955409,6.7886308,1.8813949,18.9769299),(6707,'ulna-cleaned.tif',183,4,231,10.79593,4.3381407,11.5701135,1.8,4.3235594,11.546574,1.3061618,1.4787594,3.3494751,5.692009,37.1506166,1.6762267,11.0914743,3.8491785,12.7710627,2.9171521,6.6775009,1.8244704,18.7472112),(6708,'ulna-cleaned.tif',183,4,232,10.5993485,4.3396663,11.5981827,1.8,4.3267752,11.578489,1.3021229,1.4496457,3.335855,5.6159814,36.2354089,1.6420773,10.8624051,3.8740372,12.5448755,2.874977,6.6385257,1.8697371,18.4046383),(6709,'ulna-cleaned.tif',183,4,233,10.4258379,4.3424567,11.6280721,1.8,4.3310542,11.610226,1.2975448,1.4589954,3.2864155,5.566856,35.3730171,1.6110935,10.7634039,3.8155405,12.3934499,2.874977,6.562307,1.8733185,18.3892858),(6710,'ulna-cleaned.tif',183,4,234,10.2893494,4.3432164,11.6532931,1.8,4.3331109,11.6363673,1.2928824,1.4693341,3.2548313,5.5278654,34.4813602,1.5858151,10.5939008,3.7621569,12.2650019,2.874977,6.4871561,1.9158889,18.0467129),(6711,'ulna-cleaned.tif',183,4,235,10.2131369,4.3424261,11.6701404,1.8,4.3346029,11.6548346,1.287559,1.4796307,3.2551175,5.4898339,33.7769262,1.5692469,10.3765614,3.7102731,12.0626928,2.8828867,6.4742593,1.8711077,17.6694247),(6712,'ulna-cleaned.tif',183,4,236,10.1825955,4.3388045,11.6826836,1.8,4.3327626,11.6692534,1.2822057,1.468861,3.2170421,5.4519841,33.2023699,1.5596377,10.3207758,3.7117085,11.9820915,2.8595554,6.398572,1.9142397,17.8250145),(6713,'ulna-cleaned.tif',183,4,237,10.11954,4.340275,11.7023103,1.8,4.3372027,11.6955653,1.2780838,1.4577504,3.1941886,5.3906144,32.5039843,1.5461622,10.1759754,3.6978994,11.8537829,2.8461175,6.3571358,1.9501372,17.7412044),(6714,'ulna-cleaned.tif',183,4,238,10.0839962,4.3434761,11.7206518,1.8,4.3388106,11.7097674,1.2743453,1.4640483,3.1677119,5.3552411,31.852666,1.5372402,10.0554176,3.6578309,11.7448623,2.8612399,6.3053365,1.9466024,17.4824416),(6715,'ulna-cleaned.tif',183,4,239,10.0095549,4.3500048,11.7455933,1.8,4.3427526,11.733998,1.270724,1.460048,3.1390404,5.3050591,31.0641379,1.5224983,9.8960617,3.6334828,11.5830457,2.849868,6.2459753,1.9026475,17.3969704),(6716,'ulna-cleaned.tif',183,4,240,9.9218772,4.3567612,11.7662411,1.8,4.348135,11.7526218,1.2693557,1.4466058,3.0937209,5.2132511,30.2674979,1.5078817,9.7835258,3.6037815,11.4399692,2.8365804,6.2110859,1.9250557,17.2510619),(6717,'ulna-cleaned.tif',183,4,241,9.8678223,4.3639815,11.7850154,1.8,4.3559968,11.7718027,1.2677312,1.4255629,3.0855368,5.1426913,29.5013508,1.4981482,9.5611728,3.6074812,11.2275725,2.8250549,6.20198,1.9393558,17.5114857),(6718,'ulna-cleaned.tif',183,4,242,9.8156939,4.3698441,11.8017399,1.8,4.361026,11.7868582,1.2656211,1.4268191,3.0678651,5.0750258,28.7802557,1.4882614,9.3812,3.556881,11.0353066,2.8249116,6.1647761,1.9416876,17.2857772),(6719,'ulna-cleaned.tif',183,4,243,9.7754682,4.3788667,11.8185198,1.8,4.3727018,11.8008616,1.2631484,1.4098322,3.0232263,5.0404349,28.0959252,1.4798451,9.2933583,3.575202,10.9076878,2.8022398,6.1052217,1.9525163,17.1028044),(6720,'ulna-cleaned.tif',183,4,244,9.7170438,4.3827533,11.8356034,1.8,4.3743414,11.818197,1.2607288,1.4033238,3.0044212,4.9784564,27.4613264,1.4687311,9.140305,3.5476177,10.7459175,2.8066094,6.0773871,1.9756881,17.0834416),(6721,'ulna-cleaned.tif',183,4,245,9.6746313,4.3870008,11.8492977,1.8,4.3770863,11.8308067,1.2574901,1.393241,2.9997935,4.9359438,26.9071403,1.4592719,8.9696642,3.5427782,10.5914835,2.7956358,6.0387567,1.942714,16.6924619),(6722,'ulna-cleaned.tif',183,4,246,9.62851,4.3909709,11.8636412,1.8,4.3798232,11.8433387,1.2541456,1.3974636,2.9898216,4.8764627,26.4321064,1.4491534,8.8406969,3.4895097,10.4381378,2.7925931,6.0163063,1.9513027,17.0076518),(6723,'ulna-cleaned.tif',183,4,247,9.586073,4.3957117,11.8772391,1.8,4.3838947,11.8549919,1.2506845,1.3769818,2.9671602,4.8348071,25.9775668,1.4394784,8.7550266,3.5111626,10.2998602,2.7652999,5.9727516,1.9686707,16.881106),(6724,'ulna-cleaned.tif',183,4,248,9.5209199,4.4000257,11.8914961,1.8,4.3860087,11.8691377,1.2478568,1.3952669,2.957698,4.794311,25.5799447,1.4270042,8.6485992,3.4361248,10.1721525,2.7799251,5.9516573,1.9774487,16.509489),(6725,'ulna-cleaned.tif',183,4,249,9.4488061,4.4037074,11.9047265,1.8,4.39056,11.8847656,1.2442253,1.3862296,2.9350896,4.7756761,25.2076747,1.4127369,8.5883834,3.445083,10.1164949,2.7704984,5.8992661,1.9739119,16.6787704),(6726,'ulna-cleaned.tif',183,4,250,9.3940784,4.4048322,11.9158616,1.8,4.3909711,11.8958762,1.2392069,1.4098537,2.9325407,4.7473294,24.8428256,1.3997484,8.4714342,3.3672498,10.0668072,2.7767991,5.8701838,1.9247938,16.4957975),(6727,'ulna-cleaned.tif',183,4,251,9.3712871,4.4054091,11.9254577,1.8,4.3934954,11.909158,1.2342743,1.3957336,2.9064693,4.7021457,24.5651237,1.3915797,8.4518778,3.3689422,10.039266,2.768147,5.8385032,1.9487646,16.2837806),(6728,'ulna-cleaned.tif',183,4,252,9.3579092,4.4055555,11.9311649,1.8,4.3943465,11.9129554,1.2289341,1.4081772,2.9022245,4.6699708,24.2628944,1.3843665,8.3601026,3.3163232,9.9171529,2.773853,5.8163747,1.957672,16.3071534),(6729,'ulna-cleaned.tif',183,4,253,9.3407692,4.4071003,11.9440864,1.8,4.3958,11.9256341,1.2240473,1.3940755,2.9027626,4.6513486,23.9382279,1.3769965,8.2467053,3.3365111,9.8147371,2.773853,5.8054159,1.9883228,16.1378721),(6730,'ulna-cleaned.tif',183,4,254,9.2986992,4.4079845,11.9560663,1.8,4.3964431,11.9374864,1.2195013,1.380311,2.8953844,4.624074,23.6146719,1.3662665,8.1559713,3.3500232,9.6594846,2.7518052,5.801987,2.0036844,16.0250178),(6731,'ulna-cleaned.tif',183,4,255,9.2397311,4.4085696,11.9642473,1.8,4.397511,11.9440857,1.2137756,1.4020874,2.8681352,4.5979396,23.3009596,1.3518661,8.12408,3.2793531,9.6344299,2.7657064,5.7490626,2.0002957,15.8500652),(6732,'ulna-cleaned.tif',183,4,256,9.1723804,4.4096734,11.9734421,1.8,4.4003735,11.9544252,1.2088394,1.4165141,2.8508018,4.5767917,23.020269,1.337042,8.0750155,3.2310245,9.6174279,2.774524,5.7162931,1.9876032,15.9726009),(6733,'ulna-cleaned.tif',183,4,257,9.1135315,4.408522,11.9797299,1.8,4.3975298,11.9590123,1.2034648,1.4237661,2.8435414,4.5642273,22.7895239,1.323024,8.0144863,3.2057423,9.5820391,2.7887796,5.684455,1.9747665,15.869428),(6734,'ulna-cleaned.tif',183,4,258,9.0653347,4.406878,11.9827193,1.8,4.395228,11.9608436,1.1985767,1.4096246,2.8179043,4.5497077,22.5906001,1.3110498,8.0168089,3.2276023,9.5071072,2.769978,5.6598964,1.9997575,15.7742754),(6735,'ulna-cleaned.tif',183,4,259,9.0459119,4.4047571,11.9835083,1.8,4.3931234,11.959731,1.1931398,1.394494,2.8186904,4.5266708,22.4233775,1.3026542,7.9552467,3.2461027,9.5205453,2.769978,5.653564,1.9617872,15.8637568),(6736,'ulna-cleaned.tif',183,4,260,9.0165077,4.4032824,11.9861356,1.8,4.3923627,11.9653882,1.1876397,1.3952877,2.8141494,4.4951214,22.2107948,1.292721,7.8925428,3.2216447,9.4239682,2.7690114,5.6598964,1.9997575,16.0210077),(6737,'ulna-cleaned.tif',183,4,261,9.0091563,4.4025066,11.9890938,1.8,4.3915954,11.9709506,1.1837116,1.4003787,2.8023557,4.4833867,22.0340548,1.28756,7.8626904,3.2015531,9.391752,2.7690114,5.6271734,1.9868608,15.4881296),(6738,'ulna-cleaned.tif',183,4,262,9.0015639,4.4026914,11.9890208,1.8,4.3928464,11.9708011,1.180652,1.4244354,2.7897456,4.4588527,21.9097154,1.2832558,7.8536607,3.1302596,9.3518226,2.7810391,5.6215123,2.0185723,15.6630822),(6739,'ulna-cleaned.tif',183,4,263,8.9944676,4.4006945,11.987871,1.8,4.3914622,11.9713564,1.1766634,1.4289064,2.780104,4.4338916,21.7456086,1.2780209,7.8218688,3.1029965,9.2993627,2.7786023,5.5953972,1.9738155,16.0677534),(6740,'ulna-cleaned.tif',183,4,264,8.9911752,4.3983769,11.9865776,1.8,4.3885055,11.9702113,1.1718809,1.3974131,2.7731464,4.4055409,21.6051371,1.2724469,7.790839,3.1526403,9.3289769,2.7591522,5.5907007,1.9897453,15.7001466),(6741,'ulna-cleaned.tif',183,4,265,8.9572511,4.3981698,11.988655,1.8,4.3874948,11.9707165,1.1667412,1.3866792,2.7613799,4.3832184,21.3796883,1.2621259,7.7423929,3.1609464,9.2451962,2.7314496,5.558716,1.9766306,15.4550754),(6742,'ulna-cleaned.tif',183,4,266,8.92138,4.3978062,11.9919366,1.8,4.3855227,11.9714764,1.1613097,1.3929006,2.7415418,4.374757,21.1780391,1.2512024,7.7248645,3.1407531,9.1421322,2.7498108,5.5344624,2.0021971,15.7428822),(6743,'ulna-cleaned.tif',183,4,267,8.875327,4.4002207,11.9978534,1.8,4.3892739,11.9785613,1.1573011,1.3919488,2.7352869,4.358344,20.9732608,1.2403961,7.6676639,3.1311095,9.0446051,2.7320075,5.5220794,1.9794832,15.4938008),(6744,'ulna-cleaned.tif',183,4,268,8.8494001,4.4003607,11.9976209,1.8,4.3873543,11.9751785,1.1515457,1.4026103,2.7328108,4.352484,20.8718736,1.2304929,7.6375114,3.1031314,9.0064578,2.7494598,5.5186187,2.0764903,15.6397093),(6745,'ulna-cleaned.tif',183,4,269,8.8291557,4.4020001,12.0000678,1.8,4.3879163,11.9761485,1.147209,1.3932344,2.7415396,4.3416411,20.7010245,1.2229139,7.5508757,3.1162316,8.9170649,2.7450924,5.5323046,2.0505716,16.0774348),(6746,'ulna-cleaned.tif',183,4,270,8.800754,4.4011565,11.9978384,1.8,4.3862859,11.9713171,1.1435607,1.3871761,2.7267972,4.3245602,20.5103571,1.2149568,7.5217756,3.117528,8.8496084,2.7421314,5.4982433,2.0052315,15.7291907),(6747,'ulna-cleaned.tif',183,4,271,8.7904061,4.3995295,11.9945645,1.8,4.384068,11.9677023,1.1404831,1.3869577,2.7298149,4.3164449,20.4236308,1.2101186,7.4816907,3.1121676,8.8418142,2.7421314,5.4963609,2.0214577,15.418011),(6748,'ulna-cleaned.tif',183,4,272,8.7811553,4.3988142,11.9934243,1.8,4.3859076,11.971651,1.1369269,1.3897907,2.72507,4.3123806,20.336045,1.2048866,7.462577,3.1028992,8.8131066,2.7421314,5.4790998,2.0149024,15.5969737),(6749,'ulna-cleaned.tif',183,4,273,8.7801619,4.3948007,11.9855591,1.8,4.3810296,11.9620163,1.1315063,1.3966839,2.7336272,4.3072024,20.3310347,1.1986713,7.4373837,3.0838778,8.8194538,2.7413215,5.4785186,2.0474725,15.5695907),(6750,'ulna-cleaned.tif',183,4,274,8.765979,4.393735,11.9829863,1.8,4.378407,11.9581303,1.1272301,1.4167654,2.737933,4.3047995,20.2498744,1.1919085,7.3960447,3.0384702,8.7972725,2.767107,5.4780827,2.0311866,15.8670789),(6751,'ulna-cleaned.tif',183,4,275,8.7266787,4.3966643,11.984261,1.8,4.3829285,11.9613751,1.1250647,1.4153209,2.7179706,4.2891409,20.0747177,1.1841189,7.3859215,3.0305078,8.7193057,2.7609463,5.4540543,2.099924,15.5736008),(6752,'ulna-cleaned.tif',183,4,276,8.7022997,4.3986628,11.9827098,1.8,4.3852008,11.9603657,1.1214433,1.4152502,2.7177517,4.3021175,19.9775716,1.1767126,7.3507714,3.0398283,8.6681488,2.7651283,5.4620755,2.0083061,15.5462178),(6753,'ulna-cleaned.tif',183,4,277,8.706742,4.3988118,11.9781491,1.8,4.3833961,11.9541855,1.1175015,1.4313377,2.7034488,4.3144129,19.9767723,1.1728233,7.3893659,3.0142523,8.680604,2.7800232,5.4430972,2.018052,15.4043195),(6754,'ulna-cleaned.tif',183,4,278,8.6880838,4.4016971,11.975378,1.8,4.3877737,11.9538863,1.1164208,1.4292903,2.7043869,4.3130252,19.9159474,1.1690767,7.3643115,3.0175991,8.6763544,2.8014913,5.4294798,2.0771811,15.5736008),(6755,'ulna-cleaned.tif',183,4,279,8.6770714,4.4036366,11.9713421,1.8,4.3900111,11.9519732,1.1162968,1.4348497,2.7238286,4.3298273,19.8297818,1.1674534,7.2801136,3.0176174,8.6114398,2.7922325,5.4430972,2.0508359,15.5599093),(6756,'ulna-cleaned.tif',183,4,280,8.6669216,4.4065718,11.9659551,1.8,4.3918071,11.944587,1.1138608,1.4409358,2.7269989,4.3386588,19.7738766,1.1633067,7.2511494,3.0110007,8.6581872,2.7989076,5.4430972,2.0508359,15.6066551),(6757,'ulna-cleaned.tif',183,4,281,8.6829936,4.4085182,11.9633578,1.8,4.391326,11.9403354,1.1109224,1.4428119,2.7283178,4.3734869,19.7461121,1.162089,7.2374679,3.0312247,8.5668488,2.7989076,5.4463136,2.2524021,15.4744381),(6758,'ulna-cleaned.tif',183,4,282,8.6687244,4.4096461,11.9602983,1.8,4.390616,11.9364753,1.1085488,1.4404111,2.7121347,4.3810241,19.660894,1.1574465,7.2492321,3.0415096,8.5988564,2.7969543,5.4287467,1.9949907,15.2390483),(6759,'ulna-cleaned.tif',183,4,283,8.6765778,4.4085227,11.9539578,1.8,4.3920966,11.9302568,1.1048854,1.4576369,2.7171703,4.3993335,19.6234337,1.1542542,7.2220111,3.0181272,8.6066452,2.8030769,5.4287467,1.9949907,15.3245195),(6760,'ulna-cleaned.tif',183,4,284,8.6881636,4.4036346,11.9448691,1.8,4.3874435,11.9193606,1.0994441,1.4608047,2.7082954,4.4159599,19.6606228,1.1494455,7.2594084,3.022964,8.57976,2.792705,5.4100929,2.2674232,15.3575737),(6761,'ulna-cleaned.tif',183,4,285,8.6965583,4.4024343,11.9399507,1.8,4.3866654,11.9144294,1.0943356,1.4988826,2.7312081,4.4495911,19.6665949,1.1445426,7.2006945,2.9686055,8.6060667,2.8332066,5.4347551,2.2260443,15.6260178),(6762,'ulna-cleaned.tif',183,4,286,8.7174948,4.4004599,11.9321694,1.8,4.3838349,11.9053236,1.0903414,1.4993598,2.7368305,4.4811723,19.6635054,1.1425544,7.1847727,2.9887238,8.6357814,2.8272376,5.4463136,2.2524021,15.7622449),(6763,'ulna-cleaned.tif',183,4,287,8.7466166,4.3979225,11.9231529,1.8,4.3814181,11.8961027,1.086489,1.4995948,2.730042,4.5119961,19.6681722,1.1417555,7.2043478,3.0088103,8.6481571,2.8204857,5.4347551,2.2260443,15.2914652),(6764,'ulna-cleaned.tif',183,4,288,8.7829392,4.3955272,11.91439,1.8,4.3793221,11.8865291,1.0827299,1.5031409,2.7361852,4.5451581,19.7023767,1.1419505,7.2006736,3.0237737,8.6944744,2.8204857,5.4347551,2.2260443,15.4003093),(6765,'ulna-cleaned.tif',183,4,289,8.7942768,4.3963777,11.9079766,1.8,4.3811519,11.8816191,1.0798685,1.5162595,2.7383076,4.5644305,19.6443391,1.1399438,7.1738978,3.0103227,8.6575858,2.838681,5.4463136,2.2524021,15.6590721),(6766,'ulna-cleaned.tif',183,4,290,8.7968904,4.3992538,11.9024347,1.8,4.3842565,11.8753438,1.0794547,1.5276981,2.739225,4.5767707,19.5660268,1.1397779,7.142906,2.9958606,8.6537592,2.841,5.4463136,2.2524021,15.3712652),(6767,'ulna-cleaned.tif',183,4,291,8.7950637,4.4039057,11.8986505,1.8,4.3886304,11.8715108,1.0781874,1.5258216,2.7475544,4.6087851,19.4498746,1.1379945,7.0789771,3.0205268,8.5618141,2.8355024,5.4463136,2.2524021,15.5131636),(6768,'ulna-cleaned.tif',183,4,292,8.8063705,4.4075619,11.8930836,1.8,4.392157,11.8669627,1.078231,1.5302859,2.7481587,4.6408658,19.4063485,1.1395108,7.0615821,3.032679,8.5821785,2.841,5.4463136,2.2524021,15.5462178),(6769,'ulna-cleaned.tif',183,4,293,8.8256817,4.4094529,11.88298,1.8,4.3939851,11.8554927,1.0775289,5.4604245,2.7533276,4.6951194,19.3884165,1.1411485,7.0418123,0.8598451,4.1754264,2.8730589,5.4347551,2.2260443,15.9098145),(6770,'ulna-cleaned.tif',183,4,294,8.868638,4.4105382,11.8704285,1.8,4.3959054,11.8425494,1.0767543,5.4711638,2.7473667,4.7458144,19.4441909,1.1457472,7.077392,0.8674232,4.2023318,2.8717001,5.4347551,2.2260443,15.6881161),(6771,'ulna-cleaned.tif',183,4,295,8.9163185,4.4116274,11.8587345,1.8,4.3969708,11.8320219,1.0755043,1.5730994,2.7539054,4.7738213,19.5166273,1.1503548,7.0868909,3.0346597,8.6984867,2.871594,5.4463136,2.2524021,15.5599093),(6772,'ulna-cleaned.tif',183,4,296,8.9525483,4.4116914,11.8438268,1.8,4.3963357,11.8153259,1.075348,2.4137396,3.0875297,4.8304441,19.603583,1.1548339,6.3492776,2.0012283,6.234676,2.8888485,5.4463136,2.2524021,15.3809466),(6773,'ulna-cleaned.tif',183,4,297,8.980712,4.4138583,11.8347457,1.8,4.3984638,11.8068424,1.0736615,2.4127077,3.1145636,4.8662899,19.6123457,1.156353,6.2969804,2.0169414,6.2609406,2.8873743,5.4463136,2.2524021,15.3148381),(6774,'ulna-cleaned.tif',183,4,298,8.9994801,4.4179121,11.825544,1.8,4.4038755,11.8002051,1.0712217,2.3581022,3.048566,4.8945491,19.6064972,1.1556968,6.4313836,2.0756306,6.3570711,2.8928719,5.4743034,2.211382,15.2817839),(6775,'ulna-cleaned.tif',183,4,299,9.0460536,4.4175496,11.8137335,1.8,4.4022391,11.7896204,1.0686732,1.6197411,2.7909659,4.9361104,19.6809415,1.1584408,7.0516597,3.0474688,8.7389996,2.9235721,5.4837468,2.2375829,15.8654178),(6776,'ulna-cleaned.tif',183,4,300,9.1093522,4.4171618,11.7999662,1.8,4.401539,11.7745286,1.0673571,1.6484197,2.7870074,5.00825,19.7722645,1.1648596,7.0944427,3.0382129,8.8001096,2.955415,5.4837468,2.2375829,15.9138246),(6777,'ulna-cleaned.tif',183,4,301,9.1527484,4.4180585,11.786372,1.8,4.4031832,11.7619,1.0666572,1.6482846,2.7946289,5.0703644,19.7861831,1.1695061,7.0800754,3.0761462,8.7882239,2.9523152,5.4773561,2.2478126,15.5832822),(6778,'ulna-cleaned.tif',183,4,302,9.1966861,4.4192536,11.7750331,1.8,4.4028401,11.7530927,1.0658109,1.6887341,2.7879882,5.1368446,19.8255218,1.1740224,7.1110494,3.0418315,8.8315085,2.9903953,5.4664458,2.2215966,15.7679161),(6779,'ulna-cleaned.tif',183,4,303,9.2094882,4.4213072,11.7619237,1.8,4.402977,11.7393077,1.0650616,1.6805738,2.7944145,5.1947289,19.7772092,1.1746824,7.0774072,3.0910447,8.8022012,2.9903953,5.4773561,2.2478126,15.8283534),(6780,'ulna-cleaned.tif',183,4,304,9.2389021,4.4255279,11.7508253,1.8,4.4060489,11.7278336,1.0654052,1.7101523,2.7866558,5.2631888,19.7779468,1.1788825,7.097377,3.0776141,8.8266925,3.0242124,5.4837468,2.2375829,15.5736008),(6781,'ulna-cleaned.tif',183,4,305,9.2528972,4.4315134,11.7418579,1.8,4.4129261,11.7194012,1.064897,1.7354904,2.8144774,5.3300255,19.7213084,1.1800041,7.0070941,3.0711928,8.8150635,3.0435431,5.5063447,2.2070512,15.8847805),(6782,'ulna-cleaned.tif',183,4,306,9.2608506,4.4381275,11.7362758,1.8,4.4191631,11.7138608,1.0628821,1.8046339,2.8115181,5.4056201,19.629016,1.1783784,6.9816432,2.9954109,8.8001301,3.1304675,5.5334555,2.2489156,15.7662551),(6783,'ulna-cleaned.tif',183,4,307,9.2594526,4.4440775,11.7322353,1.8,4.4241974,11.7091157,1.0608046,1.8172411,2.8000208,5.4811634,19.4566505,1.1754721,6.948752,3.0162005,8.7813556,3.1521986,5.5223677,2.2229677,15.9685907),(6784,'ulna-cleaned.tif',183,4,308,9.2420416,4.4529182,11.7308732,1.8,4.4328856,11.7067639,1.0567927,1.8986628,2.8017653,5.5577303,19.2433428,1.1679832,6.8682922,2.9271813,8.6828352,3.2343216,5.5151559,2.2331085,15.8928008),(6785,'ulna-cleaned.tif',183,4,309,9.2335878,4.4634058,11.730428,1.8,4.4446301,11.7046861,1.050365,1.9794418,2.7785302,5.6604697,19.0195384,1.1584122,6.8451797,2.8596293,8.6512354,3.3093675,5.5151559,2.2331085,16.1185093),(6786,'ulna-cleaned.tif',183,4,310,9.248457,4.4736518,11.7296013,1.8,4.4552093,11.703495,1.0437998,2.1147258,2.7649138,5.8211736,18.8432315,1.1515126,6.8151245,2.7526848,8.5750171,3.439754,5.5276984,2.2590652,16.2547365),(6787,'ulna-cleaned.tif',183,4,311,9.2734443,4.4864309,11.7268581,1.8,4.4722443,11.7037906,1.0385185,2.2123604,2.7837142,6.0356656,18.6467078,1.1475059,6.6984993,2.7281566,8.5560693,3.5501422,5.5541317,2.2186078,16.5836178),(6788,'ulna-cleaned.tif',183,4,312,9.2973368,4.4957655,11.720298,1.8,4.480046,11.6957647,1.034458,2.2906579,2.7684236,6.2304757,18.4999349,1.1449473,6.6824798,2.7199504,8.5624722,3.6306793,5.5473917,2.1927181,16.560245),(6789,'ulna-cleaned.tif',183,4,313,9.3168062,4.5079944,11.7160449,1.8,4.4936774,11.6929423,1.0298885,2.3334322,2.7564968,6.4298781,18.3071593,1.1410962,6.6414587,2.7555452,8.5434876,3.6858733,5.5473917,2.1927181,16.5932992),(6790,'ulna-cleaned.tif',183,4,314,9.3172267,4.5202833,11.7135463,1.8,4.506305,11.6898195,1.0229452,2.3642865,2.7428349,6.6049289,18.0734064,1.1315944,6.5893161,2.7936245,8.4488865,3.7276029,5.5541317,2.2186078,16.9415433),(6791,'ulna-cleaned.tif',183,4,315,9.3148428,4.5318198,11.7104036,1.8,4.5177893,11.6856233,1.0179399,2.4008502,2.7613209,6.7682028,17.8468954,1.1243772,6.4631733,2.8190859,8.4068366,3.7465824,5.5541317,2.2186078,16.8988077),(6792,'ulna-cleaned.tif',183,4,316,9.3237251,4.5440383,11.7094533,1.8,4.5313404,11.6835261,1.0141752,2.4454252,2.7779223,6.9409578,17.6606285,1.1202107,6.3574955,2.8383439,8.3764467,3.8018767,5.5541317,2.2186078,17.3405433),(6793,'ulna-cleaned.tif',183,4,317,9.2956421,4.5566299,11.7102812,1.8,4.5442873,11.6846243,1.0104886,2.4907214,2.8008539,7.0740376,17.3532445,1.1117033,6.1956978,2.8401562,8.3055327,3.8571711,5.5798693,2.1885521,17.0350348),(6794,'ulna-cleaned.tif',183,4,318,9.2555542,4.5730343,11.7157946,1.8,4.5634369,11.6919165,1.0077941,2.5050952,2.8251288,7.222716,16.9800256,1.1031618,6.0103546,2.8832102,8.1989833,3.8796706,5.5895615,2.1785983,17.0196822),(6795,'ulna-cleaned.tif',183,4,319,9.2384384,4.5891396,11.7160683,1.8,4.5827956,11.6913879,1.0094651,2.5552332,2.7987473,7.3916487,16.6856313,1.1034424,5.9618214,2.8927491,8.1922965,3.9457375,5.5473917,2.1927181,17.1325365),(6796,'ulna-cleaned.tif',183,4,320,9.2536855,4.6009275,11.7088636,1.8,4.5959129,11.678812,1.0065018,2.6554209,2.8015603,7.6190039,16.5642582,1.1011388,5.9125117,2.8692264,8.2155212,4.0568034,5.5384881,2.2027706,17.599306),(6797,'ulna-cleaned.tif',183,4,321,9.2947703,4.6212256,11.6987576,1.8,4.6207568,11.6640459,1.0096734,2.844088,2.783616,8.0306189,16.3937514,1.1104615,5.8893725,2.8236183,8.3406827,4.2660499,5.5063447,2.2070512,17.7862891),(6798,'ulna-cleaned.tif',183,4,322,9.4238631,4.6660749,11.6719902,1.8,4.6804184,11.6333147,1.0094012,3.6237383,2.8275175,9.2513569,16.2416376,1.1254993,5.7441334,2.552987,6.9783168,4.5377927,5.5363318,2.124812,19.1953061),(6799,'ulna-cleaned.tif',183,4,323,9.6096216,4.7207112,11.6364909,1.8,4.7445329,11.5993082,1.0003372,3.7842659,2.8443225,10.9828768,16.153351,1.134544,5.679156,2.9022476,7.1387252,4.599855,5.8124045,0.0962534,19.6644247),(6800,'ulna-cleaned.tif',183,4,324,9.8267681,4.7800818,11.6004236,1.8,4.8100515,11.5666256,0.9992354,3.9446003,2.7920478,12.9124377,16.0858832,1.1585398,5.7613209,3.2734464,7.3394725,4.705936,6.0433685,0.1390959,20.2327061),(6801,'ulna-cleaned.tif',183,4,325,10.0012852,4.8442051,11.5707323,1.8,4.8871232,11.5336601,1.1083077,4.1246595,2.7238746,14.7828479,15.7695038,1.3350489,5.7893649,3.5840165,7.3805868,4.7645914,6.2133923,0.1873203,20.8009875),(6802,'ulna-cleaned.tif',183,4,326,10.2296742,4.8607956,11.5372548,1.8,4.9049478,11.4971062,1.1881519,4.0037317,2.796485,15.6252924,16.082818,1.4672612,5.7510833,3.9026822,7.8228524,4.7777192,6.1674871,0.142812,21.4023231),(6803,'ulna-cleaned.tif',183,4,327,10.2822425,4.8716689,11.5246691,1.8,4.9142167,11.4853376,1.3083968,3.9341587,2.8653384,15.8027689,16.0232907,1.5983957,5.5921112,4.0168102,7.7772331,4.792491,6.2069835,0.1418971,21.6570757),(6804,'ulna-cleaned.tif',183,4,328,10.3047695,4.8810986,11.5159356,1.8,4.9208124,11.4764997,-1.4739831,3.2785765,2.8205862,15.8651996,15.9599615,1.7014144,5.6583846,4.8390512,7.8009958,4.6686208,5.8303173,3.1005199,20.0827875),(6805,'ulna-cleaned.tif',183,4,329,10.363738,4.8994258,11.5039849,1.8,4.940311,11.4639388,-0.8021045,3.1182531,3.806745,15.8222046,16.3083188,0.8924961,4.2840586,5.0740604,8.1079979,4.6859798,5.8303173,3.1005199,20.0924688),(6806,'ulna-cleaned.tif',183,4,330,10.3977916,4.9096595,11.4970111,1.8,4.9471825,11.4596478,-0.7807712,3.1055713,3.8727444,15.7805646,16.4090166,0.8584645,4.2370512,5.0813724,8.0374629,4.6877203,5.8320919,3.0936841,19.7345434),(6807,'ulna-cleaned.tif',183,4,331,10.4292939,4.9185259,11.487089,1.8,4.9559253,11.4489137,-0.7235022,3.0562592,3.8816879,15.7662958,16.5041753,0.7617939,4.2518038,5.1586907,8.1536943,4.6859798,5.8303173,3.1005199,20.1916316),(6808,'ulna-cleaned.tif',183,4,332,10.4455653,4.9269745,11.480771,1.8,4.9635446,11.4416296,-0.6848994,3.0435913,3.8728216,15.7383032,16.5780626,0.6966783,4.2806162,5.1709647,8.2284707,4.7084965,5.9516573,3.0946473,20.096479),(6809,'ulna-cleaned.tif',183,4,333,10.5210225,4.9376783,11.4667102,1.8,4.9736226,11.425711,-0.671244,3.0240208,3.8642418,15.8165729,16.8620467,0.6783165,4.3636106,5.2303122,8.3552918,4.6894607,5.9186645,3.0741276,19.7812891),(6810,'ulna-cleaned.tif',183,4,334,10.5646021,4.9459287,11.4628749,1.8,4.9815443,11.4252553,-0.6707525,3.0255779,3.8244354,15.7954924,16.9610014,0.6802833,4.4349034,5.220653,8.4698701,4.7275823,5.9186645,3.0741276,19.6063365),(6811,'ulna-cleaned.tif',183,4,335,10.5970609,4.9562787,11.4550858,1.8,4.9948727,11.416837,-0.6489127,2.999517,3.823126,15.7167379,17.0939999,0.6450134,4.4712101,5.2397562,8.5121885,4.7128664,6.0754221,0.0591415,21.0170146),(6812,'ulna-cleaned.tif',183,4,336,10.6556715,4.9616549,11.4485876,1.8,5.0000984,11.4107275,-0.6437206,3.0150075,3.7855101,15.7713801,17.2015201,0.6397145,4.5440429,5.2309588,8.6495473,4.6843643,6.0355923,0.0595322,20.4487332),(6813,'ulna-cleaned.tif',183,4,337,10.7025083,4.9718151,11.4432967,1.8,5.0099118,11.4054339,-0.6724205,3.0283208,3.7598103,15.6906194,17.3453598,0.6920621,4.6133604,5.1812937,8.692187,4.7081888,6.0095548,0.1465919,20.0497332),(6814,'ulna-cleaned.tif',183,4,338,10.7520838,4.9769216,11.4381421,1.8,5.013903,11.3979408,-0.6712421,3.1069321,3.7532579,15.7720109,17.4042044,0.6932103,4.6370926,5.0763938,8.745199,4.7345439,6.2306634,0.0448417,21.0968146),(6815,'ulna-cleaned.tif',183,4,339,10.7777731,4.9794824,11.4378042,1.8,5.0161493,11.3979164,-0.6829187,3.1225343,3.7753075,15.7335507,17.3178902,0.7153504,4.587147,5.038712,8.6390164,4.712697,6.0379658,0.1325515,20.3318688),(6816,'ulna-cleaned.tif',183,4,340,10.8150861,4.9771537,11.4321202,1.8,5.0080715,11.3896449,-0.6998161,3.1365883,3.7624178,15.8279303,17.223848,0.7477463,4.5778669,5.0462249,8.6409111,4.712697,6.0279381,0.1194289,20.5245231),(6817,'ulna-cleaned.tif',183,4,341,10.8661587,4.9857255,11.4216815,1.8,5.0152513,11.3764288,-0.7121492,3.1482716,3.7101185,15.865007,17.3838571,0.7733315,4.6855261,5.0392751,8.801138,4.7333994,5.9984181,0.1334307,19.8804519),(6818,'ulna-cleaned.tif',183,4,342,10.8698597,4.9933529,11.4169312,1.8,5.0251608,11.3709325,-0.6975448,3.1327252,3.650061,15.8351948,17.3714517,0.7474803,4.7592223,5.0547667,8.9750776,4.7534445,6.1602552,0.0713075,21.5362011),(6819,'ulna-cleaned.tif',183,4,343,11.0172346,5.0059075,11.3961806,1.8,5.0369778,11.3461648,-0.7066112,3.1356862,3.6776561,16.0561093,17.8206529,0.7740318,4.845655,5.1204452,9.0745615,4.7780966,6.2371755,0.064015,22.250391),(6820,'ulna-cleaned.tif',183,4,344,11.0212053,5.0170757,11.3906132,1.8,5.0434384,11.3415623,-0.7043781,3.1360395,3.6669636,15.9524588,17.9105044,0.7702611,4.8842875,5.0868169,9.1012101,4.7528861,6.2371755,0.064015,21.4096554),(6821,'ulna-cleaned.tif',183,4,345,11.005683,5.0275657,11.3860972,1.8,5.0512009,11.337307,-0.7120623,3.1746444,3.6511216,15.8016762,17.9109061,0.7831035,4.9055902,4.9774633,9.0884622,4.7528861,6.2769943,0.0636083,21.4427096),(6822,'ulna-cleaned.tif',183,4,346,11.0137834,5.0350342,11.3821106,1.8,5.0562716,11.3335167,-0.7116464,3.1978983,3.6431343,15.7770535,17.9468534,0.7829246,4.9262125,4.9335695,9.1122916,4.7504502,6.3144194,0.0569005,21.1839469),(6823,'ulna-cleaned.tif',183,4,347,11.02632,5.0396411,11.3742528,1.8,5.0573629,11.3236619,-0.7233397,3.2101473,3.6266131,15.7867074,17.9192031,0.8051065,4.9410298,4.9177517,9.1270731,4.7902758,6.3194599,0.0695081,21.8320283),(6824,'ulna-cleaned.tif',183,4,348,10.9718874,5.0435488,11.3732773,1.8,5.0584241,11.3245949,-0.7477758,3.2737926,3.6049748,15.6315626,17.7268495,0.8455908,4.9173297,4.7747565,9.0424284,4.7902758,6.3168141,0.0632068,21.6821096),(6825,'ulna-cleaned.tif',183,4,349,10.9588698,5.0478502,11.3682517,1.8,5.0585646,11.3196487,-0.7748383,3.3302749,3.575869,15.5418324,17.5999131,0.8939532,4.9218562,4.6668316,8.9989658,4.78784,6.3144194,0.0569005,21.4974757),(6826,'ulna-cleaned.tif',183,4,350,10.9325953,5.0538892,11.3666959,1.8,5.0605158,11.3198858,-0.7974622,3.3568102,3.5218173,15.4021513,17.4411349,0.9330293,4.9523112,4.5883296,9.0165549,4.78784,6.2745844,0.0572622,21.2871198),(6827,'ulna-cleaned.tif',183,4,351,10.9672241,5.0704155,11.3557847,1.8,5.0808984,11.3043149,-0.8088788,3.401271,3.6031656,15.2582352,17.6955571,0.9568391,4.911114,4.4860392,8.7968809,4.7869878,6.3521253,0.0502721,21.8417096),(6828,'ulna-cleaned.tif',183,4,352,10.9789483,5.0788652,11.3490096,1.8,5.0884602,11.2978392,-0.8347794,3.3983218,3.7070106,15.1560166,17.6843109,1.0051246,4.7705046,4.4598533,8.4961518,4.820358,6.2705235,0.0445565,21.7248452),(6829,'ulna-cleaned.tif',183,4,353,10.9262002,5.0806456,11.3487817,1.8,5.0826213,11.2995628,-0.8537845,3.4160293,3.7142679,14.9658401,17.4329321,1.0346626,4.6935042,4.3810631,8.3402933,4.7755126,6.2325794,0.0512372,21.9078181),(6830,'ulna-cleaned.tif',183,4,354,10.9155418,5.0835927,11.3447923,1.8,5.0813865,11.2945207,-0.905227,3.4544513,3.6145117,14.7751081,17.1713186,1.125547,4.7506607,4.2771216,8.2782362,4.7577904,6.2705235,0.0445565,21.452391),(6831,'ulna-cleaned.tif',183,4,355,10.8127788,5.0914783,11.3523495,1.8,5.089019,11.3053428,-0.9375901,3.4850255,3.4501938,14.3802401,16.892943,1.1711189,4.8962301,4.1262941,8.316027,4.7314909,6.268873,0.038198,21.4290181),(6832,'ulna-cleaned.tif',183,4,356,10.697968,5.0938376,11.3551724,1.8,5.091779,11.3070732,-0.9855903,3.4777906,3.2320274,14.1360167,16.5108914,1.2389782,5.1085246,4.0646543,8.5887651,4.727145,6.1908037,0.0451306,21.5749266),(6833,'ulna-cleaned.tif',183,4,357,10.6044275,5.0931576,11.361284,1.8,5.0874469,11.3125962,-1.031896,3.4933553,3.1299183,13.9530047,16.1544961,1.3019294,5.1613156,3.9941556,8.477755,4.7250568,6.189132,0.0386904,21.4894554),(6834,'ulna-cleaned.tif',183,4,358,10.5128092,5.0966986,11.3655323,1.8,5.0862275,11.3155209,-1.048419,3.5012832,3.0691028,13.705829,15.8921729,1.3159533,5.1781169,3.9145159,8.3844423,4.7292332,6.1877171,0.0322469,21.532191),(6835,'ulna-cleaned.tif',183,4,359,10.4125472,5.1018692,11.3689387,1.8,5.0894832,11.3186177,-1.0926562,3.4562021,2.9358272,13.3727359,15.5774326,1.3680032,5.3059773,3.8691996,8.3363323,4.6914761,6.1079591,0.0326681,21.6837707),(6836,'ulna-cleaned.tif',183,4,360,10.301604,5.103787,11.3734826,1.8,5.0888328,11.3218449,-1.1398868,3.4558214,2.917885,13.0785214,15.2583836,1.4173786,5.2292614,3.7844899,7.9543606,4.5328621,5.5792986,0.2016031,18.9672485),(6837,'ulna-cleaned.tif',183,4,361,10.1648099,5.1043911,11.3815152,1.8,5.0928261,11.328004,-1.2036821,3.4041568,2.642849,12.7412112,14.870386,1.4758863,5.62665,3.7428391,8.0524906,4.4939121,5.5102465,0.1746722,18.5956315),(6838,'ulna-cleaned.tif',183,4,362,10.0096581,5.1015656,11.3931755,1.8,5.0929837,11.3364259,-1.2806169,3.3630802,2.6578335,12.3161848,14.4526611,1.5316995,5.4377602,3.662174,7.7999263,4.4939121,5.4931739,0.1973956,19.2493841),(6839,'ulna-cleaned.tif',183,4,363,9.8352065,5.0973719,11.4079796,1.8,5.0913322,11.3510411,-1.3811227,3.2369651,2.7143255,11.807389,14.0131692,1.5809328,5.1626709,3.6476726,7.5938481,4.4668579,5.4388546,0.1844466,18.6714214),(6840,'ulna-cleaned.tif',183,4,364,9.6594265,5.0921787,11.4232636,1.8,5.0864603,11.3659365,-1.4644672,3.0958636,2.7468976,11.3489739,13.6240646,1.5917715,4.9598008,3.6658508,7.4144484,4.4709154,5.4196481,0.1106572,18.8600655),(6841,'ulna-cleaned.tif',183,4,365,9.4733304,5.085728,11.4417799,1.8,5.0771512,11.3891115,-1.5485516,2.9674656,2.7587969,10.8461795,13.2279516,1.5781073,4.7948261,3.6550312,7.140171,4.4126167,5.3845787,0.1188403,18.8834383),(6842,'ulna-cleaned.tif',183,4,366,9.281163,5.077847,11.4584829,1.8,5.0657629,11.4076793,1.5055674,2.9606659,2.7549951,10.4787092,12.8429985,1.5402882,4.6617138,3.5393082,6.9140279,4.3614122,5.1731702,0.1004361,17.8483874),(6843,'ulna-cleaned.tif',183,4,367,9.1032088,5.0771477,11.4718224,1.8,5.0677039,11.4193877,1.4656793,3.0167612,2.71446,10.1566479,12.5306249,1.5004987,4.6162497,3.3667391,6.7830068,4.5425224,5.4699394,0.0364802,19.6016384),(6844,'ulna-cleaned.tif',183,4,368,8.9266345,5.0741284,11.4831364,1.8,5.0665595,11.4278528,1.4088534,3.0515609,2.6966463,9.8139757,12.2366954,1.4490947,4.5377459,3.2160511,6.5864638,4.5303301,5.7468469,3.1207623,20.0256723),(6845,'ulna-cleaned.tif',183,4,369,8.7471518,5.0687953,11.4984178,1.8,5.062756,11.4461283,1.3545147,3.0705184,2.6721478,9.3566988,11.9415104,1.39072,4.4688809,3.0472701,6.3555459,4.3533387,5.1731702,0.1004361,18.1208417),(6846,'ulna-cleaned.tif',183,4,370,8.5991642,5.0631921,11.5081312,1.8,5.0550597,11.4604212,1.3184566,3.1498636,2.6430029,8.9994618,11.728302,1.3438555,4.4374911,2.8570957,6.1849391,4.3125845,4.891291,2.0636327,16.7528992),(6847,'ulna-cleaned.tif',183,4,371,8.4705151,5.0588486,11.5124237,1.8,5.0475042,11.4644641,1.2886163,3.1409722,2.6273133,8.6800125,11.5835359,1.302293,4.4088902,2.7634796,6.111242,4.2744253,4.891291,2.0636327,17.3735976),(6848,'ulna-cleaned.tif',183,4,372,8.3214176,5.0584993,11.5191764,1.8,5.049367,11.4745388,1.2900587,3.0543294,2.5994758,8.2941295,11.3855939,1.2804377,4.3799576,2.7155321,5.9293645,4.2253264,5.2598433,2.1945731,17.9942959),(6849,'ulna-cleaned.tif',183,4,373,8.1784391,5.0573655,11.5259707,1.8,5.0487326,11.4840129,1.2880235,3.0588703,2.5983942,7.9804086,11.2041234,1.2569555,4.3119414,2.6089398,5.8350744,4.2074559,5.2366376,2.1883886,17.7492247),(6850,'ulna-cleaned.tif',183,4,374,8.0578211,5.0578732,11.528903,1.8,5.0483823,11.4879483,1.2899031,2.5969584,2.5961281,7.7019608,11.0738855,1.2397662,4.2655389,2.9657621,5.707313,4.1662087,4.9031566,2.1768557,16.4941365),(6851,'ulna-cleaned.tif',183,4,375,7.9244524,5.0638913,11.537962,1.8,5.0577264,11.5054025,1.3036417,2.5637322,2.5905778,7.3905046,10.8783184,1.2286999,4.1991861,2.8827132,6.0451338,4.1249552,4.856176,2.0675201,16.8947975),(6852,'ulna-cleaned.tif',183,4,376,7.8026925,5.0670654,11.539517,1.8,5.0599524,11.5067666,1.3065241,2.5104325,2.5787752,7.153036,10.7151835,1.2117205,4.1551445,2.8493242,5.6971125,4.071324,4.8404145,2.0786955,16.3692518),(6853,'ulna-cleaned.tif',183,4,377,7.6842181,5.0735586,11.5426213,1.8,5.067538,11.5128227,1.3168401,2.4888953,2.5777867,6.9551171,10.5646281,1.1998661,4.0983329,2.7944594,6.7360979,4.0633183,4.8186582,2.0529603,16.2176721),(6854,'ulna-cleaned.tif',183,4,378,7.5695323,5.0764227,11.5440537,1.8,5.0675798,11.5151645,1.3188771,2.4654389,2.5476897,6.7530797,10.4043745,1.1832036,4.0838468,2.7390984,6.6307474,4.0055502,4.8021106,2.0641749,16.0056551),(6855,'ulna-cleaned.tif',183,4,379,7.4612825,5.0817755,11.5450203,1.8,5.071886,11.5152415,1.3266503,2.4371589,2.5478059,6.577982,10.2348831,1.1708838,4.0171361,2.699037,6.5009739,3.9860912,4.7670066,2.068139,15.6670924),(6856,'ulna-cleaned.tif',183,4,380,7.3520535,5.0865148,11.5502158,1.8,5.0762757,11.5221714,1.334759,2.4101619,2.5451628,6.3919192,10.1089192,1.1583325,3.9718163,2.6520704,6.3939648,3.9365026,4.7467588,2.0231662,15.709828),(6857,'ulna-cleaned.tif',183,4,381,7.2493956,5.0883693,11.553618,1.8,5.0740395,11.5270252,1.3348368,2.3595058,2.5306432,6.2047767,10.0116605,1.1422012,3.9561724,2.6296934,6.3629304,3.8912641,4.7670066,2.068139,15.418011),(6858,'ulna-cleaned.tif',183,4,382,7.1711208,5.0912715,11.5553634,1.8,5.075993,11.5286393,1.3368429,2.3372048,2.5381227,6.0785796,9.9231053,1.1309541,3.9096239,2.6007903,6.2716238,3.8501062,4.7708456,2.0868304,15.5736008),(6859,'ulna-cleaned.tif',183,4,383,7.0883578,5.0955457,11.5579448,1.8,5.0805894,11.5319344,1.344991,2.3285168,2.5366871,5.9557592,9.823723,1.1221729,3.8726586,2.5577481,6.1921005,3.8431509,4.7465911,2.0419626,15.4236822),(6860,'ulna-cleaned.tif',183,4,384,7.0050739,5.0969148,11.5579805,1.8,5.0790993,11.5311651,1.3448076,2.3273076,2.5063557,5.8091078,9.6998073,1.1088946,3.870084,2.4960636,6.1687646,3.8153167,4.7319786,2.0721619,15.178611),(6861,'ulna-cleaned.tif',183,4,385,6.9406942,5.1015747,11.5599937,1.8,5.0851205,11.5340459,1.3510655,2.3191552,2.5261074,5.694785,9.6060444,1.1018241,3.8027063,2.4555429,6.0222096,3.8017055,4.7294547,2.0533096,14.9198482),(6862,'ulna-cleaned.tif',183,4,386,6.8683892,5.1036107,11.5640136,1.8,5.0856807,11.5371722,1.3555692,2.315045,2.4924878,5.5630334,9.5163495,1.0925182,3.8180125,2.4029915,6.0276576,3.7938045,4.7109044,2.0268683,14.9569126),(6863,'ulna-cleaned.tif',183,4,387,6.8040574,5.1043616,11.566241,1.8,5.0859495,11.5375411,1.3573399,2.3135909,2.4820753,5.4510163,9.4336061,1.08312,3.8006929,2.3560848,5.9668188,3.7927387,4.6941465,2.0572537,15.0948008),(6864,'ulna-cleaned.tif',183,4,388,6.7508121,5.1061147,11.5685828,1.8,5.0863376,11.5393214,1.3633591,2.3082372,2.4808784,5.3349157,9.352152,1.077411,3.7696938,2.3112511,5.8935895,3.7840532,4.6756264,2.0497099,15.5558992),(6865,'ulna-cleaned.tif',183,4,389,6.7002715,5.10827,11.5687171,1.8,5.0897671,11.5389722,1.3635862,2.2669514,2.4639397,5.2285942,9.2716836,1.069447,3.7629507,2.306443,5.8374205,3.7384626,4.6589125,2.0612574,15.098811),(6866,'ulna-cleaned.tif',183,4,390,6.675542,5.107671,11.5717548,1.8,5.0899166,11.5444116,1.3628121,2.2687086,2.4526076,5.1167801,9.2215242,1.0651525,3.7598857,2.2553712,5.7858672,3.7310178,4.6621576,2.0803886,15.0036584),(6867,'ulna-cleaned.tif',183,4,391,6.623093,5.1031332,11.5760839,1.8,5.0835693,11.553433,1.3545628,2.2322731,2.4463413,4.9708604,9.1434492,1.0530357,3.7376017,2.2268155,5.7047435,3.6736434,4.6589125,2.0612574,14.594977),(6868,'ulna-cleaned.tif',183,4,392,6.5828495,5.0979295,11.5780543,1.8,5.0746166,11.5551437,1.3499468,2.0763347,2.4485968,4.8364018,9.0955075,1.0444934,3.7145795,2.3292977,5.6757345,3.5127048,4.6589125,2.0612574,14.4216855),(6869,'ulna-cleaned.tif',183,4,393,6.5394314,5.0955761,11.5795942,1.8,5.0718782,11.5588731,1.3444901,2.0435807,2.4376955,4.7193314,9.0031851,1.0350327,3.6933183,2.3093443,5.6061409,3.476843,4.6402518,2.0536723,14.2056584),(6870,'ulna-cleaned.tif',183,4,394,6.4991341,5.0955846,11.5803391,1.8,5.0725159,11.5599485,1.3402759,2.0075929,2.436012,4.6067753,8.9485458,1.0266411,3.6734408,2.294676,5.5395084,3.4217303,4.6218602,2.0460264,14.4410482),(6871,'ulna-cleaned.tif',183,4,395,6.4715302,5.0953126,11.5790152,1.8,5.0725453,11.558133,1.3405072,2.0074063,2.428309,4.5088495,8.8851094,1.0223916,3.6589698,2.2461071,5.481916,3.4008783,4.6232378,2.0074235,14.1258584),(6872,'ulna-cleaned.tif',183,4,396,6.4403827,5.0929832,11.5759051,1.8,5.0698297,11.5539809,1.3374053,1.9628952,2.4310237,4.4053942,8.8527742,1.0159817,3.6415829,2.2443348,5.4188733,3.3460294,4.6216879,2.0267221,14.2056584),(6873,'ulna-cleaned.tif',183,4,397,6.3955425,5.092268,11.5742802,1.8,5.0694826,11.5551793,1.3328989,1.9659127,2.4021285,4.2935933,8.7809862,1.0067271,3.6555023,2.1840204,5.4162443,3.3321687,4.6218602,2.0460264,13.9468956),(6874,'ulna-cleaned.tif',183,4,398,6.3797817,5.0948195,11.5700432,1.8,5.0750679,11.5497839,1.3324272,1.9239411,2.4055304,4.216649,8.7521077,1.0040162,3.6383277,2.1916725,5.3638627,3.2961555,4.5858972,2.0305529,13.9799499),(6875,'ulna-cleaned.tif',183,4,399,6.3431482,5.0951021,11.565711,1.8,5.0773493,11.5447628,1.3258258,1.9265292,2.3983294,4.1216992,8.7014298,0.9950077,3.6281213,2.1394429,5.3055663,3.2858395,4.5871121,2.0111019,14.168594),(6876,'ulna-cleaned.tif',183,4,400,6.3073748,5.0952613,11.5606447,1.8,5.0779438,11.5375191,1.3208304,2.5292866,2.4016743,4.0497578,8.6541679,0.9869019,3.6033894,1.6011463,4.7745486,3.2496779,4.5858972,2.0305529,13.9195126),(6877,'ulna-cleaned.tif',183,4,401,6.2964329,5.0969494,11.5530266,1.8,5.0835143,11.5273872,1.3171606,2.5874026,2.3988741,4.0076635,8.6269535,0.9833314,3.596251,1.5489138,4.6246673,3.2361556,4.5858972,2.0305529,13.6180143),(6878,'ulna-cleaned.tif',183,4,402,6.2963977,5.0961294,11.5505624,1.8,5.0830353,11.5293328,1.3117707,3.0267318,2.3901385,3.9126024,8.6130623,0.9805516,3.603583,1.2926822,4.0052844,3.1709387,4.5697261,2.0617809,13.7211872),(6879,'ulna-cleaned.tif',183,4,403,6.2832131,5.0937254,11.5476351,1.8,5.0786676,11.5282061,1.305185,2.2846211,2.3918933,3.8103732,8.6018942,0.9750438,3.59627,1.667836,5.1578489,3.160492,4.5858972,2.0305529,13.7115058),(6880,'ulna-cleaned.tif',183,4,404,6.2718267,5.0952217,11.5395759,1.8,5.0817818,11.5175506,1.3038445,2.5584831,2.3883903,3.7672062,8.5763047,0.9725654,3.5908305,1.4724374,4.5840199,3.0930422,4.5697261,2.0617809,13.929194),(6881,'ulna-cleaned.tif',183,4,405,6.2571663,5.0947912,11.5348778,1.8,5.0810531,11.5126743,1.3013089,2.559768,2.3922401,3.6984684,8.5526672,0.9689406,3.5751709,1.4448452,4.5534823,3.0473802,4.5536723,1.9952483,13.8630855),(6882,'ulna-cleaned.tif',183,4,406,6.2795721,5.0975805,11.5286764,1.8,5.0873323,11.5065303,1.3033111,2.679764,2.3981131,3.6953522,8.5696194,0.9734821,3.5734842,1.3789842,4.3695787,3.0568805,4.5702486,2.0032041,13.5946414),(6883,'ulna-cleaned.tif',183,4,407,6.2749366,5.0995598,11.5248744,1.8,5.0921793,11.5042165,1.3056017,2.6364322,2.3915239,3.6475793,8.550128,0.9739801,3.5751799,1.3835286,4.4040599,3.0319288,4.5536723,1.9952483,13.6140041),(6884,'ulna-cleaned.tif',183,4,408,6.2758829,5.1005532,11.5191495,1.8,5.0943395,11.4989075,1.3058747,2.6337428,2.396885,3.6216732,8.518819,0.9742713,3.5541208,1.3751051,4.3896634,2.9886517,4.5536723,1.9952483,13.5342041),(6885,'ulna-cleaned.tif',183,4,409,6.2462052,5.0996895,11.518469,1.8,5.0913933,11.5008523,1.3002842,2.6006219,2.3679684,3.5080373,8.4915908,0.9666948,3.5860237,1.3489225,4.3912047,2.9772114,4.5340519,2.0068919,13.5382143),(6886,'ulna-cleaned.tif',183,4,410,6.2358235,5.100269,11.5151211,1.8,5.0905243,11.4987659,1.3012589,2.5983526,2.3647646,3.4536036,8.4695528,0.965609,3.5815628,1.3291513,4.3669356,2.96388,4.5536723,1.9952483,13.4350414),(6887,'ulna-cleaned.tif',183,4,411,6.2466013,5.1040719,11.5105323,1.8,5.097414,11.4927852,1.3002402,2.6327631,2.3850951,3.4525686,8.479661,0.9667325,3.5552717,1.311386,4.3263038,2.9275726,4.5739047,1.9837063,13.5712685),(6888,'ulna-cleaned.tif',183,4,412,6.2311091,5.106692,11.5082724,1.8,5.1007733,11.4892242,1.2982574,2.6312558,2.3583082,3.408203,8.4148529,0.9632708,3.5681735,1.2952762,4.2920532,2.9053449,4.5510495,2.0148386,13.6003126),(6889,'ulna-cleaned.tif',183,4,413,6.2336493,5.1088927,11.5065285,1.8,5.1055349,11.4860943,1.2991458,2.5895059,2.3489078,3.3957108,8.3974785,0.9641413,3.5750567,1.3113354,4.338283,2.8851232,4.5340519,2.0068919,13.5148414),(6890,'ulna-cleaned.tif',183,4,414,6.2011997,5.1109288,11.5043714,1.8,5.1096939,11.4845997,1.2977363,2.5773666,2.3500343,3.316611,8.3160476,0.9583675,3.5386921,1.2868216,4.3182509,2.8649016,4.5173427,1.9988858,13.1238617),(6891,'ulna-cleaned.tif',183,4,415,6.1856051,5.1125372,11.5026515,1.8,5.112104,11.4826277,1.2961877,2.510572,2.350803,3.2527071,8.2736671,0.9551262,3.5195068,1.295604,4.3547443,2.8649016,4.5173427,1.9988858,13.1101702),(6892,'ulna-cleaned.tif',183,4,416,6.1540778,5.1139871,11.5019982,1.8,5.1143808,11.4822828,1.2929726,2.4897947,2.3391307,3.1803944,8.2182838,0.9485276,3.5133922,1.2773721,4.3633206,2.8476708,4.5173427,1.9988858,13.397977),(6893,'ulna-cleaned.tif',183,4,417,6.0895055,5.1122494,11.5043512,1.8,5.1085462,11.488309,1.2878375,2.4576426,2.3355681,3.0326209,8.1359713,0.9358032,3.4835085,1.2339552,4.3448399,2.7948171,4.5173427,1.9988858,13.1198515),(6894,'ulna-cleaned.tif',183,4,418,6.0442643,5.1132549,11.501855,1.8,5.1091444,11.4856166,1.2843274,2.4586022,2.3251544,2.9566352,8.0583402,0.9269443,3.4657226,1.2025675,4.2887655,2.7761225,4.5009253,1.9908208,13.1295329),(6895,'ulna-cleaned.tif',183,4,419,6.0251482,5.11486,11.5000361,1.8,5.1111431,11.4830265,1.2801516,2.4213965,2.3247462,2.881165,8.0211566,0.9217248,3.4503365,1.1898774,4.3046182,2.771779,4.5009253,1.9908208,13.0594143),(6896,'ulna-cleaned.tif',183,4,420,5.9998238,5.1149159,11.5008377,1.8,5.1101032,11.4868988,1.2776781,2.2439418,2.3193246,2.8215512,7.9681507,0.9164874,3.4355479,1.2574083,4.5076512,2.7353285,4.5173427,1.9988858,13.1762787),(6897,'ulna-cleaned.tif',183,4,421,5.9558528,5.1164258,11.4991371,1.8,5.1109283,11.4829847,1.2766884,2.2694475,2.3086587,2.7781531,7.8713203,0.9092265,3.4094777,1.2241539,4.437716,2.7331628,4.5009253,1.9908208,13.02636),(6898,'ulna-cleaned.tif',183,4,422,5.9347427,5.1182049,11.4972144,1.8,5.1138322,11.4809979,1.2777997,2.2893688,2.310355,2.7182184,7.8181199,0.9066126,3.3839475,1.1873222,4.3097962,2.7061883,4.5173427,1.9988858,12.8006515),(6899,'ulna-cleaned.tif',183,4,423,5.9247162,5.1196395,11.49744,1.8,5.1156635,11.4827761,1.2766284,2.3735252,2.309331,2.6856627,7.8035192,0.9044402,3.3791255,1.131508,4.0745304,2.7013426,4.5056978,1.971037,13.0747668),(6900,'ulna-cleaned.tif',183,4,424,5.9097201,5.1183972,11.4955275,1.8,5.1122587,11.479495,1.2711745,2.353203,2.2833049,2.6106019,7.7419225,0.8991454,3.3906651,1.1093824,4.0292305,2.6610698,4.4810739,2.0025822,12.8570787),(6901,'ulna-cleaned.tif',183,4,425,5.8706279,5.1166953,11.4955961,1.8,5.1069228,11.4805517,1.2673572,2.3587682,2.2968207,2.5387877,7.674654,0.8910793,3.3414249,1.0763193,3.9730383,2.6282364,4.4848027,1.9826973,12.6587532),(6902,'ulna-cleaned.tif',183,4,426,5.8651271,5.1185803,11.4947434,1.8,5.1095169,11.4787452,1.2696182,2.22825,2.2716944,2.5121958,7.618862,0.8915007,3.3538235,1.1274299,4.1308877,2.6404952,4.453455,1.9662766,12.6313702),(6903,'ulna-cleaned.tif',183,4,427,5.8677716,5.1211978,11.4908988,1.8,5.1139012,11.473736,1.272352,2.104489,2.2637927,2.5212469,7.585291,0.8934114,3.3507004,1.1980328,4.4037471,2.6207771,4.453455,1.9662766,12.5983159),(6904,'ulna-cleaned.tif',183,4,428,5.8562384,5.1241585,11.4902887,1.8,5.1187204,11.4729541,1.2729646,2.1010833,2.2637377,2.4905169,7.5361728,0.8919912,3.3290839,1.185349,4.3685494,2.5888798,4.453455,1.9662766,12.7305329),(6905,'ulna-cleaned.tif',183,4,429,5.8395376,5.1274275,11.4897317,1.8,5.1237225,11.4750555,1.275971,2.1074298,2.2610522,2.4677596,7.4696578,0.8910818,3.3036202,1.1709807,4.3385979,2.5765137,4.4482686,1.9862884,12.6410515),(6906,'ulna-cleaned.tif',183,4,430,5.8222668,5.1285671,11.4868266,1.8,5.1238425,11.4683804,1.2736998,2.1335294,2.2543548,2.4245879,7.4242908,0.8872167,3.2933106,1.1364212,4.294771,2.5705399,4.4323137,1.9780522,12.6120074),(6907,'ulna-cleaned.tif',183,4,431,5.8026209,5.1310562,11.4871551,1.8,5.1274396,11.4725377,1.274168,2.0927896,2.2535097,2.391127,7.3583218,0.8844763,3.2652719,1.1425549,4.252535,2.5547861,4.4323137,1.9780522,12.6176786),(6908,'ulna-cleaned.tif',183,4,432,5.7722772,5.131077,11.4854348,1.8,5.1250509,11.4705405,1.2723348,2.0523767,2.2514329,2.3329228,7.2651249,0.8788624,3.2268894,1.1366933,4.2256901,2.5109159,4.4166616,1.969757,12.8764414),(6909,'ulna-cleaned.tif',183,4,433,5.753294,5.1320016,11.4841718,1.8,5.1259165,11.4711694,1.2683429,1.9923644,2.2392622,2.2726757,7.1983232,0.8738079,3.214596,1.1406928,4.1792036,2.5109159,4.4013156,1.9614034,12.8240244),(6910,'ulna-cleaned.tif',183,4,434,5.7281328,5.1344706,11.4815186,1.8,5.1298111,11.4671443,1.266584,1.9665537,2.2404375,2.2347117,7.1401617,0.8690291,3.1869498,1.1363593,4.1326625,2.4849969,4.4166616,1.969757,12.4814515),(6911,'ulna-cleaned.tif',183,4,435,5.7151161,5.1354407,11.4805387,1.8,5.1291084,11.4668238,1.2653401,1.9280593,2.2145822,2.1867921,7.0873124,0.8663759,3.2002932,1.1341934,4.1364772,2.4749226,4.3862788,1.9529919,12.4620888),(6912,'ulna-cleaned.tif',183,4,436,5.6905829,5.1382207,11.4796904,1.8,5.1322992,11.4680398,1.2652844,1.8751347,2.2025366,2.1508082,7.010655,0.8626265,3.1829913,1.1470153,4.1077773,2.4602992,4.3715545,1.9445231,12.5322074),(6913,'ulna-cleaned.tif',183,4,437,5.6868481,5.1389157,11.474169,1.8,5.1321159,11.4597149,1.2640481,1.8615092,2.2071553,2.1354581,6.971743,0.8613869,3.1587007,1.1471649,4.0736579,2.4602992,4.3862788,1.9529919,12.335543),(6914,'ulna-cleaned.tif',183,4,438,5.6759475,5.1422458,11.4729086,1.8,5.1373972,11.4601407,1.264486,1.8316955,2.2075084,2.1164565,6.9297212,0.8599741,3.1391596,1.1554631,4.0269527,2.4216047,4.3862788,1.9529919,12.2323702),(6915,'ulna-cleaned.tif',183,4,439,5.6722516,5.1442771,11.4688483,1.8,5.1400716,11.4554824,1.2645441,1.8284989,2.1987588,2.1002923,6.8987575,0.8594457,3.137569,1.1486429,4.0008456,2.4039954,4.3862788,1.9529919,12.1138447),(6916,'ulna-cleaned.tif',183,4,440,5.6635848,5.1458134,11.4634582,1.8,5.1420573,11.4490053,1.2621636,1.8026096,2.2024707,2.0670348,6.8496639,0.8568364,3.1099909,1.1466902,3.9594247,2.4118723,4.3862788,1.9529919,12.4250244),(6917,'ulna-cleaned.tif',183,4,441,5.6584799,5.1448771,11.4591238,1.8,5.1389882,11.4441366,1.2583072,1.7784853,2.2041259,2.0431885,6.8049633,0.8539475,3.087375,1.1488363,3.9359456,2.4006753,4.391901,2.0019351,12.2363803),(6918,'ulna-cleaned.tif',183,4,442,5.6247492,5.1468857,11.4579355,1.8,5.1401818,11.4449325,1.2581915,1.7640033,2.1789097,1.9948426,6.7262405,0.8487936,3.0869753,1.130861,3.8965193,2.4018056,4.359155,1.9853032,12.3589159),(6919,'ulna-cleaned.tif',183,4,443,5.611299,5.1498559,11.4550022,1.8,5.1428054,11.4405272,1.2599872,1.7213407,2.1704044,1.9597648,6.6836644,0.8477443,3.0794557,1.1385107,3.8548679,2.393007,4.3644473,1.9648842,12.3549058),(6920,'ulna-cleaned.tif',183,4,444,5.5901306,5.1527839,11.4539683,1.8,5.1463053,11.4418665,1.2605821,1.629744,2.1692812,1.9244238,6.6254843,0.8448688,3.0542303,1.1808136,3.8304951,2.3758789,4.3644473,1.9648842,12.2517329),(6921,'ulna-cleaned.tif',183,4,445,5.5877979,5.155785,11.4500923,1.8,5.1499837,11.4372376,1.2610798,1.6254414,2.1600373,1.913256,6.5905144,0.8447855,3.0511113,1.1770686,3.7832158,2.3747486,4.3432393,1.9768944,12.2460617),(6922,'ulna-cleaned.tif',183,4,446,5.5777929,5.1576434,11.4466366,1.8,5.1515311,11.43454,1.2597618,1.6477286,2.1623304,1.8839927,6.5413757,0.8425602,3.0251509,1.1433877,3.7798001,2.3522483,4.3432393,1.9768944,12.1001532),(6923,'ulna-cleaned.tif',183,4,447,5.5676848,5.1585911,11.4405095,1.8,5.1521546,11.4260278,1.2578164,1.6081371,2.1672239,1.8546558,6.4997221,0.8399786,2.9991004,1.1532946,3.767964,2.3373614,4.3492831,1.9564134,12.1428888),(6924,'ulna-cleaned.tif',183,4,448,5.5648615,5.1596881,11.4348068,1.8,5.1540219,11.419921,1.2563576,1.6062045,2.1594749,1.8411045,6.4610592,0.8387583,2.9919584,1.1462454,3.7383972,2.3287093,4.3344332,1.9478839,11.9832888),(6925,'ulna-cleaned.tif',183,4,449,5.5671861,5.1605496,11.4305668,1.8,5.1545034,11.4145252,1.2553343,1.6046762,2.1628486,1.8289168,6.4209514,0.8385494,2.9687476,1.139742,3.690295,2.3072478,4.3492831,1.9564134,12.1428888),(6926,'ulna-cleaned.tif',183,4,450,5.5485718,5.1634065,11.4295672,1.8,5.1587596,11.4174518,1.257517,1.5624056,2.138091,1.7982409,6.3564248,0.8369328,2.972944,1.1509438,3.6355806,2.3095085,4.3276329,1.9684243,12.3024888),(6927,'ulna-cleaned.tif',183,4,451,5.5368068,5.1669528,11.4273547,1.8,5.1639007,11.4157089,1.257988,1.7322217,2.1269826,1.777909,6.3099638,0.8354129,2.9666269,1.0263749,3.6445253,2.2924059,4.2973616,1.9513027,12.096143),(6928,'ulna-cleaned.tif',183,4,452,5.5260644,5.1694573,11.4252024,1.8,5.1678426,11.4154743,1.2605808,1.6265353,2.1292283,1.7513407,6.2460903,0.8351854,2.9334995,1.0767308,3.6041075,2.2840849,4.2973616,1.9513027,11.615682),(6929,'ulna-cleaned.tif',183,4,453,5.522237,5.1707041,11.4212417,1.8,5.1683695,11.4108045,1.2609704,1.5386586,2.1327646,1.7322558,6.2156033,0.8348153,2.914341,1.1258221,3.5856509,2.3215787,4.2973616,1.9513027,11.7051633),(6930,'ulna-cleaned.tif',183,4,454,5.5154392,5.1729295,11.4170167,1.8,5.1705544,11.4050947,1.2621628,1.5467,2.1349016,1.715038,6.1889448,0.8344231,2.8989368,1.1088369,3.5558591,2.3137409,4.3226638,1.9890207,11.6721091),(6931,'ulna-cleaned.tif',183,4,455,5.5060117,5.1760142,11.4151919,1.8,5.174628,11.4056195,1.263751,1.530191,2.1240389,1.6899892,6.1417599,0.8338386,2.8915477,1.1044302,3.5745584,2.2843799,4.2754485,1.9634338,11.5786176),(6932,'ulna-cleaned.tif',183,4,456,5.4973395,5.1762737,11.4115178,1.8,5.1727417,11.4015348,1.2615526,1.5179216,2.1268275,1.6645906,6.1183445,0.831361,2.8767469,1.0966249,3.5423905,2.2801366,4.2908736,1.9720251,11.7712718),(6933,'ulna-cleaned.tif',183,4,457,5.4881044,5.177467,11.4060008,1.8,5.1735966,11.394935,1.2605824,1.4776098,2.1173204,1.6466177,6.0698469,0.8294492,2.8667588,1.1143792,3.4938701,2.2624775,4.2908736,1.9720251,11.7946447),(6934,'ulna-cleaned.tif',183,4,458,5.4868618,5.1784749,11.4005635,1.8,5.1740535,11.3886661,1.2593556,1.4647029,2.099673,1.6338027,6.0429409,0.828608,2.878039,1.1154499,3.4692937,2.3509201,4.2700458,1.9842769,11.9445633),(6935,'ulna-cleaned.tif',183,4,459,5.4733587,5.1806172,11.3975194,1.8,5.177422,11.3860552,1.2602388,1.4464009,2.1004532,1.6166076,6.0034026,0.8270382,2.8581463,1.1176761,3.4961105,2.3981807,4.2603412,1.954781,12.0300345),(6936,'ulna-cleaned.tif',183,4,460,5.4638438,5.1807376,11.3924146,1.8,5.1762735,11.3805304,1.2577227,1.4718128,2.0922472,1.6032344,5.9652722,0.8242624,2.8511316,1.0892924,3.4652835,2.1958999,4.2386122,1.9670357,11.6914718),(6937,'ulna-cleaned.tif',183,4,461,5.4598357,5.1794046,11.3854662,1.8,5.1717986,11.3705764,1.2523037,1.4486574,2.1034039,1.5948306,5.947967,0.8207464,2.8277817,1.1009025,3.438663,2.2087037,4.2603412,1.954781,11.7342074),(6938,'ulna-cleaned.tif',183,4,462,5.4709823,5.1776562,11.377959,1.8,5.1684606,11.361723,1.2483696,1.4495754,2.1037075,1.6013037,5.9368887,0.8202771,2.8221075,1.1046709,3.4356805,2.4355398,4.254171,1.9756881,12.2597532),(6939,'ulna-cleaned.tif',183,4,463,5.4550751,5.1794141,11.3716519,1.8,5.1699063,11.3538598,1.2478544,1.4461156,2.083772,1.5887934,5.8935033,0.8176104,2.8282861,1.0986628,3.4668784,2.4231547,4.2233732,1.9583201,12.4814515),(6940,'ulna-cleaned.tif',183,4,464,5.4321064,5.1840789,11.3686507,1.8,5.177009,11.3519706,1.2483051,1.4153623,2.078677,1.5778062,5.8461357,0.8144132,2.812431,1.1147719,3.426268,2.3964328,4.2084572,1.9495421,12.3726074),(6941,'ulna-cleaned.tif',183,4,465,5.398354,5.1863825,11.3655553,1.8,5.1789658,11.3477451,1.2467951,1.4128703,2.0743,1.542473,5.8018137,0.8085345,2.7969984,1.0917301,3.3913002,2.3804916,4.201832,1.9707006,12.5281973),(6942,'ulna-cleaned.tif',183,4,466,5.3775659,5.1906181,11.3655563,1.8,5.1859846,11.352817,1.2485585,1.4332761,2.0736494,1.519387,5.7494478,0.8063727,2.7726229,1.0600798,3.3890449,2.1539836,4.201832,1.9707006,11.6640888),(6943,'ulna-cleaned.tif',183,4,467,5.3668473,5.1909948,11.3609112,1.8,5.1857632,11.3476041,1.2462662,1.4072532,2.0646687,1.4994348,5.7204335,0.8035298,2.7706303,1.0655046,3.3475442,2.1469477,4.186459,1.9619218,11.7205159),(6944,'ulna-cleaned.tif',183,4,468,5.3490658,5.1925055,11.3547828,1.8,5.1876602,11.3398949,1.2451647,1.4043469,2.0699957,1.4799654,5.6684216,0.8002731,2.7383736,1.0538461,3.3293046,2.1476189,4.201832,1.9707006,11.6367057),(6945,'ulna-cleaned.tif',183,4,469,5.3196713,5.195093,11.3530012,1.8,5.1898675,11.3386193,1.24422,1.3895434,2.0702731,1.4511067,5.6228193,0.795367,2.7159796,1.0443047,3.3099386,2.1735855,4.1809414,1.9832068,11.564926),(6946,'ulna-cleaned.tif',183,4,470,5.2805603,5.1970662,11.3521568,1.8,5.1921821,11.3398041,1.2443086,1.3623618,2.057669,1.413995,5.5575548,0.7895668,2.7008984,1.0378997,3.2802267,2.1957567,4.1714111,1.9530789,11.1699362),(6947,'ulna-cleaned.tif',183,4,471,5.2669393,5.197834,11.3503027,1.8,5.1928217,11.3395937,1.2440724,1.3611745,2.0591009,1.3921254,5.5451006,0.7874041,2.6929717,1.0227383,3.246877,2.1957567,4.1714111,1.9530789,11.3158447),(6948,'ulna-cleaned.tif',183,4,472,5.2481867,5.198297,11.3454953,1.8,5.1929317,11.335292,1.2431993,1.2547645,2.0641824,1.3744232,5.4885339,0.7841358,2.6589384,1.0953635,3.2029724,2.182953,4.1651091,1.9744303,11.4617532),(6949,'ulna-cleaned.tif',183,4,473,5.2458402,5.2019285,11.3398257,1.8,5.1977286,11.3271357,1.2436593,1.2644174,2.0590363,1.3746533,5.4706103,0.7840301,2.656879,1.0871832,3.2462837,2.1759308,4.1423043,1.9352039,11.3859633),(6950,'ulna-cleaned.tif',183,4,474,5.2458713,5.2051969,11.3363113,1.8,5.2039686,11.3250757,1.2443329,1.2849918,2.0442478,1.3708977,5.4471381,0.7843929,2.6646172,1.0668533,3.2212127,2.2081306,4.134418,1.956679,11.2497362),(6951,'ulna-cleaned.tif',183,4,475,5.231767,5.2051244,11.3307819,1.8,5.2032257,11.317974,1.2437716,1.2955725,2.0642643,1.3557909,5.4103145,0.7819864,2.6209408,1.0464802,3.1839509,2.224054,4.1423043,1.9352039,12.0534074),(6952,'ulna-cleaned.tif',183,4,476,5.2194445,5.204578,11.3299324,1.8,5.2002813,11.3178561,1.2461759,1.2954561,2.06208,1.3378458,5.3813466,0.781413,2.6096692,1.0327219,3.1655046,2.224054,4.1423043,1.9352039,11.6019904),(6953,'ulna-cleaned.tif',183,4,477,5.2096007,5.2060822,11.3264498,1.8,5.2011651,11.3133218,1.2500662,1.2420154,2.0446965,1.3245645,5.3436547,0.781971,2.613422,1.0664638,3.1762771,2.1686129,4.1050489,1.938668,11.2166819),(6954,'ulna-cleaned.tif',183,4,478,5.189529,5.2062138,11.3261948,1.8,5.2001901,11.3147116,1.2500701,1.216265,2.0444941,1.3017816,5.3177064,0.7789602,2.6009888,1.0703109,3.1390336,2.1212265,4.134418,1.956679,11.2263633),(6955,'ulna-cleaned.tif',183,4,479,5.158845,5.2054794,11.3194454,1.8,5.1990286,11.3067415,1.2491778,1.2151,2.0382828,1.2721742,5.2742937,0.7738948,2.5876162,1.0469708,3.093591,2.0761066,4.112798,1.9693188,11.1699362),(6956,'ulna-cleaned.tif',183,4,480,5.1428419,5.2075955,11.3110692,1.8,5.2002083,11.2977478,1.2474468,1.2365025,2.0445117,1.2615772,5.2222906,0.7706022,2.5542973,1.0202787,3.0753442,2.0521462,4.134418,1.956679,11.3722718),(6957,'ulna-cleaned.tif',183,4,481,5.1192398,5.2118742,11.3038541,1.8,5.204636,11.2897266,1.2476744,1.2300427,2.0135727,1.2484732,5.1528603,0.7671826,2.5590634,1.0149836,3.0719723,2.1343933,4.0824935,1.9513027,11.7342074),(6958,'ulna-cleaned.tif',183,4,482,5.0962329,5.2139638,11.299702,1.8,5.2065963,11.2861544,1.2480039,1.1888764,2.0228077,1.2315233,5.1027919,0.7639033,2.5226283,1.0358716,3.0441868,2.0879295,4.0824935,1.9513027,11.5512345),(6959,'ulna-cleaned.tif',183,4,483,5.0799471,5.2146553,11.2954298,1.8,5.2070083,11.281411,1.2473125,1.1870728,2.0060308,1.2139039,5.0779933,0.7611095,2.5313636,1.0226028,3.0458857,2.0826721,4.0605971,1.9640757,11.4383803),(6960,'ulna-cleaned.tif',183,4,484,5.0639663,5.2150495,11.2915698,1.8,5.2072709,11.2765964,1.2463414,1.1484667,2.0035342,1.1976869,5.0465109,0.7582205,2.5188045,1.0428573,3.040761,2.044834,4.0454745,1.9549657,11.4013159),(6961,'ulna-cleaned.tif',183,4,485,5.035453,5.2152845,11.2900125,1.8,5.2066148,11.2753332,1.2420695,1.1503962,2.0040413,1.1709139,5.0289503,0.7517725,2.5094045,1.0178354,3.0073855,2.0167754,4.0454745,1.9549657,10.7983192),(6962,'ulna-cleaned.tif',183,4,486,5.0140705,5.21584,11.2866243,1.8,5.2063825,11.2746003,1.2404772,1.1184654,2.0146596,1.1524073,4.9952073,0.7477653,2.4794299,1.0303468,2.96883,2.0167754,4.0454745,1.9549657,10.9362074),(6963,'ulna-cleaned.tif',183,4,487,4.9915739,5.2166714,11.2838474,1.8,5.2072832,11.2737251,1.240484,1.1156986,1.986417,1.1359951,4.9670848,0.7444138,2.5005247,1.0181918,2.9987299,1.9943356,4.0162478,1.9365436,10.8233531),(6964,'ulna-cleaned.tif',183,4,488,4.9774127,5.2172019,11.2779838,1.8,5.2072782,11.2660903,1.2402904,1.1132509,1.9940697,1.1272406,4.9248072,0.7422033,2.4697267,1.0125666,2.9623043,1.9902191,4.0162478,1.9365436,10.926526),(6965,'ulna-cleaned.tif',183,4,489,4.9570903,5.2185909,11.2745313,1.8,5.2077946,11.261934,1.2393239,1.1105934,1.9916859,1.1146404,4.8956202,0.7386822,2.4580282,1.003644,2.9450444,1.9894663,4.0237722,1.9678758,10.9031531),(6966,'ulna-cleaned.tif',183,4,490,4.9290047,5.2220305,11.2744373,1.8,5.2121545,11.2643413,1.2401318,1.1074964,1.9793991,1.0943688,4.8542278,0.734905,2.4523745,0.9881466,2.9421346,1.9825308,4.0085107,1.9586963,10.7145091),(6967,'ulna-cleaned.tif',183,4,491,4.9005583,5.2220931,11.2691326,1.8,5.2108189,11.2570758,1.2407605,1.1058621,1.9741415,1.0751765,4.8181721,0.7309788,2.4406417,0.9722519,2.9090577,1.9795255,3.9935895,1.9494474,10.6911362),(6968,'ulna-cleaned.tif',183,4,492,4.8765128,5.2260215,11.2659427,1.8,5.217532,11.2553133,1.2410209,1.1011734,1.9852082,1.060894,4.7599235,0.7275219,2.3976948,0.9634214,2.8569697,1.9562108,4.0085107,1.9586963,11.0353701),(6969,'ulna-cleaned.tif',183,4,493,4.8630793,5.2273344,11.262917,1.8,5.2177357,11.2521674,1.2426158,1.0744195,1.9686998,1.0505222,4.7352229,0.7263082,2.4052539,0.977758,2.8902727,1.9392888,3.9790125,1.94013,10.8370447),(6970,'ulna-cleaned.tif',183,4,494,4.8473821,5.2285466,11.2576258,1.8,5.2186357,11.2453383,1.23988,1.0710424,1.9657206,1.0402905,4.6971683,0.7226103,2.3895402,0.9712879,2.8533387,1.9364408,3.9716037,1.9624963,10.8427159),(6971,'ulna-cleaned.tif',183,4,495,4.8339009,5.2307029,11.2521744,1.8,5.2218528,11.2401459,1.2398458,1.0919947,1.9641016,1.0282309,4.6725533,0.7205837,2.3789774,0.941608,2.8401104,1.9535335,3.9790125,1.94013,10.5315362),(6972,'ulna-cleaned.tif',183,4,496,4.8215187,5.233326,11.2482361,1.8,5.225077,11.2368208,1.2403279,1.0883551,1.9571001,1.0198816,4.6280698,0.7189758,2.3647589,0.9370853,2.8500824,1.9535335,3.9509061,1.921293,10.5645904),(6973,'ulna-cleaned.tif',183,4,497,4.8118768,5.2343923,11.2415939,1.8,5.2260738,11.2307464,1.241169,1.0854066,1.9509028,1.0087987,4.6094454,0.7179517,2.3627243,0.9294201,2.838106,1.9574166,3.9373842,1.9117753,10.6403803),(6974,'ulna-cleaned.tif',183,4,498,4.8026713,5.2363285,11.2367047,1.8,5.2281223,11.2257147,1.2402038,1.0569533,1.9601573,1.0019078,4.5993782,0.7161044,2.3464333,0.9479206,2.8131543,1.9349163,3.9509061,1.921293,10.446065),(6975,'ulna-cleaned.tif',183,4,499,4.7906269,5.2387173,11.2327677,1.8,5.2309272,11.2224126,1.2402938,1.0782273,1.9453331,0.9913087,4.5680694,0.7143526,2.3482197,0.9193875,2.7868265,1.9495397,3.9274656,1.9343232,10.7338718),(6976,'ulna-cleaned.tif',183,4,500,4.7545897,5.2407784,11.2304692,1.8,5.2330444,11.2213789,1.2393455,1.0752801,1.9430245,0.9751975,4.5156028,0.708517,2.3240071,0.9069242,2.7891398,1.9495397,3.9274656,1.9343232,10.475109),(6977,'ulna-cleaned.tif',183,4,501,4.7452405,5.2418779,11.2235974,1.8,5.2338273,11.2127255,1.2367497,1.0712942,1.9623207,0.9671584,4.5048279,0.7058562,2.2956635,0.9027944,2.7636325,1.9693985,3.9509061,1.921293,10.7435531),(6978,'ulna-cleaned.tif',183,4,502,4.7350038,5.2431355,11.2209126,1.8,5.2352962,11.2121509,1.2365235,1.044562,1.9487463,0.9616502,4.491236,0.7042229,2.3046797,0.9206253,2.7530743,1.9045392,3.9418293,1.943784,10.5081633),(6979,'ulna-cleaned.tif',183,4,503,4.7119507,5.2445652,11.2148415,1.8,5.2370202,11.20602,1.2363919,1.0657835,1.9435273,0.9537944,4.4609138,0.7007302,2.2952669,0.8949232,2.7308953,1.9270394,3.9274656,1.9343232,10.6306989),(6980,'ulna-cleaned.tif',183,4,504,4.6922052,5.2468242,11.2115495,1.8,5.2404157,11.2046988,1.2364417,1.0625834,1.9395508,0.9426151,4.4252598,0.6978179,2.2815901,0.8870975,2.7458824,1.914794,3.9242214,1.9021929,10.447726),(6981,'ulna-cleaned.tif',183,4,505,4.6755761,5.2486088,11.2048661,1.8,5.2421718,11.1948567,1.2335769,1.0578671,1.9476991,0.9375212,4.4050549,0.6939558,2.2616711,0.8862373,2.7169783,1.9032699,3.9134559,1.9247938,10.2961463),(6982,'ulna-cleaned.tif',183,4,506,4.6630943,5.2502723,11.2013649,1.8,5.2436221,11.1908317,1.2304812,1.0542157,1.9457814,0.9286019,4.3858394,0.6905951,2.2540248,0.8808462,2.7015197,1.8937322,3.8998041,1.9151967,10.3058277),(6983,'ulna-cleaned.tif',183,4,507,4.6527118,5.2510806,11.1980141,1.8,5.2443236,11.1896156,1.2293719,1.051999,1.9407075,0.9234087,4.369078,0.6885154,2.251281,0.8777658,2.6937826,1.8937322,3.8989876,1.8828384,10.2397192),(6984,'ulna-cleaned.tif',183,4,508,4.639784,5.2523104,11.1929323,1.8,5.2451614,11.1844955,1.2298529,1.0517082,1.9253414,0.9170116,4.3303933,0.6868368,2.249156,0.8719259,2.7057123,1.8927653,3.8869237,1.8730688,10.1696006),(6985,'ulna-cleaned.tif',183,4,509,4.6313129,5.2542558,11.1858887,1.8,5.2468179,11.1764808,1.2287717,1.0473162,1.9438156,0.9136321,4.3102705,0.6850562,2.2174276,0.8723555,2.6754784,1.8927653,3.8989876,1.8828384,10.1599192),(6986,'ulna-cleaned.tif',183,4,510,4.6208362,5.2583539,11.1814631,1.8,5.252645,11.1722839,1.2270173,1.0416336,1.9306812,0.905269,4.2883488,0.6826508,2.2211584,0.8690858,2.6632434,1.8920297,3.8865141,1.9055332,10.3622548),(6987,'ulna-cleaned.tif',183,4,511,4.6131924,5.2606671,11.1762817,1.8,5.2556488,11.1671788,1.2260618,1.0615886,1.9509163,0.8969972,4.2720272,0.6810548,2.1897542,0.8449574,2.6319919,1.905569,3.9134559,1.9247938,10.3251904),(6988,'ulna-cleaned.tif',183,4,512,4.5949794,5.2629173,11.1734652,1.8,5.2575656,11.1659603,1.2259175,1.0584828,1.9384874,0.8886144,4.2255326,0.6782956,2.1798092,0.8395171,2.6036287,1.8860132,3.8826207,1.9608444,10.4574074),(6989,'ulna-cleaned.tif',183,4,513,4.5827468,5.2638689,11.1698889,1.8,5.2564711,11.1614634,1.2263119,1.0564784,1.9353174,0.8811197,4.1940547,0.6766815,2.1671147,0.8340159,2.5872949,1.9039407,3.8676255,1.9513027,10.3018175),(6990,'ulna-cleaned.tif',183,4,514,4.5882612,5.2673935,11.1662486,1.8,5.2603033,11.1567029,1.2253229,1.0516774,1.9304082,0.8797826,4.185326,0.6770144,2.1681042,0.8365518,2.6096378,1.8868475,3.8622706,1.9186847,10.2453904),(6991,'ulna-cleaned.tif',183,4,515,4.5768776,5.2694404,11.1637156,1.8,5.2625789,11.1561935,1.2251126,1.0488392,1.9422796,0.869935,4.1608144,0.6752324,2.1422324,0.8294264,2.5711682,1.8912869,3.8622706,1.9186847,9.9342107),(6992,'ulna-cleaned.tif',183,4,516,4.5605422,5.2728367,11.1619844,1.8,5.2667871,11.1572495,1.2274292,1.0456562,1.9412402,0.8636415,4.1274189,0.673942,2.1261763,0.8259326,2.5476687,1.8808211,3.8622706,1.9186847,10.0994819),(6993,'ulna-cleaned.tif',183,4,517,4.5311381,5.275492,11.1552279,1.8,5.2691944,11.147321,1.2280132,1.0410346,1.9356261,0.8519927,4.0961542,0.6698762,2.1161908,0.8184096,2.5316672,1.8808211,3.8622706,1.9186847,10.1929734),(6994,'ulna-cleaned.tif',183,4,518,4.510013,5.2784473,11.1491424,1.8,5.2729844,11.1391056,1.2265881,1.0358244,1.9447141,0.8424908,4.0631629,0.6660737,2.0893369,0.8133529,2.4949474,1.8759516,3.8622706,1.9186847,10.0277022),(6995,'ulna-cleaned.tif',183,4,519,4.4997917,5.2816526,11.1469493,1.8,5.2772325,11.1392982,1.226319,1.0589432,1.940943,0.8381939,4.0329323,0.6644359,2.0778211,0.7915381,2.5004085,1.8920165,3.8610339,1.886011,10.0100006),(6996,'ulna-cleaned.tif',183,4,520,4.4944329,5.2842978,11.1435998,1.8,5.2797518,11.137445,1.2272071,1.0554967,1.9385311,0.8315361,4.0065354,0.6640671,2.0667893,0.787815,2.4859123,1.8933383,3.8357994,1.8991257,10.0003192),(6997,'ulna-cleaned.tif',183,4,521,4.4805908,5.2863632,11.1377496,1.8,5.2808786,11.1300834,1.2247475,1.0510844,1.9476802,0.8224062,3.9893782,0.6608532,2.0482717,0.7824359,2.4563857,1.8884711,3.8357994,1.8991257,10.0994819),(6998,'ulna-cleaned.tif',183,4,522,4.45926,5.2882843,11.1329987,1.8,5.2819111,11.1235036,1.222858,1.0472725,1.9442609,0.815134,3.9585073,0.6568089,2.0359959,0.7783399,2.4396062,1.8726943,3.8370443,1.8662372,9.9769463),(6999,'ulna-cleaned.tif',183,4,523,4.4404659,5.290807,11.1291427,1.8,5.2845513,11.1204896,1.2201274,1.0430038,1.9557763,0.8054967,3.9322247,0.6527409,2.0105698,0.7722855,2.4036619,1.8726943,3.8529851,1.9416876,10.1986446),(7000,'ulna-cleaned.tif',183,4,524,4.4191771,5.2940086,11.1233923,1.8,5.2891393,11.1130142,1.2194313,1.0378689,1.9753786,0.7947421,3.906974,0.6492805,1.9778355,0.7657442,2.3683782,1.864066,3.8760546,1.9283622,10.235709),(7001,'ulna-cleaned.tif',183,4,525,4.4039522,5.2970246,11.1200675,1.8,5.2932557,11.1125091,1.2187128,1.1262244,1.9459198,0.7903281,3.8816963,0.6467024,1.9947874,0.7017502,2.396001,1.8578695,3.8357994,1.8991257,10.0527362),(7002,'ulna-cleaned.tif',183,4,526,4.3908434,5.2991089,11.1151447,1.8,5.2938669,11.1069096,1.2172747,1.0297524,1.9422006,0.7832841,3.868158,0.644095,1.9916367,0.7606528,2.3898373,1.8543543,3.8357994,1.8991257,9.9866277),(7003,'ulna-cleaned.tif',183,4,527,4.3758902,5.3026579,11.1127445,1.8,5.2980809,11.1065703,1.2165008,1.0392569,1.95512,0.7772665,3.8439112,0.6415345,1.9660743,0.747906,2.355168,1.8651345,3.8357994,1.8991257,10.0293633),(7004,'ulna-cleaned.tif',183,4,528,4.367863,5.3047943,11.1071413,1.8,5.2996533,11.0998218,1.215768,1.0490346,1.9507299,0.7725502,3.8219159,0.6400102,1.9592235,0.7364392,2.3464995,1.8794334,3.8357994,1.8991257,10.0100006),(7005,'ulna-cleaned.tif',183,4,529,4.3587577,5.3065502,11.1020784,1.8,5.3017862,11.0954306,1.2149237,1.0454891,1.960639,0.7684891,3.7883529,0.6382758,1.9322032,0.7350522,2.3112476,1.864066,3.824785,1.9222411,9.8777836),(7006,'ulna-cleaned.tif',183,4,530,4.344295,5.309832,11.0949669,1.8,5.305614,11.085532,1.213177,1.0490774,1.9554857,0.7662764,3.7604184,0.6353302,1.9230099,0.7304288,2.3016745,1.8802481,3.8112334,1.9124118,10.0994819),(7007,'ulna-cleaned.tif',183,4,531,4.3371414,5.3128334,11.0915937,1.8,5.3083237,11.0823766,1.2127512,1.086921,1.9488889,0.7615049,3.7499816,0.6340821,1.9241639,0.7006074,2.3126114,1.9182294,3.8108157,1.8793026,10.1365463),(7008,'ulna-cleaned.tif',183,4,532,4.3247865,5.3165278,11.0851766,1.8,5.3131178,11.0750589,1.2101076,1.0948762,1.9352415,0.754814,3.7248104,0.6310212,1.9247264,0.6894058,2.3041059,1.914794,3.7988908,1.8692953,10.0801192),(7009,'ulna-cleaned.tif',183,4,533,4.3172654,5.3188703,11.0804904,1.8,5.3152048,11.0704002,1.2090455,1.0908966,1.9459946,0.7492445,3.7145951,0.6294185,1.9088415,0.6868153,2.2799633,1.9179429,3.7873488,1.9258679,10.2180074),(7010,'ulna-cleaned.tif',183,4,534,4.3076739,5.3215748,11.0762319,1.8,5.3184916,11.0679807,1.2100838,1.1243263,1.9659901,0.7470553,3.6918974,0.6285131,1.877882,0.664447,2.2494943,1.9535175,3.8158255,1.9454775,10.0100006),(7011,'ulna-cleaned.tif',183,4,535,4.281914,5.3237501,11.073069,1.8,5.3196414,11.0642353,1.2095921,1.0696774,1.9638833,0.7354002,3.6558348,0.6245226,1.8615336,0.6874972,2.2274682,1.8900604,3.8014044,1.9357094,9.9302005),(7012,'ulna-cleaned.tif',183,4,536,4.2868399,5.3260872,11.0686813,1.8,5.3222508,11.0610989,1.2081035,1.0798396,1.9467079,0.7362414,3.6627762,0.6245367,1.8815233,0.6818063,2.2542653,1.8962742,3.7873488,1.9258679,9.9068277),(7013,'ulna-cleaned.tif',183,4,537,4.2805781,5.3297726,11.0667595,1.8,5.3272428,11.0609469,1.2067239,1.1412227,1.9464095,0.7345386,3.6466657,0.6229705,1.8735347,0.6436418,2.2453636,1.9636947,3.7736627,1.915954,10.0043293),(7014,'ulna-cleaned.tif',183,4,538,4.2697014,5.3309089,11.0606199,1.8,5.3273766,11.0538231,1.2057152,1.1378901,1.9412173,0.7286779,3.6250246,0.6209093,1.8673976,0.6403763,2.2371025,1.9743242,3.7736627,1.915954,10.3719362),(7015,'ulna-cleaned.tif',183,4,539,4.2541503,5.333301,11.0561733,1.8,5.3293798,11.0487636,1.205324,1.0397295,1.9522331,0.7181617,3.6050235,0.6184627,1.8466153,0.6907198,2.2052742,1.8605566,3.7873488,1.9258679,10.0100006),(7016,'ulna-cleaned.tif',183,4,540,4.2456746,5.3355618,11.0490232,1.8,5.3310232,11.0393007,1.2035328,1.0346513,1.969601,0.7121156,3.5854137,0.6163827,1.8203756,0.6882662,2.1773214,1.8589009,3.7980526,1.9025133,9.9632548),(7017,'ulna-cleaned.tif',183,4,541,4.245223,5.3384849,11.0446906,1.8,5.3349773,11.0358709,1.2017521,1.0383778,1.9668397,0.7108082,3.5756427,0.6154711,1.8179635,0.6845372,2.1746885,1.8594882,3.7980526,1.9025133,9.8931362),(7018,'ulna-cleaned.tif',183,4,542,4.236383,5.3390964,11.0366146,1.8,5.3347638,11.0268684,1.1991247,1.0548065,1.9743599,0.7055011,3.5658573,0.6129376,1.8060827,0.6688441,2.1559447,1.8801048,3.7873488,1.9258679,9.996309),(7019,'ulna-cleaned.tif',183,4,543,4.2242749,5.3410282,11.0312569,1.8,5.3366604,11.0222553,1.1986907,1.0591405,1.9701424,0.7016491,3.5333351,0.6109789,1.7934415,0.6624703,2.1418665,1.8820294,3.7736627,1.915954,9.6851293),(7020,'ulna-cleaned.tif',183,4,544,4.2270757,5.3426455,11.0246402,1.8,5.3375678,11.0154392,1.1982688,1.055114,1.9582346,0.6992475,3.5220211,0.6111825,1.7985695,0.6627222,2.1550948,1.8820294,3.7736627,1.915954,10.0430548),(7021,'ulna-cleaned.tif',183,4,545,4.2117892,5.3467923,11.0197636,1.8,5.3435701,11.0109985,1.1955156,1.0487193,1.9553323,0.6920563,3.4971117,0.607658,1.7884999,0.6599062,2.1418729,1.8820294,3.7736627,1.915954,10.0196819),(7022,'ulna-cleaned.tif',183,4,546,4.198262,5.348084,11.0150333,1.8,5.3450939,11.0076543,1.1944236,1.0523653,1.9661208,0.6857329,3.4814089,0.6051846,1.7706994,0.6516111,2.1176051,1.8685458,3.7736627,1.915954,9.8407192),(7023,'ulna-cleaned.tif',183,4,547,4.1885824,5.3496993,11.009386,1.8,5.3466144,11.0016645,1.1932039,1.0709697,1.9615661,0.6824315,3.463914,0.6032064,1.765892,0.637209,2.1118669,1.8904502,3.7736627,1.915954,9.9632548),(7024,'ulna-cleaned.tif',183,4,548,4.1814583,5.351267,11.0044288,1.8,5.3469416,10.9958654,1.192822,1.097051,1.9722939,0.6797625,3.4408492,0.601998,1.7445925,0.6196271,2.0851693,1.9203438,3.7873488,1.9258679,10.1518989),(7025,'ulna-cleaned.tif',183,4,549,4.1727212,5.3536357,10.9975077,1.8,5.3497944,10.9876874,1.190675,1.0919726,1.9670061,0.6751292,3.4248918,0.5997135,1.7411699,0.6182657,2.0802699,1.9202929,3.7736627,1.915954,9.8971463),(7026,'ulna-cleaned.tif',183,4,550,4.161478,5.3554624,10.9905007,1.8,5.3522777,10.9797223,1.1897535,1.0875308,1.9761328,0.6684514,3.4180764,0.5976568,1.7296795,0.6146506,2.0609012,1.9084319,3.7873488,1.9258679,9.8447293),(7027,'ulna-cleaned.tif',183,4,551,4.1545124,5.3581728,10.9858627,1.8,5.3553251,10.9746493,1.1869869,1.0828385,1.9654666,0.6639462,3.4054082,0.59533,1.7326207,0.6131535,2.0700729,1.8966615,3.7603502,1.9059689,10.0059904),(7028,'ulna-cleaned.tif',183,4,552,4.1476588,5.358638,10.9809394,1.8,5.3547954,10.9697015,1.1878068,1.0807018,1.9610434,0.6579974,3.3995076,0.5947411,1.7335198,0.6088612,2.0686192,1.8966615,3.7474152,1.8959139,9.8310378),(7029,'ulna-cleaned.tif',183,4,553,4.1475037,5.3611626,10.9753529,1.8,5.3574663,10.9632662,1.1868816,1.0761126,1.9497394,0.6598224,3.3922051,0.5942751,1.7398249,0.6131537,2.0725096,1.8941864,3.7361403,1.9195673,9.7221937),(7030,'ulna-cleaned.tif',183,4,554,4.1289075,5.3623285,10.9711845,1.8,5.3581278,10.961477,1.1857302,1.0732659,1.9684557,0.6499047,3.3700116,0.5910595,1.7120079,0.6055393,2.0404743,1.8941864,3.7603502,1.9059689,10.0059904),(7031,'ulna-cleaned.tif',183,4,555,4.1151843,5.3635336,10.9637707,1.8,5.3588215,10.9521169,1.1826766,1.0385956,1.9622851,0.6461435,3.3582388,0.5876323,1.7113919,0.6221319,2.0390578,1.8558982,3.7474152,1.8959139,9.9205192),(7032,'ulna-cleaned.tif',183,4,556,4.0949358,5.3641544,10.9549602,1.8,5.3586734,10.9412116,1.1807507,1.0341657,1.9696904,0.6395021,3.3235255,0.5838182,1.687334,0.618375,2.0085749,1.8558982,3.7361403,1.9195673,9.8834548),(7033,'ulna-cleaned.tif',183,4,557,4.089899,5.3685564,10.9528793,1.8,5.3659094,10.9413666,1.1803137,1.081268,1.9694918,0.6394319,3.3091839,0.5828905,1.6802222,0.5913723,2.0012306,1.8918087,3.7641586,1.9394922,10.1518989),(7034,'ulna-cleaned.tif',183,4,558,4.0841783,5.3704042,10.9493489,1.8,5.3671472,10.9388328,1.1777559,1.0559887,1.951955,0.6372354,3.2947562,0.5808463,1.6879263,0.6034491,2.0126826,1.8704657,3.7269677,1.9433506,9.7181836),(7035,'ulna-cleaned.tif',183,4,559,4.0676607,5.3718038,10.9448429,1.8,5.3679124,10.9349732,1.1766256,1.052735,1.9699386,0.6282281,3.2859612,0.5779544,1.6680526,0.5967581,1.986745,1.8704657,3.7603502,1.9059689,9.8971463),(7036,'ulna-cleaned.tif',183,4,560,4.0545881,5.372549,10.9381737,1.8,5.368721,10.9285234,1.1758076,1.018603,1.9640927,0.6215915,3.2637788,0.5757047,1.6617234,0.6102392,1.9779606,1.8206968,3.7361403,1.9195673,9.7044921),(7037,'ulna-cleaned.tif',183,4,561,4.046545,5.3749921,10.9329344,1.8,5.3717792,10.9239418,1.1751562,1.0141409,1.9755967,0.6159655,3.2593038,0.5742503,1.649782,0.6073767,1.9603234,1.8203929,3.7361403,1.9195673,9.9205192),(7038,'ulna-cleaned.tif',183,4,562,4.0315398,5.3770561,10.9273802,1.8,5.3737636,10.9161273,1.1737361,1.0096719,1.9713707,0.6116219,3.2304327,0.5714413,1.6386734,0.605763,1.9476382,1.8203929,3.7361403,1.9195673,9.8874649),(7039,'ulna-cleaned.tif',183,4,563,4.0211715,5.3791786,10.921962,1.8,5.3771896,10.9117816,1.1720398,1.0263807,1.9673205,0.6081292,3.2221707,0.5691595,1.6378473,0.5924987,1.9456456,1.8205955,3.7361403,1.9195673,9.6577463),(7040,'ulna-cleaned.tif',183,4,564,4.010098,5.3796686,10.9163509,1.8,5.3765475,10.9057176,1.170681,1.0232571,1.946898,0.6012179,3.198234,0.5669414,1.6427332,0.5875531,1.9512149,1.8201903,3.6986677,1.9232539,9.8036548),(7041,'ulna-cleaned.tif',183,4,565,4.0040821,5.3808864,10.9094847,1.8,5.377698,10.8989556,1.1684314,1.0498762,1.9411322,0.5987415,3.1756969,0.5650113,1.6360024,0.5702972,1.9441351,1.8542819,3.6850843,1.9130919,10.0994819),(7042,'ulna-cleaned.tif',183,4,566,4.0001497,5.3837784,10.9029147,1.8,5.3804294,10.8901049,1.1693641,1.0237873,1.9517714,0.5944505,3.1606599,0.5649042,1.6193802,0.5806387,1.9223832,1.8202916,3.6986677,1.9232539,9.8600819),(7043,'ulna-cleaned.tif',183,4,567,3.9878887,5.3858353,10.8977943,1.8,5.3834701,10.8853203,1.1673193,1.0404022,1.9690574,0.5893875,3.1518869,0.5621931,1.6007084,0.5664997,1.8998629,1.8414446,3.7096274,1.8993495,9.9438921),(7044,'ulna-cleaned.tif',183,4,568,3.9899859,5.387651,10.8951383,1.8,5.3839896,10.8825086,1.1651703,1.0161025,1.9673855,0.5877563,3.1582066,0.5614546,1.605281,0.5784419,1.9038791,1.8252495,3.7096274,1.8993495,9.6714378),(7045,'ulna-cleaned.tif',183,4,569,3.986488,5.3890386,10.8879662,1.8,5.3859773,10.8752076,1.1657926,1.0331134,1.9770461,0.5852039,3.1485036,0.561262,1.5925292,0.5664469,1.8874498,1.8381962,3.7269677,1.9433506,10.0857904),(7046,'ulna-cleaned.tif',183,4,570,3.972939,5.3914677,10.8829203,1.8,5.389084,10.8718189,1.1647416,1.0600742,1.9734391,0.5819331,3.1167494,0.5588498,1.5793492,0.5489551,1.8730876,1.8562021,3.7269677,1.9433506,10.0293633),(7047,'ulna-cleaned.tif',183,4,571,3.9675141,5.3927703,10.8758435,1.8,5.3902041,10.8647552,1.1624911,1.0238203,1.951769,0.5755876,3.1086718,0.5570044,1.5927457,0.5621959,1.8873987,1.8168181,3.6898334,1.9472867,9.515848),(7048,'ulna-cleaned.tif',183,4,572,3.9637509,5.3944257,10.8697884,1.8,5.3918001,10.8586874,1.1604009,1.0191927,1.9469397,0.5729378,3.1059237,0.5554678,1.595285,0.5621487,1.8893092,1.813878,3.6986677,1.9232539,9.5916378),(7049,'ulna-cleaned.tif',183,4,573,3.9508517,5.3958669,10.8646625,1.8,5.3933648,10.8534367,1.1576646,1.0148864,1.9634274,0.5681627,3.0838776,0.5523384,1.5706603,0.5598289,1.8599087,1.8054159,3.6986677,1.9232539,9.8133362),(7050,'ulna-cleaned.tif',183,4,574,3.9429193,5.3955915,10.8581771,1.8,5.3908863,10.8455609,1.1575638,1.0124995,1.9573751,0.563762,3.0794677,0.5511807,1.573264,0.5568023,1.8611806,1.8029948,3.6850843,1.9130919,9.4594208),(7051,'ulna-cleaned.tif',183,4,575,3.9350812,5.3975161,10.8517942,1.8,5.3934697,10.8390438,1.1561578,1.0076721,1.9683516,0.5618825,3.0642443,0.5494059,1.5567566,0.5576045,1.8421419,1.8029948,3.6986677,1.9232539,9.5585836),(7052,'ulna-cleaned.tif',183,4,576,3.9256684,5.3998707,10.8469499,1.8,5.3961585,10.8354365,1.1539958,1.0027828,1.9649086,0.5577933,3.0496729,0.5470465,1.5520686,0.5562454,1.8358742,1.7903521,3.6850843,1.9130919,9.436048),(7053,'ulna-cleaned.tif',183,4,577,3.9128223,5.4008023,10.8416745,1.8,5.3969002,10.8311578,1.1527246,0.9993272,1.9442869,0.5525408,3.033065,0.5446419,1.5599884,0.5529128,1.8440911,1.7852351,3.6612464,1.927016,9.5118378),(7054,'ulna-cleaned.tif',183,4,578,3.8960085,5.4022236,10.8326277,1.8,5.3997436,10.8201927,1.1504574,1.0260632,1.9567052,0.5451403,3.0189465,0.5412069,1.5428724,0.5312931,1.8202856,1.8084692,3.6718842,1.9028558,9.8504005),(7055,'ulna-cleaned.tif',183,4,579,3.8898802,5.4030989,10.8268722,1.8,5.3993577,10.8137338,1.1496209,1.0226551,1.9517508,0.5432425,3.0083321,0.5399512,1.5413505,0.5312079,1.8185442,1.8084692,3.6753511,1.9371907,9.9028175),(7056,'ulna-cleaned.tif',183,4,580,3.8791496,5.4037442,10.8188073,1.8,5.3990463,10.8037617,1.1483638,0.985651,1.960929,0.5368815,3.0018769,0.5378545,1.5308442,0.5446973,1.8044029,1.7628664,3.6898334,1.9472867,9.5021564),(7057,'ulna-cleaned.tif',183,4,581,3.8779894,5.4053252,10.8135625,1.8,5.4023457,10.8021407,1.1469756,0.9815068,1.956753,0.5357998,2.9996082,0.5370218,1.5329519,0.5458952,1.8065536,1.7626048,3.6753511,1.9371907,9.436048),(7058,'ulna-cleaned.tif',183,4,582,3.8707393,5.4062147,10.806212,1.8,5.4024849,10.7927025,1.1456891,0.9771517,1.9503828,0.5314139,2.999004,0.5353949,1.5376489,0.5438397,1.8099132,1.7552888,3.6753511,1.9371907,9.6480649),(7059,'ulna-cleaned.tif',183,4,583,3.858996,5.4084055,10.8015207,1.8,5.4053141,10.7883129,1.1435953,0.9723621,1.9304239,0.5282609,2.980438,0.5327568,1.5439293,0.5432759,1.8165305,1.7420306,3.6475236,1.9167636,9.4981463),(7060,'ulna-cleaned.tif',183,4,584,3.853299,5.4093014,10.7956136,1.8,5.4055454,10.7823903,1.1433216,0.9689852,1.9254017,0.5257317,2.975376,0.5318377,1.5453274,0.5425591,1.8174089,1.7244802,3.6475236,1.9167636,9.436048),(7061,'ulna-cleaned.tif',183,4,585,3.8470966,5.4107607,10.7883654,1.8,5.4073236,10.7747941,1.1421757,0.9973336,1.9359255,0.5237883,2.9697054,0.5304267,1.5339977,0.5251886,1.804416,1.7679424,3.6381275,1.9411198,9.4594208),(7062,'ulna-cleaned.tif',183,4,586,3.8367427,5.4112597,10.782258,1.8,5.4081785,10.7707323,1.1404004,0.9937071,1.9501505,0.5186316,2.9622601,0.5281395,1.5189905,0.521916,1.7835163,1.7658543,3.6612464,1.927016,9.4029937),(7063,'ulna-cleaned.tif',183,4,587,3.8184989,5.4109073,10.7732265,1.8,5.406285,10.760906,1.1391364,0.9564083,1.9417001,0.5123349,2.938486,0.5250175,1.5133573,0.5356864,1.7758275,1.7199899,3.6475236,1.9167636,9.4223564),(7064,'ulna-cleaned.tif',183,4,588,3.8090152,5.4118903,10.7659948,1.8,5.406758,10.7516371,1.1377182,0.9518558,1.9521824,0.508712,2.9338897,0.5230285,1.5028768,0.5344423,1.7631038,1.7171366,3.6612464,1.927016,9.356248),(7065,'ulna-cleaned.tif',183,4,589,3.8003771,5.41278,10.7578149,1.8,5.4072811,10.7409347,1.1333445,0.9817597,1.9449586,0.5061996,2.9223446,0.519724,1.5025228,0.5156044,1.7623408,1.715556,3.6381275,1.9411198,9.3465666),(7066,'ulna-cleaned.tif',183,4,590,3.7847354,5.4136306,10.7521516,1.8,5.4092842,10.7376221,1.1336644,0.944961,1.9402018,0.4999669,2.9053745,0.5177397,1.4974599,0.5290874,1.7547772,1.6822839,3.6238779,1.9308557,9.144231),(7067,'ulna-cleaned.tif',183,4,591,3.7866227,5.4155734,10.7454149,1.8,5.4128465,10.7307383,1.1338752,0.9718498,1.9204289,0.5022563,2.9052819,0.5181,1.5128297,0.5168044,1.7682207,1.7259656,3.6212411,1.8960312,9.4691022),(7068,'ulna-cleaned.tif',183,4,592,3.7728962,5.4149152,10.7401757,1.8,5.4098442,10.7269496,1.1336854,0.970153,1.9322638,0.4964731,2.8900714,0.5161303,1.4956919,0.5117473,1.7491016,1.7256224,3.6381275,1.9411198,9.4787836),(7069,'ulna-cleaned.tif',183,4,593,3.7623756,5.4166659,10.7333014,1.8,5.4125837,10.7191241,1.1318328,0.9649013,1.9265545,0.4902301,2.8925158,0.5137987,1.5013932,0.5080624,1.7523496,1.7229777,3.6381275,1.9411198,9.515848),(7070,'ulna-cleaned.tif',183,4,594,3.7426584,5.4168173,10.7251405,1.8,5.4132074,10.7110266,1.128895,0.9259422,1.9359395,0.4820803,2.8780439,0.5096926,1.4866393,0.5206376,1.7338716,1.6790919,3.6381275,1.9411198,9.4554107),(7071,'ulna-cleaned.tif',183,4,595,3.7390203,5.4186265,10.7191897,1.8,5.4165499,10.7054326,1.1276947,0.95538,1.9501721,0.4818851,2.8756394,0.5086182,1.4745567,0.504391,1.7172905,1.6858194,3.6612464,1.927016,9.5448921),(7072,'ulna-cleaned.tif',183,4,596,3.7242334,5.4185036,10.7112906,1.8,5.4141855,10.6956788,1.1281429,0.9352071,1.9411709,0.4774447,2.8536941,0.5068222,1.4700891,0.5105229,1.7155689,1.6607389,3.6309001,1.9655874,9.4787836),(7073,'ulna-cleaned.tif',183,4,597,3.725574,5.4186866,10.704175,1.8,5.41331,10.6877931,1.1262573,0.9482576,1.9347358,0.4780651,2.8593611,0.5060969,1.4779078,0.5041511,1.7245115,1.6827612,3.6157415,1.955401,9.5021564),(7074,'ulna-cleaned.tif',183,4,598,3.7118048,5.4211274,10.6995636,1.8,5.4170129,10.6859693,1.1253556,0.9092891,1.9160167,0.4736791,2.8394551,0.503793,1.4819574,0.5209334,1.7224915,1.6382394,3.6100131,1.9205116,9.2063293),(7075,'ulna-cleaned.tif',183,4,599,3.7020169,5.421549,10.6925578,1.8,5.4170425,10.6788714,1.1234622,0.9063562,1.9095592,0.4692805,2.833899,0.5015547,1.4840592,0.5177661,1.7230612,1.6349235,3.5965375,1.9100889,9.1071666),(7076,'ulna-cleaned.tif',183,4,600,3.6885328,5.4225085,10.6860144,1.8,5.4185376,10.6720595,1.1220093,0.9363848,1.9211437,0.4671595,2.8180387,0.4990303,1.4668547,0.4988969,1.7059799,1.6822839,3.6100131,1.9205116,9.4981463),(7077,'ulna-cleaned.tif',183,4,601,3.680672,5.4227869,10.6773767,1.8,5.4191426,10.6616039,1.119007,0.9307155,1.9315657,0.463159,2.8214359,0.4965235,1.4606989,0.4976376,1.6925369,1.6605863,3.6341871,1.9064349,9.4457293),(7078,'ulna-cleaned.tif',183,4,602,3.6699944,5.4240029,10.6720729,1.8,5.41969,10.6553018,1.1181003,0.9267958,1.9271573,0.4600211,2.8105801,0.4946471,1.4584072,0.4963564,1.6892849,1.6440898,3.6212411,1.8960312,9.3989836),(7079,'ulna-cleaned.tif',183,4,603,3.6637287,5.4241441,10.6635789,1.8,5.419925,10.6455957,1.1194256,0.9400181,1.9372244,0.4572197,2.812483,0.4944386,1.4518107,0.4863946,1.683221,1.6658209,3.6341871,1.9064349,9.3796208),(7080,'ulna-cleaned.tif',183,4,604,3.6543788,5.4256769,10.6575313,1.8,5.4223003,10.6399183,1.1180229,0.9537949,1.9322536,0.4547171,2.8080709,0.4925053,1.4532621,0.4767451,1.6840423,1.6719886,3.6157415,1.955401,9.6110005),(7081,'ulna-cleaned.tif',183,4,605,3.6499047,5.4271171,10.65137,1.8,5.4237784,10.634653,1.1163083,0.9489311,1.9446196,0.4536137,2.8071379,0.4910806,1.4435409,0.478026,1.6743403,1.6717005,3.6309001,1.9655874,9.4554107),(7082,'ulna-cleaned.tif',183,4,606,3.6325531,5.4277066,10.6460624,1.8,5.4229048,10.6280907,1.1161029,0.9109186,1.9233638,0.4473999,2.7915199,0.488648,1.4513738,0.4911524,1.6722586,1.6287675,3.6100131,1.9205116,9.3191836),(7083,'ulna-cleaned.tif',183,4,607,3.6150497,5.4286679,10.6370901,1.8,5.4256031,10.6188631,1.114521,0.9051733,1.9153696,0.440863,2.7788974,0.4855404,1.4508414,0.4870482,1.6693888,1.6253263,3.6100131,1.9205116,9.3191836),(7084,'ulna-cleaned.tif',183,4,608,3.6088526,5.4300069,10.6320131,1.8,5.4280128,10.616027,1.1125778,0.9005674,1.910965,0.4398695,2.7745458,0.483782,1.4519083,0.488436,1.6703777,1.6023602,3.6100131,1.9205116,9.3989836),(7085,'ulna-cleaned.tif',183,4,609,3.5966538,5.4284617,10.6236017,1.8,5.4236823,10.6044966,1.112409,0.8981294,1.9203557,0.4348176,2.7652798,0.4820664,1.4399831,0.484137,1.6584044,1.592361,3.6009613,1.9451299,9.3756107),(7086,'ulna-cleaned.tif',183,4,610,3.5821133,5.4311646,10.6194939,1.8,5.4273043,10.6030527,1.111009,0.8930298,1.9356579,0.4325811,2.7446326,0.4794535,1.4179327,0.4843972,1.6288565,1.6023602,3.6100131,1.9205116,9.3191836),(7087,'ulna-cleaned.tif',183,4,611,3.5696339,5.4312824,10.6100935,1.8,5.4273585,10.5920631,1.1082285,0.9582413,1.926621,0.4281983,2.7397908,0.4764647,1.4220705,0.4468585,1.6315156,1.6717005,3.6100131,1.9205116,9.4650921),(7088,'ulna-cleaned.tif',183,4,612,3.5649942,5.4311997,10.603918,1.8,5.4273581,10.5882233,1.1069283,0.8835383,1.9385966,0.4257345,2.7401361,0.4752278,1.4134638,0.4818518,1.623929,1.5876898,3.6100131,1.9205116,9.3095022),(7089,'ulna-cleaned.tif',183,4,613,3.5544965,5.4316442,10.5969863,1.8,5.4277493,10.5802627,1.1072215,0.8802065,1.9326556,0.4213586,2.7363288,0.4739674,1.4158388,0.4787043,1.6250114,1.5779979,3.6100131,1.9205116,9.3852921),(7090,'ulna-cleaned.tif',183,4,614,3.5410639,5.4330801,10.5892355,1.8,5.4299826,10.5704781,1.1065963,0.8928684,1.9262904,0.4176134,2.7304359,0.4718809,1.417458,0.4677211,1.6256953,1.5709454,3.586564,1.9347753,9.5215192),(7091,'ulna-cleaned.tif',183,4,615,3.5311603,5.4329995,10.5841137,1.8,5.4283764,10.5654589,1.1061442,0.87254,1.939416,0.4133178,2.7280388,0.4703481,1.406629,0.473695,1.6141645,1.549673,3.6097926,1.9800422,9.276448),(7092,'ulna-cleaned.tif',183,4,616,3.526513,5.4345067,10.5781715,1.8,5.4307219,10.5615728,1.1038781,0.8847159,1.9164571,0.4126696,2.7272069,0.4686601,1.4230461,0.4664431,1.6205971,1.5568404,3.6100131,1.9205116,9.2063293),(7093,'ulna-cleaned.tif',183,4,617,3.5121215,5.4354222,10.5724355,1.8,5.4321538,10.5570076,1.1023996,0.8802604,1.9114584,0.4086221,2.7134622,0.466051,1.4195769,0.4642059,1.6157162,1.5568404,3.6100131,1.9205116,9.3385463),(7094,'ulna-cleaned.tif',183,4,618,3.5020004,5.4355424,10.5640414,1.8,5.4318457,10.5466662,1.1007228,0.8937973,1.9211959,0.4072984,2.6996121,0.4639185,1.4051727,0.4556944,1.6036808,1.5753923,3.6009613,1.9451299,9.5118378),(7095,'ulna-cleaned.tif',183,4,619,3.4983879,5.4369711,10.5592435,1.8,5.4324938,10.5421931,1.1004574,0.8901904,1.9180971,0.4063612,2.6928828,0.463315,1.4039346,0.456488,1.6030683,1.5714576,3.586564,1.9347753,9.3191836),(7096,'ulna-cleaned.tif',183,4,620,3.4982374,5.437779,10.5512104,1.8,5.4332211,10.5332926,1.0977496,0.8841757,1.9282204,0.4055771,2.697969,0.462017,1.3992016,0.4587064,1.5998881,1.5555524,3.6009613,1.9451299,9.3191836),(7097,'ulna-cleaned.tif',183,4,621,3.4874332,5.4393913,10.5434676,1.8,5.4362037,10.524088,1.0982626,0.8795299,1.9395358,0.4016072,2.6955738,0.4608318,1.3898036,0.4566158,1.5827257,1.5547092,3.6100131,1.9205116,9.6303633),(7098,'ulna-cleaned.tif',183,4,622,3.4744928,5.4394167,10.5349278,1.8,5.4367408,10.5147084,1.0992505,0.8406922,1.9321953,0.3966632,2.6841943,0.4595852,1.3891941,0.4718293,1.580881,1.5168782,3.6100131,1.9205116,9.3522378),(7099,'ulna-cleaned.tif',183,4,623,3.4742048,5.4410786,10.5292598,1.8,5.4378909,10.5091416,1.097732,0.8538876,1.927519,0.3972441,2.6858999,0.4588347,1.3934492,0.4652182,1.5859469,1.5386079,3.6100131,1.9205116,9.3989836),(7100,'ulna-cleaned.tif',183,4,624,3.4680389,5.4422359,10.52215,1.8,5.4386492,10.5017457,1.0967786,0.8308498,1.9214794,0.3957833,2.672045,0.4575731,1.3906186,0.4763596,1.5832032,1.5076331,3.586564,1.9347753,9.2958107),(7101,'ulna-cleaned.tif',183,4,625,3.4599549,5.4436153,10.5154919,1.8,5.4407869,10.4961843,1.0935218,0.8771012,1.9141574,0.3969201,2.64613,0.4549774,1.3823994,0.4525362,1.5650261,1.5427354,3.5834555,1.899589,9.3852921),(7102,'ulna-cleaned.tif',183,4,626,3.4451183,5.4413646,10.507479,1.8,5.4378001,10.4883121,1.093602,0.8583592,1.9072418,0.391071,2.6460535,0.453064,1.3873718,0.455603,1.5686911,1.5202275,3.586564,1.9347753,9.4610819),(7103,'ulna-cleaned.tif',183,4,627,3.4337636,5.4418902,10.4981232,1.8,5.4389699,10.4775143,1.0908386,0.868734,1.9154543,0.3885879,2.6417563,0.4502778,1.37918,0.4473036,1.5623792,1.5234785,3.6009613,1.9451299,9.4514005),(7104,'ulna-cleaned.tif',183,4,628,3.4282123,5.4424134,10.4925524,1.8,5.4390624,10.4724458,1.0910255,0.8658325,1.9122494,0.3856228,2.644569,0.4496373,1.3829624,0.4453781,1.5664336,1.5202899,3.586564,1.9347753,9.4046548),(7105,'ulna-cleaned.tif',183,4,629,3.4184201,5.444116,10.4874446,1.8,5.4426673,10.4695613,1.0900963,0.8612901,1.9252381,0.3819801,2.6466651,0.4479191,1.374721,0.4434976,1.5585388,1.5108327,3.6009613,1.9451299,9.2297022),(7106,'ulna-cleaned.tif',183,4,630,3.4054029,5.4434805,10.4803733,1.8,5.4408997,10.4614713,1.0913975,0.8425381,1.9190127,0.3776824,2.6416513,0.4468185,1.3765679,0.4482675,1.5592594,1.5003186,3.586564,1.9347753,9.3756107),(7107,'ulna-cleaned.tif',183,4,631,3.4016316,5.4426422,10.4738733,1.8,5.4380808,10.4543615,1.0892426,0.8556902,1.9123014,0.3772438,2.6446653,0.4453222,1.3829752,0.4408649,1.5657641,1.5030894,3.586564,1.9347753,9.3482277),(7108,'ulna-cleaned.tif',183,4,632,3.3876178,5.4430173,10.4653177,1.8,5.4386418,10.4451923,1.0890092,0.8512208,1.9233208,0.3729738,2.6392697,0.4433794,1.3722462,0.4381634,1.5558847,1.5030894,3.6009613,1.9451299,9.4280277),(7109,'ulna-cleaned.tif',183,4,633,3.3810425,5.4439811,10.4597853,1.8,5.4412388,10.4424457,1.0879496,0.8470063,1.9354455,0.3706967,2.6437358,0.4420281,1.3659572,0.4376552,1.542114,1.4892325,3.6100131,1.9205116,9.2627564),(7110,'ulna-cleaned.tif',183,4,634,3.3795911,5.4438489,10.4495702,1.8,5.4404066,10.4300263,1.0883677,0.8426989,1.9432846,0.3700609,2.6555067,0.442032,1.3665043,0.4391377,1.5359407,1.4876525,3.6381275,1.9411198,9.3522378),(7111,'ulna-cleaned.tif',183,4,635,3.3699108,5.4415611,10.44159,1.8,5.4362601,10.4221493,1.0890061,0.8415143,1.9369768,0.3671141,2.6510223,0.4410604,1.3686391,0.4362541,1.5386477,1.4940687,3.6475236,1.9167636,9.305492),(7112,'ulna-cleaned.tif',183,4,636,3.3678971,5.4422843,10.4313457,1.8,5.4375021,10.4085437,1.0892311,0.8363017,1.9451661,0.3658438,2.6658889,0.4409006,1.3705199,0.4374543,1.5428866,1.4940687,3.6309001,1.9655874,9.3852921),(7113,'ulna-cleaned.tif',183,4,637,3.3541701,5.4432212,10.4260379,1.8,5.4399376,10.4052256,1.0883151,0.8322964,1.9406432,0.3613226,2.6592728,0.4386829,1.3703048,0.4341274,1.5408974,1.4920352,3.6157415,1.955401,9.2530751),(7114,'ulna-cleaned.tif',183,4,638,3.3472493,5.444057,10.4192082,1.8,5.4414719,10.4000592,1.0876659,0.8278753,1.9516009,0.3599402,2.6591032,0.4374799,1.3625241,0.4347758,1.5255603,1.4672868,3.6381275,1.9411198,9.3756107),(7115,'ulna-cleaned.tif',183,4,639,3.3490067,5.4432427,10.4099552,1.8,5.4394389,10.3886243,1.0876296,0.8074734,1.9447583,0.3593825,2.6635177,0.4376929,1.3695881,0.4450705,1.5345233,1.456658,3.6381275,1.9411198,9.3852921),(7116,'ulna-cleaned.tif',183,4,640,3.3500408,5.4422156,10.4005796,1.8,5.4375003,10.3779849,1.0852738,0.8189213,1.9520958,0.3601199,2.6778652,0.436744,1.3717898,0.4397491,1.5291379,1.4632197,3.6381275,1.9411198,9.3619192),(7117,'ulna-cleaned.tif',183,4,641,3.3502739,5.4438085,10.3934399,1.8,5.4408287,10.3723341,1.0855122,0.851598,1.9632741,0.3608794,2.6832173,0.4368843,1.3667054,0.4237673,1.5279074,1.5015094,3.6475236,1.9167636,9.4263666),(7118,'ulna-cleaned.tif',183,4,642,3.338818,5.4420235,10.3856024,1.8,5.4383541,10.3654973,1.0849048,0.8324162,1.9719526,0.3571212,2.6845294,0.4351114,1.3613559,0.4290176,1.5128473,1.4937411,3.6718842,1.9028558,9.5255293),(7119,'ulna-cleaned.tif',183,4,643,3.3237252,5.4419575,10.3753881,1.8,5.4393368,10.3536125,1.0856805,0.8282522,1.9651048,0.3523173,2.6929247,0.4334992,1.3703721,0.4253744,1.5220568,1.4837857,3.6718842,1.9028558,9.4514005),(7120,'ulna-cleaned.tif',183,4,644,3.3076591,5.4410877,10.3679621,1.8,5.4379364,10.3459245,1.0848251,0.8063129,1.9578779,0.3474049,2.6844696,0.4310145,1.3711118,0.4308562,1.5209728,1.4702441,3.6475236,1.9167636,9.3949734),(7121,'ulna-cleaned.tif',183,4,645,3.2993928,5.4425218,10.3613961,1.8,5.4398265,10.3374929,1.0846908,0.8371548,1.96934,0.3454282,2.6912095,0.4298763,1.366554,0.4126217,1.5071834,1.4797186,3.6590716,1.8925469,9.5118378),(7122,'ulna-cleaned.tif',183,4,646,3.2890426,5.4408254,10.3535416,1.8,5.4363887,10.3279298,1.0849693,0.7999193,1.9783506,0.3419793,2.6978741,0.4286539,1.3636986,0.4275173,1.5065781,1.4387218,3.6718842,1.9028558,9.3095022),(7123,'ulna-cleaned.tif',183,4,647,3.2818541,5.439431,10.3457254,1.8,5.4343801,10.3211984,1.083275,0.7961986,1.9722468,0.3404175,2.6929123,0.4269508,1.3654033,0.4275535,1.5092468,1.4387218,3.6753511,1.9371907,9.3385463),(7124,'ulna-cleaned.tif',183,4,648,3.2766367,5.4393155,10.3385396,1.8,5.4348621,10.3150381,1.0836953,0.793261,1.9825556,0.3392643,2.6960379,0.426462,1.3598801,0.427683,1.5066096,1.4409932,3.6898334,1.9472867,9.2667666),(7125,'ulna-cleaned.tif',183,4,649,3.2658796,5.4403128,10.333286,1.8,5.4357435,10.310342,1.0833428,0.7917693,2.0135074,0.3373437,2.6824098,0.4249032,1.3322075,0.4260632,1.4744928,1.4494886,3.7046888,1.9573026,9.2200208),(7126,'ulna-cleaned.tif',183,4,650,3.2597119,5.4422679,10.3272479,1.8,5.4399246,10.3056497,1.0818312,0.8191266,2.0085271,0.3347216,2.6945514,0.4234204,1.3415559,0.4086323,1.4828873,1.4649075,3.7126302,1.9333406,9.4320378),(7127,'ulna-cleaned.tif',183,4,651,3.2516632,5.4401994,10.3180531,1.8,5.4353662,10.292922,1.0817143,0.800062,1.9993949,0.3315207,2.7029061,0.4223223,1.351862,0.4143688,1.4806821,1.4454698,3.6986677,1.9232539,9.5352107),(7128,'ulna-cleaned.tif',183,4,652,3.2405046,5.4402708,10.3099646,1.8,5.43604,10.2849643,1.0811225,0.7957445,1.9920709,0.3279525,2.7017666,0.4206078,1.3562602,0.4121329,1.4840268,1.4553798,3.6850843,1.9130919,9.4126751),(7129,'ulna-cleaned.tif',183,4,653,3.2444226,5.4401049,10.3006848,1.8,5.4370292,10.2767291,1.0808263,0.807725,2.0001245,0.3288967,2.7223095,0.4209834,1.36107,0.4071889,1.4932251,1.4414705,3.6986677,1.9232539,9.4650921),(7130,'ulna-cleaned.tif',183,4,654,3.2393788,5.4388468,10.2928213,1.8,5.4347317,10.2689492,1.0803213,0.8047113,1.9947772,0.3272304,2.7280371,0.4201024,1.3675898,0.4066433,1.5010165,1.4306979,3.6986677,1.9232539,9.4884649),(7131,'ulna-cleaned.tif',183,4,655,3.2261692,5.4378032,10.2831102,1.8,5.4330164,10.257296,1.0800765,0.7820466,2.0020283,0.32404,2.7227423,0.4182799,1.3599919,0.4143486,1.4953982,1.417176,3.6986677,1.9232539,9.4514005),(7132,'ulna-cleaned.tif',183,4,656,3.2147067,5.4381824,10.2801793,1.8,5.4337234,10.2586906,1.0777792,0.7809153,1.9987518,0.3213013,2.7114018,0.415769,1.3565475,0.411442,1.4904504,1.4221078,3.7046888,1.9573026,9.4554107),(7133,'ulna-cleaned.tif',183,4,657,3.2055887,5.4381624,10.2708298,1.8,5.4340654,10.2470794,1.0779775,0.7929427,2.0068558,0.3201395,2.7096299,0.4146781,1.3501867,0.403736,1.4761572,1.4306979,3.7269677,1.9433506,9.6440548),(7134,'ulna-cleaned.tif',183,4,658,3.2024599,5.4375129,10.2612949,1.8,5.4325443,10.2354051,1.0786542,0.7895915,2.0147477,0.3178019,2.7299541,0.4145743,1.3549856,0.4024891,1.4716962,1.4324031,3.7361403,1.9195673,9.4884649),(7135,'ulna-cleaned.tif',183,4,659,3.1923142,5.4380444,10.2549479,1.8,5.4335736,10.2293604,1.0767459,0.7844556,2.0112061,0.3145592,2.7328249,0.4124142,1.358799,0.4009905,1.4757914,1.4319258,3.7361403,1.9195673,9.4924751),(7136,'ulna-cleaned.tif',183,4,660,3.1847948,5.4368171,10.2451173,1.8,5.432007,10.2174552,1.0784268,0.784922,2.0189153,0.3133307,2.7344595,0.4121869,1.3544201,0.399187,1.4754043,1.4411829,3.7269677,1.9433506,9.5779463),(7137,'ulna-cleaned.tif',183,4,661,3.1773774,5.4370489,10.2378645,1.8,5.4323002,10.2096952,1.0772693,0.7803626,2.0147957,0.3113861,2.7344026,0.4107158,1.3571612,0.3990274,1.4793819,1.4094526,3.7126302,1.9333406,9.5682649),(7138,'ulna-cleaned.tif',183,4,662,3.1703427,5.4368289,10.2310765,1.8,5.4313876,10.2039583,1.0779065,0.7752461,2.0252032,0.3094616,2.7404209,0.4100873,1.3531585,0.3991786,1.4778991,1.4071181,3.7361403,1.9195673,9.3893022),(7139,'ulna-cleaned.tif',183,4,663,3.1648756,5.4376616,10.2244983,1.8,5.4335205,10.1984776,1.0758571,0.807455,2.0189929,0.3099638,2.7379776,0.4084777,1.3561105,0.3838774,1.4696296,1.4311752,3.7361403,1.9195673,9.5585836),(7140,'ulna-cleaned.tif',183,4,664,3.1565542,5.4365442,10.2162888,1.8,5.4327011,10.1928984,1.0758621,0.8045431,2.0274003,0.3079547,2.7368751,0.4074059,1.3499431,0.3827696,1.4664671,1.4311752,3.7416756,1.9532829,9.677109),(7141,'ulna-cleaned.tif',183,4,665,3.150931,5.4361049,10.2056425,1.8,5.4318189,10.180294,1.0764044,0.7814013,2.0721178,0.3052882,2.7543672,0.4069181,1.3292522,0.3906932,1.4463319,1.417176,3.7936488,1.959115,9.9261904),(7142,'ulna-cleaned.tif',183,4,666,3.1504039,5.4348583,10.1946332,1.8,5.4297189,10.1669815,1.077485,0.7971356,2.0785382,0.3042937,2.7801484,0.4073237,1.3375498,0.3817339,1.4468492,1.4394503,3.8158255,1.9454775,9.6013192),(7143,'ulna-cleaned.tif',183,4,667,3.1477878,5.4331768,10.1862026,1.8,5.4269817,10.1583302,1.076429,0.7747768,2.0698178,0.303131,2.7897378,0.406523,1.3478181,0.3912494,1.4566606,1.4338877,3.8014044,1.9357094,9.5545734),(7144,'ulna-cleaned.tif',183,4,668,3.1391466,5.43392,10.1780663,1.8,5.4281864,10.1490598,1.0764358,0.7891996,2.0630115,0.302168,2.791989,0.4054099,1.353356,0.3828791,1.4625316,1.4470067,3.8014044,1.9357094,9.7278649),(7145,'ulna-cleaned.tif',183,4,669,3.1323617,5.435285,10.1715777,1.8,5.4311708,10.1430102,1.0769537,0.7853749,2.0771008,0.2998946,2.8079845,0.4047595,1.3518769,0.381849,1.4654186,1.4377816,3.8014044,1.9357094,9.8036548),(7146,'ulna-cleaned.tif',183,4,670,3.117212,5.4345044,10.1659275,1.8,5.4301414,10.1388542,1.076705,0.7831639,2.0716496,0.2962138,2.7949281,0.402694,1.3491317,0.378227,1.4614109,1.4071181,3.8014044,1.9357094,9.7004819),(7147,'ulna-cleaned.tif',183,4,671,3.1148941,5.4344798,10.1566155,1.8,5.4299464,10.1297834,1.076097,0.7782265,2.0793557,0.2961951,2.8094504,0.4021309,1.3511159,0.3806027,1.455625,1.4071181,3.824785,1.9222411,9.756909),(7148,'ulna-cleaned.tif',183,4,672,3.1101021,5.4334784,10.1478007,1.8,5.4279741,10.1196567,1.0767765,0.7755353,2.0903635,0.2948698,2.8200582,0.4018064,1.3490756,0.3802145,1.4584683,1.4071181,3.8158255,1.9454775,9.6577463),(7149,'ulna-cleaned.tif',183,4,673,3.0995731,5.4320322,10.13884,1.8,5.4269712,10.1117758,1.0773876,0.7731156,2.0820539,0.2924736,2.8122479,0.4007096,1.3507085,0.3783052,1.459843,1.4169515,3.8158255,1.9454775,9.9495633),(7150,'ulna-cleaned.tif',183,4,674,3.10333,5.4326849,10.1320911,1.8,5.4281819,10.1056183,1.0763994,0.7684397,2.0921828,0.2937845,2.8325081,0.4007686,1.3538531,0.382313,1.4555097,1.4251544,3.8529851,1.9416876,9.8036548),(7151,'ulna-cleaned.tif',183,4,675,3.0927147,5.4327623,10.123894,1.8,5.427351,10.0953088,1.0758351,0.7639612,2.1008907,0.2917118,2.8299431,0.3991547,1.3470206,0.3818411,1.4395323,1.4251544,3.8622706,1.9186847,10.0333734),(7152,'ulna-cleaned.tif',183,4,676,3.0787452,5.4343971,10.1196074,1.8,5.4295033,10.0924208,1.0757458,0.7604037,2.0978473,0.287788,2.8246169,0.3973134,1.3464359,0.3784674,1.4377607,1.4251544,3.8622706,1.9186847,9.9769463),(7153,'ulna-cleaned.tif',183,4,677,3.0675138,5.4332738,10.1079878,1.8,5.4284739,10.0789553,1.0779587,0.7579439,2.1071336,0.2861851,2.8237092,0.3968086,1.3400713,0.3775808,1.4375691,1.4251544,3.8622706,1.9186847,10.0390446),(7154,'ulna-cleaned.tif',183,4,678,3.0556227,5.4336543,10.1008513,1.8,5.4292777,10.071525,1.0783658,0.7546153,2.1175199,0.2831456,2.8235919,0.3954431,1.3334429,0.3752185,1.4217865,1.3871097,3.8865141,1.9055332,9.6851293),(7155,'ulna-cleaned.tif',183,4,679,3.0507914,5.4336249,10.0954667,1.8,5.4285825,10.0677591,1.0786781,0.752391,2.1154685,0.2818836,2.836742,0.3949502,1.3409521,0.3746504,1.4306532,1.3871097,3.8865141,1.9055332,9.8504005),(7156,'ulna-cleaned.tif',183,4,680,3.0467474,5.4334032,10.0868687,1.8,5.4285793,10.0591586,1.0785656,0.7672731,2.1077362,0.2820344,2.8539431,0.3943791,1.3540324,0.3675802,1.4441762,1.3992008,3.8622706,1.9186847,9.8407192),(7157,'ulna-cleaned.tif',183,4,681,3.0348842,5.4320592,10.0766172,1.8,5.4263226,10.0479758,1.0793249,0.7643172,2.1147473,0.280494,2.8587321,0.3931632,1.3518079,0.3669864,1.445836,1.4166084,3.8826207,1.9608444,9.9729362),(7158,'ulna-cleaned.tif',183,4,682,3.0276059,5.4306598,10.0659707,1.8,5.4234057,10.0339558,1.0810779,0.7434008,2.1219955,0.2789336,2.8723473,0.3929555,1.3536067,0.3752129,1.4394345,1.4037117,3.9134559,1.9247938,9.8931362),(7159,'ulna-cleaned.tif',183,4,683,3.0167621,5.4302263,10.0591806,1.8,5.421956,10.0268878,1.0805311,0.7564676,2.1178808,0.2775256,2.8679978,0.3913198,1.3541828,0.3668705,1.4412132,1.4155966,3.8901989,1.9379702,9.9495633),(7160,'ulna-cleaned.tif',183,4,684,3.012661,5.4327511,10.054089,1.8,5.426595,10.0241739,1.0807577,0.7520773,2.1311031,0.2769927,2.8779662,0.3908823,1.3504584,0.3683035,1.4418208,1.4155966,3.8901989,1.9379702,9.7512378),(7161,'ulna-cleaned.tif',183,4,685,3.0026599,5.4316443,10.0446839,1.8,5.4238978,10.0131604,1.0817593,0.7496725,2.1392558,0.274678,2.884705,0.3900007,1.3484619,0.3663973,1.4311642,1.4244089,3.9134559,1.9247938,9.9438921),(7162,'ulna-cleaned.tif',183,4,686,2.990178,5.4313646,10.0356543,1.8,5.4226208,10.0012787,1.0832911,0.7472869,2.1506694,0.2715326,2.8904586,0.389012,1.3439809,0.3633579,1.4316935,1.417657,3.9134559,1.9247938,9.8874649),(7163,'ulna-cleaned.tif',183,4,687,2.9748815,5.4324501,10.0303972,1.8,5.4240018,9.9970216,1.0839131,0.7445211,2.1447702,0.2681099,2.8847995,0.3872772,1.3450389,0.3601105,1.4179296,1.3949377,3.9242214,1.9021929,10.0196819),(7164,'ulna-cleaned.tif',183,4,688,2.9659055,5.4328988,10.0233509,1.8,5.4253878,9.9911985,1.0829768,0.739835,2.1403621,0.2672256,2.8805821,0.3857256,1.3458387,0.3611962,1.4199637,1.3949377,3.9242214,1.9021929,9.6093395),(7165,'ulna-cleaned.tif',183,4,689,2.9598397,5.4337274,10.01627,1.8,5.4268168,9.9836509,1.0819341,0.7534099,2.15047,0.2675448,2.8825972,0.3845106,1.3404498,0.3551118,1.4194855,1.4037117,3.9418293,1.943784,9.8640921),(7166,'ulna-cleaned.tif',183,4,690,2.9461318,5.4342837,10.0112184,1.8,5.4269977,9.9788448,1.0816662,0.7337947,2.1461252,0.2641147,2.8681115,0.3826207,1.3364138,0.35993,1.414456,1.4010603,3.9274656,1.9343232,10.0196819),(7167,'ulna-cleaned.tif',183,4,691,2.9376167,5.433247,10.004985,1.8,5.4240637,9.971166,1.0816061,0.7504711,2.140103,0.2627133,2.8607942,0.3814904,1.3367554,0.3500645,1.4145438,1.4019457,3.9274656,1.9343232,9.9011565),(7168,'ulna-cleaned.tif',183,4,692,2.9222421,5.4344072,9.9991792,1.8,5.4266612,9.9670885,1.080776,0.7459235,2.1350742,0.2590867,2.8448925,0.3791582,1.3324561,0.3473368,1.4091213,1.4019457,3.9134559,1.9247938,9.8971463),(7169,'ulna-cleaned.tif',183,4,693,2.9129941,5.4359874,9.9951112,1.8,5.4299065,9.9669195,1.0796617,0.7202732,2.1177134,0.2576465,2.8320773,0.3775086,1.337328,0.3577067,1.4234446,1.3992619,3.8901989,1.9379702,10.1188446),(7170,'ulna-cleaned.tif',183,4,694,2.9040383,5.4359837,9.9856469,1.8,5.4281165,9.9526272,1.0810474,0.7196576,2.1615595,0.2561307,2.8334112,0.3769053,1.3108181,0.3559064,1.3975873,1.4046075,3.9274656,1.9343232,9.9826175),(7171,'ulna-cleaned.tif',183,4,695,2.9047167,5.4366805,9.9772664,1.8,5.428619,9.9415553,1.0804971,0.7333322,2.1706501,0.2561669,2.8503228,0.3767721,1.3131194,0.349319,1.3926531,1.4090758,3.9509061,1.921293,10.0527362),(7172,'ulna-cleaned.tif',183,4,696,2.8905257,5.437001,9.9723424,1.8,5.4299757,9.9397525,1.0811231,0.7313447,2.1690984,0.2540303,2.843469,0.3751819,1.310899,0.3473468,1.3915416,1.388825,3.9509061,1.921293,10.1889633),(7173,'ulna-cleaned.tif',183,4,697,2.8882141,5.4349558,9.9602457,1.8,5.4267855,9.9232743,1.0844386,0.7307457,2.1754548,0.254968,2.8724561,0.3762037,1.3203933,0.3489148,1.394548,1.406917,3.9509061,1.921293,10.2824548),(7174,'ulna-cleaned.tif',183,4,698,2.8750849,5.4349727,9.9530454,1.8,5.4275425,9.9184957,1.0852463,0.7281697,2.1861355,0.2530742,2.8743103,0.3748133,1.3147905,0.3475484,1.3928215,1.406917,3.9565433,1.9531754,10.1929734),(7175,'ulna-cleaned.tif',183,4,699,2.8761488,5.4360876,9.9469473,1.8,5.4287604,9.9125764,1.086889,0.7427358,2.1839022,0.2520906,2.8994942,0.3756013,1.3276667,0.3394082,1.3946448,1.4028942,3.9884038,1.9178579,10.4243531),(7176,'ulna-cleaned.tif',183,4,700,2.867319,5.4362452,9.9419442,1.8,5.4276839,9.9064285,1.0874512,0.740863,2.1948076,0.2515327,2.8934369,0.3746693,1.3183101,0.3395132,1.3891779,1.4114852,3.9790125,1.94013,10.2824548),(7177,'ulna-cleaned.tif',183,4,701,2.8611363,5.4351148,9.9328363,1.8,5.4248945,9.8937149,1.0895298,0.7414164,2.1889319,0.2507948,2.9119033,0.3746761,1.330285,0.3382644,1.4026592,1.4160534,3.9647834,1.9307449,10.4146718),(7178,'ulna-cleaned.tif',183,4,702,2.8464174,5.4349961,9.9261921,1.8,5.4249041,9.8874129,1.0906336,0.7395283,2.2004458,0.2506229,2.9010913,0.373178,1.3184107,0.3388956,1.3958046,1.4160534,3.9790125,1.94013,10.4340345),(7179,'ulna-cleaned.tif',183,4,703,2.8415538,5.436721,9.9229238,1.8,5.4269343,9.8869819,1.0926711,0.7371966,2.2164322,0.2478636,2.9148389,0.3733299,1.315104,0.3362245,1.3845238,1.4068729,4.0126787,1.9051248,10.2687633),(7180,'ulna-cleaned.tif',183,4,704,2.8278734,5.4372591,9.9142775,1.8,5.4267518,9.8758398,1.0935361,0.7336721,2.210691,0.2450509,2.9209427,0.3718654,1.3212804,0.3340061,1.3910098,1.411838,3.9884038,1.9178579,10.0140107),(7181,'ulna-cleaned.tif',183,4,705,2.8211158,5.4375319,9.9066604,1.8,5.4275395,9.8694703,1.094663,0.7311513,2.2045599,0.2435161,2.9186076,0.3714088,1.3238958,0.3330585,1.3938066,1.411838,3.9884038,1.9178579,10.2824548),(7182,'ulna-cleaned.tif',183,4,706,2.814461,5.4389179,9.9006406,1.8,5.4293242,9.8641761,1.0941977,0.7266544,2.2167858,0.2432155,2.9210362,0.3703548,1.3176899,0.3347059,1.3921867,1.3849131,3.9935895,1.9494474,10.0664277),(7183,'ulna-cleaned.tif',183,4,707,2.8007961,5.4405461,9.8951166,1.8,5.4308681,9.8575862,1.0948965,0.7234361,2.2301583,0.2416122,2.9157426,0.3688224,1.3074151,0.3339787,1.3745708,1.3849131,4.0162478,1.9365436,10.3058277),(7184,'ulna-cleaned.tif',183,4,708,2.7745516,5.440759,9.8893791,1.8,5.4302805,9.851673,1.0941791,0.7198317,2.2259198,0.2376985,2.8804471,0.3650961,1.294048,0.3302139,1.3607775,1.3849131,4.0162478,1.9365436,10.0664277),(7185,'ulna-cleaned.tif',183,4,709,2.772476,5.4409484,9.880717,1.8,5.4302702,9.841187,1.0964307,0.718174,2.2365988,0.2375299,2.8935449,0.3656698,1.2937255,0.3307415,1.3656641,1.3973346,4.0162478,1.9365436,10.315509),(7186,'ulna-cleaned.tif',183,4,710,2.7713878,5.4413103,9.8716594,1.8,5.4303481,9.8303733,1.0991524,0.7438446,2.3366898,0.237754,2.9222453,0.366546,1.2505919,0.3196287,1.305069,1.3973346,4.0162478,1.9365436,10.3388819),(7187,'ulna-cleaned.tif',183,4,711,2.7616892,5.442805,9.8661944,1.8,5.4312506,9.8232031,1.0993102,0.7396707,2.3318871,0.2366841,2.9246973,0.365322,1.2542191,0.3199857,1.3083653,1.4011251,4.0162478,1.9365436,10.4009803),(7188,'ulna-cleaned.tif',183,4,712,2.7510641,5.4419018,9.8630283,1.8,5.4294075,9.8224315,1.0973617,0.7284789,2.3274196,0.2324006,2.9017697,0.3631925,1.2467755,0.3190218,1.2988691,1.3924941,4.0162478,1.9365436,10.2590819),(7189,'ulna-cleaned.tif',183,4,713,2.7464215,5.4435656,9.8569177,1.8,5.4327647,9.8173879,1.0967878,0.7760028,2.3223762,0.232715,2.9033054,0.3623663,1.2501443,0.2998894,1.3026798,1.3924941,4.0021511,1.9272333,10.3251904),(7190,'ulna-cleaned.tif',183,4,714,2.7286305,5.4436466,9.8508961,1.8,5.4329223,9.8129278,1.0961819,0.7201057,2.2121601,0.2286886,2.8709053,0.359795,1.2977837,0.3175764,1.3617583,1.3769407,3.9884038,1.9178579,10.2453904),(7191,'ulna-cleaned.tif',183,4,715,2.7258116,5.4459081,9.8457913,1.8,5.4366887,9.8092356,1.0949371,0.7326746,2.2941035,0.2284916,2.879775,0.3589631,1.2552943,0.3118596,1.301083,1.3849131,4.0162478,1.9365436,10.5138345),(7192,'ulna-cleaned.tif',183,4,716,2.7078656,5.4462033,9.8395546,1.8,5.4353814,9.8000161,1.0956085,0.7302714,2.2202404,0.2250835,2.8608194,0.3568465,1.2885179,0.308219,1.3516456,1.3973346,4.0162478,1.9365436,10.2494006),(7193,'ulna-cleaned.tif',183,4,717,2.7023859,5.4490847,9.8354464,1.8,5.4400214,9.7961891,1.0935701,0.7236494,2.3037869,0.2261948,2.862451,0.3553763,1.2424981,0.3125751,1.2936695,1.3780888,4.0162478,1.9365436,10.1365463),(7194,'ulna-cleaned.tif',183,4,718,2.6819177,5.4510723,9.8339125,1.8,5.4434042,9.798981,1.0921257,0.73801,2.3024333,0.2229931,2.8321651,0.3521573,1.2300748,0.3021545,1.2802231,1.3813262,4.0395672,1.9237867,10.5081633),(7195,'ulna-cleaned.tif',183,4,719,2.6619611,5.4493394,9.82485,1.8,5.4375284,9.7846609,1.091438,0.7346549,2.2237566,0.2192524,2.7970549,0.3492872,1.2578062,0.2984428,1.3233005,1.3813262,4.0021511,1.9272333,10.3388819),(7196,'ulna-cleaned.tif',183,4,720,2.6558469,5.4517776,9.8200623,1.8,5.4414146,9.7814316,1.0898391,0.7286053,2.2029224,0.2181741,2.7942785,0.347905,1.2684417,0.2994407,1.3297278,1.3813262,3.9884038,1.9178579,10.4380447),(7197,'ulna-cleaned.tif',183,4,721,2.6481445,5.4545346,9.8172687,1.8,5.4440263,9.7780653,1.0885613,0.7235249,2.2180003,0.2182795,2.7867772,0.346433,1.2564368,0.301689,1.3218408,1.3813262,3.9790125,1.94013,10.0898006),(7198,'ulna-cleaned.tif',183,4,722,2.6312464,5.4554652,9.8146982,1.8,5.4445164,9.7772898,1.0894552,0.7224503,2.2181762,0.2143669,2.7753067,0.3445443,1.251166,0.296722,1.3163728,1.3813262,3.9870065,1.971746,10.1462277),(7199,'ulna-cleaned.tif',183,4,723,2.6267666,5.456659,9.8096231,1.8,5.4456988,9.7710841,1.0894576,0.7359391,2.2295471,0.2135696,2.7759154,0.3439586,1.2450579,0.2902001,1.3024729,1.3790309,4.0085107,1.9586963,10.4574074),(7200,'ulna-cleaned.tif',183,4,724,2.6149384,5.4565315,9.802675,1.8,5.4449061,9.7629038,1.0911056,0.6992789,2.2256511,0.2114544,2.7719881,0.3429986,1.2454729,0.3023892,1.3036893,1.3575968,4.0162478,1.9365436,10.4807803),(7201,'ulna-cleaned.tif',183,4,725,2.6059968,5.4576151,9.7962464,1.8,5.4450796,9.7539453,1.0911329,0.6953809,2.2374445,0.2103374,2.7707081,0.3418354,1.238336,0.302478,1.3003914,1.3462253,4.0085107,1.9586963,10.447726),(7202,'ulna-cleaned.tif',183,4,726,2.591663,5.4592434,9.7912721,1.8,5.4470435,9.7496234,1.0898807,0.7256288,2.2347016,0.208777,2.7534546,0.3395119,1.2321353,0.2877188,1.2946615,1.3590809,3.9935895,1.9494474,10.0994819),(7203,'ulna-cleaned.tif',183,4,727,2.5779556,5.4608385,9.7877972,1.8,5.4493449,9.7482548,1.0903705,0.7231598,2.2495004,0.2079953,2.741108,0.3378888,1.2185408,0.2876201,1.2845809,1.3675775,4.0085107,1.9586963,10.3251904),(7204,'ulna-cleaned.tif',183,4,728,2.5702998,5.4616315,9.7832783,1.8,5.4481638,9.7416833,1.0905947,0.7206217,2.2105743,0.20719,2.7320203,0.3369641,1.2358871,0.2875156,1.2943079,1.3675775,3.9647834,1.9307449,10.2784446),(7205,'ulna-cleaned.tif',183,4,729,2.5588971,5.4628979,9.7786209,1.8,5.4489258,9.7365944,1.0897176,0.6994433,2.2235556,0.2059756,2.7170806,0.3351625,1.2219531,0.2944851,1.2838614,1.3662277,3.9790125,1.94013,10.1929734),(7206,'ulna-cleaned.tif',183,4,730,2.5447088,5.4656831,9.7765441,1.8,5.452879,9.7338744,1.0899953,0.6963137,2.2246685,0.2034819,2.7036014,0.3334007,1.2152828,0.2922274,1.2775609,1.3624373,3.9790125,1.94013,10.3485633),(7207,'ulna-cleaned.tif',183,4,731,2.5341883,5.4683037,9.7733601,1.8,5.4577306,9.7328351,1.0888896,0.7098114,2.2394858,0.2008105,2.6961647,0.3316391,1.2039213,0.2829068,1.2683898,1.3500158,4.0085107,1.9586963,10.6226786),(7208,'ulna-cleaned.tif',183,4,732,2.5309392,5.4694448,9.7677897,1.8,5.4579781,9.7254998,1.0877292,0.7049955,2.2345607,0.2003936,2.6878953,0.3308115,1.2028741,0.2842481,1.2673752,1.3387934,4.0085107,1.9586963,10.2784446),(7209,'ulna-cleaned.tif',183,4,733,2.5155641,5.4710657,9.7636237,1.8,5.4609418,9.7229058,1.0867372,0.7191444,2.2311825,0.1988044,2.6705304,0.3284594,1.1969126,0.2764457,1.2610168,1.3571103,3.9870065,1.971746,10.3582446),(7210,'ulna-cleaned.tif',183,4,734,2.5132765,5.4713693,9.7581154,1.8,5.4615222,9.7189465,1.0867273,0.7330491,2.2450128,0.1979553,2.6847146,0.3281573,1.1958571,0.2700438,1.2633057,1.3683398,4.0085107,1.9586963,10.3251904),(7211,'ulna-cleaned.tif',183,4,735,2.5048703,5.4707098,9.7506619,1.8,5.4597349,9.7113736,1.0890239,0.6973028,2.2189294,0.1969407,2.6789512,0.3278484,1.207317,0.2824321,1.261266,1.3382529,3.9790125,1.94013,10.2026548),(7212,'ulna-cleaned.tif',183,4,736,2.5006365,5.4690386,9.7419014,1.8,5.4557745,9.7011022,1.0905148,0.6963289,2.2126519,0.1952543,2.6844046,0.327804,1.213207,0.2804053,1.2678679,1.3382529,3.9647834,1.9307449,10.2026548),(7213,'ulna-cleaned.tif',183,4,737,2.4971284,5.4716036,9.7403389,1.8,5.4600992,9.7041076,1.0897527,0.6925122,2.2290352,0.1962414,2.6843183,0.3270841,1.2042512,0.283376,1.2630597,1.3328503,3.9790125,1.94013,10.1889633),(7214,'ulna-cleaned.tif',183,4,738,2.4923702,5.4709365,9.7335404,1.8,5.4566675,9.6915222,1.0894147,0.6895919,2.2394291,0.1945091,2.6841217,0.3263456,1.1985741,0.2820641,1.2503292,1.3328503,4.0085107,1.9586963,10.2260277),(7215,'ulna-cleaned.tif',183,4,739,2.4906611,5.4726655,9.7311422,1.8,5.4611705,9.6940755,1.0893159,0.6868419,2.2396424,0.1947472,2.68306,0.3260881,1.1979859,0.28354,1.2510045,1.3328503,4.0085107,1.9586963,10.2590819),(7216,'ulna-cleaned.tif',183,4,740,2.48511,5.4719613,9.7237696,1.8,5.4600222,9.6876086,1.090107,0.6849148,2.2331292,0.1927361,2.6815482,0.3256302,1.200803,0.2814016,1.2586708,1.3328503,4.0085107,1.9586963,10.3348718),(7217,'ulna-cleaned.tif',183,4,741,2.4682096,5.4753995,9.7221922,1.8,5.4651742,9.6872558,1.0888455,0.715116,2.2496317,0.1912271,2.6638947,0.3229898,1.184147,0.2674071,1.2399538,1.3501031,4.0085107,1.9586963,10.3719362),(7218,'ulna-cleaned.tif',183,4,742,2.4498887,5.4742663,9.7151764,1.8,5.4624663,9.679868,1.0893801,0.713465,2.244736,0.1886228,2.6459402,0.3207716,1.1787311,0.2643757,1.2348146,1.3501031,3.9935895,1.9494474,10.3485633),(7219,'ulna-cleaned.tif',183,4,743,2.4437555,5.4738687,9.7074461,1.8,5.4606374,9.6683578,1.090348,0.7113246,2.2550236,0.1861231,2.6502838,0.3202919,1.1752799,0.261657,1.2338274,1.3354986,4.0085107,1.9586963,10.5235159),(7220,'ulna-cleaned.tif',183,4,744,2.4199046,5.4762803,9.7057622,1.8,5.4639728,9.6688043,1.0885935,0.7064369,2.2538627,0.182818,2.6089509,0.3165851,1.1575466,0.2587888,1.214905,1.3102031,3.9935895,1.9494474,10.4106616),(7221,'ulna-cleaned.tif',183,4,745,2.4077633,5.4787736,9.7050093,1.8,5.4643738,9.6661545,1.0884919,0.6869224,2.2358001,0.1816778,2.5940922,0.3149632,1.1602523,0.2644808,1.2137522,1.3073036,3.9790125,1.94013,10.2590819),(7222,'ulna-cleaned.tif',183,4,746,2.4057879,5.4808945,9.7000111,1.8,5.4695671,9.6646883,1.088299,0.7010315,2.2339454,0.1822806,2.6032425,0.3146412,1.1653116,0.2600176,1.2202832,1.3155486,3.9870065,1.971746,10.2026548),(7223,'ulna-cleaned.tif',183,4,747,2.3998236,5.4804287,9.6924116,1.8,5.4669727,9.6537824,1.0903363,0.7000453,2.244718,0.1810817,2.6070061,0.3145301,1.1613958,0.2586713,1.219472,1.3155486,3.9870065,1.971746,10.3018175),(7224,'ulna-cleaned.tif',183,4,748,2.3970391,5.482066,9.6892772,1.8,5.4689922,9.6532524,1.0886663,0.6953977,2.241972,0.1809557,2.6081637,0.3136176,1.1633347,0.260219,1.2212776,1.3155486,3.9870065,1.971746,10.2590819),(7225,'ulna-cleaned.tif',183,4,749,2.391214,5.4846958,9.6865926,1.8,5.4736819,9.6521094,1.0880025,0.7096512,2.240526,0.1801353,2.5987246,0.312638,1.1598726,0.2538364,1.2177538,1.3261896,3.9870065,1.971746,10.3388819),(7226,'ulna-cleaned.tif',183,4,750,2.3861137,5.483107,9.678109,1.8,5.4716894,9.64362,1.0892514,0.6899149,2.2159271,0.1795716,2.589605,0.3123793,1.1686327,0.2602809,1.2241095,1.3155486,3.9565433,1.9531754,10.3018175),(7227,'ulna-cleaned.tif',183,4,751,2.3780198,5.4859386,9.6761764,1.8,5.4745377,9.641342,1.0880205,0.6852098,2.2301785,0.1778732,2.5893324,0.3109188,1.1610427,0.2595893,1.2088552,1.3191809,3.9790125,1.94013,10.447726),(7228,'ulna-cleaned.tif',183,4,752,2.3641858,5.4839587,9.6673514,1.8,5.4701211,9.6300085,1.089544,0.6844893,2.2237936,0.1750648,2.5795338,0.3096032,1.1599699,0.2557597,1.2081182,1.2846265,3.9647834,1.9307449,10.2220175),(7229,'ulna-cleaned.tif',183,4,753,2.3573331,5.4865908,9.6628808,1.8,5.4747571,9.6262256,1.0896167,0.6801643,2.2379821,0.1741062,2.5818519,0.3087293,1.1536517,0.2559767,1.2051126,1.2792809,3.9790125,1.94013,10.235709),(7230,'ulna-cleaned.tif',183,4,754,2.3556419,5.487966,9.6589552,1.8,5.4777037,9.625161,1.0889923,0.67646,2.2364663,0.1735486,2.5936421,0.3083065,1.1597055,0.256554,1.211829,1.2792809,3.9870065,1.971746,10.1696006),(7231,'ulna-cleaned.tif',183,4,755,2.3558853,5.4875176,9.6520832,1.8,5.475521,9.6155079,1.0884072,0.7083899,2.2467854,0.1740462,2.5958416,0.3081496,1.155358,0.2456926,1.2106522,1.2979233,3.9870065,1.971746,10.2687633),(7232,'ulna-cleaned.tif',183,4,756,2.3383902,5.4850994,9.6450373,1.8,5.4704141,9.6065572,1.0895018,0.6731034,2.2414664,0.1714085,2.5705902,0.3062116,1.1468341,0.254654,1.2023744,1.2792809,3.9870065,1.971746,10.155909),(7233,'ulna-cleaned.tif',183,4,757,2.3431944,5.4863814,9.6402557,1.8,5.4717892,9.6005408,1.0897065,0.6699761,2.2547976,0.1716131,2.5833095,0.3069063,1.1456946,0.2561481,1.204001,1.2792809,4.0027477,1.9809237,10.2550718),(7234,'ulna-cleaned.tif',183,4,758,2.3246525,5.4896139,9.6418272,1.8,5.4779697,9.6090226,1.0876637,0.7009541,2.221558,0.1703073,2.5422772,0.3038275,1.1443668,0.2429649,1.1963126,1.2979233,3.9565433,1.9531754,10.1034921),(7235,'ulna-cleaned.tif',183,4,759,2.3235064,5.4874145,9.6343693,1.8,5.4724252,9.5969546,1.089314,0.6659076,2.2314285,0.1689395,2.5525629,0.3042029,1.1439143,0.253698,1.1984011,1.2792809,3.9716037,1.9624963,9.9342107),(7236,'ulna-cleaned.tif',183,4,760,2.3102263,5.4861418,9.6270694,1.8,5.4691787,9.5868639,1.0900276,0.6644395,2.224668,0.1680228,2.5252807,0.3026897,1.135127,0.2528791,1.1898373,1.2889867,3.9565433,1.9531754,10.076109),(7237,'ulna-cleaned.tif',183,4,761,2.312276,5.4878895,9.6226429,1.8,5.4731373,9.5833115,1.0879695,0.6770983,2.220694,0.1689185,2.5321043,0.3023069,1.1402311,0.2494741,1.1952144,1.3045765,3.9565433,1.9531754,10.2550718),(7238,'ulna-cleaned.tif',183,4,762,2.3129197,5.4882854,9.6191599,1.8,5.4746438,9.581654,1.0875549,0.693226,2.2361595,0.1689568,2.5341125,0.3022595,1.1332432,0.2437255,1.1836513,1.3155486,3.9870065,1.971746,10.1832921),(7239,'ulna-cleaned.tif',183,4,763,2.3128666,5.4889226,9.6119756,1.8,5.477494,9.5754032,1.0880588,0.6898485,2.2471032,0.1687998,2.5520121,0.3024124,1.1356898,0.2446912,1.1890948,1.3155486,3.9870065,1.971746,10.0801192),(7240,'ulna-cleaned.tif',183,4,764,2.3068188,5.4877622,9.6053307,1.8,5.4746397,9.567436,1.0878711,0.687595,2.2405983,0.1675086,2.5413239,0.3015623,1.1342167,0.2436152,1.1873343,1.2756486,3.9870065,1.971746,10.3251904),(7241,'ulna-cleaned.tif',183,4,765,2.3046398,5.4904573,9.6020103,1.8,5.4790251,9.5649502,1.0876231,0.6834057,2.2573407,0.1675124,2.5489262,0.301199,1.1291722,0.2451142,1.1857197,1.2756486,3.9870065,1.971746,10.2534107),(7242,'ulna-cleaned.tif',183,4,766,2.3049098,5.4911237,9.5989249,1.8,5.4787346,9.5621426,1.0869268,0.6806492,2.2193271,0.1670575,2.5409743,0.3010141,1.14493,0.2454384,1.1956082,1.2756486,3.9565433,1.9531754,10.2534107),(7243,'ulna-cleaned.tif',183,4,767,2.2951014,5.4917925,9.5949476,1.8,5.4797338,9.5596844,1.085967,0.6771928,2.2324678,0.165773,2.5267365,0.2994306,1.1318132,0.2447943,1.1847303,1.2756486,3.9824119,1.9941071,10.1502378),(7244,'ulna-cleaned.tif',183,4,768,2.2895509,5.4943016,9.5917071,1.8,5.4834253,9.5571676,1.0854059,0.6728686,2.2305331,0.1652438,2.5102567,0.2985298,1.1254066,0.2455812,1.1784719,1.2756486,3.9824119,1.9941071,10.1462277),(7245,'ulna-cleaned.tif',183,4,769,2.2822134,5.494281,9.5884884,1.8,5.4830324,9.5557348,1.085985,0.6701118,2.2279203,0.1634337,2.5031813,0.2977548,1.1235507,0.2438902,1.1761552,1.2792809,3.9661886,1.9849349,10.0801192),(7246,'ulna-cleaned.tif',183,4,770,2.2778033,5.493247,9.5802718,1.8,5.4805087,9.5442519,1.0853317,0.6683868,2.2385136,0.1628827,2.5075583,0.2969748,1.120189,0.2436953,1.1758126,1.2756486,3.9824119,1.9941071,10.1075022),(7247,'ulna-cleaned.tif',183,4,771,2.2605993,5.4926027,9.5776279,1.8,5.478947,9.5426909,1.0843687,0.6666901,2.2002328,0.160804,2.4838231,0.2944321,1.128891,0.2411975,1.178046,1.2756486,3.9347551,1.9663675,10.0277022),(7248,'ulna-cleaned.tif',183,4,772,2.2540186,5.4929496,9.5723372,1.8,5.4790467,9.5368666,1.0825372,0.6619358,2.2115693,0.1596391,2.4781826,0.2930056,1.1205539,0.2411701,1.171634,1.2756486,3.9503016,1.9756881,10.0140107),(7249,'ulna-cleaned.tif',183,4,773,2.2493353,5.4925662,9.5666039,1.8,5.4773934,9.5297101,1.0835281,0.6606586,2.2067404,0.1584083,2.4728089,0.2927044,1.1205708,0.2397733,1.1716097,1.2700221,3.9347551,1.9663675,10.2026548),(7250,'ulna-cleaned.tif',183,4,774,2.2365754,5.4937097,9.5597005,1.8,5.4792644,9.5224387,1.0833469,0.6562187,2.2197892,0.1552011,2.4797391,0.2909881,1.1171057,0.2365082,1.1701771,1.2357486,3.9627752,2.0074235,10.2494006),(7251,'ulna-cleaned.tif',183,4,775,2.2359955,5.4957498,9.5581151,1.8,5.4842281,9.5266469,1.0829036,0.6884352,2.2191773,0.1557729,2.4778841,0.2907759,1.1165778,0.226271,1.1700567,1.2574217,3.9627752,2.0074235,10.154248),(7252,'ulna-cleaned.tif',183,4,776,2.2317548,5.4957636,9.5502057,1.8,5.4844154,9.5161761,1.0848023,0.6868318,2.2129009,0.1550971,2.4915808,0.2908085,1.1259342,0.2258153,1.1797738,1.2703031,3.9661886,1.9849349,10.2784446),(7253,'ulna-cleaned.tif',183,4,777,2.2295525,5.4944431,9.5448808,1.8,5.4806073,9.508803,1.0845436,0.6852227,2.1888348,0.1551214,2.4847965,0.2904422,1.1352143,0.2263811,1.1861417,1.2703031,3.9503016,1.9756881,10.2413803),(7254,'ulna-cleaned.tif',183,4,778,2.2292571,5.4933709,9.538128,1.8,5.4787657,9.5012587,1.0862316,0.6496078,2.2016235,0.1559388,2.4916316,0.2909213,1.1317246,0.2400507,1.1790429,1.2542595,3.9565433,1.9531754,9.835048),(7255,'ulna-cleaned.tif',183,4,779,2.2245988,5.4955731,9.5347988,1.8,5.4835109,9.5020147,1.0854014,0.6804793,2.253312,0.1551051,2.4875098,0.2900595,1.1039349,0.2279351,1.159375,1.2703031,4.0027477,1.9809237,10.1365463),(7256,'ulna-cleaned.tif',183,4,780,2.2176202,5.4958106,9.5331796,1.8,5.482473,9.4999384,1.0850532,0.6585217,2.1959874,0.1544222,2.4721757,0.2890433,1.1257695,0.2344983,1.1718271,1.2647708,3.9661886,1.9849349,10.1462277),(7257,'ulna-cleaned.tif',183,4,781,2.2151516,5.4966885,9.531829,1.8,5.4836299,9.4989502,1.0838824,0.6784665,2.1946772,0.1538864,2.4609108,0.2883644,1.1213088,0.226815,1.1671092,1.2756486,3.9503016,1.9756881,10.1792819),(7258,'ulna-cleaned.tif',183,4,782,2.2224507,5.4957459,9.5242761,1.8,5.4829767,9.4913287,1.0834006,0.6731418,2.187345,0.1538546,2.4743331,0.2891669,1.1312038,0.2285619,1.1770333,1.2610442,3.9503016,1.9756881,10.1462277),(7259,'ulna-cleaned.tif',183,4,783,2.2155948,5.4963781,9.5202126,1.8,5.4841917,9.4874487,1.0819368,0.6690089,2.1856445,0.1514659,2.4687277,0.2878271,1.1295194,0.2264034,1.1754119,1.251309,3.9347551,1.9663675,10.0100006),(7260,'ulna-cleaned.tif',183,4,784,2.2040217,5.4964532,9.5166854,1.8,5.4845052,9.4852356,1.0811642,0.6664013,2.2151819,0.1503096,2.4562679,0.2860882,1.1088335,0.2255541,1.1512585,1.2610442,3.9716037,1.9624963,10.2687633),(7261,'ulna-cleaned.tif',183,4,785,2.2053231,5.496461,9.5104616,1.8,5.484259,9.4780071,1.080326,0.662502,2.2093023,0.1490959,2.4593566,0.2860012,1.1131825,0.2250497,1.1551357,1.251309,3.9716037,1.9624963,9.8640921),(7262,'ulna-cleaned.tif',183,4,786,2.2022227,5.4968796,9.5056335,1.8,5.4852852,9.474164,1.0797824,0.6592302,2.2049878,0.1494473,2.455041,0.2854333,1.1134034,0.2266997,1.1556935,1.2451864,3.9503016,1.9756881,10.1422175),(7263,'ulna-cleaned.tif',183,4,787,2.197476,5.4963225,9.5001901,1.8,5.4850106,9.4682259,1.0789398,0.656176,2.1995335,0.1484276,2.4592892,0.2845612,1.1180958,0.2262008,1.1598962,1.2188131,3.9661886,1.9849349,10.1091633),(7264,'ulna-cleaned.tif',183,4,788,2.1923267,5.4958601,9.4949232,1.8,5.4829447,9.4601674,1.079273,0.654485,2.178482,0.1464652,2.4513549,0.2839958,1.1252583,0.2237869,1.1637918,1.2304031,3.9503016,1.9756881,9.8640921),(7265,'ulna-cleaned.tif',183,4,789,2.17805,5.4969931,9.4936958,1.8,5.484892,9.46168,1.0773884,0.6507063,2.1934067,0.1438474,2.4275633,0.2815763,1.1067548,0.2210635,1.1468319,1.2108074,3.9503016,1.9756881,10.0100006),(7266,'ulna-cleaned.tif',183,4,790,2.1728274,5.4989429,9.4943387,1.8,5.4871901,9.4661495,1.0743308,0.6486505,2.1583853,0.143188,2.4097777,0.2799755,1.1164724,0.2207475,1.1577596,1.215037,3.9136593,1.9797042,10.076109),(7267,'ulna-cleaned.tif',183,4,791,2.1707538,5.4983262,9.4884489,1.8,5.4862766,9.4605658,1.0747252,0.6468153,2.1559821,0.1427287,2.4172321,0.2798278,1.1211745,0.2206638,1.1640039,1.215037,3.8979667,1.9703118,10.1422175),(7268,'ulna-cleaned.tif',183,4,792,2.1691335,5.4955239,9.4778987,1.8,5.4824938,9.4483362,1.0766397,0.646354,2.1460485,0.1417645,2.4270728,0.2801977,1.1309497,0.2193295,1.1738636,1.215037,3.8979667,1.9703118,9.7979836),(7269,'ulna-cleaned.tif',183,4,793,2.1710013,5.4936071,9.4686312,1.8,5.4798831,9.4382869,1.0777628,0.6422633,2.1536354,0.1422825,2.4388235,0.2807781,1.1324217,0.2215329,1.1781964,1.2211442,3.8979667,1.9703118,9.9398819),(7270,'ulna-cleaned.tif',183,4,794,2.1656521,5.4927573,9.460052,1.8,5.4780573,9.4279978,1.0775617,0.6549625,2.1455957,0.1409447,2.4508434,0.2800257,1.1422671,0.215195,1.1876431,1.2310582,3.9097929,2.0024913,9.8737734),(7271,'ulna-cleaned.tif',183,4,795,2.1608637,5.4948504,9.4552854,1.8,5.4839804,9.4277092,1.0770516,0.6502207,2.1773213,0.1408964,2.4502409,0.2792533,1.1253465,0.2166902,1.1690678,1.2357486,3.9460677,1.9982606,9.9438921),(7272,'ulna-cleaned.tif',183,4,796,2.1624651,5.4936001,9.4494103,1.8,5.4808912,9.4203,1.0775232,0.6355253,2.1339635,0.1405512,2.4624577,0.279602,1.1539362,0.2211575,1.1898244,1.2301221,3.9136593,1.9797042,10.0898006),(7273,'ulna-cleaned.tif',183,4,797,2.1563343,5.4927154,9.4409971,1.8,5.4799908,9.4096348,1.0795933,0.6321952,2.1295792,0.139719,2.4692117,0.2794291,1.1594834,0.2210061,1.197096,1.233281,3.8979667,1.9703118,9.7085022),(7274,'ulna-cleaned.tif',183,4,798,2.1563297,5.4942975,9.4375985,1.8,5.482612,9.4074714,1.0790885,0.6662585,2.1434703,0.1394705,2.4841982,0.2792775,1.1589608,0.209334,1.1993223,1.21693,3.9136593,1.9797042,9.9438921),(7275,'ulna-cleaned.tif',183,4,799,2.1542298,5.4919936,9.4295416,1.8,5.4778943,9.3984359,1.0795508,0.6461979,2.1379433,0.139147,2.480626,0.2791437,1.1602861,0.2153318,1.202146,1.2065398,3.8979667,1.9703118,10.0664277),(7276,'ulna-cleaned.tif',183,4,800,2.1646018,5.4952496,9.4266414,1.8,5.4864883,9.4018743,1.0793239,0.6416885,2.1368446,0.1409118,2.4996769,0.2804195,1.1697982,0.2195953,1.2127232,1.2065398,3.9097929,2.0024913,9.9302005),(7277,'ulna-cleaned.tif',183,4,801,2.1642981,5.4930078,9.4210498,1.8,5.4826673,9.3969394,1.079573,0.6601456,2.3453528,0.1402006,2.5026614,0.280455,1.0670725,0.2123783,1.1168766,1.21693,3.9266548,2.0117206,10.0994819),(7278,'ulna-cleaned.tif',183,4,802,2.1591786,5.4925312,9.4162601,1.8,5.4804247,9.3901194,1.0795946,0.6370533,2.142863,0.1387711,2.4917311,0.279798,1.1628047,0.2178328,1.2074723,1.2011942,3.9296944,1.9890207,10.1188446),(7279,'ulna-cleaned.tif',183,4,803,2.1633567,5.4894834,9.4056599,1.8,5.4760241,9.3770816,1.0786135,0.6360087,2.1128399,0.1389542,2.5056135,0.280045,1.1858984,0.2184785,1.2268068,1.2065398,3.893267,1.993183,9.8737734),(7280,'ulna-cleaned.tif',183,4,804,2.1587021,5.4921502,9.4040151,1.8,5.4822125,9.378433,1.0781844,0.6675163,2.1313381,0.1385543,2.5067481,0.2793138,1.1761382,0.2075669,1.2208647,1.2291653,3.9097929,2.0024913,9.9729362),(7281,'ulna-cleaned.tif',183,4,805,2.1474626,5.4932801,9.3985176,1.8,5.4850892,9.3747655,1.0768383,0.6649589,2.1265064,0.1359264,2.5067067,0.2774577,1.1787911,0.2044132,1.2223885,1.2261021,3.9136593,1.9797042,10.0624175),(7282,'ulna-cleaned.tif',183,4,806,2.1510314,5.4914075,9.3899136,1.8,5.4795647,9.3605509,1.0774982,0.6606468,2.120943,0.1351861,2.5265465,0.2781162,1.1912374,0.2046269,1.236234,1.2211596,3.9266548,2.0117206,10.0527362),(7283,'ulna-cleaned.tif',183,4,807,2.1523017,5.489993,9.3850612,1.8,5.4780495,9.3578129,1.0774842,0.6595774,2.1133488,0.1347638,2.5289903,0.2782763,1.1966743,0.2043184,1.2400827,1.2211596,3.9097929,2.0024913,9.7649293),(7284,'ulna-cleaned.tif',183,4,808,2.1476681,5.491343,9.3829551,1.8,5.4817367,9.3587669,1.0765916,0.6562731,2.111791,0.1329988,2.5275766,0.2774105,1.1968877,0.2026577,1.2395184,1.2211596,3.9097929,2.0024913,9.7883022),(7285,'ulna-cleaned.tif',183,4,809,2.1412038,5.4909727,9.3797208,1.8,5.4816215,9.3565905,1.0749693,0.6530269,2.1081439,0.1312482,2.5221423,0.2760915,1.1963805,0.2009844,1.2380111,1.2211596,3.893267,1.993183,9.9108378),(7286,'ulna-cleaned.tif',183,4,810,2.1387997,5.4908304,9.3760119,1.8,5.479618,9.3506968,1.0753334,0.6518462,2.1049539,0.1305278,2.5184541,0.2758901,1.1964414,0.2002432,1.2380167,1.215037,3.893267,1.993183,9.7512378),(7287,'ulna-cleaned.tif',183,4,811,2.1425026,5.4911608,9.3710906,1.8,5.4804548,9.346188,1.0742506,0.6478468,2.1003673,0.1303494,2.53344,0.2760441,1.206189,0.201204,1.2476052,1.1886637,3.8770813,1.983796,9.8407192),(7288,'ulna-cleaned.tif',183,4,812,2.1325225,5.4901561,9.3683613,1.8,5.4786495,9.3431919,1.0732593,0.6461729,2.0971081,0.128989,2.5126708,0.2744629,1.1981599,0.1996199,1.2389271,1.1886637,3.8906082,2.0160974,9.8544107),(7289,'ulna-cleaned.tif',183,4,813,2.1246411,5.4903127,9.3663897,1.8,5.4798434,9.3443586,1.0725124,0.6441457,2.0951627,0.1272385,2.50439,0.2732266,1.1953201,0.1975306,1.23528,1.1886637,3.8906082,2.0160974,9.7318751),(7290,'ulna-cleaned.tif',183,4,814,2.1293699,5.4898576,9.3608974,1.8,5.4778191,9.3367613,1.0720811,0.6413703,2.089955,0.1279189,2.5182733,0.2737061,1.2049414,0.1994463,1.2452499,1.2011942,3.8906082,2.0160974,9.8213565),(7291,'ulna-cleaned.tif',183,4,815,2.1281725,5.4904418,9.3542404,1.8,5.4796898,9.3303087,1.0713597,0.6367487,2.084113,0.1277811,2.528439,0.2733372,1.2131967,0.2006774,1.2535922,1.2011942,3.8735894,2.0068012,9.8213565),(7292,'ulna-cleaned.tif',183,4,816,2.1191086,5.4886091,9.348855,1.8,5.4751999,9.3230748,1.0714394,0.6199597,2.0785381,0.1261822,2.5213237,0.2721967,1.2130274,0.2035328,1.2528429,1.182551,3.8735894,2.0068012,9.6093395),(7293,'ulna-cleaned.tif',183,4,817,2.112765,5.4861964,9.3427966,1.8,5.4719538,9.3180975,1.071656,0.6353782,2.0721466,0.1257262,2.5109122,0.271446,1.2117445,0.1978762,1.2515552,1.2011942,3.8569084,1.9974238,9.9205192),(7294,'ulna-cleaned.tif',183,4,818,2.1106912,5.4873212,9.3405889,1.8,5.4751458,9.3177999,1.0700383,0.6312379,2.0701326,0.1246665,2.5112215,0.2707007,1.2130728,0.1974952,1.2522362,1.2011942,3.8906082,2.0160974,9.8173463),(7295,'ulna-cleaned.tif',183,4,819,2.1045843,5.4851509,9.3321493,1.8,5.4732982,9.307984,1.069702,0.6286513,2.0615596,0.1233342,2.5163791,0.2698181,1.2206192,0.1961885,1.259255,1.180658,3.8735894,2.0068012,9.8874649),(7296,'ulna-cleaned.tif',183,4,820,2.1089839,5.4848531,9.3278529,1.8,5.473567,9.3052637,1.06962,0.6267413,2.0576174,0.1233223,2.5367834,0.2703579,1.2328742,0.1967674,1.2715141,1.180658,3.8735894,2.0068012,9.8544107),(7297,'ulna-cleaned.tif',183,4,821,2.1062113,5.4829643,9.3204937,1.8,5.4708779,9.2969169,1.070049,0.6254265,2.050417,0.1225458,2.5453712,0.2701293,1.2413919,0.1959396,1.2798851,1.180658,3.8569084,1.9974238,9.8504005),(7298,'ulna-cleaned.tif',183,4,822,2.1074346,5.4822869,9.3130644,1.8,5.4709927,9.2894038,1.0698106,0.6221387,2.0434857,0.122077,2.5548534,0.2702157,1.2502429,0.1962216,1.2887007,1.1726524,3.8569084,1.9974238,9.9261904),(7299,'ulna-cleaned.tif',183,4,823,2.1067545,5.4825478,9.307897,1.8,5.4728233,9.2847411,1.0687383,0.6564067,2.0386806,0.1215206,2.5724695,0.269811,1.2618306,0.18513,1.2999305,1.2070314,3.8569084,1.9974238,9.7746107),(7300,'ulna-cleaned.tif',183,4,824,2.1137483,5.4809119,9.3012712,1.8,5.4705328,9.276885,1.0683828,0.6542025,2.0319532,0.1231594,2.5846851,0.270601,1.27202,0.1882589,1.3109192,1.2070314,3.8405694,1.9879658,9.7746107),(7301,'ulna-cleaned.tif',183,4,825,2.1089211,5.4817823,9.30126,1.8,5.4737662,9.2817141,1.0668054,0.6514393,2.0317755,0.1219023,2.5814283,0.2695146,1.2705283,0.1871277,1.3085662,1.2070314,3.8735894,2.0068012,10.2841159),(7302,'ulna-cleaned.tif',183,4,826,2.1048681,5.479705,9.296693,1.8,5.469804,9.2757045,1.0662992,0.6504095,2.0265839,0.1210166,2.5810957,0.2688464,1.273619,0.1860622,1.3111432,1.1652934,3.8569084,1.9974238,9.9922989),(7303,'ulna-cleaned.tif',183,4,827,2.10186,5.479949,9.2929249,1.8,5.4705159,9.2737992,1.0655545,0.6474257,2.0231254,0.1207213,2.5843886,0.2682413,1.2774238,0.1864635,1.3148287,1.1652934,3.8569084,1.9974238,9.5819564),(7304,'ulna-cleaned.tif',183,4,828,2.1018025,5.4804215,9.2913798,1.8,5.4703855,9.2732232,1.0645492,0.6449819,2.0216262,0.1201475,2.5878365,0.2679355,1.2800766,0.1862804,1.3170679,1.1652934,3.8374592,2.0111923,9.6617565),(7305,'ulna-cleaned.tif',183,4,829,2.1011419,5.4791104,9.2869829,1.8,5.4683101,9.2678277,1.064402,0.6438078,2.01709,0.119755,2.5860962,0.2678075,1.2820926,0.1860105,1.3189723,1.1652934,3.8405694,1.9879658,9.9261904),(7306,'ulna-cleaned.tif',183,4,830,2.0909042,5.4781791,9.2807137,1.8,5.465371,9.2569096,1.0646643,0.641919,2.0112534,0.1191968,2.5789414,0.2665802,1.2822558,0.1856882,1.3192254,1.1652934,3.8206204,2.0017453,9.8270277),(7307,'ulna-cleaned.tif',183,4,831,2.0909833,5.4793156,9.2810646,1.8,5.4670643,9.2603481,1.0642701,0.6405884,2.0119651,0.1191406,2.5828881,0.2664738,1.2837639,0.1859862,1.3206793,1.1597958,3.8374592,2.0111923,9.8076649),(7308,'ulna-cleaned.tif',183,4,832,2.0959243,5.4782826,9.2749601,1.8,5.4658924,9.254191,1.0637318,0.6378346,2.0097993,0.1191573,2.6061442,0.2669438,1.2967187,0.1868153,1.336048,1.1597958,3.8374592,2.0111923,9.9302005),(7309,'ulna-cleaned.tif',183,4,833,2.0977972,5.4761474,9.2661851,1.8,5.4636709,9.243952,1.0648355,0.6368752,2.001398,0.1192988,2.6271457,0.2675098,1.3126553,0.187319,1.3523785,1.1726524,3.8212454,2.0718097,9.7181836),(7310,'ulna-cleaned.tif',183,4,834,2.098665,5.4735443,9.2581682,1.8,5.4607125,9.2362128,1.0649935,0.6354734,2.0124994,0.1195716,2.6377064,0.2676673,1.310662,0.1881614,1.3604564,1.1726524,3.8374592,2.0576956,9.9632548),(7311,'ulna-cleaned.tif',183,4,835,2.0946547,5.4701251,9.248622,1.8,5.4564958,9.227715,1.0646523,0.6333895,2.0024105,0.1189766,2.6404277,0.2670548,1.3186246,0.1878412,1.3683452,1.1726524,3.8364219,2.0344439,9.9592446),(7312,'ulna-cleaned.tif',183,4,836,2.0982379,5.4703016,9.2455594,1.8,5.4591421,9.2282769,1.0631364,0.629747,1.9994556,0.1192775,2.6629528,0.2670617,1.3318389,0.1894054,1.3815609,1.1726524,3.8562892,2.06684,10.076109),(7313,'ulna-cleaned.tif',183,4,837,2.0937275,5.4692354,9.2417075,1.8,5.4591693,9.2268616,1.0625487,0.6280268,1.9799908,0.1187,2.6607881,0.2663133,1.3438386,0.1890047,1.3859864,1.1726524,3.8212454,2.0718097,9.996309),(7314,'ulna-cleaned.tif',183,4,838,2.0908901,5.4687655,9.2376924,1.8,5.4597046,9.2228961,1.0608154,0.6241771,1.9759316,0.1177153,2.6615465,0.2654382,1.3469831,0.1885927,1.3886117,1.1726524,3.8212454,2.0718097,9.8640921),(7315,'ulna-cleaned.tif',183,4,839,2.0843552,5.4664239,9.2304522,1.8,5.4561263,9.2124852,1.0600086,0.6216063,1.9836199,0.1163853,2.6605738,0.2643697,1.341272,0.1872331,1.3896044,1.1443959,3.8212454,2.0718097,10.0430548),(7316,'ulna-cleaned.tif',183,4,840,2.0812936,5.4621493,9.2218158,1.8,5.4500762,9.2015287,1.0598897,0.6209529,1.9739675,0.1159461,2.6640767,0.2639462,1.3496052,0.1867229,1.3978613,1.1321508,3.8189533,2.0484617,9.8931362),(7317,'ulna-cleaned.tif',183,4,841,2.0787664,5.4631885,9.2218995,1.8,5.4532385,9.2046085,1.0585312,0.6182553,1.9546618,0.1151188,2.6582836,0.2632239,1.3599711,0.1861995,1.3973766,1.1321508,3.7862978,2.0768713,10.0059904),(7318,'ulna-cleaned.tif',183,4,842,2.0783832,5.4625203,9.2187609,1.8,5.4524517,9.2013242,1.0578978,0.6164429,1.9558146,0.1146535,2.6537445,0.2629878,1.3568487,0.185992,1.3970987,1.1321508,3.7862978,2.0768713,10.0196819),(7319,'ulna-cleaned.tif',183,4,843,2.0718078,5.4616634,9.216222,1.8,5.4512722,9.2001351,1.0569636,0.6146774,1.96814,0.1137401,2.6483734,0.2618798,1.3456225,0.1850403,1.3926092,1.1321508,3.8212454,2.0718097,10.0430548),(7320,'ulna-cleaned.tif',183,4,844,2.0714469,5.4617064,9.2103033,1.8,5.4512586,9.1909694,1.0579306,0.6130464,1.9632405,0.1142281,2.661539,0.2621198,1.3556867,0.1863287,1.4033544,1.1517544,3.8212454,2.0718097,9.9302005),(7321,'ulna-cleaned.tif',183,4,845,2.0614046,5.4611305,9.2084835,1.8,5.450561,9.1892326,1.0574643,0.6236437,1.9416658,0.1134955,2.6559688,0.260712,1.3678815,0.1819876,1.4048543,1.1637662,3.8014044,2.0156668,9.8971463),(7322,'ulna-cleaned.tif',183,4,846,2.0473208,5.4575616,9.2024402,1.8,5.4450554,9.1811211,1.0576904,0.6233917,1.9391219,0.1118521,2.6415092,0.2589968,1.3622192,0.179425,1.4015694,1.1637662,3.7862978,2.0768713,9.8737734),(7323,'ulna-cleaned.tif',183,4,847,2.0478571,5.4567849,9.1999033,1.8,5.4429488,9.1756675,1.0559846,0.6257837,1.951293,0.1111894,2.6483139,0.2585661,1.3572098,0.1776803,1.403284,1.1637662,3.8007762,2.0391387,9.6190208),(7324,'ulna-cleaned.tif',183,4,848,2.0437939,5.4560089,9.196085,1.8,5.4414704,9.1694373,1.0551283,0.6260617,1.9520183,0.1108501,2.6440747,0.257803,1.3545338,0.1770593,1.4036868,1.1637662,3.79113,2.1003859,9.7278649),(7325,'ulna-cleaned.tif',183,4,849,2.041941,5.4563006,9.1974361,1.8,5.4431899,9.1749398,1.053046,0.6300799,1.9530094,0.1099816,2.6399974,0.2569605,1.3517587,0.1745519,1.4033934,1.1520033,3.8057992,2.0860413,9.8600819),(7326,'ulna-cleaned.tif',183,4,850,2.0353718,5.456213,9.1972654,1.8,5.4432207,9.1742899,1.0522661,0.6314212,1.932918,0.1085225,2.6321309,0.2559061,1.3617395,0.1718703,1.3988989,1.1520033,3.7862978,2.0768713,9.8600819),(7327,'ulna-cleaned.tif',183,4,851,2.0228685,5.4567097,9.200527,1.8,5.4420671,9.1763803,1.049398,0.6008814,1.9354241,0.106322,2.608018,0.2535002,1.3475176,0.1769433,1.3831743,1.1161395,3.7844052,2.0061496,9.7939734),(7328,'ulna-cleaned.tif',183,4,852,2.0238137,5.4575909,9.2012632,1.8,5.4442738,9.1783471,1.0462707,0.5961802,1.9250036,0.1064275,2.6055516,0.2527058,1.3535307,0.1785157,1.3812815,1.1241451,3.7654272,2.0202269,9.7842921),(7329,'ulna-cleaned.tif',183,4,853,2.0183633,5.4588974,9.2029303,1.8,5.4478977,9.18305,1.042973,0.6315381,1.9258175,0.1058303,2.5968414,0.2510617,1.3484359,0.1675755,1.3751415,1.1542982,3.7654272,2.0202269,9.7278649),(7330,'ulna-cleaned.tif',183,4,854,2.0093734,5.4536284,9.1965198,1.8,5.4395021,9.1726707,1.0413636,0.6307421,1.9169896,0.1032955,2.5719416,0.249474,1.3416565,0.1637682,1.3665787,1.1411255,3.7652158,2.0439223,9.7706005),(7331,'ulna-cleaned.tif',183,4,855,2.0040853,5.4550755,9.1997298,1.8,5.4429849,9.1801241,1.0385801,0.627455,1.8991311,0.1022568,2.5646252,0.2480057,1.3504203,0.1629707,1.368525,1.1181004,3.7654272,2.0202269,9.6811192),(7332,'ulna-cleaned.tif',183,4,856,1.990254,5.4560666,9.2030466,1.8,5.4474107,9.1900136,1.0353383,0.624027,1.8731492,0.100556,2.5276171,0.245352,1.3493944,0.1611405,1.3730014,1.0997241,3.713059,2.0632821,9.6013192),(7333,'ulna-cleaned.tif',183,4,857,1.9895602,5.4554767,9.2048806,1.8,5.4470213,9.1932801,1.0322341,0.6076043,1.8733737,0.0994976,2.5235618,0.2443615,1.3470681,0.1637539,1.369211,1.1042562,3.7122014,2.0152155,9.8133362),(7334,'ulna-cleaned.tif',183,4,858,1.9859665,5.4522217,9.2002071,1.8,5.440348,9.1844886,1.0299059,0.6050528,1.8738848,0.0989239,2.5204605,0.2432407,1.3450456,0.1634962,1.3795132,1.0798301,3.6971609,2.0778948,9.7899633),(7335,'ulna-cleaned.tif',183,4,859,1.9780388,5.4487152,9.194949,1.8,5.4350241,9.1776327,1.0283037,0.60331,1.8806188,0.0977694,2.5123284,0.241803,1.3359051,0.162055,1.3687518,1.0798301,3.7115581,2.0392516,9.7996446),(7336,'ulna-cleaned.tif',183,4,860,1.9813148,5.4482838,9.1944264,1.8,5.4362463,9.1798339,1.0256698,0.6134768,1.8863719,0.0975546,2.5214666,0.2414333,1.3366752,0.1590192,1.3780312,1.0920432,3.7365664,2.0965649,9.6811192),(7337,'ulna-cleaned.tif',183,4,861,1.9775019,5.4467468,9.1893372,1.8,5.4349666,9.1736944,1.0247899,0.5768769,1.87498,0.0964649,2.5210955,0.2407114,1.3445986,0.1672192,1.3873922,1.065887,3.7091982,2.1259749,9.6110005),(7338,'ulna-cleaned.tif',183,4,862,1.9752172,5.4467636,9.1866081,1.8,5.4376148,9.1744344,1.0241048,0.567141,1.8637366,0.096158,2.5244156,0.240233,1.3544916,0.1695487,1.3732885,1.053229,3.713059,2.0632821,9.7996446),(7339,'ulna-cleaned.tif',183,4,863,1.9797885,5.4442942,9.1815883,1.8,5.4325673,9.1653257,1.023835,0.5662596,1.8654789,0.0961024,2.5290869,0.2407099,1.3557306,0.1697145,1.3797195,1.053229,3.713059,2.0632821,9.9124989),(7340,'ulna-cleaned.tif',183,4,864,1.9756137,5.4420124,9.1769341,1.8,5.4301111,9.1591359,1.0221785,0.6050527,1.8673554,0.0963931,2.5320609,0.2397173,1.3559608,0.1593136,1.3924104,1.0890553,3.7021095,2.1019739,9.6440548),(7341,'ulna-cleaned.tif',183,4,865,1.9719329,5.4401022,9.1752804,1.8,5.4270047,9.1560139,1.0204163,0.5694248,1.8830815,0.0948372,2.5275912,0.2387548,1.3422633,0.166549,1.3565379,1.0616794,3.7652158,2.0439223,9.5682649),(7342,'ulna-cleaned.tif',183,4,866,1.9663869,5.4401423,9.1745465,1.8,5.4289929,9.1567477,1.0175926,0.5991833,1.8762308,0.0948982,2.5186754,0.2372571,1.3424123,0.1583792,1.3757058,1.0830897,3.7320901,2.0727028,9.6867904),(7343,'ulna-cleaned.tif',183,4,867,1.9593642,5.4422548,9.1778997,1.8,5.4323562,9.1626015,1.0156841,0.5965631,1.8538614,0.0937477,2.51576,0.235852,1.3570378,0.1571463,1.3744758,1.0830897,3.7115581,2.0392516,9.7335361),(7344,'ulna-cleaned.tif',183,4,868,1.9497269,5.4405965,9.1735231,1.8,5.4293352,9.1549724,1.014348,0.5938488,1.8572787,0.0926434,2.5063416,0.2343028,1.3494699,0.156005,1.3723145,1.0830897,3.6971609,2.0778948,9.6343734),(7345,'ulna-cleaned.tif',183,4,869,1.9413815,5.4394114,9.1740714,1.8,5.4261663,9.1553695,1.0131376,0.5934976,1.8653638,0.0911549,2.492316,0.2329484,1.3361019,0.1535893,1.3712089,1.067365,3.6971609,2.0778948,9.6110005),(7346,'ulna-cleaned.tif',183,4,870,1.9279853,5.4378584,9.1728832,1.8,5.4250721,9.1560468,1.0101727,0.5911904,2.1903354,0.0899339,2.4771615,0.2304841,1.1309508,0.1521235,1.1342363,1.0664106,3.6820589,2.0926306,9.6867904),(7347,'ulna-cleaned.tif',183,4,871,1.9299695,5.4386709,9.172201,1.8,5.4257268,9.1532886,1.0076233,0.5867417,2.1916383,0.0905274,2.4965038,0.2299819,1.1391039,0.1542883,1.1429821,1.0336158,3.6943609,2.0537652,9.6537361),(7348,'ulna-cleaned.tif',183,4,872,1.9246064,5.4393176,9.1724466,1.8,5.4255762,9.1524011,1.0066058,0.583805,2.17143,0.0886408,2.4816998,0.229048,1.1428873,0.1518329,1.1499615,1.0336158,3.6971609,2.0778948,9.5739361),(7349,'ulna-cleaned.tif',183,4,873,1.9188085,5.4363461,9.1702137,1.8,5.4197501,9.1474447,1.004957,0.5828626,2.1688229,0.0875589,2.4748523,0.2278811,1.1411039,0.1502221,1.148309,1.0336158,3.6971609,2.0778948,9.729526),(7350,'ulna-cleaned.tif',183,4,874,1.917123,5.4363547,9.1712932,1.8,5.419878,9.1504986,1.0020145,0.5794004,2.1927629,0.0876756,2.484361,0.2268287,1.1329821,0.1513213,1.1375176,1.0323879,3.713059,2.0632821,9.6166718),(7351,'ulna-cleaned.tif',183,4,875,1.913508,5.436713,9.1723577,1.8,5.4224988,9.1545085,0.9996364,0.576411,2.1951579,0.0874339,2.4719255,0.2257119,1.126081,0.1516867,1.1314151,1.0323879,3.6820589,2.0926306,9.8190074),(7352,'ulna-cleaned.tif',183,4,876,1.9130296,5.4338508,9.1710727,1.8,5.4171039,9.1519152,0.9961422,0.5733178,2.1944186,0.0874527,2.4781276,0.2246405,1.1292866,0.1525379,1.1356533,1.0262148,3.6971609,2.0778948,9.5642548),(7353,'ulna-cleaned.tif',183,4,877,1.9129815,5.4324738,9.1676227,1.8,5.4124043,9.1430985,0.9935735,0.5690512,2.1703744,0.087555,2.4890356,0.2238867,1.1468231,0.1538614,1.1561553,1.0262148,3.7021095,2.1019739,9.4514005),(7354,'ulna-cleaned.tif',183,4,878,1.9002121,5.4357803,9.1714677,1.8,5.4187635,9.1502128,0.9931716,0.5678253,2.1756011,0.0864645,2.4659322,0.2222758,1.1334486,0.152273,1.1435835,1.0262148,3.713059,2.0632821,9.5642548),(7355,'ulna-cleaned.tif',183,4,879,1.8934263,5.4355789,9.171506,1.8,5.4168265,9.1492011,0.9911383,0.6824137,2.252423,0.0852724,2.448739,0.2208944,1.0871577,0.124957,1.0766859,1.0254366,3.6820589,2.0926306,9.3288649),(7356,'ulna-cleaned.tif',183,4,880,1.889885,5.43662,9.1732476,1.8,5.4167671,9.1502714,0.989482,0.5785577,2.1898473,0.0840451,2.4437072,0.2200028,1.1159258,0.1452667,1.1160125,1.0254366,3.6640716,2.2404353,9.5836175),(7357,'ulna-cleaned.tif',183,4,881,1.8852656,5.4383749,9.1747724,1.8,5.4204747,9.1529411,0.989965,0.5630515,2.1261236,0.0831368,2.4304941,0.2196043,1.1431575,0.147654,1.1532152,1.0254366,3.6969456,2.1797539,9.3852921),(7358,'ulna-cleaned.tif',183,4,882,1.8768043,5.4397861,9.1751208,1.8,5.4211241,9.15068,0.9887715,0.5604235,2.1058284,0.0819321,2.4286236,0.218276,1.1532866,0.1461968,1.1664015,1.0254366,3.7091982,2.1259749,9.2958107),(7359,'ulna-cleaned.tif',183,4,883,1.8680441,5.4337745,9.1700841,1.8,5.4133611,9.1458632,0.9869855,0.5602079,2.077111,0.0809114,2.4153297,0.2167461,1.1628313,0.144431,1.1793146,1.0193617,3.7021095,2.1019739,9.3619192),(7360,'ulna-cleaned.tif',183,4,884,1.8627794,5.4349465,9.1714204,1.8,5.4173388,9.1507526,0.9869136,0.5598674,2.0456115,0.0795435,2.4138737,0.2161147,1.1800255,0.1420756,1.1930654,1.0169049,3.6883229,2.1167816,9.3288649),(7361,'ulna-cleaned.tif',183,4,885,1.8587126,5.4388538,9.1744423,1.8,5.4250378,9.1567475,0.9856727,0.5673765,1.8757659,0.0788087,2.3944396,0.2152891,1.2765131,0.1389003,1.3050232,1.0262964,3.6883229,2.1167816,9.6867904),(7362,'ulna-cleaned.tif',183,4,886,1.8581333,5.4381389,9.1732435,1.8,5.4244066,9.1557061,0.9829378,0.563781,1.8736249,0.078903,2.4079223,0.2144412,1.2851678,0.1399533,1.3131499,1.0230077,3.7224798,2.1112158,9.597309),(7363,'ulna-cleaned.tif',183,4,887,1.8522498,5.4347269,9.1703598,1.8,5.4195333,9.1513783,0.979183,0.6445029,2.2036228,0.0797101,2.407808,0.2126907,1.0926589,0.1236769,1.0834425,1.0262964,3.6967302,2.1408368,9.5545734),(7364,'ulna-cleaned.tif',183,4,888,1.8443503,5.4318273,9.1706295,1.8,5.4139943,9.1506949,0.9752462,0.557591,2.1482405,0.0784519,2.4091287,0.2106614,1.1214427,0.1406979,1.1302336,1.0132092,3.6833558,2.2641476,9.7004819),(7365,'ulna-cleaned.tif',183,4,889,1.8505237,5.4263475,9.1640852,1.8,5.4039922,9.1370701,0.97255,0.615983,2.1754737,0.0791456,2.4269432,0.2105934,1.115593,0.1284867,1.1113567,1.0132092,3.6833558,2.2641476,9.6400446),(7366,'ulna-cleaned.tif',183,4,890,1.8482372,5.4226657,9.164333,1.8,5.3975498,9.1366461,0.9681324,0.6464634,2.2214252,0.0779028,2.4289212,0.2090644,1.0934067,0.1205061,1.0835267,1.0132092,3.8114422,2.3191744,9.8326989),(7367,'ulna-cleaned.tif',183,4,891,1.8430654,5.4160191,9.1613537,1.8,5.3876219,9.1328252,0.9608019,0.6264208,2.2297017,0.0784161,2.4515956,0.2063705,1.0995173,0.1251811,1.0968828,0.9875208,3.8951067,2.3272171,9.9866277),(7368,'ulna-cleaned.tif',183,4,892,1.8449011,5.4102795,9.1561445,1.8,5.3788584,9.1236895,0.9561726,0.6470504,2.2477633,0.0797285,2.4864612,0.2052371,1.1061936,0.1232183,1.1014506,0.9843152,3.8938803,2.3417028,10.2220175),(7369,'ulna-cleaned.tif',183,4,893,1.8342998,5.4090804,9.1531952,1.8,5.379708,9.122054,0.9550979,0.6779421,2.2588109,0.0790332,2.4629643,0.203748,1.0903809,0.1165781,1.0778695,0.9901136,3.8678313,2.3197143,9.8931362),(7370,'ulna-cleaned.tif',183,4,894,1.8328548,5.4060278,9.1533045,1.8,5.3728045,9.1202698,0.9526926,0.6374384,2.2450295,0.0775654,2.4649415,0.2028941,1.097955,0.1216829,1.0936768,0.9857884,3.8114422,2.3191744,9.5876277),(7371,'ulna-cleaned.tif',183,4,895,1.8309565,5.4016053,9.147467,1.8,5.3656669,9.1111195,0.949718,1.01074,2.4531515,0.0790509,2.4822797,0.2018257,1.0118738,0.0782109,0.9653688,1.0000551,3.8387036,2.3267912,9.9068277),(7372,'ulna-cleaned.tif',183,4,896,1.8378029,5.3979138,9.1422564,1.8,5.3604942,9.1028485,0.9487951,0.6609903,2.2476425,0.0789008,2.4936759,0.2023127,1.1094629,0.1193675,1.0980685,1.1685602,4.1817029,2.410196,10.7572447),(7373,'ulna-cleaned.tif',183,4,897,1.8344929,5.38992,9.1348968,1.8,5.3484097,9.0925859,0.9438847,1.0912623,2.5121922,0.0808182,2.5104304,0.2005241,0.9992987,0.0740594,0.9460664,1.1685602,4.1817029,2.410196,10.7532345),(7374,'ulna-cleaned.tif',183,4,898,1.8384076,5.3857626,9.1352059,1.8,5.3410418,9.093715,0.9393942,1.076432,2.54707,0.0846228,2.5328237,0.1996428,0.9944068,0.0786142,0.94969,1.1895696,4.2061869,2.3897389,10.9555701),(7375,'ulna-cleaned.tif',183,4,899,1.8295567,5.3848999,9.1372636,1.8,5.3419381,9.0988955,0.936991,1.0684714,2.5507401,0.0835891,2.5162588,0.1979828,0.9864819,0.0782324,0.9431899,1.1895696,4.2061869,2.3897389,10.8757701),(7376,'ulna-cleaned.tif',183,4,900,1.8339956,5.3763034,9.1282484,1.8,5.3279581,9.0826775,0.9316011,1.0533597,2.5439709,0.0861297,2.5521518,0.1968881,1.0032158,0.0817666,0.9613298,1.1806051,4.2084572,2.4031398,11.0023159),(7377,'ulna-cleaned.tif',183,4,901,1.8267465,5.3697234,9.1256031,1.8,5.3184194,9.0800743,0.9267506,0.997633,2.463047,0.0872832,2.5560127,0.1946937,1.0377442,0.0874903,0.9980285,0.9692692,3.7089836,2.2724215,9.597309),(7378,'ulna-cleaned.tif',183,4,902,1.832468,5.3651754,9.1225323,1.8,5.3129055,9.0754666,0.9215198,0.9831366,2.4629106,0.0897613,2.5985717,0.1937671,1.0550816,0.091301,1.0171387,0.9692692,3.7141308,2.2572817,9.4143361),(7379,'ulna-cleaned.tif',183,4,903,1.8327523,5.3576319,9.118336,1.8,5.3011668,9.0682772,0.9172891,0.9694045,2.4590279,0.0918173,2.6245444,0.192551,1.0673097,0.0947152,1.0311079,0.9763217,3.7310235,2.2956625,9.5038175),(7380,'ulna-cleaned.tif',183,4,904,1.8420296,5.3478803,9.1090599,1.8,5.2849607,9.051858,0.9124678,0.9556517,2.4502527,0.093654,2.6687647,0.1920949,1.0891794,0.0980002,1.0538558,1.4110724,4.4865773,2.4696295,11.9518956),(7381,'ulna-cleaned.tif',183,4,905,1.8507605,5.3372266,9.1018484,1.8,5.2721849,9.0445005,0.9067989,0.9379793,2.4186583,0.0962994,2.7113477,0.1913105,1.1210131,0.1026668,1.0849556,1.4110724,4.4618478,2.4766279,11.5842888),(7382,'ulna-cleaned.tif',183,4,906,1.8626648,5.3213799,9.0872279,1.8,5.250451,9.0232371,0.9013878,0.8902712,2.4020969,0.0988271,2.7673158,0.1909083,1.1520417,0.1110078,1.1225387,1.3927906,4.4618478,2.4766279,11.5238515),(7383,'ulna-cleaned.tif',183,4,907,1.8708672,5.3195816,9.0892287,1.8,5.250655,9.0295814,0.8979584,0.8794824,2.4054949,0.1005369,2.8030508,0.1907074,1.1652699,0.1143137,1.137414,1.3947066,4.4496999,2.4514468,11.5996413),(7384,'ulna-cleaned.tif',183,4,908,1.869721,5.3134252,9.0844365,1.8,5.2407294,9.0215288,0.8945617,0.8696103,2.4007933,0.100594,2.8104848,0.189558,1.1706484,0.1156771,1.1438249,1.3927906,4.4554207,2.4640545,11.5141701),(7385,'ulna-cleaned.tif',183,4,909,1.8803408,5.3105604,9.0853558,1.8,5.2342531,9.0209342,0.8919094,0.8605152,2.4019417,0.1013919,2.8268064,0.1898228,1.1768839,0.1178269,1.1514321,1.3927906,4.4554207,2.4640545,11.7261871),(7386,'ulna-cleaned.tif',183,4,910,1.870657,5.3044235,9.0795762,1.8,5.2290016,9.0152124,0.8900365,0.854942,2.3951484,0.1011166,2.8118395,0.1882742,1.173973,0.1182731,1.1491731,1.3927906,4.4618478,2.4766279,11.6133329),(7387,'ulna-cleaned.tif',183,4,911,1.8725098,5.3015438,9.0787107,1.8,5.2277332,9.016165,0.8861985,0.8441786,2.3958241,0.1011311,2.8334958,0.1872881,1.1826811,0.1197982,1.1590494,1.3913135,4.4305174,2.4710711,11.5609159),(7388,'ulna-cleaned.tif',183,4,912,1.8762502,5.2938145,9.0734895,1.8,5.2174328,9.0095918,0.8829359,0.8338014,2.3895422,0.1016971,2.8506556,0.186662,1.1929714,0.1219681,1.1703588,1.3653252,4.4496999,2.4514468,11.4754447),(7389,'ulna-cleaned.tif',183,4,913,1.8850766,5.2924436,9.074858,1.8,5.2180114,9.0131688,0.8799033,0.824716,2.361414,0.1018842,2.8575468,0.1866048,1.2100999,0.1235385,1.1831637,1.3653252,4.4130556,2.4908584,11.7068244),(7390,'ulna-cleaned.tif',183,4,914,1.8865131,5.2783893,9.063803,1.8,5.1949858,8.9948875,0.8762734,0.7766374,2.2958293,0.1026586,2.8763919,0.1856253,1.2528771,0.1321835,1.2332696,1.3439112,4.3498322,2.479745,11.2046515),(7391,'ulna-cleaned.tif',183,4,915,1.8864459,5.2783795,9.0638377,1.8,5.1955704,8.9940732,0.8748516,0.7733862,2.2969152,0.1028631,2.8768902,0.1851789,1.2525017,0.1330036,1.2335554,1.3402576,4.3432393,2.4668517,11.0958074),(7392,'ulna-cleaned.tif',183,4,916,1.8854719,5.2754574,9.060936,1.8,5.1904574,8.9873052,0.872402,0.7674602,2.2946389,0.1039294,2.9039709,0.1843254,1.2655459,0.1354199,1.2472818,1.3412424,4.3628056,2.4468544,11.086126),(7393,'ulna-cleaned.tif',183,4,917,1.8712085,5.2800013,9.067638,1.8,5.2013174,9.0015999,0.8720168,0.7657556,2.3029787,0.1014304,2.8640414,0.1828127,1.2436248,0.1324579,1.2259206,1.3402576,4.3498322,2.479745,10.9402175),(7394,'ulna-cleaned.tif',183,4,918,1.8547097,5.2852099,9.0699142,1.8,5.2100804,9.0056004,0.874178,0.7581905,2.2808609,0.0980901,2.8306509,0.1818586,1.241045,0.129374,1.2249529,1.3402576,4.3373705,2.4539214,11.1756074),(7395,'ulna-cleaned.tif',183,4,919,1.8407615,5.2875413,9.0746822,1.8,5.213074,9.0130156,0.8736215,0.7350975,2.2864118,0.0960078,2.7993786,0.1803229,1.2243545,0.1306055,1.2087089,1.2914319,4.3121547,2.4610714,11.1619159),(7396,'ulna-cleaned.tif',183,4,920,1.8260513,5.2914522,9.078578,1.8,5.2176629,9.0180495,0.8728559,0.7339061,2.2924563,0.0938621,2.7689454,0.1786525,1.2078509,0.1278939,1.1924224,1.2914319,4.3121547,2.4610714,11.2513972),(7397,'ulna-cleaned.tif',183,4,921,1.824519,5.2928981,9.0827112,1.8,5.2188907,9.0239374,0.8699465,0.7259256,2.2986129,0.0949555,2.7864319,0.1776309,1.2122232,0.1308061,1.1984379,1.2646998,4.3322289,2.4409582,11.2513972),(7398,'ulna-cleaned.tif',183,4,922,1.8207507,5.2906835,9.0792167,1.8,5.2184955,9.0198184,0.8697849,0.7118615,2.294628,0.0940141,2.7796701,0.1772157,1.2113816,0.132068,1.197103,1.2897478,4.3373705,2.4539214,11.3311972),(7399,'ulna-cleaned.tif',183,4,923,1.8060527,5.2919561,9.0824407,1.8,5.2208583,9.0252068,0.8693252,0.7334665,2.3239852,0.0917517,2.7504662,0.1756487,1.1835128,0.1250932,1.1662861,1.2610462,4.3432393,2.4668517,11.2554074),(7400,'ulna-cleaned.tif',183,4,924,1.8028993,5.2914976,9.0818324,1.8,5.2191718,9.0247392,0.86756,0.7856434,2.3503186,0.0910711,2.753535,0.1748189,1.1715582,0.1159191,1.1516194,1.3026881,4.374467,2.4725497,11.298143),(7401,'ulna-cleaned.tif',183,4,925,1.8145137,5.2788703,9.0744792,1.8,5.1993431,9.0124867,0.8596067,0.8144899,2.3945627,0.0965807,2.8099998,0.1735692,1.1734918,0.1185781,1.1517339,1.3454596,4.4554207,2.4640545,11.5238515),(7402,'ulna-cleaned.tif',183,4,926,1.8133808,5.2761153,9.0728889,1.8,5.1969751,9.0106812,0.8579527,0.791807,2.4230572,0.0963727,2.8194451,0.1729664,1.16359,0.1217124,1.1474333,1.3199482,4.4618478,2.4766279,11.2787803),(7403,'ulna-cleaned.tif',183,4,927,1.7913477,5.2847071,9.0813785,1.8,5.2150746,9.0276611,0.8612479,0.7661287,2.4065645,0.0910739,2.7511852,0.1718378,1.1432003,0.1188755,1.1282983,1.2997339,4.4305174,2.4710711,11.2320345),(7404,'ulna-cleaned.tif',183,4,928,1.7975769,5.2824375,9.0793396,1.8,5.2110715,9.0225669,0.8606121,0.7642618,2.3477441,0.0900276,2.7720788,0.172247,1.1807415,0.1177967,1.1629475,1.2997339,4.374467,2.4725497,11.1465633),(7405,'ulna-cleaned.tif',183,4,929,1.786016,5.2834916,9.0799323,1.8,5.2153192,9.0256034,0.8602063,0.7637337,2.3231542,0.0872726,2.7423618,0.1710198,1.1804476,0.114271,1.1589897,1.2982568,4.3498322,2.479745,11.325526),(7406,'ulna-cleaned.tif',183,4,930,1.7788759,5.2827238,9.0780439,1.8,5.2131165,9.0205741,0.8592071,0.7318509,2.3219284,0.0852888,2.7423101,0.1700431,1.1810485,0.1165386,1.1651415,1.2551374,4.3432393,2.4668517,11.4246888),(7407,'ulna-cleaned.tif',183,4,931,1.7502577,5.2925501,9.0855173,1.8,5.2259758,9.0303408,0.8628997,0.7169694,2.3313736,0.0796494,2.663358,0.1683723,1.1423986,0.1110918,1.124585,1.2310742,4.3682757,2.4597192,11.2320345),(7408,'ulna-cleaned.tif',183,4,932,1.7316101,5.312189,9.1013969,1.8,5.2566921,9.0549845,0.8709936,0.710089,2.3245921,0.0745662,2.6011521,0.1688833,1.1189714,0.1050097,1.1008339,1.2085603,4.3121547,2.4610714,11.0958074),(7409,'ulna-cleaned.tif',183,4,933,1.7178829,5.3213772,9.1090081,1.8,5.2704303,9.0653812,0.8725999,0.6548406,2.2838869,0.0720925,2.5624448,0.1679976,1.1219666,0.1100916,1.1088533,1.1648368,4.2504271,2.4492582,11.1248515),(7410,'ulna-cleaned.tif',183,4,934,1.6959181,5.3326016,9.1191432,1.8,5.285463,9.0766389,0.8775216,0.6016599,2.1936109,0.0676273,2.503603,0.1672184,1.1413159,0.1124012,1.13289,1.1213696,4.1330701,2.4382019,10.6968074),(7411,'ulna-cleaned.tif',183,4,935,1.6829149,5.3450597,9.1296055,1.8,5.3024147,9.09035,0.8804531,0.5748962,2.1825941,0.0648621,2.4499695,0.1667442,1.1225035,0.112824,1.1203755,1.0995688,4.0957307,2.4044329,10.3912989),(7412,'ulna-cleaned.tif',183,4,936,1.6737195,5.353431,9.1373453,1.8,5.317401,9.1036273,0.8836551,0.5721759,2.1471143,0.0628468,2.4222995,0.1667096,1.1281651,0.1098382,1.1364246,1.0981694,4.0370047,2.3911453,10.4944718),(7413,'ulna-cleaned.tif',183,4,937,1.6687758,5.3549368,9.1379422,1.8,5.3202183,9.1035175,0.8821839,0.5645366,2.0929769,0.0623549,2.4086947,0.1658158,1.1508463,0.1104532,1.1556259,1.0957081,3.9830115,2.4057992,10.3348718),(7414,'ulna-cleaned.tif',183,4,938,1.6572519,5.3580353,9.1426457,1.8,5.3272306,9.1121918,0.8836728,0.5162542,2.0726611,0.0603016,2.3922228,0.1650742,1.1541794,0.116806,1.1572667,1.0413521,3.9563421,2.4132753,10.3582446),(7415,'ulna-cleaned.tif',183,4,939,1.653532,5.3633479,9.1472081,1.8,5.3325686,9.1158867,0.8834618,0.5115126,2.1049538,0.0597549,2.3795997,0.1646466,1.130476,0.11682,1.1374619,1.0379073,3.9806126,2.3916406,10.1091633),(7416,'ulna-cleaned.tif',183,4,940,1.6434958,5.3622503,9.1446218,1.8,5.3320271,9.1113043,0.8828687,0.5128407,2.0716765,0.0584105,2.3640312,0.1634879,1.1411199,0.1138959,1.1443453,1.0447033,3.9515105,2.3847581,9.996309),(7417,'ulna-cleaned.tif',183,4,941,1.6367883,5.3679678,9.1517143,1.8,5.3418742,9.1242391,0.8809304,0.5161497,2.0870079,0.0582473,2.3669241,0.1623017,1.1341232,0.1128496,1.1408393,1.0407671,3.9535244,2.3990254,10.2026548),(7418,'ulna-cleaned.tif',183,4,942,1.6249644,5.3637491,9.1495057,1.8,5.3326997,9.1165385,0.8796227,0.4894227,2.1032303,0.0576371,2.3560269,0.1607815,1.1201945,0.1177654,1.1214102,1.0106542,3.9830115,2.4057992,10.3114989),(7419,'ulna-cleaned.tif',183,4,943,1.6196965,5.3675362,9.1548615,1.8,5.3402858,9.1249493,0.8780118,0.5233411,2.1157224,0.0575742,2.361141,0.159833,1.1159976,0.1100128,1.1204842,1.0407671,3.9830115,2.4057992,10.2550718),(7420,'ulna-cleaned.tif',183,4,944,1.6206035,5.3601711,9.1498456,1.8,5.3272783,9.1142808,0.8763766,0.5285091,2.133335,0.057524,2.3563961,0.1594882,1.1045598,0.108842,1.1100294,1.0264892,3.9830115,2.4057992,10.2647531),(7421,'ulna-cleaned.tif',183,4,945,1.6211987,5.3646635,9.1567944,1.8,5.3366081,9.1278559,0.874885,0.5319817,2.1421749,0.0570944,2.3642225,0.1591503,1.1036552,0.107324,1.1094174,1.0407671,4.0099005,2.3984229,10.9071633),(7422,'ulna-cleaned.tif',183,4,946,1.6141,5.3627728,9.15439,1.8,5.3329699,9.1222402,0.8721197,0.5059224,2.1402645,0.0564899,2.3588958,0.1577211,1.1021516,0.1116572,1.1082147,1.0106542,4.0099005,2.3984229,10.4420548),(7423,'ulna-cleaned.tif',183,4,947,1.6098181,5.3612936,9.1550178,1.8,5.3312777,9.1236974,0.8729667,0.5366074,2.1394455,0.0560727,2.3636256,0.1575265,1.1047842,0.1044948,1.1105766,0.9701092,4.0099005,2.3984229,10.0059904),(7424,'ulna-cleaned.tif',183,4,948,1.6145355,5.3587036,9.1530749,1.8,5.3260539,9.1170991,0.8711369,0.5403674,2.1370417,0.0574303,2.3806089,0.1575031,1.113974,0.1062801,1.1173177,1.0525756,3.9901996,2.434051,10.2921362),(7425,'ulna-cleaned.tif',183,4,949,1.6165862,5.3577095,9.1540689,1.8,5.3291545,9.1226872,0.869245,0.5448931,2.1684037,0.0571677,2.3923214,0.1572007,1.1032638,0.1049155,1.1101334,1.0525756,4.0393702,2.4051065,10.7145091),(7426,'ulna-cleaned.tif',183,4,950,1.6173391,5.3525034,9.1510876,1.8,5.317483,9.1133235,0.8655626,0.5530017,2.1854749,0.0572859,2.4101015,0.1562946,1.1027816,0.1035909,1.105507,1.0712354,4.0690177,2.411693,11.0627532),(7427,'ulna-cleaned.tif',183,4,951,1.6033169,5.3602781,9.1690111,1.8,5.3290923,9.1373754,0.8607977,0.5103472,2.2105188,0.0548181,2.3654279,0.1536817,1.0700782,0.1074133,1.0761106,0.9689261,4.0690177,2.411693,9.996309),(7428,'ulna-cleaned.tif',183,4,952,1.5999036,5.3615756,9.1714274,1.8,5.3337481,9.142751,0.8599318,0.5123737,2.213525,0.0546426,2.3544664,0.1531262,1.0636728,0.1066461,1.0699634,0.9689261,4.0690177,2.411693,9.9632548),(7429,'ulna-cleaned.tif',183,4,953,1.597081,5.356099,9.16799,1.8,5.3250597,9.1367891,0.8571114,0.4887739,2.2083985,0.0549343,2.3643735,0.1521133,1.0706281,0.112392,1.0775703,0.9733113,4.0425219,2.4190487,9.8834548),(7430,'ulna-cleaned.tif',183,4,954,1.5876647,5.3591448,9.1725152,1.8,5.33048,9.1435762,0.8554021,0.4779769,2.210494,0.0537138,2.3539967,0.1507687,1.0649189,0.1123773,1.0699307,0.9733113,4.0690177,2.411693,9.9068277),(7431,'ulna-cleaned.tif',183,4,955,1.5840809,5.3616493,9.1782539,1.8,5.3354295,9.1523202,0.8551982,0.4801537,2.216554,0.0533301,2.3409894,0.1503751,1.0561391,0.1110687,1.0613767,0.9733113,4.0690177,2.411693,10.0059904),(7432,'ulna-cleaned.tif',183,4,956,1.5896478,5.364887,9.1837901,1.8,5.3392574,9.1581932,0.8539955,0.4831388,2.2272253,0.0534398,2.3567308,0.1505879,1.0581466,0.1106096,1.065582,0.9733113,4.0690177,2.411693,9.916509),(7433,'ulna-cleaned.tif',183,4,957,1.5841277,5.3563355,9.1766472,1.8,5.3234324,9.1426313,0.8514934,0.4886003,2.239671,0.0535995,2.3577842,0.1494104,1.0527369,0.1097002,1.056639,0.9933845,4.0725374,2.4255276,10.0527362),(7434,'ulna-cleaned.tif',183,4,958,1.5731326,5.359737,9.1817877,1.8,5.3298112,9.1509388,0.850714,0.4905872,2.2461193,0.0527282,2.3377476,0.1481708,1.0407941,0.1074798,1.0448054,0.9933845,4.0768352,2.4393357,10.1091633),(7435,'ulna-cleaned.tif',183,4,959,1.5676945,5.3611898,9.1857339,1.8,5.3329242,9.1577552,0.8492193,0.4607707,2.2506902,0.0524542,2.3298021,0.1472713,1.0351501,0.1138402,1.0395924,0.9607798,4.0988392,2.4181839,9.996309),(7436,'ulna-cleaned.tif',183,4,960,1.5666532,5.3587293,9.1849335,1.8,5.3289724,9.1547984,0.8469385,0.4886244,2.2494374,0.0528519,2.339888,0.1465826,1.0402103,0.1081647,1.0452776,1.0080872,4.0988392,2.4181839,10.3308616),(7437,'ulna-cleaned.tif',183,4,961,1.5644288,5.3579194,9.1854676,1.8,5.3261233,9.1525193,0.8465986,0.4753945,2.2494449,0.0523667,2.3298211,0.1462865,1.0357316,0.1101542,1.0408096,0.9828447,4.0819086,2.4531121,10.1518989),(7438,'ulna-cleaned.tif',183,4,962,1.5619759,5.3563111,9.187757,1.8,5.3229205,9.1545521,0.8436389,0.4661885,2.2513269,0.0524291,2.3275597,0.1452922,1.0338613,0.1124633,1.0397864,0.9595715,4.0819086,2.4531121,10.1615803),(7439,'ulna-cleaned.tif',183,4,963,1.5579237,5.3594785,9.1925627,1.8,5.3275682,9.1601222,0.8422622,0.4623345,2.257588,0.0524644,2.321989,0.1445602,1.0285264,0.1134771,1.0349024,0.9595715,4.0957307,2.4044329,10.0857904),(7440,'ulna-cleaned.tif',183,4,964,1.5654899,5.3558122,9.1921304,1.8,5.3245308,9.1605708,0.8400348,0.4630006,2.2557249,0.0526628,2.3458465,0.1446847,1.0399524,0.1137424,1.0468267,0.9658505,4.0988392,2.4181839,10.1752718),(7441,'ulna-cleaned.tif',183,4,965,1.5559566,5.3551433,9.1921532,1.8,5.3238759,9.1603193,0.8377337,0.4638438,2.2562128,0.051405,2.3234622,0.1432103,1.0298063,0.1108239,1.0367401,0.9576023,4.0988392,2.4181839,10.076109),(7442,'ulna-cleaned.tif',183,4,966,1.5558777,5.3522641,9.1908345,1.8,5.32093,9.1596278,0.8358962,0.467818,2.2540278,0.0511996,2.3230933,0.142729,1.030641,0.1094435,1.0378849,0.9576023,4.0819086,2.4531121,10.1051531),(7443,'ulna-cleaned.tif',183,4,967,1.5463374,5.3503873,9.1899448,1.8,5.3193132,9.159413,0.8341582,0.4656782,2.2527834,0.0508617,2.311258,0.1414081,1.0259566,0.1092208,1.0334789,0.9536637,4.0957307,2.4044329,10.0293633),(7444,'ulna-cleaned.tif',183,4,968,1.546749,5.3480588,9.1898424,1.8,5.3165862,9.1589706,0.8316717,0.4593014,2.2789702,0.0509057,2.3220335,0.1408076,1.018896,0.110833,1.0249254,0.9518253,4.1288308,2.4245808,10.2026548),(7445,'ulna-cleaned.tif',183,4,969,1.5473889,5.3422071,9.1879481,1.8,5.310566,9.1586285,0.829066,0.4564133,2.274676,0.0514075,2.3427329,0.1401966,1.0299194,0.1126337,1.0366774,0.9521463,4.1288308,2.4245808,10.0567463),(7446,'ulna-cleaned.tif',183,4,970,1.5448234,5.340258,9.1866667,1.8,5.3070903,9.1545853,0.8276455,0.4590217,2.2459817,0.0511651,2.3297921,0.1395998,1.0373157,0.1114655,1.0429024,0.9474403,4.0877546,2.4668517,9.8971463),(7447,'ulna-cleaned.tif',183,4,971,1.5406368,5.3374221,9.186179,1.8,5.3046283,9.1541033,0.8256783,0.4635949,2.2444159,0.0509309,2.3275574,0.1387181,1.0370437,0.1098608,1.0429922,0.9474403,4.0877546,2.4668517,9.8407192),(7448,'ulna-cleaned.tif',183,4,972,1.5446794,5.3388257,9.1889247,1.8,5.3064875,9.1563061,0.8238614,0.4676849,2.2751421,0.0515615,2.3454007,0.1386157,1.030881,0.1102484,1.0388367,0.9674943,4.1288308,2.4245808,9.9866277),(7449,'ulna-cleaned.tif',183,4,973,1.5384388,5.3410236,9.1938303,1.8,5.3100936,9.1635693,0.8231212,0.4698128,2.2805174,0.0511721,2.3327741,0.1378665,1.0229144,0.1089202,1.0310789,0.972902,4.1288308,2.4245808,10.2784446),(7450,'ulna-cleaned.tif',183,4,974,1.536438,5.337719,9.1933639,1.8,5.3031701,9.159885,0.8200893,0.4806418,2.3062841,0.0513217,2.3300669,0.1369128,1.0103121,0.1067775,1.0173063,0.9874746,4.1635799,2.4444004,10.3445531),(7451,'ulna-cleaned.tif',183,4,975,1.5317381,5.3423416,9.199991,1.8,5.3072748,9.1657593,0.819234,0.4795535,2.3146244,0.0506954,2.3114311,0.1362762,0.9986204,0.1057138,1.005775,0.9874746,4.1635799,2.4444004,10.5235159),(7452,'ulna-cleaned.tif',183,4,976,1.5298845,5.3442832,9.2056388,1.8,5.3089586,9.1725908,0.8159685,0.4971607,2.3213553,0.0505796,2.3115623,0.1352804,0.9957813,0.1017369,1.0036607,0.9874746,4.1551594,2.4173427,10.3542345),(7453,'ulna-cleaned.tif',183,4,977,1.5322875,5.3436473,9.2082394,1.8,5.3045983,9.1727965,0.8139707,0.4631105,2.3509755,0.0506059,2.3197572,0.1349836,0.9867211,0.109274,0.9932604,0.9656259,4.1893101,2.4370986,10.3348718),(7454,'ulna-cleaned.tif',183,4,978,1.5283043,5.3438883,9.2096616,1.8,5.3100251,9.1789309,0.8129157,0.4627271,2.3251786,0.0500186,2.3098017,0.1343643,0.9933868,0.1080952,0.9983067,0.9661183,4.1689296,2.4578833,10.2413803),(7455,'ulna-cleaned.tif',183,4,979,1.5231691,5.3446984,9.2132491,1.8,5.3102588,9.1815294,0.8120891,0.4836681,2.3286509,0.0494397,2.2891443,0.1337034,0.9830346,0.1022183,0.9915674,0.9874746,4.1635799,2.4444004,10.3912989),(7456,'ulna-cleaned.tif',183,4,980,1.5191341,5.3412629,9.2111827,1.8,5.3068447,9.1795663,0.8107413,0.4796188,2.325288,0.0488346,2.2902711,0.1330084,0.9849408,0.1018196,0.9934668,0.9592611,4.1551594,2.4173427,10.0994819),(7457,'ulna-cleaned.tif',183,4,981,1.5284928,5.3417636,9.214004,1.8,5.3040925,9.1789649,0.8086536,0.503593,2.3559911,0.0500799,2.3132961,0.1332966,0.9818781,0.0994452,0.9895255,1.0108267,4.1893101,2.4370986,10.5742718),(7458,'ulna-cleaned.tif',183,4,982,1.5269011,5.3416857,9.2158075,1.8,5.3074139,9.1840666,0.8085008,0.5006367,2.3573016,0.0497161,2.3095819,0.1331189,0.9797567,0.0993058,0.9873962,0.9828604,4.1942474,2.4505084,10.1792819),(7459,'ulna-cleaned.tif',183,4,983,1.5168571,5.3410349,9.2170676,1.8,5.3070596,9.1854835,0.8059148,0.4647091,2.3587618,0.0487905,2.2901961,0.1315901,0.9709315,0.1049916,0.9787985,0.9592611,4.1942474,2.4505084,10.3114989),(7460,'ulna-cleaned.tif',183,4,984,1.5161647,5.3418311,9.222257,1.8,5.3072016,9.1915419,0.8050092,0.4884405,2.3634002,0.0493241,2.2878373,0.1313014,0.9680279,0.1009827,0.9764987,0.9828604,4.1851278,2.4236595,10.6363701),(7461,'ulna-cleaned.tif',183,4,985,1.5201165,5.3379111,9.220651,1.8,5.3009543,9.1871001,0.8025367,0.4821442,2.3604483,0.0492431,2.3015805,0.1310176,0.9750607,0.1021337,0.9838908,0.9818756,4.1893101,2.4370986,10.5879633),(7462,'ulna-cleaned.tif',183,4,986,1.5160747,5.3389771,9.2228507,1.8,5.3023585,9.1890205,0.7992377,0.4737772,2.3639771,0.0487757,2.2934161,0.1298361,0.9701516,0.1029507,0.9793859,0.9544017,4.1942474,2.4505084,10.4670887),(7463,'ulna-cleaned.tif',183,4,987,1.5113749,5.3342393,9.2199857,1.8,5.2975257,9.1859948,0.7983582,0.4703551,2.3589359,0.0479885,2.2929324,0.1292121,0.9720198,0.1020262,0.9776714,0.9499663,4.1999371,2.4638844,10.3308616),(7464,'ulna-cleaned.tif',183,4,988,1.507915,5.33111,9.2194714,1.8,5.2936524,9.184317,0.7957109,0.4623863,2.3567369,0.0475368,2.2889038,0.1282512,0.9712174,0.1028076,0.9769587,0.9482823,4.1999371,2.4638844,10.3251904),(7465,'ulna-cleaned.tif',183,4,989,1.5115481,5.3317801,9.2218716,1.8,5.2959261,9.1885285,0.7951682,0.4878728,2.35914,0.048225,2.2927048,0.1284235,0.9718392,0.0988475,0.9780392,0.9766984,4.1942474,2.4505084,10.3348718),(7466,'ulna-cleaned.tif',183,4,990,1.5093334,5.332279,9.2248169,1.8,5.296365,9.1922328,0.7936671,0.4818164,2.3626602,0.0478955,2.2942962,0.1278578,0.9710649,0.099406,0.9776963,0.9766984,4.1999371,2.4638844,10.5178447),(7467,'ulna-cleaned.tif',183,4,991,1.5050819,5.3350587,9.22849,1.8,5.2958413,9.1924047,0.7928375,0.4802627,2.3950938,0.04801,2.2864931,0.1272896,0.954657,0.0999662,0.9597323,0.9757136,4.2310936,2.4697972,10.3251904),(7468,'ulna-cleaned.tif',183,4,992,1.5007757,5.3287186,9.2244766,1.8,5.2879088,9.1870295,0.7903208,0.473115,2.3888423,0.0475167,2.2836793,0.1262959,0.9559774,0.1004338,0.961334,0.9689936,4.2310936,2.4697972,10.2220175),(7469,'ulna-cleaned.tif',183,4,993,1.5002094,5.3294393,9.2294001,1.8,5.290769,9.1955265,0.788139,0.4650648,2.3937455,0.0476873,2.2848202,0.1257028,0.9544959,0.1025391,0.9605119,0.9489815,4.2197906,2.4432224,10.3542345),(7470,'ulna-cleaned.tif',183,4,994,1.5040395,5.3283221,9.2301857,1.8,5.288567,9.1942698,0.7863666,0.4595761,2.394233,0.0478494,2.2947425,0.1255794,0.9584458,0.1041164,0.9648449,0.9489815,4.2310936,2.4697972,10.3388819),(7471,'ulna-cleaned.tif',183,4,995,1.5005623,5.3284476,9.2321656,1.8,5.289739,9.1970583,0.785253,0.4838949,2.4243869,0.0474336,2.2739613,0.1250106,0.9379532,0.0980246,0.9429748,0.9719478,4.2623959,2.4756234,10.3485633),(7472,'ulna-cleaned.tif',183,4,996,1.4942883,5.3240427,9.2293361,1.8,5.2887688,9.1967138,0.7838307,0.4796612,2.4198751,0.0469173,2.2705118,0.1241336,0.9382765,0.0978135,0.9433685,0.9636898,4.2623959,2.4756234,10.4106616),(7473,'ulna-cleaned.tif',183,4,997,1.4874966,5.3181654,9.2266414,1.8,5.2780323,9.1908019,0.7820042,0.4734227,2.4145746,0.0467672,2.2673149,0.1231166,0.9390122,0.0987853,0.9444511,0.9636898,4.2453676,2.4962118,10.5896244),(7474,'ulna-cleaned.tif',183,4,998,1.5052564,5.3082268,9.2203356,1.8,5.2638937,9.1806242,0.7797384,0.4936919,2.4323833,0.0483599,2.3080454,0.1240182,0.9488823,0.0979557,0.9535452,0.9874996,4.2871618,2.4683052,10.5936345),(7475,'ulna-cleaned.tif',183,4,999,1.5117873,5.3055651,9.2221169,1.8,5.2604362,9.1834,0.7774153,0.4857464,2.4327427,0.0486919,2.3192317,0.123971,0.9533403,0.1002415,0.9586649,0.983561,4.2871618,2.4683052,10.4243531),(7476,'ulna-cleaned.tif',183,4,1000,1.5019735,5.3085265,9.2273726,1.8,5.2676321,9.1930253,0.7754884,0.4798121,2.439356,0.0481115,2.306075,0.1226839,0.9453622,0.1002716,0.9510156,0.9602878,4.2938408,2.4813645,10.4904616),(7477,'ulna-cleaned.tif',183,4,1001,1.5010277,5.3060812,9.2275006,1.8,5.264261,9.1929965,0.7748153,0.4765194,2.4379812,0.0479841,2.3070705,0.1224383,0.9463037,0.1006971,0.952112,0.9583186,4.2938408,2.4813645,10.4009803),(7478,'ulna-cleaned.tif',183,4,1002,1.5018747,5.3062461,9.2282926,1.8,5.2680674,9.1960089,0.7737895,0.4762282,2.4390799,0.0482879,2.3022923,0.1222507,0.9439184,0.1013966,0.9500779,0.9874996,4.2812162,2.4552074,10.6363701),(7479,'ulna-cleaned.tif',183,4,1003,1.5039435,5.3058412,9.2287022,1.8,5.2694047,9.1958831,0.7747024,0.4755139,2.3822734,0.0477129,2.3002045,0.1226479,0.9655502,0.1003397,0.9708172,0.9874996,4.2310936,2.4697972,10.2824548),(7480,'ulna-cleaned.tif',183,4,1004,1.5076522,5.2993564,9.2258108,1.8,5.2623628,9.1938116,0.7724163,0.4677266,2.433713,0.0481348,2.3184373,0.122376,0.9526338,0.1029122,0.955149,0.9583186,4.3012497,2.494381,10.447726),(7481,'ulna-cleaned.tif',183,4,1005,1.5093285,5.2997898,9.2296339,1.8,5.2639527,9.1994552,0.7707138,0.489322,2.4374751,0.0489914,2.3236185,0.122084,0.9532891,0.1001211,0.956632,0.9783939,4.3012497,2.494381,10.687126),(7482,'ulna-cleaned.tif',183,4,1006,1.5092333,5.2928648,9.2249411,1.8,5.2586257,9.196086,0.7697943,0.4887761,2.4296568,0.0489588,2.3206448,0.1218451,0.9551328,0.100166,0.9586531,1.0121417,4.2938408,2.4813645,10.4984819),(7483,'ulna-cleaned.tif',183,4,1007,1.5073733,5.2939819,9.2263418,1.8,5.2569243,9.1931837,0.7677873,0.4918151,2.4323406,0.0490775,2.3244849,0.121191,0.9556577,0.0997886,0.9595929,1.0121417,4.3012497,2.494381,10.7338718),(7484,'ulna-cleaned.tif',183,4,1008,1.5105197,5.2872862,9.222195,1.8,5.2509982,9.1897855,0.766434,0.478556,2.4252469,0.049212,2.357231,0.1211035,0.9719551,0.1028344,0.9759921,0.9827244,4.3012497,2.494381,10.5041531),(7485,'ulna-cleaned.tif',183,4,1009,1.5024364,5.281499,9.2205904,1.8,5.2386609,9.1838186,0.7638727,0.4729584,2.4210882,0.0488975,2.3485414,0.1198146,0.9700354,0.1033864,0.9745972,0.9827244,4.3012497,2.494381,10.5178447),(7486,'ulna-cleaned.tif',183,4,1010,1.505559,5.2792271,9.2212683,1.8,5.2405832,9.1885285,0.7647347,0.4726844,2.4195419,0.0487212,2.3559407,0.1202797,0.9737135,0.1030734,0.9781368,0.9827244,4.2938408,2.4813645,10.3485633),(7487,'ulna-cleaned.tif',183,4,1011,1.5018528,5.2767431,9.2205259,1.8,5.2390687,9.1874356,0.7614041,0.4781885,2.4186685,0.0488855,2.3534832,0.1191508,0.9730491,0.1022306,0.9781906,0.9827244,4.3012497,2.494381,10.3912989),(7488,'ulna-cleaned.tif',183,4,1012,1.5076784,5.2787208,9.2255273,1.8,5.2433486,9.1950289,0.7603246,0.4848026,2.4240069,0.0493169,2.3659203,0.119342,0.9760369,0.1017257,0.9816642,0.996697,4.3012497,2.494381,10.4847904),(7489,'ulna-cleaned.tif',183,4,1013,1.5068945,5.2805924,9.2301019,1.8,5.2484152,9.2028327,0.7590984,0.4801434,2.4290281,0.049097,2.358489,0.1189724,0.9709599,0.1022548,0.9769276,0.9759051,4.3184263,2.4740666,10.5605803),(7490,'ulna-cleaned.tif',183,4,1014,1.5120948,5.280079,9.2329403,1.8,5.2463523,9.2048449,0.758578,0.4766121,2.4308243,0.0490474,2.3571588,0.119252,0.9696953,0.1029085,0.9759115,0.9759051,4.3012497,2.494381,10.4380447),(7491,'ulna-cleaned.tif',183,4,1015,1.5029319,5.2751618,9.2310741,1.8,5.2411604,9.2034682,0.7555742,0.4938145,2.427194,0.0485576,2.3482293,0.1177782,0.9674667,0.0983317,0.9741153,0.996399,4.3012497,2.494381,10.5645904),(7492,'ulna-cleaned.tif',183,4,1016,1.4981592,5.2756757,9.2343032,1.8,5.2405378,9.205216,0.7548692,0.4902408,2.4300646,0.0485302,2.3403541,0.1172285,0.9630831,0.0989925,0.9700256,0.9929542,4.3012497,2.494381,10.4944718),(7493,'ulna-cleaned.tif',183,4,1017,1.5016656,5.2758816,9.2374207,1.8,5.2437115,9.2110559,0.7530804,0.4859313,2.4330578,0.0486268,2.3499658,0.117056,0.9658488,0.1000692,0.9732123,0.99545,4.3184263,2.4740666,10.4710989),(7494,'ulna-cleaned.tif',183,4,1018,1.5044322,5.2743127,9.2380671,1.8,5.240236,9.2101965,0.7514448,0.4827338,2.4621475,0.0490064,2.3548314,0.1168625,0.9564136,0.1015185,0.9627476,0.99545,4.3498322,2.479745,10.6347091),(7495,'ulna-cleaned.tif',183,4,1019,1.5023882,5.2734167,9.2394763,1.8,5.2391605,9.2115229,0.7505771,0.4811085,2.4628124,0.0488676,2.3396229,0.1164869,0.9499801,0.1015729,0.9565891,0.99545,4.3571459,2.4925971,10.5976447),(7496,'ulna-cleaned.tif',183,4,1020,1.5000095,5.268386,9.23644,1.8,5.2281977,9.2020504,0.750075,0.4829844,2.457268,0.0486002,2.3405127,0.1161773,0.9524857,0.1006249,0.9590934,0.99545,4.3331475,2.4999332,10.527526),(7497,'ulna-cleaned.tif',183,4,1021,1.4905613,5.2846614,9.2523953,1.8,5.2530026,9.2241813,0.7510371,0.4765167,2.3940987,0.0471623,2.2995522,0.1156839,0.9605085,0.098973,0.9677653,0.9665157,4.2623959,2.4756234,10.3114989),(7498,'ulna-cleaned.tif',183,4,1022,1.4901861,5.2746439,9.2464774,1.8,5.2398722,9.2163172,0.7484274,0.4703802,2.4129652,0.0467231,2.3142623,0.1150083,0.9590948,0.0993306,0.9650541,0.9690114,4.2938408,2.4813645,10.5605803),(7499,'ulna-cleaned.tif',183,4,1023,1.49544,5.2761738,9.250305,1.8,5.2439019,9.2222178,0.746985,0.4655339,2.417268,0.0467663,2.3139276,0.1150553,0.9572491,0.1004573,0.9636016,0.9690114,4.3012497,2.494381,10.3445531),(7500,'ulna-cleaned.tif',183,4,1024,1.4972881,5.2741499,9.2510341,1.8,5.2416686,9.2230026,0.7461066,0.4843973,2.4166256,0.0466162,2.3108812,0.114979,0.9562429,0.0962355,0.9628025,0.987423,4.2858619,2.5148498,10.447726),(7501,'ulna-cleaned.tif',183,4,1025,1.4945104,5.2711867,9.2515698,1.8,5.2373104,9.222051,0.7432956,0.4827146,2.4159053,0.0464959,2.3144037,0.1140678,0.9579861,0.0963217,0.9650492,0.9608564,4.2773099,2.5018229,10.2687633),(7502,'ulna-cleaned.tif',183,4,1026,1.487097,5.2641801,9.2480522,1.8,5.2276296,9.2167908,0.7417839,0.477385,2.4089424,0.0462337,2.3112387,0.1131287,0.9594412,0.0968478,0.966724,0.9564292,4.2938408,2.4813645,10.4340345),(7503,'ulna-cleaned.tif',183,4,1027,1.4894574,5.2575808,9.2452312,1.8,5.2195234,9.2127576,0.7399562,0.471175,2.4886909,0.0464016,2.3281914,0.1128563,0.9355085,0.0984807,0.9422482,0.9581078,4.2858619,2.5148498,10.0857904),(7504,'ulna-cleaned.tif',183,4,1028,1.4905479,5.2592475,9.2473507,1.8,5.2235751,9.2154184,0.7386913,0.4707122,2.4918503,0.0467331,2.3293086,0.112626,0.9347707,0.0992818,0.9418673,0.962044,4.2951383,2.5278226,10.2978074),(7505,'ulna-cleaned.tif',183,4,1029,1.4940939,5.2498481,9.2444975,1.8,5.2067337,9.2088192,0.7353833,0.5076532,2.4842532,0.0471737,2.354909,0.1120741,0.9479344,0.092925,0.9557582,0.9844305,4.3651768,2.505404,10.3582446),(7506,'ulna-cleaned.tif',183,4,1030,1.4929999,5.2549916,9.2496662,1.8,5.215877,9.2163581,0.7354745,0.5074728,2.4351434,0.0471259,2.3415024,0.1120146,0.961546,0.0928639,0.9689564,0.9893484,4.3254251,2.4870219,10.3018175),(7507,'ulna-cleaned.tif',183,4,1031,1.4940735,5.2560322,9.2513618,1.8,5.2157527,9.2171528,0.7352602,0.5064387,2.4103705,0.0465316,2.3377158,0.1120421,0.9698574,0.09188,0.975021,0.9844305,4.3012497,2.494381,10.4340345),(7508,'ulna-cleaned.tif',183,4,1032,1.4918534,5.2541701,9.251945,1.8,5.2154383,9.2193512,0.7332035,0.5001974,2.4072757,0.0466889,2.3313784,0.1113669,0.9684717,0.093341,0.9776447,0.9844305,4.3012497,2.494381,10.2687633),(7509,'ulna-cleaned.tif',183,4,1033,1.4861453,5.2515957,9.2535689,1.8,5.2046933,9.2153115,0.7317861,0.4971495,2.4099615,0.0463033,2.3297571,0.1105917,0.9667196,0.0931376,0.9726903,0.9686192,4.318242,2.5202691,10.4670887),(7510,'ulna-cleaned.tif',183,4,1034,1.4822593,5.2534888,9.2559516,1.8,5.2124705,9.2210906,0.7321238,0.4973724,2.4128273,0.046221,2.3202104,0.1103854,0.9616148,0.0929303,0.9676086,0.9893484,4.3012497,2.494381,10.6734345),(7511,'ulna-cleaned.tif',183,4,1035,1.4745557,5.2558131,9.2613103,1.8,5.2125639,9.2263724,0.73048,0.464752,2.4187872,0.0455099,2.3078301,0.1094101,0.954127,0.097923,0.9603534,0.9505761,4.3093848,2.5073505,10.4340345),(7512,'ulna-cleaned.tif',183,4,1036,1.4776803,5.2517492,9.25923,1.8,5.2126032,9.2267841,0.7299758,0.4625131,2.4114437,0.0456342,2.3203288,0.1095185,0.9622156,0.0986657,0.9718507,0.9505761,4.3012497,2.494381,10.2550718),(7513,'ulna-cleaned.tif',183,4,1037,1.4709918,5.2476442,9.2573532,1.8,5.2070419,9.2231403,0.728538,0.4846735,2.410816,0.0455853,2.3078028,0.1086725,0.9572704,0.0940536,0.9639183,0.9681407,4.318242,2.5202691,10.1752718),(7514,'ulna-cleaned.tif',183,4,1038,1.4747533,5.2437663,9.2552932,1.8,5.2057788,9.2222812,0.7284862,0.4835167,2.4033612,0.046081,2.3197165,0.1089378,0.9651968,0.0953039,0.9753165,0.9686192,4.2938408,2.4813645,10.1655904),(7515,'ulna-cleaned.tif',183,4,1039,1.4751925,5.2389972,9.2551533,1.8,5.1975619,9.2209342,0.7253201,0.496704,2.4007269,0.046285,2.3341606,0.1081971,0.9722724,0.0931843,0.9829894,0.986055,4.3012497,2.494381,10.4807803),(7516,'ulna-cleaned.tif',183,4,1040,1.4763183,5.2386868,9.2573791,1.8,5.1973324,9.2242281,0.7251859,0.4945315,2.3755489,0.0459755,2.3242887,0.1082469,0.9784217,0.0929678,0.987403,0.9806467,4.2773099,2.5018229,10.3485633),(7517,'ulna-cleaned.tif',183,4,1041,1.4768635,5.2365905,9.2578881,1.8,5.2002635,9.2280019,0.7237874,0.4896244,2.4046928,0.0465991,2.3314796,0.1079452,0.969554,0.0951731,0.9776391,0.9893484,4.2951383,2.5278226,10.6170074),(7518,'ulna-cleaned.tif',183,4,1042,1.4730143,5.2325911,9.257688,1.8,5.1973992,9.2289219,0.7238319,0.4872254,2.3751232,0.0460513,2.3322683,0.1076747,0.9819568,0.0945174,0.9878417,0.9843656,4.2951383,2.5278226,10.288126),(7519,'ulna-cleaned.tif',183,4,1043,1.4851251,5.2237525,9.2524281,1.8,5.1896285,9.222668,0.7206855,0.4819449,2.3662394,0.046937,2.3754083,0.1077874,1.0038749,0.0973907,1.0104435,0.986055,4.318242,2.5202691,10.2453904),(7520,'ulna-cleaned.tif',183,4,1044,1.484456,5.2206371,9.251576,1.8,5.1904013,9.2262261,0.7191713,0.4802073,2.3939328,0.0472791,2.3668864,0.1073674,0.9887021,0.0984556,0.9942543,0.986055,4.318242,2.5202691,10.2220175),(7521,'ulna-cleaned.tif',183,4,1045,1.4891613,5.2138766,9.2481292,1.8,5.1773616,9.2174094,0.7180488,0.495403,2.413279,0.0474595,2.3867292,0.1074316,0.9889985,0.0957998,0.9969268,1.0060262,4.350747,2.5256075,10.6500616),(7522,'ulna-cleaned.tif',183,4,1046,1.4924716,5.2069909,9.2458484,1.8,5.1716762,9.2171894,0.7163198,0.4887075,2.4072266,0.0479301,2.3947592,0.1072443,0.9948208,0.0980753,1.0032991,1.0060262,4.3651768,2.505404,10.5936345),(7523,'ulna-cleaned.tif',183,4,1047,1.4804815,5.212704,9.253975,1.8,5.1813211,9.2289545,0.7156024,0.4917187,2.3870182,0.0470947,2.3732812,0.1062074,0.9942451,0.0957757,1.0041834,1.0082683,4.3415895,2.5127964,10.4944718),(7524,'ulna-cleaned.tif',183,4,1048,1.4903178,5.2030762,9.2477255,1.8,5.1694557,9.220807,0.712517,0.5104845,2.4068598,0.0482668,2.3967266,0.1061545,0.9957899,0.0945511,1.0051929,1.028348,4.3415895,2.5127964,10.4710989),(7525,'ulna-cleaned.tif',183,4,1049,1.4867781,5.2051361,9.2528504,1.8,5.1702632,9.2253595,0.7131062,0.4790532,2.385461,0.047612,2.385861,0.1060468,1.0001677,0.0993876,1.0074006,0.986055,4.3278168,2.5331325,10.6033159),(7526,'ulna-cleaned.tif',183,4,1050,1.4967665,5.1969296,9.2468686,1.8,5.1609144,9.217869,0.7122396,0.500865,2.4319451,0.0483588,2.4130742,0.1065454,0.9922404,0.0965505,1.0004056,1.0222511,4.3973349,2.510795,10.6734345),(7527,'ulna-cleaned.tif',183,4,1051,1.4901394,5.2011332,9.2533191,1.8,5.1588354,9.220475,0.7114962,0.5039246,2.4396177,0.0479852,2.3997946,0.105891,0.9836765,0.095223,0.9920383,1.0146749,4.4063766,2.5234484,10.6170074),(7528,'ulna-cleaned.tif',183,4,1052,1.4933494,5.1964013,9.2507866,1.8,5.1524872,9.2160024,0.7109815,0.4796956,2.3824936,0.047591,2.3914633,0.1059924,1.0037648,0.0992108,1.0076521,0.989565,4.3491001,2.5586791,10.500143),(7529,'ulna-cleaned.tif',183,4,1053,1.4866026,5.200605,9.2575859,1.8,5.1596164,9.2250394,0.7114512,0.5032648,2.3899161,0.04715,2.3682969,0.1056286,0.990954,0.0936882,0.9949888,1.0098974,4.3381046,2.5459371,10.5138345),(7530,'ulna-cleaned.tif',183,4,1054,1.4942281,5.1958577,9.257002,1.8,5.1503923,9.2214449,0.7104143,0.4984206,2.386377,0.0477715,2.3921536,0.1059151,1.0024206,0.0958458,1.0068891,1.0035097,4.350747,2.5256075,10.8620786),(7531,'ulna-cleaned.tif',183,4,1055,1.5026943,5.1939975,9.257547,1.8,5.1516642,9.2244595,0.7088705,0.4935392,2.4119408,0.0483916,2.4029843,0.106133,0.9962866,0.0980502,1.0036171,1.0035097,4.3833742,2.5308667,10.7258515),(7532,'ulna-cleaned.tif',183,4,1056,1.5081709,5.1918443,9.2581913,1.8,5.1414809,9.2184199,0.7080781,0.5135551,2.4110288,0.0493523,2.3985982,0.106323,0.9948442,0.0960992,1.0028296,1.028348,4.3833742,2.5308667,10.4807803),(7533,'ulna-cleaned.tif',183,4,1057,1.4961094,5.1915379,9.2625,1.8,5.1459171,9.2274757,0.7061083,0.5193586,2.3884484,0.0480359,2.3953583,0.1049875,1.002893,0.0924909,1.0086944,1.0439226,4.3381046,2.5459371,10.6306989),(7534,'ulna-cleaned.tif',183,4,1058,1.4946269,5.1983291,9.270449,1.8,5.1567163,9.2374961,0.7057655,0.5214093,2.3989114,0.048299,2.3737168,0.1047992,0.9894975,0.0926316,0.9957951,1.0439226,4.350747,2.5256075,10.5138345),(7535,'ulna-cleaned.tif',183,4,1059,1.4991845,5.1906617,9.2671569,1.8,5.1495983,9.2356011,0.7034865,0.4985015,2.3660325,0.0485113,2.396247,0.1045567,1.0127701,0.0973142,1.0170866,1.0169077,4.3381046,2.5459371,10.3388819),(7536,'ulna-cleaned.tif',183,4,1060,1.493035,5.192946,9.2728933,1.8,5.1556501,9.2439933,0.7024051,0.5003041,2.3977166,0.0484574,2.3808259,0.1038624,0.9929555,0.0968559,1.0001629,1.0169077,4.3606156,2.5383628,10.4146718),(7537,'ulna-cleaned.tif',183,4,1061,1.4949073,5.1925537,9.2749234,1.8,5.1530672,9.2443989,0.7023037,0.4975417,2.3729933,0.0485133,2.3753569,0.1039677,1.000996,0.097506,1.0060762,1.010031,4.315845,2.5535901,10.3114989),(7538,'ulna-cleaned.tif',183,4,1062,1.4990243,5.1859163,9.2715248,1.8,5.1477825,9.2403518,0.7010707,0.5053444,2.3662407,0.0483041,2.3869379,0.1039503,1.0087469,0.0955865,1.0139297,1.0169077,4.3278168,2.5331325,10.3912989),(7539,'ulna-cleaned.tif',183,4,1063,1.482078,5.20206,9.2875991,1.8,5.1716231,9.262849,0.7020177,0.5013981,2.3885562,0.0472063,2.3284211,0.1030058,0.9748237,0.0941494,0.9801087,1.010031,4.3381046,2.5459371,10.3582446),(7540,'ulna-cleaned.tif',183,4,1064,1.485682,5.1936317,9.2829124,1.8,5.1640494,9.2584006,0.6994677,0.5054188,2.3544446,0.0474669,2.3464167,0.1026339,0.9965903,0.093916,0.9998543,1.0032259,4.315845,2.5535901,10.3388819),(7541,'ulna-cleaned.tif',183,4,1065,1.4840201,5.1897845,9.2824407,1.8,5.1607165,9.2584065,0.6988591,0.5088913,2.3465829,0.0481492,2.342195,0.1023708,0.9981301,0.0946158,1.0058918,1.0306612,4.2938408,2.5613219,10.3251904),(7542,'ulna-cleaned.tif',183,4,1066,1.4835464,5.1853996,9.2835172,1.8,5.1544406,9.2604341,0.6978516,0.5136507,2.349225,0.0476614,2.353126,0.1020927,1.0016605,0.0927895,1.0056163,1.0306612,4.3051343,2.5407373,10.3912989),(7543,'ulna-cleaned.tif',183,4,1067,1.4786494,5.1821628,9.2841504,1.8,5.1472837,9.2563598,0.6963631,0.5178578,2.3477781,0.0472973,2.3499902,0.1013946,1.0009422,0.0913327,1.0052013,1.0292509,4.3051343,2.5407373,10.3582446),(7544,'ulna-cleaned.tif',183,4,1068,1.4758952,5.1797477,9.2848683,1.8,5.1453032,9.2584138,0.6943683,0.4966217,2.3472129,0.0471845,2.3435334,0.100723,0.9984324,0.095011,1.003178,1.0084094,4.315845,2.5535901,10.4574074),(7545,'ulna-cleaned.tif',183,4,1069,1.4798109,5.1715546,9.2802766,1.8,5.1395525,9.2535394,0.6938621,0.4989037,2.3278704,0.0474917,2.3551652,0.1008675,1.0117253,0.0951921,1.0205992,1.0169794,4.2951383,2.5278226,10.3872887),(7546,'ulna-cleaned.tif',183,4,1070,1.4802603,5.1718104,9.2862415,1.8,5.1403893,9.261578,0.6927408,0.5045875,2.3171679,0.0475725,2.3661479,0.1006261,1.0211379,0.09428,1.0239419,1.0270569,4.2827034,2.5484221,10.2220175),(7547,'ulna-cleaned.tif',183,4,1071,1.4871047,5.1625358,9.282016,1.8,5.1260023,9.2543224,0.690209,0.5221791,2.3338189,0.0480456,2.3824591,0.1004749,1.0208415,0.0920098,1.0269155,1.0159218,4.3051343,2.5407373,10.6460515),(7548,'ulna-cleaned.tif',183,4,1072,1.4833602,5.1638607,9.2838794,1.8,5.1300942,9.2565808,0.690684,0.5101441,2.3358401,0.0476782,2.3670238,0.1003373,1.0133501,0.0934603,1.0193434,1.0322331,4.315845,2.5535901,10.3348718),(7549,'ulna-cleaned.tif',183,4,1073,1.4867882,5.1549473,9.281788,1.8,5.1104284,9.2485663,0.6894296,0.5158318,2.3227178,0.048141,2.3825739,0.1002639,1.0257699,0.0933269,1.0360224,1.0160738,4.3051343,2.5407373,10.3445531),(7550,'ulna-cleaned.tif',183,4,1074,1.49052,5.1534694,9.2838645,1.8,5.1126986,9.2528573,0.6883684,0.5164524,2.3540598,0.0487485,2.3998079,0.1002569,1.0194337,0.0943911,1.0287404,1.0326989,4.3278168,2.5331325,10.5178447),(7551,'ulna-cleaned.tif',183,4,1075,1.4844426,5.1522652,9.2850689,1.8,5.1054953,9.2482761,0.6870016,0.506323,2.3290654,0.0483114,2.3929374,0.0995164,1.0274239,0.0954162,1.0346723,1.0159218,4.3051343,2.5407373,10.4904616),(7552,'ulna-cleaned.tif',183,4,1076,1.4832283,5.1539863,9.290086,1.8,5.1121103,9.2581824,0.6858368,0.506609,2.3340127,0.0478228,2.3863325,0.0991526,1.0224163,0.0943979,1.0299149,1.0082207,4.315845,2.5535901,10.2824548),(7553,'ulna-cleaned.tif',183,4,1077,1.4764204,5.152001,9.2913372,1.8,5.1097167,9.258332,0.6846735,0.5019168,2.3646048,0.0472582,2.3702092,0.098417,1.0023701,0.0941555,1.0085786,1.0253337,4.3606156,2.5383628,10.5976447),(7554,'ulna-cleaned.tif',183,4,1078,1.4779483,5.1512007,9.2949767,1.8,5.1093884,9.2645687,0.684054,0.4975028,2.366527,0.0471993,2.3845414,0.0983694,1.0076122,0.0948724,1.0140607,1.0179685,4.3381046,2.5459371,10.4847904),(7555,'ulna-cleaned.tif',183,4,1079,1.4811784,5.1454315,9.2937248,1.8,5.1023352,9.261992,0.6828089,0.5113618,2.3365659,0.0471768,2.3856768,0.0982833,1.0210184,0.0922572,1.0253367,1.0080686,4.315845,2.5535901,10.1889633),(7556,'ulna-cleaned.tif',183,4,1080,1.4812269,5.1441471,9.2957013,1.8,5.1003809,9.2640185,0.6818295,0.5126918,2.3506956,0.0471422,2.4027995,0.0980499,1.0221653,0.0919504,1.032608,1.0080686,4.3331475,2.4999332,10.4847904),(7557,'ulna-cleaned.tif',183,4,1081,1.4813339,5.1328031,9.2904027,1.8,5.0856483,9.2563634,0.6803287,0.5064482,2.3256756,0.0470336,2.4046988,0.0976945,1.0339786,0.0928695,1.0388306,1.0080686,4.3381046,2.5459371,10.3058277),(7558,'ulna-cleaned.tif',183,4,1082,1.4802231,5.1346057,9.2951278,1.8,5.0882848,9.2604308,0.6791225,0.5013245,2.3555905,0.046895,2.4122185,0.0973303,1.0240399,0.0935422,1.0316257,1.0080686,4.3491001,2.5586791,10.3719362),(7559,'ulna-cleaned.tif',183,4,1083,1.4791146,5.1296749,9.2945515,1.8,5.0885655,9.2643272,0.6781324,0.4965577,2.3267186,0.046147,2.4132141,0.0970189,1.0371749,0.0929338,1.0423733,0.9808607,4.327265,2.5663771,10.1792819),(7560,'ulna-cleaned.tif',183,4,1084,1.4775424,5.1241299,9.2946973,1.8,5.0800652,9.2620522,0.6755904,0.4875363,2.3234699,0.0463294,2.4138239,0.0963044,1.0388875,0.0950276,1.0448179,0.9808607,4.327265,2.5663771,10.3582446),(7561,'ulna-cleaned.tif',183,4,1085,1.483862,5.126564,9.2996881,1.8,5.0870146,9.2715861,0.6765206,0.4871558,2.3281365,0.0464863,2.4291933,0.0969409,1.0434068,0.095424,1.0493745,0.9571273,4.3381046,2.5459371,10.2220175),(7562,'ulna-cleaned.tif',183,4,1086,1.4783767,5.1256104,9.30226,1.8,5.0868319,9.2740042,0.6746636,0.5054979,2.3359385,0.0465098,2.4222472,0.096136,1.0369482,0.0920079,1.039339,0.9660181,4.3393888,2.5790947,10.447726),(7563,'ulna-cleaned.tif',183,4,1087,1.4759936,5.1165538,9.2992293,1.8,5.0662836,9.2625728,0.6732165,0.5302688,2.327589,0.0465915,2.4325043,0.0956339,1.0450747,0.0878638,1.047844,0.9968665,4.3393888,2.5790947,10.367926),(7564,'ulna-cleaned.tif',183,4,1088,1.4655338,5.1175217,9.3026543,1.8,5.0771188,9.2738267,0.6718811,0.5253313,2.3807149,0.0459744,2.4175723,0.0946382,1.0154817,0.0875151,1.0233883,0.9792122,4.3824662,2.5636907,10.6266887),(7565,'ulna-cleaned.tif',183,4,1089,1.46421,5.1208411,9.3092599,1.8,5.0775403,9.2781583,0.671697,0.5218315,2.3874896,0.0459809,2.4048738,0.094509,1.0072814,0.0881144,1.0155089,0.9837967,4.3935319,2.5435148,10.4517362),(7566,'ulna-cleaned.tif',183,4,1090,1.4578964,5.1218943,9.3148664,1.8,5.0835406,9.2890598,0.6711799,0.5169837,2.367169,0.0452335,2.4001587,0.093979,1.0139363,0.087495,1.0200441,0.9749695,4.3711903,2.5510584,10.5879633),(7567,'ulna-cleaned.tif',183,4,1091,1.4468916,5.1206053,9.3172507,1.8,5.0805877,9.2898325,0.6693774,0.5104275,2.3435593,0.044478,2.3806811,0.0928465,1.01584,0.0871388,1.019814,0.9557596,4.3607981,2.5713547,10.4614175),(7568,'ulna-cleaned.tif',183,4,1092,1.4546537,5.114073,9.3156577,1.8,5.0709912,9.285701,0.6676993,0.504013,2.318239,0.045135,2.4109865,0.0929488,1.0400077,0.0895513,1.0511527,0.9603441,4.318242,2.5202691,10.3485633),(7569,'ulna-cleaned.tif',183,4,1093,1.4565693,5.112078,9.3189061,1.8,5.0706221,9.2913113,0.6661491,0.5215463,2.3503992,0.045397,2.4168664,0.0927053,1.0282791,0.087043,1.0419056,0.9557596,4.350747,2.5256075,10.2026548),(7570,'ulna-cleaned.tif',183,4,1094,1.4612274,5.1036236,9.3173259,1.8,5.0587842,9.2878907,0.6645493,0.5140811,2.3431599,0.0457833,2.4359401,0.0926234,1.0395962,0.0890586,1.0501632,0.9703851,4.350747,2.5256075,10.3582446),(7571,'ulna-cleaned.tif',183,4,1095,1.4602413,5.105096,9.3190178,1.8,5.0601358,9.2887276,0.664714,0.5140163,2.3521165,0.0456608,2.4397564,0.0925998,1.0372601,0.0888314,1.0485038,0.9703851,4.3833742,2.5308667,10.6443904),(7572,'ulna-cleaned.tif',183,4,1096,1.4540309,5.1057507,9.3241246,1.8,5.0623956,9.2954464,0.6632254,0.5071495,2.3493351,0.0451622,2.4308424,0.0918558,1.0346938,0.0890511,1.045468,0.9381053,4.350747,2.5256075,10.4049904),(7573,'ulna-cleaned.tif',183,4,1097,1.4647826,5.0965608,9.3199716,1.8,5.0501949,9.2894424,0.6618978,0.5088281,2.3398381,0.0457831,2.4496194,0.0922207,1.0469183,0.0899775,1.0581499,0.9469324,4.350747,2.5256075,10.3816175),(7574,'ulna-cleaned.tif',183,4,1098,1.4640466,5.0957768,9.3220726,1.8,5.052631,9.2928129,0.6623888,0.5077297,2.3051709,0.0459018,2.4382352,0.0922905,1.0577242,0.090406,1.0618093,0.9383722,4.327265,2.5663771,10.3445531),(7575,'ulna-cleaned.tif',183,4,1099,1.4728363,5.0912895,9.3210714,1.8,5.0498097,9.2936394,0.6622249,0.5054129,2.3117498,0.0460098,2.4551609,0.0928056,1.0620357,0.0910342,1.0711181,0.9383722,4.350747,2.5256075,10.3816175),(7576,'ulna-cleaned.tif',183,4,1100,1.4689344,5.0894192,9.3208376,1.8,5.0500955,9.294028,0.6626725,0.5053933,2.2992856,0.0460405,2.438791,0.092666,1.0606734,0.0910984,1.0649231,0.9469324,4.3393888,2.5790947,10.5041531),(7577,'ulna-cleaned.tif',183,4,1101,1.4705907,5.0864931,9.3239559,1.8,5.0407488,9.2937825,0.6619009,0.4995042,2.3098212,0.0460417,2.4557647,0.0925871,1.0631839,0.0921747,1.0727056,0.9469324,4.3607981,2.5713547,10.4614175),(7578,'ulna-cleaned.tif',183,4,1102,1.4642812,5.0849017,9.3250289,1.8,5.0426614,9.2978402,0.6619119,0.5222263,2.2985996,0.0464483,2.4278969,0.0921924,1.0562505,0.0889429,1.0613373,0.9917684,4.327265,2.5663771,10.7862888),(7579,'ulna-cleaned.tif',183,4,1103,1.4537161,5.0835139,9.3277308,1.8,5.0426001,9.3005747,0.66007,0.5152902,2.3102322,0.0456097,2.4211039,0.0910947,1.0479916,0.0885126,1.0580359,0.9574358,4.350747,2.5256075,10.0801192),(7580,'ulna-cleaned.tif',183,4,1104,1.4632554,5.0811484,9.3291829,1.8,5.0445946,9.3059955,0.6605128,0.5136425,2.3091492,0.0465548,2.4270532,0.0917971,1.0510595,0.0906366,1.0616258,0.9592852,4.350747,2.5256075,10.4049904),(7581,'ulna-cleaned.tif',183,4,1105,1.4774099,5.0749531,9.3285455,1.8,5.0317608,9.3005885,0.6585662,0.5377346,2.3501475,0.0479011,2.4613121,0.0922209,1.0473011,0.0890795,1.0549885,1.0036821,4.4159406,2.5686265,10.6113362),(7582,'ulna-cleaned.tif',183,4,1106,1.4746594,5.0720703,9.3278797,1.8,5.0296572,9.2990666,0.6597233,0.5074147,2.3013637,0.0473556,2.4402783,0.0923246,1.0603619,0.0933272,1.071601,0.9801686,4.3415895,2.5127964,10.4614175),(7583,'ulna-cleaned.tif',183,4,1107,1.4714665,5.0708964,9.3311572,1.8,5.0284627,9.3039914,0.658639,0.557761,2.3026902,0.0478408,2.4453412,0.0918672,1.0619497,0.085773,1.0775968,1.0036821,4.350747,2.5256075,10.4186819),(7584,'ulna-cleaned.tif',183,4,1108,1.4765689,5.0594031,9.3276383,1.8,5.0175976,9.3030537,0.6567195,0.5250509,2.379428,0.0487782,2.4654081,0.0917287,1.0361348,0.0929018,1.0515876,0.9807964,4.350747,2.5256075,10.3912989),(7585,'ulna-cleaned.tif',183,4,1109,1.4802051,5.0606698,9.3294374,1.8,5.0216123,9.3057076,0.656907,0.54916,2.381486,0.0495115,2.4646773,0.0919993,1.0349326,0.0901586,1.0506974,1.0036821,4.3607981,2.5713547,10.3388819),(7586,'ulna-cleaned.tif',183,4,1110,1.4799037,5.0492469,9.323989,1.8,5.0077209,9.2967002,0.6551021,0.5426618,2.3695254,0.0495853,2.4745838,0.0915502,1.0443373,0.0913743,1.06044,1.0036821,4.3415895,2.5127964,10.527526),(7587,'ulna-cleaned.tif',183,4,1111,1.4849432,5.0400662,9.3202205,1.8,4.9940247,9.2900323,0.6545455,0.5388785,2.3600734,0.0501199,2.4961323,0.0917289,1.0576503,0.0930077,1.0741307,1.0363662,4.3607981,2.5713547,10.5936345),(7588,'ulna-cleaned.tif',183,4,1112,1.4862808,5.0347671,9.3211431,1.8,4.9908012,9.2924662,0.6543653,0.5345398,2.3564705,0.0500842,2.5015175,0.0917684,1.0615526,0.0936959,1.0782043,1.0363662,4.4389536,2.5286576,10.6968074),(7589,'ulna-cleaned.tif',183,4,1113,1.4919117,5.0223391,9.3145324,1.8,4.9755764,9.2823206,0.6526253,0.5285662,2.4305885,0.05082,2.5151596,0.0916984,1.0347945,0.096147,1.0510757,1.0363662,4.4489843,2.5411529,10.9886244),(7590,'ulna-cleaned.tif',183,4,1114,1.4705826,5.033987,9.3264908,1.8,4.9984818,9.3039115,0.6537472,0.5042481,2.366645,0.0499126,2.4345104,0.0906528,1.0286758,0.0989843,1.0431127,0.9868312,4.3607981,2.5713547,10.7201803),(7591,'ulna-cleaned.tif',183,4,1115,1.4744915,5.0278486,9.3271658,1.8,4.9880098,9.3015421,0.6512661,0.5190027,2.3628292,0.0511715,2.4618611,0.0903055,1.0419124,0.0985959,1.0573049,1.0363662,4.3522105,2.5917395,10.395309),(7592,'ulna-cleaned.tif',183,4,1116,1.4984282,5.0186774,9.3253436,1.8,4.97844,9.3012481,0.6490736,0.5102759,2.3549807,0.0525774,2.5093026,0.0912438,1.06553,0.1030373,1.0818584,1.0036821,4.4489843,2.5411529,10.5412175),(7593,'ulna-cleaned.tif',183,4,1117,1.4882231,5.0099123,9.3216384,1.8,4.9681088,9.294826,0.6481891,0.5137929,2.3459751,0.0519701,2.4954585,0.0904112,1.0637191,0.1011498,1.0800507,1.0072756,4.4489843,2.5411529,10.7241904),(7594,'ulna-cleaned.tif',183,4,1118,1.4957803,5.0050846,9.3206997,1.8,4.9654369,9.2960197,0.6473732,0.5099641,2.2936295,0.0523426,2.5059216,0.0906745,1.0925573,0.1026398,1.1057414,0.9923493,4.4159406,2.5686265,10.607326),(7595,'ulna-cleaned.tif',183,4,1119,1.4823745,5.0187217,9.3340603,1.8,4.9862283,9.3146516,0.6475973,0.5320627,2.3124975,0.0521007,2.4584456,0.0899152,1.0631128,0.0979221,1.0765281,1.0068879,4.4376981,2.5610712,10.395309),(7596,'ulna-cleaned.tif',183,4,1120,1.4821365,5.0111602,9.3303945,1.8,4.9817794,9.3112916,0.6470063,0.5291953,2.2725964,0.0523917,2.4575007,0.0897603,1.0813626,0.0990025,1.0964464,1.0068879,4.3711903,2.5510584,10.2163463),(7597,'ulna-cleaned.tif',183,4,1121,1.4859254,5.0010111,9.3283185,1.8,4.9672793,9.3083272,0.6453683,0.5213411,2.2955617,0.0531753,2.4860145,0.0895997,1.0829656,0.1019971,1.0973875,1.0149489,4.4161209,2.536048,10.4984819),(7598,'ulna-cleaned.tif',183,4,1122,1.4820126,4.9961622,9.3276205,1.8,4.9672962,9.3095408,0.643515,0.5071706,2.291798,0.0529639,2.4784369,0.088924,1.0814378,0.1044302,1.0961792,0.9961211,4.426563,2.5485901,10.6170074),(7599,'ulna-cleaned.tif',183,4,1123,1.4933893,4.9860487,9.3239605,1.8,4.9541482,9.3038599,0.642769,0.510474,2.2817199,0.0543937,2.5099861,0.0894285,1.1000413,0.1065553,1.1155779,1.0046658,4.3944377,2.5762562,10.4186819),(7600,'ulna-cleaned.tif',183,4,1124,1.4880168,4.986433,9.3282427,1.8,4.9570245,9.3094827,0.6423507,0.5064145,2.2847094,0.0532786,2.4943855,0.0890072,1.0917737,0.1052074,1.1071174,1.0046658,4.404389,2.5561026,10.4984819),(7601,'ulna-cleaned.tif',183,4,1125,1.5018691,4.9731566,9.3234571,1.8,4.9378928,9.301197,0.6410319,0.5315702,2.2715671,0.055107,2.533888,0.0895192,1.1154801,0.1036683,1.1319112,1.0284215,4.4161209,2.536048,10.5879633),(7602,'ulna-cleaned.tif',183,4,1126,1.4982084,4.966418,9.3250178,1.8,4.9257518,9.3013564,0.6388479,0.545667,2.2676671,0.0557764,2.5320921,0.0887786,1.1166066,0.102217,1.1339222,1.0474555,4.426563,2.5485901,10.8564074),(7603,'ulna-cleaned.tif',183,4,1127,1.5026177,4.9628775,9.3248648,1.8,4.922627,9.2992296,0.6384395,0.5428413,2.2090188,0.055696,2.5399465,0.088942,1.1498076,0.1026008,1.1667966,1.0363313,4.3607981,2.5713547,10.4847904),(7604,'ulna-cleaned.tif',183,4,1128,1.5035742,4.9626284,9.3307816,1.8,4.9245357,9.3090867,0.6385065,0.538079,2.2443668,0.0556571,2.5382272,0.0890147,1.1309324,0.1034366,1.1467294,1.0140195,4.3824662,2.5636907,10.5372074),(7605,'ulna-cleaned.tif',183,4,1129,1.5029727,4.9600999,9.3309695,1.8,4.9282385,9.3112482,0.6372932,0.533931,2.2190452,0.0551316,2.5395753,0.0886883,1.144445,0.1032561,1.1580831,1.0140195,4.3824662,2.5636907,10.4614175),(7606,'ulna-cleaned.tif',183,4,1130,1.5091323,4.9511686,9.3295543,1.8,4.9125279,9.3052553,0.6355454,0.5261792,2.2589258,0.0566258,2.5677671,0.0886315,1.1367204,0.107617,1.1554358,1.0363313,4.426563,2.5485901,10.6968074),(7607,'ulna-cleaned.tif',183,4,1131,1.5042592,4.9511489,9.3352896,1.8,4.9128967,9.3126816,0.634212,0.5188193,2.2474787,0.055532,2.5661026,0.088026,1.1417695,0.1070354,1.1550115,1.0034109,4.4281811,2.5810831,10.5645904),(7608,'ulna-cleaned.tif',183,4,1132,1.5112027,4.9393183,9.3282642,1.8,4.9028498,9.3055158,0.6324476,0.5374607,2.2343401,0.0562466,2.584424,0.0880084,1.1566834,0.1046524,1.1704873,1.0247522,4.4281811,2.5810831,10.6500616),(7609,'ulna-cleaned.tif',183,4,1133,1.4970073,4.9376518,9.3333447,1.8,4.9004097,9.3120353,0.6318454,0.5075641,2.2361837,0.056893,2.545856,0.0870384,1.1384825,0.1120903,1.153195,1.0140195,4.4159406,2.5686265,10.5178447),(7610,'ulna-cleaned.tif',183,4,1134,1.5023495,4.9359725,9.3348118,1.8,4.9037673,9.3163642,0.6322806,0.5162854,2.2119824,0.0571487,2.5556736,0.0874529,1.155377,0.110692,1.1677592,1.0363313,4.3944377,2.5762562,10.4614175),(7611,'ulna-cleaned.tif',183,4,1135,1.5099692,4.9409966,9.339897,1.8,4.9122044,9.3227328,0.6320548,0.5046807,2.2898355,0.0569687,2.572278,0.0878422,1.1233462,0.1128807,1.1420458,1.0029337,4.4376981,2.5610712,10.4614175),(7612,'ulna-cleaned.tif',183,4,1136,1.5039109,4.9294926,9.3364558,1.8,4.8942934,9.3155834,0.6305049,0.5078756,2.2788815,0.0571832,2.5683534,0.0871196,1.1270237,0.112593,1.1462438,1.0140195,4.481962,2.5461828,10.6774447),(7613,'ulna-cleaned.tif',183,4,1137,1.5133642,4.9284289,9.3386038,1.8,4.8922561,9.316986,0.6309648,0.5247312,2.2791833,0.0586758,2.5909782,0.0877778,1.1368011,0.1118207,1.156688,1.0474555,4.4597065,2.5535901,10.8233531),(7614,'ulna-cleaned.tif',183,4,1138,1.5145488,4.920653,9.3366029,1.8,4.8837672,9.3139362,0.629717,0.5228261,2.2720053,0.0594192,2.5879116,0.0875465,1.1390429,0.11365,1.1595809,1.024956,4.4597065,2.5535901,10.7902989),(7615,'ulna-cleaned.tif',183,4,1139,1.5177102,4.9164631,9.3381113,1.8,4.8832601,9.3185695,0.6291551,0.5150894,2.2696308,0.0591835,2.5995955,0.087594,1.1453825,0.1148995,1.1660484,1.024956,4.4716492,2.5337907,10.7008175),(7616,'ulna-cleaned.tif',183,4,1140,1.5179683,4.9086724,9.3392478,1.8,4.8727525,9.3198465,0.6276434,0.5214651,2.2643206,0.0604514,2.6195852,0.0872451,1.1568968,0.1159261,1.1785382,1.0259104,4.481962,2.5461828,10.846726),(7617,'ulna-cleaned.tif',183,4,1141,1.5056376,4.9075553,9.3417794,1.8,4.8744739,9.3228958,0.6274341,0.5154147,2.2180981,0.0600245,2.591665,0.0864865,1.1684177,0.1164586,1.18663,1.0139796,4.4159406,2.5686265,10.607326),(7618,'ulna-cleaned.tif',183,4,1142,1.5009884,4.906868,9.3433168,1.8,4.8742472,9.3244583,0.6275549,0.5169997,2.2184118,0.0595947,2.5811816,0.0862482,1.1635268,0.1152704,1.1816701,1.0141834,4.4159406,2.5686265,10.6637531),(7619,'ulna-cleaned.tif',183,4,1143,1.498617,4.9035098,9.3462279,1.8,4.8678716,9.3264556,0.6260521,0.5221101,2.2411789,0.0591499,2.5945364,0.0857553,1.1576659,0.11329,1.1778711,1.0252294,4.4489843,2.5411529,10.7902989),(7620,'ulna-cleaned.tif',183,4,1144,1.4944208,4.9059865,9.3500135,1.8,4.8755934,9.332973,0.6279466,0.5227323,2.2215267,0.059094,2.5830836,0.0859635,1.1627515,0.1130483,1.1809832,1.024956,4.4281811,2.5810831,10.4614175),(7621,'ulna-cleaned.tif',183,4,1145,1.4905751,4.8974201,9.3483434,1.8,4.8595833,9.3252976,0.6259315,0.5130395,2.2375107,0.0579295,2.5781208,0.0852666,1.1522272,0.1129143,1.1722337,1.0141834,4.449521,2.5734879,10.5839531),(7622,'ulna-cleaned.tif',183,4,1146,1.4910318,4.9034794,9.3557842,1.8,4.875737,9.3383959,0.6274838,0.5145668,2.3021583,0.0573024,2.5870798,0.0856592,1.1237628,0.1113605,1.1436032,1.0132413,4.4929598,2.5585161,11.0450515),(7623,'ulna-cleaned.tif',183,4,1147,1.4776507,4.9179078,9.3709927,1.8,4.8980329,9.3599899,0.6268414,0.5188149,2.2671841,0.0564244,2.5557304,0.0847402,1.1272708,0.1087564,1.1467635,1.0141834,4.4489843,2.5411529,10.7806175),(7624,'ulna-cleaned.tif',183,4,1148,1.4753986,4.9124237,9.3729344,1.8,4.8897018,9.362116,0.6267452,0.5149297,2.2639024,0.0548566,2.54992,0.0845885,1.1263383,0.1065321,1.1454077,1.0112156,4.373193,2.5839605,10.3816175),(7625,'ulna-cleaned.tif',183,4,1149,1.4631317,4.9162855,9.3788812,1.8,4.8943025,9.3678979,0.6268136,0.502769,2.2705034,0.0537235,2.539761,0.0839011,1.1185894,0.1068553,1.1372683,1.0024745,4.3862788,2.596493,10.3912989),(7626,'ulna-cleaned.tif',183,4,1150,1.452831,4.9180257,9.3829038,1.8,4.8989155,9.3721448,0.6270315,0.5048593,2.2742265,0.0522607,2.5192275,0.0833605,1.1077294,0.1035155,1.1258724,0.9945647,4.373193,2.5839605,10.4574074),(7627,'ulna-cleaned.tif',183,4,1151,1.4622286,4.9155478,9.3858558,1.8,4.8949964,9.3739084,0.6265718,0.4856172,2.274047,0.0524108,2.5472006,0.0837933,1.1201178,0.1079263,1.1384972,0.9801627,4.3824662,2.5636907,10.3485633),(7628,'ulna-cleaned.tif',183,4,1152,1.4623434,4.907713,9.3858354,1.8,4.8824447,9.3719579,0.6252027,0.4911522,2.2679623,0.0530199,2.5545889,0.083483,1.1263806,0.10795,1.1453817,0.9924859,4.4281811,2.5810831,11.0684244),(7629,'ulna-cleaned.tif',183,4,1153,1.4544126,4.905058,9.3863772,1.8,4.8760896,9.3672529,0.6251654,0.519913,2.2050846,0.0521671,2.5343356,0.0830217,1.1493144,0.1003382,1.1585397,1.0129483,4.4070992,2.5887514,10.9458888),(7630,'ulna-cleaned.tif',183,4,1154,1.4539329,4.8986855,9.3864451,1.8,4.8693756,9.3681099,0.6234589,0.5549264,2.2380363,0.0522096,2.5406227,0.0826021,1.1352017,0.0940838,1.1529162,1.0529452,4.3944377,2.5762562,10.766926),(7631,'ulna-cleaned.tif',183,4,1155,1.4612692,4.8951043,9.3874145,1.8,4.8624947,9.3655259,0.6229351,0.6136645,2.2358089,0.0538556,2.5561173,0.082898,1.1432629,0.0877606,1.161887,1.0027299,4.3824662,2.5636907,10.4049904),(7632,'ulna-cleaned.tif',183,4,1156,1.4585182,4.9024408,9.3945809,1.8,4.8765578,9.3765002,0.6232913,0.679879,2.2458715,0.0545382,2.5358066,0.082824,1.1290969,0.0802175,1.1480665,0.9586291,4.4204447,2.6011732,10.4710989),(7633,'ulna-cleaned.tif',183,4,1157,1.4683745,4.896485,9.3911592,1.8,4.8660109,9.3668384,0.6226048,0.6808359,2.2017956,0.0571438,2.5497815,0.0832244,1.1580464,0.0839318,1.1705595,0.9694578,4.4159406,2.5686265,10.5041531),(7634,'ulna-cleaned.tif',183,4,1158,1.4598125,4.9015488,9.399256,1.8,4.8745763,9.3780501,0.6217326,0.652363,2.2109188,0.055951,2.533948,0.0825382,1.1461063,0.0857667,1.1586504,0.9582081,4.3944377,2.5762562,10.5138345),(7635,'ulna-cleaned.tif',183,4,1159,1.4652335,4.8903623,9.3949971,1.8,4.850848,9.3644731,0.6200432,0.6467191,2.1906046,0.0563792,2.5429248,0.0824542,1.1608324,0.0871773,1.1778764,0.9679002,4.3824662,2.5636907,10.3114989),(7636,'ulna-cleaned.tif',183,4,1160,1.4657594,4.8926684,9.4011516,1.8,4.8588539,9.3739953,0.6193121,0.6506062,2.2149067,0.0570528,2.5531868,0.082315,1.1527288,0.0876917,1.162153,0.9677534,4.4281811,2.5810831,10.6266887),(7637,'ulna-cleaned.tif',183,4,1161,1.4610957,4.8999215,9.4110625,1.8,4.8756434,9.3904239,0.6190464,0.6313963,2.2266638,0.0560803,2.5428975,0.0819919,1.1420213,0.0888195,1.1515687,0.9588891,4.4281811,2.5810831,10.5605803),(7638,'ulna-cleaned.tif',183,4,1162,1.4725714,4.8892884,9.406373,1.8,4.8637673,9.3833525,0.6171599,0.6343701,2.220163,0.0570039,2.5698189,0.0821985,1.1574911,0.0898591,1.1775103,0.9361858,4.4159406,2.5686265,10.4574074),(7639,'ulna-cleaned.tif',183,4,1163,1.4654473,4.8823153,9.4070878,1.8,4.8518042,9.3817483,0.6161432,0.5836973,2.2707264,0.0561325,2.5646005,0.0815666,1.1294186,0.0961671,1.1496212,1.0577508,4.4597065,2.5535901,11.5528956),(7640,'ulna-cleaned.tif',183,4,1164,1.46468,4.8834134,9.4111249,1.8,4.857708,9.3875656,0.6162494,0.7260627,2.2739344,0.0563114,2.5503524,0.0815483,1.1215594,0.0775573,1.1419551,1.057547,4.3824662,2.5636907,11.3545701),(7641,'ulna-cleaned.tif',183,4,1165,1.4654521,4.8719371,9.409692,1.8,4.8420524,9.3841345,0.6149174,0.7321575,2.2639969,0.0576832,2.5718869,0.0812845,1.135994,0.0787852,1.1573782,1.0764089,4.4281811,2.5810831,10.9362074),(7642,'ulna-cleaned.tif',183,4,1166,1.4625724,4.8760557,9.4140974,1.8,4.8505869,9.3913367,0.614819,0.7008337,2.2699211,0.0573217,2.5543475,0.0811022,1.1253023,0.0817907,1.1465809,1.0744435,4.4159406,2.5686265,11.1288616),(7643,'ulna-cleaned.tif',183,4,1167,1.4652891,4.8685353,9.4129572,1.8,4.8387656,9.3874017,0.6146717,0.759913,2.2631475,0.0583629,2.5574833,0.081219,1.1300559,0.076802,1.1519845,1.0811379,4.3862788,2.596493,11.3311972),(7644,'ulna-cleaned.tif',183,4,1168,1.4564671,4.8663505,9.4172524,1.8,4.8398301,9.3954864,0.6133845,0.7652482,2.2640702,0.057125,2.5468888,0.0804357,1.124916,0.074649,1.1466195,1.0474866,4.373193,2.5839605,11.3311972),(7645,'ulna-cleaned.tif',183,4,1169,1.4648326,4.8667026,9.4197267,1.8,4.8412724,9.3972092,0.6144656,0.7895947,2.265591,0.0578876,2.5675963,0.0811463,1.1333009,0.0733131,1.1552771,1.0077504,4.3862788,2.596493,10.9458888),(7646,'ulna-cleaned.tif',183,4,1170,1.4629409,4.862914,9.4198835,1.8,4.8368551,9.3950601,0.6152451,0.7915901,2.2950315,0.058496,2.5483136,0.0812206,1.1103611,0.0738969,1.1315247,1.0177496,4.4159406,2.5686265,10.9088244),(7647,'ulna-cleaned.tif',183,4,1171,1.4572001,4.8526561,9.4172401,1.8,4.822867,9.3910889,0.6140453,0.772838,2.2853637,0.0572346,2.5469279,0.0806273,1.1144519,0.0740577,1.1353982,1.0017754,4.3824662,2.5636907,11.1812786),(7648,'ulna-cleaned.tif',183,4,1172,1.4627097,4.8473637,9.4199925,1.8,4.8174096,9.3964683,0.6130827,0.7785467,2.2828048,0.0561129,2.5638623,0.0807112,1.1231194,0.072074,1.143875,1.0060178,4.504461,2.5388491,11.3408786),(7649,'ulna-cleaned.tif',183,4,1173,1.4675105,4.8403822,9.4191546,1.8,4.804664,9.3927691,0.6116033,0.7824974,2.2768817,0.0563525,2.5796182,0.0806357,1.132961,0.0720162,1.1541043,1.0060178,4.5150514,2.5511391,10.9555701),(7650,'ulna-cleaned.tif',183,4,1174,1.4716925,4.8338405,9.4182925,1.8,4.7944414,9.3900984,0.611522,0.5133604,2.2710453,0.0567259,2.5937679,0.0808467,1.1421031,0.1104992,1.1635562,0.9961653,4.5150514,2.5511391,11.298143),(7651,'ulna-cleaned.tif',183,4,1175,1.4666396,4.8449606,9.4301811,1.8,4.8144567,9.4077606,0.6104851,0.5079342,2.2087148,0.0564957,2.5532499,0.080331,1.1559889,0.1112264,1.1760757,0.9778994,4.404389,2.5561026,10.5121734),(7652,'ulna-cleaned.tif',183,4,1176,1.4612402,4.8445265,9.43392,1.8,4.8179613,9.4143402,0.6115033,0.4803755,2.2429567,0.0551019,2.5341869,0.0802683,1.1298421,0.1147058,1.1480954,0.9579009,4.4597065,2.5535901,10.6540718),(7653,'ulna-cleaned.tif',183,4,1177,1.453757,4.8424389,9.4366063,1.8,4.8178431,9.4179307,0.6122146,0.4782772,2.242624,0.0542847,2.5203824,0.0800193,1.1238542,0.1135006,1.1418747,0.9694578,4.4597065,2.5535901,10.4049904),(7654,'ulna-cleaned.tif',183,4,1178,1.4474143,4.8397272,9.4400104,1.8,4.816589,9.4222205,0.6116908,0.767246,2.2098156,0.0542032,2.5050413,0.0795513,1.1335974,0.0706464,1.1531596,0.9713654,4.4376981,2.5610712,10.7959701),(7655,'ulna-cleaned.tif',183,4,1179,1.4335048,4.8488718,9.4541293,1.8,4.8320727,9.4429257,0.6092195,0.7190403,2.2030631,0.0538951,2.4683182,0.0782322,1.1204029,0.0749541,1.138878,0.9596336,4.4159406,2.5686265,10.5839531),(7656,'ulna-cleaned.tif',183,4,1180,1.4361533,4.8413868,9.4523089,1.8,4.823442,9.4395452,0.6090192,0.7219153,2.1959276,0.0548022,2.4691453,0.0783317,1.1244202,0.0759122,1.1434957,0.9677534,4.404389,2.5561026,10.5315362),(7657,'ulna-cleaned.tif',183,4,1181,1.4358465,4.8335882,9.450526,1.8,4.8136714,9.4354586,0.6091464,0.7705203,2.1884832,0.0554862,2.4734272,0.0783436,1.1302016,0.0720113,1.1497462,0.9873166,4.404389,2.5561026,10.5742718),(7658,'ulna-cleaned.tif',183,4,1182,1.4361533,4.8294093,9.4530706,1.8,4.8112967,9.4397708,0.6075147,0.7527889,2.186861,0.0546727,2.4822706,0.077994,1.1350838,0.0726269,1.1464402,0.9660208,4.4070992,2.5887514,10.3058277),(7659,'ulna-cleaned.tif',183,4,1183,1.4320249,4.829843,9.4609447,1.8,4.8149858,9.4530157,0.607739,0.4911977,2.1916657,0.0536119,2.4972628,0.0778199,1.139436,0.1091452,1.1587656,0.9809114,4.4159406,2.5686265,10.8427159),(7660,'ulna-cleaned.tif',183,4,1184,1.437304,4.8216454,9.4605705,1.8,4.803523,9.4504468,0.6063118,0.4787815,2.1850086,0.0535097,2.5102442,0.0777865,1.1488487,0.1117622,1.1685016,0.9658784,4.404389,2.5561026,10.7201803),(7661,'ulna-cleaned.tif',183,4,1185,1.4379417,4.8092444,9.4582228,1.8,4.7813378,9.4423093,0.6048992,0.4963115,2.1742972,0.0539101,2.5154907,0.0775041,1.1569213,0.1086216,1.1774849,0.9677093,4.404389,2.5561026,10.4420548),(7662,'ulna-cleaned.tif',183,4,1186,1.4387646,4.8116483,9.4646531,1.8,4.7891856,9.4520768,0.6050247,0.502753,2.1812461,0.0540026,2.5151475,0.0775766,1.1530783,0.1074138,1.1738756,0.9935539,4.4161209,2.536048,10.8096616),(7663,'ulna-cleaned.tif',183,4,1187,1.4284428,4.8123007,9.4692473,1.8,4.7910665,9.4570855,0.6054035,0.4899508,2.1882647,0.0533327,2.4770976,0.0771044,1.1319917,0.1088531,1.1546412,0.9661676,4.4070992,2.5887514,10.8290244),(7664,'ulna-cleaned.tif',183,4,1188,1.4052819,4.8293402,9.487796,1.8,4.8177906,9.4821699,0.6048119,0.4832438,2.159322,0.0523158,2.4335166,0.0757246,1.1269818,0.1082597,1.1331368,0.9579009,4.3657238,2.6043079,10.3856277),(7665,'ulna-cleaned.tif',183,4,1189,1.4129321,4.8307258,9.4914004,1.8,4.8244041,9.4876882,0.6047266,0.4784945,2.1625441,0.0518971,2.4411592,0.0761181,1.1288368,0.1084591,1.1350035,0.9461691,4.3657238,2.6043079,10.3485633),(7666,'ulna-cleaned.tif',183,4,1190,1.4015623,4.8256565,9.4945527,1.8,4.8133945,9.4869274,0.6039119,0.4715489,2.1933169,0.0506792,2.4315338,0.0753276,1.1086104,0.1074739,1.1133302,0.9361698,4.4204447,2.6011732,10.3856277),(7667,'ulna-cleaned.tif',183,4,1191,1.4069485,4.8181942,9.493843,1.8,4.8082559,9.4874864,0.6019743,0.4870045,2.1792537,0.0511076,2.4393227,0.0751926,1.1193386,0.1049427,1.1383333,0.9432832,4.3657238,2.6043079,10.2066649),(7668,'ulna-cleaned.tif',183,4,1192,1.4048561,4.8134565,9.4958284,1.8,4.7993674,9.486435,0.6015842,0.4942392,2.1765465,0.0513985,2.4484454,0.0749956,1.1249222,0.1039951,1.1442821,0.9525084,4.3799225,2.6167969,10.4186819),(7669,'ulna-cleaned.tif',183,4,1193,1.4019296,4.8075026,9.4957524,1.8,4.7937656,9.485433,0.6015802,0.4786574,2.1541656,0.0503407,2.4367864,0.0748385,1.1311973,0.1051706,1.1423263,0.9506774,4.3657238,2.6043079,10.3251904),(7670,'ulna-cleaned.tif',183,4,1194,1.4006022,4.8021284,9.5004457,1.8,4.785335,9.4906036,0.5992645,0.5020919,2.1790489,0.0510372,2.4600851,0.0742636,1.1289719,0.1016492,1.135966,0.9432832,4.4070992,2.5887514,10.4283633),(7671,'ulna-cleaned.tif',183,4,1195,1.3982241,4.7917362,9.5008866,1.8,4.7663892,9.4869602,0.5975414,0.492528,2.1864574,0.0507095,2.4787477,0.0737637,1.1336821,0.1029575,1.1556894,0.9432832,4.4070992,2.5887514,10.5839531),(7672,'ulna-cleaned.tif',183,4,1196,1.3942752,4.7930742,9.5045099,1.8,4.7751205,9.492302,0.5966544,0.4779767,2.183226,0.0497472,2.4689213,0.0733637,1.1308592,0.1040787,1.1524672,0.9248328,4.3862788,2.596493,10.2220175),(7673,'ulna-cleaned.tif',183,4,1197,1.3716477,4.8047172,9.5175564,1.8,4.7890573,9.5060284,0.5959323,0.4487361,2.1601411,0.0485514,2.4071098,0.0720197,1.1143299,0.108196,1.1243831,0.9061721,4.373193,2.5839605,10.1462277),(7674,'ulna-cleaned.tif',183,4,1198,1.3687318,4.7966076,9.5178589,1.8,4.7803589,9.5078197,0.5947933,0.451562,2.2422568,0.0482623,2.4161035,0.0716253,1.077532,0.1068785,1.0951269,0.920014,4.373193,2.5839605,10.4243531),(7675,'ulna-cleaned.tif',183,4,1199,1.3654033,4.7908974,9.5179304,1.8,4.7733623,9.5062736,0.5929851,0.4460771,2.1825157,0.0479515,2.4045916,0.0710695,1.1017523,0.1074959,1.119328,0.8985757,4.3657238,2.6043079,10.4009803),(7676,'ulna-cleaned.tif',183,4,1200,1.365415,4.7866791,9.5203087,1.8,4.7719146,9.5105203,0.5922818,0.4736066,2.1792595,0.0479478,2.4018092,0.0709218,1.1021217,0.1012397,1.1231316,0.9278207,4.3522105,2.5917395,10.2453904),(7677,'ulna-cleaned.tif',183,4,1201,1.3620677,4.7803758,9.5227423,1.8,4.7594496,9.510338,0.590442,0.4652107,2.1498238,0.0484178,2.4015496,0.0703613,1.1170914,0.1040772,1.1319834,0.9278207,4.3522105,2.5917395,10.3251904),(7678,'ulna-cleaned.tif',183,4,1202,1.3642968,4.7700344,9.5219148,1.8,4.7492301,9.5106172,0.5881087,0.4889505,2.158619,0.0489979,2.415826,0.0699862,1.1191535,0.1002103,1.1339263,0.9218758,4.3657238,2.6043079,10.7532345),(7679,'ulna-cleaned.tif',183,4,1203,1.3662446,4.7564891,9.5197252,1.8,4.7314394,9.5060487,0.5861451,0.4796319,2.159988,0.0490575,2.4388619,0.0696737,1.129109,0.1022815,1.1408609,0.9218758,4.3799225,2.6167969,10.9983057),(7680,'ulna-cleaned.tif',183,4,1204,1.3575223,4.7479335,9.5200206,1.8,4.718793,9.5041253,0.5852823,0.4730655,2.204585,0.048636,2.4196925,0.069049,1.0975728,0.1028103,1.1173805,0.9091825,4.3600679,2.6247167,10.4574074),(7681,'ulna-cleaned.tif',183,4,1205,1.3496395,4.7321718,9.5158283,1.8,4.7002122,9.4993638,0.5839515,0.4654238,2.1893084,0.0483798,2.4145284,0.0683725,1.1028727,0.1039479,1.1229329,0.9007321,4.3600679,2.6247167,10.3348718),(7682,'ulna-cleaned.tif',183,4,1206,1.3370313,4.7485536,9.5315581,1.8,4.7303668,9.5229201,0.5835221,0.4605388,2.1683799,0.0475321,2.3790731,0.0676458,1.0971662,0.1032098,1.1057827,0.9010857,4.3799225,2.6167969,10.3816175),(7683,'ulna-cleaned.tif',183,4,1207,1.3305885,4.7444717,9.5332036,1.8,4.7251737,9.5234706,0.5825368,0.4558843,2.1548394,0.0471618,2.372812,0.067119,1.1011549,0.1034512,1.1125855,0.8965245,4.3522105,2.5917395,10.4146718),(7684,'ulna-cleaned.tif',183,4,1208,1.3276362,4.7431262,9.5350779,1.8,4.7274068,9.5258138,0.5818416,0.4409886,2.1444163,0.0461034,2.3491185,0.0668288,1.0954582,0.1045455,1.1014472,0.8799419,4.345438,2.6121963,10.4710989),(7685,'ulna-cleaned.tif',183,4,1209,1.3237672,4.7429114,9.5402003,1.8,4.7226286,9.5281605,0.5819291,0.4700778,2.1470206,0.0461817,2.3450871,0.0666518,1.0922518,0.0982427,1.0986826,0.8965245,4.345438,2.6121963,10.6033159),(7686,'ulna-cleaned.tif',183,4,1210,1.3161516,4.7382316,9.5424621,1.8,4.7145108,9.5291381,0.581598,0.4536209,2.1330505,0.0453878,2.338735,0.0662016,1.0964274,0.1000566,1.1070618,0.8838312,4.318242,2.586911,10.4009803),(7687,'ulna-cleaned.tif',183,4,1211,1.3354824,4.7347527,9.5454984,1.8,4.7049543,9.5284607,0.5780466,0.4646146,2.1444519,0.0472352,2.3807145,0.0664494,1.1101739,0.1016654,1.1182574,0.9011298,4.3314938,2.5995934,10.4146718),(7688,'ulna-cleaned.tif',183,4,1212,1.3358744,4.7251679,9.5453677,1.8,4.6946104,9.530372,0.5771919,0.4680427,2.148629,0.0473079,2.3903316,0.0662948,1.1124915,0.1010761,1.1272883,0.8887758,4.345438,2.6121963,10.3582446),(7689,'ulna-cleaned.tif',183,4,1213,1.3398288,4.7226736,9.5476697,1.8,4.6906504,9.5300011,0.5772446,0.4664006,2.1777872,0.0474717,2.3978083,0.0665018,1.1010297,0.1017831,1.1127605,0.904975,4.3799225,2.6167969,10.6210175),(7690,'ulna-cleaned.tif',183,4,1214,1.3392055,4.7172531,9.5499321,1.8,4.6846623,9.5314479,0.5756209,0.4586921,2.1746619,0.0474303,2.4065212,0.0661396,1.1066185,0.1034033,1.1269761,0.9011298,4.3404893,2.6327084,10.6831159),(7691,'ulna-cleaned.tif',183,4,1215,1.3437939,4.7181506,9.5558129,1.8,4.6860072,9.5371627,0.5766788,0.4661748,2.1785027,0.0473806,2.4330338,0.0665827,1.1168377,0.101637,1.137182,0.904975,4.345438,2.6121963,10.527526),(7692,'ulna-cleaned.tif',183,4,1216,1.3374799,4.7335578,9.5714419,1.8,4.7043529,9.5541861,0.5756843,0.4613842,2.1583699,0.0467299,2.4077317,0.0660673,1.1155324,0.101282,1.1254688,0.9011298,4.3522105,2.5917395,10.5976447),(7693,'ulna-cleaned.tif',183,4,1217,1.3480713,4.7264022,9.5722514,1.8,4.6960566,9.55538,0.5748602,0.4770839,2.1543999,0.0478949,2.4461108,0.0664214,1.1354024,0.1003909,1.1468386,0.9206187,4.3657238,2.6043079,10.395309),(7694,'ulna-cleaned.tif',183,4,1218,1.3530814,4.7241788,9.5754851,1.8,4.6923259,9.5561868,0.5745615,0.4726362,2.1761542,0.047581,2.4599227,0.0666068,1.1303991,0.1006715,1.1491509,0.9282937,4.3862788,2.596493,10.5218548),(7695,'ulna-cleaned.tif',183,4,1219,1.3443869,4.7219222,9.5809207,1.8,4.6907167,9.5638842,0.5736909,0.4771735,2.2074682,0.047121,2.4573015,0.0660009,1.1131764,0.0987503,1.1323142,0.9129436,4.3657238,2.6043079,10.579943),(7696,'ulna-cleaned.tif',183,4,1220,1.351008,4.7156816,9.581434,1.8,4.679611,9.5605941,0.5729637,0.4818539,2.1917076,0.0475306,2.4634232,0.0661767,1.1239744,0.0986411,1.144494,0.8942734,4.4000494,2.608949,10.2921362),(7697,'ulna-cleaned.tif',183,4,1221,1.3452096,4.7095539,9.5828327,1.8,4.6701815,9.5603224,0.5720002,0.4756384,2.1983338,0.0473798,2.4634751,0.065696,1.1206101,0.099613,1.1402942,0.8920959,4.373193,2.5839605,10.5976447),(7698,'ulna-cleaned.tif',183,4,1222,1.3440957,4.7000716,9.5833487,1.8,4.6584235,9.5606147,0.5708379,0.4800218,2.1915783,0.0480979,2.4599773,0.0654047,1.1224684,0.1001994,1.1417883,0.8766046,4.3657238,2.6043079,10.3816175),(7699,'ulna-cleaned.tif',183,4,1223,1.350238,4.7018663,9.589123,1.8,4.6627671,9.5666487,0.57103,0.4644607,2.1989796,0.0481293,2.4767811,0.0657429,1.126332,0.1036241,1.1472735,0.8734257,4.3799225,2.6167969,10.447726),(7700,'ulna-cleaned.tif',183,4,1224,1.3513878,4.6993143,9.5933166,1.8,4.6621168,9.5742114,0.569802,0.4694372,2.208208,0.048592,2.4829514,0.0655475,1.1244192,0.1035113,1.1428082,0.8812961,4.4070992,2.5887514,10.4146718),(7701,'ulna-cleaned.tif',183,4,1225,1.3301573,4.718568,9.6118517,1.8,4.686997,9.5967657,0.5686998,0.495905,2.1939401,0.0478979,2.4241296,0.0642958,1.1049206,0.0965868,1.1251294,0.8867949,4.4000494,2.608949,10.3582446),(7702,'ulna-cleaned.tif',183,4,1226,1.3364977,4.7070937,9.6102037,1.8,4.6670372,9.5902869,0.5670762,0.4883194,2.1901217,0.048949,2.4331445,0.0642743,1.1109631,0.1002397,1.1314916,0.9027964,4.3657238,2.6043079,10.5839531),(7703,'ulna-cleaned.tif',183,4,1227,1.338629,4.7060263,9.6139834,1.8,4.6688122,9.5954579,0.567337,0.4850073,2.1912202,0.0489847,2.4374933,0.0644296,1.1123908,0.1009978,1.1315601,0.908919,4.3862788,2.596493,10.7201803),(7704,'ulna-cleaned.tif',183,4,1228,1.3424303,4.6960727,9.6142818,1.8,4.6532155,9.5925308,0.5660176,0.4771442,2.1990198,0.049627,2.4414209,0.0643451,1.1102314,0.1040083,1.1296341,0.8947907,4.4000494,2.608949,10.7435531),(7705,'ulna-cleaned.tif',183,4,1229,1.3338455,4.6966746,9.6193844,1.8,4.6541853,9.5972513,0.5643893,0.4703615,2.2078804,0.0494004,2.42077,0.0636062,1.0964227,0.1050264,1.1174297,0.8886682,4.4144983,2.6213255,10.6266887),(7706,'ulna-cleaned.tif',183,4,1230,1.3342552,4.6984055,9.6258898,1.8,4.6516817,9.6001833,0.5630362,0.4759014,2.2027945,0.0498392,2.4050791,0.0633539,1.0918309,0.104726,1.1131273,0.8948006,4.3799225,2.6167969,10.5372074),(7707,'ulna-cleaned.tif',183,4,1231,1.3260921,4.6977321,9.6309372,1.8,4.6512057,9.6060926,0.5623825,0.4577006,2.1881219,0.0498308,2.4030211,0.0628359,1.0982117,0.1088721,1.1180181,0.8902556,4.3657238,2.6043079,10.7959701),(7708,'ulna-cleaned.tif',183,4,1232,1.325693,4.6895132,9.6309352,1.8,4.6403465,9.6039539,0.5610813,0.4636329,2.1948723,0.0496174,2.4031394,0.0625578,1.094888,0.1070188,1.1146102,0.8833565,4.3522105,2.5917395,10.8523972),(7709,'ulna-cleaned.tif',183,4,1233,1.3294113,4.6883814,9.635247,1.8,4.6423124,9.6105464,0.5597995,0.4572426,2.2059597,0.0497476,2.4109955,0.0624775,1.0929463,0.1087992,1.1143176,0.8833565,4.3657238,2.6043079,10.8757701),(7710,'ulna-cleaned.tif',183,4,1234,1.3172384,4.6902644,9.6401107,1.8,4.6491449,9.6175694,0.5601216,0.4460657,2.2104069,0.048561,2.3824954,0.0619691,1.0778538,0.108865,1.0959279,0.8764574,4.373193,2.5839605,10.8660888),(7711,'ulna-cleaned.tif',183,4,1235,1.3168769,4.6865964,9.6441812,1.8,4.6422801,9.6206455,0.5583676,0.4547694,2.1898915,0.048658,2.3906138,0.0616058,1.0916586,0.106995,1.1112335,0.8629537,4.3862788,2.596493,10.3485633),(7712,'ulna-cleaned.tif',183,4,1236,1.315395,4.6749978,9.6418037,1.8,4.6230617,9.6139626,0.5581282,0.4588162,2.2009529,0.0486198,2.3762055,0.0614893,1.0796257,0.1059679,1.0992481,0.8966837,4.373193,2.5839605,11.03136),(7713,'ulna-cleaned.tif',183,4,1237,1.3314876,4.6838271,9.6518955,1.8,4.6352767,9.6254576,0.5573874,0.4538394,2.2091178,0.0494153,2.3993377,0.062094,1.0861068,0.1088829,1.1048479,0.8623047,4.373193,2.5839605,11.0256888),(7714,'ulna-cleaned.tif',183,4,1238,1.3412596,4.681104,9.6542084,1.8,4.6312858,9.6265582,0.558081,0.4555672,2.2103266,0.0500496,2.4117793,0.0626889,1.0911416,0.1098622,1.110341,0.8697056,4.373193,2.5839605,10.4049904),(7715,'ulna-cleaned.tif',183,4,1239,1.3520861,4.6686348,9.6499808,1.8,4.607021,9.6145664,0.5563026,0.4586572,2.2017655,0.0503318,2.4240216,0.0628352,1.1009445,0.1097373,1.1214978,0.8695584,4.373193,2.5839605,10.4283633),(7716,'ulna-cleaned.tif',183,4,1240,1.3438759,4.6715917,9.6566827,1.8,4.6106583,9.6213918,0.5566949,0.4460748,2.2168516,0.0498654,2.4347723,0.0625325,1.0983019,0.111787,1.1175083,0.8560546,4.3944377,2.5762562,10.5605803),(7717,'ulna-cleaned.tif',183,4,1241,1.3483635,4.6653763,9.6574678,1.8,4.5965797,9.6169341,0.555182,0.4571557,2.2214597,0.0503055,2.4553623,0.0624365,1.1052923,0.1100401,1.1246656,0.87454,4.4159406,2.5686265,10.6403803),(7718,'ulna-cleaned.tif',183,4,1242,1.3493223,4.6684606,9.6644251,1.8,4.6008538,9.624801,0.5540025,0.4591458,2.2279158,0.0517082,2.4554986,0.0622434,1.1021505,0.1126182,1.1239156,0.8697056,4.449521,2.5734879,10.9749328),(7719,'ulna-cleaned.tif',183,4,1243,1.3340366,4.6764709,9.6734648,1.8,4.6160093,9.638383,0.5528269,0.4537859,2.2162175,0.051055,2.4086507,0.0613045,1.0868296,0.112509,1.1084492,0.8764574,4.4204447,2.6011732,10.7201803),(7720,'ulna-cleaned.tif',183,4,1244,1.337337,4.6737564,9.6753322,1.8,4.6124867,9.6397316,0.5530421,0.4561449,2.2175706,0.0511563,2.425582,0.0614991,1.0938015,0.1121492,1.1155327,0.87454,4.4281811,2.5810831,10.9225159),(7721,'ulna-cleaned.tif',183,4,1245,1.3430417,4.6653946,9.6736792,1.8,4.6023918,9.6364677,0.5526209,0.4604753,2.2124928,0.0520176,2.4368993,0.0616771,1.101427,0.112965,1.1219537,0.8806625,4.3944377,2.5762562,10.5742718),(7722,'ulna-cleaned.tif',183,4,1246,1.3401625,4.6579117,9.6746134,1.8,4.5902112,9.6358891,0.551318,0.4824639,2.2312536,0.052017,2.4429876,0.061285,1.0948947,0.1078153,1.1169772,0.8951663,4.4070992,2.5887514,10.527526),(7723,'ulna-cleaned.tif',183,4,1247,1.3436841,4.6564447,9.6773507,1.8,4.5862577,9.6367008,0.5508788,0.4684291,2.2310246,0.0523942,2.4451315,0.0613583,1.095968,0.1118508,1.1182697,0.8966837,4.4281811,2.5810831,10.9128345),(7724,'ulna-cleaned.tif',183,4,1248,1.3463234,4.6547675,9.6809693,1.8,4.5863454,9.6426413,0.5505773,0.4640645,2.2382757,0.052797,2.4373341,0.0614185,1.0889338,0.1137709,1.108609,0.8966837,4.4281811,2.5810831,10.9321972),(7725,'ulna-cleaned.tif',183,4,1249,1.3448544,4.6617981,9.6882351,1.8,4.5970584,9.6502489,0.5501559,0.4609828,2.2075438,0.0531595,2.4179041,0.0612673,1.0952916,0.1153177,1.1167061,0.8966837,4.4070992,2.5887514,10.8523972),(7726,'ulna-cleaned.tif',183,4,1250,1.3294094,4.6742127,9.6995438,1.8,4.6154797,9.665304,0.551096,0.4693917,2.1989803,0.052242,2.3704793,0.0607494,1.0779902,0.1112972,1.0954405,0.9039065,4.373193,2.5839605,10.978943),(7727,'ulna-cleaned.tif',183,4,1251,1.3370897,4.6697816,9.7013594,1.8,4.6067145,9.665941,0.551256,0.4657941,2.2071271,0.0530657,2.395534,0.0611322,1.0853629,0.1139251,1.1059419,0.9009231,4.3600679,2.6247167,10.6306989),(7728,'ulna-cleaned.tif',183,4,1252,1.3366712,4.6825541,9.7125678,1.8,4.6269195,9.6817119,0.5488739,0.4797034,2.197761,0.0539453,2.3759498,0.0606401,1.0810774,0.1124556,1.1019505,0.9190295,4.3799225,2.6167969,10.6306989),(7729,'ulna-cleaned.tif',183,4,1253,1.3371438,4.6843817,9.7183869,1.8,4.6305907,9.6883852,0.5478418,0.4738973,2.18,0.0542285,2.3754707,0.0604569,1.0896655,0.114431,1.108395,0.8948006,4.4159406,2.5686265,11.1054888),(7730,'ulna-cleaned.tif',183,4,1254,1.3435165,4.6869876,9.7259615,1.8,4.630993,9.6951971,0.5478077,0.4687289,2.1735271,0.0548714,2.3893846,0.0607382,1.0993121,0.1170643,1.1184401,0.8948006,4.404389,2.5561026,11.0998175),(7731,'ulna-cleaned.tif',183,4,1255,1.3307398,4.6980012,9.7372425,1.8,4.6490745,9.7099139,0.545569,0.4730968,2.1638462,0.0542045,2.3465287,0.0597196,1.0844249,0.1145737,1.1064221,0.9291796,4.3657238,2.6043079,10.8233531),(7732,'ulna-cleaned.tif',183,4,1256,1.3391642,4.6949086,9.7378864,1.8,4.646427,9.7094924,0.545699,0.4723613,2.1734788,0.055344,2.3552815,0.0601234,1.083646,0.1171646,1.1056795,0.9838094,4.3799225,2.6167969,11.1756074),(7733,'ulna-cleaned.tif',183,4,1257,1.3384382,4.6990427,9.7441862,1.8,4.6544151,9.719492,0.5453446,0.4746505,2.2062471,0.0560995,2.3494781,0.0600207,1.0649206,0.1181911,1.0888668,0.9838094,4.3799225,2.6167969,10.9362074),(7734,'ulna-cleaned.tif',183,4,1258,1.3391715,4.7006385,9.7483404,1.8,4.6571297,9.7228228,0.5451641,0.4913373,2.2097866,0.0558754,2.3411894,0.0600178,1.059464,0.113721,1.0833589,1.0041751,4.3600679,2.6247167,11.0821159),(7735,'ulna-cleaned.tif',183,4,1259,1.3486781,4.7036816,9.7524355,1.8,4.664039,9.7276202,0.5439851,0.4938819,2.2146403,0.056522,2.3547752,0.060209,1.0632766,0.1144443,1.087519,1.0059433,4.3600679,2.6247167,11.0296989),(7736,'ulna-cleaned.tif',183,4,1260,1.3566242,4.7074122,9.7549059,1.8,4.6738022,9.7304829,0.5444781,0.7274004,2.2190578,0.0588135,2.3653406,0.0606625,1.0659211,0.0808543,1.0911245,1.0445617,4.345438,2.6121963,11.2377057),(7737,'ulna-cleaned.tif',183,4,1261,1.3655728,4.7049406,9.7570779,1.8,4.6694883,9.7313075,0.5430399,0.7103493,2.2182177,0.0597467,2.3713636,0.0607728,1.0690401,0.0841089,1.0948167,1.0384392,4.3600679,2.6247167,10.9692616),(7738,'ulna-cleaned.tif',183,4,1262,1.3576529,4.6973039,9.7605893,1.8,4.6548319,9.734397,0.5389893,0.5067778,2.1591384,0.0586631,2.3593857,0.0596111,1.0927441,0.115757,1.1168441,1.0241251,4.373193,2.5839605,11.1522345),(7739,'ulna-cleaned.tif',183,4,1263,1.3816264,4.690596,9.7608084,1.8,4.6449967,9.7323037,0.536208,0.5118453,2.1880535,0.060928,2.4157551,0.0601004,1.1040658,0.119036,1.1304669,1.0387295,4.4070992,2.5887514,11.2554074),(7740,'ulna-cleaned.tif',183,4,1264,1.3880608,4.6764031,9.7598578,1.8,4.62395,9.7287743,0.5347769,0.4986635,2.1825428,0.0611726,2.4362656,0.0600897,1.116251,0.1226731,1.1365052,1.0184986,4.3944377,2.5762562,10.8507362),(7741,'ulna-cleaned.tif',183,4,1265,1.3919448,4.6823976,9.7668794,1.8,4.6392409,9.7398537,0.5359473,0.5074558,2.1880312,0.061882,2.440385,0.0604961,1.1153337,0.1219456,1.1390779,1.0241251,4.3947999,2.6292032,11.3739329),(7742,'ulna-cleaned.tif',183,4,1266,1.3943831,4.6755115,9.7665444,1.8,4.6308728,9.7383352,0.5342942,0.5114289,2.193802,0.0621853,2.4271737,0.060265,1.1063777,0.1215912,1.1302263,1.0437942,4.3947999,2.6292032,10.926526),(7743,'ulna-cleaned.tif',183,4,1267,1.3921783,4.6810732,9.7736666,1.8,4.6378501,9.7451252,0.5344271,0.5286788,2.1650912,0.0624868,2.4250302,0.0601967,1.1200591,0.1181943,1.145874,1.0637442,4.345438,2.6121963,11.0256888),(7744,'ulna-cleaned.tif',183,4,1268,1.3889946,4.6799857,9.7772175,1.8,4.6317408,9.7455096,0.5360313,0.5379154,2.1709156,0.0623147,2.4341831,0.0603849,1.1212703,0.1158449,1.1430179,1.0683378,4.3522105,2.5917395,11.2320345),(7745,'ulna-cleaned.tif',183,4,1269,1.3729898,4.6776204,9.7814222,1.8,4.6287805,9.7502442,0.533624,0.5234671,2.1702295,0.0613968,2.4042556,0.059206,1.1078347,0.1172887,1.129225,1.0486901,4.3862788,2.596493,11.218343),(7746,'ulna-cleaned.tif',183,4,1270,1.3746002,4.6758823,9.785886,1.8,4.6259635,9.7552457,0.5330079,0.4879292,2.1834009,0.0613784,2.4071676,0.0591519,1.1024854,0.1257937,1.1266785,1.0092397,4.4000494,2.608949,10.8837904),(7747,'ulna-cleaned.tif',183,4,1271,1.3818235,4.676495,9.791615,1.8,4.6274196,9.7620368,0.5317413,0.7096923,2.1999661,0.0617601,2.4334217,0.0592076,1.1061178,0.0870238,1.1288241,0.9839442,4.4281811,2.5810831,11.0821159),(7748,'ulna-cleaned.tif',183,4,1272,1.3745136,4.6711555,9.7943255,1.8,4.6174733,9.7623272,0.5298242,0.7555214,2.1687143,0.0621924,2.4297284,0.0585109,1.1203543,0.0823172,1.142579,0.9746853,4.3944377,2.5762562,10.7902989),(7749,'ulna-cleaned.tif',183,4,1273,1.3788284,4.6630937,9.7972071,1.8,4.6069359,9.7653928,0.5279615,0.478179,2.1734308,0.0621233,2.4454597,0.0583216,1.1251611,0.1299165,1.1472483,0.9600809,4.3944377,2.5762562,10.9458888),(7750,'ulna-cleaned.tif',183,4,1274,1.3936466,4.6625579,9.8007504,1.8,4.6121349,9.7718899,0.5272082,0.4880081,2.1920107,0.0639903,2.4737266,0.0587962,1.1285194,0.1311255,1.1493807,0.9746853,4.4159406,2.5686265,11.0490616),(7751,'ulna-cleaned.tif',183,4,1275,1.4027414,4.6536901,9.7998835,1.8,4.6003292,9.7686772,0.5267239,0.7696243,2.214418,0.0660566,2.4906344,0.0590814,1.1247354,0.0858296,1.1495442,0.995646,4.4281811,2.5810831,10.9926345),(7752,'ulna-cleaned.tif',183,4,1276,1.3864198,4.6589283,9.8069955,1.8,4.6060576,9.7768943,0.523258,0.7391341,2.1710341,0.065268,2.4326095,0.0576993,1.1204842,0.0883033,1.1440741,0.995646,4.373193,2.5839605,10.5024921),(7753,'ulna-cleaned.tif',183,4,1277,1.3979584,4.6613996,9.8111463,1.8,4.6108858,9.7820449,0.522259,0.7615412,2.2038677,0.0670612,2.4528452,0.0579781,1.112973,0.0880598,1.1427151,0.995646,4.449521,2.5734879,10.7943091),(7754,'ulna-cleaned.tif',183,4,1278,1.4085046,4.652599,9.8089736,1.8,4.5988609,9.7768596,0.5213981,0.7641335,2.1949772,0.0699701,2.4661502,0.0582409,1.1235425,0.091568,1.1470877,1.009798,4.4070992,2.5887514,11.0256888),(7755,'ulna-cleaned.tif',183,4,1279,1.4045549,4.6552073,9.8148142,1.8,4.598835,9.7802617,0.5206186,0.7679796,2.2043688,0.0699902,2.4465456,0.05792,1.1098622,0.0911355,1.1365392,1.009798,4.4070992,2.5887514,10.9128345),(7756,'ulna-cleaned.tif',183,4,1280,1.393228,4.6586218,9.8222121,1.8,4.6055306,9.7902101,0.5211249,0.7527787,2.1978298,0.0681229,2.4257141,0.0575544,1.1036861,0.0904952,1.1298869,1.006666,4.4070992,2.5887514,10.8370447),(7757,'ulna-cleaned.tif',183,4,1281,1.3892308,4.6591525,9.8296914,1.8,4.6064382,9.8002074,0.5204953,0.739252,2.1787482,0.0673277,2.4295957,0.0572634,1.1151338,0.0910754,1.1384277,1.0002143,4.3944377,2.5762562,10.9362074),(7758,'ulna-cleaned.tif',183,4,1282,1.3932618,4.6523557,9.8284479,1.8,4.5980911,9.7967803,0.5195674,0.726893,2.1850304,0.0685204,2.4132993,0.0572438,1.1044694,0.0942647,1.1283471,1.0440779,4.3944377,2.5762562,11.2884616),(7759,'ulna-cleaned.tif',183,4,1283,1.3875412,4.6677903,9.8421897,1.8,4.621443,9.8144977,0.5187646,0.5234916,2.1843929,0.0684849,2.4013382,0.0568488,1.099316,0.1308234,1.121221,1.0637256,4.3657238,2.6043079,10.9031531),(7760,'ulna-cleaned.tif',183,4,1284,1.3953873,4.6597599,9.8433739,1.8,4.6068982,9.813007,0.5170205,0.52909,2.1855298,0.0699353,2.418366,0.0568213,1.1065354,0.1321803,1.1340811,1.0637256,4.3862788,2.596493,10.9966447),(7761,'ulna-cleaned.tif',183,4,1285,1.3929806,4.657843,9.8453705,1.8,4.6032081,9.8135523,0.517236,0.4922412,2.1712995,0.0688809,2.4109216,0.0567663,1.1103588,0.1399332,1.1348727,1.0329324,4.3657238,2.6043079,11.2787803),(7762,'ulna-cleaned.tif',183,4,1286,1.3969815,4.6562268,9.8459988,1.8,4.5990277,9.811991,0.5175572,0.6070943,2.1724718,0.070092,2.398892,0.0569936,1.1042224,0.1154549,1.1294375,0.9862721,4.3522105,2.5917395,10.926526),(7763,'ulna-cleaned.tif',183,4,1287,1.400668,4.6591607,9.8492366,1.8,4.6069385,9.8170425,0.5186515,0.6081388,2.1834574,0.0719861,2.3949602,0.0573639,1.096866,0.1183711,1.1258045,0.9700993,4.345438,2.6121963,10.9595803),(7764,'ulna-cleaned.tif',183,4,1288,1.4118571,4.6646029,9.8532999,1.8,4.6142159,9.8206318,0.5198866,0.6234089,2.1819573,0.0735537,2.3946229,0.0580725,1.0974655,0.1179862,1.1225831,1.0244742,4.3404893,2.6327084,10.7475633),(7765,'ulna-cleaned.tif',183,4,1289,1.4083003,4.6599225,9.8575032,1.8,4.6046236,9.8255796,0.5174609,0.6152919,2.1635455,0.0724466,2.3977813,0.057436,1.1082648,0.1177435,1.1350666,0.9805666,4.3562323,2.6451699,11.1014786),(7766,'ulna-cleaned.tif',183,4,1290,1.4095107,4.6553597,9.8607738,1.8,4.5969918,9.8287868,0.515524,0.5469014,2.1700698,0.0724772,2.4132118,0.0570946,1.1120434,0.1325233,1.1329362,0.9700553,4.345438,2.6121963,10.9692616),(7767,'ulna-cleaned.tif',183,4,1291,1.4016163,4.6586366,9.8669041,1.8,4.5984938,9.8332247,0.5135944,0.4672021,2.1787248,0.071969,2.379179,0.0563886,1.0920053,0.1540425,1.1165331,0.9805666,4.373193,2.5839605,10.8136718),(7768,'ulna-cleaned.tif',183,4,1292,1.408105,4.6670274,9.8724599,1.8,4.6113583,9.8398515,0.5147616,0.5319446,2.1689991,0.0741141,2.3742224,0.0568842,1.0946166,0.1393267,1.1203814,1.0637696,4.3393888,2.5790947,11.0200175),(7769,'ulna-cleaned.tif',183,4,1293,1.4128886,4.6640135,9.8717039,1.8,4.6051251,9.8365694,0.5138885,0.5331091,2.1972475,0.0742643,2.3522257,0.0569013,1.0705329,0.1393041,1.1036715,1.0682938,4.4204447,2.6011732,11.1852888),(7770,'ulna-cleaned.tif',183,4,1294,1.419921,4.6640741,9.8758086,1.8,4.6052904,9.8411185,0.5130876,0.5565515,2.1543032,0.075594,2.3584856,0.0570224,1.0947789,0.1358257,1.1176224,1.102727,4.3607981,2.5713547,11.2650888),(7771,'ulna-cleaned.tif',183,4,1295,1.4404764,4.6632022,9.8734299,1.8,4.6078066,9.8372809,0.5119409,0.5791639,2.1710993,0.078485,2.3681601,0.0576125,1.0907655,0.1355144,1.1183278,1.1318051,4.373193,2.5839605,11.5044888),(7772,'ulna-cleaned.tif',183,4,1296,1.4393802,4.6622441,9.8753506,1.8,4.6039152,9.8371606,0.5103521,0.5969945,2.170566,0.0795757,2.3424739,0.0572435,1.0791996,0.1332939,1.1072717,1.152803,4.3522105,2.5917395,11.4206786),(7773,'ulna-cleaned.tif',183,4,1297,1.430177,4.6705886,9.8822823,1.8,4.6212582,9.8494337,0.5105579,0.5989067,2.154085,0.0783963,2.3055808,0.0569193,1.0703296,0.1308991,1.1024391,1.1435442,4.2633296,2.5899377,11.9655871),(7774,'ulna-cleaned.tif',183,4,1298,1.426398,4.6698221,9.8913059,1.8,4.618114,9.8619258,0.5070857,0.6081784,2.124292,0.0774694,2.3081706,0.0560665,1.08656,0.1273794,1.1058205,1.0398809,4.2720959,2.5691328,10.8039904),(7775,'ulna-cleaned.tif',183,4,1299,1.4240494,4.6689069,9.8933422,1.8,4.6167427,9.8616254,0.5064726,0.6762884,2.1394092,0.0778318,2.303719,0.0558507,1.0768015,0.1150868,1.1008557,1.0398809,4.2843758,2.5820062,11.1425532),(7776,'ulna-cleaned.tif',183,4,1300,1.4240588,4.6624244,9.898052,1.8,4.602337,9.8652203,0.504028,0.6835677,2.1420196,0.0772213,2.3332401,0.0553596,1.0892711,0.1129681,1.1130453,1.0244742,4.305689,2.5741527,11.0393803),(7777,'ulna-cleaned.tif',183,4,1301,1.42351,4.6631361,9.9038772,1.8,4.5987403,9.8690513,0.5032139,0.6883321,2.1540389,0.0775934,2.3379839,0.055175,1.0853954,0.1127268,1.1132253,0.995646,4.318242,2.586911,11.1619159),(7778,'ulna-cleaned.tif',183,4,1302,1.4227978,4.6641221,9.9072586,1.8,4.5988323,9.8710551,0.5016586,0.6016806,2.1195453,0.0781927,2.3293419,0.054836,1.0989819,0.1299572,1.1188619,1.0349415,4.2720959,2.5691328,11.1562447),(7779,'ulna-cleaned.tif',183,4,1303,1.4312197,4.6664743,9.9106476,1.8,4.6012812,9.8735123,0.4996822,0.5556615,2.1310232,0.0807167,2.3265312,0.0547636,1.0917437,0.1452623,1.1171572,1.103065,4.2843758,2.5820062,10.9305362),(7780,'ulna-cleaned.tif',183,4,1304,1.4289073,4.66456,9.9170436,1.8,4.6024288,9.8848263,0.5000537,0.5190789,2.1488857,0.0806495,2.3316332,0.0547495,1.0850429,0.1553705,1.1082262,1.0440779,4.305689,2.5741527,11.0103362),(7781,'ulna-cleaned.tif',183,4,1305,1.4187907,4.6695749,9.9253093,1.8,4.6057104,9.8926628,0.4956823,0.516489,2.1390061,0.0795701,2.2908559,0.0534945,1.0709908,0.1540596,1.0935318,1.0440779,4.305689,2.5741527,11.2554074),(7782,'ulna-cleaned.tif',183,4,1306,1.4256866,4.6814616,9.93066,1.8,4.6285093,9.8995325,0.4956168,0.6813957,2.1145317,0.0823787,2.270311,0.0537415,1.0736708,0.1208969,1.1041459,1.2314185,4.2843758,2.5820062,11.5181803),(7783,'ulna-cleaned.tif',183,4,1307,1.4366316,4.6826995,9.9323867,1.8,4.6311009,9.9017542,0.4934743,0.7015641,2.1165628,0.0856368,2.2730018,0.0537254,1.0739118,0.1220655,1.0987676,1.2574783,4.2938408,2.5613219,11.6407159),(7784,'ulna-cleaned.tif',183,4,1308,1.4246876,4.6834987,9.938559,1.8,4.6271567,9.9086222,0.4943082,0.6875871,2.1199782,0.0833834,2.2640876,0.0534441,1.0679768,0.1212695,1.0925789,1.1043958,4.2843758,2.5820062,11.1522345),(7785,'ulna-cleaned.tif',183,4,1309,1.4290307,4.6882676,9.9423447,1.8,4.629607,9.9130108,0.4919762,0.6513502,2.1614211,0.0833133,2.2601851,0.0531438,1.045694,0.1279086,1.0837691,1.0522763,4.2862334,2.6363025,10.7846277),(7786,'ulna-cleaned.tif',183,4,1310,1.4410328,4.69908,9.9492146,1.8,4.6461094,9.9220171,0.4928673,0.6331971,2.1311686,0.0849604,2.2596545,0.0537684,1.060289,0.1341769,1.0884521,1.0567253,4.2709778,2.6236053,11.3118345),(7787,'ulna-cleaned.tif',183,4,1311,1.4473325,4.7127691,9.9583874,1.8,4.6622645,9.9320282,0.4932864,0.7480364,2.0934009,0.0876554,2.2505232,0.0540878,1.075056,0.1171807,1.1033932,1.0440779,4.2320342,2.6399886,11.1756074),(7788,'ulna-cleaned.tif',183,4,1312,1.4389872,4.7158393,9.9658631,1.8,4.6605834,9.9391963,0.4901864,0.7722471,2.1006386,0.0878321,2.2194822,0.053157,1.056575,0.1137357,1.0860705,1.0399974,4.2320342,2.6399886,11.2884616),(7789,'ulna-cleaned.tif',183,4,1313,1.4401536,4.7251494,9.9724675,1.8,4.6681538,9.9463278,0.4904569,0.7736717,2.1118762,0.0889901,2.2063676,0.0532541,1.0447429,0.1150231,1.0748856,1.0549566,4.2363581,2.6189419,11.298143),(7790,'ulna-cleaned.tif',183,4,1314,1.4345484,4.7256569,9.9726855,1.8,4.6643431,9.9456157,0.4891565,0.7737166,2.1548841,0.0871987,2.1980801,0.0527887,1.0200456,0.1127011,1.0600312,1.0662637,4.2720959,2.5691328,11.2320345),(7791,'ulna-cleaned.tif',183,4,1315,1.4512614,4.7232542,9.9744454,1.8,4.6490517,9.942224,0.485751,0.7580005,2.1704457,0.0895594,2.2353843,0.0527219,1.0299195,0.1181522,1.0698404,1.0980291,4.2973616,2.5948038,11.3352074),(7792,'ulna-cleaned.tif',183,4,1316,1.4505883,4.7339423,9.9831154,1.8,4.659273,9.9522879,0.487769,0.5653587,2.1837267,0.0899745,2.2298331,0.0531009,1.0211136,0.1591458,1.0609588,1.1135825,4.305689,2.5741527,11.4150074),(7793,'ulna-cleaned.tif',183,4,1317,1.4692407,4.7420524,9.9862691,1.8,4.6665653,9.953404,0.4855616,0.778325,2.2112313,0.0934468,2.2393077,0.0533368,1.0126972,0.1200614,1.0544081,1.1190613,4.327265,2.5663771,11.537543),(7794,'ulna-cleaned.tif',183,4,1318,1.4667469,4.7572648,9.9968521,1.8,4.6845095,9.965239,0.4877652,0.7451015,2.2294668,0.0961863,2.2133294,0.0536916,0.9927617,0.1290915,1.0353343,1.1554023,4.2129942,2.6482927,11.0103362),(7795,'ulna-cleaned.tif',183,4,1319,1.4665153,4.7718485,10.0100713,1.8,4.7102738,9.9861908,0.4849973,0.6405371,2.2301263,0.0957694,2.2015444,0.053124,0.9871837,0.1495142,1.0291288,1.1554023,4.2320342,2.6399886,11.0998175),(7796,'ulna-cleaned.tif',183,4,1320,1.4732657,4.7761771,10.0150115,1.8,4.7154286,9.9911034,0.4849968,0.7525946,2.2362589,0.0969478,2.1952383,0.0533685,0.9816566,0.1288181,1.0240679,1.1591928,4.1622414,2.6307698,10.7886378),(7797,'ulna-cleaned.tif',183,4,1321,1.4857897,4.7825929,10.0189903,1.8,4.7246736,9.9944689,0.4828274,0.6254187,2.2439914,0.0984723,2.1943881,0.0533797,0.9778951,0.1574502,1.0209476,1.1591928,4.1622414,2.6307698,11.0530718),(7798,'ulna-cleaned.tif',183,4,1322,1.4944917,4.783059,10.021743,1.8,4.7280967,9.9977443,0.4818596,0.7372292,2.2457666,0.1009382,2.1817941,0.0534942,0.9715142,0.1369156,1.0157137,1.1591928,4.1744631,2.5880592,11.1933091),(7799,'ulna-cleaned.tif',183,4,1323,1.5084001,4.7857169,10.0286182,1.8,4.7330541,10.0068499,0.4796843,0.6333848,2.2868763,0.1035297,2.2030516,0.0535435,0.9633453,0.1634546,1.0077516,1.1747462,4.1877898,2.6011732,11.1562447),(7800,'ulna-cleaned.tif',183,4,1324,1.5170035,4.7812127,10.0303004,1.8,4.7252652,10.0068923,0.4757894,1.0185788,2.2485264,0.1060376,2.2124795,0.0530448,0.9839687,0.1041035,1.0307096,1.1795867,4.1970932,2.6354175,11.3118345),(7801,'ulna-cleaned.tif',183,4,1325,1.5210009,4.7878853,10.0377106,1.8,4.7311992,10.0128094,0.4764497,0.6779772,2.3115671,0.1070591,2.2190947,0.0533209,0.9599958,0.1579095,1.0061211,1.1940901,4.1877898,2.6011732,10.9772819),(7802,'ulna-cleaned.tif',183,4,1326,1.5081147,4.8052523,10.0492133,1.8,4.7582707,10.0296938,0.4739586,0.6271065,2.3141634,0.1051858,2.1603146,0.0523597,0.9335186,0.167732,0.9784947,1.1982283,4.1622414,2.6307698,10.8974819),(7803,'ulna-cleaned.tif',183,4,1327,1.5271558,4.8053608,10.0497825,1.8,4.7552688,10.027769,0.4710686,0.7543833,2.3147175,0.1087997,2.1650143,0.0524246,0.9353255,0.1442234,0.9819405,1.2172669,4.1622414,2.6307698,11.0998175),(7804,'ulna-cleaned.tif',183,4,1328,1.5302304,4.8211326,10.0596617,1.8,4.7755642,10.0408931,0.473358,0.7557777,2.3331037,0.1098524,2.1528963,0.0530032,0.9227607,0.1453501,0.9694233,1.213434,4.1472975,2.6176733,11.0764447),(7805,'ulna-cleaned.tif',183,4,1329,1.5398026,4.8300744,10.0621185,1.8,4.7896699,10.04426,0.4714302,0.9883017,2.3423141,0.1118566,2.1323689,0.0529338,0.9103685,0.1131806,0.9577409,1.213434,4.1238152,2.6476513,10.9966447),(7806,'ulna-cleaned.tif',183,4,1330,1.5557515,4.8286426,10.0620588,1.8,4.7813329,10.040916,0.4705633,1.006844,2.1426922,0.1151666,2.1407122,0.0533003,0.9990759,0.1143837,1.0378301,1.213434,4.158989,2.6521997,11.1892989),(7807,'ulna-cleaned.tif',183,4,1331,1.5715542,4.8356484,10.062904,1.8,4.7950293,10.0428133,0.4714017,1.0045854,2.1308905,0.1208531,2.1330492,0.0540193,1.001013,0.1203015,1.0390977,1.2332931,4.1428807,2.6391714,11.3311972),(7808,'ulna-cleaned.tif',183,4,1332,1.5881097,4.8312415,10.0605912,1.8,4.785789,10.0376141,0.4694704,0.9860853,2.1091611,0.1248924,2.143193,0.0541753,1.0161353,0.1266548,1.0532491,1.2592713,4.1274811,2.6260436,11.3215159),(7809,'ulna-cleaned.tif',183,4,1333,1.5599098,4.8461445,10.0750381,1.8,4.8060927,10.0563481,0.4660625,0.7592761,2.1478536,0.1174925,2.0860857,0.0525002,0.971242,0.1547428,1.0096191,1.2592713,4.1238152,2.6476513,11.3973057),(7810,'ulna-cleaned.tif',183,4,1334,1.5607026,4.8509101,10.080143,1.8,4.8105166,10.064416,0.4647196,0.7796457,2.1727069,0.1198848,2.0708507,0.0522467,0.9531201,0.1537683,0.9885852,1.2600943,4.1428807,2.6391714,11.2320345),(7811,'ulna-cleaned.tif',183,4,1335,1.552216,4.8669056,10.094172,1.8,4.8268682,10.0822143,0.4650565,0.7493437,2.1574858,0.1177218,2.0520232,0.0520324,0.9511178,0.1570999,0.9877034,1.256078,4.1238152,2.6476513,11.2650888),(7812,'ulna-cleaned.tif',183,4,1336,1.5359083,4.8807964,10.0993186,1.8,4.8453718,10.0871421,0.4638658,0.7477523,2.1548506,0.1165398,1.9986878,0.0512416,0.9275296,0.1558535,0.9610396,1.2849061,4.1050489,2.6562093,11.0667633),(7813,'ulna-cleaned.tif',183,4,1337,1.5424316,4.8782614,10.1019009,1.8,4.8327915,10.0869439,0.4623028,0.7512428,2.1187198,0.1166281,1.9986425,0.0511381,0.9433255,0.1552469,0.9789934,1.2600943,4.0698001,2.6516353,10.8120107),(7814,'ulna-cleaned.tif',183,4,1338,1.5455898,4.8894582,10.1086913,1.8,4.8465248,10.0941073,0.4644063,0.7343646,2.130944,0.1181493,1.9899839,0.0516761,0.9338509,0.1608865,0.9770934,1.2743949,4.0731237,2.6297368,11.0998175),(7815,'ulna-cleaned.tif',183,4,1339,1.5525928,4.896266,10.1136216,1.8,4.8524965,10.0987766,0.4674947,0.7534293,2.1381897,0.120458,1.982572,0.0525518,0.9272199,0.1598796,0.9711356,1.3136903,4.0887281,2.6430247,11.2126718),(7816,'ulna-cleaned.tif',183,4,1340,1.5622663,4.9150508,10.1152747,1.8,4.8849099,10.0995252,0.471991,0.7642485,2.1533636,0.1234111,1.9533672,0.0538243,0.9071237,0.1614804,0.9441324,1.3091545,3.9728061,2.5563756,11.3488989),(7817,'ulna-cleaned.tif',183,4,1341,1.5613743,4.9163778,10.1251378,1.8,4.8805254,10.1138398,0.4676622,0.6830437,2.1609178,0.1203994,1.9620262,0.0528841,0.9079597,0.1762689,0.9450257,1.3136903,4.0887281,2.6430247,11.3295362),(7818,'ulna-cleaned.tif',183,4,1342,1.5643945,4.9240145,10.1313949,1.8,4.8848361,10.1193231,0.4672073,0.7571333,2.1527795,0.1230338,1.9584992,0.052891,0.9097537,0.1624995,0.945206,1.3136462,4.0887281,2.6430247,11.2690989),(7819,'ulna-cleaned.tif',183,4,1343,1.5731235,4.935664,10.1334585,1.8,4.9023619,10.1202965,0.4686495,0.7356925,2.1814559,0.1244038,1.9364492,0.0534905,0.8876866,0.1690976,0.9264862,1.3374699,4.0731237,2.6297368,11.5609159),(7820,'ulna-cleaned.tif',183,4,1344,1.587823,4.9401968,10.137143,1.8,4.9039373,10.1243625,0.4637587,0.7728721,2.1892586,0.1286973,1.9505295,0.052951,0.8909544,0.1665182,0.9325007,1.3414999,4.0887281,2.6430247,11.564926),(7821,'ulna-cleaned.tif',183,4,1345,1.6017475,4.9474825,10.1401005,1.8,4.9089386,10.1263659,0.4642089,0.7365374,2.1969069,0.1304641,1.9570153,0.0535115,0.8908048,0.1771316,0.9329326,1.3574723,4.1079565,2.6344941,11.4190176),(7822,'ulna-cleaned.tif',183,4,1346,1.6063901,4.9535523,10.1449436,1.8,4.9088075,10.1313452,0.4619187,0.7916411,2.1876833,0.1311748,1.948562,0.0531765,0.8906966,0.1656998,0.9308611,1.3414999,4.0887281,2.6430247,11.4714345),(7823,'ulna-cleaned.tif',183,4,1347,1.6087921,4.9667769,10.1539356,1.8,4.9217707,10.1395584,0.4610143,0.7225363,2.1504524,0.1325096,1.9264641,0.0530627,0.8958413,0.1833951,0.9356157,1.3445124,4.0511766,2.6603257,11.2126718),(7824,'ulna-cleaned.tif',183,4,1348,1.6211866,4.9789414,10.168012,1.8,4.9353461,10.1585469,0.4602901,0.7214515,2.1679416,0.136509,1.9479444,0.0533156,0.8985225,0.1892144,0.94067,1.3647862,4.0511766,2.6603257,11.0433904),(7825,'ulna-cleaned.tif',183,4,1349,1.6281396,4.9854611,10.1767665,1.8,4.9411254,10.168157,0.4617723,0.7139932,2.1769968,0.1375683,1.9483458,0.0538648,0.8949695,0.1926745,0.9377296,1.3609958,4.0511766,2.6603257,10.765265),(7826,'ulna-cleaned.tif',183,4,1350,1.6322672,4.9947807,10.1845062,1.8,4.9520408,10.176737,0.4613401,0.7297051,2.1889848,0.1400885,1.9349864,0.0539076,0.8839652,0.1919796,0.9282765,1.3589287,4.0511766,2.6603257,10.8741091),(7827,'ulna-cleaned.tif',183,4,1351,1.6311049,4.9991266,10.1879182,1.8,4.9595701,10.1806996,0.4632484,0.7254507,2.1935284,0.140777,1.9200824,0.0542834,0.8753396,0.1940546,0.9198302,1.3740082,4.0537301,2.6383182,11.2690989),(7828,'ulna-cleaned.tif',183,4,1352,1.6328327,5.0047174,10.1925123,1.8,4.9653261,10.1839234,0.4615055,0.7266889,2.2011808,0.1430448,1.9047573,0.0539622,0.8653343,0.1968447,0.9153611,1.3876688,4.0346379,2.6469815,10.8878006),(7829,'ulna-cleaned.tif',183,4,1353,1.6469881,5.0076605,10.1973196,1.8,4.9644207,10.1879633,0.4593656,0.7448718,2.2071011,0.1476356,1.9184793,0.0539623,0.8692304,0.1982027,0.9178083,1.4178718,4.0731237,2.6297368,11.0143463),(7830,'ulna-cleaned.tif',183,4,1354,1.6621464,5.0068217,10.1987636,1.8,4.9545826,10.1853441,0.4525358,0.7366183,2.2458365,0.1497455,1.9361943,0.052963,0.8621261,0.2032878,0.9111831,1.4034741,4.0928144,2.6212374,11.2497362),(7831,'ulna-cleaned.tif',183,4,1355,1.666265,5.0098919,10.2019746,1.8,4.9572301,10.1871476,0.454588,0.7492685,2.2490894,0.1509311,1.926506,0.0535432,0.8565716,0.201438,0.9059699,1.4272669,4.0887281,2.6430247,11.1836277),(7832,'ulna-cleaned.tif',183,4,1356,1.6666301,5.0157148,10.2058199,1.8,4.9689614,10.1933597,0.4536191,0.7819601,2.2564405,0.1518602,1.9047162,0.0533427,0.8441243,0.1942045,0.8942933,1.4027924,4.0887281,2.6430247,11.1699362),(7833,'ulna-cleaned.tif',183,4,1357,1.668848,5.0140809,10.2086252,1.8,4.9635857,10.1945781,0.4541539,0.7677339,2.237614,0.1525996,1.9051455,0.053531,0.8514183,0.1987663,0.9060681,1.3982241,4.0928144,2.6212374,11.2360447),(7834,'ulna-cleaned.tif',183,4,1358,1.6648535,5.0190794,10.2164806,1.8,4.9687729,10.203653,0.4537948,0.7590064,2.26406,0.1534777,1.8951583,0.0533243,0.8370619,0.2022087,0.8885199,1.4133036,4.1238152,2.6476513,11.697143),(7835,'ulna-cleaned.tif',183,4,1359,1.6681219,5.0247712,10.2202547,1.8,4.9764079,10.2065231,0.4565411,0.7539132,2.2696265,0.154952,1.8782191,0.0540319,0.8275455,0.2055303,0.8793415,1.4329513,3.9290866,2.5366903,10.7983192),(7836,'ulna-cleaned.tif',183,4,1360,1.6823303,5.0279217,10.223991,1.8,4.9796847,10.2089579,0.4559432,0.7535471,2.2567954,0.1599668,1.8821431,0.0543596,0.8339892,0.212285,0.8855571,1.4439238,3.9396074,2.5507811,11.2166819),(7837,'ulna-cleaned.tif',183,4,1361,1.679155,5.0349573,10.2283847,1.8,4.9880088,10.2140505,0.4537527,0.7553314,2.2660778,0.1590078,1.858852,0.0537731,0.8202949,0.2105139,0.8720525,1.4466944,3.9175218,2.5592397,11.2206921),(7838,'ulna-cleaned.tif',183,4,1362,1.6773044,5.0444024,10.2327113,1.8,5.0025381,10.2183108,0.4559518,0.7529606,2.2929968,0.1604109,1.830346,0.0541991,0.7982331,0.2130402,0.8528038,1.4324868,3.9065341,2.5450917,11.4988176),(7839,'ulna-cleaned.tif',183,4,1363,1.6869901,5.0381379,10.2333128,1.8,4.9883812,10.2160995,0.4538087,0.7705813,2.2168395,0.163027,1.8256916,0.0540364,0.823556,0.2115637,0.8832309,1.4480308,3.8957197,2.5677936,11.8841261),(7840,'ulna-cleaned.tif',183,4,1364,1.6859922,5.0510189,10.242466,1.8,5.0077968,10.2255571,0.4552432,0.7840746,2.1967786,0.1637934,1.8034915,0.0543224,0.820971,0.2089003,0.8759864,1.4359125,3.8842605,2.5535901,10.6096751),(7841,'ulna-cleaned.tif',183,4,1365,1.6930104,5.0426763,10.2435515,1.8,4.990591,10.2236104,0.4516551,0.7851979,2.527633,0.1662088,1.8153763,0.0537512,0.718212,0.2116776,0.7810659,1.4694782,3.8957197,2.5677936,10.6524107),(7842,'ulna-cleaned.tif',183,4,1366,1.7150867,5.0405036,10.2457317,1.8,4.9844779,10.2243829,0.4480755,0.8039826,2.5273838,0.1720485,1.8601413,0.0536507,0.7359948,0.2139953,0.8014067,1.4873262,3.9065341,2.5450917,10.6096751),(7843,'ulna-cleaned.tif',183,4,1367,1.7092282,5.0497063,10.2544617,1.8,4.9947491,10.2322155,0.4491091,0.7998302,2.2395687,0.1699506,1.8285441,0.0536976,0.8164715,0.2124833,0.8741779,1.5669807,3.8742059,2.5764432,12.4290346),(7844,'ulna-cleaned.tif',183,4,1368,1.7020787,5.05689,10.2591114,1.8,5.0061965,10.2379564,0.4529671,0.8099023,2.2637365,0.1694738,1.7989015,0.0543317,0.7946603,0.2092521,0.8541928,1.4987309,3.8735894,2.5393053,11.6858006),(7845,'ulna-cleaned.tif',183,4,1369,1.7146613,5.0593378,10.2652499,1.8,5.010335,10.2449282,0.4558146,0.7839274,2.1964468,0.1727568,1.7981359,0.0553752,0.8186567,0.2203734,0.8760409,1.5082707,3.8842605,2.5535901,12.0203532),(7846,'ulna-cleaned.tif',183,4,1370,1.7084876,5.0723811,10.2717118,1.8,5.030136,10.2521178,0.4550021,0.8026475,2.1938631,0.1748227,1.7662949,0.054993,0.8051072,0.2178075,0.8608604,1.527159,3.9175218,2.5592397,11.4794548),(7847,'ulna-cleaned.tif',183,4,1371,1.7128654,5.06629,10.269877,1.8,5.0156684,10.2465402,0.4482524,0.8131242,2.2615873,0.1772572,1.7760766,0.0536207,0.785323,0.2179952,0.84706,1.6001942,3.9175218,2.5592397,11.9679362),(7848,'ulna-cleaned.tif',183,4,1372,1.7264611,5.068544,10.2730796,1.8,5.0165788,10.24895,0.4486179,0.8092949,2.1942798,0.1807447,1.7703159,0.0541285,0.8067868,0.223336,0.8665925,1.5855898,3.9175218,2.5592397,11.6664379),(7849,'ulna-cleaned.tif',183,4,1373,1.7314942,5.0710718,10.2779257,1.8,5.0158969,10.2536077,0.4471579,0.8269245,2.182135,0.1840461,1.7672702,0.0539573,0.8098812,0.222567,0.8686402,1.5855898,3.8735894,2.5393053,11.4270379),(7850,'ulna-cleaned.tif',183,4,1374,1.7513234,5.0752535,10.281759,1.8,5.0219579,10.2563115,0.4466659,0.8087974,2.2050599,0.1897647,1.7830783,0.0544633,0.8086303,0.2346258,0.8729822,1.5661977,3.8735894,2.5393053,11.5495735),(7851,'ulna-cleaned.tif',183,4,1375,1.7580609,5.0671359,10.2850727,1.8,5.0082716,10.2594638,0.4476203,0.8180646,2.2159726,0.1900484,1.8001386,0.0548909,0.812347,0.2323147,0.879802,1.5681207,3.8842605,2.5535901,11.9969803),(7852,'ulna-cleaned.tif',183,4,1376,1.7471296,5.0742072,10.297279,1.8,5.014979,10.2735179,0.4421715,0.8184572,2.2660927,0.1912526,1.7876087,0.0533169,0.7888507,0.2336745,0.8564219,1.5791781,4.0731237,2.6297368,12.0574176),(7853,'ulna-cleaned.tif',183,4,1377,1.7313852,5.0723666,10.3027132,1.8,5.0082186,10.2769989,0.4415742,0.8156393,2.2329166,0.1877031,1.7737894,0.0527032,0.7943823,0.23013,0.8558467,1.5503499,4.0328619,2.6690957,12.3549058),(7854,'ulna-cleaned.tif',183,4,1378,1.7322277,5.0727335,10.3090756,1.8,5.0053315,10.2834308,0.4424022,0.8428717,2.2526252,0.1882654,1.7920294,0.0529137,0.7955293,0.2233619,0.8600588,1.5507545,4.0698001,2.6516353,12.679777),(7855,'ulna-cleaned.tif',183,4,1379,1.736733,5.0737819,10.3113757,1.8,5.0060126,10.2861322,0.4393125,0.8268525,2.2368733,0.187754,1.7764377,0.052361,0.7941611,0.2270707,0.8633632,1.5624073,4.0237722,2.6113769,12.5088346),(7856,'ulna-cleaned.tif',183,4,1380,1.7401308,5.079837,10.3170217,1.8,5.0115514,10.2916223,0.4374467,0.8463101,2.2816634,0.1919352,1.7634061,0.0520475,0.7728599,0.2267907,0.8424771,1.5863246,4.0731237,2.6297368,12.1372176),(7857,'ulna-cleaned.tif',183,4,1381,1.7370535,5.0807366,10.3232123,1.8,5.0106156,10.2989411,0.4287366,0.8543235,2.2689706,0.1914817,1.7469978,0.0500343,0.7699517,0.2241325,0.8445147,1.5863246,4.0731237,2.6297368,12.3161803),(7858,'ulna-cleaned.tif',183,4,1382,1.7362393,5.0930426,10.3311793,1.8,5.0298624,10.3083803,0.4348041,0.8456382,2.1055483,0.1920322,1.7177562,0.0513455,0.8158237,0.2270856,0.8867175,1.5628538,3.8957197,2.5677936,11.6721091),(7859,'ulna-cleaned.tif',183,4,1383,1.7446213,5.0945459,10.3339598,1.8,5.0313368,10.3098583,0.4300861,0.8512592,2.0935526,0.1929682,1.7176703,0.0505494,0.8204572,0.2266856,0.8897663,1.5681568,3.8842605,2.5535901,11.8180176),(7860,'ulna-cleaned.tif',183,4,1384,1.7707259,5.0909414,10.3403926,1.8,5.0239306,10.3168681,0.4300502,0.8606013,2.1458773,0.1991985,1.7651715,0.0512977,0.8225874,0.2314643,0.8958788,1.6397829,3.9266548,2.6552217,12.4347058),(7861,'ulna-cleaned.tif',183,4,1385,1.7741549,5.0982122,10.345608,1.8,5.0358883,10.3213969,0.4282947,0.8940246,2.1917411,0.2010935,1.7566011,0.0510042,0.8014638,0.2249306,0.8740348,1.7562378,3.8963327,2.5308667,12.0574176),(7862,'ulna-cleaned.tif',183,4,1386,1.7712139,5.1073792,10.35297,1.8,5.0457224,10.3290011,0.4269083,0.9287599,2.1509317,0.2028021,1.7448127,0.0506108,0.8111892,0.2183579,0.884127,1.8033673,3.8405694,2.5708794,11.7712718),(7863,'ulna-cleaned.tif',183,4,1387,1.761919,5.119497,10.3596187,1.8,5.0613557,10.3345352,0.4203357,0.9438567,2.1677867,0.2063402,1.7137249,0.0488987,0.7905413,0.2186139,0.8664139,1.8260325,3.7736627,2.5594551,11.8083362),(7864,'ulna-cleaned.tif',183,4,1388,1.7686063,5.121744,10.3624574,1.8,5.0592913,10.335339,0.4190797,1.0133542,2.1715707,0.2118628,1.7227382,0.0488088,0.7933143,0.2090708,0.8718741,1.9088036,3.7854567,2.574055,12.0670989),(7865,'ulna-cleaned.tif',183,4,1389,1.7762154,5.1290858,10.3691262,1.8,5.0678428,10.3415833,0.4191774,1.0165484,2.0311978,0.214391,1.7163146,0.0490403,0.8449766,0.2109009,0.9404006,1.9088036,3.7854567,2.574055,12.1235261),(7866,'ulna-cleaned.tif',183,4,1390,1.7912664,5.1311869,10.3758212,1.8,5.0654228,10.3484744,0.4147992,1.1068999,2.4840174,0.2230759,1.7473498,0.0484878,0.703437,0.2015321,0.7669574,2.0027612,3.8080992,2.5274332,12.3492345),(7867,'ulna-cleaned.tif',183,4,1391,1.7874687,5.1374908,10.3841618,1.8,5.0721962,10.3560762,0.4190611,1.1158862,2.4214334,0.2202726,1.7310852,0.0493252,0.714901,0.197397,0.7726136,1.9979719,3.9065341,2.5450917,12.5652617),(7868,'ulna-cleaned.tif',183,4,1392,1.7901044,5.1405534,10.3943799,1.8,5.0737302,10.3669244,0.4158953,1.084607,2.4306242,0.2256666,1.7465503,0.0486978,0.7185604,0.208063,0.7795182,1.9789332,3.8405694,2.5708794,12.2871362),(7869,'ulna-cleaned.tif',183,4,1393,1.7799247,5.1548109,10.4093502,1.8,5.09753,10.3872152,0.4185315,1.0746825,2.2575474,0.2251003,1.7092297,0.0490003,0.757118,0.2094575,0.8409009,1.9925466,3.8181195,2.5419964,11.8260379),(7870,'ulna-cleaned.tif',183,4,1394,1.7736155,5.1467064,10.4193327,1.8,5.080116,10.3970688,0.4195782,1.0718451,2.2374949,0.2219311,1.7280491,0.0490566,0.7723142,0.2070552,0.853053,1.9732027,3.8289451,2.5564802,12.0654379),(7871,'ulna-cleaned.tif',183,4,1395,1.7612156,5.1467005,10.4274259,1.8,5.0767509,10.4037314,0.4227518,1.0621262,2.4649333,0.2183161,1.7232958,0.0494088,0.6991247,0.2055463,0.7540858,1.9626652,3.8289451,2.5564802,11.9776176),(7872,'ulna-cleaned.tif',183,4,1396,1.7598882,5.1453698,10.4328068,1.8,5.0715454,10.4068152,0.4243454,0.9998996,2.2724243,0.2167399,1.7329951,0.0497218,0.7626195,0.2167617,0.8454502,1.8840642,3.8511253,2.547843,12.0904718),(7873,'ulna-cleaned.tif',183,4,1397,1.7666552,5.140043,10.4348291,1.8,5.0604852,10.4065198,0.4200887,1.0202048,2.339014,0.2188975,1.7577736,0.048976,0.7515019,0.2145623,0.8371589,1.9025368,3.8405694,2.5708794,11.8510718),(7874,'ulna-cleaned.tif',183,4,1398,1.7288345,5.1557438,10.4480302,1.8,5.0830394,10.4240059,0.4171701,1.2339676,2.3111494,0.2193115,1.706764,0.0473028,0.7384914,0.1777287,0.8199814,1.9351734,3.7957465,2.5506746,11.8510718),(7875,'ulna-cleaned.tif',183,4,1399,1.7227771,5.1554618,10.4541877,1.8,5.0776016,10.4288736,0.4148577,1.2375683,2.3143373,0.2224165,1.6979579,0.0466462,0.7336692,0.1797206,0.8171427,1.6708897,3.807054,2.5652174,11.0804548),(7876,'ulna-cleaned.tif',183,4,1400,1.6916935,5.1708565,10.4688924,1.8,5.0928969,10.4467381,0.4153314,1.2452507,2.0903982,0.2209024,1.6654409,0.0459032,0.7967099,0.1773959,0.8947983,1.6812262,3.807054,2.5652174,11.2263633),(7877,'ulna-cleaned.tif',183,4,1401,1.6936925,5.1803001,10.4805428,1.8,5.0993033,10.4599456,0.4176409,1.2541621,2.1033713,0.2201011,1.665682,0.0464398,0.7919106,0.1754965,0.893115,1.6761218,3.807054,2.5652174,10.5475768),(7878,'ulna-cleaned.tif',183,4,1402,1.6858687,5.1859232,10.4902593,1.8,5.0996144,10.4684044,0.4192752,1.2095155,2.0915815,0.2193004,1.6652556,0.0465663,0.7961706,0.1813126,0.8764079,1.6761218,3.7736627,2.5594551,10.7983192),(7879,'ulna-cleaned.tif',183,4,1403,1.6930153,5.1822234,10.4965817,1.8,5.0937916,10.4760886,0.418854,1.2528848,2.1114535,0.2235815,1.6888252,0.0466753,0.7998401,0.1784534,0.8871486,1.6761218,3.8405694,2.5708794,10.7555836),(7880,'ulna-cleaned.tif',183,4,1404,1.6942782,5.1866618,10.5045028,1.8,5.0960529,10.482612,0.4190107,1.2219988,2.1187071,0.2265678,1.7001317,0.046743,0.8024383,0.1854075,0.891307,1.7495058,3.8289451,2.5564802,11.4657633),(7881,'ulna-cleaned.tif',183,4,1405,1.6887774,5.1927906,10.5101407,1.8,5.0980767,10.4854063,0.4173863,1.1706308,2.1268289,0.2262081,1.6854045,0.0462519,0.7924495,0.1932361,0.8814035,1.8765094,3.8289451,2.5564802,11.5165192),(7882,'ulna-cleaned.tif',183,4,1406,1.6827746,5.2091709,10.5247299,1.8,5.1161298,10.501525,0.4154295,1.0458245,2.1608737,0.229605,1.6622312,0.0456815,0.7692403,0.2195445,0.8611592,1.946639,3.8289451,2.5564802,11.8510718),(7883,'ulna-cleaned.tif',183,4,1407,1.6790696,5.2191086,10.5375505,1.8,5.1226752,10.5124081,0.4202961,1.0416099,2.1569448,0.2287489,1.648151,0.0465911,0.7641137,0.219611,0.8529747,1.7141991,3.8057992,2.6263477,11.1215294),(7884,'ulna-cleaned.tif',183,4,1408,1.6879087,5.2233894,10.5466784,1.8,5.1280434,10.5231191,0.4173186,1.0618436,2.1658442,0.2313893,1.6514427,0.046214,0.7624938,0.2179128,0.8532689,1.7444749,3.7862978,2.6355177,11.3666006),(7885,'ulna-cleaned.tif',183,4,1409,1.6908289,5.2236309,10.5494223,1.8,5.1225965,10.5211705,0.4150863,1.046186,2.1520183,0.2328238,1.6555806,0.0458287,0.7693153,0.2225453,0.8588097,1.9308547,3.7854567,2.574055,12.0767803),(7886,'ulna-cleaned.tif',183,4,1410,1.693281,5.2318982,10.5595756,1.8,5.1324701,10.533748,0.4125855,1.0500419,2.1647854,0.2370544,1.648715,0.0453755,0.7616067,0.2257571,0.8536501,1.9308547,3.807054,2.5652174,11.7906345),(7887,'ulna-cleaned.tif',183,4,1411,1.6989493,5.2422181,10.5666335,1.8,5.146334,10.5402306,0.4108502,1.0668644,2.7029779,0.2408382,1.641136,0.045167,0.6071585,0.225744,0.6938055,1.9498934,3.7957465,2.5506746,11.644726),(7888,'ulna-cleaned.tif',183,4,1412,1.7014658,5.2430332,10.5723074,1.8,5.1405041,10.5420809,0.4141075,1.1271336,2.7052516,0.2426027,1.641208,0.0459124,0.6066748,0.2152387,0.693818,1.721999,3.7736627,2.5594551,10.9442277),(7889,'ulna-cleaned.tif',183,4,1413,1.712888,5.2447229,10.576553,1.8,5.142696,10.5448294,0.4118353,1.2014694,2.1836633,0.2452976,1.6443704,0.0457437,0.7530329,0.2041646,0.8492051,1.714441,3.7980526,2.5885612,10.8821294),(7890,'ulna-cleaned.tif',183,4,1414,1.727297,5.2407042,10.5826904,1.8,5.131641,10.5506139,0.4148804,1.2112858,2.4967337,0.2473423,1.6676076,0.0467734,0.6679157,0.2041982,0.7613277,1.7272128,3.7980526,2.5885612,10.9716107),(7891,'ulna-cleaned.tif',183,4,1415,1.7263608,5.2382988,10.5864092,1.8,5.1289403,10.5555123,0.4122842,1.2134548,2.4442583,0.2431315,1.6573905,0.0461983,0.678075,0.200363,0.771185,1.7462514,3.7772469,2.59755,10.9345463),(7892,'ulna-cleaned.tif',183,4,1416,1.719632,5.2390047,10.593365,1.8,5.127955,10.5639852,0.4110359,1.0928144,2.1854803,0.2418243,1.6526897,0.0457558,0.7562135,0.2212858,0.8520997,1.7683025,3.7514489,2.6303619,11.0570819),(7893,'ulna-cleaned.tif',183,4,1417,1.7047191,5.2496135,10.6068706,1.8,5.1410714,10.5817715,0.4131274,1.1392637,2.1997594,0.2430548,1.6262351,0.0457952,0.7392786,0.2133438,0.8357202,1.7638188,3.7711306,2.6211342,10.8120107),(7894,'ulna-cleaned.tif',183,4,1418,1.7074107,5.2452179,10.6094433,1.8,5.1286155,10.5801745,0.4068073,1.1539081,2.1992565,0.245633,1.6416575,0.0445526,0.7464602,0.2128705,0.845161,1.7762402,3.7854567,2.574055,11.1933091),(7895,'ulna-cleaned.tif',183,4,1419,1.6943659,5.247555,10.6187394,1.8,5.1287051,10.5883161,0.4098253,1.1116391,2.712968,0.241112,1.6242904,0.0448334,0.5987134,0.2168977,0.6854243,1.7831627,3.7862978,2.6355177,10.9949836),(7896,'ulna-cleaned.tif',183,4,1420,1.7008983,5.2474124,10.6235212,1.8,5.1310414,10.5915918,0.4116342,1.1176018,2.200368,0.2421219,1.6347933,0.0453817,0.7429636,0.2166442,0.8418982,1.7875831,3.7641586,2.5829933,11.0086751),(7897,'ulna-cleaned.tif',183,4,1421,1.7062983,5.2488354,10.6264775,1.8,5.1366839,10.5916419,0.4038106,1.2022199,2.2207685,0.2475588,1.6494254,0.043906,0.7427273,0.205918,0.8466576,1.7875831,3.7854567,2.574055,11.032048),(7898,'ulna-cleaned.tif',183,4,1422,1.7009832,5.2525657,10.6379907,1.8,5.1467807,10.6081151,0.4057442,1.2287176,2.2282711,0.2476541,1.6376064,0.0441661,0.7349224,0.2015549,0.8413725,1.8063798,3.7772469,2.59755,10.9191938),(7899,'ulna-cleaned.tif',183,4,1423,1.6989498,5.2490577,10.6420552,1.8,5.1437242,10.6109556,0.4058132,1.2338974,2.2369503,0.2479523,1.639677,0.0441275,0.7329966,0.2009505,0.8300916,1.7903536,3.7711306,2.6211342,11.2497362),(7900,'ulna-cleaned.tif',183,4,1424,1.7056693,5.2573232,10.6535695,1.8,5.1570896,10.625127,0.4128717,1.2107528,2.2462001,0.2523101,1.6436247,0.0457673,0.7317357,0.2083911,0.8298589,1.8377915,3.7711306,2.6211342,11.5746074),(7901,'ulna-cleaned.tif',183,4,1425,1.7186841,5.2684317,10.663954,1.8,5.1699738,10.6334363,0.4144572,1.2171688,2.2598852,0.2619936,1.6370366,0.0464508,0.7243893,0.2152484,0.8264427,1.8741487,3.7711306,2.6211342,11.6213532),(7902,'ulna-cleaned.tif',183,4,1426,1.7222751,5.2773191,10.6799576,1.8,5.1809521,10.6533863,0.4206461,1.1807177,2.2556226,0.2666874,1.6358068,0.0478649,0.725213,0.2258689,0.8267691,1.8940987,3.7711306,2.6211342,11.724526),(7903,'ulna-cleaned.tif',183,4,1427,1.7331368,5.2807991,10.6841454,1.8,5.1857807,10.657554,0.4178396,1.2496894,2.3062586,0.275294,1.6521259,0.0475639,0.7163663,0.2202899,0.8309423,1.9432575,3.7365664,2.6158241,11.5028277),(7904,'ulna-cleaned.tif',183,4,1428,1.7188746,5.2822792,10.6876047,1.8,5.1827835,10.6611598,0.4139002,1.2327754,2.3099643,0.2684467,1.63915,0.0463384,0.7095997,0.217758,0.8215219,1.9268936,3.8529851,2.5851887,11.7011532),(7905,'ulna-cleaned.tif',183,4,1429,1.7240789,5.2917531,10.7034121,1.8,5.1912167,10.6788007,0.4201553,1.1958444,2.3150212,0.2764202,1.6464846,0.0478099,0.7112179,0.2311506,0.8150308,1.9720372,3.8057992,2.6263477,11.5963192),(7906,'ulna-cleaned.tif',183,4,1430,1.7506974,5.3110123,10.7293349,1.8,5.2111218,10.6997557,0.4367047,1.2241501,2.3355912,0.300502,1.6489805,0.0521975,0.7060227,0.245478,0.8177442,2.1050938,3.8256174,2.6172719,11.855082),(7907,'ulna-cleaned.tif',183,4,1431,1.7704822,5.309368,10.7387682,1.8,5.2030221,10.7043227,0.4401367,1.1828368,2.2833718,0.3044922,1.681522,0.0535659,0.7364206,0.2574253,0.849971,2.0555431,3.7711306,2.6211342,11.9268617),(7908,'ulna-cleaned.tif',183,4,1432,1.7641843,5.3154666,10.7424697,1.8,5.2142021,10.7101027,0.4335739,1.1956523,2.3466361,0.3027385,1.6622255,0.0518958,0.7083439,0.2531994,0.8216816,2.18989,3.8602091,2.6224465,12.4347058),(7909,'ulna-cleaned.tif',183,4,1433,1.7452059,5.3225248,10.7441875,1.8,5.226586,10.7174202,0.4243838,1.1873146,2.3579084,0.2916463,1.6237812,0.0493154,0.6886532,0.2456352,0.7985414,2.0525001,3.8602091,2.6224465,11.8801159),(7910,'ulna-cleaned.tif',183,4,1434,1.740407,5.3178767,10.745197,1.8,5.216474,10.7177475,0.4173227,1.13208,2.393594,0.2811162,1.6228708,0.0476523,0.6780059,0.2483183,0.7825187,2.0975925,3.9104037,2.6414316,11.9502345),(7911,'ulna-cleaned.tif',183,4,1435,1.7469581,5.3153071,10.745906,1.8,5.2113882,10.7164256,0.4103763,1.1285072,2.3419927,0.2832142,1.6343302,0.0463423,0.6978374,0.2509636,0.8047303,2.0761296,3.8602091,2.6224465,11.8744447),(7912,'ulna-cleaned.tif',183,4,1436,1.7428603,5.314329,10.7488626,1.8,5.210287,10.7204913,0.4095176,1.1309545,2.3585359,0.2834101,1.634551,0.0460513,0.6930363,0.2505937,0.801885,2.0854757,3.8602091,2.6224465,12.6877973),(7913,'ulna-cleaned.tif',183,4,1437,1.7515583,5.313415,10.751006,1.8,5.2100248,10.7242835,0.4057204,1.1303823,2.3442871,0.2833553,1.6479535,0.0454742,0.7029658,0.2506721,0.8107452,2.0975925,3.8405694,2.6314669,12.0243633),(7914,'ulna-cleaned.tif',183,4,1438,1.7414454,5.3247253,10.7601079,1.8,5.2259083,10.7365859,0.4067647,1.1508526,2.3578326,0.2857114,1.6207288,0.0454317,0.6873808,0.2482606,0.7959358,2.0288345,3.8602091,2.6224465,11.4367192),(7915,'ulna-cleaned.tif',183,4,1439,1.7515609,5.3216362,10.7649815,1.8,5.218937,10.7399379,0.4017102,1.115825,2.3957192,0.2877149,1.646095,0.0446285,0.6870985,0.2578495,0.7950951,2.0834643,3.8949023,2.6275291,12.2226888),(7916,'ulna-cleaned.tif',183,4,1440,1.7461596,5.3367845,10.7777577,1.8,5.2404082,10.7552638,0.4112657,1.1291717,2.4471668,0.2924569,1.6092165,0.0465107,0.6575835,0.2590012,0.7641275,2.1004992,3.949294,2.6236997,12.6353803),(7917,'ulna-cleaned.tif',183,4,1441,1.7499896,5.3256375,10.7805196,1.8,5.2196739,10.7540138,0.4082069,1.1337386,2.3869449,0.2927099,1.6385515,0.0459607,0.6864639,0.2581811,0.7945349,2.1037151,3.9104037,2.6414316,12.3435633),(7918,'ulna-cleaned.tif',183,4,1442,1.7656903,5.3262931,10.7859452,1.8,5.2169321,10.7579923,0.4055923,1.1363877,2.5321419,0.2997298,1.6587369,0.0458138,0.6550726,0.2637566,0.7435001,2.1014251,3.8949023,2.6275291,12.1936447),(7919,'ulna-cleaned.tif',183,4,1443,1.7777746,5.3245994,10.7890638,1.8,5.2117398,10.7569237,0.4056964,1.1400042,2.4062548,0.3012701,1.6819764,0.0461497,0.6990018,0.264271,0.8125999,2.1067707,3.9146761,2.6186539,12.3862989),(7920,'ulna-cleaned.tif',183,4,1444,1.7644548,5.3486588,10.8077949,1.8,5.249467,10.7828768,0.4104794,1.1147757,2.3813032,0.300815,1.6046822,0.0468287,0.6738672,0.2698435,0.7872987,2.0853572,3.8754384,2.6364941,11.8220277),(7921,'ulna-cleaned.tif',183,4,1445,1.7653567,5.357447,10.8153014,1.8,5.2625411,10.7893918,0.4096822,1.1175426,2.3878859,0.3017501,1.5931068,0.0466811,0.667162,0.2700121,0.7856818,2.0900183,3.8869237,2.5906102,11.9969803),(7922,'ulna-cleaned.tif',183,4,1446,1.7531674,5.371784,10.8313584,1.8,5.2812447,10.8098922,0.4124848,1.1080851,2.3859418,0.3038474,1.5551024,0.0469587,0.6517772,0.2742094,0.7736832,2.0960796,3.8529851,2.5851887,11.7929836),(7923,'ulna-cleaned.tif',183,4,1447,1.7446744,5.3812558,10.8459274,1.8,5.2909976,10.8251134,0.418797,1.1225344,2.4431347,0.3063709,1.5414275,0.0480872,0.630922,0.2729279,0.7419279,2.1122574,3.8742059,2.5764432,11.695482),(7924,'ulna-cleaned.tif',183,4,1448,1.7398849,5.3926405,10.8595099,1.8,5.3057822,10.8394907,0.4286951,1.1377477,2.4314075,0.3089533,1.5128378,0.0501068,0.6222066,0.2715482,0.7412779,2.1141501,3.7091982,2.5864141,11.3996548),(7925,'ulna-cleaned.tif',183,4,1449,1.7341273,5.3955827,10.863387,1.8,5.3073321,10.8413962,0.4168197,1.1473226,2.2698587,0.3099877,1.509685,0.0473726,0.6651009,0.2701836,0.781914,2.1347002,3.7091982,2.5864141,11.4327091),(7926,'ulna-cleaned.tif',183,4,1450,1.7302107,5.4007864,10.8704095,1.8,5.308162,10.8458063,0.4177577,1.1523715,2.4105775,0.3109553,1.5104725,0.0474661,0.6266019,0.2698394,0.7494802,2.1125304,3.7365664,2.6158241,11.5495735),(7927,'ulna-cleaned.tif',183,4,1451,1.7227922,5.4082989,10.8829157,1.8,5.318346,10.8579061,0.420908,1.163176,2.4579774,0.3146551,1.4982761,0.0479353,0.6095565,0.2705138,0.7312378,2.1489614,3.7167017,2.6251096,11.5535836),(7928,'ulna-cleaned.tif',183,4,1452,1.7091067,5.4135707,10.8936461,1.8,5.3215177,10.8676758,0.4222684,1.1881977,2.3158796,0.3149092,1.4742806,0.0478439,0.6365964,0.265031,0.7510572,2.1473084,3.7167017,2.6251096,11.6584176),(7929,'ulna-cleaned.tif',183,4,1453,1.6966904,5.4246777,10.9086554,1.8,5.3335052,10.8839117,0.4277821,1.1652935,2.5437268,0.313526,1.4591372,0.0486678,0.5736218,0.2690532,0.6798885,2.1128786,3.7303834,2.5773245,11.3375565),(7930,'ulna-cleaned.tif',183,4,1454,1.6848841,5.4375662,10.9222178,1.8,5.3469551,10.8972552,0.4315276,1.1918468,2.2885609,0.3113011,1.4086367,0.0491257,0.615512,0.2611922,0.7346043,2.1121822,3.6883229,2.5956073,11.4367192),(7931,'ulna-cleaned.tif',183,4,1455,1.6723962,5.4607756,10.9379668,1.8,5.3814563,10.9164481,0.4377999,1.2543215,2.3131134,0.314501,1.3621394,0.0500971,0.5888771,0.250734,0.7082173,2.1108962,3.7091982,2.5864141,11.5786176),(7932,'ulna-cleaned.tif',183,4,1456,1.6686802,5.4584584,10.947912,1.8,5.3670926,10.9232883,0.4343429,1.1918222,2.3725251,0.3117739,1.3760465,0.0492496,0.5799924,0.2615943,0.6926437,2.1493974,3.7224798,2.6011732,11.483465),(7933,'ulna-cleaned.tif',183,4,1457,1.68094,5.4657937,10.9595633,1.8,5.3717751,10.9347378,0.4330306,1.1816163,2.4155548,0.315799,1.3837879,0.0493311,0.5728655,0.2672602,0.6947451,2.1487011,3.7772469,2.59755,11.6584176),(7934,'ulna-cleaned.tif',183,4,1458,1.6785033,5.4800754,10.9714932,1.8,5.3895487,10.9470659,0.4422388,1.1564834,2.5760885,0.3186418,1.3509681,0.0512372,0.5244261,0.2755265,0.6333914,2.1115926,3.7980526,2.5885612,11.775282),(7935,'ulna-cleaned.tif',183,4,1459,1.6770886,5.4774263,10.9777655,1.8,5.3781988,10.9480723,0.4308819,1.1555684,2.4178803,0.315596,1.3611933,0.0487614,0.5629697,0.2731089,0.6811957,2.1101999,3.7772469,2.59755,11.3375565),(7936,'ulna-cleaned.tif',183,4,1460,1.6646465,5.4943001,10.9935896,1.8,5.402262,10.9656852,0.4410841,1.1525799,2.4356569,0.3180884,1.3178019,0.0505666,0.5410458,0.2759795,0.6592551,2.1095035,3.7567498,2.6066376,12.1856244),(7937,'ulna-cleaned.tif',183,4,1461,1.6559447,5.4954126,11.0088911,1.8,5.4014135,10.9849029,0.4493678,1.1709439,2.4236799,0.3097048,1.2967591,0.0520795,0.5350373,0.2644915,0.6462355,1.9950001,3.7514489,2.6303619,11.456082),(7938,'ulna-cleaned.tif',183,4,1462,1.649152,5.5042883,11.0204677,1.8,5.4146184,10.995669,0.4569456,1.1995265,2.5757213,0.3057983,1.2779832,0.0535055,0.4961652,0.2549325,0.5970186,1.9889389,3.7514489,2.6303619,11.3101735),(7939,'ulna-cleaned.tif',183,4,1463,1.6274541,5.522423,11.032855,1.8,5.4410053,11.0091064,0.4703886,1.2104791,2.3934179,0.3004766,1.217209,0.0557186,0.5085652,0.2482295,0.6195133,2.0042318,3.5965375,2.5535901,10.8587565),(7940,'ulna-cleaned.tif',183,4,1464,1.6259842,5.5298254,11.0488885,1.8,5.4436767,11.0244846,0.4735069,1.1512601,2.4585013,0.3035912,1.2087098,0.0563526,0.491645,0.2637034,0.5980904,1.9901633,3.6080281,2.5689263,10.792648),(7941,'ulna-cleaned.tif',183,4,1465,1.6129695,5.5346062,11.060712,1.8,5.4471282,11.0350891,0.4773918,1.1615159,2.4658653,0.303025,1.2024342,0.0567516,0.4876317,0.2608875,0.5936355,1.9950001,3.6080281,2.5689263,10.6564209),(7942,'ulna-cleaned.tif',183,4,1466,1.5862337,5.5500968,11.0779507,1.8,5.4639475,11.053413,0.4885254,1.052649,2.4643809,0.2982738,1.1576498,0.058232,0.4697528,0.2833555,0.5762114,1.9929821,3.6203617,2.5841616,10.7555836),(7943,'ulna-cleaned.tif',183,4,1467,1.5836511,5.5590913,11.0894779,1.8,5.4725751,11.0643749,0.4902439,1.059554,2.2843649,0.2971504,1.1422806,0.0585136,0.500043,0.2804486,0.6163102,1.9929821,3.6080281,2.5689263,10.9966447),(7944,'ulna-cleaned.tif',183,4,1468,1.5799892,5.568249,11.1027567,1.8,5.480491,11.0766094,0.4906841,1.0671929,2.5236512,0.3009182,1.1350805,0.0584747,0.4497771,0.2819717,0.5506205,1.9950001,3.5745591,2.5628777,10.8878006),(7945,'ulna-cleaned.tif',183,4,1469,1.5837495,5.5757598,11.1174916,1.8,5.4862501,11.0900153,0.4992932,1.2403253,2.5315439,0.2997908,1.1169515,0.0605136,0.4412136,0.2417034,0.5410017,1.9950001,3.5994136,2.5935687,10.9111735),(7946,'ulna-cleaned.tif',183,4,1470,1.5894317,5.5793539,11.1306163,1.8,5.4903348,11.1024828,0.4964385,1.0704606,2.3352824,0.2988894,1.1184787,0.0600961,0.4789479,0.2792157,0.5946499,1.9950001,3.6203617,2.5841616,10.7983192),(7947,'ulna-cleaned.tif',183,4,1471,1.5842721,5.5958675,11.1459101,1.8,5.512739,11.1192447,0.5040114,1.0794167,2.3343854,0.3007918,1.0771874,0.0615841,0.4614437,0.2786614,0.5757122,2.0154816,3.5994136,2.5935687,10.765265),(7948,'ulna-cleaned.tif',183,4,1472,1.589384,5.5981181,11.1525918,1.8,5.5137249,11.1237852,0.504753,1.0845038,2.3392173,0.3001002,1.0664162,0.061949,0.4558859,0.2767166,0.5700204,2.0262541,3.586564,2.5782764,10.7225294),(7949,'ulna-cleaned.tif',183,4,1473,1.5957652,5.6044945,11.1635575,1.8,5.521764,11.1377284,0.5051055,1.0911681,2.3499295,0.3004008,1.0597765,0.0622771,0.4509823,0.2753021,0.566708,2.0262541,3.5994136,2.5935687,10.845065),(7950,'ulna-cleaned.tif',183,4,1474,1.5973742,5.6080478,11.1725954,1.8,5.5266229,11.1497811,0.509537,1.0643621,2.347067,0.3020894,1.0466738,0.0633419,0.4459497,0.283822,0.5525316,1.9938795,3.5929945,2.6183143,10.845065),(7951,'ulna-cleaned.tif',183,4,1475,1.5908861,5.6144523,11.1777984,1.8,5.5332445,11.1553674,0.5124429,1.0670053,2.3575923,0.3004475,1.0232225,0.063742,0.4340116,0.2815802,0.5448073,2.0009301,3.6203617,2.5841616,10.6661022),(7952,'ulna-cleaned.tif',183,4,1476,1.6017281,5.6131894,11.187874,1.8,5.5279666,11.1678349,0.5075811,1.0588941,2.6780386,0.303973,1.0504573,0.0630704,0.3922487,0.2870664,0.4874475,1.9950001,3.6276101,2.6238108,10.8023294),(7953,'ulna-cleaned.tif',183,4,1477,1.5795905,5.6290324,11.1991816,1.8,5.5491842,11.1810597,0.5228076,1.0679007,2.3746895,0.3019605,1.001711,0.065636,0.4218282,0.2827608,0.5283011,1.9935313,3.6335299,2.5992899,10.7829666),(7954,'ulna-cleaned.tif',183,4,1478,1.5857928,5.6306049,11.2058213,1.8,5.5481463,11.1873145,0.5172374,1.070426,2.3975974,0.306428,1.0099013,0.064624,0.4212139,0.2862673,0.5306393,2.0323852,3.6335299,2.5992899,11.1272006),(7955,'ulna-cleaned.tif',183,4,1479,1.5655578,5.6398212,11.2170117,1.8,5.5580539,11.2024546,0.5198727,1.0767192,2.3946619,0.3020398,0.9794366,0.0643914,0.4090083,0.2805186,0.5162197,1.9931831,3.6203617,2.5841616,11.1272006),(7956,'ulna-cleaned.tif',183,4,1480,1.5547585,5.650704,11.2262237,1.8,5.5694459,11.2129778,0.5238068,1.0809166,2.4063802,0.3014685,0.9516525,0.0648283,0.3954705,0.2789008,0.5057633,2.0323852,3.6203617,2.5841616,10.9151836),(7957,'ulna-cleaned.tif',183,4,1481,1.5395897,5.6584429,11.2337917,1.8,5.5754967,11.2177135,0.52403,1.0836875,2.3967708,0.2986996,0.9267332,0.0642454,0.3866591,0.2756326,0.4911532,2.0316028,3.5787877,2.6030852,10.8160209),(7958,'ulna-cleaned.tif',183,4,1482,1.5413187,5.6615119,11.2461949,1.8,5.5735992,11.2319654,0.5238653,1.0928269,2.4057352,0.2990556,0.9290474,0.0642809,0.3861803,0.2736532,0.491063,2.028323,3.5787877,2.6030852,10.8120107),(7959,'ulna-cleaned.tif',183,4,1483,1.5426531,5.6679242,11.2563225,1.8,5.5798567,11.2385003,0.5250568,1.0843118,2.4301532,0.2988205,0.9188285,0.0646021,0.3780949,0.2755854,0.483302,1.9924868,3.5929945,2.6183143,11.0474006),(7960,'ulna-cleaned.tif',183,4,1484,1.5526066,5.6717876,11.2651506,1.8,5.5849994,11.2449243,0.5240017,1.0696042,2.4332339,0.2990191,0.9162368,0.0647823,0.3765511,0.2795605,0.4775276,1.9924052,3.2439462,2.5842971,9.9712751),(7961,'ulna-cleaned.tif',183,4,1485,1.5422074,5.6804707,11.279947,1.8,5.5948596,11.2635586,0.5326013,1.0468726,2.4417263,0.2998749,0.9111941,0.0662729,0.3731762,0.2864483,0.4736829,1.966202,3.2571698,2.6011732,10.0841293),(7962,'ulna-cleaned.tif',183,4,1486,1.5270046,5.6905214,11.2877979,1.8,5.6041932,11.2679245,0.5306187,1.0335712,2.4902797,0.297907,0.8860111,0.0651786,0.3557878,0.2882307,0.4541077,1.9757611,3.3059264,2.6239435,10.3098378),(7963,'ulna-cleaned.tif',183,4,1487,1.5092415,5.7012039,11.3016536,1.8,5.6173216,11.2851168,0.5373323,1.0567171,2.4874569,0.2972344,0.8702372,0.0659001,0.3498502,0.2812809,0.4504804,1.9758564,3.2004676,2.5155461,9.8293768),(7964,'ulna-cleaned.tif',183,4,1488,1.4894327,5.7117769,11.3112752,1.8,5.6300895,11.2964977,0.539409,1.0465276,2.4999547,0.2967139,0.8566996,0.0654891,0.3426861,0.2835223,0.4428938,1.9704481,3.224009,2.5055172,9.8858039),(7965,'ulna-cleaned.tif',183,4,1489,1.470922,5.7405028,11.327841,1.8,5.6696182,11.3173945,0.5697141,1.056304,2.5218978,0.2945269,0.7759044,0.0713257,0.3076669,0.2788278,0.4016522,1.970237,3.1447681,2.5183933,10.0978209),(7966,'ulna-cleaned.tif',183,4,1490,1.4575221,5.7613863,11.3411203,1.8,5.6999652,11.3346776,0.6063819,1.0664999,2.4578136,0.2927451,0.7213693,0.0788966,0.2935004,0.2744915,0.3840837,1.9898217,3.0725592,2.4851053,9.6794581),(7967,'ulna-cleaned.tif',183,4,1491,1.4572804,5.7622563,11.3509865,1.8,5.6925971,11.3435216,0.610329,1.0751074,2.515919,0.294691,0.7250697,0.0797827,0.2881928,0.2741038,0.3788446,1.9861646,3.0245148,2.5060069,9.4964852),(7968,'ulna-cleaned.tif',183,4,1492,1.456929,5.7682275,11.3615934,1.8,5.6969416,11.3537052,0.6025256,1.078477,2.5342407,0.2956204,0.7208145,0.0779888,0.2844302,0.2741092,0.3764349,1.9960749,3.0890951,2.5213432,9.6988208),(7969,'ulna-cleaned.tif',183,4,1493,1.4476922,5.7874197,11.3829444,1.8,5.7201774,11.3799279,0.6588009,1.1309621,2.4816325,0.2913091,0.6727292,0.0904207,0.2710833,0.2575763,0.3551754,1.9905181,3.0660756,2.5319328,9.4868039),(7970,'ulna-cleaned.tif',183,4,1494,1.4414827,5.7985058,11.3905526,1.8,5.7339084,11.3863968,0.6560399,1.124907,2.4980842,0.2912758,0.6537769,0.0893912,0.2617113,0.2589332,0.3465732,1.9800982,2.9850428,2.4793772,9.2707767),(7971,'ulna-cleaned.tif',183,4,1495,1.4513875,5.8025807,11.4025083,1.8,5.7372571,11.400509,0.6729701,1.1846859,2.4961866,0.2917699,0.645619,0.0939815,0.2586421,0.2462846,0.3392591,1.9597261,3.001,2.5167064,9.675448),(7972,'ulna-cleaned.tif',183,4,1496,1.4524898,5.8107736,11.4102336,1.8,5.7499325,11.4094787,0.6939295,1.210523,2.4513762,0.2919258,0.6323636,0.0990212,0.2579627,0.2411568,0.3380755,1.9721351,2.9550254,2.5386099,9.5666039),(7973,'ulna-cleaned.tif',183,4,1497,1.4570484,5.814066,11.4162915,1.8,5.7521116,11.4144482,0.6902276,1.198865,2.4622366,0.2942881,0.6361566,0.0984487,0.2583653,0.2454723,0.3397529,2.0183431,2.9778341,2.5275736,9.9285395),(7974,'ulna-cleaned.tif',183,4,1498,1.4514652,5.8168479,11.4201238,1.8,5.7523835,11.4152616,0.6895824,1.1047541,1.8627244,0.2925835,0.6291197,0.0979182,0.3377417,0.2648404,0.4545927,2.0172996,3.016609,2.4875099,9.9342107),(7975,'ulna-cleaned.tif',183,4,1499,1.4421923,5.8354282,11.4323717,1.8,5.7794675,11.4303801,0.7276762,1.1323974,1.8231042,0.2907335,0.5957558,0.1063391,0.326781,0.2567416,0.4409136,2.0459313,2.9925001,2.4980915,10.2397192),(7976,'ulna-cleaned.tif',183,4,1500,1.4574332,5.8368549,11.4479098,1.8,5.7797504,11.4479898,0.7036531,1.7451976,2.72436,0.3041982,0.6167387,0.1016848,0.2263793,0.1743059,0.284862,2.0364716,2.9925001,2.4980915,10.3622548),(7977,'ulna-cleaned.tif',183,4,1501,1.4714722,5.8454983,11.4598986,1.8,5.7912887,11.4575024,0.7274395,1.8049564,2.666818,0.3069767,0.6129278,0.1084404,0.2298349,0.1700743,0.2871465,2.0304971,2.978636,2.4605756,10.074448),(7978,'ulna-cleaned.tif',183,4,1502,1.4705756,5.8638285,11.4832174,1.8,5.8181425,11.4891365,0.8144676,1.1510394,1.7428259,0.2949254,0.5862655,0.1296688,0.3363879,0.2562253,0.4399872,2.0170191,2.8915804,2.4539214,9.702831),(7979,'ulna-cleaned.tif',183,4,1503,1.4793262,5.870448,11.4961443,1.8,5.8232462,11.5010471,0.8308556,1.1269084,1.7404319,0.2962527,0.5888624,0.1344695,0.3383427,0.2628898,0.4397152,2.0364716,3.0245148,2.5060069,9.7592581),(7980,'ulna-cleaned.tif',183,4,1504,1.4804547,5.8891107,11.5178938,1.8,5.8494504,11.5288262,0.8804397,1.0966808,1.6914128,0.2934993,0.5748177,0.146681,0.3398447,0.2676251,0.4342949,1.9993468,3.0097404,2.4689221,9.9205192),(7981,'ulna-cleaned.tif',183,4,1505,1.4788444,5.8972472,11.5269612,1.8,5.8566534,11.5351979,0.9028859,1.0931168,1.5984667,0.2902907,0.563077,0.151929,0.3522607,0.2655624,0.4440754,1.9800122,2.9129733,2.5117893,9.6246921),(7982,'ulna-cleaned.tif',183,4,1506,1.4827436,5.9071781,11.5403062,1.8,5.8650927,11.5501513,0.932114,1.1358547,1.5594611,0.2901813,0.555062,0.1593009,0.3559319,0.255474,0.4454678,1.9885604,2.8730771,2.4842035,9.7746107),(7983,'ulna-cleaned.tif',183,4,1507,1.4897292,5.9117337,11.5512428,1.8,5.8660206,11.561497,0.9409835,1.1564043,1.6083362,0.2935288,0.557919,0.1621537,0.346892,0.2538289,0.429826,2.0636167,2.9536783,2.4710711,9.595648),(7984,'ulna-cleaned.tif',183,4,1508,1.4806849,5.9232865,11.5608081,1.8,5.8791197,11.5704115,0.9716644,1.1659439,1.5190175,0.2916334,0.5484018,0.1683015,0.361024,0.2501264,0.4405885,2.0557908,2.8915804,2.4539214,9.5215192),(7985,'ulna-cleaned.tif',183,4,1509,1.4840197,5.9304593,11.5700565,1.8,5.8885607,11.5779334,0.9865833,2.3546322,2.4167671,0.2905759,0.5424569,0.1720969,0.2244556,0.1234061,0.2468849,1.9959466,2.8608607,2.4450687,9.0410581),(7986,'ulna-cleaned.tif',183,4,1510,1.4867891,5.9395564,11.5838084,1.8,5.8994952,11.5926791,1.0272486,1.284132,1.4901984,0.2869635,0.5369011,0.1815194,0.3602883,0.2234689,0.4188109,2.0234205,2.886621,2.4344656,9.3893022),(7987,'ulna-cleaned.tif',183,4,1511,1.4965966,5.9444003,11.5980434,1.8,5.9031199,11.6100477,1.0600853,1.2600146,1.4230163,0.2870869,0.538572,0.1898375,0.3784722,0.2278441,0.4344002,1.9042477,2.3418955,2.3441469,8.2430581),(7988,'ulna-cleaned.tif',183,4,1512,1.4957009,5.9499175,11.604481,1.8,5.9101408,11.6157728,1.0678994,1.2413679,1.4021963,0.2879869,0.5432278,0.1913772,0.3874121,0.2319916,0.4444002,2.0416193,2.886621,2.4344656,9.4691022),(7989,'ulna-cleaned.tif',183,4,1513,1.4685396,5.9567666,11.614307,1.8,5.9195277,11.6318487,1.0805264,1.3460765,1.4007228,0.2798092,0.5359366,0.1904909,0.3826143,0.2078702,0.4199107,1.8974316,2.3432547,2.3923233,8.027031),(7990,'ulna-cleaned.tif',183,4,1514,1.4625141,5.9683738,11.6194989,1.8,5.936817,11.6366309,1.1210253,1.3739489,1.3374494,0.2780167,0.5295111,0.1976793,0.3959111,0.2023486,0.4211529,1.8963031,2.3142001,2.3805799,8.4220208),(7991,'ulna-cleaned.tif',183,4,1515,1.4618715,5.9708321,11.6330698,1.8,5.9392585,11.65165,1.1252132,1.3399031,1.3277929,0.2700993,0.5271216,0.1983888,0.3969908,0.2015812,0.4226227,1.9068471,2.313512,2.3561945,8.4921395),(7992,'ulna-cleaned.tif',183,4,1516,1.4784992,5.9697331,11.646844,1.8,5.9356134,11.6680647,1.1335538,1.3971445,1.3116888,0.2729517,0.5375742,0.2022331,0.4098336,0.195364,0.4233007,1.8701279,2.3996459,2.320915,8.3228581),(7993,'ulna-cleaned.tif',183,4,1517,1.5020488,5.9799989,11.6683493,1.8,5.9520007,11.6939456,1.1833484,1.4250206,1.2582521,0.2684855,0.5447612,0.2146045,0.4329507,0.1884081,0.4294903,1.8950749,2.3996459,2.320915,8.3091666),(7994,'ulna-cleaned.tif',183,4,1518,1.5094179,5.9851254,11.6844126,1.8,5.9597858,11.7114851,1.1978077,1.4418207,1.2594405,0.2662551,0.5497564,0.2181644,0.4365085,0.1846659,0.4286591,1.8765565,2.3432547,2.3200656,8.106831),(7995,'ulna-cleaned.tif',183,4,1519,1.5200165,5.9928782,11.6967114,1.8,5.968919,11.7254194,1.2175648,1.4316784,1.2862235,0.2608242,0.5554866,0.2230197,0.431874,0.1821807,0.434779,1.9358932,2.4322643,2.2865399,8.4978107),(7996,'ulna-cleaned.tif',183,4,1520,1.5169579,5.9997469,11.7077966,1.8,5.9768649,11.7352249,1.2358489,1.3942405,1.3143454,0.2589405,0.5539415,0.2255068,0.4214581,0.1857215,0.4518168,1.8873956,2.3265499,1.1839206,8.3559123),(7997,'ulna-cleaned.tif',183,4,1521,1.5226836,6.0057007,11.7247994,1.8,5.9818608,11.7483561,1.2620177,1.4240215,1.3126535,0.2532902,0.5512057,0.2303434,0.4199172,0.1778696,0.444324,1.8511979,2.3265499,2.1112158,8.2196852),(7998,'ulna-cleaned.tif',183,4,1522,1.5312569,6.0086181,11.7400528,1.8,5.9800966,11.7618351,1.280457,1.4810564,1.2989234,0.2568286,0.5605479,0.2342939,0.4315481,0.1734091,0.4403838,1.8733071,2.319697,2.2831539,8.1769496),(7999,'ulna-cleaned.tif',183,4,1523,1.5394959,6.0205406,11.7633828,1.8,5.9951675,11.7895975,1.3073777,1.4494098,1.2927109,0.2486373,0.5749482,0.2391865,0.4447616,0.1715438,0.4572513,1.9291557,2.4479228,1.2387369,9.2547361),(8000,'ulna-cleaned.tif',183,4,1524,1.5339776,6.0312439,11.7713731,1.8,6.0073347,11.7871253,1.3060765,1.5333093,1.292458,0.2487024,0.5821272,0.2381616,0.4504032,0.1621998,0.4432674,1.8941632,2.3578166,1.152572,8.4357123),(8001,'ulna-cleaned.tif',183,4,1525,1.5156519,6.0398058,11.7883737,1.8,6.01751,11.8105359,1.3089613,1.5788223,1.3126694,0.2393874,0.5846664,0.2356826,0.4454027,0.151624,0.4279276,1.8993241,2.3241537,1.3633001,8.4687666),(8002,'ulna-cleaned.tif',183,4,1526,1.4939471,6.0461386,11.7905334,1.8,6.0240432,11.8052585,1.3099203,1.4697905,1.3090632,0.2352031,0.5811024,0.2324267,0.4439071,0.1600249,0.4484468,1.8800198,2.3162629,2.3074526,8.3188479),(8003,'ulna-cleaned.tif',183,4,1527,1.4827108,6.0528883,11.7948538,1.8,6.0292648,11.8065856,1.31385,1.6053393,1.313785,0.235889,0.5836164,0.2311593,0.4442252,0.1469403,0.4252909,1.9293471,2.3706108,2.3799995,8.7178479),(8004,'ulna-cleaned.tif',183,4,1528,1.4797836,6.0628257,11.8058463,1.8,6.039025,11.818992,1.3324211,1.6319153,1.3209581,0.2298962,0.5877213,0.2328798,0.4449204,0.1408751,0.4214741,1.9152,2.3473276,2.1257921,8.9532378),(8005,'ulna-cleaned.tif',183,4,1529,1.4770988,6.0709172,11.8179027,1.8,6.0457593,11.8297499,1.3327746,1.5209815,1.3272901,0.2304541,0.5994483,0.2324972,0.4516332,0.1515167,0.4512843,1.8753,2.3327003,1.3465616,8.9298649),(8006,'ulna-cleaned.tif',183,4,1530,1.451472,6.083568,11.8283979,1.8,6.0579341,11.8382497,1.3391048,1.5465591,1.3238248,0.2205024,0.600434,0.2291566,0.45356,0.1425761,0.4459735,1.8268613,2.3241537,1.3633001,7.9238581),(8007,'ulna-cleaned.tif',183,4,1531,1.4198226,6.0954369,11.8358281,1.8,6.0690893,11.8379374,1.3389738,1.5174399,1.3343591,0.2138858,0.5991815,0.224146,0.4490406,0.1409517,0.4474966,1.8220235,2.3241537,1.3633001,8.2470682),(8008,'ulna-cleaned.tif',183,4,1532,1.4039905,6.1041138,11.8534126,1.8,6.0795766,11.8581423,1.3603175,1.5822523,1.3180656,0.2081958,0.5960364,0.2237842,0.4522054,0.1315819,0.4303963,1.8354,2.3806629,1.3339476,8.7315395),(8009,'ulna-cleaned.tif',183,4,1533,1.4038592,6.1086526,11.8608521,1.8,6.0814342,11.8622957,1.368861,1.5234655,1.3108252,0.2050678,0.5908062,0.2245644,0.4507132,0.1346062,0.4419677,1.8467341,2.3517319,1.3134726,8.585631),(8010,'ulna-cleaned.tif',183,4,1534,1.4046824,6.1179625,11.8726048,1.8,6.093878,11.8762444,1.3735113,1.6911202,1.3214327,0.2061504,0.5938807,0.2251193,0.4494218,0.1219017,0.4102481,1.8119941,2.3622014,1.297137,8.3325394),(8011,'ulna-cleaned.tif',183,4,1535,1.3912894,6.1269201,11.8729352,1.8,6.1075555,11.8771104,1.3810496,1.6287594,1.34346,0.1990793,0.5876547,0.2236327,0.4374188,0.1222275,0.4177638,1.6758,2.3632121,1.3667783,8.1028208),(8012,'ulna-cleaned.tif',183,4,1536,1.3966894,6.1349103,11.878391,1.8,6.1194643,11.8861771,1.3916881,1.6134606,1.3445247,0.2006827,0.5909463,0.2253935,0.4395206,0.1243803,0.4298012,1.6758,2.4194671,1.3378171,8.3849564),(8013,'ulna-cleaned.tif',183,4,1537,1.4016236,6.1368248,11.8811402,1.8,6.1189921,11.8864528,1.3894778,1.6913723,1.3414039,0.2036666,0.5893073,0.2260077,0.4393213,0.120415,0.4129372,1.6758,2.4194671,1.3378171,7.9141767),(8014,'ulna-cleaned.tif',183,4,1538,1.3969969,6.1478549,11.8883719,1.8,6.1314479,11.8948922,1.405795,1.6369607,1.3263006,0.199824,0.5827875,0.2265512,0.4394083,0.1220701,0.4213691,1.6359,2.4289894,1.3218336,8.5679293),(8015,'ulna-cleaned.tif',183,4,1539,1.3891078,6.1545382,11.8962097,1.8,6.135957,11.9060709,1.4026933,1.6068473,1.3439584,0.2038963,0.5870945,0.225037,0.4368398,0.1268922,0.4356499,1.6359,2.4289894,1.3218336,8.0076682),(8016,'ulna-cleaned.tif',183,4,1540,1.3869417,6.1620242,11.8999551,1.8,6.1430027,11.9067696,1.4120193,1.6214609,1.3192938,0.2022829,0.592358,0.2253783,0.4489963,0.1247535,0.4356734,1.6610329,2.4289894,1.3218336,8.027031),(8017,'ulna-cleaned.tif',183,4,1541,1.381872,6.1740848,11.901933,1.8,6.1590147,11.9083299,1.4295738,1.6136477,1.3383705,0.1975174,0.5988513,0.2257492,0.447448,0.1224043,0.445926,1.6758,2.4194671,1.3378171,8.4687666),(8018,'ulna-cleaned.tif',183,4,1542,1.3596128,6.1784687,11.905681,1.8,6.1608262,11.9117083,1.4334928,1.6204636,1.3007211,0.195239,0.5898396,0.222357,0.4534712,0.1204834,0.4383031,1.6519993,2.4498731,1.2902595,7.9278682),(8019,'ulna-cleaned.tif',183,4,1543,1.3570813,6.1821354,11.9107993,1.8,6.1641702,11.9183963,1.4362469,0.9298545,1.332875,0.1928931,0.5899504,0.2221102,0.442615,0.2074444,0.5817971,1.6758,2.4882378,1.2946993,8.106831),(8020,'ulna-cleaned.tif',183,4,1544,1.3805949,6.180594,11.9138918,1.8,6.1605232,11.9215292,1.4424176,1.6333749,1.3339507,0.2023108,0.5981422,0.2263276,0.448399,0.1238606,0.4486788,1.6827592,2.4479228,1.2387369,7.8520784),(8021,'ulna-cleaned.tif',183,4,1545,1.3799467,6.1819332,11.9257257,1.8,6.1615252,11.9423116,1.4483529,1.3158051,1.3206291,0.2020232,0.5973951,0.2265602,0.4523564,0.1535358,0.5275758,1.6854478,2.4612189,1.2746812,8.0447326),(8022,'ulna-cleaned.tif',183,4,1546,1.3965992,6.1846548,11.9246009,1.8,6.1641141,11.9400208,1.4577922,1.3650224,1.3587416,0.212754,0.6022356,0.2298067,0.4432305,0.1558612,0.5294363,1.7091881,2.4498731,1.2902595,8.3849564),(8023,'ulna-cleaned.tif',183,4,1547,1.3944202,6.1870471,11.9284218,1.8,6.1633981,11.9466674,1.4630087,1.6172785,1.5987909,0.2219009,0.6091534,0.2297137,0.3810088,0.1372064,0.4590489,1.7488316,2.4612189,1.2746812,8.2994852),(8024,'ulna-cleaned.tif',183,4,1548,1.4092448,6.1914194,11.9400225,1.8,6.1655926,11.9651476,1.4793645,1.6310681,1.719199,0.2340704,0.6284455,0.2329161,0.3655455,0.1435074,0.450979,1.7884751,2.4062711,2.274027,8.4123395),(8025,'ulna-cleaned.tif',183,4,1549,1.4141011,6.1971614,11.9489221,1.8,6.170263,11.9768485,1.4734181,1.3066349,1.7960219,0.2344779,0.6381931,0.2334557,0.3553371,0.1794517,0.4422328,1.8525149,2.4022982,2.2974387,8.6614208),(8026,'ulna-cleaned.tif',183,4,1550,1.4350167,6.197012,11.953754,1.8,6.1669667,11.981113,1.4640714,1.2199529,1.7717743,0.2446582,0.6467562,0.2364556,0.3650331,0.2005472,0.4527649,1.819607,2.4260382,2.2044293,8.6614208),(8027,'ulna-cleaned.tif',183,4,1551,1.4391397,6.2036098,11.9660335,1.8,6.1768985,11.9966598,1.4682608,1.2720238,1.7664902,0.2424708,0.6503576,0.2373437,0.3681637,0.1906181,0.4538707,1.7886676,2.4230834,1.2698761,8.585631),(8028,'ulna-cleaned.tif',183,4,1552,1.4501794,6.2063949,11.9690917,1.8,6.1810893,11.9915314,1.4578328,1.1041178,1.7546717,0.2465015,0.6573924,0.2386254,0.3746527,0.2232566,0.4599328,1.8100514,2.4260382,2.2044293,8.3559123),(8029,'ulna-cleaned.tif',183,4,1553,1.4657864,6.2102683,11.9856189,1.8,6.1865427,12.0109568,1.4479746,1.0987199,1.4210932,0.2507467,0.6712329,0.240631,0.4723356,0.2282171,0.6396606,1.8241238,2.4368417,2.2634382,8.3188479),(8030,'ulna-cleaned.tif',183,4,1554,1.4722667,6.2159682,11.9969751,1.8,6.1934873,12.0241328,1.4481143,1.0911745,1.4188567,0.2542183,0.6831643,0.2417031,0.4814893,0.2329768,0.6448634,1.8211748,2.4680013,2.172251,8.5348751),(8031,'ulna-cleaned.tif',183,4,1555,1.4814521,6.2183812,12.006668,1.8,6.1923142,12.0331004,1.4654059,1.1244394,1.4345722,0.2641038,0.6933562,0.2441764,0.4833192,0.234876,0.6570764,1.8284158,2.454742,1.440393,8.5018208),(8032,'ulna-cleaned.tif',183,4,1556,1.4770696,6.2220258,12.020821,1.8,6.1931263,12.0514499,1.457727,1.1298556,1.42652,0.2733466,0.7077691,0.2430444,0.4961508,0.2419305,0.6747003,1.85013,2.4676788,2.2531129,8.7138378),(8033,'ulna-cleaned.tif',183,4,1557,1.4620619,6.2298156,12.0309464,1.8,6.2008685,12.0548873,1.4743738,1.1729942,1.4107978,0.2774827,0.7092306,0.2414185,0.502716,0.2365593,0.6841983,1.8608563,2.4997279,1.4266419,8.5719395),(8034,'ulna-cleaned.tif',183,4,1558,1.4397486,6.2375374,12.0447146,1.8,6.2100825,12.0705399,1.490833,1.2115241,1.4311163,0.2832644,0.7009975,0.238427,0.4898257,0.2338083,0.6719307,1.85013,2.5291691,1.4601391,8.426031),(8035,'ulna-cleaned.tif',183,4,1559,1.4349064,6.2362288,12.0511407,1.8,6.2025161,12.07496,1.4970856,1.2067934,1.4257608,0.296155,0.6949583,0.237854,0.4874298,0.2454066,0.6736607,1.8973643,2.4997279,1.4266419,8.8403836),(8036,'ulna-cleaned.tif',183,4,1560,1.4241456,6.2413111,12.064507,1.8,6.2082853,12.0970188,1.5128303,1.2433818,1.4414413,0.301955,0.6997829,0.236561,0.4854744,0.2428498,0.6804625,1.9063979,2.5392205,1.4288993,8.6380479),(8037,'ulna-cleaned.tif',183,4,1561,1.4180707,6.2407213,12.0816751,1.8,6.2044678,12.1199169,1.5206829,1.238183,1.4259287,0.3084466,0.7059456,0.2357521,0.4950778,0.2491123,0.6859989,1.9548764,2.5451697,1.4133795,9.0290276),(8038,'ulna-cleaned.tif',183,4,1562,1.4199398,6.2494747,12.0926395,1.8,6.2164905,12.1314283,1.5147091,1.2911393,1.4566416,0.3169137,0.7146565,0.2359129,0.4906193,0.2454528,0.6860876,1.9717576,2.5451697,1.4133795,8.906492),(8039,'ulna-cleaned.tif',183,4,1563,1.4335016,6.249326,12.1162572,1.8,6.2115528,12.1603087,1.5158611,1.3289754,1.4680956,0.3304496,0.7408829,0.2381966,0.5046557,0.2486499,0.7155448,2.0097691,2.584584,1.4157996,9.1829564),(8040,'ulna-cleaned.tif',183,4,1564,1.4807262,6.2510656,12.1488632,1.8,6.2127474,12.1974136,1.5294157,1.3628766,1.4329776,0.3478114,0.7859275,0.2463653,0.5484577,0.2552039,0.7681795,2.0342393,2.5910435,1.4005844,9.1031564),(8041,'ulna-cleaned.tif',183,4,1565,1.5309457,6.2491221,12.1770427,1.8,6.2067991,12.2245237,1.5305521,1.3991638,1.4044968,0.3681201,0.8178501,0.2547446,0.5823083,0.2631001,0.8125878,2.0348841,2.5291691,1.6814535,9.1362107),(8042,'ulna-cleaned.tif',183,4,1566,1.5547387,6.2548321,12.203477,1.8,6.2176114,12.2494604,1.529407,1.4457666,1.4181236,0.3756796,0.8496923,0.2586795,0.5991666,0.259848,0.8131124,1.9632178,2.6142875,1.2924967,9.198309),(8043,'ulna-cleaned.tif',183,4,1567,1.6125266,6.2530476,12.2347509,1.8,6.2141084,12.2766524,1.5221564,1.445509,1.4254474,0.4014656,0.8966664,0.2681191,0.6290421,0.277733,0.867998,1.9295039,2.6697245,1.4056476,9.5312005),(8044,'ulna-cleaned.tif',183,4,1568,1.6792156,6.2485921,12.2670677,1.8,6.2067162,12.3063807,1.5329814,1.4754692,1.3949338,0.4263133,0.9458602,0.2794692,0.6780682,0.2889341,0.9026907,2.0835612,2.6813276,0.9332475,10.7201803),(8045,'ulna-cleaned.tif',183,4,1569,1.7563359,6.236709,12.3039628,1.8,6.1871526,12.347978,1.5503597,1.5352263,1.6099478,0.4640257,0.9803776,0.2926004,0.6089499,0.3022523,0.8337634,2.1141711,2.7052671,0.9213956,10.367926),(8046,'ulna-cleaned.tif',183,4,1570,1.827465,6.2391962,12.3186647,1.8,6.1930326,12.3563931,1.5460461,1.5396723,1.6735038,0.4826423,1.016533,0.304391,0.607428,0.3134708,0.8532615,2.1045019,2.7310378,1.1332866,10.4437159),(8047,'ulna-cleaned.tif',183,4,1571,1.8938657,6.2373787,12.3344249,1.8,6.1905408,12.3718087,1.5529458,1.6143248,1.3971319,0.5199278,1.0410411,0.3155437,0.7451272,0.3220714,0.9522123,2.0905653,2.7481805,1.120135,10.5839531),(8048,'ulna-cleaned.tif',183,4,1572,1.9370272,6.2423963,12.3424581,1.8,6.1938684,12.3754981,1.5490269,1.6610303,1.3919766,0.5408926,1.0542796,0.3226849,0.7573975,0.3256368,0.9440856,2.1366008,2.7403488,1.2904967,10.3195192),(8049,'ulna-cleaned.tif',183,4,1573,1.972523,6.2569426,12.3517738,1.8,6.2110916,12.3856872,1.5613938,1.6719071,1.4167345,0.5421845,1.0789151,0.3287248,0.7615507,0.3242911,0.9478135,2.1538297,2.801537,1.2670618,10.6170074),(8050,'ulna-cleaned.tif',183,4,1574,1.9827976,6.2704162,12.3524748,1.8,6.2266354,12.384801,1.5622145,1.7253186,1.6482033,0.5518824,1.0778177,0.3304419,0.653935,0.3198727,0.9200869,2.1914604,2.801537,1.2670618,10.4944718),(8051,'ulna-cleaned.tif',183,4,1575,2.0766046,6.2657096,12.3559317,1.8,6.2185433,12.3863269,1.5625321,1.7603548,1.6449438,0.5852814,1.1091683,0.3460771,0.6742894,0.3324792,0.9389179,2.2048685,2.768094,1.3083369,10.7298616),(8052,'ulna-cleaned.tif',183,4,1576,2.2637045,6.2500023,12.3545367,1.8,6.1990661,12.3813546,1.5459677,1.7909179,1.4577054,0.6350081,1.1265788,0.3770515,0.772844,0.3545713,0.9633736,2.2506469,2.8261484,1.3429393,11.1579057),(8053,'ulna-cleaned.tif',183,4,1577,2.4063459,6.2498004,12.3587483,1.8,6.1993359,12.3885488,-1.5699375,1.8205482,1.4464677,0.6638854,1.1807641,0.4010574,0.8163086,0.3646624,0.9883865,2.2787778,2.8261484,1.3429393,11.3078244),(8054,'ulna-cleaned.tif',183,4,1578,2.3951268,6.2647691,12.3496065,1.8,6.214875,12.3818911,-1.5340744,1.8606085,1.4829838,0.6831358,1.2186345,0.3986497,0.821745,0.3671572,0.9895444,2.2757856,2.8483124,1.3734008,10.447726),(8055,'ulna-cleaned.tif',183,4,1579,2.2937164,6.2882001,12.3303917,1.8,6.2443056,12.3611851,-1.5432662,1.9274176,1.5084027,0.6700136,1.2081177,0.3819964,0.8009252,0.3476224,0.9488076,2.2775,2.8650312,1.3460852,10.7338718),(8056,'ulna-cleaned.tif',183,4,1580,2.2285813,6.3002693,12.3251791,1.8,6.2569786,12.3594915,-1.5351554,1.9754473,1.5161723,0.6778665,1.2115941,0.3709586,0.7991137,0.3431458,0.9263345,2.3031661,2.8940568,1.3057535,9.6150107),(8057,'ulna-cleaned.tif',183,4,1581,2.1834437,6.3110961,12.3139342,1.8,6.2676607,12.3478197,-1.5191342,2.0156243,1.5276187,0.6747907,1.2031079,0.3629369,0.7875708,0.33478,0.8977963,2.2190983,2.8777833,1.2753555,9.1539123),(8058,'ulna-cleaned.tif',183,4,1582,2.1821356,6.3187757,12.304164,1.8,6.2780621,12.3378927,-1.4931405,2.0470954,1.5650209,0.6942433,1.2025044,0.3615005,0.7683632,0.3391358,0.8862306,2.2531871,2.9225219,1.3225064,9.5876277),(8059,'ulna-cleaned.tif',183,4,1583,2.1740739,6.3234064,12.306518,1.8,6.2837293,12.3481418,-1.4791955,2.0430143,1.5592216,0.6939009,1.189614,0.3593138,0.7629538,0.3396456,0.8708552,2.192965,2.8838621,1.3191064,9.5505633),(8060,'ulna-cleaned.tif',183,4,1584,2.1626675,6.3283931,12.3183264,1.8,6.2914205,12.3629763,-1.4697295,2.1182793,1.5492422,0.7034404,1.1816754,0.3567753,0.7627442,0.332081,0.8441626,2.2135845,2.8940568,1.3057535,9.3482277),(8061,'ulna-cleaned.tif',183,4,1585,2.1506003,6.3277229,12.3264873,1.8,6.2899677,12.3718223,-1.4245478,2.1241896,1.5280576,0.7163715,1.1818697,0.3508215,0.7734458,0.3372446,0.8363527,2.1865991,2.9047639,1.2924967,9.836709),(8062,'ulna-cleaned.tif',183,4,1586,2.1514823,6.3278336,12.3372228,1.8,6.2876503,12.3851114,-1.378085,2.1652509,1.5248016,0.73055,1.1936274,0.3454276,0.7828083,0.3373974,0.8203202,2.173784,3.0386935,1.332187,9.7238548),(8063,'ulna-cleaned.tif',183,4,1587,2.1363655,6.334209,12.3478458,1.8,6.2976157,12.3941098,-1.3510567,2.1875599,1.879334,0.728788,1.1881626,0.3391433,0.6322253,0.3331511,0.7997527,2.1526404,3.0803214,1.2818209,9.9205192),(8064,'ulna-cleaned.tif',183,4,1588,2.1061275,6.3337254,12.3588733,1.8,6.2941753,12.4054589,-1.3086987,2.1755366,1.9245488,0.7313223,1.1631166,0.3274549,0.6043581,0.3361572,0.7785623,2.157125,2.9612145,1.3258177,9.5118378),(8065,'ulna-cleaned.tif',183,4,1589,2.0909804,6.336402,12.3723814,1.8,6.3000094,12.4217988,-1.2696643,2.1760162,1.4332278,0.7261541,1.1669168,0.3178386,0.8141879,0.333708,0.7656992,2.1186817,2.8838621,1.3191064,9.2821192),(8066,'ulna-cleaned.tif',183,4,1590,2.06726,6.3328143,12.3801829,1.8,6.2950003,12.4281641,-1.191746,2.1369831,1.466182,0.7356177,1.1550996,0.2973656,0.7878283,0.3442319,0.7404819,2.1231663,2.9047639,1.2924967,9.2667666),(8067,'ulna-cleaned.tif',183,4,1591,2.0526361,6.3284724,12.3996728,1.8,6.2856243,12.4506579,-1.1606035,2.1121351,1.491343,0.7298787,1.1552444,0.2877008,0.7746336,0.3455644,0.74063,2.0788101,2.8664201,1.2886726,9.224031),(8068,'ulna-cleaned.tif',183,4,1592,2.0116878,6.3279646,12.4146315,1.8,6.2838483,12.4651855,-1.1155948,2.1420199,1.5770673,0.7305821,1.1384631,0.270476,0.7218862,0.3410716,0.7132616,2.0800978,2.8664201,1.2886726,9.0039937),(8069,'ulna-cleaned.tif',183,4,1593,1.9481416,6.3314584,12.4268036,1.8,6.289929,12.4732151,-1.1207511,2.2299502,1.5736208,0.7000726,1.1065678,0.263249,0.7031985,0.3139409,0.6706762,2.0718977,2.8396357,1.2712643,8.9008208),(8070,'ulna-cleaned.tif',183,4,1594,1.9023488,6.3324546,12.4390985,1.8,6.2902956,12.4841662,-1.0919888,2.2632492,1.6428176,0.6950663,1.0958312,0.2497581,0.6670438,0.3071099,0.6461247,2.0188793,2.8396357,1.2712643,9.1635937),(8071,'ulna-cleaned.tif',183,4,1595,1.8602335,6.3404002,12.4540622,1.8,6.3005218,12.4977698,-1.1021531,2.3463191,1.6291684,0.6808867,1.074872,0.2467874,0.6597673,0.2901935,0.6146609,2.031264,2.8066467,1.3120254,8.984631),(8072,'ulna-cleaned.tif',183,4,1596,1.8359155,6.3384647,12.4687309,1.8,6.294822,12.508764,-1.0683898,2.3495361,1.7286257,0.6800168,1.0529515,0.2350348,0.6091264,0.289426,0.5992046,2.0247769,2.8137282,1.25353,9.1732751),(8073,'ulna-cleaned.tif',183,4,1597,1.8331289,6.3428522,12.4923435,1.8,6.301024,12.5299048,-1.0619952,2.4780667,1.7286882,0.6892724,1.048395,0.2330224,0.6064685,0.2781493,0.5784653,2.0247769,2.8137282,1.25353,8.9185225),(8074,'ulna-cleaned.tif',183,4,1598,1.8276645,6.3571659,12.5157508,1.8,6.3211292,12.5500323,-1.0995356,2.5453102,1.6597326,0.6690583,1.0390664,0.2418228,0.6260445,0.2628592,0.5656545,2.0275532,2.8066467,1.3120254,9.1829564),(8075,'ulna-cleaned.tif',183,4,1599,1.8742147,6.35604,12.5604477,1.8,6.3120313,12.6028579,-1.0918435,2.5877461,1.675026,0.7023031,1.0798058,0.2460273,0.6446502,0.2713957,0.5834601,2.0330369,2.7898633,1.2807094,8.9806208),(8076,'ulna-cleaned.tif',183,4,1600,1.8995512,6.371981,12.5852409,1.8,6.3320482,12.6243603,-1.1489321,2.7008069,1.5327374,0.6832499,1.0812997,0.2635124,0.7054697,0.2529799,0.5738016,2.0334508,2.8281193,1.2847449,9.0604208),(8077,'ulna-cleaned.tif',183,4,1601,1.9432387,6.3838225,12.6190403,1.8,6.3448227,12.6557665,-1.1853776,2.7977262,1.5160956,0.6744959,1.1035239,0.2780981,0.7278722,0.2410872,0.5698016,2.0057843,2.801537,1.2670618,9.5779463),(8078,'ulna-cleaned.tif',183,4,1602,1.9770569,6.398508,12.6460709,1.8,6.3674394,12.6716661,-1.2243742,2.8589196,1.5190654,0.6507728,1.1053876,0.2915224,0.7276761,0.2276289,0.5599947,1.9604249,2.8137282,1.25353,9.5722751),(8079,'ulna-cleaned.tif',183,4,1603,1.98346,6.4066633,12.664413,1.8,6.3776579,12.6872369,-1.2332915,2.9217173,1.5295606,0.648868,1.0973924,0.2943291,0.7174559,0.2220845,0.5486889,2.0105804,2.8171209,1.2983332,8.7879666),(8080,'ulna-cleaned.tif',183,4,1604,1.9499873,6.4242181,12.6719386,1.8,6.4045831,12.6967032,-1.2845067,2.9406441,1.8756412,0.5833515,1.0673479,0.2990803,0.5690576,0.1983754,0.5213432,1.9938136,2.7898633,1.2807094,8.6847937),(8081,'ulna-cleaned.tif',183,4,1605,1.9047443,6.439974,12.6695032,1.8,6.427632,12.6949064,-1.30624,2.8925715,1.8764869,0.5411031,1.036052,0.2957521,0.5521232,0.1870665,0.5076456,2.0094804,2.8281193,1.2847449,9.0136751),(8082,'ulna-cleaned.tif',183,4,1606,1.8577407,6.4462939,12.6537713,1.8,6.4327668,12.6737276,-1.2913927,2.8278007,1.886502,0.5344573,1.0015655,0.2860747,0.5309115,0.189001,0.4987026,2.118306,2.8281193,1.2847449,9.2160107),(8083,'ulna-cleaned.tif',183,4,1607,1.8179578,6.4521142,12.6421601,1.8,6.4371612,12.6667606,-1.2751156,1.248352,1.4597911,0.5312744,0.9587761,0.2772662,0.6567899,0.4255806,0.9511269,2.1181464,2.8171209,1.2983332,9.1265293),(8084,'ulna-cleaned.tif',183,4,1608,1.7889515,6.4611452,12.6336787,1.8,6.4461561,12.6549652,-1.2404741,2.8450222,1.5054561,0.5332975,0.946409,0.2667918,0.6286527,0.1874493,0.4658307,2.0988036,2.851664,1.2578951,9.0467293),(8085,'ulna-cleaned.tif',183,4,1609,1.7790567,6.4670435,12.6412535,1.8,6.4459439,12.6681905,-1.2135961,2.8655336,1.4998686,0.5559031,0.9454494,0.2602591,0.6303548,0.1939964,0.4661225,2.1129974,2.8777833,1.2753555,9.0894649),(8086,'ulna-cleaned.tif',183,4,1610,1.7588848,6.4845111,12.6440635,1.8,6.4657769,12.6696493,-1.2010958,2.8643593,1.5368613,0.5485194,0.9377742,0.254873,0.6101879,0.1914981,0.4590276,2.0328554,2.851664,1.2578951,8.9532378),(8087,'ulna-cleaned.tif',183,4,1611,1.759639,6.5012815,12.6622388,1.8,6.4857649,12.695532,-1.2385806,2.9403295,1.4708388,0.5375285,0.9384292,0.2620788,0.6380231,0.1828123,0.4538118,2.0321223,2.8664201,1.2886726,8.8033192),(8088,'ulna-cleaned.tif',183,4,1612,1.7509192,6.5091846,12.6739891,1.8,6.4896697,12.7059438,-1.2420889,1.2552992,1.4525857,0.5252312,0.9228009,0.2614085,0.6352816,0.4184112,0.8827268,2.0408098,2.8396357,1.2268272,8.9201836),(8089,'ulna-cleaned.tif',183,4,1613,1.7761185,6.5175883,12.6912388,1.8,6.4937772,12.7325865,-1.2428665,1.2945368,1.4279726,0.5355602,0.9364737,0.2653113,0.6558065,0.413708,0.8766709,2.046404,2.8137282,1.25353,14.2170008),(8090,'ulna-cleaned.tif',183,4,1614,1.7841657,6.5301325,12.6946998,1.8,6.5072786,12.7300088,-1.2309731,1.2570888,1.4473331,0.5253154,0.9330312,0.2643234,0.6446555,0.4178825,0.8826026,2.0087323,2.82643,1.2401174,14.1041466),(8091,'ulna-cleaned.tif',183,4,1615,1.8478744,6.5417432,12.7082093,1.8,6.5165048,12.7449635,-1.2243132,1.1903702,1.4225512,0.5292153,0.9592243,0.2724621,0.6742986,0.4445804,0.9397504,2.0061366,2.7887218,1.2354719,9.4223564),(8092,'ulna-cleaned.tif',183,4,1616,1.8978508,6.5515114,12.7274557,1.8,6.527022,12.7675788,-1.2368901,1.256649,1.4430608,0.5236018,0.9741027,0.2823335,0.6750254,0.4166651,0.9225303,2.0762503,2.82643,1.2401174,9.1652548),(8093,'ulna-cleaned.tif',183,4,1617,1.9978302,6.5545338,12.7474676,1.8,6.5313478,12.7848606,-1.2264243,1.4468646,1.429848,0.5258097,1.0007606,0.2950204,0.699907,0.3634132,0.9795125,2.0224934,2.7787135,1.2036225,9.6537361),(8094,'ulna-cleaned.tif',183,4,1618,2.060004,6.5559708,12.7631187,1.8,6.5344368,12.7978991,-1.208539,2.9330052,1.4527723,0.5487046,1.0171167,0.3002149,0.7001212,0.1870793,0.4802518,0.0399,0.0564271,2.3561945,0.1128542),(8095,'ulna-cleaned.tif',183,4,1619,2.0970116,6.561325,12.7666331,1.8,6.5379223,12.7976801,-1.2150878,2.9345592,1.4321967,0.5583056,1.0240254,0.3071139,0.7150034,0.190252,0.4845752,2.1305143,2.7646411,1.2170932,9.2063293),(8096,'ulna-cleaned.tif',183,4,1620,2.0947224,6.5695054,12.7671863,1.8,6.5442979,12.7946434,-1.220632,1.5267875,1.3718442,0.5517767,1.0126818,0.3080342,0.7381901,0.3613972,0.9861279,2.2860061,2.8533383,0.357134,10.0430548),(8097,'ulna-cleaned.tif',183,4,1621,2.0995397,6.5771099,12.769367,1.8,6.5490004,12.7999152,-1.2303631,1.576416,1.365279,0.570688,1.0141196,0.3109117,0.7427929,0.3620161,0.9671129,2.3370085,2.928236,0.3476069,10.0954718),(8098,'ulna-cleaned.tif',183,4,1622,2.0795213,6.5817579,12.7716876,1.8,6.5465191,12.8069104,-1.2414183,1.7372422,1.3541695,0.5809955,1.013099,0.310326,0.7481331,0.3344355,0.8865949,2.370783,3.0538492,0.3052231,10.475109),(8099,'ulna-cleaned.tif',183,4,1623,2.031035,6.5920814,12.7738901,1.8,6.5547711,12.8174422,-1.2503239,1.7517922,2.6590303,0.5881512,1.0151882,0.3049144,0.3817889,0.3357426,0.5990866,2.3727671,3.0538492,0.3052231,10.9225159),(8100,'ulna-cleaned.tif',183,4,1624,1.9966862,6.5914663,12.7746526,1.8,6.5432082,12.8221933,-1.2507491,1.789513,3.161178,0.602856,1.0178872,0.2998423,0.3219962,0.3368827,0.4799066,2.3817115,3.0660756,0.3176354,10.7572447),(8101,'ulna-cleaned.tif',183,4,1625,1.9823808,6.569333,12.8199921,1.8,6.499849,12.8901368,-1.087404,1.6738169,3.4791911,0.6304113,1.3191876,0.2590227,0.379165,0.376631,0.545542,2.3771077,3.0308247,0.280108,15.1552381),(8102,'ulna-cleaned.tif',183,4,1626,2.0715292,6.4963134,12.9213185,1.8,6.4123036,13.0090956,-0.9688794,1.5503725,3.5045267,0.6683636,2.2504816,0.234563,0.6421642,0.4310987,0.8264014,2.3593634,3.0919283,0.3421559,15.8887907),(8103,'ulna-cleaned.tif',183,4,1627,2.1808939,6.418684,13.0225855,1.8,6.3438453,13.0995967,-0.9378253,1.5683534,3.4425893,0.7005285,3.1384985,0.2362915,0.911668,0.4466649,1.1018822,2.3836947,3.1165451,0.3257991,16.6320247),(8104,'ulna-cleaned.tif',183,4,1628,2.3165709,6.354844,13.0984547,1.8,6.2957602,13.1568246,-0.9197554,1.5584487,3.4886906,0.7363814,4.0233792,0.2443002,1.1532634,0.4725092,1.3496719,2.3817115,3.154372,0.3217506,11.2360447),(8105,'ulna-cleaned.tif',183,4,1629,1.9538678,6.6767469,12.8103203,1.8,6.6526602,12.8503273,-1.4031789,1.2543952,1.5541187,0.5234615,1.0407797,0.3165808,0.6696913,0.4173019,1.0031207,2.0762963,2.801537,1.3845735,9.5118378),(8106,'ulna-cleaned.tif',183,4,1630,1.979124,6.683603,12.817409,1.8,6.660104,12.8512061,-1.4183598,1.3290015,1.5377988,0.5223597,1.0589015,0.3222484,0.6885826,0.3930467,1.0203119,0.0399,0.0892191,2.0344439,0.1926542),(8107,'ulna-cleaned.tif',183,4,1631,2.0028214,6.6929989,12.8233923,1.8,6.671991,12.8565171,-1.4342841,1.3196912,1.5357469,0.5208659,1.0879381,0.3276215,0.7084097,0.3946877,1.0405731,2.152951,2.8763999,1.1567973,10.4614175),(8108,'ulna-cleaned.tif',183,4,1632,2.0587017,6.692748,12.8292729,1.8,6.6670525,12.8608585,-1.4382128,1.3661596,1.5251511,0.5383754,1.1230875,0.3371208,0.7363779,0.3940794,1.0725885,2.2002748,2.8605824,1.1695675,9.8640921),(8109,'ulna-cleaned.tif',183,4,1633,2.0959639,6.6930675,12.830401,1.8,6.6647698,12.8607084,-1.4440563,1.3284249,1.5646413,0.548989,1.1366022,0.343746,0.7264299,0.4132631,1.0676092,2.1650259,2.8973555,1.1749459,10.155909),(8110,'ulna-cleaned.tif',183,4,1634,2.1270359,6.6945288,12.8360372,1.8,6.6629135,12.8695991,-1.4522827,1.3767028,1.5605578,0.5450837,1.1453381,0.3495501,0.7339287,0.3959342,1.0764568,2.2154247,2.8973555,1.1749459,10.1832921),(8111,'ulna-cleaned.tif',183,4,1635,2.1535468,6.7032507,12.8360892,1.8,6.6738177,12.8708388,-1.4472662,1.414229,1.5607868,0.5497914,1.1514204,0.3534752,0.7377179,0.388757,1.0795117,2.2570874,2.8973555,1.1749459,10.3816175),(8112,'ulna-cleaned.tif',183,4,1636,2.1485398,6.7107338,12.8284616,1.8,6.6785369,12.860795,-1.4521666,1.4220521,1.5954329,0.5571192,1.140256,0.3530741,0.7147001,0.3917713,1.0497359,2.2570874,2.8973555,1.1749459,11.0103362),(8113,'ulna-cleaned.tif',183,4,1637,2.1546892,6.7238467,12.8085603,1.8,6.6948282,12.8282738,-1.4369533,1.4281302,1.6180459,0.5639449,1.1166743,0.35272,0.6901376,0.3948834,1.0276795,2.2617396,2.9420671,1.2104384,12.0824515),(8114,'ulna-cleaned.tif',183,4,1638,2.1802546,6.7273689,12.8019749,1.8,6.6959674,12.8220785,-1.4380371,1.4310873,1.6305773,0.577005,1.1165644,0.3570088,0.6847663,0.4031934,1.0297743,2.2700353,2.956372,1.1978086,11.6737701),(8115,'ulna-cleaned.tif',183,4,1639,2.1906106,6.7466308,12.8022811,1.8,6.7233058,12.8210168,-1.4257772,1.4461871,1.6363307,0.5620207,1.127542,0.3574772,0.6890673,0.3886224,1.0266998,2.2729384,3.0020608,1.160669,11.9228515),(8116,'ulna-cleaned.tif',183,4,1640,2.2027733,6.7570073,12.8035023,1.8,6.7338077,12.8255512,-1.4303489,1.4298256,1.6600153,0.5465972,1.1457564,0.3599346,0.6902084,0.3822824,1.0071141,2.2520121,3.0160812,1.0893991,11.6310345),(8117,'ulna-cleaned.tif',183,4,1641,2.2341108,6.7696631,12.8061383,1.8,6.7511794,12.8296103,-1.4393516,1.4448823,1.6718017,0.5331906,1.1830844,0.3659554,0.7076703,0.3690201,1.022275,0.1995,0.3568765,0.4636476,0.8367255),(8118,'ulna-cleaned.tif',183,4,1642,2.224567,6.7822087,12.8121172,1.8,6.7702707,12.840423,-1.4506165,1.4858491,1.7086108,0.507493,1.1794874,0.3654319,0.6903195,0.3415508,0.9846347,2.1404653,3.0681518,1.2120257,10.3485633),(8119,'ulna-cleaned.tif',183,4,1643,2.2450191,6.7921496,12.8087326,1.8,6.7838858,12.8335589,-1.4461825,1.4591567,1.7175851,0.4980521,1.195532,0.3683895,0.696054,0.3413287,0.9848127,2.1459673,3.1122001,1.1760052,9.8777836),(8120,'ulna-cleaned.tif',183,4,1644,2.2615204,6.7992525,12.8211551,1.8,6.7903278,12.8493368,-1.4493104,1.3238114,1.7363085,0.4892861,1.2450901,0.3713845,0.7170903,0.3696041,0.9949097,2.1459673,3.105543,1.2165369,9.9011565),(8121,'ulna-cleaned.tif',183,4,1645,2.2593957,6.8048597,12.8338742,1.8,6.7941005,12.8618702,-1.4508074,1.3306399,2.1445944,0.4850619,1.2828157,0.3711704,0.5981624,0.3645328,0.8243393,2.1331854,3.1490682,1.1808785,9.9342107),(8122,'ulna-cleaned.tif',183,4,1646,2.2495867,6.8110178,12.8467954,1.8,6.7995762,12.8749803,-1.4411068,1.3109263,2.1325216,0.4870716,1.3157863,0.3686603,0.6170096,0.3715477,0.8454047,2.1192076,3.1568945,1.2090671,10.447726),(8123,'ulna-cleaned.tif',183,4,1647,2.2380897,6.8147788,12.8609007,1.8,6.802962,12.8958076,-1.4412172,1.3112928,2.1190215,0.4846145,1.3517809,0.3667867,0.6379269,0.36957,0.8666235,2.1167451,3.1805081,1.2252407,10.4380447),(8124,'ulna-cleaned.tif',183,4,1648,2.2315055,6.8191272,12.8661618,1.8,6.8088038,12.8967794,-1.4260615,1.274675,2.1141589,0.4814725,1.3714349,0.3641808,0.6486905,0.3777217,0.8763411,2.0856009,3.2456634,1.2062703,10.2220175),(8125,'ulna-cleaned.tif',183,4,1649,2.2519847,6.8203711,12.8716598,1.8,6.8093537,12.8974547,-1.4195347,1.3174275,2.1086722,0.4886555,1.4017468,0.3668085,0.6647533,0.3709164,0.8963163,2.1194161,3.2829725,1.2106032,10.0527362),(8126,'ulna-cleaned.tif',183,4,1650,2.2774427,6.8217033,12.882015,1.8,6.8114901,12.9095048,-1.418561,1.3874884,2.1319852,0.4903315,1.4370875,0.3708447,0.6740607,0.353395,0.9033125,2.0781769,3.2829725,1.2106032,10.0801192),(8127,'ulna-cleaned.tif',183,4,1651,2.2941977,6.8250035,12.8922913,1.8,6.8184982,12.923881,-1.4162866,1.2136452,2.0888537,0.4890982,1.4701276,0.3733104,0.7037963,0.4029993,0.9377664,2.0006538,3.2972469,1.1992785,9.7318751),(8128,'ulna-cleaned.tif',183,4,1652,2.3180889,6.8242272,12.900922,1.8,6.8203395,12.9325122,-1.4178106,1.2198762,2.1136185,0.4971986,1.5062705,0.3773761,0.7126501,0.4075812,0.9471676,2.0074029,3.3203418,1.2148386,10.0100006),(8129,'ulna-cleaned.tif',183,4,1653,2.3420517,6.8222289,12.9149964,1.8,6.8210288,12.9449281,-1.41301,1.209048,2.177794,0.5064388,1.5736988,0.3807042,0.7226114,0.4188741,0.9540546,1.9972228,3.3311125,1.2414702,10.2453904),(8130,'ulna-cleaned.tif',183,4,1654,2.3709168,6.8194228,12.9259943,1.8,6.819393,12.9534032,-1.4196451,1.2063156,2.1671462,0.5206291,1.6213226,0.3861934,0.7481371,0.4315862,0.9874957,1.9901505,3.3442295,1.2301801,10.7846277),(8131,'ulna-cleaned.tif',183,4,1655,2.4271411,6.8225291,12.9186691,1.8,6.8253678,12.9406874,-1.4199259,1.2142099,2.5119107,0.5286435,1.7315396,0.3953854,0.6893317,0.4353807,0.8949618,1.9995262,3.3442295,1.2301801,10.9402175),(8132,'ulna-cleaned.tif',183,4,1656,2.4513325,6.8209043,12.9238842,1.8,6.8227916,12.9461928,-1.4170656,1.1809096,2.202535,0.5393568,1.7639369,0.3989758,0.8008667,0.4567299,1.0435975,1.969208,3.368893,1.2453005,11.3021532),(8133,'ulna-cleaned.tif',183,4,1657,2.4638239,6.8172189,12.9266095,1.8,6.81845,12.9483388,-1.4183135,1.216695,2.1994562,0.5501306,1.8049297,0.4011634,0.8206254,0.4521516,1.0685249,2.0138141,3.3952533,1.2230293,11.2554074),(8134,'ulna-cleaned.tif',183,4,1658,2.4685323,6.8138603,12.9260038,1.8,6.8170147,12.9487837,-1.418636,1.2131747,2.3907387,0.5633578,1.8357739,0.4019698,0.7678689,0.4643665,0.9995036,2.0116478,3.4327917,1.2269905,11.1522345),(8135,'ulna-cleaned.tif',183,4,1659,2.4905893,6.8111548,12.9329298,1.8,6.8182427,12.9606107,-1.4200579,1.2110595,2.4961382,0.5734179,1.8872054,0.4057375,0.75605,0.4734845,0.9800576,2.025193,3.4327917,1.2269905,10.7943091),(8136,'ulna-cleaned.tif',183,4,1660,2.529705,6.8056074,12.9387034,1.8,6.8140616,12.9670794,-1.4221867,1.2115963,2.4901758,0.5938087,1.9377173,0.4123745,0.7781448,0.4901044,1.0107137,2.0393342,3.4464456,1.2160907,10.7475633),(8137,'ulna-cleaned.tif',183,4,1661,2.5800953,6.7966247,12.9470634,1.8,6.8043146,12.9731235,-1.4274328,1.2242018,2.594768,0.6195347,1.9840208,0.4212381,0.7646236,0.5060723,0.9958197,2.0485497,3.4703827,1.2672256,11.1892989),(8138,'ulna-cleaned.tif',183,4,1662,2.654073,6.7910299,12.9729637,1.8,6.8007893,13.0074405,-1.4372964,1.2192199,2.5766991,0.6357388,2.1176768,0.4345086,0.8218565,0.5214308,1.0632892,2.0471164,3.4825182,1.256292,12.1816142),(8139,'ulna-cleaned.tif',183,4,1663,2.7394358,6.7820027,12.9886483,1.8,6.7890498,13.025001,-1.445771,1.4614488,2.5621003,0.6586554,2.2189881,0.4494729,0.8660817,0.4506866,1.1181572,0.0399,0.0564271,2.3561945,0.1128542),(8140,'ulna-cleaned.tif',183,4,1664,2.8490015,6.7755289,12.9926219,1.8,6.7798037,13.0243983,-1.4471263,1.5003049,2.5576849,0.6985826,2.2953802,0.4676083,0.8974445,0.4656271,1.1652396,0.1916464,0.311629,2.2655346,0.7802984),(8141,'ulna-cleaned.tif',183,4,1665,2.9438372,6.7690138,12.9918783,1.8,6.7694992,13.0221984,-1.4441243,1.4932574,2.5568523,0.730117,2.3656724,0.4828088,0.9252284,0.4889425,1.2046037,0.2436768,0.311629,2.2655346,0.9262068),(8142,'ulna-cleaned.tif',183,4,1666,3.0271568,6.7644229,12.9908611,1.8,6.7619448,13.0233211,-1.4391179,1.487725,2.5902436,0.7547334,2.4272148,0.4958285,0.9370604,0.507307,1.2190782,0.2710036,0.46531,2.1112158,1.222034),(8143,'ulna-cleaned.tif',183,4,1667,3.0867971,6.765002,12.9842755,1.8,6.764597,13.0243798,-1.4378455,1.5161737,2.5621779,0.7541021,2.4635835,0.505426,0.9615193,0.4973718,1.2483911,0.2394,0.2676573,2.0344439,0.7238712),(8144,'ulna-cleaned.tif',183,4,1668,3.1305743,6.7699851,12.9565559,1.8,6.7712221,13.0083343,-1.4317697,1.515621,2.5885701,0.7494702,2.4420874,0.5117424,0.9434117,0.4944971,1.2250247,2.0688173,3.5466141,1.2739517,12.8006515),(8145,'ulna-cleaned.tif',183,4,1669,3.1605804,6.7757098,12.9283897,1.8,6.7766902,12.9937345,-1.4230308,1.5144245,2.6145974,0.7446119,2.4265792,0.5153452,0.928089,0.4916797,1.2041237,2.0485497,3.5725544,1.2172544,12.2089973),(8146,'ulna-cleaned.tif',183,4,1670,3.1734582,6.7801007,12.9059207,1.8,6.7800249,12.9742249,-1.4208681,1.4752065,2.6702736,0.7411234,2.403629,0.5171094,0.9001433,0.5023862,1.1667828,2.0603477,3.5707714,1.2525793,12.4250244),(8147,'ulna-cleaned.tif',183,4,1671,3.1902673,6.789972,12.8958,1.8,6.7960137,12.9682052,-1.420394,1.1629218,2.7210348,0.7249938,2.4163294,0.5197739,0.8880185,0.6234244,1.1442131,2.0504072,3.5584896,1.2632292,12.5241871),(8148,'ulna-cleaned.tif',183,4,1672,3.2227935,6.7957636,12.8872151,1.8,6.8018948,12.9602319,-1.4197552,1.1556276,2.6572719,0.7092408,2.4238675,0.5249713,0.9121639,0.6137279,1.171086,2.0440549,3.5466141,1.2739517,11.8373803),(8149,'ulna-cleaned.tif',183,4,1673,3.279659,6.800634,12.8853658,1.8,6.8057164,12.96061,-1.4189291,1.1270449,2.6929836,0.7005516,2.4534481,0.5340996,0.911052,0.6215827,1.1612049,2.0166985,3.5584896,1.2632292,11.724526),(8150,'ulna-cleaned.tif',183,4,1674,3.3585977,6.8100921,12.8923698,1.8,6.8177328,12.9659141,-1.41472,1.2201412,2.7254363,0.6838055,2.4943221,0.5462408,0.915201,0.5604315,1.1559993,2.0091617,3.5584896,1.2632292,12.3218515),(8151,'ulna-cleaned.tif',183,4,1675,3.3864243,6.8169268,12.9012555,1.8,6.8228673,12.9743638,-1.4155053,1.1136801,2.7179973,0.6480752,2.5012202,0.5509023,0.9202438,0.5819222,1.1491516,2.0091617,3.5466141,1.2739517,9.9479022),(8152,'ulna-cleaned.tif',183,4,1676,3.3735361,6.8278235,12.8996245,1.8,6.8353762,12.9666044,-1.4082416,1.0550828,2.6793767,0.6165742,2.4187812,0.5475293,0.9027402,0.5843847,1.1231224,1.9459426,3.4968885,1.2815253,9.5666039),(8153,'ulna-cleaned.tif',183,4,1677,3.3177087,6.8372332,12.9021441,1.8,6.8450106,12.9660994,-1.4052492,1.0268741,2.7167267,0.5755945,2.316542,0.5379353,0.852696,0.5605307,1.0554189,1.9044346,3.4364998,1.300471,9.4964852),(8154,'ulna-cleaned.tif',183,4,1678,3.2657596,6.8455685,12.915683,1.8,6.8569475,12.9754735,-1.4120064,0.9975971,2.7070363,0.5329996,2.2469065,0.5306843,0.8300245,0.5342834,1.0193847,0.0399,0.0564271,2.3561945,0.1128542),(8155,'ulna-cleaned.tif',183,4,1679,3.1232566,6.8498359,12.9422063,1.8,6.8649402,12.9979205,-1.4235539,0.9395733,2.685053,0.4664802,2.0857746,0.5093385,0.7768095,0.4964809,0.9450331,1.7960025,3.3289611,1.3287246,9.5916378),(8156,'ulna-cleaned.tif',183,4,1680,2.9435024,6.8565199,12.9627963,1.8,6.8786453,12.9993944,-1.4257671,0.8412759,2.5815525,0.4087143,1.8626279,0.4803372,0.7215146,0.4858267,0.8738472,1.6758,3.3104981,1.3024301,9.4029937),(8157,'ulna-cleaned.tif',183,4,1681,2.6736139,6.8568396,13.0214394,1.8,6.8762002,13.0537203,-1.4410911,0.7885097,2.4882145,0.3328115,1.5989129,0.4381477,0.6425945,0.4220766,0.7724576,1.5986915,3.0981008,1.441649,9.0547496),(8158,'ulna-cleaned.tif',183,4,1682,2.3473482,6.8630243,13.1030937,1.8,6.8791968,13.1316451,-1.4300986,0.8820906,2.4448407,0.2633481,1.2988298,0.3835311,0.5312533,0.29855,0.6352359,1.4948559,3.0094759,1.4645315,8.4864682),(8159,'ulna-cleaned.tif',183,4,1683,2.0483246,6.879321,13.1851764,1.8,6.8965987,13.2267997,-1.3900058,0.8374253,2.3544217,0.2121744,1.0260241,0.3303502,0.435786,0.2533651,0.5207381,1.4226909,2.7634892,1.2627435,8.0253699),(8160,'ulna-cleaned.tif',183,4,1684,1.7832722,6.8723362,13.2677638,1.8,6.8831909,13.3511338,-1.3866565,0.7431008,2.3100504,0.1649786,0.8320256,0.2872477,0.3601764,0.2220138,0.4270106,1.3839761,2.5567154,1.1700029,10.6153463),(8161,'ulna-cleaned.tif',183,4,1685,1.6808611,6.8830069,13.2495194,1.8,6.8928025,13.3150015,-1.3639847,0.7598338,2.3218099,0.1505156,0.7553369,0.2683313,0.3253225,0.1980902,0.3848948,1.2433055,2.4997279,1.1428478,7.1749529),(8162,'ulna-cleaned.tif',183,4,1686,1.4676224,6.895376,13.293626,1.8,6.9095484,13.3670049,-1.3064687,0.6753601,2.2179842,0.1188347,0.5956293,0.2279078,0.2685454,0.1759575,0.31472,1.2364265,2.4270223,1.0924439,6.8928173),(8163,'ulna-cleaned.tif',183,4,1687,1.4021314,6.9112507,13.2768567,1.8,6.9235949,13.3457168,-1.2833881,0.676821,2.2650705,0.1110429,0.548589,0.2149108,0.2421951,0.1640653,0.2833982,1.3488857,2.3381537,1.1300455,7.4901428),(8164,'ulna-cleaned.tif',183,4,1688,1.2351342,6.9281453,13.2601639,1.8,6.9510815,13.305376,-1.1913681,0.7401305,1.901961,0.0906616,0.3474788,0.1776147,0.182695,0.1224941,0.2166232,1.3038328,2.2718487,1.0364009,7.23138),(8165,'ulna-cleaned.tif',183,4,1689,1.1699326,6.944752,13.2507732,1.8,6.9613992,13.3072898,-1.1927427,0.7258123,1.9177623,0.0898142,0.3056163,0.1684228,0.1593609,0.1237431,0.1945461,1.3229054,2.1082913,1.056345,7.1378885),(8166,'ulna-cleaned.tif',183,4,1690,1.0412412,6.97347,13.2869683,1.8,6.9985723,13.3732749,-1.2578135,0.6506544,1.99554,0.079243,0.2797464,0.1570884,0.1401858,0.1217897,0.1729454,1.1791134,1.9997823,1.0714496,7.0387258),(8167,'ulna-cleaned.tif',183,4,1691,0.9880896,6.9925474,13.2850783,1.8,7.0153005,13.3858587,-1.3239595,0.6087867,2.0354391,0.0800104,0.2895762,0.1548499,0.1422672,0.131426,0.1778256,1.2056886,2.0946551,1.2610934,7.0153529),(8168,'ulna-cleaned.tif',183,4,1692,0.8044169,7.0009027,13.3691888,1.8,7.0284791,13.4874714,-1.4075873,0.6187462,1.9424223,0.064587,0.2484486,0.1305298,0.1279066,0.1043836,0.1601304,1.1723493,2.6057481,1.3703978,11.2417159),(8169,'ulna-cleaned.tif',183,4,1693,0.7305645,7.0186082,13.3896486,1.8,7.040589,13.5159377,-1.487468,0.6346262,1.9348956,0.0569364,0.2520983,0.1209172,0.1302904,0.0897165,0.1596727,0.7272909,1.5401607,0.9324765,4.281129),(8170,'ulna-cleaned.tif',183,4,1694,0.5938592,7.0440987,13.5360105,1.8,7.0717939,13.6813187,-1.5508595,0.6060409,1.7888493,0.0392849,0.2558073,0.0989372,0.143001,0.0648222,0.1644178,0.5642712,1.2978238,0.7853982,3.4403934),(8171,'ulna-cleaned.tif',183,4,1695,0.5609525,7.0749354,13.6344229,1.8,7.0974907,13.7654349,-1.5580222,0.5762786,1.7291367,0.0323502,0.2886943,0.0934768,0.1669586,0.0561364,0.1849713,0.6004436,2.652675,1.2966289,7.0911428),(8172,'ulna-cleaned.tif',183,4,1696,0.4595092,7.1320391,13.7642118,1.8,7.1512094,13.8705202,-1.5151983,0.4989841,1.5699436,0.0189171,0.2543895,0.0763484,0.1620373,0.0379112,0.1729252,0.6099832,2.6118505,1.2442149,7.1435597),(8173,'ulna-cleaned.tif',183,4,1697,0.3752771,7.1576603,13.9499061,1.8,7.1670699,14.0029268,-1.4617316,0.572298,1.4309592,0.0129134,0.2042826,0.0618051,0.1427592,0.0225641,0.1514157,0.6099832,2.6373267,1.2633989,6.6437359),(8174,'ulna-cleaned.tif',183,4,1698,0.3431764,7.1722967,14.0578231,1.8,7.17544,14.073647,-1.4248688,0.6273194,1.3290232,0.0092598,0.1814119,0.0559867,0.1365002,0.0147608,0.1432263,0.5377684,2.0717285,1.2977876,5.2347189),(8175,'ulna-cleaned.tif',183,4,1699,26.4761391,4.415909,11.664009,1.8,4.4394758,11.7524117,1.1586972,3.4940722,4.9371974,57.3377251,135.4422102,3.7047745,27.4330151,16.4100003,38.7456907,6.5774341,9.1506805,2.0910241,41.3007616),(8176,'ulna-cleaned.tif',183,4,1700,26.3869624,4.4178838,11.6919817,1.8,4.4454144,11.7764235,1.1520713,3.538749,4.8847861,56.9350539,133.637294,3.6707771,27.3578602,16.0890342,38.4932699,6.5993256,9.0917736,2.0795999,43.19826),(8177,'ulna-cleaned.tif',183,4,1701,26.1535284,4.41883,11.7099811,1.8,4.451219,11.79057,1.1481683,3.5684966,4.8041819,56.2968586,130.3934556,3.6256196,27.1416567,15.7760717,38.0302628,6.596204,8.9775889,2.0563092,42.6009345),(8178,'ulna-cleaned.tif',183,4,1702,25.6686782,4.4155778,11.7149432,1.8,4.4510224,11.801793,1.1445862,3.5668827,4.7653012,55.3631918,125.5855868,3.5469043,26.3541759,15.5214501,36.7048034,6.6220384,8.8918833,1.9379702,43.0870668),(8179,'ulna-cleaned.tif',183,4,1703,24.9563639,4.4138697,11.7140841,1.8,4.4455268,11.799462,1.1365589,3.553709,4.7484082,54.2399659,119.4729472,3.4231637,25.160631,15.2629172,35.4615714,6.6342699,8.8837332,1.9479666,37.8369953),(8180,'ulna-cleaned.tif',183,4,1704,24.1860773,4.4235879,11.7327895,1.8,4.4506986,11.8105136,1.1253067,3.5634326,4.6830481,53.0891158,113.3259475,3.2825563,24.1991849,14.898308,34.1591203,6.6546429,8.8395388,1.9596847,37.6830665),(8181,'ulna-cleaned.tif',183,4,1705,23.5252553,4.4392064,11.7727175,1.8,4.4633035,11.8527247,1.1157337,3.6043303,4.6723708,52.1251508,107.0825524,3.1634546,22.9182478,14.4618132,33.2143799,6.6767981,8.8686672,2.0424921,43.542494),(8182,'ulna-cleaned.tif',183,4,1706,22.8614767,4.4553672,11.8023993,1.8,4.4819384,11.8933175,1.09943,3.6208776,4.6134921,50.927346,100.7775314,3.0245334,21.8440889,14.0649178,31.8519247,6.7148276,8.780267,2.1260238,39.716792),(8183,'ulna-cleaned.tif',183,4,1707,22.1891791,4.469891,11.8132563,1.8,4.5006235,11.9137556,1.0681887,3.619608,4.6050443,49.2547888,94.6512044,2.8400421,20.5538098,13.6077689,30.5302028,6.7148276,8.7675656,2.13229,35.834663),(8184,'ulna-cleaned.tif',183,4,1708,21.5354211,4.4811949,11.8077635,1.8,4.5165444,11.9214022,1.0242176,3.649755,4.5689586,47.4291347,88.7338713,2.6195751,19.4210278,12.9951556,28.9949,6.7592527,8.73892,2.2005997,46.2590161),(8185,'ulna-cleaned.tif',183,4,1709,20.9929806,4.4875607,11.8088652,1.8,4.5241603,11.9326045,0.9875935,3.6768483,4.5319986,45.9428166,84.2317409,2.4377375,18.5860034,12.4951624,27.1676038,6.7442559,8.7246076,2.1905142,47.3391518),(8186,'ulna-cleaned.tif',183,4,1710,20.503317,4.4964339,11.8291952,1.8,4.5351841,11.9582184,0.9659488,3.6858297,4.5118242,44.6914794,81.1146274,2.3122695,17.9782332,12.1252154,25.9054733,6.7793217,8.7340911,2.184142,35.3308291),(8187,'ulna-cleaned.tif',183,4,1711,20.2363778,4.5074812,11.8621279,1.8,4.5449356,11.9876678,0.9578859,3.722817,4.4787952,43.818892,79.8402275,2.2566488,17.8262734,11.7703587,25.4577896,6.745529,8.7053354,2.093922,32.6650628),(8188,'ulna-cleaned.tif',183,4,1712,19.8484402,4.521271,11.8937355,1.8,4.5544604,12.0083217,0.9322588,3.7168589,4.4321188,42.4781912,77.4116691,2.1329071,17.4660635,11.4285186,24.8463564,6.7360047,8.6564613,2.1025204,32.3982797),(8189,'ulna-cleaned.tif',183,4,1713,19.4265921,4.5339175,11.9322025,1.8,4.562251,12.0345092,0.9071051,3.770016,4.3959081,41.0602012,75.3428385,2.0090612,17.1393115,10.8912538,24.3039748,6.7289963,8.6583922,2.0653619,33.8443611),(8190,'ulna-cleaned.tif',183,4,1714,18.8689671,4.5343126,11.961449,1.8,4.5623347,12.0402359,0.8587573,3.7461663,4.3109038,39.5610275,71.972919,1.8022891,16.6955523,10.5604033,23.4968119,6.6756624,8.6583922,2.0653619,36.0233071),(8191,'ulna-cleaned.tif',183,4,1715,18.3197278,4.5241037,11.9846541,1.8,4.5552947,12.0451542,0.8080703,3.7594869,4.273095,37.7486972,68.8797232,1.5958449,16.1193991,10.0409174,22.5631731,6.6738679,8.6343639,2.2152216,53.2099216),(8192,'ulna-cleaned.tif',183,4,1716,17.8701749,4.515824,12.0086269,1.8,4.556673,12.0627712,0.756569,3.8724322,4.225707,36.3213751,66.4070648,1.4033651,15.7150187,9.3794736,21.8686874,6.5931469,8.6274469,2.1985726,56.8743625),(8193,'ulna-cleaned.tif',183,4,1717,17.5171624,4.5087231,12.034459,1.8,4.5481606,12.0876303,0.7179369,3.6968585,4.1716223,35.4813959,64.9827617,1.2634056,15.5773357,9.5977155,21.5006139,6.5582124,8.6461562,2.0819289,66.5845257),(8194,'ulna-cleaned.tif',183,4,1718,17.1685598,4.5117557,12.0591638,1.8,4.5464579,12.1102206,0.6796685,3.7449914,4.1550184,34.6953773,64.0902236,1.1304253,15.4247748,9.2644745,21.2335978,6.6674581,8.6267087,2.0778948,65.6736715),(8195,'ulna-cleaned.tif',183,4,1719,16.846871,4.5200489,12.0961269,1.8,4.5525001,12.1480533,0.6389423,3.8276871,4.0962591,33.4052959,63.3331221,0.9985406,15.4612099,8.7272796,20.8860761,6.1250772,8.6657438,2.0859447,59.680366),(8196,'ulna-cleaned.tif',183,4,1720,16.7025209,4.5177988,12.1362933,1.8,4.5512953,12.1970507,0.6135277,4.0890933,4.0794337,32.3171709,63.0952537,0.9227982,15.4666697,7.9032609,20.8026421,6.6325644,8.552014,2.2703135,64.1558104),(8197,'ulna-cleaned.tif',183,4,1721,16.9540121,4.5055127,12.1678267,1.8,4.5464544,12.2365311,0.6029257,4.030549,4.0574584,31.9019139,64.0432738,0.9085967,15.7840864,7.9150294,20.9031617,6.6122012,8.5394392,2.2002797,55.0099183),(8198,'ulna-cleaned.tif',183,4,1722,17.269776,4.4862037,12.1999963,1.8,4.5406379,12.2800494,0.5930785,3.9346535,4.0301114,31.198432,64.8388117,0.899144,16.0885906,7.9291435,21.0464698,6.5718994,8.5483832,2.1937588,52.6650131),(8199,'ulna-cleaned.tif',183,4,1723,17.6336677,4.4626334,12.2247177,1.8,4.5243226,12.3165253,0.6065616,3.8702647,4.0571494,31.2812319,66.0248994,0.9550164,16.2737167,8.0824528,21.4112584,6.6164193,8.5773867,2.1742816,53.7411386),(8200,'ulna-cleaned.tif',183,4,1724,18.0048348,4.4364425,12.2292837,1.8,4.4960347,12.3154591,0.6262024,4.0486378,4.1091289,31.7228796,67.1651583,1.0307177,16.345352,7.8354452,21.6114562,6.5823237,8.5629902,2.2040462,53.0309589),(8201,'ulna-cleaned.tif',183,4,1725,18.3147524,4.4204034,12.2378213,1.8,4.4819909,12.3250144,0.6408061,4.0135946,4.1440944,32.1879927,68.4378131,1.0909941,16.51454,8.0197418,21.9666371,6.4702263,8.5629902,2.2040462,47.025623),(8202,'ulna-cleaned.tif',183,4,1726,18.506586,4.4095788,12.241388,1.8,4.4709736,12.327314,0.6537349,3.9700305,4.1583333,32.2083525,69.7773141,1.1407864,16.7801159,8.1128729,22.2575722,6.4182279,8.5483832,2.1937588,49.9331384),(8203,'ulna-cleaned.tif',183,4,1727,18.7335579,4.4006379,12.2526697,1.8,4.4604075,12.3458944,0.6699271,3.9380187,4.1901771,32.2583365,71.2715035,1.2037954,17.0091863,8.1915143,22.6395504,6.4049445,8.5483832,2.1937588,52.5868742),(8204,'ulna-cleaned.tif',183,4,1728,18.9320843,4.3851171,12.2461347,1.8,4.4392585,12.3338108,0.6743017,3.9264942,4.2044734,32.2535235,71.9467492,1.2300029,17.1119525,8.2143311,22.6791649,6.3339287,8.4837011,2.1992468,48.4797247),(8205,'ulna-cleaned.tif',183,4,1729,19.0971973,4.3735818,12.2401309,1.8,4.4272615,12.3320557,0.6818237,3.9174913,4.2248895,32.1383718,72.8549811,1.2641221,17.2442336,8.2038144,22.7196007,6.3254202,8.4830442,2.2227638,51.5518232),(8206,'ulna-cleaned.tif',183,4,1730,19.0743209,4.3664556,12.2280548,1.8,4.4117948,12.3201747,0.6933339,3.9584793,4.2687791,31.7972912,72.9833538,1.2985005,17.0970089,8.0327036,22.5300696,6.0684351,8.4927037,2.1926843,51.0947351),(8207,'ulna-cleaned.tif',183,4,1731,18.921349,4.3769575,12.2183577,1.8,4.4177457,12.3105097,0.712749,3.9377238,4.320752,31.3366913,72.9944629,1.3484809,16.8939255,7.9580724,22.4061106,6.0501268,8.4442015,2.2322539,50.8029181),(8208,'ulna-cleaned.tif',183,4,1732,18.5777253,4.399564,12.2120174,1.8,4.4312069,12.3056071,0.73527,3.9419836,4.3479308,30.6367036,72.419611,1.3931923,16.6561095,7.7719004,22.1501459,5.8863272,8.4061263,2.2418308,46.759528),(8209,'ulna-cleaned.tif',183,4,1733,18.148956,4.4229944,12.2046866,1.8,4.4522805,12.3069044,0.765227,3.8597969,4.3817679,30.0673735,71.8729466,1.4514154,16.4027278,7.789885,21.8466189,5.8639088,8.3882102,2.2314223,52.3127589),(8210,'ulna-cleaned.tif',183,4,1734,17.7732565,4.4435696,12.1963327,1.8,4.4772738,12.3099224,0.7886081,3.9136114,4.4049324,29.4458307,71.6723794,1.4906131,16.2709375,7.5239537,21.6136031,5.9147291,8.3567406,2.2343521,35.9298156),(8211,'ulna-cleaned.tif',183,4,1735,17.5286151,4.4534046,12.1975167,1.8,4.4911274,12.3289268,0.8119947,3.9225547,4.4579907,29.0379816,71.8116865,1.5383814,16.1085322,7.4028239,21.5051341,5.9387586,8.3961776,2.1152908,41.9271312),(8212,'ulna-cleaned.tif',183,4,1736,17.3643877,4.4521591,12.1922943,1.8,4.4875309,12.3261386,0.8262376,3.9528707,4.4814011,28.5331283,72.5016397,1.5650929,16.1783422,7.2183307,21.4820209,6.1711695,8.4238154,2.1022802,59.8883728),(8213,'ulna-cleaned.tif',183,4,1737,17.3338727,4.4538689,12.1936918,1.8,4.4912197,12.3257457,0.8342235,3.9529449,4.4893404,28.1972589,73.3574171,1.5853205,16.3403554,7.1332284,21.4806708,6.1711695,8.4249492,2.1298977,59.0750202),(8214,'ulna-cleaned.tif',183,4,1738,17.390123,4.4491886,12.2131966,1.8,4.4831799,12.3514367,0.841959,3.9359942,4.490633,28.3110433,74.5018972,1.6127607,16.5905113,7.192857,21.7720801,3.2997137,6.3521253,0.9235264,23.33952),(8215,'ulna-cleaned.tif',183,4,1739,17.4496403,4.4469962,12.2253118,1.8,4.4837228,12.3673705,0.8472766,3.9523467,4.5090513,28.341881,75.6014221,1.6336372,16.7665918,7.1708995,22.0055407,6.1515361,8.456259,2.1784299,62.1301052),(8216,'ulna-cleaned.tif',183,4,1740,17.4234926,4.4542322,12.2379743,1.8,4.4921804,12.3741512,0.8463811,3.9494691,4.4708023,28.1934783,75.7581614,1.6286082,16.9450931,7.138549,22.025759,6.1801139,8.3908668,2.1838596,62.0543153),(8217,'ulna-cleaned.tif',183,4,1741,17.3127636,4.4869607,12.2923803,1.8,4.5197323,12.4222847,0.8484449,3.9642391,4.4406782,28.3423759,74.324369,1.6241675,16.7371662,7.1495122,21.9913511,6.1257363,8.2835516,2.2229677,60.1801898),(8218,'ulna-cleaned.tif',183,4,1742,17.1226689,4.5313556,12.3575959,1.8,4.5578834,12.4767372,0.8481908,3.9772725,4.3585619,28.4117505,71.5946832,1.6056147,16.4262168,7.1435262,21.8832886,6.1587084,8.1385244,2.255491,55.2509794),(8219,'ulna-cleaned.tif',183,4,1743,16.8680036,4.5793234,12.4370124,1.8,4.5923148,12.5455432,0.8494653,3.9643644,4.2877801,28.4495755,68.0992816,1.5852886,15.8821767,7.176327,21.3080085,6.1684429,8.0973412,2.3527102,57.5661525),(8220,'ulna-cleaned.tif',183,4,1744,16.6210559,4.6332149,12.5222177,1.8,4.6295846,12.6200669,0.8442871,3.9741375,4.1601703,28.3852174,63.992339,1.5478437,15.382144,7.1424849,20.7605758,6.1386581,7.932076,2.388212,52.4603284),(8221,'ulna-cleaned.tif',183,4,1745,16.4247477,4.7012207,12.6183133,1.8,4.6838473,12.706083,0.8398882,3.9598808,4.0355597,28.0869722,59.8363919,1.517598,14.8272847,7.0928833,20.0769454,6.102972,7.8636414,2.4280132,48.7555011),(8222,'ulna-cleaned.tif',183,4,1746,16.3040823,4.7705428,12.7057222,1.8,4.7454942,12.7805134,0.8347239,3.9777849,3.9246728,27.6775603,56.2664089,1.4924914,14.3365858,6.9580333,20.3295787,6.042117,7.8570589,2.5549985,47.8099315),(8223,'ulna-cleaned.tif',183,4,1747,16.1200351,4.8379169,12.7849478,1.8,4.8025624,12.8413164,0.8253555,3.9696595,3.8101962,27.2155343,52.1411117,1.4505743,13.6846265,6.8558863,18.9190503,6.0401784,7.7652414,2.7515446,47.2359789),(8224,'ulna-cleaned.tif',183,4,1748,16.0106684,4.879881,12.8542565,1.8,4.8392416,12.9105008,0.8069758,3.9390322,3.708273,27.1429129,48.6096198,1.3917833,13.1084255,6.8907568,18.5907082,6.0013809,7.6775109,2.6430755,50.6256164),(8225,'ulna-cleaned.tif',183,4,1749,15.8699111,4.9143396,12.9149404,1.8,4.8655414,12.9735905,0.7797547,3.9309941,3.6090894,27.101257,45.5088665,1.307566,12.6095148,6.8942502,18.0684103,3.1305382,5.5728747,1.062307,20.3078079),(8226,'ulna-cleaned.tif',183,4,1750,15.6766123,4.9382513,12.9668555,1.8,4.8815794,13.0323521,0.7433527,3.9168374,3.4917626,27.2868461,42.6076501,1.1966586,12.2023331,6.9665506,17.3332527,3.1048742,5.4976642,1.1916377,18.1595671),(8227,'ulna-cleaned.tif',183,4,1751,15.4581048,4.947765,13.0071966,1.8,4.880698,13.0757472,0.6960435,3.8790141,3.4039634,27.3627829,40.3664895,1.0591897,11.858673,7.054056,16.8552911,5.9217004,7.5056558,2.7660221,49.0610095),(8228,'ulna-cleaned.tif',183,4,1752,15.1913669,4.9608251,13.051322,1.8,4.8860928,13.1345018,0.6430048,3.8592726,3.2983281,27.0401014,38.1894252,0.9102759,11.5784191,7.006528,16.1978396,5.7355483,7.4347954,2.7909876,48.4185994),(8229,'ulna-cleaned.tif',183,4,1753,14.8194913,4.9809555,13.0932711,1.8,4.8979886,13.1805211,0.5878039,3.8756079,3.177824,26.4759993,35.8574745,0.7595209,11.2836564,6.8314442,15.5788532,2.8828438,5.0372072,0.9542301,18.7705841),(8230,'ulna-cleaned.tif',183,4,1754,14.2116894,5.002711,13.1324044,1.8,4.9138944,13.2179637,0.4929631,3.8640269,3.2275706,25.2392652,33.2290377,0.5304618,10.2953714,6.5318554,14.5436608,5.6463692,7.25533,2.8111467,39.8974158),(8231,'ulna-cleaned.tif',183,4,1755,13.4818195,5.024155,13.1878531,1.8,4.9323724,13.2825524,0.3468862,3.7990997,3.417786,23.9716198,30.7145571,0.2597057,8.9866824,6.3098159,13.6358854,2.5674341,4.6710275,0.9614699,19.7669096),(8232,'ulna-cleaned.tif',183,4,1756,12.7426171,5.0591979,13.2539746,1.8,4.9809837,13.3696512,0.1931538,3.600629,3.5159205,22.4789203,28.5855134,0.078254,8.1303072,6.2430537,12.6780068,2.3853578,4.3890001,0.9272952,18.6867739),(8233,'ulna-cleaned.tif',183,4,1757,12.0303423,5.1015468,13.3320842,1.8,5.0249072,13.4605071,0.0130671,3.6711858,3.5415662,20.8321974,26.5540211,0.0003423,7.4978187,5.6745147,11.7561476,2.2162076,4.157649,0.9215371,16.98594),(8234,'ulna-cleaned.tif',183,4,1758,11.4377848,5.1482675,13.3948063,1.8,5.0729047,13.5109517,-0.0534688,3.0460939,3.6857433,18.7314583,25.1647927,0.0054447,6.8276031,6.1493372,10.8622348,5.2203546,7.0196792,2.9932648,39.6603649),(8235,'ulna-cleaned.tif',183,4,1759,10.9413657,5.2117492,13.4545278,1.8,5.1439545,13.5514847,-0.046317,3.5566779,3.7344801,16.6553874,23.3415748,0.0039092,6.2502876,4.6828495,9.7397384,2.1201485,3.3752665,3.0231027,14.2637466),(8236,'ulna-cleaned.tif',183,4,1760,10.3514567,5.2931231,13.525413,1.8,5.2295034,13.6004734,-0.0639348,3.4918636,3.849247,14.5473247,20.7815325,0.0070426,5.3988566,4.1660633,8.4489137,4.8626236,6.9289428,0.2980756,35.8967613),(8237,'ulna-cleaned.tif',183,4,1761,9.8670979,5.3446295,13.6152327,1.8,5.2664396,13.671315,-0.102973,3.3536021,3.9520636,12.7132706,18.8394678,0.017376,4.7669951,3.7909299,7.5332224,4.6815267,6.8409596,0.295926,41.9892295),(8238,'ulna-cleaned.tif',183,4,1762,9.5504331,5.3687739,13.6968268,1.8,5.2780161,13.7380878,-0.1368294,3.2695597,4.0095471,11.2217522,17.6821861,0.0296155,4.4100207,3.4321906,6.9208306,4.5048927,6.7646683,0.2993662,36.7842427),(8239,'ulna-cleaned.tif',183,4,1763,9.4624773,5.3557593,13.7917495,1.8,5.2596785,13.8505225,-0.1993214,3.1711871,4.0431481,10.8454729,17.117964,0.0618304,4.2338207,3.4200041,6.7764744,4.295273,6.7107959,0.4423742,34.9221477),(8240,'ulna-cleaned.tif',183,4,1764,9.3515642,5.3745317,13.9097182,1.8,5.2745597,13.985086,-0.3953076,2.8602559,4.0983822,11.0558986,15.7107164,0.2311331,3.8333947,3.865353,6.5293096,0.992417,1.2161321,0.7157436,4.1078375),(8241,'ulna-cleaned.tif',183,4,1765,9.0358198,5.3968653,14.0194158,1.8,5.2997569,14.0925674,-0.6191223,2.4550298,3.9530225,10.3412123,14.5204858,0.5071685,3.6732616,4.2122553,6.0704711,3.8903491,6.709491,0.4556691,29.5294898),(8242,'ulna-cleaned.tif',183,4,1766,8.6427569,5.4283654,14.14101,1.8,5.3321337,14.20453,-0.8163627,2.3682503,3.657638,9.1315135,13.8346496,0.7648044,3.7823999,3.8558059,5.5867186,3.9476106,6.6747586,0.4449332,35.1495172),(8243,'ulna-cleaned.tif',183,4,1767,8.2296819,5.4815845,14.2832145,1.8,5.3905883,14.345893,-0.9669432,2.8229107,3.4504775,7.6469316,13.3929959,0.9293811,3.8814906,2.7088818,5.111691,3.759951,6.3990696,1.0485566,29.6092898),(8244,'ulna-cleaned.tif',183,4,1768,7.8051343,5.5056167,14.439242,1.8,5.3936523,14.5112178,-0.9963235,2.9011132,3.3239708,6.2550879,13.2649476,0.9167453,3.9906932,2.1560992,4.7543391,1.0990387,1.6989156,2.976444,6.1569156),(8245,'ulna-cleaned.tif',183,4,1769,7.2336366,5.5473547,14.586066,1.8,5.4259976,14.6482124,-1.0250896,2.9883908,3.2641166,4.7811963,12.4214255,0.8808349,3.8054478,1.5999234,4.1869769,0.9971503,1.5885012,2.939271,6.0440614),(8246,'ulna-cleaned.tif',183,4,1770,6.6764535,5.5870611,14.7406148,1.8,5.4579247,14.7914223,-1.0256228,2.9870816,3.1520495,3.5403957,11.5514858,0.8135134,3.6647539,1.1852357,3.6965199,0.8734112,1.3548386,2.9037567,5.0614274),(8247,'ulna-cleaned.tif',183,4,1771,6.0881388,5.6054304,14.9060957,1.8,5.4659322,14.947977,-0.9954807,2.2449924,3.0659693,2.6438707,10.7066919,0.7142965,3.4921067,1.1776747,3.7142644,0.708351,1.1515834,2.896614,4.201329),(8248,'ulna-cleaned.tif',183,4,1772,5.6106822,5.5939336,15.0662076,1.8,5.4441848,15.1069574,-0.9483633,2.1942941,3.0300132,2.0849712,10.0446279,0.617264,3.3150443,0.9501786,3.4302156,0.3375813,0.8832242,2.8198421,2.5101764),(8249,'ulna-cleaned.tif',183,4,1773,5.2199037,5.5578631,15.2168473,1.8,5.3983812,15.260901,-0.8934439,2.0618171,3.0013492,1.7993141,9.2848339,0.5282602,3.0935533,0.8726836,3.228099,2.1542673,5.9139555,0.9434881,16.8714247),(8250,'ulna-cleaned.tif',183,4,1774,4.8880331,5.5167242,15.3572169,1.8,5.3420866,15.4090378,-0.8341893,1.9728439,2.9429968,1.6041819,8.5407495,0.4470219,2.9020587,0.8131317,3.0185183,2.0443336,5.75363,0.9231344,15.499472),(8251,'ulna-cleaned.tif',183,4,1775,4.5260394,5.4633604,15.4908605,1.8,5.2742414,15.5508884,-0.7662547,1.7052354,2.8515722,1.3958561,7.6880273,0.3627328,2.6960661,0.8185709,2.8319488,1.972513,5.676748,0.8949577,15.0013093),(8252,'ulna-cleaned.tif',183,4,1776,4.0935953,5.4022553,15.6125398,1.8,5.1982297,15.6837753,-0.6866793,1.4168813,2.7941249,1.1566343,6.6787361,0.2742172,2.3902783,0.816324,2.5111707,1.8828707,5.5276984,0.8825275,17.093123),(8253,'ulna-cleaned.tif',183,4,1777,3.6687401,5.353905,15.7074262,1.8,5.1312466,15.7868546,-0.6151339,1.0838277,2.8298345,0.9032247,5.8374546,0.2036195,2.0628254,0.8333656,2.2319038,1.8305169,5.3491305,0.8645972,15.8654178),(8254,'ulna-cleaned.tif',183,4,1778,3.2264619,5.3535637,15.7915125,1.8,5.1363842,15.8647583,-0.5713062,0.8955404,2.7796375,0.6441264,4.9098721,0.157231,1.7663714,0.71926,1.9131181,1.7350309,5.2023237,0.8505233,17.492123),(8255,'ulna-cleaned.tif',183,4,1779,2.8728488,5.3876529,15.8550644,1.8,5.1928911,15.9271695,-0.5596808,0.8195541,2.7372253,0.4658183,4.0878856,0.1349624,1.4934414,0.5683802,1.6054421,1.5832315,5.0540876,0.8244844,16.4724246),(8256,'ulna-cleaned.tif',183,4,1780,2.5236089,5.4269768,15.9195476,1.8,5.2593948,15.9876188,-0.5475729,0.7421503,2.660454,0.3277684,3.345988,0.1140005,1.2576756,0.441647,1.3665851,1.4250462,4.9659074,0.7967613,15.499472),(8257,'ulna-cleaned.tif',183,4,1781,2.1794181,5.4714314,15.9834179,1.8,5.3348593,16.0434148,-0.5272251,0.6698872,2.6725562,0.2283942,2.6716555,0.0919522,0.999663,0.3409442,1.0766231,1.2504044,4.8252614,0.7678561,15.0577364),(8258,'ulna-cleaned.tif',183,4,1782,1.7815498,5.5640846,16.0357495,1.8,5.4681019,16.0800782,-0.5180999,0.5592785,2.7498523,0.1434474,1.9678787,0.0728218,0.7156307,0.2564865,0.7609844,0.8723213,2.7672312,0.8261918,7.1338784),(8259,'ulna-cleaned.tif',183,4,1783,1.333603,5.6947921,16.0795393,1.8,5.6213869,16.1169644,-0.5343563,0.4408895,2.558977,0.0738785,1.2642484,0.0576502,0.4940444,0.167567,0.5179518,0.7623936,2.3244961,0.8826514,5.7095088),(8260,'ulna-cleaned.tif',183,4,1784,0.9860974,5.7953571,16.1214841,1.8,5.7532583,16.1444616,-0.5495353,0.3313788,2.3109149,0.0329124,0.755472,0.0448326,0.3269147,0.0993195,0.3384174,0.6757362,2.1770195,0.8502422,5.6023257),(8261,'ulna-cleaned.tif',183,4,1785,0.6854255,5.8612336,16.1782209,1.8,5.8464001,16.1874466,-0.5470004,0.2423641,1.7931581,0.0116907,0.4381264,0.030905,0.2443323,0.0482359,0.2507912,0.5084783,1.9185222,0.7853982,4.8317088),(8262,'ulna-cleaned.tif',183,4,1786,0.415308,5.9149673,16.233736,1.8,5.9120323,16.2365675,-0.5401633,0.1641445,1.8109192,0.0027601,0.2127163,0.0183068,0.1174632,0.0168148,0.1187974,0.3325005,1.7718476,0.625485,4.0514104),(8263,'ulna-cleaned.tif',183,4,1787,0.1441287,6.0299113,16.2575457,1.8,6.0323325,16.256121,-0.5585304,0.0603137,1.6228985,0.000144,0.0359411,0.0067461,0.0221462,0.0023869,0.0222254,0.1620193,1.7045288,0.5685245,3.642729),(8264,'ulna-cleaned.tif',183,4,1788,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8265,'ulna-cleaned.tif',183,4,1789,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8266,'ulna-cleaned.tif',183,4,1790,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8267,'ulna-cleaned.tif',183,4,1791,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8268,'ulna-cleaned.tif',183,4,1792,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8269,'ulna-cleaned.tif',183,4,1793,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8270,'ulna-cleaned.tif',183,4,1794,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8271,'ulna-cleaned.tif',183,4,1795,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8272,'ulna-cleaned.tif',183,4,1796,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8273,'ulna-cleaned.tif',183,4,1797,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8274,'ulna-cleaned.tif',183,4,1798,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8275,'ulna-cleaned.tif',183,4,1799,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8276,'ulna-cleaned.tif',183,4,1800,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8277,'ulna-cleaned.tif',183,4,1801,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8278,'ulna-cleaned.tif',183,4,1802,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8279,'ulna-cleaned.tif',183,4,1803,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8280,'ulna-cleaned.tif',183,4,1804,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8281,'ulna-cleaned.tif',183,4,1805,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8282,'ulna-cleaned.tif',183,4,1806,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8283,'ulna-cleaned.tif',183,4,1807,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8284,'ulna-cleaned.tif',183,4,1808,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8285,'ulna-cleaned.tif',183,4,1809,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8286,'ulna-cleaned.tif',183,4,1810,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8287,'ulna-cleaned.tif',183,4,1811,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8288,'ulna-cleaned.tif',183,4,1812,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8289,'ulna-cleaned.tif',183,4,1813,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8290,'ulna-cleaned.tif',183,4,1814,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8291,'ulna-cleaned.tif',183,4,1815,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8292,'ulna-cleaned.tif',183,4,1816,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8293,'ulna-cleaned.tif',183,4,1817,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8294,'ulna-cleaned.tif',183,4,1818,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8295,'ulna-cleaned.tif',183,4,1819,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8296,'ulna-cleaned.tif',183,4,1820,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8297,'ulna-cleaned.tif',183,4,1821,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8298,'ulna-cleaned.tif',183,4,1822,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8299,'ulna-cleaned.tif',183,4,1823,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8300,'ulna-cleaned.tif',183,4,1824,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8301,'ulna-cleaned.tif',183,4,1825,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8302,'ulna-cleaned.tif',183,4,1826,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8303,'ulna-cleaned.tif',183,4,1827,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8304,'ulna-cleaned.tif',183,4,1828,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8305,'ulna-cleaned.tif',183,4,1829,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8306,'ulna-cleaned.tif',183,4,1830,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8307,'ulna-cleaned.tif',183,4,1831,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8308,'ulna-cleaned.tif',183,4,1832,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8309,'ulna-cleaned.tif',183,4,1833,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8310,'ulna-cleaned.tif',183,4,1834,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8311,'ulna-cleaned.tif',183,4,1835,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8312,'ulna-cleaned.tif',183,4,1836,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8313,'ulna-cleaned.tif',183,4,1837,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8314,'ulna-cleaned.tif',183,4,1838,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8315,'ulna-cleaned.tif',183,4,1839,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8316,'ulna-cleaned.tif',183,4,1840,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8317,'ulna-cleaned.tif',183,4,1841,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8318,'ulna-cleaned.tif',183,4,1842,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8319,'ulna-cleaned.tif',183,4,1843,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8320,'ulna-cleaned.tif',183,4,1844,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8321,'ulna-cleaned.tif',183,4,1845,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8322,'ulna-cleaned.tif',183,4,1846,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8323,'ulna-cleaned.tif',183,4,1847,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8324,'ulna-cleaned.tif',183,4,1848,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8325,'ulna-cleaned.tif',183,4,1849,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8326,'ulna-cleaned.tif',183,4,1850,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8327,'ulna-cleaned.tif',183,4,1851,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8328,'ulna-cleaned.tif',183,4,1852,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8329,'ulna-cleaned.tif',183,4,1853,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8330,'ulna-cleaned.tif',183,4,1854,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8331,'ulna-cleaned.tif',183,4,1855,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8332,'ulna-cleaned.tif',183,4,1856,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8333,'ulna-cleaned.tif',183,4,1857,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8334,'ulna-cleaned.tif',183,4,1858,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8335,'ulna-cleaned.tif',183,4,1859,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8336,'ulna-cleaned.tif',183,4,1860,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8337,'ulna-cleaned.tif',183,4,1861,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8338,'ulna-cleaned.tif',183,4,1862,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8339,'lesser-mouse-deer-femur-cleaned.tif',183,7,1,0.8371497,14.3320837,12.0494657,1.8,14.3142117,12.0544305,-0.9277881,0.9122368,1.5100709,0.1456851,0.374137,0.089362,0.2477612,0.159701,0.3101767,1.7964732,2.8703551,0.9917221,11.5317567),(8340,'lesser-mouse-deer-femur-cleaned.tif',183,7,2,5.2976711,14.4369441,11.5189889,1.8,14.5017175,11.4453746,-1.1692943,1.7000144,2.8584397,1.1747806,8.6103376,0.7480967,3.0122509,0.6910415,3.1312403,2.8340677,5.5241369,1.3258177,18.1968933),(8341,'lesser-mouse-deer-femur-cleaned.tif',183,7,3,6.7615166,14.4567957,11.0954778,1.8,14.3245268,10.935115,-1.3773823,5.966008,3.2756971,12.25853,15.8515152,1.0852856,4.8391273,2.0547291,4.6818183,2.9723635,6.4859601,1.1836763,23.0233166),(8342,'lesser-mouse-deer-femur-cleaned.tif',183,7,4,12.2307746,10.9988975,10.0523129,1.8,11.3273252,10.1400646,0.2378655,3.5834365,7.1512213,23.0158364,247.7262729,0.1131773,34.6411142,6.4228392,36.3442287,3.0982397,4.5466528,0.735081,16.2974867),(8343,'lesser-mouse-deer-femur-cleaned.tif',183,7,5,18.5831258,9.5322138,9.6123501,1.8,10.1291604,9.7642533,0.229802,3.7983997,7.0464338,39.1684718,392.8478456,0.1607004,55.7513003,10.3118353,58.8137123,4.5276,6.0054669,3.0181919,19.9022133),(8344,'lesser-mouse-deer-femur-cleaned.tif',183,7,6,23.2646951,8.9945818,9.4851532,1.8,9.4936364,9.6239538,0.2283135,4.0783506,7.9687506,59.2254873,459.6123202,0.1986324,57.6768356,14.5219214,62.9415487,5.4978,7.7600874,0.1073699,25.0170466),(8345,'lesser-mouse-deer-femur-cleaned.tif',183,7,7,26.5042176,8.7519762,9.354256,1.8,9.0935699,9.4618585,0.2105995,4.1762736,8.3852613,76.7126571,504.6457729,0.1930404,60.182474,18.3686859,68.4592369,6.1908,8.0897506,0.0342723,25.09167),(8346,'lesser-mouse-deer-femur-cleaned.tif',183,7,8,28.5162259,8.6768025,9.3574655,1.8,8.8849686,9.4573668,0.215368,4.3930352,8.4867753,91.6512738,536.9874768,0.2170592,63.2734414,20.8628589,73.005277,7.1933722,15.58098,3.1030361,53.2008333),(8347,'lesser-mouse-deer-femur-cleaned.tif',183,7,9,27.6037425,8.6118498,9.3335057,1.8,8.8317351,9.4284491,0.2279363,4.4542815,8.6102644,96.8856693,520.1046287,0.2349143,60.4051868,21.7511332,71.2760072,0.1386,0.309919,2.0344439,0.66922),(8348,'lesser-mouse-deer-femur-cleaned.tif',183,7,10,27.5945988,8.4523407,9.2510826,1.8,8.6860879,9.3295264,0.231024,4.0603646,8.7295505,101.6492933,533.9190037,0.2411276,61.1622562,25.0345234,72.4790327,7.389743,15.341322,3.005658,53.27738),(8349,'lesser-mouse-deer-femur-cleaned.tif',183,7,11,28.1999239,8.4731878,9.210603,1.8,8.6729743,9.2665996,0.2385425,4.0941757,8.5534052,106.2104931,555.2934816,0.2624068,64.9207498,25.9418501,76.9880573,7.5178408,15.2169223,2.9984075,51.2453766),(8350,'lesser-mouse-deer-femur-cleaned.tif',183,7,12,27.2226281,8.5455655,9.2545525,1.8,8.7026075,9.2551827,0.2556341,4.0257563,8.3903636,100.1483344,561.1725125,0.2900918,66.8829792,24.8768996,78.6542645,7.5459121,15.153107,2.9854663,52.0294166),(8351,'lesser-mouse-deer-femur-cleaned.tif',183,7,13,26.0272671,8.8558602,9.4012895,1.8,8.9047374,9.364796,0.2671904,4.0099027,8.0309297,95.9098809,541.2300553,0.3023844,67.3932003,23.9182562,79.2685859,7.6951383,15.0314808,2.9435943,52.09011),(8352,'lesser-mouse-deer-femur-cleaned.tif',183,7,14,24.4836799,9.3368918,9.4436418,1.8,9.2476753,9.4020492,0.2857096,4.143022,7.5251541,86.388188,484.2714066,0.3241348,64.3536861,20.8514915,75.6075841,7.818053,14.8506233,2.8739763,52.6147266),(8353,'lesser-mouse-deer-femur-cleaned.tif',183,7,15,23.6993937,9.5886491,9.6469925,1.8,9.4769273,9.5493367,0.2667677,4.186923,7.3316426,81.0702438,444.4994155,0.2744894,60.6275344,19.3627263,71.5608694,7.8558142,14.5794493,2.8820109,54.2396533),(8354,'lesser-mouse-deer-femur-cleaned.tif',183,7,16,21.7136539,10.2458845,9.9572396,1.8,10.1930196,9.8512912,0.2624822,4.1772078,7.3833621,72.2155047,339.3010865,0.2436601,45.9548213,17.2879849,55.0768432,7.8777803,13.9173235,2.9376868,48.7057366),(8355,'lesser-mouse-deer-femur-cleaned.tif',183,7,17,20.8880667,10.7657258,10.204704,1.8,10.9014309,10.1187052,0.2905355,4.1449186,6.7833206,75.7469412,275.1238311,0.2856875,40.5588716,18.2746509,51.7237003,7.8713148,12.2778184,2.9331274,45.3801333),(8356,'lesser-mouse-deer-femur-cleaned.tif',183,7,18,20.8685971,10.8569454,10.2705988,1.8,11.1053625,10.2029543,0.2998572,4.2669992,6.2976104,78.6087705,243.8821109,0.3034696,38.7261348,18.4224948,51.0877596,8.1312,12.058554,2.8501359,47.6537833),(8357,'lesser-mouse-deer-femur-cleaned.tif',183,7,19,20.7052265,10.8995902,10.3748665,1.8,11.2789883,10.4026443,0.3334611,4.5299554,5.7225012,84.214185,216.66327,0.3697104,37.8616382,18.590511,51.8442785,8.1774,11.4521031,2.90542,46.6308166),(8358,'lesser-mouse-deer-femur-cleaned.tif',183,7,20,21.1921535,10.871943,10.5313025,1.8,11.1312012,10.5548726,0.3598922,4.8240874,5.7719061,89.887725,197.9024028,0.4380631,34.2871836,18.6331046,49.8584992,7.9922742,10.8922318,2.8842689,41.44136),(8359,'lesser-mouse-deer-femur-cleaned.tif',183,7,21,20.3098979,10.7473128,10.6778468,1.8,10.8901308,10.7990413,0.3895269,5.3341704,5.4344732,98.1224367,175.6529429,0.4881506,32.3219815,18.3950698,50.2000708,8.25179,10.8018129,2.8509552,45.9001066),(8360,'lesser-mouse-deer-femur-cleaned.tif',183,7,22,20.7995823,10.6339822,10.9292642,1.8,10.7675491,11.212043,0.4520179,6.0569254,5.2367312,118.1222193,158.8256129,0.6613513,30.329151,19.50201,45.7084717,8.5312416,10.0143229,2.7833619,40.1551233),(8361,'lesser-mouse-deer-femur-cleaned.tif',183,7,23,20.904505,10.5168568,11.2037315,1.8,10.5443212,11.5157332,0.4526371,5.7946353,5.0554516,132.7139804,144.1546774,0.6663836,28.5146985,22.9029048,47.5022834,8.3986532,9.6933061,2.7035258,37.3494933),(8362,'lesser-mouse-deer-femur-cleaned.tif',183,7,24,21.3049632,10.2602419,11.4494979,1.8,10.1335234,11.8493871,-0.9580265,4.8621168,5.6594775,136.3549035,162.9098299,2.3762816,28.7853127,28.0443494,52.8735636,8.380992,10.3241237,1.0250047,42.14421),(8363,'lesser-mouse-deer-femur-cleaned.tif',183,7,25,20.7073724,10.1575113,11.4706084,1.8,9.9985874,11.85067,-0.97888,4.8361547,5.7912425,131.0227896,177.8572596,2.3768239,30.7114162,27.0923488,53.2431103,8.3361898,10.4559082,0.9803427,34.1031566),(8364,'lesser-mouse-deer-femur-cleaned.tif',183,7,26,19.785592,10.1418685,11.3082829,1.8,9.946037,11.6951925,-1.0384332,4.8952855,5.831171,127.4313334,163.5479015,2.4480444,28.0471797,26.0314407,49.4654382,8.2906499,10.4175622,0.9778737,35.2521533),(8365,'lesser-mouse-deer-femur-cleaned.tif',183,7,27,19.2522278,10.1585755,11.2606427,1.8,9.9385438,11.6551707,-1.1275192,4.8396044,5.7298333,120.9684558,158.7900959,2.6184406,27.7128651,24.9955257,47.5790256,8.2238888,10.3440552,0.9567773,37.6154833),(8366,'lesser-mouse-deer-femur-cleaned.tif',183,7,28,18.9627322,10.1165052,11.2528799,1.8,9.8894059,11.6220743,-1.2072682,4.8130914,5.5293394,114.8990473,154.6327876,2.7608698,27.9658704,23.8721932,47.0445913,8.234658,10.226806,0.9652517,36.96676),(8367,'lesser-mouse-deer-femur-cleaned.tif',183,7,29,18.7108118,10.0690381,11.1471425,1.8,9.8800157,11.3939073,-1.1956931,4.7859289,5.4797605,109.9275349,150.6199905,2.6998893,27.4866009,22.9689026,46.3001414,8.2426646,10.1100971,1.0335116,32.0908533),(8368,'lesser-mouse-deer-femur-cleaned.tif',183,7,30,18.8634807,10.0737106,11.041423,1.8,9.9277965,11.2730001,-1.2392913,4.730312,5.2881557,105.3370629,144.3992406,2.8108836,27.3061629,22.2685234,45.125129,8.1366276,9.860643,0.9451003,36.09881),(8369,'lesser-mouse-deer-femur-cleaned.tif',183,7,31,18.0122703,9.9982542,10.9939431,1.8,9.7463599,11.302506,-1.3159021,4.7146514,5.1408126,100.5275656,135.9904966,2.8111866,26.4531132,21.3223752,40.7721099,8.0507418,10.1270779,0.924558,36.4572),(8370,'lesser-mouse-deer-femur-cleaned.tif',183,7,32,18.072275,10.0209225,10.8731129,1.8,9.774829,11.1165406,-1.3955506,4.6266281,4.5363444,98.0969906,127.8396155,2.9204857,28.1811972,21.2026962,41.0305895,7.9945697,9.6929758,0.9206223,33.1269533),(8371,'lesser-mouse-deer-femur-cleaned.tif',183,7,33,17.9490546,10.0577558,10.7762304,1.8,9.8048871,10.990134,-1.4881277,4.4282862,4.2867677,95.4011821,122.0381815,2.9711114,28.468578,21.5435902,42.4731459,7.9492227,9.2805669,0.9551764,31.68026),(8372,'lesser-mouse-deer-femur-cleaned.tif',183,7,34,17.7849694,10.1333226,10.6655892,1.8,9.926982,10.8181697,1.4902755,4.077957,4.2149657,90.1184769,117.1789288,2.9449846,27.8006841,22.0989277,46.0484631,7.6669234,8.5234931,0.9587382,30.6731466),(8373,'lesser-mouse-deer-femur-cleaned.tif',183,7,35,17.6848619,10.1683277,10.5466917,1.8,9.9705118,10.6632347,1.3731197,4.124395,4.1633643,86.9117653,113.1846038,2.8337936,27.1858513,21.0726097,45.3272092,7.6004163,8.3887039,2.6853341,29.4476033),(8374,'lesser-mouse-deer-femur-cleaned.tif',183,7,36,17.7348367,10.2121864,10.4523871,1.8,10.0903919,10.5148676,1.2855018,4.1334471,4.1542807,83.3404774,111.287692,2.7216811,26.7886792,20.1624638,44.707898,7.5242623,8.2513252,2.7205258,29.15455),(8375,'lesser-mouse-deer-femur-cleaned.tif',183,7,37,17.7701682,10.2499263,10.3456198,1.8,10.1424007,10.3547294,1.2435373,4.1598071,4.1301207,80.2306737,109.911898,2.6556648,26.6122725,19.2871139,44.1520563,7.4271704,8.2055414,2.4879568,27.7666266),(8376,'lesser-mouse-deer-femur-cleaned.tif',183,7,38,17.7751518,10.286412,10.2447365,1.8,10.1950106,10.2239692,1.1942372,3.6430557,4.1187471,76.9714428,109.8108208,2.5619324,26.6612197,21.1282639,44.0180896,6.7542786,8.2883624,2.8533393,29.5036533),(8377,'lesser-mouse-deer-femur-cleaned.tif',183,7,39,17.8013554,10.3211568,10.1545669,1.8,10.2631076,10.1285347,1.1940933,3.4958008,4.1165919,73.9710621,109.1307155,2.565417,26.5099669,21.1599766,43.7104406,6.6169117,8.1716556,2.7285348,27.9626366),(8378,'lesser-mouse-deer-femur-cleaned.tif',183,7,40,17.7729394,10.3324486,10.0568272,1.8,10.2894663,10.0310914,1.1848781,3.4387051,4.1066109,72.0181809,108.1237798,2.542465,26.3292001,20.9434012,43.2464377,6.5411936,8.1280494,2.4366655,26.27045),(8379,'lesser-mouse-deer-femur-cleaned.tif',183,7,41,17.6980911,10.3395865,9.9536701,1.8,10.2863732,9.9117272,1.1828392,3.451056,4.081785,70.1004263,106.9485097,2.5275543,26.2014068,20.3127468,42.9503922,6.5128646,8.1335622,2.4446726,26.57007),(8380,'lesser-mouse-deer-femur-cleaned.tif',183,7,42,17.6437855,10.343983,9.8366144,1.8,10.3061552,9.7913576,1.1757773,3.4159508,4.0387938,68.0290244,106.37423,2.5051504,26.3381183,19.9151065,42.4394115,6.4432651,8.0881674,2.424912,25.95962),(8381,'lesser-mouse-deer-femur-cleaned.tif',183,7,43,17.5566851,10.3319717,9.712768,1.8,10.3241507,9.6790784,1.1774659,3.2457399,4.0088477,66.509578,105.6697141,2.4962875,26.3591241,20.4913458,41.772791,6.2523843,8.0521975,2.4659557,25.6441466),(8382,'lesser-mouse-deer-femur-cleaned.tif',183,7,44,17.3721506,10.3138355,9.5930477,1.8,10.3369284,9.5984382,1.1859593,3.2091838,3.9522089,65.1119549,104.8154096,2.4873119,26.5207157,20.2892571,41.183966,6.2095429,8.0406584,2.3887034,25.53397),(8383,'lesser-mouse-deer-femur-cleaned.tif',183,7,45,17.240784,10.2934303,9.5087092,1.8,10.3076117,9.5242846,1.1871838,6.2472573,5.0106961,64.3589464,103.4360993,2.4709486,20.6430596,10.3019523,20.9522453,6.2061802,7.9679933,2.2699889,25.5358933),(8384,'lesser-mouse-deer-femur-cleaned.tif',183,7,46,17.119288,10.2752813,9.4088757,1.8,10.2965885,9.431589,1.1773488,3.1505244,3.9197758,63.372945,102.7677654,2.4338599,26.2177661,20.1150469,40.7277059,6.1733776,7.9578075,2.2863494,25.4929766),(8385,'lesser-mouse-deer-femur-cleaned.tif',183,7,47,16.9934836,10.2628908,9.3264405,1.8,10.2788069,9.345669,1.1725615,3.1434408,3.9166116,62.8373929,101.6777676,2.4063267,25.9606464,19.9900037,40.3692593,6.1615665,7.9497568,2.4096415,25.31282),(8386,'lesser-mouse-deer-femur-cleaned.tif',183,7,48,16.8354737,10.249177,9.2320949,1.8,10.2637412,9.2581474,1.1735831,3.1423684,3.8711524,62.1236101,100.3197024,2.3859993,25.9146869,19.7696776,39.8106434,6.1851888,7.9438478,2.3932146,25.04955),(8387,'lesser-mouse-deer-femur-cleaned.tif',183,7,49,16.7888427,10.2383545,9.1470971,1.8,10.2476653,9.1670509,1.1769094,3.1245015,3.8627116,62.0521045,99.3192287,2.3860092,25.7123077,19.8598417,39.9142599,6.1713569,7.9060066,2.3479302,25.4929766),(8388,'lesser-mouse-deer-femur-cleaned.tif',183,7,50,16.7567514,10.2211032,9.0519362,1.8,10.2279005,9.0788302,1.1741862,3.1253997,3.8591677,62.0040381,98.7291693,2.3760433,25.5830213,19.8387546,39.8429278,6.1669499,7.881265,2.401806,25.1056),(8389,'lesser-mouse-deer-femur-cleaned.tif',183,7,51,16.6732246,10.2071058,8.9779142,1.8,10.2163713,9.0278238,1.1808679,3.1178652,3.8617873,61.8639797,98.0154924,2.3773437,25.3808623,19.8417747,39.8346708,6.2109612,7.8808588,2.1474173,25.09439),(8390,'lesser-mouse-deer-femur-cleaned.tif',183,7,52,16.7224683,10.1947445,8.8931991,1.8,10.2038883,8.9404063,1.1796185,3.120435,3.8600978,62.1232904,97.897325,2.3819134,25.361359,19.9085354,40.0975973,6.2158186,7.8675765,2.2730533,25.3174633),(8391,'lesser-mouse-deer-femur-cleaned.tif',183,7,53,16.7952655,10.182465,8.8029726,1.8,10.1883658,8.8524421,1.1830187,3.1256289,3.8860563,62.6130444,97.7640868,2.3989691,25.1576613,20.0321425,40.1882388,6.2135138,7.8578038,2.2896263,25.0132),(8392,'lesser-mouse-deer-femur-cleaned.tif',183,7,54,16.9237394,10.1756442,8.7157599,1.8,10.1837166,8.7467391,1.182787,3.1268624,3.9014395,63.0606114,98.1980643,2.4168622,25.1697005,20.1673766,40.3553697,6.2413729,7.9438478,2.3191744,25.3669466),(8393,'lesser-mouse-deer-femur-cleaned.tif',183,7,55,16.9477694,10.1604643,8.6270179,1.8,10.1601754,8.6534599,1.1944433,3.1267451,3.8985548,63.407608,97.9223304,2.4430799,25.1175977,20.2791101,40.3132656,6.2624137,7.8845143,2.3023048,25.33524),(8394,'lesser-mouse-deer-femur-cleaned.tif',183,7,56,17.0975045,10.1608816,8.5478946,1.8,10.1583776,8.5638897,1.2014186,3.153037,3.8848668,64.2313294,97.9524204,2.4781511,25.2138428,20.371258,40.5917995,6.2653467,7.8732717,2.2647833,24.87596),(8395,'lesser-mouse-deer-femur-cleaned.tif',183,7,57,17.0641295,10.1606433,8.466872,1.8,10.1509748,8.4894536,1.2084303,3.1638933,3.8997515,64.7014267,97.3788633,2.4866377,24.9705306,20.4499393,40.6835886,6.3018976,7.8649988,2.2354459,25.0132),(8396,'lesser-mouse-deer-femur-cleaned.tif',183,7,58,17.1833156,10.1567247,8.4006662,1.8,10.1463487,8.4402827,1.2164616,3.1844948,3.8911981,65.5230742,97.6356527,2.5191148,25.0914113,20.5756572,41.052463,6.343357,7.8230939,2.2935152,25.3174633),(8397,'lesser-mouse-deer-femur-cleaned.tif',183,7,59,17.193473,10.1441718,8.3168305,1.8,10.1366152,8.3545045,1.2201497,3.2087459,3.898193,66.3282832,97.1110821,2.5274525,24.9118201,20.6710924,41.0522137,6.3583467,7.80821,2.2640195,25.1550833),(8398,'lesser-mouse-deer-femur-cleaned.tif',183,7,60,17.2074321,10.1439357,8.2327715,1.8,10.1334529,8.2676543,1.216915,3.2150443,3.9183055,66.89646,96.7578793,2.5234962,24.6938069,20.8073216,41.2640289,6.404556,7.797268,2.2807079,25.1709366),(8399,'lesser-mouse-deer-femur-cleaned.tif',183,7,61,17.3042763,10.1466907,8.1577354,1.8,10.124241,8.1946803,1.2178932,3.228284,3.916927,67.5703672,97.0666704,2.5395307,24.7813327,20.930738,41.6265242,6.4038866,7.7819234,2.3142024,25.2362733),(8400,'lesser-mouse-deer-femur-cleaned.tif',183,7,62,17.4080272,10.144499,8.0865209,1.8,10.1172402,8.1171565,1.2302878,3.2399593,3.9082032,68.4325739,97.3389587,2.5777412,24.90632,21.1214301,41.7419422,6.4520341,7.7885034,2.2974387,25.26798),(8401,'lesser-mouse-deer-femur-cleaned.tif',183,7,63,17.4580276,10.1535574,8.0289797,1.8,10.1175726,8.0441959,1.2351465,3.2731379,3.9001473,69.1286211,97.6159493,2.5939922,25.0287855,21.1199843,42.4946524,6.4680049,7.7445312,2.1952067,25.2969666),(8402,'lesser-mouse-deer-femur-cleaned.tif',183,7,64,17.5244296,10.147517,7.9515899,1.8,10.1126217,7.9744626,1.229471,3.2747445,3.9095405,70.0814563,97.5665109,2.5934743,24.9560047,21.4005874,42.5947642,6.4994942,7.7540338,2.3013971,25.5246833),(8403,'lesser-mouse-deer-femur-cleaned.tif',183,7,65,17.6015299,10.1553778,7.8843396,1.8,10.120728,7.9095928,1.2257756,3.2838761,3.9124944,70.8261867,97.9224368,2.5980146,25.028135,21.5678618,42.7306197,6.5293788,7.7479755,2.318238,25.1709366),(8404,'lesser-mouse-deer-femur-cleaned.tif',183,7,66,17.4719405,10.154456,7.8105987,1.8,10.1302395,7.8295501,1.2114551,3.3152254,3.9103068,71.1073936,97.0330317,2.5518844,24.8146848,21.4487357,42.7106571,6.5635839,7.7166448,2.3138469,25.2250633),(8405,'lesser-mouse-deer-femur-cleaned.tif',183,7,67,17.5253208,10.1598686,7.7507807,1.8,10.1224186,7.7861833,1.2077753,3.3228658,3.9156862,72.0024258,97.0419009,2.5525746,24.7828592,21.6687734,42.9034041,6.5715458,7.7070961,2.1987112,25.0785366),(8406,'lesser-mouse-deer-femur-cleaned.tif',183,7,68,17.5779598,10.1533416,7.6865037,1.8,10.1213143,7.7258803,1.1934914,3.3152286,3.9004502,72.6814229,96.9673254,2.5320155,24.8605469,21.9235027,43.1055193,6.5911045,7.7274248,2.2885015,25.3893666),(8407,'lesser-mouse-deer-femur-cleaned.tif',183,7,69,17.638869,10.1490785,7.623275,1.8,10.1197447,7.663745,1.1914211,3.3073212,3.9172616,73.4976658,97.0956654,2.5366109,24.7866176,22.2227178,43.3475893,6.6066231,7.6876856,2.2154994,24.6080466),(8408,'lesser-mouse-deer-femur-cleaned.tif',183,7,70,17.7576269,10.1472499,7.5648724,1.8,10.124506,7.5931119,1.1827226,3.3302922,3.9202495,74.5648247,97.5049015,2.5358153,24.872116,22.3898745,43.6273336,6.6742656,7.688796,2.3009317,25.50883),(8409,'lesser-mouse-deer-femur-cleaned.tif',183,7,71,17.8358027,10.1491441,7.5010106,1.8,10.1254079,7.5258274,1.1745858,3.3369189,3.9171432,75.5706228,97.4429732,2.5298948,24.8760303,22.6468261,43.7195674,6.6742656,7.6914328,2.2455373,24.9030233),(8410,'lesser-mouse-deer-femur-cleaned.tif',183,7,72,18.0074066,10.1489769,7.4429322,1.8,10.1306052,7.4555773,1.1535942,3.3580667,3.927965,76.8293413,97.531195,2.5084606,24.8299551,22.87904,43.9351321,6.7118127,7.6926815,2.2924512,25.5695233),(8411,'lesser-mouse-deer-femur-cleaned.tif',183,7,73,18.0115275,10.1528457,7.3877886,1.8,10.1357211,7.3909686,1.1397409,3.3419078,3.9069009,77.6249482,97.1895606,2.4778403,24.8763822,23.2277352,43.9516571,6.7158461,7.662239,2.2879247,25.40522),(8412,'lesser-mouse-deer-femur-cleaned.tif',183,7,74,18.0148407,10.1554003,7.3304533,1.8,10.1467208,7.3259073,1.1366631,3.3762027,3.898416,78.4323002,97.1483131,2.4712616,24.9199455,23.2309214,44.3957676,6.7510115,7.6488561,2.3220198,25.41643),(8413,'lesser-mouse-deer-femur-cleaned.tif',183,7,75,18.0481408,10.1659672,7.2685026,1.8,10.1603577,7.2653926,1.1237529,3.3828073,3.9174919,79.3045435,96.9899999,2.4458706,24.7581875,23.4434115,44.4329284,6.7940531,7.64439,2.3561945,25.22042),(8414,'lesser-mouse-deer-femur-cleaned.tif',183,7,76,18.0698626,10.1771711,7.2190587,1.8,10.1735175,7.2066231,1.1150135,3.3806265,3.8887383,80.1781823,96.7923425,2.4281511,24.8904231,23.7169594,44.5380253,6.7954646,7.6554111,2.2493073,25.4929766),(8415,'lesser-mouse-deer-femur-cleaned.tif',183,7,77,18.2007302,10.1835689,7.1700733,1.8,10.1814281,7.1488754,1.0825304,3.4083873,3.8830436,81.4056238,97.1525524,2.3659425,25.0196916,23.8839122,44.917812,6.8429032,7.6201995,2.3090192,25.2474833),(8416,'lesser-mouse-deer-femur-cleaned.tif',183,7,78,18.2775081,10.1922814,7.1081293,1.8,10.2024745,7.0966073,1.0650643,3.4297172,3.8782295,82.3256355,97.2615654,2.3313273,25.0788575,24.0036224,45.028423,6.8556497,7.6130535,2.2616496,25.1550833),(8417,'lesser-mouse-deer-femur-cleaned.tif',183,7,79,18.3052428,10.2070648,7.0644132,1.8,10.2443598,7.077966,1.0471811,3.4345136,3.8775767,83.165348,97.2949049,2.288112,25.0916778,24.2145925,45.2972874,6.8895011,7.5904505,2.248389,25.42764),(8418,'lesser-mouse-deer-femur-cleaned.tif',183,7,80,18.4198421,10.2037725,7.0317294,1.8,10.2362527,7.0545109,1.0181922,3.4213029,3.8511553,84.0731963,97.7662496,2.2241166,25.3862133,24.5734441,45.8278369,6.8809274,7.5775042,2.2655346,24.9590733),(8419,'lesser-mouse-deer-femur-cleaned.tif',183,7,81,18.4112032,10.2082505,6.9871853,1.8,10.2474713,7.0086756,0.9779384,3.4269894,3.8348858,84.3837641,97.7682265,2.1105893,25.4944294,24.6232932,45.8585953,6.9037519,7.5908723,2.1216539,25.4342066),(8420,'lesser-mouse-deer-femur-cleaned.tif',183,7,82,18.3171368,10.2115538,6.9508876,1.8,10.2417078,6.9601538,0.9477548,3.4203377,3.8158801,84.477186,97.5201693,2.013415,25.5564032,24.6984927,45.8936556,6.8946588,7.583558,2.3906636,25.5490266),(8421,'lesser-mouse-deer-femur-cleaned.tif',183,7,83,18.373021,10.233878,6.9047849,1.8,10.262055,6.916517,0.8892584,3.4669203,3.7900713,85.0602661,97.6284675,1.8468406,25.7590055,24.5348199,46.047171,6.9345918,7.5775042,2.2655346,25.4659133),(8422,'lesser-mouse-deer-femur-cleaned.tif',183,7,84,18.2413493,10.2332256,6.8667253,1.8,10.2556275,6.8784672,0.8660334,3.499599,3.7575433,84.7227793,97.3135409,1.7642003,25.8981819,24.2092818,45.9273742,6.949848,7.5667928,1.9524365,25.2857566),(8423,'lesser-mouse-deer-femur-cleaned.tif',183,7,85,18.2101404,10.2510949,6.8253726,1.8,10.2753368,6.8255549,0.816144,3.5385703,3.7375195,85.233967,97.0902375,1.6107673,25.9771856,24.0871196,45.7221514,6.912845,7.5590316,1.9660576,25.23163),(8424,'lesser-mouse-deer-femur-cleaned.tif',183,7,86,18.0652554,10.2382661,6.7886837,1.8,10.26465,6.7858395,0.7862459,3.5492403,3.7417075,84.8462218,96.7918484,1.5079905,25.8683633,23.9054599,45.8663933,6.9583105,7.5615725,2.5739262,25.42764),(8425,'lesser-mouse-deer-femur-cleaned.tif',183,7,87,17.9284037,10.238349,6.7465019,1.8,10.26417,6.7439631,0.7585697,3.5838875,3.729923,84.6218563,96.4407875,1.4139068,25.8559726,23.6117504,45.4084096,6.9707483,7.5870753,3.0195035,25.3193866),(8426,'lesser-mouse-deer-femur-cleaned.tif',183,7,88,17.6866823,10.2101749,6.7122291,1.8,10.2567122,6.7053395,0.7929575,3.5148267,3.7495662,84.22066,94.9245461,1.4961725,25.3161406,23.9615396,45.0432819,6.9707483,7.5711638,2.7270858,25.2045666),(8427,'lesser-mouse-deer-femur-cleaned.tif',183,7,89,17.8107877,10.2420798,6.6880972,1.8,10.2678926,6.6732588,0.6901512,3.6357533,3.745249,84.5667191,96.1527259,1.2032021,25.6732533,23.2597519,45.7066636,6.9583105,7.6509488,3.0022575,25.69091),(8428,'lesser-mouse-deer-femur-cleaned.tif',183,7,90,17.7245484,10.2591622,6.6729355,1.8,10.2842913,6.6741616,0.65968,3.6782791,3.7793155,84.6339116,95.8622693,1.1095636,25.3649818,23.0091052,45.7369984,6.9588351,7.613474,2.7295297,25.4117866),(8429,'lesser-mouse-deer-femur-cleaned.tif',183,7,91,17.716129,10.2612958,6.6465352,1.8,10.2784121,6.6780575,0.644456,3.6753102,3.7789732,84.5506229,96.0936163,1.0656752,25.428499,23.0050307,45.9247701,6.9458245,7.6633532,3.0389246,25.2923233),(8430,'lesser-mouse-deer-femur-cleaned.tif',183,7,92,17.6632974,10.263791,6.6203794,1.8,10.2831023,6.6425006,0.6378439,3.6765944,3.7856231,84.6132441,95.9824456,1.0438365,25.3544644,23.0140274,46.0647448,6.9752113,7.6904615,3.0090411,25.5873),(8431,'lesser-mouse-deer-femur-cleaned.tif',183,7,93,17.6525132,10.2778914,6.6051114,1.8,10.2832666,6.6125613,0.6356465,3.6719909,3.8177069,84.7533238,96.1836853,1.0370179,25.194099,23.0810276,46.0865856,6.9770213,7.7025252,2.9606662,25.3959333),(8432,'lesser-mouse-deer-femur-cleaned.tif',183,7,94,17.7159213,10.2831213,6.589682,1.8,10.2954216,6.5946254,0.651782,3.6463354,3.8132161,85.4241517,96.615641,1.0864835,25.3370481,23.427398,46.2231248,6.9910233,7.7424639,3.003915,25.7562466),(8433,'lesser-mouse-deer-femur-cleaned.tif',183,7,95,17.6419012,10.2946219,6.5693241,1.8,10.3043933,6.5676683,0.6236905,3.6911557,3.8426506,85.224027,96.5552072,1.0029323,25.1272411,23.0887109,46.1138108,6.9910233,7.7424639,3.003915,25.3418066),(8434,'lesser-mouse-deer-femur-cleaned.tif',183,7,96,17.6184887,10.3101802,6.5438508,1.8,10.3145991,6.549618,0.5934138,3.705718,3.8540676,85.1165485,96.8518958,0.9182124,25.1297868,22.9689763,45.9165975,7.0089367,7.7705324,3.0223999,25.5041866),(8435,'lesser-mouse-deer-femur-cleaned.tif',183,7,97,17.6584246,10.3142419,6.5256254,1.8,10.3242025,6.5319525,0.5767051,3.7172469,3.8661853,85.1306415,97.4748303,0.8750157,25.2121467,22.9015302,45.1721726,7.0236917,7.8013731,2.9929955,25.72726),(8436,'lesser-mouse-deer-femur-cleaned.tif',183,7,98,17.5233432,10.3200732,6.5041677,1.8,10.328121,6.513845,0.5392815,3.7422025,3.9008416,84.5027649,97.2825449,0.7701578,24.9388604,22.5810242,45.7864912,7.0233849,7.8404,2.9996956,25.79452),(8437,'lesser-mouse-deer-femur-cleaned.tif',183,7,99,17.5196229,10.3292596,6.4828469,1.8,10.3234231,6.4661959,0.5046147,3.7520113,3.9124203,84.5704094,97.134304,0.6825161,24.8271648,22.54002,45.4895295,7.0465094,7.854,2.9880489,25.5583133),(8438,'lesser-mouse-deer-femur-cleaned.tif',183,7,100,17.5402153,10.3293137,6.4722869,1.8,10.3330098,6.4468256,0.4792761,3.7632402,3.9295377,84.725759,97.3577904,0.6216465,24.775889,22.5140452,45.7770451,7.05636,7.8686616,2.976444,25.6797),(8439,'lesser-mouse-deer-femur-cleaned.tif',183,7,101,17.6028823,10.3261452,6.4658897,1.8,10.3396892,6.4343631,0.4615907,3.7528224,3.9260475,85.2203121,97.6485161,0.5819426,24.8719649,22.7083251,45.9142956,7.0830855,7.8931723,3.041924,25.4659133),(8440,'lesser-mouse-deer-femur-cleaned.tif',183,7,102,17.5698497,10.3377672,6.4540015,1.8,10.3406501,6.4152033,0.4523227,3.7502602,3.9544114,85.2820323,97.3637825,0.5593591,24.621561,22.7402973,45.805575,7.0877122,7.8931723,3.041924,25.33524),(8441,'lesser-mouse-deer-femur-cleaned.tif',183,7,103,17.3856421,10.3522692,6.4284218,1.8,10.3413427,6.4031776,0.4395253,3.7405639,3.9454064,84.3995433,96.653593,0.524637,24.4977531,22.5633209,45.1563242,7.1097099,7.9142367,2.9774037,25.6077966),(8442,'lesser-mouse-deer-femur-cleaned.tif',183,7,104,17.3660394,10.3518461,6.4053952,1.8,10.34103,6.3963933,0.4066562,3.758684,3.9691566,84.2692905,96.5713669,0.4528258,24.3304499,22.4198925,45.252538,7.1216967,7.9255558,3.0071151,25.7403933),(8443,'lesser-mouse-deer-femur-cleaned.tif',183,7,105,17.2064294,10.3544881,6.3906562,1.8,10.3467932,6.4029884,0.3976567,3.7375831,3.9622329,84.0189234,95.5310248,0.4300733,24.1104013,22.4794795,44.8047686,7.1150575,7.9318821,3.001343,25.3959333),(8444,'lesser-mouse-deer-femur-cleaned.tif',183,7,106,17.3786457,10.3546,6.3781215,1.8,10.3308847,6.3793984,0.4037057,3.7246859,3.9620469,84.4392286,96.1257058,0.4469628,24.2616276,22.6701607,45.2677566,7.1216967,7.9453255,2.9898275,25.54246),(8445,'lesser-mouse-deer-femur-cleaned.tif',183,7,107,17.4019987,10.3632253,6.3497717,1.8,10.3412504,6.3515517,0.3688506,3.7609578,3.9610505,84.2561552,96.1120591,0.3770191,24.2642853,22.4028451,44.9638074,7.1511469,7.9713411,3.0078921,25.7991633),(8446,'lesser-mouse-deer-femur-cleaned.tif',183,7,108,17.2855592,10.3752148,6.3368209,1.8,10.3400125,6.3353996,0.3631694,3.7277557,3.9582076,83.6646884,95.3792977,0.3635572,24.0965878,22.4437158,44.567736,7.154365,7.9726798,3.0603763,25.65728),(8447,'lesser-mouse-deer-femur-cleaned.tif',183,7,109,17.180827,10.3786006,6.3181072,1.8,10.3470459,6.3110811,0.3551908,3.7195412,3.966433,83.1898124,94.6435021,0.3463181,23.861112,22.3656115,44.2905846,7.154365,7.9897955,3.037321,25.4117866),(8448,'lesser-mouse-deer-femur-cleaned.tif',183,7,110,17.0902899,10.3883173,6.2981383,1.8,10.3480444,6.2952984,0.3202786,3.694755,3.9727166,82.1500359,94.61498,0.2823276,23.816192,22.2342306,43.9686958,7.1463896,7.9807073,3.0488363,25.45006),(8449,'lesser-mouse-deer-femur-cleaned.tif',183,7,111,17.126682,10.3936173,6.2670121,1.8,10.3585835,6.2838029,0.3001902,3.6939598,3.9607111,81.4148344,95.2507411,0.2495917,24.0488987,22.0399891,44.0769463,7.1202507,7.9807073,3.0488363,25.6843433),(8450,'lesser-mouse-deer-femur-cleaned.tif',183,7,112,17.2396628,10.3909238,6.2580476,1.8,10.366662,6.2638226,0.2605187,3.6717996,3.9655361,81.5811689,95.502248,0.1906373,24.0830612,22.2183068,44.288464,7.1103587,7.9909975,2.9907016,25.6665666),(8451,'lesser-mouse-deer-femur-cleaned.tif',183,7,113,17.357769,10.3853996,6.2521321,1.8,10.3778865,6.2562242,0.2422072,3.6349699,3.973425,81.3957117,96.3417553,0.1664208,24.2465268,22.392403,44.4566033,7.0684119,7.9999406,3.0258334,25.33524),(8452,'lesser-mouse-deer-femur-cleaned.tif',183,7,114,17.3783293,10.3884146,6.255561,1.8,10.3755678,6.2560896,0.2381808,3.6187984,3.9776188,81.0593631,96.4476901,0.1612287,24.2475951,22.3995242,44.4254219,7.0595966,7.9999406,3.0258334,26.5878466),(8453,'lesser-mouse-deer-femur-cleaned.tif',183,7,115,17.4519182,10.3901989,6.2519794,1.8,10.3740504,6.2472201,0.2332301,3.5881752,3.9560407,80.7124915,96.859857,0.1553718,24.4840393,22.4940217,44.5848092,7.0224,7.9897955,3.037321,26.31529),(8454,'lesser-mouse-deer-femur-cleaned.tif',183,7,116,17.4063377,10.3780886,6.2428261,1.8,10.3600776,6.251339,0.1885854,3.5571592,3.9854895,80.506188,96.170542,0.1019572,24.1301708,22.632158,44.2964502,6.9762,8.0054082,3.0201009,25.9167033),(8455,'lesser-mouse-deer-femur-cleaned.tif',183,7,117,17.5177003,10.3993538,6.2392774,1.8,10.3745101,6.2387667,0.170269,3.5386422,3.9751344,80.4365166,96.4443485,0.0838293,24.2619089,22.7308985,43.9817832,6.9762,7.9999406,3.0258334,25.9279133),(8456,'lesser-mouse-deer-femur-cleaned.tif',183,7,118,17.6143636,10.3850187,6.2248328,1.8,10.3789187,6.2184556,0.1181875,3.5070622,3.9831646,80.1649286,97.1271761,0.0408165,24.3844245,22.8581427,44.4783264,6.8838,8.0171311,3.0086603,25.9437666),(8457,'lesser-mouse-deer-femur-cleaned.tif',183,7,119,17.561009,10.373424,6.2350259,1.8,10.3814301,6.2219752,0.0770173,3.4870287,3.9867884,79.1240279,97.3543178,0.0173267,24.4192338,22.6909595,44.1028304,6.8838,7.9909975,2.9907016,26.7007433),(8458,'lesser-mouse-deer-femur-cleaned.tif',183,7,120,17.5015215,10.3636507,6.2533327,1.8,10.3834311,6.2213508,0.0462349,3.464886,4.0144621,78.5002288,97.0797138,0.006231,24.1824962,22.6559343,43.7167853,6.8376,7.9807073,3.0488363,26.44404),(8459,'lesser-mouse-deer-femur-cleaned.tif',183,7,121,17.5967816,10.368646,6.2596162,1.8,10.3887131,6.2178154,0.0366337,3.4166293,4.009579,78.0699305,97.6633481,0.0039341,24.3575068,22.8499854,43.7737947,6.7903168,7.9897955,3.037321,26.6129866),(8460,'lesser-mouse-deer-femur-cleaned.tif',183,7,122,17.9203506,10.3674725,6.2810787,1.8,10.3910505,6.2303792,0.0215432,3.3902639,3.9715695,78.5242843,99.5990027,0.0013859,25.0779958,23.1617024,44.074022,6.7431123,7.9835151,2.9612216,26.1826933),(8461,'lesser-mouse-deer-femur-cleaned.tif',183,7,123,18.1617792,10.3608562,6.2831338,1.8,10.3890329,6.2367023,-0.0103482,3.3728389,3.9633214,78.6920464,101.2688898,0.0003241,25.5515209,23.3311012,44.7383349,6.7144902,7.9384722,2.9955804,25.8289466),(8462,'lesser-mouse-deer-femur-cleaned.tif',183,7,124,18.3692193,10.3659115,6.2848296,1.8,10.3916466,6.254524,-0.0536459,3.3701579,3.9842319,78.8673041,102.4684471,0.0088023,25.7184945,23.4016644,44.96321,6.6827269,7.9453255,2.9898275,25.8737866),(8463,'lesser-mouse-deer-femur-cleaned.tif',183,7,125,18.404638,10.3620952,6.3162084,1.8,10.3872457,6.2836776,-0.0655947,3.3466796,3.9626374,78.4870628,103.5876522,0.0131792,26.1410881,23.4522187,44.991508,6.6397737,7.9255558,3.0071151,25.5405366),(8464,'lesser-mouse-deer-femur-cleaned.tif',183,7,126,18.4362417,10.3783307,6.3519712,1.8,10.3791353,6.3160583,-0.0907712,3.3544997,3.9420434,78.0986948,105.0507051,0.0252478,26.6487949,23.2817716,45.4031521,6.63368,7.9713411,3.0078921,25.5946633),(8465,'lesser-mouse-deer-femur-cleaned.tif',183,7,127,18.4664649,10.3541132,6.3859515,1.8,10.3645788,6.362018,-0.0883108,3.3271057,3.9749095,77.8646297,106.7810246,0.0239404,26.8637626,23.4031128,45.474736,6.6065382,7.9974055,3.1069245,26.4459633),(8466,'lesser-mouse-deer-femur-cleaned.tif',183,7,128,18.5646892,10.3334743,6.4036741,1.8,10.3511211,6.3765769,-0.1081865,3.3355703,4.0041912,78.2549785,108.946478,0.0360734,27.2081108,23.460749,45.6780011,6.6131612,8.0458331,3.0264967,26.0949366),(8467,'lesser-mouse-deer-femur-cleaned.tif',183,7,129,18.6036894,10.3089776,6.4275093,1.8,10.3373706,6.4188963,-0.1398996,3.3446864,3.9978816,78.6394356,110.7842817,0.0602901,27.7107457,23.5117515,45.7208179,6.6240204,8.1009563,3.0788181,26.45525),(8468,'lesser-mouse-deer-femur-cleaned.tif',183,7,130,18.8170791,10.289622,6.4689065,1.8,10.3177423,6.4721996,-0.1532081,3.3486206,4.0476564,79.6886615,113.8644766,0.0730405,28.1309638,23.7974587,46.2845821,6.6406062,8.1647309,3.0509328,26.7707233),(8469,'lesser-mouse-deer-femur-cleaned.tif',183,7,131,18.983849,10.2592116,6.4988095,1.8,10.2920328,6.5156792,-0.1746553,3.3787708,4.0707311,80.9784434,117.2807924,0.095538,28.8107444,23.9668353,46.4475435,6.6862854,8.2341051,0.0505188,27.1898066),(8470,'lesser-mouse-deer-femur-cleaned.tif',183,7,132,19.8416542,10.2084547,6.5084315,1.8,10.2069749,6.4960642,-0.1928524,3.4212589,4.0926678,84.1332745,122.4541233,0.1214748,29.9203669,24.5913207,47.6420458,6.7250946,8.2883624,3.0746537,27.5211333),(8471,'lesser-mouse-deer-femur-cleaned.tif',183,7,133,20.0857233,10.2075051,6.5210317,1.8,10.2251266,6.4930025,-0.1858303,3.470503,4.1538771,86.2242632,126.0739426,0.1142784,30.3509081,24.8448896,48.1381253,6.7888627,8.3684513,3.1029379,28.0214066),(8472,'lesser-mouse-deer-femur-cleaned.tif',183,7,134,20.4935725,10.2278468,6.5916934,1.8,10.2577448,6.5698375,-0.1951444,3.4710236,4.2499868,90.1271471,131.5984858,0.1284278,30.964446,25.9655816,49.0392872,6.8418297,8.4811926,3.010481,28.1343033),(8473,'lesser-mouse-deer-femur-cleaned.tif',183,7,135,20.9821776,10.2332474,6.6583378,1.8,10.2655084,6.6580778,-0.1560558,3.4509323,4.2991564,95.8165694,137.7632525,0.0844755,32.044252,27.7654157,50.0487918,6.9515921,8.6246875,3.0072712,29.1031433),(8474,'lesser-mouse-deer-femur-cleaned.tif',183,7,136,21.1616832,10.2005406,6.7698759,1.8,10.213288,6.7832289,-0.1340672,3.5954859,4.3686805,100.6775174,145.3233959,0.0630145,33.2648256,28.001088,50.4234937,7.0705899,8.7758113,3.0414002,30.4864233),(8475,'lesser-mouse-deer-femur-cleaned.tif',183,7,137,22.0885037,10.1940441,6.8931367,1.8,10.2241726,6.9181329,-0.1314928,3.760175,4.545882,110.8965142,156.9687454,0.063287,34.5298765,29.4923815,52.5538909,7.2926524,8.997146,0.7309067,34.0892266),(8476,'lesser-mouse-deer-femur-cleaned.tif',183,7,138,23.6798874,10.0924242,7.0359006,1.8,10.1552092,7.1343554,-0.2390875,4.5861138,4.8829371,125.3200845,175.3972146,0.2213354,35.9204329,27.3259865,54.0158158,8.0134718,9.5159664,2.4008383,35.61711),(8477,'lesser-mouse-deer-femur-cleaned.tif',183,7,139,25.0694178,10.0485628,7.1603911,1.8,10.0781901,7.2973096,-0.3311572,5.1582524,5.7171802,137.7088662,191.9850297,0.4416999,33.5803708,26.6968067,45.5286095,8.5095249,10.195242,0.9010093,41.25928),(8478,'lesser-mouse-deer-femur-cleaned.tif',183,7,140,26.2461274,10.0025658,7.2145289,1.8,10.0252885,7.3308156,-0.3898364,5.4463357,6.0595719,147.3938673,206.6522743,0.63178,34.1034444,27.062942,49.6984092,8.9254901,10.3918168,0.8105501,44.4561333),(8479,'lesser-mouse-deer-femur-cleaned.tif',183,7,141,26.9640912,9.9896111,7.3003069,1.8,9.9716303,7.3878231,-0.4608873,5.5298822,6.2202151,161.7579373,224.3052178,0.8888998,36.060685,29.2516061,56.3288888,9.4015549,11.0557092,1.1258381,46.5871033),(8480,'lesser-mouse-deer-femur-cleaned.tif',183,7,142,27.8736514,9.9164249,7.3981507,1.8,9.9413176,7.4615241,-0.4595621,5.6137228,5.9703357,173.7862682,242.0591247,0.9139846,40.5436373,30.9574013,61.9764836,9.0109783,10.9044724,0.8543577,42.53895),(8481,'lesser-mouse-deer-femur-cleaned.tif',183,7,143,28.6674524,9.995931,7.5366782,1.8,9.9999464,7.5587322,-0.4453863,5.6380258,6.1094637,184.4832934,260.5696508,0.8867523,42.6501679,32.7212576,70.1056045,9.5614024,11.1998558,0.9140947,44.4112933),(8482,'lesser-mouse-deer-femur-cleaned.tif',183,7,144,28.5014206,10.0098087,7.658455,1.8,10.0451451,7.7172113,-0.4145028,5.7908927,6.2892046,198.7311349,267.2091306,0.7704665,42.4869515,34.3178755,70.4611152,9.9895393,11.2399008,0.8639534,42.7256733),(8483,'lesser-mouse-deer-femur-cleaned.tif',183,7,145,27.7957367,10.0531401,7.7165682,1.8,10.1006685,7.7322423,-0.3425897,5.9335586,6.4112523,210.3061515,265.4172159,0.5227786,41.3986542,35.4435113,70.0969315,10.0942377,11.6918865,2.1905865,46.0130033),(8484,'lesser-mouse-deer-femur-cleaned.tif',183,7,146,28.3250618,10.0830773,7.8089801,1.8,10.1068236,7.8354339,-0.2853856,6.2093792,6.5405997,224.6170212,273.1605788,0.3741634,41.7638427,36.1738292,71.1717199,10.4572629,12.3318523,2.0880837,51.8670366),(8485,'lesser-mouse-deer-femur-cleaned.tif',183,7,147,28.7415831,10.0878882,7.9194402,1.8,10.1175713,7.9541804,-0.2982976,6.3756709,6.6940247,238.4275557,279.5691492,0.4137511,41.7639855,37.3964653,71.1909111,10.770944,12.7502793,2.0944368,55.3326),(8486,'lesser-mouse-deer-femur-cleaned.tif',183,7,148,28.7211713,9.9709055,8.062258,1.8,10.0219879,8.0387824,-0.4580801,6.879014,7.0782799,247.1946521,297.6084889,0.9361412,42.0453121,35.9346053,73.9385823,10.890264,12.9969887,2.0471619,56.4340366),(8487,'lesser-mouse-deer-femur-cleaned.tif',183,7,149,28.9018172,10.0154968,8.2312498,1.8,10.0254254,8.2155094,-0.5624225,7.0275552,7.3917492,272.0332814,313.56919,1.3696658,42.4215138,38.7095191,78.2410828,10.9108027,13.4937222,0.9704487,49.4085866),(8488,'lesser-mouse-deer-femur-cleaned.tif',183,7,150,30.1055716,9.8400911,8.2260572,1.8,9.771393,8.062137,-0.6862425,7.5276483,7.73152,289.9584642,348.2829,2.0145292,45.0471447,38.51913,82.3969734,11.3013161,13.5290293,0.9430043,48.7729966),(8489,'lesser-mouse-deer-femur-cleaned.tif',183,7,151,30.4689917,9.7037197,8.3971748,1.8,9.5655886,8.2137807,-0.8010369,6.6716665,7.8798304,297.6584779,383.9475794,2.6184856,48.7253608,44.6153115,86.4680513,11.4190146,14.4289042,0.9721369,52.1778666),(8490,'lesser-mouse-deer-femur-cleaned.tif',183,7,152,33.0243918,9.9104304,8.6884237,1.8,9.7809139,8.5421718,-0.9954791,7.5399884,10.1353515,385.2641616,425.4100153,3.8746097,41.972892,51.0961214,79.5228811,12.0307658,14.9048532,0.9638794,56.0644366),(8491,'lesser-mouse-deer-femur-cleaned.tif',183,7,153,39.8008766,10.4522489,9.8821757,1.8,10.2816312,9.8082434,1.1202362,8.6710517,8.547623,502.6992837,707.8028866,5.3755464,82.8069846,57.9744303,123.1001934,13.1025381,16.3869388,2.0167913,62.4542966),(8492,'lesser-mouse-deer-femur-cleaned.tif',183,7,154,42.7665153,10.0140956,10.677577,1.8,9.9808195,10.7667337,-1.4740372,7.4760961,8.9857537,614.2001249,846.574215,7.0612282,94.212933,82.1551936,154.2623112,13.8138,18.2087792,1.1332495,89.0692066),(8493,'lesser-mouse-deer-femur-cleaned.tif',183,7,155,42.111958,9.8683421,10.6404706,1.8,9.7996593,10.8818662,-1.4745728,7.809777,8.8702157,598.1400664,937.3334399,6.9538745,105.6720013,76.5886232,159.7009316,14.0960642,18.2863895,1.1184477,72.8509866),(8494,'lesser-mouse-deer-femur-cleaned.tif',183,7,156,43.2684601,9.7473397,11.0122212,1.8,9.7164004,11.1626674,-1.4110196,8.1238164,9.2400519,634.6917232,995.4934322,7.028874,107.7367792,78.1272859,168.2625231,14.3749721,18.5588914,1.0837677,83.4026933),(8495,'lesser-mouse-deer-femur-cleaned.tif',183,7,157,47.8537499,9.6511675,11.4068877,1.8,9.707438,11.5871777,-1.3725539,9.0512478,9.61945,672.624586,1075.7495851,7.666267,111.8306745,74.3129122,175.4126824,14.2151259,18.7087184,1.0740117,73.2747133),(8496,'lesser-mouse-deer-femur-cleaned.tif',183,7,158,48.6978921,9.6354565,11.6040115,1.8,9.6801781,11.7406822,-1.3967233,8.9686836,9.6426701,707.3245136,1062.1583157,7.8728536,110.1518877,78.8660345,177.7494693,14.1242461,18.6496988,1.0694725,76.5601199),(8497,'lesser-mouse-deer-femur-cleaned.tif',183,7,159,45.7652195,9.740151,11.6213659,1.8,9.7679424,11.7585843,-1.4400192,8.5399349,9.4268462,703.0422461,1032.0726764,7.4978275,109.4822862,82.3240759,180.698409,13.981478,18.5648709,1.0726413,83.8515599),(8498,'lesser-mouse-deer-femur-cleaned.tif',183,7,160,46.0572127,9.6287997,11.673747,1.8,9.7265121,11.7452705,-1.402862,8.553334,9.2891277,699.0092822,998.8258991,7.4617458,107.5263398,81.7236038,175.5374158,14.4137684,18.3667517,1.0610103,76.1495266),(8499,'lesser-mouse-deer-femur-cleaned.tif',183,7,161,46.1670728,9.9127415,11.7152003,1.8,10.0197722,11.8450317,-1.5023834,8.6598704,8.8384829,698.613073,940.7331396,7.6585554,106.4360421,80.6724624,151.692921,14.4798446,18.8788486,2.2015717,90.8835766),(8500,'lesser-mouse-deer-femur-cleaned.tif',183,7,162,44.5268797,9.8778775,11.8022366,1.8,10.0426735,11.9677303,1.5371645,8.0343941,8.3992828,684.5837202,881.1450872,7.4127557,104.9071824,85.206639,145.3541197,14.3998121,18.6093692,2.2152905,92.9256633),(8501,'lesser-mouse-deer-femur-cleaned.tif',183,7,163,43.6810165,9.9650148,11.8250981,1.8,10.0749676,11.909684,1.5594317,7.9054438,8.1515075,628.5136955,773.993644,7.2792292,94.9509824,79.5039105,138.0932142,13.9228436,17.5063865,1.0516502,70.1590499),(8502,'lesser-mouse-deer-femur-cleaned.tif',183,7,164,41.5171249,9.976322,11.8347179,1.8,10.0453769,11.9070903,-1.4356409,7.2343984,8.0264221,554.2134829,657.9920615,6.7938897,81.9782526,76.6080951,126.9362158,12.7724657,16.4415538,1.040497,61.4004199),(8503,'lesser-mouse-deer-femur-cleaned.tif',183,7,165,40.2860824,9.9996082,11.9536876,1.8,10.0422058,11.9738119,-1.2419488,7.7885012,8.764827,493.4239607,538.7402722,6.0140517,61.4661617,63.3528769,109.4747991,12.1784751,15.7690285,1.0153026,61.3733566),(8504,'lesser-mouse-deer-femur-cleaned.tif',183,7,166,37.5130136,9.900178,11.9896936,1.8,9.9074267,11.9328633,-0.5417229,8.5391571,8.7821689,378.5465345,465.7469762,1.6621814,53.0332521,44.3306677,85.1363144,11.8517611,14.9676592,0.9964915,55.5939466),(8505,'lesser-mouse-deer-femur-cleaned.tif',183,7,167,34.0319593,9.7161776,12.2918894,1.8,9.7471245,12.1009365,-0.43498,6.2744965,9.1412204,254.5553592,411.3777965,1.0071841,45.0025027,40.5698467,68.3172803,10.9387175,14.2429437,0.951301,52.4055833),(8506,'lesser-mouse-deer-femur-cleaned.tif',183,7,168,28.1183459,9.4225268,12.5833026,1.8,9.5016708,12.421606,-0.3703084,5.5453822,8.8324251,156.5462034,327.8299037,0.6137941,37.1166356,28.2300114,51.399181,0.440282,1.7168755,1.9862884,4.1572033),(8507,'lesser-mouse-deer-femur-cleaned.tif',183,7,169,20.2051856,8.8266026,12.934017,1.8,8.9835384,12.7406703,-0.3348227,4.6228052,8.4737332,73.466732,215.0209677,0.3636228,25.3749985,15.8922404,32.6089825,0.6207494,2.1551198,2.1112158,5.37618),(8508,'lesser-mouse-deer-femur-cleaned.tif',183,7,170,9.8187865,6.9630516,13.3127037,1.8,6.9414513,13.1209973,-0.5561441,4.3489728,7.5684476,10.7655809,73.7684283,0.4560738,9.7468375,2.4754307,11.0703944,0.6006,3.23433,1.5850811,7.4294767),(8509,'lesser-mouse-deer-femur-cleaned.tif',183,7,171,3.1442889,6.3847502,13.6796885,1.8,6.3957695,13.721922,-0.887245,1.0407198,1.5530039,0.5845406,1.2570351,0.3150284,0.8094218,0.5616695,1.1848878,1.976353,2.9873222,0.8839787,9.8012967),(8510,'lesser-mouse-deer-femur-cleaned.tif',183,7,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8511,'lesser-mouse-deer-femur-cleaned.tif',183,7,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8512,'lesser-mouse-deer-femur-cleaned.tif',183,7,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8513,'lesser-mouse-deer-femur-cleaned.tif',183,7,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8514,'lesser-mouse-deer-femur-cleaned.tif',183,7,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8515,'lesser-mouse-deer-femur-cleaned.tif',183,7,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8516,'lesser-mouse-deer-femur-cleaned.tif',183,7,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8517,'lesser-mouse-deer-femur-cleaned.tif',183,7,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8518,'lesser-mouse-deer-femur-cleaned.tif',183,7,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8519,'lesser-mouse-deer-femur-cleaned.tif',183,7,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8520,'lesser-mouse-deer-femur-cleaned.tif',183,7,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8521,'lesser-mouse-deer-femur-cleaned.tif',183,7,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8522,'lesser-mouse-deer-femur-cleaned.tif',183,7,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8523,'lesser-mouse-deer-femur-cleaned.tif',183,7,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8524,'lesser-mouse-deer-femur-cleaned.tif',183,7,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8525,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,1,0.0353398,9.9349005,10.0949321,1.8,9.9369266,10.0916463,-1.0755499,0.3865146,4.7830456,0.0005232,0.2833017,0.0045597,0.0592304,0.0013535,0.059147,0,0,0,0),(8526,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,2,0.9554402,11.090708,10.6896064,1.8,10.9023589,10.7883156,-0.9997917,2.429831,5.7540963,0.3636359,3.6086672,0.1127235,0.6271475,0.1496548,0.686809,0.8890934,1.4568987,2.7744188,4.5581377),(8527,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,3,5.9059902,11.147751,11.5580082,1.8,11.0146289,11.6126796,-1.1029253,3.0754536,5.1964906,2.2698678,28.4123679,0.784129,5.4676069,0.7380595,5.6428079,0,0,0,0),(8528,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,4,8.1932195,10.6651413,12.1415484,1.8,10.546144,12.1181303,-1.1671929,5.0908069,4.8517979,10.5440835,43.2256729,1.1549154,8.9092073,2.0712008,9.7965619,0,0,0,0),(8529,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,5,12.3022523,9.7098226,12.2716456,1.8,9.7523137,12.3175946,-0.7771709,3.7980974,4.536909,40.3976938,75.2986095,1.0083195,16.5968967,10.6362976,23.5607275,1.3362139,2.9446122,0.5830765,7.8895439),(8530,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,6,20.486003,9.2265815,12.3856225,1.8,9.3545445,12.4339318,-0.5240526,3.2835896,4.4869455,66.4536191,116.12958,0.8549259,25.881656,20.2381011,37.3684976,6.433086,9.2120095,1.0410872,50.2738488),(8531,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,7,27.2637334,9.0443412,12.3610394,1.8,9.1214587,12.3861766,-0.5512198,3.3996567,4.6648399,79.1678008,158.8775336,1.2463603,34.0585182,23.2869986,47.120915,6.6123797,9.1685563,1.1096997,34.9573862),(8532,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,8,28.1819289,9.2087558,12.0591536,1.8,9.2042033,12.0445326,-0.6120498,3.321699,4.5211371,78.0736433,157.6175339,1.5504925,34.8623656,23.5041296,50.4695803,6.5804702,9.1142487,1.0480915,29.8381823),(8533,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,9,25.8374858,9.2658678,11.8618936,1.8,9.1948722,11.8972198,-0.7150799,3.5021609,4.9278714,70.6623657,148.9064188,1.8513131,30.2171887,20.1767901,43.8279192,6.609655,8.9603449,1.0313778,28.9020457),(8534,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,10,24.5508668,9.1084437,11.9520624,1.8,9.0633944,11.9057068,-0.7799774,3.6020928,4.8926764,66.3995888,140.8287146,2.0237251,28.7835743,18.4336141,42.073891,6.486329,9.0060178,0.6411782,28.2490703),(8535,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,11,21.3748245,8.9689777,12.0396441,1.8,8.9534372,11.932032,-0.7950058,3.5190402,4.6152948,57.7058718,127.0935186,1.8154601,27.537465,16.3981847,39.6007223,6.2699831,8.927469,0.8933107,28.4762151),(8536,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,12,19.3522991,8.8847204,11.9511164,1.8,8.8869577,11.8550111,-0.8012183,3.3302784,4.377475,52.5132309,109.3065591,1.663709,24.9702302,15.7684206,35.5249533,6.0433744,8.4854411,1.0409473,27.5527685),(8537,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,13,18.6795489,8.900889,11.8318313,1.8,8.9042048,11.7827711,-0.8206895,3.2461595,4.2022871,48.7728787,100.8606085,1.6664088,24.0013604,15.0247941,35.1651069,5.8325231,8.2181983,0.8304128,24.9102305),(8538,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,14,17.3773262,8.8738738,11.7803096,1.8,8.875224,11.7604755,-0.8395675,3.1469659,3.9673086,44.3286539,90.7309504,1.6046901,22.869648,14.0861565,33.5876529,5.6659271,7.9471324,1.0394059,23.4869905),(8539,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,15,16.9007255,8.8513079,11.6939224,1.8,8.839112,11.7238747,-0.850136,3.0435512,3.8222772,42.2880075,84.6084473,1.5902375,22.1356127,13.8942978,32.5419766,5.5145844,7.7680333,1.0800469,22.8593951),(8540,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,16,16.7283583,8.8023542,11.6477928,1.8,8.7686396,11.6532831,-0.8398671,6.5989884,3.7419322,39.9678686,76.8973458,1.5455924,20.5501706,6.056666,17.7072539,5.4359482,7.5255128,1.0387199,22.3722917),(8541,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,17,17.2465854,8.7961977,11.5882704,1.8,8.764407,11.5936153,-0.8428625,2.8834693,3.6290112,38.2487007,74.1595944,1.6020293,20.4352068,13.2648199,30.4107073,5.3433039,7.3460016,1.129438,22.0711841),(8542,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,18,16.7924521,8.7749111,11.5505355,1.8,8.7427268,11.5619729,-0.872283,2.8538145,3.5703804,36.6899634,69.4108854,1.6413174,19.4407533,12.8564638,29.5065743,5.2612066,7.1818244,1.1266902,21.5228079),(8543,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,19,15.749478,8.7786692,11.4981699,1.8,8.7679637,11.5201998,-0.8834498,2.8429705,3.4946358,34.9871046,65.360575,1.5681871,18.703115,12.306531,28.4042114,5.1884457,7.0061965,0.9765826,21.1529938),(8544,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,20,15.6487439,8.7670267,11.4488849,1.8,8.7617992,11.4662217,-0.8993199,2.8364432,3.3823237,33.8694634,62.2772443,1.5986199,18.4125619,11.9408222,27.6956747,5.1509476,6.8705849,1.0355987,20.6785804),(8545,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,21,15.6626044,8.7698548,11.4186418,1.8,8.7603534,11.4298157,-0.9148521,2.8193021,3.3272998,33.0027848,59.6595761,1.6393853,17.9303277,11.706012,27.0199628,5.0885418,6.7652739,1.1486474,20.4873284),(8546,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,22,15.3937428,8.7689306,11.3829531,1.8,8.760224,11.3864924,-0.9191948,2.8034707,3.2864044,32.0694924,56.608148,1.6220015,17.2249488,11.4392106,26.3179448,5.0652061,6.6961889,1.152572,20.1608407),(8547,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,23,15.2525502,8.7668859,11.3656525,1.8,8.753519,11.3648934,-0.9485838,2.8069886,3.2471163,31.0960292,54.1639747,1.6785532,16.6806389,11.0780747,25.5410302,5.0167796,6.6224612,1.1389401,19.9030594),(8548,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,24,14.9631224,8.7631333,11.3509294,1.8,8.7472985,11.3570598,-0.967223,2.8013666,3.2200276,30.037808,51.8282097,1.6904432,16.0955792,10.7225551,24.9033087,4.9866574,6.5263548,1.1932661,19.6991174),(8549,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,25,14.8846385,8.7735248,11.3224351,1.8,8.7576642,11.3246578,-0.9685846,2.778444,3.1876915,29.3588732,50.011407,1.684732,15.6889105,10.5666602,24.3669855,4.9490515,6.4557725,1.1180179,19.5385017),(8550,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,26,14.8091812,8.7757562,11.3030596,1.8,8.7589357,11.3027361,-0.9747741,2.7615073,3.1480747,28.837313,48.3113078,1.6904201,15.346303,10.4425989,23.9227684,4.9490515,6.3728319,1.1659045,19.212014),(8551,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,27,14.6695819,8.7842906,11.2742567,1.8,8.7658077,11.2791995,-0.9887508,2.7453602,3.125433,28.1983652,46.7424918,1.7060546,14.9555252,10.2712805,23.4722172,4.9049466,6.3193864,1.1441688,19.1507412),(8552,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,28,14.506484,8.7690219,11.2607444,1.8,8.7532256,11.2595473,-1.0004072,2.728482,3.0915476,27.5908701,45.4735681,1.7128376,14.7089982,10.1121686,23.104531,4.9022721,6.2501868,1.1483239,18.8855263),(8553,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,29,14.4654917,8.7571275,11.250258,1.8,8.7420042,11.2355628,-1.0105642,2.7163897,3.0615253,27.1710776,44.5289595,1.7301506,14.5446975,10.0026433,22.9244881,4.9060949,6.2199172,1.2277724,18.7682371),(8554,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,30,14.464123,8.7589799,11.2338648,1.8,8.7403686,11.2254779,-1.025763,2.6967028,3.0619812,26.9098216,43.686043,1.7627262,14.2672472,9.9787866,22.6653513,4.8930312,6.1875107,1.1714539,18.8115635),(8555,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,31,14.3056497,8.7611328,11.2287927,1.8,8.7512027,11.2181575,-1.0362927,2.6634342,3.0519226,26.5434648,42.7182263,1.7655495,13.9971524,9.9658798,22.4609267,4.8762275,6.1580435,1.2060615,18.7502907),(8556,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,32,14.2026803,8.7591583,11.2265253,1.8,8.7448244,11.2129876,-1.0416547,2.6778883,3.0059372,26.3333964,41.9506796,1.7639361,13.9559399,9.8336425,22.4439103,4.9013165,6.1121223,1.156916,18.4470057),(8557,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,33,14.2579078,8.7604674,11.2266545,1.8,8.7509944,11.2164908,-1.0599338,2.6554992,3.0198154,26.2586141,41.3255814,1.8082534,13.684804,9.8883908,22.3732032,4.8896279,6.0654025,1.0569978,18.5030222),(8558,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,34,14.3861668,8.7518474,11.2326671,1.8,8.7409912,11.2253981,-1.0673098,2.6358169,3.0080241,26.1293572,41.1582558,1.8395371,13.682821,9.9131914,22.3321635,4.906598,6.0310322,1.1886796,18.3117701),(8559,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,35,14.2971357,8.7559339,11.2246393,1.8,8.7504962,11.2147752,-1.0738802,2.631063,3.0110753,26.0117629,40.2897366,1.8413304,13.3805146,9.8864084,22.0042751,4.9027786,6.0380578,1.1420183,18.4417494),(8560,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,36,14.4399581,8.7536367,11.2243995,1.8,8.7480718,11.2167464,-1.0690767,2.6036476,2.995152,26.1985085,39.8227813,1.8500054,13.2957464,10.062233,21.9742861,4.899637,6.0053531,1.2242575,18.3677865),(8561,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,37,14.3988487,8.7526617,11.2308828,1.8,8.7496277,11.2230116,-1.0640167,2.6055085,3.0168813,26.163473,39.2800867,1.8344653,13.0200968,10.0415995,21.6688606,4.8965881,5.9688044,1.1463443,18.4290594),(8562,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,38,14.4863433,8.7512665,11.2257749,1.8,8.7507766,11.2161559,-1.06413,2.5764405,3.0131082,26.3146348,38.944884,1.8458445,12.925153,10.2135621,21.6180489,4.9064327,5.9541221,1.1739782,18.1511545),(8563,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,39,14.5234082,8.7482347,11.2216345,1.8,8.7459111,11.2109929,-1.0636001,2.5767984,3.0362922,26.4790255,38.593407,1.8494785,12.7107027,10.2759399,21.4225494,4.9303318,5.9474572,1.1543577,18.1638445),(8564,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,40,14.6715948,8.7501314,11.2167892,1.8,8.7434973,11.2091902,-1.0577156,2.5701198,3.0048973,26.7650773,38.4886515,1.8560861,12.8086412,10.4139414,21.688533,4.9322571,5.9430866,1.1347008,18.1691008),(8565,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,41,14.7248243,8.7488711,11.2157208,1.8,8.7411445,11.208035,-1.0567366,2.5801261,2.9964,27.0169287,38.1725412,1.8607639,12.7394676,10.4711661,21.7276883,4.9380448,5.9031415,1.0516502,18.107828),(8566,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,42,14.819615,8.7477527,11.2190867,1.8,8.7411727,11.2111213,-1.0597326,2.5750275,3.0083626,27.2768363,37.9757088,1.8790679,12.6233817,10.5928329,21.6656852,4.974615,5.8978105,1.0714496,18.1691008),(8567,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,43,14.9508727,8.7430167,11.2200877,1.8,8.7384065,11.2184196,-1.0619002,2.566157,2.9916572,27.6825637,37.7160686,1.900313,12.6070822,10.7875565,21.8555867,4.9783565,5.8729462,1.0792675,18.1384644),(8568,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,44,14.9897196,8.7345507,11.21992,1.8,8.7280808,11.2169917,-1.0702569,2.5554328,2.9795179,27.9197605,37.5816077,1.922924,12.6133183,10.9256485,21.9530415,5.0113585,5.865956,1.0273187,18.095138),(8569,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,45,15.0642736,8.7285901,11.2304168,1.8,8.7214114,11.2251859,-1.0783422,2.5603159,2.947494,28.2803666,37.3816226,1.9494922,12.68251,11.045655,22.1438543,5.0167725,5.8212548,1.0226728,18.1384644),(8570,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,46,15.1327474,8.7207697,11.2396409,1.8,8.7139106,11.2334884,-1.0908305,2.5603943,2.9550112,28.7025763,37.1713799,1.9843773,12.5790996,11.2102172,22.1255649,5.035515,5.8390826,1.0349851,17.9651588),(8571,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,47,15.2431704,8.7133964,11.258175,1.8,8.7063916,11.2511192,-1.0969712,2.5617702,2.9236621,29.100859,37.0045497,2.0115813,12.6569175,11.3596682,22.4710811,5.0526527,5.7588976,0.9727185,18.2176836),(8572,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,48,15.3058982,8.7102721,11.276512,1.8,8.7063719,11.2738854,-1.120965,2.5910832,2.9138806,29.5576794,36.8911441,2.0686867,12.660486,11.4074607,22.5396488,5.0946692,5.7638825,0.9399987,18.3782993),(8573,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,49,15.4450229,8.6999282,11.2907042,1.8,8.6970845,11.2864786,-1.153098,2.6218763,2.8969328,30.0068461,36.9727615,2.1505695,12.7627265,11.4447988,22.8630495,5.1380458,5.7674405,1.0381527,17.9831052),(8574,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,50,15.3677374,8.6850756,11.295123,1.8,8.6808942,11.3012633,-1.1589105,2.6290186,2.8629479,30.364639,36.584767,2.1507902,12.7787051,11.5497999,23.0474023,5.1693326,5.7331923,0.9473655,18.2737001),(8575,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,51,15.5440986,8.6749586,11.314382,1.8,8.6711347,11.313928,-1.1999504,2.6755829,2.8622797,30.8372645,36.8560632,2.2504314,12.8764715,11.5254378,23.2927684,5.1776617,5.7028166,0.9548112,17.9831052),(8576,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,52,15.7103326,8.6621343,11.329038,1.8,8.6583784,11.3300203,-1.2268018,2.6938051,2.8449793,31.3185839,36.9858257,2.3205792,13.0003846,11.6261507,23.5611786,5.1776617,5.6958577,1.0414,18.3476629),(8577,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,53,15.7962364,8.6560658,11.3375416,1.8,8.6584255,11.3421396,-1.2645206,2.7202132,2.8395606,31.8080781,37.0897726,2.3933716,13.0618,11.69323,23.8979717,5.2020228,5.6852831,1.0824624,18.2610101),(8578,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,54,15.8195684,8.6474688,11.3495049,1.8,8.6486306,11.3475228,-1.2961504,2.7769826,2.8401771,32.1245713,36.9821308,2.4426659,13.0210651,11.5681572,24.0853642,5.2049969,5.6609349,1.0906213,18.3656093),(8579,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,55,15.8743309,8.6350528,11.3581239,1.8,8.638371,11.3577651,-1.3356231,2.774169,2.8228788,32.5959683,37.0675255,2.5020741,13.1311079,11.7498136,24.3052649,5.2079822,5.6775802,1.028797,18.3782993),(8580,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,56,15.8429162,8.6218944,11.3739517,1.8,8.6223803,11.3709373,-1.4010584,2.7818318,2.8138241,32.8373201,37.1801987,2.5651389,13.2134053,11.8042077,24.3072012,5.2073231,5.6775802,1.028797,18.3962457),(8581,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,57,15.8225835,8.6099745,11.3911174,1.8,8.6114575,11.391026,-1.4557538,2.7810807,2.7996909,32.9870555,37.4623063,2.6023495,13.3808723,11.8612363,24.6528144,5.2035535,5.6398774,1.2402483,18.3529193),(8582,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,58,15.9133567,8.5956287,11.409966,1.8,8.6034001,11.4164,-1.5039865,2.7709478,2.7975327,33.3258804,37.8690455,2.6404054,13.5365871,12.0268886,24.811681,5.2073231,5.6720372,0.9955808,18.4702085),(8583,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,59,15.9965151,8.5852479,11.4257872,1.8,8.5932387,11.4261117,-1.5539786,2.7365122,2.7558402,33.6450192,38.2863161,2.6653318,13.8927926,12.2948546,24.8456821,5.2313515,5.6775802,1.028797,18.23563),(8584,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,60,16.0061436,8.5744763,11.441531,1.8,8.5762457,11.4460626,1.540441,2.7571989,2.7568556,33.8742951,38.6449826,2.6652332,14.0177753,12.2857643,25.2692968,5.2006103,5.6640747,1.0699758,18.3835557),(8585,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,61,16.0439109,8.5624695,11.4509174,1.8,8.5598365,11.4534397,1.4855677,2.7207218,2.7623335,34.1346654,39.0949288,2.6546085,14.1528634,12.5461798,25.5060255,5.2076253,5.6602101,1.0161147,18.5568613),(8586,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,62,16.1111464,8.5452548,11.4663589,1.8,8.5435963,11.4666584,1.4531839,2.6950257,2.7900683,34.5660604,39.5719508,2.6482186,14.1831478,12.825874,25.6139888,5.2119219,5.6879286,1.0082984,18.5874978),(8587,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,63,16.1807509,8.5319332,11.4810981,1.8,8.5254874,11.4809073,1.4269296,2.7170614,2.7975078,34.9213278,40.1249684,2.6413587,14.3431121,12.8526091,25.5841889,5.2428707,5.6893711,1.0619121,18.7354234),(8588,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,64,16.1870028,8.5303885,11.4987666,1.8,8.5230771,11.5014403,1.4097306,2.7161681,2.8163553,35.2441933,40.6921633,2.6284492,14.448519,12.975704,25.6972795,5.2582398,5.7224477,1.0335116,18.8093862),(8589,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,65,16.3365814,8.517647,11.5174827,1.8,8.5125234,11.5222811,1.3883736,2.7127239,2.8446511,35.6934221,41.3459435,2.6331559,14.5346274,13.1577794,26.1996009,5.2671063,5.7303291,1.1071487,18.8400226),(8590,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,66,16.4482595,8.5075484,11.5395613,1.8,8.5011647,11.5420681,1.3800926,2.7181022,2.8685255,36.2105541,42.1242637,2.6428812,14.6849883,13.3219985,26.4833582,5.2759382,5.7410589,1.9732958,18.9012954),(8591,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,67,16.5469378,8.4987924,11.5606638,1.8,8.4922792,11.560263,1.3596306,2.709925,2.9179784,36.6088774,42.9773301,2.636666,14.7284608,13.5091847,26.6870284,5.3019861,5.8005435,2.0384762,19.0492211),(8592,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,68,16.6365579,8.4920003,11.5832465,1.8,8.4896462,11.5813018,1.3265576,2.7147748,2.9516593,37.1101006,43.8780277,2.6106203,14.8655462,13.6696791,26.9108617,5.3255352,5.8472746,2.0344439,19.0619111),(8593,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,69,16.6903301,8.4872055,11.6093878,1.8,8.4792766,11.6066259,1.3269084,2.7167498,2.9778718,37.5143177,44.6947663,2.6195159,15.0089625,13.8085287,27.249896,5.3526063,5.8892245,1.915015,19.1231839),(8594,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,70,16.7535484,8.4740017,11.6219312,1.8,8.4678043,11.6191433,1.3174901,2.7117876,2.9978762,38.0568008,45.4145062,2.6168948,15.1488932,14.033843,27.3360553,5.3647863,5.905921,1.971037,18.9805146),(8595,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,71,16.7375169,8.4694961,11.6411232,1.8,8.4614662,11.6396706,1.3101131,2.7280931,3.0234845,38.4760726,46.115596,2.6042731,15.2524662,14.1036511,27.6095912,5.4000673,5.9541221,1.9676145,19.4317252),(8596,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,72,16.7156757,8.4641467,11.6693145,1.8,8.4570273,11.6616202,1.2966291,2.7356078,3.02623,39.0454155,46.688832,2.5817276,15.4280512,14.273031,27.9550791,5.4187798,5.9653665,2.0148386,19.3757088),(8597,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,73,16.8306463,8.4587494,11.6806766,1.8,8.4569551,11.6672906,1.2903541,2.7398962,3.0479111,39.624547,47.4189509,2.5902154,15.5578526,14.4620614,28.2618912,5.4161759,6.0117263,1.9448408,19.5490145),(8598,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,74,16.7927821,8.4428591,11.7044386,1.8,8.4345886,11.6973753,1.2828581,2.7567457,3.0830189,40.1650796,47.9895885,2.5730955,15.5657783,14.5697442,28.3233273,5.4745139,6.0507285,1.9609332,19.4369816),(8599,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,75,16.7128969,8.4384952,11.7351735,1.8,8.433561,11.7336544,1.274227,2.7611306,3.0667995,40.492007,48.5963102,2.5475892,15.8459365,14.6650099,28.6580493,5.5253971,6.0599885,2.0074235,19.5415808),(8600,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,76,16.7633666,8.4244304,11.762082,1.8,8.4160374,11.7619693,1.2683846,2.7762929,3.0800827,40.8581706,49.4644679,2.5460794,16.0594611,14.7168085,29.1954473,5.5253971,6.064275,1.988145,19.8448657),(8601,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,77,16.8114246,8.4236674,11.7885829,1.8,8.4179016,11.7847527,1.276026,2.7772803,3.095818,41.243703,50.386352,2.565418,16.2756182,14.8503926,29.3716383,5.5768209,6.1190548,1.9655874,20.0361178),(8602,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,78,16.8204636,8.4226913,11.8087013,1.8,8.4220271,11.8035561,1.282146,2.787264,3.1301074,41.7472511,51.0987292,2.5762487,16.3249123,14.9778604,29.5933675,5.5775994,6.1689162,1.8898659,19.7761593),(8603,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,79,16.760566,8.4172691,11.8299497,1.8,8.4122586,11.8226953,1.2831302,2.8006099,3.1315328,42.1122008,51.6586914,2.5685729,16.4962956,15.0367961,29.8465153,5.6193453,6.1822037,2.0836466,19.8680685),(8604,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,80,16.674881,8.4175955,11.8485248,1.8,8.4136087,11.8410892,1.2882157,2.8263683,3.142155,42.4413079,52.1113843,2.5630714,16.5845999,15.0161986,30.0085183,5.6282448,6.2185978,1.8872278,19.9240849),(8605,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,81,16.5619264,8.4135158,11.8717475,1.8,8.4091519,11.866292,1.28756,2.8368155,3.1567505,42.6073166,52.6429635,2.544739,16.6763145,15.0194177,30.1165563,5.6510761,6.2350704,1.8951994,20.0720106),(8606,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,82,16.5654229,8.4060643,11.8984423,1.8,8.4018289,11.8888421,1.2972633,2.8414914,3.1532886,43.0701804,53.2421538,2.559433,16.8846433,15.1575967,30.4036084,5.6875194,6.2464658,2.0119758,19.9599777),(8607,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,83,16.5682611,8.3995323,11.9300049,1.8,8.3965401,11.9234727,1.3076377,2.8745001,3.1776433,43.3900192,53.9535556,2.5745185,16.9791102,15.0948054,30.4423921,5.7006579,6.3013981,1.9004207,20.3192791),(8608,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,84,16.6735737,8.3972157,11.961644,1.8,8.3924932,11.954834,1.3150491,2.8944124,3.1931628,43.9596522,54.8913771,2.6010969,17.1902844,15.1877639,30.91737,5.7351102,6.3180877,1.8820761,20.3551719),(8609,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,85,16.721842,8.3921059,11.9867632,1.8,8.385437,11.9796857,1.320493,2.8984215,3.2068787,44.4228304,55.5951925,2.6159811,17.3362318,15.3265595,31.1642219,5.7341875,6.3509047,1.8977552,20.4111883),(8610,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,86,16.716934,8.3877963,12.0153575,1.8,8.3791936,12.0083853,1.3200073,2.912927,3.2050149,44.8430361,56.1083411,2.6145631,17.5064213,15.3944936,31.4971843,5.734901,6.3577919,1.8457062,20.5157875),(8611,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,87,16.7447063,8.3778919,12.0436632,1.8,8.3698468,12.0338856,1.3165861,2.9083303,3.2327765,45.2348432,56.8145368,2.6142875,17.5745328,15.5535438,31.4871896,5.7521649,6.3839814,1.8873656,20.5337339),(8612,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,88,16.738275,8.3707547,12.0749099,1.8,8.3615842,12.0636696,1.3218989,2.9209533,3.215019,45.6991605,57.4912484,2.6204295,17.8820865,15.6452897,31.8560641,5.7860952,6.4098505,1.9467573,20.6510232),(8613,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,89,16.7380425,8.3765865,12.1065633,1.8,8.3657666,12.0983197,1.335442,2.9644464,3.2585902,46.129445,58.2659963,2.6379813,17.8807375,15.5608971,32.0365884,5.8339402,6.4313641,1.8256366,20.5823167),(8614,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,90,16.7797331,8.3771992,12.1315062,1.8,8.3687114,12.1174234,1.3464386,2.9900988,3.2570295,46.7088992,59.0843876,2.6581966,18.1405747,15.6211894,32.4427941,5.8584471,6.4676249,1.874646,20.6383331),(8615,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,91,16.778628,8.3637773,12.1644093,1.8,8.3477106,12.1490272,1.3537833,2.9965566,3.2663431,47.2574003,59.8361429,2.6667952,18.319001,15.7705683,32.7564912,5.8936723,6.5055758,2.0020811,20.8168952),(8616,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,92,16.8066873,8.3581274,12.1907225,1.8,8.353282,12.1811449,1.3557982,2.9975382,3.2750241,47.8668284,60.7008487,2.6736181,18.5344737,15.9687136,33.0008017,5.9098563,6.519226,1.9229943,20.890858),(8617,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,93,16.7710934,8.3540057,12.2169147,1.8,8.3481985,12.2089226,1.3686543,3.0147213,3.3156148,48.3011098,61.2911183,2.6825144,18.4855967,16.0217498,33.0442157,5.9495216,6.552288,1.8622531,21.0208373),(8618,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,94,16.8616752,8.3444876,12.2380168,1.8,8.3371605,12.2307962,1.3685328,3.0116243,3.3493771,49.0797516,62.3167813,2.6968685,18.605484,16.2967709,33.2047674,5.9495216,6.615436,1.8925469,21.2247793),(8619,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,95,16.8843644,8.3392702,12.2575261,1.8,8.3389319,12.2493033,1.3796152,3.0274362,3.3504221,49.6675227,63.2034625,2.7124532,18.8643285,16.4058033,33.5329418,5.962156,6.6354587,1.9249545,21.2300357),(8620,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,96,17.0534256,8.3349678,12.279399,1.8,8.3337782,12.2725956,1.381198,3.0317265,3.3690582,50.452845,64.4649307,2.7412846,19.1344068,16.6416214,33.9820571,6.0008604,6.6650723,1.8900655,21.2479821),(8621,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,97,17.2258474,8.3376575,12.3026603,1.8,8.3345807,12.2930535,1.3844213,3.0516081,3.4281474,51.286428,65.8223423,2.7723987,19.2005579,16.8063611,34.1125343,6.0144556,6.7245183,1.8384126,21.500507),(8622,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,98,17.4485788,8.335727,12.3249976,1.8,8.3318073,12.318779,1.3827071,3.0615993,3.4362104,52.1601221,67.4313904,2.8064227,19.6237662,17.0368874,34.6370994,6.0563231,6.7701239,1.9340878,21.4138542),(8623,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,99,17.7757889,8.340706,12.340777,1.8,8.3435028,12.3281058,1.3941906,3.0810756,3.4727347,53.3327198,69.1104343,2.871185,19.9008676,17.3097732,35.2442387,6.0667552,6.8130159,1.9898001,21.7477755),(8624,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,100,17.9204148,8.3347789,12.3643221,1.8,8.3385258,12.355907,1.3930427,3.0890648,3.5114426,54.1685569,70.6436593,2.8933555,20.1181302,17.5355848,35.5134164,6.0667552,6.8608243,1.9866987,21.9136475),(8625,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,101,18.0523411,8.3314123,12.3851635,1.8,8.3386204,12.3742974,1.3884122,3.0937425,3.5301428,55.0151482,71.962423,2.9097463,20.385131,17.7827172,35.8006054,6.0667552,6.8989911,1.9189197,21.9876103),(8626,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,102,18.2857045,8.3330957,12.407334,1.8,8.3400451,12.3944342,1.3836419,3.1050395,3.5734923,55.8850362,74.0087884,2.9421098,20.7104935,17.9981726,36.3338962,6.1611376,6.9639052,1.9638543,22.1661724),(8627,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,103,18.4801522,8.3302795,12.4272403,1.8,8.3356048,12.412776,1.3820007,3.1101805,3.596189,56.7288554,75.7584544,2.9715398,21.0663162,18.2397311,36.8383476,6.1713544,7.0046347,1.9776489,22.1407924),(8628,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,104,18.6586538,8.333119,12.4465644,1.8,8.3354572,12.4297504,1.3883825,3.131701,3.6142695,57.6856364,77.3655688,3.0074411,21.4055894,18.4199055,37.2601317,6.1713544,7.0649016,2.014579,22.2401352),(8629,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,105,18.7924637,8.3329086,12.4691336,1.8,8.3370815,12.4601819,1.3847081,3.1384554,3.6668714,58.6146142,78.9405968,3.0248633,21.5280516,18.6762616,37.5015799,6.223654,7.1213947,1.9785811,22.4493337),(8630,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,106,19.0131317,8.3259523,12.4914232,1.8,8.3342275,12.4824589,1.3871099,3.1445859,3.684211,59.8706602,80.5522733,3.063133,21.8641854,19.0392829,37.9755783,6.223654,7.1595096,2.0083061,22.4799701),(8631,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,107,19.2224797,8.3223543,12.5202963,1.8,8.3311191,12.5105378,1.3881745,3.14957,3.6980651,60.8297106,82.1704433,3.0980819,22.2198478,19.3136557,38.5681226,6.223654,7.1901984,1.9823738,22.5539329),(8632,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,108,19.3202474,8.3388922,12.5473313,1.8,8.3438398,12.5342881,1.3880363,3.1798534,3.6970271,61.5240526,83.483545,3.11368,22.5812637,19.3480786,38.9838187,6.2759536,7.2044497,2.0214577,22.7324949),(8633,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,109,19.4180472,8.3492648,12.57366,1.8,8.3570021,12.5625098,1.3874439,3.1488721,3.7246585,62.0294764,84.8730244,3.1287552,22.7867934,19.6989509,39.417917,6.2759536,7.2656945,1.9700171,22.8624742),(8634,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,110,19.6449934,8.3545323,12.6005652,1.8,8.3619295,12.5894342,1.3822419,3.1614811,3.7590245,62.744967,86.8208744,3.1591329,23.0966502,19.8467001,39.7310421,6.2759536,7.3107303,1.9061207,23.1149991),(8635,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,111,19.8322768,8.3615574,12.6212678,1.8,8.3688423,12.6095677,1.3762243,3.1718312,3.7786261,63.2236037,88.5576335,3.1818147,23.4364637,19.9328399,40.0073738,6.223654,7.3824012,1.971037,23.0156562),(8636,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,112,19.9070293,8.3804119,12.6402072,1.8,8.3878682,12.6267232,1.3826081,3.2079593,3.8375071,63.5799263,89.9641081,3.2017182,23.4433722,19.8194303,39.948872,6.223654,7.4305954,1.9682945,23.380214),(8637,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,113,19.9861256,8.3986775,12.6653527,1.8,8.4071391,12.6574784,1.3868727,3.1901737,3.8467543,63.8497072,91.5402943,3.2196044,23.7967614,20.0144926,40.1525307,6.223654,7.4685972,1.9435005,23.2375447),(8638,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,114,20.0287322,8.4061238,12.6848533,1.8,8.4128654,12.6730309,1.3870664,3.2071653,3.8488937,64.1097105,93.0493971,3.2267003,24.1756217,19.9895249,40.4976899,6.1713544,7.5173304,1.9409672,23.1255118),(8639,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,115,20.0207285,8.4154788,12.7158226,1.8,8.4268331,12.7050075,1.3897321,3.2212954,3.9001016,64.3995424,94.2222415,3.2285843,24.1589196,19.9918155,40.6444319,6.1713544,7.5356829,2.0002957,23.217421),(8640,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,116,20.0797144,8.4286224,12.7482727,1.8,8.440729,12.7346777,1.3906117,3.2381202,3.9031861,64.5582652,95.8850863,3.2391368,24.5658507,19.9369578,40.9473171,6.1713544,7.6239133,1.957672,23.6379952),(8641,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,117,20.2503394,8.4488773,12.7687678,1.8,8.469773,12.7285316,1.4050763,3.2337628,3.9087611,65.2678,98.1887248,3.2832124,25.1201651,20.1832364,39.2528012,6.2063241,7.7898339,1.4089589,25.9719919),(8642,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,118,20.2767914,8.4501608,12.8044342,1.8,8.4630364,12.7878126,1.3906232,3.2352853,3.9563482,65.4311502,99.026534,3.2709419,25.0297821,20.2242286,40.706196,6.1949646,7.7081185,1.9097126,23.9084665),(8643,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,119,20.4445498,8.4557746,12.8250259,1.8,8.4694548,12.8035384,1.3880872,3.2538615,3.9740032,66.0401488,100.9429164,3.2949363,25.4008142,20.2959313,41.6089229,6.1926364,7.7801718,1.9350744,23.7478508),(8644,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,120,20.511674,8.4626376,12.8492874,1.8,8.4790194,12.8360459,1.3858546,3.2641491,4.0240953,66.1829258,102.7343006,3.303011,25.5297879,20.2757053,41.7957533,6.2123876,7.8571358,1.9599551,24.3163506),(8645,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,121,20.6505154,8.4672458,12.8788624,1.8,8.4813257,12.8576168,1.3839326,3.2812629,4.0365647,66.6413211,104.6739203,3.3229656,25.9314361,20.3096562,42.0477313,6.2016104,7.9057228,1.9009149,24.4388963),(8646,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,122,20.7419919,8.4680068,12.9082497,1.8,8.4875855,12.8883777,1.3802246,3.2407116,4.0483013,66.8275367,106.4791745,3.3329614,26.3021863,20.6212537,42.3720677,6.2065436,7.954013,1.9549657,24.4515863),(8647,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,123,20.7860659,8.4704377,12.9455324,1.8,8.4967864,12.9212353,1.3622862,3.2403737,4.1003572,66.7274679,108.1009909,3.3158969,26.3637988,20.5925225,42.5066501,6.2041761,8.0129426,1.9379702,24.6607847),(8648,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,124,20.8741457,8.4812482,12.9822998,1.8,8.51019,12.9550778,1.3527983,3.2772327,4.110129,67.0794214,109.8536131,3.3162927,26.7275341,20.4683122,42.7653618,6.1974185,8.071103,1.9007434,24.6480947),(8649,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,125,21.0067673,8.484945,13.0091314,1.8,8.5208075,12.9814899,1.3457353,3.2894956,4.1533367,67.6680267,111.6423938,3.3267612,26.880169,20.5709432,42.8564922,6.2453253,8.1190834,1.953695,24.7093675),(8650,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,126,20.9933812,8.4937583,13.0389749,1.8,8.5326489,13.013189,1.3357631,3.2856659,4.1734687,67.6002953,113.9882451,3.3091485,27.3125915,20.5743059,43.0918873,6.2502277,8.1970364,1.9430091,24.6100247),(8651,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,127,21.2469584,8.5185085,13.0691996,1.8,8.5612504,13.0471802,1.3257517,3.293165,4.2183593,68.0351994,117.6535185,3.3327463,27.8908246,20.6595175,43.670684,6.2649575,8.2945604,1.9384229,24.8879296),(8652,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,128,21.3627726,8.5410942,13.1009134,1.8,8.5867324,13.0688029,1.3178533,3.332293,4.2509539,68.2848414,121.2167497,3.3374802,28.5151878,20.4918478,44.0397258,6.2695213,8.3922549,1.9339433,25.109818),(8653,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,129,21.4139772,8.5746462,13.124875,1.8,8.6240812,13.0949109,1.314228,3.3129234,4.3095564,68.9149779,124.0933534,3.3391689,28.7949251,20.8018628,44.0958938,6.2734327,8.468824,1.9570366,25.6349914),(8654,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,130,21.5430212,8.5970338,13.1585848,1.8,8.6512768,13.1332343,1.3028233,3.3127878,4.3829167,69.6391559,127.1171103,3.338784,29.0028577,21.021315,44.36983,6.2759536,8.6064254,1.9309895,25.3369629),(8655,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,131,21.746739,8.6201795,13.194162,1.8,8.6840538,13.1726951,1.296546,3.3460766,4.4393834,70.6660308,131.4088271,3.3586157,29.6006937,21.1190714,44.8476044,6.3574103,8.686303,1.9211105,25.4848885),(8656,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,132,21.7301063,8.6459762,13.2089568,1.8,8.7291313,13.1909233,1.2889749,3.3603323,4.5241798,71.6034341,134.5886955,3.3415734,29.7487506,21.3084383,44.8303,6.4087892,8.7903812,1.9678758,25.719467),(8657,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,133,21.784619,8.6621989,13.2456447,1.8,8.755816,13.230104,1.2715789,3.3639156,4.6263986,72.4618478,138.4146962,3.3152892,29.9184543,21.5409232,45.1062551,6.4235449,8.9007735,1.9185633,26.2551532),(8658,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,134,21.9405645,8.6944338,13.277395,1.8,8.7996094,13.2563809,1.253974,3.3977988,4.7447779,74.0226173,143.8144677,3.3018263,30.3100523,21.7854621,45.18702,6.5143624,9.0519134,1.9620319,26.5457481),(8659,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,135,21.9182479,8.7164166,13.2914708,1.8,8.8423343,13.2721599,1.2286703,3.4610057,4.8953731,74.4631556,149.8800438,3.2418769,30.6166741,21.5148893,45.1225335,6.5432979,9.2456487,1.9534035,27.0941242),(8660,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,136,22.1055368,8.7494455,13.3451475,1.8,8.8814267,13.3419954,1.205151,3.4883685,5.0240633,75.3279945,156.8498669,3.213248,31.2197236,21.5940476,45.4640959,6.5340432,9.3913856,1.9471662,27.5685376),(8661,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,137,22.1350225,8.7891299,13.3828876,1.8,8.9275014,13.3814147,1.1813212,3.5625158,5.1805391,76.3888704,164.3448051,3.1572869,31.7234946,21.4423947,45.5657106,6.5645162,9.5799702,1.980706,28.1348601),(8662,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,138,22.2830034,8.8260076,13.4058046,1.8,8.9869299,13.4339252,1.1611157,3.6145159,5.2543499,78.4560497,170.9335264,3.1246121,32.5318128,21.7058251,46.6554999,6.6506045,9.6759939,1.9763978,28.9611412),(8663,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,139,22.2758118,8.8514339,13.407525,1.8,8.9821322,13.4232671,1.1596858,3.6100591,5.3398944,79.2796807,175.8234781,3.1197194,32.9263962,21.9607712,46.9155759,6.7045897,9.7447247,1.9792117,29.3615917),(8664,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,140,22.1676137,8.8705525,13.4130598,1.8,8.9941061,13.4409231,1.1498994,3.6674325,5.4211566,80.1831484,179.4855941,3.0778364,33.1083581,21.8635649,47.051586,6.7644762,9.8345526,1.9868608,29.4640137),(8665,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,141,21.8813816,8.8886469,13.3762333,1.8,9.0138278,13.3898286,1.1417578,3.6736869,5.4376437,81.2382891,180.6773055,3.0157895,33.2271323,22.1135582,47.2365167,6.7864535,9.8135316,1.9819861,30.0684063),(8666,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,142,21.9808772,8.8888525,13.3406585,1.8,9.0074367,13.3565683,1.1408733,3.7085277,5.4666516,83.0821072,182.7469391,3.0270492,33.4294104,22.4029896,47.6680035,6.8377922,9.8203579,1.9700938,30.1730055),(8667,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,143,22.1418138,8.8928305,13.3202127,1.8,9.0139346,13.3384128,1.1466632,3.7461621,5.4737828,85.35556,185.6160522,3.0653212,33.910014,22.7848017,48.3185684,6.8750768,9.8307972,2.4352745,31.170415),(8668,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,144,21.8761995,8.8854829,13.2873819,1.8,8.9835166,13.3055442,1.1368448,3.8128962,5.5639287,87.4074595,187.6917143,3.0014654,33.7336662,22.9241642,48.3800392,6.9759329,9.9513673,2.3822109,31.4715227),(8669,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,145,22.0735724,8.9035791,13.2676563,1.8,9.0006941,13.2931446,1.1330352,3.8424295,5.6189922,89.9738173,192.3339272,3.0178177,34.2292571,23.4158667,49.04005,7.0516838,10.1041175,2.3964657,31.4461426),(8670,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,146,22.0866315,8.917122,13.2364907,1.8,9.0202038,13.2626542,1.1392249,3.8660141,5.6602876,91.5178385,195.2411207,3.0370084,34.4931453,23.6724018,49.1907101,7.1170066,10.224006,2.4141007,32.3210065),(8671,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,147,22.1838353,8.9145544,13.1924497,1.8,9.0210066,13.2176228,1.1515084,3.8844242,5.7256378,95.4441301,196.7774125,3.0845194,34.367772,24.5709854,49.4073054,7.2275752,10.251925,2.3958848,32.0019524),(8672,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,148,21.818164,8.9008816,13.1154797,1.8,8.998338,13.129971,1.1536723,3.9442892,5.7932482,98.529648,197.0942325,3.0395156,34.0213688,24.9803307,49.3530367,7.267018,10.2874816,2.3921502,32.1043744),(8673,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,149,22.0895507,8.9055693,13.0824491,1.8,9.0034495,13.1109597,1.1576018,3.9569644,5.8218652,103.2834431,202.4292265,3.0880013,34.7705106,26.101686,50.6828312,7.4054203,10.3550594,2.3490518,33.0785811),(8674,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,150,22.371955,8.9133908,13.0299095,1.8,9.0134251,13.0706259,1.1748444,3.9926374,5.823619,107.7107159,205.1309068,3.1740056,35.2239575,26.9773347,51.787606,7.4966081,10.3258299,2.3956006,32.6295478),(8675,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,151,22.3137912,8.8844762,12.929268,1.8,8.9856935,12.9681012,1.1805588,4.0627871,5.8828964,112.7414897,206.1538137,3.1807926,35.0429107,27.7497899,51.7999903,7.6226152,10.3210608,2.3311101,32.7827298),(8676,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,152,22.2097856,8.9042221,12.840944,1.8,9.0058523,12.9069596,1.2023601,4.1659735,5.9119693,117.9579927,208.127584,3.221481,35.2044429,28.3146285,52.3107327,7.7390457,10.3558518,2.3419097,33.9354986),(8677,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,153,22.7393664,8.8884351,12.7638251,1.8,8.9883685,12.8275489,1.1951951,4.2623905,6.001817,125.9067218,214.3261146,3.2799048,35.7102046,29.5389926,54.2294655,7.900602,10.3327149,2.4099062,33.7621929),(8678,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,154,23.5681112,8.890303,12.6882695,1.8,8.9739028,12.7547325,1.1906807,4.3679362,6.0593119,136.9735098,222.6630454,3.3872811,36.7472494,31.3588621,56.3402332,8.1428849,10.4499811,2.4199378,34.3486391),(8679,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,155,23.6760542,8.9152546,12.6488135,1.8,9.0137835,12.7432045,1.1679643,4.4911743,6.0989029,146.463798,228.9116058,3.3395714,37.5332433,32.6114704,58.7497245,8.3548392,10.621458,2.5276396,34.3972219),(8680,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,156,23.7413423,8.8586993,12.5126184,1.8,8.9307182,12.6211777,1.1462958,4.5853919,6.2874102,154.903606,233.8232282,3.2856698,37.1891164,33.7819774,59.2591399,8.5530426,10.8501218,2.5482425,35.9377512),(8681,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,157,24.0581056,8.8243114,12.3711088,1.8,8.8857044,12.4779155,1.1580988,4.6948843,6.4217765,165.1859066,241.3356113,3.3646598,37.5808176,35.1842337,60.4112256,8.7527564,11.0599772,2.5890083,36.2029661),(8682,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,158,24.1866233,8.763435,12.2264362,1.8,8.7967052,12.3257372,1.1271388,6.6264689,6.627421,179.8657175,246.8088655,3.2883652,37.2405597,27.1435241,59.3051435,9.0688953,11.3822272,2.5956571,37.588136),(8683,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,159,24.5823897,8.7704834,12.0115693,1.8,8.8158026,12.0652874,1.1688689,6.8741206,6.7464431,196.2785245,257.7680102,3.4700833,38.2079869,28.553256,61.0874951,9.3308045,11.644154,2.619661,38.679632),(8684,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,160,25.8185368,8.8125194,11.8131372,1.8,8.8778032,11.8065853,1.2663572,6.5858554,8.6818785,222.764687,279.6371617,3.9164357,32.2092921,33.8247158,53.5033029,9.6976906,11.9921315,2.5959376,42.3576495),(8685,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,161,26.25081,8.9012312,11.6578213,1.8,8.980918,11.6391611,1.2609333,6.9726208,8.8921063,241.7968768,306.3222767,3.9683298,34.4487871,34.6780478,56.7516869,9.9785449,12.4011857,1.7574396,49.0554527),(8686,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,162,26.8029588,8.9396115,11.3558799,1.8,9.0571353,11.2981613,1.334033,7.1890624,9.0239572,268.2796645,332.3986304,4.2213892,36.8351293,37.3177546,63.0042171,10.370447,13.0518713,1.7398976,47.586709),(8687,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,163,28.3658873,9.0103697,10.853927,1.8,9.1014177,10.811133,1.5190557,6.7623056,9.0787242,292.5033392,444.2332264,4.7150028,48.9312395,43.2549721,76.4835097,10.8919902,16.1622731,1.799293,53.1221326),(8688,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,164,29.6288965,9.093857,10.5264061,1.8,9.123789,10.4500137,1.5615978,6.9016617,9.2064412,317.4709045,516.9333786,4.9377316,56.1490988,45.9991981,88.1744307,11.8679873,16.5035738,1.7750283,59.3201424),(8689,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,165,33.3500727,9.2359371,10.0607884,1.8,9.2608004,9.9048721,-1.4513115,7.240679,9.1421148,384.342357,644.0262419,5.479368,70.4460902,53.0809826,111.6271603,12.4674591,16.8541946,1.75176,62.2152052),(8690,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,166,34.8107859,9.4071052,9.9189647,1.8,9.3973918,9.7321829,-1.5017304,7.6994034,9.2122592,417.5702389,699.5990222,5.7741664,75.9421776,54.2341029,121.2679819,13.0228293,16.9554025,1.7318882,60.1411671),(8691,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,167,37.2790253,9.2644386,9.7677588,1.8,9.2685728,9.6027497,-1.5611123,7.9051721,9.0548209,476.0031358,727.3660712,6.2125883,80.3291503,60.2141394,129.9353146,13.4471471,17.095655,1.6780752,59.2325877),(8692,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,168,39.8945553,8.9731901,9.6980739,1.8,8.976873,9.5538114,1.4053133,8.0909677,8.5387129,550.6839847,758.2990661,6.4686656,88.807186,68.0615726,140.8812634,13.7618456,16.9432991,1.6480417,67.3387637),(8693,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,169,44.0725123,8.9795093,9.7372224,1.8,9.0130452,9.64755,1.2817939,8.0137278,8.5774114,639.6409348,812.0372275,6.7488031,94.6715956,79.8181513,154.7382347,14.0425023,16.321921,1.6542037,61.0488446),(8694,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,170,45.7049346,9.0518965,9.7211318,1.8,9.0893391,9.6661404,1.2460343,8.1559075,8.4107042,679.7604115,749.9962772,6.8419213,89.1716386,83.3457727,158.698331,13.9249947,15.6628393,1.6275914,61.0256418),(8695,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,171,40.5149076,8.9707686,9.9247769,1.8,9.1447044,9.9234239,-0.6576682,8.1963315,8.4913688,558.574535,627.4138133,2.5230981,73.8884188,68.1493344,128.1047748,13.3143406,14.9182299,0.3694391,69.4477928),(8696,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,172,36.3792349,9.1982949,9.7862572,1.8,9.3545508,9.8795867,-0.6992648,7.7838863,8.3950823,415.8741714,563.4589301,2.5119377,67.1177378,53.4275756,107.8020365,0.2979559,0.4821786,0.2186689,1.231988),(8697,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,173,36.2405355,9.1523984,9.9323061,1.8,9.3001557,10.0142647,-0.7260647,7.2873242,8.6423331,343.0793136,526.0000281,2.6625059,60.8631978,47.0789149,92.0474525,11.59803,14.516417,0.2178874,60.0873279),(8698,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,174,40.542502,9.1710267,10.0025099,1.8,9.2954144,10.1675377,-0.7931943,6.8488443,8.9372124,280.6323777,425.8490782,3.4312185,47.6489825,40.9751434,73.2840346,11.4626138,14.1271896,0.1748867,72.5118068),(8699,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,175,27.626614,8.7498276,11.0665337,1.8,8.8939524,11.0610923,1.314828,6.8117721,6.3512207,130.7870238,209.5734015,4.3092854,32.9973421,19.2001468,49.4291407,9.5683107,11.2973218,1.8764429,92.6284192),(8700,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,176,4.2898931,10.2349688,13.553184,1.8,9.9679993,13.6692258,-0.464462,7.3213847,5.5624887,6.3490984,12.7168604,0.1434626,2.2861818,0.8671991,2.5776502,2.9035264,6.6961889,0.4182243,26.9938795),(8701,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,177,0.8683223,7.7641242,14.0855435,1.8,7.765634,14.0714062,-0.8114554,0.8808528,6.7795275,0.1584783,1.36471,0.0761295,0.2012987,0.1799146,0.2239256,1.716308,2.6882205,0.6473921,7.7923783),(8702,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8703,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8704,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8705,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8706,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8707,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8708,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8709,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8710,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8711,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8712,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8713,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8714,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8715,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8716,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8717,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8718,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8719,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8720,'lesser-mouse-deer-tibia-cleaned-1.tif',183,8,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8721,'metatarsus.tif',183,10,1,17.8306132,19.3883858,17.281553,1.8,19.3161076,17.321018,-0.6894902,3.6484052,4.7112117,63.8749109,70.897709,1.2026127,15.0487206,17.5076252,28.5894949,6.9233008,8.2161645,0.730178,26.2568446),(8722,'metatarsus.tif',183,10,2,17.9275717,19.137994,17.2387055,1.8,19.1142159,17.287133,0.9880747,4.4969171,4.0766623,68.757367,73.1866316,2.0830991,17.9525863,15.2898898,30.8477893,7.1813086,8.1263177,0.7498801,26.2251203),(8723,'metatarsus.tif',183,10,3,18.1772013,19.0316794,17.4021736,1.8,18.964974,17.4099972,1.2747061,3.9338719,3.9618573,69.1854544,78.1073949,2.7716076,19.7148431,17.5871141,33.407639,7.1550642,7.9768806,2.1952939,26.6490824),(8724,'metatarsus.tif',183,10,4,19.0875702,19.0183174,17.3527112,1.8,18.9780464,17.4133257,1.3235498,3.6134844,4.0073362,60.9223818,82.064588,2.9907192,20.4785881,16.859733,34.0372332,6.7628003,8.1923432,1.8520285,26.4183095),(8725,'metatarsus.tif',183,10,5,6.8684279,18.2009239,15.4082101,1.8,18.1826417,15.5430064,-0.9941959,1.5311387,2.6170484,3.2087953,10.013665,0.804501,3.8263201,2.0956922,4.7467283,2.9556107,4.9906981,0.6528466,14.1290224),(8726,'metatarsus.tif',183,10,6,8.1883971,17.7398611,15.6023175,1.8,17.7776531,15.6816083,-0.8751822,1.5849516,3.1850217,3.7465098,16.1560282,0.8042402,5.0725017,2.3638007,6.2435111,2.9541153,5.8747197,0.8697049,16.019482),(8727,'metatarsus.tif',183,10,7,13.7116305,18.203663,16.7709337,1.8,18.3000718,16.9647665,-1.5133605,3.5228171,4.0844727,24.915462,46.8001446,2.2777412,11.4580627,7.072596,17.4646965,5.7134639,6.9913833,1.2833331,30.433434),(8728,'metatarsus.tif',183,10,8,16.3562277,18.994683,16.8715676,1.8,19.0105165,17.0548836,0.5574585,3.7007212,3.878185,51.8704861,53.2856351,0.7629472,13.7398383,14.0163182,23.6469616,6.5879003,7.7070751,1.8781938,27.1579203),(8729,'metatarsus.tif',183,10,9,13.9147262,19.1024308,16.8403328,1.8,19.1689988,16.9746851,0.9509704,3.2278609,4.3223791,37.3376339,48.9145538,1.5365632,11.3165811,11.5672996,19.4579161,6.0651248,7.6708271,1.9117753,25.3723418),(8730,'metatarsus.tif',183,10,10,12.8072883,19.0426289,16.8361669,1.8,19.0663774,16.9874717,0.9274649,3.0451779,4.0808083,31.8822503,44.7938961,1.3664585,10.9767216,10.4697498,17.9232955,5.8483294,7.4516891,1.815775,23.6774985),(8731,'metatarsus.tif',183,10,11,11.9448352,18.9923838,16.829873,1.8,19.0281635,16.9496407,0.9646459,3.0928778,3.8720293,28.7345455,41.7995795,1.3446557,10.7952643,9.2905531,17.6556895,5.5340459,7.1547667,1.8177513,24.6102986),(8732,'metatarsus.tif',183,10,12,11.5505092,18.9539286,16.8601337,1.8,18.988002,16.9831248,1.0213356,3.0750859,3.8467925,26.525094,39.6949605,1.4000729,10.3189763,8.625806,16.5910798,5.4407409,7.1841596,1.8334897,24.3170823),(8733,'metatarsus.tif',183,10,13,11.6434154,18.9368562,16.8940485,1.8,18.9673641,17.0175331,1.0145404,3.0394774,3.6457528,25.1919127,39.6087002,1.3995484,10.8643405,8.2882383,17.031814,5.394378,7.0417619,1.821799,22.8471525),(8734,'metatarsus.tif',183,10,14,11.7578933,18.8791539,16.8640009,1.8,18.9005422,16.9480765,0.9955234,3.014521,3.4324309,24.2450609,37.8538991,1.3795821,11.0283061,8.0427574,17.5083107,5.4123338,6.7597841,1.8325098,21.8036119),(8735,'metatarsus.tif',183,10,15,11.7753614,18.9150135,16.8316255,1.8,18.9417417,16.9224311,0.9957796,2.7108706,3.4094605,20.9795882,38.4191388,1.3820907,11.2683925,7.7390594,16.486634,5.109421,6.7123535,1.8705724,20.2653794),(8736,'metatarsus.tif',183,10,16,12.4096996,18.7807652,16.853458,1.8,18.7896759,16.9219152,0.975125,3.105568,3.4388338,23.5606202,37.91498,1.4172012,11.0255343,7.5865735,17.7535318,5.3636002,6.6228905,1.856351,20.9166821),(8737,'metatarsus.tif',183,10,17,12.5718266,18.7281562,16.8252862,1.8,18.7341063,16.8727503,0.9755719,3.0779899,3.3934109,22.7899538,36.8749321,1.4365859,10.8666273,7.4041677,17.5184751,5.2888759,6.550648,1.8503185,20.3536875),(8738,'metatarsus.tif',183,10,18,12.6444367,18.6893846,16.8039674,1.8,18.7015325,16.8567459,0.993123,2.9187549,3.3631485,21.4681043,36.0414868,1.478979,10.7165908,7.3552268,17.0437782,5.1304002,6.4755007,1.929567,20.9508335),(8739,'metatarsus.tif',183,10,19,12.6703506,18.6402281,16.7666967,1.8,18.6551155,16.8001506,0.9966608,2.8961608,3.3395375,20.3931789,35.3228112,1.4888347,10.5771568,7.0414526,16.6216838,5.0656129,6.4227978,1.9816475,19.6740929),(8740,'metatarsus.tif',183,10,20,12.6639268,18.5953528,16.7415598,1.8,18.6143846,16.779253,1.0125081,2.8110155,3.3673138,19.4986075,34.6948198,1.5183642,10.3034116,6.9364994,16.0543481,4.9355798,6.4463038,1.9899389,21.4879633),(8741,'metatarsus.tif',183,10,21,12.7194564,18.5551207,16.7057515,1.8,18.5767333,16.7310723,1.0100979,2.7956951,3.3885919,19.2444909,33.8393789,1.5204252,9.9862657,6.8836157,15.6397913,4.8389002,6.4463038,1.9899389,20.5727416),(8742,'metatarsus.tif',183,10,22,12.6916861,18.5050608,16.6880009,1.8,18.5243251,16.7174532,1.010327,2.7937379,3.3188301,19.0224883,32.8866996,1.5175421,9.9091243,6.8089739,15.6226159,4.8389002,6.3461367,1.9768944,20.1404929),(8743,'metatarsus.tif',183,10,23,12.6338147,18.4551448,16.6664874,1.8,18.4702997,16.6981474,1.0076839,2.7812317,3.3511347,18.6673159,32.0289223,1.5056045,9.557635,6.7118881,15.1262287,4.8389002,6.3771249,1.9648842,19.3584442),(8744,'metatarsus.tif',183,10,24,12.5759228,18.4104682,16.6493991,1.8,18.4241295,16.6828593,1.0043912,2.7705209,3.309203,18.5074359,31.1032435,1.492465,9.3990135,6.6801287,14.9898777,4.7806002,6.2926204,1.9805543,19.1052388),(8745,'metatarsus.tif',183,10,25,12.5850009,18.3710554,16.6431169,1.8,18.3843263,16.674696,0.9970566,2.77185,3.3045204,18.2332596,30.5482725,1.4795628,9.2443892,6.5780109,14.7620125,4.7806002,6.247084,1.9634338,19.4691848),(8746,'metatarsus.tif',183,10,26,12.505282,18.3298861,16.6244422,1.8,18.3417382,16.6499155,0.9807153,2.7793491,3.2942011,18.034054,29.6963605,1.4389151,9.0147381,6.488589,14.4891458,4.7806002,6.1858473,1.9880637,18.8637523),(8747,'metatarsus.tif',183,10,27,12.504552,18.2862976,16.6083753,1.8,18.2973081,16.6350203,0.9749752,2.7838801,3.2665337,17.8769983,29.1042996,1.4277435,8.909842,6.4216121,14.3785573,4.7806002,6.139519,1.9707006,18.6446982),(8748,'metatarsus.tif',183,10,28,12.5672819,18.2459839,16.5847146,1.8,18.257257,16.6052048,0.9657435,2.7629737,3.2601189,17.7684363,28.7502943,1.4168778,8.818787,6.4309103,14.2670058,4.7608213,6.0858613,1.9744303,17.402109),(8749,'metatarsus.tif',183,10,29,12.5767155,18.206429,16.5730877,1.8,18.2191883,16.6043554,0.9570527,2.764516,3.2582276,17.8073067,28.3792278,1.4008416,8.71002,6.4413831,14.1679646,4.7725709,6.0858613,1.9744303,17.4645522),(8750,'metatarsus.tif',183,10,30,12.6414045,18.167216,16.558059,1.8,18.1797342,16.5878281,0.9508974,2.739705,3.2383753,17.7404433,28.1263283,1.3958085,8.6853208,6.4753115,14.1114817,4.7223002,6.0632002,1.9655874,17.3821036),(8751,'metatarsus.tif',183,10,31,12.7476148,18.1221981,16.5421708,1.8,18.132596,16.578725,0.9423142,2.7233752,3.2151414,17.7185731,28.0144649,1.3902399,8.7132917,6.5061079,14.2059471,4.7223002,6.0094267,1.9693188,17.3338063),(8752,'metatarsus.tif',183,10,32,12.7578607,18.0746022,16.5302927,1.8,18.0822861,16.5696319,0.9305168,2.7233672,3.2051374,17.6290869,27.7967108,1.3674082,8.6725489,6.4732684,14.0487635,4.7223002,5.9734036,2.0038858,17.5670063),(8753,'metatarsus.tif',183,10,33,12.7662755,18.0342483,16.503751,1.8,18.0485913,16.5457595,0.9104897,2.7124993,3.2005136,17.4154565,27.3469402,1.3272472,8.5445476,6.4204465,13.8767524,4.7223002,5.9870441,1.960344,17.4845576),(8754,'metatarsus.tif',183,10,34,12.7522248,17.9966423,16.4908731,1.8,18.0076945,16.537708,0.9011556,2.687706,3.1886245,17.2836262,27.072339,1.3065209,8.4902876,6.4306237,13.7469295,4.7223002,5.9788066,1.9820901,17.2172063),(8755,'metatarsus.tif',183,10,35,12.7209221,17.9565381,16.4726071,1.8,17.9684973,16.5178262,0.8931415,2.6740269,3.1519234,17.1160798,26.6010908,1.2867456,8.4396373,6.4008631,13.7353919,4.6640002,5.9110567,1.9549657,17.3055144),(8756,'metatarsus.tif',183,10,36,12.6954748,17.9169996,16.4585257,1.8,17.9305509,16.5053855,0.8804515,2.6843803,3.1713024,17.1258661,26.0716285,1.2578715,8.2211109,6.3798211,13.4374034,4.7039939,5.9254145,1.9860237,17.1206117),(8757,'metatarsus.tif',183,10,37,12.7054897,17.882289,16.4419772,1.8,17.898916,16.4860242,0.8590658,2.6668753,3.1122942,16.9658346,25.6822979,1.2142242,8.2518862,6.3616902,13.467396,4.6640002,5.857047,1.9586963,16.7566657),(8758,'metatarsus.tif',183,10,38,12.5830397,17.8448547,16.4232733,1.8,17.8613463,16.4732,0.8458028,2.6449986,3.0607894,16.7729552,25.2618141,1.1749578,8.2533657,6.3413853,13.4638372,4.6640002,5.7952079,1.9849349,16.9898657),(8759,'metatarsus.tif',183,10,39,12.6455048,17.800619,16.4091391,1.8,17.8088369,16.4561862,0.8254066,2.5760902,3.0385547,16.7253863,24.894189,1.1380233,8.1927732,6.4925468,13.5268379,4.6057002,5.7270665,1.9569737,16.7225144),(8760,'metatarsus.tif',183,10,40,12.637735,17.7600128,16.3915745,1.8,17.7665155,16.4364022,0.8089411,2.5909614,3.0351027,16.6694947,24.7008879,1.1027145,8.1384028,6.4337101,13.2912495,4.6057002,5.7418843,1.9890207,17.0664549),(8761,'metatarsus.tif',183,10,41,12.4610444,17.725452,16.3780676,1.8,17.7362317,16.4227113,0.7843499,2.5600613,2.9692871,16.4759052,24.2509929,1.0362433,8.167278,6.4357464,13.30086,4.6057002,5.6886584,1.993183,16.6400657),(8762,'metatarsus.tif',183,10,42,12.4600264,17.6805488,16.3538976,1.8,17.6845383,16.3943976,0.7617603,2.5346168,2.9295181,16.343401,23.8061168,0.9892657,8.1262912,6.4480757,13.3523133,4.5939607,5.605599,2.0344439,16.4068657),(8763,'metatarsus.tif',183,10,43,12.3668187,17.649337,16.3310705,1.8,17.6621367,16.367065,0.7208921,2.5084348,2.9092634,16.017427,23.4719787,0.8979809,8.0680144,6.3854269,13.1114751,4.4825503,5.5825106,2.0017453,16.2961251),(8764,'metatarsus.tif',183,10,44,12.3733281,17.6088023,16.3100655,1.8,17.6166543,16.345725,0.6955871,2.475986,2.8665229,15.9708165,23.1869421,0.8468948,8.0888737,6.4502856,13.2592535,4.4327168,5.5043354,2.0676071,16.1795251),(8765,'metatarsus.tif',183,10,45,12.3419904,17.5768497,16.2920859,1.8,17.5909035,16.3299767,0.672468,2.4539984,2.8462859,15.8673627,22.9933415,0.7981721,8.0783669,6.4659221,13.2916002,4.4255147,5.4596948,2.0965649,16.0829305),(8766,'metatarsus.tif',183,10,46,12.2511003,17.5291432,16.2704773,1.8,17.5396717,16.3077121,0.6421035,2.4088549,2.8332862,15.7680737,22.762855,0.7323276,8.0340825,6.5458794,13.1831984,4.4275307,5.4391121,2.1112158,16.3985792),(8767,'metatarsus.tif',183,10,47,12.1985567,17.4930111,16.2504038,1.8,17.5050111,16.2837103,0.6092235,2.3627392,2.7995092,15.5813063,22.6142997,0.6657324,8.0779515,6.5945942,13.2117285,4.374191,5.409348,2.1019739,16.0487792),(8768,'metatarsus.tif',183,10,48,12.1561628,17.4551958,16.2325246,1.8,17.4640726,16.2636219,0.5753101,2.3790578,2.7716766,15.4172944,22.4619709,0.5997838,8.1041097,6.4804203,13.1488415,4.3985825,5.3892038,2.1167816,16.4127251),(8769,'metatarsus.tif',183,10,49,12.1193343,17.4125871,16.2093366,1.8,17.4195822,16.2389617,0.539784,2.3577791,2.7444402,15.2706249,22.2460079,0.5335443,8.1058454,6.4766987,13.0733387,4.3709672,5.3359632,2.1618292,16.0970765),(8770,'metatarsus.tif',183,10,50,12.1250836,17.370789,16.197522,1.8,17.3759145,16.231358,0.5066384,2.2777927,2.7248054,15.1947127,22.1950938,0.4758257,8.1455702,6.6708057,13.068238,4.336303,5.328633,2.2164856,16.2136765),(8771,'metatarsus.tif',183,10,51,11.9303343,17.3375705,16.1747635,1.8,17.3460588,16.2019408,0.4667274,2.2574211,2.6825685,14.7507746,21.9284146,0.4025881,8.1744099,6.5343478,12.9838302,4.2678796,5.2728477,2.1833339,15.7672819),(8772,'metatarsus.tif',183,10,52,11.9158851,17.29944,16.1549664,1.8,17.3029649,16.1835565,0.4498384,2.2202132,2.6620584,14.5376228,21.8682089,0.3754863,8.2147743,6.5478498,12.9110099,4.2177104,5.2592936,2.1987776,15.6848332),(8773,'metatarsus.tif',183,10,53,11.8770164,17.2644376,16.1446185,1.8,17.2682793,16.1828279,0.4223036,2.1868203,2.6315239,14.5150832,21.8397462,0.3325317,8.2992773,6.6375291,12.9722767,4.2756899,5.2262302,2.2455373,17.3255198),(8774,'metatarsus.tif',183,10,54,11.8300898,17.2344924,16.1219653,1.8,17.2387479,16.1512287,0.3998462,2.1410207,2.6225104,14.122722,21.831537,0.2987814,8.3246713,6.5962565,13.0226469,4.1720222,5.1900101,2.2367656,16.1312278),(8775,'metatarsus.tif',183,10,55,11.9309603,17.2109259,16.1050561,1.8,17.2233056,16.1308766,0.3745236,2.1522371,2.5995779,13.9202682,21.8962851,0.266122,8.4230155,6.4678135,13.0431312,4.1490252,5.172955,2.2684206,16.4951738),(8776,'metatarsus.tif',183,10,56,11.8885302,17.1771613,16.0887967,1.8,17.1881457,16.117369,0.3564575,2.1420917,2.5914922,13.6793691,21.9080187,0.2412791,8.453824,6.3859868,12.9732775,4.1225436,5.1442939,2.2437674,16.4127251),(8777,'metatarsus.tif',183,10,57,11.7891117,17.144602,16.064714,1.8,17.1560642,16.085446,0.3404208,2.0743256,2.5954879,13.3057178,21.8996263,0.2190385,8.4375758,6.414479,12.8491753,4.0050846,5.1284123,2.2757235,15.4374873),(8778,'metatarsus.tif',183,10,58,11.7816568,17.1134696,16.0503181,1.8,17.1216219,16.0712281,0.3232055,2.077989,2.5832928,13.0801155,22.0578374,0.1980784,8.5386515,6.294603,12.8514087,3.9968179,5.122444,2.2917677,15.6023846),(8779,'metatarsus.tif',183,10,59,11.7888221,17.0756986,16.0402277,1.8,17.0778242,16.0668999,0.299797,2.143865,2.5759785,12.8940234,22.1180916,0.1713655,8.5862875,6.0143821,12.8162132,4.0757022,5.1081582,2.4775465,17.0781738),(8780,'metatarsus.tif',183,10,60,11.8422241,17.0428327,16.0290649,1.8,17.0552239,16.0516521,0.2833322,2.1442894,2.580076,12.6153142,22.2866309,0.1542487,8.6379747,5.8832142,12.8339963,3.8465531,5.0988343,2.4614946,15.258444),(8781,'metatarsus.tif',183,10,61,11.6530497,17.001617,16.0200875,1.8,17.0118483,16.0430114,0.2644947,2.136398,2.5907359,12.4246013,22.2687771,0.1327306,8.595541,5.8156772,12.7074158,3.8050481,5.0988343,2.4614946,15.2925953),(8782,'metatarsus.tif',183,10,62,11.6915622,16.959241,16.0179498,1.8,16.9492585,16.0446112,0.2408847,2.1006152,2.5948966,12.1797326,22.3702829,0.1108979,8.6208764,5.7981741,12.7079611,3.7828241,5.0965007,2.5186836,15.2242926),(8783,'metatarsus.tif',183,10,63,11.639908,16.9205082,16.00983,1.8,16.9062358,16.0375081,0.2262842,2.0957776,2.6004618,11.9442743,22.3952305,0.097652,8.6120207,5.6992088,12.6251529,3.756493,5.0838137,2.5026787,15.3067413),(8784,'metatarsus.tif',183,10,64,11.5371345,16.8921349,16.0161608,1.8,16.8852893,16.0559605,0.2177044,2.0861504,2.6103214,11.8252486,22.3880742,0.0897034,8.5767501,5.6684545,12.5467724,3.7246853,5.0991676,2.6011732,15.258444),(8785,'metatarsus.tif',183,10,65,11.5045784,16.8557595,16.0055654,1.8,16.8482945,16.0344154,0.2087223,2.0374955,2.620292,11.4189471,22.6072122,0.0823268,8.6277454,5.6044034,12.4745239,3.9644002,5.1197892,2.6167969,17.9085198),(8786,'metatarsus.tif',183,10,66,11.3075198,16.8196261,15.9955868,1.8,16.813025,16.0163574,0.2034139,2.0258776,2.6342647,11.0904992,22.4620073,0.0769093,8.5268603,5.4744173,12.222309,3.9061002,5.1386748,2.7083925,18.1900171),(8787,'metatarsus.tif',183,10,67,11.1646446,16.7841314,15.9915224,1.8,16.7741803,16.011265,0.1979834,1.9947638,2.6556101,10.7653163,22.483849,0.0719895,8.4665475,5.3967876,12.0434643,3.8478001,5.1532058,2.7589854,17.9626766),(8788,'metatarsus.tif',183,10,68,11.1072288,16.7411577,15.993897,1.8,16.7245771,16.014531,0.1840755,1.9685239,2.6694206,10.4008065,22.5694977,0.0620206,8.4548302,5.283556,11.932619,3.7895001,5.1860793,2.9949262,17.9968279),(8789,'metatarsus.tif',183,10,69,11.0212189,16.7061848,15.9951555,1.8,16.6963098,16.0148321,0.1748936,1.9507844,2.6798196,10.1514274,22.6691353,0.0556152,8.459202,5.203767,11.7988918,3.5460318,5.2281809,3.0186208,15.2242926),(8790,'metatarsus.tif',183,10,70,10.9636954,16.6590637,16.0010784,1.8,16.6436858,16.0228371,0.1609972,1.912439,2.7011405,9.8936998,22.921369,0.0469555,8.4858116,5.1733413,11.7264874,3.4703872,5.261878,2.9746225,15.127698),(8791,'metatarsus.tif',183,10,71,10.9121709,16.6351665,15.9996242,1.8,16.6349701,16.0122257,0.1608055,1.8448088,2.7155243,9.6244602,23.2699168,0.0466246,8.5692169,5.2170502,11.6660192,3.4694397,5.310103,2.9872739,15.127698),(8792,'metatarsus.tif',183,10,72,10.8702065,16.6038627,16.0152816,1.8,16.6089676,16.0325628,0.1509294,1.8206452,2.7392574,9.4951731,23.7062286,0.0409576,8.6542537,5.2152794,11.6954101,3.4217109,5.3677176,2.9889433,15.244298),(8793,'metatarsus.tif',183,10,73,10.8798359,16.5721156,16.0247083,1.8,16.5778165,16.0410737,0.1427757,1.8035997,2.756996,9.3256376,23.9862983,0.0367136,8.700157,5.1705695,11.7264257,3.4041011,5.4090339,3.0118901,15.2925953),(8794,'metatarsus.tif',183,10,74,10.9145909,16.5339156,16.0405248,1.8,16.540226,16.0549842,0.1337954,1.8055461,2.788717,9.3224383,24.4451486,0.0323702,8.765733,5.1632235,11.8068613,3.5563001,5.4596948,3.0238601,15.8697359),(8795,'metatarsus.tif',183,10,75,10.8913181,16.5022153,16.053164,1.8,16.5117322,16.0681439,0.1314307,1.7964829,2.8021582,9.2550762,24.7300068,0.031176,8.8253427,5.1517754,11.7863782,3.4071253,5.5000112,3.0566909,15.4574927),(8796,'metatarsus.tif',183,10,76,10.8009907,16.4739173,16.062928,1.8,16.4830518,16.0730449,0.1292111,1.7880667,2.8080037,9.1238599,25.0416099,0.0298878,8.9179405,5.1026396,11.7603817,3.3714206,5.53236,3.0041665,15.4292007),(8797,'metatarsus.tif',183,10,77,10.7030231,16.450411,16.0827558,1.8,16.4578163,16.0911475,0.1288018,1.7660241,2.8360095,8.9463165,25.3451019,0.0294304,8.9368889,5.0657952,11.7494872,3.3354927,5.590116,3.0055952,15.5116494),(8798,'metatarsus.tif',183,10,78,10.5699195,16.4316951,16.0953488,1.8,16.4362803,16.0986122,0.1249487,1.747974,2.8505225,8.9003036,25.8125243,0.0273604,9.0553659,5.0917825,11.7500658,3.3082696,5.6403557,3.0172377,15.6141035),(8799,'metatarsus.tif',183,10,79,10.4914514,16.4073317,16.1150047,1.8,16.4063908,16.1132519,0.1218108,1.7440514,2.8773904,8.8073864,26.3049342,0.0258171,9.1419414,5.0499579,11.8284127,3.3053564,5.7056613,3.0083659,15.7931467),(8800,'metatarsus.tif',183,10,80,10.4729384,16.3772809,16.1361264,1.8,16.3758422,16.1345572,0.1161731,1.742267,2.9182687,8.8058676,26.7673072,0.0234517,9.1723245,5.0542583,11.8141384,3.3097157,5.790514,3.0609598,15.8614494),(8801,'metatarsus.tif',183,10,81,10.4263078,16.3519997,16.154266,1.8,16.3552485,16.1527601,0.1096611,1.7347098,2.9520399,8.7865699,27.3284029,0.0208134,9.257464,5.0651527,11.8956831,3.2959033,5.8908972,3.1118984,16.0263467),(8802,'metatarsus.tif',183,10,82,10.363392,16.3331356,16.1790934,1.8,16.3321498,16.1817442,0.1037448,1.7322569,2.959585,8.8004002,27.9658773,0.0185236,9.4492564,5.0803088,11.9203766,3.297861,5.9605872,0.06852,16.1288008),(8803,'metatarsus.tif',183,10,83,10.2738218,16.3138751,16.1999989,1.8,16.307237,16.201485,0.1026796,1.7376749,2.9941378,8.8236545,28.6711446,0.0179896,9.5757599,5.0778512,11.9123828,3.3528899,6.0331348,0.096784,16.5268981),(8804,'metatarsus.tif',183,10,84,10.2849472,16.2777253,16.2242392,1.8,16.2775521,16.2250916,0.0976405,1.7574439,3.0478304,9.0091116,29.8952162,0.0162903,9.8086874,5.1262583,12.1452049,3.403756,6.1491995,0.0949517,16.7059414),(8805,'metatarsus.tif',183,10,85,10.1866287,16.2474494,16.245182,1.8,16.2423743,16.2485694,0.0941684,1.7367259,3.104051,9.0231123,30.9124455,0.0150109,9.9587426,5.195473,12.3263307,3.3160864,6.2449073,3.0948976,16.8566927),(8806,'metatarsus.tif',183,10,86,10.2104904,16.2128046,16.2795555,1.8,16.2094276,16.2804978,0.0930917,1.7748313,3.1619826,9.2154901,32.3725553,0.0147049,10.238056,5.1923188,12.5620793,3.3714289,6.3763254,3.0592107,17.1240441),(8807,'metatarsus.tif',183,10,87,10.4139131,16.1661718,16.3146994,1.8,16.1517052,16.3192003,0.0849042,1.8135566,3.2198209,9.5437545,34.5770502,0.0124818,10.7388116,5.2624519,13.0376781,3.4980001,6.5155306,0.116586,18.0168333),(8808,'metatarsus.tif',183,10,88,10.6924465,16.1150923,16.353362,1.8,16.0925575,16.3610567,0.0729622,1.8626495,3.3019952,10.0502863,36.9914041,0.00947,11.2027432,5.3956938,13.6803754,3.5276114,6.6717214,0.0874953,18.0651306),(8809,'metatarsus.tif',183,10,89,11.1681685,16.0691468,16.3991043,1.8,16.0301269,16.4114438,0.0682003,1.9138298,3.3954281,10.9928223,40.2770433,0.0086443,11.8621399,5.743887,14.5487071,3.5887226,6.8412513,0.0767719,19.5209145),(8810,'metatarsus.tif',183,10,90,11.5491243,16.0540642,16.4160837,1.8,16.0345236,16.4154769,0.0507043,1.942255,3.4901595,11.984996,43.865256,0.0049444,12.5682667,6.1706603,15.3748616,3.7194396,7.0081356,0.1418971,19.4326064),(8811,'metatarsus.tif',183,10,91,11.2008391,16.0172872,16.4236178,1.8,15.9860202,16.4258827,0.0577837,1.9839825,3.5620963,12.4186442,46.8282756,0.0062262,13.1462687,6.2594525,16.0916116,3.7603337,7.1592783,0.1142543,22.8505849),(8812,'metatarsus.tif',183,10,92,11.1614651,15.9529382,16.4558892,1.8,15.9039529,16.4580168,0.0438094,2.0343211,3.6764085,13.2170294,49.5576231,0.003568,13.4799013,6.4970221,16.5915505,3.8871907,7.3847948,0.1028108,22.3358876),(8813,'metatarsus.tif',183,10,93,11.2281316,15.9018993,16.5194434,1.8,15.8695259,16.5362782,0.0330416,2.1128706,3.7529309,14.5161079,52.4523301,0.0020423,13.9763643,6.870325,17.400623,4.0564131,7.5587926,0.1004361,21.8636281),(8814,'metatarsus.tif',183,10,94,11.2730104,15.8858619,16.5624355,1.8,15.8523847,16.5766537,0.042968,2.1923287,3.9566457,15.5382913,56.980264,0.0034667,14.4011541,7.0875738,17.8485887,4.1577581,7.848878,0.0967123,21.7611741),(8815,'metatarsus.tif',183,10,95,11.1185434,15.8631095,16.6190721,1.8,15.8158492,16.6235218,0.0529699,2.2980504,4.0470128,16.2989481,61.1338944,0.0051946,15.1059305,7.0925112,18.4767499,4.399306,8.048357,3.0181361,23.4701634),(8816,'metatarsus.tif',183,10,96,11.4784962,15.7745821,16.7097501,1.8,15.758916,16.7173656,0.0380499,2.4504249,4.1446155,17.7510047,67.9169507,0.0027684,16.3867915,7.2440517,19.8789873,4.7139803,8.3246606,3.0363491,24.5761472),(8817,'metatarsus.tif',183,10,97,13.3180225,15.4918393,16.7650534,1.8,15.5379887,16.7502647,0.0424475,2.5233987,4.4202194,19.9605652,78.6685687,0.003997,17.7974353,7.910191,21.6364636,4.8847838,8.4679624,0.1311867,25.5172337),(8818,'metatarsus.tif',183,10,98,15.7118083,15.5315739,16.7585163,1.8,15.5878098,16.7891592,0.1126254,3.0443515,4.5661507,24.1310415,91.4938054,0.0330758,20.037404,7.9264964,24.5445801,5.3512821,8.7134615,0.1816488,32.1872882),(8819,'metatarsus.tif',183,10,99,16.6170073,15.8389956,16.7780849,1.8,15.8729578,16.8039114,0.0688732,2.9091075,4.4490044,25.5856322,98.4589447,0.0131164,22.130557,8.795011,26.2436805,5.2729599,8.856229,0.1586553,31.2979313),(8820,'metatarsus.tif',183,10,100,15.0506696,15.8713133,16.7236671,1.8,15.8926783,16.7948892,0.1134463,3.2611074,4.535966,25.0335074,89.7621175,0.0321456,19.788975,7.6763825,24.4088346,5.4151763,8.8466291,0.0990129,30.9256989),(8821,'metatarsus.tif',183,10,101,14.0653397,15.9983262,16.8715167,1.8,15.9675401,16.9546086,0.1974625,3.366855,4.3385593,25.7167927,78.8201843,0.0902228,18.1673636,7.6382241,23.7553672,5.4644052,8.6890477,2.8559199,34.204645),(8822,'metatarsus.tif',183,10,102,14.3757748,15.9208648,16.9668115,1.8,15.9004419,17.0303501,0.1164113,3.1682431,4.2483794,25.195574,68.2134028,0.0323227,16.0563351,7.9525381,21.6657087,5.4226305,8.1528337,2.8515057,35.0974342),(8823,'metatarsus.tif',183,10,103,13.9854427,15.8699185,17.101622,1.8,15.8509427,17.143875,0.0676062,3.1085291,3.8411418,21.9495142,57.3170376,0.0106374,14.9218749,7.0610611,20.5995417,5.2079214,7.5245408,2.9624322,32.4815097),(8824,'metatarsus.tif',183,10,104,10.8437077,16.2430007,17.2522368,1.8,16.1692041,17.2278665,0.1346307,2.7131119,3.4775361,12.7336035,36.9264023,0.0325604,10.6185531,4.6933573,13.3614799,4.5572866,6.8737161,0.2223488,27.5877419),(8825,'metatarsus.tif',183,10,105,4.7218538,17.3741687,17.5274,1.8,17.3472806,17.5211955,1.0856118,1.4560353,2.2741254,1.461102,4.2890277,0.6158065,1.8860119,1.0034798,2.4430627,2.5039534,4.2988099,1.9311543,11.3623465),(8826,'metatarsus.tif',183,10,106,18.9740574,15.6988516,18.5789177,1.8,15.5977961,18.6042161,0.0969035,2.7305209,5.1898968,30.7247498,115.9346329,0.0296025,22.3385236,11.25234,28.1275037,0.5609257,2.1117159,1.4601391,4.7630218),(8827,'metatarsus.tif',183,10,107,15.07916,15.6162692,18.6775006,1.8,15.6269876,18.6733894,0.0176149,2.3184558,4.5255936,24.6031617,83.7919345,0.0007797,18.5151258,10.6118746,23.3526155,5.9907378,8.7539351,2.8788453,44.6317644),(8828,'metacarpus.tif',183,5,1,11.462566,5.133853,10.189045,1.8,5.13639,10.236762,0.141719,2.680719,3.794857,17.927556,34.846015,0.038113,9.182432,6.687593,12.535456,5.250152,6.363024,2.76666,22.806412),(8829,'metacarpus.tif',183,5,2,11.563219,5.1498,10.238244,1.8,5.15399,10.277706,0.182956,2.647954,3.508383,14.576148,35.154375,0.063792,10.020108,5.504684,13.707698,4.238792,6.417714,2.851846,20.116123),(8830,'metacarpus.tif',183,5,3,1.164292,5.091917,7.873152,1.8,5.122356,7.909364,0.762136,0.582854,1.335524,0.065976,0.535565,0.092512,0.401015,0.113195,0.439795,1.120229,2.567086,2.504044,7.189552),(8831,'metacarpus.tif',183,5,4,4.132098,4.310782,8.583002,1.8,4.333937,8.591537,-0.750083,1.565081,2.965703,1.836535,7.579652,0.320041,2.555769,1.173444,3.155127,1.905492,2.971263,2.999696,10.010263),(8832,'metacarpus.tif',183,5,5,6.847947,4.097294,8.811503,1.8,4.125482,8.836302,-0.858282,1.714352,2.733656,3.243796,10.777554,0.653552,3.942541,1.892141,5.123595,3.015149,4.872859,0.851966,14.543421),(8833,'metacarpus.tif',183,5,6,7.749007,4.098873,8.802536,1.8,4.13513,8.844065,-0.865715,1.747051,2.755383,4.218802,13.091202,0.749034,4.751136,2.414813,6.251588,3.117883,5.077727,0.554612,15.981913),(8834,'metacarpus.tif',183,5,7,7.813816,4.305707,8.71799,1.8,4.31623,8.767497,-0.765843,1.917298,2.99942,5.836335,15.03964,0.625692,5.014182,3.044042,6.799854,3.382679,5.287769,0.521834,15.731926),(8835,'metacarpus.tif',183,5,8,9.954086,5.10285,8.984653,1.8,5.150349,9.047593,0.107419,2.405358,3.385545,13.777327,27.711267,0.01907,8.185171,5.727766,11.096148,4.579969,6.249525,3.055913,24.861533),(8836,'metacarpus.tif',183,5,9,10.744242,5.37148,9.125038,1.8,5.354812,9.168914,0.253707,2.504506,3.237992,15.30073,31.850757,0.112811,9.836577,6.10928,13.240751,4.625319,6.256526,0.097846,24.438619),(8837,'metacarpus.tif',183,5,10,10.300216,5.349424,9.112409,1.8,5.32636,9.173897,0.26205,2.428843,3.249855,15.638964,30.199241,0.115213,9.292488,6.438854,12.983985,4.601335,6.276436,0.0609,24.57831),(8838,'metacarpus.tif',183,5,11,9.663481,5.23546,9.045325,1.8,5.230908,9.118689,0.21798,2.597551,3.326131,15.328503,26.577586,0.075323,7.990541,5.901137,11.9695,4.668398,6.230817,0.116751,19.789736),(8839,'metacarpus.tif',183,5,12,9.404536,5.210128,9.051116,1.8,5.199863,9.130125,0.26601,2.569094,3.356482,15.150044,24.576854,0.108322,7.322207,5.897038,11.45817,4.576717,6.173408,0.086738,19.75809),(8840,'metacarpus.tif',183,5,13,9.049067,5.222961,9.03886,1.8,5.208849,9.124462,0.265607,2.574154,3.300125,14.479079,23.001606,0.103919,6.969919,5.624792,10.991281,4.523838,6.126427,0.068642,23.218468),(8841,'metacarpus.tif',183,5,14,8.740307,5.228749,9.009008,1.8,5.237211,9.099283,0.213918,2.551437,3.233815,13.740213,21.68569,0.06565,6.705916,5.385284,10.517905,4.51988,6.091074,0.075329,23.529497),(8842,'metacarpus.tif',183,5,15,8.540411,5.238396,9.00834,1.8,5.225758,9.09494,0.201373,2.481073,3.168781,13.334975,20.795749,0.056945,6.562696,5.37468,10.40998,4.458293,5.986685,0.095859,20.719645),(8843,'metacarpus.tif',183,5,16,8.231752,5.235351,8.95852,1.8,5.223841,9.042941,0.195848,2.385327,3.124427,12.372924,19.425586,0.051954,6.217327,5.187096,9.826364,4.406303,5.937244,0.135528,20.283622),(8844,'metacarpus.tif',183,5,17,8.046842,5.236853,8.909018,1.8,5.218188,8.988093,0.1686,2.299058,3.056732,11.584836,18.309775,0.037763,5.989985,5.038948,9.377654,4.301974,5.804641,0.112111,18.282523),(8845,'metacarpus.tif',183,5,18,7.95009,5.252136,8.88236,1.8,5.226749,8.957248,0.157759,2.226181,2.995545,11.151349,17.82307,0.032704,5.94986,5.009184,9.292641,4.289907,5.737889,0.126832,18.444592),(8846,'metacarpus.tif',183,5,19,7.835868,5.259379,8.842057,1.8,5.233623,8.913557,0.131294,2.137902,2.952277,10.649567,17.130709,0.022383,5.802541,4.981316,9.07435,4.193135,5.624229,0.12941,17.576385),(8847,'metacarpus.tif',183,5,20,7.772869,5.274998,8.79775,1.8,5.257055,8.864086,0.135882,2.069128,2.919978,10.257918,16.388732,0.023773,5.612621,4.957604,8.876453,4.114864,5.526736,0.096918,17.594923),(8848,'metacarpus.tif',183,5,21,7.705181,5.291395,8.752718,1.8,5.276171,8.814265,0.11568,2.031317,2.86437,9.825787,15.804203,0.017108,5.517515,4.837151,8.627237,4.047575,5.429912,0.126973,17.041585),(8849,'metacarpus.tif',183,5,22,7.646136,5.308767,8.71374,1.8,5.292571,8.776255,0.10335,1.995521,2.819084,9.430705,15.440572,0.013563,5.477159,4.725937,8.491063,3.991962,5.378609,0.106736,16.857139),(8850,'metacarpus.tif',183,5,23,7.642281,5.328817,8.671316,1.8,5.320279,8.730449,0.098712,1.962161,2.777963,9.084507,15.069047,0.012371,5.424495,4.629849,8.31553,3.950277,5.316254,0.129703,16.618671),(8851,'metacarpus.tif',183,5,24,7.687833,5.347252,8.628662,1.8,5.339345,8.684851,0.105723,1.934929,2.744946,8.822218,14.906572,0.014268,5.430552,4.559452,8.257907,3.889147,5.26897,0.116262,16.726716),(8852,'metacarpus.tif',183,5,25,7.725323,5.36878,8.587091,1.8,5.361931,8.639205,0.116524,1.910996,2.718118,8.533566,14.725216,0.017403,5.417431,4.465508,8.146155,3.816839,5.207824,0.139822,16.384041),(8853,'metacarpus.tif',183,5,26,7.759416,5.387042,8.55133,1.8,5.383302,8.599022,0.128139,1.918014,2.707968,8.299418,14.638827,0.021119,5.405834,4.327089,8.129463,3.768321,5.155161,0.11884,16.033687),(8854,'metacarpus.tif',183,5,27,7.78066,5.400633,8.515411,1.8,5.395066,8.560171,0.136204,1.861257,2.677438,8.055111,14.505444,0.023909,5.417659,4.327781,8.036333,3.713997,5.117232,0.119725,15.938749),(8855,'metacarpus.tif',183,5,28,7.804756,5.41646,8.473527,1.8,5.413835,8.515603,0.147381,1.838784,2.671019,7.764854,14.285316,0.028051,5.348264,4.22282,7.933119,3.667028,5.070681,0.105666,15.709549),(8856,'metacarpus.tif',183,5,29,7.844818,5.433264,8.43817,1.8,5.431469,8.47943,0.159991,1.818162,2.663461,7.562411,14.127806,0.033183,5.304304,4.159372,7.850122,3.59931,5.021811,3.05782,15.47108),(8857,'metacarpus.tif',183,5,30,7.887309,5.449219,8.398947,1.8,5.452516,8.438692,0.169674,1.803497,2.654901,7.383752,13.949277,0.037483,5.254161,4.094131,7.715731,3.562928,4.990768,3.041924,15.200965),(8858,'metacarpus.tif',183,5,31,7.922594,5.463455,8.362627,1.8,5.465875,8.402229,0.176958,1.792223,2.638955,7.266275,13.772775,0.040919,5.219027,4.054337,7.691227,3.557326,4.980671,3.064821,15.111457),(8859,'metacarpus.tif',183,5,32,7.925,5.476456,8.323361,1.8,5.480645,8.362589,0.18339,1.775259,2.637502,7.106291,13.649546,0.043926,5.17518,4.002961,7.574262,3.514121,4.952759,3.041157,15.025788),(8860,'metacarpus.tif',183,5,33,7.958676,5.491816,8.286558,1.8,5.49482,8.324467,0.190737,1.76305,2.627084,7.007322,13.519036,0.047674,5.146023,3.974546,7.529715,3.500155,4.942584,3.064228,14.994142),(8861,'metacarpus.tif',183,5,34,7.975853,5.501377,8.247631,1.8,5.50395,8.285084,0.188287,1.754679,2.616197,6.907088,13.428867,0.046572,5.132972,3.936383,7.482184,3.481344,4.911041,3.048116,14.917742),(8862,'metacarpus.tif',183,5,35,7.991247,5.511654,8.213841,1.8,5.516028,8.250454,0.19383,1.746491,2.608947,6.795851,13.331278,0.049415,5.109831,3.891145,7.435853,3.452928,4.907622,3.055866,14.895365),(8863,'metacarpus.tif',183,5,36,8.015417,5.523457,8.181094,1.8,5.528182,8.217768,0.196697,1.747594,2.583105,6.683514,13.265164,0.051022,5.135356,3.824409,7.396881,3.426622,4.856811,3.007482,14.660736),(8864,'metacarpus.tif',183,5,37,8.013986,5.53458,8.148017,1.8,5.53597,8.183798,0.200762,1.740938,2.574269,6.630507,13.254474,0.053115,5.148831,3.808584,7.406777,3.41665,4.851851,3.015285,14.683113),(8865,'metacarpus.tif',183,5,38,8.009517,5.545895,8.115382,1.8,5.54804,8.150184,0.204999,1.734148,2.572993,6.574646,13.199652,0.055318,5.130077,3.791284,7.359352,3.409648,4.847187,3.023103,14.625251),(8866,'metacarpus.tif',183,5,39,8.01555,5.555637,8.082058,1.8,5.559079,8.116404,0.205881,1.722467,2.577107,6.495172,13.133513,0.05583,5.096224,3.770854,7.334882,3.37761,4.847187,3.023103,14.606713),(8867,'metacarpus.tif',183,5,40,8.020445,5.56235,8.046593,1.8,5.566958,8.080415,0.202194,1.717792,2.575242,6.428389,13.043664,0.053909,5.065026,3.742239,7.295994,3.380724,4.851851,3.015285,14.602874),(8868,'metacarpus.tif',183,5,41,8.032829,5.571897,8.012399,1.8,5.575477,8.046349,0.201297,1.720249,2.5721,6.374455,13.0135,0.05352,5.059483,3.705542,7.242338,3.380724,4.851851,3.015285,14.593605),(8869,'metacarpus.tif',183,5,42,8.030635,5.578934,7.977565,1.8,5.582237,8.011067,0.201766,1.707442,2.564875,6.324068,12.930825,0.053752,5.041502,3.703826,7.213607,3.362395,4.838751,3.038782,14.526474),(8870,'metacarpus.tif',183,5,43,8.044979,5.585774,7.943014,1.8,5.589925,7.977517,0.203324,1.701311,2.558573,6.267077,12.894085,0.054671,5.039562,3.683674,7.199398,3.356419,4.829846,2.990747,14.548851),(8871,'metacarpus.tif',183,5,44,8.07183,5.596385,7.910058,1.8,5.602118,7.944988,0.209899,1.701316,2.551801,6.209942,12.818504,0.058405,5.023317,3.650081,7.181428,3.335176,4.824253,2.998576,14.418428),(8872,'metacarpus.tif',183,5,45,8.067336,5.601983,7.874506,1.8,5.605423,7.907726,0.210672,1.694391,2.546317,6.149936,12.764614,0.058798,5.012971,3.629585,7.155124,3.309957,4.818957,3.006422,14.409159),(8873,'metacarpus.tif',183,5,46,8.067466,5.611216,7.840893,1.8,5.614526,7.873403,0.211503,1.688498,2.544926,6.101245,12.732751,0.059256,5.003191,3.613417,7.111668,3.305466,4.818957,3.006422,14.355136),(8874,'metacarpus.tif',183,5,47,8.076267,5.625831,7.806468,1.8,5.631509,7.839002,0.218845,1.680784,2.535152,6.065208,12.683172,0.063444,5.002924,3.608559,7.118754,3.293984,4.792083,2.989549,14.32349),(8875,'metacarpus.tif',183,5,48,8.074478,5.634975,7.770914,1.8,5.639084,7.803037,0.221696,1.67174,2.527674,6.012553,12.661906,0.065066,5.00931,3.596584,7.115828,3.277885,4.792083,2.989549,14.269467),(8876,'metacarpus.tif',183,5,49,8.06816,5.642967,7.734954,1.8,5.646811,7.767834,0.225182,1.670473,2.521828,5.981927,12.624017,0.067041,5.005899,3.580979,7.111668,3.277308,4.786446,2.997438,14.386782),(8877,'metacarpus.tif',183,5,50,8.072129,5.649091,7.699978,1.8,5.65219,7.733035,0.227122,1.662681,2.527896,5.962556,12.654628,0.068214,5.005993,3.586109,7.123789,3.260559,4.809257,3.022164,14.494828),(8878,'metacarpus.tif',183,5,51,8.114011,5.657138,7.66667,1.8,5.659188,7.69968,0.228373,1.664951,2.52831,5.962326,12.67993,0.069312,5.015181,3.581081,7.029075,3.24144,4.813958,3.014285,14.940119),(8879,'metacarpus.tif',183,5,52,8.133145,5.667907,7.62926,1.8,5.671377,7.66016,0.228738,1.654418,2.526523,5.923127,12.663891,0.069694,5.012379,3.580187,7.1256,3.21852,4.818957,3.006422,14.269467),(8880,'metacarpus.tif',183,5,53,8.162782,5.674592,7.594466,1.8,5.675829,7.626721,0.225472,1.655108,2.525686,5.906451,12.69899,0.067999,5.027937,3.56862,7.111532,3.208243,4.818957,3.006422,14.679274),(8881,'metacarpus.tif',183,5,54,8.181895,5.68301,7.557255,1.8,5.683655,7.588128,0.228429,1.652856,2.519269,5.87272,12.658834,0.069926,5.024804,3.553074,7.052272,3.184524,4.818957,3.006422,14.453913),(8882,'metacarpus.tif',183,5,55,8.198006,5.691689,7.521108,1.8,5.692362,7.550928,0.229277,1.643815,2.510923,5.832267,12.602541,0.070576,5.019086,3.548006,7.080805,3.169912,4.813958,3.014285,14.237821),(8883,'metacarpus.tif',183,5,56,8.209001,5.700704,7.484614,1.8,5.701306,7.513711,0.231857,1.642106,2.503488,5.812584,12.599909,0.072241,5.032943,3.539712,7.095826,3.166519,4.798017,2.98168,14.215444),(8884,'metacarpus.tif',183,5,57,8.211661,5.708215,7.448822,1.8,5.708765,7.478318,0.233301,1.640128,2.496584,5.803565,12.603948,0.073151,5.048478,3.538484,7.115036,3.15441,4.792083,2.989549,14.152152),(8885,'metacarpus.tif',183,5,58,8.209753,5.716803,7.413003,1.8,5.71774,7.443023,0.23343,1.631574,2.49842,5.771017,12.624188,0.073213,5.052869,3.537085,6.973177,3.162296,4.809257,3.022164,14.485559),(8886,'metacarpus.tif',183,5,59,8.20159,5.72684,7.376867,1.8,5.72625,7.406151,0.233619,1.63118,2.48828,5.741885,12.614461,0.073257,5.069551,3.520081,7.013796,3.182715,4.809257,3.022164,14.377513),(8887,'metacarpus.tif',183,5,60,8.197271,5.73762,7.339369,1.8,5.736541,7.368441,0.239255,1.626891,2.48971,5.701698,12.585765,0.076725,5.055113,3.504658,7.106585,3.130679,4.804856,3.030057,14.053375),(8888,'metacarpus.tif',183,5,61,8.199547,5.746746,7.301991,1.8,5.746162,7.330756,0.237956,1.626115,2.488912,5.686856,12.635648,0.075931,5.076776,3.497205,7.001905,3.130679,4.804856,3.030057,14.075752),(8889,'metacarpus.tif',183,5,62,8.179275,5.758373,7.264501,1.8,5.756248,7.292713,0.239525,1.622477,2.487463,5.651272,12.6092,0.076726,5.0691,3.483114,7.0597,3.124782,4.809257,3.022164,14.030998),(8890,'metacarpus.tif',183,5,63,8.177986,5.766917,7.228639,1.8,5.763546,7.257147,0.236415,1.623697,2.476595,5.639633,12.607957,0.074772,5.090844,3.473329,6.926819,3.124782,4.809257,3.022164,14.139044),(8891,'metacarpus.tif',183,5,64,8.179376,5.774241,7.191754,1.8,5.771218,7.219726,0.237444,1.622931,2.469836,5.603001,12.60957,0.075425,5.105428,3.452397,7.038267,3.124782,4.792083,2.989549,13.967706),(8892,'metacarpus.tif',183,5,65,8.178732,5.778869,7.156943,1.8,5.774295,7.185358,0.232622,1.617882,2.480949,5.597452,12.662996,0.072442,5.104093,3.45974,7.001061,3.11115,4.818957,3.006422,14.044106),(8893,'metacarpus.tif',183,5,66,8.200753,5.782221,7.119779,1.8,5.77891,7.147974,0.228832,1.619464,2.475249,5.578355,12.685943,0.07033,5.125119,3.444568,6.995246,3.11115,4.818957,3.006422,14.066483),(8894,'metacarpus.tif',183,5,67,8.202697,5.787952,7.081846,1.8,5.785288,7.109446,0.22779,1.618797,2.47762,5.554903,12.721834,0.069719,5.134699,3.431501,7.064113,3.102232,4.818957,3.006422,14.01246),(8895,'metacarpus.tif',183,5,68,8.171686,5.795927,7.043456,1.8,5.793172,7.071005,0.227342,1.749783,2.478223,5.534407,12.740389,0.069187,5.140938,3.16291,7.042524,3.093534,4.824253,2.998576,13.904414),(8896,'metacarpus.tif',183,5,69,8.157609,5.802377,7.003647,1.8,5.798998,7.030881,0.226706,1.614187,2.483339,5.49591,12.75883,0.068689,5.137772,3.404755,7.016856,3.083785,4.84282,3.030935,13.882037),(8897,'metacarpus.tif',183,5,70,8.14093,5.810687,6.965682,1.8,5.808013,6.991737,0.22494,1.610054,2.491251,5.458947,12.783396,0.067502,5.131317,3.390536,7.009748,3.072343,4.851851,3.015285,13.980814),(8898,'metacarpus.tif',183,5,71,8.060793,5.819216,6.926401,1.8,5.815196,6.953503,0.223021,1.607525,2.490405,5.421584,12.780167,0.065721,5.131763,3.372627,6.982981,3.062726,4.856811,3.007482,14.025568),(8899,'metacarpus.tif',183,5,72,8.039657,5.823265,6.888097,1.8,5.819398,6.914675,0.221937,1.606771,2.494152,5.402171,12.794698,0.064924,5.129878,3.362129,6.99947,3.062726,4.856811,3.007482,14.038677),(8900,'metacarpus.tif',183,5,73,8.046757,5.830098,6.852108,1.8,5.827115,6.879786,0.218613,1.612313,2.517744,5.376801,12.760457,0.06308,5.068211,3.334837,6.80552,3.058504,4.851851,3.015285,13.993923),(8901,'metacarpus.tif',183,5,74,8.045705,5.834584,6.812586,1.8,5.831198,6.8395,0.214535,1.610176,2.498587,5.347466,12.791374,0.060777,5.119444,3.321044,6.975883,3.086178,4.880788,3.0318,14.047946),(8902,'metacarpus.tif',183,5,75,8.054465,5.83899,6.775194,1.8,5.83634,6.801875,0.211031,1.610131,2.577164,5.329917,12.848632,0.058901,4.985569,3.310238,6.675847,3.088676,4.867616,2.991927,14.290254),(8903,'metacarpus.tif',183,5,76,8.02528,5.847457,6.736253,1.8,5.847721,6.763637,0.205788,1.607793,2.495765,5.281488,12.763974,0.055848,5.114254,3.284931,6.91898,3.036505,4.867616,2.991927,13.800208),(8904,'metacarpus.tif',183,5,77,8.003587,5.848667,6.694561,1.8,5.846663,6.720169,0.199985,1.604256,2.490859,5.237495,12.74806,0.052642,5.117938,3.26475,6.897278,3.026988,4.867616,2.991927,13.800208),(8905,'metacarpus.tif',183,5,78,7.990927,5.852681,6.654007,1.8,5.850425,6.679938,0.196448,1.601401,2.484636,5.207671,12.713674,0.05074,5.116916,3.251947,6.878959,3.016343,4.862066,2.999696,13.638139),(8906,'metacarpus.tif',183,5,79,8.008449,5.856859,6.614574,1.8,5.854177,6.640107,0.192564,1.600195,2.47771,5.164463,12.717398,0.048885,5.132722,3.227396,6.871894,3.01241,4.862066,2.999696,13.638139),(8907,'metacarpus.tif',183,5,80,7.984301,5.864766,6.574988,1.8,5.865919,6.601464,0.190012,1.605079,2.491252,5.137422,12.710495,0.04747,5.10205,3.200728,6.875374,3.01241,4.867616,2.991927,13.62887),(8908,'metacarpus.tif',183,5,81,7.928834,5.866311,6.531671,1.8,5.866222,6.557892,0.184609,1.600681,2.493747,5.098142,12.715852,0.044527,5.099094,3.184984,6.818993,2.994956,4.867616,2.991927,13.638139),(8909,'metacarpus.tif',183,5,82,7.914696,5.870034,6.491637,1.8,5.868549,6.518843,0.181729,1.598675,2.488165,5.067769,12.728069,0.043087,5.115444,3.169981,6.809214,2.99397,4.867616,2.991927,13.669785),(8910,'metacarpus.tif',183,5,83,7.918715,5.87413,6.450321,1.8,5.872199,6.477646,0.178859,1.595344,2.506415,5.033229,12.724862,0.041772,5.076918,3.154948,6.762331,3.000868,4.894671,3.008525,13.876608),(8911,'metacarpus.tif',183,5,84,7.915063,5.883986,6.408791,1.8,5.883011,6.434778,0.176562,1.590706,2.502353,4.995115,12.701079,0.040699,5.075654,3.140187,6.756818,2.97613,4.899885,3.000798,13.682893),(8912,'metacarpus.tif',183,5,85,7.872027,5.891227,6.367953,1.8,5.89148,6.394157,0.174616,1.587175,2.500823,4.958205,12.71686,0.039599,5.08507,3.123918,6.722447,2.969497,4.905392,2.993088,13.638139),(8913,'metacarpus.tif',183,5,86,7.827068,5.899666,6.327749,1.8,5.898265,6.354939,0.170961,1.584383,2.489864,4.92535,12.706135,0.037758,5.103144,3.108687,6.713049,2.952416,4.899885,3.000798,13.543201),(8914,'metacarpus.tif',183,5,87,7.766348,5.91132,6.286371,1.8,5.907494,6.313053,0.169077,1.574099,2.502153,4.875464,12.699602,0.036652,5.075469,3.097303,6.676675,2.980949,4.92306,3.024937,14.038677),(8915,'metacarpus.tif',183,5,88,7.733013,5.919888,6.243902,1.8,5.916474,6.268422,0.167611,1.568442,2.499684,4.834487,12.699905,0.03587,5.080603,3.082351,6.663656,2.921197,4.927652,3.017238,13.660516),(8916,'metacarpus.tif',183,5,89,7.723469,5.927164,6.203937,1.8,5.926059,6.229802,0.166088,1.571583,2.491581,4.804427,12.678151,0.035184,5.088397,3.057063,6.666946,2.920888,4.911189,2.985395,13.533932),(8917,'metacarpus.tif',183,5,90,7.714655,5.933944,6.166372,1.8,5.932735,6.193039,0.162512,1.558816,2.48807,4.762525,12.688915,0.03366,5.099904,3.055219,6.634867,2.901086,4.917276,2.977721,13.565578),(8918,'metacarpus.tif',183,5,91,7.686841,5.941823,6.126773,1.8,5.941165,6.153485,0.160367,1.556251,2.50419,4.708025,12.700477,0.032666,5.071691,3.025236,6.632511,2.882103,4.93771,3.001884,13.736916),(8919,'metacarpus.tif',183,5,92,7.678109,5.946809,6.085503,1.8,5.944283,6.110312,0.156053,1.558542,2.502293,4.665747,12.737581,0.030912,5.090364,2.993662,6.460113,2.882103,4.943175,2.994231,13.669785),(8920,'metacarpus.tif',183,5,93,7.671368,5.951806,6.0459,1.8,5.950949,6.070228,0.153038,1.556388,2.495048,4.624634,12.789926,0.029712,5.126124,2.971389,6.606933,2.876786,4.943175,2.994231,13.692162),(8921,'metacarpus.tif',183,5,94,7.650254,5.95652,6.005081,1.8,5.954923,6.029421,0.149087,1.54174,2.493105,4.587635,12.82044,0.028131,5.142359,2.975623,6.573937,2.860837,4.948928,2.986596,13.62887),(8922,'metacarpus.tif',183,5,95,7.599707,5.968669,5.963768,1.8,5.966596,5.989544,0.150207,1.531043,2.508894,4.551218,12.822773,0.028363,5.110927,2.972625,6.547836,2.850204,4.975541,3.002953,13.597224),(8923,'metacarpus.tif',183,5,96,7.557094,5.975114,5.922628,1.8,5.970212,5.947139,0.148063,1.517845,2.506838,4.492813,12.791722,0.027411,5.102732,2.959994,6.496907,2.824471,4.975541,3.002953,13.610332),(8924,'metacarpus.tif',183,5,97,7.556515,5.98097,5.879493,1.8,5.974872,5.903763,0.145437,1.511933,2.499491,4.445483,12.814371,0.026452,5.126792,2.940263,6.47043,2.811528,4.975541,3.002953,13.587955),(8925,'metacarpus.tif',183,5,98,7.55221,5.987056,5.8387,1.8,5.980448,5.862211,0.142773,1.508322,2.518443,4.426512,12.860563,0.025484,5.106553,2.934727,6.464678,2.80309,5.003471,3.019132,13.673624),(8926,'metacarpus.tif',183,5,99,7.563054,5.992335,5.797399,1.8,5.986954,5.821047,0.140192,1.504343,2.516909,4.400393,12.894345,0.024612,5.123088,2.925125,6.480495,2.780753,5.003471,3.019132,13.578686),(8927,'metacarpus.tif',183,5,100,7.577718,5.996289,5.753866,1.8,5.990463,5.777827,0.138059,1.49838,2.511909,4.368885,12.943301,0.02392,5.152775,2.915739,6.474098,2.768745,5.003471,3.019132,13.578686),(8928,'metacarpus.tif',183,5,101,7.549036,6.00008,5.709107,1.8,5.994794,5.733261,0.133723,1.485994,2.532942,4.323899,12.981914,0.022365,5.125232,2.909769,6.458332,2.741036,5.036899,3.027585,13.727647),(8929,'metacarpus.tif',183,5,102,7.539724,6.00662,5.6656,1.8,6.001328,5.690036,0.132565,1.479835,2.531284,4.290358,13.023574,0.021954,5.145047,2.899213,6.430084,2.739441,5.041387,3.020057,13.664355),(8930,'metacarpus.tif',183,5,103,7.47135,6.010879,5.622044,1.8,6.005353,5.646685,0.131037,1.468938,2.531458,4.244723,13.035694,0.021259,5.14948,2.889655,6.43319,2.731455,5.046161,3.012543,13.62344),(8931,'metacarpus.tif',183,5,104,7.458938,6.012001,5.582842,1.8,6.008624,5.608478,0.128942,1.453091,2.556658,4.211191,13.151586,0.020555,5.144053,2.898092,6.427757,2.716963,5.074852,3.028442,13.727647),(8932,'metacarpus.tif',183,5,105,7.453621,6.016302,5.540844,1.8,6.014119,5.566579,0.127517,1.448955,2.561422,4.178251,13.194604,0.020091,5.15128,2.883631,6.397316,2.706769,5.079307,3.020969,13.718378),(8933,'metacarpus.tif',183,5,106,7.475383,6.019814,5.498167,1.8,6.017069,5.523563,0.124504,1.444456,2.555763,4.151206,13.27728,0.019213,5.195035,2.873889,6.416352,2.703108,5.079307,3.020969,13.772401),(8934,'metacarpus.tif',183,5,107,7.459669,6.020658,5.456471,1.8,6.018079,5.481153,0.120973,1.44132,2.580802,4.103906,13.330544,0.018106,5.165272,2.847325,6.379586,2.685336,5.10867,3.036716,13.740755),(8935,'metacarpus.tif',183,5,108,7.467766,6.028258,5.416833,1.8,6.026357,5.441548,0.119933,1.439109,2.577117,4.079942,13.41164,0.017817,5.204125,2.835047,6.414723,2.685336,5.11281,3.029285,13.826424),(8936,'metacarpus.tif',183,5,109,7.435264,6.029015,5.375258,1.8,6.028835,5.400252,0.118469,1.431338,2.579974,4.043877,13.434321,0.017311,5.207154,2.825243,6.369232,2.681674,5.121935,3.014462,13.85807),(8937,'metacarpus.tif',183,5,110,7.403127,6.030895,5.336089,1.8,6.030807,5.361671,0.117727,1.425789,2.606488,3.998205,13.506029,0.017022,5.181697,2.804204,6.379138,2.67069,5.150771,3.030116,13.898985),(8938,'metacarpus.tif',183,5,111,7.392145,6.036705,5.295753,1.8,6.037137,5.320928,0.115005,1.419163,2.607385,3.962797,13.597036,0.016223,5.214818,2.792349,6.332812,2.659707,5.155161,3.022752,13.921362),(8939,'metacarpus.tif',183,5,112,7.366789,6.040411,5.255391,1.8,6.044496,5.280905,0.112059,1.400705,2.626298,3.90728,13.691924,0.015353,5.213393,2.789509,6.352397,2.631255,5.159829,3.015401,13.943739),(8940,'metacarpus.tif',183,5,113,7.366793,6.044331,5.214976,1.8,6.049661,5.240223,0.11045,1.393935,2.629719,3.87181,13.79711,0.014917,5.24661,2.777612,6.343262,2.629844,5.17,3.000741,13.956847),(8941,'metacarpus.tif',183,5,114,7.364157,6.047573,5.173483,1.8,6.050477,5.198644,0.107152,1.390592,2.64953,3.832254,13.885397,0.014038,5.240702,2.755845,6.3261,2.611521,5.218881,3.046294,14.118916),(8942,'metacarpus.tif',183,5,115,7.309177,6.054054,5.132989,1.8,6.059117,5.158123,0.108995,1.383292,2.657296,3.787239,13.915441,0.014415,5.236691,2.737845,6.291891,2.626183,5.226704,3.031743,14.226962),(8943,'metacarpus.tif',183,5,116,7.280554,6.056416,5.09287,1.8,6.058966,5.117871,0.105618,1.373517,2.677918,3.74976,13.979461,0.013486,5.220271,2.730043,6.304253,2.603862,5.256909,3.046985,14.357385),(8944,'metacarpus.tif',183,5,117,7.277254,6.066274,5.053659,1.8,6.068368,5.077825,0.105031,1.367593,2.67575,3.720808,14.10426,0.013331,5.271143,2.720697,6.315983,2.597203,5.264675,3.032538,14.379762),(8945,'metacarpus.tif',183,5,118,7.256954,6.075432,5.015163,1.8,6.079077,5.039541,0.10487,1.362382,2.666528,3.68137,14.147913,0.013253,5.305744,2.702157,6.335895,2.588216,5.264675,3.032538,14.033247),(8946,'metacarpus.tif',183,5,119,7.194929,6.084083,4.976612,1.8,6.08489,4.999934,0.105109,1.357046,2.684143,3.647831,14.15781,0.0132,5.274612,2.688067,6.308496,2.584886,5.291493,3.054854,14.150562),(8947,'metacarpus.tif',183,5,120,7.171589,6.090155,4.937123,1.8,6.091518,4.96098,0.104853,1.341215,2.690032,3.598994,14.209269,0.013093,5.282192,2.683383,6.279255,2.563478,5.30265,3.033322,14.109647),(8948,'metacarpus.tif',183,5,121,7.13311,6.096047,4.897675,1.8,6.096356,4.920467,0.103197,1.335628,2.682809,3.539594,14.209968,0.012616,5.296676,2.650136,6.269265,2.55682,5.306914,3.026166,14.08727),(8949,'metacarpus.tif',183,5,122,7.101046,6.100777,4.857113,1.8,6.101225,4.879391,0.10243,1.329011,2.707839,3.501049,14.262857,0.012374,5.267246,2.634327,6.246062,2.546832,5.336665,3.041212,14.109647),(8950,'metacarpus.tif',183,5,123,7.074129,6.105916,4.81949,1.8,6.107322,4.84099,0.101582,1.321487,2.70971,3.460307,14.317997,0.012124,5.283958,2.618494,6.22112,2.533514,5.344861,3.026989,14.078001),(8951,'metacarpus.tif',183,5,124,7.063283,6.109719,4.782409,1.8,6.111272,4.80416,0.101377,1.322274,2.735901,3.431098,14.45093,0.012057,5.281965,2.594847,6.231169,2.530616,5.374674,3.041924,14.16367),(8952,'metacarpus.tif',183,5,125,7.034116,6.11258,4.745599,1.8,6.112275,4.767829,0.101179,1.315707,2.736608,3.394397,14.584747,0.011961,5.329498,2.579903,6.26424,2.524011,5.378609,3.034857,14.132024),(8953,'metacarpus.tif',183,5,126,7.008915,6.11172,4.707096,1.8,6.112349,4.728382,0.098558,1.312682,2.738975,3.351729,14.604938,0.01131,5.332263,2.553345,6.221169,2.521014,5.387284,3.020756,14.132024),(8954,'metacarpus.tif',183,5,127,6.999851,6.11684,4.667421,1.8,6.12074,4.689962,0.098302,1.295292,2.764308,3.296105,14.637669,0.011237,5.295238,2.54468,6.2114,2.497788,5.412685,3.042626,14.217693),(8955,'metacarpus.tif',183,5,128,6.982852,6.116785,4.629835,1.8,6.120881,4.652152,0.097269,1.288665,2.767151,3.256778,14.672003,0.010976,5.302205,2.527249,6.178451,2.485929,5.416593,3.035608,14.176778),(8956,'metacarpus.tif',183,5,129,6.957944,6.122061,4.591279,1.8,6.127961,4.613307,0.098951,1.287375,2.767175,3.220306,14.697794,0.011318,5.311479,2.501452,6.152479,2.471154,5.420767,3.028601,14.154401),(8957,'metacarpus.tif',183,5,130,6.948519,6.122494,4.553603,1.8,6.129508,4.575567,0.098236,1.284288,2.800312,3.179447,14.788356,0.01114,5.280966,2.47565,6.128856,2.467824,5.45458,3.036349,14.217693),(8958,'metacarpus.tif',183,5,131,6.934018,6.129067,4.51413,1.8,6.134791,4.536429,0.097277,1.278951,2.793061,3.146128,14.848936,0.010901,5.316367,2.459929,6.14982,2.464495,5.458725,3.02939,14.154401),(8959,'metacarpus.tif',183,5,132,6.910404,6.139129,4.476606,1.8,6.146045,4.499078,0.097147,1.260165,2.813477,3.100901,14.888638,0.010835,5.291899,2.460711,6.136194,2.447848,5.488717,3.044002,14.249339),(8960,'metacarpus.tif',183,5,133,6.906968,6.142944,4.439571,1.8,6.150215,4.461948,0.097201,1.252563,2.817024,3.061647,14.999456,0.010842,5.324575,2.444306,6.126935,2.433099,5.496687,3.030168,14.217693),(8961,'metacarpus.tif',183,5,134,6.901199,6.148024,4.402981,1.8,6.15678,4.42498,0.096562,1.246457,2.841913,3.041663,15.141515,0.010691,5.32793,2.440247,6.148221,2.433099,5.526736,3.044675,14.294093),(8962,'metacarpus.tif',183,5,135,6.895839,6.148422,4.368452,1.8,6.156149,4.38978,0.095841,1.246641,2.847907,3.01586,15.222113,0.010525,5.345017,2.419189,6.128309,2.42644,5.539,3.024081,14.230801),(8963,'metacarpus.tif',183,5,136,6.880895,6.154856,4.335186,1.8,6.161614,4.358281,0.096983,1.243132,2.842009,2.983868,15.296228,0.010753,5.382188,2.400282,6.158661,2.423111,5.539,3.024081,14.284824),(8964,'metacarpus.tif',183,5,137,6.896849,6.160021,4.302939,1.8,6.169249,4.326688,0.097867,1.232547,2.871329,2.969786,15.418227,0.010975,5.369717,2.409471,6.165383,2.405032,5.572619,3.031692,14.221532),(8965,'metacarpus.tif',183,5,138,6.895765,6.160802,4.270528,1.8,6.170209,4.294203,0.096037,1.23495,2.872178,2.949313,15.482323,0.010567,5.390448,2.388205,6.156892,2.400773,5.599265,3.052786,14.284824),(8966,'metacarpus.tif',183,5,139,6.930549,6.162347,4.234098,1.8,6.173209,4.257457,0.095202,1.233138,2.873398,2.941234,15.530658,0.010438,5.40498,2.385162,6.145009,2.397776,5.606558,3.039212,14.275555),(8967,'metacarpus.tif',183,5,140,6.938793,6.162322,4.199807,1.8,6.17338,4.223561,0.096378,1.236697,2.904754,2.928306,15.556793,0.010709,5.355632,2.367845,6.137485,2.400773,5.637316,3.053387,14.275555),(8968,'metacarpus.tif',183,5,141,6.955916,6.16811,4.166348,1.8,6.177061,4.190878,0.095453,1.237487,2.901443,2.926474,15.609454,0.010531,5.379893,2.364852,6.14074,2.410814,5.640809,3.046641,14.329578),(8969,'metacarpus.tif',183,5,142,6.97644,6.181695,4.132618,1.8,6.189495,4.156756,0.094549,1.233738,2.913953,2.920615,15.665233,0.010363,5.375939,2.36729,6.186541,2.410814,5.669194,3.067405,14.361224),(8970,'metacarpus.tif',183,5,143,6.938627,6.182647,4.097459,1.8,6.189462,4.121973,0.094316,1.233176,2.919748,2.894646,15.706134,0.010257,5.379278,2.34731,6.150579,2.412738,5.675368,3.05398,14.383601),(8971,'metacarpus.tif',183,5,144,6.930844,6.185753,4.062974,1.8,6.193745,4.088108,0.09411,1.233086,2.919734,2.887105,15.719491,0.0102,5.383878,2.341365,6.133524,2.410073,5.678838,3.047279,14.383601),(8972,'metacarpus.tif',183,5,145,6.960936,6.196578,4.030656,1.8,6.204015,4.055961,0.0954,1.237268,2.940206,2.900256,15.903366,0.010527,5.40893,2.344082,6.194901,2.410814,5.710229,3.061229,14.460001),(8973,'metacarpus.tif',183,5,146,6.960484,6.204793,3.995466,1.8,6.211726,4.020861,0.097345,1.227332,2.936873,2.891638,16.037533,0.010958,5.460751,2.356036,6.23716,2.401823,5.713423,3.054565,14.460001),(8974,'metacarpus.tif',183,5,147,6.957207,6.210734,3.963179,1.8,6.214831,3.987497,0.098745,1.220087,2.935214,2.887859,16.161678,0.01127,5.506133,2.366928,6.264983,2.38529,5.71687,3.047908,14.450732),(8975,'metacarpus.tif',183,5,148,6.970588,6.213013,3.929191,1.8,6.21763,3.954501,0.09815,1.220535,2.966333,2.883573,16.294747,0.011156,5.49323,2.362548,6.268216,2.395669,5.754903,3.048529,14.504755),(8976,'metacarpus.tif',183,5,149,6.961043,6.223309,3.894056,1.8,6.227176,3.917789,0.098388,1.218723,2.959716,2.873533,16.385767,0.011195,5.536263,2.357824,6.289673,2.395669,5.754903,3.048529,14.536401),(8977,'metacarpus.tif',183,5,150,6.916079,6.231639,3.860859,1.8,6.235449,3.883481,0.099701,1.203252,2.951958,2.845565,16.374207,0.01142,5.546897,2.364895,6.296408,2.366637,5.754903,3.048529,14.568047),(8978,'metacarpus.tif',183,5,151,6.881763,6.230582,3.823399,1.8,6.236836,3.846668,0.100025,1.204016,2.957002,2.85111,16.39115,0.011437,5.543166,2.368001,6.274422,2.363972,5.762505,3.035328,14.549509),(8979,'metacarpus.tif',183,5,152,6.877332,6.233322,3.785507,1.8,6.242589,3.809004,0.10045,1.200099,2.981105,2.863704,16.480368,0.011527,5.528275,2.386224,6.313111,2.363972,5.786386,3.062289,14.581155),(8980,'metacarpus.tif',183,5,153,6.872887,6.233779,3.74938,1.8,6.240027,3.772565,0.100264,1.202175,2.987961,2.874673,16.555283,0.011477,5.540661,2.391227,6.29773,2.352512,5.792939,3.049142,14.612801),(8981,'metacarpus.tif',183,5,154,6.877006,6.238742,3.713645,1.8,6.245319,3.737663,0.099289,1.204447,2.982027,2.900039,16.595725,0.011262,5.565249,2.407776,6.330363,2.355177,5.792939,3.049142,15.278024),(8982,'metacarpus.tif',183,5,155,6.906001,6.238985,3.682114,1.8,6.244127,3.703921,0.099364,1.207245,2.981182,2.930072,16.639727,0.011327,5.581588,2.427073,6.359608,2.363972,5.792939,3.049142,14.689201),(8983,'metacarpus.tif',183,5,156,6.941644,6.246503,3.650382,1.8,6.253149,3.674234,0.099156,1.213013,3.007132,2.961624,16.803106,0.011338,5.587751,2.441544,6.393948,2.355177,5.827598,3.056274,14.743224),(8984,'metacarpus.tif',183,5,157,6.963667,6.255857,3.6183,1.8,6.261833,3.64194,0.100095,1.225287,3.001702,3.012395,16.977311,0.011589,5.655895,2.458522,6.46292,2.392832,5.830977,3.049747,14.838162),(8985,'metacarpus.tif',183,5,158,6.942196,6.26457,3.580344,1.8,6.2679,3.603826,0.100551,1.23201,2.993348,3.046445,17.034752,0.011659,5.690869,2.472743,6.509937,2.407408,5.827598,3.056274,14.905293),(8986,'metacarpus.tif',183,5,159,6.948014,6.267951,3.545302,1.8,6.27229,3.567787,0.100584,1.234791,3.023863,3.095949,17.152908,0.011676,5.672515,2.507265,6.523645,2.411658,5.862549,3.063322,15.363693),(8987,'metacarpus.tif',183,5,160,6.943343,6.267341,3.513364,1.8,6.272479,3.535161,0.096301,1.247431,3.02084,3.145385,17.308435,0.010699,5.729676,2.52149,6.592727,2.431112,5.862549,3.063322,15.134493),(8988,'metacarpus.tif',183,5,161,6.888536,6.265905,3.481352,1.8,6.27195,3.503395,0.095326,1.257931,3.024626,3.167817,17.37011,0.010401,5.742895,2.518276,6.594834,2.44177,5.86566,3.056829,15.224001),(8989,'metacarpus.tif',183,5,162,6.877562,6.269516,3.450965,1.8,6.276678,3.473778,0.094743,1.265684,3.054275,3.231548,17.461129,0.010258,5.716948,2.553203,6.606394,2.449765,5.900633,3.063828,15.242539),(8990,'metacarpus.tif',183,5,163,6.811658,6.264352,3.417951,1.8,6.267036,3.440742,0.090718,1.276969,3.056127,3.29525,17.531753,0.009317,5.736592,2.580524,6.642307,2.463088,5.930973,3.083593,15.210893),(8991,'metacarpus.tif',183,5,164,6.764661,6.27039,3.385138,1.8,6.275986,3.408429,0.090349,1.28542,3.049369,3.353926,17.619431,0.009178,5.778059,2.609206,6.704834,2.488628,5.930973,3.083593,15.220162),(8992,'metacarpus.tif',183,5,165,6.641756,6.278734,3.355418,1.8,6.281443,3.379042,0.0908,1.296361,3.040605,3.381699,17.639085,0.009101,5.801176,2.608608,6.74275,2.509189,5.927035,3.096462,15.188516),(8993,'metacarpus.tif',183,5,166,6.573942,6.289114,3.323298,1.8,6.289202,3.3471,0.091846,1.314518,3.033933,3.445723,17.806328,0.009217,5.869058,2.621282,6.816469,2.545182,5.928881,3.090026,15.318939),(8994,'metacarpus.tif',183,5,167,6.591142,6.296403,3.292715,1.8,6.296116,3.316799,0.093329,1.331032,3.057941,3.571232,18.046964,0.009541,5.901672,2.683055,6.925434,2.559175,5.967031,3.090355,15.426985),(8995,'metacarpus.tif',183,5,168,6.59502,6.303904,3.256611,1.8,6.302651,3.27821,0.095849,1.345465,3.059156,3.672608,18.200851,0.010067,5.949631,2.729619,6.972975,2.58653,5.971431,3.077578,15.449362),(8996,'metacarpus.tif',183,5,169,6.612685,6.317133,3.222001,1.8,6.313958,3.243303,0.097564,1.366345,3.084844,3.833505,18.493327,0.010458,5.994899,2.805664,7.066581,2.630768,6.005181,3.090681,17.769169),(8997,'metacarpus.tif',183,5,170,6.623816,6.320643,3.185416,1.8,6.321532,3.206107,0.096355,1.364768,3.084042,3.971822,18.700881,0.010218,6.063757,2.910253,7.157443,2.65083,6.009553,3.077984,16.951146),(8998,'metacarpus.tif',183,5,171,6.635464,6.318863,3.159511,1.8,6.316321,3.179799,0.09539,1.374238,3.114693,4.104076,19.153667,0.010032,6.149456,2.986438,7.317008,2.678981,6.045384,3.084692,16.9195),(8999,'metacarpus.tif',183,5,172,6.606852,6.313635,3.126645,1.8,6.316816,3.148531,0.097322,1.389716,3.120597,4.237088,19.254587,0.010397,6.170161,3.048888,7.355735,2.708073,6.078123,3.103875,17.895752),(9000,'metacarpus.tif',183,5,173,6.646003,6.333719,3.090313,1.8,6.338332,3.113848,0.10143,1.394614,3.144829,4.434661,19.62379,0.011357,6.240018,3.179848,7.494743,2.749234,6.117847,3.097871,16.673352),(9001,'metacarpus.tif',183,5,174,6.643365,6.346193,3.063504,1.8,6.350809,3.08672,0.099304,1.413548,3.164137,4.648327,19.855629,0.010883,6.275212,3.288411,7.609328,2.787947,6.154469,0.03725,16.861637),(9002,'metacarpus.tif',183,5,175,6.634847,6.328148,3.028416,1.8,6.330528,3.050129,0.09569,1.432753,3.210343,4.833893,20.055553,0.010095,6.247168,3.37385,7.651083,2.849628,6.194175,0.043183,16.870906),(9003,'metacarpus.tif',183,5,176,6.667361,6.342253,3.000372,1.8,6.352223,3.016352,0.083944,1.48028,3.195449,5.126607,20.341174,0.007812,6.365671,3.463268,7.819342,2.932881,6.234095,0.04904,17.258336),(9004,'metacarpus.tif',183,5,177,6.7844,6.390075,2.987994,1.8,6.404632,3.000844,0.100101,1.520333,3.185426,5.430265,21.024388,0.011292,6.600181,3.57176,8.201588,2.97719,6.266663,0.024385,17.45589),(9005,'metacarpus.tif',183,5,178,6.722733,6.373065,2.945558,1.8,6.405536,2.959534,0.099597,1.551756,3.202532,5.628073,21.040169,0.011078,6.569854,3.626906,8.223179,3.033275,6.270504,0.042657,17.482106),(9006,'metacarpus.tif',183,5,179,6.718099,6.346784,2.898293,1.8,6.38269,2.91309,0.097483,1.574029,3.262845,5.817061,21.163351,0.010607,6.486166,3.695651,8.184579,3.095179,6.304852,3.117355,17.973742),(9007,'metacarpus.tif',183,5,180,6.654879,6.364233,2.884751,1.8,6.39588,2.89375,0.101333,1.630224,3.267899,5.931443,21.758517,0.01135,6.658259,3.638422,8.312373,3.175138,6.320917,3.008242,17.973742),(9008,'metacarpus.tif',183,5,181,6.562081,6.380856,2.85925,1.8,6.415208,2.871325,0.098954,1.67371,3.282794,6.081493,22.113158,0.010674,6.736077,3.633539,8.448121,3.259346,6.387058,3.021689,18.292451),(9009,'metacarpus.tif',183,5,182,6.595694,6.409838,2.821862,1.8,6.432985,2.827514,0.08857,1.699508,3.288865,6.325916,22.778601,0.008601,6.925977,3.722203,8.670452,3.351548,6.458512,3.028976,19.259434),(9010,'metacarpus.tif',183,5,183,6.72793,6.424852,2.778009,1.8,6.441592,2.781594,0.094737,1.729229,3.350976,6.53676,23.907542,0.010034,7.1345,3.780159,8.936828,3.43956,6.586039,3.013641,19.322726),(9011,'metacarpus.tif',183,5,184,6.783084,6.44739,2.757474,1.8,6.460606,2.764283,0.089947,1.743922,3.348288,6.726711,24.857863,0.009122,7.424053,3.857233,9.233811,3.520537,6.644275,3.037919,19.277972),(9012,'metacarpus.tif',183,5,185,6.918962,6.529472,2.717223,1.8,6.545422,2.730916,0.09151,1.81611,3.376335,7.032666,26.145594,0.00963,7.743779,3.872379,9.349311,3.613704,6.737618,3.016534,19.605949),(9013,'metacarpus.tif',183,5,186,7.337479,6.557086,2.694327,1.8,6.567681,2.713204,0.097807,1.904583,3.44086,7.767477,27.898844,0.011661,8.108102,4.078309,9.826449,3.72722,6.828511,3.001278,19.961733),(9014,'metacarpus.tif',183,5,187,7.90715,6.547334,2.639624,1.8,6.545793,2.652509,0.103647,1.953112,3.487275,8.380932,30.451691,0.014107,8.732232,4.291066,10.60503,3.809114,6.960895,0.04941,20.097585),(9015,'metacarpus.tif',183,5,188,9.08709,6.654061,2.684681,1.8,6.655804,2.701608,0.109116,1.936069,3.658464,9.343406,33.990439,0.017961,9.290904,4.825968,11.390916,3.860155,7.046321,0.070535,20.386238),(9016,'metacarpus.tif',183,5,189,10.048772,6.571152,2.68501,1.8,6.518158,2.691286,0.093283,1.941292,3.662598,9.927139,40.845761,0.014531,11.152128,5.113677,13.405465,3.916799,7.188302,3.029762,22.243805),(9017,'metacarpus.tif',183,5,190,10.364206,6.590613,2.657278,1.8,6.533623,2.671285,0.10392,2.172964,3.717998,10.155177,43.727194,0.018587,11.760952,4.673421,13.392882,3.455784,4.469563,0.652048,12.764503),(9018,'metacarpus.tif',183,5,191,10.141855,6.09476,2.55783,1.8,6.043086,2.572931,0.057335,2.001811,4.042677,9.900017,43.311731,0.00555,10.713626,4.945529,12.606132,3.447073,4.409577,0.619242,12.827794),(9019,'metacarpus.tif',183,5,192,8.949763,6.219269,2.513676,1.8,6.210411,2.529878,0.059854,2.012907,3.891765,9.496395,40.070602,0.005337,10.296254,4.71775,12.365241,3.443231,4.334312,0.610004,12.773772),(9020,'metacarpus.tif',183,5,193,8.3302,6.49138,2.504015,1.8,6.481517,2.523788,0.096604,2.532026,3.757394,9.259898,37.782807,0.012916,10.055588,3.657111,10.966448,3.406886,4.291001,0.59541,12.810847),(9021,'metacarpus.tif',183,5,194,8.813012,6.572224,2.505188,1.8,6.556836,2.544929,0.124475,2.190674,3.83284,10.580816,42.656309,0.022641,11.129166,4.829936,13.313232,3.384353,4.485207,0.761306,27.214576),(9022,'metacarpus.tif',183,5,195,9.43516,6.605135,2.514676,1.8,6.581577,2.557239,0.112268,2.399038,3.8837,10.958601,47.849721,0.019737,12.320652,4.567914,14.569769,3.359787,4.510189,0.89341,13.760883),(9023,'metacarpus.tif',183,5,196,10.040121,6.530734,2.467787,1.8,6.509723,2.517414,0.086783,2.207332,3.849159,11.63032,50.647792,0.012571,13.158145,5.26895,15.63284,3.355393,4.61762,0.890887,14.443054),(9024,'metacarpus.tif',183,5,197,9.389414,6.114458,2.297118,1.8,6.124876,2.354842,-0.009475,2.536215,3.487502,10.562257,40.057708,0.00014,11.486075,4.164574,14.03765,3.373928,4.406929,0.828317,14.191477),(9025,'metacarpus.tif',183,5,198,8.900495,6.105811,2.241665,1.8,6.112571,2.313011,0.012553,2.5468,3.423717,9.871165,33.784464,0.000234,9.867774,3.875908,12.221867,3.341324,4.276353,1.243396,14.061054),(9026,'metacarpus.tif',183,5,199,8.137,6.323699,2.207739,1.8,6.326358,2.280276,0.124938,2.427679,3.122783,8.813496,25.276279,0.021059,8.094153,3.63042,10.720581,2.866207,4.095959,1.2284,12.512926),(9027,'metacarpus.tif',183,5,200,8.090424,6.384054,2.292806,1.8,6.392962,2.355932,0.181131,2.455202,3.085879,8.135215,23.12926,0.043757,7.495194,3.31346,9.963298,0.1528,0.222742,0.54042,0.530961),(9028,'metacarpus.tif',183,5,201,8.152613,6.324695,2.36703,1.8,6.335315,2.422561,0.21308,2.380571,2.918059,7.232702,21.609614,0.060764,7.405476,3.038222,9.459658,2.622732,3.930147,1.202925,11.473381),(9029,'metacarpus.tif',183,5,202,7.927193,6.316213,2.446262,1.8,6.319892,2.489884,0.213948,2.257139,2.868012,5.660811,20.580823,0.059559,7.175989,2.507959,8.848126,2.5212,3.733647,1.226396,10.802729),(9030,'metacarpus.tif',183,5,203,6.943291,6.227578,2.539561,1.8,6.25474,2.570933,0.207045,2.092661,2.787133,3.880969,18.388012,0.048902,6.597465,1.854562,7.556836,2.1774,3.492115,1.224829,9.807938),(9031,'metacarpus.tif',183,5,204,4.687676,5.945098,2.689987,1.8,5.96146,2.704497,0.229976,1.828374,2.992848,2.243531,13.926503,0.040598,4.653261,1.227063,5.24292,2.0628,3.165303,1.264312,8.837115),(9032,'metacarpus.tif',183,5,205,2.722943,5.901844,2.983406,1.8,5.914792,2.943198,0.151744,1.969777,3.142728,0.912645,9.739112,0.01037,3.098935,0.463324,3.305216,1.360759,2.566517,1.314988,6.733401),(9033,'metacarpus.tif',183,5,206,1.571545,5.71897,3.175769,1.8,5.784668,3.194339,0.088623,3.860601,3.028291,0.3398,5.677116,0.002052,1.874693,0.088017,1.558161,0.8786,1.919526,1.670465,4.771627),(9034,'metacarpus.tif',183,5,207,0.569297,4.584662,3.145093,1.8,4.704008,3.155402,0.113093,0.898406,4.009152,0.058694,0.482483,0.001208,0.120345,0.065331,0.134749,0.713482,1.390501,1.849096,3.476666),(9035,'metacarpus.tif',183,5,208,0.099129,4.351946,3.293598,1.8,4.34884,3.286826,1.299009,0.201306,0.722599,0.000661,0.009363,0.015331,0.012958,0.003285,0.013789,0.371026,0.668227,2.111216,1.714036),(9036,'metacarpus.tif',183,5,209,15.52428,6.176325,3.313234,1.8,6.195776,3.299685,0.190015,4.00716,4.010305,43.529955,68.159724,0.092301,16.996143,10.863044,25.011645,3.540768,4.197309,0.714549,13.09248),(9037,'metacarpus.tif',183,5,210,14.454716,6.28517,3.404281,1.8,6.283681,3.35922,0.13093,4.060758,3.872193,42.709215,62.384333,0.041063,16.110853,10.517548,24.473697,3.496185,4.123123,0.877244,12.695781),(9038,'metacarpus.tif',183,5,211,13.317752,6.284482,3.521248,1.8,6.290311,3.459986,0.166434,4.33782,3.771985,43.459821,55.006407,0.060918,14.582881,10.018815,21.570504,3.52331,4.069331,0.878462,12.723588),(9039,'Bos_taurus_femur-cleaned.tif',151,7,1,54.4086725,98.7583364,162.7731305,1.8,96.9565656,162.88673,0.0051335,5.7440839,80.2263418,353.8861052,111805.4873567,0.000239,1393.6256451,61.608798,1394.4719672,0.8735612,10.2389323,2.9516044,21.4847034),(9040,'Bos_taurus_femur-cleaned.tif',151,7,2,53.8390618,98.8548104,162.8950479,1.8,97.6117337,163.0268003,0.0034481,5.9982371,80.3134472,344.2161198,110291.670942,0.0001067,1373.2653093,57.3862139,1373.7269886,0.3867191,1.5944838,2.896614,3.1875869),(9041,'Bos_taurus_femur-cleaned.tif',151,7,3,53.0514229,98.6571841,163.005708,1.8,97.7470015,163.1160229,0.001995,6.224658,80.107243,331.9290732,108858.0011244,0.0000352,1358.903353,53.3248693,1358.9504683,10.2140677,159.3512793,3.124604,341.176206),(9042,'Bos_taurus_femur-cleaned.tif',151,7,4,60.5420593,60.8098177,146.3238019,1.8,60.8290661,146.7419008,1.2971948,7.5443364,11.0970482,509.7092309,1270.7396754,9.353663,114.5115041,67.5618374,160.4434693,14.5910724,22.2623966,1.8705724,60.4864165),(9043,'Bos_taurus_femur-cleaned.tif',151,7,5,252.7095919,60.999301,144.5981274,1.8,61.14856,143.4942432,-1.4931736,12.9184696,21.8641522,7755.7280915,17326.0842383,41.8649997,792.4425363,600.3596637,1140.9740619,23.9765865,39.4756712,1.5316007,108.6983229),(9044,'Bos_taurus_femur-cleaned.tif',151,7,6,347.1753222,60.076889,142.162138,1.8,60.5047283,141.048752,1.5666338,15.216354,27.3068815,15879.4997888,40527.8267692,57.8615512,1484.1616659,1043.5811192,2065.1428639,28.6172161,49.2774878,1.7204624,131.9175704),(9045,'Bos_taurus_femur-cleaned.tif',151,7,7,403.3981927,58.616489,140.7475454,1.8,59.1393589,139.319879,1.466948,16.9060366,30.7919828,24525.8413357,66607.2220047,66.5105612,2163.1352063,1450.7150297,2958.3670777,31.9426461,55.7479478,1.7804362,151.9653304),(9046,'Bos_taurus_femur-cleaned.tif',151,7,8,457.6419958,56.7376002,139.0632492,1.8,56.6599562,136.963188,1.3655264,18.2722966,32.2092568,32671.5729136,99226.0335188,73.1047038,3080.6682121,1788.0386687,3851.5948542,32.8859607,61.4202035,2.0626055,172.9969642),(9047,'Bos_taurus_femur-cleaned.tif',151,7,9,596.9510724,52.4745556,135.4443616,1.8,53.6465605,134.4206428,1.1706434,19.9258176,37.5174885,47594.75888,190395.5544457,84.3933228,5074.8480777,2388.5975424,6341.6964432,35.4460781,70.883624,1.9391452,184.3881028),(9048,'Bos_taurus_femur-cleaned.tif',151,7,10,644.1297364,51.0488982,134.3099948,1.8,52.2994274,133.5125527,1.1558191,20.2650935,39.060119,54436.3966104,235808.857811,89.9049141,6037.0747337,2686.2149183,7430.6964879,36.5438328,74.4923854,1.9763698,194.3100993),(9049,'Bos_taurus_femur-cleaned.tif',151,7,11,668.8909192,49.8650819,133.4010867,1.8,51.0784439,132.6950814,1.1455936,20.272357,40.1092745,58300.5747697,262104.1301253,92.5119874,6534.7512159,2875.8656343,7987.6925261,36.9289943,76.3728685,1.982337,197.1773176),(9050,'Bos_taurus_femur-cleaned.tif',151,7,12,696.4057112,49.068671,132.8913736,1.8,50.0202253,132.0085901,1.1421737,20.1408788,41.5569808,63115.6634403,286019.1390234,96.0182505,6882.5774524,3133.7095158,8401.3298156,37.0419614,79.0847726,1.9994473,205.9116734),(9051,'Bos_taurus_femur-cleaned.tif',151,7,13,720.5182928,48.2842595,131.6341586,1.8,49.0455575,130.9616208,1.1345577,20.1608706,44.1968098,67715.3357401,310587.6345736,98.6468302,7027.3767687,3358.7505815,8556.8828713,37.5400664,82.8671526,2.009397,210.7949372),(9052,'Bos_taurus_femur-cleaned.tif',151,7,14,752.2399739,47.4550994,130.2432167,1.8,48.0739606,129.6069473,1.1206757,20.2371613,46.0415162,72804.9097611,350373.5395474,101.6414761,7609.947906,3597.585098,9176.6789878,38.2881299,86.1411994,2.0163736,215.2639986),(9053,'Bos_taurus_femur-cleaned.tif',151,7,15,789.2863295,46.8154267,129.3324431,1.8,47.2033885,128.4245684,1.1130331,20.661955,47.5441791,79361.0320657,388135.2311559,105.8546864,8163.6751082,3840.9256053,9821.7047619,38.673176,88.5688141,2.0129629,218.6392531),(9054,'Bos_taurus_femur-cleaned.tif',151,7,16,818.3088745,46.2248063,128.4956344,1.8,46.4077944,127.3748298,1.1004281,21.3129056,48.4640965,87520.8603698,423611.0091248,108.3709055,8740.7181838,4106.4724835,10514.526958,39.7184939,90.470791,2.0554733,223.6002513),(9055,'Bos_taurus_femur-cleaned.tif',151,7,17,857.2834046,46.8584637,126.9332416,1.8,48.7456816,125.0886061,1.0436168,102.4640919,49.0711239,203310.6179492,464002.7021186,106.7164353,9455.7178465,1984.2133401,6482.619046,41.9553503,92.1438991,2.0889013,227.6939775),(9056,'Bos_taurus_femur-cleaned.tif',151,7,18,1113.4487282,65.2920097,118.3858308,1.8,60.0627161,119.6737031,-0.3700021,47.2306814,90.5045915,489282.6524224,1980797.2874957,24.2670895,21886.1524522,10359.4239607,27290.5232081,43.8013062,92.864141,2.0940746,232.7488096),(9057,'Bos_taurus_femur-cleaned.tif',151,7,19,1408.7848572,78.3686886,112.6456486,1.8,67.6868078,116.1673319,-0.3732964,47.1823191,80.5372384,530900.7728599,3343035.8424007,31.227234,41509.1938931,11252.1127097,48092.6037871,45.3532684,93.4493011,2.1048284,236.8036686),(9058,'Bos_taurus_femur-cleaned.tif',151,7,20,1630.7673321,84.1700614,109.9436888,1.8,73.0824459,113.579441,-0.3686675,46.6738837,76.019165,578643.5026346,4060924.7992565,35.2975697,53419.7501313,12397.5863244,61025.6990787,47.1937578,93.7145828,2.1175852,237.7098079),(9059,'Bos_taurus_femur-cleaned.tif',151,7,21,1830.8073564,87.9574094,108.3276275,1.8,77.3421884,111.78398,-0.370228,46.2399115,72.6558917,626943.0765998,4490554.0389367,39.9480633,61805.7797145,13558.4835028,64457.3416441,50.5889944,94.2873282,2.17245,243.030042),(9060,'Bos_taurus_femur-cleaned.tif',151,7,22,2034.1583644,90.2471135,107.3262086,1.8,80.6052678,110.37755,-0.3734541,45.8989763,74.215429,681833.5966074,4798169.9583507,45.1256132,64651.9197185,14855.0937705,66750.0832292,55.0254285,94.5407679,2.1905703,254.7643171),(9061,'Bos_taurus_femur-cleaned.tif',151,7,23,2244.4935724,92.0825875,106.7087023,1.8,83.0839411,109.2672325,-0.3816716,46.0299329,76.3523138,726001.8656303,5127295.7601602,51.8985267,67153.1156818,15772.3859228,69374.3653111,87.3568985,153.2545056,0.0808361,512.787287),(9062,'Bos_taurus_femur-cleaned.tif',151,7,24,2416.080753,93.3289432,106.0442804,1.8,84.7695618,108.1663469,-0.3819086,45.3349993,78.2497003,756907.0808183,5364028.5174044,55.9320855,68550.1477581,16695.8661467,71439.9080449,86.9727697,155.0362759,0.0974349,491.3025836),(9063,'Bos_taurus_femur-cleaned.tif',151,7,25,2479.572742,94.1884786,105.4859008,1.8,86.3091816,107.2548883,-0.3807699,45.1577581,79.3627617,790332.7393099,5431543.4601489,57.0767915,68439.4462178,17501.5938151,72189.8571762,86.1991493,156.275208,0.1240481,481.0052519),(9064,'Bos_taurus_femur-cleaned.tif',151,7,26,2475.4549949,95.0343162,105.122342,1.8,87.5300765,106.4368044,-0.3845078,43.8440308,79.9846326,809901.8049712,5385593.3271106,58.0503149,67332.8507634,18472.3391171,71764.8373939,83.0949892,156.7563051,0.1286389,467.3326657),(9065,'Bos_taurus_femur-cleaned.tif',151,7,27,2468.7318759,95.0986148,104.7038958,1.8,88.3311355,105.6973847,-0.3893254,43.10017,79.9826043,831852.3627624,5315223.3415442,59.2780136,66454.7420874,19300.4427208,71909.7679567,80.5335667,156.3727892,0.1289562,465.8407557),(9066,'Bos_taurus_femur-cleaned.tif',151,7,28,2424.7185415,95.4213793,104.3484622,1.8,89.3268647,105.1197205,-0.3951845,42.290075,80.2765389,844408.0348719,5158719.5234288,59.8939437,64261.8577887,19967.0498405,71212.8984546,77.1537355,155.8290988,0.1720845,461.3716943),(9067,'Bos_taurus_femur-cleaned.tif',151,7,29,2364.7812602,94.6961652,104.449341,1.8,90.0188339,104.6420651,-0.3988552,41.4826003,79.1907829,862487.0269006,4943528.5185418,59.4452256,62425.5542687,20791.5372123,70750.0502465,75.3034749,154.6571976,0.2116173,460.0674519),(9068,'Bos_taurus_femur-cleaned.tif',151,7,30,2300.4163425,94.2847122,104.5554166,1.8,90.5756389,104.3168119,-0.3952335,41.0167927,78.1376439,866695.2698033,4722749.5283589,56.8368567,60441.4119909,21130.2545206,69212.2373477,74.5116989,153.9010985,0.2126728,459.5755151),(9069,'Bos_taurus_femur-cleaned.tif',151,7,31,2233.4099794,93.5436017,104.8979564,1.8,91.0342137,104.1379136,-0.3961809,40.1666428,76.3968633,856511.8078248,4484689.9997331,55.4321816,58702.5410029,21323.9581006,68800.7508926,74.9913962,151.7713728,0.2313825,456.6533302),(9070,'Bos_taurus_femur-cleaned.tif',151,7,32,2145.8701238,92.6663319,105.349062,1.8,91.1432749,104.1426301,-0.404005,39.6524669,74.9591897,827954.8465171,4215371.1491914,55.2671681,56235.5485476,20880.2859296,67113.0745817,75.7609003,150.2701197,0.3575659,469.177143),(9071,'Bos_taurus_femur-cleaned.tif',151,7,33,2059.8847901,90.9590304,106.3943116,1.8,90.9251486,104.4287295,-0.4140503,39.0888623,75.7386155,789141.4433446,3883728.4879809,55.5694795,51278.0496434,20188.3962946,61666.4571395,75.9689446,148.5978033,0.364558,462.0124316),(9072,'Bos_taurus_femur-cleaned.tif',151,7,34,1980.8990646,89.6197189,107.4510677,1.8,90.7627816,104.8573364,-0.4207762,39.0867579,76.5109854,754619.3754519,3517858.4799535,55.0844989,45978.4756631,19306.2667866,55810.9666468,76.42213,146.7139218,0.3751222,460.1290871),(9073,'Bos_taurus_femur-cleaned.tif',151,7,35,1922.3897301,88.8076096,108.463815,1.8,90.2662356,105.6489734,-0.4245177,39.0596578,75.9539895,729420.9330125,3204530.2164383,54.3543671,42190.413412,18674.534667,51748.1662687,76.4525367,143.0970546,0.432219,456.7926998),(9074,'Bos_taurus_femur-cleaned.tif',151,7,36,1894.0991727,88.3136234,109.4130748,1.8,89.3037261,106.8697675,-0.4246626,37.8396419,75.1775694,711972.3949211,2982250.593589,53.5888104,39669.4202589,18815.5162116,49024.4217844,75.9295528,138.3811629,0.4823954,451.5113329),(9075,'Bos_taurus_femur-cleaned.tif',151,7,37,1852.4463984,86.7371193,110.7148199,1.8,86.887224,108.7268712,-0.4302104,37.5982505,74.0758302,695987.8933239,2652053.4753921,53.702654,35801.8731344,18511.1776433,44902.3120363,75.2984632,133.6890908,0.3025397,441.9713402),(9076,'Bos_taurus_femur-cleaned.tif',151,7,38,1809.317141,84.9398938,111.4732556,1.8,85.3168929,109.7630327,-0.4525696,37.6543944,70.3402722,676294.6847958,2307316.511959,57.6605173,32802.211886,17960.5779368,41853.0687161,74.2819751,127.1888611,0.3121355,437.6283112),(9077,'Bos_taurus_femur-cleaned.tif',151,7,39,1787.4088153,84.391269,111.9992602,1.8,84.9699869,110.3820394,-0.4612188,37.6563035,67.5042732,652512.1305337,2085510.3418765,59.002503,30894.4937043,17328.0983414,40048.9168119,73.5071768,122.0477263,0.3257585,418.900893),(9078,'Bos_taurus_femur-cleaned.tif',151,7,40,1777.88201,84.5507194,112.7470464,1.8,85.1149426,111.1065088,-0.4672233,37.371841,65.5639602,633290.1893754,1935508.5079756,60.1126125,29520.9212641,16945.6513911,38707.8216687,72.2517538,118.6288923,0.3320595,412.9787888),(9079,'Bos_taurus_femur-cleaned.tif',151,7,41,1786.8376185,85.4423091,113.8703901,1.8,86.0518485,112.5268894,-0.4755019,57.1895039,63.4931454,631411.9155715,1800308.5113016,62.4103303,28354.3758966,11040.695808,38026.6097926,70.4429859,114.746808,0.3473313,397.0408544),(9080,'Bos_taurus_femur-cleaned.tif',151,7,42,1759.4926357,86.7067271,114.2495475,1.8,86.5812168,112.7269663,-0.4899704,35.3237252,61.4267582,566796.2422591,1698342.2178043,64.944077,27648.2475618,16045.7663721,36642.2468334,68.6685722,112.1705505,0.3446473,388.2126648),(9081,'Bos_taurus_femur-cleaned.tif',151,7,43,1737.5069056,88.0722233,114.816853,1.8,87.7494878,113.7439487,-0.4941191,38.7988846,81.0477728,533774.5377927,1578415.2484592,65.1330717,19475.121821,13757.4711953,26017.2817691,67.0585719,109.1014123,0.3396859,364.35268),(9082,'Bos_taurus_femur-cleaned.tif',151,7,44,1736.073566,89.6919216,115.4380002,1.8,88.9387053,114.6719396,-0.5057565,38.3755641,82.2130122,526710.7927308,1454499.4866099,67.9124807,17691.8403498,13725.160905,24087.9682472,65.9695563,105.1776524,0.3333779,336.4539356),(9083,'Bos_taurus_femur-cleaned.tif',151,7,45,1675.1904836,91.9908367,115.4808328,1.8,90.6771999,115.2640458,-0.5144253,33.1915609,84.2113044,520446.5794366,1313410.0937826,67.5933877,15596.6007472,15680.0874893,21776.3820053,65.3871154,99.3875705,0.6473921,309.8594336),(9084,'Bos_taurus_femur-cleaned.tif',151,7,46,1635.2018117,94.2939148,115.2607004,1.8,92.4979478,115.7655613,-0.4974286,33.5640099,86.3188037,528881.279144,1206092.5937303,62.0528268,13972.536023,15757.3925422,20098.04418,65.0084291,96.7887775,0.6179271,292.0542539),(9085,'Bos_taurus_femur-cleaned.tif',151,7,47,1621.0201874,96.2788073,115.1125416,1.8,94.4688466,116.0628848,-0.4533449,33.9474484,88.0457218,550485.3626058,1137944.9535048,51.8245797,12924.4775408,16215.8096674,19157.4866888,64.5561461,94.2230681,0.663203,279.8508098),(9086,'Bos_taurus_femur-cleaned.tif',151,7,48,1605.1510309,97.8879069,114.9184694,1.8,96.1233381,116.2673416,-0.3800992,34.1673988,89.1360208,576413.0223327,1097000.3469591,36.8249396,12307.0374525,16870.2635216,18667.9069733,63.9966315,91.9220894,0.6721128,275.8897846),(9087,'Bos_taurus_femur-cleaned.tif',151,7,49,1593.5238401,99.2866829,114.8181024,1.8,97.4230153,116.3745032,-0.314356,34.0454112,89.694038,594996.7565003,1055356.6142434,25.3920506,11766.1846641,17476.5624808,18151.2429431,63.5544025,89.3287723,0.6842065,266.7251271),(9088,'Bos_taurus_femur-cleaned.tif',151,7,50,1556.6816452,99.946837,114.6300142,1.8,98.3223639,116.2797637,-0.2743366,34.0329045,89.7167416,590129.0411173,993482.6239183,19.0411685,11073.547767,17339.9552758,17289.5028022,63.555243,87.1526294,0.6816708,263.2721381),(9089,'Bos_taurus_femur-cleaned.tif',151,7,51,1510.8373901,100.4614995,114.2487146,1.8,99.1589489,116.125779,-0.2551162,33.8333948,41.818272,573713.9424388,920927.277278,16.0361465,22022.1265076,16957.0315378,34272.3041385,63.7986888,84.9515532,2.9584818,266.1004891),(9090,'Bos_taurus_femur-cleaned.tif',151,7,52,1453.9364613,100.82602,113.7443414,1.8,99.8488815,115.9821328,-0.2583164,33.5435013,41.3287526,553076.9069086,855429.7693856,15.8130901,20698.1753787,16488.3475213,32681.7648553,63.7155293,83.7316145,2.9369508,256.8969643),(9091,'Bos_taurus_femur-cleaned.tif',151,7,53,1424.5963683,101.0522745,113.1902971,1.8,100.2447808,115.5990035,-0.2843836,33.1779113,40.3608072,536156.2819397,796502.5671487,18.6900354,19734.55496,16160.0372384,31360.6472132,63.8073134,82.1384528,2.9377337,280.1323112),(9092,'Bos_taurus_femur-cleaned.tif',151,7,54,1387.2878893,101.5205381,112.5940222,1.8,100.8558822,115.1928425,-0.3139833,37.3721287,38.8929774,520785.6163364,738226.1678371,22.0551174,18980.9630558,13935.1338638,28679.8727119,63.4556231,80.2039081,2.9129868,277.9058302),(9093,'Bos_taurus_femur-cleaned.tif',151,7,55,1370.4674028,102.0747211,112.1167501,1.8,101.3969693,114.815838,-0.3746213,38.3374071,38.1096753,507816.6537744,691321.8829357,30.5836977,18140.3246752,13245.983281,27214.1437508,63.2429439,77.4105077,0.8101281,243.1855109),(9094,'Bos_taurus_femur-cleaned.tif',151,7,56,1334.6573411,102.7074545,111.4317628,1.8,102.1804801,114.1227421,-0.4523327,40.1248999,38.0070597,487527.5029098,639937.8883205,42.4922918,16837.3426619,12150.2484445,25820.0038985,62.6624519,75.7120618,0.8649401,264.7801474),(9095,'Bos_taurus_femur-cleaned.tif',151,7,57,1289.9634558,103.1197702,110.615741,1.8,102.6223036,113.3860178,-0.5284112,41.7590034,37.5131791,460314.8402915,590988.1238056,54.646973,15754.1466136,11023.1280116,24118.7239315,61.6830931,73.8269014,0.8706926,231.2086016),(9096,'Bos_taurus_femur-cleaned.tif',151,7,58,1258.0621768,103.2862673,109.8312672,1.8,103.0077788,112.3542935,-0.5613504,42.1901157,36.8831321,436724.0310401,559153.6926889,59.4172423,15160.1466687,10351.3352298,22914.1644236,61.1253425,72.4889523,0.8760581,226.0599358),(9097,'Bos_taurus_femur-cleaned.tif',151,7,59,1220.9730856,103.6352711,109.1110258,1.8,103.6472004,110.9859885,-0.6093345,42.9371208,36.3928408,418420.2765482,525779.1511429,66.6554234,14447.3237027,9744.9542166,21596.3309158,60.4007715,71.0258941,0.9011574,222.513113),(9098,'Bos_taurus_femur-cleaned.tif',151,7,60,1207.6839676,103.868545,108.3506852,1.8,104.1541237,109.9981606,-0.6817218,44.8952596,35.9611355,399381.6649983,501898.2811449,79.9214952,13956.6861178,8895.8537925,19942.6726679,59.9965399,69.8603598,0.9505468,220.9662365),(9099,'Bos_taurus_femur-cleaned.tif',151,7,61,1198.8319578,104.0235899,107.6698845,1.8,104.3948098,108.946966,-0.7268445,44.3617726,35.4413006,381957.071514,481216.9976321,88.2300499,13577.8594338,8610.0498025,19413.5082378,59.278943,68.9195999,0.9407624,223.6069199),(9100,'Bos_taurus_femur-cleaned.tif',151,7,62,1190.005281,104.1951836,107.0042804,1.8,104.5766823,108.1196356,-0.7578375,44.8288223,34.9098407,368146.6934764,460253.1273291,93.7036499,13184.0512218,8212.2767147,18479.1623433,58.5618247,67.6802684,0.9764547,210.5911703),(9101,'Bos_taurus_femur-cleaned.tif',151,7,63,1189.7084436,104.2855022,106.4450396,1.8,104.6496246,107.4947304,-0.796812,46.2249844,34.3431088,356639.8987995,444469.5978517,101.4053611,12942.0315699,7715.3059772,17324.9369597,57.438432,66.593215,0.9296181,205.6690393),(9102,'Bos_taurus_femur-cleaned.tif',151,7,64,1193.2405373,104.2908896,105.9554436,1.8,104.4161781,107.0864364,-0.8530372,42.9487778,34.1320603,344067.8046252,430654.4631197,112.8473375,12617.3005452,8011.1198141,18006.52529,56.9625592,65.5486085,0.9615203,202.2549175),(9103,'Bos_taurus_femur-cleaned.tif',151,7,65,1192.4778236,104.084757,105.2679421,1.8,103.922712,106.3337408,-0.8898742,42.4448339,33.5367943,330353.121869,415231.4560266,119.9866145,12381.3699283,7783.1173245,17512.0105063,56.2139977,64.6931531,0.9595806,197.6142879),(9104,'Bos_taurus_femur-cleaned.tif',151,7,66,1182.3035502,104.1316311,104.6808167,1.8,103.9307596,105.7949839,-0.9273233,45.5439835,35.6597355,318633.6758878,398928.546887,126.1176845,11187.0865456,6996.1749322,15514.9425009,55.9601346,64.2000358,1.0262446,195.9735776),(9105,'Bos_taurus_femur-cleaned.tif',151,7,67,1165.4745891,104.0935716,104.1597146,1.8,103.7597061,105.3825799,-0.9627305,45.7523932,35.8949183,302150.1104784,381246.8659134,130.8513228,10621.1933046,6604.0285412,14647.1463023,55.3845536,63.6690516,1.0282935,193.8797976),(9106,'Bos_taurus_femur-cleaned.tif',151,7,68,1161.9660158,104.0919381,103.6080524,1.8,103.7670064,104.7334943,-0.9910198,45.4485242,34.7883084,289840.888764,368974.2389925,135.5384179,10606.2713693,6377.3443445,13989.1556179,54.8703566,63.0079295,1.021956,191.3718151),(9107,'Bos_taurus_femur-cleaned.tif',151,7,69,1153.8657071,104.1132177,102.9982459,1.8,103.8823314,103.9722072,-1.0139246,29.453127,36.4360267,277571.7415536,357393.199935,138.5894074,9808.7863104,9424.1858221,16715.8092636,54.5058102,62.2761912,1.0293119,189.2780351),(9108,'Bos_taurus_femur-cleaned.tif',151,7,70,1158.2805636,104.1804527,102.4821323,1.8,103.9428216,103.3614155,-1.0312182,28.9159698,32.2424879,268391.4817299,350341.2051435,142.0894027,10865.8241933,9281.7734836,19177.700973,53.3617236,61.6146871,1.022842,186.2231493),(9109,'Bos_taurus_femur-cleaned.tif',151,7,71,1170.8197025,104.0913716,102.0317676,1.8,103.860733,102.9014836,-1.0494961,28.1355374,32.0342507,258883.639087,347230.7111865,146.7403869,10839.3579729,9201.3042374,18905.290618,52.2070835,61.2153307,1.0336271,183.5824658),(9110,'Bos_taurus_femur-cleaned.tif',151,7,72,1165.7218026,104.083617,101.5274046,1.8,103.8725401,102.5024285,-1.0661378,27.3730632,31.7689208,248213.2750096,339895.2016181,148.8664542,10698.9848404,9067.7931575,18477.1178747,51.3524577,60.6853391,1.0358413,181.1683172),(9111,'Bos_taurus_femur-cleaned.tif',151,7,73,1155.3424621,103.9054972,100.9631419,1.8,103.8007101,101.9698279,-1.0745316,26.0345944,31.4826394,235619.29254,331259.3507778,148.9018225,10521.9688359,9050.238637,17963.6641856,50.1421893,60.1021758,1.0524483,178.9418362),(9112,'Bos_taurus_femur-cleaned.tif',151,7,74,1138.4135732,103.9477405,100.4273638,1.8,103.9424672,101.3721712,-1.0778369,25.1369343,31.4689495,224863.5826323,322586.1130377,147.244043,10250.9336257,8945.5452288,17330.0291507,49.2935212,59.8228381,1.0348114,177.7153283),(9113,'Bos_taurus_femur-cleaned.tif',151,7,75,1116.3878721,103.9471587,99.9718231,1.8,103.9097256,100.8510624,-1.0822139,24.5457783,31.3355523,213227.7155365,312828.5504282,145.0722678,9983.1829044,8686.9404974,16733.7157065,48.5960828,59.4906779,1.0314917,175.6215483),(9114,'Bos_taurus_femur-cleaned.tif',151,7,76,1105.5999836,103.9401452,99.5549992,1.8,103.8602607,100.4586918,-1.0853103,24.1193656,31.1704873,206053.9911274,306077.4514211,144.1423582,9819.4631363,8543.0933311,16387.1051915,47.9111318,59.1680279,1.080839,174.0746717),(9115,'Bos_taurus_femur-cleaned.tif',151,7,77,1099.9864929,103.9479718,99.2008521,1.8,103.8477387,100.2265258,-1.0851932,23.8981407,30.9650999,200438.2556615,300699.567103,143.3927866,9710.9186803,8387.19039,16152.4966431,47.3954356,58.8588559,1.0630597,173.0746986),(9116,'Bos_taurus_femur-cleaned.tif',151,7,78,1093.8716868,103.9736755,98.8344962,1.8,103.8021594,99.921878,-1.0885835,23.663522,30.9682984,195835.9981259,296690.1496835,143.1047468,9580.4472596,8275.8601355,15833.2396384,47.0473838,58.7634966,1.0394059,172.8481638),(9117,'Bos_taurus_femur-cleaned.tif',151,7,79,1105.8268036,103.9577551,98.5254099,1.8,103.8225299,99.6338329,-1.0901789,23.6256145,30.7085871,194385.970445,297357.8866219,144.9101143,9683.2161463,8227.7635824,15953.3369427,46.872867,58.3753786,1.0508285,170.66055),(9118,'Bos_taurus_femur-cleaned.tif',151,7,80,1115.0685996,103.8760065,98.2789265,1.8,103.5417066,99.3979772,-1.0894625,23.6331394,30.5483388,192984.451715,297835.5448513,146.0119786,9749.647818,8165.8407028,16007.597618,46.6624088,58.333092,1.0656296,170.2074804),(9119,'Bos_taurus_femur-cleaned.tif',151,7,81,1111.6018555,103.7173706,97.9872869,1.8,103.3723654,99.1312543,-1.0896566,23.40211,30.5690968,190387.4056445,295841.2294986,145.5875263,9677.7877161,8135.4803257,15835.465116,46.1836359,58.3036013,1.0804488,169.9809455),(9120,'Bos_taurus_femur-cleaned.tif',151,7,82,1110.0812773,103.6914808,97.7386985,1.8,103.3163031,98.9616046,-1.0888862,23.3299842,30.6003552,187873.3538144,294826.7976299,145.271369,9634.7508303,8052.8710276,15726.7645484,46.0052947,58.3036013,1.0804488,169.7544107),(9121,'Bos_taurus_femur-cleaned.tif',151,7,83,1094.5988252,103.68601,97.4966848,1.8,103.4069125,98.6714558,-1.092165,23.2848865,30.6395265,183360.9323176,291065.8419483,143.735444,9499.684728,7874.6758106,15415.8522685,45.8375476,58.3753786,1.0508285,169.7544107),(9122,'Bos_taurus_femur-cleaned.tif',151,7,84,1090.0315619,103.7017436,97.2565119,1.8,103.4677789,98.3439846,-1.0913944,23.2166648,30.6973468,181616.768733,289764.3789394,143.0211762,9439.3949174,7822.6898873,15268.4153755,45.6659762,58.3753786,1.0508285,170.0747793),(9123,'Bos_taurus_femur-cleaned.tif',151,7,85,1087.6119968,103.7585869,97.0378083,1.8,103.5629575,98.1001281,-1.0891549,23.2372212,30.7456469,180822.2041071,289866.8969613,142.3709153,9427.9003977,7781.5760496,15239.4596438,45.6977563,58.3753786,1.0508285,170.3013142),(9124,'Bos_taurus_femur-cleaned.tif',151,7,86,1088.1653381,103.796432,96.8368466,1.8,103.5929269,97.9944808,-1.0892739,23.2968939,30.6136585,181191.2050211,290443.2502786,142.4610686,9487.3747481,7777.4833797,15287.8490133,45.7622509,58.2971884,1.0269639,169.5278759),(9125,'Bos_taurus_femur-cleaned.tif',151,7,87,1092.825822,103.8706783,96.6068573,1.8,103.6061273,97.8144399,-1.0889915,23.3216868,30.6580478,182775.6193198,293665.7995524,143.028983,9578.7507827,7837.15265,15486.7326635,45.8140615,58.333092,1.0656296,169.5278759),(9126,'Bos_taurus_femur-cleaned.tif',151,7,88,1092.6651672,103.8870841,96.4394489,1.8,103.5947855,97.6255279,-1.0912604,23.2370847,30.8220017,183841.128282,296842.3403026,143.346744,9630.8586046,7911.5401377,15499.8722893,45.6659762,58.5684824,1.0450983,170.0747793),(9127,'Bos_taurus_femur-cleaned.tif',151,7,89,1097.0505213,103.8035822,96.3000446,1.8,103.6946176,97.4350112,-1.0938132,23.3522413,30.9101891,185921.4341087,300311.5539782,144.3034939,9715.6168517,7961.6098309,15585.0081902,45.7622509,58.7634966,1.0394059,170.527849),(9128,'Bos_taurus_femur-cleaned.tif',151,7,90,1101.091272,103.8304917,96.2212663,1.8,103.6763456,97.4129692,-1.0962866,23.2197404,30.8146928,186833.310519,302719.3626959,145.2046057,9823.8643676,8046.3135087,15696.2377392,45.666958,58.903304,1.0483929,171.0747524),(9129,'Bos_taurus_femur-cleaned.tif',151,7,91,1090.542213,103.8813761,96.1299664,1.8,103.7316257,97.3565957,-1.1011638,23.3711797,30.890093,186142.4684781,302584.373552,144.5314974,9795.5151326,7964.6158482,15683.3834248,45.9167427,59.0111101,1.0719726,171.6216559),(9130,'Bos_taurus_femur-cleaned.tif',151,7,92,1089.4278263,103.9180835,96.0681666,1.8,103.6123962,97.3252523,-1.1012232,23.3664857,30.9615697,187790.6017684,304894.5130373,144.3925163,9847.5146942,8036.7498949,15774.0992394,45.9768094,59.1970879,1.0662359,172.3950942),(9131,'Bos_taurus_femur-cleaned.tif',151,7,93,1084.1323822,103.9779292,95.9764566,1.8,103.757799,97.2393924,-1.0989094,23.3734111,30.742568,188935.2235879,306794.7106285,143.352682,9979.4757074,8083.3397591,15908.1796361,46.0110826,59.1591807,1.0281347,173.4889011),(9132,'Bos_taurus_femur-cleaned.tif',151,7,94,1080.4176542,104.0311164,95.9251632,1.8,103.8923135,97.2377477,-1.0992665,23.5108432,30.6349359,191087.0271495,309871.1653752,142.9135426,10114.9604499,8127.6126658,16156.5518871,46.2525912,59.0972134,1.0427219,173.8092697),(9133,'Bos_taurus_femur-cleaned.tif',151,7,95,1085.8388576,104.0313424,95.9414663,1.8,103.9304182,97.2812204,-1.096481,23.5127344,30.4663461,194735.8334313,316570.9621292,143.2218242,10390.8411259,8282.1432214,16540.8391681,46.3517797,59.0972134,1.0427219,174.3561731),(9134,'Bos_taurus_femur-cleaned.tif',151,7,96,1085.2696095,104.0665803,95.9513119,1.8,104.0858765,97.2429167,-1.0888522,23.7785668,30.3495325,198401.6643104,321183.1383069,142.0193266,10582.8034999,8343.7183586,16840.3722545,46.6165356,59.1591807,1.0281347,175.1296114),(9135,'Bos_taurus_femur-cleaned.tif',151,7,97,1080.7684208,103.9028146,95.9811798,1.8,103.8969334,97.224047,-1.067593,23.8594302,30.2033046,201672.7052119,323757.5676132,138.2393149,10719.2763093,8452.5365295,17064.4346916,46.7803387,59.1591807,1.0281347,175.9968835),(9136,'Bos_taurus_femur-cleaned.tif',151,7,98,1066.7074349,103.8422978,95.9905571,1.8,103.7435774,97.0792953,-1.045065,24.176384,30.1362093,203579.2344739,325532.3223695,133.0096809,10802.032842,8420.5824371,17222.2697233,47.1559962,59.2387578,1.0516502,177.411059),(9137,'Bos_taurus_femur-cleaned.tif',151,7,99,1047.3955079,103.7466947,96.0224843,1.8,103.649365,97.0286791,-1.0194239,24.4244741,30.1798547,203879.3738454,325177.9731702,126.6605061,10774.6699334,8347.3393648,17116.9937095,47.4945076,59.4906779,1.0314917,177.8641286),(9138,'Bos_taurus_femur-cleaned.tif',151,7,100,1038.3255604,103.6342031,95.9967525,1.8,103.3745933,97.103112,-0.9967512,24.7661726,30.1145528,206331.6848139,327345.0755849,122.023149,10869.9962405,8331.1898065,17111.118027,47.7434874,59.5359104,1.069376,179.2783042),(9139,'Bos_taurus_femur-cleaned.tif',151,7,101,1031.0457919,103.4964123,96.1338737,1.8,103.0534754,99.0250045,-1.0033852,29.1800504,52.1885206,209617.6566763,340076.0949823,122.2041489,6516.3007302,7183.5947384,10094.4324022,48.2591836,59.7665637,1.0115111,181.0128483),(9140,'Bos_taurus_femur-cleaned.tif',151,7,102,1033.1874628,103.3165491,96.420488,1.8,102.6982554,99.6579856,-1.0191416,28.7363001,52.2913175,215347.3808028,356318.8262663,124.898946,6814.1107026,7493.9146671,10540.1564328,48.9484147,59.9414662,0.6435011,184.8800397),(9141,'Bos_taurus_femur-cleaned.tif',151,7,103,1046.0901482,103.2539774,96.4185134,1.8,102.5811298,99.7141338,-0.9961116,29.6054687,52.1237771,222325.5023089,364447.0189722,122.8339005,6991.9533736,7509.6092861,10800.1028238,49.5721791,60.1954144,0.6165154,184.7473386),(9142,'Bos_taurus_femur-cleaned.tif',151,7,104,1050.114131,103.2967822,96.2925374,1.8,102.6266291,99.5419925,-0.9774566,30.2889757,51.4203452,228597.7868759,367887.97673,120.3028716,7154.5217264,7547.227393,11016.6097232,50.0723337,60.4235503,0.5524936,185.3880759),(9143,'Bos_taurus_femur-cleaned.tif',151,7,105,1050.4604112,103.3037299,96.1043547,1.8,102.6367119,99.3471128,-0.9591221,30.9263221,51.8071145,235585.9401951,372460.0996084,117.3451261,7189.3619875,7617.6513681,11127.0795141,50.3406219,60.5372958,0.4779324,185.9899459),(9144,'Bos_taurus_femur-cleaned.tif',151,7,106,1050.132621,103.3155891,95.9518189,1.8,102.6393206,99.1831104,-0.9392189,31.6922727,52.1214589,240499.1532972,377906.9792035,114.0104174,7250.5065515,7588.573895,11187.5402515,50.7450036,61.1126368,0.5089424,187.8571911),(9145,'Bos_taurus_femur-cleaned.tif',151,7,107,1044.6277139,103.3618218,95.830742,1.8,102.6913804,99.0229574,-0.9344276,31.8908154,52.1575194,243079.3401208,381427.7367647,112.6165477,7312.9961192,7622.2366045,11271.5537553,51.2178214,61.2641721,0.5003543,189.685569),(9146,'Bos_taurus_femur-cleaned.tif',151,7,108,1052.4837096,103.4934568,95.6853573,1.8,102.9367427,98.8980336,-0.9380268,31.7472363,52.4195394,248890.8450842,386276.3238189,114.0663061,7368.937777,7839.7641637,11427.4052751,51.7037966,61.5697674,0.4692655,190.4590073),(9147,'Bos_taurus_femur-cleaned.tif',151,7,109,1058.0678791,103.5901798,95.3999233,1.8,103.1045245,98.5104746,-0.9294892,32.1342151,52.7777649,255095.7618573,390913.7622656,113.2317597,7406.7888869,7938.4469427,11536.4440992,52.2397208,61.5843395,0.4411795,192.0997176),(9148,'Bos_taurus_femur-cleaned.tif',151,7,110,1066.0404797,103.6649982,95.0368051,1.8,103.1051516,98.0899331,-0.9173594,32.712317,52.8806921,262417.6651297,394908.2098941,112.0114618,7467.9092479,8021.9834374,11661.6853149,52.88468,61.6729126,1.3943079,193.0996907),(9149,'Bos_taurus_femur-cleaned.tif',151,7,111,1090.2437441,103.7982655,94.7115088,1.8,103.2023446,97.7767568,-0.9110073,33.0248654,53.0943832,275002.311046,400592.0228131,113.4384289,7544.9039682,8327.128908,11911.7898813,53.5907603,62.4344842,1.3964829,194.7404011),(9150,'Bos_taurus_femur-cleaned.tif',151,7,112,1106.4187564,104.0312461,94.3862536,1.8,103.4503123,97.3375801,-0.9207487,32.6973899,53.6860634,286912.2463853,401123.1374029,116.8569043,7471.6436959,8774.7752231,12050.4543096,54.4976396,63.0684257,1.4106879,196.4749452),(9151,'Bos_taurus_femur-cleaned.tif',151,7,113,1113.5535503,104.3154479,93.9107801,1.8,103.7394542,96.6601385,-0.9462704,31.8322143,54.7164841,300446.5321326,399541.3483298,122.1403092,7302.0289017,9438.4427309,12145.200274,55.4473504,63.7723191,1.418608,198.4748914),(9152,'Bos_taurus_femur-cleaned.tif',151,7,114,1117.410987,104.5055665,93.4760248,1.8,103.9872138,95.8966582,-0.9695254,31.058913,55.8075665,312030.103882,398107.3341279,126.6387398,7133.5727278,10046.3948675,12196.5746854,56.2940779,64.4255976,1.4322948,199.6625321),(9153,'Bos_taurus_femur-cleaned.tif',151,7,115,1127.3907072,104.8574116,93.0342957,1.8,104.4655783,95.1366106,-1.0301169,31.4054191,57.2702321,323062.6301157,394570.2597697,138.1175302,6889.6221558,10286.8434672,12214.3821532,57.6289814,65.0907013,1.4457044,201.8501459),(9154,'Bos_taurus_femur-cleaned.tif',151,7,116,1156.2047408,105.235199,92.5346203,1.8,104.9206401,94.141821,-1.1081566,32.2508163,58.7342712,339632.1984265,394844.8340463,154.3158889,6722.5629277,10530.9643984,12376.2469267,58.2744231,65.5235067,1.4405849,202.9439528),(9155,'Bos_taurus_femur-cleaned.tif',151,7,117,1154.8799395,105.5519893,92.0091651,1.8,105.1162648,93.1905711,-1.257305,32.7893126,59.9423473,353725.7437277,392250.9404608,174.1752893,6543.8034697,10787.8365209,12444.5292665,58.2452172,65.9069712,1.4413468,208.3191535),(9156,'Bos_taurus_femur-cleaned.tif',151,7,118,1156.8877389,105.9619611,91.7026353,1.8,105.5824963,92.7122093,-1.4680255,31.7600711,58.8662825,364910.8989553,395991.8245688,190.7853044,6726.9718326,11489.6121507,12605.0004538,58.3489559,66.4493316,1.4247841,211.6005742),(9157,'Bos_taurus_femur-cleaned.tif',151,7,119,1178.1335959,106.3300729,91.388991,1.8,105.8589814,92.3464834,1.3487938,33.3091435,51.9183773,378268.0215599,407826.5871978,186.8361303,7855.1489488,11356.2818604,12933.295198,58.6298069,66.8889971,1.4199052,211.3190728),(9158,'Bos_taurus_femur-cleaned.tif',151,7,120,1178.5876892,106.7701788,91.0342613,1.8,106.2176478,91.8875247,1.180344,41.0056194,48.0574179,379746.5423201,423746.0248678,167.9759481,8817.4946447,9260.8415137,13088.7687418,58.3083129,67.5973547,1.4272812,213.6393876),(9159,'Bos_taurus_femur-cleaned.tif',151,7,121,1191.1499406,106.8926695,90.8549201,1.8,106.284739,91.4843812,1.1512697,42.5012488,47.5991958,383758.1880054,445378.5937659,165.586463,9356.8512344,9029.3391199,13460.4612092,58.3253499,68.3093134,1.4345037,216.3350376),(9160,'Bos_taurus_femur-cleaned.tif',151,7,122,1199.2570018,107.1844285,90.6349617,1.8,106.4798965,91.3031634,1.1276945,43.8983597,47.1750348,384702.1262908,466228.9721524,163.1346896,9882.9597838,8763.4738274,13746.1284565,58.7574507,69.2691594,1.4589061,218.4288176),(9161,'Bos_taurus_femur-cleaned.tif',151,7,123,1197.2676017,107.513776,90.5385653,1.8,106.8445586,91.0354491,1.1144612,44.810203,46.8207839,384765.69203,483217.6106057,160.796574,10320.5792398,8586.5643599,13975.8144877,59.3157704,70.1754061,1.4437072,223.5225169),(9162,'Bos_taurus_femur-cleaned.tif',151,7,124,1211.7098538,107.7598452,90.3784941,1.8,107.1611942,90.7555617,1.1183558,45.2814852,46.9463591,389477.1111647,505309.2911238,163.3565673,10763.5459118,8601.2441913,14322.1769808,59.3034257,71.2455889,1.9664225,224.0694203),(9163,'Bos_taurus_femur-cleaned.tif',151,7,125,1227.95153,108.0233223,90.3124674,1.8,107.4236273,90.4689057,1.1207675,45.443509,46.9467736,394969.8486506,528136.6128078,165.9335757,11249.6892304,8691.4469731,14738.9962064,59.4989742,72.4652228,1.9651769,226.7101038),(9164,'Bos_taurus_femur-cleaned.tif',151,7,126,1246.4251972,108.2863538,90.2313758,1.8,107.6415013,90.3128893,1.1269263,45.9648987,47.0493651,402851.8899434,556536.886148,169.4272575,11828.786329,8764.3375963,15156.3908307,59.9303523,74.0423249,1.9619716,230.6322617),(9165,'Bos_taurus_femur-cleaned.tif',151,7,127,1271.8877774,108.5134036,90.0351318,1.8,107.8751607,90.0847584,1.1305639,46.0953146,47.2143482,416216.2409062,589533.2463629,173.4847319,12486.3154787,9029.4695698,15822.5400239,60.1564059,75.7110742,1.9750174,233.1402441),(9166,'Bos_taurus_femur-cleaned.tif',151,7,128,1303.5558464,108.5232105,90.03936,1.8,107.9441436,89.980705,1.1464201,45.4027506,47.5707869,435099.4947738,624122.412597,180.4251505,13119.8673315,9583.1087163,16663.8734233,60.1191431,77.6419932,1.969802,236.9685683),(9167,'Bos_taurus_femur-cleaned.tif',151,7,129,1340.1375042,108.4973182,90.082923,1.8,107.8693671,89.9293334,1.150627,45.1737931,47.6362635,459943.2608724,664464.8758431,186.1909509,13948.7194699,10181.6391567,17703.3173221,60.8534633,79.7241924,1.9693188,242.7030048),(9168,'Bos_taurus_femur-cleaned.tif',151,7,130,1345.1244639,108.5906471,89.5096569,1.8,108.2544598,88.1332375,1.0553846,41.9971446,45.0400954,465195.0541427,670185.6171066,169.7225146,14879.755719,11076.8257882,19123.5114072,61.4971481,81.937928,1.947797,248.7189427),(9169,'Bos_taurus_femur-cleaned.tif',151,7,131,1375.32602,108.6999284,89.536093,1.8,108.4542809,87.7555539,1.0739695,35.0496634,44.4063638,492702.1993657,709258.2884627,177.145618,15971.9965199,14057.259071,24709.1312075,62.5731042,84.602269,1.9648842,256.5471592),(9170,'Bos_taurus_femur-cleaned.tif',151,7,132,1415.1211358,108.8961964,89.6212249,1.8,108.5493667,87.5644021,1.0984937,36.4825393,46.9052364,527560.6290698,762132.2048216,187.0392429,16248.3394751,14460.633492,25303.8617175,64.2826938,87.7647984,1.9357557,284.0478006),(9171,'Bos_taurus_femur-cleaned.tif',151,7,133,1482.4156351,108.8591121,89.0169546,1.8,108.6018539,86.1471106,1.2043183,38.499253,56.4828219,578780.4653802,879427.7156517,215.3455508,15569.8261151,15033.550549,24445.407036,68.107029,97.4724031,1.881255,316.5094402),(9172,'Bos_taurus_femur-cleaned.tif',151,7,134,1541.1471219,108.8478697,88.2416851,1.8,108.7762913,85.3318704,1.2803349,39.9731655,59.1034982,632796.9393207,1008258.3260785,235.7899321,17059.1988124,15830.5435875,26804.3234419,71.1252596,100.7920947,1.8707057,303.0245216),(9173,'Bos_taurus_femur-cleaned.tif',151,7,135,1627.5003528,108.9301799,88.2762645,1.8,108.8920548,85.0802197,1.3218652,40.763341,61.7342779,702299.0310174,1128816.4674065,254.7859204,18285.0841632,17228.6916277,28818.6603809,73.7346749,104.2335418,1.8643853,313.5872553),(9174,'Bos_taurus_femur-cleaned.tif',151,7,136,1735.5020519,109.1636191,88.4463621,1.8,109.2240663,85.2135357,1.3417476,42.8374725,63.8273687,781740.5736494,1256441.6388843,274.3388361,19684.9982289,18248.9892143,31207.1146747,78.3397637,107.2746617,1.8708855,329.2436884),(9175,'Bos_taurus_femur-cleaned.tif',151,7,137,1844.7594415,109.6855581,88.8585358,1.8,109.43109,85.5993717,1.3560775,44.6207748,66.1230496,891522.4043826,1412810.6504267,293.5012314,21366.3867531,19979.9848579,34239.7883733,81.199516,111.0860397,1.8639203,342.3144046),(9176,'Bos_taurus_femur-cleaned.tif',151,7,138,1916.520506,109.8454636,89.3305424,1.8,109.4850866,86.1894903,1.3893389,45.9930017,67.9167602,983214.9901939,1550794.2241253,309.0175284,22833.7485336,21377.491233,36776.3936656,83.0889206,114.0133017,1.8668015,353.197507),(9177,'Bos_taurus_femur-cleaned.tif',151,7,139,2003.7744006,109.5960534,90.0824418,1.8,109.3883943,87.0756831,1.4181934,46.4930668,69.8595172,1085761.9744635,1690446.366787,326.2453808,24197.7963027,23353.2018828,39377.3694703,86.5611223,117.3111083,1.8685682,365.8540207),(9178,'Bos_taurus_femur-cleaned.tif',151,7,140,2123.8817653,109.174898,90.9836952,1.8,109.1505188,88.1797307,1.4584397,48.3518396,71.7237969,1227495.2802171,1861312.8057871,349.5304164,25951.1192481,25386.7338043,42809.1591939,90.8811298,120.4436115,1.3110212,380.8469487),(9179,'Bos_taurus_femur-cleaned.tif',151,7,141,2268.5399434,108.9667065,92.8080758,1.8,109.1795842,90.4392315,1.4482442,49.1075718,73.7724874,1367482.3196896,2131107.7552425,372.4398175,28887.5681234,27846.6694559,47055.1535879,0.3867191,0.5469034,2.3561945,1.0938069),(9180,'Bos_taurus_femur-cleaned.tif',151,7,142,2469.6637642,108.9001802,96.5830743,1.8,108.6301152,94.1177178,1.4519144,50.3006871,77.635001,1500759.1584492,2675583.408216,405.8207278,34463.6230348,29835.7586399,53443.4980755,95.8499852,139.2017006,1.3123414,440.200691),(9181,'Bos_taurus_femur-cleaned.tif',151,7,143,2693.4354212,108.6523991,100.0645709,1.8,108.0550422,97.239185,1.4791876,51.6644766,81.2650001,1686056.1459343,3209158.0304181,445.149138,39490.0390679,32634.7281147,59964.6833764,100.6589726,144.0325029,1.7571339,515.1558998),(9182,'Bos_taurus_femur-cleaned.tif',151,7,144,2838.802293,108.5309149,102.4192402,1.8,107.5156579,99.3077709,1.4799187,51.804028,83.5684281,1850847.9346762,3553793.8711298,469.2369709,42525.5560452,35727.8768744,64346.5503717,102.4310761,146.3132829,1.7541959,516.084807),(9183,'Bos_taurus_femur-cleaned.tif',151,7,145,2967.8391626,108.2224632,104.6018131,1.8,106.9907157,101.0749007,1.4894116,52.6207107,85.6239716,2019314.3061328,3875790.4165239,491.3708609,45265.2492388,38374.8961099,68458.5241786,104.3138324,148.0482887,1.7599953,526.0229029),(9184,'Bos_taurus_femur-cleaned.tif',151,7,146,3053.6724068,107.9092269,106.3899252,1.8,106.649461,102.4185497,1.4987925,53.5639977,87.1038796,2137016.9570152,4123080.8037188,506.3112959,47335.2142443,39896.5172101,71475.1505184,105.878164,149.4408042,1.30636,523.2722863),(9185,'Bos_taurus_femur-cleaned.tif',151,7,147,3120.6373486,107.4815522,107.7063194,1.8,106.4442803,103.6958578,1.4997282,54.2130609,87.9531969,2246239.5219938,4330371.8715124,517.4837578,49234.9570581,41433.5491118,74259.7378534,106.7344817,150.4655532,1.342649,526.3499401),(9186,'Bos_taurus_femur-cleaned.tif',151,7,148,3145.5084292,107.1869754,108.9955674,1.8,106.3037242,104.7861397,1.4968397,54.9060594,88.4194628,2348292.9090899,4479421.7331999,521.38919,50661.0376682,42769.2851461,76500.6326339,108.1208741,151.0127088,1.3171222,531.1782373),(9187,'Bos_taurus_femur-cleaned.tif',151,7,149,3138.0876743,106.9337249,110.0102286,1.8,106.2472551,105.9208638,1.4974897,55.572741,88.6193793,2440103.2577788,4584086.1068258,520.2090386,51727.8065199,43908.2761279,78369.6449873,108.4945206,151.5958746,1.3443799,531.3109383),(9188,'Bos_taurus_femur-cleaned.tif',151,7,150,3155.5972316,106.6299992,110.8266849,1.8,106.1248443,106.8701591,1.492349,66.0538348,88.4637063,2526455.2655998,4668328.88583,522.7029358,52771.1202872,38248.4267813,80278.008867,109.4539609,151.3949856,1.3388281,532.8739142),(9189,'Bos_taurus_femur-cleaned.tif',151,7,151,3192.4821621,106.4091468,111.6654213,1.8,105.7608518,107.7794943,1.4856699,92.727714,88.0063982,2624512.4298676,4734614.479887,528.2339343,53798.5257386,28303.4307299,74179.2020578,110.4601724,151.764475,1.2893465,527.8190822),(9190,'Bos_taurus_femur-cleaned.tif',151,7,152,3227.7714667,106.1669789,112.2356707,1.8,105.4083995,108.4119284,1.4746753,92.8140559,87.0920311,2705792.4025647,4722046.8196658,533.0068326,54219.0457577,29152.8301101,75224.1434591,111.3072647,150.7589724,1.2847449,530.873968),(9191,'Bos_taurus_femur-cleaned.tif',151,7,153,3242.2766664,105.5779781,112.8965304,1.8,104.999388,109.167425,1.4674047,92.4025593,85.7239575,2773446.6313825,4633686.727659,534.623429,54053.5792075,30014.8248286,75638.989551,111.4152351,149.5423451,1.3038639,553.7567476),(9192,'Bos_taurus_femur-cleaned.tif',151,7,154,3280.2957879,105.2233339,113.3170543,1.8,104.8145254,109.6325462,1.4553129,92.3871649,84.1782042,2835775.3133759,4535938.1976016,539.4570785,53884.9484757,30694.4727131,75663.5579247,111.0391938,148.3878165,1.2745967,551.2487652),(9193,'Bos_taurus_femur-cleaned.tif',151,7,155,3304.4651085,104.8847954,113.6999609,1.8,104.7026895,110.2096815,1.4353744,92.5983467,82.139058,2866091.602699,4393463.275177,540.7056255,53488.1137221,30951.8658329,74872.6918906,110.8804882,147.052971,1.2773244,541.1940676),(9194,'Bos_taurus_femur-cleaned.tif',151,7,156,3344.1091318,104.5505209,114.0200421,1.8,104.7080652,110.694162,1.4241057,92.538958,80.0187922,2873996.2033993,4228063.6884282,545.4441379,52838.3842521,31057.1489589,73580.833262,110.649796,145.0624669,1.2675934,537.4984445),(9195,'Bos_taurus_femur-cleaned.tif',151,7,157,3388.1691898,104.4482384,114.0248729,1.8,104.812156,111.0585655,1.4249349,92.4142768,77.6768574,2857192.6341493,4033935.2476102,552.7656367,51932.2663412,30917.2211476,71465.6568394,110.2156609,143.2119702,1.2379446,519.4050949),(9196,'Bos_taurus_femur-cleaned.tif',151,7,158,3354.139473,104.5135463,114.0039905,1.8,105.0410405,111.3929789,1.4144416,93.0273186,74.9949497,2830061.0091707,3815810.7839136,545.4679276,50880.9032749,30421.8271775,68853.3050258,109.6367138,141.3859126,1.2334761,531.7573394),(9197,'Bos_taurus_femur-cleaned.tif',151,7,159,3286.8308342,104.8192532,113.6680136,1.8,105.2826884,111.4663334,1.4014532,94.0277311,71.5149264,2788713.7773461,3573066.5084852,532.2452712,49962.5279733,29658.4182479,65496.0727386,109.1948397,137.0797973,2.2843185,535.530697),(9198,'Bos_taurus_femur-cleaned.tif',151,7,160,3221.8307297,105.2259773,113.7140377,1.8,105.6273374,111.83568,1.3285691,95.9358674,66.6148919,2729636.8722803,3325552.877247,506.0768816,49922.0636968,28452.7252021,62114.3986347,109.6831336,135.1200205,2.2120078,534.6245577),(9199,'Bos_taurus_femur-cleaned.tif',151,7,161,3180.64433,105.5773312,113.5747813,1.8,105.7887516,112.2699957,1.1700684,97.8428591,66.0829612,2632161.7087746,3046536.1468286,449.4413561,46101.6892917,26901.9296019,58027.5680203,108.9838637,132.5674103,2.2154643,523.6248536),(9200,'Bos_taurus_femur-cleaned.tif',151,7,162,3104.561267,105.6227853,113.4336114,1.8,106.0558983,112.5652937,0.920162,95.4046237,65.6211175,2483096.4941555,2768156.1071761,327.6026885,42183.9220845,26027.0036947,53605.4019388,107.9376282,129.8023229,2.2315782,509.3825961),(9201,'Bos_taurus_femur-cleaned.tif',151,7,163,2972.1174286,105.9278991,112.9654986,1.8,106.3829618,112.6105522,0.606036,84.6197655,66.3091324,2183692.1990064,2503665.2032325,160.7221913,37757.4719046,25805.9353655,47602.303819,106.3185021,126.8916182,2.2417296,497.7649226),(9202,'Bos_taurus_femur-cleaned.tif',151,7,164,2808.2768896,106.3524619,112.5978796,1.8,106.966364,112.4710861,0.425636,74.8693396,65.8420114,1846747.8062397,2258181.4615661,79.7955554,34296.9695699,24666.2761673,41461.3481283,103.3075938,123.2669902,2.2450473,482.7103596),(9203,'Bos_taurus_femur-cleaned.tif',151,7,165,2575.7176206,106.5895228,112.9286559,1.8,107.2939087,112.7019503,0.2673983,64.4840291,76.9867038,1498099.7195811,2008738.6766267,29.9701254,26092.0207978,23232.1047522,35390.6165634,98.6051097,119.2324776,2.2597207,469.6007762),(9204,'Bos_taurus_femur-cleaned.tif',151,7,166,2220.5684289,106.7058374,114.2327711,1.8,107.2071457,113.6441965,0.147706,54.9809881,84.1919513,1118011.2071846,1748670.2180015,8.0158317,20770.0402693,20334.5055573,29050.3766227,93.7254453,114.725953,2.2702821,550.7434912),(9205,'Bos_taurus_femur-cleaned.tif',151,7,167,1722.6807589,106.0474604,116.2069952,1.8,106.8585402,115.8359601,0.089073,48.330555,86.5833686,740997.502331,1435665.2077498,2.2719369,16581.3045929,15331.8641092,22367.1020366,45.3290806,89.3622495,1.5967645,313.1891522),(9206,'Bos_taurus_femur-cleaned.tif',151,7,168,1089.9999748,100.7874262,119.2661425,1.8,102.9871217,118.6843524,0.1604307,49.145439,78.048292,378289.0349308,933947.8467829,4.6357606,11966.2816791,7697.3375873,14384.8486582,39.3682411,55.1871378,1.7255767,161.6219249),(9207,'Bos_taurus_femur-cleaned.tif',151,7,169,457.9493471,89.3497117,118.7876515,1.8,92.9573993,119.9085116,-0.1146451,47.1274024,76.6016243,165481.0271543,201747.3604601,0.9987889,2633.7217036,3511.3547265,4536.94727,30.8802746,41.3409811,1.8747973,124.2770215),(9208,'Bos_taurus_femur-cleaned.tif',151,7,170,94.9940103,82.3312455,120.4436733,1.8,81.720224,119.6695597,-1.2006106,49.6428289,55.8560556,7496.3104431,41596.3339373,13.7600247,744.7058967,151.0049005,664.2454956,17.7057987,26.4697879,2.0083061,75.0490426),(9209,'Bos_taurus_femur-cleaned.tif',151,7,171,2.3551672,20.784816,155.6140126,1.8,20.7571497,155.5819427,0.2766286,0.7309376,4.4621311,0.3125622,13.308255,0.0292791,2.9824886,0.4276181,3.0335403,1.9160132,9.2973586,2.8461518,20.6723979),(9210,'Bos_taurus_femur-cleaned.tif',151,7,172,2.24962,22.0140336,155.9414146,1.8,24.0569437,156.0838614,0.0862078,1.3121962,124.1770768,0.6799073,354.9301688,0.0027796,2.8582584,0.5181446,2.8636837,1.9186963,8.560393,2.8198421,19.1255213),(9211,'Bos_taurus_femur-cleaned.tif',151,7,173,52.3410977,97.5994487,164.6923243,1.8,96.9668547,164.442632,0.0310428,8.6145871,80.8555054,490.3059989,111171.0811948,0.0084038,1374.9352081,56.9157862,1375.0981803,12.462464,160.9420791,3.1127545,341.0662729),(9212,'Bos_taurus_femur-cleaned.tif',151,7,174,52.2573941,97.8384666,164.6678322,1.8,97.0160279,164.4713382,0.0296167,8.4693919,81.082917,457.8452195,111247.0703772,0.0076373,1372.0161351,54.0588064,1371.6781553,12.2277243,160.9420791,3.1127545,342.3477474),(9213,'Bos_taurus_femur-cleaned.tif',151,7,175,52.3807516,97.8608225,164.6415791,1.8,96.2214106,164.4514407,0.0285443,7.9707418,80.6987375,429.0184871,111601.4023369,0.0071112,1382.93864,53.8241605,1382.6601504,11.7399064,160.544809,3.1150928,339.0113601),(9214,'Bos_taurus_femur-cleaned.tif',151,7,176,52.9031855,97.8339196,164.6463956,1.8,96.2241637,164.4122793,0.0281375,7.9439954,80.2715723,406.7507002,112370.4921576,0.0069789,1399.8790481,51.2022831,1399.7400868,11.4909421,160.148421,3.1174428,337.276816),(9215,'Capra_hircus-femur-cleaned.tif',152,7,1,23.4686851,66.4641496,94.4066948,1.8,67.6131581,94.5681341,-0.0441789,2.5655467,36.7598376,29.1512854,9986.8731686,0.0076293,271.6789253,11.3626019,272.1717652,8.3203236,137.5638016,0.0040322,290.7768796),(9216,'Capra_hircus-femur-cleaned.tif',152,7,2,24.118797,65.9632465,94.5368735,1.8,67.5032713,94.6728924,-0.0427303,2.6210265,36.2559033,30.669577,10278.9588721,0.0073352,283.5113168,11.7013609,283.9863465,8.3203236,137.5638016,0.0040322,290.7768796),(9217,'Capra_hircus-femur-cleaned.tif',152,7,3,24.6221319,65.6975896,94.6515934,1.8,68.0618025,94.8031252,-0.0397703,2.6179056,35.9902138,32.3123006,10593.6925737,0.0064873,294.3492538,12.3428059,294.8284998,8.3203236,137.5638016,0.0040322,291.006639),(9218,'Capra_hircus-femur-cleaned.tif',152,7,4,24.4680593,65.5208237,94.7316237,1.8,68.0514381,94.8945791,-0.0380541,2.6294572,36.0198118,33.1502172,10588.2551315,0.0059026,293.956426,12.6072473,294.873328,8.5976677,137.5638016,0.0040322,291.006639),(9219,'Capra_hircus-femur-cleaned.tif',152,7,5,24.1196361,65.468769,94.8224845,1.8,67.7178118,95.0424337,-0.037265,2.6986267,36.0750671,33.1322805,10405.0234091,0.0055798,288.427001,12.2774596,289.3360115,8.5976677,137.5638016,0.0040322,291.006639),(9220,'Capra_hircus-femur-cleaned.tif',152,7,6,7.0487637,66.3943012,77.8842699,1.8,65.2383561,78.4443018,-0.3679347,3.3563652,21.9628678,14.8238084,1902.7262449,0.1519904,86.6337796,4.4166255,87.2156523,0,0,0,0),(9221,'Capra_hircus-femur-cleaned.tif',152,7,7,52.407927,72.4269266,76.0743723,1.8,67.8966234,77.9615271,-0.4000385,6.7711646,30.3707971,407.5864506,10097.7204033,1.3248221,332.4812436,60.1944388,345.6221506,12.0798148,12.9166157,2.8809903,40.8912287),(9222,'Capra_hircus-femur-cleaned.tif',152,7,8,93.5523768,72.3494723,76.4035267,1.8,68.9348291,77.6133888,-0.4122544,8.1762156,30.4347114,1329.4842867,18198.3295816,2.503168,597.9465148,162.6038682,641.5535824,15.8086148,17.3378898,3.0132694,54.2152925),(9223,'Capra_hircus-femur-cleaned.tif',152,7,9,128.4252556,72.2507129,76.2703434,1.8,69.7348458,77.1611941,-0.4094509,9.2399198,30.6933454,2537.0824264,24373.3493445,3.3923133,794.0923028,274.5784041,874.28498,18.4990355,21.0233428,0.1456284,69.5677702),(9224,'Capra_hircus-femur-cleaned.tif',152,7,10,152.4372273,72.2014718,76.0729474,1.8,70.0474336,76.9474232,-0.4054407,10.1991598,30.789448,3716.1777117,29639.5802281,3.9524463,962.6538364,364.3611599,1082.5353445,20.2461207,24.0203065,0.54636,74.9521882),(9225,'Capra_hircus-femur-cleaned.tif',152,7,11,174.4792607,71.4013455,76.2400281,1.8,69.5561262,76.9734002,-0.3824493,11.6229145,30.052927,4971.2501136,37595.4741187,4.0500622,1250.9754562,427.7111506,1390.25766,21.6328413,27.4626702,0.3504966,81.6084471),(9226,'Capra_hircus-femur-cleaned.tif',152,7,12,187.2533952,71.3973575,76.1527881,1.8,69.4014427,76.8755507,-0.3772827,11.8367483,30.0643001,5781.82879,42463.0255403,4.2355274,1412.4069227,488.4642866,1587.2649786,22.7422178,30.0927955,0.3479836,86.7746516),(9227,'Capra_hircus-femur-cleaned.tif',152,7,13,194.4118046,70.3721177,76.4210051,1.8,68.7334455,76.9652604,-0.3713672,12.9277455,29.5067143,6385.7106951,46860.6515373,4.2669831,1588.1351951,493.9539312,1718.0821158,24.2863773,52.2622596,0.623334,188.0779129),(9228,'Capra_hircus-femur-cleaned.tif',152,7,14,200.998397,69.6817905,76.2989729,1.8,68.331413,76.8578591,-0.3529896,13.6595821,28.6260976,6390.4197306,48575.4859911,4.0036105,1696.8951424,467.8342039,1887.422953,25.0342247,51.2914189,0.5144513,162.7689213),(9229,'Capra_hircus-femur-cleaned.tif',152,7,15,193.1686181,69.5121518,76.0538488,1.8,68.1208159,76.706621,-0.3525219,13.9597138,28.647806,6325.9120704,46668.630561,3.8378874,1629.0472866,453.1548526,1825.1445978,25.5485227,51.3266488,0.5265186,160.7799278),(9230,'Capra_hircus-femur-cleaned.tif',152,7,16,186.8756726,69.0413306,76.0046612,1.8,67.8616866,76.5697252,-0.3619857,14.3325249,28.5330492,6198.6802128,44592.0200473,3.9059963,1562.820003,432.4904558,1765.2825185,24.9561081,51.8121573,0.2709469,158.7515137),(9231,'Capra_hircus-femur-cleaned.tif',152,7,17,183.4220686,68.3573236,75.9822766,1.8,67.3787072,76.4364314,-0.3709907,14.391849,28.3719533,6224.0804295,42901.3167435,4.0179973,1512.1030387,432.472605,1725.3363346,24.8040857,52.2821252,0.301619,163.5927894),(9232,'Capra_hircus-femur-cleaned.tif',152,7,18,176.4693147,67.6092508,76.2249413,1.8,66.871289,76.4110192,-0.3714587,14.1246341,27.6728504,5896.8750506,39042.1311765,3.8749977,1410.8460299,417.4886949,1616.3312437,24.8648208,52.3857452,0.2899355,180.7160474),(9233,'Capra_hircus-femur-cleaned.tif',152,7,19,175.1949408,66.3684815,76.8463443,1.8,66.0823078,76.6627718,-0.3694537,14.038691,26.1924305,5783.1595368,37015.2430191,3.8074993,1413.203825,411.9443583,1632.9331515,24.6168413,50.3583914,0.4562586,164.8367558),(9234,'Capra_hircus-femur-cleaned.tif',152,7,20,174.5574624,65.7405123,77.2172171,1.8,65.4171378,76.8651611,-0.3728549,14.0516263,25.3566804,5676.2293684,35275.5333988,3.8605349,1391.1731671,403.955332,1615.0198901,24.998228,49.0554249,0.5142373,169.761655),(9235,'Capra_hircus-femur-cleaned.tif',152,7,21,172.1967017,65.092497,77.5118726,1.8,64.4880507,77.1488544,-0.3649177,13.6107096,24.3245119,5500.862611,32233.3134678,3.6551029,1325.1371101,404.1569301,1548.8082762,25.2435114,47.8995054,0.4947257,164.4724065),(9236,'Capra_hircus-femur-cleaned.tif',152,7,22,160.9822901,63.8050025,78.472303,1.8,62.6275234,78.3642881,-0.3371841,14.2154153,23.0176676,5145.2728448,27085.3769241,2.9365643,1176.7211784,361.9502317,1378.5324016,25.588542,42.2847471,0.3902503,148.7555794),(9237,'Capra_hircus-femur-cleaned.tif',152,7,23,156.8414896,63.0375205,79.060507,1.8,61.3521267,79.2041269,-0.3285844,14.054974,20.4328935,5145.2620832,24298.946166,2.7221812,1189.2073034,366.081225,1354.9627227,25.4550237,40.3819133,0.3652014,149.5284811),(9238,'Capra_hircus-femur-cleaned.tif',152,7,24,156.9692231,62.8538411,79.5641358,1.8,60.9369463,79.9096187,-0.3439915,13.764063,19.5043105,5121.0539992,22621.220152,2.9755041,1159.8061939,372.059761,1321.7311376,25.2296264,39.0504066,0.3554457,142.8049272),(9239,'Capra_hircus-femur-cleaned.tif',152,7,25,149.0416161,63.3171595,79.789704,1.8,60.9908126,80.5330835,-0.3547772,13.2275863,19.2857484,4838.0257431,20062.4524514,2.9975708,1040.2734742,365.7527254,1173.8305238,23.7584387,38.0325663,0.6872688,136.5687667),(9240,'Capra_hircus-femur-cleaned.tif',152,7,26,143.1954113,63.4664372,79.8139194,1.8,60.8922747,80.8886241,-0.347509,12.1297597,18.8847408,4667.9613574,17835.6640762,2.7679421,944.4484442,384.8354343,1119.0495933,22.7476557,36.8773829,0.1206237,125.4634559),(9241,'Capra_hircus-femur-cleaned.tif',152,7,27,138.8612159,63.6583601,79.9640449,1.8,60.840687,81.3106953,-0.3543214,11.2146206,18.4364403,4806.3707716,16036.7765187,2.7859505,869.8412652,428.5807735,1072.6407105,22.2331842,36.0547355,0.3947911,117.3613457),(9242,'Capra_hircus-femur-cleaned.tif',152,7,28,134.2319283,64.2172177,79.9233485,1.8,61.2647717,81.7361118,-0.334987,11.6004609,18.395164,5058.0933106,14116.1528677,2.4179888,767.3839099,436.0252033,1005.0511764,22.188842,35.3099476,0.6010738,111.7192939),(9243,'Capra_hircus-femur-cleaned.tif',152,7,29,129.9965631,64.8645731,79.872547,1.8,61.9372754,81.9424914,-0.2970061,12.5580047,18.3370685,5276.897139,12541.2031902,1.8556816,683.9262878,420.2018753,945.7726057,22.8361008,34.8847751,0.1115352,105.118784),(9244,'Capra_hircus-femur-cleaned.tif',152,7,30,131.9565252,65.156785,80.2895788,1.8,62.4913098,82.664703,-0.2952645,13.9607175,17.718585,5967.0289347,12169.6452339,1.8622776,686.8294076,427.415636,1000.0935178,24.0361045,34.2045254,0.0730406,112.8680908),(9245,'Capra_hircus-femur-cleaned.tif',152,7,31,137.8380199,65.2683788,81.0749002,1.8,63.0478357,83.4223726,-0.3610627,12.9537837,17.0683424,6974.0036409,12424.825036,2.8670018,727.9456163,538.3758001,1094.9275704,24.1632143,33.6730484,3.0591354,111.2991956),(9246,'Capra_hircus-femur-cleaned.tif',152,7,32,140.4465322,65.6246683,81.3824205,1.8,63.6303559,83.6075688,-0.3571824,12.6872553,16.7369231,7493.1938133,12182.7132348,2.861487,727.8944388,590.607949,1128.1587004,24.3678146,33.4208295,3.0501815,106.5367608),(9247,'Capra_hircus-femur-cleaned.tif',152,7,33,137.4754714,65.9144602,81.423022,1.8,64.0752548,83.8399905,-0.3414285,12.7193295,16.3672831,7890.845331,11846.1016026,2.5688084,723.7671337,620.3821795,1157.4407399,24.6109739,32.7148521,3.0140831,101.3426818),(9248,'Capra_hircus-femur-cleaned.tif',152,7,34,139.3007541,66.2448348,81.4749154,1.8,64.7633922,83.9112974,-0.342082,12.6687466,16.0282018,8207.5205494,11815.4575075,2.6124962,737.1667538,647.8557656,1197.3697918,24.8943447,32.1300499,3.0204496,96.2437722),(9249,'Capra_hircus-femur-cleaned.tif',152,7,35,135.0232229,66.6632952,81.4047556,1.8,65.6841803,83.9190025,-0.3079674,12.8914495,15.8378482,8325.312811,11654.1220579,2.0677265,735.839992,645.8011436,1211.3342178,25.5876885,31.1676059,2.9354713,94.2826531),(9250,'Capra_hircus-femur-cleaned.tif',152,7,36,130.1017334,66.8890654,81.4607944,1.8,66.5319001,83.8246296,-0.1974672,12.9580954,15.3477149,8307.6673538,10904.2339648,0.8345826,710.4793137,641.1179321,1156.0978212,25.7930031,30.5683047,2.9406384,93.7558393),(9251,'Capra_hircus-femur-cleaned.tif',152,7,37,134.3312014,67.6364957,81.6007006,1.8,67.6567754,83.9741163,0.0446566,13.4071392,15.0450773,8855.6102962,11093.6708087,0.0446178,737.3621671,660.5145329,1137.6793586,25.7930031,30.9695414,2.4640545,95.1228497),(9252,'Capra_hircus-femur-cleaned.tif',152,7,38,136.0794244,68.5735887,81.6460627,1.8,68.8124815,83.9221706,0.338971,14.6766459,16.8351544,8918.9980822,11521.909107,2.5076584,684.3958068,607.7000268,1155.7605064,25.7930031,31.8885439,2.4424001,95.8400024),(9253,'Capra_hircus-femur-cleaned.tif',152,7,39,133.7234654,68.8669398,81.6198554,1.8,69.4786289,83.7726074,0.5276477,14.8403241,17.6919601,8533.7442203,11788.0744053,5.6501432,666.2955555,575.0375918,1137.9067294,25.7245987,32.2793289,2.4413539,95.6775379),(9254,'Capra_hircus-femur-cleaned.tif',152,7,40,133.7362853,69.1483367,81.4182248,1.8,70.1584234,83.706564,0.6049322,13.6553642,17.938603,8292.1208753,11967.3285293,7.2089854,667.1271169,607.2427473,1126.7254704,25.6766773,32.5640265,2.3321028,95.7448329),(9255,'Capra_hircus-femur-cleaned.tif',152,7,41,133.9589098,69.2971662,81.0410152,1.8,70.7069822,83.3428658,0.6256631,13.4844872,18.0605452,8100.0164039,12029.1284892,7.6572758,666.0445951,600.6914653,1111.867536,25.5138556,32.5923594,2.40435,97.1791382),(9256,'Capra_hircus-femur-cleaned.tif',152,7,42,132.7538335,69.3259258,80.7313131,1.8,70.9130455,82.9512234,0.638167,13.3311174,18.0709679,7828.2396639,11820.3603917,7.8521094,654.1077648,587.2155655,1085.4029907,25.2202947,32.4302927,2.2896263,94.1759376),(9257,'Capra_hircus-femur-cleaned.tif',152,7,43,132.0856339,69.3152871,80.2698077,1.8,70.9876583,82.3776608,0.6464606,13.1009321,17.9772582,7546.3236597,11518.3199401,7.987737,640.7161648,576.0142578,1058.0244367,24.9639742,32.2005958,2.3074526,94.6354564),(9258,'Capra_hircus-femur-cleaned.tif',152,7,44,130.5908265,69.1284244,79.7412671,1.8,70.8424764,81.8273536,0.6751278,12.9696747,17.9612357,7352.5801728,10946.4109221,8.5019273,609.4464262,566.9055207,1018.6027123,24.7592344,31.6767782,2.2756239,92.0523541),(9259,'Capra_hircus-femur-cleaned.tif',152,7,45,128.4911269,68.9921516,79.1853876,1.8,70.6609919,81.2030469,0.7034507,12.8343737,17.4664417,7104.2393699,10313.7778722,8.9605194,590.4910712,553.5322203,997.2140262,24.532643,30.8201577,2.311638,90.29312),(9260,'Capra_hircus-femur-cleaned.tif',152,7,46,128.1872705,68.9066722,78.6066368,1.8,70.3265577,80.4095592,0.7224648,12.8379231,16.9420845,6887.5106652,9886.0254574,9.3412766,583.5188381,536.4972668,989.8933482,24.355054,30.056989,2.2974387,88.3320009),(9261,'Capra_hircus-femur-cleaned.tif',152,7,47,130.0295454,69.0067862,78.138171,1.8,70.079263,79.7333674,0.7053346,12.7125926,16.3903266,6752.014358,9661.5949385,9.108097,589.4693377,531.128038,1001.1971442,24.1327833,29.3001954,2.2825027,86.2084174),(9262,'Capra_hircus-femur-cleaned.tif',152,7,48,129.4708282,69.0131319,77.6834459,1.8,69.836634,78.9079139,0.6884962,12.580686,15.9613227,6633.741391,9205.39339,8.7113047,576.7312364,527.2956799,992.3163864,23.7102899,28.6752897,2.3014547,84.5722272),(9263,'Capra_hircus-femur-cleaned.tif',152,7,49,129.7416091,68.9249788,77.2373155,1.8,69.606338,78.2652293,0.6744029,12.3279277,15.3961122,6595.407654,8723.3219297,8.4313468,566.5925151,534.9972684,994.9676974,23.4964165,27.8920501,2.299916,84.2472983),(9264,'Capra_hircus-femur-cleaned.tif',152,7,50,127.3430179,68.8515215,76.8058772,1.8,69.3477191,77.6004435,0.6534099,12.110489,14.8714722,6441.7096618,8080.5203095,7.8430417,543.35712,531.9116061,975.8863933,23.1890334,27.1088803,2.2982883,81.1768028),(9265,'Capra_hircus-femur-cleaned.tif',152,7,51,125.9932392,68.7625746,76.2666851,1.8,69.0559158,76.7959288,0.6648775,12.1086374,14.5825858,6319.217775,7617.7980237,7.9930742,522.3900706,521.8768672,952.4656045,22.6983311,26.3841588,2.4455085,79.2156837),(9266,'Capra_hircus-femur-cleaned.tif',152,7,52,124.932842,68.6860398,75.7918365,1.8,68.8754805,76.2584258,0.692956,12.2309213,14.47838,6249.2764005,7161.4606323,8.4971731,494.6313475,510.9407755,924.2864545,22.5019921,26.1013088,2.3937708,78.3639411),(9267,'Capra_hircus-femur-cleaned.tif',152,7,53,123.5735533,68.7420159,75.4016326,1.8,68.937415,75.8731707,0.7273518,15.409143,14.0106692,6143.6476059,6755.279908,9.1049801,482.1525535,398.7014463,830.5993229,22.3421001,25.64196,2.2489156,77.0248052),(9268,'Capra_hircus-femur-cleaned.tif',152,7,54,124.0131148,68.8372864,75.1682896,1.8,68.9596087,75.5708543,0.8117786,11.6585387,13.2969856,6084.0132147,6520.0798945,10.8794258,490.342707,521.8504104,944.8761917,22.0792686,25.1283568,2.2231272,76.2124831),(9269,'Capra_hircus-femur-cleaned.tif',152,7,55,124.6241374,68.937094,74.8628334,1.8,69.0183383,75.3386842,0.9959434,11.6748052,12.75367,6042.3124542,6323.4337023,14.6304153,495.8128664,517.5514592,959.2931395,21.9101854,24.7691746,2.16501,75.265571),(9270,'Capra_hircus-femur-cleaned.tif',152,7,56,125.882265,69.0796499,74.5229986,1.8,69.0957835,75.0126951,1.1673071,11.5583581,11.898084,5975.9689711,6223.2840785,17.7460821,523.0492644,517.0257692,978.5601397,21.7311027,24.3115495,2.177784,75.0079372),(9271,'Capra_hircus-femur-cleaned.tif',152,7,57,127.2805264,69.1678815,74.1296123,1.8,69.2104015,74.5562785,1.2492519,11.3923951,11.5985453,5898.6998288,6178.7369459,19.0947018,532.7165429,517.7752134,996.0615715,21.3554972,23.7967073,2.2073045,73.6015063),(9272,'Capra_hircus-femur-cleaned.tif',152,7,58,127.4774643,69.2972773,73.7683104,1.8,69.353927,74.0804649,1.3548922,11.2083083,11.5690258,5770.6249899,6091.1469938,20.2711524,526.5047442,514.8524508,980.4041825,21.3554972,23.5399651,2.1718701,73.1141131),(9273,'Capra_hircus-femur-cleaned.tif',152,7,59,126.9003097,69.4008378,73.3356293,1.8,69.4326782,73.6477705,1.4386698,11.0441454,11.4136771,5639.8822348,5954.9284956,20.7829702,521.7361988,510.6671482,990.891193,21.0781531,23.1860347,2.2119051,72.4921299),(9274,'Capra_hircus-femur-cleaned.tif',152,7,60,125.9124735,69.477914,72.8788323,1.8,69.4868922,73.1489236,1.5128543,10.8272743,11.1492852,5500.3412524,5817.4617171,20.9150373,521.7788976,508.0079364,980.252931,21.0781531,22.9190978,1.1992785,72.0047366),(9275,'Capra_hircus-femur-cleaned.tif',152,7,61,123.9754707,69.5019469,72.4643662,1.8,69.5447889,72.7070876,-1.3893533,10.7168358,11.1705226,5356.9451956,5623.291563,19.9897659,503.404518,499.8625822,951.158722,20.800809,22.870382,1.1722739,71.220289),(9276,'Capra_hircus-femur-cleaned.tif',152,7,62,123.1936863,69.5594415,72.077807,1.8,69.5934203,72.3466567,-1.2254887,10.9791831,11.4512017,5235.4360737,5492.1157795,18.1798387,479.6104293,476.8511478,865.9770637,20.800809,22.7253003,1.1562895,71.1251195),(9277,'Capra_hircus-femur-cleaned.tif',152,7,63,123.1690486,69.658043,71.6994867,1.8,69.6957085,71.9299464,-1.1334452,11.0083549,11.5493406,5140.5412171,5418.9757998,16.8456809,469.2021817,466.9672518,871.7122554,20.5234648,22.6608985,1.1948354,70.4358413),(9278,'Capra_hircus-femur-cleaned.tif',152,7,64,124.0127419,69.75381,71.3192791,1.8,69.7935529,71.5647647,-1.1134533,10.8918096,11.4398859,5074.7727268,5397.3116077,16.6387827,471.797679,465.9255837,906.338643,20.5234648,22.4631616,1.2178059,70.1782074),(9279,'Capra_hircus-femur-cleaned.tif',152,7,65,125.6207611,69.7635144,70.9071046,1.8,69.817176,71.1081772,-1.1513633,10.7994152,11.4384067,5027.0987305,5410.4791827,17.4644976,473.0098643,465.4973091,895.2764032,20.2461207,22.3016406,1.2018368,69.3937598),(9280,'Capra_hircus-femur-cleaned.tif',152,7,66,125.0861921,69.8440087,70.5357107,1.8,69.8653086,70.7631515,-1.1295096,10.7806642,11.5600423,4933.9342042,5319.577285,17.04472,460.1693619,457.6651411,875.5274407,20.2461207,22.3016406,1.2018368,69.1640004),(9281,'Capra_hircus-femur-cleaned.tif',152,7,67,124.1411046,69.9121611,70.2225295,1.8,69.9760056,70.4140789,-1.1018114,10.7528476,11.7129681,4827.4126902,5233.7700344,16.463451,446.835508,448.9427236,836.2913215,20.2461207,22.251573,1.1740877,69.068831),(9282,'Capra_hircus-femur-cleaned.tif',152,7,68,123.4550503,69.9946834,69.9389712,1.8,70.0468763,70.1248913,-1.0705372,10.7100481,11.5393189,4731.8661552,5172.8703188,15.8420206,448.2821181,441.8155846,858.2377332,20.1758696,22.2187089,1.1462349,68.9063665),(9283,'Capra_hircus-femur-cleaned.tif',152,7,69,123.4066608,70.1114017,69.6440848,1.8,70.1800156,69.8177261,-1.0500958,10.5629202,11.4684573,4689.0343683,5108.5302881,15.4773697,445.4418028,443.9145896,842.5539649,20.0868713,22.1059096,1.1576675,68.7439021),(9284,'Capra_hircus-femur-cleaned.tif',152,7,70,123.5105957,70.2188116,69.3371274,1.8,70.2645964,69.5021554,-1.0276635,10.5639087,11.3903623,4669.6573153,5029.9721012,15.086749,441.5989552,442.0387814,840.7705284,19.9687766,21.9960291,1.1692158,68.1219189),(9285,'Capra_hircus-femur-cleaned.tif',152,7,71,123.9605297,70.305884,69.047631,1.8,70.3055872,69.1825729,-1.0048309,10.5038698,11.3364605,4642.3465171,4996.2170213,14.7194122,440.7210699,441.9653519,848.1404122,19.9643347,21.8891112,1.1808785,68.0546239),(9286,'Capra_hircus-femur-cleaned.tif',152,7,72,126.0108608,70.4349504,68.7609357,1.8,70.5256537,68.8847325,-0.9732409,10.4047775,11.3860199,4669.8644019,5012.3941644,14.3537948,440.223555,448.8192488,846.7579334,19.6914325,21.8891112,1.1808785,67.4999357),(9287,'Capra_hircus-femur-cleaned.tif',152,7,73,128.2342149,70.4762705,68.4742738,1.8,70.5429904,68.5774048,-0.9774646,10.3008136,11.3463189,4710.2062515,5043.3223843,14.6908897,444.4897437,457.2654588,810.1428543,19.6914325,21.7851996,1.192654,67.3374713),(9288,'Capra_hircus-femur-cleaned.tif',152,7,74,128.2063373,70.5443437,68.2053994,1.8,70.613905,68.4023752,-0.9388402,10.3104675,11.2445765,4693.4398455,4986.505861,13.9113474,443.4587504,455.2111589,836.3792956,19.7733787,21.7851996,1.192654,67.3374713),(9289,'Capra_hircus-femur-cleaned.tif',152,7,75,127.8467724,70.6147938,67.9193337,1.8,70.7343116,68.0727529,-0.8888475,10.2332059,11.2028036,4637.0426966,4943.7382462,12.8424818,441.2947343,453.1368516,840.7124862,19.6914325,21.7410195,1.1642295,66.782783),(9290,'Capra_hircus-femur-cleaned.tif',152,7,76,127.1810668,70.6784203,67.6503419,1.8,70.7968322,67.7996667,-0.85676,10.1497607,11.1653534,4580.8802676,4900.5647273,12.1059381,438.9081609,451.3288915,798.7117442,19.6478541,21.7144683,1.0785851,66.782783),(9291,'Capra_hircus-femur-cleaned.tif',152,7,77,125.6761433,70.7130073,67.4272121,1.8,70.73334,67.6225475,-0.8941587,10.209902,11.1838863,4520.7578023,4830.0957404,12.7331899,431.8799029,442.7817031,824.7957887,19.6425543,21.6328413,1.1760052,67.0125424),(9292,'Capra_hircus-femur-cleaned.tif',152,7,78,126.3105216,70.8047922,67.1481472,1.8,70.8718977,67.2916146,-0.8715731,10.1785927,11.303105,4497.1555726,4828.965772,12.3310421,427.2247127,441.8248856,768.1365658,19.6372648,21.5990358,1.1473569,66.782783),(9293,'Capra_hircus-femur-cleaned.tif',152,7,79,126.8447643,70.9144649,66.9053694,1.8,70.9671787,67.0687167,-0.8342818,10.0763208,11.1452763,4478.3620488,4842.0432652,11.6021901,434.4480239,444.4441734,810.1073507,19.5598515,21.5847861,1.089909,66.3905592),(9294,'Capra_hircus-femur-cleaned.tif',152,7,80,127.5974125,70.9954371,66.6702293,1.8,71.0458175,66.8534618,-0.7989249,9.952927,10.9433203,4493.2414939,4845.9226693,10.9207446,442.8201442,451.449258,824.6156152,19.5608473,21.5830042,1.1186425,66.3905592),(9295,'Capra_hircus-femur-cleaned.tif',152,7,81,129.821932,71.0165991,66.4413607,1.8,71.0753044,66.5821059,-0.7767032,9.88694,11.0751854,4540.0171968,4909.6032294,10.6303702,443.2976123,459.1933588,836.720848,19.5608473,21.4704477,1.0724805,66.6203186),(9296,'Capra_hircus-femur-cleaned.tif',152,7,82,130.0370043,71.0918527,66.1979818,1.8,71.1671947,66.3108856,-0.7344025,10.0019796,11.0545881,4511.8406684,4909.8545357,9.7331111,444.1463121,451.0947668,835.2508892,19.5754587,21.3842928,0.9791966,66.3905592),(9297,'Capra_hircus-femur-cleaned.tif',152,7,83,129.57453,71.1740055,66.0135252,1.8,71.2637137,66.1686438,-0.693795,9.8980584,11.0304537,4482.8065991,4879.907513,8.8306857,442.403156,452.8975716,823.9017335,19.5747354,21.4040672,1.0259324,66.1607998),(9298,'Capra_hircus-femur-cleaned.tif',152,7,84,128.6114946,71.2419229,65.8352416,1.8,71.3484734,65.9524316,-0.6545928,9.8804207,11.3026914,4447.2134123,4852.1651791,7.9456513,429.2929005,450.1036513,821.795145,19.6372648,21.3626997,1.0548708,66.3905592),(9299,'Capra_hircus-femur-cleaned.tif',152,7,85,127.9703568,71.3090839,65.6196459,1.8,71.4435505,65.7147186,-0.6347097,9.8827845,10.9612521,4407.236964,4835.1727919,7.4986859,441.1150048,445.9509337,820.4433898,19.6425543,21.4040672,1.0259324,65.9983354),(9300,'Capra_hircus-femur-cleaned.tif',152,7,86,126.5015623,71.3513879,65.4377442,1.8,71.4455754,65.5352118,-0.6454821,9.8991868,10.9433215,4370.6389324,4799.8227708,7.6302123,438.6074897,441.514946,817.9815684,19.6425543,21.3842928,0.9791966,65.9310404),(9301,'Capra_hircus-femur-cleaned.tif',152,7,87,125.1177525,71.3493797,65.2662071,1.8,71.3988967,65.3352098,-0.6364456,9.8628601,11.1475318,4333.1333271,4799.8360233,7.3661173,430.5738798,439.3384171,815.7822277,19.6432777,21.4040672,1.0259324,65.9983354),(9302,'Capra_hircus-femur-cleaned.tif',152,7,88,125.1169134,71.4100901,65.0833829,1.8,71.4606978,65.1619104,-0.6036289,9.8732282,10.9474202,4321.3234783,4833.16416,6.7189487,441.4888689,437.6809062,820.9968973,19.6914325,21.4040672,1.0259324,66.2280948),(9303,'Capra_hircus-femur-cleaned.tif',152,7,89,125.6208777,71.3870589,64.9248462,1.8,71.3903583,65.0333494,-0.5761868,9.8358292,10.9136547,4351.4973209,4862.5058014,6.2148859,445.5433077,442.4128612,786.9108677,19.6914325,21.4040672,1.0259324,65.9310404),(9304,'Capra_hircus-femur-cleaned.tif',152,7,90,124.121898,71.4519271,64.7875109,1.8,71.4467951,64.8678396,-0.5332351,9.7959766,10.8532652,4316.3955497,4816.1111054,5.3453353,443.7476672,440.6294285,821.1313483,19.6914325,21.3842928,0.9791966,66.1607998),(9305,'Capra_hircus-femur-cleaned.tif',152,7,91,125.5460557,71.6069966,64.6905379,1.8,71.5509492,64.7987171,-0.5320439,9.844928,10.9364282,4336.0249566,4911.2441754,5.3848582,449.0720448,440.4323696,835.3509822,19.6914325,21.3842928,0.9791966,65.9983354),(9306,'Capra_hircus-femur-cleaned.tif',152,7,92,126.2358628,71.7099255,64.6335226,1.8,71.6418133,64.7407157,-0.543514,9.8877809,10.976859,4342.201028,4970.8271639,5.6267709,452.8460421,439.1481859,837.5058087,19.7103733,21.3572981,0.9143089,66.3905592),(9307,'Capra_hircus-femur-cleaned.tif',152,7,93,125.7899846,71.7432818,64.5633837,1.8,71.7182177,64.6402081,-0.5268053,9.9475939,10.9314307,4342.7467499,4974.347322,5.2995745,455.0499794,436.5625276,846.031207,19.7341933,21.3626997,1.0548708,66.3905592),(9308,'Capra_hircus-femur-cleaned.tif',152,7,94,126.1841867,71.7753278,64.4944027,1.8,71.8007197,64.5412341,-0.5536215,9.8905451,10.9215067,4380.2278685,5011.0455222,5.8136287,458.8236465,442.8702164,849.8001482,19.7103733,21.4489414,0.8677801,66.5530237),(9309,'Capra_hircus-femur-cleaned.tif',152,7,95,125.6271478,71.837673,64.3824868,1.8,71.9004827,64.4101003,-0.5620363,9.9102378,10.9541873,4371.1723796,5018.5075536,5.9462142,458.1359997,441.0764386,851.6540497,19.734861,21.4722389,0.9505468,66.3905592),(9310,'Capra_hircus-femur-cleaned.tif',152,7,96,124.5843489,71.8620041,64.2698799,1.8,71.921533,64.3045552,-0.5672481,9.8230431,10.9774426,4372.4728436,5008.5786532,5.9946967,456.2609741,445.1240607,846.5644092,19.7227748,21.4847733,0.8859751,66.5530237),(9311,'Capra_hircus-femur-cleaned.tif',152,7,97,124.1312915,71.8327762,64.1923241,1.8,71.8984249,64.2115099,-0.5749922,9.816244,10.9998544,4381.7548217,5027.1878396,6.1186216,457.0231243,446.3779447,853.8643115,19.6914325,21.4847733,0.8859751,66.3232643),(9312,'Capra_hircus-femur-cleaned.tif',152,7,98,121.994717,71.8314133,64.1076363,1.8,71.8210332,64.106073,-0.6050173,9.7162788,10.9911951,4326.8345317,5001.0651654,6.5776798,455.0064968,445.3180732,846.5452935,19.7227748,21.5776577,0.9221539,66.5530237),(9313,'Capra_hircus-femur-cleaned.tif',152,7,99,119.8995392,71.8602521,64.0460844,1.8,71.8515507,63.9881027,-0.6098561,9.7009309,10.9852322,4270.8206553,4962.5601719,6.5553479,451.7483166,440.2485379,835.9884325,19.5997286,21.6612682,0.8760581,66.7154881),(9314,'Capra_hircus-femur-cleaned.tif',152,7,100,118.6389176,71.894089,63.9933347,1.8,71.8737286,63.9650789,-0.6063987,9.7453967,10.9508422,4241.375616,4942.1274534,6.4223132,451.3011305,435.2183649,837.3790563,19.6004327,21.7002943,0.8940594,66.7154881),(9315,'Capra_hircus-femur-cleaned.tif',152,7,101,117.2158787,71.9391467,63.9232606,1.8,71.9029442,63.8921288,-0.6057614,9.7134017,11.027401,4202.2616278,4918.9506748,6.3336203,446.0661827,432.625124,825.7800383,19.5990245,21.7463259,0.9119903,66.9452475),(9316,'Capra_hircus-femur-cleaned.tif',152,7,102,116.3660785,72.0046797,63.8709723,1.8,72.0046249,63.828728,-0.5714017,9.6696709,11.0158417,4187.9984557,4906.3248396,5.6724048,445.3881022,433.1066176,820.1631185,19.584641,21.8116648,0.8483778,67.1077119),(9317,'Capra_hircus-femur-cleaned.tif',152,7,103,115.8772651,72.0379481,63.8372895,1.8,72.0437917,63.7809903,-0.5348399,9.6106439,10.9953993,4173.0747075,4919.2988912,5.0174357,447.3961127,434.2138523,826.0040642,19.4759782,21.7993184,0.9298397,66.9452475),(9318,'Capra_hircus-femur-cleaned.tif',152,7,104,116.4533242,72.0887398,63.8052095,1.8,72.1372608,63.7520945,-0.4926598,9.5831776,10.9419324,4194.5766726,4953.9838626,4.3417996,452.7521895,437.7020681,826.611732,19.4759782,21.8750504,0.8841748,67.1077119),(9319,'Capra_hircus-femur-cleaned.tif',152,7,105,117.432303,72.0795953,63.7704447,1.8,72.0845381,63.7339588,-0.4661783,9.5833985,10.9015271,4221.6085441,5019.1221114,3.9541092,460.4054135,440.5126779,833.9155665,19.3522279,21.8750504,0.6866216,67.1077119),(9320,'Capra_hircus-femur-cleaned.tif',152,7,106,117.3963838,72.1832225,63.7244521,1.8,72.2997785,63.6875137,-0.4173802,9.6325959,10.9910498,4197.0440368,5044.8574226,3.2151424,458.9968658,435.7126654,825.7901767,19.352932,22.0204943,0.7140907,67.4999357),(9321,'Capra_hircus-femur-cleaned.tif',152,7,107,116.6537817,72.2382551,63.703759,1.8,72.2745273,63.6862284,-0.4024224,9.644184,11.0007739,4168.7159464,5047.748909,2.9822233,458.8539814,432.2518072,822.9734424,19.3522279,22.0204943,0.7140907,67.4999357),(9322,'Capra_hircus-femur-cleaned.tif',152,7,108,116.246107,72.3265427,63.6763392,1.8,72.3681794,63.6625338,-0.3938573,9.7496617,11.1233438,4147.9987433,5063.5521564,2.8531941,455.2185244,425.4505318,816.2640228,19.3522279,22.1823287,0.7411792,67.6624001),(9323,'Capra_hircus-femur-cleaned.tif',152,7,109,116.1647352,72.4023752,63.6487157,1.8,72.4586991,63.6137181,-0.383563,9.8572,11.1444783,4136.9634677,5077.8181253,2.7113972,455.6353372,419.6895116,811.0515193,19.4752741,22.2308223,0.7059199,67.6624001),(9324,'Capra_hircus-femur-cleaned.tif',152,7,110,116.6412415,72.4730573,63.6354417,1.8,72.5467593,63.5906983,-0.3805299,9.9474667,11.2615093,4134.4595084,5129.6488349,2.6817236,455.5027823,415.6293908,813.5127793,19.5402294,22.1875296,0.6435011,67.7296951),(9325,'Capra_hircus-femur-cleaned.tif',152,7,111,116.5565132,72.5355732,63.6583654,1.8,72.624115,63.6460935,-0.3738073,9.9043426,11.3041084,4109.0512201,5178.8763339,2.5903444,458.1410703,414.8736955,812.7657411,19.4752741,22.265396,0.6883588,67.6624001),(9326,'Capra_hircus-femur-cleaned.tif',152,7,112,116.5954859,72.5651687,63.6961173,1.8,72.6819828,63.6684339,-0.3482685,9.954565,11.2880604,4100.6639874,5220.2281994,2.2632304,462.455729,411.938038,815.3423614,19.5598515,22.3119854,0.6086893,67.6624001),(9327,'Capra_hircus-femur-cleaned.tif',152,7,113,117.5303873,72.5492534,63.7282476,1.8,72.6475812,63.7288139,-0.3367199,10.0166911,11.3381552,4125.6087281,5290.8988592,2.1382601,466.6454774,411.8734122,819.4732981,19.5747354,22.4100227,0.6360755,67.6624001),(9328,'Capra_hircus-femur-cleaned.tif',152,7,114,116.9492469,72.5799064,63.7582339,1.8,72.6802666,63.8075559,-0.318635,9.9637861,11.328393,4105.928739,5297.9841911,1.912869,467.6730578,412.0851959,817.5914027,19.5076398,22.4717206,0.6188148,67.6624001),(9329,'Capra_hircus-femur-cleaned.tif',152,7,115,116.4471939,72.5933062,63.7911069,1.8,72.7252234,63.8652759,-0.3069111,10.0010658,11.3191047,4091.8142115,5300.8208065,1.7714295,468.307429,409.1378157,816.9764599,19.4693701,22.5400758,0.6016536,68.0546239),(9330,'Capra_hircus-femur-cleaned.tif',152,7,116,115.6259939,72.5957578,63.8022633,1.8,72.6363146,63.8339471,-0.3184872,10.0037205,11.3295171,4070.8286993,5327.8931596,1.8895313,470.2665728,406.9314712,817.7570393,19.4594665,22.5486057,0.5572955,67.8921595),(9331,'Capra_hircus-femur-cleaned.tif',152,7,117,115.7262227,72.6579561,63.821123,1.8,72.6443293,63.888435,-0.3181828,9.9691265,11.3824118,4073.2203841,5368.0427688,1.8876791,471.6085537,408.5834772,818.3096356,19.4140884,22.6405231,0.5404195,67.6624001),(9332,'Capra_hircus-femur-cleaned.tif',152,7,118,116.29114,72.7269991,63.8484955,1.8,72.7733425,63.879976,-0.3091173,10.0039531,11.4424053,4100.5021489,5412.615587,1.7937618,473.0312768,409.888182,821.2549098,19.4140884,22.6405231,0.5404195,68.0546239),(9333,'Capra_hircus-femur-cleaned.tif',152,7,119,117.4094368,72.7929456,63.8685744,1.8,72.8211616,63.9543851,-0.2978683,10.0402717,11.5585139,4148.0075776,5495.9217152,1.6854573,475.486882,413.1369866,825.6646322,19.56092,22.7692597,0.5947593,68.6766072),(9334,'Capra_hircus-femur-cleaned.tif',152,7,120,118.3616568,72.8146657,63.9180349,1.8,72.8461993,64.0331417,-0.2697841,10.0330547,11.5707465,4189.1073955,5584.9284109,1.4012973,482.6765872,417.5306044,832.7172565,19.5865944,22.8434598,0.5070985,69.068831),(9335,'Capra_hircus-femur-cleaned.tif',152,7,121,120.269127,72.7655244,63.9575314,1.8,72.8214041,64.0613726,-0.2431672,10.0349686,11.6265687,4271.4327785,5714.8889854,1.1620798,491.5370254,425.6548205,851.8735524,19.4140884,22.7844566,0.5508575,68.8390716),(9336,'Capra_hircus-femur-cleaned.tif',152,7,122,119.9023596,72.8334164,64.0249912,1.8,72.8507195,64.1463709,-0.2190732,9.991608,11.7261327,4275.3234409,5744.218709,0.9438352,489.8647217,427.8914324,846.6983306,19.6798545,22.8787887,0.5341826,69.2312954),(9337,'Capra_hircus-femur-cleaned.tif',152,7,123,119.9319388,72.9306176,64.0982969,1.8,72.9956793,64.2372942,-0.1981916,9.9794553,11.8414814,4284.3831525,5779.946479,0.7749259,488.1100832,429.3203401,843.8657604,19.6914325,22.9543103,0.4366272,69.2985904),(9338,'Capra_hircus-femur-cleaned.tif',152,7,124,118.2797489,72.9125613,64.2021521,1.8,72.8571579,64.3229818,-0.1872545,9.9257643,11.8414735,4287.1148427,5756.6400386,0.6831901,486.1422065,431.917857,840.7056353,19.6914325,23.0729639,0.44752,69.6235192),(9339,'Capra_hircus-femur-cleaned.tif',152,7,125,117.8079744,72.9891295,64.285569,1.8,72.9204526,64.4593519,-0.1774391,9.9462558,11.8861336,4300.2938825,5776.969223,0.6117294,486.0259374,432.353035,838.7748352,19.8150535,23.0912923,0.4206633,69.8532786),(9340,'Capra_hircus-femur-cleaned.tif',152,7,126,117.8660139,73.0624336,64.3569474,1.8,72.9939314,64.5093771,-0.1543963,9.9193687,11.9504334,4340.002782,5811.3661897,0.4645766,486.2891565,437.528126,837.1523928,19.8802355,23.1777395,0.3671738,70.015743),(9341,'Capra_hircus-femur-cleaned.tif',152,7,127,118.6908501,73.1175299,64.4061104,1.8,72.9994734,64.5516158,-0.1377232,9.9563004,12.000389,4401.8689003,5903.1839917,0.372849,491.9160526,442.1189305,841.042433,19.9116602,23.3397889,0.3518167,70.5704313),(9342,'Capra_hircus-femur-cleaned.tif',152,7,128,120.9260218,73.2142361,64.5255962,1.8,73.0718603,64.7068904,-0.1384062,9.945951,12.119636,4495.5623017,6085.5897259,0.3836233,502.1264425,451.9992401,853.511864,19.9116602,23.4368089,0.3629258,70.7328957),(9343,'Capra_hircus-femur-cleaned.tif',152,7,129,124.0200143,73.1806088,64.593161,1.8,73.026397,64.7397554,-0.1395838,9.9203466,12.2774712,4614.4812756,6369.2684751,0.4001179,518.7769034,465.1532308,882.9826243,19.9687766,23.5366972,0.3739419,71.2875839),(9344,'Capra_hircus-femur-cleaned.tif',152,7,130,123.2518889,73.1416345,64.6852708,1.8,72.7913385,64.8665713,-0.1414086,9.9363397,12.3076081,4671.1431282,6438.2757797,0.4080349,523.1134867,470.1070263,886.1577087,20.0243195,23.696292,0.3587707,71.7471027),(9345,'Capra_hircus-femur-cleaned.tif',152,7,131,123.380205,73.1610706,64.7942712,1.8,72.8195559,65.0221994,-0.1275823,10.0395005,12.3494391,4746.2848595,6552.2556095,0.3329027,530.5711102,472.7610564,889.1322636,20.1198269,23.8967007,0.3805064,72.0720316),(9346,'Capra_hircus-femur-cleaned.tif',152,7,132,123.9695736,73.1934976,64.9303253,1.8,72.8709023,65.2034579,-0.1186901,10.1726054,12.5481207,4856.5677385,6674.6054731,0.2897027,531.9207272,477.4163123,894.3836204,20.2292812,24.1225618,0.3399304,73.248703),(9347,'Capra_hircus-femur-cleaned.tif',152,7,133,123.5239751,73.2728937,65.0676618,1.8,72.8431327,65.3992024,-0.1103999,10.3115634,12.6833943,4937.2229965,6752.5784603,0.2499033,532.3952149,478.8045025,894.1973571,20.336876,24.2941417,0.3253606,73.5736318),(9348,'Capra_hircus-femur-cleaned.tif',152,7,134,124.8710265,73.3143439,65.195496,1.8,72.8906493,65.5479179,-0.0874774,10.4200033,12.8411753,5081.5234152,6955.5106777,0.1588523,541.6568608,487.6700366,914.3620809,20.531336,24.4393523,0.1595517,74.5878389),(9349,'Capra_hircus-femur-cleaned.tif',152,7,135,127.3073084,73.3924778,65.3070314,1.8,72.9259535,65.6819072,-0.0461816,10.4794563,12.8266237,5242.2932815,7227.5706204,0.0452202,563.4819256,500.2447786,937.7849818,20.7245244,24.5852695,0.1929708,75.3722865),(9350,'Capra_hircus-femur-cleaned.tif',152,7,136,130.9578737,73.5055257,65.4143936,1.8,73.0775331,65.7707205,0.0089992,10.7845692,12.738843,5492.2170368,7561.0883743,0.0017676,593.5459287,509.2662445,969.4236254,21.0752495,24.8064122,0.1798535,76.5489579),(9351,'Capra_hircus-femur-cleaned.tif',152,7,137,134.750857,73.471533,65.5734706,1.8,73.1142802,65.9043573,0.0413023,10.9856286,12.6471155,5766.7338172,7947.6659677,0.0382896,628.417283,524.9343493,1017.5222622,21.3604364,24.9116163,0.2017623,77.3334056),(9352,'Capra_hircus-femur-cleaned.tif',152,7,138,136.0818252,73.5488306,65.6415421,1.8,73.1498574,65.9147935,0.0817641,11.5574461,12.8329546,5848.0866626,8230.4707723,0.1512886,641.3543107,506.0016394,1035.243803,21.4470641,25.3128743,0.0767719,78.510077),(9353,'Capra_hircus-femur-cleaned.tif',152,7,139,136.8155931,73.6590138,65.6463542,1.8,73.2194116,65.7655299,0.1427027,11.6018482,12.7757612,5859.9508124,8458.4411577,0.4612101,662.0694495,505.0876983,1045.9769268,21.5694724,25.63746,3.0440769,79.4569891),(9354,'Capra_hircus-femur-cleaned.tif',152,7,140,138.8699335,73.6764776,65.6846574,1.8,73.2005025,65.6225647,0.1835926,11.6240724,12.911988,5910.0392458,8822.3920353,0.7714047,683.2713959,508.4310417,1074.5275921,21.7741547,26.0068348,3.0132694,79.6194535),(9355,'Capra_hircus-femur-cleaned.tif',152,7,141,139.9459244,73.701471,65.738692,1.8,73.3031229,65.5023362,0.2022386,11.7120359,13.4024007,6006.7721036,9113.9148529,0.9410399,680.0210706,512.8717275,1107.7145326,22.0123461,26.632257,2.9952774,80.0789723),(9356,'Capra_hircus-femur-cleaned.tif',152,7,142,144.7176068,73.8988288,65.7211108,1.8,73.5017725,65.3131247,0.2436823,11.8017335,13.6014229,6214.5298361,9553.309744,1.4041221,702.375759,526.5777149,1144.1006651,22.4536869,26.9922947,2.976444,81.0931793),(9357,'Capra_hircus-femur-cleaned.tif',152,7,143,147.4052298,73.9051183,65.728358,1.8,73.5912091,65.2456367,0.2837302,11.9535085,13.8634411,6482.9653873,9927.9200055,1.9252515,716.122347,542.3483329,1177.3415324,22.7489813,27.089011,2.9562447,81.4181081),(9358,'Capra_hircus-femur-cleaned.tif',152,7,144,148.0200518,73.8839279,65.7705616,1.8,73.5669358,65.185556,0.3084071,12.3054685,14.1666059,6714.6905467,10176.0484064,2.2730285,718.3123797,545.6672021,1189.4764576,23.1743441,27.5004561,2.4132753,83.4071017),(9359,'Capra_hircus-femur-cleaned.tif',152,7,145,151.2586301,73.7762452,65.7708124,1.8,73.5084232,65.1504093,0.3465984,12.5507603,14.555564,7033.1971499,10682.2116067,2.9091167,733.8919729,560.3801665,1214.1416139,23.511824,28.264618,2.3978371,85.0711664),(9360,'Capra_hircus-femur-cleaned.tif',152,7,146,149.9207857,73.8972322,65.928223,1.8,73.707999,65.1079567,0.3854808,12.9526826,14.5936009,7195.7746823,10918.5328797,3.5326226,748.172638,555.5431962,1222.7232761,23.5227512,29.035161,2.329174,86.1132479),(9361,'Capra_hircus-femur-cleaned.tif',152,7,147,149.4816904,74.0570696,66.114487,1.8,73.8650561,65.1226646,0.4073743,13.4173271,14.852498,7360.6276967,11233.7483726,3.9107978,756.3541389,548.5912072,1232.235982,23.7031493,29.9017608,2.2774105,88.2647059),(9362,'Capra_hircus-femur-cleaned.tif',152,7,148,150.069404,74.1481024,66.1483145,1.8,73.9252159,65.0215258,0.4353787,13.8295601,15.3153825,7696.1441516,11614.3033887,4.4489641,758.3423668,556.4995633,1237.602333,24.1169016,31.2119972,2.3121977,91.2006115),(9363,'Capra_hircus-femur-cleaned.tif',152,7,149,152.2865112,74.2095011,66.3481978,1.8,73.959449,65.0816077,0.4633248,14.374464,15.8295812,8112.7542958,12087.6814926,5.0696644,763.6134747,564.3865619,1245.4418706,24.7479337,32.2483358,2.2831539,93.8115883),(9364,'Capra_hircus-femur-cleaned.tif',152,7,150,151.6931801,74.2900714,66.6256244,1.8,74.0085626,65.2709782,0.4645823,15.2017598,16.1329248,8497.5564626,12314.6724058,5.0753573,763.3254701,558.9850517,1229.5375879,25.4036149,33.1574145,2.3266173,96.5850295),(9365,'Capra_hircus-femur-cleaned.tif',152,7,151,151.5146097,74.4937352,66.9884043,1.8,74.0969087,65.655485,0.4356026,16.187299,16.3384524,8957.950225,12630.5992986,4.496134,773.0597127,553.3937581,1255.2022033,26.3768584,33.7403684,2.3329429,100.2775083),(9366,'Capra_hircus-femur-cleaned.tif',152,7,152,152.8048338,74.5409183,67.4035703,1.8,74.2327021,66.0892174,0.462571,17.0347159,16.6730803,9708.3614706,13210.9415247,5.0715783,792.3515794,569.9162523,1277.3163651,27.7522514,34.9277455,2.3224994,105.9589806),(9367,'Capra_hircus-femur-cleaned.tif',152,7,153,157.1015484,74.3690378,67.7871744,1.8,74.074766,66.3893503,0.5007612,17.7134819,17.4866126,10822.8289301,14016.6396806,6.0350488,801.5640324,610.9938725,1314.5428684,29.0734646,35.9018722,2.3835101,111.505863),(9368,'Capra_hircus-femur-cleaned.tif',152,7,154,160.7771941,74.3287839,68.3137269,1.8,74.0573215,67.0173922,0.5346129,18.9967716,18.0610369,12008.2694641,14952.4733869,6.9562507,827.8856541,632.1215884,1326.1540647,30.7605853,37.0781186,2.3297456,120.1742074),(9369,'Capra_hircus-femur-cleaned.tif',152,7,155,170.356245,74.0232369,69.1098847,1.8,73.8341633,67.9309151,0.3817365,21.0652169,18.7012338,13794.0119388,16654.963559,3.9403529,890.5810015,654.8241102,1417.011459,32.8593317,38.3026186,2.299844,125.6653408),(9370,'Capra_hircus-femur-cleaned.tif',152,7,156,192.1865625,74.221899,70.9221328,1.8,73.8928856,70.1112444,0.8129055,19.4110709,22.6290366,17605.5222344,21610.6032424,16.8961918,954.9943994,906.983562,1676.8165155,34.7017912,41.1853683,1.125219,131.5765725),(9371,'Capra_hircus-femur-cleaned.tif',152,7,157,228.9529494,74.2040948,73.5582294,1.8,73.2788397,72.7156462,1.0967331,21.737496,24.0051878,23871.9908031,30053.9172541,30.2066415,1251.9759292,1098.1941451,2071.570792,36.6598186,47.7064134,1.1643778,146.9011758),(9372,'Capra_hircus-femur-cleaned.tif',152,7,158,271.5544926,74.4101708,75.5128645,1.8,73.2634286,74.0028159,1.2083375,22.422491,26.380066,29555.0984185,38739.0881656,39.5689748,1468.498529,1318.1005834,2441.9768189,37.9887302,49.199471,1.1651643,171.3190043),(9373,'Capra_hircus-femur-cleaned.tif',152,7,159,294.8941623,74.6810791,76.1187402,1.8,73.3461613,74.5557784,1.2881105,23.3301378,27.0690254,32911.0709231,44618.4922736,45.3249767,1648.3228201,1410.6676601,2710.7193295,38.9759975,50.1586636,2.1434627,175.8516797),(9374,'Capra_hircus-femur-cleaned.tif',152,7,160,318.3866226,74.7133261,76.2188483,1.8,73.4776297,74.9091013,1.3355992,23.814929,27.3032743,35879.1879155,49753.8497499,50.1827637,1822.2667785,1506.5838708,2987.1508508,40.0994764,51.0772701,2.151269,178.1656021),(9375,'Capra_hircus-femur-cleaned.tif',152,7,161,346.5267847,74.6538818,75.8584477,1.8,73.5280383,74.689114,1.3782034,24.139791,27.3445673,38692.1357948,56344.6888961,55.6385896,2060.5441787,1602.8364046,3344.5802204,40.9729135,51.8633503,2.0607537,180.4237755),(9376,'Capra_hircus-femur-cleaned.tif',152,7,162,361.6560858,74.7555103,75.8569575,1.8,73.6441297,74.9387143,1.3806732,24.6017376,27.2030898,40436.9161326,60464.3191671,58.1233559,2222.7004215,1643.6609772,3548.1201106,41.4601253,52.711437,2.1310688,180.0594262),(9377,'Capra_hircus-femur-cleaned.tif',152,7,163,365.5773386,74.7316031,76.2802646,1.8,73.6846581,75.3970802,1.3730696,24.6543425,27.9388761,42750.0934066,62031.5690854,58.5783442,2220.2599993,1733.9782406,3635.3547045,41.7313885,53.9054524,2.0873898,184.9679969),(9378,'Capra_hircus-femur-cleaned.tif',152,7,164,367.2317195,74.5102816,76.4373778,1.8,73.6547234,75.5894233,1.4023197,24.3443858,27.7068055,44571.3234771,62493.5510935,59.4843872,2255.5307225,1830.8666287,3680.5315353,42.5102095,54.0109426,2.0803886,184.0210848),(9379,'Capra_hircus-femur-cleaned.tif',152,7,165,371.9186969,74.4549333,76.4391224,1.8,73.7488951,75.7486708,1.4138584,24.2224402,27.4543238,45802.7820778,62873.7048641,60.4722464,2290.1203257,1890.9235288,3764.1423978,42.8764807,54.0109426,2.0803886,183.4942711),(9380,'Capra_hircus-femur-cleaned.tif',152,7,166,373.6010719,74.2997365,76.4826857,1.8,73.8111809,75.9441814,1.4451549,23.8952871,27.289052,46353.3851883,61645.5612594,61.2890761,2258.9850749,1939.8547077,3796.7360227,43.1489023,53.9860142,2.068913,182.8444134),(9381,'Capra_hircus-femur-cleaned.tif',152,7,167,365.2301275,74.1932002,76.1751362,1.8,73.7335655,75.8656303,1.5274118,22.9869662,26.5723141,44942.3900313,58392.2237468,60.757186,2197.4835746,1955.1248982,3732.7338903,42.9138875,53.3287381,2.1299469,181.6677419),(9382,'Capra_hircus-femur-cleaned.tif',152,7,168,356.1929181,74.3376368,75.9376049,1.8,73.8037586,75.922464,1.5281481,22.8936939,25.8284381,42322.7149976,55678.3368298,59.2575741,2155.698945,1848.6625662,3621.7301851,42.4822408,52.8003769,2.1238278,183.3039322),(9383,'Capra_hircus-femur-cleaned.tif',152,7,169,347.124358,74.3949991,75.6893947,1.8,73.8737743,75.9066383,1.5554202,22.4013177,24.7926466,39764.4506086,52314.3897793,57.8403829,2110.0768543,1775.0942632,3474.6047047,41.7861553,51.8596424,2.1350645,182.7492439),(9384,'Capra_hircus-femur-cleaned.tif',152,7,170,337.4205573,74.4677372,75.6093163,1.8,74.0523982,75.9090449,-1.5317438,21.6930873,23.9714634,37720.438492,48150.1313828,56.1510364,2008.6438035,1738.8229701,3266.0218938,40.8791126,50.4651994,2.1725176,179.6508739),(9385,'Capra_hircus-femur-cleaned.tif',152,7,171,317.6910116,74.6388445,75.3827011,1.8,74.3382456,75.8303891,-1.5021512,21.5784394,22.8114739,34301.127816,42285.4376695,52.6993922,1853.6916044,1589.6018805,2985.7652654,40.2423026,48.8511573,2.1745457,176.3227444),(9386,'Capra_hircus-femur-cleaned.tif',152,7,172,299.8330403,74.7598551,75.0944461,1.8,74.6831167,75.7185091,-1.4775217,21.5525166,21.5524256,30879.0849568,36641.8580408,49.5386666,1700.1268812,1432.7368598,2695.8639403,39.3235074,46.8785405,2.1965478,171.5603097),(9387,'Capra_hircus-femur-cleaned.tif',152,7,173,286.7155872,74.6591493,74.8182734,1.8,74.8606241,75.6525598,-1.2769407,23.0409312,22.1449281,27544.8245523,30406.2280605,43.7769745,1373.0560742,1195.4735815,2390.7837602,38.0863072,44.8620724,2.1313616,166.3383561),(9388,'Capra_hircus-femur-cleaned.tif',152,7,174,271.1807558,74.4952986,74.5856948,1.8,74.9615864,75.6229075,-0.5074485,21.5696606,22.1663301,23040.0888005,25161.2299324,10.673056,1135.1103155,1068.1711331,2072.5629988,36.9370321,42.6938821,0.9936041,160.0349006),(9389,'Capra_hircus-femur-cleaned.tif',152,7,175,226.6370119,74.8737576,74.2642499,1.8,75.1009619,75.5390592,-0.3665674,19.0922599,20.8178757,16386.1829378,19254.8231236,4.8522946,924.9177664,858.2631415,1576.9870088,34.7671915,40.3304507,0.9121657,160.2925345),(9390,'Capra_hircus-femur-cleaned.tif',152,7,176,171.3354568,75.1750785,73.8284195,1.8,75.3098109,75.431319,-0.2348463,16.9803647,18.9489769,10073.1852277,13004.4909739,1.5461962,686.2898743,593.2254945,1061.5018508,13.7162125,33.2593307,1.2833331,89.9008962),(9391,'Capra_hircus-femur-cleaned.tif',152,7,177,83.7322175,75.5299576,71.8294318,1.8,75.8357187,74.5395232,0.2521624,18.5255979,15.7700024,2986.7234815,4902.8950291,0.8687154,310.9000814,161.2214352,377.769045,10.3602631,29.0682571,1.3003602,77.6025854),(9392,'Capra_hircus-femur-cleaned.tif',152,7,178,24.4629779,71.0526654,69.004495,1.8,72.9678254,69.3979829,0.377463,6.7730673,14.195485,194.2563568,394.5158201,0.5538371,27.7916407,28.6807067,40.4710599,5.2640597,14.6363087,1.7421755,33.6014407),(9393,'Capra_hircus-femur-cleaned.tif',152,7,179,5.3135471,69.4820145,69.0479733,1.8,69.6883318,69.3114008,1.4341076,1.6260504,4.7179446,1.7957743,22.7307537,0.8691478,4.8179357,1.104378,5.192836,3.14738,9.5754036,1.7454685,21.9414417),(9394,'Capra_hircus-femur-cleaned.tif',152,7,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9395,'Capra_hircus-femur-cleaned.tif',152,7,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9396,'Capra_hircus-femur-cleaned.tif',152,7,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9397,'Capra_hircus-femur-cleaned.tif',152,7,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9398,'Capra_hircus-femur-cleaned.tif',152,7,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9399,'Capra_hircus-femur-cleaned.tif',152,7,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9400,'Capra_hircus-femur-cleaned.tif',152,7,186,24.4927902,65.4432017,95.9220302,1.8,65.5818909,95.900656,0.0152925,1.6622007,36.0611259,8.5836256,10652.5167325,0.0009546,295.4016676,5.1640128,295.4799211,8.3203236,137.2923426,3.131492,287.6275431),(9401,'Capra_hircus-femur-cleaned.tif',152,7,187,24.3462464,65.4078445,95.9038509,1.8,65.4255901,95.8851606,0.0154162,1.6403779,36.0966955,8.6544911,10578.5019936,0.0009643,293.0601224,5.2759132,293.1477109,8.3203236,137.2923426,3.131492,287.8573025),(9402,'Capra_hircus-femur-cleaned.tif',152,7,188,24.1588652,65.4525804,95.8837993,1.8,65.5877026,95.867035,0.0152565,1.8769743,36.0481189,8.679944,10529.3757899,0.0009371,292.0922399,4.624434,292.1545825,8.3203236,137.2923426,3.131492,287.694838),(9403,'Capra_hircus-femur-cleaned.tif',152,7,189,23.9670319,65.4303747,95.8706355,1.8,65.524187,95.8568635,0.015402,1.8547109,36.0704151,8.6943267,10425.8881735,0.0009475,289.0426444,4.6876991,289.1110016,8.3203236,137.2923426,3.131492,287.8573025),(9404,'Capra_hircus-femur-cleaned.tif',152,7,190,23.7510506,65.4282656,95.8654014,1.8,65.6407283,95.8523734,0.0156045,1.846593,36.0724546,8.7816095,10329.3237453,0.0009638,286.3493448,4.7555738,286.4223474,8.3203236,137.5629628,3.1395765,288.6417501),(9405,'Capra_hircus-femur-cleaned.tif',152,7,191,23.114458,65.1881132,95.8652086,1.8,65.6915817,95.8695504,0.0157421,1.8409277,36.3168432,8.7891168,9995.8356567,0.0009546,275.2396621,4.7742867,275.3517969,8.3203236,137.5629628,3.1395765,288.7090451),(9406,'Capra_hircus-femur-cleaned.tif',152,7,192,21.2510884,65.1421367,95.821298,1.8,65.6888896,95.8469159,0.0153457,1.8160758,36.3721857,8.0939929,9339.5223613,0.000834,256.7764949,4.4568585,256.8931012,8.3203236,137.5629628,3.1395765,290.0876014),(9407,'humerus',249,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9408,'humerus',249,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9409,'humerus',249,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9410,'humerus',249,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9411,'humerus',249,2,5,11.354071,105.2589502,152.8440632,1.8,105.334944,153.0767648,-0.7930658,3.4517612,4.9445972,22.3702432,45.1863108,0.9606819,9.138522,6.48082,13.5395564,6.9136358,9.798394,0.6610432,26.7196181),(9412,'humerus',249,2,6,54.9596209,105.3135895,152.5692669,1.8,105.2353103,152.2089018,-0.6409095,7.958467,8.4101745,421.230301,705.9117855,3.2748053,83.9354505,52.9285729,124.3310586,14.0318358,17.18752,0.6435011,54.0900927),(9413,'humerus',249,2,7,152.0666483,105.179198,151.4858108,1.8,105.353502,151.4486319,-0.4246005,11.2407648,16.048377,3057.8241663,5603.0347382,4.3011639,349.1340417,272.0299042,534.3006607,20.2448179,30.7099189,0.3129012,86.8432309),(9414,'humerus',249,2,8,251.7429667,106.052267,151.4285983,1.8,105.7471232,151.3684026,-0.3379557,13.4427928,18.0601656,7795.4981815,16297.821584,4.6124104,902.4181701,579.9016822,1327.134696,25.2726576,36.2265465,0.3893167,102.5205185),(9415,'humerus',249,2,9,322.3525924,107.330302,151.3811626,1.8,106.4796583,151.3812288,-0.3597298,14.9781924,20.4897013,13567.8828436,27354.0510223,6.6576038,1335.0146281,905.8424711,1985.2237391,27.875714,40.8542687,0.3883187,111.5134295),(9416,'humerus',249,2,10,363.3659122,108.8628509,151.5213436,1.8,107.475896,151.2921435,-0.440822,17.7176654,24.1100116,17874.0719222,38544.7814542,11.0256365,1598.7043917,1008.827715,2306.4878073,30.4030838,48.0521072,0.5557557,129.0137289),(9417,'humerus',249,2,11,421.5673314,110.9003683,150.7465972,1.8,108.8439489,150.6535546,-0.5467787,19.8739471,26.0054313,22940.4094386,59565.5539862,18.9941236,2290.5043694,1154.2955873,3169.5204517,33.0160223,52.0259729,0.5375866,138.8839041),(9418,'humerus',249,2,12,454.2990767,111.7279294,150.4786196,1.8,109.742457,150.199448,-0.6273207,21.3319183,27.22085,28069.8094447,74360.0589735,26.0875778,2731.731708,1315.8595962,3758.8421058,35.566409,54.6920417,0.6796489,147.5819239),(9419,'humerus',249,2,13,485.7807529,112.5296166,150.1038995,1.8,110.720571,149.6089896,-0.6979109,22.199841,32.5416113,33212.9772964,92726.9332968,33.4345469,2849.4880762,1496.0907753,3857.5268759,37.3350567,61.9481355,0.692074,161.748979),(9420,'humerus',249,2,14,509.9807757,113.3568053,149.7142418,1.8,111.7018323,149.0902275,-0.7576954,22.2403051,34.1840201,36750.0732275,115722.2477428,40.1449581,3385.2732188,1652.4086789,4449.3535413,37.642328,64.8771965,0.7150917,166.6535296),(9421,'humerus',249,2,15,518.5163587,113.9592718,149.612958,1.8,112.6240976,148.7179924,-0.8042077,22.6026246,37.4000757,38740.562917,132048.0444159,44.834826,3530.6892297,1713.9851499,4562.6327766,38.074942,68.7097849,0.7500147,173.9887626),(9422,'humerus',249,2,16,528.59261,114.5401296,149.3201934,1.8,113.5143673,148.2600493,-0.8368846,22.7495957,39.6019927,40951.6393696,147258.2972861,48.577267,3718.4567537,1800.1040507,4749.8654064,38.3569423,71.1623523,0.7426891,180.0654686),(9423,'humerus',249,2,17,538.2892471,115.4027263,148.7448814,1.8,114.7834205,147.719502,-0.8676755,22.3649263,40.8720031,42481.9392508,164814.3251796,52.2056712,4032.450398,1899.4893445,5067.282533,38.2450759,73.1732297,0.8685394,184.4234226),(9424,'humerus',249,2,18,534.7009006,116.0468939,148.4768504,1.8,115.5812278,147.4708313,-0.8880061,22.3287914,40.8266502,42621.254109,171737.9554626,53.6384582,4206.5159514,1908.8025539,5236.0423636,38.2439851,73.6886733,0.8514178,188.1737059),(9425,'humerus',249,2,19,526.8580224,116.608014,148.299146,1.8,116.416556,147.2534776,-0.9051604,22.4130909,41.0925899,42617.5678992,174797.0055306,54.3208485,4253.7354326,1901.4587567,5288.0698094,38.2015401,74.2216838,0.8879181,190.5001285),(9426,'humerus',249,2,20,514.182939,117.0658934,148.1774606,1.8,117.0461639,147.2405068,-0.9210378,21.8700048,40.8989939,42330.5900722,172852.1287466,54.3304571,4226.3173808,1935.5546747,5251.8612227,37.8036933,74.176894,0.9458331,191.3163187),(9427,'humerus',249,2,21,497.3536406,117.6669684,147.9944449,1.8,117.7571393,147.201225,-0.9396454,21.0952214,40.8436693,41208.0958011,168447.7755226,54.030199,4124.2077071,1953.4327235,5132.7517725,37.4576731,74.2502853,0.9249804,189.8924579),(9428,'humerus',249,2,22,484.5354955,118.2193646,147.8769881,1.8,118.4808442,147.1805991,-0.9610114,20.7098423,40.5047263,40209.2287879,163515.5647829,54.2699811,4036.9502423,1941.5516615,5022.5445153,36.9381938,73.5770912,0.9471524,188.3211516),(9429,'humerus',249,2,23,479.0306711,118.6837894,147.8368802,1.8,119.3161693,146.985386,-0.9830775,20.3475494,61.4625299,39974.6978555,164704.4784152,55.2936777,2679.7542956,1964.5951967,3317.313899,36.4413954,73.4816734,0.9389906,190.5433144),(9430,'humerus',249,2,24,491.0546198,118.65786,147.062177,1.8,118.8584744,146.3459243,-0.8686102,55.7085178,62.6428479,63717.1997861,197184.0650375,47.7001015,3147.7506463,1143.7604573,3720.6976303,5.5602274,10.2135672,1.1824776,25.2957573),(9431,'humerus',249,2,25,511.3937683,118.1978321,146.0520523,1.8,118.4357021,145.330921,-0.704908,49.8716765,62.5983778,95552.4971272,253604.5454745,35.7853789,4051.295805,1915.9672167,4891.4193431,8.59376,13.9962251,1.2587542,37.9957659),(9432,'humerus',249,2,26,542.6853857,117.7458937,144.4685653,1.8,117.7746398,143.8764201,-0.5762429,44.6429289,62.32566,129780.8096246,340190.1118142,26.8531002,5458.2672972,2907.085465,6504.9341408,11.171888,18.4565877,1.359703,49.5846931),(9433,'humerus',249,2,27,573.9242432,118.7957592,142.7267942,1.8,118.2275843,142.4132868,-0.5833034,44.9651952,64.5189366,146634.5788776,410778.7563786,29.0179069,6366.7936533,3261.0684394,7563.2500732,12.460952,21.2597881,1.3258177,55.6003251),(9434,'humerus',249,2,28,614.0814869,119.631999,141.0375462,1.8,118.2795202,140.6752924,-0.5741491,56.111235,66.8821134,168594.2526904,488916.6215951,30.190279,7310.1251843,3004.643416,8761.7325531,13.320328,23.4485273,1.3302621,62.3278875),(9435,'humerus',249,2,29,677.8713184,118.3799422,138.9585775,1.8,115.3024915,138.5450099,-0.433859,53.3551508,70.2345216,238178.7800877,625258.913665,19.9650603,8902.444265,4464.0259958,10691.2781099,15.6855745,43.44951,1.7196863,126.1407097),(9436,'humerus',249,2,30,757.4323403,115.2371778,136.892616,1.8,112.5016596,136.8799088,-0.2386552,42.2096697,70.1157144,318904.197764,838864.8277684,7.0546152,11964.0059985,7555.2402967,14665.3318306,17.8997505,47.8518892,1.6517004,119.7080385),(9437,'humerus',249,2,31,828.5518855,113.5057815,135.5343964,1.8,110.8011545,135.6278852,-0.170107,39.881168,71.9511329,367880.8915735,1004489.7127079,3.9574889,13960.7212798,9224.4262254,17532.0711856,21.8082794,51.2212608,1.6295521,133.389571),(9438,'humerus',249,2,32,926.0936927,111.2962429,134.7745303,1.8,107.6992969,135.0844534,-0.1336621,41.1991518,72.0067866,411549.9910333,1182279.0472401,2.741146,16418.9946959,9989.2831148,20699.4128036,31.9768679,54.6126518,1.6101461,160.5083402),(9439,'humerus',249,2,33,1073.6352399,108.7440797,134.0702182,1.8,105.6045093,134.4745532,-0.1071298,42.2245205,71.3415437,475610.0605562,1427932.5811588,2.0458046,20015.4427079,11263.8356906,25214.4947236,36.0146143,58.4944108,1.6148854,176.2467017),(9440,'humerus',249,2,34,1161.949095,107.5025171,133.6619533,1.8,104.4061143,134.0576826,-0.0855406,42.7516355,71.2547519,521133.4007883,1569243.9987038,1.4135816,22023.0083756,12189.7886304,27865.6935986,38.3074966,61.1607702,1.8703283,186.5160279),(9441,'humerus',249,2,35,1272.281856,106.5797423,133.3037585,1.8,103.4907431,133.7331563,-0.0681667,42.8949929,71.1814021,573929.5388683,1718391.6781097,0.9837939,24141.0203629,13379.8725733,30746.2203908,40.4121027,64.3342098,1.8481786,194.7106369),(9442,'humerus',249,2,36,1511.4398172,104.4925851,130.5091938,1.8,101.5256457,130.3659527,-0.004853,45.2802462,70.9203457,777696.022146,1871328.6495762,0.0059317,26386.3441589,17175.1721081,36458.8687766,85.1776777,134.0881319,0.2131077,480.0400858),(9443,'humerus',249,2,37,1865.8581377,101.8331542,125.592922,1.8,99.9023401,127.2355539,0.1310409,48.1702128,69.5776171,1134229.0022199,2084808.3041215,5.3095007,29963.7784588,23546.2734354,44518.6336546,93.8056821,134.5993802,0.2155526,603.7501131),(9444,'humerus',249,2,38,2182.6888413,100.2203768,122.1290539,1.8,98.9773748,124.849502,0.2637649,51.6503975,67.1573228,1438319.677017,2377978.2488431,24.7274636,35409.0685911,27847.2140701,52914.425458,96.2215383,135.1708574,0.2048767,599.6870503),(9445,'humerus',249,2,39,2444.3364076,99.9306512,119.8492373,1.8,98.6096929,122.9163095,0.3414291,55.3035653,65.511179,1690879.6284524,2619174.6026844,45.6739921,39980.5749898,30574.5139597,60299.2707756,97.600958,135.5050931,0.2011269,612.1174653),(9446,'humerus',249,2,40,2703.1135093,100.3466253,118.0270465,1.8,98.4661401,121.2454178,0.3746394,58.7095147,64.9173941,1936554.7591376,2830918.1592676,60.3289178,43608.0067675,32985.3648031,67663.6635833,98.9940064,136.0123728,0.2035913,459.3613973),(9447,'humerus',249,2,41,2906.055164,100.4803685,116.67846,1.8,98.1494977,120.0269694,0.4221124,61.5371522,63.6304572,2137316.9236394,3002821.735218,81.2942489,47191.5787912,34732.1389947,73497.8407854,101.5747624,136.1378803,0.2227771,459.7173625),(9448,'humerus',249,2,42,3031.2672881,100.2988201,115.5819317,1.8,97.9490509,119.0126331,0.4764949,63.9145328,61.6577822,2299414.2778035,3157347.5767533,106.2841932,51207.6085765,35976.3918467,78114.7461538,104.272498,136.6988741,0.212191,459.1528777),(9449,'humerus',249,2,43,3155.44139,100.1735528,114.730654,1.8,97.7787781,118.1452122,0.5100404,65.5061763,62.5462994,2454653.7853575,3275921.1158585,125.3506885,52375.9382454,37472.0968817,82099.4119572,106.4821114,137.0711455,0.2244492,458.128168),(9450,'humerus',249,2,44,3179.6945643,100.5023613,113.9236065,1.8,97.9192527,117.328389,0.5861321,67.6030903,64.9140835,2573932.2295108,3345397.3612792,162.14697,51535.7712964,38074.1799894,85283.2515165,108.5340008,137.3019578,0.2176506,456.5568616),(9451,'humerus',249,2,45,3216.6076039,100.7297921,113.2212799,1.8,97.8784357,116.4392728,0.6602465,68.9077079,67.092063,2696421.3104064,3443991.8797306,201.6550511,51332.3294027,39130.9099389,87782.691869,110.3627669,137.3953836,0.2207042,456.7221953),(9452,'humerus',249,2,46,3173.6218573,100.8488196,112.3678857,1.8,97.7448836,115.5415172,0.7235037,69.7999822,68.984783,2787186.127166,3523246.9422953,231.8137899,51072.8133308,39931.0435017,88966.600003,112.137328,137.2098141,0.2145929,460.0554396),(9453,'humerus',249,2,47,3144.2610966,101.0164305,111.5531898,1.8,97.5800493,114.7287685,0.7791373,70.3779584,70.504263,2854301.9557968,3575189.0587833,258.7408608,50708.8352562,40556.7598458,89610.6374373,113.5781923,137.1189549,0.2115311,460.2892568),(9454,'humerus',249,2,48,3112.5405181,101.1130021,110.8467225,1.8,97.4504677,114.0715506,0.8413956,70.6540413,71.6869349,2894494.2603313,3606171.7858197,288.3667468,50304.4493193,40967.1436443,89796.9983639,114.9758658,136.9411005,0.2053954,467.0778932),(9455,'humerus',249,2,49,3099.218608,101.0338492,109.8100899,1.8,97.1675635,113.1845106,0.9048255,70.2224681,73.0460886,2940444.1278876,3686065.7350581,319.3718797,50462.1918172,41873.2666093,90402.2256742,116.5626906,137.2992684,2.2430935,468.4838658),(9456,'humerus',249,2,50,3075.8893758,100.9527685,109.1258843,1.8,96.9029476,112.6160258,0.9466169,69.7476218,73.8397167,2936865.4048588,3733555.0103891,337.5479592,50562.9649856,42107.0328666,90242.1964557,117.5901752,138.423574,2.2726887,466.3480746),(9457,'humerus',249,2,51,3060.1122548,100.5847911,108.2495975,1.8,96.3988561,111.9835272,0.9777855,68.9286284,74.7329602,2937145.273151,3785107.4275287,350.7271806,50648.4343701,42611.3987716,89943.9637382,118.53183,139.3574307,2.2710616,467.3117104),(9458,'humerus',249,2,52,3058.5541304,100.3189694,107.4106391,1.8,96.0984188,111.3409934,1.0054872,67.8149433,75.4330245,2932480.5934987,3848878.8747785,363.4837955,51023.7909731,43242.3954005,89874.1622311,119.4931202,139.9833554,2.2474548,459.264547),(9459,'humerus',249,2,53,3062.230261,99.9952046,106.6427329,1.8,95.8628725,110.7040864,1.0204805,67.3646403,76.0802194,2916799.0053284,3906370.4693974,370.7934928,51345.4154361,43298.6651821,89595.8991831,120.2652541,140.7338078,2.2588889,458.1534656),(9460,'humerus',249,2,54,3075.0053253,99.8074758,105.8479235,1.8,95.7443766,110.0396327,1.022824,67.358007,76.562491,2898750.0721172,3973704.0399292,373.4098391,51901.4466183,43034.9738824,89609.5226181,121.1459808,141.2811269,2.2635876,457.0423842),(9461,'humerus',249,2,55,3059.398625,99.5474785,105.082279,1.8,95.6504509,109.3213083,1.0210122,67.1990804,77.2172908,2836520.0043352,4014477.6233653,370.6922642,51989.3612276,42210.6967381,88556.0881265,121.9375748,142.0091212,2.2790944,456.1398224),(9462,'humerus',249,2,56,3031.0954687,99.0779727,104.2087613,1.8,95.613509,108.6496445,1.0216674,66.876863,78.0620677,2772650.93968,3997052.6894984,367.5577171,51203.5205498,41459.0460138,86520.0211396,122.6532022,142.4368732,2.2686246,456.3915278),(9463,'humerus',249,2,57,3009.1402886,98.7296947,103.6703254,1.8,95.5715152,108.0992927,1.0263792,66.4034679,78.5319999,2715837.2497335,4021548.5755283,366.9944199,51209.0432309,40899.0273229,85515.5747233,122.5539172,142.9905859,2.2732297,456.2008964),(9464,'humerus',249,2,58,2998.1020498,98.4035474,103.0351981,1.8,95.6144475,107.6282786,1.020494,65.1642273,79.0550193,2656585.6609958,4065339.0550805,363.0344577,51424.1738546,40767.5464148,84828.4107919,121.6138569,143.2685728,2.2755189,453.6227684),(9465,'humerus',249,2,59,2964.9525891,98.0419807,102.4273498,1.8,95.6095321,107.1638045,1.0237519,63.7845576,79.6006457,2569028.1298942,4093115.4260168,360.4533104,51420.6309497,40276.6473105,83435.9249911,120.6387876,143.6475968,2.2693645,449.074183),(9466,'humerus',249,2,60,2924.431397,97.7306208,101.8528932,1.8,95.5209766,106.7619274,1.0270876,62.5670847,79.8642418,2486723.1818789,4110604.7771715,356.9691659,51469.902997,39744.9104806,82315.0466822,118.5230707,143.7015697,2.2651518,450.2284502),(9467,'humerus',249,2,61,2897.8260138,97.194166,101.6723849,1.8,95.3309378,106.455271,1.025472,61.1336626,79.9940396,2414137.0298071,4136701.1666275,353.0300881,51712.6174276,39489.4879049,81707.7495954,116.2453612,143.8742753,2.2758593,446.3307212),(9468,'humerus',249,2,62,2881.8412659,96.6984698,101.1080765,1.8,95.1966267,106.0983859,1.0282129,59.836347,80.1453581,2352916.421581,4133258.7758278,352.2486767,51572.0295646,39322.527877,80494.1783834,113.8672319,143.9243147,2.2716507,444.2738922),(9469,'humerus',249,2,63,2868.1375597,96.2142039,100.7445412,1.8,95.0447443,105.805185,1.03335,58.9668273,80.449066,2290762.3320047,4146550.6042355,352.7394816,51542.5574552,38848.3226211,79568.593949,110.8435495,144.0320329,2.2632428,437.44207),(9470,'humerus',249,2,64,2845.3057704,95.7370573,100.4289627,1.8,94.7652953,105.5177469,1.0391749,57.892486,80.9480039,2225495.6192734,4155826.7710647,352.3533133,51339.4595517,38441.8734515,78433.1942555,109.140925,144.201782,2.2739281,433.6917866),(9471,'humerus',249,2,65,2827.4461707,95.4189935,99.8849154,1.8,94.680002,104.9482808,1.0440632,56.4866079,81.400613,2161059.96086,4159612.0580251,352.149327,51100.5004092,38257.917071,77463.9196824,103.0718881,143.9615122,2.2292217,425.2275841),(9472,'humerus',249,2,66,2789.2515068,95.2527152,99.4696379,1.8,94.822506,104.6303871,1.048758,55.8334912,81.1748366,2111168.0135384,4135434.4090972,349.2840894,50944.7826736,37811.8575007,76744.2653814,102.2206863,143.7015697,2.2651518,423.0054213),(9473,'humerus',249,2,67,2752.4614991,95.1253867,99.0746046,1.8,95.0146694,104.2092267,1.0577476,54.0574598,81.1157799,2057633.2178119,4103419.3694256,348.2232145,50587.189999,38063.8162567,75841.395959,101.3601197,142.9576561,2.1896482,418.4568359),(9474,'humerus',249,2,68,2718.1389552,95.1032647,98.717767,1.8,95.1225165,103.7655752,1.0632901,53.5086209,81.0371297,2007392.6910014,4071120.7199832,346.0212002,50237.7211025,37515.3135335,74870.9955676,100.3013646,142.7088231,2.1871956,415.6701883),(9475,'humerus',249,2,69,2694.7260793,95.1170443,98.4595235,1.8,95.346472,103.353692,1.06988,52.7911918,81.0164821,1957334.7498105,4022592.8141226,345.5445802,49651.5364471,37076.9191731,73674.2309237,99.0876674,142.4608516,2.1847345,414.4980329),(9476,'humerus',249,2,70,2676.7978302,95.1937291,98.2455376,1.8,95.4801031,102.8599099,1.0789569,51.7614018,80.9177632,1905925.2322075,3974750.3203795,346.6371883,49120.8625237,36821.3604382,72529.0457952,97.4688051,142.2585291,2.1931526,410.3485985),(9477,'humerus',249,2,71,2654.1049063,95.2674218,97.9661436,1.8,95.6329856,102.3630428,1.0855195,50.533155,80.8739011,1844956.6649937,3909038.5089542,346.1047429,48334.9814692,36509.8253496,71055.3354965,95.6335612,141.7592745,2.1882269,405.5483077),(9478,'humerus',249,2,72,2622.8672797,95.3637524,97.7561605,1.8,95.7486862,101.8704065,1.0921636,49.6455403,80.619719,1776285.2608247,3829763.6441528,344.4170005,47504.0559516,35779.3519916,69367.4384628,94.1571993,141.4776696,2.1748043,400.1224582),(9479,'humerus',249,2,73,2594.4815986,95.420297,97.623934,1.8,95.7731172,101.54059,1.1048421,48.7699473,80.4392034,1711950.2146505,3736037.7481196,345.1315782,46445.4841582,35102.564403,67586.5936557,92.7062851,140.9121162,2.1850197,396.328989),(9480,'humerus',249,2,74,2571.2097701,95.5385954,97.5903129,1.8,95.8708755,101.259138,1.1123268,48.0293746,80.0004108,1652613.9971983,3663926.0809806,344.5962221,45798.8408176,34408.4013072,66159.1383276,91.3495626,140.5263712,2.1757608,394.9662022),(9481,'humerus',249,2,75,2541.1161891,95.5570255,97.5790894,1.8,95.9731266,101.0618254,1.1249442,47.1880375,79.7439179,1591130.2485502,3587471.5173892,344.7631554,44987.399795,33718.9324496,64736.6396902,89.7330955,140.0295112,2.15965,392.032109),(9482,'humerus',249,2,76,2505.6770706,95.561614,97.7017463,1.8,96.0475325,100.9067447,1.1326167,46.5409581,79.246071,1532693.942426,3502335.9991725,342.4327057,44195.7053064,32932.1527444,63205.3757605,88.2187653,139.4680143,2.1365804,390.773582),(9483,'humerus',249,2,77,2493.4634547,95.5405398,97.8923992,1.8,96.147622,100.8003571,1.1351281,45.9263731,78.8625122,1497341.0241098,3450448.6223364,341.5638591,43752.7099396,32603.0758391,62405.4371629,87.1768787,138.9753417,2.1425053,388.4471594),(9484,'humerus',249,2,78,2468.8481783,95.5354783,98.0566825,1.8,96.2366411,100.7055715,1.136535,45.4251961,78.4990446,1453616.0562377,3391623.2871288,338.6344344,43205.9180194,32000.2153021,61450.5796564,85.929965,138.2821171,2.1346657,388.6556789),(9485,'humerus',249,2,79,2394.5453016,96.1290978,98.5148093,1.8,96.4631232,100.6375319,1.1538413,45.1593158,77.5042408,1368707.5232876,3268122.8961502,333.6370292,42167.0203392,30308.4202722,59496.7782943,85.0337684,137.5974767,2.1267475,392.0499971),(9486,'humerus',249,2,80,2307.0324127,96.4888093,98.9486116,1.8,97.1089795,100.8022386,1.165621,44.8036998,76.6991496,1285536.7356388,3148926.4197178,324.7618092,41055.5584471,28692.6468257,57422.7972836,84.258569,137.0058015,2.1257387,391.7982917),(9487,'humerus',249,2,81,2217.3184334,96.9474291,99.7518627,1.8,97.672594,101.0527134,1.1614912,44.4475565,75.3656811,1207280.7613203,2998882.0666551,311.0226402,39791.0829328,27161.9152131,55394.9934639,83.3142047,135.8228747,2.1236948,393.2832265),(9488,'humerus',249,2,82,2139.8062647,97.2979868,100.4110806,1.8,98.0587212,101.2163309,1.1584663,44.1935163,74.4257192,1146800.1685262,2879294.500221,299.3600783,38686.8213028,25949.5117049,53705.9014028,82.6154191,134.8563312,2.1057514,379.5585081),(9489,'humerus',249,2,83,2070.6428652,97.7667676,101.0886551,1.8,98.6385379,101.5343413,1.1510867,44.021468,73.3721846,1093520.0285844,2757985.7643396,287.8012695,37588.982515,24840.6079394,52154.4354639,81.6597959,133.7738204,2.0919345,374.445438),(9490,'humerus',249,2,84,2011.329571,98.3441009,101.9709482,1.8,99.2276738,102.0483161,1.1404753,43.8749441,72.2154454,1046619.1494321,2639689.2390032,276.8847761,36552.9731947,23854.5978943,50738.4257484,80.7811953,132.8146077,2.0923501,369.7925928),(9491,'humerus',249,2,85,1966.7441859,98.9726129,102.9194623,1.8,99.7613099,102.9637942,1.1238391,43.9105301,70.9793795,1006720.858149,2522999.353233,266.5537315,35545.5256219,22926.6386993,49511.8094511,80.1844113,131.802898,2.0854944,366.2076432),(9492,'humerus',249,2,86,1937.2650371,99.4706612,103.8889835,1.8,100.2601167,103.8766551,1.1050898,43.6860893,69.7568497,978875.6639024,2423370.1764613,257.7693703,34740.2468299,22407.0334239,48617.6066399,79.9684887,130.5530463,2.0683043,362.7701392),(9493,'humerus',249,2,87,1897.7879097,99.7787096,104.9660005,1.8,100.6686399,104.9690426,1.0874949,43.459784,68.5666258,946649.0103914,2319162.4956188,247.9931909,33823.4887435,21782.1839655,47495.444382,79.7172984,129.5635797,2.0611438,357.5706973),(9494,'humerus',249,2,88,1867.5874101,100.2114903,106.1026843,1.8,101.1406287,106.2744756,1.0659631,43.1977613,67.2497994,914377.6873422,2226641.1288243,238.4509279,33110.0040088,21167.2470883,46644.4149527,79.5193234,128.2357746,2.0029701,355.4527943),(9495,'humerus',249,2,89,1828.3851603,100.5230319,107.3826312,1.8,101.7503074,107.8196447,1.0391327,42.7649672,65.9051403,883355.9473667,2117745.4602046,226.4099864,32133.2365081,20656.0651448,45500.1697082,78.7959899,126.7055126,2.0010724,355.8698335),(9496,'humerus',249,2,90,1736.7193993,101.2541545,109.9792788,1.8,102.6699413,110.7943887,0.9708594,42.0113014,63.1516634,838067.1929035,1908616.9916268,197.1864459,30222.7508883,19948.6129709,43493.2486771,75.5083076,114.3729051,2.0596487,315.7561646),(9497,'humerus',249,2,91,1677.7037539,101.9403193,112.323776,1.8,103.466396,113.3807907,0.8920604,41.1116279,60.5213657,796687.8402373,1745723.1103537,169.4075631,28844.740879,19378.6498191,39608.1534821,74.356035,110.9136182,2.0985919,310.2439434),(9498,'humerus',249,2,92,1632.281819,102.1896135,113.5709685,1.8,103.9653857,115.0346293,0.8556747,40.2721124,59.1060973,764861.2816738,1662845.5437739,155.0791071,28133.2319297,18992.3308419,40919.6910008,73.0952986,108.4738824,2.1071398,305.4868384),(9499,'humerus',249,2,93,1594.5419647,102.4151849,114.56319,1.8,104.3510422,116.0547928,0.8326796,39.5582059,57.971793,738301.5463944,1604457.953271,145.4251441,27676.5280031,18663.6762098,40227.1763632,71.8549699,106.4906963,2.0994517,302.0493344),(9500,'humerus',249,2,94,1562.5528868,102.6027921,115.3692614,1.8,104.6809192,116.9497812,0.8094388,38.7972196,56.9077933,711628.3941169,1550438.9776248,136.4711282,27244.7565924,18342.2523926,39458.5805655,70.4720658,104.8033608,2.1280919,298.0041598),(9501,'humerus',249,2,95,1536.5849868,102.7477825,116.1456683,1.8,104.9286937,117.7109801,0.789021,38.2396295,56.1010012,687253.5190551,1510208.8926093,128.9765368,26919.4642077,17972.285005,38887.7132396,69.1810429,103.5797661,2.140389,295.4260318),(9502,'humerus',249,2,96,1509.8261354,102.8276919,116.7777801,1.8,105.1426704,118.3145375,0.7736402,37.5419372,55.2533241,663464.7333386,1476655.7555319,122.8603679,26725.1930866,17672.6291581,38313.4454555,67.9658401,102.3722079,2.1529783,291.9885278),(9503,'humerus',249,2,97,1473.9054637,102.940779,117.7102854,1.8,105.3554117,119.298976,0.7533636,36.6465041,54.4220609,633948.9781186,1428131.7984971,114.961519,26241.7809186,17299.0300947,37638.6117368,66.5864655,100.8257192,2.1682549,287.7348336),(9504,'humerus',249,2,98,1460.9158348,103.0245508,118.3969585,1.8,105.4460844,120.1072949,0.7404228,36.1290621,53.6553457,618470.0378745,1407553.1423834,110.8068856,26233.232183,17118.3529624,37443.8015441,65.7339828,100.0075166,2.1790584,285.2609654),(9505,'humerus',249,2,99,1448.6405072,103.1991854,119.1510541,1.8,105.6401111,120.9667168,0.7274932,35.4256129,52.9947241,601191.5051741,1389974.4797964,106.7706901,26228.5444943,16970.5322399,37331.1717921,64.9966689,99.0074256,2.2021453,283.4379536),(9506,'humerus',249,2,100,1431.7501125,103.1528889,119.9156258,1.8,105.7549741,121.6372199,0.7219021,34.6909583,52.5501032,582176.1674191,1366674.8254158,104.2014433,26007.081649,16781.7839766,37001.9843909,64.3674069,98.1543212,2.1976615,281.6149418),(9507,'humerus',249,2,101,1403.3113357,103.0812491,120.5343957,1.8,105.7827273,122.26556,0.7179567,34.0389867,52.2327845,557930.6854762,1333554.5870354,101.2168429,25530.987864,16390.9310972,36201.7433103,63.7571384,97.4596418,2.2028341,278.8893682),(9508,'humerus',249,2,102,1383.9534772,102.9542294,121.0148252,1.8,105.9119493,122.890768,0.7138942,33.4945011,52.0559981,538160.226006,1307406.900555,98.8925883,25115.3939579,16067.1216928,35451.5479798,63.1980055,96.7036686,2.1920789,277.4223216),(9509,'humerus',249,2,103,1371.9699237,102.8914508,121.5114244,1.8,105.9713838,123.5094537,0.7106099,32.9187765,52.0081853,522874.5330559,1287777.2617547,97.2933194,24761.0497269,15883.7778727,34721.1172415,62.6425173,96.1061356,2.3119196,275.8510152),(9510,'humerus',249,2,104,1363.3419688,102.8796122,122.1325254,1.8,106.1334915,124.1644359,0.7090732,32.3430583,51.7112352,509353.9564777,1272037.2331207,96.3362661,24598.8560713,15748.4784471,34260.2539638,62.117273,95.6381631,2.2862451,273.2728872),(9511,'humerus',249,2,105,1354.349618,102.9710407,122.6569831,1.8,106.1902151,124.7346431,0.7059174,31.9415895,51.597064,496124.9986251,1256599.736595,94.997146,24354.0937973,15532.2576713,33792.8224777,61.6069911,95.1251986,2.2730533,270.9464646),(9512,'humerus',249,2,106,1344.3052577,102.9177526,123.0883911,1.8,106.2189957,125.3069061,0.7050039,31.5248216,51.4116853,484314.7573926,1237194.7666872,94.0905493,24064.4662743,15362.9658619,33243.6022913,61.2357167,94.8452922,2.3241542,269.7311234),(9513,'humerus',249,2,107,1342.3014434,102.8912008,123.5365501,1.8,106.3825758,125.9275922,0.7033982,31.0770431,51.4796567,473352.723621,1228898.2156677,93.5958005,23871.5309021,15231.5881968,32785.1431023,60.8006326,94.5723668,2.4462726,267.6564062),(9514,'humerus',249,2,108,1344.989794,103.0728684,123.9431123,1.8,106.6313011,126.4118367,0.6989705,30.8132976,51.3848889,464673.8964067,1225937.0907947,92.8047712,23857.9301417,15080.304028,32648.9907435,60.4071362,94.4854504,2.4689824,266.441065),(9515,'humerus',249,2,109,1351.9840373,103.1710606,124.2776358,1.8,106.8076137,126.8613042,0.6941719,30.5951173,51.4004016,457694.2375663,1228484.0924727,92.2231174,23900.2819791,14959.715094,32582.5530986,60.0347086,94.4189884,2.4625873,265.4774292),(9516,'humerus',249,2,110,1355.4007323,103.3133484,124.6893943,1.8,107.0063405,127.2364835,0.6922221,30.3019363,51.3704736,451267.3450157,1222275.785577,92.023182,23793.3524969,14892.36004,32326.9504689,59.6449081,94.4189884,2.4625873,264.262088),(9517,'humerus',249,2,111,1360.9557989,103.3952032,125.0471776,1.8,107.2280769,127.6733331,0.6879319,30.0498549,51.3207999,444760.9609472,1217937.3090086,91.4448383,23731.845792,14800.769021,32214.9507899,59.3133503,94.2976724,2.4497715,263.5501577),(9518,'humerus',249,2,112,1357.6476451,103.5904992,125.433938,1.8,107.4806912,128.1329194,0.6832524,29.8176442,51.03564,436638.9587809,1209263.2348137,90.1847403,23694.4855446,14643.6437425,32042.3847777,59.0375199,93.9141097,2.4404104,262.9424871),(9519,'humerus',249,2,113,1353.2065235,103.7701461,125.865715,1.8,107.6746638,128.5267599,0.6769031,29.4980885,50.5731323,424938.8881519,1193763.1007824,88.4894108,23604.6897898,14405.6415032,31801.5579509,58.6333186,93.480597,2.4603909,260.7635101),(9520,'humerus',249,2,114,1352.4885297,103.8476838,126.1811053,1.8,107.7893442,128.9074,0.6721151,29.2715214,50.2794975,419061.0222233,1185298.6392569,87.3896081,23574.194235,14316.3389649,31566.7990348,58.3769195,93.1630572,2.5100836,259.2964635),(9521,'humerus',249,2,115,1348.9821484,104.0612587,126.5345414,1.8,107.9983622,129.272722,0.669328,29.1095025,50.1798044,411750.5937658,1173972.7051301,86.5528243,23395.3224713,14144.8859928,31290.124655,58.1559636,93.1630572,2.5100836,257.6208973),(9522,'humerus',249,2,116,1350.5799406,104.2554079,126.9273859,1.8,108.2272433,129.7006883,0.6670795,28.9059546,50.137613,406857.127634,1167710.3987968,86.163063,23290.1075496,14075.2012078,31065.6033186,57.7287067,93.2581357,2.5165226,256.7615213),(9523,'humerus',249,2,117,1345.9343254,104.4145272,127.2431073,1.8,108.4256115,130.0569408,0.6637689,28.7315857,50.2240865,400442.3330661,1155102.8282587,85.1453271,22998.9813276,13937.3558205,30739.5185756,57.7007839,93.3283919,2.4999332,256.1538507),(9524,'humerus',249,2,118,1346.0534968,104.6280566,127.6416121,1.8,108.6015615,130.4079232,0.6629243,28.5425257,50.2281048,394801.8829907,1151543.6213568,84.9689922,22926.2805188,13832.0584114,30528.7809745,57.4217239,93.4598564,2.5293601,254.9385095),(9525,'humerus',249,2,119,1353.7279684,104.6542071,127.9024668,1.8,108.6367561,130.6757172,0.6627489,28.4063451,50.3538674,392825.4334483,1144833.1932032,85.4150513,22735.7550023,13828.7918526,30319.2197988,57.3262808,93.5102186,2.5127964,254.9816953),(9526,'humerus',249,2,120,1352.9982253,104.6686579,128.1614752,1.8,108.4969074,130.8880614,0.6630739,28.2928669,50.3299645,388959.9030425,1131575.9034022,85.4401125,22483.1452661,13747.6313164,30022.6563869,57.0443629,93.4173731,2.506371,254.0180595),(9527,'humerus',249,2,121,1350.7286532,104.6278846,128.4474664,1.8,108.3607624,131.1710094,0.6654649,28.5206083,50.0263926,383819.0643441,1117971.5871353,85.8193387,22347.6355066,13457.6044175,29850.6618369,56.8172008,92.9845229,2.4971673,252.8027183),(9528,'humerus',249,2,122,1355.6695114,104.49919,128.6544903,1.8,108.1209528,131.3589572,0.668948,28.46292,49.6448066,380959.052098,1104344.9717831,86.8983685,22244.9244514,13384.3980881,29738.4589874,56.5133655,92.38292,2.4980915,251.231412),(9529,'humerus',249,2,123,1359.9930841,104.3321505,128.8363154,1.8,107.7751442,131.4251388,0.6725191,28.4056015,49.2395832,379278.640547,1087103.7530871,87.9637475,22077.8422978,13352.2481518,29635.0030154,56.5368665,91.7341111,2.4690463,250.2677762),(9530,'humerus',249,2,124,1357.1954651,104.0926437,128.9608827,1.8,107.4086505,131.4920023,0.674108,28.5008343,48.8710301,375669.1090742,1064538.146465,88.1332144,21782.6009652,13180.9864136,29322.7065607,56.3928509,91.0634485,2.4631671,248.8007296),(9531,'humerus',249,2,125,1363.0803512,103.8479552,128.9974125,1.8,107.1640957,131.556782,0.6770931,28.4580848,48.6936881,376346.3805041,1047324.5499059,89.1772325,21508.4252514,13224.5856551,29165.2265341,56.2095302,90.4592747,2.4638844,248.0456134),(9532,'humerus',249,2,126,1367.4306116,103.6381452,129.0754463,1.8,106.9257511,131.5706781,0.6810762,28.4776626,48.6669713,375932.3630238,1029794.2242424,90.3491682,21160.0228565,13200.955703,28795.3256491,56.1711076,90.1249454,2.460895,246.8302722),(9533,'humerus',249,2,127,1374.3924045,103.4270199,129.1482955,1.8,106.6002217,131.5774374,0.6838408,28.5198454,48.6289682,375827.7487692,1017622.3006885,91.4290413,20926.2572812,13177.7624799,28442.9142774,55.9056949,89.7636641,2.5296902,245.5106712),(9534,'humerus',249,2,128,1375.3242914,103.1437906,129.1211286,1.8,106.215928,131.4895806,0.6875093,28.4967631,48.456909,375021.9449004,1000540.3665331,92.3152604,20648.0435426,13160.1594248,28093.8614707,55.9787464,89.2138255,2.5135046,244.5470354),(9535,'humerus',249,2,129,1370.1925911,102.8680596,129.0111753,1.8,105.7367043,131.2463911,0.6951407,28.4648821,48.2668102,371968.0144352,962100.8305608,93.6827827,19932.9689616,13067.6112816,27376.9084063,55.8641745,88.5198996,2.5078,242.8282834),(9536,'humerus',249,2,130,1368.2191012,102.5669615,128.9779783,1.8,105.3300505,131.0829566,0.7017849,28.4766481,48.0966225,371891.3339814,940822.820438,95.040121,19561.0995318,13059.5192556,27071.9636446,55.6018596,87.922397,2.4844072,241.0052716),(9537,'humerus',249,2,131,1364.1150724,102.1397572,128.8646631,1.8,104.6916201,130.8436735,0.7092673,28.4768752,47.6098111,371233.2095548,912555.9455796,96.4345112,19167.3927,13036.304265,26645.0429126,55.6841123,86.9138915,2.5247914,238.3228838),(9538,'humerus',249,2,132,1361.9836944,101.7455449,128.704375,1.8,104.1275992,130.606228,0.717431,28.4559066,47.3027121,371194.929268,886863.5996192,98.1177555,18748.6839764,13044.5651939,26279.7168711,55.6018596,86.0374445,2.4801115,236.499872),(9539,'humerus',249,2,133,1361.1508372,101.456628,128.7407401,1.8,103.6587512,130.3996423,0.7233158,28.5537686,47.0912877,369322.5349479,868097.0591755,99.3814834,18434.3453215,12934.2834131,25994.2047509,55.6018596,85.5122304,2.4880416,234.0691896),(9540,'humerus',249,2,134,1361.6457623,101.161011,128.7039618,1.8,103.2099599,130.1991745,0.7271138,28.4860359,46.3467396,368204.7533297,850641.7948522,100.2732979,18353.8648303,12925.7982777,26046.8928209,55.528759,84.2287127,2.4827866,231.282542),(9541,'humerus',249,2,135,1362.6418228,100.9211965,128.7084316,1.8,102.8768039,130.0990177,0.7323433,28.5418431,46.0714861,367570.566421,835319.4897297,101.526965,18130.943041,12878.3052051,25971.2612238,55.552349,83.5696213,2.4435628,230.0672008),(9542,'humerus',249,2,136,1370.3369395,100.7660723,128.7678024,1.8,102.6255156,130.0484593,0.7378331,28.5383285,45.5414417,368018.7329195,824887.7842146,103.3477612,18112.9044786,12895.5952479,25984.5739808,55.5210104,82.8094731,2.4627999,228.244189),(9543,'humerus',249,2,137,1383.0236044,100.7136989,128.8707005,1.8,102.427373,129.9688534,0.74215,28.4722273,45.1158362,368717.1517031,819747.3197078,105.295532,18169.8354374,12950.0635163,26206.9389841,55.2980243,82.2176297,2.4227627,227.0288479),(9544,'humerus',249,2,138,1386.3980019,100.5327522,128.8523624,1.8,102.1588265,129.8458652,0.7477079,28.4928977,44.8967832,368575.6280316,806900.2459953,106.8324549,17972.3398394,12935.7017964,26075.5572891,55.2980243,81.654288,2.4306833,225.8135067),(9545,'humerus',249,2,139,1389.5808859,100.3104328,128.8494532,1.8,101.9325336,129.7712332,0.7582458,28.3278306,44.7029931,368809.732388,793111.9836457,109.5130911,17741.8093976,13019.3426048,25867.9368502,54.994189,81.0961399,2.4387134,223.9904949),(9546,'humerus',249,2,140,1396.8206336,100.1360284,128.8524296,1.8,101.6232905,129.6774401,0.7645166,28.3952775,44.760369,369813.5646208,781415.6539733,111.541824,17457.7572085,13023.7700309,25663.608213,55.2980243,80.8772812,2.3937708,223.1743047),(9547,'humerus',249,2,141,1409.7838545,100.0103386,128.8625033,1.8,101.3624788,129.559955,0.7738546,28.3928585,44.5062687,372154.3529518,775409.4571103,114.7698988,17422.4773388,13107.3225157,25718.872491,55.2980243,80.325227,2.4091752,222.3149287),(9548,'humerus',249,2,142,1412.4529586,99.873547,128.8275451,1.8,101.0879425,129.433164,0.7831,28.3887469,44.2920712,372082.6618482,762813.7250577,117.1634094,17222.3538781,13106.6955109,25549.7342238,55.2980243,79.9554582,2.3219873,220.9953277),(9549,'humerus',249,2,143,1415.2420174,99.6897106,128.8324109,1.8,100.9019463,129.4139135,0.7921874,28.2005158,44.1001157,372606.5822158,750673.8675197,119.5381974,17022.0385186,13212.7576965,25396.7102607,54.994189,79.3993201,2.3064272,220.2402115),(9550,'humerus',249,2,144,1422.6441851,99.5436084,128.8371542,1.8,100.6746025,129.3701067,0.8023299,28.4780844,43.8855994,373628.8257431,742193.0721859,122.5675647,16911.9958057,13119.8721327,25352.8080244,55.2980243,79.0345639,2.325435,219.5282811),(9551,'humerus',249,2,145,1417.4535145,99.2911675,128.7200164,1.8,100.3956039,129.154034,0.8175977,28.5118097,43.8037098,371751.2216838,719572.0139858,125.7227499,16427.1934433,13038.4996778,24874.3823658,55.2980243,78.4742525,2.3097164,217.6010095),(9552,'humerus',249,2,146,1422.8630017,99.125569,128.6990759,1.8,100.2002692,129.0465671,0.8314095,28.5263766,43.3692769,372824.7296168,710202.9034562,129.4678359,16375.7146611,13069.4737136,24942.544741,55.2980243,77.8980616,2.3015614,216.7416335),(9553,'humerus',249,2,147,1428.8075855,98.9844249,128.725299,1.8,100.0159802,129.0135569,0.8461267,28.5086292,43.1709003,373267.0322211,700846.790465,133.4933253,16234.2407933,13093.1245304,24868.7511596,55.4448615,77.4631058,2.2697959,216.4899281),(9554,'humerus',249,2,148,1434.3625402,98.8976358,128.7403398,1.8,99.8282166,128.9515099,0.8609521,28.5064792,42.9139541,373832.1509557,691754.043951,137.5235069,16119.5596918,13113.9362474,24814.414,55.2980243,77.0867936,2.2812364,215.2745869),(9555,'humerus',249,2,149,1434.6504539,98.775431,128.6857869,1.8,99.6825167,128.877232,0.8759094,28.5081924,42.7308734,372656.5053758,680166.1896201,141.0781983,15917.4417873,13071.9093091,24613.399007,55.2980243,76.6400074,2.2569203,214.0592457),(9556,'humerus',249,2,150,1440.1849872,98.7128259,128.7296647,1.8,99.5775327,128.8686315,0.8867361,28.4788696,42.4415074,372241.7903488,673055.4985846,144.1734531,15858.4258746,13070.8063789,24598.043601,55.2980243,76.25237,2.2684206,212.7396447),(9557,'humerus',249,2,151,1444.7491967,98.6228084,128.744176,1.8,99.4602806,128.8463106,0.8978872,28.4395507,42.1238046,372581.1030072,664575.1296934,147.2542634,15776.7119261,13100.8083236,24561.270873,55.2980243,75.7641205,2.2517374,211.8802687),(9558,'humerus',249,2,152,1446.4237509,98.487457,128.7866237,1.8,99.3002715,128.8292335,0.9106565,28.4565784,41.7569546,371495.1443724,655751.9593974,150.416553,15704.0178233,13054.807192,24579.277733,55.2980243,75.2972285,2.2348425,211.3768579),(9559,'humerus',249,2,153,1450.0621719,98.3693733,128.8152053,1.8,99.1666679,128.8381494,0.9226849,28.3530691,41.6052649,370821.5119977,648448.4010004,153.6022289,15585.7294225,13078.7080248,24484.530661,55.2980243,74.9593148,2.2383754,211.1251525),(9560,'humerus',249,2,154,1452.4669169,98.2368553,128.8562327,1.8,99.0273877,128.8726684,0.9320616,28.4426109,41.3801125,370346.5176342,639977.6383319,156.035941,15465.8264624,13020.8341123,24397.7897916,55.5872107,74.6272935,2.1843525,210.7691873),(9561,'humerus',249,2,155,1455.0542235,98.1282166,128.9174681,1.8,98.8658619,128.9241819,0.9444469,28.3886974,41.0232518,369343.6882526,632302.503491,159.1780794,15413.2711601,13010.23723,24372.2771413,55.2980243,74.2502853,2.2166122,209.6581059),(9562,'humerus',249,2,156,1453.9671899,97.9921644,128.9100309,1.8,98.7695359,128.8923719,0.9587839,28.3249739,40.6789315,367644.8566893,622036.8887816,162.3431078,15291.3772663,12979.5303107,24303.5223603,55.2980243,73.7362637,2.2073045,209.1546951),(9563,'humerus',249,2,157,1463.0474367,97.9088492,128.9129039,1.8,98.6241341,128.8328442,0.9739479,28.2489444,40.3212946,367720.7203817,616612.0826046,166.8148719,15292.4673994,13017.1490836,24400.581196,55.2980243,73.2955034,2.1685547,207.5833887),(9564,'humerus',249,2,158,1467.2785816,97.8247062,128.9401044,1.8,98.4805706,128.7917228,0.9912066,28.2471037,39.9575938,366214.5554157,611546.4324997,171.1937187,15304.8863818,12964.676303,24430.834446,55.2980243,72.8317991,2.1800723,207.3316833),(9565,'humerus',249,2,159,1471.8665693,97.6995779,128.867199,1.8,98.3012712,128.7330965,1.0102769,28.1763564,39.5785885,365774.5254299,604549.6885733,175.9797008,15274.6652137,12981.6119483,24472.7998395,55.2980243,72.3434334,2.1703305,207.1842377),(9566,'humerus',249,2,160,1474.2939177,97.6102101,128.7872593,1.8,98.2347749,128.7215117,1.027144,28.0440264,39.4254758,365447.5609123,597384.1418813,179.9711711,15152.2367319,13031.208683,24364.5788637,55.5005568,72.1018513,2.1654104,207.1842377),(9567,'humerus',249,2,161,1476.0314706,97.5494408,128.6324229,1.8,98.175055,128.5719973,1.0467541,28.0147094,39.0994389,363640.9580896,585147.6775012,184.4094313,14965.6284959,12980.3580373,24208.3215765,55.2980243,71.5349868,2.0720606,205.1095205),(9568,'humerus',249,2,162,1480.5025809,97.4269585,128.5987644,1.8,98.0205792,128.4830986,1.0617637,28.0008707,38.7247644,363467.4913176,579989.947169,188.1488774,14977.2363058,12980.5781605,24307.2331393,55.4107971,71.1260198,2.0614644,204.5018499),(9569,'humerus',249,2,163,1488.0277805,97.2942473,128.5218328,1.8,97.877412,128.416227,1.0798959,27.9926274,38.3960264,362645.7239877,575976.1862278,192.8888319,15000.9321281,12955.0441572,24387.6668613,55.4690398,70.7251307,2.0507468,203.9984391),(9570,'humerus',249,2,164,1492.7757824,97.1643144,128.4560414,1.8,97.7724802,128.3651209,1.092002,27.8749181,38.097982,361249.6970103,572091.9773062,195.9882301,15016.3328054,12959.6684424,24401.4482226,55.30186,70.2444606,2.0891837,203.3907685),(9571,'humerus',249,2,165,1485.7740979,97.0346154,128.4472135,1.8,97.632722,128.3537718,1.1042024,27.7463674,37.9237648,356804.8835474,564780.4661502,197.518246,14892.5210544,12859.5170207,24242.6695238,0.429688,0.9608116,2.0344439,2.0747172),(9572,'humerus',249,2,166,1487.6207513,96.9233917,128.4233217,1.8,97.5130902,128.3535636,1.1179844,27.807486,37.5780559,354712.9385855,559998.2390636,200.4810586,14902.2674275,12756.0232706,24247.3893637,0.859376,2.7175855,1.8925469,5.8681864),(9573,'humerus',249,2,167,1493.7655766,96.8043346,128.3776799,1.8,97.3995576,128.3758834,1.1313693,27.7005296,37.4507666,352372.8664829,557789.8678169,203.9032304,14893.9506047,12720.7988877,24241.2135638,0.429688,0.9608116,2.0344439,2.0747172),(9574,'humerus',249,2,168,1497.8529325,96.6808925,128.3532529,1.8,97.3011681,128.3870116,1.1400943,27.7325799,37.1409506,349656.9511797,555416.212047,206.1261218,14954.2810105,12608.1652711,24294.5733272,0.429688,0.9608116,2.0344439,2.0747172),(9575,'humerus',249,2,169,1502.2116412,96.5441348,128.3471333,1.8,97.1204232,128.3700726,1.1456843,27.6987691,37.0121571,347959.5152242,553083.1607406,207.7827609,14943.2836076,12562.2735833,24299.2626551,54.3849546,69.2384582,1.9928014,199.9532645),(9576,'humerus',249,2,170,1507.8525896,96.4482256,128.3327809,1.8,97.0233338,128.3872249,1.1527779,27.7256568,36.698384,346601.2087699,550344.0319061,209.894168,14996.4105064,12501.1000223,24400.2275581,54.1932288,68.8909271,1.9814211,200.9169003),(9577,'humerus',249,2,171,1512.2509661,96.3560028,128.2735586,1.8,96.8836029,128.3179449,1.1619742,27.7092584,36.4294844,345169.2945149,546785.0968389,212.2118653,15009.4108038,12456.8218372,24465.6059572,54.1096282,68.6210525,1.9559538,200.4134895),(9578,'humerus',249,2,172,1514.9080412,96.24648,128.275294,1.8,96.764339,128.324517,1.1677277,27.6785912,36.2353143,343362.1417522,542855.6360386,213.6387708,14981.3972001,12405.3330428,24408.0337309,54.0004121,68.4971731,1.9839252,233.522593),(9579,'humerus',249,2,173,1520.5678444,96.1313426,128.2341136,1.8,96.664596,128.2928559,1.1755531,27.6832314,35.7365134,341928.5460577,540771.6006288,215.8572421,15132.1869031,12351.4679607,24642.5721753,53.8109356,67.9898949,1.9665597,197.4793963),(9580,'humerus',249,2,174,1525.1096183,96.0133548,128.198636,1.8,96.5004908,128.2267471,1.1824396,27.6634446,35.4709169,339795.596185,538551.1051925,217.7374971,15182.8921271,12283.1990438,24723.4712469,53.6169604,67.8254035,1.9607142,196.4115007),(9581,'humerus',249,2,175,1530.7761913,95.911965,128.1545283,1.8,96.4149363,128.1790411,1.1878756,27.5675047,35.2172675,338121.3281903,537651.934983,219.5132326,15266.7135425,12265.2134103,24846.2132686,53.5337685,67.5936237,1.9690104,195.9080899),(9582,'humerus',249,2,176,1536.6542517,95.8315405,128.0830116,1.8,96.3274698,128.1093961,1.1948832,27.5173023,34.9866843,336875.8722031,536836.2112823,221.5910315,15344.0150665,12242.3291592,24963.2748799,53.4241437,67.4404864,1.9288213,195.3004193),(9583,'humerus',249,2,177,1541.4800787,95.8384342,127.9014284,1.8,96.3336171,127.9569071,1.2042636,27.4160973,34.8960211,333731.284803,533613.8827053,223.9162555,15291.5394386,12172.8224546,24823.0957428,53.2324178,67.3459695,1.9430091,253.0544237),(9584,'humerus',249,2,178,1551.7564597,95.7510482,127.7869367,1.8,96.2132757,127.8007379,1.2122544,27.2811035,34.7170487,333252.0842485,534693.5724907,226.7795621,15401.469686,12215.4913866,24983.3416281,53.040692,67.1441639,1.9168336,231.3868018),(9585,'humerus',249,2,179,1562.1780843,95.6579607,127.6091647,1.8,96.1243397,127.6251611,1.2219192,27.242564,34.6080804,332558.8698312,534472.314428,229.9378968,15443.5700525,12207.3263627,24653.4725699,52.850057,67.005156,1.8702382,225.7703208),(9586,'humerus',249,2,180,1574.1830103,95.5537461,127.4277838,1.8,95.9450023,127.367734,1.2317955,27.1213735,34.5414311,332693.7608242,534726.2991463,233.350037,15480.7221809,12266.8477952,25007.1863368,52.9664591,66.8879453,1.9250557,207.0978661),(9587,'humerus',249,2,181,1583.5821665,95.4518671,127.2360218,1.8,95.7634939,127.1430119,1.2428999,27.0113666,34.4488706,332311.1527904,533883.4612788,236.5561238,15497.8509083,12302.6412534,24404.9323606,52.9144289,66.8796639,1.8640993,202.4450209),(9588,'humerus',249,2,182,1594.5943889,95.3542548,127.0433717,1.8,95.5882197,126.917323,1.2552266,26.8901259,36.4878391,331852.0794421,534235.7685234,240.166605,14641.4745823,12341.0385277,23132.7561406,52.832283,66.5947092,1.8721416,201.5856449),(9589,'humerus',249,2,183,1609.8093342,95.1971476,126.7343999,1.8,95.0615642,126.1195709,1.2620634,26.8108958,37.1143323,331717.1078537,538711.3991566,243.5303905,14514.915541,12372.4738718,21448.4417772,52.5574659,66.3447177,1.8597717,199.5109277),(9590,'humerus',249,2,184,1622.0822001,95.1039214,126.5114803,1.8,95.1758331,126.2583255,1.2776278,26.6695685,35.4374031,330629.4821996,537873.8305271,247.7694154,15178.1390208,12397.2565361,21693.937819,52.415628,68.7030668,1.8430823,206.9504205),(9591,'humerus',249,2,185,1637.9174522,94.9568671,126.1933082,1.8,95.0289816,125.9225789,1.2878855,26.5891446,34.1926404,329780.4308055,541469.1881487,251.7135658,15835.8401827,12402.8221161,22086.7369707,52.3234772,67.9518662,1.8265108,202.8009861),(9592,'humerus',249,2,186,1644.4277365,94.8684385,126.0101993,1.8,95.0593016,125.9662437,1.3028189,26.4997602,33.6508032,328294.9008968,537628.1521853,254.8563432,15976.6811277,12388.5989142,23248.5604529,52.2045898,65.691693,1.849096,196.3683149),(9593,'humerus',249,2,187,1653.9453368,94.7413703,125.8149987,1.8,94.9149877,125.8145825,1.3117219,26.4827319,33.5998731,327604.8075489,537457.0962119,257.5658051,15995.807309,12370.5065002,23711.0760903,52.415628,65.5749502,1.7887545,193.3299619),(9594,'humerus',249,2,188,1656.4512376,94.6061471,125.6200679,1.8,94.7667146,125.5969164,1.3194739,26.3593596,33.4000146,326153.3809052,535568.9561278,259.0015387,16034.9916841,12373.3423625,24117.9110137,51.9113416,65.3493153,1.8301281,195.6563845),(9595,'humerus',249,2,189,1664.1804833,94.4789682,125.4548303,1.8,94.6738338,125.4314995,1.3308101,26.4088418,33.4827628,325873.3307137,536380.2674897,261.6934439,16019.5940436,12339.5540627,24446.9975831,51.7018784,65.4890186,1.7488893,192.1146207),(9596,'humerus',249,2,190,1662.3955416,94.3871352,125.25211,1.8,94.6324331,125.2642416,1.3414978,26.509421,33.4826451,323671.9648312,535329.5100274,262.7519306,15988.2681828,12209.6957252,24846.5747472,51.56256,65.414265,1.7424244,192.9739967),(9597,'humerus',249,2,191,1659.2973085,94.3017502,125.0713107,1.8,94.6080576,125.1292409,1.3496036,26.2947846,33.2516444,322030.3893442,533563.3281841,263.2382622,16046.2238232,12246.9301224,25230.6572879,51.56256,65.2248834,1.763024,195.0487139),(9598,'humerus',249,2,192,1655.2264575,94.2261252,124.9081456,1.8,94.5646679,124.9446119,1.3596124,26.2604687,33.1741009,320981.5863245,531668.8553166,263.7494265,16026.6243968,12222.9953219,25510.9037137,51.5322656,65.2064813,1.7229447,195.2572335),(9599,'humerus',249,2,193,1646.6918257,94.2991475,124.5257428,1.8,94.6599281,124.6320233,1.3761243,26.1589544,32.9918056,318414.1639047,526147.1717647,264.1785298,15947.8137711,12172.281766,25563.6825427,0.429688,0.9608116,2.0344439,2.0747172),(9600,'humerus',249,2,194,1647.5138287,94.2474281,124.2948821,1.8,94.6340278,124.4381689,1.391297,26.0863495,32.9112624,318417.1326049,525510.2934703,265.833098,15967.4912057,12206.2740972,25462.1467063,51.132872,64.9738839,1.7772708,194.0418923),(9601,'humerus',249,2,195,1645.6820577,94.1688308,123.97894,1.8,94.5066676,124.0856025,1.4110874,25.9557105,32.7415794,316790.6437723,522763.0852369,267.3435684,15966.3368558,12205.0461032,25395.6671787,51.132872,64.8031618,1.7642907,195.5089389),(9602,'humerus',249,2,196,1652.3765821,94.12307,123.6785781,1.8,94.4665478,123.7602982,1.4298139,25.9141143,33.067072,316400.75846,523196.7394115,269.9584796,15822.2880758,12209.5918356,25288.351727,51.132872,64.8031618,1.7642907,193.4342217),(9603,'humerus',249,2,197,1655.6615731,94.0779687,123.3548643,1.8,94.4589167,123.4291209,1.447957,25.8201011,32.6369686,315210.9081166,522494.801363,271.8006445,16009.2932767,12207.9656805,25365.1425965,51.132872,64.7333208,1.6638601,195.2572335),(9604,'humerus',249,2,198,1662.4560225,94.034782,123.0138303,1.8,94.4089178,123.0831603,1.4689685,25.7797892,32.5118636,315057.5361437,522499.6470098,274.2129486,16071.0457349,12221.1059916,25417.1089436,51.132872,64.5676818,1.7446975,191.8629153),(9605,'humerus',249,2,199,1671.6041914,94.0087136,122.6708948,1.8,94.3906487,122.7817999,1.4909658,25.6886394,32.5390165,314716.6939576,523702.7399027,276.8289705,16094.6087771,12251.2013392,25437.7143566,51.132872,64.6562658,1.7108137,191.0035393),(9606,'humerus',249,2,200,1674.3009343,93.9342053,122.3268076,1.8,94.3227417,122.473962,1.5096483,25.699483,32.704498,312875.724374,524302.4820044,278.0080664,16031.5098675,12174.3975994,25346.2955149,51.132872,64.81883,1.6770612,209.2336573),(9607,'humerus',249,2,201,1667.2276909,93.8001063,122.06299,1.8,94.2324534,122.1634287,1.5228007,25.8106694,32.4610087,309923.3788515,522711.729207,277.2316759,16102.7568203,12007.5684265,25328.0469552,51.132872,64.6591213,1.6506263,194.1461521),(9608,'humerus',249,2,202,1652.0130254,93.6529304,121.9051286,1.8,94.0808468,121.9760429,1.5318111,25.9600282,32.1341233,307158.7080126,519167.0573183,274.9172495,16156.2539879,11831.9866854,25308.6252536,51.132872,64.347123,1.6711294,192.8265511),(9609,'humerus',249,2,203,1640.6287978,93.5717498,121.7294776,1.8,94.0289696,121.7904834,1.5425031,26.0084823,32.2225271,305694.6085335,515689.6788886,273.2193023,16004.0110105,11753.6503952,24740.1925524,51.132872,64.5962705,1.6373645,212.37627),(9610,'humerus',249,2,204,1636.385568,93.5431231,121.5084881,1.8,93.9898152,121.5858384,1.5559906,25.9822601,32.0961465,305037.2361764,513568.4357397,272.6711475,16000.9375599,11740.2117724,24577.0037549,51.132872,64.6262751,1.497594,223.8177516),(9611,'humerus',249,2,205,1639.8732622,93.5330422,121.2684229,1.8,93.9822831,121.2881285,-1.5704245,25.920344,32.3251335,305693.8961598,513520.0287818,273.3121723,15886.0915116,11793.5894826,24486.5944087,51.132872,64.81883,1.4645315,216.6299642),(9612,'humerus',249,2,206,1639.7735051,93.5514279,121.004789,1.8,94.0077754,121.027905,-1.5549959,25.914823,32.1658994,306150.5022208,511848.3848733,273.2273625,15912.7645713,11813.7215111,24312.4618322,51.132872,64.7817899,1.4176427,188.8856363),(9613,'humerus',249,2,207,1643.3962044,93.5745652,120.7206544,1.8,93.9995695,120.6964059,-1.5388117,25.9073791,32.3839451,307420.3630991,510680.0781204,273.6192609,15769.5449616,11866.1313532,24957.3245015,51.132872,64.81883,1.4645315,188.6339309),(9614,'humerus',249,2,208,1646.6544517,93.6188812,120.4398559,1.8,94.0537609,120.43393,-1.5236885,25.9009033,32.2351943,308906.8355911,509792.37024,273.8338304,15814.7758092,11926.4889043,24990.0085613,51.132872,64.7817899,1.4176427,188.2779657),(9615,'humerus',249,2,209,1648.7045918,93.7848734,119.9155784,1.8,94.1895799,119.9000728,-1.5042583,25.8094079,32.2372806,309689.3841588,505529.6488832,273.5693398,15681.5227503,11999.0890881,24976.318775,51.132872,64.5676818,1.3968951,188.0262603),(9616,'humerus',249,2,210,1656.6557313,93.8553912,119.6117031,1.8,94.2364016,119.599704,-1.4879646,25.7814084,32.3994327,311498.3637341,506066.7706995,274.2192068,15619.6182639,12082.2865415,24970.2093287,51.132872,64.5676818,1.3968951,188.0262603),(9617,'humerus',249,2,211,1666.8559656,93.9424628,119.2862025,1.8,94.334136,119.2422625,-1.4693152,25.7447212,32.3103283,313251.1794971,507613.9555912,274.9581408,15710.5786878,12167.5887258,25044.3937998,51.4988376,64.4947231,1.4034571,188.2779657),(9618,'humerus',249,2,212,1674.958727,94.0291954,118.9619787,1.8,94.4173063,118.9089688,-1.4508279,25.7267279,32.4415463,314584.795629,509322.8230995,275.1612393,15699.7085982,12227.9365098,25073.5044045,51.4988376,64.4947231,1.4034571,188.6339309),(9619,'humerus',249,2,213,1677.8618099,94.1078469,118.687108,1.8,94.4992555,118.6293802,-1.4325018,25.6938705,32.4031449,315060.5489936,510341.4596402,274.329357,15749.7508519,12262.0898796,25104.2368786,51.4988251,64.5676818,1.3968951,188.2779657),(9620,'humerus',249,2,214,1689.7863372,94.1995818,118.373511,1.8,94.583824,118.3318812,-1.4127844,25.6685405,32.4337565,316673.1998912,513361.2050635,274.6576813,15827.9909605,12337.0162017,25187.8685973,51.56256,64.7361729,1.3499676,188.8856363),(9621,'humerus',249,2,215,1699.7696012,94.3098823,118.0747712,1.8,94.683212,118.0187857,-1.393703,25.643046,32.4484968,317944.1702331,515805.6003199,274.5027243,15896.1323732,12398.8456879,25237.4620428,51.56256,64.7361729,1.3499676,188.1737059),(9622,'humerus',249,2,216,1705.2262535,94.4160925,117.8050247,1.8,94.7948699,117.723762,-1.3756532,25.6314446,32.4365973,318490.1428283,516978.8404194,273.5183231,15938.134184,12425.7585904,25268.5911068,51.56256,64.6319887,1.3016288,188.7813765),(9623,'humerus',249,2,217,1709.9861166,94.5479594,117.5540938,1.8,94.9258594,117.4170023,-1.356734,25.6636533,32.5161288,319613.6055996,518303.2112201,272.1365892,15939.8806382,12453.9402811,25301.6375931,51.6387199,64.5462319,1.2595717,189.1373417),(9624,'humerus',249,2,218,1708.4559109,94.6157807,117.3566814,1.8,95.0130625,117.2021446,-1.3416424,25.7308851,32.6698216,319752.192253,520478.0094534,270.0502765,15931.461632,12426.7856011,25255.332299,51.748555,64.6990854,1.2742505,189.3890471),(9625,'humerus',249,2,219,1702.0542795,94.6899985,117.1618701,1.8,95.1214438,116.9075544,-1.323588,25.7551101,32.7675651,321013.2778962,521591.8173541,266.6900134,15917.9303214,12464.0615587,25167.1162735,51.8721733,64.8658121,1.288857,189.2847873),(9626,'humerus',249,2,220,1700.6150469,94.8035197,116.927576,1.8,95.2332866,116.7096637,-1.3012752,25.7858525,32.9748268,322699.6113009,523800.203533,263.3403383,15884.8507798,12514.5992966,25197.6662333,51.8545091,65.1101393,1.276179,189.5364927),(9627,'humerus',249,2,221,1697.789789,94.8551226,116.7465068,1.8,95.3399621,116.4592989,-1.2829933,25.8783111,33.1385194,324847.8034789,525323.1019081,260.1668416,15852.3407574,12552.8981703,25121.5562049,51.8859735,64.9554107,1.2615974,190.1441633),(9628,'humerus',249,2,222,1704.1717822,94.9929049,116.5156009,1.8,95.493324,116.198339,-1.2583954,25.8932182,33.3014699,327986.4340136,528826.6928493,257.1991493,15879.980503,12666.8856406,25242.3613169,51.8881552,65.093123,1.234433,190.1441633),(9629,'humerus',249,2,223,1720.6112838,95.2017646,116.2242469,1.8,95.6250939,115.9729097,-1.2311815,25.9662233,33.391861,332400.4876788,534193.8874767,254.9453862,15997.7273238,12801.2643146,25519.4540883,52.0776993,65.1894901,1.1927379,190.7518339),(9630,'humerus',249,2,224,1714.397809,95.2355357,116.0771142,1.8,95.7371028,115.7834037,-1.2156167,26.0359155,33.6916996,334548.0924923,535067.479368,251.1775192,15881.2848997,12849.4844704,25411.7239069,52.0809719,65.2362052,1.2282155,191.2552447),(9631,'humerus',249,2,225,1697.0439885,95.3114049,115.9173461,1.8,95.7128959,115.6583747,-1.1928222,26.0655764,34.0771596,336447.8634804,530140.7004373,244.3207974,15557.0683433,12907.7469004,25094.7277222,52.2737886,65.2786444,1.2074032,191.5069501),(9632,'humerus',249,2,226,1700.1711473,95.4398646,115.875611,1.8,95.7989825,115.6252125,-1.1717757,26.1888311,34.3067308,341483.4557492,529711.9091039,240.5898793,15440.4659721,13039.2782325,25050.2478212,52.4211098,65.3817982,1.2220253,191.7586556),(9633,'humerus',249,2,227,1706.024646,95.6160375,115.8521588,1.8,95.9419644,115.587388,-1.1469034,26.2504192,34.6353814,346448.3224736,531087.347023,236.2339471,15333.6653529,13197.8205641,25140.9215426,52.4676962,65.4326087,1.2012651,192.6180316),(9634,'humerus',249,2,228,1706.7927142,95.778873,115.7712814,1.8,96.1155239,115.4940483,-1.1176591,26.2329067,34.9399304,349492.649587,534203.119551,229.9451933,15289.1866977,13322.6810883,25166.7157428,52.6583312,65.676233,1.1744954,193.2257021),(9635,'humerus',249,2,229,1708.0215786,95.9295101,115.7239345,1.8,96.2157614,115.4054829,-1.0927198,26.4532804,35.1086613,351971.3546126,536935.3283517,224.4151201,15293.5289515,13305.3953628,25160.268928,52.9124681,65.7478806,1.1890764,193.4774076),(9636,'humerus',249,2,230,1713.5995843,96.1106989,115.6129059,1.8,96.3853496,115.2833503,-1.0631598,26.5167829,35.442614,354926.6640802,542886.2665606,218.1109435,15317.3314479,13384.9820863,25205.0677795,53.0439646,65.9091531,1.1830262,194.3367836),(9637,'humerus',249,2,231,1712.2019777,96.221463,115.5554295,1.8,96.4836959,115.1327405,-1.0415553,26.58773,35.7135038,357840.575248,546294.4636154,212.6263309,15296.5798949,13458.8614954,25285.9473257,53.2356904,66.0127201,1.1624858,194.4842292),(9638,'humerus',249,2,232,1712.6133149,96.3649734,115.4762867,1.8,96.6602462,114.9978236,-1.0138915,26.6394862,35.9642964,361020.1386738,551254.6320197,205.6914292,15327.830294,13552.0683988,25365.5129264,53.429598,66.3586309,1.0636978,194.7359346),(9639,'humerus',249,2,233,1709.8189969,96.5447161,115.288353,1.8,96.8103429,114.8298363,-0.9821725,26.6567087,36.0563521,363090.8448337,558464.191907,197.1233428,15488.6492743,13620.9930881,25557.3658278,53.6213238,66.469831,1.0348114,196.307241),(9640,'humerus',249,2,234,1703.6392035,96.6855959,115.1445227,1.8,96.9646198,114.6907934,-0.9532828,26.7656065,36.3508673,364970.3920597,564664.1621019,188.748405,15533.7190905,13635.7975775,25573.9304421,53.8130497,66.7719115,1.0149255,196.706392),(9641,'humerus',249,2,235,1702.0785614,96.8568441,115.0228075,1.8,97.1395544,114.5359468,-0.9234175,26.9325384,36.5690247,367294.1540904,572210.775449,180.4978293,15647.4168985,13637.5616998,25691.0871071,54.0058664,67.1194113,0.8760581,197.8174734),(9642,'humerus',249,2,236,1705.4249844,97.0407176,114.8813247,1.8,97.3050448,114.3905697,-0.8908316,27.0948072,36.7266311,369176.6424007,581814.002988,171.865295,15841.747144,13625.365156,25856.2317804,54.1986831,67.6727907,0.8663023,198.6768494),(9643,'humerus',249,2,237,1708.4426509,97.1980964,114.7332999,1.8,97.5028713,114.2281763,-0.8634751,27.2850218,36.9549895,371520.7490004,592071.2458119,164.5116413,16021.4156288,13616.2892608,26045.6337359,54.6070318,68.2325062,0.8567056,199.4319656),(9644,'humerus',249,2,238,1704.462829,97.3432284,114.6287875,1.8,97.7236993,114.0849512,-0.836487,27.520555,37.2333231,372895.6383832,600897.636401,156.5264874,16138.7055242,13549.7135931,26145.6488284,54.9010495,68.7635064,0.8384457,200.543047),(9645,'humerus',249,2,239,1710.1084212,97.5637043,114.4785251,1.8,97.8785299,113.9609232,-0.8114151,27.5364159,37.2807777,375003.9897229,614879.5667527,149.9209738,16493.2065382,13618.4749276,26440.3981697,55.1827972,69.3703297,0.8379812,201.7583882),(9646,'humerus',249,2,240,1708.9888253,97.740548,114.3678749,1.8,98.2026382,113.8078884,-0.7911119,27.7628372,37.6011425,376666.4999547,625168.7008432,144.0431395,16626.3219325,13567.2913259,26558.4424805,55.4424115,70.0114592,0.7246036,203.2254348),(9647,'humerus',249,2,241,1706.5534762,98.0286838,114.1918581,1.8,98.6651285,113.5938459,-0.7626969,28.021719,37.846836,377141.0730573,637502.3390582,135.7581837,16844.2703716,13458.8842593,26696.0987797,55.223368,70.8724735,0.7382229,204.5882216),(9648,'humerus',249,2,242,1709.8310819,98.2143119,114.0995757,1.8,98.9035215,113.5296951,-0.7422313,28.0637403,37.9594712,379089.8498983,652148.51216,130.1998534,17180.1263796,13508.1726787,27032.5705894,55.0389658,71.5104631,0.7301353,204.7356672),(9649,'humerus',249,2,243,1710.7487578,98.4498737,113.9625043,1.8,99.1766181,113.3754242,-0.7212383,28.2684987,38.2287879,380338.813032,667387.511193,124.3189865,17457.7209218,13454.5105385,27254.1098261,55.0027469,72.2910953,0.6970214,206.8103844),(9650,'humerus',249,2,244,1711.4024102,98.6727125,113.8732919,1.8,99.4216784,113.2374886,-0.700248,28.4308455,38.4408545,381920.3851304,683080.0792296,118.446411,17769.6382682,13433.3108501,27500.1475663,54.8399221,73.0444324,0.7271309,208.5291364),(9651,'humerus',249,2,245,1711.1116991,98.8600424,113.8020432,1.8,99.6429398,113.1375618,-0.6817981,28.5008695,38.6794097,382487.3515537,699705.0627115,113.2583664,18089.8588598,13420.199382,27822.1310792,54.7759232,73.7312556,0.7111547,209.996183),(9652,'humerus',249,2,246,1713.4763286,98.9659994,113.7554888,1.8,99.7772718,113.1332209,-0.6662737,28.6497512,39.0412497,383919.7448721,716874.0544314,109.091135,18361.9648311,13400.4565052,27980.5096369,54.6215831,74.6186338,0.7161214,211.0030046),(9653,'humerus',249,2,247,1712.7755671,99.016885,113.7451572,1.8,99.8405642,113.1155611,-0.6514264,28.8725582,39.4245968,385851.1751381,732977.5370764,104.9433415,18591.8841825,13363.9413776,28243.5342929,54.5829806,75.4307463,0.6845271,212.574311),(9654,'humerus',249,2,248,1707.4798801,99.0145786,113.7707931,1.8,99.8965088,113.1707508,-0.6382207,29.0866999,39.8219529,388121.0798913,747701.5991029,101.0084609,18776.1157977,13343.5928027,28246.0349276,54.397342,76.25237,0.6976243,214.1888032),(9655,'humerus',249,2,249,1700.9231022,98.9909817,113.8250831,1.8,99.8204891,113.3107744,-0.6249202,29.1780333,40.3254014,391117.0806804,761220.6002689,97.0271877,18876.9503367,13404.5045473,28378.3740336,54.3653019,77.1873229,0.6947383,216.5152258),(9656,'humerus',249,2,250,1695.104124,98.9870266,113.9047055,1.8,99.8387691,113.4021873,-0.6091834,29.2997691,40.8596453,393812.2498338,775421.9195561,92.4991471,18977.6958312,13440.79705,28345.2016793,54.2610793,78.1229034,0.6919214,217.8780126),(9657,'humerus',249,2,251,1695.5221751,98.9893718,114.0263432,1.8,99.8403861,113.5324853,-0.5918127,29.3603155,41.3289535,397796.9716615,792212.7650582,87.9452949,19168.4690356,13548.7975767,28537.7851502,54.2967308,79.059089,0.6891712,219.2407994),(9658,'humerus',249,2,252,1706.4677623,99.0367365,114.1843557,1.8,100.0389805,113.7472886,-0.5751232,29.3348469,41.7642418,402595.9533498,813218.2411184,84.1484096,19471.6390192,13724.1539065,28711.2613602,54.2339366,80.1630152,0.7057193,223.2427882),(9659,'humerus',249,2,253,1721.2892181,99.0813628,114.286437,1.8,100.2085366,113.9201335,-0.5588407,29.3453506,42.1851919,407447.4756256,837005.7979748,80.6469429,19841.2229648,13884.5666419,29122.7906461,54.1061276,80.9970428,0.6763979,222.9300088),(9660,'humerus',249,2,254,1724.3478953,99.090373,114.4008003,1.8,100.2408049,114.1386482,-0.5447962,29.2946742,42.7450258,409713.5478018,857900.9025926,77.1866014,20070.1926611,13985.9397493,29330.9186161,54.1901131,82.0062672,0.6665578,235.6300174),(9661,'humerus',249,2,255,1731.7788208,99.1575915,114.4433379,1.8,100.4007246,114.2239924,-0.5318243,29.3777912,43.7549396,413067.3820136,882551.8161638,74.2231757,20170.3356216,14060.5322986,29497.4404511,54.3629705,83.2763723,0.6352454,238.0606998),(9662,'humerus',249,2,256,1736.6696046,99.2798353,114.3975252,1.8,100.5639373,114.2448153,-0.5163404,29.5092618,43.9349865,414993.7781191,904662.7074663,70.5494899,20590.9408453,14063.1704535,29846.0101171,54.5385952,84.2287127,0.658806,245.6476381),(9663,'humerus',249,2,257,1736.6467215,99.3975854,114.2294955,1.8,100.6938146,114.1544121,-0.4913306,29.7369529,44.2115726,415737.8203821,925530.9012778,64.4280896,20934.132095,13980.5117748,30058.3394299,54.4639807,85.5122304,0.653551,238.6072964),(9664,'humerus',249,2,258,1747.7169072,99.5017318,114.2837807,1.8,100.8795122,114.3226271,-0.4754592,29.9396637,44.4442487,419551.8219883,948935.8434641,61.0337964,21351.1505298,14013.2443282,30409.0736119,54.4639807,86.4559592,0.6514532,241.393944),(9665,'humerus',249,2,259,1763.6237181,99.6000146,114.3375309,1.8,101.0729309,114.4347124,-0.4629024,30.1660425,44.6739698,423347.669249,976435.3412599,58.6123259,21856.9190623,14033.9147595,30899.0329983,54.7492087,87.5087858,0.6670724,245.5433784),(9666,'humerus',249,2,260,1781.7323468,99.6418804,114.4003891,1.8,101.0806567,114.6402072,-0.4545396,30.4314402,45.1902466,427477.2727176,1007675.4299407,57.2422486,22298.5158295,14047.2244956,31367.3454481,55.2229687,88.5251139,0.6580632,248.3732118),(9667,'humerus',249,2,261,1792.278458,99.6530281,114.5655545,1.8,101.0647374,114.9129439,-0.4508078,30.9577477,45.8025126,430034.7265351,1037524.8374417,56.704174,22652.1380114,13891.0211172,31696.6147915,55.8928332,89.6566433,0.6665076,260.9868487),(9668,'humerus',249,2,262,1804.1357346,99.7733826,114.690178,1.8,101.1679139,114.9940017,-0.4434625,31.2966195,46.1038235,431978.0720324,1071844.1716433,55.3571129,23248.4876653,13802.7070947,32252.8002579,56.3744237,90.7944064,0.6747409,260.4834379),(9669,'humerus',249,2,263,1808.6940134,99.9620249,114.7488913,1.8,101.429179,115.0436494,-0.4334479,31.6182377,46.2835785,433490.2204164,1101715.5318315,53.1761869,23803.5944167,13710.1322457,32762.5047483,56.7798976,91.8789101,0.6594025,264.7371321),(9670,'humerus',249,2,264,1812.727882,100.2165883,114.8843442,1.8,101.658427,115.068376,-0.4220981,32.0399358,46.4216251,434887.4871244,1131446.43977,50.7061791,24373.2621707,13573.2946053,33348.9268977,57.458273,92.8145973,0.6870324,270.7095782),(9671,'humerus',249,2,265,1824.4477478,100.4996608,115.045069,1.8,101.9471328,115.1347419,-0.4113945,32.4518692,46.5414554,437667.4701308,1164114.9569138,48.6246722,25012.431324,13486.664438,33954.5544039,58.051224,93.545752,0.6747409,274.5641214),(9672,'humerus',249,2,266,1859.6624548,100.8132214,115.2479795,1.8,102.1110731,115.263408,-0.4018816,32.9618057,46.6523339,443401.3022233,1201867.9575227,47.4210507,25762.2257466,13451.9724439,34723.3123985,58.8908683,94.4189884,0.6790053,281.8561686),(9673,'humerus',249,2,267,1889.7274458,101.1697287,115.5038454,1.8,102.3897234,115.4683638,-0.393991,33.5450351,46.7513047,450868.0220523,1243121.4095602,46.4121259,26590.0901998,13440.6781939,35580.1381331,59.6767157,95.4255692,0.6705216,288.4794712),(9674,'humerus',249,2,268,1932.5043906,101.5366545,115.8574499,1.8,102.5840107,115.7678282,-0.3873162,34.1555612,46.7937637,461706.2313856,1289867.3019052,45.948799,27564.9402974,13517.7469067,36103.7814062,60.5280879,96.1704717,0.6873013,299.7735071),(9675,'humerus',249,2,269,1986.4762315,101.8585442,116.3054232,1.8,102.7391674,116.2125044,-0.3836416,34.8396413,47.0312465,476680.0043326,1348337.4681341,46.3843368,28668.9715645,13682.1157199,37200.7882272,61.5284436,97.1075867,0.6851068,302.4558949),(9676,'humerus',249,2,270,2035.1815909,101.9808509,116.9373654,1.8,102.7734152,116.8280893,-0.3857863,35.6414158,47.5723091,497031.349145,1414053.2501894,48.0277262,29724.2928942,13945.3312473,38738.7652136,62.7716198,98.0451604,0.6829543,313.3760775),(9677,'humerus',249,2,271,2112.9195139,101.9358635,117.8191817,1.8,102.5018586,117.5332951,-0.396398,36.6095159,48.5084222,529379.4616151,1500914.522351,52.4961068,30941.3180929,14460.1601145,41180.3407642,64.5446104,98.7805892,0.6713442,326.2235317),(9678,'humerus',249,2,272,2184.7598504,101.8569411,118.785524,1.8,102.2464917,118.5690865,-0.4118613,37.6551228,49.2606346,568291.9038046,1593838.5512977,58.3522686,32355.2175975,15092.0209869,43113.4108134,66.519663,99.6922462,0.7030162,346.0502537),(9679,'humerus',249,2,273,2336.0958044,101.9788179,120.5013877,1.8,102.839363,119.8922739,-0.4395499,39.4768494,50.6972974,648709.4376871,1749263.343605,70.5024404,34504.0748339,16432.6547832,44927.0659486,68.5904501,100.6259208,0.7007524,368.6025492),(9680,'humerus',249,2,274,2438.088748,102.4042782,121.75436,1.8,103.4127765,120.8296697,-0.4327232,40.980969,50.9893362,725794.29611,1874117.2792222,71.4562425,36755.082922,17710.5206084,48974.2140591,70.8718005,101.5973629,0.7375306,395.0883501),(9681,'humerus',249,2,275,2494.8743213,102.8927819,122.7607504,1.8,103.5699469,121.5433483,-0.4173693,42.2360363,51.1951236,794302.6561148,1968081.5530445,68.3239208,38442.7542342,18806.2783816,52058.3384617,72.4681921,102.841853,0.732194,414.7676265),(9682,'humerus',249,2,276,2505.3859119,102.9666161,123.4907582,1.8,103.4334998,122.2788274,-0.4206684,43.0189403,51.7198859,832266.1934406,2007542.4472693,69.6357811,38815.6781752,19346.5061361,51953.5115617,73.576516,103.956083,0.7561667,412.8403549),(9683,'humerus',249,2,277,2521.4643184,103.2586227,124.1084057,1.8,103.4189679,123.1161421,-0.4234747,43.7374653,52.1270732,867242.3227902,2056096.3395162,70.9641055,39443.9244711,19828.3626559,52355.5201939,74.8096426,104.8975692,0.7477348,402.7795483),(9684,'humerus',249,2,278,2543.7170914,103.5691042,124.893642,1.8,103.4908306,123.9757976,-0.423794,44.7186459,52.5619463,904505.4024438,2111156.6881899,71.6918498,40165.1163743,20226.5829865,53914.5515171,75.9347335,106.0911767,0.75389,404.3508547),(9685,'humerus',249,2,279,2582.6655565,103.9302038,125.4638338,1.8,103.545774,124.6897504,-0.4234983,45.4256692,52.6789576,945583.6150624,2170341.5668716,72.6941758,41199.4022792,20816.0635104,55700.9038295,76.9137765,106.9931748,0.7569967,413.5090995),(9686,'humerus',249,2,280,2615.6556184,104.4313168,126.0905596,1.8,103.8980249,125.6545525,-0.417184,46.385515,52.666818,991716.002396,2230479.4938449,71.5717383,42350.7547624,21379.8640101,58114.5894827,77.9935088,107.6417754,0.7458707,414.7676265),(9687,'humerus',249,2,281,2722.4873693,105.4127744,127.24314,1.8,104.8911333,127.2134062,-0.3929657,47.9285118,52.1591753,1094461.7970621,2293531.3409331,66.5354114,43971.7715744,22835.2968999,62082.6225405,82.419069,108.541094,0.7489997,402.5278429),(9688,'humerus',249,2,282,2869.5251515,106.5172256,128.739513,1.8,105.3212755,128.306579,-0.3531702,49.8031187,52.3982871,1217779.1443629,2365244.2603604,57.2130063,45139.7247737,24451.8651883,65339.495783,84.1226069,109.1990995,0.7380798,404.6457459),(9689,'humerus',249,2,283,2934.7859947,106.9593257,129.6321714,1.8,105.5045999,129.1242338,-0.3338391,50.8714575,52.7370826,1286396.374255,2418479.3998948,52.5176724,45859.1806877,25287.1932083,66871.1796132,85.5621029,110.0957591,0.741228,408.3349553),(9690,'humerus',249,2,284,2943.3441251,107.0382809,130.4325986,1.8,105.579667,129.8700576,-0.3337928,51.6533819,52.9415233,1322554.2014423,2432293.7447505,52.6567459,45943.0252774,25604.4067562,67654.7512649,86.9454744,110.7628654,0.7305083,428.3523087),(9691,'humerus',249,2,285,2949.188728,107.0144159,131.2140545,1.8,105.4750338,130.498682,-0.3481403,52.5779992,53.1577647,1344057.7305465,2439757.9197435,57.2061477,45896.548412,25563.1205211,68149.4341851,87.9584019,111.2850444,0.7471654,450.4011935),(9692,'humerus',249,2,286,2933.4814313,106.7907951,131.8012022,1.8,105.3989142,131.0235014,-0.3664203,53.0983227,53.5405255,1362861.3424747,2437255.1601559,62.7576433,45521.6891999,25666.7494073,68355.3646454,88.9463385,111.3381225,0.7362574,416.8244555),(9693,'humerus',249,2,287,2897.7257532,106.442189,132.4684212,1.8,105.2841855,131.6809083,-0.3807643,53.6903905,54.3392153,1379873.3546769,2436917.9079648,66.7003082,44846.3949113,25700.564693,67917.9218435,75.8447677,111.8708201,0.752801,381.0329643),(9694,'humerus',249,2,288,2894.3326128,105.8675997,132.9237899,1.8,105.2426924,132.0828211,-0.3726713,53.9753765,54.9436481,1428403.2547509,2430178.763535,63.951356,44230.3860348,26463.9794385,67996.9223743,90.3956746,111.9450636,0.7365241,463.2054618),(9695,'humerus',249,2,289,2925.1437959,105.3447651,133.4599551,1.8,105.139709,132.5665978,-0.3434972,54.3741918,55.4568531,1525338.4897196,2417875.4474582,55.2960102,43599.2183351,28052.6190679,68705.1592793,91.291796,112.499507,0.7475784,441.9548791),(9696,'humerus',249,2,290,2953.2753006,104.8300648,133.8092909,1.8,104.8838507,132.7881129,-0.3383539,54.5285213,55.917005,1579505.7440842,2389145.4651437,54.2323193,42726.6350353,28966.5977695,68459.4960247,91.7516697,113.0528644,0.7638961,436.8418089),(9697,'humerus',249,2,291,2983.0834856,104.3834649,134.2376905,1.8,104.5762855,133.1407704,-0.3452301,54.7818649,56.2833265,1614233.640653,2356421.6859009,56.9388702,41867.1360505,29466.5696871,67993.0766718,92.2272376,113.1067454,0.7477815,440.5310183),(9698,'humerus',249,2,292,3003.813494,104.1245988,134.7844851,1.8,104.5126491,133.4176159,-0.3559428,55.1950831,56.5932857,1640254.9010464,2331392.0065525,60.7943275,41195.5584177,29717.4097346,67428.7525332,92.9573684,113.3993768,0.7505597,440.9301693),(9699,'humerus',249,2,293,3030.6526881,104.0564837,135.2464591,1.8,104.5397511,133.5382267,-0.3668797,55.5813482,56.7503452,1664800.5781848,2334571.7135471,64.9918083,41137.577336,29952.5044227,67700.3602365,93.205044,113.4775013,0.7345038,413.1605438),(9700,'humerus',249,2,294,3071.1843427,103.9281996,135.6790402,1.8,104.5173601,133.7195849,-0.3706126,55.8623524,56.9226953,1697281.7518768,2342625.0700008,67.1458464,41154.5001279,30383.2846344,68200.5837401,93.5874635,113.4775013,0.7345038,409.496632),(9701,'humerus',249,2,295,3113.9669384,103.900772,135.9607868,1.8,104.490076,133.8633761,-0.3745174,56.0119936,57.0363994,1732233.9560485,2357537.4825149,69.4553566,41333.9114538,30926.1257244,68992.9828114,93.8954142,113.4775013,0.7345038,411.9883884),(9702,'humerus',249,2,296,3133.5766235,103.9024866,136.1837495,1.8,104.3940368,133.9525835,-0.3796831,56.0409144,57.0262533,1755777.5486605,2360797.4394637,71.7399549,41398.4314644,31330.2801388,69486.3867003,93.9249684,113.5458162,0.7238139,408.9932212),(9703,'humerus',249,2,297,3166.6215714,103.8601893,136.3769465,1.8,104.3863145,134.0542147,-0.3812809,56.1183338,56.9979517,1774145.4670217,2371483.0099218,73.0780272,41606.460188,31614.3646339,69956.9768864,93.9279958,113.7139884,0.7479825,412.8045786),(9704,'humerus',249,2,298,3201.6965178,103.7852386,136.5273293,1.8,104.3174367,134.1022333,-0.3860852,56.0494271,57.0345679,1790643.4967205,2381602.4150533,75.6672892,41757.1746905,31947.5789395,70449.506423,93.9255966,113.5458162,0.7238139,402.1792872),(9705,'humerus',249,2,299,3224.5398886,103.7041418,136.6124861,1.8,104.1725509,134.166213,-0.3891582,56.012019,57.0939504,1803767.0786312,2376509.3447167,77.3630175,41624.538673,32203.2147874,70555.0582713,93.7806483,113.7967645,0.7319731,401.424171),(9706,'humerus',249,2,300,3239.039134,103.5279325,136.7175177,1.8,103.9952569,134.2355312,-0.3824117,55.9075046,57.0487563,1804528.6243308,2375363.6692124,75.1714286,41637.4312812,32277.0375073,70526.5538174,93.7057487,113.6725778,0.7078063,401.3377994),(9707,'humerus',249,2,301,3262.5782309,103.4106294,136.8305329,1.8,103.8423483,134.2258958,-0.3794855,55.8236485,57.161884,1793291.0945873,2386824.8904105,74.6193823,41755.5322233,32124.2187393,70589.0831368,93.3396069,113.4441422,0.6995879,397.4400704),(9708,'humerus',249,2,302,3280.1751499,103.4035455,136.8076244,1.8,103.7019165,134.2348738,-0.3774881,55.6476325,57.1338897,1781349.8591843,2392844.5810098,74.2719399,41881.3526262,32011.2424887,70573.8617882,93.0241745,113.4441422,0.6995879,400.9818342),(9709,'humerus',249,2,303,3304.3546953,103.5557357,136.7737012,1.8,103.6892952,134.2085242,-0.3756144,55.5229139,56.9665069,1768046.165125,2405588.6732689,74.1137236,42228.1232551,31843.5406464,70894.183839,92.6840803,113.4091453,0.6753327,393.3770076),(9710,'humerus',249,2,304,3322.2608446,103.7691119,136.671759,1.8,103.7654937,134.1954154,-0.3683074,55.4467848,56.6493154,1749041.1464922,2427469.8368832,71.7755431,42850.8238533,31544.5008021,71129.1476588,92.1384887,113.6782625,0.6782828,399.5579734),(9711,'humerus',249,2,305,3338.2322207,104.2825415,136.2707536,1.8,103.9416203,133.910992,-0.3589013,55.2289019,56.2709677,1702198.1457385,2444890.3531481,68.6415969,43448.5215289,30820.7856141,71318.3152525,91.5852458,113.4408872,0.6510767,402.0065439),(9712,'humerus',249,2,306,3344.0625565,104.6838375,136.1308898,1.8,103.9984327,133.8157527,-0.349615,55.1550115,55.8959609,1668155.2822545,2457747.9640156,65.3937151,43970.0458919,30244.8542437,71406.573867,91.0158159,113.3611087,0.6563889,400.4784234),(9713,'humerus',249,2,307,3363.063796,105.0234811,135.8960122,1.8,104.1213694,133.6984238,-0.3359699,54.7969505,55.6246302,1634855.8547939,2477812.1280046,60.9231239,44545.2332568,29834.7962592,71689.8656228,90.1934709,113.0985833,0.6343828,395.0525738),(9714,'humerus',249,2,308,3369.7850641,105.3685992,135.6667816,1.8,104.1992016,133.5484046,-0.3140157,54.5568835,55.0797726,1592546.5279313,2480853.8740087,53.5835823,45041.1059634,29190.5700176,71652.6018098,89.3901839,112.752784,0.6366415,389.4792786),(9715,'humerus',249,2,309,3329.2829506,105.5369095,135.6702518,1.8,104.2222587,133.5255748,-0.2742434,54.4356013,54.1369173,1519308.2229998,2434253.6974531,40.6964595,44964.763776,27910.1945507,70324.3237428,88.5163355,111.9409402,0.6135561,389.792058),(9716,'humerus',249,2,310,3263.9450656,105.1728886,135.9924666,1.8,104.1315104,133.6281296,-0.1895561,54.1811178,52.3919512,1440191.8016035,2319213.4753836,19.3134148,44266.5986303,26581.0647827,67593.4354817,87.785905,110.392191,0.6139147,390.4429144),(9717,'humerus',249,2,311,3179.7041875,104.7196493,136.195514,1.8,103.5890262,133.9597554,-0.105049,53.5912601,51.4481017,1356159.0725813,2202525.9521273,5.8266795,42810.635912,25305.6015169,65587.6302011,86.5760182,106.5418306,0.5902397,385.3477324),(9718,'humerus',249,2,312,3102.2423729,104.389279,136.3452089,1.8,103.2237805,134.1207016,-0.0251375,52.8520236,51.4149897,1267696.9400464,2105876.271828,0.3266487,40958.4108328,23985.7786782,62325.5833999,85.7745295,104.3584688,0.4470745,385.157101),(9719,'humerus',249,2,313,2995.7402177,103.7738654,136.496928,1.8,102.7830705,134.2886782,0.0584117,52.1535662,51.896485,1161666.7551405,2002570.5453903,1.7016045,38587.7877132,22273.9658865,58676.1337904,84.5665694,103.6269918,0.4321182,379.8965852),(9720,'humerus',249,2,314,2869.9052132,103.2158536,136.5017741,1.8,102.3371494,134.3967339,0.1366755,51.0804536,52.1865797,1058213.1117347,1891932.7317814,8.8795676,36253.242571,20716.595834,54705.8192714,83.2813042,102.7017243,0.4224724,375.703965),(9721,'humerus',249,2,315,2743.1100115,102.7287422,136.3615856,1.8,101.9240285,134.3790938,0.1910453,50.0454624,52.2645603,961735.9035887,1791914.6667426,16.4844573,34285.4633761,19217.2448262,50426.3801897,82.070408,101.9456853,0.3484109,370.7994144),(9722,'humerus',249,2,316,2616.5250662,102.2209798,135.972804,1.8,101.5954343,134.1955896,0.2335265,48.7482928,52.3720701,869199.198556,1705211.8911872,23.3526869,32559.5663373,17830.3515609,46956.1292525,80.5645359,100.6974538,0.3757521,367.8653212),(9723,'humerus',249,2,317,2464.5223677,101.4706175,135.4899681,1.8,101.1481174,133.8703458,0.2750648,47.2154153,52.4195612,777022.2835877,1594872.6966957,30.3019621,30425.1439887,16456.9617477,42943.2576425,78.849599,99.0605589,0.3313525,380.7306635),(9724,'humerus',249,2,318,2266.1604762,100.3909906,134.8049038,1.8,100.4362025,133.4781069,0.3214293,45.3282922,52.6331908,678661.9927037,1443890.0980247,37.6965614,27433.0717187,14972.1500553,38077.6832752,76.9046121,97.3354767,0.291034,377.6059389),(9725,'humerus',249,2,319,2001.2560053,98.638432,133.6157826,1.8,99.4129332,132.8653346,0.3634602,43.1600272,54.0074562,576881.4152733,1249875.218005,42.155695,23142.6418727,13366.1040613,32455.85276,74.8605845,95.4990643,0.2733553,373.6218383),(9726,'humerus',249,2,320,1687.1071622,95.8994967,131.6507914,1.8,96.986957,131.4108182,0.4173708,40.5786133,56.6208552,475720.1336152,1013295.1638543,46.2029404,17896.1472843,11723.4201818,25815.2504423,41.8888237,74.8446934,1.1945543,213.7211687),(9727,'humerus',249,2,321,1285.5173808,91.2242062,128.2320026,1.8,93.0577679,128.5860345,0.5794641,35.4032996,60.4255133,325336.0148693,633503.9313354,64.2413913,10484.047156,9189.4263763,15611.2515426,34.804728,69.8847607,1.2840509,191.8450272),(9728,'humerus',249,2,322,920.2901565,87.284281,123.8572047,1.8,89.5317012,125.9173312,0.9152439,43.6466722,55.0232178,183396.0186295,360018.6574118,96.3837075,6543.0316872,4201.8327937,8427.1531971,29.4339819,65.5749502,1.2987972,180.2129142),(9729,'humerus',249,2,323,521.7195522,85.45163,113.8198489,1.8,86.1953785,118.3610475,0.8418265,28.2082999,53.4970668,56364.644616,165037.5468953,48.3728449,3084.9830996,1998.1581616,4134.3592467,20.4004128,47.3242375,1.2088376,117.4426899),(9730,'humerus',249,2,324,391.8304254,81.0631807,109.4115045,1.8,82.8716328,110.937679,-1.3658575,48.9964751,28.8395399,17439.9177129,40675.9452131,62.6004488,1410.4228183,355.9422934,1034.0093639,17.3627778,42.2866263,1.1298721,101.7475142),(9731,'humerus',249,2,325,298.0144316,80.1983997,109.1933421,1.8,80.3139513,109.0624282,-1.1995341,7.3954806,19.4834175,2901.4194848,23875.6606433,43.1317269,1225.4349476,392.3233181,1371.0519674,15.1712724,38.7053257,1.1717354,92.5892694),(9732,'humerus',249,2,326,174.4087158,79.8967988,109.5835488,1.8,79.9557518,109.2434231,-1.1858039,5.9343663,17.1768645,1018.6361936,9062.2466138,24.9683696,527.584451,171.6503746,586.8868045,12.0481648,33.2973546,1.2286404,79.4901098),(9733,'humerus',249,2,327,38.6936173,79.3117536,112.2382761,1.8,79.3438288,111.4003439,-1.1020961,4.1351397,14.5638627,109.1058772,424.1832235,5.1329832,29.1257362,26.3850525,36.3178948,8.4566636,16.0889326,0.9753865,42.6054253),(9734,'humerus',249,2,328,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9735,'humerus',249,2,329,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9736,'humerus',249,2,330,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9737,'humerus',249,2,331,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9738,'humerus',249,2,332,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9739,'humerus',249,2,333,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9740,'humerus',249,2,334,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9741,'humerus',249,2,335,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9742,'humerus',249,2,336,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9743,'humerus',249,2,337,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9744,'humerus',249,2,338,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9745,'humerus',249,2,339,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9746,'humerus',249,2,340,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9747,'humerus',249,2,341,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9748,'humerus',249,2,342,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9749,'humerus',249,2,343,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9750,'humerus',249,2,344,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9751,'humerus',249,2,345,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9752,'humerus',249,2,346,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9753,'humerus',249,2,347,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9754,'humerus',249,2,348,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9755,'humerus',249,2,349,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9756,'humerus',249,2,350,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9757,'humerus',249,2,351,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9758,'humerus',249,2,352,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9759,'humerus',249,2,353,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9760,'humerus',249,2,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9761,'humerus',249,2,355,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9762,'humerus',249,2,356,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9763,'humerus',249,2,357,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9764,'humerus',249,2,358,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9765,'humerus',249,2,359,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9766,'humerus',249,2,360,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9767,'humerus',249,2,361,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9768,'humerus',249,2,362,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9769,'humerus',249,2,363,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9770,'humerus',249,2,364,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9771,'humerus',249,2,365,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9772,'humerus',249,2,366,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9773,'humerus',249,2,367,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9774,'humerus',249,2,368,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9775,'Cervus_giganteus-radius.tif',249,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9776,'Cervus_giganteus-radius.tif',249,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9777,'Cervus_giganteus-radius.tif',249,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9778,'Cervus_giganteus-radius.tif',249,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9779,'Cervus_giganteus-radius.tif',249,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9780,'Cervus_giganteus-radius.tif',249,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9781,'Cervus_giganteus-radius.tif',249,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9782,'Cervus_giganteus-radius.tif',249,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9783,'Cervus_giganteus-radius.tif',249,3,9,2.6021891,119.424071,85.8142467,1.8,119.373938,86.0103171,-0.0919134,1.8370099,3.0917457,1.131954,3.8450649,0.0036536,1.2436549,0.6161938,1.5926841,6.6764752,10.7765203,1.160669,27.6832541),(9784,'Cervus_giganteus-radius.tif',249,3,10,16.8704772,118.8437733,86.7935852,1.8,118.8612504,87.1808313,-0.1509145,3.4934187,5.9581055,26.9904363,80.1760266,0.0635533,13.456631,7.7260811,17.8150381,10.1322212,17.4962708,1.1401038,44.7844026),(9785,'Cervus_giganteus-radius.tif',249,3,11,27.0349043,118.5045413,87.6404086,1.8,118.5055969,87.8917982,-0.2223088,4.2263894,7.7769997,77.9658198,243.2534433,0.2190387,31.2785719,18.4473819,41.0483592,12.1620075,26.1404327,1.129204,63.2051521),(9786,'Cervus_giganteus-radius.tif',249,3,12,36.8060097,118.1408227,88.2571324,1.8,118.0739665,88.4607287,-0.2522831,4.820254,9.1378677,150.1897498,474.9384457,0.3822174,51.9747559,31.1580575,68.0611752,13.6496246,34.0566711,1.056345,82.1293125),(9787,'Cervus_giganteus-radius.tif',249,3,13,48.613324,117.6736465,88.9375582,1.8,117.5256553,89.0584925,-0.279748,5.3534929,10.20976,266.0694684,812.52697,0.6177022,79.5833563,49.7001625,105.0549778,14.8859286,37.8954613,1.0614952,91.8952279),(9788,'Cervus_giganteus-radius.tif',249,3,14,61.5356463,117.07158,89.6061912,1.8,116.9864579,89.700463,-0.3273979,6.1469527,11.4416955,439.8173658,1261.1222489,1.060606,110.2216231,71.550472,148.2076088,15.9987966,41.4153261,1.0374941,101.0534728),(9789,'Cervus_giganteus-radius.tif',249,3,15,73.2781157,116.5986909,90.2181341,1.8,116.6923961,90.2214599,-0.3785221,7.0557569,12.5373684,644.2116619,1868.9458341,1.6678759,149.0700262,91.3029842,200.2639753,17.0298562,44.2390876,1.0636978,108.0327406),(9790,'Cervus_giganteus-radius.tif',249,3,16,81.2726718,116.4063655,90.7035433,1.8,116.5408469,90.6275996,-0.4150349,7.7308762,13.3138536,823.7282019,2391.416646,2.2023247,179.6186675,106.5504324,241.4350143,17.8703032,46.3684923,1.0573973,113.4407021),(9791,'Cervus_giganteus-radius.tif',249,3,17,91.3351038,116.2854573,91.2168845,1.8,116.2950932,91.1404705,-0.4520893,8.2676676,14.0346462,1045.1445323,3054.2682047,2.9049787,217.6234563,126.4134681,292.0922931,18.8255295,49.1969309,1.1188669,120.2725243),(9792,'Cervus_giganteus-radius.tif',249,3,18,99.5816543,116.2848734,91.5512154,1.8,116.2949441,91.427769,-0.4724907,8.819569,14.5671858,1220.6903785,3592.5803311,3.4375758,246.6214389,138.407033,330.3946246,19.0743113,50.9320775,1.088283,123.7100283),(9793,'Cervus_giganteus-radius.tif',249,3,19,112.006422,116.2528302,91.8392818,1.8,116.308744,91.7587263,-0.498245,9.1324765,14.7236357,1493.0526562,4232.3769776,4.2632202,287.4546121,163.4882562,388.7718126,19.5550507,52.4659434,1.1217997,128.1111681),(9794,'Cervus_giganteus-radius.tif',249,3,20,120.89012,116.3855366,92.2081077,1.8,116.450969,92.05666,-0.5282702,9.3764406,15.5211095,1662.5558112,4853.7654661,5.118818,312.720265,177.3120403,419.2755586,20.2514677,53.7127192,1.1680054,131.5486722),(9795,'Cervus_giganteus-radius.tif',249,3,21,133.6148304,116.5514684,92.5322218,1.8,116.585043,92.396553,-0.554229,9.7860725,15.8898932,1952.0206308,5706.2354568,6.1680828,359.1110003,199.4692589,480.8714545,21.0547569,54.9799191,1.1351135,134.9861762),(9796,'Cervus_giganteus-radius.tif',249,3,22,148.8176909,116.6387549,92.9035909,1.8,116.6638694,92.6976506,-0.5806635,10.4203069,16.3461032,2341.6393278,6738.7271009,7.4641666,412.2528177,224.7188439,553.5780854,21.8785551,56.1511969,1.1448021,138.6321998),(9797,'Cervus_giganteus-radius.tif',249,3,23,163.3571079,116.5813127,93.3541308,1.8,116.6694046,93.0015564,-0.6001151,10.789164,17.3275098,2746.7566048,7796.8035819,8.6832027,449.9667678,254.5847476,605.1242633,22.964663,57.380646,1.1708209,141.566293),(9798,'Cervus_giganteus-radius.tif',249,3,24,176.3166923,116.4937339,93.775609,1.8,116.6168313,93.3220512,-0.6126328,11.3437878,17.9688103,3173.1388183,8960.1881993,9.7165775,498.6522794,279.7248045,671.1054451,23.9159716,58.821761,1.1332866,145.7157275),(9799,'Cervus_giganteus-radius.tif',249,3,25,189.9514136,116.3163507,94.2071509,1.8,116.5333968,93.6504166,-0.6310518,11.6043245,18.6737138,3647.9470324,10268.8007298,11.020136,549.9067208,314.3609987,739.4807804,24.8615125,60.4273342,1.161236,147.9378903),(9800,'Cervus_giganteus-radius.tif',249,3,26,201.7425586,116.1876677,94.6163656,1.8,116.4621645,93.9736513,-0.6478015,12.1174736,19.666745,4159.5883076,11765.3491548,12.2435371,598.2357106,343.2719106,800.9515914,25.6753145,61.8870071,1.1257801,151.5839139),(9801,'Cervus_giganteus-radius.tif',249,3,27,216.5782817,116.1249986,95.0609341,1.8,116.4092898,94.3773632,-0.6640431,12.4307031,19.9400495,4799.58497,13790.4574935,13.7105934,691.5959508,386.1072812,922.3998714,26.3654995,63.3057456,1.1587745,154.4137473),(9802,'Cervus_giganteus-radius.tif',249,3,28,235.3733493,115.939971,95.6157594,1.8,116.2741177,94.8758931,-0.6881522,13.0034692,21.0227455,5656.9423245,16163.1078676,15.823599,768.8390589,435.0333144,1022.6810329,27.31218,64.6591218,1.160669,158.9191469),(9803,'Cervus_giganteus-radius.tif',249,3,29,258.8254459,115.7462499,96.2292925,1.8,116.1602453,95.4043851,-0.7143266,13.5968135,21.7931297,6775.4309685,19156.7432781,18.5132441,879.026719,498.3102097,1169.0450163,28.0958417,66.3029614,1.1216405,162.7126162),(9804,'Cervus_giganteus-radius.tif',249,3,30,281.8170261,115.5541482,96.8265087,1.8,115.9864907,95.9373596,-0.744482,14.1504155,22.2044285,7931.8638241,22459.5961638,21.5650853,1011.4917456,560.5392887,1341.6364172,29.9285721,67.6741554,1.1383886,167.4265354),(9805,'Cervus_giganteus-radius.tif',249,3,31,303.8463949,115.2837907,97.4341155,1.8,115.7458993,96.4710087,-0.7737256,14.3321775,22.9891939,8993.3635201,26046.0324796,24.7294742,1132.968499,627.4945654,1486.8174005,30.9756589,69.0635752,1.1544671,171.3242644),(9806,'Cervus_giganteus-radius.tif',249,3,32,324.5022152,115.0307391,98.0190621,1.8,115.5364986,96.9645291,-0.8014986,14.7768467,23.4325923,9919.4010851,29747.3972243,27.9124723,1269.4881045,671.2799632,1646.4957333,31.873935,70.5905597,1.1507179,174.7617684),(9807,'Cervus_giganteus-radius.tif',249,3,33,345.8556639,114.7932377,98.8028276,1.8,115.2953223,97.6111594,-0.8399172,14.9699821,24.2292906,10791.037018,34837.6940124,31.9577033,1437.8338423,720.8450186,1819.5274847,32.5524398,72.5574985,1.1627941,179.4146137),(9808,'Cervus_giganteus-radius.tif',249,3,34,359.0266797,114.711424,99.4200843,1.8,115.2618538,98.1078328,-0.8655434,14.8959361,24.5786961,11290.9620645,38802.0994577,34.6940955,1578.6882804,757.9894254,1965.3661265,32.9788304,74.0822494,1.1590501,182.9563775),(9809,'Cervus_giganteus-radius.tif',249,3,35,373.1456957,114.6876102,99.9542127,1.8,115.2108364,98.6190926,-0.8917387,15.3312233,25.094013,11932.1541301,43815.5876672,37.6591484,1746.0574238,778.2910659,2130.7031372,33.2901392,75.7470607,1.1375962,186.1421761),(9810,'Cervus_giganteus-radius.tif',249,3,36,387.1678081,114.6410935,100.5224951,1.8,115.1854476,99.1179896,-0.9154421,15.2146879,25.3903392,12598.9296968,48804.5463031,40.5611649,1922.1699182,828.0767733,2314.5749173,33.4600625,77.1837355,1.1644426,189.9356453),(9811,'Cervus_giganteus-radius.tif',249,3,37,401.8048002,114.5479463,101.0852384,1.8,115.1111491,99.6578814,-0.9377978,15.3067856,25.9751223,13246.7186349,54154.5404254,43.5322565,2084.8618094,865.4147867,2470.522107,33.7916825,78.880232,1.1558906,193.2257037),(9812,'Cervus_giganteus-radius.tif',249,3,38,416.7445324,114.4421315,101.6783281,1.8,115.0420448,100.2068105,-0.9562123,15.307471,26.858198,13860.2442537,60223.3918857,46.363583,2242.2722399,905.4561844,2607.4859956,34.1456422,80.2332329,1.1574659,196.7674676),(9813,'Cervus_giganteus-radius.tif',249,3,39,429.9521948,114.2791908,102.3888825,1.8,114.9617742,100.7781603,-0.9743962,15.0407143,27.3646655,14500.2597987,66793.9285704,49.0524844,2440.8823343,964.0672288,2806.8006196,34.5230622,81.759364,1.1541728,199.7015608),(9814,'Cervus_giganteus-radius.tif',249,3,40,443.1846986,114.0288425,103.1207307,1.8,114.7893285,101.3712501,-0.9964933,15.1150722,28.132183,15237.0042789,73059.5205114,52.0653192,2597.0085733,1008.0669215,2948.4800765,34.5468769,83.1643343,1.1672614,203.49503),(9815,'Cervus_giganteus-radius.tif',249,3,41,458.8068971,113.811652,103.7748406,1.8,114.6754489,101.9299664,-1.0156413,14.9194082,28.8273125,16050.781497,80031.9237766,55.2244358,2776.2533787,1075.8323143,3113.7932613,34.4465682,84.7477212,1.1752252,206.533383),(9816,'Cervus_giganteus-radius.tif',249,3,42,472.0822578,113.6178193,104.4736225,1.8,114.5539707,102.4932676,-1.0270524,14.9686109,29.3981195,16817.2604581,87727.8997731,57.6220156,2984.1330421,1123.5017431,3325.4624814,34.4101156,86.1746763,1.1875122,210.0751468),(9817,'Cervus_giganteus-radius.tif',249,3,43,486.6382916,113.5180909,105.0486681,1.8,114.4837641,102.9870698,-1.0346216,15.073157,30.0777642,17656.8397033,96283.4954792,59.9401297,3201.1520153,1171.4095271,3537.4812699,34.2293699,87.5309373,1.1884668,212.2541238),(9818,'Cervus_giganteus-radius.tif',249,3,44,500.8914734,113.4492042,105.6172525,1.8,114.454518,103.4672678,-1.0358045,15.2868844,31.0265099,18614.2908153,105308.6856503,61.7824021,3394.1518364,1217.6641354,3722.4681803,34.4772622,88.6637014,1.2091896,214.5805465),(9819,'Cervus_giganteus-radius.tif',249,3,45,516.3714495,113.4676513,106.1119665,1.8,114.4550227,103.919101,-1.0323933,15.386514,31.7030891,19656.2624397,115899.2822159,63.4337776,3655.7725317,1277.4993984,3996.3692288,34.2995993,89.8705582,1.214264,217.1586745),(9820,'Cervus_giganteus-radius.tif',249,3,46,534.0922399,113.4663747,106.5257742,1.8,114.4157186,104.3500195,-1.0306879,15.6234453,32.0791715,20910.7996344,127696.2101289,65.4769092,3980.6579844,1338.4243513,4347.9275429,34.1694009,90.9772394,1.2087089,218.8774265),(9821,'Cervus_giganteus-radius.tif',249,3,47,552.2443414,113.3847282,107.0231145,1.8,114.2688807,104.8708291,-1.032842,15.8002171,32.5226189,22155.2985897,140337.5044782,67.8769434,4315.0739187,1402.2148173,4702.2893225,34.2555659,92.2909417,1.2240142,221.6640741),(9822,'Cervus_giganteus-radius.tif',249,3,48,566.0766746,113.2634089,107.6501029,1.8,114.2173819,105.4764927,-1.0355208,15.4419066,33.2571113,22868.7510566,152264.4594333,69.7991782,4578.4030417,1480.9538479,5043.7625376,33.7220127,93.2452669,1.2228127,223.0700467),(9823,'Cervus_giganteus-radius.tif',249,3,49,581.083266,113.0885215,108.4067863,1.8,114.058179,106.1947032,-1.0415512,15.8226848,34.3842726,23766.8109191,168025.1102253,72.1603052,4886.6850341,1502.0719475,5425.4334626,33.6127731,94.6035989,1.2231895,225.8566943),(9824,'Cervus_giganteus-radius.tif',249,3,50,596.5274906,112.9964754,108.9866802,1.8,113.9294834,106.7487759,-1.0460439,15.6282333,35.3960034,24514.1391204,182187.0897906,74.4665372,5147.1090603,1568.5803142,5823.6246275,32.7585072,95.5580136,1.2220253,226.1515856),(9825,'Cervus_giganteus-radius.tif',249,3,51,613.6833638,112.950775,109.5640644,1.8,113.8385708,107.3800165,-1.0488798,15.705029,36.2116839,25517.0669186,197536.9054474,76.8592831,5455.059919,1624.7704427,6140.3786544,32.4725806,96.474287,1.2490458,228.4348224),(9826,'Cervus_giganteus-radius.tif',249,3,52,635.2492509,112.8682022,110.2052664,1.8,113.6594401,108.061722,-1.053323,15.6810036,37.1182839,26575.1862531,214395.2504187,79.9657992,5776.0011404,1694.7375918,6470.9251628,31.9165505,97.4331168,1.2615974,228.4348224),(9827,'Cervus_giganteus-radius.tif',249,3,53,661.0298899,112.7657496,110.783784,1.8,113.4786466,108.7598496,-1.0609296,16.1368921,38.1295907,27879.1292962,231740.5004358,83.9283761,6077.7075349,1727.6641053,6795.4378458,31.5679991,98.3826024,1.260095,230.6137994),(9828,'Cervus_giganteus-radius.tif',249,3,54,689.9730476,112.6686117,111.4986857,1.8,113.2895366,109.5294388,-1.0655662,16.1475464,39.179694,29395.9743894,251867.2117145,88.0561376,6428.5140158,1820.460748,7165.1774417,31.2427107,99.5996031,1.25041,232.2893656),(9829,'Cervus_giganteus-radius.tif',249,3,55,716.0590004,112.4642473,112.3638503,1.8,113.1250167,110.2842886,-1.0724543,15.905148,39.8808327,30655.7109531,269602.3587877,92.0785964,6760.1988381,1927.4080877,7521.4402037,30.6262924,100.1541811,1.2341215,233.001296),(9830,'Cervus_giganteus-radius.tif',249,3,56,722.5808663,112.149088,112.9784341,1.8,112.8065732,111.0441859,-1.0893491,15.7615308,40.7549343,30572.8756403,274924.4259161,94.606703,6745.794854,1939.7148694,7494.0059619,30.3708956,100.8458612,1.2274858,235.0760132),(9831,'Cervus_giganteus-radius.tif',249,3,57,717.6475611,111.8079418,113.5218181,1.8,112.5518964,111.2989047,-1.1040885,15.5314922,41.4699928,29730.9411893,276551.998331,95.3928538,6668.7254898,1914.2359855,7384.914613,29.6533996,84.205694,1.3233424,206.2816776),(9832,'Cervus_giganteus-radius.tif',249,3,58,737.6364131,111.1988873,114.8245888,1.8,111.958629,112.4852702,-1.1171745,15.0204136,41.3735556,29536.3854505,294551.7074373,99.3300929,7119.3230315,1966.4162576,7831.8895196,28.4581924,83.3727609,1.3208177,204.814631),(9833,'Cervus_giganteus-radius.tif',249,3,59,800.2868437,110.1624506,117.0008288,1.8,110.8593993,114.6705703,-1.1239119,14.9585569,40.0389963,30828.8115222,339254.0292829,108.4708044,8473.0902557,2060.9482424,9163.337624,28.1796167,100.9410196,1.2005663,242.914657),(9834,'Cervus_giganteus-radius.tif',249,3,60,860.6670308,109.1864145,119.1736952,1.8,110.034756,116.2702471,-1.1227504,14.8352,41.320462,32975.2792564,385188.914939,116.5247511,9321.989556,2222.7728081,9967.2152281,27.731417,101.4973636,1.1336577,243.0189168),(9835,'Cervus_giganteus-radius.tif',249,3,61,869.6276028,108.8953059,119.9076024,1.8,109.7940172,117.2139893,-1.1230961,14.527955,41.9195356,34580.181877,405541.9642274,117.7770278,9674.2952467,2380.2511644,10362.3768787,27.3104569,100.8852164,1.1071487,247.1072773),(9836,'Cervus_giganteus-radius.tif',249,3,62,878.9516196,108.5291653,120.8093341,1.8,109.5952168,117.8520962,-1.1228966,14.5462357,42.7061617,36027.9121418,418792.0948395,119.0169952,9806.3623152,2476.7859525,10533.1397795,27.3400322,74.2515292,1.3904252,194.6927503),(9837,'Cervus_giganteus-radius.tif',249,3,63,919.3070354,108.2522414,121.9399713,1.8,109.2785556,119.0563371,-1.1312793,14.3811925,43.6093676,39400.8155102,432607.4888775,125.4773901,9920.0587489,2739.7460575,10718.616114,27.1430369,98.1204575,1.1561291,277.9152561),(9838,'Cervus_giganteus-radius.tif',249,3,64,987.9984501,108.0806749,123.0888379,1.8,109.1437891,119.8990012,-1.1431965,14.4660676,44.47176,43236.6243148,444005.1293816,136.3493752,9983.9792508,2988.8305075,10860.2391992,27.4895848,96.8782086,1.1746405,237.697327),(9839,'Cervus_giganteus-radius.tif',249,3,65,977.2686021,108.3356204,122.6364811,1.8,109.2903139,119.6570119,-1.146025,14.2049701,43.7605198,42033.1341584,416963.544413,135.2154299,9528.304188,2959.0441865,10403.5831182,27.5078577,94.4971749,1.2130901,225.1447639),(9840,'Cervus_giganteus-radius.tif',249,3,66,923.4932533,108.8365202,121.0393264,1.8,109.629025,118.5635021,-1.1358765,13.665958,41.9746768,39560.1055533,368615.5954628,126.5916133,8781.8566646,2894.7919834,9656.1174231,27.015508,91.5971471,1.2312435,216.5078181),(9841,'Cervus_giganteus-radius.tif',249,3,67,870.0754188,109.4555222,119.1230677,1.8,110.1791369,116.7889926,-1.1236366,13.5357968,40.037197,37686.6818846,323155.7694646,117.8988212,8071.388446,2784.2233783,8949.7972172,26.9452602,86.1993119,1.2143594,205.274856),(9842,'Cervus_giganteus-radius.tif',249,3,68,830.4555088,109.9703167,117.5316753,1.8,110.5911478,115.4758201,-1.1120463,13.5881535,38.2445162,36113.9737799,293683.408472,111.2676919,7679.0985413,2657.7543222,8573.1129052,26.8457085,82.1063956,1.1844591,199.7626348),(9843,'Cervus_giganteus-radius.tif',249,3,69,794.9130518,110.3722697,116.2034827,1.8,110.9090501,114.4242744,-1.1027162,13.4014322,36.7210101,34660.0231651,268974.0292323,105.5170588,7324.7992955,2586.2924616,8228.1700225,26.9157974,78.8345759,1.1852293,193.4342233),(9844,'Cervus_giganteus-radius.tif',249,3,70,772.7106886,110.7879374,115.0053153,1.8,111.1203608,113.5861334,-1.0932815,13.4393678,35.4986238,33635.6345999,251969.3824777,101.5846988,7098.0042498,2502.7691152,8007.0767162,26.8363057,76.0559904,1.1703555,189.8924595),(9845,'Cervus_giganteus-radius.tif',249,3,71,752.7969762,111.0969266,113.9557971,1.8,111.3199927,112.779656,-1.0869669,13.4732574,34.447121,32896.6879379,237412.5878525,98.3171132,6892.0879532,2441.6284052,7807.4898416,26.6777422,73.5758371,1.1751067,185.1353545),(9846,'Cervus_giganteus-radius.tif',249,3,72,739.1325459,111.3605046,113.0502378,1.8,111.4381364,112.1129489,-1.0806584,13.3741333,33.343048,32291.9973573,225155.1839398,95.8897202,6752.6875119,2414.5113946,7688.6307282,26.6525188,71.5156273,1.13671,179.8748386),(9847,'Cervus_giganteus-radius.tif',249,3,73,730.8693226,111.5987311,112.2023769,1.8,111.5437164,111.5085256,-1.0759699,13.3178419,32.2937384,31667.7823427,215778.4241777,94.3418349,6681.7418738,2377.8463934,7635.1432811,26.4228223,69.5723131,1.1237218,176.4373346),(9848,'Cervus_giganteus-radius.tif',249,3,74,721.997262,111.7442736,111.5483565,1.8,111.5690444,111.025786,-1.0712945,13.2430555,31.6623189,31112.3218516,206512.6254399,92.7249298,6522.3468249,2349.3310824,7476.5506729,26.3195999,67.7109767,1.152572,171.4285242),(9849,'Cervus_giganteus-radius.tif',249,3,75,713.1800874,111.8395646,110.9822596,1.8,111.5148148,110.6333573,-1.0659845,13.1902603,30.9271597,30700.8155436,197677.5999842,91.0599862,6391.7153048,2327.5367467,7362.083361,26.229419,66.3029614,1.092657,170.9251134),(9850,'Cervus_giganteus-radius.tif',249,3,76,710.1911227,111.9751033,110.3642126,1.8,111.5224674,110.2200755,-1.0590675,13.2423841,30.1274298,30610.6140026,190274.1422779,89.9821902,6315.6446963,2311.5636705,7315.4914298,26.2814613,64.98525,1.0746158,164.4492563),(9851,'Cervus_giganteus-radius.tif',249,3,77,714.1008405,112.1289624,109.8776657,1.8,111.5726666,109.9294149,-1.0523514,13.2077323,29.6413678,30896.8919074,184607.5761412,89.7922299,6228.0383659,2339.3033202,7255.3385405,26.294169,63.6895613,1.0558343,162.9822097),(9852,'Cervus_giganteus-radius.tif',249,3,78,713.4732603,112.2594296,109.5087864,1.8,111.6424798,109.6591723,-1.0466324,13.2887257,29.0521037,31060.935301,178378.5879848,89.1259424,6139.9542739,2337.3900507,7200.2514042,26.4969948,62.6873417,1.0703555,160.1523763),(9853,'Cervus_giganteus-radius.tif',249,3,79,718.9166528,112.3744583,109.1895974,1.8,111.6680703,109.4243014,-1.0398736,13.3072978,28.7276859,31294.8030256,173281.4985766,89.1014154,6031.8641415,2351.7023086,7113.868168,26.5039265,61.4589047,1.035173,157.1140233),(9854,'Cervus_giganteus-radius.tif',249,3,80,721.6436642,112.4282427,108.9406782,1.8,111.6256438,109.2509493,-1.029577,13.2742832,28.2771984,31509.2549342,168907.2588298,88.3518116,5973.2671039,2373.7067005,7085.2390669,26.5466424,60.5006202,1.0340309,154.4316355),(9855,'Cervus_giganteus-radius.tif',249,3,81,729.8822699,112.4264333,108.6339251,1.8,111.6034158,108.9879337,-1.0126028,13.4685725,27.798607,31858.4843931,162812.1456846,87.5208885,5856.8454767,2365.3942914,7002.8826697,26.6361444,59.3234049,1.0390723,152.2094727),(9856,'Cervus_giganteus-radius.tif',249,3,82,735.3760165,112.5181026,108.452081,1.8,111.6669501,108.9616703,-1.0035942,13.7678209,27.5952576,32242.9015492,159403.0745621,87.1832603,5776.4662737,2341.9030431,6919.1843664,26.934802,58.5291214,1.0051932,153.9282247),(9857,'Cervus_giganteus-radius.tif',249,3,83,742.5977488,112.5680227,108.398432,1.8,111.7429391,108.8836119,-0.9959099,14.0801001,27.2872084,32778.7561067,156226.533139,87.1744632,5725.2662441,2328.0201007,6870.9016688,27.4197383,57.7079147,1.0137755,152.7128835),(9858,'Cervus_giganteus-radius.tif',249,3,84,748.3759402,112.6291417,108.3310788,1.8,111.7530977,108.9265296,-0.9907225,14.4311746,27.1930068,33480.0511338,153887.3017971,87.2608881,5659.0763624,2319.9810174,6807.8543134,27.8071996,56.8910811,1.022605,150.0304956),(9859,'Cervus_giganteus-radius.tif',249,3,85,753.1591342,112.6653349,108.3552923,1.8,111.7757887,108.9952196,-0.9889507,14.8589791,26.9555181,34004.8016362,151559.8789588,87.6145377,5622.5919497,2288.5018816,6759.8428373,28.3016138,56.3874444,1.0081583,150.5339065),(9860,'Cervus_giganteus-radius.tif',249,3,86,760.0632438,112.713295,108.413489,1.8,111.7609864,109.1649863,-0.987603,15.2697178,26.975803,34822.7383215,149767.9265864,88.2608285,5551.935804,2280.509621,6695.7521211,28.7542112,55.79495,1.0105644,154.6833409),(9861,'Cervus_giganteus-radius.tif',249,3,87,770.7046923,112.6837707,108.5935127,1.8,111.756459,109.4037252,-0.9851965,15.925978,26.901007,35777.2419613,148562.5861984,89.2120805,5522.5659742,2246.4706422,6684.5839588,29.447055,55.3013635,0.995724,157.3657287),(9862,'Cervus_giganteus-radius.tif',249,3,88,774.0079227,112.6935077,108.7464395,1.8,111.7619233,109.6552749,-0.984622,16.5513228,26.7841803,36798.580381,147229.3659903,89.5261537,5496.8778047,2223.3014686,6666.2664592,30.1961587,54.7072313,0.9980431,156.4020929),(9863,'Cervus_giganteus-radius.tif',249,3,89,786.2844255,112.6543033,108.9922218,1.8,111.7685717,109.9366753,-0.9844519,17.403204,26.7724297,38214.23088,146831.9692781,90.9255709,5484.4469065,2195.8158267,6713.5795482,31.0991818,54.351711,0.9652517,157.3657287),(9864,'Cervus_giganteus-radius.tif',249,3,90,791.6902202,112.5851962,109.2659948,1.8,111.6765745,110.3166437,-0.9828792,18.3958893,27.0339455,40196.8070254,147231.379361,91.3592795,5446.1669099,2185.0972483,6793.6821026,32.3350192,53.9989788,0.9607223,158.6242557),(9865,'Cervus_giganteus-radius.tif',249,3,91,803.6294063,112.5293737,109.6683567,1.8,111.6793126,110.8385038,-0.9855194,19.7434807,26.9333954,43387.2386126,148807.2114599,93.0630811,5525.0075033,2197.5475938,6940.7078279,33.9356773,53.7539521,0.8873165,163.1296553),(9866,'Cervus_giganteus-radius.tif',249,3,92,823.3290018,112.569196,110.3079092,1.8,111.8008933,111.5566098,-1.0077706,21.7528291,27.3031334,48821.5057364,150659.5424662,98.1289925,5518.0312254,2244.3749995,7142.0243415,36.498356,53.5198789,1.0028356,165.9163029),(9867,'Cervus_giganteus-radius.tif',249,3,93,847.8431228,112.5583768,110.9661913,1.8,111.8773875,112.2320902,-1.0246819,23.4603676,27.7120461,55115.7985238,153441.6798358,103.1901405,5537.0029137,2349.3152186,7438.955424,38.9350737,53.5112538,0.9738853,155.1867517),(9868,'Cervus_giganteus-radius.tif',249,3,94,862.5703607,112.5895856,111.580668,1.8,111.9551514,112.8822815,-1.0441507,25.3111191,27.9335697,61027.1539153,153667.3723739,107.4412989,5501.1720245,2411.0808294,7571.7138128,41.5234065,53.5991651,0.8534746,161.3677175),(9869,'Cervus_giganteus-radius.tif',249,3,95,871.9643697,112.5925406,112.1214931,1.8,111.9486157,113.3174817,-1.0579225,25.6135718,28.0790295,67940.1748922,153213.6766672,110.3368992,5456.5160976,2652.5068557,7760.5077492,42.3553053,53.8483251,0.8362019,169.7276603),(9870,'Cervus_giganteus-radius.tif',249,3,96,877.2791913,112.5690895,112.4683146,1.8,112.0175325,113.6652826,-1.0549434,25.7111872,27.9578251,73639.8092816,152083.2474728,110.6362899,5439.738145,2864.1154853,7864.8956437,42.6668845,53.6439272,0.8647765,180.1012464),(9871,'Cervus_giganteus-radius.tif',249,3,97,858.7693518,112.4980718,112.7210163,1.8,111.96588,113.8012298,-1.02427,28.2364053,27.5491356,78155.7480425,147041.0523943,104.4676248,5337.4107423,2767.9071502,7059.3094375,42.7693756,54.1372781,0.8303118,172.1583427),(9872,'Cervus_giganteus-radius.tif',249,3,98,16.0996115,118.2768781,135.7404943,1.8,117.8171935,135.4318961,0.4112248,3.471144,14.7014089,22.0300901,1652.8185119,0.4287486,112.4258582,6.3466367,113.1983815,0,0,0,0),(9873,'Cervus_giganteus-radius.tif',249,3,99,56.5340833,118.0021577,135.4714814,1.8,117.3962227,135.1546819,0.3980118,4.7013779,16.7178041,154.6776376,6299.4878728,1.4154547,376.8131162,32.9004905,385.1263634,7.4593463,14.1731922,2.896614,39.419627),(9874,'Cervus_giganteus-radius.tif',249,3,100,109.0008404,117.0383625,135.3358522,1.8,116.0844655,135.0503322,0.376614,5.9458346,21.6303906,456.796422,14123.8786597,2.4571995,652.9645686,76.826292,654.4544882,8.6640175,16.8840596,2.8842689,44.2199179),(9875,'Cervus_giganteus-radius.tif',249,3,101,192.3834618,114.4505309,134.9132554,1.8,112.5175978,134.2543215,0.3350144,8.2496663,29.2032907,1203.8008522,33121.4981606,3.4660482,1134.1700649,145.9211562,1173.778749,12.3333941,25.5402443,2.9210989,67.2503268),(9876,'Cervus_giganteus-radius.tif',249,3,102,280.8970563,112.4886018,134.6132682,1.8,110.9288039,134.0691753,0.3399574,8.5767099,29.4391874,2210.8287646,60887.6590645,5.2053432,2068.2520261,257.7711959,2143.2684789,14.0684942,30.9912007,2.8461518,77.2679476),(9877,'Cervus_giganteus-radius.tif',249,3,103,370.0674923,111.7787842,134.8301083,1.8,110.7385342,134.5762642,0.348956,10.0239346,31.9631573,3785.8530697,93965.3220296,7.2105924,2939.8010081,377.6813427,3058.1138644,16.2784883,34.7861566,2.8276544,85.2540371),(9878,'Cervus_giganteus-radius.tif',249,3,104,477.1824589,110.853475,135.7017978,1.8,109.733093,136.2482065,0.3591229,40.9105647,33.963244,16039.3436196,138358.1590197,9.8235468,4073.7615899,392.0587194,3745.8380397,19.8840556,64.9511474,2.7549438,166.9052364),(9879,'Cervus_giganteus-radius.tif',249,3,105,602.8825165,110.5732025,137.8007716,1.8,110.2149729,139.1315762,0.3890427,39.4056526,36.7078353,44409.6951405,188197.7950854,14.4561833,5126.9107456,1126.987938,5829.059423,23.3316357,68.6708111,2.722733,175.7075161),(9880,'Cervus_giganteus-radius.tif',249,3,106,841.6305991,112.0357052,142.0747878,1.8,111.7112375,143.1010957,0.5143703,37.1417495,41.8369246,93086.0786358,299489.7568715,33.9529186,7158.503152,2506.2383922,9365.4890169,34.079051,74.5938869,2.4992436,219.0680579),(9881,'Cervus_giganteus-radius.tif',249,3,107,1078.6382753,112.7144937,144.636772,1.8,111.4845413,144.5987324,0.5152692,35.3018778,45.8815047,136567.8744176,421758.3931117,43.6527444,9192.3400461,3868.5725169,12143.5107445,35.627313,77.0975715,2.7103526,219.9885079),(9882,'Cervus_giganteus-radius.tif',249,3,108,1238.9569596,111.5879562,145.7479618,1.8,110.0716807,145.5446868,0.4666147,33.7192417,46.9974479,177889.1181422,505406.6180259,41.7897959,10753.9162415,5275.5966329,14513.3694997,37.5245537,79.7924954,2.7550863,232.7927764),(9883,'Cervus_giganteus-radius.tif',249,3,109,1405.7070401,109.864894,146.7243694,1.8,108.7676763,146.5704094,0.4048136,31.5825902,47.3482882,219409.6740827,576296.9671117,36.3412224,12171.4424952,6947.1716121,16804.6830876,51.4280806,82.2097702,2.8281064,323.9149999),(9884,'Cervus_giganteus-radius.tif',249,3,110,1580.2972015,108.3054659,147.636538,1.8,107.1589801,147.531295,0.3511388,33.3534093,47.726898,259562.7437181,661646.0537809,31.1617487,13863.1690101,7782.1952661,19291.5144064,51.3955675,84.5383165,2.8423463,266.0314376),(9885,'Cervus_giganteus-radius.tif',249,3,111,1768.3987166,106.4437718,148.5365532,1.8,105.4043013,148.243555,0.2639161,30.446487,47.5523286,308596.1234195,777800.5819051,20.0564419,16356.7296079,10135.6890108,22785.4495751,51.4571326,86.8830843,2.9374077,282.2121361),(9886,'Cervus_giganteus-radius.tif',249,3,112,1953.3962917,104.4643173,149.0752916,1.8,103.488419,148.4946626,0.2004897,28.1856512,46.7457349,345733.4085138,916176.79393,12.9120937,19599.1526329,12266.2913217,26818.0751152,51.8065168,88.7417564,2.9565421,283.5749229),(9887,'Cervus_giganteus-radius.tif',249,3,113,2183.9103564,100.9590631,149.009133,1.8,100.4720215,148.1389004,0.14473,28.4626994,45.8899386,380017.5271272,1157511.8902117,7.5712281,25223.653035,13351.4225486,32053.7203096,55.1256875,92.4078992,3.118341,293.6536177),(9888,'Cervus_giganteus-radius.tif',249,3,114,2348.0557301,97.751819,148.9309108,1.8,98.2600652,148.189348,0.1110978,29.9766439,49.817093,390554.1470568,1387408.2422112,4.810388,27850.0442086,13028.6148098,34448.5134784,55.5644229,95.8907291,0.1393622,271.3604369),(9889,'Cervus_giganteus-radius.tif',249,3,115,2455.9333379,95.2901632,148.8677656,1.8,98.1167621,148.101078,0.0837886,30.6661396,52.9950774,397740.1680327,1584076.6764887,2.8669389,29891.0154537,12970.0109973,36435.3079239,55.7108999,96.3287289,0.1027756,273.1834487),(9890,'Cervus_giganteus-radius.tif',249,3,116,2413.9024726,94.8482065,148.6725943,1.8,97.9634147,147.9795666,0.0790789,30.5868545,53.6766137,402098.2470519,1619534.0450256,2.5106353,30172.0606912,13146.1130382,36847.7717589,55.6809082,97.0238937,0.0842446,271.9681075),(9891,'Cervus_giganteus-radius.tif',249,3,117,2322.2865606,94.8197063,148.5745928,1.8,98.0242827,147.9891941,0.0760779,30.1123392,53.9038177,401067.4196349,1617358.5013126,2.2358543,30004.5260118,13319.038994,36780.1511601,53.8882237,97.2282458,0.1062649,269.1814599),(9892,'Cervus_giganteus-radius.tif',249,3,118,2269.3916256,95.0078259,148.440576,1.8,98.1315909,147.9744062,0.0730427,30.4430546,54.1442467,404211.2148658,1630061.9326878,2.0143702,30105.9121153,13277.6168355,37036.0388153,53.8582319,97.6110805,0.1014207,275.9522082),(9893,'Cervus_giganteus-radius.tif',249,3,119,2230.6947627,95.139968,148.278254,1.8,97.9989787,147.8416579,0.07689,30.7348246,54.4253719,406214.101203,1651567.1330332,2.1936757,30345.5369503,13216.7372364,37369.0404938,56.1623865,98.2736952,0.078784,294.9374424),(9894,'Cervus_giganteus-radius.tif',249,3,120,2195.3721294,95.3514041,148.2534613,1.8,97.9335376,147.8175059,0.0819437,30.6493754,54.4607283,405576.079912,1661945.7292561,2.4514113,30516.4065889,13232.7681898,37691.605897,56.1811292,98.6094181,0.0654087,286.491128),(9895,'Cervus_giganteus-radius.tif',249,3,121,2172.9030013,95.5692329,148.280285,1.8,97.8789513,147.8095969,0.0862998,30.6269336,54.4454431,405537.8730855,1654067.4447376,2.690482,30380.273389,13241.2169744,37746.3619792,56.1811292,98.5120076,3.0935946,279.3033405),(9896,'Cervus_giganteus-radius.tif',249,3,122,2138.2218795,95.5080449,148.3072975,1.8,97.6668464,147.8360986,0.0945221,30.8385726,54.4471944,402896.9005744,1611625.6042699,3.1744971,29599.7915212,13064.70654,36956.2338273,54.5353766,97.8453459,3.0624631,273.9385649),(9897,'Cervus_giganteus-radius.tif',249,3,123,2103.1832435,95.0429469,148.2238449,1.8,97.1856509,147.7966861,0.1056914,30.7051531,54.3483758,398066.6687595,1536345.1305064,3.90111,28268.4644543,12964.1649315,35592.7156657,54.5387413,96.8639139,2.9946768,270.2493555),(9898,'Cervus_giganteus-radius.tif',249,3,124,2055.8535021,94.3739159,147.9663267,1.8,96.4740198,147.627951,0.1132374,30.4042497,53.8559916,395303.1505831,1430402.8927894,4.3748509,26559.7726429,13001.5755682,33897.3826988,54.5855422,95.6700123,3.0651652,269.7459447),(9899,'Cervus_giganteus-radius.tif',249,3,125,2017.7104226,93.7498144,147.7408112,1.8,95.9132661,147.3990234,0.1184346,28.6494296,53.0726193,391555.322226,1338809.7524076,4.694974,25225.9973451,13667.1245442,32601.5184324,55.0424429,94.2673198,3.0823015,273.6004879),(9900,'Cervus_giganteus-radius.tif',249,3,126,1961.9447432,93.1122695,147.697996,1.8,95.4829712,147.4832644,0.12053,29.0900892,52.3778996,383641.0037058,1255465.1342727,4.7273899,23969.3676885,13188.0311926,31287.7493069,55.517569,92.6383818,3.067311,272.1945152),(9901,'Cervus_giganteus-radius.tif',249,3,127,1927.8209297,92.6533816,147.7613244,1.8,95.1259967,147.7194818,0.1224711,29.4144657,51.6490845,374223.7251321,1203908.0852115,4.7952391,23309.379013,12722.4383137,30554.5419573,56.2034003,91.2760892,2.990375,273.8090075),(9902,'Cervus_giganteus-radius.tif',249,3,128,1876.0821253,92.0942765,147.8788889,1.8,94.805733,147.8218624,0.1255027,29.6665369,51.5466466,361933.1818079,1157110.4693461,4.8992038,22447.8321223,12200.0482659,29441.5347195,55.8654771,90.8218554,3.0278006,265.7186582),(9903,'Cervus_giganteus-radius.tif',249,3,129,1725.6923228,91.3626658,147.6648868,1.8,93.7727027,147.6814728,0.1321487,30.7149657,51.0062314,340960.4833032,1076258.6940102,4.9935418,21100.5334807,11100.7932414,27757.1049616,56.8583945,89.8294604,3.0409721,263.1405302),(9904,'Cervus_giganteus-radius.tif',249,3,130,1663.4516068,91.1294231,147.5518828,1.8,93.570709,147.6463974,0.1341609,30.074982,50.6495194,332262.0007293,1035899.0946608,4.9602536,20452.298601,11047.7871839,26946.6595612,55.8366835,89.6731171,3.0600431,257.5240491),(9905,'Cervus_giganteus-radius.tif',249,3,131,1628.5893222,90.8012143,147.556659,1.8,93.461354,147.7944016,0.1329943,29.87961,50.1293815,322920.5865891,995721.3114656,4.7727035,19863.028052,10807.3896169,26245.5081599,55.5756686,88.8529962,3.0544354,257.2723437),(9906,'Cervus_giganteus-radius.tif',249,3,132,1589.8269429,90.5298342,147.6747336,1.8,93.3271507,148.0478202,0.132249,30.5210169,49.6146081,309980.3349061,950902.9349624,4.6073363,19165.7854647,10156.2911723,25364.996637,53.9773396,88.0902327,2.9700287,252.0118279),(9907,'Cervus_giganteus-radius.tif',249,3,133,1550.9775629,90.3818867,147.807609,1.8,93.2688023,148.2645425,0.1285704,30.2726104,49.1653982,298284.869739,903311.4753235,4.2495381,18372.9108128,9853.2919873,24401.8093606,53.8390196,87.4549684,2.9837136,244.633409),(9908,'Cervus_giganteus-radius.tif',249,3,134,1522.4054592,90.3990361,147.9010708,1.8,93.3621155,148.4218818,0.1270422,29.5759454,48.4338553,288600.2185286,864191.2315839,4.073214,17842.7099362,9757.9372286,23796.0913356,53.3186066,86.5541398,3.0221637,246.812386),(9909,'Cervus_giganteus-radius.tif',249,3,135,1486.0163257,90.3654054,148.0451405,1.8,93.279523,148.5925055,0.1264425,29.6728377,47.8128771,276500.1741516,824961.7521977,3.9386107,17253.9659158,9318.292278,23009.1419249,52.5093475,85.8655978,3.0060649,248.2794326),(9910,'Cervus_giganteus-radius.tif',249,3,136,1457.8865549,90.3555165,148.1614346,1.8,93.3263735,148.7230366,0.1263238,30.0609522,47.2190853,266035.331547,791567.4624318,3.8568387,16763.7186797,8849.8637563,22392.6097725,52.151731,84.9011739,3.0147267,247.7760218),(9911,'Cervus_giganteus-radius.tif',249,3,137,1424.9239075,90.4693203,148.3021388,1.8,93.4384761,148.8836631,0.1298103,30.1131807,46.5539615,254606.1531462,755353.1601668,3.9794051,16225.3251064,8454.9737757,21694.3544101,52.0000357,83.6424977,3.0593047,248.5311381),(9912,'Cervus_giganteus-radius.tif',249,3,138,1394.2275312,90.7264267,148.452411,1.8,93.6141283,149.0437726,0.1334292,29.7820598,45.7955557,245965.0933326,716358.3660223,4.1124948,15642.5302484,8258.8341905,21010.8508956,51.1770905,81.5502099,3.0041665,231.6385091),(9913,'Cervus_giganteus-radius.tif',249,3,139,1368.9720857,90.7463605,148.6015558,1.8,93.5467429,149.1692181,0.1363409,29.5428152,45.193849,237212.6938901,684943.5106558,4.2150518,15155.679924,8029.4546263,20396.7366204,50.5275249,80.4630226,2.9861013,228.7044159),(9914,'Cervus_giganteus-radius.tif',249,3,140,1339.4438691,90.6794585,148.7425725,1.8,93.3490422,149.3746127,0.1389256,29.6775859,44.6990893,228004.3520529,653359.6590781,4.2809666,14616.8449963,7682.7122371,19717.5454233,49.9402554,79.1232861,2.9889433,226.5254389),(9915,'Cervus_giganteus-radius.tif',249,3,141,1322.2129683,90.6044204,148.7871598,1.8,93.1246896,149.3219125,0.1418685,29.2299924,44.2205441,222386.9200125,627565.2403066,4.4056138,14191.7123064,7608.1757722,19217.6898747,49.2315654,78.1465339,2.9981404,226.4822531),(9916,'Cervus_giganteus-radius.tif',249,3,142,1298.7104057,90.6182176,148.8982048,1.8,92.8325875,149.3499273,0.1468375,28.4582625,43.5875223,215139.4032259,603141.3798423,4.633526,13837.4779714,7559.8221498,18770.7984029,48.9518287,77.2124355,2.9682099,223.1921947),(9917,'Cervus_giganteus-radius.tif',249,3,143,1278.7335828,90.6267246,149.0256504,1.8,92.6615181,149.4033672,0.1525124,27.993738,43.0730937,208512.2065405,581517.2504483,4.9189147,13500.7077639,7448.5303282,18341.5975147,48.9288452,76.3660881,2.9662686,217.5757136),(9918,'Cervus_giganteus-radius.tif',249,3,144,1262.705642,90.6484137,149.1368095,1.8,92.5641913,149.4890598,0.157117,24.916712,42.5420887,203876.8013562,562635.8318338,5.1525308,13225.3927564,8182.3316534,18015.4162329,47.9319147,75.595786,2.9932648,218.0791245),(9919,'Cervus_giganteus-radius.tif',249,3,145,1237.4268097,90.7210573,149.1520729,1.8,92.5003156,149.4855281,0.1633273,24.6401732,41.6149195,196204.1234615,538023.6267558,5.4528128,12928.6235063,7962.7737038,17640.0186313,47.348289,74.5257889,2.9736004,211.750713),(9920,'Cervus_giganteus-radius.tif',249,3,146,1222.3486036,90.7596461,149.2246567,1.8,92.0165705,149.3269179,0.1670877,24.3841692,41.2092064,192045.2470571,524161.5998242,5.6349148,12719.5266574,7875.8166886,17378.2931434,46.8655032,73.9075857,2.954459,205.9867864),(9921,'Cervus_giganteus-radius.tif',249,3,147,1213.8144192,90.8062303,149.3172279,1.8,91.7832999,149.3062421,0.1707317,24.2221477,40.7218942,188519.5670201,511525.1472446,5.8399011,12561.4281189,7782.9418434,17188.3351906,46.5126576,73.3295027,2.9648838,205.7782668),(9922,'Cervus_giganteus-radius.tif',249,3,148,1210.4718566,90.8882285,149.3827547,1.8,91.6146522,149.108894,0.1748164,27.5175898,40.3528835,186484.2646108,502571.6625268,6.1029415,12454.417598,6776.9112828,17075.7542279,46.6162132,72.9065451,2.9638477,201.837352),(9923,'Cervus_giganteus-radius.tif',249,3,149,1198.3821117,90.8505468,149.4958739,1.8,91.5228735,149.2010325,0.178368,27.6127082,39.9467908,182443.2900291,491304.7617975,6.2873443,12298.9795077,6607.2218983,16865.9662834,46.9310063,72.3357772,2.9744909,200.1796739),(9924,'Cervus_giganteus-radius.tif',249,3,150,1191.9981042,90.7995821,149.5667515,1.8,91.4460903,149.3141547,0.181969,23.3542769,39.7499038,179040.378027,483215.3291088,6.5060932,12156.3898903,7666.2779398,16645.870895,45.319091,71.9852454,2.967612,192.6359213),(9925,'Cervus_giganteus-radius.tif',249,3,151,1188.8319489,90.7227405,149.64223,1.8,91.4446405,149.3845878,0.1833558,23.4272397,39.4652006,176639.0094694,475625.4813049,6.5869743,12051.7690186,7539.8984852,16518.4481719,45.116303,71.4885143,2.9724914,197.3930263),(9926,'Cervus_giganteus-radius.tif',249,3,152,1182.2414895,90.651084,149.762907,1.8,91.3611211,149.548303,0.1865083,23.1022101,39.0866662,172741.3308288,468600.96426,6.7750037,11988.7677742,7477.2643109,16396.3111463,44.2956995,70.9935091,2.977439,197.4362121),(9927,'Cervus_giganteus-radius.tif',249,3,153,1180.9125883,90.6482527,149.8347589,1.8,91.383165,149.6054645,0.1898414,22.7148608,38.7298214,170217.9611674,462723.5186557,7.0084924,11947.4735875,7493.6827931,16334.8036435,44.2754351,70.5329946,2.9453918,193.3910375),(9928,'Cervus_giganteus-radius.tif',249,3,154,1177.7386002,90.632643,149.9349628,1.8,91.3911506,149.7133347,0.1939307,23.0722502,38.4722212,167031.7783786,456617.8768946,7.2902024,11868.7682292,7239.5096649,16170.2502599,44.1888039,70.2181721,2.9694018,193.3910375),(9929,'Cervus_giganteus-radius.tif',249,3,155,1172.3465689,90.6057939,150.0375665,1.8,91.3995295,149.8666595,0.198334,22.9235151,38.2140747,162992.7085809,450422.6121024,7.5857279,11786.8250346,7110.2842652,16028.7953856,43.2634561,69.870229,2.9622892,193.7901885),(9930,'Cervus_giganteus-radius.tif',249,3,156,1166.9966113,90.6277237,150.1690898,1.8,91.4172413,149.9735076,0.2035846,22.2018651,37.8207217,159138.9859419,445002.6217963,7.9505963,11766.1060423,7167.8206005,15954.1738851,43.1623279,69.5258559,2.9551058,193.5384831),(9931,'Cervus_giganteus-radius.tif',249,3,157,1166.287905,90.6301393,150.2929529,1.8,91.3612228,150.1199008,0.2104868,22.5014917,37.5092867,155535.073562,441578.859982,8.4855666,11772.5208717,6912.211665,15849.4591641,43.029202,69.2984315,2.9733859,194.3546733),(9932,'Cervus_giganteus-radius.tif',249,3,158,1165.5004225,90.6346245,150.3807966,1.8,91.3386443,150.2004517,0.2161158,22.5683721,37.2302504,152433.9159359,437937.2673548,8.9322758,11762.9417545,6754.3159582,15809.9213019,42.8489492,69.0248006,2.9600688,192.5316615),(9933,'Cervus_giganteus-radius.tif',249,3,159,1166.5514808,90.6717549,150.4752028,1.8,91.3224007,150.3042723,0.2206674,22.1964888,36.8346241,149456.1741789,434853.4271064,9.3146893,11805.5616897,6733.3250581,15822.9401735,42.360469,68.6815649,2.9527858,189.3890487),(9934,'Cervus_giganteus-radius.tif',249,3,160,1164.8033536,90.7077743,150.6076814,1.8,91.3731145,150.439946,0.2243086,22.8763659,36.6646626,145935.9961264,431376.770892,9.6049953,11765.464066,6379.3347678,15682.4127091,42.0658651,68.6022163,2.958938,187.9220021),(9935,'Cervus_giganteus-radius.tif',249,3,161,1158.5872491,90.7673037,150.7156543,1.8,91.4231009,150.5266465,0.2290441,27.2238362,36.0501155,140553.7975336,423569.5013602,9.9542379,11749.4630775,5162.8946258,15558.233696,41.6280866,68.0279029,2.9702135,181.5504048),(9936,'Cervus_giganteus-radius.tif',249,3,162,1159.3456382,90.8363464,150.8482605,1.8,91.4282067,150.6906865,0.2313508,26.2440086,35.7222582,137826.7798621,420170.4283702,10.1587816,11762.1463435,5251.7426693,15480.5655476,41.1107498,67.7559534,2.9952113,180.4393234),(9937,'Cervus_giganteus-radius.tif',249,3,163,1157.7518742,90.8873077,151.0123162,1.8,91.4026566,150.8626396,0.2335554,27.5607754,35.4287968,134277.2890336,415332.6677384,10.3355378,11723.0249335,4872.0432157,15404.7675127,40.4561787,67.462385,2.9816795,179.328242),(9938,'Cervus_giganteus-radius.tif',249,3,164,1156.5794624,90.9076413,151.1729797,1.8,91.399452,150.9910565,0.2352594,27.7405595,35.0466565,131112.8968885,410414.8941815,10.473485,11710.5291817,4726.3969845,15356.706444,39.7532999,67.0382142,2.9806589,176.8975596),(9939,'Cervus_giganteus-radius.tif',249,3,165,1150.067052,90.8921462,151.3506338,1.8,91.3863072,151.1438316,0.237158,28.0491456,34.8106041,127343.6689599,404049.0478609,10.5801095,11607.0679596,4540.0195328,15111.3520043,39.3736967,66.8437662,2.9996956,175.7864782),(9940,'Cervus_giganteus-radius.tif',249,3,166,1148.1049197,90.8807894,151.5197538,1.8,91.3186041,151.3373054,0.2388918,19.1970075,34.4571225,124293.6301922,399192.4897922,10.7140958,11585.1952008,6474.6357151,15053.6471077,38.7168121,66.3586314,3.00519,175.430513),(9941,'Cervus_giganteus-radius.tif',249,3,167,1149.3767529,90.9175989,151.6461271,1.8,91.3865232,151.4211429,0.2384275,28.5546077,34.1791124,122286.7476084,395357.9657867,10.6851002,11567.2391271,4282.5574444,14952.1264569,38.0508013,66.1468361,3.0309354,174.2151718),(9942,'Cervus_giganteus-radius.tif',249,3,168,1152.7952383,90.9393493,151.7746828,1.8,91.3602308,151.5375751,0.2372769,28.8562259,33.9301591,120944.0246054,391808.2253766,10.6156414,11547.4915604,4191.2627398,14965.0557127,37.7356096,65.8376815,2.9710792,172.6438654),(9943,'Cervus_giganteus-radius.tif',249,3,169,1156.0105728,90.9635075,151.8801202,1.8,91.3361057,151.7107976,0.2385803,18.8788432,33.6724362,119263.8466835,388207.3399901,10.7602863,11528.9353626,6317.3281026,14856.3370014,37.6093263,65.6312383,2.9904366,172.7481252),(9944,'Cervus_giganteus-radius.tif',249,3,170,1158.9792839,90.9667248,151.9827081,1.8,91.2402065,151.78975,0.2395877,18.8766989,33.4256816,117835.7025938,384429.0296822,10.8774673,11501.0079493,6242.389268,14864.9537137,37.3675486,65.272988,2.9829374,172.39216),(9945,'Cervus_giganteus-radius.tif',249,3,171,1163.3774927,90.9777576,152.0790018,1.8,91.2280866,151.909406,0.239898,18.7843121,33.2884557,116632.6524538,381279.9343944,10.9464997,11453.8186347,6209.0457214,14760.4949105,37.1160878,65.142742,2.9959643,171.532784),(9946,'Cervus_giganteus-radius.tif',249,3,172,1168.0622724,90.9591464,152.1677129,1.8,91.1937766,151.971579,0.2396738,18.6947753,33.073297,115693.8090976,378179.8878966,10.9704388,11434.598965,6188.563776,14790.1249692,36.9631507,64.8487322,2.9818905,170.9251134),(9947,'Cervus_giganteus-radius.tif',249,3,173,1173.8740892,90.9344917,152.223473,1.8,91.1329193,152.0202208,0.2402078,18.6322344,32.8770659,114942.0247904,375643.0451495,11.073259,11425.6864233,6168.9877118,14716.1354691,36.7850527,64.6562663,3.0015753,170.4217026),(9948,'Cervus_giganteus-radius.tif',249,3,174,1176.9692451,90.8978536,152.2571742,1.8,91.1062223,152.077087,0.2402199,18.4969275,32.6916766,114013.3788221,372033.1111587,11.1035573,11380.0560352,6163.9090429,14721.2728388,36.5556674,64.3571653,2.9874205,169.4580668),(9949,'Cervus_giganteus-radius.tif',249,3,175,1182.3311199,90.8614741,152.2980076,1.8,91.0579497,152.1179316,0.2398236,18.4513722,32.5150155,113378.7291854,368954.823682,11.118078,11347.2135213,6144.7315797,14627.0841301,36.4208681,64.171857,3.0072712,169.4580668),(9950,'Cervus_giganteus-radius.tif',249,3,176,1184.0404745,90.7908436,152.3571673,1.8,90.9823959,152.1748793,0.2399185,18.3764632,32.3558717,112611.7123324,365756.3909658,11.1427874,11304.1736008,6128.0405976,14635.4204489,36.4193254,63.9643671,3.0339028,168.7029506),(9951,'Cervus_giganteus-radius.tif',249,3,177,1183.5481231,90.6823404,152.3187559,1.8,90.9159974,152.1396889,0.2406881,18.3748943,32.1595539,111388.7377328,359773.3866872,11.2083433,11187.1385928,6062.0069823,14410.5327541,36.4193254,63.877714,3.0472787,168.4512451),(9952,'Cervus_giganteus-radius.tif',249,3,178,1182.9966335,90.5620456,152.3686167,1.8,90.8010384,152.2082103,0.2432668,22.7687043,32.0389493,110749.5110511,356533.3845609,11.4396883,11128.1234957,4864.1112566,14402.1443968,36.2953251,63.537185,3.0331759,167.7393148),(9953,'Cervus_giganteus-radius.tif',249,3,179,1183.7218448,90.4565082,152.4143621,1.8,90.645759,152.2469183,0.2459501,18.2003573,32.0117014,109795.8951531,353337.7368902,11.6954692,11037.7681203,6032.6230476,14244.2033875,36.0226411,63.537185,3.0331759,167.8435745),(9954,'Cervus_giganteus-radius.tif',249,3,180,1185.8000153,90.3568076,152.4611577,1.8,90.576029,152.3008029,0.2487819,18.218407,31.8757026,108997.8383089,350568.1264074,11.9817222,10997.9733019,5982.8413323,14249.1166071,36.0133848,63.2094275,3.018924,166.6282333),(9955,'Cervus_giganteus-radius.tif',249,3,181,1182.8192192,90.2419902,152.5168128,1.8,90.4906013,152.3588938,0.2516693,18.132131,31.7447195,107790.5290871,346668.138798,12.2247238,10920.4977731,5944.7248151,14073.3512864,35.8785855,63.110037,3.0324392,166.3765279),(9956,'Cervus_giganteus-radius.tif',249,3,182,1184.2125737,90.1399289,152.56476,1.8,90.3791352,152.3974009,0.2539231,18.0515469,31.6180072,107118.6129948,343861.620417,12.4545672,10875.4994744,5934.0406411,13942.448919,35.8538337,63.0222093,3.0459945,166.2722681),(9957,'Cervus_giganteus-radius.tif',249,3,183,1186.0523454,90.0414145,152.6023964,1.8,90.260208,152.4339542,0.2555766,17.9837635,31.5866634,106588.1014653,341329.6611889,12.6333445,10806.1322162,5926.9074282,13958.7439808,35.7465667,62.7829904,3.0180866,165.4128921),(9958,'Cervus_giganteus-radius.tif',249,3,184,1185.2030952,89.9360406,152.6528388,1.8,90.1626222,152.5047752,0.2576105,17.9870394,31.4675793,105791.3757151,338627.8657367,12.8215384,10761.1666755,5881.5335599,13829.5565311,35.6105297,62.6829237,3.0316924,165.1611867),(9959,'Cervus_giganteus-radius.tif',249,3,185,1186.1926096,89.8647495,152.7031165,1.8,90.1019439,152.5562554,0.2585834,17.9148511,31.4090304,105173.3909172,336677.3769945,12.9271865,10719.1267085,5870.7376413,13866.7167015,35.5792691,62.4113505,3.010406,164.8052215),(9960,'Cervus_giganteus-radius.tif',249,3,186,1187.6872878,89.7918739,152.7516705,1.8,90.0314491,152.5902295,0.2586989,17.8729337,31.2465921,104667.8582229,334880.8609421,12.9547744,10717.3563112,5856.2214735,13792.4935078,35.6443027,62.3047605,3.024081,164.5535161),(9961,'Cervus_giganteus-radius.tif',249,3,187,1190.223625,89.7354606,152.7934267,1.8,89.9796841,152.6487111,0.2581129,17.8835598,31.0980519,104196.5787995,333374.7890103,12.9250027,10720.1180916,5826.389162,13866.0962137,35.5815033,62.1668113,3.044675,165.1611867),(9962,'Cervus_giganteus-radius.tif',249,3,188,1192.5136745,89.673383,152.8263877,1.8,89.8972518,152.6910647,0.2581362,17.8589899,31.039843,103744.4592309,331697.3180069,12.9521611,10686.1789864,5809.0888561,13787.7271887,35.5752918,62.1668113,3.044675,164.6577759),(9963,'Cervus_giganteus-radius.tif',249,3,189,1194.021109,89.5923508,152.8861268,1.8,89.8294425,152.7289468,0.2594928,17.7732587,30.9846484,103137.3833195,330437.5893165,13.102114,10664.5583037,5802.952906,13707.2748075,35.4604992,62.1668113,3.044675,164.3018107),(9964,'Cervus_giganteus-radius.tif',249,3,190,1193.9824483,89.534123,152.9451435,1.8,89.7372774,152.7937056,0.2591531,17.7804171,30.9178548,102314.4433206,329452.2471073,13.0681808,10655.7278854,5754.3331453,13635.4029863,35.4329734,62.1668113,3.044675,164.6577759),(9965,'Cervus_giganteus-radius.tif',249,3,191,1194.3853372,89.4630932,152.9998864,1.8,89.6336722,152.8568177,0.2591341,17.7416803,30.7774829,101563.3534497,328508.598042,13.0707239,10673.6668258,5724.5622672,13718.0418717,35.4318527,61.8780564,3.0232669,163.4424347),(9966,'Cervus_giganteus-radius.tif',249,3,192,1193.926779,89.3922965,153.0654925,1.8,89.5702151,152.9272905,0.2588467,18.2670976,30.7208573,100811.7297604,327549.218663,13.037382,10662.1119311,5518.7601183,13645.5562664,35.4329734,61.8288041,3.030168,163.3381749),(9967,'Cervus_giganteus-radius.tif',249,3,193,1191.8931438,89.383557,153.0120329,1.8,89.5611351,152.8136334,0.2569019,19.0931465,30.5370362,99796.3630383,324980.2543854,12.8246476,10642.1675138,5226.815965,13541.1164675,35.3279018,61.782501,3.0370797,163.5898803),(9968,'Cervus_giganteus-radius.tif',249,3,194,1192.8398573,89.3323777,153.0444951,1.8,89.5100918,152.8824131,0.2553081,17.9968982,30.3910307,99503.8702083,324398.4195834,12.6795357,10674.1499679,5528.9455423,13663.7728347,35.3290225,61.4513938,3.0224414,163.8415857),(9969,'Cervus_giganteus-radius.tif',249,3,195,1193.1480245,89.2756545,153.081878,1.8,89.4509449,152.9030121,0.2539205,18.5868612,30.3372271,99048.3342939,323709.0155606,12.5482982,10670.3560602,5328.9435624,13611.3132833,35.3951456,61.6613514,3.0578727,165.1611867),(9970,'Cervus_giganteus-radius.tif',249,3,196,1193.0771371,89.2111025,153.1172678,1.8,89.3772782,152.9270906,0.2533351,18.8590878,30.194157,98504.1155519,323009.790221,12.4910063,10697.7581705,5223.1643759,13713.5694265,35.6346309,61.3551739,3.0363491,174.8228424),(9971,'Cervus_giganteus-radius.tif',249,3,197,1190.6170585,89.1572039,153.1437989,1.8,89.3526466,152.9465796,0.2521592,18.6956097,30.1392687,97808.1810686,321905.866671,12.3522529,10680.6130601,5231.612269,13642.7985808,35.9921288,61.3551739,3.0363491,175.9339238),(9972,'Cervus_giganteus-radius.tif',249,3,198,1192.4312616,89.120711,153.1651663,1.8,89.343709,152.9610262,0.2503843,18.4346764,30.1135345,97657.1950174,322057.1550838,12.2011766,10694.7643469,5297.4726915,13635.2141134,35.9645373,61.3551739,3.0363491,176.7932998),(9973,'Cervus_giganteus-radius.tif',249,3,199,1193.9190021,89.0886881,153.1851467,1.8,89.3218657,152.9773439,0.2486135,18.4799875,30.1977347,97526.6468004,322289.7355899,12.0477706,10672.6461022,5277.4195278,13624.6744675,36.1227992,61.4017993,3.0293898,174.4668772),(9974,'Cervus_giganteus-radius.tif',249,3,200,1194.5108308,89.0543096,153.2008213,1.8,89.3083383,152.9376929,0.2467145,28.655707,30.2771408,97235.353796,322506.9471039,11.8740459,10651.8296878,3393.2282262,13780.4264884,36.4288709,61.1335955,3.0076477,176.1856292),(9975,'Cervus_giganteus-radius.tif',249,3,201,1192.2173684,88.9785019,153.2475747,1.8,89.2161207,153.0237922,0.2476161,28.2010864,30.2136263,96236.2921567,322234.4141682,11.9362451,10665.2015582,3412.5030112,13716.4066798,36.2970073,61.0776974,3.0146199,182.0538156),(9976,'Cervus_giganteus-radius.tif',249,3,202,1189.8367934,88.9093359,153.2821895,1.8,89.1521754,153.0874788,0.247764,26.7916688,30.2602013,95285.0031479,322253.4612956,11.9263508,10649.4156648,3556.5161688,13655.647007,35.6431167,61.3115246,3.0433187,172.0361948),(9977,'Cervus_giganteus-radius.tif',249,3,203,1191.2777046,88.869786,153.2928019,1.8,89.1602877,153.0997836,0.2458991,18.1438378,30.3310707,95099.6925955,322884.1538314,11.7653413,10645.3266131,5241.4320297,13652.788933,35.5391657,61.4017993,3.0293898,176.0813694),(9978,'Cervus_giganteus-radius.tif',249,3,204,1191.6212875,88.8273572,153.3013666,1.8,89.1671808,153.0587829,0.2441654,18.8048169,30.3983397,94976.8230976,323201.9478688,11.6066708,10632.2236995,5050.6646079,13729.36299,35.6431167,61.1335955,3.0076477,171.8276752),(9979,'Cervus_giganteus-radius.tif',249,3,205,1195.171365,88.7971198,153.2983357,1.8,89.1801815,153.0439533,0.2419878,19.0355543,30.4753264,95230.2398399,324391.3772567,11.4385841,10644.3938464,5002.7563314,13754.1084313,36.0023197,61.1924598,3.0006886,178.7637572),(9980,'Cervus_giganteus-radius.tif',249,3,206,1188.156868,88.6394959,153.373814,1.8,88.8810587,153.1890187,0.2483466,18.3594841,30.4370052,93240.8280287,323013.1516116,11.9644287,10612.5142643,5078.6191717,13667.0838075,35.6059015,61.1924598,3.0006886,174.571137),(9981,'Cervus_giganteus-radius.tif',249,3,207,1190.279518,88.5801804,153.3775024,1.8,88.8404879,153.1735839,0.2486419,18.3748026,30.4858379,93141.6576861,323242.2516731,12.0137338,10603.0299278,5068.9881959,13654.9872009,36.0133848,61.2542818,2.9937433,177.8001214),(9982,'Cervus_giganteus-radius.tif',249,3,208,1190.9483327,88.5294675,153.3916875,1.8,88.7553541,153.1412139,0.2487912,18.6112093,30.5458822,93057.7097068,323721.2518277,12.0346308,10597.8687801,5000.0893701,13643.9690575,35.7275504,61.4017993,3.0293898,173.9634664),(9983,'Cervus_giganteus-radius.tif',249,3,209,1184.9224549,88.3640474,153.3402511,1.8,88.5981206,153.1017047,0.2513291,19.1033541,30.5746523,91522.400247,322695.1098953,12.2140748,10554.3345801,4790.9073882,13536.3224793,35.8616157,61.3190526,2.9868123,174.8660282),(9984,'Cervus_giganteus-radius.tif',249,3,210,1189.526612,88.4002948,153.32042,1.8,88.6254999,153.1093342,0.245777,18.0897418,30.8205832,92310.2756902,325011.1115945,11.7366177,10545.2615813,5102.907313,13539.7845528,35.8807346,61.4574026,2.9729957,172.5396056),(9985,'Cervus_giganteus-radius.tif',249,3,211,1189.8267785,88.3770296,153.3419373,1.8,88.6578239,153.0936878,0.2443511,18.4216047,30.9075369,91941.7212918,326277.1757628,11.6064701,10556.5570082,4990.9724291,13530.989727,36.1878536,61.530962,2.9661114,174.4058032),(9986,'Cervus_giganteus-radius.tif',249,3,212,1189.3965865,88.3130689,153.3688632,1.8,88.5551492,153.1220272,0.2466065,18.4742205,30.9573644,91221.5455913,326497.9535687,11.813066,10546.6973534,4937.7750908,13490.8874288,36.2507682,61.6179189,3.001668,173.3989816),(9987,'Cervus_giganteus-radius.tif',249,3,213,1179.6017586,88.1966811,153.4434333,1.8,88.3881566,153.2048726,0.2523311,18.6060954,30.9734562,89219.4933002,325567.3946095,12.2543076,10511.1742135,4795.1755303,13385.5873799,36.2781624,61.7436394,2.9878851,177.0450052),(9988,'Cervus_giganteus-radius.tif',249,3,214,1178.8295502,88.1444047,153.4606578,1.8,88.3170529,153.1799005,0.254076,24.5556654,31.1286605,88828.0525494,326498.1652366,12.4125703,10488.6673678,3617.4158278,13342.2394267,36.2781624,61.8108844,2.9810154,176.4373346),(9989,'Cervus_giganteus-radius.tif',249,3,215,1177.4201943,88.1121625,153.4840474,1.8,88.2480063,153.2387094,0.2553825,24.5890302,31.2118543,88269.6893544,327410.7607246,12.5227671,10489.9490234,3589.7995367,13317.0590995,35.1968755,61.8810401,2.9741609,172.5396056),(9990,'Cervus_giganteus-radius.tif',249,3,216,1178.3894552,88.1093145,153.4627453,1.8,88.2566188,153.1738283,0.2551525,24.2613516,31.4205349,88488.5709881,328567.8398357,12.5110036,10457.1052254,3647.3059134,13263.7658394,36.6935521,61.8541814,2.9387476,176.9407454),(9991,'Cervus_giganteus-radius.tif',249,3,217,1185.9839198,88.1740286,153.3881293,1.8,88.2597387,153.0757213,0.2514081,24.5795228,31.5668467,89889.8028551,330770.1640963,12.2325422,10478.4037207,3657.1012174,13308.0260773,37.2042845,61.9421749,2.9319528,180.126544),(9992,'Cervus_giganteus-radius.tif',249,3,218,1188.1622391,88.1813803,153.343665,1.8,88.2098437,153.0233983,0.2500941,24.5313573,31.7644096,90420.9232153,332230.7212652,12.1299226,10459.2128434,3685.9323373,13302.6033312,37.1010354,62.1905663,2.9469071,178.407792),(9993,'Cervus_giganteus-radius.tif',249,3,219,1187.6042035,88.1595556,153.3175045,1.8,88.2123028,152.9877559,0.2498917,24.0945574,31.8516169,90468.8189181,333836.4217355,12.1050179,10480.9882418,3754.7408434,13267.4296963,37.1010354,62.2751198,2.9401376,179.9790984),(9994,'Cervus_giganteus-radius.tif',249,3,220,1186.9667203,88.1286038,153.29103,1.8,88.1854921,152.9619098,0.2510673,24.4959102,32.0211288,90450.2270804,335158.7252497,12.2102071,10466.7992062,3692.4623954,13263.56612,37.6093263,62.452753,2.926655,184.8836491),(9995,'Cervus_giganteus-radius.tif',249,3,221,1188.7371713,88.094486,153.2672521,1.8,88.1543734,152.8852926,0.2523954,24.0686903,32.1992282,90843.9969495,337050.806207,12.3553732,10467.6672364,3774.3639413,13244.0647415,37.5085187,62.5458085,2.9199431,184.2759785),(9996,'Cervus_giganteus-radius.tif',249,3,222,1182.8451795,88.0299554,153.2978386,1.8,88.0891724,152.9797282,0.2547409,22.8559626,32.2589033,89748.3566586,338005.2112309,12.5187068,10477.8890953,3926.693358,13201.5203019,35.4880721,62.6416733,2.9132514,179.267168),(9997,'Cervus_giganteus-radius.tif',249,3,223,1189.2995709,88.0858215,153.2118703,1.8,88.0901816,152.8953607,0.2510788,21.9109859,32.4830132,91342.7243952,340166.7717684,12.2353049,10472.1433865,4168.8094165,13247.3756174,35.563524,62.7403344,2.9065804,179.3714278),(9998,'Cervus_giganteus-radius.tif',249,3,224,1186.691563,88.0534406,153.2140643,1.8,88.0416031,152.8645116,0.2519861,22.2423055,32.5612471,91290.1452323,341353.1864303,12.2949933,10483.4186944,4104.3472386,13231.9494278,35.6228714,62.8417787,2.8999307,184.4234241),(9999,'Cervus_giganteus-radius.tif',249,3,225,1178.8239553,88.0735077,153.1096588,1.8,88.1733525,152.689817,0.2536748,22.6615716,32.5740831,90801.8757176,340481.6202764,12.3741829,10452.5312018,4006.8657866,13134.9659116,36.225742,62.8608731,2.8717435,187.9220021),(10000,'Cervus_giganteus-radius.tif',249,3,226,1170.4256151,87.9604137,153.1494436,1.8,87.9012041,152.8427459,0.2610736,18.5548239,32.6156606,89554.7318901,338855.4863437,12.9965749,10389.3491616,4826.4932156,13018.7247165,35.1968755,62.9767836,2.8651674,176.9839312),(10001,'Cervus_giganteus-radius.tif',249,3,227,1166.9053584,87.9648914,153.1322736,1.8,87.8832397,152.7925522,0.2626833,21.9721833,32.6225198,89459.6654915,338618.1893807,13.1140601,10379.8906973,4071.4964222,13009.5960968,35.1968755,62.8608731,2.8717435,176.5237063),(10002,'Cervus_giganteus-radius.tif',249,3,228,1163.8822648,87.965634,153.1092367,1.8,87.8890258,152.7617108,0.2639385,22.061834,32.6225994,89329.1740399,338936.4617777,13.2024677,10389.6215636,4049.0366243,13018.5255879,34.8686341,62.8608731,2.8717435,175.6643302),(10003,'Cervus_giganteus-radius.tif',249,3,229,1158.5570926,87.9638178,153.1011938,1.8,87.9364972,152.6994163,0.2656309,18.780917,32.6258596,89120.0462614,338422.2826414,13.3071368,10372.823493,4745.2446742,12949.4329039,35.1264414,62.8608731,2.8717435,181.8884819),(10004,'Cervus_giganteus-radius.tif',249,3,230,1155.8377462,87.9631526,153.087967,1.8,87.9554651,152.6421402,0.2673637,21.0611787,32.6289087,89189.0790117,338605.8997032,13.445516,10377.4816034,4234.7619906,12959.5042371,35.25207,62.8608731,2.8717435,178.9975745),(10005,'Cervus_giganteus-radius.tif',249,3,231,1166.3797173,88.1741897,152.9328014,1.8,88.2157569,152.5049877,0.2566397,17.5131508,32.7684028,92321.7425949,341803.2812632,12.5250855,10430.8801254,5271.5667111,13029.9918389,35.4196136,62.9298582,2.8435957,178.4941637),(10006,'Cervus_giganteus-radius.tif',249,3,232,1161.5809695,88.1676817,152.9142017,1.8,88.1790198,152.444982,0.258758,17.7388529,32.6600887,92415.1107545,341635.2952532,12.6756797,10460.32969,5209.7568774,13037.3660908,35.4431617,62.6829237,2.8567018,173.7370586),(10007,'Cervus_giganteus-radius.tif',249,3,233,1157.4033118,88.1755155,152.8980408,1.8,88.1724384,152.4323007,0.2607547,17.5283927,32.6744522,92511.5431043,341612.1133757,12.8213104,10455.0219084,5277.8109533,13039.6733047,35.1570718,62.6829237,2.8567018,175.9592215),(10008,'Cervus_giganteus-radius.tif',249,3,234,1155.8702526,88.2077761,152.8825916,1.8,88.201689,152.3798443,0.2630064,17.4615554,32.6020391,92905.1513266,341813.803515,13.0212778,10484.4302062,5320.5541516,13109.4599386,35.1816259,62.5192354,2.7981064,175.4558107),(10009,'Cervus_giganteus-radius.tif',249,3,235,1154.0594624,88.2439636,152.8655122,1.8,88.2171664,152.3705747,0.2649857,17.4810682,32.5650891,93294.9797116,341621.6102299,13.1926759,10490.4245643,5336.9152579,13106.250277,35.1241327,62.5192354,2.7981064,173.1725739),(10010,'Cervus_giganteus-radius.tif',249,3,236,1149.0872167,88.261719,152.8451288,1.8,88.1961168,152.3376407,0.2667131,17.5103366,32.474245,93432.5457589,340825.3580847,13.3035614,10495.2511749,5335.8509257,13084.2191373,35.5093804,62.4113505,2.782822,174.7438803),(10011,'Cervus_giganteus-radius.tif',249,3,237,1147.1352671,88.2956962,152.827561,1.8,88.2220431,152.3117815,0.2679896,17.4892872,32.3228116,93911.4129641,340584.5012393,13.4053283,10536.9701622,5369.6535538,13083.0767404,35.5093804,62.3180942,2.7674882,176.7143377),(10012,'Cervus_giganteus-radius.tif',249,3,238,1140.2304302,88.2988424,152.8193478,1.8,88.2184402,152.3266753,0.269835,17.4977738,32.2211873,94039.3333532,339066.7042462,13.5042871,10523.0977856,5374.3598803,13105.1538428,35.5093804,62.1623562,2.7739225,179.2924657),(10013,'Cervus_giganteus-radius.tif',249,3,239,1134.0490701,88.292158,152.8023734,1.8,88.185501,152.2495707,0.27206,17.5119271,32.1561686,94395.4787251,338115.8244663,13.6479802,10514.8044316,5390.3535702,13092.826245,35.5093804,62.1623562,2.7739225,175.7075161),(10014,'Cervus_giganteus-radius.tif',249,3,240,1127.5523253,88.3092689,152.8176041,1.8,88.2324549,152.2543388,0.2738842,17.501479,32.073918,94510.4894519,337070.3101619,13.7477882,10509.1716601,5400.1429998,13055.7872114,35.0943336,62.0776491,2.7585156,175.0998455),(10015,'Cervus_giganteus-radius.tif',249,3,241,1115.8288787,88.4123783,152.7279688,1.8,88.3152546,152.0939656,0.2777007,17.7971658,31.8791733,94043.9047106,333600.2116316,13.9767913,10464.5189062,5284.2068148,12979.2454937,35.8111616,61.8422404,2.7494739,173.2768337),(10016,'Cervus_giganteus-radius.tif',249,3,242,1110.7096548,88.4475469,152.7254028,1.8,88.323963,152.1649522,0.2790533,17.5084655,31.8036199,94194.5380095,332362.2565726,14.044984,10450.4536646,5379.9425209,12991.081249,35.3971011,61.6793145,2.7559117,170.9935969),(10017,'Cervus_giganteus-radius.tif',249,3,243,1104.6952466,88.4726483,152.7109988,1.8,88.3473525,152.1592526,0.2810526,17.5279964,31.781839,94264.8179736,330636.2600773,14.1645014,10403.3080164,5377.9573928,12935.2628922,35.3971011,61.6793145,2.7559117,172.5649033),(10018,'Cervus_giganteus-radius.tif',249,3,244,1099.3724243,88.5030088,152.6953518,1.8,88.3947713,152.1442396,0.2831506,17.5501366,31.5832352,94381.4301907,329079.9731006,14.301809,10419.4510367,5377.8174258,12936.8712936,34.9613078,61.4453845,2.7468015,171.8097871),(10019,'Cervus_giganteus-radius.tif',249,3,245,1096.2080034,88.6000001,152.5922253,1.8,88.4786465,152.0331717,0.2816199,17.6771219,31.5823523,95874.8490981,326839.8701759,14.1109674,10348.813394,5423.6684948,12903.9093803,35.3763546,61.4453845,2.7468015,172.5217174),(10020,'Cervus_giganteus-radius.tif',249,3,246,1088.7868129,88.6257725,152.5818933,1.8,88.5278311,152.0060173,0.2841475,17.6928095,31.504774,95941.2921887,324850.6532339,14.2613109,10311.1564493,5422.6148903,12888.0658772,35.486,61.2814035,2.7532739,177.8864931),(10021,'Cervus_giganteus-radius.tif',249,3,247,1081.0294247,88.6758552,152.595925,1.8,88.7252107,152.0091464,0.2859855,21.2025383,57.3485544,95933.9755444,323751.3223142,14.33844,5645.3266474,4524.645776,7300.9941492,35.4091896,61.0489731,2.7440944,173.6759847),(10022,'Cervus_giganteus-radius.tif',249,3,248,1073.3501973,88.7265756,152.6064157,1.8,88.9141404,152.0312511,0.2881375,21.1988161,59.5159838,95833.9450425,322695.54782,14.4456618,5421.9980438,4520.7215535,7001.1934162,35.3574236,60.9929975,2.7283754,173.2768337),(10023,'Cervus_giganteus-radius.tif',249,3,249,1065.8951017,88.7995916,152.6173811,1.8,89.1331223,152.0523696,0.2895549,20.3651658,61.6602955,95792.9266809,321816.1093787,14.4828337,5219.1788411,4703.7636483,6726.4893421,35.7729514,60.952118,2.7126314,172.8166087),(10024,'Cervus_giganteus-radius.tif',249,3,250,1057.9115676,88.8750147,152.6261884,1.8,89.377627,152.0858997,0.2901876,20.7639716,63.8053523,95865.440601,320895.6563532,14.4354734,5029.2905645,4616.9125304,6470.0940044,35.9516059,60.7746556,2.7190611,171.8529729),(10025,'Cervus_giganteus-radius.tif',249,3,251,1050.1594386,88.9112348,152.5997701,1.8,89.3652981,152.0259151,0.291834,19.5751992,63.7636407,96292.4137752,317652.2495983,14.488096,4981.7144406,4919.1026263,6429.5412146,36.6454202,60.653015,2.741352,173.7802445),(10026,'Cervus_giganteus-radius.tif',249,3,252,1042.2756057,88.9333,152.6045734,1.8,89.306382,151.9963996,0.2939903,20.1042576,63.3105394,96257.9107778,314502.5504499,14.5864339,4967.6176143,4787.9366033,6424.7060578,35.6132959,60.4273342,2.7320324,169.0663253),(10027,'Cervus_giganteus-radius.tif',249,3,253,1038.3950373,88.9799191,152.602357,1.8,89.327387,151.9458844,0.2962455,20.2093302,62.5498406,96625.2666673,313234.427785,14.7493492,5007.7574136,4781.2206423,6494.5632326,36.175953,60.4273342,2.7320324,171.2453023),(10028,'Cervus_giganteus-radius.tif',249,3,254,1033.8500183,89.0779019,152.6143526,1.8,89.5825107,152.0196106,0.2975682,20.0638056,62.0307094,96783.7588763,313261.3347523,14.8123144,5050.1007941,4823.7986856,6551.7531271,38.1840579,60.3830142,2.716143,181.5146285),(10029,'Cervus_giganteus-radius.tif',249,3,255,1053.7136004,89.5367244,152.3277271,1.8,90.1010324,151.8096036,0.2770471,19.8220173,60.9987386,103573.1139494,316741.5740889,13.1382863,5192.5921952,5225.1550606,6852.8802534,38.3025205,60.3585478,2.6524728,174.4742867),(10030,'Cervus_giganteus-radius.tif',249,3,256,1048.6071889,89.5870541,152.347239,1.8,90.2528272,151.8435293,0.2788692,19.8236375,60.5201238,103755.5032853,315702.7991873,13.2426652,5216.4929535,5233.9285997,6892.4323078,38.3067339,60.206941,2.7226437,173.3632053),(10031,'Cervus_giganteus-radius.tif',249,3,257,1033.1011406,89.688202,152.2017961,1.8,90.2072645,151.669058,0.2853126,19.7640582,60.0091763,102393.5832015,309678.8234297,13.6400841,5160.5244803,5180.7974876,6826.8556094,38.1840579,60.1716645,2.7066911,174.1793955),(10032,'Cervus_giganteus-radius.tif',249,3,258,1024.1987556,89.68427,152.1966525,1.8,90.0316982,151.6639767,0.2877251,19.6342814,59.1744948,102259.4054935,306196.4759189,13.7458224,5174.4670933,5208.2071811,6862.5456362,38.0477159,59.9918936,2.7131869,173.2157597),(10033,'Cervus_giganteus-radius.tif',249,3,259,1014.4266991,89.6619805,152.1819506,1.8,89.7131503,151.5876335,0.2912478,19.7424637,58.7655626,101921.5176328,302048.2239911,13.9405532,5139.8848374,5162.5531178,6832.8776035,38.1415565,59.9918936,2.7131869,172.0004185),(10034,'Cervus_giganteus-radius.tif',249,3,260,1006.3471004,89.6882877,152.1690858,1.8,89.7368974,151.563431,0.294237,19.7172571,30.585429,101815.6664563,299741.1721008,14.1065787,9800.1297328,5163.7845041,12785.8776367,38.1415565,59.8624943,2.7357584,171.3927479),(10035,'Cervus_giganteus-radius.tif',249,3,261,1013.4013772,89.9468425,151.9152501,1.8,89.9645538,151.3642168,0.2825142,19.4212974,37.8148785,106585.5801271,299187.8213411,13.1257939,7911.9075227,5488.0772391,10724.1289826,38.1415565,59.6941652,2.7423719,172.6080891),(10036,'Cervus_giganteus-radius.tif',249,3,262,1005.4519161,89.9692215,151.9185349,1.8,90.1035372,151.4335218,0.2850734,19.5344319,38.0373777,106350.1033342,297474.3285013,13.253385,7820.5792896,5444.2383621,10601.325126,38.2260486,59.6400138,2.7262944,174.1793955),(10037,'Cervus_giganteus-radius.tif',249,3,263,999.213376,90.004582,151.9223983,1.8,90.200703,151.4588879,0.2880346,19.5238054,35.2159442,106336.8073872,296159.8519933,13.4385614,8409.8228406,5446.5205512,11429.3651296,38.1840579,59.4679504,2.7329058,173.2157597),(10038,'Cervus_giganteus-radius.tif',249,3,264,993.9909822,90.0494888,151.9064956,1.8,90.2668056,151.4496625,0.2907053,19.4915927,31.7222991,106320.5253731,295192.6035388,13.6103229,9305.5236329,5454.6863842,12616.3922629,38.1840579,59.4229148,2.7167605,173.3200195),(10039,'Cervus_giganteus-radius.tif',249,3,265,989.8258571,90.0914258,151.8908727,1.8,90.2781799,151.4377243,0.2941251,19.458891,30.2295007,106372.2941078,294285.5983597,13.8647459,9735.046597,5466.5136828,12920.162141,38.1415565,60.750347,2.8399736,177.9728647),(10040,'Cervus_giganteus-radius.tif',249,3,266,986.9625539,90.1257455,151.8960954,1.8,90.2783522,151.4454626,0.2973725,19.699997,30.155418,106535.478771,293554.0757734,14.1224979,9734.7042459,5407.8931552,12946.303252,38.4551992,59.9256884,2.8879186,176.7575235),(10041,'Cervus_giganteus-radius.tif',249,3,267,982.6013834,90.1603593,151.8641591,1.8,90.3194149,151.3987666,0.3005915,19.6559873,30.1659455,106658.8419464,292821.5733768,14.3568697,9707.0245418,5426.2775123,12955.4083634,38.4551992,59.4229148,2.9229237,174.9955857),(10042,'Cervus_giganteus-radius.tif',249,3,268,978.1430854,90.1882019,151.8129181,1.8,90.3700248,151.3331176,0.3041098,19.6188535,30.0938736,106863.349164,292163.4777138,14.6178075,9708.4038382,5446.9721808,13003.7560104,38.3870126,59.6632276,2.9385474,175.9592215),(10043,'Cervus_giganteus-radius.tif',249,3,269,978.7185211,90.2255955,151.7814229,1.8,90.4946493,151.3043967,0.3070642,19.6999177,30.112336,107684.9136626,292859.6351604,14.9029499,9725.5701066,5466.2621132,12744.4788139,38.4291778,60.3401915,2.9553698,178.9975745),(10044,'Cervus_giganteus-radius.tif',249,3,270,976.0041542,90.2533445,151.7486319,1.8,90.6370357,151.2479263,0.3090977,19.7864756,30.0090712,108124.2149934,292639.1308127,15.0527788,9751.6890486,5464.5514919,12545.6918882,38.6174846,59.9179854,2.9540421,191.280544),(10045,'Cervus_giganteus-radius.tif',249,3,271,983.9260884,90.3805165,151.5444585,1.8,90.5195657,151.0901806,0.3061016,19.947309,29.9244359,112090.053896,292284.7071982,14.8914046,9767.4258023,5619.3070436,13281.2440813,39.0005672,59.646205,3.0333221,172.7734228),(10046,'Cervus_giganteus-radius.tif',249,3,272,982.6593466,90.394171,151.4996766,1.8,90.4402684,150.7063266,0.3109813,21.8112428,30.0178675,112886.3649313,292911.7533055,15.3346802,9757.9134673,5175.6044338,13406.4962799,40.7418757,59.9164446,2.9976672,183.5461599),(10047,'Cervus_giganteus-radius.tif',249,3,273,972.4949754,90.3638424,151.4838034,1.8,90.3418125,151.1056043,0.3168139,19.7601496,39.298948,112084.604923,291003.6397871,15.7313282,7404.8709778,5672.2548865,10125.4987614,38.8761769,58.9675362,2.7529674,169.5876242),(10048,'Cervus_giganteus-radius.tif',249,3,274,963.7803554,90.4147253,151.4223153,1.8,90.5112036,151.0583935,0.318537,19.6814048,29.7015682,111264.7154157,287651.0134623,15.7546183,9684.7079305,5653.2913443,13278.9708085,38.6338689,58.7400946,2.782822,165.33393),(10049,'Cervus_giganteus-radius.tif',249,3,275,972.0570064,90.7065781,151.2392365,1.8,90.7859818,150.8826956,0.3010155,19.5619251,29.5849594,115237.879844,289501.585873,14.2416837,9785.4312473,5890.9273572,13485.7113027,38.8618842,58.6410002,2.7107202,165.5856354),(10050,'Cervus_giganteus-radius.tif',249,3,276,968.7289906,90.7179772,151.2244836,1.8,90.7874764,150.8190029,0.303127,19.5681859,29.5995013,115295.4231323,289336.7178198,14.3865746,9775.05382,5891.9832429,13560.5935819,38.8264425,58.5906024,2.7896888,173.0251283),(10051,'Cervus_giganteus-radius.tif',249,3,277,963.5620982,90.7216794,151.2068976,1.8,90.803031,150.80059,0.3048878,19.6755144,29.4753625,115116.5471553,288635.2490774,14.4713737,9792.4240712,5850.7516014,13534.7682341,38.8745528,58.5701159,2.7501875,173.3810935),(10052,'Cervus_giganteus-radius.tif',249,3,278,972.7008678,90.900325,151.0096625,1.8,90.9991901,150.6030546,0.2967958,19.5977698,29.4352478,119004.4395581,289918.9578047,13.866085,9849.3805809,6072.3460346,13758.4729645,39.1843254,58.4912548,2.773364,164.7262594),(10053,'Cervus_giganteus-radius.tif',249,3,279,971.4884525,90.9185576,150.9873457,1.8,90.9873503,150.5706721,0.2991079,19.6706993,29.326056,119403.70011,290227.1320538,14.0589167,9896.5620322,6070.1298989,13790.4918144,39.2778793,58.4628388,2.7173982,165.4381898),(10054,'Cervus_giganteus-radius.tif',249,3,280,968.4196485,90.9398178,150.9724974,1.8,91.0293455,150.5850077,0.3008035,19.5632213,29.3174829,119514.6787252,290181.3991379,14.1690114,9897.8960901,6109.1513035,13866.7498167,39.1540462,58.4438871,2.7965905,165.794155),(10055,'Cervus_giganteus-radius.tif',249,3,281,966.9908223,90.9742168,150.9310472,1.8,91.0847888,150.5494911,0.3030087,19.5965564,29.217733,120062.0531103,290284.324544,14.349903,9935.2103767,6126.6913634,13964.1908283,39.2509737,58.4280893,2.8198421,166.1501202),(10056,'Cervus_giganteus-radius.tif',249,3,282,965.2112517,91.0094751,150.8914265,1.8,91.084597,150.4852995,0.3047004,19.827366,29.1158356,120504.4284911,290232.444863,14.4788818,9968.1990661,6077.6821552,13978.3145679,39.5001416,58.3379603,2.7802358,166.1501202),(10057,'Cervus_giganteus-radius.tif',249,3,283,961.6063441,91.0288039,150.8494773,1.8,91.1080628,150.4543289,0.3064246,19.9291183,29.1260996,120572.1981523,289921.9988646,14.583368,9954.0275928,6050.0517962,13981.2024259,39.5428498,58.4280893,2.8198421,166.8620506),(10058,'Cervus_giganteus-radius.tif',249,3,284,957.1426191,91.0541933,150.8065192,1.8,91.1359323,150.4174142,0.3081868,19.8758143,29.0113427,120504.1328089,289473.4939763,14.6777743,9977.9419852,6062.8526178,13879.9365865,39.5298792,58.3616919,2.9037567,168.0773918),(10059,'Cervus_giganteus-radius.tif',249,3,285,983.7983568,91.6356035,150.4181723,1.8,91.6842123,149.959972,0.2707713,21.0413972,29.2567677,129570.3323977,296280.2276252,11.7306033,10126.8954475,6157.8768211,14485.1617746,41.2660602,58.4644178,2.896614,167.573981),(10060,'Cervus_giganteus-radius.tif',249,3,286,951.2787137,91.1404089,150.7450544,1.8,91.2603272,150.365721,0.3130572,20.0421678,28.9685651,121117.6540658,289007.2198481,15.03729,9976.580452,6043.1414037,13691.7377878,39.7991592,58.4644178,2.896614,168.3290972),(10061,'Cervus_giganteus-radius.tif',249,3,287,947.5597261,91.1633555,150.7093069,1.8,91.2735984,150.3341072,0.3168956,19.9997443,29.0714987,121291.6228551,288482.5130637,15.3356166,9923.207467,6064.6586807,13813.3140425,39.7310482,58.4912548,2.8663202,165.7509692),(10062,'Cervus_giganteus-radius.tif',249,3,288,942.4433557,91.1774666,150.6707864,1.8,91.2879641,150.3066608,0.3196189,20.08134,29.191778,121226.2185638,287992.8879744,15.5070607,9865.5480352,6036.7594264,13763.1308828,39.8808852,58.5842997,2.9197415,166.3586398),(10063,'Cervus_giganteus-radius.tif',249,3,289,931.9620893,91.1742984,150.5022787,1.8,91.29646,150.1956434,0.3276235,20.0384095,29.3421367,120140.0566132,285471.6618723,16.0843107,9729.0686371,5995.4886329,13567.9463351,39.743574,58.6787702,2.8824054,169.5444384),(10064,'Cervus_giganteus-radius.tif',249,3,290,950.3675839,91.6838082,150.1699395,1.8,91.7234669,149.8636653,0.2963013,19.8663353,29.2368114,126885.3577778,291777.3395703,13.5039374,9979.7934896,6386.9534005,14152.0234484,40.2207772,58.7903643,2.8753406,167.2180158),(10065,'Cervus_giganteus-radius.tif',249,3,291,945.9076074,91.7214784,150.1061727,1.8,91.7828782,149.8156427,0.2990493,20.2037654,29.2091763,126776.9401988,291598.9610717,13.6835184,9983.128514,6274.9164775,14047.1728415,40.5704452,58.6803434,2.9125984,167.8256864),(10066,'Cervus_giganteus-radius.tif',249,3,292,942.1223761,91.7309154,150.0347294,1.8,91.7877648,149.7354122,0.3027064,20.1304626,29.335608,126792.2963209,291422.1908834,13.9538305,9934.0770823,6298.5286875,14051.1444518,40.5400175,58.7903643,2.8753406,167.113756),(10067,'Cervus_giganteus-radius.tif',249,3,293,934.1130495,91.73562,149.9682884,1.8,91.7876822,149.6669902,0.3064697,20.0631017,29.3589771,126330.2123248,290032.7042458,14.1704485,9878.8422939,6296.6441645,13918.1575607,40.5341942,58.9048814,2.868303,168.0773918),(10068,'Cervus_giganteus-radius.tif',249,3,294,928.0631696,91.726214,149.912493,1.8,91.7880264,149.6200279,0.3107016,20.079787,29.4808072,126056.8712355,289279.7973558,14.4574973,9812.4788546,6277.7992329,13790.0664571,40.4911944,58.9816243,2.8382732,168.0773918),(10069,'Cervus_giganteus-radius.tif',249,3,295,922.5550441,91.7142113,149.8645881,1.8,91.7975708,149.5654248,0.3153553,19.9992978,29.5010337,125841.3260813,288642.067433,14.7909626,9784.1340141,6292.2872194,13759.0533468,40.4911944,58.9111498,2.9284616,167.4697212),(10070,'Cervus_giganteus-radius.tif',249,3,296,918.0612744,91.717105,149.7928328,1.8,91.7924414,149.4805185,0.3203274,20.2984355,29.4978873,125940.8264937,288044.6886492,15.1706174,9764.9260595,6204.4597589,13531.5298268,40.7429666,58.9111498,2.9284616,169.0410276),(10071,'Cervus_giganteus-radius.tif',249,3,297,949.8609095,92.6082248,149.3161393,1.8,92.5056358,149.0448904,0.2585431,20.8026131,29.3854245,136239.7391453,299947.3432485,10.3484763,10207.351028,6549.1646923,14653.3756077,41.0897206,59.0223045,2.861293,169.4401786),(10072,'Cervus_giganteus-radius.tif',249,3,298,945.0834783,92.620769,149.265813,1.8,92.5081275,149.0238322,0.2630898,20.8565716,29.3962986,136261.855525,299359.8589509,10.6532897,10183.5902166,6533.2815896,14467.0115196,41.1278985,59.0223045,2.861293,169.7961438),(10073,'Cervus_giganteus-radius.tif',249,3,299,940.8282193,92.6244379,149.1890917,1.8,92.53208,148.9211663,0.2671666,20.8589225,29.3153481,136184.1563645,298938.1882449,10.9286249,10197.3269015,6528.8202972,14457.0590573,41.3657796,58.9816243,2.8382732,170.152109),(10074,'Cervus_giganteus-radius.tif',249,3,300,960.9544261,93.1934776,148.8030433,1.8,93.0974451,148.5090683,0.2281432,21.3423238,29.6474589,143524.056448,306537.1209912,8.1925412,10339.4062281,6724.8560873,15039.0894598,41.5153284,58.9048814,2.868303,170.6555198),(10075,'Cervus_giganteus-radius.tif',249,3,301,958.5926499,93.2052419,148.7389161,1.8,93.0984351,148.4506577,0.2328562,21.3829208,29.6556282,144085.2051945,306674.8586207,8.507358,10341.202582,6738.3313248,14990.3361021,41.5267819,58.9440484,3.0905422,171.011485),(10076,'Cervus_giganteus-radius.tif',249,3,302,952.5958097,93.2242755,148.682544,1.8,93.1159325,148.4043889,0.2379476,21.4473783,29.5709306,144100.2773603,305750.8448316,8.8208058,10339.5746563,6718.7828465,14973.9174408,41.8595168,58.9174177,2.965653,171.2631904),(10077,'Cervus_giganteus-radius.tif',249,3,303,949.3431013,93.2240925,148.6336214,1.8,93.1064555,148.3629917,0.2447787,21.397144,29.4655623,144543.6177406,305347.3213358,9.2924059,10362.8540278,6755.2762008,14978.9795243,41.8855318,58.9941443,2.9584818,171.2631904),(10078,'Cervus_giganteus-radius.tif',249,3,304,944.3160255,93.2227059,148.591419,1.8,93.1141799,148.279248,0.2499167,21.4478294,29.4673566,144703.5970336,304519.7816347,9.6271127,10334.139778,6746.7711603,14750.7772849,41.9877496,59.1316891,3.0469854,171.9751208),(10079,'Cervus_giganteus-radius.tif',249,3,305,930.2752821,93.1867162,148.4018896,1.8,93.0391986,148.1055745,0.2606972,21.5317135,29.3270844,143315.9127945,300454.2694109,10.3008223,10244.9416727,6656.0384541,14568.2398486,42.1425298,59.1738263,3.0397564,171.6191556),(10080,'Cervus_giganteus-radius.tif',249,3,306,938.3317178,93.5362742,148.1707606,1.8,93.3590022,147.8881261,0.2392184,21.8161053,29.5410655,147117.488959,305131.8934031,8.7799974,10329.0754241,6743.5267274,14793.722774,42.2840604,59.3529643,3.0981418,172.8344968),(10081,'Cervus_giganteus-radius.tif',249,3,307,931.7766183,93.5521394,148.1134006,1.8,93.3863609,147.7837477,0.2450198,21.7727527,29.5537033,147019.021779,303726.1799842,9.1380684,10277.0937646,6752.4315254,14756.2804151,42.3404408,59.3964987,3.0836864,173.6938728),(10082,'Cervus_giganteus-radius.tif',249,3,308,925.9779495,93.5601645,148.0521772,1.8,93.4037348,147.7284501,0.2521854,21.8443676,29.4637357,147122.8823822,302345.3786871,9.608663,10261.6104836,6735.0488399,14722.7141931,42.4927276,59.2673571,3.025331,172.9819424),(10083,'Cervus_giganteus-radius.tif',249,3,309,916.5022549,93.5684322,147.9912433,1.8,93.4402083,147.6834967,0.2586012,21.9136362,29.4738949,146535.9122551,300053.9519583,9.989424,10180.3291586,6686.9738664,14463.2320934,42.7607391,59.5207073,3.0548543,173.6938728),(10084,'Cervus_giganteus-radius.tif',249,3,310,910.5101144,93.5793955,147.9440733,1.8,93.4414603,147.6101787,0.2651883,21.9695102,29.4118556,146348.2513524,298838.2537504,10.4240806,10160.4692429,6661.4253151,14425.7326695,42.7607391,59.5594694,3.0476669,174.6575086),(10085,'Cervus_giganteus-radius.tif',249,3,311,904.0385467,93.5566779,147.8774325,1.8,93.4336699,147.5413979,0.2731567,22.0353127,29.3508349,146170.7528502,297526.1973491,10.9655621,10136.8904169,6633.4775976,14370.9606163,42.770559,59.6013041,3.0404893,174.6575086),(10086,'Cervus_giganteus-radius.tif',249,3,312,897.5766022,93.5182666,147.7980964,1.8,93.3763279,147.4674223,0.2818651,21.9878539,29.3052277,145921.2130177,296353.7568892,11.5736639,10112.6584097,6636.4463525,14117.0929671,42.7285906,59.8516984,3.0769347,175.2651792),(10087,'Cervus_giganteus-radius.tif',249,3,313,890.8445358,93.5190075,147.7337484,1.8,93.4009793,147.3850286,0.2876181,22.0504575,29.3309972,145419.2783935,295119.3969253,11.9474225,10061.6898601,6594.8417806,14065.5253311,43.0623027,59.9133631,3.0626205,175.5168846),(10088,'Cervus_giganteus-radius.tif',249,3,314,884.0221678,93.526961,147.6652724,1.8,93.4447373,147.2860708,0.2936947,21.9937426,29.3448958,145016.3665022,293698.3991871,12.3475563,10008.500336,6593.5284029,13802.8885669,43.0769429,60.2115408,3.0987617,176.8364856),(10089,'Cervus_giganteus-radius.tif',249,3,315,876.3434439,93.4970372,147.615012,1.8,93.4546437,147.2625429,0.3014911,22.0281388,29.4851293,144542.7725475,292376.4539687,12.8787385,9916.0648467,6561.7333329,13530.6673314,43.0769429,60.3417214,3.0631823,179.9790984),(10090,'Cervus_giganteus-radius.tif',249,3,316,868.4205585,93.4423676,147.5733108,1.8,93.3974113,147.1909139,0.3090408,22.0450713,29.5982075,143960.8983956,290662.7961089,13.3887545,9820.2837487,6530.2986191,13439.4687854,43.3888038,60.3768985,3.0560874,184.6319437),(10091,'Cervus_giganteus-radius.tif',249,3,317,894.1339468,94.1826373,147.1288644,1.8,94.0368058,146.7243212,0.255624,22.5925221,29.5351072,152934.1908388,301540.7023993,9.5274033,10209.5685801,6769.2394019,14406.5634824,43.5334385,60.3768985,3.0560874,178.6594974),(10092,'Cervus_giganteus-radius.tif',249,3,318,889.0457747,94.1806678,147.0740339,1.8,94.042706,146.688011,0.262312,22.6282899,29.5988165,152944.2767101,300743.8755745,9.96381,10160.6723344,6758.9852021,14192.1076066,43.6906729,60.738189,3.0707892,181.8021102),(10093,'Cervus_giganteus-radius.tif',249,3,319,885.9630954,94.1816197,147.0256015,1.8,94.0633389,146.6810171,0.2670062,22.6761103,29.6670332,153078.0637378,300618.5365951,10.2792598,10133.0839143,6750.6314725,14195.4582804,43.7963796,60.738189,3.0707892,183.6683079),(10094,'Cervus_giganteus-radius.tif',249,3,320,906.4910721,94.8185027,146.663007,1.8,94.8053701,146.1836185,0.2198966,23.0445131,29.9554212,160201.3255917,310448.7905686,7.1884955,10363.6930394,6951.8207949,14892.5663451,44.0053775,60.7700985,3.0637362,182.2012613),(10095,'Cervus_giganteus-radius.tif',249,3,321,895.8934877,94.7648008,146.510632,1.8,94.7210007,145.9855466,0.2280417,22.9964093,29.8896076,158929.2064203,307811.1952328,7.6311912,10298.26819,6911.0444204,14594.8613079,44.2551074,61.1124509,3.0853141,185.4913197),(10096,'Cervus_giganteus-radius.tif',249,3,322,889.5035496,94.7778893,146.4315996,1.8,94.7512307,145.9237383,0.2315962,23.0531788,30.0387593,158891.6260799,306886.2321316,7.8105301,10216.3417908,6892.3955086,14576.403392,44.1361847,61.1381255,3.078297,184.0242731),(10097,'Cervus_giganteus-radius.tif',249,3,323,882.8240194,94.8009995,146.3303286,1.8,94.7537034,145.8182904,0.2358132,23.0806189,30.2141927,158588.0044886,305932.5990982,8.03145,10125.4599938,6871.0464406,14391.7366926,44.2991875,61.4994473,3.0996592,184.0242731),(10098,'Cervus_giganteus-radius.tif',249,3,324,877.8803636,94.8090395,146.2414493,1.8,94.7352567,145.7043868,0.241312,23.1597587,30.3718415,158786.2620664,305422.9711596,8.355947,10056.1229177,6856.1276497,14391.1526909,44.2623756,61.4994473,3.0996592,181.5935907),(10099,'Cervus_giganteus-radius.tif',249,3,325,869.4720645,94.7928387,146.1557236,1.8,94.7092885,145.6708871,0.2493646,23.1496669,30.4309609,158557.5754375,303182.7535789,8.8257859,9962.9701132,6849.2378662,14312.6818867,44.2266958,61.4017993,3.0293898,180.8816603),(10100,'Cervus_giganteus-radius.tif',249,3,326,863.9072067,94.7698116,146.097656,1.8,94.6263559,145.6375859,0.258652,23.2207923,30.5691921,158589.2782336,301930.6707303,9.4197814,9876.9594523,6829.6239173,14144.8537003,44.2377683,61.7391538,3.0440016,181.8452961),(10101,'Cervus_giganteus-radius.tif',249,3,327,859.0602308,94.7298537,146.0230505,1.8,94.5990571,145.5702571,0.269205,23.1887057,30.507626,158530.1749008,301446.1745649,10.1279587,9881.010556,6836.5253868,14095.8988068,44.2561238,61.7391538,3.0440016,182.5572265),(10102,'Cervus_giganteus-radius.tif',249,3,328,851.9820078,94.6824005,145.9377699,1.8,94.5536062,145.4752121,0.279841,23.2709885,30.5718174,158239.7841206,300185.8429294,10.8326656,9819.0381895,6799.8737566,14012.1036821,44.3564325,61.782501,3.0370797,182.2012613),(10103,'Cervus_giganteus-radius.tif',249,3,329,844.7165235,94.5922734,145.8825378,1.8,94.5007344,145.4822454,0.2926327,23.2700945,30.6508821,158010.6920683,298430.7900203,11.7158285,9736.4502836,6790.2900755,13916.0058738,44.3400012,61.8288041,3.030168,183.2691569),(10104,'Cervus_giganteus-radius.tif',249,3,330,836.4256054,94.532012,145.8293049,1.8,94.4538456,145.4562639,0.3049803,23.3260434,30.5830085,157353.3845308,296924.2765245,12.5693476,9708.7987976,6745.8240509,13827.2677878,44.389614,61.8288041,3.030168,184.9879089),(10105,'Cervus_giganteus-radius.tif',249,3,331,830.6884246,94.4698431,145.7409568,1.8,94.4291939,145.408716,0.3159653,23.2740868,30.6737756,156984.6414423,296248.2737368,13.3679485,9658.0309466,6745.0397757,13773.5659127,44.311763,61.8780564,3.0232669,184.0242731),(10106,'Cervus_giganteus-radius.tif',249,3,332,859.2987415,95.373389,145.2196467,1.8,95.3827214,144.8060114,0.2451207,23.8758714,30.658337,167367.3605046,310776.1936412,8.4340744,10136.759656,7009.8953844,14643.9475443,45.5966909,62.0895448,3.0584514,190.1441649),(10107,'Cervus_giganteus-radius.tif',249,3,333,856.3955466,95.3972375,145.0904616,1.8,95.4301874,144.6758344,0.2513955,23.9203465,30.8155923,168326.5785042,310771.3107634,8.8322171,10084.8722322,7036.9623821,14628.6199547,45.9162246,62.2098605,3.0378003,189.0330835),(10108,'Cervus_giganteus-radius.tif',249,3,334,849.9822218,95.4338705,144.9881763,1.8,95.4504429,144.6691319,0.2577117,24.0453939,30.7453673,168318.9221304,309888.310764,9.2021803,10079.1871466,7000.0484431,14590.5968675,45.9320868,62.2558458,3.0309354,190.3958703),(10109,'Cervus_giganteus-radius.tif',249,3,335,863.262562,95.9203808,144.5748702,1.8,95.9902835,144.2924554,0.2266738,24.4978073,30.9312366,174815.4603371,315247.7210536,7.2667999,10191.8887251,7135.963558,15046.4405814,45.8603151,62.4246614,3.0796032,192.2188821),(10110,'Cervus_giganteus-radius.tif',249,3,336,857.6610576,95.9662641,144.4675215,1.8,96.0261693,144.1604848,0.2328255,24.6243718,31.0506186,175051.9452403,314057.7939136,7.6096374,10114.3812159,7108.8897764,14939.1489247,46.5060565,62.5177587,3.0590222,193.6859287),(10111,'Cervus_giganteus-radius.tif',249,3,337,844.3249362,95.9232479,144.2464993,1.8,95.964748,143.9897497,0.2479041,24.5467601,31.1452809,173167.3355297,310213.9271385,8.4724819,9960.222484,7054.5902924,14764.7267509,46.5065951,62.637252,3.038511,190.8992811),(10112,'Cervus_giganteus-radius.tif',249,3,338,849.005184,96.2404842,144.0294621,1.8,96.5310083,143.7832088,0.2269548,24.8117486,31.3795582,176964.1173668,313229.3868344,7.1642142,9981.9565665,7132.2710908,14941.1765094,46.0542853,62.8814298,3.0732063,193.9376341),(10113,'Cervus_giganteus-radius.tif',249,3,339,839.1746048,96.1966582,144.0056204,1.8,96.4973818,143.7689987,0.2372178,24.8185496,31.4929706,175507.367204,310962.2230216,7.7238546,9874.0200542,7071.620638,14734.0752793,46.0238399,63.060283,2.9147938,199.19815),(10114,'Cervus_giganteus-radius.tif',249,3,340,830.1306688,96.1019151,143.9995713,1.8,96.4502752,143.7509581,0.2508231,24.8304857,31.5871214,174074.9707601,308815.6551093,8.5232193,9776.6317778,7010.5342551,14507.4076396,46.1437622,63.2824092,3.0804445,200.7694564),(10115,'Cervus_giganteus-radius.tif',249,3,341,820.0117842,96.0770741,143.9985899,1.8,96.321771,143.7832867,0.2623923,24.7648487,31.6628389,172516.1694507,305870.3931525,9.1956193,9660.2327362,6966.1709322,14294.5691411,46.0483737,63.4499486,3.0466409,195.8038318),(10116,'Cervus_giganteus-radius.tif',249,3,342,814.3696048,96.1334391,143.9650636,1.8,96.3366127,143.801707,0.2660008,24.8597648,31.9241778,172519.5636973,305176.5201559,9.3792641,9559.416756,6939.710218,14263.7005674,46.2268946,63.6765147,2.9031605,189.9356453),(10117,'Cervus_giganteus-radius.tif',249,3,343,815.0721567,96.2349889,143.8716127,1.8,96.4493507,143.7782358,0.2635213,24.9647488,32.0936796,174139.9071446,306601.5393361,9.2172186,9553.330845,6975.4319747,14294.9514608,46.3274454,63.9932253,2.8835854,191.7586571),(10118,'Cervus_giganteus-radius.tif',249,3,344,817.9307043,96.3844531,143.760516,1.8,96.5796881,143.6284361,0.2520318,25.0525785,32.1299946,176572.979864,309124.5941121,8.4773647,9621.05962,7048.096071,14407.2484494,46.4802292,64.1042084,2.8771043,191.0467267),(10119,'Cervus_giganteus-radius.tif',249,3,345,821.3815282,96.6237898,143.6267971,1.8,96.6433347,143.5291173,0.2401112,25.1839517,32.3463504,179326.2303047,312303.5849435,7.7420565,9654.9867564,7120.6549392,14515.0808942,46.7761575,64.3471235,3.0412595,191.6543973),(10120,'Cervus_giganteus-radius.tif',249,3,346,824.5233456,96.8712768,143.4899268,1.8,96.8553954,143.4143962,0.225612,25.2784741,32.4765338,182113.5289682,315562.4420443,6.8769326,9716.6293657,7204.2928127,14590.3823424,47.2141693,64.7746649,3.041924,196.4115024),(10121,'Cervus_giganteus-radius.tif',249,3,347,835.8614714,97.2876113,143.2931997,1.8,97.2167243,143.2619714,0.1914546,25.3340275,32.5488742,187128.0010055,322994.2541606,5.044313,9923.3617735,7386.4292261,14927.4821296,47.4091027,65.1611622,3.0491417,198.1302544),(10122,'Cervus_giganteus-radius.tif',249,3,348,836.5912705,97.3755222,143.2097257,1.8,97.2946832,143.1888741,0.1905033,25.4124472,32.600081,188510.2073451,324779.441744,4.9992738,9962.5348009,7418.0265229,14921.7319849,47.6483923,65.4833803,3.0693502,195.9080916),(10123,'Cervus_giganteus-radius.tif',249,3,349,835.8694721,97.3519125,143.1642382,1.8,97.3142865,143.1097002,0.1939641,25.4787611,32.5980675,188982.7137566,327859.7426887,5.1757879,10057.6435286,7417.2646265,14896.2572373,47.9262023,65.6734222,3.0367157,196.7674676),(10124,'Cervus_giganteus-radius.tif',249,3,350,836.5999985,97.3380385,143.1081597,1.8,97.3549547,143.1063359,0.1959736,25.5429761,32.6655547,190104.7531449,329252.7577446,5.2868239,10079.5091429,7442.5451692,14831.8550527,47.963657,66.1007646,3.0373962,196.4115024),(10125,'Cervus_giganteus-radius.tif',249,3,351,841.6567832,97.3052058,143.0196679,1.8,97.3358836,143.0309047,0.1984298,25.5621026,32.926533,192697.5645657,331482.4396793,5.4511729,10067.3350567,7538.4082371,14787.1743536,48.0748047,66.485107,3.0444963,196.7674676),(10126,'Cervus_giganteus-radius.tif',249,3,352,845.3016943,97.220795,142.9614495,1.8,97.3072712,142.9934509,0.2013802,25.7149004,33.2437292,194495.5325789,334404.0111646,5.6365741,10059.1606018,7563.5343614,14890.9505488,48.309101,66.6736783,3.0188364,196.3072426),(10127,'Cervus_giganteus-radius.tif',249,3,353,845.2985052,97.0347038,142.781426,1.8,97.2262081,142.8344274,0.2130104,25.8108898,33.6672122,195109.0039266,336086.3715136,6.296248,9982.6017436,7559.1738729,14756.907781,48.5301457,67.1537879,3.0132694,197.2708784),(10128,'Cervus_giganteus-radius.tif',249,3,354,869.0560835,97.5171952,142.3298985,1.8,97.6961204,142.4671141,0.1712911,26.129323,33.9171868,203451.30329,348639.7219016,4.2083775,10279.1461979,7786.3212589,15324.6912597,48.5445701,67.4281662,3.0330466,201.1686074),(10129,'Cervus_giganteus-radius.tif',249,3,355,873.6814453,97.4950366,142.2414918,1.8,97.6621159,142.3933673,0.1803003,26.1467692,34.125063,205592.3668225,351117.599136,4.6825632,10289.1414331,7863.0122492,15272.9586835,48.8029793,68.195967,3.0469396,202.8441736),(10130,'Cervus_giganteus-radius.tif',249,3,356,878.3497759,97.4250056,142.1528003,1.8,97.5841756,142.3128923,0.1915067,26.2173757,34.3333112,207685.9352939,353831.2041581,5.303569,10305.7698846,7921.6904651,15241.56926,48.9165084,68.5847204,3.0537688,203.556104),(10131,'Cervus_giganteus-radius.tif',249,3,357,866.7134419,96.7429152,142.1897523,1.8,97.0884074,142.3564867,0.2428338,26.5034227,34.5729645,206022.5420707,343258.5679715,8.3519767,9928.525753,7773.4315593,14982.7099462,49.1403458,68.4877389,3.0094557,200.4745651),(10132,'Cervus_giganteus-radius.tif',249,3,358,872.1776474,96.5549046,142.0843214,1.8,97.0030263,142.2795154,0.2607641,26.6230444,34.670658,208176.5553968,345540.9728418,9.6623594,9966.3805754,7819.4120896,15031.487012,49.3767323,68.6062532,2.9970384,200.3271195),(10133,'Cervus_giganteus-radius.tif',249,3,359,878.9186096,96.4461545,141.9518324,1.8,96.9052217,142.2033718,0.2775512,26.8717074,34.8970898,210456.1867755,348405.4044823,10.9977297,9983.795402,7831.8873982,14974.4311118,49.5598963,68.9712826,3.0041009,200.8305303),(10134,'Cervus_giganteus-radius.tif',249,3,360,882.1983974,96.3325339,141.8607175,1.8,96.8061828,142.0827744,0.2952452,27.1993722,34.917779,211938.0842399,350308.236226,12.4487186,10032.3745104,7792.0211764,15022.6065637,50.0142019,69.094312,2.9917802,201.6899064),(10135,'Cervus_giganteus-radius.tif',249,3,361,908.7890105,96.9765636,141.5282965,1.8,97.44301,141.8038467,0.2372009,27.1388967,35.950215,219507.7930624,374204.3720638,8.363423,10408.9606064,8088.3094018,15217.6004284,50.32762,70.3757594,3.0437466,206.6376428),(10136,'Cervus_giganteus-radius.tif',249,3,362,916.938881,96.8216106,141.3576114,1.8,97.3723301,141.6294747,0.2589333,27.4869125,36.2332378,221543.9147918,379345.0400433,10.019293,10469.5319183,8059.9781738,15189.2859292,50.591029,70.9401751,3.0262532,208.6081002),(10137,'Cervus_giganteus-radius.tif',249,3,363,922.4951787,96.747905,141.2121959,1.8,97.3286772,141.4648993,0.2742673,27.6369335,36.4009504,223070.5558241,383353.7684917,11.278309,10531.4219544,8071.4655238,15175.2703371,50.822211,71.4575155,3.0814244,209.571736),(10138,'Cervus_giganteus-radius.tif',249,3,364,933.7516188,96.6543945,141.0269801,1.8,97.3075895,141.2706029,0.2883213,27.8635912,36.7221325,226549.2718287,386922.3367197,12.5824719,10536.4887733,8130.6558776,15166.2666478,51.2462272,71.9133935,3.0758194,209.9277012),(10139,'Cervus_giganteus-radius.tif',249,3,365,975.9718716,97.3459132,140.4690001,1.8,98.013712,140.7350309,0.2343481,28.0064296,37.5690577,240341.8428125,409004.3212612,8.7708994,10886.7335569,8581.6666333,15941.9212446,51.5829077,72.7442881,3.08249,213.5737248),(10140,'Cervus_giganteus-radius.tif',249,3,366,984.5925532,97.1628282,140.2888218,1.8,97.9106645,140.5552649,0.2604049,28.4279152,37.7895325,241727.0790728,413721.2435079,10.8783881,10948.0381569,8503.1588535,15893.6142982,51.9797333,73.5570141,3.0948431,215.1450312),(10141,'Cervus_giganteus-radius.tif',249,3,367,1041.6375071,98.3603267,139.4888493,1.8,99.1222717,139.7367247,0.1620911,29.2726402,39.2392881,261549.2797047,450186.4511055,4.5214398,11472.8496085,8934.9398636,17094.5508456,52.4773647,74.8101499,3.1071236,220.1970275),(10142,'Cervus_giganteus-radius.tif',249,3,368,1097.2971071,99.5742489,138.7568217,1.8,100.3416296,138.9477469,0.0604935,30.5035119,39.8344284,278924.0166981,495672.954963,0.6684374,12443.3304247,9143.9968345,18536.2382057,53.1945009,75.7726499,0.0624188,226.3169193),(10143,'Cervus_giganteus-radius.tif',249,3,369,1107.8972093,99.5198812,138.4070752,1.8,100.3569197,138.54527,0.0855322,30.689331,40.3202933,281835.1401612,497495.138859,1.3475608,12338.5793694,9183.489211,18478.9801386,54.0619478,76.1530316,3.0907889,228.5569703),(10144,'Cervus_giganteus-radius.tif',249,3,370,1140.9360593,100.2218153,137.9199171,1.8,101.0117628,137.9863554,0.037177,31.3433889,40.8619429,292433.2859252,527169.6339565,0.2626985,12901.2375811,9329.9830163,19224.7616887,54.7891175,77.260245,0.0946881,229.9629429),(10145,'Cervus_giganteus-radius.tif',249,3,371,1148.0476279,100.1282807,137.8541603,1.8,100.9993192,137.9013769,0.0496684,31.3620157,41.2798015,294806.9171991,533640.4382185,0.4716398,12927.3983498,9400.1265689,19260.6971275,55.2481812,77.6880188,0.0941651,232.8970362),(10146,'Cervus_giganteus-radius.tif',249,3,372,1133.6438872,99.56491,138.1044368,1.8,100.5807281,137.9870682,0.0992394,30.6420038,41.4110357,289062.0340102,524393.0070984,1.8546725,12663.1222422,9433.522544,18966.3837744,54.5506649,77.9738708,3.0698926,229.8154973),(10147,'Cervus_giganteus-radius.tif',249,3,373,1135.1863459,99.4327791,138.0631078,1.8,100.4427625,137.8922963,0.1201569,30.6031327,41.3217535,288646.9650288,528485.360053,2.7184575,12789.5191971,9431.9417533,18997.6640646,54.2108393,78.1158136,3.0479447,226.6728845),(10148,'Cervus_giganteus-radius.tif',249,3,374,1185.0662439,100.335367,137.3641477,1.8,101.1566483,137.316819,0.0580642,31.4877368,41.5044967,306151.6313408,569504.9112838,0.665151,13721.5231343,9722.8846189,20529.4514891,55.3051359,78.9328793,3.0543827,232.0376602),(10149,'Cervus_giganteus-radius.tif',249,3,375,1193.3312016,100.1766031,137.3469755,1.8,101.0187806,137.2465748,0.0802735,31.4581187,41.8384715,306846.5200408,578279.4679741,1.2788569,13821.7159254,9754.1281012,20512.2916892,55.5960829,79.5862919,3.0929823,236.4388),(10150,'Cervus_giganteus-radius.tif',249,3,376,1203.424014,100.0119673,137.3208465,1.8,100.8457748,137.14721,0.0982489,31.4262201,41.8241566,308325.5009138,582850.3504121,1.9298585,13935.7347099,9811.090872,20502.5070898,55.7122873,79.8271963,3.0499581,234.259823),(10151,'Cervus_giganteus-radius.tif',249,3,377,1253.4593943,100.8945286,136.6462356,1.8,101.3078769,136.6459802,0.0291414,31.8256498,42.0107447,325344.1391632,625959.4673817,0.1773605,14899.9850266,10222.7021629,22216.2475921,56.7264175,80.6830051,3.0509328,240.1711952),(10152,'Cervus_giganteus-radius.tif',249,3,378,1272.4155951,100.9171264,136.5295876,1.8,101.1458302,136.5730295,0.0290877,31.9428675,42.4214215,328926.4812453,639362.3009649,0.1793807,15071.6849633,10297.3373102,22483.3053813,57.097051,81.5015188,3.0571379,243.7129591),(10153,'Cervus_giganteus-radius.tif',249,3,379,1318.9483427,101.0981834,136.3776251,1.8,100.9386744,136.4925943,0.0177288,32.0876577,42.7385854,335286.1630643,660926.0582764,0.0690861,15464.3878013,10449.0694119,22978.320647,57.4703227,82.3231081,3.0632195,243.7129591),(10154,'Cervus_giganteus-radius.tif',249,3,380,1425.9683079,100.3225323,136.7584844,1.8,99.8712738,136.9366482,0.0668357,31.6795842,43.5733584,333609.4294808,658044.3470455,1.0600554,15101.9882666,10530.7388993,22264.9228125,57.1379808,83.2896745,3.0485974,244.1299982),(10155,'Cervus_giganteus-radius.tif',249,3,381,1544.5738054,100.5841934,136.6301152,1.8,99.7953866,136.8675019,0.037319,31.8349188,43.9497953,352470.8045111,704966.9266193,0.3583568,16040.2778177,11071.8298609,23663.5396188,57.6481637,84.1453751,3.0495458,247.1683512),(10156,'Cervus_giganteus-radius.tif',249,3,382,1578.8500241,100.6454642,136.6555012,1.8,99.4343369,136.9313853,0.0610647,31.7814126,43.3326305,358822.5540213,728091.4818352,0.9800126,16802.3836407,11290.3274167,24552.417628,58.3942339,84.7967257,3.0247799,250.9618205),(10157,'Cervus_giganteus-radius.tif',249,3,383,1629.0671828,100.7435279,136.5338618,1.8,99.0792017,136.7313138,0.0912487,31.8673237,42.9508613,367783.1137394,775216.6297291,2.2544255,18048.9193234,11541.0731513,25858.6271267,59.3774656,86.1275278,3.0215693,257.8979025),(10158,'Cervus_giganteus-radius.tif',249,3,384,1685.6532987,100.6315941,136.360786,1.8,98.7049725,136.6113701,0.1357854,31.9094384,43.4359917,372748.025426,822774.0060954,5.1481671,18942.2176047,11681.4348478,26901.6294429,60.1590433,86.660731,3.0123176,258.5055731),(10159,'Cervus_giganteus-radius.tif',249,3,385,1803.8363251,101.0178447,135.7264499,1.8,98.7267269,135.9447189,0.171257,32.3993927,44.5109938,394994.2740616,924174.489246,8.7315798,20762.836569,12191.4097984,29071.4101797,60.4490051,87.9601885,3.0584514,257.4555657),(10160,'Cervus_giganteus-radius.tif',249,3,386,1787.931696,99.8885905,135.4846398,1.8,98.3425588,135.7782782,0.2414183,33.3115663,43.8762588,405056.4926061,930396.7152349,17.0328099,21205.0147593,12159.6351583,29016.8532792,60.7336685,87.6078941,3.0482685,255.7799995),(10161,'Cervus_giganteus-radius.tif',249,3,387,1798.4669532,98.7078532,134.7609835,1.8,98.1594054,135.4358283,0.2870779,33.7204046,43.4044362,425300.6797049,925758.565723,24.0318501,21328.6623835,12612.5615718,28702.0270379,60.7694553,87.6268594,3.0038565,254.0612474),(10162,'Cervus_giganteus-radius.tif',249,3,388,1803.3720601,98.2315981,134.3536296,1.8,97.8773131,135.1514093,0.3206707,33.6263617,43.56568,438089.5840832,898911.2478141,29.8617382,20633.4722353,13028.158904,28192.4029068,60.6128506,87.6268594,3.0038565,254.4782866),(10163,'Cervus_giganteus-radius.tif',249,3,389,1753.9238088,98.4553748,134.5513816,1.8,97.625903,135.0075741,0.3211183,32.5643448,43.4199776,431594.004211,858857.017577,29.1212616,19780.2270941,13253.5755654,27416.1598202,59.8800815,87.5130062,3.0135836,251.5441934),(10164,'Cervus_giganteus-radius.tif',249,3,390,1720.7796068,98.3186969,134.7793893,1.8,97.4337532,134.9933968,0.3211515,31.489053,43.7483777,415623.9728389,837293.9494316,28.5766579,19138.8570998,13198.9988126,26316.1370738,58.9893638,87.405342,3.0776406,248.1498752),(10165,'Cervus_giganteus-radius.tif',249,3,391,1718.0247328,98.1656036,134.8247357,1.8,97.3351068,135.1756117,0.3072376,30.4950852,43.9846078,400128.2961735,823185.4853518,26.1889804,18715.3080694,13121.0748582,25940.284549,57.7704416,86.9807822,3.0227523,243.3927702),(10166,'Cervus_giganteus-radius.tif',249,3,392,1645.102341,98.3681369,135.3031621,1.8,97.3156313,135.4970136,0.2641957,30.1715533,44.0867829,353708.2374155,790729.7546963,18.6966972,17935.7553872,11723.2359203,24562.1998657,56.2650922,86.5541398,3.0221637,240.857828),(10167,'Cervus_giganteus-radius.tif',249,3,393,1545.4299374,98.7766057,135.8993324,1.8,97.2818536,136.1936057,0.2288183,29.5172675,43.701041,302103.9417814,753091.3845608,13.2521604,17232.8019451,10234.8207479,23070.9515535,54.7730437,86.5039966,3.0270956,246.4921971),(10168,'Cervus_giganteus-radius.tif',249,3,394,1494.271828,98.7012362,136.3192241,1.8,97.2647544,136.6094045,0.2100972,28.5954441,43.5995079,274536.5250162,728906.9011906,10.8322687,16718.2368708,9600.7085719,22093.2500398,53.5505938,86.1275278,3.0215693,242.8461735),(10169,'Cervus_giganteus-radius.tif',249,3,395,1462.3844089,98.5376434,136.6758973,1.8,97.0965894,136.83823,0.2003074,27.7792601,43.1313984,253688.2573908,712669.5598546,9.6491258,16523.2194254,9132.289929,21365.6539276,52.2942042,85.5554027,3.0359271,243.3063985),(10170,'Cervus_giganteus-radius.tif',249,3,396,1437.2555201,98.2232808,136.8285828,1.8,96.8864159,136.8792279,0.192428,26.7854912,43.0018872,237438.9470928,698735.2261305,8.7609704,16248.9432992,8864.4611707,20918.5263182,50.5304436,84.9566099,3.0097096,239.4518553),(10171,'Cervus_giganteus-radius.tif',249,3,397,1444.6536036,97.9348068,136.7370452,1.8,96.6546835,136.659042,0.1883473,26.0884067,42.927427,228701.8074038,698726.8521722,8.4409169,16276.9329875,8766.4153072,20793.3019614,49.7517627,84.5885336,3.0040059,239.7035607),(10172,'Cervus_giganteus-radius.tif',249,3,398,1475.5165961,97.5544439,136.4008844,1.8,96.2642958,136.2916849,0.1921702,25.4744836,42.8174739,225685.7060632,708161.4259039,8.9704032,16539.0753378,8859.2848248,20978.295938,48.7953483,84.3699808,3.0241864,236.1007229),(10173,'Cervus_giganteus-radius.tif',249,3,399,1502.7341739,97.0012247,135.9813084,1.8,95.9461226,135.8049899,0.2076834,24.7210075,42.4194876,223412.8714509,703532.6143392,10.6483308,16585.1276046,9037.3692032,20860.1753753,48.6913724,83.5165816,3.0229811,245.154708),(10174,'Cervus_giganteus-radius.tif',249,3,400,1505.5037625,95.8919151,135.781273,1.8,95.2337742,135.4117633,0.2423869,24.7857118,41.1322839,216112.8413044,673632.9404367,14.455297,16377.231614,8719.2509697,20435.3551838,48.5051341,81.3836338,3.0198572,240.0848236),(10175,'Cervus_giganteus-radius.tif',249,3,401,1509.9681589,94.118663,135.362601,1.8,93.6554572,134.7561031,0.3090745,25.1322312,38.8321659,201331.03546,633939.3255111,23.2846448,16325.1086009,8010.8699272,20867.9813976,47.9371216,77.1909115,2.9398303,222.5845241),(10176,'Cervus_giganteus-radius.tif',249,3,402,1531.5305772,93.3509118,135.0222002,1.8,92.8187156,134.3587799,0.3405657,25.2296981,38.298776,193837.1329267,627165.3548759,28.4787154,16375.5978661,7682.89547,20751.413068,47.5230611,75.7823959,2.9186187,220.0495819),(10177,'Cervus_giganteus-radius.tif',249,3,403,1553.0296612,92.8408005,134.4586536,1.8,92.2539649,133.7773416,0.3566724,25.0969429,37.8185792,190211.3300692,625617.6262745,31.5553124,16542.5999271,7579.0637352,20980.2212858,46.9896787,74.6483206,2.726875,221.5166285),(10178,'Cervus_giganteus-radius.tif',249,3,404,1578.0838581,92.3278372,133.9675178,1.8,91.8391518,133.2330891,0.3677472,25.014297,38.0290844,187554.1303283,606060.3387457,33.9946748,15936.7586225,7497.8773409,20689.9357396,46.4630275,75.0417837,2.7291822,219.4419113),(10179,'Cervus_giganteus-radius.tif',249,3,405,1540.6424913,91.0096535,133.4227227,1.8,91.2441925,132.737046,0.400095,25.0888605,38.6520608,179507.471453,543669.765204,38.9563818,14065.7381299,7154.8674606,18637.2848402,46.1402716,74.9679358,2.7035805,215.9865191),(10180,'Cervus_giganteus-radius.tif',249,3,406,1510.0030152,90.0790286,132.8760316,1.8,90.2450962,132.2243451,0.4171538,24.2758754,38.8442643,169755.5950437,493049.0537999,41.3123217,12692.9692912,6992.7692526,17044.4979559,45.565051,74.7669473,2.6573824,220.9521437),(10181,'Cervus_giganteus-radius.tif',249,3,407,1432.5838325,88.9316423,132.1013144,1.8,89.3667893,131.738773,0.4252482,23.6694632,39.2329869,157838.03317,432870.9276776,40.6364248,11033.3411219,6668.4247172,15038.146626,45.0520883,74.0386221,2.6390037,217.2018603),(10182,'Cervus_giganteus-radius.tif',249,3,408,1294.2026488,87.9033921,131.0675157,1.8,88.696295,131.1004808,0.4269317,23.6010904,39.5982699,139036.4718625,369348.951747,36.9844599,9327.4012421,5891.1037357,12837.2863052,44.4280212,73.0785485,2.6384918,228.4958963),(10183,'Cervus_giganteus-radius.tif',249,3,409,1118.1516583,86.4402542,129.8851891,1.8,87.6005716,130.1201851,0.4323103,23.9294404,40.2179911,115671.2244119,295189.0204805,32.7125612,7339.7256458,4833.8457721,10211.3891283,43.3142456,71.7900517,2.6217041,264.5212051),(10184,'Cervus_giganteus-radius.tif',249,3,410,906.7828463,83.3847603,128.4270364,1.8,85.2521048,129.0788181,0.4644525,23.5078881,40.5477347,86902.7418709,198293.8836218,30.3234624,4890.3812991,3696.7481467,7022.0274674,42.2495807,68.7782731,2.5743843,262.784565),(10185,'Cervus_giganteus-radius.tif',249,3,411,725.4815435,79.7491631,125.9670759,1.8,81.2471192,127.1240614,0.1576848,22.115691,35.5628529,65169.6733498,98364.8050853,2.9816191,2765.9424662,2946.7618029,4133.5122989,38.9853896,52.0986737,2.7074568,194.6927503),(10186,'Cervus_giganteus-radius.tif',249,3,412,633.6284077,78.5419705,125.0947349,1.8,79.4008298,125.9996881,-0.091489,25.7246618,27.0841438,49228.6373368,75072.7606232,0.8814741,2771.8343687,1913.6748113,3605.5054587,37.3826598,49.4608036,2.4546406,191.8629169),(10187,'Cervus_giganteus-radius.tif',249,3,413,544.4404036,77.75007,124.6466934,1.8,78.8695948,125.5518654,-0.1870466,29.1466999,24.1057711,36101.6726566,61340.3977618,3.1378185,2544.6353668,1238.619562,2643.6321698,35.2368438,47.4644813,2.6819936,192.3663277),(10188,'Cervus_giganteus-radius.tif',249,3,414,396.4812505,76.1124303,124.4859793,1.8,77.9227825,124.8437797,-0.3158073,32.5888422,23.2443338,21551.1882656,41903.3028167,6.3742544,1802.7319342,661.3057357,1648.5567585,33.0859763,46.3127131,2.6696465,162.7305043),(10189,'Cervus_giganteus-radius.tif',249,3,415,220.4263437,71.7586217,124.9739198,1.8,74.4022682,125.1619486,-0.8262499,38.3264711,18.791748,8934.1485118,14709.1515414,19.867992,782.7452514,233.1064731,607.9515612,13.3203281,31.938857,1.7602765,81.1477885),(10190,'Cervus_giganteus-radius.tif',249,3,416,127.1709015,68.8449465,125.0460302,1.8,69.5873038,126.1090367,1.5052101,37.599738,22.7015812,858.8159858,5767.0814378,21.1041088,254.0387558,22.8410098,150.8575682,10.5691025,29.4108805,1.7767877,70.522497),(10191,'Cervus_giganteus-radius.tif',249,3,417,49.3357937,68.345711,123.5475711,1.8,69.0238575,124.9422308,1.4260128,31.1356563,15.9013979,223.2385272,1153.3367006,8.0514682,72.5305228,7.1698674,39.5281255,6.8750081,24.0202896,1.7506498,54.931581),(10192,'Cervus_giganteus-radius.tif',249,3,418,13.034724,67.9866828,122.7521678,1.8,68.1284931,122.7927334,1.3517489,29.1377669,18.9544177,17.7895104,88.5589056,2.0698723,4.672204,0.610531,3.059478,4.2430793,12.4015432,1.815775,28.125591),(10193,'Cervus_giganteus-radius.tif',249,3,419,35.3455164,104.0571911,139.5863406,1.8,103.8129484,139.4247713,0.478201,4.3193501,39.8064791,100.2287002,159.5590626,1.2475092,4.0083691,23.2045787,6.5247466,7.2920472,10.2135672,2.7532739,29.8622311),(10194,'Cervus_giganteus-radius.tif',249,3,420,35.0477557,104.1407222,139.6685489,1.8,104.268673,139.7324845,1.0044538,4.4270682,5.0071378,98.6237189,102.7645055,4.1596716,20.5236026,22.2774336,39.8276821,7.4892533,10.0679118,2.4468544,33.5514406),(10195,'Cervus_giganteus-radius.tif',249,3,421,35.0630857,104.1979041,139.7341449,1.8,104.2709555,139.8401488,1.0669633,4.4471426,4.4919887,98.6002504,103.1265573,4.481751,22.9578842,22.1715963,42.1659889,7.2920472,10.0219603,2.6011732,30.5130876),(10196,'Cervus_giganteus-radius.tif',249,3,422,35.2730065,104.2559446,139.7839301,1.8,104.2839251,139.8414532,1.1420156,4.4223101,4.7103566,99.2788322,105.0708609,4.8626294,22.3063494,22.449541,41.7556025,7.4741268,9.817219,1.9756881,33.403995),(10197,'Cervus_giganteus-radius.tif',249,3,423,35.3683436,104.3277909,139.8584353,1.8,104.4492956,139.9194551,1.0744778,4.4523744,5.067346,99.6154323,106.0117922,4.5580463,20.9205751,22.3735522,40.1128759,7.4377484,10.0587383,1.9195673,37.9525804),(10198,'Cervus_giganteus-radius.tif',249,3,424,35.5658437,104.3950914,139.9552553,1.8,104.5488632,140.1344051,1.0502152,4.2544175,5.3399466,99.9767398,109.2702579,4.4611942,20.4627997,23.4995131,39.0602289,7.5958825,10.3482575,2.2974387,31.624169),(10199,'Cervus_giganteus-radius.tif',249,3,425,35.6542991,104.4631578,140.0374136,1.8,104.686902,140.2875837,1.0258895,3.7787397,5.3879597,99.978769,110.3403583,4.3458153,20.4790616,26.4582311,38.9712851,7.5958825,10.4016452,2.2390857,33.5514406),(10200,'Cervus_giganteus-radius.tif',249,3,426,35.5378132,104.5115101,140.0918012,1.8,104.6487092,140.2734528,1.1333066,4.3056311,5.3202053,99.3996303,108.407124,4.8598332,20.3764925,23.0859606,39.0167251,7.4741268,10.0679118,2.2655346,33.4471808),(10201,'Cervus_giganteus-radius.tif',249,3,427,35.3407048,104.5776878,140.148813,1.8,104.6555634,140.1758677,1.1498531,4.2460696,5.0196594,98.4963752,106.1156088,4.9066354,21.1400018,23.1970703,40.1646465,6.8750081,10.1864155,2.0533096,36.0253088),(10202,'Cervus_giganteus-radius.tif',249,3,428,35.2178967,104.6527842,140.2218753,1.8,104.7373242,140.3018667,1.1671858,3.5045303,4.9071583,97.5744172,105.3462695,4.9642811,21.4678767,27.8423663,40.650524,7.171309,10.0219603,2.1112158,36.1295686),(10203,'Cervus_giganteus-radius.tif',249,3,429,35.2240511,104.723586,140.3109588,1.8,104.8456125,140.4940601,1.1126973,3.6579214,5.4139386,97.6881574,105.9875992,4.7224904,19.576801,26.7059204,37.1982437,6.8750081,9.6560369,2.1341126,26.5110988),(10204,'Cervus_giganteus-radius.tif',249,3,430,35.428265,104.786237,140.385444,1.8,104.8835364,140.489798,1.2721312,3.9051574,5.4099916,99.1034495,107.8949797,5.3934812,19.9436502,25.3775816,37.5054806,6.8750081,9.6942032,1.7942729,34.202297),(10205,'Cervus_giganteus-radius.tif',249,3,431,35.2982395,104.8483325,140.4667587,1.8,104.9624668,140.6145398,1.1970217,3.636064,5.2214341,97.8489993,105.9666257,5.0987048,20.2945442,26.9106921,38.9879191,7.2920472,10.3838798,1.9974238,31.225018),(10206,'Cervus_giganteus-radius.tif',249,3,432,35.2149873,104.8906482,140.513257,1.8,105.0255296,140.572605,1.2068369,3.5910877,5.0645401,97.8141352,104.2860202,5.1254261,20.5914096,27.2380245,38.7612016,7.3046961,10.2496577,2.1471715,36.4855338),(10207,'Cervus_giganteus-radius.tif',249,3,433,35.1410227,104.9296559,140.5690231,1.8,105.0949663,140.7007179,1.176947,4.0408725,5.0328514,98.4395413,102.7020418,4.9943543,20.4063332,24.3609619,39.0875293,7.3046961,9.2955728,2.1587989,31.1207582),(10208,'Cervus_giganteus-radius.tif',249,3,434,35.2236594,104.9780543,140.6428016,1.8,105.0724669,140.7606337,1.2100123,3.949691,5.3105444,98.1152789,105.278584,5.1390465,19.8244429,24.8412545,37.5486078,6.8750081,10.6125108,2.1251038,38.8119564),(10209,'Cervus_giganteus-radius.tif',249,3,435,35.1146707,105.0282572,140.7080841,1.8,105.1462459,140.7431562,1.2443813,3.8407464,5.0550071,97.5388791,104.3252498,5.2507199,20.6380025,25.3958133,39.4232353,6.8750081,10.3927663,2.0899424,36.2338284),(10210,'Cervus_giganteus-radius.tif',249,3,436,35.193335,105.0799412,140.7859893,1.8,105.1593184,140.8472943,1.2614115,4.0518473,5.2120931,97.813291,106.2894906,5.3217973,20.3928611,24.1404188,37.2398001,6.8750081,10.8448349,2.1587989,37.24065),(10211,'Cervus_giganteus-radius.tif',249,3,437,35.4472877,105.1233453,140.8574312,1.8,105.1303315,140.9854083,1.2962206,4.5315342,5.3665,99.4162819,109.2705258,5.4735567,20.3615999,21.9387688,37.7567881,6.8750081,10.7679505,2.070143,34.0548514),(10212,'Cervus_giganteus-radius.tif',249,3,438,35.3682876,105.1737633,140.9195791,1.8,105.2451379,141.0078865,1.2598736,4.1034052,5.4678906,98.4771959,107.3037376,5.3429835,19.6243387,23.9988964,36.2815908,6.8750081,10.8448349,2.1587989,37.3449098),(10213,'Cervus_giganteus-radius.tif',249,3,439,35.2121899,105.2197449,140.9739485,1.8,105.349186,140.9823527,1.2963976,3.4801305,4.9308056,97.4137009,105.5499012,5.4377962,21.4062185,27.9913933,38.6851638,7.1226669,10.0219603,2.1112158,33.4471808),(10214,'Cervus_giganteus-radius.tif',249,3,440,35.3102126,105.2441656,141.0358158,1.8,105.3625197,141.0736211,1.2887511,3.7901491,4.9320859,97.9278705,106.3015293,5.4291665,21.5530573,25.8374718,41.2788825,7.3995682,9.994288,2.0152155,35.3744524),(10215,'Cervus_giganteus-radius.tif',249,3,441,35.1376098,105.2677918,141.1012196,1.8,105.2838323,141.0814651,1.3039444,4.2869062,4.7429519,97.4814063,104.4680982,5.4490491,22.0259663,22.7393376,39.9968736,7.3041269,9.817219,1.9756881,36.1295686),(10216,'Cervus_giganteus-radius.tif',249,3,442,35.0047868,105.3198458,141.1823021,1.8,105.4033442,141.1832012,1.2808432,3.8462241,4.7730137,97.1615645,102.9581185,5.3572318,21.5708827,25.2615457,41.8326854,7.3046961,9.6942032,1.7942729,31.9801342),(10217,'Cervus_giganteus-radius.tif',249,3,443,35.0371813,105.3660678,141.2511488,1.8,105.4539237,141.2400382,1.2523045,3.5528917,4.8393565,96.8501755,103.5532789,5.266945,21.3981504,27.2595347,40.8726845,7.3046961,9.798394,1.8370484,36.381274);
INSERT INTO `slices_w` VALUES (10218,'Cervus_giganteus-radius.tif',249,3,444,35.1408549,105.4171197,141.3103672,1.8,105.5084106,141.344738,1.2574724,3.5362312,5.0361733,97.5363645,104.4499528,5.3004062,20.7399441,27.5820099,40.1066428,7.4741268,9.6081159,1.7506498,36.2338284),(10219,'Cervus_giganteus-radius.tif',249,3,445,35.1059427,105.4931707,141.3811136,1.8,105.6757488,141.4945408,1.2410708,3.4664906,5.3508731,97.4559493,104.6532235,5.237598,19.5581585,28.1137211,37.7311814,7.4377484,10.0311674,1.7429871,36.2338284),(10220,'Cervus_giganteus-radius.tif',249,3,446,35.9747751,105.6062157,141.5047428,1.8,105.9897075,141.9501973,1.1339768,4.2411685,5.8869142,100.0090422,122.9663839,4.9226709,20.8880882,23.5805396,37.7820763,7.6817123,10.6298941,1.815775,34.0548514),(10221,'Cervus_giganteus-radius.tif',249,3,447,36.533538,105.7356838,141.5363109,1.8,106.216915,141.8376306,1.1811796,4.2881779,5.9779492,106.8444981,122.8293584,5.2104512,20.5470729,24.9160599,38.0327502,8.1640721,10.9549376,1.7681919,35.521898),(10222,'Cervus_giganteus-radius.tif',249,3,448,36.4938701,105.9628858,141.2351984,1.8,106.6829375,140.5045397,-0.8513204,4.0161674,8.298471,88.9719557,181.8732424,3.4409546,21.9164762,22.1534478,32.5017735,7.5936962,14.6975911,0.9097532,39.879852),(10223,'Cervus_giganteus-radius.tif',249,3,449,1.4618361,105.5752042,139.9646014,1.8,105.5438485,140.0089846,1.0402349,1.2763637,2.4507898,0.5884327,1.8733063,0.1812545,0.7643684,0.4610228,0.9973651,3.0763405,5.3839753,2.070143,13.0559739),(10224,'Cervus_giganteus-radius.tif',249,3,450,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10225,'Cervus_giganteus-radius.tif',249,3,451,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10226,'Cervus_giganteus-radius.tif',249,3,452,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10227,'Cervus_giganteus-radius.tif',249,3,453,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10228,'Cervus_giganteus-radius.tif',249,3,454,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10229,'Cervus_giganteus-radius.tif',249,3,455,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10230,'Cervus_giganteus-radius.tif',249,3,456,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10231,'Cervus_giganteus-radius.tif',249,3,457,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10232,'Cervus_giganteus-radius.tif',249,3,458,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10233,'Cervus_giganteus-radius.tif',249,3,459,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10234,'Cervus_giganteus-radius.tif',249,3,460,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10235,'Cervus_giganteus-radius.tif',249,3,461,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10236,'Cervus_giganteus-radius.tif',249,3,462,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10237,'Cervus_giganteus-radius.tif',249,3,463,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10238,'Cervus_giganteus-radius.tif',249,3,464,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10239,'Cervus_giganteus-ulna.tif',249,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10240,'Cervus_giganteus-ulna.tif',249,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10241,'Cervus_giganteus-ulna.tif',249,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10242,'Cervus_giganteus-ulna.tif',249,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10243,'Cervus_giganteus-ulna.tif',249,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10244,'Cervus_giganteus-ulna.tif',249,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10245,'Cervus_giganteus-ulna.tif',249,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10246,'Cervus_giganteus-ulna.tif',249,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10247,'Cervus_giganteus-ulna.tif',249,4,9,13.269598,120.4123664,82.9233586,1.8,120.4915502,82.7967496,-1.0267749,3.1003894,5.321489,22.6055982,67.8971985,1.619134,12.7590602,7.2912125,16.9759078,6.6764752,10.7765203,1.160669,27.6832541),(10248,'Cervus_giganteus-ulna.tif',249,4,10,64.6382435,120.6838783,82.2807379,1.8,120.558177,82.5328745,-1.0148376,4.8604523,8.7659615,290.3510194,975.8259305,7.7724429,111.319897,59.7374482,143.5795016,10.1322212,17.4962708,1.1401038,44.7844026),(10249,'Cervus_giganteus-ulna.tif',249,4,11,101.0041582,121.4404276,80.9859005,1.8,121.4427652,80.9905122,-1.0341933,6.0032364,13.084874,737.233752,3470.7063561,12.4345322,265.2456833,122.8060511,319.3646037,12.1620075,26.1404327,1.129204,63.2051521),(10250,'Cervus_giganteus-ulna.tif',249,4,12,152.3564108,122.5526084,78.8059905,1.8,122.3422658,79.0821239,-1.0616875,6.7727737,17.0517346,1380.6025334,9729.517265,19.3604858,570.5881249,203.8459578,651.4999117,13.6496246,34.0566711,1.056345,82.1293125),(10251,'Cervus_giganteus-ulna.tif',249,4,13,201.1355676,123.1279763,77.4220528,1.8,122.4616378,78.4940681,-1.0661314,7.4632075,19.8695809,2213.0111545,18695.785112,25.6854839,940.9249845,296.5227962,1051.8447273,14.8859286,37.8954613,1.0614952,91.8952279),(10252,'Cervus_giganteus-ulna.tif',249,4,14,242.3398421,123.1545324,77.0043731,1.8,122.3913386,78.2768596,-1.0648974,8.1110281,22.2090102,3198.7163695,27713.8809432,30.905142,1247.8665519,394.3663273,1389.6564575,15.9987966,41.4153261,1.0374941,101.0534728),(10253,'Cervus_giganteus-ulna.tif',249,4,15,279.5984794,123.0583619,76.7678263,1.8,122.2419551,78.1676019,-1.0712913,8.7024977,23.9052739,4355.7479226,36924.1804796,35.9082525,1544.6039523,500.5169892,1724.0975499,17.0298562,44.2390876,1.0636978,108.0327406),(10254,'Cervus_giganteus-ulna.tif',249,4,16,308.8044856,123.0628134,76.4178276,1.8,122.1294137,78.0343006,-1.087562,9.0364761,25.3525445,5444.9708548,45118.0122552,40.3558317,1779.6246178,602.5546658,1988.6178778,17.8703032,46.3684923,1.0573973,113.4407021),(10255,'Cervus_giganteus-ulna.tif',249,4,17,346.5369552,123.0174364,75.9687723,1.8,121.9817495,77.8115109,-1.1139337,9.5126007,27.0221283,6878.1505108,56562.8168237,46.5168202,2093.2036217,723.0567911,2340.1394596,18.8255295,49.1969309,1.1188669,120.2725243),(10256,'Cervus_giganteus-ulna.tif',249,4,18,373.9051478,122.9788603,75.7631445,1.8,121.9718333,77.6816246,-1.13122,9.7632006,27.9277511,7948.1974776,65432.9800193,51.0319472,2342.9376668,814.0975281,2619.7234493,19.0743113,50.9320775,1.088283,123.7100283),(10257,'Cervus_giganteus-ulna.tif',249,4,19,403.9864205,122.9194532,75.6503518,1.8,122.0339542,77.4275717,-1.1483629,10.012753,28.5332483,9144.8300237,76344.3562966,56.0137555,2675.6279332,913.3182478,2982.2838805,19.5550507,52.4659434,1.1217997,128.1111681),(10258,'Cervus_giganteus-ulna.tif',249,4,20,431.5380699,122.9755843,75.4988344,1.8,122.1411244,77.2230055,-1.1667645,10.4617401,29.0914959,10504.1384741,86585.6845239,60.807295,2976.322865,1004.0527103,3318.1857496,20.2514677,53.7127192,1.1680054,131.5486722),(10259,'Cervus_giganteus-ulna.tif',249,4,21,461.1196619,122.9737982,75.5363229,1.8,122.2476424,77.1099365,-1.1805282,10.9174358,29.5143337,12207.2210161,98193.6021823,65.7301594,3326.9801486,1118.1399401,3710.8178354,21.0547569,54.9799191,1.1351135,134.9861762),(10260,'Cervus_giganteus-ulna.tif',249,4,22,492.2253053,122.9346563,75.7329743,1.8,122.2989018,77.0851163,-1.1909332,11.4070437,29.9154058,14191.8871708,110917.002803,70.7583943,3707.6883916,1244.1336677,4155.7799965,21.8785551,56.1511969,1.1448021,138.6321998),(10261,'Cervus_giganteus-ulna.tif',249,4,23,521.0602575,122.9002937,75.9556372,1.8,122.3637592,77.0817842,-1.1956889,11.9843128,30.406419,16491.7535733,124331.052864,75.186493,4088.9738767,1376.1117465,4620.9194516,22.964663,57.380646,1.1708209,141.566293),(10262,'Cervus_giganteus-ulna.tif',249,4,24,545.9276406,122.9152062,76.2379415,1.8,122.3788224,77.2083254,-1.1932552,12.5124358,31.1112591,18658.4673207,136813.4359731,78.6233672,4397.5538098,1491.1938499,4983.8910297,23.9159716,58.821761,1.1332866,145.7157275),(10263,'Cervus_giganteus-ulna.tif',249,4,25,574.3237846,122.8404467,76.5557409,1.8,122.3664766,77.3344294,-1.1879009,13.1065078,31.9946203,20954.239658,150142.4832784,82.3596811,4692.7415245,1598.7660428,5342.4172869,24.8615125,60.4273342,1.161236,147.9378903),(10264,'Cervus_giganteus-ulna.tif',249,4,26,593.3627341,122.7410402,76.8960216,1.8,122.3641323,77.4756669,-1.1831968,13.4685485,32.6957775,23085.0744569,162047.4758125,84.7659066,4956.2202946,1713.9986909,5642.5807704,25.6753145,61.8870071,1.1257801,151.5839139),(10265,'Cervus_giganteus-ulna.tif',249,4,27,612.4510306,122.6236489,77.2796457,1.8,122.363361,77.7305217,-1.1809639,13.827924,33.4946957,25348.9985651,176533.6920477,87.3329277,5270.496959,1833.1745675,6013.1523142,26.3654995,63.3057456,1.1587745,154.4137473),(10266,'Cervus_giganteus-ulna.tif',249,4,28,644.6584221,122.5762316,77.764573,1.8,122.3382527,78.0548569,-1.1752823,13.975509,34.2304906,28622.5467185,194709.8979753,91.4939312,5688.2006203,2048.0503909,6513.5685172,27.31218,64.6591218,1.160669,158.9191469),(10267,'Cervus_giganteus-ulna.tif',249,4,29,678.7491138,122.4638535,78.4005597,1.8,122.3209218,78.4416017,-1.1712931,14.1713565,34.9003418,32016.7002878,216641.8966061,96.0101381,6207.4434007,2259.2544607,7106.2412002,28.0958417,66.3029614,1.1216405,162.7126162),(10268,'Cervus_giganteus-ulna.tif',249,4,30,712.947843,122.3702579,78.9670649,1.8,122.343617,78.7329444,-1.1669798,14.9740941,35.5385744,35835.1764648,239998.4967418,100.4787644,6753.1830126,2393.1448744,7747.1162552,29.9285721,67.6741554,1.1383886,167.4265354),(10269,'Cervus_giganteus-ulna.tif',249,4,31,747.3041807,122.2001457,79.5038984,1.8,122.2296787,79.0350731,-1.1633038,15.6036016,36.1689226,39649.4082125,264137.1799474,104.9887187,7302.876645,2541.0420794,8388.3582969,30.9756589,69.0635752,1.1544671,171.3242644),(10270,'Cervus_giganteus-ulna.tif',249,4,32,773.5242993,121.9602409,80.0803495,1.8,122.0570082,79.3603253,-1.1645314,16.1219062,36.8967596,42495.6318961,286206.1258113,108.7874233,7756.9447449,2635.8937576,8900.1706261,31.873935,70.5905597,1.1507179,174.7617684),(10271,'Cervus_giganteus-ulna.tif',249,4,33,799.0346486,121.6275412,80.7529134,1.8,121.7856238,79.7634048,-1.1743487,16.4591245,37.8841569,45398.8391361,312590.939416,113.3154817,8251.2312426,2758.2778862,9443.1035322,32.5524398,72.5574985,1.1627941,179.4146137),(10272,'Cervus_giganteus-ulna.tif',249,4,34,817.527088,121.4590435,81.1648933,1.8,121.7137996,80.0908402,-1.1833826,16.9001564,38.7806824,47210.4249253,332890.8523439,116.8070288,8583.9348802,2793.4904212,9792.3683787,32.9788304,74.0822494,1.1590501,182.9563775),(10273,'Cervus_giganteus-ulna.tif',249,4,35,835.1162863,121.3235326,81.5817359,1.8,121.5982075,80.444893,-1.1904978,17.2776783,39.8465116,48842.1223516,353695.7678304,120.0079182,8876.4550208,2826.8915245,10085.6939512,33.2901392,75.7470607,1.1375962,186.1421761),(10274,'Cervus_giganteus-ulna.tif',249,4,36,848.8613391,121.2176489,82.0683892,1.8,121.527652,80.8419868,-1.1962467,17.4958919,40.7834772,49766.7816979,374783.2574749,122.5403912,9189.5856588,2844.483843,10402.2347139,33.4600625,77.1837355,1.1644426,189.9356453),(10275,'Cervus_giganteus-ulna.tif',249,4,37,856.5988654,121.0547314,82.7207011,1.8,121.4159589,81.3548992,-1.2001997,17.8536605,41.7783692,49903.9428302,393533.8956449,124.0400469,9419.5609638,2795.1658829,10594.4678745,33.7916825,78.880232,1.1558906,193.2257037),(10276,'Cervus_giganteus-ulna.tif',249,4,38,865.8537851,120.8916066,83.3925985,1.8,121.3733535,82.0065231,-1.2036652,18.112339,42.687852,50346.4652268,412799.3376259,125.7165783,9670.1829193,2779.6777174,10835.7518698,34.1456422,80.2332329,1.1574659,196.7674676),(10277,'Cervus_giganteus-ulna.tif',249,4,39,873.0518509,120.729233,84.1254482,1.8,121.2911134,82.6600971,-1.2050703,18.3248642,43.6071413,50843.0968796,433956.0124269,126.8984743,9951.4895896,2774.5415299,11089.9487497,34.5230622,81.759364,1.1541728,199.7015608),(10278,'Cervus_giganteus-ulna.tif',249,4,40,878.0196767,120.5198949,84.9258099,1.8,121.1205767,83.3873236,-1.2051018,18.3881553,44.3898482,50873.7368905,455278.0470118,127.6236212,10256.355119,2766.6579919,11383.6695332,34.5468769,83.1643343,1.1672614,203.49503),(10279,'Cervus_giganteus-ulna.tif',249,4,41,895.7467334,120.3662894,85.5265512,1.8,120.969097,84.0428319,-1.2059039,18.3850791,45.5307122,51990.6617802,481138.2414091,130.2802359,10567.3339675,2827.8726162,11692.3888463,34.4465682,84.7477212,1.1752252,206.533383),(10280,'Cervus_giganteus-ulna.tif',249,4,42,909.4844568,120.233407,86.1520652,1.8,120.7901512,84.7415848,-1.205845,17.9786154,46.5046684,52797.4413356,506820.9854296,132.2723389,10898.2818921,2936.6800668,12023.284152,34.4101156,86.1746763,1.1875122,210.0751468),(10281,'Cervus_giganteus-ulna.tif',249,4,43,928.1085443,120.151382,86.7094471,1.8,120.655423,85.3724221,-1.2057946,17.9915415,47.4657228,54080.7273925,531207.5043353,134.9757667,11191.3918779,3005.8973811,12315.1649862,34.2293699,87.5309373,1.1884668,212.2541238),(10282,'Cervus_giganteus-ulna.tif',249,4,44,946.5464334,120.0575153,87.2667654,1.8,120.5045667,86.0562776,-1.2058189,18.1101896,48.3637255,55628.6658735,554892.8572554,137.659761,11473.3274062,3071.6777118,12617.5820356,34.4772622,88.6637014,1.2091896,214.5805465),(10283,'Cervus_giganteus-ulna.tif',249,4,45,962.6746908,119.957461,87.8732261,1.8,120.3358608,86.7807148,-1.2060715,18.1231001,49.2718955,56658.1571998,576780.710737,140.0323718,11706.0791857,3126.2950009,12845.7780131,34.2995993,89.8705582,1.214264,217.1586745),(10284,'Cervus_giganteus-ulna.tif',249,4,46,976.2005912,119.7832168,88.5922417,1.8,120.1339226,87.5686621,-1.2056343,18.0764246,50.0498738,57239.8495711,595479.8588348,141.9524365,11897.729474,3166.5470864,13026.6699997,34.1694009,90.9772394,1.2087089,218.8774265),(10285,'Cervus_giganteus-ulna.tif',249,4,47,988.7879467,119.543214,89.4026163,1.8,119.8555831,88.4377344,-1.2051776,17.907829,50.967109,57485.2706209,615504.4801426,143.7325778,12076.5037028,3210.0636383,13192.0064657,34.2555659,92.2909417,1.2240142,221.6640741),(10286,'Cervus_giganteus-ulna.tif',249,4,48,996.7611303,119.2948018,90.2193318,1.8,119.60813,89.3312929,-1.2052018,17.9983084,51.6266096,57156.8684435,635553.6431992,144.8942597,12310.5826285,3175.6800264,13400.5610826,33.7220127,93.2452669,1.2228127,223.0700467),(10287,'Cervus_giganteus-ulna.tif',249,4,49,1003.0963502,118.9455034,91.2722468,1.8,119.2257344,90.4514917,-1.2057871,18.0126075,52.5237393,56543.0331932,655387.8841052,145.8804799,12477.9364973,3139.0809539,13545.3656032,33.6127731,94.6035989,1.2231895,225.8566943),(10288,'Cervus_giganteus-ulna.tif',249,4,50,1009.1146189,118.6850042,92.2338394,1.8,118.9860104,91.3462871,-1.2048858,17.6566764,53.0455233,56024.8776226,671055.3178448,146.6545192,12650.5551359,3173.0137937,13693.633643,32.7585072,95.5580136,1.2220253,226.1515856),(10289,'Cervus_giganteus-ulna.tif',249,4,51,1016.4269886,118.4309509,93.2845302,1.8,118.6490466,92.4500436,-1.2036348,17.4437944,53.4264778,55808.0705902,684096.2898294,147.5754157,12804.4430126,3199.3079864,13844.4332731,32.4725806,96.474287,1.2490458,228.4348224),(10290,'Cervus_giganteus-ulna.tif',249,4,52,1029.5762402,118.1478642,94.3973925,1.8,118.2963465,93.6484349,-1.2022728,17.1725079,53.8002746,55450.9067207,702341.8829846,149.3277172,13054.6152186,3229.0511787,14077.6213307,31.9165505,97.4331168,1.2615974,228.4348224),(10291,'Cervus_giganteus-ulna.tif',249,4,53,1045.8932696,117.8308434,95.5635967,1.8,117.9322296,94.8105545,-1.2004967,16.6949182,54.114153,54814.762597,718693.1741872,151.4858212,13281.0574385,3283.3202169,14282.8161952,31.5679991,98.3826024,1.260095,230.6137994),(10292,'Cervus_giganteus-ulna.tif',249,4,54,1065.0437814,117.5084885,96.8698904,1.8,117.5364379,96.2310873,-1.1977597,16.5640703,54.5430225,54216.346488,738816.7093025,153.9307583,13545.5769789,3273.1294625,14530.3631448,31.2427107,99.5996031,1.25041,232.2893656),(10293,'Cervus_giganteus-ulna.tif',249,4,55,1082.5889478,117.1161939,98.1619393,1.8,117.1463341,97.6638167,-1.1976734,16.3707535,54.7106735,53017.3575205,761352.4303578,156.4559917,13915.9762014,3238.5410696,14871.0188957,30.6262924,100.1541811,1.2341215,233.001296),(10294,'Cervus_giganteus-ulna.tif',249,4,56,1077.7160676,116.7190558,99.129396,1.8,116.6623597,99.0390104,-1.1985034,16.2022447,55.1763991,49522.2361134,758974.9817331,155.8528862,13755.4279379,3056.5046366,14634.9966868,30.3708956,100.8458612,1.2274858,235.0760132),(10295,'Cervus_giganteus-ulna.tif',249,4,57,1061.1658986,116.3533572,99.9587701,1.8,116.3057262,99.8474856,-1.1978419,15.6797947,55.6295997,46114.9032525,746031.0515775,153.3801659,13410.6852352,2941.0399976,14224.2435357,29.6533996,84.205694,1.3233424,206.2816776),(10296,'Cervus_giganteus-ulna.tif',249,4,58,1070.5244919,115.7182111,101.5712003,1.8,115.6450857,101.4992314,-1.1966562,14.8730534,55.1706606,43972.9934633,774050.2818007,154.589098,14030.1071967,2956.5545352,14798.9404626,28.4581924,83.3727609,1.3208177,204.814631),(10297,'Cervus_giganteus-ulna.tif',249,4,59,1123.5296464,114.5973234,104.2944013,1.8,114.4624402,104.2718746,-1.1920063,14.4632367,53.1986028,43719.8314509,855826.8473617,161.647925,16087.3933337,3022.8248595,16798.4843935,28.1796167,100.9410196,1.2005663,242.914657),(10298,'Cervus_giganteus-ulna.tif',249,4,60,1167.7736313,113.421147,107.1635424,1.8,113.4611578,106.5578191,-1.1873317,14.2828685,52.1182525,44552.2445514,926439.5084954,167.3852673,17775.7208533,3119.2784943,18475.959388,27.731417,101.4973636,1.1336577,243.0189168),(10299,'Cervus_giganteus-ulna.tif',249,4,61,1155.4418509,112.8311635,108.6275405,1.8,112.9102095,108.2267763,-1.1866182,14.1973152,51.265112,44880.3236114,915252.3254996,165.5222378,17853.317585,3161.1838477,18538.8750021,27.3104569,100.8852164,1.1071487,247.1072773),(10300,'Cervus_giganteus-ulna.tif',249,4,62,1145.7222186,112.2095249,110.1598135,1.8,112.4432145,109.4874769,-1.1861899,14.1179737,49.8517689,45330.2050416,903962.789952,164.0730017,18133.013321,3210.8152451,18868.9311224,27.3400322,74.2515292,1.3904252,194.6927503),(10301,'Cervus_giganteus-ulna.tif',249,4,63,1170.3870662,111.6251396,112.0219068,1.8,111.8606447,111.3349271,-1.191425,13.9524997,49.7098183,47694.1748942,907648.6456587,168.3115717,18258.9411135,3418.3247453,19187.7538522,27.1430369,98.1204575,1.1561291,277.9152561),(10302,'Cervus_giganteus-ulna.tif',249,4,64,1225.9419856,111.1149712,113.9972416,1.8,111.4665456,112.8213152,-1.1992935,13.7228792,50.88621,50612.7348836,915707.5845952,177.3977401,17995.2011389,3688.2008703,18928.8937692,27.4895848,96.8782086,1.1746405,237.697327),(10303,'Cervus_giganteus-ulna.tif',249,4,65,1198.166652,111.108622,114.218252,1.8,111.4196807,113.0876922,-1.2012578,14.1457206,49.98961,48494.5913247,836485.3385508,173.6433625,16733.1839408,3428.2163964,17647.9150906,27.5078577,94.4971749,1.2130901,225.1447639),(10304,'Cervus_giganteus-ulna.tif',249,4,66,1133.052562,111.4893507,112.980147,1.8,111.6607501,112.2988307,-1.1959223,14.2880484,47.8765308,45664.5402476,730429.576485,163.5240939,15256.52684,3195.9956387,16159.0861762,27.015508,91.5971471,1.2312435,216.5078181),(10305,'Cervus_giganteus-ulna.tif',249,4,67,1066.6485113,111.9481922,111.5380755,1.8,112.0937971,110.9198856,-1.188992,14.3132251,45.4636977,43454.1025753,625734.5855155,153.0947528,13763.3896195,3035.9406878,14692.1763036,26.9452602,86.1993119,1.2143594,205.274856),(10306,'Cervus_giganteus-ulna.tif',249,4,68,1014.1289383,112.2929788,110.4463775,1.8,112.390505,109.9532557,-1.1813003,14.3340169,43.5052758,41610.4592616,549545.9618316,144.6504515,12631.7085008,2902.9168592,13562.3350377,26.8457085,82.1063956,1.1844591,199.7626348),(10307,'Cervus_giganteus-ulna.tif',249,4,69,965.0032892,112.5337754,109.6142238,1.8,112.5804364,109.2946254,-1.173836,14.295459,41.6647988,39780.9834184,486257.6571632,136.7936321,11670.7069471,2782.7706338,12593.4347041,26.9157974,78.8345759,1.1852293,193.4342233),(10308,'Cervus_giganteus-ulna.tif',249,4,70,930.6625053,112.773154,108.9322565,1.8,112.7000524,108.7805152,-1.1659295,14.372142,40.1289526,38499.9135196,437717.8116926,131.0443593,10907.7806128,2678.787449,11835.9554933,26.8363057,76.0559904,1.1703555,189.8924595),(10309,'Cervus_giganteus-ulna.tif',249,4,71,898.3263751,112.9193951,108.3881893,1.8,112.7783179,108.3384267,-1.1586146,14.385469,38.7620526,37365.744258,396462.6209694,125.6926633,10228.1121441,2597.4644504,11163.3692027,26.6777422,73.5758371,1.1751067,185.1353545),(10310,'Cervus_giganteus-ulna.tif',249,4,72,872.7827361,113.0253417,107.9784718,1.8,112.7859446,108.0383682,-1.1508704,14.2895824,37.5373167,36384.8122739,362022.5312764,121.2857523,9644.336979,2546.2474241,10587.0517703,26.6525188,71.5156273,1.13671,179.8748386),(10311,'Cervus_giganteus-ulna.tif',249,4,73,853.2580932,113.1091506,107.6191522,1.8,112.7934808,107.7824171,-1.1433154,14.1981466,36.372362,35371.0902707,333625.6498003,117.7671959,9172.5043706,2491.2470096,10120.7865136,26.4228223,69.5723131,1.1237218,176.4373346),(10312,'Cervus_giganteus-ulna.tif',249,4,74,833.7683624,113.1222115,107.3908227,1.8,112.7353072,107.5827672,-1.1360031,14.1037036,35.3887063,34450.7036344,308931.0886893,114.3056496,8729.6519399,2442.6707106,9661.327333,26.3195999,67.7109767,1.152572,171.4285242),(10313,'Cervus_giganteus-ulna.tif',249,4,75,814.6537139,113.098413,107.2238634,1.8,112.6129839,107.456392,-1.1277612,13.97999,34.6274924,33684.5344616,286684.9888743,110.8241935,8279.1149264,2409.482014,9223.0944463,26.229419,66.3029614,1.092657,170.9251134),(10314,'Cervus_giganteus-ulna.tif',249,4,76,801.8265609,113.1062382,107.0169244,1.8,112.5340385,107.3262171,-1.1180533,14.0100813,33.8354094,33299.508585,266857.2345271,108.0663904,7886.9219837,2376.8247868,8831.9406136,26.2814613,64.98525,1.0746158,164.4492563),(10315,'Cervus_giganteus-ulna.tif',249,4,77,797.1040156,113.1377129,106.9044425,1.8,112.5082082,107.2835163,-1.1090395,13.9584709,32.9230071,33358.6132954,251153.3555783,106.481199,7628.5059541,2389.8472424,8577.0862171,26.294169,63.6895613,1.0558343,162.9822097),(10316,'Cervus_giganteus-ulna.tif',249,4,78,788.0258948,113.1586158,106.8654723,1.8,112.4944049,107.2559396,-1.1009107,13.9678333,32.4676627,33292.5674121,236086.1488963,104.4116391,7271.424214,2383.5169512,8257.736343,26.4969948,62.6873417,1.0703555,160.1523763),(10317,'Cervus_giganteus-ulna.tif',249,4,79,785.4726051,113.1659863,106.8705009,1.8,112.4362617,107.2792071,-1.0915723,13.9671338,31.6752033,33321.8287331,223127.5910837,103.0795761,7044.2354772,2385.7313343,8034.913512,26.5039265,61.4589047,1.035173,157.1140233),(10318,'Cervus_giganteus-ulna.tif',249,4,80,781.2577413,113.1338238,106.8882311,1.8,112.3233659,107.3272253,-1.0794169,13.8823919,31.1112971,33398.0374523,212318.7127308,101.220356,6824.4892447,2405.7840734,7826.893421,26.5466424,60.5006202,1.0340309,154.4316355),(10319,'Cervus_giganteus-ulna.tif',249,4,81,780.0877913,113.0170703,106.9409916,1.8,112.1972897,107.3800429,-1.0595202,13.7549923,30.5246467,33561.8491378,198114.963236,98.8884484,6490.3277986,2439.9758571,7514.7416111,26.6361444,59.3234049,1.0390723,152.2094727),(10320,'Cervus_giganteus-ulna.tif',249,4,82,779.4815276,113.0317195,106.9847636,1.8,112.211334,107.4965902,-1.0477619,14.0111699,29.9724257,33807.668329,189675.6045496,97.4986633,6328.3367982,2412.9083054,7373.1861417,26.934802,58.5291214,1.0051932,153.9282247),(10321,'Cervus_giganteus-ulna.tif',249,4,83,780.4454734,113.0046322,107.1536451,1.8,112.2090496,107.6259837,-1.0366633,14.182186,29.4976613,34184.748258,181787.686174,96.361902,6162.7830299,2410.4004949,7217.0520484,27.4197383,57.7079147,1.0137755,152.7128835),(10322,'Cervus_giganteus-ulna.tif',249,4,84,780.4672375,112.9955898,107.2872934,1.8,112.1514712,107.8551865,-1.0272438,14.4699803,28.9833849,34709.5692416,175168.4338533,95.2853082,6043.7534918,2398.7295355,7138.0409512,27.8071996,56.8910811,1.022605,150.0304956),(10323,'Cervus_giganteus-ulna.tif',249,4,85,779.6909448,112.9662483,107.4979355,1.8,112.112984,108.0912199,-1.0206284,14.8180857,28.6370063,35036.573662,168970.5779712,94.4268622,5900.4274443,2364.4466821,7021.6746264,28.3016138,56.3874444,1.0081583,150.5339065),(10324,'Cervus_giganteus-ulna.tif',249,4,86,781.5312201,112.9537777,107.7256789,1.8,112.0391243,108.4161233,-1.0145293,15.2135431,28.2177838,35674.8661219,163721.6425299,93.9394233,5802.0730417,2344.9413433,6943.1855536,28.7542112,55.79495,1.0105644,154.6833409),(10325,'Cervus_giganteus-ulna.tif',249,4,87,787.4050285,112.8691457,108.0631991,1.8,111.9788498,108.8030629,-1.0073164,15.8571697,28.0157366,36459.9587831,159422.4098869,93.7935413,5690.4593423,2299.2727848,6869.7084271,29.447055,55.3013635,0.995724,157.3657287),(10326,'Cervus_giganteus-ulna.tif',249,4,88,786.3720416,112.8307317,108.3541834,1.8,111.9305442,109.199741,-1.0017603,16.4801506,27.6636205,37309.5808591,155263.3700048,93.0111367,5612.5469902,2263.9101937,6842.6040345,30.1961587,54.7072313,0.9980431,156.4020929),(10327,'Cervus_giganteus-ulna.tif',249,4,89,795.0795002,112.7508808,108.7156742,1.8,111.8959879,109.5888091,-0.9972234,17.3525703,27.5225093,38585.2246916,152584.4328301,93.4941269,5543.9869679,2223.6028412,6801.1933531,0.859376,1.2153412,2.3561945,2.4306824),(10328,'Cervus_giganteus-ulna.tif',249,4,90,797.4727757,112.6488183,109.0840716,1.8,111.7696648,110.0617749,-0.9916779,18.3553309,27.370528,40447.2781398,151048.745931,93.1019852,5518.6639389,2203.5711836,6855.2197744,32.3350192,53.9989788,0.9607223,158.6242557),(10329,'Cervus_giganteus-ulna.tif',249,4,91,806.831313,112.5641942,109.5679064,1.8,111.7396812,110.6714732,-0.9906397,19.7206259,27.332998,43529.597953,150958.7228751,94.0665989,5522.9478612,2207.3132052,6979.4313871,33.9356773,53.7539521,0.8873165,163.1296553),(10330,'Cervus_giganteus-ulna.tif',249,4,92,824.7221885,112.583824,110.2643109,1.8,111.8346023,111.4588101,-1.0100753,21.7398397,27.538372,48879.9375691,151633.3456331,98.5806972,5506.2567183,2248.4037735,7158.4535803,36.498356,53.5198789,1.0028356,165.9163029),(10331,'Cervus_giganteus-ulna.tif',249,4,93,848.2559706,112.5625538,110.9533636,1.8,111.8944002,112.1814051,-1.0253983,23.4553777,27.8463943,55132.6356264,153742.1870339,103.3302591,5521.0805945,2350.5328392,7391.236593,38.9350737,53.5112538,0.9738853,155.1867517),(10332,'Cervus_giganteus-ulna.tif',249,4,94,862.5703607,112.5895856,111.580668,1.8,111.9551514,112.8822815,-1.0441507,25.3111191,27.9335697,61027.1539153,153667.3723739,107.4412989,5501.1720245,2411.0808294,7571.7138128,41.5234065,53.5991651,0.8534746,161.3677175),(10333,'Cervus_giganteus-ulna.tif',249,4,95,871.9643697,112.5925406,112.1214931,1.8,111.9486157,113.3174817,-1.0579225,25.6135718,28.0790295,67940.1748922,153213.6766672,110.3368992,5456.5160976,2652.5068557,7760.5077492,42.3553053,53.8483251,0.8362019,169.7276603),(10334,'Cervus_giganteus-ulna.tif',249,4,96,877.2791913,112.5690895,112.4683146,1.8,112.0175325,113.6652826,-1.0549434,25.7111872,27.9578251,73639.8092816,152083.2474728,110.6362899,5439.738145,2864.1154853,7864.8956437,42.6668845,53.6439272,0.8647765,180.1012464),(10335,'Cervus_giganteus-ulna.tif',249,4,97,858.7693518,112.4980718,112.7210163,1.8,111.96588,113.8012298,-1.02427,28.2364053,27.5491356,78155.7480425,147041.0523943,104.4676248,5337.4107423,2767.9071502,7059.3094375,42.7693756,54.1372781,0.8303118,172.1583427),(10336,'Cervus_giganteus-ulna.tif',249,4,98,850.3860059,112.2661743,112.9263604,1.8,111.7272468,113.8120537,-0.9599136,26.81022,27.1458697,81297.7140612,146536.2307262,95.1005981,5398.1040982,3032.3404295,7639.6960532,42.7410433,54.4280894,0.8244844,185.9694328),(10337,'Cervus_giganteus-ulna.tif',249,4,99,834.4527309,112.0681182,113.093097,1.8,111.529159,113.8555303,-0.8874064,27.3592011,27.5764592,84811.4825036,144219.1895534,83.626358,5229.7935903,3099.9254057,7460.6029502,42.9518538,55.035301,0.7467434,180.7521028),(10338,'Cervus_giganteus-ulna.tif',249,4,100,802.578292,112.3992502,112.9781346,1.8,111.6898535,113.7345948,-0.8819474,27.2578036,28.2774387,86301.2124315,132329.8666413,79.7161386,4679.6977702,3166.110288,6900.8342577,43.1465102,55.1358528,0.7136981,179.8927268),(10339,'Cervus_giganteus-ulna.tif',249,4,101,769.6330447,112.6321699,112.9887558,1.8,112.0032679,113.6082937,-0.8855126,27.329132,28.189095,86673.5460669,122832.5590859,76.8923475,4357.4495447,3171.4708754,6489.5260291,43.6053931,54.8555262,0.7077767,180.3961376),(10340,'Cervus_giganteus-ulna.tif',249,4,102,746.9710602,112.9113773,113.0840896,1.8,112.4076174,113.5906201,-0.9252901,27.1984121,26.5570082,87278.0687269,114625.3012929,79.4371283,4316.1978352,3208.9398576,6207.5406994,43.8243961,53.969908,0.6498704,178.3646062),(10341,'Cervus_giganteus-ulna.tif',249,4,103,727.363277,113.1019069,113.1644792,1.8,112.5990289,113.5978848,-0.9491613,27.2131759,25.8272635,86765.3046402,108285.2212176,80.1131096,4192.6710905,3188.3564396,5932.0451261,44.1535562,53.5474701,0.6258464,177.8001214),(10342,'Cervus_giganteus-ulna.tif',249,4,104,713.5878999,113.1803728,113.2970715,1.8,112.715754,113.714986,-0.9232492,28.1620393,25.9084172,86655.1374122,103657.4940968,75.6535551,4000.9196006,3077.0192628,5761.7460788,45.0702197,53.5112538,0.5969111,181.6546646),(10343,'Cervus_giganteus-ulna.tif',249,4,105,706.0745054,113.1426288,113.5005766,1.8,112.7065311,113.9012176,-0.8427666,28.8384133,27.5805889,86369.7830922,101166.8744239,65.5758061,3668.0462001,2994.9561446,5621.6241778,45.1396693,53.7110004,2.8577985,183.8336416),(10344,'Cervus_giganteus-ulna.tif',249,4,106,695.5178197,113.0935398,113.6167959,1.8,112.7479349,113.9619255,-0.732954,28.490099,29.3569102,85198.2049389,97871.2972819,51.8916482,3333.8419047,2990.4495955,5500.1954257,43.4720845,53.5922753,2.8654956,187.7134825),(10345,'Cervus_giganteus-ulna.tif',249,4,107,687.8204089,112.9866201,113.8295413,1.8,112.6895058,114.1794207,-0.6358077,28.8114703,29.8359955,84263.4986783,96153.9427811,40.4244862,3222.7496072,2924.6511134,5548.0906584,42.9925751,53.17899,2.863293,188.4864869),(10346,'Cervus_giganteus-ulna.tif',249,4,108,677.4419208,112.8538317,114.0098623,1.8,112.6693647,114.3211257,-0.5340954,27.7861279,30.4443987,82507.7764441,95540.0062758,29.2592571,3138.1801001,2969.387344,5518.3968088,42.3607095,52.5345206,2.8767753,176.1424434),(10347,'Cervus_giganteus-ulna.tif',249,4,109,660.0073096,112.8267084,114.0283487,1.8,112.6300758,114.3686904,-0.4991719,27.6870778,30.3889327,78660.3244978,92400.4548926,25.207046,3040.5955938,2841.0482692,5377.095021,42.0667856,51.8215133,2.8644319,171.7844894),(10348,'Cervus_giganteus-ulna.tif',249,4,110,644.7119094,112.7445863,114.0328843,1.8,112.573839,114.4821544,-0.471816,27.5148731,33.0436717,74124.9027707,89075.207244,22.1968372,2695.6812799,2693.9939928,4715.4465925,41.663011,53.5371251,2.814766,178.6163116),(10349,'Cervus_giganteus-ulna.tif',249,4,111,624.8188421,112.8206976,114.0091187,1.8,112.4620489,114.6215958,-0.4814146,27.6100075,33.2207772,69691.7108654,85114.0420143,22.3268607,2562.072568,2524.1467527,4453.0406223,41.4061983,54.0860974,2.8349163,178.6163116),(10350,'Cervus_giganteus-ulna.tif',249,4,112,608.3001165,112.8647443,113.9499231,1.8,112.3372551,114.5013565,-0.4981941,26.5984325,33.3165366,64663.5397603,81348.9860043,23.1489663,2441.69996,2431.103403,4183.833385,41.2031138,51.9087295,2.8303129,173.5643154),(10351,'Cervus_giganteus-ulna.tif',249,4,113,576.3514892,112.9626765,113.4694045,1.8,112.6668388,113.9413595,-0.4915788,24.0847781,30.5598959,55466.417404,72836.1346968,21.401981,2383.3894874,2302.9656841,3907.3996519,39.3422296,49.8826874,2.8443603,160.6126013),(10352,'Cervus_giganteus-ulna.tif',249,4,114,538.719504,112.9709983,112.8690125,1.8,112.5118523,113.5522543,-0.482256,23.6657811,30.9563721,46016.5032346,67620.5439484,19.3122855,2184.3820623,1944.4320511,3451.9605817,38.3166708,49.3468191,2.8501359,159.3361861),(10353,'Cervus_giganteus-ulna.tif',249,4,115,514.4484815,113.0766232,112.6570598,1.8,112.5319433,113.2108147,-0.5061927,25.6856077,31.0420933,40580.798575,62718.7543386,20.1561297,2020.4421688,1579.9041643,3090.774549,36.6224653,48.2572341,0.4317859,149.0489717),(10354,'Cervus_giganteus-ulna.tif',249,4,116,497.7355568,112.9977187,112.4395893,1.8,112.546387,113.0295963,-0.5437123,22.6897498,30.2328906,34531.1910375,58736.4580353,22.2003659,1942.7999377,1521.8850482,2830.9241215,35.9983987,47.3281392,0.5123895,143.7884559),(10355,'Cervus_giganteus-ulna.tif',249,4,117,475.5265916,112.9357697,112.2005615,1.8,112.4129439,112.8553161,-0.5694419,21.4933397,29.8325468,28977.7979503,55085.7079901,23.0389287,1846.4969937,1348.2222082,2582.0381013,34.6841901,49.0860951,0.4048918,153.3026659),(10356,'Cervus_giganteus-ulna.tif',249,4,118,459.8903499,112.944493,112.1114448,1.8,112.2419559,112.7486207,-0.5706173,20.7427224,30.0021944,25710.2106908,52556.7671027,22.363227,1751.7641022,1239.4810201,2376.1100366,33.6151706,50.1926353,0.3677885,149.1532315),(10357,'Cervus_giganteus-ulna.tif',249,4,119,444.1711358,113.153193,112.0175398,1.8,112.9166858,112.4509923,-0.6027991,19.1477669,25.3061794,22815.0798831,48007.0458201,23.7952002,1897.048348,1191.5269308,2585.768019,31.5396486,43.998457,0.5554937,128.4060594),(10358,'Cervus_giganteus-ulna.tif',249,4,120,429.5851133,113.2302637,111.9727624,1.8,112.9415056,112.4875619,-0.615694,17.914414,24.1456681,20412.5372507,45254.6246282,23.8803091,1874.233691,1139.4476657,2566.5189239,29.5345391,43.332496,0.5302158,125.7847455),(10359,'Cervus_giganteus-ulna.tif',249,4,121,418.3767893,113.3057776,111.9882751,1.8,112.9705914,112.3698827,-0.6245249,16.6785957,23.9323187,18585.673281,42808.8978606,23.8396683,1788.7484453,1114.3428146,2462.5070704,28.2280153,42.8159894,0.5490251,121.7827567),(10360,'Cervus_giganteus-ulna.tif',249,4,122,408.9964318,113.2978661,112.0157361,1.8,113.0207622,112.392345,-0.6222121,16.6674494,22.825512,16873.9217646,41063.6150575,23.1557134,1799.0227346,1012.3877617,2403.5928681,28.092925,41.635415,0.5421894,119.6648537),(10361,'Cervus_giganteus-ulna.tif',249,4,123,401.6558079,113.3031027,112.1020347,1.8,113.069698,112.3963565,-0.6267463,14.9735353,23.0558005,15420.3583106,39781.7471902,23.0280674,1725.455044,1029.8408494,2316.42202,26.1260246,41.1985431,0.5243207,115.5154193),(10362,'Cervus_giganteus-ulna.tif',249,4,124,396.6809326,113.3519861,112.2839628,1.8,113.1709346,112.6011281,-0.6430732,14.6409852,22.7128697,14480.584913,38382.6393956,23.7736991,1689.9070813,989.0444359,2209.3923273,25.4911663,41.4153261,0.5333022,115.0120085),(10363,'Cervus_giganteus-ulna.tif',249,4,125,391.1898156,113.3911115,112.4364169,1.8,113.2173422,112.7376248,-0.6549945,14.5813422,20.6731735,13453.5435762,37012.781538,24.1931104,1790.3773506,922.6546756,2292.1846615,25.2881549,39.3534163,0.551655,111.9304696),(10364,'Cervus_giganteus-ulna.tif',249,4,126,379.5863796,113.4567775,112.5217374,1.8,113.2119867,112.8170352,-0.6595484,13.9479456,20.5618104,12276.8412042,35255.3909026,23.7541891,1714.6053863,880.1899233,2182.7033528,24.322703,39.0898019,0.5819051,109.2480818),(10365,'Cervus_giganteus-ulna.tif',249,4,127,370.6690003,113.5611076,112.5986963,1.8,113.3543873,112.8770049,-0.6648778,13.1419411,20.4118025,11319.3234713,33611.6087766,23.5154449,1646.6751935,861.3129046,2106.2044655,22.997521,38.7315532,0.5880026,105.8105778),(10366,'Cervus_giganteus-ulna.tif',249,4,128,364.8597012,113.622548,112.7338009,1.8,113.3202995,113.0579392,-0.6708927,12.403058,20.2688429,10619.7138534,32439.0616188,23.5026073,1600.4397401,856.217383,2040.7206806,22.5337379,38.3747714,0.5942137,103.3798954),(10367,'Cervus_giganteus-ulna.tif',249,4,129,357.0657783,113.60556,112.9114179,1.8,113.2334131,113.1737998,-0.6766015,11.9703309,19.9786175,9809.9073241,31274.80652,23.3318597,1565.4139509,819.5184719,1992.5538642,22.1336786,37.8149856,0.632138,101.6611434),(10368,'Cervus_giganteus-ulna.tif',249,4,130,353.5067489,113.6387366,113.1340853,1.8,113.3227973,113.4930082,-0.6854748,11.3859893,19.8190923,9337.180594,30654.1116335,23.6107416,1546.6960463,820.0587905,1950.0835068,21.2711264,37.8149856,0.632138,100.089837),(10369,'Cervus_giganteus-ulna.tif',249,4,131,348.3815945,113.6497739,113.3351023,1.8,113.3643959,113.585961,-0.6878725,11.1133831,19.6281355,8799.9448247,29775.7769719,23.4049463,1516.9946703,791.8331222,1907.40492,20.9771504,37.4691881,0.638914,99.3347207),(10370,'Cervus_giganteus-ulna.tif',249,4,132,348.0746022,113.5041223,113.6334934,1.8,113.1690972,113.8617746,-0.688553,11.2429107,19.3227431,8338.716993,30077.7282741,23.4230577,1556.5972241,741.6866666,1924.1455997,21.1422033,37.2145534,0.6296452,98.8744958),(10371,'Cervus_giganteus-ulna.tif',249,4,133,342.8825328,113.5068578,113.8125323,1.8,113.2267517,114.0356219,-0.6892731,11.6440231,19.2073661,7905.6488187,29322.6212267,23.1140535,1526.6341588,678.944791,1871.3971052,20.9646358,36.8681321,0.6365082,100.1940968),(10372,'Cervus_giganteus-ulna.tif',249,4,134,340.743154,113.5160051,114.0231736,1.8,113.2437474,114.2489693,-0.6946925,11.2187475,18.9961599,7564.4226634,28787.2005972,23.2722487,1515.4221052,674.2662392,1854.2599727,20.6364431,36.5234803,0.6435011,98.0151197),(10373,'Cervus_giganteus-ulna.tif',249,4,135,338.0556426,113.4570186,114.2239565,1.8,113.179725,114.4556239,-0.692623,11.3360418,18.7762449,7213.9609088,28670.542431,22.9740513,1526.9582715,636.3738791,1860.5110557,20.3569652,36.1806485,0.6506269,97.5117089),(10374,'Cervus_giganteus-ulna.tif',249,4,136,333.0408756,113.4689229,114.3993012,1.8,113.1572487,114.7212619,-0.696461,10.8926811,18.6561818,6893.6590295,28044.5751068,22.8427787,1503.2322992,632.870727,1817.0441096,20.0208988,35.9220199,0.6411088,97.6159687),(10375,'Cervus_giganteus-ulna.tif',249,4,137,327.2183166,113.5332099,114.5703031,1.8,113.2610107,114.8993906,-0.7048425,10.432979,18.2284162,6574.4907054,27213.4734675,22.8939611,1492.914863,630.1642784,1794.8638994,19.9015126,35.3207721,0.638635,95.1852863),(10376,'Cervus_giganteus-ulna.tif',249,4,138,327.8358259,113.3577202,114.9319822,1.8,113.0964777,115.2674205,-0.7090818,12.6959362,18.4424295,6350.1760739,28052.3792674,23.1659512,1521.0782995,500.1739133,1536.5175255,19.3559362,35.2370362,0.6556956,93.9267593),(10377,'Cervus_giganteus-ulna.tif',249,4,139,325.939154,113.2925478,115.175328,1.8,113.0418808,115.4583144,-0.7077172,12.4867968,18.5313577,6161.913713,27978.9173157,22.9586721,1509.8147602,493.474334,1527.8463775,19.0368421,35.0663322,0.6287963,92.9631235),(10378,'Cervus_giganteus-ulna.tif',249,4,140,323.600317,113.2334896,115.3955787,1.8,112.9071951,115.7540449,-0.7018899,9.8380625,18.488502,5982.6675599,27755.508427,22.4837217,1501.2307843,608.1144105,1800.3292095,18.9292554,35.4329805,0.6823166,93.7182397),(10379,'Cervus_giganteus-ulna.tif',249,4,141,322.6593103,113.1877752,115.5865463,1.8,112.8603345,115.8753962,-0.6949962,9.7338138,18.3474868,5849.7990851,27591.2093736,22.0532117,1503.8141004,600.9770915,1796.870925,18.7980592,35.1636038,0.6728325,93.4665343),(10380,'Cervus_giganteus-ulna.tif',249,4,142,322.4046863,113.0762177,115.8673454,1.8,112.7364564,116.2126239,-0.6916586,14.0789135,18.4782998,5712.8348486,27864.5086157,21.8595002,1507.9584654,405.7724237,1787.2288329,18.6076344,35.3207721,0.638635,92.9631235),(10381,'Cervus_giganteus-ulna.tif',249,4,143,320.5696142,113.034667,116.0842931,1.8,112.6679162,116.3874242,-0.684891,9.6595332,18.3314254,5559.4108283,27674.5341296,21.3803008,1509.6771565,575.5361809,1782.3661856,18.4904507,35.2370362,0.6556956,93.9267593),(10382,'Cervus_giganteus-ulna.tif',249,4,144,318.5812978,112.9915067,116.2893017,1.8,112.5263922,116.6284021,-0.6766639,9.5388586,18.7349738,5412.7938423,27406.9421871,20.8203905,1462.8759243,567.4466979,1733.5843558,18.5169137,35.5006554,0.6652894,94.1784647),(10383,'Cervus_giganteus-ulna.tif',249,4,145,314.910874,112.9183505,116.4614063,1.8,112.4809472,116.8883989,-0.6621452,11.0177529,18.6090138,5258.6165942,26778.2704699,19.8389392,1438.9946017,477.2857646,1705.7535413,19.2194469,35.3207721,0.638635,98.9355697),(10384,'Cervus_giganteus-ulna.tif',249,4,146,313.9817845,112.8418117,116.6409612,1.8,112.4331609,117.0131055,-0.6456084,10.704083,18.479314,5149.4413663,26642.1001163,18.944834,1441.7256002,481.0726306,1706.8704154,18.8400549,35.0663322,0.6287963,98.4321589),(10385,'Cervus_giganteus-ulna.tif',249,4,147,317.2212889,112.6307753,116.9555071,1.8,112.0535212,117.4028326,-0.6306196,10.5347318,19.1036941,5109.0773999,27302.211372,18.3819974,1429.158738,484.9746074,1683.9893535,0.429688,0.6076706,2.3561945,1.2153412),(10386,'Cervus_giganteus-ulna.tif',249,4,148,318.9185026,112.4852782,117.2515912,1.8,111.7730312,117.7487294,-0.6210436,12.0417221,18.8346304,5062.8924223,27747.9659756,17.9970641,1473.2418605,420.4458772,1729.0355656,19.1963072,35.5188535,0.6047796,102.8764846),(10387,'Cervus_giganteus-ulna.tif',249,4,149,315.5175852,112.3991592,117.4939206,1.8,111.8347665,117.9723062,-0.6100454,10.5023629,18.7555487,4890.7994367,27514.9626677,17.2598532,1467.0305328,465.685625,1705.5213733,18.9898657,35.4147382,0.6216599,97.6159687),(10388,'Cervus_giganteus-ulna.tif',249,4,150,314.7182415,112.2718589,117.7549962,1.8,111.4360564,118.2549485,-0.596149,10.8340276,22.1736321,4812.6114922,27636.7662867,16.5351535,1246.3797613,444.2125948,1325.0153015,19.1769147,35.9913402,0.5813802,101.0534728),(10389,'Cervus_giganteus-ulna.tif',249,4,151,312.0169107,112.3071314,117.9432364,1.8,111.5637874,118.3993376,-0.5883058,11.3009242,22.0603741,4685.9029136,26948.5476784,16.0154219,1221.5816245,414.6477624,1310.4529767,1.718752,2.14844,0.6435011,5.4690354),(10390,'Cervus_giganteus-ulna.tif',249,4,152,311.6839021,112.2380162,118.1878626,1.8,111.3927014,118.67775,-0.5775947,10.8042085,21.9726277,4601.0492227,26925.7623584,15.4869156,1225.4229523,425.8571312,1311.887724,19.1286875,35.8911679,0.5547922,101.7654032),(10391,'Cervus_giganteus-ulna.tif',249,4,153,310.2119952,112.2067931,118.3956539,1.8,111.2896707,118.8940972,-0.5649903,10.8971778,21.5930167,4522.6604139,26623.0825185,14.8209631,1232.9487323,415.0304317,1322.8854744,19.0652638,35.8911679,0.5547922,98.9787555),(10392,'Cervus_giganteus-ulna.tif',249,4,154,310.0630589,112.143323,118.6467213,1.8,111.2560167,119.1569229,-0.5568203,11.3749255,21.4823904,4466.6984745,26442.2874695,14.4334943,1230.8819928,392.6793594,1318.4444798,19.4087467,35.9913402,0.5813802,101.6611434),(10393,'Cervus_giganteus-ulna.tif',249,4,155,309.5253328,112.1081406,118.8762761,1.8,111.319642,119.3636994,-0.5468478,11.4776854,21.2819184,4406.2444288,25917.7234274,13.9491304,1217.8283434,383.8966011,1317.6343983,19.1576333,35.6666927,0.5445517,96.3395536),(10394,'Cervus_giganteus-ulna.tif',249,4,156,308.1701915,112.0968066,119.1024975,1.8,111.3174576,119.5424702,-0.5415409,11.6117911,21.0550621,4357.8465676,25416.2162724,13.6465935,1207.1309117,375.2949511,1316.7599978,19.3081132,35.0768611,0.5404195,99.1262012),(10395,'Cervus_giganteus-ulna.tif',249,4,157,306.0254975,112.2529038,119.30839,1.8,111.6300425,119.8658116,-0.5232793,52.3517043,39.5039992,4794.0640469,24706.8544773,12.736954,625.426665,91.5741733,459.5944389,18.8886296,34.4876489,0.536146,96.591259),(10396,'Cervus_giganteus-ulna.tif',249,4,158,298.0758125,112.689419,119.4316501,1.8,112.4383545,120.0911718,-0.511205,52.3278859,40.3940241,5256.7500427,22876.1902091,11.8904705,566.3261015,100.4579098,438.8561218,18.3151089,33.3112143,0.5271459,94.0131309),(10397,'Cervus_giganteus-ulna.tif',249,4,159,287.9781326,113.2047144,119.4694319,1.8,113.2872787,120.2296995,-0.4938353,51.7776432,40.9605149,5529.9979927,20491.7998927,10.7839208,500.2817949,106.8028139,407.7973428,18.2567889,32.4122636,0.6726706,89.4034715),(10398,'Cervus_giganteus-ulna.tif',249,4,160,278.2889925,113.6106849,119.4654674,1.8,113.8180839,120.322299,-0.4827626,51.1765776,41.094488,5380.2066273,18191.0135164,9.9955594,442.6631018,105.1302546,371.5072508,18.5162037,31.6922212,0.7086263,89.5077313),(10399,'Cervus_giganteus-ulna.tif',249,4,161,268.3200513,113.8658139,119.5107226,1.8,114.1566905,120.3410222,-0.4829364,50.6439914,40.8818479,4943.5804465,15970.4572287,9.6438882,390.6491033,97.6143529,331.9149172,18.4323413,30.8089595,0.696524,88.7958009),(10400,'Cervus_giganteus-ulna.tif',249,4,162,262.9782063,113.9870257,119.5897864,1.8,114.0698224,120.2285443,-0.5259412,51.3364444,38.4483431,4097.5597806,14371.6882086,11.0464583,373.7921342,79.8177557,295.520125,17.791164,30.1547926,0.7148086,86.2608587),(10401,'Cervus_giganteus-ulna.tif',249,4,163,257.7188301,114.1094617,119.6829483,1.8,113.8805388,120.1397257,-0.5605878,10.6185449,15.3918299,3392.5167606,12937.3586622,12.1423372,840.5341477,319.4897973,1049.8606709,17.686392,29.5111523,0.7338974,87.3719401),(10402,'Cervus_giganteus-ulna.tif',249,4,164,253.4847758,114.2373333,119.8328715,1.8,114.0211897,120.3086787,-0.5507141,11.1040913,14.9497423,3333.3819542,12064.3092252,11.5689838,806.9911148,300.1940328,999.2548144,0.429688,0.9608116,2.677945,1.8230118),(10403,'Cervus_giganteus-ulna.tif',249,4,165,249.3793483,114.3335845,120.0006753,1.8,114.1855917,120.444541,-0.5428633,11.2401955,14.5655767,3263.7512521,11313.5390539,11.0917688,776.731284,290.3642786,994.7217122,18.2149386,28.0583305,0.6986598,82.6148351),(10404,'Cervus_giganteus-ulna.tif',249,4,166,246.619271,114.401411,120.1835448,1.8,114.2351357,120.6309115,-0.5330668,11.7416123,14.654893,3219.8267169,10738.2334422,10.6146517,732.74049,274.2235584,847.8829305,0.429688,0.6076706,2.3561945,1.2153412),(10405,'Cervus_giganteus-ulna.tif',249,4,167,243.9021067,114.4508419,120.385444,1.8,114.3256702,120.8479597,-0.5262949,11.8835056,13.9177237,3167.3959625,10270.0512241,10.2576493,737.9117027,266.53717,909.9314393,18.6486782,27.1248529,0.7069081,83.4742111),(10406,'Cervus_giganteus-ulna.tif',249,4,168,241.8310976,114.4706174,120.6088891,1.8,114.3232974,121.0884989,-0.5176765,12.0150262,13.5916517,3121.8579193,9917.2277561,9.8702901,729.6558198,259.8294717,881.3931632,0.429688,0.9608116,2.0344439,2.0747172),(10407,'Cervus_giganteus-ulna.tif',249,4,169,240.1901127,114.471957,120.8492757,1.8,114.347519,121.3451608,-0.5103896,12.1476698,13.4618486,3078.7835599,9615.7932051,9.5535257,714.2996105,253.4464315,858.445686,18.660519,26.5608364,2.9791035,87.3719401),(10408,'Cervus_giganteus-ulna.tif',249,4,170,238.4362786,114.4591533,121.0863239,1.8,114.2680015,121.5552459,-0.5031178,11.9144001,14.3189233,3046.3222366,9400.4197467,9.2385178,656.5032523,255.6840633,774.5873756,18.4173087,27.770613,3.0018838,88.8389867),(10409,'Cervus_giganteus-ulna.tif',249,4,171,236.7966925,114.4405676,121.3431447,1.8,114.2569774,121.8212865,-0.4977022,11.6728565,14.2192659,3019.8686765,9237.6263361,8.9950464,649.6556434,258.7086277,763.9877763,1.5381702,2.8824348,0.4636476,6.3284114),(10410,'Cervus_giganteus-ulna.tif',249,4,172,234.7591409,114.4345846,121.5992355,1.8,114.2469784,122.0594005,-0.4867967,12.156455,13.7946021,3001.1400476,9077.5316239,8.5622178,658.0495451,246.8762513,773.9590841,18.5025191,27.770613,3.0018838,89.8026225),(10411,'Cervus_giganteus-ulna.tif',249,4,173,234.8818931,114.4035662,121.8602778,1.8,114.1781031,122.3476778,-0.4805818,11.9105489,14.0887961,2991.0514349,9027.9587004,8.3663682,640.7899319,251.1262458,771.0964545,18.2335931,27.770613,3.0018838,89.8026225),(10412,'Cervus_giganteus-ulna.tif',249,4,174,233.1889315,114.3568026,122.1130242,1.8,114.155388,122.6118699,-0.4814549,12.0932307,14.1234581,2920.4882284,8881.9610283,8.3339014,628.8800498,241.4977686,759.0963057,18.1868156,27.7140435,3.0172377,90.1585877),(10413,'Cervus_giganteus-ulna.tif',249,4,175,231.9612421,114.3047856,122.3727303,1.8,114.1029251,122.8750782,-0.483503,11.8972094,14.3237587,2861.0529579,8762.8079298,8.3551146,611.7673515,240.4810123,730.3867139,18.0876669,28.0912127,3.0343138,89.2992117),(10414,'Cervus_giganteus-ulna.tif',249,4,176,230.7641568,114.2538024,122.6161161,1.8,114.0591244,123.0970482,-0.4872586,11.9028615,14.3397875,2814.2535216,8672.1907591,8.4312059,604.764244,236.4350381,723.7430822,18.1126748,27.7140435,3.0172377,89.8026225),(10415,'Cervus_giganteus-ulna.tif',249,4,177,227.297835,114.1365452,122.8781999,1.8,113.9188054,123.3431492,-0.4975918,12.1513536,13.6630303,2705.3365188,8509.8996034,8.6307094,622.8413027,222.6366384,732.318778,17.2013672,27.2369325,3.0309354,87.3287543),(10416,'Cervus_giganteus-ulna.tif',249,4,178,225.6875102,114.0704901,123.1283175,1.8,113.8773311,123.5154057,-0.5054097,10.3262519,13.4296327,2619.9027933,8428.4995794,8.8174852,627.6046244,253.7128498,724.7657929,16.4735582,27.2369325,3.0309354,85.1497773),(10417,'Cervus_giganteus-ulna.tif',249,4,179,223.9690359,113.9925889,123.4088183,1.8,113.7810342,123.8431651,-0.5104908,10.3140731,13.1877926,2576.6829193,8340.6166113,8.9115557,632.449786,249.8220541,719.919782,16.6328498,27.1928351,3.0466409,86.2176729),(10418,'Cervus_giganteus-ulna.tif',249,4,180,222.813185,113.8943577,123.7029431,1.8,113.6272159,124.0917945,-0.5169304,10.302721,13.1209104,2533.4444012,8299.0295282,9.0702588,632.5040936,245.9005153,718.7641571,16.6992513,27.1554659,3.0623936,86.9296033),(10419,'Cervus_giganteus-ulna.tif',249,4,181,220.8370095,113.8103023,123.994231,1.8,113.63059,124.391155,-0.5256331,10.8792955,12.8371071,2475.7181213,8189.5776481,9.2664622,637.9613097,227.5623558,711.7765907,17.131266,26.7651136,3.0451189,85.8617077),(10420,'Cervus_giganteus-ulna.tif',249,4,182,219.836529,113.7209375,124.296089,1.8,113.5510927,124.6890183,-0.5324492,10.3260566,12.5539006,2441.498028,8135.5100793,9.4421045,648.0463975,236.440505,709.7377008,16.7705058,26.7651136,3.0451189,83.2835797),(10421,'Cervus_giganteus-ulna.tif',249,4,183,219.2057597,113.6082477,124.6051889,1.8,113.3503408,124.9822685,-0.5389585,10.2995567,12.6870714,2418.768789,8135.182275,9.6237807,641.2182961,234.8420284,713.7739025,16.8449264,26.7271465,3.0611216,85.1065915),(10422,'Cervus_giganteus-ulna.tif',249,4,184,217.9056723,113.5285968,124.8952893,1.8,113.3164194,125.249498,-0.5446212,10.1188963,12.4255069,2375.5508899,8081.2497306,9.7484279,650.3758601,234.7638329,710.4887842,16.7314943,26.7271465,3.0611216,82.4242037),(10423,'Cervus_giganteus-ulna.tif',249,4,185,217.5491091,113.4339186,125.2051811,1.8,113.2422048,125.5719409,-0.5508043,9.7090884,12.3586894,2358.9479059,8111.2214356,9.9318053,656.3172828,242.9628632,716.2607021,16.6067114,26.6960423,3.0771658,82.4242037),(10424,'Cervus_giganteus-ulna.tif',249,4,186,217.6792466,113.3256744,125.5216133,1.8,113.0711343,125.8609241,-0.5539941,9.2329201,12.66674,2364.4395665,8168.4263226,10.0411325,644.8720306,256.0879481,704.3057855,16.451972,27.1554659,3.0623936,82.9276145),(10425,'Cervus_giganteus-ulna.tif',249,4,187,217.8648295,113.2074121,125.8435018,1.8,113.0326367,126.1887772,-0.5632953,9.2135598,12.3208621,2359.3940251,8227.7472875,10.3532855,667.7898992,256.0784409,713.8673429,16.4006604,25.1027542,3.0214839,79.2384051),(10426,'Cervus_giganteus-ulna.tif',249,4,188,218.4579451,113.0728847,126.1738849,1.8,112.8999592,126.5149305,-0.573363,9.2983288,12.6671519,2380.3033896,8330.2048592,10.714021,657.6225593,255.9926028,688.7920688,16.6929889,27.9825549,3.0801317,85.8617077),(10427,'Cervus_giganteus-ulna.tif',249,4,189,219.5261238,112.9503017,126.481103,1.8,112.7860569,126.8012317,-0.5840673,8.9384652,12.413642,2389.923469,8414.8803067,11.1250609,677.8736118,267.375149,721.1752569,0.429688,0.6076706,2.3561945,1.2153412),(10428,'Cervus_giganteus-ulna.tif',249,4,190,220.1215893,112.8066813,126.7971566,1.8,112.6288825,127.1138515,-0.5950378,9.1872011,12.7364454,2401.2288334,8496.6045987,11.5272246,667.1095707,261.3667443,693.9441493,16.9111457,26.6545135,3.1093458,83.5963591),(10429,'Cervus_giganteus-ulna.tif',249,4,191,221.3429006,112.6750091,127.1208855,1.8,112.5704444,127.4353812,-0.6091092,9.309839,12.6261985,2414.8053714,8620.0519003,12.0757636,682.7115784,259.3820752,728.0576211,17.1028715,25.4424649,3.0570489,79.2384051),(10430,'Cervus_giganteus-ulna.tif',249,4,192,221.8028575,112.5401069,127.4142292,1.8,112.3615576,127.7167813,-0.6141848,9.6765067,12.8311554,2443.6672274,8738.469635,12.2772714,681.0352871,252.5360956,704.4363707,17.4520501,28.5184676,0.1056656,88.3534641),(10431,'Cervus_giganteus-ulna.tif',249,4,193,222.448789,112.3796845,127.771723,1.8,112.2139723,128.0406081,-0.6302626,10.3250656,12.9396532,2465.6214705,8922.3742796,12.8776197,689.5373563,238.7995926,704.6417333,17.5755887,28.9935941,0.1188403,88.5440955),(10432,'Cervus_giganteus-ulna.tif',249,4,194,225.0205418,112.2185899,128.1688199,1.8,112.1567323,128.5046663,-0.6639144,9.9655583,13.0551387,2522.076684,9256.9957673,14.2403494,709.0691238,253.0793166,824.6649385,18.6222371,27.1928351,0.0949517,86.9296033),(10433,'Cervus_giganteus-ulna.tif',249,4,195,226.758934,112.0640973,128.5310611,1.8,112.0252416,128.8506101,-0.6804472,10.4527757,13.109012,2579.4754853,9524.3156676,14.9592127,726.5471796,246.7742125,806.1225129,19.4672849,27.1554659,0.0791991,88.7526151),(10434,'Cervus_giganteus-ulna.tif',249,4,196,229.1805756,111.9242003,128.9065552,1.8,111.8592457,129.2912105,-0.6971386,10.8292932,13.3736541,2689.5713189,9786.7185041,15.7446326,731.7909101,248.3607444,836.5433778,20.1378391,28.0122307,0.0767719,92.3375647),(10435,'Cervus_giganteus-ulna.tif',249,4,197,229.1207101,111.7833052,129.1895326,1.8,111.7677963,129.4454293,-0.696067,10.7237974,13.5672805,2665.6856088,9889.3339545,15.7002411,728.9105555,248.5766474,850.7378334,20.1588609,28.0122307,0.0767719,91.3739289),(10436,'Cervus_giganteus-ulna.tif',249,4,198,228.8698907,111.6783902,129.438074,1.8,111.6956869,129.7220192,-0.6928101,10.4878996,13.6581889,2634.9782532,9958.7633186,15.5608705,729.1423025,251.2398446,883.4017662,20.0842616,27.773937,0.6094585,90.5145529),(10437,'Cervus_giganteus-ulna.tif',249,4,199,228.4046186,111.5779983,129.6876694,1.8,111.6238998,129.9662662,-0.6876047,10.782877,13.7556261,2605.0161747,10036.8230388,15.3346622,729.6522142,241.58823,864.9384349,20.3024276,28.0221156,0.622032,95.3759178),(10438,'Cervus_giganteus-ulna.tif',249,4,200,228.9008305,111.4369201,130.0060642,1.8,111.5417246,130.2602783,-0.6961257,10.6060915,13.6813025,2616.2453998,10173.2971424,15.6873786,743.5912713,246.673847,923.3764147,20.2728842,27.6506818,0.5750723,84.6463665),(10439,'Cervus_giganteus-ulna.tif',249,4,201,228.5716264,111.3161731,130.2584759,1.8,111.3727767,130.4781609,-0.6928898,10.557871,13.6678878,2597.7796406,10193.7729437,15.5435745,745.8191861,246.0514661,893.390855,20.1210541,27.770613,0.1397089,93.9088711),(10440,'Cervus_giganteus-ulna.tif',249,4,202,224.2240515,111.0484586,130.5610541,1.8,111.2351791,130.7346339,-0.6980742,11.2480238,14.0022,2480.799631,10260.8535999,15.4385482,732.8029605,220.5542662,903.0648945,20.3172324,28.3724261,0.6132073,91.3739289),(10441,'Cervus_giganteus-ulna.tif',249,4,203,210.303095,110.7913878,130.9187632,1.8,110.9791269,130.9464806,-0.7175112,11.0662145,14.1534072,2350.3481471,9938.8051945,15.1530879,702.2199714,212.3895346,851.349425,20.1165978,28.245246,0.579564,93.5529059),(10442,'Cervus_giganteus-ulna.tif',249,4,204,208.1871589,110.6928073,131.2975874,1.8,110.8467242,131.2097435,-0.7215069,9.9411294,14.1823781,2266.2647142,10164.2908527,15.1380663,716.6845229,227.9685356,855.6552089,17.3402507,29.0476718,0.5099721,79.9503354),(10443,'Cervus_giganteus-ulna.tif',249,4,205,208.0502516,110.5644099,131.7736632,1.8,110.8898149,131.6029671,-0.7218028,9.6674485,14.5924295,2193.380163,10299.9034561,15.1382908,705.8388384,226.883047,841.5647955,17.3104253,28.5184676,0.5378355,80.9139712),(10444,'Cervus_giganteus-ulna.tif',249,4,206,202.2035786,110.4091388,132.3259005,1.8,110.7497815,131.9256622,-0.7025937,10.9515941,14.8900933,2205.3201839,9982.8817124,14.0724778,670.437823,201.3697886,801.7888983,20.0698571,28.4633844,0.504166,90.2196617),(10445,'Cervus_giganteus-ulna.tif',249,4,207,210.1981906,110.3125408,132.3358986,1.8,110.6751757,131.9653232,-0.6945644,11.029897,14.9396801,2439.6642808,9946.4041897,14.3518086,665.7708927,221.1864961,818.668212,19.9759379,28.4504082,0.4366272,90.2196617),(10446,'Cervus_giganteus-ulna.tif',249,4,208,210.222976,110.1204058,132.440958,1.8,110.6982803,132.1389544,-0.674454,11.3919146,15.1330996,2459.8054931,9510.829245,13.663232,628.4785997,215.9255556,787.0507512,19.9682459,28.1503038,0.5456551,92.1901191),(10447,'Cervus_giganteus-ulna.tif',249,4,209,205.2699767,109.3654209,132.7674177,1.8,110.0690525,132.6306851,-0.6661783,12.0289905,15.4816811,2206.7294175,9038.1740137,13.0656614,583.7979709,183.4509241,714.0356151,20.4165209,28.8243476,0.4636476,92.9020495),(10448,'Cervus_giganteus-ulna.tif',249,4,210,207.5841403,109.5261846,132.7243684,1.8,110.0021275,132.651182,-0.6596117,10.7722146,15.2706418,2142.8310767,9470.8780553,12.9925574,620.2017044,198.9220567,753.321389,19.2802335,28.6379882,0.4837791,83.0750601),(10449,'Cervus_giganteus-ulna.tif',249,4,211,215.205964,109.9726654,132.4045801,1.8,110.1521423,132.5574071,-0.6531317,10.1672906,14.7351225,2067.6102238,10660.8625331,13.2448794,723.5000959,203.3590171,855.9655815,18.6137107,28.663765,0.4167023,82.9708003),(10450,'Cervus_giganteus-ulna.tif',249,4,212,216.0590747,110.0258501,132.5092831,1.8,110.1421546,132.6727308,-0.6503639,11.5093786,14.5833119,2186.2278598,10639.246305,13.2012557,729.5493883,189.9518593,863.8144136,20.3742884,28.8883306,0.3970794,97.3463752),(10451,'Cervus_giganteus-ulna.tif',249,4,213,208.4919692,110.1297065,132.3929711,1.8,110.2316537,132.5774366,-0.621439,11.6679183,14.4065091,1969.6136672,9589.72559,11.7785269,665.6522772,168.8059189,796.1787204,20.219154,28.3268374,0.3889569,95.5844373),(10452,'Cervus_giganteus-ulna.tif',249,4,214,208.1740109,110.0800554,132.5283435,1.8,110.0856543,132.5448383,-0.6127513,11.3754075,14.3973464,1917.389895,9235.9805074,11.4760578,641.5057526,168.5557104,762.8760284,19.9504462,28.3268374,0.3889569,91.7909681),(10453,'Cervus_giganteus-ulna.tif',249,4,215,210.1177359,109.8197661,132.7764812,1.8,109.5345088,133.0418362,-0.5993045,11.1333402,14.5427567,1852.9921332,9842.7854598,11.1423006,676.8170346,166.4363166,791.2470191,19.5730827,29.682703,0.3858827,102.9196704),(10454,'Cervus_giganteus-ulna.tif',249,4,216,208.8114381,109.7837838,132.8033632,1.8,109.2515851,133.3394464,-0.5496616,11.5515923,14.5589227,1870.7069872,9375.9781287,9.4974543,644.0021916,161.9436478,767.4142762,19.5699973,29.772759,0.3537031,93.2580147),(10455,'Cervus_giganteus-ulna.tif',249,4,217,221.0451958,109.338915,133.4257967,1.8,109.1632535,133.5497412,-0.574506,11.1853945,14.9996873,2123.4978095,10418.6653071,10.8793082,694.5921653,189.8455896,828.408528,19.4336553,29.6266685,0.3400971,97.7634143),(10456,'Cervus_giganteus-ulna.tif',249,4,218,233.3630449,108.9265781,133.9724821,1.8,109.0356965,133.5897819,-0.5957541,10.3660788,15.6068246,2250.8527939,11318.2342669,12.2465187,725.2105759,217.1363764,863.2965561,18.2104431,29.5236623,0.3723984,94.3690961),(10457,'Cervus_giganteus-ulna.tif',249,4,219,234.6870786,108.8389347,134.1555807,1.8,108.9875177,133.8082334,-0.5867694,10.1479123,15.5593968,2306.5108783,11172.6682394,11.9907311,718.065643,227.2892016,859.3903812,17.9900687,29.3700473,0.3587707,89.9679563),(10458,'Cervus_giganteus-ulna.tif',249,4,220,234.3175912,108.7863663,134.3008632,1.8,109.0383889,133.9415063,-0.5758902,10.036243,15.5768164,2337.7201082,10938.6539194,11.5818955,702.2393803,232.9278116,850.1188327,17.8215583,29.2219435,0.3450022,88.5440955),(10459,'Cervus_giganteus-ulna.tif',249,4,221,235.2410858,108.7288174,134.4824264,1.8,108.9191649,134.1409355,-0.5684889,10.069158,15.4996015,2407.6337613,10740.7989584,11.3633466,692.9725879,239.1097417,845.2564677,17.7319124,29.0794352,0.3310961,89.7594367),(10460,'Cervus_giganteus-ulna.tif',249,4,222,246.4000628,108.3322776,134.9899749,1.8,108.5151606,134.5588085,-0.5816779,10.7476204,15.8559317,2653.4546789,11744.5981859,12.3967826,740.7069103,246.8876435,903.4517585,17.1063134,30.1762148,0.348771,92.6503441),(10461,'Cervus_giganteus-ulna.tif',249,4,223,245.4125625,108.3005077,135.1203395,1.8,108.5110296,134.7010776,-0.5737317,11.3664585,15.9656064,2655.1207368,11463.220048,12.0497292,717.9946559,233.5926131,880.9918201,16.9951019,30.1762148,0.348771,90.0722161),(10462,'Cervus_giganteus-ulna.tif',249,4,224,243.6835698,108.2722906,135.2397365,1.8,108.4849627,134.7698129,-0.5657255,10.4032569,15.8336738,2654.5241826,11165.3552466,11.6694554,705.1651674,255.1628031,868.7507361,17.3996506,30.032087,0.3353244,90.3239215),(10463,'Cervus_giganteus-ulna.tif',249,4,225,240.5216107,108.3201068,135.2909114,1.8,108.5564143,134.8882322,-0.541024,11.4561789,15.7050627,2713.7159369,10613.2713419,10.6326345,675.7866245,236.8779292,848.1766088,17.7279932,29.893441,0.3217506,99.0651272),(10464,'Cervus_giganteus-ulna.tif',249,4,226,236.4595437,108.4077911,135.3719441,1.8,108.6517212,134.9208019,-0.5464755,9.5598596,15.4460886,2625.3987926,10024.7354264,10.6433008,649.0144956,274.6273383,817.829621,16.7778969,28.414693,0.3552309,83.1793199),(10465,'Cervus_giganteus-ulna.tif',249,4,227,249.1605317,107.9039339,135.8713219,1.8,108.0922585,135.3487082,-0.5424731,10.736325,16.1385813,2889.2063576,11337.0003391,11.0677053,702.4781275,269.1057093,880.9096951,16.837772,29.772759,0.3537031,87.5804597),(10466,'Cervus_giganteus-ulna.tif',249,4,228,247.7152005,107.8777567,136.0044873,1.8,108.1224638,135.5187067,-0.53071,10.7178373,16.0169256,2904.8458518,11039.4600798,10.5767624,689.2371447,271.0291054,869.8340792,16.8017012,29.6266685,0.3400971,85.5057425),(10467,'Cervus_giganteus-ulna.tif',249,4,229,245.0845893,107.8706573,136.1343977,1.8,108.1625221,135.6581437,-0.5221486,10.6744438,15.8787287,2893.4810431,10697.2687028,10.1606014,673.6854623,271.0662111,854.8311345,16.571888,29.4861163,0.3263588,83.6827307),(10468,'Cervus_giganteus-ulna.tif',249,4,230,243.4833842,107.878692,136.2645532,1.8,108.2316016,135.8629017,-0.5110118,10.7246966,15.7786212,2911.5045333,10421.284338,9.7060472,660.4686296,271.4766333,844.9794524,16.9041733,29.2219435,0.3450022,91.3739289),(10469,'Cervus_giganteus-ulna.tif',249,4,231,245.6724457,107.9339207,136.5361688,1.8,108.3416642,136.1849049,-0.5120717,11.2145573,15.6531012,3203.9128155,10141.7424321,9.8303626,647.9062701,285.6923129,852.5849092,17.4531894,29.0794352,0.3310961,86.2608587),(10470,'Cervus_giganteus-ulna.tif',249,4,232,243.0916291,107.9563297,136.6403889,1.8,108.32616,136.2770086,-0.5034464,11.285243,15.4762651,3166.1114301,9859.9144006,9.4301421,637.0990911,280.553236,841.6173851,17.3915484,28.9426051,0.3170558,86.5125641),(10471,'Cervus_giganteus-ulna.tif',249,4,233,241.2385974,107.9803264,136.7516532,1.8,108.3388704,136.3910261,-0.495809,10.9371709,15.3355284,3154.8746272,9580.3839925,9.0999928,624.7182191,288.4543595,829.7533098,17.1029983,28.6734253,0.3359676,81.6511993),(10472,'Cervus_giganteus-ulna.tif',249,4,234,239.1735189,107.9842408,136.8582372,1.8,108.3195971,136.4520004,-0.4838393,11.5701146,15.1731856,3128.9693785,9346.7212447,8.625936,616.0025648,270.4354688,821.7297053,17.1875201,28.5346483,0.3217506,81.1909743),(10473,'Cervus_giganteus-ulna.tif',249,4,235,235.9930407,107.9764613,136.9506248,1.8,108.2872598,136.5459526,-0.4765308,10.8763011,15.021144,3065.8354531,9071.6987282,8.2756863,603.9286168,281.8821797,807.8331247,16.93643,28.4016945,0.3073975,81.1909743),(10474,'Cervus_giganteus-ulna.tif',249,4,236,235.3108542,108.2815718,137.2845262,1.8,108.4995481,136.806196,-0.5686138,11.1344989,14.7799858,3447.9682467,8129.6429847,11.3711624,550.0440336,309.6653272,783.3300817,17.3740903,28.0385827,0.2635639,83.5352851),(10475,'Cervus_giganteus-ulna.tif',249,4,237,234.029174,108.2688929,137.3662844,1.8,108.5090006,136.8908336,-0.5643624,10.7551299,14.604516,3396.7156991,7967.447462,11.1590438,545.5468338,315.8228434,778.012799,17.2003341,27.7406788,0.282555,80.3494865),(10476,'Cervus_giganteus-ulna.tif',249,4,238,231.7639658,108.2324932,137.4389452,1.8,108.4320467,136.9450363,-0.5551401,11.2369954,14.5367416,3342.0305473,7759.7698797,10.7304697,533.8039369,297.4131814,763.2199196,17.1502467,27.6239597,0.2676163,79.7418159),(10477,'Cervus_giganteus-ulna.tif',249,4,239,216.4530118,108.2121063,137.003084,1.8,108.3706158,136.5848174,-0.434555,10.5150012,14.0228359,2681.5880245,7275.3662272,6.3942637,518.8227461,255.0249846,706.1819735,15.8984561,27.4529949,0.3019512,78.4654007),(10478,'Cervus_giganteus-ulna.tif',249,4,240,213.7502263,108.1987786,137.0822279,1.8,108.4340224,136.661518,-0.4268993,10.2308782,13.8781581,2629.0242015,7098.8683736,6.1074747,511.5137286,256.9695544,698.110486,15.8984561,27.3282921,0.2869388,78.7171061),(10479,'Cervus_giganteus-ulna.tif',249,4,241,216.3196293,108.2316075,137.2925104,1.8,108.4532016,136.9089932,-0.4095508,10.8981575,13.9079538,2902.9367384,7041.0273017,5.7166458,506.2590383,266.3694985,703.0042012,16.7578321,27.5134567,0.2525543,83.2225057),(10480,'Cervus_giganteus-ulna.tif',249,4,242,213.3369309,108.2951543,137.3662024,1.8,108.6227548,136.9971889,-0.4206639,10.686143,13.5471274,2819.2067533,6668.183479,5.9294591,492.221213,263.8189245,696.217353,16.3281441,25.741862,0.2530757,75.7830129),(10481,'Cervus_giganteus-ulna.tif',249,4,243,206.1224161,108.1712427,137.2571549,1.8,108.4058965,136.8192541,-0.4122706,9.7876757,13.3878072,2430.9637459,6486.6264051,5.5155975,484.5174639,248.3698705,662.5691459,15.4610605,25.4533479,0.3805064,74.7151173),(10482,'Cervus_giganteus-ulna.tif',249,4,244,204.335684,108.1360982,137.3274417,1.8,108.3405209,136.864707,-0.3995678,9.4963939,13.4288716,2405.2434437,6336.162527,5.1539147,471.8313439,253.2796631,646.3435673,15.3635619,25.4533479,0.3805064,74.1074467),(10483,'Cervus_giganteus-ulna.tif',249,4,245,203.0628996,108.0850598,137.4009362,1.8,108.2733324,136.9373226,-0.3835704,9.5193294,13.3155153,2382.8010843,6224.3893323,4.7398584,467.4538823,250.3118638,642.5008391,15.2512459,25.3260894,0.2573237,74.4634119),(10484,'Cervus_giganteus-ulna.tif',249,4,246,208.2108253,108.1596028,137.6820332,1.8,108.4373817,137.2486101,-0.3516285,10.0922631,13.0332184,2760.0418321,6186.6535291,4.1166761,474.6834846,273.4809618,671.8178005,15.8984561,25.0549008,0.3868757,76.6423889),(10485,'Cervus_giganteus-ulna.tif',249,4,247,202.0215764,108.4019232,137.650054,1.8,108.5999197,137.1882374,-0.3344944,10.0868799,12.6039901,2730.8415564,5524.4101197,3.6288267,438.3064469,270.7320387,555.8774197,15.8984561,24.4959851,0.266252,73.9600011),(10486,'Cervus_giganteus-ulna.tif',249,4,248,197.0744518,108.3127595,137.5701553,1.8,108.4133726,137.0960297,-0.3168103,9.676022,12.6158492,2479.7567072,5430.7161102,3.1878564,430.4677421,256.2785311,542.1007113,15.4687681,24.4959851,0.266252,73.7082957),(10487,'Cervus_giganteus-ulna.tif',249,4,249,196.0893573,108.2586772,137.6219817,1.8,108.2681687,137.1249921,-0.2951297,9.5035182,12.4957472,2464.4398311,5365.7833425,2.7649207,429.408764,259.3186839,558.800333,15.4687681,25.7562029,2.6555607,74.3159663),(10488,'Cervus_giganteus-ulna.tif',249,4,250,195.5558833,108.2009731,137.6767583,1.8,108.1542702,137.1438688,-0.2756749,9.2200301,12.2164229,2449.0692895,5331.3139436,2.4148175,436.4054841,265.6248689,551.0708495,15.0390801,25.7562029,2.6555607,72.4929545),(10489,'Cervus_giganteus-ulna.tif',249,4,251,195.1691077,108.1441137,137.7200844,1.8,107.9690793,137.1530089,-0.2525039,9.1487273,12.0922984,2443.9961227,5309.2967623,2.0302347,439.0643183,267.1405586,573.0614075,15.0390801,25.4243164,2.6098686,70.4614231),(10490,'Cervus_giganteus-ulna.tif',249,4,252,190.1937288,108.3383528,137.6778117,1.8,108.1751813,137.0924048,-0.1815113,8.2059273,14.385396,2435.8496665,4949.6040743,1.0329458,344.0714508,296.8402702,453.5991659,15.3711399,24.9995715,2.6395025,70.6699427),(10491,'Cervus_giganteus-ulna.tif',249,4,253,190.0380227,108.3081945,137.6834166,1.8,108.1200616,137.1040197,-0.1707427,7.9040727,14.0855828,2368.4139663,4978.1740796,0.9144276,353.4233648,299.6447593,463.6315886,15.2722074,25.1761971,2.6626791,70.6699427),(10492,'Cervus_giganteus-ulna.tif',249,4,254,189.7437308,108.2966829,137.733698,1.8,108.1093839,137.1617708,-0.1551462,7.7544873,14.5316361,2346.9303313,4968.7310238,0.7551118,341.9250933,302.6544822,449.9418441,15.1155456,24.5975272,2.6701327,69.202896),(10493,'Cervus_giganteus-ulna.tif',249,4,255,189.8297245,108.2576734,137.7779765,1.8,108.0849058,137.2115293,-0.1342725,7.6227135,14.6361099,2325.7555902,5006.0109038,0.5669898,342.0315203,305.1086199,451.5865196,15.0024457,24.5975272,2.6701327,68.4909656),(10494,'Cervus_giganteus-ulna.tif',249,4,256,175.5943904,108.6419442,137.5139499,1.8,108.4427061,136.9794508,-0.0684662,7.4549309,15.4679486,2027.2451665,4298.7502368,0.1369722,277.9134036,271.933463,382.8394234,14.6093921,25.3661537,2.6855207,69.5156754),(10495,'Cervus_giganteus-ulna.tif',249,4,257,177.9840852,108.6364264,137.5016931,1.8,108.4780454,136.9648376,-0.0450787,7.4152877,15.5946785,2074.4626688,4437.4500878,0.060239,284.5489952,279.7548476,394.300819,14.6093921,24.9811012,2.677945,67.1281788),(10496,'Cervus_giganteus-ulna.tif',249,4,258,167.727566,108.5940086,137.1740338,1.8,108.4640191,136.6820695,-0.0638896,6.9124062,15.468251,1623.7771357,4324.7654837,0.113952,279.5898187,234.9076559,363.0830763,13.3203281,24.791918,2.6934477,65.8085778),(10497,'Cervus_giganteus-ulna.tif',249,4,259,167.5756644,108.5915633,137.2089417,1.8,108.5299349,136.7141626,-0.0540761,6.7918061,15.5161604,1608.9419576,4357.7944859,0.0815918,280.8552105,236.8945651,364.0367861,13.3203281,24.791918,2.6934477,66.5205082),(10498,'Cervus_giganteus-ulna.tif',249,4,260,167.1165467,108.5643889,137.2482684,1.8,108.4689497,136.7611776,-0.039547,6.6251811,15.56255,1591.4305938,4381.0933231,0.0435381,281.5151324,240.2093708,364.7338288,12.8906401,24.791918,2.6934477,65.4526126),(10499,'Cervus_giganteus-ulna.tif',249,4,261,152.9109215,109.2809805,137.1466944,1.8,109.3177046,136.6817596,0.0132203,6.3817569,13.0818607,1496.4089319,3324.6482123,0.004454,254.1418444,234.482283,354.1125114,12.8906401,24.4053708,2.6858189,63.3347096),(10500,'Cervus_giganteus-ulna.tif',249,4,262,153.1621886,109.2911745,137.1773325,1.8,109.3552328,136.7023252,0.0230972,6.3600915,13.1293644,1487.6543711,3353.2347679,0.0136157,255.3996264,233.9045563,355.0826043,12.8906401,24.4053708,2.6858189,63.3347096),(10501,'Cervus_giganteus-ulna.tif',249,4,263,153.4553055,109.2993469,137.209201,1.8,109.3157571,136.7248308,0.0381629,6.4225289,13.6383427,1478.1227752,3396.7386622,0.0372309,249.0580231,230.1465352,343.5421524,12.8906401,24.9995715,2.7163876,64.2983454),(10502,'Cervus_giganteus-ulna.tif',249,4,264,153.9773099,109.3063341,137.2314363,1.8,109.337921,136.7359069,0.0474466,6.4878641,13.6821626,1470.9794775,3447.924878,0.0577284,252.001454,226.7278498,346.3140334,12.8906401,24.9995715,2.7163876,64.6543106),(10503,'Cervus_giganteus-ulna.tif',249,4,265,154.5705934,109.3088999,137.2632742,1.8,109.3162542,136.7372383,0.0611919,6.5544088,13.7377904,1469.4845763,3497.8841817,0.0963434,254.6176705,224.1978813,349.4196544,12.8906401,24.9995715,2.7163876,63.9423802),(10504,'Cervus_giganteus-ulna.tif',249,4,266,155.1902288,109.3226972,137.2870026,1.8,109.3180037,136.7377646,0.0708278,6.5989695,13.7878266,1468.3472222,3548.2278963,0.1295371,257.3449746,222.5115933,352.3704549,12.8906401,24.9811012,2.677945,63.586415),(10505,'Cervus_giganteus-ulna.tif',249,4,267,151.7065069,109.3380443,137.1438592,1.8,109.2784163,136.6367035,0.0689014,6.2239729,13.7864247,1327.8972687,3579.3134789,0.1198456,259.6259398,213.3520329,345.4195763,12.63051,24.9995715,2.7163876,63.586415),(10506,'Cervus_giganteus-ulna.tif',249,4,268,154.6274376,109.2677823,137.1826517,1.8,109.2264707,136.6689914,0.0637404,6.1984885,13.7008942,1347.6830406,3793.6552293,0.1045625,276.8910673,217.4212393,363.3012618,12.6042782,24.9995715,2.7163876,64.906016),(10507,'Cervus_giganteus-ulna.tif',249,4,269,156.0557043,109.2977923,137.200507,1.8,109.2517343,136.676562,0.070332,6.2645331,13.7853408,1355.75844,3883.1981872,0.1284454,281.6904009,216.418114,365.7030608,12.6042782,25.3661537,2.6855207,65.1577214),(10508,'Cervus_giganteus-ulna.tif',249,4,270,150.6006185,109.7349394,137.1783517,1.8,110.1512359,136.7496394,0.1039486,6.4039662,14.3410364,1313.6952668,3562.0837693,0.270239,248.3839849,205.1377571,331.0004377,12.5581401,27.3113968,2.7201734,84.0208077),(10509,'Cervus_giganteus-ulna.tif',249,4,271,152.1417903,109.6671065,137.0882248,1.8,109.4228611,135.9403669,0.1153206,7.7076679,14.3006172,1397.4764082,3547.4754367,0.3357259,248.064499,181.3098897,337.8412182,14.0745606,25.3661537,2.6855207,77.6492105),(10510,'Cervus_giganteus-ulna.tif',249,4,272,150.2600568,109.6272848,137.1716352,1.8,109.0170114,136.3829006,0.13197,6.5348377,18.8642956,1309.5854218,3700.6088902,0.4336304,196.1700014,200.4006031,258.239478,12.4609521,25.5583106,2.6704264,63.9423802),(10511,'Cervus_giganteus-ulna.tif',249,4,273,151.4102568,109.6694314,137.1521187,1.8,109.6638999,136.6262636,0.1158067,6.4622326,15.1654439,1334.8737365,3643.2438887,0.3369219,240.2332503,206.5654106,321.7012902,12.5780464,25.1798637,2.7008418,63.6906748),(10512,'Cervus_giganteus-ulna.tif',249,4,274,151.5504091,109.6801504,137.1674894,1.8,109.6771143,136.6434052,0.1163087,6.4296551,15.1794167,1333.6174523,3683.3695546,0.3401504,242.6555405,207.4166397,323.8998364,12.4609521,25.0549008,2.7547169,62.9787444),(10513,'Cervus_giganteus-ulna.tif',249,4,275,151.631759,109.6893093,137.1735225,1.8,109.5954749,136.5843652,0.1192558,6.4523873,15.1982478,1340.787811,3735.8655821,0.3577156,245.8089659,207.7971683,327.5281647,12.4609521,26.0129867,2.7518841,65.0534616),(10514,'Cervus_giganteus-ulna.tif',249,4,276,143.2662609,109.6887842,136.8606616,1.8,109.5940119,136.2879927,0.0974071,6.0077545,15.5666295,1089.8860249,3679.4034999,0.2258393,236.3648155,181.4132083,299.1253868,12.0312641,26.744411,2.7282622,66.164543),(10515,'Cervus_giganteus-ulna.tif',249,4,277,143.0669704,109.707242,136.8810874,1.8,109.6183117,136.2842437,0.103931,6.0664871,15.6092756,1094.9026165,3723.4686694,0.2566339,238.5420551,180.4837957,301.7516222,12.040506,27.1010188,2.6992184,66.7722136),(10516,'Cervus_giganteus-ulna.tif',249,4,278,143.6259571,109.7338883,136.9045994,1.8,109.5669881,136.2655754,0.1092011,6.0724102,15.6558461,1102.6605493,3792.886303,0.2843207,242.2664534,181.5853198,305.9592743,11.9844205,27.1010188,2.6992184,68.9511906),(10517,'Cervus_giganteus-ulna.tif',249,4,279,144.6511671,109.7810362,136.9280015,1.8,109.6553925,136.2861882,0.1176477,6.1376546,15.7327624,1118.7321939,3891.1499617,0.3321491,247.3278292,182.2735676,312.0888059,11.9844205,27.4899596,2.7059098,69.0554504),(10518,'Cervus_giganteus-ulna.tif',249,4,280,146.3270082,109.849286,136.9603177,1.8,109.7022727,136.3216535,0.1253712,6.1501563,15.8286795,1137.4040549,4001.1375814,0.3813225,252.7777247,184.93905,318.6163543,11.928335,27.7040486,2.7265179,70.1665318),(10519,'Cervus_giganteus-ulna.tif',249,4,281,147.8198401,109.9181167,136.9839243,1.8,109.7043211,136.3053368,0.1337171,6.2059495,16.8342795,1157.2725447,4134.3204759,0.4378907,245.5893927,186.4779188,308.517464,11.928335,29.022236,2.69781,71.381873),(10520,'Cervus_giganteus-ulna.tif',249,4,282,157.2149681,110.230687,137.3387061,1.8,109.9648797,136.6122333,0.220916,7.125232,18.3717113,1397.9883337,4597.4683802,1.2581148,250.2471497,196.2025016,323.7825729,13.0968564,29.5986114,2.658467,74.6719315),(10521,'Cervus_giganteus-ulna.tif',249,4,283,159.1836464,110.2889543,137.3616089,1.8,109.9428837,136.5992475,0.2272505,7.1784348,18.4479326,1415.2242357,4758.7746811,1.3466905,257.9570721,197.149416,332.3015988,13.0968564,30.5592465,2.6590794,76.6423889),(10522,'Cervus_giganteus-ulna.tif',249,4,284,161.5398277,110.385309,137.3881039,1.8,110.0035582,136.580087,0.2331511,7.222328,18.5605044,1444.958345,4934.5359696,1.4372077,265.8621699,200.0682255,341.5305359,13.0968564,30.9405201,2.6655233,76.1389781),(10523,'Cervus_giganteus-ulna.tif',249,4,285,160.9154925,110.4974626,137.288764,1.8,110.0577407,136.4909259,0.2324907,7.0953797,19.1624888,1382.2298747,5098.4899957,1.4237008,266.0661699,194.8070327,335.7659088,12.9397108,31.7213367,2.6476513,78.6739203),(10524,'Cervus_giganteus-ulna.tif',249,4,286,161.1309522,110.7177262,137.2951318,1.8,110.1241168,136.4269658,0.249696,7.1603135,19.4144134,1388.1642552,5111.9717746,1.6398583,263.3080733,193.8692002,333.1634987,12.9397108,31.7213367,2.6476513,77.9619899),(10525,'Cervus_giganteus-ulna.tif',249,4,287,110.7546745,112.6926108,136.5538405,1.8,112.2189244,135.906538,0.3652112,6.441254,15.7166395,738.8405813,2604.9604959,2.3545277,165.745387,114.7044638,212.7490423,11.3250346,27.0566999,2.5712094,66.3298768),(10526,'Cervus_giganteus-ulna.tif',249,4,288,113.0260929,112.8141184,136.602603,1.8,112.3511823,135.9272538,0.3717778,6.4677203,16.2467518,760.4514856,2732.944207,2.4859491,168.2148061,117.5764327,214.9623214,11.3250346,27.4193474,2.5796711,66.4773224),(10527,'Cervus_giganteus-ulna.tif',249,4,289,118.6731958,112.9104365,136.591043,1.8,112.4729632,135.9507752,0.3809353,6.6143763,16.7265915,826.5131645,3029.5911344,2.7339734,181.1242376,124.9570817,230.3149522,11.5431177,28.1503038,2.5959376,68.1960744),(10528,'Cervus_giganteus-ulna.tif',249,4,290,101.4383786,113.1316822,136.0282196,1.8,112.5993644,135.4949504,0.3453865,6.2314549,16.7597863,603.2327303,2852.904311,1.9378641,170.2231909,96.8044767,206.0127272,11.6293317,28.1503038,2.5959376,68.5520396),(10529,'Cervus_giganteus-ulna.tif',249,4,291,103.5313197,113.2156351,136.0764574,1.8,112.6339035,135.5094669,0.3581803,6.0888801,16.9950578,633.7722624,3024.9442047,2.1206621,177.9896388,104.0868355,215.1722104,11.6952663,28.7409566,2.5909171,69.4114156),(10530,'Cervus_giganteus-ulna.tif',249,4,292,97.1531869,114.0066322,136.1942282,1.8,113.1052328,135.5194413,0.4499559,6.2228868,18.4112818,607.370816,2557.5646267,3.0629232,138.9129046,97.6027428,170.0721611,11.6390554,29.4767223,2.6061731,71.1301676),(10531,'Cervus_giganteus-ulna.tif',249,4,293,99.5917251,114.1075806,136.2513622,1.8,113.2046814,135.541606,0.4598732,6.4498634,18.4993393,633.7887571,2720.4940114,3.269747,147.0589825,98.2639039,179.1549378,11.7860642,29.8470826,2.6135182,71.7378382),(10532,'Cervus_giganteus-ulna.tif',249,4,294,97.4797613,113.9973278,135.9533197,1.8,113.0585849,135.2730035,0.390479,5.9753203,18.4393937,554.7017265,2624.7465153,2.3538154,142.3445128,92.8321321,171.5857968,11.066091,29.6328997,2.6260436,71.1301676),(10533,'Cervus_giganteus-ulna.tif',249,4,295,100.3379173,114.0671316,135.9789925,1.8,113.0162175,135.2271457,0.3953739,5.9911714,20.8182161,583.2611937,2805.2869437,2.4807391,134.7515526,97.3534481,162.0547878,11.1069112,30.7609797,2.6467052,73.4565903),(10534,'Cervus_giganteus-ulna.tif',249,4,296,103.1990944,114.1401071,136.0005851,1.8,112.9838635,135.1855121,0.3983791,6.1608479,21.8466475,615.0629606,2992.3366228,2.5883311,136.9700604,99.8341408,164.4603591,11.412392,32.511797,2.6306431,76.8940943),(10535,'Cervus_giganteus-ulna.tif',249,4,297,105.9839012,114.206509,136.0231473,1.8,112.9805378,135.1830976,0.4033256,6.1757633,21.9065935,645.1351292,3160.9771245,2.7209593,144.2934123,104.4624119,172.9666997,11.4532122,33.4715647,2.6320004,79.6807419),(10536,'Cervus_giganteus-ulna.tif',249,4,298,109.0743015,114.2866316,136.0442633,1.8,113.1016703,135.2312817,0.4065813,6.2312735,22.9409026,679.3425196,3353.3254779,2.8431644,146.1723429,109.0214571,175.0487755,11.6094013,34.0566711,2.6271413,80.0798929),(10537,'Cervus_giganteus-ulna.tif',249,4,299,112.1701288,114.3317033,136.0472803,1.8,112.9264144,135.1247577,0.4088085,6.3934704,22.9787115,713.5557844,3581.5798053,2.9541722,155.8651276,111.6069587,186.0881555,11.776898,35.016277,2.6285347,82.8665405),(10538,'Cervus_giganteus-ulna.tif',249,4,300,111.7788773,114.2710612,135.8491782,1.8,112.8120319,134.9215929,0.3738368,6.1126023,22.9118254,677.5150275,3600.3811904,2.48454,157.1407397,110.8390497,186.2963319,11.2357296,34.6025591,2.6501744,81.6511993),(10539,'Cervus_giganteus-ulna.tif',249,4,301,115.4559591,114.3241284,135.8448367,1.8,112.7971546,134.9105122,0.3754356,6.2524583,23.9142045,717.7940171,3836.3478934,2.5872267,160.4213051,114.8018878,190.0604089,11.5113041,36.1449094,2.646041,84.4810327),(10540,'Cervus_giganteus-ulna.tif',249,4,302,102.5216636,114.8554255,135.5513861,1.8,112.8496147,134.52575,0.3856285,5.8208817,25.2374063,595.0749234,3303.0089963,2.4175033,130.877514,102.2310629,153.9011654,11.2205834,35.9425732,2.6565579,85.2972229),(10541,'Cervus_giganteus-ulna.tif',249,4,303,105.9901115,114.9307778,135.554498,1.8,112.7705091,134.4440606,0.3863924,5.9599877,26.2646749,634.1071441,3536.2365608,2.5087045,134.6385049,106.3940354,158.2683221,11.434669,36.9031708,2.6571147,86.5557499),(10542,'Cervus_giganteus-ulna.tif',249,4,304,109.6199163,114.9831414,135.5523818,1.8,112.7355421,134.4198168,0.3884602,6.0183152,26.3079027,676.4629711,3838.5774525,2.6210484,145.9096722,112.4007216,171.0298809,11.6011897,38.4444717,2.6529503,90.2017736),(10543,'Cervus_giganteus-ulna.tif',249,4,305,116.4059176,115.0053801,135.4652036,1.8,113.179984,134.3764236,0.3918632,6.2670571,23.3436234,762.3913914,4167.0841331,2.8297509,178.5105963,121.6506216,210.6635645,11.8592633,35.6019265,2.6239435,83.7259165),(10544,'Cervus_giganteus-ulna.tif',249,4,306,119.8738619,115.076106,135.4663036,1.8,113.4079439,134.4273503,0.392375,6.4071855,23.408563,811.5987739,4396.553287,2.921276,187.8181626,126.670092,221.933349,12.0642927,35.6019265,2.6239435,85.0455175),(10545,'Cervus_giganteus-ulna.tif',249,4,307,118.7018977,115.6110132,135.5709677,1.8,114.3841135,134.6090402,0.4511381,6.6881959,20.9035938,831.3698043,3716.7734209,3.7606215,177.8054745,124.3040448,216.3341301,11.8587762,33.1612256,2.5967287,78.2136953),(10546,'Cervus_giganteus-ulna.tif',249,4,308,115.6880916,116.2162789,135.6443034,1.8,114.8116304,134.5902487,0.5195855,6.871091,21.2629672,829.107725,3380.0917588,4.7534793,158.9661372,120.666095,194.7024042,12.2270907,33.385956,2.5857218,79.4290365),(10547,'Cervus_giganteus-ulna.tif',249,4,309,112.8440908,116.038711,135.2309116,1.8,114.6294806,134.214584,0.4427709,6.5450516,23.0836012,758.1426762,3277.0635333,3.4523698,141.9650036,115.8344839,173.776372,11.4419046,33.0971351,2.6256671,78.1094355),(10548,'Cervus_giganteus-ulna.tif',249,4,310,117.2899121,116.1162787,135.2008158,1.8,114.7165819,134.1771597,0.4393146,6.6803624,23.1495731,819.0391182,3571.5574946,3.5362216,154.2817868,122.6039949,188.5658298,11.6094013,33.3112143,2.6144467,79.5332963),(10549,'Cervus_giganteus-ulna.tif',249,4,311,121.9407867,116.1624504,135.153527,1.8,114.6240558,134.0665598,0.434516,6.7870993,24.1436801,883.7795667,3904.9739677,3.6016622,161.7389704,130.2146208,197.3525622,11.8177182,35.9759472,2.6298538,85.2972229),(10550,'Cervus_giganteus-ulna.tif',249,4,312,127.3405949,116.2681308,135.1160629,1.8,114.8207729,134.0738566,0.4279188,6.9028637,24.2397447,958.299948,4273.288234,3.6548215,176.2926252,138.8264343,214.8267416,12.0260351,36.3511988,2.6356423,85.0887033),(10551,'Cervus_giganteus-ulna.tif',249,4,313,132.9230207,116.3703237,135.0814661,1.8,114.825107,133.9786661,0.4230749,7.1712525,24.8979999,1037.7369606,4690.0613999,3.7343518,188.3710107,144.7079102,229.2501368,12.4018487,36.9356769,2.6311043,86.9117151),(10552,'Cervus_giganteus-ulna.tif',249,4,314,137.5505645,116.3853415,135.0355498,1.8,114.6964029,133.8819374,0.421755,7.2951714,24.895632,1115.4808969,5109.1872684,3.8417303,205.2242444,152.9067419,249.1477867,12.6101655,37.1052447,2.646867,87.1634205),(10553,'Cervus_giganteus-ulna.tif',249,4,315,142.497857,116.4584569,135.0042643,1.8,114.8453727,133.8812333,0.4230897,7.4565167,25.9066548,1202.1570175,5453.2244262,4.0036127,210.4951202,161.222333,256.0180934,12.7776623,38.480474,2.6279866,92.0247854),(10554,'Cervus_giganteus-ulna.tif',249,4,316,112.0317669,117.837039,134.5381411,1.8,117.3681193,133.8700998,0.4972548,6.9827624,16.4042447,826.2499993,3024.2519537,4.2486728,184.3578908,118.3270958,233.7276892,11.4710829,28.3724261,2.5283853,66.8332876),(10555,'Cervus_giganteus-ulna.tif',249,4,317,116.5999488,117.8993866,134.4990713,1.8,117.3498729,133.7668134,0.4972656,7.1236757,16.4403878,890.7603389,3255.3105909,4.4220909,198.0069225,125.0422358,251.0286052,11.7082436,28.3724261,2.5283853,67.084993),(10556,'Cervus_giganteus-ulna.tif',249,4,318,82.4686941,119.1933668,133.6912873,1.8,118.4095018,133.1681597,0.565924,6.1195208,16.8199299,515.208722,2144.5022854,3.9517094,127.4976947,84.191024,154.8330021,11.1770866,28.1273386,2.5408789,66.5815822),(10557,'Cervus_giganteus-ulna.tif',249,4,319,86.5222568,119.2298111,133.6549546,1.8,118.3806404,133.0368302,0.5691933,6.3057638,16.819551,576.3569064,2326.5974066,4.1886873,138.3269626,91.4016006,168.7838664,11.4266077,28.3724261,2.5283853,66.7290278),(10558,'Cervus_giganteus-ulna.tif',249,4,320,89.6872931,119.2647708,133.6101927,1.8,118.314771,132.8847281,0.5704143,6.4834787,16.8204045,634.1978114,2494.9679365,4.3584927,148.3298421,97.8175208,181.7554951,11.7445063,28.6218659,2.5161076,67.5884038),(10559,'Cervus_giganteus-ulna.tif',249,4,321,86.0391929,118.8453514,132.7093006,1.8,117.9241859,132.1043985,0.416165,6.0734189,17.9633462,539.7423987,2370.373887,2.3434603,131.9561431,88.8696147,161.4901725,11.1576784,28.6057346,2.5702552,67.5884038),(10560,'Cervus_giganteus-ulna.tif',249,4,322,89.7547117,118.9403853,132.7068968,1.8,118.0133105,132.0970843,0.4216042,6.2200962,18.0410161,602.4311226,2542.3345263,2.5051263,140.9196973,96.852381,173.6544307,11.3853784,28.6057346,2.5702552,67.8401092),(10561,'Cervus_giganteus-ulna.tif',249,4,323,70.1851977,119.3839504,131.6572464,1.8,118.3867817,131.2875392,0.3044056,5.5425589,17.3897115,308.349938,1585.2000065,1.0508572,91.1573494,55.6331369,108.8697371,9.9906342,26.5434526,2.6344941,63.0830042),(10562,'Cervus_giganteus-ulna.tif',249,4,324,73.4402559,119.4019647,131.584971,1.8,118.3835799,131.1767183,0.3040662,5.6199741,17.3853704,352.2050445,1730.0776008,1.0972188,99.513416,62.6702255,119.7409981,10.1956636,27.503389,2.6360116,65.765392),(10563,'Cervus_giganteus-ulna.tif',249,4,325,77.0362676,119.4452766,131.5500504,1.8,118.3817577,131.0911909,0.3116988,5.8746721,17.4123541,404.6812428,1888.2279907,1.2075456,108.4418556,68.8857589,131.6110074,10.6649809,28.0879262,2.6300365,66.8764734),(10564,'Cervus_giganteus-ulna.tif',249,4,326,81.2330599,119.4974962,131.5019248,1.8,118.4912614,131.0097472,0.3129636,5.9244212,17.4464783,462.4543902,2047.664814,1.2833449,117.3683753,78.0589991,143.772729,10.8732978,28.0879262,2.6300365,67.1281788),(10565,'Cervus_giganteus-ulna.tif',249,4,327,84.9750425,119.5527163,131.446345,1.8,118.6697163,130.9987289,0.3074092,6.0470479,17.4856857,514.467859,2213.0015179,1.2967315,126.5607511,85.0775238,155.8811122,11.2491114,28.0879262,2.6300365,68.4477798),(10566,'Cervus_giganteus-ulna.tif',249,4,328,89.3248554,119.5946192,131.3896682,1.8,118.6477201,130.8275006,0.3078286,6.1097802,17.5081797,578.2716086,2413.4402784,1.3667142,137.8464419,94.6468766,170.7362248,11.4574283,28.0879262,2.6300365,68.6994852),(10567,'Cervus_giganteus-ulna.tif',249,4,329,93.8789381,119.6486108,131.3447421,1.8,118.7995152,130.7787819,0.3037077,6.2459826,17.5490266,648.8666313,2607.7036613,1.3993761,148.5953449,103.8854373,185.4252662,11.8332419,28.0879262,2.6300365,68.9511906),(10568,'Cervus_giganteus-ulna.tif',249,4,330,77.1975127,120.1449348,130.4425294,1.8,119.0526815,129.9695085,0.2364506,6.1475968,16.9916378,382.2670143,2006.3064821,0.7060318,118.0761092,62.1815366,140.5509408,10.7682825,26.519096,2.6706988,65.6611322),(10569,'Cervus_giganteus-ulna.tif',249,4,331,59.8119688,121.8547479,130.0038574,1.8,120.9143446,129.5888467,0.330044,5.0961609,14.1712459,243.2521441,971.1430341,1.047017,68.5291215,47.7324305,85.6377332,9.73745,22.1820579,2.5912067,54.9926549),(10570,'Cervus_giganteus-ulna.tif',249,4,332,62.5743959,121.9368136,129.8691176,1.8,120.8507426,129.3301395,0.3209701,5.1532063,14.2107034,267.5069299,1089.7614696,1.0380282,76.6859625,51.9107741,95.4413157,9.8478407,21.9603782,2.6078845,55.3486201),(10571,'Cervus_giganteus-ulna.tif',249,4,333,70.4848606,121.5184561,129.7579126,1.8,120.1183422,129.1547044,0.2725285,5.5167164,16.2703269,323.3198042,1596.7405483,0.8511179,98.138197,58.6072913,117.9449899,10.5321543,24.7956413,2.6546934,62.6838532),(10572,'Cervus_giganteus-ulna.tif',249,4,334,73.0968968,121.5204735,129.5220083,1.8,119.9970095,128.8205764,0.2401777,5.2848503,16.6424793,326.578096,1774.5528167,0.6893601,106.6279116,61.7951464,126.223906,10.3067632,24.791918,2.6934477,61.867663),(10573,'Cervus_giganteus-ulna.tif',249,4,335,77.8567041,121.6058204,129.4730285,1.8,120.1073517,128.8103082,0.2399602,5.5336614,16.7138149,372.2913531,2027.1542115,0.7329448,121.2861473,67.2775809,143.5175341,10.6563973,25.3661537,2.6855207,63.586415),(10574,'Cervus_giganteus-ulna.tif',249,4,336,81.0367907,121.8918296,129.4356103,1.8,120.381828,128.7212087,0.2562111,5.7038318,18.1301375,416.7412929,2116.4734049,0.8673672,116.7378576,73.0633911,139.7117841,10.9589175,26.7167824,2.6563657,66.9807332),(10575,'Cervus_giganteus-ulna.tif',249,4,337,86.0902185,121.8951979,129.1217251,1.8,120.4161389,128.475732,0.2379005,5.8348738,18.4696027,454.7195692,2522.5851249,0.7968644,136.5803675,77.9313455,161.193884,11.16225,27.2877256,2.6849872,67.9875548),(10576,'Cervus_giganteus-ulna.tif',249,4,338,87.6067168,122.1569078,129.0392938,1.8,120.6316591,128.4300392,0.2401089,5.9077778,17.3502527,484.424663,2666.7335924,0.8257345,153.6999858,81.9977791,181.615237,11.5181868,25.9561431,2.8041366,66.3730626),(10577,'Cervus_giganteus-ulna.tif',249,4,339,89.9503095,122.4270872,128.9615505,1.8,120.9224907,128.3910548,0.2396295,6.1829029,17.5943203,531.3083221,2852.9190827,0.8445074,162.1500024,85.9318565,192.3265598,11.9107264,26.3269387,2.6852442,66.4162484),(10578,'Cervus_giganteus-ulna.tif',249,4,340,75.1881035,123.8554439,128.4705197,1.8,122.5454438,127.9311668,0.2732893,6.0244204,15.6244298,366.8670488,1573.0070304,0.9128596,100.676124,60.8966546,124.1217195,11.3390966,23.4721374,2.7270858,59.8972056),(10579,'Cervus_giganteus-ulna.tif',249,4,341,74.1498574,123.970044,128.0577274,1.8,122.7938138,127.6619585,0.2267122,5.772249,14.8061979,328.6248323,1628.9891494,0.6243892,110.0207603,56.931853,132.211262,11.6015761,23.0794863,2.7195876,63.187264),(10580,'Cervus_giganteus-ulna.tif',249,4,342,75.3518663,124.1076871,127.7343637,1.8,122.9199921,127.3916697,0.1869288,5.8283059,14.6022348,312.4418943,1704.2923817,0.4337415,116.71449,53.6076692,137.5730308,11.6015761,23.2548164,2.6614176,60.4006164),(10581,'Cervus_giganteus-ulna.tif',249,4,343,78.2982538,124.2769802,127.5079301,1.8,123.1551087,127.0636378,0.1727807,5.7136794,14.4887045,326.5868166,1825.6715296,0.3857138,126.0065404,57.1587582,148.5471486,11.6015761,23.2548164,2.6614176,61.6159576),(10582,'Cervus_giganteus-ulna.tif',249,4,344,83.6667305,124.2638891,127.3357215,1.8,123.1845772,126.9440908,0.1463564,5.9288656,14.6968303,365.4746411,2099.7650978,0.2965661,142.8719701,61.643266,166.3663674,11.6015761,23.6484601,2.7104539,66.1213572),(10583,'Cervus_giganteus-ulna.tif',249,4,345,87.5485857,124.4095605,127.1976433,1.8,123.5722355,126.7179054,0.1324372,6.3245682,16.0730079,409.0514425,2275.7626318,0.2544353,141.589094,64.6765803,166.0346955,12.2014279,24.825408,2.7321554,64.6543106),(10584,'Cervus_giganteus-ulna.tif',249,4,346,93.6307482,124.5368677,127.1858325,1.8,123.7611873,126.7848466,0.1280868,7.0597891,17.4684143,509.4059582,2580.447554,0.2546241,147.7207665,72.155974,176.10083,13.6241677,26.2672603,3.0761126,71.6946524),(10585,'Cervus_giganteus-ulna.tif',249,4,347,101.1872234,124.7160456,127.2216454,1.8,124.1250869,126.7786634,0.1332369,7.6989157,17.6590148,664.4268877,2890.8979537,0.297613,163.7066385,86.3013595,200.5417724,14.3825836,26.9198763,2.6422459,72.9531794),(10586,'Cervus_giganteus-ulna.tif',249,4,348,103.0765101,124.7719094,126.9181083,1.8,124.2902731,126.3734328,0.096115,6.6111762,17.5738504,665.3862942,3173.4840911,0.158217,180.5798972,100.6456757,217.6630116,13.2321905,27.6206176,0.0934768,71.5293187),(10587,'Cervus_giganteus-ulna.tif',249,4,349,107.0406104,124.9350909,126.7925974,1.8,124.4488109,126.2716016,0.0863862,7.1059577,17.7102834,755.3269233,3516.2116221,0.1328024,198.5406751,106.2948805,240.3061873,14.032056,28.0912127,0.1072789,73.2480707),(10588,'Cervus_giganteus-ulna.tif',249,4,350,115.49227,124.4957665,126.6277712,1.8,123.9906769,126.1391169,0.0601356,7.0014262,18.4509325,812.410655,4634.1582243,0.0695251,251.1611928,116.035023,294.8329047,13.9672823,30.3257465,0.1278699,77.3975051),(10589,'Cervus_giganteus-ulna.tif',249,4,351,119.6963356,124.7061661,126.515841,1.8,124.2970207,126.0544596,0.0423885,7.6456841,18.6373275,907.4807827,4998.0772053,0.0358232,268.1756392,118.6919008,316.2990827,14.7175179,30.8718197,0.1537075,80.7918233),(10590,'Cervus_giganteus-ulna.tif',249,4,352,122.3610758,125.046652,126.4403728,1.8,124.7576766,126.0452627,0.0235242,7.8780982,18.9616546,1005.3619603,5136.562738,0.0112835,270.8921162,127.614805,322.4391074,14.9847259,31.6601632,0.136139,81.6511993),(10591,'Cervus_giganteus-ulna.tif',249,4,353,128.491858,125.262621,126.2343607,1.8,125.2409847,125.8794181,0.0023862,8.2410633,19.9939058,1188.2078511,5594.3941845,0.000122,279.8049682,144.1813764,337.5374716,15.4447284,29.67026,0.1746722,79.0730713),(10592,'Cervus_giganteus-ulna.tif',249,4,354,127.9851836,125.352081,125.8819436,1.8,125.4170504,125.5381443,-0.0432469,7.6725028,20.3968681,1077.5655496,5873.3709684,0.0398701,287.9545491,140.4451173,337.1179287,14.5468213,30.0228638,0.15809,79.6196679),(10593,'Cervus_giganteus-ulna.tif',249,4,355,132.3603413,125.5799406,125.7780711,1.8,125.6851095,125.4487126,-0.0598098,7.8932959,20.5777727,1187.1151358,6271.0218243,0.0788194,304.7473567,150.3953666,357.9620343,14.8311094,31.0952831,0.1946855,83.5173969),(10594,'Cervus_giganteus-ulna.tif',249,4,356,130.1185758,126.4960604,125.5897474,1.8,126.5557952,125.2660459,-0.0781517,8.1810356,17.192259,1307.6716849,5524.1629273,0.1321845,321.3168747,159.8418272,391.4523712,15.2611809,30.9405201,0.1674318,81.0435287),(10595,'Cervus_giganteus-ulna.tif',249,4,357,135.4599732,126.7313706,125.4536366,1.8,126.8313304,125.162259,-0.093715,8.4016853,17.3942295,1452.7496594,5943.8170478,0.1976999,341.7120054,172.9116966,417.4255103,15.3849274,31.4377786,0.178631,81.6511993),(10596,'Cervus_giganteus-ulna.tif',249,4,358,145.3056028,126.3578396,125.2660855,1.8,126.586025,124.9859545,-0.0641807,8.8713768,18.8823011,1650.5301518,8188.2085934,0.0996192,433.6446358,186.0511838,519.5456514,16.3421739,33.7079216,0.1923956,88.734727),(10597,'Cervus_giganteus-ulna.tif',249,4,359,154.1750338,126.5122219,125.1465817,1.8,126.6080298,124.8637148,-0.060346,9.407036,19.8808936,1883.8134861,9112.5389271,0.0934613,458.3566055,200.2557956,551.0071142,17.181904,34.634559,0.1998286,92.2764908),(10598,'Cervus_giganteus-ulna.tif',249,4,360,163.6642681,126.8735624,124.9988162,1.8,126.9161656,124.6977187,-0.0617632,9.5433419,18.5061841,2180.6559593,9592.8014426,0.1039226,518.3565335,228.5002455,631.824278,17.3644789,33.3721276,0.2074962,89.3855834),(10599,'Cervus_giganteus-ulna.tif',249,4,361,173.8361923,127.0907555,124.8554618,1.8,127.0850717,124.4955749,-0.0661367,9.7330211,19.1239567,2520.2485647,10523.5884347,0.1265438,550.2830083,258.9379528,676.8708451,17.8797777,34.1297803,0.1899883,91.0611496),(10600,'Cervus_giganteus-ulna.tif',249,4,362,187.0993562,127.236683,124.7058195,1.8,127.2308375,124.3308704,-0.0678608,10.3434074,19.6751357,2926.3793759,11782.3973348,0.1433813,598.8470679,282.922181,740.5093802,18.9062722,34.8974386,0.1732457,96.1742198),(10601,'Cervus_giganteus-ulna.tif',249,4,363,201.3699941,127.5251863,124.6167129,1.8,127.4086314,124.1877087,-0.0571315,10.3554891,19.9963689,3443.0227318,13102.233034,0.1094266,655.2306108,332.4828707,821.3110186,19.2525456,35.3207721,0.1711486,97.1810414),(10602,'Cervus_giganteus-ulna.tif',249,4,364,217.7222714,127.668853,124.4831335,1.8,127.442084,124.0366037,-0.0400988,10.3608334,20.5960844,4024.2705375,14770.8529772,0.0583153,717.1680143,388.411857,906.3234459,19.8719394,35.7442572,0.1691012,103.1103018),(10603,'Cervus_giganteus-ulna.tif',249,4,365,186.8777421,128.5370084,123.0451456,1.8,128.1569158,122.6993464,-0.0900295,8.7831154,19.9665564,2595.1313816,11361.6297593,0.2517691,569.0330139,295.4682083,682.8458573,17.1257196,34.216226,0.1259126,92.233305),(10604,'Cervus_giganteus-ulna.tif',249,4,366,159.1143815,130.3197878,121.9920762,1.8,129.5433331,121.6119357,-0.057601,8.677362,21.0472263,2149.1042211,7558.4193972,0.0878895,359.1171242,247.667924,456.0992862,15.9493208,33.7380338,0.1148766,90.5577388),(10605,'Cervus_giganteus-ulna.tif',249,4,367,164.4453164,130.7233671,121.7662271,1.8,130.0636226,121.4571582,-0.0564092,8.8705783,19.2728593,2385.4141451,7501.9914074,0.0871184,389.2516046,268.9130376,503.7719614,16.5741471,31.6047138,0.1226687,86.1134131),(10606,'Cervus_giganteus-ulna.tif',249,4,368,161.7121507,131.7385474,121.500956,1.8,130.9917937,121.2364844,-0.0420815,9.4308117,20.3270297,2625.5586268,6152.7039261,0.0477,302.6858338,278.4021907,426.1525953,17.5053678,31.938857,0.094314,87.8321651),(10607,'Cervus_giganteus-ulna.tif',249,4,369,182.8807438,131.2909152,120.9904929,1.8,130.5315312,120.7620261,0.0161913,9.9137992,20.8971663,3217.2059671,9316.1158436,0.0079899,445.8076136,324.5179664,596.8728093,18.6048052,33.1194415,2.7418116,94.6639874),(10608,'Cervus_giganteus-ulna.tif',249,4,370,198.9870692,131.2754098,120.6236558,1.8,130.660634,120.5621595,0.0265074,10.343852,20.4625303,3779.2201888,11108.2084687,0.0232974,542.8560541,365.3590744,725.629959,19.5493285,33.5156643,2.7468015,96.3395536),(10609,'Cervus_giganteus-ulna.tif',249,4,371,168.853596,133.0019777,119.1098436,1.8,132.4107206,118.8399042,-0.0347986,9.8065566,18.1715184,2820.8595122,6728.2081534,0.0340648,370.2611979,287.650358,515.1813791,18.4226762,29.8470826,2.7423719,85.3582969),(10610,'Cervus_giganteus-ulna.tif',249,4,372,184.3039191,132.9754159,118.7077541,1.8,132.5334886,118.5767015,-0.0370586,10.2515764,18.565844,3340.551605,8174.9581981,0.0421659,440.3224646,325.8573588,608.0806805,19.3671995,30.6407017,2.7532739,88.1881303),(10611,'Cervus_giganteus-ulna.tif',249,4,373,194.3821847,132.9907037,118.3649361,1.8,132.5737894,118.2933275,-0.0322619,10.7502021,18.6081914,3764.3431683,9462.6971535,0.0337081,508.5232053,350.1648756,699.8764154,20.1932848,30.6407017,2.7532739,90.9747779),(10612,'Cervus_giganteus-ulna.tif',249,4,374,204.7328661,133.0068242,118.1161694,1.8,132.5920153,118.0613993,-0.020062,11.0056191,18.6639145,4155.0388386,10575.9970439,0.0137318,566.6548155,377.5379471,782.4277013,20.7247655,31.0150218,0.1810927,93.1537549),(10613,'Cervus_giganteus-ulna.tif',249,4,375,215.1460985,133.0133097,117.869362,1.8,132.7094046,117.8900212,-0.0106823,11.2443931,18.270359,4615.6174708,11523.6488082,0.0040917,630.7291944,410.4816887,879.9092679,21.4175065,31.0952831,0.1946855,95.9835884),(10614,'Cervus_giganteus-ulna.tif',249,4,376,157.4421211,137.0447335,117.2961128,1.8,137.1060444,117.0243473,1.5619073,12.4004237,12.0893821,2512.799455,4388.9311537,26.2382802,363.0401542,202.638194,519.5707378,18.8241079,24.657503,2.4178447,79.9071496),(10615,'Cervus_giganteus-ulna.tif',249,4,377,164.8007606,136.994508,117.1168563,1.8,137.0833398,116.9313914,1.500951,12.4966753,13.0432041,2836.1081673,4586.2667473,27.3330179,351.6211742,226.9490173,528.6844574,19.1064163,25.8706437,2.4149503,78.5875486),(10616,'Cervus_giganteus-ulna.tif',249,4,378,143.6116342,137.761492,116.2384381,1.8,137.9593969,115.796823,1.5401223,10.8860999,11.107362,1888.9922037,3543.844812,23.9127589,319.0536888,173.5233202,446.2197312,17.1631834,22.5166354,2.410196,68.465668),(10617,'Cervus_giganteus-ulna.tif',249,4,379,150.7862573,137.731105,116.2518292,1.8,137.9225545,115.7319654,1.4889105,11.0290002,11.3723312,2087.2840557,3868.9271046,24.9629083,340.2052792,189.25415,481.4449621,17.4697129,23.4445902,2.4210385,70.7920906),(10618,'Cervus_giganteus-ulna.tif',249,4,380,154.8086565,137.6768677,116.1455645,1.8,137.8040623,115.578358,1.4354158,11.0730538,12.2128647,2300.0990872,4072.920556,25.3314385,333.4942819,207.7203922,487.5037224,17.5626101,24.657503,2.4178447,71.504021),(10619,'Cervus_giganteus-ulna.tif',249,4,381,177.4443449,135.5381921,115.2867887,1.8,135.6169787,114.6962143,0.0323264,11.0414386,15.2634748,3355.5599015,6049.742911,0.0308941,396.3542382,303.9060408,615.0643237,19.6284773,27.1010188,2.6992184,81.0614169),(10620,'Cervus_giganteus-ulna.tif',249,4,382,176.1402851,135.8846589,115.2428119,1.8,135.8832999,114.6463488,0.0332605,11.0049617,14.7216677,3624.4189395,5560.5151411,0.0324643,377.7095945,329.3440764,623.9047983,19.8302036,26.3514729,2.7217127,79.9503354),(10621,'Cervus_giganteus-ulna.tif',249,4,383,184.0123128,136.1583636,115.5421908,1.8,136.2222217,114.9555858,0.0865395,11.5365834,13.6793704,4342.129817,5486.2742544,0.2291077,401.0618989,376.3791814,715.9889757,20.3872613,25.3770694,2.6476513,79.69863),(10622,'Cervus_giganteus-ulna.tif',249,4,384,185.7113728,136.556628,115.7345531,1.8,136.6456101,115.0655152,0.4504512,12.4853769,12.6115819,4808.9511988,5174.3770624,5.8668869,410.2877111,385.1666811,711.6046639,20.5889876,25.1761971,2.6626791,82.8412428),(10623,'Cervus_giganteus-ulna.tif',249,4,385,188.523091,136.6116849,115.6885653,1.8,136.5275201,115.0641805,-0.6523591,14.2918034,13.1887879,4945.8314578,5485.7132404,11.5792529,415.937634,346.0606978,729.4962131,21.5053629,25.7955992,0.5232783,86.4261925),(10624,'Cervus_giganteus-ulna.tif',249,4,386,198.9724665,136.8145481,116.2052475,1.8,136.6782797,115.5980712,-1.2957818,13.5257557,13.4748964,5390.7299837,6189.5407273,30.7165288,459.3386521,398.5529611,734.9016723,22.7058634,27.3418009,0.5269432,88.1449445),(10625,'Cervus_giganteus-ulna.tif',249,4,387,202.5661842,136.7163693,116.3658989,1.8,136.6638392,115.6596497,-1.0165802,13.16449,13.0281096,5482.0615031,6698.9550131,24.4103252,514.1924042,416.427943,801.0614906,23.0872271,27.1928351,0.5485494,88.0406847),(10626,'Cervus_giganteus-ulna.tif',249,4,388,199.6895092,136.9157013,116.5447277,1.8,136.8456941,115.7681315,-1.0428253,12.980722,13.2778578,5429.1555203,6684.421667,24.8348524,503.4262115,418.247576,788.9617578,23.0872271,27.4193474,0.5619216,88.6483553),(10627,'Cervus_giganteus-ulna.tif',249,4,389,212.7927707,136.9570928,117.2545145,1.8,136.8363894,116.5757754,-1.2703334,13.0397421,14.2929763,6023.0482454,7431.8946749,32.358909,519.9683055,461.8993364,921.4670636,23.2031522,27.1758555,0.6055447,89.0043205),(10628,'Cervus_giganteus-ulna.tif',249,4,390,220.4678019,137.0861517,117.6151847,1.8,136.9406808,116.9635109,1.564255,14.2071024,14.4786135,6455.2176632,7823.0723097,36.7430614,540.3191601,454.365535,959.9831999,23.4785188,28.0385827,1.8343602,90.2196617),(10629,'Cervus_giganteus-ulna.tif',249,4,391,233.859033,137.10111,117.9847558,1.8,136.9684353,117.3819806,1.2914268,13.7697972,15.632201,6924.0625328,9179.3547683,36.0128143,587.2080806,502.8441923,998.3409191,23.060226,30.1180334,1.815775,91.5392627),(10630,'Cervus_giganteus-ulna.tif',249,4,392,243.7183701,136.9275095,118.0286909,1.8,136.7795001,117.3005158,1.1608334,13.2185755,15.6518076,7363.90149,9814.4701094,34.1667864,627.0502658,557.0873729,1086.3113119,23.3081065,29.9212216,1.7879076,90.9315921),(10631,'Cervus_giganteus-ulna.tif',249,4,393,252.6019002,136.8322539,117.9038728,1.8,136.6649563,117.2185278,1.168784,13.0408077,15.7855184,7543.1534397,10408.8990772,35.6550512,659.3954538,578.4268578,1117.5117356,22.9239836,30.2525988,1.7709774,90.6188127),(10632,'Cervus_giganteus-ulna.tif',249,4,394,263.2755753,136.8034159,117.8163803,1.8,136.6223205,117.2717425,1.1982685,12.997551,16.0431627,7831.9641968,11080.7208408,38.0663616,690.6818199,602.572298,1145.7757288,22.7607824,30.9405201,1.7382281,89.6551769),(10633,'Cervus_giganteus-ulna.tif',249,4,395,271.0347539,136.7339318,117.7075842,1.8,136.6169665,117.2247944,1.2174578,12.6799736,15.9730984,8088.9959209,11242.4199182,39.7635913,703.8346388,637.934762,1169.1899686,22.3574089,30.8718197,1.7245039,88.7958009),(10634,'Cervus_giganteus-ulna.tif',249,4,396,274.1175451,136.754237,117.5520068,1.8,136.669978,117.0705191,1.2657875,12.5649744,15.3199632,8108.8058394,11133.0216831,41.5662218,726.7002871,645.349971,1165.8053962,21.9450894,30.2739518,1.6845883,86.5736381),(10635,'Cervus_giganteus-ulna.tif',249,4,397,271.6998759,136.7739424,117.4241012,1.8,136.7247872,116.9947528,1.378268,12.4101461,14.6688862,7858.0062562,10717.828191,43.6254259,730.6504422,633.1920838,1143.0762213,21.8520429,29.8006521,1.6718997,85.7142621),(10636,'Cervus_giganteus-ulna.tif',249,4,398,259.4516274,136.9525453,117.2178255,1.8,136.8900928,116.9027482,1.5609862,11.9346926,14.9206978,6798.5892998,9771.0780952,43.2377764,654.867369,569.6493035,1045.0737365,21.0033693,28.9457945,1.6748963,82.6759091),(10637,'Cervus_giganteus-ulna.tif',249,4,399,239.8959327,137.2008682,116.9166054,1.8,137.0863312,116.6661583,-1.4219551,10.6521925,15.0430125,5232.5022475,8475.0586567,39.1034132,563.3883928,491.2136404,906.5907315,19.3359602,27.583828,1.648763,78.7781801),(10638,'Cervus_giganteus-ulna.tif',249,4,400,209.7601097,137.7085733,116.2784625,1.8,137.4696213,116.2195964,-1.3836066,9.5192995,14.1066067,3653.163929,6693.1865891,33.7492607,474.4717668,383.7639445,729.3866404,17.6172081,25.9098659,1.4711277,73.8125555),(10639,'Cervus_giganteus-ulna.tif',249,4,401,157.0264199,138.9430971,114.8030625,1.8,138.7118011,114.8756842,-1.5697514,8.3216113,11.6813665,2024.2283403,3766.7750172,26.1710414,322.4601341,243.2495677,477.3797586,15.4687681,22.8382307,1.4954674,64.7585704),(10640,'Cervus_giganteus-ulna.tif',249,4,402,135.0670432,139.570373,114.287822,1.8,139.4443598,114.0243152,1.4744737,7.9252719,10.5104385,1499.5999503,2685.1392366,22.3029592,255.4735681,189.2174773,378.4750146,14.4430609,20.7855326,1.6951513,58.3869731),(10641,'Cervus_giganteus-ulna.tif',249,4,403,116.38572,140.0580366,114.0646224,1.8,140.0038954,113.6672274,1.407569,7.1555562,9.3093951,1102.0099979,1971.1116213,18.8853795,211.733587,154.0075936,307.4928256,13.4956802,19.081244,1.706324,53.9858333),(10642,'Cervus_giganteus-ulna.tif',249,4,404,100.1577054,140.3805385,113.9587446,1.8,140.3230418,113.5747144,1.3567288,6.3915712,8.8830304,772.4544826,1467.3443169,15.9396117,165.1851052,120.8551787,240.8395456,12.3139977,18.0928756,1.6421038,50.1923641),(10643,'Cervus_giganteus-ulna.tif',249,4,405,84.1913645,140.6179717,113.8702892,1.8,140.6382924,113.4992685,1.3722099,5.668178,8.1511589,509.0306293,1077.6045757,13.4857605,132.2026208,89.8049837,185.966438,11.002162,16.4688823,1.7016237,45.6869645),(10644,'Cervus_giganteus-ulna.tif',249,4,406,67.6701212,140.7837522,113.7640711,1.8,140.8307776,113.4632859,1.4351329,5.0865735,7.3658588,318.8767038,745.445562,11.0720508,101.202803,62.6898842,135.4521869,9.7961417,15.1917651,1.7126934,41.53753),(10645,'Cervus_giganteus-ulna.tif',249,4,407,50.3389038,140.8822358,113.5927709,1.8,141.0266275,113.4483084,1.5247668,4.3089053,6.5711452,184.074878,441.7712822,8.3720542,67.228964,42.7196385,91.5683002,8.5937601,13.5675305,1.7619808,36.2770142),(10646,'Cervus_giganteus-ulna.tif',249,4,408,30.3120065,140.8876717,113.3959148,1.8,140.9986859,113.3651708,-1.5120752,3.4800926,5.6132557,70.7541219,179.6374582,5.0346009,32.0023652,20.3311031,43.2845616,6.8750081,11.6729711,1.6814535,30.6605332),(10647,'Cervus_giganteus-ulna.tif',249,4,409,5.2481863,140.9130436,112.871773,1.8,140.9152188,112.9662588,-1.5324249,2.1499987,3.5865846,4.5270577,12.7628408,0.8734105,3.5584943,2.1056095,4.7994997,4.29688,7.5041784,1.3397057,18.9241603),(10648,'Cervus_giganteus-ulna.tif',249,4,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10649,'Cervus_giganteus-ulna.tif',249,4,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10650,'Cervus_giganteus-ulna.tif',249,4,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10651,'Cervus_giganteus-ulna.tif',249,4,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10652,'Cervus_giganteus-ulna.tif',249,4,414,168.414564,92.1183937,125.3126282,1.8,92.2149242,125.967279,0.8666209,9.8227116,26.9256774,952.1066742,21508.5556868,16.3043832,798.8120536,96.9291076,819.8905712,34.9168223,56.7220716,2.4420048,219.208094),(10653,'Cervus_giganteus-ulna.tif',249,4,415,64.9632514,96.8180959,130.3290241,1.8,94.2020672,127.6494633,0.9103761,5.2719246,20.5778721,164.8245611,10302.0332624,6.7527205,500.6364698,31.2645898,507.9759244,8.8401154,22.7775175,2.1954317,57.6497451),(10654,'Cervus_giganteus-ulna.tif',249,4,416,35.5520802,103.877474,139.3198731,1.8,103.6128375,138.8845579,1.0103423,4.9685566,8.3216825,99.6819705,127.5689529,4.2510359,15.3297069,20.0625609,26.7216552,7.9737258,14.0948145,2.485897,41.3468986),(10655,'Cervus_giganteus-ulna.tif',249,4,417,35.6306326,103.982329,139.4200418,1.8,103.9009464,138.9995932,0.9508459,5.6141585,7.1052663,103.2488699,115.1921076,3.9338894,16.2122154,18.3908005,30.5814013,7.2920472,12.8188254,2.4511462,38.8119564),(10656,'Cervus_giganteus-ulna.tif',249,4,418,35.5406106,104.0516877,139.5343567,1.8,104.1888803,139.4570923,0.7150018,4.0021005,5.6702932,102.2057437,107.0430481,2.5461054,18.8778683,25.5380254,36.1222821,7.8997178,10.6125108,2.7686049,34.8710416),(10657,'Cervus_giganteus-ulna.tif',249,4,419,35.3109399,104.0921846,139.6031097,1.8,104.2224779,139.6205062,0.7367977,4.0540577,5.5117672,99.818736,105.6118595,2.6570072,19.161161,24.6219327,37.1109171,7.2920472,10.2135672,2.7532739,29.8622311),(10658,'Cervus_giganteus-ulna.tif',249,4,420,35.0477557,104.1407222,139.6685489,1.8,104.268673,139.7324845,1.0044538,4.4270682,5.0071378,98.6237189,102.7645055,4.1596716,20.5236026,22.2774336,39.8276821,7.4892533,10.0679118,2.4468544,33.5514406),(10659,'Cervus_giganteus-ulna.tif',249,4,421,35.0630857,104.1979041,139.7341449,1.8,104.2709555,139.8401488,1.0669633,4.4471426,4.4919887,98.6002504,103.1265573,4.481751,22.9578842,22.1715963,42.1659889,7.2920472,10.0219603,2.6011732,30.5130876),(10660,'Cervus_giganteus-ulna.tif',249,4,422,35.2730065,104.2559446,139.7839301,1.8,104.2839251,139.8414532,1.1420156,4.4223101,4.7103566,99.2788322,105.0708609,4.8626294,22.3063494,22.449541,41.7556025,7.4741268,9.817219,1.9756881,33.403995),(10661,'Cervus_giganteus-ulna.tif',249,4,423,35.3683436,104.3277909,139.8584353,1.8,104.4492956,139.9194551,1.0744778,4.4523744,5.067346,99.6154323,106.0117922,4.5580463,20.9205751,22.3735522,40.1128759,7.4377484,10.0587383,1.9195673,37.9525804),(10662,'Cervus_giganteus-ulna.tif',249,4,424,35.5658437,104.3950914,139.9552553,1.8,104.5488632,140.1344051,1.0502152,4.2544175,5.3399466,99.9767398,109.2702579,4.4611942,20.4627997,23.4995131,39.0602289,7.5958825,10.3482575,2.2974387,31.624169),(10663,'Cervus_giganteus-ulna.tif',249,4,425,35.6542991,104.4631578,140.0374136,1.8,104.686902,140.2875837,1.0258895,3.7787397,5.3879597,99.978769,110.3403583,4.3458153,20.4790616,26.4582311,38.9712851,7.5958825,10.4016452,2.2390857,33.5514406),(10664,'Cervus_giganteus-ulna.tif',249,4,426,35.5378132,104.5115101,140.0918012,1.8,104.6487092,140.2734528,1.1333066,4.3056311,5.3202053,99.3996303,108.407124,4.8598332,20.3764925,23.0859606,39.0167251,7.4741268,10.0679118,2.2655346,33.4471808),(10665,'Cervus_giganteus-ulna.tif',249,4,427,35.3407048,104.5776878,140.148813,1.8,104.6555634,140.1758677,1.1498531,4.2460696,5.0196594,98.4963752,106.1156088,4.9066354,21.1400018,23.1970703,40.1646465,6.8750081,10.1864155,2.0533096,36.0253088),(10666,'Cervus_giganteus-ulna.tif',249,4,428,35.2178967,104.6527842,140.2218753,1.8,104.7373242,140.3018667,1.1671858,3.5045303,4.9071583,97.5744172,105.3462695,4.9642811,21.4678767,27.8423663,40.650524,7.171309,10.0219603,2.1112158,36.1295686),(10667,'Cervus_giganteus-ulna.tif',249,4,429,35.2240511,104.723586,140.3109588,1.8,104.8456125,140.4940601,1.1126973,3.6579214,5.4139386,97.6881574,105.9875992,4.7224904,19.576801,26.7059204,37.1982437,6.8750081,9.6560369,2.1341126,26.5110988),(10668,'Cervus_giganteus-ulna.tif',249,4,430,35.428265,104.786237,140.385444,1.8,104.8835364,140.489798,1.2721312,3.9051574,5.4099916,99.1034495,107.8949797,5.3934812,19.9436502,25.3775816,37.5054806,6.8750081,9.6942032,1.7942729,34.202297),(10669,'Cervus_giganteus-ulna.tif',249,4,431,35.2982395,104.8483325,140.4667587,1.8,104.9624668,140.6145398,1.1970217,3.636064,5.2214341,97.8489993,105.9666257,5.0987048,20.2945442,26.9106921,38.9879191,7.2920472,10.3838798,1.9974238,31.225018),(10670,'Cervus_giganteus-ulna.tif',249,4,432,35.2149873,104.8906482,140.513257,1.8,105.0255296,140.572605,1.2068369,3.5910877,5.0645401,97.8141352,104.2860202,5.1254261,20.5914096,27.2380245,38.7612016,7.3046961,10.2496577,2.1471715,36.4855338),(10671,'Cervus_giganteus-ulna.tif',249,4,433,35.1410227,104.9296559,140.5690231,1.8,105.0949663,140.7007179,1.176947,4.0408725,5.0328514,98.4395413,102.7020418,4.9943543,20.4063332,24.3609619,39.0875293,7.3046961,9.2955728,2.1587989,31.1207582),(10672,'Cervus_giganteus-ulna.tif',249,4,434,35.2236594,104.9780543,140.6428016,1.8,105.0724669,140.7606337,1.2100123,3.949691,5.3105444,98.1152789,105.278584,5.1390465,19.8244429,24.8412545,37.5486078,6.8750081,10.6125108,2.1251038,38.8119564),(10673,'Cervus_giganteus-ulna.tif',249,4,435,35.1146707,105.0282572,140.7080841,1.8,105.1462459,140.7431562,1.2443813,3.8407464,5.0550071,97.5388791,104.3252498,5.2507199,20.6380025,25.3958133,39.4232353,6.8750081,10.3927663,2.0899424,36.2338284),(10674,'Cervus_giganteus-ulna.tif',249,4,436,35.193335,105.0799412,140.7859893,1.8,105.1593184,140.8472943,1.2614115,4.0518473,5.2120931,97.813291,106.2894906,5.3217973,20.3928611,24.1404188,37.2398001,6.8750081,10.8448349,2.1587989,37.24065),(10675,'Cervus_giganteus-ulna.tif',249,4,437,35.4472877,105.1233453,140.8574312,1.8,105.1303315,140.9854083,1.2962206,4.5315342,5.3665,99.4162819,109.2705258,5.4735567,20.3615999,21.9387688,37.7567881,6.8750081,10.7679505,2.070143,34.0548514),(10676,'Cervus_giganteus-ulna.tif',249,4,438,35.3682876,105.1737633,140.9195791,1.8,105.2451379,141.0078865,1.2598736,4.1034052,5.4678906,98.4771959,107.3037376,5.3429835,19.6243387,23.9988964,36.2815908,6.8750081,10.8448349,2.1587989,37.3449098),(10677,'Cervus_giganteus-ulna.tif',249,4,439,35.2121899,105.2197449,140.9739485,1.8,105.349186,140.9823527,1.2963976,3.4801305,4.9308056,97.4137009,105.5499012,5.4377962,21.4062185,27.9913933,38.6851638,7.1226669,10.0219603,2.1112158,33.4471808),(10678,'Cervus_giganteus-ulna.tif',249,4,440,35.3102126,105.2441656,141.0358158,1.8,105.3625197,141.0736211,1.2887511,3.7901491,4.9320859,97.9278705,106.3015293,5.4291665,21.5530573,25.8374718,41.2788825,7.3995682,9.994288,2.0152155,35.3744524),(10679,'Cervus_giganteus-ulna.tif',249,4,441,35.1376098,105.2677918,141.1012196,1.8,105.2838323,141.0814651,1.3039444,4.2869062,4.7429519,97.4814063,104.4680982,5.4490491,22.0259663,22.7393376,39.9968736,7.3041269,9.817219,1.9756881,36.1295686),(10680,'Cervus_giganteus-ulna.tif',249,4,442,35.0047868,105.3198458,141.1823021,1.8,105.4033442,141.1832012,1.2808432,3.8462241,4.7730137,97.1615645,102.9581185,5.3572318,21.5708827,25.2615457,41.8326854,7.3046961,9.6942032,1.7942729,31.9801342),(10681,'Cervus_giganteus-ulna.tif',249,4,443,35.0371813,105.3660678,141.2511488,1.8,105.4539237,141.2400382,1.2523045,3.5528917,4.8393565,96.8501755,103.5532789,5.266945,21.3981504,27.2595347,40.8726845,7.3046961,9.798394,1.8370484,36.381274),(10682,'Cervus_giganteus-ulna.tif',249,4,444,35.1408549,105.4171197,141.3103672,1.8,105.5084106,141.344738,1.2574724,3.5362312,5.0361733,97.5363645,104.4499528,5.3004062,20.7399441,27.5820099,40.1066428,7.4741268,9.6081159,1.7506498,36.2338284),(10683,'Cervus_giganteus-ulna.tif',249,4,445,35.1059427,105.4931707,141.3811136,1.8,105.6757488,141.4945408,1.2410708,3.4664906,5.3508731,97.4559493,104.6532235,5.237598,19.5581585,28.1137211,37.7311814,7.4377484,10.0311674,1.7429871,36.2338284),(10684,'Cervus_giganteus-ulna.tif',249,4,446,35.9747751,105.6062157,141.5047428,1.8,105.9897075,141.9501973,1.1339768,4.2411685,5.8869142,100.0090422,122.9663839,4.9226709,20.8880882,23.5805396,37.7820763,7.6817123,10.6298941,1.815775,34.0548514),(10685,'Cervus_giganteus-ulna.tif',249,4,447,36.533538,105.7356838,141.5363109,1.8,106.216915,141.8376306,1.1811796,4.2881779,5.9779492,106.8444981,122.8293584,5.2104512,20.5470729,24.9160599,38.0327502,8.1640721,10.9549376,1.7681919,35.521898),(10686,'Cervus_giganteus-ulna.tif',249,4,448,36.4938701,105.9628858,141.2351984,1.8,106.6829375,140.5045397,-0.8513204,4.0161674,8.298471,88.9719557,181.8732424,3.4409546,21.9164762,22.1534478,32.5017735,7.5936962,14.6975911,0.9097532,39.879852),(10687,'Cervus_giganteus-ulna.tif',249,4,449,1.4618361,105.5752042,139.9646014,1.8,105.5438485,140.0089846,1.0402349,1.2763637,2.4507898,0.5884327,1.8733063,0.1812545,0.7643684,0.4610228,0.9973651,3.0763405,5.3839753,2.070143,13.0559739),(10688,'Cervus_giganteus-ulna.tif',249,4,450,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10689,'Cervus_giganteus-ulna.tif',249,4,451,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10690,'Cervus_giganteus-ulna.tif',249,4,452,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10691,'Cervus_giganteus-ulna.tif',249,4,453,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10692,'Cervus_giganteus-ulna.tif',249,4,454,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10693,'Cervus_giganteus-ulna.tif',249,4,455,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10694,'Cervus_giganteus-ulna.tif',249,4,456,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10695,'Cervus_giganteus-ulna.tif',249,4,457,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10696,'Cervus_giganteus-ulna.tif',249,4,458,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10697,'Cervus_giganteus-ulna.tif',249,4,459,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10698,'Cervus_giganteus-ulna.tif',249,4,460,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10699,'Cervus_giganteus-ulna.tif',249,4,461,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10700,'Cervus_giganteus-ulna.tif',249,4,462,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10701,'Cervus_giganteus-ulna.tif',249,4,463,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10702,'Cervus_giganteus-ulna.tif',249,4,464,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10703,'Cervus_giganteus-metacarpals.tif',249,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10704,'Cervus_giganteus-metacarpals.tif',249,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10705,'Cervus_giganteus-metacarpals.tif',249,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10706,'Cervus_giganteus-metacarpals.tif',249,5,4,0.3694314,85.7294262,110.8883321,1.8,85.722756,110.859504,1.2528794,0.7492246,0.9129377,0.0708309,0.0800789,0.0555556,0.0877156,0.094539,0.164855,1.718752,2.3139407,1.9513027,5.7207408),(10707,'Cervus_giganteus-metacarpals.tif',249,5,5,11.9189883,86.4473811,111.2882783,1.8,86.7894376,111.3897038,-0.3147908,3.5107376,4.398956,15.9140904,24.7548356,0.1904317,5.6274342,4.5329764,8.878038,6.2375304,8.0731046,0.4398426,22.4659239),(10708,'Cervus_giganteus-metacarpals.tif',249,5,6,60.7129709,90.0611433,111.8703701,1.8,94.6176572,113.0948405,0.2821142,8.352042,43.5834616,619.0128543,4732.6815562,0.7842018,108.5889321,74.1151507,122.0967085,10.9632809,17.1552631,0.3851575,46.4599685),(10709,'Cervus_giganteus-metacarpals.tif',249,5,7,190.5018929,99.9224877,115.4318283,1.8,101.3129676,116.1439248,0.3407618,11.2214017,34.8249213,3222.6783474,59655.8331759,3.546291,1713.0213343,287.1903569,1795.0645226,16.3368832,23.6991533,0.390607,66.8511752),(10710,'Cervus_giganteus-metacarpals.tif',249,5,8,567.5390609,99.6488026,119.2858112,1.8,96.0226808,122.2632549,0.06365,26.9219332,33.3774873,46622.9917552,175235.2758437,0.3826966,5250.1038909,1731.7846908,5612.0263658,23.9039717,60.3095848,0.7148086,159.231925),(10711,'Cervus_giganteus-metacarpals.tif',249,5,9,1449.2569535,97.4468412,123.7615954,1.8,98.2272833,125.5441419,-0.2086168,23.2114645,33.8472839,158972.0137271,485665.3377101,10.3605592,14348.7240982,6848.8575471,17189.9012806,43.7415352,67.9939681,0.3617292,263.999904),(10712,'Cervus_giganteus-metacarpals.tif',249,5,10,1740.5231496,98.8045381,125.278921,1.8,98.5394067,126.115209,-0.2302022,22.8123734,35.9591124,222882.124415,575306.6696893,15.1029711,15998.9118452,9770.229527,20631.0976784,45.2921111,69.2011157,0.355137,252.6805704),(10713,'Cervus_giganteus-metacarpals.tif',249,5,11,1754.5030202,99.0646127,125.6142505,1.8,98.6755073,126.6645467,-0.2487499,23.5793828,37.0146209,245754.4713672,593613.8494467,17.7236297,16037.2802646,10422.4301896,21695.0504856,47.0696764,70.2970093,0.2850166,202.5313925),(10714,'Cervus_giganteus-metacarpals.tif',249,5,12,1716.2905086,99.1495567,125.698189,1.8,98.5304199,126.8834612,-0.2727332,24.3355962,37.866123,257843.1702134,593823.5677044,20.7549035,15682.1855779,10595.3093699,21916.9618296,48.3772949,71.1805116,0.2376581,200.8558264),(10715,'Cervus_giganteus-metacarpals.tif',249,5,13,1687.9908211,99.0591359,125.6581691,1.8,98.2861912,126.9489179,-0.296323,24.9201968,38.2212924,265035.0903517,593370.6009463,23.988369,15524.6084894,10635.3530086,22002.7023204,49.2007207,71.5981934,0.2362453,202.1754273),(10716,'Cervus_giganteus-metacarpals.tif',249,5,14,1648.9738744,98.9778663,125.4579738,1.8,98.2034206,126.8350818,-0.3075816,25.5917347,38.3907135,268055.0969843,582064.2222041,25.1909309,15161.589087,10474.2839826,21730.5472029,50.088804,71.4988437,0.2304024,202.8873577),(10717,'Cervus_giganteus-metacarpals.tif',249,5,15,1623.0155417,98.8859273,125.396851,1.8,98.164783,126.7536266,-0.3133302,26.0974634,38.4849353,270802.3976614,567234.8343868,25.6990227,14739.1396015,10376.5792648,21490.2254727,50.5436923,71.1260198,0.2068739,202.7399121),(10718,'Cervus_giganteus-metacarpals.tif',249,5,16,1590.0310187,98.7041416,125.3781932,1.8,98.0157403,126.7322978,-0.3209584,26.4823478,38.4971113,269069.4728031,552542.3327796,26.3746905,14352.8258273,10160.3330056,21180.3302682,50.9158131,70.8724735,0.1890723,204.6239979),(10719,'Cervus_giganteus-metacarpals.tif',249,5,17,1485.3337231,98.8560031,125.1141172,1.8,98.306788,126.4903932,-0.3256031,26.4347297,38.7459704,259583.5969234,509935.3102813,25.3307208,13160.9895213,9819.793889,19723.6403243,50.5610449,70.2851893,0.2093854,203.3043969),(10720,'Cervus_giganteus-metacarpals.tif',249,5,18,1434.9299193,98.8451787,124.9594995,1.8,98.510061,126.220945,-0.3220321,26.2964412,38.6322324,251217.2912098,485045.4988545,23.955912,12555.461309,9553.2809504,18935.4145997,50.2520846,69.6518814,0.1610919,202.4450209),(10721,'Cervus_giganteus-metacarpals.tif',249,5,19,1379.3052323,98.8258145,124.9385312,1.8,98.534885,126.1369275,-0.3032592,25.9624011,38.2487075,238471.0018208,454729.1982199,20.5013573,11888.7467766,9185.2444837,17925.8022001,49.760686,68.8587589,0.125129,200.7262689),(10722,'Cervus_giganteus-metacarpals.tif',249,5,20,1327.2851171,98.713405,125.0442822,1.8,98.5059217,126.1086388,-0.2774259,25.4597602,37.7163707,224132.404537,424933.4262633,16.5934433,11266.5513195,8803.3980919,17010.2152843,48.7539358,67.7559528,0.1463813,199.5541135),(10723,'Cervus_giganteus-metacarpals.tif',249,5,21,1266.3072836,98.4443049,125.3276687,1.8,98.251625,126.3107337,-0.2588144,24.9381102,36.8541384,206486.057948,394388.3990332,13.8243858,10701.3327812,8279.9400638,16064.3981988,47.4631937,66.7843533,0.1355277,196.0123497),(10724,'Cervus_giganteus-metacarpals.tif',249,5,22,1218.2075165,98.2505748,125.6702302,1.8,97.9451324,126.659277,-0.234489,24.1294322,36.0204308,193577.4410267,370674.3941188,10.9607555,10290.6707529,8022.4615133,15451.3525107,46.2139974,65.7197928,0.1113792,189.3279732),(10725,'Cervus_giganteus-metacarpals.tif',249,5,23,1180.5397805,98.1372601,125.9736233,1.8,97.7548273,126.9484892,-0.2070429,23.7651904,35.0902941,183977.7960244,350929.553227,8.3144894,10000.7584043,7741.4821103,14972.1758759,45.1742765,64.347123,0.1003331,184.8225736),(10726,'Cervus_giganteus-metacarpals.tif',249,5,24,1135.5249307,98.1025475,126.057588,1.8,97.6471656,127.0700835,-0.186534,23.4568705,34.3194363,174479.7365858,328713.1282254,6.5090605,9578.0456708,7438.3211757,14336.5984123,44.7298543,63.0646741,0.1023805,182.6004108),(10727,'Cervus_giganteus-metacarpals.tif',249,5,25,1084.9592104,98.0689425,126.0476207,1.8,97.5933552,127.0827785,-0.1711746,23.4950701,33.251016,165042.226021,308205.5208696,5.2468072,9269.0557373,7024.5470743,13821.1473228,44.257864,61.5039499,0.1260881,182.9131901),(10728,'Cervus_giganteus-metacarpals.tif',249,5,26,1045.2244377,98.0288621,125.9444371,1.8,97.563578,127.0003359,-0.1582294,23.242078,32.7019661,155575.9887989,292375.9618564,4.3251902,8940.6233552,6693.7211465,13229.5880094,43.6790181,60.5387544,0.1639818,184.2327911),(10729,'Cervus_giganteus-metacarpals.tif',249,5,27,1014.4888417,97.9330335,125.9070164,1.8,97.481563,126.8535253,-0.152861,22.802448,32.0127985,147492.6552313,279334.667179,3.9201633,8725.7184779,6468.2816227,12849.6800733,43.3519924,59.5594689,0.0939257,191.8197295),(10730,'Cervus_giganteus-metacarpals.tif',249,5,28,1002.8526198,97.7856208,125.9718588,1.8,97.3837653,126.6928677,-0.152545,22.2667819,31.4301219,143342.1062825,268030.1024129,3.8593183,8527.8098304,6437.4864388,12593.4584725,43.060906,58.7055087,0.1543188,179.979097),(10731,'Cervus_giganteus-metacarpals.tif',249,5,29,983.2564183,97.6158593,125.9049449,1.8,97.2635798,126.5272878,-0.1563638,22.1388978,30.8775857,138952.483634,258151.0264229,3.9741624,8360.4666719,6276.3957409,12345.7865166,42.8730998,57.9250662,0.1639292,174.9702866),(10732,'Cervus_giganteus-metacarpals.tif',249,5,30,956.9696089,97.5079208,125.8472511,1.8,97.146818,126.5148614,-0.1537581,21.6280244,30.4006714,135243.3016885,248197.3650261,3.7410856,8164.2067011,6253.1509703,12088.9752837,42.2972593,57.1501193,0.1738011,172.7913096),(10733,'Cervus_giganteus-metacarpals.tif',249,5,31,939.7304839,97.4610687,125.8419385,1.8,97.1747938,126.6021936,-0.1478707,22.032404,30.1153008,132988.8740434,240816.5036827,3.399765,7996.4834218,6036.0582659,11941.7321064,43.1115466,56.6569332,0.1140073,182.7046706),(10734,'Cervus_giganteus-metacarpals.tif',249,5,32,924.5376385,97.3821006,125.8509328,1.8,97.2042143,126.6626285,-0.1483296,22.3544044,29.7412519,130857.8354419,234205.7725964,3.365439,7874.7785399,5853.783129,11751.3062161,43.828176,56.1594161,0.1613751,194.4410433),(10735,'Cervus_giganteus-metacarpals.tif',249,5,33,914.1702845,97.2427945,125.8755582,1.8,97.0954471,126.607373,-0.1507787,22.071869,29.4262008,128913.655133,227009.9348256,3.4376535,7714.5512673,5840.6315709,11598.1185847,43.6115262,55.5412256,0.1397089,187.4617756),(10736,'Cervus_giganteus-metacarpals.tif',249,5,34,913.3211461,97.1614468,125.9609321,1.8,97.0861394,126.6295119,-0.152403,22.0124942,29.1149172,128750.3129802,223711.6772927,3.5082806,7683.7476743,5848.9652132,11601.6064572,43.381592,55.1375267,0.2279671,185.4913181),(10737,'Cervus_giganteus-metacarpals.tif',249,5,35,910.3590929,97.0381104,126.0489723,1.8,96.9720149,126.7107017,-0.1580459,22.2780948,28.8214636,127963.7715626,219503.203903,3.7584507,7615.9631207,5743.9279619,11631.8318664,43.6265244,54.6312427,0.1341108,187.9651864),(10738,'Cervus_giganteus-metacarpals.tif',249,5,36,907.8498352,96.923707,126.0702745,1.8,96.8392971,126.7353931,-0.1606582,22.1560123,28.5847103,126590.4297008,215765.8019148,3.8719433,7548.2941528,5713.5926886,11503.2563562,43.6340235,54.3279265,0.1508454,186.2464344),(10739,'Cervus_giganteus-metacarpals.tif',249,5,37,903.5074636,96.8377963,126.1040208,1.8,96.7945054,126.7819738,-0.1662082,22.1708699,28.3858575,124891.291206,212170.4053396,4.1217609,7474.5110421,5633.1254397,11439.7878784,43.6490217,54.0194895,0.2083156,184.8836476),(10740,'Cervus_giganteus-metacarpals.tif',249,5,38,906.4191627,96.8170389,126.1495838,1.8,96.670659,126.8601951,-0.1672428,22.278795,28.2222134,124073.790325,209986.0090817,4.1861966,7440.4514772,5569.1427785,11418.9699385,43.6490217,53.7676889,0.184857,180.4393219),(10741,'Cervus_giganteus-metacarpals.tif',249,5,39,910.9783927,96.8071629,126.2089309,1.8,96.6394756,126.9467786,-0.1645146,22.2730749,27.9743145,123687.9407524,208429.0187731,4.0723426,7450.7283744,5553.249451,11448.6597983,43.2418964,53.3540321,0.1373413,180.9427327),(10742,'Cervus_giganteus-metacarpals.tif',249,5,40,911.2635648,96.7811762,126.2300783,1.8,96.5879822,126.9182797,-0.1622598,22.2394402,27.8568079,122538.4232928,205878.0616292,3.9636935,7390.5833918,5509.9598841,11340.7532627,43.2343973,53.0955988,0.4165809,181.1944381),(10743,'Cervus_giganteus-metacarpals.tif',249,5,41,914.221254,96.7861027,126.2700998,1.8,96.5476393,126.976902,-0.1620587,22.1282932,27.784414,121963.4189561,204018.9549249,3.9667917,7342.9281242,5511.650529,11334.9101503,43.2418964,52.8446367,0.1798535,183.7725661),(10744,'Cervus_giganteus-metacarpals.tif',249,5,42,920.9895193,96.836817,126.3249199,1.8,96.6335886,127.0175469,-0.1578405,22.1033278,27.6617138,121975.6809317,202981.9348877,3.7925441,7338.0100919,5518.4306245,11361.1306803,43.2418964,52.5028803,0.1395822,183.2691553),(10745,'Cervus_giganteus-metacarpals.tif',249,5,43,928.7157997,96.887909,126.3881232,1.8,96.6476363,127.1319455,-0.157123,22.094661,27.4752583,122164.5242885,201866.6078886,3.7899589,7347.2141968,5529.1422799,11322.99153,43.057137,52.190733,0.3973244,176.541593),(10746,'Cervus_giganteus-metacarpals.tif',249,5,44,934.8094876,96.9374931,126.4319888,1.8,96.6821958,127.1953745,-0.1518202,22.1308519,27.2834124,122233.3916181,200168.754563,3.5636243,7336.6465946,5523.2122074,11263.2989225,43.2343973,52.0259729,0.3897086,182.7657445),(10747,'Cervus_giganteus-metacarpals.tif',249,5,45,945.349836,96.9204726,126.4949251,1.8,96.6906842,127.2730474,-0.1471557,22.2650948,27.1183205,122792.9909074,200160.9508602,3.3873386,7381.0231301,5515.0445965,11374.3367331,42.9688,51.705591,0.3743336,185.4913181),(10748,'Cervus_giganteus-metacarpals.tif',249,5,46,957.3949334,96.7745049,126.6105508,1.8,96.6733277,127.3885886,-0.1587146,22.2620888,26.9833857,123521.8807284,201784.2186698,3.985879,7478.0911747,5548.5305834,11531.462375,42.9688,51.569721,0.4114562,176.7932984),(10749,'Cervus_giganteus-metacarpals.tif',249,5,47,969.520989,96.6114356,126.7530029,1.8,96.6324905,127.5010435,-0.1686679,22.2241199,26.8006893,124378.6135443,203467.4209859,4.5535346,7591.8726967,5596.55968,11708.8253805,42.7897766,51.3993784,0.4037941,175.3694376),(10750,'Cervus_giganteus-metacarpals.tif',249,5,48,975.6759411,96.5212758,126.8605072,1.8,96.5999011,127.6589861,-0.1749299,22.1319947,26.6603054,125044.8699308,203155.6743761,4.9254723,7620.1555509,5649.9593243,11851.8842774,42.1682927,51.0678358,0.3883187,171.8276738),(10751,'Cervus_giganteus-metacarpals.tif',249,5,49,977.4527702,96.5234575,126.8596796,1.8,96.5895774,127.6623878,-0.176837,22.075441,26.477951,125065.5869888,200420.1304615,5.0414956,7569.3217573,5665.3720848,11823.8763628,42.3252213,50.7832321,0.4182243,167.6782394),(10752,'Cervus_giganteus-metacarpals.tif',249,5,50,984.2530943,96.5330301,126.9492225,1.8,96.5317216,127.6171542,-0.1772704,21.7499172,26.399009,126029.9080981,199662.2119084,5.1012175,7563.2464781,5794.5005819,11937.7583398,42.0248716,50.5079921,0.3836659,160.950677),(10753,'Cervus_giganteus-metacarpals.tif',249,5,51,991.9682408,96.5205745,127.0468563,1.8,96.5128989,127.6778639,-0.1843207,22.0111142,26.2590918,126928.6950027,198901.1437202,5.5535529,7574.5629505,5766.5729048,11975.6930869,42.2165724,50.3468934,0.4598308,159.69215),(10754,'Cervus_giganteus-metacarpals.tif',249,5,52,997.0007435,96.4962776,127.1534398,1.8,96.4716398,127.7402932,-0.193228,22.0153547,26.0998216,127787.8566851,197966.2202962,6.127349,7584.9645126,5804.4877537,12071.474158,42.0881177,50.0452801,0.521276,158.7285142),(10755,'Cervus_giganteus-metacarpals.tif',249,5,53,996.8306026,96.486047,127.2478381,1.8,96.4908288,127.8779921,-0.1980387,22.2327723,26.0942637,128044.7182301,196064.3073471,6.4310999,7513.6938099,5759.2780737,12035.2640463,42.2047127,49.8900891,0.3517143,158.1208436),(10756,'Cervus_giganteus-metacarpals.tif',249,5,54,1000.8430987,96.4535874,127.3464771,1.8,96.4395088,127.9754594,-0.205038,22.3041996,26.0000162,128714.676281,195203.4144645,6.9149465,7507.8189574,5770.8717841,12075.8061913,42.3881687,49.7733783,0.4752301,159.69215),(10757,'Cervus_giganteus-metacarpals.tif',249,5,55,1005.9534265,96.444194,127.4528746,1.8,96.4127805,128.098961,-0.2115346,22.2728359,25.8254603,129566.2561752,194131.1572954,7.3909809,7517.045385,5817.2321205,12175.3440994,42.4038213,49.4589367,0.5180685,158.1208436),(10758,'Cervus_giganteus-metacarpals.tif',249,5,56,1010.7615178,96.4159919,127.5664485,1.8,96.3809228,128.2088414,-0.2209772,22.5946265,25.6798673,130297.7298412,193181.6299118,8.0930443,7522.6880027,5766.7574078,12182.912428,42.6633276,49.374872,0.5493745,158.4768088),(10759,'Cervus_giganteus-metacarpals.tif',249,5,57,1013.7900943,96.389913,127.6753058,1.8,96.3666102,128.2977549,-0.2283696,22.6663247,25.6715043,130874.0562138,192102.936361,8.6598488,7483.1195796,5773.9425208,12199.4744409,42.7828192,49.2475687,0.5104883,158.832774),(10760,'Cervus_giganteus-metacarpals.tif',249,5,58,1017.2100344,96.3640664,127.7635611,1.8,96.3202409,128.4211438,-0.2369774,22.7767575,25.5706896,131441.6918979,190849.1114143,9.3439033,7463.5887448,5770.8693569,12204.2128402,42.7944244,49.1518749,0.5419187,158.832774),(10761,'Cervus_giganteus-metacarpals.tif',249,5,59,1018.9316977,96.3420289,127.8482267,1.8,96.2755944,128.4966573,-0.2473816,22.9115034,25.4754064,131755.9490938,189387.1468115,10.182424,7434.1168123,5750.6461554,12189.0288775,42.9572897,49.0108092,0.4832529,158.832774),(10762,'Cervus_giganteus-metacarpals.tif',249,5,60,1021.0853435,96.3441431,127.937777,1.8,96.2704856,128.5749569,-0.2522626,22.9760763,25.482801,132260.5705989,188095.3509309,10.601923,7381.2667265,5756.4472193,12178.8141797,42.7232746,48.9316348,0.5343955,159.0844794),(10763,'Cervus_giganteus-metacarpals.tif',249,5,61,1025.7238532,96.3558293,128.0269685,1.8,96.2964264,128.6382171,-0.2537468,22.9008982,25.3875634,133162.3350789,187416.7019772,10.7730614,7382.2248637,5814.7210678,12202.9709627,42.7232746,48.8334315,0.4951333,158.8759598),(10764,'Cervus_giganteus-metacarpals.tif',249,5,62,1027.0670774,96.3712888,128.1025629,1.8,96.2573543,128.6796152,-0.2553929,22.8394383,25.1774075,133619.9267183,185858.8973641,10.9245164,7381.9712253,5850.4033551,12245.7936449,42.8165321,48.7293473,0.9167136,159.7353358),(10765,'Cervus_giganteus-metacarpals.tif',249,5,63,1030.7772809,96.3706414,128.1906812,1.8,96.2456155,128.7422468,-0.2589149,22.7875804,25.0644903,134354.8202928,184828.2493583,11.261628,7374.1076393,5895.9669271,12275.9953606,42.9660002,48.7293473,0.9167136,159.3793706),(10766,'Cervus_giganteus-metacarpals.tif',249,5,64,1032.5882389,96.3629832,128.261115,1.8,96.2742405,128.880493,-0.264454,22.8511125,24.9893754,134762.7395741,183707.0680283,11.7578594,7351.4069438,5897.4257542,12178.1478477,43.0584285,48.9203138,0.8974271,160.6989716),(10767,'Cervus_giganteus-metacarpals.tif',249,5,65,1029.1459752,96.4098782,128.2411686,1.8,96.3103652,128.8919865,-0.2705579,22.8363109,24.8939157,134089.4606815,180897.3515114,12.2524594,7266.7294998,5871.7654236,12024.0371977,42.8453682,48.9203138,0.8974271,159.8827814),(10768,'Cervus_giganteus-metacarpals.tif',249,5,66,1029.6899676,96.3922576,128.2635146,1.8,96.2793556,128.7728784,-0.270208,23.0009927,24.8684612,134010.9869775,179939.7803859,12.2280169,7235.6620402,5826.3131934,11971.186486,42.8892492,48.9203138,0.8974271,160.2387466),(10769,'Cervus_giganteus-metacarpals.tif',249,5,67,1031.443354,96.3723821,128.3086588,1.8,96.2254484,128.8559299,-0.2711561,22.9705812,24.8439928,134164.926585,178892.745106,12.3328275,7200.6438959,5840.7284358,11858.0641495,42.8667611,48.9919698,0.9097532,158.9191456),(10770,'Cervus_giganteus-metacarpals.tif',249,5,68,1032.1100426,96.3721335,128.3389874,1.8,96.2391588,128.8993373,-0.2690895,22.9244058,24.7067446,134116.274143,177697.2211796,12.1579586,7192.2555671,5850.3707891,11799.2487352,42.844068,49.0710469,0.9220413,159.9870412),(10771,'Cervus_giganteus-metacarpals.tif',249,5,69,1028.4946726,96.3796457,128.3664019,1.8,96.2668508,128.9422173,-0.2655785,22.9796161,24.4177665,133712.9694503,175368.4743814,11.8086956,7182.0030868,5818.7642926,11675.433752,43.0234206,49.0710469,0.9220413,158.6674402),(10772,'Cervus_giganteus-metacarpals.tif',249,5,70,1027.0528104,96.377531,128.3940312,1.8,96.2612836,129.0002178,-0.2650138,22.9485575,24.290825,133576.4798291,173736.0129582,11.7432266,7152.3306842,5820.6917781,11618.6854464,42.7713347,49.0710469,0.9220413,157.5563588),(10773,'Cervus_giganteus-metacarpals.tif',249,5,71,1026.1107966,96.371468,128.4241609,1.8,96.2575027,129.013504,-0.2662056,23.0069645,24.1742797,133518.0379653,172223.6425611,11.8357109,7124.2512552,5803.3748017,11571.2652287,42.7938229,48.9919698,0.9097532,159.8827814),(10774,'Cervus_giganteus-metacarpals.tif',249,5,72,1025.8229949,96.362454,128.4471738,1.8,96.204904,129.0241834,-0.2666072,22.9901124,24.0495907,133467.3087038,170692.3249763,11.8672688,7097.5147609,5805.4221911,11548.6683795,42.7992967,48.8126324,0.9290558,158.2072152),(10775,'Cervus_giganteus-metacarpals.tif',249,5,73,1025.467215,96.3434941,128.4745977,1.8,96.1878024,129.1048945,-0.2705868,23.1129266,23.9396521,133503.7443269,169603.9296795,12.211204,7084.6447098,5776.1505767,11523.254038,42.8667611,48.8126324,0.9290558,158.5199946),(10776,'Cervus_giganteus-metacarpals.tif',249,5,74,1025.4724183,96.3255466,128.5133845,1.8,96.1832906,129.1091748,-0.2795337,23.1491083,23.9750231,133755.1233929,168883.4820668,13.0106722,7044.1426235,5777.9816679,11420.2265387,42.8892492,48.9203138,0.8974271,158.7717),(10777,'Cervus_giganteus-metacarpals.tif',249,5,75,1025.9627555,96.2898265,128.5525422,1.8,96.14749,129.1619526,-0.2872738,23.1796666,24.1793118,133877.3278464,168139.6132446,13.7275336,6953.862639,5775.6364709,11419.6069063,42.8965317,48.9203138,0.8974271,159.7353358),(10778,'Cervus_giganteus-metacarpals.tif',249,5,76,1024.2532331,96.2632132,128.5783244,1.8,96.1227045,129.1930212,-0.2898137,23.181407,24.1689854,133573.6820543,166751.6250251,13.9412172,6899.405263,5762.1041823,11371.5370536,42.9660002,48.799392,0.8726759,157.8080642),(10779,'Cervus_giganteus-metacarpals.tif',249,5,77,1026.4143201,96.26385,128.603341,1.8,96.0873015,129.231838,-0.290495,23.1623069,23.9222909,133895.8013654,165964.7008868,14.0345305,6937.6591629,5780.7627629,11344.7178007,43.0320218,48.8126324,0.9290558,157.3478392),(10780,'Cervus_giganteus-metacarpals.tif',249,5,78,1025.5003928,96.2608079,128.6177151,1.8,96.0841407,129.2695158,-0.2889159,23.1376613,23.9026731,133685.1686542,165158.9529843,13.8742589,6909.6436318,5777.8168316,11311.7822911,42.9360267,48.7293473,0.9167136,156.8444284),(10781,'Cervus_giganteus-metacarpals.tif',249,5,79,1024.5963125,96.2625024,128.623569,1.8,96.1064933,129.2707341,-0.2787937,23.1731592,23.70235,133494.3321854,164178.8639996,12.932611,6926.6913938,5760.7308112,11268.8853689,42.9421013,48.7293473,0.9167136,162.2523898),(10782,'Cervus_giganteus-metacarpals.tif',249,5,80,1023.7996544,96.2646755,128.6397444,1.8,96.0913819,129.352077,-0.2708982,23.092293,23.568632,133601.2355114,163454.7264087,12.218732,6935.2657666,5785.533544,11250.1436745,43.090632,48.6535098,0.9043311,157.912324),(10783,'Cervus_giganteus-metacarpals.tif',249,5,81,1016.9123296,96.2537759,128.5518786,1.8,96.1375003,129.2610748,-0.2595677,23.0846259,23.3630334,132316.2085709,161399.9913816,11.1649808,6908.3491413,5731.78917,11115.6486687,43.0049857,48.6535098,0.9043311,158.5631804),(10784,'Cervus_giganteus-metacarpals.tif',249,5,82,1016.2940929,96.2555836,128.5734384,1.8,96.1203584,129.166094,-0.2490375,22.9721104,23.2604754,132290.1980268,161026.4422278,10.2896516,6922.749403,5758.73072,11106.7717783,42.58305,48.5851549,0.8919118,158.5631804),(10785,'Cervus_giganteus-metacarpals.tif',249,5,83,1016.3223471,96.241242,128.6095651,1.8,96.0891106,129.2228297,-0.2486262,22.9370089,23.2337745,132262.7330694,160504.3960078,10.2566791,6908.2359356,5766.3461448,11084.5024404,42.58305,48.5851549,0.8919118,158.7106261),(10786,'Cervus_giganteus-metacarpals.tif',249,5,84,1016.0527848,96.2257932,128.6189786,1.8,96.0722397,129.2358687,-0.239629,22.9532725,23.03779,132031.8664249,159721.2329104,9.5392673,6933.0101796,5752.202275,11053.3071801,42.6079816,48.5566452,0.9361445,160.030227),(10787,'Cervus_giganteus-metacarpals.tif',249,5,85,1012.4360161,96.2146385,128.6279791,1.8,96.0513674,129.2888384,-0.2299213,22.8541738,22.9510372,131507.7297904,158563.9912204,8.7641214,6908.7941359,5754.21063,10995.4767462,42.5568182,48.5566452,0.9361445,155.5248275),(10788,'Cervus_giganteus-metacarpals.tif',249,5,86,1010.8782274,96.2044016,128.636794,1.8,96.0474523,129.3249217,-0.2231269,22.7814686,22.8861777,131222.1765092,157862.6903397,8.24959,6897.7307004,5760.0402669,11022.0974928,42.633354,48.4024031,0.9557068,156.3842035),(10789,'Cervus_giganteus-metacarpals.tif',249,5,87,1008.9417198,96.1915668,128.6564676,1.8,96.0422164,129.3213883,-0.2133286,22.6672704,22.7913449,130962.0163628,157067.3441375,7.5372838,6891.5346895,5777.5821267,10991.6731599,42.7038703,48.4024031,0.9557068,155.7765329),(10790,'Cervus_giganteus-metacarpals.tif',249,5,88,1008.8956738,96.1795268,128.678595,1.8,96.0298684,129.3734227,-0.2025901,22.6998091,22.6757616,130860.2956653,156439.8489492,6.8074088,6898.9898484,5764.819218,10974.2751038,42.7488466,48.3031238,0.9433081,157.2435795),(10791,'Cervus_giganteus-metacarpals.tif',249,5,89,1007.6334079,96.1702999,128.6837537,1.8,96.030388,129.4013195,-0.1896138,22.5776863,22.6016812,130421.9564719,155822.3649502,5.9659576,6894.2820486,5776.586428,10937.9922384,42.6127149,48.3031238,0.9433081,153.9535211),(10792,'Cervus_giganteus-metacarpals.tif',249,5,90,1005.9643925,96.1640769,128.6763149,1.8,96.0249048,129.3922042,-0.1802822,22.4212005,22.519204,129882.7232065,155159.3086462,5.3904728,6890.0885029,5792.8532182,10891.1487638,42.597719,48.2667978,0.9753865,156.4884632),(10793,'Cervus_giganteus-metacarpals.tif',249,5,91,1006.1634592,96.1514192,128.6933076,1.8,96.0152184,129.436677,-0.1763287,22.5212725,22.5697533,129841.6634146,155171.3619804,5.1600936,6875.1908739,5765.2898231,10818.7058846,42.5677272,48.4024031,0.9557068,155.7765329),(10794,'Cervus_giganteus-metacarpals.tif',249,5,92,1004.2334417,96.1320383,128.6913158,1.8,95.9849338,129.4333407,-0.1682336,22.4443566,22.5315781,129344.0514151,154859.4562412,4.6925397,6872.9964535,5762.8763332,10792.3642443,42.5527313,48.3031238,0.9433081,156.6359089),(10795,'Cervus_giganteus-metacarpals.tif',249,5,93,1004.9554079,96.1186247,128.6879631,1.8,95.979547,129.4296496,-0.1572718,22.2687119,22.5574715,129088.3889374,154786.1717425,4.1087858,6861.8582488,5796.8502737,10782.2779613,42.1832886,48.3031238,0.9433081,153.9535211),(10796,'Cervus_giganteus-metacarpals.tif',249,5,94,1003.5963501,96.118259,128.694126,1.8,95.9769693,129.407994,-0.1396935,22.1417193,22.4372192,128748.1387745,154570.1117875,3.2428964,6889.0048433,5814.7308822,10763.1957026,42.1642063,48.2113,0.9308603,154.7086373),(10797,'Cervus_giganteus-metacarpals.tif',249,5,95,1004.3075741,96.105075,128.7432608,1.8,95.9677456,129.4351793,-0.1383224,22.0798997,22.4130681,129103.6615445,154619.9782138,3.1822122,6898.652955,5847.1126847,10797.6346493,42.1642063,48.1557382,0.9629943,153.9535211),(10798,'Cervus_giganteus-metacarpals.tif',249,5,96,1003.7938502,96.0818078,128.7763742,1.8,95.9645634,129.5400424,-0.1482647,22.1584141,22.4785328,129347.0448844,154435.3968488,3.6507688,6870.350398,5837.3782647,10816.4886463,42.1832886,48.1557382,0.9629943,157.7469903),(10799,'Cervus_giganteus-metacarpals.tif',249,5,97,995.48128,96.0450605,128.6916916,1.8,95.9019961,129.442481,-0.1476796,21.9427208,22.4527164,128156.5270409,152811.3208938,3.592222,6805.9168402,5840.5030218,10802.2696201,42.1648625,47.9116571,0.9703566,153.9535211),(10800,'Cervus_giganteus-metacarpals.tif',249,5,98,993.0628834,96.040247,128.6723007,1.8,95.9028152,129.3524902,-0.1422015,22.0798684,22.4317748,127735.5926447,152464.5214497,3.3243347,6796.8104429,5785.1609616,10767.6869323,41.9530287,47.8036349,0.9578612,154.9171569),(10801,'Cervus_giganteus-metacarpals.tif',249,5,99,990.8385181,96.0113975,128.657819,1.8,95.8569285,129.3397004,-0.1435193,21.9321395,22.4099332,127169.0719632,151942.7230612,3.378222,6780.1506483,5798.2976102,10728.5364474,41.7688583,47.8036349,0.9578612,154.6654515),(10802,'Cervus_giganteus-metacarpals.tif',249,5,100,990.6868963,95.9702807,128.6516213,1.8,95.8163239,129.3435943,-0.1461104,21.9122853,22.379215,126638.3259414,151542.6135304,3.4998913,6771.5785967,5779.3299156,10728.3331415,41.7688583,47.7031095,0.9453113,153.4501103),(10803,'Cervus_giganteus-metacarpals.tif',249,5,101,989.190092,95.9428053,128.652233,1.8,95.7773168,129.3723988,-0.1446462,21.8989388,22.4087568,126072.3944935,150919.8270316,3.4254014,6734.8594295,5757.0093205,10689.878605,41.7538624,47.7031095,0.9453113,151.7313583),(10804,'Cervus_giganteus-metacarpals.tif',249,5,102,991.0229261,95.9157793,128.6752456,1.8,95.758514,129.4320111,-0.1451468,21.8858065,22.3806563,126043.23819,150821.3957464,3.4553766,6738.9174723,5759.1315333,10699.3808394,41.7538624,47.6101284,0.9327103,152.4864745),(10805,'Cervus_giganteus-metacarpals.tif',249,5,103,992.9507056,95.8952964,128.7043827,1.8,95.7267677,129.4650441,-0.1454479,21.8633984,22.4196202,125951.6665297,150789.3545318,3.4763769,6725.7764895,5760.8457899,10709.3026214,41.7388665,47.6101284,0.9327103,152.8424397),(10806,'Cervus_giganteus-metacarpals.tif',249,5,104,992.5550341,95.8806794,128.7076335,1.8,95.723839,129.4598511,-0.1439263,21.8447739,22.3981151,125687.5108322,150543.347867,3.4031653,6721.2507442,5753.6649866,10716.176618,41.7497759,47.524736,0.9200621,151.6270985),(10807,'Cervus_giganteus-metacarpals.tif',249,5,105,990.4060881,95.8619806,128.704149,1.8,95.701323,129.4501302,-0.1502049,21.9230103,22.4712274,125402.9950147,150354.6540088,3.696251,6690.985377,5720.1540052,10701.7853169,41.7538624,47.524736,0.9200621,151.8788039),(10808,'Cervus_giganteus-metacarpals.tif',249,5,106,988.156266,95.8411826,128.6940507,1.8,95.6709346,129.4303014,-0.1566982,22.0098947,22.4818252,125009.1864404,149989.3586268,4.010929,6671.5828178,5679.6812705,10652.7227303,41.7497759,47.5577467,0.9652517,152.1305093),(10809,'Cervus_giganteus-metacarpals.tif',249,5,107,985.1447538,95.8297502,128.68433,1.8,95.6815969,129.4448714,-0.1561087,22.0146137,22.4025844,124581.3052655,149576.5833963,3.9689182,6676.7557186,5659.027537,10642.1615172,41.7538624,47.4528098,0.9526521,151.3753931),(10810,'Cervus_giganteus-metacarpals.tif',249,5,108,982.7787256,95.8099576,128.6694367,1.8,95.741975,129.4474168,-0.1569173,22.0415599,44.9847534,124144.5617632,149605.1095622,4.000175,3325.6847789,5632.2947433,6081.037518,41.7538624,47.3768775,0.894639,151.0194279),(10811,'Cervus_giganteus-metacarpals.tif',249,5,109,983.5861259,95.785889,128.6616656,1.8,95.7968546,129.4034202,-0.1612415,22.0328296,45.9166948,124020.1964566,150089.3430113,4.225207,3268.7314209,5628.8819317,5965.9939442,41.7538624,47.3242375,1.0054599,150.7677225),(10812,'Cervus_giganteus-metacarpals.tif',249,5,110,981.4775751,95.7780443,128.6513583,1.8,95.9006131,129.3406163,-0.158699,22.016673,46.843269,123642.7335622,150182.8891445,4.085345,3206.0719138,5615.8681995,5843.56282,41.7388665,47.3242375,1.0054599,153.1984049),(10813,'Cervus_giganteus-metacarpals.tif',249,5,111,980.3784565,95.789207,128.6360657,1.8,95.9922866,129.2768425,-0.1457707,21.5873911,48.1797707,123382.2446001,150765.6140989,3.4475041,3129.2306245,5715.4773303,5689.9089756,41.698098,47.2050942,0.9600704,152.3390289),(10814,'Cervus_giganteus-metacarpals.tif',249,5,112,979.2215986,95.7826319,128.6194275,1.8,96.0408938,129.3195231,-0.1345507,21.4680634,49.0947354,123151.878617,151130.1275108,2.9368346,3078.3367329,5736.5155165,5586.5704532,41.698098,47.2050942,0.9600704,150.5160171),(10815,'Cervus_giganteus-metacarpals.tif',249,5,113,1005.753185,95.7048752,127.7259988,1.8,95.5867448,127.1948146,0.0127188,22.7724465,48.5939298,131298.4541161,154094.7492112,0.0271143,3171.069925,5765.6718738,5811.3535052,43.398488,52.3161683,2.3097164,173.8592052),(10816,'Cervus_giganteus-metacarpals.tif',249,5,114,1082.4242161,95.4813631,126.4624394,1.8,94.5294009,123.1126056,0.3619221,26.8736174,44.1574532,147464.9501604,178523.1844933,22.616772,4042.8777341,5487.350205,6622.1050523,53.439868,74.7632425,2.016451,257.3691919),(10817,'Cervus_giganteus-metacarpals.tif',249,5,115,1126.7247088,95.8181426,128.0617737,1.8,96.2388022,126.1592908,0.2305794,30.0745206,45.7955273,152546.5602586,180483.6341167,9.8083749,3941.0755741,5072.2856904,6781.9201833,83.19412,197.4139311,0.0435454,770.6418004),(10818,'Cervus_giganteus-metacarpals.tif',249,5,116,983.2276605,95.6711191,128.6606703,1.8,95.816996,129.1923093,-0.1362919,24.1517666,49.328266,122299.9583756,150532.5209431,3.0251869,3051.6483397,5063.8100374,5529.2446133,43.398488,52.5994979,0.942,172.7481238),(10819,'Cervus_giganteus-metacarpals.tif',249,5,117,964.40322,95.6870372,128.3349723,1.8,95.7962643,128.7745591,-0.1095941,21.3534471,49.2264743,118906.6837175,149161.1955628,1.9228366,3030.1011336,5568.5006316,5440.0655403,41.6361038,48.9033272,0.941354,155.3773818),(10820,'Cervus_giganteus-metacarpals.tif',249,5,118,956.3851654,95.7061872,128.294448,1.8,95.9765529,128.8098759,-0.0986974,21.5598937,47.893501,118533.1084429,148766.3067661,1.5476828,3106.1898542,5497.8521638,5571.2882361,41.5159071,46.6641959,0.9291368,151.9830637),(10821,'Cervus_giganteus-metacarpals.tif',249,5,119,954.8006331,95.6146626,128.283467,1.8,95.6854321,128.7944602,-0.1057648,21.6118476,46.2931294,118092.436922,148348.6505957,1.7734678,3204.5500607,5464.2453142,5745.9792731,41.5009089,46.6067899,0.9623362,152.6949941),(10822,'Cervus_giganteus-metacarpals.tif',249,5,120,953.2693643,95.6521816,128.2141032,1.8,95.6325263,128.6067999,-0.0886301,20.867705,44.8750545,117018.8068925,147099.4544824,1.24477,3277.9782936,5607.6510001,5871.80355,40.9059193,46.5056624,0.9032703,151.7313583),(10823,'Cervus_giganteus-metacarpals.tif',249,5,121,947.896132,95.6612886,128.2519668,1.8,95.6709842,128.8501816,-0.0847045,21.5155404,43.5722965,117747.7108143,146678.9676481,1.1307952,3366.3354814,5472.6820049,6050.2337914,42.0862842,46.4082933,0.9365542,153.9103352),(10824,'Cervus_giganteus-metacarpals.tif',249,5,122,947.5678791,95.5505131,128.2601389,1.8,95.3582644,129.072985,-0.1016206,22.4882011,25.4406209,117765.2993852,146446.700403,1.6252751,5756.4122003,5236.7594303,10159.5530761,42.539112,46.4082933,0.9365542,154.6222656),(10825,'Cervus_giganteus-metacarpals.tif',249,5,123,947.6904074,95.5258057,128.1722895,1.8,95.350265,128.7989622,-0.1115787,21.2698752,25.1765228,116377.8200681,146288.022373,1.9582801,5810.4935049,5471.4857992,10153.032784,41.0487891,46.3206853,0.9235847,153.7018157),(10826,'Cervus_giganteus-metacarpals.tif',249,5,124,945.7362199,95.6235779,128.1521185,1.8,95.5012728,128.7685165,-0.0761356,20.697109,24.4876724,116364.660286,146189.2622572,0.9119166,5969.9125218,5622.2664021,10225.9907621,40.9699894,46.3206853,0.9235847,150.9151681),(10827,'Cervus_giganteus-metacarpals.tif',249,5,125,944.8940752,95.6133177,128.174512,1.8,95.5991972,128.9824751,-0.0821369,22.077481,24.1878796,117026.1835851,146960.2993864,1.0600626,6075.7826519,5300.703629,10298.8287431,42.3649442,46.3206853,0.9235847,153.6586298),(10828,'Cervus_giganteus-metacarpals.tif',249,5,126,942.6464911,95.5259354,128.1284567,1.8,95.3975175,129.0114808,-0.0939163,22.6102614,24.0216119,116293.7306055,147040.4091159,1.3816633,6121.1716299,5143.4049658,10259.8504352,42.539112,46.2408976,0.9105682,154.2663004),(10829,'Cervus_giganteus-metacarpals.tif',249,5,127,942.7122312,95.4891205,128.0396926,1.8,95.3468169,128.7503716,-0.1025026,21.7328331,23.742423,115007.968514,147007.5480956,1.6450392,6191.7668703,5291.8994998,10288.2927773,41.6433916,46.2548704,0.9570262,155.5248275),(10830,'Cervus_giganteus-metacarpals.tif',249,5,128,942.9069897,95.5619198,127.9961216,1.8,95.4115724,128.6972733,-0.0761813,20.7271221,23.0527823,114547.3866847,147014.5648204,0.9102773,6377.3024451,5526.4491575,10293.9404146,40.9100058,46.2408976,0.9105682,153.7018157),(10831,'Cervus_giganteus-metacarpals.tif',249,5,129,933.1812591,95.7118767,127.9120932,1.8,95.7281034,128.9182873,-0.0774525,22.7892473,22.6112218,114500.979512,146638.2708366,0.9311442,6485.1988934,5024.3423113,10321.5476644,42.8282288,46.1689709,0.8975089,155.2299362),(10832,'Cervus_giganteus-metacarpals.tif',249,5,130,929.4882319,95.6369768,127.8531983,1.8,95.5609799,128.9177539,-0.0866419,23.2125847,22.6145305,113757.10836,146974.8890598,1.16001,6499.1351024,4900.6653078,10253.0936327,42.8978361,46.1689709,0.8975089,156.5495372),(10833,'Cervus_giganteus-metacarpals.tif',249,5,131,929.5531328,95.5937501,127.7766183,1.8,95.4393654,128.6989533,-0.0948065,22.7571455,22.612844,112764.7047288,146676.836596,1.388345,6486.4391505,4955.1339593,10191.443277,42.3810725,46.1049417,0.8844111,157.9555098),(10834,'Cervus_giganteus-metacarpals.tif',249,5,132,928.0545382,95.6779367,127.7236075,1.8,95.524953,128.507427,-0.0636718,20.9049798,22.5869875,112140.2967349,146351.879079,0.6262254,6479.4775706,5364.2862973,10226.4669774,40.9549935,45.9605501,2.2966623,159.3182966),(10835,'Cervus_giganteus-metacarpals.tif',249,5,133,923.2849399,95.7327098,127.7030775,1.8,95.754433,128.7177058,-0.0712171,22.4824876,22.6827491,112595.3779519,146583.0139375,0.7791462,6462.3125418,5008.137004,10290.6721416,42.7607412,46.2408976,0.9105682,155.4816416),(10836,'Cervus_giganteus-metacarpals.tif',249,5,134,920.1275686,95.6265032,127.6837649,1.8,95.550486,128.7894182,-0.0855629,23.44839,22.6506762,112297.2215776,146564.1021874,1.1199735,6470.6281196,4789.1229065,10318.9930842,43.028991,46.208944,1.0447299,154.9782308),(10837,'Cervus_giganteus-metacarpals.tif',249,5,135,919.5771981,95.5566648,127.589052,1.8,95.3838221,128.5603193,-0.1035062,22.7845044,27.481738,111202.1139278,146140.656033,1.6361306,5317.7370338,4880.6027004,8872.9740381,42.4082271,46.208944,1.0447299,157.2003936),(10838,'Cervus_giganteus-metacarpals.tif',249,5,136,917.9457805,95.6247313,127.544107,1.8,95.4773713,128.3866526,-0.0760465,21.2041973,22.7792402,110637.5709382,146054.1598642,0.8830538,6411.722204,5217.7203218,10281.7162866,41.2944444,45.9946834,1.052809,159.7785216),(10839,'Cervus_giganteus-metacarpals.tif',249,5,137,913.5930584,95.620379,127.5647882,1.8,95.6432942,128.5786089,-0.0762799,23.0340824,24.7466961,111271.908748,146500.093821,0.8842582,5919.98597,4830.7506547,9566.77828,42.6525681,46.6008473,0.9955808,153.8671494),(10840,'Cervus_giganteus-metacarpals.tif',249,5,138,909.7090772,95.4739853,127.5789308,1.8,95.3196166,128.754601,-0.0888411,25.8888638,23.9136913,110953.9249639,146672.9102721,1.1935366,6133.4282793,4285.7780824,8572.3061192,43.0552228,49.8604741,0.9014389,166.9231232),(10841,'Cervus_giganteus-metacarpals.tif',249,5,139,911.4771223,95.4669521,127.4978703,1.8,95.2784261,128.6037645,-0.0970732,26.3688539,23.1477263,110335.2896689,146974.4349477,1.4270162,6349.411314,4184.3035703,7971.3778015,42.4082271,49.1575091,0.9342881,163.6762506),(10842,'Cervus_giganteus-metacarpals.tif',249,5,140,910.0071736,95.5825596,127.4220475,1.8,95.452256,128.4300482,-0.075697,26.5941576,22.9082697,110004.1331191,147221.3834508,0.8674037,6426.5605881,4136.4022355,8295.8465176,41.679736,51.2753012,0.8803499,169.8825141),(10843,'Cervus_giganteus-metacarpals.tif',249,5,141,906.7027683,95.5708661,127.4621533,1.8,95.6253129,128.5780184,-0.0605317,26.8138519,22.8299619,110338.6152116,147488.9908104,0.55303,6460.3257586,4114.9856332,8428.9082913,42.9545944,47.0954514,1.0131641,161.6015334),(10844,'Cervus_giganteus-metacarpals.tif',249,5,142,905.3589847,95.4481391,127.4724331,1.8,95.3402496,128.6724689,-0.067779,25.905326,22.79608,110493.682987,148288.2856625,0.6921397,6504.9905703,4265.2882684,8805.969625,43.1573057,46.9619695,1.0005584,163.528805),(10845,'Cervus_giganteus-metacarpals.tif',249,5,143,904.3551473,95.3727585,127.422208,1.8,95.159455,128.6225463,-0.0957319,25.1368895,22.8583051,109463.1507615,148206.7966236,1.3771255,6483.7176726,4354.6816215,8881.9977249,42.9515874,47.9116571,0.9703566,164.4313668),(10846,'Cervus_giganteus-metacarpals.tif',249,5,144,899.4523903,95.4949313,127.3154932,1.8,95.3392922,128.3434229,-0.0629917,25.4027084,22.801135,108092.8797941,147192.4851501,0.594044,6455.4893895,4255.1714626,9037.1535264,41.5192304,48.4691111,0.9237491,167.0094948),(10847,'Cervus_giganteus-metacarpals.tif',249,5,145,890.9737634,95.5224651,127.2269061,1.8,95.5840167,128.4736879,-0.0664573,26.2492959,22.8513071,108259.7152478,146875.3237626,0.6548757,6427.4364432,4124.2902502,8707.8764694,43.0339549,47.3242375,1.0054599,161.9574986),(10848,'Cervus_giganteus-metacarpals.tif',249,5,146,889.3737332,95.4254302,127.1558848,1.8,95.3036326,128.3441029,-0.0748694,23.9707407,22.8002615,107612.8761707,147071.0797935,0.8293361,6450.4119818,4489.3429725,9955.0350242,42.872552,46.2788139,1.0240075,160.7421574),(10849,'Cervus_giganteus-metacarpals.tif',249,5,147,886.9467765,95.4221807,127.0442706,1.8,95.2674584,128.0533002,-0.0725155,22.7443794,22.8249121,106196.7812365,146623.524327,0.7759725,6423.8374179,4669.1439427,10189.5636843,41.85698,46.5036774,1.0161147,158.9191456),(10850,'Cervus_giganteus-metacarpals.tif',249,5,148,883.2000382,95.5202578,126.9843354,1.8,95.4809526,128.0389429,-0.0478488,26.3137971,23.0714668,106025.2894936,146197.0844842,0.3367583,6336.7052353,4029.2660623,8659.7155172,41.7970329,46.6008473,0.9955808,165.646708),(10851,'Cervus_giganteus-metacarpals.tif',249,5,149,877.2792888,95.4979421,126.9797421,1.8,95.5957094,128.2381452,-0.0542827,27.0085399,23.1146934,106142.9424524,146175.7787655,0.430411,6323.9332886,3929.9770681,8341.0701665,42.9054867,46.5810331,2.2253671,162.3134638),(10852,'Cervus_giganteus-metacarpals.tif',249,5,150,875.4885843,95.3901835,126.9264542,1.8,95.2507231,128.1266797,-0.0631596,24.0413752,23.0423201,105620.0618285,146360.2502934,0.5812999,6351.8017958,4393.2620677,9694.8928311,42.8749405,46.6641959,2.2124558,163.2770996),(10853,'Cervus_giganteus-metacarpals.tif',249,5,151,875.623925,95.3925696,126.8101749,1.8,95.2093473,127.8282654,-0.0615846,22.9103251,23.0726986,104524.9694177,146286.5763985,0.5527907,6340.2456173,4562.3520889,10079.9405565,41.7863342,46.4778635,0.9827937,163.3202854),(10854,'Cervus_giganteus-metacarpals.tif',249,5,152,870.9219691,95.5029656,126.7377616,1.8,95.4989013,127.862872,-0.0413067,26.6192013,23.0976774,104369.3491297,146251.8365548,0.2475261,6331.8849833,3920.829485,8491.4351794,41.9756235,46.6008473,0.9955808,164.2839212),(10855,'Cervus_giganteus-metacarpals.tif',249,5,153,867.6468811,95.4407364,126.7368268,1.8,95.4349676,128.0269127,-0.0511071,26.4828353,23.1020516,104732.9639451,147068.3510684,0.3773782,6366.0298791,3954.7489124,8586.9581001,43.0474443,47.4469732,0.9073703,166.7146036),(10856,'Cervus_giganteus-metacarpals.tif',249,5,154,868.121161,95.3684963,126.6540184,1.8,95.2167203,127.833237,-0.0601942,23.8607488,23.1040085,104016.925405,147174.6545921,0.5236168,6370.091775,4359.3319799,9918.9110644,42.6346091,46.6008473,0.9955808,161.4540878),(10857,'Cervus_giganteus-metacarpals.tif',249,5,155,864.7862075,95.4719675,126.5734304,1.8,95.4954571,127.7957596,-0.0454831,26.7150368,23.1325018,103419.3742708,147019.3960705,0.2979601,6355.5337445,3871.2046353,8445.5715243,42.2814106,46.7175796,0.9751408,162.1049442),(10858,'Cervus_giganteus-metacarpals.tif',249,5,156,859.6202104,95.4616489,126.5052728,1.8,95.5888868,127.7017837,-0.0432597,25.9898536,23.112668,102641.3396366,147325.3477774,0.2679479,6374.225073,3949.2850307,8793.0325893,42.2726754,46.1209573,0.9776258,157.7648784),(10859,'Cervus_giganteus-metacarpals.tif',249,5,157,854.8788664,95.4235883,126.3373304,1.8,95.3378784,126.966012,-0.0401312,21.5100905,23.0806582,100655.2125764,147333.7103112,0.2293424,6383.42759,4679.4416058,10006.7675743,40.2899693,45.7209031,0.3752708,148.6498195),(10860,'Cervus_giganteus-metacarpals.tif',249,5,158,851.6126183,95.4042909,126.26289,1.8,95.3164445,126.8915432,-0.0411163,21.1845663,23.0707054,100154.9393866,147417.3875948,0.2398142,6389.8084231,4727.7314086,9977.2934573,40.2352728,45.8157034,0.3543799,148.6498195),(10861,'Cervus_giganteus-metacarpals.tif',249,5,159,850.0327298,95.3902081,126.1896019,1.8,95.341467,126.8094235,-0.0388695,21.2489573,23.0616795,99774.829166,147536.9511556,0.213935,6397.4937887,4695.5164813,9952.7600533,40.3812034,45.8640364,0.2654304,148.9015249),(10862,'Cervus_giganteus-metacarpals.tif',249,5,160,846.6726552,95.3737411,126.1188366,1.8,95.3068858,126.7470292,-0.0375044,21.2876764,23.3549307,99252.368307,147577.0270106,0.1983929,6318.8809544,4662.4331556,9920.6828618,40.4149163,45.934431,0.3040009,149.8651606),(10863,'Cervus_giganteus-metacarpals.tif',249,5,161,840.021827,95.466454,125.9709569,1.8,95.4148267,126.6462411,-0.0361473,21.4162283,23.111157,98307.5691271,147068.9904328,0.1828527,6363.549456,4590.3306501,9873.0322467,40.803959,45.9786238,0.2744486,149.5091955),(10864,'Cervus_giganteus-metacarpals.tif',249,5,162,837.8693562,95.47556,125.8944927,1.8,95.3999605,126.5525907,-0.0350342,21.4643296,23.4092853,98037.6153394,147385.4547156,0.1713296,6296.0253858,4567.4669219,9883.7555822,40.583481,46.0969318,0.2065361,150.2211258),(10865,'Cervus_giganteus-metacarpals.tif',249,5,163,833.7420526,95.465716,125.8142061,1.8,95.3789353,126.4509991,-0.0347109,21.1416812,23.4310689,97463.6895124,147106.4190556,0.1673552,6278.2632607,4610.0255111,9832.6052416,40.3012944,46.2189319,0.2923473,151.0805018),(10866,'Cervus_giganteus-metacarpals.tif',249,5,164,828.7835704,95.449339,125.7221353,1.8,95.3708224,126.3680992,-0.03624,21.252746,23.4552649,96799.9651497,146766.1932652,0.1813328,6257.2814244,4554.7039049,9774.5880759,40.2562563,46.2189319,0.2923473,149.2574901),(10867,'Cervus_giganteus-metacarpals.tif',249,5,165,822.1467854,95.4346217,125.630386,1.8,95.334092,126.3043045,-0.0361193,21.3435097,23.4587934,95799.7549092,146167.0614247,0.1786851,6230.8004813,4488.4724284,9713.9464337,40.2562563,46.3445948,0.3012256,150.1168661),(10868,'Cervus_giganteus-metacarpals.tif',249,5,166,815.9145677,95.4143978,125.5422578,1.8,95.2956595,126.1944419,-0.036317,21.4034994,23.4428577,94857.140951,145685.6558371,0.179276,6214.5007038,4431.8519714,9691.3591257,40.2562563,46.3923768,0.2719384,149.6134552),(10869,'Cervus_giganteus-metacarpals.tif',249,5,167,811.3513094,95.4111031,125.4369534,1.8,95.3013956,126.024341,-0.0349917,21.0945824,23.4208746,94201.6651604,145324.5450736,0.1655046,6204.9153765,4465.6805041,9630.3112055,40.1408898,46.3923768,0.2719384,149.1100444),(10870,'Cervus_giganteus-metacarpals.tif',249,5,168,807.7727539,95.4142169,125.339964,1.8,95.3126373,125.8605489,-0.0358301,21.201569,23.4626238,93514.1418293,145567.678892,0.1727621,6204.237009,4410.7179891,9616.6884268,40.3970139,46.5849966,0.25169,148.5023738),(10871,'Cervus_giganteus-metacarpals.tif',249,5,169,802.8880125,95.3975125,125.2620672,1.8,95.2954446,125.8687689,-0.0355931,21.2618479,23.4625302,92883.5860564,145743.5604666,0.1694545,6211.7580236,4368.5565985,9584.534252,40.4307269,46.695838,0.1757383,148.7540792),(10872,'Cervus_giganteus-metacarpals.tif',249,5,170,798.7955653,95.3747425,125.1890564,1.8,95.3022022,125.8228125,-0.0341572,21.3040906,23.4326497,92350.5298461,145774.5603407,0.1552675,6221.0019912,4334.8731375,9574.3051648,40.1671217,46.6997918,0.2226609,148.3981141),(10873,'Cervus_giganteus-metacarpals.tif',249,5,171,795.2682591,95.3518147,125.1189067,1.8,95.2749693,125.7701085,-0.0318971,20.9609231,23.3965683,91881.5343384,145685.532679,0.1348082,6226.7906457,4383.467947,9541.0084268,40.114658,46.6997918,0.2226609,149.0057846),(10874,'Cervus_giganteus-metacarpals.tif',249,5,172,789.9478986,95.3189518,125.0245538,1.8,95.2582024,125.6561319,-0.0328488,21.0542677,23.3875025,91087.710971,145371.7526364,0.1420137,6215.7878056,4326.3300468,9505.4899446,40.1671217,46.8537281,0.1937985,148.5023738),(10875,'Cervus_giganteus-metacarpals.tif',249,5,173,786.9958603,95.2981336,124.942641,1.8,95.2424098,125.6090229,-0.0318012,21.1239264,23.3615182,90487.1633862,145598.87993,0.1326056,6232.4237232,4283.6337216,9485.8578503,39.8099906,46.8537281,0.1937985,147.8947032),(10876,'Cervus_giganteus-metacarpals.tif',249,5,174,782.6544399,95.2782786,124.8652156,1.8,95.1903688,125.5817328,-0.02868,20.7461513,23.6635606,89740.4582888,145525.9382938,0.1072652,6149.7904229,4325.6436797,9466.211592,39.4667395,47.0267948,0.2117315,147.1827729),(10877,'Cervus_giganteus-metacarpals.tif',249,5,175,779.3076252,95.2669349,124.7968224,1.8,95.2012844,125.5399497,-0.0233537,20.7460902,23.648763,89212.7647427,145617.4750749,0.0708259,6157.509181,4300.2206078,9448.9338552,39.4667395,47.0326836,0.091487,146.8268077),(10878,'Cervus_giganteus-metacarpals.tif',249,5,176,775.1467523,95.2510575,124.7324057,1.8,95.1762261,125.4674852,-0.0175495,20.7351856,23.6080342,88560.1818675,145534.3055943,0.0397854,6164.6092302,4271.0098466,9411.9968934,39.5192032,47.1679225,0.1187053,147.2870326),(10879,'Cervus_giganteus-metacarpals.tif',249,5,177,764.9408671,95.3682977,124.5404939,1.8,95.3205216,125.3445205,-0.0098388,20.8200951,23.6691234,86702.1778445,144421.9065262,0.0123409,6101.7006787,4164.3507053,9300.062808,39.004879,47.2207367,0.127741,147.1827729),(10880,'Cervus_giganteus-metacarpals.tif',249,5,178,763.7028831,95.3791852,124.4582485,1.8,95.321563,125.2455942,-0.0082876,20.0302841,23.6751471,86282.4648972,144981.9422039,0.008742,6123.8032352,4307.6006523,9286.6680473,38.4335426,47.3378905,0.1457481,146.8268077),(10881,'Cervus_giganteus-metacarpals.tif',249,5,179,760.0658609,95.3553518,124.3691983,1.8,95.2954607,125.1577138,-0.007304,20.1029849,23.6456576,85658.7536526,144880.6287957,0.0067579,6127.1558319,4260.9967726,9248.3779637,38.1538481,47.4022017,0.1547169,148.4412999),(10882,'Cervus_giganteus-metacarpals.tif',249,5,180,759.4268111,95.3434159,124.31952,1.8,95.2886993,125.1456285,-0.0063901,20.140658,27.4735481,85485.6665627,145265.5691178,0.0051677,5287.4702819,4244.4326653,7733.7933001,38.1276162,47.5014205,0.0996687,145.8631719),(10883,'Cervus_giganteus-metacarpals.tif',249,5,181,757.6940139,95.3524098,124.2839011,1.8,95.3296215,125.1488369,-0.0040996,19.7161783,26.2001773,85188.3324203,145432.6481514,0.0021223,5550.8268682,4320.732503,7998.7892546,37.7511933,47.6469551,0.1265921,144.8995361),(10884,'Cervus_giganteus-metacarpals.tif',249,5,182,755.9229476,95.3476903,124.2284292,1.8,95.3450132,125.065531,-0.0027722,19.3243341,24.4995672,84891.1865278,145841.8872492,0.0009683,5952.8352525,4392.9682613,8321.4887193,37.4629037,47.7031095,0.1355277,144.7952763),(10885,'Cervus_giganteus-metacarpals.tif',249,5,183,755.9294377,95.3504721,124.1688175,1.8,95.3649123,124.9908927,0.0005067,19.3410734,24.0200783,84820.2412691,146705.8672474,0.0000326,6107.6348385,4385.4981216,8380.7766803,37.4629037,47.8518892,0.0809041,146.1148773),(10886,'Cervus_giganteus-metacarpals.tif',249,5,184,756.129903,95.3330622,124.0939365,1.8,95.3229105,124.8849279,0.0037833,18.9527978,23.9913523,84596.9183605,147551.9954587,0.0018041,6150.2158639,4463.5583198,7962.3658173,37.1651367,47.9732749,0.1076899,148.5887455),(10887,'Cervus_giganteus-metacarpals.tif',249,5,185,756.5663614,95.3089615,124.0384146,1.8,95.248218,124.8107219,0.0069853,18.8815717,24.2767667,84478.3670086,148303.7588417,0.0061527,6108.8760623,4474.1173295,7569.3527147,36.771157,48.0213588,0.116586,145.8020979),(10888,'Cervus_giganteus-metacarpals.tif',249,5,186,756.5677041,95.2810481,123.9589287,1.8,95.2291745,124.6648973,0.0101696,19.7309614,25.2335489,84243.5833925,148804.3946124,0.0130404,5897.0854736,4269.6137096,7275.495805,36.991164,48.2514944,2.9896204,146.1148773),(10889,'Cervus_giganteus-metacarpals.tif',249,5,187,756.5003415,95.2480574,123.8850589,1.8,95.2186624,124.5714425,0.0128382,20.1556117,26.184872,83831.6304884,149506.3668003,0.0207802,5709.6466525,4159.2203641,7061.4646287,36.9721157,48.7426067,2.982241,147.5819239),(10890,'Cervus_giganteus-metacarpals.tif',249,5,188,756.3401595,95.2020322,123.8299794,1.8,95.17593,124.4645659,0.0144355,20.1557671,27.5527768,83608.4578002,150236.3651644,0.0262666,5452.676014,4148.1159005,6850.6990667,37.6161579,48.4004958,0.1067357,153.5543701),(10891,'Cervus_giganteus-metacarpals.tif',249,5,189,752.9388505,95.1296059,123.7726428,1.8,95.1374656,124.4919083,0.0136657,20.6508859,28.4756284,83050.6975721,150541.0853297,0.0234339,5286.664199,4021.653019,6641.3904911,37.877416,48.6478172,0.0618678,150.0126063),(10892,'Cervus_giganteus-metacarpals.tif',249,5,190,750.5888236,95.0899353,123.6885066,1.8,95.181265,124.4311518,0.012079,21.3903204,29.772489,82501.348968,150903.6288455,0.0182515,5068.5593912,3856.9477814,6430.8260663,38.6531383,48.7085038,0.0794782,158.4157348),(10893,'Cervus_giganteus-metacarpals.tif',249,5,191,751.1873103,95.0342747,123.6399573,1.8,95.1154292,124.4214556,0.0119152,21.875113,30.2601003,82248.3192628,151337.4629581,0.0177738,5001.2214528,3759.9037376,6318.6190115,37.812544,48.8277599,0.1057982,150.8719823),(10894,'Cervus_giganteus-metacarpals.tif',249,5,192,751.3842509,94.9901921,123.5739207,1.8,95.160554,124.4681723,0.0116628,21.9488332,30.7292498,81866.5293107,151743.5549348,0.0170334,4938.0819899,3729.8806931,6247.6571432,38.20394,48.9259746,0.1232657,150.9762421),(10895,'Cervus_giganteus-metacarpals.tif',249,5,193,747.9494844,95.1683462,123.3420841,1.8,95.2331016,124.1484843,0.0140149,22.5778737,30.610406,81000.8548916,152184.4725092,0.0244829,4971.658079,3587.6210529,6195.9515765,37.382856,49.1725305,0.0874953,147.5387381),(10896,'Cervus_giganteus-metacarpals.tif',249,5,194,748.8811476,95.1905347,123.2617765,1.8,95.1754779,124.0136639,0.0152728,22.6426797,30.6169641,80943.2537504,153056.0947254,0.0291116,4999.0617766,3574.8089407,6212.6536605,37.382856,49.2550663,0.1048769,148.2938543),(10897,'Cervus_giganteus-metacarpals.tif',249,5,195,747.6564234,95.1984487,123.1861577,1.8,95.2033013,124.0131233,0.0181748,23.0958296,30.2521516,80488.8446997,153448.3518469,0.0411569,5072.3120003,3484.9947353,6218.4875968,37.5321614,49.3524306,0.1221952,149.9083465),(10898,'Cervus_giganteus-metacarpals.tif',249,5,196,746.5629557,95.1965348,123.0856093,1.8,95.1642687,123.9418163,0.020758,23.5731116,29.454625,80024.1152756,153949.6476009,0.0536074,5226.6714426,3394.7200839,6322.6595406,37.4796977,49.600589,0.0867383,150.2643117),(10899,'Cervus_giganteus-metacarpals.tif',249,5,197,744.9870955,95.2069608,123.0025494,1.8,95.2564631,123.9043091,0.0258373,23.9457208,29.6340745,79593.3972469,154406.2416496,0.0828705,5210.4290159,3323.9090195,6499.9217305,36.52348,49.6824137,3.0376211,146.4708425),(10900,'Cervus_giganteus-metacarpals.tif',249,5,198,746.8713467,95.2033512,122.9236539,1.8,95.2343652,123.8310559,0.0273255,23.9050408,30.9294145,79377.1187959,155332.5980842,0.0929228,5022.1641872,3320.5180166,7061.9359982,37.5196319,49.728845,3.029027,152.1915832),(10901,'Cervus_giganteus-metacarpals.tif',249,5,199,747.9215099,95.194129,122.8407852,1.8,95.1893267,123.6762717,0.0277517,18.8120536,30.9563258,79073.6787046,156021.4321138,0.0959779,5040.0500653,4203.3517758,7314.3902765,36.7878845,50.067411,3.0470478,147.4344783),(10902,'Cervus_giganteus-metacarpals.tif',249,5,200,748.5556361,95.2058112,122.7313904,1.8,95.2131704,123.4972768,0.0329103,17.9970261,24.8811015,78482.8915446,156816.9750934,0.1350764,6302.6540386,4360.8811345,9107.6947306,36.2972538,50.2055079,3.0214839,146.1148773),(10903,'Cervus_giganteus-metacarpals.tif',249,5,201,749.7056683,95.2117125,122.617187,1.8,95.2176724,123.3760889,0.0364541,17.982001,25.0362506,77868.1711397,157522.7084772,0.165974,6291.7851024,4330.3396046,9095.5650112,36.093792,50.4567892,3.0563298,146.0106175),(10904,'Cervus_giganteus-metacarpals.tif',249,5,202,751.4442283,95.2343433,122.5098793,1.8,95.2487198,123.2674228,0.0384924,18.0614245,25.0792003,77289.5166626,158393.0728734,0.1854729,6315.714649,4279.2591877,9059.0407809,36.093792,50.5828743,3.0309354,146.0106175),(10905,'Cervus_giganteus-metacarpals.tif',249,5,203,751.4765668,95.2470722,122.4097303,1.8,95.2740059,123.1539103,0.0382012,18.5417505,25.2625797,76469.028787,158858.0784832,0.1826867,6288.2761824,4124.1536891,9027.5581259,36.093792,50.8849295,3.0570489,146.7225479),(10906,'Cervus_giganteus-metacarpals.tif',249,5,204,748.5907721,95.2768773,122.3106948,1.8,95.3226637,123.063104,0.0388532,18.2792686,25.2730684,75544.1946798,159174.5818335,0.1882471,6298.1898072,4132.7799351,8921.462584,36.5222122,51.0099563,3.0318657,147.3302185),(10907,'Cervus_giganteus-metacarpals.tif',249,5,205,748.4099449,95.3020069,122.2311918,1.8,95.3950425,122.9848435,0.0389055,18.4099196,25.2680567,75147.2136684,160220.1365542,0.1887085,6340.8175257,4081.8871135,8881.4022897,36.52348,51.1112025,3.0151522,150.8719823),(10908,'Cervus_giganteus-metacarpals.tif',249,5,206,745.4596969,95.3256328,122.1333151,1.8,95.4156422,122.8153015,0.0389597,18.0794463,25.6002148,74256.1499444,161130.9549381,0.1884881,6294.1251175,4107.2137138,8911.6978262,36.093792,51.4370817,3.0327804,149.4481215),(10909,'Cervus_giganteus-metacarpals.tif',249,5,207,744.9773044,95.3365246,122.0254287,1.8,95.4391125,122.6557109,0.0378699,18.2005468,25.6433236,73529.3395398,162507.7924825,0.1779806,6337.2359621,4039.9522149,8871.5912158,36.093792,51.5929873,3.0079404,149.9083465),(10910,'Cervus_giganteus-metacarpals.tif',249,5,208,742.6500489,95.3625059,121.9229789,1.8,95.5011972,122.4859938,0.0382925,18.256068,25.6642215,72652.3315614,163497.611736,0.1814044,6370.6437207,3979.6264783,8819.1783091,36.0443267,51.8642494,3.0336802,149.1964161),(10911,'Cervus_giganteus-metacarpals.tif',249,5,209,738.5863594,95.4316898,121.6429355,1.8,95.5907414,122.2093068,0.0385187,17.6307043,25.755027,71153.5520784,164331.9845164,0.1825492,6380.5790037,4035.7748002,8739.8543813,34.804728,52.0188747,3.0090411,148.0242607),(10912,'Cervus_giganteus-metacarpals.tif',249,5,210,733.6360457,95.2536225,121.546189,1.8,95.564508,122.0772433,0.0382697,17.5705204,26.1317007,70617.5270017,164364.3989453,0.1789897,6289.8469858,4019.0913662,8719.8900919,34.804728,52.5643848,3.0679555,148.1285205),(10913,'Cervus_giganteus-metacarpals.tif',249,5,211,723.9747684,94.9875265,121.4208679,1.8,95.3106858,121.8983254,0.0348691,17.4847691,26.3995742,69338.3351192,163526.8599345,0.1466489,6194.2991518,3965.642029,8558.5408611,34.804728,52.9371431,3.0847434,149.0921563),(10914,'Cervus_giganteus-metacarpals.tif',249,5,212,719.6817439,94.7817693,121.3084644,1.8,95.2123652,121.88254,0.0316513,17.5751138,26.617473,68581.7184126,163464.802929,0.1201227,6141.2592835,3902.2062106,8442.9263871,35.234416,53.1459964,3.0362925,151.0626137),(10915,'Cervus_giganteus-metacarpals.tif',249,5,213,716.8846284,94.6613853,121.1912913,1.8,95.0855295,121.8035659,0.0283417,17.3544943,26.7307904,67907.0087029,163621.7995295,0.0959475,6121.0984332,3912.9350219,8347.9847026,34.804728,53.2431809,3.0202407,151.0194279),(10916,'Cervus_giganteus-metacarpals.tif',249,5,214,720.135994,94.5671792,121.0824026,1.8,94.9931586,121.6581694,0.0256636,17.2126449,27.1933143,67464.0007321,166228.1411967,0.0790319,6112.8312466,3919.4441753,8343.0202982,34.37504,53.8826011,3.0617627,150.8109083),(10917,'Cervus_giganteus-metacarpals.tif',249,5,215,722.5179677,94.4861663,120.9905044,1.8,94.9899707,121.5465075,0.0234334,17.4521046,27.2935723,67108.3481743,168788.4602874,0.0661129,6184.1835299,3845.2868458,8314.4713869,34.804728,54.2497054,3.0781857,154.1009667),(10918,'Cervus_giganteus-metacarpals.tif',249,5,216,725.8231563,94.4327309,120.9368559,1.8,94.8086309,121.4241452,0.0201656,17.4324886,27.3328135,66732.7657789,171198.1793512,0.0491862,6263.4671488,3828.0688072,8365.9694961,34.7085464,54.4738646,3.0309354,153.0941451),(10919,'Cervus_giganteus-metacarpals.tif',249,5,217,734.5715694,94.4105862,120.8802913,1.8,94.7347083,121.3141705,0.0194188,17.3913101,27.7631025,67134.6356307,174445.0846062,0.0461612,6283.3425889,3860.2402827,8404.9755292,34.804728,55.1073813,3.0791738,153.7018157),(10920,'Cervus_giganteus-metacarpals.tif',249,5,218,743.7399358,94.3741011,120.8308739,1.8,94.6887582,121.2119693,0.0187819,17.3566711,27.8121475,67606.6529993,178498.9481423,0.0437217,6418.021052,3895.1393779,8505.2810677,33.945352,55.3280658,3.0326507,151.3143191),(10921,'Cervus_giganteus-metacarpals.tif',249,5,219,751.5265852,94.3417037,120.7634753,1.8,94.6359892,121.0699072,0.018129,17.6700525,28.2467917,68039.7237019,182227.3711549,0.0411614,6451.2590763,3850.5671527,8589.044276,34.3632605,55.9931443,3.0724722,154.0577809),(10922,'Cervus_giganteus-metacarpals.tif',249,5,220,759.3050101,94.3030209,120.7192793,1.8,94.5794009,120.9811925,0.0182301,17.6502278,28.3104565,68647.50434,186146.7739116,0.0420525,6575.1950729,3889.3268183,8652.6402306,33.945352,56.2300559,3.026716,153.5975559),(10923,'Cervus_giganteus-metacarpals.tif',249,5,221,771.8422351,94.2188979,120.6783472,1.8,94.5308362,120.9262368,0.0158388,17.6104181,28.7917855,69955.2738106,191238.0631772,0.0322691,6642.1050239,3972.3800762,8764.1055414,33.945352,56.952709,3.0509328,155.7765329),(10924,'Cervus_giganteus-metacarpals.tif',249,5,222,783.3957644,94.1423392,120.6435103,1.8,94.4521445,120.862851,0.013428,17.5855008,28.8683267,70977.4759533,196744.9812965,0.0235411,6815.2540674,4036.1361687,8876.4353768,33.945352,57.4208523,3.0441578,155.9239785),(10925,'Cervus_giganteus-metacarpals.tif',249,5,223,797.2998241,94.0997886,120.6512953,1.8,94.4286208,120.8322248,0.012742,17.6014257,29.323479,72065.8851427,203266.2917935,0.0215741,6931.8613909,4094.320908,9067.6110865,33.945352,58.1366435,3.0750245,156.5316491),(10926,'Cervus_giganteus-metacarpals.tif',249,5,224,810.2869352,94.0579783,120.6305369,1.8,94.4132657,120.8218075,0.0114449,17.9836067,29.7701827,73195.0965169,208873.0917363,0.0176886,7016.1844171,4070.1010408,9201.2970697,34.37504,58.5953286,3.0681953,159.5700021),(10927,'Cervus_giganteus-metacarpals.tif',249,5,225,830.4942678,93.9834589,120.4986628,1.8,94.3267579,120.6690456,0.0107752,17.8682894,30.262064,75188.1441775,216124.9699062,0.0160702,7141.778897,4207.9094741,9418.067578,34.37504,59.3731802,3.0909115,161.6447192),(10928,'Cervus_giganteus-metacarpals.tif',249,5,226,846.9682899,93.9190901,120.495323,1.8,94.177269,120.611631,0.0096473,18.2677995,30.3363314,77125.997928,222462.9639323,0.0131374,7333.219068,4221.9643369,9572.8756221,34.7169371,59.8809965,3.0697739,164.2228472),(10929,'Cervus_giganteus-metacarpals.tif',249,5,227,856.014128,93.8723331,120.4234081,1.8,94.114876,120.5604939,0.0080385,18.2003689,30.7940214,78170.1194453,228954.925567,0.0092185,7435.0446881,4294.9744469,9721.9691107,34.804728,60.640837,3.0990651,167.4697198),(10930,'Cervus_giganteus-metacarpals.tif',249,5,228,870.5125341,93.8028038,120.4242942,1.8,94.0403967,120.544964,0.0064239,18.2014993,30.8605685,80026.6391794,235812.6474021,0.0059877,7641.2282394,4396.705878,9884.4681129,35.234416,60.8050273,3.0566909,171.3063748),(10931,'Cervus_giganteus-metacarpals.tif',249,5,229,888.340131,93.7547716,120.5354596,1.8,93.9477508,120.5743901,0.0038172,18.6858299,31.3128814,82702.2327806,243011.4499211,0.0021574,7760.75018,4425.9330902,10113.5067208,35.664104,61.5669586,3.0787385,166.8009752),(10932,'Cervus_giganteus-metacarpals.tif',249,5,230,905.2805441,93.7194023,120.5746486,1.8,93.8752532,120.5758137,0.0004099,18.7412133,31.7520253,86075.491657,250959.8440312,0.0000255,7903.7428768,4592.8452118,10363.2412985,36.093792,62.3417911,3.1071236,168.9799522),(10933,'Cervus_giganteus-metacarpals.tif',249,5,231,927.1096711,93.6635973,120.5905516,1.8,93.8322532,120.6607721,-0.0017278,18.7663317,31.7983074,89376.7973342,259911.4104505,0.0004612,8173.7498631,4762.6141755,10624.9096918,36.093792,62.8535293,3.0800267,167.8077969),(10934,'Cervus_giganteus-metacarpals.tif',249,5,232,952.9007162,93.6059433,120.6423963,1.8,93.7426189,120.6952538,-0.00357,19.2525438,32.2752043,92546.0861106,269443.0601035,0.0020247,8348.2991334,4806.9536747,10921.9131391,36.953168,63.6460619,3.1010743,170.342739),(10935,'Cervus_giganteus-metacarpals.tif',249,5,233,976.1639844,93.5566014,120.700473,1.8,93.7163807,120.7744203,-0.0061628,19.3301002,32.3199262,95912.2789413,280202.8372438,0.006179,8669.6620504,4961.8097234,11235.6914259,36.953168,63.802519,3.0606886,170.9935955),(10936,'Cervus_giganteus-metacarpals.tif',249,5,234,997.2447932,93.5072982,120.8134099,1.8,93.7212195,120.8597461,-0.0067516,19.454806,32.794596,98910.9058649,291379.2771121,0.0075769,8884.9784,5084.1373442,11580.0237187,37.382856,64.5962705,3.0750245,173.4242778),(10937,'Cervus_giganteus-metacarpals.tif',249,5,235,1024.1533082,93.5148212,120.8502889,1.8,93.7550369,120.9133421,-0.0051193,19.8967406,33.221259,102708.447414,305250.681193,0.0044734,9188.4140022,5162.0740098,12025.357891,37.812544,65.4029741,3.0890096,175.8549602),(10938,'Cervus_giganteus-metacarpals.tif',249,5,236,1056.7039465,93.4609406,120.8119354,1.8,93.7378101,120.9281458,-0.0058545,19.8714141,33.6963496,106806.2741726,320909.5148582,0.0060371,9523.5691272,5374.8703464,12481.9388855,38.242232,66.2221562,3.1026513,177.8254176),(10939,'Cervus_giganteus-metacarpals.tif',249,5,237,1108.0935721,93.4025942,120.8278522,1.8,93.753081,120.9849285,-0.0064218,19.8987009,33.7628317,111963.9897616,342357.9650756,0.0076157,10140.0844562,5626.6984623,13115.500825,38.242232,66.7691463,3.0707437,179.9001348),(10940,'Cervus_giganteus-metacarpals.tif',249,5,238,1170.6943749,93.3724005,120.8466527,1.8,93.8271087,121.0131969,-0.0094861,20.2796015,34.2117762,117945.1726793,367350.7260969,0.0175567,10737.5519952,5815.9512043,13868.0825225,38.7928664,67.5977208,3.0779843,182.2265574),(10941,'Cervus_giganteus-metacarpals.tif',249,5,239,1235.9118576,93.3701389,120.844779,1.8,93.8873647,121.0379494,-0.0112343,20.3413867,34.6372306,124719.3081571,394998.1516757,0.0259958,11403.8606666,6131.3080716,14674.2676354,38.8723786,68.4297533,3.0850492,184.1970148),(10942,'Cervus_giganteus-metacarpals.tif',249,5,240,1295.4298693,93.430478,120.8288084,1.8,93.9523701,121.1000827,-0.0113466,20.3509017,35.0010806,131883.0159754,420162.8638087,0.0277951,12004.2826152,6480.4507398,15393.8772575,39.101608,69.2451244,3.0981418,186.7751428),(10943,'Cervus_giganteus-metacarpals.tif',249,5,241,1373.8410269,93.7211336,120.8164837,1.8,94.2403233,121.3070608,-0.006115,21.923304,35.1666694,143919.6357053,451453.0901366,0.0085614,12837.5276377,6564.6873068,16398.9461999,41.8203279,69.8332237,3.0615173,209.4495864),(10944,'Cervus_giganteus-metacarpals.tif',249,5,242,1416.3792932,94.0641226,121.0351082,1.8,94.3819409,121.4809667,-0.0066892,22.5724085,35.2472663,151287.136194,470530.0559499,0.0105629,13349.4056481,6702.3036674,17160.4004213,42.2895153,70.2286884,3.0681056,226.784552),(10945,'Cervus_giganteus-metacarpals.tif',249,5,243,1422.8919274,94.3445242,121.299408,1.8,94.3902631,121.7596472,-0.0067985,22.1236613,35.392087,154373.1456775,476882.7596078,0.0109605,13474.2763091,6977.7394997,17519.617791,41.9249491,70.5997129,0.0609002,205.5518574),(10946,'Cervus_giganteus-metacarpals.tif',249,5,244,1415.1252518,94.4586877,121.463565,1.8,94.2442066,122.01811,0.0087299,22.600459,35.3482109,153391.6215541,477438.1708993,0.0179745,13506.7138724,6787.1020617,17455.1958358,41.7950008,70.6271671,0.0669729,205.239078),(10947,'Cervus_giganteus-metacarpals.tif',249,5,245,1409.5295102,94.1374678,121.5160543,1.8,94.1227718,122.1121217,0.0109653,22.1448656,35.2775396,150937.816884,476419.2381964,0.0282448,13504.8884944,6815.928329,17173.7636146,42.8850903,70.5696318,0.1651487,231.940808),(10948,'Cervus_giganteus-metacarpals.tif',249,5,246,1411.7069903,93.890356,121.5617694,1.8,93.9734143,122.1382734,0.0017041,22.3584223,35.4545353,149043.0903706,475494.1208363,0.0006822,13411.3764707,6666.082637,17025.1594656,42.0141389,70.8581439,0.1521883,263.73772),(10949,'Cervus_giganteus-metacarpals.tif',249,5,247,1431.1845797,93.9372808,121.7395717,1.8,94.1000569,122.3601009,0.0035919,21.3921057,34.994636,152448.8737108,479071.1200637,0.0030784,13689.8443388,7126.408019,17038.697138,41.679736,70.8581439,0.1521883,243.6161068),(10950,'Cervus_giganteus-metacarpals.tif',249,5,248,1451.4782976,93.9735313,121.8753248,1.8,94.00659,122.4348433,-0.0020049,21.6088051,35.1323627,155323.2923498,483840.3237299,0.0009725,13771.9267076,7187.9630466,17066.1176236,41.7463086,70.9909078,0.121352,224.943652),(10951,'Cervus_giganteus-metacarpals.tif',249,5,249,1461.0181656,94.0964238,121.8821084,1.8,94.1215204,122.4264761,-0.001535,20.3683485,35.2498025,156238.3661143,483499.0459245,0.0005736,13716.361854,7670.6447648,16961.7962001,40.82036,70.7747138,0.2641221,212.2615316),(10952,'Cervus_giganteus-metacarpals.tif',249,5,250,1479.3034254,94.1622983,121.8619657,1.8,94.0234096,122.2811795,0.0018994,20.8582002,35.7039405,163031.9951493,488325.5806321,0.0008896,13677.0780312,7816.2062649,17124.2659305,42.0965715,70.9622935,0.0423988,223.2606763),(10953,'Cervus_giganteus-metacarpals.tif',249,5,251,1504.77461,94.1174482,121.8409647,1.8,94.1015365,122.0740762,-0.0014859,21.3175969,35.7005555,173821.741996,496692.3442411,0.0005542,13912.7343157,8153.9088533,17503.9134167,42.9634142,71.4109914,3.0934371,216.1160748),(10954,'Cervus_giganteus-metacarpals.tif',249,5,252,1531.3229252,94.1140397,121.7383353,1.8,94.0635583,121.9001781,-0.014068,21.9569417,36.3001389,186105.1013754,505806.1132987,0.0505073,13933.9993791,8475.9118086,17859.935817,44.228626,72.6376094,3.1179284,231.9586961),(10955,'Cervus_giganteus-metacarpals.tif',249,5,253,1555.0984627,94.3081702,121.6936831,1.8,94.272061,121.8774435,-0.0193971,22.1556992,36.5833731,197742.6812782,518965.2648108,0.0975043,14185.8232573,8925.138383,18256.7311563,44.428927,73.1088594,3.1004394,243.5044375),(10956,'Cervus_giganteus-metacarpals.tif',249,5,254,1559.846073,94.3474369,121.6210383,1.8,94.2732921,121.9021618,-0.0228106,22.3407811,37.0826574,204439.1674261,538762.5380102,0.1352466,14528.692825,9150.9409112,18862.1767893,44.8184617,73.5381857,3.1006798,247.5496121),(10957,'Cervus_giganteus-metacarpals.tif',249,5,255,1551.2209156,94.3888972,121.5311931,1.8,94.2888585,121.8259555,-0.0265583,23.6262511,37.1875519,206767.7505865,560886.8879327,0.1823147,15082.6515553,8751.6106511,19370.6010772,46.2309364,73.5570135,3.0948431,303.9050534),(10958,'Cervus_giganteus-metacarpals.tif',249,5,256,1546.2913591,94.407485,121.5725357,1.8,94.3974012,121.8947493,-0.0271209,22.4978465,37.6189371,206789.4960673,577752.3750501,0.1895125,15358.0196381,9191.5240081,19749.1859508,34.7776928,49.6377988,0.8527807,149.7430127),(10959,'Cervus_giganteus-metacarpals.tif',249,5,257,1516.0386031,94.603733,121.1431804,1.8,94.4149156,121.4649058,-0.0017335,23.2623663,37.9065108,193069.2438565,581618.0475015,0.0007577,15343.4867745,8299.6390648,19338.3366219,34.804728,49.1894241,0.8905984,146.7478455),(10960,'Cervus_giganteus-metacarpals.tif',249,5,258,1549.4965108,94.3152987,121.4790122,1.8,94.2657065,121.7088898,-0.0251484,22.9077954,37.4930777,198867.7025467,599966.7844496,0.1632941,16002.0681505,8681.2239741,20211.7732682,34.37504,49.1293316,0.8782977,146.8521053),(10961,'Cervus_giganteus-metacarpals.tif',249,5,259,1548.0168269,94.1983703,121.4737138,1.8,94.0886532,121.7101489,-0.0245009,23.1948902,37.3576827,191205.9895432,606812.3527594,0.1548465,16243.3081874,8243.4531069,20321.0299972,34.7734052,48.7501819,0.860258,145.3850587),(10962,'Cervus_giganteus-metacarpals.tif',249,5,260,1531.338423,94.1348561,121.3897308,1.8,94.1771992,121.3438567,-0.0228253,22.6525124,37.2561491,178204.592441,606243.4620096,0.1329475,16272.3060945,7866.8798256,20123.8930124,34.5047881,48.3165002,0.8988332,143.3103415),(10963,'Cervus_giganteus-metacarpals.tif',249,5,261,1511.116264,94.1111908,121.4795742,1.8,94.2589183,121.5127164,-0.0229414,22.3244417,37.1923245,167469.0475211,599245.9690312,0.1325271,16112.087038,7501.6007168,19913.903412,34.497289,48.1940635,0.8737749,143.2671557),(10964,'Cervus_giganteus-metacarpals.tif',249,5,262,1513.6952342,94.4509828,121.6519105,1.8,94.1494966,121.391087,-0.0181311,22.0527107,37.0527871,158715.1250297,590783.3149503,0.0829255,15944.3691348,7197.0800836,19582.31952,42.7909286,74.1320771,0.2759111,304.512724),(10965,'Cervus_giganteus-metacarpals.tif',249,5,263,1442.88408,94.3939992,121.449818,1.8,94.4200522,121.4707131,-0.0237061,20.7216155,36.6035716,137721.5023852,563038.9932602,0.1351189,15382.0779885,6646.2724463,18621.1448153,41.679736,74.0111854,0.2224473,295.5451106),(10966,'Cervus_giganteus-metacarpals.tif',249,5,264,1360.7791679,94.4558884,121.2290336,1.8,94.5096176,120.9907532,-0.0189089,20.3772971,36.1651676,115683.6475101,523114.9763103,0.0810805,14464.6080832,5677.0850036,17302.1691989,33.7849869,43.7902459,0.7437556,138.1108997),(10967,'Cervus_giganteus-metacarpals.tif',249,5,265,1251.9673251,94.3692839,121.1407543,1.8,94.199792,120.8928943,-0.0169825,19.6056294,35.6214856,93971.7406064,454276.7156661,0.060174,12752.8851741,4793.0999217,15123.2451079,33.7050698,42.0238379,0.6475911,134.7165815),(10968,'Cervus_giganteus-metacarpals.tif',249,5,266,1093.4119888,94.5673392,121.0772061,1.8,94.4273617,121.0367677,-0.0182382,18.7163332,35.3681301,73863.0039844,353983.9763754,0.0606099,10008.5578621,3946.4463018,11976.1408251,32.9402254,39.7966253,0.6629371,129.6035114),(10969,'Cervus_giganteus-metacarpals.tif',249,5,267,856.6626891,94.72006,120.9397046,1.8,94.862422,120.8356348,-0.0214364,17.0658808,34.2140815,53377.55205,200950.6266549,0.0655985,5873.331041,3127.734966,7397.7026247,33.945352,68.3798198,0.1196785,264.2516094),(10970,'Cervus_giganteus-metacarpals.tif',249,5,268,678.9601423,93.8701527,120.8790495,1.8,93.9683232,120.8087714,-0.0302597,16.0853508,21.1636208,38166.0341234,102845.9738807,0.1035837,4859.5641919,2372.7200372,5739.3010708,19.33596,33.3112141,1.0436504,94.5850245),(10971,'Cervus_giganteus-metacarpals.tif',249,5,269,590.5306407,94.024324,120.765714,1.8,93.9873253,120.6561241,-0.0256678,15.0229788,20.7608663,24229.8076338,86157.5581539,0.0648297,4149.9982117,1612.8497472,4667.5752356,18.8972398,30.880789,1.0136719,93.3264974),(10972,'Cervus_giganteus-metacarpals.tif',249,5,270,473.4257539,94.3339877,120.6921417,1.8,94.1666733,120.7250089,-0.0276791,12.9518074,20.6590532,12235.3479791,67108.5708686,0.0604357,3248.3855916,944.6826693,3450.1306801,18.3716289,27.7739368,0.9613378,79.5154075),(10973,'Cervus_giganteus-metacarpals.tif',249,5,271,122.8899599,96.1703702,121.3848471,1.8,94.9816256,121.3631435,-0.0182836,9.515172,22.2642777,2159.8276614,29599.1159226,0.0068461,1329.4442474,226.9877697,1385.6350718,8.8271929,18.7198054,1.4094212,53.0221971),(10974,'Cervus_giganteus-metacarpals.tif',249,5,272,21.1115807,97.7983193,121.6903163,1.8,96.5037573,121.1590822,0.0007542,9.9796635,23.8936636,246.8735076,5400.8748937,0.000002,226.0379562,24.7376585,235.3573248,6.015632,13.7567282,1.8233506,36.7804247),(10975,'Cervus_giganteus-metacarpals.tif',249,5,273,1414.4131326,91.7709305,111.9999772,1.8,92.7011294,112.090607,-0.0361317,20.7096591,39.9875412,148276.0569357,661540.0640363,0.3076183,16543.6544713,7159.7536434,19718.768609,37.2582527,51.5124053,1.0847644,150.6023887),(10976,'Cervus_giganteus-metacarpals.tif',249,5,274,1716.9544556,94.6503197,117.8162973,1.8,95.4296397,118.9381325,0.2353495,32.9919039,39.1262817,363791.0749287,777061.3097695,15.5596893,19860.3413452,11026.6772045,26984.1923779,37.812544,50.5828743,1.065348,150.5592029),(10977,'Cervus_giganteus-metacarpals.tif',249,5,275,1629.4447,94.5578671,117.7012442,1.8,95.499873,118.0038339,0.2278057,32.2333761,39.080109,334791.1051023,744026.3574853,13.8513448,19038.4923988,10386.473441,25795.9528248,65.7335792,80.5856904,2.3147089,395.6960207),(10978,'Cervus_giganteus-metacarpals.tif',249,5,276,1534.1209358,94.4713485,117.4711902,1.8,95.1702527,117.6271371,0.2089997,31.3246938,39.118051,294279.6656779,710991.816597,11.0069533,18175.5429447,9394.494566,24412.8058295,65.0725869,79.7531487,2.2952015,378.1093497),(10979,'Cervus_giganteus-metacarpals.tif',249,5,277,1400.6328322,94.5636391,116.3659681,1.8,94.9738318,116.8263357,0.1556872,30.2471148,39.2478899,224606.9450924,680263.5855994,5.6126386,17332.4881394,7425.7312374,21966.3654193,63.4767024,79.3062513,2.3447007,367.9442833),(10980,'Cervus_giganteus-metacarpals.tif',249,5,278,1321.3315816,94.0391562,116.0113482,1.8,94.7121847,116.0788303,0.1288077,29.3066491,38.6753469,193803.6018774,648882.7614213,3.6336356,16777.6843068,6612.956705,20732.4323183,60.1139227,78.2185605,2.2978949,334.5402886),(10981,'Cervus_giganteus-metacarpals.tif',249,5,279,1234.477996,93.3896556,115.4860555,1.8,94.2350502,115.6708234,0.0871481,29.3784943,38.7236572,166171.5369019,591571.5244005,1.55865,15276.7472545,5656.2305423,18951.970569,50.5383584,77.1490415,0.0780534,283.7402543),(10982,'Cervus_giganteus-metacarpals.tif',249,5,280,1115.578936,92.1576037,114.17368,1.8,93.1877069,114.7396481,-0.0073147,30.3814786,39.7452176,121301.7211526,508164.9555512,0.0099476,12785.5622868,3992.6207286,15753.8456715,50.939256,76.6881738,0.0729043,292.8984991),(10983,'Cervus_giganteus-metacarpals.tif',249,5,281,1051.7686272,91.7976439,114.148535,1.8,92.2454057,114.2771829,-0.0273332,22.0870178,39.7032321,109257.2338884,472002.9847014,0.1309312,11888.276095,4946.672059,14536.8905736,51.2381451,75.8420622,0.1306796,290.1550374),(10984,'Cervus_giganteus-metacarpals.tif',249,5,282,961.8795274,92.0922055,113.8424192,1.8,92.3649086,114.0965519,-0.0159451,21.4815287,39.3869179,99358.433986,432236.3524012,0.0407552,10974.1095548,4625.2962525,13481.6823233,51.3588995,75.1217031,0.097392,281.8561686),(10985,'Cervus_giganteus-metacarpals.tif',249,5,283,882.9491069,92.3678586,113.395983,1.8,92.6035967,113.7628832,-0.0083146,20.8254776,38.6817253,90598.0826906,396307.7902866,0.0101735,10245.3493918,4350.3483693,12522.027019,50.5832521,74.1868496,0.0869892,279.529746),(10986,'Cervus_giganteus-metacarpals.tif',249,5,284,815.0179287,92.4940238,112.992555,1.8,92.7718518,113.5667432,-0.0055778,20.3432294,37.7031646,84066.7833454,363121.6150134,0.0042256,9631.0646299,4132.4207459,11784.4725147,49.5979355,73.1454691,2.9465012,275.5277572),(10987,'Cervus_giganteus-metacarpals.tif',249,5,285,757.3998899,92.2866382,112.4777555,1.8,92.6636842,113.183442,-0.0055814,19.8297838,37.4636035,76832.7953745,332194.3194731,0.0039328,8867.1213666,3874.6158928,10865.1575782,49.5120847,72.4339783,2.9081243,278.9652612),(10988,'Cervus_giganteus-metacarpals.tif',249,5,286,702.0521506,92.3280154,111.8468326,1.8,92.6251174,112.7426717,0.0023287,19.1083458,36.5879935,68836.8867065,303208.380366,0.0006347,8287.1005245,3602.4513877,10026.608506,49.3159321,71.6999805,2.899521,282.8019162),(10989,'Cervus_giganteus-metacarpals.tif',249,5,287,659.1106597,92.2559652,111.3222672,1.8,92.6649902,112.2222179,0.0033836,18.6190233,35.3755952,62715.3395581,278090.8743665,0.0012577,7861.0938729,3368.3474515,9143.2398078,34.1153143,48.5224116,1.971037,138.6574963),(10990,'Cervus_giganteus-metacarpals.tif',249,5,288,621.744433,92.1468013,110.8491453,1.8,92.6909636,111.751427,0.0021897,18.1075775,35.0398445,58097.5198404,256723.0098409,0.0004966,7326.6024311,3208.464508,8438.34397,32.9336679,48.5224116,1.971037,138.1540855),(10991,'Cervus-giganteus-tibia-cleaned.tif',249,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10992,'Cervus-giganteus-tibia-cleaned.tif',249,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10993,'Cervus-giganteus-tibia-cleaned.tif',249,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10994,'Cervus-giganteus-tibia-cleaned.tif',249,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10995,'Cervus-giganteus-tibia-cleaned.tif',249,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10996,'Cervus-giganteus-tibia-cleaned.tif',249,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10997,'Cervus-giganteus-tibia-cleaned.tif',249,8,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10998,'Cervus-giganteus-tibia-cleaned.tif',249,8,8,14.9289898,80.8964698,107.1101915,1.8,80.8091348,107.0820976,0.9895662,2.1757746,5.7635894,10.2768336,82.1596544,1.7380862,14.2549457,4.7232988,16.0374099,4.7689108,11.4413255,2.1692152,26.1119475),(10999,'Cervus-giganteus-tibia-cleaned.tif',249,8,9,43.4244429,80.6774905,107.02721,1.8,80.6398614,106.8277729,1.0138757,3.1280558,7.7172992,67.0408567,507.4081476,5.2153393,65.7494464,21.4321163,74.4252947,6.6816145,15.3849907,2.1975392,36.8414987),(11000,'Cervus-giganteus-tibia-cleaned.tif',249,8,10,75.8263687,80.6008839,106.7786756,1.8,80.5981983,106.6429263,0.987036,3.9766556,9.0177684,211.654236,1271.1289291,8.798597,140.9582592,53.2241804,164.4290149,8.4420773,17.99567,2.1521765,43.9250263),(11001,'Cervus-giganteus-tibia-cleaned.tif',249,8,11,115.2276852,82.3570515,106.7896231,1.8,84.0961428,106.9659238,0.372266,7.8530398,23.2960482,1244.7530981,5732.1369348,2.5407214,246.0561931,158.5058952,294.4048212,10.2381279,20.2820019,2.2058231,50.1491779),(11002,'Cervus-giganteus-tibia-cleaned.tif',249,8,12,179.636089,85.9234887,107.1495913,1.8,86.9086272,107.2581885,0.2701479,8.814771,21.5686979,2520.3052697,19044.5129478,2.1323319,882.96999,285.9184068,999.1485959,12.2779666,22.6881774,2.221873,57.840376),(11003,'Cervus-giganteus-tibia-cleaned.tif',249,8,13,259.5462329,88.1421762,107.2315532,1.8,88.5248579,107.1949181,0.2894587,10.0292094,20.6171193,4847.4464495,33411.9307832,3.5243031,1620.5916195,483.3328592,1849.5771499,15.1910673,24.6762153,2.1829488,65.7832796),(11004,'Cervus-giganteus-tibia-cleaned.tif',249,8,14,365.5988937,89.5968161,107.1588214,1.8,89.8986474,107.2653948,0.322328,11.5079928,20.3918618,8819.2976017,49464.7118831,6.1144432,2425.7084657,766.3628029,2812.0703046,22.0306586,41.8587574,2.5906102,127.9205357),(11005,'Cervus-giganteus-tibia-cleaned.tif',249,8,15,476.538254,90.5365087,107.1819612,1.8,90.5234614,107.2126457,0.343829,13.3519493,22.1736591,14378.1640741,66662.9355325,9.0250507,3006.4021062,1076.8587976,3595.6463619,25.0677685,44.1074261,2.5292705,134.1446872),(11006,'Cervus-giganteus-tibia-cleaned.tif',249,8,16,552.7172694,90.8836342,107.021456,1.8,90.8574369,107.0692751,0.3431944,14.580743,23.3980474,20305.6744658,83814.9196168,10.4307098,3582.1330879,1392.6364676,4375.2566844,27.6947238,46.1549721,2.5148498,140.4730986),(11007,'Cervus-giganteus-tibia-cleaned.tif',249,8,17,656.0566823,91.1077581,106.6076561,1.8,91.061152,106.6251786,0.3254889,16.1094538,24.9080368,31095.358282,113498.4160179,11.1807538,4556.6985783,1930.255278,5711.9580207,31.3069468,49.0013904,2.5244013,148.7719674),(11008,'Cervus-giganteus-tibia-cleaned.tif',249,8,18,745.8087069,91.0798941,106.2725506,1.8,91.0471893,106.2658442,0.3075471,17.1251195,25.9348941,42517.5613166,142312.0954088,11.3910402,5487.2826977,2482.7599764,7057.5038768,33.688526,51.3130956,2.6629649,156.1072004),(11009,'Cervus-giganteus-tibia-cleaned.tif',249,8,19,890.4315055,90.7170179,104.9910149,1.8,90.5566343,103.9177527,0.3497251,28.7432356,26.638371,74264.327478,185107.2100152,17.4230522,6948.8937531,2583.7149526,8303.8762945,43.7187999,56.5492916,1.8637087,190.5180167),(11010,'Cervus-giganteus-tibia-cleaned.tif',249,8,20,1121.4629829,89.8428727,102.4000162,1.8,89.6314915,102.4598567,0.4618385,28.3687809,29.8826547,146516.4025194,256206.6908384,37.1119493,8573.7593755,5164.7056416,13104.6003746,51.0708956,60.0979769,1.9287302,205.9435989),(11011,'Cervus-giganteus-tibia-cleaned.tif',249,8,21,1330.454965,88.4560662,101.2996414,1.8,88.3110109,101.9377678,0.3343885,30.8521194,32.4692817,228334.890479,347953.175843,23.8838208,10716.3804713,7400.9466641,16521.8049167,54.9614988,65.0817763,3.0024967,221.7072581),(11012,'Cervus-giganteus-tibia-cleaned.tif',249,8,22,1539.5752383,86.5044996,101.7783926,1.8,86.470144,101.9736025,0.0884284,33.8675959,40.6300687,295519.4240441,530084.4850766,2.0012473,13046.6056855,8725.7278281,20044.5709544,58.9431737,77.8696143,0.0496828,249.8075512),(11013,'Cervus-giganteus-tibia-cleaned.tif',249,8,23,1794.0669805,83.7191406,102.5679556,1.8,84.4967045,101.9232768,0.0035135,39.400803,42.8995776,349690.6870358,876540.8560418,0.0036913,20432.3889557,8875.2172663,28439.4469259,64.2870467,85.5953164,3.0963973,278.0195136),(11014,'Cervus-giganteus-tibia-cleaned.tif',249,8,24,2038.2308126,82.2658362,102.9670603,1.8,84.0064679,101.5855922,-0.0370793,42.2795217,47.6047908,439922.4624256,1224607.4013304,0.4668377,25724.4571344,10405.0955341,34936.4261483,69.4108279,92.0625969,0.1451974,303.6712361),(11015,'Cervus-giganteus-tibia-cleaned.tif',249,8,25,2248.3654976,82.785475,103.1963906,1.8,85.6547959,100.8466979,-0.0837463,44.0866884,74.0846253,562371.4389084,1619559.4227656,2.6219913,21860.9382885,12756.0372391,29432.3642109,74.1135271,99.6746504,0.1601877,316.9789153),(11016,'Cervus-giganteus-tibia-cleaned.tif',249,8,26,2596.5085198,88.5779616,103.2479678,1.8,90.4229924,100.751309,-0.1014315,46.3550388,70.1441826,681375.5170772,2710402.3973643,4.437049,38640.4445295,14699.0604446,48029.7775365,77.6797946,123.5956284,0.2854629,391.7551059),(11017,'Cervus-giganteus-tibia-cleaned.tif',249,8,27,2834.6459708,90.8950438,103.2052802,1.8,91.412841,100.7893086,-0.1082087,47.5388543,68.3222507,841399.2517688,3241073.3108929,5.510314,47438.0348443,17699.1907925,58887.7418875,80.8098102,124.9742211,0.36199,391.9025515),(11018,'Cervus-giganteus-tibia-cleaned.tif',249,8,28,2931.4708472,91.4505898,103.1659487,1.8,92.3079654,100.8449371,-0.1151084,50.501137,67.5826511,1005874.1782141,3432016.3064313,6.4450972,50782.5048039,19917.8521276,64083.4687582,85.1489871,125.5880337,0.3455556,396.2173197),(11019,'Cervus-giganteus-tibia-cleaned.tif',249,8,29,2953.2048608,91.7826678,103.4710602,1.8,92.7262419,101.0591811,-0.1182692,52.569387,67.0689295,1137866.9490025,3499327.6465924,6.8526681,52175.0931796,21645.0488409,67219.658584,87.4311277,125.6820873,0.3671738,402.3372115),(11020,'Cervus-giganteus-tibia-cleaned.tif',249,8,30,2953.9297923,91.9414835,103.8221671,1.8,93.0549491,101.2974231,-0.1177495,55.140452,66.656013,1254198.9114696,3516966.3337309,6.7945256,52762.9267831,22745.5319445,68835.0388609,90.8309913,125.2251203,0.3575659,407.3892077),(11021,'Cervus-giganteus-tibia-cleaned.tif',249,8,31,2985.1403396,92.3698147,104.2489115,1.8,93.4473339,101.8495387,-0.1085138,56.1479294,66.3147792,1386385.4096528,3541569.8068907,5.8355045,53405.4376311,24691.6569357,71293.6659199,94.3542788,125.1285099,3.10381,413.0488745),(11022,'Cervus-giganteus-tibia-cleaned.tif',249,8,32,3020.4088136,93.0905465,104.8335663,1.8,93.9605359,102.5610119,-0.0849453,57.5119335,66.1743836,1516331.795017,3575433.6772968,3.6236713,54030.479528,26365.515849,72567.1434951,97.3558206,125.4137013,3.0282869,418.3093903),(11023,'Cervus-giganteus-tibia-cleaned.tif',249,8,33,3064.351848,94.0107368,105.5737545,1.8,94.7945958,102.8861841,-0.0353362,58.7390543,67.1712381,1686623.8789694,3620339.9956658,0.6374527,53897.1753137,28713.8412406,75507.3482682,100.4994311,126.2529811,3.066648,429.4559806),(11024,'Cervus-giganteus-tibia-cleaned.tif',249,8,34,3080.5587135,94.1861575,105.8695573,1.8,95.1728654,103.1519725,-0.006132,59.5390635,67.3367612,1773776.4303132,3687510.545538,0.0193053,54762.2202489,29791.8093948,77361.6877432,101.8632076,126.4925866,3.0906164,427.3201894),(11025,'Cervus-giganteus-tibia-cleaned.tif',249,8,35,3100.4607882,94.2746671,106.2075213,1.8,95.5679574,103.4150964,0.0177511,60.0047882,67.4972802,1867818.2242347,3725163.8747553,0.1628095,55189.8367153,31127.8196195,78843.5628621,102.8785759,126.3253489,2.8801138,428.4312708),(11026,'Cervus-giganteus-tibia-cleaned.tif',249,8,36,3096.6917822,94.4799904,106.2499797,1.8,95.8335321,103.5310048,0.0468355,60.1158414,67.5669403,1970296.3391936,3701699.330659,1.1313002,54785.6587214,32774.9939798,79953.5773939,103.5996699,125.9103155,2.8792316,422.9011615),(11027,'Cervus-giganteus-tibia-cleaned.tif',249,8,37,3057.894995,94.9025385,105.8578139,1.8,96.0170367,103.6454632,0.0928093,59.688151,67.3646869,2032015.3601928,3654235.963851,4.3773083,54245.5718473,34043.8650991,80429.0819798,105.0771878,125.582153,2.8891452,423.5699061),(11028,'Cervus-giganteus-tibia-cleaned.tif',249,8,38,3005.241425,95.3097747,105.4985452,1.8,96.1017906,103.7353263,0.1375897,59.5663632,67.1937411,2034817.9235664,3616541.9522508,9.4223219,53822.6015608,34160.5197238,80117.9186475,106.992312,125.18678,2.9165947,424.490356),(11029,'Cervus-giganteus-tibia-cleaned.tif',249,8,39,2994.2498477,96.0832737,105.5370364,1.8,96.2362552,103.8420751,0.1754684,59.5363291,67.2362359,2036338.2654986,3594090.5709974,15.2080179,53454.666558,34203.2889471,80420.1419612,108.1913045,125.2523937,2.9657281,426.4787016),(11030,'Cervus-giganteus-tibia-cleaned.tif',249,8,40,3040.9297404,97.1756667,105.9638472,1.8,96.374983,103.888101,0.2014634,59.8517628,66.5164773,2027947.7134228,3622827.5255184,20.2938279,54465.1141306,33882.8401824,82075.1636336,108.52078,125.057664,2.9374587,428.050008),(11031,'Cervus-giganteus-tibia-cleaned.tif',249,8,41,2855.6814608,97.1260331,105.1499627,1.8,96.7559636,103.6230787,0.2382514,58.7624904,67.2508029,1945957.3709427,3453850.5547211,26.5091871,51357.7594317,33115.6381879,77937.4052863,107.9177496,125.6277212,2.1417228,428.2153417),(11032,'Cervus-giganteus-tibia-cleaned.tif',249,8,42,2710.5725212,97.105962,104.5363533,1.8,97.1369679,103.5156841,0.2772375,57.9205908,67.4761881,1888698.1798415,3310564.098765,33.8421866,49062.7018735,32608.4066842,75040.4968009,105.835166,126.3290028,2.1503086,427.6255593),(11033,'Cervus-giganteus-tibia-cleaned.tif',249,8,43,2599.2848782,96.9227208,104.2270197,1.8,97.424481,103.4693219,0.3078692,57.4853648,67.2904196,1839713.851241,3160028.0917915,39.7804897,46961.0400792,32003.1691287,72281.9786173,104.0947862,126.7586883,2.1240058,425.5508421),(11034,'Cervus-giganteus-tibia-cleaned.tif',249,8,44,2510.2848643,96.6997632,104.0261698,1.8,97.6782355,103.4118979,0.3456044,56.8097496,67.5809137,1793906.2970298,3039588.7646834,48.0142126,44977.0297353,31577.4371668,69947.3366471,102.8355142,126.9849815,2.1268849,424.6482803),(11035,'Cervus-giganteus-tibia-cleaned.tif',249,8,45,2440.069847,96.7071122,103.8960735,1.8,97.8734062,103.3367122,0.3833127,56.2578097,67.7870282,1755789.3993624,2944137.0104065,56.8829657,43432.1593365,31209.7006337,68025.3638971,101.5065826,127.1244856,2.1222299,425.5940279),(11036,'Cervus-giganteus-tibia-cleaned.tif',249,8,46,2361.0723996,96.55957,103.6229942,1.8,98.2118174,103.2371671,0.4200305,55.8232863,68.0747809,1720614.5964955,2825528.1600172,65.4376289,41506.2395221,30822.5242727,65936.3881205,100.2958661,127.1244856,2.1222299,423.0158999),(11037,'Cervus-giganteus-tibia-cleaned.tif',249,8,47,2288.5098731,96.3302999,103.1471218,1.8,98.2933416,103.006961,0.4416539,55.1254797,68.1338482,1677737.8027667,2704227.505878,69.6854593,39689.9276278,30434.8880209,63576.1605779,98.9568089,126.6012819,2.1088875,422.2607837),(11038,'Cervus-giganteus-tibia-cleaned.tif',249,8,48,2226.857686,96.2249705,102.6069256,1.8,98.3087183,102.7268013,0.462578,54.3404342,68.2703292,1636044.7190987,2608316.0061942,73.9112528,38205.7042257,30107.3177692,61641.9165227,97.9105695,125.4961164,2.1141518,419.2835047),(11039,'Cervus-giganteus-tibia-cleaned.tif',249,8,49,2150.0047086,95.6571742,101.6114996,1.8,98.1502664,101.9628881,0.528002,52.3465458,68.6390768,1590489.2638284,2433758.0879635,90.9534143,35457.3254737,30383.8436435,58368.9120371,96.4166738,124.6635897,2.082247,412.9982791),(11040,'Cervus-giganteus-tibia-cleaned.tif',249,8,50,2082.0583123,95.0114916,100.8401839,1.8,97.7660897,101.3314698,0.5941538,50.7153578,69.0475206,1557190.5359851,2304526.1516037,108.7475497,33375.9435671,30704.5164295,55910.5827987,95.0271506,123.9782056,2.0576956,417.7121983),(11041,'Cervus-giganteus-tibia-cleaned.tif',249,8,51,2031.0827654,94.6094622,100.1353361,1.8,97.3982768,100.7730374,0.6658037,50.66461,68.3950083,1534740.0828305,2210998.6508245,129.1574558,32326.9008401,30292.1522799,54746.5150161,93.4369188,123.7531279,2.0313384,402.8763986),(11042,'Cervus-giganteus-tibia-cleaned.tif',249,8,52,1981.0068229,94.5159962,99.7169557,1.8,97.0145674,100.2438149,0.7411511,51.3275204,66.8829531,1500442.3605515,2132359.7152914,150.4939915,31881.9611838,29232.7069188,54061.2348584,92.4889781,122.4369548,2.0564184,398.6227044),(11043,'Cervus-giganteus-tibia-cleaned.tif',249,8,53,1921.9282908,94.568495,99.3098527,1.8,96.6593815,99.716822,0.8214516,51.9169073,65.910702,1449286.9099694,2073578.0873382,171.6993668,31460.4157566,27915.5093031,52915.8665166,91.6423794,120.518867,2.1350645,393.1104832),(11044,'Cervus-giganteus-tibia-cleaned.tif',249,8,54,1892.7216697,94.8102455,99.1438293,1.8,96.195143,99.1641133,0.8917316,52.2174954,64.6554267,1403745.5425082,2080207.4602911,191.0178073,32173.748871,26882.6670151,52927.9815403,90.847277,120.7492089,2.1380714,391.2874714),(11045,'Cervus-giganteus-tibia-cleaned.tif',249,8,55,1837.6770622,94.167048,98.2126551,1.8,95.5738032,98.4042709,0.9883499,52.1218781,63.7797209,1348433.690531,1974919.4457246,213.6068451,30964.6924923,25870.7809281,50197.4529347,90.1094591,120.6191695,2.14299,390.575541),(11046,'Cervus-giganteus-tibia-cleaned.tif',249,8,56,1752.3786917,92.173107,96.2908394,1.8,94.0045132,96.8983235,1.2187626,50.1235766,59.8261672,1252757.464755,1772873.2549903,257.3390732,29633.7428355,24993.3773814,44681.1032287,89.400549,109.8825724,2.1501224,360.2530851),(11047,'Cervus-giganteus-tibia-cleaned.tif',249,8,57,1705.3822953,91.168293,95.0570814,1.8,93.006136,95.9358812,1.3482807,49.4542083,57.446412,1165071.0357065,1712470.5387187,270.3879636,29809.8781,23558.5823101,42239.3909826,88.7115982,107.9953922,2.1378307,356.2510964),(11048,'Cervus-giganteus-tibia-cleaned.tif',249,8,58,1675.2445705,90.6839093,94.2943251,1.8,92.4181376,95.304306,1.3957485,47.2342004,57.1418117,1106873.600793,1694695.1625393,270.7390583,29657.7079633,23433.7321415,48722.5503008,87.8033144,106.5799487,2.1319597,353.360189),(11049,'Cervus-giganteus-tibia-cleaned.tif',249,8,59,1645.5607602,90.3436215,93.5204982,1.8,92.0233382,94.7378697,1.4281421,46.5059122,56.5557447,1051652.8176281,1685351.013146,268.7166257,29799.8200302,22613.3144947,47938.4570871,87.0634961,105.4838095,1.1910464,357.7002548),(11050,'Cervus-giganteus-tibia-cleaned.tif',249,8,60,1621.3421064,89.9460872,92.858973,1.8,91.6147761,94.2665982,1.4575281,45.4308504,56.1847299,1003879.726514,1673354.4025257,266.7715992,29783.0817484,22096.8728869,47097.172869,86.2960477,105.6621926,1.2091699,350.9726924),(11051,'Cervus-giganteus-tibia-cleaned.tif',249,8,61,1608.87672,89.6909545,92.4806729,1.8,91.2742241,93.9118987,1.4778313,44.9923723,55.864548,969514.1886383,1668024.1548378,265.8353344,29858.366603,21548.4122834,46329.1409215,85.6682163,105.8149777,1.2053718,348.8547894),(11052,'Cervus-giganteus-tibia-cleaned.tif',249,8,62,1590.409346,89.5064914,92.1420037,1.8,91.036007,93.6959636,1.4950947,44.625816,56.0336105,934029.081797,1653441.630786,263.5520878,29508.0330582,20930.2409532,45404.2950425,84.8631156,105.9135161,1.2143998,350.6778012),(11053,'Cervus-giganteus-tibia-cleaned.tif',249,8,63,1572.5948413,89.3327303,91.9740727,1.8,90.8324273,93.554744,1.5086999,44.2845263,56.0921494,903181.1044236,1633373.2017039,261.0897918,29119.4618123,20394.9591391,44575.3872984,84.2287605,105.8751581,1.2272264,341.1635912),(11054,'Cervus-giganteus-tibia-cleaned.tif',249,8,64,1548.5046465,89.2166246,91.9051665,1.8,90.6456344,93.5184075,1.5157414,44.0519855,56.3870096,872256.69258,1602192.2709645,257.3026323,28414.2089237,19800.621544,43331.1462569,83.4813836,106.180765,1.3670516,346.1292158),(11055,'Cervus-giganteus-tibia-cleaned.tif',249,8,65,1508.5565402,89.1316401,92.0515164,1.8,90.3603833,93.4668574,1.5178443,43.5017115,56.2272654,829144.6223147,1535203.5258335,250.7217711,27303.5424265,19060.0459805,41600.2414603,82.486574,105.252512,1.3693976,334.853068),(11056,'Cervus-giganteus-tibia-cleaned.tif',249,8,66,1476.5147023,89.0669726,92.2903935,1.8,90.310546,93.5705707,1.5203272,42.9839169,56.0661484,803348.5949261,1481006.8213429,245.459501,26415.3480149,18689.5158116,40321.2942794,81.8084412,104.4954925,1.2399433,328.8806218),(11057,'Cervus-giganteus-tibia-cleaned.tif',249,8,67,1446.0281913,88.9683497,92.4743241,1.8,90.0856722,93.5809192,1.5168323,42.9004475,55.7547509,778300.8332644,1420328.4193566,240.303545,25474.5720484,18142.0213403,39039.3823666,81.135387,103.6866615,1.2634615,330.7468194),(11058,'Cervus-giganteus-tibia-cleaned.tif',249,8,68,1416.9339718,88.8392535,92.6890613,1.8,89.8230958,93.5169555,1.5128143,42.7864421,55.4119761,752161.4321479,1366405.9635226,235.3626176,24659.0368998,17579.4339259,37814.1414355,80.4969548,103.0481055,1.2173941,322.300505),(11059,'Cervus-giganteus-tibia-cleaned.tif',249,8,69,1386.0009876,88.644203,92.8694916,1.8,89.582759,93.5352336,1.5106173,42.1788471,55.1613362,726022.4026097,1313731.1821285,230.1646016,23816.1595349,17212.9504052,36525.2372115,79.7841999,102.6090985,1.2291808,319.722377),(11060,'Cervus-giganteus-tibia-cleaned.tif',249,8,70,1361.3232162,88.469278,93.1707742,1.8,89.3251275,93.6734158,1.504219,41.6316854,54.9752192,703450.3338974,1267585.2920329,225.8830001,23057.394066,16896.9938992,35448.8946696,79.0714451,102.0606241,1.2317372,313.6024852),(11061,'Cervus-giganteus-tibia-cleaned.tif',249,8,71,1337.5601553,88.278565,93.4831387,1.8,89.1089176,93.8519946,1.4949393,41.126947,54.4728035,683755.2746263,1217087.1232731,221.6463678,22343.0234053,16625.4809608,34391.4886687,78.4821602,101.2505775,1.2289143,309.5573106),(11062,'Cervus-giganteus-tibia-cleaned.tif',249,8,72,1316.6987786,88.0262368,93.8731143,1.8,88.8297892,93.968234,1.4894214,40.5469822,54.3059819,666663.5283813,1166367.064992,217.9998311,21477.6903694,16441.7545138,33233.2923552,77.59666,100.5598451,1.2625585,310.0607214),(11063,'Cervus-giganteus-tibia-cleaned.tif',249,8,73,1293.8375041,87.7329784,94.2943217,1.8,88.5028719,94.0525605,1.4819743,40.1501696,53.8210233,649508.8324096,1114160.763046,213.9427951,20701.2184861,16176.9884972,32267.9776811,77.0059853,99.6468614,1.3446439,309.809016),(11064,'Cervus-giganteus-tibia-cleaned.tif',249,8,74,1273.7330058,87.4869719,94.6031121,1.8,88.204481,94.1650873,1.4755239,39.7108738,52.6862403,631546.5543415,1070612.4147551,210.3677447,20320.5316834,15903.6176709,31719.6593671,76.5568317,97.9961868,1.2726198,301.8661125),(11065,'Cervus-giganteus-tibia-cleaned.tif',249,8,75,1258.5369154,87.2526144,94.7950745,1.8,87.914393,94.17054,1.4661427,39.4442652,51.906358,614987.0825878,1037544.4588303,207.4671985,19988.7739902,15591.2926663,31165.12083,75.8128558,97.1750598,1.2700217,300.7982169),(11066,'Cervus-giganteus-tibia-cleaned.tif',249,8,76,1245.9187881,87.0222533,95.017584,1.8,87.5490594,94.1913359,1.4597182,39.1340734,51.230686,600289.6574227,1007331.9048243,205.1015527,19662.6667322,15339.3093293,30668.6063557,75.3080535,96.5125545,1.2208842,292.7510535),(11067,'Cervus-giganteus-tibia-cleaned.tif',249,8,77,1234.9471286,86.7881843,95.1771621,1.8,87.2502067,94.1388815,1.4556667,38.8468418,50.8599588,586449.374522,984134.3593319,203.1083832,19349.8851189,15096.4492318,30157.1057284,74.7334897,95.8165702,1.2703192,292.2476427),(11068,'Cervus-giganteus-tibia-cleaned.tif',249,8,78,1224.2604175,86.5841104,95.3168525,1.8,86.9373553,94.1838693,1.4524676,38.6225982,50.4739163,573678.4265668,960694.6996846,201.199759,19033.4883897,14853.439521,29829.8650035,74.3472886,95.2561216,1.2590312,290.6331505),(11069,'Cervus-giganteus-tibia-cleaned.tif',249,8,79,1218.1484903,86.3412004,95.4674384,1.8,86.639433,94.0870679,1.4494599,38.2896725,49.8312845,564840.7578848,941358.8066513,200.0503512,18890.9199695,14751.7782366,29481.8430448,73.9610876,94.6192099,1.2806444,283.0893979),(11070,'Cervus-giganteus-tibia-cleaned.tif',249,8,80,1210.6158495,86.0918172,95.6262102,1.8,86.3797391,94.1826574,1.4506007,37.9532153,49.4932586,555340.5800827,924741.274769,198.868358,18684.1865166,14632.2406437,29135.3582416,73.5628927,94.4580893,1.2706252,282.2300219),(11071,'Cervus-giganteus-tibia-cleaned.tif',249,8,81,1196.9141015,85.8374662,95.7647828,1.8,86.0350687,94.319765,1.4453358,37.7109463,48.7966955,539038.6171607,895780.4778898,196.3621491,18357.4004214,14293.9562661,28632.3568755,72.9776699,93.7665465,1.234554,279.9035993),(11072,'Cervus-giganteus-tibia-cleaned.tif',249,8,82,1190.645461,85.6558782,96.0027718,1.8,85.7969722,94.3907322,1.4422178,37.4911727,48.5044063,530187.6627358,879941.2966865,195.1782379,18141.4713291,14141.6665444,28415.7851636,72.5945932,93.3610281,1.2330355,277.9331419),(11073,'Cervus-giganteus-tibia-cleaned.tif',249,8,83,1182.6051387,85.4862022,96.2469309,1.8,85.5971474,94.6333167,1.440927,37.2909846,48.2320804,520512.4038373,863368.3170236,193.7951925,17900.2918793,13958.1298201,28010.1907892,72.0223233,92.955727,1.2315037,275.9626845),(11074,'Cervus-giganteus-tibia-cleaned.tif',249,8,84,1174.781563,85.3059768,96.5226292,1.8,85.4063963,94.9082234,1.4412915,37.140745,48.0038624,511990.220084,847432.8362603,192.5314344,17653.4302305,13785.1359852,27647.9107978,71.6267374,92.6732526,1.2402483,273.9311531),(11075,'Cervus-giganteus-tibia-cleaned.tif',249,8,85,1164.5880985,85.0825558,96.748419,1.8,85.1392457,95.1138328,1.441121,37.2220969,47.6600391,503907.4382023,826605.3317809,190.8523785,17343.7820767,13537.8573511,27211.3324125,70.9191937,92.1457876,1.2283997,272.8200717),(11076,'Cervus-giganteus-tibia-cleaned.tif',249,8,86,1162.3824761,84.8437438,96.9601507,1.8,84.9103844,95.3160934,1.4357328,37.0276305,47.2179249,499399.9877887,810165.2841723,190.2177877,17158.0027256,13487.2251099,27035.6221749,70.7103456,91.5971464,1.2312435,271.6047305),(11077,'Cervus-giganteus-tibia-cleaned.tif',249,8,87,1161.7982564,84.728018,97.2284495,1.8,84.7493347,95.5845138,1.4278643,36.8661358,46.9708255,494339.6258076,796628.2344422,189.7040678,16960.0646082,13409.0437101,26763.4478773,70.4500713,91.3367518,1.2252407,270.137684),(11078,'Cervus-giganteus-tibia-cleaned.tif',249,8,88,1159.8437332,84.6854556,97.5144796,1.8,84.6157004,95.8457275,1.4156238,36.632579,46.5059323,490228.4930107,782079.278113,188.6899762,16816.7637788,13382.3090267,26510.5279873,70.1413817,90.6763858,1.2175719,268.9223428),(11079,'Cervus-giganteus-tibia-cleaned.tif',249,8,89,1158.237157,84.5987322,97.8191503,1.8,84.4704007,96.185847,1.4020744,36.6956612,46.2221025,486085.8065061,768779.3168875,187.5962012,16632.2879261,13246.4109027,26314.8887132,69.8511997,90.1249454,1.220396,268.6706374),(11080,'Cervus-giganteus-tibia-cleaned.tif',249,8,90,1156.7087416,84.4951779,98.0827974,1.8,84.3473614,96.464555,1.3885917,36.7601937,45.911381,481685.7485646,756348.220108,186.4551339,16474.0899364,13103.4605768,26078.6521853,69.5683858,89.3720052,1.2018966,267.4552962),(11081,'Cervus-giganteus-tibia-cleaned.tif',249,8,91,1156.4645241,84.3805203,98.3898229,1.8,84.1844003,96.7420321,1.375867,36.7865457,45.6388162,478334.7209874,744864.430895,185.512597,16320.8534631,13002.9800651,25857.145287,69.5520013,88.7667188,1.2199575,266.3442148),(11082,'Cervus-giganteus-tibia-cleaned.tif',249,8,92,1156.4401303,84.1384083,98.721849,1.8,83.969412,97.0568789,1.3696205,36.6541967,45.4276551,476220.2895474,733178.6134203,185.0441696,16139.4774297,12992.2446214,25632.0574034,69.3362758,88.4155498,1.2029247,265.6322844),(11083,'Cervus-giganteus-tibia-cleaned.tif',249,8,93,1162.3390596,83.8885552,99.0672755,1.8,83.7037362,97.4139557,1.3672948,36.38683,45.1818579,475531.367063,725447.5107766,185.8106805,16056.1682337,13068.7770111,25479.6226288,68.7960281,88.0147458,1.2011689,264.981428),(11084,'Cervus-giganteus-tibia-cleaned.tif',249,8,94,1164.9289399,83.5968907,99.3119868,1.8,83.3947681,97.6469047,1.3665288,36.1362303,44.8603629,472135.2612529,714898.2783108,186.1657194,15936.0787961,13065.4265099,25292.567336,68.394121,87.4591899,1.2039752,262.4464858),(11085,'Cervus-giganteus-tibia-cleaned.tif',249,8,95,1165.374518,83.3834742,99.583343,1.8,83.1610088,97.856215,1.3608872,36.0411504,44.6018363,468984.6177594,704831.2246178,185.7959548,15802.7400483,13012.47635,25078.2471058,68.0167465,87.1324204,1.186627,262.1947804),(11086,'Cervus-giganteus-tibia-cleaned.tif',249,8,96,1164.5042309,83.2124639,99.8768263,1.8,82.9144541,98.2266357,1.3517217,36.0342477,44.2375185,466210.2993649,693776.9265791,184.9172943,15682.9982716,12937.9778711,24874.2104852,67.7940345,86.4538236,1.2207514,260.8751794),(11087,'Cervus-giganteus-tibia-cleaned.tif',249,8,97,1163.1070719,83.0232177,100.2495443,1.8,82.7474671,98.6351014,1.3386763,35.8481054,43.8825118,461420.042559,676964.2259129,183.5927775,15426.7428713,12871.5321799,24458.0742491,67.3211928,85.8795725,1.2395524,259.6598382),(11088,'Cervus-giganteus-tibia-cleaned.tif',249,8,98,1164.4248392,82.8511223,100.5593751,1.8,82.595982,98.8069041,1.3300526,35.820542,43.7144257,458741.0505393,668846.8546124,183.0385653,15300.3692496,12806.6473898,24275.5979669,67.0695644,85.6147275,1.2331741,259.2606872),(11089,'Cervus-giganteus-tibia-cleaned.tif',249,8,99,1164.4391622,82.7019397,100.8913452,1.8,82.4705899,99.2069858,1.3234829,35.7877543,43.3955947,455198.3451859,659357.6484908,182.4429621,15194.1148101,12719.388346,24065.1840015,66.782431,85.0673726,1.2362669,256.725745),(11090,'Cervus-giganteus-tibia-cleaned.tif',249,8,100,1163.2632256,82.5249778,101.2329329,1.8,82.3022769,99.6963825,1.3161167,35.6365782,43.2494884,452569.5712642,649155.2206808,181.5715384,15009.5468083,12699.5798582,23820.5704348,66.7259528,84.8043454,1.2298174,257.6893808),(11091,'Cervus-giganteus-tibia-cleaned.tif',249,8,101,1159.1331806,82.3749165,101.6201836,1.8,82.1417384,100.2039408,1.3043651,35.6649297,43.0949989,449447.5756365,636889.6043265,179.7966696,14778.7358268,12601.9476046,23498.5098156,66.5054549,84.520842,1.2393998,254.2950626),(11092,'Cervus-giganteus-tibia-cleaned.tif',249,8,102,1159.0278286,82.2765725,101.9648305,1.8,82.0709225,100.6108321,1.2903758,35.7252926,42.759425,446947.9738832,627176.5527512,178.3751628,14667.5628376,12510.687563,23299.953319,66.3965102,84.11465,1.2377377,253.4356866),(11093,'Cervus-giganteus-tibia-cleaned.tif',249,8,103,1159.1953959,82.1702345,102.2908969,1.8,81.9334934,100.9261335,1.2773522,35.7549795,42.5343122,444075.9691412,619516.8751062,177.0350117,14565.1085646,12419.975493,23115.6860917,66.318344,83.8376236,1.247425,252.6805704),(11094,'Cervus-giganteus-tibia-cleaned.tif',249,8,104,1161.542961,82.0095357,102.6296831,1.8,81.7781977,101.274153,1.2638929,35.6645883,42.2991213,442570.3743353,613152.0036755,175.9216138,14495.6203618,12409.2382919,23007.8516916,66.2234001,83.3074059,1.2669884,251.569489),(11095,'Cervus-giganteus-tibia-cleaned.tif',249,8,105,1164.9191489,81.8165825,102.9667188,1.8,81.6402446,101.6532128,1.2554105,35.6083141,42.1381109,441219.1009994,606961.9892752,175.4729964,14404.1100959,12390.9011667,22904.7226318,66.1144554,82.8974955,1.2326538,249.8939228),(11096,'Cervus-giganteus-tibia-cleaned.tif',249,8,106,1169.6367705,81.6665347,103.2741725,1.8,81.4892208,101.9383256,1.2436037,35.5092771,41.9138621,440271.2810533,602584.0681061,174.8043897,14376.7249762,12398.7677778,22679.1081869,65.9525577,82.8094731,1.2867947,249.9981826),(11097,'Cervus-giganteus-tibia-cleaned.tif',249,8,107,1172.4879328,81.5240048,103.6202189,1.8,81.4177613,102.3137378,1.2334462,35.3832883,41.7651687,438884.9280417,597207.4291632,174.0064147,14299.1743592,12403.7349171,22539.6998072,65.5546903,82.6901037,1.2917829,248.4268762),(11098,'Cervus-giganteus-tibia-cleaned.tif',249,8,108,1173.8887285,81.3500294,103.9709041,1.8,81.2600609,102.6351791,1.2229052,35.3320242,41.5701185,437431.9122406,590993.5877611,172.9091615,14216.7886087,12380.6071792,22400.4180981,65.3431018,82.4877863,1.2638717,248.531136),(11099,'Cervus-giganteus-tibia-cleaned.tif',249,8,109,1183.584918,81.1943374,104.2826864,1.8,81.1267085,102.9722645,1.2136823,35.1683971,41.2885384,438158.4744013,589654.8944917,173.1583912,14281.3215774,12458.8696425,22434.3342505,65.0823177,82.4575638,1.3018021,247.9234654),(11100,'Cervus-giganteus-tibia-cleaned.tif',249,8,110,1186.0274286,81.0751771,104.6191075,1.8,80.9639779,103.2728431,1.2032552,35.0955617,41.0734753,436639.6314029,584855.7826141,172.1494655,14239.2572967,12441.4487315,22361.0455564,64.7575319,82.2771178,1.2903446,246.7081242),(11101,'Cervus-giganteus-tibia-cleaned.tif',249,8,111,1190.8768102,80.9605523,104.9778935,1.8,80.884063,103.671636,1.1925213,34.964105,40.9255537,436283.133341,580946.7191455,171.4077061,14195.2073047,12478.0294927,22320.8287333,64.4327461,82.0434075,1.3004102,246.812384),(11102,'Cervus-giganteus-tibia-cleaned.tif',249,8,112,1194.7977737,80.8702237,105.2892508,1.8,80.7666643,104.1146476,1.1823852,34.9297267,40.756123,435916.0683299,577611.2263042,170.5717946,14172.3791121,12479.8018491,22291.7564521,64.2022652,82.0434075,1.3004102,246.4564188),(11103,'Cervus-giganteus-tibia-cleaned.tif',249,8,113,1196.5055057,80.698021,105.5877788,1.8,80.616583,104.4745455,1.1744945,34.7174745,40.5877622,431737.4158026,570733.8353904,169.7037122,14061.7221751,12435.7379587,22101.569602,63.945279,81.8643039,1.2888918,247.5243144),(11104,'Cervus-giganteus-tibia-cleaned.tif',249,8,114,1196.4044059,80.5974464,105.8513941,1.8,80.4635272,104.6245567,1.1623768,34.6732668,40.3922929,429289.9826941,566801.5078865,167.9481568,14032.4172688,12381.0077002,21877.2369905,63.9133213,81.7458128,1.2939407,244.9893722),(11105,'Cervus-giganteus-tibia-cleaned.tif',249,8,115,1194.9902943,80.4918893,106.0909932,1.8,80.366004,104.9198634,1.1448818,34.6334366,40.0048562,425347.9749509,560700.1484583,165.1683616,14015.8021123,12281.4255987,21763.2126528,63.6748639,81.2155788,1.2975838,244.2774418),(11106,'Cervus-giganteus-tibia-cleaned.tif',249,8,116,1194.7481469,80.3924787,106.2933818,1.8,80.3014718,105.1687624,1.1320999,34.7205174,39.6819664,421147.5694749,556512.8031376,163.1984589,14024.3252541,12129.6455451,21701.9167265,63.5227153,80.6864369,1.3012748,243.6697712),(11107,'Cervus-giganteus-tibia-cleaned.tif',249,8,117,1190.8302606,80.2877498,106.4807514,1.8,80.1848058,105.4159047,1.1188161,34.663117,39.3367745,415184.5601317,549740.5853343,160.6135114,13975.2328963,11977.7041393,21529.6967403,63.2205195,80.2723429,1.2998495,241.6993138),(11108,'Cervus-giganteus-tibia-cleaned.tif',249,8,118,1191.829678,80.191989,106.67291,1.8,80.1133093,105.6504444,1.1064227,34.5971703,39.0222263,411066.9882262,546042.8601944,158.7951921,13993.1242283,11881.5204918,21483.6991958,62.9992138,79.5619286,1.2917548,240.2322672),(11109,'Cervus-giganteus-tibia-cleaned.tif',249,8,119,1194.4748919,80.0924277,106.8585053,1.8,79.9967619,105.879098,1.0921132,34.5613063,38.6782623,407064.3033473,543438.7067762,156.8420644,14050.2358221,11778.0358205,21466.3986197,62.5999162,78.9153334,1.3007239,239.7720422),(11110,'Cervus-giganteus-tibia-cleaned.tif',249,8,120,1196.5401941,79.9796141,107.1008816,1.8,79.9060717,106.1740274,1.0826367,34.4348109,38.4523603,403491.7828224,540390.9599664,155.5577663,14053.5185734,11717.5547758,21402.4650703,62.3396495,78.5013047,1.2992635,238.6609608),(11111,'Cervus-giganteus-tibia-cleaned.tif',249,8,121,1196.2101508,79.8491027,107.3472723,1.8,79.8210874,106.4212933,1.0748105,34.3329981,38.2419917,399419.803763,536187.881656,154.2154503,14020.9193535,11633.7001047,21315.1407377,62.1723693,77.9726862,1.3030943,237.9058446),(11112,'Cervus-giganteus-tibia-cleaned.tif',249,8,122,1197.4511561,79.7426154,107.5704874,1.8,79.7496378,106.6746855,1.0656652,34.2248458,38.021646,395626.8702471,532455.6677285,152.8385387,14004.0141236,11559.6392174,21092.2229534,61.9514839,77.5583864,1.3016288,237.1939142),(11113,'Cervus-giganteus-tibia-cleaned.tif',249,8,123,1196.3428619,79.6917073,107.8846795,1.8,79.664809,106.9989391,1.0515432,34.2671877,37.6993138,391548.1226759,527902.9127057,150.2913649,14002.9846643,11426.3278995,21126.031851,61.7362349,77.0304879,1.3055228,236.0828328),(11114,'Cervus-giganteus-tibia-cleaned.tif',249,8,124,1198.8664426,79.5915844,108.092349,1.8,79.5699556,107.2054254,1.0414598,34.2138291,37.4721966,387353.0545991,524958.2143875,148.8621704,14009.2725401,11321.5347362,21089.9903639,61.4157872,76.5037734,1.3094703,234.9717514),(11115,'Cervus-giganteus-tibia-cleaned.tif',249,8,125,1202.9504975,79.5030633,108.3428811,1.8,79.5267361,107.5013617,1.0341542,34.067788,37.1972737,384564.8692332,522810.4441065,148.0872847,14055.0742524,11288.2253946,21070.2987583,61.0825109,76.1809074,1.3258177,234.1123754),(11116,'Cervus-giganteus-tibia-cleaned.tif',249,8,126,1204.6778117,79.4553897,108.5312167,1.8,79.4804694,107.6674072,1.0314741,33.9505698,37.2103883,380317.6696034,521272.0684581,147.8263536,14008.77799,11202.0997513,21060.5099435,60.7630976,75.7641205,1.3244421,234.4683406),(11117,'Cervus-giganteus-tibia-cleaned.tif',249,8,127,1210.3213338,79.3652332,108.7302,1.8,79.3992277,107.9163177,1.0229415,33.6891508,37.0964532,376940.5398342,520465.1144591,146.9950884,14030.050586,11188.7812797,21084.723164,60.4039712,75.2432643,1.3285877,231.3257279),(11118,'Cervus-giganteus-tibia-cleaned.tif',249,8,128,1208.5295104,79.3078098,109.0131478,1.8,79.314382,108.2309011,1.0087599,33.5943044,36.8535866,372741.6212087,515954.84519,144.219146,14000.125716,11095.3814389,21145.4769465,60.0974868,74.7323667,1.3090828,230.3620921),(11119,'Cervus-giganteus-tibia-cleaned.tif',249,8,129,1200.8159864,79.2366844,109.4179464,1.8,79.2508491,108.5873049,0.9854943,33.4633384,36.4850996,365404.7859185,504366.2461415,139.0540262,13823.8966408,10919.5556399,20898.7418251,59.7535061,73.79133,1.3116943,228.1399293),(11120,'Cervus-giganteus-tibia-cleaned.tif',249,8,130,1199.7867481,79.1931609,109.7038404,1.8,79.1718494,108.9132084,0.965109,33.5129156,35.9719664,361003.1317067,499111.3117976,135.149263,13875.0077164,10772.0598205,20752.5755503,59.5080262,72.9065445,1.3930514,226.525437),(11121,'Cervus-giganteus-tibia-cleaned.tif',249,8,131,1198.3302831,79.1871769,110.0444534,1.8,79.2075366,109.2811884,0.9411016,33.4394321,35.4424614,355812.3219321,493420.9714978,130.4580438,13921.7467428,10640.5013467,20703.0891014,59.1295946,72.2655507,1.4095577,226.2737316),(11122,'Cervus-giganteus-tibia-cleaned.tif',249,8,132,1198.4366982,79.1828976,110.3836613,1.8,79.2014136,109.7205309,0.9178619,33.3329489,34.8298844,350862.4965408,487444.505188,126.0195335,13995.0078344,10525.9962995,20514.8623434,58.8252358,71.7733322,1.4145057,225.7703208),(11123,'Cervus-giganteus-tibia-cleaned.tif',249,8,133,1194.1264414,79.1587327,110.6935968,1.8,79.1643423,110.0813736,0.8956699,33.1959473,34.2810028,345280.8900591,480493.0422495,121.2794601,14016.3064764,10401.2964791,20407.6508371,58.3726669,70.9935086,1.4066427,224.3032742),(11124,'Cervus-giganteus-tibia-cleaned.tif',249,8,134,1191.8564216,79.1188807,111.0004619,1.8,79.1585086,110.4285402,0.8730638,33.0232451,33.8811977,340498.6679003,474580.5619756,116.6464333,14007.1955742,10310.8784914,20397.6218288,58.0460605,70.3075144,1.4297636,222.8794135),(11125,'Cervus-giganteus-tibia-cleaned.tif',249,8,135,1192.5871159,79.0936253,111.2655733,1.8,79.1310897,110.7323398,0.857595,32.8114854,33.8689196,336321.3624943,470074.8574706,113.6826079,13879.2398076,10250.110852,20264.7213939,57.667114,69.9072136,1.478467,221.8725919),(11126,'Cervus-giganteus-tibia-cleaned.tif',249,8,136,1192.1013105,79.0871256,111.5819174,1.8,79.135705,111.0587071,0.8417016,32.5854987,33.787862,332248.8784416,465476.6271962,110.5047195,13776.445157,10196.2189312,20264.0716234,57.2760145,69.4567758,1.7135683,219.5461693),(11127,'Cervus-giganteus-tibia-cleaned.tif',249,8,137,1191.962445,79.0717866,111.8944419,1.8,79.1167176,111.3822419,0.8233203,32.6089026,33.68577,327890.3269576,461187.1244758,106.8566036,13690.8589323,10055.2395505,20134.9737342,57.1446138,68.971282,1.7082881,220.8657702),(11128,'Cervus-giganteus-tibia-cleaned.tif',249,8,138,1187.6340607,79.0418741,112.1795912,1.8,79.1179775,111.8206433,0.807699,32.4455525,33.8910368,322907.304281,455586.6665367,103.3822529,13442.6889718,9952.2824914,20128.7351248,56.7831688,68.4971731,1.9839252,216.8637815),(11129,'Cervus-giganteus-tibia-cleaned.tif',249,8,139,1183.2233195,79.0049354,112.4521214,1.8,79.1411271,112.1404773,0.7942204,32.2472002,33.8092197,318191.0407759,449430.6232637,100.3416342,13293.1379949,9867.2455016,20082.2353798,56.4956514,68.4971731,1.9839252,215.7527001),(11130,'Cervus-giganteus-tibia-cleaned.tif',249,8,140,1180.6803245,78.9707512,112.7891091,1.8,79.1906582,112.5268717,0.7773387,32.0103772,33.6936192,314121.4036287,444224.0563629,96.8041583,13184.2190699,9813.1115855,19960.1080838,56.2167362,68.2446817,2.0062824,215.6052545),(11131,'Cervus-giganteus-tibia-cleaned.tif',249,8,141,1183.4155603,78.9375463,113.1130284,1.8,79.2493744,112.9644065,0.7568226,31.7881926,33.6353425,310915.072256,440326.5389388,92.9849061,13091.1864069,9780.8351647,19983.3645417,55.8418144,67.9029408,2.0797387,212.3583819),(11132,'Cervus-giganteus-tibia-cleaned.tif',249,8,142,1180.7486942,78.8973135,113.4262446,1.8,79.2279395,113.4010598,0.7353997,31.5480548,33.8140204,306374.5855099,434536.5482012,88.5728353,12850.7803416,9711.3621673,19958.0149864,55.586551,67.663241,2.0600065,210.6396299),(11133,'Cervus-giganteus-tibia-cleaned.tif',249,8,143,1175.2148322,78.8715814,113.7397786,1.8,79.2729958,113.8224952,0.7169395,31.3378522,33.7462954,301922.3433257,428394.3303618,84.5674808,12694.5587829,9634.4299832,19735.8366759,55.1485294,67.6946136,2.0741957,213.8254285),(11134,'Cervus-giganteus-tibia-cleaned.tif',249,8,144,1170.2280398,78.8291627,113.9738147,1.8,79.2923817,114.2163014,0.7043333,31.1813897,33.6840925,297788.8832246,422800.2633987,81.777456,12551.9267949,9550.2120296,19762.2892052,54.8473571,67.6946136,2.0741957,209.7802539),(11135,'Cervus-giganteus-tibia-cleaned.tif',249,8,145,1169.3837131,78.8687665,114.2917794,1.8,79.3019522,114.3860897,0.6874715,30.9614126,33.5230618,292889.6510485,415966.9635505,78.4847754,12408.3822115,9459.8284288,19580.2059039,54.6363334,67.1537874,2.0859742,207.6012769),(11136,'Cervus-giganteus-tibia-cleaned.tif',249,8,146,1167.3212083,78.8704877,114.5936196,1.8,79.2277431,114.650597,0.669501,30.7828413,33.4741422,289527.1727799,411166.0854193,74.9299332,12283.0955094,9405.4726675,19564.4019152,54.2744095,66.5683655,2.0835374,209.0251377),(11137,'Cervus-giganteus-tibia-cleaned.tif',249,8,147,1164.7902423,78.8666761,114.9153922,1.8,79.2067445,114.9968565,0.6528735,30.5107102,33.4507297,285393.1680493,405762.5239736,71.6387918,12130.154629,9353.8684046,19485.4671142,53.9610508,65.1569113,2.0137979,207.3063857),(11138,'Cervus-giganteus-tibia-cleaned.tif',249,8,148,1165.0999761,78.8862555,115.2353014,1.8,79.2093798,115.2947363,0.6350036,30.3276595,33.3766297,281963.2589443,402067.6290896,68.3259317,12046.3819296,9297.231089,19441.7303666,53.7316265,65.4481263,2.0931998,210.4489985),(11139,'Cervus-giganteus-tibia-cleaned.tif',249,8,149,1159.6086914,78.9016227,115.5354232,1.8,79.2301193,115.5885511,0.6161867,30.0589045,33.237553,277506.8811642,396567.9081645,64.5515645,11931.3208377,9232.1022923,19355.102996,53.5540965,64.385847,2.19027,205.900413),(11140,'Cervus-giganteus-tibia-cleaned.tif',249,8,150,1160.3090053,78.9177206,115.8414319,1.8,79.2743368,115.8434938,0.59674,29.8801441,33.2069123,274007.7408225,393064.0730553,61.0683267,11836.8148504,9170.2282191,19270.4519446,53.244002,64.0364878,2.1941659,205.900413),(11141,'Cervus-giganteus-tibia-cleaned.tif',249,8,151,1159.7658522,78.9269364,116.1387601,1.8,79.2872114,116.1506081,0.5757121,29.5981122,33.2113124,270207.5342863,389551.9164639,57.293681,11729.4948147,9129.2151439,19128.2718332,53.0664323,63.8516946,2.2129515,202.7578003),(11142,'Cervus-giganteus-tibia-cleaned.tif',249,8,152,1157.9701123,78.915422,116.4426444,1.8,79.302675,116.4538129,0.5591826,29.3950683,33.1454081,267003.5469087,385612.7802517,54.3133014,11633.972928,9083.2769606,19052.6877008,52.7057181,63.5386374,2.1831843,204.7893316),(11143,'Cervus-giganteus-tibia-cleaned.tif',249,8,153,1157.5323112,78.9236834,116.7561271,1.8,79.2776296,116.7537235,0.5359767,29.1164043,33.1318186,263152.2201213,381558.7266239,50.3131336,11516.3834292,9037.9367334,18943.2066768,52.5830182,63.0485699,2.1720307,201.603533),(11144,'Cervus-giganteus-tibia-cleaned.tif',249,8,154,1157.7051377,78.9415772,117.0737934,1.8,79.3129164,117.1299651,0.5152583,28.8643358,33.0549739,259575.8680548,378104.6372591,46.8507922,11438.6608935,8992.9617727,19027.3166093,52.3773351,62.6770319,2.2444666,201.3950135),(11145,'Cervus-giganteus-tibia-cleaned.tif',249,8,155,1155.1577787,78.9461374,117.3544071,1.8,79.2896486,117.3804444,0.4997327,28.7409227,33.1019226,256207.641259,374824.0664809,44.2086452,11323.3322154,8914.3847035,18898.2638146,52.0613192,62.4882186,2.1950426,197.8532497),(11146,'Cervus-giganteus-tibia-cleaned.tif',249,8,156,1153.9839682,78.9500675,117.6497497,1.8,79.3455645,117.7204198,0.4844659,28.6605827,32.9996883,252802.9936946,371811.7824233,41.7184028,11267.1301191,8820.5810861,18739.296917,51.8682729,62.2232141,2.2681871,199.8237071),(11147,'Cervus-giganteus-tibia-cleaned.tif',249,8,157,1157.4557729,78.9711644,117.961271,1.8,79.3643392,118.0085231,0.4665242,28.5805784,32.8431541,250813.0454092,370239.8908805,39.0267527,11272.9700101,8775.6462314,18675.2314044,51.5538251,62.0077154,2.2531129,194.6674511),(11148,'Cervus-giganteus-tibia-cleaned.tif',249,8,158,1158.1806485,79.00686,118.2579868,1.8,79.4280475,118.2739656,0.4485812,28.5694736,32.9321573,247641.0313291,368048.0245686,36.3060495,11175.9464083,8668.0291841,18557.0537291,51.1838535,61.8944646,2.2726456,195.0234163),(11149,'Cervus-giganteus-tibia-cleaned.tif',249,8,159,1161.0186067,79.0404167,118.5651251,1.8,79.4039716,118.5436822,0.4323864,28.527038,32.8339758,245305.2233752,366792.266623,33.9778904,11171.1194745,8599.0429003,18520.9084252,51.1668041,61.4694178,2.2422622,193.3046643),(11150,'Cervus-giganteus-tibia-cleaned.tif',249,8,160,1162.6189167,79.0557263,118.8337805,1.8,79.4600041,118.9378848,0.4180821,28.4854843,32.8483141,243315.1227326,365250.4376021,31.9415786,11119.3054346,8541.7232239,18444.5047293,50.8933472,61.133595,2.246635,193.5563697),(11151,'Cervus-giganteus-tibia-cleaned.tif',249,8,161,1165.9049147,79.1874511,119.1295208,1.8,79.6505243,119.3011889,0.4005499,28.2760604,32.7492226,239891.5280046,362236.4136812,29.5442829,11060.9164194,8483.9091662,18299.8102506,51.0600024,60.7381885,2.2610056,192.2367687),(11152,'Cervus-giganteus-tibia-cleaned.tif',249,8,162,1169.1342923,79.2382342,119.405905,1.8,79.5995898,119.4705254,0.3850145,28.2750964,32.7131173,238311.9398843,361698.5640126,27.4853301,11056.6828739,8428.3334215,18239.3035148,50.6483905,60.3554883,2.2755616,188.9467103),(11153,'Cervus-giganteus-tibia-cleaned.tif',249,8,163,1175.0258924,79.2695638,119.6985718,1.8,79.6798993,119.8207597,0.3698054,28.1677247,32.6923773,237039.8919664,361204.3630598,25.5831568,11048.5805269,8415.3013636,18245.5018082,51.0144972,60.5250287,2.3109992,190.4137569),(11154,'Cervus-giganteus-tibia-cleaned.tif',249,8,164,1183.6075774,79.2996246,119.9663315,1.8,79.7231343,120.0624944,0.3558395,28.0626489,32.6973083,236377.7023676,361241.3870346,23.9417741,11048.0466296,8423.214179,18219.1559229,50.9347197,60.2360663,2.3057323,190.6654623),(11155,'Cervus-giganteus-tibia-cleaned.tif',249,8,165,1185.8991934,79.3320872,120.2281795,1.8,79.804669,120.3247964,0.3410879,28.0591988,32.757873,233978.8737992,359649.021762,22.1167428,10979.0101856,8338.7581938,18089.2332294,51.0853521,59.948791,2.3004148,189.7018265),(11156,'Cervus-giganteus-tibia-cleaned.tif',249,8,166,1192.0576703,79.3767397,120.4896899,1.8,79.8708718,120.6126035,0.3285684,27.9409487,32.662496,232057.1790226,359351.2603537,20.6877186,11001.9534511,8305.2720075,18084.758557,50.9632673,59.948791,2.3004148,191.1688731),(11157,'Cervus-giganteus-tibia-cleaned.tif',249,8,167,1196.4193442,79.4104984,120.7444321,1.8,79.9231893,120.8420316,0.3155264,27.6728509,32.6959433,230133.6389563,358763.2388017,19.2018477,10972.7141073,8316.2244448,17999.5319106,50.9110619,59.6632271,2.2950463,193.3910359),(11158,'Cervus-giganteus-tibia-cleaned.tif',249,8,168,1203.7675771,79.4398755,120.9744831,1.8,79.9340678,121.0241842,0.3057724,27.5602587,32.6303719,229091.73763,358505.7291795,18.1806915,10986.8722839,8312.3942974,17957.8210238,51.0331281,59.8748296,2.3308192,190.9603535),(11159,'Cervus-giganteus-tibia-cleaned.tif',249,8,169,1208.8710792,79.4702534,121.2324563,1.8,79.9837634,121.3038072,0.2936984,27.2734949,32.6780063,227407.9554762,357885.1838169,16.885294,10951.8671487,8338.0570165,17881.7877675,50.6699401,59.6291772,2.4071707,191.5680241),(11160,'Cervus-giganteus-tibia-cleaned.tif',249,8,170,1212.0737132,79.4957257,121.4905573,1.8,80.059118,121.5653738,0.2806061,27.0929364,32.666788,225865.4560257,356652.9468301,15.4932691,10917.9068031,8336.6916161,17832.0598312,50.8273897,59.6632271,2.4173427,192.2799545),(11161,'Cervus-giganteus-tibia-cleaned.tif',249,8,171,1215.7190718,79.5234194,121.7482262,1.8,80.0779357,121.8305084,0.2680225,26.9714476,32.6410785,224269.1085414,355467.0143415,14.2101937,10890.1737057,8315.0564192,17750.9433492,50.6972216,59.4229143,2.4329664,188.7813765),(11162,'Cervus-giganteus-tibia-cleaned.tif',249,8,172,1219.1414176,79.563521,121.9967502,1.8,80.1181024,121.9765754,0.2564366,26.685466,32.6587382,222571.9969299,354393.3186926,13.0714033,10851.4087851,8340.5699959,17664.1498804,50.7386569,59.4229143,2.4329664,190.8560937),(11163,'Cervus-giganteus-tibia-cleaned.tif',249,8,173,1227.3644694,79.599936,122.2333268,1.8,80.1887347,122.1869167,0.2461921,26.5162765,32.5716482,222106.107361,354103.5754893,12.1500618,10871.5277022,8376.2178069,17675.2657622,50.6619114,59.2564523,2.4589244,300.2948061),(11164,'Cervus-giganteus-tibia-cleaned.tif',249,8,174,1231.2652353,79.6333102,122.478027,1.8,80.2139549,122.432252,0.2349799,26.3188215,32.5827474,220724.9891231,352935.9185607,11.1238126,10831.9876699,8386.5832972,17585.737923,50.5048865,59.2112559,2.4951888,188.1737059),(11165,'Cervus-giganteus-tibia-cleaned.tif',249,8,175,1232.6827038,79.6609391,122.7373178,1.8,80.2627938,122.6801788,0.2240699,25.9979561,32.5902581,218812.9150375,351528.2173031,10.1434731,10786.2974446,8416.5429987,17496.7377268,50.2584387,59.0551407,2.4748061,299.4354301),(11166,'Cervus-giganteus-tibia-cleaned.tif',249,8,176,1231.6590605,79.6885465,122.9720871,1.8,80.3824276,122.9254648,0.214414,25.7053588,32.596837,216808.0910312,349870.0603466,9.2935165,10733.2518386,8434.353821,17373.1910762,50.2095135,59.0551407,2.4748061,301.9092983),(11167,'Cervus-giganteus-tibia-cleaned.tif',249,8,177,1229.6885358,79.8337635,123.2082998,1.8,80.5760017,123.1825854,0.1984516,25.3817194,32.5521246,213420.7756651,345872.4360808,7.9660749,10625.1877532,8408.4443672,17181.3008713,49.8228784,58.791934,2.5170951,298.5149801),(11168,'Cervus-giganteus-tibia-cleaned.tif',249,8,178,1230.2104283,79.8662255,123.443579,1.8,80.5683831,123.3917201,0.1870138,25.1438272,32.4727243,211900.4218297,344823.680269,7.0877163,10618.8713026,8427.5325276,17143.6784051,49.3678297,58.6095062,2.4966253,299.0183909),(11169,'Cervus-giganteus-tibia-cleaned.tif',249,8,179,1230.8211119,79.9025605,123.6769621,1.8,80.6574115,123.6640893,0.1746799,24.8852529,32.3903385,210280.8803098,343173.8804649,6.195947,10594.9457897,8450.0198217,17055.8556617,49.3024233,58.5921775,2.4496713,296.0842977),(11170,'Cervus-giganteus-tibia-cleaned.tif',249,8,180,1233.470466,79.945311,123.9054774,1.8,80.7515651,123.9086744,0.1616226,24.5397663,32.371663,208983.6424616,341982.9640743,5.3234948,10564.2692593,8516.1219653,16973.7551287,48.9543483,58.4012228,2.5393053,298.2200889),(11171,'Cervus-giganteus-tibia-cleaned.tif',249,8,181,1231.9644302,80.0265628,124.156273,1.8,80.8340736,124.192239,0.1476925,24.2258499,32.2992269,207200.4409953,340790.9874544,4.4463482,10551.0571097,8552.8657092,16941.6677883,48.6225216,58.3521999,2.5025098,297.3607129),(11172,'Cervus-giganteus-tibia-cleaned.tif',249,8,182,1236.7080122,80.1132128,124.3769054,1.8,80.8935817,124.4364929,0.1340276,23.9258456,32.1571519,206408.7307709,340921.4554599,3.6804626,10601.7304203,8627.0192665,16988.6686658,48.2156904,58.2667068,2.4921919,302.5601547),(11173,'Cervus-giganteus-tibia-cleaned.tif',249,8,183,1239.7736271,80.1915802,124.5892424,1.8,81.0075083,124.648057,0.1205918,23.8612855,32.076146,205312.49919,340656.1863768,2.9903386,10620.2343034,8604.4190394,16964.2674037,47.9528943,58.0730923,2.5884835,186.6887712),(11174,'Cervus-giganteus-tibia-cleaned.tif',249,8,184,1241.2330573,80.2760564,124.802404,1.8,81.1058397,124.8530243,0.1076999,23.9035692,31.9327285,203591.03822,340331.7400357,2.3903009,10657.7720272,8517.1815284,16928.3839309,47.6636718,58.0715026,2.7143528,186.2285462),(11175,'Cervus-giganteus-tibia-cleaned.tif',249,8,185,1242.0176864,80.3636545,125.0148247,1.8,81.2113713,125.0587877,0.0964977,23.8146504,31.832695,201936.2908949,339382.558991,1.9215962,10661.446016,8479.4984415,16907.900643,47.3429682,57.8947777,2.7211076,200.7515666),(11176,'Cervus-giganteus-tibia-cleaned.tif',249,8,186,1244.1329512,80.451533,125.2040934,1.8,81.2994801,125.2737771,0.0868676,23.7173266,31.9360028,200537.6757438,338860.0458314,1.560769,10610.596697,8455.3237952,16867.1135633,47.0808388,57.7846493,2.7845626,199.1802602),(11177,'Cervus-giganteus-tibia-cleaned.tif',249,8,187,1245.8614963,80.5685241,125.3750395,1.8,81.4006643,125.4245758,0.0792314,23.5702304,31.8284924,198930.013079,338202.852774,1.3007812,10625.7892457,8439.8841042,16827.2779414,46.8279024,57.7207105,2.7279034,200.2913416),(11178,'Cervus-giganteus-tibia-cleaned.tif',249,8,188,1244.8115009,80.6858201,125.5530475,1.8,81.4689908,125.5645174,0.0714747,23.6929353,31.7139492,196725.875783,336859.4618659,1.0580778,10621.8074568,8303.1449513,16777.6169538,46.7157313,57.6118517,2.7513913,286.1098628),(11179,'Cervus-giganteus-tibia-cleaned.tif',249,8,189,1248.3677328,80.8121002,125.717974,1.8,81.6209458,125.7591443,0.0648279,23.4957243,31.5885418,195237.4906488,336623.2377535,0.8731852,10656.4981549,8309.4901956,16768.2270787,46.448492,57.5493251,2.7347401,282.9240642),(11180,'Cervus-giganteus-tibia-cleaned.tif',249,8,190,1247.1746758,80.9308619,125.8870272,1.8,81.7394933,125.8998491,0.0569459,23.3299264,31.4612295,192899.1820842,335369.1195162,0.6733346,10659.7588445,8268.3150761,16693.3821858,46.2174958,57.3468501,2.805625,279.8857112),(11181,'Cervus-giganteus-tibia-cleaned.tif',249,8,191,1248.3005939,81.0667946,126.0538196,1.8,81.8570262,126.0620078,0.0495604,23.123984,31.3126473,191210.9368208,334792.0254302,0.5106025,10691.9106064,8268.9443422,16670.6470472,45.976616,57.3049805,2.9530204,277.810994),(11182,'Cervus-giganteus-tibia-cleaned.tif',249,8,192,1246.4761522,81.1881651,126.2318265,1.8,82.0533385,126.2821407,0.0432585,23.3511393,31.4578055,189170.27864,333984.6315198,0.3885125,10616.9081376,8101.1155989,16619.9378341,45.976616,57.2517942,3.0815147,275.8405366),(11183,'Cervus-giganteus-tibia-cleaned.tif',249,8,193,1240.5418072,81.4752763,126.4119051,1.8,82.407483,126.5145037,0.0335117,23.2737576,31.2266833,185743.1903563,331019.889191,0.2321095,10600.5459023,7980.7994,16464.2140044,46.406304,57.1339638,3.020969,189.4143448),(11184,'Cervus-giganteus-tibia-cleaned.tif',249,8,194,1243.5772655,81.6097857,126.5591653,1.8,82.431883,126.5930184,0.0251901,22.5141729,31.07188,184675.0426463,331267.5109502,0.1314894,10661.328226,8202.6128027,16487.4295079,45.11724,57.0838527,3.0284417,177.1745612),(11185,'Cervus-giganteus-tibia-cleaned.tif',249,8,195,1244.857491,81.7558737,126.7098051,1.8,82.553666,126.6985032,0.0166254,22.3334859,30.9046442,183193.5945278,330741.3895157,0.0573419,10701.9963617,8202.6422208,16441.3521789,44.687552,57.0773835,2.9752064,176.5668906),(11186,'Cervus-giganteus-tibia-cleaned.tif',249,8,196,1244.6555151,81.8989438,126.8663487,1.8,82.6561447,126.8590544,0.0092287,22.4052061,30.7285557,181518.6824051,330192.4712032,0.0176682,10745.4601767,8101.6296628,16419.7001986,45.0447681,57.0077937,2.9826397,175.7075146),(11187,'Cervus-giganteus-tibia-cleaned.tif',249,8,197,1240.6785466,82.0222168,127.0191291,1.8,82.7678819,127.0532628,0.001461,22.1671425,30.990335,179702.1689216,328808.0236561,0.0004422,10610.0183862,8106.6907436,16325.5583374,44.6722387,56.9932177,3.0434244,175.4558092),(11188,'Cervus-giganteus-tibia-cleaned.tif',249,8,198,1240.6467675,82.1498582,127.1629325,1.8,82.9048817,127.1829234,-0.0056437,22.7997931,30.8623049,178543.2439271,328086.9787001,0.006586,10630.6700064,7830.9150976,16289.0270642,44.257864,56.9154156,3.0584514,176.3151852),(11189,'Cervus-giganteus-tibia-cleaned.tif',249,8,199,1240.8673186,82.2777895,127.3053544,1.8,83.046162,127.3490037,-0.0128282,21.8194877,30.7456718,177203.4879984,327577.6508654,0.0340318,10654.4313987,8121.3404293,16276.4224102,43.828176,56.8180132,3.0050431,175.8549602),(11190,'Cervus-giganteus-tibia-cleaned.tif',249,8,200,1240.1663333,82.3993155,127.4403893,1.8,83.109516,127.5036067,-0.0208025,22.9386035,30.6430149,175871.3781236,326586.8857066,0.0894329,10657.792225,7667.0481874,16242.9899519,44.2089542,56.761118,3.0125429,174.7438788),(11191,'Cervus-giganteus-tibia-cleaned.tif',249,8,201,1239.5925201,82.5255372,127.5862362,1.8,83.1911555,127.6746543,-0.0277452,21.9479561,30.863574,174671.3662238,325777.5243648,0.1589972,10555.4050265,7958.4342673,16163.543716,43.828176,56.7985127,3.088612,173.9276886),(11192,'Cervus-giganteus-tibia-cleaned.tif',249,8,202,1239.277583,82.6629866,127.7220602,1.8,83.3566168,127.8110913,-0.0352161,21.8203639,30.7743804,173457.6526088,324883.3176416,0.2560471,10556.9409654,7949.3473674,16141.1832577,43.828176,56.6569332,3.0275854,173.6759832),(11193,'Cervus-giganteus-tibia-cleaned.tif',249,8,203,1238.9255518,82.7976879,127.8455524,1.8,83.4198647,127.9249313,-0.0416204,21.7441023,30.6586628,172514.5568063,324056.8824426,0.3574836,10569.8309374,7933.8550846,16118.4933937,43.398488,56.6096614,3.0351265,173.0683126),(11194,'Cervus-giganteus-tibia-cleaned.tif',249,8,204,1237.247137,82.9553074,127.9740147,1.8,83.4851527,128.0535667,-0.0467306,21.6129724,30.5459986,171299.3951402,323488.8746186,0.4499779,10590.2209594,7925.7675542,16098.0420626,43.398488,56.5835634,2.9814377,172.4606421),(11195,'Cervus-giganteus-tibia-cleaned.tif',249,8,205,1238.5744716,83.1123984,128.0878703,1.8,83.6424783,128.1253903,-0.0520426,21.74472,30.4204126,170344.0219041,323551.7348357,0.5585949,10636.0074484,7833.8107736,16128.5584777,43.398488,56.5166325,2.9889433,171.8529715),(11196,'Cervus-giganteus-tibia-cleaned.tif',249,8,206,1234.4441469,83.2443991,128.1964975,1.8,83.7439081,128.2673834,-0.0579663,21.6849387,30.3503286,168668.9978934,322297.4998592,0.6905356,10619.2425295,7778.1634522,16077.1310404,43.3570549,56.544394,0.1988859,171.6012661),(11197,'Cervus-giganteus-tibia-cleaned.tif',249,8,207,1230.9725659,83.3852306,128.2925698,1.8,83.8893055,128.3652847,-0.0621474,21.6517975,30.4384932,167152.4312843,321516.2775403,0.7913767,10562.8184566,7720.0256229,16000.1922582,43.375925,56.5427613,0.4228539,171.6012661),(11198,'Cervus-giganteus-tibia-cleaned.tif',249,8,208,1227.6681047,83.5255117,128.3802037,1.8,84.0689855,128.469224,-0.0656765,21.5798846,30.3546602,165707.3132265,320867.2539599,0.8813024,10570.6093181,7678.7858711,15974.494849,42.9688,56.5427613,0.4228539,171.4970063),(11199,'Cervus-giganteus-tibia-cleaned.tif',249,8,209,1218.0340745,83.8452104,128.3730996,1.8,84.3252171,128.4603791,-0.0704521,21.5607603,30.1823185,162861.5782004,317425.1758612,1.0059524,10516.9248681,7553.6101675,15859.6500222,42.9688,56.4218141,0.3988919,170.6376303),(11200,'Cervus-giganteus-tibia-cleaned.tif',249,8,210,1214.2082243,83.9890911,128.4355607,1.8,84.4381309,128.4828743,-0.0726794,21.547812,30.2561182,161655.4995666,316193.6464038,1.0670859,10450.5688441,7502.1769881,15764.5771591,42.9688,56.3038863,0.0228968,170.2816651),(11201,'Cervus-giganteus-tibia-cleaned.tif',249,8,211,1209.5064363,84.1427944,128.5219464,1.8,84.6444069,128.6022054,-0.0753428,21.4810988,30.1691029,160083.2751902,314440.586397,1.1421392,10422.6031232,7452.2852241,15698.430227,42.539112,56.2300559,0.1148766,169.4222891),(11202,'Cervus-giganteus-tibia-cleaned.tif',249,8,212,1206.0668582,84.2884932,128.5995815,1.8,84.7665213,128.6637963,-0.0790167,21.5481422,30.094167,158702.0976131,313078.0446619,1.2524312,10403.2799567,7365.0014131,15669.1828992,42.8856,56.2103514,0.2078899,169.5265489),(11203,'Cervus-giganteus-tibia-cleaned.tif',249,8,213,1198.4328377,84.4298469,128.6650519,1.8,84.9039964,128.7697169,-0.0857624,21.5174071,30.0311632,156784.5961482,311014.3611672,1.4655195,10356.3874377,7286.4074968,15573.7336245,42.8551181,56.19064,0.2709469,169.5265489),(11204,'Cervus-giganteus-tibia-cleaned.tif',249,8,214,1195.6352187,84.5860862,128.7245659,1.8,85.0755476,128.8129371,-0.0911569,21.503733,30.0771456,155549.8809445,310043.2472292,1.65129,10308.2669796,7233.6222344,15443.4677565,42.539112,56.2103514,0.2078899,172.0004171),(11205,'Cervus-giganteus-tibia-cleaned.tif',249,8,215,1193.1493476,84.7544835,128.7886858,1.8,85.2406311,128.8486564,-0.0949851,21.4131849,29.9889531,154344.8705071,308942.5947902,1.7887439,10301.8799481,7207.936211,15435.2268561,42.5257899,56.1725651,0.2394129,170.5333705),(11206,'Cervus-giganteus-tibia-cleaned.tif',249,8,216,1190.3266075,84.91618,128.8507091,1.8,85.4334489,128.9261201,-0.0994553,21.3644092,29.9563249,153215.7135518,307888.7962451,1.9558635,10277.9228378,7171.5399141,15392.5550578,42.5384635,56.0919791,0.1538142,169.5265489),(11207,'Cervus-giganteus-tibia-cleaned.tif',249,8,217,1186.6420286,85.0878931,128.9070349,1.8,85.5946293,129.0048131,-0.1035538,21.3232629,29.835427,151913.2902888,306956.0533426,2.1132322,10288.307695,7124.2985184,15378.9212429,42.4762612,56.0392889,0.1928843,170.2816651),(11208,'Cervus-giganteus-tibia-cleaned.tif',249,8,218,1182.3913575,85.2747056,128.9567658,1.8,85.7881617,129.0611151,-0.1071575,21.2900771,29.7020503,150562.033932,306079.4373798,2.2541977,10304.9935777,7071.9346469,15369.2369482,42.109424,55.9667589,0.1386397,169.0663239),(11209,'Cervus-giganteus-tibia-cleaned.tif',249,8,219,1178.7797921,85.4638211,129.0058479,1.8,86.0280273,129.1323625,-0.1111302,21.2579266,29.7110424,149353.1333538,304972.5263159,2.4163336,10264.618866,7025.762034,15272.3856845,42.109424,55.9667589,0.1386397,171.3495606),(11210,'Cervus-giganteus-tibia-cleaned.tif',249,8,220,1174.0438191,85.6513513,129.041015,1.8,86.2140585,129.1799484,-0.1146259,21.6538457,29.6216802,147959.7712702,304002.7218944,2.5597407,10262.8453332,6832.9558177,15253.8125508,42.109424,55.9667589,0.1386397,170.2816651),(11211,'Cervus-giganteus-tibia-cleaned.tif',249,8,221,1171.5845798,85.8324618,129.063238,1.8,86.378927,129.1989173,-0.1179675,21.1695796,29.5431508,146974.2985883,303797.6685015,2.7047765,10283.1844374,6942.7121945,15257.9651331,41.679736,55.9667589,0.1386397,169.4222891),(11212,'Cervus-giganteus-tibia-cleaned.tif',249,8,222,1166.0294013,86.0227253,129.0967815,1.8,86.5949019,129.2265021,-0.1233544,21.4987614,29.4115374,145673.357436,302795.065921,2.942142,10295.1118084,6775.89535,15246.3220363,41.679736,55.8809203,0.1777902,168.5629131),(11213,'Cervus-giganteus-tibia-cleaned.tif',249,8,223,1161.5021742,86.1879371,129.1099103,1.8,86.7493343,129.2340908,-0.127169,21.0870437,29.3500405,144433.5904788,301751.3402365,3.1137858,10281.1217659,6849.3996719,15157.7974467,41.679736,55.8065303,0.1702119,169.1705837),(11214,'Cervus-giganteus-tibia-cleaned.tif',249,8,224,1157.0684378,86.3260341,129.1515207,1.8,86.9388314,129.3303067,-0.1301848,21.5265431,29.4347248,143198.1130967,300981.0347439,3.2499285,10225.3728065,6652.164829,15087.4518699,42.2873698,55.9089974,0.1310279,173.8845028),(11215,'Cervus-giganteus-tibia-cleaned.tif',249,8,225,1149.9691222,86.6451946,129.071066,1.8,87.2296118,129.1707409,-0.1345799,21.0674366,29.2778113,141051.4751355,298485.1859812,3.4504175,10194.9282507,6695.2367111,15010.0853324,41.5799262,55.7353537,0.1626138,168.2069479),(11216,'Cervus-giganteus-tibia-cleaned.tif',249,8,226,1147.9330813,86.8003108,129.1030405,1.8,87.3207856,129.1866455,-0.1381599,20.8955654,29.3192011,140148.1713127,298034.578432,3.6288103,10165.167086,6707.0772361,14931.1316247,41.2002184,55.8544818,0.1234008,168.0595023),(11217,'Cervus-giganteus-tibia-cleaned.tif',249,8,227,1145.2952527,86.9797153,129.1492786,1.8,87.5413742,129.228978,-0.1421005,20.819599,29.2646076,138999.7277607,297362.7693196,3.8285335,10161.1739645,6676.3883342,14909.0158586,41.1588198,55.7353537,0.1626138,167.8077969),(11218,'Cervus-giganteus-tibia-cleaned.tif',249,8,228,1143.6462112,87.1527938,129.1925099,1.8,87.7382154,129.2460437,-0.1451652,20.747315,29.2223426,138027.707429,296974.3000398,3.9885271,10162.5767535,6652.7985718,14884.8120277,41.1416656,55.7353537,0.1626138,167.7035371),(11219,'Cervus-giganteus-tibia-cleaned.tif',249,8,229,1138.4574428,87.3129496,129.2411631,1.8,87.8858519,129.3143756,-0.1471993,20.6092657,29.1347473,136546.973754,295663.643953,4.0816718,10148.1451199,6625.5137737,14829.3398382,41.0654047,55.7022174,0.2019341,167.9552425),(11220,'Cervus-giganteus-tibia-cleaned.tif',249,8,230,1136.82513,87.4682624,129.2866611,1.8,88.0912979,129.4030319,-0.1483874,21.3885212,29.1596538,135554.726413,295200.7756026,4.1413951,10123.603589,6337.7325308,14764.7521758,40.82036,55.6690613,0.0927563,168.5629131),(11221,'Cervus-giganteus-tibia-cleaned.tif',249,8,231,1134.3712618,87.6182308,129.3416377,1.8,88.2758857,129.4827155,-0.1495203,21.244882,29.1464882,134559.1943843,294376.6980334,4.1953218,10099.9028252,6333.722828,14716.5411688,41.3156553,55.6674029,0.1549967,170.6376303),(11222,'Cervus-giganteus-tibia-cleaned.tif',249,8,232,1131.2098063,87.7841898,129.3859338,1.8,88.4490036,129.5117015,-0.1508928,20.5532034,29.0535825,133436.3169232,293734.5913409,4.2602066,10110.0988523,6492.2394053,14701.37452,40.7742344,55.6176303,0.1943653,170.0299597),(11223,'Cervus-giganteus-tibia-cleaned.tif',249,8,233,1129.0301442,87.942668,129.4305927,1.8,88.6190053,129.6055874,-0.1532595,21.0609474,29.0358699,132585.2646018,292877.5479728,4.3853675,10086.7495541,6295.3134099,14639.1728195,41.3362338,55.6176303,0.1943653,170.9935955),(11224,'Cervus-giganteus-tibia-cleaned.tif',249,8,234,1127.0836777,88.1136267,129.4600055,1.8,88.8039261,129.6568456,-0.1562768,21.0521927,29.0321925,131660.0580054,292331.3760362,4.550462,10069.2145644,6253.9831425,14601.7124643,41.149565,55.6026898,0.1473615,170.5944444),(11225,'Cervus-giganteus-tibia-cleaned.tif',249,8,235,1125.564326,88.2893457,129.4753857,1.8,88.9561364,129.68306,-0.1598629,21.0543858,28.9958586,130997.2395442,291727.9185995,4.7534815,10061.0201839,6221.8504484,14537.4211635,41.0240759,55.6226095,0.3632914,168.9188783),(11226,'Cervus-giganteus-tibia-cleaned.tif',249,8,236,1124.5636218,88.472859,129.4910787,1.8,89.1583255,129.7017996,-0.1629264,20.9203061,28.8876597,130485.873897,291250.9607389,4.9313883,10082.1930018,6237.2831968,14587.0850864,40.9274588,55.4580575,0.1791605,169.1705837),(11227,'Cervus-giganteus-tibia-cleaned.tif',249,8,237,1127.9141291,88.6499229,129.4993486,1.8,89.3171808,129.6796533,-0.1657778,20.8632303,28.8562476,130743.0224381,291685.6606813,5.1191204,10108.2325474,6266.6720715,14616.1399803,40.8313227,55.483021,0.1320398,170.9935955),(11228,'Cervus-giganteus-tibia-cleaned.tif',249,8,238,1126.9465467,88.8300756,129.5260582,1.8,89.5493298,129.7394408,-0.1681799,21.0053717,28.8240458,130440.6952912,291227.6963447,5.2626197,10103.6370316,6209.8732152,14588.9801176,40.2367968,55.3830996,0.1715261,168.8756924),(11229,'Cervus-giganteus-tibia-cleaned.tif',249,8,239,1124.9698117,89.007468,129.5481002,1.8,89.6854039,129.8009641,-0.1700156,20.9551861,28.7249649,129910.3660857,290733.1165725,5.3675841,10121.2696943,6199.437479,14588.8576007,40.8133582,55.3630936,0.2751014,171.9572312),(11230,'Cervus-giganteus-tibia-cleaned.tif',249,8,240,1122.0334951,89.1663863,129.5683533,1.8,89.8678908,129.8751039,-0.17193,21.3243502,28.645467,129312.3294348,290138.1162056,5.473618,10128.5874031,6064.068918,14541.118264,41.1494483,55.3764317,0.3733019,174.5353592),(11231,'Cervus-giganteus-tibia-cleaned.tif',249,8,241,1116.497563,89.4427311,129.4595964,1.8,90.057284,129.8197998,-0.1750339,20.9220708,28.6292736,128059.8447797,287738.2551228,5.643018,10050.4909478,6120.801622,14438.8841196,40.7604037,55.3630936,0.2751014,273.6615596),(11232,'Cervus-giganteus-tibia-cleaned.tif',249,8,242,1115.773135,89.6051341,129.4629896,1.8,90.150208,129.7864579,-0.1765774,20.804167,28.5744219,127747.8039164,287590.4406607,5.7382088,10064.610991,6140.4911727,14421.955385,40.6205899,55.32306,0.348771,272.9496292),(11233,'Cervus-giganteus-tibia-cleaned.tif',249,8,243,1113.7852662,89.7741734,129.4738841,1.8,90.31772,129.8241871,-0.1769457,20.8674151,28.5621109,127210.0295687,287006.5262293,5.7516558,10048.5054167,6096.1086312,14335.6280503,40.6849502,55.4447391,0.3070457,272.9496292),(11234,'Cervus-giganteus-tibia-cleaned.tif',249,8,244,1112.6805528,89.9366996,129.484845,1.8,90.5047809,129.8321599,-0.1770585,20.9477214,28.5692246,127069.9289579,286005.5487603,5.7532028,10010.966432,6066.0501833,14370.0206032,40.7485845,55.316385,0.2996411,271.6911022),(11235,'Cervus-giganteus-tibia-cleaned.tif',249,8,245,1108.5024475,90.0982902,129.4974697,1.8,90.6283106,129.7655027,-0.1780524,20.9002046,28.5640253,126461.8180812,284654.3866709,5.7954422,9965.4857521,6050.7454567,14247.4588655,40.9127753,55.3630936,0.2751014,271.0834316),(11236,'Cervus-giganteus-tibia-cleaned.tif',249,8,246,1107.7037193,90.2652287,129.5082472,1.8,90.7967649,129.7889641,-0.1804782,21.1518892,28.5565441,126266.086045,284090.2016139,5.9484185,9948.3397221,5969.4944926,14224.4725942,41.1410469,55.3764317,0.3733019,273.3666684),(11237,'Cervus-giganteus-tibia-cleaned.tif',249,8,247,1107.5504749,90.4396571,129.5205159,1.8,90.9417088,129.778609,-0.1827012,21.0184505,28.5457138,126078.5895587,283864.877615,6.0933712,9944.2206797,5998.4721174,14231.1109103,41.1299736,55.3630936,0.2751014,275.0422345),(11238,'Cervus-giganteus-tibia-cleaned.tif',249,8,248,1106.2590036,90.5951237,129.5297022,1.8,91.0855479,129.7508431,-0.1855226,21.1227049,28.5844036,125800.696913,283053.1704065,6.2735169,9902.3640551,5955.7096317,14194.8928561,41.2486321,55.32306,0.348771,273.0107032),(11239,'Cervus-giganteus-tibia-cleaned.tif',249,8,249,1104.0787821,90.7355531,129.5445657,1.8,91.2470368,129.7050356,-0.1882107,20.8064506,28.5911849,125493.3877688,282161.6879629,6.4417409,9868.8350454,6031.4654533,14143.2858921,41.0810533,55.32306,0.348771,270.475761),(11240,'Cervus-giganteus-tibia-cleaned.tif',249,8,250,1102.2479062,90.8744543,129.563988,1.8,91.3863382,129.6642783,-0.1908599,21.0079669,28.6450476,125155.2973712,281473.4674878,6.6111611,9826.2523757,5957.5159354,14092.548818,41.2302823,55.32306,0.348771,272.3598468),(11241,'Cervus-giganteus-tibia-cleaned.tif',249,8,251,1100.8725673,91.0372987,129.5672272,1.8,91.6054151,129.5764018,-0.1927329,20.7059714,28.8190046,125000.6758764,280791.9545632,6.7315208,9743.2912074,6036.9385014,13959.5835089,41.2156196,55.4813572,0.282555,277.9763277),(11242,'Cervus-giganteus-tibia-cleaned.tif',249,8,252,1097.4912321,91.1754702,129.5847121,1.8,91.7006818,129.6082237,-0.193448,20.6587702,28.6068806,124568.6396829,279591.0993545,6.7601129,9773.561248,6029.8187255,14019.8273525,41.1567674,55.2479189,0.2676163,271.7521762),(11243,'Cervus-giganteus-tibia-cleaned.tif',249,8,253,1098.8250569,91.3310231,129.5995326,1.8,91.8786553,129.5966157,-0.1946362,20.5190297,28.6273705,124796.9794348,279689.1943818,6.8506782,9769.9924761,6082.0117326,13975.4471097,41.1982886,55.316385,0.2996411,269.616385),(11244,'Cervus-giganteus-tibia-cleaned.tif',249,8,254,1097.5699524,91.4831749,129.6148599,1.8,92.0281413,129.6310707,-0.1960721,20.4694355,28.6575295,124765.9235932,279234.6259481,6.9428881,9743.8485119,6095.230311,13953.8961509,41.2582199,55.316385,0.2996411,269.217234),(11245,'Cervus-giganteus-tibia-cleaned.tif',249,8,255,1098.3563159,91.6322592,129.613914,1.8,92.1673604,129.655409,-0.1975453,20.4357975,28.684087,125087.2703501,278933.6471445,7.0512933,9724.3341787,6120.9879448,13947.6471975,41.0162692,55.2479189,0.2676163,267.9408188),(11246,'Cervus-giganteus-tibia-cleaned.tif',249,8,256,1096.4556717,91.7775655,129.6251038,1.8,92.2997458,129.6676381,-0.1985839,20.561781,28.6324868,125031.3122444,278521.5219216,7.1123235,9727.4653029,6080.7627563,13917.2461277,41.3842916,55.2980243,0.390607,268.5053036),(11247,'Cervus-giganteus-tibia-cleaned.tif',249,8,257,1091.2169408,92.0024574,129.5371728,1.8,92.5326524,129.555457,-0.2010679,20.5638674,28.5764789,124517.5378992,276361.6242718,7.2541186,9670.9473997,6055.1614977,13826.0782764,41.4317882,55.3030324,0.3242076,278.0805875),(11248,'Cervus-giganteus-tibia-cleaned.tif',249,8,258,1091.8608581,92.1616269,129.536302,1.8,92.6373195,129.5507393,-0.2030136,20.3098754,28.5908528,124667.3707518,276395.7242707,7.3976107,9667.278066,6138.263678,13903.6782982,41.0795456,55.1776948,0.3414524,270.6842806),(11249,'Cervus-giganteus-tibia-cleaned.tif',249,8,259,1091.2348445,92.3263806,129.5457105,1.8,92.8023266,129.5836631,-0.2063039,20.5512701,28.6190233,124782.9719697,275839.6199213,7.6315319,9638.3310207,6071.7888074,13841.5468035,41.1125199,55.2211774,0.3660565,170.6555184),(11250,'Cervus-giganteus-tibia-cleaned.tif',249,8,260,1091.734749,92.4880957,129.5410794,1.8,92.9351029,129.5843,-0.2091793,20.4648848,28.7140455,124945.1320043,275572.831197,7.846202,9597.1440486,6105.3425392,13837.8253406,40.8282744,55.2211774,0.3660565,169.544437),(11251,'Cervus-giganteus-tibia-cleaned.tif',249,8,261,1088.0892225,92.6575497,129.5342429,1.8,93.0950243,129.5969817,-0.211792,20.7614871,28.7362169,124432.2756237,274554.6756658,8.0136278,9554.3083088,5993.4182486,13743.0741845,40.8282744,55.32306,0.348771,171.4717086),(11252,'Cervus-giganteus-tibia-cleaned.tif',249,8,262,1088.0683536,92.8237761,129.5452465,1.8,93.3047465,129.630521,-0.2132892,20.8177988,28.8202838,124749.8962116,274296.0857005,8.1254441,9517.4665118,5992.4633339,13744.6518263,40.8720756,55.3630936,0.2751014,268.2104124),(11253,'Cervus-giganteus-tibia-cleaned.tif',249,8,263,1089.5756762,93.0217647,129.5663521,1.8,93.5732675,129.7096378,-0.2122223,20.9281531,28.7182533,125190.2395116,274737.3367298,8.0567201,9566.6450823,5981.9057538,13783.0827202,40.8793438,55.3764317,0.3733019,270.07661),(11254,'Cervus-giganteus-tibia-cleaned.tif',249,8,264,1091.0446738,93.1911376,129.5711527,1.8,93.7709925,129.7045471,-0.2123264,20.9464865,28.7930207,125548.9898964,274574.5984217,8.0753796,9536.1511676,5993.7970851,13706.8230344,40.8304992,55.6026898,2.8516162,280.7629753),(11255,'Cervus-giganteus-tibia-cleaned.tif',249,8,265,1093.306413,93.3664324,129.5644406,1.8,93.9484453,129.8014835,-0.2138026,20.7790689,28.8067717,126128.8071385,274827.7757575,8.20331,9540.3878841,6069.9932153,13808.2788278,40.5267498,55.4813572,0.282555,278.3322929),(11256,'Cervus-giganteus-tibia-cleaned.tif',249,8,266,1095.6989052,93.5483527,129.5017763,1.8,94.1284631,129.7598646,-0.2160753,21.0029057,28.7671969,126988.1409651,274922.8155401,8.3942291,9556.8162909,6046.2177462,13623.7728853,40.9052557,55.4447391,0.3070457,168.5376154),(11257,'Cervus-giganteus-tibia-cleaned.tif',249,8,267,1093.7801334,93.7271816,129.4554833,1.8,94.380657,129.5967238,-0.2232374,20.7432813,29.2454688,126516.6990957,275509.4098338,8.9348286,9420.5845072,6099.1651957,13161.9639935,40.7807777,55.8065303,0.1702119,169.20636),(11258,'Cervus-giganteus-tibia-cleaned.tif',249,8,268,1090.1841218,93.8261926,129.4243773,1.8,94.2320286,129.5809805,-0.2236029,20.8878943,28.9139498,126686.3274956,273590.9047282,8.9341516,9462.245949,6065.0597623,13036.1822822,40.7864096,55.4430741,0.2506177,168.6418752),(11259,'Cervus-giganteus-tibia-cleaned.tif',249,8,269,1090.3335057,93.9291383,129.3884472,1.8,94.2154905,129.4547381,-0.2218284,20.982396,28.8967633,127284.2021225,273623.4666528,8.7964435,9469.0005256,6066.237726,13048.1102275,40.9835601,55.3630936,0.2751014,176.8975581),(11260,'Cervus-giganteus-tibia-cleaned.tif',249,8,270,1084.8341084,94.0741606,129.3919574,1.8,94.3601168,129.4954678,-0.2251114,21.6620407,28.9907505,126780.2633102,272288.1366287,9.0086312,9392.2417305,5852.6463463,13107.3670544,40.9650098,55.4813572,0.282555,175.7864767),(11261,'Cervus-giganteus-tibia-cleaned.tif',249,8,271,1077.3606057,94.2057118,129.4370885,1.8,94.4938708,129.6912486,-0.2269077,20.8131152,29.0684383,125797.2607394,271164.1876675,9.0874468,9328.4745699,6044.134155,13157.0122633,0.859376,3.543298,1.815775,7.5869384),(11262,'Cervus-giganteus-tibia-cleaned.tif',249,8,272,1072.1797261,94.3064329,129.4455765,1.8,94.5881386,129.6342036,-0.2291483,22.6645231,29.102809,125697.6188662,270426.0821133,9.2200832,9292.0955643,5546.007657,13413.3427377,40.3321153,55.4813572,0.282555,166.106933),(11263,'Cervus-giganteus-tibia-cleaned.tif',249,8,273,1059.5082234,94.4737683,129.3055922,1.8,94.6423191,129.5693695,-0.2323462,25.6804359,29.2070485,124313.635131,267752.9538766,9.3625696,9167.408823,4840.7914773,13395.716717,40.5164442,57.3822544,0.3596471,174.4668758),(11264,'Cervus-giganteus-tibia-cleaned.tif',249,8,274,1054.3437369,94.5813618,129.2832485,1.8,94.7093265,129.5941167,-0.2336331,27.6073611,29.2191902,123873.4025125,267662.5348124,9.418536,9160.5049027,4486.9700598,13368.7603814,40.0771439,56.8033885,0.3073975,170.464887),(11265,'Cervus-giganteus-tibia-cleaned.tif',249,8,275,1048.5526213,94.6734233,129.2694709,1.8,94.7850182,129.5388666,-0.2358129,30.3863538,29.3282589,123364.2088964,267352.6869094,9.539138,9115.8731292,4059.8556027,12838.6208794,40.1607719,57.2146958,0.2504431,165.768856),(11266,'Cervus-giganteus-tibia-cleaned.tif',249,8,276,1042.5402833,94.832918,129.2176807,1.8,95.0798528,129.4478572,-0.2397078,30.612283,29.3791649,122932.463274,266162.0930247,9.7942608,9059.5527178,4015.7888042,12585.3943567,40.2304058,57.0077937,0.2358381,175.0745464),(11267,'Cervus-giganteus-tibia-cleaned.tif',249,8,277,1030.3503898,95.0302594,129.1343149,1.8,95.4097344,129.3793975,-0.2374825,29.5994143,29.3826478,121360.1300564,263610.0619708,9.5042313,8971.623797,4100.0855191,12264.0420811,40.0771439,55.7353537,0.1626138,166.9231232),(11268,'Cervus-giganteus-tibia-cleaned.tif',249,8,278,1023.9651516,95.1855829,129.085603,1.8,95.5588823,129.3456418,-0.2368688,28.6008192,29.5231391,120632.305969,263319.6621154,9.3974946,8919.0943093,4217.7919866,11637.7960062,39.9674544,55.8809203,0.2170009,167.1748286),(11269,'Cervus-giganteus-tibia-cleaned.tif',249,8,279,1019.9192539,95.3365153,129.0660567,1.8,95.7304297,129.3412755,-0.2370917,28.5267609,29.6887087,120347.7207627,263797.7311292,9.3776608,8885.4565493,4218.765706,11293.1221412,39.8982593,56.0392889,0.1928843,167.6782394),(11270,'Cervus-giganteus-tibia-cleaned.tif',249,8,280,1017.7524601,95.5059662,129.0552607,1.8,95.9549476,129.4023943,-0.2370172,28.5715008,29.7373454,120431.7704663,264929.8485044,9.3519671,8908.9945679,4215.1013056,11072.0485125,40.0771439,56.1594161,0.1613751,174.4668758),(11271,'Cervus-giganteus-tibia-cleaned.tif',249,8,281,1014.3992114,95.6700456,129.0520898,1.8,96.2439769,129.4310083,-0.2377339,20.9121633,29.9314393,120415.1387135,266122.8633112,9.3765419,8891.0814032,5758.1387978,12604.5553693,40.0274009,57.2791994,3.0740265,177.400969),(11272,'Cervus-giganteus-tibia-cleaned.tif',249,8,282,1010.0731769,95.8194178,129.0307432,1.8,96.3578968,129.4023144,-0.2383379,21.0019895,29.8433704,120344.3561107,266559.2717541,9.3831539,8931.9426199,5730.1407567,12678.0044389,40.1232244,57.1743441,3.1115265,181.7589229),(11273,'Cervus-giganteus-tibia-cleaned.tif',249,8,283,1004.5460288,95.9598134,129.0212796,1.8,96.4874233,129.4357868,-0.239466,20.8816733,29.9172626,120228.6102332,266887.7332476,9.4186595,8920.8607362,5757.6137879,12737.7985164,39.8729501,56.952709,3.0509328,178.0086396),(11274,'Cervus-giganteus-tibia-cleaned.tif',249,8,284,999.9644193,96.1119507,128.9968488,1.8,96.6763423,129.3930515,-0.2392211,20.9700729,34.0506582,120078.8057625,266906.7541167,9.3569016,7838.5196826,5726.1987814,11278.2622213,39.9359529,57.3806456,3.0516107,191.3163187),(11275,'Cervus-giganteus-tibia-cleaned.tif',249,8,285,998.1062963,96.249742,128.9358107,1.8,96.770813,129.2980226,-0.2370985,21.0878182,33.8103626,120322.3475304,267295.5543458,9.1776129,7905.728716,5705.7750761,11359.6642637,39.60889,56.8228873,3.0810606,182.0538141),(11276,'Cervus-giganteus-tibia-cleaned.tif',249,8,286,995.8367801,96.3847649,128.8839412,1.8,96.8645051,129.2462669,-0.2345518,20.9940396,33.5787332,120764.1050291,267583.1604031,8.9646956,7968.8283393,5752.3043263,11441.4149817,39.6800197,56.5835634,0.160155,171.9319336),(11277,'Cervus-giganteus-tibia-cleaned.tif',249,8,287,994.0762881,96.547859,128.8528061,1.8,97.0518462,129.2465224,-0.2315302,20.9730318,33.3290638,121192.6131522,268353.815738,8.7238746,8051.6457705,5778.4975589,11544.7919566,39.6130264,56.7074216,0.1215355,173.963465),(11278,'Cervus-giganteus-tibia-cleaned.tif',249,8,288,989.3835638,96.6847112,128.8448844,1.8,97.2701834,129.2343182,-0.2300248,21.0407716,33.1039266,121421.4802936,268632.9122393,8.5721451,8114.8353144,5770.7712825,11617.1727893,39.8288254,60.2544544,0.0570808,185.3006867),(11279,'Cervus-giganteus-tibia-cleaned.tif',249,8,289,979.30569,96.7670381,128.7284998,1.8,97.4026241,129.1701988,-0.2277573,21.155185,33.0100795,121161.4403907,267473.400442,8.3212592,8102.7796575,5727.2692418,11605.7324534,40.1028751,60.0288131,0.1003809,192.7401795),(11280,'Cervus-giganteus-tibia-cleaned.tif',249,8,290,975.3229028,96.8624688,128.718072,1.8,97.3612409,129.1437273,-0.2266532,21.0132817,30.6667958,121683.5657374,267298.6138711,8.2086448,8716.2224371,5790.7930562,12301.6665019,40.0931046,58.2001253,3.0602908,181.0469925),(11281,'Cervus-giganteus-tibia-cleaned.tif',249,8,291,970.7793945,96.9970519,128.72735,1.8,97.4707617,129.1521603,-0.2231958,21.1275988,30.2338161,122077.7372533,267061.4553672,7.9271587,8833.203675,5778.1169713,12435.4662969,40.0348198,56.7074216,0.1215355,189.1984157),(11282,'Cervus-giganteus-tibia-cleaned.tif',249,8,292,966.0933281,97.1201186,128.7411763,1.8,97.5899237,129.1384934,-0.2184993,21.5493579,30.4813422,122428.5633623,266731.3863951,7.5656378,8750.6444066,5681.3091031,12394.4286569,40.16779,56.6096614,0.1064661,173.8592052),(11283,'Cervus-giganteus-tibia-cleaned.tif',249,8,293,957.2276458,97.2353485,128.7359842,1.8,97.699441,129.1159445,-0.2144457,21.5763821,30.7165448,122221.0777482,265453.7277787,7.2248904,8642.0438737,5664.5769975,12309.4220575,40.4329097,56.6569332,0.1140073,164.6398864),(11284,'Cervus-giganteus-tibia-cleaned.tif',249,8,294,953.3262085,97.3788478,128.7561694,1.8,97.8276217,129.1457576,-0.2093209,21.8882002,30.5569372,122929.5522967,265415.8160328,6.8606158,8685.9430474,5616.2476213,12444.072317,0.429688,0.6076706,2.3561945,1.2153412),(11285,'Cervus-giganteus-tibia-cleaned.tif',249,8,295,951.7079949,97.5144043,128.7881745,1.8,97.9408727,129.179483,-0.2047596,21.8647717,30.7991136,123939.6792632,266157.6357021,6.5578715,8641.7303856,5668.4643711,12444.3906696,40.6703424,56.6569332,0.1140073,172.122565),(11286,'Cervus-giganteus-tibia-cleaned.tif',249,8,296,950.3376914,97.6198272,128.8295195,1.8,98.0342074,129.2272435,-0.2019451,22.1909994,30.6618192,125135.3645361,266860.7432973,6.3720866,8703.3564874,5639.0143713,12625.3854987,40.7486468,56.6536743,0.1676424,165.4992624),(11287,'Cervus-giganteus-tibia-cleaned.tif',249,8,297,948.8804432,97.7406488,128.879906,1.8,98.2128919,129.278518,-0.19899,22.1682798,30.8695334,126469.0672606,267459.8091492,6.1799224,8664.1999185,5704.9562769,12630.8328231,40.8461776,56.6569332,0.1140073,169.7961424),(11288,'Cervus-giganteus-tibia-cleaned.tif',249,8,298,946.6159064,97.8732413,128.9032388,1.8,98.296468,129.3026753,-0.1948067,22.4909686,30.7582197,127602.3021298,267716.8512914,5.911935,8703.912443,5673.4907486,12772.9376296,40.9207922,56.6569332,0.1140073,171.0114836),(11289,'Cervus-giganteus-tibia-cleaned.tif',249,8,299,943.216164,97.9860995,128.9354911,1.8,98.3721421,129.348673,-0.1896356,22.4573631,30.6203493,128539.8538481,267863.7462998,5.5858294,8747.899753,5723.7286973,12905.9540405,40.6969485,56.6569332,0.1140073,167.9731306),(11290,'Cervus-giganteus-tibia-cleaned.tif',249,8,300,941.057315,98.1149739,128.9792027,1.8,98.5740147,129.3646387,-0.1838224,22.8199515,30.8310778,129737.9947105,268578.3506605,5.2404028,8711.2864534,5685.287932,12895.5452604,40.6963598,56.7985127,0.0529807,169.1884718),(11291,'Cervus-giganteus-tibia-cleaned.tif',249,8,301,943.0257136,98.2454352,129.021313,1.8,98.7197757,129.3795857,-0.1796436,22.0101371,30.6902513,131751.0829133,270198.6483114,5.0178644,8804.0546038,5985.9274025,13091.5259656,40.9731606,56.8228873,0.060532,167.2180144),(11292,'Cervus-giganteus-tibia-cleaned.tif',249,8,302,942.6039139,98.3759125,129.078828,1.8,98.8535194,129.4795254,-0.1754047,21.5996464,30.1909315,133578.2516678,271104.1796301,4.784121,8979.6560089,6184.2795542,13401.6015671,41.0440796,56.7074216,0.1215355,167.9731306),(11293,'Cervus-giganteus-tibia-cleaned.tif',249,8,303,942.0764824,98.5185909,129.114006,1.8,98.9587908,129.4877906,-0.171367,21.5878912,29.8640652,135207.6017071,272151.54777,4.5659769,9113.0107572,6263.1222379,13637.7209967,41.0475171,56.7074216,0.1215355,166.2975644),(11294,'Cervus-giganteus-tibia-cleaned.tif',249,8,304,938.1098645,98.6570496,129.1470507,1.8,99.0996351,129.53494,-0.1678799,22.2446343,29.8067723,136250.641762,272636.0923592,4.3653218,9146.7834891,6125.1014476,13717.9124561,41.7254231,56.7074216,0.1215355,170.6555184),(11295,'Cervus-giganteus-tibia-cleaned.tif',249,8,305,930.1149169,98.8354546,129.0375836,1.8,99.2853946,129.4241557,-0.1616491,22.4842497,29.76004,137073.0701738,271213.0706611,4.015559,9113.3301729,6096.4040261,13697.6580019,42.042909,56.8504992,3.0735162,168.8325066),(11296,'Cervus-giganteus-tibia-cleaned.tif',249,8,306,929.4952815,98.9493608,129.0502605,1.8,99.3399247,129.3509618,-0.1574702,22.3105481,29.7910284,138839.6063444,271880.9639494,3.8097795,9126.2698472,6223.0477526,13783.2445542,41.8123208,56.8504992,3.0735162,168.224836),(11297,'Cervus-giganteus-tibia-cleaned.tif',249,8,307,928.8391673,99.0698728,129.0774604,1.8,99.4319444,129.3248754,-0.153599,22.1376658,29.7442039,140514.9879575,272394.2538218,3.6236635,9157.8935748,6347.3262711,13881.9517611,41.7449647,56.8180132,3.0050431,167.4086458),(11298,'Cervus-giganteus-tibia-cleaned.tif',249,8,308,926.979086,99.1958047,129.1081934,1.8,99.5907619,129.4093253,-0.1477729,22.7776764,29.7328308,142241.0783633,272661.9443914,3.349226,9170.3997551,6244.7580499,13921.3286272,42.4172301,56.8813437,3.0659795,169.5876228),(11299,'Cervus-giganteus-tibia-cleaned.tif',249,8,309,920.1004893,99.3131212,129.1271949,1.8,99.7061528,129.4180534,-0.141458,23.0479176,29.8134575,143003.9108939,271807.690359,3.0481796,9116.9462743,6204.6347796,13911.1977851,42.7300336,56.9932177,3.0434244,171.7665998),(11300,'Cervus-giganteus-tibia-cleaned.tif',249,8,310,917.2719864,99.4312679,129.1666705,1.8,99.8212688,129.4714381,-0.1357122,22.7478181,29.762544,144406.1313561,271703.3878985,2.7984449,9129.0377536,6348.131089,13980.8980218,42.5437314,56.9932177,3.0434244,173.2768322),(11301,'Cervus-giganteus-tibia-cleaned.tif',249,8,311,914.316759,99.5505101,129.2339657,1.8,99.9360245,129.573781,-0.1318357,22.6951008,29.7090494,146480.9997809,271089.2489489,2.6332628,9124.8038593,6454.3004643,14051.1343109,42.6104316,56.8780977,2.9975589,171.0978552),(11302,'Cervus-giganteus-tibia-cleaned.tif',249,8,312,910.7856483,99.6696682,129.2922874,1.8,100.0841979,129.6619976,-0.1282218,23.2366388,29.7469498,148505.4889592,270850.7626825,2.4820308,9105.160843,6391.0056178,14084.4220045,43.2651854,57.0369347,3.0359271,170.342739),(11303,'Cervus-giganteus-tibia-cleaned.tif',249,8,313,906.0026222,99.77444,129.3108562,1.8,100.1279799,129.6801164,-0.1236676,23.0932797,29.8097987,149767.0691554,270774.5800835,2.2976016,9083.4085485,6485.3096399,14107.2781039,43.1555399,57.0838527,3.0284417,172.6691616),(11304,'Cervus-giganteus-tibia-cleaned.tif',249,8,314,902.3352197,99.869322,129.3333288,1.8,100.2260393,129.7364719,-0.1168105,23.1768295,29.7664204,151004.0788316,271005.6935786,2.0426971,9104.4099202,6515.3035223,14171.8603078,43.3195671,57.0838527,3.0284417,171.3495606),(11305,'Cervus-giganteus-tibia-cleaned.tif',249,8,315,897.4763827,99.9461869,129.3458783,1.8,100.2832894,129.7235785,-0.1113854,23.2597026,29.7791733,152348.4936186,270645.9495234,1.8481244,9088.4305763,6549.8900181,14171.6827429,43.4939286,57.2791994,3.0740265,171.4538204),(11306,'Cervus-giganteus-tibia-cleaned.tif',249,8,316,891.5975391,100.0514756,129.3747699,1.8,100.4591726,129.73518,-0.1049178,23.516311,29.8699524,153598.3569991,270344.0512509,1.6297548,9050.702448,6531.5668209,14192.8852568,43.8453715,57.1872597,3.0135098,172.2089366),(11307,'Cervus-giganteus-tibia-cleaned.tif',249,8,317,889.7083084,100.1537455,129.3900607,1.8,100.5678989,129.7606783,-0.1023408,23.6273653,29.9015858,155543.8619263,270975.5461237,1.547667,9062.2466642,6583.2080606,14250.5858581,44.0111575,57.2437314,3.0060649,172.7123475),(11308,'Cervus-giganteus-tibia-cleaned.tif',249,8,318,885.203293,100.2853244,129.4198523,1.8,100.6946221,129.7395668,-0.0972771,23.8908137,29.9855338,157241.5840216,271114.1659098,1.3916916,9041.4987313,6581.6755372,14281.7055357,44.3407992,57.464244,3.0367157,173.0251268),(11309,'Cervus-giganteus-tibia-cleaned.tif',249,8,319,882.1824374,100.4117004,129.4367179,1.8,100.837221,129.7645337,-0.0942921,23.9491047,29.984582,159146.0650365,271634.5566628,1.303379,9059.1410283,6645.1780688,14362.6181833,44.4888787,57.464244,3.0367157,172.920867),(11310,'Cervus-giganteus-tibia-cleaned.tif',249,8,320,877.2104715,100.5297201,129.4223311,1.8,100.9642451,129.7327681,-0.0916224,24.1131831,30.1343464,160474.4187708,271864.9191442,1.2238856,9021.7625966,6655.0491667,14339.8456517,44.8163672,57.7079143,3.0745292,175.2472896),(11311,'Cervus-giganteus-tibia-cleaned.tif',249,8,321,868.8349027,100.731561,129.3476944,1.8,101.1978315,129.6829336,-0.089302,24.2451917,30.120396,161740.23239,270712.3559198,1.1517367,8987.6758607,6671.0230247,14346.136583,45.1172682,57.7287067,2.9996956,174.3879136),(11312,'Cervus-giganteus-tibia-cleaned.tif',249,8,322,865.3990172,100.7739037,129.3071563,1.8,101.2218576,129.6283339,-0.0888279,24.5186952,30.3495745,163342.9031665,270652.8129437,1.1350678,8917.8453909,6661.9737126,14297.3278931,45.3342902,57.9378145,3.0301164,175.3515494),(11313,'Cervus-giganteus-tibia-cleaned.tif',249,8,323,861.27356,100.850131,129.2768379,1.8,101.2798763,129.5535452,-0.0855242,24.7294687,30.3828821,164664.0084553,270440.148112,1.0473909,8901.0695821,6658.6148889,14315.9130655,45.7188611,57.9378145,3.0301164,176.4626308),(11314,'Cervus-giganteus-tibia-cleaned.tif',249,8,324,855.5034813,100.9267877,129.2476869,1.8,101.3461097,129.523882,-0.0860064,24.8262396,30.6217488,165689.9670727,270087.3005749,1.0521087,8820.1135146,6673.9856726,14228.4861424,45.9134293,58.236596,3.0529368,175.95922),(11315,'Cervus-giganteus-tibia-cleaned.tif',249,8,325,848.0280763,101.0471355,129.2212082,1.8,101.4870422,129.513147,-0.087231,24.9728851,30.6111315,166576.9425765,269575.5728869,1.0727507,8806.4556903,6670.3122845,14244.8737751,46.1802477,58.2762122,3.0455924,176.9228558),(11316,'Cervus-giganteus-tibia-cleaned.tif',249,8,326,844.8163226,101.1716663,129.1989452,1.8,101.6067345,129.4580704,-0.0892367,25.2167672,30.837763,168315.1873633,270356.5901286,1.118266,8767.062317,6674.7329692,14224.4375724,46.4030811,58.5385838,3.0828368,178.8501274),(11317,'Cervus-giganteus-tibia-cleaned.tif',249,8,327,843.1869751,101.3163318,129.1653575,1.8,101.6983287,129.4717025,-0.0934627,25.392535,30.7692182,170366.8386003,271955.1679101,1.2240081,8838.54658,6709.3276992,14374.2751784,46.9459934,58.5795716,3.0017703,180.4646196),(11318,'Cervus-giganteus-tibia-cleaned.tif',249,8,328,843.2613314,101.5098364,129.1332522,1.8,101.8736948,129.4045222,-0.0974888,25.6415479,30.9606803,172950.8128633,274392.1053118,1.3315097,8862.5993457,6744.9443259,14448.4122064,47.1714281,58.8405905,3.0244839,180.5688794),(11319,'Cervus-giganteus-tibia-cleaned.tif',249,8,329,846.6678996,101.7287181,129.0780734,1.8,102.0781724,129.3782066,-0.1061447,25.8865576,31.0704336,176820.6781983,277374.2384378,1.583895,8927.2728619,6830.59836,14603.2216436,47.789462,59.0926459,3.0542244,181.5325152),(11320,'Cervus-giganteus-tibia-cleaned.tif',249,8,330,849.3855115,101.9306902,129.0232256,1.8,102.2580118,129.3655222,-0.1155138,26.256008,30.9974924,180374.4318177,280317.1707164,1.8805657,9043.2208869,6869.8345891,14860.6485026,48.3175894,59.2673566,3.025331,183.2080814),(11321,'Cervus-giganteus-tibia-cleaned.tif',249,8,331,852.1915788,102.1503052,128.981068,1.8,102.4870631,129.259099,-0.1247964,26.5876918,31.0881929,183984.4490444,283523.7741521,2.2005673,9119.9824537,6919.9105633,15016.7500898,48.6515942,59.6013036,3.0404893,184.7793878),(11322,'Cervus-giganteus-tibia-cleaned.tif',249,8,332,853.2859977,102.3161382,128.9307462,1.8,102.614615,129.2025783,-0.1345506,26.6571864,31.0147244,187053.0681299,286433.7497404,2.5591284,9235.4117348,7016.9846692,15256.2397908,48.8906751,59.6941647,3.026166,185.8904692),(11323,'Cervus-giganteus-tibia-cleaned.tif',249,8,333,856.2984609,102.4955054,128.8440118,1.8,102.7735571,129.0433767,-0.1470705,26.6959393,31.2329473,190355.332475,290481.0583401,3.0647264,9300.4690186,7130.4976446,15373.7458802,49.0402922,60.0733944,3.034095,185.994729),(11324,'Cervus-giganteus-tibia-cleaned.tif',249,8,334,859.0017499,102.6778284,128.7552273,1.8,102.9400226,128.9382026,-0.1653104,26.7830253,31.3563446,194115.8720859,294309.6302848,3.8768891,9385.9674677,7247.7201385,15516.14975,49.2262952,60.4151107,0.0925916,187.713481),(11325,'Cervus-giganteus-tibia-cleaned.tif',249,8,335,860.3481631,102.8088869,128.7301746,1.8,103.1045396,128.9249929,-0.1790461,27.0203717,31.3349514,197815.1087896,297643.560698,4.5478579,9498.7720624,7320.9617853,15767.1569036,49.5542567,60.5479031,3.0278006,188.572857),(11326,'Cervus-giganteus-tibia-cleaned.tif',249,8,336,858.2495153,102.9067397,128.7485917,1.8,103.2230776,128.9913561,-0.1872712,27.1127461,31.5639698,200534.7683534,299744.0480818,4.9581684,9496.3988935,7396.3282014,15774.7374471,49.8386017,60.8839239,0.0989664,189.5364927),(11327,'Cervus-giganteus-tibia-cleaned.tif',249,8,337,856.5940396,103.1255186,128.4932822,1.8,103.4286253,128.7694609,-0.1981102,27.3670975,31.6852625,204053.5161995,302607.5533818,5.530298,9550.4196533,7456.1621286,15881.6940437,50.3349396,61.3115241,0.098274,191.3595045),(11328,'Cervus-giganteus-tibia-cleaned.tif',249,8,338,860.7673892,103.2741542,128.4520482,1.8,103.5634258,128.6850609,-0.2000104,27.1171077,31.7803935,207770.9136709,307641.1783214,5.6629268,9680.2193048,7661.9865089,16167.1056146,50.2643987,61.4513933,3.0224414,191.3595045),(11329,'Cervus-giganteus-tibia-cleaned.tif',249,8,339,864.2201713,103.4164234,128.4396013,1.8,103.6508729,128.6143151,-0.1997731,27.1770578,31.9749532,211572.9088881,312290.9272345,5.6723384,9766.736035,7784.9821253,16311.7071076,50.5439622,61.8780559,3.0232669,194.1461521),(11330,'Cervus-giganteus-tibia-cleaned.tif',249,8,340,867.4656063,103.5523198,128.4351848,1.8,103.7796932,128.5921701,-0.2001428,27.401347,32.0106305,214893.2019093,317489.0139375,5.7144483,9918.2368174,7842.4320477,16483.5021999,50.7961072,62.3580778,3.1002369,194.7538227),(11331,'Cervus-giganteus-tibia-cleaned.tif',249,8,341,872.9195171,103.7212612,128.4119824,1.8,103.8429835,128.523188,-0.2011709,27.3800898,32.1733946,218529.260508,323934.8891523,5.8088042,10068.4087927,7981.3200699,16802.4351677,51.0648375,62.5944961,3.0453393,195.3614933),(11332,'Cervus-giganteus-tibia-cleaned.tif',249,8,342,886.1223117,103.9897401,128.3583994,1.8,104.0620164,128.3500913,-0.1985915,27.4904854,32.3276707,223628.9424265,334669.1609216,5.7483986,10352.4056639,8134.7760552,17210.8604702,51.3373787,63.1100365,3.0324392,196.4725747),(11333,'Cervus-giganteus-tibia-cleaned.tif',249,8,343,900.2320959,104.2627347,128.3299517,1.8,104.3007578,128.1421403,-0.1932648,27.518425,32.5723365,228639.635457,346672.5403562,5.5347117,10643.1585199,8308.6017924,17624.3979855,51.4978607,63.6895607,3.0130536,197.9396213),(11334,'Cervus-giganteus-tibia-cleaned.tif',249,8,344,914.7339149,104.5180301,128.3728571,1.8,104.5433067,128.1687816,-0.1809952,27.5874003,33.0075221,232885.3687667,360444.3600122,4.9400378,10920.067217,8441.7294293,17973.7910945,51.5453574,64.4660894,0.2013171,198.9464429),(11335,'Cervus-giganteus-tibia-cleaned.tif',249,8,345,931.3284512,104.7291332,128.400069,1.8,104.7327755,128.2307495,-0.1712325,27.7150666,33.3037526,237227.1237189,376299.9966917,4.5068728,11299.0269211,8559.5003897,18421.565194,51.8094803,65.1554944,0.2193843,200.3092297),(11336,'Cervus-giganteus-tibia-cleaned.tif',249,8,346,950.2637828,104.8716003,128.4236739,1.8,104.9527293,128.3229947,-0.1602936,27.8634202,33.5861343,242296.4238842,393517.974665,4.0346199,11716.6796091,8695.8608294,18912.8937134,52.0157075,65.8152424,0.2037975,201.6720165),(11337,'Cervus-giganteus-tibia-cleaned.tif',249,8,347,974.8818566,105.0301847,128.4284192,1.8,105.108266,128.2890617,-0.1514504,28.0321661,33.9778009,248427.7451729,414932.4708821,3.6984415,12211.8695185,8862.2386181,19498.3722869,52.2032871,66.6570606,0.2011882,204.7103695),(11338,'Cervus-giganteus-tibia-cleaned.tif',249,8,348,1001.7841613,105.177197,128.4017051,1.8,105.3414583,128.295051,-0.1484536,28.1397094,34.3989309,255769.5060743,438576.0529084,3.6526797,12749.7001066,9089.2731855,20106.3154846,52.5165047,67.5717682,3.0843305,205.7171911),(11339,'Cervus-giganteus-tibia-cleaned.tif',249,8,349,1037.3960504,105.3027337,128.377567,1.8,105.5642702,128.2428634,-0.1433807,28.3330301,35.0844279,265237.535659,467467.9175993,3.5301781,13324.0854989,9361.4249734,20824.7804327,52.8183285,68.5739509,0.2404194,207.6876485),(11340,'Cervus-giganteus-tibia-cleaned.tif',249,8,350,1070.1286908,105.3484009,128.3742469,1.8,105.7241679,128.3022169,-0.133332,28.5890097,35.8049598,274144.3291784,495935.9025612,3.1519468,13851.0392189,9589.1509457,21456.8815631,53.3014595,69.6306719,0.2240236,210.9777069),(11341,'Cervus-giganteus-tibia-cleaned.tif',249,8,351,1105.5668023,105.4377455,128.4309985,1.8,105.9434297,128.3963239,-0.123156,28.767058,36.5005691,284067.0741323,526179.1694345,2.7806601,14415.6428908,9874.7350021,22188.0993826,53.7514842,70.7251307,0.0851594,213.5558349),(11342,'Cervus-giganteus-tibia-cleaned.tif',249,8,352,1140.8987225,105.5429022,128.4784195,1.8,106.1443641,128.4702198,-0.1189179,28.9144953,36.95356,293866.2607233,556218.7781594,2.6763466,15051.8320227,10163.2851396,22898.8377411,54.1129405,71.8620262,3.0877525,215.5262923),(11343,'Cervus-giganteus-tibia-cleaned.tif',249,8,353,1194.7893254,105.6448381,128.3422617,1.8,106.5041891,128.4066805,-0.1059656,29.2312766,38.0533342,308259.7855909,596065.8356693,2.2276336,15663.9581762,10545.5464572,23722.0956935,54.6097141,73.6285152,3.0773537,220.0748777),(11344,'Cervus-giganteus-tibia-cleaned.tif',249,8,354,1259.9284795,105.8207426,128.4660809,1.8,106.7090172,128.6675016,-0.0930573,29.4971022,38.9855427,323408.8319026,631764.0327597,1.8131833,16205.0849879,10964.0882586,24436.6555606,54.9225176,75.3180679,3.0845119,223.9294209),(11345,'Cervus-giganteus-tibia-cleaned.tif',249,8,355,1347.1592174,105.9881585,128.5282487,1.8,106.8510842,128.8154391,-0.0776032,29.7096398,39.9603994,338436.9858964,682230.0019609,1.3494424,17072.6522101,11391.4873536,25506.2199823,55.4607267,77.8696143,3.0919098,228.4780063),(11346,'Cervus-giganteus-tibia-cleaned.tif',249,8,356,1550.8405182,105.887085,128.8220485,1.8,106.1352373,129.1797423,-0.0726457,29.7808549,41.5362673,357517.4336629,761102.3273657,1.3616692,18323.8017549,12004.9419249,26924.0688674,55.9853735,80.0154744,3.0932433,237.5930653),(11347,'Cervus-giganteus-tibia-cleaned.tif',249,8,357,1760.9268632,105.6014541,129.0322614,1.8,105.9393534,129.1556069,-0.0828532,29.6105435,42.825091,381760.8684502,849367.886625,2.010086,19833.4169635,12892.7342388,28746.2472317,56.5486102,81.8033871,3.0785185,241.3433486),(11348,'Cervus-giganteus-tibia-cleaned.tif',249,8,358,1858.5905834,106.1922066,128.8613395,1.8,105.8042946,128.8357779,-0.0811711,30.0047793,43.0084731,404821.3808132,935339.4005634,2.0364855,21747.7936887,13491.8966129,31158.0578008,56.9773438,83.0410275,3.0898255,241.8899453),(11349,'Cervus-giganteus-tibia-cleaned.tif',249,8,359,1970.2962216,107.0396104,128.230824,1.8,105.6788841,128.4459366,-0.0612397,30.9724107,42.5548964,418640.7968306,1026954.8280414,1.229996,24132.4715827,13516.5712662,33969.4387252,57.5609263,83.8596433,3.10059,246.75131),(11350,'Cervus-giganteus-tibia-cleaned.tif',249,8,360,2060.1257356,107.2690841,127.9888043,1.8,105.5742215,128.2427554,-0.0558721,31.6191088,42.3611064,436943.2279731,1095118.1496739,1.0707324,25851.9722846,13818.9608998,36163.2513243,58.0509882,83.9223676,3.0852421,250.7964846),(11351,'Cervus-giganteus-tibia-cleaned.tif',249,8,361,2142.1785033,107.1413278,127.9464268,1.8,105.4180786,128.061126,-0.0706469,31.8153917,42.2126094,461505.5750626,1146149.4302449,1.7789616,27151.8261151,14505.7329381,38038.5097176,58.5664989,84.0366913,3.0648208,249.2683641),(11352,'Cervus-giganteus-tibia-cleaned.tif',249,8,362,2236.5990823,107.0288489,127.8644577,1.8,105.2238148,127.9216206,-0.0855862,31.8340002,42.3073185,484360.1808069,1191580.1063103,2.7238584,28164.8695521,15215.1843318,39603.8981489,59.0789885,84.2582999,3.11099,256.1433721),(11353,'Cervus-giganteus-tibia-cleaned.tif',249,8,363,2294.856003,106.8470044,127.7906515,1.8,105.0312714,127.8694338,-0.0811827,32.3383504,42.1194866,500397.6811285,1213601.2433322,2.5152271,28813.296233,15473.8159268,40651.5016558,59.6102052,83.9223676,3.0852421,260.2928065),(11354,'Cervus-giganteus-tibia-cleaned.tif',249,8,364,2266.8636435,105.3364167,127.8183698,1.8,104.6015254,127.8030371,-0.0888796,32.766458,43.2883929,509713.1803393,1189330.9947502,2.976699,27474.593411,15555.9438321,39190.0462988,60.3746468,83.642497,3.0593047,269.0340121),(11355,'Cervus-giganteus-tibia-cleaned.tif',249,8,365,2205.2592928,102.5100968,127.9594408,1.8,103.3085004,127.7143831,-0.129977,32.767421,45.6887846,517927.1399598,1072587.6452014,6.1743961,23475.9504892,15806.161269,34743.5745612,60.9548044,83.7175147,3.049074,270.2672414),(11356,'Cervus-giganteus-tibia-cleaned.tif',249,8,366,2088.3666206,99.1046436,128.2301277,1.8,100.8631748,127.6266948,-0.2134045,32.3008107,48.3139871,508829.3408729,853679.3597114,15.6120424,17669.4040673,15752.8349692,28050.9170821,60.9997191,83.1121452,2.7265179,335.2954048),(11357,'Cervus-giganteus-tibia-cleaned.tif',249,8,367,1980.5526846,96.9209056,128.8235701,1.8,98.37333,127.8237378,-0.249867,31.972889,49.6442521,492153.7052499,679031.6899044,20.1834645,13677.9518435,15392.8443841,23502.3759613,61.4044419,74.176894,0.9458331,268.4800059),(11358,'Cervus-giganteus-tibia-cleaned.tif',249,8,368,1841.5631695,95.8675473,129.0138231,1.8,96.9560658,128.0624804,-0.3830607,32.5925962,41.7487345,470990.081862,545445.7732014,42.8769163,13064.9654246,14450.8304558,21140.8135876,61.2920926,70.1984483,1.0660759,234.3640808),(11359,'Cervus-giganteus-tibia-cleaned.tif',249,8,369,1632.1038451,94.9761833,128.1542525,1.8,96.2908612,127.4624771,-1.2523406,47.3794825,34.5645816,367006.7869747,444582.4391105,245.3509642,12862.3700522,7746.1121856,17118.4401346,59.9463258,69.0314868,1.0709528,241.656128),(11360,'Cervus-giganteus-tibia-cleaned.tif',249,8,370,1483.6050102,95.0144697,127.3247339,1.8,95.7623544,126.7643453,-1.4760438,44.846902,34.0681992,297898.9689727,398182.1158124,245.0541592,11687.7946436,6642.5763139,15438.0032094,57.8040124,68.2243879,1.0930651,227.6365185),(11361,'Cervus-giganteus-tibia-cleaned.tif',249,8,371,1360.0181493,95.5298563,126.386005,1.8,96.0480461,126.0357879,1.5103377,30.8744037,34.2721636,250148.5701937,357499.1943528,225.842166,10431.1825369,8102.1344485,17560.639152,55.6045724,67.0781366,1.1272033,213.2177579),(11362,'Cervus-giganteus-tibia-cleaned.tif',249,8,372,1268.3694527,95.8608298,125.4419569,1.8,96.6706543,125.2642005,1.4380828,29.8011148,34.5200272,219244.5055041,322999.4940348,207.6934414,9356.8725327,7356.9229454,15423.7846676,53.5753496,66.3029609,1.092657,266.4916604),(11363,'Cervus-giganteus-tibia-cleaned.tif',249,8,373,1176.5323198,95.7944477,124.4902256,1.8,96.7299854,124.7569422,1.4022144,28.5845958,34.9289786,196772.7003407,289909.9964677,190.5684969,8299.9849419,6883.8720661,13623.4076186,51.5533246,65.5679109,1.0719726,260.1200632),(11364,'Cervus-giganteus-tibia-cleaned.tif',249,8,374,1079.6428223,95.5386338,123.3048586,1.8,96.5912193,124.0898651,1.3696336,28.4617274,35.7033649,178816.2039899,255283.2373843,172.7566136,7150.1170266,6282.6897809,11823.6302524,50.1493668,64.5848366,1.1309537,270.3462035),(11365,'Cervus-giganteus-tibia-cleaned.tif',249,8,375,957.9581163,94.9078113,121.6415288,1.8,96.1386773,123.1455342,1.3232636,29.1581906,37.064612,163217.8354201,213816.0307103,150.0751281,5768.7378639,5597.6667989,9951.2485729,49.5377242,63.2400896,1.0828374,287.2567205),(11366,'Cervus-giganteus-tibia-cleaned.tif',249,8,376,848.1503809,94.2761296,119.7949946,1.8,95.400869,121.0658003,1.204902,30.4048085,37.9765457,149566.2758183,169245.4570902,123.2631423,4456.5785013,4919.1651992,8113.9392294,38.977072,56.0936249,0.3847738,255.4419203),(11367,'Cervus-giganteus-tibia-cleaned.tif',249,8,377,754.4674337,93.7745883,118.030383,1.8,94.9310252,119.2950803,-0.0247969,40.6160251,27.7053027,126341.6700581,138818.0513004,0.0773031,5010.5228193,3110.6360021,6508.4302076,26.6566529,55.85944,0.3947911,171.3674488),(11368,'Cervus-giganteus-tibia-cleaned.tif',249,8,378,673.4138597,93.3604744,116.4704315,1.8,94.5964875,117.7282291,-0.1298451,41.9007981,27.3229168,87758.4554341,127133.2998441,1.8816552,4652.9915147,2094.4339846,5127.5926984,26.0304717,54.1082812,0.3996781,176.2719994),(11369,'Cervus-giganteus-tibia-cleaned.tif',249,8,379,608.6756363,93.2310705,115.3557112,1.8,94.434443,116.5158484,-0.1263259,42.1730511,26.0588384,57203.0781529,116766.3980015,1.6103056,4480.8750271,1356.3893677,4124.7433813,39.3178782,52.9231902,0.4091562,252.3856792),(11370,'Cervus-giganteus-tibia-cleaned.tif',249,8,380,551.1081195,93.1329001,114.5942055,1.8,94.3030352,115.5588276,-0.1172565,41.9400605,24.8341112,32490.2607395,107685.6931583,1.257095,4336.2008192,774.6832119,3340.5134812,40.2832703,51.7430711,0.4190675,260.684548),(11371,'Cervus-giganteus-tibia-cleaned.tif',249,8,381,515.6235144,93.1135532,114.6116566,1.8,94.3577829,115.3401112,-0.1077393,29.2124331,24.7890348,27968.9796725,100646.8990804,0.993684,4060.1378829,957.434103,4398.4797473,11.171888,24.8030861,1.3258177,62.7270385),(11372,'Cervus-giganteus-tibia-cleaned.tif',249,8,382,480.9479882,93.2297668,114.7064719,1.8,94.4355208,115.5062243,-0.093867,27.0682522,24.8168337,25977.2284745,93293.5706363,0.7042016,3759.2857992,959.6936024,4200.241616,11.171888,23.6796687,1.3698421,59.4980541),(11373,'Cervus-giganteus-tibia-cleaned.tif',249,8,383,448.2168024,93.3539346,114.8271349,1.8,94.5271185,115.7037738,-0.0765014,26.4853841,24.8526137,24016.7840146,86516.5248046,0.4363433,3481.1841515,906.7938718,3916.0022111,11.171888,22.2526948,1.3961241,56.3122555),(11374,'Cervus-giganteus-tibia-cleaned.tif',249,8,384,414.2253649,93.6060579,114.9864093,1.8,94.6543102,115.8849022,-0.0522775,27.4759825,24.9656193,22023.2308063,79364.9242013,0.1885034,3178.9687768,801.5447978,3605.5851258,11.171888,20.3592323,1.4438235,53.1264569),(11375,'Cervus-giganteus-tibia-cleaned.tif',249,8,385,355.6373379,94.243145,115.5130295,1.8,95.2324907,116.4562768,0.0014005,24.9872969,25.0674626,18766.2516547,67475.0842861,0.0001161,2691.7396991,751.0316827,2992.4578423,10.7422,18.6010739,1.6865555,47.6142357),(11376,'Cervus-giganteus-tibia-cleaned.tif',249,8,386,302.5542472,94.5838297,116.0783479,1.8,95.7037779,116.9199744,0.0556971,23.2256627,25.1544107,16101.6977509,57693.4167703,0.1562675,2293.5705956,693.2718336,2664.7970475,10.3050708,16.6860637,1.7782926,43.4648013),(11377,'Cervus-giganteus-tibia-cleaned.tif',249,8,387,212.4645702,94.004804,117.6491912,1.8,95.9101211,117.9843971,0.1887709,18.1043646,24.4914949,11634.5258838,44536.7992037,1.2469263,1818.4598087,642.6365212,2071.8627994,9.4745397,15.3369125,1.7681919,40.0272973),(11378,'Cervus-giganteus-tibia-cleaned.tif',249,8,388,98.5350143,89.7100012,122.1890273,1.8,93.4009378,121.7009548,0.4969417,20.4196736,27.8753033,1453.901537,30513.8485932,3.732514,1094.6553047,71.2010174,1127.1237872,0,0,0,0),(11379,'Cervus-giganteus-tibia-cleaned.tif',249,8,389,74.2593484,92.80272,124.57291,1.8,93.8513742,124.9986028,0.5332517,6.5751428,24.2870726,256.0808078,23566.3487467,3.1981737,970.3247959,38.9468056,973.9779085,0,0,0,0),(11380,'Cervus-giganteus-tibia-cleaned.tif',249,8,390,53.7772502,99.6492697,128.6863616,1.8,98.3042475,127.730785,0.5354969,6.6519402,30.878592,194.6703161,11777.2656709,2.3336982,381.405527,29.2651934,387.7082347,2.076491,3.3559706,2.2655346,8.1514232),(11381,'Cervus-giganteus-tibia-cleaned.tif',249,8,391,43.0736425,106.3144131,132.7986726,1.8,106.4735101,132.9827009,1.2384915,5.8785834,7.8433727,161.6613774,209.7284582,6.414949,26.7395757,27.5000568,46.4226615,10.7422,13.9168507,1.7257931,45.7480381),(11382,'Cervus-giganteus-tibia-cleaned.tif',249,8,392,43.3213848,107.1443791,133.4381236,1.8,109.3131577,134.8910874,0.5118387,6.2167812,61.6401407,167.2464906,2677.6987813,1.7320293,43.4408285,26.902425,46.142479,10.7958833,15.8519352,2.1437625,52.5366744),(11383,'Cervus-giganteus-tibia-cleaned.tif',249,8,393,42.3144143,106.2648922,133.0725345,1.8,106.1756138,133.4874754,0.9699642,5.7907387,7.2930916,148.6874235,186.9522516,4.798476,25.6341564,25.6767627,45.602508,10.9380707,14.4441652,2.1010121,47.6753097),(11384,'Cervus-giganteus-tibia-cleaned.tif',249,8,394,42.7676573,107.2742239,133.7280452,1.8,109.8004272,135.5741356,0.5062586,5.6651577,61.3927582,154.3077149,3034.4451936,1.6760379,49.4267611,27.2380265,51.9297886,10.0265649,13.943359,2.1587989,42.2062743),(11385,'Cervus-giganteus-tibia-cleaned.tif',249,8,395,42.8314951,107.3687448,133.8637572,1.8,110.0319567,135.539884,0.5060745,5.7383155,61.2445244,157.304581,3197.1215595,1.6774255,52.2025698,27.4130239,54.758859,10.0951517,12.8188253,2.4511462,40.7392277),(11386,'Cervus-giganteus-tibia-cleaned.tif',249,8,396,42.741641,107.4153511,133.9640533,1.8,110.2211648,135.6203941,0.505376,5.6367119,61.1560746,155.7453292,3400.6807636,1.669689,55.60659,27.6305284,58.1398544,10.0215597,12.2215837,1.7475052,40.4875223),(11387,'Cervus-giganteus-tibia-cleaned.tif',249,8,397,41.7228093,107.4873824,134.1284752,1.8,110.5692305,136.088328,0.502697,5.5421212,61.0170388,144.2379378,3614.9612489,1.614132,59.2451112,26.0257637,61.5958822,8.7648424,14.8972278,2.1507991,48.9949106),(11388,'Cervus-giganteus-tibia-cleaned.tif',249,8,398,41.716543,107.5381053,134.2828862,1.8,110.8212366,136.4713142,0.5008071,5.0402229,60.9006786,141.3340623,3799.893108,1.6028078,62.3949222,28.0412325,64.7019057,8.3922875,13.8370211,2.2018757,43.5258753),(11389,'Cervus-giganteus-tibia-cleaned.tif',249,8,399,42.7881347,107.6649996,134.3975055,1.8,111.6461464,136.8466762,0.4998037,5.6978721,60.735604,150.8687573,4055.6583195,1.6379561,66.7756317,26.4780879,69.2453624,9.1608272,11.4655059,1.3439975,39.3332551),(11390,'Cervus-giganteus-tibia-cleaned.tif',249,8,400,44.1614034,107.676289,134.1660448,1.8,111.0002797,135.0977716,0.4936879,8.8175635,60.8417582,223.3097298,4118.8268221,1.6528074,67.6973668,25.3255596,71.3635868,8.1623751,16.1519256,0.4993467,47.0244532),(11391,'Cervus-giganteus-tibia-cleaned.tif',249,8,401,1.3546937,158.6876311,162.1787285,1.8,158.1625482,162.1044685,-0.0511055,0.897496,6.1527941,0.1315295,7.0231705,0.0005892,1.1414603,0.1465517,1.16276,13.0340963,200.4009738,0.04075,420.5507125),(11392,'Cervus-giganteus-tibia-cleaned.tif',249,8,402,1.3603446,158.6717753,162.1768587,1.8,158.1625482,162.1044685,-0.0519179,0.8924294,6.1369969,0.1319286,7.0630047,0.0006106,1.1508894,0.1478309,1.1723029,13.0041046,200.4009738,0.04075,420.1947473),(11393,'Cervus-giganteus-tibia-cleaned.tif',249,8,403,1.4132164,158.5665417,162.1743797,1.8,158.033761,162.1112259,-0.0525008,0.882717,6.4610906,0.1365735,7.9076038,0.0006486,1.2238807,0.1547194,1.2448937,12.9741128,200.4009738,0.04075,420.1947473),(11394,'Cervus-giganteus-tibia-cleaned.tif',249,8,404,1.4958531,158.5198843,162.1552929,1.8,158.0392464,162.0783136,-0.0553199,0.8762456,6.4152763,0.1571709,8.4963802,0.0007622,1.3243982,0.1793685,1.3487705,12.944121,200.4009738,0.04075,420.1947473),(11395,'Cervus-giganteus-tibia-cleaned.tif',249,8,405,1.5446406,158.4226567,162.1515479,1.8,157.9145526,162.0850538,-0.0558482,0.8656708,6.74738,0.1624363,9.4043839,0.0008021,1.3937831,0.1876422,1.4176812,12.9141292,200.4009738,0.04075,420.1947473),(11396,'Cervus-giganteus-tibia-cleaned.tif',249,8,406,1.6355019,158.3133489,162.1364138,1.8,157.7814336,162.0626886,-0.0566372,0.8665165,7.0680172,0.1830107,10.6091356,0.0008735,1.5010059,0.2112028,1.5266979,12.8841374,200.4009738,0.04075,420.1947473),(11397,'Cervus-giganteus-tibia-cleaned.tif',249,8,407,1.7071166,157.3818063,162.1321598,1.8,155.5545944,162.0677599,-0.0054819,0.9809368,123.0065073,0.2245738,191.9335835,0.0000085,1.5603531,0.228938,1.5621712,12.8541456,200.4009738,0.04075,420.1947473),(11398,'Cervus-giganteus-tibia-cleaned.tif',249,8,408,1.8050833,156.418858,162.1207377,1.8,153.6028939,162.0557726,-0.0042095,0.9715023,122.0440051,0.2514038,394.0055706,0.0000053,3.2283894,0.2587784,3.2304444,12.8241538,200.4009738,0.04075,419.8387821),(11399,'Cervus-giganteus-tibia-cleaned.tif',249,8,409,1.893315,154.6136528,162.1189714,1.8,149.9141149,162.0662286,-0.003441,0.9664895,120.2389439,0.2626619,797.6818266,0.0000037,6.6341387,0.271769,6.6363204,12.794162,200.4009738,0.04075,419.8387821),(11400,'Cervus-giganteus-tibia-cleaned.tif',249,8,410,2.0004573,153.5059208,162.1096314,1.8,148.4951176,162.0555654,-0.0033982,0.9550882,119.1312547,0.2894082,1075.0500666,0.0000038,9.0240808,0.3030172,9.0265074,12.7641702,200.4009738,0.04075,419.8387821),(11401,'Cervus-giganteus-tibia-cleaned.tif',249,8,411,2.1142017,151.5868036,162.1104185,1.8,145.4792274,162.0699586,-0.0032578,0.9505137,117.2121569,0.3031917,1556.6338765,0.0000037,13.2804815,0.3189766,13.2830658,12.7191826,200.4009738,0.04075,419.8387821),(11402,'Cervus-giganteus-tibia-cleaned.tif',249,8,412,2.2296805,149.7129945,162.1026229,1.8,142.9673744,162.0602215,-0.0032683,0.9379112,115.3383825,0.3288611,2072.9335089,0.000004,17.9726251,0.3506314,17.9754741,12.6946455,200.4009738,0.04075,419.8387821),(11403,'Cervus-giganteus-tibia-cleaned.tif',249,8,413,2.3656926,147.2290166,162.1058369,1.8,139.3090934,162.0772526,-0.0032328,0.9334391,112.8544092,0.3442577,2761.4801257,0.0000041,24.4694039,0.3688057,24.4724521,12.6646537,200.4009738,0.04075,419.5870767),(11404,'Cervus-giganteus-tibia-cleaned.tif',249,8,414,2.5242521,145.2340964,162.1006147,1.8,137.7026566,162.0713991,-0.0033012,0.9222167,110.8595135,0.3732735,3397.7046264,0.0000046,30.648742,0.4047568,30.6521066,12.6646537,200.4009738,0.04075,419.5870767),(11405,'Cervus-giganteus-tibia-cleaned.tif',249,8,415,2.6786154,141.432744,162.1035316,1.8,132.3018693,162.0811159,-0.0030318,0.9173134,107.0581777,0.3918884,4517.6474575,0.0000041,42.1980605,0.4272132,42.2017209,12.6346619,200.4009738,0.04075,419.5870767),(11406,'Cervus-giganteus-tibia-cleaned.tif',249,8,416,2.814068,138.0668865,162.1075273,1.8,127.8760257,162.0888366,-0.0029755,0.9122825,103.6923234,0.4056356,5511.4747016,0.0000042,53.1521961,0.4446382,53.1561079,12.6346619,200.4009738,0.04075,419.3353713),(11407,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11408,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11409,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11410,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11411,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11412,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11413,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11414,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11415,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,9,2.3956812,78.2745748,132.4440832,1.8,78.325984,132.4499309,0.1640465,1.6786694,2.5269273,1.355921,3.0892923,0.0106491,1.2225489,0.8077355,1.7581597,3.437504,5.4351711,2.8198421,13.9153498),(11416,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,10,33.1015683,78.3601793,133.3423553,1.8,78.3623133,133.6079133,0.5012193,4.7180281,5.0412398,101.2869088,132.4455886,1.2737244,26.272424,21.4680597,45.7536641,9.023448,10.4016451,2.4733032,30.6605329),(11417,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,11,69.6835576,78.1894755,134.2048586,1.8,78.1276581,134.3320696,0.5891066,5.9509512,6.6218894,407.1385439,485.9118653,3.5853564,73.3796412,68.4157092,134.8413496,11.171888,12.7538463,2.5722795,38.4991767),(11418,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,12,94.0363771,77.9881574,134.8611855,1.8,78.0170977,134.952553,0.7081925,7.0376325,7.2080083,781.9763991,839.2218874,6.6311445,116.4290951,111.1135596,222.0407708,12.89064,14.4377726,0.9332475,43.5079871),(11419,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,13,109.6408395,77.8070816,135.4976403,1.8,77.8586251,135.5119337,-1.0585698,7.4036503,7.7306193,1048.0682079,1181.3985538,13.883877,152.8206878,141.5610096,285.8074095,13.750016,15.8519352,0.9978302,46.1903749),(11420,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,14,120.9325273,77.6371028,136.0141103,1.8,77.668151,135.9931244,-0.8830647,7.4773628,8.1877328,1177.3990899,1563.9919451,12.0337274,191.0164852,157.4618117,332.6535722,14.1332869,16.9331967,0.947597,48.5167975),(11421,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,15,127.9529548,77.5097184,136.406217,1.8,77.5607565,136.3750498,-0.7805752,7.242027,8.5296665,1253.5400948,1840.5077048,10.5598951,215.7772179,173.0924348,362.4983061,14.1332869,17.3851149,0.8728935,49.7321387),(11422,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,16,132.2137527,77.4011902,136.7007829,1.8,77.4528318,136.6753205,-0.7205488,7.2808859,8.5647565,1311.7838424,2009.5517842,9.5928196,234.6303457,180.1681645,386.9092861,14.0308944,17.4487192,0.9075933,50.3398093),(11423,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,17,138.1457479,77.311898,136.9209471,1.8,77.3369856,136.9222446,-0.6729132,7.2405156,8.8578482,1401.6872618,2209.8306722,8.94405,249.4771435,193.589427,406.6013827,14.2226203,18.0520106,0.6673061,51.1991853),(11424,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,18,145.2679467,77.1915953,137.1903033,1.8,77.236008,137.175844,-0.6376771,7.2952035,9.1325252,1530.5512412,2481.2100324,8.5809437,271.6893709,209.8024062,439.1773842,14.5037737,18.3914495,0.6528466,52.4145265),(11425,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,19,158.5911436,77.4948869,137.2836995,1.8,78.6375823,136.8977331,-0.4072087,7.4110582,30.4650088,1788.4753752,4801.646729,4.145939,157.611861,241.3252353,215.9907589,14.7314111,19.0812438,0.625485,55.2011741),(11426,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,20,189.8547865,80.218844,136.5694338,1.8,82.3378959,135.8975091,-0.3120912,7.7726922,28.3608093,2133.675146,19328.296699,2.9832324,681.5142862,274.5091537,755.0941232,15.0671961,19.9052705,0.5700405,57.1716315),(11427,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,21,254.5953038,84.904876,135.9402971,1.8,87.6857669,135.3945927,-0.2265287,8.2925433,25.2945377,3435.0785228,42455.8368261,2.1404452,1678.4586978,414.2370305,1793.0406081,15.595068,21.4543008,0.5713375,60.9651007),(11428,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,22,330.4818737,88.0129609,135.683348,1.8,89.7379719,135.2375627,-0.1961756,9.6826327,24.7477096,5544.6000522,62506.0269648,2.0927037,2525.7297693,572.6335179,2719.4858984,16.2899999,22.8826511,0.5984189,64.2551591),(11429,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,23,393.4791313,89.4662336,135.5470542,1.8,90.8341866,135.1677133,-0.1892519,10.5882572,25.2503639,7660.7975412,79157.5376481,2.3209168,3134.9068086,723.518271,3422.2265247,16.8413434,24.0778691,0.607802,68.152888),(11430,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,24,462.0259725,90.7092997,135.4730876,1.8,91.7324141,135.1597941,-0.1820145,11.293746,26.1885444,9866.0840096,97951.2869817,2.5230485,3740.2341102,873.5882704,4116.9310524,17.3591083,24.8365611,0.6504214,71.4429464),(11431,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,25,529.7416351,91.5445317,135.4251626,1.8,92.5488419,135.1083303,-0.1769803,11.9331272,27.54757,11963.8374303,115890.5655238,2.7366766,4206.9251683,1002.5735306,4640.7675541,22.8762834,54.0399928,0.1677631,149.6134552),(11432,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,26,581.6470547,92.3605055,135.3293249,1.8,93.419361,134.9597686,-0.1760291,12.4865319,29.0680255,14322.8517154,134566.6259467,2.9729455,4629.3693335,1147.0640388,5116.5620533,24.3378122,56.544394,0.1988859,150.9330562),(11433,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,27,623.9289626,93.1437514,135.1453925,1.8,94.2851282,134.7228046,-0.1807971,12.9961607,30.9612288,17059.7278288,156010.4891,3.3622463,5038.8984876,1312.6744261,5582.8511593,25.5029272,59.2424295,0.2045078,162.3745378),(11434,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,28,673.9847076,94.1134252,134.8349504,1.8,95.2144682,134.3525405,-0.1912442,13.4739622,32.9994499,20511.5234773,185167.4965718,4.0585805,5611.2297936,1522.3082291,6230.151361,26.7103576,62.30476,0.1662825,164.5535148),(11435,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,29,729.8538918,95.0653496,134.4027041,1.8,95.9095923,134.020721,-0.2082907,14.2947722,34.8681522,25074.9982036,220901.0041732,5.2015747,6335.3229381,1754.1376529,7049.3926122,27.6671036,65.3422517,0.1651487,171.7413021),(11436,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,30,787.2866274,95.8344293,133.8488364,1.8,96.5063502,133.4870745,-0.2278377,15.0800318,36.4637997,30679.5927809,256014.2837079,6.694295,7021.0533754,2034.4514664,7831.6595872,29.0829784,67.7654895,0.2172934,177.9654537),(11437,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,31,839.723227,95.9374433,133.3228356,1.8,96.5026959,132.9728272,-0.2457653,15.6930724,37.3320749,37336.3604756,280966.7365437,8.2844682,7526.1484132,2379.161934,8465.2024617,31.2753972,68.7930354,0.2267988,180.2918763),(11438,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,32,896.7760688,95.5974404,132.6873011,1.8,96.1018671,132.1974688,-0.2581071,17.534711,38.2956785,47229.1665828,298816.5315317,9.7379392,7802.8786306,2693.4670715,8975.3196462,34.1005323,69.4089113,0.2374713,181.9063685),(11439,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,33,960.973321,95.2195236,131.8297115,1.8,95.9057518,131.5603211,-0.2675431,18.5739133,39.229056,61994.6328098,320078.1796908,11.1933601,8159.2118756,3337.7259701,9657.3246503,35.9413809,69.9283392,0.241998,185.8040975),(11440,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,34,990.5854047,95.0035706,131.3025829,1.8,95.4733365,130.740664,-0.2715303,38.6152109,39.6583156,78509.7740591,335576.4273651,11.8762069,8461.6913767,2033.130786,10364.8510009,37.8900957,70.1458257,0.2286354,191.7765437),(11441,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,35,1058.1592925,94.6661067,129.6806931,1.8,94.9437784,129.2500393,-0.2549365,37.6785933,39.8153832,127525.082714,355550.4436769,11.2159193,8929.9766759,3384.5499949,12035.4235413,40.7965191,70.2851893,0.2093854,202.7146145),(11442,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,36,1178.7555662,93.8624395,127.1087984,1.8,94.0798209,126.9252806,-0.1878287,35.5146606,39.7748186,203014.4332794,379257.1270992,6.8498812,9535.1063976,5716.3557209,14502.1478458,56.4549439,70.2484031,0.2598144,249.6169197),(11443,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,37,1338.5014976,93.1355738,124.7137221,1.8,93.4547241,125.3724333,-0.0494542,33.0337793,38.8807323,270746.9596895,415327.4987798,0.5451547,10682.0904321,8196.0637028,17110.9109689,57.1188609,70.177404,0.2791407,251.3788576),(11444,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,38,1518.9140472,92.7574578,122.9877258,1.8,92.7309235,123.0921136,0.0716501,35.2488028,37.9747862,317845.0987981,479330.9582499,1.2973952,12622.3477856,9017.1884925,19933.2513413,58.1113015,70.5526237,3.0928508,258.5666449),(11445,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,39,1774.19758,91.8769719,120.7268145,1.8,93.0756497,121.0720174,0.2042481,34.9981271,37.786604,391578.9681029,588893.0588593,12.1651943,15584.7045352,11188.5692379,24330.1990781,58.7775529,70.7251307,3.0564333,271.6658045),(11446,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,40,1939.7078834,92.7729278,119.1188293,1.8,93.516189,120.115476,0.174575,35.9415532,37.3596124,470604.8683906,622274.3744761,9.7528729,16656.33913,13093.615243,27906.0879577,59.358576,70.7094656,0.283308,254.8595474),(11447,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,41,2078.4559785,93.9980766,118.0044034,1.8,94.4092695,119.4297994,0.0732031,36.6831685,36.6549425,526718.7089236,648174.6463225,1.8529906,17683.1445343,14358.5936189,31062.9475723,59.8949627,70.7094656,0.283308,233.5047048),(11448,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,42,2135.1498513,95.1452414,117.5275493,1.8,94.9994121,119.2823245,-0.0627063,35.8947491,36.3107294,549735.2825542,660179.5391271,1.3974287,18181.3901864,15315.2005694,32564.5189573,60.1800253,70.4740719,0.2715996,228.244189),(11449,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,43,2104.7816725,95.7696683,117.7037163,1.8,95.5039908,119.2041929,0.0047827,35.7250748,34.8387917,546896.5060188,644172.3963554,0.008024,18490.0900476,15308.4775609,32634.5979991,60.4620223,69.5789468,2.7553524,226.6728827),(11450,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,44,2064.1798578,96.2130775,117.8534938,1.8,96.0306798,119.0928862,0.0854378,35.2894056,33.8730637,541236.9052956,623298.7833169,2.5051819,18401.0158769,15337.0932704,32447.5347261,60.4824975,69.5046074,2.7748627,224.2422003),(11451,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,45,2066.6467062,96.3893046,117.9912732,1.8,96.477855,118.9474431,0.1829692,34.8715778,34.1948658,544036.5911419,613667.6270326,11.4030039,17946.1920216,15601.1463994,33023.6777928,60.58313,69.2851081,2.7334435,224.8498709),(11452,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,46,2083.780703,96.2619527,117.9722072,1.8,96.652013,118.7330784,0.2706255,33.9987341,34.8388806,542899.6736994,605810.7883818,24.820455,17388.9280375,15968.2319808,32810.1634968,60.7661996,69.2384582,2.7195876,219.9274321),(11453,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,47,2107.2475697,96.0689578,117.7647951,1.8,96.8348226,118.3252617,0.3326098,32.9627162,35.2367816,530306.2494639,605134.5238283,37.4420514,17173.376713,16088.0628454,32196.5282488,61.0748392,69.1156854,2.7391498,220.6393625),(11454,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,48,2109.5034903,95.8818862,117.3777456,1.8,96.9201416,117.8441753,0.3575961,32.7385776,35.5723169,504979.615133,601792.05941,43.0747927,16917.4266022,15424.6046178,31104.406882,61.1369779,69.2384582,2.7195876,228.5390803),(11455,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,49,1963.6165795,96.741773,115.672028,1.8,97.3979358,116.895534,0.4037363,34.01979,35.0578758,403734.4855547,577363.2440162,50.5096442,16468.8598682,11867.6360215,27966.3487405,60.4205392,68.7205326,2.7367009,231.0308366),(11456,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,50,1793.8968954,98.2253594,114.4990006,1.8,98.2533275,115.6491281,0.453254,31.9322159,33.8620276,318957.1246267,535758.5052087,57.3301024,15821.8081983,9988.5684572,24594.5599274,58.7422483,68.2230348,2.7540688,259.6166524),(11457,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,51,7.1026166,92.4685949,135.2355179,1.8,93.0362211,135.4394114,0.2645027,4.8769637,5.4085379,11.3396278,17.0350354,0.0809051,3.1496563,2.3251409,4.8543278,7.4070205,9.6081158,2.677945,28.9417809),(11458,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,52,29.8983189,92.6765497,135.5314736,1.8,92.9648875,135.5583008,0.0070741,4.9450189,5.3213068,88.5321489,126.4320514,0.0002494,23.7595871,17.9032983,32.0594649,8.8329186,12.1077509,2.6620734,33.8031457),(11459,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,53,53.3553386,93.5444625,135.5922243,1.8,93.6655588,135.387862,-0.2180196,6.2417306,34.5213869,234.4691366,420.6826713,0.4160312,12.1861463,37.5647639,18.6753362,10.2873912,13.4856331,2.6066376,39.9662233),(11460,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,54,77.1853705,94.7565378,135.1529797,1.8,95.75486,134.5302736,-0.3918363,7.4886158,32.8343884,405.9758652,1310.9456713,1.8760809,39.9259964,54.2124041,52.2896824,11.1461045,21.337806,0.4366272,58.5344183),(11461,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,55,103.3501551,95.9189681,134.6760732,1.8,96.6380016,134.3209704,-0.4046781,5.998069,30.3925514,595.187122,2487.4147288,2.6701841,81.8429059,99.2297899,101.4222078,11.6727634,24.0970318,0.3838176,60.5048757),(11462,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,56,134.3958206,97.1718231,134.2199805,1.8,97.558446,134.0869971,-0.3661006,6.3040099,27.1139146,860.7806974,4765.5675314,2.8704181,175.7609553,136.5449469,207.2776368,12.2225761,27.3687983,0.3863372,67.9443685),(11463,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,57,180.6190015,98.5801529,134.0084686,1.8,99.6983811,133.8707165,-0.338587,8.6108471,30.9615445,1298.8047046,14872.9696667,3.3211828,480.3691128,150.8335578,521.4425301,13.2357273,38.6241474,0.363979,88.90006),(11464,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,58,283.2053405,101.54478,133.0424174,1.8,101.7477444,133.0439077,-0.3533284,8.1085407,30.0761786,2248.4382519,53182.3752189,5.6514377,1768.255733,277.2925896,1836.8017202,15.0830528,57.5493251,0.4068526,136.6617413),(11465,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,59,408.6287281,102.7707608,131.8004674,1.8,102.1442138,131.5862845,-0.3609634,12.0172829,28.9268711,6515.2133566,88928.7327821,8.4949202,3074.260351,542.1536144,3295.6168211,21.4977216,58.2872999,0.4174758,153.216293),(11466,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,60,608.2790137,103.5281529,129.7959557,1.8,102.2626154,130.1277875,-0.389012,13.2419973,31.2761442,16017.5032079,143275.8281314,14.5833986,4580.9939704,1209.5987373,5054.673811,26.076697,59.9595694,0.4764674,161.9143128),(11467,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,61,792.9163859,102.7406941,127.7123528,1.8,101.9580694,126.7485545,-0.4370088,41.0902373,32.2418993,60121.9469078,205395.9495355,23.6718241,6370.4668071,1463.1686462,6150.247028,29.901951,60.9445442,0.5488836,167.9299448),(11468,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,62,1045.9178699,102.8404772,122.6907391,1.8,101.2625959,121.7984448,-0.7663104,37.9267415,35.8492628,167082.0013356,294642.4648169,83.8332635,8218.9267441,4405.3877214,11337.7307103,6.44532,9.2557628,1.1902899,24.3931955),(11469,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,63,1495.6517301,101.1569484,117.1946636,1.8,99.3586476,117.1469923,-0.9214251,34.1848504,38.6207836,313698.6974619,456544.8916864,158.1290728,11821.2229167,9176.5414729,19925.4471654,61.2181009,70.9831051,1.1531866,289.6263289),(11470,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,64,1795.9982848,98.8978781,115.683639,1.8,97.737152,116.2680654,-0.806255,34.0385608,38.0820103,421677.7437429,537512.7042113,155.9078687,14114.6095014,12388.2365677,24931.6833321,61.6573245,71.1584605,1.1476671,295.7894065),(11471,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,65,2082.8687899,96.5332477,113.7149861,1.8,96.0149853,114.4875548,-0.1938414,33.6801422,31.674122,556446.9603384,567849.4909862,12.8812402,17927.8683886,16521.5145581,29129.4498123,61.9942372,71.1584605,1.1476671,234.1555613),(11472,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,66,2165.7393644,95.7496617,112.9397974,1.8,96.0667117,114.2756242,0.5361869,38.712608,37.206823,570423.8400924,628754.1138413,94.2023376,16898.8928092,14734.8336612,30972.7592437,63.0860258,71.0338077,1.1666988,234.5115265),(11473,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,67,2162.890608,95.6868047,112.8041578,1.8,96.0282338,114.1538815,0.4988841,38.7969047,37.0414962,575443.7780595,645986.0542801,82.5180601,17439.5237835,14832.2084622,31477.1060325,63.9138767,71.1532709,2.1453994,235.3709025),(11474,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,68,2141.6427354,95.6228455,112.8769314,1.8,95.9240668,114.194297,0.5523964,38.7148554,37.3153658,570007.2533047,644088.9768259,98.2800548,17260.6904382,14723.2179142,31346.3266915,63.9956839,71.1532709,2.1453994,233.6521505),(11475,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,69,2085.4609641,95.5651374,113.0546986,1.8,95.8881627,114.2651402,0.6399254,38.4894104,37.7110671,554109.5355925,627898.1311456,123.9357974,16650.2350476,14396.4152538,30629.8171197,63.8864828,71.0377065,2.1755759,235.2234568),(11476,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,70,2021.6406963,95.5422896,113.2058881,1.8,95.8814038,114.3768773,0.7344441,37.7885632,37.7314039,531275.38922,606997.414982,151.3313068,16087.3265403,14059.1582314,29490.1832346,63.3931257,71.0532991,2.1319597,231.7859528),(11477,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,71,1930.7201203,95.6104308,113.329111,1.8,95.9215402,114.5740173,0.8186664,37.292553,37.6647306,503930.6103064,580503.8571657,171.5907159,15412.3990169,13512.901915,28033.7465592,62.564972,70.7929726,2.1486983,230.9697627),(11478,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,72,1822.1146735,95.6376736,113.7257704,1.8,95.9111854,114.7589036,0.9110604,35.8040529,37.0407595,474411.799415,552229.8118876,189.6042382,14908.7065158,13250.2262033,26875.9134216,61.015696,69.9811253,2.1860494,229.5027161),(11479,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,73,1730.7669267,95.6333533,114.2257288,1.8,95.8529256,115.0320006,0.9579804,34.6586858,36.5019247,447291.196472,524140.1330345,193.0312163,14359.2464561,12905.6017649,25793.8563294,59.296944,69.2811108,2.1932088,228.4958945),(11480,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,74,1651.3438191,95.5738661,114.6358245,1.8,95.7123315,115.3381298,0.9983659,33.4717328,36.1515899,419900.5091655,495121.2658857,194.4695104,13695.6982236,12544.9289474,24660.588856,57.3347763,68.6479532,2.1692152,235.0149373),(11481,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,75,1585.5505091,95.5087781,115.0430731,1.8,95.6042286,115.7506392,1.0553944,31.9698175,35.4045181,394817.1197234,469534.7397924,200.0607422,13262.0005821,12349.6832637,23565.277324,56.1294163,67.7327868,2.1939957,227.0109597),(11482,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,76,1517.3824986,95.4654343,115.2724017,1.8,95.5681836,115.8418585,1.0924046,30.643233,34.928687,370050.1942193,444190.2597204,199.3021153,12717.0614893,12076.0819868,22458.7203039,54.5331474,66.988621,2.1783694,299.2700963),(11483,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,77,1466.930243,95.4675797,115.5131605,1.8,95.4944039,115.9846978,1.1057162,29.9126618,34.4395593,351440.3248366,425437.2964316,195.3102108,12353.1573726,11748.8817126,21672.7394037,53.2971942,66.5336869,2.1910458,336.111595),(11484,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,78,1426.2330352,95.4925757,115.8188275,1.8,95.4850269,116.2123707,1.1205534,29.1413154,34.0550845,333085.3584384,410484.4017948,192.6875655,12053.5423114,11430.0042331,21089.1130967,52.3178522,66.1845066,2.1948194,228.4780063),(11485,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,79,1399.1470499,95.5520828,116.0970425,1.8,95.6171735,116.4453669,1.1186769,28.732686,33.7915482,317960.1283674,396659.1242255,188.6847717,11738.4122653,11066.1470318,20402.3141364,51.3800524,65.6860716,2.1842018,221.8978895),(11486,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,80,1379.1180269,95.5559166,116.3149458,1.8,95.7196168,116.7275036,1.1209964,28.2138215,33.5777524,305399.6716687,385045.2433442,186.4019787,11467.272681,10824.4702544,19824.3968145,50.6490338,65.2362052,2.1971713,217.9569747),(11487,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,81,1315.0425197,95.4516181,116.5476123,1.8,95.5706805,116.9473894,1.1378835,27.1805851,33.107302,283938.5671197,367237.4297401,180.6004263,11092.3393833,10446.374365,19018.6284666,49.6432455,64.7361729,2.1864162,210.1615167),(11488,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,82,1275.0407023,95.3642078,116.6979423,1.8,95.4159983,116.9585063,1.1433375,26.5563499,32.9661374,272560.8992687,357697.8647563,175.9854281,10850.463316,10263.4925653,18512.5758037,49.0864077,64.4889974,2.1809764,206.2206019),(11489,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,83,1247.4877665,95.3880131,116.8851221,1.8,95.4023581,117.049138,1.140447,26.1581222,32.8081419,261318.3277401,349175.7862698,171.7279052,10642.9613674,9989.9498017,18016.6896428,48.6297898,64.2437448,2.175495,203.7899196),(11490,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,84,1225.7837976,95.4326578,117.070566,1.8,95.5289322,117.2473022,1.1388894,25.7264883,32.6328943,251042.5892712,342465.1627555,168.4985388,10494.4771267,9758.1366818,17604.5466266,48.0446569,64.1373214,2.1848154,202.4703186),(11491,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,85,1202.6597864,95.4661341,117.240508,1.8,95.5797638,117.4154094,1.1368042,25.3894508,32.5089442,241368.9058873,335426.6765737,165.0015036,10317.9812524,9506.6611495,17291.6819181,47.6659613,63.7692316,2.1401095,202.8262838),(11492,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,86,1183.0206162,95.5022714,117.4282025,1.8,95.6510039,117.6058151,1.1390598,24.9758906,32.3083011,232736.836851,329381.1998275,162.6457601,10194.9402518,9318.4599576,16937.9863553,47.2108081,63.6417104,2.1494359,205.0916324),(11493,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,87,1164.9551241,95.52993,117.5944238,1.8,95.7172576,117.8241984,1.1380379,24.8159036,32.2417112,224896.9755419,323591.4696651,160.0111169,10036.4235564,9062.6148104,16601.1583806,46.792763,63.4077407,2.1437625,202.5745784),(11494,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,88,1149.5375874,95.575267,117.7436312,1.8,95.7953936,118.041879,1.1412969,24.6057423,32.1071477,218222.731488,317904.0826987,158.3675618,9901.3492621,8868.772535,16298.5992297,46.5153089,63.1626745,2.1625725,202.9737294),(11495,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,89,1135.7745193,95.6344196,117.8448134,1.8,95.9006404,118.1405452,1.1433974,24.4016167,31.9492486,211815.6386062,312621.6507464,156.7719978,9784.9453326,8680.3936345,15999.6665711,46.1034184,62.9401256,2.1815223,205.1958922),(11496,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,90,1125.4532113,95.6788447,117.9465455,1.8,95.9191837,118.3127173,1.1481056,24.1958043,31.8769883,206304.0136651,308657.130859,156.010882,9682.7569713,8526.4375203,15726.3520973,45.8023386,62.9239896,2.156905,198.2166244),(11497,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,91,1119.1603449,95.6967584,118.0302921,1.8,96.0097003,118.4262749,1.15346,24.0050722,31.9305297,201414.0532487,305172.8783969,155.8822759,9557.4010656,8390.4789779,15507.2499053,45.4883087,62.8138606,2.1417228,201.2981632),(11498,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,92,1111.5643697,95.7007731,118.1221968,1.8,96.0269793,118.5231039,1.1583054,23.7868592,31.8257478,196711.7619337,301632.6671391,155.4865768,9477.6301682,8269.7661182,15290.1853064,45.1163027,62.6873412,2.1511945,199.7268568),(11499,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,93,1109.6050909,95.724359,118.2457972,1.8,96.0341639,118.6295798,1.1611835,23.6233685,31.6912574,193735.5846814,299741.0114972,155.6024396,9458.1609042,8201.0143864,15193.1661798,44.8143331,62.5664682,2.1607037,198.6157754),(11500,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,94,1106.111522,95.7426034,118.359097,1.8,96.0211629,118.7890782,1.1666323,23.4453375,31.5568503,190340.5715581,297211.1289956,155.8426781,9418.2761063,8118.4828893,15057.4605687,44.5419179,62.3284624,2.1549749,210.2478884),(11501,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,95,1106.3480744,95.7520502,118.4360563,1.8,95.9827888,118.767098,1.1717401,23.2658642,31.2927002,187805.3379669,295473.6209462,156.5537459,9442.2539013,8072.1410715,14956.2550865,44.2772973,62.2202468,2.1396442,195.4731626),(11502,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,96,1104.6596448,95.7431938,118.5258488,1.8,96.0386035,119.0347978,1.1763042,23.1142292,31.359166,185137.8180787,293354.583254,156.913823,9354.6678858,8009.6903246,14838.1509867,43.9908408,62.0925179,2.1492023,205.8467486),(11503,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,97,1099.0853877,95.7411513,118.5157246,1.8,96.0422639,119.0914055,1.1791251,22.9566808,31.0969215,180113.8790696,288164.0314495,156.4876811,9266.6417646,7845.8153756,14636.3740968,43.624295,61.6269069,2.1375255,183.1723051),(11504,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,98,1097.6549949,95.7358882,118.5578159,1.8,96.0430862,118.9580595,1.1771025,22.8291947,30.962371,177298.8438733,285438.6824948,156.0223836,9218.8896713,7766.3205544,14476.891871,43.4145914,61.4979457,2.1471715,180.3424717),(11505,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,99,1096.5488827,95.7076334,118.6177838,1.8,96.0234818,119.0505458,1.1758323,22.7227691,30.9595471,174390.7993482,282579.0067173,155.7004774,9127.3624184,7674.7159798,14310.0608436,43.1117908,61.2648301,2.141291,198.8674808),(11506,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,100,1097.3277491,95.6909131,118.6723138,1.8,96.0030493,119.0416332,1.1761366,22.5917319,31.2448518,172144.7166869,280341.5998374,155.8505877,8972.4093445,7619.8105427,14216.6525792,42.8989872,61.0338491,2.1353657,196.9402092),(11507,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,101,1094.8180997,95.6605468,118.7391291,1.8,95.9972078,119.0894127,1.1774271,22.5014429,31.0238399,169384.0160121,277189.9671382,155.6610896,8934.7407606,7527.6957523,14090.0722848,42.5708595,60.8050273,2.1293956,188.4938948),(11508,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,102,1098.3906686,95.626151,118.8157108,1.8,95.9714197,119.2486431,1.1801163,22.3745938,30.8137911,167403.3872614,275901.7560701,156.5166767,8953.8400358,7481.8514518,14005.3334468,42.3138615,60.6712761,2.1391551,190.967763),(11509,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,103,1102.9972315,95.607914,118.915069,1.8,95.9269828,119.4254291,1.1822643,22.3197322,30.6424543,165771.5785993,274914.3137458,157.4505868,8971.6806249,7427.1311676,13953.1717843,42.1497976,60.4410816,2.1331635,186.4191776),(11510,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,104,1106.5778011,95.5950397,119.0006703,1.8,95.9432606,119.5482342,1.184815,22.1830188,30.6229305,163992.1205439,273731.270796,158.2906962,8938.767999,7392.6872693,13886.336375,41.8927996,60.3095848,2.14299,179.8390609),(11511,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,105,1110.7192597,95.5771913,119.0679575,1.8,95.8569327,119.611951,1.1844545,22.1532952,30.5697829,162500.017991,272366.8596395,158.8365486,8909.6759679,7335.252693,13814.7931926,41.7214676,60.1839365,2.1528584,174.9776961),(11512,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,106,1114.9254514,95.5695383,119.1348486,1.8,95.8698054,119.7256928,1.1828452,22.0363032,30.5217358,161105.1812146,271133.8582029,159.2289576,8883.30402,7310.8987331,13752.8045649,41.4717377,59.948791,2.1468711,172.5470137),(11513,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,107,1120.5202978,95.5598338,119.1928427,1.8,95.8415922,119.7532632,1.181787,21.912578,30.550612,159863.1248677,270151.3229161,159.8894338,8842.7466798,7295.4959737,13699.7918295,41.3821884,59.848613,2.1309177,172.7555333),(11514,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,108,1122.4776184,95.5337726,119.2542049,1.8,95.8177438,119.8575438,1.1807367,21.8971915,30.5099172,158180.7290503,268546.7251903,160.0306659,8801.9486772,7223.7907281,13609.6489838,41.2021104,59.7158115,2.1408368,173.2589441),(11515,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,109,1127.7286581,95.5170897,119.3396412,1.8,95.8158112,119.9709171,1.1791584,21.7944977,30.4465686,157025.8759362,267842.7704415,160.5703138,8797.141454,7204.8403305,13575.6515009,40.9650098,59.5889112,2.1507991,171.0799671),(11516,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,110,1129.431019,95.5097315,119.4238263,1.8,95.7625804,120.025142,1.1782052,21.6768015,30.4733763,155483.7483745,266093.930809,160.6859814,8732.0134238,7172.8178419,13458.5831437,40.7936778,59.4850234,2.1347555,170.4722965),(11517,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,111,1131.4132929,95.49622,119.5094703,1.8,95.7584612,120.1509533,1.1772563,21.5646826,30.4736317,154219.3793885,264483.5908481,160.8413834,8679.0965197,7151.4792284,13393.0696178,40.6185657,59.3545191,2.1447436,170.3248509),(11518,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,112,1132.2015587,95.4728796,119.5729677,1.8,95.7736406,120.2574335,1.1758386,21.5551683,30.4329164,152851.1895156,263172.3460283,160.763693,8647.6216346,7091.1619503,13323.3913631,40.5366797,59.1223207,2.1386404,169.6129205),(11519,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,113,1128.1621511,95.46677,119.5784356,1.8,95.7970088,120.3188272,1.1739937,21.412257,30.4418264,150184.5710861,259638.3303392,159.9432858,8528.9997819,7013.9533192,13125.1564608,40.3321153,58.9941438,2.1486983,172.9640529),(11520,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,114,1128.7207461,95.4568419,119.6279771,1.8,95.7497666,120.2050825,1.1709148,21.3589637,30.4191973,149165.9487304,258207.4870382,159.6083181,8488.3070446,6983.7633804,13060.9946431,40.1242135,58.8923419,2.1324892,169.2137695),(11521,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,115,1128.0702268,95.4538501,119.6850489,1.8,95.7549709,120.3229093,1.1686692,21.3396498,30.381689,147727.8525551,256480.7718821,159.2128853,8441.9523852,6922.6933911,12977.9515056,40.0202625,58.6646088,2.1262901,169.9256999),(11522,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,116,1127.6919555,95.4521149,119.7400791,1.8,95.7521063,120.3805793,1.1661454,21.2126508,30.3472217,146604.5011763,254794.9076002,158.8169918,8395.9879403,6911.1825206,12905.7138832,39.9364915,58.5291209,2.1363994,169.5697347),(11523,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,117,1123.6027533,95.4514102,119.7875174,1.8,95.7473397,120.4482057,1.1608169,21.0985728,30.5073429,144936.526269,252119.1272592,157.5151858,8264.2112809,6869.4943435,12741.7592172,39.8718728,58.4391477,2.1200428,169.7782543),(11524,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,118,1125.21968,95.4724819,119.8654273,1.8,95.7711226,120.5592548,1.1565295,21.09156,30.5019244,143957.8112856,250807.3603857,157.1516561,8222.6733318,6825.3752267,12699.1351015,39.803266,58.299969,2.1301769,169.9256999),(11525,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,119,1126.3275826,95.4847485,119.9478687,1.8,95.7859951,120.6414119,1.1543273,21.0018778,30.4331087,143099.597003,249447.712346,157.0011245,8196.5899249,6813.6572548,12658.0624784,39.6627678,58.0730923,2.1239055,168.7103587),(11526,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,120,1128.498125,95.4822182,120.0477824,1.8,95.7658186,120.7360336,1.1547443,20.996236,30.5142171,142645.9649357,248455.292405,157.3616977,8142.2797717,6793.8827049,12577.5603121,39.5717581,58.0730923,2.1239055,169.2137695),(11527,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,121,1129.8522592,95.4803514,120.1302607,1.8,95.7626734,120.8136828,1.1539833,20.8629592,30.443868,142171.6952283,246997.4531477,157.444495,8113.2086465,6814.5507853,12565.6157508,39.4982665,57.8485174,2.1175852,167.8509827),(11528,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,122,1130.4958408,95.4775058,120.2091272,1.8,95.7458314,120.8860238,1.1509909,20.7855644,30.3898984,141511.5544834,245629.9988896,157.1156161,8082.6199476,6808.1651236,12525.7793735,39.4767648,57.7766608,2.1010121,167.7035371),(11529,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,123,1131.7913964,95.4814207,120.2945664,1.8,95.7269081,120.9334023,1.1473998,20.7986516,30.3304288,140856.0271202,244625.3100239,156.7897973,8065.3429363,6772.3634094,12501.4103213,39.3817715,57.6262713,2.1112158,167.4950175),(11530,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,124,1131.5945118,95.4983193,120.3816867,1.8,95.7382459,121.0108017,1.1435432,20.7017022,30.2653372,140058.4089996,243542.3826675,156.2157765,8046.9079607,6765.5503836,12473.2953486,39.3817715,57.4819127,2.1214719,166.1322307),(11531,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,125,1136.4118905,95.52169,120.4872046,1.8,95.7545269,121.1272342,1.1409155,20.7010786,30.1739208,140060.3928849,243264.6656849,156.5045671,8062.0833931,6765.850004,12505.0012282,39.2903646,57.3436305,2.1317785,165.5245601),(11532,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,126,1137.0140699,95.5380303,120.5791373,1.8,95.7615582,121.2012857,1.1374859,20.7072029,30.1019742,139547.2185379,242152.3249234,156.0936126,8044.4001095,6739.0665681,12486.5170633,39.2734941,57.2582437,2.1150768,165.5245601),(11533,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,127,1139.2351902,95.5394405,120.6832373,1.8,95.7454937,121.323079,1.1343418,20.6913825,30.0236231,139356.7073845,241482.6030328,155.9423416,8043.08669,6735.0118886,12493.5963479,39.1864137,57.1161875,2.1254084,164.6651841),(11534,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,128,1139.5478333,95.5379008,120.7663519,1.8,95.7704729,121.4477786,1.1312228,20.6808139,29.9653582,139029.4323663,240727.1212118,155.5300817,8033.5138791,6722.6286731,12454.3567175,39.0835834,56.980258,2.1357904,166.4881959),(11535,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,129,1137.3477499,95.5409164,120.8067668,1.8,95.7616025,121.516973,1.1282534,20.6907617,29.7588862,138016.1890497,238347.9051522,154.7952168,8009.3019554,6670.4257317,12428.5782122,39.0835834,56.7513588,2.1293956,163.7015483),(11536,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,130,1138.5765583,95.5418208,120.8893008,1.8,95.7498359,121.5011364,1.1243005,20.8572238,29.7026009,137992.0692627,237367.2204144,154.3800263,7991.4624675,6616.0324267,12422.9132331,39.0824627,56.6178145,2.1398538,163.8058081),(11537,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,131,1137.312446,95.5357326,120.9664335,1.8,95.7484638,121.6056866,1.1198944,20.8592751,29.6561109,137371.6810899,235791.1763386,153.5557572,7950.8461914,6585.6402144,12374.1778349,38.9807532,56.524799,2.1229493,163.4498429),(11538,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,132,1136.45637,95.5366588,121.0393227,1.8,95.7563549,121.6936127,1.1177868,20.8476027,29.5997478,136922.7645502,234352.0230227,153.1265001,7917.3655248,6567.794222,12335.7755035,38.9807532,56.4904916,2.1503603,163.1981375),(11539,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,133,1130.9724146,95.5320356,121.095575,1.8,95.7751247,121.7209557,1.1156382,20.8464155,29.5609523,136066.2361428,231916.9225821,152.0682866,7845.3806302,6527.080702,12243.6776766,38.9785118,56.3694322,2.1609131,163.5541027),(11540,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,134,1129.1860742,95.5228799,121.1633713,1.8,95.7725294,121.8154843,1.1110878,21.0314573,29.5244741,135606.0116896,230499.1871065,151.1494432,7807.05479,6447.7705844,12201.0686932,39.0331327,56.2563178,2.1439695,163.3023973),(11541,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,135,1126.5124941,95.5285701,121.2238721,1.8,95.7834904,121.9109612,1.1061283,21.0550752,29.4903468,134906.9118626,228975.4405068,150.0482782,7764.4200711,6407.3345902,12148.0065967,39.0682471,56.1314643,2.1545527,161.9827963),(11542,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,136,1126.2929502,95.5124175,121.3195819,1.8,95.7774552,122.0245039,1.1056559,21.0020022,29.4145276,134728.5343937,227941.6513006,149.9479576,7749.2881788,6415.0328542,12134.6731354,38.9750015,56.0244609,2.1375255,162.3387615),(11543,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,137,1125.4704995,95.5044623,121.3982759,1.8,95.7561408,122.0849247,1.1021981,20.9903786,29.3660383,134360.3014554,227029.172272,149.3170849,7731.0112362,6401.0423053,12115.3937567,38.9750015,55.9007409,2.1758548,161.7310909),(11544,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,138,1125.6946313,95.5070288,121.4723221,1.8,95.7564279,122.1495849,1.0984456,20.9920996,29.318369,134066.933735,226304.4038969,148.7778766,7718.8606146,6386.5423745,12105.8890616,38.919151,55.7949496,2.1310283,160.4114899),(11545,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,139,1125.369008,95.5055982,121.5333807,1.8,95.7474654,122.1931078,1.0926668,21.0127797,29.2941207,133741.6395425,225228.1760236,147.8529085,7688.5112436,6364.7761863,12078.2241295,38.9796325,55.7734362,2.1587989,161.1234203),(11546,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,140,1124.5241218,95.5061466,121.5870963,1.8,95.7624929,122.2728723,1.0853996,21.1124375,29.2820304,133156.4941132,224144.2471184,146.6234073,7654.6688913,6307.0166271,12039.5448251,38.9796325,55.6624277,2.14167,160.7674551),(11547,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,141,1126.6681443,95.5078944,121.6338076,1.8,95.7617752,122.3097264,1.0794784,21.281021,29.2680898,133001.7695844,223584.2234745,145.981596,7639.1805981,6249.7832921,12030.9729585,38.8768022,55.5478736,2.1802549,159.5521139),(11548,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,142,1127.9475866,95.4994274,121.7105553,1.8,95.7563869,122.3494284,1.0782383,21.0446718,29.2102433,133052.7978547,222781.5868892,145.9532588,7626.8309329,6322.3983199,12028.3171588,38.8756816,55.5478736,2.1802549,159.5521139),(11549,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,143,1129.9825645,95.4875561,121.7901973,1.8,95.7412651,122.400524,1.0782407,20.9965314,29.3210903,133315.1570557,222191.2257595,146.2169544,7577.8636946,6349.3895561,12005.0525772,38.9579902,55.5478736,2.1802549,159.9080791),(11550,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,144,1129.9052989,95.474004,121.8580963,1.8,95.740468,122.5592003,1.0764322,21.1707374,29.2752048,133251.1141043,221339.3960387,145.9228118,7560.6438202,6294.117739,11993.0287299,38.9785118,55.4314174,2.1351474,159.6563737),(11551,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,145,1125.1295462,95.4720061,121.8468683,1.8,95.7510593,122.5325849,1.0698743,21.2284239,29.312528,132163.9829455,218795.6285266,144.2743935,7464.2360618,6225.8028797,11866.1197883,39.0345226,55.4314174,2.1351474,160.3683041),(11552,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,146,1125.0692331,95.4650955,121.897927,1.8,95.7222032,122.4805126,1.0643251,21.2426932,29.2926635,132223.3751791,217810.1099064,143.3869513,7435.6539731,6224.4167408,11849.6296809,38.9796325,55.3030324,2.173884,160.1165987),(11553,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,147,1123.6837675,95.4671341,121.9473996,1.8,95.7372442,122.5397004,1.0567592,21.2802396,29.4394638,131753.4239891,216705.822792,142.0026175,7361.0655553,6191.3505893,11740.8369888,38.9807532,55.4314174,2.1351474,159.4046683),(11554,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,148,1123.343989,95.461134,122.0077444,1.8,95.7482563,122.6391489,1.049817,21.2987647,29.4654709,131444.8986331,215928.5814464,140.8420697,7328.1904267,6171.479912,11691.4791799,39.0825868,55.4164267,2.1631,159.1529629),(11555,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,149,1119.6502905,95.4513311,122.0701681,1.8,95.7217171,122.6843205,1.0436423,21.3055408,29.4394603,130799.6330519,214620.3651146,139.3805621,7290.2275675,6139.2308302,11642.8696304,39.0847041,55.3030324,2.173884,158.0850673),(11556,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,150,1117.3783125,95.4598941,122.1284434,1.8,95.7410757,122.7584839,1.0376994,21.3271423,29.4062397,130167.847836,213717.3255297,138.1321183,7267.7543269,6103.3890945,11611.3007197,39.188655,55.3030324,2.173884,158.4410325),(11557,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,151,1114.8980364,95.4547862,122.1762776,1.8,95.7331107,122.833798,1.0334701,21.3287812,29.3823936,129626.1182429,212571.809555,137.1359847,7234.6661777,6077.5211181,11567.9601831,39.1335893,55.1960955,2.1847111,158.9012575),(11558,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,152,1113.2780883,95.4318219,122.2294179,1.8,95.7029934,122.9016257,1.0326976,21.2873296,29.3511705,129300.7359881,211201.5594438,136.8106178,7195.6775787,6074.0702824,11521.6193511,39.1633883,55.0956537,2.1955789,157.4773967),(11559,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,153,1112.7484189,95.4073419,122.2988532,1.8,95.6846656,122.9502006,1.0321907,21.2342853,29.3058677,129310.8467193,210094.8113963,136.6627654,7169.0356973,6089.7197618,11500.1088688,39.1384977,55.0604557,2.1674567,157.4773967),(11560,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,154,1112.2374924,95.3952196,122.3614458,1.8,95.6874532,122.9886144,1.0292484,21.2150303,29.2686293,129206.1200376,209016.5046775,136.1189404,7141.3151025,6090.3104313,11476.3985282,39.1932179,54.9496869,2.1783192,158.1893271),(11561,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,155,1109.8401887,95.3931998,122.3971551,1.8,95.6869184,123.0640626,1.0232689,21.250652,29.1787939,128620.6887324,207658.8866831,134.8453648,7116.7741724,6052.5525732,11448.1548116,39.1713729,54.7477148,2.2001696,157.1214315),(11562,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,156,1106.8835625,95.3723621,122.4360081,1.8,95.6617614,123.0906359,1.0206543,21.2367185,29.1625779,128283.4905667,206195.6268994,134.0567807,7070.5555557,6040.6456151,11434.0002886,39.188655,54.7072309,2.1435496,156.6180207),(11563,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,157,1111.9871765,95.3530784,122.5205108,1.8,95.6985299,123.1850489,1.0205596,21.1769651,28.9592613,128877.4803463,206329.6522822,134.6592464,7124.8244376,6085.7389093,11515.6367218,39.1897757,54.495891,2.1937956,159.6131879),(11564,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,158,1174.3298306,95.6782151,122.6426205,1.8,96.8840787,123.0317982,0.9565235,21.9752574,32.497584,133107.3640731,212475.5694855,130.7036957,6538.1958739,6057.1469793,10629.8991027,42.0843387,58.1921939,2.1936209,179.6231318),(11565,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,159,1176.6449452,95.7887011,122.7055046,1.8,96.6760707,123.0620312,0.9553628,23.0463508,33.0180099,133087.1038532,213730.0907884,130.7468682,6473.136672,5774.7582335,10154.0304414,42.8650629,59.848613,1.9379702,190.9603535),(11566,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,160,1105.1975387,95.373413,122.5645158,1.8,95.8429922,122.7689553,0.988447,21.5829334,29.1048107,128620.5750496,202679.9029914,128.4817385,6963.7938871,5959.3648644,11323.9163548,40.8313227,54.495891,2.1937956,163.528805),(11567,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,161,1152.1433572,95.5558584,122.8435768,1.8,96.5689112,123.5459282,0.985364,21.5999424,35.6778163,129098.3038306,211348.3925741,133.3947242,5923.8040515,5976.7892603,9274.9045436,40.0236206,58.2872999,1.9882722,190.9603535),(11568,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,162,1204.4304052,96.1002721,123.2936272,1.8,97.9021095,124.6782068,0.9353589,24.2017144,37.6529493,137283.7411564,228301.9356392,130.0228062,6063.3214621,5672.4800088,9698.4893625,46.2272548,63.8849391,2.2465877,217.992751),(11569,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,163,1118.3201024,95.4788977,122.7960042,1.8,95.911523,123.0888632,0.9776167,21.5072931,28.7603324,128327.2164917,204121.1615206,128.1443189,7097.315805,5966.6837599,11537.8996649,39.9302359,54.147508,2.1984258,162.270278),(11570,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,164,1096.1985859,95.3563081,122.7406961,1.8,95.6810581,122.9500763,0.9852493,21.3743304,28.7393359,126887.6866131,199921.3650917,126.8981547,6956.3669018,5936.4520137,11323.8914863,39.2384739,54.0553652,2.209528,159.5700021),(11571,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,165,1094.3640734,95.4589874,122.825019,1.8,95.6922202,123.0969845,0.9732247,21.5158167,28.5280282,125483.6897635,201126.3945079,124.6553713,7050.133042,5832.1601967,11391.9738396,39.2302044,53.8911668,2.2318395,158.3546609),(11572,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,166,1091.3246427,95.4679481,122.9017017,1.8,95.7282986,123.1443289,0.9698503,21.5112615,28.5806253,125891.2408074,201154.7747534,123.7374419,7038.1516456,5852.3411348,11409.3621752,39.306363,53.8963056,2.1919726,159.4225564),(11573,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,167,1090.198221,95.3933314,122.9303068,1.8,95.589438,123.1461107,0.9697647,21.4343328,28.4880156,126113.3846685,199676.312885,123.5952228,7009.1338068,5883.7093647,11378.5673699,39.306363,53.8191724,2.2430435,159.4225564),(11574,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,168,1091.2034011,95.3926269,122.9362499,1.8,95.6193103,123.0908625,0.9645685,21.4497586,28.3615143,125840.3868441,197746.1817677,122.8259268,6972.3421492,5866.7507296,11387.1656992,39.3981218,53.5526414,2.2367656,156.6790947),(11575,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,169,1088.3600158,95.4752827,122.9664935,1.8,95.6627903,123.1826969,0.9517593,21.5945531,28.3092844,124550.1189976,198038.4471538,120.319764,6995.5299635,5767.6636501,11382.0587613,39.3522424,53.5526414,2.2367656,156.4273893),(11576,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,170,1083.1083607,95.4752019,123.0253931,1.8,95.6857101,123.2109391,0.9511012,21.5650187,28.2622716,124908.6909454,197407.3057712,119.6268645,6984.8350674,5792.190248,11391.0114535,39.3981218,53.4542925,2.2078667,158.311475),(11577,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,171,1081.135822,95.3777989,123.04138,1.8,95.5325056,123.1886126,0.9522578,21.4681119,28.2031915,125318.026754,195419.9335786,119.606003,6929.0006979,5837.4032771,11341.1712686,39.4440012,53.3678723,2.2191283,157.5995446),(11578,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,172,1082.0109206,95.3620882,123.0420074,1.8,95.5726042,123.2097536,0.9485582,21.4815238,28.0676565,125123.1410208,193644.9964237,119.0716479,6899.2221138,5824.6864772,11349.1286298,39.4742804,53.1095063,2.2126793,155.6722731),(11579,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,173,1081.9456841,95.4397022,123.0508952,1.8,95.577186,123.2522761,0.9341269,21.6394988,27.9366148,124130.9831737,194464.8421654,116.5877876,6960.9307818,5736.3150736,11393.8527763,39.4440012,52.9493488,2.2353982,155.6722731),(11580,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,174,1074.4722933,95.4418395,123.0664949,1.8,95.619399,123.2686052,0.9285085,21.6696144,27.9291058,123904.2696175,193807.9484303,114.8188803,6939.2822495,5717.8806876,11367.7318855,39.4842345,52.9493488,2.2353982,156.6359089),(11581,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,175,1070.9445395,95.3618005,123.0773456,1.8,95.4954403,123.230206,0.9230742,21.5606966,27.9740057,124009.0280312,192389.6059549,113.50992,6877.4421566,5751.6243678,11303.7648042,39.5522882,52.8795638,2.2468063,156.6359089),(11582,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,176,1071.9007643,95.319699,123.100606,1.8,95.4872345,123.3180769,0.9208058,21.5202386,27.9830783,124068.7794905,191156.4221465,113.2210396,6831.1434609,5765.2139274,11258.4128419,39.5522882,52.8795638,2.2468063,155.6722731),(11583,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,177,1064.4716851,95.497797,123.0568779,1.8,95.6520555,123.2913108,0.9066619,21.5503982,27.8448158,122102.8353341,190111.6318355,110.0093256,6827.5413824,5665.9201462,11205.6286018,39.6421978,52.7607175,2.2697056,155.0646025),(11584,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,178,1061.0436325,95.4720094,123.1164153,1.8,95.6568132,123.3268639,0.9081825,21.5699776,27.8122089,123127.1178465,189706.8254115,109.9159789,6820.9909585,5708.2635919,11239.515895,39.6779168,52.6854263,2.2289783,155.7765329),(11585,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,179,1059.1614514,95.3780794,123.1730058,1.8,95.562659,123.4605171,0.9112904,21.5544612,27.7452306,123876.3587119,188382.0813597,110.2527631,6789.7104164,5747.1331734,11228.6303885,39.7183564,52.5450626,2.2519229,156.1324981),(11586,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,180,1061.4446191,95.338383,123.1688266,1.8,95.5661343,123.4470776,0.9110109,21.5269651,27.6622752,124077.8862218,186840.4425498,110.442525,6754.3411107,5763.8355214,11238.8448486,39.7459705,52.423697,2.222494,156.3842035),(11587,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,181,1056.2090773,95.3940225,123.1611405,1.8,95.5722476,123.4638984,0.8987328,21.6313888,27.6359822,122488.9732563,186656.3690614,107.7978627,6754.1065664,5662.557055,11186.3287488,39.8201616,52.423697,2.222494,154.4569319),(11588,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,182,1048.9914855,95.3970176,123.1842561,1.8,95.6000211,123.4943773,0.8983946,21.67647,27.547503,122486.5006529,186135.4923223,107.0036133,6756.8916255,5650.6664095,11200.7968774,39.918553,52.3461575,2.2339993,156.3842035),(11589,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,183,1044.8777776,95.2821283,123.1939274,1.8,95.4392201,123.4533517,0.899967,21.5658469,27.6104032,123081.9113739,184321.9506065,106.8507486,6675.8152546,5707.2607487,11129.864785,39.9518755,52.2755673,2.2455373,155.7765329),(11590,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,184,1044.7202251,95.2210081,123.1812254,1.8,95.4012033,123.4559427,0.8984052,21.4849662,27.3918621,123098.470203,182332.3433925,106.5697192,6656.4420764,5729.5165738,11149.3581865,39.9565036,52.0082257,2.2390857,155.5248275),(11591,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,185,1043.2092658,95.2878751,123.1906654,1.8,95.4442561,123.4196238,0.8847782,21.589955,27.3448124,121759.3603539,182615.037606,104.0995893,6678.2333244,5639.63012,11130.9617341,40.0665948,52.0082257,2.2390857,154.5611917),(11592,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,186,1035.1226737,95.3104601,123.2119301,1.8,95.4671329,123.4972809,0.8792701,21.6625021,27.313391,121303.6197502,182043.264552,102.3600799,6664.982189,5599.7049236,11105.8762852,40.0882175,51.9407309,2.2507052,155.0214166),(11593,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,187,1029.6409562,95.2117569,123.2432817,1.8,95.3296559,123.4910549,0.8774755,22.3465918,27.2960905,121706.0657804,180338.9324962,101.5153492,6606.7678375,5446.2920831,11063.9543145,40.0882175,51.8802665,2.2623533,156.0282383),(11594,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,188,1028.3883695,95.148877,123.240252,1.8,95.309738,123.5048291,0.8777989,21.5300062,27.1200076,121824.9011934,178287.7584994,101.4463535,6574.030561,5658.3774428,11064.7488925,40.0913029,51.6072998,2.25594,154.4137461),(11595,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,189,1028.3810961,95.1974342,123.2413057,1.8,95.335177,123.3751804,0.8658445,21.4164622,27.0319075,121034.7723686,178331.1728925,99.4272553,6597.0621206,5651.4830232,11074.2993553,40.0897602,51.499859,2.2794226,153.5975559),(11596,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,190,1018.4805807,95.2284098,123.2223623,1.8,95.418381,123.3817877,0.8557283,21.7039273,27.0654168,119924.612945,177651.1409163,96.7723749,6563.7688972,5525.4798483,10985.7201773,40.0897602,51.4801373,2.225983,152.9898853),(11597,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,191,1012.3546103,95.1521459,123.2248293,1.8,95.3001403,123.340804,0.8509517,22.527467,27.0685007,120231.8755252,176075.3458485,95.3917883,6504.8059978,5337.1235812,10944.2473649,40.2245595,51.4047663,2.2377045,154.5611917),(11598,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,192,1009.9553483,95.0743554,123.1989522,1.8,95.238367,123.3434586,0.8485839,21.8981638,26.8922713,120321.8175602,174201.5244454,94.7704539,6477.7542519,5494.607613,10934.7610895,40.2276449,51.2194585,2.219331,153.3458505),(11599,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,193,1005.4514519,95.1063345,123.1288734,1.8,95.2755544,123.2892357,0.835519,21.5531478,26.8703356,118839.8687386,172782.0847094,92.172569,6430.2168585,5513.805687,10839.7752121,40.2261022,51.1400931,2.2311026,151.5228387),(11600,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,194,997.0763307,95.1018677,123.1174947,1.8,95.2868568,123.3403079,0.826381,21.8747838,26.8685074,118483.8362594,172053.4241622,89.8925811,6403.5348791,5416.4574752,10794.7882159,40.463161,51.0678358,2.2429092,154.0577809),(11601,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,195,991.7451161,94.996739,123.1423484,1.8,95.150966,123.3268456,0.8192921,22.3302842,26.8896958,119078.3152585,170251.4484889,88.2434908,6331.4754283,5332.5929179,10751.4680258,40.3609015,51.0027167,2.2547475,154.2052265),(11602,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,196,991.8517549,94.9307964,123.1551755,1.8,95.0952478,123.2860362,0.8168408,21.8035857,26.647767,119379.869307,168529.0635707,87.848625,6324.3221644,5475.2402263,10774.1437523,40.4957008,50.8014073,2.2362905,150.8109083),(11603,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,197,989.4965808,94.9808435,123.1965771,1.8,95.1535797,123.3152242,0.8075808,21.5658447,26.5636549,118149.1486114,168398.9759293,86.1151276,6339.4505133,5478.5310071,10748.8221949,40.4957008,50.8014073,2.2362905,150.2032377),(11604,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,198,979.595338,95.0106441,123.1769841,1.8,95.2032027,123.3670411,0.7962872,22.2185072,26.5231254,116979.4738603,167655.3696774,83.4106053,6321.101561,5264.9565018,10701.9530951,40.6305001,50.6704006,2.2601058,153.7018157),(11605,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,199,973.7508471,94.9064403,123.1823546,1.8,95.0201724,123.3816213,0.7884606,32.2836218,26.5765065,117285.5215936,166046.7910306,81.6429162,6247.8787839,3632.9728533,8636.1073674,40.7269773,50.6704006,2.2601058,154.8128971),(11606,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,200,975.5195076,94.8558708,123.1961684,1.8,95.0021165,123.3365209,0.7869869,31.6217406,26.2959417,117483.5818276,164922.5533308,81.5515946,6271.7872938,3715.278779,8781.0393107,40.7652993,50.3982079,2.2535264,150.9151681),(11607,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,201,975.5207385,94.8979925,123.2273698,1.8,95.0529949,123.3630944,0.7815193,21.6138419,26.2352507,116876.2123914,165438.6822343,80.6627498,6305.96918,5407.4704845,10712.1877988,40.8454154,50.3395584,2.2655346,149.6998269),(11608,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,202,966.7781441,94.896086,123.1998388,1.8,95.0777745,123.4426352,0.7704177,30.0220553,26.2393183,116231.4131779,164543.619851,78.1514163,6270.8801449,3871.5341714,9127.7655703,40.8454154,50.288184,2.277569,153.1984049),(11609,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,203,962.3753476,94.7835237,123.1980316,1.8,94.9011005,123.4259764,0.7608845,29.5842151,26.2902881,116839.9736427,163017.2363469,76.2676367,6200.6637534,3949.4025236,9233.2615955,40.9016413,50.244107,2.2896263,153.4501103),(11610,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,204,961.5197192,94.7347227,123.1746872,1.8,94.8811413,123.3903111,0.7546524,28.9000727,26.0505111,116632.8793494,161489.6419601,75.2026394,6199.0968659,4035.7296193,9329.524344,40.9031841,50.0102195,2.2710351,150.1600519),(11611,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,205,960.7727997,94.7924375,123.1784929,1.8,94.9441751,123.3583883,0.7434326,28.2453289,25.9597341,115349.3505197,162009.5449513,73.3523941,6240.8014126,4083.8381118,9477.6044776,40.9047268,49.9215357,2.2952943,149.9515323),(11612,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,206,952.0741253,94.7725268,123.172905,1.8,94.9318202,123.4403419,0.7293509,28.1256137,25.6869374,114749.2785598,160881.1101799,70.4645998,6263.1487521,4079.8853245,9423.0015375,40.9031841,49.6377988,2.288812,154.2663004),(11613,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,207,950.8273573,94.6473899,123.2005858,1.8,94.7690181,123.47129,0.7210473,27.6708548,25.7059129,115881.8073258,159326.3166671,69.065976,6198.041556,4187.865114,9566.406484,41.0379833,49.5242217,2.2455373,151.3753931),(11614,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,208,952.5278719,94.6074685,123.2244244,1.8,94.7459156,123.4252345,0.7184498,26.9997879,25.6724278,116302.643472,158509.7298499,68.7806943,6174.3178748,4307.5391455,9770.055454,41.0395261,49.4047781,2.2699889,150.6634627),(11615,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,209,938.7256395,94.7430379,123.1201679,1.8,94.9244225,123.518699,0.7036111,26.4910049,25.4050268,113977.6370665,157032.5779262,65.4881799,6181.1616656,4302.5033367,9826.985669,41.1727826,49.1293316,2.263295,158.4157348),(11616,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,210,937.0702198,94.6730602,123.1386768,1.8,94.8524477,123.3950689,0.691686,26.0647352,25.3601289,114479.4250606,156355.9607184,63.5389152,6165.4245249,4392.1192492,9974.5146738,41.1743253,49.0766903,2.2756239,149.5091955),(11617,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,211,936.7238394,94.6096653,123.1567656,1.8,94.7797142,123.2527713,0.682916,25.4006463,25.3686452,114542.5094041,155469.0346624,62.1725251,6128.3932645,4509.4328794,10234.2135247,41.3091246,49.0315243,2.2879775,147.0174391),(11618,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,212,933.3597365,94.5704446,123.1458391,1.8,94.7174559,123.2126004,0.6713053,25.1021866,25.1669719,114147.6644148,154654.8063109,60.185324,6145.1495622,4547.3195685,10371.4345913,41.3170529,48.7501819,2.2813346,145.4461327),(11619,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,213,927.311647,94.5415313,123.1387765,1.8,94.7203881,123.2929767,0.6602111,25.0928067,25.1623034,113467.2179309,153449.7274126,58.1295721,6098.3974771,4521.9021968,10336.3572627,41.3181438,48.7085038,2.2937757,145.5503925),(11620,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,214,924.7380479,94.5099084,123.1431326,1.8,94.6927008,123.3123424,0.6497938,25.0874724,25.0701099,113216.3168148,152637.7584108,56.4170158,6088.4359602,4512.862642,10330.6543547,41.3192346,48.6743769,2.3062361,144.4824969),(11621,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,215,921.4886965,94.4699863,123.1403574,1.8,94.6636128,123.32079,0.6396673,25.094758,24.8953909,112972.9764037,151860.5310644,54.7247161,6099.9456259,4501.8555864,10321.1235291,41.4977386,48.3165002,2.2427595,144.3350513),(11622,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,216,918.0727848,94.4312743,123.1373165,1.8,94.6184372,123.3319858,0.6295391,25.113247,24.8012211,112609.9471871,151221.9856868,53.0420809,6097.360495,4484.0855102,10305.5224625,41.5098696,48.2514944,2.2552727,143.9790861),(11623,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,217,914.2713843,94.3883106,123.1302398,1.8,94.5864413,123.3232134,0.6174997,24.783654,24.7909174,112197.7631365,150665.2425853,51.0832631,6077.4371621,4527.0872194,10405.996276,41.5109605,48.1940635,2.2678177,144.2307915),(11624,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,218,910.5890994,94.3528576,123.126672,1.8,94.5444073,123.3321583,0.6053964,24.5697207,24.7690188,111902.2893984,150112.1939239,49.1507461,6060.4820594,4554.4795127,10379.0985949,41.6418192,48.1940635,2.2678177,144.9427219),(11625,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,219,907.2446905,94.3053247,123.1202948,1.8,94.4662537,123.2916251,0.5923032,24.607945,24.6274623,111657.2404335,149379.2711046,47.1266916,6065.5567787,4537.4467714,10416.5996258,41.6587026,47.9809716,2.2483345,145.0469817),(11626,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,220,902.8721065,94.2599763,123.1138269,1.8,94.4293702,123.2593436,0.5794268,21.3669129,24.5061104,111220.2970524,148549.5233864,45.1142452,6061.7340238,5205.2581302,10376.1379286,41.5120514,47.8653917,2.2735804,144.3350513),(11627,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,221,902.4404598,94.2206749,123.128085,1.8,94.3865152,123.2791595,0.5698119,21.3468338,24.471324,111340.2638499,148280.3324577,43.7731577,6059.3506172,5215.7741569,10381.664053,41.5131422,47.8190816,2.2862451,144.6910165),(11628,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,222,899.6453025,94.1946683,123.1458166,1.8,94.3732918,123.2844318,0.5603822,21.4219869,24.4360484,111084.6177129,147991.632411,42.3587333,6056.2833291,5185.5422243,10358.2044686,41.508867,47.8190816,2.4261439,144.3350513),(11629,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,223,896.9429647,94.1712528,123.1693161,1.8,94.3628549,123.3270857,0.5500668,21.3900488,24.3891578,110881.3824534,147775.3131401,40.849992,6059.0576479,5183.7835226,10342.2159089,41.4901243,47.7804555,2.2989323,143.6231209),(11630,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,224,893.4029581,94.1310596,123.1731059,1.8,94.3399667,123.3300291,0.5388892,23.7934755,24.2877881,110661.1391624,147219.2778503,39.2139409,6061.4526515,4650.9026909,10311.6527871,41.5101747,47.7495321,2.311638,144.2307915),(11631,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,225,884.6982412,94.182806,123.0818441,1.8,94.3819363,123.2585588,0.5218716,23.6496309,24.0470842,109572.1862117,145386.9927443,36.6420913,6045.9301945,4633.1457128,10287.439647,41.4526389,47.4605908,2.3049573,143.7273807),(11632,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,226,881.4378118,94.147827,123.0708088,1.8,94.3335393,123.1856037,0.5104736,23.5744634,23.9706029,109434.8091682,144802.0461023,35.0695738,6040.8178539,4642.0912034,10259.7998459,41.250048,47.4333515,2.3946371,143.3714155),(11633,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,227,877.8042025,94.1193465,123.0731233,1.8,94.3285669,123.1678342,0.4978179,23.3374194,23.9282554,109114.4598351,144163.1967157,33.3587864,6024.8101719,4675.5152325,10327.8216436,41.1405529,47.1091707,2.4725497,144.1876057),(11634,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,228,875.2905807,94.0827717,123.0609117,1.8,94.2724103,123.1367351,0.4866279,22.9162359,23.8826102,108907.1991086,143820.6117103,31.9035474,6021.9804611,4752.4034716,10304.487836,41.0944129,47.1189678,2.3239476,144.4393111),(11635,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,229,870.4126092,94.0319287,123.0416739,1.8,94.2510156,123.1082123,0.4766475,22.5096512,23.7041399,108368.394085,143289.608814,30.5369992,6044.9191419,4814.3080159,10244.6222099,40.7704536,47.1189678,2.3239476,143.7273807),(11636,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,230,866.3164693,93.9986736,123.0611203,1.8,94.1981971,123.1212191,0.4570351,22.291803,23.6260167,107973.952954,142594.8373627,28.1172274,6035.5005656,4843.6617134,10293.3237555,41.4183721,46.8438755,2.479745,145.0469817),(11637,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,231,862.7507261,93.9508592,123.0487562,1.8,94.1725934,123.1107936,0.4471092,21.7339796,23.6336761,107614.0050362,142464.9757716,26.8798249,6028.0497597,4951.4174232,10254.4601012,41.4612496,46.8537281,2.4080959,143.4756753),(11638,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,232,858.4903758,93.9188516,123.0556769,1.8,94.1468949,123.1555544,0.4369644,21.0853882,23.5901066,107273.2889501,142025.2187669,25.6246063,6020.541638,5087.5652749,10232.5225238,41.6186771,46.8261357,2.3951358,143.8316405),(11639,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,233,863.3142447,93.8987704,123.0509569,1.8,94.1066125,123.0535307,0.4234937,21.2831255,23.5740665,109257.9573342,143355.1358895,24.2991674,6081.0524833,5133.5485048,10360.8481921,42.7419162,46.9324739,2.4339594,145.5072067),(11640,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,234,853.3444084,93.8804902,123.013415,1.8,94.1361893,123.0752089,0.4291303,21.1004927,23.6658759,107415.6357176,141954.0672557,24.622213,5998.2596031,5090.6695605,10193.3732197,42.4728623,46.9226379,2.4925971,147.0785131),(11641,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,235,845.6036373,93.8396219,122.9839646,1.8,94.0736907,123.0496849,0.4010345,21.0159526,23.434404,106128.5753511,141098.8021319,21.4768545,6021.0109145,5049.905542,10199.4355966,42.4851935,46.5810331,2.4870219,148.1895945),(11642,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,236,839.1429238,93.8239158,122.9752111,1.8,94.0652553,122.9898385,0.3838016,21.2299397,23.3804604,105450.0691216,140501.6464504,19.6095736,6009.361828,4967.0451473,10139.4060992,42.4677745,46.5810331,2.4870219,148.7972651),(11643,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,237,837.6634078,93.81134,122.9580323,1.8,94.0540651,122.9623947,0.3718282,21.3452219,23.3444283,105414.8872274,140821.3426072,18.4287248,6032.3320195,4938.5706836,10142.5139699,40.82036,46.5810331,2.4870219,143.6841949),(11644,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,238,834.4412476,93.7977181,122.9373306,1.8,94.1070928,122.910572,0.3572508,21.4743433,23.2940155,105338.2020993,140813.3353844,17.0073083,6045.043432,4905.3049362,10150.8057189,39.960984,46.5056624,2.4740666,153.2415907),(11645,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,239,830.3479611,93.782769,122.9375353,1.8,94.1965533,122.8975193,0.3386249,20.8145142,23.1876802,104914.3158655,140733.7213698,15.2715492,6069.3316534,5040.440287,8577.1680636,39.8602169,50.5938233,0.3647348,165.7330797),(11646,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,240,825.4586319,93.7415138,122.9526955,1.8,94.1094286,123.0208745,0.3315951,20.70997,25.1363576,104275.0273199,140593.1688395,14.5808838,5593.2196278,5035.0158658,7712.061366,39.8602169,46.5056624,2.4740666,142.6162993),(11647,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,241,817.9240888,93.8964132,122.7543495,1.8,94.7818488,122.6303116,0.2830071,27.6184589,40.1832782,103883.7941165,141146.5683394,10.6299363,3512.5697715,3761.3899582,5035.5061417,40.2690009,46.4381218,2.4610714,146.9742533),(11648,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,242,815.1402332,93.8827528,122.7457044,1.8,94.8621707,122.5572493,0.2611114,27.1449939,41.0889157,103900.46004,141581.7449223,9.0539977,3445.7405987,3827.6103673,5001.7985132,40.2133808,46.3206853,2.494381,148.6930053),(11649,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,243,811.231075,93.8463903,122.7332761,1.8,94.8195546,122.5730864,0.2488159,26.7469362,41.3483124,103449.9896441,141596.7410778,8.1991504,3424.4865844,3867.7323275,4976.0615163,39.6643603,46.3206853,2.494381,142.9722645),(11650,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,244,808.2954297,93.8064683,122.7485838,1.8,94.6619529,122.6195366,0.2395711,26.7033391,41.2115475,103113.1382447,141358.3786998,7.5851281,3430.0672348,3861.4323734,4987.0688545,39.5805323,46.3206853,2.494381,142.6162993),(11651,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,245,802.8683185,93.7241249,122.7461876,1.8,94.4156181,122.6848329,0.2439972,27.3195638,41.0714757,102343.137951,140367.6745516,7.8095718,3417.6438078,3746.1483188,4929.0060432,39.4949468,46.2548704,2.5278226,142.5120395),(11652,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,246,799.9904126,93.6503253,122.7475682,1.8,94.2359958,122.7218087,0.2388986,27.4449428,41.1778056,101937.1354198,139915.9185051,7.4659139,3397.8478553,3714.2411337,4904.6198836,39.4649733,46.2788139,2.5948038,142.7637449),(11653,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,247,798.0399178,93.6070697,122.7344762,1.8,94.2228983,122.6999845,0.2239308,26.8301613,41.2053647,102008.6827254,140229.5858706,6.558881,3403.1875938,3802.0152654,4934.5161189,39.4559612,46.368492,2.5741527,142.7637449),(11654,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,248,793.7532714,93.6073593,122.7479378,1.8,94.4157714,122.6444402,0.1922863,25.9509674,41.9353945,101926.3562145,140621.355151,4.8313863,3353.2856127,3927.6515018,4925.2457247,39.4559612,46.2788139,2.5948038,142.5120395),(11655,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,249,790.3698102,93.5462264,122.732349,1.8,94.3774298,122.6094625,0.1765733,25.7085501,42.318784,101802.9250537,141025.1681044,4.0645365,3332.4484985,3959.8858953,4910.4537552,39.422153,46.368492,2.6281936,142.8680047),(11656,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,250,787.2006337,93.4910664,122.731318,1.8,94.3236762,122.604433,0.1618393,25.0912381,42.6721033,101576.799587,141165.2761352,3.4064895,3308.1396313,4048.2976225,4903.6515445,39.4313303,46.4261927,2.6075223,143.3714155),(11657,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,251,785.0868796,93.3860416,122.7382359,1.8,93.7163437,122.8339274,0.1789807,20.1879767,23.2898254,101097.3658547,139965.2838824,4.1470221,6009.718047,5007.8007954,9956.0360781,39.4981647,46.368492,2.5741527,147.1216989),(11658,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,252,782.2370042,93.3633133,122.7442724,1.8,93.6829243,122.831917,0.1611987,20.1523169,23.2788363,100891.5968207,140340.1503505,3.3584974,6028.6583284,5006.4514761,9986.6236556,39.4771115,46.4261927,2.6075223,147.9810749),(11659,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,253,781.0087553,93.3324625,122.7603887,1.8,93.6584325,122.8776733,0.1476317,20.0753193,23.3863889,100982.0574364,141364.9041736,2.8164807,6044.7512857,5030.1594793,10027.029578,39.0811393,46.4401097,2.7524954,143.7273807),(11660,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,254,777.8658748,93.2891379,122.7630247,1.8,93.6233039,122.8863983,0.1367254,20.0024897,23.4847159,100684.8968415,141989.2004992,2.4084868,6046.0259042,5033.6182201,10051.3397332,39.101608,46.5215401,2.7730926,144.3350513),(11661,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,255,774.9540639,93.2362904,122.7669911,1.8,93.5288839,122.8911556,0.1263023,19.8785462,23.58114,100432.4888238,142673.3495771,2.0494463,6050.3160421,5052.3055238,10064.9592782,39.101608,46.6048091,2.7439647,144.0833459),(11662,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,256,771.1055543,93.1797649,122.7565565,1.8,93.4705871,122.8878313,0.116827,20.0297644,23.6736717,100073.3757553,142972.6127017,1.7461138,6039.3087524,4996.2333025,10081.6015187,39.101608,46.695838,2.9658544,144.4393111),(11663,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,257,765.2120521,93.2444363,122.6471131,1.8,93.8311917,122.8127044,0.1081295,19.9543699,23.797213,98653.1899716,142966.9136495,1.4853385,6007.7166782,4943.9391248,10016.9397504,39.0477966,46.8537281,2.9477942,144.4393111),(11664,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,258,765.036484,93.2579726,122.6299197,1.8,93.8825887,122.7594997,0.0978961,19.9061957,23.7815655,98444.9138016,143976.4013646,1.218075,6054.1178953,4945.4408776,10050.3887665,39.0477966,47.0326836,3.0501056,145.0469817),(11665,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,259,762.650426,93.2289178,122.6154528,1.8,93.9322453,122.7486218,0.0904078,19.8374825,23.8460635,98098.4615158,144473.5438814,1.0361018,6058.5909176,4945.1064006,10076.5318736,39.0328007,47.1679225,3.0228873,145.0469817),(11666,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,260,760.998643,93.1841732,122.6108905,1.8,93.9520975,122.7428488,0.0815518,19.7675505,23.915049,97825.1949521,145107.8305763,0.8416605,6067.6367597,4948.7767913,10075.6244792,39.0328007,47.3378905,2.9958445,145.6546523),(11667,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,261,757.8894998,93.1318954,122.6039944,1.8,93.872227,122.7521325,0.0724723,19.6916678,23.9816993,97243.8044755,145448.9051431,0.6622743,6064.9957943,4938.3224229,9956.0363934,39.0477966,47.4703154,2.9779321,145.2986871),(11668,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,262,756.2104137,93.0662872,122.5882364,1.8,93.8475082,122.6990095,0.0613046,19.5876149,24.0459116,96802.7014936,146157.4599697,0.4730786,6078.2665486,4942.036183,9987.6525053,39.0328007,47.6469551,3.0150005,145.6546523),(11669,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,263,753.1167684,92.9797576,122.563045,1.8,93.7331221,122.6681414,0.0502135,19.4719311,24.0973797,96343.8892648,146473.3416616,0.3162176,6078.3929044,4947.8343229,9848.8776546,39.0328007,47.7630636,2.9971511,145.4029469),(11670,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,264,750.8443988,92.888687,122.5418669,1.8,93.6149125,122.6349227,0.0406622,19.3700178,24.1904119,96025.0961594,146921.510217,0.2067947,6073.5431381,4957.4087656,9722.3092784,38.67192,47.965577,2.970553,145.5503925),(11671,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,265,749.6932476,92.8429247,122.5226162,1.8,93.567571,122.6151418,0.0332364,19.3001041,24.5320166,95744.831659,147667.0790067,0.1379752,6019.3616147,4960.8453605,9749.7352855,38.67192,48.0405789,2.9617392,145.9063577),(11672,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,266,748.6697721,92.817302,122.4921104,1.8,93.5356133,122.5835584,0.0277273,19.2998532,24.5844623,95409.4417911,148445.9369596,0.0959054,6038.2014957,4943.5319955,9645.7483581,38.67192,48.3165002,3.0525431,146.2623229),(11673,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,267,747.895046,92.811665,122.4708348,1.8,93.4614647,122.542911,0.0247669,19.2866003,24.5918153,95031.571599,149363.6430772,0.0764441,6073.7135992,4927.3365989,9659.5029218,38.67192,48.4995757,3.0172377,146.2623229),(11674,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,268,746.434217,92.8301162,122.4409745,1.8,93.4644089,122.5347429,0.0192065,19.2706941,24.5613552,94544.9339938,150127.0393932,0.0458864,6112.3272013,4906.1509457,9814.0644003,38.67192,48.6136478,2.9996956,146.7657337),(11675,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,269,748.3360362,92.8279396,122.3942636,1.8,93.4414673,122.4765278,0.0105431,19.2452601,24.5305906,94469.5780509,151697.9145234,0.0138634,6184.0302639,4908.7192253,9835.2457195,38.67192,48.7426067,2.982241,146.7657337),(11676,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,270,746.3593013,92.8083019,122.3260494,1.8,93.403147,122.4139301,0.0021114,19.1963595,24.9300686,93880.3363791,152469.4618467,0.0005543,6115.8861846,4890.5281407,9827.6643262,38.6483621,48.8126324,2.9735496,146.8699935),(11677,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,271,743.5326447,92.7746087,122.2625754,1.8,93.3459488,122.3333044,-0.0063971,19.164308,24.9581228,93204.9466192,153351.9255825,0.0050711,6144.3693867,4863.4652747,9767.9159372,38.6033744,49.2119398,3.0453992,147.2259587),(11678,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,272,739.4729276,92.7134908,122.2115076,1.8,93.2891451,122.3015826,-0.010316,19.1286753,25.0259804,92373.1880112,153883.8710612,0.0131155,6148.9647285,4829.0426131,9703.9896003,38.242232,49.3019001,3.028048,147.1216989),(11679,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,273,730.895159,92.6628605,121.9925735,1.8,93.1611377,122.1471177,-0.0188716,19.3476386,25.0907799,90653.4680496,153400.9080728,0.0433783,6113.8357883,4685.5055485,9535.7944031,38.67192,49.4645359,3.0021526,147.8336293),(11680,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,274,728.4939948,92.638925,121.9061192,1.8,93.1409047,121.9952077,-0.0271537,19.2922193,25.4657994,90038.3370665,154138.6720282,0.0895009,6052.7717735,4667.0803175,9521.3043965,38.6333662,49.8900891,3.0985159,148.9015249),(11681,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,275,724.5546241,92.6254242,121.8324575,1.8,93.1317448,121.9405527,-0.0363645,19.242544,25.5146591,88969.6165767,154774.7886358,0.1596187,6066.1123378,4623.5891049,9448.7866368,38.242232,50.067411,0.0945449,148.1895945),(11682,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,276,724.1165432,92.6207377,121.770785,1.8,93.1328668,121.8900707,-0.0421927,19.1952778,25.5459853,88198.0737883,156304.6420721,0.2147208,6118.5599374,4594.7797567,9423.2129378,38.242232,50.2588037,0.1285968,149.0489705),(11683,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,277,721.0965268,92.6270817,121.6856868,1.8,93.1349294,121.8230875,-0.0471654,19.1022012,25.5734552,87098.446652,156828.6139911,0.2671582,6132.4765343,4559.6026164,9368.8442228,38.242232,50.5079921,0.1623515,148.6930053),(11684,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,278,722.0648925,92.6529893,121.6543582,1.8,93.1449088,121.7510018,-0.0513776,19.0801782,25.8873061,86461.7606183,158545.7956715,0.3173874,6124.4609585,4531.4964851,9351.8491545,38.1870911,50.8849295,0.0845438,149.6566411),(11685,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,279,723.5130211,92.6379212,121.6507977,1.8,93.1143593,121.7366599,-0.0568445,19.0857099,25.9412438,85976.6467843,160198.7412601,0.3892282,6175.4456528,4504.7654655,9333.9970862,37.812544,51.1112025,0.1264405,149.3006759),(11686,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,280,725.5895691,92.6363198,121.6439305,1.8,93.1097969,121.7158803,-0.0614095,19.0865547,25.9903414,85743.0990048,161894.5622481,0.4554763,6229.0279123,4492.3298352,9329.6965521,37.812544,51.4263121,0.1678959,149.5523813),(11687,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,281,727.4058982,92.6182733,121.6096124,1.8,93.0923684,121.6902782,-0.0665577,19.0594223,26.3187855,85428.3441736,163734.2374255,0.5362667,6221.1927451,4482.2105704,9310.5192497,38.1326667,51.8197315,0.0996687,151.2279475),(11688,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,282,726.9041473,92.5955824,121.553875,1.8,93.0319602,121.6129041,-0.0736352,19.0126544,26.4160822,84747.9328013,165493.3667682,0.6557108,6264.8717412,4457.4487684,9260.7155029,38.1121202,52.1394121,0.1488899,151.3753931),(11689,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,283,727.8631136,92.5814438,121.5396056,1.8,93.0643381,121.5554224,-0.0772136,19.00221,26.7206762,84193.2069139,167699.0311134,0.7218107,6276.0025236,4430.7060641,9275.2099417,38.0933775,52.4448242,0.1314687,151.7313583),(11690,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,284,731.4511245,92.551159,121.5538971,1.8,92.9696527,121.5666079,-0.0803283,19.0525071,26.8115209,84002.7001387,170153.0396762,0.78494,6346.2658646,4409.0102994,9275.4757148,38.0371493,52.8708342,0.1304033,153.0509592),(11691,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,285,740.2120702,92.5348152,121.5766471,1.8,92.9851562,121.553587,-0.082884,19.3994797,27.1098845,84548.7410443,173957.2586357,0.845574,6416.7465911,4358.2994154,9358.1151364,38.242232,53.2431809,0.121352,153.9103352),(11692,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,286,744.7109871,92.5380949,121.5866982,1.8,92.9916006,121.5493159,-0.0857221,19.4472388,27.2063764,84681.9157763,177006.0016411,0.9098254,6506.0483976,4354.4441892,9403.2434732,38.1898224,53.6198288,0.1124271,153.8060755),(11693,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,287,750.4121926,92.5789771,121.620027,1.8,93.0269967,121.5966305,-0.0882136,19.4855762,27.4760195,85163.4326706,180722.0231409,0.9707182,6577.4455825,4370.5883565,9511.2391955,38.1673342,54.0963369,0.1194289,154.4137461),(11694,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,288,753.7428379,92.5938737,121.7115314,1.8,93.0236235,121.6993952,-0.0906885,19.5795539,27.5758914,85553.7437363,184455.713855,1.0303508,6689.0208945,4369.545102,9583.505611,38.1898224,54.5754508,0.1263081,155.5248275),(11695,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,289,756.2411297,92.6989989,121.7051915,1.8,93.0958555,121.6508094,-0.0938362,19.8918619,27.8491301,85616.6507637,188754.250671,1.1065595,6777.7431488,4304.1044152,9676.2382994,38.4839927,55.1776948,0.1485049,156.4884632),(11696,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,290,763.4046748,92.7031295,121.8042396,1.8,93.0947289,121.7395111,-0.096963,19.9885854,27.9686982,86412.712715,193250.7242745,1.1924879,6909.5358906,4323.102951,9795.1149111,38.4686299,55.6026898,0.1473615,157.7038044),(11697,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,291,774.3593817,92.7435317,121.8765488,1.8,93.1117836,121.8104284,-0.0984753,20.0633457,28.2755312,87479.566872,198509.1319523,1.2475022,7020.5270532,4360.1684398,9938.8149679,38.4877966,56.1594161,0.1613751,158.4589206),(11698,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,292,788.6243126,92.7558132,121.9021675,1.8,93.1040177,121.8662036,-0.1019899,20.0435521,28.5515939,89275.7555168,204023.8552736,1.3624683,7145.7956402,4454.0885219,10108.2136661,38.5477436,56.7074216,0.1215355,159.0665912),(11699,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,293,798.9699024,92.7933047,121.9372546,1.8,93.1099312,121.9144991,-0.1056471,20.0324004,28.637852,91294.7199022,208423.5263214,1.4807382,7277.9035994,4557.3530022,10261.1765229,38.5964333,57.1872597,0.1280828,159.6742618),(11700,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,294,809.5701723,92.779662,122.0919323,1.8,93.0816494,122.0706365,-0.1083538,20.1335222,29.0402621,93171.7667794,214046.9495476,1.5779429,7370.6962139,4627.6933398,10414.7663998,38.7665703,57.7910393,0.1492576,161.748979),(11701,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,295,822.1568003,92.779598,122.2437141,1.8,93.0582604,122.1702745,-0.1088036,20.3300569,29.3423854,95160.1569719,219666.7757273,1.6157557,7486.3298632,4680.7619663,10560.113701,38.9164379,58.3648549,0.1106572,162.2523898),(11702,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,296,834.6689042,92.7567257,122.3757883,1.8,93.0362493,122.2848698,-0.1107628,20.4076891,29.5603964,96870.2995409,225462.2076821,1.6997081,7627.1713276,4746.7549547,10756.5500092,39.0030443,58.8923419,0.124355,163.5719908),(11703,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,297,844.4390024,92.727427,122.49825,1.8,93.0325129,122.3910495,-0.1105889,20.5739953,29.9357617,98608.8185752,231913.4393449,1.7142298,7747.0365162,4792.8862113,10888.7769512,39.2606789,59.4306815,0.1378071,164.9347776),(11704,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,298,855.8338602,92.7018019,122.6414592,1.8,92.98888,122.4449686,-0.1102343,20.7142022,30.0728438,100511.3988305,237869.9318892,1.7262838,7909.7917615,4852.2939874,11083.8022073,39.4575622,59.9164441,0.1439254,166.1501188),(11705,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,299,876.0498649,92.7402889,122.8207483,1.8,93.0145832,122.5876841,-0.1080568,20.9471813,30.394258,103005.1707588,244245.9308232,1.6982096,8035.9234455,4917.3761927,11262.4714857,39.7452673,60.4044136,0.1499452,167.36546),(11706,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,300,894.0642756,92.7320288,122.9575454,1.8,92.9877602,122.7177816,-0.1075067,21.1292192,30.6617823,105073.001011,250858.0725677,1.7155957,8181.4576133,4972.8766637,11423.7060738,40.1075011,61.0247732,0.1199882,169.1884718),(11707,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,301,908.1393714,92.7473702,123.076013,1.8,92.9991257,122.797922,-0.1054576,21.2710125,30.8500371,106975.574145,258581.4678387,1.6770527,8381.885148,5029.1717042,11688.7619518,40.2899693,61.5594609,0.1330128,169.943588),(11708,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,302,924.4792837,92.7576934,123.3105124,1.8,93.0083661,122.9391396,-0.1037995,21.5134308,31.2074624,108850.2456511,266063.105375,1.6541559,8525.6244692,5059.6414143,11860.3344951,40.6489208,62.2558453,0.1106572,171.7665998),(11709,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,303,940.7590508,92.7849376,123.5096727,1.8,93.0109356,123.0641798,-0.0998714,21.7761938,31.5563396,111054.2605037,273958.4511003,1.558709,8681.5661938,5099.8012655,12050.7945627,41.039524,62.7829899,0.1235061,173.9455768),(11710,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,304,952.2786749,92.8022142,123.6657544,1.8,93.0265188,123.1827692,-0.0968679,21.9462391,31.6915884,112741.6051842,281955.5447435,1.484614,8896.8574737,5137.1720065,12314.3412053,41.2154365,63.3800724,0.1428558,174.4489876),(11711,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,305,963.9639082,92.7083782,123.7226944,1.8,92.9328564,123.2392739,-0.0946826,22.0440235,32.1428001,114274.5442728,291700.1098399,1.4359912,9075.1306478,5183.9240708,12485.3917764,41.4675769,64.1157276,0.12768,176.7754102),(11712,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,306,975.8578873,92.6513091,123.8596063,1.8,92.9472081,123.3583198,-0.0941313,22.1771254,32.6018144,115568.0795732,300713.5958789,1.4368806,9223.8300613,5211.1388474,12635.5308752,41.6387204,64.9156043,0.1194289,178.2424568),(11713,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,307,988.6020678,92.6931901,123.9982853,1.8,92.9910713,123.4653857,-0.0930327,22.2835396,32.9650996,116965.4252184,311206.3748439,1.4219629,9440.4803566,5248.9607641,12873.5820322,41.85818,65.7197928,0.1113792,180.5688794),(11714,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,308,999.1651875,92.7820901,124.1300135,1.8,93.0329498,123.5894204,-0.091998,22.4273741,33.0508225,118391.3885034,322170.0424903,1.4054555,9747.7163248,5278.8787549,13211.2912205,41.9813957,66.3586309,0.1364026,181.6799608),(11715,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,309,1019.9666427,92.7487924,124.2620452,1.8,92.9943114,123.7020673,-0.0916575,22.5179231,33.4853801,119765.0162684,334795.0515847,1.4241437,9998.2455225,5318.6528747,13469.7654603,42.1931466,67.1537874,0.1283232,183.3987128),(11716,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,310,1052.5811748,92.6811141,124.3693481,1.8,92.9629357,123.8200026,-0.0918384,22.5783059,33.9506202,122044.3485758,351416.429322,1.4754734,10350.8102869,5405.3811361,13846.6395949,42.3192047,67.9532247,0.1204334,186.4370658),(11717,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,311,1095.3316558,92.6772822,124.4331484,1.8,92.9361741,123.92831,-0.0925804,22.5581426,34.3859937,125555.6327249,371824.1886766,1.5602388,10813.2454257,5565.8674921,14366.7855815,42.3841699,68.8064534,0.1189329,188.051558),(11718,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,312,1132.4908711,92.6525565,124.4893393,1.8,92.9415037,124.0646054,-0.0935337,22.3787885,34.8007208,127303.6635999,391718.4943255,1.6464657,11256.0454264,5688.5860375,14800.1361405,42.3194315,69.6107822,0.1113389,190.5254262),(11719,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,313,1167.7927467,92.6284208,124.5943042,1.8,92.930182,124.2103584,-0.0939095,22.4392354,35.2208204,130381.8212406,412712.7831377,1.7114196,11717.8640049,5810.4395699,15278.0490369,42.3926857,70.0865781,0.1167506,192.9992944),(11720,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,314,1216.742827,92.6372876,124.7136232,1.8,92.9323175,124.4145984,-0.0934522,22.2533745,35.5724638,135983.937174,437162.3408838,1.7658817,12289.3467054,6110.7108629,15954.094004,42.1266314,70.4649018,0.1099838,194.6137866),(11721,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,315,1270.3485375,92.7759775,124.7721048,1.8,92.9584616,124.6292365,-0.0964493,22.2327166,35.5504677,142810.4826736,461769.1409967,1.9634628,12989.1157887,6423.438266,16838.7418184,42.3504861,70.8920093,0.1093185,195.9765734),(11722,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,316,1313.144561,92.990573,124.7716091,1.8,92.9652947,124.8586367,-0.1001252,21.8974997,35.6232983,150243.5900221,476129.261835,2.1867342,13365.6703504,6861.2212372,17413.4120229,41.9961779,70.8464175,0.1032896,197.44362),(11723,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,317,1332.4240909,93.1140371,124.7764331,1.8,92.9805868,125.0882281,-0.0989901,21.5326431,35.1635867,154522.137422,476457.9105581,2.1689791,13549.7528901,7176.1806916,17530.1540895,41.7239767,70.2484031,0.1349767,196.8791352),(11724,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,318,1300.6579139,93.1337236,124.7331066,1.8,93.05385,125.3708008,-0.0927468,21.3856771,35.1229435,150679.455479,459248.4578663,1.8593621,13075.4547241,7045.8117643,16753.5058081,42.0079791,69.9560569,0.2166703,197.4868058),(11725,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,319,1281.1821148,93.0759341,125.0319502,1.8,93.0294178,125.7460626,-0.0871256,21.2316448,35.1163121,146769.7595776,443950.7222906,1.6167826,12642.2934338,6912.7832994,16214.9292011,41.6977953,69.8649433,0.2106638,197.5910656),(11726,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,320,1299.5076019,92.7608294,125.6493819,1.8,92.7874637,126.4852841,-0.0925677,24.6834958,35.530881,147555.4558537,438888.2535499,1.8505727,12352.3042763,5977.8994542,15953.185171,44.117009,69.6903071,0.1986047,212.8260164),(11727,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,321,1290.183865,92.4667727,126.1797113,1.8,92.2545378,127.3316874,-0.0996292,25.7079511,35.8595028,148078.048113,428139.707289,2.1273367,11939.3654248,5760.0097175,15527.1505268,44.8031263,69.7763568,2.9369508,246.1689371),(11728,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,322,1293.477584,92.4366227,126.5182723,1.8,92.409365,127.4109031,-0.1008609,24.9644508,35.9141763,148296.0445845,425865.9823418,2.1856451,11857.8797222,5940.2886954,15417.079997,44.0276719,70.0496877,2.9189317,221.9842612),(11729,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,323,1342.4639753,92.1547529,127.182098,1.8,91.952929,128.3682886,-0.1353797,26.3186173,36.2024539,159449.8348017,442469.6319951,4.0757135,12222.0895119,6058.4427023,15980.5653326,46.0512212,70.3757588,0.0978461,232.5663667),(11730,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,324,1361.1531311,92.3517469,126.8731783,1.8,92.2017605,127.6716084,-0.0993548,25.8903251,36.6868676,160941.2040729,443703.4340179,2.2320513,12094.3395452,6216.2681841,15903.4192365,45.8884775,70.9909078,0.121352,234.9538633),(11731,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,325,1384.0330367,92.2303794,126.8368839,1.8,92.2034783,127.593172,-0.0816294,23.3634235,37.3195592,170264.0596025,455045.2185269,1.53364,12193.2098933,7287.6331484,16212.9245936,44.7802967,71.4704327,0.1265921,227.5143705),(11732,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,326,1400.694488,92.09848,126.7345354,1.8,92.1830829,127.49167,-0.0665814,23.8513069,37.6107797,179785.1248811,468987.660867,1.0333713,12469.5011533,7537.7473263,16609.9051177,45.6299801,71.7077053,0.1503714,229.3373823),(11733,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,327,1411.3302855,92.0680053,126.7721582,1.8,92.4340013,127.6842847,-0.0423218,23.8876714,38.1959867,191201.64609,491077.8990013,0.4210603,12856.7931104,8004.1977687,17272.8309988,46.0078274,72.4339783,2.8029582,252.7237562),(11734,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,328,1396.565506,91.9690417,126.7004656,1.8,92.6426262,127.6467528,-0.03365,24.1015925,38.3720796,196712.3703866,508179.1051123,0.263461,13243.4601115,8161.799704,17660.3817125,46.4318135,73.2400644,2.8254079,308.1334499),(11735,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,329,1394.3396301,92.0536321,126.7515537,1.8,92.4939548,127.5764023,-0.0256924,24.123687,38.3488938,199200.034376,528092.903735,0.1533668,13770.7467126,8257.4456551,18215.1275936,34.0370708,48.2801842,1.0074801,159.9691531),(11736,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,330,1396.1482942,92.0001877,126.7648288,1.8,92.4448265,127.6395119,-0.0370073,23.942212,38.2649148,197631.9914956,543778.7605186,0.3185354,14210.8969338,8254.5418821,18494.077498,34.4699143,48.4176587,1.0197227,156.4273893),(11737,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,331,1401.3633586,92.001764,126.8290262,1.8,92.4501944,127.5905932,-0.0460893,23.7198816,37.800069,195139.9721587,557956.4160495,0.4957843,14760.7248222,8226.8526983,18876.3666668,33.4006869,48.1499868,0.9951693,152.7813657),(11738,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,332,1413.4824766,91.9623409,126.9095184,1.8,92.388906,127.541491,-0.0510359,23.1560118,37.7745933,191166.7992268,572377.1840386,0.613074,15152.4380137,8255.6012312,19131.2463957,34.0520491,47.9174372,1.0026916,154.8560829),(11739,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,333,1433.1257311,92.030337,126.9824868,1.8,92.4547733,127.5147836,-0.0511683,23.3801388,37.7310771,187705.4173969,587686.9661212,0.6248219,15575.6742659,8028.4132969,19529.2397719,34.1344166,47.6701994,0.9777938,148.5708573),(11740,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,334,1444.1059507,92.2113778,127.1282975,1.8,92.6591289,127.4492526,-0.0445927,23.7496734,37.6755163,181401.6228808,598499.977521,0.4782848,15885.6476495,7638.068094,19807.1799434,34.3894909,47.0738844,0.9802621,145.8020979),(11741,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,335,1445.4251728,92.4047096,127.1644451,1.8,92.7167028,127.2747543,-0.0401293,24.3295189,37.895688,172857.9219658,599459.700788,0.3877348,15818.6784017,7104.863952,19712.7068993,34.3625174,46.3625188,0.969941,146.4529543),(11742,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,336,1430.4596482,92.5779351,127.1810662,1.8,92.9942128,127.1902247,-0.0379098,23.0466825,37.7753487,161972.057511,588616.8996917,0.3424665,15582.0374889,7027.9988368,19297.4577387,34.3176028,45.3050932,0.9538544,142.8680047),(11743,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,337,1382.3154576,93.0632277,127.1125432,1.8,93.4662645,127.0706124,-0.0369518,22.1682761,36.9453721,142677.6440074,555350.0238269,0.314435,15031.6532916,6436.1181486,18352.0822588,34.0519861,43.9963584,1.354246,140.1856169),(11744,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,338,1334.2520014,93.4892894,127.0149746,1.8,93.7650973,126.7246071,-0.0380693,22.0704887,36.6153982,127365.719324,519945.5991892,0.3221269,14200.1896765,5770.8608583,17355.1196069,33.7436203,42.1028466,1.3233424,136.4353335),(11745,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,339,1255.6605761,93.9897757,126.9444644,1.8,93.9952865,126.5322428,-0.0347788,26.6504178,36.6071949,108956.2329423,464874.9367717,0.2530319,12699.0045922,4088.3499051,15088.3180239,33.2085576,40.2533039,1.2895641,131.7824883),(11746,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,340,1129.4486429,95.5118163,126.8101428,1.8,95.3083802,126.4870426,-0.0430518,20.3264346,38.9806748,90310.9199266,369690.8255761,0.3486814,9483.951415,4443.0281017,11641.8622299,33.3219258,39.8684709,2.610415,139.7253919),(11747,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,341,957.3980665,97.8150429,126.6585691,1.8,98.3114853,126.437455,-0.0523598,18.9165522,30.5694705,71515.8280037,241372.4883055,0.4370594,7895.867498,3780.5952815,10080.4461277,20.4065192,36.9631594,1.2637506,102.527928),(11748,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,342,830.3937274,96.6721047,126.7059954,1.8,97.2002555,126.5463261,-0.0542392,17.7253511,30.537734,53296.7393645,191417.7397688,0.406755,6268.236532,3006.8086669,7979.3270521,20.1527209,35.6097044,1.226149,103.908603),(11749,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,343,663.4189024,94.1156652,126.8789134,1.8,96.0302361,126.3579775,-0.0533129,17.0038964,32.8771267,37065.06663,122304.7131585,0.3139704,3720.0548029,2179.7984307,4819.7301499,20.195336,32.3951697,1.1902899,99.212572),(11750,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,344,557.8525505,93.4355327,126.8088274,1.8,93.4905963,126.8210749,-0.0188332,15.2696727,22.2723765,23491.7806617,93124.4338335,0.0329735,4181.16287,1538.4599994,4855.0915422,18.864763,28.9681105,1.2068174,83.6648419),(11751,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,345,432.7221679,94.6654016,126.4463723,1.8,93.4564866,126.4289971,-0.0109424,13.7418058,22.9894732,12703.9145623,71634.9169971,0.008635,3115.9877549,924.4719918,3472.0392576,17.617208,26.7444107,1.1574659,98.353196),(11752,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,346,247.6911384,97.7531263,126.8602213,1.8,95.5824039,127.0323513,-0.0572167,11.5361783,25.4574522,4039.2043786,37974.1117852,0.1349992,1491.6697647,350.133664,1620.6439153,15.03908,19.770318,0.739277,63.7338601),(11753,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,347,46.1367397,109.5195619,126.7783204,1.8,108.7688057,126.8119522,1.3379444,6.712932,9.2837561,117.8538795,566.8448755,7.280015,61.057709,17.5562451,73.7514396,9.563671,17.9442977,1.8622531,44.1767317),(11754,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,348,1662.5363653,91.1042781,113.7889818,1.8,91.5951689,113.9654715,-0.1823714,24.0975511,40.6267178,191398.8996012,793122.1556261,9.1140864,19522.1814217,7942.6701302,23843.2587285,37.382856,47.4314053,0.9853063,142.5120395),(11755,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,349,1628.2618257,91.3605913,113.7273337,1.8,91.5828754,113.9447388,-0.179204,24.6717344,41.0605559,200120.4030384,780503.4253543,8.6221227,19008.5937058,8111.3228555,23550.9034519,37.812544,47.4314053,0.9853063,145.7589121),(11756,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,350,1574.3028531,91.2419466,113.6339657,1.8,91.528436,113.9513187,-0.186934,25.0852595,41.1646864,203421.8944528,764644.1645173,9.0625234,18575.2457112,8109.2202507,23233.8372074,38.242232,47.3242375,1.0054599,144.6910165),(11757,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,351,1542.0588714,91.1981305,113.4889457,1.8,91.4198929,113.8999267,-0.1965634,25.3664528,41.2120149,205147.5028113,757454.4827009,9.8029029,18379.4576652,8087.3547455,23098.4464359,38.67192,47.0738844,0.9802621,146.9742533),(11758,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,352,1528.2404137,91.2131062,113.2747975,1.8,91.2452254,113.8238963,-0.2025868,25.6440925,41.3796233,206924.6493122,755600.7974065,10.3112991,18260.2145159,8069.096213,23048.4091996,38.67192,46.8537281,0.9548112,145.4029469),(11759,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,353,1469.9729187,91.033101,112.7961346,1.8,91.0702115,113.3965796,-0.2141473,26.0119125,41.353411,203648.7750828,726446.3911566,11.0645652,17566.7828437,7829.05812,22272.6581161,38.67192,46.7096747,1.0824624,145.4029469),(11760,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,354,1421.847527,90.825359,112.6577213,1.8,90.7505649,113.3033196,-0.228579,26.1966994,41.4365742,201215.9031102,706446.115467,12.1673929,17048.8542718,7680.9639298,21729.3240125,38.242232,46.3366263,1.1403316,143.3282297),(11761,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,355,1380.0504733,90.4319972,112.5080723,1.8,90.4718583,113.1212236,-0.2497105,26.250655,41.2915304,198228.5600793,687466.1153536,14.0466166,16649.0829745,7551.375761,21278.1273371,38.242232,46.0067245,0.9983365,142.0697027),(11762,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,356,1306.6263878,90.4681665,112.0802715,1.8,90.4487857,112.8471979,-0.2658218,26.2342473,41.5078648,194630.4261836,657724.0925304,15.0289197,15845.7703366,7418.9445418,20379.5984034,37.812544,45.6461346,0.9932372,140.8543615),(11763,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,357,1206.6499029,91.0242006,111.3230166,1.8,90.7755487,112.4595311,-0.2733333,26.2070681,42.0974681,188382.0809437,619082.455985,14.6545529,14705.930879,7188.2165694,18955.3731012,37.382856,45.1826688,1.0091728,145.0037959),(11764,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,358,1130.6563026,91.4712357,110.5006445,1.8,91.5660591,111.7767615,-0.2785433,26.0776382,42.4868388,181819.3542242,587585.7481782,14.2463599,13829.829769,6972.2324069,17823.5544249,36.953168,44.8195687,1.0040671,142.7205591),(11765,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,359,1087.0895813,91.6842869,109.7171012,1.8,91.8396609,111.2129111,-0.2924331,25.8071416,42.4682362,174905.4803294,567769.7368457,15.0574603,13369.2798994,6777.4061504,17221.7900037,36.093792,44.226565,1.0070477,143.7273807),(11766,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,360,1052.4411904,91.7817598,108.9653059,1.8,91.7071256,110.5153914,-0.3140829,25.2217455,42.2467003,168531.8228215,550203.2451704,16.7419947,13023.5791629,6682.0047208,16859.7041155,36.0099909,43.8618641,1.5316007,144.0833459),(11767,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,361,1001.6357285,92.0319463,107.9123967,1.8,92.307436,109.3714608,-0.3219851,24.8076166,42.0433324,158486.9254162,518188.5634676,16.7174341,12325.1068251,6388.6397456,15984.9654707,34.804728,42.9365613,1.971746,137.7549345),(11768,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,362,950.610387,91.8819281,106.8638473,1.8,92.260152,108.3344423,-0.3362858,24.4283178,41.7665861,146414.8887106,494122.1001429,17.2518207,11830.5599387,5993.6541706,15220.6430923,34.7680452,42.9365613,1.971746,128.8483951),(11769,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,363,924.0226277,91.6847642,106.1722038,1.8,91.9408282,107.4781588,-0.3551844,24.0061162,41.6124853,139618.3449305,484897.2294523,18.6251025,11652.686108,5815.9489017,14930.9436771,34.37504,42.7706868,1.9624963,127.3813486),(11770,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,364,901.3952761,91.5215276,105.4824479,1.8,91.6660791,106.7205505,-0.3715929,22.9620557,41.5509269,134606.5914582,479036.3566079,19.8069084,11528.8969935,5862.1315649,14741.9815758,34.2207514,42.7123705,1.9849349,126.9821975),(11771,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,365,884.8886357,91.3355667,104.7069584,1.8,91.3406756,105.9303008,-0.3866209,22.751565,41.6157599,129364.4976955,478192.3107002,20.9681643,11490.6543127,5685.9603932,14592.0937817,33.8378443,42.7123705,1.9849349,125.1591857),(11772,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,366,881.3042615,91.1584352,104.0062626,1.8,90.9901606,105.1130571,-0.4010854,22.4805035,41.7406846,125085.1792653,485203.2544769,22.3889627,11624.2284735,5564.1627009,14612.6012823,33.5042604,42.3193601,1.9890207,124.6557749),(11773,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,367,891.6522572,90.9797389,103.3244607,1.8,90.7390798,104.4500233,-0.410456,22.2149119,42.0828194,121823.9316418,502847.2368439,23.6619158,11948.9911687,5483.8809166,14838.304086,33.4672128,41.9446803,2.0848599,124.0481043),(11774,'Cervus_giganteus-metatarsus-cleaned.tif',249,10,368,903.696907,90.8377989,102.6309169,1.8,90.6770345,103.6277367,-0.4178591,22.2021265,42.6346201,118906.7629112,523482.9214601,24.8030867,12278.3531257,5355.6474801,15059.7047281,33.6299011,41.7527633,1.983796,124.5083293),(11775,'Alces_humerus.tif',242,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11776,'Alces_humerus.tif',242,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11777,'Alces_humerus.tif',242,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11778,'Alces_humerus.tif',242,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11779,'Alces_humerus.tif',242,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11780,'Alces_humerus.tif',242,2,6,13.9109739,82.7329726,112.7676767,1.8,83.0951199,113.0625252,0.3391263,4.7000568,11.1705074,49.5799335,546.3278347,0.256576,48.9080591,10.5487946,52.9512415,7.7391338,12.0970027,2.1910458,35.1501377),(11781,'Alces_humerus.tif',242,2,7,147.0868772,83.3732934,112.1303729,1.8,83.4207849,112.0928215,0.3521855,15.7275496,14.4021065,2969.6822402,5833.7951666,2.9169896,405.0654107,188.8204023,542.3556663,22.7837756,28.9329332,2.6616421,89.1786221),(11782,'Alces_humerus.tif',242,2,8,229.3775866,81.5581563,111.4321365,1.8,81.8280919,111.5231855,0.681484,35.3325077,17.9452966,9033.6478842,13926.8391987,15.1707385,776.0718305,255.6752539,619.6102856,27.5396007,36.0175226,2.4668517,109.5838538),(11783,'Alces_humerus.tif',242,2,9,278.8733758,79.8278774,110.3910403,1.8,80.6900686,110.6072875,0.7798469,36.512882,57.3045578,15000.0390781,25740.0530402,22.9814366,449.1798566,410.8149853,647.345817,30.3282087,40.3623186,2.485897,113.3760816),(11784,'Alces_humerus.tif',242,2,10,311.4185575,77.5960261,107.5536035,1.8,77.9795902,106.633381,0.9791041,37.4067173,54.8169024,18721.8074833,60249.1332455,35.7558667,1099.0977344,500.493196,1189.9699647,31.571168,45.0287658,2.3948493,125.8410091),(11785,'Alces_humerus.tif',242,2,11,360.0682022,75.6309288,104.5468621,1.8,75.8724642,103.865087,1.0284675,34.4177349,42.147165,20972.8444222,99108.6495707,44.0247992,2351.4902955,609.3615538,2807.4706722,32.5328603,70.9188657,2.0167074,186.5595205),(11786,'Alces_humerus.tif',242,2,12,382.8915972,74.1198221,102.3399228,1.8,74.2494381,101.660546,1.0805338,36.2692777,43.5534185,21047.333641,125692.8476175,49.6669863,2885.9467722,580.3074934,3331.4379211,32.7040331,74.8917833,1.9966468,192.9875754),(11787,'Alces_humerus.tif',242,2,13,398.3629125,72.7940749,99.746448,1.8,73.2516795,98.5481308,1.1852883,73.2648434,55.7788304,30335.1086836,149223.1196353,57.0058333,2675.2644083,414.0472742,2146.7205174,0.4971837,0.9943675,0.7853982,1.988735),(11788,'Alces_humerus.tif',242,2,14,438.2080015,73.7892663,97.8595873,1.8,76.2256077,97.341605,0.985161,77.5667358,67.2921913,71124.3536089,184945.6016617,50.7218949,2748.3961825,916.9440075,3121.6340876,0.351562,0.4971837,2.3561945,0.9943675),(11789,'Alces_humerus.tif',242,2,15,515.3116182,78.3528147,96.4959676,1.8,81.0817488,96.3042304,0.5013897,77.1420713,78.9327822,129376.1067768,299471.7208399,19.8411528,3794.009439,1677.1147639,5424.0039346,0.4971837,1.4915512,0.7853982,2.9831025),(11790,'Alces_humerus.tif',242,2,16,604.9500629,83.2587407,95.3464017,1.8,85.4215081,95.104122,0.3184,72.0788803,67.0210484,164473.4373551,447928.4853181,9.8807167,6683.400151,2281.8533899,8314.037802,35.7873986,80.0180135,1.846682,201.8162459),(11791,'Alces_humerus.tif',242,2,17,712.4002411,87.4556924,94.7514104,1.8,89.0139736,95.2075547,0.241073,58.9658844,62.6175812,184994.0758406,601432.2164732,6.7676902,9604.8458796,3137.3068949,11779.559693,0.703124,0.9943675,0.7853982,1.988735),(11792,'Alces_humerus.tif',242,2,18,949.0461619,93.3620707,91.4936079,1.8,95.7732835,90.4503285,0.0686286,54.0494678,51.6435848,308007.2097256,799168.4508587,0.743814,15474.6897282,5698.6168871,19586.6453804,0.351562,0.4971837,2.3561945,0.9943675),(11793,'Alces_humerus.tif',242,2,19,1416.7252918,97.6942121,84.2392057,1.8,97.8650891,85.5609853,-0.1683094,53.9388556,52.4088046,575359.1586053,1050446.8379896,6.6259266,20043.3275509,10666.877383,25126.6269779,0.351562,0.7861165,2.677945,1.4915512),(11794,'Alces_humerus.tif',242,2,20,1726.8064674,98.1156248,81.3174792,1.8,98.9809123,83.7825453,-0.238646,59.4492163,50.7647265,750504.4064426,1203474.5219924,16.0820129,23706.9044649,12624.2943658,27797.8857933,83.8115002,106.5905605,2.4472767,507.5560199),(11795,'Alces_humerus.tif',242,2,21,1848.228968,98.7811319,79.9006778,1.8,99.8139708,82.674948,-0.3086036,62.5447417,62.354538,886794.7649772,1326613.7370689,28.4168243,21275.3358507,14178.5662627,31494.9143989,86.13269,106.6253409,0.6190996,458.0728567),(11796,'Alces_humerus.tif',242,2,22,1904.1192689,98.880194,78.7658971,1.8,100.0259524,81.7186623,-0.3937635,64.5351821,56.0965434,983155.3591958,1439446.618276,46.7144091,25660.1660292,15234.4089982,35648.6285505,88.2373353,109.6174601,0.6075731,412.8437713),(11797,'Alces_humerus.tif',242,2,23,1955.7286969,98.9864528,77.7022577,1.8,100.1839863,80.9399009,-0.4582545,66.1738541,66.0627119,1065140.7593005,1535757.8184206,63.7903464,23246.9690292,16096.0967828,36445.8103774,1.6214619,5.5028157,1.1071487,15.3627267),(11798,'Alces_humerus.tif',242,2,24,1998.6763786,99.1621163,76.6539719,1.8,100.2699914,80.2809576,-0.5262035,66.570145,69.9212093,1131656.7121348,1612018.8938102,84.0307215,23054.7913963,16999.4629272,37791.111204,0.7870085,1.75781,0.6435011,3.6862265),(11799,'Alces_humerus.tif',242,2,25,2037.6659971,99.5976244,75.517301,1.8,100.5573706,79.410745,-0.6001949,67.7999917,70.069079,1183661.8693537,1672954.3718204,108.3368673,23875.7865104,17458.1418066,39464.79632,0.8463012,2.745787,0.8760581,5.6749615),(11800,'Alces_humerus.tif',242,2,26,2045.620101,100.0065413,74.6009387,1.8,100.7299008,78.6758035,-0.6546033,72.4173536,70.9337111,1195206.0555944,1680967.2226379,126.3824061,23697.7199655,16504.4149826,39547.6449684,0.351562,0.4971837,2.3561945,0.9943675),(11801,'Alces_humerus.tif',242,2,27,2034.1240774,100.433009,73.7198962,1.8,100.8754023,78.0748841,-0.7131707,58.5760972,69.7190465,1189872.4416855,1662843.5381232,145.1088115,23850.6350936,20313.2761944,40040.1853823,93.7072535,111.5432598,0.5469059,356.8765214),(11802,'Alces_humerus.tif',242,2,28,1994.4682399,100.5990019,73.2533379,1.8,100.8703193,77.642368,-0.7844443,57.0606011,62.3449262,1149436.9692321,1640053.7693279,165.8886257,26306.1305786,20144.144082,44712.3014973,92.9354961,110.9165574,0.6187756,348.5596704),(11803,'Alces_humerus.tif',242,2,29,1938.984719,100.8184342,72.9054979,1.8,100.7854596,77.2206766,-0.83015,66.7924962,62.5347716,1084054.8181616,1600343.3912483,176.0249309,25591.2566602,16230.1887188,39388.799238,91.4181797,110.4654574,0.7448798,347.1534224),(11804,'Alces_humerus.tif',242,2,30,1907.1802885,101.015419,72.6330305,1.8,100.5060448,76.6938696,-0.8216558,62.5158661,60.1168499,1019583.1730479,1563559.6210538,170.446563,26008.675179,16309.1905491,39557.4673293,0.351562,0.4971837,2.3561945,0.9943675),(11805,'Alces_humerus.tif',242,2,31,1859.0157387,100.8039208,72.758103,1.8,100.0522125,76.3025838,-0.8192577,54.1110656,60.2104919,937687.8690129,1532195.1623037,165.4008648,25447.3118212,17328.9485096,40868.9407328,88.999683,109.6343715,0.7173217,341.2371869),(11806,'Alces_humerus.tif',242,2,32,1782.8055701,100.2667725,73.1460093,1.8,99.5354828,76.1401157,-0.8158908,56.6720337,59.9527404,839600.3218019,1474584.7160562,157.621914,24595.7850386,14815.0731012,37743.3710438,86.5057957,109.2815082,0.7330542,341.0458824),(11807,'Alces_humerus.tif',242,2,33,1686.1384922,99.9825743,73.5686196,1.8,99.1011007,76.0726451,-0.8070737,59.042113,59.3098244,734572.2865558,1360775.558716,146.6009556,22943.5101502,12441.4972442,33310.0296607,79.4789322,108.220012,0.8244587,338.5039319),(11808,'Alces_humerus.tif',242,2,34,1581.8914313,99.294653,75.0035138,1.8,98.7369104,76.9000978,-0.7999813,41.3265427,57.053049,634856.9078194,1246563.1733,135.6685597,21849.1946537,15361.9651185,32434.6348478,75.5247139,106.6948679,0.7551044,339.8602104),(11809,'Alces_humerus.tif',242,2,35,1459.992787,98.1107399,77.0983173,1.8,97.820656,78.483472,-0.7816959,40.1767957,54.9208604,535576.4214559,1117436.6443774,120.7652004,20346.3062502,13330.4912141,29554.7969082,72.9534949,104.9634849,0.8185614,380.0467908),(11810,'Alces_humerus.tif',242,2,36,1362.6544339,96.9350708,79.1413496,1.8,96.7818477,80.1853556,-0.7409798,37.0556213,51.621441,469389.4472079,995244.0097407,103.4799844,19279.6634655,12667.159024,27797.6048377,69.7191182,103.1731152,0.8843476,347.7651809),(11811,'Alces_humerus.tif',242,2,37,1257.1814521,95.566659,81.7113142,1.8,95.5055345,82.2982791,-0.6669277,35.1243032,50.7010117,410261.0343119,846181.9191589,80.1735927,16689.6456302,11680.261165,23742.7526964,66.9790126,100.6241442,0.9391745,346.5441751),(11812,'Alces_humerus.tif',242,2,38,1146.685348,93.863171,84.699862,1.8,93.5830873,85.679826,-0.5189405,35.9127147,46.2503257,346505.20754,692536.2974883,47.0096424,14973.6523225,9648.5384263,19254.0105089,61.780686,86.2961189,0.9737544,295.2075497),(11813,'Alces_humerus.tif',242,2,39,1089.2239192,92.9457445,85.9887245,1.8,92.7093249,87.0609911,-0.4679432,35.9358486,43.6055716,315523.3051826,636581.4202856,36.933314,14598.6257582,8780.1823882,21596.9273943,59.687262,82.6058492,0.7432545,298.1053489),(11814,'Alces_humerus.tif',242,2,40,1045.6085953,92.3161876,86.9943304,1.8,92.0427923,88.0135779,-0.432692,39.0505909,41.3505637,293315.4487178,594373.4979427,30.6408762,14374.0119832,7511.1654363,20291.4157384,0.351562,1.1117367,1.8925469,2.4006155),(11815,'Alces_humerus.tif',242,2,41,1000.5048029,92.0897241,87.9122109,1.8,91.5795087,88.7303916,-0.4174485,37.868297,39.8633541,267566.7982324,547761.0389644,27.4093268,13740.9671489,7065.720385,18968.7136799,55.9798055,79.113949,0.4358218,280.1360665),(11816,'Alces_humerus.tif',242,2,42,960.1482144,92.0101791,88.86066,1.8,91.3084939,89.4764464,-0.4214662,33.0929067,39.1053322,242492.027734,506814.5609308,26.782026,12960.2417885,7327.6134265,18234.8676326,54.2626781,77.2956849,0.3821956,273.0402213),(11817,'Alces_humerus.tif',242,2,43,925.7173722,92.051825,89.7591398,1.8,91.3367401,90.3113115,-0.4364921,28.8515824,39.2130038,220605.5425354,469568.1071786,27.5753691,11974.8058611,7646.2198777,17396.5087049,0.351562,3.1835293,1.6814535,6.6193595),(11818,'Alces_humerus.tif',242,2,44,895.2607356,91.9691544,90.4808387,1.8,91.3590772,91.0239596,-0.4427933,39.122532,37.9101989,204489.2131023,439224.0238587,27.3923425,11585.9066103,5226.8910745,16449.5366534,51.7321465,75.0681605,0.4196509,258.9777413),(11819,'Alces_humerus.tif',242,2,45,876.4124449,91.6860951,91.2341545,1.8,91.2177124,91.6581743,-0.4412702,26.9519464,37.4151354,192732.6071966,417327.2603852,26.6435876,11153.9690029,7150.971756,16192.6137328,50.479002,74.0453338,0.3999043,259.6808653),(11820,'Alces_humerus.tif',242,2,46,855.9607042,91.5548474,91.8801509,1.8,91.0809462,92.2920431,-0.4398567,26.490062,37.0006492,181169.6831331,396620.7241526,25.8662766,10719.2909589,6839.1566174,15468.6007597,49.842612,73.1223607,0.3688998,259.6808653),(11821,'Alces_humerus.tif',242,2,47,833.9257008,91.3682701,92.5116094,1.8,91.0048793,92.8679608,-0.4358359,26.7577365,36.609274,170849.7360595,378724.0576209,24.7712197,10345.0305404,6385.0593728,14952.3457895,48.7481187,72.297082,0.3525101,297.8994087),(11822,'Alces_humerus.tif',242,2,48,819.8217301,91.1512856,93.1064048,1.8,90.7909417,93.3833358,-0.4285493,26.2059249,36.5758235,162382.3595622,365075.1091232,23.5949086,9981.3230231,6196.3987291,14416.3086823,46.5500273,72.0573468,0.3433521,234.1331896),(11823,'Alces_humerus.tif',242,2,49,817.2153185,90.9782615,93.5912031,1.8,90.6119103,93.7668615,-0.4221931,26.9382719,36.3612293,154920.0373667,357963.2327805,22.8690693,9844.6405645,5750.9270862,14091.4966801,47.6429151,72.0899291,0.3587707,245.191869),(11824,'Alces_humerus.tif',242,2,50,810.6168363,90.831868,93.957592,1.8,90.3285505,94.1032365,-0.4162502,25.2996382,37.4136886,148151.7249539,350384.6263256,22.087383,9365.1452156,5855.8831384,13293.395731,47.1666406,72.2688688,0.3786997,278.1119977),(11825,'Alces_humerus.tif',242,2,51,809.9005047,90.5544231,94.2724673,1.8,90.0232029,94.428225,-0.4034109,24.9967511,36.119518,142917.6308859,347227.1849111,20.8011527,9613.2839997,5717.4482557,13566.4777643,46.5448518,72.1396315,0.3741716,240.3053348),(11826,'Alces_humerus.tif',242,2,52,806.604728,90.3513589,94.5863653,1.8,89.8467026,94.7303546,-0.3915192,24.5895289,36.0318841,138079.2756358,344097.9029869,19.5753995,9549.8171062,5615.3688927,13285.5902632,45.9182795,72.0985009,0.2816486,242.0028263),(11827,'Alces_humerus.tif',242,2,53,803.5070792,90.2393262,94.9249711,1.8,89.6993528,95.0925163,-0.3857407,24.4886974,37.8910553,133760.9670776,338378.3919016,18.9575065,8930.2973719,5462.1511764,12460.3230114,45.782828,72.1661825,0.3017224,241.1290958),(11828,'Alces_humerus.tif',242,2,54,798.0811469,90.169486,95.2156789,1.8,89.6101759,95.3676298,-0.3796469,25.2131629,38.6319926,129856.5510642,333120.9697256,18.2679205,8622.9300568,5150.3475236,11977.022569,45.8022563,72.1970038,0.2863262,230.2909923),(11829,'Alces_humerus.tif',242,2,55,793.5423706,90.1747015,95.456431,1.8,89.5726481,95.6123704,-0.3770918,24.2605811,36.1275652,126380.8253401,327437.7966612,17.9320266,9063.3784754,5209.3074271,12382.7529018,45.1250233,72.0599196,0.2615452,246.6834203),(11830,'Alces_humerus.tif',242,2,56,788.4727689,90.3855343,95.670942,1.8,89.7635953,95.8317832,-0.3811801,31.6112194,37.3062921,123530.7309082,321601.9691267,18.1869125,8620.5825122,3907.8129024,10263.8523301,44.5994006,71.6013648,0.3093288,257.1742485),(11831,'Alces_humerus.tif',242,2,57,781.9192306,90.8570779,95.9039194,1.8,90.1108346,95.9648849,-0.390648,29.8012409,36.3306061,119863.789825,312431.3281838,18.8962832,8599.6728785,4022.1073435,11805.7658363,43.6064636,71.1598311,0.3061268,225.4397918),(11832,'Alces_humerus.tif',242,2,58,774.2249026,91.2085985,96.1514881,1.8,90.4367092,96.2444598,-0.4019789,24.8604019,38.8933985,116164.7662198,303903.5745719,19.7516317,7813.7572609,4672.6825514,9941.8295138,43.1568979,70.6149712,0.2981329,232.0384533),(11833,'Alces_humerus.tif',242,2,59,772.2334366,91.6413779,96.3471907,1.8,90.8679023,96.3645723,-0.4147428,28.8984682,36.1312876,113995.5933403,295013.2234622,20.8982269,8165.0348795,3944.6932766,11250.6191822,42.4566288,69.9290312,0.3169811,237.7134148),(11834,'Alces_humerus.tif',242,2,60,764.5557005,92.1142985,96.5091614,1.8,91.373417,96.5556208,-0.4266813,28.8115728,35.5712305,111787.0578968,285109.3764557,21.8246825,8015.1676551,3879.9359777,10953.1978479,42.5425366,69.2014769,0.2831845,243.88556),(11835,'Alces_humerus.tif',242,2,61,762.0249071,92.5250081,96.6273277,1.8,91.8308019,96.6235278,-0.4338083,30.531623,41.7868411,110488.1372157,275687.412249,22.4386828,6597.4695597,3618.8098241,8999.3891677,41.7568263,68.5266396,0.2860514,253.949872),(11836,'Alces_humerus.tif',242,2,62,762.9013514,92.9280349,96.6892296,1.8,92.1820011,96.6878292,-0.4406544,34.666484,42.7129486,110220.6291605,266861.0223164,23.1323188,6247.778047,3179.4579787,8710.2512012,2.3885075,24.1940054,0.9505468,65.3577093),(11837,'Alces_humerus.tif',242,2,63,766.1113975,93.3590897,96.7137623,1.8,92.6803343,96.6673503,-0.4437052,29.9635955,40.8277181,110888.407937,258484.1904485,23.5309729,6331.0956973,3700.7710891,8739.9966142,2.2798174,20.7689547,0.9780989,54.2990299),(11838,'Alces_humerus.tif',242,2,64,694.6670845,93.5227241,97.0002993,1.8,91.986595,97.682111,-0.4505892,28.7312292,33.2281728,107230.3980773,245753.6011013,21.9580508,7395.9408743,3732.1897094,10596.070009,0.7457756,1.4915512,0.7853982,2.9831025),(11839,'Alces_humerus.tif',242,2,65,698.2125248,94.0498755,96.9159481,1.8,92.6501532,97.4739347,-0.4540352,28.8678992,32.9293475,107420.8916068,240058.5187594,22.3853921,7290.1085771,3721.1191216,10546.6289213,0.703124,0.9943675,2.3561945,1.988735),(11840,'Alces_humerus.tif',242,2,66,701.1724579,94.3603645,96.9230452,1.8,93.0013728,97.4611605,-0.4568831,28.8524521,38.7318161,107306.8797517,236561.3991048,22.7432291,6107.6763959,3719.1597925,8058.7776878,1.8587356,5.798109,1.3258177,16.9395812),(11841,'Alces_humerus.tif',242,2,67,702.6953085,94.6865856,96.9278178,1.8,93.4835815,97.3812391,-0.4572371,28.9466056,39.9801388,107212.1185078,233471.1250869,22.8254605,5839.6777047,3703.7889718,7877.4886355,1.4807064,4.1149277,1.2220253,10.767436),(11842,'Alces_humerus.tif',242,2,68,711.7604641,95.071191,96.9268068,1.8,94.0337557,97.5001314,-0.4545024,27.6201126,32.0864398,107524.0459797,232481.3908666,22.8634603,7245.4716765,3892.9618913,10588.3427717,1.6762025,8.9631075,1.1246908,21.8261154),(11843,'Alces_humerus.tif',242,2,69,717.6096559,95.6193982,96.8046263,1.8,94.8146362,97.3528321,-0.4502251,29.838633,32.1896267,108141.7822438,232140.8241474,22.6491254,7211.6656293,3624.2203984,10563.2304633,1.3644764,4.3485818,1.3258177,10.9733762),(11844,'Alces_humerus.tif',242,2,70,725.6656702,96.1377165,96.7518161,1.8,95.3071054,97.4551441,-0.4401643,31.9464919,31.5141982,108825.0051416,233726.881576,21.9575591,7416.5580962,3406.4774799,8221.8537962,1.9330212,6.9070974,1.3134726,21.1583252),(11845,'Alces_humerus.tif',242,2,71,731.2489437,96.5509849,96.6795335,1.8,95.6603959,97.6241694,-0.4313409,30.5385885,31.1137013,109610.1412233,232818.5220838,21.3035517,7482.8294979,3589.2340393,10188.2077224,0.7457756,1.75781,2.2142974,3.6862265),(11846,'Alces_humerus.tif',242,2,72,732.1937403,96.8867977,96.5339318,1.8,96.034085,97.486702,-0.4315948,30.953212,30.9382489,110717.3922134,227431.3808275,21.3546202,7351.1394236,3576.9274015,9978.0316239,0.8794877,1.75781,2.4980915,3.6862265),(11847,'Alces_humerus.tif',242,2,73,730.8569951,97.2346697,96.4333065,1.8,96.556454,97.2756959,-0.4361863,30.9733073,30.3820029,110582.7680524,221338.7537911,21.7423103,7285.1929748,3570.2602593,9640.7435378,0.351562,0.4971837,2.3561945,0.9943675),(11848,'Alces_humerus.tif',242,2,74,729.6759807,97.3678617,96.3650346,1.8,96.5200454,97.2018417,-0.4386303,29.4075714,30.1325534,110656.1137305,214715.6806825,21.9352682,7125.7048049,3762.8443498,10649.2105143,0.4971837,0.9943675,2.3561945,1.988735),(11849,'Alces_humerus.tif',242,2,75,726.7420027,97.6590187,96.3058386,1.8,96.9413484,97.1888166,-0.4403605,32.2375283,29.4877065,110693.1881312,208460.6282174,22.0084556,7069.4079927,3433.6747882,9873.180645,41.9850218,58.220408,0.504166,164.2654927),(11850,'Alces_humerus.tif',242,2,76,725.1164178,97.9491981,96.1633982,1.8,97.3195176,97.0679563,-0.4435461,24.9117602,42.5887641,110913.914011,202861.1202762,22.2569101,4763.254459,4452.2712645,6969.979062,41.9850218,57.26577,0.4993467,163.1504882),(11851,'Alces_humerus.tif',242,2,77,726.1206152,98.2927597,95.9415376,1.8,97.6634399,96.8241836,-0.4447826,24.983397,28.7995231,111778.8044483,197090.1622632,22.403859,6843.5217393,4474.1235368,10523.2089056,1.44606,4.1149277,1.2220253,11.6765002),(11852,'Alces_humerus.tif',242,2,78,728.1884486,98.51708,95.7601674,1.8,98.0080859,96.658376,-0.4570739,25.1256234,28.4562251,112262.5698189,191617.4301423,23.6378647,6733.761396,4468.0511186,10523.3206476,1.0233573,1.8932193,1.1902899,4.3893505),(11853,'Alces_humerus.tif',242,2,79,731.1592806,98.7858983,95.5876168,1.8,98.2119939,96.3721527,-0.4654818,24.4970554,27.6829648,112738.4681265,185983.9326296,24.5510322,6718.3531028,4602.123247,10517.8822239,0.351562,0.4971837,2.3561945,0.9943675),(11854,'Alces_humerus.tif',242,2,80,736.7414305,98.9842047,95.4355993,1.8,98.4520132,96.1239995,-0.481507,25.7566634,26.9479655,113749.3258851,181102.0701309,26.3355419,6720.4357272,4416.3067365,8376.4960732,41.9832368,53.0206316,0.7338008,157.8874072),(11855,'Alces_humerus.tif',242,2,81,741.3511059,99.5322376,95.2338898,1.8,99.0144495,96.0023302,-0.4939301,25.3744119,27.2459945,113737.0185008,176605.6790692,27.7711611,6481.8951247,4482.3509236,8168.8052442,41.9832368,52.355597,0.7093546,156.6017962),(11856,'Alces_humerus.tif',242,2,82,743.3832087,99.8193978,95.1168549,1.8,99.2030095,95.746237,-0.4986557,24.2301773,27.2970568,113267.202625,173222.1496558,28.3376023,6345.8178179,4674.6336688,10489.2216792,0.703124,0.9943675,2.3561945,1.988735),(11857,'Alces_humerus.tif',242,2,83,743.196167,100.1620081,95.0534342,1.8,99.6340194,95.8080734,-0.5068303,24.3082502,27.428476,112562.9757124,169567.3204738,29.1854884,6182.1633908,4630.6490489,10220.2069663,0.703124,2.2234733,1.8925469,4.801231),(11858,'Alces_humerus.tif',242,2,84,747.5218342,100.5225336,94.8797962,1.8,100.0538464,95.5636064,-0.5191168,24.5016227,26.9918156,112982.6979344,166591.7387371,30.6644113,6171.9352718,4611.2332807,10347.0705352,0.6292498,1.2675748,0.5880026,2.4859187),(11859,'Alces_humerus.tif',242,2,85,753.584285,100.9127083,94.6344994,1.8,100.5601202,95.1990514,-0.5351154,25.5362597,26.5053174,113463.5338175,163616.7635166,32.6602314,6172.9788503,4443.2322973,10451.4272343,1.1732352,5.2851357,1.6373645,12.0030775),(11860,'Alces_humerus.tif',242,2,86,720.6967804,101.0513198,94.5807242,1.8,100.9174437,94.9736658,-0.7167601,24.3262943,26.2080126,108278.154534,151128.8331378,51.8393956,5766.5125391,4451.0747601,9842.0145431,1.054686,1.8932193,0.3805064,4.1834102),(11861,'Alces_humerus.tif',242,2,87,665.4217994,100.9795752,94.581699,1.8,101.0745469,94.9611353,-0.9715536,24.04975,26.9582743,96907.9534788,140684.8111128,75.6234675,5218.6133903,4029.4786242,8809.039823,24.1816535,47.52853,0.3708913,153.221449),(11862,'Alces_humerus.tif',242,2,88,682.2529311,101.3646525,94.2308688,1.8,101.512009,94.5369331,-0.9732787,24.7659279,25.2271542,99425.4170007,140561.3770561,77.7188734,5571.8285195,4014.6049644,9389.7132059,41.7550842,49.4716567,0.8860668,155.8280047),(11863,'Alces_humerus.tif',242,2,89,783.9315956,102.3733518,93.5751362,1.8,101.9651895,94.2392482,-0.6715383,24.2444875,25.0683234,114753.712739,151154.0142538,50.5794762,6029.681844,4733.1878138,9837.1298198,41.672182,49.1546038,0.8714793,150.1030738),(11864,'Alces_humerus.tif',242,2,90,790.4568566,102.7972546,93.2291985,1.8,102.290772,93.9123236,-0.6752954,26.4890454,25.3789687,114879.8722661,148829.7498133,51.4831042,5864.2946176,4336.8823047,9946.4184816,1.3450456,8.8171301,1.6506263,22.0673895),(11865,'Alces_humerus.tif',242,2,91,790.6617261,103.147477,92.8992314,1.8,102.8073161,93.5348773,-0.7259756,25.0118528,25.0984157,114618.5540723,145594.6942158,58.0763744,5800.951588,4582.5695087,10237.3223899,0.703124,0.9943675,2.3561945,1.988735),(11866,'Alces_humerus.tif',242,2,92,795.0258952,103.5516467,92.5298622,1.8,103.3744994,93.0558557,-0.7738215,23.8416811,24.4957811,114621.0803073,143263.6116241,64.7183342,5848.5014595,4807.5922102,10356.027446,0.9954939,2.8990545,1.3258177,6.789966),(11867,'Alces_humerus.tif',242,2,93,801.1447507,103.9421788,92.1951846,1.8,103.6962896,92.7952475,-0.8162516,23.6453161,24.5720245,114784.2021476,141443.4045353,70.8791274,5756.2780254,4854.4160631,10238.7780488,0.351562,0.4971837,2.3561945,0.9943675),(11868,'Alces_humerus.tif',242,2,94,803.9195148,104.3481573,91.7791009,1.8,104.1470936,92.2976388,-0.8644792,23.7223202,24.643969,114297.1697628,140243.5291834,77.5449637,5690.7850033,4818.1277728,9899.0259989,41.8413582,47.8873387,1.0051932,147.0846375),(11869,'Alces_humerus.tif',242,2,95,809.5822267,104.7284512,91.3344658,1.8,104.5689965,91.7219418,-0.9331304,24.7355502,24.1526845,114716.16937,139584.7250738,87.1099849,5779.2633924,4637.7043778,10242.2287847,0.351562,0.4971837,2.3561945,0.9943675),(11870,'Alces_humerus.tif',242,2,96,816.2805969,105.1136877,90.9131351,1.8,104.8986818,91.3339808,-1.0065605,23.1116168,25.055914,115210.9747611,139292.0843634,97.1402126,5559.2497898,4984.9811851,9864.7196923,0.703124,0.9943675,2.3561945,1.988735),(11871,'Alces_humerus.tif',242,2,97,823.6831637,105.6125555,90.3081945,1.8,105.3795822,90.7118323,-1.083317,24.9409857,25.7146901,114909.6792864,139469.0915823,107.1613345,5423.7127208,4607.2629545,9566.1702484,0.6292498,1.2675748,0.9827937,2.691859),(11872,'Alces_humerus.tif',242,2,98,825.4251535,105.9321943,89.8956778,1.8,105.7112917,90.3928134,-1.1476683,22.8996108,24.6986623,113937.730281,138953.6537736,114.3758096,5625.958679,4975.5312992,10173.8660522,0.703124,1.2675748,2.1587989,2.691859),(11873,'Alces_humerus.tif',242,2,99,820.6259644,106.3030749,89.3165969,1.8,106.1314776,89.7708851,-1.2170571,23.3277229,24.6805857,112366.7819886,138176.0281703,120.3586871,5598.57167,4816.8774336,10141.2766687,1.6309094,6.0177721,1.4536876,16.1864877),(11874,'Alces_humerus.tif',242,2,100,818.2076058,106.6241379,88.7385967,1.8,106.4721904,89.0167704,-1.2788219,23.237046,25.312608,111174.6720867,138200.3439238,125.0693111,5459.743385,4784.3719967,9446.1158136,0.703124,1.5722331,2.0344439,3.394983),(11875,'Alces_humerus.tif',242,2,101,816.8591752,106.8863296,88.1917837,1.8,106.8203638,88.5926117,-1.3354705,23.0548415,25.1302194,109871.8179257,138728.7344875,128.7419763,5520.3948761,4765.6722338,9447.3781878,1.406248,2.55941,1.849096,6.3780855),(11876,'Alces_humerus.tif',242,2,102,817.81944,107.0660681,87.6172243,1.8,106.9526426,87.8121616,-1.3833951,23.1661309,24.9886592,109162.6600249,139466.4436644,131.5721498,5581.1895516,4712.166249,9949.5849352,1.406248,5.3200984,1.4382448,12.7915047),(11877,'Alces_humerus.tif',242,2,103,821.3388128,107.2033596,87.0915351,1.8,107.1736775,87.2724343,-1.4153095,22.4837974,24.7095727,108817.7735302,141020.7159662,133.6069178,5707.1288874,4839.8307363,10109.844192,1.054686,3.1835293,1.6814535,7.2018465),(11878,'Alces_humerus.tif',242,2,104,824.8881483,107.3275746,86.5356242,1.8,107.211867,86.5973975,-1.4412485,23.9196591,25.3198959,108495.2716668,142571.8266551,135.1869386,5630.8219884,4535.820156,9885.547153,40.6852539,47.7399967,1.408069,145.7990265),(11879,'Alces_humerus.tif',242,2,105,829.3528794,107.6176905,85.7620926,1.8,107.545899,85.7677369,-1.4865042,24.1208295,25.1066548,108408.2215564,144570.1023506,137.2456881,5758.2383342,4494.3819864,9909.621411,0.703124,1.2675748,0.5880026,2.691859),(11880,'Alces_humerus.tif',242,2,106,832.2428123,107.7808659,85.2500732,1.8,107.5696411,85.4059498,-1.5212996,24.8457916,25.1511817,108271.4210533,145659.6089186,138.3675905,5791.3624396,4357.7368263,9755.8590467,0.703124,0.9943675,2.3561945,1.988735),(11881,'Alces_humerus.tif',242,2,107,833.4320665,107.9501276,84.7039897,1.8,107.7861554,84.9041543,-1.5566378,22.513009,25.2722531,108007.2474065,146725.6863991,138.8775009,5805.8015634,4797.5482609,9726.1408956,0.703124,1.8932193,1.1902899,4.098107),(11882,'Alces_humerus.tif',242,2,108,836.1484783,108.0795509,84.1522518,1.8,107.9944679,84.25121,1.5444519,38.6026289,31.2087513,108180.4774676,148093.631562,139.2613829,4745.2597631,2802.4121832,5162.6328456,0.703124,1.4495273,1.815775,3.394983),(11883,'Alces_humerus.tif',242,2,109,838.0750753,108.1396573,83.5928159,1.8,107.9765918,83.5714064,1.503835,22.3842746,25.4027446,108525.3877573,149147.9473809,139.0538191,5871.3320049,4848.287001,10121.4600481,0.703124,1.8932193,1.9513027,4.3893505),(11884,'Alces_humerus.tif',242,2,110,840.1049684,108.2554591,83.1185304,1.8,108.0796065,83.1354186,1.4676496,22.6652318,27.9130342,108894.1303385,150859.4306337,138.5330914,5404.6231366,4804.4569519,8868.6066084,0.351562,0.7861165,2.0344439,1.6974915),(11885,'Alces_humerus.tif',242,2,111,850.1677297,108.3189519,82.6212212,1.8,108.1936511,82.5835964,1.4218416,32.145187,25.3549361,110215.7339635,153653.702622,138.5739541,6060.1100289,3428.6854148,7643.23964,40.5742681,48.2050349,1.746736,147.3259115),(11886,'Alces_humerus.tif',242,2,112,860.9138637,108.3085423,82.1045304,1.8,108.2336318,82.1176482,1.3722022,22.19435,25.4298052,111735.8960901,156107.4270298,137.9006285,6138.7582816,5034.4297558,10484.4562018,1.8442707,15.1008054,1.359703,37.7566934),(11887,'Alces_humerus.tif',242,2,113,863.5948821,108.4618312,81.5476532,1.8,108.1850077,81.5234985,1.3322063,35.6777697,26.7194787,112756.149438,157849.2397995,135.8933927,5907.6466783,3160.4035303,7351.0722132,0.351562,0.4971837,2.3561945,0.9943675),(11888,'Alces_humerus.tif',242,2,114,865.3546996,108.5110605,81.100453,1.8,108.135091,80.8444981,1.2938938,32.3489093,25.3976739,113836.1586835,159217.9783071,133.4470363,6268.9984445,3519.0107257,7961.9368794,1.61906,3.7864386,1.9513027,10.2702522),(11889,'Alces_humerus.tif',242,2,115,872.0928077,108.5233684,80.7805223,1.8,108.1416896,80.5049086,1.2440223,33.656668,26.5716912,115919.1519595,161708.1723535,130.3728972,6085.7312742,3444.1660099,7917.6996071,3.1125617,20.9820967,1.4194209,55.9319162),(11890,'Alces_humerus.tif',242,2,116,883.1160211,108.4010595,80.3410979,1.8,108.0740003,79.9734119,1.1706212,32.8139892,26.8041257,118403.5997873,166445.0170458,124.8472506,6209.6790225,3608.3268964,8332.4674196,2.5896779,21.2803937,1.4382448,54.0638182),(11891,'Alces_humerus.tif',242,2,117,895.5503618,108.316741,79.9527684,1.8,107.9688807,79.5572868,1.1053002,23.250618,27.1992171,120946.5910179,171047.6422047,119.1856806,6288.6972749,5201.8656513,10592.9891732,2.768139,23.2987753,1.4801364,59.6534764),(11892,'Alces_humerus.tif',242,2,118,905.8156705,108.3483502,79.6442019,1.8,107.8883127,79.1820692,1.0512975,34.1964788,28.1083581,123391.2096991,176448.5197343,113.761724,6277.4395745,3608.301615,8611.7164875,2.8979513,22.1930039,1.5073894,61.9334549),(11893,'Alces_humerus.tif',242,2,119,905.9055209,108.3372925,79.2938673,1.8,107.8438102,78.8337873,0.9900789,34.8995948,28.6470024,125211.7929545,182296.062496,105.5397802,6363.5301233,3587.7721157,8670.914987,2.8653324,22.1930039,1.5073894,64.2987366),(11894,'Alces_humerus.tif',242,2,120,907.1595692,108.431596,79.0430436,1.8,107.8688856,78.4381152,0.9336408,35.8206028,29.4953052,127304.5763156,187128.1390095,97.6829949,6344.3364218,3553.9484603,8538.0760152,2.6165386,20.0513657,1.6058697,62.5159419),(11895,'Alces_humerus.tif',242,2,121,908.984518,108.6386409,78.7465281,1.8,107.9696891,77.9850972,0.8701288,22.8535012,30.3890006,128481.0457595,195098.8527789,88.5238293,6420.0483289,5621.9414548,10645.9098013,44.2493536,56.8281242,2.237808,292.9543315),(11896,'Alces_humerus.tif',242,2,122,909.1718219,108.7750772,78.5322825,1.8,108.1205496,77.5298795,0.8357614,23.1219586,31.081302,129360.6299526,201776.1872362,83.3828951,6491.8833687,5594.7089977,10652.9254137,44.4979455,57.8754772,2.2313067,279.062458),(11897,'Alces_humerus.tif',242,2,123,908.5594607,108.9111034,78.3570645,1.8,108.1953914,77.3912692,0.7982407,22.8155091,31.9883181,130204.1396351,209727.5279375,77.6577766,6556.3787057,5706.8259729,10626.6426574,44.9134104,59.1052994,2.2761968,269.5806331),(11898,'Alces_humerus.tif',242,2,124,898.1620543,109.1117061,78.1200763,1.8,108.1476181,77.1310842,0.760711,38.2326365,32.7291826,130433.7135887,216712.4133795,71.1528289,6621.3817747,3411.5804029,9028.8205149,45.58354,60.1828554,2.261047,287.599885),(11899,'Alces_humerus.tif',242,2,125,909.1470278,109.0679354,77.8484917,1.8,107.7703403,76.6270736,0.7148522,23.6507617,33.532339,130679.7023037,228347.7801427,65.1082454,6809.7778644,5525.39086,10706.0420499,45.9303406,61.4871787,2.3036114,281.874954),(11900,'Alces_humerus.tif',242,2,126,911.2663968,109.1627806,77.6699595,1.8,107.8443085,76.4421641,0.6730237,37.1846316,34.2170545,131604.5183445,238473.8030997,59.015012,6969.4427627,3539.2180185,9886.4061062,1.9832795,4.4050592,2.070143,11.9677437),(11901,'Alces_humerus.tif',242,2,127,915.8492182,109.2312217,77.5609696,1.8,107.9875147,76.3529653,0.6326093,37.18435,35.1982845,132958.1303309,251363.0808411,53.3601055,7141.344651,3575.6475576,10232.0104658,45.9396065,63.9118057,2.3289639,260.9518405),(11902,'Alces_humerus.tif',242,2,128,936.7845557,109.1904862,77.5597663,1.8,108.0135187,76.543765,0.5991255,36.7516255,36.1927229,135509.2952679,267568.6098112,49.6505721,7392.884219,3687.1646756,10869.3429553,45.8872778,65.4028166,2.3295848,272.7989472),(11903,'Alces_humerus.tif',242,2,129,947.4470565,109.2822063,77.4592097,1.8,107.8444103,76.3638338,0.5639895,34.578708,37.0322525,139513.4729556,282730.5821754,45.12321,7634.7119922,4034.6641312,11383.9777683,1.620545,2.745787,2.2655346,7.5783932),(11904,'Alces_humerus.tif',242,2,130,964.6444812,109.1885879,77.51684,1.8,107.4941062,76.4586119,0.5347656,25.2044552,37.509205,143527.9144564,298035.5715032,41.7582156,7945.6648502,5694.545393,11736.9083127,0.703124,1.2675748,2.5535901,2.4859187),(11905,'Alces_humerus.tif',242,2,131,974.5500885,109.1161599,77.6198414,1.8,107.4612567,76.7321845,0.5097365,25.6945793,38.3323166,148509.9066368,315864.6391726,38.6721819,8240.1656588,5779.8146871,12065.4790486,0.351562,0.7861165,2.0344439,1.6974915),(11906,'Alces_humerus.tif',242,2,132,985.9756625,108.9475249,77.6922464,1.8,107.3296266,77.1316631,0.4825864,30.5040416,38.879662,151533.9010823,336776.56262,35.3903761,8662.0239217,4967.6663478,12498.795612,0.351562,1.1117367,1.8925469,2.4006155),(11907,'Alces_humerus.tif',242,2,133,994.7880084,108.8508257,77.6621941,1.8,107.4621253,77.4034914,0.4503036,32.2038982,39.2684293,153079.7708727,356889.6716671,31.4075979,9088.4631329,4753.4546954,12890.8240613,0.7457756,1.75781,2.4980915,3.4802862),(11908,'Alces_humerus.tif',242,2,134,1001.2692245,108.550065,77.6201158,1.8,107.257898,77.5219567,0.4245279,37.5368189,39.5117464,156140.6530786,380759.5551877,28.3115336,9636.6167055,4159.6666312,13333.0330341,1.2584997,2.2510952,2.2455373,5.383718),(11909,'Alces_humerus.tif',242,2,135,1010.346028,108.2268768,77.6083282,1.8,107.1294723,77.5295217,0.3965755,27.8004097,39.5716866,158672.3837167,406734.1882854,25.1236423,10278.4142805,5707.555584,14132.93027,51.0344692,74.5924763,2.3761918,377.0076565),(11910,'Alces_humerus.tif',242,2,136,1022.0534754,108.002809,77.7933796,1.8,107.0887758,77.6286981,0.3745269,35.4748381,39.8270455,163834.3978111,434736.6787774,22.7974515,10915.6145913,4618.3268588,14842.3811603,51.3201234,75.8307091,2.3398025,310.6909134),(11911,'Alces_humerus.tif',242,2,137,1052.0474517,107.8231627,78.21524,1.8,107.0309652,78.2120868,0.3645586,36.2424513,40.7159956,176400.032417,475090.5749845,22.2891272,11668.401272,4867.2213361,15914.0132517,0.351562,0.4971837,2.3561945,0.9943675),(11912,'Alces_humerus.tif',242,2,138,1121.1650169,107.9775524,79.1911056,1.8,107.8794408,79.132972,0.3763352,36.6803451,41.7122763,197920.1763837,525662.1106037,25.2387286,12602.0960211,5395.8100934,17230.8676148,55.4448154,79.3105483,2.3405218,413.6846792),(11913,'Alces_humerus.tif',242,2,139,1178.9260345,108.1456416,80.9101884,1.8,107.9881915,80.6302363,0.4281524,35.7012424,44.0386792,235838.4861379,590179.8497061,33.871201,13401.3975854,6605.890165,18737.6374171,58.3708952,80.6419166,2.3068519,429.7212584),(11914,'Alces_humerus.tif',242,2,140,1246.5949066,108.2234753,82.8810111,1.8,107.9650301,82.4062832,0.4894075,35.31326,45.8586212,282982.1351142,658383.9008516,45.9155965,14356.8184957,8013.4809246,20523.0011128,61.1123721,82.5991159,2.2688043,454.4805069),(11915,'Alces_humerus.tif',242,2,141,1277.4371623,107.9891275,84.5936612,1.8,107.8512575,84.3238401,0.5264448,37.3951176,47.3627885,333411.8764796,711271.9594694,53.7521555,15017.5271045,8915.9199953,22004.3119481,64.0941632,84.1291612,2.2644645,432.4338155),(11916,'Alces_humerus.tif',242,2,142,1306.1742437,107.2481017,86.1217536,1.8,107.5601802,86.0386727,0.5226384,39.3462935,47.7075447,387875.0021969,758393.8614598,54.2429618,15896.7280078,9857.9807124,23856.4774427,67.520397,85.8740111,2.2372254,547.6073275),(11917,'Alces_humerus.tif',242,2,143,1366.3773279,106.5984499,87.9354892,1.8,107.0221809,87.7891982,0.5170794,41.4748575,48.9310371,446900.4304097,810062.1050983,55.6515242,16555.1795461,10775.2131525,25660.2309688,0.351562,0.4971837,2.3561945,0.9943675),(11918,'Alces_humerus.tif',242,2,144,1511.2655474,104.5414014,90.456271,1.8,104.5038335,90.5729948,0.4065872,51.1620476,48.2668568,553528.5837418,874297.9586011,39.394185,18113.8366172,10819.1249121,22923.7227589,0.9760982,2.5351496,2.5535901,5.6749615),(11919,'Alces_humerus.tif',242,2,145,1669.1793452,102.2080187,92.4972297,1.8,102.7699967,92.2178021,0.2676272,47.0626043,48.0504085,641135.0671679,987159.2503383,19.4544333,20544.242631,13623.0256835,33777.1827415,0.351562,0.7861165,2.677945,1.4915512),(11920,'Alces_humerus.tif',242,2,146,1767.6207725,100.908085,93.7173375,1.8,102.2742321,93.1711994,0.1929223,47.8583274,46.9689661,680495.6011925,1062638.7165958,10.8294908,22624.2730891,14218.9591322,34671.7963498,81.0818236,90.7581663,2.249167,511.6627003),(11921,'Alces_humerus.tif',242,2,147,1794.9101347,101.2440914,94.5742237,1.8,102.0622308,93.648916,0.1557961,48.1001471,46.8300742,705360.6500259,1078927.5422471,7.2025821,23039.2020501,14664.4177329,35088.039415,1.054686,1.4915512,2.3561945,3.4802862),(11922,'Alces_humerus.tif',242,2,148,1852.1979675,101.2830643,95.344198,1.8,101.3624255,94.1065116,0.097588,48.1024156,46.37456,733894.0803755,1101273.706892,2.9305541,23747.3672146,15256.9069848,36094.0233338,82.5248701,93.6561432,0.6442519,500.7599916),(11923,'Alces_humerus.tif',242,2,149,1921.6885299,101.376402,95.7602358,1.8,101.1501576,94.3666142,0.0585786,47.9372994,46.0069706,754106.6413035,1113751.2540216,1.0977732,24208.3153775,15731.1039733,36410.6200739,82.7455074,95.3148058,0.6730128,589.0734566),(11924,'Alces_humerus.tif',242,2,150,1937.9249409,101.4471875,95.8688949,1.8,101.3157532,94.4207576,0.0160153,47.302247,46.1573999,765291.6084528,1100584.6103378,0.0828368,23844.1639457,16178.7580145,36331.4155123,82.5292581,95.7030287,0.6839203,541.4997875),(11925,'Alces_humerus.tif',242,2,151,1934.642535,101.469213,95.6653909,1.8,101.6499992,94.4530901,-0.0266575,46.1830478,45.8909277,773598.5501337,1071082.184308,0.2290808,23339.7370355,16750.703712,36254.6284902,82.2210449,95.7546729,0.6787547,673.136395),(11926,'Alces_humerus.tif',242,2,152,1898.9580565,101.9432179,95.7262245,1.8,102.0591941,94.5737173,-0.0207239,45.8836018,49.2982436,752935.8099092,1041766.7452971,0.135909,21131.9241635,16409.692786,35705.4571943,81.8781821,95.5421077,0.7437556,682.9034012),(11927,'Alces_humerus.tif',242,2,153,1870.165694,102.4452929,96.1680087,1.8,102.5168885,94.9906377,-0.0148586,44.9222218,46.6695382,685256.8713227,1025576.2365946,0.0688099,21975.2814461,15254.2960516,34318.4029772,0.351562,0.4971837,2.3561945,0.9943675),(11928,'Alces_humerus.tif',242,2,154,1812.6601078,102.9517538,96.6054168,1.8,102.9338188,95.5768802,-0.051533,43.1469858,46.8247446,603484.9861823,984137.0786542,0.8015884,21017.4574964,13986.724099,32173.8938454,76.6851345,94.2717289,0.6770706,568.7388924),(11929,'Alces_humerus.tif',242,2,155,1772.490486,103.1346633,97.1379207,1.8,103.3007492,96.1950816,-0.0935364,40.8511242,46.1891228,514611.8075991,965977.8120198,2.5770723,20913.5344846,12597.2496054,27980.3768256,73.093786,93.6746168,0.6870498,501.8189643),(11930,'Alces_humerus.tif',242,2,156,1722.6582913,103.1510895,97.5533403,1.8,103.5195237,96.7171383,-0.1196758,38.8557791,45.9355495,426877.8956413,931688.7575431,4.0924735,20282.5212307,10986.2137774,25661.9863041,69.734201,92.9254914,0.5806575,528.8788892),(11931,'Alces_humerus.tif',242,2,157,1621.2119121,103.3333964,97.8793762,1.8,103.4862207,97.0560476,-0.1440907,39.0656657,46.2035693,331113.7771516,861843.6761784,5.5712471,18653.1839097,8475.8257874,22683.2113424,65.3579561,91.0878078,0.6705216,468.466257),(11932,'Alces_humerus.tif',242,2,158,1456.1108664,104.0084748,98.1553119,1.8,103.7957608,97.4572765,-0.1571219,34.8864702,46.16256,231660.9678668,757952.4757403,5.9420963,16419.2037072,6640.4244039,20999.5162177,2.5304884,12.8932697,1.3787483,30.1783002),(11933,'Alces_humerus.tif',242,2,159,1154.728366,105.7647864,97.9267486,1.8,104.7470116,97.8402746,-0.1505395,31.9880651,47.0748349,136121.7489192,606637.8771218,4.3285877,12886.6703174,4255.391767,15538.0152882,1.512246,8.5538726,1.4056476,19.787411),(11934,'Alces_humerus.tif',242,2,160,672.2560127,109.0732562,96.8114137,1.8,107.8083643,96.858645,-0.1353119,28.4734856,49.6765099,58835.8792353,379645.6670286,2.0389359,7642.3578881,2066.3391902,8763.8111086,0.351562,2.8343835,1.6951513,5.9162355),(11935,'Alces_humerus.tif',242,2,161,90.4546641,110.2057433,95.8757737,1.8,111.3606327,95.6647953,-0.1516767,19.3520244,48.2071206,4634.1384414,48810.9773966,0.3441792,1012.526298,239.4653055,1103.1436795,6.676538,17.1690442,1.3854484,41.6841939),(11936,'Alces_humerus.tif',242,2,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11937,'Alces_humerus.tif',242,2,163,0.0151311,89.3245945,121.2192738,1.8,89.472529,121.113109,-0.622462,0.0001811,18.5728457,0.0001558,5.1173042,0.0008573,0.2755261,0.8606314,0.2755345,0,0,0,0),(11938,'Alces_humerus.tif',242,2,164,11.7778596,125.0444853,113.3530264,1.8,124.6141948,113.1086291,-0.3619477,12.7507703,18.4842937,33.8652886,221.6948607,0.2461264,11.9936885,2.6559406,11.4328319,5.5099523,19.0298663,0.4388593,43.8435354),(11939,'Alces_humerus.tif',242,2,165,160.7451163,123.5036007,109.4297756,1.8,122.7809523,108.1583063,-0.4223875,12.3393884,20.6449103,2446.9799392,7046.1065769,4.5022085,341.299936,198.3064206,406.4402036,21.6636132,29.7168685,2.9511575,160.0967182),(11940,'Alces_humerus.tif',242,2,166,372.2261002,121.5855167,105.2291894,1.8,120.7278081,104.2891264,-0.4367796,16.8913813,18.5075663,13927.5520629,20402.3860483,11.1015806,1102.3808171,824.5360069,1846.390826,28.4450835,29.5144622,1.3547114,96.9129861),(11941,'Alces_humerus.tif',242,2,167,471.9728493,120.7964847,103.4234646,1.8,120.614558,104.0462165,1.2818875,21.7052915,26.2367474,24521.9201336,25588.381993,72.2770044,975.2878882,1129.7669137,1779.7080164,29.179646,30.2363759,1.9772148,97.6161101),(11942,'Alces_humerus.tif',242,2,168,474.9838687,121.0114491,103.9001675,1.8,120.8538051,104.5954985,1.2443758,24.3910348,18.1532894,24617.0917181,26051.8650039,71.0243851,1435.1043746,1009.268034,1993.8770329,29.179646,30.4238269,1.9620319,97.6161101),(11943,'Alces_humerus.tif',242,2,169,477.1602791,121.3781548,104.373532,1.8,121.0545543,105.2425708,1.2585273,26.669828,18.230018,24896.7379809,26246.3313469,72.0207154,1439.7315101,933.517005,1917.6310477,29.179646,30.291509,1.9513027,97.3248666),(11944,'Alces_humerus.tif',242,2,170,475.0434569,121.6291643,104.8825434,1.8,121.4462873,105.6405744,1.2286571,26.2270433,18.1993494,24641.419843,26055.0641213,70.2619094,1431.6481098,939.5424241,1912.3102215,0.351562,0.4971837,2.3561945,0.9943675),(11945,'Alces_humerus.tif',242,2,171,473.4933778,121.8822218,105.4387413,1.8,121.7302075,106.2289373,1.2369988,24.8714357,18.1426574,24480.6119591,26084.2459532,70.4444849,1437.7301735,984.2862403,2005.613224,0.80953,4.6904221,1.7975952,10.0143425),(11946,'Alces_humerus.tif',242,2,172,481.0932111,121.4701297,105.8262891,1.8,118.2185112,105.7757068,0.3042742,24.1511371,45.5771922,25593.2986272,38477.4699179,7.1972056,844.2264228,1059.7140202,1404.2083403,0.703124,2.8343835,1.6951513,6.207479),(11947,'Alces_humerus.tif',242,2,173,526.6661059,118.2927569,105.4752821,1.8,111.7669569,104.414344,0.2649409,18.8828782,46.7235607,26569.2788817,109384.1516623,6.0186161,2341.0919483,1407.0566265,2909.6863077,29.179646,30.3770726,1.9878456,97.3248666),(11948,'Alces_humerus.tif',242,2,174,571.0614693,115.6169062,105.2095175,1.8,108.0073006,103.697329,0.2677219,17.9156488,46.2919863,28404.413868,171979.7811003,6.6603735,3715.1091312,1585.4527102,4328.6767371,22.85153,23.5021235,0.3832841,75.3427804),(11949,'Alces_humerus.tif',242,2,175,594.7238554,114.5279948,105.4322496,1.8,106.4350297,103.6073306,0.2583998,20.2172083,56.392322,29888.6743588,202099.8338322,6.4723334,3583.8182699,1478.3779168,4043.3002167,25.664026,26.4303554,0.4993467,85.8189729),(11950,'Alces_humerus.tif',242,2,176,608.1471502,113.9958804,105.7944654,1.8,105.8673159,103.9634027,0.253031,23.9907483,52.6264414,31007.6950409,220350.5691844,6.3520897,4187.0695293,1292.4855323,4500.1008815,27.421836,28.0391358,0.5253669,90.8261441),(11951,'Alces_radius.tif',242,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11952,'Alces_radius.tif',242,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11953,'Alces_radius.tif',242,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11954,'Alces_radius.tif',242,3,4,15.6580573,89.8542005,59.1463489,1.8,89.9522158,59.6663214,1.4742874,3.6411781,6.2969158,34.9914595,94.0703905,2.5854451,14.9391215,9.609928,20.4807772,7.6435788,24.81191,1.6986662,57.0322849),(11955,'Alces_radius.tif',242,3,5,27.0817586,89.9499008,60.1705048,1.8,90.0805334,60.5229456,1.4303165,4.8740671,7.8091927,121.4165401,276.2298662,4.4251364,35.372397,24.910724,50.8643406,11.9439871,52.1983744,1.7536619,124.9173091),(11956,'Alces_radius.tif',242,3,6,35.3793466,90.444758,60.9508679,1.8,90.4543914,61.283953,1.4458258,5.0280195,8.4495345,196.287491,468.7504009,5.8049459,55.4764764,39.0387294,78.4986511,14.6248559,56.0054928,1.7411049,144.2075363),(11957,'Alces_radius.tif',242,3,7,42.753786,90.9483906,61.7575943,1.8,90.8963009,62.0024571,1.4425757,5.4775651,9.7689533,259.9114477,729.8049208,7.0091224,74.7065622,47.4501799,101.109055,16.7057891,59.9967102,1.7475052,163.2418538),(11958,'Alces_radius.tif',242,3,8,54.8011969,91.312962,62.6007592,1.8,91.2528513,62.8167281,1.4154969,6.1108364,58.1838869,363.2582232,1212.1207464,8.9150162,20.8325846,59.4449272,27.0690607,18.1327911,63.5812294,1.7486716,156.8991021),(11959,'Alces_radius.tif',242,3,9,64.0900984,91.6836463,63.5662601,1.8,91.6226275,63.5975132,1.3691527,6.3138326,50.2728922,488.5584549,1900.2156756,10.253219,37.7980178,77.3790632,47.515924,21.9042473,67.6398344,1.7590178,168.0930543),(11960,'Alces_radius.tif',242,3,10,73.7054802,91.724636,64.3080516,1.8,91.7027005,64.0670984,1.3346476,7.7280913,13.3395446,619.9472695,2543.0872872,11.6118405,190.6427368,80.2199725,237.0636993,0.351562,0.7861165,2.0344439,1.6974915),(11961,'Alces_radius.tif',242,3,11,88.4542841,91.6504156,64.9659809,1.8,91.7146257,64.6199404,1.3083087,8.6590796,14.1860073,850.5866799,3567.5756889,13.7497495,251.4855382,98.2306113,310.6244215,0.703124,1.1117367,1.8925469,2.691859),(11962,'Alces_radius.tif',242,3,12,101.0045428,91.4781702,65.5224594,1.8,91.6445794,65.3459865,1.2751918,9.5634355,15.0754854,1077.696635,4604.6344995,15.4054439,305.4385566,112.6892771,376.7352735,1.4997811,12.2795328,1.9832068,27.5717445),(11963,'Alces_radius.tif',242,3,13,113.0832646,91.3985091,66.0389146,1.8,91.5875039,65.8716326,1.2805652,10.4207568,15.4755693,1300.7106853,5696.0240758,17.3037109,368.0655598,124.8192157,450.632081,26.682607,76.048801,1.7709117,241.5324029),(11964,'Alces_radius.tif',242,3,14,120.5344833,91.211432,66.1712136,1.8,91.3377607,65.9099763,1.2780861,10.3208407,15.6411114,1465.1028997,6406.2977005,18.4164626,409.5807218,141.9557712,502.2307915,27.1764769,76.2913841,1.7374602,247.8751546),(11965,'Alces_radius.tif',242,3,15,127.5383973,90.9355875,65.936114,1.8,91.0712714,65.6197231,1.2615092,10.3081167,15.5353667,1649.3452355,6687.7958257,19.2870581,430.4884437,160.0045174,529.4252773,27.5110925,75.7760881,1.7245039,223.9750009),(11966,'Alces_radius.tif',242,3,16,136.0696563,90.7426257,66.2503724,1.8,91.0010474,66.3180956,1.2573556,50.3705662,62.3728071,1851.4600144,7909.2011922,20.5222622,126.8052788,36.7567838,154.9368129,26.9846091,76.1778962,1.7283579,230.9355734),(11967,'Alces_radius.tif',242,3,17,147.0274013,90.7024668,66.8290191,1.8,90.9494695,67.1434371,1.2565278,46.6073841,66.6052919,2179.7654353,9746.0192141,22.1630154,146.3249981,46.7686715,177.2934903,26.2005123,77.014549,1.7081744,215.8141207),(11968,'Alces_radius.tif',242,3,18,159.748447,90.4689972,67.3436765,1.8,90.6373962,67.5762343,1.2642693,49.4109217,62.1773467,2555.8726297,11224.2390566,24.2004869,180.5197497,51.7268762,216.9237388,26.08203,78.0127089,1.7018589,221.8656289),(11969,'Alces_radius.tif',242,3,19,174.4211084,90.2167368,68.0241719,1.8,90.3515333,68.1783918,1.287654,48.2007716,62.0588096,3086.3197652,13269.4824699,26.8012573,213.8210927,64.0305053,253.554479,25.3498042,78.8142101,1.6735719,231.0562104),(11970,'Alces_radius.tif',242,3,20,189.5933217,89.9489683,68.6640432,1.8,90.0996111,68.7857867,1.3080524,24.822555,61.3469344,3582.5937775,15249.2140397,29.467215,248.5733669,144.3281635,289.8220129,24.662592,78.9708737,1.6912861,219.2091037),(11971,'Alces_radius.tif',242,3,21,205.6812304,89.7077878,69.3444705,1.8,89.8057654,69.3996203,1.3310835,24.4269116,60.4842042,4176.9909129,17475.3776106,32.3478306,288.9246512,170.9995512,332.2880313,24.6183839,80.1044644,1.6984175,229.7912975),(11972,'Alces_radius.tif',242,3,22,222.6421376,89.4503342,70.1375216,1.8,89.5158258,70.1829486,1.3605399,48.2562814,60.4162562,4874.0100057,20847.5956836,35.490635,345.065997,101.0026024,373.733166,24.5623748,80.8470308,1.7016237,237.113781),(11973,'Alces_radius.tif',242,3,23,242.4713673,89.1529081,70.9230184,1.8,89.2504838,70.6994617,1.3724483,49.4171037,57.782194,5517.1309909,23909.1870899,38.8427535,413.7812261,111.6441591,468.1241293,23.3796571,82.0835161,1.6350853,229.9619039),(11974,'Alces_radius.tif',242,3,24,262.1981248,88.8650822,71.8332813,1.8,88.9946278,71.4407383,1.3845597,39.7814552,52.3555563,6110.6288961,27585.9937167,42.2014458,526.8971557,153.6049616,592.1968236,22.916688,83.237083,1.6511315,230.9916052),(11975,'Alces_radius.tif',242,3,25,288.0223144,88.6647113,72.742996,1.8,88.622992,72.181112,1.3961898,42.7396091,56.4484236,7156.1879633,32659.5426971,46.5550213,578.5731582,167.4369071,638.9976657,22.8443233,84.28841,1.6501274,236.5105959),(11976,'Alces_radius.tif',242,3,26,314.8923497,88.3855412,74.0195737,1.8,88.2975782,73.2631113,1.408586,40.5649888,55.0914925,8074.4876869,38952.5075702,51.1132101,707.051231,199.0506571,791.810366,23.4044719,84.9471572,1.686938,231.8653357),(11977,'Alces_radius.tif',242,3,27,365.3846585,88.3637051,75.9585252,1.8,88.3040714,74.8022514,1.3968294,41.4251346,55.1696269,10068.8526534,50022.3738976,59.0729309,906.701326,243.0614346,973.6826139,25.1127256,85.7292425,1.694134,336.2007442),(11978,'Alces_radius.tif',242,3,28,423.870959,88.2609153,77.6456739,1.8,88.0611373,75.7884147,1.4062322,15.6621099,46.9856251,13119.9169178,59507.8761741,68.7492021,1266.5123878,837.6851547,1466.4202273,25.5709707,85.2565032,1.6823643,336.5626553),(11979,'Alces_radius.tif',242,3,29,441.2116051,87.6217447,77.4024295,1.8,87.4670951,75.5097201,1.4585389,14.336907,32.7558438,15427.0453111,54974.2832845,72.6124812,1678.3045966,1076.0371997,1985.3480006,26.7097778,83.1211829,1.6809865,278.3093645),(11980,'Alces_radius.tif',242,3,30,382.6953045,87.5528854,74.5625365,1.8,87.3721781,73.2997905,1.4133434,34.1146968,44.3870678,13911.8276143,35903.1469738,62.2143136,808.8650302,407.7957278,889.8334578,26.418687,76.4960459,1.6443959,265.8091033),(11981,'Alces_radius.tif',242,3,31,336.9675404,87.6807439,72.3349159,1.8,87.4799157,71.0294224,1.3057963,30.5584463,32.4544283,12123.2206456,24720.5916165,52.3087914,761.7016512,396.7224159,889.843202,25.5279438,69.2639597,1.6724852,315.9868171),(11982,'Alces_radius.tif',242,3,32,303.9572265,87.8592555,70.8341774,1.8,87.6880581,69.6213029,1.1789316,51.1033931,67.8398588,10572.3766848,19372.9253877,43.270482,285.5684805,206.8820884,424.7795434,24.8491271,64.4088066,1.6856729,269.5866954),(11983,'Alces_radius.tif',242,3,33,280.625478,88.159784,69.3833918,1.8,88.1986105,68.1364075,1.0158384,33.8595078,63.675313,9132.3380628,15941.7563906,33.785833,250.3600789,269.7126643,393.0790972,24.6199845,60.3100487,1.7052739,239.5790017),(11984,'Alces_radius.tif',242,3,34,257.9451545,88.5323532,68.1223994,1.8,88.491481,67.2636727,0.8646322,50.6773987,18.653896,7510.9772232,14183.7091682,24.8875308,760.3617582,148.2115779,427.5193765,1.9771061,17.926215,1.7681919,41.5988907),(11985,'Alces_radius.tif',242,3,35,214.7456743,89.2826292,66.2509459,1.8,89.3970851,65.8926952,0.7289864,37.1833658,25.6854455,4493.9920132,12965.1854301,15.8807245,504.767784,120.8602802,386.3307224,23.2508852,54.8819699,1.7707044,231.6386974),(11986,'Alces_radius.tif',242,3,36,200.6840633,89.4407809,65.3180319,1.8,89.8317471,65.1839195,0.653445,27.4257189,64.8831037,3737.1063876,12850.1094224,12.3612429,198.0501655,136.2628413,236.5784864,23.7665871,52.7448458,1.7721134,235.8367434),(11987,'Alces_radius.tif',242,3,37,200.6212167,89.6176348,64.8497227,1.8,90.0424407,64.7401423,0.5933632,44.3142076,54.0605191,3462.5037749,13408.4043936,10.4540874,248.0258165,78.135297,255.3645715,24.1216951,51.2521452,1.7991376,186.6387614),(11988,'Alces_radius.tif',242,3,38,204.8057224,89.5729059,64.5491497,1.8,89.9347679,64.537404,0.5470046,61.8334898,18.1298975,3575.3057835,14013.1603493,9.2345699,772.93103,57.8215106,274.4014557,24.3327541,49.8896084,1.8345762,187.9097367),(11989,'Alces_radius.tif',242,3,39,210.8575365,89.5085997,64.4470184,1.8,89.8297305,64.3188212,0.4926902,49.4903785,18.0253738,3479.2138518,14835.3390333,7.8624192,823.025319,70.3008132,366.2336054,24.448093,49.1634035,1.8608833,198.7125064),(11990,'Alces_radius.tif',242,3,40,221.8385774,89.5407906,64.5201818,1.8,89.823072,64.4462059,0.4574789,50.126726,18.3758533,3726.2350184,16755.7482003,7.2130078,911.8351113,74.3362936,407.0238606,25.2560622,48.8405539,1.9700171,189.8278041),(11991,'Alces_radius.tif',242,3,41,241.6827135,89.9549756,64.8094058,1.8,90.186078,64.8453627,0.433146,51.6762813,45.1464247,4301.8541253,20235.1861308,7.0962826,448.2123725,83.2462016,382.9188188,27.2361615,49.2412752,2.0695732,174.2591372),(11992,'Alces_radius.tif',242,3,42,264.3603403,90.2031934,65.4055833,1.8,90.2375918,65.4367754,0.4101135,12.1841531,19.957393,5086.4881921,24168.92214,7.0043312,1211.0260162,417.467522,1462.7611604,29.2574394,50.0269144,2.0690213,188.4215561),(11993,'Alces_radius.tif',242,3,43,351.0050316,89.8297114,71.2005419,1.8,88.6410191,75.0181,0.9948848,43.2683816,57.4836108,42147.4624143,68956.3330808,41.150157,1199.5824925,974.0938029,1853.4116867,35.5324826,50.7663319,2.1088405,301.1030871),(11994,'Alces_radius.tif',242,3,44,15.5162217,85.1027095,78.9679228,1.8,82.6853116,79.3104105,-0.1046688,34.6420629,45.8254419,101.8373942,1055.3580981,0.0282281,23.0299601,2.9397035,20.1440547,0.4971837,0.9943675,2.3561945,1.988735),(11995,'Alces_radius.tif',242,3,45,69.2017976,85.8357324,80.1993536,1.8,83.6812989,80.3439411,-0.0396901,22.1293871,32.2290413,498.4699559,7105.220197,0.0181595,220.4601788,22.525249,234.1705092,6.7346878,13.6928773,2.6320004,43.3463517),(11996,'Alces_radius.tif',242,3,46,258.3596125,86.8247633,86.4518702,1.8,86.6171441,88.5855787,-0.1200707,34.9293112,33.3277819,33494.3045198,48221.4199049,0.6178167,1446.8835647,958.9168347,1824.8327177,27.8122139,59.6475469,0.0885254,363.3984531),(11997,'Alces_radius.tif',242,3,47,569.948957,85.183173,90.5536395,1.8,84.5424501,92.8655256,-0.2422038,34.7435282,37.9833069,82092.3164185,153516.7572816,5.4643379,4041.6901448,2362.8088641,5235.0903688,48.2466744,69.6172656,0.0151504,620.2082794),(11998,'Alces_radius.tif',242,3,48,1010.6292498,84.6750434,93.852845,1.8,86.2119854,95.0253998,-0.0864874,35.8916542,41.2415656,138975.6728402,323979.5653733,1.2567914,7855.6563259,3872.0888115,9836.8807249,50.2153275,75.7915816,2.6115149,593.3982019),(11999,'Alces_radius.tif',242,3,49,1325.0062797,88.1443387,95.563967,1.8,89.9227485,96.020981,0.0552079,37.6540772,45.4766485,179010.4789482,514098.9068125,0.6724008,11304.6788698,4754.0795661,14737.8804735,3.9819756,7.1099014,1.4219064,23.5942745),(12000,'Alces_radius.tif',242,3,50,1466.6105952,91.4981579,96.2341549,1.8,91.1129867,95.8661988,0.1246343,39.5807785,44.6049712,190481.6583854,649575.401385,3.7773627,14562.8476723,4812.4788222,17188.1143626,50.9051356,84.0850761,2.7603099,432.0719044),(12001,'Alces_radius.tif',242,3,51,1391.6829019,91.0052451,96.0118255,1.8,90.0951912,94.9217124,0.1326835,38.678996,44.9809037,191385.5923469,652775.6008532,4.0594991,14512.2829121,4948.049647,17444.644103,53.7316042,84.5987039,2.5155461,490.7163776),(12002,'Alces_radius.tif',242,3,52,1648.0453929,90.5916582,95.2515768,1.8,90.6816722,94.9424552,0.1309723,41.9045,44.2193783,235254.4197071,747999.2160734,4.6848133,16915.6429762,5614.0610083,18089.9604157,63.9368362,91.213911,2.4271136,716.7058338),(12003,'Alces_radius.tif',242,3,53,1359.8712803,90.744218,95.4173396,1.8,89.8218619,94.8540192,0.1735416,33.8546576,42.5657021,193469.9682505,649806.2167266,6.7575516,15265.9579014,5714.7223368,19781.775075,55.195234,81.9863388,2.9299003,460.9438956),(12004,'Alces_radius.tif',242,3,54,1218.6213104,88.6052719,94.6182393,1.8,88.6648127,94.2239325,0.1660413,34.3424108,40.7665221,177728.1168038,582650.0191082,5.5482351,14292.3651426,5175.1788149,17889.6974157,50.115209,79.1522149,2.9494235,338.8365714),(12005,'Alces_radius.tif',242,3,55,1135.6308987,89.63566,94.8584901,1.8,89.1281835,94.1959618,0.171545,29.793488,41.1795794,165935.493427,519858.1680418,5.5154127,12624.1738048,5569.5222181,16647.4330151,48.867118,78.1425138,2.9697873,309.255394),(12006,'Alces_radius.tif',242,3,56,1071.5345456,90.9604999,95.1868399,1.8,89.8561904,94.3982502,0.166748,30.8779308,40.5786699,156439.2330018,469580.2759731,4.9197961,11572.0963047,5066.3768311,14729.4598712,48.4805253,75.8804046,3.0534495,307.6371434),(12007,'Alces_radius.tif',242,3,57,988.290313,92.0779851,95.6049646,1.8,90.7442553,94.4717056,0.1532163,32.8162503,39.8455312,141887.1527314,420095.5383605,3.8365613,10543.1029706,4323.6857213,14103.7985892,47.9105908,73.6511902,3.0219742,290.5976232),(12008,'Alces_radius.tif',242,3,58,900.3480901,92.3925147,96.4120125,1.8,91.1772345,95.227721,0.1645624,27.7138565,38.9008152,124637.5929787,376441.3152327,4.0271385,9676.9518458,4497.3023902,12878.5255116,46.054622,71.8469223,2.9893153,299.9588112),(12009,'Alces_radius.tif',242,3,59,830.2298106,92.5774676,97.1554024,1.8,90.9997004,95.8424207,0.1840569,27.254274,38.141287,111825.1333048,340898.4386327,4.6349136,8937.7801809,4103.03108,11547.1560929,45.6948265,69.6563126,2.9946992,278.097362),(12010,'Alces_radius.tif',242,3,60,794.4858563,93.0241449,97.7184952,1.8,91.5934972,96.4237376,0.1860155,27.726639,37.4373095,103290.3107989,313563.5155869,4.5291668,8375.6957901,3725.3094749,11134.6818988,46.1710205,68.2139002,2.9967802,359.1650733),(12011,'Alces_radius.tif',242,3,61,762.7991789,93.3130309,98.1720124,1.8,92.0886364,96.9963202,0.1836289,26.4110799,36.766867,96104.9181615,289617.8474859,4.2389115,7877.142417,3638.8106276,10365.2160083,45.3888023,66.9797118,2.8596881,366.7788003),(12012,'Alces_radius.tif',242,3,62,727.7012188,93.4653307,98.5918364,1.8,92.4166189,97.5925906,0.1799594,26.670304,36.2345053,89196.3511317,265631.8134507,3.8855935,7330.9076971,3344.4069912,9427.7109432,44.992813,65.1386612,2.9844296,343.2698291),(12013,'Alces_radius.tif',242,3,63,697.5763808,93.7132719,98.9250464,1.8,92.6709474,97.8690747,0.1789578,27.8560887,35.2150841,83842.8500236,245843.0877457,3.6838371,6981.1870069,3009.8572351,9293.9508191,42.8756725,63.7093979,2.9528549,319.0077644),(12014,'Alces_radius.tif',242,3,64,660.1215229,94.0382079,99.3189008,1.8,93.1368302,98.3916145,0.1760123,25.2064578,35.5131739,78653.6889358,226774.7973804,3.3734105,6385.6527772,3120.3785004,8130.4950378,42.187703,62.3465249,2.8733624,262.749271),(12015,'Alces_radius.tif',242,3,65,637.7255073,94.3986796,99.482209,1.8,93.6585376,98.5522779,0.1688715,25.7635373,34.1786377,74024.2272391,210481.3021953,3.0023616,6158.2706743,2873.2167646,7601.7801974,42.1393933,60.7561795,2.9964223,243.6150145),(12016,'Alces_radius.tif',242,3,66,630.7711065,94.4201195,99.6215984,1.8,93.5182706,98.8806157,0.1676467,25.1477559,32.7611764,71819.2796321,199001.142284,2.9271019,6074.2978176,2855.8921835,7819.7660729,41.0459256,59.7127824,2.9938672,257.8834348),(12017,'Alces_radius.tif',242,3,67,621.8439662,94.8063064,99.795164,1.8,94.28074,99.0667384,0.1566285,24.1689283,32.3199392,69855.2476227,187058.8960189,2.5218386,5787.7242601,2890.2914819,7862.4018255,39.9194937,58.669789,2.9912212,237.2015953),(12018,'Alces_radius.tif',242,3,68,608.662807,94.9170464,100.0321961,1.8,94.5735555,99.5081365,0.1463516,24.435079,31.3805594,67286.3574801,176958.5987308,2.1573356,5639.1154988,2753.678733,7541.942377,39.264943,57.7771584,2.7678658,228.2522878),(12019,'Alces_radius.tif',242,3,69,610.1264814,94.9925263,100.2574028,1.8,94.7199329,99.8166674,0.1352883,23.7051635,30.5417599,65828.4750415,170571.4210895,1.8498568,5584.8589452,2776.9677741,7180.302621,38.6821037,56.5851025,2.9856368,208.7414846),(12020,'Alces_radius.tif',242,3,70,610.3101897,95.1587143,100.5649459,1.8,94.9288791,100.2458421,0.1229291,27.5262945,31.2364381,63396.7025846,165031.2169083,1.5293958,5283.2917833,2303.1324684,5513.2251738,36.1388871,55.6590489,2.9702135,197.5268344),(12021,'Alces_radius.tif',242,3,71,600.2491513,95.1528973,100.8946065,1.8,94.8094038,100.6326742,0.1074994,21.9492967,30.1936859,61365.1718605,159167.471334,1.1516466,5271.5482276,2795.7693937,6490.1793251,33.749952,54.9663561,2.968032,177.7247877),(12022,'Alces_radius.tif',242,3,72,601.1392286,95.2591147,101.1589882,1.8,94.9763257,100.8841142,0.1002179,23.089614,29.1233098,59851.1531422,155546.4239726,1.0029045,5340.9597026,2592.1244542,6197.009809,33.39839,54.5601118,2.973266,175.480143),(12023,'Alces_radius.tif',242,3,73,593.8623924,95.3440571,101.3486479,1.8,95.0980266,100.9941829,0.092568,22.7593566,28.0339561,57323.5539203,150704.8260166,0.8456985,5375.795882,2518.6807776,6509.8897028,33.6011521,54.0994407,2.9849908,194.7850059),(12024,'Alces_radius.tif',242,3,74,591.5304386,95.3392268,101.6346514,1.8,95.216609,101.5724405,0.0810898,25.146973,28.650687,55330.4283971,146667.6847133,0.6468537,5119.1681665,2200.2818512,6684.1605794,32.2204224,53.596777,3.0034062,182.8172622),(12025,'Alces_radius.tif',242,3,75,590.2250792,95.2514365,102.003202,1.8,94.9286662,101.7749355,0.0685053,27.2060663,37.0568769,53126.8897166,143760.191955,0.4609306,3879.4470577,1952.7589586,4706.7176801,0.9438747,1.2675748,0.5880026,3.4802862),(12026,'Alces_radius.tif',242,3,76,584.3548012,95.2366233,102.4417665,1.8,94.9960855,102.3229295,0.059275,26.6606989,37.2664482,50774.5261575,140162.3242572,0.3417895,3761.0862093,1904.4709343,4330.1739108,0.351562,0.4971837,2.3561945,0.9943675),(12027,'Alces_radius.tif',242,3,77,583.159592,95.1723188,102.7457988,1.8,95.1113561,102.5912877,0.0555312,23.6187243,27.1083106,49467.2756432,136122.4899547,0.2994078,5021.4302105,2094.4092947,6586.4726778,2.1449676,14.7865155,2.066348,39.5041544),(12028,'Alces_radius.tif',242,3,78,580.9661403,95.1249936,103.065115,1.8,94.9772092,102.9414499,0.0491463,21.8727338,26.7311249,48175.5850726,131804.3468511,0.2336852,4930.7444893,2202.5406371,6252.575023,32.695266,51.4411016,2.9281127,190.5516262),(12029,'Alces_radius.tif',242,3,79,589.3244026,95.1126417,103.3953448,1.8,95.0637289,103.2631697,0.0436825,24.8498106,26.3979988,47617.4244701,129252.5183288,0.1873019,4896.299879,1916.2087472,5724.7808105,1.7158368,11.4945184,1.9797042,28.0689282),(12030,'Alces_radius.tif',242,3,80,590.4648177,95.148008,103.7870664,1.8,95.1559188,103.7858134,0.0393243,24.4619514,26.0391335,46586.9267281,126278.1121411,0.1521044,4849.551247,1904.4648564,5563.6871293,0.351562,0.4971837,2.3561945,0.9943675),(12031,'Alces_radius.tif',242,3,81,590.3526077,95.2898975,104.0638976,1.8,95.341928,104.1276149,0.0318879,24.128429,25.8021194,45473.7641324,122734.7765543,0.1000145,4756.7711305,1884.6549943,5822.889463,1.7950409,11.1728151,1.9922155,26.5420432),(12032,'Alces_radius.tif',242,3,82,587.7722261,95.2753799,104.3061345,1.8,95.3309844,104.3701719,0.0219146,23.8493907,25.4370652,44526.3435407,119546.8623635,0.0470386,4699.7112869,1866.9803398,5926.3658948,1.2245504,10.4526897,1.9138203,23.182394),(12033,'Alces_radius.tif',242,3,83,589.3969496,95.3136051,104.5571983,1.8,95.3645958,104.5695133,0.0097463,24.2336644,25.617683,43839.6242363,117285.7140852,0.0093312,4578.3107658,1809.038185,5509.5606606,2.3900499,14.2371759,1.9237867,35.1501377),(12034,'Alces_radius.tif',242,3,84,588.2527143,95.3438682,104.8901362,1.8,95.4175121,104.9792268,0.0013178,23.7987691,25.0334638,43001.0712601,115247.9189484,0.0001699,4603.7543959,1806.8611446,5543.2128652,2.0549525,14.1544642,1.821799,36.2651422),(12035,'Alces_radius.tif',242,3,85,588.2364971,95.3944415,105.1499377,1.8,95.4946821,105.0638784,-0.0102252,22.8161988,24.7252555,42188.7388653,113628.5635352,0.0102508,4595.6477032,1849.0695705,5382.1065714,0.351562,1.1117367,1.8925469,2.4006155),(12036,'Alces_radius.tif',242,3,86,583.0913895,95.4653816,105.5089854,1.8,95.4585387,105.3399062,-0.0258839,23.6140141,24.6373876,41057.0894551,111941.6022832,0.0650951,4543.5662363,1738.6747258,5179.1077953,1.755401,7.1099014,1.4219064,20.6611415),(12037,'Alces_radius.tif',242,3,87,585.6881381,95.4556419,105.7347236,1.8,95.403543,105.4644622,-0.0359637,20.3037964,24.4713367,40508.2906854,111282.3115371,0.126199,4547.4553769,1995.1091826,5433.5319527,1.3702562,7.4162085,1.665748,17.3014922),(12038,'Alces_radius.tif',242,3,88,584.9122559,95.4918497,106.0120865,1.8,95.4303978,105.7224781,-0.0442876,20.4678129,24.4687619,39999.6956427,110519.2277245,0.1910826,4516.7478514,1954.2730715,5160.7598397,1.054686,6.0689011,1.3961241,14.6096332),(12039,'Alces_radius.tif',242,3,89,580.8383497,95.6629102,106.3076007,1.8,95.5956458,106.2053646,-0.0567351,19.7699843,38.3721978,39256.8920546,109335.9238191,0.3112732,2849.3526561,1985.6814997,3514.3986791,1.5429238,9.8688156,1.4994889,26.0801932),(12040,'Alces_radius.tif',242,3,90,576.0073629,95.7353046,106.5564978,1.8,95.820563,106.3750819,-0.0638116,22.3411449,24.8826945,38658.5393365,108142.1901052,0.39038,4346.080374,1730.3741376,4389.8922341,0.351562,0.4971837,2.3561945,0.9943675),(12041,'Alces_radius.tif',242,3,91,574.099942,95.8552726,106.814257,1.8,95.926891,106.5010001,-0.0704242,19.552272,25.011261,38317.3643087,107998.7732722,0.4737639,4318.0059238,1959.7397374,5472.5551416,4.4787093,16.0491037,1.0679531,46.4500912),(12042,'Alces_radius.tif',242,3,92,574.7704307,95.9045909,107.0324892,1.8,95.8841054,106.5773167,-0.0739689,19.1368677,24.9630878,38158.7704631,108521.2919359,0.5231774,4347.2703682,1993.9924867,5546.6414287,5.2582835,19.3901662,1.1801893,56.5497369),(12043,'Alces_radius.tif',242,3,93,574.3841001,95.9679092,107.3095783,1.8,95.8876916,106.809117,-0.0746017,22.049626,27.2690321,38055.0484535,108881.9706515,0.5317941,3992.8799108,1725.8818123,4190.0232374,0.351562,0.4971837,2.3561945,0.9943675),(12044,'Alces_radius.tif',242,3,94,574.8261612,96.1304447,107.6226379,1.8,96.167651,107.3311584,-0.0766564,19.7915607,24.7907711,37723.0990851,109326.9393626,0.5618638,4409.9854324,1906.0194255,5444.345145,1.406248,7.8059432,1.706324,21.6908427),(12045,'Alces_radius.tif',242,3,95,579.6339644,96.253482,107.8844003,1.8,96.3260502,107.7328492,-0.0768271,20.4426399,24.9853318,37948.9652011,110542.7157101,0.5690845,4424.3044946,1856.3632423,5346.2811422,1.5699148,8.9008389,1.4121411,22.599907),(12046,'Alces_radius.tif',242,3,96,585.9893,96.2891425,108.0825915,1.8,96.2962215,107.8727236,-0.0756972,19.9205917,24.8018712,38286.0155214,111525.6617815,0.5585584,4496.6632175,1921.9316462,5455.7598737,1.054686,6.7624301,1.7273982,16.1011845),(12047,'Alces_radius.tif',242,3,97,581.2441561,96.3591299,108.1668637,1.8,96.3935648,107.6737749,-0.0739893,19.522947,25.0350257,38378.4748682,111621.1327782,0.5293623,4458.5986928,1965.8136063,5629.8671482,4.2396273,18.4192991,1.1583859,49.2272534),(12048,'Alces_radius.tif',242,3,98,580.5877123,96.3771156,108.3083525,1.8,96.3342953,107.819109,-0.069157,19.5556718,25.0727514,38676.5099757,111793.7036977,0.4620585,4458.7728684,1977.7643235,5633.2468215,29.4934799,49.1897932,0.1146035,191.7872677),(12049,'Alces_radius.tif',242,3,99,576.8287883,96.4278435,108.4211079,1.8,96.4719597,107.9047129,-0.0659685,18.9144417,25.4682752,38934.4456104,111811.7662482,0.4177722,4390.2370842,2058.4506965,5767.1107771,30.6556212,49.7494391,0.0849018,266.3355585),(12050,'Alces_radius.tif',242,3,100,577.51894,96.5198907,108.5480412,1.8,96.6299329,108.1208549,-0.0633427,19.3739781,25.5714612,39320.2929692,112956.7863878,0.3856804,4417.2988552,2029.5415191,5760.2863695,30.8215161,49.780484,3.049654,250.7169221),(12051,'Alces_radius.tif',242,3,101,578.2851967,96.6244663,108.6517621,1.8,96.8648327,108.2188739,-0.0634892,19.8822239,25.8023363,39479.8927216,113695.8824695,0.3879777,4406.4181353,1985.6879663,5603.4661768,1.5345568,6.7165826,1.4659194,16.392428),(12052,'Alces_radius.tif',242,3,102,577.0790886,96.6779658,108.7633622,1.8,96.9095381,108.4201847,-0.0666903,18.9344653,26.1086174,39517.4489651,113683.1881713,0.4271344,4354.2400798,2087.064427,5866.7375712,1.054686,4.9718375,1.4288993,11.00871),(12053,'Alces_radius.tif',242,3,103,577.9285666,96.6994599,108.8351669,1.8,97.0117128,108.4829932,-0.0685191,17.9396721,26.1170328,39731.8064264,114175.8097278,0.4515092,4371.6991359,2214.7454076,5889.6752227,0.703124,5.3200984,1.4382448,11.4205905),(12054,'Alces_radius.tif',242,3,104,579.6456873,96.658298,108.912035,1.8,96.8300471,108.4309658,-0.0717912,20.223661,26.1915508,40185.4161461,114184.8148154,0.4970585,4359.6049676,1987.0495333,5763.9810985,0.703124,3.585243,1.3734008,7.9049705),(12055,'Alces_radius.tif',242,3,105,575.6050022,96.7554,109.0388918,1.8,96.9870041,108.3029408,-0.0771342,20.4240552,26.1377282,39993.9579936,114328.4160207,0.5696473,4374.0762421,1958.1791006,5781.4566482,0.703124,2.1384682,1.735945,4.801231),(12056,'Alces_radius.tif',242,3,106,568.2445703,96.7512532,109.2206839,1.8,96.8114312,108.0056088,-0.0816059,29.7344267,26.1060828,39793.7016221,114140.5406978,0.6293068,4372.181818,1338.3039824,4582.473318,3.6013321,18.5763178,1.056345,49.3625261),(12057,'Alces_radius.tif',242,3,107,564.5156464,96.6878981,109.3929163,1.8,96.6776604,108.146797,-0.0874368,28.9097405,25.931062,39669.7242772,113982.6198104,0.7174744,4395.6016823,1372.1923343,4709.680617,4.0522019,18.0396188,0.9936041,52.9634494),(12058,'Alces_radius.tif',242,3,108,563.2240699,96.618958,109.5254671,1.8,96.5750182,108.1970112,-0.0939406,32.3108068,25.7406583,40041.0017004,113703.4496964,0.8259595,4417.2704748,1239.2448756,4701.732927,33.9678026,50.1995576,0.1052435,232.8122448),(12059,'Alces_radius.tif',242,3,109,561.8359762,96.5467033,109.5926898,1.8,96.5476169,108.1483386,-0.0952708,31.6422384,25.7556746,40294.7120726,113060.2947257,0.8473511,4389.7236731,1273.4469546,4821.9368848,33.8430881,50.2831989,0.1685969,266.1795877),(12060,'Alces_radius.tif',242,3,110,562.0404337,96.4481189,109.6633722,1.8,96.4203409,108.0880816,-0.0997203,32.9061246,25.5897891,40856.022236,112686.2284613,0.9284175,4403.5622129,1241.5932524,4627.6663136,6.7810446,26.4677392,1.2742505,100.0959665),(12061,'Alces_radius.tif',242,3,111,564.5997665,96.340107,109.79449,1.8,96.2878826,108.4718573,-0.1047485,32.2733878,41.6236431,40894.2105981,112600.1273993,1.0287176,2705.1963497,1267.118621,3532.2163319,34.069412,49.8139908,0.0989664,250.0784033),(12062,'Alces_radius.tif',242,3,112,569.1585429,96.2196128,109.9055831,1.8,96.05411,108.76049,-0.1103265,33.1649079,25.4828013,41549.5020064,112553.6075264,1.1499495,4416.8459428,1252.8152404,4618.7590428,3.5992533,19.1915503,1.0743736,57.2674966),(12063,'Alces_radius.tif',242,3,113,575.518223,96.1822894,109.8622584,1.8,95.9124974,108.4090442,-0.1165505,33.1395812,25.220663,43280.8173072,112505.3238485,1.2970865,4460.8392715,1306.0158182,4676.2678126,42.3184761,49.4754041,0.1569713,288.2116434),(12064,'Alces_radius.tif',242,3,114,576.4389745,96.0885279,109.9345795,1.8,95.8803039,108.6157218,-0.1191315,30.9055913,25.0215211,43710.4424265,112017.1973617,1.3570634,4476.8340339,1414.3215074,5030.9905539,3.0000932,20.1251973,1.0993364,47.7856716),(12065,'Alces_radius.tif',242,3,115,577.2702876,96.0279214,110.0064814,1.8,95.7988619,108.6916553,-0.1217105,31.4082756,25.0551706,44213.0267315,112163.1694871,1.4182023,4476.6476002,1407.6871748,4966.3052388,3.5447602,21.8563016,1.1215362,56.6850096),(12066,'Alces_radius.tif',242,3,116,579.0693936,96.0087278,110.1259504,1.8,95.7161777,108.8574536,-0.1225258,31.5263118,25.0479408,44634.8406148,112970.7519761,1.4416497,4510.1812143,1415.7964576,4987.3540019,3.5290663,21.5487719,1.0779599,59.8387186),(12067,'Alces_radius.tif',242,3,117,571.0477989,96.0376882,110.2056073,1.8,95.7957546,108.8571147,-0.1222794,31.6083702,25.0235206,44502.4664851,112734.2603736,1.4159959,4505.1318795,1407.9329668,4936.300346,41.2662511,50.4108526,0.2179125,260.2633522),(12068,'Alces_radius.tif',242,3,118,570.4018046,95.984162,110.3190157,1.8,95.6236673,109.1211534,-0.1252701,30.6302904,36.1350019,44545.5935955,112961.4195539,1.4840605,3126.0941956,1454.2987664,4066.4589292,3.2073885,21.881734,1.1574659,53.1693896),(12069,'Alces_radius.tif',242,3,119,572.8622982,95.9131351,110.4036082,1.8,95.5639006,109.4975585,-0.1278156,28.7869503,27.895517,44646.137697,113517.8537066,1.551318,4069.3941542,1550.9158589,5493.4989137,3.0332711,20.9585213,1.1747149,50.6834709),(12070,'Alces_radius.tif',242,3,120,576.2913711,95.8274874,110.4027512,1.8,95.5046372,109.4911312,-0.1327915,31.448848,24.5897609,45540.5542954,113788.0142918,1.6837478,4627.4551015,1448.0833878,5059.0761034,2.8066548,20.4541418,1.1455913,50.1009839),(12071,'Alces_radius.tif',242,3,121,578.5272199,95.8864737,110.3299493,1.8,95.6840614,109.3380288,-0.1402059,30.4547112,40.7706811,47139.94223,113770.2372719,1.8830319,2790.4914577,1547.8702751,3826.8453425,3.223814,22.4917268,1.1351135,57.0615564),(12072,'Alces_radius.tif',242,3,122,576.3200978,95.7527995,110.3366232,1.8,95.4843589,109.4788184,-0.1475077,29.0489397,34.7621081,47532.3977062,113129.9436829,2.0748636,3254.4040017,1636.2868363,4328.3145268,3.2775081,22.8109291,1.1416178,57.3028304),(12073,'Alces_radius.tif',242,3,123,572.0321836,95.5933197,110.3710632,1.8,95.2383997,109.7962982,-0.1504459,24.9933153,24.9880748,47730.5767746,112354.7311822,2.1416627,4496.3340363,1909.7337077,4895.2740181,3.199025,23.7740147,1.1600794,57.1821934),(12074,'Alces_radius.tif',242,3,124,572.7403503,95.3843047,110.334801,1.8,94.8660935,109.779359,-0.1560807,26.6770354,36.9397007,48839.6108066,112024.5315832,2.3066163,3032.6323589,1830.7735483,4128.5946912,3.3364918,23.4521105,1.1540941,54.4050311),(12075,'Alces_radius.tif',242,3,125,572.5047317,95.2001498,110.2966696,1.8,94.6824453,109.7768581,-0.1656611,25.7364382,25.1444259,49694.2610483,111579.1708005,2.5947299,4437.5310582,1930.8911646,5707.6441564,3.4595138,23.7740147,1.1600794,59.1709284),(12076,'Alces_radius.tif',242,3,126,571.644205,95.0360662,110.248062,1.8,94.5118884,109.7208218,-0.1773873,25.2624737,25.3175461,50324.5934504,111337.9571713,2.9666052,4397.6598987,1992.0691105,5931.3477951,3.4502338,24.237389,1.152572,64.1427659),(12077,'Alces_radius.tif',242,3,127,573.2405389,94.8842303,110.2084231,1.8,94.3422417,109.7162008,-0.1910884,24.9205861,24.8155586,50904.4230013,111903.7977025,3.4463685,4509.4208695,2042.6655622,6107.4805856,2.9586071,22.1735034,1.1284221,55.1081551),(12078,'Alces_radius.tif',242,3,128,573.2051456,94.7424081,110.1410099,1.8,94.2464054,109.6275475,-0.2050757,25.0272327,27.7247485,51410.2671654,112468.8142734,3.9617804,4056.6216278,2054.1730561,5910.0279961,3.077753,23.1310698,1.1479424,64.2280691),(12079,'Alces_radius.tif',242,3,129,568.0147944,94.7222586,109.9427666,1.8,94.0976984,109.4425369,-0.2204845,24.9702264,36.8343286,52194.6352822,112212.1152219,4.5280949,3046.4004472,2090.2748085,4278.7472996,3.547998,24.5590655,1.1583859,59.2915654),(12080,'Alces_radius.tif',242,3,130,565.9134779,94.6203013,109.9000524,1.8,94.0245756,109.5528057,-0.2311291,24.5766167,26.4111909,52468.9064629,111447.3066845,4.9494926,4219.7001619,2134.9116948,6196.1757901,3.469284,23.9165538,1.1466019,60.9537231),(12081,'Alces_radius.tif',242,3,131,562.1356025,94.4660277,109.8151205,1.8,93.87201,109.4763354,-0.2410826,24.5392333,27.3252266,52974.295389,110719.2814449,5.3406177,4051.9071577,2158.7591922,5990.1205023,3.6474587,26.6376372,1.1780357,68.5674501),(12082,'Alces_radius.tif',242,3,132,560.9070973,94.3178621,109.7538221,1.8,93.6876438,109.619169,-0.2521789,25.2212472,26.784373,53442.9721319,110542.5388421,5.8201147,4127.1281153,2118.9662673,6103.5924351,0.351562,0.4971837,2.3561945,0.9943675),(12083,'Alces_radius.tif',242,3,133,560.4123769,94.1990261,109.5933095,1.8,93.5436152,109.3642162,-0.2625166,25.1913658,28.2871158,54250.3346651,110368.5080225,6.2902888,3901.7236213,2153.5289175,5809.3410623,3.7131199,24.0633852,1.1332866,62.3246374),(12084,'Alces_radius.tif',242,3,134,560.9007677,94.1128613,109.434391,1.8,93.4480582,109.2145966,-0.2757859,24.6770546,25.7015208,55092.984798,110547.8946702,6.931708,4301.2199709,2232.5591791,6422.9009049,4.029632,26.6376372,1.1780357,66.6640184),(12085,'Alces_radius.tif',242,3,135,564.071001,94.0179161,109.2455341,1.8,93.4359549,108.8267177,-0.2843128,25.5384976,25.021028,56329.286558,111005.0818305,7.3967639,4436.4716758,2205.6617163,6364.6577452,2.5399902,16.9042474,1.2753555,43.8082017),(12086,'Alces_radius.tif',242,3,136,552.1451261,94.0410723,109.0918889,1.8,93.9022508,108.6551576,-0.2885601,25.1502183,25.0073592,56428.8634407,110102.1869331,7.4522394,4402.7914322,2243.6729047,6327.7303198,2.0868146,13.3083748,1.357858,38.7510609),(12087,'Alces_radius.tif',242,3,137,546.8694938,94.0756705,108.9700869,1.8,93.9352523,108.2520143,-0.2895284,25.6243454,25.3520764,56061.7443265,110103.3223174,7.4292581,4342.9705951,2187.8312787,6239.2415201,2.4682997,16.805252,1.2953702,42.0607407),(12088,'Alces_radius.tif',242,3,138,535.1032448,93.931815,108.9494543,1.8,93.6701611,108.3188805,-0.2872122,25.0105866,25.1131187,55203.2479646,109020.1771336,7.156773,4341.1644084,2207.1952544,6348.2006963,2.0998619,15.2636221,1.3146449,42.6432277),(12089,'Alces_radius.tif',242,3,139,532.5501293,93.8349127,108.7582721,1.8,93.5035905,108.0701292,-0.2959258,25.9674671,28.1104673,55686.8756896,108797.4988386,7.5484942,3870.3553914,2144.4862287,5840.4548866,2.1614891,18.077262,1.3352513,40.8957667),(12090,'Alces_radius.tif',242,3,140,534.8998734,93.674606,108.5977173,1.8,93.19662,107.9701562,-0.3044532,25.3789478,27.7599821,56577.1157193,109460.3728599,8.0112814,3943.0995513,2229.2931986,5974.4718409,2.3672354,16.8932766,1.3611565,44.9585399),(12091,'Alces_radius.tif',242,3,141,534.6489364,93.608244,108.4055178,1.8,93.2117573,107.6969431,-0.3139657,26.5501255,27.0736947,56944.9992525,109901.4215978,8.4989353,4059.3433187,2144.8109287,6055.2002248,2.0781711,16.8236284,1.3815973,43.4669887),(12092,'Alces_radius.tif',242,3,142,530.6872403,93.5282494,108.3479292,1.8,93.0949845,107.9748325,-0.3222819,25.4182149,26.5618483,57006.1637562,110351.3149218,8.8730034,4154.504375,2242.728847,6298.5054001,2.0181894,16.7610663,1.4021994,44.9585399),(12093,'Alces_radius.tif',242,3,143,537.3041496,93.493024,108.2051418,1.8,93.2025535,107.9832753,-0.3306383,23.6483366,25.8104882,57804.8360315,111658.5031329,9.4382444,4326.0903263,2444.351035,6552.6458305,1.6974199,15.6632609,1.4130276,36.7976597),(12094,'Alces_radius.tif',242,3,144,536.9749727,93.4127377,107.9723731,1.8,93.1595554,107.6963856,-0.3379881,24.1033345,25.5430928,58553.1355327,112030.8384268,9.8402203,4385.9543349,2429.2545686,6652.8371406,1.1992592,9.9000758,1.4640607,23.0117875),(12095,'Alces_radius.tif',242,3,145,538.7856143,93.3348947,107.7057697,1.8,93.1259982,107.3505244,-0.3457364,25.7816013,28.2728697,59184.1882333,112832.9918752,10.3129099,3990.8574161,2295.5978426,6025.1465531,1.6285584,12.7001012,1.4876551,31.2080015),(12096,'Alces_radius.tif',242,3,146,541.7341616,93.2446501,107.4958652,1.8,92.9527572,107.0684899,-0.3551975,25.7297968,25.2344412,59670.0188804,113861.378079,10.9202648,4512.1418537,2319.101833,6572.8775287,1.9130197,18.0533163,1.4536876,42.3373485),(12097,'Alces_radius.tif',242,3,147,543.1817685,93.2334582,107.2414273,1.8,92.930126,106.8162235,-0.3637159,25.2089184,27.7353025,59951.7419888,115233.5442528,11.4573076,4154.7606762,2378.1957274,6268.6763154,1.7860481,17.3159899,1.4691075,41.9754374),(12098,'Alces_radius.tif',242,3,148,547.6956758,93.2460967,107.046788,1.8,93.0783491,106.5716378,-0.3711005,24.0372702,25.5174194,60031.6018308,117676.4038344,12.004453,4611.6106772,2497.4384037,6857.0812359,1.960855,14.0800471,1.5208379,33.02613),(12099,'Alces_radius.tif',242,3,149,554.5460689,93.1897451,106.7833853,1.8,93.1326477,105.9783012,-0.3797081,23.8144894,25.7780788,60654.8990454,120575.9018669,12.6973439,4677.4588109,2546.974573,6980.4963511,1.7546612,16.9079028,1.5083775,39.8160959),(12100,'Alces_radius.tif',242,3,150,565.9199199,93.1130944,106.4868978,1.8,92.9304179,105.7921441,-0.3856078,25.8293694,26.5938814,61696.7554789,124019.7175649,13.3432645,4663.4681067,2388.6280169,6970.0288205,1.75781,15.1539127,1.6404509,38.9923349),(12101,'Alces_radius.tif',242,3,151,574.24983,93.0808199,106.1787355,1.8,92.9206069,105.4240231,-0.3898494,25.4227175,26.6739082,62715.5465594,127152.1941184,13.8238524,4766.9127834,2466.9096246,7107.3912331,2.460934,14.4311812,1.6195382,35.2208052),(12102,'Alces_radius.tif',242,3,152,581.8319105,92.9729974,105.8789367,1.8,92.7918286,105.1216876,-0.3923723,26.1710683,26.0524115,63937.6625171,129752.148776,14.1788214,4980.4275758,2443.066586,7208.6635346,36.2725854,52.5570492,0.5805816,189.421986),(12103,'Alces_radius.tif',242,3,153,586.5769795,92.9952341,105.4901756,1.8,92.8327092,104.6387583,-0.391012,24.7598017,26.3427667,64853.8216783,132003.4139666,14.200603,5010.9927959,2619.3191029,7359.3166794,1.6971072,14.832417,1.665748,37.3801467),(12104,'Alces_radius.tif',242,3,154,591.1475162,92.9883167,105.2499435,1.8,93.0028484,104.363721,-0.3872006,24.9115355,26.5244871,65294.093333,133541.1859609,14.0476374,5034.6378161,2621.0384919,7488.5036996,1.9644648,16.2328781,1.6575347,42.3873179),(12105,'Alces_radius.tif',242,3,155,593.5027285,92.9546804,104.9024641,1.8,92.9391615,103.8906791,-0.3895646,24.1926183,26.6160624,66368.2309225,134739.5944995,14.267522,5062.3413998,2743.3256717,7554.4511178,1.9778642,15.9602953,1.7033479,41.5635569),(12106,'Alces_radius.tif',242,3,156,603.1259381,92.7704683,104.5765555,1.8,92.7667379,103.615605,-0.3898209,24.3570485,26.7960695,68859.7830959,136586.2964139,14.5169693,5097.2511669,2827.0988199,7665.2819114,2.0232644,15.5682832,1.6839473,40.7751297),(12107,'Alces_radius.tif',242,3,157,610.6191419,92.6843996,104.3773427,1.8,92.5792817,103.7357403,-0.3887587,23.999318,27.0673099,70399.7068953,138409.1255628,14.6214132,5113.51612,2933.4044743,7714.3661493,2.0226003,16.9662816,1.6745887,43.3816854),(12108,'Alces_radius.tif',242,3,158,617.3930179,92.5134138,104.0627751,1.8,92.462649,103.3507652,-0.3880205,33.9613669,27.2990498,72196.8299754,140336.0123568,14.7303677,5140.6921971,2125.8517131,5269.0779202,2.3854569,20.7897728,1.6384893,51.5778994),(12109,'Alces_radius.tif',242,3,159,618.4742942,92.4376952,103.8583086,1.8,92.3769244,103.1389672,-0.3809311,23.8300866,27.4955015,72610.8434782,142009.4126152,14.2480028,5164.8235113,3047.0238971,7800.202293,1.5755163,15.5325168,1.6614562,38.4098479),(12110,'Alces_radius.tif',242,3,160,619.4433605,92.333574,103.6333267,1.8,92.3024357,102.9112433,-0.3764365,24.7204905,27.7047727,73042.6577211,144157.362704,13.9515437,5203.3403911,2954.741446,7839.7789239,1.406248,5.6687669,1.6951513,13.9918125),(12111,'Alces_radius.tif',242,3,161,621.0220913,92.2813942,103.2656828,1.8,92.2043953,102.4730437,-0.3686581,26.0900206,28.1723035,73624.183089,146191.9852039,13.4412169,5189.2095033,2821.9288956,7740.8943989,1.6382829,10.755729,1.3734008,30.1783002),(12112,'Alces_radius.tif',242,3,162,622.1635551,92.1581153,102.9430901,1.8,91.9879149,102.1312461,-0.3590098,24.6885522,28.199764,74534.0857221,146745.1130554,12.8004946,5203.7709648,3018.9735411,7846.5663633,2.1362723,17.6657719,1.670465,45.8676042),(12113,'Alces_radius.tif',242,3,163,624.0038223,91.9978807,102.6025742,1.8,91.7413204,101.8151153,-0.3522532,25.0271966,28.3517192,75677.4248988,147680.0774123,12.3796488,5208.857923,3023.807507,7877.3727859,2.8060801,21.5487719,1.6688416,61.7275146),(12114,'Alces_radius.tif',242,3,164,622.2198848,91.8297258,102.3194288,1.8,91.5531715,101.4813148,-0.3454215,25.2027224,28.7415846,76390.2031039,149332.6399079,11.8891106,5195.6996181,3031.0298212,7701.6470481,2.263439,21.6289217,1.7011996,54.4403649),(12115,'Alces_radius.tif',242,3,165,627.670349,91.6441803,102.1918409,1.8,91.2949654,101.722802,-0.3371379,23.9181143,47.4692882,77729.5332098,151997.7518732,11.4466539,3202.0229825,3249.8186168,4705.233418,2.4806325,23.0695402,1.7083831,61.2303309),(12116,'Alces_radius.tif',242,3,166,646.0218593,91.4637111,101.9724931,1.8,90.9841966,101.8183249,-0.3328806,24.1581715,29.3148246,79542.7650919,155395.8762078,11.496668,5300.9314641,3292.582179,8009.2453603,2.5097264,25.258696,1.7245039,61.8481516),(12117,'Alces_radius.tif',242,3,167,653.2350249,91.266166,101.7226611,1.8,90.8283202,101.6659579,-0.3260118,25.5792622,29.5219412,81000.9636202,158966.8667068,11.167187,5384.7023617,3166.6653652,8128.3264756,39.4201109,55.0562256,0.3520443,212.9809267),(12118,'Alces_radius.tif',242,3,168,665.769703,91.0956596,101.4529957,1.8,90.6439768,101.5575743,-0.3177644,26.3690839,29.7071156,83055.2897944,162764.4972245,10.8321881,5478.9734401,3149.7222347,8264.8100288,2.2592847,18.6161955,1.7607846,52.4162962),(12119,'Alces_radius.tif',242,3,169,679.7484674,90.9730889,101.0234832,1.8,90.530855,101.0673188,-0.3058723,28.802325,30.1284912,85333.6947615,165791.97501,10.2728487,5502.830316,2962.7363293,8333.6569967,40.3066217,56.0132162,0.3793409,215.0049954),(12120,'Alces_radius.tif',242,3,170,687.0735808,90.8401352,100.7267855,1.8,90.3832571,100.8464515,-0.296996,28.1144632,30.2654211,86680.9065991,167796.7811014,9.8072266,5544.1746793,3083.1428604,8404.8663668,40.3451452,55.9204644,0.3197625,304.0569182),(12121,'Alces_radius.tif',242,3,171,696.0879498,90.7535889,100.4537401,1.8,90.2633794,100.5776408,-0.2935893,26.0176071,30.3679066,88059.7546582,171057.9933975,9.7158188,5632.8542986,3384.6215869,8527.9436621,40.9939295,56.4133786,0.363147,314.8596879),(12122,'Alces_radius.tif',242,3,172,699.552903,90.6408512,100.1910194,1.8,90.1258002,100.2882701,-0.2880992,25.8216078,30.5326662,89339.4923944,173863.3638319,9.4124878,5694.3393838,3459.873345,8616.225238,40.2653195,56.549051,0.4024428,262.166784),(12123,'Alces_radius.tif',242,3,173,701.6448562,90.5555664,99.9619214,1.8,90.0669848,100.0364191,-0.2843991,26.7302881,30.6482541,90596.3928643,176889.4502596,9.2062289,5771.5995737,3389.2785772,8608.7716119,0.703124,0.9943675,0.7853982,1.988735),(12124,'Alces_radius.tif',242,3,174,706.0804487,90.396268,99.6116957,1.8,89.9554278,99.6417349,-0.2701917,26.4040209,30.8883146,93091.7470288,180381.4474002,8.3840259,5839.7957273,3525.6655595,8682.1224734,40.250125,57.6829577,3.1111143,299.6175982),(12125,'Alces_radius.tif',242,3,175,712.0681802,90.2796429,99.2316208,1.8,89.8499216,99.2879421,-0.2538693,25.5592936,31.0610196,95948.0627733,185699.9321076,7.4858389,5978.5523561,3753.9403232,8950.5212969,3.3298082,26.36715,1.8545904,66.6140489),(12126,'Alces_radius.tif',242,3,176,719.0368133,90.1584907,98.8484303,1.8,89.7189939,98.8918995,-0.2353072,25.6469826,31.3098781,99392.8135159,190966.0918336,6.513884,6099.2282191,3875.4193777,8798.5911051,0.351562,0.4971837,2.3561945,0.9943675),(12127,'Alces_radius.tif',242,3,177,731.4012662,90.1082392,98.2891107,1.8,89.7282167,98.318865,-0.213926,23.9155793,31.7664874,103747.2199644,197837.5714491,5.4940996,6227.8705502,4338.0600821,9460.6785073,0.703124,1.2675748,0.5880026,2.4859187),(12128,'Alces_radius.tif',242,3,178,743.076354,89.9160186,97.8622892,1.8,89.6562965,97.921492,-0.1870774,24.490445,31.9892557,107875.0986514,203363.0321449,4.2840297,6357.2292521,4404.7831143,9650.7600256,43.2763537,60.0296619,3.0477514,333.8026398),(12129,'Alces_radius.tif',242,3,179,759.5121288,89.7922382,97.4028475,1.8,89.515598,97.5029504,-0.1526877,25.3014006,32.2829962,112981.3492449,210649.9164901,2.9282912,6525.1042791,4465.4187661,9411.83451,44.1473068,60.7988847,3.037321,319.1430371),(12130,'Alces_radius.tif',242,3,180,775.5829587,89.7150248,96.9411425,1.8,89.4633731,97.0769339,-0.1263286,25.4018835,32.462574,117595.3514835,218891.7416197,2.0519585,6742.8954326,4629.3949566,9648.5190597,44.6313343,61.7199107,3.0617627,330.8695068),(12131,'Alces_radius.tif',242,3,181,801.1265859,89.3530865,96.2008333,1.8,88.9975364,96.1891324,-0.0576713,26.6156133,32.4630303,127721.2343358,231446.5850755,0.4435958,7129.5434557,4798.7334671,10455.9637892,3.1978195,26.7949293,1.9049944,68.2762066),(12132,'Alces_radius.tif',242,3,182,833.9725548,88.9143585,95.4007701,1.8,88.4569129,95.3007663,0.0237233,27.7124743,32.5971094,140923.9373822,248753.6310986,0.0782106,7631.1561189,5085.2167136,10705.9906626,3.458337,26.2379273,1.8840725,74.1924421),(12133,'Alces_radius.tif',242,3,183,869.444898,88.376186,94.5286375,1.8,87.9998981,94.4456229,0.1216043,28.5988688,32.9849879,155966.7745848,271193.6083908,2.1322926,8221.7282872,5453.5994386,11128.9998489,3.2199419,25.8009146,1.9184032,61.1096939),(12134,'Alces_radius.tif',242,3,184,905.8760077,87.8908701,93.7365517,1.8,87.6203868,93.7673083,0.2080207,29.9162248,34.2027146,170592.4310519,296096.161428,6.4395736,8657.0953504,5702.3381775,11947.9587077,3.126276,19.6780529,1.8981965,51.3366254),(12135,'Alces_radius.tif',242,3,185,967.3936272,87.3097695,92.3525823,1.8,87.0599897,92.4301764,0.3145212,32.4890588,38.4290446,189438.8712643,342567.8381062,15.430635,8914.2949462,5830.8513136,12576.0959806,3.3898442,24.5716438,1.9061207,63.8868561),(12136,'Alces_radius.tif',242,3,186,1006.4150062,87.1967673,91.6791575,1.8,86.8350959,91.6598941,0.3284729,32.3394108,40.4276202,199878.7800905,367680.6845702,17.4561763,9094.7892199,6180.6561975,13326.7790207,56.5159641,74.8893078,2.7767781,314.9242931),(12137,'Alces_radius.tif',242,3,187,1066.3582769,86.720645,90.4398542,1.8,86.483231,90.427948,0.3950554,33.4886225,41.5765632,219365.8345419,415287.4071095,26.3242385,9988.4977335,6550.4585847,14621.4304471,3.1827249,19.6780529,1.8981965,47.9416424),(12138,'Alces_radius.tif',242,3,188,1105.9213052,86.684519,89.8532873,1.8,86.6706789,90.0535725,0.3884176,34.1552476,42.0614495,233054.9719339,446555.5719882,26.4374477,10616.7423381,6823.4016216,15688.7292998,59.576886,78.3951729,2.7985687,328.5541946),(12139,'Alces_radius.tif',242,3,189,1147.1319785,87.2044703,89.7238695,1.8,87.6361121,90.0276204,0.3055218,34.2505504,42.2047941,241721.0055023,460372.2408897,17.297824,10908.0556038,7057.4342016,15943.1197808,3.7145719,12.6024067,1.9720251,37.3094792),(12140,'Alces_radius.tif',242,3,190,1257.6119401,87.252518,88.7604236,1.8,88.1984249,89.3758843,0.2694151,34.9863829,41.6201979,265430.3482661,512361.1793506,14.8493034,12310.3974744,7586.6759017,17823.6615088,61.2754599,81.5176688,2.793927,302.8566104),(12141,'Alces_radius.tif',242,3,191,1336.6374347,87.268006,88.7618358,1.8,88.403388,89.2268453,0.1942235,34.6451621,40.8212051,277530.9882512,550650.2576319,8.298476,13489.3190183,8010.6708021,19101.345822,61.1345238,81.2716757,2.8294177,362.9719368),(12142,'Alces_radius.tif',242,3,192,1347.7494124,88.5751256,89.032441,1.8,88.7758239,89.4396947,0.0932229,33.1128852,40.195369,285125.0523293,540112.461975,1.9464583,13437.1813158,8610.6979452,18927.8182442,58.5859017,79.9345616,2.8240145,349.9951899),(12143,'Alces_radius.tif',242,3,193,1325.4893522,89.2733425,89.3887589,1.8,89.3022919,89.501519,0.066798,32.6709942,39.6478081,266487.3533239,523788.871609,0.9842497,13211.0423449,8156.6955577,18334.5584109,57.874404,78.764012,2.8565488,399.2749239),(12144,'Alces_radius.tif',242,3,194,1240.1885222,89.1947248,89.9092665,1.8,89.5218949,89.9524917,0.0712186,30.5910372,39.1405861,228015.5367876,461934.9169906,1.0466212,11801.9417415,7453.6713205,16846.0040728,53.8256661,77.1812716,2.9165009,349.6711237),(12145,'Alces_radius.tif',242,3,195,1139.0010201,89.3257859,89.8719274,1.8,89.7393199,90.2660045,0.1068039,30.2427836,38.7051756,183038.8655801,417757.5232665,2.1572211,10793.3245706,6052.3154273,14540.6168275,51.044748,76.8386183,2.8777483,358.0440065),(12146,'Alces_radius.tif',242,3,196,1068.0882441,90.2747892,90.0654536,1.8,90.1431318,90.4531827,0.0835337,27.8589889,37.2473696,151614.0330076,367995.8597182,1.2392794,9879.7811414,5442.1943834,12817.9622899,48.6333575,74.7563341,2.8555412,343.81092),(12147,'Alces_radius.tif',242,3,197,985.1658476,92.0656522,90.9281584,1.8,91.6989462,90.9969212,-0.0153088,27.1080457,33.6128553,116009.7258956,295405.9724139,0.038477,8788.4819587,4279.5311488,10393.00631,1.7906461,10.5761163,1.8399638,26.577377),(12148,'Alces_radius.tif',242,3,198,976.9703573,92.7447479,90.9612687,1.8,92.6953327,91.2285563,-0.0161486,24.1659231,32.9309983,97385.6607658,275197.690425,0.0424584,8356.7976901,4029.8754793,11160.6839589,43.5186607,64.9819349,3.0004607,236.0658928),(12149,'Alces_radius.tif',242,3,199,1000.4069749,93.4287097,90.5043341,1.8,93.3464144,90.7854636,0.00252,21.6339113,32.6238263,85106.4450316,265833.465923,0.0010592,8148.4453647,3933.93705,10576.9900603,41.2354077,64.5382042,3.010481,237.7280505),(12150,'Alces_radius.tif',242,3,200,939.3616788,95.4561497,90.3917656,1.8,94.2956511,90.4505988,-0.0173689,28.7191751,33.4960948,69881.0371142,215496.4233786,0.0472263,6433.479032,2433.2536319,8379.709731,37.9826608,62.8942355,2.9957431,225.7310353),(12151,'Alces_radius.tif',242,3,201,653.7374982,99.4703085,89.7930291,1.8,96.7769984,90.372945,-0.0677913,18.2824679,34.6932026,39283.5629748,122788.423313,0.4999595,3539.2645812,2148.7013239,4659.490186,33.6661397,58.1439335,0.1701188,232.897548),(12152,'Alces_radius.tif',242,3,202,302.4006679,106.6476092,89.0382696,1.8,103.21526,89.1757349,0.156741,15.4989386,35.1360117,14857.0355165,35444.3192217,1.2281104,1008.7746863,958.5840647,1366.5705172,28.6254888,53.5483285,0.2386093,194.2524884),(12153,'Alces_radius.tif',242,3,203,96.728726,114.3657315,90.0780916,1.8,113.3251994,90.7244503,-1.3200026,23.8396453,12.7601177,978.3258656,3202.7726569,15.1285371,250.9986757,41.0377693,174.7960105,13.8313236,24.7820041,1.018212,84.2920878),(12154,'Alces_radius.tif',242,3,204,14.7216503,116.0073111,88.0025683,1.8,115.8068499,88.0351142,-1.1187617,3.1858747,7.7562636,15.7635343,153.2969605,1.9854811,19.7642794,4.9479455,21.7934418,5.750291,15.1335089,1.0343609,34.4823474),(12155,'Alces_radius.tif',242,3,205,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12156,'Alces_radius.tif',242,3,206,18.1895623,87.3303237,118.0768985,1.8,87.3370318,118.1112856,1.1741532,6.6136386,6.6101,157.4925353,165.3921698,2.5791392,25.0211297,23.8132963,47.6121599,13.1753693,13.728935,2.9090357,43.9288387),(12157,'Alces_radius.tif',242,3,207,123.090258,99.7149723,120.8907938,1.8,101.6530352,120.3620019,0.2065656,9.9328718,30.0318873,2044.345895,26548.8446148,0.8629834,884.0218503,205.8161959,947.3386296,19.8972103,20.3116448,1.1613591,66.3228054),(12158,'Alces_radius.tif',242,3,208,438.1850801,108.3860637,119.424906,1.8,102.9487403,118.4756857,0.0574374,13.5403152,32.9418658,13233.3901447,86432.1937459,0.2406678,2623.7795495,977.3325036,3022.2796424,23.554654,24.4885078,2.4578833,78.6524601),(12159,'Alces_radius.tif',242,3,209,504.0671309,108.5533531,118.8741623,1.8,102.2543963,118.4320423,0.0187038,13.4077182,34.4080739,16982.0743383,102847.9875181,0.0293862,2989.0655275,1266.5894483,3479.2556162,26.36715,27.152333,0.0777649,88.1342851),(12160,'Alces_radius.tif',242,3,210,503.24402,108.2023982,119.0543677,1.8,102.03812,118.6261287,0.0144356,14.3812481,34.7509644,16882.4026491,105295.969228,0.0174774,3030.0157397,1173.9177652,3512.6308206,29.5342721,57.2301473,3.0431465,186.7447627),(12161,'Alces_radius.tif',242,3,211,496.3037391,108.020845,119.2509626,1.8,102.0109093,118.8706608,0.0099184,15.0091266,34.9088887,16300.4620477,104737.3122141,0.0081374,3000.3049669,1086.0366805,3465.4280403,29.6183308,57.4510827,2.9694018,180.0400999),(12162,'Alces_radius.tif',242,3,212,490.1981046,107.9048631,119.4253547,1.8,101.9521643,119.0667812,0.0066972,15.2403906,34.8020238,15644.3352065,103934.472339,0.0036648,2986.4490866,1026.5048714,3421.7458733,29.5806633,57.6272212,2.9884795,180.2460402),(12163,'Alces_radius.tif',242,3,213,483.6433678,107.7271805,119.5921309,1.8,101.7302067,119.2547317,0.0057195,15.0725571,34.6241857,14937.9590612,103365.3468041,0.0026368,2985.3509786,991.0699945,3397.1240007,29.6437205,57.6272212,2.9884795,180.5372837),(12164,'Alces_radius.tif',242,3,214,479.5306226,107.494756,119.7231637,1.8,101.4875133,119.3573034,0.0078707,14.8084605,34.7384605,14434.135114,103667.415131,0.0049505,2984.2259491,974.7221916,3393.9555431,29.6661672,57.6529524,3.0316088,183.4350829),(12165,'Alces_radius.tif',242,3,215,477.4427518,107.2474008,119.8311529,1.8,101.1593427,119.5028989,0.0114915,14.1593683,34.507558,14017.3429553,104522.2513642,0.0105079,3028.9669133,989.9695147,3424.585045,29.5619702,57.7386403,2.976444,183.2644765),(12166,'Alces_radius.tif',242,3,216,474.4900097,106.9500653,119.9318252,1.8,100.7942451,119.5965074,0.0161611,13.824536,34.5473047,13599.1185108,105411.7558949,0.0206524,3051.2295224,983.69439,3443.7058944,29.5492463,57.8242013,3.0074341,185.8356984),(12167,'Alces_ulna.tif',242,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12168,'Alces_ulna.tif',242,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12169,'Alces_ulna.tif',242,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12170,'Alces_ulna.tif',242,4,4,53.4329344,87.0200292,43.4130529,1.8,87.3545235,44.3618997,1.3764321,4.140953,24.1292376,153.3355413,12553.4917623,8.5732776,520.2606052,37.0290465,526.5842342,7.6435801,24.8119143,1.6986662,57.0322948),(12171,'Alces_ulna.tif',242,4,5,141.4525286,86.8048591,39.93115,1.8,87.3757905,41.3100783,1.3906343,5.9659304,28.2929261,878.0341596,31553.328329,22.8184452,1115.237365,147.174725,1146.1087296,11.9439891,52.1983834,1.7536619,124.9173306),(12172,'Alces_ulna.tif',242,4,6,229.1965414,86.8819411,37.4588865,1.8,87.3325258,39.3837285,1.3935212,8.2488957,32.2223115,2043.6922308,48795.0760133,37.0114728,1514.3257494,247.7534327,1577.5881675,14.6248585,56.0055024,1.7411049,144.2075611),(12173,'Alces_ulna.tif',242,4,7,283.6159583,86.8593189,36.7510615,1.8,87.2898926,38.9181375,1.3905443,8.6958469,35.1224573,3396.4840811,65022.2411469,45.7500702,1851.3010233,390.5869233,1947.9087729,16.705792,59.9967206,1.7475052,163.2418819),(12174,'Alces_ulna.tif',242,4,8,332.7047222,86.9959437,36.8036469,1.8,87.3194899,38.4015852,1.3929515,9.5082137,37.1855663,5264.1916939,86855.1941278,53.7153594,2335.7233146,553.6467585,2477.1330002,18.1327943,63.5812403,1.7486716,156.8991291),(12175,'Alces_ulna.tif',242,4,9,396.671846,87.0671054,36.043006,1.8,87.2375313,37.6344933,1.3964665,11.153427,40.1839055,8713.2372391,113723.5026091,64.1230431,2830.0759039,781.2161451,3046.8777967,21.9042511,67.6398461,1.7590178,168.0930832),(12176,'Alces_ulna.tif',242,4,10,442.9619871,86.9447438,35.7881108,1.8,87.1378234,37.5139307,1.3971462,12.1784577,42.2480904,12177.0621877,138372.639488,71.6230793,3275.2400893,999.8854132,3563.3583389,23.3258067,70.5344246,1.7613494,172.3971312),(12177,'Alces_ulna.tif',242,4,11,491.0621338,86.9839869,36.0796543,1.8,87.1862971,37.8526091,1.4030124,13.1855282,43.2848457,16434.4643814,167320.9411184,79.5612104,3865.5778596,1246.4016746,4240.0532535,25.2948916,72.95061,1.7795336,195.8707727),(12178,'Alces_ulna.tif',242,4,12,521.8332388,87.0876321,36.7353868,1.8,87.2352627,38.5128335,1.411976,13.9399815,44.057686,19668.5310351,188297.7069701,84.7968115,4273.8900749,1410.9438436,4719.986537,26.9949339,75.0270009,1.7498116,222.8600348),(12179,'Alces_ulna.tif',242,4,13,526.0148246,87.3888095,37.9412223,1.8,87.4528641,39.2205007,1.4270359,15.1095024,43.6552669,19869.3399435,200215.4861469,85.8697216,4586.2847851,1315.0227839,5036.1315245,26.6826116,76.0488141,1.7709117,241.5324445),(12180,'Alces_ulna.tif',242,4,14,538.6766984,87.4315841,38.5749206,1.8,87.4224841,39.3978136,1.4385002,13.9850756,43.2513794,21342.4027648,206650.4246191,88.2172519,4777.8921102,1526.0841871,5266.7802996,27.1764816,76.2913973,1.7374602,247.8751973),(12181,'Alces_ulna.tif',242,4,15,555.1953255,87.2878781,38.7958568,1.8,87.3063865,39.1837225,1.4455516,14.4656144,42.7314613,22810.0779695,212735.1346044,91.0886398,4978.4193681,1576.8481951,5501.5036152,0.3515621,0.4971838,2.3561945,0.9943677),(12182,'Alces_ulna.tif',242,4,16,559.6136162,87.1082759,39.5336465,1.8,87.2172403,39.533784,1.4467808,14.2071299,42.6724786,22524.502783,219659.1213405,91.8418122,5147.5594662,1585.436534,5665.2629148,0.3515621,0.7861167,2.677945,1.4915515),(12183,'Alces_ulna.tif',242,4,17,559.7697964,87.1154987,40.731893,1.8,87.3710937,40.5891034,1.4468137,13.587075,42.7474784,21751.432739,226857.2135722,91.8681987,5306.9145162,1600.891495,5812.2837946,0.3515621,0.7861167,2.0344439,1.6974918),(12184,'Alces_ulna.tif',242,4,18,558.3043238,87.023649,42.0006,1.8,87.2642302,41.8663497,1.4492601,13.2807571,42.9340231,21145.0756977,232666.1429656,91.6830169,5419.1553982,1592.1589024,5905.2241058,26.0820345,78.0127223,1.7018589,221.8656671),(12185,'Alces_ulna.tif',242,4,19,559.1155248,86.9552455,43.514918,1.8,87.1964199,43.3520244,1.4512512,13.4338992,43.0540764,20654.1746536,237780.5206853,91.8605305,5522.8340814,1537.466842,6000.6665941,25.3498085,78.8142237,1.6735719,231.0562502),(12186,'Alces_ulna.tif',242,4,20,560.4939185,86.9550391,45.0481265,1.8,87.1773218,44.8730535,1.4554713,13.0045448,42.6547162,20065.9255159,242122.5498764,92.1787359,5676.3371454,1542.9932965,6139.9022067,24.6625962,78.9708873,1.6912861,219.2091414),(12187,'Alces_ulna.tif',242,4,21,571.3699067,86.9593226,46.2615718,1.8,87.1735303,46.1118424,1.4629681,13.6272965,43.1413029,20087.7126869,253026.9060313,94.1253896,5865.0733495,1474.0790789,6324.4096117,24.6183881,80.1044782,1.6984175,229.791337),(12188,'Alces_ulna.tif',242,4,22,577.5273412,87.0591273,47.6947548,1.8,87.2257475,47.4039611,1.4740418,34.4390504,50.4642048,19726.2098738,262524.9663314,95.3562833,5202.2015852,572.786114,4619.8208895,24.562379,80.8470448,1.7016237,237.1138218),(12189,'Alces_ulna.tif',242,4,23,591.2410534,87.0318659,49.0938625,1.8,87.1766461,48.6964218,1.4815547,12.9541031,43.3594006,19724.9785918,277012.9146882,97.7574763,6388.7625422,1522.6819187,6836.9541439,23.3796611,82.0835302,1.6350853,229.9619436),(12190,'Alces_ulna.tif',242,4,24,605.5901234,86.9390144,50.5327756,1.8,87.1063873,49.980719,1.4863323,12.7345669,43.3843175,19738.7446123,291626.8974548,100.2133335,6721.9427205,1550.013031,7160.6400948,22.916692,83.2370974,1.6511315,230.991645),(12191,'Alces_ulna.tif',242,4,25,625.1551268,86.9553321,52.2939271,1.8,87.1030741,51.8752219,1.4916246,40.6225669,45.2839443,20160.443402,305872.9275423,103.5407882,6754.5557805,496.286792,5435.6735305,22.8443272,84.2884245,1.6501274,236.5106367),(12192,'Alces_ulna.tif',242,4,26,642.0977628,86.8451553,54.4168964,1.8,86.9224386,53.9872587,1.4946272,38.6005985,44.0747515,20475.6165302,322034.6805756,106.3966131,7306.5569214,530.4481621,5876.478165,23.4044759,84.9471718,1.686938,231.8653756),(12193,'Alces_ulna.tif',242,4,27,679.0935684,86.897915,57.7132482,1.8,86.9879642,56.9552369,1.4880182,39.6904023,43.9439959,21986.3281291,353763.1460627,112.4084819,8050.3181043,553.9457109,6694.4195781,25.1127299,85.7292573,1.694134,336.2008021),(12194,'Alces_ulna.tif',242,4,28,725.1357313,86.9462306,60.8820345,1.8,86.9366486,59.4136186,1.4879277,13.1204955,45.675156,24387.9614676,381381.4815633,120.0279103,8349.8670825,1858.7683322,8864.9958927,25.5709751,85.2565179,1.6823643,336.5627132),(12195,'Alces_ulna.tif',242,4,29,729.5610631,86.5914977,61.8501131,1.8,86.5525868,60.2800248,1.5039897,14.0138211,44.6015949,25716.7750236,354984.0729484,121.0516304,7958.9995283,1835.1008472,8528.4937935,26.7097824,83.1211972,1.6809865,278.3094125),(12196,'Alces_ulna.tif',242,4,30,663.5677159,86.4389242,59.4129649,1.8,86.4185798,58.8252962,1.4956051,13.4749586,40.7407723,23847.2477613,270067.4113408,109.9705255,6628.922227,1769.7455245,7205.0860262,26.4186915,76.4960591,1.6443959,265.8091491),(12197,'Alces_ulna.tif',242,4,31,612.009731,86.3829111,57.5686414,1.8,86.3483476,57.1211463,1.4784103,12.8460699,37.4250727,22003.7022536,211841.4615446,101.1334933,5660.4154973,1712.8742374,6230.1512362,25.5279482,69.2639717,1.6724852,315.9868715),(12198,'Alces_ulna.tif',242,4,32,572.1694222,86.3747984,56.4341565,1.8,86.3360902,56.0289861,1.4593702,13.0808078,34.8379002,20323.9914545,174218.2731981,94.182473,5000.825892,1553.7260235,5559.3182573,2.909212,19.1011791,1.6814535,44.6673041),(12199,'Alces_ulna.tif',242,4,33,543.1785473,86.504698,55.5609627,1.8,86.6565772,55.1932493,1.4364079,14.1706421,32.5114477,18934.121165,145195.5470396,88.9045858,4465.9822079,1336.1512513,5016.5818413,2.425417,23.1203848,1.7234457,53.5166741),(12200,'Alces_ulna.tif',242,4,34,514.3232534,86.5734521,54.8222555,1.8,86.7800358,54.9081209,1.4018699,12.7019704,30.3808319,17494.6094119,122206.0150454,83.297589,4022.4709868,1377.3146109,4565.2254561,1.9771064,17.9262181,1.7681919,41.5988979),(12201,'Alces_ulna.tif',242,4,35,466.0548291,86.6653552,53.2098963,1.8,87.0389686,53.8105506,1.3316558,13.4249788,27.3877731,15275.9814013,95211.3772748,73.3177017,3476.4190881,1137.8775081,3992.7090774,0.7031241,3.9305833,1.7506498,8.608096),(12202,'Alces_ulna.tif',242,4,36,448.4547754,86.5841533,52.8178263,1.8,87.1339316,53.4764851,1.2913464,13.2108869,26.5529318,14853.1625715,82261.7344041,69.0560192,3098.0283139,1124.3122949,3619.8237435,0.7031241,6.3670597,1.6814535,13.2387213),(12203,'Alces_ulna.tif',242,4,37,443.8986567,86.5904171,53.0314673,1.8,87.2075834,53.5821941,1.2503066,13.5652638,26.1432874,14851.2884867,76021.9663216,66.6406716,2907.8962086,1094.8027808,3433.878068,2.4156691,17.3159929,1.4691075,42.302022),(12204,'Alces_ulna.tif',242,4,38,443.4747977,86.5450872,53.3898866,1.8,87.1517476,53.8526761,1.2208042,13.6236849,25.7091325,15004.1977131,71425.4460031,65.2222956,2778.2129953,1101.3318219,3306.672191,2.477454,20.0883189,1.5007357,49.1273229),(12205,'Alces_ulna.tif',242,4,39,444.0545747,86.4901589,53.9007973,1.8,87.095379,54.3256632,1.1924965,13.279522,25.4104691,15369.4088397,68161.970141,63.9133049,2682.4365172,1157.3766591,3232.3399723,1.99196,16.2671074,1.4625257,35.8386321),(12206,'Alces_ulna.tif',242,4,40,448.8815932,86.5269422,54.55191,1.8,87.1162311,55.0272399,1.1568186,13.7720692,25.5404113,16152.74714,67543.3786995,62.7081258,2644.5689517,1172.862766,3208.6810353,1.8036178,17.6097152,1.5108682,38.9423722),(12207,'Alces_ulna.tif',242,4,41,465.1250135,86.9001322,55.4014701,1.8,87.5279216,55.9107479,1.1094747,15.2039717,26.0304998,17733.9268146,70720.3566687,62.1606645,2716.8266884,1166.4009333,3326.2189123,2.017017,18.2947438,1.5323537,45.6970056),(12208,'Alces_ulna.tif',242,4,42,479.1595507,87.1827876,56.5129158,1.8,87.7030642,57.1109867,1.0723235,16.8690474,26.3657934,19469.7246472,75364.9895511,61.6067359,2858.4381414,1154.1685919,3517.8084531,2.3490112,22.8542381,1.5861797,57.4088416),(12209,'Alces_ulna.tif',242,4,43,500.7271071,87.4916089,58.0066634,1.8,87.6956422,58.9459802,1.0457068,50.9461593,37.2885906,23057.0494037,82730.3274574,62.4830541,2218.6498913,452.576793,2075.200736,3.3099027,22.9190423,1.4940244,57.9559949),(12210,'Alces_ulna.tif',242,4,44,538.9734783,87.4241996,59.6063847,1.8,86.9226349,60.0601326,1.0210073,32.2218515,28.2164356,31746.4745904,89998.011804,65.3043657,3189.5599141,985.2467523,3744.2694399,2.0054166,4.2769371,1.735945,12.5502329),(12211,'Alces_ulna.tif',242,4,45,579.9187717,86.5512148,61.3398552,1.8,85.8818648,61.4543694,1.0603569,45.4471361,29.8190757,48494.5457662,91987.2160284,73.5828431,3084.8446482,1067.053942,3062.8166423,44.7165321,52.2137719,2.1158347,319.8608519),(12212,'Alces_ulna.tif',242,4,46,594.6836107,85.0950282,62.3450671,1.8,84.4669703,62.2373629,1.3387425,45.4986662,26.5882393,61437.10494,84157.7256751,93.8718685,3165.2237159,1350.3056256,3036.3732155,0.7803653,1.7578103,2.2142974,3.6862271),(12213,'Alces_ulna.tif',242,4,47,583.5775469,84.4464605,62.6565615,1.8,84.2708427,62.191303,1.5478362,31.7121906,26.1695845,57926.2177035,79350.6280835,97.2116597,3032.1699595,1826.6230283,4148.8763973,0.7031241,1.267575,2.5535901,2.4859192),(12214,'Alces_ulna.tif',242,4,48,554.4577578,84.3567044,62.7018734,1.8,84.3216198,62.1208879,1.5641514,35.1323928,25.4613096,54128.1198582,72773.2868167,92.405546,2858.1910383,1540.6898183,3518.7549196,0.4971838,0.9943677,0.7853982,1.9887353),(12215,'Alces_ulna.tif',242,4,49,494.4913203,84.1312894,61.9437803,1.8,84.0305267,61.4013643,-1.5668881,41.0695629,24.3205363,42282.7824084,61571.4695986,82.4139611,2531.6657888,1029.5405988,2437.0356112,0.6680515,2.0499415,1.0303768,4.3893512),(12216,'Alces_ulna.tif',242,4,50,432.0376467,84.4801918,60.9773648,1.8,84.2616775,61.0749332,1.412052,38.6751006,23.0557603,31297.6562643,51396.6690378,70.2069249,2229.2333184,809.2456324,2018.5789063,0.4971838,0.9943677,2.3561945,1.9887353),(12217,'Alces_ulna.tif',242,4,51,368.1917217,85.4832992,59.3964009,1.8,85.5831234,59.7129044,1.0771012,31.3103728,31.4128353,20894.0374324,42185.5359637,47.5847839,1342.9394559,667.3199821,1448.885256,0.3515621,0.7861167,2.0344439,1.6974918),(12218,'Alces_ulna.tif',242,4,52,398.013498,85.8280836,59.7253031,1.8,84.2751066,59.6978817,0.7273771,27.6930627,28.9084386,26790.9178221,48389.2600035,29.3275653,1673.8800989,967.4234351,2072.4326797,0.988682,2.7457875,2.4468544,5.6749625),(12219,'Alces_ulna.tif',242,4,53,321.2041253,85.4283989,59.0178673,1.8,85.9732936,59.8337622,1.0334115,25.6552757,23.264435,14990.9718443,35064.2223773,39.5063641,1507.2028315,584.3231629,1717.0804391,0.3515621,0.7861167,2.0344439,1.6974918),(12220,'Alces_ulna.tif',242,4,54,300.2934998,85.1375841,58.976148,1.8,85.6533234,59.8006241,1.0872167,26.6207131,22.5637373,12184.2953865,31795.6476431,39.2293536,1409.1481058,457.699813,1525.3041035,0.3515621,0.4971838,2.3561945,0.9943677),(12221,'Alces_ulna.tif',242,4,55,288.726648,85.1593522,59.1674634,1.8,85.6625853,59.96503,1.0982652,23.6071836,22.0265043,10069.3280359,30390.4577657,38.1526372,1379.7222367,426.5366092,1423.8624073,29.2283208,43.0932493,2.4196928,271.9605973),(12222,'Alces_ulna.tif',242,4,56,276.4309551,85.2870355,59.3418082,1.8,85.7607273,60.0368344,1.0900573,25.1678831,22.1218296,8174.9554488,29526.1838018,36.2195614,1334.7080397,324.8169674,1320.1855457,0.3515621,0.4971838,2.3561945,0.9943677),(12223,'Alces_ulna.tif',242,4,57,270.6215366,85.5063417,59.6865558,1.8,86.3402543,60.3469746,1.0822932,22.050711,22.4680194,6898.4847215,29315.8649811,35.1696675,1304.7818974,312.8463624,1295.3435051,26.2817699,42.9424099,2.4489508,246.3775835),(12224,'Alces_ulna.tif',242,4,58,268.0478209,85.6197641,60.2503506,1.8,86.5372059,60.9769026,1.081441,16.3277266,22.3865984,6097.2496253,29460.0846297,34.8036153,1315.9696751,373.4291841,1288.332452,3.9387008,17.6097152,1.6307245,50.1716601),(12225,'Alces_ulna.tif',242,4,59,262.367504,85.6451523,60.6723809,1.8,86.5851425,61.2631589,1.075912,16.1612172,22.0429473,5415.9032019,28803.2636809,33.8647213,1306.6884065,335.1172823,1293.5677034,3.3282555,17.2587971,1.6319445,40.3132866),(12226,'Alces_ulna.tif',242,4,60,255.9639264,85.6045752,61.0593053,1.8,86.6400678,61.6491913,1.0726328,16.1763486,22.1333669,4875.2619361,27927.0804238,32.9210004,1261.7637671,301.3821012,1196.5282989,3.6957795,17.9847275,1.6490675,44.6673041),(12227,'Alces_ulna.tif',242,4,61,252.2459001,85.614013,61.572835,1.8,86.6653906,62.2652378,1.0712262,13.9706093,21.2510443,4421.4596116,27620.6847525,32.3931146,1299.733059,316.4829467,1296.3349142,0.9943677,2.2510956,2.4668517,4.6805948),(12228,'Alces_ulna.tif',242,4,62,250.6855208,85.6817186,62.140302,1.8,86.5823916,62.6850708,1.0618612,15.1764299,20.5973138,4095.1451096,27698.7339941,31.8617023,1344.7740921,269.8358656,1337.8323548,0.7031241,0.9943677,2.3561945,1.9887353),(12229,'Alces_ulna.tif',242,4,63,247.5625525,85.7356469,62.7074127,1.8,86.6711982,63.280269,1.0575326,13.9126518,20.9473327,3711.1407925,27495.2556125,31.3123858,1312.5898162,266.7457547,1272.2427744,0.3515621,0.7861167,2.0344439,1.6974918),(12230,'Alces_ulna.tif',242,4,64,244.8834432,85.7705454,63.2860848,1.8,86.6615802,63.934838,1.0567162,12.9657922,21.1812894,3404.4003024,26966.9031264,30.945005,1273.1473793,262.5678584,1270.9295975,3.586108,13.5248625,1.7273982,33.9851696),(12231,'Alces_ulna.tif',242,4,65,240.6442917,85.8898379,63.7505148,1.8,86.8751622,64.3272844,1.0524489,12.9027611,20.7250701,3202.526006,26186.9463557,30.26238,1263.539579,248.2047052,1235.5336767,1.0442585,5.7660465,2.226492,12.053049),(12232,'Alces_ulna.tif',242,4,66,234.5016138,85.9155295,64.2644463,1.8,86.8462148,64.6727058,1.0500178,13.5748023,20.3341256,2964.3942887,25237.4528807,29.4080044,1241.1378482,218.3747662,1212.7339854,0.3515621,0.4971838,2.3561945,0.9943677),(12233,'Alces_ulna.tif',242,4,67,230.5294668,85.9875051,64.8403937,1.8,86.9792884,65.2794054,1.0417263,13.1047076,20.3695261,2809.4557004,24537.5399324,28.6335606,1204.6200673,214.3852254,1222.6566547,0.9943677,3.9774707,2.3561945,8.1608816),(12234,'Alces_ulna.tif',242,4,68,225.0799371,86.0689986,65.4025192,1.8,87.0370982,65.9293121,1.0364622,10.7076126,19.8661596,2620.5824322,23779.1598128,27.7840926,1196.9681277,244.7401228,1193.6894911,18.1246135,38.0272511,2.1587989,212.3010484),(12235,'Alces_ulna.tif',242,4,69,220.2592483,86.1126677,65.9363574,1.8,87.0829017,66.4410067,1.0322823,10.865791,20.3311756,2436.6868777,23058.7243158,27.0542115,1134.1559742,224.2530596,1146.4081503,0.7031241,1.267575,2.1587989,2.6918595),(12236,'Alces_ulna.tif',242,4,70,215.1526035,86.1284427,66.4822372,1.8,87.0865877,67.0022859,1.0332335,11.8647603,20.3301951,2249.3684677,22186.3812427,26.4569874,1091.3019355,189.5839793,1084.3948701,5.2439199,16.6760528,1.8925469,51.7131811),(12237,'Alces_ulna.tif',242,4,71,208.3659536,86.0350246,66.8735554,1.8,86.9053179,67.3228794,1.0407325,10.6366985,19.988895,2001.1792626,20826.4019405,25.8505871,1041.8986087,188.1391357,1024.0140603,0.3515621,0.7861167,2.0344439,1.6974918),(12238,'Alces_ulna.tif',242,4,72,202.4626397,85.9044187,67.23708,1.8,86.6752088,67.6870408,1.0485527,10.5843428,19.5992069,1807.9659606,19461.2726923,25.3474007,992.9622533,170.8151366,988.878457,0.9943677,1.7578103,2.2142974,3.6862271),(12239,'Alces_ulna.tif',242,4,73,195.3793597,85.8987038,67.5932666,1.8,86.8623738,68.0086564,1.0513252,11.5833243,20.4450849,1709.0822986,18041.541626,24.5385447,882.4390681,147.546788,869.9616833,17.6331136,35.7575084,2.0960399,185.4823928),(12240,'Alces_ulna.tif',242,4,74,188.635032,85.7751912,67.9922294,1.8,86.7147655,68.3668122,1.0591654,11.1571652,20.2317924,1542.4563069,16758.360594,23.9029455,828.3181378,138.2480472,818.3037019,17.4724638,35.1034321,2.0837313,162.7325734),(12241,'Alces_ulna.tif',242,4,75,179.3383745,85.5030032,68.2638766,1.8,86.3930965,68.8780345,1.0768026,12.4639053,19.817863,1388.598879,15054.6887835,23.1700885,759.6524802,111.4096139,732.2740426,18.0646759,35.9660188,2.2592769,183.8702042),(12242,'Alces_ulna.tif',242,4,76,168.5672555,85.1994216,68.4358096,1.8,85.813395,68.7452733,1.0964115,11.5952687,19.9554385,1171.5583975,13158.0582287,22.2323843,659.3720404,101.0376238,650.6341734,17.9362378,33.5018538,2.0626055,214.6870285),(12243,'Alces_ulna.tif',242,4,77,162.0010182,85.0747037,68.8516511,1.8,85.616275,69.1456054,1.1037088,11.552297,19.7300087,1056.6924096,12016.3993111,21.5256409,609.0417656,91.4703295,608.138818,16.9460071,32.8837403,2.0727028,202.683949),(12244,'Alces_ulna.tif',242,4,78,156.5638481,85.0061514,69.3655833,1.8,85.5067917,69.7676899,1.1139845,11.8720726,18.4158887,966.6698405,11276.7020493,21.0171427,612.3354809,81.4238486,562.3500509,16.8300939,32.4067001,2.0684114,201.1923975),(12245,'Alces_ulna.tif',242,4,79,152.024059,84.9227311,69.8631361,1.8,85.3079976,70.2041611,1.1234951,11.6758747,18.1050397,844.4460859,10728.0262202,20.5970927,592.5436461,72.3240106,567.7728625,1.1458985,5.0703001,2.5535901,10.5614975),(12246,'Alces_ulna.tif',242,4,80,148.0834103,84.8693845,70.3688116,1.8,85.2028955,70.5667794,1.1304851,11.4691228,17.3889832,760.8973882,10267.0723143,20.1969888,590.4354621,66.3431196,529.4097973,4.4761886,25.0029593,2.0533096,67.3318202),(12247,'Alces_ulna.tif',242,4,81,144.4820135,84.9455261,70.9613704,1.8,85.351138,71.2273768,1.1377571,11.7748134,16.7353072,746.5319885,9846.4345422,19.840016,588.3629386,63.4007488,517.6752934,12.8639274,31.4544916,2.0094491,138.9737507),(12248,'Alces_ulna.tif',242,4,82,141.8300204,84.9522702,71.6085979,1.8,85.3022698,71.7749532,1.1458779,10.7753148,16.5727888,703.3627518,9608.0599375,19.6210685,579.7491313,65.2753787,521.6280131,14.9723873,31.4839479,1.9844855,197.9533847),(12249,'Alces_ulna.tif',242,4,83,139.6381411,84.9930012,72.269088,1.8,85.5923579,72.4038851,1.1495449,10.8918471,16.3012255,697.3356457,9414.0843031,19.3817383,577.507764,64.023635,534.921304,14.9489783,31.3442765,1.9742154,180.1900394),(12250,'Alces_ulna.tif',242,4,84,139.4313614,85.0149137,73.08678,1.8,85.4837018,73.4004613,1.161331,11.098683,17.5788863,683.4133891,9482.1830168,19.5552791,539.407494,61.5760796,514.099301,15.2065863,31.7283542,1.9451299,204.4167745),(12251,'Alces_ulna.tif',242,4,85,139.4355936,85.0930809,73.9516546,1.8,85.6875941,74.2856669,1.1687413,12.2213912,19.8527182,672.7040643,9711.2220626,19.6807818,489.1633455,55.0431661,502.8922389,11.7840919,32.2595308,1.927016,100.7345027),(12252,'Alces_ulna.tif',242,4,86,141.23691,85.1141683,74.8331715,1.8,85.6551028,75.3369911,1.1804654,13.0508171,19.1529151,693.4204191,9996.776962,20.1315318,521.9454549,53.1323374,527.1659573,11.6840642,32.3838086,1.9371907,108.2982615),(12253,'Alces_ulna.tif',242,4,87,141.5310307,85.0802801,75.6298084,1.8,85.4185846,75.9146274,1.196749,13.9482122,18.0122877,655.5166155,10107.7068817,20.4392782,561.1561972,46.9964614,535.1118115,11.2966818,32.1386183,1.9167636,139.2649942),(12254,'Alces_ulna.tif',242,4,88,143.9892779,85.0925006,76.5598612,1.8,85.2977449,76.9356349,1.2159462,11.6053772,16.5668114,686.295492,10563.7411356,21.1011156,637.644801,59.1359916,677.9110054,11.5919628,32.2595308,1.927016,137.0349849),(12255,'Alces_ulna.tif',242,4,89,143.0726834,85.258081,77.2945918,1.8,85.5121121,77.4525212,1.2209875,9.6328564,15.6942968,715.1131871,10328.543021,21.0446623,658.1080472,74.2368785,703.664161,11.3680347,31.6014989,1.9347753,150.8062237),(12256,'Alces_ulna.tif',242,4,90,139.9534229,85.2922852,77.8326825,1.8,85.540948,77.9522411,1.2183008,11.344974,15.5513765,690.8336688,9799.8986326,20.5453647,630.1627797,60.8933671,674.5631322,11.2287462,31.074984,1.9534035,95.4714208),(12257,'Alces_ulna.tif',242,4,91,140.2442103,85.4010734,78.6156186,1.8,85.946636,79.1350656,1.2167797,16.0594379,15.98628,787.3827524,9814.8839486,20.5649712,613.9567158,49.0292847,475.7845256,12.1188074,31.6679174,1.9698573,101.5935976),(12258,'Alces_ulna.tif',242,4,92,140.4608027,85.4938592,79.3556093,1.8,86.062928,79.6062669,1.2192223,15.3625954,15.6091426,817.3888773,9762.2699752,20.6338131,625.4200021,53.2064314,491.1276028,12.3371376,30.242512,1.8778421,130.0390774),(12259,'Alces_ulna.tif',242,4,93,138.9524461,85.5811213,79.9709087,1.8,86.186399,80.3323808,1.216533,15.0379858,15.678835,838.1253149,9515.8491312,20.3718351,606.923227,55.7338814,496.3137596,13.4714075,29.907581,1.8813949,90.0877019),(12260,'Alces_ulna.tif',242,4,94,136.6822894,85.6968528,80.46282,1.8,86.2600339,80.6767233,1.2074285,14.9012214,15.5251739,811.8463819,9144.1536225,19.9026192,588.9888039,54.4818684,491.1853573,17.1875077,30.7330398,2.1937054,218.8351057),(12261,'Alces_ulna.tif',242,4,95,134.2105964,85.7501434,80.9346161,1.8,86.1450259,81.1784726,1.2043841,15.715189,15.3294411,760.5641539,8684.5726077,19.4973089,566.5289793,48.3967551,461.5933938,13.4663497,29.4830433,2.1091708,134.6343689),(12262,'Alces_ulna.tif',242,4,96,132.9396937,85.8443866,81.4257499,1.8,86.2163378,81.6583399,1.1989812,12.0762161,15.168576,745.912832,8326.3929719,19.2321188,548.9238378,61.7670985,523.6707091,13.5639635,29.4830433,2.1091708,147.6464519),(12263,'Alces_ulna.tif',242,4,97,129.7405079,86.0620331,81.7783224,1.8,86.6934423,82.0007695,1.1850975,13.594778,15.1255525,785.0091395,7680.0954963,18.5630232,507.7563607,57.743432,458.4287993,17.4089283,30.6988372,2.2670009,216.9316737),(12264,'Alces_ulna.tif',242,4,98,125.0819918,86.1465123,82.0845207,1.8,86.868384,82.3651505,1.1756015,13.7583051,14.7932718,773.8846627,6984.8361713,17.7571454,472.1630388,56.2485463,401.7343542,13.6187487,28.6991805,2.1112158,83.5536445),(12265,'Alces_ulna.tif',242,4,99,121.8804465,86.2625165,82.480877,1.8,87.1186818,82.833191,1.1677752,13.3295243,14.5586285,786.2204494,6423.1360861,17.1887951,441.1910162,58.9833838,394.4278732,17.8232335,29.6335746,2.2974387,124.805267),(12266,'Alces_ulna.tif',242,4,100,117.2687845,86.3474033,82.7140961,1.8,87.2253112,83.0948783,1.1595061,13.7464931,14.3466062,736.5594112,5776.9351017,16.4208771,402.6691056,53.581623,344.6575375,17.7006346,29.1118011,2.3134854,197.0942898),(12267,'Alces_ulna.tif',242,4,101,111.9920268,86.4728084,82.8746416,1.8,87.432844,83.3323252,1.1406734,13.4560901,14.0519288,666.9990129,5176.4304676,15.4199128,368.3786422,49.5685603,314.0338384,3.1884693,18.4193023,1.801887,49.0213216),(12268,'Alces_ulna.tif',242,4,102,108.9823547,86.617757,83.1915927,1.8,87.5334737,83.6678818,1.1276962,12.5071659,13.786692,635.855897,4817.0153034,14.8248711,349.3960191,50.8393271,305.9981496,13.3219683,26.3483979,2.1180807,119.8894604),(12269,'Alces_ulna.tif',242,4,103,106.1634323,86.7532984,83.5010206,1.8,87.4197957,83.9535539,1.1188847,10.4919503,13.6432065,552.6911858,4523.6860095,14.3197715,331.5705882,52.6776406,332.085965,13.1849258,26.1317288,2.1550676,124.7406618),(12270,'Alces_ulna.tif',242,4,104,105.2758266,87.011046,83.9294801,1.8,87.6058607,84.3295636,1.0945778,10.0427806,13.6722863,510.4498648,4473.5365578,13.8586774,327.1974026,50.827543,337.5476271,2.3062562,14.5845299,1.8391625,40.4838932),(12271,'Alces_ulna.tif',242,4,105,104.9147019,87.3451279,84.3563967,1.8,87.7349027,84.5506756,1.0713241,10.0645272,13.7233342,518.0863629,4497.5911301,13.4744597,327.7331202,51.4764732,358.8674623,3.9840035,13.8141971,1.82812,44.9232139),(12272,'Alces_ulna.tif',242,4,106,109.7420574,87.8546483,85.4321152,1.8,87.8861338,85.714721,1.0659753,11.6114625,14.2930123,545.9762228,5285.5090662,14.0119005,369.7967196,47.0204528,407.7259134,5.8559022,17.8605983,1.7488893,81.2383318),(12273,'Alces_ulna.tif',242,4,107,110.2653923,88.0994974,85.9759345,1.8,88.032071,86.0416677,1.0622702,11.152784,14.2365753,545.3250414,5414.5510318,14.020938,380.3267941,48.8958669,417.8797817,6.2153466,18.1489125,1.7263912,76.4724338),(12274,'Alces_ulna.tif',242,4,108,108.0098049,88.1878089,86.2567649,1.8,88.1169661,86.2367257,1.063506,12.3895917,14.0822035,515.6228826,5163.4608915,13.7530332,366.6656917,41.6174235,403.1783022,0.3515621,0.4971838,2.3561945,0.9943677),(12275,'Alces_ulna.tif',242,4,109,105.3016693,88.2560018,86.4578537,1.8,88.2542754,86.5483528,1.0546704,11.6271617,13.8087527,503.6765739,4824.1884049,13.2757944,349.3572898,43.3189618,385.5338569,0.3515621,0.4971838,2.3561945,0.9943677),(12276,'Alces_ulna.tif',242,4,110,102.3606866,88.3561023,86.6784686,1.8,88.3543218,86.7220828,1.0454445,11.0344174,13.563749,474.6530456,4553.5635212,12.7691599,335.715702,43.015687,370.0296772,0.7031241,0.9943677,2.3561945,1.9887353),(12277,'Alces_ulna.tif',242,4,111,99.5779066,88.4407157,86.9032681,1.8,88.4339878,86.9106207,1.0406898,10.6586853,13.3153426,413.7732114,4303.9768643,12.3533549,323.2344069,38.820286,353.2054685,0.3515621,0.4971838,2.3561945,0.9943677),(12278,'Alces_ulna.tif',242,4,112,96.9918687,88.4957752,87.0757885,1.8,88.4956558,87.083079,1.0342223,10.5977707,12.8803612,378.6792348,4036.0313695,11.940996,313.3476862,35.7319711,342.0531607,5.1111984,12.6220083,1.7955075,50.1363263),(12279,'Alces_ulna.tif',242,4,113,91.691141,88.4918174,86.9439696,1.8,88.6531573,86.9915573,1.0340526,11.3228722,12.2830229,388.2810072,3452.6896374,11.2861255,281.0944563,34.2917417,311.903285,5.2734309,14.4311837,1.6195382,54.6109808),(12280,'Alces_ulna.tif',242,4,114,87.273899,88.4439224,86.9522636,1.8,88.5712369,87.0494279,1.0300955,11.0250068,11.6590734,363.0074299,3037.9714903,10.6917192,260.5671472,32.9258236,290.9465699,0.3515621,0.4971838,2.3561945,0.9943677),(12281,'Alces_ulna.tif',242,4,115,84.9152027,88.5253386,87.1431519,1.8,88.6693603,87.1964054,1.0186986,10.9037208,11.3728367,353.1751873,2869.6374046,10.259548,252.3238034,32.3903366,282.5100934,5.4010697,12.0355463,1.4536876,41.5282303),(12282,'Alces_ulna.tif',242,4,116,83.9201809,88.6857673,87.489968,1.8,88.7716018,87.4999161,1.0105168,10.1593594,12.2546233,341.0187693,2861.4263865,10.0367084,233.4977026,33.5669559,260.5941109,6.23443,12.4295959,1.4288993,57.4734468),(12283,'Alces_ulna.tif',242,4,117,82.0207744,88.7832861,87.713309,1.8,88.8191696,87.7081009,1.0028611,10.3882231,12.0205637,321.6266899,2730.9340038,9.7149723,227.188514,30.960703,253.293192,6.4780298,14.786518,2.066348,52.9634585),(12284,'Alces_ulna.tif',242,4,118,80.1007685,88.9470853,87.9712496,1.8,89.0115154,88.0060771,0.9831913,9.7096361,12.5093084,302.423747,2667.9132753,9.247295,213.2742418,31.1467641,235.0207139,6.693233,13.6928797,2.301703,57.7293566),(12285,'Alces_ulna.tif',242,4,119,77.6400494,88.9897549,88.0532531,1.8,89.1148193,88.1249792,0.9737402,9.5856697,12.433987,259.1478084,2497.7115454,8.8499237,200.8777673,27.0349193,219.6859137,3.8430459,8.0245532,2.0736395,28.4101461),(12286,'Alces_ulna.tif',242,4,120,73.8314236,88.8696995,87.9003629,1.8,89.2121922,87.9479543,0.9663881,8.2734574,11.551732,234.661611,2126.6745912,8.3314239,184.1000627,28.3631858,204.0823083,4.5206977,8.0245532,2.0736395,36.4857244),(12287,'Alces_ulna.tif',242,4,121,70.5185296,88.8076595,87.7354298,1.8,89.1500463,87.891633,0.9637161,8.5496372,10.4569615,248.8491089,1789.3592932,7.9281851,171.1165607,29.106394,194.5842102,13.6560576,20.5746421,2.1493205,145.807625),(12288,'Alces_ulna.tif',242,4,122,68.2487848,88.8195626,87.7654278,1.8,89.3388939,87.9633895,0.9567833,9.1126441,10.4295563,241.9704449,1630.8289794,7.5989193,156.3660945,26.5532641,179.3226599,4.0577569,6.0689021,1.3961241,24.8092222),(12289,'Alces_ulna.tif',242,4,123,65.3772405,88.7772515,87.7382083,1.8,89.1809547,87.7880008,0.942513,8.3819073,9.4232354,231.0237717,1452.639304,7.1320244,154.1550475,27.562196,171.9960783,4.2629819,8.0245532,2.0736395,37.4800921),(12290,'Alces_ulna.tif',242,4,124,62.9672706,88.783489,87.7292474,1.8,89.2406239,87.9021725,0.9237675,8.24615,9.3766337,214.9933421,1337.5254543,6.6809313,142.6445238,26.0719659,158.5947165,0.3515621,0.7861167,2.0344439,1.6974918),(12291,'Alces_ulna.tif',242,4,125,60.5465142,88.7790294,87.6795412,1.8,89.3210998,87.7412081,0.9103001,7.8635014,9.2100823,192.3919503,1225.5817859,6.292871,133.0695801,24.4664484,150.504115,3.9087976,10.4881045,2.2612428,34.7882327),(12292,'Alces_ulna.tif',242,4,126,59.2929148,88.8021272,87.7466349,1.8,89.2501626,87.8709839,0.8942983,7.7663929,9.1520993,181.3077489,1171.7575568,6.0087559,128.0315611,23.3451683,144.4706669,0.3515621,0.4971838,2.3561945,0.9943677),(12293,'Alces_ulna.tif',242,4,127,59.4672974,88.8753123,87.8618142,1.8,89.3571826,87.9371545,0.8907932,6.8096584,9.0182167,173.9161914,1165.3489562,5.9924826,129.2216632,25.5396352,144.9107815,2.9955362,4.781761,2.1995926,15.6539729),(12294,'Alces_ulna.tif',242,4,128,59.5293575,88.8990541,87.9211726,1.8,89.2874457,87.9629061,0.8759527,6.8763988,8.9635989,174.119159,1137.9350027,5.8543187,126.9506827,25.3212712,142.7661966,11.4851501,17.6552773,2.1864162,115.8352599),(12295,'Alces_ulna.tif',242,4,129,57.8417119,88.974015,87.7818882,1.8,89.4592946,87.7802766,0.8558571,7.4913008,8.424288,181.5919534,1031.689718,5.497141,122.4661024,24.2403767,127.2837181,0.4971838,0.9943677,2.3561945,1.9887353),(12296,'Alces_ulna.tif',242,4,130,56.7584127,88.9901579,87.7917278,1.8,89.4923584,87.8625211,0.839199,6.8300777,8.4298985,173.3589726,988.637058,5.2378277,117.2774571,25.3816984,134.3048061,3.1890584,5.7660465,2.485897,21.9967257),(12297,'Alces_ulna.tif',242,4,131,56.0414817,88.9451099,87.7211182,1.8,89.4226046,87.6911163,0.8179143,7.0100733,8.2824628,180.6016285,921.2133014,4.9736181,111.2245621,25.7631584,124.7502861,3.1883685,5.7230157,2.3127436,21.0376918),(12298,'Alces_ulna.tif',242,4,132,55.358783,88.9342735,87.7055415,1.8,89.3589119,87.7544503,0.8027905,6.7041082,8.0857341,176.75681,876.3518747,4.7736695,108.382475,26.3654471,111.0556532,0.3515621,0.4971838,2.3561945,0.9943677),(12299,'Alces_ulna.tif',242,4,133,53.6512497,88.920735,87.5438561,1.8,89.6351513,87.6285374,0.7480755,6.2345811,9.6029281,173.315478,818.1850079,4.1375129,85.2016177,27.7990576,96.5384452,3.088698,9.0043822,2.4668517,22.9411239),(12300,'Alces_ulna.tif',242,4,134,52.9169029,88.905122,87.4856095,1.8,89.3900745,87.5288863,0.727364,6.3528013,8.967755,168.5628895,777.9368427,3.899059,86.7482267,26.5336317,99.3889872,10.3790539,17.6552773,2.9207639,98.0719146),(12301,'Alces_ulna.tif',242,4,135,51.7269742,88.9036649,87.3710563,1.8,89.5125041,87.4234221,0.6921163,5.4018686,9.1956586,155.3364733,741.3077004,3.5110399,80.6149655,28.7560627,91.7940486,2.4859192,4.7297838,2.4087776,13.0474167),(12302,'Alces_ulna.tif',242,4,136,52.3315079,88.9412993,87.3706125,1.8,89.5554833,87.4287805,0.6737314,5.7766073,9.2255355,156.5686339,757.5468842,3.3950869,82.1141367,27.1039082,93.9212966,2.5762408,7.9003747,2.5782764,20.3345677),(12303,'Alces_ulna.tif',242,4,137,52.9874275,89.4113843,87.3548912,1.8,90.4395376,87.390033,0.5957734,5.430398,11.4705583,153.9694681,917.1339323,2.7808531,79.9554747,28.3532567,84.398281,2.7345111,4.40506,2.6422459,12.3796264),(12304,'Alces_ulna.tif',242,4,138,53.3499379,89.4780888,87.4058943,1.8,90.2619542,87.4706043,0.5895964,6.2671774,12.1012223,158.5792298,954.0798942,2.748984,78.8416138,25.3031339,81.7117557,2.673866,4.2769371,1.4056476,14.6596052),(12305,'Alces_ulna.tif',242,4,139,54.0563446,89.5762232,87.5051139,1.8,90.2798483,87.5965921,0.6126777,6.2268553,10.9537136,163.6265765,1014.637007,2.9793533,92.6294994,26.2775619,94.561621,2.8085285,3.9305833,1.7506498,13.6652376),(12306,'Alces_ulna.tif',242,4,140,51.7825923,89.3037738,87.2766733,1.8,89.9699593,87.3620355,0.6238615,6.1150821,10.7504723,154.2048913,897.2507741,2.945211,83.4615218,25.2171418,85.0143537,2.8124965,4.0084242,2.2318395,15.1567891),(12307,'Alces_ulna.tif',242,4,141,48.6766278,88.9777831,86.9333995,1.8,89.7292938,86.9449055,0.6177646,5.5655289,9.4951343,137.2199553,744.1871886,2.7217477,78.3756358,24.6553305,82.484045,9.5034603,18.4025193,3.026716,91.6791923),(12308,'Alces_ulna.tif',242,4,142,48.7075642,88.9104581,86.86571,1.8,89.6441748,86.9080507,0.609977,5.8258403,10.1248745,138.0535498,754.6216358,2.6639428,74.5314561,23.6967616,76.4189604,8.8167159,18.2338401,2.8076476,51.592544),(12309,'Alces_ulna.tif',242,4,143,48.5458783,88.8029888,86.7929939,1.8,89.5564836,86.8789733,0.6318895,5.8638416,9.1565814,132.2168463,745.7344956,2.8228747,81.442458,22.5478203,87.0073498,8.8167159,17.4546226,2.8134728,60.4565498),(12310,'Alces_ulna.tif',242,4,144,45.3272543,88.3948891,86.405701,1.8,89.1551754,86.4799326,0.6320164,5.4540529,8.7317795,118.5691329,602.444393,2.6366305,68.9944579,21.7396373,76.2440068,1.9521967,3.4802868,2.3561945,8.3668219),(12311,'Alces_ulna.tif',242,4,145,43.2033527,88.1125983,85.9457881,1.8,89.0337912,85.9685804,0.6011292,5.8138401,9.7969024,126.0307928,504.2874328,2.3032716,51.4741712,21.6777193,56.7978235,0.6292499,1.267575,2.5535901,2.4859192),(12312,'Alces_ulna.tif',242,4,146,42.7561603,88.0363345,85.83991,1.8,89.0295209,85.8949512,0.6087666,6.5381933,11.1208962,124.4614652,515.6757073,2.3303486,46.3699777,19.0360638,49.6212023,0.3515621,0.4971838,2.3561945,0.9943677),(12313,'Alces_ulna.tif',242,4,147,43.1536896,87.9681612,85.7540333,1.8,88.9487258,85.782905,0.6148384,6.11753,10.8146488,128.8005558,545.3770048,2.3930797,50.4294699,21.0543398,54.7633006,0.3515621,0.7861167,2.677945,1.4915515),(12314,'Alces_ulna.tif',242,4,148,44.6070648,87.9722962,85.7365049,1.8,89.1209823,85.7353051,0.6121586,6.5280486,11.4125045,139.6484561,609.5756586,2.4549189,53.4129609,21.3920676,57.6007756,2.4609344,3.3166298,2.1293956,14.1624214),(12315,'Alces_ulna.tif',242,4,149,44.0687486,87.617909,85.5171984,1.8,88.6815298,85.5115555,0.6417123,7.0321472,12.2015353,146.2742413,566.9377025,2.6315188,46.4644563,20.8007935,50.6437645,9.9376151,21.4712049,3.0924519,104.605972),(12316,'Alces_ulna.tif',242,4,150,45.2367671,87.4379444,85.3885265,1.8,88.6349288,85.3955069,0.6363781,7.4621012,12.533894,166.5964061,589.4339666,2.6627596,47.0272021,22.3256696,51.8289437,10.1234886,22.5685319,3.063626,107.2125282),(12317,'Alces_ulna.tif',242,4,151,42.8487823,87.015179,84.9551046,1.8,87.9951196,84.8169622,0.6767468,8.0323994,11.78114,140.3487434,504.7786847,2.8008947,42.8463363,17.4728293,46.1890964,9.8991218,21.8676123,3.0611216,112.0990633),(12318,'Alces_ulna.tif',242,4,152,45.2320855,86.9244664,84.8715311,1.8,87.8371298,84.7585746,0.665527,7.5023385,11.9875292,154.6659645,586.6903675,2.874302,48.9417256,20.6157008,52.7033032,2.7456441,4.2913618,2.1815223,15.4480326),(12319,'Alces_ulna.tif',242,4,153,47.2865487,86.8383,84.5906256,1.8,88.2331107,84.4641861,0.6177885,9.9032533,13.3800291,198.4063986,658.0712363,2.6441998,49.1830946,20.0344668,54.0703714,0.3515621,0.4971838,2.3561945,0.9943677),(12320,'Alces_ulna.tif',242,4,154,48.3234807,86.5240124,84.3740054,1.8,87.724897,84.2235798,0.6241436,8.4912583,14.1982389,209.1417298,674.3656449,2.7506235,47.4964288,24.6302399,53.4047097,3.7418525,6.2197678,2.3162158,23.7295513),(12321,'Alces_ulna.tif',242,4,155,49.0632956,86.2422428,84.0311431,1.8,87.6144441,83.7614844,0.6275975,9.4883201,14.263486,222.8791301,715.6333032,2.8195528,50.1723983,23.489841,54.7840693,10.3440687,23.2270538,0.0454233,116.8149919),(12322,'Alces_ulna.tif',242,4,156,46.4170703,85.5856115,83.4285016,1.8,86.8858323,83.1671212,0.6764636,9.7287289,13.6297733,207.2717323,636.9444229,3.032003,46.7318427,21.3051195,50.4138689,10.417958,21.1054391,0.033321,114.9822273),(12323,'Alces_ulna.tif',242,4,157,47.7812693,85.2821375,83.1621871,1.8,86.6266441,82.9350599,0.7035401,13.0033832,17.7457282,218.6729586,724.0552284,3.3327998,40.8016633,16.8166204,42.8513324,3.3839475,8.7890515,1.8545904,27.948296),(12324,'Alces_ulna.tif',242,4,158,43.9402463,84.2996872,82.4983716,1.8,85.6607448,82.3618405,0.8437638,16.4674688,13.8670699,201.1576398,624.9809442,4.0881502,45.0694305,12.215456,38.374313,0.3515621,0.7861167,2.677945,1.4915515),(12325,'Alces_ulna.tif',242,4,159,46.8414911,83.9878708,82.3577312,1.8,85.1284042,82.3746276,0.8715203,14.3766266,15.186609,210.6329206,807.1394662,4.5724863,53.1481034,14.651067,48.6688128,0.3515621,0.4971838,2.3561945,0.9943677),(12326,'Alces_ulna.tif',242,4,160,45.4272546,83.1634196,81.747963,1.8,83.8450814,81.9147834,0.9928378,13.5985848,10.3271327,149.5858039,794.1848878,5.311504,76.9027486,11.0001008,55.2706014,0.6846402,2.2510956,2.4668517,4.4746545),(12327,'Alces_ulna.tif',242,4,161,44.8654551,82.6029769,80.8701119,1.8,83.4007337,80.9629749,0.9755713,16.0191711,12.10803,154.8862591,862.5699015,5.1267829,71.2394914,9.6688061,50.6693839,0.7031241,0.9943677,2.3561945,1.9887353),(12328,'Alces_ulna.tif',242,4,162,43.4762749,81.8385123,80.1485932,1.8,82.4644649,80.4415355,0.9988639,20.0149881,11.970604,134.8859583,868.2273815,5.1232433,72.5299559,6.7392475,44.8642305,1.3644767,2.2510956,2.2455373,6.5840269),(12329,'Alces_ulna.tif',242,4,163,43.8769502,81.3509133,79.5538503,1.8,82.4411081,79.9637857,0.9629034,15.6763384,12.9260073,143.9585532,988.8551723,4.9273824,76.5012077,9.1831747,55.7536458,1.0546862,2.6774169,1.9756881,6.2074801),(12330,'Alces_ulna.tif',242,4,164,45.294183,80.8940237,79.1383477,1.8,82.1827578,79.6256378,0.9343563,14.438135,14.1214661,161.2070409,1219.2914494,4.8824448,86.3431203,11.1653645,68.3552853,1.3348407,2.35835,2.0344439,5.6749625),(12331,'Alces_ulna.tif',242,4,165,44.1777377,80.0772543,78.4338691,1.8,81.0245942,79.0559287,0.9652473,14.2930325,13.6234163,125.2324659,1251.5158025,4.9773286,91.8650486,8.7617842,70.0091526,0.7031241,1.8932196,1.1902899,4.0981077),(12332,'Alces_ulna.tif',242,4,166,45.4307378,79.5373863,77.8882191,1.8,80.7225767,78.5816293,0.9438997,15.6840282,14.446214,143.2830935,1439.1544079,4.9660356,99.6215626,9.1356054,74.7418697,0.8532564,4.0084242,1.8370484,8.8993395),(12333,'Alces_ulna.tif',242,4,167,45.2695762,78.6687525,77.0567197,1.8,79.7724025,77.8511901,0.9597701,18.1568681,16.502066,126.1821638,1485.8923901,5.0615818,90.0428099,6.9495556,65.7037972,7.8013442,23.280205,2.2384619,55.0228614),(12334,'Alces_ulna.tif',242,4,168,45.1340327,77.5929467,75.9192569,1.8,78.69771,76.6776896,0.9841785,17.8439785,16.5256094,133.8605029,1350.8449819,5.2173832,81.7425216,7.5017185,61.0466329,9.0035823,24.4076249,2.4173427,62.1040721),(12335,'Alces_ulna.tif',242,4,169,45.8805519,76.6655542,74.7283496,1.8,77.8637111,75.5219566,0.9882197,24.181061,19.4847965,172.6664859,1319.0474459,5.3321223,67.6962391,7.140567,48.0353789,0.3515621,0.7861167,2.0344439,1.6974918),(12336,'Alces_ulna.tif',242,4,170,47.1632524,75.7157612,73.8229845,1.8,76.4272009,74.7385075,1.0398844,17.0408228,15.0800803,136.3181926,1309.8992429,5.8454147,86.8628825,7.9995077,73.9351279,0.7031241,1.267575,2.1587989,2.6918595),(12337,'Alces_ulna.tif',242,4,171,50.8448741,74.9170059,73.1363764,1.8,75.653803,74.2714061,1.0646245,15.5934977,15.8719181,171.7103999,1416.0460577,6.4821899,89.2170717,11.0116667,72.9834354,9.4888327,25.615826,2.3270765,85.8189876),(12338,'Alces_ulna.tif',242,4,172,53.3506121,74.0337149,72.3639215,1.8,74.4988257,73.4045888,1.0961782,12.9899334,15.0393955,182.5853422,1502.6017264,7.0347413,99.9110454,14.0559106,84.7993594,0.7031241,1.5722333,2.0344439,3.3949836),(12339,'Alces_ulna.tif',242,4,173,55.4296446,73.1991868,71.5934732,1.8,73.6722664,72.749851,1.1054625,17.1454756,15.8300202,218.0133062,1618.1772854,7.378141,102.2220605,12.7155007,78.6857585,0.3515621,0.4971838,2.3561945,0.9943677),(12340,'Alces_ulna.tif',242,4,174,57.5574414,72.3576469,70.9250238,1.8,72.582998,72.0796566,1.1298719,23.2574111,19.2390865,259.923179,1663.7722374,7.8456792,86.4787544,11.1759292,63.7331368,9.8545451,22.0365202,2.1632237,71.0034116),(12341,'Alces_ulna.tif',242,4,175,61.3050558,71.607049,70.3295667,1.8,72.0195954,71.677028,1.1306494,26.0738845,20.8099914,339.08789,1918.7524923,8.3626467,92.2034254,13.0048858,67.6806531,0.8898938,1.5722333,2.0344439,3.6862271),(12342,'Alces_ulna.tif',242,4,176,68.5112201,70.9080124,69.8543429,1.8,71.4785319,71.4686995,1.123221,27.6108263,22.6595766,478.6768796,2441.8573286,9.2798523,107.7627076,17.3365648,82.0350391,11.48158,23.7037314,2.1875976,60.7684914),(12343,'Alces_ulna.tif',242,4,177,76.9710586,70.1340814,69.032579,1.8,70.4390438,70.4650641,1.1607983,25.42007,17.8525874,584.6289279,3021.5288733,10.7902142,169.2487936,22.9987143,116.1831982,12.3301302,25.2587004,2.1781016,69.5118601),(12344,'Alces_ulna.tif',242,4,178,82.0576284,69.5204342,68.5672239,1.8,70.0691605,70.2024931,1.1839313,25.9647226,17.8681253,704.4640122,3475.1152641,11.7295157,194.4868426,27.1315825,135.5325276,12.8028734,25.7217565,1.9487646,71.9977793),(12345,'Alces_ulna.tif',242,4,179,85.6569278,68.8713662,67.8258987,1.8,69.5857467,69.4760025,1.1797439,16.689739,16.909644,803.6185344,3623.387098,12.2020551,214.2793243,48.1504554,186.9683524,13.3277928,26.4513949,1.9809237,68.929373),(12346,'Alces_ulna.tif',242,4,180,91.9943254,68.3146443,67.0994091,1.8,69.2951902,68.4858616,1.1579262,18.933011,18.8909009,956.5094985,3786.4323657,12.8639732,200.436834,50.520728,178.1851506,13.9194699,27.3586671,2.0229502,71.5359292),(12347,'Alces_ulna.tif',242,4,181,82.5562442,67.2859002,65.3166635,1.8,68.6664125,66.7720465,1.1541585,22.401874,21.7866721,949.6055301,2979.2839139,11.5059663,136.7480033,42.3895578,126.5518212,14.6532192,26.8893271,2.0169019,105.4357955),(12348,'Alces_ulna.tif',242,4,182,75.1004537,65.7907057,62.9279273,1.8,66.3480343,63.3513411,1.4870474,31.6792593,12.8921722,717.4672339,1700.0369756,12.4291563,131.8658289,22.6478538,70.6829196,14.0351429,22.3483995,1.9074711,90.4642487),(12349,'Alces_ulna.tif',242,4,183,72.3688349,65.0320114,61.1649552,1.8,65.4439078,61.1790389,-1.5472083,28.071314,12.004331,742.1297998,1384.4299766,12.0547628,115.3275409,26.4373018,69.6539465,14.3377479,20.6016567,2.0115472,64.5899912),(12350,'Alces_ulna.tif',242,4,184,71.3862101,64.406946,59.792851,1.8,65.3358498,60.1007859,1.447644,40.6381139,18.0262623,964.0756706,1365.3666316,11.7181655,75.743191,23.7234354,52.6939793,16.132165,21.4193351,1.9756881,87.9576314),(12351,'Alces_ulna.tif',242,4,185,68.3600211,64.0867958,57.5429186,1.8,64.7368665,57.3486326,1.1619079,27.4525817,26.5785257,651.3263933,1148.9063067,9.5923061,43.2268636,23.7255061,47.1132383,1.4062482,4.624077,1.7234457,11.0940151),(12352,'Alces_ulna.tif',242,4,186,56.2661266,63.4406973,55.2397418,1.8,63.8975091,55.1258147,0.9794815,22.0114933,33.7820803,441.5235596,927.9135781,6.4635346,27.4676269,20.0587736,33.9638764,2.0839756,7.06631,1.4711277,20.540508),(12353,'Alces_ulna.tif',242,4,187,60.5294355,62.406312,53.7755704,1.8,62.625934,53.5168559,1.3021994,38.053314,27.9905786,549.1794265,935.4693436,9.3777649,33.4208648,14.4318423,31.428426,13.6914607,17.6552773,0.9551764,82.6799138),(12354,'Alces_ulna.tif',242,4,188,81.1150413,62.0755403,54.9668711,1.8,63.3753038,54.9119609,1.1968845,40.8794912,32.9020857,1437.3442559,2298.1839316,11.715517,69.8491869,35.1605222,71.1861129,2.4464873,8.5031518,1.0516502,21.9467562),(12355,'Alces_ulna.tif',242,4,189,83.995125,61.436568,54.8097057,1.8,61.6721072,54.1697591,1.5037681,11.7280277,10.5541065,946.9631227,2519.1237138,13.9363864,238.686593,80.7435952,268.7720612,18.247583,22.2486294,1.0222469,75.6693707),(12356,'Alces_ulna.tif',242,4,190,112.3403425,61.8429262,56.7187333,1.8,62.5341442,56.0936229,1.3775165,16.7644901,13.0021748,2599.4034902,4054.1014166,18.0326056,311.8017941,155.0541336,373.4742829,2.7822265,11.3211718,0.9397169,29.5251508),(12357,'Alces_ulna.tif',242,4,191,130.2077752,62.002239,57.4586013,1.8,62.9453297,56.9455016,1.4179209,17.9918814,13.9640265,3036.6645468,4858.4249691,21.198056,347.9243593,168.7797115,424.2734187,2.0951463,8.4667356,0.844154,21.3289354),(12358,'Alces_ulna.tif',242,4,192,143.8913375,60.8146901,58.8033661,1.8,61.7031637,57.9293834,-1.23956,27.3294263,14.1876637,3209.9877055,6467.9720926,21.4454907,455.8870451,117.4553636,327.017113,1.7247483,6.7532867,0.8960554,17.5220712),(12359,'Alces_ulna.tif',242,4,193,145.5697696,61.1053314,59.0254764,1.8,62.0866881,58.1288304,-1.1901088,16.7866486,14.2221097,2966.39239,6211.9123463,20.9121646,436.7785417,176.711413,499.913542,2.0216079,9.0043822,0.8960554,22.202666),(12360,'Alces_ulna.tif',242,4,194,153.1298301,60.9997204,59.7982239,1.8,61.7839775,58.8881725,-1.1039527,15.0550001,15.7813934,2480.943121,7199.2980208,20.3519006,456.1889978,164.7919694,579.6580773,3.6994652,14.1194957,1.2411719,41.7841401),(12361,'Alces_ulna.tif',242,4,195,145.4004058,61.859447,59.6275716,1.8,62.6415734,58.9066416,-1.1756326,13.4798958,13.8324573,2165.1466257,5727.4615369,20.6421645,414.0595844,160.6204275,543.6581202,2.8333636,11.2334944,1.2193515,27.7423557),(12362,'Alces_ulna.tif',242,4,196,144.8255352,62.8058619,59.5920893,1.8,63.4458837,59.2856841,-1.3393639,12.6010459,13.6081115,2325.1611473,4868.3877006,22.8676743,357.7563067,184.5212822,524.4876454,19.4671904,26.5935263,1.1485452,124.1228409),(12363,'Alces_ulna.tif',242,4,197,114.6665668,63.0989056,58.3705487,1.8,63.38612,58.7285288,-1.4677743,8.5367409,12.1004379,1213.8746417,3142.6857936,18.9089748,259.7166987,142.194153,359.4334321,15.4925658,23.9604439,1.1793912,102.623299),(12364,'Alces_ulna.tif',242,4,198,73.8871541,62.9290783,56.7570005,1.8,63.3739899,56.5727425,-1.4163102,7.3097901,10.0966271,446.5379261,1330.5878732,12.0229581,131.7853836,61.0876539,175.9927731,0.8532564,3.3352106,1.2490458,7.2018477),(12365,'Alces_ulna.tif',242,4,199,44.5891622,62.6819544,56.2942326,1.8,62.9420693,55.9179483,-1.3773548,4.7519806,8.4387856,150.9888091,508.5287871,7.1568934,60.2608965,31.7738692,77.5635456,8.4435449,15.6790373,1.2277724,46.7766765),(12366,'Alces_ulna.tif',242,4,200,19.7834686,62.6656749,56.3498175,1.8,62.5956249,56.0501785,-1.3572964,2.9755539,6.0688915,32.3056391,120.5686753,3.1492187,19.8666718,10.8570171,25.0304412,6.2672216,11.8961038,1.2397003,31.3786134),(12367,'Alces_ulna.tif',242,4,201,0.7323618,63.2588589,56.2525007,1.8,63.2182046,56.2814129,-1.3835974,1.1456731,2.1446272,0.2253799,0.8657167,0.1178326,0.4036677,0.1967227,0.5087216,2.4609344,4.6904229,1.3439975,11.3852587),(12368,'Alces_ulna.tif',242,4,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12369,'Alces_ulna.tif',242,4,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12370,'Alces_ulna.tif',242,4,204,14.7216554,116.007331,88.0025835,1.8,115.8068699,88.0351293,-1.1187617,3.1858753,7.7562649,15.7635451,153.2970661,1.9854818,19.7642896,4.947948,21.7934531,5.750292,15.1335115,1.0343609,34.4823534),(12371,'Alces_ulna.tif',242,4,205,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12372,'Alces_ulna.tif',242,4,206,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12373,'Alces_ulna.tif',242,4,207,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12374,'Alces_ulna.tif',242,4,208,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12375,'Alces_ulna.tif',242,4,209,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12376,'Alces_ulna.tif',242,4,210,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12377,'Alces_ulna.tif',242,4,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12378,'Alces_ulna.tif',242,4,212,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12379,'Alces_ulna.tif',242,4,213,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12380,'Alces_ulna.tif',242,4,214,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12381,'Alces_ulna.tif',242,4,215,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12382,'Alces_ulna.tif',242,4,216,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12383,'Alces_metacarpus.tif',242,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12384,'Alces_metacarpus.tif',242,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12385,'Alces_metacarpus.tif',242,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12386,'Alces_metacarpus.tif',242,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12387,'Alces_metacarpus.tif',242,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12388,'Alces_metacarpus.tif',242,5,6,0.010293,151.656112,167.728363,1.8,151.656112,167.728363,0.7853982,0,0,0.0001457,0.0001457,0.0008577,0,0,0,0.412109,0.5828101,2.3561945,1.1656203),(12389,'Alces_metacarpus.tif',242,5,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12390,'Alces_metacarpus.tif',242,5,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12391,'Alces_metacarpus.tif',242,5,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12392,'Alces_metacarpus.tif',242,5,10,0.0208432,53.3655716,133.9333899,1.8,53.3681155,133.935425,0.6764977,0.0023236,1.3226483,0.0002951,0.0365785,0.0013616,0.0276555,0.1270016,0.0278786,0,0,0,0),(12393,'Alces_metacarpus.tif',242,5,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12394,'Alces_metacarpus.tif',242,5,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12395,'Alces_metacarpus.tif',242,5,13,0.0216667,149.9450276,168.0788025,1.8,149.595567,168.140472,-0.1744087,0.0019677,7.4689644,0.0003067,1.0941392,0.0001087,0.1464914,0.1558737,0.1465325,0,0,0,0),(12396,'Alces_metacarpus.tif',242,5,14,0.0216667,153.9192854,167.316254,1.8,153.9227115,167.316254,0.2940651,0.0607169,0.2004883,0.0003839,0.0011491,0.0003034,0.0057313,0.0063229,0.007318,0.412109,0.9215037,2.677945,1.7484304),(12397,'Alces_metacarpus.tif',242,5,15,0.0946438,153.1062247,167.4672934,1.8,153.0984935,167.4707949,-0.1655321,0.1842018,1.4733092,0.0024102,0.0852618,0.0004283,0.0578709,0.0130843,0.0595021,0.8090748,3.3983379,0.2449787,7.0351407),(12398,'Alces_metacarpus.tif',242,5,16,0.5099132,132.8252097,150.2467974,1.8,134.7930572,152.0904972,0.7553802,2.4607586,27.5114728,0.5557416,191.3925141,0.0399432,6.9568254,0.2258416,6.9492827,0,0,0,0),(12399,'Alces_metacarpus.tif',242,5,17,37.1295346,123.8651811,139.202787,1.8,124.7049968,139.0684866,0.5355601,19.1120627,41.5142173,655.9377352,919.9508408,1.6116035,22.1598985,34.3206145,37.4868515,15.3294021,20.2101548,1.5300026,85.4387887),(12400,'Alces_metacarpus.tif',242,5,18,84.4141543,125.5209223,136.3651013,1.8,124.5780589,137.2321053,-0.2316978,36.5986692,51.3040831,1981.6262637,12443.9533788,0.7418609,242.552885,54.1447629,279.1906445,18.9061305,30.9713006,0.4398426,158.8799723),(12401,'Alces_metacarpus.tif',242,5,19,113.5106519,119.9400147,136.8561816,1.8,119.543205,138.3394965,-0.2522932,37.8244133,47.8162992,5733.8046647,52337.255527,1.1788605,1094.5484354,151.5900489,1191.726782,1.236327,3.5210608,1.2120257,7.6179508),(12402,'Alces_metacarpus.tif',242,5,20,317.4827775,106.144775,137.6014275,1.8,101.1315338,138.1350541,-0.092253,34.9976422,47.2082292,27443.1790416,216988.2465242,0.4490534,4596.4072455,784.1436545,4245.0596859,23.9223518,32.7542408,1.9442935,176.2885447),(12403,'Alces_metacarpus.tif',242,5,21,406.9236529,108.9639129,138.6447,1.8,105.1538822,139.590449,-0.1352676,52.6246881,56.1575752,47055.8145502,228494.2308846,1.2333858,4068.8051437,894.1775478,4840.5998304,4.3463513,6.1264407,2.3086114,26.6092775),(12404,'Alces_metacarpus.tif',242,5,22,468.5713253,110.3347521,139.1680214,1.8,105.5967843,139.0262373,-0.1783505,58.5977827,57.5308264,64811.6687581,234559.1105721,2.4578953,4077.1031001,1106.0430229,5038.3183634,38.2837468,59.4537758,2.1837937,463.2009711),(12405,'Alces_metacarpus.tif',242,5,23,639.13127,109.3929478,139.9852053,1.8,107.1302877,138.7352977,-0.2195734,57.5418867,60.9668003,77549.4975216,265751.1228954,5.0536771,4358.9481755,1347.7051594,5504.721133,15.2011195,25.9759465,0.7292774,110.8895522),(12406,'Alces_metacarpus.tif',242,5,24,735.1048807,107.8690314,138.2213776,1.8,105.9858043,135.863794,-0.1416281,62.3907443,59.548227,111847.8165375,308970.6722096,2.4411334,5188.5788641,1792.6988671,6653.4627978,44.7872475,80.213182,0.2811225,664.2474249),(12407,'Alces_metacarpus.tif',242,5,25,848.7554654,105.1109001,138.7497251,1.8,104.1697894,137.6765062,0.0117408,62.8735158,49.951874,167910.679819,365164.0053484,0.0194995,7310.3164381,2670.6106338,8343.9028197,0.5828101,1.1656203,2.3561945,2.3312405),(12408,'Alces_metacarpus.tif',242,5,26,1060.9217129,103.2018432,136.9789156,1.8,102.8738611,137.2837852,0.1790772,57.9253929,53.7473734,220263.7046946,444717.4498771,5.6100315,8274.2173501,3802.5414003,11268.1710861,0.824218,1.4858801,2.5535901,3.1554585),(12409,'Alces_metacarpus.tif',242,5,27,1267.0678145,102.2133313,135.4234739,1.8,102.4162265,135.9030832,0.2888193,56.0967746,48.1423629,263307.0564232,514953.3876153,17.1313438,10696.4709879,4693.8002792,13687.083129,61.8042215,74.6816102,2.9528549,675.2894484),(12410,'Alces_metacarpus.tif',242,5,28,1384.9252345,101.888673,134.9557351,1.8,102.2065088,135.7231566,0.3546063,53.6087343,45.8851613,295187.7200502,555678.2512996,27.8283487,12110.1950203,5506.3363026,15709.2213438,1.4570253,3.4968608,2.3561945,7.8179396),(12411,'Alces_metacarpus.tif',242,5,29,1419.3147834,102.2084929,134.6445169,1.8,102.5630951,135.20415,0.3921354,54.977239,46.6663792,307960.2299221,565519.0486271,34.5480652,12118.3399766,5601.5950533,15721.3997398,0.412109,0.5828101,2.3561945,1.1656203),(12412,'Alces_metacarpus.tif',242,5,30,1426.6327172,102.5916437,134.5730119,1.8,102.7124713,134.9432062,0.430811,64.0384402,47.7079592,320138.2357351,559485.1908002,41.4665715,11727.2924609,4999.1572994,13554.6619544,0.824218,1.3032031,1.8925469,3.1554585),(12413,'Alces_metacarpus.tif',242,5,31,1423.5534755,102.7738663,134.6388848,1.8,102.8371028,134.7467492,0.4778092,62.8156053,44.3255861,328004.7830492,556045.9616737,50.1679331,12544.5822812,5221.7085475,14057.6663761,0.412109,0.5828101,2.3561945,1.1656203),(12414,'Alces_metacarpus.tif',242,5,32,1404.1131633,102.7057363,134.7867648,1.8,102.8238776,134.2009628,0.5301589,68.5327063,57.4662402,330299.4698796,551109.4274366,59.839232,9590.1424205,4819.5888887,12860.9943751,0.412109,0.5828101,2.3561945,1.1656203),(12415,'Alces_metacarpus.tif',242,5,33,1368.1980949,102.6590341,135.105103,1.8,102.6140935,134.5648797,0.5608512,68.9837968,59.1029448,318378.0602696,547957.802401,64.5162952,9271.2436546,4615.2585849,12558.5348851,0.412109,0.5828101,2.3561945,1.1656203),(12416,'Alces_metacarpus.tif',242,5,34,1322.2182622,102.3591069,135.2685541,1.8,102.8286786,135.3928855,0.5531624,64.4638781,57.2457151,296354.4114434,527810.3364929,60.8275141,9220.084602,4597.2166127,12736.9478214,60.5562327,74.4047934,2.3052582,663.14038),(12417,'Alces_metacarpus.tif',242,5,35,1298.4832643,102.3311086,135.2516712,1.8,102.8594996,135.6517031,0.5443446,55.7620128,56.1938414,275891.8866587,517964.4639008,58.0371064,9217.4596105,4947.6672861,12941.2394031,59.8862352,74.0535907,2.3247088,760.8353379),(12418,'Alces_metacarpus.tif',242,5,36,1267.830986,102.4025083,134.9512427,1.8,102.9780129,135.5198528,0.5050426,49.6077872,59.2860422,254387.9735203,501925.3713258,49.4677433,8466.1642613,5127.9846999,12731.797025,58.316703,73.2128776,2.3999912,449.4034667),(12419,'Alces_metacarpus.tif',242,5,37,1235.9909516,102.494951,134.5933627,1.8,103.0141572,135.2157938,0.461667,47.3049072,57.4837643,233964.7632752,491362.4645428,40.8737783,8547.8477364,4945.8877927,12498.9978168,24.1937428,48.4994692,1.3567356,243.7844762),(12420,'Alces_metacarpus.tif',242,5,38,1200.1126291,102.5266162,134.3570493,1.8,103.0344313,134.9478425,0.427962,51.1956411,58.7522637,214431.5201172,485002.6975996,34.4511332,8255.0469847,4188.4722115,11754.4834726,0.412109,0.5828101,2.3561945,1.1656203),(12421,'Alces_metacarpus.tif',242,5,39,1175.8940679,102.6808516,134.3017273,1.8,103.1576596,134.8279528,0.4047294,53.7231399,62.5644021,201176.7615791,482008.0051809,30.3880084,7704.1894234,3744.6947819,10805.6300497,23.3501324,46.2774737,1.418824,228.0728653),(12422,'Alces_metacarpus.tif',242,5,40,1161.7106789,102.4929845,134.0724158,1.8,103.0346495,134.6125411,0.3670648,56.5048626,58.2032287,187683.4074943,486122.7407521,24.9366874,8352.1610643,3321.5443545,11288.488186,25.8981449,47.7833233,1.3090828,269.2281334),(12423,'Alces_metacarpus.tif',242,5,41,1147.6242495,102.343063,133.8266725,1.8,102.8641847,134.7821564,0.3267998,55.5316724,57.0634523,165692.3003231,492536.3542786,19.7104209,8631.3802274,2983.744106,11105.7203731,50.0000283,76.3681455,2.3790913,546.40557),(12424,'Alces_metacarpus.tif',242,5,42,1159.7118376,102.3887804,133.9334996,1.8,102.6566555,134.6989903,0.312946,52.9207758,57.1517652,154673.6870112,502998.281308,18.3194998,8801.0979067,2922.7403529,11051.0814342,48.2774015,76.7994727,2.4207435,540.2703791),(12425,'Alces_metacarpus.tif',242,5,43,1198.7979609,102.4352404,134.127853,1.8,102.671625,134.7184349,0.3067241,49.5972376,57.0884525,154867.4039973,516958.7391881,18.2149544,9055.3994133,3122.5005987,11338.3362702,0.412109,0.9215037,2.0344439,1.9898383),(12426,'Alces_metacarpus.tif',242,5,44,1220.9583934,102.1290963,133.9469134,1.8,102.4471391,134.3788066,0.2902783,48.4728534,56.8879981,156191.3926283,523874.7312221,16.6704042,9208.8797131,3222.2446499,11431.5324835,49.5434604,77.0390352,2.4091752,513.2782803),(12427,'Alces_metacarpus.tif',242,5,45,1216.4224921,101.2756828,133.5960762,1.8,102.1172692,134.0605674,0.2786625,46.2294464,39.0244969,153099.5083071,516771.4458754,15.3397941,13242.2320923,3311.7313786,13139.3420886,27.0008854,44.3797578,1.7481581,187.0690605),(12428,'Alces_metacarpus.tif',242,5,46,1146.0684687,100.2096472,133.034567,1.8,102.087486,133.7985935,0.2917531,52.3259228,63.1580046,143812.5148972,465180.511823,15.8027564,7365.3452926,2748.3990198,9406.1007959,25.6790171,42.8771639,1.2581641,151.9761951),(12429,'Alces_metacarpus.tif',242,5,47,1054.5032809,99.9248815,132.3505377,1.8,101.5955814,133.1626482,0.3589887,48.9972109,64.4792652,121775.4324351,401645.5996691,21.6930744,6229.0660213,2485.3543738,8011.9362133,47.4954781,75.4339605,2.4762371,464.0737145),(12430,'Alces_metacarpus.tif',242,5,48,1004.1572263,100.7750313,131.9445825,1.8,102.1034187,132.787861,0.4126027,50.4725311,51.5193789,98935.817121,365181.6596789,26.9109022,7088.2387843,1960.1913165,9001.0202254,45.8369195,74.6645525,2.4539214,434.5089673),(12431,'Alces_metacarpus.tif',242,5,49,970.9952157,103.8496475,131.5918869,1.8,104.4199727,132.6649365,0.4237597,46.555074,53.1980972,77651.202843,364373.6204325,27.3622595,6849.3731839,1667.9428506,8276.4115974,39.2434761,73.9526127,2.4746844,423.6769826),(12432,'Alces_metacarpus.tif',242,5,50,951.0885296,104.9464207,131.4589425,1.8,104.4780856,132.1045551,0.4028103,46.2845109,44.1866853,68656.8887153,355584.7874312,24.3586669,8047.3288559,1483.3664081,8480.3022589,39.4220347,73.1200296,2.4800552,441.2955937),(12433,'Alces_metacarpus.tif',242,5,51,986.4436095,102.680092,131.8801567,1.8,102.1427781,132.4532828,0.2823476,46.318824,35.9268326,77438.3680715,382453.5562512,12.7619726,10645.3457933,1671.8552295,9669.3042994,40.2128071,71.6382482,2.4785313,435.1260901),(12434,'Alces_metacarpus.tif',242,5,52,1000.8073312,100.5748461,132.3472278,1.8,101.030784,132.5988946,0.1804147,45.9420588,45.065547,79118.3525072,388453.0912814,5.3706406,8619.7354048,1722.1333701,8724.8001058,40.3316365,70.491121,2.9235578,385.1629881),(12435,'Alces_metacarpus.tif',242,5,53,970.1620007,100.0863512,132.7203183,1.8,100.1954243,132.6129672,0.0871199,46.294043,42.9966474,73547.0963858,360523.0322171,1.2241343,8384.9103102,1588.6946069,8079.4349374,33.2193466,49.7219371,0.5788075,198.5010117),(12436,'Alces_metacarpus.tif',242,5,54,964.5671597,99.4469336,132.283233,1.8,99.6050684,132.315244,0.0230091,51.0243857,40.6698136,73840.937099,345108.9145743,0.0850951,8485.6281333,1447.1695454,7775.4655922,35.3024287,50.9817311,0.6014547,262.6172331),(12437,'Alces_metacarpus.tif',242,5,55,1007.8497739,98.1746727,131.4883176,1.8,98.317528,131.4025978,0.0307071,45.5863605,55.3041392,83865.0572978,356614.6318313,0.1583374,6448.244866,1839.6962691,6911.5121166,35.7286527,52.0270271,0.6165663,193.1971451),(12438,'Alces_metacarpus.tif',242,5,56,1066.4793963,97.2532608,130.873714,1.8,98.2180436,131.1398466,0.0751343,54.3074787,58.0011753,99168.9856788,373604.9151664,1.0015224,6441.3335338,1826.0649915,7276.1639723,0.824218,2.2192749,1.1902899,4.8038945),(12439,'Alces_metacarpus.tif',242,5,57,1112.046327,97.5180388,131.3049442,1.8,98.5491597,132.0333258,0.1400666,52.244199,57.4740372,117134.1234253,388695.1823055,3.6124255,6762.9698796,2242.0503258,8030.8491758,2.0524356,7.5202836,1.4056476,19.3155726),(12440,'Alces_metacarpus.tif',242,5,58,1149.6281342,97.8457357,131.9323043,1.8,98.7589315,132.9718946,0.2015395,48.8118668,61.8882332,130242.492775,400494.2929276,7.6778262,6471.2510263,2668.2546939,8172.3001611,45.2430248,69.5292738,2.9988574,467.6119944),(12441,'Alces_metacarpus.tif',242,5,59,1160.0799139,98.0138807,132.2151778,1.8,98.6968439,133.3864195,0.236157,49.545812,61.100782,137459.2700703,401010.9767974,10.5839958,6563.107113,2774.3872717,8469.0664555,45.1888488,68.4212647,3.1235223,495.5182556),(12442,'Alces_metacarpus.tif',242,5,60,1179.7448184,98.1775774,132.5595777,1.8,98.5704821,133.7664767,0.2463176,48.916254,56.9386489,146455.4922906,408670.6637752,11.6903296,7177.3860346,2994.0046589,9249.5492824,47.3372142,68.6084133,2.4668517,559.1688177),(12443,'Alces_metacarpus.tif',242,5,61,1210.2107427,98.4475789,132.9782099,1.8,98.6762426,134.0111406,0.2492285,52.4691291,44.9638952,155664.0448398,421627.90601,12.2714085,9377.0324775,2966.7739389,10793.8751664,46.9304159,68.7468964,2.483704,511.3541237),(12444,'Alces_metacarpus.tif',242,5,62,1241.6659747,98.666422,133.3732854,1.8,98.9320733,134.2066567,0.2417032,53.8680014,50.869634,164448.4168302,436166.6626309,11.856174,8574.2048533,3052.8033803,10770.8274882,3.454568,5.5290224,1.1071487,20.8225952),(12445,'Alces_metacarpus.tif',242,5,63,1248.73837,98.6960599,133.6102873,1.8,99.0075633,134.2509956,0.2137544,61.6509123,36.9197463,168667.9792996,446106.6916164,9.3653887,12083.1461753,2735.8553651,9670.5889342,48.1252067,69.7451109,0.0532042,425.2839995),(12446,'Alces_metacarpus.tif',242,5,64,1167.5328913,100.3175045,132.8037303,1.8,100.5268791,133.2455202,0.3115902,62.6301133,36.2229315,135379.8737443,406691.701406,18.2887752,11227.465157,2161.5779804,8547.9031864,0.412109,0.5828101,2.3561945,1.1656203),(12447,'Alces_metacarpus.tif',242,5,65,1143.0656522,100.2968344,132.5566994,1.8,100.4299687,133.1388015,0.3012916,57.2804498,50.5804919,122249.0175899,386764.5816846,16.7769377,7646.5168138,2134.2188813,8512.3239375,42.8456399,68.0828515,2.5065659,292.4062319),(12448,'Alces_metacarpus.tif',242,5,66,4.2651965,108.5547149,115.806801,1.8,108.184354,115.2795185,1.5435323,20.9746892,53.4368252,197.3631822,1024.7125806,0.7103378,19.1761501,9.4095879,22.5162166,7.4019183,9.2150374,0.4636476,45.6662859),(12449,'Alces_metacarpus.tif',242,5,67,11.4718119,110.5399797,118.7174794,1.8,108.7413353,118.18935,-1.5646576,48.1438276,50.6083506,237.6131675,563.9679662,1.9118966,11.1437729,4.9354856,14.4618993,6.9225911,15.6655635,2.677945,47.0904704),(12450,'Alces_metacarpus.tif',242,5,68,38.6755371,110.1667292,120.1399321,1.8,108.052892,120.9263058,-1.1268769,32.2341364,43.8398037,659.0535251,816.7655999,5.2569401,18.6306856,20.4458254,27.1216609,12.9639295,21.5639751,2.6864918,71.8927421),(12451,'Alces_metacarpus.tif',242,5,69,169.1161513,109.9890332,123.7320404,1.8,112.3708176,127.5657313,0.9214985,26.174651,39.9715878,3930.8303236,21034.2294124,17.8819439,526.2295187,150.1769911,610.8552868,24.0258121,55.2056885,2.4248694,382.8660602),(12452,'Alces_metacarpus.tif',242,5,70,753.1120013,100.2497557,128.535385,1.8,101.5938677,130.3237408,0.1024962,47.4746064,34.6493613,69110.5200869,198556.7879694,1.3140221,5730.4602566,1455.7365587,5369.7107443,38.0321064,62.0699636,2.7462908,329.5475108),(12453,'Alces_metacarpus.tif',242,5,71,1115.3756361,101.8233523,130.265554,1.8,102.1739364,131.3638822,0.2674806,46.586855,37.4035078,103942.5343119,285409.2041791,12.9859103,7630.5464574,2231.1558537,7758.6948207,40.3934487,63.0580638,2.7598727,276.3461122),(12454,'Alces_metacarpus.tif',242,5,72,1163.0603431,102.1734069,130.3017091,1.8,102.382824,130.8029641,0.3150439,46.0224677,32.4040539,116224.0869879,304005.1184586,18.6113083,9381.7001925,2525.3771191,8730.6453657,42.5742697,63.052677,2.6516353,319.7568893),(12455,'Alces_metacarpus.tif',242,5,73,1153.8403219,101.9463718,130.1991883,1.8,102.3385661,130.9498202,0.3205928,48.660081,32.4320628,120797.9633147,305635.036783,19.0972868,9423.8543795,2482.4858682,8553.943775,43.6408373,62.2666561,2.6068485,276.4218439),(12456,'Alces_metacarpus.tif',242,5,74,1124.7681158,101.7500792,130.3722744,1.8,102.0941625,131.3706533,0.325403,46.8217778,32.4830314,119520.7629254,300649.5905836,19.158951,9255.5890893,2552.6745996,8703.3221531,42.9072539,62.9340504,2.730682,287.9608959),(12457,'Alces_metacarpus.tif',242,5,75,1098.6712954,101.9034433,130.7345583,1.8,102.1877042,131.8075422,0.3454996,44.6890508,32.4318916,119873.4073442,292817.2259601,21.0020506,9028.6817028,2682.3887526,8859.6397739,43.5796343,62.4776816,2.5060069,261.6930207),(12458,'Alces_metacarpus.tif',242,5,76,1074.2160991,102.0331784,130.9019444,1.8,102.3253061,132.015023,0.3614474,40.3479029,32.5026873,118389.2694158,282624.2214325,22.3890114,8695.410889,2934.2112196,9285.1407824,43.7435443,61.9261482,2.6719927,284.5054541),(12459,'Alces_metacarpus.tif',242,5,77,1051.5029347,102.1545792,130.9125842,1.8,102.5139513,132.0202421,0.371501,44.182982,32.470304,115903.3299767,270210.6237435,23.0944245,8321.7768309,2623.2572954,8427.8138774,43.9637959,61.1978396,2.6960154,285.2882531),(12460,'Alces_metacarpus.tif',242,5,78,1022.1161243,102.2932773,130.9602079,1.8,102.6295135,131.8092759,0.3810449,49.6248743,32.1685589,113313.2747974,257036.56217,23.5602309,7990.3039228,2283.3967134,7331.2309928,42.0651721,60.9879551,2.4087776,296.1788132),(12461,'Alces_metacarpus.tif',242,5,79,993.0796347,102.3439948,130.9676911,1.8,102.8071396,131.3986849,0.3824985,52.6670365,34.055128,112000.1579231,241716.3358589,23.0572815,7097.7955481,2126.5703438,6676.8143279,41.5909425,59.5565235,2.5382362,280.7015037),(12462,'Alces_metacarpus.tif',242,5,80,957.8990719,102.4901429,130.8961953,1.8,103.2353439,130.293052,0.3904577,54.0174787,37.1018152,113755.0281102,227508.2486772,23.1277163,6131.997789,2105.8929613,6266.0572426,0.824218,1.4858801,2.1587989,3.1554585),(12463,'Alces_metacarpus.tif',242,5,81,915.4428794,102.486615,131.0514437,1.8,103.0930223,130.6597699,0.3917394,54.1782951,37.6153811,108378.7439091,211220.422205,22.2404828,5615.2673758,2000.4089053,5852.065054,0.737621,1.4858801,0.5880026,2.9140507),(12464,'Alces_metacarpus.tif',242,5,82,875.8736046,102.3529481,131.2404558,1.8,102.6816433,131.2391673,0.3838153,49.5241852,35.819828,99788.4738753,199195.1047714,20.4693065,5561.0290704,2014.9442832,5919.0889465,42.0377141,58.4468786,2.6495615,297.8272492),(12465,'Alces_metacarpus.tif',242,5,83,842.3369818,102.4046956,131.5093195,1.8,102.3926801,131.7696952,0.385099,44.8372259,36.0044191,93203.9095404,186318.3487585,19.8108705,5174.8744643,2078.7171308,5989.3153703,40.7000205,57.5316563,2.4220888,276.2390114),(12466,'Alces_metacarpus.tif',242,5,84,787.9237673,102.5987787,131.4139887,1.8,103.0288231,131.7237581,0.371011,45.8361935,36.3528758,85885.2117682,173038.2434759,17.2618587,4759.9602467,1873.742238,5229.7049104,0.737621,1.4858801,2.5535901,2.9140507),(12467,'Alces_metacarpus.tif',242,5,85,760.8841119,102.5148469,131.5483984,1.8,102.9861703,131.7812308,0.3596973,46.2189908,30.6630912,82979.0756912,162927.1495893,15.7119547,5313.4613389,1795.3458996,5162.6785836,0.412109,0.5828101,2.3561945,1.1656203),(12468,'Alces_metacarpus.tif',242,5,86,737.5268141,102.4517802,131.7349172,1.8,102.7740928,132.1746631,0.3468353,46.3294853,33.9562574,80782.7973575,155258.2502157,14.2032702,4572.3016013,1743.6584229,4690.1094804,0.412109,0.5828101,2.3561945,1.1656203),(12469,'Alces_metacarpus.tif',242,5,87,712.9317879,102.3408423,131.6536335,1.8,102.9723425,131.3780692,0.3305848,53.6757802,38.2441248,80741.9252276,148415.727403,12.5194052,3880.7458165,1504.2524749,4263.1576144,0.412109,0.5828101,2.3561945,1.1656203),(12470,'Alces_metacarpus.tif',242,5,88,698.182389,102.2671553,131.8375365,1.8,102.632687,131.3507764,0.3142383,52.2084872,37.9100144,79432.6895969,142057.5445368,11.1171524,3747.2300337,1521.451662,4241.2657581,41.0017527,50.6558911,0.1223368,245.2329234),(12471,'Alces_metacarpus.tif',242,5,89,668.6792681,102.3091157,131.9851609,1.8,102.7839338,132.4423402,0.2960684,51.2904938,34.0578686,72651.9845237,132506.854075,9.4868888,3890.6384814,1416.4805051,3984.2649295,1.648436,3.7994572,1.3521274,10.2905936),(12472,'Alces_metacarpus.tif',242,5,90,657.8033671,102.3226012,132.2479988,1.8,102.7425791,133.3943439,0.2712515,37.4196171,25.9260846,69693.2184132,126786.0117991,7.8706653,4890.287659,1862.4781306,5078.6726419,39.5158435,48.7143519,3.0823401,267.7382672),(12473,'Alces_metacarpus.tif',242,5,91,647.6347468,102.3266427,132.4198811,1.8,102.7953832,133.6012554,0.2530155,37.7877107,25.6432527,67792.7788472,122841.2274774,6.7637234,4790.3918081,1794.0430278,5043.8913531,39.3534836,49.5782714,2.9066943,259.7203388),(12474,'Alces_metacarpus.tif',242,5,92,640.3393031,102.3620868,132.6109824,1.8,102.7875731,133.7263798,0.2418575,35.5746383,37.9901054,66425.3684231,119829.3196503,6.1220021,3154.224461,1867.2113482,4397.1564513,1.648436,3.1385286,1.1659045,8.6421576),(12475,'Alces_metacarpus.tif',242,5,93,633.9893707,102.3685619,132.7878425,1.8,102.7373397,133.7841729,0.2373662,35.5243413,25.0013903,64877.9220541,117551.4291293,5.8424707,4701.7956859,1826.2948631,5073.555476,2.0863073,6.645058,1.0516502,20.6811817),(12476,'Alces_metacarpus.tif',242,5,94,627.9866712,102.4102135,132.986696,1.8,102.7950759,133.9254109,0.2344148,42.1820038,24.990452,63686.6654141,115299.6681344,5.6467638,4613.7488138,1509.8065449,3960.5471751,1.6428043,5.357417,1.1760052,14.5116781),(12477,'Alces_metacarpus.tif',242,5,95,625.6498092,102.4595342,133.1707746,1.8,102.9076665,134.0525267,0.2339283,38.867157,26.2506551,62935.4442078,113717.1976258,5.6028547,4331.9756097,1619.2448608,4251.0761109,1.6951045,4.979532,1.1441688,12.8632421),(12478,'Alces_metacarpus.tif',242,5,96,624.4527381,102.4921601,133.3301326,1.8,102.9416856,134.118834,0.2320606,42.0765299,30.118064,62451.2848851,112318.8840784,5.5047934,3729.2863255,1484.2308759,3489.0391073,1.959982,10.4256247,1.2490458,23.7780649),(12479,'Alces_metacarpus.tif',242,5,97,621.5875899,102.5805482,133.5095071,1.8,103.1243749,134.5689122,0.2290282,33.4688799,26.88001,60904.9209782,109885.3003712,5.339768,4087.9932772,1819.7478111,4398.2633625,1.959982,10.1950136,1.3258177,25.6264897),(12480,'Alces_metacarpus.tif',242,5,98,620.9596165,102.643087,133.698479,1.8,103.1615049,134.8124677,0.2363134,35.9267196,24.6841235,60345.2106878,108552.6902703,5.6726953,4397.6724669,1679.6749451,4425.5504899,2.4464059,12.9339213,1.1784562,36.1584912),(12481,'Alces_metacarpus.tif',242,5,99,620.1290776,102.6691103,133.8561303,1.8,103.1129273,134.9747826,0.2389272,35.1659647,24.1443789,59724.2289927,107048.5487922,5.7887151,4433.6841055,1698.3532086,4739.4769922,1.5139989,6.9082057,1.2679115,15.5773039),(12482,'Alces_metacarpus.tif',242,5,100,618.5449397,102.6864521,133.9668547,1.8,103.0911538,135.0196764,0.2383965,34.9756677,23.3106799,59186.1715599,105589.6377131,5.7487925,4529.6678708,1692.2099096,4689.5422727,1.774791,12.0007952,1.2924967,32.6202113),(12483,'Alces_metacarpus.tif',242,5,101,618.4248723,102.7417054,134.0834047,1.8,103.1473805,135.1028824,0.2394829,40.8234359,23.8161194,58739.9456144,104634.180378,5.7991766,4393.4185334,1438.8780436,3967.0084454,2.2604215,11.0963744,1.3078016,30.9132),(12484,'Alces_metacarpus.tif',242,5,102,617.9646741,102.7658751,134.2134529,1.8,103.1126221,135.2463108,0.2386962,37.3018228,23.9547741,58314.9210122,103529.4156866,5.7575738,4321.8698412,1563.3263098,4331.117063,2.5309938,15.9076209,1.2818209,42.0280116),(12485,'Alces_metacarpus.tif',242,5,103,620.7574628,102.7345735,134.2910885,1.8,102.8455483,135.1940174,0.2337127,34.064064,22.9773727,57877.1924724,102485.6534189,5.5489832,4460.285992,1699.0689197,4546.8688584,0.412109,0.5828101,2.3561945,1.1656203),(12486,'Alces_metacarpus.tif',242,5,104,621.2104559,102.7676049,134.371809,1.8,103.0295938,135.2405931,0.2298372,39.2530807,31.5186834,57635.8204981,101353.0574924,5.3736253,3215.6501033,1468.3133013,3399.5545997,2.0257285,10.1950136,1.3258177,26.4507077),(12487,'Alces_metacarpus.tif',242,5,105,618.9086929,102.8110477,134.4951758,1.8,103.0127511,135.5957475,0.2273662,46.3292276,23.0062835,57088.2342922,99350.262264,5.241198,4318.3968558,1232.2293551,3104.9179271,2.582905,15.6926432,1.332187,41.7866038),(12488,'Alces_metacarpus.tif',242,5,106,617.510909,102.8081243,134.6075698,1.8,103.0113947,135.7135629,0.2243637,40.0784753,23.0088157,56546.3233357,97734.3035485,5.0944707,4247.6894357,1410.8900818,3757.1428092,2.2388222,11.8655907,1.2160907,33.6858372),(12489,'Alces_metacarpus.tif',242,5,107,617.1428843,102.8098524,134.737838,1.8,102.9721255,135.9011016,0.2211556,21.3711133,23.5154777,56366.6358024,96295.3961027,4.9492369,4094.9793662,2637.5151865,6087.2334991,2.487601,10.9500083,1.2252407,27.1335122),(12490,'Alces_metacarpus.tif',242,5,108,620.4861404,102.7620134,134.8396137,1.8,102.8034919,135.9774082,0.2181609,39.156752,22.9472569,56437.0135682,95482.9681955,4.8443291,4160.9752561,1441.3098797,3868.5422057,2.1582601,10.1783415,1.1978086,26.79211),(12491,'Alces_metacarpus.tif',242,5,109,620.2808473,102.7590961,134.9213983,1.8,102.8375205,136.0752811,0.2142468,40.7316181,22.6568744,56281.7116036,94332.9315878,4.673161,4163.5456765,1381.7695985,3655.9840571,2.2725934,9.9077723,1.2753555,31.4545911),(12492,'Alces_metacarpus.tif',242,5,110,619.9289825,102.7543269,135.0179443,1.8,102.8189568,136.1844072,0.2125972,19.9131031,24.1035179,56055.6526826,93474.3854568,4.5999466,3878.0391303,2815.0134355,4917.5965976,2.3998699,12.1204893,1.259798,33.9272451),(12493,'Alces_metacarpus.tif',242,5,111,619.9027354,102.7556266,135.0932807,1.8,102.9077655,136.1884287,0.2121104,42.4805866,26.7110826,56079.3028963,92768.8692279,4.5790282,3473.0478934,1320.1160206,3375.6484702,2.2247437,9.5142751,1.2627435,24.8022717),(12494,'Alces_metacarpus.tif',242,5,112,620.4642678,102.770652,135.1604755,1.8,103.0436411,136.0242879,0.2082733,49.8064272,27.8063249,56260.4354582,92236.2513584,4.4212394,3317.0960775,1129.5818362,2929.5265155,0.412109,0.5828101,2.3561945,1.1656203),(12495,'Alces_metacarpus.tif',242,5,113,620.7553012,102.8031434,135.3084745,1.8,102.9236418,136.4872215,0.2086578,42.6077216,22.1184829,55933.8321639,90762.878751,4.4394233,4103.4857199,1312.7628058,3306.2547348,2.2608168,9.1224216,1.2490458,25.143674),(12496,'Alces_metacarpus.tif',242,5,114,619.9767418,102.8008272,135.4147697,1.8,102.8198043,136.5094724,0.2039829,45.3438434,23.5128248,55878.5768288,89667.5833259,4.2401352,3813.5606461,1232.3299623,3184.0515565,2.5796652,11.2105768,1.2722974,27.616328),(12497,'Alces_metacarpus.tif',242,5,115,620.5630802,102.8028729,135.5163743,1.8,102.8845796,136.5861595,0.1960582,45.1607552,22.2421886,55772.7473315,88646.7974676,3.9249413,3985.52494,1234.9826092,3191.5129293,2.6138025,16.8158652,1.2722974,47.031895),(12498,'Alces_metacarpus.tif',242,5,116,620.2919122,102.7882851,135.6023361,1.8,102.9102625,136.6583597,0.188797,46.0539261,22.2690858,55722.1217101,87807.918727,3.6414023,3943.0410195,1209.9320603,3053.6653041,2.7687626,12.1204893,1.259798,34.7514631),(12499,'Alces_metacarpus.tif',242,5,117,620.0167814,102.815248,135.6769495,1.8,103.0087305,136.6471194,0.1848827,47.426578,39.6762149,55362.6673985,87188.2089698,3.4921347,2197.4931147,1167.3342182,2887.8945946,2.492856,7.1971743,1.3397057,19.9983772),(12500,'Alces_metacarpus.tif',242,5,118,617.7246938,102.8392827,135.7543141,1.8,103.0110928,136.6895787,0.1762699,45.8420638,22.4534301,54977.9570915,86228.6526615,3.1659,3840.3331771,1199.2906196,3077.0145416,2.0031437,7.8192185,1.2490458,18.3913602),(12501,'Alces_metacarpus.tif',242,5,119,615.092218,102.8693203,135.8049048,1.8,103.1365921,136.65486,0.1661497,47.7312248,26.1095835,54674.0380252,85436.1711161,2.8040648,3272.215013,1145.4564235,2914.293747,2.3493151,6.7086485,1.3854484,18.3499412),(12502,'Alces_metacarpus.tif',242,5,120,612.7307558,102.9064467,135.8523171,1.8,103.2679689,136.6635486,0.1570683,48.2295751,41.626342,54442.5637388,84565.4628979,2.4987418,2031.5372155,1128.8211362,2864.1220607,1.8262587,8.7324331,1.2341215,20.7226007),(12503,'Alces_metacarpus.tif',242,5,121,609.6866646,102.9418446,135.9440204,1.8,103.2190715,136.8504289,0.1519401,47.9347138,42.2553471,54164.8535608,83369.3137253,2.3278533,1972.9884951,1129.9713573,2852.6611067,1.8292179,8.6050886,1.2793395,19.8983827),(12504,'Alces_metacarpus.tif',242,5,122,607.4350797,102.938282,136.0301715,1.8,103.2142768,136.9350991,0.1464738,23.9735121,40.5984419,53888.6714704,82424.393993,2.156555,2030.2354004,2247.8421718,3154.4114871,2.9702322,14.0842434,1.2120257,41.5037768),(12505,'Alces_metacarpus.tif',242,5,123,604.7810916,102.9185439,136.0929678,1.8,103.2434105,137.0162721,0.1424628,27.7236595,42.3047104,53699.9496341,81452.6136176,2.0319335,1925.3793004,1936.9719108,2688.9559,2.616224,12.2042725,1.3667783,38.1069104),(12506,'Alces_metacarpus.tif',242,5,124,603.4806792,102.8985183,136.1439649,1.8,103.1997321,137.1299029,0.1351239,31.3235841,41.3993481,53566.9583184,80722.8961488,1.8252882,1949.8591137,1710.1158738,3096.1000683,2.1762428,6.5160154,1.2490458,17.0843265),(12507,'Alces_metacarpus.tif',242,5,125,605.1071726,102.8621616,136.1794177,1.8,103.2583049,137.1181873,0.1299668,28.7300378,41.3101225,53616.8651215,80409.9675871,1.6939457,1946.4955009,1866.2302323,2893.205944,2.358212,11.8941826,1.3258177,33.5444238),(12508,'Alces_metacarpus.tif',242,5,126,613.5205346,102.7043337,136.2691319,1.8,102.9055952,137.6022739,0.1283183,31.6074916,40.2607487,54749.1339883,80695.0062501,1.6744411,2004.3096267,1732.1568784,3196.0728222,1.648436,4.2027037,1.3734008,11.1148116),(12509,'Alces_metacarpus.tif',242,5,127,612.0062344,102.684562,136.306142,1.8,102.8429731,137.6005041,0.1232789,32.9623627,25.2647333,54484.105048,80118.9937445,1.5423415,3171.17908,1652.9186799,3419.0009774,1.756397,8.7324331,1.2341215,21.4054053),(12510,'Alces_metacarpus.tif',242,5,128,612.3969037,102.6522157,136.3376952,1.8,102.783396,137.550346,0.1154147,33.7607756,37.8167523,54459.1756394,79780.196617,1.3535504,2109.6522501,1613.0901811,3294.0718981,2.0438972,12.7820242,1.2082521,33.9272451),(12511,'Alces_metacarpus.tif',242,5,129,613.1253879,102.6904127,136.4085493,1.8,102.8759014,137.7845983,0.1069834,33.5524647,26.7167878,54505.6294817,79154.1354887,1.1651267,2962.7115421,1624.4895844,3338.9763841,1.8321771,11.8655907,1.2160907,29.6061662),(12512,'Alces_metacarpus.tif',242,5,130,612.5238159,102.658732,136.4748859,1.8,102.8234025,137.84297,0.0959123,33.4341367,26.1206286,54354.4817276,78584.7949842,0.9362416,3008.5338363,1625.718116,3330.3558796,2.0892665,10.714834,1.1760052,29.3647584),(12513,'Alces_metacarpus.tif',242,5,131,611.4888073,102.6353741,136.5285027,1.8,102.8224262,137.884753,0.0868664,32.228086,21.7497413,54105.0824729,77958.8327936,0.767094,3584.3567849,1678.8177383,3649.9045677,2.1917592,12.6417417,1.2387369,32.1788147),(12514,'Alces_metacarpus.tif',242,5,132,617.747081,102.5530727,136.5537533,1.8,102.3785188,137.7260676,0.0845188,32.1365646,22.5992384,54020.7810495,77710.8751497,0.7337236,3438.6501723,1680.9756049,3912.7522335,35.6976759,42.3651259,2.4942005,197.1354026),(12515,'Alces_metacarpus.tif',242,5,133,611.779532,102.6087524,136.6134064,1.8,102.7574393,137.9681381,0.0824567,33.0249178,22.49357,54019.3359241,77293.7608393,0.6916892,3436.2602689,1635.7144687,3898.0902147,2.3417408,13.6991379,1.2014627,35.5756811),(12516,'Alces_metacarpus.tif',242,5,134,611.5443379,102.6101971,136.6498176,1.8,102.7723542,138.0063333,0.0771967,32.5701346,21.9946181,53985.717736,76993.7373557,0.6061935,3500.5716823,1657.5220941,3567.4505324,2.331976,9.5142751,1.2627435,26.3092942),(12517,'Alces_metacarpus.tif',242,5,135,613.0237964,102.6067358,136.6779605,1.8,102.7600362,137.943213,0.0684934,30.9119137,22.6222697,53918.3463723,76929.5756168,0.4785691,3400.6126092,1744.2577954,3501.2033944,1.756397,8.2112137,1.2649175,19.8983827),(12518,'Alces_metacarpus.tif',242,5,136,613.85907,102.5828549,136.7150759,1.8,102.7279593,137.9126062,0.0581696,32.1808483,20.6082464,53844.6714748,76749.9005211,0.3457956,3724.2324727,1673.1899372,3487.5405771,1.8146435,10.4256247,1.2490458,27.0335178),(12519,'Alces_metacarpus.tif',242,5,137,614.1850995,102.6246942,136.7802255,1.8,102.7621586,138.0665912,0.0477429,25.5816842,20.9619095,53782.0407762,76251.0744403,0.2331502,3637.601551,2102.3651262,5075.4319049,2.2244694,13.6991379,1.2014627,37.0827036),(12520,'Alces_metacarpus.tif',242,5,138,612.1907872,102.6185828,136.8386488,1.8,102.773717,138.1361063,0.0369229,25.5454477,21.4343959,53564.917495,75846.2024506,0.1390365,3538.5276464,2096.8478648,4638.4629427,2.1946063,15.248033,1.240499,38.6311452),(12521,'Alces_metacarpus.tif',242,5,139,618.1677028,102.5271824,136.8665351,1.8,102.4251451,138.0835943,0.0279338,25.9499937,20.8076268,53403.3912758,75773.8847579,0.0803719,3641.6399347,2057.9346508,4661.5624072,2.0870434,14.0842434,1.2120257,37.4241059),(12522,'Alces_metacarpus.tif',242,5,140,617.8152204,102.4868086,136.9002569,1.8,102.3486688,138.1469037,0.0158008,26.7602569,21.5622378,53159.8121351,75592.4857764,0.0257058,3505.7810973,1986.5209914,4717.7182527,2.0922257,10.5631825,1.2120257,28.5405404),(12523,'Alces_metacarpus.tif',242,5,141,616.4482124,102.4672763,136.9126186,1.8,102.3244645,138.1313618,0.0077842,27.1208307,21.2273438,52898.8271273,75352.5069063,0.0062256,3549.7850195,1950.4869804,4719.606209,2.4044088,16.072251,1.1760052,39.0725419),(12524,'Alces_metacarpus.tif',242,5,142,615.7777805,102.4595644,136.9301814,1.8,102.2984849,138.0592515,0.0029121,27.0982336,41.0102791,52720.5184783,75217.0394668,0.0008702,1834.1021105,1945.5333973,2826.9270422,2.8189916,15.1530636,1.1801893,39.8967599),(12525,'Alces_metacarpus.tif',242,5,143,610.8568711,102.4964362,136.9694023,1.8,102.4793947,138.1412278,-0.0024495,27.4582593,20.9176055,52564.4337899,74958.8797941,0.0006111,3583.5306196,1914.3396257,4562.851687,1.8625178,10.714834,1.1760052,28.1991381),(12526,'Alces_metacarpus.tif',242,5,144,608.9898827,102.4948501,137.0076344,1.8,102.4327161,138.1895926,-0.0105777,27.4017993,47.814835,52429.4171419,74918.1627659,0.0113563,1566.8393049,1913.356731,2582.1785563,2.4065416,14.6168039,1.1955255,34.4100608),(12527,'Alces_metacarpus.tif',242,5,145,606.8625339,102.5432882,137.0552765,1.8,102.5361388,138.250878,-0.0223352,28.1581884,21.1101032,51986.3218495,74329.8760045,0.0504483,3521.0569662,1846.22395,3933.5646225,0.412109,0.5828101,2.3561945,1.1656203),(12528,'Alces_metacarpus.tif',242,5,146,605.6754469,102.5299609,137.1206919,1.8,102.5383795,138.3987377,-0.0338637,27.9961947,27.265478,51804.1787626,74013.3186255,0.1157156,2714.5432307,1850.4007204,3378.6717232,2.2339327,14.4708365,1.2220253,38.2483239),(12529,'Alces_metacarpus.tif',242,5,147,604.0247135,102.524506,137.1635638,1.8,102.5191659,138.4247515,-0.0427546,28.3763947,23.2525183,51542.5218446,73657.3533494,0.1839098,3167.7151042,1816.3872604,3479.2820557,0.412109,0.5828101,2.3561945,1.1656203),(12530,'Alces_metacarpus.tif',242,5,148,603.7498915,102.5354844,137.2099199,1.8,102.5162108,138.4431389,-0.0473155,27.129443,23.5493868,51391.7137611,73494.7928653,0.225107,3120.8792549,1894.3151067,3476.3460531,2.2152582,15.9182936,1.199905,41.8865982),(12531,'Alces_metacarpus.tif',242,5,149,604.1546621,102.5458854,137.2516221,1.8,102.5486914,138.5162036,-0.0514915,28.2927893,41.3369568,51371.0066467,73409.345844,0.2667378,1775.8768773,1815.692546,2611.0215223,1.926611,14.6168039,1.1955255,35.5756811),(12532,'Alces_metacarpus.tif',242,5,150,604.8111471,102.5555179,137.2864326,1.8,102.5173168,138.5351282,-0.0565452,28.3394328,20.8825759,51330.6176178,73269.1702647,0.3219563,3508.6270347,1811.2789364,3572.3721136,2.3469334,14.938596,1.1441688,38.006916),(12533,'Alces_metacarpus.tif',242,5,151,604.9278692,102.5614222,137.3055819,1.8,102.4732538,138.5258767,-0.0620308,19.0525534,21.1999953,51270.290683,73278.5448146,0.3874453,3456.5359008,2690.9931526,5395.8682247,1.9570228,10.9500083,1.2252407,31.1131888),(12534,'Alces_metacarpus.tif',242,5,152,606.0096593,102.565803,137.3450491,1.8,102.4163067,138.6156669,-0.0666488,23.6008086,28.3725412,51333.7925579,73383.5833314,0.4479919,2586.4297057,2175.0861757,3379.3916656,1.6954946,7.9591468,1.199905,20.6811817),(12535,'Alces_metacarpus.tif',242,5,153,606.0825849,102.6342317,137.3526333,1.8,102.4965634,138.6589106,-0.0709414,27.2786451,26.9262291,51268.8691176,73031.4641657,0.5075183,2712.2796875,1879.4507192,3445.2821236,2.5168378,15.9182936,1.199905,41.9865926),(12536,'Alces_metacarpus.tif',242,5,154,605.4490532,102.6509726,137.4012711,1.8,102.4407795,138.7925899,-0.0709344,29.1838431,26.5574472,51155.3949995,72750.3861677,0.5068872,2739.3591533,1752.8669809,3434.6011029,2.262218,16.16182,1.2329181,40.47957),(12537,'Alces_metacarpus.tif',242,5,155,604.6246901,102.6880184,137.4281428,1.8,102.5412305,138.8116615,-0.0714967,27.3968995,26.6356267,50925.1104766,72502.4718878,0.5142406,2722.0111166,1858.7910099,3394.5267166,2.1024116,15.1530636,1.1801893,37.9069216),(12538,'Alces_metacarpus.tif',242,5,156,605.1676437,102.707764,137.4507877,1.8,102.5770919,138.7856103,-0.0756146,22.6004668,31.9728852,50704.2321397,72526.8638997,0.5755825,2268.386585,2243.5037565,3148.7771321,2.2587738,15.9182936,1.199905,39.9967543),(12539,'Alces_metacarpus.tif',242,5,157,604.9952367,102.7419106,137.450294,1.8,102.6291486,138.7578447,-0.0747922,27.4209085,21.212259,50543.6216094,72445.7325257,0.5629926,3415.276634,1843.2511674,4107.464353,2.2587738,16.3030654,1.2090671,40.8209723),(12540,'Alces_metacarpus.tif',242,5,158,605.4257912,102.760986,137.4584993,1.8,102.637111,138.6971944,-0.0777564,19.111053,21.2472367,50348.7661148,72440.2323964,0.608844,3409.3954654,2634.5364687,5287.012383,2.4672783,17.4648663,1.2341215,43.735023),(12541,'Alces_metacarpus.tif',242,5,159,605.2510167,102.7831483,137.4663746,1.8,102.6905048,138.6633774,-0.0791882,18.7943567,21.2766429,50188.3757742,72436.9143903,0.6312436,3404.52743,2670.3960455,5276.9712033,1.9253563,9.7957191,1.1824776,25.967892),(12542,'Alces_metacarpus.tif',242,5,160,605.5325291,102.8088086,137.4760581,1.8,102.726255,138.6239175,-0.0770555,18.8966075,21.2896652,50048.0328813,72387.8132916,0.5980459,3400.1386371,2648.5194762,5265.4349743,1.7953294,13.6991379,1.2014627,33.4444293),(12543,'Alces_metacarpus.tif',242,5,161,604.1013961,102.8632022,137.4958313,1.8,102.7588904,138.6963127,-0.0790783,27.8891839,21.7519415,49765.9396146,72100.3272903,0.6283014,3314.6616886,1784.4172034,4117.9063449,2.394027,15.5349242,1.1902899,41.262369),(12544,'Alces_metacarpus.tif',242,5,162,602.0108961,102.8512272,137.5131567,1.8,102.6416827,138.7037658,-0.0836472,28.9586171,20.9862213,49554.0782615,71623.7822523,0.7003939,3412.8955887,1711.2031997,4078.3865422,2.5655027,15.4856503,1.1309537,38.1483295),(12545,'Alces_metacarpus.tif',242,5,163,599.3257718,102.8675149,137.5329733,1.8,102.7290016,138.814546,-0.082981,29.3866159,21.4450863,49298.5631208,71220.3148059,0.686234,3321.0551804,1677.585584,4011.2032096,2.32395,18.1374785,1.1987286,49.8045322),(12546,'Alces_metacarpus.tif',242,5,164,598.7723194,102.8725199,137.535344,1.8,102.71521,138.806656,-0.0882914,29.3878451,20.9728739,49081.8944888,71151.1972282,0.7759225,3392.534457,1670.1426845,4008.804793,2.6658757,16.9916894,1.1722739,43.9764308),(12547,'Alces_metacarpus.tif',242,5,165,602.0114622,102.8429976,137.5225723,1.8,102.5626055,138.6467355,-0.090786,30.5470235,20.9459419,48900.2312025,71238.5643827,0.8247035,3401.0675988,1600.8182027,3721.6256837,2.5106732,16.072251,1.1760052,39.8967599),(12548,'Alces_metacarpus.tif',242,5,166,596.6784741,102.8917544,137.5220184,1.8,102.7773953,138.6740101,-0.0933538,30.5991195,21.0068883,48706.9373351,70996.006402,0.8641547,3379.6536332,1591.7757825,3807.8352136,2.1334521,14.3943485,1.1583859,36.5998879),(12549,'Alces_metacarpus.tif',242,5,167,596.8939572,102.8905701,137.5180589,1.8,102.7560409,138.6279862,-0.0969346,28.1332559,21.4844525,48578.9326184,71078.2009844,0.9318438,3308.3552408,1726.7440657,4005.2758667,2.4169812,15.859505,1.1420183,43.3936207),(12550,'Alces_metacarpus.tif',242,5,168,597.2414475,102.8937151,137.5293066,1.8,102.7548475,138.6855919,-0.1007905,28.1242496,21.0430622,48571.8976121,71055.4255506,1.0077825,3376.6675597,1727.0468844,4018.8032777,1.9873476,14.7728287,1.1695675,40.5795644),(12551,'Alces_metacarpus.tif',242,5,169,597.1656913,102.9655509,137.5639728,1.8,102.8590661,138.7742005,-0.1031941,19.0990853,20.8672658,48556.6826404,70526.8669056,1.056115,3379.7847626,2542.3564408,5210.6241679,2.2509266,14.7728287,1.1695675,39.4139442),(12552,'Alces_metacarpus.tif',242,5,170,593.2920905,103.0038126,137.5820663,1.8,102.9632536,138.774963,-0.1034154,28.3595342,21.3138186,48396.614011,70020.5712391,1.0537534,3285.2194392,1706.5376885,3902.5556037,2.2736229,15.5349242,1.1902899,42.5694027),(12553,'Alces_metacarpus.tif',242,5,171,593.6092681,103.0159884,137.611586,1.8,102.9413565,138.9259619,-0.1073566,30.7589571,21.6395574,48503.5730664,69808.6975708,1.1358936,3225.9762172,1576.8926417,3582.0966624,2.3902691,15.5349242,1.1902899,41.7866038),(12554,'Alces_metacarpus.tif',242,5,172,593.618789,103.0325217,137.6080738,1.8,102.9720189,138.8553114,-0.1080321,19.1734988,21.3831719,48412.6686866,69603.2551091,1.1501956,3255.0481908,2524.9783082,4732.0953766,2.7166829,16.2352118,1.152572,45.0006377),(12555,'Alces_metacarpus.tif',242,5,173,594.6981088,103.0648091,137.5967961,1.8,103.0304822,138.8430705,-0.105055,18.9823381,21.3984826,48395.0020553,69600.6131334,1.089884,3252.5957243,2549.4752906,5009.4791513,2.1854296,15.1530636,1.1801893,38.5897262),(12556,'Alces_metacarpus.tif',242,5,174,594.346141,103.0752,137.5864762,1.8,103.0430149,138.7501709,-0.10315,30.7693818,21.3558274,48147.39751,69530.0264742,1.0502337,3255.7870597,1564.7827378,3542.8518154,2.2817387,8.6050886,1.2793395,22.1296289),(12557,'Alces_metacarpus.tif',242,5,175,595.0559435,103.0932296,137.5759708,1.8,103.1444885,138.7309805,-0.1043499,19.1297153,20.8430565,48053.3924977,69501.9515688,1.0760036,3334.5374102,2511.9763589,4771.8215519,2.0289706,12.2528815,1.2277724,33.1030271),(12558,'Alces_metacarpus.tif',242,5,176,596.4086957,103.0973673,137.5732265,1.8,103.1089888,138.7463907,-0.105999,31.3386603,35.1980254,48027.8796767,69511.1053213,1.1126777,1974.8580958,1532.5441243,2815.9412303,1.7846683,8.4958447,1.3258177,23.495238),(12559,'Alces_metacarpus.tif',242,5,177,596.7454813,103.1662816,137.5659271,1.8,103.1890898,138.7779865,-0.1090642,31.2867851,21.7571453,47880.4371532,69133.3174756,1.1783648,3177.4994619,1530.3725532,3487.1470443,2.6309881,18.2448432,1.2490458,45.7662803),(12560,'Alces_metacarpus.tif',242,5,178,595.3435802,103.1938603,137.5849218,1.8,103.1796135,138.8433767,-0.110639,31.2602405,22.2898433,47642.8194114,68737.7337679,1.2096503,3083.8141359,1524.0707893,3471.3383358,2.6137314,17.9917558,1.2200684,47.2733028),(12561,'Alces_metacarpus.tif',242,5,179,592.3909419,103.2327641,137.5856283,1.8,103.2340039,138.8560428,-0.110004,28.0329288,33.4632104,47367.7174267,68224.9052469,1.1899313,2038.8033457,1689.7170379,2834.3042829,2.589508,16.6891425,1.2178059,43.6350286),(12562,'Alces_metacarpus.tif',242,5,180,590.3544799,103.2575045,137.5763461,1.8,103.2563406,138.8617538,-0.1093297,28.1832857,33.8827351,47087.3209161,67848.9988071,1.171404,2002.4652265,1670.7534189,2795.1884365,2.50039,16.9416401,1.2490458,40.6209835),(12563,'Alces_metacarpus.tif',242,5,181,587.6857729,103.288916,137.5441675,1.8,103.3013719,138.7923985,-0.1058972,30.7199312,33.8372047,46813.5085782,67517.5781705,1.0943061,1995.3651249,1523.8806476,2777.4432368,2.3143784,16.6891425,1.2178059,43.776442),(12564,'Alces_metacarpus.tif',242,5,182,585.5093782,103.3160472,137.5274132,1.8,103.3270765,138.727914,-0.103503,32.5483109,21.2203,46634.5258551,67236.8935944,1.0416875,3168.5175818,1432.7786769,3099.272722,2.1372101,13.3156493,1.1902899,36.5998879),(12565,'Alces_metacarpus.tif',242,5,183,584.9819155,103.3553662,137.5021343,1.8,103.3704207,138.6490077,-0.1010102,18.4923936,21.2207747,46377.6387603,67121.5475547,0.9913893,3163.0111831,2507.9305471,5037.3436482,2.5363698,17.8543579,1.2417466,48.1975153),(12566,'Alces_metacarpus.tif',242,5,184,583.0452952,103.3891953,137.488975,1.8,103.4524872,138.6434715,-0.0987624,18.769187,21.2425054,46163.1115708,66893.3288867,0.9447607,3149.0319816,2459.5157776,4940.7310042,0.412109,0.5828101,2.3561945,1.1656203),(12567,'Alces_metacarpus.tif',242,5,185,578.2401815,103.4479179,137.4715428,1.8,103.4437424,138.7135181,-0.099588,19.7307877,21.8405371,45922.324422,66232.4319116,0.9526526,3032.5459343,2327.44506,4883.3997801,2.4065416,17.2200425,1.2036225,46.1076826),(12568,'Alces_metacarpus.tif',242,5,186,574.2043637,103.4807676,137.461543,1.8,103.4480569,138.6683168,-0.0994606,19.6140683,21.2995559,45559.5292681,65749.7747093,0.9435927,3086.9082375,2322.7985394,4963.7446354,2.4065416,15.9182936,1.199905,43.4936151),(12569,'Alces_metacarpus.tif',242,5,187,571.5890771,103.5170257,137.4594502,1.8,103.4852446,138.7005655,-0.0960983,29.7016277,21.9251085,45297.1461474,65240.6113292,0.8770551,2975.6117899,1525.0728551,3465.197904,2.5705939,15.3147157,1.1553042,40.3381566),(12570,'Alces_metacarpus.tif',242,5,188,572.223741,103.5458408,137.4601086,1.8,103.5142227,138.7033978,-0.0972033,18.7700165,21.4719479,45308.4164463,65183.3792359,0.8982727,3035.745964,2413.8719615,4906.6061833,2.7552393,16.8360524,1.1948354,45.6248668),(12571,'Alces_metacarpus.tif',242,5,189,572.4661402,103.5839126,137.4479615,1.8,103.6325056,138.6104296,-0.0999872,18.5138622,21.1596197,45191.0909791,65199.7239325,0.9506914,3081.3277794,2440.9326703,4925.3659825,2.6894003,16.8360524,1.1948354,42.3694139),(12572,'Alces_metacarpus.tif',242,5,190,571.9725413,103.6039165,137.4531225,1.8,103.6393498,138.659648,-0.1002665,33.1543736,21.3861141,45132.8241898,65094.3873082,0.9551688,3043.7688267,1361.2932259,2889.6164351,2.5142381,16.0299277,1.2571757,41.0623802),(12573,'Alces_metacarpus.tif',242,5,191,571.8159854,103.6427131,137.4269112,1.8,103.7328068,138.575583,-0.1012069,28.8414724,25.7467904,45029.9736088,65049.3791346,0.9728417,2526.5043934,1561.2924695,3520.307586,1.86275,7.3025901,1.2847449,17.0843265),(12574,'Alces_metacarpus.tif',242,5,192,569.2426941,103.5990267,137.3138537,1.8,103.6383987,138.4641225,-0.1312022,19.2829071,40.5557509,44042.3017912,64555.6389704,1.6238102,1591.7752116,2284.0073597,2554.4494489,1.6535356,8.8770995,1.1902899,21.5053997),(12575,'Alces_metacarpus.tif',242,5,193,568.7730264,103.7152059,137.3144685,1.8,103.6768578,138.5360047,-0.124193,18.6936824,21.2712964,44136.5507641,64183.4336459,1.4546136,3017.3729225,2361.0410109,4347.7343465,2.6493231,16.6126449,1.1626472,44.3178331),(12576,'Alces_metacarpus.tif',242,5,194,565.7851862,103.8638463,137.2982007,1.8,103.7692644,138.5315497,-0.0838276,31.7715089,30.6888722,44075.4621415,63285.052418,0.6610841,2062.1498262,1387.2637344,2691.6738008,2.775006,19.2106457,1.174355,45.383459),(12577,'Alces_metacarpus.tif',242,5,195,567.3512085,103.8034943,137.2146209,1.8,103.6239409,138.4951895,-0.0900787,32.1738038,32.3625538,43178.2528859,62914.0248167,0.7651913,1944.0377073,1342.0313347,2617.4342936,2.5680196,15.6926432,1.1659045,42.4279893),(12578,'Alces_metacarpus.tif',242,5,196,562.743205,103.8389956,137.2147392,1.8,104.0023883,138.3934179,-0.11299,32.5507857,34.1303905,43303.3639748,63253.6206495,1.1923122,1853.2932001,1330.3323733,2585.3995979,2.578286,17.2200425,1.2036225,49.4631299),(12579,'Alces_metacarpus.tif',242,5,197,559.5359704,103.8795391,137.2378255,1.8,103.7170962,138.4024671,-0.0905912,31.2571219,35.6201962,43802.9082019,63459.7275157,0.763239,1781.5659182,1401.3736865,2535.3006459,3.111604,19.8241135,1.2095926,51.7357951),(12580,'Alces_metacarpus.tif',242,5,198,558.5890181,103.9004895,137.2280018,1.8,103.6268411,138.4741269,-0.0920069,30.9092016,37.2778424,43762.993326,63406.1283013,0.785879,1700.9066039,1415.8564782,2469.3431687,3.1484396,19.6822499,1.2291808,49.2217221),(12581,'Alces_metacarpus.tif',242,5,199,557.9071095,103.9668118,137.173909,1.8,103.9428381,138.1612525,-0.0815938,32.0191759,33.4854499,43468.01955,63119.3333538,0.6176762,1884.9779121,1357.562095,2595.1248074,2.0069237,14.6168039,1.1955255,38.006916),(12582,'Alces_metacarpus.tif',242,5,200,556.2948719,104.0106887,137.1378018,1.8,104.0476609,138.0826261,-0.0797826,31.5149147,20.7880165,43290.3029245,62985.203013,0.5889102,3029.8803697,1373.6449326,3025.6092693,2.3991382,13.6432355,1.1341692,35.1928598),(12583,'Alces_metacarpus.tif',242,5,201,560.5617152,104.034898,137.1306706,1.8,103.6860116,138.1962921,-0.0802646,24.2431836,33.9689653,43168.9214563,62773.6054318,0.6006023,1847.9693103,1780.6622326,2538.5943364,2.4274691,14.3943485,1.1583859,35.1928598),(12584,'Alces_metacarpus.tif',242,5,202,558.4365279,104.0789042,137.1345212,1.8,103.76588,138.2575455,-0.0735831,29.7672078,21.3593416,43046.1742064,62391.4810112,0.5030317,2921.0395172,1446.0937839,3272.0667477,2.3699145,14.7267715,1.2578951,38.5897262),(12585,'Alces_metacarpus.tif',242,5,203,555.5516173,104.1218487,137.1119994,1.8,103.7710159,138.2827368,-0.0711116,29.9341535,21.3879567,42780.3475966,62024.9267968,0.4674353,2899.9931001,1429.1483992,3298.0709315,2.1334521,12.3495254,1.122073,31.6959989),(12586,'Alces_metacarpus.tif',242,5,204,554.0205911,104.1790036,137.0641245,1.8,103.9411073,138.2148512,-0.0641862,23.4509771,36.1111385,42667.7671552,61954.9233521,0.3798935,1715.6734981,1819.4451781,2429.8272253,2.4015429,14.2341757,1.1849137,34.9928709),(12587,'Alces_metacarpus.tif',242,5,205,552.9418889,104.2330902,137.0173368,1.8,104.0706718,138.1811603,-0.0581638,30.0807869,37.9084284,42555.9263261,61850.5767365,0.3114186,1631.5785018,1414.7211798,2157.4618661,2.4523501,15.5349242,1.1902899,38.7311396),(12588,'Alces_metacarpus.tif',242,5,206,550.5052367,104.2587741,136.9597034,1.8,104.0573747,138.0759457,-0.0600413,31.5024873,50.1758712,42462.581715,61672.3778777,0.3303609,1229.1242064,1347.9120337,1959.7935651,1.648436,5.4982198,1.3439975,13.0046555),(12589,'Alces_metacarpus.tif',242,5,207,549.4250421,104.2972031,136.8928502,1.8,104.0780004,137.875064,-0.0597779,30.8943553,53.0193671,42255.0499403,61606.4152304,0.3268292,1161.960593,1367.727195,1873.8497126,1.236327,3.9096093,1.2490458,9.1249734),(12590,'Alces_metacarpus.tif',242,5,208,549.3567483,104.3447737,136.8358305,1.8,104.1395442,137.8320028,-0.0573871,30.1515544,20.618453,42240.5906392,61621.0851874,0.3012001,2988.6376629,1400.9423904,3007.8378381,1.6951045,7.005853,1.080839,17.767131),(12591,'Alces_metacarpus.tif',242,5,209,547.2847241,104.4264395,136.7912477,1.8,104.196149,137.88691,-0.0559045,32.4194591,50.256892,42017.7976086,61313.1978428,0.2847754,1219.9958138,1296.0672011,1942.4087527,2.0040417,13.555818,1.2298174,31.8374124),(12592,'Alces_metacarpus.tif',242,5,210,545.1438401,104.4576727,136.7471616,1.8,104.2017092,137.8114713,-0.053993,32.426856,23.9982627,41760.3771643,61087.2354747,0.2646141,2545.4857376,1287.8330583,2693.3545319,2.1205913,14.4708365,1.2220253,34.6514687),(12593,'Alces_metacarpus.tif',242,5,211,542.9227738,104.4838337,136.7077535,1.8,104.2200697,137.7972319,-0.0504032,30.0822491,37.8747069,41537.4184475,60961.9273803,0.2296865,1609.5682955,1380.7949753,2119.1689875,0.412109,0.9215037,2.0344439,1.9898383),(12594,'Alces_metacarpus.tif',242,5,212,533.3244349,104.5966112,136.6527297,1.8,104.6394122,137.7777541,-0.0463807,32.3868318,50.2649177,41347.7263924,60606.765648,0.1910743,1205.7468389,1276.6832707,1908.9942136,2.333614,14.0177651,1.1466019,40.5795644),(12595,'Alces_metacarpus.tif',242,5,213,538.8068253,104.6788157,136.6314231,1.8,104.9414895,137.7826844,-0.0379245,32.5855984,39.2848392,41423.6510367,60880.1597208,0.1290957,1549.7113131,1271.2257285,2076.7229197,2.5799767,14.0177651,1.1466019,33.9272451),(12596,'Alces_metacarpus.tif',242,5,214,537.9760291,104.6994176,136.582731,1.8,104.9750057,137.6920893,-0.0387618,32.6316307,41.3124305,41358.0913762,60897.7038023,0.1346488,1474.0770057,1267.4233718,2014.9927005,1.6020656,3.7994572,0.8621701,8.8835655),(12597,'Alces_metacarpus.tif',242,5,215,538.0884797,104.7350015,136.5280491,1.8,105.0281476,137.5691884,-0.0382845,32.613963,40.8612622,41279.902041,61008.1922812,0.131382,1493.0569691,1265.712541,2020.1714642,0.824218,1.8430075,1.1071487,3.9796765),(12598,'Alces_metacarpus.tif',242,5,216,537.8626007,104.7679769,136.480787,1.8,105.0386726,137.4649201,-0.0394041,33.0232619,42.0283159,41234.7806525,61172.0314845,0.1391163,1455.4956611,1248.6586218,1982.2737534,1.4704442,10.3356411,1.160669,23.0538413),(12599,'Alces_metacarpus.tif',242,5,217,536.5306917,104.8511098,136.4558321,1.8,105.1932876,137.5911246,-0.035078,33.0030156,33.2378147,41193.3504621,60991.3115785,0.1099857,1834.9976392,1248.1692863,2436.0292788,1.7465962,9.959064,1.1441688,24.4608694),(12600,'Alces_metacarpus.tif',242,5,218,535.0716133,104.8736459,136.4354461,1.8,105.1154467,137.5721155,-0.0388385,33.0730866,47.3393315,41051.6417515,60798.3650458,0.1344519,1284.3097501,1241.2401126,1834.0606952,1.5075101,4.979532,1.1441688,11.4562139),(12601,'Alces_metacarpus.tif',242,5,219,533.4701318,104.9151573,136.3819824,1.8,105.1386426,137.44505,-0.0368126,33.097845,47.3545983,40725.7689707,60621.4062599,0.1204361,1280.1588105,1230.4658805,1825.3347631,0.9719942,4.3025443,1.2793395,9.6077891),(12602,'Alces_metacarpus.tif',242,5,220,533.3566004,104.9618234,136.3430138,1.8,105.2126811,137.422209,-0.0379863,33.421658,47.2880817,40712.8189989,60742.1288891,0.1282067,1284.5124331,1218.1567717,1834.6382536,2.0101984,12.0149388,1.1839206,29.1233505),(12603,'Alces_metacarpus.tif',242,5,221,533.3162006,104.9971771,136.2860527,1.8,105.2993234,137.296146,-0.0363158,33.5659899,46.0330711,40643.1047041,60836.8189511,0.1171746,1321.5894027,1210.8418326,1857.4665687,0.9719942,4.6987655,1.3045443,10.4320071),(12604,'Alces_metacarpus.tif',242,5,222,533.5360067,105.0286707,136.2526613,1.8,105.3434389,137.3886089,-0.0354087,33.3209531,20.7286085,40698.4066968,60935.2402795,0.1114427,2939.6686338,1221.4058405,2729.7620738,2.136265,10.8799898,1.141034,27.616328),(12605,'Alces_metacarpus.tif',242,5,223,533.2879979,105.057995,136.1896834,1.8,105.3822473,137.249604,-0.0369245,33.8045588,20.7978889,40618.9342516,61044.582753,0.1211272,2935.1336062,1201.5815514,2715.1292288,0.824218,1.4858801,0.9827937,3.1554585),(12606,'Alces_metacarpus.tif',242,5,224,539.0371817,105.013081,136.1560481,1.8,104.9119648,137.210162,-0.039383,33.7496138,20.784354,40706.3943379,61351.508844,0.1392712,2951.8121593,1206.1291904,2828.3526505,1.3764569,9.2150374,1.1071487,20.239785),(12607,'Alces_metacarpus.tif',242,5,225,530.8966861,105.2075674,136.1008658,1.8,105.4409985,137.1648234,-0.0311798,33.641447,33.9170668,40518.9420585,60737.1855276,0.0859931,1790.7558401,1204.4351727,2367.666221,1.1224587,8.7421521,1.4288993,19.0155894),(12608,'Alces_metacarpus.tif',242,5,226,529.4887122,105.264252,136.0877005,1.8,105.5434917,137.1798247,-0.0252415,33.7420922,33.4068012,40484.8947404,60549.4056288,0.0562141,1812.4873836,1199.8335652,2377.2656007,0.824218,1.1656203,0.7853982,2.3312405),(12609,'Alces_metacarpus.tif',242,5,227,526.9474835,105.3034028,136.0770849,1.8,105.5506251,137.1755377,-0.0214907,33.7478938,53.7709674,40452.2197445,60580.3020921,0.0405555,1126.6358968,1198.6590913,1784.4935811,33.1508261,39.106951,0.506075,147.6551163),(12610,'Alces_metacarpus.tif',242,5,228,524.0134754,105.322389,136.0410821,1.8,105.4354426,137.1035273,-0.0281195,33.2580087,53.9072692,40241.2404798,60410.276259,0.0690385,1120.6332119,1209.9714334,1776.8253832,0.956795,7.5202836,1.4056476,15.8601308),(12611,'Alces_metacarpus.tif',242,5,229,529.73528,105.2703602,136.0126928,1.8,105.0893867,137.0594514,-0.027036,32.2334105,53.8371383,40264.992784,60627.3769798,0.0645187,1126.1255505,1249.169484,1782.3215624,1.400074,2.4029878,1.0303768,6.0695092),(12612,'Alces_metacarpus.tif',242,5,230,520.4143878,105.3583752,135.9349157,1.8,105.5084651,136.9548087,-0.0216529,32.3721714,22.7866185,40156.8280668,60215.7824121,0.0406597,2642.5940434,1240.4737268,2614.5929544,0.824218,1.1656203,0.7853982,2.3312405),(12613,'Alces_metacarpus.tif',242,5,231,527.1629151,105.3063826,135.9119555,1.8,105.1560225,136.8914561,-0.0274758,32.3279391,23.7386948,40193.2967392,60694.4120654,0.0663104,2556.7712371,1243.2990755,2596.3262527,0.824218,4.2027037,1.3734008,8.9249845),(12614,'Alces_metacarpus.tif',242,5,232,525.1033454,105.3378653,135.866952,1.8,105.2017698,136.8417082,-0.0285272,30.347413,53.9465512,40136.8694246,60772.1944406,0.0712021,1126.5260359,1322.5796041,1774.7005762,0.824218,4.2027037,1.3734008,8.9249845),(12615,'Alces_metacarpus.tif',242,5,233,522.3359804,105.4190404,135.8173371,1.8,105.2833365,136.7824138,-0.0243245,20.6395742,21.1252903,39862.9266187,60514.2730176,0.0514992,2864.5416063,1931.3831881,4477.8930586,2.2167559,13.8532388,1.1737169,33.6858372),(12616,'Alces_metacarpus.tif',242,5,234,520.1579902,105.4650814,135.7933029,1.8,105.342335,136.7674254,-0.0246309,21.0725528,21.0828591,39673.6312384,60331.9844255,0.0525844,2861.6604725,1882.7159456,4336.3339689,1.0541555,3.1385286,1.1659045,7.1351351),(12617,'Alces_metacarpus.tif',242,5,235,517.53133,105.5029831,135.7653589,1.8,105.3501822,136.7642472,-0.0243836,21.1111584,21.0602028,39523.3689262,60196.3023939,0.051274,2858.2964248,1872.1553882,4021.8251891,2.6448354,15.7736032,1.2242575,39.2139553),(12618,'Alces_metacarpus.tif',242,5,236,514.3194635,105.5300994,135.7053476,1.8,105.3920171,136.6828183,-0.0260628,34.0136325,31.7086804,39386.6551096,60212.2620605,0.0582136,1898.9204609,1157.9667393,2312.5470295,0.412109,0.5828101,2.3561945,1.1656203),(12619,'Alces_metacarpus.tif',242,5,237,513.0658325,105.5646323,135.6324213,1.8,105.4098956,136.5517831,-0.0262306,34.0985654,21.2683168,39325.7471704,60251.5707247,0.0588219,2832.9261464,1153.2962358,2727.1722866,1.5694158,6.7086485,1.3854484,15.8187118),(12620,'Alces_metacarpus.tif',242,5,238,513.0247121,105.6131066,135.5773207,1.8,105.4198921,136.5013895,-0.0258,34.1361403,33.0125872,39234.9809135,60414.5245009,0.0569025,1830.0451328,1149.3678112,2273.3697135,1.7056609,10.8799898,1.141034,27.4749145),(12621,'Alces_metacarpus.tif',242,5,239,512.4644149,105.6548051,135.5179534,1.8,105.4653439,136.4118858,-0.0242364,34.184708,34.6385608,39232.58183,60659.9189801,0.0501607,1751.2251563,1147.6646766,2240.1428807,0.824218,1.6991689,1.815775,4.3210788),(12622,'Alces_metacarpus.tif',242,5,240,510.6908351,105.6670411,135.4702164,1.8,105.4543746,136.4051294,-0.025445,34.2583287,24.8823874,39288.5445095,60756.8414157,0.0550961,2441.7609302,1146.8319084,2485.7036908,0.824218,1.1656203,2.3561945,2.3312405),(12623,'Alces_metacarpus.tif',242,5,241,509.3977306,105.7390586,135.4154041,1.8,105.5617423,136.4033278,-0.0223147,34.2602443,23.9312984,39076.3064718,60620.8503181,0.0422681,2533.1199927,1140.5729076,2646.4481641,2.3819573,11.7288278,1.2490458,32.0374012),(12624,'Alces_metacarpus.tif',242,5,242,507.8617638,105.7713624,135.3905003,1.8,105.6407295,136.4063511,-0.0201861,34.2483989,33.0204943,38867.7556048,60594.7622176,0.0344853,1835.0652685,1134.8780339,2242.337214,2.2573761,12.9339213,1.1784562,33.3444349),(12625,'Alces_metacarpus.tif',242,5,243,505.7463033,105.8126795,135.3477921,1.8,105.6672092,136.3141219,-0.0201362,29.6686544,33.4732123,38729.9674264,60656.5802108,0.0341726,1812.0931949,1305.4170537,2222.5171615,2.5655027,12.7820242,1.2082521,32.6616304),(12626,'Alces_metacarpus.tif',242,5,244,505.5100799,105.8629424,135.2747746,1.8,105.7335903,136.2247041,-0.018227,29.7955118,33.0560849,38631.710121,60866.4295192,0.0279876,1841.3078783,1296.561386,2235.7849535,2.2229557,12.9010523,1.1071487,32.7202058),(12627,'Alces_metacarpus.tif',242,5,245,503.7773117,105.903843,135.2032875,1.8,105.7587602,136.1171398,-0.0172357,23.2634674,21.1406747,38594.5626998,60949.1479797,0.0249402,2883.0275718,1659.0202174,3777.0946194,2.1057492,11.2483866,1.0743736,29.1233505),(12628,'Alces_metacarpus.tif',242,5,246,501.9136685,105.938071,135.1503475,1.8,105.8308378,136.0458327,-0.0144854,22.3979329,20.7311329,38540.9778074,61146.8866556,0.0175515,2949.5197907,1720.7381611,4173.1415335,1.236327,2.4029878,1.0303768,5.4866991),(12629,'Alces_metacarpus.tif',242,5,247,500.9547764,105.9843358,135.0911809,1.8,105.9271762,135.970748,-0.0121456,21.9849203,20.7422937,38442.4748633,61578.6001941,0.0123156,2968.7459351,1748.58377,4435.4412299,1.9462982,9.7957191,1.1824776,27.7163224),(12630,'Alces_metacarpus.tif',242,5,248,499.2523724,106.0292577,135.008287,1.8,105.9771149,135.8567708,-0.0132821,17.1615785,20.8196703,38279.9292983,61860.980542,0.0146784,2971.2756982,2230.5599285,4609.2441424,1.6296431,9.959064,1.1441688,23.7366458),(12631,'Alces_metacarpus.tif',242,5,249,498.1266829,106.1081358,134.9523798,1.8,105.9954282,135.8677064,-0.0148974,33.2374822,52.0572076,38000.7601369,61868.4259131,0.0184239,1188.4699306,1143.3104309,1755.5952844,1.4570253,2.060545,0.6435011,4.903889),(12632,'Alces_metacarpus.tif',242,5,250,495.4744961,106.1215687,134.8995908,1.8,106.0304226,135.8581645,-0.0146235,17.9818338,20.9131799,37654.5716165,61813.172686,0.0176581,2955.704155,2094.0340116,4538.1459344,2.188479,10.691032,1.089909,25.7264841),(12633,'Alces_metacarpus.tif',242,5,251,493.5852749,106.1305709,134.8513747,1.8,106.0451615,135.7903135,-0.0152495,34.2227192,25.0503272,37522.1862293,61876.2825655,0.019129,2470.0788169,1096.4115962,2365.5671335,2.128227,12.6417417,1.2387369,29.8475741),(12634,'Alces_metacarpus.tif',242,5,252,492.8079506,106.1617964,134.8005229,1.8,106.1228935,135.6868883,-0.0167443,34.1946394,23.0794419,37478.4102129,62066.7274127,0.0230257,2689.2646577,1096.0317428,2412.9520623,1.7613369,9.7696782,1.088283,22.8124334),(12635,'Alces_metacarpus.tif',242,5,253,492.7229822,106.1808092,134.7493439,1.8,106.129696,135.6268199,-0.015757,21.4070971,20.969217,37547.9423459,62199.1420587,0.0203879,2966.2119535,1753.9950533,4500.0271259,2.1325026,10.1365411,1.1071487,25.6264897),(12636,'Alces_metacarpus.tif',242,5,254,492.1751909,106.1846172,134.6922913,1.8,106.1724144,135.4994045,-0.0153299,21.4081897,21.0903721,37551.0967388,62345.1858434,0.0192757,2956.0970098,1754.0528805,4426.6570902,2.0539716,9.038256,1.1479424,21.4054053),(12637,'Alces_metacarpus.tif',242,5,255,491.3218017,106.2109973,134.6029846,1.8,106.1798048,135.3654289,-0.0167111,21.4887923,21.4057087,37528.9102548,62495.2889669,0.0228662,2919.5617767,1746.4411074,4437.9963696,29.7097144,40.0340085,0.3575659,119.0145815),(12638,'Alces_metacarpus.tif',242,5,256,491.126853,106.2185731,134.5377814,1.8,106.1430655,135.3302613,-0.0199746,21.5423137,21.8597906,37430.8922247,62755.3414051,0.0326542,2870.8116453,1737.5520895,4421.3123426,29.8617255,40.1800992,0.3671738,119.0145815),(12639,'Alces_metacarpus.tif',242,5,257,486.8420485,106.2780554,134.4403406,1.8,106.1577146,135.2938283,-0.020645,17.388218,21.1012258,37067.3512062,62400.4911961,0.0345785,2957.1974537,2131.751007,4530.3274204,2.3705024,12.9339213,1.1784562,31.8374124),(12640,'Alces_metacarpus.tif',242,5,258,485.7714778,106.3300869,134.3923611,1.8,106.2162324,135.2206326,-0.0213088,22.8874264,21.1407284,36825.1290705,62479.2511084,0.0367566,2955.3972788,1608.9676656,4124.465891,29.7744437,40.3045973,0.2797042,119.1145759),(12641,'Alces_metacarpus.tif',242,5,259,485.4738054,106.3599312,134.3502137,1.8,106.2524634,135.1974682,-0.0212576,18.1077393,21.5832075,36646.6444468,62738.4959662,0.0365575,2906.8198506,2023.8111347,4471.4437396,2.1035029,11.3386158,1.237552,30.5303787),(12642,'Alces_metacarpus.tif',242,5,260,482.9415316,106.3969401,134.2970124,1.8,106.2628931,135.1384739,-0.0212454,17.730632,22.0683087,36517.0877172,62924.5817117,0.0363254,2851.354967,2059.5480029,4295.1148313,2.3064275,10.5067592,1.1246908,27.8163168),(12643,'Alces_metacarpus.tif',242,5,261,483.0642236,106.4541924,134.2234551,1.8,106.2840476,135.0303478,-0.0192687,34.2479213,25.9334045,36476.9994705,63290.831855,0.0298885,2440.5138134,1065.0865249,2322.4053742,2.1228777,11.6343268,1.1705557,32.7202058),(12644,'Alces_metacarpus.tif',242,5,262,482.9587208,106.5195098,134.1364331,1.8,106.3478201,134.9546682,-0.0169028,34.8280315,24.6899012,36327.4595314,63682.3528304,0.0229951,2579.2874661,1043.0523335,2342.6043999,2.1035029,11.4281326,1.1232764,29.3647584),(12645,'Alces_metacarpus.tif',242,5,263,482.6305298,106.5593974,134.0650152,1.8,106.4750309,134.8064217,-0.0130622,17.629586,21.3408377,36141.6184292,64270.7198761,0.0137234,3011.6306031,2050.0548527,4495.2269257,1.90762,10.3356411,1.160669,24.9022661),(12646,'Alces_metacarpus.tif',242,5,264,484.3960296,106.5720524,133.983686,1.8,106.437259,134.632899,-0.0118345,32.1032273,34.4231948,36005.0917831,64890.5292479,0.0113069,1885.0815462,1121.5411921,2143.5283554,29.259739,41.1387177,0.1915017,119.2559894),(12647,'Alces_metacarpus.tif',242,5,265,484.8980173,106.6864503,133.931813,1.8,106.550894,134.7487238,-0.0045249,17.3346151,21.8689403,35692.5903709,65256.4694563,0.0016546,2983.9795011,2059.0356497,4486.7038465,29.5352447,41.2808991,0.2522425,119.9387939),(12648,'Alces_metacarpus.tif',242,5,266,486.3691385,106.7180798,133.8818147,1.8,106.6262924,134.7495707,0.000971,23.5313899,22.2320709,35602.4298168,65813.6369597,0.0000765,2960.3016863,1512.9760701,3784.8508123,2.2296676,13.0970289,1.1493771,35.3342732),(12649,'Alces_metacarpus.tif',242,5,267,486.3153577,106.7488685,133.8176752,1.8,106.6778661,134.6415624,0.004172,23.5545113,22.2417681,35473.5899021,66358.7974062,0.0014111,2983.5216818,1506.0210508,3794.4801788,1.9288419,11.8655907,1.2160907,29.3647584),(12650,'Alces_metacarpus.tif',242,5,268,488.9417607,106.7710445,133.7510672,1.8,106.6662731,134.5442727,0.0068347,22.4464075,21.8527798,35539.5477592,67323.606116,0.0038064,3080.7799582,1583.3067158,4491.3360306,2.2869683,13.0970289,1.1493771,33.1444461),(12651,'Alces_metacarpus.tif',242,5,269,491.206572,106.8077844,133.6668148,1.8,106.6791049,134.4261808,0.0114566,17.1411661,21.8616023,35564.6903707,68284.8023128,0.0107449,3123.5040094,2074.8116094,4546.2410694,2.3001225,9.7957191,1.1824776,25.3850818),(12652,'Alces_metacarpus.tif',242,5,270,492.8388809,106.7955758,133.6104452,1.8,106.6738771,134.4180584,0.0131109,22.5668974,22.2509238,35599.4881937,69385.5451438,0.0141186,3118.3219939,1577.5091956,4618.083408,29.259739,42.8771639,3.1127545,149.6863736),(12653,'Alces_metacarpus.tif',242,5,271,496.9067614,106.84594,133.5391445,1.8,106.7906239,134.3167496,0.0187173,17.6806713,22.6523093,35608.4911064,70744.4284676,0.0290106,3123.0559162,2013.978462,4562.3632135,1.236327,2.2192749,1.9513027,5.8281014),(12654,'Alces_metacarpus.tif',242,5,272,500.3569613,106.8687843,133.4590425,1.8,106.7578794,134.2569976,0.0206007,36.116605,22.6148757,35705.970411,72077.4856656,0.035386,3187.1714211,988.6303095,2890.4065458,1.0002064,3.5210608,1.2120257,7.9593531),(12655,'Alces_metacarpus.tif',242,5,273,503.0781109,106.9814732,133.40814,1.8,106.9364934,134.2210781,0.0246612,36.4921974,22.5590444,35738.386674,73197.0188395,0.0509828,3244.6861428,979.3432365,2594.033844,29.0078725,43.1633767,0.1824154,122.6528558),(12656,'Alces_metacarpus.tif',242,5,274,505.315543,107.0209518,133.3826241,1.8,106.9517852,134.1478354,0.0280418,17.8276755,22.799091,35842.876486,74078.3061383,0.0662078,3249.1780615,2010.5187836,4672.8818597,2.4049406,13.0970289,1.1493771,32.0788202),(12657,'Alces_metacarpus.tif',242,5,275,504.4180484,106.9972476,133.286203,1.8,106.8556919,133.9283448,0.0252834,17.0930311,23.6438786,35873.3782869,75310.2756066,0.0537299,3185.191267,2098.7136911,4617.8739823,30.3231135,44.6297113,3.0676536,164.9222753),(12658,'Alces_metacarpus.tif',242,5,276,512.407186,107.0496973,133.2775799,1.8,107.0317407,134.04467,0.0296689,18.3430676,23.308312,36358.0417551,76988.1674496,0.0751519,3303.0348775,1982.1134902,4771.7253811,1.3006395,5.2128123,1.2490458,11.5976274),(12659,'Alces_metacarpus.tif',242,5,277,515.0595787,106.9977816,133.1698491,1.8,106.9258176,133.7420645,0.0282441,22.8268463,23.3341228,36623.6916792,78926.2279819,0.0684613,3382.4381847,1604.4131208,4812.2131178,29.2920675,44.3089049,0.1682068,126.0497222),(12660,'Alces_metacarpus.tif',242,5,278,520.7420127,107.0085468,133.1080479,1.8,106.9160801,133.6630782,0.0300294,36.5946604,24.2045999,37030.6555418,80836.8880406,0.0782408,3339.7324639,1011.9141731,3100.3120257,2.0374612,8.8483555,1.0863184,24.6608582),(12661,'Alces_metacarpus.tif',242,5,279,525.7289,107.0446717,133.0322226,1.8,106.9549079,133.5268745,0.0297454,16.4916515,23.7328719,37530.2532828,82933.0221821,0.0775034,3494.4368571,2275.712251,4975.7578635,0.824218,1.1656203,2.3561945,2.3312405),(12662,'Alces_metacarpus.tif',242,5,280,532.1859822,107.0206012,132.9848156,1.8,106.9126591,133.4838807,0.0283071,36.6383596,24.1873078,38236.3297883,84869.0282231,0.0710533,3508.8249085,1043.6146772,2854.6042986,1.6102599,9.2150374,1.1071487,23.3952436),(12663,'Alces_metacarpus.tif',242,5,281,540.6121074,107.1232594,132.9611022,1.8,107.0076448,133.5135313,0.0308991,36.7495329,24.0948741,38961.1439462,87138.5286813,0.0859979,3616.4757893,1060.1806576,2888.0493989,1.8113126,6.0847165,1.076855,15.1944826),(12664,'Alces_metacarpus.tif',242,5,282,547.5043244,107.1814415,132.9563639,1.8,107.0363559,133.5190017,0.0326273,36.7968591,24.5263146,39646.1724587,89316.3727212,0.0971063,3641.6548649,1077.4336011,2951.1270923,1.8262587,7.0421217,1.2120257,17.3257343),(12665,'Alces_metacarpus.tif',242,5,283,559.5748263,107.2987072,132.9885546,1.8,107.2123622,133.5914628,0.038878,37.2956334,24.7545844,40675.6604897,92013.4603823,0.1408954,3717.027075,1090.6279592,3041.9876026,2.1448147,12.2528815,1.2277724,31.4545911),(12666,'Alces_metacarpus.tif',242,5,284,567.0890983,107.3689245,132.9864069,1.8,107.2392283,133.5578982,0.0414535,36.1216872,32.5445378,41717.9844911,94904.6365509,0.1623208,2916.1463976,1154.9290104,2809.9974701,1.5647305,6.1264407,1.2277724,14.2702702),(12667,'Alces_metacarpus.tif',242,5,285,576.841214,107.4408879,132.9757405,1.8,107.308413,133.5216492,0.0440667,36.971234,32.0915957,42813.7630052,98383.4160441,0.1865713,3065.7065776,1158.0290502,2900.0814425,1.771262,9.5854108,1.1263771,23.9780537),(12668,'Alces_metacarpus.tif',242,5,286,582.3617397,107.4742083,132.9207957,1.8,107.3634739,133.4447975,0.0436615,37.426799,30.8661948,43861.2778556,101964.7906955,0.1849115,3303.4454473,1171.9216977,3005.9326172,1.4579913,5.4982198,1.3439975,13.1046499),(12669,'Alces_metacarpus.tif',242,5,287,593.745238,107.4908858,132.8793042,1.8,107.4026994,133.3409546,0.0446525,36.6349705,25.5260228,45231.2693253,106009.0733972,0.1971746,4152.9804457,1234.6473519,3938.9846697,1.8247791,6.5160154,1.2490458,17.4257287),(12670,'Alces_metacarpus.tif',242,5,288,603.7540602,107.5419271,132.8505675,1.8,107.3939458,133.3268423,0.0443068,18.9627784,25.7930231,46664.1564794,110415.3937644,0.197408,4280.8240551,2460.8290723,5965.2460703,31.5134519,49.1309291,0.1430833,139.1543721),(12671,'Alces_metacarpus.tif',242,5,289,613.0629611,107.5843836,132.782681,1.8,107.4081593,133.2986202,0.0416529,18.7550941,26.3966543,48332.8581821,114641.5904902,0.1771714,4343.0348817,2577.0522824,6125.5691068,0.9123895,2.4029878,2.6011732,4.903889),(12672,'Alces_metacarpus.tif',242,5,290,621.4241892,107.6418253,132.7587028,1.8,107.4604255,133.2604206,0.0410141,18.9296998,26.9173718,49746.8487428,118716.7963367,0.1741241,4410.4155953,2627.9787452,6109.5377246,32.556611,50.3549307,0.1395822,150.8519939),(12673,'Alces_metacarpus.tif',242,5,291,628.0852778,107.6452783,132.7337475,1.8,107.5348895,133.2615068,0.0413456,23.3708884,26.5097009,51233.8835985,122880.7033416,0.1788458,4635.3108155,2192.2095038,6196.8241777,0.824218,1.4858801,2.1587989,3.1554585),(12674,'Alces_metacarpus.tif',242,5,292,634.1472647,107.6707845,132.6892016,1.8,107.5595118,133.1736522,0.0393719,22.6788825,27.3428966,52753.2846855,127261.3316913,0.1637521,4654.2739644,2326.0971804,6171.2989136,0.824218,1.6991689,1.815775,3.9796765),(12675,'Alces_metacarpus.tif',242,5,293,640.8668687,107.7369693,132.6528938,1.8,107.578631,133.0575361,0.0389593,22.4024038,27.5120728,54408.7582082,131757.6645426,0.1620391,4789.0853422,2428.701789,6393.5025506,34.0746605,52.0449779,0.1430169,176.8198859),(12676,'Alces_metacarpus.tif',242,5,294,650.0943009,107.7566539,132.6465986,1.8,107.6074602,133.0607699,0.0398766,37.5302813,27.6254053,56338.4179422,136864.4414724,0.1721993,4954.2962403,1501.1456361,4577.0121528,0.824218,1.4858801,2.1587989,3.1554585),(12677,'Alces_metacarpus.tif',242,5,295,663.3081447,107.8048225,132.6650737,1.8,107.6787985,133.0584214,0.0412703,36.4695084,27.5320638,58743.6794148,142429.0219535,0.188188,5173.2054331,1610.7614823,5427.4075763,34.2757361,53.2131507,0.1320398,178.1683386),(12678,'Alces_metacarpus.tif',242,5,296,670.6805282,107.8152395,132.6628287,1.8,107.6856427,133.0654222,0.0421245,22.5067233,28.268944,61082.9908025,146958.6065448,0.198234,5198.5884689,2713.98862,7286.5680088,0.737621,1.8430075,1.1071487,3.9796765),(12679,'Alces_metacarpus.tif',242,5,297,679.5602641,107.9154446,132.6644047,1.8,107.7770766,133.0849823,0.0419701,22.5086319,28.417884,63370.3180965,151833.1033931,0.1993894,5342.8715359,2815.3784954,7183.8296078,35.3531036,55.173377,0.2413555,173.5058575),(12680,'Alces_metacarpus.tif',242,5,298,685.8671205,107.9832553,132.6798372,1.8,107.7866413,133.042871,0.0427662,22.6056186,28.8552323,65692.5550016,155710.2598029,0.2089423,5396.2573697,2906.0277564,7224.0245244,1.3491319,7.1141044,1.3961241,17.3257343),(12681,'Alces_metacarpus.tif',242,5,299,694.699406,107.9855928,132.6269924,1.8,107.8296331,132.9960442,0.0431812,22.7860678,29.1000557,68279.4056242,161133.6001447,0.2157564,5537.2265247,2996.5418437,7510.4625134,37.7479376,55.5231811,0.1040999,179.1925455),(12682,'Alces_metacarpus.tif',242,5,300,710.4258126,108.1366506,132.5946822,1.8,108.5387038,133.3250338,0.05698,26.176594,34.7192025,71896.4921137,169000.4285077,0.3840097,4867.6356717,2746.5946185,6618.7574332,0.824218,3.7994572,1.7894653,8.4421688),(12683,'Alces_metacarpus.tif',242,5,301,718.2184576,108.0146076,132.5646524,1.8,108.1478526,133.1810225,0.0592801,55.5882552,46.6367939,74696.3785526,172749.9034116,0.420159,3704.1547901,1343.7438944,4104.1707886,37.4695256,57.4844047,0.2241121,173.0644608),(12684,'Alces_metacarpus.tif',242,5,302,722.5614689,107.7688385,132.0681755,1.8,107.6145501,131.5753428,0.0016367,56.3004093,52.4898194,79988.6288244,180538.1132262,0.000322,3439.4881784,1420.7468438,3873.734775,0.412109,0.5828101,2.3561945,1.1656203),(12685,'Alces_metacarpus.tif',242,5,303,724.5895936,107.6300963,131.7620027,1.8,107.534918,130.4889099,-0.002829,55.9863829,52.5055309,89298.3029333,188641.3258944,0.0009663,3592.7896103,1595.000396,4088.2757193,0.412109,0.5828101,2.3561945,1.1656203),(12686,'Alces_metacarpus.tif',242,5,304,757.9830413,107.492058,131.8429545,1.8,106.7708494,129.6443321,0.0523247,57.601443,51.0201941,110609.9858558,205039.2620155,0.3455615,4018.7864007,1920.2641463,4687.0377924,0.412109,0.5828101,2.3561945,1.1656203),(12687,'Alces_metacarpus.tif',242,5,305,764.4933895,107.9270765,131.5407255,1.8,108.0146145,128.940935,0.0185889,56.2477637,53.3709114,112644.919418,211475.3939527,0.0440231,3962.3717962,2002.6559637,4654.9550818,40.2448891,61.5092528,0.2092216,186.427675),(12688,'Alces_metacarpus.tif',242,5,306,830.7749007,106.819471,132.7507539,1.8,106.329936,131.6804068,-0.0474726,57.5469976,48.5491798,106985.8743058,240693.8325568,0.3118113,4957.732209,1859.1043624,5205.2653763,0.8025507,2.060545,2.4980915,4.079671),(12689,'Alces_metacarpus.tif',242,5,307,829.303059,107.5578239,132.9395161,1.8,106.985975,132.4552045,-0.0511144,57.4884414,48.4757626,104512.1952522,236109.8561853,0.3608037,4870.6785307,1817.9688429,5314.6152756,0.5828101,1.7484304,2.3561945,3.4968608),(12690,'Alces_metacarpus.tif',242,5,308,900.6639912,108.0520575,133.4867677,1.8,106.5040467,132.9707573,-0.0014634,57.7070139,52.4275925,122335.2713326,255252.2636285,0.0003222,4868.6626933,2119.9376465,5676.554164,0.412109,0.5828101,2.3561945,1.1656203),(12691,'Alces_metacarpus.tif',242,5,309,928.6843083,107.950061,133.3677382,1.8,107.8318379,133.3347984,-0.0445783,58.2712134,49.1924486,120354.0211522,259506.9569256,0.3073799,5275.3413227,2065.4112745,6014.0762537,46.5761922,64.8204358,0.2048767,272.0735588),(12692,'Alces_metacarpus.tif',242,5,310,992.2624767,107.9110597,133.3401944,1.8,107.5680795,133.1782163,-0.0184517,56.5312255,53.2759496,125616.5854821,279679.9149926,0.0562983,5249.6467361,2222.0743383,6556.5579164,0.412109,0.5828101,2.3561945,1.1656203),(12693,'Alces_metacarpus.tif',242,5,311,1075.4946391,107.772172,133.3311072,1.8,107.3544822,133.0496917,-0.0032174,57.5737086,50.0109751,135530.6226014,310257.0471481,0.0018558,6203.779205,2354.0366912,7238.3411695,46.9718055,68.0678827,0.2508523,335.7998526),(12694,'Alces_metacarpus.tif',242,5,312,1083.0218802,107.9999338,133.01783,1.8,107.7353919,131.7813059,0.0404521,57.1418814,41.4105197,133470.0078089,309788.09547,0.2952086,7480.9033451,2335.7650215,7375.8348387,0.412109,0.5828101,2.3561945,1.1656203),(12695,'Alces_metacarpus.tif',242,5,313,1026.4164197,108.3146869,132.9070656,1.8,107.7300858,131.8768469,0.0762834,56.4760303,50.1949078,124558.6052032,291121.5849249,0.9935505,5799.823085,2205.5127566,6900.2954827,47.3499516,66.6063004,0.1804069,325.550678),(12696,'Alces_metacarpus.tif',242,5,314,995.2915917,108.3699709,132.8880582,1.8,108.0271722,132.3622527,0.0685089,56.3629354,42.4948414,111620.287819,278814.1390014,0.7773433,6561.1290593,1980.3845759,6623.1534751,1.2913599,3.5450957,2.1910458,8.1593419),(12697,'Alces_metacarpus.tif',242,5,315,966.2927229,108.3626339,132.7708578,1.8,107.927125,132.4719988,0.0601286,52.6876823,40.8999993,101252.6062406,267071.081197,0.5815609,6529.8554047,1921.7510016,6545.1286866,1.475242,2.3312405,2.3561945,6.6523194),(12698,'Alces_metacarpus.tif',242,5,316,950.7365104,108.2979996,132.6638649,1.8,107.8146892,132.6958578,0.0613565,53.5516032,40.5435084,95743.2519697,261008.6452049,0.5957783,6437.7419558,1787.8690127,6417.751194,0.737621,1.4858801,2.5535901,2.9140507),(12699,'Alces_metacarpus.tif',242,5,317,954.6726409,108.292944,132.7615911,1.8,108.1022564,132.777915,0.0560498,56.179757,41.572368,95809.481212,263610.4499166,0.4993405,6341.0015551,1705.4093209,6044.0814123,2.8350726,4.3807788,2.2896263,15.1944826),(12700,'Alces_metacarpus.tif',242,5,318,932.8662862,108.1415273,132.4856782,1.8,108.4718432,131.6049914,0.0271687,57.1918773,47.7732512,94446.0558195,266448.7765293,0.1147362,5577.3632698,1651.3893285,5609.4134575,0.412109,0.5828101,2.3561945,1.1656203),(12701,'Alces_metacarpus.tif',242,5,319,898.7177984,108.4688441,132.5821926,1.8,107.9515892,130.6384084,0.0441203,57.1859591,55.5868074,97481.0190636,266303.009526,0.2913853,4790.7592065,1704.6320557,6108.5614576,0.412109,0.9215037,2.677945,1.7484304),(12702,'Alces_metacarpus.tif',242,5,320,890.7841913,108.1699818,132.534794,1.8,107.6895574,129.4574908,0.0291034,57.7082993,53.1042575,106979.0993319,273178.4002011,0.1257164,5144.1901873,1853.7905402,5292.2376519,0.783105,2.2192749,2.7610863,4.5624867),(12703,'Alces_metacarpus.tif',242,5,321,870.5015548,108.1474667,132.410234,1.8,107.4595768,129.1345254,0.0333614,57.8369813,53.9029785,108044.4696474,271848.0598908,0.161415,5043.2845729,1868.0862524,5365.8485255,0.412109,0.5828101,2.3561945,1.1656203),(12704,'Alces_metacarpus.tif',242,5,322,862.5216808,108.1634049,132.5962477,1.8,107.7235763,130.4807471,0.0177042,56.942117,47.6581651,101546.6714883,268589.0386308,0.0450527,5635.7402412,1783.3315108,5641.1666824,0.412109,0.5828101,2.3561945,1.1656203),(12705,'Alces_metacarpus.tif',242,5,323,872.2429177,108.3140307,132.8002453,1.8,108.0156588,131.5601834,0.0137499,56.3970495,47.2404083,100265.1725776,270757.61612,0.0274828,5731.4834044,1777.8442921,5597.3054317,32.2397392,43.4457497,0.9064254,210.5471421),(12706,'Alces_metacarpus.tif',242,5,324,897.9935858,108.3087197,132.7883497,1.8,107.7624639,131.7340354,0.0194856,54.2780338,53.6398522,104212.7671234,281457.2604139,0.0568183,5247.1669598,1919.9805118,6026.1130619,33.2410424,44.0243528,0.9048271,201.5978948),(12707,'Alces_metacarpus.tif',242,5,325,947.6338007,108.6296335,132.8677468,1.8,108.0126679,131.6335479,0.0385299,57.0037952,38.8392042,110300.7999891,296720.5505538,0.234353,7639.7175568,1934.9729199,6528.9304921,0.412109,0.5828101,2.3561945,1.1656203),(12708,'Alces_metacarpus.tif',242,5,326,949.0745062,108.1734891,132.312045,1.8,108.0419418,130.0311852,0.0298539,56.7726548,53.8692484,118430.8909968,292265.5603518,0.1409366,5425.4620057,2086.0551876,5719.627847,41.3268924,69.4718484,0.1368635,337.7725345),(12709,'Alces_metacarpus.tif',242,5,327,969.0363112,108.3200003,131.9235457,1.8,108.0042688,128.0879049,0.0433798,56.5459271,56.9681559,131455.0664006,304725.7870627,0.3037332,5349.0547867,2324.7486281,5753.3664668,2.5806273,4.8059755,2.6011732,13.6874601),(12710,'Alces_metacarpus.tif',242,5,328,986.7232177,108.3922564,131.5746569,1.8,107.9656895,127.0120568,0.0347157,56.9571772,57.923976,136979.3823195,320347.390096,0.1981168,5530.4799881,2404.9538465,5849.5840966,1.8262587,4.4576404,2.5535901,13.1046499),(12711,'Alces_metacarpus.tif',242,5,329,993.4004663,108.3513995,131.5045871,1.8,107.2771831,127.3002244,0.0674468,56.5798343,58.3832673,123706.6217312,320277.4225763,0.7520335,5485.7742221,2186.4083412,6044.6920788,0.412109,0.5828101,2.3561945,1.1656203),(12712,'Alces_metacarpus.tif',242,5,330,966.900728,108.3484642,132.1006185,1.8,107.8188816,130.7709343,0.0413559,56.4928803,57.66169,95746.985418,296166.0193478,0.2754594,5136.2701926,1694.8504834,5163.5737414,34.1138408,45.4629265,0.798218,204.653359),(12713,'Alces_metacarpus.tif',242,5,331,937.0284501,108.4909777,132.2206315,1.8,108.3608648,131.8870507,0.0428472,55.6659469,44.5042996,78448.6051406,284370.3732716,0.2865369,6389.7280873,1409.2746024,5649.8547504,34.0095833,46.8029562,0.6981205,220.0306741),(12714,'Alces_metacarpus.tif',242,5,332,894.2717032,108.4704316,132.1545747,1.8,108.1301648,131.4940576,0.0478425,54.6727904,57.796402,67873.1340045,267906.0472613,0.3408904,4635.3412657,1241.4426549,4723.9153001,3.2054558,4.2429218,1.0636978,15.0944882),(12715,'Alces_metacarpus.tif',242,5,333,830.1941205,108.6105972,132.2157828,1.8,108.7330734,132.2634921,0.0435814,53.9029458,40.0768878,55536.1514095,238711.5885142,0.2626366,5956.3404705,1030.2990049,4411.3658249,3.296872,7.9591468,1.199905,29.264764),(12716,'Alces_metacarpus.tif',242,5,334,732.1861577,108.7584831,132.0558548,1.8,108.8296246,131.9452557,0.0503007,57.1531968,58.7591464,43641.7667057,189124.7949971,0.308498,3218.6443586,763.5927495,3201.6245309,30.4807001,37.4203141,0.6368933,136.923126),(12717,'Alces_metacarpus.tif',242,5,335,579.822055,108.6622674,131.9233864,1.8,108.641712,132.0211732,0.0391118,36.9432591,31.3339026,31546.3583361,114360.4890208,0.1477537,3649.7365324,853.9137876,3859.6210807,30.3503273,37.2656841,0.5726664,167.9120576),(12718,'Alces_metacarpus.tif',242,5,336,450.1891293,109.5609614,131.8279221,1.8,109.0981435,131.7701135,0.0369576,56.633836,45.0755365,21936.4358404,60601.3752556,0.1024362,1344.4404642,387.3379833,1327.0030753,18.7418515,33.3375549,1.4219064,106.792725),(12719,'Alces_metacarpus.tif',242,5,337,370.7850214,109.5673276,131.7452442,1.8,109.1907461,131.964423,0.0414661,54.8804946,26.1461589,13523.6789058,48788.6624201,0.1061962,1865.9973185,246.4204997,1025.0334441,19.4939172,29.8373746,1.0019485,101.023199),(12720,'Alces_metacarpus.tif',242,5,338,279.6194063,109.5358315,131.7993955,1.8,109.1448554,132.209112,0.0375046,53.9741853,18.6251912,7000.3543023,37302.2398114,0.065521,2002.7842655,129.6981931,802.274966,16.3830199,28.0052248,0.995038,82.973241),(12721,'Alces_metacarpus.tif',242,5,339,175.6492984,109.7109549,133.1798561,1.8,109.4566779,133.6333255,0.0611368,35.6312266,18.4028104,3062.620726,23961.1238204,0.1092848,1302.0361152,85.9532779,726.5165713,20.4867624,38.2374087,2.610415,158.0457044),(12722,'Alces_metacarpus.tif',242,5,340,33.8415003,108.1942385,133.5588955,1.8,108.5070272,135.8222186,0.0493294,35.109485,18.5023894,843.586694,7294.3244726,0.0137138,394.2368907,24.0273161,227.0761068,5.1113544,20.8064035,1.4317004,54.449857),(12723,'Alces_metacarpus.tif',242,5,341,1352.8539174,107.4140912,130.0767695,1.8,107.3752982,130.7632236,-0.1414726,46.4053043,48.5928979,280381.0273975,494524.3303245,4.4827554,10176.8849256,6042.0038471,14845.3477098,37.3575892,58.9877569,1.3020933,289.9921532),(12724,'Alces_metacarpus.tif',242,5,342,1230.5897727,106.9537993,128.1170075,1.8,107.0680345,128.7410509,-0.1850918,46.5198794,57.2532717,220306.6172342,455263.5819852,6.94658,7951.7478757,4735.7521127,10985.1822352,34.0745736,53.2195335,1.6172745,202.5221073),(12725,'Alces_metacarpus.tif',242,5,343,1106.6764901,106.635008,126.2814968,1.8,106.7444108,125.905463,-0.2075044,44.9781025,47.5355034,165464.3740638,419868.4096276,7.8285558,8832.7329924,3678.7762203,11099.7033391,43.8170613,67.0231658,2.9996956,342.7835243),(12726,'Alces_metacarpus.tif',242,5,344,1107.0353027,109.2687358,126.5841728,1.8,108.9145686,125.492546,-0.0001679,49.1050611,44.8566506,182441.1937709,495608.5689685,0.0000039,11048.7199225,3715.3236315,12556.0444483,0.412109,0.9215037,2.677945,1.7484304),(12727,'Alces_metacarpus.tif',242,5,345,1069.1658072,109.8082406,126.0542063,1.8,109.4700078,125.0117385,0.0114209,49.566008,44.8494474,172819.549325,485871.9892008,0.023242,10833.3996712,3486.6545878,11942.0231953,0.412109,0.9215037,2.677945,1.7484304),(12728,'Alces_metacarpus.tif',242,5,346,1078.389997,109.892531,125.9914724,1.8,109.5890203,125.1585931,0.0103471,46.0541083,45.3867047,171257.7403066,498043.6880542,0.0192424,10973.3388077,3718.6202602,12495.5404771,41.3843633,67.1838793,0.2226609,311.2875142),(12729,'Alces_metacarpus.tif',242,5,347,1091.4953016,109.6835794,125.9650039,1.8,110.1723353,125.4285456,0.0200516,47.15992,47.440047,172387.4915138,501463.9352221,0.0731314,10570.4771914,3655.3813406,11372.9320242,1.648436,2.060545,0.6435011,5.728107),(12730,'Alces_metacarpus.tif',242,5,348,1047.551725,110.0682792,126.0503138,1.8,110.0384927,125.6768022,0.0304924,48.8014541,47.5870451,176192.7010316,507482.980744,0.1622842,10664.3095809,3610.3985861,11440.4619583,1.400074,2.6387851,0.8960554,6.552325),(12731,'Alces_metacarpus.tif',242,5,349,992.6189219,110.1197271,125.7170933,1.8,109.9993047,125.2725603,0.02236,44.9213438,47.1790163,173433.4494743,499460.6136499,0.0827,10586.499096,3860.8250519,10796.6152841,1.8618271,2.7645112,2.0344439,7.7179452),(12732,'Alces_metacarpus.tif',242,5,350,961.5359862,110.450659,125.609981,1.8,109.9791266,125.3759259,0.0413874,50.691414,47.5128886,175514.6103252,504478.2610053,0.2743484,10617.713977,3462.4129923,11454.8423217,0.5828101,2.3312405,2.3561945,4.6624811),(12733,'Alces_metacarpus.tif',242,5,351,922.2502824,109.9345438,125.2073321,1.8,109.8125746,124.7475791,0.02258,50.020239,54.4052808,175998.7715884,485359.6311506,0.0783564,8921.1860324,3518.5511948,10489.1960128,0.7997352,2.6064062,2.8198421,5.3867047),(12734,'Alces_metacarpus.tif',242,5,352,887.5136035,109.7521172,124.7308672,1.8,110.0251535,123.6066138,0.0161791,49.4543407,55.988343,178080.9877395,470189.7556498,0.0387165,8397.9937691,3600.9172327,10320.6524957,0.412109,0.5828101,2.3561945,1.1656203),(12735,'Alces_metacarpus.tif',242,5,353,887.0621543,110.922561,125.027272,1.8,110.27022,124.338607,0.0587113,50.5611989,57.5484187,180624.1946102,496928.2141922,0.5090352,8634.958619,3572.3874909,10663.5747101,0.412109,0.5828101,2.3561945,1.1656203),(12736,'Alces_metacarpus.tif',242,5,354,845.6797233,110.889044,125.0091762,1.8,110.3308409,125.0858166,0.0428178,50.4929808,57.0270055,171156.2121494,474989.8788708,0.2582476,8329.2095496,3389.7030733,10245.9103621,0.5828101,1.1656203,2.3561945,2.3312405),(12737,'Alces_metacarpus.tif',242,5,355,807.8234543,110.8289781,124.6466172,1.8,110.6464442,125.0002013,0.0334124,48.5455851,54.6053478,165175.9091485,449123.541596,0.1502514,8224.9002996,3402.4908503,10160.7329545,1.4579913,3.322529,2.6224465,8.7835711),(12738,'Alces_metacarpus.tif',242,5,356,776.4746514,110.3228928,124.3899248,1.8,110.1117473,125.6219868,0.0180152,48.4485265,48.72022,159782.1834001,424169.213171,0.0419956,8706.2253242,3297.9781801,9454.032654,0.412109,1.3032031,2.8198421,2.5726484),(12739,'Alces_metacarpus.tif',242,5,357,764.3697196,109.8589066,124.3528833,1.8,110.2893684,125.2165335,-0.0626281,47.3967606,49.63279,166638.8670226,439139.1307482,0.4990256,8847.7623495,3515.8281897,9631.7003317,0.412109,1.3032031,2.8198421,2.5726484),(12740,'Alces_metacarpus.tif',242,5,358,763.2258116,108.8510422,124.5739312,1.8,109.3246015,125.2654863,-0.1390215,50.0518868,51.6069217,176667.8141797,463585.1676891,2.4426777,8983.0036805,3529.6933934,10033.4577795,28.435521,39.5646103,1.9551712,115.3763072),(12741,'Alces_metacarpus.tif',242,5,359,753.1336679,108.6878211,124.392012,1.8,108.5952613,125.1068986,-0.1607901,54.298096,55.8650737,181331.803887,468766.5436612,3.2173157,8391.0485214,3339.5609991,9928.8093107,0.412109,0.9215037,2.677945,1.7484304),(12742,'Alces_metacarpus.tif',242,5,360,729.3791134,109.8232711,123.8196593,1.8,109.2070895,125.0348776,-0.1332253,53.9431635,56.8164428,183721.9317866,453305.5728925,2.1448859,7978.4222786,3405.8427421,9383.0366111,0.412109,0.9215037,2.677945,1.7484304),(12743,'Alces_metacarpus.tif',242,5,361,743.218872,108.2057788,124.0561991,1.8,107.0729482,124.7425527,-0.1733959,51.8525529,51.9792672,189488.4565473,486942.6543373,3.6871099,9368.016913,3654.3708259,11404.2177458,26.787085,37.4634055,2.2627177,168.3434044),(12744,'Alces_metacarpus.tif',242,5,362,720.3090606,108.4765454,123.6420577,1.8,107.7298623,124.1351949,-0.1610643,51.8919977,51.3162123,188012.1595687,474716.471161,3.0875025,9250.8088554,3623.1436016,11308.2507315,0.412109,0.5828101,2.3561945,1.1656203),(12745,'Alces_metacarpus.tif',242,5,363,695.2939273,109.2655457,122.866871,1.8,108.5213679,123.4611171,-0.1177944,50.2332416,51.080106,185990.8073893,454625.2697738,1.6005043,8900.2413154,3702.5443984,10130.8759099,25.138649,36.0047442,2.1524498,150.7105804),(12746,'Alces_metacarpus.tif',242,5,364,663.5163712,110.0009004,121.8586086,1.8,109.177641,122.5526902,-0.0698056,47.8420616,50.0593123,181351.810362,431527.979764,0.5379922,8620.3337622,3790.6353613,9629.2942556,25.138649,35.21302,0.9600704,123.2356659),(12747,'Alces_metacarpus.tif',242,5,365,646.9064685,110.4869577,121.2121654,1.8,109.5201918,121.9664126,-0.0350093,45.9844821,49.6631129,181756.3466421,423472.7771785,0.1320926,8526.9076494,3952.5583034,9150.3702676,24.72654,34.6392262,0.9629943,121.6458053),(12748,'Alces_metacarpus.tif',242,5,366,640.5959581,111.0063082,120.8263753,1.8,109.9128915,121.5449008,0.0066392,48.3205144,55.8924357,185760.0078951,424354.4006786,0.0047065,7592.3404581,3844.3301012,9389.7449969,24.72654,31.8925508,2.144463,113.2036365),(12749,'Alces_metacarpus.tif',242,5,367,641.5591732,111.3603813,120.5596949,1.8,110.082736,121.2406795,0.0336811,49.3981293,57.3813111,191243.682849,429453.5129797,0.121254,7484.2053082,3871.476219,9498.6163195,24.72654,32.3472752,0.9757267,107.5755239),(12750,'Alces_metacarpus.tif',242,5,368,639.8364921,111.3286206,120.1436587,1.8,109.603154,120.6607434,0.0327324,49.9359225,59.3243174,194077.2028995,428134.2444308,0.1142139,7216.8423254,3886.5248336,9178.9073166,0.412109,0.5828101,2.3561945,1.1656203),(12751,'Alces_metacarpus.tif',242,5,369,633.7562866,111.0415328,119.7682596,1.8,110.1703469,120.6910349,-0.0160341,49.4028098,57.8018418,193832.9175741,419604.9179068,0.0271531,7259.3693374,3923.5201049,9229.4178289,24.72654,31.3229951,1.0010399,123.9356268),(12752,'Alces_metacarpus.tif',242,5,370,630.9253111,110.5117643,119.4295683,1.8,110.0062392,120.4293399,-0.0611097,50.7968995,51.5384663,195626.1955326,419495.288482,0.3921988,8139.4600767,3851.1444068,9461.9754638,0.412109,0.5828101,2.3561945,1.1656203),(12753,'Alces_metacarpus.tif',242,5,371,638.2135497,110.6525761,119.5368975,1.8,110.5706619,120.6819974,-0.0326838,50.6605062,52.0719107,210949.8411448,434826.1591879,0.1135864,8350.4936414,4163.9900025,10077.190393,0.412109,0.5828101,2.3561945,1.1656203),(12754,'Alces_metacarpus.tif',242,5,372,639.4424776,110.5747579,119.4859601,1.8,111.3879475,120.9250979,-0.0012332,43.6885235,48.7909281,226963.0391838,441726.5485139,0.0001622,9053.4565611,5195.026543,11370.5146683,24.72654,30.7980832,1.1430614,104.1372385),(12755,'Alces_metacarpus.tif',242,5,373,649.755611,110.820335,119.8062475,1.8,111.9769179,121.1464777,0.0476119,40.947837,48.4912433,248178.7289927,453930.4935357,0.2453025,9361.0817644,6060.8507578,11826.9258833,24.72654,30.0500659,1.1316837,105.1614453),(12756,'Alces_metacarpus.tif',242,5,374,692.4023777,112.5154095,120.80988,1.8,112.5900951,121.320141,0.1577419,52.9592863,48.4951597,272900.7033034,505089.2205402,2.8477132,10415.2501747,5153.0283421,12610.4836791,0.412109,1.3032031,2.8198421,2.5726484),(12757,'Alces_metacarpus.tif',242,5,375,696.5312954,112.120463,120.117684,1.8,111.6226369,120.7598613,0.1441022,42.0274907,59.4532667,276809.1148027,500711.8194382,2.3939903,8421.9395711,6586.3821547,12979.409278,0.824218,1.8430075,2.677945,3.7382687),(12758,'Alces_metacarpus.tif',242,5,376,705.939266,111.4034248,119.8371491,1.8,112.2233548,120.4871361,0.0583556,48.2232986,60.4529842,295533.9389037,512355.2069684,0.400211,8475.2674166,6128.4471969,12251.0907361,1.236327,3.7318057,3.0309354,8.6835767),(12759,'Alces_metacarpus.tif',242,5,377,706.0812059,110.1086049,119.6266282,1.8,110.7357908,120.790137,-0.0707528,46.6326982,53.8149489,300505.6427557,525363.8145242,0.58812,9762.4140659,6444.097256,13323.9441011,24.8261891,29.4448924,1.6829991,139.1058467),(12760,'Alces_metacarpus.tif',242,5,378,716.0085593,109.5207434,119.2609439,1.8,110.68292,120.1980809,-0.1490466,46.3408501,54.9807338,304298.1784698,544527.759717,2.6314369,9903.9740359,6566.5212858,12787.7313437,0.412109,0.5828101,2.3561945,1.1656203),(12761,'Alces_metacarpus.tif',242,5,379,719.4166096,109.3172544,118.6070832,1.8,110.4591578,119.5472289,-0.1829094,48.5447173,56.2733645,307331.7717337,553024.3917942,3.9669108,9827.4627223,6330.9004277,12377.565727,28.9532105,36.3614679,0.6162969,213.2126785),(12762,'Alces_metacarpus.tif',242,5,380,712.0940439,109.7468361,117.2893873,1.8,110.3959175,118.5501146,-0.1684144,48.8927178,56.9457006,305493.308946,537394.8833757,3.33453,9436.9702606,6248.2374145,12913.1326385,27.5216801,32.062504,0.6486425,179.0854447),(12763,'Alces_metacarpus.tif',242,5,381,729.0264766,109.2911882,116.6823444,1.8,109.8118513,117.7116534,-0.1974157,50.6858332,58.1000957,312344.4409585,552949.0263576,4.6741858,9517.1792623,6162.3617778,12354.5019229,32.0710901,63.3536333,2.9914161,405.2856224),(12764,'Alces_metacarpus.tif',242,5,382,752.2809992,107.9355055,117.012618,1.8,108.5259539,117.8107768,-0.2716461,52.9335085,59.8596336,320507.6024092,593969.3634989,9.0266579,9922.702956,6054.9094826,14000.8257404,4.6559031,10.5631825,2.782822,37.2241171),(12765,'Alces_metacarpus.tif',242,5,383,761.4924258,107.8363636,116.7661908,1.8,108.130617,117.6151645,-0.2908144,53.5310668,61.1551539,324372.2322026,612582.7867374,10.4344222,10016.8628019,6059.5136925,14285.1006491,1.2750318,7.1971743,0.2310907,15.1359072),(12766,'Alces_metacarpus.tif',242,5,384,771.8982988,107.4769329,116.1145094,1.8,107.678781,117.240614,-0.2971301,54.5585541,60.3626783,322573.0111709,619886.5416058,11.0276657,10269.3677502,5912.4186249,14484.4963434,0.412109,0.9215037,2.677945,1.7484304),(12767,'Alces_metacarpus.tif',242,5,385,772.2910781,106.8757128,115.4890273,1.8,106.8108926,116.4784633,-0.3192622,55.832152,60.3523996,314712.2803439,623735.2981533,12.679984,10334.888124,5636.7571245,13444.5330154,31.5338425,37.7816533,1.1071487,275.8875592),(12768,'Alces_metacarpus.tif',242,5,386,783.5468408,106.9537936,114.9102518,1.8,106.1907543,115.7824834,-0.3251702,56.3849292,60.7728566,316444.2779884,642029.5640939,13.3282758,10564.4131328,5612.2138027,14813.7082731,31.4714345,34.7077994,2.0928879,219.8235789),(12769,'Alces_metacarpus.tif',242,5,387,802.4916499,106.8542468,113.5257338,1.8,106.2695115,114.4740601,-0.3211813,57.233182,61.5475588,325195.5425191,647331.4185091,13.3292114,10517.5807346,5681.9406345,14717.3934636,30.8397218,35.9858714,2.7291822,245.1500853),(12770,'Alces_metacarpus.tif',242,5,388,829.1504144,106.9798663,111.9058583,1.8,106.7329105,113.0059203,-0.3070854,59.5967934,62.3483422,332316.2510918,645141.4969879,12.6271584,10347.3721052,5576.0760286,14519.756008,30.9782983,35.4030175,2.7091849,215.4439247),(12771,'Alces_metacarpus.tif',242,5,389,857.0514361,106.9727053,110.3923039,1.8,106.8758434,111.7173139,-0.29011,58.9991842,63.0063979,336429.7196946,641206.1235386,11.6886018,10176.84148,5702.2774876,14194.825431,30.8607813,34.5901621,2.7632987,202.9220849),(12772,'Alces_metacarpus.tif',242,5,390,878.5651106,106.4609067,109.2896058,1.8,106.4844928,110.7969786,-0.3021602,68.9492523,63.5633308,341856.1599067,645254.948436,12.9670057,10151.3709223,4958.0836395,13344.034187,29.9993032,34.7469234,2.1620884,187.0447978),(12773,'Alces_metacarpus.tif',242,5,391,877.7711117,105.699829,108.2121857,1.8,106.1772152,109.806441,-0.3191043,70.2927599,64.0316977,340127.7547883,634893.8637682,14.3980587,9915.3058066,4838.7309758,13385.5764743,29.2686701,35.029265,2.2142974,185.0549595),(12774,'Alces_metacarpus.tif',242,5,392,850.1103791,104.9021302,107.1925786,1.8,106.019444,108.6044288,-0.3326819,62.7049101,64.0969451,334069.3347533,610031.9129697,15.1112621,9517.3320904,5327.642356,13568.3643969,29.1688681,35.4341853,2.1491218,178.4440591),(12775,'Alces_metacarpus.tif',242,5,393,839.9751079,105.1222591,105.990396,1.8,106.6574816,107.2123531,-0.3335795,62.995954,64.842365,323974.4751104,609685.490634,15.0087644,9402.5794862,5142.7822662,13233.5451205,29.0669127,37.3817166,1.3258177,190.8244855),(12776,'Alces_metacarpus.tif',242,5,394,898.7928341,106.8086783,105.2448628,1.8,107.3760142,106.5576809,-0.2929273,63.8599767,65.708612,313577.0323601,666478.4318095,12.4902375,10142.9388181,4910.3843833,13644.1629535,30.4874862,40.1927776,1.3009472,196.4697544),(12777,'Alces_metacarpus.tif',242,5,395,999.6312577,109.1526928,104.8030733,1.8,108.4113357,106.1816855,-0.253881,60.2654262,66.9532565,300841.9712468,739480.5301579,10.5098847,11044.7283418,4991.9496182,14146.4273452,29.259739,41.9805387,1.3329604,182.0409144),(12778,'Alces_metacarpus.tif',242,5,396,1105.9999339,109.301085,104.5822085,1.8,108.6157931,105.8342358,-0.2222761,61.106911,66.1595715,281157.2510257,763024.8435526,8.9582919,11533.0983316,4601.0712421,14168.9532371,0.412109,0.5828101,2.3561945,1.1656203),(12779,'Alces_metacarpus.tif',242,5,397,1069.464303,109.2824367,104.3617731,1.8,108.7491873,105.1955713,-0.2110384,58.25903,65.7322028,253316.5161398,719361.2346594,7.8213395,10943.8175579,4348.1073414,13222.8455622,0.412109,0.5828101,2.3561945,1.1656203),(12780,'Alces_metacarpus.tif',242,5,398,1003.8339244,109.1688852,103.9721611,1.8,108.6422807,104.6140071,-0.2036082,63.8769695,65.3692806,222573.5411655,668161.005007,6.8405582,10221.3302459,3484.4098411,12125.800953,0.412109,0.5828101,2.3561945,1.1656203),(12781,'Alces_metacarpus.tif',242,5,399,927.5352538,109.0174277,103.3154915,1.8,108.7030962,103.6806844,-0.1997977,57.6005494,64.977627,186706.6453144,604815.3126145,6.0893878,9308.0547902,3241.4039001,10846.1289106,0.412109,0.5828101,2.3561945,1.1656203),(12782,'Alces_metacarpus.tif',242,5,400,859.0359702,109.0097442,102.6418075,1.8,108.7939524,102.8174895,-0.1949489,62.6741854,64.6194206,157442.7774715,541375.9675056,5.3727042,8377.9142986,2512.0833457,9656.4371063,29.259739,42.1178624,1.8585043,196.045514),(12783,'Alces_metacarpus.tif',242,5,401,784.7031518,109.0805493,101.5312185,1.8,108.9644482,101.6582433,-0.1834446,56.5369201,64.1366659,127182.4706467,477979.0538363,4.3519806,7452.5085926,2249.5472077,8423.2115788,29.1597165,42.0027833,1.849096,158.6628271),(12784,'Alces_metacarpus.tif',242,5,402,710.535484,109.2605153,100.276633,1.8,109.0582521,100.4659838,-0.1656793,55.5622834,63.663976,98156.0692581,422333.7179033,3.2210223,6633.7942538,1766.5953097,7254.1840232,0.412109,0.5828101,2.3561945,1.1656203),(12785,'Alces_metacarpus.tif',242,5,403,655.1857132,110.1272358,98.9700721,1.8,109.6692186,99.3349526,-0.0996393,36.957576,62.1698819,80319.2584838,364178.9664043,1.0805296,5857.8037386,2173.2826461,6152.9314714,27.8171899,41.4820002,1.9365436,132.7777733),(12786,'Alces_metacarpus.tif',242,5,404,612.0060285,111.1360415,97.7074536,1.8,110.6880387,98.1431316,-0.0143726,39.4939149,59.7840945,63353.1630376,314827.1003565,0.0210695,5266.0678925,1604.1246656,5278.0664078,1.6020656,2.6387851,0.8960554,6.3109171),(12787,'Alces_metacarpus.tif',242,5,405,588.0217351,111.3552922,96.921839,1.8,111.1148239,97.3413603,0.0176872,27.1858441,37.1274736,56458.8130721,297510.6004541,0.0306555,8013.2196379,2076.7724873,9501.8122349,26.3325486,39.5731945,1.7171116,134.8676059),(12788,'Alces_metacarpus.tif',242,5,406,573.3285872,111.1852506,96.3274665,1.8,110.9956765,96.6799532,0.0223225,29.1818109,36.8010813,55231.4801171,292400.2928404,0.0476066,7945.426669,1892.6680165,9439.9308122,25.550758,39.2910867,1.7928782,134.7676115),(12789,'Alces_metacarpus.tif',242,5,407,557.2073427,111.0264397,95.6005235,1.8,110.6781432,95.9429558,0.0278882,29.5933466,38.9724315,54412.0772046,286244.9019116,0.0722093,7344.8048006,1838.6591396,8731.76833,0.412109,0.5828101,2.3561945,1.1656203),(12790,'Alces_metacarpus.tif',242,5,408,545.6684722,110.9235231,94.8618985,1.8,110.6301233,95.4957414,0.0293436,31.9340636,38.4506117,54139.744217,281115.2293774,0.0782849,7311.0730096,1695.3603183,8713.1500753,1.236327,4.6075187,2.9617392,10.4320071),(12791,'Alces_metacarpus.tif',242,5,409,534.4950017,110.8360491,93.9145279,1.8,110.7024917,94.6869667,0.0206796,36.7583413,37.1960006,52105.2588765,277015.7782921,0.0380904,7447.4613924,1417.5084368,8743.3751366,2.2118168,2.9717603,0.5880026,10.5320015),(12792,'Alces_metacarpus.tif',242,5,410,520.8857024,110.9832479,93.0113362,1.8,110.6907393,93.8397985,0.0113624,37.1532642,37.2493706,49455.4025333,273551.1647731,0.0112076,7343.7795076,1331.1186397,8339.0267561,23.902322,42.4792234,1.6096118,141.8441713),(12793,'Alces_metacarpus.tif',242,5,411,510.0158743,111.0584855,92.2279011,1.8,110.7117197,93.2555554,0.0075026,35.5140308,36.5114742,46710.4896615,269670.0105673,0.0047846,7385.8976209,1315.2686043,8557.0797078,23.902322,43.1436989,1.6856729,150.7691558),(12794,'Alces_metacarpus.tif',242,5,412,490.9860453,110.7888353,91.4633411,1.8,110.4654116,92.4056688,0.0054942,37.0707107,35.9419408,43063.8711631,263289.0573217,0.00247,7325.399,1161.6683442,8073.4289516,0.737621,1.4858801,0.5880026,2.9140507),(12795,'Alces_metacarpus.tif',242,5,413,484.8179895,111.0784597,90.9912602,1.8,110.5170551,92.0301478,0.0080357,35.98529,35.6110066,40670.6208597,261533.5089296,0.0052175,7344.176253,1130.2012798,8294.5199624,0.824218,1.1656203,2.3561945,2.3312405),(12796,'Alces_metacarpus.tif',242,5,414,468.7732731,111.0153599,90.5697777,1.8,110.3833233,91.8411148,0.003827,38.4332798,40.9545924,38454.6459176,252621.5114712,0.0011443,6168.3317283,1000.5559269,7106.358554,0.824218,1.8430075,2.677945,3.7382687),(12797,'Alces_metacarpus.tif',242,5,415,463.3447664,110.9964806,90.1999046,1.8,110.3469523,91.673762,0.0059631,39.9971684,40.5076092,37080.8471228,249918.9525891,0.002746,6169.6791652,927.0868054,7063.3745629,0.824218,1.4858801,0.5880026,3.1554585),(12798,'Alces_metacarpus.tif',242,5,416,466.19324,110.7130222,90.0632073,1.8,109.9919119,92.2417838,0.0020787,42.2370972,34.8844987,37733.5864529,249363.6161719,0.000336,7148.2642876,893.3754676,6721.4628201,0.824218,1.4858801,0.5880026,2.9140507),(12799,'Alces_metacarpus.tif',242,5,417,457.266671,110.7891894,89.7569783,1.8,109.8066954,91.6589542,0.0005099,68.9236454,39.081966,35940.9414493,245949.4897868,0.0000201,6293.1708631,521.4602511,3612.745635,0.412109,0.9215037,2.677945,1.7484304),(12800,'Alces_metacarpus.tif',242,5,418,439.6992143,110.9956505,89.5388068,1.8,110.3584522,90.7455232,0.0069527,74.0619073,38.8735434,32379.7402326,239682.5443016,0.0035426,6165.6983961,437.1983037,3672.9614404,0.783105,1.8430075,0.4636476,3.7382687),(12801,'Alces_metacarpus.tif',242,5,419,432.7075158,110.8051474,89.4827532,1.8,110.0295225,90.3888428,0.0078812,37.4452446,39.5094976,30350.231499,239888.920377,0.0044789,6071.6773139,810.522986,6839.7090049,0.412109,0.5828101,2.3561945,1.1656203),(12802,'Alces_metacarpus.tif',242,5,420,427.8736848,110.6344719,89.4492278,1.8,110.0905636,90.1400789,0.008822,37.5459958,36.8657166,28995.6093709,241436.2691644,0.0055498,6549.0729964,772.2690201,6664.476142,0.412109,0.5828101,2.3561945,1.1656203),(12803,'Alces_metacarpus.tif',242,5,421,430.4149135,110.4648353,89.500077,1.8,110.1929831,90.2899011,0.0128228,37.5640595,37.3831694,28890.772011,246914.1418158,0.0117946,6604.9547288,769.1067568,6804.9831928,24.226455,49.5388616,1.2227361,203.4948451),(12804,'Alces_metacarpus.tif',242,5,422,441.3170101,110.5963868,89.6212095,1.8,110.3968062,90.620916,0.0187709,73.8577687,38.0098997,30074.8123218,258045.1550599,0.0259132,6788.8933426,407.1990372,3828.6467787,23.5471353,50.4543283,1.2206297,200.6393698),(12805,'Alces_metacarpus.tif',242,5,423,452.538909,110.2679342,89.611597,1.8,110.3911576,90.7576615,0.0234025,39.6625368,38.6980503,30865.5800175,269668.1345151,0.0412998,6968.5199162,778.2048884,7268.9869765,24.6170016,51.4806457,1.2617033,208.815868),(12806,'Alces_metacarpus.tif',242,5,424,468.240561,110.1404613,89.4744506,1.8,110.3456559,90.9864764,0.0241531,41.0313297,41.1938763,32525.664118,283867.4939887,0.0455175,6891.0119502,792.7031455,6713.2736303,25.5138267,53.3852177,1.3052213,215.4681874),(12807,'Alces_metacarpus.tif',242,5,425,484.3869204,109.7762775,88.9675743,1.8,110.1503174,90.513309,0.0204082,44.8860245,37.9116468,32842.5175428,298895.1675346,0.0336194,7883.993249,731.6869318,6877.9347118,25.517662,53.9532373,1.2442149,208.8744434),(12808,'Alces_metacarpus.tif',242,5,426,493.0067591,109.5817885,88.4105231,1.8,110.3484114,89.5505379,0.0166711,45.7515019,38.8714588,30336.9887032,309942.3004999,0.0228342,7973.5186238,663.0818096,7145.5912956,26.0388364,54.9095615,1.2894039,208.9330188),(12809,'Alces_metacarpus.tif',242,5,427,503.9564092,109.4820812,87.9145082,1.8,110.3274159,88.9481306,0.012477,44.9130565,38.1305591,28936.1241997,322816.4213263,0.0130747,8466.0815068,644.2697619,7644.068255,1.236327,2.2192749,1.1902899,5.8281014),(12810,'Alces_metacarpus.tif',242,5,428,511.8996402,109.4457894,87.3757004,1.8,110.1090888,88.4697408,0.0109235,43.69295,38.6148534,27154.8376476,332932.2789624,0.0101795,8621.8708591,621.4924301,7963.2438571,25.6276469,59.4709128,1.3258177,226.0416079),(12811,'Alces_metacarpus.tif',242,5,429,517.2384438,109.6621116,86.7876448,1.8,110.1092437,88.177936,0.0116853,45.4244859,39.9134226,25698.956213,336272.5541326,0.0117706,8425.0493255,565.7511732,7884.0572957,27.222691,58.2882984,1.3498268,202.7463588),(12812,'Alces_metacarpus.tif',242,5,430,511.6349568,109.5020923,86.1402289,1.8,109.7695877,87.9600486,0.0184026,46.8167513,38.8428109,24144.9605629,328163.5583551,0.0288748,8448.5018049,515.7333621,7395.40527,0.412109,0.5828101,2.3561945,1.1656203),(12813,'Alces_metacarpus.tif',242,5,431,488.49623,109.1281497,85.4147308,1.8,109.3309409,87.725489,0.0272551,49.5791121,38.812847,21432.0856192,310180.1957199,0.060464,7991.6888239,432.2805453,6619.0383112,0.412109,0.5828101,2.3561945,1.1656203),(12814,'Alces_metacarpus.tif',242,5,432,420.8636135,110.0656606,84.7114285,1.8,109.6133101,87.6858122,0.0413664,59.6475707,41.0956164,18882.8387614,252736.9127712,0.1199603,6149.9725476,316.5734756,4551.9205201,28.7977737,57.7893796,1.5137155,194.7284303),(12815,'Alces_metacarpus.tif',242,5,433,344.1016568,106.7232388,84.0533442,1.8,108.452306,86.7382282,0.0396564,58.4278021,38.6397488,14669.4529027,193493.9285758,0.0901437,5007.6393978,251.0697371,3460.7179468,27.9222262,57.4622422,1.4918242,220.8619985),(12816,'Alces_metacarpus.tif',242,5,434,308.7656703,107.9146538,83.2749302,1.8,107.2951976,85.8913455,0.0144643,59.373309,38.284237,11699.1913358,181799.1600356,0.0107656,4748.6687566,197.0446237,3252.9820794,27.0615181,56.9918587,1.5056712,232.1353799),(12817,'Alces_metacarpus.tif',242,5,435,260.6781483,108.619335,82.2207246,1.8,107.6758137,84.8182251,0.0055132,54.9620454,38.5909188,8881.9160838,161701.2789612,0.0013205,4190.1380919,161.6009014,3012.4541846,25.8452722,56.6406304,1.4906762,210.8885444),(12818,'Alces_metacarpus.tif',242,5,436,221.8425042,106.8022338,80.821236,1.8,106.7229165,83.3749381,-0.0151267,51.53367,38.3125836,5291.5407356,145871.5598346,0.0084595,3807.4059816,102.6812322,2924.0472541,26.4832115,57.2356943,1.2786499,213.9854276),(12819,'Alces_metacarpus.tif',242,5,437,213.9198076,105.1567704,80.5568455,1.8,104.7962751,82.9090608,-0.0278274,51.5714415,39.5639056,4587.1667339,140681.91979,0.0276015,3555.8147718,88.9478091,2744.3178773,24.9959369,57.1659209,1.194306,181.3237972),(12820,'Alces_metacarpus.tif',242,5,438,215.4553112,105.4799123,80.6783944,1.8,104.8611711,83.6790572,-0.0271703,53.3409643,39.6660279,5672.4508414,141519.0057079,0.0265025,3567.7634832,106.3432377,2621.4430062,25.9559564,58.317428,1.2021004,182.306585),(12821,'Alces_metacarpus.tif',242,5,439,214.7026901,105.5111107,80.7814219,1.8,104.6576509,85.4180398,-0.0263859,54.8374304,38.3779141,7996.4211331,138531.6765451,0.0249073,3609.6718605,145.8204929,2663.1131604,25.0426098,59.0021508,1.191587,211.0471142),(12822,'Alces_metacarpus.tif',242,5,440,203.3200152,105.2618194,80.822377,1.8,104.5246461,87.3849699,-0.0243441,59.9155873,40.8754381,10862.7523171,129401.0923598,0.0200784,3165.7420292,181.3009404,2321.1949049,24.6674256,60.2102391,1.2577036,210.9885388),(12823,'Alces_metacarpus.tif',242,5,441,167.2046973,104.7464509,80.875621,1.8,104.9330203,89.1679807,-0.0161618,74.1189524,51.332196,13112.4474703,106910.518732,0.0072784,2082.7185864,176.910858,1513.0047697,23.9998071,59.4352052,1.2315037,192.4386088),(12824,'Alces_metacarpus.tif',242,5,442,123.2894778,103.8494685,81.0544413,1.8,104.9605473,90.9820992,0.0045548,79.1969395,52.8233295,13787.6222241,79126.5960887,0.0004263,1497.947912,174.0928666,1157.3867738,61.0123495,73.44564,2.4835022,615.9842279),(12825,'Alces_metacarpus.tif',242,5,443,95.8193708,104.304904,84.0138117,1.8,109.2601184,96.4306241,0.1343174,66.4757559,55.0890763,21631.5628052,62414.9734282,0.2863871,1132.9827549,325.4052927,1120.6406324,0.412109,0.5828101,2.3561945,1.1656203),(12826,'Alces_metacarpus.tif',242,5,444,41.5067185,102.3423037,88.1210177,1.8,99.1792353,99.8876334,-0.3674023,74.2194634,54.2128603,13570.3643118,30762.336229,0.8925266,567.436141,182.8410457,592.6988617,0.412109,0.5828101,2.3561945,1.1656203),(12827,'Alces_metacarpus.tif',242,5,445,6.275257,112.2669201,87.2587584,1.8,108.9740787,90.3582526,-0.205166,53.8996606,56.7772271,2100.9213258,4023.8447252,0.0434099,70.8707511,38.9783776,105.835039,0,0,0,0),(12828,'Alces_metacarpus.tif',242,5,446,2.0123765,121.7248383,97.7095136,1.8,120.3954413,100.6686387,-0.8435231,31.7339956,53.1873088,459.901214,1320.159783,0.187149,24.8209547,14.4923829,31.6674138,0,0,0,0),(12829,'Alces_metacarpus.tif',242,5,447,1.215547,100.508463,119.1706373,1.8,100.3844593,119.0768161,0.0028586,43.4992173,56.0477584,321.2211547,1378.6689265,0.0000017,24.59811,7.3845272,24.2899471,0.412109,0.5828101,2.3561945,1.1656203),(12830,'Alces_metacarpus.tif',242,5,448,4.515161,90.3552024,115.8315456,1.8,90.2068946,115.6635161,0.2502212,53.5643602,62.6453109,1258.981318,5225.88152,0.046141,83.4201546,23.5040858,84.7157501,0.412109,0.5828101,2.3561945,1.1656203),(12831,'Alces_metacarpus.tif',242,5,449,4.0454932,92.9156091,117.2143541,1.8,93.0852663,117.3261481,0.2132123,37.5524094,60.7241676,1160.1758986,4716.0978406,0.0301894,77.6642649,30.8948458,87.4038696,0.412109,0.5828101,2.3561945,1.1656203),(12832,'Alces_metacarpus.tif',242,5,450,3.9805447,102.7929268,123.9320485,1.8,103.1426405,123.6503618,0.1069042,52.2376054,55.2997756,930.9408534,3585.334649,0.0075531,64.8345243,17.8212773,64.7851202,0.412109,0.5828101,2.3561945,1.1656203),(12833,'Alces_metacarpus.tif',242,5,451,3.7522468,134.2279071,118.5279159,1.8,133.3453896,118.8378445,-0.3741402,41.6999717,67.1758667,497.1738854,2398.671561,0.0835313,35.7073407,11.9226432,36.6255195,0.412109,0.9215037,2.0344439,1.9898383),(12834,'Alces_metacarpus.tif',242,5,452,2.69727,99.8363736,127.8442244,1.8,99.5493259,127.7572386,0.389147,26.830847,61.8936273,196.2144667,1821.4135652,0.0647092,29.4281277,7.313018,29.9089566,0.412109,1.3032031,1.8925469,2.8140563),(12835,'Alces_metacarpus.tif',242,5,453,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12836,'Alces_metacarpus.tif',242,5,454,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12837,'Alces_metacarpus.tif',242,5,455,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12838,'Alces_metacarpus.tif',242,5,456,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12839,'Alces_metacarpus.tif',242,5,457,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12840,'Alces_metacarpus.tif',242,5,458,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12841,'Alces_metacarpus.tif',242,5,459,4.4188703,93.2876699,159.5782406,1.8,93.2587404,159.6048975,-1.007268,3.5826749,3.6705,12.1200082,12.906412,0.5263317,3.5162544,3.3829495,6.8024388,7.3970132,7.7756571,0.5585993,24.2194616),(12842,'Alces_metacarpus.tif',242,5,460,27.7196598,93.3039883,159.7031964,1.8,93.3032847,159.7296335,-0.9904212,6.5996328,6.6502141,256.4689423,260.8901082,3.2308456,39.2303322,38.861093,76.4761008,13.187488,13.944882,0.5961991,43.3350453),(12843,'Alces_metacarpus.tif',242,5,461,52.2218949,93.3044914,159.7579385,1.8,93.3886949,159.7867978,0.1273919,8.5806903,48.2009434,861.7580451,954.8689337,0.1404865,19.8101711,100.4299203,37.6600576,17.308578,17.7541991,1.9513027,56.6811031),(12844,'Alces_metacarpus.tif',242,5,462,77.0865452,93.2372435,159.7876874,1.8,93.2392172,159.7675096,0.8186018,9.8278183,9.9530287,1737.153092,1749.5246211,6.8501574,175.7781142,176.7587724,345.8680114,19.781232,20.6959154,2.5259728,65.7060821),(12845,'Alces_metacarpus.tif',242,5,463,98.6248198,93.2397693,159.6364581,1.8,93.2153227,159.54218,0.0624428,10.8889311,11.2690023,2665.6681986,2831.4259503,0.0640082,251.2579087,244.8053139,487.5104662,22.253886,22.9156321,2.2286849,73.6654352),(12846,'Alces_metacarpus.tif',242,5,464,114.2985779,93.2409457,159.4944402,1.8,93.1905338,159.2607984,0.0069345,11.5577392,12.0638133,3421.0614743,3973.6964474,0.000916,329.3897493,295.9974629,603.2847003,23.902322,24.7608586,2.8198421,79.2935477),(12847,'Alces_metacarpus.tif',242,5,465,125.6267001,93.7036539,159.7464217,1.8,94.4591446,159.6968695,0.1331161,12.6006627,19.5054761,3980.0190419,5943.6176036,0.3688293,304.715331,315.8579145,478.0402233,25.550758,26.1063814,2.9349094,84.3388501),(12848,'Alces_metacarpus.tif',242,5,466,228.206538,102.7517191,160.8455117,1.8,103.3674855,160.2928204,0.0998117,13.3526431,27.3679753,6483.442978,34992.3702416,0.3776568,1278.588201,485.5550274,1482.1939922,26.787085,29.8459114,2.5229483,92.6396055),(12849,'Alces_metacarpus.tif',242,5,467,414.2580039,111.9522045,160.9100455,1.8,106.9962425,160.341086,0.0462987,13.8393072,34.2074404,11473.4436184,87160.7984612,0.147893,2548.0070229,829.0475434,2876.8299552,27.199194,28.581475,2.6456982,91.956801),(12850,'Alces_metacarpus.tif',242,5,468,445.3800529,113.1128243,160.9945318,1.8,107.0386203,160.3616671,0.0436667,14.3114754,33.6995739,12164.5092694,97451.8533333,0.1414503,2891.782953,849.9828912,3246.456091,29.3398611,57.578869,2.8809903,183.7721885),(12851,'Alces_metacarpus.tif',242,5,469,446.4624605,113.0618666,161.0314621,1.8,107.0036227,160.4466403,0.0393533,14.4627249,33.987673,12142.2851915,97561.7920217,0.1151785,2870.5052,839.5572277,3227.2226585,37.8387501,163.6093491,3.1365549,585.6207447),(12852,'Alces_metacarpus.tif',242,5,470,447.4272196,112.9976708,161.0660646,1.8,106.9610512,160.5199579,0.0353993,14.9080702,33.9803635,12100.566698,97815.9338899,0.0934069,2878.6017526,811.6789434,3226.4038507,38.1424537,163.6093491,3.1365549,575.4473017),(12853,'Alces_metacarpus.tif',242,5,471,447.4701927,112.9422651,161.0983283,1.8,106.9231816,160.6002302,0.0319661,14.6763404,33.9437849,12003.4903406,97838.1730282,0.0761802,2882.3589763,817.8803449,3219.7451112,37.8818863,163.6093491,3.1365549,581.9824704),(12854,'Alces_metacarpus.tif',242,5,472,447.2194562,112.8381271,161.1259033,1.8,106.768562,160.6422784,0.0295589,14.7234696,34.1954014,11900.3730616,98191.0156587,0.0651055,2871.4684305,808.2587448,3214.6954398,29.4266299,57.8730759,2.9986885,179.9925007),(12855,'Alces_metacarpus.tif',242,5,473,445.607939,112.8136201,161.159438,1.8,106.7256603,160.6671999,0.0275589,14.7702676,34.1793829,11813.2759724,97974.2629431,0.0563915,2866.4725537,799.8010799,3204.3343072,29.4159864,57.9493251,2.9483812,179.8925063),(12856,'Alces_metacarpus.tif',242,5,474,444.7526456,112.6997584,161.1790095,1.8,106.6111757,160.6887696,0.0265841,14.7560595,34.0746988,11733.8856942,98275.5769092,0.0523731,2884.1216645,795.1910015,3152.2050126,37.7161588,163.2034892,3.131492,585.7621581),(12857,'Alces_metacarpus.tif',242,5,475,444.1240031,112.5680352,161.186396,1.8,106.4686605,160.685504,0.0257828,14.4349333,34.3210159,11696.4405405,98791.7612167,0.0491942,2878.4626194,810.2871201,3096.06817,29.4788361,57.9961978,2.9846214,181.0581266),(12858,'Alces_metacarpus.tif',242,5,476,444.4265131,112.4318085,161.193081,1.8,106.3071362,160.7183563,0.025436,14.4093104,34.2053949,11657.8162477,99452.8630288,0.0479125,2907.5198042,809.0474781,3239.7912902,33.0009393,61.0213625,2.7021095,263.7728034),(12859,'Alces_metacarpus.tif',242,5,477,444.7428672,112.2899864,161.2018137,1.8,106.1230842,160.7538734,0.0254311,14.0516815,34.4338873,11612.1273825,100182.2939794,0.0479287,2909.4099414,826.3870332,3245.6732822,29.3950205,58.1190589,3.0207557,184.3549986),(12860,'Alces_metacarpus.tif',242,5,478,445.8895544,112.1342774,161.2022955,1.8,105.9784726,160.7598935,0.0254785,14.034305,34.3097773,11615.9318977,101101.255037,0.0482311,2946.7184842,827.6813087,3279.2638116,29.4303963,58.2022811,2.9636391,189.1588931),(12861,'Alces_metacarpus.tif',242,5,479,447.2631498,111.9965659,161.200418,1.8,105.7541382,160.7757045,0.025791,13.9878057,34.5209179,11621.9139816,101989.1676182,0.0495731,2954.4164444,830.8604092,3290.3658324,29.3835539,58.2766425,2.9566791,186.8276526),(12862,'Alces_metacarpus.tif',242,5,480,448.5827586,111.8543409,161.1933599,1.8,105.6159347,160.7907503,0.0257462,13.6157548,34.4210131,11638.6201957,102986.0465055,0.0495478,2991.952803,854.7906736,3326.0700092,32.6809555,61.4263637,2.7199623,252.7579862),(12863,'Alces_femur.tif',242,7,1,1.4785364,172.71452,166.3909647,1.8,172.5758288,166.3709944,-0.1389009,0.8845432,4.6590645,0.1903133,4.8113933,0.0047239,1.0326952,0.2151544,1.0723945,29.3638902,183.4861665,0.0158717,708.1302486),(12864,'Alces_femur.tif',242,7,2,2.7140939,171.0095381,166.0799362,1.8,170.8972394,166.0703871,-0.1790028,0.8739576,6.7086292,0.3718741,19.9156813,0.01434,2.9686663,0.4255059,3.0170352,23.3256956,184.7228158,0.0112608,664.9625555),(12865,'Alces_femur.tif',242,7,3,3.7894837,168.9105047,165.8231451,1.8,167.9573723,165.8288244,-0.0415915,4.4680073,131.3969194,1.7367518,254.7619746,0.0010919,1.9388733,0.3887084,1.9509633,17.4568415,185.1345988,0.0089885,399.2039109),(12866,'Alces_femur.tif',242,7,4,5.4360022,152.5401084,165.7462875,1.8,150.6063992,165.7465126,-0.0104818,2.0149641,115.1036252,3.5061926,9240.6835933,0.0000995,80.2814297,1.7400769,80.3118394,17.0045376,186.3825967,0.0089283,399.7331156),(12867,'Alces_femur.tif',242,7,5,9.6333001,122.6693193,165.8357508,1.8,121.6772215,165.8047514,-0.0093007,2.2693264,85.2295004,6.3149314,32802.1334317,0.0001389,384.8683057,2.7827338,384.9410926,16.1616461,186.3867752,0.0111603,398.5982564),(12868,'Alces_femur.tif',242,7,6,13.5368523,111.3624581,165.6591059,1.8,109.5409465,165.6506575,-0.0073489,2.1242842,73.9214565,10.0208814,46301.191272,0.0001218,626.356588,4.7172979,626.4476898,15.7202333,187.2145957,0.0088887,401.0525407),(12869,'Alces_femur.tif',242,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(12870,'Alces_femur.tif',242,7,8,1.9460857,147.306336,134.5097099,1.8,147.3647534,135.0704901,1.4417585,1.7763248,5.3837183,1.368023,9.2687261,0.3189769,1.7216217,0.7701424,1.9664702,2.912112,7.2654071,1.3397057,17.2881062),(12871,'Alces_femur.tif',242,7,9,40.2067284,147.7493992,133.8924468,1.8,147.760932,133.5648002,-1.5186795,4.3579992,11.9801465,136.392566,1143.2720945,6.6829365,95.4305607,31.2970607,106.3449872,8.4552132,23.3895724,1.4817467,58.78159),(12872,'Alces_femur.tif',242,7,10,74.6161593,147.7603921,133.2198367,1.8,147.7944755,133.1851548,-1.5306866,6.0733618,14.2748578,559.4354087,3615.6045181,12.4160303,253.2848012,92.1129723,292.2158348,12.0838703,28.8524417,1.469693,73.5736002),(12873,'Alces_femur.tif',242,7,11,104.5649646,147.7722965,132.7583382,1.8,147.9353283,132.5609419,-1.5032753,7.7123462,16.5116162,1319.2472902,6925.1245658,17.3481612,419.4092487,171.0565445,491.440186,14.8274305,33.3773451,1.3954021,89.2985847),(12874,'Alces_femur.tif',242,7,12,136.285318,147.6639155,132.3115079,1.8,147.7485355,132.1695695,-1.4597803,8.5191385,18.2634826,2455.8947964,11357.6629702,22.4354252,621.8782696,288.2797122,754.6649151,17.2066763,36.3175058,1.3981148,97.8626013),(12875,'Alces_femur.tif',242,7,13,170.5856103,147.3713666,132.2167352,1.8,147.4715018,132.2338775,-1.4250779,9.8002711,20.3798677,3946.8936388,16800.4149114,27.831497,824.3632972,402.7331062,1012.9319406,19.4636511,40.0111377,1.4141944,106.7885757),(12876,'Alces_femur.tif',242,7,14,206.0332473,146.9263818,132.3449974,1.8,147.1323696,132.2383517,-1.4221672,10.5677779,21.5385778,5931.8948954,22611.9779727,33.5858765,1049.8361686,561.3190355,1320.1736569,21.2180862,42.5090189,1.3638041,115.3525922),(12877,'Alces_femur.tif',242,7,15,237.3970778,146.5655774,132.0971993,1.8,147.0442067,131.8494923,-1.4087866,11.6259171,22.3355232,8143.8131303,29164.6289216,38.5367341,1305.7508748,700.4878058,1593.9238326,22.7717819,45.31711,1.3013237,121.8069634),(12878,'Alces_femur.tif',242,7,16,256.3997212,146.6304372,131.5518975,1.8,147.0800479,131.266313,-1.3727155,12.6128973,24.2052519,9548.1212589,35496.132595,41.0784179,1466.4640885,757.0125294,1806.6606002,24.0493166,48.5742106,1.2842616,128.6232925),(12879,'Alces_femur.tif',242,7,17,277.0585854,146.8365397,130.6630244,1.8,147.2201401,130.2896683,-1.3444865,13.3026666,25.1348206,10924.8046292,43527.3661409,43.8515538,1731.7555915,821.2492218,2086.1806547,25.038336,50.687414,1.2101044,133.6154845),(12880,'Alces_femur.tif',242,7,18,293.6793755,147.1332353,129.917257,1.8,147.3912437,129.529149,-1.3247909,13.6244668,27.0947806,11806.5325207,52687.3391997,46.0436567,1944.5567771,866.568408,2342.0303929,25.56863,53.7836451,1.3126852,138.7677496),(12881,'Alces_femur.tif',242,7,19,307.1434862,147.451889,129.6225261,1.8,147.642345,129.068964,-1.3190064,14.0622086,27.9666465,12594.514796,60699.9159217,48.0131995,2170.4395629,895.6284981,2591.5042063,25.7872678,55.4987797,1.3130911,144.205523),(12882,'Alces_femur.tif',242,7,20,322.2023519,147.7902177,129.2823273,1.8,147.8846886,128.7060829,-1.3214307,14.7230646,28.349469,13676.4263508,69340.8145483,50.4297734,2445.9299202,928.9116587,2901.9328762,26.124929,56.5184952,1.3026075,145.2221208),(12883,'Alces_femur.tif',242,7,21,336.4718643,148.1104502,128.9445387,1.8,148.1476774,128.2820338,-1.3153786,14.9860617,29.4872952,14855.2590814,78252.4923883,52.4990413,2653.7697661,991.271712,3110.1511634,26.2273118,58.3328016,1.2061827,149.2395267),(12884,'Alces_femur.tif',242,7,22,352.5329063,148.3405239,128.4757227,1.8,148.3708244,127.9695703,-1.3093806,14.2829083,30.0703211,16494.5578318,85628.2655622,54.8308779,2847.600641,1154.8458845,3391.2598209,26.7431925,59.3738059,1.2867219,152.3239582),(12885,'Alces_femur.tif',242,7,23,366.349449,148.5713918,128.1582896,1.8,148.5517842,127.6402775,-1.3088346,15.4150826,30.6947976,18413.9415669,91071.8737195,56.9631586,2967.0133367,1194.5405684,3566.713225,27.1510971,60.9275281,1.2727994,155.6102744),(12886,'Alces_femur.tif',242,7,24,385.0302884,148.7687501,128.2393974,1.8,148.7158757,127.5429601,-1.3174594,15.5124719,31.4354182,20920.7544097,98228.4464644,60.1405582,3124.769828,1348.6409231,3786.0578789,27.8630229,61.8312308,1.2490458,157.0724536),(12887,'Alces_femur.tif',242,7,25,400.9260753,149.0805348,128.3757416,1.8,148.9814608,127.4373558,-1.3196392,16.1461066,32.0858315,23497.2044227,103410.0715711,62.6938354,3222.9201128,1455.286091,3955.1620996,28.5933917,62.4924718,1.2385198,160.2578275),(12888,'Alces_femur.tif',242,7,26,415.532968,149.2434088,128.3873817,1.8,149.1020719,127.3520022,-1.3165442,16.3965726,32.5638933,25739.1300595,107866.3334873,64.8741759,3312.4520044,1569.7872131,4102.756166,29.3675156,63.1604912,1.2282155,161.4344984),(12889,'Alces_femur.tif',242,7,27,428.4226459,149.4596778,128.3122485,1.8,149.2319162,127.2623921,-1.3064131,16.8676797,33.0546397,27992.8842553,112282.0927681,66.5279698,3396.8633123,1659.5574901,4243.3888613,29.790448,64.0678147,1.2469924,162.8548659),(12890,'Alces_femur.tif',242,7,28,441.6312434,149.6316726,128.3440834,1.8,149.3361219,127.3138582,-1.2974543,17.201091,33.5541678,30260.747976,116756.5584033,68.2413381,3479.6439921,1759.2342222,4381.382121,30.6418992,65.0529847,1.2045408,164.1324793),(12891,'Alces_femur.tif',242,7,29,458.4970052,149.8970182,128.5566729,1.8,149.4718301,127.5612233,-1.2887645,17.2918357,33.9168665,33110.8594367,121532.4833373,70.4973381,3583.2462132,1914.8261681,4559.1142343,31.4711617,65.7423755,1.1949903,165.2082078),(12892,'Alces_femur.tif',242,7,30,473.6564609,150.0482102,128.937615,1.8,149.5740344,127.8813645,-1.2822411,18.5212133,34.4031703,36202.0432472,125779.8053336,72.5500653,3656.0527465,1954.6259039,4706.5094706,32.5568342,66.437638,1.1856388,169.4274985),(12893,'Alces_femur.tif',242,7,31,486.6206635,150.180169,129.3329918,1.8,149.6391966,128.2803188,-1.2677577,19.7879092,34.823176,38897.5470154,128763.198749,73.8807319,3697.6293779,1965.722943,4814.6308646,33.3527697,67.1385898,1.1764819,169.0410478),(12894,'Alces_femur.tif',242,7,32,522.5687855,146.4889037,128.9840952,1.8,144.4944465,127.9138887,-0.1125471,31.1869826,76.417149,123818.1818411,191000.5939439,1.0985666,2499.4467406,3970.1879227,3972.2672299,34.8973275,67.6828754,1.1731683,176.2438276),(12895,'Alces_femur.tif',242,7,33,649.3675975,133.6356601,127.2408002,1.8,137.6561732,127.200415,0.1113224,33.6671085,69.5066326,130299.0745845,704275.260553,1.3357012,10132.4900125,3870.2187532,11995.5478016,19.3522721,22.4031472,1.9513027,75.3977373),(12896,'Alces_femur.tif',242,7,34,731.8922377,127.2234478,126.3651492,1.8,133.0887546,126.8002593,0.1201346,33.4684732,65.4241371,133856.9647965,963853.2515168,1.7520299,14732.3800372,3999.4942075,16737.603263,24.3400547,27.0889993,1.3854484,112.5291763),(12897,'Alces_femur.tif',242,7,35,801.7338342,122.9573607,125.887665,1.8,129.2733103,126.4569691,0.1234347,33.1600821,63.3131359,139613.5386788,1148552.856795,2.0255648,18140.8303506,4210.2892992,20283.4609068,28.1621376,31.9033012,1.3606137,121.2114542),(12898,'Alces_femur.tif',242,7,36,870.1633949,119.3579277,125.6144441,1.8,126.1590137,126.2779204,0.128626,32.5636218,61.3836765,146484.594855,1307333.3841527,2.3862207,21297.7367584,4498.4122347,23617.2437046,31.3863737,34.113312,1.3494819,126.9520548),(12899,'Alces_femur.tif',242,7,37,923.0869941,116.4710485,125.4401854,1.8,123.506436,126.0847365,0.1332597,32.1953316,60.0587614,153465.3354303,1418581.534367,2.7159175,23619.8932782,4766.6952948,26130.7334847,34.3345544,36.8943104,1.4464413,139.0042724),(12900,'Alces_femur.tif',242,7,38,978.3700525,113.6542107,125.3217635,1.8,121.1346121,125.8770865,0.1405672,31.3817188,58.5128488,160512.7209793,1519251.8888631,3.2007909,25964.4150018,5114.8479831,28576.822442,36.4767991,39.6635859,1.3487144,139.3489113),(12901,'Alces_femur.tif',242,7,39,1025.3177782,111.5814924,125.1776417,1.8,118.9662908,125.7329681,0.1449519,54.4870332,57.6893319,167712.6137434,1592848.853251,3.5654233,27610.8043198,3078.0279973,28950.7787769,38.5099763,41.1203986,2.9481653,147.4673465),(12902,'Alces_femur.tif',242,7,40,1073.229395,109.6389836,125.0278212,1.8,116.9951138,125.6279771,0.1494279,54.6656958,60.2597291,173797.2423256,1653926.0164402,3.9643277,27446.6221849,3179.2743084,29248.5417069,40.3845829,43.5924426,2.910502,164.0243631),(12903,'Alces_femur.tif',242,7,41,1122.9991469,107.8253285,124.871073,1.8,114.94157,125.5564648,0.1575656,60.3771338,61.5043661,177945.6035495,1705195.584792,4.6084419,27724.7892085,2947.2350273,29557.7529683,41.4658376,46.7162073,2.9896204,158.057385),(12904,'Alces_femur.tif',242,7,42,1146.4343052,106.2219678,124.9837622,1.8,112.9491359,125.7169612,0.1700444,50.6013237,62.9306421,176862.1546323,1689506.9393275,5.4718315,26847.1269887,3495.2080657,29236.8773369,42.3601538,49.1180844,2.9541635,158.1583274),(12905,'Alces_femur.tif',242,7,43,1181.3894813,104.6878028,124.8995759,1.8,110.7987543,125.6092062,0.182782,29.4655513,64.0351768,179781.9575244,1667937.0627059,6.5052955,26047.2000786,6101.4286069,28690.7650923,43.4124561,53.251673,3.0162687,156.1914362),(12906,'Alces_femur.tif',242,7,44,1231.5154413,103.9085014,124.7281764,1.8,109.3464297,125.3102802,0.1900159,28.2290873,65.3159224,185516.1596124,1652830.4358432,7.3220969,25305.1687207,6571.8086319,28127.7632048,44.3524769,55.7290661,3.0218673,164.5708869),(12907,'Alces_femur.tif',242,7,45,1288.154052,103.4437272,124.3887558,1.8,108.2359393,124.8667338,0.1924085,28.6247278,65.17372,193842.8213116,1634824.5310777,7.8505346,25084.1064718,6771.8660096,28053.1671958,55.4714217,116.3425023,2.9070212,471.8851175),(12908,'Alces_femur.tif',242,7,46,1312.0872827,102.7469874,124.0782694,1.8,107.4077235,124.6205731,0.1927015,46.5138295,71.3741591,201128.5086893,1619873.9370379,8.0204632,22695.5239428,4324.0582576,24724.0961024,55.1247854,116.3573772,2.8775356,506.3358947),(12909,'Alces_femur.tif',242,7,47,1326.9015439,101.8636834,123.8576058,1.8,106.7183969,124.4260934,0.1938415,57.9815364,71.2397046,206450.8598775,1613986.8445178,8.206061,22655.7206276,3560.6310668,24673.2065424,54.786727,116.538698,2.9000772,476.6754247),(12910,'Alces_femur.tif',242,7,48,1319.5530733,101.8181363,123.8283455,1.8,106.301399,124.1579013,0.1905389,63.9646465,71.8855635,212146.5349293,1591496.1309253,7.8882529,22139.3010511,3316.6217073,24300.1894816,54.3287115,115.9558315,2.8765993,394.4022276),(12911,'Alces_femur.tif',242,7,49,1300.4706607,102.4672185,123.8857276,1.8,106.0950423,123.9127423,0.1850958,58.2868618,71.1353451,216384.61109,1550736.3239203,7.3413695,21799.800391,3712.4079864,24005.7053807,54.4390449,115.3752707,2.8677506,397.2256436),(12912,'Alces_femur.tif',242,7,50,1278.3676117,102.9111754,123.9149801,1.8,105.8878901,123.7722004,0.1781375,54.2556083,71.3048955,217360.9289114,1502396.353762,6.6898499,21070.0309332,4006.2389048,23311.4101569,54.2945641,114.8814456,2.8438924,430.8443888),(12913,'Alces_femur.tif',242,7,51,1258.6270638,103.4523821,124.0194742,1.8,105.797412,123.7500021,0.1744539,33.0268034,66.8753941,217285.0336161,1461995.1311528,6.3197054,21861.480617,6579.0513016,23901.5923007,54.6627432,114.2416598,2.8497871,403.2935641),(12914,'Alces_femur.tif',242,7,52,1233.0768412,103.9826947,124.0846965,1.8,105.6780586,123.682684,0.1721578,34.1019966,67.5752486,215742.6927625,1411630.7794493,6.0311171,20889.7608122,6326.3947684,23148.8726677,54.9416119,113.2916293,2.839584,368.2962632),(12915,'Alces_femur.tif',242,7,53,1216.8444082,104.3878362,124.1488803,1.8,105.6429253,123.629156,0.1725619,34.3793704,70.7186009,214108.0634405,1371603.8672158,5.9794142,19395.2347749,6227.8064045,21737.3189021,55.7700763,112.2449408,2.7975715,374.6251992),(12916,'Alces_femur.tif',242,7,54,1196.3082658,104.7539341,124.3271513,1.8,105.6892218,123.7318052,0.1700663,33.9991195,57.6384306,210950.3736386,1318516.9335358,5.7113347,22875.6564001,6204.583426,24684.5899241,56.5063769,111.4084323,2.774955,356.9333234),(12917,'Alces_femur.tif',242,7,55,1170.170604,105.436247,124.6331684,1.8,105.8743804,123.9207542,0.1661902,42.3851848,56.8232287,207001.5458673,1246752.1430257,5.3371181,21940.8888273,4883.8184164,24656.6673177,57.0546742,111.1393576,2.9265778,360.9507293),(12918,'Alces_femur.tif',242,7,56,1139.5172492,106.1611836,124.9258712,1.8,106.0752498,124.0705525,0.1643008,65.9792685,54.8126611,204517.0546429,1175213.8124128,5.0808639,21440.5538534,3099.7169171,20558.4073795,57.433001,108.2425346,2.7760744,346.2005309),(12919,'Alces_femur.tif',242,7,57,1103.2197895,107.0212022,125.1214277,1.8,106.4805158,124.2420396,0.1600939,55.1860416,55.0956005,198166.8057997,1094590.9026293,4.6724731,19867.1199385,3590.886394,21936.5405645,57.6104879,107.1360344,3.001343,353.3196872),(12920,'Alces_femur.tif',242,7,58,1084.0829387,107.9500207,125.3449985,1.8,107.1650355,124.5082099,0.1590547,52.2227236,55.4437336,192892.5009212,1032966.6412846,4.5325108,18630.8997422,3693.6507283,20828.5137932,57.4016217,106.2544282,3.0041252,340.3763069),(12921,'Alces_femur.tif',242,7,59,1062.9624514,108.9952065,125.5856327,1.8,107.9148983,124.8602756,0.1612847,36.4616638,55.5479163,187805.5123679,973090.9389766,4.5686096,17518.04576,5150.7663859,18867.8689147,57.217032,105.2133991,3.018709,332.8288882),(12922,'Alces_femur.tif',242,7,60,1036.9995372,110.0656113,125.8561599,1.8,108.7358067,125.2219367,0.1666089,36.6080751,55.5933438,182257.1941096,913225.1207855,4.753369,16426.878797,4978.6063219,19182.0417938,56.919077,104.387691,3.017732,332.8462071),(12923,'Alces_femur.tif',242,7,61,1007.8203658,111.294863,126.0321821,1.8,109.6919878,125.5022585,0.1809518,37.2641389,60.1998287,177295.7701658,841446.534124,5.4401688,13977.5569517,4757.812078,16199.4093783,56.6849058,102.736581,3.0157309,320.6339164),(12924,'Alces_femur.tif',242,7,62,989.6584198,112.1726219,126.3400612,1.8,110.5889183,125.8215875,0.1968122,37.4673155,64.4567651,173084.7295645,792383.6541062,6.3070091,12293.2581746,4619.6191917,14637.0696128,56.2888326,100.8870966,3.0300247,319.2308679),(12925,'Alces_femur.tif',242,7,63,974.2795331,113.0344712,126.6949214,1.8,111.4241059,126.1544103,0.215613,37.1403672,54.0555722,169589.2717262,748261.2472598,7.432616,13842.4442914,4566.1711057,16602.4619629,55.746144,99.0782085,3.0068214,315.1125196),(12926,'Alces_femur.tif',242,7,64,967.0461799,113.5894611,126.946497,1.8,112.3426098,126.4027154,0.2331537,56.3987275,64.3303229,166934.100534,715235.8874836,8.6039243,11118.1765514,2959.8912592,13553.9670127,54.9487023,97.4294906,3.0045265,349.9079357),(12927,'Alces_femur.tif',242,7,65,954.6307643,114.2069733,127.1607582,1.8,113.2402983,126.6447015,0.2490942,51.9014015,70.008147,162843.6762798,681852.3912575,9.669642,9739.6148883,3137.5583635,11478.6117796,54.1027807,95.9771543,3.0199258,321.8279063),(12928,'Alces_femur.tif',242,7,66,934.7972834,114.6897122,127.4192784,1.8,114.126056,126.9017959,0.2652149,36.3410363,70.1671529,159203.8879736,647338.4659559,10.7042298,9225.6624269,4380.8296071,10891.2090401,53.30974,94.019616,3.0084563,322.1898642),(12929,'Alces_femur.tif',242,7,67,922.6588836,115.0806011,127.7509909,1.8,114.7097054,127.1932808,0.2798932,35.9781315,53.7068506,157557.0124608,618823.8138894,11.735562,11522.2510165,4379.2438881,13112.6018267,52.7007156,92.1360395,2.9920329,301.2952956),(12930,'Alces_femur.tif',242,7,68,921.661375,115.441072,128.1682237,1.8,115.1035729,127.4940051,0.2979403,35.7555781,49.6068936,158236.8015775,601437.5890165,13.2370081,12124.0727879,4425.5137255,15128.1071261,52.3538994,90.8402158,2.9945143,294.1098348),(12931,'Alces_femur.tif',242,7,69,927.8190763,115.8127811,128.6269218,1.8,115.2283904,127.8620016,0.3163687,36.6055443,49.1529216,159732.886475,586922.7571466,14.9679043,11940.7501645,4363.6255029,14049.9277467,51.8087335,89.3892448,2.9779742,297.1769473),(12932,'Alces_femur.tif',242,7,70,922.5209526,115.8125562,128.8895622,1.8,115.3981664,128.296528,0.3307353,37.0418476,48.3480628,157530.978505,566397.1833831,16.2140995,11714.9923059,4252.784051,13503.1149998,51.4370024,88.0903443,2.9803259,281.6538475),(12933,'Alces_femur.tif',242,7,71,915.8835347,115.4725697,129.0356841,1.8,115.3925099,128.6336541,0.3412342,51.1017453,47.3555521,157232.0314183,542684.6747595,17.0951028,11459.7898487,3076.8426898,12384.5201167,51.0308621,87.0756371,2.9929389,276.9471638),(12934,'Alces_femur.tif',242,7,72,921.2543475,115.1521499,129.2055306,1.8,115.3515642,128.8590829,0.3552095,52.6656646,57.8348542,159564.9205337,525202.646042,18.5718245,9081.0749556,3029.7713267,11774.4586845,50.6688679,85.9050375,2.9859978,270.7956198),(12935,'Alces_femur.tif',242,7,73,915.9418538,114.9562126,129.4531263,1.8,115.1222341,129.2057444,0.3693383,50.8663769,45.6569883,158583.0122495,504282.4853266,19.8942342,11045.0229796,3117.6392313,11356.9658847,50.161126,84.5454651,2.9934326,269.6189489),(12936,'Alces_femur.tif',242,7,74,914.0782644,114.7798394,129.6607235,1.8,114.8775009,129.4859705,0.3832512,48.510228,45.6324738,158617.1978234,486785.6804443,21.3025096,10667.5277542,3269.768135,12533.7005813,0.5883355,1.1766709,2.3561945,2.3533419),(12937,'Alces_femur.tif',242,7,75,902.3330467,114.4878179,129.6489916,1.8,114.5452985,129.5525479,0.3912005,39.7694654,45.0024608,157588.7564485,469237.4713419,21.8648177,10426.9291799,3962.5565734,11058.6352398,49.4062232,81.9498724,2.8744501,257.6676737),(12938,'Alces_femur.tif',242,7,76,893.4491891,114.214662,129.6519683,1.8,114.3080737,129.6552763,0.3994759,32.1254403,44.5350454,157225.8943364,454171.4406287,22.5254784,10198.0684338,4894.124184,13407.3744049,49.0166935,80.6910193,2.9391415,255.1715777),(12939,'Alces_femur.tif',242,7,77,883.7489688,113.7356555,129.559614,1.8,113.935653,129.7440737,0.406942,34.8173378,46.8817216,156363.3321216,437287.4586469,23.0746787,9327.4616172,4490.9617401,12514.6635392,48.851874,79.3228083,2.8762606,256.9365841),(12940,'Alces_femur.tif',242,7,78,871.6499554,113.3748028,129.6003349,1.8,113.5944699,129.8180868,0.4162247,35.296594,42.4109165,155861.3683635,422272.6697828,23.7476464,9956.6975834,4415.7622844,12203.8116294,48.5650907,78.1191207,2.8720711,245.4308902),(12941,'Alces_femur.tif',242,7,79,868.1562105,112.9725044,129.5119416,1.8,113.1664083,129.8068285,0.4227703,44.242675,46.4350154,156797.6029614,412419.2791681,24.3570787,8881.6440692,3544.0353264,10677.7257024,48.2686614,76.8053872,2.8729653,230.4788069),(12942,'Alces_femur.tif',242,7,80,858.1911941,112.6286417,129.4073546,1.8,112.8168204,129.7554655,0.4306935,48.76418,43.9748923,157952.2192015,401857.7388414,24.931471,9138.3450386,3239.1033596,10015.2827476,48.266308,75.4917173,2.8738906,234.0679504),(12943,'Alces_femur.tif',242,7,81,855.1592296,112.2836601,129.3009638,1.8,112.2699893,129.7209458,0.4397036,43.3907432,42.472098,157769.1214278,390568.7685344,25.8252452,9195.8906495,3636.0087358,10226.9037915,48.7113292,74.4017604,2.864061,316.8112216),(12944,'Alces_femur.tif',242,7,82,845.9050036,111.9671639,129.2661922,1.8,111.8774267,129.7254218,0.4480659,32.8781241,41.1377847,158220.1963897,378494.6974088,26.4602291,9200.6582241,4812.3243234,12364.2402286,48.3484976,73.202268,2.8593898,247.4395931),(12945,'Alces_femur.tif',242,7,83,840.5743639,111.6902042,129.1697285,1.8,111.5021102,129.701402,0.4540828,35.7265624,43.0243599,159052.6464932,369361.8226627,26.9549043,8584.9463691,4451.9437565,12160.742328,49.6982026,71.970768,2.836294,272.8807724),(12946,'Alces_femur.tif',242,7,84,829.0553425,111.4053798,128.9619156,1.8,111.1598055,129.4983807,0.4576743,32.9064645,43.3932718,158840.7050026,360462.5765464,26.9778623,8306.8771203,4827.0365,11854.9295716,48.5105191,70.9633552,2.725154,300.6161629),(12947,'Alces_femur.tif',242,7,85,825.6499154,110.9469416,128.7069923,1.8,110.7390813,129.3571363,0.4627663,37.743469,49.3478747,159326.3314696,352443.4124022,27.424712,7142.0180666,4221.2953814,10370.602577,48.5801808,70.3473092,2.6011732,249.5074268),(12948,'Alces_femur.tif',242,7,86,823.0601691,110.5575765,128.5548019,1.8,110.2981871,129.2863186,0.4665688,37.9337352,44.9384059,161619.4818531,344415.9449397,27.7566205,7664.1780615,4260.5738973,11218.2477949,0.416016,0.5883355,2.3561945,1.1766709),(12949,'Alces_femur.tif',242,7,87,821.6620313,110.1157095,128.3949911,1.8,109.9573007,129.1444493,0.4702804,40.6991722,46.1544631,164054.214021,336239.4035532,28.1189812,7285.0897021,4030.8980547,10825.1816938,49.4428307,69.6351635,2.5950257,277.4273831),(12950,'Alces_femur.tif',242,7,88,819.2855798,109.6485305,128.1693354,1.8,109.3853116,128.8206486,0.4641063,45.3235921,47.4012616,166704.2753302,330131.9726852,27.3596442,6964.6241789,3678.0905425,9218.6864388,50.0360075,69.1450631,2.5836311,258.7607212),(12951,'Alces_femur.tif',242,7,89,815.9411989,109.2140814,128.0198462,1.8,108.9563206,128.7801804,0.4651046,40.7235905,46.3719944,168755.0445033,320392.3010668,27.3567184,6909.176649,4143.9136997,10527.4597858,0.416016,0.5883355,2.3561945,1.1766709),(12952,'Alces_femur.tif',242,7,90,807.0727603,108.7359337,127.9486629,1.8,108.5410123,128.7300383,0.4741454,27.8507894,36.2732151,169749.7546828,310645.4495757,28.0408986,8564.0450936,6094.9710415,13054.6545184,0.416016,0.5883355,2.3561945,1.1766709),(12953,'Alces_femur.tif',242,7,91,803.2113741,108.3256088,127.8373255,1.8,108.0218419,128.6727279,0.4823702,27.9515072,34.9628665,170913.4900996,302641.0552734,28.8064922,8656.0710217,6114.6430794,13295.4250969,0.416016,0.9302401,2.0344439,2.0087029),(12954,'Alces_femur.tif',242,7,92,804.5952468,107.9654645,127.7552373,1.8,107.6624257,128.6256004,0.4857715,26.7908677,34.3851408,174069.1047908,296783.4464377,29.2318762,8631.1540183,6497.3298604,13519.5228479,52.1100075,67.6483463,2.6201582,243.2203024),(12955,'Alces_femur.tif',242,7,93,802.2370463,107.3340745,127.6543891,1.8,107.0864071,128.6153212,0.4958373,29.0193906,35.4968933,176264.3454233,290870.5944641,30.2651229,8194.2549633,6074.0195368,13125.3832519,0.416016,0.9302401,2.0344439,2.0087029),(12956,'Alces_femur.tif',242,7,94,805.8721837,106.7877828,127.5759931,1.8,106.6293821,128.5637142,0.4946247,28.5960211,43.4647667,180334.1241068,285782.5676479,30.2660604,6575.0397304,6306.266299,10485.0851137,2.0572321,10.5326839,1.7294516,25.9112534),(12957,'Alces_femur.tif',242,7,95,812.9168914,106.3148274,127.6152941,1.8,106.1547587,128.6344444,0.4874247,29.0695573,34.1464945,185330.6238488,282304.2648412,29.7193816,8267.4449937,6375.4195499,13651.3402667,1.95072,8.6866691,1.8622531,24.7937131),(12958,'Alces_femur.tif',242,7,96,821.62018,105.8169788,127.6364162,1.8,105.6752805,128.6314097,0.4737258,45.2500925,33.8176002,191357.6382166,279570.3992275,28.4996632,8267.0088312,4228.8894341,10023.5378957,1.9624184,6.1845225,1.9138203,14.993895),(12959,'Alces_femur.tif',242,7,97,827.2323458,105.3479937,127.5579035,1.8,105.2569916,128.5686872,0.4436801,44.9935672,38.7981718,196894.764219,273107.3071664,25.4056057,7039.1798034,4376.0647644,10435.6756227,53.2015769,65.5103025,2.6523824,249.1454689),(12960,'Alces_femur.tif',242,7,98,834.9678098,104.983923,127.4783997,1.8,104.8927841,128.3805283,0.4402874,28.9957804,33.7150694,201106.0349476,267594.3458811,25.278092,7936.9359273,6935.700019,13718.2590901,2.08008,10.84837,1.6475682,26.9451702),(12961,'Alces_femur.tif',242,7,99,835.7105394,104.5206634,127.386823,1.8,104.4393445,128.324333,0.4049252,33.5244184,46.0653587,205711.3527346,260340.1489691,21.6165713,5651.5385203,6136.1647021,8205.1882708,53.4835174,63.3178539,2.5007197,273.8382396),(12962,'Alces_femur.tif',242,7,100,839.2926546,103.9701498,127.1491657,1.8,103.9585234,128.1052631,0.3375286,31.2374708,32.4650186,210610.6663496,250012.2705074,15.3400854,7700.9741846,6742.2445218,13618.5041435,53.5195433,62.9051409,2.4875099,259.0289104),(12963,'Alces_femur.tif',242,7,101,830.5799783,103.473509,126.8967909,1.8,103.3642268,127.8644065,0.2045488,30.2779899,29.9064183,214844.9973015,239592.7458819,5.7116083,8011.4155889,7095.7483684,14485.6059383,53.6002957,60.2591673,0.3894805,234.4788938),(12964,'Alces_femur.tif',242,7,102,840.1433165,102.9890345,126.7082363,1.8,102.8889966,127.8274254,0.0075918,31.8949585,29.7710867,218158.1698974,236541.6713005,0.0080697,7945.3489035,6839.8950887,14088.6468956,2.3348692,12.5427272,1.670465,32.483886),(12965,'Alces_femur.tif',242,7,103,840.150449,102.5850695,126.6844823,1.8,102.4782788,127.858678,-0.3742834,29.9392124,31.3331501,218595.9693274,237110.6972739,18.7168014,7567.4069242,7301.3266588,13814.1975438,53.250048,61.2575614,0.7373582,236.9158591),(12966,'Alces_femur.tif',242,7,104,841.7366555,102.2689515,126.5503259,1.8,102.2780392,127.6783637,-0.6332389,45.3973797,41.6082955,216367.3442216,240224.5374764,49.1263348,5773.4770101,4766.0756125,9789.1228436,2.0359065,8.3618181,1.670465,20.9190614),(12967,'Alces_femur.tif',242,7,105,836.6043637,102.0229633,126.3981411,1.8,101.9467108,127.5296107,-0.7304986,31.0966086,32.592076,210527.0477225,240990.6173794,62.0775356,7394.1475108,6770.0967052,13582.3300985,54.5077278,62.1536815,0.8374837,249.4727888),(12968,'Alces_femur.tif',242,7,106,818.7902345,101.8911621,126.1815174,1.8,101.7895079,127.4623995,-0.8035099,28.6219696,32.5159244,204359.2487522,237620.6678298,70.7035971,7307.8244613,7139.9436046,13384.6593805,53.8589246,62.2260373,0.8563688,272.1395376),(12969,'Alces_femur.tif',242,7,107,804.9679752,101.8019228,125.8833749,1.8,101.7075209,127.1736767,-0.8689307,28.5924276,32.2471846,198041.9397749,235117.8424252,78.2354371,7291.1122498,6926.37724,13221.6918619,0.832032,1.1766709,2.3561945,2.3533419),(12970,'Alces_femur.tif',242,7,108,794.8079675,101.7200033,125.5316854,1.8,101.6749856,127.0191005,-0.9154913,28.3862957,32.0713332,193253.9190762,233332.948755,83.2733869,7275.4365117,6808.0006235,13051.3607805,1.5899712,4.6512003,1.3909428,13.5735275),(12971,'Alces_femur.tif',242,7,109,785.7658826,101.6630221,125.1198958,1.8,101.5538332,126.6278015,-0.962225,27.6822476,38.6867057,188565.8900886,229899.9583528,88.1581953,5942.6088177,6811.7984095,10809.5568557,1.4718138,3.0286422,1.2924967,7.2027798),(12972,'Alces_femur.tif',242,7,110,779.9816964,101.4962844,124.7597447,1.8,101.3701445,126.4843227,-0.9864449,27.9681981,31.8608233,184855.4270128,227013.3642091,90.4353465,7125.1568798,6609.4864778,12808.2511127,1.248048,4.2425474,1.7681919,10.3881536),(12973,'Alces_femur.tif',242,7,111,773.9199175,101.4814533,124.3338301,1.8,101.2413246,126.0977948,-1.01229,32.7275438,31.2092633,181149.6929555,222770.1642397,92.7652228,7137.9501061,5535.0836633,12265.7791804,1.248048,3.5544423,1.2120257,9.2114827),(12974,'Alces_femur.tif',242,7,112,774.9153807,101.4158926,123.857264,1.8,101.2666247,125.7230538,-1.0168194,34.9834314,42.5609599,177942.2869694,219253.861514,93.4091564,5151.5252949,5086.4732209,9118.4444236,2.08008,4.3433346,1.2793395,14.7501984),(12975,'Alces_femur.tif',242,7,113,765.0961622,101.4330641,123.3172832,1.8,101.1327396,124.9980386,-1.0400724,27.280895,30.984587,172464.3182616,211801.2779207,94.8469665,6835.697951,6321.7983922,11404.9045948,2.496096,6.3638211,1.7681919,17.9355723),(12976,'Alces_femur.tif',242,7,114,764.0155803,101.3366783,122.8214512,1.8,101.1391444,124.3055808,-1.0487446,27.1299994,30.0490535,169316.0967417,207566.5226745,95.6723931,6907.5893729,6240.9178122,12354.2553084,1.7760231,5.5503457,1.3439975,13.4725851),(12977,'Alces_femur.tif',242,7,115,755.9148876,101.3778774,122.3570786,1.8,101.1683052,123.7410775,-1.0860901,26.9479997,43.3813004,165358.3871882,201936.343817,98.6332892,4654.9167966,6136.2026499,7440.5533609,2.0169734,6.7080564,1.6951513,20.6335531),(12978,'Alces_femur.tif',242,7,116,744.2733541,101.3101916,121.8068724,1.8,101.1401687,123.2018526,-1.1232478,26.0337634,43.1380253,161806.5839193,195956.8289016,100.8145017,4542.5544566,6215.2590544,7226.1273274,2.08008,6.2954644,1.4382448,16.4142624),(12979,'Alces_femur.tif',242,7,117,738.803682,101.2447287,121.287178,1.8,101.0754891,122.6964671,-1.1528441,25.9992547,43.0173985,159114.8760373,191040.1920373,102.8480545,4440.9982619,6119.9783491,6989.7757167,0.744614,1.499967,0.9827937,3.1853739),(12980,'Alces_femur.tif',242,7,118,736.3223925,101.1838205,120.7839463,1.8,100.9664429,122.0691164,-1.1926005,25.6380747,28.7638715,156640.8133644,187981.8365112,105.9885255,6535.3454315,6109.694873,11894.8641835,49.7414172,56.0927811,1.0074801,252.8600475),(12981,'Alces_femur.tif',242,7,119,735.6219863,101.1880255,120.2358834,1.8,100.9888529,121.4534677,-1.232173,26.4685231,28.3824824,154527.1772536,184634.5833146,109.0744164,6505.2302587,5838.1488374,11838.4875486,0.416016,0.5883355,2.3561945,1.1766709),(12982,'Alces_femur.tif',242,7,120,732.0970888,101.1613723,119.7183914,1.8,100.9921245,121.1381735,-1.2710659,26.2662156,28.3333936,151444.4511966,181047.7635605,111.3788093,6389.9074747,5765.7507097,10598.3338425,2.2402112,14.5308142,1.3397057,38.4090524),(12983,'Alces_femur.tif',242,7,121,735.8708914,101.1585141,119.1214689,1.8,101.0799643,119.8708118,-1.3150211,26.2672923,29.0484591,148076.7306095,177958.3437347,114.7950367,6126.2576062,5637.3047063,11166.9758768,48.6249944,53.6676764,1.0064452,250.5658363),(12984,'Alces_femur.tif',242,7,122,734.9160733,101.0531284,118.5911252,1.8,100.9343402,119.2351492,-1.3525765,25.5277478,28.733291,144203.548407,173946.9571692,116.7452401,6053.8473274,5648.8942698,11062.597244,2.6834814,13.8290126,1.4501727,36.1566529),(12985,'Alces_femur.tif',242,7,123,721.1690205,100.9429398,118.1093194,1.8,100.680145,119.0608867,-1.3930941,54.2800213,49.9422072,140490.9097606,169459.6500677,116.439098,3393.1149542,2588.261878,4202.1469045,47.84184,51.9470569,1.0138948,201.2221066),(12986,'Alces_femur.tif',242,7,124,718.1964239,100.9192704,117.5569568,1.8,100.6765483,118.4155562,-1.4363788,25.0756431,27.259531,137063.6920948,167061.1081738,117.549662,6128.5393381,5466.0090475,11002.1742469,47.009808,51.2392571,1.0526573,197.3056431),(12987,'Alces_femur.tif',242,7,125,724.6323472,100.9069474,116.9552306,1.8,100.6738969,117.8313967,-1.4408626,24.6573281,27.1608455,135023.5125917,167118.1439138,118.7445382,6152.9065483,5475.9993491,11112.1201229,46.8800649,50.5900088,0.9371633,207.7356084),(12988,'Alces_femur.tif',242,7,126,728.7904685,100.823065,116.3718597,1.8,100.2545386,117.0085024,-1.4599514,24.4438481,27.1880828,132597.9438538,166629.4507179,119.9787879,6128.7679568,5424.5936671,10957.2258569,46.593792,50.0085149,1.8662372,201.2221066),(12989,'Alces_femur.tif',242,7,127,731.2498359,100.8114273,115.8366517,1.8,100.2291139,116.444703,-1.4861851,24.5452393,27.2292639,130783.6844867,165331.3065652,121.0045431,6071.824323,5328.2709152,10798.03776,46.1170423,49.9097847,1.9373717,207.1054613),(12990,'Alces_femur.tif',242,7,128,733.7818924,100.7714083,115.3239253,1.8,100.1117355,115.9069547,-1.5089035,23.95623,27.2423623,128914.5660154,163466.0062257,121.8290935,6000.4343301,5381.2543115,10628.2628903,2.4190104,17.5960507,1.4523064,48.1497398),(12991,'Alces_femur.tif',242,7,129,735.7036435,100.7728749,114.7997863,1.8,100.2710578,115.2923833,-1.5343601,24.9694432,27.384373,126347.595262,161297.335245,122.4545598,5890.123355,5060.0886129,10218.7116015,2.4725651,20.9500305,1.4513674,50.7467782),(12992,'Alces_femur.tif',242,7,130,732.3404872,100.710402,114.3842516,1.8,100.2174754,114.7500723,-1.5502707,23.7506533,27.5745858,123333.2158869,158728.3421652,122.0053328,5756.3273462,5192.8346731,10097.7106558,2.4152488,22.1115537,1.4954674,57.3612225),(12993,'Alces_femur.tif',242,7,131,726.1767023,100.684123,113.9969369,1.8,100.1214772,114.2971564,-1.5567508,23.3037567,27.111738,120766.4426247,155832.3666677,121.0055764,5747.7822516,5182.2735831,10001.9342918,44.513712,49.2869239,1.9513027,193.5319338),(12994,'Alces_femur.tif',242,7,132,721.3123009,100.6099949,113.6450848,1.8,100.0044674,113.9865295,-1.5533536,23.4450239,27.0574009,118551.4492592,153526.7974184,120.1821442,5674.1147528,5056.5719188,9896.4966837,2.4591738,22.8960029,1.5344487,60.6475388),(12995,'Alces_femur.tif',242,7,133,720.306873,100.618264,113.3306556,1.8,100.2286518,113.6542261,-1.5615737,22.9359049,26.9187764,116701.3429795,152062.0306016,120.0409347,5648.9205967,5088.1507981,9780.8123618,2.3298379,21.6488267,1.5323537,59.9582609),(12996,'Alces_femur.tif',242,7,134,717.6101385,100.6045352,112.96458,1.8,100.1947147,113.2788004,-1.5639259,22.9930074,26.431107,114642.4890038,150502.6015772,119.596044,5694.1467289,4985.9719089,9899.9900968,2.08008,21.2208942,1.5904017,50.443951),(12997,'Alces_femur.tif',242,7,135,717.3931725,100.5963853,112.5975984,1.8,100.1933749,112.8568052,1.5703843,22.9577346,26.3504048,112941.6841958,149280.1611215,119.5655082,5665.194224,4919.5482982,9855.9848365,2.0466971,19.17739,1.6359215,46.7293724),(12998,'Alces_femur.tif',242,7,136,717.6584406,100.5731007,112.2687097,1.8,100.1985053,112.4723407,1.5616403,22.1882718,26.2377953,111113.5528994,148196.5845114,119.5997133,5648.2102563,5007.7605877,8948.192324,2.2714161,18.7622755,1.6373645,47.9060433),(12999,'Alces_femur.tif',242,7,137,716.9434021,100.5627496,111.8797709,1.8,100.1119158,111.9526427,1.5395356,22.5790664,26.1372378,108925.344319,146283.7684406,119.3738342,5596.7569996,4824.1739735,9635.0415221,2.1660863,21.2819734,1.6490675,57.0165836),(13000,'Alces_femur.tif',242,7,138,712.4851366,100.4825166,111.5345153,1.8,100.0417811,111.4392478,1.5289436,22.4855875,26.0301124,106965.9919378,144251.8142146,118.53964,5541.7284468,4757.0912581,9549.2329731,2.4035607,20.4906357,1.6724852,50.9904748),(13001,'Alces_femur.tif',242,7,139,711.3274078,100.4087379,111.2333696,1.8,99.9460897,111.2131062,1.509212,23.2418201,25.839737,105170.4307284,142816.2869506,118.1055021,5527.0023361,4525.0514113,9435.2820272,2.4385032,20.4906357,1.6724852,59.7563761),(13002,'Alces_femur.tif',242,7,140,714.1793803,100.3468905,110.931778,1.8,100.1385441,110.8687022,1.4835475,22.3006957,25.6862382,104109.4998891,141905.7093428,118.1260945,5524.5812363,4668.4418064,9403.7639153,2.2290067,20.9500305,1.6902253,50.9904748),(13003,'Alces_femur.tif',242,7,141,712.5536825,100.2151883,110.7050757,1.8,99.9945434,110.9366233,1.4673931,22.6515713,25.8299567,103006.1693914,140909.9014366,117.493667,5455.289887,4547.41827,9430.496052,0.416016,0.5883355,2.3561945,1.1766709),(13004,'Alces_femur.tif',242,7,142,713.7513746,100.0810294,110.5338768,1.8,99.7517687,110.9677255,1.4559797,22.718425,25.0856285,102057.8915679,140104.0899537,117.397227,5585.0340643,4492.2960727,9251.0603373,1.6899208,18.3660581,1.799293,46.0992252),(13005,'Alces_femur.tif',242,7,143,715.8009873,99.9508074,110.2670363,1.8,99.7292508,110.5057437,1.445607,23.2218694,24.9893667,101308.9196242,139306.3436531,117.4401948,5574.6248218,4362.6513346,9537.1570444,1.7276715,14.1261784,1.8086323,34.3916465),(13006,'Alces_femur.tif',242,7,144,713.5788298,99.8428721,109.9403951,1.8,99.6903094,110.1339365,1.4338049,23.2509195,24.9993783,100076.1385673,138151.9134585,116.7118183,5526.2139725,4304.179824,9484.5112855,1.6839768,13.9473979,1.8736812,34.0470076),(13007,'Alces_femur.tif',242,7,145,711.08102,99.7946886,109.5872183,1.8,99.6621398,109.7341243,1.4161227,22.5772233,24.6206197,98284.7929797,136633.2209207,115.700735,5549.5443421,4353.2719629,9294.8353376,1.248048,3.835478,1.7894653,10.7746043),(13008,'Alces_femur.tif',242,7,146,706.7886388,99.7334411,109.3399831,1.8,99.4921009,109.564612,1.4008994,21.9103464,24.7347622,96679.6749278,135026.6528464,114.4304577,5458.9832656,4412.5123798,8413.3857638,0.832032,1.8604801,2.0344439,4.0174059),(13009,'Alces_femur.tif',242,7,147,703.1629941,99.7026155,109.0608216,1.8,99.6675144,109.3294544,1.3907736,22.2899754,24.7435354,95454.1656543,133505.2302086,113.4366437,5395.5600139,4282.3809427,8430.9233922,2.4085846,18.2905161,1.8709675,47.5195927),(13010,'Alces_femur.tif',242,7,148,701.7149808,99.6246085,108.7250089,1.8,99.5968172,108.8856855,1.3855934,22.4750763,24.6619377,94414.881142,132517.8265157,112.9866671,5373.3744692,4200.8703366,8581.7668697,2.167176,14.7436446,1.8568478,36.8877425),(13011,'Alces_femur.tif',242,7,149,707.2309096,99.5764268,108.4810776,1.8,99.8102267,108.6851666,1.3738414,42.9303032,39.2110945,93879.5909415,132205.9059042,113.358241,3371.6453909,2186.7907759,3888.4891705,0.416016,0.9302401,2.0344439,2.0087029),(13012,'Alces_femur.tif',242,7,150,703.9807728,99.4780404,108.1916283,1.8,99.6868489,108.2873956,1.3655297,22.1526731,24.7284608,92690.243439,130984.6721909,112.4555371,5296.9197472,4184.1561594,8625.9320582,0.416016,0.5883355,2.3561945,1.1766709),(13013,'Alces_femur.tif',242,7,151,713.1910496,99.4387228,107.934456,1.8,99.6632122,108.2297342,1.3541797,21.8798511,24.583878,92062.7493088,130745.8551762,113.3743835,5318.3576273,4207.6497138,8998.197269,0.416016,3.3540282,1.6951513,7.0008949),(13014,'Alces_femur.tif',242,7,152,712.3948259,99.4073261,107.6367537,1.8,99.6850928,107.8620737,1.339662,44.0377366,39.9675917,91076.9891413,130015.6318202,112.5015703,3253.026424,2068.1578157,3717.690711,0.8258302,4.2425474,1.7681919,9.0095979),(13015,'Alces_femur.tif',242,7,153,712.1080553,99.3693923,107.2791362,1.8,99.6032956,107.4024868,1.3334199,21.2401173,24.5740357,89571.930301,128572.7905141,112.121755,5232.0584265,4217.1109078,8627.7664591,0.416016,1.3155581,1.8925469,2.8407349),(13016,'Alces_femur.tif',242,7,154,711.8255327,99.2885287,107.0325944,1.8,99.5219926,107.1590371,1.32526,21.0539611,24.3382962,88503.3462501,127709.0031375,111.6277374,5247.2450126,4203.6434743,8491.9119843,0.416016,1.7152779,1.815775,3.6727669),(13017,'Alces_femur.tif',242,7,155,711.3507459,99.2594741,106.7775188,1.8,99.5488339,106.8879316,1.314794,45.7918864,40.9411387,87806.330301,126970.8481965,110.9567347,3101.3023151,1917.5084762,3496.5560048,38.9255099,46.8456922,1.915015,157.1489033),(13018,'Alces_femur.tif',242,7,156,711.9281681,99.2425527,106.551365,1.8,99.4624621,106.6467844,1.3072848,21.345621,25.2394913,86898.2750271,126468.2085323,110.6044617,5010.7273147,4071.0118055,7852.3984393,0.416016,0.9302401,2.0344439,2.0087029),(13019,'Alces_femur.tif',242,7,157,710.6478747,99.2290659,106.2875839,1.8,99.4923855,106.3847211,1.29689,21.9597237,24.4013382,86282.2138004,125718.1206201,109.7753031,5152.0994328,3929.1119986,8419.0668121,38.152654,46.7439843,1.9347753,140.045363),(13020,'Alces_femur.tif',242,7,158,704.4734959,99.1822539,105.9728965,1.8,99.4579881,106.1187843,1.2864608,61.6198524,40.6622599,85369.9200542,124625.9454804,108.1729248,3064.904552,1385.4288304,2844.431875,38.0221438,46.7439843,1.9347753,139.5579699),(13021,'Alces_femur.tif',242,7,159,699.6629033,99.108142,105.7038116,1.8,99.327535,105.8883267,1.280595,21.4325417,24.9682979,84600.9645372,123872.5775488,107.0625316,4961.1943157,3947.3136473,8190.0141332,38.0020688,46.5975063,1.9264322,139.3142734),(13022,'Alces_femur.tif',242,7,160,698.3364581,99.036698,105.4868777,1.8,99.2436232,105.6122835,1.2726335,21.5302687,40.3181754,83932.6171102,123769.040963,106.3452793,3069.8075904,3898.3543716,4544.2220472,37.8916337,46.5956492,1.9745158,138.8268803),(13023,'Alces_femur.tif',242,7,161,701.6332187,98.9962851,105.2427108,1.8,99.1070308,105.2620747,1.2669422,22.100438,24.2347807,83158.183595,123137.2662902,106.4704287,5081.0142609,3762.7391706,8509.7017553,37.7611235,46.5975063,1.9264322,138.4822414),(13024,'Alces_femur.tif',242,7,162,700.2390143,98.9362366,104.9869017,1.8,99.0685012,105.0292064,1.2565184,21.5723203,23.9647361,82511.1553661,122041.5538223,105.5538845,5092.5473692,3824.8623393,8423.9830307,37.7596298,46.5956492,1.9745158,138.7259379),(13025,'Alces_femur.tif',242,7,163,694.2155729,98.8253652,104.697767,1.8,98.9713731,104.8063386,1.2544574,20.7803074,28.534004,81841.9162361,120479.553677,104.5053038,4222.3150175,3938.4362658,6624.1092925,38.689488,46.3797206,1.9862884,171.2098239),(13026,'Alces_femur.tif',242,7,164,689.7132534,98.7285478,104.4492909,1.8,98.8850502,104.5659909,1.2468527,20.6732748,24.5282714,81357.434828,119675.3467324,103.3052883,4879.0778955,3935.3917434,8183.494212,0.416016,0.5883355,2.3561945,1.1766709),(13027,'Alces_femur.tif',242,7,165,685.9770016,98.644873,104.2149047,1.8,98.7876074,104.3511494,1.2386965,20.9753753,24.1007167,80880.7452426,119161.2147595,102.1768711,4944.3017093,3855.9855971,8195.4957447,0.744614,1.8604801,2.0344439,4.0174059),(13028,'Alces_femur.tif',242,7,166,683.5824041,98.561468,103.9935789,1.8,98.6915339,104.1191128,1.2366595,20.745439,24.4690519,80441.3647588,118784.3579493,101.6767635,4854.4732528,3877.5445952,8118.7103544,0.832032,1.7152779,1.815775,4.0174059),(13029,'Alces_femur.tif',242,7,167,681.7943883,98.4755435,103.7833794,1.8,98.6380851,103.9328403,1.2377228,45.0027787,49.698828,80129.1420958,118510.1410127,101.4855736,2384.5661104,1780.5376547,2962.7123621,37.5910456,46.2133673,1.9780522,137.3055704),(13030,'Alces_femur.tif',242,7,168,678.6148428,98.3923049,103.5778095,1.8,98.5389196,103.7320106,1.2378957,20.4942644,24.4050905,79678.5793582,118178.9504387,101.0243779,4842.3893596,3887.847725,8103.498352,37.4956222,46.2133673,1.9780522,137.6502094),(13031,'Alces_femur.tif',242,7,169,675.6795873,98.3566474,103.356754,1.8,98.4399234,103.5394326,1.235533,20.3275036,24.3322241,78822.8499579,117378.4890675,100.4225726,4823.9934325,3877.6453477,8005.2922861,37.4956222,46.2133673,1.9780522,137.3055704),(13032,'Alces_femur.tif',242,7,170,672.1094296,98.3028107,103.1577723,1.8,98.4081732,103.3360387,1.2357554,20.3965359,45.4312939,78189.3957983,116753.1327305,99.9074306,2569.8835053,3833.4644742,4265.8348322,37.914562,46.2133673,1.9780522,181.2706575),(13033,'Alces_femur.tif',242,7,171,670.0555689,98.2557592,102.975991,1.8,98.3511815,103.1910484,1.2343346,20.3009016,24.878107,77663.2148025,116582.7960669,99.5034111,4686.1602544,3825.6042199,7797.4421351,0.832032,1.7152779,1.815775,4.0174059),(13034,'Alces_femur.tif',242,7,172,669.688662,98.2000665,102.7782499,1.8,98.3215253,102.9779682,1.2315561,20.8955584,24.4102501,77416.4002664,116837.294594,99.2549601,4786.4030164,3704.9213351,7930.8169104,0.416016,1.7152779,1.815775,3.6727669),(13035,'Alces_femur.tif',242,7,173,669.6122492,98.1356279,102.597205,1.8,98.2486297,102.7950152,1.2280699,20.217238,24.2310087,77307.9407615,117168.1952195,98.9984025,4835.4650344,3823.8626176,8008.7588662,0.832032,1.1766709,0.7853982,2.3533419),(13036,'Alces_femur.tif',242,7,174,668.5866824,98.0689486,102.4102087,1.8,98.2009305,102.6556517,1.2222823,20.8854142,24.5674466,77110.3041359,117323.049826,98.4356517,4775.549191,3692.0648683,7913.2261257,37.6305796,46.2751186,1.9579804,170.9243156),(13037,'Alces_femur.tif',242,7,175,666.7934221,98.0167887,102.2410112,1.8,98.1104172,102.3978605,1.2214926,20.4457407,24.6015767,76933.7413946,117409.386473,98.1152409,4772.433409,3762.8248594,7885.8800991,37.7410059,46.2751186,1.9579804,180.3376831),(13038,'Alces_femur.tif',242,7,176,663.7117395,97.9493552,102.0806551,1.8,98.0501892,102.2751078,1.217542,20.4671997,24.6280148,76645.328325,117349.4489737,97.3793974,4764.8764945,3744.7882215,7866.0860387,0.416016,1.3155581,1.8925469,2.8407349),(13039,'Alces_femur.tif',242,7,177,662.1952327,97.8982132,101.8742897,1.8,98.0177397,102.0114538,1.2157849,20.2146776,24.302289,75900.9952063,117208.4736168,97.0307522,4822.9396637,3754.746752,7919.4660845,0.416016,1.7152779,1.815775,3.6727669),(13040,'Alces_femur.tif',242,7,178,660.4373205,97.8125348,101.7595153,1.8,97.954941,101.9228198,1.2127927,20.9794909,24.2891079,75467.6428986,117233.7024589,96.5577212,4826.59564,3597.2103939,7842.0636746,0.416016,0.9302401,2.0344439,2.0087029),(13041,'Alces_femur.tif',242,7,179,656.7562412,97.7266465,101.6109538,1.8,97.8478538,101.8150433,1.2099832,20.3815553,24.6508636,75037.4173199,116989.5342143,95.81704,4745.8594616,3681.6335223,7764.1066496,0.7905293,2.2403147,1.9513027,4.8494379),(13042,'Alces_femur.tif',242,7,180,654.7481127,97.6618031,101.509562,1.8,97.7725961,101.6716007,1.2115332,20.3036521,23.9919609,74909.7028826,117141.2894015,95.6356023,4882.5225267,3689.4693875,7918.8783956,37.025009,46.5213043,2.0144466,137.4065129),(13043,'Alces_femur.tif',242,7,181,643.3841194,97.6626438,101.4009137,1.8,97.9959199,101.6258708,1.2089479,32.4605046,24.2804798,74433.6639064,117110.6137848,93.7926966,4823.2413379,2293.0531967,5467.206372,37.025009,46.4337969,1.9662766,137.4065129),(13044,'Alces_femur.tif',242,7,182,644.1470928,97.5742561,101.2931366,1.8,97.5942187,101.4842031,1.2100318,20.31171,24.4146349,74467.8578298,117846.2645893,93.9808796,4826.8698331,3666.2525185,7776.7920911,0.416016,1.3155581,1.8925469,2.8407349),(13045,'Alces_femur.tif',242,7,183,645.7187195,97.5218226,101.1653125,1.8,97.5278958,101.1866447,1.2108625,20.3145551,24.407775,74697.3547248,118557.731253,94.2691774,4857.3756148,3677.0362128,7884.0627007,0.416016,1.3155581,1.8925469,2.8407349),(13046,'Alces_femur.tif',242,7,184,647.0865964,97.4936873,101.1014025,1.8,97.622175,101.3122761,1.2073815,21.0455137,24.2998379,74941.8938556,119162.297442,94.2203836,4903.8309692,3560.9439085,7925.0928654,37.0057454,46.6606038,1.954614,137.6502094),(13047,'Alces_femur.tif',242,7,185,643.1904916,97.4729762,100.9453726,1.8,97.5941166,101.0666363,1.202657,20.4472762,24.4670755,74716.7089737,118780.0828195,93.3147605,4854.6906557,3654.1155073,7852.9873628,0.7905293,1.8604801,2.0344439,4.0174059),(13048,'Alces_femur.tif',242,7,186,639.7549608,97.4090991,100.8020906,1.8,97.4939218,100.8875958,1.2024591,20.7487172,24.6243232,74600.6314311,118640.5076733,92.8021559,4818.0210518,3595.433434,7793.1066537,36.842552,46.7439843,1.9347753,138.4822414),(13049,'Alces_femur.tif',242,7,187,636.5269035,97.3653489,100.6469426,1.8,97.4125979,100.6651002,1.2045181,20.2829869,24.4541204,74458.4762342,118465.9135923,92.4803127,4844.4152515,3670.9818198,7876.7272694,37.8966689,46.7606425,1.9826973,194.0121531),(13050,'Alces_femur.tif',242,7,188,635.0105541,97.3164692,100.506131,1.8,97.3077439,100.526002,1.2050589,20.3357658,24.4550589,74584.8750703,118606.0765149,92.2982594,4849.9607737,3667.6698526,7879.4831134,36.842552,46.7606425,1.9826973,138.2385449),(13051,'Alces_femur.tif',242,7,189,634.9907822,97.2781983,100.3549434,1.8,97.218756,100.2918801,1.2057135,20.4276853,24.2673663,75186.6880832,118771.9753434,92.3416222,4894.3084236,3680.6269066,7795.1430852,0.416016,1.7152779,1.815775,3.6727669),(13052,'Alces_femur.tif',242,7,190,635.0400283,97.2523507,100.2187019,1.8,97.2750638,100.1033484,1.2045803,20.4484083,24.3891277,75598.9791016,119344.5239495,92.2686853,4893.3494259,3697.0593435,7892.5375175,37.0292336,46.8179756,1.9628533,139.1715193),(13053,'Alces_femur.tif',242,7,191,632.0414714,97.2694659,100.1213156,1.8,97.3711626,100.3450282,1.2054601,21.3837952,24.409429,74852.7394428,119933.3853689,91.8949234,4913.4039725,3500.4422162,7977.9580077,37.0292336,46.8179756,1.9628533,139.4152158),(13054,'Alces_femur.tif',242,7,192,593.7393445,97.4254999,100.0769248,1.8,97.4922834,100.177971,1.2125573,19.9248898,24.1036924,66681.5285071,120110.7301288,86.7910038,4983.0842608,3346.6447787,7538.4191323,0.416016,0.5883355,2.3561945,1.1766709),(13055,'Alces_femur.tif',242,7,193,564.9616415,97.3089029,100.0778699,1.8,97.3583159,100.2650209,1.2071451,20.0213258,24.9928438,60964.466933,119785.1832816,82.2476142,4792.7792589,3044.9765246,7229.3444164,20.2947432,37.3071496,0.1229719,129.0443811),(13056,'Alces_femur.tif',242,7,194,556.6634924,97.2506261,99.9799328,1.8,97.3007613,100.1488209,1.2045355,19.4062827,24.4671876,59769.0449776,119789.6976765,80.8781221,4895.9324417,3079.8811822,7228.3072486,18.0171443,36.5763008,0.3361381,139.718043),(13057,'Alces_femur.tif',242,7,195,558.2924418,97.1674004,99.8346365,1.8,97.1858407,99.9841827,1.2035097,19.9970426,24.7469607,60744.6073155,120114.3770659,81.0508884,4853.7021768,3037.6795544,7291.3268332,20.8964853,37.7727866,0.1325515,160.4943503),(13058,'Alces_femur.tif',242,7,196,570.4479911,97.0889811,99.6377487,1.8,97.1071863,99.7158112,1.2004852,19.5756294,24.5298108,63853.0063501,120906.7219297,82.6222073,4928.9708256,3261.8622442,7387.6179091,37.0848756,47.2320171,2.117258,140.9365257),(13059,'Alces_femur.tif',242,7,197,604.4483491,96.945598,99.3913077,1.8,96.9807399,99.4462583,1.1919295,20.2976301,24.81875,71804.0361099,121722.297198,86.9597441,4904.4491364,3537.5576269,7651.0196213,1.5896229,3.7209602,2.0344439,9.2114827),(13060,'Alces_femur.tif',242,7,198,623.3876386,96.9297355,99.1891556,1.8,96.9054441,99.2568325,1.1884936,20.6923794,24.6267704,77114.6013416,121749.4779453,89.4382345,4943.7858031,3726.7150302,7967.0012559,0.416016,1.3155581,1.8925469,2.8407349),(13061,'Alces_femur.tif',242,7,199,623.184728,96.9388626,99.0628509,1.8,96.9178412,99.0508233,1.1867552,20.5530095,24.5193351,77863.3628093,122127.6569362,89.2839006,4980.8714759,3788.4166193,8107.2542436,0.7905293,2.2403147,1.1902899,4.8494379),(13062,'Alces_femur.tif',242,7,200,621.489278,96.9160467,98.9462301,1.8,96.9014521,98.9633221,1.1903572,33.5358411,24.8648031,78076.0093482,122552.3685939,89.2992403,4928.7488008,2328.1363107,5059.6205605,0.416016,0.9302401,2.0344439,2.0087029),(13063,'Alces_femur.tif',242,7,201,618.6321659,96.8925659,98.7314337,1.8,96.7886711,98.6556314,1.1933294,20.5626063,24.9984878,77761.4610418,122596.6226065,89.099365,4904.1615536,3781.692848,8009.3999342,0.7905293,2.2403147,1.9513027,4.8494379),(13064,'Alces_femur.tif',242,7,202,616.1336744,96.8231064,98.576556,1.8,96.7023804,98.5088739,1.1933886,20.6364203,25.0949341,77753.6725563,122518.518383,88.743682,4882.2012334,3767.7887594,7949.443417,1.248048,3.5544423,1.929567,8.8668438),(13065,'Alces_femur.tif',242,7,203,614.0500248,96.7773189,98.4301183,1.8,96.6884459,98.3729187,1.197105,20.731778,24.8043195,77816.6680824,122655.3305558,88.7031303,4944.9181941,3753.4970671,7934.4440128,0.416016,0.9302401,2.0344439,2.0087029),(13066,'Alces_femur.tif',242,7,204,613.9910239,96.7149342,98.3106345,1.8,96.5770577,98.3034603,1.2039992,20.9477778,25.4041385,78183.8109737,123291.7182569,89.1705673,4853.2139025,3732.3200468,7830.0796086,0.8585784,3.9466743,1.8925469,8.5222048),(13067,'Alces_femur.tif',242,7,205,614.0123691,96.6376947,98.127733,1.8,96.6006543,98.122501,1.2085737,20.5224325,25.6112024,78636.2057374,124033.5176409,89.4855051,4842.9400407,3831.7195537,7893.2494445,37.769623,47.8852307,2.0888649,142.4996473),(13068,'Alces_femur.tif',242,7,206,613.9588225,96.5524262,97.9664943,1.8,96.5201462,98.0085138,1.2126465,20.7800074,25.3596317,79045.2253844,124685.0099372,89.7526199,4916.6727355,3803.9074727,8030.7095722,0.7905293,1.8604801,2.0344439,4.0174059),(13069,'Alces_femur.tif',242,7,207,615.1104152,96.4844866,97.8447511,1.8,96.5174751,97.9493988,1.2180515,20.7250522,25.4096697,79686.4230237,125447.4689205,90.2825303,4936.9972212,3844.9323113,7810.9217196,0.416016,0.9302401,2.0344439,2.0087029),(13070,'Alces_femur.tif',242,7,208,615.8106117,96.4227466,97.7160525,1.8,96.4774951,97.7919783,1.2215371,20.9358244,24.9904179,80163.3782612,125978.8454565,90.6163142,5041.08599,3829.0051019,8013.4501698,0.416016,1.3155581,1.8925469,2.8407349),(13071,'Alces_femur.tif',242,7,209,613.0840882,96.3670933,97.5367304,1.8,96.3019548,97.5394327,1.2247515,20.9191872,25.1882932,80012.552344,125657.9157936,90.4255164,4988.7427872,3824.8404094,7990.2332159,0.8084021,3.1682835,1.9756881,6.8581408),(13072,'Alces_femur.tif',242,7,210,612.6525687,96.2905369,97.4227349,1.8,96.1872931,97.3766849,1.2250189,21.0613305,24.8847615,80153.9695118,125772.4988434,90.379291,5054.1974878,3805.7410171,8124.9864098,0.8073171,3.0286422,1.849096,6.5135019),(13073,'Alces_femur.tif',242,7,211,612.1242878,96.2251598,97.283394,1.8,96.1229371,97.2449197,1.223619,21.0070045,25.538089,80467.6391073,125908.8444956,90.2101211,4930.2375159,3830.5146771,7929.6428716,1.3888736,7.7718202,1.8417432,17.7336875),(13074,'Alces_femur.tif',242,7,212,612.9859632,96.153023,97.1638878,1.8,96.0902043,97.1861748,1.2220138,21.1186315,25.7452354,81037.2575531,126651.4001748,90.2319685,4919.4112347,3837.2400096,7970.9204998,0.832032,2.6311162,1.8925469,5.6814699),(13075,'Alces_femur.tif',242,7,213,617.4288098,96.0876605,97.0286936,1.8,96.0972958,96.9353989,1.2220497,21.0144474,25.8235868,81707.4547039,127974.3418985,90.8883345,4955.7152126,3888.1562288,8118.1095766,0.416016,1.3155581,1.8925469,2.8407349),(13076,'Alces_femur.tif',242,7,214,617.614361,96.0751607,96.9739138,1.8,96.1456782,97.0653231,1.2176333,20.6519111,25.8767448,82199.1251736,128516.414369,90.6221187,4966.4830564,3980.2188231,8140.5192477,0.416016,0.9302401,2.0344439,2.0087029),(13077,'Alces_femur.tif',242,7,215,623.6979047,96.0658818,96.8560495,1.8,96.1605573,97.0818574,1.2163192,20.825135,25.0066228,83216.4612116,129738.3361051,91.4259609,5188.1590426,3995.9626235,8462.6311942,0.416016,0.9302401,2.0344439,2.0087029),(13078,'Alces_femur.tif',242,7,216,626.5614151,96.0172571,96.7472361,1.8,96.1485178,96.940469,1.2118106,20.706184,25.5204951,83917.8461834,130998.3888725,91.537579,5133.0661341,4052.7914819,8251.3583824,0.416016,1.3155581,1.8925469,2.8407349),(13079,'Alces_femur.tif',242,7,217,625.1036995,96.0343963,96.5686693,1.8,96.1565314,96.7758248,1.2016129,21.4932509,25.8053805,83974.4990099,130963.3578455,90.6175722,5075.040752,3907.0171073,8295.3989199,0.416016,0.5883355,2.3561945,1.1766709),(13080,'Alces_femur.tif',242,7,218,623.0206792,95.959725,96.4561932,1.8,96.0751204,96.6739901,1.1981572,21.3004501,25.7283581,83846.9454827,131309.8309906,90.0731715,5103.700376,3936.3931267,8120.2036412,0.416016,0.9302401,2.0344439,2.0087029),(13081,'Alces_femur.tif',242,7,219,621.5306573,95.9041737,96.3559013,1.8,96.0006607,96.5224721,1.1962682,21.268532,25.5548459,84052.0711714,131129.3834386,89.7247774,5131.2922797,3951.945115,8412.9013234,0.416016,0.5883355,2.3561945,1.1766709),(13082,'Alces_femur.tif',242,7,220,622.9287427,95.8533592,96.2731004,1.8,95.9864277,96.4113699,1.1902675,28.8754841,46.6681754,84552.8211859,131864.1421287,89.4996466,2825.5688357,2928.1871443,4196.4999371,0.416016,0.5883355,2.3561945,1.1766709),(13083,'Alces_femur.tif',242,7,221,623.8026379,95.8152198,96.1965969,1.8,96.0040429,96.2882128,1.1847265,20.7037546,25.6475036,85039.0884194,132579.3518745,89.2255857,5169.2887591,4107.4235147,8430.0424898,0.416016,0.9302401,2.0344439,2.0087029),(13084,'Alces_femur.tif',242,7,222,623.3471509,95.7634451,96.1245561,1.8,95.9771095,96.1532081,1.1810729,20.819223,25.6542225,85524.7281255,133279.9512642,88.8946238,5195.2442256,4107.969265,8364.8955431,0.832032,1.499967,2.1587989,3.1853739),(13085,'Alces_femur.tif',242,7,223,624.8128382,95.7312687,96.0825417,1.8,95.9615273,96.1562539,1.1754373,28.4381596,42.991342,86295.7361659,134036.2042881,88.6888001,3117.7487884,3034.5049496,4274.4767235,1.6604462,8.423682,1.9237867,19.3977515),(13086,'Alces_femur.tif',242,7,224,625.1371071,95.6932423,96.0491205,1.8,95.9397432,96.1479247,1.1727694,21.1030571,25.7938306,86885.8422333,134485.4077217,88.5367129,5213.8594572,4117.2158922,8517.6892776,1.4779319,7.3718223,1.8568478,17.489991),(13087,'Alces_femur.tif',242,7,225,624.7200625,95.6871798,95.923962,1.8,95.9008103,95.9420443,1.162576,21.7230554,25.4029632,87056.6684849,134826.5363657,87.7117012,5307.5121808,4007.5701454,8547.5706352,1.6474669,14.217769,1.929567,34.979982),(13088,'Alces_femur.tif',242,7,226,624.5737403,95.6485462,95.8398253,1.8,95.8430222,95.9301957,1.1552478,22.137724,25.9436141,87241.9471638,135136.1190283,87.1314592,5208.8393925,3940.8724773,8311.477491,2.4400776,21.212737,2.0169019,55.5125927),(13089,'Alces_femur.tif',242,7,227,624.2717606,95.6292977,95.7626917,1.8,95.8178237,95.8400059,1.1453918,21.8409572,25.3625421,87649.0073196,135256.659193,86.325085,5332.929911,4013.0570453,8495.790992,1.116921,1.7650064,0.7853982,4.3620448),(13090,'Alces_femur.tif',242,7,228,622.206257,95.5313947,95.7072538,1.8,95.7298967,95.7688403,1.1363299,22.1140922,25.4321845,87918.4511086,135575.9495225,85.3273908,5330.8810073,3975.6753523,8612.9240917,0.416016,0.9302401,2.0344439,2.0087029),(13091,'Alces_femur.tif',242,7,229,620.8862102,95.4837595,95.6529162,1.8,95.5886098,95.7316844,1.124419,21.8353642,25.6020447,88439.2157417,135757.592037,84.1957447,5302.6074149,4050.274356,8753.1654456,1.8239355,13.2211953,1.9922155,31.651854),(13092,'Alces_femur.tif',242,7,230,621.5117246,95.5036701,95.6172027,1.8,95.5380946,95.7341837,1.112492,21.3481513,25.3549197,88970.4279855,136575.3525989,83.3092319,5386.5425115,4167.5940314,8646.866463,1.624697,8.6866691,1.8622531,21.2637003),(13093,'Alces_femur.tif',242,7,231,625.298114,95.5131087,95.5784585,1.8,95.5376188,95.6887119,1.1006251,21.7000677,25.5163504,89942.9519465,137665.8102842,82.8265418,5395.1998593,4144.8235638,8893.6303503,1.0291396,3.9466743,1.8925469,8.8668438),(13094,'Alces_femur.tif',242,7,232,624.3546241,95.5962226,95.5569168,1.8,95.6149984,95.5987408,1.0940762,21.1980154,25.7251592,90561.6631847,138149.4711882,82.1484903,5370.2085974,4272.1764997,8748.1872494,0.416016,0.9302401,2.0344439,2.0087029),(13095,'Alces_femur.tif',242,7,233,623.1778576,95.633491,95.4644329,1.8,95.6062879,95.5299,1.0945183,21.4816357,25.8150381,90635.1808948,138035.6520524,82.0310893,5347.102386,4219.1936458,8709.1648126,0.416016,0.9302401,2.0344439,2.0087029),(13096,'Alces_femur.tif',242,7,234,624.3751302,95.6250083,95.4221734,1.8,95.6033223,95.4492593,1.0923076,21.7772873,45.9325318,91079.3167502,138409.123975,82.0009266,3013.3136253,4182.3077207,4957.2981188,39.3869496,48.9433586,2.0572537,148.7276409),(13097,'Alces_femur.tif',242,7,235,622.6840856,95.6206195,95.3999812,1.8,95.5931847,95.4410477,1.0917392,21.8504506,25.9545586,91423.4339824,138264.7365006,81.7305948,5327.185053,4184.0525692,8778.1434101,39.4487011,48.9734063,1.8549302,148.9713374),(13098,'Alces_femur.tif',242,7,236,622.0717874,95.641741,95.3562762,1.8,95.6003974,95.3790602,1.0864483,21.8374784,25.9255778,91967.5807298,138596.651414,81.1997929,5345.9426287,4211.4560546,8893.2907557,39.6322142,49.0493273,1.7931451,149.3159764),(13099,'Alces_femur.tif',242,7,237,629.0474771,95.6681967,95.3008282,1.8,95.6449535,95.2614052,1.0772244,21.9509182,26.2540286,93561.6669242,139557.4961656,81.3083414,5315.6602405,4262.3122154,8798.6369568,0.832032,1.8604801,2.0344439,4.0174059),(13100,'Alces_femur.tif',242,7,238,632.3394128,95.6975758,95.3009453,1.8,95.6618462,95.2374225,1.0693634,21.7488644,26.0639935,94469.896607,140219.7485844,81.0389592,5379.8259522,4343.6703177,8992.1559481,1.0407295,2.08008,2.2142974,4.3620448),(13101,'Alces_femur.tif',242,7,239,636.0533229,95.707132,95.2485127,1.8,95.6769816,95.1969081,1.060309,21.9375204,26.0129032,95478.1884596,140937.2337208,80.7011324,5417.9740177,4352.2780553,9073.4791779,0.416016,0.9302401,2.0344439,2.0087029),(13102,'Alces_femur.tif',242,7,240,641.6984768,95.6820108,95.1677542,1.8,95.6501117,95.0870744,1.0483321,21.7364411,26.2312308,96565.1546775,142111.2040419,80.3173262,5417.6338569,4442.5466943,9095.3679211,0.416016,0.5883355,2.3561945,1.1766709),(13103,'Alces_femur.tif',242,7,241,670.2826568,95.8197868,95.1920075,1.8,95.8353335,95.2516373,1.0539466,21.925185,26.365324,97451.0724491,143907.3630424,84.4357196,5458.2057441,4444.7092373,9114.7955403,40.1912028,49.3378139,1.8792143,150.7363438),(13104,'Alces_femur.tif',242,7,242,667.2670552,95.8152101,95.1181113,1.8,95.8686699,95.1524677,1.0536324,23.140603,26.4553566,97598.8591646,144249.956967,84.0258136,5452.5803183,4217.6454589,9129.4298224,40.3757721,49.3728798,1.8525682,150.9800404),(13105,'Alces_femur.tif',242,7,243,673.4470456,95.815373,95.0800551,1.8,95.7846221,95.1298255,1.0469177,22.3970402,26.5272471,98577.4929772,144628.6767112,84.1536744,5452.0801257,4401.3625091,9152.0599998,40.5624537,50.6925354,1.9756881,183.4221146),(13106,'Alces_femur.tif',242,7,244,677.6459694,95.8532083,95.0092946,1.8,95.8870063,95.0477756,1.0441884,22.6323824,26.4842284,99610.3538869,145032.584028,84.4109113,5476.1868736,4401.231481,9236.7775937,0.416016,1.7152779,1.815775,3.6727669),(13107,'Alces_femur.tif',242,7,245,680.241065,95.8235996,94.9694532,1.8,95.7953173,94.9470645,1.0405744,22.7225734,26.4336863,100834.1947107,145205.6247736,84.3773773,5493.2037591,4437.6221454,9286.549309,0.832032,1.499967,0.9827937,3.1853739),(13108,'Alces_femur.tif',242,7,246,679.075889,95.8586433,94.891849,1.8,95.8299725,94.8986887,1.0363175,22.4224666,26.4343039,102170.0507008,145225.7716011,83.8114538,5493.8375561,4556.5928421,9302.0718146,41.1214423,51.0870358,2.2175548,198.0713706),(13109,'Alces_femur.tif',242,7,247,680.6735285,95.827366,94.7790242,1.8,95.9460534,94.7321708,1.0365836,22.546963,26.4667264,103464.6507252,145395.5367817,84.0350964,5493.5217458,4588.8508677,9280.222933,41.3081239,50.9598374,2.3042182,180.3794949),(13110,'Alces_femur.tif',242,7,248,686.665765,95.7530063,94.7119023,1.8,95.8949004,94.7933769,1.0400736,22.5460847,27.5872726,105317.4270873,145339.0145936,85.1242735,5268.3357601,4671.2069342,9076.5568868,41.4979739,51.2645834,2.2353982,191.843377),(13111,'Alces_femur.tif',242,7,249,691.5904261,95.8227293,94.6484724,1.8,95.9163259,94.6816728,1.0371294,23.112618,26.5786637,106760.9389439,145176.9244852,85.4379989,5462.160396,4619.162535,9387.2945788,1.2251178,3.0286422,1.849096,6.8581408),(13112,'Alces_femur.tif',242,7,250,695.4717939,95.7739188,94.6282141,1.8,95.8310478,94.6205333,1.0403894,22.7165252,26.6565208,108493.1858487,145284.9221379,86.2478907,5450.2582404,4775.9586866,9263.8651493,1.2412111,4.2425474,1.3734008,9.9425723),(13113,'Alces_femur.tif',242,7,251,697.0428961,95.7177677,94.6059004,1.8,95.7958662,94.6142692,1.0388215,23.1877733,26.6990326,110027.5435168,145358.1820561,86.2836141,5444.3239233,4745.0672403,9561.7040448,0.832032,1.7152779,1.815775,4.0174059),(13114,'Alces_femur.tif',242,7,252,698.8409289,95.6328574,94.4950383,1.8,95.7092352,94.5250043,1.0501692,23.2075306,26.4975544,111559.3778416,145465.8210341,87.654352,5489.7829019,4807.0335264,9632.5737065,0.832032,4.2425474,1.7681919,9.0095979),(13115,'Alces_femur.tif',242,7,253,699.6886539,95.5443851,94.385146,1.8,95.6891414,94.4071852,1.0630914,23.5433639,26.3550896,113412.9765333,145435.5157781,89.0512211,5518.3085376,4817.1950762,9763.5591143,0.832032,2.2403147,1.9513027,4.8494379),(13116,'Alces_femur.tif',242,7,254,703.471477,95.4736047,94.2844965,1.8,95.5856326,94.3550289,1.0764864,23.7809856,26.3653549,115383.3396096,145398.0241061,90.8558765,5514.737993,4851.9157852,9854.999569,0.416016,0.5883355,2.3561945,1.1766709),(13117,'Alces_femur.tif',242,7,255,706.2524387,95.3500453,94.1978642,1.8,95.4452078,94.243675,1.102904,23.4463331,26.4382545,117262.2506038,145472.5229475,93.7660147,5502.3497493,5001.3044764,9906.0473843,0.416016,0.9302401,2.0344439,2.0087029),(13118,'Alces_femur.tif',242,7,256,711.3252051,95.2369704,94.0549789,1.8,95.3566882,94.0695564,1.1269271,23.7988434,26.4544825,119973.7132949,145655.1189941,96.6909009,5505.8766973,5041.1573159,10038.0713567,1.0545369,3.1682835,1.1659045,6.8581408),(13119,'Alces_femur.tif',242,7,257,715.7220047,95.1827628,93.9759743,1.8,95.3705283,93.93449,1.1593986,23.8116821,26.4870443,122580.6288393,145458.6510567,100.2114945,5491.6905627,5147.9197565,9862.1590066,1.248048,3.7671851,1.6814535,8.8668438),(13120,'Alces_femur.tif',242,7,258,722.337081,95.0562428,93.9881062,1.8,95.2621495,93.8805175,1.2145308,24.442389,26.6275117,124962.3352972,145756.1784496,105.7447115,5473.8940669,5112.5254215,10166.832516,1.248048,4.6512003,1.7506498,11.1192432),(13121,'Alces_femur.tif',242,7,259,729.7244659,94.8936113,93.9101762,1.8,95.0863181,93.7634861,1.2989051,24.9335467,36.0022891,127837.9456074,146281.6036511,112.8493269,4063.1195205,5127.146453,7208.7112077,0.416016,0.5883355,2.3561945,1.1766709),(13122,'Alces_femur.tif',242,7,260,737.6614246,94.684659,93.8785729,1.8,94.9012438,93.6712074,1.4203772,25.2594649,26.4966836,130937.1702124,147488.6836122,120.1827769,5566.3073049,5183.6874027,10436.6057751,1.2423022,8.825032,1.4288993,18.8512278),(13123,'Alces_femur.tif',242,7,261,742.4879081,94.4629336,93.825647,1.8,94.7133285,93.5955631,-1.5451109,24.6213806,37.6450648,133208.1759068,149373.7955586,123.6663607,3967.9516143,5410.2642768,7506.4505911,1.8450807,14.296673,1.7168086,36.299407),(13124,'Alces_femur.tif',242,7,262,753.3661011,94.2672521,93.7856916,1.8,94.5255758,93.465539,-1.3887954,25.9940537,26.4048203,135954.5948385,153058.1973208,121.4476123,5796.6006062,5230.2190584,10483.2939905,1.6516603,5.2622324,1.8925469,12.2959142),(13125,'Alces_femur.tif',242,7,263,759.142368,94.0746455,93.7794018,1.8,94.3984625,93.4612415,-1.2789039,27.1950285,26.6257642,137447.8277181,157232.884299,116.0464554,5905.290957,5054.1527291,10071.8429368,1.6114626,10.5326839,1.7294516,26.2558923),(13126,'Alces_femur.tif',242,7,264,768.3338694,93.8167533,93.729347,1.8,94.1997378,93.3690601,-1.1945725,30.670062,34.7936927,138130.481879,162791.9591055,110.7693006,4678.7778629,4503.7562013,6687.5104587,1.248048,14.584313,1.5137155,32.7102635),(13127,'Alces_femur.tif',242,7,265,778.64922,93.6238453,93.6270397,1.8,94.1387283,93.262368,-1.1369785,27.3949034,34.2462368,138335.7435108,168593.4521714,106.8457185,4922.9774735,5049.6890376,7832.0422264,2.08008,13.753718,1.5102643,35.6101291),(13128,'Alces_femur.tif',242,7,266,783.3044174,93.3920649,93.4744257,1.8,93.9774239,93.1365938,-1.1001048,28.1339646,32.777202,137940.0054776,172375.6170689,103.7010579,5259.0095184,4902.9707561,7500.616483,1.9386393,12.6526327,1.4056476,34.8790396),(13129,'Alces_femur.tif',242,7,267,780.5046279,93.2589348,93.2189853,1.8,93.8672206,92.8745904,-1.0726794,28.5695158,33.2700768,137499.4679588,173238.0874277,100.3903012,5207.0239763,4812.8035857,7658.7253781,1.664064,15.028488,1.4876551,38.1062251),(13130,'Alces_femur.tif',242,7,268,785.4472252,93.1880995,93.0760277,1.8,93.7890068,92.7157412,-1.0710885,27.0478456,27.0606034,139091.717289,175805.207415,100.8510239,6496.7216299,5142.4323947,11235.5085053,2.08008,11.3015553,1.4601391,28.9538731),(13131,'Alces_femur.tif',242,7,269,791.252442,93.1436539,92.8930224,1.8,93.7276488,92.5748996,-1.0755434,29.720462,27.4502295,141073.0870558,179283.697429,102.0891668,6531.2276332,4746.665349,10186.1329776,2.3644544,11.7151169,1.4640607,32.6266401),(13132,'Alces_femur.tif',242,7,270,795.941047,93.0575071,92.817319,1.8,93.6729614,92.494351,-1.0745634,27.3117756,27.8064537,142244.8112427,184525.7188714,102.585302,6636.0752444,5208.1861345,10864.1690793,1.6019708,9.6494192,1.4410938,23.5579115),(13133,'Alces_femur.tif',242,7,271,802.7374264,92.9707316,92.8341651,1.8,93.6007506,92.432074,-1.0787176,28.7643416,28.9025992,144006.5574453,189416.6193829,103.925394,6553.6188734,5006.4263428,11308.5481304,1.248048,3.1682835,1.9756881,8.0348118),(13134,'Alces_femur.tif',242,7,272,805.9380549,92.8059273,92.750889,1.8,93.4688228,92.3730416,-1.0887135,36.2480955,36.2259546,144438.2599571,193776.9531625,105.4504545,5349.119305,3984.713069,8439.7500627,1.6549481,7.1210469,1.6879051,18.0783264),(13135,'Alces_femur.tif',242,7,273,807.8820953,92.727581,92.5599559,1.8,93.4839673,92.2389255,-1.0962376,36.5754207,36.473031,145012.9259399,196688.2753668,106.5327648,5392.7044241,3964.7644018,8660.740679,2.3765387,19.3570416,1.419781,49.1836567),(13136,'Alces_femur.tif',242,7,274,807.4377792,92.6706642,92.4743877,1.8,93.4022224,92.1287609,-1.0996354,39.328731,29.0206801,145944.0985334,199341.9998438,106.8449746,6868.963762,3710.8773856,7476.2720782,2.1232409,15.6656403,1.3838171,39.972174),(13137,'Alces_femur.tif',242,7,275,807.7830787,92.5980992,92.3575338,1.8,93.3359768,92.0135557,-1.1114336,38.085732,29.516226,146641.9025781,201563.4406538,108.1644242,6828.9028676,3850.3107334,9055.6305888,2.3222377,17.2383297,1.4254863,43.6449409),(13138,'Alces_femur.tif',242,7,276,807.5622317,92.5116631,92.2589533,1.8,93.2701459,91.8349153,-1.1148849,28.9221073,29.1608147,148234.9105581,203607.6583561,108.5030868,6982.2349063,5125.3150002,12019.5584916,2.665538,16.5624533,1.3684747,47.0321996),(13139,'Alces_femur.tif',242,7,277,803.7588501,92.4523115,92.164221,1.8,93.2206718,91.7570273,-1.1231519,26.653617,29.0183375,148667.8190485,205362.8198253,108.8619982,7077.0015683,5577.7727695,12161.2289214,2.4829216,16.6510372,1.3439975,45.2671932),(13140,'Alces_femur.tif',242,7,278,803.0597549,92.3703128,92.1123447,1.8,93.1999217,91.6893858,-1.134607,37.7776521,36.7252287,149679.2677995,208401.1555413,109.9527049,5674.6047082,3962.111446,8003.669448,2.2652142,17.7136858,1.4056476,44.2332764),(13141,'Alces_femur.tif',242,7,279,804.2688801,92.3065707,92.0506463,1.8,93.1330488,91.5743737,-1.1505079,37.6448887,58.1314137,151304.6587661,211421.2764875,111.7285748,3636.9539818,4019.2616824,5826.8877066,2.1847319,15.341912,1.3521274,41.5944262),(13142,'Alces_femur.tif',242,7,280,807.4649458,92.2872781,91.9567446,1.8,93.1594826,91.5846499,-1.1665137,39.4339468,37.0558356,154009.7355306,214873.9778685,113.754106,5798.6542346,3905.5115718,8171.8410518,1.861777,7.7718202,1.2998495,23.6170422),(13143,'Alces_femur.tif',242,7,281,805.1931751,92.2993615,91.8726581,1.8,93.2036332,91.4890292,-1.1762978,37.1653275,36.4617198,153673.4776862,217468.3822898,114.3748337,5964.293064,4134.861393,8565.9302292,2.0503223,18.0619947,1.3146449,43.5439985),(13144,'Alces_femur.tif',242,7,282,805.522741,92.3173874,91.7996895,1.8,93.2341493,91.3913072,-1.192469,30.0294357,36.9169581,154543.3388535,220734.6132632,115.937323,5979.2199755,5146.395042,9557.8136161,2.4052673,20.3975152,1.3654009,56.9747719),(13145,'Alces_femur.tif',242,7,283,807.1991009,92.2726455,91.7924312,1.8,93.2460782,91.3544974,-1.2062957,33.5966436,36.9408377,156175.3082273,223460.1609902,117.436715,6049.1362612,4648.5390083,8641.8854285,2.3890147,19.6762814,1.3360737,54.1340369),(13146,'Alces_femur.tif',242,7,284,811.8072024,92.2478409,91.7071901,1.8,93.2174978,91.3004274,-1.208098,29.5618993,36.1500195,158836.5851013,228403.4772884,118.2692377,6318.2117257,5373.0169164,9268.8693582,1.9483446,19.5837074,1.3567356,50.6040241),(13147,'Alces_femur.tif',242,7,285,815.5584535,92.2869917,91.6220401,1.8,93.2517873,91.3254366,-1.2162758,28.5386942,30.5586461,161519.183418,233899.413322,119.5463622,7654.1157116,5659.6557,12709.886872,2.2749324,21.6008071,1.2977876,57.3194108),(13148,'Alces_femur.tif',242,7,286,822.3806885,92.2993407,91.6169238,1.8,93.2613193,91.3071471,-1.219512,29.1322953,54.83173,165135.4351395,239534.2633129,120.8341036,4368.5337562,5668.4663391,6754.0104121,1.7243447,10.1987576,1.3654009,25.9112534),(13149,'Alces_femur.tif',242,7,287,829.1020712,92.3531499,91.5998013,1.8,93.2831387,91.3191484,-1.2153733,31.323636,60.1128716,169422.1269586,245874.9099809,121.4503303,4090.2206688,5408.7631111,6251.7092291,1.4905197,5.6584294,1.2722974,13.2288886),(13150,'Alces_femur.tif',242,7,288,839.8739577,92.3922825,91.6312863,1.8,93.3841176,91.3584738,-1.2197086,40.7769124,37.8033921,174500.7028688,253149.6023305,123.4222017,6696.4785012,4279.3996013,9171.101211,1.248048,2.6311162,1.8925469,6.8581408),(13151,'Alces_femur.tif',242,7,289,847.949634,92.4133678,91.6222339,1.8,93.4467998,91.4076685,-1.2226601,65.1501657,38.3579548,178838.029209,260247.9767936,124.8774189,6784.7198348,2745.0126553,6175.5647045,0.416016,0.5883355,2.3561945,1.1766709),(13152,'Alces_femur.tif',242,7,290,856.4116745,92.4743343,91.661594,1.8,93.4248867,91.3985637,-1.2152274,33.9127693,38.0309443,183206.0497327,267455.01209,125.4371716,7032.5630044,5402.2733462,9532.6205117,1.8966745,12.9166101,1.3101939,35.4255633),(13153,'Alces_femur.tif',242,7,291,860.0874044,92.431433,91.7105744,1.8,93.478117,91.4883994,-1.2261503,31.0188638,39.2055966,186994.8021103,273680.8807134,126.9844797,6980.6584941,6028.4220378,11320.9367667,1.8848317,13.4290068,1.2882414,36.4003494),(13154,'Alces_femur.tif',242,7,292,865.7265271,92.4514976,91.7489439,1.8,93.5343932,91.4731928,-1.2244035,29.9522098,32.6230968,191356.6046136,280538.6608836,127.6564131,8599.3878115,6388.7307852,13992.016958,2.0279717,18.4178134,1.2490458,48.797206),(13155,'Alces_femur.tif',242,7,293,876.1638653,92.479611,91.8514202,1.8,93.6612845,91.520382,-1.2189979,29.5498432,39.6487427,197471.0191438,289657.2164551,128.6880351,7305.5839114,6682.6418676,11778.6781124,1.8965235,17.1022553,1.2490458,43.6031292),(13156,'Alces_femur.tif',242,7,294,881.2338521,92.5674651,91.9863331,1.8,93.6535133,91.6689009,-1.2195211,34.9499313,37.0327906,204289.9588724,296617.1863147,129.4823777,8009.5823635,5845.2177601,12819.8899836,0.416016,0.5883355,2.3561945,1.1766709),(13157,'Alces_femur.tif',242,7,295,888.5192835,92.6221185,92.1021067,1.8,93.7072853,91.7157521,-1.2182176,41.3961979,33.2217717,211694.7233475,303594.0804504,130.4279267,9138.4072723,5113.8687602,11949.4632672,0.416016,0.9302401,2.677945,1.7650064),(13158,'Alces_femur.tif',242,7,296,902.334148,92.6960885,92.2474767,1.8,93.7706493,91.8388243,-1.2362065,42.4038572,44.0703429,221328.2947645,313118.2644833,134.1718879,7104.9654713,5219.5321282,10453.9920239,2.1199435,20.003406,1.2753555,50.2175735),(13159,'Alces_femur.tif',242,7,297,912.8962535,92.9119745,92.3392238,1.8,93.9863489,91.8547023,-1.2412926,43.6373801,38.4699438,230514.0264004,320563.5888431,136.219368,8332.8322552,5282.490059,12283.8969755,2.0449334,19.3391516,1.2422432,50.1757618),(13160,'Alces_femur.tif',242,7,298,923.5136887,93.009667,92.4396924,1.8,94.0302901,91.8774481,-1.2484521,36.1932265,42.2190147,239448.825942,328038.3713597,138.4721837,7769.9201057,6615.8463623,10844.1900561,2.0119892,17.1527791,1.3258177,48.3098129),(13161,'Alces_femur.tif',242,7,299,938.1029072,93.1551064,92.6007795,1.8,94.1131101,91.9802374,-1.2585047,34.7071417,35.4779225,250102.8758878,336584.2072364,141.591536,9487.145336,7206.0925742,15246.5326111,2.1995089,20.4017572,1.2167989,56.3446247),(13162,'Alces_femur.tif',242,7,300,945.0849953,93.3260338,92.7553655,1.8,94.1938623,91.999602,-1.2694968,31.9221616,36.2996464,258425.7489618,344835.5065269,143.6423122,9499.6932641,8095.496539,15301.655938,1.8675591,12.5151,1.3016288,31.651854),(13163,'Alces_femur.tif',242,7,301,959.4305008,93.4955382,92.960118,1.8,94.3457933,92.0784968,-1.2795457,32.3230425,37.272635,269936.8903344,355855.1557965,146.7200552,9547.3570938,8351.2215906,15461.3470941,1.8157767,13.155581,1.2490458,33.9042534),(13164,'Alces_femur.tif',242,7,302,971.4291864,93.6486063,93.0783091,1.8,94.4351061,92.1359848,-1.2916219,34.6268628,38.3271841,280221.9056742,367712.7555352,149.6107028,9594.0456884,8092.616058,15636.7313465,0.416016,0.5883355,2.3561945,1.1766709),(13165,'Alces_femur.tif',242,7,303,986.4934541,93.7648648,93.2608588,1.8,94.6019668,92.2077883,-1.3025909,37.4166919,43.3751552,292046.3879851,381264.8344539,152.8693685,8789.9359197,7805.2434231,15197.4233811,1.9546358,12.7615917,1.2387369,35.2236785),(13166,'Alces_femur.tif',242,7,304,1005.3158431,93.9408461,93.4285177,1.8,94.7677306,92.2577863,-1.3212375,47.9963502,44.2096624,306093.0806013,398750.9460273,157.3323667,9019.5428836,6377.4241072,13441.1736302,60.6278338,78.1600959,1.9127462,276.8217286),(13167,'Alces_femur.tif',242,7,305,1028.8308755,94.1509129,93.5455544,1.8,95.0321999,92.2925218,-1.343581,44.3839407,43.8587393,321316.4733959,418693.4907795,162.7705714,9546.409625,7239.4759977,15096.890116,62.7220981,80.1227808,1.9040406,294.6563586),(13168,'Alces_femur.tif',242,7,306,1048.9452532,94.3601417,93.6806292,1.8,95.1619669,92.2525395,-1.3812662,38.2530099,45.9777328,336814.1831373,439601.7193908,168.6190684,9561.187391,8804.9066881,15990.7120311,63.9126846,83.8135449,1.9098136,304.5398002),(13169,'Alces_femur.tif',242,7,307,1070.7729122,94.5254864,93.8936014,1.8,95.2434839,92.3610591,-1.4083464,37.7520979,50.5795097,352673.5650656,461396.341101,173.7938252,9122.1987596,9341.8269422,12898.1929628,64.5115772,85.5183602,1.949496,331.6868552),(13170,'Alces_femur.tif',242,7,308,1092.3053044,94.6355942,94.1416578,1.8,95.3959308,92.4945492,-1.4313447,35.9958705,48.36664,369269.3142397,483931.1923542,178.5334748,10005.474686,10258.657716,16894.5667211,66.4260266,87.4009914,1.9769381,323.3247235),(13171,'Alces_femur.tif',242,7,309,1125.4484973,94.7871148,94.2721177,1.8,95.5596973,92.7478491,-1.4687923,41.3665523,49.6562563,391313.4281033,512696.944363,185.6298255,10324.9214294,9459.6577855,14143.3261239,67.810608,89.382468,1.9573528,325.0132802),(13172,'Alces_femur.tif',242,7,310,1165.3099786,95.1796197,94.5674428,1.8,95.8618811,93.1123281,-1.5284633,36.426313,51.2702489,422628.6887318,544482.8062648,193.8704815,10619.8588495,11602.2911539,18366.5515735,1.4741747,4.3433346,1.2793395,11.8085211),(13173,'Alces_femur.tif',242,7,311,1205.0476367,95.5728658,94.9188962,1.8,96.2137663,93.5502782,1.5611974,37.3754672,52.1775964,456102.0394422,576841.457614,200.8227682,11055.3474565,12203.2465158,19368.1020045,1.3046588,4.2831469,1.0636978,9.5561216),(13174,'Alces_femur.tif',242,7,312,1242.5053426,95.8782992,95.3028731,1.8,96.4470671,93.9890356,1.487646,48.2108896,53.6356462,490397.717959,611996.8008638,205.6557461,11410.262465,10171.9284224,20380.7243224,0.416016,0.5883355,2.3561945,1.1766709),(13175,'Alces_femur.tif',242,7,313,1280.073708,96.1360295,95.5920261,1.8,96.7609337,94.4892096,1.4459477,40.9679986,54.5606531,518754.6756545,650359.176208,210.0374024,11919.9301927,12662.4363711,21354.9600704,0.832032,1.499967,0.5880026,2.9416773),(13176,'Alces_femur.tif',242,7,314,1311.7068449,96.2000254,95.8873554,1.8,96.9291437,94.9990313,1.4322354,39.2027372,55.033617,542469.8491743,691600.7950493,214.4473253,12566.8788042,13837.5503193,22345.7539846,2.6806132,17.3832971,1.2036225,45.5700204),(13177,'Alces_femur.tif',242,7,315,1340.9305423,96.2674376,96.2069585,1.8,97.0643443,95.4883993,1.432363,40.3161805,55.656099,565394.9270867,733843.1205212,219.2328297,13185.3136245,14024.0201394,23291.0588553,76.5253803,101.4345632,2.0069279,370.2386617),(13178,'Alces_femur.tif',242,7,316,1378.0598885,96.3181568,96.4186625,1.8,97.2031145,96.0222479,1.4240029,44.7623924,56.0240989,590977.0680577,784538.7002356,224.7629507,14003.5933706,13202.5353654,19975.6396913,0.744614,1.499967,0.9827937,3.1853739),(13179,'Alces_femur.tif',242,7,317,1408.5031477,96.2780996,96.7310946,1.8,97.3542522,96.5678478,1.425454,43.1365973,56.3816309,615549.0652571,825772.6895506,229.8263852,14646.1298785,14269.7640435,25481.1665772,78.5539841,105.0998372,1.9777671,388.5188729),(13180,'Alces_femur.tif',242,7,318,1426.7857178,96.1461707,97.2101058,1.8,97.5164542,97.2473551,1.4509537,61.688937,56.9906127,635198.7091025,866412.12468,234.3986282,15202.7164406,10296.8010101,22730.2442758,79.9371708,108.7680972,1.988244,418.7330404),(13181,'Alces_femur.tif',242,7,319,1486.0344235,96.613119,97.7446322,1.8,97.9421109,97.9518341,1.4184459,71.9332994,59.6453326,675193.9360409,933709.6858278,241.9681054,15654.3629762,9386.3890787,19142.4019485,1.2389736,3.3540282,1.0516502,7.5474187),(13182,'Alces_femur.tif',242,7,320,1530.7956544,96.9273641,98.4068942,1.8,98.3787581,98.6434932,1.387549,58.0550687,59.4764091,713007.8440156,997782.4822037,246.660827,16776.1049707,12281.5778161,27307.598609,0.832032,1.8604801,2.677945,4.1183483),(13183,'Alces_femur.tif',242,7,321,1587.1964259,97.1241104,99.4400557,1.8,98.3745682,99.7077242,1.3923508,53.2043786,61.1697657,753470.3121534,1084286.6754237,256.1983049,17725.8595388,14161.8102062,29610.6868116,82.7047944,115.4097668,2.0021971,479.8261606),(13184,'Alces_femur.tif',242,7,322,1664.6829135,96.9233206,100.9420443,1.8,98.3903342,100.6870879,1.4684318,58.460512,62.1834651,818104.4873761,1193982.7036127,274.5500625,19200.9676906,13994.1382437,31730.2499618,1.858616,5.9998681,0.9827937,15.1957798),(13185,'Alces_femur.tif',242,7,323,1728.2890849,96.7930513,102.3996903,1.8,98.2886057,101.8232857,1.509926,56.6913688,61.8768293,880964.2985143,1286304.630178,286.9822219,20788.1470977,15539.6547632,34630.582792,84.7333487,115.2687175,1.9633665,587.9198139),(13186,'Alces_femur.tif',242,7,324,1803.5023333,96.3759256,102.6325871,1.8,97.9881143,102.0817856,1.4852527,52.8532695,65.8666515,944178.2631452,1402599.3380397,298.3894985,21294.529279,17864.1411016,28352.5181045,85.3752907,116.0378925,1.9606233,684.4140046),(13187,'Alces_femur.tif',242,7,325,1826.3845613,96.8347246,103.5759854,1.8,98.3754134,103.3537775,1.5115539,70.0863844,66.8709302,991846.779429,1452448.4662654,303.330345,21720.1773784,14151.7755347,28456.793833,87.1976135,116.680437,1.9738155,772.7969339),(13188,'Alces_femur.tif',242,7,326,1851.3296182,97.0377045,104.2530804,1.8,98.6187545,104.0510941,1.5493381,57.8491167,65.5437644,1029223.2222519,1499759.4110654,308.4128839,22881.8015755,17791.5114658,29216.5364242,87.9969618,117.1245746,1.9644946,553.2080212),(13189,'Alces_femur.tif',242,7,327,1895.690115,97.1384608,104.9738942,1.8,98.7284966,105.0298109,1.5559223,57.540917,63.6777384,1080961.0813568,1560980.8220477,315.8784582,24513.7604164,18785.9550608,39571.6544209,87.937462,117.5567292,1.9821936,650.5933746),(13190,'Alces_femur.tif',242,7,328,1928.2935938,97.2640235,105.659197,1.8,98.7669498,105.5186545,1.5508463,59.0464554,65.7474243,1139940.886108,1618798.0364482,321.2543723,24621.4669917,19305.8309398,38520.2791776,0.416016,0.9302401,2.0344439,2.0087029),(13191,'Alces_femur.tif',242,7,329,1953.2092813,97.529161,106.1484789,1.8,98.7674346,106.0375717,1.5508732,54.7811303,66.2081614,1176177.337546,1670706.9692146,325.4056818,25234.1544477,21470.4831768,41147.6087128,0.416016,1.3155581,1.8925469,2.8407349),(13192,'Alces_femur.tif',242,7,330,1962.405765,97.7158406,106.8560944,1.8,99.2598987,106.7602253,1.5580352,70.4914639,64.287293,1212295.1175327,1692553.9462334,327.0143684,26327.9703984,17197.7577222,36064.034666,94.2840558,117.8530081,1.9965474,678.1615182),(13193,'Alces_femur.tif',242,7,331,1995.7656092,98.214359,107.438319,1.8,100.1042473,107.4776526,1.5417121,77.2331542,64.7514109,1268972.4822959,1744156.9168387,332.3463137,26936.1994188,16430.411204,36990.5206742,99.5522056,117.8214307,2.0044371,797.2316606),(13194,'Alces_femur.tif',242,7,332,2044.3229319,98.6361729,108.0510194,1.8,101.1541031,107.9682695,1.5697013,76.5241601,68.0588197,1343848.2311627,1781565.8773573,340.7200825,26176.855322,17561.0974231,35340.8650202,1.248048,2.08008,2.4980915,4.9503803),(13195,'Alces_femur.tif',242,7,333,2072.4279198,99.1682733,108.1727078,1.8,100.7925698,107.5546826,-1.5654548,75.2501978,65.2168518,1402824.1040749,1803599.3769813,345.3947999,27655.4192356,18642.1317929,36255.0056665,0.416016,0.9302401,2.0344439,2.0087029),(13196,'Alces_femur.tif',242,7,334,2110.5793189,101.3269427,107.8677525,1.8,102.9948177,106.5117051,1.5478143,74.1527711,67.1528746,1528258.1884167,1829949.2783509,351.5774619,27250.4980414,20609.5897035,41454.4728373,110.5288459,122.9339599,0.6171024,904.6432097),(13197,'Alces_femur.tif',242,7,335,2163.0435503,100.819911,108.9900271,1.8,101.372533,108.1940754,1.5678638,74.3761666,68.1339693,1505054.7988908,1815256.0058889,360.5041581,26642.4519696,20235.713494,39522.7049003,0.832032,1.3155581,1.8925469,3.1853739),(13198,'Alces_femur.tif',242,7,336,2157.2833315,99.7283642,109.564067,1.8,99.6707678,108.7361782,-1.5132561,73.693204,66.8001328,1420864.5460105,1788668.2224867,358.3581174,26776.417156,19280.8083966,41275.2327989,100.7675948,120.0045727,1.0279987,869.9804025),(13199,'Alces_femur.tif',242,7,337,2198.5359755,99.2890492,110.4985524,1.8,99.333718,109.5719744,-1.4798922,60.7559737,69.7991775,1433627.2141059,1771699.950043,363.4030372,25382.8198735,23596.4815612,44059.0108765,100.7906683,119.2573556,2.0375641,902.9445078),(13200,'Alces_femur.tif',242,7,338,2223.6426686,98.7639921,111.0927133,1.8,99.0388259,110.2819147,-1.4625801,59.601298,72.3107376,1435487.5744101,1747973.5945233,366.2839396,24173.0848217,24084.8374429,42673.8556652,100.9029382,117.7215023,1.0328011,767.6966257),(13201,'Alces_femur.tif',242,7,339,2241.2760715,98.2406152,111.4750647,1.8,98.8764587,110.6604481,-1.4453947,62.4529273,69.6574533,1431385.4016584,1728804.3129905,367.7025175,24818.6551779,22919.4285118,42539.3355534,0.832032,1.499967,0.5880026,2.9416773),(13202,'Alces_femur.tif',242,7,340,2250.3862303,97.6000641,111.8933085,1.8,98.7512909,111.0746961,-1.4042959,56.5317641,70.6151754,1438078.1937078,1689790.6623934,364.7624191,23929.5682878,25438.4100221,41970.0818565,1.248048,1.7650064,0.7853982,4.7066838),(13203,'Alces_femur.tif',242,7,341,2241.8002093,97.0675134,112.2105433,1.8,98.6369921,111.5134118,-1.2762364,62.2080565,73.451147,1434055.941356,1643663.1128241,342.1416906,22377.6371095,23052.5758565,41238.6806779,100.4252392,118.4068069,1.0032587,830.1264899),(13204,'Alces_femur.tif',242,7,342,2219.9856616,96.3878992,112.4800639,1.8,98.4260024,111.564244,-1.0736767,68.2383891,75.6216966,1414964.5666215,1596573.9005338,285.849212,21112.6432241,20735.6091771,39471.8763597,100.3002256,115.4007688,0.9647957,899.9855114),(13205,'Alces_femur.tif',242,7,343,2189.4558678,95.8002596,112.5922316,1.8,98.2470727,111.3461887,-0.8369662,76.2202001,72.5434953,1394132.6807824,1570588.3823338,201.2389784,21650.2992553,18290.8556901,38118.6458118,99.5471371,115.9819481,1.0026916,961.8342139),(13206,'Alces_femur.tif',242,7,344,2144.8529166,95.7377959,112.3145114,1.8,97.2567089,110.9687935,-0.7126672,70.3311386,69.114673,1343337.1246915,1527854.5163322,152.8298023,22106.0803662,19100.1759941,37868.0234749,98.9016489,111.1323499,1.0014831,985.8896637),(13207,'Alces_femur.tif',242,7,345,2151.1885122,96.0240169,111.9546384,1.8,95.6322721,110.5784806,-0.4597669,77.5937095,72.2809634,1301718.7226397,1509264.7709302,70.5964587,20880.5292601,16776.0857296,36224.4946535,96.8985119,121.9636598,2.9943893,1113.9837515),(13208,'Alces_femur.tif',242,7,346,2097.9978617,97.34061,111.8604372,1.8,98.340444,110.8716196,-0.2980327,75.6820234,66.6164778,1204853.2934367,1411150.5068765,30.1498256,21183.2050342,15919.9402957,34541.1285274,92.618704,110.5601166,0.9619199,840.8592825),(13209,'Alces_femur.tif',242,7,347,2071.2378322,97.3823358,112.0137908,1.8,98.1650494,111.2758674,-0.2010615,73.7441273,53.2965519,1115353.2705209,1379508.1009685,13.768179,25883.6275888,15124.6385535,33439.0705346,90.6525223,108.0392831,0.9550231,810.9479422),(13210,'Alces_femur.tif',242,7,348,2020.916199,97.3550682,112.0035311,1.8,97.8679341,111.4283408,-0.1467561,69.4098658,50.7096409,1026113.237015,1333971.5508768,7.2022693,26306.0737258,14783.3917531,33356.9304153,88.3775648,106.9290611,0.9428582,732.5075852),(13211,'Alces_femur.tif',242,7,349,1958.5810381,97.2737097,112.1792054,1.8,97.7683704,111.7638273,-0.134968,65.5284385,51.1950493,925837.4980857,1286334.6791999,5.9103485,25126.1537412,14128.7892573,33044.7017374,86.4527519,104.4233308,0.9352632,717.1344133),(13212,'Alces_femur.tif',242,7,350,1853.306332,96.8341145,112.3589354,1.8,97.4368277,111.9261581,-0.1283584,63.6154151,49.7304193,818339.0915272,1209950.0166663,5.0612516,24330.1792479,12863.8489537,30664.3003546,0.416016,2.1212737,1.7681919,4.5047989),(13213,'Alces_femur.tif',242,7,351,1750.5101357,96.6061058,112.7944982,1.8,97.0941959,112.2573989,-0.1187339,52.1177426,53.5237021,714710.9567764,1144608.8270931,4.093744,21385.0832807,13713.3905003,32526.8122772,82.8027402,100.5107054,0.9322621,696.702745),(13214,'Alces_femur.tif',242,7,352,1649.0375001,96.3299781,113.4587455,1.8,96.850106,112.6895153,-0.1104872,59.127267,53.7573217,615471.5163403,1085643.5581237,3.3414561,20195.2687261,10409.2671251,26857.3114599,80.1455758,98.7457597,0.2817719,667.7070601),(13215,'Alces_femur.tif',242,7,353,1522.9841972,96.3480261,114.2045546,1.8,96.5459975,113.2350587,-0.0959467,54.9578267,49.6037625,507108.5972856,1012436.6958342,2.3295457,20410.4818896,9227.2316298,24999.0302604,77.4559017,97.8725717,0.2491024,657.7226761),(13216,'Alces_femur.tif',242,7,354,1351.4052215,96.3651436,115.3765875,1.8,96.5005432,114.4690375,-0.0911412,46.1764261,47.6545179,403429.0537912,932927.7766765,1.8657816,19576.9009564,8736.6885625,25019.5961317,31.2304035,68.9156591,1.3331382,240.5915975),(13217,'Alces_femur.tif',242,7,355,1189.7605817,96.3323906,116.4859716,1.8,96.4031809,115.7147674,-0.0911147,45.147529,46.8654979,310544.0411835,840473.9321633,1.6416615,17933.7459287,6878.4282969,21700.7928568,27.7752235,64.1164205,1.2880404,182.691025),(13218,'Alces_femur.tif',242,7,356,1019.5175962,96.6785185,117.669734,1.8,96.6868885,116.8070051,-0.0978609,42.8037563,47.8861754,226839.4830786,731172.1842008,1.6220914,15268.9618377,5299.52282,14915.7742504,26.3141324,58.5460309,1.2378103,150.8372862),(13219,'Alces_femur.tif',242,7,357,856.4302925,97.4093887,118.8675145,1.8,97.3188647,117.8947637,-0.1152753,39.1034543,49.9649591,157870.9878084,625478.9151814,1.8883761,12518.3513947,4037.2644941,13499.6620612,24.8665713,52.7815945,1.2166382,160.7971775),(13220,'Alces_femur.tif',242,7,358,705.8422119,98.066643,120.1232778,1.8,98.8021558,119.3889045,-0.1240915,37.018151,46.391093,97983.8822597,514516.3509158,1.8022285,11090.8434632,2646.9145423,11761.023263,22.8924886,34.7092997,1.3287246,99.0147795),(13221,'Alces_femur.tif',242,7,359,585.7737508,97.5286429,120.549002,1.8,98.5681711,119.870266,-0.0903993,33.7472716,44.5559079,64539.4162344,418080.9249088,0.7956571,9383.2882082,1912.4336018,9390.3020173,20.6558919,30.2778491,1.3491468,85.9877757),(13222,'Alces_femur.tif',242,7,360,461.186817,98.4426941,120.7875834,1.8,98.9857542,120.1992606,-0.0605354,31.1390189,43.9687373,37569.0539262,323406.6418767,0.2813284,7355.3770692,1206.4944649,8127.493776,17.8633436,26.0367528,1.3451951,71.8677244),(13223,'Alces_femur.tif',242,7,361,286.7406596,102.4864569,121.9946726,1.8,101.027781,121.0846046,-0.0192653,29.5322589,45.993967,9360.8609306,196463.6909329,0.0177352,4271.5100164,316.9707048,4458.1646224,13.9475954,20.8672564,1.160669,57.5631073),(13224,'Alces_femur.tif',242,7,362,136.3922538,116.4384699,122.0083212,1.8,109.439203,121.8725987,0.0149417,9.3639718,56.9186898,2548.5481391,30057.3147398,0.0050746,528.0746068,272.1652934,570.0964515,7.3683155,12.1288464,1.0303768,32.2401894),(13225,'Alces_femur.tif',242,7,363,60.8736168,120.2196292,121.9722097,1.8,120.1209319,121.8956385,0.6477128,6.2282782,8.2715436,390.0851927,713.8205933,3.6934879,86.2983538,62.6313056,131.4171263,12.3550449,16.4996372,2.5535901,45.7545862),(13226,'Alces_femur.tif',242,7,364,2.3119962,120.2431285,121.8657551,1.8,120.1984293,121.889333,0.4220306,2.1691699,2.9996121,2.5103433,4.6289056,0.0646524,1.5431681,1.1572829,2.3520451,4.8378789,6.3502086,2.5899377,17.489991),(13227,'Alces_femur.tif',242,7,365,8.6834643,114.8498762,165.6603491,1.8,117.1189044,165.6097294,-0.005085,2.2754544,77.4048828,6.5439117,32854.7530383,0.0000374,424.4532368,2.8758703,424.4552631,15.1205772,187.6305953,0.0088689,398.6818798),(13228,'Alces_femur.tif',242,7,366,8.7113652,114.0553432,165.6592097,1.8,115.3772051,165.6079855,-0.0049567,2.2781135,76.6104794,6.6104626,33073.0467657,0.0000357,431.7039525,2.9017266,431.7056153,15.1205772,187.6305953,0.0088689,399.0265188),(13229,'Alces_femur.tif',242,7,367,8.8381253,113.282894,165.6565709,1.8,115.2281941,165.5867249,-0.0047916,2.2818599,75.838196,6.6718352,33638.3276839,0.0000338,443.5539008,2.9238584,443.5545938,15.1472772,188.0507365,0.0110615,400.2031897),(13230,'Alces_femur.tif',242,7,368,8.8434223,111.9830192,165.6616756,1.8,113.5786713,165.6058844,-0.0045529,2.2958199,74.5385151,6.6846973,33814.9622166,0.0000306,453.6575779,2.911682,453.6558194,15.5365774,188.0507365,0.0110615,400.7915252),(13231,'Alces_femur.tif',242,7,369,9.1197563,110.7600524,165.6179239,1.8,113.3223584,165.5363665,-0.0039298,8.1427375,73.3162402,7.9109518,34710.0208311,0.0000235,473.4288164,0.9715347,473.4479394,15.5002736,188.0507365,0.0110615,400.4468862),(13232,'Alces_femur.tif',242,7,370,9.1998926,110.4219407,165.439979,1.8,113.5440033,164.8822687,-0.0048833,25.5575888,72.9782553,49.8638398,34819.4618528,0.0000366,477.121051,1.9510385,477.7340011,15.392592,187.6305953,0.0088689,399.6148542),(13233,'Alces_femur.tif',242,7,371,9.0310714,109.8440843,165.6297595,1.8,111.8824274,165.570387,-0.0036993,2.3099093,72.400405,7.1049716,34417.8438744,0.0000206,475.3819246,3.0758661,475.3883238,15.392592,187.6305953,0.0088689,399.2702153),(13234,'Alces_femur.tif',242,7,372,9.0527837,109.4524349,165.6322729,1.8,111.5609699,165.5724057,-0.0035652,2.3197883,72.0088476,7.0628939,34537.4183744,0.0000192,479.6274279,3.0446286,479.6323391,15.392592,187.6305953,0.0088689,399.2702153),(13235,'Alces_femur.tif',242,7,373,30.6003327,121.7610139,149.3691882,1.8,121.8738884,149.2296694,-0.0896453,21.1565703,85.3945218,3288.5900842,37786.8342056,0.0408758,442.4971699,155.4406049,478.8175425,0,0,0,0),(13236,'Alces_femur.tif',242,7,374,121.508765,124.6005422,142.0899788,1.8,123.3471764,142.433267,-0.1596239,30.6661834,89.7177069,6183.1687723,42320.8130201,0.5116355,471.7108191,201.6282461,537.9756248,13.3791322,27.1942121,0.5115561,76.776293),(13237,'Alces_femur.tif',242,7,375,236.8516997,123.8740886,138.7488957,1.8,122.5890102,138.7579043,-0.2176924,36.1870013,90.0965397,10596.9812707,49151.2755794,1.8413674,545.5401034,292.839442,661.097817,19.3425547,29.0526941,0.5084893,93.9807758),(13238,'Alces_femur.tif',242,7,376,352.3098566,122.8197701,136.1286465,1.8,121.7969584,136.1197457,-0.2426325,40.1467133,89.8521447,18086.7923374,56173.4086485,3.3894734,625.1760473,450.5173858,823.479036,25.0542825,29.4402975,0.7454195,103.0321853),(13239,'Alces_femur.tif',242,7,377,449.78328,121.8914676,134.0089096,1.8,121.1745853,134.6544589,-0.2032188,40.6680444,88.9149268,29333.6154328,61991.9049407,3.0534646,697.204701,721.2939764,1016.2125924,29.12112,30.1202479,2.1396442,96.3586104),(13240,'Alces_femur.tif',242,7,378,478.6178336,121.6215552,133.456482,1.8,121.2902663,134.6794129,-0.1742728,40.2652001,88.3297461,33688.0880297,62493.120127,2.3982561,707.4980165,836.655174,1070.9900729,29.12112,30.1604427,1.9974238,96.8460034),(13241,'Alces_femur.tif',242,7,379,478.2742124,121.733219,133.6525953,1.8,121.4260308,134.9191404,-0.180994,40.2950743,88.5112781,33325.4810144,61805.1227043,2.5828935,698.2739831,827.0360988,1058.859635,29.12112,30.148964,2.2584676,96.8460034),(13242,'Alces_femur.tif',242,7,380,478.5505988,121.8614661,133.8865525,1.8,121.5518089,135.1937598,-0.1822023,40.0851312,88.6889438,33204.6386224,61832.6458472,2.6186226,697.1855026,828.3529985,1055.6657972,0.5883355,1.1766709,2.3561945,2.3533419),(13243,'Alces_femur.tif',242,7,381,479.2438725,122.0135003,134.1274421,1.8,121.7599087,135.4703701,-0.1707174,39.4081899,88.6144699,33393.4356,62217.7833113,2.3053544,702.1176496,847.3729864,1061.3416497,29.12112,30.2120432,2.2390857,96.8460034),(13244,'Alces_femur.tif',242,7,382,479.6662665,122.1512488,134.3803081,1.8,121.8408811,135.7154635,-0.1639167,38.957412,88.5968069,33498.4118278,62945.9158407,2.1288299,710.4761226,859.8726178,1070.0828456,0.416016,0.5883355,2.3561945,1.1766709),(13245,'Alces_femur.tif',242,7,383,480.9438852,122.290552,134.6234596,1.8,121.9787169,136.034716,-0.1612438,38.5967478,88.6507349,33503.8159451,63036.1950437,2.0660563,711.0622954,868.0476419,1070.5705587,29.12112,30.148964,2.2584676,96.8460034),(13246,'Alces_femur.tif',242,7,384,481.2158662,122.4188614,134.8415591,1.8,122.1152914,136.2523927,-0.1647426,38.4888396,88.798785,33207.7305171,62574.9066375,2.1570893,704.6820139,862.7885608,1061.615823,29.12112,30.186254,2.0899424,96.6023069),(13247,'Alces_femur.tif',242,7,385,481.4337762,122.5982943,135.0375925,1.8,122.2080826,136.5107051,-0.1688365,38.3539954,88.9374559,33202.4129843,62859.9383917,2.2656221,706.7881331,865.6832917,1065.1223155,0.416016,0.5883355,2.3561945,1.1766709),(13248,'Alces_femur.tif',242,7,386,480.7798365,122.7401539,135.2802473,1.8,122.3724729,136.7959108,-0.1699786,38.1345846,89.0532655,32962.3244224,62446.1384166,2.292961,701.2223312,864.3682563,1057.2338889,29.12112,30.2091788,1.9666468,96.8460034),(13249,'Alces_femur.tif',242,7,387,479.8625691,122.8923057,135.5309609,1.8,122.6338051,137.0479751,-0.1629052,37.6646375,89.1246558,32916.5675459,62662.2454043,2.103731,703.0854129,873.9382533,1056.8046848,29.12112,30.252116,2.1206495,96.6023069),(13250,'Alces_femur.tif',242,7,388,479.5841373,123.0196683,135.7722956,1.8,122.6187555,137.2326803,-0.1610661,37.3393243,89.183238,32921.7884486,63181.687296,2.0557162,708.4480075,881.6921308,1062.1163612,29.12112,30.2320862,2.1702488,96.8460034),(13251,'Alces_femur.tif',242,7,389,486.710712,122.8185576,135.908363,1.8,121.1080457,136.9099854,-0.0985517,34.8890248,87.8408158,33793.8274524,67549.0946355,0.7853108,768.9943911,968.6091146,1122.9303901,0.416016,0.5883355,2.3561945,1.1766709),(13252,'Alces_femur.tif',242,7,390,512.8530938,121.6511451,135.7645161,1.8,118.4792194,136.2033555,0.035962,33.7663669,83.1432967,35820.7464686,84413.5731106,0.1104954,1015.2781578,1060.8409999,1348.0342688,29.12112,33.3980795,2.2591551,173.4622233),(13253,'Alces_femur.tif',242,7,391,538.9427682,120.622362,135.6442532,1.8,116.5235419,135.6900393,0.1025714,38.6793983,79.8495278,37229.2650133,100773.0279413,0.9417177,1262.0366164,962.5088977,1563.5560471,17.8633436,18.3660581,0.2284966,58.7397783),(13254,'Alces_femur.tif',242,7,392,563.6701773,119.6943778,135.5435853,1.8,115.0489234,135.3000471,0.1420955,41.4337562,77.4067135,38560.0323746,116782.143298,1.8841229,1508.6823612,930.6429333,1776.926161,20.384784,20.9500305,0.1194289,67.7493762),(13255,'Alces_femur.tif',242,7,393,584.8535465,119.0335003,135.4846513,1.8,114.1156757,135.0756977,0.1675709,43.0502537,75.708135,39873.8858456,130490.0118845,2.7115917,1723.5930036,926.2172103,1965.4540005,22.464864,23.1553175,1.2604089,74.607517),(13256,'Alces_femur.tif',242,7,394,594.6512625,118.7729118,135.6608186,1.8,113.6897981,135.1890475,0.1670473,42.8031317,75.5022563,40406.4940665,136962.9698619,2.7399741,1814.0248594,944.00789,2053.4949331,24.128928,24.9366806,2.6555607,80.0452903),(13257,'Alces_femur.tif',242,7,395,601.4925875,118.6132557,135.8804678,1.8,113.5382712,135.4955991,0.1626467,42.2630987,75.5616358,40922.5578501,141879.5311259,2.6286738,1877.6662217,968.2810569,2121.8977424,25.376976,26.732063,2.7755361,86.5587922),(13258,'Alces_femur.tif',242,7,396,608.5195687,118.4797903,136.0693539,1.8,113.3328677,135.6342786,0.1625787,42.0505812,75.4632781,41426.3557439,146688.0284514,2.6571802,1943.8332416,985.1553673,2188.3599861,26.625024,27.3971095,0.8391099,88.3237986),(13259,'Alces_femur.tif',242,7,397,614.4369134,118.3904815,136.254312,1.8,113.1750778,135.8062245,0.1635309,41.9167262,75.36659,41896.6052911,151069.9306498,2.7142554,2004.4681676,999.5199799,2248.6187467,27.457056,28.1971704,1.948563,91.1645335),(13260,'Alces_femur.tif',242,7,398,618.8010921,118.3317898,136.4413531,1.8,113.0217668,135.9309013,0.1632753,41.7733203,75.3494202,42203.5434792,154625.1652916,2.7250744,2052.1082308,1010.2989951,2296.7639548,28.289088,28.9691749,1.7879076,93.1732365),(13261,'Alces_femur.tif',242,7,399,622.3938012,118.3415813,136.6583551,1.8,112.930128,136.1008488,0.1593257,41.2309823,75.5519115,42253.9191333,156898.518342,2.6110044,2076.6981968,1024.8099066,2325.5662139,28.289088,29.6190537,1.7544187,94.8373005),(13262,'Alces_femur.tif',242,7,400,625.4370415,118.359841,136.8952576,1.8,112.9028475,136.3437234,0.1560621,40.7826648,75.7360698,42238.9736157,159106.769286,2.5182472,2100.8057281,1035.7090165,2352.83027,28.9040556,30.1288656,1.8794472,97.2915848),(13263,'Alces_tibia.tif',242,8,1,15.9792941,90.6111441,134.3058544,1.8,84.0034183,124.3484744,0.0523437,53.0910859,65.5072263,3239.5606903,28925.5156287,0.0072902,441.5622102,61.0189194,483.0808586,0.351562,0.4971837,2.3561945,0.9943675),(13264,'Alces_tibia.tif',242,8,2,11.3835139,95.5170678,141.8259653,1.8,95.4200706,142.0811086,-0.0077101,4.9860491,70.9126225,58.5541179,20569.4583974,0.0001128,290.0676588,11.7435904,290.8896016,9.6266923,147.6978867,3.1177876,316.0756715),(13265,'Alces_tibia.tif',242,8,3,10.6659839,94.1515444,141.6502358,1.8,95.1195577,141.7471335,-0.0122049,5.8001598,69.5545446,64.4181444,18143.4055128,0.0002648,260.8514743,11.1062707,261.7683161,3.9504654,5.5586833,0.6055447,21.3289317),(13266,'Alces_tibia.tif',242,8,4,9.8292026,92.4240261,141.4218055,1.8,91.1602641,141.6735475,-0.0206738,5.0378205,67.8418593,57.7295914,15682.1307209,0.0007001,231.1571482,11.4592394,231.998616,0.351562,0.4971837,2.3561945,0.9943675),(13267,'Alces_tibia.tif',242,8,5,9.8867309,90.892719,141.1709567,1.8,91.4929516,141.3522792,-0.0370024,6.3423937,66.3348538,65.3608382,12913.3691368,0.0022551,194.6694444,10.3053896,195.654163,3.9929901,5.7230147,2.3127436,20.249261),(13268,'Alces_tibia.tif',242,8,6,0.5605633,105.0791265,136.9518262,1.8,105.1242127,136.8508896,-0.003375,1.6038788,5.6670863,0.1683731,1.9914728,0.0000011,0.3514103,0.1049787,0.3724525,2.460934,4.0084235,0.266252,10.9733762),(13269,'Alces_tibia.tif',242,8,7,8.7612222,101.6851275,100.6922268,1.8,101.4937736,100.8341654,-0.7920317,7.6890469,47.8845913,9.9464898,62.3673771,0.7397879,1.3024519,1.293592,1.4910692,4.9718375,10.6923408,0.8086498,25.5476757),(13270,'Alces_tibia.tif',242,8,8,71.2323649,101.3519704,98.4201645,1.8,103.6807402,97.4747147,1.4740249,42.4977134,32.7361385,2130.7201182,4304.103412,11.761229,131.4786537,50.1372886,137.9876483,10.4217515,17.9055189,0.7576275,48.5241294),(13271,'Alces_tibia.tif',242,8,9,258.7099505,99.0684545,96.2246362,1.8,96.1241138,97.7874407,-1.30833,43.225533,46.489422,9075.8147814,32551.7200689,40.2155492,700.1962743,209.9642077,781.0274474,20.3270228,40.4846197,1.5186697,146.1695109),(13272,'Alces_tibia.tif',242,8,10,651.7998899,95.4264468,103.0306051,1.8,92.9118516,105.923584,1.4983648,41.0709635,41.5399701,94428.2375887,133887.8475763,108.0643843,3223.1089087,2299.1483434,4874.9431401,57.6709706,68.0624395,2.5435617,420.1213075),(13273,'Alces_tibia.tif',242,8,11,1199.7509223,93.9663656,106.1362442,1.8,92.5092556,106.2755236,0.9237586,40.9146216,39.8741147,232078.5219291,347567.4206785,127.2938413,8716.61786,5672.263675,13810.47328,62.1644091,82.1196457,2.6070468,377.2635662),(13274,'Alces_tibia.tif',242,8,12,1367.2823116,94.8708491,105.2855102,1.8,92.9644324,105.0120558,0.8226585,36.2670954,42.6006059,319658.3669954,525305.0300964,122.4232464,12330.9286108,8814.0051941,18661.528748,64.4713317,89.7833184,2.6919546,480.3426352),(13275,'Alces_tibia.tif',242,8,13,1601.034704,93.541304,100.850563,1.8,91.2652079,99.6792957,0.9471412,49.3132977,54.1660133,431300.4052727,858754.6510781,175.83014,15854.1232524,8746.1278264,23151.8698774,0.7457756,1.4915512,2.3561945,2.9831025),(13276,'Alces_tibia.tif',242,8,14,1838.0704386,91.4574701,95.9848146,1.8,90.3696165,96.2365466,1.0228907,47.5588436,63.3457256,572612.1717959,1239646.2380439,223.2221856,19569.5325349,12040.0777014,26534.5658878,74.6821539,103.7036393,2.076907,740.7851674),(13277,'Alces_tibia.tif',242,8,15,2019.620967,91.0592081,93.9244315,1.8,90.3210773,94.8726407,1.0593034,48.0072338,64.882083,708906.7233205,1425861.405957,255.9565659,21976.1965123,14766.6646677,30195.5791035,78.6310949,108.8486142,1.8792688,734.0487221),(13278,'Alces_tibia.tif',242,8,16,2248.9675798,91.7034577,93.6150195,1.8,91.0854331,92.8551998,1.1040934,53.4195206,64.0230963,864603.5517445,1646114.4860812,298.9440715,25711.2601662,16185.1611995,35084.5544979,0.351562,0.4971837,2.3561945,0.9943675),(13279,'Alces_tibia.tif',242,8,17,2175.6638235,92.4336074,92.3307913,1.8,91.4843466,92.1929146,1.1106548,69.8191383,56.4990343,937952.3205264,1558440.714358,291.1029085,27583.4929695,13434.0288825,35608.2741567,0.351562,0.4971837,2.3561945,0.9943675),(13280,'Alces_tibia.tif',242,8,18,2143.9760224,92.1713905,90.6308576,1.8,91.8892312,91.2348856,1.1925177,68.5208881,62.4526859,996513.681364,1480862.1336011,308.5902445,23711.7445503,14543.2102289,34812.1804151,0.351562,0.4971837,2.3561945,0.9943675),(13281,'Alces_tibia.tif',242,8,19,2079.8815045,92.4521954,89.5798313,1.8,92.5415486,90.4823498,1.3233498,52.8836858,62.0887649,1036388.9211878,1415353.9302082,325.8514804,22795.6528325,19597.5167986,34904.4256764,0.8794877,3.0242507,0.9505468,6.3780855),(13282,'Alces_tibia.tif',242,8,20,2032.3993911,92.5252701,88.3672507,1.8,93.048013,90.4109531,1.5118845,51.9376643,55.8266566,1002855.051264,1390882.3258738,337.5589836,24914.3045925,19308.8207607,39241.9352277,91.801782,104.5032459,1.8925469,563.2845069),(13283,'Alces_tibia.tif',242,8,21,1878.4040683,92.2344836,89.1385926,1.8,92.61819,90.3738504,-1.4699352,49.0603681,55.9213485,924718.3848416,1282701.9725774,309.8933084,22937.6080334,18848.5822917,37052.7746058,0.351562,0.4971837,2.3561945,0.9943675),(13284,'Alces_tibia.tif',242,8,22,1753.907889,91.7738274,89.5658326,1.8,92.0930431,90.1400895,-1.3539031,46.0615609,57.9790542,857793.0643996,1229174.9625792,278.7808484,21200.327926,18622.7528399,35718.2336174,86.4532547,105.201661,0.887183,419.3571296),(13285,'Alces_tibia.tif',242,8,23,1680.2648808,91.2717194,89.8962753,1.8,91.4815315,90.2113409,-1.2696003,44.8892875,58.804836,804585.5307557,1189381.3289026,255.397819,20225.9101537,17923.7759101,31079.588619,84.4152976,106.0214471,0.8934661,408.7249663),(13286,'Alces_tibia.tif',242,8,24,1612.7771702,90.5743787,90.6315239,1.8,90.9500584,90.626139,-1.206068,63.4141463,59.3961082,741836.5088608,1144873.7235633,234.5968006,19275.2312889,11698.2810953,27710.7995025,82.2567744,106.1909301,0.8862315,402.8587003),(13287,'Alces_tibia.tif',242,8,25,1544.1428648,90.0796357,91.4935334,1.8,90.4207452,91.2418612,-1.134863,66.0791195,60.6622048,686516.9555956,1104245.30129,211.4702013,18203.1844217,10389.3175484,26148.5839614,80.6092806,106.7325094,0.8646709,440.5946957),(13288,'Alces_tibia.tif',242,8,26,1475.5932038,89.6103227,92.6108562,1.8,90.0712546,92.2945338,-1.063047,73.7557516,61.4393617,641168.6663174,1055339.2393674,187.7933809,17176.9238925,8693.134467,22908.3342568,79.0551746,107.190095,0.8596798,438.0941412),(13289,'Alces_tibia.tif',242,8,27,1408.1319352,89.0092404,93.9393116,1.8,89.6194824,93.6075355,-0.9928416,43.0924145,61.4671988,601192.5953548,979756.8790402,164.6442424,15939.5075401,13951.2395038,25312.1429069,77.6542834,106.5377884,0.8367548,466.7102227),(13290,'Alces_tibia.tif',242,8,28,1346.5563005,88.3772477,95.7705259,1.8,89.108377,95.4670747,-0.8957821,42.9047057,61.2980435,575376.8022108,889154.3329391,136.7853229,14505.4276067,13410.5756684,22907.0910257,76.4539765,105.8645359,0.8488423,572.2166675),(13291,'Alces_tibia.tif',242,8,29,1277.6967885,87.8688316,98.0813171,1.8,88.6483861,97.8275902,-0.7014864,41.282002,57.0909199,521999.547183,767300.3809725,88.6895266,13439.9722776,12644.7246317,19908.966638,74.7240264,101.9681324,0.9100555,546.5776263),(13292,'Alces_tibia.tif',242,8,30,1222.0552148,87.6571794,100.1517283,1.8,88.3163935,100.176403,-0.4901921,56.1375794,55.5285655,455995.4695779,677996.1389268,45.1444026,12209.8623011,8122.8202983,17051.0289589,71.405933,93.3130587,0.8707518,455.8660568),(13293,'Alces_tibia.tif',242,8,31,1185.7311465,87.7585082,101.460171,1.8,88.2416661,101.5017928,-0.4114526,41.5600642,54.8418382,417407.7106889,630018.0194699,31.610192,11487.908511,10043.4808807,18790.5532769,69.086281,89.515169,0.7631796,559.7663758),(13294,'Alces_tibia.tif',242,8,32,1162.2622441,87.9581817,102.4741436,1.8,88.3097189,102.4790874,-0.3631247,40.8023876,47.7735406,386230.6612676,592019.0967365,24.4394435,12392.1963786,9465.8838311,19235.9006284,67.3821289,86.5114009,0.7911452,623.0207754),(13295,'Alces_tibia.tif',242,8,33,1135.9248695,88.2416686,103.3139678,1.8,88.5932282,103.1622446,-0.3221724,40.0795193,47.4809349,353417.3232129,557821.323719,18.9800238,11748.322253,8817.9032507,18679.2746862,66.1822561,83.9379583,0.7231641,559.6396764),(13296,'Alces_tibia.tif',242,8,34,1110.9874238,88.4354397,104.0014206,1.8,88.7679235,103.8848073,-0.3023627,42.6450769,46.9762017,327059.5290333,529065.770686,16.4187081,11262.4212191,7669.3384753,17224.5316674,64.7239935,81.5457134,3.0509328,529.2054665),(13297,'Alces_tibia.tif',242,8,35,1080.8098515,88.7179924,104.5008984,1.8,89.0098552,104.3917785,-0.2943592,38.3700586,46.3703593,301558.6679398,498293.3914735,15.1625845,10745.9463099,7859.2183381,16957.4704467,62.9146801,80.4639328,3.0540973,526.0456952),(13298,'Alces_tibia.tif',242,8,36,1051.3455771,89.0126003,105.0302428,1.8,89.2792976,104.9977989,-0.2920829,37.6696408,45.7120556,281110.2033148,469793.7556275,14.5285071,10277.2397596,7462.5135038,16171.958191,61.6678664,79.3269096,3.0661804,566.9914314),(13299,'Alces_tibia.tif',242,8,37,1021.983288,89.2509569,105.526906,1.8,89.5207258,105.4250286,-0.2970676,39.8308505,44.8478281,263535.0031205,444388.1421188,14.5945249,9908.799621,6616.3539046,15118.0680936,60.1913384,78.2492039,3.069645,458.9344626),(13300,'Alces_tibia.tif',242,8,38,989.2164578,89.5023833,105.9044369,1.8,89.8194105,105.6981025,-0.305773,35.7510502,44.1061054,249225.8237791,422406.5086617,14.9403491,9577.052991,6971.1469353,14976.4020033,59.6101771,77.3947594,0.0363476,565.0380302),(13301,'Alces_tibia.tif',242,8,39,957.3867463,89.6622024,106.3456123,1.8,90.123008,106.1818688,-0.3161122,34.8738056,43.1414826,236931.4336902,403151.4019329,15.4207094,9344.8666597,6793.9655365,14564.8933448,58.5331038,76.4055123,3.0863494,505.8671018),(13302,'Alces_tibia.tif',242,8,40,922.6118208,89.7428907,106.6628392,1.8,90.0115209,106.1889512,-0.3243984,37.1739963,42.1583491,223390.7551145,385167.3883498,15.622021,9136.2066343,6009.328485,14094.0855529,57.4854767,75.7459074,0.1162953,508.7295673),(13303,'Alces_tibia.tif',242,8,41,896.1315619,90.0181661,106.9425194,1.8,90.1852535,106.0896783,-0.3363959,37.9997779,41.2103379,211924.2596833,368243.7785747,16.2733795,8935.7136366,5576.9867944,12631.6326625,56.3585578,74.9824963,3.0899953,449.4380019),(13304,'Alces_tibia.tif',242,8,42,873.799479,90.2402603,107.2142687,1.8,90.2919121,106.2513003,-0.3459381,33.8856893,40.4759187,202622.8052905,352951.8034805,16.7441537,8720.0442847,5979.5981533,13276.8318638,56.3921995,74.9684842,0.1080679,492.1958042),(13305,'Alces_tibia.tif',242,8,43,850.842975,90.4908068,107.4396304,1.8,90.2625844,106.2677163,-0.3584951,31.4828423,39.8478271,194057.1636089,339752.6362681,17.4573909,8526.2525262,6163.9022827,12892.6992833,55.8533741,73.9484573,3.0845119,385.3598412),(13306,'Alces_tibia.tif',242,8,44,835.2188878,90.8411107,107.8187133,1.8,90.544252,106.7613349,-0.3662389,30.8281886,39.4277695,188421.8252048,328933.8613284,17.8514292,8342.6951448,6111.9979384,12611.1734575,55.1166985,74.1962418,0.0996687,456.7251516),(13307,'Alces_tibia.tif',242,8,45,822.8430491,91.2268915,108.1140165,1.8,90.7879317,107.0590898,-0.3718733,31.2223017,39.092857,182583.7713957,319453.4913665,18.1068572,8171.6588685,5847.8639056,12331.6911295,54.9405251,74.0419953,0.0760436,383.4564095),(13308,'Alces_tibia.tif',242,8,46,807.4495618,91.5245463,108.5017876,1.8,90.9254623,107.5798275,-0.3729641,30.7104622,38.6905495,176963.8745307,311683.0028533,17.8676268,8055.7915693,5762.3318528,12123.9951927,53.9062049,72.8420854,0.0434509,366.431525),(13309,'Alces_tibia.tif',242,8,47,799.1113744,91.8658989,108.8256946,1.8,91.0004776,108.0030467,-0.3699491,30.3746192,38.4681876,172649.2813901,306303.1719664,17.4114954,7962.505937,5683.9982203,11972.6721274,54.1320801,72.7622938,0.096784,414.5937434),(13310,'Alces_tibia.tif',242,8,48,791.5599682,92.2239046,109.1177941,1.8,91.3550428,108.5254805,-0.3719798,30.7531154,38.2017314,169306.7840497,300075.5844226,17.427986,7855.0257577,5505.3539038,11833.4537806,53.6078146,72.5658374,0.0630232,421.1777692),(13311,'Alces_tibia.tif',242,8,49,786.8237757,92.6511401,109.3583494,1.8,91.8342191,108.6009995,-0.3649378,29.664454,38.0514412,165820.8038137,294378.0721779,16.7031339,7736.3185926,5589.8822173,11679.6606907,53.5645867,72.6679589,0.0823377,323.2704156),(13312,'Alces_tibia.tif',242,8,50,782.2763102,92.8631966,109.7286194,1.8,92.1035697,109.0216162,-0.3628783,29.4328689,37.8086457,162346.4862166,290115.6132874,16.4279634,7673.2611811,5515.8226964,11605.5773692,52.8353783,72.412385,0.0972532,313.0147991),(13313,'Alces_tibia.tif',242,8,51,780.1409861,93.2237777,110.0189227,1.8,92.4317026,109.3638594,-0.3551805,30.730943,37.7402976,159929.9878264,287242.5972884,15.7246165,7611.0315974,5204.2004592,11555.7560731,52.6024262,72.3790941,0.0924189,360.3946525),(13314,'Alces_tibia.tif',242,8,52,776.8841233,93.5126114,110.3163358,1.8,92.5109458,109.6419292,-0.3496132,29.4769569,43.1950843,157264.397627,285810.1725881,15.1919511,6616.7291358,5335.1639504,9836.6916055,52.382738,72.1730328,0.112271,331.7079036),(13315,'Alces_tibia.tif',242,8,53,781.0947339,93.8441969,110.5967941,1.8,92.7440157,109.9110855,-0.3467555,29.6407785,37.7399971,155829.3854338,286818.9105166,15.0356592,7599.8657197,5257.2635787,11458.3229049,52.0249051,72.1344915,0.107428,356.6084871),(13316,'Alces_tibia.tif',242,8,54,788.0938915,94.1866097,110.9153907,1.8,93.0729473,110.3899387,-0.3436378,29.1870321,37.768026,154957.1752961,290426.2571901,14.9096014,7689.7388501,5309.110393,11530.5364089,51.328052,72.4473667,0.1020829,302.3033949),(13317,'Alces_tibia.tif',242,8,55,788.6266644,94.4996589,111.1739597,1.8,93.4302091,110.7598739,-0.3423878,28.8363171,37.7960047,153699.8556052,288833.4484123,14.8156019,7641.9042325,5330.0792513,11521.3900624,50.97649,72.2132652,0.1171087,358.8884656),(13318,'Alces_tibia.tif',242,8,56,788.5610463,94.8750809,111.4497746,1.8,93.8229234,111.1196314,-0.3325004,32.5672773,37.7942988,152457.8457325,285530.0716006,14.0024558,7554.845052,4681.319975,11374.8622827,50.273366,72.613512,0.0726873,350.7982529),(13319,'Alces_tibia.tif',242,8,57,785.6183791,95.3783438,111.6063776,1.8,94.3564007,111.1301483,-0.3236801,28.7408935,37.6129253,151788.6754283,279490.0628067,13.2456148,7430.6919873,5281.2789339,11252.2618559,50.1925766,72.3474963,0.0875803,338.7951754),(13320,'Alces_tibia.tif',242,8,58,778.3484344,95.7844481,111.7722907,1.8,94.83074,111.2477366,-0.3241575,29.0313421,37.4967057,149894.8911386,271783.1750614,13.160418,7248.1880767,5163.2091574,11054.2039551,49.9148578,72.0624924,0.0977269,321.8202604),(13321,'Alces_tibia.tif',242,8,59,776.7357708,96.2906284,111.8919605,1.8,95.2946952,111.4110631,-0.3300314,29.040855,37.1158528,149152.8839741,264610.9685905,13.5958687,7129.3247696,5135.967373,10920.5759111,49.570242,71.5884174,0.0786551,292.5303264),(13322,'Alces_tibia.tif',242,8,60,775.1772273,96.7205507,112.0197647,1.8,95.6701444,111.6168133,-0.3398738,28.6354186,36.3104476,148139.6953908,257391.763827,14.3581334,7088.6419959,5173.302938,10960.3359222,49.3091541,70.2464512,0.0902068,295.8253704),(13323,'Alces_tibia.tif',242,8,61,775.8867049,97.2212214,112.1260536,1.8,96.1274479,111.7509865,-0.3477303,29.1788872,35.8450751,147646.1372742,250731.6221733,15.0160843,6994.8694914,5060.0331731,10917.7265668,49.0914123,69.4857646,0.0810404,280.6186145),(13324,'Alces_tibia.tif',242,8,62,772.3936243,97.7349416,112.2345311,1.8,96.64737,111.9278241,-0.3522103,28.8910781,35.2732665,146634.9717552,243872.3974143,15.3199873,6913.8024746,5075.4413285,10882.0844712,48.867118,68.8460374,0.0920468,301.4856962),(13325,'Alces_tibia.tif',242,8,63,772.3905906,98.2939344,112.2934345,1.8,97.1515923,112.0777848,-0.3605395,28.0142464,34.737969,146090.4589389,237250.8085533,16.0210672,6829.7259629,5214.8630669,10868.2093726,48.515556,67.7338732,0.0831412,278.5092425),(13326,'Alces_tibia.tif',242,8,64,769.9566514,98.8728315,112.372045,1.8,97.7702523,112.2371269,-0.3713471,37.3016507,34.0704148,145289.2718788,229751.0447883,16.8973923,6743.4178965,3894.982373,10037.3712089,48.3938691,66.6541526,0.0791991,235.5394376),(13327,'Alces_tibia.tif',242,8,65,766.7887777,99.4861913,112.3929652,1.8,98.2323607,112.2041069,-0.377725,31.5229574,33.7386119,144404.5531182,222042.0013905,17.3829021,6581.2429392,4580.9329078,10333.4846796,0.4971837,0.9943675,2.3561945,1.988735),(13328,'Alces_tibia.tif',242,8,66,756.1496852,99.9320017,112.5247978,1.8,98.4753711,112.3426783,-0.3832525,27.6604083,33.3564921,142096.6919151,214164.5117997,17.6221112,6420.4746373,5137.1870672,10541.2493899,48.0977489,64.9961984,0.0975158,267.309228),(13329,'Alces_tibia.tif',242,8,67,760.5645661,100.4022595,112.6471761,1.8,99.0380218,112.5356799,-0.3848067,28.262049,33.4143133,141455.1403332,208647.5351229,17.8618753,6244.2562623,5005.126854,10368.5643049,0.351562,0.4971837,2.3561945,0.9943675),(13330,'Alces_tibia.tif',242,8,68,757.4937712,100.9393666,112.7577786,1.8,99.6849833,112.6699128,-0.3938325,32.2898792,33.6387659,140061.6531445,202897.2143198,18.5900285,6031.6485678,4337.633232,9398.9851372,47.812432,63.9379074,0.1434523,261.8402067),(13331,'Alces_tibia.tif',242,8,69,750.077946,101.5781526,112.778414,1.8,100.4254434,112.7113341,-0.4117969,27.7268419,32.6212667,138588.9783708,192981.6626633,20.0277583,5915.8236908,4998.3686953,10108.6322046,47.46087,62.1976671,0.1818757,268.6448084),(13332,'Alces_tibia.tif',242,8,70,746.6995473,102.2230407,112.7805651,1.8,101.2051278,112.7572564,-0.425614,27.7504075,31.7868101,137446.1066775,185056.1197212,21.214977,5821.7895829,4952.9401274,10138.4695586,47.433691,60.3428292,0.1756847,243.4943775),(13333,'Alces_tibia.tif',242,8,71,742.7362033,102.7615977,112.7789563,1.8,101.8596278,112.8700793,-0.4485302,34.0502495,31.1220704,136457.82735,178311.0992902,23.2779768,5729.4099411,4007.5426593,8341.030388,47.109308,58.5801886,0.2362453,247.4718475),(13334,'Alces_tibia.tif',242,8,72,740.0129375,103.3302994,112.7893262,1.8,102.5008652,113.0874448,-0.4710739,33.9639282,30.4947023,135693.3386869,172153.921391,25.4038904,5645.3714414,3995.2192211,8520.365225,46.9876945,57.6604552,0.2715996,239.7374835),(13335,'Alces_tibia.tif',242,8,73,737.3290725,104.0732019,112.7845747,1.8,103.3544703,113.1122274,-0.4914915,33.4080639,45.2863564,134912.9633961,165803.1219129,27.3707157,3661.2157647,4038.3352872,6634.8768023,46.6601042,56.893334,0.2179987,232.3296968),(13336,'Alces_tibia.tif',242,8,74,733.385354,104.5090976,112.7902429,1.8,103.9111189,113.0806875,-0.5282545,32.7275468,45.258276,133137.4549064,160398.886976,31.0518727,3544.0785898,4068.0548305,6465.9871853,0.4971837,0.9943675,2.3561945,1.988735),(13337,'Alces_tibia.tif',242,8,75,730.2619373,104.9049988,112.7671534,1.8,104.4366286,113.0412853,-0.6063163,32.8147355,54.8931321,131411.0023173,155756.9948094,39.5220742,2837.4586918,4004.6338979,5049.626738,46.3111627,54.9157399,0.2325569,254.1058427),(13338,'Alces_tibia.tif',242,8,76,730.7983058,105.3171024,112.6921217,1.8,104.9087616,112.9106962,-0.6865427,29.281082,28.2033417,129789.4623903,151678.7322378,48.9375848,5378.0411557,4432.5364159,9550.4487157,46.1364064,54.3296958,0.2685222,250.9168),(13339,'Alces_tibia.tif',242,8,77,728.8052293,105.7633885,112.6572067,1.8,105.4317049,112.8055123,-0.7734854,30.5046634,27.5152117,128301.3046192,147699.476258,59.2868956,5367.9207714,4205.9570671,9047.4779619,46.0411285,53.0439374,0.2272956,243.0118295),(13340,'Alces_tibia.tif',242,8,78,729.6216734,106.1889433,112.6463313,1.8,105.9222919,112.8027192,-0.8657082,42.1367484,44.8997641,126679.0644609,144633.2907421,70.5258602,3221.2483463,3006.3796898,4406.2015953,45.6929879,52.3968929,0.2856728,269.5892065),(13341,'Alces_tibia.tif',242,8,79,730.0961691,106.6130752,112.6237418,1.8,106.3648982,112.8549486,-0.9590864,25.8570356,26.9697241,124917.2471054,142170.9912732,81.553699,5271.5033658,4831.0738003,9704.589222,45.544934,51.8598638,0.8621701,273.5520407),(13342,'Alces_tibia.tif',242,8,80,739.0227101,106.9553626,112.5309935,1.8,106.6830357,112.8183996,-1.0711628,30.1159633,30.0580168,124131.9311543,140752.1413504,94.8978444,4682.6822322,4121.7984661,6225.3231971,45.2469913,51.1229658,0.9121657,293.3394517),(13343,'Alces_tibia.tif',242,8,81,740.4841372,107.4856088,112.4815445,1.8,107.1586752,112.7012138,-1.1594454,25.7410089,25.9741386,122503.5302234,139106.2422501,103.6827933,5355.5670979,4759.0803797,9608.8877043,45.2469913,51.2087193,0.9561334,271.1014557),(13344,'Alces_tibia.tif',242,8,82,740.3390432,107.8632615,112.4746162,1.8,107.5626012,112.7768426,-1.2358363,25.5377091,25.8683296,120419.3758203,136838.3284051,110.0557986,5289.8014896,4715.3554566,9536.1094091,45.1910269,50.6847071,0.8787223,264.396793),(13345,'Alces_tibia.tif',242,8,83,739.5672059,108.1941576,112.4595383,1.8,107.9652076,112.7581297,-1.3086642,25.2131332,26.3362195,117728.8374641,134956.7271123,114.9837488,5124.3773663,4669.3457867,9417.0177472,46.9012189,50.5124986,0.8938815,365.2872491),(13346,'Alces_tibia.tif',242,8,84,740.2595673,108.5224642,112.4376017,1.8,108.3571779,112.7291353,-1.3570971,24.6601299,26.0866077,114970.3998025,133651.9463288,117.8275598,5123.3931221,4662.1976513,9279.3434707,45.3876636,50.1367349,0.9146732,275.646777),(13347,'Alces_tibia.tif',242,8,85,739.4574303,108.8418171,112.4072801,1.8,108.7091905,112.7256908,-1.3999853,24.0616085,26.0004044,112537.8786407,132472.8726524,119.681955,5095.0312311,4677.0721255,9152.1269827,45.4904582,50.0750676,0.9048271,280.1920983),(13348,'Alces_tibia.tif',242,8,86,736.860869,109.1266688,112.3258803,1.8,109.0358953,112.6578969,-1.435955,24.2033818,26.5384948,109556.8104696,131649.2059475,120.590689,4960.6884937,4526.508369,8963.5666159,44.6191056,49.9193281,0.8751563,276.008688),(13349,'Alces_tibia.tif',242,8,87,740.2147358,109.32809,112.18623,1.8,109.1629668,112.5144789,-1.4627792,23.4125241,26.4878478,106996.7815752,131974.8393951,121.9352786,4982.4674467,4570.0660503,8924.4637301,3.3743387,26.4677392,1.2742505,67.0259294),(13350,'Alces_tibia.tif',242,8,88,742.1124937,109.5166615,112.0743298,1.8,109.3571966,112.4637368,-1.4847522,22.8348354,26.0595351,104541.9246264,131973.5548943,122.7719566,5064.3096453,4578.1772842,8821.7089604,2.6347331,25.9299319,1.3521274,61.9334549),(13351,'Alces_tibia.tif',242,8,89,739.7392289,109.8438351,111.9320935,1.8,109.6129169,112.4237867,-1.5050793,22.4941393,25.4794797,101518.9343297,131431.0158302,122.7581829,5158.3084702,4513.1282012,8899.2163319,4.0458305,30.1381125,1.2748703,77.2608478),(13352,'Alces_tibia.tif',242,8,90,739.38758,110.0128801,111.8495165,1.8,109.7852634,112.3644172,-1.5179225,22.3450303,26.0519132,98857.3457511,130597.5483318,122.8870732,5012.9734152,4424.1312047,8779.121437,3.4191562,32.1482257,1.3390795,84.7892716),(13353,'Alces_tibia.tif',242,8,91,735.3626627,110.195007,111.7544873,1.8,109.9302091,112.3750755,-1.53103,22.4117411,25.9605962,96234.2020861,129686.9017406,122.3667338,4995.5286419,4293.9190481,8665.2861295,43.0319834,49.0627412,2.0152155,365.4846159),(13354,'Alces_tibia.tif',242,8,92,734.9859576,110.3540155,111.6705277,1.8,110.0844905,112.3990116,-1.5373517,21.8488178,25.8056068,93957.9323455,129145.9433796,122.3606923,5004.5691335,4300.3668731,8580.0354035,3.7876152,32.3379715,1.3627402,87.5664338),(13355,'Alces_tibia.tif',242,8,93,733.9643818,110.4903591,111.5199068,1.8,110.2068145,112.247028,-1.5457056,22.1190797,25.6664313,91561.6474191,128900.9957852,122.2504028,5022.1627749,4139.4871993,8523.3071016,42.212521,48.775981,1.3380548,337.500991),(13356,'Alces_tibia.tif',242,8,94,732.3728419,110.6224701,111.368302,1.8,110.3729703,112.1401274,-1.5446894,21.6237396,25.8871321,89180.5537495,129031.9335156,121.9789661,4984.4043395,4124.196619,8395.8818056,3.920044,32.1366899,1.3948567,86.6927033),(13357,'Alces_tibia.tif',242,8,95,731.9024661,110.7523829,111.1920889,1.8,110.5050176,111.873716,-1.5452326,20.7944038,25.7178957,86991.399189,129104.2630025,121.9040444,5020.0165931,4183.4043537,8375.3331505,3.1122273,30.7531359,1.3868529,76.5430881),(13358,'Alces_tibia.tif',242,8,96,731.2232133,110.8710589,111.0507417,1.8,110.6104358,111.5899983,-1.5489712,20.6551887,25.6045857,85072.6792941,128920.7600957,121.8124943,5035.0652665,4118.707446,8313.2994711,3.0738905,32.0211038,1.4164776,79.7674646),(13359,'Alces_tibia.tif',242,8,97,728.193692,111.1112368,110.8847508,1.8,110.8233311,111.559306,-1.5504198,20.4589342,25.4638672,82718.8299343,128456.157982,121.3152309,5044.64452,4043.1641772,8235.6578199,3.6782981,32.3685331,1.418147,84.2421184),(13360,'Alces_tibia.tif',242,8,98,725.1719235,111.2259212,110.7887772,1.8,110.920664,111.3876001,-1.5521548,20.0137803,25.3588917,80657.7644901,127413.6780205,120.8199913,5024.4182492,4030.1114199,8093.9771292,3.4174191,31.5270954,1.4478245,78.8584004),(13361,'Alces_tibia.tif',242,8,99,722.8397075,111.3376088,110.6982106,1.8,111.0528367,111.317028,-1.5527181,20.2838955,25.5289902,78852.3344635,126754.0085414,120.4339157,4965.1007588,3887.4354444,7887.1218376,3.3859535,32.9663195,1.4424731,81.9268061),(13362,'Alces_tibia.tif',242,8,100,722.7905688,111.4388645,110.5990803,1.8,111.1956227,111.2545467,-1.5555936,19.8165824,25.1506678,77337.8263783,126534.9399444,120.4372547,5031.0767381,3902.6823459,7989.8733175,3.4884219,31.7983894,1.4711277,78.6171264),(13363,'Alces_tibia.tif',242,8,101,722.5417666,111.5134033,110.5246083,1.8,111.3034963,111.2187236,-1.5590349,20.8436238,25.4316372,75898.6819666,126525.730372,120.4069704,4975.1311443,3641.3381163,7847.3695186,3.4806263,31.0650337,1.4801364,79.3555841),(13364,'Alces_tibia.tif',242,8,102,720.1869662,111.5794681,110.5227728,1.8,111.3047548,111.3859833,-1.5601862,68.1260171,25.4344514,74654.6237347,126092.9525308,120.0176494,4957.5652519,1095.8313267,2824.2398782,3.5148813,32.8480088,1.4743226,82.0827769),(13365,'Alces_tibia.tif',242,8,103,725.9637983,111.6336911,110.3222825,1.8,111.3903487,110.949332,-1.568554,67.6439722,25.2414273,73523.3307848,126724.0367616,120.9933588,5020.4782515,1086.916224,2839.8851231,3.0165816,32.4124149,1.5056712,80.0440724),(13366,'Alces_tibia.tif',242,8,104,728.6446296,111.711986,110.1886985,1.8,111.4997053,110.6859477,1.567829,19.0548339,25.1176348,72552.0808663,126599.3993706,121.4397031,5040.2595693,3807.5420288,7895.6699367,3.2029946,30.364864,1.47804,77.4521524),(13367,'Alces_tibia.tif',242,8,105,726.7205794,111.88473,110.0546928,1.8,111.6865013,110.6114521,1.5600414,19.2582955,25.0140004,71318.3361394,126112.4385732,121.1060879,5041.6741274,3703.2527734,7773.7144288,3.267132,30.6585447,1.5019398,76.0812381),(13368,'Alces_tibia.tif',242,8,106,724.7933083,111.9386318,109.9480879,1.8,111.7332759,110.506265,1.5563736,19.5422136,25.0724193,70035.7719447,125258.197439,120.7737591,4995.8560402,3583.8197943,7672.6700621,3.2487327,30.6585447,1.5019398,72.2743746),(13369,'Alces_tibia.tif',242,8,107,722.1680952,111.9917751,109.7678109,1.8,111.7672548,110.3341487,1.5499504,29.3009556,25.0912908,68881.7084076,124520.5923391,120.3090533,4962.701734,2350.8348762,6031.6647067,3.2558223,31.6718145,1.5263811,78.8937341),(13370,'Alces_tibia.tif',242,8,108,719.2304843,112.0331188,109.6026395,1.8,111.8543895,110.1717298,1.542503,25.9454765,26.0898142,67677.6930088,123916.391836,119.7758147,4749.6080562,2608.4582783,5208.1163153,3.7019814,33.4150388,1.5392279,82.4946574),(13371,'Alces_tibia.tif',242,8,109,717.4699926,112.0701225,109.4132285,1.8,111.8694667,109.9899407,1.5358311,28.6219317,26.0081568,66742.4929848,123595.389514,119.4321996,4752.177956,2331.8654308,4921.6623413,3.4050411,31.2969173,1.5483282,82.4946574),(13372,'Alces_tibia.tif',242,8,110,714.6303595,112.1306896,109.2149435,1.8,112.0118941,109.7926038,1.5275028,19.7726602,24.8616735,65742.5002313,123272.2907771,118.8819571,4958.3263449,3324.9193403,7602.6482644,3.3958373,31.6483915,1.5930149,85.8543066),(13373,'Alces_tibia.tif',242,8,111,715.025192,112.1622154,108.9768234,1.8,112.0735381,109.4742961,1.5186801,18.6114975,27.1671244,65044.0368939,123417.0330557,118.847478,4542.8817217,3494.8309212,6092.6657394,2.7571664,32.3513457,1.592532,76.2018751),(13374,'Alces_tibia.tif',242,8,112,715.3255673,112.1916294,108.7382346,1.8,112.1680371,109.2531871,1.509053,18.5822195,24.4931473,64491.5137657,123534.6570916,118.7670073,5043.6416132,3470.603379,7621.1054578,2.8386649,29.9344256,1.6295521,73.8012596),(13375,'Alces_tibia.tif',242,8,113,712.7526016,112.3429711,108.4300835,1.8,112.2771841,109.0419122,1.4970475,23.5388626,25.1102568,63706.091236,122980.3440707,118.1471744,4897.6139536,2706.4218176,5447.9680619,2.7572424,30.2670178,1.6172745,73.2687421),(13376,'Alces_tibia.tif',242,8,114,709.0846516,112.3839967,108.2338558,1.8,112.3165124,108.8531665,1.4872866,21.3857065,25.0694778,62875.9095286,121949.0170385,117.358512,4864.4418594,2940.0903597,5608.9322267,3.156736,29.9344256,1.6295521,73.1834389),(13377,'Alces_tibia.tif',242,8,115,704.9128051,112.4177978,108.0257306,1.8,112.3403022,108.5024272,1.4774285,67.3539696,24.2507645,62223.208624,120678.3003994,116.4642553,4976.2678821,923.8239262,2678.4132886,3.4482319,30.334321,1.6520126,78.8584004),(13378,'Alces_tibia.tif',242,8,116,703.0398412,112.4379553,107.8517311,1.8,112.417387,108.322343,1.4662991,18.9342226,24.2420337,61581.0846141,120019.8862345,115.8984644,4950.9000646,3252.3693143,7445.2050338,3.2963304,29.6648341,1.665748,72.5656181),(13379,'Alces_tibia.tif',242,8,117,700.6010706,112.4498506,107.6996107,1.8,112.4208531,108.1971156,1.454685,18.8795359,24.3490194,61193.3791869,119406.9416738,115.1996761,4903.9733172,3241.2544245,7405.6569561,3.1435577,29.7002274,1.677532,73.0628019),(13380,'Alces_tibia.tif',242,8,118,697.9996778,112.4554378,107.5371718,1.8,112.4820968,108.0144123,1.444469,18.7833878,24.2454655,60749.1928591,118733.2357537,114.4866194,4897.1316183,3234.1978704,7308.6627228,3.1713959,26.2520552,1.7051178,67.3525066),(13381,'Alces_tibia.tif',242,8,119,696.8182888,112.4378422,107.3564486,1.8,112.4567002,107.7705865,1.4351441,18.5406272,23.9496895,60436.9174769,118398.2528115,114.0123723,4943.6237124,3259.701894,7433.738964,2.6868965,25.9537536,1.7203561,60.9244517),(13382,'Alces_tibia.tif',242,8,120,695.1175726,112.4204891,107.1623664,1.8,112.4588302,107.5127391,1.4273848,18.460643,24.0420454,60270.7844475,118143.9399971,113.4864888,4914.0552669,3264.8258407,7391.9543643,2.5630643,26.0084608,1.7337228,62.4659724),(13383,'Alces_tibia.tif',242,8,121,694.2885816,112.5396066,106.9001653,1.8,112.553426,107.2890269,1.4179738,18.2467843,24.1139742,60012.4892084,117743.8013791,113.0332502,4882.8036522,3288.9350901,7307.8403259,2.6539905,26.3554287,1.7315591,61.5069387),(13384,'Alces_tibia.tif',242,8,122,689.0989421,112.5263565,106.7447832,1.8,112.5563341,107.1280397,1.4107967,18.2808752,24.540883,59361.524447,116719.441505,111.9346856,4756.1223291,3247.1926953,7127.6835398,3.0086488,26.0084608,1.7337228,63.4956737),(13385,'Alces_tibia.tif',242,8,123,684.0046961,112.5169655,106.5591843,1.8,112.5407054,106.9274563,1.4050961,18.5393883,24.3720259,58750.540129,115888.0291428,110.8992534,4754.960856,3168.9578591,6844.1293428,2.9409664,25.3758611,1.751889,61.2656647),(13386,'Alces_tibia.tif',242,8,124,681.1556247,112.5031366,106.3796899,1.8,112.5539726,106.7095381,1.3982232,18.2073732,24.5975563,58282.2577765,115291.3286902,110.1783965,4687.1049837,3201.0250527,7049.9691629,2.9102412,25.3149053,1.7382281,59.4828699),(13387,'Alces_tibia.tif',242,8,125,676.0736634,112.4697509,106.2264786,1.8,112.5622871,106.5728115,1.3900842,18.3056227,25.8295196,57696.9917787,114447.7672289,109.0390848,4430.8902805,3151.8726643,6658.4534022,2.7802243,24.4076207,1.7738415,58.7444122),(13388,'Alces_tibia.tif',242,8,126,671.0401667,112.4205009,106.0567192,1.8,112.5028164,106.3522759,1.3825776,18.2779025,24.309999,57112.0551431,113719.8515738,107.924518,4677.904419,3124.6503863,6922.9195581,3.3181006,26.8225909,1.7553391,69.1353014),(13389,'Alces_tibia.tif',242,8,127,670.4163448,112.3639703,105.854174,1.8,112.4845138,106.0748372,1.3761799,18.1212249,23.7289792,56811.606296,113744.4690341,107.5571534,4793.483442,3135.0864376,7067.8217233,2.7513907,26.8225909,1.7553391,65.7756522),(13390,'Alces_tibia.tif',242,8,128,669.4789265,112.2963539,105.6537216,1.8,112.3702399,105.7675607,1.3732222,17.7477084,23.7213708,56605.276779,113692.5362905,107.2806219,4792.8316324,3189.4414406,6900.2357829,2.4009064,25.168009,1.7818897,62.2600322),(13391,'Alces_tibia.tif',242,8,129,668.3655902,112.3975394,105.3962631,1.8,112.5467358,105.5250627,1.3714161,17.9353801,23.6235386,56563.4793703,113648.7673857,107.0244359,4810.8274306,3153.7374221,7119.0087876,2.8525741,24.6845598,1.7570192,59.7741134),(13392,'Alces_tibia.tif',242,8,130,664.7783894,112.3408231,105.2196071,1.8,112.4895039,105.3825105,1.368873,17.953257,23.9826489,56146.8931575,113205.7200163,106.3399574,4720.3176087,3127.3931568,7021.5773865,2.8562432,23.9939455,1.7624448,60.5625407),(13393,'Alces_tibia.tif',242,8,131,661.0965443,112.2668538,105.0339064,1.8,112.4222023,105.2229318,1.3656034,89.6320888,24.4079926,55903.1355215,113013.1434531,105.6083512,4630.1695309,623.6955566,1884.5263135,2.8082845,23.9939455,1.7624448,61.4716049),(13394,'Alces_tibia.tif',242,8,132,660.0984891,112.1727156,104.8566271,1.8,112.3677058,105.0057321,1.3626792,17.9008884,23.9930668,55576.1284246,113072.0713295,105.3197017,4712.6977159,3104.6575476,6990.3883135,2.8914939,25.2440122,1.7955075,62.2600322),(13395,'Alces_tibia.tif',242,8,133,657.5580703,112.0861238,104.7087618,1.8,112.261081,104.9377124,1.3599676,17.949427,24.008506,55206.9719535,113067.9704707,104.7934858,4709.4963044,3075.6954983,6961.1658142,2.8914939,25.2440122,1.7955075,58.0766219),(13396,'Alces_tibia.tif',242,8,134,660.0944067,112.0224506,104.5554232,1.8,112.1756187,104.8213134,1.3576194,17.984721,23.8767003,55275.8960442,113645.3610055,105.0914111,4759.6761517,3073.4919927,6996.0754482,2.7412933,22.7675416,1.8045395,56.5497369),(13397,'Alces_tibia.tif',242,8,135,662.9261372,111.9525631,104.4107724,1.8,112.1111712,104.6635457,1.3537011,17.5324966,25.6620247,55471.0327962,114277.370739,105.3616609,4453.1704736,3163.898099,6476.021353,2.3703238,22.0841387,1.811914,54.8522454),(13398,'Alces_tibia.tif',242,8,136,662.7203314,111.8683603,104.2699766,1.8,111.958699,104.4284722,1.3486415,17.7642597,23.8694654,55576.9258863,114616.2724534,105.091298,4801.7946903,3128.5810289,6906.4295072,2.4447202,22.7675416,1.8045395,55.3494292),(13399,'Alces_tibia.tif',242,8,137,658.7639912,111.9245694,104.0977463,1.8,112.0172951,104.3031726,1.3419513,17.8200544,23.9376861,55596.1366235,114348.7531391,104.14376,4776.934264,3119.8634674,6801.7354235,2.7409396,24.1377461,1.7910451,60.6478439),(13400,'Alces_tibia.tif',242,8,138,657.6894564,111.827281,104.1865315,1.8,111.7534769,104.7617838,1.3196335,94.6732786,49.3433511,65976.2329686,119037.4850727,102.8442801,2412.4321218,696.8833647,1919.6723395,2.5699724,22.85153,1.8195063,56.9969512),(13401,'Alces_tibia.tif',242,8,139,650.9759926,111.755089,103.8866622,1.8,111.865493,104.0863701,1.33267,18.9307961,24.1287205,55621.2199183,113573.8805178,102.4592336,4706.9997061,2938.1342279,6889.9863316,2.6641878,22.9405991,1.8343602,54.9375487),(13402,'Alces_tibia.tif',242,8,140,647.0805888,111.6469921,103.765,1.8,111.7664213,103.908583,1.326295,18.6854586,23.9761024,55644.7019767,113483.9245594,101.5270396,4733.2098673,2977.9682221,6933.7278908,2.875449,22.1707162,1.8273129,56.8909499),(13403,'Alces_tibia.tif',242,8,141,643.179979,111.5143468,103.6658467,1.8,111.6855779,103.8093643,1.3207835,18.1857676,24.1079257,55767.8974755,113635.6744253,100.634631,4713.6230505,3066.5682525,6666.55555,3.027082,25.3563712,1.8662372,63.8368866),(13404,'Alces_tibia.tif',242,8,142,641.7506118,111.4114266,103.5742427,1.8,111.5438002,103.7856297,1.3148487,18.062055,24.4728082,56171.9415333,113972.2541186,100.1033462,4657.0975032,3109.9418963,6889.0720228,3.3648913,27.5410179,1.815775,71.3799461),(13405,'Alces_tibia.tif',242,8,143,643.7109916,111.3137313,103.4882998,1.8,111.433573,103.690898,1.3096869,18.1670352,24.6855065,56699.1608479,114967.1863763,100.1353874,4657.2747604,3120.9914095,6877.9359856,2.9592192,26.0298366,1.8583722,63.8368866),(13406,'Alces_tibia.tif',242,8,144,640.933868,111.2229738,103.4433024,1.8,111.3451259,103.7557632,1.3040377,18.2774336,24.8620704,56882.8055363,115838.0587085,99.3994254,4659.2281753,3112.1877784,6887.6112552,2.1305755,21.1229965,1.8925469,52.7428734),(13407,'Alces_tibia.tif',242,8,145,636.524343,111.2791104,103.3109306,1.8,111.3789051,103.5660104,1.2986501,18.4168532,24.6531492,57087.2321104,116359.8026733,98.4222503,4719.8758235,3099.7278096,6978.8515798,0.351562,0.4971837,2.3561945,0.9943675),(13408,'Alces_tibia.tif',242,8,146,630.4638023,111.2095455,103.2520626,1.8,111.2268025,103.5333593,1.2937243,18.4544605,24.4089512,57049.6909919,116464.1614238,97.2149527,4771.3709891,3091.3768004,7015.5758926,3.0295044,26.2379273,1.8840725,70.3855786),(13409,'Alces_tibia.tif',242,8,147,625.3274213,111.1345495,103.1703372,1.8,111.1562126,103.4628415,1.2869521,18.9343154,24.8353487,57370.8656309,116762.193158,96.0474833,4701.4517379,3029.9941838,6985.1160391,2.8330854,26.2520552,1.9264322,66.9905956),(13410,'Alces_tibia.tif',242,8,148,622.7215341,111.0515312,103.1012576,1.8,111.0413785,103.3810062,1.2817364,18.947622,24.7144867,57715.9664011,117603.5792569,95.3537964,4758.4876235,3046.0796867,6923.2292742,2.918581,25.2048134,1.9720251,63.1837321),(13411,'Alces_tibia.tif',242,8,149,617.0319682,110.9218725,103.0389391,1.8,110.9508944,103.3166857,1.2765316,18.9741338,24.9989199,57878.9021685,117790.5670811,94.187767,4711.8262445,3050.4107798,6941.6729582,3.1780598,27.5746552,1.9086745,73.8658649),(13412,'Alces_tibia.tif',242,8,150,612.7689604,110.8140311,102.997525,1.8,110.7985975,103.3472068,1.2736244,19.1791294,24.7437139,58127.1040681,118090.944843,93.3714928,4772.563463,3030.7477958,6995.8310087,2.7938554,25.6832824,1.9055332,70.2649416),(13413,'Alces_tibia.tif',242,8,151,613.5341685,110.7201515,102.9386943,1.8,110.6586054,103.248057,1.2730351,19.1508561,24.6301935,58625.8387182,119271.8348297,93.4543186,4842.5049906,3061.2646525,7090.8223255,2.488637,24.2857849,1.956679,63.6809159),(13414,'Alces_tibia.tif',242,8,152,614.1090389,110.6135666,102.86269,1.8,110.4776924,103.0951709,1.2735077,18.9956347,24.9197305,59002.0316882,120652.1972537,93.5689977,4841.6333189,3106.083721,7167.148913,1.2994279,7.8611653,1.7506498,19.4108642),(13415,'Alces_tibia.tif',242,8,153,611.7980589,110.6834048,102.7885584,1.8,110.5829737,103.0044629,1.2790469,19.0196862,25.0095429,59263.7954967,121659.7300168,93.5306744,4864.5323271,3115.91868,7166.5819431,3.9058977,33.1364669,1.8724154,84.2067846),(13416,'Alces_tibia.tif',242,8,154,607.572467,110.6456394,102.7896716,1.8,110.542229,103.0939094,1.2840827,19.0396874,25.8080144,59250.8915316,121756.2843068,93.1634703,4717.7703185,3111.9676564,6974.2970086,3.6852741,30.3506144,1.8888839,81.6501983),(13417,'Alces_tibia.tif',242,8,155,600.8049955,110.5789486,102.6927725,1.8,110.4692375,103.0036777,1.2879776,19.0087666,25.6906788,59405.0350327,121654.2806499,92.3360716,4735.3470752,3125.1388509,7022.6442656,3.0863028,26.8318051,1.9464366,69.0999676),(13418,'Alces_tibia.tif',242,8,156,601.0008387,110.5340449,102.6556283,1.8,110.4563241,103.0064082,1.2931393,19.4191398,25.8932945,59828.0083431,122873.7636676,92.6410187,4745.3893299,3080.8783952,7055.698895,3.1424687,27.6149657,1.9489386,73.3686811),(13419,'Alces_tibia.tif',242,8,157,600.7273548,110.4849962,102.6155484,1.8,110.35995,102.9694401,1.2972957,19.0068129,25.7972373,60070.830655,124406.7036006,92.8167882,4822.4816623,3160.4893928,6988.9612316,4.3641515,35.359518,1.8736812,93.9798531),(13420,'Alces_tibia.tif',242,8,158,601.3535363,110.432515,102.6020769,1.8,110.2790288,102.8770116,1.3028352,19.4953693,25.8463217,60379.9733784,126282.926009,93.1996756,4885.9148021,3097.144379,7206.9745278,2.6425538,24.611851,1.9513027,67.4524456),(13421,'Alces_tibia.tif',242,8,159,601.7816648,110.3636271,102.5722719,1.8,110.3221151,102.854387,1.3101085,19.1855397,25.6552785,60841.1682414,128373.9885254,93.6339573,5003.8041369,3171.199198,7304.4937512,2.8223497,27.1409507,1.8597717,63.9928574),(13422,'Alces_tibia.tif',242,8,160,602.1100926,110.2866645,102.6179821,1.8,110.211303,102.8783798,1.3153141,18.6239142,25.9450306,61411.5891616,130178.8448378,93.9428875,5017.4866479,3297.4587592,7308.0323226,1.5646941,8.4521237,1.8662372,21.2789622),(13423,'Alces_tibia.tif',242,8,161,598.819859,110.3866802,102.6458189,1.8,110.2535562,102.9694066,1.3216065,19.532332,26.3378499,61736.8697228,131449.7804371,93.7331871,4990.9077915,3160.7526358,7211.9597239,2.8172564,26.912295,1.9173352,70.7121559),(13424,'Alces_tibia.tif',242,8,162,596.5268191,110.3931037,102.7607164,1.8,110.2534602,103.1003807,1.3273908,19.5466032,26.0763044,62193.9919612,131958.873955,93.6462189,5060.4898588,3181.8312009,7439.5995193,3.0429507,29.2388855,1.8887446,80.1586471),(13425,'Alces_tibia.tif',242,8,163,595.9455067,110.3993963,102.8002285,1.8,110.2896173,103.1717253,1.3335917,19.5519096,25.9823209,63125.3876141,133187.1373798,93.8396998,5126.0677564,3228.6047197,7462.3647121,3.5272474,31.3580692,1.9138203,85.1304846),(13426,'Alces_tibia.tif',242,8,164,597.4770464,110.3979061,102.8128281,1.8,110.2590757,103.2579245,1.3389365,19.6361007,26.3769608,64286.199682,135172.3542236,94.3214588,5124.6371892,3273.8780738,7305.7093284,3.1328802,30.2465933,1.9146021,77.8786686),(13427,'Alces_tibia.tif',242,8,165,598.4556633,110.4281384,102.8084925,1.8,110.2711384,103.295655,1.3446431,19.5231941,26.0875743,65556.0933712,137488.3795294,94.7276259,5270.2630782,3357.8569641,7719.4544122,2.9438305,32.9194217,1.9195673,82.7298691),(13428,'Alces_tibia.tif',242,8,166,602.0076579,110.4365446,102.8934718,1.8,110.2861241,103.426966,1.3444068,20.007631,26.7941914,66823.1505956,140451.3883267,95.2794935,5241.8595678,3339.8831993,6828.8175433,2.86493,32.9194217,1.9195673,82.7298691),(13429,'Alces_tibia.tif',242,8,167,611.3448367,110.418469,103.0095858,1.8,110.2819538,103.5807797,1.3462723,19.9681529,26.2641195,68520.5661314,144471.0262422,96.8401189,5500.6993968,3431.4924598,8044.325938,3.068422,34.4638364,1.8925469,89.6758058),(13430,'Alces_tibia.tif',242,8,168,618.7110364,110.3969301,103.094348,1.8,110.2870774,103.6926072,1.3430957,19.9611372,30.5383511,70235.7761255,148437.7272869,97.8638252,4860.6988187,3518.6259824,6055.3923072,2.5230199,31.2732135,1.9387773,79.5408263),(13431,'Alces_tibia.tif',242,8,169,620.9236267,110.5476968,103.1286482,1.8,110.4142016,103.7461231,1.340329,20.0816742,26.9828777,71818.9244993,151933.8538416,98.0871598,5630.7505597,3576.3414892,8265.5809011,36.9755915,51.2135462,1.474543,217.4202466),(13432,'Alces_tibia.tif',242,8,170,621.8213819,110.5625145,103.2750734,1.8,110.3955093,103.7871762,1.3333591,20.1167223,26.8264034,73200.9928048,154353.8613465,97.9031942,5753.8037928,3638.8131165,8443.4084531,37.2500963,51.6353508,1.6799498,222.3421146),(13433,'Alces_tibia.tif',242,8,171,623.5686151,110.5258741,103.5030477,1.8,110.2990923,104.0938788,1.3258259,20.5379404,27.1128498,74840.3833111,157665.4444382,97.8150892,5815.1557422,3644.0062652,8492.7537335,37.9098699,52.1095059,1.6993354,210.8008871),(13434,'Alces_tibia.tif',242,8,172,635.7904084,110.4451878,103.5786617,1.8,110.2523989,104.0870774,1.3162031,20.3554213,27.6027401,77282.4616128,162862.0414198,99.2437773,5900.2128343,3796.6525213,8660.4577215,38.4748167,52.6838853,1.677769,199.4655999),(13435,'Alces_tibia.tif',242,8,173,652.1362953,110.364889,103.6340274,1.8,110.1328005,104.0606159,1.3059896,21.4268699,29.5831656,80489.0667476,169197.361966,101.2442939,5719.3798734,3756.4547303,8363.1068403,39.0201489,53.2532304,1.6500999,194.0465481),(13436,'Alces_tibia.tif',242,8,174,665.8125495,110.3165967,103.656896,1.8,110.0952353,104.1149191,1.2981069,21.5185823,28.5490776,84111.9604056,175130.648315,102.9196867,6134.3715127,3908.805853,9040.8690897,39.4808478,53.8532857,1.6951513,186.5534582),(13437,'Alces_tibia.tif',242,8,175,684.7391176,110.2286834,103.7013844,1.8,110.0451924,104.1994292,1.2898595,21.2649899,29.1820309,88682.5914455,182105.2187701,105.3504447,6240.3202703,4170.3566234,9214.8550229,39.9253839,54.5091184,1.6871515,183.3997492),(13438,'Alces_tibia.tif',242,8,176,704.7400705,110.1476559,103.7531013,1.8,109.9778406,104.346206,1.2824191,21.2560701,28.3547453,94003.9853203,189583.4149591,107.9566015,6686.1265325,4422.4536693,9928.6728317,40.4217342,54.9899611,1.7054602,178.5132149),(13439,'Alces_tibia.tif',242,8,177,730.6048221,110.2140636,103.6912381,1.8,110.0200588,104.1858419,1.2719943,21.7467021,28.9922182,100472.4692657,198851.8092349,111.2154753,6858.7994058,4620.1244039,10170.1366361,41.6342073,55.6001722,1.735945,192.3843904),(13440,'Alces_tibia.tif',242,8,178,751.0469373,110.1311465,103.7849755,1.8,109.9497985,104.2787438,1.2708635,22.6340856,29.7523844,105921.8302502,206222.4086894,114.2474773,6931.2901505,4679.748599,10460.0306644,42.5301927,56.1938619,1.7596031,191.5252956),(13441,'Alces_tibia.tif',242,8,179,774.3843787,109.969363,103.8945102,1.8,109.7599832,104.426449,1.2653677,23.2353539,30.2301669,113187.749274,215370.2131918,117.3938757,7124.3474799,4871.3589595,10851.0493068,43.3644628,56.893334,1.788795,191.3900229),(13442,'Alces_tibia.tif',242,8,180,806.2721054,109.8593761,103.9938474,1.8,109.7230969,104.553484,1.271641,23.8309637,30.385055,121592.9200117,227648.0498086,122.7071103,7492.1059005,5102.3081282,11447.3164343,44.4005964,57.8156509,1.8290485,200.2186934),(13443,'Alces_tibia.tif',242,8,181,837.7451119,109.8862169,104.2148813,1.8,109.8040402,104.7072916,1.289631,24.2501514,30.9988206,129530.1861235,241578.5781442,128.87416,7793.1538634,5341.4176165,11958.5937591,44.9379437,59.0163602,1.8360034,199.0890532),(13444,'Alces_tibia.tif',242,8,182,877.0464915,110.12631,104.4774943,1.8,109.9880348,105.0001747,1.3259157,24.2312235,31.6364022,136768.4908734,257204.5151403,137.5826642,8130.0178672,5644.3080889,12036.6787588,45.4864317,60.0296619,1.4769551,202.8605829),(13445,'Alces_tibia.tif',242,8,183,910.0895397,110.3034323,104.5643938,1.8,110.1868758,105.0637829,1.3467703,24.477165,32.2845659,144785.5312589,270759.9617598,144.1955459,8386.6688012,5915.1266622,12871.317008,45.7560437,61.3422802,1.6453704,235.7953473),(13446,'Alces_tibia.tif',242,8,184,947.3430487,110.3534206,104.6956655,1.8,110.3458636,105.2194679,1.3597268,24.4531854,44.415837,155931.8760217,285788.5092365,150.9602679,6434.3830641,6376.7510544,9638.1371376,46.4775377,62.7052984,1.6944559,218.4792193),(13447,'Alces_tibia.tif',242,8,185,996.6304479,110.6095495,104.882373,1.8,110.565661,105.4036896,1.3832668,25.5148015,33.4738327,168665.3153799,308100.0574882,160.3317613,9204.2061648,6610.4890363,14225.1295169,47.979453,64.7217908,1.8684965,296.1166139),(13448,'Alces_tibia.tif',242,8,186,1035.1041849,110.6762636,105.1090037,1.8,110.6666384,105.5556138,1.3970655,25.4447529,34.5981344,177385.5777204,328329.4261164,167.3625522,9489.8014632,6971.401082,14596.0366697,49.0379346,66.2738663,1.7900406,260.319384),(13449,'Alces_tibia.tif',242,8,187,1067.7230371,110.7698746,105.3853922,1.8,110.7376365,105.6417627,1.3997537,26.312435,34.314178,187686.2314683,352029.2390735,172.79827,10259.0025262,7132.9860266,15294.4521341,49.6813387,67.6398344,1.7590178,299.7382352),(13450,'Alces_tibia.tif',242,8,188,1068.1022516,110.7740712,105.759295,1.8,110.7802992,105.7828404,1.4200531,27.3032178,34.8788561,197771.8925198,355792.9670845,174.0024186,10200.8209742,7243.53789,15473.7797086,50.5558053,67.8979,1.9416876,300.8032702),(13451,'Alces_tibia.tif',242,8,189,1216.9122046,110.5401395,105.6516199,1.8,110.5688205,105.5654387,1.4079624,28.3287198,34.7770734,216610.7606485,404002.7683567,197.4883448,11616.9283129,7646.3307371,16233.1888868,53.7285515,68.7211542,1.4115349,343.0992226),(13452,'Alces_tibia.tif',242,8,190,1347.8044312,110.2052412,105.1233851,1.8,110.2065362,105.3331917,1.4159671,39.7878987,44.1423917,239632.6225781,453507.2404942,219.292016,10273.735128,6022.7513938,13721.4694546,0.351562,0.4971837,2.3561945,0.9943675),(13453,'Alces_tibia.tif',242,8,191,1333.3555158,110.3537769,106.1978909,1.8,110.1549376,105.6750313,1.4170904,29.7495535,37.8090724,250095.0482717,482433.450976,217.0169346,12759.7272522,8406.6824073,17589.0862825,54.6512706,73.8690242,1.5374753,348.4476068),(13454,'Alces_tibia.tif',242,8,192,1403.8161557,109.8889599,105.834317,1.8,109.9368728,105.6343217,1.4123539,36.2372041,53.557972,265346.6960481,534860.5846518,228.1447766,9986.5727736,7322.4936302,14105.5154923,0.351562,0.4971837,2.3561945,0.9943675),(13455,'Alces_tibia.tif',242,8,193,1568.120233,110.1940464,105.3158991,1.8,110.0386503,105.6463391,1.4218221,42.921064,39.4909776,280416.7763292,607488.9479204,255.5958573,15382.9807607,6533.3137197,18048.3481467,56.4880507,76.0195415,1.4269372,375.8280468),(13456,'Alces_tibia.tif',242,8,194,1637.1254383,110.7509085,105.8084369,1.8,110.1075856,105.9215526,1.481893,37.7827372,38.9494066,289124.4196942,576469.2828587,270.7033335,14800.4638277,7652.2888778,17575.2731658,57.8155623,75.7059198,1.6824792,402.37009),(13457,'Alces_tibia.tif',242,8,195,1398.9536332,110.8480431,108.4734675,1.8,110.3044265,106.8788216,-1.4830504,31.2992842,39.4058016,271795.0138648,415274.8680662,231.3683686,10538.4194948,8683.7453674,17226.0624187,57.561863,74.799308,1.4860938,391.120106),(13458,'Alces_tibia.tif',242,8,196,1127.9159714,109.8611042,111.9531522,1.8,110.237661,110.5944989,-0.9162093,32.1445349,35.9179908,223208.8655651,267513.7213075,118.3040907,7447.9032845,6943.9133568,11805.6290718,56.5970785,72.4840366,1.4638884,402.1934212),(13459,'Alces_tibia.tif',242,8,197,827.780628,106.6010883,115.1170308,1.8,107.7894062,114.5557321,-0.1860121,42.2574164,33.2744325,121566.1069372,182896.5040549,4.718801,5496.6077629,2876.799326,7192.3031629,49.2129752,60.7012288,2.8235051,288.7734324),(13460,'Alces_tibia.tif',242,8,198,573.7469448,102.5344862,117.0226602,1.8,103.3808252,116.4369364,-0.0820869,28.0299021,36.9313893,82714.3629348,120121.0156804,0.6428962,3252.5452735,2950.9329967,5487.6990675,28.4523704,50.3360181,2.0032041,250.1637065),(13461,'Alces_tibia.tif',242,8,199,416.5131488,100.4943647,118.4897012,1.8,100.8804587,117.9251215,0.1588271,26.4165972,37.2759086,56873.9090889,69411.9604685,1.7364869,1862.1131727,2152.9612095,3271.2061076,21.8125914,48.5944659,2.0117941,208.4149074),(13462,'Alces_tibia.tif',242,8,200,314.7512631,98.1055329,119.9316665,1.8,99.4551874,119.3451007,1.1676179,39.0679786,25.1090095,21141.5354782,43690.9134479,44.3834049,1740.0492647,541.1474114,1627.1993812,1.8976671,13.6521986,1.7782926,33.4879799),(13463,'Alces_tibia.tif',242,8,201,249.1029208,97.1029468,120.2094811,1.8,96.7887236,120.2040225,1.2030816,9.6958945,22.2084963,3850.6927071,33648.8816022,36.1519469,1515.1355187,397.1467224,1683.0731953,0.703124,1.5722331,2.0344439,3.394983),(13464,'Alces_tibia.tif',242,8,202,181.5617644,97.2184082,119.602227,1.8,97.0574954,119.9512648,1.203838,8.936474,22.4065641,2184.2780393,23504.3790494,26.3651401,1048.9952399,244.4228056,1142.5405468,16.4654634,21.239699,1.9974238,67.3525066),(13465,'Alces_tibia.tif',242,8,203,76.6021922,97.1379592,117.1282452,1.8,97.5337932,119.3209824,1.2325821,7.0094682,23.0380496,518.0619017,7901.9524655,11.3614677,342.9957219,73.9088742,365.3342909,13.454908,16.3126283,2.4937812,49.3478904),(13466,'Alces_tibia.tif',242,8,204,2.4844262,95.7927641,112.6514642,1.8,95.6815675,112.5973701,0.9093578,2.150067,3.1829938,2.1610585,5.0441361,0.2578394,1.5847144,1.0051122,2.2175911,4.4038563,6.3378741,2.1587989,16.974915),(13467,'Alces_tibia.tif',242,8,205,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(13468,'Alces_tibia.tif',242,8,206,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(13469,'Alces_tibia.tif',242,8,207,0.060562,25.0430853,145.195106,1.8,25.136683,145.195106,0.0706847,0.0438545,0.6193901,0.0006675,0.0093458,0.0000503,0.0150887,0.0152206,0.016126,10.4585569,142.0662868,3.1193191,299.5833046),(13470,'Alces_tibia.tif',242,8,208,0.1829593,25.3164942,145.1308389,1.8,25.4530888,145.0896374,0.0967473,0.2855621,1.4018685,0.0049769,0.0736955,0.0002845,0.0525694,0.0174284,0.0560468,10.7738474,142.4260061,3.1169063,300.5776721),(13471,'Alces_tibia.tif',242,8,209,5.7105398,80.7091594,134.7800134,1.8,83.724849,134.2500482,-0.184971,4.0204361,57.0583687,18.4467501,1841.1944964,0.032194,32.2686144,4.588246,32.5918782,8.085926,9.9994517,2.9648838,29.6457827),(13472,'Alces_tibia.tif',242,8,210,45.617614,85.07107,133.9581758,1.8,85.1921245,133.9417603,-0.1883001,8.6452186,61.496433,684.2883105,3307.7706181,0.2664056,53.7880078,79.1522277,64.9146219,17.5030935,18.3520752,0.3520443,58.8297154),(13473,'Alces_tibia.tif',242,8,211,97.0608243,86.036338,134.1535437,1.8,87.0200646,134.5659276,-0.0451977,12.0353551,61.8631492,2800.8299665,6924.3972634,0.033024,111.9308887,232.716853,155.824346,22.3732687,22.9567563,0.6986598,73.9365324),(13474,'Alces_tibia.tif',242,8,212,370.5822381,103.2455435,135.2017029,1.8,100.9434954,134.2899845,0.0454545,13.5562174,78.1488172,13157.7523858,81067.663652,0.1275226,1037.3498476,970.6064734,1188.6843418,25.312464,26.0488226,0.5543075,84.2421184),(13475,'Alces_tibia.tif',242,8,213,529.3330044,107.3319698,134.7807853,1.8,100.8162891,134.4348679,-0.0035793,14.6274007,82.7581178,19592.1008588,118906.8024119,0.0011299,1436.7992598,1339.4109647,1662.0050101,27.421836,27.9685193,1.8249211,90.8261441),(13476,'Alces_tibia.tif',242,8,214,532.3801662,107.0549747,134.911655,1.8,100.7892432,134.7049112,-0.012917,15.3297919,82.5670435,19536.6018736,120767.114193,0.0148035,1462.6551847,1274.4205546,1689.5572257,31.9534336,58.954547,2.7500125,245.3039326),(13477,'Alces_tibia.tif',242,8,215,532.7491186,106.8760233,135.0027791,1.8,100.6285977,134.8606964,-0.0166752,15.8330168,82.4193347,19302.2131409,120398.8391636,0.0246868,1460.8081897,1219.1115205,1686.1280228,29.4240274,57.778228,3.0134641,182.0288349),(13478,'Alces_tibia.tif',242,8,216,532.4403911,106.6810379,135.0633724,1.8,100.4642148,134.9464972,-0.0185575,15.6050863,82.2390513,19091.0045724,120218.7865695,0.0305567,1461.8211749,1223.3834676,1685.4904475,29.3822659,57.778228,3.0134641,180.8285272),(13479,'Alces_metatarsus.tif',242,10,1,23.5403496,89.7651028,157.5299425,1.8,89.9493743,157.4502844,0.0519315,2.9269894,37.7792342,51.6693733,11241.8274409,0.0105714,297.5663135,17.6527367,298.5511459,10.283193,164.1519963,3.1369523,344.4840801),(13480,'Alces_metatarsus.tif',242,10,2,22.9011028,89.5914676,157.6464288,1.8,90.22084,157.5946057,0.0508894,3.8894251,37.948593,46.7641932,11185.7422028,0.0098761,294.7603932,12.0234204,295.5661567,9.902334,163.7698129,3.1392671,343.4068482),(13481,'Alces_metatarsus.tif',242,10,3,22.2998338,89.1831828,157.7586907,1.8,89.7323007,157.7325948,0.0497296,2.9217032,38.3719072,41.8426008,11075.535309,0.0091838,288.6365601,14.3213044,289.4593875,10.283193,163.392506,0.0069929,343.2761581),(13482,'Alces_metatarsus.tif',242,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(13483,'Alces_metatarsus.tif',242,10,5,3.0262572,88.6533739,146.2657712,1.8,88.8353617,146.2117701,-0.1753697,2.0739034,2.4712221,1.6858694,4.7248365,0.0153535,1.9119433,0.8128968,2.5581541,4.189449,5.453071,0.4324078,16.0119334),(13484,'Alces_metatarsus.tif',242,10,6,22.2417244,89.0150294,146.2660025,1.8,88.7835783,146.5527614,-0.5329288,3.9598103,8.5898509,47.4061987,128.8579022,0.9568506,15.0011803,11.9718359,20.513219,7.0020075,9.2979531,0.610726,26.0608129),(13485,'Alces_metatarsus.tif',242,10,7,48.138843,88.6774795,146.8451956,1.8,88.5293035,147.0676364,-0.5322402,5.4078122,10.22592,155.1321674,749.0039704,2.0661246,73.2456321,28.6866782,88.2997043,8.8063508,18.8130468,0.5543075,47.2358039),(13486,'Alces_metatarsus.tif',242,10,8,69.3672143,88.9882133,146.967675,1.8,88.8352517,147.2092684,-0.5049835,5.5061871,11.3000302,258.3114367,1597.5240023,2.7059648,141.3734272,46.9129418,163.5058227,9.3203932,22.3184674,0.4407508,54.2760896),(13487,'Alces_metatarsus.tif',242,10,9,93.2907691,89.6176398,146.8809803,1.8,89.9513102,147.1427412,-0.4318017,11.9161253,30.0116424,438.61758,3275.8277346,2.7232946,109.1518981,36.8087417,116.1597074,10.5588479,26.3096118,0.3858827,94.8095445),(13488,'Alces_metatarsus.tif',242,10,10,145.8791525,94.5309576,146.3274978,1.8,97.0111462,146.2305763,-0.1193575,8.1555054,29.5482273,1196.0212031,20005.1199263,0.3447291,677.0328294,146.6520033,717.2762465,14.4658387,47.3017065,0.2274023,159.9186546),(13489,'Alces_metatarsus.tif',242,10,11,245.446258,98.4576038,145.7631974,1.8,99.226266,145.7301475,-0.0388734,9.3860921,26.6028605,2698.2853886,43095.2642551,0.0617863,1619.9485081,287.4769774,1710.1588568,1.142577,1.904295,0.9272952,5.0706457),(13490,'Alces_metatarsus.tif',242,10,12,311.5065585,99.1366683,145.4820174,1.8,99.3242961,145.4676086,0.0050038,10.9961588,26.5331598,4619.5819463,56859.1702091,0.0012997,2142.947567,420.1086957,2276.7001422,21.4889468,49.4501084,0.2094796,244.8417205),(13491,'Alces_metatarsus.tif',242,10,13,366.1538676,99.1251316,144.7885635,1.8,99.5265426,144.3533485,0.049189,14.2617649,26.4482536,7913.5710419,71936.756327,0.1475362,2719.9057259,554.8802053,2911.6463741,0.761718,1.0772319,2.3561945,2.1544639),(13492,'Alces_metatarsus.tif',242,10,14,475.1367085,100.0832365,142.5810582,1.8,100.3117883,141.4775724,0.0131224,37.9775964,26.7536666,21134.1308055,106011.2789822,0.0136356,3962.495326,556.4894263,3240.2988469,1.7495131,4.6333497,1.4056476,12.2033434),(13493,'Alces_metatarsus.tif',242,10,15,644.2423234,101.6159535,138.5604778,1.8,101.5918272,136.627042,-0.163553,33.8681134,26.9110454,64665.0857592,143975.4000472,2.8466819,5350.0485749,1909.3205744,5873.0010993,2.0450628,3.5113465,2.2794226,8.5254435),(13494,'Alces_metatarsus.tif',242,10,16,909.4261097,101.44322,133.3610612,1.8,101.1958834,132.7821269,-0.3255105,30.4170229,29.4103797,137821.4942388,211097.0291443,15.5007492,7177.6369814,4531.0645547,11007.7774981,53.3920783,60.0997433,0.9247604,362.8117514),(13495,'Alces_metatarsus.tif',242,10,17,1199.5249578,100.2099831,129.0454273,1.8,100.1101996,129.0985526,-0.2289713,32.6953169,28.2446108,228806.3981486,250683.3551694,10.2995224,8875.4402316,6998.1398001,14604.6917469,55.0418937,60.6810108,1.022842,295.3857767),(13496,'Alces_metatarsus.tif',242,10,18,1321.0067139,99.5822009,126.9313153,1.8,100.0360566,128.581655,1.1056237,30.9568187,32.1917393,253999.8158389,289256.4179001,175.8653221,8985.4237199,8204.9715151,16097.3886368,54.462837,61.6944559,0.9964915,320.5317585),(13497,'Alces_metatarsus.tif',242,10,19,1308.8642789,99.677377,126.703365,1.8,100.0783386,128.6401937,1.1699887,30.8084191,32.7917367,246596.3800838,299038.8721489,184.9367464,9119.3362294,8004.1880419,15555.0427733,53.7883351,61.2425535,1.815775,294.3785337),(13498,'Alces_metatarsus.tif',242,10,20,1279.4637209,99.9054505,126.8752781,1.8,100.233149,128.6474539,1.2397193,30.0932739,32.6111699,236211.0446709,294359.9042131,190.7114987,9026.3521719,7849.2969926,16002.7206856,0.380859,0.538616,2.3561945,1.0772319),(13499,'Alces_metatarsus.tif',242,10,21,1236.1469423,100.0918541,127.1971063,1.8,100.317589,128.819105,1.2862929,29.3131855,31.8741043,222847.2068723,286306.3318713,189.7935228,8982.4118295,7602.2855618,15228.3073964,52.6151315,60.7813259,1.8112158,322.8486233),(13500,'Alces_metatarsus.tif',242,10,22,1200.5365967,100.1727825,127.4559675,1.8,100.3916509,128.9732227,1.312073,28.7684685,31.5611815,210308.7380362,277001.1927972,186.9920818,8776.6420622,7310.390467,14899.3161846,0.761718,1.0772319,2.3561945,2.1544639),(13501,'Alces_metatarsus.tif',242,10,23,1170.5608352,100.1819213,127.6581009,1.8,100.3871318,129.0864365,1.3214721,27.8620373,31.0725729,199195.8247729,267553.8247327,183.215177,8610.6105596,7149.3632163,14109.1193966,1.142577,2.9005357,1.1659045,6.2785678),(13502,'Alces_metatarsus.tif',242,10,24,1126.5485907,100.2021841,127.8189839,1.8,100.3027119,129.1125324,1.324305,28.0800312,30.9016563,188076.7702716,255477.7238756,176.5794729,8267.4443457,6697.8832362,13894.6533764,0.761718,1.7032532,2.0344439,3.6778999),(13503,'Alces_metatarsus.tif',242,10,25,1085.1442777,100.2994076,128.1136244,1.8,100.3045317,129.2916177,1.329608,27.573297,30.3850269,177324.7711886,241903.1493126,170.5390083,7961.2616581,6431.0325648,13472.1823422,0.8445709,1.904295,2.2142974,3.9934138),(13504,'Alces_metatarsus.tif',242,10,26,1040.4668087,100.2934975,128.3626648,1.8,100.2478806,129.4857192,1.3238105,27.2104211,30.1708398,167503.4684552,229274.0031513,163.0460675,7599.1919537,6155.8572662,12607.9799251,1.4227749,2.9005357,1.1659045,7.1326977),(13505,'Alces_metatarsus.tif',242,10,27,996.5342557,100.2421423,128.5050485,1.8,100.2254715,129.5349801,1.3241993,27.3974185,29.9480608,159184.6884316,216483.1913453,156.192223,7228.621327,5810.2075723,11908.6985808,0.9948153,3.5113465,1.3521274,7.8020038),(13506,'Alces_metatarsus.tif',242,10,28,956.6466756,100.2510056,128.6408953,1.8,100.2160096,129.5844835,1.3191016,27.4319393,30.1116755,152052.305852,206374.1314114,149.5519805,6853.6249727,5542.8930471,11347.1416878,1.142577,3.1406438,1.3258177,8.1175177),(13507,'Alces_metatarsus.tif',242,10,29,922.4813713,100.1866433,128.7426092,1.8,100.1867843,129.7369381,1.318584,25.6507902,30.1261286,144751.6504695,198081.7974314,144.1725145,6575.0830467,5643.1653496,11197.995308,1.142577,7.7023966,1.4219064,17.9815734),(13508,'Alces_metatarsus.tif',242,10,30,891.8594621,100.1247506,128.7816987,1.8,100.1267061,129.6071418,1.3114766,25.3023845,29.5460197,138170.1209735,190325.5751547,138.8695336,6441.6654692,5460.7549386,10452.5475514,1.838661,12.9715901,1.6295521,35.7941785),(13509,'Alces_metatarsus.tif',242,10,31,870.4334662,100.0794378,128.82672,1.8,100.127889,129.5793948,1.3018808,25.0812577,30.1363674,132849.6557589,183637.9424863,134.8317273,6093.5659541,5296.7700947,10426.2325079,1.142577,8.0792394,1.4288993,18.2046755),(13510,'Alces_metatarsus.tif',242,10,32,847.9902931,100.0015115,128.8473634,1.8,100.0954334,129.4899049,1.3010115,24.7471706,29.0627504,128127.0271634,177302.6677416,131.292206,6100.6844006,5177.441467,10436.7503314,1.523436,12.6603398,1.4501727,29.776991),(13511,'Alces_metatarsus.tif',242,10,33,828.4462576,99.9852714,128.8560859,1.8,99.9936673,129.5380717,1.3059811,24.4332036,29.6502439,123088.6511134,171317.9108109,128.6158566,5777.959586,5037.7614484,9857.3093689,1.7617601,15.3103423,1.670465,37.9869206),(13512,'Alces_metatarsus.tif',242,10,34,810.7387322,99.9044979,128.9099748,1.8,99.8922963,129.5629558,1.3063201,24.7367231,29.6870669,118986.747858,166870.1063544,125.8898997,5620.9697901,4810.1257212,9595.3099748,1.904295,18.2970942,1.5291537,48.9282083),(13513,'Alces_metatarsus.tif',242,10,35,798.0737966,99.847756,128.9747278,1.8,99.8150267,129.6361983,1.3068442,24.5906064,29.7374166,115264.5231222,163101.622208,123.9584603,5484.7273511,4687.3395905,9315.2383127,2.2521983,12.6603398,1.4501727,36.3327945),(13514,'Alces_metatarsus.tif',242,10,36,784.7731307,99.8101924,128.9906284,1.8,99.8412182,129.6226288,1.3058156,24.4611921,29.1364614,111866.4092439,159854.1224094,121.8246873,5486.3945353,4573.2198495,9269.9818603,2.0631581,17.5567324,1.5056712,43.8192843),(13515,'Alces_metatarsus.tif',242,10,37,773.5530167,99.7418572,128.992214,1.8,99.8394504,129.5737797,1.306015,23.9255611,28.585738,109013.4891807,157140.5729753,120.0959134,5497.1669008,4556.3608213,9310.5319242,2.2006745,16.5355978,1.4321566,39.7717369),(13516,'Alces_metatarsus.tif',242,10,38,763.6070885,99.7006322,129.0196724,1.8,99.8362141,129.5613981,1.3055613,24.1507335,28.2662007,106263.8669434,154802.7461392,118.5226001,5476.6025323,4400.0264768,9167.5778089,1.519725,7.3259691,1.4141944,19.5974213),(13517,'Alces_metatarsus.tif',242,10,39,757.4150589,99.6509428,129.0584448,1.8,99.7732797,129.528146,1.3080435,23.7016808,28.5297632,104039.9105907,153104.6018848,117.7193664,5366.4869571,4389.5583429,8893.7574974,1.8194184,11.071146,1.5019398,29.553889),(13518,'Alces_metatarsus.tif',242,10,40,753.0409903,99.5929602,129.0917218,1.8,99.7880801,129.5513728,1.3160032,23.7531578,29.0842381,102096.4690994,151658.8336239,117.5337885,5214.4681575,4298.2272058,8716.3777904,1.7964556,16.4872801,1.4550371,43.6344605),(13519,'Alces_metatarsus.tif',242,10,41,753.1028358,99.5841854,129.1549102,1.8,99.7769795,129.761821,1.3290258,23.4963189,28.0788561,100214.4092072,150475.192989,118.3221333,5359.0214851,4265.1110367,8663.4271306,4.5909977,34.6414239,1.3151514,90.4623386),(13520,'Alces_metatarsus.tif',242,10,42,751.8312434,99.5027165,129.210442,1.8,99.7253052,129.9439172,1.3358893,22.7020102,28.6767902,98336.5301824,149006.2947832,118.5169532,5196.0590391,4331.6221402,8491.3012466,2.4307344,15.7815396,1.4254863,43.6885942),(13521,'Alces_metatarsus.tif',242,10,43,747.8925113,99.4225954,129.2321301,1.8,99.6472894,129.987819,1.3382645,23.1233804,28.3658985,96472.4562186,147477.6958756,118.0294659,5199.119489,4172.074088,8488.5573497,1.904295,3.1406438,1.3258177,9.8257775),(13522,'Alces_metatarsus.tif',242,10,44,745.4019414,99.3659342,129.3239324,1.8,99.6384498,130.0844907,1.3423404,22.4220047,29.1243977,95196.5591654,146048.3237833,117.861663,5014.638418,4245.6756469,8226.2757684,3.0583077,16.6579559,1.3868529,45.8813363),(13523,'Alces_metatarsus.tif',242,10,45,742.7568674,99.2923346,129.3957181,1.8,99.561346,130.1201493,1.3496753,22.6592419,28.134297,93945.3704718,144357.8158227,117.8380288,5131.0262311,4146.0067725,8417.312111,0.380859,0.538616,2.3561945,1.0772319),(13524,'Alces_metatarsus.tif',242,10,46,741.0901579,99.2149404,129.4778618,1.8,99.4952968,130.2017666,1.3525799,22.4513731,28.1440139,92815.5822245,143129.8397642,117.7262024,5085.6228266,4134.0715168,8311.7608275,0.380859,0.538616,2.3561945,1.0772319),(13525,'Alces_metatarsus.tif',242,10,47,742.8711521,99.1260146,129.5675296,1.8,99.42782,130.290434,1.3563114,21.8670342,28.6102549,92029.9700079,142299.0758931,118.2028543,4973.7087725,4208.6169175,8121.5357577,39.1401915,55.9253542,1.8537732,287.714463),(13526,'Alces_metatarsus.tif',242,10,48,744.4026102,99.0485673,129.7052871,1.8,99.3889902,130.4900535,1.3574927,21.5054107,28.0996649,91104.9481326,141524.6615453,118.5073367,5036.5248907,4236.3733156,8132.5102545,3.7477265,27.945813,1.2662854,78.666921),(13527,'Alces_metatarsus.tif',242,10,49,747.4478562,99.0316,129.7599766,1.8,99.297953,130.6046306,1.3647312,27.9701337,28.0141297,89989.936541,140734.0944323,119.3592988,5023.6825507,3217.3581162,7847.9994825,4.7617184,34.7396858,1.3045443,89.9778562),(13528,'Alces_metatarsus.tif',242,10,50,746.8822351,98.9650295,129.8100016,1.8,99.1766772,130.5821405,1.3689828,22.9462757,27.6600365,88874.0593549,139230.2955945,119.4789057,5033.6266027,3873.1365695,8033.3000984,4.1849623,30.7176419,1.2686511,90.2933702),(13529,'Alces_metatarsus.tif',242,10,51,747.7994133,98.9260138,129.8728199,1.8,99.1290184,130.6403029,1.3657534,27.2438439,27.8754385,87861.1819256,138559.7062793,119.4663549,4970.6735972,3224.9921164,7811.6546701,5.2765799,34.4756293,1.2909792,97.8722719),(13530,'Alces_metatarsus.tif',242,10,52,749.1221701,98.876154,129.9409483,1.8,99.1087756,130.7375439,1.3657845,22.071183,27.5968401,87091.1231876,138154.2849965,119.6792203,5006.1631847,3945.9200382,7692.8586421,4.6307466,37.0452683,1.3108562,107.9211514),(13531,'Alces_metatarsus.tif',242,10,53,747.3562966,98.8218675,129.9632728,1.8,99.0358613,130.6662996,1.3672311,21.8869801,27.6853356,86280.3483023,137334.7470094,119.4686974,4960.5592295,3942.085569,8028.7487215,3.7000472,26.1575558,1.2904967,74.4662606),(13532,'Alces_metatarsus.tif',242,10,54,746.973531,98.7762824,130.024809,1.8,99.0057795,130.716624,1.3670996,21.9731804,27.7363664,85379.1274346,136382.9683155,119.4010248,4917.117348,3885.6062639,7914.4169353,4.0876618,31.0370877,1.3228415,86.8768506),(13533,'Alces_metatarsus.tif',242,10,55,746.1005282,98.7203152,130.107685,1.8,98.9869931,130.8426133,1.365597,21.7759899,27.4375145,84504.1833243,135314.535523,119.1871851,4931.7344599,3880.6127202,7428.2575671,4.3314855,31.3162456,1.3376165,88.9389026),(13534,'Alces_metatarsus.tif',242,10,56,746.1067699,98.6656233,130.1901454,1.8,98.8784131,130.90377,1.3672887,21.764452,27.502954,83634.7809881,134444.9301252,119.2717868,4888.3814568,3842.7239556,7720.7132772,1.6094914,5.5453907,1.2924967,14.7115994),(13535,'Alces_metatarsus.tif',242,10,57,746.9646959,98.7311226,130.3005855,1.8,98.9493378,131.1901654,1.369529,21.4770116,27.548517,82662.6145862,134159.7723603,119.5187717,4869.9453572,3848.8881023,7619.0165622,4.0759311,34.3702828,1.3473197,95.9026318),(13536,'Alces_metatarsus.tif',242,10,58,745.1261198,98.7106698,130.3752778,1.8,98.9610645,131.3297559,1.3697343,21.5779726,27.3966534,81996.9986886,133653.4051587,119.234571,4878.4573524,3800.0325743,7616.6029451,0.380859,1.2043819,2.8198421,2.3775659),(13537,'Alces_metatarsus.tif',242,10,59,745.0289779,98.6537365,130.4130416,1.8,98.8933164,131.3278321,1.373742,21.4890802,27.8505974,81473.2455897,133137.6499174,119.4119518,4780.423493,3791.3789195,7503.0352726,3.4653628,25.2460971,1.3734008,69.8800972),(13538,'Alces_metatarsus.tif',242,10,60,747.4570869,98.592764,130.4769041,1.8,98.8111742,131.3734807,1.3749106,21.5517174,27.7231098,81121.2824687,133415.1739768,119.8568704,4812.4173198,3764.028688,7452.4983905,0.380859,0.538616,2.3561945,1.0772319),(13539,'Alces_metatarsus.tif',242,10,61,747.7824904,98.5703784,130.5505158,1.8,98.8276321,131.4694023,1.3723498,26.8458917,27.6663227,80642.302061,133417.9220043,119.786434,4822.3944884,3003.8973136,7386.6717183,3.3558298,26.2350763,1.4104209,72.1652512),(13540,'Alces_metatarsus.tif',242,10,62,746.3869431,98.5269431,130.6213445,1.8,98.7751314,131.5124241,1.3727679,27.4569951,27.5284942,80086.6965133,133152.5449374,119.5829674,4836.8989589,2916.8048487,7326.641899,2.8021768,26.2985828,1.3961241,69.4721714),(13541,'Alces_metatarsus.tif',242,10,63,744.5288507,98.4827631,130.6649295,1.8,98.6764682,131.4485092,1.3710222,27.4218551,27.5108328,79555.5423645,132561.2507992,119.2013538,4818.5110101,2901.1728829,7299.4701305,3.3725494,26.9765417,1.3429393,73.0193811),(13542,'Alces_metatarsus.tif',242,10,64,746.0448804,98.44603,130.7212443,1.8,98.6799762,131.5192604,1.370557,28.0498481,28.1325215,79317.4748047,132612.8285351,119.4215496,4713.8621647,2827.7327769,7113.0118284,3.2605282,18.7551307,1.3455195,55.6147019),(13543,'Alces_metatarsus.tif',242,10,65,750.5207942,98.4634959,130.7968145,1.8,98.6682168,131.7994979,1.3743488,21.5192037,27.9541909,78994.3382938,132554.6482224,120.3212725,4741.8524402,3670.8764533,7012.9885342,4.8252029,33.9050085,1.3094703,96.256424),(13544,'Alces_metatarsus.tif',242,10,66,749.6799231,98.4096817,130.8987297,1.8,98.5938551,132.0046909,1.3785362,21.2612575,27.5252729,78516.5203545,131807.8474507,120.3847571,4788.6118294,3692.938693,7067.8514474,39.4960656,55.9461,1.9399252,370.8751355),(13545,'Alces_metatarsus.tif',242,10,67,747.2527811,98.3856079,131.0073335,1.8,98.5893644,132.0484962,1.3762084,31.931659,27.7448247,78157.3757383,130738.127609,119.8856289,4712.1626829,2447.6453185,6495.9277854,38.9753895,56.1660503,1.9311543,332.1806306),(13546,'Alces_metatarsus.tif',242,10,68,748.7298661,98.3414307,131.0386433,1.8,98.5206352,131.9981911,1.377251,22.1533772,27.7941705,77928.1329352,130858.4515762,120.1718457,4708.1258192,3517.663789,7131.5213634,0.380859,0.538616,2.3561945,1.0772319),(13547,'Alces_metatarsus.tif',242,10,69,748.6243726,98.2834343,131.0966189,1.8,98.4429685,131.9891373,1.3820825,21.514387,27.6243058,77619.5633547,129793.7507892,120.3797799,4698.5343923,3607.7980517,7135.3360452,38.6995734,56.1660503,1.9311543,356.0935471),(13548,'Alces_metatarsus.tif',242,10,70,749.5532429,98.2024691,131.1203144,1.8,98.3333648,131.9851533,1.3861618,21.2086078,27.5787363,77379.4286751,128672.4928111,120.7150157,4665.6413558,3648.4916675,7083.9762552,4.3669689,32.8025524,1.300471,93.5633442),(13549,'Alces_metatarsus.tif',242,10,71,747.3733074,98.1334672,131.1224007,1.8,98.2618652,131.9475972,1.3951745,21.1518565,27.2804038,76946.0086215,127089.6422682,120.7596761,4658.6422687,3637.7898313,7087.7465461,4.2250755,33.8536308,1.2739517,87.0616744),(13550,'Alces_metatarsus.tif',242,10,72,745.7909927,98.0622002,131.1693076,1.8,98.1888815,131.9664298,1.4011827,20.9798216,27.1446486,76462.9672769,125370.9180041,120.7567419,4618.6237297,3644.5956816,7077.5122811,3.9011755,35.3132498,1.2865708,95.271604),(13551,'Alces_metatarsus.tif',242,10,73,745.6324887,98.0578563,131.2267175,1.8,98.1302002,132.1239262,1.4070387,20.9185851,27.1773735,75891.5881477,124163.8735207,120.9692126,4568.64876,3627.950353,7134.0880863,38.6704995,54.8026854,1.8815583,347.9694619),(13552,'Alces_metatarsus.tif',242,10,74,741.6098892,98.0111365,131.2983107,1.8,98.0743195,132.2479877,1.4074698,20.7961712,27.1732762,75298.3058868,123237.1322475,120.3337187,4535.2327535,3620.7773544,7052.4515301,38.6541401,54.687427,1.8749276,338.7747123),(13553,'Alces_metatarsus.tif',242,10,75,738.7280702,97.95359,131.3742383,1.8,97.9593821,132.3338811,1.4093889,21.0217749,27.0934173,74950.5837137,122177.4224655,119.9415009,4509.4873438,3565.3784793,7013.6913087,38.7728288,54.687427,1.8749276,375.0916513),(13554,'Alces_metatarsus.tif',242,10,76,735.3344319,97.891258,131.4432567,1.8,97.9274898,132.3810401,1.4119462,21.3510381,27.0159186,74559.8278178,120969.4015358,119.4891677,4477.708244,3492.0937982,6965.8697742,38.6740214,54.3561986,1.8548707,330.6413392),(13555,'Alces_metatarsus.tif',242,10,77,732.7885218,97.8273409,131.4763768,1.8,97.859884,132.3701533,1.4138213,21.3226973,26.8597845,74103.2771247,120098.9254857,119.1465966,4471.328701,3475.3237867,6997.466654,38.6569656,54.0994089,1.8636017,333.8347567),(13556,'Alces_metatarsus.tif',242,10,78,731.5336765,97.7714697,131.5275161,1.8,97.8050896,132.4076872,1.4134903,20.7857644,26.4623518,73802.3503631,119472.2659249,118.9300935,4514.8015094,3550.6199764,6978.3000948,38.7945032,53.7240737,1.9104822,332.2030534),(13557,'Alces_metatarsus.tif',242,10,79,731.3907328,97.7053434,131.5766638,1.8,97.7515783,132.4551388,1.4119275,20.7247869,26.6727358,73784.8855983,119199.547156,118.8476207,4468.9659084,3560.2240983,6971.172696,38.7804544,53.6795056,1.8364261,287.8292978),(13558,'Alces_metatarsus.tif',242,10,80,729.4408171,97.6414508,131.6128231,1.8,97.7086913,132.4208131,1.4113636,21.4595729,26.7849083,73527.5346536,118759.4302989,118.5093142,4433.8188198,3426.327955,6946.6280895,37.8672224,53.4940836,1.9195673,336.0499217),(13559,'Alces_metatarsus.tif',242,10,81,731.1639217,97.621083,131.69763,1.8,97.6351079,132.6898914,1.4117153,21.1951615,26.7027063,73111.1163608,118299.5278981,118.8026787,4430.2448804,3449.4248279,6931.4214127,38.3626731,53.5184823,1.8520285,331.4954691),(13560,'Alces_metatarsus.tif',242,10,82,729.1162048,97.5605315,131.7679543,1.8,97.5522001,132.8273663,1.4126095,21.2224889,27.0798797,72627.3873633,117608.6453392,118.5038575,4343.0268756,3422.1899136,6897.3814333,38.4290452,53.3705641,1.8677213,323.585198),(13561,'Alces_metatarsus.tif',242,10,83,726.39667,97.5111323,131.8417792,1.8,97.5134273,132.9605214,1.4098377,20.9435815,26.5871019,72085.8407012,116387.6218178,117.9565645,4377.5971672,3441.9060845,6843.916012,38.8122388,53.1363143,1.9220168,314.0142333),(13562,'Alces_metatarsus.tif',242,10,84,726.3360991,97.4673416,131.9120758,1.8,97.4834908,133.0038379,1.4080907,20.9697981,26.873349,71800.5270951,115470.5973451,117.8794659,4296.8443251,3423.9970622,6810.4919948,38.4350614,53.0064883,1.9152702,324.885532),(13563,'Alces_metatarsus.tif',242,10,85,725.7087644,97.4142245,131.9763336,1.8,97.3856463,133.0648056,1.4053911,29.1872284,26.4920085,71619.9428321,114624.66446,117.6724313,4326.7638381,2453.8110241,6228.0065565,38.493754,52.8736003,1.8857133,316.799725),(13564,'Alces_metatarsus.tif',242,10,86,725.8043239,97.3670382,132.0097939,1.8,97.3746203,133.1481144,1.4047909,20.6236139,26.6269223,71506.3163495,114490.9467116,117.6643035,4299.8190187,3467.2059274,6810.477456,38.0859,52.6812121,1.849096,294.5316468),(13565,'Alces_metatarsus.tif',242,10,87,724.2010863,97.3208697,132.0137561,1.8,97.3696079,133.0074837,1.4048562,20.9544713,26.2862575,71440.20421,113689.0845376,117.4069611,4325.0388353,3409.3059725,6487.0405596,37.4803565,52.5309363,1.8650309,291.4306411),(13566,'Alces_metatarsus.tif',242,10,88,723.0882616,97.283687,132.0556578,1.8,97.3202115,133.0251536,1.4034099,20.6059887,26.4452602,71270.2972741,113015.4691908,117.1695192,4273.5623857,3458.7176692,6551.2761078,37.8745836,52.6316272,1.8948352,320.1686785),(13567,'Alces_metatarsus.tif',242,10,89,724.5736981,97.2906173,132.146875,1.8,97.2669474,133.1499304,1.4027886,21.2385715,26.3572828,70962.1310342,112239.0000041,117.3855262,4258.36764,3341.1913311,6711.7072443,38.4152765,52.6316272,1.8948352,324.7548418),(13568,'Alces_metatarsus.tif',242,10,90,724.7580481,97.2518955,132.185573,1.8,97.2248028,133.1957912,1.4026788,20.6077462,26.3261599,70673.7987991,111871.8734952,117.4110171,4249.4565897,3429.4773431,6716.6068299,38.0405538,52.5198899,1.9108934,286.0220586),(13569,'Alces_metatarsus.tif',242,10,91,722.7118256,97.2131021,132.2340888,1.8,97.172282,133.2425176,1.3991249,20.8294168,26.3027819,70242.4244007,111057.2318235,116.9368596,4222.2618155,3372.2703341,6676.7621497,38.0859,52.5116036,1.8879598,299.7105597),(13570,'Alces_metatarsus.tif',242,10,92,719.8102266,97.1801502,132.2958249,1.8,97.1683029,133.3025955,1.3967842,20.5720805,26.2593331,69912.4319664,109853.8024285,116.3722206,4183.4193511,3398.4133059,6629.7433827,38.466759,52.3940737,1.9040406,324.193803),(13571,'Alces_metatarsus.tif',242,10,93,718.5792052,97.135093,132.3335743,1.8,97.146878,133.2763381,1.3911624,20.8994324,26.1898276,69736.4063955,109016.2140415,115.9400285,4162.5403513,3336.7607774,6631.4311385,38.2264486,52.1498757,1.8902374,302.9646784),(13572,'Alces_metatarsus.tif',242,10,94,717.9517825,97.0829281,132.3891828,1.8,97.1244289,133.4079044,1.38816,20.5855757,26.1580645,69627.5403579,108205.5404188,115.7114772,4136.6034714,3382.3460393,6602.8261318,38.1014455,52.0343164,1.9064349,305.61948),(13573,'Alces_metatarsus.tif',242,10,95,718.566502,97.0401579,132.4268418,1.8,97.0371103,133.3754133,1.3866785,20.9984725,26.2052392,69636.7910237,107457.3441555,115.7469248,4100.605355,3316.2788897,6578.1764828,37.6533676,52.1095287,1.8370484,298.378515),(13574,'Alces_metatarsus.tif',242,10,96,717.4257216,97.003377,132.4913357,1.8,96.9565798,133.3840454,1.3797067,20.9188059,26.1823268,69514.2546874,105822.2885009,115.2576779,4041.7449969,3323.0508079,6521.9823005,38.1295824,51.9492234,1.8531242,300.9409047),(13575,'Alces_metatarsus.tif',242,10,97,717.7121364,96.9856016,132.5135124,1.8,96.9605561,133.5439929,1.3809185,20.8893018,26.1581273,69337.7875985,104627.3000785,115.3575881,3999.8008652,3319.2965523,6482.7443103,38.0846148,51.6917011,1.8622531,288.7534167),(13576,'Alces_metatarsus.tif',242,10,98,716.4964996,96.9273012,132.5167849,1.8,96.9209665,133.6237536,1.3816688,21.2561701,26.0906597,69153.3505037,104454.6211677,115.195349,4003.525488,3253.330687,6463.471749,37.8602878,50.9070449,1.835736,274.4114648),(13577,'Alces_metatarsus.tif',242,10,99,714.7746257,96.8766714,132.5680717,1.8,96.881477,133.6777996,1.3785087,20.7147299,26.064108,69026.7389042,103492.8183277,114.7783817,3970.7024745,3332.2538757,6427.9728114,38.0859,50.7457995,1.8521888,276.6583406),(13578,'Alces_metatarsus.tif',242,10,100,714.0662367,96.8183781,132.6075291,1.8,96.8362435,133.7202788,1.3745057,21.12164,25.8295352,69014.1025013,102741.2133472,114.4841338,3977.6640352,3267.4594566,6401.1090613,38.1332602,50.598376,1.9163519,291.2616727),(13579,'Alces_metatarsus.tif',242,10,101,712.7714797,96.7694789,132.6024467,1.8,96.7904183,133.6524015,1.3692954,21.10684,25.9476161,68940.5907009,102076.613739,114.0367756,3933.9495938,3266.2677408,6366.9700247,37.9189269,50.5051202,1.9330974,269.9942699),(13580,'Alces_metatarsus.tif',242,10,102,710.1515923,96.7455391,132.6411678,1.8,96.7954735,133.7178282,1.3656477,21.0976943,26.1523637,68836.8778623,101340.7285471,113.4468554,3875.012209,3262.76781,6134.8989266,0.380859,0.538616,2.3561945,1.0772319),(13581,'Alces_metatarsus.tif',242,10,103,707.61777,96.7023873,132.6721114,1.8,96.7209356,133.7127427,1.3666767,27.9877193,26.0487934,68946.3770501,100476.4384209,113.0903666,3857.2396436,2463.451072,5930.1039702,38.1428796,50.172301,1.8397115,274.6569898),(13582,'Alces_metatarsus.tif',242,10,104,707.1247198,96.6584498,132.6566231,1.8,96.6869555,133.7281583,1.3716642,31.2000264,25.7525678,68992.0122972,100419.1175766,113.2422238,3899.3827068,2211.2805769,5406.3996661,37.705041,50.0144874,1.9286757,264.569832),(13583,'Alces_metatarsus.tif',242,10,105,705.7998092,96.6715445,132.6630628,1.8,96.7576726,133.8784128,1.3693512,20.9905516,25.8313065,68699.4142416,99912.0982544,112.9239498,3867.8685546,3272.8732142,6321.7276156,38.253162,49.9085167,1.849096,267.6708376),(13584,'Alces_metatarsus.tif',242,10,106,703.3044481,96.6270598,132.6866885,1.8,96.6904465,133.9382622,1.3685685,20.936077,25.9648374,68313.1969492,99262.9138638,112.4886641,3822.9746009,3262.9416172,6318.1275708,38.6048526,49.9753189,1.8250169,266.093268),(13585,'Alces_metatarsus.tif',242,10,107,700.3878602,96.5768172,132.718209,1.8,96.6519131,134.0037548,1.3654171,21.0580315,26.1124258,68089.889332,98354.5608447,111.8763514,3766.5807636,3233.4403787,6267.3925657,38.0462594,50.0144874,1.856418,294.1619992),(13586,'Alces_metatarsus.tif',242,10,108,698.4468235,96.5311627,132.7361804,1.8,96.566221,133.9408227,1.3587996,20.5080943,26.0557829,67935.9208362,97378.8640776,111.2540408,3737.3225152,3312.6393859,6239.7003999,37.8947407,49.805233,1.8417432,306.1580959),(13587,'Alces_metatarsus.tif',242,10,109,696.1777021,96.5045736,132.7342237,1.8,96.5635548,133.9083945,1.3558093,20.7380212,25.9478983,67880.4991906,96556.3471074,110.7489098,3721.1625402,3273.2389779,6200.017968,2.8309389,22.1848324,1.3633001,60.5546574),(13588,'Alces_metatarsus.tif',242,10,110,695.0921738,96.4720408,132.7188079,1.8,96.5126382,133.8236259,1.3568158,20.7044432,26.0452095,67937.0362251,95833.5997179,110.6247214,3679.5096507,3281.278107,6131.7843899,2.8745061,21.9845064,1.3258177,57.0074477),(13589,'Alces_metatarsus.tif',242,10,111,694.3417194,96.4352142,132.6935569,1.8,96.4467178,133.7441729,1.3576593,21.0723252,26.0726802,68104.0442811,95435.7484723,110.5457221,3660.3735343,3231.9188117,6114.3320556,2.3792175,19.04295,1.2870022,48.0358001),(13590,'Alces_metatarsus.tif',242,10,112,692.5542637,96.4075584,132.6801851,1.8,96.4352529,133.7266482,1.3525957,20.8359133,25.5024406,68090.9508558,94900.6137883,110.0167819,3721.2365441,3267.9609416,6195.5122212,2.9413366,22.3541847,1.3299499,59.3850136),(13591,'Alces_metatarsus.tif',242,10,113,693.3401464,96.4203838,132.6681373,1.8,96.4576965,133.7806915,1.3556697,20.6705797,26.0311992,67938.8393422,94243.3553002,110.2907826,3620.4000645,3286.7408853,6093.2073771,2.5663285,19.3077108,1.3114646,45.7889244),(13592,'Alces_metatarsus.tif',242,10,114,693.7541645,96.3808025,132.6585813,1.8,96.428236,133.7911509,1.3556407,21.4595677,25.723894,67802.0054459,93686.7619648,110.3552398,3642.0132233,3159.5233642,6175.5199278,38.466759,49.1426192,1.821414,294.9237172),(13593,'Alces_metatarsus.tif',242,10,115,692.2621785,96.3383946,132.6583223,1.8,96.3754056,133.8011558,1.3576822,20.7433284,25.6746627,67649.7450235,93044.9616609,110.2157306,3623.9993831,3261.2772511,6106.8819888,3.267578,25.2460971,1.3734008,63.4167056),(13594,'Alces_metatarsus.tif',242,10,116,692.4363747,96.3141159,132.6480209,1.8,96.3873742,133.8166778,1.3552474,20.7008913,25.7853357,67626.0900943,92800.7159738,110.1266712,3598.9725762,3266.8202145,6054.7812045,38.0859,48.7052996,1.7835281,284.8365594),(13595,'Alces_metatarsus.tif',242,10,117,690.1781982,96.2759097,132.6288589,1.8,96.332547,133.7542559,1.3540338,20.6311247,25.8196442,67548.7801114,91979.6788267,109.7090366,3562.3914163,3274.1200981,6013.1996095,2.8272629,21.812284,1.359703,54.5374699),(13596,'Alces_metatarsus.tif',242,10,118,687.1649958,96.2480602,132.6092292,1.8,96.3056798,133.736078,1.3558594,20.9671457,25.752357,67369.6023203,91490.0285599,109.3175461,3552.6856298,3213.1031773,6018.2529484,2.190653,18.7551307,1.3455195,48.2589022),(13597,'Alces_metatarsus.tif',242,10,119,686.5805178,96.2195461,132.5878287,1.8,96.3023976,133.6974636,1.3522829,20.384409,25.5112961,67453.0903907,91214.1460844,109.0526779,3575.4414675,3309.0530287,6111.6080279,2.6024022,22.2664126,1.3465616,59.0694997),(13598,'Alces_metatarsus.tif',242,10,120,685.2378931,96.1761871,132.5664809,1.8,96.2502205,133.6578406,1.350204,20.846971,25.0403445,67439.6983581,90770.2951408,108.7384828,3624.9619184,3234.9878738,6084.5489963,2.2256903,18.8438626,1.3258177,49.7440599),(13599,'Alces_metatarsus.tif',242,10,121,683.9559711,96.1683085,132.5619645,1.8,96.2505354,133.7843898,1.3532611,20.6279547,25.2553014,67142.0173039,90025.4179613,108.6829037,3564.6146775,3254.9042505,6087.1570256,2.4079584,20.3251713,1.3439975,52.8833438),(13600,'Alces_metatarsus.tif',242,10,122,681.8495734,96.122,132.5648198,1.8,96.1897543,133.8477566,1.3536482,20.947748,25.0971437,66808.337041,89461.0418225,108.3667154,3564.5905717,3189.2849373,6047.5892047,3.2572183,21.6654882,1.3940875,59.4774255),(13601,'Alces_metatarsus.tif',242,10,123,679.6346931,96.0735474,132.55099,1.8,96.1561235,133.8025131,1.347142,20.9413978,25.6439719,66431.4186269,88756.3422775,107.7002638,3461.0996521,3172.2533109,5956.0155261,2.5802809,21.524431,1.3386925,57.3229616),(13602,'Alces_metatarsus.tif',242,10,124,677.6873708,96.0209979,132.5026295,1.8,96.0655738,133.6406036,1.3432298,20.9782096,25.3770943,66222.7763993,88144.9745581,107.1989931,3473.4069099,3156.741099,5993.2924696,2.4079584,18.7551307,1.3455195,45.2120302),(13603,'Alces_metatarsus.tif',242,10,125,678.1581356,95.9819883,132.4565842,1.8,96.0263402,133.5421748,1.343242,20.5795207,25.1455948,66228.3526557,87895.017081,107.274065,3495.4439402,3218.1678889,6003.1377329,2.7450275,20.0449098,1.3212094,51.3057742),(13604,'Alces_metatarsus.tif',242,10,126,678.4633196,95.9402273,132.4232981,1.8,96.0118914,133.474376,1.3423189,20.9198724,25.5617061,66287.2397119,87807.152972,107.2763704,3435.1053341,3168.6254302,5973.3024605,2.3132151,19.4088676,1.2924967,52.8833438),(13605,'Alces_metatarsus.tif',242,10,127,678.2780466,95.9056571,132.3857536,1.8,96.004611,133.397943,1.3375962,20.5183082,25.2333161,66253.4363705,87573.1977627,107.0092604,3470.5386051,3228.9911875,5978.0887734,2.1099855,18.5724906,1.3009472,51.6754217),(13606,'Alces_metatarsus.tif',242,10,128,676.7923023,95.8724769,132.3690516,1.8,95.9903932,133.390406,1.3350385,20.5008458,25.2845943,66148.5177721,87067.4543264,106.6444684,3443.4981726,3226.6238372,5981.7025481,1.6313096,10.906142,1.359703,27.0456329),(13607,'Alces_metatarsus.tif',242,10,129,676.6396005,95.8857029,132.366223,1.8,95.9675635,133.5052272,1.334042,20.6972602,25.5943852,65933.4267573,86460.3494647,106.5692591,3378.0983151,3185.6113347,5953.9964457,2.5554222,20.3251713,1.3439975,52.69852),(13608,'Alces_metatarsus.tif',242,10,130,674.2015136,95.8528626,132.3556685,1.8,95.9560455,133.5158299,1.3313926,20.8615979,25.8011679,65686.8618469,85884.4112291,106.0488078,3328.7024688,3148.6975365,5869.5074861,2.6590506,20.9887521,1.3698421,56.284008),(13609,'Alces_metatarsus.tif',242,10,131,672.6542754,95.8235887,132.3254562,1.8,95.9306247,133.4628993,1.3313486,20.4879524,26.0910237,65404.7446008,85335.7808755,105.8031605,3270.6950046,3192.3514564,5734.6016118,2.4169099,20.0991098,1.3994172,53.8681638),(13610,'Alces_metatarsus.tif',242,10,132,671.6167467,95.7832756,132.2773784,1.8,95.8429654,133.4159106,1.3326551,20.9058338,25.1118309,65414.2584638,85058.9798831,105.7071841,3387.2074223,3128.9954375,5854.9008842,3.1182406,21.4400277,1.3559809,57.8998559),(13611,'Alces_metatarsus.tif',242,10,133,669.6832704,95.7372875,132.2491551,1.8,95.844579,133.3841013,1.3340971,20.3642366,24.5039708,65437.613639,84693.9735567,105.4764553,3456.3367021,3213.3595196,5942.059304,2.2894411,19.8704766,1.3583643,50.0978521),(13612,'Alces_metatarsus.tif',242,10,134,668.1107138,95.6829214,132.2002552,1.8,95.7593341,133.31525,1.3346527,20.9952842,24.4726129,65405.7681954,84288.5538971,105.2569507,3444.1992016,3115.2599599,5908.5405018,2.2894411,18.7551307,1.3455195,50.951982),(13613,'Alces_metatarsus.tif',242,10,135,666.0969306,95.6484501,132.1526287,1.8,95.7338605,133.2744776,1.329647,20.7274895,24.9357207,65354.256525,83984.7439362,104.6844101,3368.0495953,3153.0232632,5913.1675589,2.1146072,14.9653842,1.3134726,35.9248686),(13614,'Alces_metatarsus.tif',242,10,136,663.0581021,95.6032282,132.0921365,1.8,95.6370757,133.1300025,1.3243979,20.3491984,24.7316475,65177.8554798,83639.3528973,103.9350836,3381.8755068,3202.9691913,5920.014164,0.380859,0.538616,2.3561945,1.0772319),(13615,'Alces_metatarsus.tif',242,10,137,663.5236802,95.6014596,132.044705,1.8,95.6849155,133.1709683,1.3300185,20.9784399,24.9413843,64925.4581281,83277.6882166,104.2990373,3338.9360941,3094.865899,5878.615634,2.3292427,17.9287124,1.3567356,46.1968502),(13616,'Alces_metatarsus.tif',242,10,138,661.7501584,95.5537967,132.0172889,1.8,95.6226788,133.1238701,1.3346728,20.4669523,24.4133352,64714.4599578,82732.1043998,104.2558921,3388.8079437,3161.9001684,5888.6024369,2.3718143,17.2735407,1.3258177,44.1347982),(13617,'Alces_metatarsus.tif',242,10,139,660.0564601,95.5071135,131.97325,1.8,95.5377512,133.0971911,1.3372986,20.862196,25.8525209,64500.5572984,82336.901153,104.1197797,3184.8693337,3091.7434186,5652.2768476,2.484114,17.8516865,1.3775848,51.5830098),(13618,'Alces_metatarsus.tif',242,10,140,658.4755519,95.4704899,131.9388681,1.8,95.5499742,133.0898256,1.3346061,20.6857288,26.257788,64409.782875,81951.637915,103.7366607,3121.0411856,3113.730407,5510.6349284,2.4680548,19.4983442,1.354246,52.2523159),(13619,'Alces_metatarsus.tif',242,10,141,658.5166504,95.430642,131.8902489,1.8,95.5233163,133.1120301,1.3389181,20.7304752,25.3598466,64352.9170175,81994.322498,103.9566512,3233.2341702,3104.2663744,5655.8791133,1.8183658,10.6231673,1.3171222,25.745299),(13620,'Alces_metatarsus.tif',242,10,142,654.3657884,95.3879568,131.8085384,1.8,95.4779262,132.9268033,1.3409936,21.0938769,24.4364566,64191.7181057,81382.2332459,103.4022037,3330.3614589,3043.1446309,5838.3041157,1.8168423,10.9922532,1.3258177,26.8225309),(13621,'Alces_metatarsus.tif',242,10,143,653.4096656,95.3493936,131.7525273,1.8,95.4137346,132.8039685,1.3400437,20.0462917,26.1387832,64190.1873922,81017.6911864,103.205145,3099.5203781,3202.0978461,5403.4266375,1.7657491,12.3998707,1.3854484,30.9466348),(13622,'Alces_metatarsus.tif',242,10,144,651.566694,95.3090839,131.7213252,1.8,95.400472,132.7770308,1.338077,19.9325666,24.7275447,64195.4387761,80496.35982,102.8185693,3255.3316909,3220.6308417,5698.8944278,1.992159,17.9287124,1.3567356,43.1882565),(13623,'Alces_metatarsus.tif',242,10,145,651.3543883,95.3092781,131.6769222,1.8,95.3629559,132.756868,1.3432578,20.3851106,24.9163428,63915.1537801,79884.8495243,103.0348835,3206.122594,3135.3841993,5617.9436447,2.4280195,18.9091795,1.4089589,46.8661563),(13624,'Alces_metatarsus.tif',242,10,146,649.5534382,95.2745923,131.6406133,1.8,95.3483422,132.7370347,1.3429758,20.5863464,24.5041629,63577.5378955,79330.4233568,102.7365706,3237.4263827,3088.3351818,5644.112784,2.1629794,17.5567324,1.3521274,47.0509801),(13625,'Alces_metatarsus.tif',242,10,147,646.9121884,95.2329524,131.592563,1.8,95.2877596,132.7228046,1.3385104,20.4328984,25.434115,63210.9233613,78824.2426881,102.1050347,3099.1541372,3093.5857501,5511.8818119,2.4991602,19.4200747,1.3734008,50.0437185),(13626,'Alces_metatarsus.tif',242,10,148,645.1589741,95.1998569,131.545682,1.8,95.2516529,132.6460589,1.3368973,20.4173103,23.9064123,63094.5663305,78448.2323732,101.7503511,3281.4724144,3090.2486858,5760.7037273,2.4261,17.5567324,1.3521274,44.9889281),(13627,'Alces_metatarsus.tif',242,10,149,642.728052,95.1642379,131.4687251,1.8,95.2082092,132.5301307,1.3384498,20.2193677,23.9806659,62897.7489144,78034.6485056,101.4417237,3254.0651269,3110.7673512,5716.1435359,2.0935733,17.5567324,1.3521274,44.8965162),(13628,'Alces_metatarsus.tif',242,10,150,640.1471532,95.1289598,131.3902976,1.8,95.1458822,132.3634492,1.3405355,20.3705325,23.90234,62800.4467818,77585.2146797,101.1336879,3245.9254942,3082.9064922,5789.4538215,2.3017914,17.4780673,1.3734008,46.1968502),(13629,'Alces_metatarsus.tif',242,10,151,638.853583,95.1021155,131.3302875,1.8,95.1394657,132.2586706,1.3370599,20.37153,23.6789499,62737.0588653,77286.7573108,100.7637126,3263.943613,3079.6439369,5763.2783191,2.0698052,13.5940523,1.3734008,33.0086868),(13630,'Alces_metatarsus.tif',242,10,152,637.9547343,95.0647329,131.2824654,1.8,95.0862261,132.1554605,1.3351221,20.2648021,23.6557464,62716.1540392,77031.4696922,100.5287379,3256.3533716,3094.8317988,5777.4148146,1.945609,15.1627808,1.3684747,39.5103566),(13631,'Alces_metatarsus.tif',242,10,153,638.6109479,95.0634254,131.2476016,1.8,95.0546304,132.1915301,1.3391077,20.4324263,23.4738915,62393.4566944,76612.8005763,100.8232598,3263.7451904,3053.64893,5739.3038053,2.5762987,14.7161473,1.388628,41.3110283),(13632,'Alces_metatarsus.tif',242,10,154,635.988599,95.0254379,131.2141279,1.8,95.0400278,132.1977368,1.3389802,20.445035,26.2601638,62050.4499793,76102.1675926,100.4032063,2898.0081056,3034.9886836,5256.8035067,2.1210246,17.5567324,1.3521274,42.3341266),(13633,'Alces_metatarsus.tif',242,10,155,632.987924,94.9857738,131.1525741,1.8,94.9880209,132.1565446,1.341773,20.0459495,23.3700995,61699.0723725,75607.8426923,100.0605123,3235.2383679,3077.8822609,5634.1723346,2.4988379,16.6579559,1.3868529,46.7354662),(13634,'Alces_metatarsus.tif',242,10,156,631.9692962,94.9432511,131.0817035,1.8,94.9237577,132.0651641,1.3450628,20.2410248,26.7472064,61567.7320047,75298.1888703,100.0516955,2815.1795688,3041.7299861,5097.4324748,1.9813158,15.465877,1.3975507,37.3558927),(13635,'Alces_metatarsus.tif',242,10,157,631.514839,94.9024692,131.0039448,1.8,94.875865,131.9531121,1.3429621,20.4536784,24.4073691,61528.1768415,75003.2193736,99.8828651,3072.9743569,3008.1717099,5518.6020325,2.3767785,15.8411707,1.4016951,39.4179447),(13636,'Alces_metatarsus.tif',242,10,158,628.7547331,94.8557707,130.9396711,1.8,94.7820854,131.9199172,1.3444313,20.190347,23.5612724,61487.2766028,74703.7900139,99.5138631,3170.617812,3045.3798859,5694.3440666,2.0522616,13.5245171,1.4010181,33.1010987),(13637,'Alces_metatarsus.tif',242,10,159,627.1230123,94.822186,130.8495936,1.8,94.794694,131.7684178,1.3393753,20.200391,23.1075461,61444.5375971,74438.8151431,99.0220523,3221.4071854,3041.7499135,5525.6717975,1.9874276,10.7723193,1.4288993,28.030453),(13638,'Alces_metatarsus.tif',242,10,160,625.4090943,94.7845187,130.7546444,1.8,94.7747795,131.6196534,1.3385095,20.1894035,23.0170931,61338.1163951,74212.269839,98.7110638,3224.2242501,3038.1341574,5656.0958387,1.765191,10.906142,1.359703,28.3459669),(13639,'Alces_metatarsus.tif',242,10,161,625.8519034,94.7813706,130.6455159,1.8,94.8411016,131.4495831,1.3317479,20.3509103,22.9779561,61128.3863333,73682.0437485,98.4607003,3206.640465,3003.7175388,5768.9022714,2.2712616,16.359213,1.359703,41.8496442),(13640,'Alces_metatarsus.tif',242,10,162,624.3105552,94.7397743,130.6021051,1.8,94.7613133,131.4490756,1.3290023,20.1330996,23.05166,60913.2046623,73292.7775946,98.0860731,3179.5010648,3025.5254171,5815.5803146,2.095129,16.7318082,1.3644724,42.6496405),(13641,'Alces_metatarsus.tif',242,10,163,622.0864883,94.7079126,130.5560762,1.8,94.7410335,131.3929487,1.3246301,20.0382964,23.3851365,60674.392041,72785.259159,97.5241242,3112.4581654,3027.9216764,5705.5234351,2.5067538,18.5333988,1.4056476,44.5268687),(13642,'Alces_metatarsus.tif',242,10,164,621.8162051,94.6845046,130.5063193,1.8,94.7082976,131.340298,1.3180758,20.2422578,22.7411338,60654.4208843,72434.988306,97.1567596,3185.1968756,2996.4256734,5699.871843,2.2445694,15.0282541,1.418147,39.2872546),(13643,'Alces_metatarsus.tif',242,10,165,622.1289494,94.6573219,130.4510937,1.8,94.7085361,131.2604529,1.3076693,20.2745006,22.5012236,60685.917273,72253.8497244,96.6733786,3211.1075838,2993.2139098,5761.4064036,2.030291,15.1627808,1.3684747,41.3110283),(13644,'Alces_metatarsus.tif',242,10,166,623.4893322,94.6284283,130.3926442,1.8,94.6684171,131.1463925,1.2970909,20.672406,22.5022164,60798.8337169,72016.2394128,96.3226037,3200.4064937,2941.0622898,5783.8943031,1.8880035,11.9045095,1.4424731,28.1611431),(13645,'Alces_metatarsus.tif',242,10,167,622.737603,94.599599,130.3115381,1.8,94.6619726,131.0483467,1.283676,20.3534712,22.7898771,60923.9985509,71763.6108619,95.4659372,3148.9248706,2993.2976984,5761.8290451,1.7292154,12.3998707,1.3854484,31.4852508),(13646,'Alces_metatarsus.tif',242,10,168,623.1660825,94.5672169,130.2389867,1.8,94.6268635,130.945152,1.2787603,20.3239798,22.6016657,61155.4014449,71700.5110183,95.2521882,3172.3551638,3009.0268696,5738.4756062,1.9959671,12.0257398,1.3796119,30.8159447),(13647,'Alces_metatarsus.tif',242,10,169,625.1051851,94.5588188,130.1890331,1.8,94.6123175,130.9506647,1.2785985,19.8560742,22.833617,61084.4740827,71368.4996026,95.5392861,3125.5888905,3076.3620958,5752.5272379,2.2221401,16.9685401,1.4130276,40.8106906),(13648,'Alces_metatarsus.tif',242,10,170,623.4761016,94.5152839,130.1268785,1.8,94.554749,130.8720261,1.2837822,21.0968571,22.3749586,61028.4266771,70913.0192076,95.5851384,3169.3028181,2892.7733842,5802.4285106,1.8659917,14.3417563,1.3838171,34.5321228),(13649,'Alces_metatarsus.tif',242,10,171,621.4628898,94.4809269,130.06032,1.8,94.5234466,130.8505555,1.2862979,20.4516494,22.5899721,60956.0662225,70671.1006503,95.4174381,3128.4279724,2980.496337,5766.1420331,2.1100143,14.2758634,1.4100336,38.3024345),(13650,'Alces_metatarsus.tif',242,10,172,621.0016194,94.4520835,129.9751531,1.8,94.5232151,130.7317792,1.2861233,20.2168747,22.7966495,61056.780038,70583.1726709,95.3368756,3096.2081806,3020.0899455,5704.1563914,2.195525,14.7898883,1.3633001,37.7638186),(13651,'Alces_metatarsus.tif',242,10,173,620.6426777,94.413307,129.8980028,1.8,94.4619469,130.6415764,1.2819464,20.0134891,22.8873955,61247.3497711,70573.2946361,95.0473399,3083.5004658,3060.3034467,5690.6992801,2.0084688,12.4756759,1.3554386,33.6397146),(13652,'Alces_metatarsus.tif',242,10,174,620.9499276,94.376591,129.8297916,1.8,94.4002827,130.5798924,1.2835313,20.2102698,22.7832345,61367.2219519,70574.9932673,95.1837452,3097.6722562,3036.4375405,5775.3590534,2.1996231,12.7743992,1.3909428,32.062145),(13653,'Alces_metatarsus.tif',242,10,175,621.1987604,94.333965,129.7692393,1.8,94.3525719,130.5086433,1.2737847,20.2136691,22.363546,61541.9960292,70651.3524348,94.6652864,3159.2195761,3044.5732376,5876.2168544,1.6895991,11.7326828,1.3415644,27.0839112),(13654,'Alces_metatarsus.tif',242,10,176,621.0407399,94.3075312,129.7030938,1.8,94.3885231,130.419536,1.2652518,20.2305258,22.7982928,61691.3314923,70596.5608666,94.1406481,3096.5722453,3049.4180968,5741.0788746,1.5984816,8.2216159,1.3370531,22.9598073),(13655,'Alces_metatarsus.tif',242,10,177,623.183401,94.3163517,129.6387151,1.8,94.3834331,130.4489563,1.2655023,20.143165,22.0152333,61751.330798,70366.8280286,94.4803701,3196.2790025,3065.6220487,5939.251484,1.8621568,10.1625857,1.3439975,26.507017),(13656,'Alces_metatarsus.tif',242,10,178,622.2665745,94.2798174,129.5846094,1.8,94.3238102,130.4243845,1.2549822,20.2664392,22.8343802,61733.4923519,70173.8637109,93.7064584,3073.1670007,3046.094667,5704.9716579,2.6499795,16.5925191,1.4094212,42.7803306),(13657,'Alces_metatarsus.tif',242,10,179,621.7981833,94.2491845,129.512219,1.8,94.2999276,130.3186955,1.2411827,20.2934007,22.8061804,61580.8732228,70055.3373215,92.7756959,3071.7698535,3034.5270371,5771.3087358,2.4801447,15.090862,1.3932002,39.1948427),(13658,'Alces_metatarsus.tif',242,10,180,621.4023629,94.2149844,129.4289161,1.8,94.2445435,130.2344984,1.2288791,20.3158065,22.7139348,61651.7855634,70046.6940575,91.9238404,3083.8643571,3034.6708394,5734.8304794,1.9438084,14.1738917,1.4631065,38.0793325),(13659,'Alces_metatarsus.tif',242,10,181,621.9604235,94.1870419,129.3422879,1.8,94.2392686,130.054242,1.2165133,20.3444956,22.2035789,61756.2341437,70137.1495481,91.1843647,3158.8218272,3035.5254562,5816.9526453,1.6366777,12.0257398,1.3796119,30.5004307),(13660,'Alces_metatarsus.tif',242,10,182,620.2099785,94.1430275,129.2494836,1.8,94.206355,129.900516,1.2007976,20.5032565,22.2823424,61791.8736177,70063.1414663,89.8513846,3144.3346516,3013.7589867,5764.3036891,1.5187804,7.1150333,1.2998495,17.3122673),(13661,'Alces_metatarsus.tif',242,10,183,618.9877043,94.1021661,129.1714642,1.8,94.1700165,129.8034138,1.1858151,20.3809954,22.444962,61879.3617568,70153.1534425,88.6151443,3125.5634702,3036.1305057,5750.0713925,1.692646,10.5340394,1.3521274,27.5842489),(13662,'Alces_metatarsus.tif',242,10,184,617.5938273,94.073026,129.0958689,1.8,94.1512897,129.7184734,1.1769291,19.7199759,22.2209931,61885.5705953,70080.1592494,87.7730978,3153.7816074,3138.2173541,5827.9463736,1.6116105,9.5290891,1.610775,24.0370392),(13663,'Alces_metatarsus.tif',242,10,185,617.8282867,94.0996688,129.010432,1.8,94.2067516,129.6381783,1.1793964,20.0751779,23.7877332,61658.8242829,69914.1684795,87.9860404,2939.0849388,3071.3961548,5277.813196,2.0085511,15.9096981,1.3780956,38.7486386),(13664,'Alces_metatarsus.tif',242,10,186,616.8869329,94.069377,128.9616872,1.8,94.1726997,129.5903316,1.1808768,19.6125653,22.2842244,61515.7753016,69826.9590629,87.9591668,3133.4704706,3136.5491568,5806.4368709,1.8198892,10.7723193,1.4288993,27.8073509),(13665,'Alces_metatarsus.tif',242,10,187,613.7862149,94.0289032,128.8863998,1.8,94.1187514,129.5096775,1.1732496,20.1466358,22.3742104,61316.3958822,69603.571586,86.964201,3110.8839319,3043.5054501,5849.5091457,2.0637114,14.7161473,1.388628,37.6714067),(13666,'Alces_metatarsus.tif',242,10,188,612.7248183,93.9906523,128.7973641,1.8,94.0786838,129.3977285,1.1689963,19.9045247,22.1754284,61206.6543669,69563.4183504,86.5024338,3136.9593972,3075.0121007,5896.7532106,2.0096638,15.2438785,1.3439975,37.1327907),(13667,'Alces_metatarsus.tif',242,10,189,609.998866,93.964413,128.7223336,1.8,94.0853025,129.3156904,1.1617991,20.2078919,22.403938,61165.6155155,69394.9040357,85.5872239,3097.4422524,3026.8182231,5827.5577934,1.6809226,10.6231673,1.3171222,24.4832433),(13668,'Alces_metatarsus.tif',242,10,190,607.9475007,93.9313055,128.638682,1.8,94.0263123,129.1635757,1.1568952,19.9468149,21.9491237,61178.2973314,69296.0477596,84.9351237,3157.1213892,3067.0709848,5942.8831283,1.2274838,6.5746457,1.3961241,14.8422896),(13669,'Alces_metatarsus.tif',242,10,191,607.9090835,93.8968665,128.5776439,1.8,94.0019444,129.1102924,1.1540574,20.2836998,21.9059661,61363.3031151,69209.8130169,84.7174623,3159.4047298,3025.2519855,5957.0471244,0.761718,3.4488249,1.6814535,7.4864899),(13670,'Alces_metatarsus.tif',242,10,192,607.0739265,93.868533,128.5171191,1.8,93.9960662,129.0496655,1.1483546,19.5935323,22.1400712,61421.8904315,69058.3284341,84.1717314,3119.1556582,3134.8043633,5832.1973072,34.8639826,40.8106013,1.9634338,137.0895375),(13671,'Alces_metatarsus.tif',242,10,193,605.5018094,93.8584478,128.4428114,1.8,93.8880505,129.0283537,1.1556943,19.7622912,25.9444653,61167.7184684,68759.5008384,84.5040947,2650.2570012,3095.1734192,4624.3155629,1.9562371,14.132897,1.3258177,32.285247),(13672,'Alces_metatarsus.tif',242,10,194,603.2575669,93.8221142,128.3887708,1.8,93.8708281,129.03095,1.1572196,20.1589814,26.0249707,61032.5005648,68507.2968449,84.3039182,2632.3678797,3027.5587581,4601.5484887,2.0300701,11.4574643,1.3016288,30.5004307),(13673,'Alces_metatarsus.tif',242,10,195,599.7494681,93.7881297,128.3121625,1.8,93.8531319,128.9429513,1.1605745,19.5721771,25.9927469,60770.5681349,68186.7701376,84.0597255,2623.2998895,3104.946776,4569.339342,1.142577,2.7726954,1.849096,6.5940817),(13674,'Alces_metatarsus.tif',242,10,196,597.2595575,93.7640376,128.2441619,1.8,93.8274385,128.8498647,1.1493965,20.2186711,24.1421743,60763.6564285,67970.4640658,82.8884501,2815.4243001,3005.323954,5118.8100671,0.380859,0.538616,2.3561945,1.0772319),(13675,'Alces_metatarsus.tif',242,10,197,595.3118835,93.734907,128.170615,1.8,93.7943806,128.7637618,1.1559594,19.6472242,21.996596,60732.725131,67830.7648312,83.1013882,3083.6937147,3091.1605929,5842.6730916,1.142577,2.4087638,1.8925469,5.5168498),(13676,'Alces_metatarsus.tif',242,10,198,593.7852166,93.7068057,128.0874379,1.8,93.7870373,128.6203244,1.1564467,19.8091934,21.6937311,60728.8715195,67653.5918106,82.9238364,3118.5779615,3065.6912761,5916.8033343,1.7707889,6.8976499,1.4601391,18.0739853),(13677,'Alces_metatarsus.tif',242,10,199,593.2981442,93.6765907,128.009626,1.8,93.7813956,128.5627052,1.1594852,19.593874,26.0765835,60788.3249595,67536.5186349,83.0766518,2589.92972,3102.4148075,4189.7488151,1.3680206,6.8660333,1.2315037,16.6812395),(13678,'Alces_metatarsus.tif',242,10,200,592.1400013,93.6424747,127.9319653,1.8,93.7026065,128.4842214,1.1573452,19.6609367,25.7517154,60840.530493,67427.9831328,82.7593866,2618.3880167,3094.4878853,4481.4675182,0.761718,1.5703219,1.815775,3.6778999),(13679,'Alces_metatarsus.tif',242,10,201,591.3509978,93.680489,127.8414239,1.8,93.7909425,128.470985,1.1617465,19.5868249,26.981249,60574.14863,67064.9684069,82.9670072,2485.6139276,3092.5966242,4388.8260753,1.142577,6.9500246,1.4056476,15.2884936),(13680,'Alces_metatarsus.tif',242,10,202,588.1136217,93.6424227,127.7812508,1.8,93.7689759,128.408208,1.1535179,19.8703772,27.4245141,60361.6009227,66745.0439695,81.9196275,2433.7730772,3037.7682456,4353.2566588,1.523436,5.3861596,1.4288993,14.3960855),(13681,'Alces_metatarsus.tif',242,10,203,585.58314,93.5932643,127.713515,1.8,93.6663667,128.3729355,1.1495476,20.2797728,27.777893,60190.6213427,66448.7283259,81.278991,2392.1442952,2968.0126009,4317.6054657,1.142577,5.009418,1.418147,11.4799036),(13682,'Alces_metatarsus.tif',242,10,204,584.0135724,93.554213,127.6322927,1.8,93.5993898,128.2528917,1.1439092,27.6910644,28.7918965,60088.6956782,66196.7881956,80.6495001,2299.1465039,2169.9669889,4212.8375895,0.9167877,6.9500246,1.4056476,14.9729797),(13683,'Alces_metatarsus.tif',242,10,205,583.4341933,93.5202461,127.5415563,1.8,93.5884136,128.1439476,1.1364895,20.3194829,28.8258055,60206.9477995,66134.3412085,80.0221569,2294.2755639,2963.015748,4201.4268408,1.142577,2.4087638,1.2490458,5.8323637),(13684,'Alces_metatarsus.tif',242,10,206,581.1174678,93.4776316,127.4539393,1.8,93.5322544,128.0476417,1.1366068,20.1574788,30.0708333,60268.5604557,65898.9325961,79.7130732,2191.4568179,2989.8858398,4086.6787397,1.3848627,4.6333497,1.4056476,11.4799036),(13685,'Alces_metatarsus.tif',242,10,207,579.7258326,93.4620937,127.3739441,1.8,93.5473556,127.9113271,1.1210019,20.0042386,30.0368713,60270.9656411,65806.2354246,78.3563192,2190.848533,3012.9097503,4073.0042776,35.419887,40.1079067,1.9707006,136.5509215),(13686,'Alces_metatarsus.tif',242,10,208,576.5954885,93.4281184,127.2911627,1.8,93.5011361,127.8316244,1.1186951,19.6354743,21.7005268,60247.5500024,65573.9352435,77.7593096,3021.7669775,3068.3012393,5768.4705019,35.419887,40.0626739,1.9919164,143.0525913),(13687,'Alces_metatarsus.tif',242,10,209,575.5922892,93.4542923,127.192163,1.8,93.4765102,127.739297,1.1262496,19.9326217,21.6471395,60060.0700096,65154.2661433,78.1901925,3009.8325937,3013.1545562,5718.303557,35.419887,40.0626739,1.9919164,131.9264799),(13688,'Alces_metatarsus.tif',242,10,210,574.1116877,93.4385369,127.1168125,1.8,93.4673813,127.6876702,1.117863,19.7226315,22.5175612,59914.679809,64912.012978,77.3617287,2882.7283893,3037.8643795,5538.7473307,1.4134555,6.1411668,1.4464413,13.6726457),(13689,'Alces_metatarsus.tif',242,10,211,571.2665277,93.4177189,127.0295357,1.8,93.429513,127.6099202,1.1103222,20.6111433,22.4280597,59772.1607442,64626.1911203,76.410015,2881.4882766,2899.9924946,5534.7276315,1.142577,5.009418,1.7234457,11.7954176),(13690,'Alces_metatarsus.tif',242,10,212,569.8088711,93.3929784,126.9444541,1.8,93.4005966,127.5014683,1.0841135,20.4511793,26.2273798,59748.4662887,64564.0608279,74.1948163,2461.7045723,2921.5169206,4235.4451768,1.142577,2.7726954,1.2924967,6.8171837),(13691,'Alces_metatarsus.tif',242,10,213,568.477587,93.3682971,126.8537197,1.8,93.3642591,127.4491328,1.0745214,20.6749769,26.4440871,59816.2008074,64580.6059222,73.2652162,2442.1567527,2893.1689263,4227.832326,1.4656655,5.009418,1.418147,11.7030057),(13692,'Alces_metatarsus.tif',242,10,214,567.1495116,93.3474767,126.7542493,1.8,93.4114702,127.3271283,1.053924,20.0943652,22.2073483,59787.2978978,64380.595251,71.4421706,2899.0672058,2975.3265344,5524.4254588,0.380859,0.8516266,2.677945,1.6158479),(13693,'Alces_metatarsus.tif',242,10,215,566.586396,93.3082938,126.6534923,1.8,93.3473965,127.1098581,1.0178079,21.4620172,21.9740038,59838.0578062,64174.028014,68.380435,2920.4522136,2788.0910337,5086.0170146,35.800746,39.7300017,2.0816192,132.2419938),(13694,'Alces_metatarsus.tif',242,10,216,566.5521546,93.2870633,126.5417093,1.8,93.3480368,126.942153,0.9972902,20.2039928,22.3935285,59865.4827048,63958.2180269,66.6271316,2856.1027315,2963.0520656,5422.8449823,0.761718,1.2043819,1.8925469,2.9161819),(13695,'Alces_metatarsus.tif',242,10,217,567.2681478,93.2744864,126.4211242,1.8,93.3110402,126.9579831,0.9901737,21.1364804,22.9962941,59684.0754846,63762.3926295,66.096078,2772.7247008,2823.7471091,5204.8903891,0.761718,2.3166749,1.735945,5.2013359),(13696,'Alces_metatarsus.tif',242,10,218,567.8371095,93.2383394,126.349351,1.8,93.2380002,126.8468306,0.9590326,20.1834512,20.4003728,59563.9671358,63470.0500053,63.4241362,3111.2201053,2951.1289547,5629.5076815,1.142577,4.5861497,1.6539376,10.4026717),(13697,'Alces_metatarsus.tif',242,10,219,567.0496004,93.2089914,126.2613777,1.8,93.2249401,126.7704779,0.9227405,22.0051294,20.3913746,59480.2818928,63203.6425848,60.0715071,3099.5282987,2703.0189598,5207.8187566,0.761718,2.6930798,1.7126934,5.9630539),(13698,'Alces_metatarsus.tif',242,10,220,566.1924657,93.1834824,126.1361268,1.8,93.2164714,126.577991,0.8809312,20.7376155,20.5391454,59445.362327,63062.3227165,56.1429669,3070.3479439,2866.5476173,5513.5461484,36.181605,39.5873573,2.0947157,133.8578417),(13699,'Alces_metatarsus.tif',242,10,221,565.6529982,93.1454648,126.008568,1.8,93.1729989,126.5033954,0.8288699,22.3292938,20.2264039,59467.7688376,63080.4097615,51.2309047,3118.716019,2663.2176234,5332.2305906,0.380859,0.8516266,2.0344439,1.8389499),(13700,'Alces_metatarsus.tif',242,10,222,565.1892663,93.1013362,125.8783973,1.8,93.1300061,126.3243032,0.7889765,20.9692193,20.7639042,59407.7490093,63089.6821304,47.436177,3038.430606,2833.0930268,5634.449293,0.380859,1.9420075,1.7681919,4.1241039),(13701,'Alces_metatarsus.tif',242,10,223,564.3558676,93.0458951,125.7954967,1.8,93.0655102,126.225844,0.7521171,21.709579,20.034413,59504.7608548,63043.4315825,43.9015735,3146.7571046,2740.9449427,5527.1508581,36.4224782,39.5451972,2.0732176,136.3278195),(13702,'Alces_metatarsus.tif',242,10,224,564.5323055,93.0035153,125.675635,1.8,93.0667636,126.1362636,0.6757375,20.4557593,20.0411292,59467.0126076,63161.9143438,36.8090461,3151.6145554,2907.1036574,5843.5788239,0.6816876,1.3732067,2.1587989,2.9161819),(13703,'Alces_metatarsus.tif',242,10,225,564.1567486,92.9796984,125.5497748,1.8,92.9941018,126.032621,0.5970246,23.4822973,43.7215199,59251.767668,63054.2525805,29.717063,1442.1788811,2523.2525935,2763.9421233,1.2965887,5.0812928,1.3439975,12.1109315),(13704,'Alces_metatarsus.tif',242,10,226,561.9783515,92.8983535,125.455167,1.8,92.9182456,125.9334893,0.5387487,23.364631,20.3901598,58914.8965394,62839.7583981,24.6552063,3081.8668916,2521.5419203,5199.9631407,1.142577,4.3424607,1.3045443,10.7181856),(13705,'Alces_metatarsus.tif',242,10,227,560.5317718,92.8254891,125.3602714,1.8,92.8449947,125.9224764,0.4695128,23.2546245,20.185774,58653.9914311,62722.0596784,19.1246636,3107.2407535,2522.2506409,5175.6160483,1.7208047,10.4580303,1.3876855,25.8759891),(13706,'Alces_metatarsus.tif',242,10,228,560.4665856,92.7313774,125.2514605,1.8,92.7632456,125.7578077,0.4210744,23.4527006,20.2343202,58477.1803362,62931.0071297,15.6061356,3110.1122481,2493.4092344,4940.3652358,1.5150905,6.1999353,1.3854484,15.6964194),(13707,'Alces_metatarsus.tif',242,10,229,559.5454953,92.6742877,125.1403843,1.8,92.760709,125.6496101,0.3965744,23.8517767,20.1357459,58319.8724286,63161.5984496,13.9137928,3136.7896065,2445.0955248,4926.7858568,1.252627,5.9125217,1.3101939,13.5419556),(13708,'Alces_metatarsus.tif',242,10,230,560.6883417,92.6363716,125.0334547,1.8,92.7318264,125.5163531,0.3788937,24.0358187,20.170844,58293.9224247,63467.1685646,12.7856286,3146.4805611,2425.2938142,4910.0404484,0.8430505,3.8840149,1.3734008,8.5637218),(13709,'Alces_metatarsus.tif',242,10,231,560.8833289,92.6084618,124.8850926,1.8,92.6517967,125.392762,0.3496882,23.9771915,21.9000991,58143.8929504,63784.1936868,10.9725739,2912.5070847,2424.9667793,4735.6367309,0.9724415,3.8840149,1.3734008,8.8792357),(13710,'Alces_metatarsus.tif',242,10,232,557.577426,92.5950805,124.7428443,1.8,92.6938463,125.2293668,0.33326,22.7199222,20.0449592,57853.5591055,64009.59048,9.9444904,3193.3011076,2546.380163,5357.9859288,35.5369937,39.4570659,0.6415706,136.0123055),(13711,'Alces_metatarsus.tif',242,10,233,559.3422885,92.5676238,124.6020106,1.8,92.6452158,125.1683885,0.3158977,22.6151427,20.7921664,57494.4125491,64217.8321136,8.9975588,3088.5589776,2542.2971351,5045.3569959,0.761718,3.5113465,1.7894653,7.8020038),(13712,'Alces_metatarsus.tif',242,10,234,559.3121789,92.5163473,124.4797655,1.8,92.5343878,125.050086,0.2974441,28.6712066,21.8503457,57168.0551474,64428.6386099,8.0069641,2948.6324561,1993.9187029,3373.1657765,1.9094593,9.0529151,1.3156139,22.5136032),(13713,'Alces_metatarsus.tif',242,10,235,560.4570911,92.4990345,124.3907981,1.8,92.5739099,124.9263243,0.2839908,22.7678968,20.2749936,56857.2398748,64778.0300657,7.3331865,3194.971673,2497.2548086,5304.4134201,0.761718,1.0772319,2.3561945,2.1544639),(13714,'Alces_metatarsus.tif',242,10,236,557.7115346,92.4583679,124.2868298,1.8,92.5383321,124.8559047,0.2668339,21.9653339,20.5634714,56537.7889002,65030.4455867,6.4626204,3162.4254707,2573.9553639,5485.6528385,1.5055899,8.1418355,1.3825748,20.1360373),(13715,'Alces_metatarsus.tif',242,10,237,558.6895474,92.4256994,124.1678665,1.8,92.5146492,124.7375457,0.2553868,21.1749556,20.2633228,56483.916882,65586.4363822,5.9422885,3236.7068837,2667.486911,5647.7631689,1.142577,2.7726954,1.849096,7.3557997),(13716,'Alces_metatarsus.tif',242,10,238,563.4090194,92.3326501,124.0462205,1.8,92.4376238,124.531148,0.2333993,20.7042889,20.1543819,56478.5412512,66459.186797,5.0230929,3297.5055835,2727.8667458,5825.0972126,1.4109602,6.3843602,1.2679115,16.1043453),(13717,'Alces_metatarsus.tif',242,10,239,564.2996483,92.3113626,123.896041,1.8,92.4142211,124.3899037,0.2140075,20.6283199,20.3267678,56307.3322874,67073.2582824,4.2420562,3299.7503036,2729.6131023,5849.3056604,0.538616,1.0772319,2.3561945,2.1544639),(13718,'Alces_metatarsus.tif',242,10,240,570.441085,92.2717709,123.7908911,1.8,92.3647935,124.2415437,0.1944049,20.7819587,20.6691846,56300.9677276,68254.8018963,3.5481,3302.2493797,2709.1271134,5921.6753762,0.761718,2.4087638,1.8925469,5.5168498),(13719,'Alces_metatarsus.tif',242,10,241,572.9514349,92.2495054,123.6262977,1.8,92.3373224,124.0959793,0.1856821,24.7913268,29.762712,55921.4677206,69044.5305959,3.2546919,2319.8333037,2255.686767,3226.1469921,35.1064213,40.2144544,0.4932999,152.9166471),(13720,'Alces_metatarsus.tif',242,10,242,572.585768,92.2199272,123.5042342,1.8,92.3151454,123.9993211,0.1706506,21.1167983,21.2943655,55557.9016081,69669.3256854,2.752233,3271.7258271,2630.9813118,5880.7225879,35.203062,40.2577151,0.4086185,140.6367472),(13721,'Alces_metatarsus.tif',242,10,243,572.4922744,92.150483,123.3792332,1.8,92.2381368,123.8796277,0.1608009,21.2519461,21.0530392,55252.8099309,70506.3970979,2.4459576,3348.9890114,2599.8941266,5882.9708621,0.761718,3.1406438,1.815775,6.7247719),(13722,'Alces_metatarsus.tif',242,10,244,576.4000178,92.1028282,123.2739068,1.8,92.2156299,123.7259299,0.1520189,20.5,20.9381623,55264.1094094,71606.0243458,2.203029,3419.8810519,2695.8102206,5642.496511,35.1608601,40.5252589,0.3752708,145.9304949),(13723,'Alces_metatarsus.tif',242,10,245,580.7958885,92.0299172,123.1512409,1.8,92.2054011,123.5985833,0.148257,21.2227325,21.0934294,55298.976049,72711.0712821,2.1121201,3447.0957789,2605.6482662,5919.9441746,0.380859,1.2043819,1.8925469,2.6006679),(13724,'Alces_metatarsus.tif',242,10,246,584.5125128,92.0023214,123.0439396,1.8,92.1789938,123.569221,0.1475125,21.4377926,21.1746313,55477.6140513,73766.0182695,2.1044965,3483.6978785,2587.8417135,5997.756128,35.4659356,40.8106013,0.3926375,157.5952223),(13725,'Alces_metatarsus.tif',242,10,247,586.4710877,91.9663178,122.9266191,1.8,92.1318237,123.4227814,0.1438775,21.5509874,22.1886303,55544.3321592,75002.7368309,2.0094738,3380.2328381,2577.3451167,5882.8186004,0.380859,0.538616,2.3561945,1.0772319),(13726,'Alces_metatarsus.tif',242,10,248,591.351789,91.9448911,122.7712727,1.8,92.1236758,123.303042,0.1390852,27.2338349,25.1899277,55572.6115887,76613.7449708,1.8943231,3041.4436216,2040.5723885,3563.2279913,34.9671455,41.3245178,0.3479836,159.9186546),(13727,'Alces_metatarsus.tif',242,10,249,592.3147689,91.9168664,122.6076276,1.8,92.0878492,123.1523601,0.1353973,22.4479824,24.4198144,55503.7916638,77598.3375489,1.7987301,3177.6792488,2472.5514653,4975.4033659,0.7527949,3.2540607,1.2120257,7.0402858),(13728,'Alces_metatarsus.tif',242,10,250,590.1958878,91.8877518,122.4809634,1.8,92.04145,123.028483,0.1263524,24.0781827,22.0900316,55080.9040922,78633.7814113,1.5620662,3559.6952911,2287.5855994,4641.0132119,0.761718,3.4488249,1.6814535,7.8020038),(13729,'Alces_metatarsus.tif',242,10,251,591.8178945,91.8513059,122.3464633,1.8,92.0503726,122.8501106,0.1261003,23.3545654,21.9882967,54995.9397114,79919.8578206,1.5601483,3634.6543334,2354.8260811,5721.8274057,34.990479,41.903145,0.192048,163.9503466),(13730,'Alces_metatarsus.tif',242,10,252,592.0163981,91.8395653,122.2144766,1.8,92.0417033,122.7583777,0.1271621,25.1124064,22.3958795,54848.4492631,81602.9960412,1.5869215,3643.6611553,2184.1176201,5055.2070884,0.761718,2.0509885,1.9513027,4.7551318),(13731,'Alces_metatarsus.tif',242,10,253,595.7892856,91.8140405,122.0856566,1.8,92.0235415,122.6379188,0.1287365,19.1263722,22.293225,55153.9925272,83466.1467882,1.6366065,3744.0140193,2883.6619841,5819.794866,36.5700045,43.2539137,2.4434722,235.3763027),(13732,'Alces_metatarsus.tif',242,10,254,600.6615913,91.8100433,121.9693121,1.8,91.980505,122.4788388,0.1248997,19.5039931,22.3101474,55570.6698436,85503.9776091,1.5536105,3832.5151314,2849.1944964,6113.0852289,35.0629527,42.8275903,0.1607627,155.3866248),(13733,'Alces_metatarsus.tif',242,10,255,604.6699931,91.7421695,121.8728462,1.8,91.9487469,122.3281229,0.1257441,19.4130864,22.4420769,56096.4276537,87562.6370524,1.5850829,3901.7171768,2889.6192228,6282.2556225,0.380859,0.8516266,2.677945,1.6158479),(13734,'Alces_metatarsus.tif',242,10,256,607.3145836,91.7160794,121.7859068,1.8,91.9000236,122.2193538,0.1264011,19.012076,23.2726799,56744.7079863,89707.4464783,1.6086076,3854.624691,2984.6665891,6275.8416468,34.7326903,43.471347,0.1939591,166.8665285),(13735,'Alces_metatarsus.tif',242,10,257,613.1038037,91.7128975,121.6898353,1.8,91.9172657,122.0983849,0.1277424,34.6642248,23.5387518,57527.0348451,91613.7899028,1.6584,3892.0411274,1659.5505927,4043.9448803,0.380859,0.538616,2.3561945,1.0772319),(13736,'Alces_metatarsus.tif',242,10,258,616.8255708,91.6407295,121.6031752,1.8,91.8363609,122.0206648,0.1300299,34.7612866,36.8872179,58099.5950672,93838.4556344,1.7284172,2543.9287929,1671.3879338,3392.0580514,36.128462,44.2206658,0.138243,173.5913003),(13737,'Alces_metatarsus.tif',242,10,259,618.6744325,91.5897359,121.4780091,1.8,91.7932326,121.9209712,0.1254229,35.0310206,24.0542985,58563.076961,96006.3284651,1.6135642,3991.2337668,1671.7490932,4153.5874511,1.0772319,2.1544639,2.3561945,4.5320297),(13738,'Alces_metatarsus.tif',242,10,260,624.8178472,91.5651921,121.4027075,1.8,91.7438466,121.7736119,0.1277302,20.4613487,23.7010613,59239.7055024,98630.5056242,1.6897634,4161.438352,2895.2004288,6622.138904,35.6980606,44.9752392,0.1359091,167.2203207),(13739,'Alces_metatarsus.tif',242,10,261,627.2539561,91.4897942,121.2684818,1.8,91.6927626,121.662824,0.1253549,24.6652391,23.6619696,59874.7506215,101174.1299189,1.6341759,4275.8118541,2427.4952483,6202.8217852,35.6201699,45.303014,0.1264405,150.6314931),(13740,'Alces_metatarsus.tif',242,10,262,632.249865,91.445574,121.1344019,1.8,91.6673216,121.5179276,0.121979,28.6723132,26.4400617,60792.7732678,103989.397403,1.5601018,3933.0240061,2120.2605057,4253.107446,35.5353416,45.7157735,0.1843244,148.7925431),(13741,'Alces_metatarsus.tif',242,10,263,638.5849262,91.3414791,121.0107638,1.8,91.6094855,121.4308835,0.119757,19.4464973,25.8207541,61548.0573749,107466.6109539,1.5191195,4162.0244991,3164.9945215,6544.7033769,34.6586601,46.1594195,0.1407302,141.0288176),(13742,'Alces_metatarsus.tif',242,10,264,645.2447316,91.3219069,120.8922325,1.8,91.5807956,121.2963468,0.1225018,19.3598855,25.1463271,62433.0926416,111080.702357,1.6057753,4417.3728437,3224.8688978,6895.1001418,35.6095178,46.6486203,0.155753,179.2929739),(13743,'Alces_metatarsus.tif',242,10,265,651.9711297,91.3173948,120.7558223,1.8,91.5442302,121.1226462,0.122784,20.3821625,24.5099156,63373.8667606,114763.8913592,1.6299598,4682.3454388,3109.2808191,7141.814853,0.380859,1.2043819,1.8925469,2.6006679),(13744,'Alces_metatarsus.tif',242,10,266,657.679999,91.2166228,120.6648167,1.8,91.4771062,121.0542007,0.1198487,21.0079992,24.9284436,64299.332056,118364.4884309,1.5669303,4748.170006,3060.7070911,7235.3345207,0.380859,1.9420075,1.7681919,4.1241039),(13745,'Alces_metatarsus.tif',242,10,267,662.4788548,91.1713681,120.5563663,1.8,91.4440679,120.9387705,0.1190157,24.9044481,24.9992231,65421.0938912,121706.4191048,1.5566012,4868.4080519,2626.8839039,7161.3653866,36.6038835,48.1767817,0.1989459,178.2540202),(13746,'Alces_metatarsus.tif',242,10,268,669.7446765,91.0952525,120.4815953,1.8,91.4082871,120.7986902,0.115315,27.194439,25.3235036,66584.0358038,126003.8482104,1.4777589,4975.7667846,2448.4430764,6998.2929692,0.761718,1.0772319,2.3561945,2.1544639),(13747,'Alces_metatarsus.tif',242,10,269,676.895642,91.057656,120.3617716,1.8,91.3930688,120.7824615,0.1150678,25.6635679,25.4258603,67908.364536,130158.0264451,1.4871686,5119.119862,2646.0999035,7640.4755686,36.0640878,49.225197,0.1867738,151.0235635),(13748,'Alces_metatarsus.tif',242,10,270,687.4433228,91.0368737,120.2382051,1.8,91.3398084,120.5970212,0.1097325,24.0887542,26.3306544,69566.9707409,134887.622517,1.37408,5122.8359339,2887.9438953,7673.9399963,36.2853744,49.7002754,0.2319682,153.5318195),(13749,'Alces_metatarsus.tif',242,10,271,695.4306761,90.9815945,120.1394534,1.8,91.2560464,120.5107716,0.1022473,26.0571926,25.6246344,71097.4382022,139572.5387151,1.2075147,5446.8109214,2728.5148932,7819.6612294,36.8448088,50.2806007,0.175111,188.879794),(13750,'Alces_metatarsus.tif',242,10,272,704.3810973,90.8981821,120.0900297,1.8,91.1431784,120.474124,0.0966642,24.9249496,26.760943,72805.8677895,144905.8198777,1.0935394,5414.8248681,2921.0036155,7568.5738918,37.2780484,50.8471727,0.1503714,206.7306773),(13751,'Alces_metatarsus.tif',242,10,273,710.2019655,90.8793417,120.0462187,1.8,91.1409723,120.3221048,0.0889646,24.1225999,26.7271965,74575.2810118,149986.1232378,0.9343711,5611.7417064,3091.5109173,8208.1879806,37.2544334,51.4385295,0.3006764,162.6341573),(13752,'Alces_metatarsus.tif',242,10,274,719.2355946,90.8578371,119.9790413,1.8,91.1007972,120.2760491,0.0851402,24.2964049,26.8832312,76300.9342005,154709.6090647,0.8668416,5754.8740342,3140.420753,8372.7655954,37.5501194,52.0566129,0.2893545,165.6810293),(13753,'Alces_metatarsus.tif',242,10,275,724.5736542,90.779877,119.9184491,1.8,91.0251025,120.2420835,0.0826858,21.3535483,27.1010384,78014.4569299,159131.711508,0.823765,5871.7938869,3653.4657245,8507.6964256,38.0862879,52.5888916,2.9299935,204.2065658),(13754,'Alces_metatarsus.tif',242,10,276,733.5494377,90.7050993,119.8335821,1.8,90.9963668,120.1783588,0.0794949,25.2894314,27.5965457,80124.334993,164822.6167476,0.7709778,5972.5814394,3168.2932531,8673.6060955,38.1752691,53.246758,3.034095,175.545085),(13755,'Alces_metatarsus.tif',242,10,277,741.1053225,90.6375348,119.8010362,1.8,90.9359873,120.0995157,0.0764006,26.3909884,27.6814486,82412.1760423,170898.3098485,0.7195754,6173.7487822,3122.7392794,7211.1771974,38.6143295,53.8683286,0.2209696,178.2764431),(13756,'Alces_metatarsus.tif',242,10,278,750.0301176,90.6238578,119.7413541,1.8,90.8919801,120.0412566,0.0765046,23.4640733,28.4315895,84546.377932,177379.3541875,0.7302227,6238.8124375,3603.226804,9158.371418,38.9938938,54.5639504,3.0085799,225.512247),(13757,'Alces_metatarsus.tif',242,10,279,761.3180991,90.5664029,119.7465073,1.8,90.8789178,120.037975,0.0784173,22.0650101,28.3198211,87531.4673588,184180.3308461,0.778661,6503.5838346,3966.9806164,9353.0311745,39.2809676,55.1522758,2.9116882,202.4217496),(13758,'Alces_metatarsus.tif',242,10,280,771.5711453,90.5994376,119.7047251,1.8,90.8560469,119.9792043,0.0803314,25.7272163,29.0098197,90543.9820958,191410.6523801,0.8280576,6598.1331336,3519.3851097,9508.9971005,39.8086477,55.87086,2.9495446,227.4053305),(13759,'Alces_metatarsus.tif',242,10,281,785.2020058,90.6209136,119.6069407,1.8,90.8895761,119.7777082,0.0797955,25.7362514,28.8902768,93697.770416,198237.2470646,0.8315043,6861.7288905,3640.6922212,9878.2849161,40.3466627,56.7224242,2.9112709,176.845419),(13760,'Alces_metatarsus.tif',242,10,282,795.3171632,90.5674496,119.5117532,1.8,90.8817836,119.7003196,0.0794112,26.1774354,29.4677229,96656.3050673,204504.1129197,0.8341424,6939.9360672,3692.3519605,9646.1498898,41.0304807,57.3796664,2.9207639,175.545085),(13761,'Alces_metatarsus.tif',242,10,283,802.5829849,90.577174,119.5038177,1.8,90.8613303,119.6919277,0.0846158,29.1413047,29.5208261,99416.9474975,211032.6332429,0.955443,7148.6018911,3411.5475734,10192.4637433,41.2873587,58.0419619,2.930041,173.9675154),(13762,'Alces_metatarsus.tif',242,10,284,809.9273992,90.5093827,119.5208496,1.8,90.8321943,119.6521584,0.0898423,26.400621,30.1003288,100863.741451,218545.4644785,1.0866432,7260.5673402,3820.5064008,10245.8342669,41.9015638,58.7511271,2.9060477,176.4374932),(13763,'Alces_metatarsus.tif',242,10,285,817.7251718,90.485025,119.5038786,1.8,90.8027808,119.650965,0.0924083,32.6660925,29.7469125,102727.9759638,226110.8729133,1.1604892,7601.1543384,3144.7892327,7935.2459764,42.3529814,59.4932967,2.8826397,179.4460869),(13764,'Alces_metatarsus.tif',242,10,286,825.0405754,90.4588413,119.5224913,1.8,90.7744406,119.6617129,0.0973945,33.1508162,30.4698454,104689.3771874,233715.0770151,1.3002271,7670.3729102,3157.9728395,8117.7542567,42.8581621,60.4366953,2.9256578,182.1391667),(13765,'Alces_metatarsus.tif',242,10,287,835.1075135,90.4007867,119.4903475,1.8,90.7487248,119.632094,0.100896,28.3353403,31.3287336,107233.0474605,241946.5041325,1.4120982,7722.8306404,3784.427722,11019.2766596,43.4093905,61.2626826,2.9222494,184.3319088),(13766,'Alces_metatarsus.tif',242,10,288,844.6708519,90.3574023,119.4905531,1.8,90.7348871,119.6309359,0.1070178,27.2766568,32.4461462,109521.0376665,250418.4625425,1.6061633,7717.9724441,4015.1928619,10846.9407661,44.175502,62.0893625,2.9189317,188.1946325),(13767,'Alces_metatarsus.tif',242,10,289,857.9771001,90.2861176,119.4202746,1.8,90.7414129,119.585468,0.1120355,27.8276288,31.9727179,112168.336666,259459.6204224,1.7873837,8115.0317288,4030.8262514,11237.0596707,44.8017668,62.8094114,0.3658678,191.5570184),(13768,'Alces_metatarsus.tif',242,10,290,868.5402533,90.1607118,119.4777401,1.8,90.7459634,119.6005543,0.1158359,27.9964408,32.8255736,114182.4862211,268180.3715901,1.9336657,8169.860951,4078.4643684,11539.6653829,45.3998947,63.6570244,0.3671738,194.5656121),(13769,'Alces_metatarsus.tif',242,10,291,889.1904763,90.0952559,119.4585065,1.8,90.773895,119.5975977,0.1194243,28.3351198,32.3100564,117840.9144665,280533.701677,2.1035993,8682.5506696,4158.8288807,11680.7295159,45.8358017,64.5912611,0.35532,199.7286697),(13770,'Alces_metatarsus.tif',242,10,292,936.1652862,89.8622326,119.4173258,1.8,90.7891451,119.6227068,0.1171559,28.6703811,33.0819608,125206.6777989,299469.2768242,2.1317746,9052.3436081,4367.1089492,12287.2621028,46.0390261,64.9484649,0.35328,202.3293377),(13771,'Alces_metatarsus.tif',242,10,293,1002.3822006,89.5557062,119.3725703,1.8,90.8113961,119.614605,0.1074507,29.1667951,33.7711361,133446.7743142,323533.0585062,1.9214477,9580.1650595,4575.2978283,12943.2824623,0.380859,0.8516266,2.0344439,1.8389499),(13772,'Alces_metatarsus.tif',242,10,294,1053.3921374,89.8229725,119.2960817,1.8,90.876281,119.5244269,0.1135355,29.1336506,33.9201496,138908.0920942,343782.431173,2.2533828,10135.0505571,4767.960392,13639.9589388,0.380859,0.8516266,2.0344439,1.8389499),(13773,'Alces_metatarsus.tif',242,10,295,1078.0362568,90.7502133,119.2967179,1.8,91.0384442,119.4356661,0.1166162,29.1027498,34.1475826,141206.414642,351977.180672,2.432373,10307.5284885,4851.9956288,14102.0802242,0.761718,1.3732067,0.9827937,2.9161819),(13774,'Alces_metatarsus.tif',242,10,296,1082.3942816,91.0369798,119.3333934,1.8,91.1407766,119.339193,0.1255471,31.3194401,33.8813034,141728.2691047,348137.4177244,2.8285524,10275.2073518,4525.249137,13276.0860997,45.845443,66.358055,3.0899146,219.6033267),(13775,'Alces_metatarsus.tif',242,10,297,1091.8850054,90.8510017,119.1884907,1.8,91.2081495,119.2228522,0.1324099,29.7730263,33.6474598,141774.4886783,341955.5657006,3.1719565,10162.8939597,4761.8433969,13598.5995036,46.1757054,65.9952932,2.6288888,241.801416),(13776,'Alces_metatarsus.tif',242,10,298,1090.3415034,90.6629248,119.0906282,1.8,91.2008691,119.2184543,0.1215663,30.0196684,33.9359768,139030.9895046,335190.3690646,2.6723746,9877.1392603,4631.3299475,13436.4181804,0.380859,0.538616,2.3561945,1.0772319),(13777,'Alces_metatarsus.tif',242,10,299,1069.0851763,90.7077117,119.0720228,1.8,91.0030714,119.212987,0.110595,29.9712275,34.8725259,131930.2966161,329940.7995466,2.1705039,9461.3393055,4401.8983359,13020.4139685,0.380859,0.538616,2.3561945,1.0772319),(13778,'Alces_metatarsus.tif',242,10,300,1058.7657131,90.5567981,119.1188614,1.8,90.9114691,119.3155075,0.1044827,30.1370106,34.3328919,126200.9080462,325783.7332681,1.9193608,9488.968593,4187.572202,12527.3871741,45.8518191,66.4159567,0.39435,329.5323965),(13779,'Alces_metatarsus.tif',242,10,301,1038.2763678,90.2773862,119.1615724,1.8,90.7582336,119.7527293,0.0926735,32.0081423,37.0743294,122122.7611645,318921.8677788,1.4819349,8602.2288958,3815.3654733,11623.5914412,0.8432035,2.2207705,2.6011732,4.5320297),(13780,'Alces_metatarsus.tif',242,10,302,1004.4465328,90.2343521,119.0467044,1.8,91.0207489,119.0645372,0.0939078,32.0381206,35.3129918,112069.7454254,311669.779228,1.4719793,8825.9239208,3498.0124718,9783.4792099,1.0225314,1.6158479,0.7853982,3.9934138),(13781,'Alces_metatarsus.tif',242,10,303,985.7847746,90.1929712,119.266594,1.8,90.9895592,119.1803052,0.1043733,34.4366489,37.3980187,108067.6652683,312674.2101009,1.7833322,8360.7159178,3138.1585774,8877.7402279,0.538616,1.0772319,2.3561945,2.1544639),(13782,'Alces_metatarsus.tif',242,10,304,940.6719251,90.2889548,119.362747,1.8,90.7799428,119.0006135,0.1253114,35.2792927,40.0806665,104300.4212811,305626.0040051,2.4490256,7625.2725006,2956.4204162,8546.2958841,31.7430451,47.8868668,0.6896467,176.985397),(13783,'Alces_metatarsus.tif',242,10,305,920.8456065,90.6537923,119.7399644,1.8,90.7773623,119.4910367,0.1222255,35.0459582,37.1973374,102776.315805,306171.9473966,2.2813702,8231.0178259,2932.6153779,8610.7287917,0.7625809,3.5113465,2.2794226,7.2251096),(13784,'Alces_metatarsus.tif',242,10,306,895.7840844,90.5923928,119.8549848,1.8,90.6444121,119.8554701,0.1234935,34.5905075,40.0208164,99599.548553,302870.6098947,2.2653293,7567.8268723,2879.3896287,8725.5862666,0.7416937,1.904295,2.2142974,3.9934138),(13785,'Alces_metatarsus.tif',242,10,307,880.0227385,90.4400949,119.6135311,1.8,90.2956397,119.7264749,0.1306156,34.7734383,38.6694119,99796.6542367,298647.5566621,2.488064,7723.0953783,2869.9104579,8602.6990269,30.404001,42.6358,1.2433961,209.3789113),(13786,'Alces_metatarsus.tif',242,10,308,879.9634423,90.2717632,119.4233263,1.8,90.0786147,119.7378609,0.1343128,35.6282228,35.2374826,105025.6992102,299006.5123817,2.6298756,8485.4674807,2947.8231262,8473.6272952,31.5926944,45.3238212,0.8448518,223.7591414),(13787,'Alces_metatarsus.tif',242,10,309,871.6207517,90.080381,119.0831313,1.8,89.9501441,119.3917972,0.1423471,35.3019008,36.283786,107827.7914468,295802.1646763,2.9237385,8152.4614,3054.4471795,8742.6403553,29.8786294,44.4692638,1.2842616,188.0032412),(13788,'Alces_metatarsus.tif',242,10,310,882.9594581,89.8482175,118.8416487,1.8,89.9304325,119.1388638,0.1380199,34.7035783,36.8023886,113597.1365504,296873.0080726,2.785565,8066.6777268,3273.3551445,9157.9788304,33.3299317,45.7997794,0.6734422,243.5796648),(13789,'Alces_metatarsus.tif',242,10,311,902.9958406,89.2488455,118.6751354,1.8,89.6472286,118.8439103,0.1177132,33.9620419,36.7575812,118095.7076389,305115.9111605,2.0757638,8300.7613944,3477.2852583,8995.406313,0.380859,0.538616,2.3561945,1.0772319),(13790,'Alces_metatarsus.tif',242,10,312,928.6195552,89.0474773,118.5376915,1.8,90.0718385,118.3549561,0.1216258,33.7450775,37.597679,123308.1101562,298735.8732556,2.2782208,7945.5934864,3654.106592,8996.0612402,33.4219542,48.1752763,0.6055447,279.5520995),(13791,'Alces_metatarsus.tif',242,10,313,936.0055075,89.2958372,118.2989721,1.8,90.0154633,118.0798337,0.1395469,33.6504536,38.6819623,123679.4889462,296911.5424748,3.0181887,7675.7104519,3675.4181781,9169.3836044,31.8811962,44.5279391,1.3112959,250.6675167),(13792,'Alces_metatarsus.tif',242,10,314,932.2559605,89.4102994,118.0752593,1.8,89.9523407,118.0858783,0.1544551,33.9217067,39.488408,118680.8314391,295487.6746025,3.6773253,7482.896624,3498.669232,9418.5915865,43.6187443,73.2725602,2.7523992,470.2484205),(13793,'Alces_metatarsus.tif',242,10,315,951.7527877,89.3499554,118.1372102,1.8,89.9118609,117.9907529,0.1549606,33.4533279,37.3215819,117122.3608067,300195.1456146,3.77865,8043.4732466,3501.0675482,9827.992983,43.5221919,70.7250138,2.7550863,541.2374604),(13794,'Alces_metatarsus.tif',242,10,316,958.1619141,89.7732367,118.1301988,1.8,90.2755224,117.9052057,0.1625535,32.7246017,39.5862796,110859.8459618,304547.8207641,4.1826509,7693.2670567,3387.660664,9473.0299645,35.5953217,46.6221821,0.6287963,222.0508816),(13795,'Alces_metatarsus.tif',242,10,317,938.3512437,90.006851,118.0654455,1.8,90.4508983,117.8546405,0.1591158,31.6647019,39.2647718,102237.0562058,298878.3310134,3.9262028,7611.8698178,3228.7389493,9905.6067415,34.6959193,46.6361807,0.5404195,248.4047856),(13796,'Alces_metatarsus.tif',242,10,318,911.2062248,90.4649617,118.0051093,1.8,91.0246062,117.7766656,0.1453853,33.0007109,38.6160266,92876.4960264,278756.3641766,3.1874597,7218.6703041,2814.3786488,9430.1543324,41.620585,65.7652076,3.0021526,426.3432919),(13797,'Alces_metatarsus.tif',242,10,319,878.4264019,91.5268508,118.1519676,1.8,91.8411244,117.964411,0.1445439,27.3629011,34.9079942,82964.1891347,258280.3510455,3.0375764,7398.8883337,3031.9953544,9589.0016928,31.3962519,43.1229274,0.9484935,221.3591526),(13798,'Alces_metatarsus.tif',242,10,320,823.967047,93.1754071,118.3431049,1.8,93.2132217,117.7074397,0.1408554,29.3091007,33.1394779,73071.745413,218961.8082279,2.7066465,6607.279969,2493.1418496,8203.1926186,28.6252392,40.43747,1.0481456,150.47838),(13799,'Alces_metatarsus.tif',242,10,321,745.5600498,95.0733985,118.4321075,1.8,95.2422209,117.5846535,0.1319035,27.9043064,29.1095815,59865.9318603,168850.1593894,2.1494319,5800.5010921,2145.401176,6566.2416708,25.469263,41.0568828,0.9235847,193.8356049),(13800,'Alces_metatarsus.tif',242,10,322,685.2684862,95.2867367,118.5345566,1.8,95.4249941,118.2054837,0.1301307,20.7067623,28.1945515,47450.9717575,147309.8495906,1.9231652,5224.7629948,2291.5688677,6453.6752998,18.9205392,35.818974,0.9591993,112.3290585),(13801,'Alces_metatarsus.tif',242,10,323,616.4875521,95.2466543,118.3794999,1.8,95.8315194,118.0847542,0.136939,20.0663936,29.1318008,35536.574656,125792.4789227,1.9147459,4318.0467908,1770.9497472,5341.5063893,16.7694483,33.7441934,0.9295526,91.6926835),(13802,'Alces_metatarsus.tif',242,10,324,513.7948496,94.6834541,118.2193743,1.8,95.3942405,118.205461,0.1389851,16.9378354,27.1033835,23645.0042394,95008.0873093,1.6435258,3505.3958257,1395.9873652,4278.3507268,17.7421924,30.3972251,0.9097532,88.3844312),(13803,'Alces_metatarsus.tif',242,10,325,377.7492308,93.959244,118.0084201,1.8,94.2013266,117.9232497,0.1456307,16.2042292,22.6904807,14496.6994988,57787.5666511,1.3258246,2546.7757801,894.6244437,2894.9753637,16.4394032,24.7763343,0.7853982,76.4583235),(13804,'Alces_metatarsus.tif',242,10,326,247.4985464,96.3234777,118.1781598,1.8,95.1309827,117.7973015,0.1360978,14.7509237,24.575851,7423.8808463,32097.519687,0.7593479,1306.0593388,503.2824378,1536.118988,16.7347102,21.1642493,0.5280744,77.7203792),(13805,'Alces_metatarsus.tif',242,10,327,129.865765,101.3263615,118.8400926,1.8,98.2324347,118.1187916,0.1859578,12.3170981,29.1220075,3102.2083864,8107.6922023,0.7398788,278.4043032,251.8619536,381.4946945,5.4241338,13.5084196,1.1955255,34.6245347),(13806,'Alces_metatarsus.tif',242,10,328,53.1333454,105.3671328,119.8479238,1.8,105.1401664,119.5647201,-1.5201074,5.2462116,10.3472669,149.9487882,1026.4144571,8.8328239,99.1966732,28.5822992,112.6346598,8.759757,20.2751533,1.4767351,50.7671582),(13807,'Alces_metatarsus.tif',242,10,329,15.7747964,105.7282593,120.0365349,1.8,105.9046961,119.9177179,-1.5084821,2.6646765,7.9310364,15.3702225,151.3853325,2.6189368,19.0877113,5.7681382,21.0140484,5.332026,15.4047932,1.4219064,35.870735),(13808,'Alces_metatarsus.tif',242,10,330,1222.8008703,90.3908361,119.0349191,1.8,89.7254774,119.6446858,0.1762716,36.3346043,40.4016568,180819.884084,478859.113275,6.2670944,11852.4622887,4976.5199753,13870.5845722,1.523436,3.6131457,1.8925469,9.7333656),(13809,'Alces_metatarsus.tif',242,10,331,1212.4906818,90.8463703,119.1226423,1.8,89.9491062,120.0060058,0.1964923,46.9306565,41.9996478,190660.1294393,482735.3778876,7.7023241,11493.795864,4062.5924257,12260.668539,0.380859,0.538616,2.3561945,1.0772319),(13810,'Alces_metatarsus.tif',242,10,332,1161.3273399,90.6092291,118.9675032,1.8,89.9966789,119.5736216,0.1835649,46.6671463,41.0749939,184938.7962243,463394.6851995,6.4491004,11281.6738718,3962.9334719,11814.1222054,48.0145778,69.7554462,2.9881131,335.4413167),(13811,'Alces_metatarsus.tif',242,10,333,1099.9824675,90.0523893,118.48849,1.8,90.0370141,119.0406045,0.1503882,46.0738505,42.2980749,170843.8860803,429629.9540574,4.1151472,10157.1987704,3708.0444605,10945.0204097,34.658169,47.2173008,1.7903402,159.1952148),(13812,'Alces_metatarsus.tif',242,10,334,1081.0258989,90.3926631,118.7909719,1.8,90.6261407,119.2251615,0.2319121,48.1301195,43.7154489,173957.8126878,440808.6401291,9.517696,10083.5894682,3614.3233045,11205.3738799,34.27731,46.2363453,0.9256478,137.5198862),(13813,'Alces_metatarsus.tif',242,10,335,1061.1536027,91.0742452,119.1080083,1.8,90.9211389,119.5157795,0.3263748,50.317682,45.2417089,172388.7418845,452273.084521,18.1796164,9996.8169909,3426.0072206,11339.2728054,33.896451,45.867822,0.9505468,149.1846136),(13814,'Alces_metatarsus.tif',242,10,336,1022.7162947,90.9929078,118.9545814,1.8,90.669648,119.4304819,0.3141217,50.1599301,44.5232044,172994.715289,438315.5016509,16.2730252,9844.6530822,3448.8627671,11085.2785113,0.9234884,4.6019368,2.7149652,9.9564676),(13815,'Alces_metatarsus.tif',242,10,337,990.5057411,90.8073865,118.6095159,1.8,90.4684403,119.1513948,0.2702107,49.3887237,43.9422595,170957.3927657,422270.2823138,11.7629212,9609.6624816,3461.4661003,10732.0792591,33.515592,44.1040642,0.9324765,143.1291478),(13816,'Alces_metatarsus.tif',242,10,338,951.9125664,90.6439891,118.3447037,1.8,90.3195203,118.9769962,0.248428,49.0528347,43.7946908,162990.2670812,403175.129365,9.5916678,9206.0275263,3322.7491932,10226.3267811,0.852593,3.0705834,2.6224465,6.5940817),(13817,'Alces_metatarsus.tif',242,10,339,902.6370308,90.385901,118.2496424,1.8,90.438378,119.0157154,0.2248701,48.4696733,42.5108902,158479.5313489,383034.1947683,7.479849,9010.2604963,3269.6636992,9798.9023735,32.753874,42.1946396,1.0303768,157.3562649),(13818,'Alces_metatarsus.tif',242,10,340,856.6077943,90.3378234,118.1691083,1.8,90.5677343,118.9908009,0.2116014,48.1818345,44.3717258,153415.7386467,365441.9071442,6.2976183,8235.9182609,3184.0991597,9384.1112606,1.704219,2.2207705,2.1112158,7.7637255),(13819,'Alces_metatarsus.tif',242,10,341,823.7142582,89.9369076,118.1477504,1.8,89.9206789,118.9551007,0.2166735,48.2534499,43.2003246,151052.338291,354599.9412487,6.3449773,8208.2702967,3130.394585,9186.6089115,0.761718,1.3732067,2.5535901,2.9161819),(13820,'Alces_metatarsus.tif',242,10,342,801.1942947,89.3699622,117.9928949,1.8,88.9759128,118.5789544,0.2039944,47.9506104,45.8501675,148447.9204081,348230.0734242,5.480124,7594.9574982,3095.8504844,8793.7486836,1.523436,2.7726954,1.849096,9.0640595),(13821,'Alces_metatarsus.tif',242,10,343,764.8269451,90.2266697,117.7937743,1.8,89.9665051,118.2589052,0.2477392,49.4669191,41.2500134,140335.6499248,336748.1546668,7.6647561,8163.588986,2836.9595765,8596.1772625,0.380859,1.9420075,1.7681919,4.1241039),(13822,'Alces_metatarsus.tif',242,10,344,746.3508555,90.4387771,117.6490484,1.8,90.4421039,118.2301375,0.2629576,50.0390147,41.4254402,136296.2349958,331980.7422472,8.4048497,8013.9339684,2723.7993376,8399.8693372,0.8322232,2.2207705,2.6011732,4.5320297),(13823,'Alces_metatarsus.tif',242,10,345,732.0326169,90.432296,117.6960808,1.8,90.1295045,118.6604798,0.2606391,49.9347898,44.1179793,136715.0421026,330443.4172453,8.102178,7489.9943919,2737.8715837,8385.7683289,0.6816876,1.7032532,2.677945,3.4547978),(13824,'Alces_metatarsus.tif',242,10,346,728.7730432,91.1163762,117.8747435,1.8,91.3977229,119.0435614,0.3024824,50.9574214,42.0177031,133628.4930286,327237.9086176,10.7784232,7788.0960823,2622.3558678,8225.5309966,44.969279,66.3285385,2.4049363,379.1523338),(13825,'Alces_metatarsus.tif',242,10,347,689.9008381,90.5489725,117.2893181,1.8,90.506609,118.1720563,0.2717239,50.6286326,45.5627655,126909.7307272,314203.2687485,8.2827801,6896.0535125,2506.6790126,7864.164579,0.380859,0.538616,2.3561945,1.0772319),(13826,'Alces_metatarsus.tif',242,10,348,641.7160615,89.5163867,116.0226938,1.8,89.4553506,116.9988547,0.2090978,50.0429318,45.5385022,114263.3943734,282587.8216417,4.6084205,6205.4702679,2283.3073568,6919.580232,0.380859,0.538616,2.3561945,1.0772319),(13827,'Alces_metatarsus.tif',242,10,349,612.0464511,89.0371716,115.0366019,1.8,89.0989757,116.1827395,0.1687417,49.7811111,44.3574014,103030.156205,260136.9218743,2.8770798,5864.5663158,2069.6636509,6243.4624121,1.2532265,2.9746039,2.2655346,6.5940817),(13828,'Alces_metatarsus.tif',242,10,350,592.1513419,88.9277746,114.2587094,1.8,89.0600504,115.5244977,0.1546646,50.0308332,39.5354999,93058.7074844,248578.9819561,2.3420587,6287.4880166,1860.0271388,5983.0161307,27.2511511,33.169736,0.9732399,100.0874369),(13829,'Alces_metatarsus.tif',242,10,351,618.6743886,90.8492855,115.7171809,1.8,90.2537015,116.6651986,0.3384736,53.3497945,49.0920911,105457.7722754,292321.7629188,11.3687247,5954.5592068,1976.7231206,6955.4417698,0.380859,0.8516266,2.677945,1.6158479),(13830,'Alces_metatarsus.tif',242,10,352,622.1863555,91.4524729,115.9505789,1.8,90.5610249,117.0232258,0.393576,54.4192558,42.340067,105414.4039857,306367.1563645,15.2505338,7235.8684912,1937.0791179,7172.9847971,0.6816876,1.7032532,2.677945,3.4547978),(13831,'Alces_metatarsus.tif',242,10,353,610.9362637,91.6723984,115.7846317,1.8,91.2950798,117.0197859,0.4250653,54.8626974,42.5068437,102671.6622048,305013.839962,17.3157118,7175.640762,1871.4293498,7103.6708709,0.380859,0.8516266,2.677945,1.6158479),(13832,'Alces_metatarsus.tif',242,10,354,600.2211559,91.8576228,115.5787768,1.8,92.0094316,117.3048432,0.4494156,55.522483,42.3831791,98758.2590577,300038.7504182,18.880702,7079.1940695,1778.7075387,6915.4279043,26.279271,31.0557763,0.9861951,95.424717),(13833,'Alces_metatarsus.tif',242,10,355,596.4636968,92.0489404,115.5122398,1.8,91.9833699,117.1504312,0.4704448,55.9839037,43.0735044,96012.5196058,300278.7783244,20.4254302,6971.3106125,1715.0022288,6851.0011908,26.279271,30.7388843,0.9793573,92.6392253),(13834,'Alces_metatarsus.tif',242,10,356,592.5699753,92.1021813,115.0267845,1.8,92.4133037,116.7865868,0.4703749,56.2671375,42.9342434,91808.9749751,293539.1556428,20.2865155,6836.9472127,1631.6624419,6644.699532,26.279271,30.4401422,1.017502,91.8775073),(13835,'Alces_metatarsus.tif',242,10,357,589.3620934,92.0415205,114.6283658,1.8,92.3946979,116.3924756,0.469151,56.4103408,42.4660883,88458.325566,289560.2349503,20.0796462,6818.6227292,1568.1225166,6493.2734839,26.279271,30.3279531,0.9549264,91.1157893),(13836,'Alces_metatarsus.tif',242,10,358,586.829458,92.0835901,114.2934021,1.8,92.4544572,116.0116689,0.4677578,56.7081873,41.6972708,85106.4695139,287344.3659416,19.8835637,6891.2032066,1500.7792277,6367.0049658,26.173353,33.1522391,0.8260262,121.8934557),(13837,'Alces_metatarsus.tif',242,10,359,582.8291001,92.0726863,113.8688031,1.8,92.2851626,115.6374233,0.460747,56.6429513,40.9222796,81841.4549465,282864.9666396,19.2027171,6912.2485143,1444.8656543,6231.859617,0.380859,0.538616,2.3561945,1.0772319),(13838,'Alces_metatarsus.tif',242,10,360,585.6579965,92.3350804,113.7990948,1.8,92.5581062,115.575936,0.4736498,57.0074591,43.0177484,80954.3882446,286339.3135791,20.3087888,6656.3063829,1420.0665925,6252.0458342,26.1862524,32.6407495,0.843185,119.8314038),(13839,'Alces_metatarsus.tif',242,10,361,586.9993904,92.4077126,113.5453571,1.8,92.459556,115.1493143,0.4743396,57.2761341,42.2044973,80605.1343737,285251.4045461,20.4101153,6758.7916663,1407.3075236,6202.3474227,0.380859,0.538616,2.3561945,1.0772319),(13840,'Alces_metatarsus.tif',242,10,362,585.9121479,92.272296,113.1652167,1.8,92.2887049,114.7136848,0.4659015,57.0936216,42.1693115,78688.9241467,280387.3576219,19.7067771,6649.0855042,1378.2436967,6096.6331575,0.380859,0.538616,2.3561945,1.0772319),(13841,'Alces_metatarsus.tif',242,10,363,587.5725718,92.1163113,112.7976289,1.8,92.2477309,114.4304909,0.4546129,57.1884582,41.9194118,77129.7863533,276628.1437226,18.8827836,6599.0464053,1348.6949784,5988.3655462,0.8079239,2.6930798,2.3561945,5.6092617),(13842,'Alces_metatarsus.tif',242,10,364,587.8323057,91.864505,112.3508463,1.8,91.9555895,114.0546436,0.4364988,56.864164,41.665877,75080.9816513,272202.1053989,17.5109098,6532.9743469,1320.3567294,5890.0469993,26.305146,31.0066947,0.4856221,117.8617637),(13843,'Alces_metatarsus.tif',242,10,365,586.1710466,91.511385,111.8019039,1.8,91.5322197,113.5637267,0.4163455,56.897805,41.6608351,72747.0587399,266001.1232286,15.9786574,6384.9205808,1278.5565048,5726.5300927,0.538616,1.0772319,2.3561945,2.1544639),(13844,'Alces_metatarsus.tif',242,10,366,584.9978708,91.2296936,111.3145269,1.8,91.1113516,113.070142,0.3959485,56.5455618,41.9698773,71118.8230317,260706.9550441,14.5032459,6211.7635783,1257.7259957,5618.7630584,26.5826681,32.0578321,0.4158118,149.6242501),(13845,'Alces_metatarsus.tif',242,10,367,583.3094032,90.9792561,110.7994941,1.8,90.8935244,112.6968041,0.3716914,56.5045778,41.2462046,69205.8017486,255222.7162415,12.8238933,6187.7866925,1224.782211,5471.1965844,0.538616,1.0772319,2.3561945,2.1544639),(13846,'Alces_metatarsus.tif',242,10,368,578.3199118,90.7372351,110.3033364,1.8,90.5884364,112.2124418,0.3521342,56.166825,41.0048146,67694.0442828,249315.7798848,11.4658952,6080.1586877,1205.2318112,5351.6744532,25.6379315,30.8519299,0.5023024,141.1370849),(13847,'Alces_metatarsus.tif',242,10,369,574.5508045,90.3256648,109.6655982,1.8,90.0899183,111.5409298,0.3286275,56.0568382,41.1682942,65159.8254354,243608.4722469,9.9745728,5917.3807699,1162.3885251,5211.5759923,23.8568652,32.1955411,0.4795193,117.9541756),(13848,'Alces_metatarsus.tif',242,10,370,574.5742768,89.8280309,109.0809411,1.8,89.6101081,110.8822856,0.3034438,55.7157355,41.0283368,62804.2969519,239105.5911336,8.5502845,5827.8158387,1127.2272785,5088.0713273,23.613258,32.5606603,0.4217873,124.0861978),(13849,'Alces_metatarsus.tif',242,10,371,578.7821932,89.3379314,108.4958799,1.8,88.9120365,110.208715,0.2767487,55.2135964,40.6279442,60394.305107,234678.7650204,7.2014381,5776.2894419,1093.8303068,4984.1214955,22.85154,34.0650646,0.4636476,104.4346429),(13850,'Alces_metatarsus.tif',242,10,372,585.9211588,88.7304575,107.8228339,1.8,88.1364466,109.4672288,0.2460984,55.0377345,40.2084541,57891.8055539,230517.0526945,5.7958919,5733.0493734,1051.8566233,4856.9148171,26.279271,35.0886701,0.473356,167.7906474),(13851,'Alces_metatarsus.tif',242,10,373,593.9097429,87.9621228,107.2279324,1.8,87.3275765,108.8837409,0.2072198,54.181041,39.7077411,55950.3125291,225411.407244,4.189927,5676.7622899,1032.6548092,4760.3398055,26.7834555,34.2963477,0.5232783,191.7894083),(13852,'Alces_metatarsus.tif',242,10,374,608.2608604,87.4342295,106.8766666,1.8,86.5713548,108.4563668,0.1695921,53.5112973,37.537344,55296.6843094,224098.5359628,2.8879012,5970.0157749,1033.364675,4728.3781185,24.2618405,35.729771,0.54956,129.3033891),(13853,'Alces_metatarsus.tif',242,10,375,625.2599968,87.7324071,106.9357207,1.8,87.0573317,108.5382639,0.1664693,53.1084021,45.0228677,57283.3979846,232381.505525,2.8612932,5161.410575,1078.6127197,4509.3787855,29.7952396,36.055099,0.5440427,252.3440657),(13854,'Alces_metatarsus.tif',242,10,376,650.5246818,88.2776518,107.1841455,1.8,87.8478408,109.0393824,0.1684205,52.9446786,46.7219857,61325.9584108,244727.2516441,3.0464366,5237.946288,1158.3025918,4727.2724578,34.799552,68.869165,2.9355205,470.8477376),(13855,'Alces_metatarsus.tif',242,10,377,655.6568092,88.4337107,106.98964,1.8,87.821607,108.3659159,0.1664763,52.735976,35.1329657,62561.6350662,246309.7067621,3.0006433,7010.7860836,1186.3179521,5238.9933155,37.6250386,68.2705029,2.9507616,521.2386808),(13856,'Alces_metatarsus.tif',242,10,378,655.8837961,88.8793903,106.9131518,1.8,88.3299329,108.1690941,0.1780628,52.989671,34.524352,60246.4209437,252663.5590208,3.4294721,7318.4156865,1136.9464994,5305.7781709,29.8273338,40.0355097,2.6566717,194.2052524),(13857,'Alces_metatarsus.tif',242,10,379,661.0448903,88.8912387,106.8323844,1.8,88.4228778,108.0360965,0.1965282,53.3758848,46.3094057,59448.1222823,255835.2516574,4.2007916,5524.47711,1113.7636881,4926.3404837,28.3668466,36.809584,2.645549,191.3973379),(13858,'Alces_metatarsus.tif',242,10,380,660.0259109,88.2878181,106.3853259,1.8,88.4760364,107.6139096,0.2029088,53.8505352,49.2134303,58209.941321,257118.3915049,4.4672805,5224.5573973,1080.9538118,4767.7790451,27.3913549,34.8168458,0.527287,186.8111745),(13859,'Alces_metatarsus.tif',242,10,381,659.8501324,87.914259,105.9936242,1.8,88.4911774,107.2159221,0.2066379,54.0909665,49.8238294,56446.524451,257158.1559752,4.6293915,5161.3486825,1043.5480841,4703.5231871,26.4510585,34.8251772,2.4258491,182.0177644),(13860,'Alces_metatarsus.tif',242,10,382,666.8847034,87.8599196,105.7154131,1.8,88.3038656,106.8580869,0.2067881,54.1991297,49.9407874,54623.7659088,259572.5552529,4.6854524,5197.6063816,1007.834742,4694.3694389,31.3345588,36.8154945,1.9974238,171.5226809),(13861,'Alces_metatarsus.tif',242,10,383,677.0222782,87.6359276,105.6462702,1.8,88.3596245,106.8982539,0.194386,54.1023913,49.6174487,54063.1007133,265202.7897096,4.2102184,5344.9501475,999.2737738,4756.6993565,30.9183017,36.1414923,1.0647214,163.2586176),(13862,'Alces_metatarsus.tif',242,10,384,684.8113476,87.6239817,105.5130087,1.8,87.8152096,106.6002928,0.1760978,54.5031085,48.8176696,55711.0571661,272004.3842758,3.5029494,5571.842868,1022.1629314,4874.2925902,31.2772332,39.9175845,1.0516502,192.1207776),(13863,'Alces_metatarsus.tif',242,10,385,705.0578821,87.1788403,105.5055122,1.8,86.3729781,106.2246961,0.1144864,54.5862489,46.3216587,64230.4996568,288779.1153998,1.5334964,6234.213613,1176.6791268,5229.385942,32.0005134,42.7937077,1.2068174,193.051464),(13864,'Alces_metatarsus.tif',242,10,386,747.711502,87.1050274,105.5650139,1.8,85.8536523,106.3692916,0.0895387,54.6058874,45.1505341,73026.8867486,311172.671266,0.996423,6891.8934773,1337.3445655,5691.7127426,31.1256852,46.6221821,0.942,217.1426368),(13865,'Alces_metatarsus.tif',242,10,387,834.5241783,85.5866289,105.3810324,1.8,85.5371059,106.7089715,0.0982364,54.7862625,47.114379,81891.5626071,360588.582577,1.3379348,7653.4720411,1494.7462898,6453.1276813,30.9721578,45.8614967,1.0104364,202.953798),(13866,'Alces_metatarsus.tif',242,10,388,897.3772562,85.3252102,105.6161042,1.8,86.5431344,107.1463118,0.1229723,54.7258035,48.5627478,92202.5284137,399329.3239112,2.2503394,8222.9557037,1684.8090388,7171.0892431,30.2261893,46.5084826,1.0191413,181.7946624),(13867,'Alces_metatarsus.tif',242,10,389,963.9950899,87.1475723,106.5111954,1.8,88.2706022,108.1113959,0.181704,54.4537448,49.2954345,107567.8118821,430261.1354424,5.2464739,8728.2146935,1975.3978765,8088.7601599,31.3421094,46.5365439,1.0668775,214.7267927),(13868,'Alces_metatarsus.tif',242,10,390,999.997256,88.6610545,107.3481779,1.8,89.0107852,108.4013965,0.2103749,54.1906679,48.8963228,117639.3346248,428088.465839,7.2680689,8755.0237201,2170.8412009,8416.9529894,31.9155301,45.7617581,1.1779258,165.5054934),(13869,'Alces_metatarsus.tif',242,10,391,1027.9493882,90.446149,107.7059824,1.8,89.616794,108.4197468,0.2042287,54.3993425,46.7358979,121346.7149083,441130.4775576,7.0470549,9438.7932546,2230.6651037,8890.3336905,31.992156,44.9816891,1.1981514,199.0686515),(13870,'Alces_metatarsus.tif',242,10,392,1041.3678991,91.6823027,107.7554854,1.8,89.9411288,108.297098,0.1915224,54.6993118,44.9689269,118841.1534048,434895.3225646,6.2889101,9671.0184755,2172.6261183,8870.7437153,31.7915497,44.3385965,1.8136917,217.9043548),(13871,'Alces_metatarsus.tif',242,10,393,969.0355259,92.1057117,107.832424,1.8,90.1521989,108.4295599,0.1894878,54.9702986,44.378688,111831.2193008,403039.9297538,5.7298955,9081.835184,2034.393519,8330.6005256,31.2720621,46.9863326,1.8669115,215.0423066),(13872,'Alces_metatarsus.tif',242,10,394,890.4611456,92.0603281,107.8137436,1.8,90.3265508,108.2825075,0.1934609,55.1731431,44.5241517,105114.9534963,375441.3448949,5.4856156,8432.3076545,1905.1833487,7809.5042817,30.8723328,43.7059557,1.7459733,225.945316),(13873,'Alces_metatarsus.tif',242,10,395,831.7941821,92.2091251,107.7887564,1.8,90.4171552,108.0083564,0.1928294,55.3643334,44.28308,98131.7383108,355606.4594377,5.0912152,8030.3009524,1772.4721368,7374.9871881,30.6679534,39.7208732,1.318841,139.9450182),(13874,'Alces_metatarsus.tif',242,10,396,769.0927071,91.7982522,107.6722019,1.8,90.4664679,107.8544807,0.1913521,55.6706597,44.646256,91854.2904512,334446.5183849,4.6364612,7491.0316812,1649.9587218,6932.6538282,30.087861,40.0355097,1.7719232,140.4836341),(13875,'Alces_metatarsus.tif',242,10,397,698.1652877,91.4597954,107.523967,1.8,90.6817496,107.5687427,0.1895067,55.8692254,44.8567281,84673.7151755,311281.192204,4.1290585,6939.4537954,1515.5698786,6431.3473205,29.707002,39.7263505,1.6475682,156.5497011),(13876,'Alces_metatarsus.tif',242,10,398,649.3874178,91.4310707,107.408067,1.8,91.2418692,107.625219,0.1892907,56.2610769,44.825996,80713.5430126,295288.2021303,3.831934,6587.4320387,1434.6249207,6070.2214845,29.0663551,36.9492121,1.7156088,108.7211477),(13877,'Alces_metatarsus.tif',242,10,399,614.5009774,91.49397,107.3624403,1.8,91.6978903,107.5785974,0.1936052,56.5347032,44.9530563,77521.447001,284087.7422646,3.7911621,6319.6535633,1371.218784,5824.075277,28.183566,39.8903215,1.3883809,120.7779455),(13878,'Alces_metatarsus.tif',242,10,400,580.6416482,91.5570972,107.2835749,1.8,92.110067,107.5241479,0.2018793,56.9920266,45.1739925,74146.3377701,271860.1074738,3.890745,6018.0668639,1300.9949313,5536.6319034,27.6959982,37.224949,1.4477104,109.744246),(13879,'Alces_metatarsus.tif',242,10,401,541.7275534,91.4441635,107.1954716,1.8,92.0181188,107.8071589,0.2084959,57.2707443,45.4943345,71818.6195512,258619.321471,3.8683205,5684.6489647,1254.0193151,5268.0078407,1.6158479,2.9746039,2.4468544,6.9095956),(13880,'Alces_metatarsus.tif',242,10,402,514.1009566,90.955507,106.936909,1.8,91.2898521,107.8268951,0.2034935,57.5580882,45.7454513,67988.9104518,251091.4883185,3.4994126,5488.8842742,1181.2225287,5087.200258,27.0043328,38.6323215,1.7391865,134.5205803),(13881,'Alces_metatarsus.tif',242,10,403,501.6061294,90.0913899,106.6770407,1.8,90.8111967,107.5503371,0.192587,57.5777551,46.1997383,67094.865059,251086.3148543,3.0625939,5434.7995007,1165.2914384,5078.6549707,0.8079239,2.4386875,2.2455373,5.0706457),(13882,'Alces_metatarsus.tif',242,10,404,473.0669258,90.9910252,106.3146171,1.8,91.8310323,107.3351316,0.2195975,58.7818219,46.408406,63002.8657009,237662.6010775,3.7413993,5121.1110554,1071.8086584,4714.1782041,25.4859212,35.703373,1.3775848,110.9138898),(13883,'Alces_metatarsus.tif',242,10,405,449.8231449,91.034754,106.0024143,1.8,91.9494362,107.2074451,0.2189237,59.3315021,46.3238954,60656.8398228,229561.879413,3.5361176,4955.5823762,1022.3378413,4524.2252741,24.755835,33.9370801,1.7285651,96.4636707),(13884,'Alces_metatarsus.tif',242,10,406,434.0154697,91.0437614,105.6841331,1.8,92.0611897,107.1365978,0.2200427,59.8326499,46.4291953,59633.0758209,223742.1349938,3.4462532,4818.9966123,996.6644612,4384.3999678,24.2616384,33.731295,1.6839473,96.2405686),(13885,'Alces_metatarsus.tif',242,10,407,419.9430309,91.3800385,105.6149441,1.8,93.0960318,107.5374969,0.2192432,60.1245216,46.0010586,58659.2949936,218756.3108429,3.3107131,4755.4625343,975.6301335,4255.2170966,23.8439628,33.2745242,1.6624925,95.2940269),(13886,'Alces_metatarsus.tif',242,10,408,410.9127424,91.1877148,105.2956347,1.8,93.2665145,107.3694373,0.2186597,60.4624415,46.2347428,58657.2208724,215491.7806462,3.2225776,4660.8192761,970.1431073,4195.4379116,23.613258,33.189409,1.6282044,94.7554109),(13887,'Alces_metatarsus.tif',242,10,409,398.6281109,91.3776954,105.0333081,1.8,92.4470787,107.0907867,0.2129932,60.795266,45.7951111,58041.3281844,215393.7154267,2.9687312,4703.4216197,954.7014428,4163.8752517,23.2774447,32.8952837,1.6635526,94.5323089),(13888,'Alces_metatarsus.tif',242,10,410,389.4087253,91.2274907,104.5989372,1.8,92.1505693,106.7757442,0.2015112,61.0744501,45.5617801,56875.4674376,214134.5289875,2.5999582,4699.8718739,931.24813,4103.874987,22.85154,32.5962798,1.4536876,93.7164572),(13889,'Alces_metatarsus.tif',242,10,411,387.8201249,91.2356674,104.3208996,1.8,91.9637884,106.5423298,0.1978204,61.333531,45.3805668,57553.7845687,216469.0439679,2.4965977,4770.0824267,938.3738979,4121.4805686,22.7205597,33.346375,1.3285877,95.1092031),(13890,'Alces_metatarsus.tif',242,10,412,393.3152379,91.3548755,104.0841714,1.8,91.8840029,106.4876642,0.1965438,61.5572442,45.2569509,59797.9782415,222529.4059648,2.4998204,4917.0216153,971.4206514,4229.674028,22.470681,33.8985906,1.0920745,96.4095371),(13891,'Alces_metatarsus.tif',242,10,413,399.2097318,91.2844533,103.755612,1.8,91.6208961,106.2863002,0.1911007,61.8742951,45.1605835,60325.1748936,228679.0030885,2.4003859,5063.685753,974.9634293,4308.0391543,22.2916166,34.3723929,1.3016288,96.8557411),(13892,'Alces_metatarsus.tif',242,10,414,406.2706323,91.3290685,103.5426602,1.8,91.6786445,106.1616527,0.1854771,62.0153076,44.8471594,61743.9382113,234517.1734366,2.3028147,5229.2536785,995.6241543,4389.1560166,22.5407925,35.4055507,1.0156178,114.9838601),(13893,'Alces_metatarsus.tif',242,10,415,423.1681434,91.20464,103.5526821,1.8,91.4523536,106.2618214,0.1761939,61.7335776,44.5723654,64358.6114328,246685.0598251,2.1669281,5534.4843688,1042.5219779,4613.4668562,22.9436327,40.185588,1.3120254,159.3034821),(13894,'Alces_metatarsus.tif',242,10,416,430.8461809,90.8796796,103.5478598,1.8,91.1240749,106.327631,0.1647982,61.3721748,44.4032904,64610.9364994,254652.2868878,1.9325954,5734.9868578,1052.7724778,4747.7892275,22.8660564,43.0976921,1.3751339,154.5259274),(13895,'Alces_metatarsus.tif',242,10,417,445.6756235,91.453245,103.6379031,1.8,91.7810612,106.4888163,0.170936,61.5485356,44.0873254,66050.7449745,260376.9371301,2.1493182,5905.9363327,1073.1489284,4836.7712553,25.8652302,42.1705687,1.2204821,201.3696609),(13896,'Alces_metatarsus.tif',242,10,418,462.2653133,91.5906024,103.8229028,1.8,91.0595934,106.4084869,0.1755692,61.5179851,44.1184043,66989.5105711,268005.359606,2.3505523,6074.6838817,1088.9418827,4969.3216467,31.5726306,47.3874924,1.9408553,244.9275649),(13897,'Alces_metatarsus.tif',242,10,419,447.1489283,92.3716719,104.0139919,1.8,92.2109398,106.3739574,0.1861049,61.7617483,44.0438433,65649.9259153,257875.3810042,2.5515083,5854.96999,1062.9544625,4778.967541,24.8292132,42.7937077,1.0074801,184.4270411),(13898,'Alces_metatarsus.tif',242,10,420,428.953979,92.9369954,103.8480494,1.8,92.6238888,106.2032678,0.1889537,62.1096423,43.3576247,63464.5629873,247109.9452791,2.5222918,5699.3423177,1021.814981,4556.6931535,25.2833926,54.7430993,1.0136719,234.0628337),(13899,'Alces_metatarsus.tif',242,10,421,421.0166911,92.9212137,103.7172796,1.8,92.2651823,105.8459306,0.1924581,62.3329638,43.7644517,60947.9158099,245606.2406003,2.5671518,5612.0031426,977.7798465,4491.2561016,27.5069903,45.7601732,1.5208379,222.0825924),(13900,'Alces_metatarsus.tif',242,10,422,423.0560126,93.0642303,103.795514,1.8,92.5457666,105.9304268,0.2000657,62.4944823,43.7858119,61634.8791909,246783.1810741,2.7847727,5636.1449204,986.2451357,4517.3498952,28.3109315,43.2404974,1.6678357,175.1464471),(13901,'Alces_metatarsus.tif',242,10,423,435.1977003,92.7106407,103.7776129,1.8,92.7107154,105.6403117,0.2033966,62.5318167,44.2760903,63169.7048999,260310.7112042,2.9595499,5879.2614589,1010.2010177,4751.0885466,29.0203374,39.7591988,1.7343702,186.6422061),(13902,'Alces_metatarsus.tif',242,10,424,446.7164049,92.710322,103.6257854,1.8,92.9222106,105.5507727,0.2043997,62.707403,44.4266443,63119.1846409,270268.9955729,3.0674998,6083.4888521,1006.5667149,4887.6840457,30.0880538,39.3779475,0.7306584,178.9933153),(13903,'Alces_metatarsus.tif',242,10,425,450.025121,93.300728,103.4764179,1.8,93.7994205,105.2627638,0.198449,62.8094124,43.6236486,64889.5009184,271391.1882004,2.9152416,6221.1941726,1033.1174655,4896.9691322,29.86396,55.4709072,1.0056469,272.2187227),(13904,'Alces_metatarsus.tif',242,10,426,448.5530909,94.4059432,103.2286233,1.8,94.9714305,104.9296877,0.1980011,63.2573317,42.8344677,65535.0850236,263703.1063538,2.8927762,6156.3297091,1036.0077368,4736.2099995,30.5269237,55.6471363,1.2360595,277.6748714),(13905,'Alces_metatarsus.tif',242,10,427,451.4206683,95.6394583,103.0473915,1.8,96.235448,104.9604334,0.2007982,63.7613281,44.0252663,69570.63539,255458.3550479,2.9929891,5802.5396879,1091.1101998,4617.5453908,5.6861638,13.8058104,2.7149652,36.2403826),(13906,'Alces_metatarsus.tif',242,10,428,444.1977034,97.9473613,102.6366046,1.8,97.9762127,104.8059848,0.2134361,65.0234155,46.2664553,69630.6615784,226330.8814887,3.3216677,4891.9001858,1070.8551847,4104.1411126,3.7207587,9.7324193,2.6078845,23.3294548),(13907,'Alces_metatarsus.tif',242,10,429,431.5374711,100.5069829,102.6687285,1.8,99.7597691,104.7626584,0.2033959,65.1926562,48.7314756,72318.1422492,186746.4103262,2.9346382,3832.1517668,1109.2989073,3515.7757511,28.651999,56.1053268,1.3933715,199.4990002),(13908,'Alces_metatarsus.tif',242,10,430,418.3785621,101.9243928,102.3528783,1.8,101.3566881,104.8686728,0.1623243,64.2682325,47.5342177,70514.7638978,162325.3274344,1.8212413,3414.9153055,1097.1946972,3111.3403287,28.512816,56.4147193,1.4012082,198.2527999),(13909,'Alces_metatarsus.tif',242,10,431,417.5769433,102.6880362,101.9694836,1.8,101.4290733,104.720001,0.1397418,63.8721121,50.4051216,69477.3804773,151901.1403837,1.3502341,3013.6052771,1087.7576792,2927.4370326,28.2140274,56.6187608,1.3813162,210.0864957),(13910,'Alces_metatarsus.tif',242,10,432,404.2669149,103.4371348,101.7908578,1.8,101.9236087,104.8357866,0.1106429,62.9274196,50.5364436,68329.1309533,134167.2629454,0.8214697,2654.8615887,1085.8403436,2655.8766563,28.7337165,56.9928484,1.3825748,221.1201952),(13911,'Alces_metatarsus.tif',242,10,433,374.6418315,104.5088102,101.6494157,1.8,103.1497937,104.5754558,0.0382349,59.8303209,51.2785809,67964.856572,105383.8679749,0.0912376,2055.1245023,1135.9600868,2249.6957051,0.380859,0.538616,2.3561945,1.0772319),(13912,'Alces_metatarsus.tif',242,10,434,306.0774228,105.3402748,101.6531614,1.8,103.4100663,104.33718,-0.3930009,59.9196607,69.8861551,60774.1875591,70836.6851133,7.4815569,1013.6011198,1014.2612104,1695.9668475,0.380859,0.538616,2.3561945,1.0772319),(13913,'Alces_metatarsus.tif',242,10,435,233.9696189,106.8258043,101.852923,1.8,104.4102822,104.8581425,-1.1627062,54.1171534,74.0693869,35098.9483227,60295.1720256,32.8534096,814.0363322,648.5734399,1215.962925,0.538616,1.0772319,0.7853982,2.1544639),(13914,'Alces_metatarsus.tif',242,10,436,223.456751,106.8218999,100.7773036,1.8,104.124808,103.6535757,-0.9211178,51.1853308,78.9576272,43564.216893,55955.4195807,23.6141309,708.6765591,851.1074595,1255.8680002,0.538616,1.0772319,0.7853982,2.1544639),(13915,'Alces_metatarsus.tif',242,10,437,195.5076957,106.0158541,99.6708278,1.8,104.3723537,102.5412524,-0.3434315,62.5985291,69.4324063,42240.4161834,51252.128837,3.6944605,738.1586145,674.7828874,1175.4786841,0.761718,4.6333497,1.4056476,9.7716439),(13916,'Alces_metatarsus.tif',242,10,438,159.9584044,105.835268,98.173582,1.8,103.9016819,101.2951781,-0.2486574,64.039039,65.6429707,35518.0737862,44016.4843594,1.6146895,670.5437597,554.6315867,987.3627948,0.380859,0.8516266,2.0344439,1.8389499),(13917,'Alces_metatarsus.tif',242,10,439,132.0142722,106.8967382,96.4633155,1.8,104.5765455,100.5619442,-0.4515802,65.1439392,75.4065392,27997.3314769,34413.9742574,4.1900091,456.3791761,429.7764582,756.0992068,0.380859,0.8516266,2.0344439,1.8389499),(13918,'Alces_metatarsus.tif',242,10,440,127.3288658,107.8864422,96.6443137,1.8,104.2222814,100.3944603,-0.7393383,59.4973487,82.4442819,21548.4135955,29439.7332045,9.6346627,357.0864168,362.1743502,613.9613131,0.380859,1.2043819,1.8925469,2.6006679),(13919,'Alces_metatarsus.tif',242,10,441,123.0957629,108.6581586,96.8799804,1.8,103.8833214,100.2537097,-0.8100676,56.9397931,83.305787,16111.4750217,27484.7301489,10.7638928,329.9258206,282.9563322,522.8866925,0.380859,0.8516266,2.0344439,1.8389499),(13920,'Alces_metatarsus.tif',242,10,442,120.5196992,109.4742249,96.559158,1.8,105.0795557,99.5882231,-0.8547357,55.0327664,84.1531692,11253.6149519,24154.385472,11.4316052,287.0288274,204.489356,420.7417353,0.380859,0.8516266,2.0344439,1.8389499),(13921,'Alces_metatarsus.tif',242,10,443,116.5010558,109.7729172,96.1100768,1.8,106.67669,99.2900734,-0.8566109,55.0342633,84.6866772,8136.5335288,21547.4334692,11.0864777,254.4371109,147.8448705,350.4996916,0.380859,0.538616,2.3561945,1.0772319),(13922,'Alces_metatarsus.tif',242,10,444,112.607598,109.8980128,95.6523225,1.8,106.6045551,99.1159265,-0.8263893,56.3238687,84.8354582,6240.6606641,20783.130236,10.1524241,244.9816467,110.799574,318.4305012,0.380859,0.8516266,2.0344439,1.8389499),(13923,'Alces_metatarsus.tif',242,10,445,110.2436203,110.4465989,95.1725432,1.8,107.9569118,98.9382022,-0.8354163,55.9203898,85.5493053,4526.3649324,20645.6203796,10.1044663,241.3300762,80.9430147,294.22421,0.380859,0.538616,2.3561945,1.0772319),(13924,'Alces_metatarsus.tif',242,10,446,103.2661476,110.6224331,94.7252919,1.8,107.8841149,98.78713,-0.8413363,55.8717207,86.0035993,3486.0979559,21113.6170109,9.566257,245.4968999,62.3946768,286.0257363,0.380859,0.538616,2.3561945,1.0772319),(13925,'Alces_metatarsus.tif',242,10,447,88.5679564,110.7071545,94.4525816,1.8,107.6754629,97.5084423,-0.8437849,46.2550477,86.2647148,2157.9705255,21171.3385737,8.240571,245.4229244,46.6537305,270.4350834,0.380859,0.538616,2.3561945,1.0772319),(13926,'Alces_metatarsus.tif',242,10,448,67.4458258,110.4102367,95.9015689,1.8,107.0937532,103.1511471,-0.9040866,45.5230696,84.8121328,2122.9450415,23890.1623719,6.9421647,281.6833108,46.634488,306.0895897,23.232399,58.3025346,1.6034644,166.7358383),(13927,'Alces_metatarsus.tif',242,10,449,47.6844297,108.7693002,99.9205793,1.8,104.8732917,109.4529149,-0.9304525,43.8664278,80.1310893,2185.2169162,27766.3058555,5.1104055,346.5110248,49.8152466,371.461926,0.380859,0.538616,2.3561945,1.0772319),(13928,'Alces_metatarsus.tif',242,10,450,28.2997333,100.3138482,114.8736253,1.8,100.8375111,114.5486368,-0.8181637,49.2121311,63.9375095,4173.3552101,22406.8918656,2.5127432,350.4498695,84.8033831,414.9178201,0.380859,0.538616,2.3561945,1.0772319),(13929,'Alces_metatarsus.tif',242,10,451,6.444203,79.359952,135.3356648,1.8,92.6404683,120.3433159,-0.8819067,45.397879,61.3006937,336.1538677,9770.0477503,0.640028,159.3790733,7.4046161,164.8341798,0.380859,0.538616,2.3561945,1.0772319),(13930,'Alces_metatarsus.tif',242,10,452,4.2342018,60.7026635,158.7423348,1.8,61.8047744,158.2965222,-0.0596471,22.2951653,58.7324101,15.9763764,127.8958396,0.0025077,2.1776024,0.7165848,2.4429418,11.3498513,162.2678364,3.1251622,341.9375458),(13931,'Alces_metatarsus.tif',242,10,453,4.7218016,61.1648769,158.7215648,1.8,61.5159968,158.4315294,-0.0051371,23.7633323,26.1742544,12.7285837,110.9855976,0.0000208,4.2402582,0.5356397,3.4994629,11.3299106,162.6553326,3.1228595,343.3302917),(13932,'Alces_metatarsus.tif',242,10,454,5.3749823,63.0030555,157.7602901,1.8,66.1408958,155.0508525,-0.6113743,16.2338656,87.4748938,73.0278947,573.603912,0.2951478,6.5573548,4.4984908,7.3204909,11.2169132,162.6553326,3.1228595,343.0147778),(13933,'Alces_metatarsus.tif',242,10,455,8.0655504,72.2420528,146.5486726,1.8,83.0009623,132.5515948,-0.8446225,42.0623187,70.6091952,577.7856581,5465.9654375,0.7515559,77.4115244,13.7364196,84.6094198,0,0,0,0),(13934,'Alces_metatarsus.tif',242,10,456,8.9984207,74.9499261,145.8967211,1.8,86.6432133,132.1695606,-0.7784746,31.1444271,68.5008884,557.9514874,7225.3360952,0.7394852,105.4779911,17.9149703,113.5287685,0,0,0,0),(13935,'Alces_metatarsus.tif',242,10,457,8.7263353,70.1166549,153.3529168,1.8,77.9820704,144.2146407,-0.7805123,32.9771276,76.0986339,320.8951467,3042.0907599,0.7200888,39.9756291,9.7308398,44.1883212,11.3985047,163.4244623,3.1206167,345.1692416),(13936,'Alces_metatarsus.tif',242,10,458,8.8972348,68.6490228,155.9571826,1.8,71.8824754,150.2888257,-0.7880336,45.8524418,77.3513401,535.2932986,1393.5362475,0.7453443,18.0156704,11.6742594,24.9285082,11.7460711,163.8136499,3.118341,345.9309596),(13937,'Alces_metatarsus.tif',242,10,459,9.5609648,69.5040623,157.9130671,1.8,71.0087467,156.9004975,-0.0778781,41.9287803,58.0940865,142.0060191,1009.3275869,0.009645,17.374016,3.3868388,16.0700732,11.7061897,163.8136499,3.118341,346.2464735),(13938,'Alces_metatarsus.tif',242,10,460,11.0981372,72.2708421,156.8909812,1.8,74.7745789,153.4817484,-0.3121079,45.724183,68.6593962,559.6367181,1609.8620037,0.1744057,23.4470749,12.2394033,28.5359577,11.7034612,163.8136499,3.118341,346.5619875),(13939,'Alces_metatarsus.tif',242,10,461,11.4535624,73.150337,158.1021186,1.8,73.0200207,157.994909,0.094224,22.7665299,24.3805957,6.5577222,1519.7468704,0.0168977,62.3342797,0.2880422,61.6942015,11.6336731,163.8229472,3.1160168,345.6154457),(13940,'Alces_metatarsus.tif',242,10,462,12.4816846,74.6588216,158.0031869,1.8,74.1592944,157.9291784,0.0952408,3.4544986,25.1623073,1.8638879,1856.2182746,0.0188128,73.7697959,0.5395538,73.8047058,11.6336731,164.2138405,3.1137576,346.6926776),(13941,'Alces_metatarsus.tif',242,10,463,13.461983,76.1003582,157.8649904,1.8,75.5644041,157.7874106,0.0944406,3.2239246,44.1437823,2.0067653,2233.9988464,0.0199519,50.6073275,0.6224604,50.5182412,11.9054629,164.2248816,3.1114394,348.1778354),(13942,'Alces_metatarsus.tif',242,10,464,13.0386463,77.0321891,157.6547658,1.8,76.5313928,157.4909964,0.0941494,21.1971566,47.0285011,10.3141389,2341.6202982,0.0192058,49.7915146,0.4865812,49.8902101,11.9879472,164.6174639,3.1091966,347.7699095),(13943,'Alces_metatarsus.tif',242,10,465,14.2058881,77.8601209,157.4286882,1.8,77.4841575,157.2892606,0.0981542,20.6102429,48.4500594,8.1789841,2719.6449485,0.0227374,56.1329538,0.3968407,56.1332202,12.2888235,165.0108703,3.1069645,349.1626554),(13944,'Alces_metatarsus.tif',242,10,466,14.2285692,78.1742068,157.2451499,1.8,77.6513252,157.1101624,0.1016155,19.7279146,48.1429165,8.7046259,2764.8593807,0.0244025,57.4302427,0.441234,57.4406901,12.2755317,165.0108703,3.1069645,349.1626554),(13945,'Alces_metatarsus.tif',242,10,467,13.936528,78.3941708,157.0844554,1.8,77.7006898,156.9938975,0.1065911,2.2692429,26.4580421,1.6294984,2775.8939663,0.0262906,104.9168325,0.7180802,104.9706849,12.2755317,165.0244951,3.104658,349.4781693),(13946,'Alces_metatarsus.tif',242,10,468,14.1240427,78.3797735,156.9021809,1.8,77.8803013,156.8352329,0.111225,2.1971058,26.4908096,1.6071785,2833.2882282,0.0290015,106.9536293,0.731498,107.0089744,12.2622399,165.4195641,3.1024422,350.5554012),(13947,'Alces_metatarsus.tif',242,10,469,14.4568308,78.4466201,156.7561154,1.8,77.7737268,156.6730838,0.1163235,0.8867372,26.4396757,1.543813,2907.1404429,0.0324562,109.9537104,1.741004,110.0073201,12.6295751,165.785696,3.1048276,352.1712491),(13948,'Alces_metatarsus.tif',242,10,470,14.2414482,78.5139284,156.6376137,1.8,77.9141621,156.5674258,0.1213815,0.8799369,26.3856263,1.4639517,2865.4262614,0.0347996,108.5980006,1.6637008,108.6484323,12.964263,166.1807011,3.1026216,353.025379),(13949,'Alces_metatarsus.tif',242,10,471,14.0209228,78.5251239,156.5377187,1.8,77.9977875,156.4654198,0.1263403,1.3641442,26.3855212,1.4942385,2832.5677785,0.037102,107.3531108,1.095367,107.4034872,13.0500775,166.5469016,3.1049957,354.102611),(13950,'Alces_metatarsus.tif',242,10,472,13.6701569,78.4068984,156.4496149,1.8,77.9982948,156.3819719,0.1317583,1.3657727,26.1348088,1.4373806,2734.4308257,0.0393245,104.6279255,1.0524304,104.6757556,13.411349,166.5612716,3.1027107,354.6412269),(13951,'Alces_metatarsus.tif',242,10,473,13.4150384,78.1796162,156.31268,1.8,78.0094672,156.27194,0.1384917,1.5709751,26.3761666,1.4467795,2683.2984833,0.0426099,101.7319355,0.9209436,101.776359,13.6442127,166.9570482,3.1005199,355.4953568),(13952,'Alces_metatarsus.tif',242,10,474,13.0615033,77.8121037,156.2620725,1.8,77.4315644,156.2034595,0.1452141,0.7651185,25.990299,1.3054438,2519.4738425,0.0455832,96.9390094,1.706198,96.9748467,14.0247092,167.3536224,3.0983395,356.8881027),(13953,'Alces_metatarsus.tif',242,10,475,12.9935479,77.4386883,156.2161333,1.8,77.0076756,156.1366261,0.151774,0.730733,25.9863901,1.3161504,2436.6109236,0.0495033,93.7648867,1.8011373,93.7928379,14.4550442,167.7181267,3.1007064,358.2808485),(13954,'Alces_metatarsus.tif',242,10,476,12.6281447,77.0261102,156.1965036,1.8,76.5282088,156.10423,0.1582291,1.4332831,25.6404729,1.3041545,2288.3617258,0.0522557,89.2480311,0.9099071,89.2688712,14.8939816,168.479211,3.1008912,360.7508263),(13955,'Alces_metatarsus.tif',242,10,477,12.1485888,76.5068001,156.1839766,1.8,75.9626633,156.0811986,0.1640195,0.8165032,25.0233356,1.2439612,2113.8785281,0.0539843,84.4762888,1.5235228,84.4930065,14.9352178,168.479211,3.1008912,360.4353124),(13956,'Alces_metatarsus.tif',242,10,478,12.2484999,75.9507439,156.1630517,1.8,75.5297236,156.074423,0.1694685,1.9708518,25.0026646,1.3161343,2047.0591777,0.0580695,81.8736406,0.6677997,81.6729365,15.3277757,168.495138,3.0986327,361.5125443),(13957,'Alces_metatarsus.tif',242,10,479,12.1296,75.2619388,156.1586188,1.8,74.8587338,156.0644528,0.1747158,1.996901,28.8039625,1.3424691,1919.7895503,0.0610852,66.6501893,0.6722763,66.5370903,15.8607404,169.240301,3.1010743,363.536318),(13958,'Alces_metatarsus.tif',242,10,480,11.6841976,74.8395099,156.1946519,1.8,74.9076723,156.1430737,0.1782048,2.1731539,31.1478216,1.6749751,1783.2726133,0.0611905,57.2519207,0.7707577,57.1670715,15.9561118,169.6058821,3.103409,364.9290638),(13959,'Alces_metatarsus.tif',242,10,481,11.2809047,74.0949154,156.1677661,1.8,73.650725,156.0453379,0.1858497,2.8722077,33.738561,1.521979,1616.5290316,0.0641964,47.9133959,0.5298986,47.7857371,16.4031977,169.6208481,3.1011653,366.0062958),(13960,'Alces_metatarsus.tif',242,10,482,11.3171241,73.5546882,156.2271763,1.8,73.6270182,156.186521,0.1868562,3.5595215,36.8750467,1.7464223,1553.3316393,0.0650938,42.1241945,0.490634,41.9764424,16.8369919,170.017181,3.0990175,366.8604257),(13961,'Alces_metatarsus.tif',242,10,483,10.5830651,72.7817251,156.2697948,1.8,72.4647724,156.1787347,0.1936345,5.3191225,44.3277314,1.4090812,1329.7694612,0.0653117,29.9985905,0.2649086,29.8164834,16.890159,170.3670474,3.1035797,367.6221437),(13962,'Alces_metatarsus.tif',242,10,484,10.4569564,72.3150427,156.3577515,1.8,71.6790965,156.2154675,0.1985889,2.0259282,20.098336,1.1366848,1212.4512279,0.067834,60.3259507,0.5610686,60.339626,17.5161019,170.720445,3.108123,369.0148895),(13963,'Alces_metatarsus.tif',242,10,485,9.9642138,71.8753134,156.4652266,1.8,71.4227718,156.3407707,0.1987104,5.9872012,43.581516,1.3750018,1100.6916975,0.0647156,25.2559295,0.2296569,25.0521786,17.8058151,171.0887982,3.1104224,369.8690194),(13964,'Alces_metatarsus.tif',242,10,486,9.7704134,71.3062684,156.5584112,1.8,70.4806419,156.3656244,0.2033089,1.5260618,18.8039285,1.0452,998.4572386,0.0663869,53.098332,0.6849002,53.1068888,17.8357242,171.0887982,3.1104224,371.6696911),(13965,'Alces_metatarsus.tif',242,10,487,9.5039544,70.7370083,156.6522228,1.8,69.8976491,156.4515318,0.2046091,1.7412946,18.2224647,1.0201837,916.6247273,0.0653934,50.3019072,0.5858766,50.3104763,18.1540272,171.4474766,3.1149323,371.5772792),(13966,'Alces_metatarsus.tif',242,10,488,9.2357371,70.1345029,156.7444134,1.8,69.2183228,156.5386499,0.2065185,0.8837072,18.046187,0.9527406,828.8250852,0.0647225,45.9279894,1.078118,45.9257524,18.5646648,171.4474766,3.1149323,372.1158951),(13967,'Alces_metatarsus.tif',242,10,489,8.9933218,69.7641656,156.8279132,1.8,68.7783216,156.5896823,0.2074323,1.6680733,17.6451846,0.9718955,769.2726364,0.0635746,43.5967463,0.5826455,43.5949916,18.955363,171.8184922,3.1172072,374.3627709),(13968,'Alces_metatarsus.tif',242,10,490,19.580299,80.5117472,141.601445,1.8,82.469398,138.5083748,-0.8891375,28.0790068,26.4174772,630.6171184,5912.3151716,1.967809,223.8031715,22.458669,204.5348167,0,0,0,0),(13969,'Alces_metatarsus.tif',242,10,491,43.6052154,85.5740941,134.5265356,1.8,85.8006348,134.0213029,-0.8988184,28.3096707,35.2758211,905.9117294,8739.4114527,4.4510029,247.7450896,32.00008,257.3396267,14.811939,15.3198136,0.6086893,48.4820042),(13970,'Alces_metatarsus.tif',242,10,492,67.3735188,86.9489941,132.5579143,1.8,86.8626385,132.467627,-0.8897684,25.4701358,37.8402175,1540.2886952,10208.8980614,6.7779329,269.789624,60.4743024,295.969339,17.900373,18.6970351,0.9884434,59.6463939),(13971,'Alces_metatarsus.tif',242,10,493,92.5278312,87.6606671,131.5995427,1.8,87.4817723,131.7079131,-0.8828933,25.5209382,39.3534329,2461.8321367,11663.0975258,9.2046459,296.367983,96.4632303,344.2448232,20.947245,21.3076911,1.06717,68.6180415),(13972,'Alces_metatarsus.tif',242,10,494,115.1538597,88.1883807,131.0696017,1.8,88.3470218,131.294825,-0.8641157,30.9618477,40.5999137,3716.2831567,12936.7489096,11.1006939,318.6398129,120.0278224,396.669973,22.85154,23.3445131,0.9827937,75.1197113),(13973,'Alces_metatarsus.tif',242,10,495,441.8784286,107.3571492,132.4173032,1.8,103.4838168,132.324255,0.0227283,27.916266,53.1460415,27171.1676819,89816.369572,0.0380376,1689.9917117,973.3095265,2009.459867,24.6918643,25.061564,0.6343828,81.1751771),(13974,'Alces_metatarsus.tif',242,10,496,560.2043902,109.0951308,132.7225748,1.8,102.9793915,132.2152685,0.054118,28.7637123,54.1485747,34782.4316514,113398.768973,0.2731844,2094.2152134,1209.2469609,2475.7700665,25.517553,26.3564335,0.9186249,84.9837671),(13975,'Alces_metatarsus.tif',242,10,497,575.5779596,108.7413504,132.603257,1.8,102.6659577,132.1400711,0.0680257,29.3611243,53.4157857,35900.3362928,118832.6610888,0.4432308,2224.6730896,1222.7166747,2591.0804575,27.040989,27.4984418,0.9328353,88.9771808),(13976,'Alces_metatarsus.tif',242,10,498,586.5859438,108.3880095,132.5526372,1.8,102.3570699,132.0771349,0.0703927,29.5209272,52.9987409,37063.2066464,123844.9426541,0.4836359,2336.752545,1255.4892462,2708.352708,29.3936221,57.2303223,2.9676915,187.2798014),(13977,'Alces_metatarsus.tif',242,10,499,593.2048264,108.1573006,132.4881604,1.8,102.1513574,131.9718676,0.077302,30.8632924,52.5543396,37467.0091094,126679.6930245,0.5896157,2410.4516193,1213.9666943,2764.5480465,29.4154687,57.4794341,2.9818905,181.7246734),(13978,'Alces_metatarsus.tif',242,10,500,597.6269386,108.021882,132.4543506,1.8,102.0558229,131.9438693,0.0802723,30.9532825,52.3372265,37828.0957967,128384.0806277,0.6404381,2453.0165101,1222.1028839,2776.4372999,29.3591741,57.6721643,2.9623298,180.7398534),(13979,'Alces_metatarsus.tif',242,10,501,600.081421,107.9550017,132.4308842,1.8,102.0095877,131.9131373,0.0802427,30.0977655,52.238947,38054.1958351,129396.2998587,0.6425949,2477.0081945,1264.3528591,2827.9327474,0.380859,0.538616,2.3561945,1.0772319),(13980,'Alces_metatarsus.tif',242,10,502,601.5668136,107.9361435,132.4255728,1.8,102.0349473,131.9402011,0.0818491,30.2209099,52.1758999,38137.3296369,129754.9198595,0.6701784,2486.8745938,1261.9517342,2828.7754314,29.3591741,57.6054746,2.9688354,179.9781354),(13981,'Alces_metatarsus.tif',242,10,503,603.8131221,107.9344332,132.4181966,1.8,102.0602996,131.9274384,0.0821528,30.2703869,52.1340374,38317.3935866,130237.982711,0.6776702,2498.1372846,1265.8375877,2839.8796951,29.3774528,57.6054746,2.9688354,180.2012374),(13982,'Alces_metatarsus.tif',242,10,504,604.7494649,107.9205154,132.4112174,1.8,102.0432761,131.9314444,0.0824298,30.3490621,52.11191,38406.810991,130613.1594801,0.6832947,2506.3974731,1265.5024037,2848.1814735,29.3774528,57.6344249,3.0090411,179.8857235),(13983,'Alces_metatarsus.tif',242,10,505,602.372784,107.9785145,132.4266339,1.8,102.1345261,131.9126996,0.083362,30.3733557,52.145105,38290.0354511,129890.6575183,0.6960548,2490.9463213,1260.6455408,2831.8084317,29.3178733,57.6344249,3.0090411,180.9629554),(13984,'Alces_metatarsus.tif',242,10,506,601.9320848,107.9778842,132.4461664,1.8,102.1783257,132.0317565,0.0858943,31.2326289,52.0429562,38344.2863706,129808.2185036,0.7383405,2494.2514415,1227.6996112,2824.3428831,29.3178733,57.5853266,3.015597,180.7398534),(13985,'Alces_metatarsus.tif',242,10,507,602.029007,107.9547273,132.454151,1.8,102.1704114,132.0492139,0.0848534,30.4642305,52.0499641,38551.5538481,130110.0768108,0.7207114,2499.7150161,1265.4694767,2834.0554381,29.3178733,57.5853266,3.015597,179.3471075),(13986,'Alces_metatarsus.tif',242,10,508,603.3321156,107.9507864,132.4528457,1.8,102.1606555,132.0359194,0.0862464,30.5510397,52.0065769,38817.6711162,130406.1236839,0.7461213,2507.4929274,1270.5842918,2843.6476238,29.3774528,57.6054746,2.9688354,179.3471075),(13987,'Alces_metatarsus.tif',242,10,509,605.0182096,107.9247139,132.4734135,1.8,102.1401434,132.1187129,0.0847077,30.5013929,52.0257977,39302.8554387,131182.1182273,0.7218116,2521.4821089,1288.5593641,2866.3925843,29.3774528,57.6054746,2.9688354,178.3622875),(13988,'Alces_metatarsus.tif',242,10,510,606.4042625,107.90954,132.488728,1.8,102.1314477,132.1941777,0.0861061,30.9785021,51.9725362,39640.851015,131549.5544374,0.7474894,2531.1359442,1279.6245239,2879.2274142,29.3178733,57.6054746,2.9688354,178.5853895),(13989,'Alces_metatarsus.tif',242,10,511,607.8043811,107.8879552,132.49431,1.8,102.0372179,132.1899757,0.0845106,30.4698141,51.964339,39932.5346469,132233.3833884,0.7217727,2544.6948044,1310.5604948,2889.0494576,29.3028796,57.6054746,2.9688354,178.5853895),(13990,'Alces_metatarsus.tif',242,10,512,609.3825641,107.8726621,132.5047061,1.8,102.0486326,132.2439722,0.0847864,30.4688627,51.9421105,40288.6375111,132679.1559162,0.7283667,2554.3659026,1322.2888516,2903.3937055,29.3028796,57.6054746,2.9688354,178.5853895),(13991,'humerus-1.tif',40,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(13992,'humerus-1.tif',40,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(13993,'humerus-1.tif',40,2,3,0.0009326,13.3424332,5.6853276,1.8,13.3140756,5.6988752,-0.0071683,0.3380429,5.929104,0.0000445,0.0031486,0.000000008,0.000531,0.0001317,0.0005383,0,0,0,0),(13994,'humerus-1.tif',40,2,4,0.0038718,14.0237367,6.7841054,1.8,14.0375942,6.846645,0.1915505,5.7262293,6.167879,0.0092059,0.0239328,0.0000234,0.0038802,0.0016077,0.0042983,0.0501,0.0708521,2.3561945,0.1417042),(13995,'humerus-1.tif',40,2,5,0.0046197,12.7462569,7.1305309,1.8,12.8198198,6.9398138,-0.4871329,4.0920755,7.2017639,0.0171915,0.0264929,0.0001687,0.0036787,0.0042012,0.0059948,0,0,0,0),(13996,'humerus-1.tif',40,2,6,0.0032556,11.1629304,10.2055871,1.8,11.184229,10.2669219,-0.5983617,14.5678063,8.2681144,0.0687798,0.0785583,0.0001722,0.0095014,0.0047214,0.0095147,0.1002,0.1806381,2.5535901,0.3836084),(13997,'humerus-1.tif',40,2,7,0.0052788,12.5968722,11.1328489,1.8,12.6517241,11.286499,-0.2347728,10.9783526,10.3101394,0.1022542,0.1752485,0.0000476,0.0169977,0.0093142,0.0213261,0,0,0,0),(13998,'humerus-1.tif',40,2,8,0.0094349,13.7629059,11.65268,1.8,13.6334631,11.733003,0.2315846,8.8057327,10.6815836,0.1496335,0.2694974,0.0000828,0.0252301,0.0169927,0.0348208,0,0,0,0),(13999,'humerus-1.tif',40,2,9,0.0472925,15.4170733,14.0185019,1.8,15.4141561,14.0247549,1.0039173,15.1140397,12.6112515,0.2493095,0.868355,0.0056091,0.0688556,0.0164952,0.0732904,0.2609289,0.3912935,0.6947383,1.0506252),(14000,'humerus-1.tif',40,2,10,0.0880854,16.1324223,14.7477502,1.8,16.1392824,14.7842071,0.920231,15.3429307,14.3265017,0.4148096,1.2037726,0.009296,0.0840242,0.0270359,0.10546,0.1503,0.224054,2.677945,0.5253126),(14001,'humerus-1.tif',40,2,11,0.1753189,16.6500469,15.6775689,1.8,16.6631034,15.6801773,0.8314461,15.9419049,15.7964376,0.8155753,2.3043297,0.0159535,0.1458765,0.0511592,0.1922441,0.1002,0.1806381,0.9827937,0.3836084),(14002,'humerus-1.tif',40,2,12,0.3306541,16.2152215,15.5142344,1.8,16.1967065,15.5271663,0.6868417,16.6893194,15.9922386,2.8022396,6.0688923,0.0221583,0.3794899,0.1679062,0.5234677,0.2004,0.2834084,2.3561945,0.6255126),(14003,'humerus-1.tif',40,2,13,0.8047021,15.5451055,15.9656388,1.8,15.4072824,15.9899273,0.2242192,13.0237972,14.2806932,11.6181098,17.6890947,0.0066304,1.238672,0.8920678,1.7886592,0.9202007,1.2831862,0.6747409,6.9393347),(14004,'humerus-1.tif',40,2,14,2.9953029,15.1262087,15.9504166,1.8,14.8975326,15.9537828,-0.7540235,15.8770783,15.6914779,64.0381515,70.4533744,0.2339561,4.4899133,4.0333713,8.4327381,0.0501,0.112027,2.677945,0.2125563),(14005,'humerus-1.tif',40,2,15,9.5239463,16.3953988,16.0013811,1.8,16.195473,16.0879452,-1.224562,14.9175746,13.2397593,173.7702964,193.3961131,1.404522,14.6072227,11.6486963,23.5059236,0.3378219,0.6532241,3.0648208,1.7641816),(14006,'humerus-1.tif',40,2,16,15.066416,17.0385575,15.9468409,1.8,16.608294,15.8381484,0.7816641,16.8093421,16.7467144,154.9098251,207.8368978,1.2461583,12.4106074,9.2156983,21.2711201,0.1002,0.1806381,0.5880026,0.3542605),(14007,'humerus-1.tif',40,2,17,20.4907853,17.248144,15.9789705,1.8,16.2659973,16.0223272,0.7800688,14.9443387,15.5778375,59.2990681,195.1109942,1.6893654,12.5249088,3.9679955,15.9633198,0.347287,0.6978123,2.7744188,1.8593463),(14008,'humerus-1.tif',40,2,18,31.1424288,17.200413,15.9669302,1.8,17.2566235,16.19356,0.8100299,11.5653227,7.87262,82.4841679,338.1948443,2.7229992,42.9583602,7.1320248,32.9740888,8.341674,13.093365,2.2993452,58.5370051),(14009,'humerus-1.tif',40,2,19,39.0486678,17.0571475,16.0021596,1.8,16.9612111,15.8576541,0.7936654,5.2686966,7.5301973,148.5838792,458.8594666,3.3078575,60.9359152,28.2012596,79.4205697,9.0222654,13.9391496,2.4427127,64.6332355),(14010,'humerus-1.tif',40,2,20,43.4956035,16.960194,15.9378524,1.8,16.9492372,15.9491085,0.7417179,6.7382579,7.8029692,211.6895798,541.5820701,3.3083862,69.407178,31.4160699,96.2831215,10.6464298,15.0654463,2.391474,83.8409184),(14011,'humerus-1.tif',40,2,21,45.0858246,17.0128189,15.8452809,1.8,16.7516867,16.0244608,0.7434224,8.6464108,9.1102426,253.008606,573.5901912,3.4421041,62.9610224,29.2616914,88.9725906,12.6738636,16.1264428,2.4750999,118.5346421),(14012,'humerus-1.tif',40,2,22,45.8226613,17.0523407,15.7683156,1.8,16.4855166,15.9738217,0.7484729,9.6492977,9.8250878,276.1840296,588.1743359,3.5368091,59.8645374,28.6221897,78.7985004,0.0501,0.112027,2.677945,0.2125563),(14013,'humerus-1.tif',40,2,23,45.8361692,17.0677269,15.7127264,1.8,16.7909609,16.0052529,0.726688,15.6885425,13.2598805,274.6765542,587.6446377,3.372203,44.3174911,17.508099,54.6128769,12.6937705,15.6132861,2.5874151,96.3654129),(14014,'humerus-1.tif',40,2,24,45.2264545,17.0092218,15.703646,1.8,16.6326956,16.0643897,0.6750987,11.7529315,10.3781299,272.4670139,570.3395889,2.9441891,54.9559118,23.1828981,61.9320763,12.7202388,15.4686545,2.4663459,104.4342098),(14015,'humerus-1.tif',40,2,25,44.3471681,16.9020088,15.6594895,1.8,16.7293745,16.1131146,0.6235822,10.0299298,8.7451142,263.6575691,567.3394906,2.5203529,64.8750236,26.2870801,79.3865603,11.9570891,14.9781412,2.6390425,80.3519738),(14016,'humerus-1.tif',40,2,26,42.7243437,16.8182997,15.6519884,1.8,16.8067154,16.2007178,0.5929038,12.6900416,8.8059855,247.2058933,557.9224174,2.2232727,63.3571807,19.480306,63.4265393,11.6182692,14.9700952,2.3041089,83.05651),(14017,'humerus-1.tif',40,2,27,39.7736093,16.7824062,15.7808584,1.8,16.4891218,16.3493029,0.5361331,11.8573957,9.7376703,227.8433524,523.9331712,1.7297043,53.804776,19.2152946,60.2982881,11.6641145,15.0780199,2.7314653,83.7851722),(14018,'humerus-1.tif',40,2,28,35.667203,16.7675022,16.2275613,1.8,16.4696214,16.4703379,0.4316019,14.3096598,13.2414709,192.5724151,485.9955263,1.0402751,36.7025332,13.4575118,41.3120721,11.2650761,15.2024409,2.8542394,86.4159067),(14019,'humerus-1.tif',40,2,29,31.8758539,16.7172283,16.7690123,1.8,16.3356461,15.9679929,0.362665,12.9328645,13.2274954,160.8166982,464.0460383,0.6686479,35.0819277,12.4347316,38.9085942,0.1002,0.224054,1.1071487,0.4838084),(14020,'humerus-1.tif',40,2,30,29.3313245,16.5856555,17.1837129,1.8,16.1642651,16.1742113,0.3522717,13.4144789,15.3550081,140.1452414,435.336442,0.5819642,28.3514304,10.4473116,35.935744,0.0501,0.0708521,2.3561945,0.1417042),(14021,'humerus-1.tif',40,2,31,27.9919971,16.4033959,17.4208604,1.8,16.0904484,16.363792,0.3464425,12.2652269,16.4033754,117.994478,403.9071063,0.5378979,24.6234142,9.6202442,29.9766237,12.9325096,23.4453022,1.3859734,195.3309905),(14022,'humerus-1.tif',40,2,32,27.6114696,16.2439952,17.626923,1.8,16.1314448,16.8924858,0.3087192,12.0786582,13.894998,89.0539507,362.2397625,0.4248389,26.069796,7.3728347,29.2052353,11.1935854,14.0669529,2.7544726,101.3229743),(14023,'humerus-1.tif',40,2,33,27.7312955,16.1332456,17.7603322,1.8,16.0916347,17.3926894,0.2789885,12.8166921,14.2515469,73.3562461,319.7296492,0.3505051,22.4347331,5.7234929,24.2512897,10.6551171,13.9325755,2.789135,94.4968599),(14024,'humerus-1.tif',40,2,34,27.9008479,16.0722084,17.8321056,1.8,16.0992058,17.5880741,0.2575885,12.059853,14.2196965,65.5473763,279.769048,0.3017814,19.6747553,5.4351721,23.4336114,9.4324748,12.7597732,2.7887962,71.7972828),(14025,'humerus-1.tif',40,2,35,27.920592,16.0414729,17.8763947,1.8,16.0489832,17.6329803,0.2316363,12.1935089,15.24127,67.8484679,255.3976031,0.2452479,16.7569765,5.5643104,18.9713705,9.4112738,12.6638099,2.743454,77.7002342),(14026,'humerus-1.tif',40,2,36,27.6905793,16.0348117,17.8874226,1.8,16.0234757,17.6428499,0.2005893,12.3640177,11.5282938,72.0578796,235.0385428,0.1832161,20.3879729,5.8280311,23.0321063,9.2275327,12.3376278,2.7761681,72.7963332),(14027,'humerus-1.tif',40,2,37,27.5465376,16.0481379,17.8696591,1.8,16.1141044,17.5783817,0.1776895,12.3407495,10.3682919,74.4677805,216.0460321,0.1434379,20.8371865,6.0342996,19.5996122,8.9116416,11.8837374,2.894569,67.5796759),(14028,'humerus-1.tif',40,2,38,27.3917707,16.0413703,17.8516678,1.8,16.0647721,17.6377689,0.1662624,12.457784,11.5230161,72.3621801,200.6070311,0.1250407,17.4092468,5.8085916,17.5848569,8.8810296,11.6900601,2.7316362,69.175755),(14029,'humerus-1.tif',40,2,39,27.2398918,16.0299121,17.8194051,1.8,16.0499437,17.5898566,0.1470707,12.4401486,9.1916005,75.7149075,188.0548051,0.0974929,20.459419,6.0863347,19.6557026,8.8101119,11.596392,2.9238609,64.6604977),(14030,'humerus-1.tif',40,2,40,26.975149,16.0273206,17.7734198,1.8,16.1057134,17.5538541,0.1266424,12.4205536,8.0754698,76.8300853,174.3244402,0.0717213,21.5869101,6.1857215,19.1292182,8.5584348,11.0434997,2.8327539,62.2091581),(14031,'humerus-1.tif',40,2,41,26.7695903,16.033393,17.7272802,1.8,16.0505964,17.5291648,0.1090828,12.4190873,9.0835309,79.3912293,164.2452525,0.0528786,18.081653,6.3926783,18.4640579,8.7541013,11.3037419,2.755325,63.6220288),(14032,'humerus-1.tif',40,2,42,26.5693969,16.042634,17.6821639,1.8,16.0581297,17.506175,0.0904004,12.3381781,8.2137609,79.8594482,153.1024753,0.0360901,18.6397531,6.4725479,18.0762046,8.3938368,10.9508337,2.8444392,60.8801598),(14033,'humerus-1.tif',40,2,43,26.3448391,16.0408484,17.6321308,1.8,16.0985936,17.494271,0.0712398,12.0790099,8.4294964,79.5808409,144.5141266,0.0222462,17.1438625,6.5883579,17.9340714,8.3528291,10.6023963,2.9562447,60.4500118),(14034,'humerus-1.tif',40,2,44,26.0043176,16.0311784,17.588364,1.8,16.1198299,17.378312,0.0516924,11.792139,7.5111433,81.8517325,138.9185762,0.0115707,18.4949974,6.9412116,17.0093091,8.3974722,10.7924522,2.8448002,62.4955161),(14035,'humerus-1.tif',40,2,45,25.6576861,16.0205604,17.5470877,1.8,16.0990591,17.3758248,0.0309716,11.5970514,9.0827678,80.7773166,132.6233139,0.0041007,14.601641,6.9653323,16.7074464,9.5404901,13.1305023,1.6970444,81.8985637),(14036,'humerus-1.tif',40,2,46,25.3585193,16.0307609,17.5049123,1.8,16.0935396,17.3400016,0.0242672,11.6031011,8.0257716,80.7998613,127.6451436,0.0024885,15.9044078,6.9636437,17.2789805,8.3710009,10.4671842,2.8652654,55.8861294),(14037,'humerus-1.tif',40,2,47,25.0718684,16.0343057,17.4635111,1.8,16.0944611,17.2835854,0.0042692,12.1557847,10.33432,80.2170832,122.0728519,0.0000762,11.8123739,6.5990872,14.7023823,9.3971716,12.9122976,1.886412,77.0998981),(14038,'humerus-1.tif',40,2,48,24.8601715,16.0180873,17.4114636,1.8,16.1027011,17.2613744,-0.0048145,11.8983289,8.4850814,79.0301545,116.947436,0.0000961,13.7827123,6.6421222,16.3149621,9.0813031,12.1289611,1.6659438,71.1596138),(14039,'humerus-1.tif',40,2,49,24.8141596,16.0059516,17.3412183,1.8,16.1383266,17.2527986,-0.0027874,11.9785835,7.9191085,76.6471415,111.6349591,0.0000321,14.0969099,6.3986816,14.9395299,8.7688446,11.4004754,1.9774192,70.3701701),(14040,'humerus-1.tif',40,2,50,24.4533384,16.0349213,17.2638931,1.8,16.0791378,17.1857799,0.0031332,11.7547097,8.2520489,76.6465224,106.488735,0.00004,12.9045206,6.5204947,14.8521414,8.695928,11.3966218,1.9537517,66.6908961),(14041,'humerus-1.tif',40,2,51,23.7930741,16.08751,17.2083931,1.8,16.1018537,17.0845688,-0.0079718,11.6922717,8.169485,77.8636781,102.8357975,0.000252,12.5877944,6.659414,15.4278432,8.8770402,12.3616108,1.8669115,73.1778559),(14042,'humerus-1.tif',40,2,52,23.507677,16.1039563,17.1451299,1.8,16.0970541,17.0381608,-0.0097917,11.5277041,8.7995589,76.7009323,98.1045467,0.0003756,11.1488028,6.6536174,14.509574,8.875732,12.1074199,1.868991,70.6808407),(14043,'humerus-1.tif',40,2,53,23.6372736,16.0606976,17.0805319,1.8,16.130027,16.9887797,-0.0415175,11.7214711,8.264571,75.255307,95.4013628,0.0067867,11.5434138,6.4202954,13.5685694,8.9134225,11.4390495,1.9008569,71.9855265),(14044,'humerus-1.tif',40,2,54,23.4426536,16.0608626,16.9913256,1.8,16.0914727,16.9212617,-0.0219602,11.5651655,7.7403063,74.1777214,91.3383631,0.0018839,11.8003551,6.4138919,13.7592897,9.0520765,11.2946341,1.9430657,70.6737197),(14045,'humerus-1.tif',40,2,55,22.8851262,16.0837615,16.8960095,1.8,16.114088,16.8087726,0.0191883,11.489792,8.4848551,74.2472583,87.9756186,0.0014042,10.3685469,6.4620194,13.8359696,9.0340231,11.4460689,1.9285424,67.4581129),(14046,'humerus-1.tif',40,2,56,22.4653233,16.0974647,16.8108657,1.8,16.1192984,16.7582388,0.0466105,11.200792,7.3633055,72.5989088,84.1042817,0.0081286,11.4220824,6.4815871,12.8726299,9.2559721,11.3690583,1.9594858,67.6019028),(14047,'humerus-1.tif',40,2,57,22.1923836,16.0951328,16.738855,1.8,16.1388025,16.6452727,0.1131617,11.4215763,7.2711311,72.7352158,80.9074481,0.0471626,11.1272163,6.3682292,12.5505551,9.2559919,12.0249398,1.8885943,74.4431232),(14048,'humerus-1.tif',40,2,58,22.3363668,16.1023568,16.6741455,1.8,16.1521386,16.5465554,0.2208572,11.1379636,5.870659,73.3680682,78.3230773,0.1786536,13.3414455,6.5872067,12.2586814,8.935346,11.2117716,1.9363661,64.7455918),(14049,'humerus-1.tif',40,2,59,22.6398257,16.1307897,16.5795347,1.8,16.1569517,16.4944376,0.2814155,11.0093468,5.8256831,72.6622058,76.1132641,0.29102,13.0651227,6.6000469,12.3449995,8.7197777,11.5191879,1.9076764,67.5855751),(14050,'humerus-1.tif',40,2,60,22.3821608,16.1297633,16.4687024,1.8,16.1833546,16.3919598,0.1870974,10.8627453,7.1148067,72.0848835,74.8171304,0.1290663,10.515694,6.6359729,13.080383,9.0039999,11.8986187,1.8832262,68.5238441),(14051,'humerus-1.tif',40,2,61,22.1175559,16.1156812,16.3733796,1.8,16.1927911,16.2523985,0.3174436,10.5933911,5.8390079,72.2746991,73.2233136,0.3591548,12.5403689,6.8226216,13.1482012,9.15574,12.444179,1.8313987,74.0117535),(14052,'humerus-1.tif',40,2,62,21.9829077,16.1175941,16.2700854,1.8,16.2133603,16.1431187,1.1016003,10.9434154,9.5450833,71.414356,71.896205,2.9147244,7.5322763,6.5257832,12.1577989,9.1418992,11.3471804,1.9176813,72.7749702),(14053,'humerus-1.tif',40,2,63,21.9255643,16.1346468,16.176134,1.8,16.2216252,16.0429019,1.5117986,8.0306465,10.8349572,69.7973073,72.2028218,3.641556,6.663877,8.6913684,12.763237,9.0116639,12.4973147,1.8468933,73.3568929),(14054,'humerus-1.tif',40,2,64,22.023122,16.1511954,16.0950417,1.8,16.2283363,15.9136446,1.4881811,8.1288631,10.5371071,68.0372709,72.7511634,3.645525,6.9042825,8.3698385,12.8600992,8.7092381,11.0475901,1.9226669,64.9166439),(14055,'humerus-1.tif',40,2,65,21.9521926,16.1569749,15.979938,1.8,16.241313,15.7858175,-1.562865,7.6741398,10.3694072,67.9844224,73.0609173,3.6584686,7.0458143,8.8588981,12.3359863,9.2814788,11.755899,1.900633,78.1434023),(14056,'humerus-1.tif',40,2,66,21.8536734,16.159142,15.8736912,1.8,16.2587828,15.6758252,-1.5161768,7.0924777,9.9264187,67.5617777,73.1089231,3.6314238,7.3650856,9.5258358,12.8333012,9.0896258,12.7833569,1.8243299,80.2132192),(14057,'humerus-1.tif',40,2,67,22.2407805,16.1583183,15.7783484,1.8,16.2722317,15.6152397,-1.4426358,6.8892269,10.2038801,66.4387261,73.144433,3.6462448,7.168296,9.643858,13.2463887,0.1002,0.1806381,2.1587989,0.3836084),(14058,'humerus-1.tif',40,2,68,22.452711,16.165755,15.6694511,1.8,16.2738591,15.5038212,-1.4437245,6.5486345,10.1716854,66.3981199,73.7966873,3.6820181,7.2551091,10.1392313,13.6659352,8.9665696,11.1838647,1.9662766,64.5066372),(14059,'humerus-1.tif',40,2,69,22.3925098,16.17808,15.5681465,1.8,16.2821416,15.4166765,-1.4591466,6.7086576,10.1052871,65.9484646,74.3690095,3.685755,7.3594158,9.8303519,13.1220276,8.9727715,10.9535838,1.9258197,71.4287803),(14060,'humerus-1.tif',40,2,70,22.2820706,16.1873896,15.4618979,1.8,16.2890964,15.3003785,-1.438249,6.8556885,10.0086131,65.8426606,75.2889707,3.6488148,7.5224179,9.6040916,12.6225147,0.0501,0.0708521,2.3561945,0.1417042),(14061,'humerus-1.tif',40,2,71,22.3034017,16.1848297,15.358197,1.8,16.3382092,15.1911133,-1.4235056,6.7634325,9.9016703,65.7277248,75.9423069,3.6371714,7.6696461,9.7181016,13.3070716,0.1417042,0.2125563,0.7853982,0.4544605),(14062,'humerus-1.tif',40,2,72,22.2945388,16.1854605,15.2527215,1.8,16.3235707,15.0670134,-1.390358,8.0331551,9.5826711,65.9070446,77.0944599,3.5960862,8.0451952,8.2043785,14.0926162,0.0501,0.0708521,2.3561945,0.1417042),(14063,'humerus-1.tif',40,2,73,22.4841044,16.1959847,15.1559034,1.8,16.3463024,14.9814953,-1.3689546,6.5640462,9.2265322,65.9005879,78.2586217,3.5967453,8.4819106,10.0396289,14.0981277,9.138392,12.0725413,1.8872976,79.6241755),(14064,'humerus-1.tif',40,2,74,22.4016986,16.213728,15.0430363,1.8,16.3888846,14.8734501,-1.3423839,7.7045363,8.6941035,66.4672093,79.2952338,3.5421893,9.1205763,8.6270227,15.3560544,9.0782536,11.5105777,0.3602989,80.9653301),(14065,'humerus-1.tif',40,2,75,22.3586376,16.2272375,14.9397201,1.8,16.3833814,14.7781733,-1.3337482,6.5834375,9.0031873,66.7379502,80.6463425,3.520937,8.9575325,10.1372497,15.4797002,0.0501,0.112027,2.0344439,0.2419042),(14066,'humerus-1.tif',40,2,76,22.300003,16.2266172,14.8375675,1.8,16.3894122,14.6606557,-1.3100456,7.1030184,8.6834873,67.0909418,81.8913394,3.4696429,9.4306972,9.4454129,16.0446047,0.0501,0.0708521,2.3561945,0.1417042),(14067,'humerus-1.tif',40,2,77,22.3114451,16.2367949,14.7350529,1.8,16.4205355,14.5809089,-1.3058384,6.5829196,8.836156,67.4415968,83.2970214,3.4635721,9.4268392,10.244937,16.0207898,9.382197,12.9805422,1.8644712,82.3903571),(14068,'humerus-1.tif',40,2,78,22.4003404,16.2442767,14.6265074,1.8,16.4123759,14.474575,-1.2906447,8.7485448,8.7139328,68.117623,84.8297418,3.4479612,9.7349548,7.7861661,16.2801566,9.2330057,12.6590522,1.9013076,85.5250412),(14069,'humerus-1.tif',40,2,79,22.5091373,16.2500528,14.5229516,1.8,16.4259237,14.3678162,-1.2954434,6.5509071,8.6425721,68.500481,86.5302699,3.4742017,10.012097,10.4566406,16.7162502,0.0501,0.0708521,2.3561945,0.1417042),(14070,'humerus-1.tif',40,2,80,22.6213388,16.254635,14.4199399,1.8,16.4356264,14.2468823,-1.2954155,8.5471364,8.3293526,69.0628683,88.3670788,3.4914645,10.6091173,8.0802347,16.5742282,9.7343832,13.9427505,1.8811837,91.8966951),(14071,'humerus-1.tif',40,2,81,22.6571237,16.2583884,14.3107575,1.8,16.4422674,14.1580724,-1.2846801,7.7327803,8.3300089,69.5414762,89.4852289,3.475403,10.742513,8.9930754,17.4507957,9.2110779,13.8316842,1.9028558,81.7467889),(14072,'humerus-1.tif',40,2,82,22.6904059,16.2633162,14.2103099,1.8,16.4596078,14.0817254,-1.2772113,8.0490253,11.0941529,70.2451473,90.7936853,3.4650364,8.1839223,8.727162,12.8724928,0.1002,0.1417042,2.3561945,0.2834084),(14073,'humerus-1.tif',40,2,83,22.7924616,16.2662008,14.1093111,1.8,16.4410736,13.978377,-1.2732983,9.0460921,8.0351569,70.6729012,92.623429,3.4723379,11.5272707,7.8125339,15.0512037,0.0501,0.0708521,2.3561945,0.1417042),(14074,'humerus-1.tif',40,2,84,22.9616181,16.2731693,14.006665,1.8,16.4535706,13.8885335,-1.2646901,7.6048294,7.871902,71.7393768,94.64882,3.4794096,12.0236279,9.4333972,18.2814076,9.152985,12.005721,0.2358696,83.8115705),(14075,'humerus-1.tif',40,2,85,23.1515723,16.2776074,13.9086804,1.8,16.4849695,13.8060912,-1.2463066,7.5942334,7.6877157,72.4804483,96.384976,3.4663711,12.5375313,9.5441428,17.7913968,9.7908783,14.7502608,1.8850282,95.5466212),(14076,'humerus-1.tif',40,2,86,23.1579888,16.2752231,13.8139377,1.8,16.455932,13.7266421,-1.2423426,7.3852066,7.5501174,72.9165043,97.5580621,3.458037,12.9213966,9.8733195,19.6606601,9.4363444,13.471312,1.9478497,92.3117371),(14077,'humerus-1.tif',40,2,87,23.2374498,16.275617,13.7191269,1.8,16.4770313,13.6379456,-1.2293386,8.1330943,7.9702955,73.5804799,99.1300984,3.4386317,12.4374434,9.0470462,18.2554476,9.9586749,14.2926446,1.9102834,95.0636767),(14078,'humerus-1.tif',40,2,88,23.4720337,16.2758384,13.6271454,1.8,16.4980068,13.5753798,-1.221515,7.8103236,7.1352101,74.6835497,101.0978787,3.453846,14.1688719,9.5621582,20.1133877,9.5261982,14.0789029,1.9308165,92.957391),(14079,'humerus-1.tif',40,2,89,23.6126429,16.2777033,13.5303732,1.8,16.5067118,13.4921676,-1.2175938,7.7456716,7.1074803,75.5115842,103.289394,3.4645655,14.532491,9.7488749,18.6959744,9.9596018,15.2810756,1.9257297,101.2580215),(14080,'humerus-1.tif',40,2,90,23.6336511,16.2717718,13.4385194,1.8,16.4987426,13.4171452,-1.2054735,9.0901101,8.0691134,76.3262277,104.5967282,3.4362218,12.9626048,8.396623,17.3154016,9.5762253,15.1654121,1.9144869,97.5556566),(14081,'humerus-1.tif',40,2,91,23.6859594,16.2646466,13.3424025,1.8,16.4828964,13.305295,-1.2068467,7.7293064,10.1073599,76.8093534,105.7982539,3.4474395,10.467447,9.9374186,14.4249678,0.0708521,0.1417042,2.3561945,0.2834084),(14082,'humerus-1.tif',40,2,92,23.9088898,16.2593074,13.2521604,1.8,16.496577,13.2213819,-1.2060473,8.5215374,7.6317313,77.7249441,107.4257761,3.4777653,14.0762001,9.1210002,20.4159181,0.2004,0.3647335,2.863293,0.8674168),(14083,'humerus-1.tif',40,2,93,24.2172865,16.2546757,13.1783811,1.8,16.4689977,13.1427578,-1.2043387,8.0356601,7.7913874,78.3247155,109.0461992,3.5180192,13.9957358,9.7471414,17.7769199,0.126816,0.2505,0.6435011,0.4959647),(14084,'humerus-1.tif',40,2,94,24.1638934,16.2570721,13.0844763,1.8,16.4984361,13.0603473,-1.2097795,8.2671592,7.3676229,78.550857,110.0787094,3.5248338,14.9408718,9.5015537,18.5784721,9.126031,14.7686275,1.9752427,104.6073476),(14085,'humerus-1.tif',40,2,95,24.1079525,16.244554,12.982194,1.8,16.4774403,12.9736623,-1.2124224,8.2518511,7.9817702,78.6716432,111.0732075,3.5236709,13.9158614,9.5338176,17.7664267,10.3686883,17.3997819,1.9144013,115.1660387),(14086,'humerus-1.tif',40,2,96,23.9586193,16.2440672,12.8828622,1.8,16.493273,12.8875585,-1.2169636,8.0005607,8.6065223,79.0402754,112.3574402,3.5136942,13.0549177,9.879342,16.9280648,0.2913718,0.4251126,0.7853982,1.0678168),(14087,'humerus-1.tif',40,2,97,23.8761674,16.2487784,12.7925872,1.8,16.4965176,12.7982131,-1.207099,8.6029802,8.1316593,79.0912335,113.3458352,3.4757916,13.9388323,9.1934692,17.1400465,0.31137,0.6415931,0.6747409,1.6346337),(14088,'humerus-1.tif',40,2,98,24.049222,16.2481204,12.7116727,1.8,16.5048109,12.7275059,-1.2027078,8.1543769,7.4970491,79.8603577,115.1771424,3.4892234,15.362997,9.7935574,18.5647416,0.0501,0.0708521,2.3561945,0.1417042),(14089,'humerus-1.tif',40,2,99,24.4391989,16.2486275,12.6182685,1.8,16.5123778,12.6518413,-1.2003761,8.7572148,8.4028355,80.773149,116.932156,3.5394101,13.9157973,9.2236117,16.9026868,10.262978,18.1191006,1.9266544,113.5984436),(14090,'humerus-1.tif',40,2,100,24.6527405,16.2396859,12.5403225,1.8,16.4959905,12.565453,-1.1956169,10.4030954,7.6040898,81.1989481,117.7112214,3.5570704,15.4799883,7.8052681,18.0280831,9.8406658,17.1927704,1.9561728,107.3026771),(14091,'humerus-1.tif',40,2,101,24.4808915,16.2284093,12.4580111,1.8,16.4691043,12.4665296,-1.1873913,11.4316655,8.6425059,82.0830419,118.8218789,3.5091883,13.7485448,7.1803222,14.0189618,9.5616407,15.5943047,2.0301336,108.0719796),(14092,'humerus-1.tif',40,2,102,24.7806738,16.2199904,12.3678915,1.8,16.4953988,12.4233069,-1.1810477,11.672573,8.4431977,82.9993447,119.7782771,3.5338624,14.1863641,7.1106298,16.0123015,0.3507,0.729467,2.863293,2.1184421),(14093,'humerus-1.tif',40,2,103,24.8660057,16.2072202,12.2891471,1.8,16.446751,12.3258657,-1.1892197,11.5641051,6.5281618,83.2147196,120.7475833,3.5696395,18.496414,7.1959498,17.6157312,0.1002,0.1806381,2.5535901,0.3542605),(14094,'humerus-1.tif',40,2,104,24.8780703,16.2013994,12.2088065,1.8,16.4598524,12.2539493,-1.1841567,9.7037634,15.8067683,83.5098503,122.0356752,3.5567846,7.7204697,8.605924,12.9750437,0.1902239,0.3207965,0.8960554,0.7672168),(14095,'humerus-1.tif',40,2,105,24.5127185,16.1936896,12.1398622,1.8,16.4678484,12.2044964,-1.1792106,10.2290089,6.5933183,84.4866074,122.8025753,3.4903652,18.6253067,8.2595106,19.358736,0.1503,0.2921307,0.5404195,0.6255126),(14096,'humerus-1.tif',40,2,106,24.5433981,16.1738205,12.0794582,1.8,16.4212739,12.1243486,-1.1821896,9.4115631,6.8775898,84.4551616,124.2827775,3.5033052,18.0706877,8.9735531,19.8657699,0.3137263,0.5419144,0.5880026,1.3927295),(14097,'humerus-1.tif',40,2,107,24.4641042,16.1671419,12.02492,1.8,16.4447398,12.0538763,-1.1801137,8.4830145,7.5929934,84.7939533,125.7251672,3.4860383,16.5580504,9.9957336,18.5927691,0.2916709,0.3815502,2.7367009,1.0799731),(14098,'humerus-1.tif',40,2,108,24.4857724,16.1501353,11.9695159,1.8,16.4280916,12.0131953,-1.1802628,9.4813315,8.9961713,85.0541371,126.9710625,3.4895544,14.1139,8.9706954,16.2221924,0.1345086,0.3612763,0.5880026,0.7672168),(14099,'humerus-1.tif',40,2,109,24.4642305,16.1404257,11.9063211,1.8,16.3984582,11.9427852,-1.1875004,9.859865,7.2054954,85.3606328,128.018536,3.5071087,17.7667916,8.6573835,19.0591033,0.1002,0.1806381,2.5535901,0.3542605),(14100,'humerus-1.tif',40,2,110,24.5469322,16.1221048,11.8458156,1.8,16.3689771,11.88341,-1.1928124,9.8888175,6.7601116,86.1447878,129.0403006,3.5339564,19.0884867,8.7113336,20.1001927,0.0501,0.0708521,2.3561945,0.1417042),(14101,'humerus-1.tif',40,2,111,24.5186114,16.106807,11.793712,1.8,16.3171481,11.8312173,-1.1859691,10.1872657,9.2221061,86.5443387,129.4660021,3.5105568,14.038659,8.4953452,15.7340546,0.1002,0.1806381,0.5880026,0.3836084),(14102,'humerus-1.tif',40,2,112,24.5174249,16.0875003,11.7416925,1.8,16.2891578,11.7857388,-1.1895815,11.2024305,6.7332464,87.2228309,130.3512371,3.5206205,19.3593446,7.7860631,19.1691354,0.1606768,0.5533726,3.0509328,1.309721),(14103,'humerus-1.tif',40,2,113,24.4609909,16.0632337,11.6935191,1.8,16.2573085,11.7330469,-1.1879819,8.8343928,7.2665237,87.3434803,131.1547436,3.5080051,18.049173,9.8867553,19.2022326,0.1503,0.2505,0.6435011,0.4959647),(14104,'humerus-1.tif',40,2,114,24.3744912,16.0395275,11.6456375,1.8,16.2089555,11.6774005,-1.186585,9.2931985,6.4172214,86.9288861,131.6120699,3.4916617,20.5091988,9.354033,20.8924291,0.1771303,0.2505,2.2142974,0.5961647),(14105,'humerus-1.tif',40,2,115,24.3634471,16.019576,11.6021057,1.8,16.1733905,11.6224086,-1.1773794,8.6944158,5.2373755,87.1284238,132.2381823,3.4638546,25.2489406,10.0211936,24.2032871,0.1002,0.1417042,2.3561945,0.2834084),(14106,'humerus-1.tif',40,2,116,24.4149945,15.9895281,11.5547911,1.8,16.1124313,11.5833755,-1.1805114,9.5703749,5.959963,87.6374257,132.5944836,3.4801798,22.2475345,9.157157,22.9676906,0.0501,0.112027,2.677945,0.2125563),(14107,'humerus-1.tif',40,2,117,24.4954443,15.956053,11.5150089,1.8,16.0522431,11.5561136,-1.1669296,9.7023476,7.8486288,88.3237145,133.1152093,3.4520987,16.9603141,9.1033344,17.744294,0.126816,0.3815502,2.7367009,0.8259126),(14108,'humerus-1.tif',40,2,118,24.4840899,15.9373523,11.4584663,1.8,16.0340657,11.5082886,-1.1718207,10.6917574,5.5180522,88.2117634,133.9328622,3.4648555,24.2717642,8.2504457,20.3989793,0.0501,0.112027,2.0344439,0.2419042),(14109,'humerus-1.tif',40,2,119,24.5272897,15.923343,11.4043963,1.8,15.9943948,11.4676802,-1.1678166,9.376047,6.5913423,88.6840438,134.5274316,3.4592049,20.409717,9.458575,20.7017003,0.0501,0.112027,2.0344439,0.2419042),(14110,'humerus-1.tif',40,2,120,24.3526678,15.9001497,11.3699995,1.8,15.9648139,11.4466063,-1.1684524,9.166114,5.0192369,88.8554635,135.1931514,3.4364377,26.9350013,9.6939078,21.4654947,8.7717551,13.4451082,2.2664888,94.2084162),(14111,'humerus-1.tif',40,2,121,24.3264084,15.8718003,11.3327312,1.8,15.918529,11.4363133,-1.169849,8.7995154,5.4385705,89.5934353,135.8109571,3.4368073,24.9718116,10.1816329,23.3280156,0.1503,0.224054,2.677945,0.5253126),(14112,'humerus-1.tif',40,2,122,24.3410386,15.8362376,11.3044773,1.8,15.8337962,11.4022733,-1.1717939,9.9335916,6.7917428,90.5806144,136.5331976,3.444534,20.1028221,9.1186167,19.3124451,8.712042,12.7647884,3.0630146,87.1961437),(14113,'humerus-1.tif',40,2,123,24.3289213,15.81114,11.2780335,1.8,15.7915542,11.400074,-1.1695356,9.1069179,5.7629494,91.5487849,137.619963,3.4362488,23.8801267,10.052664,21.2642655,8.9415967,12.7203698,2.3366984,84.7984646),(14114,'humerus-1.tif',40,2,124,24.4215601,15.792343,11.2401382,1.8,15.7660129,11.3642673,-1.1626069,10.0850178,5.1242911,92.6679572,138.9840855,3.4289178,27.1225977,9.1886756,21.9641099,0.0501,0.0708521,2.3561945,0.1417042),(14115,'humerus-1.tif',40,2,125,24.5156643,15.768362,11.2143159,1.8,15.6991644,11.3353499,-1.1639817,9.3017423,5.1678956,94.0275503,140.0816817,3.4462184,27.1061361,10.1085955,22.6083206,0.1002,0.1806381,2.5535901,0.3542605),(14116,'humerus-1.tif',40,2,126,24.7298947,15.7480468,11.1978901,1.8,15.6736169,11.3407202,-1.1650413,8.6081316,5.1088808,95.2720129,142.3705297,3.4795043,27.8672642,11.0676762,25.5670312,9.0682623,12.6920225,3.0902544,91.210401),(14117,'humerus-1.tif',40,2,127,24.7411859,15.7251278,11.1846651,1.8,15.6206256,11.3251771,-1.1656728,11.9317409,5.2912519,96.0653067,144.7776327,3.4829806,27.3616972,8.0512397,19.6053707,0.1002,0.1417042,0.7853982,0.2834084),(14118,'humerus-1.tif',40,2,128,24.6846028,15.6873916,11.1735545,1.8,15.6089968,11.3424374,-1.1693732,9.1084915,5.0608181,96.1216444,146.1261156,3.4860052,28.8740109,10.5529707,25.2909548,0.0501,0.112027,2.0344439,0.2419042),(14119,'humerus-1.tif',40,2,129,24.7723461,15.6441445,11.1611355,1.8,15.5645892,11.3222655,-1.1648161,10.2639482,5.4603374,97.9850707,148.1773558,3.4848028,27.1370329,9.5465282,21.1734379,9.063358,13.6570069,3.0755125,85.8206059),(14120,'humerus-1.tif',40,2,130,25.0176611,15.6065095,11.1319604,1.8,15.5375959,11.3185451,-1.1699981,9.7253612,4.9813739,99.7744265,150.2012775,3.5349133,30.1525806,10.2592001,24.1321687,9.0772775,13.4679578,3.0633942,86.2448546),(14121,'humerus-1.tif',40,2,131,25.3349869,15.5707008,11.1250827,1.8,15.4951872,11.3173702,-1.1724979,8.6657347,5.3097403,101.5731572,153.3645701,3.5873158,28.8836291,11.7212401,27.2402303,0.0501,0.0708521,2.3561945,0.1417042),(14122,'humerus-1.tif',40,2,132,25.5743588,15.5488106,11.122296,1.8,15.4605028,11.3069304,-1.1745359,9.2982774,4.9401217,103.384463,156.956227,3.6274082,31.7717327,11.1186684,27.5821563,9.1530674,13.1242882,3.0191316,90.8997304),(14123,'humerus-1.tif',40,2,133,25.7299367,15.5236201,11.1153308,1.8,15.4468761,11.3078807,-1.1797911,10.128705,4.9214592,106.2295295,158.7555078,3.6654399,32.2578125,10.4879676,23.7091995,0.1503,0.2921307,1.0303768,0.6255126),(14124,'humerus-1.tif',40,2,134,26.0095176,15.4825137,11.1082043,1.8,15.4756394,11.2767628,-1.1768361,8.6863318,4.9960358,106.8849977,161.0116077,3.6962146,32.2278728,12.3049637,26.7601137,9.1636505,13.2063644,3.0313544,90.9412346),(14125,'humerus-1.tif',40,2,135,25.9424326,15.4434535,11.1053296,1.8,15.3664297,11.2826896,-1.1770794,10.2066986,5.1945569,112.0002759,164.8404439,3.6874269,31.7333021,10.9732128,25.3096848,0.1002,0.1417042,2.3561945,0.2834084),(14126,'humerus-1.tif',40,2,136,25.9656156,15.3919405,11.1154167,1.8,15.3146661,11.2611893,-1.1738716,11.234154,5.5205408,113.3250316,168.1437245,3.6808547,30.4578355,10.0875448,22.6063102,9.271274,13.898575,3.0404893,93.2500061),(14127,'humerus-1.tif',40,2,137,26.2232257,15.344833,11.1442269,1.8,15.2161534,11.2554773,-1.1679902,11.3025902,4.9625194,117.8995555,171.8622572,3.6989383,34.6320573,10.4311979,23.473837,9.3128521,14.1310429,3.0207557,87.0858731),(14128,'humerus-1.tif',40,2,138,26.7180638,15.2950803,11.1672848,1.8,15.2317824,11.2605318,-1.1652318,9.6159847,5.0480383,119.7651018,175.635234,3.7598555,34.7927696,12.4547933,27.6504332,0.0501,0.112027,2.677945,0.2125563),(14129,'humerus-1.tif',40,2,139,27.018951,15.2657735,11.1879356,1.8,15.1968599,11.2502709,-1.1585015,10.4607026,4.9421077,124.1395515,180.52256,3.7800825,36.5274435,11.8672288,29.1191562,0.1002,0.1417042,2.3561945,0.2834084),(14130,'humerus-1.tif',40,2,140,27.0306939,15.2175892,11.20345,1.8,15.197536,11.272539,-1.1506908,8.1993223,5.1239659,124.3370113,183.5856934,3.7557025,35.8288283,15.1643034,34.7867526,9.2623345,14.1211813,3.0634602,76.835767),(14131,'humerus-1.tif',40,2,141,27.0592887,15.1577546,11.2175157,1.8,14.9915786,11.3104842,-1.1615038,8.7202025,4.9612816,123.7795036,187.7397733,3.7956402,37.8409833,14.1945676,35.2105504,9.3924283,12.2244005,2.9602729,70.2972323),(14132,'humerus-1.tif',40,2,142,27.2789895,15.1060658,11.2401765,1.8,15.0407602,11.3202511,-1.1670539,7.6127195,4.8063212,127.2417953,191.6136697,3.8447869,39.8670132,16.714368,39.4663749,9.4381758,12.4193449,2.9426148,79.3185402),(14133,'humerus-1.tif',40,2,143,27.8402189,15.0624757,11.2506951,1.8,14.971303,11.3511172,-1.1721821,7.9291634,5.0560738,130.9346429,201.4158617,3.9409969,39.8364161,16.5130464,38.7656809,9.678237,12.6352364,2.8562125,73.7618643),(14134,'humerus-1.tif',40,2,144,28.620988,14.9889558,11.2880395,1.8,14.9099364,11.354392,-1.1476141,8.7169564,4.9659195,138.0261506,210.7318441,3.9657003,42.4356139,15.8342137,37.3324749,9.647165,12.7475712,2.8832687,80.7548595),(14135,'humerus-1.tif',40,2,145,29.2065915,14.9234239,11.3431079,1.8,14.8480283,11.3407875,-1.152292,8.5171687,5.2858754,141.9692373,219.6085221,4.063823,41.5462915,16.6685952,40.359054,9.6274491,13.4925361,2.9624034,71.8144744),(14136,'humerus-1.tif',40,2,146,29.589837,14.8612941,11.3527285,1.8,14.7869313,11.4166305,-1.1382654,9.6215611,5.053031,151.7233922,231.381153,4.0651333,45.7905665,15.7691035,36.9581207,0.1002,0.1806381,2.5535901,0.3836084),(14137,'humerus-1.tif',40,2,147,30.1649578,14.7926631,11.361116,1.8,14.7412023,11.3991743,-1.1267474,10.5288395,5.5701236,159.0486073,243.7224902,4.0996414,43.755311,15.1059959,38.1874071,0.1002,0.224054,2.677945,0.4838084),(14138,'humerus-1.tif',40,2,148,30.9938568,14.7155169,11.3952614,1.8,14.5325263,11.3571515,-1.1248657,9.6908701,6.479234,164.1978015,258.9822712,4.2047416,39.9711246,16.9435562,42.8229798,0.1503,0.3647335,2.863293,0.8674168),(14139,'humerus-1.tif',40,2,149,31.5589067,14.641937,11.4347039,1.8,14.4630441,11.4419291,-1.1155803,11.052509,5.7343234,168.8752965,274.7991333,4.2431068,47.9218063,15.2793629,39.891798,0.1002,0.1806381,0.9827937,0.3836084),(14140,'humerus-1.tif',40,2,150,32.2025038,14.5710657,11.4940029,1.8,14.4447579,11.5897856,-1.120313,8.3946119,5.6573898,172.7591458,289.3776659,4.3496255,51.150385,20.5797656,53.3309915,10.7873697,12.0617251,0.1207486,72.2861265),(14141,'humerus-1.tif',40,2,151,32.7435111,14.5124436,11.5471799,1.8,14.3622571,11.6324759,-1.1046121,9.2278696,6.3789001,181.793126,305.2465959,4.3547059,47.8525438,19.7004437,52.7476484,0.1110989,0.2921307,0.5404195,0.5961647),(14142,'humerus-1.tif',40,2,152,33.4735066,14.4529305,11.5947916,1.8,14.3049212,11.7190674,-1.0948068,8.845994,6.2377071,195.5748607,329.509994,4.4075465,52.8254995,22.1088621,59.1702979,0.1002,0.1417042,0.7853982,0.2834084),(14143,'humerus-1.tif',40,2,153,34.4479149,14.3781977,11.6782406,1.8,14.2192825,11.8127671,-1.0896154,8.7877626,7.9499917,202.8443044,355.8218559,4.5114812,44.7575127,23.0825881,54.8705166,0.1944473,0.336081,0.4636476,0.808721),(14144,'humerus-1.tif',40,2,154,35.7295593,14.2989089,11.7615991,1.8,14.1272521,11.9601644,-1.0885228,8.8629612,7.2167601,214.8020639,393.5010324,4.6739897,54.525996,24.2359251,65.0631474,0.2004,0.2834084,0.7853982,0.6255126),(14145,'humerus-1.tif',40,2,155,37.2066909,14.2071237,11.8827246,1.8,14.0264149,12.1062762,-1.0794435,10.0566644,7.7458782,227.7775393,439.1730284,4.8206644,56.6976419,22.6494124,63.7638741,0.1503,0.2697968,2.7610863,0.5961647),(14146,'humerus-1.tif',40,2,156,39.1844867,14.0770587,12.0269786,1.8,13.8147869,12.3645706,-1.07067,12.219947,8.7520681,251.2760333,497.9909167,5.0289688,56.8997991,20.5627761,53.5919304,0.0501,0.112027,2.677945,0.2125563),(14147,'humerus-1.tif',40,2,157,41.6090833,13.8820106,12.2388296,1.8,13.4223881,12.6623931,-1.0589473,11.8256729,10.8406171,281.838187,570.2684751,5.2712161,52.604798,23.83274,67.3672133,0.2379148,0.3815502,2.7367009,1.0384689),(14148,'humerus-1.tif',40,2,158,45.0219199,13.570917,12.5518479,1.8,12.7603511,13.2504271,-1.0115091,11.1663448,10.2310868,321.0857703,709.7968571,5.3912439,69.3764866,28.7547784,92.291698,0.2004,0.336081,0.4636476,0.808721),(14149,'humerus-1.tif',40,2,159,50.0018384,13.0611107,13.0749236,1.8,12.585333,13.4323077,-0.9705188,14.6074999,9.0825472,357.9661105,992.1360264,5.6745432,109.235439,24.5056384,89.6501456,0.1503,0.2065676,2.896614,0.4959647),(14150,'humerus-1.tif',40,2,160,54.6206581,12.6526045,13.5362668,1.8,12.5664997,14.0585018,-0.9609626,11.2533602,9.1363101,405.3227881,1260.3305987,6.1173224,137.9474416,36.0179341,136.1164361,0.126816,0.2921307,2.1112158,0.6255126),(14151,'humerus-1.tif',40,2,161,58.9415828,12.3239367,13.896473,1.8,12.1632824,14.1123174,-0.9621617,11.7403253,8.9606406,482.497674,1468.7717415,6.612307,163.9136988,41.0974706,163.7507461,14.9106415,17.7770311,0.8912139,119.4909666),(14152,'humerus-1.tif',40,2,162,62.0379385,12.0569132,14.2650994,1.8,12.2585074,14.2554145,-0.9756785,11.2478457,9.1706476,569.0385503,1561.1232035,7.0901151,170.2304204,50.5908924,186.4912053,0.1002,0.1806381,2.5535901,0.3836084),(14153,'humerus-1.tif',40,2,163,64.6681928,11.877134,14.5333387,1.8,12.3403293,14.385463,-1.0027447,11.2752035,10.3444122,665.1643548,1591.388952,7.6585036,153.8404425,58.9935566,182.5294152,0.0501,0.112027,2.677945,0.2125563),(14154,'humerus-1.tif',40,2,164,67.3644512,11.8251981,14.7077833,1.8,12.3729643,14.4629095,-1.0296259,11.077562,10.9990209,758.373684,1632.9992906,8.2480051,148.4676963,68.4603421,201.6419702,0.1062782,0.3207965,0.8960554,0.6670168),(14155,'humerus-1.tif',40,2,165,69.3774661,11.8625531,14.8633441,1.8,12.3418105,14.4801197,-1.0253095,10.3328826,9.7389253,831.9740128,1642.7020452,8.4503017,168.6738522,80.5171259,225.7240001,15.4095269,18.290275,1.0040671,97.7225373),(14156,'humerus-1.tif',40,2,166,70.0992751,11.8952654,14.9904904,1.8,12.4479962,14.3432593,-1.0093613,10.1776892,9.8922409,856.9580971,1626.387078,8.3715907,164.4103792,84.1996722,224.7839972,16.0308156,18.4957917,0.7662434,115.1832303),(14157,'humerus-1.tif',40,2,167,70.7180934,11.9092101,15.0554452,1.8,12.537901,14.4303951,-1.0202928,10.9434625,10.0649047,884.8559002,1600.0328237,8.5610051,158.9714833,80.8570322,223.9426039,15.9781782,18.2480274,1.0025931,107.3127477),(14158,'humerus-1.tif',40,2,168,70.788023,11.9465757,15.0866002,1.8,12.7193998,14.3732511,-1.0557984,11.4576718,10.16156,904.1714149,1547.846319,8.9359399,152.3236908,78.9140615,213.5354088,0.0708521,0.1417042,2.3561945,0.2834084),(14159,'humerus-1.tif',40,2,169,70.0538939,12.0152654,14.9976198,1.8,12.8899731,14.2874752,-1.1090794,12.276507,10.595561,898.5335086,1467.7465814,9.3585269,138.5246686,73.1913002,192.3299024,15.3937486,18.5091541,1.1228859,106.2742788),(14160,'humerus-1.tif',40,2,170,68.9578938,12.1595651,14.845684,1.8,12.8975373,14.4374353,-1.1918084,9.2654449,9.6387476,892.2324686,1395.1505167,9.9197597,144.743962,96.2967756,197.1092903,0.1503,0.224054,2.0344439,0.5253126),(14161,'humerus-1.tif',40,2,171,67.4434238,12.3636825,14.6587993,1.8,12.8791195,14.259885,-1.2982228,9.545622,9.8168119,885.1138199,1306.585945,10.4259159,133.096769,92.7245835,191.4385314,16.5169651,18.2072672,1.2690605,131.800819),(14162,'humerus-1.tif',40,2,172,65.2130697,12.6059181,14.48355,1.8,13.1921681,14.3498973,-1.4419682,9.6300551,9.7545122,823.4847271,1228.5387095,10.6894538,125.9456842,85.5119438,180.9863118,0.1122813,0.3207965,2.4668517,0.6670168),(14163,'humerus-1.tif',40,2,173,61.3121608,12.8987096,14.4033814,1.8,13.5982706,14.2078211,-1.5468531,9.8684665,9.220131,713.5895444,1139.8875324,10.2128364,123.6302973,72.3100745,187.217117,14.9332044,17.9360806,1.5652098,96.207381),(14164,'humerus-1.tif',40,2,174,56.7953154,13.214905,14.3129252,1.8,13.4878494,14.1760772,1.4961234,8.7419957,8.7292803,621.1570012,1068.1942306,9.4132018,122.369107,71.0543706,181.4662708,0.1002,0.2065676,2.896614,0.4544605),(14165,'humerus-1.tif',40,2,175,50.9800697,13.6541782,14.2020556,1.8,13.8711787,13.8055739,1.426261,7.9787597,8.9108698,509.3768163,1009.644931,8.3204113,113.3048679,63.8416036,166.3512924,13.6059105,17.2263158,1.6406533,84.4400327),(14166,'humerus-1.tif',40,2,176,43.321742,14.0773416,13.770633,1.8,14.309728,13.121381,1.3091864,10.1748535,9.5131921,367.5892799,874.7295407,6.7373063,91.9491098,36.1272306,109.8598621,0.1671107,0.2834084,0.7853982,0.5961647),(14167,'humerus-1.tif',40,2,177,35.1382715,14.4120478,13.0710975,1.8,13.6359818,13.8796864,1.1877031,13.420759,10.2429056,265.7345863,731.5583958,5.0381259,71.4209838,19.8002651,65.1871102,0.1417042,0.224054,0.4636476,0.4959647),(14168,'humerus-1.tif',40,2,178,27.5244627,14.6054796,12.0681208,1.8,14.22642,13.9290143,1.1032731,15.2648394,12.6085533,196.6326996,512.7758394,3.6556638,40.6688877,12.8814129,42.7591078,0.2004,0.3168602,1.2490458,0.8380689),(14169,'humerus-1.tif',40,2,179,21.7648246,14.8450205,10.943498,1.8,15.8442183,13.1738511,0.7969953,15.6071141,16.026286,121.4053531,288.4250717,1.8558,17.9970002,7.778847,24.4431696,0.0501,0.112027,2.677945,0.2125563),(14170,'humerus-1.tif',40,2,180,17.3595225,14.8457803,10.0004374,1.8,14.5639659,10.1330905,0.1652056,13.035266,10.7609951,33.7204962,127.5761398,0.0782495,11.8554222,2.5868667,11.2359922,9.6309207,11.5547593,0.2007969,102.3765492),(14171,'humerus-1.tif',40,2,181,15.4415771,15.3694007,10.1098084,1.8,15.2164822,10.0077363,0.1823171,7.1850416,7.7323497,20.9026254,93.4047936,0.0846014,12.0797426,2.9091864,12.9424283,7.3966548,9.9935377,2.9294489,59.7242992),(14172,'humerus-1.tif',40,2,182,13.6305445,15.9432825,10.3280197,1.8,15.2262663,10.1263702,0.1421911,4.973089,5.9707394,19.3694791,52.5136219,0.0456224,8.7951622,3.8948588,11.8216066,8.1947566,9.4700932,3.125721,72.5301164),(14173,'humerus-1.tif',40,2,183,12.3990782,16.2454368,10.4711782,1.8,16.1042845,10.4160265,0.1371566,2.8667951,3.355187,10.2035799,34.0625244,0.0386319,10.1521984,3.5592288,12.4298985,4.5090002,6.7309497,0.1418971,22.0426309),(14174,'humerus-1.tif',40,2,184,7.6001973,16.5410024,10.2843472,1.8,16.2438871,10.5144538,0.3022359,3.2337257,2.8094926,2.9317187,10.0872271,0.112228,3.5904089,0.9066071,3.50198,3.9692783,5.2614544,2.9012329,18.9293098),(14175,'humerus-1.tif',40,2,185,3.9227884,16.6747915,10.3554851,1.8,16.6366803,10.6337254,-1.386644,5.3747878,6.6200548,11.0371004,16.0009304,0.6318759,2.417039,2.0534951,3.9460108,8.8910855,10.4978335,1.6424438,95.311838),(14176,'humerus-1.tif',40,2,186,0.0911302,18.6801064,7.9101448,1.8,18.6601048,7.9446883,-1.0727999,7.3511032,13.1449758,0.610083,1.1715508,0.0117229,0.0891254,0.082992,0.1354458,0.2004,0.3207965,2.2455373,0.7965647),(14177,'humerus-1.tif',40,2,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14178,'humerus-1.tif',40,2,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14179,'humerus-1.tif',40,2,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14180,'humerus-1.tif',40,2,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14181,'humerus-1.tif',40,2,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14182,'humerus-1.tif',40,2,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14183,'humerus-1.tif',40,2,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14184,'humerus-1.tif',40,2,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14185,'humerus-1.tif',40,2,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14186,'humerus-1.tif',40,2,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14187,'femur-1.tif',40,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14188,'femur-1.tif',40,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14189,'femur-1.tif',40,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14190,'femur-1.tif',40,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14191,'femur-1.tif',40,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14192,'femur-1.tif',40,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14193,'femur-1.tif',40,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14194,'femur-1.tif',40,7,8,0.5285842,18.4877144,9.5178102,1.8,18.462078,9.5877603,-0.7925788,1.0519439,1.2019825,0.0566766,0.1449764,0.0446813,0.1206144,0.053878,0.1669462,1.6639817,2.3366771,0.9342881,6.6186962),(14195,'femur-1.tif',40,7,9,13.254036,18.1228134,14.2146122,1.8,18.9254853,17.0557323,1.3203953,3.437648,11.0012657,26.3842508,432.6023942,2.0733706,39.3229658,7.6750879,41.7153922,0,0,0,0),(14196,'femur-1.tif',40,7,10,31.6535655,18.6985433,17.2189262,1.8,18.6449154,17.0015293,1.3220171,4.5465594,8.8370053,99.6454169,1127.3531464,4.9557627,127.5718536,21.9166646,138.7345654,0,0,0,0),(14197,'femur-1.tif',40,7,11,44.164892,18.8689464,18.151062,1.8,18.7862263,17.8941695,1.2936685,4.5431685,9.8429978,180.8181503,1433.3582305,6.8098304,145.6221227,39.8000094,161.7032288,8.0154042,9.1112901,2.4514468,30.8058812),(14198,'femur-1.tif',40,7,12,55.0639716,18.7781559,18.4084538,1.8,18.6614534,18.027161,1.2636107,5.1232281,9.8922278,257.1711044,1595.1989703,8.3382271,161.2578086,50.1970823,180.210018,9.2573703,18.6734105,1.6408569,65.5517773),(14199,'femur-1.tif',40,7,13,60.1986467,18.6457281,18.5492417,1.8,18.5474227,18.1018352,1.2416786,5.5720228,10.0904233,333.7874562,1805.4678261,8.9850135,178.9288482,59.9041802,204.9776801,0.2451,0.3653735,2.0344439,0.8566475),(14200,'femur-1.tif',40,7,14,60.3167647,18.5540119,18.6321633,1.8,18.4292549,18.2135145,1.2363538,5.802443,10.3869555,364.6851169,1890.7434031,8.9696734,182.0305679,62.8502714,213.5036363,10.0432145,19.6272242,2.0605088,65.6208686),(14201,'femur-1.tif',40,7,15,58.6382786,18.4436614,18.5594549,1.8,18.3626922,18.2081349,1.2415042,5.8697169,10.3763761,364.3632407,1914.9086807,8.7510763,184.5450347,62.0750957,213.8618299,10.1707567,19.7201869,2.0863453,67.3027274),(14202,'femur-1.tif',40,7,16,56.0337681,18.326121,18.3161983,1.8,18.3276389,18.0687429,1.2469476,5.8353867,10.1516794,338.0389283,1870.4864297,8.3932758,184.2538912,57.929139,210.7370387,10.3113933,19.6722337,2.1069423,73.7696361),(14203,'femur-1.tif',40,7,17,54.1363263,18.1950069,17.8520634,1.8,18.2323815,17.7921495,1.263103,5.7306504,9.6611234,307.684401,1811.013069,8.1951133,187.4536741,53.6910085,212.6623176,10.1827635,19.3449661,1.99288,72.6374486),(14204,'femur-1.tif',40,7,18,52.4068124,18.050122,17.191199,1.8,18.1403988,17.3925649,1.2637771,5.6474887,9.8597019,268.2725895,1642.1541031,7.9366968,166.5521049,47.5029882,193.412856,9.917615,18.9390752,1.9048246,71.4574023),(14205,'femur-1.tif',40,7,19,49.9629536,17.9396632,16.2829074,1.8,18.0224039,16.2406518,1.255436,5.4662605,10.1423377,253.2452671,1278.1299233,7.5260975,126.0192628,46.3287957,150.9538608,9.9029809,18.387583,1.735945,71.584556),(14206,'femur-1.tif',40,7,20,47.3995623,17.7757952,15.3098162,1.8,17.957635,15.2486188,1.2745851,5.3156407,8.4153882,259.9881387,879.339992,7.2268157,104.4919106,48.9100289,132.8456538,9.6257442,15.6806545,2.0064792,60.2649148),(14207,'femur-1.tif',40,7,21,45.8347508,17.9043347,15.0943214,1.8,18.1553419,14.9029536,1.3169078,5.1215204,7.6823357,276.3525313,738.9190475,7.1572017,96.1841656,53.9590804,127.6030864,9.7186468,14.7633054,2.0171189,44.9081324),(14208,'femur-1.tif',40,7,22,44.7938769,18.0099036,15.0293722,1.8,18.2178762,14.8225669,1.3716044,4.9831072,6.7270979,294.3368637,630.735308,7.1733255,93.7603878,59.0669339,135.0192039,9.6510308,13.4346205,1.8925469,40.7240137),(14209,'femur-1.tif',40,7,23,44.546359,18.153693,15.0128714,1.8,18.2677949,14.845419,1.4178865,5.0300135,6.4488858,315.1605266,563.390726,7.2521491,87.3624901,62.6559999,135.4073691,9.8918271,12.8674259,2.0032041,41.1943899),(14210,'femur-1.tif',40,7,24,44.0336331,18.2185704,15.0689024,1.8,18.3299354,14.8924153,1.4339945,5.275164,6.3064988,338.7104434,517.1121852,7.2024471,81.9967151,64.2085149,135.0625785,10.0995702,12.3888023,2.0137979,39.5125311),(14211,'femur-1.tif',40,7,25,43.9749018,18.3048141,15.0703902,1.8,18.3684592,14.8788606,1.5297426,5.6647694,6.1153137,375.6791968,467.5120604,7.3168046,76.4493994,66.3185332,136.2622674,10.5102149,11.9909886,2.067968,40.1777436),(14212,'femur-1.tif',40,7,26,44.2783925,18.3415908,15.0895182,1.8,18.5534468,14.9654743,-1.2316395,6.3147973,5.6277,412.1422549,445.7743746,6.5629136,79.2107564,65.2661098,128.8266802,11.1269951,11.8055794,0.0831412,39.7073674),(14213,'femur-1.tif',40,7,27,45.0477886,18.5732831,15.1525249,1.8,18.8019306,14.9889006,-0.1848874,5.9440994,6.7559498,417.2349604,484.4096162,0.2537364,71.7011861,70.193133,131.5072579,11.0989506,12.3245202,3.0353278,42.0906849),(14214,'femur-1.tif',40,7,28,44.8029186,18.537603,15.2192846,1.8,18.7455078,15.0345572,-0.1981678,5.8538995,6.7257261,391.2546043,488.0059782,0.2894202,72.5581108,66.8365772,129.3333309,10.8587695,12.3245202,0.1062649,41.8315674),(14215,'femur-1.tif',40,7,29,44.1582055,18.4232298,15.3511227,1.8,18.5869127,15.2059296,-0.2383262,5.8628444,6.6635736,366.7211079,470.9779823,0.4101717,70.6794898,62.5500325,123.9646851,10.6710328,12.2432841,0.1069726,41.9867561),(14216,'femur-1.tif',40,7,30,44.2379134,18.3149379,15.4355971,1.8,18.3954118,15.2979899,-0.2882152,5.804008,6.5153425,345.992577,457.2609099,0.5956872,70.1821752,59.6126984,121.0581503,10.4043421,12.0753043,0.1562501,41.7953211),(14217,'femur-1.tif',40,7,31,44.4419755,18.1453361,15.5087915,1.8,18.1891773,15.3613068,-0.3627244,5.7266171,6.2353869,335.6670795,430.7894426,0.9325346,69.0878451,58.6152474,119.4770651,10.2308665,11.7608279,0.2028451,41.5444149),(14218,'femur-1.tif',40,7,32,43.913107,17.9471407,15.5344823,1.8,17.9779921,15.4426487,-0.5054305,5.4818949,5.6582864,320.6253379,399.8981925,1.7157898,70.6747887,58.488049,119.134713,10.1857846,11.3009147,0.2782997,41.9306861),(14219,'femur-1.tif',40,7,33,42.4202827,17.7535731,15.5562659,1.8,17.7355017,15.5130763,-0.7182901,5.2388751,5.460919,303.8317033,368.8191077,3.0619897,67.53792,57.9955995,121.9638953,10.0509151,10.9642497,0.9228243,40.0936386),(14220,'femur-1.tif',40,7,34,41.0977534,17.5428852,15.6385319,1.8,17.5281311,15.6222466,-0.9029687,5.1025093,5.4065931,287.5819571,343.2786704,4.2227264,63.4926036,56.3608889,116.6180952,9.8031835,10.8710132,0.8972291,39.0421549),(14221,'femur-1.tif',40,7,35,40.3944248,17.368706,15.7252188,1.8,17.3387547,15.7506528,-1.0363174,4.8611039,5.2988615,271.6762933,329.0656348,4.9854735,62.1011956,55.8877771,110.4830086,9.6028764,10.6702203,0.9211697,38.4165899),(14222,'femur-1.tif',40,7,36,39.29148,17.1693427,15.8389993,1.8,17.1506444,15.8882926,-1.1466604,4.7632907,5.2006209,254.7013976,317.6092472,5.439514,61.0714092,53.4717307,107.4015736,9.3138001,10.5456315,1.9685672,38.2614012),(14223,'femur-1.tif',40,7,37,38.6420936,16.947425,15.9679864,1.8,16.9558627,15.9989862,-1.2160504,4.6332107,5.1068017,238.7065656,310.0153077,5.6632982,60.706353,51.5207665,103.9966056,9.05572,10.4531311,1.9469486,37.2133187),(14224,'femur-1.tif',40,7,38,37.7850528,16.7624969,16.0610599,1.8,16.7774164,16.0966079,-1.2787693,4.5271249,5.0742086,224.4258246,301.1412807,5.7755526,59.3474377,49.5735881,99.8763995,8.8379986,10.4233961,1.9396584,36.3368474),(14225,'femur-1.tif',40,7,39,37.2267039,16.6174289,16.1602053,1.8,16.6176214,16.1978855,-1.3314338,4.4096705,5.0929789,212.1870044,294.8805023,5.8557077,57.8994151,48.1185627,96.2577219,8.6602001,10.414427,1.9148757,34.8464237),(14226,'femur-1.tif',40,7,40,36.7523072,16.4469636,16.265519,1.8,16.4730003,16.2895234,-1.3469328,4.3266891,5.0673945,204.1417038,290.5060741,5.8235055,57.3284897,47.1819672,95.3299643,8.4968001,10.2330678,1.9127462,36.2014824),(14227,'femur-1.tif',40,7,41,36.4115175,16.311887,16.3581586,1.8,16.3302593,16.391991,-1.3689927,4.5899716,5.0552064,197.0624145,286.1495807,5.8247817,56.6049251,42.9332531,94.1472688,8.3974525,10.2004013,0.9561334,36.2971999),(14228,'femur-1.tif',40,7,42,36.1490169,16.176371,16.4301771,1.8,16.1930507,16.4766765,-1.3920568,4.5658844,5.014363,190.779989,282.9211125,5.8343968,56.4221446,41.7837979,92.7416181,8.2517001,10.1258573,1.31799,34.2571049),(14229,'femur-1.tif',40,7,43,35.8237146,16.0470919,16.5228971,1.8,16.0628838,16.5615027,-1.4067842,4.0863732,5.0099949,185.3442519,279.6778827,5.8114446,55.8239853,45.3566625,91.1074783,8.1700001,10.105732,1.1722739,34.1415637),(14230,'femur-1.tif',40,7,44,35.5469212,15.9207065,16.6111617,1.8,15.9397361,16.6453654,-1.4224877,4.4909177,5.0287962,181.6032621,277.0689324,5.7951277,55.0964731,40.4378957,89.9135312,8.0883001,10.0968112,1.4735431,35.3051874),(14231,'femur-1.tif',40,7,45,35.3032808,15.7977063,16.7002956,1.8,15.8171325,16.7348879,-1.4279462,4.022601,5.0200328,178.7426571,274.4486038,5.7646273,54.6706798,44.4345977,89.5833941,8.0066001,10.0637025,1.4323436,34.0061987),(14232,'femur-1.tif',40,7,46,35.2678616,15.6738853,16.7836222,1.8,15.6958441,16.8142706,-1.4281123,4.4905378,5.0044532,177.128964,272.2274411,5.7591187,54.3970396,39.4449334,89.2568457,8.0066001,10.0968112,1.4735431,33.4879637),(14233,'femur-1.tif',40,7,47,35.2382871,15.55185,16.8612454,1.8,15.5885729,16.8923668,-1.432284,4.4833299,5.0078545,175.6430773,270.4593479,5.7610883,54.0070295,39.1769245,88.1549806,7.9249001,10.0424556,1.4484595,33.9979874),(14234,'femur-1.tif',40,7,48,35.3096565,15.4401301,16.9393742,1.8,15.4730201,16.9709967,-1.4319787,4.6076801,4.9857401,175.4976641,269.6460099,5.7722646,54.083447,38.0880747,88.3093826,8.0066001,10.0238276,1.4646395,33.6035049),(14235,'femur-1.tif',40,7,49,35.3205657,15.3256324,17.0144701,1.8,15.3718529,17.0406841,-1.4354744,4.5235517,4.9854448,175.0810233,268.4603662,5.7796189,53.8488296,38.7043268,87.2821676,8.2766047,9.9988251,1.1766337,36.1255887),(14236,'femur-1.tif',40,7,50,35.418881,15.2207593,17.0810486,1.8,15.2715948,17.1176704,-1.4429825,4.585686,4.968725,175.3986587,267.691503,5.8072348,53.8752909,38.2491644,87.7331312,8.384764,9.9674001,1.3894766,36.9822362),(14237,'femur-1.tif',40,7,51,35.4916165,15.1026348,17.1491809,1.8,15.1685202,17.1864128,-1.4533638,4.6233945,4.9621451,175.0290047,267.567252,5.8340698,53.92169,37.857251,87.1956257,8.4997745,9.953327,0.9486384,38.5601662),(14238,'femur-1.tif',40,7,52,35.4505596,14.9867663,17.2210369,1.8,15.0640833,17.2659604,-1.4614582,4.5945898,4.9493448,174.2928659,266.9520454,5.8380734,53.9368456,37.9343691,87.30488,7.9249001,9.9529917,1.3975507,32.0734337),(14239,'femur-1.tif',40,7,53,35.4249956,14.8768828,17.2876802,1.8,14.9564211,17.3302575,-1.4687645,4.6138668,4.9347311,173.6090578,265.2724433,5.8429137,53.7562103,37.6276698,88.6599316,8.3834114,9.9022288,1.3798732,34.7589174),(14240,'femur-1.tif',40,7,54,35.4506882,14.7699603,17.336873,1.8,14.8471865,17.3879634,-1.4791675,4.5066336,4.9293656,173.3144233,265.4135884,5.8589803,53.8433561,38.4576246,87.5404708,8.1388654,9.9425913,1.4637689,33.9617412),(14241,'femur-1.tif',40,7,55,35.5042111,14.6690261,17.3898183,1.8,14.7498182,17.4494728,-1.4893322,5.2117998,4.9097521,173.9096033,264.9570332,5.8781853,53.9654601,33.3684349,72.6819353,8.1566947,9.9022288,1.3798732,35.0098237),(14242,'femur-1.tif',40,7,56,35.5157752,14.5686573,17.4476839,1.8,14.655001,17.5126072,-1.5069346,4.6654195,4.8907997,173.7088655,263.6959953,5.8951879,53.9167444,37.2332789,89.1981299,8.2290934,9.8907628,1.4382448,33.1727762),(14243,'femur-1.tif',40,7,57,35.3868026,14.474745,17.5013034,1.8,14.5618904,17.5756309,-1.5165394,4.5297119,5.0589419,173.498457,262.2608418,5.8804554,51.8410469,38.3023165,86.129034,8.1512247,9.8613627,1.4628838,32.6907874),(14244,'femur-1.tif',40,7,58,35.2688306,14.3918206,17.5589086,1.8,14.4737692,17.630786,-1.5280303,4.6682582,5.0783724,174.0065945,260.7552732,5.8673943,51.3462289,37.2744149,85.6077319,8.275635,9.8802969,1.4464413,34.2885412),(14245,'femur-1.tif',40,7,59,35.2458341,14.3041844,17.6098797,1.8,14.3879524,17.6828964,-1.5393786,5.3971487,5.1029787,174.5013597,259.9447031,5.8685092,50.9397982,32.3321388,71.7707376,8.154387,9.8210061,1.4288993,32.7865049),(14246,'femur-1.tif',40,7,60,35.1438388,14.2164892,17.6650507,1.8,14.3048347,17.7365956,-1.5478164,5.4134803,5.0499872,174.8018599,258.6947394,5.8542139,51.2268112,32.2901072,71.5442285,8.3340414,9.8586548,1.4042853,34.4321174),(14247,'femur-1.tif',40,7,61,35.144446,14.1374312,17.7082143,1.8,14.2239945,17.7806474,-1.5537067,4.6658082,5.0881923,175.310441,257.6634797,5.8556972,50.6394928,37.5734347,85.0833977,8.3710472,9.7780942,1.4029004,34.3363999),(14248,'femur-1.tif',40,7,62,35.1275377,14.0556027,17.756087,1.8,14.1391303,17.8286565,-1.5648416,5.543298,4.9583904,176.3575825,257.73367,5.854382,51.9793018,31.8145594,70.798165,8.1825902,9.8097854,1.4371441,33.4995762),(14249,'femur-1.tif',40,7,63,35.1526417,13.9811363,17.7822836,1.8,14.0550965,17.8651117,1.5687986,5.4896046,5.0935223,177.3114068,257.7767263,5.8587502,50.6087359,32.2994858,71.4682965,8.232112,9.8586548,1.4042853,33.6827999),(14250,'femur-1.tif',40,7,64,35.1589287,13.9097862,17.8249873,1.8,13.979995,17.9034504,1.5598541,4.7114312,5.1321781,178.3065125,258.1703047,5.8591199,50.3042369,37.8455091,85.037533,8.1855967,9.8315351,1.4959365,33.7785174),(14251,'femur-1.tif',40,7,65,35.1925992,13.8292227,17.8625371,1.8,13.8913063,17.9375212,1.5522217,5.7058405,5.0091561,179.9961571,258.7109152,5.8634098,51.6476054,31.5459495,70.618789,8.3037038,9.8704962,1.4546547,34.4519412),(14252,'femur-1.tif',40,7,66,35.3125752,13.7529012,17.8982275,1.8,13.8138976,17.9659007,1.5425811,5.7336303,5.0543838,180.8649745,259.9034489,5.8807451,51.4213918,31.5445823,71.0618452,8.20036,9.9130082,1.4965529,34.5873062),(14253,'femur-1.tif',40,7,67,35.38637,13.6845917,17.9468494,1.8,13.7459582,17.9950984,1.5301584,4.5781022,5.0050605,181.6135705,261.2227322,5.8879939,52.1917227,39.6700562,88.3022601,8.3050332,9.7264185,1.3849324,34.0095999),(14254,'femur-1.tif',40,7,68,35.4959571,13.6114279,17.9932663,1.8,13.6678259,18.0275955,1.5190807,5.808851,5.0368426,183.1957373,262.7452667,5.9001846,52.1646764,31.5373446,71.7266381,8.393454,9.926466,1.4801364,35.2607299),(14255,'femur-1.tif',40,7,69,35.4653841,13.5331412,18.0342827,1.8,13.5869137,18.054992,1.5130047,5.8232475,4.993721,184.2200101,263.2369383,5.8911776,52.713585,31.6352705,72.1251977,8.2574143,9.8941365,1.5294975,34.9141062),(14256,'femur-1.tif',40,7,70,35.3775024,13.4504698,18.063012,1.8,13.5133393,18.08186,1.5048494,5.8376405,5.0490723,184.8371453,263.4641343,5.8706448,52.1807019,31.6629889,72.4046817,8.5952475,9.934196,1.471946,35.8466474),(14257,'femur-1.tif',40,7,71,35.9826348,13.3773494,18.102135,1.8,13.4518849,18.094249,1.4947395,4.7001552,4.9998777,188.6186039,265.7611822,5.9624815,53.1535362,40.1302925,90.5260419,8.3219773,9.9072831,1.5047767,34.6351649),(14258,'femur-1.tif',40,7,72,36.730274,13.3052588,18.1450022,1.8,13.379896,18.1186093,1.4735835,5.9173683,4.9537529,192.6551899,268.4440291,6.0640422,54.1900325,32.5575797,74.2725071,8.2090789,9.9704131,1.5462111,33.5952937),(14259,'femur-1.tif',40,7,73,36.9589102,13.267551,18.1956776,1.8,13.3225589,18.1276349,1.4481148,4.8714754,5.1690863,193.862902,271.7988962,6.0675726,52.5816129,39.7955208,90.0810595,8.2822831,9.934196,1.471946,33.8461999),(14260,'femur-1.tif',40,7,74,36.5294223,13.2190942,18.2259398,1.8,13.2614903,18.1430266,1.4388083,6.0449948,5.0904894,194.403493,272.2562941,5.9827893,53.4833245,32.1594147,74.6866631,8.5488566,10.151862,1.6352232,36.5398949),(14261,'femur-1.tif',40,7,75,35.9618675,13.1620921,18.2177184,1.8,13.2017441,18.1534697,1.4291473,6.166476,4.9682051,196.7451492,270.4129122,5.8741876,54.4286938,31.9056054,73.5690536,8.2486966,9.8911002,1.5377505,32.3243399),(14262,'femur-1.tif',40,7,76,35.5671658,13.1071691,18.2281265,1.8,13.1416015,18.1672058,1.4242872,4.7563739,5.2133647,198.0088115,270.5126555,5.8015277,51.8883042,41.6302034,89.8691563,8.3849807,10.0573995,1.6114244,35.9820124),(14263,'femur-1.tif',40,7,77,35.4314013,13.0555175,18.2251712,1.8,13.0926834,18.1749028,1.411674,4.6860216,5.1212997,199.252243,272.0265665,5.7569712,53.1167056,42.5205555,92.0078365,8.3563361,10.2389367,1.6426723,34.8265999),(14264,'femur-1.tif',40,7,78,35.4857368,13.0142695,18.2338276,1.8,13.0425902,18.1796698,1.4067808,6.2249008,5.1359245,201.704267,273.8139812,5.7566102,53.313475,32.4028084,74.4264614,8.4060879,10.0573995,1.6114244,34.4403287),(14265,'femur-1.tif',40,7,79,35.5178296,12.9729503,18.2505509,1.8,12.9871735,18.1841603,1.3925023,6.2815897,5.1578726,203.2445591,275.2277065,5.7334459,53.3607026,32.3555927,74.5268917,8.3709716,10.0782837,1.7666021,33.6910112),(14266,'femur-1.tif',40,7,80,35.5962941,12.9348317,18.2659808,1.8,12.955308,18.1991773,1.3868684,6.2636082,5.1802722,205.9382748,276.8140024,5.734268,53.4361886,32.8785371,75.3095032,8.3950632,10.3407804,1.665748,35.4125174),(14267,'femur-1.tif',40,7,81,35.6415688,12.8937514,18.2643466,1.8,12.9076926,18.2027307,1.3948733,4.654048,5.2525949,208.5994663,278.1411686,5.7583055,52.9530969,44.821082,92.6429354,8.4327305,10.4147474,1.6571949,35.2012587),(14268,'femur-1.tif',40,7,82,35.6989278,12.8632848,18.2590215,1.8,12.8733231,18.2131602,1.3749703,6.4509745,5.1578968,211.0431977,279.8057692,5.7245603,54.2480355,32.7149326,74.6743148,8.4608546,10.2389367,1.6426723,34.7589174),(14269,'femur-1.tif',40,7,83,35.3134297,12.836706,18.2680023,1.8,12.8466061,18.2200124,1.3793327,6.4176072,5.162638,211.7139658,278.6862886,5.67244,53.9813734,32.9895489,74.9251994,8.4917693,10.3149284,1.6342033,34.5278349),(14270,'femur-1.tif',40,7,84,35.3414405,12.8008996,18.2667271,1.8,12.8061594,18.2188476,1.3686108,6.492648,5.2005286,214.1098739,279.8927202,5.6527163,53.8200517,32.9772806,74.629373,8.5419821,10.1469296,1.6271881,33.6711874),(14271,'femur-1.tif',40,7,85,35.0918447,12.7725574,18.2874055,1.8,12.7880525,18.2299569,1.3786033,6.5122612,5.1848588,215.5264756,278.8127375,5.6352496,53.7744129,33.0954898,74.5621466,8.5660726,10.3204274,1.6421038,34.4321174),(14272,'femur-1.tif',40,7,86,34.8617323,12.741998,18.2984873,1.8,12.7756913,18.2299218,1.3719324,6.5205448,5.268112,216.445742,279.3327082,5.5835231,53.0233051,33.1944258,74.4423746,8.582972,10.3964655,1.6337053,34.4321174),(14273,'femur-1.tif',40,7,87,34.8618413,12.7143677,18.3296777,1.8,12.7621578,18.2378676,1.3553116,4.4036061,5.3041817,218.7155321,281.0580778,5.5446631,52.9880185,49.6673699,94.0108037,8.6273391,10.4019214,1.6415442,34.4601524),(14274,'femur-1.tif',40,7,88,34.7414594,12.6997633,18.33703,1.8,12.7553853,18.2414534,1.350688,6.5601228,5.2267354,222.0871089,281.5626076,5.5142204,53.8696888,33.8541083,75.7352228,8.7009945,10.1429819,1.7571339,34.4122937),(14275,'femur-1.tif',40,7,89,34.8138597,12.6800093,18.3399555,1.8,12.7465254,18.2484232,1.3492935,4.5039916,5.2864711,226.8295476,282.5300817,5.5222539,53.4439847,50.3618935,95.9172853,8.7782774,10.3058649,1.6183794,34.8067762),(14276,'femur-1.tif',40,7,90,34.6948443,12.6592492,18.3406229,1.8,12.7449572,18.2562988,1.3450925,6.5441149,5.2372531,230.878851,281.1059992,5.4928703,53.6743199,35.2803784,77.0772881,8.8400634,10.158435,1.7650373,33.7388699),(14277,'femur-1.tif',40,7,91,34.7156686,12.6573409,18.3233294,1.8,12.7428393,18.2489836,1.3361829,4.747932,5.2959591,234.4078691,283.0989233,5.4732671,53.4556473,49.3705191,97.393606,8.8759923,10.2386107,1.7634971,34.2967524),(14278,'femur-1.tif',40,7,92,34.6933972,12.6872584,18.3205074,1.8,12.7555823,18.2392902,1.3292787,4.618296,5.3168056,238.8991866,284.3387486,5.4514579,53.4792451,51.7288602,98.1877236,8.9857619,10.2545706,1.7713169,34.4321174),(14279,'femur-1.tif',40,7,93,34.7870283,12.7061933,18.3428987,1.8,12.763407,18.2477671,1.2747407,4.6269946,5.1904202,242.2487345,287.1371144,5.3043384,55.3205908,52.3555256,100.8893036,9.0316198,10.1426528,1.5224469,34.5955174),(14280,'femur-1.tif',40,7,94,35.1305734,12.7345403,18.3251569,1.8,12.7848748,18.2392497,1.1682343,4.7284502,4.9779329,245.8703917,291.9529852,4.9564023,58.649442,51.9980929,103.3913385,9.09537,10.105732,2.2531129,35.0857174),(14281,'femur-1.tif',40,7,95,36.1029572,12.7501392,18.2887752,1.8,12.8058574,18.2235506,1.102742,4.8398009,4.9466332,251.6935389,299.962413,4.7924449,60.6397116,52.0049366,107.3018663,9.1739585,10.1469296,2.2706892,35.0378587),(14282,'femur-1.tif',40,7,96,36.2602727,12.8220797,18.273651,1.8,12.8543616,18.2126172,1.0893376,4.8969305,5.1948143,258.0837092,305.6905432,4.7474594,58.8453269,52.7031594,97.9407463,9.2434225,10.3614155,2.2332226,36.2889887),(14283,'femur-1.tif',40,7,97,36.7589544,12.8352231,18.264472,1.8,12.8739072,18.2022111,1.0427726,7.0179345,5.2317457,265.296424,314.32318,4.5713322,60.0799802,37.8026361,81.5604861,9.3336157,10.2724553,2.451946,36.3566712),(14284,'femur-1.tif',40,7,98,37.2061447,12.8580714,18.2635818,1.8,12.912468,18.1993869,0.9978086,5.3148929,5.1455944,274.4152264,322.0158185,4.3784118,62.5808788,51.6313747,110.9810215,9.4518277,10.4690828,2.5449323,36.2609537),(14285,'femur-1.tif',40,7,99,37.3773942,12.8921333,18.2698913,1.8,12.9234959,18.1808249,0.9243094,5.3663862,5.4102806,284.1275704,327.4143218,3.9690505,60.517068,52.9457925,113.0236952,9.6263406,10.4012797,2.3339759,36.8386599),(14286,'femur-1.tif',40,7,100,37.9608059,12.9444541,18.2663653,1.8,12.9553605,18.1920248,0.8603398,5.322286,5.3905861,296.5835864,341.0145055,3.6357683,63.2611182,55.7248494,118.2747014,9.7426451,10.5266258,2.4717002,37.5120836),(14287,'femur-1.tif',40,7,101,38.8892805,13.0000277,18.2599735,1.8,13.0263428,18.1836317,0.7821282,5.407136,5.3962128,310.4481206,351.8086844,3.2195791,65.1954798,57.4145206,122.1443898,9.7955588,10.7521671,2.5072098,36.8865187),(14288,'femur-1.tif',40,7,102,40.7121308,13.0547855,18.2412677,1.8,13.0820738,18.1725823,0.687165,5.394033,5.4666623,323.562566,372.6119218,2.7304103,68.1607723,59.9852779,124.993487,9.9883406,10.8869658,2.5973122,38.2053311),(14289,'femur-1.tif',40,7,103,42.0009538,13.1382183,18.2595893,1.8,13.0972529,18.1557838,0.630762,5.4327708,5.4076517,343.7642744,388.5890675,2.4347761,71.8591148,63.2760491,131.2423842,10.106194,11.0452237,2.7707014,37.2727899),(14290,'femur-1.tif',40,7,104,43.1007,13.1421435,18.2920469,1.8,13.1087803,18.1793685,0.623902,5.5299028,5.4460167,367.5904265,405.9044154,2.4516916,74.5323489,66.4732169,133.7734713,10.4114143,11.4336225,2.9035463,37.9065661),(14291,'femur-1.tif',40,7,105,44.0871612,13.1833241,18.3114957,1.8,13.1327253,18.2126854,0.4436174,5.5648765,5.6198291,388.7231203,429.8028567,1.3536288,76.4797025,69.8529643,142.6928709,10.4986701,11.4758695,2.9190627,39.2055549),(14292,'femur-1.tif',40,7,106,44.9420908,13.2807152,18.3142902,1.8,13.2053264,18.2435394,0.1859605,5.7111483,5.8637998,413.7637765,459.0483123,0.256054,78.2851276,72.448438,141.2932151,10.6811106,11.7329848,2.9168815,40.5243674),(14293,'femur-1.tif',40,7,107,46.0384252,13.3373387,18.2773457,1.8,13.2532932,18.2153668,-0.0346428,6.0335819,5.9787306,431.528686,498.2578565,0.009205,83.3384018,71.5211449,148.8918474,10.8810562,12.0753043,2.9853425,41.2456499),(14294,'femur-1.tif',40,7,108,47.6011138,13.4407091,18.2650828,1.8,13.300131,18.1898296,-0.1184098,6.1738112,6.1720602,458.2272107,547.018106,0.1107161,88.6281227,74.2211245,155.1224377,10.8780815,12.5217079,3.0828368,42.1980149),(14295,'femur-1.tif',40,7,109,49.0074495,13.5869266,18.2325245,1.8,13.3990952,18.1910583,-0.1706193,6.3002152,6.4435961,486.1355586,608.5992362,0.2354772,94.4502464,77.1617388,164.2368273,10.8448967,13.0213501,3.0725203,42.0065799),(14296,'femur-1.tif',40,7,110,50.5630082,13.694213,18.1555859,1.8,13.4837961,18.1573757,-0.1717582,6.4975575,6.7655674,525.2211599,665.977153,0.2461738,98.4362605,80.8336301,171.2199099,11.4637599,13.4236855,3.0806924,44.4691924),(14297,'femur-1.tif',40,7,111,52.5320734,13.8160455,18.1282717,1.8,13.5487541,18.1205193,-0.2331616,6.5261552,7.1973994,568.8968238,744.7251945,0.4674153,103.4714284,87.1718197,181.5385726,11.3258058,13.9573159,0.2123198,43.9311336),(14298,'femur-1.tif',40,7,112,54.5520267,13.9925626,18.0283693,1.8,13.6595855,18.1048663,-0.2616746,6.5140023,7.6648944,624.5553581,829.0731643,0.6084815,108.1649823,95.878898,189.2720858,11.7216439,14.5329581,0.2790719,44.9710049),(14299,'femur-1.tif',40,7,113,57.0366994,14.1138317,17.9766858,1.8,13.7973505,18.0678208,-0.2862703,6.8524636,8.0391631,697.4506384,942.3586167,0.7579833,117.2209848,101.7810064,198.0429756,12.2485344,15.3232702,0.3032029,48.8399361),(14300,'femur-1.tif',40,7,114,60.5815668,14.2962658,17.8131302,1.8,13.9272816,17.9946838,-0.3252796,7.1512745,8.6263988,802.37629,1072.2466702,1.0311728,124.2982957,112.2004607,211.6353797,12.770338,16.2385816,0.1668029,51.421491),(14301,'femur-1.tif',40,7,115,65.0310148,14.4502424,17.6271933,1.8,14.1171455,17.7745959,-0.4070969,7.4927779,8.9857319,924.99949,1309.2727376,1.69918,145.7057422,123.4521432,241.9384264,13.5437865,17.2191352,0.1620286,54.031081),(14302,'femur-1.tif',40,7,116,72.0273888,14.6659997,17.3536195,1.8,14.5110392,17.3777675,-0.4338131,8.2545343,9.2664256,1135.3189508,1594.237938,2.120972,172.0445413,137.5388254,284.1290323,14.6576781,18.3942974,0.1381282,57.5533885),(14303,'femur-1.tif',40,7,117,83.5712119,14.9580679,16.5594658,1.8,14.9577513,16.7141239,-0.5419012,8.6787995,9.656971,1641.3744242,1907.1088454,3.7051899,197.4851993,189.1245934,341.3944049,16.1601078,19.3009227,0.1658446,63.3797185),(14304,'femur-1.tif',40,7,118,100.9906876,16.2069173,15.6125524,1.8,15.8846326,15.7728114,-0.5133073,9.3440267,11.1436397,2293.3407615,2880.7230982,4.0588317,258.5082776,245.433883,441.1980581,17.2715729,22.2563158,0.2636764,93.0998621),(14305,'femur-1.tif',40,7,119,114.1107558,17.1042303,15.1788163,1.8,16.5562601,15.3360157,-0.4062944,10.3879972,12.0054962,2641.7463882,3605.6555832,2.9704834,300.333741,254.3075762,503.7167599,18.0739665,23.2631337,0.2483858,74.0854072),(14306,'femur-1.tif',40,7,120,121.8685798,17.5537023,14.9210601,1.8,16.8919726,15.1041192,-0.4032209,10.633532,12.337886,2847.7735905,3946.7249579,3.1272365,319.8866458,267.8106948,539.4527944,18.3963389,23.7190453,0.2399662,74.5311496),(14307,'femur-1.tif',40,7,121,122.3119699,17.8543145,14.7398193,1.8,17.1329204,14.9824847,-0.3914867,10.7549299,12.4130417,2864.3740756,3954.8980583,2.9679081,318.6082962,266.3312638,541.4186111,18.470776,23.82112,0.2283413,75.0972434),(14308,'femur-1.tif',40,7,122,116.21612,18.0101721,14.6393688,1.8,17.3566358,14.8658239,-0.4022307,10.7002076,12.27796,2848.011441,3897.0296013,2.9683591,317.4004145,266.1641283,543.7698125,18.3449453,23.7319869,0.2115742,72.6742784),(14309,'femur-1.tif',40,7,123,109.3547139,18.0886366,14.5670402,1.8,17.4687688,14.8902834,-0.3701942,10.6842466,12.0186016,2713.15814,3699.6402462,2.3856955,307.8261835,253.9400529,520.2205003,18.2006969,23.4416366,0.2035472,72.1608534),(14310,'femur-1.tif',40,7,124,103.5252959,18.0698893,14.5696039,1.8,17.5982773,14.8945306,-0.2807773,10.6968582,11.4896186,2513.7161799,3354.8560771,1.3248798,291.9902033,234.9957458,502.200218,17.8757691,22.9459219,0.1862228,71.5667247),(14311,'femur-1.tif',40,7,125,96.7391802,18.0500613,14.6786801,1.8,17.7138022,14.9380065,-0.2594412,10.5472187,11.1584483,2254.8377513,2820.6124396,1.0611163,252.7781966,213.7850572,442.9103753,17.7684105,22.2237518,0.1923487,70.4591709),(14312,'femur-1.tif',40,7,126,89.9876558,18.0958496,14.7931373,1.8,17.769952,14.9990286,-0.0780683,10.3478584,11.1128341,1902.3532663,2409.4342666,0.0912218,216.8154628,183.8402871,386.3597951,17.0315647,21.3060068,0.1462354,64.8885572),(14313,'femur-1.tif',40,7,127,83.2371962,18.0648403,14.8051765,1.8,17.8506173,15.0557001,0.1939113,9.4452685,10.7116339,1502.0532719,2016.3012371,0.5151363,188.2347042,159.0270588,325.7994081,16.4665716,20.1865144,0.129877,63.087756),(14314,'femur-1.tif',40,7,128,74.1200232,18.3048793,14.9043407,1.8,18.0622995,15.1574356,0.3225808,8.2636557,9.800728,1015.3825013,1617.9430527,1.241494,165.0839669,122.8732823,261.1884778,15.0329519,18.8309197,0.0651252,72.0336997),(14315,'femur-1.tif',40,7,129,59.0572962,18.937291,15.0958107,1.8,18.6553934,15.1665152,0.358727,7.2118302,8.5808965,542.1117566,1118.1392276,1.2132235,130.3056418,75.1697893,188.1210955,12.9841986,17.1849887,0.0570808,64.7628123),(14316,'femur-1.tif',40,7,130,37.2065078,20.1733816,15.6734268,1.8,19.7144533,15.4759618,0.3107827,5.5991069,8.2544723,198.5852482,588.7679245,0.579901,71.3271427,35.4673078,92.535518,4.4264876,9.6177246,0.5054483,29.6340462),(14317,'femur-1.tif',40,7,131,17.1035694,21.5239453,16.0187781,1.8,21.1410929,16.0317539,0.3398791,3.5379138,8.0622514,31.916645,171.1480292,0.3168084,21.2283172,9.0213179,25.0035454,3.9297138,7.4687386,0.527287,19.6646537),(14318,'femur-1.tif',40,7,132,0.9485957,22.7333217,16.084244,1.8,22.8834057,16.0244279,-0.1894466,1.2860116,2.0759115,0.190505,0.3399288,0.0056066,0.1637492,0.1481363,0.2552775,2.2398041,3.1863,0.3947911,9.3718625),(14319,'femur-1.tif',40,7,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14320,'femur-1.tif',40,7,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14321,'femur-1.tif',40,7,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14322,'femur-1.tif',40,7,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14323,'femur-1.tif',40,7,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14324,'tibia-1.tif',40,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14325,'tibia-1.tif',40,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14326,'tibia-1.tif',40,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14327,'tibia-1.tif',40,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14328,'tibia-1.tif',40,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14329,'tibia-1.tif',40,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14330,'tibia-1.tif',40,8,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14331,'tibia-1.tif',40,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14332,'tibia-1.tif',40,8,9,0.0549581,16.9854067,19.195135,1.8,16.9907829,19.2164036,1.326919,0.1863026,1.3609436,0.0005249,0.065102,0.0086256,0.0478359,0.0028175,0.0481507,0,0,0,0),(14333,'tibia-1.tif',40,8,10,30.2035657,19.1396888,18.3332863,1.8,19.2740438,18.3184245,-0.5612894,4.0304024,4.5127038,72.7829463,174.957861,1.4262127,38.7700742,18.0584813,48.9740271,6.9216842,9.4054409,1.0020684,31.9578924),(14334,'tibia-1.tif',40,8,11,46.5089454,19.4312715,17.9978827,1.8,19.551892,18.1384784,-1.1296488,5.7293691,5.6817832,247.1759461,275.9033681,6.338319,48.5592915,43.1419132,90.8439279,8.4820115,10.9910036,2.568022,35.10214),(14335,'tibia-1.tif',40,8,12,53.2413992,19.5302153,17.7864521,1.8,19.5818808,17.9390509,1.2356575,4.4283453,5.4039845,302.5717911,437.743061,7.913665,81.0037602,68.326151,116.4786075,8.7008307,12.308804,2.5259728,40.7288237),(14336,'tibia-1.tif',40,8,13,57.3676281,19.5928813,17.7019595,1.8,19.5544638,17.7690379,1.1255527,4.8238772,5.941027,316.3570047,592.8954438,7.7878148,99.7967927,65.5814799,135.4203488,8.9494244,13.3348818,2.5127964,42.2192475),(14337,'tibia-1.tif',40,8,14,63.0151355,19.3302661,17.5260746,1.8,19.2476712,17.4803816,1.0160599,5.0095341,7.3436628,356.3312895,762.2653413,7.5887743,103.7990665,71.1306251,143.4664032,8.7466786,15.0492199,2.4948342,44.7413312),(14338,'tibia-1.tif',40,8,15,65.8231174,19.0872142,17.2231238,1.8,18.9961524,17.1646664,0.9884447,5.0962052,7.4791749,362.6958112,754.4127107,7.6520649,100.8684414,71.1697815,141.2725424,9.0249541,15.3478621,2.5225808,47.1198387),(14339,'tibia-1.tif',40,8,16,3.7976846,22.6622749,13.3140575,1.8,22.7014889,13.3109998,-1.0180331,1.3905096,1.4910158,1.2023294,1.6236267,0.4584641,1.08894,0.8646682,1.8928006,2.5230623,2.9457354,0.9827937,8.9179087),(14340,'tibia-1.tif',40,8,17,11.7773894,21.1735507,14.9746912,1.8,21.093635,15.0464288,-0.8203481,2.340157,5.2598293,8.14229,96.786458,1.0499965,18.4010643,3.4793777,19.9354296,2.727982,4.4756391,1.9445231,11.8542987),(14341,'tibia-1.tif',40,8,18,22.8026397,19.1567552,14.959846,1.8,19.0962815,14.9038187,-0.3990397,5.5140532,6.1955027,140.1259337,281.6527432,0.5737085,45.4608381,25.4125102,59.9620019,0.3770634,2.3819439,2.1112158,5.2636375),(14342,'tibia-1.tif',40,8,19,37.7355349,18.5481577,14.8912103,1.8,18.5946088,14.8898222,-0.3555517,5.2398191,6.4539977,254.4804112,502.1200793,0.7621251,77.7998543,48.5666409,110.6350199,3.9605283,7.5257187,2.1316971,24.6459487),(14343,'tibia-1.tif',40,8,20,57.799242,17.9644362,14.7678648,1.8,18.082811,14.7812918,-0.2620128,4.7933911,7.6717919,313.9077312,751.191537,0.6463306,97.9160475,65.4876114,138.8124973,9.1457565,13.5005388,0.2758059,52.1804286),(14344,'tibia-1.tif',40,8,21,60.0283228,18.1119094,14.552927,1.8,18.1278026,14.5560438,-0.2621674,4.7246338,7.5333495,299.9380453,802.7694725,0.6720312,106.5620903,63.4838713,145.4207671,8.9665709,13.8285547,0.4134253,49.9571099),(14345,'tibia-1.tif',40,8,22,60.2945127,18.5819501,14.134496,1.8,18.3805653,14.1910149,-0.3228128,4.6404531,6.8638477,280.7438475,770.3624756,1.0113223,112.2347849,60.4992312,153.0521586,8.6040346,13.6461014,0.4127533,40.7684712),(14346,'tibia-1.tif',40,8,23,53.1328315,18.5473142,14.0412015,1.8,18.414267,14.0568329,-0.327,4.374621,6.5561839,243.3538318,662.3480375,0.9136339,101.0264587,55.6285523,137.7575066,8.2048657,13.1415156,0.4024428,39.2500124),(14347,'tibia-1.tif',40,8,24,45.6732812,18.3651631,14.0197239,1.8,18.3875714,13.9865063,-0.3308098,4.1516469,6.358323,205.5203725,554.7674617,0.8030954,87.2505946,49.5033365,118.9731774,7.8018557,12.6384382,0.3913103,37.3336699),(14348,'tibia-1.tif',40,8,25,41.0105702,18.2284634,13.9581602,1.8,18.2887246,13.8847863,-0.3281687,3.9110113,6.0789138,178.3089597,479.8905728,0.7100553,78.9434745,45.5915224,107.1720185,7.4763606,12.0982226,0.2875758,35.3810812),(14349,'tibia-1.tif',40,8,26,38.3069539,18.1251437,13.8979165,1.8,18.1229707,13.8307506,-0.3296208,3.7963068,5.820243,155.5094774,420.6174756,0.6689126,72.2680264,40.9633583,97.705899,7.2383269,11.6519211,0.2551824,33.7190462),(14350,'tibia-1.tif',40,8,27,36.0022426,18.0278695,13.8458751,1.8,18.0130454,13.795874,-0.3419645,3.6681067,5.6240138,139.4772209,385.9427625,0.6747535,68.6240777,38.0243086,91.7063687,7.0002616,11.3165561,0.2257166,32.5752462),(14351,'tibia-1.tif',40,8,28,34.3587144,17.9809823,13.8204231,1.8,17.9488637,13.7881699,-0.3378773,3.541656,5.6496529,127.6125407,355.3768076,0.6292365,62.9024145,36.0318846,85.2632724,6.8094589,11.1687218,0.3587707,32.3639874),(14352,'tibia-1.tif',40,8,29,33.2498416,17.9318401,13.8138736,1.8,17.9022488,13.7900442,-0.3501564,3.4564308,5.291381,117.3318154,327.9178564,0.6521385,61.972074,33.9459464,82.7013223,6.647097,10.7353925,0.1914255,30.9015987),(14353,'tibia-1.tif',40,8,30,32.1022134,17.8388288,13.8245077,1.8,17.8034516,13.8062233,-0.3566116,3.3975894,5.1454342,110.0124873,302.9010236,0.6520575,58.8679227,32.3795712,78.5793636,6.5419589,10.4655755,0.2203624,30.1803162),(14354,'tibia-1.tif',40,8,31,31.5788831,17.7760967,13.8339673,1.8,17.7533018,13.8197602,-0.3642507,3.3396414,5.0658595,105.9126069,286.5682814,0.6679645,56.5685407,31.7137663,75.9265857,6.4492045,10.3061887,0.223828,29.6422574),(14355,'tibia-1.tif',40,8,32,31.2632136,17.7426683,13.8682744,1.8,17.7254927,13.8568932,-0.3654559,3.2853278,4.982777,102.1375474,271.5580359,0.6654739,54.4993358,31.088997,73.2460504,6.3600109,10.158435,0.194241,29.0843749),(14356,'tibia-1.tif',40,8,33,30.8818813,17.7007362,13.9175659,1.8,17.6810715,13.914604,-0.3645467,3.256757,4.8969397,98.8174141,257.7998259,0.6542359,52.6450893,30.342274,71.6511175,6.2761817,9.9674001,0.1813198,28.5545274),(14357,'tibia-1.tif',40,8,34,30.6209677,17.6556308,13.9765498,1.8,17.6424129,13.9730698,-0.3628171,3.2277778,4.8157002,96.0956292,245.893412,0.6428396,51.0607811,29.7714515,69.6362196,6.2065597,9.8097854,0.1336522,27.9966449),(14358,'tibia-1.tif',40,8,35,30.3059769,17.6105598,14.0527032,1.8,17.6011592,14.0519326,-0.3579164,3.2182905,4.7467454,93.6373652,235.0729968,0.6198912,49.5229836,29.095374,68.1999454,6.1710048,9.659276,0.1442894,27.4866212),(14359,'tibia-1.tif',40,8,36,30.0978672,17.5495155,14.1214147,1.8,17.5439625,14.1236074,-0.3553551,3.2010899,4.645928,91.9501736,224.4879202,0.6072277,48.3192852,28.7246456,67.2381719,6.1483652,9.4648666,0.121143,27.0046324),(14360,'tibia-1.tif',40,8,37,29.8108754,17.4830471,14.1838999,1.8,17.4812007,14.1844428,-0.3539973,3.1784552,4.5810333,90.3794705,214.5406135,0.5970435,46.8323623,28.4350305,66.1761291,6.1130842,9.2678199,0.1593516,26.6101499),(14361,'tibia-1.tif',40,8,38,29.6253038,17.4106994,14.2399363,1.8,17.4086215,14.2356458,-0.3519891,3.183913,4.5515218,89.71522,206.2720055,0.5868939,45.319349,28.1776603,64.8654401,6.1285282,9.1493058,0.1886392,26.2156674),(14362,'tibia-1.tif',40,8,39,29.5808484,17.3589993,14.3059966,1.8,17.3541508,14.303818,-0.3477799,3.1962508,4.5175487,89.4032318,199.3748474,0.5726481,44.1334142,27.971282,63.8541591,6.1726929,9.0572843,0.2646698,25.8888674),(14363,'tibia-1.tif',40,8,40,29.5430228,17.2915408,14.3763192,1.8,17.2892364,14.3733464,-0.3464768,3.2105913,4.4937559,89.3024966,193.0645133,0.5678107,42.9628398,27.8149686,62.6674701,6.2075418,8.9572417,0.2582522,25.6099262),(14364,'tibia-1.tif',40,8,41,29.4075049,17.2254771,14.4406147,1.8,17.2183341,14.4398429,-0.3463419,3.2057836,4.4517789,89.4153181,186.5073198,0.5647836,41.8950097,27.891876,61.7757046,6.2375889,8.86172,0.213669,25.4267024),(14365,'tibia-1.tif',40,8,42,29.3245833,17.1615324,14.5046919,1.8,17.1562048,14.501327,-0.3480673,3.2112646,4.4291091,89.7144438,180.4433241,0.5685873,40.7403202,27.9374191,60.9889541,6.230095,8.7647767,0.2065361,25.2831262),(14366,'tibia-1.tif',40,8,43,29.2092591,17.0974865,14.5697708,1.8,17.0952436,14.5650663,-0.3481089,3.2016867,4.3789747,89.7674763,174.4442009,0.5664814,39.8367684,28.0375576,59.9624434,6.2630834,8.6848292,0.2084652,25.0520437),(14367,'tibia-1.tif',40,8,44,29.0555067,17.0345256,14.63914,1.8,17.032513,14.635854,-0.3527363,3.199331,4.3567002,90.2009685,168.7192166,0.5779499,38.7263778,28.193697,59.2617661,6.2844211,8.6049146,0.2104302,24.9563262),(14368,'tibia-1.tif',40,8,45,28.9894119,16.9803872,14.7135676,1.8,16.9740665,14.7076365,-0.3579198,3.1959361,4.3084399,90.2261662,164.5051196,0.5929724,38.1820616,28.2315301,59.0392362,6.2781512,8.5066141,0.2822574,24.7450674),(14369,'tibia-1.tif',40,8,46,28.9409692,16.9325311,14.7910381,1.8,16.9245528,14.7856171,-0.3642334,3.1771492,4.2645917,90.6011102,160.5753133,0.6121111,37.6531503,28.5164797,58.8175422,6.3002092,8.4281778,0.2849574,24.6295262),(14370,'tibia-1.tif',40,8,47,29.0263404,16.8825514,14.8677004,1.8,16.8769423,14.8637828,-0.3691103,3.1853068,4.2148056,91.4765243,157.3424297,0.6297091,37.3308865,28.7182776,58.8342535,6.3393001,8.3653779,0.2165503,24.5139849),(14371,'tibia-1.tif',40,8,48,29.1613544,16.8261021,14.9433379,1.8,16.8171942,14.9455091,-0.3724331,3.2179693,4.1888723,92.6598463,154.3549657,0.6435459,36.8488116,28.7945087,58.7685133,6.3754939,8.3037109,0.2282738,24.4661262),(14372,'tibia-1.tif',40,8,49,29.3476526,16.771863,15.016357,1.8,16.7656707,15.0208841,-0.3763928,3.2420354,4.1457388,93.8618384,152.0098863,0.6608425,36.6665375,28.9515152,59.1104094,6.4175725,8.2261799,0.2714785,24.3027262),(14373,'tibia-1.tif',40,8,50,29.2950328,16.7168224,15.0915571,1.8,16.7113419,15.0910272,-0.3810251,3.2640782,4.1018848,94.372333,149.3663273,0.6751966,36.4140714,28.9123993,59.2696596,6.4452908,8.1716339,0.2013171,24.2548674),(14374,'tibia-1.tif',40,8,51,29.3961286,16.6577134,15.1639937,1.8,16.6514153,15.1613198,-0.3853699,3.305133,4.0766837,95.4319062,147.2429788,0.6922898,36.1183234,28.8738477,59.3566958,6.4826687,8.1126085,0.1618374,24.2548674),(14375,'tibia-1.tif',40,8,52,29.368691,16.601409,15.241225,1.8,16.596269,15.239219,-0.3964623,3.318965,4.0491779,96.1827927,144.8346356,0.7298981,35.7688988,28.9797551,59.3757425,6.5054695,8.0469316,0.2671425,24.2350437),(14376,'tibia-1.tif',40,8,53,29.3584991,16.545821,15.3153177,1.8,16.5331604,15.3141315,-0.4120132,3.3547117,4.0087226,96.9319978,142.9182416,0.7846748,35.6518159,28.8942856,59.4867662,6.5678408,8.0053494,0.2474539,24.1871849),(14377,'tibia-1.tif',40,8,54,29.4513763,16.4875397,15.4002084,1.8,16.4757595,15.4068554,-0.4279578,3.362829,3.9865377,97.9504093,141.2778881,0.845433,35.4387438,29.1273836,59.9622845,6.6137955,7.9316353,0.2074962,24.1195024),(14378,'tibia-1.tif',40,8,55,29.5166344,16.4281776,15.4717444,1.8,16.41443,15.4741767,-0.4433548,3.388495,3.9591025,99.3369446,139.9740893,0.9052615,35.3550051,29.3159485,60.1678619,6.6506647,7.869114,0.2197951,24.1195024),(14379,'tibia-1.tif',40,8,56,29.5857069,16.3720991,15.552863,1.8,16.3618725,15.5563166,-0.4604862,3.3971737,3.96672,100.6076643,138.5124664,0.9737488,34.91864,29.6151077,60.0779891,6.6871191,7.823175,0.430949,24.0518199),(14380,'tibia-1.tif',40,8,57,29.6436941,16.3166095,15.6378626,1.8,16.3041093,15.6395823,-0.4792336,3.4057719,3.9530408,101.7182938,137.6689723,1.0504368,34.8260941,29.866443,59.9304237,6.7235735,7.7975364,0.6141594,24.1673612),(14381,'tibia-1.tif',40,8,58,29.6687473,16.2633819,15.7304184,1.8,16.2536262,15.731654,-0.5073466,3.40285,3.9767694,102.8593306,136.6280981,1.1672663,34.3565555,30.2274069,59.9764298,6.7602352,7.7769646,0.5530314,24.0518199),(14382,'tibia-1.tif',40,8,59,29.7798266,16.2105553,15.8144829,1.8,16.1984035,15.8140532,-0.53189,3.4388146,3.9874924,104.585176,136.4360751,1.2766334,34.2160087,30.4131478,59.9299549,6.8329365,7.778681,0.6287963,24.1673612),(14383,'tibia-1.tif',40,8,60,29.9389428,16.1574548,15.8988045,1.8,16.1473965,15.8979886,-0.5561689,3.4603213,3.999044,106.6339247,136.371473,1.3907477,34.1010181,30.8161916,60.1910902,6.9058453,7.7722426,0.590918,24.2630787),(14384,'tibia-1.tif',40,8,61,30.144428,16.1115839,15.9827066,1.8,16.105477,15.9844677,-0.5867281,3.4616981,4.0024102,108.8108265,137.0256123,1.5399607,34.2357747,31.432789,61.0563232,6.9429219,7.7615001,0.6435011,24.2630787),(14385,'tibia-1.tif',40,8,62,30.3191515,16.0630133,16.0641227,1.8,16.0555894,16.0671592,-0.6183719,3.4870501,4.034224,110.7721769,137.7273585,1.6981904,34.1397397,31.766729,61.2959684,7.0158306,7.7962522,0.6665578,24.4264787),(14386,'tibia-1.tif',40,8,63,30.5627032,16.0151945,16.1442523,1.8,16.0061757,16.1525234,-0.6516363,3.5473289,4.0482515,112.8344859,138.8519762,1.8736361,34.2992462,31.8082959,62.1655345,7.0524924,7.7975364,0.6141594,24.406655),(14387,'tibia-1.tif',40,8,64,30.7966225,15.965674,16.2251266,1.8,15.9578486,16.2285318,-0.6946676,3.6052206,4.0739938,115.0525431,140.0820378,2.1032376,34.3844506,31.9127613,62.620747,7.1256085,7.8107935,0.6518691,24.5898787),(14388,'tibia-1.tif',40,8,65,31.1002148,15.9225907,16.312894,1.8,15.9122454,16.3161126,-0.7375408,3.6832827,4.0936752,117.3220131,141.8234948,2.344001,34.6445399,31.8525684,63.1082026,7.1987246,7.8640229,1.0606706,24.6855962),(14389,'tibia-1.tif',40,8,66,31.2556993,15.8838089,16.3934467,1.8,15.883354,16.3901617,-0.7777965,3.6965565,4.1161874,119.4109548,143.3699713,2.5650439,34.8307686,32.3032946,63.6215835,7.2712185,7.8974789,1.1441688,24.733455),(14390,'tibia-1.tif',40,8,67,31.400288,15.840795,16.485619,1.8,15.8396578,16.4826822,-0.8176597,3.7735383,4.1616879,121.5000359,144.6963661,2.7854106,34.7686728,32.1979073,63.8945071,7.3078803,7.9387853,1.1577966,24.8489962),(14391,'tibia-1.tif',40,8,68,31.6184732,15.8032043,16.5809657,1.8,15.8012808,16.5779729,-0.8624813,3.8524366,4.2009992,123.6830531,146.5906752,3.0394742,34.89424,32.1051496,64.3352834,7.3745792,7.9815507,1.1712808,25.0800787),(14392,'tibia-1.tif',40,8,69,31.7817468,15.7600404,16.6708442,1.8,15.751978,16.6595523,-0.9154104,3.9265516,4.2073959,125.8394149,148.2445367,3.3294141,35.2342729,32.0483281,65.1417535,7.4347,8.0257516,1.1846189,25.0123962),(14393,'tibia-1.tif',40,8,70,31.8411621,15.7210335,16.7689972,1.8,15.7104175,16.7599362,-0.9591979,3.9553849,4.2205481,127.6883068,150.4265857,3.5572996,35.6414815,32.2821442,65.7395351,7.4347,8.0713646,1.1978086,25.1757962),(14394,'tibia-1.tif',40,8,71,31.6972282,15.6871233,16.8573474,1.8,15.6837911,16.8529376,-0.9943678,3.9850083,4.2351783,128.9145737,152.5020991,3.713536,36.008425,32.3498887,66.1049765,7.4347,8.1014933,1.1884173,25.2913375),(14395,'tibia-1.tif',40,8,72,31.6833706,15.6533624,16.9451132,1.8,15.6443582,16.9424172,-1.0318602,4.0383444,4.2621291,130.6389244,155.0796862,3.889672,36.3854967,32.3496242,66.512721,7.5164,8.1700001,1.2870022,25.4068787),(14396,'tibia-1.tif',40,8,73,31.721555,15.6205102,17.0352241,1.8,15.6115045,17.0333529,-1.0741091,4.0506493,4.2855985,132.0626611,158.1121296,4.0864386,36.8938268,32.6028376,67.129398,7.4347,8.2261799,1.2993178,25.5025962),(14397,'tibia-1.tif',40,8,74,31.9990413,15.5857138,17.1248876,1.8,15.5766887,17.1199783,-1.1092873,4.0609524,4.2902397,134.2822335,161.947718,4.2756487,37.7479421,33.0666848,68.0910148,7.5164,8.3197722,1.2614675,25.7535024),(14398,'tibia-1.tif',40,8,75,32.0898104,15.561009,17.2236911,1.8,15.5591375,17.2179273,-1.1481926,4.0852373,4.2880197,135.818155,165.1462504,4.4486534,38.5134072,33.2460867,68.7244715,7.5164,8.3653779,1.354246,25.8211849),(14399,'tibia-1.tif',40,8,76,32.299168,15.5245606,17.3132551,1.8,15.5110018,17.3046136,-1.1731227,4.0647647,4.2999801,137.9166089,168.4329093,4.5758145,39.1706254,33.9297888,69.6599958,7.5636831,8.4281778,1.285839,26.0324437),(14400,'tibia-1.tif',40,8,77,32.5022393,15.5011814,17.405224,1.8,15.5033029,17.4021311,-1.2098596,4.0737844,4.286958,139.7443337,172.1517068,4.7414513,40.157078,34.3033206,70.11303,7.5164,8.4842215,1.2977876,26.0324437),(14401,'tibia-1.tif',40,8,78,32.77628,15.4779199,17.4972263,1.8,15.4878918,17.4964624,-1.2266042,4.0788092,4.2882056,142.4979615,175.6869328,4.8407108,40.9698017,34.9361673,70.3581763,7.5963067,8.5800561,1.3304366,26.2635262),(14402,'tibia-1.tif',40,8,79,32.7528434,15.4498177,17.5794868,1.8,15.4624657,17.5791449,-1.2388195,4.0981541,4.2850216,144.2409462,178.9982956,4.8789782,41.7730208,35.1965651,70.475056,7.6319256,8.6223504,1.3510996,26.5144324);
INSERT INTO `slices_w` VALUES (14403,'tibia-1.tif',40,8,80,32.7679195,15.4197399,17.6659016,1.8,15.4269918,17.6643055,-1.2550533,4.0920458,4.2818712,145.7779799,182.2360487,4.9347152,42.5599094,35.6247184,71.2106756,7.6370066,8.6594293,1.3326825,26.5821149),(14404,'tibia-1.tif',40,8,81,32.8513437,15.3921448,17.7486384,1.8,15.4014154,17.7502598,-1.2580719,4.0905303,4.2942591,147.5645776,185.6542343,4.9569951,43.2331238,36.074681,71.3771675,7.6370066,8.7036388,1.4010181,26.6778324),(14405,'tibia-1.tif',40,8,82,32.9026044,15.3687983,17.8331356,1.8,15.378494,17.8326481,-1.2631842,4.0957785,4.3206595,148.86633,188.8852904,4.9810266,43.7167728,36.3462843,72.1853194,7.6732536,8.7647767,1.3642603,26.6778324),(14406,'tibia-1.tif',40,8,83,33.0005603,15.3481312,17.9177935,1.8,15.356973,17.9179297,-1.2579655,4.1030504,4.3528103,150.5273394,192.3821439,4.979168,44.1972266,36.68669,73.0959372,7.6732536,8.8183031,1.3370531,26.7933737),(14407,'tibia-1.tif',40,8,84,33.1791296,15.3308651,17.9964224,1.8,15.3400334,18.0016639,-1.2589042,4.1105134,4.3795446,152.7066585,195.9259864,5.0091466,44.7366121,37.1502641,73.4792337,7.7034347,8.86172,1.3571273,26.9089149),(14408,'tibia-1.tif',40,8,85,33.2320707,15.3148126,18.0741086,1.8,15.3244016,18.0761517,-1.2547037,4.096817,4.3962275,154.2748281,199.1625631,5.003471,45.303061,37.6572421,74.4014095,7.7147945,8.8978015,1.3391799,27.0921387),(14409,'tibia-1.tif',40,8,86,33.4110133,15.304166,18.1514772,1.8,15.3121765,18.1525504,-1.2471765,4.1376034,4.4101689,156.8070834,203.2033637,5.0053909,46.0760952,37.8980458,75.537383,7.7356215,8.9169104,1.3302621,27.2555387),(14410,'tibia-1.tif',40,8,87,33.7712528,15.2938793,18.2299922,1.8,15.3051235,18.2311613,-1.2408913,4.1543447,4.4271068,159.9727245,207.9615582,5.0378512,46.9745973,38.5073309,77.1267937,7.773023,8.9415789,1.3590648,27.2555387),(14411,'tibia-1.tif',40,8,88,34.1204149,15.2908899,18.3036354,1.8,15.3005143,18.307493,-1.2302601,4.1783312,4.4457212,163.041068,212.6563919,5.0523745,47.8339467,39.0206184,78.615949,7.8062534,8.9784546,1.3037462,27.4189387),(14412,'tibia-1.tif',40,8,89,34.352187,15.2772045,18.3830508,1.8,15.2865094,18.3875393,-1.2263146,4.1873743,4.4594568,165.7633685,217.1737589,5.072402,48.6995989,39.5864703,79.1668644,7.8144293,9.0388414,1.3521274,27.5823387),(14413,'tibia-1.tif',40,8,90,34.735902,15.2768823,18.4696295,1.8,15.2887133,18.4753752,-1.2148871,4.2176591,4.4646563,169.4153393,221.7089924,5.0864225,49.6586916,40.1680966,80.8130986,7.8538452,9.0756897,1.3345511,27.8134212),(14414,'tibia-1.tif',40,8,91,34.9094739,15.2727997,18.5510448,1.8,15.2873038,18.5490922,-1.2012652,4.2441468,4.4849217,172.701503,225.7541555,5.0592571,50.336253,40.6916895,82.3159864,7.8902954,9.0951588,1.3258177,27.8811037),(14415,'tibia-1.tif',40,8,92,35.2601694,15.2677131,18.6332351,1.8,15.2788319,18.6252566,-1.1851568,4.2716345,4.5196229,176.6921405,231.2253068,5.0452005,51.1603098,41.3640592,84.1114726,7.9290564,9.1361644,1.3084658,28.0246799),(14416,'tibia-1.tif',40,8,93,35.4078454,15.2489951,18.7312879,1.8,15.2580061,18.7259658,-1.179672,4.2923244,4.5647066,179.457711,234.4295507,5.0436422,51.3569816,41.8089814,84.4741017,7.9515062,9.1744408,1.3279775,28.2557624),(14417,'tibia-1.tif',40,8,94,35.3739718,15.2466071,18.8122702,1.8,15.25607,18.8083,-1.1721848,4.3030799,4.5853545,182.7536052,237.7020024,5.0074688,51.8393953,42.4704187,85.6584847,7.9657181,9.2150937,1.310765,28.3713037),(14418,'tibia-1.tif',40,8,95,35.431575,15.2475183,18.8927156,1.8,15.2614612,18.8873863,-1.1597347,4.3355247,4.6278286,186.1382721,241.4373137,4.9623907,52.1707557,42.9332749,86.9233541,8.0111919,9.2584523,1.2937088,28.5347037),(14419,'tibia-1.tif',40,8,96,35.5211215,15.2504562,18.9703275,1.8,15.2634204,18.9648835,-1.1563266,4.3784362,4.6590391,189.4646024,245.6293975,4.9601043,52.7210424,43.2722085,87.3614846,8.0633937,9.3044787,1.2212751,28.7459624),(14420,'tibia-1.tif',40,8,97,35.5716656,15.261429,19.0525845,1.8,15.2706541,19.0534568,-1.1600969,4.4217732,4.6839279,193.2344452,249.5489618,4.9835838,53.2777125,43.7006685,88.8167058,8.103008,9.3616936,1.2048756,28.9093624),(14421,'tibia-1.tif',40,8,98,35.8084531,15.2810367,19.1239982,1.8,15.2946422,19.1250471,-1.1562598,4.4683116,4.7036969,197.0394566,254.4528155,4.9999327,54.0963466,44.0970713,90.2754258,8.1336134,9.4157257,1.2984561,29.0925862),(14422,'tibia-1.tif',40,8,99,36.0407138,15.3041021,19.2030211,1.8,15.330327,19.2130479,-1.1618214,4.5208069,4.728127,200.8676842,259.7017192,5.0568686,54.9269766,44.4318212,91.6619243,8.1787589,9.4859999,1.219082,29.2361624),(14423,'tibia-1.tif',40,8,100,36.2580247,15.3171781,19.2780913,1.8,15.3473102,19.279145,-1.1686896,4.5407392,4.7623751,203.8824122,265.700962,5.1174516,55.7916912,44.9007093,92.3665141,8.1932991,9.5435253,1.2030079,29.4672449),(14424,'tibia-1.tif',40,8,101,36.2118785,15.3207783,19.3544366,1.8,15.3413068,19.3446895,-1.1751352,4.5738434,4.7784483,206.2062544,269.8253324,5.1387835,56.4671444,45.0838032,92.5819772,8.2239045,9.6121709,1.2329181,29.6306449),(14425,'tibia-1.tif',40,8,102,36.4522931,15.330312,19.4403064,1.8,15.3539058,19.4281591,-1.1808617,4.615066,4.8145279,210.2225093,274.3998711,5.1975062,56.9941389,45.5513553,93.1750245,8.2617941,9.6675649,1.2169712,29.7940449),(14426,'tibia-1.tif',40,8,103,36.5225769,15.3423455,19.5258433,1.8,15.3695329,19.5123833,-1.1877297,4.641363,4.8490366,213.3166904,277.5792401,5.23672,57.2442044,45.9599238,93.601107,8.2823571,9.7253891,1.20121,29.9376212),(14427,'tibia-1.tif',40,8,104,36.7271123,15.3545592,19.6150061,1.8,15.3801812,19.6044025,-1.1961911,4.6691216,4.8700335,216.6643599,282.119421,5.3016409,57.9296673,46.4036658,94.0447392,8.3011804,9.7726315,1.2120257,30.2363862),(14428,'tibia-1.tif',40,8,105,36.5015097,15.3662355,19.6988725,1.8,15.3933758,19.6836462,-1.2005543,4.6965694,4.903643,217.9598323,285.3234216,5.2870674,58.1860099,46.4083061,94.1281157,8.3187705,9.8311957,1.1964627,30.3321037),(14429,'tibia-1.tif',40,8,106,36.4245122,15.3743521,19.7948796,1.8,15.39354,19.7790308,-1.2084464,4.7371375,4.9474538,220.3972659,288.9084692,5.3079573,58.3953852,46.5254108,94.0868831,8.3661466,9.8779321,1.2071854,30.6110449),(14430,'tibia-1.tif',40,8,107,36.3460198,15.3977193,19.8858318,1.8,15.4153496,19.8756144,-1.2151369,4.7693185,4.9847043,223.392989,292.0325653,5.3231821,58.5857355,46.8396039,94.3206782,8.3863623,9.9553387,1.1659045,30.7067624),(14431,'tibia-1.tif',40,8,108,36.2127278,15.4271281,19.9553631,1.8,15.4443026,19.940929,-1.2239927,4.8092629,4.9831947,227.1458625,294.9272663,5.3381933,59.184375,47.2309097,94.4543345,8.4165074,9.9988251,1.1766337,30.9857037),(14432,'tibia-1.tif',40,8,109,36.3633852,15.4436556,20.034301,1.8,15.463271,20.0235866,-1.247966,4.8654009,4.9790055,232.4034883,299.1822767,5.4505758,60.0887625,47.7665647,95.3530037,8.4814267,10.0434525,1.1872688,31.2646449),(14433,'tibia-1.tif',40,8,110,36.3332572,15.4678168,20.1182552,1.8,15.4930708,20.1105988,-1.2691936,4.9096104,5.0109816,237.1901417,302.1700119,5.5212063,60.301561,48.311398,96.1171029,8.5324069,10.1073831,1.2158099,31.4957274),(14434,'tibia-1.tif',40,8,111,36.2713612,15.4872114,20.1970289,1.8,15.5226321,20.1985055,-1.3033695,4.9363399,5.1097842,241.4976122,306.8055548,5.6230983,60.0427614,48.9224035,96.9315138,8.5899117,10.205962,1.2363882,31.8902099),(14435,'tibia-1.tif',40,8,112,36.4283599,15.5154512,20.2805804,1.8,15.5588424,20.2805794,-1.3539887,4.9934456,5.2377179,246.7525325,313.6958079,5.7904479,59.8916956,49.4152837,98.351863,8.6733784,10.2838202,1.26412,31.9661037),(14436,'tibia-1.tif',40,8,113,36.5199194,15.5353681,20.3578511,1.8,15.587428,20.3699873,-1.4145562,5.0049001,5.3737763,252.0382837,320.4592861,5.9392772,59.6339093,50.3583048,98.9131012,8.7569849,10.3375524,1.224051,32.3804099),(14437,'tibia-1.tif',40,8,114,36.733858,15.5542253,20.4372882,1.8,15.6159741,20.4462038,-1.4747813,4.9948375,5.5237734,256.8027822,327.9044794,6.0660421,59.3624057,51.4136408,100.2340408,8.857677,10.4275577,2.087027,32.5916687),(14438,'tibia-1.tif',40,8,115,36.763535,15.5710552,20.5114986,1.8,15.6407909,20.5267153,-1.54023,4.9953303,5.6780447,261.1122534,334.9892596,6.1215329,58.9972921,52.2712692,100.882334,8.9482581,10.608738,2.1310283,33.1215162),(14439,'tibia-1.tif',40,8,116,36.691777,15.6032525,20.580112,1.8,15.675786,20.617622,1.541834,4.9472805,5.8562777,265.0644036,346.0253164,6.110168,59.0862205,53.5777996,100.8820095,9.0607722,10.8365742,2.1901694,33.5638574),(14440,'tibia-1.tif',40,8,117,36.8362979,15.63749,20.6527871,1.8,15.6946358,20.6800696,1.4861481,4.917102,6.0485044,268.4715679,363.2721205,6.0954973,60.059826,54.5995521,101.3608578,9.1771993,11.1259084,2.1628722,33.85101),(14441,'tibia-1.tif',40,8,118,37.2483127,15.680133,20.7368216,1.8,15.7272952,20.7509503,1.4389433,4.9743176,6.2775249,273.1225274,385.5296099,6.1007478,61.41427,54.906532,102.9514979,9.3160424,11.407614,2.2343521,34.6119399),(14442,'tibia-1.tif',40,8,119,37.2001308,15.7151107,20.7981127,1.8,15.7630623,20.8292225,1.4026604,5.0795108,6.5208704,276.41216,403.9993829,6.0263944,61.9548248,54.4170827,102.8861648,9.4362483,11.6833857,2.2073045,35.0542812),(14443,'tibia-1.tif',40,8,120,37.2132252,15.7549643,20.8356024,1.8,15.7930904,20.88045,1.3782041,5.1899635,6.6618102,281.3059452,420.9894529,5.9749839,63.1944531,54.2019121,103.5137693,9.5462224,11.9812431,2.2402125,35.7475287),(14444,'tibia-1.tif',40,8,121,37.1621707,15.805262,20.8483456,1.8,15.8528651,20.8780462,1.3662561,5.2429994,6.7789177,287.0694823,434.3475563,5.9381648,64.0732891,54.7529111,105.1588109,9.6529744,12.1469521,2.2465877,36.1420112),(14445,'tibia-1.tif',40,8,122,37.2262494,15.823902,20.8561912,1.8,15.8437468,20.8846534,1.3510679,5.3238758,6.8965835,293.540544,444.870623,5.9096139,64.5059433,55.1366253,105.9660839,9.7371565,12.2391946,2.223643,36.4209524),(14446,'tibia-1.tif',40,8,123,37.1986811,15.8714518,20.8807823,1.8,15.9052935,20.9255733,1.3419859,5.3906805,7.6499925,299.001761,459.0473223,5.8808206,60.006245,55.4664221,96.6796251,9.8389103,12.3256034,2.2434669,37.0383062),(14447,'tibia-1.tif',40,8,124,37.0416403,15.9133191,20.8713021,1.8,15.9706982,20.930558,1.3460091,5.3967868,7.5382659,305.3219195,468.8163352,5.8668777,62.1915362,56.5747599,99.2471465,9.9539265,12.5043712,2.2404353,37.5086824),(14448,'tibia-1.tif',40,8,125,37.0370103,15.9635484,20.8810228,1.8,16.0138598,20.9416131,1.3366618,5.4348079,7.516405,311.3282854,479.6298015,5.8405849,63.8110639,57.2841382,102.3804814,10.0567238,12.7098,2.2605964,37.9510237),(14449,'tibia-1.tif',40,8,126,36.9484501,16.0285495,20.9018658,1.8,16.0684678,20.9451863,1.3283572,5.4824438,7.3186147,316.3248048,491.7046076,5.8031596,67.1854751,57.6977738,109.4858157,10.0800482,12.8487375,2.2435512,38.4330124),(14450,'tibia-1.tif',40,8,127,37.014015,16.0625431,20.8985765,1.8,16.1010157,20.9522684,1.3176142,5.5615991,7.4431096,323.5145674,506.0174278,5.7819395,67.9846809,58.169343,110.501939,10.1995001,13.0413266,2.2318395,38.8951774),(14451,'tibia-1.tif',40,8,128,37.1751317,16.1254793,20.9306034,1.8,16.1772467,20.9834824,1.2985329,5.6464377,7.5132832,330.8913978,522.5894668,5.7478097,69.555406,58.6017971,112.5909468,10.2841658,13.2328782,2.2600011,39.6362837),(14452,'tibia-1.tif',40,8,129,37.1753166,16.1743979,20.932204,1.8,16.227781,20.9838401,1.283532,5.7140877,7.6342827,338.8431792,536.8978482,5.698507,70.327216,59.2996113,113.7274436,10.3781442,13.4358625,2.2398393,39.8673662),(14453,'tibia-1.tif',40,8,130,37.1067871,16.2501889,20.8862502,1.8,16.3169879,20.9758067,1.2806204,5.7392281,7.7758471,347.4821732,550.8120269,5.6781727,70.8362724,60.5451062,114.3905932,10.4728771,13.6527032,2.2502101,40.6563312),(14454,'tibia-1.tif',40,8,131,37.4450678,16.3126112,20.8760246,1.8,16.3829239,20.9727018,1.2587475,5.8481631,7.9440596,360.1017796,573.1884973,5.6526161,72.1530966,61.575194,116.8706975,10.574045,13.8709663,2.2602556,41.0111662),(14455,'tibia-1.tif',40,8,132,37.7133381,16.3522527,20.8789751,1.8,16.4052402,21.0022829,1.248777,5.971695,8.039794,372.1672978,600.2349024,5.6559866,74.6579952,62.3218869,120.4260221,10.7470826,14.1010035,2.2618254,41.7919199),(14456,'tibia-1.tif',40,8,133,38.2243342,16.4234857,20.8502631,1.8,16.4763586,20.9847303,1.2421615,6.046265,8.1806074,389.6917996,631.7255046,5.7070946,77.2223226,64.4516569,123.9237887,10.8576786,14.410963,2.2960262,42.4058724),(14457,'tibia-1.tif',40,8,134,38.3628841,16.4816105,20.849295,1.8,16.52633,20.9888892,1.2291072,6.1655685,8.3284397,406.1842937,657.9754423,5.6759297,79.0034466,65.8794552,127.2034128,10.9800119,14.6960111,2.3011321,43.1271549),(14458,'tibia-1.tif',40,8,135,38.7693882,16.5467492,20.8120568,1.8,16.5638127,20.9756906,1.2119951,6.2822024,8.4579155,424.5390627,691.1855263,5.6648035,81.7205519,67.5780622,131.5607278,11.1527074,14.9063884,2.2669381,43.8204024),(14459,'tibia-1.tif',40,8,136,39.3859896,16.617568,20.8104651,1.8,16.6194247,21.0191938,1.1956799,6.4220693,8.6082742,445.7118433,728.0908435,5.6831691,84.58035,69.4031507,135.9888226,11.3430344,15.1891705,2.2724215,44.7447324),(14460,'tibia-1.tif',40,8,137,39.9705824,16.6565562,20.7822358,1.8,16.660295,21.0100668,1.1696935,6.628126,8.8030135,467.3808264,773.8269747,5.6462537,87.9047811,70.5147769,140.7359477,11.5838473,15.4723926,2.2777044,45.7846036),(14461,'tibia-1.tif',40,8,138,40.4243085,16.7485754,20.7897611,1.8,16.7384629,21.0323986,1.1625028,6.7746429,8.9456155,488.6543811,823.0346088,5.6752785,92.0042457,72.1299102,146.4808138,11.7648001,15.8179725,2.2794226,46.6494624),(14462,'tibia-1.tif',40,8,139,41.8112024,16.8329564,20.7781495,1.8,16.7687305,20.9877105,1.158822,6.8974612,9.0968971,518.4895176,896.1410191,5.8512298,98.5106252,75.1710671,155.2566652,11.9282001,16.1825821,2.2668274,47.7371924),(14463,'tibia-1.tif',40,8,140,42.6323106,16.9250219,20.8092265,1.8,16.8370865,20.9867843,1.162599,7.0173252,9.277219,549.6859838,969.0618342,5.9857638,104.4560702,78.3326934,163.3635308,12.2084845,16.5550895,2.2933403,48.7572399),(14464,'tibia-1.tif',40,8,141,43.8812811,17.0109205,20.8198155,1.8,16.8773132,20.9902458,1.1520547,7.2057392,9.3048907,588.1264827,1053.6185145,6.1043789,113.2327663,81.6191746,175.8439859,12.4920794,16.8884,2.308286,50.0083699),(14465,'tibia-1.tif',40,8,142,45.7407722,17.0935903,20.778404,1.8,16.8943275,20.8698121,1.1462744,7.4102454,9.3525662,642.5723377,1152.4623764,6.330146,123.2241878,86.7140434,191.5346915,12.8371803,17.1626404,2.3326298,51.2198524),(14466,'tibia-1.tif',40,8,143,47.4911478,17.204646,20.7332158,1.8,16.9599612,20.7516636,1.1629822,7.4706883,9.4506692,707.8771847,1246.4143494,6.6701757,131.8863595,94.7539451,206.550501,13.2370629,17.4105366,2.3064018,52.4908061),(14467,'tibia-1.tif',40,8,144,48.6176618,17.2784891,20.5698748,1.8,17.036451,20.6055034,1.1729903,7.6371881,9.6751028,768.7926417,1294.0895044,6.886885,133.7546005,100.6643592,213.0235063,13.4709042,17.6838514,2.3300567,54.1165949),(14468,'tibia-1.tif',40,8,145,49.9239949,17.2830065,20.2192026,1.8,17.1109395,20.36405,1.199135,7.7306174,9.9990339,863.8187853,1301.3400399,7.2232698,130.1465777,111.7399482,215.8638568,13.8073001,17.9327314,2.3046273,55.2720074),(14469,'tibia-1.tif',40,8,146,50.6399661,17.2560293,19.7270677,1.8,17.1464826,20.0280607,1.3382433,7.5817486,10.3888714,966.5643361,1254.2832715,7.991721,120.7333521,127.4856755,210.2888247,14.2439381,18.2851099,1.4857998,70.333426),(14470,'tibia-1.tif',40,8,147,57.5011296,17.6635929,19.9716213,1.8,17.4759073,19.9982905,1.3639754,8.1782083,10.4202157,1127.6471146,1746.5567179,9.1793991,167.6123386,137.8843724,260.716642,14.7553566,20.0391632,1.4686936,65.9032111),(14471,'tibia-1.tif',40,8,148,65.4345634,17.9881976,19.9735059,1.8,17.7397843,19.7942816,1.437077,8.9345794,11.0526549,1365.0803751,2207.9431016,10.7119156,199.7658588,152.7861925,283.3989249,15.4322248,21.9335212,1.4663093,66.4775161),(14472,'tibia-1.tif',40,8,149,72.6848069,17.9702184,19.5704004,1.8,17.9130412,19.35044,1.5500626,9.5098047,11.8100503,1616.4193708,2395.5572036,12.1089274,202.8405591,169.973982,316.0192091,16.4284245,22.5054957,1.51268,68.9831773),(14473,'tibia-1.tif',40,8,150,84.7370473,18.2847088,18.859234,1.8,18.1748135,18.5765539,-1.2985219,10.5258511,12.7089613,1973.6291695,3061.8444023,13.1014849,240.9201133,187.5030483,382.8234269,17.5770398,22.9124443,1.3734008,72.7728136),(14474,'tibia-1.tif',40,8,151,98.3246727,18.1102915,18.1827446,1.8,18.0406153,17.9858048,-1.2481465,10.4525149,12.6103073,2362.8337861,3480.8207787,14.7398483,276.029813,226.0540944,451.9237747,18.4082374,23.1908585,1.4932138,76.5740623),(14475,'tibia-1.tif',40,8,152,114.3482906,17.7631366,17.6326059,1.8,18.005033,17.6652888,-1.0519013,10.4645631,12.4751375,2940.2653936,3674.7482484,14.3709587,294.5657522,280.9735454,529.9004477,18.7624355,23.006929,1.4640607,74.255026),(14476,'tibia-1.tif',40,8,153,126.4808455,17.8013138,17.4986603,1.8,18.1142085,17.7258631,-0.7137008,11.3887527,11.8869216,3058.3575523,3951.6812905,9.0338532,332.4394161,268.5419222,581.8586976,18.7797615,22.3853529,1.3612324,73.3901673),(14477,'tibia-1.tif',40,8,154,124.2486785,18.0685446,17.6242226,1.8,18.2891876,18.0076909,-0.6008246,10.2747318,11.1783,2585.1020856,3809.2165822,6.6181046,340.7688633,251.5980121,547.5306775,17.663312,21.6381646,1.3267334,76.458521),(14478,'tibia-1.tif',40,8,155,117.8352948,18.1791188,18.1187236,1.8,18.3931024,18.4905387,-0.553366,9.5005388,10.6962605,2211.5996127,3559.9426384,5.4244854,332.8212349,232.7867565,517.5432596,15.9310928,20.1204395,0.5418123,71.8252586),(14479,'tibia-1.tif',40,8,156,112.6195265,18.2281321,18.6419303,1.8,18.3882533,18.8795249,-0.5387083,8.4460077,10.573589,1602.9370271,3210.7642254,4.9401933,303.6588841,189.7863569,440.6519495,15.4722333,19.703425,0.4321182,72.2115298),(14480,'tibia-1.tif',40,8,157,82.169613,18.6506272,18.3733762,1.8,18.5782007,18.7048718,-0.5380937,7.6101852,9.040588,750.2257172,1578.1218471,3.5970603,174.5596461,98.5817945,239.8302543,11.51868,15.7089365,0.9553836,55.8661361),(14481,'tibia-1.tif',40,8,158,26.3238346,17.8152357,17.4171668,1.8,17.8950463,17.7517548,-1.5535996,4.5864421,8.0679046,114.8894071,275.4673229,4.3860085,34.1436018,25.0497891,48.0581676,5.7073903,8.2581688,0.4503741,34.7985649),(14482,'tibia-1.tif',40,8,159,5.3567612,17.0808343,15.7403617,1.8,17.1087971,15.8352575,-0.480988,2.7870482,3.2836463,2.7278414,29.5842366,0.1911024,9.0095685,0.9787564,9.5214163,1.2255,3.2123792,1.4432868,7.5792725),(14483,'tibia-1.tif',40,8,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14484,'tibia-1.tif',40,8,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14485,'tibia-1.tif',40,8,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14486,'tibia-1.tif',40,8,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14487,'tibia-1.tif',40,8,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14488,'tibia-1.tif',40,8,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14489,'tibia-1.tif',40,8,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14490,'tibia-1.tif',40,8,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14491,'tibia-1.tif',40,8,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14492,'metacarpus.tif',40,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14493,'metacarpus.tif',40,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14494,'metacarpus.tif',40,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14495,'metacarpus.tif',40,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14496,'metacarpus.tif',40,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14497,'metacarpus.tif',40,5,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14498,'metacarpus.tif',40,5,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14499,'metacarpus.tif',40,5,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14500,'metacarpus.tif',40,5,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14501,'metacarpus.tif',40,5,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14502,'metacarpus.tif',40,5,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14503,'metacarpus.tif',40,5,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14504,'metacarpus.tif',40,5,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14505,'metacarpus.tif',40,5,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14506,'metacarpus.tif',40,5,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14507,'metacarpus.tif',40,5,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14508,'metacarpus.tif',40,5,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14509,'metacarpus.tif',40,5,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14510,'metacarpus.tif',40,5,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14511,'metacarpus.tif',40,5,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14512,'metacarpus.tif',40,5,21,0.0113597,5.8919508,10.8674268,1.8,5.8906057,10.9195536,1.5587579,0.0610507,2.2926318,0.0000289,0.0104941,0.001893,0.0045773,0.0004726,0.0045899,0,0,0,0),(14513,'metacarpus.tif',40,5,22,0.1853276,6.1301645,11.2096574,1.8,6.1263319,11.1563729,1.5675794,0.2060315,2.1855022,0.0012914,0.3765056,0.0308876,0.1722742,0.0062681,0.1727471,0,0,0,0),(14514,'metacarpus.tif',40,5,23,0.7036769,6.3291358,11.3743184,1.8,6.2994695,11.1682354,1.5659587,0.4153755,2.7260722,0.0149132,1.3353201,0.1172767,0.489833,0.0359029,0.4944256,0.6579932,5.1733635,1.6071439,11.6959612),(14515,'metacarpus.tif',40,5,24,1.4928631,6.481822,11.6123897,1.8,6.4362477,11.1133707,1.5537939,0.5813176,3.5230991,0.0629408,3.0549272,0.2487386,0.8671136,0.1082726,0.8807402,0.9399903,6.0188745,1.5395565,14.561548),(14516,'metacarpus.tif',40,5,25,2.5981274,6.6415252,11.5971282,1.8,6.5762153,11.0711342,-1.5572717,0.7047422,3.8943756,0.188375,7.3420722,0.432942,1.8853015,0.2672963,1.925654,1.1718927,6.6798859,1.5285679,15.7162575),(14517,'metacarpus.tif',40,5,26,4.1021964,6.8141055,11.4845255,1.8,6.7074084,11.1216694,-1.5391039,0.9190532,3.9790207,0.4679662,14.3148343,0.6830129,3.5975773,0.5091829,3.6972931,1.4857098,7.1463993,1.5444866,16.8214378),(14518,'metacarpus.tif',40,5,27,5.8877502,6.973625,11.4245276,1.8,6.8562179,11.2521704,-1.5401449,1.278104,4.2042589,0.9490462,22.4904554,0.9803701,5.3494458,0.7425422,5.5343416,1.9533973,7.5345952,1.5083775,21.5481104),(14519,'metacarpus.tif',40,5,28,8.0506999,7.1242133,11.314599,1.8,7.0028902,11.2499168,-1.5384372,1.6181032,4.3783154,1.7972973,32.8235489,1.3403788,7.4968443,1.1107433,7.8486761,2.3499757,8.3849029,1.5034825,23.1205188),(14520,'metacarpus.tif',40,5,29,10.3643543,7.2568671,11.2030711,1.8,7.1401804,11.1593076,-1.534673,1.7511668,4.7439302,3.1039231,45.5053781,1.7251393,9.5923372,1.7724885,10.1500032,2.6319728,8.9477002,1.5077222,23.4642595),(14521,'metacarpus.tif',40,5,30,12.7569883,7.3845969,11.0958227,1.8,7.2695189,11.1006395,-1.5254956,1.9819302,4.9313075,5.0673212,61.4317505,2.1218045,12.4574975,2.5567607,13.3282232,3.0079689,9.3134964,1.5304143,25.6006621),(14522,'metacarpus.tif',40,5,31,15.0353995,7.5079931,10.9897383,1.8,7.3941729,11.025798,-1.5150471,2.1100155,4.9357369,7.6036778,78.9848182,2.4981197,16.0026393,3.6036122,17.2790805,3.2899659,9.5897437,1.5904017,27.0723912),(14523,'metacarpus.tif',40,5,32,16.9841765,7.6308272,10.9104842,1.8,7.5467054,10.99704,-1.4993031,2.247649,5.1623572,10.2837113,96.2175156,2.8162522,18.6382908,4.575319,20.3016543,3.571963,9.9709886,1.5330784,29.9513386),(14524,'metacarpus.tif',40,5,33,18.6023232,7.7391783,10.83957,1.8,7.687247,10.9565069,-1.4815069,2.3562077,5.3102392,13.1861905,113.143377,3.0757347,21.3066443,5.5963618,23.3763105,3.8539601,10.4377021,1.5437759,33.8253396),(14525,'metacarpus.tif',40,5,34,20.3741299,7.8589373,10.8031707,1.8,7.8339943,10.9532154,-1.4698769,2.4141921,5.3951988,17.4502425,132.4262688,3.3612214,24.5452065,7.2281914,27.2225912,4.0419582,10.5429872,1.5172761,34.022785),(14526,'metacarpus.tif',40,5,35,22.3616743,7.9833787,10.7907997,1.8,7.974954,10.912037,-1.4720422,2.4978201,5.4895752,23.2532276,155.1716466,3.6907171,28.2666035,9.3094086,31.6820067,4.3213297,10.6422508,1.5089285,32.2946339),(14527,'metacarpus.tif',40,5,36,24.6343643,8.1226677,10.8162348,1.8,8.113959,10.8943637,-1.4820569,2.5401635,5.5146899,31.0594232,180.0813748,4.0734808,32.6548509,12.2273323,37.0247406,4.4937352,10.6634014,1.4825307,33.6467889),(14528,'metacarpus.tif',40,5,37,26.796053,8.2596537,10.8808013,1.8,8.2600406,10.8828491,-1.4971745,2.6070568,5.5395079,39.325175,200.17266,4.441846,36.1354587,15.0841265,42.071671,4.7355275,10.6555267,1.4913181,30.2817187),(14529,'metacarpus.tif',40,5,38,28.8654891,8.3847372,10.9571309,1.8,8.3965586,10.9091172,-1.5100656,2.7055749,5.5908828,48.7034225,217.7575935,4.7931929,38.9486956,18.001136,46.5255213,5.0759475,10.6422508,1.5089285,32.1561651),(14530,'metacarpus.tif',40,5,39,30.6286475,8.4922212,11.0333257,1.8,8.5159951,10.9329684,-1.5248123,2.9393116,5.6258482,58.9453323,231.8359988,5.093988,41.2090749,20.0541286,50.9572805,5.4519436,10.6256327,1.5442539,33.2841534),(14531,'metacarpus.tif',40,5,40,32.4656931,8.5962382,11.0993004,1.8,8.6351405,10.961047,-1.5399495,3.0792471,5.675255,70.4966302,242.6752316,5.4058018,42.7602337,22.8941127,54.6189095,5.7339406,10.6368528,1.5177488,33.0733474),(14532,'metacarpus.tif',40,5,41,34.0184596,8.6908427,11.1523993,1.8,8.7467015,10.9849596,-1.5530502,3.2044342,5.7188128,81.8216287,248.9164724,5.6679579,43.5258999,25.5338767,56.9962485,6.0159377,10.6322831,1.5265774,29.9513386),(14533,'metacarpus.tif',40,5,42,35.0229749,8.7559933,11.1897204,1.8,8.8410907,11.0143319,-1.5614083,3.3785211,5.6539863,91.0099186,253.1045198,5.836648,44.765676,26.9377981,59.8183942,6.3919338,10.4761483,1.4809488,29.8184039),(14534,'metacarpus.tif',40,5,43,34.903821,8.7552989,11.1918755,1.8,8.8552779,11.0419487,-1.5650429,3.3865163,5.6522522,94.3669711,252.9939071,5.8171109,44.7598404,27.8655,60.3591372,6.6347348,10.4761483,1.4809488,31.4859574),(14535,'metacarpus.tif',40,5,44,34.1370747,8.7315856,11.1679348,1.8,8.8409242,11.0413228,-1.5620456,3.358549,5.6292702,95.3080716,248.5082209,5.6890768,44.1457262,28.3777527,60.4583044,6.6314454,10.4609557,1.642744,31.8163376),(14536,'metacarpus.tif',40,5,45,33.4332899,8.7109807,11.1346484,1.8,8.833824,11.0514649,-1.5528976,3.3347584,5.6051879,96.1973452,244.3403938,5.57043,43.5918293,28.8468711,60.0339731,6.6739309,10.4681327,1.4898922,31.7290188),(14537,'metacarpus.tif',40,5,46,32.9922931,8.6870475,11.1015505,1.8,8.8272355,11.0362698,-1.543233,3.3676655,5.5731438,97.3596943,241.8028001,5.494539,43.3871451,28.9101435,60.5522376,6.7055443,10.4609557,1.642744,31.4954048),(14538,'metacarpus.tif',40,5,47,32.8007803,8.6614124,11.0697142,1.8,8.8139182,11.0018294,-1.5323157,3.3182864,5.5444768,98.2678375,242.0309638,5.4587057,43.6526247,29.6140312,61.1911417,6.6976079,10.4681327,1.6517004,31.8942089),(14539,'metacarpus.tif',40,5,48,32.7222759,8.6297497,11.0591852,1.8,8.7709476,10.9969638,-1.5251705,3.357623,5.4573051,98.4184987,243.4966624,5.4423675,44.6184804,29.3119564,62.1291733,6.7679299,10.3914638,1.670465,34.0667801),(14540,'metacarpus.tif',40,5,49,32.8530843,8.5992717,11.0523749,1.8,8.7519104,10.9880494,-1.5168605,3.3865544,5.4578593,99.719838,245.4894458,5.4596008,44.9790721,29.4458103,62.7426984,6.7725219,10.3672021,1.6433958,41.0305345),(14541,'metacarpus.tif',40,5,50,32.9657394,8.5726229,11.0331836,1.8,8.7271481,10.9768219,-1.5097172,3.4695609,5.4279452,101.719395,247.3153309,5.4738181,45.5633433,29.3176568,64.127044,6.7905842,10.346727,1.6071439,36.8544955),(14542,'metacarpus.tif',40,5,51,33.1243622,8.5632682,11.0113875,1.8,8.7054428,10.9650809,-1.5143419,3.3929254,5.4047913,103.3511284,247.9801581,5.5031506,45.881542,30.4607724,64.2402743,6.813967,10.3505692,1.6162196,36.5107548),(14543,'metacarpus.tif',40,5,52,33.2538291,8.5773602,10.973294,1.8,8.7065826,10.9417338,-1.5179325,3.4499847,5.2804635,105.2676653,248.6611638,5.5268309,47.0907837,30.5125024,65.0328048,6.9029177,10.2734529,1.6440595,36.0246319),(14544,'metacarpus.tif',40,5,53,33.2336049,8.5772527,10.9402353,1.8,8.696743,10.908042,-1.5202539,3.5543021,5.2459561,106.4876527,247.6949925,5.5247968,47.2163675,29.9602143,64.5187762,6.8893599,10.225176,1.6905903,33.7458473),(14545,'metacarpus.tif',40,5,54,33.37811,8.5635685,10.9089746,1.8,8.6970258,10.8685164,-1.519742,3.5772637,5.2061739,107.9419915,248.1693271,5.5485307,47.6682744,30.1744576,64.8800194,6.9789685,10.236835,1.6997071,33.5901046),(14546,'metacarpus.tif',40,5,55,33.6811685,8.5463534,10.8717781,1.8,8.6806631,10.8385105,-1.512846,3.5833949,5.1786487,109.5570031,248.533754,5.5946976,47.9920091,30.573522,64.5884457,7.1470705,10.236835,1.6997071,34.1218434),(14547,'metacarpus.tif',40,5,56,33.8515713,8.5326067,10.8333226,1.8,8.6542219,10.8054509,-1.5038171,3.6071779,5.2397834,110.9753814,248.9562311,5.6166555,47.5126954,30.7651533,64.4952992,7.2481548,10.2889224,1.4793093,34.1863542),(14548,'metacarpus.tif',40,5,57,34.0352246,8.5195944,10.7944512,1.8,8.6316888,10.7684773,-1.4913854,3.59984,5.2080983,111.4998451,251.1161888,5.636841,48.2164838,30.973556,65.0576942,7.1962515,10.256668,1.6166358,33.4666173),(14549,'metacarpus.tif',40,5,58,34.3930555,8.5239403,10.7560657,1.8,8.6421369,10.7486853,-1.467166,3.624383,5.1890146,111.978474,256.3412656,5.6708368,49.4007602,30.8958722,65.5939464,7.1618207,10.2734529,1.6440595,36.5107548),(14550,'metacarpus.tif',40,5,59,34.5724863,8.5270528,10.7230608,1.8,8.6320583,10.7356088,-1.4389237,3.6388667,5.488442,113.063855,262.4249584,5.6624557,47.8141081,31.0711724,66.4331629,7.2092365,10.3146533,1.2461639,36.4006281),(14551,'metacarpus.tif',40,5,60,34.7622409,8.5376546,10.6694095,1.8,8.6401746,10.6755835,-1.4134313,3.7056888,5.4796309,113.6043337,268.9085188,5.6514133,49.0742032,30.6567391,67.2522589,7.1872421,10.339893,0.9272952,33.7969974),(14552,'metacarpus.tif',40,5,61,34.8652925,8.5381453,10.6279036,1.8,8.642705,10.610419,-1.4010635,3.7546796,5.4694435,113.2429927,273.3001931,5.6450766,49.9685561,30.1604942,68.3636701,7.2083828,10.5831383,1.3559809,35.2915345),(14553,'metacarpus.tif',40,5,62,34.9441004,8.526712,10.6139494,1.8,8.6388348,10.5978578,-1.3970138,3.7822997,5.5228599,112.6354657,276.9755862,5.6498928,50.1507535,29.7796249,68.0521216,7.1846588,10.6368528,1.3751339,37.1070043),(14554,'metacarpus.tif',40,5,63,34.7792551,8.5035569,10.6050152,1.8,8.624503,10.5974878,-1.3927349,3.7288766,5.5393121,111.1342166,279.032414,5.6146923,50.3731165,29.8036727,67.5527854,7.0846664,10.6555267,1.3664805,36.6853922),(14555,'metacarpus.tif',40,5,64,34.7563842,8.4712062,10.6235579,1.8,8.6051033,10.6163323,-1.3927654,3.757327,5.5466091,109.6788375,280.6189091,5.6110615,50.5928767,29.1906554,67.1853073,7.09921,10.6368528,1.3751339,35.3048951),(14556,'metacarpus.tif',40,5,65,35.2616833,8.4372987,10.6689678,1.8,8.57553,10.6346284,-1.3918135,3.7858708,5.5983667,108.9041005,284.6828249,5.6906819,50.8510496,28.7659313,66.2190766,7.0364443,10.6368528,1.3751339,36.5335628),(14557,'metacarpus.tif',40,5,66,35.9737651,8.4136462,10.7141569,1.8,8.5428303,10.6348604,-1.3924911,3.706337,5.6796235,108.531841,287.4969507,5.8070216,50.6190153,29.2827773,66.3358249,7.0832386,10.6368528,1.3751339,35.6580832),(14558,'metacarpus.tif',40,5,67,36.4108642,8.4117083,10.7416572,1.8,8.5255075,10.6403985,-1.3953553,3.6059295,5.6540276,107.1357962,287.2937464,5.8836009,50.8122289,29.7110072,65.2398553,7.0519853,10.5881465,1.2827409,41.2602353),(14559,'metacarpus.tif',40,5,68,36.5674184,8.4215739,10.7562514,1.8,8.519704,10.6327728,-1.3985723,3.5983738,5.7116304,104.8406783,287.0444717,5.9155782,50.2561357,29.1355722,64.4178252,6.9772196,10.678306,1.2852417,42.0995463),(14560,'metacarpus.tif',40,5,69,36.3962882,8.4150573,10.7820861,1.8,8.4988782,10.6215533,-1.4013962,3.6318618,5.7660954,102.9006471,284.0647627,5.893633,49.2646658,28.3327539,63.3436537,6.8967613,10.6368528,1.3751339,42.676901),(14561,'metacarpus.tif',40,5,70,36.0098212,8.4193346,10.8137549,1.8,8.4947815,10.639689,-1.4168918,3.5739038,5.7721991,100.3352924,279.3846326,5.8605973,48.4017661,28.0744244,61.5641606,6.8877599,10.6696142,1.3215442,42.8877071),(14562,'metacarpus.tif',40,5,71,35.4167438,8.4309983,10.8081542,1.8,8.4921337,10.610087,-1.4346414,3.8863564,5.8157961,96.2105583,275.7066848,5.7940382,47.4065257,24.7559791,60.5521365,6.8738073,10.7113531,1.3854484,44.120288),(14563,'metacarpus.tif',40,5,72,34.853772,8.4276056,10.7748374,1.8,8.448947,10.595988,-1.4546155,4.0890139,5.7498941,94.2470893,272.8190015,5.7309049,47.4476568,23.0488553,60.385431,7.0152685,10.6368528,1.3751339,45.6887831),(14564,'metacarpus.tif',40,5,73,34.2847254,8.400498,10.7054547,1.8,8.3815367,10.5931852,-1.48202,4.1801504,5.5650692,94.5017484,269.7955904,5.6692048,48.4801861,22.6072602,60.3482211,7.5652029,10.6248011,1.3386925,39.8246749),(14565,'metacarpus.tif',40,5,74,33.6865478,8.3606435,10.6107061,1.8,8.3202919,10.5950587,-1.5071548,4.3611925,5.4857266,94.9634654,267.5548568,5.5917155,48.7729113,21.7746557,61.2320231,7.7374438,10.6019068,1.3925289,37.1242781),(14566,'metacarpus.tif',40,5,75,32.9549889,8.3093305,10.51461,1.8,8.2361355,10.6092526,-1.5254343,4.3221825,5.2732774,96.0114458,262.8271352,5.4812039,49.8413251,22.2136494,61.1328182,7.7087512,10.5635001,1.364675,36.4367967),(14567,'metacarpus.tif',40,5,76,32.6143793,8.2223804,10.4227777,1.8,8.144838,10.6084287,-1.5265082,4.2322827,5.1827485,99.635431,256.5999552,5.425075,49.5104005,23.5417711,61.0422561,7.6720871,10.5064677,0.9827937,41.0305345),(14568,'metacarpus.tif',40,5,77,33.141635,8.1101027,10.4190025,1.8,8.0950327,10.5868959,-1.5052958,4.1845153,5.3022558,104.9326343,255.8590129,5.4999416,48.254747,25.0764132,61.4053739,7.7401183,10.4355855,0.9453113,41.7085686),(14569,'metacarpus.tif',40,5,78,33.7921447,7.9852545,10.4668296,1.8,8.054122,10.5671188,-1.4619057,4.0184668,5.468822,108.9150034,257.248656,5.5655078,47.0391346,27.1036215,61.1345907,7.7327433,10.4715085,1.3628378,40.0810969),(14570,'metacarpus.tif',40,5,79,34.2506804,7.8432646,10.5321758,1.8,7.9669061,10.5444611,-1.4178613,3.8471039,5.5800927,111.114929,258.4827438,5.5759688,46.3223027,28.8827471,60.7763789,7.6387726,10.4050597,1.1718357,37.6332089),(14571,'metacarpus.tif',40,5,80,34.4561758,7.73157,10.5658301,1.8,7.8704085,10.5416792,-1.3791584,4.0641932,5.7167697,110.5348886,259.627247,5.5343642,45.4150265,27.1972526,60.0336696,7.558078,10.3965643,0.9200621,45.1932129),(14572,'metacarpus.tif',40,5,81,34.595439,7.6544047,10.5622802,1.8,7.7943048,10.5130997,-1.3510108,4.1055585,5.7671008,109.5403265,259.1480529,5.4918365,44.9355858,26.6809807,59.5684364,7.473391,10.4037858,0.9652517,41.9382694),(14573,'metacarpus.tif',40,5,82,34.6182353,7.5881017,10.5383043,1.8,7.7400875,10.4870165,-1.3211768,4.4357664,5.8156972,107.975295,256.6339319,5.4176012,44.1278019,24.3419706,58.8952663,7.4467825,10.4575766,0.9578612,41.8281427),(14574,'metacarpus.tif',40,5,83,34.3754295,7.5283679,10.5022942,1.8,7.6860732,10.4513197,-1.2906412,4.587635,5.8511405,105.5703576,254.2153312,5.2912101,43.4471419,23.0119349,58.1686049,7.3901755,10.445741,0.8299546,41.7730794),(14575,'metacarpus.tif',40,5,84,33.806225,7.4700694,10.4660681,1.8,7.6252544,10.4280542,-1.2556972,4.6570412,5.8605656,101.4766494,248.6172061,5.0932197,42.4220497,21.7899403,56.5141621,7.3622088,10.5018412,0.7853982,42.1396281),(14576,'metacarpus.tif',40,5,85,33.2799031,7.414083,10.4181297,1.8,7.5845465,10.3972547,-1.2199283,4.8161138,5.8954197,95.6321716,243.6650955,4.8913767,41.331255,19.8567092,55.2046035,7.3198382,10.5119327,1.0150406,42.2914575),(14577,'metacarpus.tif',40,5,86,32.6537764,7.3598849,10.3711675,1.8,7.5303202,10.3559067,-1.192548,4.9146011,5.8634893,89.6610259,239.1704855,4.7000894,40.789788,18.2438053,53.6150664,7.1167816,10.445741,0.8299546,42.9105151),(14578,'metacarpus.tif',40,5,87,32.0269052,7.3258445,10.3285314,1.8,7.4967103,10.3385039,-1.1727666,4.9560635,5.8822272,86.0540643,236.2018237,4.5358853,40.1551682,17.3633901,53.2367654,6.8581031,10.4321982,1.0102868,36.8544955),(14579,'metacarpus.tif',40,5,88,31.5802872,7.3108799,10.3113252,1.8,7.4649221,10.3218481,-1.1630741,4.8752451,5.8249674,84.7533473,233.1321743,4.4358326,40.0229151,17.384428,52.3752098,6.7940526,10.4525058,0.8426603,38.4630725),(14580,'metacarpus.tif',40,5,89,31.117662,7.3044113,10.3160948,1.8,7.4541672,10.31877,-1.1648957,4.7767498,5.8280657,85.0090937,228.6626915,4.3777174,39.2347482,17.79643,52.2336942,6.64748,10.3825319,0.8366353,36.7994322),(14581,'metacarpus.tif',40,5,90,30.6359259,7.2938552,10.3351162,1.8,7.4460538,10.3269744,-1.1709902,4.7139008,5.7934719,85.4104787,222.6452182,4.3323916,38.4303612,18.1188536,51.5113711,6.7006568,10.3386111,0.8690733,36.7121134),(14582,'metacarpus.tif',40,5,91,30.1026828,7.281506,10.3592701,1.8,7.4465394,10.3543615,-1.1780698,4.6764229,5.797227,85.7525645,215.2024549,4.2822773,37.1216196,18.3372134,50.4277108,6.7512452,10.3056548,0.9017533,34.0117167),(14583,'metacarpus.tif',40,5,92,29.776232,7.2607574,10.3991166,1.8,7.4406169,10.3837867,-1.1884161,4.6395397,5.8269601,86.1564058,207.3943174,4.2717684,35.5921979,18.5700332,48.8237629,6.7546137,10.2850572,1.0335116,37.775591),(14584,'metacarpus.tif',40,5,93,29.6801702,7.2361914,10.4319321,1.8,7.4323819,10.3983592,-1.2008442,4.5651486,5.7992609,86.3336943,200.5487224,4.2999965,34.581773,18.9114753,47.9910437,6.8423694,10.2476185,0.9089487,37.5458902),(14585,'metacarpus.tif',40,5,94,29.5339561,7.1901511,10.4896033,1.8,7.4055863,10.4302287,-1.224564,4.5170517,5.793046,85.674552,191.0817837,4.3554581,32.9846826,18.9669187,46.7488773,6.8985577,10.0767658,1.3258177,36.469052),(14586,'metacarpus.tif',40,5,95,29.4515774,7.1498887,10.5634854,1.8,7.3736804,10.4736572,-1.2568879,4.4209867,5.7620222,83.821078,182.0448413,4.4405904,31.5939153,18.9598123,45.086186,6.8777699,10.0121099,1.3531457,37.6332089),(14587,'metacarpus.tif',40,5,96,29.8012583,7.1354999,10.6462779,1.8,7.3529178,10.5284584,-1.2953572,4.2411539,5.7264926,81.4022412,175.3960756,4.5994893,30.6288839,19.1934185,41.8612748,6.8288068,9.9678866,0.8990009,35.6069331),(14588,'metacarpus.tif',40,5,97,30.4150245,7.1458075,10.7041623,1.8,7.3503523,10.5410272,-1.3269682,4.1013841,5.8230363,79.0859587,171.340274,4.7737229,29.424559,19.2827484,40.5559377,6.80723,9.9732037,1.3715523,35.185321),(14589,'metacarpus.tif',40,5,98,30.8220961,7.1807681,10.7317066,1.8,7.3487779,10.5372272,-1.3468858,4.0032803,5.8993362,76.365185,170.928547,4.8837424,28.9741998,19.075653,39.5585776,6.7546137,9.5069224,0.7644222,34.2453307),(14590,'metacarpus.tif',40,5,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(14591,'metacarpus.tif',40,5,100,0.7733022,4.5999138,10.2869543,1.8,4.4790166,10.3909633,-0.9743277,0.7604652,2.6153471,0.0545113,0.4768019,0.0882165,0.1823092,0.0716815,0.1950729,1.1744308,3.5196329,0.9753865,9.145773),(14592,'metacarpus.tif',40,5,101,1.2816161,4.7323392,10.3320786,1.8,4.5733698,10.4382171,-0.9318173,0.8304375,2.9058394,0.1214275,0.6471533,0.1376318,0.2227079,0.1462211,0.254314,1.5791367,3.9255146,1.2793395,10.406696),(14593,'metacarpus.tif',40,5,102,2.1330199,4.6594462,10.5819715,1.8,4.4944699,10.7891137,-1.0546403,0.8089936,2.825161,0.2174663,1.5879838,0.268909,0.5620861,0.268811,0.6366766,1.5630448,4.1498202,1.3422997,10.9612428),(14594,'metacarpus.tif',40,5,103,3.0416352,4.714841,10.635314,1.8,4.6172655,10.7380163,-0.9855854,0.9582208,2.7876737,0.433431,2.1815872,0.3522627,0.7825834,0.452329,0.9301924,1.8366256,4.2090157,1.0571903,11.8367223),(14595,'metacarpus.tif',40,5,104,4.1546186,4.7564583,10.7937576,1.8,4.6786537,10.9262365,-0.9726707,1.1072471,2.6752455,0.8684539,3.3757475,0.4728819,1.2618459,0.7843361,1.5781074,2.2609171,4.3127016,1.2145767,12.3551005),(14596,'metacarpus.tif',40,5,105,11.137221,5.6042106,12.0816997,1.8,5.6484074,12.1082618,1.0173228,2.4555034,3.9376259,7.3170342,29.2866218,1.3433288,7.4376344,2.979851,9.0501244,4.5887145,7.1741644,2.1224513,21.9185724),(14597,'metacarpus.tif',40,5,106,11.1592071,5.7686418,11.9216833,1.8,5.8011133,11.9744286,0.8388177,2.6642026,4.0482246,7.672997,33.9006095,1.0290984,8.3741919,2.880035,10.2694737,4.1504087,7.1741644,2.1224513,23.4681728),(14598,'metacarpus.tif',40,5,107,13.758915,5.8278536,11.9887681,1.8,5.8510451,12.0173998,0.8434922,2.6118413,4.1385624,10.6313429,38.1350292,1.2794952,9.2145594,4.0704398,11.7430565,4.352541,7.1741644,2.1224513,22.959242),(14599,'metacarpus.tif',40,5,108,15.5065255,5.893081,12.0272664,1.8,5.9125213,12.020925,0.787774,2.5110763,3.7467323,13.2239455,41.8832614,1.2983507,11.1786105,5.2662459,14.6358174,4.5156635,6.98698,2.1550676,21.9280197),(14600,'metacarpus.tif',40,5,109,17.3886222,5.9163558,12.0833809,1.8,5.9656857,12.0814427,0.7741836,3.2220167,3.7541471,17.6596953,45.2587006,1.4165537,12.0556546,5.4809447,16.7003168,4.7191818,7.015376,2.1848154,21.3640256),(14601,'metacarpus.tif',40,5,110,18.0115309,5.8992997,12.1007682,1.8,5.9465117,12.0524886,0.7595484,3.1695705,3.884087,18.9976267,48.0642156,1.4233965,12.3746497,5.9937543,17.2342377,4.7828587,7.4330589,2.1307361,23.0371133),(14602,'metacarpus.tif',40,5,111,17.9751622,5.8536555,12.0864565,1.8,5.9104028,12.0146088,0.7414446,3.5268812,3.6452267,20.3928524,46.5690297,1.3664209,12.7753454,5.7821206,16.5932971,4.6168128,7.2324295,2.0576956,21.9869963),(14603,'metacarpus.tif',40,5,112,18.2210495,5.8826842,12.0926329,1.8,5.9850482,11.9899822,0.7093805,3.4580698,3.6814405,22.7472055,49.9434801,1.2884554,13.5662873,6.5780066,17.7770535,5.0944352,7.4425625,2.057039,25.9160607),(14604,'metacarpus.tif',40,5,113,18.0373137,5.8622071,12.0702331,1.8,5.9804396,11.9465025,0.7228561,3.4098123,3.7176962,23.703725,50.5480789,1.3155841,13.5966135,6.9516217,18.7156503,5.1124252,7.4425625,2.057039,25.0767498),(14605,'metacarpus.tif',40,5,114,17.9967299,5.8699926,12.0407437,1.8,5.9680194,11.9150481,0.7192984,3.2604201,3.6502235,24.6666367,51.663597,1.3020411,14.1535436,7.5654781,20.5572713,4.9660568,7.3991028,2.0458071,22.8168599),(14606,'metacarpus.tif',40,5,115,17.8999928,5.8642034,11.9913556,1.8,5.9709801,11.8680665,0.7450122,3.4038023,3.7038497,26.000088,52.1600321,1.3713122,14.0826536,7.6385423,19.6078993,5.131608,7.6550074,2.0014888,23.3485987),(14607,'metacarpus.tif',40,5,116,21.198812,6.0955108,11.249574,1.8,6.2252459,11.0335054,-1.4691451,3.3457693,5.4923711,47.5688586,93.6012602,3.4967531,17.0420496,14.2176145,24.9663274,5.4903676,7.7678694,1.9423142,24.7235616),(14608,'metacarpus.tif',40,5,117,22.4469289,6.1490652,11.0301039,1.8,6.2295264,10.8963914,-1.4287806,3.2932985,5.3172918,48.9465948,106.9037571,3.6662074,20.1049258,14.8624837,28.7030913,6.0511544,9.1353321,1.5090194,32.1411836),(14609,'metacarpus.tif',40,5,118,23.9007848,6.2547588,10.8477131,1.8,6.3513286,10.8221294,-1.3942475,3.2977147,5.0614201,53.1214148,119.263259,3.8605863,23.563201,16.1085536,33.5777874,6.1016949,9.0317364,1.6124389,30.4358405),(14610,'metacarpus.tif',40,5,119,24.7133181,6.2714167,10.7195128,1.8,6.3699565,10.7716058,-1.3797682,3.3059581,4.9443039,53.5570296,125.7628319,3.9704005,25.4359024,16.2001536,35.8089668,6.0905044,9.0361378,1.6228326,29.8679331),(14611,'metacarpus.tif',40,5,120,25.0993252,6.27612,10.6601171,1.8,6.3716332,10.7379787,-1.380928,3.3124043,4.8841635,53.7494138,128.0236909,4.0342194,26.2119995,16.2267071,36.7195891,6.0624853,9.0317364,1.5291537,30.6010305),(14612,'metacarpus.tif',40,5,121,24.9892527,6.2761285,10.6201434,1.8,6.3636987,10.6923893,-1.3713693,3.3219412,4.8524664,52.9935376,127.5564657,4.0014179,26.2869345,15.9525815,36.7508012,6.0703362,9.0361378,1.6228326,30.0142284),(14613,'metacarpus.tif',40,5,122,24.5889256,6.2769348,10.612921,1.8,6.3824955,10.6816493,-1.3696586,3.2871548,4.7714165,52.6083856,122.6575732,3.9345816,25.706742,16.0042312,36.6093717,6.0544667,8.9378198,1.6128767,28.9413034),(14614,'metacarpus.tif',40,5,123,24.0659602,6.2669342,10.6118504,1.8,6.3872156,10.6557777,-1.3763935,3.2937984,4.7695522,51.4667952,118.9142854,3.8613081,24.9319599,15.625363,35.5758326,6.0544667,8.8439048,1.5282688,30.027589),(14615,'metacarpus.tif',40,5,124,23.436579,6.2424597,10.6215874,1.8,6.3736968,10.6411093,-1.3788223,3.3147137,4.708375,50.0660532,114.1447532,3.7639009,24.242919,15.1041861,34.6167035,5.970821,8.7499917,1.6137806,29.2527888),(14616,'metacarpus.tif',40,5,125,22.6111382,6.2186173,10.6217123,1.8,6.358965,10.6097979,-1.3669119,3.3438182,4.7198716,47.7457703,107.4861253,3.6140284,22.7731036,14.2788178,32.6719711,5.9286402,8.7545347,1.6245081,29.1521094),(14617,'metacarpus.tif',40,5,126,22.0246764,6.2152128,10.6218985,1.8,6.3706417,10.5732537,-1.3608854,3.3166494,4.7239614,46.1130183,104.0422362,3.511397,22.024362,13.9034948,31.5952011,5.8871753,8.6606727,1.6250907,28.909048),(14618,'metacarpus.tif',40,5,127,21.3859497,6.2180234,10.6200807,1.8,6.3729613,10.5433254,-1.3523305,3.3204661,4.7258513,44.2598507,100.4787431,3.3968986,21.2615117,13.3294091,30.4721671,5.8452331,8.5791816,1.4940244,28.0107605),(14619,'metacarpus.tif',40,5,128,20.5863632,6.21091,10.6312957,1.8,6.3595873,10.5417621,-1.353154,3.120545,4.8094278,41.8423142,94.1491801,3.2710874,19.5759628,13.4086559,28.1912181,5.6348064,8.6560804,1.5273454,27.158089),(14620,'metacarpus.tif',40,5,129,20.0917905,6.2275217,10.6156856,1.8,6.3641755,10.5436217,-1.3495541,3.0596232,4.7001578,40.1056073,91.6302517,3.1873795,19.4951436,13.1080219,27.9443562,5.6218152,8.5621711,1.5268686,26.6035422),(14621,'metacarpus.tif',40,5,130,19.6203278,6.2262256,10.6088599,1.8,6.3397662,10.5571061,-1.3484118,2.9214685,4.5817824,38.436582,88.6182862,3.110983,19.3414438,13.1565965,27.6749496,5.5664148,8.3917496,1.6492864,26.5256708),(14622,'metacarpus.tif',40,5,131,19.2531183,6.2374662,10.5714476,1.8,6.3425482,10.5359283,-1.3454957,2.9220286,4.6352549,36.9138051,86.6492573,3.0487079,18.6935257,12.6329377,26.6175034,5.5497289,8.4682638,1.5263811,26.7042215),(14623,'metacarpus.tif',40,5,132,18.8622929,6.2454742,10.5509777,1.8,6.3388096,10.540205,-1.3506414,2.8718378,4.4081772,35.3483004,83.8469721,2.9937911,19.0207806,12.308599,27.0049961,5.4526595,8.2980433,1.6501746,26.2503541),(14624,'metacarpus.tif',40,5,133,18.5112398,6.2541289,10.5339318,1.8,6.3438428,10.5377474,-1.3491921,2.8685459,4.3899648,34.158268,81.4983537,2.9361609,18.5646942,11.9078687,26.3149908,5.4136787,8.2043436,1.6510831,26.7498375),(14625,'metacarpus.tif',40,5,134,18.1716032,6.2618628,10.5324477,1.8,6.3502659,10.5401503,-1.3561969,2.7825063,4.3852744,33.2309076,79.2974133,2.8912527,18.0826571,11.9427968,25.6235457,5.3466144,8.1914098,1.6282044,26.1174194),(14626,'metacarpus.tif',40,5,135,17.7730382,6.2541451,10.5420465,1.8,6.3415265,10.5482338,-1.363556,2.7410797,4.486391,32.1059963,76.6156393,2.8367629,17.0773434,11.7129016,24.1948773,5.2809045,8.2740504,1.548073,25.9066133),(14627,'metacarpus.tif',40,5,136,17.4654761,6.2411561,10.5589366,1.8,6.3454268,10.547908,-1.3684713,2.6914225,4.5042435,31.2537587,74.5419003,2.7933704,16.5492608,11.6123571,23.4409647,5.2395121,8.1973403,1.5019398,25.993932),(14628,'metacarpus.tif',40,5,137,17.1471242,6.2233714,10.598076,1.8,6.3123487,10.5969108,-1.3842612,2.6658181,4.3387639,30.2584632,71.7520527,2.759562,16.5374412,11.3505355,23.4519199,5.2339481,8.0097982,1.6412677,25.8192946),(14629,'metacarpus.tif',40,5,138,16.8972846,6.22087,10.6088854,1.8,6.3135335,10.5837803,-1.3955059,2.6544023,4.346092,29.3577985,69.7969164,2.7305637,16.059696,11.060041,22.7374091,5.2245007,8.0169653,1.6529638,25.5990412),(14630,'metacarpus.tif',40,5,139,16.7405019,6.2203902,10.6217132,1.8,6.3203885,10.5979046,-1.4065452,2.6407993,4.354602,28.8669801,68.4101678,2.7154861,15.7098554,10.9311526,22.2429615,5.1717366,7.9921287,1.5472713,25.6084886),(14631,'metacarpus.tif',40,5,140,16.6809235,6.2235919,10.6239203,1.8,6.3310472,10.5944892,-1.4142256,2.6288663,4.2748526,28.6959708,67.3746504,2.7125552,15.7606957,10.9157208,22.294704,5.193159,7.9009523,1.6064954,25.9294213),(14632,'metacarpus.tif',40,5,141,16.6570498,6.2351667,10.6125695,1.8,6.3614214,10.5748905,-1.4143933,2.8486443,4.2471044,28.4217865,66.7014985,2.7088164,15.7051705,9.9773025,22.2776617,5.3979469,7.822278,1.64296,26.1174194),(14633,'metacarpus.tif',40,5,142,16.6178065,6.236548,10.6098588,1.8,6.3649755,10.5762366,-1.4199278,2.825942,4.2417135,28.1210344,66.2817468,2.7070708,15.6261725,9.9510303,22.1243335,5.3040374,7.9098938,1.63025,26.6719661),(14634,'metacarpus.tif',40,5,143,16.5202893,6.2292645,10.6150067,1.8,6.3528245,10.591126,-1.4239702,2.8271402,4.2322128,27.707342,65.2832744,2.6944497,15.4253289,9.8004839,21.8776338,5.2902635,7.8070139,1.6069252,26.4289047),(14635,'metacarpus.tif',40,5,144,16.4552445,6.2309249,10.6128533,1.8,6.3511907,10.581147,-1.4315191,2.8159065,4.2137073,27.3808548,64.3908541,2.6896837,15.2812831,9.7236376,21.675419,5.286983,7.7285266,1.6438369,26.1858433),(14636,'metacarpus.tif',40,5,145,16.4836894,6.2401213,10.6123641,1.8,6.369582,10.5786285,-1.4354813,2.8142772,4.1682195,27.3782711,64.0492421,2.6972847,15.3660913,9.7283491,21.6107482,5.3232502,7.6607765,1.6814535,25.4850012),(14637,'metacarpus.tif',40,5,146,16.4036265,6.2429906,10.6108161,1.8,6.3622499,10.5859549,-1.4408517,2.8039183,4.1501836,27.0160232,63.4490803,2.6880328,15.2882587,9.6350963,21.5348204,5.3166932,7.6509665,1.6692425,26.2865227),(14638,'metacarpus.tif',40,5,147,16.2921624,6.240705,10.6115422,1.8,6.3371532,10.5836883,-1.4461282,2.6934697,4.1593858,26.3991729,62.6673504,2.673376,15.0664916,9.8011768,21.0574586,5.1619383,7.6284134,1.6324465,25.5534252),(14639,'metacarpus.tif',40,5,148,16.2580431,6.2446654,10.6089527,1.8,6.3384926,10.584485,-1.4472753,2.6535319,4.1554444,26.0942985,62.3098797,2.668541,14.9947573,9.8337989,20.9189901,5.1679476,7.5673595,1.6828253,25.0767498),(14640,'metacarpus.tif',40,5,149,16.1873912,6.2420314,10.6136597,1.8,6.3288219,10.5857305,-1.4496776,2.5482494,4.1585754,25.7944888,61.7682177,2.6585142,14.8532157,10.1224351,20.6940058,5.0892579,7.6347813,1.6447354,26.0206533),(14641,'metacarpus.tif',40,5,150,16.0986953,6.2405514,10.6187343,1.8,6.3167986,10.6063834,-1.4561656,2.5028189,4.0759998,25.4327495,61.0038002,2.6480133,14.9665855,10.1616419,20.6932806,4.9310291,7.4851798,1.696709,23.7930188),(14642,'metacarpus.tif',40,5,151,16.0945407,6.2448225,10.6128784,1.8,6.316208,10.5952384,-1.4575935,2.4970741,4.1511701,25.2085638,60.8298968,2.6481951,14.653675,10.0952408,20.341405,4.9285685,7.5410423,1.6456562,24.2468862),(14643,'metacarpus.tif',40,5,152,16.0362839,6.2471379,10.6081357,1.8,6.3132717,10.5889157,-1.4591206,2.55496,4.1449549,24.8829777,60.5308084,2.6395197,14.6034901,9.7390869,20.2186705,4.9819484,7.5410423,1.4959365,23.5499573),(14644,'metacarpus.tif',40,5,153,16.0140152,6.253908,10.6079645,1.8,6.3182972,10.5900713,-1.463742,2.4691126,4.0568292,24.6583179,60.0866299,2.6385308,14.8112298,9.9867127,20.3592348,4.9162654,7.4407815,1.6340032,23.7151474),(14645,'metacarpus.tif',40,5,154,15.9623022,6.2574849,10.6017128,1.8,6.3255079,10.5872418,-1.4590254,2.4625841,4.1374957,24.2880936,59.7172355,2.6272864,14.4331837,9.8628483,19.928831,4.9138048,7.5252077,1.5333139,23.5822127),(14646,'metacarpus.tif',40,5,155,15.9545936,6.2558003,10.6022305,1.8,6.3272713,10.5934499,-1.4581982,2.4864409,4.0560226,24.1995994,59.3719272,2.6255282,14.6379675,9.7326261,20.1064948,4.9133411,7.3805699,1.4559197,23.3391513),(14647,'metacarpus.tif',40,5,156,15.9272627,6.2554142,10.5997251,1.8,6.3257954,10.5923545,-1.4587121,2.5586968,4.0531089,23.9064554,58.7891018,2.6213345,14.5046932,9.3432153,19.9064804,4.8855644,7.3703869,1.673003,23.0960899),(14648,'metacarpus.tif',40,5,157,15.935841,6.258405,10.590332,1.8,6.3322158,10.5828624,-1.4583602,2.5677977,4.04376,23.6714417,58.7262117,2.6225382,14.522675,9.2185772,19.881933,4.8879494,7.3805699,1.6856729,23.0732819),(14649,'metacarpus.tif',40,5,158,15.9055108,6.257655,10.5934448,1.8,6.3292678,10.5927951,-1.4617877,2.4800236,4.0438015,23.438871,58.4440523,2.6195425,14.4527502,9.4510679,19.7425513,4.7939504,7.3805699,1.4559197,23.0276659),(14650,'metacarpus.tif',40,5,159,15.8374528,6.2559293,10.588628,1.8,6.3256896,10.5841353,-1.4592304,2.475775,4.0415509,23.0123134,58.057321,2.6068569,14.3651095,9.2949938,19.5652667,4.7939504,7.3703869,1.673003,22.7295412),(14651,'metacarpus.tif',40,5,160,15.7926734,6.2523875,10.584544,1.8,6.3152225,10.5937721,-1.456789,2.4220036,4.0508084,22.6141306,57.9338359,2.5980488,14.3017962,9.3369518,19.3035355,4.6999513,7.3469726,1.5067813,22.9497946),(14652,'metacarpus.tif',40,5,161,15.7631732,6.2553951,10.5846168,1.8,6.3310771,10.582621,-1.4563069,2.4091109,4.1336645,22.375078,57.8749049,2.5929089,14.0008713,9.2876911,18.9768277,4.6999513,7.4550177,1.4824195,22.8396679),(14653,'metacarpus.tif',40,5,162,15.7436193,6.2558367,10.5828678,1.8,6.3257742,10.586886,-1.4545182,2.4118279,4.0510064,22.1902894,57.6089289,2.5886189,14.2208932,9.2006107,19.1368146,4.6999513,7.3469726,1.5067813,23.0732819),(14654,'metacarpus.tif',40,5,163,15.7006737,6.2588338,10.5768184,1.8,6.3251743,10.5832767,-1.4560442,2.4177849,4.0431401,21.8710138,57.4074574,2.582472,14.1987308,9.0458889,19.0425952,4.6999513,7.3421604,1.2449972,23.1739612),(14655,'metacarpus.tif',40,5,164,15.6985603,6.2623358,10.5736342,1.8,6.3286099,10.5832789,-1.4564557,2.4246715,4.0391682,21.6733759,57.3143199,2.582369,14.1896342,8.9386854,18.9919268,4.6999513,7.325293,1.4161958,22.9080918),(14656,'metacarpus.tif',40,5,165,15.705562,6.2662584,10.5701833,1.8,6.3373511,10.5874059,-1.4541927,2.3706823,4.0375172,21.4141939,57.0688986,2.5821648,14.1346514,9.0329244,18.8914865,4.6999513,7.3637904,1.3258177,22.8624759),(14657,'metacarpus.tif',40,5,166,15.6784942,6.2673209,10.5636974,1.8,6.338279,10.5855844,-1.4533386,2.3825833,4.1141217,21.1076746,56.7322786,2.5771969,13.7896454,8.8591551,18.5103976,4.6999513,7.3925319,1.3659196,22.9175392),(14658,'metacarpus.tif',40,5,167,15.7005034,6.265447,10.5582473,1.8,6.3448725,10.5662159,-1.4503922,2.3668709,4.029455,20.9968633,56.6700786,2.5789981,14.0639563,8.8711484,18.7442568,4.6059523,7.3204665,1.3507346,22.2851211),(14659,'metacarpus.tif',40,5,168,15.6805489,6.265107,10.552004,1.8,6.3371527,10.5651686,-1.4472065,2.3836718,4.0263565,20.72673,56.3125539,2.573709,13.9859832,8.6952952,18.6185406,4.6059523,7.2817401,1.3759324,22.2300577),(14660,'metacarpus.tif',40,5,169,15.6499694,6.2679325,10.5515619,1.8,6.3350299,10.5768549,-1.4506038,2.3536606,4.0110447,20.4943603,55.932274,2.5708288,13.9445651,8.7074408,18.6197706,4.604374,7.3005239,1.3633001,22.5966065),(14661,'metacarpus.tif',40,5,170,15.666634,6.2715527,10.5463024,1.8,6.3387698,10.5639267,-1.4489279,2.3412986,3.9954115,20.3648048,55.8816861,2.5725174,13.9864657,8.6980809,18.7401252,4.6059523,7.2871984,1.4544412,22.4864798),(14662,'metacarpus.tif',40,5,171,15.6489171,6.2737313,10.5408588,1.8,6.3429396,10.5694883,-1.4480383,2.3407941,3.9904241,20.0818304,55.4737604,2.5690463,13.9017206,8.5790674,18.5970502,4.5994528,7.2476846,1.5188949,22.2756737),(14663,'metacarpus.tif',40,5,172,15.6452902,6.274425,10.538072,1.8,6.3400952,10.5689299,-1.4443201,2.3343518,3.9785255,19.8708827,55.3049911,2.5660593,13.9008762,8.5123769,18.6380154,4.5119533,7.2434164,1.531855,22.5415431),(14664,'metacarpus.tif',40,5,173,15.6366762,6.2761605,10.536903,1.8,6.3441427,10.5633906,-1.4418172,2.3130423,3.9787698,19.5840458,55.0768303,2.5629983,13.8426784,8.4667912,18.5181816,4.5119533,7.2403662,1.5967645,21.8996776),(14665,'metacarpus.tif',40,5,174,15.637329,6.2754812,10.5352278,1.8,6.3449758,10.5511211,-1.4417864,2.334639,3.9202774,19.3710235,54.6381739,2.5630848,13.9373232,8.2972244,18.3625781,4.5994528,7.1550489,1.3991683,22.2434183),(14666,'metacarpus.tif',40,5,175,15.6569153,6.2775133,10.5362286,1.8,6.348318,10.5576422,-1.4419556,2.323645,4.0019929,19.2684223,54.4636789,2.5664078,13.6091394,8.2923262,18.0407706,4.5119533,7.2324295,1.4141944,21.6432556),(14667,'metacarpus.tif',40,5,176,15.6216605,6.2801216,10.5368722,1.8,6.3553648,10.5643354,-1.4417935,2.272878,4.0024299,19.0311202,54.2008716,2.5605213,13.5419915,8.3731374,17.919473,4.4179543,7.2476846,1.4013833,21.7211269),(14668,'metacarpus.tif',40,5,177,15.597987,6.2830494,10.5399358,1.8,6.3613129,10.564125,-1.4429287,2.3253692,3.9229102,18.8751334,53.7528197,2.5573908,13.7022816,8.1170481,18.0121867,4.5119533,7.1395958,1.4121411,21.8218063),(14669,'metacarpus.tif',40,5,178,15.6045987,6.2843307,10.5401757,1.8,6.3659829,10.5679021,-1.4427928,2.3362052,3.9231112,18.7087973,53.5539642,2.5583854,13.6508911,8.0081996,17.9226311,4.4959308,7.1253495,1.4251679,21.4096416),(14670,'metacarpus.tif',40,5,179,15.6115922,6.2827017,10.5388417,1.8,6.3672126,10.5665597,-1.4398944,2.2775033,3.9246815,18.5951734,53.4326341,2.5576012,13.6145148,8.1647186,17.8673374,4.4179543,7.112317,1.4382448,21.7761903),(14671,'metacarpus.tif',40,5,180,15.6601395,6.2771276,10.5442745,1.8,6.3578504,10.5662867,-1.4378761,2.2740023,3.9326556,18.5392672,53.2169141,2.5641809,13.5320556,8.1527037,17.768865,4.4179543,7.1395958,1.4121411,21.6660636),(14672,'metacarpus.tif',40,5,181,15.6741461,6.2833577,10.5456042,1.8,6.3615078,10.5833834,-1.4390292,2.259778,3.9320944,18.4107699,53.0704257,2.5672623,13.4967324,8.1471587,17.7049753,4.4179543,7.1395958,1.4121411,21.7211269),(14673,'metacarpus.tif',40,5,182,15.6789812,6.2877362,10.5415919,1.8,6.3715226,10.5795388,-1.4391917,2.2557689,3.9273933,18.3305355,52.8496963,2.5681648,13.4566853,8.1260698,17.6535974,4.4179543,7.112317,1.4382448,21.9641883),(14674,'metacarpus.tif',40,5,183,15.7519097,6.2975626,10.5354719,1.8,6.3840458,10.5607578,-1.4355157,2.2468732,3.9233326,18.2538812,53.2449404,2.5775651,13.5713553,8.1241259,17.7730889,4.4179543,7.1550489,1.3991683,22.399161),(14675,'metacarpus.tif',40,5,184,15.7477052,6.298958,10.5367946,1.8,6.3835418,10.5693164,-1.4363778,2.236075,3.9236882,18.0864824,52.9018376,2.57748,13.4826813,8.0884954,17.6429,4.4156409,7.112317,1.4382448,22.6422224),(14676,'metacarpus.tif',40,5,185,15.7704751,6.3003335,10.5311712,1.8,6.3894731,10.5513087,-1.4336374,2.2353694,3.9203569,17.9298018,52.7372038,2.5792746,13.4521436,8.0209571,17.5881732,4.4172814,7.0899198,1.4645315,21.9452936),(14677,'metacarpus.tif',40,5,186,15.798427,6.3017633,10.5388256,1.8,6.3885767,10.5607661,-1.437432,2.2318516,3.9243864,17.832753,52.4746089,2.5865163,13.3714175,7.9901158,17.4696592,4.4090585,7.0899198,1.4645315,21.6110002),(14678,'metacarpus.tif',40,5,187,15.8221693,6.3063345,10.5416645,1.8,6.3982736,10.5628816,-1.4384469,2.225816,3.9256898,17.7841107,52.2106339,2.5911061,13.299735,7.9899286,17.3873745,4.4164403,7.1253495,1.4251679,21.9869963),(14679,'metacarpus.tif',40,5,188,15.8107809,6.3114032,10.5429679,1.8,6.4039839,10.5692115,-1.4368366,2.2349611,3.9277346,17.6346169,52.0526705,2.5881244,13.2525934,7.8903463,17.3133197,4.4123599,7.1005051,1.4513674,22.2756737),(14680,'metacarpus.tif',40,5,189,15.8041645,6.3148598,10.5415679,1.8,6.404737,10.5646234,-1.4395576,2.2284407,3.9111849,17.4971446,51.8155579,2.5889198,13.2480461,7.8517433,17.3673486,4.4090585,7.0899198,1.4645315,21.931933),(14681,'metacarpus.tif',40,5,190,15.8367554,6.316677,10.5384013,1.8,6.4113706,10.5503903,-1.4363076,2.2183787,3.8977596,17.4180404,51.6989323,2.5920059,13.2637559,7.8516984,17.4311234,4.4179543,7.0805668,1.4777326,22.1749944),(14682,'metacarpus.tif',40,5,191,15.8481933,6.318801,10.5378105,1.8,6.414451,10.5574909,-1.4375635,2.2274403,3.9209997,17.2630323,51.4959621,2.5947555,13.1333755,7.7501661,17.1141576,4.3239552,7.112317,1.4382448,21.9641883),(14683,'metacarpus.tif',40,5,192,15.8856497,6.3158976,10.5484231,1.8,6.4136322,10.5624447,-1.4390775,2.2024005,3.9305709,17.2393916,51.2632163,2.6019377,13.0421807,7.8275462,17.0039484,4.3224735,7.0805668,1.4777326,22.1521864),(14684,'metacarpus.tif',40,5,193,15.8723958,6.3181355,10.5481489,1.8,6.4106026,10.5677669,-1.4385773,2.2007257,3.8496592,17.1677351,50.8831387,2.5994216,13.2175696,7.8009427,17.1255669,4.3224735,6.9964581,1.4631065,22.0515071),(14685,'metacarpus.tif',40,5,194,15.8531978,6.322888,10.5454915,1.8,6.419297,10.5606526,-1.439736,2.1829,3.913884,17.0671505,50.8740473,2.5970743,12.9983535,7.8185671,17.0189783,4.3239552,7.0599465,1.5175135,22.4636718),(14686,'metacarpus.tif',40,5,195,15.870111,6.326728,10.5500213,1.8,6.422227,10.5665579,-1.4443443,2.174224,3.9142283,16.9905408,50.7479693,2.6029493,12.9649997,7.8145309,16.9552612,4.3224735,7.0805668,1.4777326,22.4636718),(14687,'metacarpus.tif',40,5,196,15.8416182,6.3296583,10.544258,1.8,6.4331198,10.5603976,-1.4403918,2.1879623,3.8990409,16.8335688,50.6214581,2.595625,12.9830538,7.6937197,17.0094394,4.3232967,7.0724508,1.4909663,22.7617965),(14688,'metacarpus.tif',40,5,197,15.8150969,6.3320324,10.5418135,1.8,6.4298553,10.5576835,-1.4408775,2.1550155,3.8393012,16.6357737,50.4647444,2.591609,13.1442525,7.7195611,16.9335011,4.2299562,6.98698,1.4764824,22.8168599),(14689,'metacarpus.tif',40,5,198,15.8588362,6.3314977,10.5456474,1.8,6.4331124,10.5481718,-1.4404409,2.1425653,3.8435999,16.6668978,50.4087984,2.5984796,13.1149964,7.778945,16.9111956,4.2299562,7.0191535,1.4364749,22.4180558),(14690,'metacarpus.tif',40,5,199,15.8394341,6.3353979,10.5480013,1.8,6.4283099,10.5577359,-1.4421252,2.1476542,3.8437794,16.601306,50.0994088,2.5964394,13.033893,7.7299716,16.813506,4.2299562,6.98698,1.3813162,22.1749944),(14691,'metacarpus.tif',40,5,200,15.8574363,6.3389653,10.5454211,1.8,6.435194,10.5560287,-1.4419007,2.1628212,3.8409822,16.5328341,50.1104931,2.5992392,13.0462705,7.644106,16.8147884,4.2299562,6.98698,1.3813162,21.2216435),(14692,'metacarpus.tif',40,5,201,15.8968582,6.3470248,10.5449316,1.8,6.4472346,10.5544141,-1.4422545,2.1588617,3.8391177,16.5322742,50.187798,2.6059396,13.0727428,7.6578662,16.8487037,4.2299562,7.0052929,1.3681377,21.5197683),(14693,'metacarpus.tif',40,5,202,15.8572144,6.3486906,10.5384702,1.8,6.4543663,10.5471771,-1.4411968,2.1690127,3.9024341,16.3361002,49.9041342,2.5987273,12.7879504,7.5315834,16.6551696,4.3150917,7.0724508,1.4909663,22.7846045),(14694,'metacarpus.tif',40,5,203,15.8796455,6.3515728,10.5327313,1.8,6.4482673,10.5348554,-1.4397396,2.135828,3.8288569,16.250456,49.940182,2.6014095,13.043105,7.608504,16.7701369,4.2299562,6.9787552,1.4898922,23.0599213),(14695,'metacarpus.tif',40,5,204,15.9529563,6.3503093,10.5391193,1.8,6.4525558,10.5427481,-1.4398917,2.1232535,3.8352093,16.3471577,49.9768698,2.613524,13.0310671,7.699108,16.7767056,4.2299562,7.0071846,1.4497691,22.3952478),(14696,'metacarpus.tif',40,5,205,15.9615824,6.3546726,10.5362149,1.8,6.461716,10.5417819,-1.4396508,2.1075594,3.8319902,16.2840415,49.8323082,2.6147712,13.0042891,7.7264922,16.7423947,4.1359572,7.0071846,1.4497691,22.7940519),(14697,'metacarpus.tif',40,5,206,15.977726,6.3588784,10.5317771,1.8,6.4664128,10.5328836,-1.4388737,2.1061013,3.8277782,16.23614,49.7287854,2.6168776,12.9915537,7.7090974,16.7280669,4.1359572,6.98698,1.4764824,22.1749944),(14698,'metacarpus.tif',40,5,207,16.0137108,6.3668426,10.5337353,1.8,6.4790788,10.5394777,-1.4407013,2.1073926,3.8269482,16.2376437,49.5933511,2.6240348,12.9589817,7.7050873,16.6986922,4.1359572,7.0191535,1.4364749,19.9701679),(14699,'metacarpus.tif',40,5,208,15.9845421,6.3680962,10.5272574,1.8,6.4811532,10.5273599,-1.440684,2.0995024,3.8203787,16.1056656,49.3321041,2.6192433,12.9128832,7.6711821,16.6263164,4.1359572,6.98698,1.3813162,20.2037819),(14700,'metacarpus.tif',40,5,209,16.0081517,6.3712414,10.5287903,1.8,6.4850353,10.5320932,-1.4408743,2.1111768,3.8213111,16.0358061,49.3449285,2.6232425,12.9130884,7.595672,16.6106293,4.1359572,6.98698,1.3813162,19.8828491),(14701,'metacarpus.tif',40,5,210,16.0355341,6.3727407,10.5283796,1.8,6.48279,10.5264216,-1.4407861,2.1204782,3.8207927,15.9489739,49.251383,2.6276691,12.8903573,7.5214044,16.568706,4.2299562,6.98698,1.3813162,20.0157838),(14702,'metacarpus.tif',40,5,211,16.0489488,6.3757465,10.52674,1.8,6.4860145,10.5216462,-1.4402297,2.1273761,3.8070608,15.9142857,49.0360414,2.6294839,12.8802886,7.480711,16.6563797,4.2299562,6.98698,1.4764824,20.2265899),(14703,'metacarpus.tif',40,5,212,16.0867399,6.3829084,10.5251645,1.8,6.496287,10.5208665,-1.4413016,2.1224356,3.8036672,15.8957859,49.1688699,2.6364146,12.9267012,7.4894078,16.7025002,4.1359572,6.9717881,1.5033313,19.8049778),(14704,'metacarpus.tif',40,5,213,16.1227832,6.3902816,10.5229601,1.8,6.504286,10.518552,-1.4418942,2.1176024,3.8000342,15.8809453,49.1497473,2.6427286,12.9340275,7.4994934,16.7134147,4.1743733,6.9717881,1.5033313,19.9701679),(14705,'metacarpus.tif',40,5,214,16.1155596,6.3908368,10.5194948,1.8,6.5063445,10.5193861,-1.4380507,2.1158757,3.7872701,15.750676,48.969839,2.6388742,12.9301153,7.4440461,16.7306986,4.176834,6.98698,1.4764824,19.8049778),(14706,'metacarpus.tif',40,5,215,16.1189373,6.3949636,10.5172466,1.8,6.505195,10.5093183,-1.4392903,2.1079404,3.8082463,15.6689117,49.0425636,2.640297,12.8779916,7.4332801,16.5217592,4.176834,6.98698,1.4764824,20.3595246),(14707,'metacarpus.tif',40,5,216,16.169326,6.3960968,10.5202306,1.8,6.5149554,10.5125691,-1.4404215,2.0978795,3.8100196,15.7515764,49.0663803,2.64934,12.8782487,7.5083323,16.5389025,4.1359572,6.98698,1.4764824,20.0936552),(14708,'metacarpus.tif',40,5,217,16.1732382,6.3980421,10.5220183,1.8,6.5158176,10.5170497,-1.4385683,2.0864199,3.8132305,15.7020817,48.990473,2.6486842,12.8474985,7.5258494,16.5028132,4.1359572,6.98698,1.4764824,19.7821698),(14709,'metacarpus.tif',40,5,218,16.1773106,6.4020426,10.5172017,1.8,6.5207141,10.5113557,-1.4384531,2.0772588,3.8080327,15.6478301,49.050185,2.64927,12.8807152,7.5329229,16.5292073,4.1359572,6.9964581,1.4631065,20.4051406),(14710,'metacarpus.tif',40,5,219,16.2351381,6.4064362,10.520386,1.8,6.523654,10.5210437,-1.4399953,2.0710881,3.809216,15.6903067,49.0574055,2.6598255,12.8786094,7.575876,16.5359652,4.1359572,6.9964581,1.4631065,19.7365538),(14711,'metacarpus.tif',40,5,220,16.1857535,6.4077088,10.5152416,1.8,6.5361253,10.5147531,-1.4365347,2.07589,3.8070615,15.58103,48.7131415,2.6492892,12.7954701,7.5057107,16.442223,4.1359572,6.9964581,1.4631065,20.0157838),(14712,'metacarpus.tif',40,5,221,16.2144939,6.4123356,10.5113741,1.8,6.5333985,10.5021112,-1.4360249,2.08459,3.803062,15.5182422,48.8459526,2.6536272,12.8438486,7.4442659,16.4823096,4.1694521,6.9698868,1.3945616,20.0157838),(14713,'metacarpus.tif',40,5,222,16.2343335,6.4118122,10.5179857,1.8,6.5329121,10.5143174,-1.4380754,2.1240398,3.7829806,15.4829098,48.6768843,2.6583406,12.8673365,7.2893691,16.6266046,4.1760844,6.9660826,1.5167948,19.9151045),(14714,'metacarpus.tif',40,5,223,16.2591323,6.4143886,10.5192459,1.8,6.5370841,10.5141459,-1.4366991,2.1133966,3.7722882,15.4901518,48.528699,2.661418,12.8645257,7.3295053,16.5893342,4.1359572,6.9616418,1.530278,19.9929758),(14715,'metacarpus.tif',40,5,224,16.2850435,6.4187982,10.5177619,1.8,6.5427508,10.5101052,-1.4381445,2.1309747,3.7693533,15.5567843,48.526877,2.6666934,12.8740592,7.3003141,16.6193137,4.176834,6.903011,1.4616429,19.5713638),(14716,'metacarpus.tif',40,5,225,16.3141946,6.4242359,10.5175585,1.8,6.5513446,10.5068139,-1.4390024,2.1244819,3.7679141,15.4964886,48.5997997,2.6720767,12.8983302,7.2942437,16.6323702,4.1728039,6.9660826,1.5167948,19.5485558),(14717,'metacarpus.tif',40,5,226,16.2676386,6.426158,10.5177228,1.8,6.5494195,10.5167112,-1.4373334,2.1127771,3.7131884,15.3699399,48.3676577,2.663265,13.0259101,7.2747568,16.6928433,4.1695234,6.8934044,1.4751982,19.7271064),(14718,'metacarpus.tif',40,5,227,16.2708988,6.4316321,10.5120839,1.8,6.5516835,10.5004949,-1.4353634,2.0778474,3.8271289,15.2699827,48.6412969,2.6623795,12.7096052,7.3489433,16.1031657,4.1620703,6.8780059,1.50241,19.8277858),(14719,'metacarpus.tif',40,5,228,16.2617225,6.4337969,10.5190727,1.8,6.5491005,10.5151599,-1.4391772,2.0725943,3.8297364,15.2203832,48.4980296,2.6636057,12.6635426,7.3436386,16.0320287,4.1620703,7.0191535,1.4364749,20.5247146),(14720,'metacarpus.tif',40,5,229,16.2698158,6.4367626,10.5199527,1.8,6.5585056,10.5041067,-1.436778,2.0802412,3.8327507,15.2627471,48.4135212,2.6632234,12.6315341,7.3370084,16.0228372,4.0788621,6.9964581,1.4631065,20.1809739),(14721,'metacarpus.tif',40,5,230,16.30203,6.4421334,10.5197376,1.8,6.5612212,10.5062239,-1.4368341,2.0730019,3.8317614,15.3443334,48.58107,2.6685369,12.6785215,7.401987,16.0948173,4.0828671,6.9660826,1.5167948,19.5941717),(14722,'metacarpus.tif',40,5,231,16.3166333,6.4487685,10.5180376,1.8,6.570609,10.5043811,-1.4385199,2.0677588,3.8274334,15.3003885,48.6646236,2.6721336,12.7146884,7.3995034,16.1216246,4.0854232,7.0323586,1.4232283,20.7355207),(14723,'metacarpus.tif',40,5,232,16.2493938,6.4468325,10.5161882,1.8,6.5640693,10.5019672,-1.4360884,2.051577,3.8283914,15.1748695,48.3201429,2.6593847,12.6215263,7.3966853,16.0070054,4.0854232,6.9717881,1.5033313,20.0063365),(14724,'metacarpus.tif',40,5,233,16.2150358,6.4523141,10.5162763,1.8,6.5744503,10.5065737,-1.4372161,2.0577749,3.8265754,15.0658461,48.3137015,2.6545694,12.625833,7.3214256,15.9861504,4.0788621,6.98698,1.4764824,19.7271064),(14725,'metacarpus.tif',40,5,234,16.1876081,6.4512801,10.5212204,1.8,6.5719215,10.5098677,-1.4392715,2.0710937,3.8294724,15.0319321,48.0161559,2.6515322,12.5385826,7.257968,15.8826835,4.0854232,6.8934044,1.4751982,19.3054944),(14726,'metacarpus.tif',40,5,235,16.2026159,6.4529039,10.5207039,1.8,6.5726855,10.508391,-1.4362697,2.0961422,3.8318637,15.0189569,48.0993115,2.6518592,12.5524588,7.1650467,15.9047914,4.090249,6.9660826,1.5167948,19.9056571),(14727,'metacarpus.tif',40,5,236,16.2202106,6.4572987,10.5202572,1.8,6.5734506,10.5102,-1.4396589,2.0771535,3.7904507,15.0239648,48.0774395,2.6571444,12.6838318,7.2329585,16.3213438,4.0919842,6.9660826,1.5167948,19.5391084),(14728,'metacarpus.tif',40,5,237,16.2523924,6.4621489,10.5201401,1.8,6.5770008,10.5057856,-1.4404795,2.0946261,3.7080912,15.0120231,48.1951865,2.6629909,12.9973034,7.1669224,16.5998321,4.0919842,6.903011,1.4616429,20.0936552),(14729,'metacarpus.tif',40,5,238,16.1843315,6.4643549,10.5189267,1.8,6.5805841,10.5079172,-1.4368596,2.082376,3.7777544,14.8883526,47.9935288,2.6492887,12.7042479,7.1496946,16.4035836,4.0828671,6.9660826,1.5167948,19.9835285),(14730,'metacarpus.tif',40,5,239,16.1696522,6.4683024,10.5132721,1.8,6.5857378,10.4924012,-1.4358025,2.0722676,3.772306,14.8015423,48.0777505,2.6461288,12.7449234,7.142679,16.4311016,4.0690206,6.9660826,1.5167948,19.7042985),(14731,'metacarpus.tif',40,5,240,16.1806771,6.470416,10.5189137,1.8,6.5890417,10.501501,-1.4374092,2.0636946,3.7209165,14.7770506,47.982359,2.6490819,12.8953067,7.1604834,16.3539561,4.0743883,6.9260126,1.4346574,19.7821698),(14732,'metacarpus.tif',40,5,241,16.1833251,6.4727059,10.5220956,1.8,6.5898674,10.5148072,-1.4376809,2.0541172,3.8291542,14.7763735,47.8141658,2.6497085,12.4868739,7.1935395,15.7970558,4.0723011,7.0071846,1.4497691,20.1715265),(14733,'metacarpus.tif',40,5,242,16.2258332,6.4785915,10.5214055,1.8,6.5964959,10.5093278,-1.4390724,2.0610418,3.7083999,14.7883914,47.9780413,2.6576533,12.9376667,7.175202,16.5038722,4.0743883,6.8934044,1.4751982,19.7821698),(14734,'metacarpus.tif',40,5,243,16.2510447,6.4821927,10.5196853,1.8,6.5941358,10.5093198,-1.4402009,2.0775855,3.705271,14.7622223,48.0415626,2.6625754,12.9657351,7.1054703,16.526142,4.0788621,6.8934044,1.4751982,19.7499144),(14735,'metacarpus.tif',40,5,244,16.2058764,6.483054,10.5196323,1.8,6.5923422,10.5117535,-1.4409517,2.0668281,3.8220217,14.6453502,47.7582455,2.6556972,12.4955454,7.0859061,15.774672,4.0788621,6.903011,1.4616429,20.1259105),(14736,'metacarpus.tif',40,5,245,16.2190517,6.4859119,10.5158451,1.8,6.6019912,10.4967363,-1.4400237,2.0561234,3.7011281,14.5513993,47.9798024,2.6572099,12.9635616,7.077104,16.4756242,4.0755816,6.903011,1.4616429,19.4384291),(14737,'metacarpus.tif',40,5,246,16.2091167,6.4881182,10.5191753,1.8,6.6041419,10.5074278,-1.4415944,2.0844463,3.7028216,14.5231768,47.8005231,2.656673,12.9092158,6.9674027,16.4107476,4.0854232,6.903011,1.4616429,19.6169797),(14738,'metacarpus.tif',40,5,247,16.2341433,6.4858547,10.5231307,1.8,6.602732,10.5048028,-1.4393055,2.0247764,3.7089611,14.6002111,47.716602,2.6591786,12.8652204,7.2107772,16.3895386,4.0046035,6.8612851,1.4056476,19.5163004),(14739,'metacarpus.tif',40,5,248,16.2700604,6.4910848,10.5209813,1.8,6.6054858,10.5070617,-1.4404249,2.0301988,3.6929907,14.6330464,47.8277682,2.6658477,12.9509582,7.2076913,16.5810471,4.0034102,6.8780059,1.50241,19.3833657),(14740,'metacarpus.tif',40,5,249,16.2762123,6.4952761,10.5189034,1.8,6.6111004,10.5073724,-1.4420511,2.02277,3.6891786,14.5932086,47.767666,2.667986,12.9480492,7.2144674,16.5095206,3.9914814,6.8780059,1.50241,19.4156211),(14741,'metacarpus.tif',40,5,250,16.2533262,6.4966752,10.519623,1.8,6.6095508,10.5036611,-1.4412298,2.0480837,3.6903222,14.5494335,47.6127954,2.6636662,12.9020702,7.1039252,16.5153229,4.0001297,6.8328952,1.4327903,19.1725597),(14742,'metacarpus.tif',40,5,251,16.2260682,6.5033109,10.5129407,1.8,6.6233287,10.5038457,-1.4423295,2.0421717,3.6699856,14.4254216,47.6178698,2.6599579,12.9749475,7.0637653,16.6222924,4.0432548,6.8780059,1.50241,19.250431),(14743,'metacarpus.tif',40,5,252,16.2092623,6.502114,10.5198482,1.8,6.614693,10.5164959,-1.4454278,2.0550432,3.6749701,14.3828612,47.5266301,2.6593048,12.9325217,6.9988122,16.556037,4.0471977,6.8780059,1.50241,19.250431),(14744,'metacarpus.tif',40,5,253,16.200304,6.5040483,10.5187272,1.8,6.6245486,10.5066098,-1.4429526,2.0439323,3.6991967,14.3943192,47.4624625,2.6561609,12.8304783,7.0424636,16.3131554,3.9980424,6.8780059,1.50241,19.6948511),(14745,'metacarpus.tif',40,5,254,16.2189606,6.507315,10.5162223,1.8,6.6254498,10.5055848,-1.4453269,2.0361868,3.6825513,14.382602,47.6079946,2.6608282,12.9279922,7.0634982,16.4428904,4.0057042,6.8934044,1.4751982,19.9929758),(14746,'metacarpus.tif',40,5,255,16.2311044,6.5111717,10.5137066,1.8,6.6249559,10.5046793,-1.4448882,2.0276504,3.6798979,14.3109441,47.670501,2.6625253,12.9542998,7.0578952,16.4571766,3.9947619,6.8934044,1.4751982,19.5941717),(14747,'metacarpus.tif',40,5,256,16.2230805,6.5160198,10.5112628,1.8,6.6330331,10.4995264,-1.4440152,2.0315824,3.6775058,14.2639576,47.5839183,2.660619,12.9391825,7.0211071,16.4936277,4.0366977,6.8780059,1.50241,19.6169797),(14748,'metacarpus.tif',40,5,257,16.2330699,6.5192584,10.5064552,1.8,6.6371074,10.4940811,-1.4442103,2.0224487,3.6959192,14.1871544,47.67418,2.6623895,12.8991401,7.0148403,16.244778,4.0242898,6.9260126,1.4346574,20.0063365),(14749,'metacarpus.tif',40,5,258,16.2419084,6.5189162,10.5104068,1.8,6.6315715,10.5033086,-1.445947,2.0122003,3.6748733,14.159271,47.5740579,2.6650088,12.9457682,7.0367105,16.4177624,3.9852033,6.8850678,1.4887889,19.6948511),(14750,'metacarpus.tif',40,5,259,16.2403298,6.5167313,10.5169738,1.8,6.6346922,10.5128247,-1.4455739,1.9987996,3.6819365,14.2172433,47.3110123,2.6644998,12.8494916,7.1128909,16.3332589,3.9811032,6.8850678,1.4887889,19.6169797),(14751,'metacarpus.tif',40,5,260,16.3103524,6.5227986,10.5138343,1.8,6.6471502,10.5029558,-1.4465979,1.9937337,3.6889575,14.2981065,47.5200657,2.6766753,12.881706,7.1715227,16.3503255,4.0021646,6.903011,1.4616429,19.3283024),(14752,'metacarpus.tif',40,5,261,16.3163579,6.5259984,10.5150063,1.8,6.6480626,10.5111261,-1.4471277,1.997074,3.666096,14.2509693,47.4239696,2.6780144,12.9358231,7.1359244,16.5523611,3.9973555,6.8780059,1.50241,19.250431),(14753,'metacarpus.tif',40,5,262,16.3171976,6.5298297,10.513617,1.8,6.6511308,10.5014692,-1.4484493,2.0140442,3.6748716,14.2407164,47.3979271,2.6790275,12.8978458,7.070707,16.4471802,4.0094574,6.8464596,1.4191908,19.250431),(14754,'metacarpus.tif',40,5,263,16.3298661,6.5340186,10.5095588,1.8,6.6561595,10.5051009,-1.4466591,2.0044004,3.6832749,14.1511971,47.6331213,2.6799187,12.9322744,7.0600649,16.37519,4.0094574,6.8946861,1.3787483,19.3833657),(14755,'metacarpus.tif',40,5,264,16.3476942,6.5365676,10.5089673,1.8,6.6578191,10.5030246,-1.4464853,2.0299881,3.6708589,14.13677,47.5970807,2.682728,12.9661972,6.963967,16.5013318,4.0134727,6.8934044,1.4751982,19.3833657),(14756,'metacarpus.tif',40,5,265,16.3350544,6.5393149,10.5142618,1.8,6.6582164,10.503949,-1.4474437,2.0573024,3.6750819,14.1814179,47.3519186,2.6812934,12.8845888,6.8932103,16.4294192,4.0755816,6.8780059,1.50241,19.7955304),(14757,'metacarpus.tif',40,5,266,16.3957238,6.542526,10.5112652,1.8,6.6589858,10.5055959,-1.4472468,2.0484081,3.6718545,14.2655477,47.6227968,2.6911204,12.9696853,6.9642116,16.5412026,4.0755816,6.903011,1.4616429,19.4061737),(14758,'metacarpus.tif',40,5,267,16.3875688,6.546669,10.5090753,1.8,6.6657321,10.5035816,-1.4478264,2.0411526,3.6572259,14.2434789,47.4103397,2.6901682,12.9634704,6.9781547,16.6049666,4.0803271,6.8934044,1.4751982,19.3605577),(14759,'metacarpus.tif',40,5,268,16.3998114,6.5533385,10.5078619,1.8,6.682249,10.4969131,-1.4493418,2.0011435,3.6542645,14.2585541,47.4165867,2.6931803,12.9756853,7.1252033,16.626604,4.0151959,6.8464596,1.4191908,19.1725597),(14760,'metacarpus.tif',40,5,269,16.4371436,6.5562399,10.5024891,1.8,6.6849178,10.4945234,-1.4463642,2.0136619,3.673743,14.240763,47.5968331,2.6973254,12.9559505,7.0720727,16.4507004,4.0229421,6.9260126,1.4346574,19.7176591),(14761,'metacarpus.tif',40,5,270,16.3994785,6.5572108,10.4993229,1.8,6.6848116,10.4881316,-1.4468113,2.0027752,3.6701248,14.1206427,47.33578,2.691445,12.8975941,7.0505379,16.3637019,4.0101922,6.8934044,1.4751982,20.3595246),(14762,'metacarpus.tif',40,5,271,16.4130923,6.5560079,10.5105702,1.8,6.683877,10.4969113,-1.4493975,1.9927631,3.6679784,14.1745041,47.3005329,2.6953979,12.8955321,7.11299,16.452012,4.0066689,6.8464596,1.4191908,19.5619164),(14763,'metacarpus.tif',40,5,272,16.4119727,6.5574217,10.5086324,1.8,6.6847345,10.4956031,-1.4500205,1.9829468,3.6654394,14.1127418,47.2976868,2.6956227,12.903688,7.117055,16.4040256,3.9993269,6.8464596,1.4191908,19.9929758),(14764,'metacarpus.tif',40,5,273,16.3811726,6.5601536,10.5073674,1.8,6.6889609,10.4958188,-1.4519719,1.9756092,3.6624591,14.0059716,47.2301488,2.6918282,12.8957479,7.0894443,16.4070578,3.9578109,6.8934044,1.4751982,19.250431),(14765,'metacarpus.tif',40,5,274,16.3215285,6.5598868,10.5104908,1.8,6.6786763,10.5015234,-1.4547849,2.0103926,3.6526757,13.9013354,47.0767184,2.6838077,12.8882829,6.9147368,16.4470074,3.9917439,6.8464596,1.4191908,19.5163004),(14766,'metacarpus.tif',40,5,275,16.3130483,6.5615371,10.5037451,1.8,6.6872062,10.4961045,-1.4516684,1.9986737,3.6477445,13.8108701,47.213958,2.6804392,12.9433293,6.9100174,16.4904756,3.9483723,6.8464596,1.4191908,19.250431),(14767,'metacarpus.tif',40,5,276,16.2483527,6.5609638,10.5024344,1.8,6.6812378,10.4910675,-1.4504704,2.008573,3.6472562,13.6833209,47.0202692,2.6690395,12.8919566,6.8124587,16.3992432,3.9868244,6.8205994,1.4464413,19.3511103),(14768,'metacarpus.tif',40,5,277,16.2297266,6.5603064,10.5064416,1.8,6.6833308,10.4904985,-1.4532474,2.0096539,3.638554,13.6732062,46.8507107,2.6677499,12.8761895,6.8037616,16.3331659,3.9807649,6.8328952,1.4327903,19.273239),(14769,'metacarpus.tif',40,5,278,16.2797224,6.5632669,10.5060836,1.8,6.6880019,10.4933532,-1.4524391,2.001089,3.6382815,13.7062243,47.0446403,2.6754553,12.9304565,6.8493827,16.4006073,3.9934037,6.8205994,1.4464413,19.4061737),(14770,'metacarpus.tif',40,5,279,16.2538267,6.5654347,10.5042169,1.8,6.6876667,10.4971096,-1.4544281,1.9931894,3.574491,13.6562209,46.9936614,2.6724527,13.146952,6.8514418,16.5306945,3.9868244,6.7685827,1.4033645,19.204815),(14771,'metacarpus.tif',40,5,280,16.2620887,6.567543,10.5064588,1.8,6.6911565,10.4970663,-1.4559778,1.9857538,3.6254942,13.6636378,47.0041147,2.6747735,12.9648848,6.8808319,16.4472176,3.9807649,6.8328952,1.4327903,19.6397877),(14772,'metacarpus.tif',40,5,281,16.2655727,6.5727922,10.5004743,1.8,6.7013576,10.4876762,-1.4537551,1.9776781,3.6199199,13.5973661,47.1317058,2.673962,13.0200962,6.8754192,16.4331173,3.9750264,6.8095791,1.4601391,19.3283024),(14773,'metacarpus.tif',40,5,282,16.2067639,6.5736757,10.5006955,1.8,6.7034865,10.4859759,-1.4548178,1.9685827,3.5697171,13.4970373,46.8461495,2.664957,13.1232108,6.8562206,16.4744333,3.98384,6.7685827,1.4033645,19.6720431),(14774,'metacarpus.tif',40,5,283,16.2012576,6.5771816,10.5076468,1.8,6.7118698,10.4937998,-1.457764,1.9649474,3.5737952,13.4948474,46.7933748,2.6658576,13.0934686,6.8677906,16.4352979,3.9720658,6.8212471,1.3625904,18.9617536),(14775,'metacarpus.tif',40,5,284,16.244558,6.5788587,10.5055351,1.8,6.706515,10.4954719,-1.4583339,1.9880448,3.5815858,13.5324925,46.9635183,2.6733275,13.1124927,6.8069354,16.3587159,3.9811032,6.8024388,1.3761108,19.250431),(14776,'metacarpus.tif',40,5,285,16.2107323,6.5804496,10.5040342,1.8,6.7074429,10.4882145,-1.4595299,2.0113068,3.5579389,13.4527561,46.7093977,2.6684778,13.1282181,6.6885648,16.5110467,3.9868244,6.7685827,1.4033645,19.9607205),(14777,'metacarpus.tif',40,5,286,16.2209403,6.5812694,10.5076349,1.8,6.70902,10.4908962,-1.4606504,2.0028861,3.5605996,13.4597749,46.6822088,2.6708234,13.1107718,6.7201898,16.4919154,3.9868244,6.7848808,1.3897037,19.1403043),(14778,'metacarpus.tif',40,5,287,16.2430416,6.5847323,10.5038047,1.8,6.7123888,10.4940547,-1.460064,1.9950976,3.5672309,13.4191172,46.8425904,2.6741146,13.1313593,6.7260453,16.4556045,3.9868244,6.8024388,1.3761108,19.227623),(14779,'metacarpus.tif',40,5,288,16.1753662,6.5865086,10.5063289,1.8,6.7196815,10.4885929,-1.460669,1.9873014,3.5690429,13.2760971,46.5117676,2.6633304,13.0320001,6.6804648,16.3182316,3.9627005,6.8464596,1.4191908,19.7176591),(14780,'metacarpus.tif',40,5,289,16.1781403,6.5847327,10.5087208,1.8,6.7097005,10.4881702,-1.461089,1.9544937,3.5712668,13.283387,46.5587701,2.6640342,13.0370462,6.7963314,16.3203739,3.9101425,6.7685827,1.4033645,19.1725597),(14781,'metacarpus.tif',40,5,290,16.2241998,6.5900935,10.5102276,1.8,6.7167706,10.4949851,-1.4614195,1.9600957,3.5719045,13.3646473,46.5775339,2.671813,13.0399719,6.8183648,16.3492312,3.9412113,6.7848808,1.3897037,19.5391084),(14782,'metacarpus.tif',40,5,291,16.1919866,6.592866,10.5099579,1.8,6.7182881,10.5018426,-1.4658055,1.9543916,3.5578338,13.310263,46.3350982,2.669026,13.0234017,6.810438,16.3661377,3.9210387,6.7685827,1.4033645,19.039625),(14783,'metacarpus.tif',40,5,292,16.208528,6.5990843,10.5092738,1.8,6.7280278,10.4979747,-1.4650844,1.970123,3.5570346,13.3527628,46.6029134,2.6713452,13.1016193,6.777629,16.4648905,3.9558085,6.8024388,1.3761108,19.1953677),(14784,'metacarpus.tif',40,5,293,16.1448481,6.601708,10.5020647,1.8,6.7313102,10.4886971,-1.4650208,1.9620261,3.5694843,13.184455,46.410737,2.6608141,13.0020847,6.7198163,16.1646308,3.9558085,6.8212471,1.3625904,19.1953677),(14785,'metacarpus.tif',40,5,294,16.0613505,6.6011168,10.5040601,1.8,6.727311,10.4903164,-1.4649658,1.9516964,3.5715817,13.0605595,46.1241819,2.647022,12.9142171,6.6919014,16.0442656,3.9313857,6.8212471,1.3625904,19.062433),(14786,'metacarpus.tif',40,5,295,16.0378588,6.6022622,10.5062434,1.8,6.7294625,10.4815799,-1.4664782,1.9440513,3.5624462,13.0306038,46.0353459,2.6439938,12.9223973,6.7028087,16.1444458,3.9249552,6.7848808,1.3897037,19.296047),(14787,'metacarpus.tif',40,5,296,16.0640995,6.6046576,10.5083125,1.8,6.7327588,10.490417,-1.4692483,1.938779,3.5619401,13.0103782,46.1188274,2.6498358,12.9476708,6.7106041,16.1565667,3.9141838,6.8024388,1.3761108,19.2181756),(14788,'metacarpus.tif',40,5,297,16.0705412,6.6062656,10.5106074,1.8,6.7319756,10.5003302,-1.4703758,1.9602324,3.5631123,13.0294624,46.0769108,2.6515042,12.9316472,6.6468966,16.1430796,3.9130276,6.8024388,1.3761108,19.484045),(14789,'metacarpus.tif',40,5,298,16.0814165,6.6106082,10.5108611,1.8,6.7382526,10.4984641,-1.4727448,1.9381481,3.5517312,13.0245223,46.0989205,2.6545505,12.9792818,6.7200862,16.2842012,3.8966425,6.7848808,1.3897037,19.062433),(14790,'metacarpus.tif',40,5,299,16.0770817,6.6131321,10.5073224,1.8,6.7391359,10.4944515,-1.4725272,1.9585887,3.5481258,12.9556213,46.0012259,2.6537212,12.9649365,6.6147739,16.22244,3.9210387,6.8024388,1.3761108,19.1174963),(14791,'metacarpus.tif',40,5,300,16.0571652,6.6149137,10.5060796,1.8,6.7436126,10.4865096,-1.4725497,1.9510329,3.5559177,12.9154763,46.0128388,2.6504455,12.939793,6.6198148,16.1257073,3.8904713,6.8212471,1.3625904,18.9617536),(14792,'metacarpus.tif',40,5,301,16.0441701,6.6150096,10.5117455,1.8,6.7441157,10.489696,-1.473793,1.9434252,3.5696016,12.903187,45.9427973,2.6489455,12.870567,6.639405,15.942262,3.8992831,6.8024388,1.3761108,19.273239),(14793,'metacarpus.tif',40,5,302,16.0817992,6.6144347,10.5126794,1.8,6.7429667,10.4959865,-1.4736542,1.9337194,3.5524835,12.9372653,45.9539826,2.6550864,12.9357344,6.6903528,16.1845025,3.9130276,6.7685827,1.4033645,19.3283024),(14794,'metacarpus.tif',40,5,303,16.0633596,6.6170235,10.5132984,1.8,6.7429641,10.4919502,-1.4750892,1.9158869,3.5517688,12.9137196,45.8783625,2.6527784,12.9170464,6.7403349,16.1911919,3.8915384,6.7848808,1.3897037,19.1631123),(14795,'metacarpus.tif',40,5,304,16.0735613,6.6192003,10.515607,1.8,6.7416052,10.4987622,-1.4778859,1.9098315,3.5430193,12.9006111,45.9634707,2.6558679,12.9729665,6.7548427,16.3257031,3.8915384,6.7685827,1.4033645,19.4061737),(14796,'metacarpus.tif',40,5,305,16.0424671,6.6235495,10.5102883,1.8,6.747905,10.498276,-1.478944,1.9052529,3.5538581,12.7417262,45.8635809,2.6512499,12.9052931,6.6876825,16.0321055,3.8539601,6.7535537,1.4170888,18.9845616),(14797,'metacarpus.tif',40,5,306,16.0092716,6.6249902,10.5119323,1.8,6.7490963,10.4911125,-1.4764036,1.9061054,3.5575221,12.6772238,45.7740757,2.6445087,12.8668421,6.6508514,15.9851987,3.8426733,6.8024388,1.3761108,18.7737556),(14798,'metacarpus.tif',40,5,307,16.0010905,6.6275202,10.5161032,1.8,6.7513518,10.4961232,-1.4809612,1.9364609,3.5575593,12.6517422,45.7601999,2.6453839,12.8628072,6.5334353,15.9607444,3.8634834,6.8024388,1.3761108,19.3283024),(14799,'metacarpus.tif',40,5,308,16.0092875,6.6290799,10.5156721,1.8,6.756322,10.4902493,-1.4785881,1.9787871,3.5503591,12.664335,45.7580733,2.6455927,12.8882945,6.4000495,16.0677365,3.9165508,6.7535537,1.4170888,19.250431),(14800,'metacarpus.tif',40,5,309,15.9822781,6.6294572,10.51713,1.8,6.7541586,10.4945365,-1.4809201,1.9721874,3.5500066,12.6631032,45.6449309,2.6422541,12.8577033,6.4208418,16.0309418,3.9016267,6.8024388,1.3761108,19.1953677),(14801,'metacarpus.tif',40,5,310,15.9954815,6.6309511,10.5174399,1.8,6.7541709,10.4952396,-1.4826744,1.906042,3.54884,12.6447166,45.7099704,2.645265,12.8802568,6.6340179,16.071642,3.8539601,6.7535537,1.4170888,19.1403043),(14802,'metacarpus.tif',40,5,311,15.9704341,6.6332996,10.5101795,1.8,6.7578057,10.4867161,-1.4816864,1.8990057,3.5337909,12.5083195,45.6809344,2.6406591,12.9268923,6.5867731,16.1793154,3.8426733,6.7535537,1.4170888,19.0073696),(14803,'metacarpus.tif',40,5,312,15.9172941,6.632266,10.5163409,1.8,6.7513915,10.4946876,-1.4845519,1.916041,3.5461843,12.456051,45.5471089,2.6331988,12.8439767,6.5009315,15.9549364,3.8539601,6.7848808,1.3897037,19.1403043),(14804,'metacarpus.tif',40,5,313,15.8832157,6.6364241,10.5192139,1.8,6.7606241,10.4935705,-1.4878203,1.9135097,3.5539479,12.3468622,45.5216879,2.6290184,12.8087662,6.4524692,15.8118285,3.8494547,6.7848808,1.3897037,19.1403043),(14805,'metacarpus.tif',40,5,314,15.9428215,6.6348441,10.5210174,1.8,6.7593807,10.4997886,-1.4854002,1.9032034,3.5419494,12.4654464,45.5872155,2.6378068,12.8706568,6.5497184,16.0965411,3.8539601,6.7705405,1.5430257,18.9294983),(14806,'metacarpus.tif',40,5,315,15.9253176,6.6343502,10.5252883,1.8,6.7570235,10.5092185,-1.4884196,1.9044213,3.5441789,12.4864275,45.4539223,2.636249,12.8249516,6.5565468,16.0465138,3.8366889,6.7293062,1.359703,18.9066903),(14807,'metacarpus.tif',40,5,316,15.9503555,6.637488,10.5214264,1.8,6.7611705,10.495192,-1.4885128,1.9149982,3.5554594,12.4990175,45.7339493,2.6404343,12.8630211,6.5269082,15.9037576,3.8474872,6.8024388,1.3761108,18.7965636),(14808,'metacarpus.tif',40,5,317,15.9040118,6.6412909,10.5184077,1.8,6.7652964,10.4905972,-1.489962,1.9114645,3.5432814,12.3972699,45.5135475,2.6333863,12.8450275,6.4857442,15.9587494,3.8420796,6.7783662,1.5152978,19.1631123),(14809,'metacarpus.tif',40,5,318,15.8673795,6.6398871,10.5216859,1.8,6.7617793,10.4993011,-1.4911155,1.9033588,3.5457553,12.3623931,45.5707513,2.6278083,12.8521985,6.4950408,15.9493165,3.831458,6.7293062,1.359703,18.9845616),(14810,'metacarpus.tif',40,5,319,15.8410223,6.6409539,10.5230538,1.8,6.7592413,10.4968419,-1.4953032,1.8854825,3.5437065,12.2727452,45.5170509,2.6251521,12.8444753,6.5090741,15.9054994,3.8163724,6.7293062,1.359703,18.9294983),(14811,'metacarpus.tif',40,5,320,15.8576882,6.6408099,10.5271325,1.8,6.7622123,10.5099275,-1.4935587,1.8987484,3.5419249,12.296976,45.4095174,2.6272124,12.8205761,6.4763589,15.98162,3.8273295,6.7783662,1.5152978,19.7727224),(14812,'metacarpus.tif',40,5,321,15.8413141,6.6410709,10.529286,1.8,6.7617402,10.5066324,-1.4943183,1.8924611,3.5435179,12.3144567,45.40788,2.6248068,12.8143503,6.5071123,15.9771422,3.8040035,6.716163,1.4585935,18.7737556),(14813,'metacarpus.tif',40,5,322,15.8774759,6.6440433,10.5273499,1.8,6.7568287,10.5109202,-1.4960377,1.9175594,3.5541906,12.3150532,45.6200713,2.6314841,12.8355726,6.4222539,15.8071315,3.8539601,6.7398023,1.4308717,18.8288189),(14814,'metacarpus.tif',40,5,323,15.8909203,6.6454659,10.5229202,1.8,6.7599654,10.5099601,-1.4952346,1.925396,3.5503837,12.274282,45.5527374,2.6333938,12.8303704,6.374939,15.7976886,3.8297911,6.7998405,1.4738787,19.0946883),(14815,'metacarpus.tif',40,5,324,15.8407677,6.64594,10.5263339,1.8,6.7580556,10.5097239,-1.4974577,1.9199809,3.5311013,12.1938827,45.5229287,2.6259533,12.8919916,6.3510439,16.0058373,3.8093222,6.7705405,1.5430257,18.9294983),(14816,'metacarpus.tif',40,5,325,15.8192122,6.6499688,10.5274031,1.8,6.7637817,10.5089886,-1.5008032,1.918913,3.5429503,12.1052748,45.5023091,2.62364,12.8430559,6.308402,15.8487025,3.8202634,6.7998405,1.4738787,19.0073696),(14817,'metacarpus.tif',40,5,326,15.8498802,6.6493576,10.530275,1.8,6.7636106,10.5115545,-1.4992512,1.9109924,3.5471148,12.1590983,45.5324623,2.628148,12.8364785,6.3627142,15.8590417,3.8291863,6.7842296,1.5014632,19.039625),(14818,'metacarpus.tif',40,5,327,15.8251026,6.6503368,10.5315969,1.8,6.7648023,10.5073689,-1.5006719,1.9063342,3.527456,12.115462,45.4370309,2.6245685,12.8809633,6.3553713,15.9451574,3.8081426,6.716163,1.4585935,18.9294983),(14819,'metacarpus.tif',40,5,328,15.8611425,6.6533229,10.5298606,1.8,6.7647181,10.5111468,-1.502944,1.904398,3.5434279,12.1245706,45.6993744,2.6313718,12.8969391,6.3666157,15.9022027,3.8081426,6.7842296,1.5014632,18.9066903),(14820,'metacarpus.tif',40,5,329,15.8483165,6.6556375,10.5284011,1.8,6.7723857,10.5121245,-1.5014623,1.9184621,3.5430171,12.0964011,45.614938,2.6287087,12.8746027,6.3052593,15.8802644,3.8420796,6.791389,1.4876551,19.4517897),(14821,'metacarpus.tif',40,5,330,15.8200212,6.65577,10.5307989,1.8,6.7783695,10.517281,-1.5028309,1.913198,3.5379064,12.1000731,45.7130088,2.6245094,12.9209208,6.3245275,16.0132156,3.8439639,6.7842296,1.5014632,19.0852409),(14822,'metacarpus.tif',40,5,331,15.8342623,6.6560576,10.5282015,1.8,6.7746228,10.5039756,-1.5047931,1.8456736,3.533877,12.0913785,45.831629,2.6275636,12.9692202,6.5512009,16.0551389,3.7599611,6.7705405,1.5430257,18.7509476),(14823,'metacarpus.tif',40,5,332,15.8579256,6.6565564,10.5312036,1.8,6.7781797,10.5116195,-1.5031772,1.8522219,3.5380077,12.1528415,45.8295661,2.6309213,12.9534953,6.5612233,16.0593082,3.7599611,6.7705405,1.5430257,18.6958842),(14824,'metacarpus.tif',40,5,333,15.8455592,6.6552139,10.532891,1.8,6.7726129,10.5096702,-1.5050316,1.8452138,3.5507933,12.1880997,45.7933502,2.629521,12.8966535,6.6052506,15.8122248,3.7498887,6.7842296,1.5014632,18.4622702),(14825,'metacarpus.tif',40,5,334,15.8788115,6.6573797,10.5321134,1.8,6.7752358,10.5116652,-1.5053689,1.8474269,3.543421,12.2160703,46.080703,2.6351559,13.0045804,6.6124783,16.0279058,3.7599611,6.7783662,1.6262948,19.1403043),(14826,'metacarpus.tif',40,5,335,15.8505917,6.6592268,10.5292573,1.8,6.7785778,10.5095768,-1.5053513,1.8429306,3.5404647,12.118646,45.8842993,2.6304666,12.9599652,6.5757474,15.961462,3.7456533,6.7783662,1.6262948,18.9294983),(14827,'metacarpus.tif',40,5,336,15.8022739,6.6560864,10.5308189,1.8,6.7712154,10.5118049,-1.5059959,1.8523304,3.5416977,12.0643428,45.8179174,2.6226686,12.9367103,6.513062,15.9177285,3.7599611,6.7842296,1.5014632,19.039625),(14828,'metacarpus.tif',40,5,337,15.7893363,6.6588703,10.5337465,1.8,6.7773298,10.5123962,-1.5089238,1.850089,3.5362069,11.9577787,45.9896041,2.6214948,13.0053488,6.4633533,16.0414348,3.7351301,6.7783662,1.6262948,18.8060109),(14829,'metacarpus.tif',40,5,338,15.7349935,6.6552645,10.537098,1.8,6.7670236,10.5153751,-1.5102186,1.9124487,3.5388123,11.8647099,45.6942628,2.612887,12.912316,6.2039364,15.915467,3.7973842,6.7705405,1.5430257,19.062433),(14830,'metacarpus.tif',40,5,339,15.7243588,6.654293,10.5427886,1.8,6.7716676,10.517924,-1.5122243,1.9078418,3.5430471,11.9053408,45.6575071,2.6117459,12.8865087,6.2402138,15.8912965,3.814717,6.7842296,1.5014632,19.273239),(14831,'metacarpus.tif',40,5,340,15.7459477,6.6553954,10.5432832,1.8,6.7696913,10.5232082,-1.514022,1.8486514,3.5367842,11.8783902,45.9248065,2.6158746,12.984905,6.4254353,15.9737529,3.7280757,6.7783662,1.6262948,18.9845616),(14832,'metacarpus.tif',40,5,341,15.7265198,6.6568029,10.54331,1.8,6.7739473,10.5226903,-1.5149023,1.933652,3.5361456,11.8431547,45.7798655,2.6129065,12.9462616,6.1247601,15.9259735,3.8178851,6.7738023,1.6124389,18.8060109),(14833,'metacarpus.tif',40,5,342,15.6985355,6.6558566,10.5430559,1.8,6.7741851,10.5209075,-1.5133924,1.9265889,3.5477346,11.8030403,45.9454543,2.6078104,12.9506459,6.1263928,15.829654,3.8229095,6.7998405,1.4738787,19.1403043),(14834,'metacarpus.tif',40,5,343,15.6850139,6.6554941,10.545433,1.8,6.7684874,10.523517,-1.5165025,1.8393484,3.5321642,11.7222372,45.941029,2.6064704,13.0064819,6.373038,16.0644101,3.7409953,6.7783662,1.6262948,19.2181756),(14835,'metacarpus.tif',40,5,344,15.7004,6.6535976,10.5489036,1.8,6.7694377,10.5183274,-1.5145977,1.8420521,3.552673,11.745174,45.896848,2.6084776,12.9189622,6.3761357,15.773442,3.7491892,6.7842296,1.5014632,19.3511103),(14836,'metacarpus.tif',40,5,345,15.6947517,6.6536975,10.5512535,1.8,6.7712763,10.5139049,-1.5170119,1.8381008,3.5529368,11.7868726,46.0297039,2.6082324,12.9553961,6.4125278,15.8115973,3.7374607,6.8095791,1.4601391,19.3739183),(14837,'metacarpus.tif',40,5,346,15.6881195,6.6549595,10.5515985,1.8,6.7702152,10.5267699,-1.5188023,1.8499559,3.5467772,11.7485145,46.0852654,2.6076245,12.9935607,6.3506998,15.9295049,3.7557455,6.7998405,1.4738787,19.4517897),(14838,'metacarpus.tif',40,5,347,15.6670553,6.6548867,10.5522895,1.8,6.7644836,10.5296142,-1.5188555,1.8450528,3.5474297,11.6783678,46.0485099,2.6041377,12.9808097,6.3295574,15.897058,3.7557455,6.8722225,1.5160565,19.3739183),(14839,'metacarpus.tif',40,5,348,15.6083158,6.6536019,10.5527382,1.8,6.7662083,10.5318076,-1.5175998,1.8433478,3.5489176,11.6069903,46.0174014,2.5940313,12.9666018,6.2966903,15.8654609,3.7194808,6.8095791,1.4601391,18.9294983),(14840,'metacarpus.tif',40,5,349,15.6314611,6.652288,10.5558142,1.8,6.7616002,10.531508,-1.5203837,1.8384369,3.5451543,11.598225,46.2340114,2.5986281,13.0414667,6.3087425,16.0126802,3.7150528,6.7998405,1.4738787,19.062433),(14841,'metacarpus.tif',40,5,350,15.6106119,6.6491807,10.5582534,1.8,6.7575481,10.5346825,-1.5208453,1.8403521,3.5474268,11.5909508,46.0041869,2.5952823,12.9683259,6.2982245,15.9332894,3.6992938,6.7842296,1.5014632,18.9066903),(14842,'metacarpus.tif',40,5,351,15.6266131,6.6499627,10.5581677,1.8,6.7633677,10.5281062,-1.521516,1.8413592,3.556097,11.6127685,46.2786035,2.5981156,13.0138754,6.3066285,15.798793,3.7056129,6.8095791,1.4601391,18.9617536),(14843,'metacarpus.tif',40,5,352,15.6689974,6.650846,10.5559816,1.8,6.7633352,10.5225233,-1.5219592,1.8468753,3.5534783,11.6468834,46.4488427,2.6052759,13.0713737,6.3062641,15.864728,3.742651,6.8095791,1.4601391,18.9294983),(14844,'metacarpus.tif',40,5,353,15.6426712,6.650906,10.5603287,1.8,6.7624031,10.5347564,-1.5245748,1.8390982,3.5424622,11.5631117,46.3517649,2.6015459,13.084618,6.2873812,16.0647736,3.7075748,6.8645038,1.5434059,18.9294983),(14845,'metacarpus.tif',40,5,354,15.6209767,6.6474065,10.5622725,1.8,6.758258,10.5312589,-1.5248942,1.844455,3.5529954,11.5078602,46.4682409,2.5980144,13.0786101,6.2391656,15.9148202,3.665962,6.8722225,1.5160565,19.2409836),(14846,'metacarpus.tif',40,5,355,15.6436413,6.6487675,10.5645568,1.8,6.7608186,10.5382779,-1.5252952,1.8417383,3.5548926,11.4869044,46.7090262,2.6018793,13.1393636,6.2369904,15.967092,3.665962,6.8722225,1.6255361,19.296047),(14847,'metacarpus.tif',40,5,356,15.6240259,6.6470028,10.5686267,1.8,6.7600283,10.536613,-1.5250888,1.8443885,3.5463198,11.4600552,46.4359332,2.5985679,13.0941188,6.2134715,16.0190546,3.7157752,6.8722225,1.6255361,19.4517897),(14848,'metacarpus.tif',40,5,357,15.6509226,6.6446132,10.573779,1.8,6.7562985,10.5459412,-1.5276769,1.8387649,3.5623596,11.5036825,46.6223076,2.6036402,13.0874793,6.2562009,15.9042952,3.7157752,6.8645038,1.5434059,19.9284651),(14849,'metacarpus.tif',40,5,358,15.6842911,6.6448611,10.571863,1.8,6.7555028,10.5382971,-1.5284913,1.839188,3.5597688,11.541073,46.7862655,2.6093729,13.1430631,6.2750915,15.967746,3.7050323,6.8645038,1.5434059,18.9845616),(14850,'metacarpus.tif',40,5,359,15.6690297,6.6472188,10.5746156,1.8,6.7580828,10.5453062,-1.529579,1.8381265,3.5576553,11.4847848,46.6822429,2.6070709,13.1216317,6.2480927,16.0190271,3.7050323,6.8625728,1.5844941,19.1725597),(14851,'metacarpus.tif',40,5,360,15.6003847,6.646881,10.5689369,1.8,6.7587372,10.5388964,-1.5289533,1.8412296,3.5524498,11.3626511,46.7033769,2.5955145,13.1468085,6.1712298,16.015164,3.665962,6.8645038,1.5434059,19.227623),(14852,'metacarpus.tif',40,5,361,15.5932522,6.6452707,10.5719984,1.8,6.7525011,10.5469069,-1.5307041,1.83653,3.5618336,11.3101605,46.8043678,2.5947002,13.1405261,6.1584404,15.7967685,3.665962,6.8722225,1.6255361,19.296047),(14853,'metacarpus.tif',40,5,362,15.5751164,6.6420423,10.5754646,1.8,6.7514131,10.5516286,-1.5298442,1.8292482,3.5662195,11.3080752,46.7192066,2.5915017,13.1004855,6.1818158,15.7548455,3.665962,6.8722225,1.6255361,19.016817),(14854,'metacarpus.tif',40,5,363,15.5646142,6.6417601,10.5717475,1.8,6.7504458,10.5471063,-1.5292588,1.836327,3.5591522,11.3356462,46.9722748,2.5896292,13.1976022,6.1729998,15.9593174,3.665962,6.8722225,1.6255361,19.3511103),(14855,'metacarpus.tif',40,5,364,15.5988414,6.6415738,10.5722025,1.8,6.7513775,10.5424122,-1.5307758,1.8366343,3.5583586,11.3545018,47.1115,2.5956452,13.2396718,6.1822335,16.0004472,3.665962,6.8722225,1.6255361,19.273239),(14856,'metacarpus.tif',40,5,365,15.5619338,6.640406,10.5747036,1.8,6.7480838,10.5460509,-1.5320678,1.8323254,3.5598269,11.3045933,46.8347611,2.5897674,13.1564716,6.1695338,15.8992108,3.665962,6.8780059,1.6391827,19.273239),(14857,'metacarpus.tif',40,5,366,15.5252586,6.6388609,10.571609,1.8,6.7506737,10.5453207,-1.5305105,1.8262454,3.5543093,11.2349421,46.8438396,2.5833459,13.1794494,6.1519346,15.9986854,3.7168837,6.8722225,1.6255361,19.2181756),(14858,'metacarpus.tif',40,5,367,15.5442325,6.6372128,10.5763721,1.8,6.7483342,10.5445452,-1.5327698,1.8259051,3.5610276,11.2267329,46.9793071,2.586961,13.1926265,6.1485853,15.9067489,3.665962,6.8780059,1.50241,19.062433),(14859,'metacarpus.tif',40,5,368,15.5304216,6.6341197,10.5814198,1.8,6.7401104,10.5587776,-1.5318793,1.8262298,3.5669402,11.2466354,46.8622868,2.5844853,13.1379514,6.1583902,15.8555508,3.665962,6.867721,1.5297235,19.227623),(14860,'metacarpus.tif',40,5,369,15.5445937,6.6331182,10.5822815,1.8,6.7404275,10.5569429,-1.5329357,1.8256766,3.56339,11.2905192,47.0747873,2.5870537,13.210675,6.1842931,16.0257493,3.6898172,6.8780059,1.50241,19.3511103),(14861,'metacarpus.tif',40,5,370,15.5425674,6.6353013,10.5825658,1.8,6.7473569,10.5590949,-1.5354473,1.8255225,3.5616959,11.2827321,47.2066164,2.5871924,13.2539717,6.1805493,16.0609335,3.7050323,6.8780059,1.50241,19.8049778),(14862,'metacarpus.tif',40,5,371,15.5019301,6.6341703,10.5828747,1.8,6.7394231,10.5543215,-1.5344223,1.8273288,3.562822,11.2278041,47.09826,2.5802382,13.2193692,6.1443809,16.0135701,3.7029312,6.8780059,1.6391827,19.1403043),(14863,'metacarpus.tif',40,5,372,15.4792553,6.6307118,10.5800036,1.8,6.7331987,10.5544146,-1.5347029,1.8306616,3.5666492,11.1970126,47.319691,2.5765164,13.2672681,6.1163748,15.8548562,3.665962,6.903011,1.4616429,19.5847244),(14864,'metacarpus.tif',40,5,373,15.4722166,6.6321708,10.5824999,1.8,6.7421921,10.5488945,-1.5364516,1.8293283,3.564201,11.176937,47.4088408,2.5756622,13.3013938,6.1098583,15.9788543,3.665962,6.8934044,1.4751982,19.1953677),(14865,'metacarpus.tif',40,5,374,15.4617068,6.629337,10.589389,1.8,6.7382052,10.559942,-1.5365747,1.8235515,3.5710771,11.1691994,47.3631796,2.5739344,13.2629955,6.1249706,15.9321498,3.665962,6.9660826,1.5167948,19.273239),(14866,'metacarpus.tif',40,5,375,15.4713565,6.6263658,10.5902154,1.8,6.7359797,10.5645778,-1.5357589,1.8203028,3.5694171,11.2188777,47.4741765,2.5753952,13.3002604,6.1631931,16.0745075,3.665962,6.8934044,1.4751982,19.1953677),(14867,'metacarpus.tif',40,5,376,15.5140086,6.6282687,10.5891131,1.8,6.7424692,10.5587097,-1.5369482,1.8257963,3.5673339,11.2619879,47.8276815,2.5827068,13.4071222,6.168261,16.1899324,3.665962,6.8934044,1.6663944,19.4061737),(14868,'metacarpus.tif',40,5,377,15.4778131,6.628393,10.5903294,1.8,6.7413865,10.5557681,-1.537896,1.8200436,3.5678128,11.2080219,47.6741948,2.5768442,13.3623027,6.1581063,16.1280148,3.663589,6.9660826,1.5167948,19.6492351),(14869,'metacarpus.tif',40,5,378,15.4570999,6.6272437,10.5899505,1.8,6.7381693,10.5581234,-1.5374697,1.8155507,3.5740664,11.1832915,47.9422883,2.5733231,13.4139334,6.1597243,15.9742703,3.665962,6.9660826,1.5167948,19.4061737),(14870,'metacarpus.tif',40,5,379,15.2625637,6.6068773,10.5946156,1.8,6.6691612,10.5691084,-1.5408153,1.8000235,3.5704655,10.6881575,47.8431242,2.5414748,13.3996882,5.9377876,15.9904418,3.5664975,6.958468,1.5437759,19.1725597),(14871,'metacarpus.tif',40,5,380,15.2528958,6.6055711,10.6029216,1.8,6.6699693,10.5744854,-1.5427777,1.7972114,3.5772155,10.6918381,47.7689288,2.5401541,13.3536625,5.9491264,15.9347433,3.571963,6.9717881,1.5033313,19.016817),(14872,'metacarpus.tif',40,5,381,15.3036873,6.6026764,10.6055106,1.8,6.6672999,10.582104,-1.541273,1.7908057,3.5838851,10.7806369,48.1604822,2.548392,13.4380653,6.0199924,15.9447194,3.5628935,6.9660826,1.5167948,19.1497517),(14873,'metacarpus.tif',40,5,382,15.3310483,6.6020481,10.6117787,1.8,6.66612,10.5829246,-1.5447427,1.7998745,3.5870028,10.8012334,48.251604,2.5534407,13.4517887,6.0011037,15.9481886,3.5664975,6.9660826,1.6247978,19.4061737),(14874,'metacarpus.tif',40,5,383,15.311214,6.6010686,10.609984,1.8,6.6642146,10.5758042,-1.5445396,1.7963115,3.585421,10.7514437,48.2314488,2.5501101,13.4521019,5.9852891,15.9355755,3.571963,6.9717881,1.6382614,19.3283024),(14875,'metacarpus.tif',40,5,384,15.2994829,6.5975486,10.606603,1.8,6.6609609,10.5727289,-1.5429647,1.7946269,3.5835822,10.7094231,48.4651297,2.5479392,13.5242132,5.9674927,15.997238,3.5628935,6.9717881,1.5033313,19.0718803),(14876,'metacarpus.tif',40,5,385,15.2910386,6.5961158,10.6121742,1.8,6.6592979,10.58388,-1.544801,1.7915309,3.5850556,10.7023855,48.42848,2.5467847,13.5084321,5.973877,16.0678003,3.5632164,6.9660826,1.6247978,18.7832029),(14877,'metacarpus.tif',40,5,386,15.25347,6.5972225,10.6164478,1.8,6.6620864,10.5882267,-1.5465889,1.7935111,3.5878098,10.6811109,48.3827414,2.5407555,13.4853139,5.9554196,16.032776,3.568138,6.9717881,1.6382614,19.4612371),(14878,'metacarpus.tif',40,5,387,15.2586627,6.5933648,10.6178981,1.8,6.6602227,10.583881,-1.54552,1.7916117,3.5926246,10.7327356,48.5404596,2.541486,13.5111418,5.9905478,15.9720467,3.5664975,6.9787552,1.4898922,18.9389456),(14879,'metacarpus.tif',40,5,388,15.2653335,6.5932086,10.6203509,1.8,6.6560454,10.5908233,-1.5478537,1.7901239,3.5950564,10.7594736,48.6010478,2.5428833,13.5188553,6.0104632,15.870147,3.5615759,6.98698,1.6651103,19.0490723),(14880,'metacarpus.tif',40,5,389,15.246957,6.59416,10.621191,1.8,6.659021,10.5954083,-1.5474388,1.7909207,3.5941067,10.7310099,48.6973215,2.5397734,13.5492142,5.9918956,16.0011413,3.5664975,6.98698,1.4764824,19.3605577),(14881,'metacarpus.tif',40,5,390,15.2090149,6.5939483,10.6182665,1.8,6.6610439,10.589249,-1.5478624,1.7886636,3.5907911,10.6665377,48.8303269,2.5335028,13.5987658,5.9634119,16.0314807,3.477964,6.98698,1.4764824,19.016817),(14882,'metacarpus.tif',40,5,391,15.2015344,6.5932258,10.6237666,1.8,6.6592811,10.5906312,-1.549671,1.7929568,3.5946031,10.6595715,48.8730903,2.5324585,13.596241,5.9452474,16.017445,3.477964,6.98698,1.4764824,19.1269437),(14883,'metacarpus.tif',40,5,392,15.1868915,6.591406,10.6260318,1.8,6.6535756,10.5861126,-1.5514475,1.7899247,3.5952187,10.6630498,48.884969,2.5302011,13.5972171,5.9572618,16.010041,3.5633572,6.9964581,1.4631065,18.8610743),(14884,'metacarpus.tif',40,5,393,15.1997564,6.5874838,10.6284195,1.8,6.6528255,10.5929809,-1.5516632,1.7861365,3.5974753,10.7318448,49.0394777,2.5323655,13.6316372,6.0084124,16.0555084,3.5633572,6.9964581,1.4631065,19.3054944),(14885,'metacarpus.tif',40,5,394,15.2308454,6.5870141,10.6342349,1.8,6.6533907,10.5992737,-1.553618,1.7881673,3.6014187,10.7824047,49.2275681,2.5377252,13.6689378,6.0298635,16.0948856,3.5628935,6.9964581,1.4631065,19.204815),(14886,'metacarpus.tif',40,5,395,15.2101183,6.5876586,10.630948,1.8,6.6536211,10.5903216,-1.5534532,1.787075,3.6890047,10.7496515,49.3410434,2.5342573,13.375164,6.0152213,15.9416669,3.5633572,7.1463993,1.597106,19.4612371),(14887,'metacarpus.tif',40,5,396,15.1650068,6.5858199,10.6275405,1.8,6.6515775,10.5978171,-1.5533767,1.7835094,3.5933416,10.6722225,49.3701456,2.5267343,13.7393412,5.9838331,16.238426,3.5658178,6.98698,1.6651103,19.1269437),(14888,'metacarpus.tif',40,5,397,15.1783591,6.5854985,10.6290047,1.8,6.65337,10.5848188,-1.5532266,1.7831394,3.6856236,10.6725522,49.5190867,2.5289457,13.4357416,5.9852597,16.0470375,3.5658178,7.0655762,1.6373645,19.1041357),(14889,'metacarpus.tif',40,5,398,15.1641507,6.5858859,10.631827,1.8,6.6549372,10.60012,-1.5548315,1.7858634,3.5993559,10.6536198,49.6167651,2.5267143,13.7849012,5.965529,16.0569986,3.5632164,7.0655762,1.6373645,19.1497517),(14890,'metacarpus.tif',40,5,399,15.1844082,6.5803412,10.6373184,1.8,6.6458676,10.6048673,-1.5552118,1.77909,3.603063,10.7629595,49.7620424,2.5301201,13.8110386,6.0496993,16.21212,3.5658178,7.0599465,1.6240792,19.3377497),(14891,'metacarpus.tif',40,5,400,15.1888534,6.5810175,10.6409903,1.8,6.65138,10.6082536,-1.5565892,1.7831519,3.605375,10.7833696,49.8734185,2.5309646,13.8330739,6.0473646,16.2328909,3.5559754,7.0599465,1.6240792,19.5713638),(14892,'metacarpus.tif',40,5,401,15.2038916,6.5798873,10.6384361,1.8,6.6478761,10.6078099,-1.5555734,1.7802583,3.6052646,10.8187668,50.1831764,2.5333948,13.9194158,6.0770771,16.2168936,3.5628935,7.0724508,1.4909663,19.2921338),(14893,'metacarpus.tif',40,5,402,15.1739367,6.577651,10.6365108,1.8,6.6472679,10.6141845,-1.5546076,1.777617,3.602889,10.7838798,50.2337801,2.5283267,13.9426389,6.0664811,16.3442147,3.5633572,7.0655762,1.5042282,19.182007),(14894,'metacarpus.tif',40,5,403,15.1533252,6.5780096,10.6385691,1.8,6.6502889,10.6003933,-1.5566831,1.777484,3.6942408,10.725995,50.2687167,2.5250512,13.60732,6.0343695,16.1404585,3.477964,7.1494896,1.5313431,18.8933297),(14895,'metacarpus.tif',40,5,404,15.1430908,6.5769562,10.6378016,1.8,6.648176,10.6008416,-1.5576344,1.776875,3.6927284,10.7403693,50.4004352,2.5234113,13.6485627,6.0445274,16.1813074,3.477964,7.1538138,1.5182133,19.1041357),(14896,'metacarpus.tif',40,5,405,15.1519378,6.5720423,10.6402401,1.8,6.6399904,10.6125032,-1.5558362,1.7725427,3.6966735,10.8160673,50.5753285,2.5247578,13.6813081,6.1020065,16.2326666,3.5632164,7.1538138,1.5182133,19.0262644),(14897,'metacarpus.tif',40,5,406,15.1623466,6.5712146,10.6421714,1.8,6.6421205,10.6146427,-1.5587658,1.7717255,3.6951282,10.8586789,50.6728149,2.526692,13.7134118,6.1288721,16.3477295,3.5628935,7.1538138,1.6233794,19.2598784),(14898,'metacarpus.tif',40,5,407,15.1501014,6.5736725,10.6394238,1.8,6.645653,10.6094234,-1.5576692,1.7736294,3.6931318,10.8286133,51.019713,2.5245818,13.8147555,6.1053415,16.4296241,3.5628935,7.1593697,1.6364911,19.3700051),(14899,'metacarpus.tif',40,5,408,15.1250811,6.5696211,10.6380201,1.8,6.6420925,10.6151758,-1.5566527,1.771733,3.6925052,10.823761,51.0495958,2.5203426,13.8251928,6.109138,16.4549188,3.5628935,7.1538138,1.6233794,19.0490723),(14900,'metacarpus.tif',40,5,409,15.1252032,6.5679803,10.6388156,1.8,6.6369626,10.6072324,-1.5578483,1.7692321,3.6949043,10.8004047,51.1830743,2.5204446,13.8523409,6.1045719,16.2946063,3.477964,7.1593697,1.6364911,19.2693258),(14901,'metacarpus.tif',40,5,410,15.0782883,6.5672675,10.6378681,1.8,6.6396785,10.6108339,-1.5581614,1.7698145,3.6008787,10.7372353,51.0502327,2.5126469,14.1771599,6.0668704,16.531824,3.477964,7.0805668,1.6638601,19.0262644),(14902,'metacarpus.tif',40,5,411,15.0987687,6.5632041,10.6417322,1.8,6.6384759,10.6116859,-1.5568557,1.764117,3.6074138,10.8106907,51.252073,2.5159724,14.2074284,6.1281032,16.4631173,3.477964,7.0805668,1.4777326,18.7926503),(14903,'metacarpus.tif',40,5,412,15.1222336,6.5630059,10.6394485,1.8,6.6381259,10.6112348,-1.5567469,1.7638453,3.6966006,10.8551843,51.4802254,2.5198748,13.9263693,6.1542725,16.3791132,3.477964,7.1593697,1.5051015,18.948393),(14904,'metacarpus.tif',40,5,413,15.134115,6.5617394,10.6366171,1.8,6.6343569,10.6113742,-1.5575782,1.7641019,3.6917901,10.8496527,51.8052485,2.5219118,14.0325551,6.1502415,16.5719577,3.477964,7.1593697,1.5051015,19.3700051),(14905,'metacarpus.tif',40,5,414,15.094213,6.5591858,10.6323653,1.8,6.6369442,10.6062235,-1.5563988,1.7679099,3.6885348,10.787171,51.6748761,2.5151807,14.0095943,6.1016521,16.536493,3.477964,7.1593697,1.5051015,19.3149417),(14906,'metacarpus.tif',40,5,415,15.1106541,6.5586256,10.6334415,1.8,6.6347718,10.612111,-1.5582239,1.7658628,3.6881266,10.8036928,51.9234919,2.5180443,14.0785545,6.1180817,16.601518,3.477964,7.1593697,1.6364911,19.4478764),(14907,'metacarpus.tif',40,5,416,15.0819602,6.5572548,10.6357668,1.8,6.6338115,10.6088609,-1.5585308,1.7575774,3.6925223,10.7875311,51.9827685,2.5132819,14.0778483,6.1377274,16.3953402,3.477964,7.2434164,1.531855,19.2598784),(14908,'metacarpus.tif',40,5,417,15.183319,6.5615204,10.6388301,1.8,6.6649746,10.6066142,-1.5570031,1.763746,3.6931778,11.1183427,52.079711,2.5300718,14.1015987,6.303823,16.7742958,3.571963,7.1538138,1.6233794,19.4478764),(14909,'metacarpus.tif',40,5,418,15.2043634,6.5592101,10.6432556,1.8,6.660383,10.6162033,-1.5597952,1.7612517,3.6976732,11.147766,52.2722573,2.5337539,14.1365272,6.3294566,16.6438108,3.571963,7.1661544,1.4920124,19.3700051),(14910,'metacarpus.tif',40,5,419,15.1966287,6.5571657,10.6419862,1.8,6.6608361,10.6110472,-1.5591562,1.7589533,3.6970148,11.145313,52.4241,2.5324283,14.1801162,6.3363327,16.6861352,3.571963,7.2434164,1.531855,20.0252312),(14911,'metacarpus.tif',40,5,420,15.1360729,6.5528713,10.6398566,1.8,6.6583756,10.611214,-1.559231,1.7535756,3.691605,11.084768,52.2401397,2.5223414,14.1510645,6.3212376,16.8997891,3.571963,7.2476846,1.6226977,19.7365538),(14912,'metacarpus.tif',40,5,421,15.1434751,6.5501119,10.6407584,1.8,6.6567568,10.6027984,-1.5610387,1.7525933,3.6941179,11.0565846,52.582639,2.5236722,14.234153,6.3086996,16.7018238,3.5480167,7.2531686,1.6356404,19.8922965),(14913,'metacarpus.tif',40,5,422,15.0827866,6.5479226,10.6437789,1.8,6.6533725,10.6156932,-1.5623404,1.757274,3.6959382,10.9949946,52.5192891,2.513618,14.210002,6.2568471,16.65383,3.477964,7.2531686,1.6356404,19.8694885),(14914,'metacarpus.tif',40,5,423,15.09324,6.5417923,10.649629,1.8,6.6452229,10.6214734,-1.5606501,1.7537557,3.7024813,11.0824916,52.4601837,2.515281,14.1689259,6.3192903,16.7303823,3.5682784,7.2385354,1.5837826,20.0708472),(14915,'metacarpus.tif',40,5,424,15.1102446,6.5397484,10.6511034,1.8,6.6417777,10.6193044,-1.5620932,1.7500765,3.7027479,11.0896904,52.7438038,2.5181834,14.2445031,6.3366889,16.7985048,3.477964,7.2476846,1.5188949,20.1259105),(14916,'metacarpus.tif',40,5,425,15.1023082,6.5394703,10.6491448,1.8,6.6409357,10.6155736,-1.5638912,1.7482628,3.700548,11.1077114,52.9431365,2.5169314,14.306837,6.3535708,16.6524349,3.5658178,7.2598656,1.4930314,19.8144252),(14917,'metacarpus.tif',40,5,426,15.076678,6.5347571,10.6515184,1.8,6.6403154,10.6310617,-1.5647875,1.7443423,3.7003137,11.0684146,52.886635,2.5126889,14.2924732,6.3453225,16.9166832,3.571963,7.2476846,1.6226977,19.9701679),(14918,'metacarpus.tif',40,5,427,15.091106,6.5334739,10.651301,1.8,6.6392778,10.6275341,-1.563401,1.7431692,3.702567,11.0513699,53.2083047,2.5150468,14.3706528,6.339815,16.8009272,3.571963,7.2598656,1.4930314,20.579778),(14919,'metacarpus.tif',40,5,428,15.038836,6.5307956,10.6533511,1.8,6.6361229,10.6196391,-1.5665614,1.7385552,3.7015788,10.9606646,53.1960478,2.5064277,14.371178,6.3044674,16.7622971,3.477964,7.2598656,1.4930314,19.9701679),(14920,'metacarpus.tif',40,5,429,15.0332092,6.5261176,10.6611556,1.8,6.6346951,10.6241023,-1.5657486,1.7417805,3.7092479,11.0034637,53.1037959,2.505471,14.316594,6.3173654,16.906645,3.5559754,7.2476846,1.6226977,20.3367166),(14921,'metacarpus.tif',40,5,430,15.1078915,6.5211269,10.6600599,1.8,6.6266196,10.6295812,-1.567847,1.7476176,3.7070616,11.0833008,53.602066,2.51796,14.4594483,6.3419483,16.8608285,3.5608966,7.2677723,1.4801364,20.2911006),(14922,'metacarpus.tif',40,5,431,15.1023554,6.5191434,10.6597869,1.8,6.6240056,10.6208525,-1.568091,1.7501191,3.7065528,11.1022873,53.7617162,2.5170408,14.5045057,6.3437326,16.9062756,3.5608966,7.2531686,1.6356404,20.0802946),(14923,'metacarpus.tif',40,5,432,15.0571498,6.5163209,10.6588141,1.8,6.6255173,10.6159839,-1.5679842,1.7235249,3.7056936,11.0412803,53.7153872,2.5095051,14.4953665,6.4062202,16.8791871,3.477964,7.2768847,1.674321,20.346164),(14924,'metacarpus.tif',40,5,433,15.0519578,6.5139941,10.6601712,1.8,6.6215934,10.6212645,-1.568755,1.7586059,3.7060971,10.9979258,53.9184265,2.5086492,14.5485737,6.2537749,17.016779,3.571963,7.2768847,1.674321,20.1581659),(14925,'metacarpus.tif',40,5,434,14.9904343,6.5107056,10.6694358,1.8,6.6126435,10.6381414,1.5688394,1.719602,3.7118937,10.9437564,53.8139404,2.4983962,14.4977052,6.3641216,16.9317727,3.477964,7.3343339,1.5964317,20.3367166),(14926,'metacarpus.tif',40,5,435,14.9769159,6.5040168,10.6701572,1.8,6.6080981,10.63997,-1.5699331,1.710432,3.715186,11.0027045,53.79184,2.4961508,14.4789091,6.4327049,16.7146279,3.477964,7.2677723,1.4801364,20.2911006),(14927,'metacarpus.tif',40,5,436,14.9952268,6.5025763,10.668713,1.8,6.6067229,10.6374447,1.5695549,1.7102002,3.7118693,11.017169,54.1666207,2.4992006,14.5928146,6.4420348,16.9324164,3.477964,7.3373451,1.5323537,20.3139086),(14928,'metacarpus.tif',40,5,437,14.9656137,6.5014886,10.6713258,1.8,6.6064841,10.6431736,1.5691859,1.7715628,3.714207,11.0281697,54.2151367,2.4942625,14.5966924,6.2251082,16.9355267,3.5682784,7.3373451,1.5323537,20.790584),(14929,'metacarpus.tif',40,5,438,14.9500443,6.4990424,10.6688293,1.8,6.6100416,10.6369449,-1.5697767,1.7721523,3.7139403,11.001355,54.2297064,2.4916715,14.6016634,6.2079061,16.9400864,3.571963,7.3535842,1.6475682,20.602586),(14930,'metacarpus.tif',40,5,439,14.9478153,6.4977313,10.6707214,1.8,6.6067649,10.6441255,-1.5707212,1.7977412,3.7148631,10.9903725,54.5416699,2.4913025,14.6820134,6.1134341,17.1146686,3.571963,7.3373451,1.5323537,20.4696513),(14931,'metacarpus.tif',40,5,440,14.8776475,6.4947898,10.6769911,1.8,6.5991094,10.6481594,1.5680694,1.7964759,3.7192791,10.9033114,54.5095551,2.4795895,14.6559465,6.0692779,16.9476997,3.571963,7.3469726,1.6348113,20.579778),(14932,'metacarpus.tif',40,5,441,14.9195972,6.4876547,10.675943,1.8,6.5944382,10.6351041,-1.5704469,1.7874593,3.7203755,11.0334239,54.6151875,2.4865992,14.6800202,6.1726854,17.0048516,3.571963,7.3469726,1.6348113,20.5019067),(14933,'metacarpus.tif',40,5,442,14.9691842,6.4853959,10.6774087,1.8,6.5911203,10.6468871,1.5688815,1.7864149,3.7203929,11.1234549,55.0064307,2.4948549,14.7851135,6.2266916,17.0050915,3.571963,7.3535842,1.4940244,20.4468433),(14934,'metacarpus.tif',40,5,443,14.9085096,6.4843625,10.6775982,1.8,6.5901574,10.6427601,1.5675198,1.6948404,3.7197971,11.0669591,55.0473639,2.4847249,14.7984856,6.5297941,17.222081,3.477964,7.3469726,1.6348113,20.4562907),(14935,'metacarpus.tif',40,5,444,14.8902512,6.4801029,10.6783693,1.8,6.5888622,10.6460397,1.5699698,1.6984023,3.7220467,11.0110908,55.0126124,2.4817068,14.7802047,6.4832052,17.1904409,3.477964,7.3703869,1.673003,20.4012273),(14936,'metacarpus.tif',40,5,445,14.8907353,6.477046,10.6779678,1.8,6.5767916,10.646468,1.5702509,1.7013099,3.7217781,11.0132516,55.3709035,2.4817885,14.8775403,6.4733955,17.0574659,3.477964,7.3703869,1.673003,20.4657381),(14937,'metacarpus.tif',40,5,446,14.8163673,6.4729656,10.6845249,1.8,6.5732838,10.6553409,1.5682763,1.7069972,3.7273679,10.9214176,55.1101676,2.4693789,14.785277,6.3980288,17.0501045,3.477964,7.3703869,1.673003,20.2132293),(14938,'metacarpus.tif',40,5,447,14.8555115,6.4698104,10.6853085,1.8,6.5742299,10.6558504,1.5683445,1.7726943,3.7277165,11.0136359,55.2642016,2.4759037,14.8252158,6.2129357,17.106585,3.571963,7.3469726,1.6348113,20.4790987),(14939,'metacarpus.tif',40,5,448,14.9004646,6.4667353,10.6853425,1.8,6.5653869,10.653028,1.5670295,1.7704273,3.7268372,11.0868884,55.6332139,2.4833755,14.9277287,6.262267,17.2168813,3.571963,7.3469726,1.6348113,20.6120334),(14940,'metacarpus.tif',40,5,449,14.8428087,6.4650745,10.6899708,1.8,6.5648152,10.6544619,1.5658339,1.7703611,3.7306281,11.0567478,55.6820752,2.4737405,14.9256569,6.2454759,17.1999397,3.571963,7.3469726,1.6348113,20.4012273),(14941,'metacarpus.tif',40,5,450,14.8229883,6.4631609,10.6817637,1.8,6.5660077,10.6481914,1.5675232,1.7670039,3.7238952,11.0470619,55.6349856,2.4704716,14.9399977,6.2518605,17.2180364,3.571963,7.3703869,1.673003,20.4562907),(14942,'metacarpus.tif',40,5,451,14.8273278,6.4620595,10.6816128,1.8,6.5622237,10.6454731,1.5670433,1.7668105,3.7234523,11.0504979,56.0558745,2.4711865,15.054812,6.2544895,17.2081692,3.571963,7.3703869,1.673003,20.790584),(14943,'metacarpus.tif',40,5,452,14.7592196,6.4588098,10.6878712,1.8,6.5582077,10.6531395,1.5645836,1.7654225,3.820444,10.9895142,55.90998,2.459775,14.6344194,6.2248636,17.0474796,3.5607575,7.4407815,1.6340032,20.4790987),(14944,'metacarpus.tif',40,5,453,14.7854084,6.4548758,10.6880453,1.8,6.5558167,10.6523052,1.564973,1.761078,3.8214915,11.0651835,56.0990576,2.4641512,14.6798854,6.2831875,17.1103789,3.571963,7.4407815,1.6340032,21.0792614),(14945,'metacarpus.tif',40,5,454,14.7781191,6.4500439,10.689556,1.8,6.5438757,10.6573136,1.5648315,1.7569468,3.8228594,11.0558719,56.2696406,2.4629322,14.7192547,6.2926618,17.2281653,3.5447514,7.4407815,1.6340032,20.4240353),(14946,'metacarpus.tif',40,5,455,14.737743,6.4474788,10.6912227,1.8,6.5428648,10.655914,1.5621612,1.7582272,3.8223254,11.0586193,56.2424756,2.4561074,14.714204,6.2896419,17.2124462,3.5447514,7.4407815,1.6340032,20.4012273),(14947,'metacarpus.tif',40,5,456,14.7427003,6.4448294,10.684263,1.8,6.5439836,10.651487,1.5659271,1.7500461,3.8188847,11.0650694,56.5255509,2.4570585,14.8015862,6.3227303,17.1278685,3.5402624,7.4407815,1.6340032,20.6348414),(14948,'metacarpus.tif',40,5,457,14.7311583,6.4425608,10.6898689,1.8,6.5405293,10.6621391,1.563496,1.7509875,3.8227178,11.0669422,56.7725258,2.4550622,14.8513516,6.3204003,17.4320017,3.5402624,7.5345952,1.6332151,20.579778),(14949,'metacarpus.tif',40,5,458,14.6440476,6.4388524,10.6940627,1.8,6.5366099,10.6583673,1.5608327,1.7512074,3.825855,11.0109429,56.4949784,2.4404323,14.7666281,6.2876291,17.3249494,3.5436723,7.5410423,1.6456562,20.4012273),(14950,'metacarpus.tif',40,5,459,14.6878915,6.4336075,10.6947593,1.8,6.5346056,10.6672587,1.5632956,1.7415215,3.8280997,11.1150596,56.7844012,2.4478442,14.8335742,6.3823845,17.2478374,3.5435429,7.5410423,1.6456562,20.4790987),(14951,'metacarpus.tif',40,5,460,14.6402687,6.4277272,10.6981952,1.8,6.5246509,10.6631694,1.5620275,1.7377556,3.82819,11.0967032,56.7383894,2.4398572,14.8212051,6.3856524,17.2109814,3.477964,7.5222718,1.5957911,20.7355207),(14952,'metacarpus.tif',40,5,461,14.5738913,6.4241434,10.702267,1.8,6.5148589,10.6744868,1.5592828,1.7383036,3.8339609,11.0758962,56.8221046,2.4286599,14.8207313,6.3716694,17.2060483,3.4774343,7.5410423,1.6456562,20.4790987),(14953,'metacarpus.tif',40,5,462,14.5451733,6.4204894,10.6987737,1.8,6.5141454,10.6830599,1.5610524,1.7388576,3.8286976,11.0467197,56.7102599,2.4239654,14.8118931,6.3528605,17.1814436,3.5424701,7.4407815,1.6340032,20.066934),(14954,'metacarpus.tif',40,5,463,14.5201431,6.4171889,10.6992099,1.8,6.510044,10.6818675,1.5594572,1.733304,3.827728,11.0235593,56.9227395,2.4197127,14.871156,6.3598535,17.3152577,3.4758453,7.5222718,1.5957911,20.6899047),(14955,'metacarpus.tif',40,5,464,14.4661446,6.4129669,10.7030516,1.8,6.5014065,10.6912856,1.5585829,1.7279689,3.8319088,10.9741184,56.9469901,2.4106645,14.8612591,6.3508773,17.2883902,3.477964,7.5410423,1.6456562,21.2444515),(14956,'metacarpus.tif',40,5,465,14.4961654,6.4081689,10.7073827,1.8,6.4947587,10.6930962,1.5588029,1.7228522,3.8363531,11.0505802,57.0500027,2.4156801,14.8708945,6.4141198,17.1199217,3.477964,7.5410423,1.6456562,20.5986728),(14957,'metacarpus.tif',40,5,466,14.4760158,6.4039881,10.7104984,1.8,6.4885164,10.6892783,1.5575389,1.7214046,3.8384218,11.0258051,57.0258876,2.4122453,14.8565973,6.4051213,17.0900894,3.477964,7.5345952,1.6332151,21.0108375),(14958,'metacarpus.tif',40,5,467,14.4746733,6.4025242,10.7125614,1.8,6.4873448,10.6928279,1.5566481,1.7844754,3.8410878,11.094,57.4622723,2.4119627,14.9598955,6.2169531,17.3069183,3.571963,7.5410423,1.6456562,21.3317702),(14959,'metacarpus.tif',40,5,468,14.4454888,6.3995071,10.7077611,1.8,6.4850269,10.691904,1.5587839,1.7860861,3.8377418,11.0470995,57.2279479,2.4072341,14.9118807,6.1850877,17.2531555,3.571963,7.5345952,1.6332151,20.9880295),(14960,'metacarpus.tif',40,5,469,14.4198745,6.3970207,10.7096636,1.8,6.481196,10.6885107,1.5580952,1.7914167,3.8391318,10.9788194,57.443902,2.4029247,14.9627323,6.1285683,17.1790078,3.571963,7.5574282,1.670465,21.4875129),(14961,'metacarpus.tif',40,5,470,14.3504208,6.392007,10.7152549,1.8,6.4712238,10.691606,1.5579646,1.7100165,3.8457728,10.9303163,57.3543537,2.391343,14.9136095,6.391936,17.2161983,3.477964,7.5673595,1.6828253,21.0659008),(14962,'metacarpus.tif',40,5,471,14.3672773,6.3876125,10.7169901,1.8,6.4641803,10.6902053,1.5593214,1.7047952,3.8482861,10.9724425,57.4464996,2.3942309,14.9278141,6.4362233,17.2381903,3.4561622,7.6347813,1.6447354,20.767776),(14963,'metacarpus.tif',40,5,472,14.36832,6.3851412,10.7180092,1.8,6.4595066,10.6951411,1.5591575,1.7877959,3.8491759,11.0353685,57.6018181,2.3943956,14.9647146,6.1726111,17.2863031,3.5304209,7.5574282,1.670465,20.8000314),(14964,'metacarpus.tif',40,5,473,14.30886,6.3868144,10.7175139,1.8,6.4671506,10.685636,1.5593252,1.7056349,3.8498813,11.0431787,57.7284278,2.3844962,14.9948591,6.4745268,17.2223759,3.4561622,7.5673595,1.6828253,20.7544154),(14965,'metacarpus.tif',40,5,474,14.3009471,6.3840894,10.7211328,1.8,6.4651122,10.6974304,1.5594876,1.7009789,3.8535534,11.062863,57.8368917,2.3831864,15.0087169,6.5038216,17.236323,3.4573555,7.6347813,1.6447354,20.8550948),(14966,'metacarpus.tif',40,5,475,14.241115,6.3793059,10.7195204,1.8,6.4544101,10.6940421,1.5588304,1.7821812,3.8515403,10.9792488,57.7349662,2.3731793,14.9900978,6.1605682,17.1912267,3.5304209,7.5574282,1.670465,21.2216435),(14967,'metacarpus.tif',40,5,476,14.1779155,6.3759935,10.7219906,1.8,6.4557598,10.7011329,1.5566583,1.7817383,3.8541348,10.9490789,57.8669154,2.3625136,15.0142427,6.1451667,17.2026935,3.5337014,7.6607765,1.6814535,21.1988355),(14968,'metacarpus.tif',40,5,477,14.2148615,6.3713959,10.7314516,1.8,6.4517234,10.7169457,1.5571822,1.7778649,3.8637658,11.0423383,57.918928,2.3687045,14.9902792,6.2110109,17.2967201,3.5435429,7.6607765,1.6814535,21.1665801),(14969,'metacarpus.tif',40,5,478,14.2098544,6.3693417,10.7347956,1.8,6.4460558,10.7138227,1.5563857,1.7737702,3.8667207,11.0998067,58.0761065,2.3678173,15.0194727,6.2577479,17.2319152,3.5337014,7.6509665,1.6692425,21.3317702),(14970,'metacarpus.tif',40,5,479,14.1828368,6.3693088,10.7380901,1.8,6.4432341,10.7140364,1.5554047,1.7758266,3.956321,11.1218801,58.3868728,2.3632462,14.7578705,6.2629312,17.1032366,3.5920646,7.713077,1.6073654,20.7544154),(14971,'metacarpus.tif',40,5,480,14.185086,6.3663218,10.7371057,1.8,6.4367037,10.7241454,1.5559791,1.7768901,3.9558258,11.1389391,58.3694749,2.363662,14.75532,6.2687832,17.1045087,3.5920646,7.713077,1.6073654,20.6993521),(14972,'metacarpus.tif',40,5,481,14.1553563,6.364373,10.7365166,1.8,6.4376057,10.7270858,1.55644,1.7727871,3.9569866,11.0943587,58.5099797,2.3587398,14.7864995,6.2581449,17.1287747,3.536551,7.713077,1.6073654,21.2538989),(14973,'metacarpus.tif',40,5,482,14.1187449,6.3600547,10.7383046,1.8,6.4326874,10.7220907,1.5566757,1.7861411,3.9589104,11.1066679,58.8848791,2.352655,14.8740115,6.2182479,17.294611,3.6068232,7.7285266,1.6438369,22.3079291),(14974,'metacarpus.tif',40,5,483,14.1412823,6.3527544,10.7442534,1.8,6.4224846,10.7378059,1.5564964,1.7931209,3.9646037,11.188881,58.7953572,2.3563985,14.8300718,6.2398922,17.2618613,3.5652334,7.7285266,1.6438369,21.561471),(14975,'metacarpus.tif',40,5,484,14.1132062,6.3538448,10.7466652,1.8,6.4296752,10.738525,1.5540938,1.7866515,3.9665545,11.2314947,58.7833647,2.3515449,14.8197547,6.2863379,17.1782987,3.5845237,7.7285266,1.6438369,21.7400217),(14976,'metacarpus.tif',40,5,485,14.0837575,6.3532203,10.7418052,1.8,6.4254446,10.7304223,1.5550688,1.7908757,3.9624267,11.2574401,59.2161924,2.3467124,14.9444258,6.2859973,17.3932637,3.5849045,7.7285266,1.6438369,21.9185724),(14977,'metacarpus.tif',40,5,486,14.0701979,6.3506223,10.7450774,1.8,6.4233557,10.7306889,1.5568588,1.8900706,3.9670149,11.2961211,59.2407052,2.3445775,14.9333206,5.9765605,17.2191402,3.6555352,7.7285266,1.6438369,22.1293784),(14978,'metacarpus.tif',40,5,487,14.0247252,6.3491041,10.7394558,1.8,6.4170716,10.7328704,1.5590196,1.8046086,3.9641042,11.2709816,59.5424763,2.33713,15.0204116,6.2456656,17.3081904,3.6045756,7.7285266,1.6438369,21.3089622),(14979,'metacarpus.tif',40,5,488,13.9610133,6.3464899,10.7426122,1.8,6.4173499,10.7309504,1.5569416,1.8016672,3.9658575,11.2737382,59.8031294,2.3263889,15.0794954,6.257392,17.4489388,3.5849045,7.7285266,1.6438369,20.9974768),(14980,'metacarpus.tif',40,5,489,13.9825856,6.3438683,10.751819,1.8,6.4185415,10.7556441,1.5578662,1.805189,3.9756423,11.4029198,59.8068493,2.3300413,15.0433176,6.3167457,17.4406446,3.6045756,7.7542076,1.6801149,21.3640256),(14981,'metacarpus.tif',40,5,490,13.9625677,6.3433972,10.755547,1.8,6.4072743,10.7567079,1.5577035,1.8065745,3.9804865,11.4688746,60.1772633,2.3266957,15.1180676,6.3484095,17.5314579,3.5980186,7.7542076,1.6801149,21.0202848),(14982,'metacarpus.tif',40,5,491,13.9404166,6.3415754,10.7541698,1.8,6.404591,10.7450536,1.5569822,1.8982216,3.9786715,11.554929,60.5540029,2.3229594,15.2196539,6.0872391,17.4551761,3.6746196,7.7542076,1.6801149,20.7638628),(14983,'metacarpus.tif',40,5,492,13.9500211,6.3418324,10.7607848,1.8,6.4090205,10.7591606,1.5566909,1.8047131,3.9851217,11.593727,60.6361,2.324541,15.2156206,6.4241386,17.6507307,3.6045756,7.822278,1.64296,20.9424135),(14984,'metacarpus.tif',40,5,493,13.8763923,6.3371534,10.7550868,1.8,6.4014991,10.7555805,1.5578155,1.8142723,3.9812292,11.5858404,60.740112,2.3123424,15.2566226,6.3859435,17.6002185,3.6242467,7.7542076,1.6801149,21.6849583),(14985,'metacarpus.tif',40,5,494,13.8307793,6.3330508,10.7591726,1.8,6.3953805,10.7604267,1.5581553,1.9095504,3.9854266,11.6249568,61.0156247,2.3047616,15.3096848,6.0877977,17.6554785,3.6801128,7.822278,1.64296,22.1293784),(14986,'metacarpus.tif',40,5,495,13.788611,6.3288431,10.7601732,1.8,6.3890499,10.7622127,1.5595498,1.9159608,4.0789315,11.6000856,60.8480386,2.2978112,14.9176416,6.0544483,17.5246091,3.7082137,7.9048655,1.6183794,22.4959271),(14987,'metacarpus.tif',40,5,496,13.799517,6.3301805,10.7570172,1.8,6.3925163,10.7560336,1.5589883,1.9154461,4.0720832,11.7415525,61.3616257,2.2995988,15.0688537,6.1299312,17.4772023,3.8200005,7.9009523,1.6064954,22.9269866),(14988,'metacarpus.tif',40,5,497,13.7838835,6.327627,10.7570082,1.8,6.3918889,10.7548379,1.5589092,1.9167049,3.9846799,11.8276415,61.6028339,2.2969893,15.4599202,6.1708203,17.8508431,3.7462036,7.8476522,1.6788081,22.0837624),(14989,'metacarpus.tif',40,5,498,13.8044069,6.3249053,10.7621369,1.8,6.3849377,10.7706919,1.559718,1.9203275,3.9869714,11.9030692,61.7394119,2.3004521,15.485291,6.198458,17.9737235,3.7593305,7.822278,1.64296,22.6060538),(14990,'metacarpus.tif',40,5,499,13.7418143,6.322004,10.7510443,1.8,6.3759675,10.747282,1.5622196,1.9307916,4.0699142,11.8628504,62.0682456,2.2901339,15.2505047,6.1440347,17.7755912,3.7548707,7.9009523,1.6064954,22.7389885),(14991,'metacarpus.tif',40,5,500,13.6893333,6.3191551,10.7499287,1.8,6.3763203,10.7428043,1.5630296,1.9588052,3.9776631,11.8915748,62.249932,2.2814179,15.6498753,6.0708306,18.0446833,3.7580016,7.8476522,1.6788081,22.5281825),(14992,'metacarpus.tif',40,5,501,13.686677,6.3132932,10.757034,1.8,6.3672955,10.7561028,1.5622264,1.8713507,4.0766403,11.9358518,62.3517453,2.2809453,15.2948851,6.3782015,17.8287303,3.6957738,7.9232872,1.6539376,22.8491153),(14993,'metacarpus.tif',40,5,502,13.729327,6.3083342,10.7531431,1.8,6.3582497,10.744871,1.5627704,1.8758554,4.0731288,12.106181,62.9892687,2.2880738,15.4645903,6.4536858,18.0348195,3.5566544,7.9160353,1.6421038,22.7161806),(14994,'metacarpus.tif',40,5,503,13.6994918,6.3035153,10.7560959,1.8,6.3527752,10.75678,1.5615388,1.8024255,4.0750802,12.1630424,63.214544,2.283053,15.5124664,6.7481526,18.1639588,3.5566544,7.9160353,1.6421038,22.4503112),(14995,'metacarpus.tif',40,5,504,13.7213444,6.3017718,10.7544127,1.8,6.3510508,10.7497687,1.5616767,1.8013939,4.0743465,12.2239046,63.3726447,2.2867005,15.5540636,6.7858034,18.2226144,3.5435429,7.9232872,1.6539376,22.6155012),(14996,'metacarpus.tif',40,5,505,13.7309073,6.3004711,10.7482176,1.8,6.3562666,10.7446035,1.5634063,1.7986498,4.0693316,12.3255816,64.0428688,2.2883596,15.7379331,6.8526855,18.2667068,3.5533845,7.9160353,1.6421038,22.2166971),(14997,'metacarpus.tif',40,5,506,13.7277389,6.2949611,10.7551702,1.8,6.3442288,10.7657791,1.5632105,1.7940674,4.0761079,12.4170046,64.2903191,2.2878248,15.7724773,6.9211471,18.5533662,3.5533845,7.9316466,1.665748,22.4275032),(14998,'metacarpus.tif',40,5,507,13.7426258,6.2895103,10.7634647,1.8,6.3329799,10.7702976,1.5637022,1.7865105,4.0853701,12.5303005,64.5224669,2.2903224,15.7935426,7.0138409,18.4432248,3.5582949,8.0169653,1.6529638,22.1938891),(14999,'metacarpus.tif',40,5,508,13.766373,6.2876586,10.7557718,1.8,6.3317526,10.7518432,1.5636801,1.7854102,4.077651,12.7360024,64.9619275,2.2942793,15.9312133,7.1333761,18.53926,3.5632164,7.9411099,1.677532,21.8273404),(15000,'metacarpus.tif',40,5,509,13.7951534,6.2867917,10.7546535,1.8,6.3384155,10.7485289,1.5628121,1.8973769,4.0760005,12.9221816,65.1603562,2.2990457,15.9863465,6.8105508,18.6349988,3.568138,8.0097982,1.6412677,22.98205),(15001,'metacarpus.tif',40,5,510,13.8556907,6.2889816,10.7563162,1.8,6.3395409,10.7518299,1.564432,1.8933405,4.0792544,13.0809747,65.5458506,2.3091882,16.0680958,6.9089395,18.8510724,3.5632164,8.0169653,1.6529638,22.6155012),(15002,'metacarpus.tif',40,5,511,13.8715992,6.285095,10.7470563,1.8,6.3297464,10.7347337,1.5681586,1.8692835,4.0718377,13.16042,65.98785,2.3119171,16.2059138,7.0403553,19.0137571,3.6424366,8.0097982,1.6412677,22.8034993),(15003,'metacarpus.tif',40,5,512,13.8899503,6.2821485,10.7453829,1.8,6.3252783,10.7393328,1.5670784,1.8675666,4.0696177,13.2539204,66.3340366,2.3149597,16.2998202,7.0968932,18.9287347,3.6424366,8.0345802,1.6762856,22.1482732),(15004,'metacarpus.tif',40,5,513,13.8126979,6.2811211,10.7478379,1.8,6.3225644,10.7437272,1.5667297,1.8672264,4.0722759,13.3015222,66.2298928,2.3020782,16.2636065,7.1236795,19.0050253,3.6473581,8.0450208,1.6879051,21.9830831),(15005,'metacarpus.tif',40,5,514,13.8236267,6.2808163,10.7511997,1.8,6.3244102,10.7448989,1.5681316,1.8657671,4.0762067,13.4894966,66.7938973,2.3039214,16.3862879,7.2300003,19.1694092,3.6473581,8.0345802,1.6762856,22.8813706),(15006,'metacarpus.tif',40,5,515,13.8558445,6.2772739,10.7551247,1.8,6.3180355,10.7516186,1.5679108,1.8627247,4.1734884,13.6969556,67.2574142,2.3092882,16.115395,7.3531831,19.2020245,3.6473581,8.1106509,1.6520126,22.8813706),(15007,'metacarpus.tif',40,5,516,13.9192177,6.2793046,10.753629,1.8,6.3169132,10.7484427,1.5670917,1.8657248,4.1715101,13.8784923,67.9133066,2.3198378,16.280269,7.43866,19.1895304,3.6506391,8.1188174,1.6635526,22.936434),(15008,'metacarpus.tif',40,5,517,13.9057386,6.2770536,10.7436923,1.8,6.3233159,10.7435856,1.5700996,1.8599964,4.1633519,13.9591047,68.1773012,2.317622,16.3755797,7.5049094,19.3123886,3.665962,8.1280628,1.6750679,23.2707273),(15009,'metacarpus.tif',40,5,518,13.9035832,6.2755039,10.7383564,1.8,6.3190476,10.7399604,1.5691878,1.8597791,4.1576271,14.0548258,68.5244555,2.3172579,16.4816263,7.5572557,19.7205257,3.665962,8.1383834,1.6865555,23.170048),(15010,'metacarpus.tif',40,5,519,13.9267919,6.2726782,10.7429,1.8,6.3097069,10.7460967,1.5684204,1.8582278,4.1617797,14.2119948,68.9794801,2.3211189,16.5745152,7.6481444,19.6442372,3.665962,8.1865544,1.616741,23.1377926),(15011,'metacarpus.tif',40,5,520,13.9540987,6.274501,10.7407548,1.8,6.3097402,10.7415413,-1.5696526,1.8575415,4.1618146,14.4464409,69.6180235,2.3256801,16.7278053,7.7771834,19.7766732,3.665962,8.1827759,1.6052654,22.7484359),(15012,'metacarpus.tif',40,5,521,14.0547305,6.2708052,10.743413,1.8,6.3052096,10.7466636,1.5704677,1.8533052,4.1633484,14.7308265,70.2969883,2.3424548,16.884724,7.9484084,20.0738357,3.665962,8.2317605,1.6852366,23.101624),(15013,'metacarpus.tif',40,5,522,14.1602452,6.2772115,10.736382,1.8,6.314173,10.7282197,-1.5702435,1.859788,4.1569807,14.9662119,71.2954404,2.3600402,17.1507751,8.0472677,20.2205719,3.665962,8.2317605,1.6852366,23.6239155),(15014,'metacarpus.tif',40,5,523,14.2413798,6.2702598,10.7274699,1.8,6.3061613,10.723293,-1.5666706,1.9432333,4.151495,15.1352583,71.8507063,2.3735229,17.3071885,7.7886987,20.4243914,3.7599611,8.2215571,1.6738779,23.9448482),(15015,'metacarpus.tif',40,5,524,14.3599457,6.2690639,10.7259131,1.8,6.303724,10.715932,-1.5666586,1.941633,4.1499546,15.3731932,72.8545356,2.3932833,17.555502,7.9176615,20.7220124,3.7599611,8.2317605,1.6852366,23.6789788),(15016,'metacarpus.tif',40,5,525,14.3897262,6.2700057,10.7295705,1.8,6.2997555,10.7201656,-1.5660506,1.9429708,4.1537392,15.5661389,73.3275044,2.3982337,17.6533722,8.0115144,20.9621956,3.7599611,8.2317605,1.6852366,23.2117507),(15017,'metacarpus.tif',40,5,526,14.4146746,6.2747992,10.7391464,1.8,6.3039131,10.7440845,-1.5621756,1.9542133,4.1673628,15.817625,73.9038738,2.4022672,17.7339669,8.0941138,21.0156473,3.7599611,8.2553411,1.7078625,23.3446854),(15018,'metacarpus.tif',40,5,527,14.497498,6.2767677,10.7439481,1.8,6.3030044,10.7451238,-1.5624901,1.9553204,4.2642903,16.1016489,74.917765,2.416083,17.5686363,8.2347879,21.0321125,3.8353275,8.3251516,1.6839473,23.4453648),(15019,'metacarpus.tif',40,5,528,14.5760328,6.2828245,10.7433685,1.8,6.307494,10.7505622,-1.5607518,1.9637672,4.2649259,16.3697398,75.7677408,2.4290937,17.7653122,8.3358862,21.2985796,3.8402491,8.3917496,1.6492864,23.8764242),(15020,'metacarpus.tif',40,5,529,14.6383279,6.2775631,10.7504381,1.8,6.2998591,10.762784,-1.558129,1.9586515,4.2739466,16.5604556,76.2178647,2.4393299,17.8331344,8.4550293,21.4076608,3.8539601,8.3743585,1.6157099,23.5004281),(15021,'metacarpus.tif',40,5,530,14.7575076,6.2785508,10.7567237,1.8,6.2936809,10.7642102,-1.5569446,1.9627857,4.2810656,16.8045068,77.4771418,2.4591127,18.09763,8.5615595,21.7244154,3.8539601,8.3996428,1.4811496,24.2563336),(15022,'metacarpus.tif',40,5,531,14.7536713,6.2798025,10.7720561,1.8,6.2962085,10.7809116,-1.5579483,1.9624458,4.2956638,17.0197792,78.1172553,2.4585393,18.1851418,8.6727386,21.8466714,3.9289183,8.3996428,1.4811496,24.453779),(15023,'metacarpus.tif',40,5,532,14.7775288,6.2815447,10.7729718,1.8,6.3029426,10.7836587,-1.5567475,2.0376621,4.2974104,17.3120876,78.4072224,2.4624354,18.2452256,8.4960541,21.9773859,3.9908972,8.3917496,1.6492864,24.2107176),(15024,'metacarpus.tif',40,5,533,14.841349,6.2810502,10.7732449,1.8,6.2975673,10.7841221,-1.5568408,2.0438241,4.3002477,17.6655735,79.0339917,2.4730765,18.3789392,8.6433924,22.0132172,4.0056608,8.4687855,1.4147715,24.3436523),(15025,'metacarpus.tif',40,5,534,14.941821,6.285581,10.7702781,1.8,6.2969682,10.7777899,-1.5566892,2.0469054,4.2960273,17.9770147,80.16269,2.4898079,18.6597253,8.7825331,22.4602621,4.0419582,8.4682638,1.6152115,24.1100383),(15026,'metacarpus.tif',40,5,535,15.0054616,6.2820076,10.7635847,1.8,6.298574,10.7756522,-1.5548498,2.0450566,4.2908519,18.2830062,80.34176,2.5002744,18.7239647,8.9400978,22.6015766,4.0419582,8.4729578,1.6262948,24.499395),(15027,'metacarpus.tif',40,5,536,15.0563383,6.2838106,10.7630504,1.8,6.298973,10.7884049,-1.5535296,2.0641004,4.2945766,18.5433404,81.2982416,2.5086416,18.930444,8.9837397,22.6723772,4.097352,8.5119739,1.4601391,24.499395),(15028,'metacarpus.tif',40,5,537,15.0528744,6.2800348,10.7810664,1.8,6.2928699,10.814953,-1.5582222,2.0566456,4.3056564,18.7313304,82.011654,2.5084158,19.0474219,9.1077092,22.9946408,4.097352,8.5228664,1.4491773,23.9220402),(15029,'metacarpus.tif',40,5,538,15.1376274,6.275341,10.7862284,1.8,6.2842866,10.8050757,-1.5596298,2.0533901,4.4016202,19.1822961,82.9257776,2.5226233,18.8398301,9.3417692,22.9627313,4.103913,8.5869024,1.658483,24.1879096),(15030,'metacarpus.tif',40,5,539,15.2643067,6.2739125,10.7841039,1.8,6.2781884,10.7989868,-1.559278,2.1288551,4.3997342,19.5422303,84.2271784,2.5437136,19.1436971,9.1796902,23.3462163,4.1852021,8.6054043,1.4613454,24.3208443),(15031,'metacarpus.tif',40,5,540,15.3198134,6.2705107,10.7978822,1.8,6.2751857,10.8192033,-1.5600779,2.1282572,4.4130418,19.7956313,85.1017922,2.5530089,19.2841574,9.3013342,23.5251737,4.1991624,8.6560804,1.5273454,24.3302917),(15032,'metacarpus.tif',40,5,541,15.4376133,6.2650328,10.8010135,1.8,6.2716531,10.8292576,-1.5583164,2.1205876,4.4197045,20.069163,86.4171705,2.5725348,19.5527033,9.4639632,23.6856081,4.1991624,8.6729067,1.4948557,24.6968404),(15033,'metacarpus.tif',40,5,542,15.5201082,6.2628425,10.7901525,1.8,6.2723638,10.8135411,-1.5573262,2.1314911,4.4096876,20.3349606,87.3965885,2.5862154,19.8192247,9.5402514,24.0171826,4.2581968,8.6988469,1.4625257,24.9855178),(15034,'metacarpus.tif',40,5,543,15.6078305,6.257322,10.8000803,1.8,6.262564,10.8231568,-1.5578988,2.1283357,4.5119934,20.6455226,88.3787333,2.6008724,19.587514,9.7003128,23.849297,4.2665375,8.7827492,1.4743226,25.6179359),(15035,'metacarpus.tif',40,5,544,15.7748862,6.2555392,10.7956568,1.8,6.2592142,10.8240649,-1.5574081,2.1254937,4.4177388,21.1837465,89.6813785,2.6286765,20.3002898,9.9665063,24.4553818,4.2079853,8.7827492,1.4743226,25.8609973),(15036,'metacarpus.tif',40,5,545,15.8269512,6.2608005,10.7846088,1.8,6.2677092,10.8072158,-1.556364,2.1337533,4.4975953,21.5929937,90.5191485,2.6372758,20.1261213,10.1197237,24.6100548,4.2145474,8.8439048,1.5282688,25.7052547),(15037,'metacarpus.tif',40,5,546,15.8882492,6.2664463,10.7895417,1.8,6.2718757,10.8061296,-1.5590092,2.1400729,4.5005296,22.052443,91.6268618,2.6476736,20.3591286,10.304529,24.932805,4.2299562,8.8483996,1.6239377,25.8153814),(15038,'metacarpus.tif',40,5,547,16.0504818,6.2720455,10.7876022,1.8,6.2826784,10.799518,-1.5580746,2.1463941,4.5015914,22.5608636,93.2150701,2.6746474,20.7071368,10.5110534,25.2103935,4.2299562,8.9076168,1.4438235,26.6129896),(15039,'metacarpus.tif',40,5,548,16.1412083,6.2747512,10.7873502,1.8,6.277284,10.800357,-1.5555769,2.1496477,4.5035538,22.9562084,94.5001647,2.6895783,20.9834651,10.6790559,25.5808499,4.2929462,8.9698913,1.4763414,25.7241494),(15040,'metacarpus.tif',40,5,549,16.2735659,6.273691,10.7947945,1.8,6.2837585,10.793842,-1.5546089,2.2235884,4.5118783,23.5008867,96.0217544,2.7115503,21.2819912,10.5689013,25.9884068,4.3772423,8.9541166,1.497245,26.6224369),(15041,'metacarpus.tif',40,5,550,16.4831357,6.2664712,10.8058928,1.8,6.2798504,10.8043057,-1.5598435,2.2325721,4.6082028,24.0400816,97.9979649,2.7468597,21.2659838,10.7678858,26.2994843,4.4179543,9.0283117,1.5395565,27.5852352),(15042,'metacarpus.tif',40,5,551,16.5567684,6.2617099,10.8097562,1.8,6.2724767,10.8139707,-1.5633306,2.2231977,4.6122784,24.341163,99.12856,2.7593076,21.4923192,10.9487171,26.3286886,4.4139797,9.0727323,1.467004,28.139782),(15043,'metacarpus.tif',40,5,552,16.7234431,6.2613111,10.7887259,1.8,6.2726487,10.8010461,-1.563679,2.2238292,4.5922938,24.8582072,101.0217868,2.7870993,21.9981105,11.1781097,26.736714,4.466558,9.0941326,1.4464413,26.7364769),(15044,'metacarpus.tif',40,5,553,16.7726174,6.2641894,10.7785264,1.8,6.274613,10.7936178,-1.5635909,2.2260114,4.5821653,25.2141697,102.1070382,2.7952911,22.2835781,11.3270625,27.1037711,4.4623835,9.1570685,1.4782777,27.7315305),(15045,'metacarpus.tif',40,5,554,16.8762217,6.2697403,10.7671433,1.8,6.2798763,10.769811,-1.5587794,2.2361441,4.6685047,25.6420407,104.1295183,2.8122975,22.3046834,11.4670788,27.2813884,4.49158,9.2425472,1.4893443,28.0847186),(15046,'metacarpus.tif',40,5,555,16.958396,6.2740645,10.7652902,1.8,6.2811763,10.7958701,-1.5560739,2.2422787,4.6648873,26.1340976,105.8325139,2.8257868,22.6870464,11.6551515,28.0480191,4.4932205,9.2195748,1.5300026,26.1685695),(15047,'metacarpus.tif',40,5,556,17.0089984,6.2675185,10.7684148,1.8,6.2651582,10.7858353,-1.5603512,2.2367874,4.6683597,26.5286449,107.0907774,2.8345238,22.9397013,11.8601546,28.0802898,4.4997825,9.2597391,1.4691075,26.3793755),(15048,'metacarpus.tif',40,5,557,17.2332243,6.2734505,10.7669971,1.8,6.2786428,10.7836389,-1.5625897,2.3196612,4.6648185,27.2467445,110.0628303,2.8720106,23.5942365,11.7460015,28.8715215,4.5609571,9.3442787,1.4801364,26.5351182),(15049,'metacarpus.tif',40,5,558,17.4841815,6.2747325,10.7579015,1.8,6.2844641,10.7637916,-1.5604234,2.3183088,4.7507246,27.9118356,113.112657,2.9137167,23.8095591,12.0397404,29.2523282,4.5944982,9.4229043,1.5009103,26.1913775),(15050,'metacarpus.tif',40,5,559,17.6553647,6.2767933,10.7461492,1.8,6.2912517,10.7522683,-1.5587133,2.3347086,4.7414792,28.504315,114.9946734,2.9421312,24.252911,12.208939,29.7292006,4.6713469,9.4299344,1.4909663,26.2692488),(15051,'metacarpus.tif',40,5,560,17.8013774,6.2813527,10.7244515,1.8,6.2998747,10.7488387,-1.5570734,2.3384509,4.7237768,28.8997307,117.6689224,2.9663376,24.9099245,12.3584935,30.2475865,4.6999513,9.5166761,1.5016,26.6129896),(15052,'metacarpus.tif',40,5,561,17.947826,6.283134,10.7249796,1.8,6.2957214,10.7464282,-1.5560758,2.5095709,4.7239698,29.6044208,119.8397858,2.9906562,25.3684487,11.7966068,30.9766112,4.7702531,9.5500421,1.462313,26.878859),(15053,'metacarpus.tif',40,5,562,18.0234314,6.2725842,10.7271537,1.8,6.2949401,10.7519359,-1.560104,2.5891885,4.8162669,30.1256987,121.3397375,3.0035618,25.1937322,11.6351894,30.7819117,4.911167,9.6251515,1.482789,27.7220831),(15054,'metacarpus.tif',40,5,563,18.2219816,6.2714315,10.7092184,1.8,6.2926475,10.7436881,-1.5589056,2.5911997,4.7984333,30.7873612,123.8162781,3.0365676,25.80348,11.8815086,31.655989,5.0227033,9.6251515,1.482789,27.8644652),(15055,'metacarpus.tif',40,5,564,18.4998138,6.2693994,10.6938387,1.8,6.3007308,10.738337,-1.5577995,2.5958987,4.8768538,31.6481276,126.5602213,3.0827815,25.9512025,12.1915878,32.0009647,5.0350038,9.7871902,1.5227564,29.1938122),(15056,'metacarpus.tif',40,5,565,18.8025203,6.2695345,10.6681584,1.8,6.3111336,10.746617,-1.5550727,2.6022781,4.8533684,32.3605292,129.2387231,3.1329787,26.6286651,12.4354617,32.749822,5.039104,9.7871902,1.5227564,28.4835227),(15057,'metacarpus.tif',40,5,566,19.231995,6.2664334,10.6419027,1.8,6.3211759,10.7200528,-1.5475653,2.6272714,4.9423972,33.1929285,132.472409,3.203603,26.8032706,12.6339929,32.9786478,5.0587693,9.8739255,1.59936,29.6248717),(15058,'metacarpus.tif',40,5,567,19.6503404,6.2698023,10.6381888,1.8,6.3257514,10.7203178,-1.5429291,2.6327538,4.9576994,34.1913692,136.2059223,3.272514,27.4736143,12.9869222,33.899408,5.0653313,9.8985037,1.4947528,29.4140656),(15059,'metacarpus.tif',40,5,568,20.0334215,6.2798214,10.6313188,1.8,6.3371641,10.7048131,-1.541655,2.6314155,4.964403,35.0860185,140.4471561,3.3360689,28.2908452,13.333515,34.5360654,5.0759475,9.9145582,1.4758446,30.0142284),(15060,'metacarpus.tif',40,5,569,20.4815554,6.2887782,10.6304286,1.8,6.3476001,10.7192513,-1.5414969,2.6256449,5.0539508,36.0827941,144.9948699,3.410663,28.6894105,13.7424499,34.9998972,5.0702528,10.0688711,1.5241013,30.0370364),(15061,'metacarpus.tif',40,5,570,21.0012986,6.300682,10.6129187,1.8,6.3591021,10.7047656,-1.5395539,2.6194216,5.070778,37.0797781,150.3232484,3.496801,29.6450066,14.155712,36.2441516,5.0759475,10.0859686,1.4961688,29.0286221),(15062,'metacarpus.tif',40,5,571,21.6737445,6.3154642,10.5926209,1.8,6.375909,10.6908559,-1.5394701,2.6055048,5.1766047,37.9166646,155.9433265,3.6087471,30.1246348,14.5525216,37.006671,5.0759475,10.1588554,1.5337762,28.3316933),(15063,'metacarpus.tif',40,5,572,22.403147,6.3207865,10.579487,1.8,6.3818238,10.6983016,-1.5407593,2.5971288,5.1937465,38.6272652,161.2009437,3.7304901,31.0375069,14.8730649,37.7574212,5.0759475,10.1797084,1.6447354,28.2538219),(15064,'metacarpus.tif',40,5,573,23.2324766,6.3252376,10.5811933,1.8,6.390976,10.7150618,-1.5456416,2.5794642,5.280008,39.7369684,167.6941794,3.8696298,31.7602132,15.4051253,38.5374548,5.0759475,10.3416019,1.5889761,28.8272635),(15065,'metacarpus.tif',40,5,574,23.8583124,6.3223232,10.6141366,1.8,6.3936025,10.7372175,-1.5548287,2.5569141,5.1699249,40.5371435,173.4944138,3.9753716,33.5584013,15.8539326,40.4290287,5.0759475,10.256668,1.5249569,28.8272635),(15066,'metacarpus.tif',40,5,575,24.3391316,6.3195384,10.649487,1.8,6.3969257,10.7477861,-1.561781,2.5879813,5.231246,41.1746658,178.8484727,4.0561922,34.1885039,15.9099548,41.1107899,5.1445514,10.3672021,1.6433958,28.7950081),(15067,'metacarpus.tif',40,5,576,24.8893001,6.3265456,10.6964706,1.8,6.4033264,10.7918394,-1.5658409,2.5922471,5.1866482,41.9490166,184.7248785,4.1481148,35.6154635,16.1824917,42.7320591,5.1478325,10.3672021,1.6433958,30.8535393),(15068,'metacarpus.tif',40,5,577,25.5183808,6.3345117,10.7409185,1.8,6.4102006,10.8247311,-1.5660623,2.796149,5.2350257,42.7682375,190.0306174,4.2529682,36.2998445,15.2954073,43.9154068,5.205084,10.4444721,1.6158109,30.7394994),(15069,'metacarpus.tif',40,5,578,26.017744,6.347226,10.7700149,1.8,6.4224652,10.8249703,-1.5665625,2.7835588,5.1337984,43.4267869,195.4107902,4.3362129,38.0635889,15.6011746,45.3175819,5.2639455,10.3914638,1.670465,31.0415374),(15070,'metacarpus.tif',40,5,579,26.3256039,6.3499295,10.7888868,1.8,6.4151339,10.8369481,-1.5688031,2.7740081,5.1895422,43.6303036,200.4355244,4.3875832,38.6229685,15.7282537,46.1982045,5.4092562,10.4609557,1.642744,32.5132664),(15071,'metacarpus.tif',40,5,580,26.5918872,6.3545234,10.7998662,1.8,6.4130841,10.8563497,1.5645917,2.7475198,6.6046396,43.8478274,205.1927131,4.4318106,31.0679653,15.9590577,35.5311671,5.2639455,10.4681327,1.6517004,31.2979594),(15072,'metacarpus.tif',40,5,581,26.644318,6.3509747,10.8019134,1.8,6.4068101,10.858363,1.5607564,2.8361689,6.4235903,43.8592352,207.3673327,4.4402721,32.282154,15.4642538,36.7723637,5.2639455,10.5383768,1.6154096,31.2523434),(15073,'metacarpus.tif',40,5,582,26.3493105,6.3411895,10.8226279,1.8,6.402961,10.8781159,1.5597927,2.8427553,6.4981829,43.4115829,207.4868765,4.39102,31.9299843,15.2709529,36.5107145,5.2639455,10.5383768,1.6154096,33.8654214),(15074,'metacarpus.tif',40,5,583,25.9325882,6.3223952,10.8602127,1.8,6.4029348,10.8871247,1.5591714,2.8593036,6.3693067,42.5617975,206.5671699,4.321514,32.4316569,14.8853722,36.7041229,5.2533007,10.561827,1.6509812,37.2076836),(15075,'metacarpus.tif',40,5,584,25.2840172,6.3037922,10.9288252,1.8,6.3961228,10.9042468,1.554886,2.9572636,5.374817,41.4069365,202.3695123,4.2129362,37.6514237,14.0017742,44.483213,5.2483792,10.6285428,1.6061798,37.5514244),(15076,'metacarpus.tif',40,5,585,24.7217917,6.2884063,10.9780322,1.8,6.3803234,10.9305202,1.5559098,2.9762886,5.4243495,40.3432808,197.6611495,4.1193856,36.4396042,13.5548953,43.2810369,5.1642375,10.6422508,1.6326642,37.029133),(15077,'metacarpus.tif',40,5,586,23.8953617,6.2652145,10.9845314,1.8,6.3587743,10.9498321,1.5573291,3.0035233,5.4325915,39.2230433,192.0530015,3.981838,35.3520052,13.0590109,41.7299144,5.1642375,10.6555267,1.6502746,37.6615511),(15078,'metacarpus.tif',40,5,587,23.0114098,6.2498177,10.9470085,1.8,6.3536176,10.9509086,1.5587242,3.0234762,5.3955525,38.4088006,187.9047643,3.8346761,34.8258615,12.7035234,41.0851749,5.1642375,10.6720983,1.6678357,37.4641056),(15079,'metacarpus.tif',40,5,588,22.1700295,6.2448434,10.897246,1.8,6.3487761,10.9349805,1.5631329,3.3241792,5.3478581,37.8142596,184.4468024,3.6947879,34.4898462,11.3755177,40.8367676,5.1642375,10.6720983,1.6678357,37.3539789),(15080,'metacarpus.tif',40,5,589,21.4438568,6.2499625,10.8739311,1.8,6.3565676,10.9431233,1.5690561,3.4272996,5.3269154,37.2463328,182.3663099,3.5739653,34.23488,10.8675452,40.1721487,5.1699465,10.7492316,1.6495803,39.059322),(15081,'metacarpus.tif',40,5,590,20.9056422,6.2587355,10.8326919,1.8,6.3637559,10.8988277,-1.5686546,3.428946,5.3330313,36.8552475,181.3029887,3.4842577,33.9962354,10.748273,39.6322264,5.2964297,10.7492316,1.6495803,37.8951651),(15082,'metacarpus.tif',40,5,591,20.5911923,6.269902,10.8122594,1.8,6.3720621,10.864315,-1.5665142,3.4236293,5.3517815,36.8044673,181.4189277,3.4318025,33.8987922,10.7501321,39.1756063,5.2964297,10.7656589,1.6669898,39.0042587),(15083,'metacarpus.tif',40,5,592,20.5038821,6.2816574,10.7902379,1.8,6.3748229,10.8539864,-1.5654413,3.4148964,5.3739069,37.0697439,183.0341132,3.4172157,34.0597848,10.8553056,39.3861562,4.6256031,6.6553701,0.9357696,20.55697),(15084,'metacarpus.tif',40,5,593,20.4262362,6.2824986,10.7511609,1.8,6.3650448,10.8345009,-1.5658895,3.4130242,5.4123797,36.9402529,183.94591,3.4042907,33.9861432,10.8233199,39.2634728,5.2639455,10.7492316,1.6495803,39.1332801),(15085,'metacarpus.tif',40,5,594,20.5629122,6.2874688,10.7390929,1.8,6.3634349,10.8442464,-1.5654671,3.4092874,5.4240984,37.2544246,186.335129,3.4270547,34.3531982,10.9273349,39.8449035,5.3579445,10.7422424,1.6408569,39.9308883),(15086,'metacarpus.tif',40,5,595,20.5343943,6.2912657,10.7348527,1.8,6.3760251,10.8394006,-1.5663596,3.4030279,5.4283094,37.1064663,186.2326291,3.4223317,34.3076667,10.903956,39.7779912,5.4379891,10.648476,1.6414749,39.7428903),(15087,'metacarpus.tif',40,5,596,20.5446307,6.2896654,10.7599169,1.8,6.3795557,10.8512237,1.5671882,3.3821963,5.4140152,36.4149709,185.5465267,3.4240605,34.2715191,10.766664,39.154256,5.4407945,10.6816153,1.6765945,40.041015),(15088,'metacarpus.tif',40,5,597,20.7729201,6.2955026,10.7889252,1.8,6.383045,10.8805046,1.5632016,3.3654374,5.390907,35.8942197,186.8701713,3.4619537,34.6639575,10.6655438,39.6946544,5.3579445,10.6634014,1.659062,40.2518211),(15089,'metacarpus.tif',40,5,598,20.8634165,6.2929389,10.8035312,1.8,6.3866774,10.886341,1.5649133,3.372828,5.3736389,35.0836616,186.2850049,3.4771157,34.666454,10.4018531,39.5394043,5.4519436,10.648476,1.6414749,39.340173),(15090,'metacarpus.tif',40,5,599,20.883505,6.2852741,10.8304438,1.8,6.3989214,10.9117389,1.5599393,3.3670533,5.3545608,34.2617707,185.7102989,3.4801739,34.6826392,10.175595,39.4560677,5.5121455,10.5881465,1.677532,41.159556),(15091,'metacarpus.tif',40,5,600,20.7440281,6.2723393,10.8702346,1.8,6.4110657,10.9410357,1.5588354,3.3774339,5.3155139,33.391694,181.6048237,3.4568434,34.165055,9.8867055,38.9354444,5.509759,10.5697716,1.6598459,41.5583601),(15092,'metacarpus.tif',40,5,601,20.3737033,6.2605066,10.9604855,1.8,6.4141091,10.9926892,1.550697,3.0086152,5.2372746,32.529045,172.8556119,3.3942456,33.0048787,10.8119661,37.4784212,5.5303333,10.5165547,1.69626,39.573787),(15093,'metacarpus.tif',40,5,602,19.8453211,6.2522404,11.0235627,1.8,6.4167853,11.0139772,1.5514285,3.0160401,5.1810205,31.3252754,158.8813394,3.306313,30.6660317,10.3862263,34.9699351,5.4330676,10.4774134,1.7329952,40.2785423),(15094,'metacarpus.tif',40,5,603,19.2214928,6.2275199,10.9906438,1.8,6.3902189,10.9523604,-1.5689226,3.1764416,5.1754627,30.0124072,140.4987002,3.2035709,27.1470803,9.4484365,32.2103482,5.5064784,10.4012376,1.6794575,38.894132),(15095,'metacarpus.tif',40,5,604,18.6816419,6.2102085,11.02557,1.8,6.3750494,11.028195,-1.5574872,3.2178165,5.1293807,28.9433646,125.9966884,3.1130555,24.5637235,8.994722,29.4384611,5.509759,9.9701024,1.7126934,36.9190062),(15096,'metacarpus.tif',40,5,605,18.3480659,6.2045994,10.9798296,1.8,6.3775568,11.0109971,-1.5441384,3.2547819,5.1636277,28.2237272,115.6395401,3.0558383,22.3950188,8.6714651,27.3690571,5.4190977,9.8124359,1.6571197,36.9512616),(15097,'metacarpus.tif',40,5,606,18.0649619,6.2198089,10.9041015,1.8,6.3824761,10.9407926,-1.5253263,3.2878864,4.9644885,27.7120311,106.6293079,3.0046063,21.4784075,8.4285245,26.896598,5.4125367,9.3134964,1.6111784,35.6903386),(15098,'metacarpus.tif',40,5,607,17.95633,6.2621788,10.9116331,1.8,6.4122155,10.9760354,-1.5132819,3.2779801,4.9477123,27.3330381,103.0687324,2.9828329,20.8315937,8.3383783,26.1622881,5.3185949,9.1193591,1.7156088,35.5157011),(15099,'metacarpus.tif',40,5,608,17.4344521,6.2902666,10.8521005,1.8,6.4221565,10.8785538,-1.4909276,3.3850443,4.3199789,26.1235668,94.7705863,2.8872456,21.9377428,7.7173486,27.9146606,3.9518028,5.7914386,0.6240231,17.1918998),(15100,'metacarpus.tif',40,5,609,17.4970976,6.3311686,10.9146844,1.8,6.4505836,10.9394817,-1.4897619,3.3417013,4.2536568,25.4060981,93.9539549,2.8970755,22.0878078,7.6027437,28.0107798,3.9288028,5.7616113,0.5880026,16.8159037),(15101,'metacarpus.tif',40,5,610,17.6140149,6.3635374,10.9616089,1.8,6.4728861,10.9794032,-1.4891036,3.3069768,4.2173668,24.5827129,93.1763519,2.9161209,22.0934901,7.433591,27.8093288,0,0,0,0),(15102,'metacarpus.tif',40,5,611,17.4514218,6.3960818,10.9785162,1.8,6.4988211,11.013768,-1.4901046,3.2711426,4.1951778,23.5845674,90.6109739,2.8896732,21.5988398,7.2098866,27.1120828,0,0,0,0),(15103,'metacarpus.tif',40,5,612,17.2522757,6.4263073,10.9859987,1.8,6.5094488,11.0422979,-1.4925541,3.2354713,4.1892719,22.6016227,88.1821135,2.8578125,21.0495082,6.9855735,26.344255,0,0,0,0),(15104,'metacarpus.tif',40,5,613,16.8159902,6.4664689,10.9951454,1.8,6.5158523,11.0751223,-1.4975518,3.1914853,4.1880859,21.1361357,85.1099143,2.7876563,20.3219124,6.6226643,25.1742671,0,0,0,0),(15105,'metacarpus.tif',40,5,614,16.1488082,6.5074912,11.0295441,1.8,6.5547698,11.0873707,-1.4993828,3.1442172,3.9749284,19.2013004,81.0930998,2.6777651,20.4011475,6.1068619,23.9030899,0,0,0,0),(15106,'metacarpus.tif',40,5,615,15.23437,6.5642784,11.0888669,1.8,6.6228126,11.1251741,-1.5014034,2.9854322,3.9117866,16.8409731,76.6511524,2.5268547,19.5949216,5.6410503,22.867028,3.8693761,5.2370198,2.7744188,15.399238),(15107,'metacarpus.tif',40,5,616,14.2913515,6.62092,11.1583116,1.8,6.6847509,11.1433599,-1.4955765,3.6752093,3.8434793,14.9889991,72.5497518,2.3684405,18.8760615,4.0784069,21.3878927,3.6494782,4.9400938,2.7716866,14.6889485),(15108,'metacarpus.tif',40,5,617,13.4788915,6.677787,11.2498181,1.8,6.7233698,11.1784846,-1.4864712,3.6041233,3.8350741,13.7632356,68.2328417,2.2305456,17.791792,3.8187471,20.2199595,3.7158041,5.0488942,2.7195876,16.4627156),(15109,'metacarpus.tif',40,5,618,12.3553296,6.749697,11.3605432,1.8,6.741717,11.243649,-1.4907205,3.6208235,3.8899248,12.0423117,60.7512627,2.0460458,15.617593,3.3258488,17.51624,3.4709615,4.963291,2.7118304,16.0733588),(15110,'metacarpus.tif',40,5,619,11.7054145,6.831382,11.4277006,1.8,6.7719801,11.259766,-1.4993687,3.448765,3.9402447,10.991137,55.5916161,1.940966,14.1086709,3.1869777,16.418396,3.477964,4.963291,2.7118304,17.5356405),(15111,'metacarpus.tif',40,5,620,8.5141855,6.9118331,11.6829878,1.8,6.9125678,11.5985841,-1.5134404,2.908539,4.1749129,7.7366075,44.8413483,1.4143679,10.7406667,2.6599635,12.4219302,3.4362126,4.8315866,0.6473921,17.0172624),(15112,'metacarpus.tif',40,5,621,6.897547,7.0076413,11.8000054,1.8,6.9395866,11.7774996,-1.5123977,2.8050749,4.2088476,6.1413463,37.5182196,1.1456751,8.9141311,2.1893698,10.318346,3.1812451,4.698071,2.7945311,16.3069729),(15113,'metacarpus.tif',40,5,622,5.8666824,7.0885209,11.8655048,1.8,6.9377917,11.8858268,-1.517171,2.8146619,4.2736333,5.1319084,31.9982688,0.9749713,7.4873689,1.823277,8.6673277,3.4428749,4.698071,2.7945311,17.1824524),(15114,'metacarpus.tif',40,5,623,3.6649484,7.3000835,11.9168733,1.8,7.157229,11.9942256,1.5669608,1.9443684,4.3046011,2.0089488,22.4356176,0.6108157,5.2120086,1.033214,5.6498145,0,0,0,0),(15115,'metacarpus.tif',40,5,624,2.5759456,7.4279067,12.140072,1.8,7.2969116,12.1020729,1.5661187,1.7913967,4.4347507,1.0394658,15.2472051,0.4293149,3.4381201,0.5802544,3.645065,0,0,0,0),(15116,'metacarpus.tif',40,5,625,1.5830736,7.5702245,12.7472299,1.8,7.5405561,12.3754877,1.5616629,1.0948833,4.9507149,0.3644471,7.1391088,0.2638236,1.4420359,0.3328639,1.5057349,0,0,0,0),(15117,'metacarpus.tif',40,5,626,0.9213828,7.6268403,13.6046905,1.8,7.6179,13.4547919,-1.5407825,0.9330506,5.7086342,0.1663498,0.5543585,0.1534255,0.0971088,0.1782859,0.126233,1.0663517,2.024801,0.3805064,5.3457301),(15118,'metacarpus.tif',40,5,627,0.6150143,7.6970602,13.7770585,1.8,7.7119202,13.7738574,-0.1451605,0.5297193,0.855535,0.0306234,0.0791607,0.0021448,0.0925277,0.0578106,0.1278788,1.0339893,1.7560467,0.2709469,4.6165459),(15119,'metacarpus.tif',40,5,628,0.2737294,7.75602,13.8050133,1.8,7.7625708,13.7894386,-0.0528072,0.44913,0.6218417,0.009908,0.0235183,0.0001271,0.0378204,0.0220605,0.051888,0.8459912,1.3686465,0.2782997,3.9746804),(15120,'metacarpus.tif',40,5,629,0.0604954,7.7570847,13.8052964,1.8,7.73142,13.7943572,0.0351773,0.2642347,0.4244558,0.0007252,0.0029026,0.0000125,0.0068385,0.0027446,0.0082769,0.4699951,0.8917531,0.3217506,2.3244006),(15121,'metacarpus.tif',40,5,630,37.8874229,8.1449689,10.2189044,1.8,8.3659754,10.212664,1.4987882,5.6408707,8.0936184,179.4029341,587.6121656,6.2818849,72.6019111,31.8041209,92.4720507,5.3809592,6.5624517,2.4780369,34.0951222),(15122,'metacarpus.tif',40,5,631,36.582617,8.2599883,10.2492625,1.8,8.4475753,10.2133905,1.4870711,5.4980552,8.1123238,165.4770839,573.7418163,6.0544625,70.7247184,30.0973849,89.1876953,5.4936975,6.393316,2.2937757,33.1417713),(15123,'metacarpus.tif',40,5,632,34.5580279,8.404587,10.2531933,1.8,8.5480458,10.2087281,1.4783086,5.3262429,8.101715,148.2740905,552.9630229,5.7105435,68.2525886,27.8384017,84.7897364,5.4519436,6.3822501,2.3770248,33.9849955),(15124,'metacarpus.tif',40,5,633,31.9392602,8.5756172,10.228036,1.8,8.6686745,10.2164135,1.4652709,5.1308265,8.0872496,130.568523,526.9080419,5.2641526,65.1529347,25.4478536,80.3287031,5.0759475,6.3231378,2.3036114,34.5489897),(15125,'metacarpus.tif',40,5,634,29.0641278,8.752814,10.1337736,1.8,8.7860337,10.2096745,1.452716,4.893191,7.9666197,112.9161103,498.0699024,4.7767946,62.5196032,23.0761707,75.6727719,4.7939504,6.2103415,2.2597207,31.7935296),(15126,'metacarpus.tif',40,5,635,26.2891371,8.9072998,9.9795282,1.8,8.9060357,10.1598393,1.4421919,4.7088488,7.7983141,96.6533754,460.6546185,4.309455,59.0710519,20.5259034,71.1482271,4.5119533,6.0758574,2.1802549,29.5887031),(15127,'metacarpus.tif',40,5,636,24.3747971,9.0819468,9.9564848,1.8,9.0263468,10.1337917,1.4191135,4.4401502,7.7990027,87.4671454,440.7876247,3.9697129,56.51846,19.6991413,67.5579099,4.1359572,5.998287,2.1327179,33.297514),(15128,'metacarpus.tif',40,5,637,22.8326979,9.2417343,9.9538401,1.8,9.1486735,10.0565621,1.3961468,4.2325595,7.8091805,79.8724376,424.4967975,3.6905495,54.358687,18.8709544,64.4068492,3.8539601,5.9346076,2.0840486,25.6140227),(15129,'metacarpus.tif',40,5,638,20.7308792,9.4124815,9.9360508,1.8,9.3151786,9.9995715,1.3782213,3.9994089,7.8126761,70.0566627,397.2499986,3.3285881,50.8468538,17.5167543,59.664683,3.5336873,6.0115299,2.0414368,29.1576436),(15130,'metacarpus.tif',40,5,639,18.1144898,9.6290234,9.9122664,1.8,9.5274243,9.9667848,1.3595571,3.7168668,7.8428525,58.4268113,361.3349441,2.886356,46.071878,15.7193717,53.4555221,3.2789961,6.0954582,1.9169323,25.8570841),(15131,'metacarpus.tif',40,5,640,15.5389401,9.8663629,9.8201214,1.8,9.7726852,9.8599677,1.3414244,3.502421,7.7987234,46.51093,327.0821585,2.4559417,41.9404741,13.2796513,47.8735332,2.9139698,6.1236597,1.8828384,26.6224369),(15132,'metacarpus.tif',40,5,641,13.3773689,10.107466,9.7347111,1.8,10.0217536,9.8410423,1.3259862,3.5680544,7.7006956,36.2938756,301.2653703,2.0985876,39.1218385,10.1718953,43.7700416,2.6319728,6.0685818,1.8533513,26.9111143),(15133,'metacarpus.tif',40,5,642,11.5190564,10.3532793,9.741161,1.8,10.2998571,9.9656005,1.3167646,3.5587756,7.6936504,28.9840893,274.7864985,1.7985934,35.7160104,8.1443993,39.3909747,1.1269195,2.0182447,2.6571147,6.2212096),(15134,'metacarpus.tif',40,5,643,9.6911912,10.6649604,9.6695943,1.8,10.6250975,10.0389616,1.3007619,3.6426701,7.6328871,20.5932566,249.5657173,1.5002556,32.69611,5.6533411,35.3800519,0,0,0,0),(15135,'metacarpus.tif',40,5,644,7.4598336,11.1560345,9.5754124,1.8,11.0422093,10.1317243,1.2649751,3.9708872,7.6783492,8.7189791,208.0486188,1.1306037,27.0954879,2.1957257,28.2309973,0,0,0,0),(15136,'metacarpus.tif',40,5,645,5.9694877,11.5754449,9.8379878,1.8,11.516343,10.329198,1.252617,3.9919922,7.9702552,3.0637833,168.8940272,0.8975448,21.1905421,0.7674823,21.5747022,0,0,0,0),(15137,'metacarpus.tif',40,5,646,4.9340654,11.9342485,10.4909322,1.8,11.8782093,10.7449471,1.2572385,2.5937023,8.4363117,1.8220577,130.0926312,0.7441078,15.4205577,0.702493,15.6359778,0,0,0,0),(15138,'metacarpus.tif',40,5,647,4.1016371,12.3444326,11.4910961,1.8,12.2172555,11.4470619,1.2642438,2.649382,9.3392065,1.461571,87.2043222,0.621352,9.3374445,0.5516649,9.4924899,0.2819971,0.5481038,1.0303768,1.2286677),(15139,'metacarpus.tif',40,5,648,3.4117671,12.8265488,12.7714458,1.8,12.597646,12.3471793,1.2771598,2.1787977,10.2641048,1.1465357,40.2508899,0.5209924,3.9215198,0.526224,4.0329789,2.1023581,3.5334133,1.0714496,9.6641512),(15140,'metacarpus.tif',40,5,649,3.039005,13.1470755,13.6697371,1.8,12.9347742,13.3537897,1.3206927,2.1635255,10.5927293,1.0236834,9.7592489,0.4754734,0.9213158,0.4731552,1.0175789,0.3759961,0.9586057,1.3734008,2.3472086),(15141,'metacarpus.tif',40,5,650,2.9374593,13.2586554,13.918842,1.8,13.1414362,13.8934285,-1.2111027,2.3832415,1.8532475,0.6422394,1.4524784,0.4289204,0.7837477,0.2694815,0.8783733,0.2819971,0.8666282,1.7894653,2.0585312),(15142,'metacarpus.tif',40,5,651,2.8386465,13.2856079,13.8842789,1.8,13.1745206,13.8501019,-1.2434928,2.3991656,1.8966083,0.5855839,1.3425955,0.424209,0.7078929,0.2440781,0.8035163,2.0801689,3.4931738,1.1553042,10.2965693),(15143,'metacarpus.tif',40,5,652,2.699123,13.3230651,13.8520417,1.8,13.229485,13.8362436,-1.2673908,2.3641574,1.8513222,0.476469,1.2250782,0.4096978,0.6617315,0.2015386,0.7192765,2.0606545,3.4931738,1.1553042,10.218698),(15144,'metacarpus.tif',40,5,653,2.5744582,13.3510998,13.8102166,1.8,13.2608096,13.7902868,-1.2690003,1.8457825,1.8028335,0.4013505,1.1269705,0.3911679,0.6251107,0.2174419,0.8270167,2.0413025,3.3339853,1.1955255,10.0078919),(15145,'metacarpus.tif',40,5,654,2.4436385,13.3787479,13.7852744,1.8,13.2941481,13.7894069,-1.2766643,1.7484373,1.7699397,0.3438749,1.0306974,0.3730428,0.5823347,0.1966756,0.7748686,1.9850263,3.3630114,1.1071487,9.9756366),(15146,'metacarpus.tif',40,5,655,2.3184304,13.4061659,13.7599517,1.8,13.3170072,13.7719338,-1.2763293,1.731878,1.7377893,0.3084817,0.9420717,0.3538569,0.5421093,0.1781197,0.7184436,1.9351363,3.2792056,1.0943289,10.2092506),(15147,'metacarpus.tif',40,5,656,2.217486,13.4301738,13.732442,1.8,13.3562455,13.7563765,-1.2803956,1.081336,1.7041377,0.2632367,0.8767981,0.3392796,0.5145113,0.2434365,0.668017,1.9730754,3.2467106,1.1849137,9.6318958),(15148,'metacarpus.tif',40,5,657,2.1063121,13.4523559,13.7023173,1.8,13.3779522,13.7297162,-1.2966039,1.0137656,1.7579118,0.2424243,0.7927924,0.3253142,0.4509853,0.2391325,0.5882732,1.8926473,3.2125122,1.2120257,9.5768325),(15149,'metacarpus.tif',40,5,658,1.9766995,13.4832378,13.665913,1.8,13.4296495,13.6943235,-1.3310297,0.7366106,1.7114024,0.2049459,0.7063821,0.3108707,0.4127505,0.2782282,0.5312076,1.6915381,3.1959669,1.080839,8.9900303),(15150,'metacarpus.tif',40,5,659,1.8151636,13.5172934,13.6116331,1.8,13.4816054,13.619765,-1.3808605,0.6777264,1.6435863,0.1688444,0.5836035,0.291744,0.3550793,0.2491336,0.4550418,1.6536396,3.1133409,1.0666304,8.2474855),(15151,'metacarpus.tif',40,5,660,1.5097783,13.597579,13.5546459,1.8,13.586776,13.5311599,-1.4378604,0.560934,1.5634499,0.0987363,0.457299,0.2472091,0.2924935,0.1760213,0.3526905,1.4099854,3.0372015,1.1902899,7.537196),(15152,'metacarpus.tif',40,5,661,1.0748716,13.7245341,13.4883663,1.8,13.7284155,13.4646485,-1.4888487,0.3547808,1.4746309,0.0363543,0.3080917,0.1779449,0.208928,0.1024697,0.2321987,1.1279883,2.944136,1.2793395,6.9503938),(15153,'metacarpus.tif',40,5,662,0.6031247,13.8635147,13.3907357,1.8,13.8668999,13.3458184,-1.5381499,0.1685954,1.2688334,0.0068791,0.1612601,0.1004137,0.1270932,0.0408023,0.1320971,0.8459912,2.5998846,1.3521274,5.7767895),(15154,'metacarpus.tif',40,5,663,0.1483239,14.0046029,13.2688276,1.8,14.0019384,13.2107799,-1.5683387,0.0900112,1.1429528,0.0001257,0.0397975,0.0247205,0.0348199,0.0013961,0.0349298,0.5639942,2.2735331,1.4464413,5.0342447),(15155,'metacarpus.tif',40,5,664,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15156,'metacarpus.tif',40,5,665,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15157,'metacarpus.tif',40,5,666,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15158,'metatarsal.tif',40,10,1,10.0467435,10.3218523,15.8816414,1.8,10.2388622,15.8114688,0.1991717,2.4172741,6.774547,10.6172024,140.0657602,0.065551,20.6752955,4.3922211,22.0119157,7.8080867,12.9746185,0.2938693,42.6451659),(15159,'metatarsal.tif',40,10,2,9.9370716,10.880032,15.8460115,1.8,10.7480009,15.7084281,0.2045555,4.4991996,6.3898441,18.8939363,143.3825481,0.0683382,22.4391309,4.1993994,25.145301,7.6693054,12.7263322,0.2730087,41.6169071),(15160,'metatarsal.tif',40,10,3,10.9719328,10.9764835,15.1617462,1.8,11.0185742,15.1823166,0.4074152,4.0106978,6.8623922,40.7264804,167.013407,0.2871064,24.3374909,10.1544625,30.1852022,5.8007,12.5470029,0.2702497,33.910481),(15161,'metatarsal.tif',40,10,4,12.8527606,10.9512914,14.8056502,1.8,11.0518156,14.8499668,0.5012452,4.5164488,7.1198515,48.0894326,208.828915,0.4946116,29.3305156,10.6476205,35.7740541,0,0,0,0),(15162,'metatarsal.tif',40,10,5,15.0674472,11.0556813,14.5764323,1.8,11.1777764,14.6455323,0.5208669,4.7000896,7.1839665,53.29626,264.7293443,0.6218783,36.8500247,11.3394135,43.8014416,0,0,0,0),(15163,'metatarsal.tif',40,10,6,17.6745964,11.2281977,14.402508,1.8,11.3785797,14.4679042,0.520412,4.8137535,7.1515082,59.1996533,313.9525342,0.7283267,43.9001854,12.2980233,51.4957377,0,0,0,0),(15164,'metatarsal.tif',40,10,7,20.1560349,11.447335,14.2869137,1.8,11.5662542,14.3209172,0.5006204,4.8549178,7.0640866,64.1633923,337.6254566,0.7738946,47.7946374,13.2161645,56.5053895,0,0,0,0),(15165,'metatarsal.tif',40,10,8,23.8783192,11.7024168,14.1566418,1.8,11.8041588,14.1525489,0.5070777,7.3744271,6.93153,77.0603907,367.5364066,0.9385428,53.0238498,10.4496783,57.0272725,4.1217353,8.8164105,2.5741527,24.7614898),(15166,'metatarsal.tif',40,10,9,27.6146941,11.8488386,13.9262925,1.8,11.9351025,13.9396041,0.5554604,7.0606494,6.821788,107.920163,406.9033109,1.2798568,59.647604,15.2847362,67.0453945,4.3403307,9.497603,2.5273431,26.7619373),(15167,'metatarsal.tif',40,10,10,29.6843366,11.6641144,13.324914,1.8,11.7722917,13.378375,0.6755735,6.4082583,7.0774954,150.2025928,405.3872436,1.9347081,57.278348,23.4389104,76.8581255,4.5983016,10.4913744,2.5557499,29.3879498),(15168,'metatarsal.tif',40,10,11,30.5940089,11.2604697,12.1666002,1.8,11.4062696,12.2335434,1.0573398,5.0279993,7.2485678,179.9666449,332.2343923,3.8687726,45.834488,35.7928934,63.1921897,8.6192638,10.8328778,2.6205756,37.5763647),(15169,'metatarsal.tif',40,10,12,31.4864578,11.1600995,11.1662703,1.8,11.2644612,11.3126913,1.3004493,4.9950214,7.218154,183.4553899,300.9053582,4.8734521,41.687301,36.7276483,62.8600262,8.6279119,11.0364574,2.69781,39.1741184),(15170,'metatarsal.tif',40,10,13,35.3784843,11.2497702,10.4734554,1.8,11.3453164,10.5954456,1.1769773,5.7666931,7.7244766,208.3558062,332.7426555,5.0282296,43.0764013,36.1308987,69.8836792,8.6596,11.2217857,0.4929552,40.5886484),(15171,'metatarsal.tif',40,10,14,38.0788687,11.795415,10.3285153,1.8,11.8533173,10.4535996,0.7374771,5.71027,6.6084003,254.424044,326.6717314,2.8695742,49.4327999,44.555519,77.4477551,8.7299538,11.3280519,0.4797752,40.6084721),(15172,'metatarsal.tif',40,10,15,38.9910091,12.2971537,10.4141208,1.8,12.2079191,10.5007375,0.2927385,4.6680902,5.9912395,239.4068779,337.2303088,0.5411674,56.2872354,51.2858298,90.3452471,8.9380358,11.3324703,0.4958945,37.5565409),(15173,'metatarsal.tif',40,10,16,38.3713964,12.4852382,10.673028,1.8,12.3479616,10.6817221,0.347997,4.8080132,5.7820724,254.9686513,332.7291567,0.7437118,57.5449658,53.0299398,90.8751716,9.1773427,11.4043953,0.4924858,36.8468709),(15174,'metatarsal.tif',40,10,17,37.6985904,12.4227144,10.6451468,1.8,12.302364,10.5914519,0.5759645,5.6561468,5.8778202,253.7822882,333.6099944,1.8637997,56.7574346,44.8684056,90.9088122,9.4666843,11.3715717,0.5022137,37.0581297),(15175,'metatarsal.tif',40,10,18,38.2481481,12.2215557,10.6666569,1.8,12.1636871,10.5999839,0.7713948,5.9874306,5.8401617,250.3845581,345.8429196,3.0980904,59.2180387,41.8183649,95.0373857,9.6852553,11.2686782,0.515549,36.8072234),(15176,'metatarsal.tif',40,10,19,39.4711726,12.005236,10.8063863,1.8,11.9417422,10.6998221,0.7987946,5.7795343,5.9474009,267.5692235,354.5179863,3.3773826,59.6088933,46.2959831,103.8096682,9.7824106,11.292938,2.0117941,36.9425884),(15177,'metatarsal.tif',40,10,20,39.5740059,12.0487082,10.8617334,1.8,12.0460356,10.8114897,1.0127778,5.8463659,5.9673302,262.1579075,375.0160495,4.7463945,62.8448628,44.8411738,106.776744,9.9308907,11.4204794,1.9061207,44.7761683),(15178,'metatarsal.tif',40,10,21,40.9249008,12.1268648,10.6998084,1.8,12.1218704,10.7540446,1.1339723,5.8277864,6.1276874,248.9081633,390.9850505,5.6000064,63.8062986,42.7105845,104.4262455,9.9991216,11.5269406,1.8656475,48.4981221),(15179,'metatarsal.tif',40,10,22,1.5932782,9.2062003,7.807457,1.8,9.2007138,7.8034282,-0.9529311,0.6972965,1.3826894,0.1371278,0.5381354,0.1764332,0.3891947,0.1966563,0.4806213,1.3287244,2.6599593,0.8288491,6.4949437),(15180,'metatarsal.tif',40,10,23,4.5172913,9.4369796,7.9176412,1.8,9.4324617,7.9273702,-0.8879263,1.224856,2.0372466,1.3034808,2.9725099,0.4530927,1.459082,1.064191,2.0776721,2.3685956,3.6719583,1.0074801,9.8422387),(15181,'metatarsal.tif',40,10,24,14.9202664,10.9971094,7.7170322,1.8,11.0326074,7.7544327,-0.3450997,2.2487435,3.5634084,11.4376358,46.5744649,0.2845803,13.0702011,5.0862341,16.0616798,3.9406503,6.9847528,0.4217873,19.9552073),(15182,'metatarsal.tif',40,10,25,19.1024344,10.9960604,8.0248372,1.8,10.9447117,8.162614,-0.5065094,3.1677028,4.5483695,25.2498641,64.4145055,0.7492899,14.1621091,7.9710332,19.6547033,5.0578767,8.1409448,0.5490251,24.3704085),(15183,'metatarsal.tif',40,10,26,24.8487187,10.879238,9.4178593,1.8,10.8717361,9.5990121,-1.3450033,3.6040275,4.710311,58.9701614,156.442943,3.9338754,33.2128691,16.3622949,42.1005747,6.8885289,9.2908384,0.9730379,34.9455422),(15184,'metatarsal.tif',40,10,27,30.6533706,11.1608992,10.1652242,1.8,11.233806,10.2359939,1.4677874,4.426701,4.6094915,120.0729284,188.0987249,5.0548769,40.8068272,27.1246983,61.2355026,8.2302212,9.2158179,0.9237491,38.0781772),(15185,'metatarsal.tif',40,10,28,36.2854924,11.8096614,10.153891,1.8,11.964077,10.1984167,0.2071863,5.0867997,5.1223285,176.8355217,229.0725408,0.2559061,44.7203921,34.7636105,74.0840565,8.6705664,9.8921124,2.604006,32.2730797),(15186,'metatarsal.tif',40,10,29,33.9101475,12.0567801,10.0097129,1.8,12.0805181,10.1303247,0.1392643,5.1654635,4.9821783,159.1931776,235.2399322,0.1089052,47.2162812,30.8187596,72.6097069,8.5215176,10.0676812,0.2626933,32.7072097),(15187,'metatarsal.tif',40,10,30,28.3354965,12.4605222,9.8825242,1.8,12.4993377,10.0305564,0.6668281,4.6330568,5.135855,122.7078831,180.7536699,1.8065681,35.194465,26.4852967,55.1459163,8.2196395,9.725389,2.5838838,31.9661035),(15188,'metatarsal.tif',40,10,31,26.0538344,12.4505638,9.9179081,1.8,12.5183153,10.050176,0.7382504,4.4369091,4.9940526,108.5598231,172.4217829,1.9667263,34.5254241,24.4674435,50.6452236,7.9422655,9.518313,2.5702552,34.4205047),(15189,'metatarsal.tif',40,10,32,24.9558712,12.3262204,9.9071275,1.8,12.3952574,10.0310874,0.6710851,4.2820728,4.9947134,102.1484753,166.810768,1.6083235,33.3974652,23.8549132,53.588791,7.9992812,9.3184572,2.5876401,34.1613872),(15190,'metatarsal.tif',40,10,33,23.1388556,12.3646687,9.8955602,1.8,12.4281786,10.0234177,0.777952,4.104312,4.8805121,88.646526,153.4786458,1.8995232,31.4472424,21.5983888,49.0314692,7.5749075,9.0720116,2.4710711,32.2450447),(15191,'metatarsal.tif',40,10,34,22.8228182,12.2068028,9.9120027,1.8,12.2530237,10.0276029,0.7535127,3.7145625,4.7519366,88.651344,147.949624,1.7806978,31.1345956,23.8658909,48.2553502,7.3139853,8.8421144,2.5202691,30.9576685),(15192,'metatarsal.tif',40,10,35,22.0955484,12.1357332,9.9080095,1.8,12.1752865,10.022399,0.7818757,3.6488914,4.7480994,83.5482979,141.5522389,1.8283239,29.8124001,22.8968992,46.6539357,7.1886227,8.7281453,2.5224313,30.4674685),(15193,'metatarsal.tif',40,10,36,21.678245,12.0893348,9.8960532,1.8,12.1228795,9.9936435,0.7899252,3.5231828,4.6749209,79.4385853,136.2607134,1.8228765,29.1471701,22.5473926,45.6306105,7.0797292,8.595601,2.5113987,29.0611498),(15194,'metatarsal.tif',40,10,37,21.4480346,12.0652791,9.8972068,1.8,12.0941249,9.9848074,0.7997515,3.465518,4.6931746,75.5412716,132.9911482,1.8386376,28.3371408,21.7979739,44.3949144,6.9530647,8.5363795,2.4578833,28.6386323),(15195,'metatarsal.tif',40,10,38,21.3425751,12.0391807,9.8887382,1.8,12.0636445,9.9690457,0.8126575,3.4190106,4.6663656,72.1600084,130.1438877,1.8754639,27.8897754,21.1055236,43.266747,6.8368697,8.4542724,2.4245808,27.2323135),(15196,'metatarsal.tif',40,10,39,21.445138,12.0332557,9.8997636,1.8,12.0519171,9.9734233,0.8349872,3.4575415,4.6127763,70.5641476,129.3555416,1.9640452,28.042882,20.408764,43.2816963,6.7499493,8.3817192,2.3217254,26.8856898),(15197,'metatarsal.tif',40,10,40,21.5781807,12.01061,9.8993325,1.8,12.0249927,9.9704352,0.8565538,3.4981133,4.5250127,68.6810682,127.9071834,2.0532204,28.2667016,19.6337458,43.3799624,6.702351,8.2710911,2.3072825,26.646396),(15198,'metatarsal.tif',40,10,41,21.5123497,11.981208,9.8889476,1.8,11.9897277,9.955503,0.872541,3.5250899,4.5228356,66.4657262,126.0079349,2.1035575,27.8603838,18.8550445,42.3449849,6.6488345,8.2355059,2.2083451,26.2238785),(15199,'metatarsal.tif',40,10,42,21.6853255,11.9515749,9.8751317,1.8,11.9638795,9.9337341,0.878828,3.5764101,4.5030049,65.4939729,124.6442523,2.1428249,27.6802389,18.3127691,41.9941739,6.6590793,8.2058693,2.1864162,26.1479848),(15200,'metatarsal.tif',40,10,43,21.8751,11.920499,9.8611093,1.8,11.9315824,9.9188769,0.8852113,3.573895,4.4962454,64.7760297,122.7010011,2.1844165,27.2896585,18.1247712,41.3217517,6.6185606,8.1838772,2.1283374,25.8492198),(15201,'metatarsal.tif',40,10,44,22.0136844,11.8814277,9.824573,1.8,11.888727,9.878377,0.8892728,3.5744247,4.4607033,63.701229,119.5681617,2.2128486,26.8047779,17.8213933,40.4033648,6.5578161,8.1544622,1.9941071,25.5901023),(15202,'metatarsal.tif',40,10,45,22.103326,11.8515302,9.7982803,1.8,11.8586716,9.8542914,0.8905624,3.530874,4.4767495,62.5092827,117.5350082,2.2265069,26.2545419,17.7036287,39.8834378,6.5438247,8.0986091,2.1112158,25.3590198),(15203,'metatarsal.tif',40,10,46,22.173358,11.8227819,9.7713191,1.8,11.8315732,9.8233588,0.8895164,3.5234204,4.5151876,61.6780508,115.1190669,2.2297803,25.4959652,17.5051638,38.836893,6.5069061,8.0986091,2.1112158,25.0800785),(15204,'metatarsal.tif',40,10,47,22.2674064,11.784231,9.7425482,1.8,11.7858002,9.786451,0.88509,3.5547667,4.4960213,60.7604279,112.7753212,2.2231506,25.0833602,17.0926627,38.3255152,6.4776539,8.0568794,2.1025204,24.984361),(15205,'metatarsal.tif',40,10,48,22.3263035,11.7509788,9.7178004,1.8,11.7459897,9.760361,0.8846865,3.5554121,4.4324993,59.8373582,110.7835906,2.227559,24.9934819,16.8299358,38.0797706,6.4195991,7.9865668,2.1077071,24.685596),(15206,'metatarsal.tif',40,10,49,22.4571637,11.7258841,9.690307,1.8,11.7205171,9.7293535,0.8879081,3.5993063,4.4083708,59.3580796,108.7938745,2.2524285,24.67893,16.4915333,37.8101244,6.4435643,7.9316353,2.0068012,24.522196),(15207,'metatarsal.tif',40,10,50,22.5751559,11.6945097,9.6623373,1.8,11.690035,9.6951014,0.8907122,3.6094784,4.4000986,59.2419026,106.8728716,2.2745865,24.2887446,16.4128706,37.3698445,6.4146351,7.9194234,1.9513027,24.358796),(15208,'metatarsal.tif',40,10,51,22.6115184,11.6613937,9.6426374,1.8,11.6545457,9.680355,0.8886719,3.5925298,4.3834637,58.7533667,105.088448,2.2707279,23.9738376,16.3543159,36.9220869,6.4022937,7.8974788,1.9974238,24.7532785),(15209,'metatarsal.tif',40,10,52,22.6306899,11.6282852,9.6173685,1.8,11.6191936,9.6509587,0.8903678,3.5735697,4.3736997,58.3199201,103.6397702,2.2789114,23.696133,16.3197935,36.5160578,6.3723894,7.8746256,1.9647894,24.1277135),(15210,'metatarsal.tif',40,10,53,22.6766904,11.6013555,9.6040522,1.8,11.59495,9.6418733,0.8919234,3.5757436,4.3508129,58.0260153,102.479445,2.289292,23.5540913,16.227678,36.3107933,6.3566792,7.8602024,1.9320001,24.0996785),(15211,'metatarsal.tif',40,10,54,22.6925083,11.5715068,9.5823922,1.8,11.5620878,9.6163306,0.8924606,3.5669981,4.3232137,57.69781,101.1349445,2.2928744,23.3934644,16.1754528,36.2436504,6.3192117,7.8317025,1.9222411,23.9362785),(15212,'metatarsal.tif',40,10,55,22.7339307,11.539417,9.5665493,1.8,11.5323465,9.6011738,0.8969581,3.5591733,4.3330749,57.1433958,99.9737694,2.313695,23.072246,16.0552439,35.936564,6.3066404,7.8039539,1.9124118,23.9164548),(15213,'metatarsal.tif',40,10,56,22.8315041,11.5085791,9.5492015,1.8,11.5012274,9.5827665,0.8950989,3.5429857,4.3265989,56.6730807,99.0268658,2.316723,22.8879238,15.9958538,35.6149763,6.2911175,7.7838279,1.9357094,23.7810898),(15214,'metatarsal.tif',40,10,57,22.7409579,11.4764157,9.5331998,1.8,11.4684298,9.5672488,0.9025355,3.502121,4.3130057,56.0577167,97.7376112,2.3349991,22.6611367,16.0067905,35.2683248,6.2274225,7.7838279,1.9357094,23.5896548),(15215,'metatarsal.tif',40,10,58,22.8066823,11.4507894,9.5208473,1.8,11.4446271,9.5522519,0.908389,3.4993498,4.2919514,55.7618439,97.3939946,2.3633589,22.6922408,15.9349158,35.2575665,6.2274225,7.7838279,1.9357094,23.5896548),(15216,'metatarsal.tif',40,10,59,22.8864229,11.4159936,9.5044348,1.8,11.4075427,9.5364226,0.9120523,3.4878835,4.2786437,55.2862957,96.3810774,2.3851618,22.5260818,15.8509583,34.9807716,6.2196611,7.7550473,1.9258679,23.4741135),(15217,'metatarsal.tif',40,10,60,22.9951789,11.3842545,9.4855226,1.8,11.3804065,9.5199635,0.9106233,3.4721243,4.261937,55.0101475,95.5380203,2.3911923,22.4165724,15.8433694,34.777461,6.1976924,7.7550473,1.9258679,23.3305373),(15218,'metatarsal.tif',40,10,61,22.899409,11.347122,9.4609224,1.8,11.3393691,9.4917631,0.909012,3.4696625,4.2384824,54.406942,94.3206792,2.3752734,22.2534084,15.6807594,34.6196035,6.1480977,7.7075626,1.9394922,23.2628548),(15219,'metatarsal.tif',40,10,62,22.9226673,11.3188089,9.4439575,1.8,11.3153767,9.4745821,0.9065537,3.4537694,4.2171932,54.0235737,93.1640207,2.3685742,22.0914755,15.641917,34.3429716,6.1320615,7.6997645,1.9059689,23.0317723),(15220,'metatarsal.tif',40,10,63,22.9652704,11.284866,9.4235664,1.8,11.2794157,9.4525141,0.902785,3.4336074,4.1871788,53.754277,92.0759542,2.3589599,21.9899744,15.6553359,34.3307035,6.1446575,7.6501919,1.9195673,22.9839135),(15221,'metatarsal.tif',40,10,64,22.960338,11.2537313,9.4079726,1.8,11.2518962,9.4405295,0.8972845,3.4101441,4.1638313,53.3575588,90.8802929,2.3379551,21.8261228,15.6467169,34.0374088,6.0770955,7.6314098,1.9433506,22.752831),(15222,'metatarsal.tif',40,10,65,22.9756722,11.2232206,9.3917314,1.8,11.2184918,9.4202499,0.8935432,3.3905818,4.1801618,52.9337077,89.7790268,2.3255354,21.4774049,15.6119836,33.7045263,6.0804822,7.6020522,1.9333406,22.7330073),(15223,'metatarsal.tif',40,10,66,22.9576509,11.19076,9.368217,1.8,11.1883049,9.3977343,0.8851575,3.3670742,4.1498751,52.5319079,88.881075,2.2923168,21.4177709,15.6016485,33.6689877,6.0229257,7.5734622,1.9232539,22.7049723),(15224,'metatarsal.tif',40,10,67,22.9351487,11.1589919,9.3493759,1.8,11.1556715,9.3750592,0.8835248,3.351923,4.1316978,51.9932069,87.8605673,2.2839505,21.2650035,15.5114561,33.3668738,6.0076869,7.5416668,1.9714207,22.6571135),(15225,'metatarsal.tif',40,10,68,22.9564417,11.1258016,9.335312,1.8,11.1222938,9.3606097,0.8695522,3.3236619,4.0911823,51.3975517,87.2810644,2.2334983,21.3339463,15.4641338,33.420131,5.9907527,7.4968376,1.927016,22.426031),(15226,'metatarsal.tif',40,10,69,23.0775971,11.0945569,9.3183397,1.8,11.0944054,9.3438745,0.8609089,3.2965679,4.0650231,51.2133412,86.7024096,2.2124647,21.3288846,15.5353517,33.3222785,5.960106,7.4923845,1.8925469,22.3781723),(15227,'metatarsal.tif',40,10,70,23.2254807,11.0499857,9.3017443,1.8,11.0430539,9.3257433,0.8450327,3.2475714,4.0399269,50.8644849,85.8100661,2.1657499,21.2404999,15.6623144,33.0533613,5.9598986,7.449499,1.9411198,22.262631),(15228,'metatarsal.tif',40,10,71,23.2413823,11.0183393,9.2892185,1.8,11.0162117,9.311201,0.8330598,3.2179277,4.0376197,50.6185895,85.2657989,2.1211227,21.117838,15.7301824,32.9679081,5.9176366,7.449499,1.9411198,22.262631),(15229,'metatarsal.tif',40,10,72,23.1413637,10.9907017,9.2732464,1.8,10.9904728,9.2972366,0.8261946,3.1960799,4.0236593,50.1535346,84.5535363,2.0856202,21.0140894,15.692203,32.709521,5.8503281,7.4347,1.9655874,22.2147723),(15230,'metatarsal.tif',40,10,73,23.050052,10.963547,9.2528141,1.8,10.9641273,9.2768889,0.8165446,3.172963,3.9925431,49.6898339,83.741861,2.040415,20.9745666,15.6603889,32.4750179,5.8449353,7.403661,1.955401,22.0315485),(15231,'metatarsal.tif',40,10,74,22.9464055,10.935089,9.2356466,1.8,10.935679,9.2588939,0.8050623,3.1437394,3.9566145,49.2140959,83.0132979,1.9873846,20.980891,15.6546358,32.2680123,5.8449353,7.3919314,1.9205116,22.0035135),(15232,'metatarsal.tif',40,10,75,22.87437,10.9073295,9.2209732,1.8,10.9092088,9.2482312,0.7940351,3.1153983,3.9725434,48.6348391,82.2342771,1.9391232,20.7006618,15.6111144,32.1818923,5.7990671,7.3439166,1.9347753,22.071196),(15233,'metatarsal.tif',40,10,76,22.891321,10.8775503,9.2045942,1.8,10.8787054,9.2295362,0.7881885,3.094665,3.9427185,48.2699024,81.8955478,1.9182557,20.7713403,15.5977795,31.8892647,5.7990671,7.3593517,1.9698573,21.935831),(15234,'metatarsal.tif',40,10,77,22.8953659,10.8512575,9.1873875,1.8,10.8553404,9.2123315,0.7812324,3.1336634,3.9114184,47.900885,81.3045494,1.8920514,20.7864621,15.285906,31.7493597,5.7632522,7.3439166,1.9347753,21.935831),(15235,'metatarsal.tif',40,10,78,22.8388493,10.8178157,9.169701,1.8,10.8147885,9.1941304,0.7770566,3.0603224,3.9424115,47.437236,80.9025755,1.871487,20.5210884,15.5007314,31.5206518,5.7508507,7.3279936,1.9595841,22.0035135),(15236,'metatarsal.tif',40,10,79,22.8133362,10.7953626,9.1553211,1.8,10.7973723,9.1805543,0.7659657,3.0394992,3.9073679,47.1495642,80.4813385,1.8272434,20.5973279,15.5122805,31.4831426,5.7256357,7.3097534,2.0094491,21.7526073),(15237,'metatarsal.tif',40,10,80,22.8421744,10.7634282,9.1363436,1.8,10.7660561,9.1612347,0.755281,3.0618683,3.8816038,46.9213514,80.1515863,1.7889268,20.6490899,15.3244184,31.408842,5.6839009,7.2841403,1.9742154,21.8004661),(15238,'metatarsal.tif',40,10,81,22.7222549,10.7420397,9.1218557,1.8,10.7450174,9.1458036,0.7459491,3.0410499,3.8467077,46.3635445,79.4796752,1.7442807,20.6617401,15.2459005,31.476679,5.6805052,7.2418651,1.9890207,21.7047485),(15239,'metatarsal.tif',40,10,82,22.7161094,10.7196311,9.1089432,1.8,10.7179406,9.1293822,0.740183,2.9803611,3.8690783,45.8983305,79.4334453,1.7220568,20.5303279,15.4002582,31.1739107,5.6312396,7.2418651,1.9890207,21.6370661),(15240,'metatarsal.tif',40,10,83,22.6098711,10.6999913,9.097599,1.8,10.7018553,9.1223508,0.7321524,3.0058001,3.8809347,45.2844532,79.403253,1.6838883,20.4598271,15.0656901,31.0742412,5.606764,7.2215591,1.9534035,21.6370661),(15241,'metatarsal.tif',40,10,84,22.5303666,10.6719196,9.0783397,1.8,10.6728923,9.1025428,0.7211223,2.9817099,3.8608392,44.6686313,78.8395183,1.6368348,20.4203061,14.9808775,30.8703477,5.5621838,7.2090702,1.9786643,21.5892073),(15242,'metatarsal.tif',40,10,85,22.5093345,10.6446133,9.0626329,1.8,10.644374,9.0866666,0.7126598,2.960419,3.8705278,44.1760437,78.1840351,1.6038575,20.1998383,14.9222268,30.693706,5.5522047,7.1770555,1.9682144,21.4538423),(15243,'metatarsal.tif',40,10,86,22.4701593,10.6190853,9.0476107,1.8,10.6148381,9.0686344,0.7042976,2.9308882,3.8496236,43.6361106,77.9545725,1.5701197,20.2499207,14.8883573,30.6939994,5.4831489,7.1341458,1.9832068,21.4736661),(15244,'metatarsal.tif',40,10,87,22.3633325,10.6038339,9.0326944,1.8,10.6063895,9.0525712,0.6959043,2.8537825,3.8132066,42.8889923,77.4046006,1.5318258,20.2990837,15.028823,30.5527287,5.3957274,7.1041427,2.1013542,21.3102661),(15245,'metatarsal.tif',40,10,88,22.3733343,10.5736081,9.0155765,1.8,10.5742389,9.035497,0.6863547,2.8290376,3.8188015,42.5576058,77.1264901,1.497533,20.196517,15.0431392,30.3302199,5.4190826,7.0942703,2.0756577,21.2904423),(15246,'metatarsal.tif',40,10,89,22.3233479,10.550643,9.0020493,1.8,10.5462076,9.0197727,0.6785935,2.8099229,3.7995075,42.0110198,76.5913173,1.4659211,20.1582225,14.9509512,30.2248636,5.3697847,7.0758992,2.1171564,21.0791836),(15247,'metatarsal.tif',40,10,90,22.2746526,10.5257864,8.9878646,1.8,10.5221151,9.0059321,0.6649987,2.7928984,3.781482,41.5997914,76.4513481,1.4135522,20.2172981,14.8948462,30.2357546,5.3320417,7.0494366,2.1330811,21.0791836),(15248,'metatarsal.tif',40,10,91,22.1714955,10.499442,8.9762553,1.8,10.4954204,8.9943688,0.65059,2.7593525,3.769905,41.248904,76.0354776,1.3554885,20.1690699,14.9487619,30.0191612,5.3237308,7.0494366,2.1330811,21.0313248),(15249,'metatarsal.tif',40,10,92,22.1196599,10.4751273,8.9641854,1.8,10.4734466,8.9835106,0.6370265,2.7387728,3.7533701,40.8635129,75.7296692,1.3043091,20.1764458,14.9203734,30.0169162,5.2849585,7.0247749,2.1491218,21.0791836),(15250,'metatarsal.tif',40,10,93,21.9586056,10.4582141,8.9533914,1.8,10.4577121,8.9730058,0.6289826,2.6993239,3.7195252,40.1910469,75.1418028,1.2667306,20.2019881,14.8893012,29.9012324,5.2512642,6.9923937,2.0971887,20.9834661),(15251,'metatarsal.tif',40,10,94,21.9160539,10.4254716,8.9407865,1.8,10.4236033,8.9581713,0.6111106,2.7244108,3.7141721,40.0354014,75.1260577,1.2025359,20.2268647,14.6950676,29.9341918,5.241496,6.967051,2.2565258,21.0313248),(15252,'metatarsal.tif',40,10,95,21.7539578,10.4070911,8.9288305,1.8,10.4020367,8.9438472,0.5979068,2.6901599,3.6854786,39.2917184,74.5459419,1.1488692,20.2269364,14.6057184,29.6584317,5.1763404,6.963697,2.1132279,20.7325598),(15253,'metatarsal.tif',40,10,96,21.6955902,10.384474,8.9180817,1.8,10.3793515,8.9326166,0.585871,2.681222,3.6778301,38.8551,74.4077014,1.1054858,20.2314133,14.4915641,29.6960857,5.1437626,6.9368063,2.1293956,20.7325598),(15254,'metatarsal.tif',40,10,97,21.5452461,10.3628297,8.9066312,1.8,10.3613664,8.9208881,0.5744838,2.671086,3.6498248,38.3177179,74.0466775,1.0603323,20.2877347,14.3453704,29.5870381,5.114458,6.9291041,2.2308054,20.6847011),(15255,'metatarsal.tif',40,10,98,21.4574404,10.3398983,8.8949919,1.8,10.3379646,8.9112669,0.5617428,2.6403857,3.6489261,37.9053772,73.9291809,1.0146822,20.2605311,14.356,29.5026404,5.0818802,6.9141566,2.1882986,20.6368423),(15256,'metatarsal.tif',40,10,99,21.4005143,10.3117377,8.8878375,1.8,10.3095403,8.9036646,0.5544158,2.6288117,3.6463114,37.5542758,73.7864639,0.9885117,20.2359193,14.285647,29.4592739,5.0279685,6.9141566,2.5240904,20.6847011),(15257,'metatarsal.tif',40,10,100,21.2937942,10.284124,8.875088,1.8,10.2772062,8.8882135,0.5473563,2.6218087,3.6293585,37.1164054,73.4648574,0.9612339,20.2418298,14.1567939,29.3121674,5.0052489,6.9040126,2.4483695,20.6368423),(15258,'metatarsal.tif',40,10,101,21.3403851,10.2640886,8.8676092,1.8,10.2554173,8.8803534,0.5350238,2.6068847,3.6141288,36.829629,73.5480451,0.9246035,20.3501451,14.1278322,29.2442994,4.9786009,6.9141566,2.5240904,20.6170186),(15259,'metatarsal.tif',40,10,102,21.3228647,10.2458274,8.8586399,1.8,10.2407568,8.8709486,0.5285984,2.6006486,3.6176641,36.4225688,73.6817557,0.9038842,20.3672184,14.0051865,29.4171089,4.9619664,6.9218755,2.6092701,20.5691598),(15260,'metatarsal.tif',40,10,103,21.2736343,10.2227172,8.848628,1.8,10.2212171,8.8625026,0.5204087,2.5796622,3.6074768,36.0260822,73.6119567,0.8766241,20.4053859,13.9654263,29.2297122,4.9300437,6.9141566,2.5240904,20.5213011),(15261,'metatarsal.tif',40,10,104,21.2149486,10.1987936,8.8327456,1.8,10.1956733,8.8431848,0.5089094,2.5846685,3.6192236,35.678417,73.5889438,0.8393637,20.3327983,13.803866,29.3152195,4.8995964,6.9368063,2.5829933,20.5691598),(15262,'metatarsal.tif',40,10,105,21.1504392,10.1713803,8.8196671,1.8,10.1656283,8.8305982,0.4985155,2.5531602,3.604165,35.2436713,73.66384,0.8058347,20.4385314,13.8039406,29.0970205,4.8610742,6.9218755,2.6092701,20.5213011),(15263,'metatarsal.tif',40,10,106,21.0342962,10.1521757,8.8091499,1.8,10.1532734,8.820627,0.4884431,2.5542579,3.5864876,34.9303184,73.4596843,0.7719484,20.4823473,13.6753295,29.1021663,4.8311781,6.9368063,2.5829933,20.5213011),(15264,'metatarsal.tif',40,10,107,20.9367894,10.1296466,8.7997203,1.8,10.1271814,8.8122273,0.4828415,2.5260104,3.6033297,34.5275903,73.4258242,0.7522323,20.3772149,13.6688235,28.9945345,4.813588,6.9517051,2.625362,20.5213011),(15265,'metatarsal.tif',40,10,108,20.8259444,10.1046962,8.7910122,1.8,10.1018992,8.804562,0.4738636,2.5329307,3.5891282,34.0687536,73.2877701,0.7227813,20.4193794,13.4503297,28.9862867,4.7958232,6.9517051,2.625362,20.4057598),(15266,'metatarsal.tif',40,10,109,20.7849428,10.0759074,8.7823696,1.8,10.0743514,8.7956008,0.46484,2.5078687,3.6122813,33.7148874,73.5282966,0.6961388,20.355086,13.4436416,28.8441974,4.7727509,6.9794948,2.6936506,20.5213011),(15267,'metatarsal.tif',40,10,110,20.7104964,10.0501657,8.7737692,1.8,10.0494333,8.7879158,0.4533005,2.4858846,3.5971747,33.2945951,73.4251765,0.6620012,20.4119016,13.3934598,28.9341748,4.7412658,6.9833191,2.6413122,20.3380773),(15268,'metatarsal.tif',40,10,111,20.5651152,10.0293831,8.7636958,1.8,10.0306362,8.7777275,0.4450881,2.4933721,3.5843873,32.8276277,73.3403824,0.6353333,20.4610654,13.1659563,28.6835814,4.7359369,6.9947797,2.7459031,20.3859361),(15269,'metatarsal.tif',40,10,112,20.5310475,10.0019434,8.7563417,1.8,10.0022536,8.770793,0.4372345,2.4706937,3.6054021,32.5684939,73.5319083,0.6135286,20.3949256,13.1819232,28.8283905,4.7059937,7.0185959,2.7091849,20.4057598),(15270,'metatarsal.tif',40,10,113,20.4513602,9.9765133,8.7465322,1.8,9.9778768,8.7581199,0.4294049,2.4732537,3.5948556,32.209425,73.6170362,0.5908074,20.4784405,13.0230977,28.6401926,4.6898649,7.0095553,2.7719084,20.4337948),(15271,'metatarsal.tif',40,10,114,20.3634649,9.9528609,8.7395256,1.8,9.952119,8.7519342,0.4235355,2.4543617,3.5832192,31.8648332,73.7079493,0.5732641,20.5703152,12.9829408,28.7289275,4.6620862,7.0290494,2.7977869,20.4057598),(15272,'metatarsal.tif',40,10,115,20.1684096,9.9282275,8.7285331,1.8,9.923713,8.7395622,0.4168955,2.4517443,3.5746501,31.6231972,73.5857614,0.5511464,20.5854444,12.8982445,28.5157499,4.634535,7.0290494,2.7977869,20.3859361),(15273,'metatarsal.tif',40,10,116,20.1427841,9.9063601,8.7242754,1.8,9.9041452,8.736978,0.4111357,2.427837,3.5945636,31.2668517,74.0596261,0.5362031,20.6032316,12.8784809,28.397809,4.6110986,7.0588989,2.8601134,20.3182536),(15274,'metatarsal.tif',40,10,117,20.0740071,9.8798571,8.721085,1.8,9.8802158,8.7347509,0.4023357,2.4207634,3.6060177,30.9835909,74.3081207,0.5129778,20.6066988,12.7990991,28.2836524,4.6161643,7.0857972,2.7760744,20.4337948),(15275,'metatarsal.tif',40,10,118,19.9782352,9.8537804,8.7144647,1.8,9.8539032,8.726615,0.3967435,2.4177114,3.6173921,30.6322531,74.7558902,0.4971849,20.6656865,12.6699376,28.3415899,4.6000354,7.1154087,2.8743336,20.3859361),(15276,'metatarsal.tif',40,10,119,19.8207897,9.8237407,8.7096031,1.8,9.8238016,8.7222713,0.388252,2.3996182,3.6235497,30.2938576,75.0119829,0.4734395,20.701243,12.6244492,28.2281255,4.5723342,7.1374197,2.863293,20.5014773),(15277,'metatarsal.tif',40,10,120,19.6827499,9.7976341,8.7089238,1.8,9.7999038,8.7232066,0.3808777,2.4140692,3.6291872,29.9458232,75.4278192,0.4533173,20.783667,12.4047078,28.0889355,4.5641038,7.1458315,2.7547169,20.5493361),(15278,'metatarsal.tif',40,10,121,19.6290899,9.7714095,8.7095023,1.8,9.7740964,8.7238136,0.3761478,2.3974929,3.6500407,29.6679164,76.156002,0.4414547,20.8644252,12.3745588,28.149897,4.5463876,7.1914566,2.7695249,20.6170186),(15279,'metatarsal.tif',40,10,122,19.6344089,9.7458019,8.7111476,1.8,9.7512173,8.7252016,0.3688648,2.384101,3.6559595,29.3457097,76.8034091,0.4254161,21.0077296,12.3089205,28.1670877,4.5285767,7.2104589,2.7947578,20.5493361),(15280,'metatarsal.tif',40,10,123,19.603274,9.7197601,8.7104635,1.8,9.7210806,8.7234348,0.3641042,2.3782265,3.6783104,29.2246913,77.5092818,0.4143348,21.0719794,12.288439,28.3652739,4.4950559,7.2621144,2.844748,20.5493361),(15281,'metatarsal.tif',40,10,124,19.6369779,9.6944955,8.7117783,1.8,9.6985205,8.725724,0.3587847,2.3816758,3.6798416,29.1482601,78.3437022,0.4035298,21.2899661,12.2385508,28.4189424,4.5043656,7.2873469,2.7985687,20.5971948),(15282,'metatarsal.tif',40,10,125,19.6034835,9.6684255,8.7171175,1.8,9.669702,8.7304386,0.3545373,2.3791152,3.6996042,28.96808,79.1701959,0.3937609,21.3996395,12.1759888,28.454992,4.4881087,7.3170549,2.8586918,20.6648773),(15283,'metatarsal.tif',40,10,126,19.6992001,9.6384962,8.7193824,1.8,9.641267,8.731005,0.3487978,2.3667359,3.7231046,29.0072987,80.339263,0.383496,21.5785673,12.2562465,28.6002134,4.4672219,7.3733967,2.8724252,20.7127361),(15284,'metatarsal.tif',40,10,127,19.736429,9.6120827,8.7277513,1.8,9.6145339,8.7400751,0.3451672,2.3796533,3.7426734,29.0400208,81.1922123,0.3765824,21.6936406,12.2034672,28.7068552,4.4810525,7.418522,2.8511907,20.7605948),(15285,'metatarsal.tif',40,10,128,19.7592512,9.5885631,8.7355139,1.8,9.5906148,8.7466277,0.340698,2.3760888,3.7592326,28.9702496,82.1772618,0.3676964,21.8601163,12.1924105,28.8344245,4.46694,7.4521866,2.8753406,20.8761361),(15286,'metatarsal.tif',40,10,129,19.8109992,9.5636675,8.7454645,1.8,9.5636394,8.7589423,0.3374563,2.3686482,3.7772452,28.8756536,83.1498472,0.3619444,22.0133571,12.1907735,28.9514778,4.4564514,7.4968376,2.8543112,20.8761361),(15287,'metatarsal.tif',40,10,130,19.7784856,9.5410197,8.749072,1.8,9.5401612,8.7612274,0.3322746,2.3561995,3.793995,28.7655192,84.3690824,0.350747,22.2375311,12.2084397,29.113208,4.4389969,7.5456485,2.799297,20.9718536),(15288,'metatarsal.tif',40,10,131,19.6437633,9.516342,8.7526615,1.8,9.5179883,8.7630961,0.3272753,2.3710401,3.8142341,28.6747868,85.1000831,0.3383284,22.3111853,12.0937589,28.967687,4.446899,7.58931,2.8913921,20.9041711),(15289,'metatarsal.tif',40,10,132,19.6668959,9.4965001,8.7644145,1.8,9.4969139,8.7780177,0.328289,2.3615366,3.8548276,28.7800067,86.7325975,0.3407525,22.4997345,12.186983,29.3050004,4.4389969,7.6536811,2.8603605,21.1352536),(15290,'metatarsal.tif',40,10,133,19.6343708,9.4773085,8.7761024,1.8,9.4792665,8.7908806,0.3246434,2.3560994,3.8665848,28.8192315,87.8057147,0.3329413,22.7088552,12.2317553,29.3802747,4.4444105,7.7101602,2.8734819,21.2029361),(15291,'metatarsal.tif',40,10,134,19.6477339,9.4495221,8.7839973,1.8,9.455235,8.7972911,0.3213745,2.3741988,3.9139469,28.9464538,89.0463599,0.3267237,22.7510394,12.1920937,29.4167549,4.4531094,7.778681,2.8430937,21.2986536),(15292,'metatarsal.tif',40,10,135,19.6222475,9.4192564,8.7924865,1.8,9.4217265,8.806705,0.3169319,2.369594,3.9375908,28.9084053,90.2516048,0.317643,22.9205139,12.1997294,29.5532218,4.4314659,7.8107935,2.8661665,21.4141948),(15293,'metatarsal.tif',40,10,136,19.5313471,9.390003,8.8020208,1.8,9.3917527,8.8160069,0.3111095,2.3672464,3.9592703,28.8781906,91.5998898,0.3050354,23.1355484,12.1990641,29.7348702,4.4362682,7.869114,2.9217976,21.4818773),(15294,'metatarsal.tif',40,10,137,19.47221,9.3646342,8.8144951,1.8,9.3685961,8.8266881,0.3102263,2.3626708,4.0040721,28.7894675,93.0885777,0.3024433,23.248477,12.1851369,29.7628691,4.4089962,7.9467688,2.8816525,21.6931361),(15295,'metatarsal.tif',40,10,138,19.4517359,9.3427294,8.8251858,1.8,9.346135,8.8380669,0.3061717,2.3584573,4.0192157,28.8510854,94.4082117,0.2945263,23.4892124,12.2330327,29.8961372,4.3913286,8.0053494,2.8941387,21.6254536),(15296,'metatarsal.tif',40,10,139,19.3752575,9.317678,8.8354818,1.8,9.3150131,8.8482338,0.3054036,2.3519708,4.0641055,28.9103751,96.0965433,0.2919442,23.645189,12.2919787,30.0055514,4.3913286,8.0688833,2.8646838,21.7888536),(15297,'metatarsal.tif',40,10,140,19.3699385,9.2878832,8.8466462,1.8,9.2890948,8.8602131,0.3012284,2.3703361,4.1106261,29.1444203,97.8213473,0.2841797,23.7971892,12.2954802,30.2189456,4.4180084,8.1475015,2.8674252,22.0199361),(15298,'metatarsal.tif',40,10,141,19.3998013,9.2654366,8.859574,1.8,9.2632695,8.870711,0.2983109,2.3733926,4.1260703,29.3679787,100.2593214,0.279295,24.2989852,12.3738395,30.5694001,4.4180084,8.2066826,2.971534,22.2510186),(15299,'metatarsal.tif',40,10,142,19.3538102,9.241363,8.8758221,1.8,9.2452734,8.8899351,0.2955235,2.3682147,4.1660698,29.3776813,101.9884961,0.2736021,24.4807457,12.4049904,30.7716426,4.4180084,8.3049165,2.8727522,22.4144186),(15300,'metatarsal.tif',40,10,143,19.3864515,9.2148521,8.8873876,1.8,9.2150199,8.898022,0.2943578,2.387924,4.2108386,29.596035,104.0899311,0.2719683,24.7195252,12.394044,31.0067652,4.4439322,8.3837099,2.8753406,22.4622773),(15301,'metatarsal.tif',40,10,144,19.4277082,9.1930148,8.9051367,1.8,9.1957292,8.9190184,0.2934371,2.388327,4.233114,29.8134205,105.8962737,0.270894,25.0161637,12.4829727,31.2829055,4.4439322,8.445188,2.927121,22.5778186),(15302,'metatarsal.tif',40,10,145,19.3937205,9.1606846,8.9176693,1.8,9.1567786,8.9269531,0.2891122,2.3899245,4.281193,30.0295077,108.1115203,0.2627294,25.2526621,12.5650447,31.5069202,4.4439322,8.5426326,2.9198117,22.7890773),(15303,'metatarsal.tif',40,10,146,19.4376434,9.1430645,8.9372981,1.8,9.1340697,8.9481427,0.2899626,2.3896529,4.3163964,30.2517364,110.6279246,0.2648319,25.6296954,12.6594686,31.7872399,4.4635402,8.6223503,2.921896,23.0878423),(15304,'metatarsal.tif',40,10,147,19.5168965,9.1162169,8.9538892,1.8,9.1100448,8.9633468,0.2857753,2.3941117,4.3574361,30.5058854,113.169723,0.2584961,25.9716309,12.7420477,32.1094367,4.4680678,8.7021047,2.923942,23.2512423),(15305,'metatarsal.tif',40,10,148,19.6391851,9.1009924,8.9774292,1.8,9.0984787,8.9903992,0.2861321,2.3975724,4.3887414,31.0384998,115.8797024,0.2607479,26.4038577,12.9458028,32.7237989,4.4943731,8.7997386,2.9168815,23.3469598),(15306,'metatarsal.tif',40,10,149,19.6612608,9.0755558,8.9969829,1.8,9.0748597,9.0134773,0.28282,2.404211,4.4377336,31.4857497,118.3345853,0.2551938,26.6655452,13.0960841,32.9687439,4.5160517,8.8978014,2.9099762,23.5582186),(15307,'metatarsal.tif',40,10,150,19.7427859,9.0460486,9.0154744,1.8,9.0387544,9.0311142,0.2794745,2.4338956,4.4813098,32.0350566,121.1469308,0.2503831,27.0338216,13.1620503,33.3979719,4.5369385,8.9962793,2.9032218,23.7893011),(15308,'metatarsal.tif',40,10,151,19.7918411,9.0255534,9.0372573,1.8,9.0217113,9.0528172,0.2778291,2.4398633,4.5162547,32.591508,124.0022512,0.2481345,27.4568773,13.3579236,33.7854105,4.5719378,9.0572843,2.8769229,24.0682423),(15309,'metatarsal.tif',40,10,152,20.0064602,9.0076827,9.0612784,1.8,9.003354,9.0734689,0.2759141,2.4700626,4.5476538,33.238318,128.1318732,0.2474673,28.1753798,13.4564676,34.410901,4.5902015,9.1649777,2.9441971,24.2514661),(15310,'metatarsal.tif',40,10,153,20.1385164,8.9742662,9.0885308,1.8,8.9688573,9.0984615,0.275851,2.4832063,4.6064378,33.9092127,132.2927097,0.2489897,28.7190916,13.6554153,35.1286766,4.6248121,9.2782572,2.9286543,24.5782661),(15311,'metatarsal.tif',40,10,154,20.2910524,8.9370827,9.1108917,1.8,8.9315207,9.1219409,0.2734723,2.4955587,4.6567578,34.7567065,135.7969808,0.2466756,29.161272,13.927425,35.68916,4.6496421,9.3755867,2.9219785,24.9050661),(15312,'metatarsal.tif',40,10,155,20.4746833,8.8947407,9.133529,1.8,8.8885532,9.1439589,0.270759,2.5320573,4.7333263,35.6131378,139.3052876,0.2441141,29.4307381,14.0649022,36.3420199,4.7022901,9.491979,2.907052,25.1361485),(15313,'metatarsal.tif',40,10,156,20.7556419,8.8545114,9.1562538,1.8,8.8475106,9.1692487,0.2698229,2.5440281,4.7870478,36.623268,143.5336037,0.2457975,29.9837415,14.3957798,36.955003,4.7266559,9.5979246,2.93585,25.6461723),(15314,'metatarsal.tif',40,10,157,21.1148652,8.8022323,9.1830574,1.8,8.8040417,9.1879903,0.2665339,2.5519563,4.8632982,37.7425672,148.4745925,0.2441369,30.5296092,14.7896605,37.702294,4.7538444,9.6699811,2.9027615,25.8772548),(15315,'metatarsal.tif',40,10,158,21.5526694,8.7484221,9.2127624,1.8,8.7489626,9.2125125,0.2616445,2.6150133,4.9253881,38.916263,154.0701497,0.2403476,31.2808139,14.8818605,38.5321002,4.8056919,9.7890102,2.888517,26.2519135),(15316,'metatarsal.tif',40,10,159,21.9427268,8.7497455,9.2603697,1.8,8.7485396,9.2635022,0.2631403,2.6375666,4.9553175,40.244969,158.1368672,0.2474384,31.91256,15.2583705,39.476607,4.8598862,9.888738,2.8825869,26.8296198),(15317,'metatarsal.tif',40,10,160,22.5146001,8.731879,9.2909527,1.8,8.7328132,9.2881623,0.2579125,2.6785125,4.9811943,41.7889453,164.3055042,0.2441219,32.9851629,15.6015497,40.705919,4.9093871,10.0105007,2.8688983,27.3676785),(15318,'metatarsal.tif',40,10,161,22.8495349,8.6715015,9.3075911,1.8,8.6712427,9.3016868,0.2521608,2.699086,5.0685632,43.0368003,170.0693482,0.2370592,33.5537587,15.9449536,41.6206469,4.9865718,10.1469295,2.9141903,29.013291),(15319,'metatarsal.tif',40,10,162,22.9208657,8.6231096,9.3181255,1.8,8.6248666,9.3055497,0.2493278,2.7239448,5.1309438,43.9866277,174.0221863,0.2325966,33.9162135,16.1481347,41.9858586,5.0304195,10.2049808,2.8907888,30.3881735),(15320,'metatarsal.tif',40,10,163,22.4053985,8.6253482,9.3223802,1.8,8.6248146,9.3081256,0.245127,2.7114934,5.1243473,44.798759,178.5688002,0.2199214,34.8471306,16.5218025,43.0487972,4.8527324,5.9992505,0.5123895,17.1425699),(15321,'metatarsal.tif',40,10,164,22.2352241,8.58143,9.3214804,1.8,8.5934325,9.3196613,0.2416854,2.7255946,5.1850337,45.7264366,185.9462146,0.2122847,35.8621033,16.7766828,44.0290281,4.7949618,6.1034876,0.4875951,17.2779349),(15322,'metatarsal.tif',40,10,165,21.9009959,8.5273419,9.3161604,1.8,8.5435771,9.3205167,0.2399364,2.7160717,5.2766707,46.1986973,191.4551394,0.2061365,36.2833217,17.0093807,44.6191016,4.7949618,6.110592,0.5174877,17.3934761),(15323,'metatarsal.tif',40,10,166,21.6792295,8.4972995,9.3288733,1.8,8.5177914,9.3245263,0.2333764,2.7437569,5.3358758,46.6833265,193.9033588,0.1932446,36.3395563,17.0143818,44.4611658,4.7949618,6.1514187,0.5290305,17.4413349),(15324,'metatarsal.tif',40,10,167,21.484498,8.4464009,9.3593227,1.8,8.4747347,9.3565577,0.2238548,2.796433,5.3951902,47.7339982,199.4838297,0.1764575,36.9743832,17.0696022,45.3912209,5.2652818,10.7599241,2.9039803,34.5162222),(15325,'metatarsal.tif',40,10,168,21.549531,8.4370429,9.3934798,1.8,8.4615034,9.3909348,0.2214663,2.8346016,5.4311361,49.6860273,204.9786798,0.1732965,37.7414001,17.5283987,46.4025678,5.3418846,10.8786856,2.8911496,35.6121635),(15326,'metatarsal.tif',40,10,169,21.6708997,8.3557679,9.4093394,1.8,8.363287,9.4026744,0.219847,2.8696837,5.5235285,50.9159685,212.1690907,0.1717745,38.4118757,17.742711,47.0828834,5.4241671,10.9991991,2.8785979,35.1698222),(15327,'metatarsal.tif',40,10,170,21.5972703,8.3255291,9.4611998,1.8,8.3172089,9.4542117,0.220518,2.8821952,5.586237,51.8894927,216.9155349,0.1722204,38.8303492,18.0034622,47.7728261,5.4315966,11.1573607,2.9125984,31.678951),(15328,'metatarsal.tif',40,10,171,21.6920042,8.2966655,9.5016981,1.8,8.2627833,9.4903324,0.223473,2.925443,5.6506307,53.4877033,225.1710351,0.1775649,39.8488324,18.2836254,48.9990894,5.5072473,11.37832,2.9244813,31.9018222),(15329,'metatarsal.tif',40,10,172,21.7802632,8.2154922,9.5261013,1.8,8.1567489,9.5127296,0.2219308,2.9504831,5.7778198,54.9807006,234.9028024,0.1758754,40.6559586,18.6344737,49.9273171,5.5866743,11.617786,2.9290258,32.9416934),(15330,'metatarsal.tif',40,10,173,21.8524529,8.1199404,9.5474854,1.8,8.0436305,9.5221341,0.2211496,2.9929924,5.9097732,56.605319,245.9923079,0.1752386,41.6246616,18.9126173,51.109325,5.7173858,11.8408642,2.9401376,35.2210822),(15331,'metatarsal.tif',40,10,174,21.8865054,8.065712,9.5781018,1.8,7.9760163,9.5407081,0.2155036,3.0389041,6.0239685,58.2115001,261.9631281,0.1668018,43.4868021,19.1554251,52.8254408,5.8242298,12.0517885,2.9229237,36.4605997),(15332,'metatarsal.tif',40,10,175,22.8038752,8.0639653,9.6481744,1.8,7.9445457,9.5985271,0.2262751,3.1425477,6.1514109,62.3834167,277.8619921,0.1912961,45.170449,19.8512234,54.8989091,6.0124819,12.2661606,2.9063067,33.719046),(15333,'metatarsal.tif',40,10,176,23.928677,8.0155587,9.6906594,1.8,7.921586,9.6428682,0.2253709,3.2138906,6.3111666,66.7789549,300.660222,0.199158,47.6394052,20.7782288,57.7586811,6.1884689,12.4347829,2.8551704,34.1613872),(15334,'metatarsal.tif',40,10,177,25.7253193,7.8504678,9.6997187,1.8,7.8195874,9.6568596,0.2341027,3.2536305,6.6065587,71.3865313,326.5387854,0.2307141,49.4264565,21.9405772,59.5962635,6.2838596,12.6088275,2.8321366,34.2571047),(15335,'metatarsal.tif',40,10,178,28.3999963,7.678319,9.700516,1.8,7.7180788,9.6751487,0.2523614,3.3019878,6.8508171,76.7470986,355.4983688,0.2951031,51.8913825,23.2426957,62.3789923,6.3376129,12.7391758,2.8015885,34.6317635),(15336,'metatarsal.tif',40,10,179,31.7317339,7.6787631,9.6728076,1.8,7.8218884,9.695194,0.2888726,4.8989049,6.9001838,81.4054301,386.3102446,0.4291817,55.9855005,16.6170669,59.3114242,6.3728077,12.7666544,2.7955554,34.755516),(15337,'metatarsal.tif',40,10,180,35.1983575,7.8250838,9.7492458,1.8,8.0052982,9.7786957,0.2985073,3.2807296,6.6708268,88.8100496,421.2966959,0.5073915,63.1550944,27.0702128,76.3349732,6.4657972,12.701657,2.9012941,35.0344572),(15338,'metatarsal.tif',40,10,181,37.9411317,8.1200066,9.8097319,1.8,8.2676216,9.8228466,0.279635,3.519943,6.3418471,92.9924488,444.6376681,0.4817175,70.1116979,26.4187374,84.6821605,6.7239711,12.6278708,2.9264325,41.6135059),(15339,'metatarsal.tif',40,10,182,35.987958,8.4110096,9.8598267,1.8,8.449607,9.8450726,0.2555329,3.8267316,6.4442844,89.8684036,407.5596273,0.3832006,63.2435822,23.4843758,76.9311545,5.6682292,7.4566637,1.0040671,22.1040411),(15340,'metatarsal.tif',40,10,183,33.5646339,8.5451899,9.9243909,1.8,8.514606,9.8903916,0.2170189,3.8475674,6.915734,85.0328654,391.5125207,0.2593565,56.6118533,22.1004228,68.5243497,5.4341356,7.5950246,1.0156178,22.3351236),(15341,'metatarsal.tif',40,10,184,30.8358894,8.4281521,9.8328968,1.8,8.403041,9.8429145,0.2071851,4.0505156,6.6802516,80.8834114,368.9835977,0.2174699,55.2349852,19.9686705,64.3997363,5.4048728,7.6384039,1.0065281,22.4704886),(15342,'metatarsal.tif',40,10,185,28.0175604,8.1546912,9.8235032,1.8,8.174802,9.8759516,0.2437073,4.1936717,6.2542822,80.4900259,338.9446685,0.2718948,54.1940159,19.1932112,63.2367241,5.404409,7.5257187,1.0098955,22.1717236),(15343,'metatarsal.tif',40,10,186,26.7133821,8.1074582,9.9433947,1.8,8.1245956,10.021132,0.2865235,4.1980534,6.1341787,77.5456399,322.8343339,0.3556157,52.6287792,18.4718087,64.9180488,5.4223845,7.5008431,0.9948777,22.9244423),(15344,'metatarsal.tif',40,10,187,26.1753897,8.2583328,10.0812387,1.8,8.1949261,10.1519327,0.2815158,4.0343464,6.0416031,76.2553969,286.2897237,0.3367008,47.3863837,18.901549,60.0079648,5.1131647,7.3643385,0.9827937,21.4141948),(15345,'metatarsal.tif',40,10,188,26.5199493,8.2249303,10.1919904,1.8,8.2074673,10.2652137,0.2693688,3.8440343,5.9815769,74.0388098,266.8221153,0.3130304,44.6073198,19.2607047,54.580972,4.4597773,7.1616936,0.9638087,19.1115811),(15346,'metatarsal.tif',40,10,189,26.454482,8.1645387,10.2302753,1.8,8.1494856,10.2948581,0.2237323,3.9713274,5.9480058,68.3366805,254.7568563,0.2170435,42.8306331,17.2075162,51.8539042,4.1634938,6.7500222,0.9055069,18.2549336),(15347,'metatarsal.tif',40,10,190,25.1896523,8.195037,10.3179826,1.8,8.2387625,10.3878831,0.209281,3.9360754,5.7493737,57.6358237,228.8468576,0.1812095,39.8037888,14.6429673,49.301813,3.9028917,6.265916,0.8777275,16.8321924),(15348,'metatarsal.tif',40,10,191,21.9344046,8.2431592,10.4501837,1.8,8.30378,10.511028,0.2168193,4.2288185,4.830922,45.4326616,172.43775,0.169182,35.6945834,10.7435829,41.7317891,3.5472734,5.5030879,0.7118469,14.7278161),(15349,'metatarsal.tif',40,10,192,15.6953249,9.1934904,10.8418794,1.8,8.987256,10.7452836,0.2686693,3.5417491,5.5352385,33.3643729,87.709641,0.1843233,15.8456842,9.4203097,20.1151237,1.4269056,3.8285844,0.8760581,9.1325686),(15350,'metatarsal.tif',40,10,193,11.7155536,10.0323393,11.16804,1.8,10.0240476,11.1641863,1.4192185,3.1120832,3.2699717,11.9164171,21.6946446,1.9080723,6.6345054,3.8290806,10.2026949,4.2277435,5.9478498,1.849096,17.7120648),(15351,'metatarsal.tif',40,10,194,8.0150099,10.1105091,11.3228529,1.8,10.1057968,11.2841715,1.3157572,2.5407514,2.8251008,4.934212,12.2500612,1.2508133,4.3361501,1.9420287,5.9363697,3.3423239,5.1178383,1.8622531,14.3251224),(15352,'metatarsal.tif',40,10,195,1.7551171,10.541629,12.2481718,1.8,10.5384642,12.1937772,-1.5489014,1.2333498,3.9704214,0.1330396,0.8148806,0.2923793,0.2052378,0.1078685,0.2279986,1.1438,2.8699851,1.6563016,6.8101312),(15353,'metatarsal.tif',40,10,196,37.7779844,7.3389583,10.9198114,1.8,7.2473795,10.9652911,0.18824,7.0798996,6.7873959,160.9194905,522.7603785,0.2204833,77.0192851,22.7290639,88.8055979,6.1057493,7.0280997,0.6202495,21.7970648),(15354,'metatarsal.tif',40,10,197,38.3529638,7.8273516,10.967643,1.8,7.7013922,11.0009818,0.2157147,7.1464576,6.8126991,150.8150077,517.4550491,0.2928603,75.9544847,21.1034635,86.1915631,6.0582072,7.0280997,0.6202495,21.6815236),(15355,'metatarsal.tif',40,10,198,37.2699882,8.1290271,11.0200848,1.8,8.0302713,10.9893231,0.2628284,7.1406588,7.0825285,127.3775742,499.6006929,0.4193044,70.5398772,17.8383504,82.1699207,6.0335855,6.9809292,0.610726,21.4025823),(15356,'metatarsal.tif',40,10,199,30.9903393,8.1178849,10.926299,1.8,8.1786449,10.9410789,0.2677991,6.9397944,7.022469,94.416011,418.095535,0.3616481,59.5368284,13.6050155,69.9112299,5.9568547,6.8144853,0.6578886,21.0757823),(15357,'metatarsal.tif',40,10,200,27.7876566,8.0573934,10.9119714,1.8,8.224971,10.918195,0.2401083,3.2130287,6.9787421,81.8460865,382.5516637,0.2619104,54.8167076,25.4731888,66.325365,5.8820147,6.5853444,0.6534263,20.6532648),(15358,'metatarsal.tif',40,10,201,24.2434785,7.6580095,10.8573848,1.8,7.7916502,10.8530234,0.2196043,3.1444318,6.5694376,71.9663052,346.4231487,0.1917488,52.7325426,22.8869031,62.9962319,5.7118513,6.4060303,0.658806,20.1910998),(15359,'metatarsal.tif',40,10,202,22.1312729,7.3811145,10.874909,1.8,7.5325619,10.8906675,0.2140568,3.0814902,6.6733461,66.0629284,327.3344587,0.1664447,49.0510242,21.4386303,57.79493,5.5975889,6.2845305,1.8473103,19.7289349),(15360,'metatarsal.tif',40,10,203,21.5130753,7.2532029,10.9091503,1.8,7.3794174,10.9247705,0.215614,3.0496539,6.7130467,61.5430121,320.1440186,0.1641211,47.6898241,20.180327,56.0243596,5.4671422,6.1838859,1.8382071,19.3542761),(15361,'metatarsal.tif',40,10,204,21.1075676,7.2571407,10.9543588,1.8,7.3888204,10.9971962,0.2047721,2.9800882,6.6236258,57.964107,318.6133656,0.1454621,48.1025612,19.4504668,55.8085282,5.3400667,6.0491113,1.8583722,18.8442524),(15362,'metatarsal.tif',40,10,205,20.890867,7.2637091,11.0045182,1.8,7.3658491,11.0474382,0.2007761,2.9518847,6.5531065,54.2498367,321.1403223,0.1384796,49.0058147,18.3780335,56.4761052,5.205268,5.8897711,1.9847953,18.4976286),(15363,'metatarsal.tif',40,10,206,20.8276488,7.2872921,11.0532411,1.8,7.3557619,11.0932371,0.196087,2.9001002,6.4513816,51.5190756,323.946436,0.1317689,50.2134979,17.7645845,57.2113411,5.0861467,5.7747511,2.0091329,18.1510049),(15364,'metatarsal.tif',40,10,207,20.7917929,7.2891154,11.0905905,1.8,7.3348829,11.126766,0.193258,2.8315945,6.4235624,48.8231199,328.5882943,0.127821,51.1535927,17.242271,57.9294557,4.9921181,5.719,0.6435011,17.8043811),(15365,'metatarsal.tif',40,10,208,20.5844009,7.283298,11.1275399,1.8,7.3360397,11.1700882,0.1904627,2.7801039,6.3884927,46.225589,329.2150687,0.1229558,51.5325103,16.6272884,57.8097676,4.9192937,5.6703567,0.6319742,17.4577574),(15366,'metatarsal.tif',40,10,209,20.3376205,7.2423762,11.1527926,1.8,7.2738531,11.192049,0.1885628,2.7264086,6.4033698,43.9611229,328.3545789,0.1190988,51.2784036,16.1241872,57.2316151,4.8497737,5.5562007,0.6287963,17.2464986),(15367,'metatarsal.tif',40,10,210,20.1542276,7.20582,11.1735647,1.8,7.242994,11.2162202,0.1878079,2.7014923,6.4842922,41.9408242,329.124411,0.1170928,50.7571835,15.5250581,56.6213329,4.7885461,5.4421032,0.625485,17.0352399),(15368,'metatarsal.tif',40,10,211,19.9722783,7.1981805,11.2005275,1.8,7.2363512,11.24357,0.1849275,2.6543727,6.4187974,40.1949063,330.5549502,0.1125442,51.4979569,15.1429023,57.0225309,4.7417846,5.3280679,0.622032,16.7084399),(15369,'metatarsal.tif',40,10,212,19.658309,7.2017633,11.2222785,1.8,7.2338415,11.2627945,0.1801602,2.60739,6.4063648,38.1230119,329.0589618,0.1051984,51.3643812,14.621139,56.566847,4.6666693,5.2140989,0.618428,16.5846874),(15370,'metatarsal.tif',40,10,213,19.3741891,7.2212619,11.248866,1.8,7.2566279,11.2906819,0.1763407,2.5587972,6.3784643,36.4332677,327.5988002,0.0993736,51.3601371,14.2384349,56.3180804,4.5906183,5.1961457,0.6403565,16.1505574),(15371,'metatarsal.tif',40,10,214,19.069738,7.2440432,11.2761877,1.8,7.2678613,11.3103529,0.1729932,2.5323397,6.3196525,34.8624725,326.987978,0.0941705,51.7414492,13.7669018,56.6809097,4.5752,5.1210978,0.5924274,15.9591224),(15372,'metatarsal.tif',40,10,215,18.7312077,7.2739867,11.3079688,1.8,7.2898773,11.3363494,0.1701637,2.495641,6.282501,33.2404646,325.0424712,0.0895267,51.7377508,13.3194093,56.4843828,4.4766413,5.0077502,0.5880026,15.6124986),(15373,'metatarsal.tif',40,10,216,18.3729347,7.297359,11.3389262,1.8,7.3062523,11.3648019,0.1686093,2.4616217,6.3238743,31.5225642,323.1697127,0.0862325,51.1031212,12.8056089,55.9265921,4.4079147,4.9196698,0.6202495,15.3137336),(15374,'metatarsal.tif',40,10,217,17.9615291,7.3059941,11.3585405,1.8,7.3151633,11.3829481,0.1679603,2.4377543,6.3353536,29.761661,320.6804319,0.08366,50.6176056,12.2086385,55.142121,4.3445054,4.8368884,0.6536359,15.1701574),(15375,'metatarsal.tif',40,10,218,17.6010165,7.3235024,11.3755456,1.8,7.3436873,11.4005887,0.1695523,2.4043519,6.3700585,28.0177194,317.8264733,0.0835272,49.893808,11.6529197,54.0632768,4.234026,4.7371912,0.5640837,14.7278161),(15376,'metatarsal.tif',40,10,219,17.1630904,7.3361616,11.3855526,1.8,7.3552595,11.4074417,0.1717666,2.3784806,6.3855255,25.9126103,315.570106,0.0835692,49.4195984,10.8946063,53.2581083,4.0794016,4.6940187,0.5493745,14.3333336),(15377,'metatarsal.tif',40,10,220,16.9312346,7.3773986,11.3983969,1.8,7.4034338,11.4146971,0.1732022,2.3367331,6.4432656,24.1664448,315.5247269,0.0838102,48.9696912,10.3419791,52.4482128,3.9216,4.6129762,0.4002407,14.1501099),(15378,'metatarsal.tif',40,10,221,16.7304794,7.4232419,11.4100204,1.8,7.4677204,11.4302839,0.1734814,2.2890139,6.4906104,22.5665613,315.8383161,0.0830811,48.6608034,9.858639,51.8709715,3.8560582,4.6129762,0.4002407,13.9388511),(15379,'umzc_hippo_humerus-cleaned.tif',250,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15380,'umzc_hippo_humerus-cleaned.tif',250,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15381,'umzc_hippo_humerus-cleaned.tif',250,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15382,'umzc_hippo_humerus-cleaned.tif',250,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15383,'umzc_hippo_humerus-cleaned.tif',250,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15384,'umzc_hippo_humerus-cleaned.tif',250,2,6,8.2451198,79.5598093,79.292312,1.8,79.2575165,79.6777172,-1.0883265,2.8592583,6.7118519,13.4724257,98.4119981,1.0783699,14.6624209,4.7118603,15.8063941,6.1459158,13.4881197,1.237552,35.9120138),(15385,'umzc_hippo_humerus-cleaned.tif',250,2,7,100.7466761,79.0123927,81.9292351,1.8,79.2982869,82.8070736,-1.2440411,8.1237024,12.8364125,718.4441044,2902.8086792,15.0612457,226.1386249,88.4380137,282.0955508,14.9105051,25.6847087,1.1583859,76.3899246),(15386,'umzc_hippo_humerus-cleaned.tif',250,2,8,198.4236171,79.5536301,83.416761,1.8,79.9707908,83.2453726,-1.2281417,9.5076485,16.0526179,3020.2852177,8701.4572884,29.3373171,542.058456,317.669002,721.7989854,18.3838851,30.9158553,1.0929653,91.6220199),(15387,'umzc_hippo_humerus-cleaned.tif',250,2,9,264.0489885,80.024112,83.856802,1.8,80.2789944,83.3752822,-1.1977293,10.7166978,18.9981308,5973.0732619,16880.9710795,38.162089,888.5595777,557.3613588,1198.9873449,21.0117575,35.7602132,1.0703555,97.168385),(15388,'umzc_hippo_humerus-cleaned.tif',250,2,10,301.331146,80.1290121,84.008726,1.8,80.3018345,83.454268,-1.1645005,11.4687883,20.676616,8415.9910596,24701.4984718,42.3776805,1194.6586648,733.8169319,1601.2744163,0.490234,0.6932956,2.3561945,1.3865913),(15389,'umzc_hippo_humerus-cleaned.tif',250,2,11,323.9985072,79.8903613,84.3788784,1.8,80.2458278,83.4961754,-1.1585403,12.6950214,22.8541499,10625.9822043,31986.0070205,45.3305051,1399.5710724,837.019639,1863.1902715,23.1980889,41.669894,1.080839,115.7480078),(15390,'umzc_hippo_humerus-cleaned.tif',250,2,12,345.1287797,79.6884171,84.4546876,1.8,80.1195279,83.4993809,-1.1514375,12.8451386,24.3049308,12767.187788,40520.3376791,47.9849003,1667.1653173,993.9314929,2186.9596721,24.4418967,44.0938206,1.0723369,124.4736787),(15391,'umzc_hippo_humerus-cleaned.tif',250,2,13,363.3331508,79.4647253,84.4427528,1.8,79.9520128,83.5269944,-1.1455138,13.5321443,25.648717,15094.6894762,47829.4073861,50.2477203,1864.7875196,1115.4691509,2438.1678318,25.765483,46.2849485,1.0739855,134.5162611),(15392,'umzc_hippo_humerus-cleaned.tif',250,2,14,379.810937,79.1737556,84.4989931,1.8,79.8153597,83.4226221,-1.1247594,34.411058,27.2056709,17404.4552647,55246.679927,51.5213245,2030.7045616,505.7808814,2068.6807536,26.5299333,48.0454378,1.0706353,146.0151145),(15393,'umzc_hippo_humerus-cleaned.tif',250,2,15,398.4219018,78.9042974,84.3069538,1.8,79.5763104,83.2792181,-1.1114548,14.2678418,28.7119218,19839.1842337,63353.0786994,53.3509307,2206.5077755,1390.4824885,2884.4510529,27.1874019,50.044709,1.0589405,135.9028523),(15394,'umzc_hippo_humerus-cleaned.tif',250,2,16,416.3967218,78.6224923,83.9918825,1.8,79.3055031,83.1176147,-1.0886335,31.0530919,29.7310201,22411.8435999,71767.6616253,54.4775669,2413.8983903,721.7266366,2985.4394987,28.052557,52.8475941,0.9235847,166.5556735),(15395,'umzc_hippo_humerus-cleaned.tif',250,2,17,434.4452429,78.2766621,83.7514537,1.8,78.9995884,82.9228581,-1.0631369,16.0836927,31.0562964,25193.4543446,80764.9126447,55.2957958,2600.5970486,1566.3973955,3400.4433947,29.6685405,54.7132824,0.9380475,165.8827865),(15396,'umzc_hippo_humerus-cleaned.tif',250,2,18,459.6544154,77.9383805,83.5426647,1.8,78.8140144,82.6683938,-1.0390858,28.6053137,31.9451019,28029.6910349,92040.1618444,56.916127,2881.1979415,979.8770705,2913.235513,30.4286834,55.9060294,0.9536049,187.7810745),(15397,'umzc_hippo_humerus-cleaned.tif',250,2,19,475.1866146,77.5945855,83.2507226,1.8,78.5644702,82.4319044,-1.0211847,26.3306345,32.6691876,30191.3402088,102709.9299894,57.5881882,3143.9389049,1146.624106,3936.2306516,31.0964202,57.4996683,0.8880662,196.0309425),(15398,'umzc_hippo_humerus-cleaned.tif',250,2,20,491.9021813,77.2811842,83.1322026,1.8,78.2378484,82.3552821,-1.008102,25.6072418,33.7079566,32620.5092565,114003.870657,58.6521937,3382.1056585,1273.8782827,4329.2609831,32.165562,58.8280857,0.9272952,200.0224946),(15399,'umzc_hippo_humerus-cleaned.tif',250,2,21,518.167711,76.629403,83.4218669,1.8,77.8418806,82.430862,-1.008248,18.1012473,35.1295022,34988.2922823,127744.7668971,61.7953596,3636.395595,1932.9216187,4613.6325831,33.1775729,61.0985835,0.9048271,219.1271913),(15400,'umzc_hippo_humerus-cleaned.tif',250,2,22,533.7942941,76.0820296,83.0910667,1.8,77.4139765,82.0812908,-0.9893183,28.5046231,35.8863551,36116.4059058,140011.7688212,62.1259887,3901.5321725,1267.0367799,4562.9288151,33.0523459,63.3977069,0.8839787,202.7956771),(15401,'umzc_hippo_humerus-cleaned.tif',250,2,23,547.9512992,75.5795282,82.8141218,1.8,76.9539042,81.8543982,-0.9727839,26.7664111,36.5417728,37328.1785349,148999.0956527,62.3778545,4077.5004644,1394.5903454,4815.3434451,32.6851752,63.8528671,0.8996525,213.9869493),(15402,'umzc_hippo_humerus-cleaned.tif',250,2,24,559.1017104,75.0178803,82.6313897,1.8,76.452265,81.6538075,-0.9628602,31.1499624,37.2759717,38545.3612527,158908.7761534,62.783353,4263.0351098,1237.4127697,5229.0393974,32.5511855,65.3502396,0.8597291,208.1041408),(15403,'umzc_hippo_humerus-cleaned.tif',250,2,25,573.654458,74.3965862,82.6003276,1.8,75.8956262,81.7125917,-0.9582241,30.276531,38.0238336,40148.6359522,169708.0354859,64.0011958,4463.2016168,1326.0646003,5497.3657763,33.8481722,66.9164986,0.8891905,248.1963371),(15404,'umzc_hippo_humerus-cleaned.tif',250,2,26,590.261221,73.7485329,82.6574967,1.8,75.2987854,81.7849356,-0.9569237,20.0572492,38.6849064,41796.8051687,182623.477769,65.7335528,4720.7940977,2083.875253,5789.502092,0.9804681,1.5502562,1.8925469,4.1597738),(15405,'umzc_hippo_humerus-cleaned.tif',250,2,27,608.8908295,73.0819914,83.0100898,1.8,74.827709,81.8495822,-0.9661585,28.5823513,39.4835282,43447.7797958,198112.3019983,68.6878059,5017.5936967,1520.0911695,6082.7829645,34.7833661,69.2966245,0.880587,253.0289978),(15406,'umzc_hippo_humerus-cleaned.tif',250,2,28,632.2511405,72.4296273,83.2433478,1.8,74.1611478,82.0411506,-0.9791246,39.9492924,39.84255,45714.5715729,214590.9266202,72.5946222,5385.9737035,1144.3149249,6499.19453,0.490234,0.6932956,2.3561945,1.3865913),(15407,'umzc_hippo_humerus-cleaned.tif',250,2,29,649.1616654,71.8634649,83.4193194,1.8,73.5320866,82.2451732,-0.9955971,19.8198872,40.1260191,48015.2701611,227955.4655187,76.1749937,5680.9888049,2422.5803987,6706.3136042,36.0479904,70.0228595,0.9847355,274.9969656),(15408,'umzc_hippo_humerus-cleaned.tif',250,2,30,670.559359,71.340457,83.5770336,1.8,72.839995,82.6650536,-1.0126434,29.3295666,40.4922943,50198.6822477,244605.5346224,80.411502,6040.7921781,1711.5384936,7256.26446,0.6932956,1.3865913,2.3561945,2.7731826),(15409,'umzc_hippo_humerus-cleaned.tif',250,2,31,689.646176,70.7228494,83.9659506,1.8,72.141995,83.1014855,-1.0348451,22.785357,41.0585531,52545.2542914,259287.075526,84.9675401,6315.0563218,2306.0974768,7548.7551996,36.776106,73.0514531,0.9138732,266.0333933),(15410,'umzc_hippo_humerus-cleaned.tif',250,2,32,705.3989685,70.1146377,84.3510861,1.8,71.2887443,83.7599127,-1.0578882,31.5154497,41.4690603,54815.5227511,273649.423456,89.256541,6598.8817049,1739.3222455,7890.4033308,36.0237707,74.1048398,0.9736197,254.7027616),(15411,'umzc_hippo_humerus-cleaned.tif',250,2,33,723.7171683,69.556168,84.599209,1.8,70.7957453,83.9315252,-1.0815662,67.5148882,62.0919346,57120.2382645,291164.0783082,93.9807409,4689.2415299,846.0391448,3864.1006799,1.902688,3.28859,1.1071487,9.3000158),(15412,'umzc_hippo_humerus-cleaned.tif',250,2,34,737.9834869,69.0203149,84.8889882,1.8,70.1253106,84.3878134,-1.0998178,26.7507134,42.684799,58423.9222648,308022.0159953,97.6725157,7216.1992762,2184.013618,8379.5978007,38.144583,77.1974654,1.0815861,316.6932459),(15413,'umzc_hippo_humerus-cleaned.tif',250,2,35,753.152643,68.4346525,85.424512,1.8,69.4925551,84.9382504,-1.1206195,29.2945101,43.5410904,60409.6106257,324653.7647518,101.7592613,7456.2617061,2062.1478372,8778.5683177,38.4287697,78.9946418,1.0655061,298.7661013),(15414,'umzc_hippo_humerus-cleaned.tif',250,2,36,768.4333702,67.7296109,86.3398962,1.8,68.735388,85.8505252,-1.1470657,26.171382,45.3142666,62574.8039491,342262.7054319,106.4208705,7553.0893682,2390.9629167,8244.8469304,38.6465599,81.1851857,1.0666304,289.6343073),(15415,'umzc_hippo_humerus-cleaned.tif',250,2,37,777.9687677,67.00833,87.3663742,1.8,67.914777,86.9065069,-1.1774383,47.3775256,46.0391535,64212.7358365,362458.6468974,110.6125274,7872.8347303,1355.3416954,7962.3297037,0.490234,0.6932956,2.3561945,1.3865913),(15416,'umzc_hippo_humerus-cleaned.tif',250,2,38,791.805989,66.3997264,88.1607717,1.8,67.2152801,87.8962862,-1.2056026,54.8145133,47.0640288,66184.5751122,384390.0700289,115.1362396,8167.3855797,1207.4279436,6562.8075144,38.1985588,86.4828996,1.1934478,344.7903772),(15417,'umzc_hippo_humerus-cleaned.tif',250,2,39,819.412484,67.5434229,88.5026232,1.8,69.4905776,88.6474721,-1.1048952,90.6922374,69.1325659,139355.8417826,436518.6907255,109.0083713,6314.2266588,1536.5795992,6139.3900862,0.9804681,1.3865913,0.7853982,2.7731826),(15418,'umzc_hippo_humerus-cleaned.tif',250,2,40,879.2272726,71.9947391,89.0244168,1.8,73.7808295,89.183538,-0.5517796,103.8099068,67.9128391,351316.3105716,581255.9297573,40.267047,8558.8518706,3384.2272044,8192.6497581,0.490234,0.6932956,2.3561945,1.3865913),(15419,'umzc_hippo_humerus-cleaned.tif',250,2,41,932.7164452,75.7532618,89.6860121,1.8,77.3086406,89.8135333,-0.2232553,79.8064517,81.7793552,426016.9653024,819164.9092551,7.6203435,10016.7689955,5338.1268845,11352.8427061,37.8480033,91.4059754,1.2032374,330.1818978),(15420,'umzc_hippo_humerus-cleaned.tif',250,2,42,975.9004378,78.4719256,89.9302886,1.8,80.0310253,90.2437414,-0.1359727,83.2893029,83.2412568,460058.1837616,1014510.5450671,2.9886804,12187.592833,5523.6166901,14016.0125337,0.490234,0.6932956,2.3561945,1.3865913),(15421,'umzc_hippo_humerus-cleaned.tif',250,2,43,1014.6414677,80.9316811,89.9833478,1.8,82.3305065,90.5325287,-0.0885417,64.2249597,83.1269293,486983.5341342,1193939.3835328,1.3222739,14362.8471899,7582.4653873,19075.2082087,0.490234,0.6932956,2.3561945,1.3865913),(15422,'umzc_hippo_humerus-cleaned.tif',250,2,44,1041.6730656,82.7456186,90.1593842,1.8,84.5879856,90.7835741,-0.066961,55.2719371,83.3435198,508722.0053722,1325214.8698255,0.7772757,15900.634773,9203.9836461,20871.2512697,37.6269902,93.490859,1.2341215,359.8338421),(15423,'umzc_hippo_humerus-cleaned.tif',250,2,45,1075.1041261,84.5458734,90.3992124,1.8,86.7720538,90.9886941,-0.0534286,53.9914239,82.8855513,532559.1288252,1454371.5772332,0.5110148,17546.7443381,9863.7726269,22767.0553575,37.9663817,94.1006776,1.2473983,384.3659532),(15424,'umzc_hippo_humerus-cleaned.tif',250,2,46,1125.8074437,86.6165794,90.5279795,1.8,89.1327237,91.1773032,-0.0434485,90.9074919,82.0245703,558108.0995359,1609378.2690989,0.3539888,19620.6851511,6139.2970767,20172.0084387,38.155432,94.8777045,1.2555816,320.8614733),(15425,'umzc_hippo_humerus-cleaned.tif',250,2,47,1181.6944485,88.636537,90.6923406,1.8,91.5045114,91.3595316,-0.0326347,89.8089064,81.2174215,587231.2617947,1758653.475028,0.2096811,21653.6482297,6538.6751217,23729.0124121,37.8853791,95.0460026,1.2669884,373.0761389),(15426,'umzc_hippo_humerus-cleaned.tif',250,2,48,1241.9333821,90.7995122,90.906683,1.8,93.8571988,91.5941188,-0.0162879,87.0797953,89.8519512,616317.0525462,1924813.1184361,0.0549085,21422.0514103,7077.6125548,25189.1126418,0.6932956,1.3865913,0.7853982,2.7731826),(15427,'umzc_hippo_humerus-cleaned.tif',250,2,49,1299.8567053,92.953261,91.1925726,1.8,95.9276932,91.8195554,-0.0092465,100.3361637,106.4671371,647504.1161827,2089905.4548382,0.018522,19629.5825329,6453.3473483,23979.5628001,38.8407772,97.1059482,1.2841751,431.2024754),(15428,'umzc_hippo_humerus-cleaned.tif',250,2,50,1359.5554803,94.5813354,91.2957776,1.8,97.7201831,91.856617,-0.0073399,75.0069397,78.8630614,678570.0591893,2227462.5701907,0.0122076,28244.6880799,9046.7637018,32418.8376477,39.6685717,97.9106751,1.2918089,388.3082343),(15429,'umzc_hippo_humerus-cleaned.tif',250,2,51,1439.6860432,97.0905583,91.6179722,1.8,99.6844256,91.8426728,0.0051437,75.8117241,76.5700859,713628.3126392,2426171.1568365,0.0063494,31685.6266929,9413.1655965,35618.8666496,41.0255539,98.2488229,1.2979798,402.5021369),(15430,'umzc_hippo_humerus-cleaned.tif',250,2,52,1506.3161372,98.5128291,92.0969251,1.8,101.1801265,92.2688793,0.0125317,57.2505205,75.8346194,757214.9676044,2574941.8342329,0.0394238,33954.7010952,13226.3420624,40186.6187791,39.7988885,99.1630909,1.3210215,407.1954382),(15431,'umzc_hippo_humerus-cleaned.tif',250,2,53,1559.7710082,98.9902873,93.0792974,1.8,101.5861947,93.4766864,0.0097481,87.5202542,75.7021158,851894.4861919,2689607.6841338,0.0247017,35528.8310839,9733.6838654,31652.3085613,39.6258621,100.4979797,1.3494819,356.2892306),(15432,'umzc_hippo_humerus-cleaned.tif',250,2,54,1651.3223893,98.5850956,95.6980107,1.8,101.3331726,95.7262922,-0.0635786,80.4847577,75.8353666,1148052.4087625,2872147.5379108,1.111007,37873.4575704,14264.2214716,37914.3368329,0.490234,0.6932956,2.3561945,1.3865913),(15433,'umzc_hippo_humerus-cleaned.tif',250,2,55,1790.3700739,98.8685348,99.6403765,1.8,103.0985769,100.8598278,-0.102464,91.8313557,77.4516093,1539267.7142914,3169618.8021774,3.1218611,40923.8598387,16761.8968832,41825.3493142,1.4707021,2.6399911,1.9513027,6.12071),(15434,'umzc_hippo_humerus-cleaned.tif',250,2,56,2148.4419767,104.5020008,107.7706214,1.8,105.5181391,106.3976301,0.1506505,84.9472649,86.0360101,2282682.8192245,4032809.9080273,8.0653967,46873.5114648,26871.7635786,59864.6420242,0.490234,0.6932956,2.3561945,1.3865913),(15435,'umzc_hippo_humerus-cleaned.tif',250,2,57,2396.6311169,105.9062704,112.3048129,1.8,105.6828327,109.9094898,0.2286128,85.9409069,90.1858339,2750583.3537678,4569521.9426901,20.5150109,50667.8460143,32005.5192932,70588.3762871,0.490234,0.6932956,2.3561945,1.3865913),(15436,'umzc_hippo_humerus-cleaned.tif',250,2,58,2566.0260715,107.1016976,114.6342764,1.8,106.3260024,111.9589335,0.3208135,88.7763804,95.6575934,3014970.3533931,4943346.6836236,42.5269433,51677.5146418,33961.4021149,75985.6061891,0.490234,0.6932956,2.3561945,1.3865913),(15437,'umzc_hippo_humerus-cleaned.tif',250,2,59,2717.9593457,108.1012155,116.4579114,1.8,107.0306684,113.4128451,0.3925488,107.3359717,107.2166943,3217760.4299133,5281976.0110144,66.2911908,49264.4923235,29978.3975366,72017.9873862,44.3192483,142.7524172,1.4225856,569.5913379),(15438,'umzc_hippo_humerus-cleaned.tif',250,2,60,2879.782904,109.1443621,118.0002174,1.8,107.7889189,114.8833792,0.4505871,95.9317336,104.1886237,3396827.9497287,5623689.669488,91.0275785,53976.0433753,35408.8039659,82779.7304093,44.7384272,143.651124,1.4269688,608.3462139),(15439,'umzc_hippo_humerus-cleaned.tif',250,2,61,3056.2567253,110.2370156,119.8052511,1.8,108.4234664,116.3144358,0.4935904,92.6578327,107.2008379,3592210.2296852,5955471.7633911,114.3435899,55554.339711,38768.5544188,86442.620138,46.3656556,143.651124,1.4269688,643.614203),(15440,'umzc_hippo_humerus-cleaned.tif',250,2,62,3265.6449717,110.8334211,121.264862,1.8,108.7194646,117.6464375,0.5309769,106.6701297,109.474223,3802612.0286559,6321055.7923138,139.5609666,57740.129297,35648.3304169,90255.1364706,0.490234,0.6932956,2.3561945,1.3865913),(15441,'umzc_hippo_humerus-cleaned.tif',250,2,63,3510.2617243,111.0496063,122.4645822,1.8,108.9462778,118.8218238,0.5653125,97.6287446,111.2847548,4025419.5630205,6669477.9805744,167.8798863,59931.6410836,41231.9095081,94539.5203794,0.490234,0.6932956,2.3561945,1.3865913),(15442,'umzc_hippo_humerus-cleaned.tif',250,2,64,3777.8008786,110.9889067,123.5969541,1.8,109.0315985,120.4046897,0.5998826,116.4775202,112.1368151,4258953.0079716,6981813.4248213,200.6715706,62261.563431,36564.5920445,94609.0899023,1.3865913,2.0798869,2.3561945,5.1402419),(15443,'umzc_hippo_humerus-cleaned.tif',250,2,65,4120.5298598,110.6541064,125.5073123,1.8,108.7414411,122.3445978,0.6291004,115.7890588,113.8627728,4604800.405256,7281478.7454119,237.7787887,63949.5997578,39768.8732621,101898.7389818,137.9495257,163.3862636,1.0494172,1211.5521859),(15444,'umzc_hippo_humerus-cleaned.tif',250,2,66,4290.1676928,110.542085,126.9098438,1.8,108.7693533,123.3532499,0.6501884,126.0055002,114.8446553,4836599.7990966,7418632.8046121,262.0092005,64597.1097506,38384.0371485,96488.1456246,137.8339166,163.4531771,1.0427219,1160.863471),(15445,'umzc_hippo_humerus-cleaned.tif',250,2,67,4347.9325442,110.8152039,127.8943142,1.8,108.9433175,124.012666,0.6706709,121.0135821,115.3982569,4950521.8033737,7500711.5577026,279.9176028,64998.4822842,40908.8113678,102370.2008441,138.1961578,163.2067117,1.0453165,1221.0119698),(15446,'umzc_hippo_humerus-cleaned.tif',250,2,68,4382.4002985,111.0979459,128.6514711,1.8,109.0618443,124.7049793,0.6921797,126.924902,116.3271446,5017525.2759171,7565391.8797127,297.5069844,65035.4816417,39531.4488869,98922.0163989,0.490234,0.6932956,2.3561945,1.3865913),(15447,'umzc_hippo_humerus-cleaned.tif',250,2,69,4439.2995999,111.5495559,128.9586647,1.8,109.2670352,125.1262555,0.7126149,125.47237,117.4146283,5107609.8307532,7648638.7121408,316.2805292,65142.1277165,40707.0483495,101498.7105585,139.3842937,163.2067117,1.0453165,1081.5729596),(15448,'umzc_hippo_humerus-cleaned.tif',250,2,70,4476.3779144,112.1396374,129.3764648,1.8,109.6684789,125.593082,0.7297773,126.1877074,118.3817429,5150963.5631423,7718200.0644045,331.6203769,65197.5539173,40819.852173,101923.2359025,139.8620492,164.0527057,2.1281286,1101.8059374),(15449,'umzc_hippo_humerus-cleaned.tif',250,2,71,4515.4001297,112.7817841,129.8215807,1.8,110.0569343,125.8946033,0.7419044,123.2646465,119.2436112,5152513.2420692,7759876.0723734,343.5926339,65075.8224438,41800.4138965,104697.6983685,0.490234,0.6932956,2.3561945,1.3865913),(15450,'umzc_hippo_humerus-cleaned.tif',250,2,72,4552.0157007,113.2076734,129.9739021,1.8,110.2530171,126.089822,0.7566987,125.6440732,119.6282521,5161586.1638754,7855266.8142548,357.5731726,65663.9771491,41081.0158667,103595.7504358,0.490234,0.6932956,2.3561945,1.3865913),(15451,'umzc_hippo_humerus-cleaned.tif',250,2,73,4573.1133467,113.7345621,130.3447913,1.8,110.4117546,126.3024679,0.7677005,127.2748537,120.8294064,5118877.3292868,7903907.6052111,367.6067186,65413.7750348,40219.0784888,102261.9835816,139.5328303,166.9828129,2.1449562,1125.6855703),(15452,'umzc_hippo_humerus-cleaned.tif',250,2,74,4556.30427,114.1429184,130.6192674,1.8,110.5524605,126.627459,0.7748163,119.2340907,121.0484747,5031624.5159736,7896408.4703838,371.656896,65233.4404944,42199.5461643,106616.6052788,0.490234,0.6932956,2.3561945,1.3865913),(15453,'umzc_hippo_humerus-cleaned.tif',250,2,75,4506.4832527,114.4007216,131.0228301,1.8,110.5403451,126.9277451,0.7721024,123.8003651,121.4594319,4981724.4878814,7878250.6184085,365.5552588,64863.2262876,40239.9822039,103786.6885549,140.0508459,166.3013785,2.1162714,1036.9352749),(15454,'umzc_hippo_humerus-cleaned.tif',250,2,76,4366.3557607,114.5569686,131.845354,1.8,110.6168401,127.3710323,0.757826,127.8165681,122.322853,4890230.6607184,7837797.7833994,343.808205,64074.6809919,38259.7556237,99532.3566598,0.490234,0.6932956,2.3561945,1.3865913),(15455,'umzc_hippo_humerus-cleaned.tif',250,2,77,4252.0384833,114.8711349,132.555182,1.8,110.8773872,127.8030655,0.7578857,125.6807663,123.0396176,4801055.0689422,7759322.3319706,334.8490265,63063.6089918,38200.3962101,99877.0804616,138.7637396,166.4371666,2.1718701,934.971545),(15456,'umzc_hippo_humerus-cleaned.tif',250,2,78,4203.3933323,115.2233535,133.2717937,1.8,111.0934786,128.2663443,0.7532678,128.4403245,123.6214704,4753012.3092863,7743768.8474976,327.7888087,62640.9702439,37005.6080616,97205.8545441,0.490234,0.6932956,2.3561945,1.3865913),(15457,'umzc_hippo_humerus-cleaned.tif',250,2,79,4165.3801364,115.6512892,133.8814924,1.8,111.4867824,128.6904322,0.7478726,124.4154679,124.393389,4697366.3896574,7685382.9888468,321.0880562,61782.889338,37755.4854527,98726.5967567,139.2806862,166.3512285,2.1865923,991.3459845),(15458,'umzc_hippo_humerus-cleaned.tif',250,2,80,4121.1593772,115.9358982,134.3674102,1.8,111.8268147,129.1039659,0.7436836,124.2656558,124.9627597,4627680.5486858,7620856.0222965,314.8111149,60985.0169994,37240.2215003,97583.1747568,139.1127479,166.3114942,2.099083,1015.7387362),(15459,'umzc_hippo_humerus-cleaned.tif',250,2,81,4068.8631854,116.3368616,134.9360963,1.8,112.1041833,129.2878376,0.7368759,124.8433636,125.458636,4546012.2408325,7536414.9889265,306.218451,60070.9144517,36413.7276467,95647.4946023,138.4342692,165.5060929,2.1793384,1075.2023929),(15460,'umzc_hippo_humerus-cleaned.tif',250,2,82,4014.0976451,116.6106396,135.4032174,1.8,112.2178309,129.7648426,0.7319696,123.0623302,125.6470238,4454070.8870092,7417914.5332446,298.8315602,59037.7257559,36193.6173362,93923.7699829,138.7283441,165.908558,2.1776492,956.9599215),(15461,'umzc_hippo_humerus-cleaned.tif',250,2,83,3984.6573638,116.9109212,135.770747,1.8,112.2962943,130.1887029,0.7227628,125.9986076,125.7685823,4395749.3515064,7388947.0053256,290.5667746,58750.3402525,34887.2851499,92708.6683628,137.009102,164.8236566,2.1785983,895.3058806),(15462,'umzc_hippo_humerus-cleaned.tif',250,2,84,3939.8311201,117.1644632,136.0179716,1.8,112.5919404,130.5902839,0.7194337,125.5100684,126.3775033,4312286.6402574,7296595.207558,285.1299864,57736.5038434,34358.0933082,91295.0140474,0.490234,0.6932956,2.3561945,1.3865913),(15463,'umzc_hippo_humerus-cleaned.tif',250,2,85,3892.0462028,117.3801203,136.3272568,1.8,112.759884,130.9711966,0.7084405,123.2030758,126.7409852,4211699.7620135,7192052.9330808,274.6136171,56746.0708957,34185.0212235,88897.9756319,133.7943299,163.2744348,2.1962814,799.2657767),(15464,'umzc_hippo_humerus-cleaned.tif',250,2,86,3845.1278551,117.5060969,136.5689709,1.8,112.9812994,131.2632482,0.6974409,129.1741028,126.7855058,4116239.0245914,7112998.1476842,264.3497796,56102.6128345,31865.8224373,86927.0743582,131.4685304,162.2526584,2.1822649,898.7927675),(15465,'umzc_hippo_humerus-cleaned.tif',250,2,87,3779.3298835,117.391194,136.7783321,1.8,113.2770901,131.7791574,0.689144,126.7874352,126.7281222,3993438.2843092,6980085.012157,254.6885637,55079.2112256,31497.1138642,85677.0404644,0.9804681,1.3865913,2.3561945,2.7731826),(15466,'umzc_hippo_humerus-cleaned.tif',250,2,88,3718.6185933,117.3430729,136.8555089,1.8,113.5075704,131.9548252,0.6845033,124.7542799,126.6951539,3916185.4911311,6859849.1591934,247.7768198,54144.5268453,31391.1914978,83754.687792,129.2256567,159.5220385,2.4279664,1005.4089813),(15467,'umzc_hippo_humerus-cleaned.tif',250,2,89,3656.3383162,117.2509825,136.8673451,1.8,113.7275218,132.1533507,0.6742013,128.4112725,126.4391516,3827154.0466004,6689526.4323956,237.4898323,52907.0809677,29803.879142,81880.3019506,128.5398449,159.7125046,2.4126562,899.8429154),(15468,'umzc_hippo_humerus-cleaned.tif',250,2,90,3596.6625545,117.2597857,136.8876713,1.8,113.8087826,132.2940792,0.665381,128.8080431,126.1330341,3726752.666336,6523880.9529791,228.467218,51722.2232991,28932.6083751,79569.2677137,0.490234,0.6932956,2.3561945,1.3865913),(15469,'umzc_hippo_humerus-cleaned.tif',250,2,91,3558.3589242,117.2987772,136.7520932,1.8,113.9160633,132.4624548,0.6553415,128.2778748,126.2205655,3658651.3719126,6384875.0143512,220.265385,50585.0610556,28521.297048,78285.4054615,126.6690163,158.4214668,2.34963,879.3720361),(15470,'umzc_hippo_humerus-cleaned.tif',250,2,92,3496.2148337,117.2011736,136.6554224,1.8,114.0378221,132.6977007,0.6467057,113.4675519,125.4111556,3560843.0204394,6201574.668116,211.5671779,49449.9443604,31382.0379465,76126.5976163,125.6935885,156.7829494,2.3915779,789.8383567),(15471,'umzc_hippo_humerus-cleaned.tif',250,2,93,3430.7183663,116.9581532,136.601999,1.8,114.1000381,132.7498602,0.6465503,128.2521131,125.6846488,3446209.5872305,6048939.1480224,207.5183049,48127.9074861,26870.5871839,73935.8719067,0.490234,0.6932956,2.3561945,1.3865913),(15472,'umzc_hippo_humerus-cleaned.tif',250,2,94,3370.0835446,116.8513559,136.4570017,1.8,114.2528387,132.7057499,0.6516837,122.8618546,125.6871723,3303200.2835113,5929272.3971566,206.6274969,47174.841209,26885.4828428,72111.59669,0.490234,1.0961967,2.0344439,2.3670594),(15473,'umzc_hippo_humerus-cleaned.tif',250,2,95,3312.5082621,117.1020445,136.1410858,1.8,114.4472021,132.5364652,0.6564139,126.7509247,125.4448118,3167386.7401061,5835301.3361134,205.6192841,46516.880643,24989.0621946,70320.5629781,0.490234,0.6932956,2.3561945,1.3865913),(15474,'umzc_hippo_humerus-cleaned.tif',250,2,96,3263.7535791,117.4016546,135.9940836,1.8,114.6659313,132.3864316,0.6469643,127.9892944,125.3680511,3013530.5023534,5767998.9075203,197.6355018,46008.5233702,23545.1763035,68545.3483157,0.8786992,2.4511702,2.4980915,4.8530695),(15475,'umzc_hippo_humerus-cleaned.tif',250,2,97,3214.9847677,117.6498212,135.9724135,1.8,114.7775729,132.1866121,0.6417766,127.79672,125.8707395,2856029.3743318,5689421.1141959,192.0124599,45200.505989,22348.221259,66635.1989511,0.490234,0.6932956,2.3561945,1.3865913),(15476,'umzc_hippo_humerus-cleaned.tif',250,2,98,3106.7261951,117.0512791,135.4860635,1.8,114.6066612,132.1195191,0.6568902,128.1169968,124.9816722,2672038.0124867,5441532.9580165,193.0841594,43538.6473894,20856.2335881,63313.4373642,0.490234,0.6932956,2.3561945,1.3865913),(15477,'umzc_hippo_humerus-cleaned.tif',250,2,99,3035.5512532,116.3812059,135.0609947,1.8,114.0901782,131.9283767,0.6708901,125.9365125,124.4289405,2524198.9913356,5265821.2859607,195.5351685,42319.9077755,20043.4245957,61847.2784155,0.490234,0.6932956,2.3561945,1.3865913),(15478,'umzc_hippo_humerus-cleaned.tif',250,2,100,2958.435805,115.7305905,134.5788089,1.8,113.6911539,131.7384826,0.6820849,128.6576509,124.1013087,2384974.2529957,5059681.7646046,195.9570621,40770.5754211,18537.3682544,57862.5453817,109.124772,150.0228326,2.4163072,695.2953412),(15479,'umzc_hippo_humerus-cleaned.tif',250,2,101,2916.2681874,115.3002052,134.1583346,1.8,113.3407013,131.513077,0.6855063,127.9172328,123.345527,2280727.7966666,4936480.4843831,194.7927598,40021.5606089,17829.7149391,56419.1089475,0.490234,0.6932956,2.3561945,1.3865913),(15480,'umzc_hippo_humerus-cleaned.tif',250,2,102,2860.0604521,114.722161,133.6248341,1.8,113.0274895,131.1717406,0.6933263,128.5070576,122.6176976,2166512.4680495,4782119.7503854,194.697458,39000.2409394,16859.0932596,54067.9799623,101.9144589,148.6387692,2.4168676,754.9476284),(15481,'umzc_hippo_humerus-cleaned.tif',250,2,103,2823.763718,114.3764383,133.2130547,1.8,112.8909288,130.9535767,0.6929327,128.3464503,122.2225522,2087769.4367416,4611336.158239,192.0444874,37729.0121639,16266.6706568,52182.760009,101.4736939,148.340967,2.5490071,809.439265),(15482,'umzc_hippo_humerus-cleaned.tif',250,2,104,2776.5817363,113.9454355,133.3348872,1.8,112.5828313,130.8143293,0.6945601,129.7245746,122.0488583,1969434.482574,4450323.8183581,189.5761117,36463.4612668,15181.6607467,49471.4164595,0.490234,0.6932956,2.3561945,1.3865913),(15483,'umzc_hippo_humerus-cleaned.tif',250,2,105,2741.879333,113.5864848,133.6856551,1.8,111.867757,130.6945476,0.7055097,123.9778336,122.1545389,1834913.2330131,4328168.3030946,192.137649,35431.907345,14800.3330837,49703.7727306,0.490234,0.6932956,2.3561945,1.3865913),(15484,'umzc_hippo_humerus-cleaned.tif',250,2,106,2698.0648762,113.4309979,133.6532095,1.8,111.2151968,130.4980723,0.7035452,128.1950895,121.98802,1703365.4621797,4231890.8645959,188.1954833,34691.0365827,13287.2910281,46287.1041748,94.9020831,145.3384802,2.3919787,712.7670916),(15485,'umzc_hippo_humerus-cleaned.tif',250,2,107,2631.6799182,113.0612943,132.7795647,1.8,110.5065867,129.668223,0.6801877,126.7773469,120.8484431,1592048.284991,4069703.0605015,173.499755,33676.0901253,12557.8293325,44654.9112176,0.490234,1.5502562,1.8925469,3.3475275),(15486,'umzc_hippo_humerus-cleaned.tif',250,2,108,2535.9682892,112.3361393,131.7804108,1.8,109.7136668,128.6657961,0.652972,128.3239359,119.0744813,1479617.7100324,3811374.9840917,156.0113417,32008.3274051,11530.3329819,41112.6983672,0.490234,0.6932956,2.3561945,1.3865913),(15487,'umzc_hippo_humerus-cleaned.tif',250,2,109,2457.2822518,111.159544,130.4016264,1.8,108.5889693,127.4295495,0.6200308,127.665007,117.0069445,1403092.2753805,3484250.7172225,138.27577,29778.1531861,10990.4217906,37954.3106082,0.490234,2.499713,1.7681919,5.3084637),(15488,'umzc_hippo_humerus-cleaned.tif',250,2,110,2344.371557,109.6765556,128.5482771,1.8,106.9540933,125.4207673,0.5585861,125.1375048,112.3927632,1316289.3529435,3061137.056357,109.7505692,27236.0690176,10518.7438002,34340.724491,86.9390221,129.3781429,2.3910329,571.4945495),(15489,'umzc_hippo_humerus-cleaned.tif',250,2,111,2295.5096726,109.462085,128.1024585,1.8,106.4843207,124.7308166,0.5404111,123.4788907,111.5962697,1254364.137905,2918790.8927381,101.2696442,26154.9145133,10158.530993,33051.1796241,0.490234,0.6932956,2.3561945,1.3865913),(15490,'umzc_hippo_humerus-cleaned.tif',250,2,112,2258.5480271,109.3087779,127.6364456,1.8,106.1428432,124.1853411,0.5258844,122.0866285,110.8592867,1209870.7364179,2801085.6277266,94.8522583,25267.0363485,9909.9365048,32001.8673978,85.4634887,124.9241022,2.5122193,576.1385798),(15491,'umzc_hippo_humerus-cleaned.tif',250,2,113,2216.895734,109.2484264,127.1165717,1.8,105.891589,123.7456559,0.5070134,121.8188816,110.1865872,1151986.9507592,2671164.2082357,87.1154216,24242.1902291,9456.5549735,30339.3676211,83.7702804,122.2581205,2.4186133,617.0922935),(15492,'umzc_hippo_humerus-cleaned.tif',250,2,114,2169.9554654,109.1483559,126.7818768,1.8,105.4028126,123.3261347,0.4950593,114.7760249,108.6991368,1096148.3705282,2571656.5266903,81.628183,23658.4815973,9550.3252663,30206.6522933,82.0581656,121.7331198,2.4674806,553.5181339),(15493,'umzc_hippo_humerus-cleaned.tif',250,2,115,2128.8165305,109.164784,126.5513982,1.8,105.1838152,123.0724441,0.4822899,119.6541104,109.0928666,1052402.486969,2465841.6784412,76.3247783,22603.1431365,8795.3726229,28154.5654108,0.6932956,2.0798869,2.3561945,4.1597738),(15494,'umzc_hippo_humerus-cleaned.tif',250,2,116,2085.2288572,109.1391438,126.2385123,1.8,105.0409447,122.7574594,0.4658765,114.8342379,107.8960921,1011239.9305017,2362158.7353709,70.1283688,21892.9035318,8806.0838756,27812.8496591,80.5223533,118.7641938,2.5203835,518.3979578),(15495,'umzc_hippo_humerus-cleaned.tif',250,2,117,2043.3939866,109.0137754,125.8026401,1.8,104.7243999,122.363609,0.4564268,116.0846331,107.49947,968040.8344653,2283393.863614,66.1565261,21240.9778648,8339.0954381,26323.9886777,79.1468983,118.3161364,2.5329033,551.9717744),(15496,'umzc_hippo_humerus-cleaned.tif',250,2,118,2009.8202577,109.0127696,125.4443366,1.8,104.5725721,122.0147442,0.4500021,119.4618065,106.8939396,935207.5142643,2210545.5747898,63.3752142,20679.8026373,7828.5063794,24895.1554444,0.6932956,1.3865913,2.3561945,2.7731826),(15497,'umzc_hippo_humerus-cleaned.tif',250,2,119,1975.8104402,109.0687742,125.0396009,1.8,104.5342352,121.7452612,0.4459993,115.4458575,108.1819587,899125.9435921,2140564.5540455,61.2735364,19786.7054648,7788.2910902,24939.2262772,0.490234,0.6932956,2.3561945,1.3865913),(15498,'umzc_hippo_humerus-cleaned.tif',250,2,120,1944.0037152,109.1692049,124.6254487,1.8,104.5370014,121.397051,0.4479195,89.2551483,107.6885315,863015.8546643,2084562.2365386,60.7721524,19357.3281018,9669.0876793,25789.0553018,76.3510016,113.4687979,2.6315567,425.9228741),(15499,'umzc_hippo_humerus-cleaned.tif',250,2,121,1915.1238385,109.2015184,124.2081821,1.8,104.7592273,121.0672155,0.4447115,117.3917041,106.310822,823572.1318952,2026719.3837258,59.0719473,19064.0928791,7015.5905651,22864.0748333,76.2210041,112.2122069,2.5269297,476.1069238),(15500,'umzc_hippo_humerus-cleaned.tif',250,2,122,1891.2809022,109.2508307,123.9047628,1.8,104.7313931,120.8453981,0.4393996,89.7416072,105.7488856,791572.9220272,1975027.8060361,57.0416328,18676.582688,8820.5788413,24354.2002997,74.6051118,112.4443456,2.5547992,431.7071406),(15501,'umzc_hippo_humerus-cleaned.tif',250,2,123,1854.9216825,109.2671666,123.5039116,1.8,104.8077891,120.4604964,0.4384814,112.7036263,107.2633485,758050.3469495,1918091.7708629,55.7266184,17882.0799205,6726.0510757,22110.2849184,73.5985702,110.0452598,2.5239325,437.7088999),(15502,'umzc_hippo_humerus-cleaned.tif',250,2,124,1826.9306605,109.1930156,123.0781401,1.8,104.923349,120.2060854,0.4317438,116.2954048,106.5635826,732813.8193569,1866566.3833328,53.3173821,17515.9875179,6301.3136317,20985.4711816,71.4690518,110.4115479,2.5425068,450.1678127),(15503,'umzc_hippo_humerus-cleaned.tif',250,2,125,1809.7482721,109.049872,122.7417389,1.8,104.9146526,120.0059003,0.4251452,108.1895839,105.58927,715895.3302079,1823497.7992584,51.3116479,17269.7263637,6617.0448642,22316.1040414,0.6932956,1.3865913,2.3561945,2.7731826),(15504,'umzc_hippo_humerus-cleaned.tif',250,2,126,1791.7118403,109.0050059,122.4608367,1.8,104.9787943,119.8546601,0.4197986,56.2066689,102.6267399,698466.0021919,1783957.1042666,49.6061228,17382.9657451,12426.7460811,22209.8739708,0.490234,0.6932956,2.3561945,1.3865913),(15505,'umzc_hippo_humerus-cleaned.tif',250,2,127,1777.9873553,108.9616776,122.1665218,1.8,104.9360303,119.7128391,0.4160356,111.4295555,104.1156188,688734.536001,1750457.3135441,48.3988957,16812.6294071,6180.8963773,20092.9869593,69.7029603,107.1113716,2.5980334,405.5505368),(15506,'umzc_hippo_humerus-cleaned.tif',250,2,128,1768.2165078,108.8635086,121.8879381,1.8,105.0064589,119.6439245,0.4123557,85.1451376,104.433958,680783.9857465,1717288.3454465,47.3338355,16443.7734462,7995.5709162,21571.4289573,0.6932956,1.3865913,2.3561945,2.7731826),(15507,'umzc_hippo_humerus-cleaned.tif',250,2,129,1759.0706625,108.8850961,121.6424637,1.8,105.2452035,119.5016979,0.4057946,87.8749062,104.3859579,666099.776145,1681050.2040871,45.6850349,16104.1795087,7580.0908937,21040.8307672,0.490234,0.6932956,2.3561945,1.3865913),(15508,'umzc_hippo_humerus-cleaned.tif',250,2,130,1739.7012763,108.8028044,121.4304667,1.8,105.2204706,119.3857814,0.4017562,58.9666115,103.377699,650609.9469065,1643800.0032473,44.3358786,15900.9149879,11033.5311776,20614.5165886,69.1961591,104.3461759,2.6148709,439.6494274),(15509,'umzc_hippo_humerus-cleaned.tif',250,2,131,1732.9520979,108.8511909,121.2685536,1.8,105.3658375,119.3383015,0.39509,77.1217638,103.6886044,641116.9199175,1607823.8568733,42.7869455,15506.2734849,8313.0479397,20417.7741893,0.490234,1.0961967,2.677945,2.0798869),(15510,'umzc_hippo_humerus-cleaned.tif',250,2,132,1720.7864041,108.877363,121.1356807,1.8,105.4425232,119.3135043,0.3916403,69.3928947,103.691003,630887.957583,1574472.3821037,41.7860668,15184.2718911,9091.5353793,20139.883228,68.3369825,102.8253498,2.6715485,440.6791665),(15511,'umzc_hippo_humerus-cleaned.tif',250,2,133,1710.5425446,108.9312195,121.001061,1.8,105.5260647,119.2436448,0.3860944,112.2182768,102.5703569,622106.7813391,1544351.5467969,40.4279196,15056.5094372,5543.7206777,17723.0626983,67.3089753,102.2052753,2.7058348,414.4528829),(15512,'umzc_hippo_humerus-cleaned.tif',250,2,134,1704.2077524,108.8883648,120.8389932,1.8,105.6069076,119.0929743,0.3815439,63.4888558,101.1349808,616833.5303497,1517203.3849563,39.3806393,15001.7666783,9715.6189534,19566.0126821,66.9826403,100.8560497,2.6670759,482.0678656),(15513,'umzc_hippo_humerus-cleaned.tif',250,2,135,1694.4887577,109.0202267,120.7091229,1.8,105.7997455,119.0947842,0.3742595,108.4319744,101.2484219,609148.5328708,1487436.6551461,37.7450834,14690.9613745,5617.7943458,17692.6599479,0.490234,0.6932956,2.3561945,1.3865913),(15514,'umzc_hippo_humerus-cleaned.tif',250,2,136,1687.3492989,109.1002521,120.5580068,1.8,105.8688578,119.0254985,0.3686961,64.8816371,103.0637684,604680.1031659,1465392.8598882,36.5276726,14218.31243,9319.7417711,18668.1900948,65.0514992,98.5089913,2.7157889,329.3372875),(15515,'umzc_hippo_humerus-cleaned.tif',250,2,137,1678.2018513,109.1936913,120.3938878,1.8,106.0601449,118.9887596,0.3580544,59.8722778,101.6278771,594777.0775559,1430487.0236261,34.3519713,14075.734573,9934.0980412,18294.9959351,0.490234,1.0961967,2.0344439,2.3670594),(15516,'umzc_hippo_humerus-cleaned.tif',250,2,138,1673.1402224,109.2124568,120.2884878,1.8,106.2400207,119.1278393,0.3480402,80.5437695,102.3372699,588791.0088065,1400150.1538652,32.4364214,13681.7227552,7310.1993145,18029.7536367,0.490234,0.6932956,2.3561945,1.3865913),(15517,'umzc_hippo_humerus-cleaned.tif',250,2,139,1670.9344353,109.318185,120.1448714,1.8,106.385946,119.0156262,0.3379609,105.6327484,101.6282329,585554.5599808,1376105.1864304,30.6156128,13540.5796859,5543.3051677,16280.0082647,0.9804681,1.3865913,2.3561945,2.7731826),(15518,'umzc_hippo_humerus-cleaned.tif',250,2,140,1666.7458576,109.4492596,120.038015,1.8,106.5328025,119.0356963,0.3273915,58.9256785,97.1492728,581778.2595603,1352111.8019986,28.7263461,13917.878783,9873.0854523,17421.6324662,64.7147929,94.6266008,2.7312587,352.4335363),(15519,'umzc_hippo_humerus-cleaned.tif',250,2,141,1667.607038,109.5042699,119.9607213,1.8,106.6553729,119.0381431,0.3170895,64.0307322,97.8668485,579947.5315934,1336084.6859989,27.0210115,13652.0661091,9057.3309307,17375.107225,0.490234,0.6932956,2.3561945,1.3865913),(15520,'umzc_hippo_humerus-cleaned.tif',250,2,142,1666.6615966,109.5334072,119.9246645,1.8,106.7429027,119.059501,0.3027247,62.9145555,99.074883,578180.4651902,1319572.9277112,24.687914,13318.9451023,9189.9316618,17205.9396077,64.2034912,93.3377819,2.7367009,345.2134075),(15521,'umzc_hippo_humerus-cleaned.tif',250,2,143,1668.9319086,109.6461313,119.8861144,1.8,107.0078889,119.1118579,0.2928916,65.5247517,100.4635465,576285.7089733,1305011.4346334,23.1871155,12989.9001151,8794.9315904,17107.6398254,0.490234,0.6932956,2.3561945,1.3865913),(15522,'umzc_hippo_humerus-cleaned.tif',250,2,144,1670.6680337,109.7000164,119.8599539,1.8,106.9957993,119.1139984,0.2821428,76.1785387,99.9929314,574971.7472985,1292810.6950791,21.5835179,12929.0208506,7547.6867495,17080.9007299,0.9804681,3.1005124,1.2490458,6.6950549),(15523,'umzc_hippo_humerus-cleaned.tif',250,2,145,1673.5715773,109.79835,119.8618374,1.8,107.1791826,119.1451756,0.2708774,63.960065,99.6621112,570068.6458222,1279258.960097,19.9705685,12835.9608727,8912.884085,16853.875413,0.490234,1.5502562,1.8925469,3.3475275),(15524,'umzc_hippo_humerus-cleaned.tif',250,2,146,1670.2336201,109.8156142,119.8731997,1.8,107.2170587,119.300586,0.2575007,63.3605465,97.9885011,565080.9892826,1259807.5653481,18.053544,12856.6877873,8918.499299,16606.3040371,0.9804681,4.9267912,1.670465,10.6169273),(15525,'umzc_hippo_humerus-cleaned.tif',250,2,147,1674.5289623,109.8516339,119.861387,1.8,107.2742323,119.3300754,0.251,67.1840431,98.0073896,563384.0198123,1251819.5625996,17.2166778,12772.705889,8385.6819796,16381.0846105,1.4171309,4.1885615,1.929567,9.0621143),(15526,'umzc_hippo_humerus-cleaned.tif',250,2,148,1680.951584,109.8932673,119.8736401,1.8,107.3983521,119.4473626,0.2413919,67.3389899,96.2910602,562688.0879117,1242841.4687795,16.0102247,12907.1324669,8356.0518054,16495.3564666,63.3753029,90.7780564,0.0432163,377.2239576),(15527,'umzc_hippo_humerus-cleaned.tif',250,2,149,1681.6322989,109.9671842,119.8755481,1.8,107.5820397,119.4843706,0.2303901,66.0405436,95.4529344,560875.1727632,1229293.1204043,14.6153659,12878.5262446,8492.8915212,16247.1135981,0.490234,2.0212868,1.815775,4.3279956),(15528,'umzc_hippo_humerus-cleaned.tif',250,2,150,1689.4649989,109.9371583,119.8720606,1.8,107.563734,119.4440838,0.2232965,65.9885148,95.4510444,561376.8635658,1227206.706078,13.80802,12856.9227749,8507.1904578,16272.8169622,0.9624541,3.1005124,1.8925469,6.6950549),(15529,'umzc_hippo_humerus-cleaned.tif',250,2,151,1697.5212052,109.9164542,119.9118485,1.8,107.5694295,119.5541138,0.2122567,68.2355278,96.6082643,562511.6619016,1225232.7002622,12.5561016,12682.4833185,8243.6771528,16280.6459163,0.490234,1.0961967,2.0344439,2.3670594),(15530,'umzc_hippo_humerus-cleaned.tif',250,2,152,1701.3532214,109.9359993,119.8971556,1.8,107.6621811,119.5557177,0.2030693,68.8827741,93.8526473,562686.2139806,1221918.0589135,11.5333049,13019.5374838,8168.7507754,16521.2296129,0.490234,1.0961967,2.677945,2.0798869),(15531,'umzc_hippo_humerus-cleaned.tif',250,2,153,1714.2463851,110.0059833,119.9907972,1.8,107.8017582,119.6857145,0.1900564,72.0005369,95.2874275,560240.1252686,1218610.0597481,10.1965056,12788.781189,7781.0548269,16253.6141603,0.490234,4.4392581,1.6814535,9.230336),(15532,'umzc_hippo_humerus-cleaned.tif',250,2,154,1718.6333438,109.9680462,120.0281865,1.8,107.7248345,119.8062917,0.1803357,70.2733519,93.5126024,557968.0069901,1215038.4835546,9.2147205,12993.3126953,7939.9657495,16163.117303,0.490234,2.9819773,1.735945,6.2889318),(15533,'umzc_hippo_humerus-cleaned.tif',250,2,155,1720.8784576,109.8911598,120.0277029,1.8,107.5661312,119.8301515,0.1722689,71.6567346,95.1530968,556446.858759,1217493.9189504,8.4277584,12795.105572,7765.4509608,16040.3882234,62.9792037,89.5090047,0.1984697,381.7898546),(15534,'umzc_hippo_humerus-cleaned.tif',250,2,156,1723.7868077,109.8515525,120.0854541,1.8,107.6990683,120.0059726,0.1585591,68.678874,94.5215414,553554.3534516,1213948.704107,7.1626187,12843.0904395,8060.0382802,16024.3548194,0.9690772,3.7335113,1.9756881,8.0816462),(15535,'umzc_hippo_humerus-cleaned.tif',250,2,157,1732.3195946,109.7469876,120.1509773,1.8,107.6129359,120.100708,0.1466914,75.3703257,92.8314509,553803.3139345,1220206.7957611,6.1683465,13144.3253692,7347.7633084,16094.2445052,62.4030359,88.9433728,2.7692744,378.085475),(15536,'umzc_hippo_humerus-cleaned.tif',250,2,158,1738.2909796,109.6387764,120.1807772,1.8,107.5881089,120.0688071,0.1372937,75.9425928,91.4865743,552168.4049373,1228327.2481124,5.4267778,13426.31154,7270.8658555,16059.6812702,62.4252375,90.2483467,0.2357563,377.2239576),(15537,'umzc_hippo_humerus-cleaned.tif',250,2,159,1746.6293909,109.5525227,120.2339921,1.8,107.6009945,120.1462087,0.1264687,76.4386412,91.0105725,552221.5862617,1236953.8193242,4.6312531,13591.3200597,7224.3773237,16242.1274993,62.0251391,89.5626881,0.2715328,364.6460941),(15538,'umzc_hippo_humerus-cleaned.tif',250,2,160,1758.9325823,109.4674486,120.2661717,1.8,107.4726785,120.2095943,0.1151262,76.8440618,90.6458476,552043.7501654,1251240.7532257,3.8683572,13803.6191012,7183.9480778,16378.1750578,63.2387895,89.7141701,2.9935133,328.069647),(15539,'umzc_hippo_humerus-cleaned.tif',250,2,161,1771.1742347,109.4630385,120.3148551,1.8,107.4021045,120.3263113,0.1043035,77.7018693,88.810752,549977.8576189,1261163.5994344,3.1998716,14200.5733619,7078.0518229,16339.9541957,0.8774546,1.767564,2.1587989,3.7536507),(15540,'umzc_hippo_humerus-cleaned.tif',250,2,162,1777.5064052,109.4437804,120.3408386,1.8,107.2873154,120.4779519,0.0964728,77.915716,89.9585579,545913.2758532,1269438.197996,2.7486638,14111.3666948,7006.459083,16536.0418906,62.9021338,92.4893801,0.1973956,395.8732601),(15541,'umzc_hippo_humerus-cleaned.tif',250,2,163,1778.8958734,109.4958268,120.3375829,1.8,107.1812101,120.470842,0.0930539,77.01018,90.1300539,543764.4891412,1270356.2404377,2.5598483,14094.7018791,7060.942971,16456.0575267,0.490234,0.6932956,2.3561945,1.3865913),(15542,'umzc_hippo_humerus-cleaned.tif',250,2,164,1788.126708,109.5655054,120.3566664,1.8,107.2266768,120.5598133,0.0882727,80.9039933,88.3793836,542231.5535948,1276983.6543153,2.316173,14448.8861874,6702.1605641,16490.7584409,0.490234,0.6932956,2.3561945,1.3865913),(15543,'umzc_hippo_humerus-cleaned.tif',250,2,165,1793.4096584,109.6421633,120.376579,1.8,107.1376614,120.6413888,0.0837056,79.1398102,89.4111749,539959.3610159,1282726.9026246,2.089406,14346.3823584,6822.8538829,16379.1768355,61.9226434,94.4982556,0.1352941,424.5158741),(15544,'umzc_hippo_humerus-cleaned.tif',250,2,166,1801.7251293,109.7130541,120.3766961,1.8,107.0232199,120.6280607,0.0802225,79.314194,87.9098214,540444.7307002,1291972.0137996,1.9284022,14696.5605503,6813.9724221,16551.7272901,61.8172718,94.7408213,0.1140858,410.2642468),(15545,'umzc_hippo_humerus-cleaned.tif',250,2,167,1810.5021782,109.8043586,120.4190364,1.8,107.0510584,120.647905,0.0777165,79.1367925,89.5626713,539684.2089734,1305076.4786721,1.8188581,14571.6564774,6819.6371335,16683.0768842,61.3370069,96.7265443,0.0557796,400.2709354),(15546,'umzc_hippo_humerus-cleaned.tif',250,2,168,1819.8426176,109.8491022,120.4313216,1.8,106.9375665,120.5725258,0.0756165,89.9399873,89.214072,539523.7526782,1321644.180596,1.7309615,14814.3017318,5998.7083478,15489.4469488,62.5438359,95.4056419,0.1288164,474.7780571),(15547,'umzc_hippo_humerus-cleaned.tif',250,2,169,1827.7125322,110.1092751,120.4710171,1.8,106.9874714,120.6198122,0.0728252,80.8247729,88.6744364,534188.9742533,1328966.5272206,1.6126943,14987.030999,6609.2233231,16724.375648,61.5883861,97.4666167,0.0906599,438.984994),(15548,'umzc_hippo_humerus-cleaned.tif',250,2,170,1829.2443774,110.3133369,120.5002674,1.8,107.1264159,120.7753863,0.0697802,80.6885274,88.4703945,529037.0065555,1326569.5035637,1.4821079,14994.5019567,6556.5331726,16684.5782777,61.4408781,97.072531,0.1011762,437.7870332),(15549,'umzc_hippo_humerus-cleaned.tif',250,2,171,1834.5244876,110.3937102,120.4950444,1.8,106.9818473,120.7318124,0.0697814,80.780175,89.1892155,528408.8004678,1337414.2295899,1.4864368,14995.2460257,6541.3178509,16672.2299918,62.259724,97.6636784,0.1106572,465.3302283),(15550,'umzc_hippo_humerus-cleaned.tif',250,2,172,1844.0214324,110.5153917,120.5612642,1.8,107.0398894,120.7536422,0.06534,79.110686,89.1606499,526502.0283495,1350287.978829,1.310252,15144.4385008,6655.2580339,16868.8978845,62.1020346,98.1754116,0.1807468,495.4783842),(15551,'umzc_hippo_humerus-cleaned.tif',250,2,173,1850.1078842,110.5963684,120.5913174,1.8,107.0324151,120.8010528,0.0615662,81.0964431,88.0962673,524693.10328,1362207.898441,1.1672983,15462.7198142,6469.9891038,16904.4032985,61.3693909,98.8718339,0.129275,499.4903451),(15552,'umzc_hippo_humerus-cleaned.tif',250,2,174,1852.7672385,110.6768702,120.6189222,1.8,106.9285612,120.8466417,0.0610227,81.8517848,88.663891,522101.845567,1372622.2210746,1.1484534,15481.1863795,6378.6250564,17000.4516056,61.2501813,99.2260839,0.2090229,489.8130684),(15553,'umzc_hippo_humerus-cleaned.tif',250,2,175,1863.7763652,110.7026464,120.7006573,1.8,107.0123483,120.9482632,0.0608586,88.1539742,88.8930647,519909.6898705,1385422.866508,1.14908,15585.2750931,5897.74533,16482.6729367,0.490234,0.6932956,2.3561945,1.3865913),(15554,'umzc_hippo_humerus-cleaned.tif',250,2,176,1874.4241966,110.7975175,120.7254972,1.8,107.0052954,120.9506497,0.0621664,81.5476481,88.4987192,520515.8701695,1402503.403357,1.2057797,15847.7254312,6382.9660639,17212.5577886,0.490234,0.6932956,2.3561945,1.3865913),(15555,'umzc_hippo_humerus-cleaned.tif',250,2,177,1880.7845511,110.9555376,120.8367174,1.8,107.0930504,121.0354124,0.0586443,81.1308044,89.2094147,512911.501451,1416488.8634269,1.0768152,15878.244111,6322.0315012,17185.1426128,60.4338077,101.3730046,0.0871573,472.3821354),(15556,'umzc_hippo_humerus-cleaned.tif',250,2,178,1890.2224332,110.9164745,120.8974914,1.8,106.8663581,121.1235688,0.0611294,81.649492,89.6256789,509758.8266053,1433862.9797689,1.1757635,15998.3499928,6243.2577827,17275.0100084,60.7834417,102.2699194,0.0767719,462.9631689),(15557,'umzc_hippo_humerus-cleaned.tif',250,2,179,1901.9143867,110.8715942,120.9262017,1.8,106.6219277,121.0173448,0.0640493,87.0887559,89.6182687,508736.6707736,1457657.3013055,1.2985981,16265.1803279,5841.5884547,16400.1053154,61.5647677,103.2475269,0.0760436,494.6372756),(15558,'umzc_hippo_humerus-cleaned.tif',250,2,180,1913.556745,110.8212445,120.9868884,1.8,106.6853371,121.0994556,0.0652596,78.8398227,89.2553122,504581.566841,1477621.1767871,1.3563179,16554.9942115,6400.0849994,17841.8863576,0.490234,0.6932956,2.3561945,1.3865913),(15559,'umzc_hippo_humerus-cleaned.tif',250,2,181,1925.3290268,110.9497674,121.0610427,1.8,106.8574401,121.1245441,0.0692689,80.5797361,89.6477829,503323.9771564,1488977.6287717,1.5372163,16609.1963617,6246.2847559,17831.4550623,61.0661383,103.7004353,0.0709707,497.4885914),(15560,'umzc_hippo_humerus-cleaned.tif',250,2,182,1935.5222715,111.0184095,121.1011068,1.8,106.7572016,121.1289109,0.0763623,81.1239186,89.0500781,503045.6353269,1508876.5571373,1.877413,16944.1351323,6200.9533534,17928.2628827,59.9164479,103.0436517,3.0987617,473.2929238),(15561,'umzc_hippo_humerus-cleaned.tif',250,2,183,1944.1764611,111.1063518,121.1305808,1.8,106.9888875,121.1722362,0.0824503,91.4835457,89.8809859,500989.4471673,1520562.5286885,2.1977807,16917.5105689,5476.2792955,16930.4114634,59.4915393,103.8150899,3.0564906,500.1716855),(15562,'umzc_hippo_humerus-cleaned.tif',250,2,184,1955.0726329,111.2157759,121.215677,1.8,107.0825797,121.2979873,0.092595,79.3226299,91.5328603,502786.0682649,1532038.5061453,2.7857684,16737.5792786,6338.4946859,18160.0152118,60.7308137,104.438263,0.0187771,514.9687954),(15563,'umzc_hippo_humerus-cleaned.tif',250,2,185,1971.8515592,111.3237798,121.2962445,1.8,107.0431426,121.3448814,0.0994502,78.9994944,91.6086679,496148.9029382,1545236.0766211,3.2396807,16867.7933266,6280.4060518,18086.9023886,60.7498,104.7920429,3.0572859,517.4752142),(15564,'umzc_hippo_humerus-cleaned.tif',250,2,186,1975.49925,111.2794116,121.3475202,1.8,106.9635969,121.2657515,0.1075582,78.3163705,91.9503872,492228.5675214,1557070.7636189,3.7943494,16933.8141011,6285.1299722,18155.9903383,60.2859921,105.3672527,3.0484054,488.5454278),(15565,'umzc_hippo_humerus-cleaned.tif',250,2,187,1979.9531368,111.3380286,121.4182644,1.8,106.827524,121.3005689,0.1161864,77.0343899,93.2048234,489506.6386809,1553231.8404803,4.4346455,16664.7152368,6354.3910659,18061.8276576,59.8811132,105.7690609,3.0580665,500.8853899),(15566,'umzc_hippo_humerus-cleaned.tif',250,2,188,1982.0977492,111.4889507,121.4564463,1.8,106.9104779,121.254364,0.1261084,77.0022338,94.1774561,486364.4522787,1552130.3129276,5.2258681,16480.9114282,6316.2382231,17974.997874,59.8326762,105.0268527,3.0340282,484.5250135),(15567,'umzc_hippo_humerus-cleaned.tif',250,2,189,1988.5919599,111.5901089,121.5232605,1.8,107.0675204,121.2565408,0.1374571,76.2717314,94.2642724,485270.0513597,1558628.6177325,6.2228899,16534.6697996,6362.3841036,18113.1689223,59.5333595,104.7691064,3.0149161,504.9466217),(15568,'umzc_hippo_humerus-cleaned.tif',250,2,190,1999.8195679,111.7572019,121.5969243,1.8,107.2645837,121.2777741,0.1456153,76.1546158,95.0547537,483780.0882207,1568306.8816476,7.0174864,16498.984224,6352.6036267,18158.5969589,59.6928863,104.8344621,3.0526262,490.7442655),(15569,'umzc_hippo_humerus-cleaned.tif',250,2,191,2007.0300332,112.0536067,121.6199308,1.8,107.6237899,121.3245472,0.1516055,76.2580112,94.520002,481228.4329934,1566770.7734581,7.62961,16576.076382,6310.5295477,18065.9157448,59.7244473,104.5394652,3.0335248,500.7664392),(15570,'umzc_hippo_humerus-cleaned.tif',250,2,192,2018.127936,112.2136576,121.6583485,1.8,107.7804247,121.4154324,0.160106,75.7931987,94.9886578,480849.3450821,1574498.2771284,8.548667,16575.6450706,6344.2281557,18103.4979269,58.7394332,105.5142665,3.034527,464.2800805),(15571,'umzc_hippo_humerus-cleaned.tif',250,2,193,2025.7072706,112.6326264,121.789398,1.8,108.2847168,121.5115618,0.1677391,98.9748989,96.1912198,474833.7239967,1561063.9696664,9.4105897,16228.757387,4797.516637,16843.5626233,60.7102804,105.6565266,3.0719381,500.113961),(15572,'umzc_hippo_humerus-cleaned.tif',250,2,194,2023.8982455,112.87625,121.8799984,1.8,108.4980633,121.5641518,0.1781028,73.9880443,97.0758033,469891.7266855,1546834.2995431,10.5872238,15934.2930685,6350.9142725,17632.4666741,60.3025767,105.3672527,3.0484054,482.8019787),(15573,'umzc_hippo_humerus-cleaned.tif',250,2,195,2019.798007,113.1688609,121.9846133,1.8,108.8085325,121.6617469,0.1884861,100.0249518,99.4050436,466452.782919,1529514.0914441,11.8186005,15386.6849831,4663.3642374,16690.3964797,59.3116451,104.6968238,2.9864513,453.7532416),(15574,'umzc_hippo_humerus-cleaned.tif',250,2,196,2015.7377507,113.66212,122.0900961,1.8,109.3442687,121.7119098,0.1983906,100.9533688,97.9476829,461442.2142956,1503265.3289208,13.050271,15347.635429,4570.8451301,16415.8119658,59.6357412,104.5934762,3.028865,448.0879258),(15575,'umzc_hippo_humerus-cleaned.tif',250,2,197,2020.3238187,114.1167433,122.2074771,1.8,109.7533979,121.7436476,0.212138,73.011639,101.0219585,461483.1757998,1487588.302661,14.9273331,14725.3955882,6320.6795828,16937.200786,59.1733571,105.1366321,3.0247563,482.7527077),(15576,'umzc_hippo_humerus-cleaned.tif',250,2,198,2029.1956157,114.4978499,122.3800074,1.8,110.3463182,121.9073575,0.2229806,72.4472554,101.7870624,460683.1957694,1470397.5236325,16.5385334,14445.8194326,6358.8771294,16669.087358,59.6223736,104.4117963,3.0050076,456.4074734),(15577,'umzc_hippo_humerus-cleaned.tif',250,2,199,2039.1377525,114.8814104,122.527268,1.8,110.8494657,122.0327968,0.2346713,102.0648609,103.6885433,461574.3029169,1462831.5917397,18.3750387,14107.9384936,4522.3625315,16386.4639082,0.490234,0.6932956,2.3561945,1.3865913),(15578,'umzc_hippo_humerus-cleaned.tif',250,2,200,2044.6571726,115.4029153,122.6883979,1.8,111.570005,122.1391454,0.2470168,103.1584429,105.0737443,462260.6048451,1442845.320568,20.3737511,13731.7398351,4481.0738882,16251.1224038,59.8221479,102.9549859,3.0030626,486.1290975),(15579,'umzc_hippo_humerus-cleaned.tif',250,2,201,2048.1721725,116.0278435,122.9145854,1.8,112.0536268,122.2161886,0.2608461,72.0117378,105.3915646,458424.5671027,1416784.4463557,22.7044772,13443.0535432,6365.9700676,16018.9429922,60.2153809,102.9689909,2.9451308,488.4180236),(15580,'umzc_hippo_humerus-cleaned.tif',250,2,202,2043.5101458,116.5462217,123.1261365,1.8,112.6907047,122.459367,0.2757188,71.2276532,105.4207472,454585.1762522,1376981.2720313,25.242082,13061.7673282,6382.1445183,15590.4299075,60.3325608,101.526986,2.9423032,463.648011),(15581,'umzc_hippo_humerus-cleaned.tif',250,2,203,2050.0339244,116.9370283,123.2932489,1.8,113.1891057,122.6238031,0.2907848,73.0447383,105.1970469,453010.3422842,1354965.5259875,28.0852165,12880.2620057,6201.8203202,15474.8110281,0.490234,1.0961967,2.0344439,2.3670594),(15582,'umzc_hippo_humerus-cleaned.tif',250,2,204,2062.4569891,117.3225263,123.4660702,1.8,113.886006,122.7643832,0.3039416,106.9415978,108.2954747,453386.546863,1341627.0948877,30.7892399,12388.579475,4239.5714681,15224.3946493,59.2357626,99.8008644,2.9538307,435.6494217),(15583,'umzc_hippo_humerus-cleaned.tif',250,2,205,2069.5218002,117.7482931,123.6762018,1.8,114.485835,122.9651068,0.3201999,109.472761,109.518968,452963.9630688,1320617.1477713,34.1717789,12058.341786,4137.6864806,14770.3874013,0.490234,0.6932956,2.3561945,1.3865913),(15584,'umzc_hippo_humerus-cleaned.tif',250,2,206,2068.2744905,118.3017024,123.9417378,1.8,115.1270224,123.1806016,0.3388689,106.715799,109.7186498,453525.0821592,1284211.4883004,38.0918891,11704.5870536,4249.8401036,14737.9007049,58.256499,97.776809,2.8674252,436.2237666),(15585,'umzc_hippo_humerus-cleaned.tif',250,2,207,2068.8228057,118.857585,124.1572816,1.8,115.9450224,123.4480708,0.3588823,60.8531846,111.1092975,453237.2623497,1247044.2577069,42.5353799,11223.5815166,7448.0450878,14353.9357153,0.490234,0.6932956,2.3561945,1.3865913),(15586,'umzc_hippo_humerus-cleaned.tif',250,2,208,2073.5174589,119.4793732,124.409193,1.8,116.7266331,123.7312546,0.3779489,82.3656006,112.6194844,454347.6680337,1210989.4362455,47.0591625,10752.9300342,5516.2308595,14038.6869692,60.0785214,95.5138986,2.8393202,460.4194343),(15587,'umzc_hippo_humerus-cleaned.tif',250,2,209,2072.1134253,120.1599631,124.6912743,1.8,117.5081575,123.8936687,0.3978829,58.5355021,114.6855433,452186.9058756,1170407.0537719,51.8481047,10205.3582395,7725.0025998,13406.834692,59.2260841,93.643686,2.8330864,466.2037008),(15588,'umzc_hippo_humerus-cleaned.tif',250,2,210,2067.5100244,120.7064723,124.9824997,1.8,118.2707899,124.2641868,0.4163649,55.0146611,114.4119355,451915.3700551,1130276.4217561,56.3639789,9879.0079588,8214.4533992,13287.377474,60.3759565,91.9368574,2.7184956,419.3467698),(15589,'umzc_hippo_humerus-cleaned.tif',250,2,211,2061.2528659,121.2537657,125.2696952,1.8,118.8871305,124.5025674,0.4339825,112.7652377,114.8117919,452457.0655587,1097569.6291491,60.7415727,9559.7291078,4012.3807182,12779.0197443,0.9804681,1.3865913,2.3561945,2.7731826),(15590,'umzc_hippo_humerus-cleaned.tif',250,2,212,2065.3105733,121.7131856,125.5041298,1.8,119.5120825,124.7710118,0.4514372,110.063803,116.05703,453959.8795031,1075203.3338351,65.5123691,9264.4395044,4124.5156641,12451.2623522,60.2498671,88.7012097,2.8443127,424.3884698),(15591,'umzc_hippo_humerus-cleaned.tif',250,2,213,2072.37553,122.1865233,125.7803524,1.8,120.1371162,125.1699497,0.4699505,47.5774518,119.6454845,456110.6749121,1051807.7954247,70.8289601,8791.0362845,9586.6982773,12374.2639317,0.490234,0.6932956,2.3561945,1.3865913),(15592,'umzc_hippo_humerus-cleaned.tif',250,2,214,2074.347178,122.6636018,126.1147411,1.8,120.7160043,125.5666438,0.4874509,112.7492117,120.2289669,457882.0490654,1031492.3201642,75.843429,8579.3993476,4061.0665225,12157.4036737,61.663622,87.2795604,2.7005543,497.5990886),(15593,'umzc_hippo_humerus-cleaned.tif',250,2,215,2079.205328,123.1319031,126.4218123,1.8,121.2161591,125.8645569,0.5070568,79.6070596,122.3205862,459715.3389772,1011068.1804028,81.7175064,8265.7237965,5774.80617,11814.5094655,61.0526645,86.6064734,2.6906026,388.2385545),(15594,'umzc_hippo_humerus-cleaned.tif',250,2,216,2075.4516009,123.5820767,126.7230237,1.8,121.6933211,126.1422793,0.528018,53.65958,122.9246808,460971.9696868,992298.6535361,87.8043578,8072.4118822,8590.6741965,11624.0289126,0.490234,0.6932956,2.3561945,1.3865913),(15595,'umzc_hippo_humerus-cleaned.tif',250,2,217,2079.749128,124.154436,127.128905,1.8,122.4455006,126.5353842,0.5484692,87.8867487,123.6117788,459769.4304396,969469.0571989,94.2260625,7842.8533805,5231.3851309,11367.0313461,60.8839009,84.8501531,2.6676095,502.2142566),(15596,'umzc_hippo_humerus-cleaned.tif',250,2,218,2083.9666908,124.6331714,127.4923469,1.8,123.0103391,127.0875634,0.5660145,37.0068173,122.854597,461434.4279854,944690.7579734,99.887324,7689.502723,12468.9033326,11165.3796329,61.10191,82.0801722,2.7233683,409.2056454),(15597,'umzc_hippo_humerus-cleaned.tif',250,2,219,2084.5538229,125.0619272,127.8266919,1.8,123.3779135,127.3639271,0.5872366,118.0145068,125.0499307,464057.0806421,934837.8411934,106.6546256,7475.7165855,3932.2037027,11073.6804775,0.490234,0.6932956,2.3561945,1.3865913),(15598,'umzc_hippo_humerus-cleaned.tif',250,2,220,2089.0487842,125.4895672,128.1276249,1.8,123.8308513,127.6585457,0.6084693,118.0873239,127.1813406,467084.9995662,921577.1449269,113.762782,7246.1663048,3955.4203136,10875.2552798,0.490234,0.6932956,2.3561945,1.3865913),(15599,'umzc_hippo_humerus-cleaned.tif',250,2,221,2091.9162055,125.8906579,128.4881282,1.8,124.3123155,128.1473422,0.6302895,109.0095855,127.7705532,467780.9145446,907634.8648881,121.1105151,7103.6310154,4291.1906563,10727.8066001,0.490234,1.0961967,2.677945,2.0798869),(15600,'umzc_hippo_humerus-cleaned.tif',250,2,222,2094.5249449,126.2860091,128.8700882,1.8,124.7130114,128.5662131,0.6521773,40.1396359,128.4261068,470756.0787439,893568.4741203,128.5863098,6957.8413323,11727.9608555,10599.8893234,60.6633684,79.9622677,2.6148421,374.2740998),(15601,'umzc_hippo_humerus-cleaned.tif',250,2,223,2101.2937867,126.6791835,129.2152414,1.8,125.1657076,128.9090896,0.6747224,116.9304852,128.2669754,475291.0843875,880916.0478182,136.6631618,6867.8320754,4064.7319939,10568.5522129,1.0399435,2.4511702,2.4980915,4.8530695),(15602,'umzc_hippo_humerus-cleaned.tif',250,2,224,2107.7759809,127.0988085,129.5775528,1.8,125.460613,129.2479213,0.7001511,117.7017667,129.0580185,480426.6641312,874235.2512143,145.8459132,6773.9708198,4081.728572,10460.6422467,1.0399435,2.0798869,2.3561945,4.1597738),(15603,'umzc_hippo_humerus-cleaned.tif',250,2,225,2113.260007,127.6608275,130.0603255,1.8,126.2444138,129.8351031,0.7281468,35.3225329,129.5936055,482503.5792901,855392.61846,155.9845429,6600.5773575,13659.9371426,10321.2392286,0.490234,0.6932956,2.3561945,1.3865913),(15604,'umzc_hippo_humerus-cleaned.tif',250,2,226,2113.3844685,128.0200344,130.4529128,1.8,126.648642,130.2956024,0.7568054,76.3009683,130.1931809,485397.9480279,845001.9504351,166.0496231,6490.3702675,6361.6223856,10196.8904585,61.9850298,78.0935298,2.4629302,497.7180393),(15605,'umzc_hippo_humerus-cleaned.tif',250,2,227,2117.289239,128.3619307,130.8521138,1.8,126.9829369,130.7556283,0.7882457,34.6802468,130.9457613,489244.5215966,835773.0250474,177.4456244,6382.5893756,14107.2964112,10118.5090522,0.490234,0.6932956,2.3561945,1.3865913),(15606,'umzc_hippo_humerus-cleaned.tif',250,2,228,2120.7429185,128.7204683,131.2376853,1.8,127.4172231,131.1679815,0.8192031,37.9303372,132.1874442,492527.8162337,826700.903753,188.6680858,6254.0047466,12985.0629609,9979.2088144,0.490234,0.6932956,2.3561945,1.3865913),(15607,'umzc_hippo_humerus-cleaned.tif',250,2,229,2126.1560109,129.0966984,131.6789313,1.8,127.8795314,131.6863216,0.8542303,114.5630743,132.628457,497793.908412,818128.9674979,201.4940126,6168.5778892,4345.1514512,9910.8024119,0.9804681,1.5502562,2.8198421,4.1597738),(15608,'umzc_hippo_humerus-cleaned.tif',250,2,230,2125.3936569,129.4622431,132.1151592,1.8,128.1894935,132.1802109,0.8879654,78.5848775,130.0555756,501163.495349,811459.8374133,213.1944729,6239.331407,6377.3528856,9967.6164527,0.490234,0.6932956,2.3561945,1.3865913),(15609,'umzc_hippo_humerus-cleaned.tif',250,2,231,2132.376756,129.8609658,132.5647518,1.8,128.7461981,132.7699386,0.9226644,107.764175,130.0818367,507121.3121689,801222.2542868,225.8714478,6159.3707077,4705.8432171,9811.435073,0.490234,0.6932956,2.3561945,1.3865913),(15610,'umzc_hippo_humerus-cleaned.tif',250,2,232,2137.6286093,130.2196049,133.0034982,1.8,129.1126889,133.1775548,0.956219,78.9468898,132.3003282,513366.4162876,796393.886746,237.8172913,6019.591163,6502.6806925,9809.4253337,0.490234,0.6932956,2.3561945,1.3865913),(15611,'umzc_hippo_humerus-cleaned.tif',250,2,233,2143.2228956,130.6909041,133.5284325,1.8,129.5716088,133.7724966,0.9959884,39.6378816,129.9742722,518542.0992356,789129.8675867,251.6211517,6071.4313258,13081.983159,9710.6242503,0.490234,1.0961967,2.0344439,2.3670594),(15612,'umzc_hippo_humerus-cleaned.tif',250,2,234,2146.3701914,131.0295422,133.978815,1.8,129.9322151,134.2763706,1.0324422,107.2175458,130.6923948,524425.4347983,785045.1635227,263.6867644,6006.8159667,4891.2277446,9696.2379038,64.7412937,76.0937366,2.2878081,413.8004047),(15613,'umzc_hippo_humerus-cleaned.tif',250,2,235,2146.6528334,131.3672823,134.4328658,1.8,130.2453912,134.8560636,1.0717503,104.5916616,127.5866006,529454.0082066,780008.6519767,275.8282086,6113.5624605,5062.1053349,9645.1708479,0.490234,0.6932956,2.3561945,1.3865913),(15614,'umzc_hippo_humerus-cleaned.tif',250,2,236,2148.0272264,131.7082793,134.8732631,1.8,130.6366841,135.396497,1.1072638,59.0346021,129.9830337,535015.2359767,777629.5536531,286.4365763,5982.5465807,9062.7397632,9591.7091281,63.5986533,75.453056,2.2780132,493.7553495),(15615,'umzc_hippo_humerus-cleaned.tif',250,2,237,2156.8655957,131.996246,135.3160147,1.8,130.9304273,135.890687,1.1513158,67.4670332,121.6320593,542551.4175743,777017.4501728,299.8467619,6388.2618988,8041.7263399,9889.5458826,0.490234,0.6932956,2.3561945,1.3865913),(15616,'umzc_hippo_humerus-cleaned.tif',250,2,238,2164.151874,132.2981578,135.7356124,1.8,131.3222507,136.315454,1.1925979,72.1274126,115.0106589,550070.0705206,777368.3611517,311.514069,6759.0984071,7626.3663197,9888.5395243,64.4305403,75.510367,2.2688596,498.1241625),(15617,'umzc_hippo_humerus-cleaned.tif',250,2,239,2175.2483203,132.5993422,136.178588,1.8,131.6338746,136.8083871,1.2344403,71.7798011,121.605726,558767.3897902,781429.9954803,323.0487899,6425.9309241,7784.4655664,9931.9689445,64.7108943,75.7724876,2.2829314,395.8936689),(15618,'umzc_hippo_humerus-cleaned.tif',250,2,240,2185.1166105,132.9113911,136.6390248,1.8,131.9618705,137.3866687,1.2815238,91.5351208,115.500978,567489.0039353,783011.2669923,334.5521199,6779.2609228,6199.6859701,10364.6498668,63.7948102,74.4268287,2.2301064,392.1892892),(15619,'umzc_hippo_humerus-cleaned.tif',250,2,241,2200.3339782,133.331583,137.1922711,1.8,132.3391432,138.1367182,1.3366917,84.8446138,80.9914475,576823.1772732,787319.0730079,346.9886142,9721.014957,6798.5833357,11629.9671211,65.6237044,75.135465,1.6295521,420.0893365),(15620,'umzc_hippo_humerus-cleaned.tif',250,2,242,2208.0189848,133.5865217,137.6087124,1.8,132.5609812,138.601738,1.3872802,109.9046237,51.8241772,583862.0528675,789976.3696104,355.7479959,15243.3943526,5312.4430373,12486.4191989,64.7155567,74.3412091,2.290867,428.0316233),(15621,'umzc_hippo_humerus-cleaned.tif',250,2,243,2214.4556621,133.8756382,138.0288119,1.8,132.8206665,139.0943545,1.4403257,53.9455893,41.5256449,590866.366831,794439.6305241,362.8288841,19131.301468,10953.0060668,21183.8166223,0.9315612,3.7335113,2.7367009,7.7944738),(15622,'umzc_hippo_humerus-cleaned.tif',250,2,244,2224.0189524,134.1408578,138.4122495,1.8,133.0866939,139.611774,1.4883155,97.8622462,99.2595976,599209.6021249,803209.3883535,368.1538393,8092.0073008,6122.9904837,10061.1382725,65.6917699,77.7125346,1.2829649,478.7900179),(15623,'umzc_hippo_humerus-cleaned.tif',250,2,245,2239.710643,134.3787965,138.8170146,1.8,133.331339,140.1229095,1.5470972,108.7103691,94.26259,607845.206223,813572.9506629,373.0754939,8630.9208168,5591.4188409,10088.3403835,0.490234,0.6932956,2.3561945,1.3865913),(15624,'umzc_hippo_humerus-cleaned.tif',250,2,246,2256.1909781,134.6235222,139.2044494,1.8,133.6487047,140.5778639,-1.5457558,100.3409965,102.975977,616465.3517341,825919.96639,375.7960951,8020.511095,6143.7037019,10283.2905309,65.2011283,78.3286014,1.0679531,463.943637),(15625,'umzc_hippo_humerus-cleaned.tif',250,2,247,2271.2495099,134.8364943,139.5744229,1.8,133.8455504,141.0028715,-1.4945361,107.3101833,106.6862171,624096.8502679,840084.1347191,376.3443933,7874.3455118,5815.8213055,10384.1544998,0.490234,0.6932956,2.3561945,1.3865913),(15626,'umzc_hippo_humerus-cleaned.tif',250,2,248,2279.547575,135.0204569,139.9241978,1.8,134.0342949,141.3087079,-1.450221,106.1131489,110.9629907,632707.2824177,857340.2599779,374.4278057,7726.3622258,5962.5719232,10632.077168,66.1815964,79.1966997,1.1431442,425.9228741),(15627,'umzc_hippo_humerus-cleaned.tif',250,2,249,2292.3484668,135.3237445,140.4439999,1.8,134.187016,142.0755868,-1.4030992,47.2503419,114.2244822,639562.5278865,875694.901501,371.4140633,7666.437919,13535.6169406,12350.2980854,68.4479374,79.8901023,1.1538181,477.9981803),(15628,'umzc_hippo_humerus-cleaned.tif',250,2,250,2295.8142355,135.54427,140.8798263,1.8,134.4171516,142.5442942,-1.3579968,121.7251082,83.8930788,643622.2734333,889067.3059722,365.5685459,10597.6240102,5287.5062766,10974.1391032,0.490234,1.0961967,2.677945,2.0798869),(15629,'umzc_hippo_humerus-cleaned.tif',250,2,251,2296.0197536,135.7488489,141.2911002,1.8,134.6518624,143.165615,-1.3080881,129.8346951,60.1225971,646875.123972,906352.7805283,356.8617627,15075.0770019,4982.2978622,10855.6901068,0.490234,0.6932956,2.3561945,1.3865913),(15630,'umzc_hippo_humerus-cleaned.tif',250,2,252,2301.4903795,135.9661994,141.7326853,1.8,134.9113693,143.5739051,-1.2597476,130.9632138,117.4137846,650891.2722081,924594.2950898,347.6512399,7874.665639,4970.0313045,11045.0399636,0.490234,0.6932956,2.3561945,1.3865913),(15631,'umzc_hippo_humerus-cleaned.tif',250,2,253,2304.3326026,136.2096438,142.1344011,1.8,135.1573909,144.103913,-1.2078166,124.1720606,69.3318967,652031.4598227,942056.2383205,335.6381189,13587.6311312,5251.0319666,11723.2033458,67.5339266,84.2361334,1.0733075,467.7669674),(15632,'umzc_hippo_humerus-cleaned.tif',250,2,254,2308.1116007,136.4253838,142.6158055,1.8,135.4122909,144.5811902,-1.1609943,127.6866641,48.5341066,653012.6481616,964972.2523359,323.6185357,19882.3532491,5114.180505,12451.2093497,67.4545812,86.6619548,1.0691923,493.4393148),(15633,'umzc_hippo_humerus-cleaned.tif',250,2,255,2319.3090582,136.6095638,143.1115479,1.8,135.5947667,145.186575,-1.120539,131.7874892,64.1464321,655336.9568611,994707.1522731,313.3399558,15506.8196363,4972.6795837,11639.5284728,68.9116147,86.8987385,1.0642458,487.4868265),(15634,'umzc_hippo_humerus-cleaned.tif',250,2,256,2326.97127,136.8200244,143.5245081,1.8,135.6850574,145.5242852,-1.0821753,125.2683085,68.5949983,657604.4074961,1022011.1146169,302.372643,14899.2075275,5249.5672301,12281.7878591,68.0714709,88.3863574,1.0798602,489.5871221),(15635,'umzc_hippo_humerus-cleaned.tif',250,2,257,2331.2470945,137.1291754,144.0247676,1.8,135.7599706,146.0969369,-1.0454021,142.4890248,51.0699523,657870.0581606,1051840.2234196,290.8011109,20596.0682732,4616.9875841,11740.8438938,0.8774546,2.1923933,0.4636476,4.4469463),(15636,'umzc_hippo_humerus-cleaned.tif',250,2,258,2328.9954263,137.3377064,144.5085772,1.8,135.9598652,146.8139374,-1.0174555,145.1763356,122.7989867,653306.4167309,1083050.5995512,280.9605698,8819.703066,4500.0889031,11811.3288704,68.0759831,90.5115977,0.877445,521.1218693),(15637,'umzc_hippo_humerus-cleaned.tif',250,2,259,2328.2098404,137.5317499,144.9601344,1.8,136.2285365,147.3237361,-0.9915012,145.9954643,56.997811,652589.0034512,1117223.1020168,271.7470287,19601.1580506,4469.9265584,11997.8776007,67.9044048,91.6436138,1.0377161,512.2772477),(15638,'umzc_hippo_humerus-cleaned.tif',250,2,260,2339.3308295,137.6654416,145.4046937,1.8,136.4000749,147.8719364,-0.9674793,140.8466065,118.1954517,650789.9136561,1156367.5789622,264.3768615,9783.520116,4620.5579929,12717.7881655,0.490234,0.6932956,2.3561945,1.3865913),(15639,'umzc_hippo_humerus-cleaned.tif',250,2,261,2342.7129199,137.8177928,145.742769,1.8,136.4317531,148.2175935,-0.9492537,147.0664154,75.2370345,657028.1983509,1193805.8992866,258.0648174,15867.2641369,4467.5611124,12538.2578597,0.490234,0.6932956,2.3561945,1.3865913),(15640,'umzc_hippo_humerus-cleaned.tif',250,2,262,2348.2009515,137.92351,146.0991212,1.8,136.4993864,148.5001391,-0.9319758,147.634838,84.0768178,658437.7584966,1235058.3808384,252.2308785,14689.6423269,4459.9077514,12721.1770905,67.9778391,96.1283842,0.9813793,518.2501447),(15641,'umzc_hippo_humerus-cleaned.tif',250,2,263,2356.850116,138.0375882,146.408344,1.8,136.5415888,148.6962857,-0.915625,148.4268731,56.5294298,664646.9869171,1275112.5639876,246.981985,22556.614659,4477.942391,12998.629883,0.490234,0.6932956,2.3561945,1.3865913),(15642,'umzc_hippo_humerus-cleaned.tif',250,2,264,2366.6785698,138.1668819,146.640407,1.8,136.4809916,148.7627326,-0.9023566,148.6430116,57.1546334,672867.6489032,1316041.4832161,242.9374984,23025.9806468,4526.7358468,13311.742378,0.490234,1.5502562,2.8198421,3.060355),(15643,'umzc_hippo_humerus-cleaned.tif',250,2,265,2380.5495101,138.3634436,147.0225657,1.8,136.2347504,149.0258555,-0.8888749,149.2493647,58.8956871,685160.5661987,1362819.896288,239.1419477,23139.553376,4590.7101029,13638.9677521,0.490234,0.6932956,2.3561945,1.3865913),(15644,'umzc_hippo_humerus-cleaned.tif',250,2,266,2380.23446,138.4829851,147.3765023,1.8,136.4815185,149.6536552,-0.8777026,149.2556349,60.8326123,680358.1594247,1406948.1490386,234.7629358,23128.188896,4558.3415317,13976.4170598,0.8786992,2.8585311,2.6011732,5.8335376),(15645,'umzc_hippo_humerus-cleaned.tif',250,2,267,2381.8467791,138.6113146,147.6928951,1.8,136.6427685,149.9972545,-0.8678546,149.8672128,86.9994579,684743.5758418,1447805.4450594,231.0721669,16641.5455997,4569.0018726,14121.207982,0.490234,0.6932956,2.3561945,1.3865913),(15646,'umzc_hippo_humerus-cleaned.tif',250,2,268,2381.4400398,138.7742655,147.9701916,1.8,136.8608545,150.4322293,-0.8550072,147.6601452,110.3305101,677438.7105099,1486868.2101626,225.9924753,13476.4917618,4587.8236785,14624.7605842,0.490234,0.6932956,2.3561945,1.3865913),(15647,'umzc_hippo_humerus-cleaned.tif',250,2,269,2373.3859454,138.8614919,148.2696024,1.8,136.8762343,150.6877534,-0.8433959,149.082769,89.4904104,680187.5663973,1521398.4922045,220.6725778,17000.687398,4562.4827815,14766.0419467,0.490234,0.6932956,2.3561945,1.3865913),(15648,'umzc_hippo_humerus-cleaned.tif',250,2,270,2370.3229834,138.9313821,148.5286835,1.8,136.9572339,150.6645788,-0.8339214,150.4647804,63.24987,684358.7250346,1557671.9679073,216.6661266,24627.2753875,4548.2984327,14844.8870196,0.490234,0.6932956,2.3561945,1.3865913),(15649,'umzc_hippo_humerus-cleaned.tif',250,2,271,2367.5388035,139.0015871,148.7118325,1.8,136.9425905,150.5638546,-0.8237115,150.4452307,84.9794296,689491.2734257,1586253.6475567,212.3981646,18666.324948,4583.0051932,15125.5474473,1.4707021,3.1005124,2.8198421,7.7944738),(15650,'umzc_hippo_humerus-cleaned.tif',250,2,272,2355.3176882,139.0362346,148.8625215,1.8,136.718077,150.1898119,-0.8130524,151.7990309,116.7795437,705864.6604664,1612460.6800456,207.1266824,13807.7323208,4649.9945112,15257.7356306,0.490234,0.6932956,2.3561945,1.3865913),(15651,'umzc_hippo_humerus-cleaned.tif',250,2,273,2351.3044782,139.2349908,149.2115611,1.8,136.9404207,150.4841165,-0.8042945,152.0014127,70.8534569,699356.2005532,1651544.4264779,203.3454403,23309.2991872,4600.9848718,15466.2328853,0.490234,0.6932956,2.3561945,1.3865913),(15652,'umzc_hippo_humerus-cleaned.tif',250,2,274,2335.6771668,139.3691572,149.5017875,1.8,137.3756471,151.0254776,-0.793158,152.2106293,64.2769581,690885.3712004,1677206.3778217,197.660371,26093.4310956,4539.0087052,15523.8063997,0.490234,0.6932956,2.3561945,1.3865913),(15653,'umzc_hippo_humerus-cleaned.tif',250,2,275,2321.3195231,139.4319037,149.6741928,1.8,137.4622964,151.3355974,-0.7850554,152.4310926,119.1955237,689305.6431058,1700951.5864776,193.310686,14270.2639645,4522.0803149,15679.7824206,0.490234,0.6932956,2.3561945,1.3865913),(15654,'umzc_hippo_humerus-cleaned.tif',250,2,276,2308.5303565,139.4272785,149.8413393,1.8,137.4862557,151.4894927,-0.7778324,152.9577258,66.1447364,699819.0319194,1733348.9574152,189.4666865,26205.3951844,4575.2447493,15886.064425,0.490234,0.6932956,2.3561945,1.3865913),(15655,'umzc_hippo_humerus-cleaned.tif',250,2,277,2304.9519971,139.5086824,149.937073,1.8,137.7028746,151.6831327,-0.7706799,153.0849767,118.3877166,705289.0270619,1761512.5114061,186.4259974,14879.1830931,4607.1733645,16109.9911488,0.490234,0.6932956,2.3561945,1.3865913),(15656,'umzc_hippo_humerus-cleaned.tif',250,2,278,2302.1690552,139.547861,149.9089385,1.8,137.6141604,151.3741001,-0.7634042,152.7124069,110.806005,724434.4660512,1789978.7842597,183.4111584,16154.16767,4743.7826469,16465.0097197,0.6932956,1.3865913,2.3561945,2.7731826),(15657,'umzc_hippo_humerus-cleaned.tif',250,2,279,2311.1758736,139.6297065,149.8232085,1.8,137.6612932,151.0055623,-0.7579519,153.2113314,121.2173384,745884.101983,1819029.6426993,182.0310986,15006.3486472,4868.3350975,16733.0180998,0.490234,1.0961967,2.677945,2.0798869),(15658,'umzc_hippo_humerus-cleaned.tif',250,2,280,2324.2544551,139.6079748,149.788857,1.8,137.4546256,150.7441861,-0.7543191,150.9579318,118.5593886,772224.8146413,1861297.5187657,181.6563316,15699.284054,5115.4967837,17445.2621171,0.490234,1.0961967,2.677945,2.0798869),(15659,'umzc_hippo_humerus-cleaned.tif',250,2,281,2341.5942228,139.7934039,149.7905538,1.8,137.7701482,150.8622001,-0.7510829,151.6315676,119.7163733,791569.380243,1899342.4085278,181.751305,15865.3520482,5220.3468744,17738.0697737,0.490234,0.6932956,2.3561945,1.3865913),(15660,'umzc_hippo_humerus-cleaned.tif',250,2,282,2356.2819918,139.8267389,149.7956962,1.8,137.9589879,151.1326219,-0.7505611,152.563267,109.9450267,807755.7714014,1944638.3481906,182.6869272,17687.3698362,5294.5626258,18007.1215245,0.490234,0.6932956,2.3561945,1.3865913),(15661,'umzc_hippo_humerus-cleaned.tif',250,2,283,2366.1962359,139.832655,149.7098529,1.8,138.0715916,151.3159969,-0.751923,152.6232412,89.8082746,823813.5402808,1987591.7582395,183.9913968,22131.4992153,5397.6939154,18413.2345714,0.490234,0.6932956,2.3561945,1.3865913),(15662,'umzc_hippo_humerus-cleaned.tif',250,2,284,2385.9955932,139.8142395,149.4995898,1.8,138.0964873,151.178325,-0.7553378,152.7363432,111.849142,854374.6875362,2036839.7222763,186.8861784,18210.5976416,5593.7877612,18925.9103601,0.6932956,1.3865913,0.7853982,2.7731826),(15663,'umzc_hippo_humerus-cleaned.tif',250,2,285,2405.7931299,139.8508006,149.2489837,1.8,138.1472252,150.9699191,-0.7560082,151.0588157,114.2642993,887600.8961514,2074127.3440089,188.7051961,18152.0156024,5875.8629346,19524.3137315,0.490234,0.6932956,2.3561945,1.3865913),(15664,'umzc_hippo_humerus-cleaned.tif',250,2,286,2430.0615948,139.8239776,148.9764998,1.8,138.0041846,150.5593095,-0.7562364,151.9829797,102.6351028,938741.6617058,2122864.2213206,190.7010026,20683.6078896,6176.6236153,20143.1478498,0.490234,0.6932956,2.3561945,1.3865913),(15665,'umzc_hippo_humerus-cleaned.tif',250,2,287,2459.2623478,139.8193554,148.6714847,1.8,137.9526812,150.0326337,-0.7561724,151.9728426,103.732097,981811.49599,2177667.7349147,192.9663571,20993.191099,6460.4404271,20785.6151398,0.490234,0.6932956,2.3561945,1.3865913),(15666,'umzc_hippo_humerus-cleaned.tif',250,2,288,2489.3502805,139.7835927,148.3456118,1.8,137.7563906,149.5351787,-0.7556227,150.7068513,99.9639157,1027505.0302557,2225655.1906637,195.0995555,22264.5859282,6817.9052328,21497.4883225,0.490234,0.6932956,2.3561945,1.3865913),(15667,'umzc_hippo_humerus-cleaned.tif',250,2,289,2515.6477084,139.9336618,148.0384027,1.8,137.8914926,149.2928992,-0.756139,151.4689134,98.9337876,1089709.6721093,2278791.290129,197.37668,23033.4989146,7194.2793231,22210.0907205,0.490234,1.0961967,2.677945,2.0798869),(15668,'umzc_hippo_humerus-cleaned.tif',250,2,290,2526.8657031,140.0022404,147.7513015,1.8,138.2425273,149.2564669,-0.7581008,151.2881418,105.1138758,1124839.947049,2324325.3364917,199.0817231,22112.4501325,7435.0833679,22754.8598788,0.8774546,1.767564,0.5880026,3.4664782),(15669,'umzc_hippo_humerus-cleaned.tif',250,2,291,2536.6597097,140.0643524,147.2669101,1.8,138.6880811,148.8861093,-0.764212,150.7352045,105.6147647,1169248.8408574,2373813.4631155,202.43398,22476.1515978,7756.9725297,23486.1442426,85.1215507,123.6371823,0.9288813,923.2960163),(15670,'umzc_hippo_humerus-cleaned.tif',250,2,292,2579.7332236,139.946953,146.1800209,1.8,138.7602735,147.5657158,-0.8007128,150.6662625,114.8794329,1280538.9184423,2458025.7080076,221.5613626,21396.5689568,8499.1749116,24812.2938813,0.490234,0.6932956,2.3561945,1.3865913),(15671,'umzc_hippo_humerus-cleaned.tif',250,2,293,2635.3182144,139.8261398,144.9352096,1.8,138.8295083,146.5023303,-0.8423577,149.5537186,105.3383512,1397476.2283919,2551141.2059585,244.5735215,24218.5412645,9344.309465,26374.3033342,0.490234,0.6932956,2.3561945,1.3865913),(15672,'umzc_hippo_humerus-cleaned.tif',250,2,294,2668.2040185,139.8107541,143.9768059,1.8,138.9747163,145.6244885,-0.8663522,148.5253621,121.1092323,1500709.7246949,2617175.4550836,258.1935682,21610.0408354,10104.0637317,27717.3102789,0.490234,0.6932956,2.3561945,1.3865913),(15673,'umzc_hippo_humerus-cleaned.tif',250,2,295,2680.4580515,139.853066,143.3353553,1.8,139.1021066,144.4709875,-0.8671611,148.0379684,117.1010633,1601130.736254,2663939.4720583,259.7359478,22749.0630447,10815.6762308,28702.5110975,0.490234,1.0961967,2.677945,2.0798869),(15674,'umzc_hippo_humerus-cleaned.tif',250,2,296,2667.5877556,139.8558347,142.8504278,1.8,139.2380479,143.6718732,-0.8631827,148.1565496,119.0279053,1676093.8119682,2695616.8939112,256.7425195,22646.932138,11312.991672,29503.0209277,0.490234,0.6932956,2.3561945,1.3865913),(15675,'umzc_hippo_humerus-cleaned.tif',250,2,297,2657.4230591,140.0319901,142.2124792,1.8,139.4194707,142.8345739,-0.8607216,147.8800733,106.0123822,1756178.8488762,2733897.6635294,254.686898,25788.474953,11875.6963676,30361.221351,0.8774546,1.767564,2.5535901,3.4664782),(15676,'umzc_hippo_humerus-cleaned.tif',250,2,298,2631.0922036,140.3148514,141.7186192,1.8,140.245513,142.3002131,-0.8575344,147.4833922,116.5051086,1806249.961928,2748712.109145,250.7808941,23593.0607939,12247.1414216,30866.630359,0.490234,0.6932956,2.3561945,1.3865913),(15677,'umzc_hippo_humerus-cleaned.tif',250,2,299,2611.9427553,140.5698915,141.314555,1.8,140.601467,141.8533741,-0.8447671,147.4457883,109.0626287,1862375.3613466,2774288.9969926,243.4459212,25437.5768404,12630.915968,31442.5896742,0.490234,1.0961967,2.0344439,2.3670594),(15678,'umzc_hippo_humerus-cleaned.tif',250,2,300,2602.6184835,140.6468384,140.929899,1.8,140.9116592,141.171762,-0.8214715,147.3386452,116.108157,1939006.840158,2801204.5651786,232.5188146,24125.8205951,13160.2054448,32146.7665708,0.490234,1.0961967,2.0344439,2.3670594),(15679,'umzc_hippo_humerus-cleaned.tif',250,2,301,2611.1255624,140.5696391,140.5066157,1.8,141.0543371,140.4964582,-0.7945156,147.0978535,114.2770636,2025194.058496,2840654.7799414,221.5613744,24857.6108945,13767.6656084,33078.3030333,0.490234,1.0961967,2.677945,2.0798869),(15680,'umzc_hippo_humerus-cleaned.tif',250,2,302,2634.9482527,140.1851839,140.0190905,1.8,140.7032485,139.9044973,-0.7701412,146.4596884,114.8238555,2117791.465829,2891902.1955967,212.8798268,25185.5520985,14459.8932885,34199.4672564,0.8774546,1.767564,0.5880026,3.4664782),(15681,'umzc_hippo_humerus-cleaned.tif',250,2,303,2700.2026429,139.4704785,139.3261796,1.8,139.7502335,139.0620899,-0.7264837,144.9647194,111.9986995,2262682.8668129,2974161.9626068,198.5647166,26555.3258705,15608.5072049,35971.0340545,0.490234,0.6932956,2.3561945,1.3865913),(15682,'umzc_hippo_humerus-cleaned.tif',250,2,304,2762.4828472,138.6927324,138.7769164,1.8,138.5420942,138.5819476,-0.6559453,142.7665894,114.7097668,2387774.4854519,3090051.617944,171.2686541,26937.9993047,16725.0229561,37877.7608195,0.490234,0.6932956,2.3561945,1.3865913),(15683,'umzc_hippo_humerus-cleaned.tif',250,2,305,2855.1020192,137.5622679,138.5085717,1.8,137.401175,138.6946564,-0.5392782,138.7270917,113.3111699,2496901.0598046,3338466.1741006,125.4814603,29462.8162284,17998.6549781,40689.2356337,0.490234,0.6932956,2.3561945,1.3865913),(15684,'umzc_hippo_humerus-cleaned.tif',250,2,306,2943.0300337,136.0280309,138.1897933,1.8,136.3990228,138.4909649,-0.4393418,134.9241873,117.4979703,2585940.2049009,3600910.6463338,88.7409064,30646.5774415,19165.875715,43481.1390848,0.490234,0.6932956,2.3561945,1.3865913),(15685,'umzc_hippo_humerus-cleaned.tif',250,2,307,3061.9731426,134.3581767,137.8189128,1.8,134.8083659,138.3379448,-0.3489535,128.7472788,114.4792292,2705840.813019,3928463.9398624,59.660298,34315.953808,21016.6835301,47111.0134466,0.490234,0.6932956,2.3561945,1.3865913),(15686,'umzc_hippo_humerus-cleaned.tif',250,2,308,3199.1720385,132.546011,137.1845059,1.8,132.9559914,137.7246159,-0.2569966,121.8132329,112.6516459,2834684.9489246,4274180.1486477,34.4475682,37941.5685769,23270.7471949,51099.8840004,0.6932956,1.3865913,0.7853982,2.7731826),(15687,'umzc_hippo_humerus-cleaned.tif',250,2,309,3308.2407398,131.2239231,136.6212277,1.8,131.7693106,137.3361488,-0.1981636,116.8791943,111.8983283,2936134.437674,4552730.8386213,21.3698506,40686.3168325,25121.104361,54367.7604779,119.4095656,139.3248268,1.067799,1009.5229857),(15688,'umzc_hippo_humerus-cleaned.tif',250,2,310,3385.4664483,130.257367,136.1216033,1.8,130.5858327,136.9560755,-0.1498248,113.5036351,110.1284883,3021791.6678619,4740046.5838061,12.5713674,43041.057386,26622.8624676,56724.3855118,120.2926891,139.5618069,1.0647214,1060.9542673),(15689,'umzc_hippo_humerus-cleaned.tif',250,2,311,3494.9535412,128.7975057,135.5833112,1.8,129.3870706,136.5254296,-0.1074408,109.1038176,107.1864967,3099035.8982705,4991717.2727012,6.6981772,46570.3929641,28404.4680318,59904.8865479,120.4867894,139.9907938,1.0664189,1036.3524765),(15690,'umzc_hippo_humerus-cleaned.tif',250,2,312,3586.5888191,127.9982126,135.1915893,1.8,128.8874424,136.3820612,-0.0808823,106.7410241,104.8996799,3166474.7024919,5186878.1365027,3.9020271,49446.081623,29665.0208314,62127.9516055,0.490234,0.6932956,2.3561945,1.3865913),(15691,'umzc_hippo_humerus-cleaned.tif',250,2,313,3649.7359572,127.9030339,134.8683673,1.8,128.4755462,136.2525904,-0.0628332,104.8205473,104.6404696,3230273.4376893,5329507.2474819,2.3983741,50931.6067394,30817.1777521,63913.219521,121.637489,141.7531055,2.7475996,1135.5310687),(15692,'umzc_hippo_humerus-cleaned.tif',250,2,314,3680.6585612,127.8930704,134.5962597,1.8,128.3097789,136.3171116,-0.0540651,103.7872201,104.7532771,3263648.7445809,5406579.0967688,1.7913686,51612.5055475,31445.5743288,64722.1912572,120.9974666,143.7063227,2.7160945,1118.4485343),(15693,'umzc_hippo_humerus-cleaned.tif',250,2,315,3724.6510075,127.632656,134.476273,1.8,127.9183628,136.1937263,-0.0518081,103.7010146,103.3265996,3309700.416639,5528009.2543349,1.6647113,53500.3501108,31915.7958864,66027.0000132,0.490234,0.6932956,2.3561945,1.3865913),(15694,'umzc_hippo_humerus-cleaned.tif',250,2,316,3794.4013056,127.175516,134.4303612,1.8,127.6220431,136.3231584,-0.0508023,102.9991054,103.8619337,3356102.9320532,5631718.2999055,1.630746,54223.1219877,32583.8066246,67365.6105409,122.5146706,146.6594782,2.7542583,1059.76476),(15695,'umzc_hippo_humerus-cleaned.tif',250,2,317,3822.9395505,127.0777717,134.320204,1.8,127.317179,136.1849215,-0.0546189,103.4579599,103.246418,3394590.2301204,5693410.5443351,1.8988893,55143.9038487,32811.3006661,68231.4024779,122.1893745,148.4397611,2.734099,1149.4955234),(15696,'umzc_hippo_humerus-cleaned.tif',250,2,318,3846.7974891,126.9506367,134.2951046,1.8,127.078372,136.188793,-0.0614763,103.8699675,103.7684467,3446596.984259,5738400.1317454,2.4200021,55300.0484762,33181.8432917,68986.0034598,120.9412748,147.6735985,2.7462908,1042.6005908),(15697,'umzc_hippo_humerus-cleaned.tif',250,2,319,3899.261766,126.8901834,134.3373201,1.8,126.8859753,136.295189,-0.0632997,103.5506936,104.1091337,3501208.7163867,5805130.312548,2.6004874,55760.0482016,33811.5428894,70224.8445377,0.490234,0.6932956,2.3561945,1.3865913),(15698,'umzc_hippo_humerus-cleaned.tif',250,2,320,3966.9393321,126.691583,134.5309544,1.8,126.4953608,136.5066772,-0.0707343,105.0641869,103.6995857,3567837.7681392,5892217.1614712,3.3024733,56820.064615,33958.6482682,71462.2789821,0.490234,0.6932956,2.3561945,1.3865913),(15699,'umzc_hippo_humerus-cleaned.tif',250,2,321,4080.0782671,126.4000432,134.8842468,1.8,126.4169854,136.9474688,-0.0865888,105.9889779,103.9357944,3640882.7415069,5997470.8612448,5.0857483,57703.613047,34351.5223234,72329.3022393,0.6932956,1.3865913,2.3561945,2.7731826),(15700,'umzc_hippo_humerus-cleaned.tif',250,2,322,4121.9274118,126.3967285,135.0365844,1.8,126.4001164,137.0411669,-0.0823093,106.5695283,103.5626614,3649277.5938878,5994972.1980906,4.6437239,57887.3902624,34243.1617239,72586.6773426,122.0682778,151.1805818,2.6373288,1059.9041195),(15701,'umzc_hippo_humerus-cleaned.tif',250,2,323,4152.7322544,126.6067725,134.9743398,1.8,126.4529109,137.1407681,-0.0807661,106.4028818,103.4870979,3663141.3862058,6020370.3418486,4.5050174,58175.0813914,34427.0881125,72635.271428,121.2799892,151.0000448,2.606741,1108.0455981),(15702,'umzc_hippo_humerus-cleaned.tif',250,2,324,4175.4248867,126.8986803,134.9077297,1.8,126.5887792,137.2140985,-0.07791,105.7895481,104.6782478,3673034.0822813,6049365.2854171,4.2155652,57790.0893016,34720.1982319,72819.4332279,121.3114097,151.5901655,2.5939631,1003.6570843),(15703,'umzc_hippo_humerus-cleaned.tif',250,2,325,4201.1200345,126.9323903,135.0070569,1.8,126.6633005,137.316646,-0.0792833,106.46041,104.8336649,3692357.3997271,6065665.4253731,4.392042,57859.9005561,34682.9154712,72943.0849864,0.490234,1.0961967,2.677945,2.0798869),(15704,'umzc_hippo_humerus-cleaned.tif',250,2,326,4229.1843934,127.1886296,135.0985014,1.8,126.7648343,137.3905867,-0.0775186,106.010703,104.524857,3713834.8079019,6080820.052395,4.2271537,58175.8275087,35032.6401368,73189.300163,120.7352823,152.0516042,2.5768417,1124.0610775),(15705,'umzc_hippo_humerus-cleaned.tif',250,2,327,4258.9389965,127.4419372,135.1240777,1.8,126.9117851,137.4288661,-0.0783803,106.3518524,104.1075617,3727132.3822838,6117945.6608747,4.3518612,58765.6224107,35045.2982023,73411.4872341,0.6932956,1.3865913,2.3561945,2.7731826),(15706,'umzc_hippo_humerus-cleaned.tif',250,2,328,4266.6245129,127.4845038,135.3204836,1.8,127.0320093,137.5067668,-0.0717262,106.1973886,104.5775623,3723735.2160471,6131431.7479318,3.6521071,58630.4711542,35064.2823366,73339.3099855,119.7680945,151.3751928,2.5778441,1069.421628),(15707,'umzc_hippo_humerus-cleaned.tif',250,2,329,4272.4632069,127.7787349,135.4232958,1.8,127.1943726,137.6046472,-0.0665778,105.0136411,105.0199816,3690885.7891891,6135590.353373,3.1516913,58423.0758892,35146.7271414,73231.5168632,117.834909,151.0764215,2.5688904,1196.311637),(15708,'umzc_hippo_humerus-cleaned.tif',250,2,330,4249.7429732,127.9558882,135.5442282,1.8,127.4264291,137.8676255,-0.0638537,105.5802961,105.2113996,3627641.0116369,6095682.0706651,2.8839865,57937.4677331,34359.0721369,72182.7411879,0.490234,0.6932956,2.3561945,1.3865913),(15709,'umzc_hippo_humerus-cleaned.tif',250,2,331,4215.7928011,128.0498342,135.7661756,1.8,127.5060487,138.0841796,-0.0646045,105.9313311,104.8313867,3547620.5389303,6025388.3879476,2.9285271,57476.9501475,33489.8136443,70928.0749199,117.0800336,150.4347698,2.6196171,1078.2254321),(15710,'umzc_hippo_humerus-cleaned.tif',250,2,332,4176.5475892,128.1641579,135.8994587,1.8,127.5462466,138.1585155,-0.0663997,105.663264,105.4638487,3451125.9449941,5929931.6290338,3.0645002,56227.1498953,32661.5496761,69452.6278132,0.490234,0.6932956,2.3561945,1.3865913),(15711,'umzc_hippo_humerus-cleaned.tif',250,2,333,4144.3178844,128.292948,135.9986254,1.8,127.6076561,138.1722965,-0.067384,106.2728194,105.5245592,3351129.362149,5840206.5134538,3.1315424,55344.5241203,31533.2686356,67966.880921,115.6157312,148.340967,2.5490071,1005.3019857),(15712,'umzc_hippo_humerus-cleaned.tif',250,2,334,4095.5637112,128.4426057,136.1391781,1.8,127.6861384,138.2714263,-0.0682906,106.5953319,104.037759,3245127.0761312,5763443.6691289,3.1784013,55397.6145142,30443.4257981,66850.8424567,114.2342719,147.5286855,2.5452953,1086.2578073),(15713,'umzc_hippo_humerus-cleaned.tif',250,2,335,4051.3640719,128.6063693,136.1592233,1.8,127.8136248,138.1884993,-0.0657497,105.8088005,104.5101403,3122668.4374616,5689095.0556041,2.9148227,54435.8187767,29512.3697053,64990.5949346,111.7270447,146.7184592,2.5415424,1062.8131599),(15714,'umzc_hippo_humerus-cleaned.tif',250,2,336,3998.7282873,128.6722139,136.2351839,1.8,127.6800321,138.0562667,-0.0609573,106.2899224,104.4732007,3002059.6074881,5603515.6224908,2.473345,53635.9141265,28244.0662325,63345.2404818,0.490234,0.6932956,2.3561945,1.3865913),(15715,'umzc_hippo_humerus-cleaned.tif',250,2,337,3930.6945238,128.9261195,136.3157602,1.8,127.7919102,138.1811368,-0.0557744,105.1818387,105.3756815,2820801.164494,5503372.2087506,2.0358076,52226.2075087,26818.329091,61247.4084867,110.5196575,144.7021107,2.5319769,1068.9746873),(15716,'umzc_hippo_humerus-cleaned.tif',250,2,338,3856.9033413,129.0590841,136.4039071,1.8,127.8542994,138.2998525,-0.0580904,105.9816681,104.0746465,2635410.6957811,5410079.682479,2.1667506,51982.6861284,24866.6655535,59427.7390681,0.490234,0.6932956,2.3561945,1.3865913),(15717,'umzc_hippo_humerus-cleaned.tif',250,2,339,3770.3090094,129.1132724,136.4977342,1.8,127.898851,138.2646942,-0.0566874,106.0203835,105.5084796,2454695.2859962,5305856.2381428,2.0171262,50288.4342296,23153.0504311,57273.2932597,0.490234,0.6932956,2.3561945,1.3865913),(15718,'umzc_hippo_humerus-cleaned.tif',250,2,340,3665.6814502,129.1041112,136.7253487,1.8,128.1328563,138.3343694,-0.0542972,105.5878188,105.5637709,2254628.7423552,5186873.7116935,1.7994194,49134.9794245,21353.114101,54588.3980929,0.490234,0.6932956,2.3561945,1.3865913),(15719,'umzc_hippo_humerus-cleaned.tif',250,2,341,3502.4959524,129.7052685,136.8674878,1.8,128.5170508,138.1278692,-0.0345612,103.9590909,103.8935835,2040072.9060861,4970838.361485,0.6969973,47845.4799218,19623.8047818,52282.1358194,101.027633,139.6487423,2.5409325,1088.8747233),(15720,'umzc_hippo_humerus-cleaned.tif',250,2,342,3238.7997384,130.5392838,137.0183392,1.8,129.2729741,137.9864919,-0.0105924,101.1761013,105.1113434,1792857.1032444,4653978.9102846,0.0605635,44276.6571266,17720.1639454,46861.9605184,98.3178553,138.0354925,2.5329033,988.9416093),(15721,'umzc_hippo_humerus-cleaned.tif',250,2,343,2950.8013404,131.2725793,137.433606,1.8,129.9057767,138.2609358,0.0129459,92.5714928,106.8208707,1545740.3075764,4332229.4464178,0.0824189,40556.0207307,16697.8003809,44107.2270044,58.0263403,87.1197076,1.1902899,506.7717001),(15722,'umzc_hippo_humerus-cleaned.tif',250,2,344,2648.2540547,131.9526979,137.6488689,1.8,130.569096,138.2483747,0.0493323,94.2512847,104.9949022,1284120.20736,3925020.4822868,1.0732954,37382.9623964,13624.4318688,37572.8569055,55.1695994,82.820541,1.043574,470.4331544),(15723,'umzc_hippo_humerus-cleaned.tif',250,2,345,2260.0928355,132.1108899,137.7785816,1.8,130.8252791,138.3808855,0.0987491,84.8254941,112.2608023,986505.4104278,3345201.39402,3.6612457,29798.4810796,11629.8221551,31222.8885382,51.8846425,79.047865,1.1626472,439.997826),(15724,'umzc_hippo_humerus-cleaned.tif',250,2,346,1846.4511628,132.2751675,137.7386131,1.8,130.3670501,138.1697015,0.166809,50.362537,72.6018821,706913.6382526,2721645.7361928,8.483864,37487.2614611,14036.49777,42534.2289353,48.992944,72.6754408,1.1614759,349.6230379),(15725,'umzc_hippo_humerus-cleaned.tif',250,2,347,1413.0087491,133.6742169,138.0421711,1.8,131.7361467,138.001804,0.2852942,48.3225577,64.0790044,418513.950043,2089346.6682704,18.6536853,32605.7916664,8660.8402026,37983.1891874,41.3205902,52.3702144,2.4756234,224.7720984),(15726,'umzc_hippo_humerus-cleaned.tif',250,2,348,995.0573873,130.3853213,140.6641108,1.8,130.8474987,138.5491192,0.3871276,69.741595,67.7831983,181723.1961718,1622304.8751078,23.6374261,23933.7315997,2605.6644691,24181.2303561,1.7332391,2.7731826,2.3561945,6.4078825),(15727,'umzc_hippo_humerus-cleaned.tif',250,2,349,696.98438,126.4803322,143.9400984,1.8,122.7404877,142.2877842,0.4430908,31.1393329,72.2192374,42647.7626382,1279872.6275004,21.352427,17722.0457334,1369.5785558,17529.4006477,33.7573837,44.5708761,2.6238108,188.4046904),(15728,'umzc_hippo_humerus-cleaned.tif',250,2,350,454.6223543,131.396142,147.5111497,1.8,123.7163763,143.5633307,0.4260374,19.6785948,72.8655522,19879.2162816,932935.5107926,12.9407123,12803.5193918,1010.1949086,12732.3196972,0,0,0,0),(15729,'umzc_hippo_humerus-cleaned.tif',250,2,351,255.0740683,142.3105316,153.5545707,1.8,132.1530623,149.2649576,0.4010923,17.3587612,71.7253528,7425.2055479,537544.7039772,6.4802015,7494.4867176,427.7497386,7550.6823955,0,0,0,0),(15730,'umzc_hippo_humerus-cleaned.tif',250,2,352,130.4417065,154.9240078,158.9244453,1.8,143.3099533,154.2775419,0.3886285,67.434357,96.3580784,2643.386615,212031.0959461,3.1214707,2200.4496102,39.1994042,1825.2975389,12.1365781,22.4064312,1.3948567,58.9385829),(15731,'umzc_hippo_humerus-cleaned.tif',250,2,353,40.7272433,174.2975868,166.4682739,1.8,170.5703396,165.4395093,0.3722291,69.8393263,110.9003322,578.1210825,3775.5741181,0.8978487,34.0447503,8.2778731,33.2193979,8.4422191,17.1231391,1.3397057,44.2808324),(15732,'umzc_hippo_humerus-cleaned.tif',250,2,354,2.4815833,175.1079763,165.899043,1.8,175.0943628,165.9738546,-1.3814317,2.0562507,3.8257195,1.8856768,7.9987415,0.3989425,2.090781,0.9170461,2.5451585,4.1917341,8.085147,1.3258177,21.1353126),(15733,'umzc_hippo_humerus-cleaned.tif',250,2,355,0.0148567,53.9257452,182.3670657,1.8,53.9257452,182.3670657,0.7853982,0.0000000000000201,0.0000000000000201,0.0002975,0.0002975,0.0012381,14805179112.9868,14805179112.477,20937685094.5883,0.490234,0.6932956,2.3561945,1.3865913),(15734,'umzc_hippo_humerus-cleaned.tif',250,2,356,0.0292037,145.3525613,196.093619,1.8,145.3543951,196.093619,0.0369697,0.0272473,0.7366811,0.0006064,0.0163548,0.0000066,0.0222007,0.0222572,0.0230082,0.490234,0.6932956,2.3561945,1.3865913),(15735,'umzc_hippo_humerus-cleaned.tif',250,2,357,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15736,'umzc_hippo_humerus-cleaned.tif',250,2,358,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15737,'umzc_hippo_humerus-cleaned.tif',250,2,359,553.469554,119.4132706,175.8451203,1.8,124.517732,176.0694173,0.0700872,20.1158498,37.8691106,29195.9884759,90237.4144441,0.4523855,2382.8765197,1451.3922466,3122.573969,29.7284273,57.7665475,0.1190919,182.7189659),(15738,'umzc_hippo_humerus-cleaned.tif',250,2,360,610.7860819,119.0751385,178.5214881,1.8,122.3741742,181.0730747,0.0332684,32.0965071,93.1749837,69075.2392239,224684.6419637,0.1126261,2411.4266827,2152.1107908,3114.826484,29.6912922,57.6582768,0.1022067,180.4011775),(15739,'umzc_hippo_radius-cleaned.tif',250,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15740,'umzc_hippo_radius-cleaned.tif',250,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15741,'umzc_hippo_radius-cleaned.tif',250,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15742,'umzc_hippo_radius-cleaned.tif',250,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15743,'umzc_hippo_radius-cleaned.tif',250,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15744,'umzc_hippo_radius-cleaned.tif',250,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15745,'umzc_hippo_radius-cleaned.tif',250,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15746,'umzc_hippo_radius-cleaned.tif',250,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15747,'umzc_hippo_radius-cleaned.tif',250,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15748,'umzc_hippo_radius-cleaned.tif',250,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15749,'umzc_hippo_radius-cleaned.tif',250,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15750,'umzc_hippo_radius-cleaned.tif',250,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15751,'umzc_hippo_radius-cleaned.tif',250,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15752,'umzc_hippo_radius-cleaned.tif',250,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15753,'umzc_hippo_radius-cleaned.tif',250,3,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15754,'umzc_hippo_radius-cleaned.tif',250,3,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15755,'umzc_hippo_radius-cleaned.tif',250,3,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15756,'umzc_hippo_radius-cleaned.tif',250,3,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15757,'umzc_hippo_radius-cleaned.tif',250,3,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15758,'umzc_hippo_radius-cleaned.tif',250,3,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15759,'umzc_hippo_radius-cleaned.tif',250,3,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15760,'umzc_hippo_radius-cleaned.tif',250,3,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15761,'umzc_hippo_radius-cleaned.tif',250,3,23,0.0182715,115.7774347,186.1095211,1.8,115.7774347,186.1095211,0.7853982,0,0,0.0004457,0.0004457,0.0015226,0,0,0,0.541016,0.7651122,2.3561945,1.5302245),(15762,'umzc_hippo_radius-cleaned.tif',250,3,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15763,'umzc_hippo_radius-cleaned.tif',250,3,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15764,'umzc_hippo_radius-cleaned.tif',250,3,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15765,'umzc_hippo_radius-cleaned.tif',250,3,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15766,'umzc_hippo_radius-cleaned.tif',250,3,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15767,'umzc_hippo_radius-cleaned.tif',250,3,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15768,'umzc_hippo_radius-cleaned.tif',250,3,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15769,'umzc_hippo_radius-cleaned.tif',250,3,31,0.0180054,97.382889,134.7129964,1.8,97.382889,134.7129964,0.7853982,0,0,0.0004392,0.0004392,0.0015004,0,0,0,0.541016,0.7651122,2.3561945,1.5302245),(15770,'umzc_hippo_radius-cleaned.tif',250,3,32,0.0737955,114.506177,182.8114041,1.8,114.4248945,182.8634248,1.2529662,5.3093953,12.780763,0.9676156,5.6463455,0.0110981,0.4417847,0.1822459,0.5049502,0,0,0,0),(15771,'umzc_hippo_radius-cleaned.tif',250,3,33,0.0381395,97.6458479,157.4016997,1.8,97.653397,157.7061785,1.5459853,0.000751,33.046102,0.0009303,40.8832154,0.0063527,1.237157,1.2386816,1.2371851,0.541016,0.7651122,2.3561945,1.5302245),(15772,'umzc_hippo_radius-cleaned.tif',250,3,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15773,'umzc_hippo_radius-cleaned.tif',250,3,35,0.017828,98.4649211,196.9298421,1.8,98.4649211,196.9298421,0.7853982,0,0,0.0004349,0.0004349,0.0014857,0,0,0,0.541016,0.7651122,2.3561945,1.5302245),(15774,'umzc_hippo_radius-cleaned.tif',250,3,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15775,'umzc_hippo_radius-cleaned.tif',250,3,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15776,'umzc_hippo_radius-cleaned.tif',250,3,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15777,'umzc_hippo_radius-cleaned.tif',250,3,39,0.036809,106.8434997,143.3692532,1.8,106.8506698,143.3692532,0.2941635,0.0805098,0.2657505,0.0011241,0.0033632,0.0005157,0.0126553,0.0139622,0.0161599,0.541016,1.2097487,2.677945,2.2953367),(15778,'umzc_hippo_radius-cleaned.tif',250,3,40,0.2960688,107.9882947,162.664952,1.8,107.9146681,162.4851536,1.1255752,12.1446301,37.6078109,8.2950696,69.8839586,0.040193,1.8582299,0.6830236,2.0639481,0.541016,0.7651122,2.3561945,1.5302245),(15779,'umzc_hippo_radius-cleaned.tif',250,3,41,0.077432,106.2895129,157.5267694,1.8,106.0391458,157.3004165,0.68503,1.0923653,12.5850373,0.0306568,4.7643662,0.0051661,0.3785739,0.0280646,0.3808328,0,0,0,0),(15780,'umzc_hippo_radius-cleaned.tif',250,3,42,0.018981,113.0723544,157.4356705,1.8,113.0723544,157.4356705,0.7853982,0.00000000000001005,0.00000000000001005,0.000463,0.000463,0.0015818,46073794628.6125,46073794623.2313,65158185229.9714,0.541016,0.7651122,2.3561945,1.5302245),(15781,'umzc_hippo_radius-cleaned.tif',250,3,43,0.0191584,113.0723544,157.9766865,1.8,113.0723544,157.9766865,0.7853982,0,0,0.0004673,0.0004673,0.0015965,0,0,0,0.541016,0.7651122,2.3561945,1.5302245),(15782,'umzc_hippo_radius-cleaned.tif',250,3,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15783,'umzc_hippo_radius-cleaned.tif',250,3,45,0.0180941,121.7286112,193.6837458,1.8,121.7286112,193.6837458,0.7853982,0.0000000000000201,0.0000000000000201,0.0004413,0.0004413,0.0015078,21960406784.8305,21960406783.5887,31056705109.4593,0.541016,0.7651122,2.3561945,1.5302245),(15784,'umzc_hippo_radius-cleaned.tif',250,3,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15785,'umzc_hippo_radius-cleaned.tif',250,3,47,0.0372525,109.8417157,178.6512284,1.8,109.8262581,178.5352964,1.4378936,0.0029163,8.3040159,0.000909,2.4973579,0.0060997,0.300741,0.3116792,0.3008504,0,0,0,0),(15786,'umzc_hippo_radius-cleaned.tif',250,3,48,0.0761016,103.6430374,179.4559065,1.8,102.9283035,178.9410585,0.5048072,9.1372544,16.6672327,3.6755582,11.1137915,0.0029668,0.6668048,0.4022607,0.8386134,0,0,0,0),(15787,'umzc_hippo_radius-cleaned.tif',250,3,49,0.0919782,108.9362163,182.7283012,1.8,108.744226,182.5388152,0.7802958,2.4717492,16.4852336,0.1861975,15.3880606,0.0075866,0.9334451,0.0753302,0.9430048,0.541016,0.7651122,2.3561945,1.5302245),(15788,'umzc_hippo_radius-cleaned.tif',250,3,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15789,'umzc_hippo_radius-cleaned.tif',250,3,51,0.0181828,91.4317124,191.5196816,1.8,91.4317124,191.5196816,0.7853982,0.00000000000001005,0.00000000000001005,0.0004435,0.0004435,0.0015152,44136111671.2512,44136111679.5299,62417887721.7508,0.541016,0.7651122,2.3561945,1.5302245),(15790,'umzc_hippo_radius-cleaned.tif',250,3,52,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15791,'umzc_hippo_radius-cleaned.tif',250,3,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15792,'umzc_hippo_radius-cleaned.tif',250,3,54,0.0184489,116.8594668,186.1095211,1.8,116.8594668,186.1095211,0.7853982,0.00000000000001005,0.00000000000001005,0.00045,0.00045,0.0015374,44782006004.9974,44782005991.7514,63331320233.1744,0.541016,0.7651122,2.3561945,1.5302245),(15793,'umzc_hippo_radius-cleaned.tif',250,3,55,0.1549527,112.5589001,179.5296883,1.8,112.3284573,179.2115665,1.4190532,14.3799733,44.803007,10.5914002,71.066504,0.0252354,1.5861994,0.7365382,1.7731505,0,0,0,0),(15794,'umzc_hippo_radius-cleaned.tif',250,3,56,0.2479066,112.7763925,172.6979365,1.8,112.8226547,172.2928035,1.3479977,12.6432625,29.9811566,10.4824409,58.1648968,0.0393005,1.9400485,0.829093,2.1097586,0,0,0,0),(15795,'umzc_hippo_radius-cleaned.tif',250,3,57,0.0760129,112.3110179,189.6636872,1.8,112.5313384,189.6261254,-0.3688094,2.624853,11.4649747,0.1843678,3.2375365,0.0016465,0.282385,0.0702393,0.2981363,0.541016,0.7651122,2.3561945,1.5302245),(15796,'umzc_hippo_radius-cleaned.tif',250,3,58,0.0386717,107.4351161,169.4397743,1.8,107.3916859,168.7970075,1.5032712,0.0012446,20.707468,0.0009433,15.5515301,0.0064159,0.7510107,0.757911,0.7510563,0,0,0,0),(15797,'umzc_hippo_radius-cleaned.tif',250,3,59,0.0201341,113.6133705,187.7325693,1.8,113.6133705,187.7325693,0.7853982,0.0000000000000201,0.0000000000000201,0.0004911,0.0004911,0.0016778,24436334999.8927,24436335001.1345,34558196372.4187,0.541016,0.7651122,2.3561945,1.5302245),(15798,'umzc_hippo_radius-cleaned.tif',250,3,60,0.0367203,115.5056198,178.5352964,1.8,115.5069266,178.5352964,0.2940067,0.078769,0.2601514,0.0011213,0.003357,0.0005139,0.0129039,0.0142354,0.0164754,0.541016,1.2097487,2.677945,2.2953367),(15799,'umzc_hippo_radius-cleaned.tif',250,3,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15800,'umzc_hippo_radius-cleaned.tif',250,3,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15801,'umzc_hippo_radius-cleaned.tif',250,3,63,0.1492762,101.9646488,155.2960372,1.8,101.8462714,154.7305902,1.3697283,22.1979163,42.9459041,15.0821215,70.4159644,0.023887,1.6396433,0.6794386,1.9045411,0,0,0,0),(15802,'umzc_hippo_radius-cleaned.tif',250,3,64,0.5913394,112.1376066,149.3604359,1.8,112.4615298,149.2331691,-1.1708878,42.9668222,56.3833309,132.9821046,443.8192022,0.0836173,7.8714612,3.0949951,8.136701,0,0,0,0),(15803,'umzc_hippo_radius-cleaned.tif',250,3,65,0.3429893,112.9083847,143.8551463,1.8,113.042298,143.6698177,-1.514034,39.4376481,48.413214,91.9595329,250.615809,0.0569809,5.1765993,2.3317702,6.4154493,0.541016,0.7651122,2.3561945,1.5302245),(15804,'umzc_hippo_radius-cleaned.tif',250,3,66,0.0180941,115.2364186,187.1915532,1.8,115.2364186,187.1915532,0.7853982,0,0,0.0004413,0.0004413,0.0015078,0,0,0,0.541016,0.7651122,2.3561945,1.5302245),(15805,'umzc_hippo_radius-cleaned.tif',250,3,67,0.017828,95.7598408,151.4844939,1.8,95.7598408,151.4844939,0.7853982,0.0000000000000201,0.0000000000000201,0.0004349,0.0004349,0.0014857,21637459627.8919,21637459627.064,30599988860.4796,0.541016,0.7651122,2.3561945,1.5302245),(15806,'umzc_hippo_radius-cleaned.tif',250,3,68,0.0214645,118.4825149,181.7813927,1.8,118.4825149,181.7813927,0.7853982,0.0000000000000201,0.0000000000000201,0.0005236,0.0005236,0.0017887,26051070791.6227,26051070794.9342,36841777630.196,0.541016,0.7651122,2.3561945,1.5302245),(15807,'umzc_hippo_radius-cleaned.tif',250,3,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15808,'umzc_hippo_radius-cleaned.tif',250,3,70,0.0183602,100.0879692,124.4336914,1.8,100.0879692,124.4336914,0.7853982,0,0,0.0004478,0.0004478,0.00153,0,0,0,0.541016,0.7651122,2.3561945,1.5302245),(15809,'umzc_hippo_radius-cleaned.tif',250,3,71,0.2754026,107.1964497,154.9395043,1.8,107.2654488,154.8027257,1.4502319,16.1745402,44.5891272,17.0467736,163.6751042,0.0452365,3.6707403,1.0539263,4.0234163,0,0,0,0),(15810,'umzc_hippo_radius-cleaned.tif',250,3,72,0.6493469,108.7562716,150.3156303,1.8,108.9573535,150.3532786,1.3943609,8.0655315,36.8571305,13.5962147,267.9128953,0.1048903,7.268957,1.6857184,7.5553966,0.541016,0.7651122,2.3561945,1.5302245),(15811,'umzc_hippo_radius-cleaned.tif',250,3,73,0.618037,112.0470793,149.8524392,1.8,112.1473915,149.5822117,-1.5425493,21.1902445,53.0429381,35.8760915,349.3054145,0.102924,6.5853331,1.6930476,6.7981619,0,0,0,0),(15812,'umzc_hippo_radius-cleaned.tif',250,3,74,0.1126445,110.2245652,158.462749,1.8,110.1869355,158.6980413,-1.5292722,4.8997503,31.0399847,1.2185233,35.1995446,0.0187417,1.1340065,0.2486909,1.1681779,0,0,0,0),(15813,'umzc_hippo_radius-cleaned.tif',250,3,75,0.0196019,123.8926754,170.4200557,1.8,123.8926754,170.4200557,0.7853982,0.00000000000003015,0.00000000000001005,0.0004781,0.0004781,0.0016335,47580881356.3014,15860293789.1132,30092791639.1139,0.541016,0.7651122,2.3561945,1.5302245),(15814,'umzc_hippo_radius-cleaned.tif',250,3,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15815,'umzc_hippo_radius-cleaned.tif',250,3,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15816,'umzc_hippo_radius-cleaned.tif',250,3,78,0.0185376,112.5313384,178.5352964,1.8,112.5313384,178.5352964,0.7853982,0.00000000000001005,0.00000000000001005,0.0004522,0.0004522,0.0015448,44997304110.727,44997304096.6531,63635797733.665,0.541016,0.7651122,2.3561945,1.5302245),(15817,'umzc_hippo_radius-cleaned.tif',250,3,79,0.0360108,132.9620233,118.1413816,1.8,132.8194402,118.2120069,-0.4598881,0.0004599,32.4596317,0.0008784,37.5708416,0.0011824,1.1574636,1.9099835,1.1574906,0,0,0,0),(15818,'umzc_hippo_radius-cleaned.tif',250,3,80,0.1294969,117.0351117,139.3894502,1.8,117.4004828,139.7367169,-1.116772,27.0815735,48.6120654,45.7468937,144.9198504,0.0174312,2.9811498,1.6892258,3.6427735,0,0,0,0),(15819,'umzc_hippo_radius-cleaned.tif',250,3,81,0.0770772,110.4413604,167.9584015,1.8,110.2320201,167.5797214,1.3964512,4.9290789,30.8107027,0.8693661,66.2986939,0.0124597,2.1518073,0.176375,2.1595478,0,0,0,0),(15820,'umzc_hippo_radius-cleaned.tif',250,3,82,0.0184489,105.4981297,139.5821408,1.8,105.4981297,139.5821408,0.7853982,0.00000000000001005,0.00000000000001005,0.00045,0.00045,0.0015374,44782005989.2678,44782005994.442,63331320223.9544,0.541016,0.7651122,2.3561945,1.5302245),(15821,'umzc_hippo_radius-cleaned.tif',250,3,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15822,'umzc_hippo_radius-cleaned.tif',250,3,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15823,'umzc_hippo_radius-cleaned.tif',250,3,85,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15824,'umzc_hippo_radius-cleaned.tif',250,3,86,0.0181828,120.1055631,188.8146014,1.8,120.1055631,188.8146014,0.7853982,0,0,0.0004435,0.0004435,0.0015152,0,0,0,0.541016,0.7651122,2.3561945,1.5302245),(15825,'umzc_hippo_radius-cleaned.tif',250,3,87,0.0965018,117.7898353,185.1617485,1.8,117.6168892,185.1356922,0.1842769,0.4933657,9.1153263,0.0165975,2.7606355,0.00054,0.3028565,0.0336414,0.3042871,0,0,0,0),(15826,'umzc_hippo_radius-cleaned.tif',250,3,88,0.1867948,105.296212,151.2979898,1.8,105.2817233,151.3762907,-1.3316388,9.9620552,35.9281814,5.3036112,89.6475391,0.0293855,2.4951872,0.5323812,2.6244582,0,0,0,0),(15827,'umzc_hippo_radius-cleaned.tif',250,3,89,0.0180054,120.6465791,199.0939063,1.8,120.6465791,199.0939063,0.7853982,0.00000000000001005,0.00000000000001005,0.0004392,0.0004392,0.0015004,43705515467.2429,43705515459.792,61808932719.0135,0.541016,0.7651122,2.3561945,1.5302245),(15828,'umzc_hippo_radius-cleaned.tif',250,3,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15829,'umzc_hippo_radius-cleaned.tif',250,3,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15830,'umzc_hippo_radius-cleaned.tif',250,3,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15831,'umzc_hippo_radius-cleaned.tif',250,3,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15832,'umzc_hippo_radius-cleaned.tif',250,3,94,0.0186263,113.0723544,144.4512853,1.8,113.0723544,144.4512853,0.7853982,0.0000000000000201,0.0000000000000201,0.0004543,0.0004543,0.0015522,22606301102.8471,22606301100.3635,31970137612.98,0.541016,0.7651122,2.3561945,1.5302245),(15833,'umzc_hippo_radius-cleaned.tif',250,3,95,0.0191584,112.5313384,137.4180766,1.8,112.5313384,137.4180766,0.7853982,0.00000000000001005,0.00000000000003015,0.0004673,0.0004673,0.0015965,15501463612.7133,46504390832.7242,29411959249.1214,0.541016,0.7651122,2.3561945,1.5302245),(15834,'umzc_hippo_radius-cleaned.tif',250,3,96,0.3001489,101.729403,146.9239077,1.8,101.7110174,146.9534845,-0.6018304,18.7083149,31.3083844,16.5238781,44.5949296,0.0160344,1.4243766,0.8832371,1.9121597,0,0,0,0),(15835,'umzc_hippo_radius-cleaned.tif',250,3,97,0.1301177,115.5200187,150.74765,1.8,115.5455706,150.9434779,-1.5551813,9.6962984,31.0090446,2.9888258,59.2306594,0.021681,1.9101091,0.308244,2.0030331,0.541016,0.7651122,2.3561945,1.5302245),(15836,'umzc_hippo_radius-cleaned.tif',250,3,98,0.0180941,112.5313384,186.1095211,1.8,112.5313384,186.1095211,0.7853982,0,0,0.0004413,0.0004413,0.0015078,0,0,0,0.541016,0.7651122,2.3561945,1.5302245),(15837,'umzc_hippo_radius-cleaned.tif',250,3,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15838,'umzc_hippo_radius-cleaned.tif',250,3,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15839,'umzc_hippo_radius-cleaned.tif',250,3,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(15840,'umzc_hippo_radius-cleaned.tif',250,3,102,0.0543709,105.6366934,153.720929,1.8,105.6784684,153.6485581,-1.0554863,0.5020527,25.6946007,0.0082737,21.4355629,0.0068611,0.8342439,0.0164798,0.8345378,0.541016,0.7651122,2.3561945,1.5302245),(15841,'umzc_hippo_radius-cleaned.tif',250,3,103,116.5407815,145.2241892,162.9499555,1.8,145.631419,165.7689689,0.7614858,43.9836893,71.0563662,1122.6399225,9737.5316855,9.2474481,137.0395393,25.5240054,152.8215143,14.0347505,45.4871933,2.039763,147.7847403),(15842,'umzc_hippo_radius-cleaned.tif',250,3,104,147.1674967,144.4437421,163.1557443,1.8,144.0239552,165.7464349,0.7509852,60.4671966,66.8641799,1919.3988172,14131.3923462,11.4205448,211.3447344,31.7428114,229.1186493,15.7211395,49.3601175,2.0246403,162.4306225),(15843,'umzc_hippo_radius-cleaned.tif',250,3,105,195.6078346,147.6924139,165.5685111,1.8,146.3322074,167.5460594,0.5179874,46.0769054,61.251662,3513.3388805,16499.7084062,7.9924136,269.3756852,76.2494541,315.1003506,20.4099841,37.513914,2.1507991,148.8986245),(15844,'umzc_hippo_radius-cleaned.tif',250,3,106,224.7467552,143.7871283,165.7695528,1.8,142.4145552,167.9339654,-0.0904621,35.5046039,47.3665559,11191.6640311,30037.0052369,0.3056962,634.1395247,315.2172617,832.3067599,19.7650436,36.6815265,2.4921919,124.5144534),(15845,'umzc_hippo_radius-cleaned.tif',250,3,107,343.6196331,141.64321,165.8625365,1.8,139.6923167,167.9840144,-0.3438682,38.3069035,50.2744176,19828.9804089,80618.4262916,6.5091624,1603.5675836,517.6346455,1997.8757891,27.9265966,42.1437265,2.0803886,164.255244),(15846,'umzc_hippo_radius-cleaned.tif',250,3,108,432.3901692,137.2137357,167.8615829,1.8,135.6173571,169.6647888,-0.3713931,40.5545092,47.3197357,34788.5248929,144089.8758422,9.491431,3045.0270661,857.8213761,3762.0678179,25.8587734,52.5036495,2.0298357,184.7820019),(15847,'umzc_hippo_radius-cleaned.tif',250,3,109,510.283768,132.058474,169.5850779,1.8,130.3488965,170.3360347,-0.3806763,39.6369704,43.7558287,48333.239338,204410.6794881,11.740627,4671.6217113,1219.3979233,5625.3667033,28.6917088,57.1329343,2.0005586,237.6834958),(15848,'umzc_hippo_radius-cleaned.tif',250,3,110,828.5188248,129.8089703,164.8309287,1.8,127.8458198,166.326615,-0.7025356,41.0116587,49.6810547,129805.8682165,326690.7351383,57.6533423,6575.7608662,3165.0967659,9187.6002165,0.541016,1.2097487,2.677945,2.2953367),(15849,'umzc_hippo_radius-cleaned.tif',250,3,111,1019.2804614,127.3048905,165.3581018,1.8,125.7094613,166.3553184,-0.734341,62.9491309,41.3363239,175673.8350798,406320.2071358,76.2815139,9829.616393,2790.7269335,9220.6647761,0.541016,0.7651122,2.3561945,1.5302245),(15850,'umzc_hippo_radius-cleaned.tif',250,3,112,1201.0942202,125.4316331,165.4473013,1.8,124.0753654,166.0348332,-0.7790764,52.2061985,77.9398632,248365.9008023,479284.5112238,98.8257211,6149.4143261,4757.4025328,9186.2576259,72.6294807,79.8800625,2.9920329,637.4900235),(15851,'umzc_hippo_radius-cleaned.tif',250,3,113,1380.2182585,123.7371752,166.5588217,1.8,122.9560639,167.1317252,-0.8269693,63.937336,56.6175093,386853.5160861,519746.620737,124.5700478,9179.9626498,6050.5103974,12903.7204583,73.4336744,86.3814763,2.1101417,747.7073666),(15852,'umzc_hippo_radius-cleaned.tif',250,3,114,1566.7123529,122.5694297,166.1688882,1.8,121.8994672,166.7697544,-1.2075019,49.6285019,68.8248675,501902.2365539,586926.3497599,228.1452794,8527.8238991,10113.1853069,15715.4050932,73.6270771,91.1254775,2.1275077,743.0304663),(15853,'umzc_hippo_radius-cleaned.tif',250,3,115,1793.8869967,121.5350902,166.2777461,1.8,121.0977379,167.0463159,1.2563012,47.3569354,59.7285455,579915.867386,765897.8307522,270.3719581,12822.978102,12245.6375671,19533.2696728,72.3762001,99.0074153,2.208833,797.5709344),(15854,'umzc_hippo_radius-cleaned.tif',250,3,116,2109.8258792,121.0979545,167.1963325,1.8,120.7050031,167.8013259,1.0275498,50.5553043,59.3719901,622301.1159558,1186765.8081543,257.6786476,19988.6479504,12309.3140263,27212.6259749,72.4547477,106.3533528,2.3490004,508.8781346),(15855,'umzc_hippo_radius-cleaned.tif',250,3,117,2511.3951765,120.9341363,167.6046341,1.8,121.9547979,169.1823965,0.9365765,58.435191,60.2890052,690794.1098309,1673206.1489348,271.6012748,27753.0893762,11821.5427684,32896.9605579,72.9771332,107.9784549,2.398722,485.1821781),(15856,'umzc_hippo_radius-cleaned.tif',250,3,118,2572.81988,120.9703398,168.1923414,1.8,122.1740711,169.4845958,0.9480199,80.9054386,61.3348418,681681.4469668,1840427.7629162,282.9114362,30006.2363989,8425.6566543,29259.0394839,71.4108361,108.754992,2.4513129,495.4455571),(15857,'umzc_hippo_radius-cleaned.tif',250,3,119,2568.9084541,121.2011029,168.8825298,1.8,122.4400176,169.70888,0.9624827,89.8999851,71.6272864,674496.2665359,1944124.3196912,288.3195583,27142.2305141,7502.7405846,27826.3794852,0.541016,0.7651122,2.3561945,1.5302245),(15858,'umzc_hippo_radius-cleaned.tif',250,3,120,2593.1385571,122.3794912,169.5003939,1.8,123.1549882,170.3432221,0.9370415,88.6241624,79.5012876,684350.5824338,2083828.6330643,280.6334469,26211.2563803,7721.9413324,30231.3346375,0.541016,0.7651122,2.3561945,1.5302245),(15859,'umzc_hippo_radius-cleaned.tif',250,3,121,2525.190494,122.5852357,169.2956321,1.8,123.4263899,170.377158,0.9447608,88.7169055,79.1391556,669365.8443077,2051571.3977233,276.3729198,25923.5947441,7544.9638395,29721.3734286,0.541016,1.2097487,2.677945,2.2953367),(15860,'umzc_hippo_radius-cleaned.tif',250,3,122,2447.0886359,122.8280184,169.2528341,1.8,123.7191533,170.4331631,0.9443514,52.5430188,67.5237499,647716.4361103,2000559.5257563,267.6663424,29627.4944537,12327.3548279,34858.1260632,0.541016,0.7651122,2.3561945,1.5302245),(15861,'umzc_hippo_radius-cleaned.tif',250,3,123,2386.1657771,123.2165661,169.4341286,1.8,124.1147158,170.7165654,0.9503233,52.5640109,63.3336511,624516.0838067,1948307.2742014,263.2540114,30762.5920673,11881.0584182,35977.8193995,68.2698784,109.9341418,2.2586034,497.2158037),(15862,'umzc_hippo_radius-cleaned.tif',250,3,124,2325.5245296,123.6107107,169.6878388,1.8,124.6826075,170.8608341,0.9480185,46.8735221,66.9861278,602233.5320017,1901119.6305775,255.7179501,28380.7960511,12848.0537648,35738.8244296,68.0133781,108.9472539,2.1725722,499.0854709),(15863,'umzc_hippo_radius-cleaned.tif',250,3,125,2272.0455224,123.9289887,170.0197205,1.8,124.9880976,170.9647291,0.9461875,44.8052801,61.3760099,582733.0804657,1855267.5303289,249.1799115,30227.894139,13005.9019597,36856.263384,0.541016,0.7651122,2.3561945,1.5302245),(15864,'umzc_hippo_radius-cleaned.tif',250,3,126,2187.2253499,123.5213096,170.1620981,1.8,124.673997,170.972652,0.9599056,63.1446657,74.3924149,543096.1936665,1784005.5469402,244.599645,23981.0140624,8600.8245953,30391.5187676,1.1821858,3.629246,2.0344439,7.8367697),(15865,'umzc_hippo_radius-cleaned.tif',250,3,127,2150.2390087,123.7565151,170.4805023,1.8,124.8407886,171.1477303,0.9565562,63.3830241,65.6237503,533174.1124733,1761576.1509933,239.3340724,26843.5763395,8411.9386882,28994.8291894,0.9683477,1.9506611,2.5535901,3.8255612),(15866,'umzc_hippo_radius-cleaned.tif',250,3,128,2045.9410903,122.7644202,170.4375365,1.8,123.8289801,170.9520428,0.9885258,49.426965,71.3258131,479247.5338628,1684472.9518288,237.8699955,23616.5965672,9696.0744719,28541.4841459,64.1178803,105.6242913,2.0848599,463.9221601),(15867,'umzc_hippo_radius-cleaned.tif',250,3,129,2009.3329509,123.130257,170.7426651,1.8,124.0069164,171.2406727,0.9843752,51.4473993,74.5983722,469684.6522127,1655143.3134696,232.3346555,22187.3918375,9129.4148788,27743.0161765,63.8231559,106.1508785,2.2224522,456.0535383),(15868,'umzc_hippo_radius-cleaned.tif',250,3,130,1980.595914,123.3378252,170.9365652,1.8,124.2071931,171.6596649,0.977597,52.1875859,66.3585826,459228.8154428,1622238.8824344,226.9434143,24446.5571631,8799.579584,27097.8445502,63.167563,107.0350725,2.2810673,453.2331116),(15869,'umzc_hippo_radius-cleaned.tif',250,3,131,1945.5274566,123.6009938,171.3514121,1.8,124.4571722,172.2492542,0.9635881,51.8354932,71.9226735,444378.8011157,1582108.4821642,218.6908984,21997.353608,8572.8672309,27959.5559078,62.5383542,106.5732959,2.2915365,475.6070138),(15870,'umzc_hippo_radius-cleaned.tif',250,3,132,1908.3992898,123.8168266,171.6814907,1.8,124.7546641,172.666092,0.953943,41.5986793,68.4281191,432322.8791243,1526444.2051846,211.6322432,22307.2652653,10392.7068488,28257.629182,62.3924992,104.2351349,2.2974387,464.1303303),(15871,'umzc_hippo_radius-cleaned.tif',250,3,133,1886.5861658,123.987132,171.7538574,1.8,124.9670694,172.827751,0.9480664,56.0139394,61.086922,425299.0631729,1479061.2663306,207.465929,24212.4045267,7592.7361624,26362.8332497,61.9566493,102.8243667,2.1310688,428.9258382),(15872,'umzc_hippo_radius-cleaned.tif',250,3,134,1790.701108,122.6100047,171.2081658,1.8,123.9592291,172.6721204,0.9913195,61.607255,70.9839311,381218.1202476,1352722.1900683,208.9596769,19056.7381709,6187.8770601,22655.8317685,58.0383528,100.4164265,2.2952015,407.0545033),(15873,'umzc_hippo_radius-cleaned.tif',250,3,135,1770.5975199,122.7134255,171.0096492,1.8,124.0669614,172.3848472,0.9912113,86.1075228,63.4672823,375276.6629068,1307682.2330934,206.5845092,20604.037011,4358.233181,18209.6461714,57.8427501,101.1931437,2.1929103,438.0077646),(15874,'umzc_hippo_radius-cleaned.tif',250,3,136,1751.2953931,122.7879684,170.8392273,1.8,124.0471952,172.1989218,0.987185,87.8831873,72.5710205,367878.3868099,1266998.3837557,203.2534995,17458.7373108,4185.9927702,17357.4160605,57.5632053,99.2480635,2.4140449,413.492321),(15875,'umzc_hippo_radius-cleaned.tif',250,3,137,1734.2775553,122.9081658,170.7779121,1.8,124.0770125,172.2005907,0.9821468,87.9187723,75.2259701,357157.7808059,1212795.928821,199.9362872,16122.0377358,4062.3608768,16689.3352607,0.7651122,1.5302245,2.3561945,3.0604489),(15876,'umzc_hippo_radius-cleaned.tif',250,3,138,1710.2401898,123.016577,170.7994431,1.8,124.2562082,172.4564429,0.9724018,57.3401309,62.1360248,343797.8136716,1159637.2268558,194.5895081,18662.8808467,5995.7626259,20415.7310816,57.2980902,98.3667758,2.199997,432.4888544),(15877,'umzc_hippo_radius-cleaned.tif',250,3,139,1686.6402753,123.1662409,170.7009142,1.8,124.3875434,172.4968444,0.9604869,65.9387392,58.1555867,333089.0711411,1102859.5453896,188.7722232,18963.9483929,5051.4928714,19183.0230149,57.1150076,97.1813021,2.3719412,414.1261607),(15878,'umzc_hippo_radius-cleaned.tif',250,3,140,1656.0803485,123.2599626,170.5222214,1.8,124.4326956,172.155074,0.9509747,48.3534824,57.0711528,321859.9892331,1047188.1149341,182.8773158,18348.8165877,6656.3972901,20976.6331062,56.6645366,95.7399709,2.1713375,379.7186329),(15879,'umzc_hippo_radius-cleaned.tif',250,3,141,1636.7385744,123.474568,170.4266724,1.8,124.5567265,171.8381641,0.9414741,42.9695128,58.7567267,313477.5363989,1002578.8406061,178.2827235,17063.2180539,7295.3476972,22084.7885504,56.4273708,94.9063055,2.1983353,400.4085153),(15880,'umzc_hippo_radius-cleaned.tif',250,3,142,1617.7826299,123.5718831,170.3130027,1.8,124.611248,171.6146968,0.9288639,64.4116581,55.8811271,305467.5518852,961691.3077831,172.9693498,17209.5903989,4742.4264656,17384.0210241,0.541016,0.7651122,2.3561945,1.5302245),(15881,'umzc_hippo_radius-cleaned.tif',250,3,143,1610.8114418,123.5761329,170.0881842,1.8,124.5304901,171.2326314,0.9150413,81.1306558,54.8177165,301328.4884662,926445.2319748,168.6507129,16900.4710628,3714.1138015,14270.6162677,56.181157,92.6575873,2.3148957,408.2678079),(15882,'umzc_hippo_radius-cleaned.tif',250,3,144,1617.8068441,123.3952942,168.9721726,1.8,124.3962134,169.6105017,0.9337897,84.6541086,59.6442837,317063.3416547,843636.4078421,174.2439254,14144.4637271,3745.3981484,13281.365723,57.9624923,92.8343185,2.281951,402.9438743),(15883,'umzc_hippo_radius-cleaned.tif',250,3,145,1498.9479802,121.4154561,168.1656454,1.8,122.6483791,169.094856,0.9991279,56.4982996,56.6378068,272591.1054808,710423.4764314,176.6960121,12543.2730689,4824.7665415,13580.8994761,55.3854944,88.0776788,2.2167544,417.3497342),(15884,'umzc_hippo_radius-cleaned.tif',250,3,146,1488.0899352,121.4899476,168.1582333,1.8,122.6648754,169.1921002,0.9815801,78.9564269,60.3985865,266647.4159946,684020.5538431,171.4247042,11325.108632,3377.1464412,11297.5170866,54.7125585,86.8663564,2.2591551,383.8385912),(15885,'umzc_hippo_radius-cleaned.tif',250,3,147,1481.5596573,121.6517591,168.1866516,1.8,122.8153031,169.2100903,0.9644549,44.7722929,56.7961469,259599.3404123,664285.5590259,166.7381932,11695.9617,5798.214116,16136.8106417,0.541016,0.7651122,2.3561945,1.5302245),(15886,'umzc_hippo_radius-cleaned.tif',250,3,148,1468.4436661,121.7215809,168.1832686,1.8,122.9623963,169.1745223,0.9504494,44.7461859,61.1951195,252614.5108366,641625.2322286,162.0354035,10484.9085653,5645.4981794,14416.1292882,53.5396992,84.3846304,2.283595,417.6666541),(15887,'umzc_hippo_radius-cleaned.tif',250,3,149,1461.2725561,121.7818138,168.1428895,1.8,123.0410221,169.0680932,0.9381246,36.6228712,59.9164499,246182.2196539,621901.0441436,158.3928203,10379.4708413,6722.0895383,14350.2241194,53.0271485,82.5062779,2.2772889,375.7392765),(15888,'umzc_hippo_radius-cleaned.tif',250,3,150,1454.4428389,121.8403678,168.1039417,1.8,123.075981,169.0089646,0.9261491,44.1161782,60.332952,239406.1982184,604309.0590588,154.8737706,10016.2355508,5426.7211744,13534.3314783,0.541016,1.2097487,2.0344439,2.6122566),(15889,'umzc_hippo_radius-cleaned.tif',250,3,151,1450.0269075,121.9256703,168.0574198,1.8,123.1228405,168.7660335,0.9104785,67.7859445,55.7351006,233467.6220264,587536.6755047,150.749592,10541.5917354,3444.1892621,10550.8679904,0.541016,0.7651122,2.3561945,1.5302245),(15890,'umzc_hippo_radius-cleaned.tif',250,3,152,1339.4247985,119.8315235,166.5897316,1.8,121.574453,167.2170993,1.0271313,70.5398818,65.6681393,213944.5585745,465662.0643242,163.5048137,7091.1414487,3032.9588466,9072.831861,55.877998,81.6199413,2.2434669,392.6261205),(15891,'umzc_hippo_radius-cleaned.tif',250,3,153,1325.8035035,119.8042166,166.6069975,1.8,121.7303272,167.6004967,1.0148164,64.4561702,54.6235298,204995.7810149,444506.4362788,159.4173943,8137.6366232,3180.3903392,9736.8423488,56.2018779,80.4369155,2.2465877,410.2011791),(15892,'umzc_hippo_radius-cleaned.tif',250,3,154,1261.454566,118.7859642,165.9163061,1.8,120.9259294,166.7479888,1.0739533,60.029544,54.7798024,189276.4555781,382153.3489391,162.4758253,6976.1724615,3153.0550284,8143.8588833,1.0820321,1.9506611,0.5880026,4.142481),(15893,'umzc_hippo_radius-cleaned.tif',250,3,155,1221.5397333,118.2413448,165.9644996,1.8,120.5131303,167.2091268,1.0777947,33.5899208,55.9143623,170883.6192945,359943.2330732,157.9885454,6437.4020957,5087.3480792,9374.8834764,0.541016,0.7651122,2.3561945,1.5302245),(15894,'umzc_hippo_radius-cleaned.tif',250,3,156,1166.9317974,117.2755315,165.3306629,1.8,119.4954933,166.3080769,1.1384136,39.5448046,54.6264132,156199.6900923,312997.2540854,160.3382317,5729.7786087,3949.9421433,8429.6509428,0.541016,0.7651122,2.3561945,1.5302245),(15895,'umzc_hippo_radius-cleaned.tif',250,3,157,1147.6195592,117.0767834,165.2986771,1.8,119.3380393,166.1810306,1.1362366,34.0590315,51.5030169,148988.8682677,299611.5672354,157.3672702,5817.3595458,4374.4305565,8323.5674724,49.4798971,67.7891167,2.070143,327.6591489),(15896,'umzc_hippo_radius-cleaned.tif',250,3,158,1127.16766,116.7780479,165.2358087,1.8,118.9898072,166.2061796,1.1413884,37.8634312,54.2120393,141755.0852208,286068.9686508,155.2987505,5276.8531166,3743.852072,7766.3683849,1.0820321,2.4194973,2.0344439,5.6727055),(15897,'umzc_hippo_radius-cleaned.tif',250,3,159,1101.713457,116.379039,165.0783287,1.8,118.4714014,165.9798462,1.1603687,59.4041804,48.9651941,133923.0470306,267765.3956523,154.386374,5468.4843132,2254.4380909,6703.5829518,49.0854615,65.632628,2.0786955,380.0899277),(15898,'umzc_hippo_radius-cleaned.tif',250,3,160,1077.8672324,115.9293102,164.8129585,1.8,117.8585305,165.4279344,1.1943757,70.2697475,57.6162047,127628.5246626,251658.4229939,155.3700003,4367.8410326,1816.2655942,5339.3346586,0.541016,0.7651122,2.3561945,1.5302245),(15899,'umzc_hippo_radius-cleaned.tif',250,3,161,1063.4323247,115.7701101,164.7655699,1.8,117.6030017,165.268113,1.205036,67.4056883,72.0279659,123913.4589397,239456.7879169,154.5663016,3324.4974361,1838.3234707,5014.8023778,48.1023289,62.4235,2.0383199,323.5166679),(15900,'umzc_hippo_radius-cleaned.tif',250,3,162,1049.8519187,115.5571046,164.6964178,1.8,117.2524368,165.5050306,1.2038147,68.5678775,53.6610663,119264.9333014,229736.2781789,152.4494872,4281.2469834,1739.3703541,4771.2808577,47.704829,62.3296512,2.2021453,330.0088605),(15901,'umzc_hippo_radius-cleaned.tif',250,3,163,1035.7724178,115.3754552,164.5662881,1.8,117.0356864,165.4348238,1.2081649,46.2714159,58.3128887,115816.3428828,220294.5320409,150.9055744,3777.8017352,2502.9781488,5501.2961629,0.541016,1.710843,1.8925469,3.6942887),(15902,'umzc_hippo_radius-cleaned.tif',250,3,164,1025.744483,115.1807391,164.4150413,1.8,116.8306996,165.2164714,1.2131524,46.9944486,54.9501948,113693.9036605,212747.7142992,150.006966,3871.6462272,2419.3049831,5673.3896358,0.541016,1.2097487,2.677945,2.2953367),(15903,'umzc_hippo_radius-cleaned.tif',250,3,165,1019.6408351,115.0201764,164.2458108,1.8,116.518555,165.0019233,1.2156158,35.7284887,56.3251333,112107.4890575,206548.4779882,149.3881324,3667.0748167,3137.7618552,5404.7632103,0.541016,0.7651122,2.3561945,1.5302245),(15904,'umzc_hippo_radius-cleaned.tif',250,3,166,1014.8379211,114.9288738,164.1205003,1.8,116.3844749,164.891852,1.2206024,40.0650732,57.9597758,111399.5040712,200770.6969928,149.2312588,3463.9660738,2780.4642609,5120.6121921,42.9407231,59.2307574,1.8578787,295.8638777),(15905,'umzc_hippo_radius-cleaned.tif',250,3,167,1012.9910831,114.76528,163.9508614,1.8,116.0374978,164.6521933,1.2241684,44.8376593,51.4206949,111483.6107016,195981.8935249,149.3460708,3811.3427693,2486.3833764,5016.4146313,41.202443,59.4748666,2.115896,245.1808228),(15906,'umzc_hippo_radius-cleaned.tif',250,3,168,1007.2997851,114.6914233,163.7866203,1.8,115.9693221,164.3027237,1.2355651,60.5397826,53.6812829,111961.9041431,191880.1699968,149.7128152,3574.4333879,1849.3938909,4221.8904397,1.0820321,1.5302245,2.3561945,3.0604489),(15907,'umzc_hippo_radius-cleaned.tif',250,3,169,1001.2707309,114.6739104,163.7252522,1.8,115.9140027,164.4002779,1.2393097,61.5227969,56.1326477,111231.8170794,186855.488308,149.2031715,3328.8201408,1807.9772478,4287.1761859,1.0820321,1.9506611,2.1587989,4.5906734),(15908,'umzc_hippo_radius-cleaned.tif',250,3,170,993.0141535,114.642361,163.6155271,1.8,115.8724222,164.4316183,1.2369636,38.7267367,52.5544258,110297.215208,180963.4701552,147.7331315,3443.3535787,2848.0895779,5348.3098897,0.541016,1.710843,1.8925469,3.6942887),(15909,'umzc_hippo_radius-cleaned.tif',250,3,171,987.4139468,114.6974968,163.4869438,1.8,115.9354289,164.3886035,1.2367066,31.5077123,52.1046279,110783.9758827,176626.4950046,146.8737883,3389.8427481,3516.0907548,5297.2805575,1.6230481,3.9386563,1.849096,9.683914),(15910,'umzc_hippo_radius-cleaned.tif',250,3,172,986.0913936,114.7840528,163.3210086,1.8,116.0623197,164.1844519,1.2331383,25.3315586,49.8314194,112683.3841458,172790.9193715,146.3120884,3467.509482,4448.3399586,5592.2373121,0.541016,1.2097487,2.0344439,2.6122566),(15911,'umzc_hippo_radius-cleaned.tif',250,3,173,993.8208479,114.9540629,163.1755502,1.8,116.4716429,164.0760326,1.218461,40.6217473,51.3211,117159.9017553,170917.733613,145.9115338,3330.3599054,2884.1669664,5411.1122436,1.0820321,2.7586514,1.7681919,6.3065452),(15912,'umzc_hippo_radius-cleaned.tif',250,3,174,993.5966232,115.0162371,163.0774561,1.8,116.6574016,164.0368531,1.1997711,41.72371,51.7734748,118980.1900538,169046.9860236,143.8300964,3265.1272986,2851.6205808,5361.2451615,45.7594557,61.5237781,2.1685547,314.2809462),(15913,'umzc_hippo_radius-cleaned.tif',250,3,175,996.2628393,115.0515372,162.9241781,1.8,116.5134389,163.8119823,1.1842206,55.639189,52.8063122,121676.4094485,166936.5331603,142.4417843,3161.2988306,2186.8832299,4565.5709971,46.0672118,59.3073036,2.1942271,287.3932683),(15914,'umzc_hippo_radius-cleaned.tif',250,3,176,998.4276541,115.1805747,162.7810405,1.8,116.7303193,163.535713,1.1783091,79.0336544,52.9523151,125143.0671807,166611.1516078,142.0601449,3146.4375292,1583.414916,3478.0919779,0.7651122,1.5302245,0.7853982,3.0604489),(15915,'umzc_hippo_radius-cleaned.tif',250,3,177,997.3135377,115.2904672,162.7786089,1.8,116.8468058,163.7656281,1.1527685,48.2014648,54.4040124,126374.9472249,164472.2565757,138.8256133,3023.1640913,2621.8071974,4658.8645661,47.6470848,67.542555,2.2768162,351.4638551),(15916,'umzc_hippo_radius-cleaned.tif',250,3,178,992.2574839,115.3026328,162.7246562,1.8,116.9410326,163.7791816,1.1191092,58.2980317,52.2738623,126641.0276831,162060.4459804,133.8690376,3100.2194738,2172.3036612,4331.2269159,46.8854492,65.730667,2.1747793,370.0121961),(15917,'umzc_hippo_radius-cleaned.tif',250,3,179,987.1318033,115.3113938,162.6813485,1.8,116.927431,163.8518928,1.0866272,44.3209413,44.3547099,126699.8244982,160227.3348084,128.8757771,3612.4085844,2858.6898357,5239.6245374,48.5303021,66.3158575,2.2926962,345.36548),(15918,'umzc_hippo_radius-cleaned.tif',250,3,180,999.0016977,115.6255089,162.5548864,1.8,116.9987656,163.5251077,0.9429537,46.6603445,49.3349874,133241.6621772,158995.6787071,109.0511945,3222.7773236,2855.5653346,5270.7331796,1.0820321,3.9386563,1.849096,9.8151865),(15919,'umzc_hippo_radius-cleaned.tif',250,3,181,994.4702835,115.5892181,162.4639749,1.8,116.9006453,163.4196146,0.8867496,31.8743734,40.5643223,133086.7764904,157548.1430506,99.5562177,3883.9091654,4175.3535043,6620.8727813,2.4208693,5.5701011,2.0778948,14.9084272),(15920,'umzc_hippo_radius-cleaned.tif',250,3,182,990.351574,115.5380244,162.3855723,1.8,116.8911364,163.384917,0.858191,28.9331471,43.0309754,132681.6852132,156542.0116779,94.5019787,3637.8913113,4585.8020546,6575.2691605,45.1241018,62.4141214,2.3132761,273.2818054),(15921,'umzc_hippo_radius-cleaned.tif',250,3,183,987.1969952,115.448891,162.2987795,1.8,116.6694302,163.3853437,0.8119813,29.7289825,39.4142145,132464.4802854,155406.3078354,86.6381623,3942.9000391,4455.7354137,6528.3569584,1.6230481,2.9134606,1.9513027,7.5198498),(15922,'umzc_hippo_radius-cleaned.tif',250,3,184,986.1130356,115.4115198,162.2013748,1.8,116.6621863,163.2177242,0.7852027,77.8477876,50.8267848,133120.6985708,155728.9363084,82.1439659,3063.9147613,1710.0126115,3626.2912594,45.4453482,56.9199281,2.2009902,290.9337616),(15923,'umzc_hippo_radius-cleaned.tif',250,3,185,982.9535785,115.4412018,162.2077549,1.8,116.8205702,163.1754601,0.7637575,84.9706864,47.1688948,133446.0600432,155612.7459958,78.3686162,3299.0543181,1570.4952586,3391.2216314,0.541016,0.7651122,2.3561945,1.5302245),(15924,'umzc_hippo_radius-cleaned.tif',250,3,186,978.3087215,115.4041076,162.2053245,1.8,116.8151553,163.3648214,0.7201239,51.2450905,45.8133158,132251.2860334,154743.75285,70.9128667,3377.702533,2580.7601236,5266.0153325,1.6230481,2.2953367,2.3561945,5.6727055),(15925,'umzc_hippo_radius-cleaned.tif',250,3,187,972.9821434,115.3437161,162.1419547,1.8,116.7591699,163.3346271,0.6812176,60.5137195,46.7888853,131775.2606721,153856.9491047,64.3095187,3288.3226029,2177.6096676,4691.361576,0.541016,0.7651122,2.3561945,1.5302245),(15926,'umzc_hippo_radius-cleaned.tif',250,3,188,968.5153002,115.272233,162.0175773,1.8,116.6886287,163.1643057,0.6291224,30.9539857,45.8105197,131236.6750855,152760.313982,55.8924068,3334.6121124,4239.7343051,5561.9026179,1.6230481,4.1202555,1.9756881,10.0008339),(15927,'umzc_hippo_radius-cleaned.tif',250,3,189,964.568928,115.1642507,161.862702,1.8,116.540469,163.0318107,0.5976121,32.8686389,45.3590028,131089.4279587,151598.1811036,50.8966937,3342.1850496,3988.282818,5730.1534667,1.0820321,3.4216859,1.8925469,7.3885773),(15928,'umzc_hippo_radius-cleaned.tif',250,3,190,959.8895681,115.0711141,161.7155406,1.8,116.3656031,162.7797823,0.5535152,52.3979751,47.0260534,130900.0422871,150733.0401995,44.209358,3205.3091708,2498.1889463,5372.6194883,0.541016,0.7651122,2.3561945,1.5302245),(15929,'umzc_hippo_radius-cleaned.tif',250,3,191,958.8009962,114.9928362,161.6027345,1.8,116.2073659,162.704329,0.5170001,57.4215116,43.2632296,130930.8993994,150458.0599106,39.0403489,3477.7352809,2280.1715915,4900.1282709,0.541016,0.7651122,2.3561945,1.5302245),(15930,'umzc_hippo_radius-cleaned.tif',250,3,192,957.450415,114.9087489,161.4846189,1.8,116.1465839,162.5977172,0.4949938,63.4600686,47.9360261,131396.9430279,150364.4304866,36.0081002,3136.772957,2070.54524,4359.8036125,0.541016,1.2097487,2.0344439,2.6122566),(15931,'umzc_hippo_radius-cleaned.tif',250,3,193,954.2428844,114.8998819,161.446954,1.8,116.1189631,162.5303988,0.4571807,57.0148257,45.0373116,131566.9681736,149805.126741,30.9893076,3326.2448725,2307.5922206,4896.4695673,45.9863642,58.9806755,2.232644,304.5519866),(15932,'umzc_hippo_radius-cleaned.tif',250,3,194,949.7469488,114.8304012,161.3895455,1.8,116.0794441,162.5406582,0.4024059,44.8183308,38.1867662,130349.8956125,149422.5358032,24.2781479,3912.94028,2908.4058532,5714.6803643,1.6230481,3.629246,2.0344439,8.9188018),(15933,'umzc_hippo_radius-cleaned.tif',250,3,195,945.2586411,114.739833,161.2899708,1.8,115.8949099,162.3887883,0.3619328,36.5886218,37.3702316,129855.3906123,149217.3816315,19.7518765,3992.9477337,3549.0648204,6027.1062282,1.6230481,3.1546386,1.0303768,7.0716575),(15934,'umzc_hippo_radius-cleaned.tif',250,3,196,943.7108876,114.6604244,161.2070576,1.8,115.7989842,162.2432323,0.3325687,39.1553955,37.7284565,129836.6223968,149449.2504293,16.7640808,3961.1811448,3315.9318297,5340.7562847,46.5273803,57.1790237,2.1404283,307.6349583),(15935,'umzc_hippo_radius-cleaned.tif',250,3,197,938.2370734,114.5679695,161.1255504,1.8,115.6943513,162.14662,0.2941033,40.0052909,33.3781514,129227.1407291,149441.7330285,13.1402341,4477.2321673,3230.2512435,6148.9292127,0.541016,0.7651122,2.3561945,1.5302245),(15936,'umzc_hippo_radius-cleaned.tif',250,3,198,935.227602,114.4655905,161.0431986,1.8,115.5455327,162.0609593,0.2566618,37.3213486,31.5070592,129381.2678429,149763.7262557,10.0445673,4753.3387702,3466.6825473,6965.2460257,1.0820321,1.5302245,0.7853982,3.0604489),(15937,'umzc_hippo_radius-cleaned.tif',250,3,199,933.2689178,114.3670354,160.9393029,1.8,115.3854986,161.8834903,0.2208869,56.4514258,34.3306259,129617.0094133,150796.6312684,7.4665665,4392.4812708,2296.0803476,4354.8833009,1.0820321,2.9134606,1.9513027,6.3065452),(15938,'umzc_hippo_radius-cleaned.tif',250,3,200,930.3657048,114.2674202,160.8272998,1.8,115.228329,161.7575968,0.2113947,58.9550572,39.4323795,129430.8038624,151780.2137747,6.8267131,3849.1264165,2195.4147799,4688.628431,47.0683963,51.6464927,1.9688106,272.1453984),(15939,'umzc_hippo_radius-cleaned.tif',250,3,201,930.997135,114.2856101,160.8457733,1.8,115.3747352,161.8151463,0.2002225,67.5427883,49.09194,130610.2593467,153501.7097596,6.1377831,3126.8210154,1933.7410041,3402.5881274,1.0280591,2.4194973,2.677945,4.9075933),(15940,'umzc_hippo_radius-cleaned.tif',250,3,202,927.2444758,114.2113679,160.7875105,1.8,115.1452715,161.6868361,0.1624068,60.7302777,28.8508468,129126.1733153,154389.8976891,4.0404492,5351.3125112,2126.2239898,4621.997565,0.541016,0.7651122,2.3561945,1.5302245),(15941,'umzc_hippo_radius-cleaned.tif',250,3,203,924.4811372,114.1491449,160.7219222,1.8,115.1419915,161.6251662,0.1407019,47.2507195,27.7327875,128944.9059498,155690.8889615,3.030254,5613.9646687,2728.9511611,6016.7238683,47.6094124,55.6615864,2.0561796,338.6107424),(15942,'umzc_hippo_radius-cleaned.tif',250,3,204,925.8646248,114.0839434,160.6321256,1.8,115.0581995,161.5212084,0.1253797,41.2861383,28.1546943,129262.7863952,157271.200151,2.4130923,5585.9672519,3130.9003908,6046.0219067,1.5302245,2.2953367,2.3561945,5.2245131),(15943,'umzc_hippo_radius-cleaned.tif',250,3,205,924.2141608,113.97321,160.5372246,1.8,114.8317057,161.3107373,0.1091245,32.0683403,29.0665275,129355.9461606,158610.3001959,1.8270116,5456.8025065,4033.7586776,6874.8584221,0.541016,0.7651122,2.3561945,1.5302245),(15944,'umzc_hippo_radius-cleaned.tif',250,3,206,918.9867453,113.9139486,160.423064,1.8,114.7813354,161.1626211,0.1057883,42.3477503,29.9746068,129438.8462587,160151.4298624,1.7077039,5342.9034356,3056.5696031,5962.5826032,49.0381431,54.9391077,2.1314833,286.2118157),(15945,'umzc_hippo_radius-cleaned.tif',250,3,207,917.1380447,113.8161281,160.2975068,1.8,114.5307493,160.9911206,0.0964011,49.5722934,32.007639,130068.5040519,162095.0503341,1.4161238,5064.2613887,2623.8145348,5148.7057984,0.541016,0.7651122,2.3561945,1.5302245),(15946,'umzc_hippo_radius-cleaned.tif',250,3,208,918.4512847,113.743256,160.2138268,1.8,114.4549704,160.9039261,0.0881943,52.8306583,30.7438386,131332.4227927,164958.7221911,1.1875718,5365.5863999,2485.9130456,5379.6026372,0.541016,0.7651122,2.3561945,1.5302245),(15947,'umzc_hippo_radius-cleaned.tif',250,3,209,919.5928971,113.7121124,160.2068811,1.8,114.5748264,160.981375,0.082443,56.8133353,49.4924065,132868.5151165,167395.2091858,1.0393641,3382.2402493,2338.6853517,3985.0495768,0.541016,0.7651122,2.3561945,1.5302245),(15948,'umzc_hippo_radius-cleaned.tif',250,3,210,918.7902827,113.6492162,160.1020316,1.8,114.4404057,160.7530159,0.0762146,44.8271081,28.7029361,132736.1998602,169431.2308418,0.8877692,5902.9233134,2961.0698858,5912.2670903,49.5369709,53.4484429,2.1251038,286.6600081),(15949,'umzc_hippo_radius-cleaned.tif',250,3,211,924.0389852,113.6026541,160.014763,1.8,114.3468844,160.6803346,0.0696637,51.2224545,28.51036,134111.5057184,173012.0052727,0.7461896,6068.3907644,2618.2170886,5325.4651341,1.6922465,7.5354816,1.2036225,17.5206838),(15950,'umzc_hippo_radius-cleaned.tif',250,3,212,927.4049277,113.5514938,159.913753,1.8,114.350527,160.6376627,0.07392,35.0873766,30.0135054,134995.4373017,176362.6785312,0.8430449,5876.1106457,3847.4075413,6743.3121148,1.6230481,3.2908722,1.735945,8.9188018),(15951,'umzc_hippo_radius-cleaned.tif',250,3,213,929.5928924,113.4662648,159.7740124,1.8,114.1769323,160.382782,0.0729527,45.5362233,27.8601462,136329.9432826,179725.4493555,0.8231018,6450.9873022,2993.8790149,6339.7774653,1.5932282,3.9386563,1.2924967,9.8151865),(15952,'umzc_hippo_radius-cleaned.tif',250,3,214,932.6182404,113.4358921,159.6805228,1.8,114.0900499,160.3222388,0.0749057,43.9153125,28.0376004,137684.9212483,182883.5563313,0.8705028,6522.7963086,3135.2371977,6964.7759992,0.7651122,1.5302245,2.3561945,3.0604489),(15953,'umzc_hippo_radius-cleaned.tif',250,3,215,931.5899822,113.3305317,159.5484765,1.8,113.9563901,160.1549836,0.0800587,57.6810329,28.3021834,139305.0994542,184959.6933285,0.9930308,6535.1740042,2415.0937065,5185.9511698,49.7734766,53.6479546,2.7592136,288.5071524),(15954,'umzc_hippo_radius-cleaned.tif',250,3,216,934.6067267,113.2569321,159.4665322,1.8,113.8588322,160.0010584,0.0754308,53.4275648,36.9749324,141775.8346489,187918.3168428,0.8846077,5082.3167141,2653.6083959,5519.8323517,1.4525216,1.9506611,0.5880026,5.3557856),(15955,'umzc_hippo_radius-cleaned.tif',250,3,217,937.31055,113.3132769,159.4461251,1.8,113.9723254,159.8949077,0.0775978,65.3446056,46.7718551,144369.8803747,191337.5797945,0.9387699,4090.8700235,2209.3618745,4177.6108354,0.541016,1.2097487,2.677945,2.2953367),(15956,'umzc_hippo_radius-cleaned.tif',250,3,218,936.2009571,113.3182401,159.3630918,1.8,113.9844224,160.0061249,0.0854625,46.9694707,30.1327611,143815.0819178,193972.146546,1.1368714,6437.2510027,3061.8842373,6266.2027198,0.541016,1.2097487,2.0344439,2.6122566),(15957,'umzc_hippo_radius-cleaned.tif',250,3,219,934.8873623,113.2659294,159.23382,1.8,113.856064,159.9182348,0.0867335,47.2598857,29.3889097,144899.6396035,196640.4535324,1.1692111,6690.9747756,3066.0175644,6138.3468547,0.541016,0.7651122,2.3561945,1.5302245),(15958,'umzc_hippo_radius-cleaned.tif',250,3,220,954.3393862,113.7467239,159.1792208,1.8,114.5935615,159.8632551,0.086463,45.8997972,41.8378767,147855.6887521,211647.6891349,1.1861239,5058.7579016,3221.2710674,5804.3911561,50.7260009,58.0099398,0.3423966,336.7410753),(15959,'umzc_hippo_radius-cleaned.tif',250,3,221,956.5277943,113.6960448,159.0159667,1.8,114.4997569,159.7278498,0.0837943,50.8624651,30.2689055,149826.7576422,214707.5077602,1.1167568,7093.3357,2945.7234792,6993.8475991,0.541016,0.7651122,2.3561945,1.5302245),(15960,'umzc_hippo_radius-cleaned.tif',250,3,222,957.250848,113.6917721,158.8977017,1.8,114.3816071,159.516934,0.083515,44.5940371,31.6953046,151654.875431,218357.9599958,1.1101809,6889.2841659,3400.7882096,7539.9225486,0.541016,0.7651122,2.3561945,1.5302245),(15961,'umzc_hippo_radius-cleaned.tif',250,3,223,962.2538613,113.7642153,158.7830013,1.8,114.3823763,159.437246,0.0878309,50.5139623,37.7648568,154208.9937364,223113.3135904,1.2340036,5907.9613267,3052.799396,6366.2636066,0.541016,1.2097487,2.677945,2.2953367),(15962,'umzc_hippo_radius-cleaned.tif',250,3,224,964.1550702,113.7263314,158.6373669,1.8,114.3276336,159.0838059,0.0772556,60.6105738,61.5932413,157407.0855567,226920.0568584,0.9571744,3684.1713803,2597.023518,4540.2605453,50.5674,59.3960723,0.3534402,309.2964553),(15963,'umzc_hippo_radius-cleaned.tif',250,3,225,966.7341863,113.8246114,158.5772669,1.8,114.5332229,159.0375904,0.0771333,64.2325957,60.3864788,160809.0501172,230663.0437422,0.9567062,3819.7796662,2503.5427644,4658.2061114,1.0820321,2.7586514,1.7681919,7.6511224),(15964,'umzc_hippo_radius-cleaned.tif',250,3,226,966.366362,113.8432298,158.4895343,1.8,114.4289976,159.1596096,0.0855977,54.5211144,37.6411039,161761.5357492,233023.455675,1.1772107,6190.6647672,2966.9521175,6430.8875053,51.7417527,59.5854947,0.3619588,303.4699545),(15965,'umzc_hippo_radius-cleaned.tif',250,3,227,964.9195452,113.8572991,158.3824115,1.8,114.4074377,159.0064936,0.0872183,44.9811957,35.478916,163003.4912921,235501.2468258,1.2202634,6637.78021,3623.8141045,7237.2461879,51.9375408,60.0113381,0.44752,302.2791727),(15966,'umzc_hippo_radius-cleaned.tif',250,3,228,964.1902827,113.8827061,158.2414613,1.8,114.4411221,158.8960081,0.0939123,47.7783099,42.6681064,165535.7514517,238160.0189238,1.4131216,5581.6870938,3464.6631896,6415.270238,51.8669046,60.0430327,0.4273732,287.4251203),(15967,'umzc_hippo_radius-cleaned.tif',250,3,229,965.6353257,113.9314399,158.0978961,1.8,114.3708361,158.7679612,0.1056265,46.0683922,42.6356496,168045.313192,240853.5153414,1.7889255,5649.1109542,3647.7355736,6522.9166645,53.0195729,60.4995295,0.4836449,320.7731388),(15968,'umzc_hippo_radius-cleaned.tif',250,3,230,965.3239124,113.9855383,157.9878946,1.8,114.3646504,158.6593819,0.1080142,49.6747719,42.1654636,170809.1909423,243788.0299167,1.8697947,5781.6992693,3438.5500786,6642.0119022,52.7535013,60.2182701,0.5481235,311.9630867),(15969,'umzc_hippo_radius-cleaned.tif',250,3,231,969.5742474,114.0369965,157.8587,1.8,114.2897119,158.4968613,0.1104683,54.6236567,42.7791038,174403.8679689,247969.2700369,1.9639823,5796.5045586,3192.8266682,6418.4765195,51.2749726,60.7409492,0.3358341,297.8741466),(15970,'umzc_hippo_radius-cleaned.tif',250,3,232,970.5907977,114.1043819,157.6501869,1.8,114.40968,158.1157707,0.1028232,62.3207278,47.6714836,179505.263583,251585.343715,1.7042623,5277.4808935,2880.3460731,6334.5111196,51.9574828,61.9693679,0.4324078,303.5787042),(15971,'umzc_hippo_radius-cleaned.tif',250,3,233,969.7402872,114.1799457,157.5981175,1.8,114.5218343,158.1213268,0.117061,66.2775071,43.8902958,182633.8339447,254469.1144509,2.2046724,5797.8446047,2755.5929902,5863.4561491,53.5605889,61.2209325,0.4478386,302.0166276),(15972,'umzc_hippo_radius-cleaned.tif',250,3,234,967.1160247,114.1989698,157.5466527,1.8,114.423565,158.2927054,0.1419188,70.3419029,49.0588687,183773.0578293,256492.6834658,3.2246999,5228.2633195,2612.568758,5175.6088424,52.9986437,62.2168457,2.4980915,320.488071),(15973,'umzc_hippo_radius-cleaned.tif',250,3,235,967.5568461,114.2239975,157.4282728,1.8,114.6131373,158.2583234,0.1675925,44.9195575,45.9367693,186743.1091677,259779.2790922,4.4870857,5655.149086,4157.2784687,6950.4648533,54.2124302,62.1132608,2.485897,362.8317889),(15974,'umzc_hippo_radius-cleaned.tif',250,3,236,998.6670459,115.1540025,157.4423776,1.8,115.227322,158.0687646,0.1785955,46.3579623,38.8331626,191252.9299528,286532.2661065,5.252766,7378.5457288,4125.5680888,8129.90746,53.596688,62.6504995,0.2889754,305.9734613),(15975,'umzc_hippo_radius-cleaned.tif',250,3,237,996.3027527,115.2214899,157.2944606,1.8,115.3372019,157.763559,0.1932581,45.241972,33.0402158,194370.2371494,288758.6125982,6.1249429,8739.610373,4296.237064,9016.054354,53.9668864,63.814672,0.3190696,291.7757715),(15976,'umzc_hippo_radius-cleaned.tif',250,3,238,991.902964,115.2653869,157.2286578,1.8,115.3590946,157.7250617,0.206802,62.3748745,34.8201315,198626.1890109,290027.8644911,6.969915,8329.3155967,3184.3942067,7829.8797441,0.541016,0.7651122,2.3561945,1.5302245),(15977,'umzc_hippo_radius-cleaned.tif',250,3,239,991.7476565,115.3151213,157.0355677,1.8,115.247628,157.3630669,0.2182637,65.1341719,40.0464909,202836.4064174,293360.7912963,7.7500643,7325.5055402,3114.1319579,7466.7219087,52.9237344,63.3243051,0.2947301,321.7013756),(15978,'umzc_hippo_radius-cleaned.tif',250,3,240,991.2743721,115.3789733,156.8682661,1.8,115.38342,157.017526,0.2266311,68.6323077,53.9705838,209246.4483978,296624.2755935,8.3412946,5496.0360773,3048.8039156,6759.9624708,53.6219825,63.5388744,2.4708411,319.351664),(15979,'umzc_hippo_radius-cleaned.tif',250,3,241,988.6573826,115.4755779,156.747852,1.8,115.5050462,156.7286812,0.2522079,62.7247089,38.9445607,215081.862975,298559.2521716,10.2608614,7666.2631894,3428.9814432,8051.0915501,55.7246531,64.8790814,0.2874632,331.3309148),(15980,'umzc_hippo_radius-cleaned.tif',250,3,242,982.9322026,115.5453617,156.702927,1.8,115.4548454,156.9613036,0.2783679,61.9325487,39.6648056,215676.5062819,300410.5757979,12.3698352,7573.7311999,3482.4419594,7942.5693386,0.541016,0.7651122,2.3561945,1.5302245),(15981,'umzc_hippo_radius-cleaned.tif',250,3,243,979.1958636,115.5764809,156.5481286,1.8,115.5963455,156.9204548,0.2916143,55.073719,43.7236929,218846.0366446,301562.201849,13.4893257,6896.997522,3973.6927304,8508.338918,56.2676613,65.4450548,2.3854259,315.0779105),(15982,'umzc_hippo_radius-cleaned.tif',250,3,244,976.8453183,115.6104786,156.3954523,1.8,115.6653246,156.7172075,0.313811,45.5989835,40.5855778,222446.2323485,304020.7503998,15.513427,7490.8567834,4878.3155971,9807.6622244,55.03248,66.2098439,2.3850882,303.5693749),(15983,'umzc_hippo_radius-cleaned.tif',250,3,245,1010.4653622,116.6152218,156.3760167,1.8,116.4567863,156.5690283,0.2936838,43.6097548,38.8787654,230007.8123161,334305.3745972,14.1126355,8598.6622994,5274.2285157,9658.9200595,56.2513368,66.4415289,0.171842,309.66775),(15984,'umzc_hippo_radius-cleaned.tif',250,3,246,1010.3759562,116.6632217,156.1029844,1.8,116.5897697,156.3242706,0.3121342,56.7259972,39.2000101,236367.7348799,337810.3682971,15.8805049,8617.6092168,4166.8326066,9537.3280744,55.1636349,67.0685358,0.1784105,309.4277278),(15985,'umzc_hippo_radius-cleaned.tif',250,3,247,1014.0673261,116.6892292,155.9222496,1.8,116.6305797,156.0271218,0.3280228,66.6067064,39.0777177,244687.9877854,341592.6570919,17.5424752,8741.3666296,3673.6238907,8347.2477864,56.5575928,67.6010325,0.2178009,316.4450104),(15986,'umzc_hippo_radius-cleaned.tif',250,3,248,1020.6769874,116.8356258,155.7168625,1.8,116.805231,155.572587,0.3386253,67.0509888,44.0940143,254531.8922926,349151.6610876,18.7720762,7918.3459782,3796.094538,7522.5045453,56.4252981,67.6810862,2.1743187,335.4733958),(15987,'umzc_hippo_radius-cleaned.tif',250,3,249,1030.6100169,117.0824198,155.5450094,1.8,117.1275689,155.5732821,0.3587908,73.3774599,50.2244994,264307.2133646,356457.8022007,21.1791934,7097.2893048,3602.0218455,7764.4275298,57.9419926,69.4694945,2.223643,375.0285391),(15988,'umzc_hippo_radius-cleaned.tif',250,3,250,1016.0088032,116.8084287,155.3312521,1.8,116.9870085,155.5038626,0.4107078,67.510072,45.6348863,267408.728361,350344.7243427,26.9931961,7677.1249584,3961.0197474,9140.8326517,60.1781443,73.7946685,2.2157637,382.1227194),(15989,'umzc_hippo_radius-cleaned.tif',250,3,251,1015.3819852,116.9011797,155.2246677,1.8,117.0489394,155.5313664,0.4418283,59.6069803,41.4688887,271450.2885631,355566.5958789,30.9413512,8574.2976732,4554.0016839,10157.539234,59.8291924,72.174461,2.1587989,401.9612626),(15990,'umzc_hippo_radius-cleaned.tif',250,3,252,1019.2936771,117.0183508,155.027071,1.8,117.1256236,155.3117107,0.4671811,49.2111813,41.9629586,277716.1839796,361929.0729597,34.4579457,8624.9655715,5643.3553654,11152.7892852,60.2670435,71.5471993,2.3401531,369.6952762),(15991,'umzc_hippo_radius-cleaned.tif',250,3,253,1043.9685042,117.6728037,155.0514763,1.8,117.6144454,155.3896564,0.5010221,47.3317403,36.5296969,285580.4246524,388164.7706779,40.1422446,10626.0058015,6033.5923155,14048.6096083,60.0589019,75.0921702,2.0827933,380.4068475),(15992,'umzc_hippo_radius-cleaned.tif',250,3,254,1048.9826046,117.6802169,154.7538151,1.8,117.7022459,155.1580796,0.5309574,53.3584647,39.4343858,296764.4254642,392819.6903299,44.8264546,9961.3492725,5561.7122302,11827.3093564,61.5933527,75.7364501,2.0216651,369.6952762),(15993,'umzc_hippo_radius-cleaned.tif',250,3,255,1052.2429983,117.6276475,154.4122354,1.8,117.7562403,154.7004296,0.5559981,76.7130057,46.2776323,308563.207849,398763.1233175,48.8527842,8616.7572456,4022.3063207,9121.9704111,61.0409482,75.4945202,2.0472637,353.2341018),(15994,'umzc_hippo_radius-cleaned.tif',250,3,256,1119.198193,119.4074103,154.5887183,1.8,119.1299215,154.5974743,0.521819,76.5325377,42.4022691,332240.5755679,464412.8627346,46.3460515,10952.547419,4341.1676326,9725.8091915,62.1142295,78.155756,2.0220607,396.5285793),(15995,'umzc_hippo_radius-cleaned.tif',250,3,257,1122.8713801,119.5454851,154.1920221,1.8,119.4129671,154.2466417,0.5673074,83.885008,48.3861818,344170.6905567,470934.9604644,54.0398993,9732.8398836,4102.8867828,9373.5665404,0.541016,0.7651122,2.3561945,1.5302245),(15996,'umzc_hippo_radius-cleaned.tif',250,3,258,1150.6830467,120.2192069,154.3588382,1.8,119.8801726,154.6541599,0.6150519,70.3521098,42.1741125,353984.4283706,508011.5952096,63.8494974,12045.5788026,5031.6106982,12201.2021004,65.0932316,82.1222446,2.125904,422.0398281),(15997,'umzc_hippo_radius-cleaned.tif',250,3,259,1148.5075883,120.1630817,154.1720699,1.8,119.8552589,154.5813921,0.6415763,52.2828641,44.2673105,356958.8048572,514562.1801627,68.5569514,11623.9765827,6827.4531436,15539.2228068,0.541016,0.7651122,2.3561945,1.5302245),(15998,'umzc_hippo_radius-cleaned.tif',250,3,260,1148.294628,120.1210105,153.8551647,1.8,119.7456564,154.4314815,0.6709715,49.7862289,44.2037764,361286.7712102,523130.9308333,73.982622,11834.5302854,7256.7611457,17224.7000147,65.6061865,84.157129,2.1034982,388.8230821),(15999,'umzc_hippo_radius-cleaned.tif',250,3,261,1195.6285661,121.2654556,153.893134,1.8,120.8706536,154.3881429,0.6139434,52.3351846,44.6549303,380451.0024319,574634.0060518,66.1353377,12868.321647,7269.5072225,15826.2796927,67.0487221,86.6183423,2.0372372,417.2091325),(16000,'umzc_hippo_radius-cleaned.tif',250,3,262,1195.684977,121.2232853,153.4660007,1.8,120.8848136,154.0827362,0.6150045,59.7032802,43.7689007,390145.415248,581367.579004,66.3376723,13282.6634831,6534.7400283,15966.184347,67.829962,86.4627606,1.989656,439.0804674),(16001,'umzc_hippo_radius-cleaned.tif',250,3,263,1257.5579525,122.477056,154.5850223,1.8,121.6491718,154.8472716,0.6965658,65.7706042,45.4271108,404592.5677686,684525.1763654,86.2756453,15068.6487334,6151.5713995,16558.9735627,67.3834138,92.9115327,2.0422563,469.7711837),(16002,'umzc_hippo_radius-cleaned.tif',250,3,264,1258.9393114,122.2493856,154.8828169,1.8,121.7182368,154.7973637,0.7893385,75.5011363,62.4213299,408851.5630489,724547.7122582,105.738375,11607.3738518,5415.1709929,14928.521275,0.541016,0.7651122,2.3561945,1.5302245),(16003,'umzc_hippo_radius-cleaned.tif',250,3,265,1280.0791404,122.5641221,154.6717723,1.8,122.0587134,154.5248918,0.8057125,71.182885,55.1155111,425789.9641816,749727.2404527,111.0060646,13602.8356709,5981.6339898,16248.2770698,0.541016,0.7651122,2.3561945,1.5302245),(16004,'umzc_hippo_radius-cleaned.tif',250,3,266,1322.3140955,123.6090613,155.0013506,1.8,122.772075,154.9513237,0.7802307,82.6582084,54.7312399,445821.7511164,810838.8841359,109.0540245,14814.9189764,5393.5569126,15193.046668,69.4529576,97.119539,1.9895863,447.7910991),(16005,'umzc_hippo_radius-cleaned.tif',250,3,267,1353.690296,124.3186567,154.832242,1.8,123.460594,154.9990474,0.7514839,55.5143745,51.0005815,464854.8357376,849127.9942953,105.1618249,16649.3786922,8373.594043,21932.8600108,68.9442797,98.3280857,1.990138,442.5665859),(16006,'umzc_hippo_radius-cleaned.tif',250,3,268,1341.7737472,123.8797336,154.4456384,1.8,123.2271814,154.7494185,0.7728579,54.7640549,52.264083,469445.5712978,842248.1153209,109.0104022,16115.2376039,8572.1477814,21985.1897033,68.9931981,99.4601764,2.0149817,450.0320609),(16007,'umzc_hippo_radius-cleaned.tif',250,3,269,1325.3491115,123.2561041,154.1220803,1.8,122.8446401,154.4656745,0.8024757,44.7678146,52.281639,470945.2565578,833072.1994871,114.2173073,15934.3168158,10519.7285408,21619.511737,70.1859499,99.5366616,1.9906763,459.2677826),(16008,'umzc_hippo_radius-cleaned.tif',250,3,270,1323.4871951,122.8377629,153.8991156,1.8,122.7127711,154.2591185,0.8458809,55.9318986,52.9756532,475578.1805993,846021.9271011,123.599451,15970.0140743,8502.8077429,21241.6644679,71.1554379,102.4736385,1.9493419,478.1874183),(16009,'umzc_hippo_radius-cleaned.tif',250,3,271,1405.2562089,124.8677167,155.1495671,1.8,124.2972522,155.0240436,0.788964,66.9163698,51.0701975,501470.531697,1017086.546332,117.9398296,19915.4613941,7493.9888927,22559.6824198,71.1554379,105.0463155,2.0068012,533.4929986),(16010,'umzc_hippo_radius-cleaned.tif',250,3,272,1421.1557615,124.8420734,155.1516708,1.8,124.42471,154.7748493,0.8223033,74.5785136,62.8841463,518310.3113714,1046567.024876,127.1630397,16642.7801985,6949.8611126,20693.0136457,70.382819,106.2060118,1.9683304,469.924979),(16011,'umzc_hippo_radius-cleaned.tif',250,3,273,1435.2901656,124.9513976,155.021337,1.8,124.5261669,154.505036,0.8590674,69.1779257,59.5120413,527569.0871377,1077999.7376267,137.1666204,18113.9768262,7626.2634593,23109.161144,72.1190875,106.998149,1.9597532,564.2606126),(16012,'umzc_hippo_radius-cleaned.tif',250,3,274,1435.603619,124.9319879,155.1020254,1.8,124.2135757,154.8282084,0.8746837,68.3792102,54.9898264,526450.1725076,1092659.7017594,140.8833937,19870.2155289,7698.9800142,23337.384912,70.8115435,108.0001384,1.9559538,534.6744512),(16013,'umzc_hippo_radius-cleaned.tif',250,3,275,1449.579966,124.881117,155.0619024,1.8,123.967636,154.9281891,0.889447,55.265449,52.8753405,531926.4940277,1111803.7728143,145.7551535,21026.8863111,9624.9375202,27550.5348713,71.4637635,108.5017096,1.9540805,496.3100897),(16014,'umzc_hippo_radius-cleaned.tif',250,3,276,1471.3778342,124.9057246,155.0711676,1.8,123.9850361,154.8958254,0.9074188,45.2956752,53.3567077,543673.8199854,1137553.1449486,152.2417647,21319.7776611,12002.7754787,29685.0801172,71.0541406,109.3066663,1.9457881,452.5899426),(16015,'umzc_hippo_radius-cleaned.tif',250,3,277,1534.1618998,125.8124058,155.7516773,1.8,124.42772,155.2931091,0.9040507,54.4576212,55.6999263,563186.4479694,1238751.1501758,157.9015897,22239.7269331,10341.7379559,30546.1359572,73.0236568,111.246898,1.9756881,507.5017055),(16016,'umzc_hippo_radius-cleaned.tif',250,3,278,1556.705794,125.9058946,155.6829003,1.8,124.4746728,155.185642,0.9065874,53.1308818,55.3018523,573660.7860065,1264412.1306349,160.861193,22863.8296751,10797.1252511,31662.4104809,71.8117827,110.9650164,1.9820901,452.5674198),(16017,'umzc_hippo_radius-cleaned.tif',250,3,279,1593.3011612,126.2420615,155.7283256,1.8,124.7687618,155.1504601,0.910387,68.3652692,55.8996796,594933.9615771,1298975.3768273,165.621318,23237.6175769,8702.2836026,27663.4149388,72.8982515,111.0928738,2.0083061,539.1113293),(16018,'umzc_hippo_radius-cleaned.tif',250,3,280,1608.7555462,125.8904525,155.599013,1.8,124.6258393,154.9900804,0.9445809,69.4441851,60.8089661,609607.2010932,1302933.1527535,176.026626,21426.6618428,8778.3764828,26366.9183537,73.9570602,112.4610884,2.1227665,627.9599047),(16019,'umzc_hippo_radius-cleaned.tif',250,3,281,1651.4087052,126.039778,155.6493298,1.8,124.6989533,154.9302679,0.9566931,69.9097187,60.0395258,632314.5130806,1326352.1407647,183.8468701,22091.3160749,9044.7297585,27965.5237946,73.8755437,110.4693305,1.984048,521.8531906),(16020,'umzc_hippo_radius-cleaned.tif',250,3,282,1678.1384522,125.9371333,155.850996,1.8,124.3422279,155.2390674,0.9635346,72.6568531,59.3069112,631136.1367059,1351793.8302719,188.6204559,22793.1922925,8686.5327872,26443.3965956,74.111876,111.0928738,2.0083061,486.6580277),(16021,'umzc_hippo_radius-cleaned.tif',250,3,283,1707.5241264,125.8200541,156.3761622,1.8,124.2555684,155.4356318,0.9623801,61.4181433,58.9243577,637620.3777409,1371271.0638968,191.6153177,23271.7184902,10381.6290015,32413.8131685,74.5984429,110.4693305,1.984048,538.9031591),(16022,'umzc_hippo_radius-cleaned.tif',250,3,284,1741.0071342,125.770551,156.8440729,1.8,124.0862721,155.7077006,0.9590566,55.3572545,55.369068,649419.9334486,1391143.8187667,194.4670242,25124.9274895,11731.4331971,35530.4267562,75.3635552,110.6030538,2.0103786,507.1622628),(16023,'umzc_hippo_radius-cleaned.tif',250,3,285,1758.127239,125.4235841,156.9300083,1.8,123.9126032,155.8177512,0.9626732,58.5863404,56.3458734,657210.3729119,1392428.1415652,197.3744504,24712.1582585,11217.8089448,34984.9118347,74.3944767,110.8343707,2.0147958,491.1174287),(16024,'umzc_hippo_radius-cleaned.tif',250,3,286,1754.9325694,125.0166422,157.0069242,1.8,123.7792658,155.875435,0.9727133,62.5645225,59.3388401,658155.106067,1376323.1189413,199.7593519,23194.3043897,10519.621666,32010.0738301,0.541016,0.7651122,2.3561945,1.5302245),(16025,'umzc_hippo_radius-cleaned.tif',250,3,287,1774.1910576,124.9265463,156.9539622,1.8,124.0092794,155.5129831,0.9905493,80.2079403,58.2739159,675335.5343564,1388926.2029637,206.824319,23834.44089,8419.8089628,25067.5519479,75.7674064,111.402023,2.0778948,609.2165871),(16026,'umzc_hippo_radius-cleaned.tif',250,3,288,1792.0208229,124.9687191,156.2908206,1.8,124.4894803,155.169379,1.0573907,78.480811,65.7494631,710080.711934,1413563.3111153,226.6234222,21499.2373353,9047.8258711,25818.9361765,0.541016,0.7651122,2.3561945,1.5302245),(16027,'umzc_hippo_radius-cleaned.tif',250,3,289,1781.904103,125.2546475,155.2804004,1.8,124.7943688,154.7044663,1.1305587,73.3064383,63.6846662,728929.8107064,1403764.7802389,243.0494634,22042.4297257,9943.5987812,26681.9104513,0.541016,1.2097487,2.0344439,2.6122566),(16028,'umzc_hippo_radius-cleaned.tif',250,3,290,1734.5643997,125.3811354,154.8732915,1.8,124.7294859,154.7031333,1.1558275,64.8757756,66.0451815,716852.3466293,1351714.614697,242.104968,20466.5137302,11049.6150565,31218.6114721,77.3880521,108.7226909,2.0745116,604.4946412),(16029,'umzc_hippo_radius-cleaned.tif',250,3,291,1698.6006401,125.5781876,154.6918665,1.8,124.9113667,154.5037404,1.1631454,55.6916369,67.4474071,709637.8528622,1304054.5215441,238.6036569,19334.3907282,12742.269617,29680.3914297,0.541016,1.2097487,2.0344439,2.6122566),(16030,'umzc_hippo_radius-cleaned.tif',250,3,292,1686.02144,125.6345795,154.4299775,1.8,124.9182275,154.1644234,1.1652612,59.7359453,62.8869062,711104.7070231,1277870.6421362,237.2685719,20320.1384887,11904.1341598,31615.9772646,77.817892,107.2754476,1.7790718,558.7417024),(16031,'umzc_hippo_radius-cleaned.tif',250,3,293,1679.2216135,125.7218507,154.2849392,1.8,125.0382509,153.8148589,1.190056,54.4937757,67.9519135,707740.1803231,1268135.548523,241.2223043,18662.2492699,12987.5416308,28775.3219196,78.7969293,107.4771651,1.830426,535.8108582),(16032,'umzc_hippo_radius-cleaned.tif',250,3,294,1694.4295997,125.7839522,154.0415207,1.8,125.1845734,153.2773399,1.2118532,60.4844072,65.9633138,714647.2656922,1275574.3378319,247.5558632,19337.632751,11815.3966994,29891.1994807,79.0389945,106.5897733,1.6724852,573.0613355),(16033,'umzc_hippo_radius-cleaned.tif',250,3,295,1699.1888752,125.9167055,153.7340077,1.8,125.399209,152.6616519,1.2277974,60.0629517,66.7832859,719566.7997813,1259595.6642034,251.1666375,18860.9417301,11980.2104294,29174.7376235,79.2919026,105.9687351,1.7090833,629.0644596),(16034,'umzc_hippo_radius-cleaned.tif',250,3,296,1721.0817373,126.1763784,153.4562886,1.8,125.8068681,152.1419402,1.2326617,64.4171031,68.15667,734035.809306,1261187.7059676,255.281343,18504.2447977,11395.0453246,28547.2662558,77.7403501,105.1577114,1.6325733,577.8469855),(16035,'umzc_hippo_radius-cleaned.tif',250,3,297,1750.1759549,126.4503246,153.2257162,1.8,126.0818477,151.5858027,1.24672,67.1360233,63.2558378,739575.5417346,1262824.4591514,262.1180886,19963.7614935,11016.0760971,27557.456251,0.541016,0.7651122,2.3561945,1.5302245),(16036,'umzc_hippo_radius-cleaned.tif',250,3,298,1771.4682532,126.7991389,153.0794721,1.8,126.0472854,151.2546084,1.2420607,59.0872724,65.8692241,739191.0267563,1257988.425663,264.4713782,19098.2730191,12510.1565333,30221.6650126,77.7245045,104.1508591,1.6435842,734.2017557),(16037,'umzc_hippo_radius-cleaned.tif',250,3,299,1807.3259317,126.9615316,152.7621666,1.8,126.0104555,151.0463899,1.2359252,56.7070967,62.392433,746378.3306701,1262751.4081711,268.6863575,20238.8550705,13161.9916011,31649.7456683,77.0898237,103.8877608,1.5864201,619.0317737),(16038,'umzc_hippo_radius-cleaned.tif',250,3,300,1839.8357619,126.987183,152.2725301,1.8,125.9674159,150.645565,1.2269115,52.3302023,64.4946434,747402.5280969,1269600.4738162,271.7841812,19685.3631017,14282.4314706,31063.4249355,77.4327775,102.9651762,1.6286265,559.692462),(16039,'umzc_hippo_radius-cleaned.tif',250,3,301,1877.5605012,127.0351941,151.8375904,1.8,125.9963739,150.2427132,1.2203172,50.3864524,65.3063686,754991.5091097,1269257.9313726,276.0365175,19435.4388126,14984.0179744,30770.8602734,76.7668981,103.5052926,1.5132683,568.7743884),(16040,'umzc_hippo_radius-cleaned.tif',250,3,302,1915.7525823,127.0733869,151.4505725,1.8,126.0695968,149.8981325,1.208421,52.2743342,66.1278605,767670.75207,1260337.3856007,279.1674185,19059.0981873,14685.4238166,30371.0037088,76.855823,101.3145547,1.5173713,579.4315848),(16041,'umzc_hippo_radius-cleaned.tif',250,3,303,1946.8919632,127.0757358,151.0007212,1.8,126.1155568,149.5295103,1.1895147,53.7232148,65.771991,765528.7939529,1246269.4152886,279.5522239,18948.3303754,14249.4970988,30556.0061313,75.0957718,100.4615965,1.4357537,571.8348373),(16042,'umzc_hippo_radius-cleaned.tif',250,3,304,1979.493062,126.939244,150.443776,1.8,126.0818899,148.9960425,1.1676623,65.1871109,62.4003326,759013.0158785,1230792.6005226,279.1409563,19724.1352611,11643.6057048,30322.7285296,74.4436964,100.0777332,1.4243121,570.1414883),(16043,'umzc_hippo_radius-cleaned.tif',250,3,305,1982.890137,126.8809591,149.9683156,1.8,126.0295063,148.8295056,1.1494425,63.5377214,60.4757386,736812.2996261,1192935.7066266,275.1993962,19725.8559151,11596.4545606,29989.4864063,74.7052829,99.5954564,1.4619387,605.2372306),(16044,'umzc_hippo_radius-cleaned.tif',250,3,306,1941.8663323,126.9384037,149.7655698,1.8,125.9426416,148.8157587,1.1355632,50.733381,68.346204,698600.633654,1129350.0818404,266.1117671,16523.9620551,13770.0389825,26718.9191905,73.0874467,98.4619484,1.466207,601.3347718),(16045,'umzc_hippo_radius-cleaned.tif',250,3,307,1880.0390355,126.8757241,149.3766301,1.8,125.8620534,148.4862317,1.1152246,46.608268,50.4458333,652341.0006337,1054391.6390049,252.6839062,20901.46144,13996.2506434,33568.1612845,72.1008551,97.4024237,1.4202585,602.6024513),(16046,'umzc_hippo_radius-cleaned.tif',250,3,308,1798.1263334,126.7512476,149.0075664,1.8,125.7158733,148.2316744,1.1116374,44.2550814,59.7835963,602308.1890413,980143.5983718,240.8227045,16394.8584479,13609.9216177,25983.1961026,71.8656458,96.4314632,1.4527043,609.7191543),(16047,'umzc_hippo_radius-cleaned.tif',250,3,309,1661.085934,126.141843,148.3233759,1.8,125.4758041,147.6846484,1.1210604,39.2731219,45.399329,534114.6480653,888354.8812777,224.526723,19567.5773384,13600.0048399,28291.0480962,69.4310736,94.9556379,1.4393743,658.4781672),(16048,'umzc_hippo_radius-cleaned.tif',250,3,310,1448.9307965,124.087081,147.3334153,1.8,123.9176762,146.8585742,1.2350956,45.2434978,48.0114877,429058.3948761,776087.7642238,215.2810019,16164.626451,9483.3161802,23866.3618836,67.7255369,93.497216,1.425626,660.8278788),(16049,'umzc_hippo_radius-cleaned.tif',250,3,311,1248.5847962,121.5284535,146.2418395,1.8,120.9767664,145.6121961,1.3774958,52.3194619,50.1981315,311861.1409472,668411.496105,200.4182511,13315.4656499,5960.710019,18728.529292,0.541016,0.7651122,2.3561945,1.5302245),(16050,'umzc_hippo_radius-cleaned.tif',250,3,312,1118.2730888,119.8915553,145.9845006,1.8,119.4241169,144.8557721,1.4666718,44.1423057,50.5627484,218968.0139771,596534.9357998,184.365435,11797.9135685,4960.5024108,14796.5764058,46.2861726,64.6372685,0.6786625,308.006253),(16051,'umzc_hippo_radius-cleaned.tif',250,3,313,992.6241551,119.4358252,145.5210029,1.8,118.7947376,144.3497371,1.4725089,39.5291212,49.3382723,170444.0256842,511376.1399418,163.8443059,10364.6949182,4311.8597267,13813.1340218,43.5373462,63.1159628,0.6760796,337.7687325),(16052,'umzc_hippo_radius-cleaned.tif',250,3,314,849.2676798,119.1989294,144.349358,1.8,118.5056165,143.4824021,1.4640852,31.3091164,49.6689331,137040.6264693,410610.5606221,139.9389166,8266.9494819,4377.0199364,11025.4978438,40.3505324,60.7023865,0.6399361,285.6773964),(16053,'umzc_hippo_radius-cleaned.tif',250,3,315,677.1613953,118.7881671,142.6301391,1.8,118.214703,142.1694917,1.4491244,29.8210779,50.1560196,107891.830797,291183.2346724,111.1976711,5805.5491078,3617.9721941,7952.9478272,36.8918895,57.1764641,0.6037493,259.2153881),(16054,'umzc_hippo_radius-cleaned.tif',250,3,316,427.8449184,117.5405474,137.7619394,1.8,117.2152271,139.3598629,1.5212997,28.1409573,53.3587617,79666.4753483,118577.6356717,71.1329314,2222.271132,2830.979574,3713.739233,32.2533105,54.3714401,0.5438325,209.7137858),(16055,'umzc_hippo_radius-cleaned.tif',250,3,317,234.934521,116.4616952,133.4232731,1.8,115.4495891,134.557731,-0.1948877,54.1963902,25.6510017,28910.2193833,53669.0330429,1.4684504,2092.2782555,533.4344091,1514.8118354,18.6160638,22.5026259,1.0963964,72.9031617),(16056,'umzc_hippo_radius-cleaned.tif',250,3,318,83.9152911,108.5411635,132.0173978,1.8,112.3046965,131.7569042,-0.0814667,9.9004691,27.3734684,1223.4334942,14189.3352353,0.0926167,518.3608815,123.573286,545.4896894,15.1605283,17.1084297,0.9652517,54.9886605),(16057,'umzc_hippo_radius-cleaned.tif',250,3,319,24.4549485,101.9209249,131.6187688,1.8,101.6486698,131.9697031,1.2290635,6.2978437,5.9717213,106.7500553,145.4081316,3.618087,24.3494505,16.9502548,39.8083898,10.500844,11.9759008,1.8925469,36.834137),(16058,'umzc_hippo_radius-cleaned.tif',250,3,320,1.5235393,101.9591786,130.6652187,1.8,101.9477119,130.7737233,1.3872122,1.0210314,3.0681354,0.291093,2.6743729,0.2454609,0.8716607,0.285097,0.9625809,2.1640642,6.691999,1.815775,15.225347),(16059,'umzc_hippo_radius-cleaned.tif',250,3,321,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16060,'umzc_hippo_radius-cleaned.tif',250,3,322,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16061,'umzc_hippo_radius-cleaned.tif',250,3,323,35.6433879,128.3351668,217.9596941,1.8,128.1108762,217.8441,0.0421082,5.6877505,56.1281993,212.2083025,34517.2431273,0.010527,614.9715042,37.3097065,615.5996271,26.7402904,252.7014098,3.1223231,558.4131896),(16062,'umzc_hippo_radius-cleaned.tif',250,3,324,61.1125806,135.7273402,207.5827712,1.8,136.9349206,204.5411566,-0.2052001,20.9469557,62.600157,9452.1579657,45647.0690905,0.4228927,729.1845785,451.2425634,870.1261937,26.7686165,252.7014098,3.1223231,551.2102597),(16063,'umzc_hippo_radius-cleaned.tif',250,3,325,256.9279649,133.6094492,197.6947101,1.8,135.6777562,196.4922211,-0.2131823,28.5508358,62.5440764,21969.6672264,71306.4428386,1.9167841,1140.0990628,769.4929631,1491.3650666,23.2636901,29.8393772,2.3561945,145.2587107),(16064,'umzc_hippo_radius-cleaned.tif',250,3,326,492.4338685,132.8806421,192.4698498,1.8,136.6200743,192.8807733,-0.1330687,34.088951,62.2368936,43481.7923724,98515.2068043,1.4447201,1582.9068761,1275.5391722,2253.7045218,29.0380697,30.6283898,2.5192898,102.0636536),(16065,'umzc_hippo_radius-cleaned.tif',250,3,327,556.9420162,132.7690574,191.1835435,1.8,136.9805297,192.7090098,-0.0983974,36.7438436,61.8745863,54128.7458305,105461.5612465,0.8958267,1704.4406674,1473.137823,2522.0137676,29.2148667,29.7558827,0.9272952,95.9427557),(16066,'umzc_hippo_radius-cleaned.tif',250,3,328,563.3795177,132.9510155,191.314729,1.8,137.161101,192.9622051,-0.0767688,37.0616678,61.7447604,55292.0614705,108823.6990965,0.5522891,1762.4766607,1491.893505,2588.0648492,29.2148667,30.6236112,1.012197,102.0636536),(16067,'umzc_hippo_radius-cleaned.tif',250,3,329,567.8811298,133.241646,191.4979457,1.8,137.2729058,193.3100756,-0.0611016,35.0912398,61.7897367,55160.5196858,112222.7053372,0.352915,1816.2030029,1571.9170924,2630.3703203,29.2148667,31.5463856,1.0303768,115.9444235),(16068,'umzc_hippo_radius-cleaned.tif',250,3,330,571.7218646,133.4838243,191.6193065,1.8,137.5220238,193.3541707,-0.048348,35.6600772,61.8267319,55217.420683,115362.3396847,0.2225621,1865.8974235,1548.4380569,2672.4007938,29.2148667,30.8426602,2.4805495,106.2061346),(16069,'umzc_hippo_radius-cleaned.tif',250,3,331,575.121157,133.6401607,191.7837083,1.8,137.574463,193.5555359,-0.040859,35.4028925,61.8556663,55797.6059002,118676.3919691,0.1599344,1918.601787,1576.0747757,2729.0840296,32.3027125,57.4012675,0.199244,221.9649108),(16070,'umzc_hippo_radius-cleaned.tif',250,3,332,577.2841092,133.7254559,191.9406847,1.8,137.5975606,193.7379959,-0.0278276,34.6085331,61.720749,55872.4888407,120397.2867723,0.0744865,1950.6776689,1614.4136681,2755.622782,31.4367183,57.7444351,0.2267988,220.2490389),(16071,'umzc_hippo_radius-cleaned.tif',250,3,333,577.6651493,133.7726594,192.0719895,1.8,137.6600994,193.8285516,-0.0111784,32.5186309,61.478172,55611.9869204,120654.4539211,0.0120302,1962.5576022,1710.1576961,2755.2549163,0.541016,0.7651122,2.3561945,1.5302245),(16072,'umzc_hippo_radius-cleaned.tif',250,3,334,578.3709071,133.8223984,192.2018575,1.8,137.7693628,193.9658908,-0.0012066,31.7883251,61.3475754,55406.6189397,121257.6656015,0.0001402,1976.568181,1742.9864198,2767.6063102,29.3469576,57.8457235,0.1313154,190.8803769),(16073,'umzc_hippo_radius-cleaned.tif',250,3,335,579.9428747,133.8230439,192.3494452,1.8,137.7033025,194.1397256,0.0035301,33.7957311,61.2664154,55513.4275024,121823.2277235,0.0012046,1988.417747,1642.616558,2773.3211694,29.5782721,57.714014,0.1127276,185.6558638),(16074,'umzc_hippo_radius-cleaned.tif',250,3,336,581.3876516,133.849914,192.498051,1.8,137.7187014,194.3355969,0.0089779,30.8888681,61.1997898,55302.7392289,122696.543794,0.0078101,2004.8523717,1790.3776529,2784.3862542,30.2995447,57.7773733,0.1220321,187.5030081),(16075,'umzc_hippo_ulna-cleaned.tif',250,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16076,'umzc_hippo_ulna-cleaned.tif',250,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16077,'umzc_hippo_ulna-cleaned.tif',250,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16078,'umzc_hippo_ulna-cleaned.tif',250,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16079,'umzc_hippo_ulna-cleaned.tif',250,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16080,'umzc_hippo_ulna-cleaned.tif',250,4,6,0.3999324,214.484967,125.0847345,1.8,214.4969515,125.0701809,0.1609957,0.9116007,1.8591705,0.0879472,0.3015574,0.0017128,0.1622,0.0964756,0.2084137,2.1640642,3.9386563,2.863293,9.0500743),(16081,'umzc_hippo_ulna-cleaned.tif',250,4,7,28.454716,213.405264,124.1417829,1.8,212.4285447,123.7269306,0.2362019,4.2662204,11.8683032,82.7328821,354.4296935,0.2597037,29.8635524,19.3925477,35.9780888,8.6623073,20.0832853,3.0606886,49.7641473),(16082,'umzc_hippo_ulna-cleaned.tif',250,4,8,96.2028572,211.8742464,123.8614329,1.8,211.128342,123.95312,0.0471495,5.9661535,13.3305784,546.7861887,2841.1100462,0.0356179,213.1272904,91.6480251,254.0863352,11.9023531,24.6385148,2.9872739,65.940254),(16083,'umzc_hippo_ulna-cleaned.tif',250,4,9,162.3036388,211.8572695,123.9633386,1.8,212.0055499,123.968448,-0.0365766,8.594296,14.9544274,1427.3504496,7317.541939,0.0361734,489.3227769,166.0811374,584.4871838,16.1450696,29.8001148,0.0544915,94.3806792),(16084,'umzc_hippo_ulna-cleaned.tif',250,4,10,215.0069953,212.7101463,124.0900671,1.8,213.1197474,124.1194248,-0.0453788,10.6423582,16.3201063,2430.3059372,13328.2736877,0.0737409,816.6781157,228.3615983,964.5345191,16.7714975,33.041866,0.0491407,114.119802),(16085,'umzc_hippo_ulna-cleaned.tif',250,4,11,263.9446543,213.9742265,124.2961739,1.8,213.9382205,124.2965325,-0.0363256,13.1531814,18.7190571,3802.2531374,21417.3613319,0.0580223,1144.1474425,289.0747884,1345.0267294,18.852982,35.8543055,0.0906599,130.481556),(16086,'umzc_hippo_ulna-cleaned.tif',250,4,12,309.9524913,214.8134808,124.5930482,1.8,214.320308,124.5783818,-0.0320673,11.4290065,21.0790708,5564.1561849,31480.8452935,0.0531029,1493.4645674,486.845131,1742.7125272,20.6969602,40.6662731,3.0750245,125.4426902),(16087,'umzc_hippo_ulna-cleaned.tif',250,4,13,364.4620628,215.1637795,124.9041552,1.8,214.3908249,124.8526686,-0.0101704,13.4195062,22.5561142,7924.4529975,46107.7395292,0.0062829,2044.1348708,590.5174819,2342.4312812,21.9958143,43.9390307,2.968347,163.2275868),(16088,'umzc_hippo_ulna-cleaned.tif',250,4,14,420.954444,215.404459,125.1346158,1.8,214.4694349,124.9395102,0.0144766,14.9212707,25.0134989,11448.6407125,64415.3236913,0.0147021,2575.2224417,767.2698239,3010.7060415,23.7933339,47.4431284,3.0158232,153.2492757),(16089,'umzc_hippo_ulna-cleaned.tif',250,4,15,483.2073952,215.4608648,125.4855043,1.8,214.3195992,125.2195196,0.0378758,14.1029093,27.9121294,16513.8372511,89667.2408366,0.1154772,3212.4829884,1170.9525228,3759.2354881,25.9687704,52.4143765,2.9441971,164.6490615),(16090,'umzc_hippo_ulna-cleaned.tif',250,4,16,588.4030106,213.2726571,125.2034461,1.8,209.6592775,123.9963588,0.1597407,15.6264872,47.2188213,27839.5537918,171936.3961676,2.4811775,3641.2682774,1781.5618775,4212.5930488,7.0169768,8.9554091,1.1341692,31.9265437),(16091,'umzc_hippo_ulna-cleaned.tif',250,4,17,875.6744829,204.9638985,123.6623992,1.8,203.3926583,123.4335921,0.2099209,19.8281126,41.4055095,50525.3156639,456999.8755789,6.3374457,11037.1755265,2548.1656659,12162.434599,35.2121533,80.7274992,3.0139127,288.4209255),(16092,'umzc_hippo_ulna-cleaned.tif',250,4,18,955.2007176,205.2231586,124.8613014,1.8,202.8436799,123.8065852,0.1766649,75.2361697,59.9307849,70081.5886813,537283.2697396,4.9172368,8965.0631305,931.4879922,6793.3152345,38.5763366,84.3603466,3.0323519,312.3025294),(16093,'umzc_hippo_ulna-cleaned.tif',250,4,19,988.3559033,207.4938678,126.4591442,1.8,202.9368082,124.8485,0.1480694,29.7593487,51.2407675,90241.6811931,550110.2400276,3.5852251,10735.7923465,3032.3809156,11108.1797806,42.1792907,86.2322561,3.0094557,316.2818858),(16094,'umzc_hippo_ulna-cleaned.tif',250,4,20,1073.9587336,208.3934112,127.6695948,1.8,203.3303692,125.6800726,0.1366239,36.0220144,53.2624983,116263.1140704,602098.1495304,3.3203637,11304.3542696,3227.5572611,12405.3728706,43.6737662,88.0710321,2.9562447,335.0158742),(16095,'umzc_hippo_ulna-cleaned.tif',250,4,21,1167.9488799,209.109218,128.4200109,1.8,203.9983366,126.4020979,0.1379638,37.7733286,50.3162667,144815.590594,650274.7391611,3.6816769,12923.7477526,3833.8053897,15171.0148807,46.6362667,90.0186329,2.8864103,358.2861611),(16096,'umzc_hippo_ulna-cleaned.tif',250,4,22,1240.7299251,209.9451303,129.6624032,1.8,204.8966368,127.5844432,0.132485,38.032881,51.7743826,176600.4206075,701322.1246013,3.6084189,13545.7361216,4643.3616353,15600.1422896,49.0857417,91.7018215,2.8235734,350.2412212),(16097,'umzc_hippo_ulna-cleaned.tif',250,4,23,1318.6252978,210.5206832,131.1900265,1.8,206.0787793,129.6005893,0.1385717,67.4798056,86.2491153,222489.9317422,770765.1811764,4.1931203,8936.4995679,3297.1335633,9069.9969308,0.7651122,1.5302245,2.3561945,3.0604489),(16098,'umzc_hippo_ulna-cleaned.tif',250,4,24,1378.6949852,211.5090419,133.1272001,1.8,207.0499592,130.9814996,0.1082063,44.0718924,53.8883937,267911.0717485,800069.6638338,2.6799489,14846.7899914,6078.9554746,19054.8566254,56.5785344,92.6022896,2.8512551,399.0320862),(16099,'umzc_hippo_ulna-cleaned.tif',250,4,25,1369.3228722,212.7760808,134.8895243,1.8,208.8726656,132.9279785,0.0044216,49.975116,85.4171751,278346.1713549,773866.1604805,0.0044624,9059.8425815,5569.6953522,10632.4187503,58.5823257,93.8347071,2.9736004,435.3861788),(16100,'umzc_hippo_ulna-cleaned.tif',250,4,26,1340.0589783,213.1453401,135.6423199,1.8,210.0924747,134.1686432,-0.0718747,41.6908764,51.2123813,276866.7517171,758949.3054727,1.1517982,14819.6448991,6640.9434318,18526.7557174,1.1476684,2.2953367,2.3561945,4.5906734),(16101,'umzc_hippo_ulna-cleaned.tif',250,4,27,1333.1838485,213.1507468,135.8698426,1.8,211.0431156,134.8798717,-0.1100828,44.1857143,50.0600802,284498.7315346,778019.0265804,2.6817771,15541.7055658,6438.7039176,19325.2925927,58.8741842,92.6070307,3.0244839,462.9076964),(16102,'umzc_hippo_ulna-cleaned.tif',250,4,28,1325.7486891,213.2081069,136.2751907,1.8,211.6689812,135.4897868,-0.1611233,31.2467163,52.5038732,287184.5325834,782405.203365,5.6867689,14901.8568594,9190.8708122,18634.1756175,59.6135944,91.2025338,3.0047291,420.6408761),(16103,'umzc_hippo_ulna-cleaned.tif',250,4,29,1306.6137551,213.7869124,137.0358586,1.8,212.6714596,136.299578,-0.2375772,47.6938571,58.8977665,278403.7096088,767023.0081523,12.0619989,13022.9557656,5837.3074931,15585.0399655,0.541016,1.2097487,2.0344439,2.6122566),(16104,'umzc_hippo_ulna-cleaned.tif',250,4,30,1286.8895218,214.3217666,137.9130734,1.8,213.604868,137.1092428,-0.2983293,43.814227,50.7409858,265103.2759055,764016.2107237,18.5293094,15057.1810669,6050.6208672,18647.2918478,60.0403378,90.0430161,0.3559577,379.7411558),(16105,'umzc_hippo_ulna-cleaned.tif',250,4,31,1284.6119737,214.3387602,138.5034715,1.8,214.1452629,137.7545552,-0.333489,41.1596005,68.900558,262734.1126081,788372.2615901,22.9415967,11442.1752822,6383.3008449,13861.5720454,58.6523968,90.2200026,0.285713,383.7523643),(16106,'umzc_hippo_ulna-cleaned.tif',250,4,32,1290.607678,214.3225723,139.0450845,1.8,214.3964042,138.2696076,-0.3602911,40.110008,112.243583,261903.6187092,817216.2252173,26.7347528,7280.7389395,6529.6326668,9487.2696602,58.2568339,91.714588,0.4451801,386.5502682),(16107,'umzc_hippo_ulna-cleaned.tif',250,4,33,1302.2474051,214.3802811,139.5921671,1.8,214.8263553,138.8091686,-0.3846642,40.5952546,102.7760499,261815.776578,861037.1915865,30.5617844,8377.8000103,6449.4182649,10752.4323382,58.8405202,93.4940854,0.4170492,461.640017),(16108,'umzc_hippo_ulna-cleaned.tif',250,4,34,1319.1404469,214.2950898,140.0232537,1.8,214.974085,139.3065096,-0.4052342,47.4546631,59.7356474,264829.0659266,899427.8260465,34.1702281,15056.8021893,5580.6752992,17927.127499,59.0396278,94.554067,0.3996326,436.7532787),(16109,'umzc_hippo_ulna-cleaned.tif',250,4,35,1333.646578,214.1077481,140.56281,1.8,214.9414252,139.7611365,-0.420843,40.7753852,57.5785288,267989.121628,934502.5480235,37.0968831,16230.0525562,6572.325932,20258.4112425,59.6302177,96.0040564,0.3449193,433.05899),(16110,'umzc_hippo_ulna-cleaned.tif',250,4,36,1341.7718846,213.9462803,141.0899988,1.8,214.9609311,140.2371801,-0.4330046,48.2346232,59.9335398,270043.2654446,972670.4163935,39.3729923,16229.1501571,5598.5358106,19852.9212078,58.0586551,97.564561,0.4289221,412.1927895),(16111,'umzc_hippo_ulna-cleaned.tif',250,4,37,1347.3435311,213.7628342,141.5647539,1.8,214.8548314,140.6398684,-0.4458619,47.0120787,56.8378319,271556.7900397,1004083.8872893,41.7596064,17665.7668551,5776.319566,21027.987317,0.541016,0.7651122,2.3561945,1.5302245),(16112,'umzc_hippo_ulna-cleaned.tif',250,4,38,1342.2942181,213.556135,142.1302385,1.8,214.9497808,141.1467344,-0.4543774,37.9335719,61.870197,267563.2860036,1025310.1513395,43.0956617,16571.9555067,7053.4693349,20369.8751994,58.2013907,98.3890902,0.4070578,420.6090241),(16113,'umzc_hippo_ulna-cleaned.tif',250,4,39,1348.8932359,213.3362987,142.6810112,1.8,214.808052,141.5894958,-0.4588792,38.6386559,60.4572531,265344.9745059,1056107.2711295,44.1085689,17468.6612067,6867.3448413,20601.719104,59.2954777,99.7422918,0.5413497,444.5675256),(16114,'umzc_hippo_ulna-cleaned.tif',250,4,40,1351.4583379,212.9468158,143.1824655,1.8,214.7740797,141.9666436,-0.4604555,41.7931668,107.7760462,260884.623241,1090046.1925158,44.4748,10113.993149,6242.2793833,12497.1691644,59.0982243,102.3793362,0.4896465,456.918071),(16115,'umzc_hippo_ulna-cleaned.tif',250,4,41,1353.6565026,212.7731558,143.6456515,1.8,214.6502132,142.4301653,-0.4658924,45.6488503,72.401155,254869.3817637,1123822.5207993,45.5277237,15522.162874,5583.259599,18380.569123,58.4355502,102.4707821,0.5132523,488.5820697),(16116,'umzc_hippo_ulna-cleaned.tif',250,4,42,1359.1886791,212.4313947,144.0383687,1.8,214.3664249,142.816638,-0.4675645,43.4050582,62.7011034,250572.9928506,1153482.5299233,46.0182134,18396.5268254,5772.898443,21903.0227021,59.6919819,103.9455025,0.5172094,456.2073337),(16117,'umzc_hippo_ulna-cleaned.tif',250,4,43,1365.272459,212.0087017,144.4721516,1.8,214.0198113,143.2692616,-0.467729,40.6757667,63.0470547,245021.7261812,1186180.3181568,46.2543166,18814.2066853,6023.7764728,21946.6291152,57.3945041,103.8144814,0.4822935,440.4025217),(16118,'umzc_hippo_ulna-cleaned.tif',250,4,44,1367.6656673,211.5133783,145.0872465,1.8,213.6276909,143.7542279,-0.4597494,45.5989652,60.0326687,234567.9994543,1220180.4324304,44.8800768,20325.2738749,5144.151812,22214.3265903,57.982531,106.4647558,0.4522845,454.6771092),(16119,'umzc_hippo_ulna-cleaned.tif',250,4,45,1365.3702912,210.9015841,145.6825849,1.8,213.0163538,144.4598093,-0.45161,42.7756137,101.1814054,224646.374858,1242559.1489753,43.3408986,12280.5088986,5251.7393783,14487.8325587,56.2061671,105.5036784,0.4797013,462.2288111),(16120,'umzc_hippo_ulna-cleaned.tif',250,4,46,1356.0041209,210.2310393,146.423587,1.8,212.4943546,145.1427637,-0.4395318,33.4414187,63.438026,211709.4195159,1261948.2170885,40.9205188,19892.6148232,6330.7547303,21859.1692676,56.640866,107.7287808,0.4973427,468.3722318),(16121,'umzc_hippo_ulna-cleaned.tif',250,4,47,1347.2021489,209.4882518,147.4763098,1.8,212.0371473,145.9941066,-0.4176336,42.3867087,64.9973744,195219.7945944,1272999.7332262,36.938083,19585.4024044,4605.6842011,21585.898942,54.229122,108.7778661,0.5148278,510.1908597),(16122,'umzc_hippo_ulna-cleaned.tif',250,4,48,1338.8979414,208.5537091,148.6305252,1.8,211.2038063,146.9708352,-0.3923999,43.513304,101.4190492,177214.3203003,1287466.2405785,32.6323089,12694.5209055,4072.6468506,14431.4304942,54.3348374,108.9042598,0.4858662,514.1026478),(16123,'umzc_hippo_ulna-cleaned.tif',250,4,49,1341.8674107,207.6151245,149.6596268,1.8,209.8606317,148.2478143,-0.3749807,40.2430128,98.4687886,163351.9915547,1321870.453121,30.0002193,13424.2583002,4059.1392178,15047.2418132,0.541016,0.7651122,2.3561945,1.5302245),(16124,'umzc_hippo_ulna-cleaned.tif',250,4,50,1344.9512984,206.6509304,150.4327681,1.8,208.8077438,149.1078563,-0.363127,44.2087415,74.5989554,154380.8833101,1360869.9031156,28.28127,18242.4793443,3492.0895312,20209.9507047,48.9652701,111.5805436,0.3462855,537.264185),(16125,'umzc_hippo_ulna-cleaned.tif',250,4,51,1355.8918312,205.6428717,151.1051646,1.8,207.553062,149.8477191,-0.3539842,44.2758815,66.2934617,148239.2461468,1408420.0335891,27.1534842,21245.232916,3348.0811897,21612.2954929,46.6490856,114.3094067,0.3427056,480.6684024),(16126,'umzc_hippo_ulna-cleaned.tif',250,4,52,1367.3060918,204.4711111,151.7703915,1.8,206.4492342,150.5439198,-0.346543,42.4862825,82.7587504,142869.4408577,1471426.0052673,26.2889624,17779.7030244,3362.7192735,19158.8127576,0.541016,1.2097487,2.0344439,2.6122566),(16127,'umzc_hippo_ulna-cleaned.tif',250,4,53,1381.5693719,203.1812331,152.4777147,1.8,205.3420126,151.2349335,-0.3362634,44.2894592,72.7705872,136759.1883432,1547296.6833471,25.0697211,21262.6659112,3087.8495891,20635.6093958,45.7372604,119.6086035,0.3031547,474.0224145),(16128,'umzc_hippo_ulna-cleaned.tif',250,4,54,1403.1161404,201.7062618,153.2111525,1.8,203.8964333,152.0555883,-0.3264088,41.9942261,90.9155283,134019.933,1642555.8497497,24.0429284,18066.8350211,3191.389518,19522.4792397,0.541016,0.7651122,2.3561945,1.5302245),(16129,'umzc_hippo_ulna-cleaned.tif',250,4,55,1436.7600436,199.7707144,153.9665888,1.8,201.7331682,152.9075967,-0.3157564,45.3627758,89.7813042,131944.5492946,1788207.6563036,23.0916952,19917.3722447,2908.6524595,21219.1679449,44.1069827,125.7440485,0.2700256,480.3833346),(16130,'umzc_hippo_ulna-cleaned.tif',250,4,56,1470.2576864,197.6158156,154.7754257,1.8,199.5636059,153.8050687,-0.3065679,42.9060385,88.1320167,131169.4286602,1941170.7732837,22.3175846,22025.7160457,3057.1321242,23435.1355414,44.0217184,127.1675459,0.2625207,512.3549239),(16131,'umzc_hippo_ulna-cleaned.tif',250,4,57,1518.8735546,195.6823463,155.7856658,1.8,197.3446462,154.9624543,-0.305041,42.9292465,81.276277,134306.936078,2081459.1158143,22.8335961,25609.6759299,3128.5649532,24506.9232304,0.541016,0.7651122,2.3561945,1.5302245),(16132,'umzc_hippo_ulna-cleaned.tif',250,4,58,1577.8156437,193.4483998,157.0917974,1.8,195.2632163,156.3918211,-0.3113659,42.6538027,78.7360839,141021.681735,2239116.8746208,24.6812308,28438.2555415,3306.1924833,26840.5423757,43.5614645,129.8280714,0.2742928,532.1390923),(16133,'umzc_hippo_ulna-cleaned.tif',250,4,59,1653.2315064,190.9578167,158.6425905,1.8,193.8450046,157.6314925,-0.3218229,43.2192577,84.9200368,153279.5196553,2410343.9078444,27.5658218,28383.6889158,3546.5560442,27208.0092015,44.9302354,129.5109257,0.2490313,541.9542788),(16134,'umzc_hippo_ulna-cleaned.tif',250,4,60,1658.0682139,190.3594152,159.0233482,1.8,193.319853,158.1000495,-0.3185019,42.3011381,89.0737307,153178.3499708,2405727.8782455,27.0981636,27008.2757142,3621.1401561,26382.7341627,43.9707726,130.348945,0.2731686,567.420482),(16135,'umzc_hippo_ulna-cleaned.tif',250,4,61,1644.2173724,190.3800873,159.0056929,1.8,193.3569263,158.1567088,-0.3092427,40.5770534,89.6987603,150221.9924201,2320475.3417356,25.3815607,25869.647845,3702.1414758,25096.0094524,42.9465984,128.4955829,0.2684677,529.6355854),(16136,'umzc_hippo_ulna-cleaned.tif',250,4,62,1615.1842667,190.8384984,158.8857769,1.8,193.8080862,158.0866453,-0.2990107,40.8897571,80.0012559,146417.0443786,2188419.6154687,23.3594361,27354.8157587,3580.7755944,28648.8836124,42.7153045,126.1867022,0.2824221,557.6821931),(16137,'umzc_hippo_ulna-cleaned.tif',250,4,63,1592.8261916,191.166656,158.8069052,1.8,193.9065362,158.1451566,-0.289363,42.8927169,82.5698532,141977.0551859,2076023.3913083,21.614625,25142.6314833,3310.0504123,23837.6658777,41.6318044,123.3706409,0.266252,533.1986016),(16138,'umzc_hippo_ulna-cleaned.tif',250,4,64,1574.0274173,191.3706176,158.7264303,1.8,194.0986288,158.0207416,-0.2793125,66.1164582,81.150632,138077.2804806,1976957.1091036,19.9396838,24361.5737819,2088.3949972,25201.0777215,42.518154,122.6866475,0.2449787,503.7530419),(16139,'umzc_hippo_ulna-cleaned.tif',250,4,65,1555.4557946,191.6861465,158.6918402,1.8,194.1972924,158.1153536,-0.2671184,67.8068426,81.2507769,135187.6957374,1869270.7590297,18.0617593,23006.1893617,1993.7176049,21988.9286344,41.3397554,119.9543733,0.2646698,505.9171061),(16140,'umzc_hippo_ulna-cleaned.tif',250,4,66,1532.074783,191.9384623,158.6226627,1.8,194.242132,158.0737051,-0.2584772,42.393312,81.456483,130009.5549059,1767577.1143815,16.6832145,21699.6492929,3066.7468264,21313.3599127,42.6537372,117.4453511,0.2561514,526.9464312),(16141,'umzc_hippo_ulna-cleaned.tif',250,4,67,1508.1442081,192.158431,158.5693772,1.8,194.2948488,158.0747392,-0.2480677,45.2292656,79.443291,125953.1308451,1667914.6902131,15.1532347,20995.0351966,2784.7706362,19623.082981,42.1152401,115.339242,0.2415657,499.293641),(16142,'umzc_hippo_ulna-cleaned.tif',250,4,68,1489.8992546,192.1762685,158.5555047,1.8,194.0043232,158.1854646,-0.2389457,36.1519759,81.8303508,121831.9109891,1573581.808968,13.9098629,19229.8064772,3369.9931439,19076.623752,42.1138291,114.0325288,0.2346223,478.2417932),(16143,'umzc_hippo_ulna-cleaned.tif',250,4,69,1473.2538533,192.1552978,158.5379812,1.8,194.0163898,158.1802031,-0.2276649,47.9082949,82.6715577,119013.6526799,1497057.9116705,12.5084113,18108.5001158,2484.1972122,17525.7908543,41.0342925,110.9082902,0.2213144,478.3730657),(16144,'umzc_hippo_ulna-cleaned.tif',250,4,70,1452.6095714,192.0615075,158.550712,1.8,193.795861,158.299,-0.2147722,45.4934654,78.3406129,115456.6384281,1418212.1184026,10.9967916,18103.1532124,2537.8730204,18149.6327503,40.5898634,108.6890337,0.1700586,469.6173884),(16145,'umzc_hippo_ulna-cleaned.tif',250,4,71,1434.2366289,191.9592017,158.5820299,1.8,193.8182814,158.2697714,-0.20161,58.7713264,82.863727,112016.0627142,1347656.2233619,9.5852113,16263.5241192,1905.9645156,15219.5975411,39.7411701,107.7165537,0.1767089,474.3393343),(16146,'umzc_hippo_ulna-cleaned.tif',250,4,72,1416.8216083,191.950449,158.5687364,1.8,193.7233729,158.1912074,-0.1880209,52.5589645,80.3081879,109193.4144965,1281767.8505043,8.2499732,15960.6122784,2077.5412065,14524.5868524,38.8041222,107.1157129,0.1418971,422.9905877),(16147,'umzc_hippo_ulna-cleaned.tif',250,4,73,1399.1000527,192.1061396,158.6439489,1.8,193.3687907,158.297531,-0.1727733,70.4947633,80.4292786,107484.1571172,1207772.3567549,6.891684,15016.5757707,1524.7112279,14015.620469,40.4012118,104.9752389,0.1032584,427.2099664),(16148,'umzc_hippo_ulna-cleaned.tif',250,4,74,1381.7544814,192.1385898,158.6686235,1.8,193.5565684,158.3076346,-0.1576133,42.8925164,78.033449,105479.4279188,1152166.8337179,5.6736993,14765.0379224,2459.1569083,14445.5902559,39.9823248,103.3609712,0.1048769,407.0545033),(16149,'umzc_hippo_ulna-cleaned.tif',250,4,75,1368.6880716,192.0050131,158.714731,1.8,192.9455595,158.2831578,-0.1429325,55.3532134,72.9783956,103373.7435154,1099887.3141259,4.6286657,15071.4099079,1867.52922,13189.1467557,39.5876466,102.7674192,0.1001925,433.471466),(16150,'umzc_hippo_ulna-cleaned.tif',250,4,76,1355.9116105,191.8921458,158.8181628,1.8,192.5846781,158.4622563,-0.1281908,57.5608045,76.72187,101879.1546504,1052393.5271986,3.6932921,13716.9952564,1769.9397274,12074.7486966,40.2554078,100.4164265,0.0809041,380.4612224),(16151,'umzc_hippo_ulna-cleaned.tif',250,4,77,1344.9505002,191.9169212,158.8611407,1.8,192.5316766,158.5574727,-0.1098283,57.0288453,78.2803354,99787.0224316,1010587.6339401,2.6930022,12909.8531505,1749.7640357,11464.7820849,39.3376193,99.2480635,0.1257073,400.222868),(16152,'umzc_hippo_ulna-cleaned.tif',250,4,78,1329.7198076,191.8327742,158.9364526,1.8,192.3111534,158.4997968,-0.0953789,53.1444804,76.8692943,98866.6541758,967903.9529812,2.0100009,12591.5550748,1860.3372044,11548.80078,0.541016,0.7651122,2.3561945,1.5302245),(16153,'umzc_hippo_ulna-cleaned.tif',250,4,79,1321.1401977,191.7630145,159.1074474,1.8,192.1834676,158.7941362,-0.0802411,60.6747376,76.2796056,98520.6571024,931500.1679121,1.4146826,12211.6542277,1623.7508564,10567.7895704,37.6445424,96.5194467,0.0673139,352.5140352),(16154,'umzc_hippo_ulna-cleaned.tif',250,4,80,1320.4398503,191.5939892,159.2686872,1.8,191.8278119,158.9655062,-0.0651357,66.2197367,71.8164298,99639.4749224,906989.29283,0.9323771,12629.2729291,1504.6794177,11642.6568802,38.2995741,95.4046178,0.0624188,370.7998311),(16155,'umzc_hippo_ulna-cleaned.tif',250,4,81,1315.1624101,191.3733297,159.503125,1.8,191.2797738,159.1444452,-0.048408,61.3389915,76.2114394,101086.7122657,872816.6010781,0.5132429,11452.5668103,1648.0008849,10170.4989718,38.559828,94.7766857,3.0959102,358.3180132),(16156,'umzc_hippo_ulna-cleaned.tif',250,4,82,1311.7471523,191.0139723,159.7344628,1.8,190.9650076,159.4040284,-0.0323961,50.0308586,72.0416646,102368.3630093,850739.6512202,0.2293681,11808.9949234,2046.1044624,11741.2128121,40.6216169,94.2129394,3.1013845,361.7722796),(16157,'umzc_hippo_ulna-cleaned.tif',250,4,83,1311.3639835,190.7771973,159.9838675,1.8,190.5768206,159.5670733,-0.0186935,62.9853775,72.7125617,104937.2307838,831275.7130698,0.0763645,11432.3535464,1666.0570258,10065.1800491,40.5932926,94.324717,3.0784583,391.2722141),(16158,'umzc_hippo_ulna-cleaned.tif',250,4,84,1312.0461481,190.3798385,160.2166528,1.8,190.0309282,159.7101354,-0.0052572,67.408717,73.3674092,107500.5276843,816494.6709281,0.0060438,11128.8469906,1594.7570654,9929.3971086,39.4941716,92.8689941,3.0540973,362.3292217),(16159,'umzc_hippo_ulna-cleaned.tif',250,4,85,1313.8713442,189.9164645,160.4567239,1.8,189.5218857,159.854699,0.0079818,66.9006241,72.5417985,110702.2342436,801902.5811481,0.0139505,11054.3520797,1654.7264804,9251.8665074,40.5538775,92.2840813,3.0594251,385.0425665),(16160,'umzc_hippo_ulna-cleaned.tif',250,4,86,1315.3412221,189.4609324,160.6821019,1.8,189.110956,160.0478793,0.0222864,70.100554,72.5246245,114077.4624488,789300.9593855,0.1088671,10883.213326,1627.3403838,9109.4232847,41.7767579,91.3019686,3.0466409,386.3420981),(16161,'umzc_hippo_ulna-cleaned.tif',250,4,87,1317.4669219,188.8754006,160.94207,1.8,188.1716565,160.4742392,0.0392165,64.929661,73.4288659,115938.7024236,774400.7574608,0.3375227,10546.2715226,1785.6046152,9972.2846484,41.8819932,90.5939412,3.0098304,371.1392738),(16162,'umzc_hippo_ulna-cleaned.tif',250,4,88,1318.5638312,188.3011583,161.1736926,1.8,187.7967757,160.6923099,0.0535926,71.8740728,74.1661963,120653.438434,767751.7793622,0.630586,10351.7750319,1678.6781891,8967.9528683,41.9228052,90.3691159,2.985302,409.4492604),(16163,'umzc_hippo_ulna-cleaned.tif',250,4,89,1327.2936043,187.7653223,161.5378647,1.8,187.0460911,161.0245191,0.072473,74.3161728,72.832908,127561.0887001,760335.6525671,1.1598662,10439.4520721,1716.4647199,9118.4039525,43.6013051,90.0105037,2.9724914,400.3222884),(16164,'umzc_hippo_ulna-cleaned.tif',250,4,90,1334.356948,187.0327693,161.8086626,1.8,186.143798,161.2773635,0.0893427,74.1416219,71.6921802,133373.3180526,755570.1150833,1.7704481,10539.0868776,1798.8993862,8997.8852332,44.5784519,89.3872474,2.977439,394.6721057),(16165,'umzc_hippo_ulna-cleaned.tif',250,4,91,1336.6324561,186.4323619,162.0919704,1.8,185.8794474,161.3981761,0.0998029,76.207527,74.6318793,142232.264955,751809.1060666,2.2115921,10073.5652568,1866.3807979,8985.0584052,45.7114994,89.1347544,2.9584818,406.1262665),(16166,'umzc_hippo_ulna-cleaned.tif',250,4,92,1347.74506,185.7515644,162.4504107,1.8,185.2411564,161.7636319,0.1138389,78.3128222,75.3755528,151413.7317078,750941.6315721,2.898419,9962.6683195,1933.4475188,8630.3215117,46.1173076,88.5053313,2.9633794,397.2299875),(16167,'umzc_hippo_ulna-cleaned.tif',250,4,93,1363.5438534,185.0493535,162.804368,1.8,184.5276128,162.161045,0.1259033,78.3049308,77.4157954,162845.2092802,756153.8934776,3.5834058,9767.4368646,2079.6290553,8885.4448093,48.1964929,88.5714492,2.9010584,441.7470988),(16168,'umzc_hippo_ulna-cleaned.tif',250,4,94,1376.7226417,184.3709295,163.2061686,1.8,183.6673228,162.6305031,0.1405364,81.4600056,74.1054929,176660.9511161,755162.5325266,4.5020677,10190.371901,2168.6832662,8820.0322862,49.6900659,88.8123616,2.7542991,426.2592068),(16169,'umzc_hippo_ulna-cleaned.tif',250,4,95,1402.9482379,183.5428853,163.7881404,1.8,182.8806573,163.4455121,0.149326,80.6873591,76.0851493,198610.6927645,760852.7428465,5.1752461,10000.0164334,2461.4846105,9080.1333853,55.8786872,88.6639313,2.8507203,475.4120372),(16170,'umzc_hippo_ulna-cleaned.tif',250,4,96,1433.6046665,182.7946084,164.3813919,1.8,182.7340943,163.8647826,0.1546351,83.2697847,76.1966554,228320.3112529,774866.9668476,5.6680017,10169.3041861,2741.934689,9350.7949771,0.541016,0.7651122,2.3561945,1.5302245),(16171,'umzc_hippo_ulna-cleaned.tif',250,4,97,1444.0732453,182.0696457,164.8094975,1.8,181.665361,164.6185187,0.178748,81.0317092,77.5399237,239821.9387934,779469.3542457,7.6083422,10052.4906015,2959.6060762,10241.2836754,58.8814517,89.3479448,2.7892004,484.6159068),(16172,'umzc_hippo_ulna-cleaned.tif',250,4,98,1451.0701554,181.3441423,165.0454638,1.8,181.1133317,164.7846347,0.1960764,87.673453,80.2337933,248690.078669,788701.8563562,9.179418,9830.0457157,2836.5493784,9436.6585666,59.8140766,89.5361131,2.7835292,497.0977248),(16173,'umzc_hippo_ulna-cleaned.tif',250,4,99,1472.0850999,180.3783933,165.3234123,1.8,179.9922088,165.1007014,0.2133755,89.1691491,78.4313284,260437.7211665,802013.5954117,11.0019496,10225.6790915,2920.7155591,9616.5141146,0.541016,1.2097487,2.677945,2.2953367),(16174,'umzc_hippo_ulna-cleaned.tif',250,4,100,1501.648167,179.4020207,165.5979187,1.8,179.1812451,165.3060842,0.2286223,87.4790976,81.5198513,273668.6569761,826779.8116912,12.8550669,10142.0672225,3128.3891177,10074.7756001,61.0372681,91.2538685,2.7071145,465.2799308),(16175,'umzc_hippo_ulna-cleaned.tif',250,4,101,1542.9789502,178.342121,165.8470047,1.8,178.3964761,165.5671154,0.2416424,91.3232229,85.6955502,288029.9373916,860975.0050521,14.7260298,10046.9044543,3153.9615921,10418.4878531,0.541016,0.7651122,2.3561945,1.5302245),(16176,'umzc_hippo_ulna-cleaned.tif',250,4,102,1586.2656681,177.0668582,166.0479633,1.8,177.4841524,165.6310936,0.246103,87.6323382,82.233459,303073.2948728,897627.4415673,15.6918033,10915.5987427,3458.464092,11117.3605359,61.3968736,92.4631093,2.7067329,466.7557804),(16177,'umzc_hippo_ulna-cleaned.tif',250,4,103,1620.8203955,175.9172446,166.2463559,1.8,176.2524421,165.6147101,0.2569417,93.5625629,86.1562956,318474.0513803,929374.3873283,17.4451465,10787.0745929,3403.861989,10901.3265115,61.0353318,93.3938505,2.6727637,529.9206532),(16178,'umzc_hippo_ulna-cleaned.tif',250,4,104,1662.333716,174.7783869,166.4122739,1.8,175.231504,165.8044948,0.2727693,92.3756832,83.8733982,326307.5449175,966745.9428898,20.1075942,11526.2522279,3532.3965546,12038.2091417,60.9734419,94.0870309,2.6110348,522.7946209),(16179,'umzc_hippo_ulna-cleaned.tif',250,4,105,1702.2050875,173.686734,166.6260094,1.8,174.0244402,166.0161631,0.2882856,95.8695779,86.1454907,339561.3754238,1000520.7199219,22.9320025,11614.3133183,3541.9095707,11797.7388783,62.3907699,96.3327654,2.6503139,556.2063435),(16180,'umzc_hippo_ulna-cleaned.tif',250,4,106,1463.1517683,177.5532505,167.6590847,1.8,178.0761127,166.6738843,0.3323298,94.9197274,80.6411621,320095.5757358,760253.0686673,25.9554901,9427.6055623,3372.2766009,9886.9117912,62.1305593,91.7449013,2.7095967,495.7849997),(16181,'umzc_hippo_ulna-cleaned.tif',250,4,107,1458.7291847,177.2461934,167.9929629,1.8,178.2535213,166.9468468,0.336773,95.4422968,79.0728,326431.3559227,758117.9390212,26.5470873,9587.5944547,3420.19594,10258.129135,62.4660016,91.5724603,2.7281673,456.4155038),(16182,'umzc_hippo_ulna-cleaned.tif',250,4,108,1461.1547672,176.8094704,168.2507426,1.8,177.8333934,166.9014863,0.3446835,97.1064324,81.9352932,333904.4727555,754541.0013373,27.804704,9208.9864094,3438.5412416,9781.2411357,62.0346349,90.3172783,2.7610863,466.5476102),(16183,'umzc_hippo_ulna-cleaned.tif',250,4,109,1358.5269147,178.9142049,169.7931905,1.8,179.5912025,168.0949956,0.2790156,96.0193298,82.059049,333731.0091409,595614.7989246,17.1741251,7258.3682893,3475.664847,8190.5686674,62.4134301,88.6094446,2.7134492,434.5123168),(16184,'umzc_hippo_ulna-cleaned.tif',250,4,110,1360.1208791,178.4468981,169.9173331,1.8,179.2109196,167.952769,0.309635,99.116303,82.7446695,343546.9731695,605892.9586479,21.0475951,7322.4409762,3466.0995493,8283.41546,62.602898,89.7255179,2.7454101,449.8689364),(16185,'umzc_hippo_ulna-cleaned.tif',250,4,111,1424.5994022,176.7328511,169.8031863,1.8,177.6665694,168.0347563,0.3314858,98.8467986,83.6457147,354683.2235281,668303.8432948,25.1481217,7989.6961352,3588.2115412,9058.3202546,64.9808173,87.651279,2.6392903,469.5536843),(16186,'umzc_hippo_ulna-cleaned.tif',250,4,112,1370.542094,177.7313665,171.0583362,1.8,178.0052095,168.778074,0.2598674,96.9662632,84.5077243,364975.1636382,580055.3228085,15.0815727,6863.9325858,3763.9396599,8325.0177717,65.1646047,86.4170476,2.7087476,463.3558888),(16187,'umzc_hippo_ulna-cleaned.tif',250,4,113,1405.8168593,176.5612691,170.823088,1.8,176.7328021,168.5966367,0.3926318,103.9846797,79.787133,369986.5238418,631352.6646685,34.3017044,7912.9634187,3558.0868733,8702.8476891,65.9236917,89.1347544,2.5636907,482.3524222),(16188,'umzc_hippo_ulna-cleaned.tif',250,4,114,1393.0339234,176.4268557,171.2557373,1.8,176.8363006,168.8525116,0.3824533,105.6372403,77.3260004,379322.0058498,618578.5432443,32.3361407,7999.6190162,3590.7981373,8533.1371572,67.3532035,88.6490746,2.6315303,501.1951602),(16189,'umzc_hippo_ulna-cleaned.tif',250,4,115,1395.2843304,175.9603637,171.6587318,1.8,176.4763266,169.145041,0.3937722,105.1274834,82.4559674,393597.1376717,617587.6357719,34.2324222,7489.9083104,3743.9984768,8742.317732,69.9264759,90.135612,2.5052943,466.1312699),(16190,'umzc_hippo_ulna-cleaned.tif',250,4,116,1277.0804013,177.3897267,169.93023,1.8,177.6927339,167.3816321,0.5120755,106.7200087,76.9011828,290318.918398,609066.4636344,51.1019074,7920.118279,2720.3794492,7978.9752439,66.6429253,90.7827511,2.5469786,494.6804448),(16191,'umzc_hippo_ulna-cleaned.tif',250,4,117,1262.8102029,177.3663779,170.1275472,1.8,177.7893532,167.4483007,0.5226495,106.9542111,89.6793068,286574.887818,602628.4616945,52.4441578,6719.8162337,2679.4165929,7839.6281306,66.6269464,90.6327035,2.5602125,487.192447),(16192,'umzc_hippo_ulna-cleaned.tif',250,4,118,1253.6522032,177.3112202,170.3655251,1.8,177.6444927,167.4831709,0.5407937,110.173182,77.4308926,288266.701542,596269.2275622,55.3771944,7700.6632353,2616.4870289,7664.7835195,66.2303803,90.1956672,2.5352893,466.3169173),(16193,'umzc_hippo_ulna-cleaned.tif',250,4,119,1252.4046873,176.8999219,169.9274662,1.8,177.23303,166.1972723,0.5501225,110.5826104,88.7943668,285869.845946,633177.800623,57.0493467,7130.8329953,2585.1247756,7998.6378698,62.0134187,91.5708621,2.5240904,472.1977929),(16194,'umzc_hippo_ulna-cleaned.tif',250,4,120,1244.6973184,176.8400295,169.9645369,1.8,177.4036473,165.5657762,0.5722351,111.1472333,87.8709379,291095.2359531,637180.6560618,60.8316238,7251.3241738,2619.0056865,8071.774788,61.9668253,90.5583945,2.5950257,478.5812358),(16195,'umzc_hippo_ulna-cleaned.tif',250,4,121,1223.888682,176.7199187,170.3536249,1.8,176.7591526,166.2354228,0.5905341,111.461458,87.8000057,274398.4371405,629282.8198109,63.2406724,7167.229828,2461.8235051,7856.1356903,61.5006701,91.393289,2.5371712,569.7795228),(16196,'umzc_hippo_ulna-cleaned.tif',250,4,122,1202.5998429,176.8196199,170.7641164,1.8,177.0050985,167.0984316,0.5760084,112.0751795,90.1188898,266172.0519555,611253.5980591,59.463968,6782.7466503,2374.9420087,7561.745447,61.0894512,91.0869249,2.5420584,483.0724888),(16197,'umzc_hippo_ulna-cleaned.tif',250,4,123,1181.3581016,177.0612599,171.1802033,1.8,177.6936174,167.7724682,0.5551804,110.7990439,84.7156134,263593.7060524,595299.0041769,54.7029608,7027.0281961,2379.0250951,7473.218312,61.1601982,90.5826324,2.478978,470.536296),(16198,'umzc_hippo_ulna-cleaned.tif',250,4,124,1163.3257535,177.0544187,171.6951177,1.8,177.6759159,168.795615,0.5570287,110.3168914,84.9473177,255140.7553031,579427.3510049,54.1892976,6821.0199784,2312.7986294,7257.4181152,60.3532579,91.0097707,2.482635,474.4706068),(16199,'umzc_hippo_ulna-cleaned.tif',250,4,125,1144.608846,177.1396596,172.0626704,1.8,178.029962,169.1714184,0.5494699,112.8230076,76.1593678,251400.7502975,566206.8603619,52.028134,7434.5005299,2228.2755584,6989.7604429,59.9505083,89.921034,2.5836311,531.754604),(16200,'umzc_hippo_ulna-cleaned.tif',250,4,126,1151.9646221,177.3134062,173.474926,1.8,177.3915445,169.9423723,0.5002748,110.2098436,79.2776429,258212.6305417,484830.0548569,44.1740326,6115.5962372,2342.9180378,6385.6783067,59.1693032,89.5687977,2.4545882,453.0699871),(16201,'umzc_hippo_ulna-cleaned.tif',250,4,127,1094.2846838,177.2530944,171.6066592,1.8,177.0521104,168.0801026,0.5630769,112.2089699,90.2551729,208443.2902474,536640.9697633,51.9661994,5945.81953,1857.6348263,6407.9471351,57.3222414,90.8294894,2.4659215,510.8021766),(16202,'umzc_hippo_ulna-cleaned.tif',250,4,128,1086.2443484,177.197243,171.7231157,1.8,177.062145,167.4663135,0.5740717,113.8196558,95.3371925,212750.2635664,530071.6151283,53.3905886,5559.9666943,1869.187374,6322.4163767,56.8339283,91.1302954,2.520653,518.6614691),(16203,'umzc_hippo_ulna-cleaned.tif',250,4,129,1091.840475,176.6681591,172.2894905,1.8,176.37934,167.9583196,0.5923651,115.0988968,93.0894253,214297.9740136,533401.4024261,56.7259378,5729.989206,1861.8594961,6322.3348432,56.1861429,89.9991216,2.4029689,461.8349936),(16204,'umzc_hippo_ulna-cleaned.tif',250,4,130,1068.7413409,176.6977194,172.811464,1.8,176.4492744,169.1290886,0.576203,114.6126231,90.8197583,203477.5003359,505809.4445444,52.8768635,5569.3766894,1775.3498244,5999.2868836,55.7033426,90.4079746,2.4621788,476.634671),(16205,'umzc_hippo_ulna-cleaned.tif',250,4,131,1051.5202107,176.6387205,173.2030123,1.8,176.6080186,169.9605948,0.5524314,111.0625076,86.5610279,195054.7782696,484721.4178853,48.2597787,5599.7650379,1756.2612483,5929.0852562,55.2191687,89.9356806,2.518546,413.5466958),(16206,'umzc_hippo_ulna-cleaned.tif',250,4,132,1156.0421764,175.1425824,175.8373016,1.8,176.0019708,172.2788272,0.4393922,113.2437703,82.7563891,272367.1776317,459522.9602595,34.8655024,5552.7188357,2405.1404944,6028.2164346,60.6010542,85.8444335,2.467836,430.2478925),(16207,'umzc_hippo_ulna-cleaned.tif',250,4,133,1109.1684844,174.9883761,174.359246,1.8,175.6462583,171.3248028,0.4635389,112.0467312,80.8482616,215880.6791461,485977.3015156,36.9562018,6010.9802246,1926.7021617,5858.4689448,57.3655491,87.9862437,2.5177692,396.2885571),(16208,'umzc_hippo_ulna-cleaned.tif',250,4,134,1092.7948491,174.7856959,174.54906,1.8,174.9539218,171.2198086,0.4796017,113.4345054,83.4265021,203974.7470048,470954.0988641,38.7785199,5645.137778,1798.1719607,5624.5337086,56.1202151,86.6048245,2.5293314,392.2773486),(16209,'umzc_hippo_ulna-cleaned.tif',250,4,135,1072.0380114,175.0680081,175.4244311,1.8,174.7683026,171.5865736,0.5409386,116.2254472,88.6900411,220152.1763147,443514.7328107,47.377656,5000.7275605,1894.1822266,5509.2328878,59.7263228,91.3820791,2.5585161,440.5881691),(16210,'umzc_hippo_ulna-cleaned.tif',250,4,136,1173.0114085,172.8387081,176.2465176,1.8,172.9716389,171.5103467,0.5231676,118.2856082,89.1909789,272841.181935,487514.8280999,48.8024865,5465.9656624,2306.6304189,6143.7066739,61.6703209,90.7827511,2.5469786,415.5476355),(16211,'umzc_hippo_ulna-cleaned.tif',250,4,137,1149.7108447,172.8121551,176.4728364,1.8,172.6741072,171.7977136,0.5055253,117.5738006,85.0575345,255543.1112171,470311.7981072,44.9373371,5529.3372986,2173.4698536,5875.4555508,61.5830936,91.3276116,2.5075699,460.884234),(16212,'umzc_hippo_ulna-cleaned.tif',250,4,138,1151.1641364,171.7239192,175.491349,1.8,171.7252134,171.8619179,0.5009461,115.8968303,81.7378156,215494.1720381,521262.2784968,44.2517945,6377.247483,1859.3620855,5990.659682,59.9799781,91.393289,2.5371712,455.3971758),(16213,'umzc_hippo_ulna-cleaned.tif',250,4,139,1130.1823645,171.5876864,175.6594943,1.8,171.5746409,172.446531,0.4921825,116.663438,81.4548552,203652.0003064,501892.5969347,42.0623538,6161.6044342,1745.6368834,5710.1912234,59.7685863,90.0430161,2.5702552,455.5284483),(16214,'umzc_hippo_ulna-cleaned.tif',250,4,140,1110.1222376,171.5753375,175.7717697,1.8,171.6851686,172.5931631,0.4735049,113.5374557,82.0735667,198509.1392851,488364.9649585,38.4738137,5950.3319331,1748.402217,5721.5076426,57.3258425,88.5483135,2.4687601,418.7168341),(16215,'umzc_hippo_ulna-cleaned.tif',250,4,141,1117.9339135,171.1291598,176.3192756,1.8,171.1970934,173.3073872,0.4708934,115.6157671,82.8095346,201757.0421114,475651.9137571,38.3503324,5743.9269066,1745.0651161,5463.8821074,56.5726526,89.1347544,2.5636907,398.561371),(16216,'umzc_hippo_ulna-cleaned.tif',250,4,142,1102.0575993,171.1488177,176.3775346,1.8,171.4138081,173.3247353,0.457139,114.8175648,83.0661353,194220.9438727,465742.8304358,35.7835675,5606.8917739,1691.5612544,5395.1847835,59.0072683,87.9379943,2.539939,407.1314009),(16217,'umzc_hippo_ulna-cleaned.tif',250,4,143,1087.3897746,171.0313968,176.430185,1.8,171.0223939,173.201571,0.4630449,115.8892744,79.0576092,185520.3635325,452344.8851415,36.1589744,5721.7121766,1600.841531,5155.5561083,56.8065768,86.7668985,2.5829933,429.7453253),(16218,'umzc_hippo_ulna-cleaned.tif',250,4,144,1070.1800864,171.011928,176.3459434,1.8,171.2528028,172.5178487,0.4527138,114.3716435,83.3829699,186374.7699028,447846.4359461,34.1254285,5370.9580801,1629.5540072,5126.0797658,55.2678379,85.3948892,2.5729198,393.0424608),(16219,'umzc_hippo_ulna-cleaned.tif',250,4,145,1056.9693674,170.928445,176.5260458,1.8,170.6713503,172.7410549,0.4711623,111.3007841,84.1114179,168902.3213581,434652.7656879,36.2972877,5167.5833848,1517.5303816,5040.9988595,52.9828054,87.029625,2.5553142,375.8161741),(16220,'umzc_hippo_ulna-cleaned.tif',250,4,146,1039.2876364,170.8865439,176.6700043,1.8,170.8451534,173.1881086,0.4492823,115.7997764,83.940128,164963.0041529,421533.5251269,32.67401,5021.835622,1424.5537369,4716.3022324,54.846992,85.023904,2.6295498,422.6736678),(16221,'umzc_hippo_ulna-cleaned.tif',250,4,147,1068.7947361,169.9736473,177.5100504,1.8,169.9845713,174.0770102,0.4188697,115.7320173,84.9547344,175571.5997225,411289.1706551,29.4680519,4841.2742798,1517.052963,4660.2780271,54.7682443,84.5526912,2.6264148,384.8118736),(16222,'umzc_hippo_ulna-cleaned.tif',250,4,148,1051.2991791,170.042468,177.6188851,1.8,170.2579448,174.2112402,0.3922375,114.4433995,87.3074558,173041.0995943,399963.0134986,25.6027007,4581.0865725,1512.0234138,4546.9794259,54.9219826,84.6478352,2.5748634,391.358441),(16223,'umzc_hippo_ulna-cleaned.tif',250,4,149,1028.2038589,170.1150247,177.819142,1.8,169.9950806,174.5979939,0.3918145,112.8718699,86.9714371,160298.665379,383491.3074607,24.9890665,4409.3937058,1420.182597,4349.828178,53.919624,83.3270103,2.5878109,402.9663971),(16224,'umzc_hippo_ulna-cleaned.tif',250,4,150,1038.2419937,170.113607,179.8517988,1.8,170.7101599,176.6253764,0.124027,97.6130227,92.6150499,156946.8451763,335418.0345219,2.6482046,3621.6363842,1607.8474037,3873.597961,53.3867557,76.826184,2.5516369,372.7013503),(16225,'umzc_hippo_ulna-cleaned.tif',250,4,151,1031.7998801,170.0000449,179.8213253,1.8,170.7471238,176.289258,0.1129331,97.7619845,91.4540504,156257.7179383,331750.0238513,2.1839334,3627.5049869,1598.3484661,3815.3388703,52.2984678,74.8970239,2.5776335,370.1209458),(16226,'umzc_hippo_ulna-cleaned.tif',250,4,152,1025.0115841,169.7083867,179.8100555,1.8,170.1559515,176.3961437,0.1519855,96.8389555,91.4662882,147487.1609768,323441.8733709,3.9159329,3536.1867173,1523.0147845,3850.1768336,50.1927099,73.8640477,2.5860989,344.5009473),(16227,'umzc_hippo_ulna-cleaned.tif',250,4,153,1016.270103,169.4823756,179.8961191,1.8,169.7837562,176.3981953,0.1567888,101.0991698,92.5425434,140820.2383542,316924.302723,4.129775,3424.6335894,1392.892134,3611.5831087,53.6175058,71.4673806,2.6271413,364.7651602),(16228,'umzc_hippo_ulna-cleaned.tif',250,4,154,1029.7014989,168.7724057,179.7454892,1.8,169.3901401,176.485566,0.1886942,102.8384326,92.0360593,133091.8829364,331439.8922748,6.0383284,3601.1960409,1294.1842804,3675.4756688,48.2997278,73.2132855,2.6151139,315.1866602),(16229,'umzc_hippo_ulna-cleaned.tif',250,4,155,1032.0127516,168.4441486,180.0320032,1.8,168.6829892,176.850497,0.1653063,99.116671,92.1545583,134393.2435048,329980.7971596,4.6575008,3580.7322319,1355.9095772,3667.7517409,52.6563118,73.8343218,2.6451699,406.9776056),(16230,'umzc_hippo_ulna-cleaned.tif',250,4,156,1048.7717731,167.6963224,180.5794307,1.8,167.8597573,177.6953959,0.0965841,94.2680188,92.9977757,133384.6017572,339798.7425916,1.6255113,3653.8373091,1414.9507268,3757.6698425,51.722902,72.3466114,2.6679119,438.8497745),(16231,'umzc_hippo_ulna-cleaned.tif',250,4,157,1029.6632707,167.8462445,180.7351453,1.8,167.6149382,178.1987882,0.1136656,98.9131973,93.7188094,123971.5553768,321342.7465252,2.2076534,3428.796723,1253.3368524,3433.8542735,49.7441314,72.5143168,2.5204759,414.3887057),(16232,'umzc_hippo_ulna-cleaned.tif',250,4,158,1005.4936588,168.1437942,180.7815474,1.8,168.1858434,178.3351573,0.115989,97.4811821,94.49313,117557.5927362,315484.4573615,2.2444656,3338.7025832,1205.9516536,3457.4703239,48.9836982,72.1156333,2.6578135,429.854075),(16233,'umzc_hippo_ulna-cleaned.tif',250,4,159,982.3821958,168.4253972,180.8693619,1.8,168.3478953,178.6451066,0.1319272,100.3427337,93.9875936,110400.1232456,301195.8379072,2.8331983,3204.6339974,1100.230372,3201.3320999,48.479937,66.8061725,2.7069224,410.8031668),(16234,'umzc_hippo_ulna-cleaned.tif',250,4,160,959.2482926,168.7466795,180.900695,1.8,168.5610408,178.5863609,0.1517112,91.1996929,92.0561432,105578.4634555,291771.1659775,3.6515775,3169.4915295,1157.662489,3280.7554832,47.4727741,67.5078778,2.6671928,369.8490715),(16235,'umzc_hippo_ulna-cleaned.tif',250,4,161,939.3681308,168.9867284,180.9644431,1.8,168.5274355,178.4935658,0.173185,96.6153614,92.3763577,101588.8646282,280144.7507482,4.6489885,3032.6455571,1051.4773551,3079.3926142,0.541016,0.7651122,2.3561945,1.5302245),(16236,'umzc_hippo_ulna-cleaned.tif',250,4,162,925.3479678,169.0664312,181.0651663,1.8,168.3415026,178.7930174,0.1925055,64.1471854,91.8699398,94468.2143775,270971.8355375,5.6450609,2949.5157621,1472.6790229,3522.377686,47.6540279,65.8174431,2.6632402,360.7764744),(16237,'umzc_hippo_ulna-cleaned.tif',250,4,163,912.2208009,169.203592,181.1188665,1.8,168.6320095,178.8715502,0.1960113,104.956289,91.0107449,93494.8239804,268242.6661986,5.7668954,2947.3735927,890.7977299,2856.5033654,47.3168587,66.0682279,2.6559706,344.1746982),(16238,'umzc_hippo_ulna-cleaned.tif',250,4,164,905.632072,169.162888,181.1799689,1.8,168.493552,178.9548336,0.2133923,106.3990042,84.9673607,91307.6855473,264441.3861329,6.7694878,3112.2702181,858.1629708,2765.0226294,47.3550747,66.8455927,2.4478906,360.5139294),(16239,'umzc_hippo_ulna-cleaned.tif',250,4,165,897.9233727,169.1177916,181.2662298,1.8,168.3313964,179.153928,0.2326301,106.119043,90.9363382,89079.0213183,263115.9618885,7.9537409,2893.4083687,839.4254109,2837.5509554,46.9774721,67.5078778,2.6671928,377.4007734),(16240,'umzc_hippo_ulna-cleaned.tif',250,4,166,892.9429769,169.0765617,181.3412771,1.8,168.4442429,179.1698592,0.2419696,105.481827,87.8646229,89591.9202067,264475.1914555,8.5447941,3010.0304628,849.3588206,2898.480859,0.541016,0.7651122,2.3561945,1.5302245),(16241,'umzc_hippo_ulna-cleaned.tif',250,4,167,892.127945,168.9737328,181.4391798,1.8,168.3618515,179.364436,0.2571444,103.4811751,89.1418836,88666.6715467,266536.0783702,9.616934,2990.0207116,856.838661,2851.0016098,46.1414124,68.9662849,2.660403,396.3654548),(16242,'umzc_hippo_ulna-cleaned.tif',250,4,168,889.5617786,168.8509093,181.4384324,1.8,167.9483879,179.1078206,0.2809337,107.644115,89.5094704,88659.4789619,267608.0050108,11.3966393,2989.7172209,823.6351704,2889.7549599,46.0203557,69.4547462,2.6988479,389.6425692),(16243,'umzc_hippo_ulna-cleaned.tif',250,4,169,887.7306399,168.7636722,181.5068756,1.8,167.7640326,178.9950131,0.2980071,111.0913338,89.9818106,87852.4040077,268524.4459703,12.7552394,2984.2080761,790.8123975,2818.0346796,45.1037845,70.6994342,2.7155985,394.2332426),(16244,'umzc_hippo_ulna-cleaned.tif',250,4,170,882.6227873,168.6094609,181.5623718,1.8,167.6812438,179.385792,0.3051645,107.9513699,84.4771109,84689.8319157,270403.1599184,13.2790953,3200.9044448,784.5183625,2825.7994947,46.1857811,70.9247074,2.7086521,386.8221425),(16245,'umzc_hippo_ulna-cleaned.tif',250,4,171,880.5821475,168.2475137,181.3832894,1.8,166.6386222,178.7229404,0.3364514,94.439999,88.4623437,83873.3160171,278578.6777012,15.996086,3149.1216043,888.1122075,3242.0707268,46.2566837,72.5950004,2.4459002,364.9958531),(16246,'umzc_hippo_ulna-cleaned.tif',250,4,172,882.1727414,167.915058,181.2002119,1.8,166.2830566,178.4385785,0.3518027,111.0020731,86.0114708,83827.1194572,289115.3648021,17.4585991,3361.358223,755.1851702,2982.2859993,44.0696534,73.7629306,2.602431,404.7816893),(16247,'umzc_hippo_ulna-cleaned.tif',250,4,173,883.1776724,167.6505669,181.1163889,1.8,166.0586922,178.543746,0.3640187,109.5943276,85.8335375,82874.8395756,295024.9788976,18.6584748,3437.1760434,756.1964326,3095.8335664,43.4759202,83.7649404,2.6432769,389.665092),(16248,'umzc_hippo_ulna-cleaned.tif',250,4,174,870.86332,167.9661376,181.4338363,1.8,166.6998494,179.2167987,0.3431213,109.6452304,89.1482614,80242.3466089,284381.6903054,16.4279418,3189.9858263,731.8361805,2929.0757536,43.0795459,74.2848726,2.6649165,373.9690298),(16249,'umzc_hippo_ulna-cleaned.tif',250,4,175,869.7095563,167.8721204,181.481267,1.8,166.4386876,179.2987357,0.3543012,112.2512388,86.4810017,77600.0031869,283193.9353056,17.4469411,3274.6375468,691.3064305,2872.2988171,43.2736007,74.1507843,2.5798998,420.3014335),(16250,'umzc_hippo_ulna-cleaned.tif',250,4,176,868.9653928,167.7592754,181.4704751,1.8,166.2169304,179.1152411,0.3615833,110.6644663,86.4087786,78797.5069885,286673.6198256,18.1241549,3317.6446251,712.0398229,2942.1033991,42.4740084,74.0401762,2.6877487,425.1865039),(16251,'umzc_hippo_ulna-cleaned.tif',250,4,177,875.8385714,167.4228459,181.2920372,1.8,165.5434347,178.5368872,0.3802388,115.1744375,86.7620762,78896.2337575,298018.4904143,20.1072942,3434.893486,685.0151431,2997.9302612,0.541016,0.7651122,2.3561945,1.5302245),(16252,'umzc_hippo_ulna-cleaned.tif',250,4,178,872.1802853,167.4085495,181.3818328,1.8,165.6021504,178.6835579,0.3732109,109.3433504,86.026981,77270.5229024,296912.0347625,19.3243713,3451.3827113,706.6778419,3009.7871884,43.3815927,79.6047714,2.6688268,413.6010707),(16253,'umzc_hippo_ulna-cleaned.tif',250,4,179,865.2300295,167.3745034,181.4084498,1.8,165.5367752,178.7466296,0.3737528,84.425263,85.789947,75472.8042476,297219.064493,19.2234735,3464.4975873,893.9599544,3445.8878671,45.0466488,78.7972743,2.5764432,409.612385),(16254,'umzc_hippo_ulna-cleaned.tif',250,4,180,857.7263965,167.3256571,181.4761818,1.8,165.2421241,178.8357012,0.3770584,111.8040539,84.8955954,73382.2440624,292613.3884931,19.3791488,3446.7440509,656.3468991,2978.3952086,44.3032416,79.8800625,2.6476513,417.4266319),(16255,'umzc_hippo_ulna-cleaned.tif',250,4,181,852.4203073,167.3799301,181.5140591,1.8,165.4243299,178.8112904,0.3712352,116.620068,87.5716141,73696.9958715,292204.1426011,18.6963838,3336.7449662,631.9409441,2844.5136394,42.9623633,79.5440795,2.5743418,397.2936916),(16256,'umzc_hippo_ulna-cleaned.tif',250,4,182,848.4632914,167.433013,181.6114512,1.8,165.5269354,179.1276306,0.3670028,90.9784517,87.7264561,71587.3324694,291629.7278299,18.2068074,3324.307636,786.8603078,3218.7152557,43.7726283,82.086595,2.5389659,435.9524501),(16257,'umzc_hippo_ulna-cleaned.tif',250,4,183,845.5336469,167.4710574,181.661763,1.8,165.4911865,179.2567343,0.3676524,81.2271838,88.3485008,70095.3701417,289882.4612693,18.2052992,3281.1248497,862.9545788,3451.1858486,41.7206747,77.7201144,2.6405793,416.4758723),(16258,'umzc_hippo_ulna-cleaned.tif',250,4,184,842.3099735,167.5217903,181.7158978,1.8,165.5139323,179.2484616,0.3690862,77.4237894,87.0585566,69923.5696685,290333.9560841,18.271134,3334.9272885,903.1277106,3603.5197293,41.4918468,77.6843286,2.6561416,444.9031039),(16259,'umzc_hippo_ulna-cleaned.tif',250,4,185,839.7775118,167.5541702,181.7327294,1.8,165.2941126,178.7922568,0.3722753,114.8008966,87.4625434,72085.968735,291405.306215,18.5176146,3331.7726075,627.9216528,2858.75875,0.541016,0.7651122,2.3561945,1.5302245),(16260,'umzc_hippo_ulna-cleaned.tif',250,4,186,835.2303983,167.6565253,181.8319659,1.8,165.562211,178.9473339,0.3644716,114.4270766,88.3490869,71005.2638265,288600.2642277,17.6874809,3266.5902306,620.5285144,2828.3447703,42.944979,79.4336118,2.5158009,393.1512105),(16261,'umzc_hippo_ulna-cleaned.tif',250,4,187,828.2617824,167.8169797,182.0839364,1.8,165.7513599,179.6704124,0.3537232,110.0000606,87.733444,68305.5244201,277894.4989648,16.5635818,3167.4864941,620.9589709,2766.9544694,0.541016,0.7651122,2.3561945,1.5302245),(16262,'umzc_hippo_ulna-cleaned.tif',250,4,188,823.5697389,167.860799,182.1405588,1.8,165.8674015,179.8035772,0.351599,73.3921652,87.7445548,66943.5694671,276961.6490565,16.2807369,3156.4539766,912.1350933,3279.0669964,0.541016,1.2097487,2.677945,2.2953367),(16263,'umzc_hippo_ulna-cleaned.tif',250,4,189,819.8507844,167.9082804,182.1845082,1.8,165.8102691,179.8061666,0.351945,112.5477211,86.1295,66813.8631942,275316.7243826,16.2378017,3196.5438605,593.6491875,2677.7801642,43.3715879,73.7728502,2.4496713,391.9922808),(16264,'umzc_hippo_ulna-cleaned.tif',250,4,190,815.7539829,167.9112158,182.2097416,1.8,165.9306686,179.975993,0.3501539,107.1458668,86.0119558,66044.6327395,275719.7207992,15.9993912,3205.5976213,616.3992576,2779.7013912,0.541016,1.2097487,2.677945,2.2953367),(16265,'umzc_hippo_ulna-cleaned.tif',250,4,191,812.3600123,168.0178896,182.2133908,1.8,166.2082674,179.9684263,0.347783,98.9715088,85.9070272,65687.995565,276346.5449967,15.7265357,3216.809544,663.7061147,2925.9701282,0.541016,0.7651122,2.3561945,1.5302245),(16266,'umzc_hippo_ulna-cleaned.tif',250,4,192,812.38671,168.0549438,182.2073099,1.8,166.2028849,179.9325314,0.3490723,115.2100766,87.6242182,66952.3962986,276206.1096845,15.839094,3152.1663215,581.1331637,2650.8082808,41.7098081,72.9248697,2.5515324,423.4481093),(16267,'umzc_hippo_ulna-cleaned.tif',250,4,193,813.0994748,168.1284434,182.2803385,1.8,166.2948915,179.704337,0.3529608,103.4315666,88.7350627,68277.0403422,280324.9430727,16.1932813,3159.1226126,660.1180141,2893.5276832,42.2870868,74.0243616,2.5170951,395.6640466),(16268,'umzc_hippo_ulna-cleaned.tif',250,4,194,811.9069507,168.1584305,182.4254067,1.8,166.1786658,180.0787443,0.3560326,108.2515126,86.3316871,67064.486039,278178.8234869,16.4401618,3222.209976,619.5247014,2811.4705667,43.2016599,74.3419838,2.5111912,410.0699066),(16269,'umzc_hippo_ulna-cleaned.tif',250,4,195,810.5725123,168.1879279,182.4895232,1.8,165.9310914,180.1053447,0.3623824,113.0113784,83.5801542,66540.1977097,276338.4501028,16.9777554,3306.2687298,588.7920194,2724.0002667,41.8268194,72.3749263,2.5909171,392.3635755),(16270,'umzc_hippo_ulna-cleaned.tif',250,4,196,808.942892,168.3581913,182.557477,1.8,166.4253237,180.2587652,0.3605012,84.4539469,84.2971881,66465.2326182,278609.7095424,16.775829,3305.0890042,786.9997209,3202.40493,41.2421997,73.4706967,2.5025098,375.7392765),(16271,'umzc_hippo_ulna-cleaned.tif',250,4,197,817.0250921,168.1366759,182.4880273,1.8,166.1857407,180.4174119,0.3700079,114.470156,84.1001535,67113.4953113,286940.1314797,17.8072082,3411.8859435,586.2968798,2799.2579976,41.9329949,73.0371667,2.4980915,397.3255436),(16272,'umzc_hippo_ulna-cleaned.tif',250,4,198,815.05674,168.2883344,182.5212731,1.8,166.5526982,180.4518954,0.3680331,111.6643752,86.7944711,67716.3426874,289731.8713317,17.5838049,3338.137413,606.4274535,2830.7276696,41.7894293,73.7093418,2.5230497,402.0156375),(16273,'umzc_hippo_ulna-cleaned.tif',250,4,199,816.6289737,168.3914919,182.5385292,1.8,166.6134964,180.3592958,0.3715508,115.7973497,83.8618415,68638.0310751,290585.522822,17.9404105,3465.0505826,592.7426771,2800.4299339,42.3883069,72.6252336,2.5577223,396.112239),(16274,'umzc_hippo_ulna-cleaned.tif',250,4,200,810.148277,168.4988215,182.6396054,1.8,166.6753945,180.699619,0.3689956,117.0637287,84.0615018,68163.8684989,288598.7153428,17.5652575,3433.1853349,582.2800048,2790.981141,41.686506,73.0371667,2.4980915,392.1779281),(16275,'umzc_hippo_ulna-cleaned.tif',250,4,201,800.8863251,168.6122444,182.6431727,1.8,166.6494546,180.4666944,0.369767,115.8299263,84.8351759,67908.6639568,287335.7557339,17.4337849,3386.9883884,586.2790914,2780.2399536,0.541016,0.7651122,2.3561945,1.5302245),(16276,'umzc_hippo_ulna-cleaned.tif',250,4,202,790.0127582,168.7320943,182.6970568,1.8,166.8021903,180.7698802,0.368304,113.8542273,82.4193209,65777.8254202,284281.9890042,17.0674665,3449.2153764,577.7372259,2782.1981044,0.541016,0.7651122,2.3561945,1.5302245),(16277,'umzc_hippo_ulna-cleaned.tif',250,4,203,784.8436163,168.8032284,182.6793281,1.8,166.7626836,180.6310235,0.3688721,106.7649109,81.5551697,66382.1114119,284612.5838052,17.0057444,3489.8165856,621.7596291,2991.8468853,0.541016,0.7651122,2.3561945,1.5302245),(16278,'umzc_hippo_ulna-cleaned.tif',250,4,204,778.4605745,168.9397743,182.7383711,1.8,167.0967682,180.8080722,0.3682982,114.2072521,85.2833944,66496.7487722,284413.3547939,16.8173875,3334.9206685,582.2462897,2773.85499,42.1585195,73.5324209,2.5393053,378.2202605),(16279,'umzc_hippo_ulna-cleaned.tif',250,4,205,775.0138295,169.115815,182.8009257,1.8,167.237754,181.0055236,0.3739507,99.1490945,83.2962038,65608.3719406,283905.6424201,17.2364567,3408.3863322,661.7142824,3129.4107945,40.6675832,74.2277175,2.501007,340.5347844),(16280,'umzc_hippo_ulna-cleaned.tif',250,4,206,771.3598009,169.3529882,182.8684165,1.8,167.680512,181.1135237,0.3657147,105.6445469,85.6490917,66300.3278869,287465.7978232,16.4415059,3356.3204475,627.5792727,2935.1967946,42.0082053,72.6433675,2.5308667,365.8471923),(16281,'umzc_hippo_ulna-cleaned.tif',250,4,207,769.8510738,169.4418665,182.8511877,1.8,167.6478124,181.1934144,0.3724601,116.150221,85.3141848,66705.90645,288114.9468102,16.9917664,3377.1048433,574.3071849,2760.4681067,0.541016,0.7651122,2.3561945,1.5302245),(16282,'umzc_hippo_ulna-cleaned.tif',250,4,208,770.4300844,169.523979,182.8517557,1.8,167.7733678,181.3135618,0.3754883,96.0618393,85.6237888,66509.0692898,291669.7385357,17.2690105,3406.4100933,692.3568173,3150.6863496,41.4842835,73.9788757,2.5434484,359.4093745),(16283,'umzc_hippo_ulna-cleaned.tif',250,4,209,767.7854216,169.6287585,182.8475362,1.8,167.7476526,181.0747287,0.3803038,69.1030911,83.0284131,67125.801121,294855.9850087,17.6323678,3551.266056,971.3863746,3754.026048,0.541016,0.7651122,2.3561945,1.5302245),(16284,'umzc_hippo_ulna-cleaned.tif',250,4,210,763.3347212,169.6913488,182.8513042,1.8,167.8876883,181.1187821,0.3796636,109.4186011,84.7035216,67462.6970472,295823.3063226,17.474042,3492.4558106,616.5560185,2979.2706877,0.541016,0.7651122,2.3561945,1.5302245),(16285,'umzc_hippo_ulna-cleaned.tif',250,4,211,761.5106782,169.7141724,182.845638,1.8,167.7782779,181.0412602,0.3839663,78.8337109,84.5082504,68389.5966476,298274.9949623,17.8099422,3529.5369817,867.5171556,3584.3681473,42.6572176,76.499746,2.4966771,377.5864208),(16286,'umzc_hippo_ulna-cleaned.tif',250,4,212,762.8130086,169.8307337,182.8964232,1.8,168.1871985,181.2051473,0.382463,78.2430062,85.3543383,68819.0840159,301861.6737399,17.7078365,3536.5709561,879.5557243,3569.1459426,0.541016,0.7651122,2.3561945,1.5302245),(16287,'umzc_hippo_ulna-cleaned.tif',250,4,213,765.2095873,169.9008505,182.9434401,1.8,168.1866496,181.3858782,0.3825589,114.4903574,82.7466658,70834.9981239,304581.0731822,17.7719422,3680.8863561,618.6983752,2977.9261179,42.115427,76.3005275,2.4768182,386.0026554),(16288,'umzc_hippo_ulna-cleaned.tif',250,4,214,768.6787725,170.0058314,183.0064822,1.8,168.455487,181.4018062,0.3812086,113.039824,82.6846247,72929.8453925,307976.2999415,17.7328641,3724.710622,645.169488,3080.7079064,0.541016,0.7651122,2.3561945,1.5302245),(16289,'umzc_hippo_ulna-cleaned.tif',250,4,215,769.6431693,170.0252293,183.0135248,1.8,168.5512782,181.3021177,0.3822185,114.0895409,80.7983743,75171.2798792,311544.9619309,17.8446855,3855.8320599,658.8796774,3148.2008886,43.5838878,77.9232161,2.5189219,362.9180158),(16290,'umzc_hippo_ulna-cleaned.tif',250,4,216,772.2242367,170.0353976,183.0030731,1.8,168.3866547,181.1886337,0.3906151,118.2504302,82.2280104,77361.2657431,313962.2943289,18.6590062,3818.1915493,654.215512,3025.9257062,0.541016,0.7651122,2.3561945,1.5302245),(16291,'umzc_hippo_ulna-cleaned.tif',250,4,217,773.6691023,170.1459257,183.0779072,1.8,168.7316291,181.2180292,0.3814496,114.5797015,83.1200348,80967.5827782,320698.4033372,17.8694618,3858.2563633,706.6485747,3170.8695132,0.7651122,1.5302245,2.3561945,3.0604489),(16292,'umzc_hippo_ulna-cleaned.tif',250,4,218,768.3736567,170.3553943,183.4057301,1.8,168.9059672,181.9760555,0.367387,115.7485593,83.9901976,78473.7983466,311455.3647363,16.5211654,3708.2346964,677.9678193,3040.3746027,44.0830991,72.077065,2.4785745,342.0199633),(16293,'umzc_hippo_ulna-cleaned.tif',250,4,219,772.1131887,170.3273742,183.3791406,1.8,168.887282,182.01177,0.367854,117.778898,81.9085988,80418.9279322,315039.765744,16.6418835,3846.2355624,682.7957241,3047.8623294,43.7789961,74.1507843,2.5272803,375.2685613),(16294,'umzc_hippo_ulna-cleaned.tif',250,4,220,771.0871479,170.5004578,183.3807748,1.8,169.1369985,182.0997807,0.3573936,116.7045423,83.9512085,81352.9469627,318802.6894228,15.7280709,3797.4758796,697.0846666,3124.1800792,44.046944,74.3557626,2.4748061,381.411982),(16295,'umzc_hippo_ulna-cleaned.tif',250,4,221,771.6290834,170.5264474,183.3009269,1.8,169.4273267,182.1419126,0.3571709,116.6088939,84.4704203,82570.302216,323573.2156346,15.7203625,3830.6097488,708.0960932,3172.7867463,44.3073287,74.2277175,2.501007,381.674527),(16296,'umzc_hippo_ulna-cleaned.tif',250,4,222,770.7479726,170.5663689,183.2593751,1.8,169.5213489,182.1011407,0.3531661,116.2640407,85.08655,84240.982973,329119.4877118,15.3669473,3868.0553817,724.5661034,3201.4083809,45.4633565,74.5523257,2.4951888,416.4852015),(16297,'umzc_hippo_ulna-cleaned.tif',250,4,223,772.0060434,170.570803,183.2618257,1.8,169.4202338,182.2012324,0.3597373,116.6313135,83.7696689,84878.4539855,332544.8856084,15.9450088,3969.7528968,727.7501338,3232.9119024,45.5970818,73.8481954,2.4599868,363.9456731),(16298,'umzc_hippo_ulna-cleaned.tif',250,4,224,777.2121717,170.6726467,183.2448318,1.8,169.5905991,181.9686208,0.3607964,91.453103,83.636721,88567.8826991,339704.5757417,16.1430526,4061.6677904,968.451368,3825.877198,44.6791544,73.7093418,2.5230497,375.608004),(16299,'umzc_hippo_ulna-cleaned.tif',250,4,225,778.7733183,170.6922415,183.2280027,1.8,169.5426452,181.8112945,0.3672043,102.0897703,84.6017573,91041.4139221,345314.8680245,16.7288789,4081.6512441,891.778027,3764.0757833,0.541016,0.7651122,2.3561945,1.5302245),(16300,'umzc_hippo_ulna-cleaned.tif',250,4,226,778.2381238,170.6557852,183.2813305,1.8,169.619068,182.2133129,0.3655319,94.9119078,81.0230688,90817.7836306,346054.051678,16.5722876,4271.0558465,956.8639562,3962.3460679,0.541016,1.2097487,2.677945,2.2953367),(16301,'umzc_hippo_ulna-cleaned.tif',250,4,227,781.870954,170.7643489,183.3684075,1.8,169.863822,182.2843647,0.3563618,112.6789124,85.199568,95530.7465644,351700.7477225,15.8600058,4127.9639769,847.8138859,3570.9461598,0.541016,0.7651122,2.3561945,1.5302245),(16302,'umzc_hippo_ulna-cleaned.tif',250,4,228,787.7703339,170.7875192,183.4571492,1.8,169.9779618,182.4996443,0.3607598,107.8069697,83.6559707,97191.4397904,355510.3093346,16.3591796,4249.6704841,901.5320628,3708.8985854,0.541016,1.2097487,2.677945,2.2953367),(16303,'umzc_hippo_ulna-cleaned.tif',250,4,229,792.5492113,170.7157396,183.4713153,1.8,169.864117,182.5864409,0.3600199,117.3579749,85.1388077,101701.9930754,359839.8485875,16.3939143,4226.5079633,866.5963536,3595.0910711,0.541016,0.7651122,2.3561945,1.5302245),(16304,'umzc_hippo_ulna-cleaned.tif',250,4,230,796.6896514,170.7677701,183.4934785,1.8,169.9798505,182.5778056,0.3596836,114.7418172,84.0772584,105386.1404455,366395.1733208,16.4501249,4357.8392114,918.4632338,3808.9205095,0.541016,1.2097487,2.677945,2.2953367),(16305,'umzc_hippo_ulna-cleaned.tif',250,4,231,805.9180761,170.7439694,183.5552626,1.8,170.1438603,182.6921224,0.3635013,117.4145257,83.155534,110142.2776843,373263.3955107,16.9800293,4488.7378818,938.0634722,3775.3533641,0.541016,0.7651122,2.3561945,1.5302245),(16306,'umzc_hippo_ulna-cleaned.tif',250,4,232,815.9200227,170.813363,183.4507091,1.8,170.3303604,182.1419598,0.3703478,116.5174998,82.9208377,118177.6839704,386380.0607722,17.8142981,4659.6256298,1014.2483674,3956.2550838,0.541016,0.7651122,2.3561945,1.5302245),(16307,'umzc_hippo_ulna-cleaned.tif',250,4,233,822.5185083,170.8245414,183.4456083,1.8,169.9904347,182.2715824,0.3873395,115.6056508,82.7454146,117032.6550331,391379.9329323,19.5591084,4729.9289612,1012.3437238,4142.4223011,0.541016,0.7651122,2.3561945,1.5302245),(16308,'umzc_hippo_ulna-cleaned.tif',250,4,234,823.027626,170.8781177,183.4975565,1.8,170.2936069,182.8177467,0.3775665,110.3007822,83.8463212,116998.4084549,394985.339741,18.6429174,4710.8249232,1060.7214756,4220.6648961,48.5357737,77.8029235,2.5092177,387.4016074),(16309,'umzc_hippo_ulna-cleaned.tif',250,4,235,828.5165187,170.900168,183.5118471,1.8,170.4887839,182.9154708,0.3801792,111.3181092,83.7163871,119653.4047485,402936.2877613,19.0152091,4813.11129,1074.8781631,4205.7391663,49.8177573,79.3008474,2.4092847,402.4638298),(16310,'umzc_hippo_ulna-cleaned.tif',250,4,236,832.5754467,170.9709139,183.5216902,1.8,170.7473393,183.0114171,0.3852855,115.8621181,82.9405364,122669.8510455,409144.5682986,19.599308,4932.9867632,1058.7571939,4260.9225621,50.3411249,78.5815336,2.4195243,390.0363867),(16311,'umzc_hippo_ulna-cleaned.tif',250,4,237,839.7836318,171.0561047,183.5206585,1.8,171.1222008,183.1223279,0.3822097,115.6860862,83.7922226,127517.6636771,418295.8755267,19.4700792,4992.0608661,1102.2731245,4375.1806067,49.7358334,79.4557176,2.4381362,385.9482805),(16312,'umzc_hippo_ulna-cleaned.tif',250,4,238,818.5038397,172.2588936,184.1557698,1.8,171.9785203,183.3900146,0.3551336,116.8882895,82.931453,130029.8922373,387140.8838083,16.4936923,4668.2033154,1112.4287369,4047.2581543,49.6036792,79.5311995,2.4912889,420.0388884),(16313,'umzc_hippo_ulna-cleaned.tif',250,4,239,820.5914887,172.2480731,184.0933367,1.8,171.7947696,183.4300144,0.3662342,114.4866135,82.9927314,132544.286004,389715.5869264,17.5383601,4695.7797431,1157.7273704,4176.1719975,0.7651122,1.5302245,2.3561945,3.0604489),(16314,'umzc_hippo_ulna-cleaned.tif',250,4,240,825.2089384,172.2647844,184.008549,1.8,171.6953712,183.0662984,0.3787835,118.7378121,84.5165977,141320.1866762,394959.5519826,18.8071985,4673.159627,1190.1868845,4151.02946,0.541016,0.7651122,2.3561945,1.5302245),(16315,'umzc_hippo_ulna-cleaned.tif',250,4,241,838.5414377,172.242192,183.983322,1.8,171.7532961,182.9458384,0.3818526,117.9693295,83.2363346,149850.7672536,408495.9398698,19.4067492,4907.6637221,1270.2519196,4398.6584923,0.541016,0.7651122,2.3561945,1.5302245),(16316,'umzc_hippo_ulna-cleaned.tif',250,4,242,850.6020295,172.1816646,184.0393839,1.8,171.9618899,183.5537156,0.3731984,113.7765878,82.4289819,151493.891523,414727.0441406,18.8450711,5031.3255655,1331.5032065,4700.717001,53.9300338,79.101283,2.4871481,353.967362),(16317,'umzc_hippo_ulna-cleaned.tif',250,4,243,864.3756164,172.3942226,183.9650824,1.8,172.4532316,183.4838222,0.3511575,116.45648,82.5531565,161742.1008352,425376.308557,17.0462957,5152.7564351,1388.8630395,4602.9752837,0.541016,0.7651122,2.3561945,1.5302245),(16318,'umzc_hippo_ulna-cleaned.tif',250,4,244,875.5226345,172.5664623,184.0186357,1.8,172.5161245,183.7939135,0.3445384,117.1591769,82.5905277,166009.0153787,433709.180487,16.6470869,5251.3186746,1416.9527282,4649.2988999,0.9683477,1.9506611,0.5880026,3.8255612),(16319,'umzc_hippo_ulna-cleaned.tif',250,4,245,858.7654757,173.6987371,184.7231844,1.8,173.3047734,184.384337,0.3118638,115.3078337,82.3849224,167159.3729631,403344.6492403,13.474963,4895.8551835,1449.6792417,4433.0033236,53.9835467,77.4333651,2.540025,368.4501196),(16320,'umzc_hippo_ulna-cleaned.tif',250,4,246,877.3606029,173.7788611,184.7081318,1.8,173.3929813,184.1750464,0.3083334,111.9701711,83.9210401,174326.4575268,414979.8793346,13.4667099,4944.8848418,1556.900877,4868.5216858,54.7082043,78.3633315,2.5229483,375.2817548),(16321,'umzc_hippo_ulna-cleaned.tif',250,4,247,896.1601754,174.0484132,184.6622557,1.8,173.3435943,183.9499153,0.3127354,112.6798693,81.009089,182354.791194,425791.9604759,14.1378515,5256.1010836,1618.3440069,4882.0525177,55.4113109,78.0151897,2.4939307,381.1944826),(16322,'umzc_hippo_ulna-cleaned.tif',250,4,248,916.7617943,174.1994063,184.4132263,1.8,173.3752594,183.3284646,0.321543,115.4036716,82.3290531,194008.4735855,445677.3093765,15.2603389,5413.3661487,1681.1291258,5021.4802793,55.482453,78.3446535,2.4442019,455.2884261),(16323,'umzc_hippo_ulna-cleaned.tif',250,4,249,942.2051763,174.282802,184.3540988,1.8,173.377054,183.1289738,0.315786,114.9988875,82.1038764,204564.054135,462183.1337991,15.1459209,5629.2486332,1778.8350703,5208.0301553,56.0168915,78.4025407,2.5976229,406.2350162),(16324,'umzc_hippo_ulna-cleaned.tif',250,4,250,959.1220775,174.2112247,184.5016464,1.8,173.3206936,183.6119179,0.3260836,113.3307659,80.0934169,200221.476878,468307.072236,16.4033592,5847.0107805,1766.7001119,5342.5584314,56.3132574,78.1950693,2.6439025,398.7695412),(16325,'umzc_hippo_ulna-cleaned.tif',250,4,251,983.940238,174.0909949,184.5990385,1.8,173.1587677,183.7533897,0.3293686,115.1843031,83.3178178,203285.6658657,475414.1650327,17.1561559,5706.0323648,1764.8729942,5336.0663427,57.3986826,82.4068856,0.1316839,454.7089612),(16326,'umzc_hippo_ulna-cleaned.tif',250,4,252,1004.1818379,173.9078935,184.5927119,1.8,173.2281272,183.892189,0.3348023,116.396428,82.07008,207568.990178,481423.2101326,18.0696526,5866.0014735,1783.2934719,5363.6718737,58.5441846,80.7474384,2.5758912,453.0699871),(16327,'umzc_hippo_ulna-cleaned.tif',250,4,253,1023.6946188,173.3891621,184.4040633,1.8,172.85954,183.8790086,0.3540803,116.5425529,81.392186,211102.8193667,491741.7561723,20.5114593,6041.6334817,1811.379742,5510.7965339,58.3745298,80.2182871,0.060736,396.7911243),(16328,'umzc_hippo_ulna-cleaned.tif',250,4,254,1021.448558,173.2058141,184.5815957,1.8,172.7621116,183.9020299,0.322217,113.8616599,82.680745,216827.5152644,478949.7193834,17.0718184,5792.7600863,1904.3066426,5494.018706,59.9675095,79.7039857,2.2985661,391.3809638),(16329,'umzc_hippo_ulna-cleaned.tif',250,4,255,1035.0963732,172.4120163,184.0401882,1.8,172.5648905,183.2332847,0.3372453,116.1178584,83.4221452,229520.5128083,486497.5287328,18.8883384,5831.7551963,1976.6168267,5611.1261896,60.5360763,80.0996141,2.4710711,439.4067165),(16330,'umzc_hippo_ulna-cleaned.tif',250,4,256,1055.5226392,171.7351997,183.5882785,1.8,172.3027316,182.8914234,0.352705,113.6325075,83.0385838,239036.8873769,494944.1427709,20.9920799,5960.4116573,2103.5959921,5886.7791152,61.5967489,80.2784693,2.5479826,468.6666288),(16331,'umzc_hippo_ulna-cleaned.tif',250,4,257,986.9576034,173.6356441,184.4769612,1.8,173.4046872,182.8194438,0.31653,113.3470131,83.1719394,236570.2572549,418267.6005638,15.937642,5028.9509116,2087.1326974,5305.1865797,60.910768,83.654798,2.2324067,504.1787115),(16332,'umzc_hippo_ulna-cleaned.tif',250,4,258,998.2524786,173.1006872,184.4054709,1.8,173.1790679,183.2884447,0.3131101,114.7757738,83.8239618,232217.6328411,417448.6140164,15.7849898,4980.0630393,2023.2286406,5114.5142473,60.6251872,83.0173219,2.1895307,455.1253016),(16333,'umzc_hippo_ulna-cleaned.tif',250,4,259,1019.0156137,172.6190244,184.2429363,1.8,172.9983523,183.4155042,0.3057845,113.9836682,84.0812001,235813.2426777,425185.3229273,15.3915315,5056.8417495,2068.8336011,5165.531532,62.9951933,84.5111403,2.2245404,439.8774317),(16334,'umzc_hippo_ulna-cleaned.tif',250,4,260,945.4273418,174.5522944,185.660873,1.8,174.8293312,184.7694285,0.1469887,103.7205262,85.0962437,210166.9540075,355334.252427,3.3799835,4175.6749393,2026.2812172,4549.5152703,60.2983333,74.5915762,0.2045078,346.5787846),(16335,'umzc_hippo_ulna-cleaned.tif',250,4,261,892.5183869,175.7032159,186.8113975,1.8,175.8275105,185.7491068,-0.0116102,92.7438576,88.3014511,188246.7730703,317715.0840622,0.0200507,3598.0731918,2029.749224,3962.3442652,61.6891723,75.027828,2.1507991,387.446653),(16336,'umzc_hippo_ulna-cleaned.tif',250,4,262,879.9988795,176.0119263,186.4744514,1.8,176.565865,185.260991,-0.0402111,89.9151433,90.7779483,195818.7172324,309593.1739273,0.2370222,3410.4447141,2177.816884,3995.2412756,60.2983333,74.4659019,0.2872815,419.5813668),(16337,'umzc_hippo_ulna-cleaned.tif',250,4,263,839.6249538,176.6674599,186.5808345,1.8,177.0410702,185.0117026,-0.0442858,94.0327244,90.6951062,196321.976934,279718.0307642,0.2742701,3084.1579269,2087.8048389,3797.9566312,61.2751574,77.6089362,2.1878043,411.6676995),(16338,'umzc_hippo_ulna-cleaned.tif',250,4,264,831.7789524,176.6301631,186.0858631,1.8,177.086642,184.0326842,0.1151793,99.5616371,85.2149616,213351.1362606,270969.7088734,1.8309817,3179.8372457,2142.9050633,3959.7592423,60.7480258,78.5591818,2.2046559,420.4552288),(16339,'umzc_hippo_ulna-cleaned.tif',250,4,265,832.528615,176.4869015,186.0805457,1.8,176.6632005,183.6060885,0.2364467,110.2884064,82.5276346,215325.7860153,267395.5135431,7.6138773,3240.0724308,1952.3882243,3801.9771342,61.7776008,78.4939527,2.2487665,475.7608091),(16340,'umzc_hippo_ulna-cleaned.tif',250,4,266,775.5902679,178.0415812,187.6497585,1.8,178.7147178,186.15832,-0.1532972,92.1757239,98.5453318,161514.4415511,233409.8800987,3.0140131,2368.5533945,1752.2448942,3137.6504291,60.8346861,72.6050795,0.2793232,434.3041467),(16341,'umzc_hippo_ulna-cleaned.tif',250,4,267,774.8546194,177.986042,187.7488888,1.8,178.5475394,186.5846714,-0.090031,87.5485692,93.3159402,152128.2955816,222932.9812011,1.043951,2389.0128607,1737.6445667,2985.9130378,58.0891581,70.3175191,0.3290497,397.393112),(16342,'umzc_hippo_ulna-cleaned.tif',250,4,268,762.1590495,178.2385068,188.0607666,1.8,178.8268674,186.7513437,-0.124612,85.9593353,95.8457176,139901.944428,216762.9458615,1.9622989,2261.5819598,1627.5363689,2847.1528424,56.9148402,71.7432977,0.3623011,396.8361699),(16343,'umzc_hippo_ulna-cleaned.tif',250,4,269,658.0014489,181.0574164,190.2632494,1.8,181.9307033,188.8057751,-0.3609514,67.4456095,108.1990403,91989.1349577,199008.6880343,13.6782206,1839.2833009,1363.9010105,2346.4815635,50.7155634,72.7158579,0.3335147,321.1669563),(16344,'umzc_hippo_ulna-cleaned.tif',250,4,270,657.4106417,181.1541697,190.5380129,1.8,182.1640747,188.9504345,-0.3535812,69.5264302,110.233377,89872.3569988,197751.733786,13.1367921,1793.937001,1292.6358613,2283.7066211,50.1815351,69.1189029,0.326701,314.2490941),(16345,'umzc_hippo_ulna-cleaned.tif',250,4,271,651.2695639,181.319662,190.8797217,1.8,182.5162323,189.1708407,-0.3317462,83.7013875,108.3203597,83774.5817665,194659.6684367,11.5141097,1797.0736891,1000.8744685,2214.2720287,47.8559426,70.0338955,0.3632914,325.12379),(16346,'umzc_hippo_ulna-cleaned.tif',250,4,272,648.4836076,181.303539,191.1708994,1.8,181.8504845,189.2049349,-0.2994897,89.4795483,105.3860416,82494.4540314,185802.3705647,9.4077983,1763.0643275,921.9364158,2133.3229501,47.6287502,68.1272192,0.3996781,324.0417579),(16347,'umzc_hippo_ulna-cleaned.tif',250,4,273,635.7862638,181.9489544,191.1866169,1.8,182.8582799,188.8839692,-0.3085689,84.8365643,106.7752091,79267.2154261,182022.5726882,9.7731947,1704.7269137,934.3520223,2045.663281,45.0569297,66.8105537,0.3729877,342.5900989),(16348,'umzc_hippo_ulna-cleaned.tif',250,4,274,623.8373408,181.9326453,191.3796257,1.8,182.864713,189.7838298,-0.2825778,74.5549058,104.3165068,69665.0556735,176745.8927266,8.0836202,1694.3233456,934.4127647,1938.2901193,44.1869673,67.3146597,0.370059,305.8872344),(16349,'umzc_hippo_ulna-cleaned.tif',250,4,275,616.7469447,181.9126971,191.3878256,1.8,182.8440791,189.9587484,-0.2909243,80.0145071,106.1325356,63527.8573502,174002.2245439,8.4572372,1639.4805192,793.9542422,1852.1022756,43.3767774,68.3245654,0.3643313,265.5444561),(16350,'umzc_hippo_ulna-cleaned.tif',250,4,276,600.9877098,181.9406227,191.3668521,1.8,182.7188666,190.1803633,-0.2921749,74.3036761,105.0988905,58694.2977732,167635.6447953,8.3101121,1595.0277306,789.9245483,1793.4342403,43.071648,66.744806,0.347386,293.2741439),(16351,'umzc_hippo_ulna-cleaned.tif',250,4,277,593.2295179,181.9715295,191.24918,1.8,183.0372943,189.8183022,-0.2883628,71.5994753,103.7550665,55324.8687841,166502.7421558,7.9961119,1604.7673406,772.699361,1826.0636578,42.1519468,68.715428,0.4566055,293.6454387),(16352,'umzc_hippo_ulna-cleaned.tif',250,4,278,559.5769224,182.7074293,191.5597654,1.8,183.5628336,189.9252587,-0.3053647,74.9268353,105.3162725,44912.0413142,155815.8173088,8.4295597,1479.5037231,599.4119616,1606.3937602,37.138765,65.03454,0.3480603,238.6342554),(16353,'umzc_hippo_ulna-cleaned.tif',250,4,279,557.3654532,182.9572427,190.4635497,1.8,184.5893663,188.1313474,-0.2801316,86.0883663,103.1924626,52084.4448882,151117.050912,7.1010574,1464.419465,605.0114216,1622.0669805,37.2018296,62.0920517,0.3934506,239.7706623),(16354,'umzc_hippo_ulna-cleaned.tif',250,4,280,551.4390209,183.0330848,190.1524875,1.8,184.7648412,187.1179776,-0.3176028,96.1520963,106.234381,54659.9924318,149987.7573019,8.9631937,1411.8570263,568.4742665,1625.4354882,37.7169108,62.9534421,0.5020902,257.6851636),(16355,'umzc_hippo_ulna-cleaned.tif',250,4,281,548.5696899,183.118061,189.9959619,1.8,184.5324737,187.466704,-0.2881517,83.6239603,104.3813025,51202.3580058,144688.4161899,7.3836233,1386.1526224,612.2929101,1549.6646867,37.5325219,65.8463431,0.4967238,260.9856348),(16356,'umzc_hippo_ulna-cleaned.tif',250,4,282,544.1535811,183.3313862,189.8523066,1.8,184.9940007,187.9352335,-0.2928626,97.5461987,104.8321037,47692.4005953,145040.7333148,7.5586827,1383.5526354,488.9211597,1527.6588257,37.8880158,62.4797416,0.5062575,261.2707026),(16357,'umzc_hippo_ulna-cleaned.tif',250,4,283,544.3833937,183.4992184,189.6714304,1.8,185.6245393,187.7067655,-0.3222678,77.6548855,104.5773964,47037.2049509,152516.2751593,9.1012358,1458.4057404,605.7211293,1602.0373978,37.4990195,64.9579837,0.5232783,265.5219333),(16358,'umzc_hippo_ulna-cleaned.tif',250,4,284,543.6785228,183.4641072,189.77033,1.8,184.7020059,188.7928734,-0.2867919,74.4771306,102.7239805,43418.6758166,141000.9760028,7.2507838,1372.6198628,582.9799758,1491.4125411,37.4584164,63.3982174,0.4789136,278.637591),(16359,'umzc_hippo_ulna-cleaned.tif',250,4,285,544.2894641,183.7852499,189.5208277,1.8,184.8343,188.3893467,-0.2965253,74.2880396,104.3989999,43465.818323,137911.3216549,7.7452581,1321.0023258,585.0984704,1449.5738722,37.3656634,63.6700273,0.4294404,215.1239463),(16360,'umzc_hippo_ulna-cleaned.tif',250,4,286,577.3448663,183.2409383,189.1387726,1.8,184.3384797,187.8972715,-0.2725192,82.2505048,102.3224588,47595.7430433,151395.5889668,6.9710831,1479.592953,578.6680964,1604.7516682,39.0153374,62.4516271,0.5567628,269.2931196),(16361,'umzc_hippo_ulna-cleaned.tif',250,4,287,585.8746288,183.5205448,188.8312481,1.8,184.6622007,187.2206533,-0.2686116,88.6306082,100.0646565,50853.2230786,150224.9779992,6.8775301,1501.2791049,573.765927,1640.7387489,38.1230282,63.4282196,0.4979853,281.1954727),(16362,'umzc_hippo_ulna-cleaned.tif',250,4,288,597.1538047,184.2168648,188.4103798,1.8,186.0356405,186.519149,-0.2887504,89.1437981,101.994815,51804.0124178,153777.8592993,8.0700555,1507.7027127,581.1286206,1674.2203598,37.2306198,59.1268914,0.6032299,237.4753256),(16363,'umzc_hippo_ulna-cleaned.tif',250,4,289,611.9163573,184.6763466,187.9962526,1.8,186.110508,186.5519463,-0.2728142,77.643641,101.3197353,52449.4485674,153041.3812393,7.4041204,1510.4794817,675.5150573,1670.1540547,40.0253352,60.3323867,0.5681047,266.3639432),(16364,'umzc_hippo_ulna-cleaned.tif',250,4,290,618.1807232,185.1067255,187.8130406,1.8,185.9068752,186.7864594,-0.2631607,77.3618452,99.5160439,52031.1143139,150740.9998887,6.9720032,1514.7406787,672.5681657,1664.9610633,40.1548078,61.4237897,0.5464617,248.9201571),(16365,'umzc_hippo_ulna-cleaned.tif',250,4,291,637.3229302,185.3695762,187.5210465,1.8,186.2755069,186.6369654,-0.2273129,79.8778081,96.2876631,52704.728253,151445.7639698,5.3946507,1572.8470197,659.8169069,1673.8194683,41.1453862,61.2711126,0.5070985,274.5945304),(16366,'umzc_hippo_ulna-cleaned.tif',250,4,292,650.9312755,185.7098772,187.2579044,1.8,186.541474,186.2808364,-0.2319411,77.5939892,94.1113852,54533.1092959,154796.6420282,5.7324145,1644.8237556,702.8006919,1749.6178016,41.0037428,62.8161339,0.5330341,271.9822739),(16367,'umzc_hippo_ulna-cleaned.tif',250,4,293,663.0066797,186.0443168,186.8974242,1.8,186.6181954,186.0727825,-0.2134602,78.7036895,95.3237898,54920.747617,152602.7434634,4.9589992,1600.888339,697.8166835,1717.4756317,39.7867134,62.9534421,0.5020902,327.7135238),(16368,'umzc_hippo_ulna-cleaned.tif',250,4,294,672.2351931,186.7198337,186.3854901,1.8,187.2832278,185.2595889,-0.2281217,76.9901399,95.3460636,56681.119015,152253.3077294,5.7300237,1596.8494348,736.2127029,1733.958725,40.0922794,58.6821632,0.3188351,273.5668732),(16369,'umzc_hippo_ulna-cleaned.tif',250,4,295,672.4001685,186.9465277,186.1525708,1.8,187.0173141,185.2613495,-0.1986521,77.3386374,93.5026909,53144.7142588,142766.1549212,4.3645804,1526.8668052,687.1690015,1619.9941043,39.9935422,59.5854947,0.5653365,273.4581235),(16370,'umzc_hippo_ulna-cleaned.tif',250,4,296,689.0068095,186.3990739,185.7924476,1.8,186.5037977,184.6589751,-0.1722434,80.7975537,91.2040826,53645.8309736,154230.3269698,3.3733252,1691.0463064,663.9536538,1734.8457869,38.4121395,60.6903307,0.1973956,266.8890332),(16371,'umzc_hippo_ulna-cleaned.tif',250,4,297,693.0932334,186.4687249,185.5638616,1.8,186.1716178,184.5331681,-0.1473779,82.2429185,89.8352475,50774.8013924,150210.4537847,2.4909119,1672.0658976,617.3759676,1664.0348387,38.9529815,60.4874332,0.1798535,278.2344442),(16372,'umzc_hippo_ulna-cleaned.tif',250,4,298,688.3357319,186.5975088,185.3558258,1.8,186.8047384,184.0878508,-0.1418083,83.7978276,87.5444345,47606.4173352,152341.8965976,2.2916039,1740.1665507,568.1103998,1704.4162097,38.8528693,61.0293922,0.2234766,305.5159397),(16373,'umzc_hippo_ulna-cleaned.tif',250,4,299,672.4053129,186.4674524,185.174351,1.8,186.5926868,183.9620602,-0.1200635,83.8902945,86.5794319,42870.1502655,146791.4656578,1.6077328,1695.454248,511.026341,1594.3417222,39.2466869,60.3032711,0.1621988,259.8942734),(16374,'umzc_hippo_ulna-cleaned.tif',250,4,300,639.368537,186.2605962,184.9708021,1.8,186.2614609,183.7224646,-0.0924063,85.7759043,84.7277806,36802.3578997,139282.8772436,0.9073339,1643.8867662,429.0524034,1481.3512445,37.3856478,59.4551778,0.127741,256.9107221),(16375,'umzc_hippo_ulna-cleaned.tif',250,4,301,581.4898299,185.9384359,184.8122694,1.8,186.0416665,183.8159384,-0.061402,89.0354361,82.5560396,28941.0211947,129858.8019935,0.3649304,1572.9776119,325.0505919,1354.6885121,36.3702393,59.1491637,0.1561264,289.6792757),(16376,'umzc_hippo_ulna-cleaned.tif',250,4,302,489.618199,185.456293,184.5231001,1.8,186.0171628,183.5554838,-0.0546254,88.8320368,82.8075448,22707.2718155,121980.6970852,0.2432558,1473.0625981,255.6202991,1207.0237176,32.460963,58.3821246,0.1301021,242.7448844),(16377,'umzc_hippo_ulna-cleaned.tif',250,4,303,362.7849012,184.49396,183.9817565,1.8,184.8831795,183.097133,-0.0194597,89.9348993,80.4614944,15900.8470575,105345.4424476,0.0228939,1309.2652977,176.803968,1009.1732226,23.5225535,31.9932209,1.2436982,135.4341949),(16378,'umzc_hippo_ulna-cleaned.tif',250,4,304,273.4727844,183.5491564,183.4484331,1.8,185.0618874,182.1021072,-0.0282513,88.9616318,81.3808429,12578.9635824,91433.4710611,0.0363683,1123.5257319,141.3976265,864.2103994,20.6297192,29.0843305,1.4025896,111.6613407),(16379,'umzc_hippo_ulna-cleaned.tif',250,4,305,190.7772472,181.584622,182.701569,1.8,184.257223,180.7259453,-0.0525132,86.7881883,86.1988103,9943.1410305,68021.2108169,0.0876018,789.1200654,114.5679063,641.6942627,17.3593384,26.6913436,1.2618656,103.3763786),(16380,'umzc_hippo_ulna-cleaned.tif',250,4,306,125.5244039,177.9347695,181.9255172,1.8,182.5847505,179.7326772,-0.0834899,82.7767261,91.8434488,6484.196378,42555.0117837,0.1454907,463.3429205,78.3335689,401.1258736,14.977355,23.1122158,1.2860659,85.6475247),(16381,'umzc_hippo_ulna-cleaned.tif',250,4,307,68.906872,171.1175532,180.6273732,1.8,179.6685392,177.660585,-0.364124,53.1060645,116.8635234,2690.3009632,17240.0403102,1.4565669,147.5228524,50.6590159,156.6319649,12.6243519,20.8203333,1.1420183,70.4221777),(16382,'umzc_hippo_ulna-cleaned.tif',250,4,308,32.7595107,168.8739932,180.3670526,1.8,177.8084098,176.7263777,-0.4540193,41.4384052,118.3276209,660.5044239,7706.4820051,1.0502339,65.1283441,15.9394267,68.9678492,8.7987907,15.5017857,1.060308,44.037067),(16383,'umzc_hippo_ulna-cleaned.tif',250,4,309,5.7813249,171.9657044,179.2999617,1.8,183.9984977,175.3634572,-0.356686,45.8728845,113.5968648,233.9654708,3312.8001507,0.1174767,29.162778,5.1003,29.2190021,4.7911342,8.240511,1.1659045,20.2642128),(16384,'umzc_hippo_ulna-cleaned.tif',250,4,310,0.3191299,260.2843553,147.3667273,1.8,260.2605444,147.0290676,1.5354335,12.3166993,51.6531003,4.4772197,202.9771585,0.0531218,3.929622,0.3635081,4.0161839,0.541016,1.710843,2.8198421,3.3773688),(16385,'umzc_hippo_ulna-cleaned.tif',250,4,311,0.2052436,256.8383683,145.2955415,1.8,256.8842571,144.746385,-1.5549586,6.0840153,51.6098848,3.5902163,152.6645461,0.0341987,2.9580486,0.5901064,3.0067928,0,0,0,0),(16386,'umzc_hippo_ulna-cleaned.tif',250,4,312,0.1878591,258.4411702,153.9492078,1.8,258.443367,154.081371,-1.5072828,4.405306,53.4978636,1.1774601,118.9032739,0.0311837,2.2225799,0.2672822,2.2441156,0,0,0,0),(16387,'umzc_hippo_ulna-cleaned.tif',250,4,313,0.0355673,250.2178993,167.4464912,1.8,250.219923,167.4444674,-0.7853982,0.000000000003415,1.1505304,0.0008675,0.0477144,0.0029639,0.0414717,254051322.67439,0.0422257,0,0,0,0),(16388,'umzc_hippo_ulna-cleaned.tif',250,4,314,0.0362769,250.4282605,172.922751,1.8,250.219923,173.1251359,-0.7709024,0.0000548,13.4900272,0.0008848,6.3182943,0.0029354,0.4683678,16.1552963,0.4684334,0,0,0,0),(16389,'umzc_hippo_ulna-cleaned.tif',250,4,315,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16390,'umzc_hippo_ulna-cleaned.tif',250,4,316,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16391,'umzc_hippo_ulna-cleaned.tif',250,4,317,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16392,'umzc_hippo_ulna-cleaned.tif',250,4,318,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16393,'umzc_hippo_ulna-cleaned.tif',250,4,319,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16394,'umzc_hippo_ulna-cleaned.tif',250,4,320,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16395,'umzc_hippo_ulna-cleaned.tif',250,4,321,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16396,'umzc_hippo_ulna-cleaned.tif',250,4,322,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16397,'umzc_hippo_ulna-cleaned.tif',250,4,323,19.3410646,228.3539852,205.7176741,1.8,230.1415173,205.4127501,-0.2047931,8.032115,39.167283,6.2917317,8812.2010748,0.1333153,224.9888276,0.7833219,225.1285626,26.7402904,252.7014098,3.1223231,558.4131896),(16398,'umzc_hippo_ulna-cleaned.tif',250,4,324,29.5741542,205.5192879,199.527573,1.8,205.6673469,199.0193493,0.1774098,15.9849105,56.6828949,1521.4306556,41494.5324133,0.1535165,732.0468106,95.1791789,741.7567056,26.7686165,252.7014098,3.1223231,551.2102597),(16399,'umzc_hippo_ulna-cleaned.tif',250,4,325,42.361791,191.1172431,195.6380117,1.8,196.5060698,196.7504452,0.2136753,16.9237599,70.8014253,1775.7351955,60091.5581232,0.3174768,848.7337344,104.9255724,860.7541143,0,0,0,0),(16400,'umzc_hippo_ulna-cleaned.tif',250,4,326,53.6749377,185.8625181,194.2903486,1.8,189.9604214,195.1047989,0.2166078,16.9806498,76.1863859,2213.2366716,69755.6087982,0.413205,915.591519,130.3387504,932.3709945,11.9635207,19.1889172,1.1955255,52.4307788),(16401,'umzc_hippo_ulna-cleaned.tif',250,4,327,56.0918279,185.3428908,194.5772604,1.8,189.9940386,195.2238604,0.2088679,16.449687,76.7289279,2622.8989572,70087.9379018,0.4019453,913.4486797,159.4497789,935.8773934,13.5219341,22.029387,1.1401038,68.683783),(16402,'umzc_hippo_ulna-cleaned.tif',250,4,328,57.5808643,184.4093178,195.1982357,1.8,188.8577705,195.7188632,0.1969463,15.5883505,77.3440943,2811.5177955,68522.0411926,0.3674517,885.9375988,180.360186,913.2499045,14.1489367,24.0311023,1.0265158,76.0723604),(16403,'umzc_hippo_ulna-cleaned.tif',250,4,329,550.1700404,136.66094,190.2552415,1.8,147.433345,191.1214697,0.1182098,19.5805029,125.9605956,29816.8413039,250014.5458828,1.275349,1984.86316,1522.7822023,2219.4532881,29.2148667,31.5463856,1.0303768,115.9444235),(16404,'umzc_hippo_ulna-cleaned.tif',250,4,330,554.1704288,136.8163066,190.4062773,1.8,147.5541046,191.2588295,0.1178033,21.9597728,125.7907855,30291.3850007,251062.9669047,1.2758427,1995.8772489,1379.4033893,2234.4761524,29.2148667,30.8426602,2.4805495,106.2061346),(16405,'umzc_hippo_ulna-cleaned.tif',250,4,331,556.5815538,136.8691805,190.5538051,1.8,146.9899861,191.3844276,0.1177289,21.8540352,125.3111869,30736.4548098,248205.6555348,1.2797827,1980.7142659,1406.4430015,2224.5052611,32.3027125,57.4012675,0.199244,221.9649108),(16406,'umzc_hippo_ulna-cleaned.tif',250,4,332,558.8563522,136.9732001,190.7242754,1.8,146.9159297,191.606148,0.1193474,19.9230266,125.1800217,30873.9294555,252622.344995,1.3204178,2018.0723848,1549.6606032,2262.9422454,31.4367183,57.7444351,0.2267988,220.2490389),(16407,'umzc_hippo_ulna-cleaned.tif',250,4,333,559.1750387,137.0086317,190.8651772,1.8,146.927073,191.7022585,0.1222448,20.3624259,125.1128139,30630.2300701,254068.3787413,1.3857748,2030.7142868,1504.2524971,2273.3830938,30.2929957,57.6023322,0.0940612,185.7871363),(16408,'umzc_hippo_ulna-cleaned.tif',250,4,334,559.3685744,136.956104,190.9863531,1.8,146.5070888,191.7534558,0.1227722,20.6323155,125.1472171,30486.3539069,250224.2873033,1.3981829,1999.4394857,1477.6021568,2240.7707534,29.3469576,57.8457235,0.1313154,190.8803769),(16409,'umzc_hippo_ulna-cleaned.tif',250,4,335,560.0502955,136.9038766,191.1092231,1.8,146.4137151,191.8524144,0.1233286,20.7725576,125.1807768,30355.8221455,248064.5729936,1.4125389,1981.650693,1461.3425411,2221.7335529,29.5782721,57.714014,0.1127276,185.6558638),(16410,'umzc_hippo_ulna-cleaned.tif',250,4,336,561.863961,137.0408031,191.2759558,1.8,146.8090095,192.1411983,0.1242867,20.8744421,125.018588,30266.208855,256237.2562557,1.4391045,2049.5932668,1449.9170195,2288.960047,30.2995447,57.7773733,0.1220321,187.5030081),(16411,'umzc_hippo_femur-cleaned.tif',250,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16412,'umzc_hippo_femur-cleaned.tif',250,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16413,'umzc_hippo_femur-cleaned.tif',250,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16414,'umzc_hippo_femur-cleaned.tif',250,7,4,43.9713452,232.6081204,178.5387222,1.8,232.592803,178.7420184,0.5841635,5.0626628,7.6548817,200.004207,596.1010657,2.2290116,77.8720157,39.5057338,102.0952479,9.9186284,16.2504893,2.6224465,45.0238202),(16415,'umzc_hippo_femur-cleaned.tif',250,7,5,124.4872838,233.3572507,179.4728063,1.8,233.943759,180.0312052,0.5873391,6.6565224,16.3559773,1084.8819539,3506.7789045,6.3712591,214.4035081,162.9802896,271.3076669,13.9429531,28.5210757,2.3228735,78.4149918),(16416,'umzc_hippo_femur-cleaned.tif',250,7,6,230.6654053,235.2098724,181.1932571,1.8,235.7725318,182.0480427,0.7700609,8.9009457,20.9383301,3301.2498263,14908.3125474,18.6325793,712.0105788,370.8875348,843.4572853,18.5284085,37.360119,2.2286849,97.6490388),(16417,'umzc_hippo_femur-cleaned.tif',250,7,7,350.2709662,236.1078447,181.9425287,1.8,236.4946073,182.6013067,0.8132159,10.9028398,23.216234,7420.5962398,34048.2488694,30.8123693,1466.5707161,680.6113218,1784.2935159,22.2975495,42.768422,2.3784131,122.9777098),(16418,'umzc_hippo_femur-cleaned.tif',250,7,8,469.332092,236.8018086,182.1215053,1.8,237.148432,182.5133321,0.8490525,13.9049837,25.4312555,13994.7549157,58543.9052536,44.0767381,2302.0454217,1006.4560497,2851.8226109,26.6048943,46.5973315,2.3969882,144.6687059),(16419,'umzc_hippo_femur-cleaned.tif',250,7,9,592.2976932,237.8173643,182.230911,1.8,238.2840067,182.8188079,0.882847,15.2480695,27.0813585,24313.2738486,86501.7211963,58.9171381,3194.1426119,1594.5148846,4091.5091121,29.9305061,50.3682273,2.3373288,166.129151),(16420,'umzc_hippo_femur-cleaned.tif',250,7,10,705.6861605,238.5805401,182.2583189,1.8,238.8688596,182.7975967,0.9148417,16.2436513,28.5749966,35832.8154238,117636.3704303,73.8621055,4116.7588629,2205.9581731,5370.7476611,32.3059431,53.3495861,2.2042222,167.5404279),(16421,'umzc_hippo_femur-cleaned.tif',250,7,11,810.2752974,239.139195,182.2129127,1.8,239.4639862,182.9432507,0.9348449,18.7691262,30.2952586,48392.2538594,153860.1243766,87.4059442,5078.6866179,2578.2901888,6674.7646672,35.1564675,57.2514812,2.197867,192.8015721),(16422,'umzc_hippo_femur-cleaned.tif',250,7,12,883.9450324,239.6303113,182.6859341,1.8,239.9377067,183.5399236,0.9510041,18.9898079,32.2854529,59975.1690834,191125.998653,97.6162056,5919.8797357,3158.2820384,7772.3495725,38.3053469,60.3417106,2.2298864,208.2744762),(16423,'umzc_hippo_femur-cleaned.tif',250,7,13,926.5584361,240.226086,183.3419144,1.8,240.4679099,183.8272212,0.973309,19.8356942,33.7500431,69527.8732546,229660.5878595,105.5533006,6804.7494719,3505.1898115,8827.8575199,39.2468602,63.6049592,2.114839,210.6638985),(16424,'umzc_hippo_femur-cleaned.tif',250,7,14,974.7442291,240.8979752,184.0335757,1.8,241.1426179,184.6365749,1.0124464,20.4277063,36.5355234,79470.3392878,281571.912265,116.8596961,7706.7983754,3890.3212119,9789.4578998,39.1052734,68.8106328,2.0257105,233.3725962),(16425,'umzc_hippo_femur-cleaned.tif',250,7,15,1047.4387686,241.5625884,185.3008761,1.8,241.6849741,185.8635096,1.0544109,20.3094261,40.1168907,91390.9205036,358372.4078483,132.0158193,8933.2049707,4499.9263039,11126.7251699,40.4357821,74.9193396,2.0866054,245.8599223),(16426,'umzc_hippo_femur-cleaned.tif',250,7,16,1112.4968529,242.0841702,186.3686386,1.8,242.0835864,186.6568211,1.0884072,108.842002,70.71176,104607.0019414,437010.3557042,145.514508,6180.1651625,961.090388,4172.8686017,41.9649907,79.6816607,2.0721619,272.9259187),(16427,'umzc_hippo_femur-cleaned.tif',250,7,17,1174.1672648,242.7705368,187.2422633,1.8,242.6926181,187.3509363,1.1062759,98.9411759,112.5189946,118518.3865724,524393.9125878,156.4189044,4660.4923434,1197.8671723,4667.9276556,43.3230286,83.2962486,1.9947536,275.7089163),(16428,'umzc_hippo_femur-cleaned.tif',250,7,18,1210.0670171,243.1031397,187.7018817,1.8,242.9867183,187.8765997,1.119765,22.1609005,44.8557843,128067.0160965,590925.6555654,163.3583272,13173.9008553,5778.9626432,15972.2051374,0.671875,0.9501748,2.3561945,1.9003496),(16429,'umzc_hippo_femur-cleaned.tif',250,7,19,1279.7179179,240.4970245,188.7857038,1.8,237.2551525,189.6142183,0.7649562,88.2721789,60.9433912,468789.7027798,700440.251285,102.2843891,11493.2930024,5310.729933,11379.8390276,44.017518,87.7999559,1.9967905,285.8347906),(16430,'umzc_hippo_femur-cleaned.tif',250,7,20,1477.9106397,230.5909693,191.4709316,1.8,229.2309043,191.7499131,-0.1317337,44.4193804,97.365611,685505.9534421,1908568.1067974,4.249884,19602.0759963,15432.587009,26565.0646245,44.7147615,89.5587001,2.0545754,286.8524922),(16431,'umzc_hippo_femur-cleaned.tif',250,7,21,1677.9248936,222.2861749,193.6082734,1.8,223.0374623,193.3092709,-0.1644925,166.9101913,118.6179977,753168.9701436,3108349.673022,7.4988202,26204.7052899,4512.4205065,18858.1737847,30.9062519,36.5539543,1.8692953,118.7834354),(16432,'umzc_hippo_femur-cleaned.tif',250,7,22,1867.4312758,215.9456574,195.2467285,1.8,218.4261197,194.5361908,-0.171512,158.7060284,110.0792479,818219.9756578,4085861.1173908,9.0660881,37117.4512424,5155.5696021,27364.0080464,36.0045585,41.9209109,1.9483265,142.2117568),(16433,'umzc_hippo_femur-cleaned.tif',250,7,23,2022.207894,211.2706649,196.2339892,1.8,214.8220204,195.4728627,-0.1749061,132.3696979,106.3445873,878990.616798,4795603.5763111,10.2058961,45094.9474554,6640.4217174,34000.6874633,40.1576504,46.7424196,1.8925469,163.250656),(16434,'umzc_hippo_femur-cleaned.tif',250,7,24,2141.3565672,207.8068706,196.9498359,1.8,212.0112741,196.1446386,-0.1776359,155.4998757,110.4919052,940768.6160769,5309437.1308066,11.143624,48052.7249737,6049.9637806,33015.5446139,43.2719839,50.1706689,1.9264322,171.4086539),(16435,'umzc_hippo_femur-cleaned.tif',250,7,25,2263.7613181,204.8227812,197.8688716,1.8,209.5896022,197.0663779,-0.1795416,161.9957448,117.6222528,1000679.9182734,5804173.0148317,12.0320042,49345.8752628,6177.1987862,35315.3589132,46.41377,56.5413886,1.922613,208.696022),(16436,'umzc_hippo_femur-cleaned.tif',250,7,26,2372.4204497,202.4779272,198.5966064,1.8,207.7085423,197.6166208,-0.180161,170.1063923,134.402934,1062086.7821862,6210244.2759596,12.695745,46206.1659588,6243.6617937,37268.6062855,49.5930516,58.2403671,1.8633581,201.0946237),(16437,'umzc_hippo_femur-cleaned.tif',250,7,27,2479.2927944,200.370287,199.1271531,1.8,205.9024048,197.7698267,-0.1822552,169.4717862,132.5737983,1137693.7558028,6567872.0896491,13.5744589,49541.2530464,6713.1749848,39395.224156,52.2596138,61.4058503,1.8821666,224.9840473),(16438,'umzc_hippo_femur-cleaned.tif',250,7,28,2566.4490633,198.2103127,199.5768707,1.8,203.8688695,198.3336822,-0.1824489,167.45456,137.7018118,1182159.3834066,6853548.2633954,14.0812003,49770.9374453,7059.5831113,41975.8065266,54.6350508,63.5872138,1.849096,240.2543709),(16439,'umzc_hippo_femur-cleaned.tif',250,7,29,2638.3203841,196.5961873,199.8731518,1.8,202.6094658,198.3301197,-0.182273,168.9839124,144.3894118,1248870.9741347,7118398.135391,14.4479379,49300.0009187,7390.4725978,43520.1720613,56.5354004,64.8106978,1.8761549,227.1149479),(16440,'umzc_hippo_femur-cleaned.tif',250,7,30,2698.7991943,195.2198383,200.1646027,1.8,201.5865768,198.8506738,-0.1845073,168.8719669,142.3576112,1274237.5350097,7317893.1522654,15.1395406,51405.0010427,7545.5835452,44896.9478526,58.9108374,67.3787165,1.8641633,273.7410398),(16441,'umzc_hippo_femur-cleaned.tif',250,7,31,2773.7271491,194.2391719,200.3912661,1.8,200.0945825,199.0638136,-0.1818875,168.3736685,142.5148101,1340407.0721293,7540283.618031,15.1259919,52908.7721536,7960.9067407,47079.2230198,60.2827642,69.0594729,1.9079303,271.4471149),(16442,'umzc_hippo_femur-cleaned.tif',250,7,32,2862.8671865,193.6320297,200.675244,1.8,199.9819959,199.1726287,-0.1811266,169.4394832,145.7323832,1445003.9229297,7791994.3806178,15.4831765,53467.8306221,8528.1417015,48362.3826339,62.8722981,71.5633659,1.7884469,275.3828678),(16443,'umzc_hippo_femur-cleaned.tif',250,7,33,2980.1739453,193.226715,201.3505573,1.8,199.6159971,199.8775559,-0.1775463,169.2032988,146.5964615,1516877.4848085,8031628.6943174,15.4933475,54787.3298541,8964.8221728,49786.4208429,64.4685803,72.79232,1.7283579,303.3035417),(16444,'umzc_hippo_femur-cleaned.tif',250,7,34,3066.236693,192.5958664,201.7646482,1.8,199.0261767,200.1122578,-0.1763627,170.0661912,143.5436241,1604167.8937201,8196081.6760874,15.7311497,57098.1938405,9432.6090454,51145.7817406,65.4996604,75.0367421,1.8613955,306.9691872),(16445,'umzc_hippo_femur-cleaned.tif',250,7,35,3148.0455966,191.8386785,202.1328037,1.8,198.6970694,200.4141445,-0.1775035,171.6228757,148.1146661,1656003.6884567,8346555.6013814,16.3582831,56351.9860681,9649.0848394,51651.4236558,67.2886718,75.7820247,1.8308276,334.5917831),(16446,'umzc_hippo_femur-cleaned.tif',250,7,36,3241.6345446,191.0897689,202.3408508,1.8,197.6446408,200.6286394,-0.178753,171.4480213,147.135018,1699671.9540273,8440455.3045814,17.080039,57365.373772,9913.6282915,52763.1979299,70.441632,81.3967671,0.0495462,369.0961537),(16447,'umzc_hippo_femur-cleaned.tif',250,7,37,3342.6796549,190.6373512,202.5352448,1.8,197.1628938,200.5284999,-0.1807005,170.2839175,149.5725093,1758050.482334,8553788.3249092,17.9940901,57188.2384148,10324.2308971,54117.434773,71.2235347,83.4857123,3.0771658,374.0100519),(16448,'umzc_hippo_femur-cleaned.tif',250,7,38,3430.2408304,190.1392891,202.688138,1.8,196.700916,200.1913417,-0.1838749,171.9811555,149.9141119,1838241.5576985,8669986.270827,19.1125361,57833.0229132,10688.6219725,55159.8029906,72.2845225,88.5168276,0.1064661,404.0220701),(16449,'umzc_hippo_femur-cleaned.tif',250,7,39,3526.9549456,189.8183953,202.9677267,1.8,196.4519828,200.6656965,-0.1870219,170.9504583,150.0107867,1845942.9681655,8746825.1228587,20.3218915,58307.9744966,10798.1165221,55868.3181429,100.4608321,168.3512937,3.0296133,1056.0629337),(16450,'umzc_hippo_femur-cleaned.tif',250,7,40,3614.6745271,189.4605242,203.0408748,1.8,195.816183,200.4098685,-0.1885286,173.4558984,150.3551224,1919096.190803,8825891.4124203,21.1602601,58700.3041365,11063.8854485,55770.5439877,100.4432437,169.2298391,3.0581217,1061.966563),(16451,'umzc_hippo_femur-cleaned.tif',250,7,41,3683.576214,188.8161272,203.1722476,1.8,195.4668194,200.5582684,-0.1894667,172.0959089,153.133335,1936702.7838873,8886121.5390918,21.7761514,58028.6554694,11253.6247764,56691.7948511,99.1181338,167.4277015,3.0087759,1116.7506527),(16452,'umzc_hippo_femur-cleaned.tif',250,7,42,3713.3409483,188.276513,203.2818848,1.8,194.5011866,201.1676103,-0.1891634,173.6495093,152.2401921,1930438.0769891,8844963.9342996,21.8827278,58098.7439232,11116.8645662,55960.6766408,98.3345037,166.425767,3.0242481,1031.2908621),(16453,'umzc_hippo_femur-cleaned.tif',250,7,43,3755.0062414,187.9928345,203.3361976,1.8,194.70853,201.159957,-0.1930912,174.2316956,152.4754221,1970461.0581155,8874880.9519179,23.0451914,58205.3214234,11309.4293843,56127.1214391,98.8420279,166.300949,3.0769057,1062.022504),(16454,'umzc_hippo_femur-cleaned.tif',250,7,44,3799.5744134,188.0153505,203.480028,1.8,194.6713797,201.2819713,-0.2002465,174.7031925,154.3537693,2023230.4272211,8934126.4194301,25.0553658,57880.8438461,11580.9585314,56904.2879837,97.6143019,165.723124,3.0685521,951.897725),(16455,'umzc_hippo_femur-cleaned.tif',250,7,45,3805.6203793,187.8223491,203.5793199,1.8,194.4185906,201.4475171,-0.2072158,174.2149274,153.7415798,2030374.5768544,8902178.8561445,26.8469493,57903.5213832,11654.4236878,57066.2647605,97.5281347,166.0020907,0.0242867,1025.9554181),(16456,'umzc_hippo_femur-cleaned.tif',250,7,46,3807.9443513,187.9119115,203.6333772,1.8,194.5254695,201.4597038,-0.2109402,173.5772707,153.1370568,2041589.3627185,8863754.3150686,27.823193,57881.1849949,11761.8473558,57983.9857233,98.8977376,164.9176108,3.0804445,1033.584787),(16457,'umzc_hippo_femur-cleaned.tif',250,7,47,3788.6452199,187.6973139,203.5315706,1.8,193.853682,201.5870562,-0.2109268,173.337551,155.29691,2018835.3042743,8762987.983906,27.6787155,56427.3170916,11646.8433567,56749.1535718,98.4520161,164.0751318,3.100632,961.3039756),(16458,'umzc_hippo_femur-cleaned.tif',250,7,48,3748.8559026,187.8536326,203.2128726,1.8,193.7477256,201.0053716,-0.2140039,174.4206402,154.4702338,2042675.5359281,8682295.3142847,28.1806468,56206.9150768,11711.2030637,56294.6998587,98.4682911,163.377576,0.0370201,1124.4871048),(16459,'umzc_hippo_femur-cleaned.tif',250,7,49,3686.0445024,188.1550727,203.0397631,1.8,193.4501123,200.8277055,-0.2143024,172.4230419,154.5904318,2018096.9455386,8500254.4282511,27.78464,54985.6438784,11704.3344307,56181.7848114,98.6702615,162.7616423,0.0454233,1033.4892896),(16460,'umzc_hippo_femur-cleaned.tif',250,7,50,3604.9335154,188.6320668,202.9323603,1.8,193.6101755,201.2373387,-0.2153289,175.6449174,154.0178278,1959685.2945743,8346689.49417,27.4301463,54193.0087676,11157.0851224,53432.7583944,97.2659262,162.1572884,3.087703,922.3072526),(16461,'umzc_hippo_femur-cleaned.tif',250,7,51,3549.5440794,189.2193073,202.7161082,1.8,193.8976476,201.2592749,-0.2178415,175.7604129,154.118955,1904755.8823751,8230806.2526285,27.6326124,53405.5415329,10837.229222,52498.4768185,97.374512,161.7028898,0.0748598,881.6802875),(16462,'umzc_hippo_femur-cleaned.tif',250,7,52,3499.6091175,189.6730342,202.3855015,1.8,193.8769745,200.937481,-0.2214263,175.0849826,153.0137249,1896549.2539775,8114379.2321831,28.1330702,53030.4012838,10832.1640498,51918.3227345,97.0663353,161.6079462,0.0665682,905.8957595),(16463,'umzc_hippo_femur-cleaned.tif',250,7,53,3449.8384436,190.165857,202.1910168,1.8,193.6582348,201.1963443,-0.2200482,174.8281236,151.5199077,1834057.3022117,7950490.5013134,27.3944241,52471.5901659,10490.6308237,50888.4738847,95.8704881,160.9375654,0.0668459,864.116039),(16464,'umzc_hippo_femur-cleaned.tif',250,7,54,3380.4713877,190.7301121,201.8048448,1.8,194.0468343,200.6457714,-0.2292003,175.4579886,153.3697311,1790093.403024,7781868.4508399,29.0829177,50739.2716612,10202.4046728,49668.218775,96.533546,160.2235332,0.062942,886.105113),(16465,'umzc_hippo_femur-cleaned.tif',250,7,55,3310.0451456,191.3219632,201.5912085,1.8,193.7605263,200.7049919,-0.2292805,174.8235347,152.4458624,1728039.1994319,7532968.4333452,28.4966282,49414.0563379,9884.4769493,48645.5443763,95.0058658,160.6469945,0.0292803,902.9101814),(16466,'umzc_hippo_femur-cleaned.tif',250,7,56,3254.2088077,191.9858121,201.0785052,1.8,194.230982,199.5581127,-0.2324977,174.8034286,152.4686075,1730265.5521653,7345020.3536912,28.7933324,48173.9846364,9898.3501965,47071.0730348,0.671875,0.9501748,2.3561945,1.9003496),(16467,'umzc_hippo_femur-cleaned.tif',250,7,57,3191.7254365,192.8469788,200.6954876,1.8,194.6189908,199.287062,-0.2296367,174.6310095,151.7877214,1674526.2048176,7072102.5662248,27.5619299,46592.0596279,9588.9396122,45744.002994,0.671875,0.9501748,2.3561945,1.9003496),(16468,'umzc_hippo_femur-cleaned.tif',250,7,58,3143.7507146,193.6050095,200.38226,1.8,195.0091577,199.7930508,-0.2299504,172.9918236,150.9606987,1571298.6221739,6817386.1664685,27.2205542,45160.0067117,9083.0802815,44139.4664493,92.0860673,159.0812258,0.3899179,826.7331735),(16469,'umzc_hippo_femur-cleaned.tif',250,7,59,3114.6055147,194.0680354,199.8652018,1.8,195.359188,199.3773106,-0.2256176,172.9217404,150.4026375,1531810.8276159,6590445.8625074,25.978623,43818.6854504,8858.4051053,42419.986557,90.9191579,159.2783201,0.1609878,923.0548469),(16470,'umzc_hippo_femur-cleaned.tif',250,7,60,3062.8880065,194.9082292,199.4659325,1.8,196.3938273,199.1686432,-0.2269678,173.3859739,145.8712562,1461482.2763264,6349996.5898333,25.8486544,43531.5137089,8429.0686449,40969.2307867,90.4151107,158.2561692,0.0679802,864.9707164),(16471,'umzc_hippo_femur-cleaned.tif',250,7,61,2995.8993661,195.822541,199.179248,1.8,197.434992,198.849032,-0.2323735,173.3994153,148.1336409,1390421.3831067,6074344.9991785,26.4800134,41005.8442007,8018.6047948,39021.3740379,88.0589576,156.9155494,0.0685619,828.0093967),(16472,'umzc_hippo_femur-cleaned.tif',250,7,62,2948.1923477,196.9167799,198.813097,1.8,198.6922561,198.5343787,-0.2390485,175.2864114,145.9536438,1324209.6496167,5791574.6838219,27.5478797,39680.9187791,7554.5482331,36570.3129833,87.7690309,155.5749836,0.0691536,937.2910841),(16473,'umzc_hippo_femur-cleaned.tif',250,7,63,2923.8287383,197.6860002,198.4682127,1.8,199.6749089,198.0552884,-0.2449615,171.2319156,145.9193455,1273679.3688754,5556092.3725252,28.6610459,38076.4617273,7438.3292651,36466.4467691,87.0000269,154.9527975,0.0737789,931.2524011),(16474,'umzc_hippo_femur-cleaned.tif',250,7,64,2877.3743311,198.2078944,198.1376834,1.8,200.109103,197.6525201,-0.2465402,173.274492,143.1415885,1233099.1402638,5285661.4252746,28.5629848,36926.1056868,7116.4493161,34157.6870523,84.8593779,154.2169114,0.1486745,877.716564),(16475,'umzc_hippo_femur-cleaned.tif',250,7,65,2837.23373,199.0378749,197.7785889,1.8,201.2857369,197.5970104,-0.2567175,174.4026855,144.8893867,1159539.3225658,5008940.3919009,30.4854785,34570.7888223,6648.6322697,31855.8744123,83.5358418,152.7285916,0.0528143,860.1127593),(16476,'umzc_hippo_femur-cleaned.tif',250,7,66,2808.6563568,198.9108959,197.5852395,1.8,202.0510133,197.5315765,-0.2635912,169.9131754,147.2200484,1099285.0556678,4874901.8875676,31.7780716,33113.030067,6469.6869631,31800.3982773,82.5724527,152.1021817,0.3944513,863.0983373),(16477,'umzc_hippo_femur-cleaned.tif',250,7,67,2758.8071639,199.8959538,196.8358759,1.8,203.3049153,196.3953805,-0.2646181,175.8933012,142.7182695,1089041.7857081,4610197.1258104,31.4520236,32302.7818561,6191.4909665,29368.1508272,81.9471964,150.4910108,0.0938935,887.6282721),(16478,'umzc_hippo_femur-cleaned.tif',250,7,68,2605.1618217,203.4177831,195.4543184,1.8,207.3989416,194.8815928,-0.2586338,170.0773204,136.9089085,1050036.2165782,3870118.3009819,28.4019983,28267.8340079,6173.8755901,25804.461124,80.4322728,132.4684754,0.0405868,771.408869),(16479,'umzc_hippo_femur-cleaned.tif',250,7,69,2536.3478189,205.2675309,194.4879008,1.8,209.9087236,193.4136553,-0.254133,171.0500185,138.5712016,1015790.4047789,3421232.4745962,26.7183818,24689.3469567,5938.557703,22768.4607554,79.9383717,128.3351682,3.1311218,703.1593078),(16480,'umzc_hippo_femur-cleaned.tif',250,7,70,2502.8056896,206.12108,193.9005078,1.8,211.2111506,192.630608,-0.2498531,165.3878758,137.7835959,990214.7767766,3195959.3939035,25.5028939,23195.4999642,5987.2271282,22109.8286941,78.7375093,126.5588601,0.4327786,681.9573844),(16481,'umzc_hippo_femur-cleaned.tif',250,7,71,2465.86002,206.3455958,193.6265679,1.8,211.1323021,192.5760983,-0.2498371,170.8829509,138.6465805,959612.252539,3024245.1247437,25.1232711,21812.619636,5615.611432,20473.2396463,78.9702294,123.714437,3.1035675,653.2611457),(16482,'umzc_hippo_femur-cleaned.tif',250,7,72,2427.5194747,206.6954055,193.295497,1.8,211.5293924,192.1494123,-0.2510758,168.1442095,136.8276997,945724.6816109,2866472.18163,24.9733087,20949.5020945,5624.4855788,19930.1167216,78.0877147,121.7596265,3.0919098,631.3955396),(16483,'umzc_hippo_femur-cleaned.tif',250,7,73,2391.3323208,207.2507871,192.9211687,1.8,211.5632228,191.9224019,-0.2491099,168.6868687,136.7385326,919178.3542064,2691910.295272,24.2252694,19686.5524585,5449.0213802,19118.4282912,77.3197831,119.1115264,3.0851555,628.5845716),(16484,'umzc_hippo_femur-cleaned.tif',250,7,74,2357.6919744,207.7486613,192.4689222,1.8,211.896877,191.2845875,-0.2600891,163.2950403,134.030958,904821.7934021,2565205.5084546,25.9875492,19138.9030351,5541.0243414,19018.903185,77.0738329,117.9690895,0.1717029,648.1726375),(16485,'umzc_hippo_femur-cleaned.tif',250,7,75,2333.031388,208.049892,192.1347743,1.8,212.1765311,190.9440066,-0.2605977,173.3392395,135.2923116,897383.0544142,2468198.698056,25.8141065,18243.4513041,5177.0335272,17039.3388167,77.900086,116.4051384,0.3783628,626.7121925),(16486,'umzc_hippo_femur-cleaned.tif',250,7,76,2315.3405289,208.1596813,191.7064891,1.8,212.3078709,190.1828928,-0.265487,168.7010459,135.7210685,903872.6828918,2396794.0495578,26.5657872,17659.7051265,5357.8368637,17063.1020483,75.5458522,115.2887454,0.3696843,616.4908208),(16487,'umzc_hippo_femur-cleaned.tif',250,7,77,2309.3736292,208.2414421,191.2543604,1.8,212.439261,189.7016935,-0.2722365,168.048903,134.9951025,900580.4223509,2332339.2820101,27.8278739,17277.214059,5359.0377938,17069.6351679,75.8662251,113.8387131,0.1302114,630.6759159),(16488,'umzc_hippo_femur-cleaned.tif',250,7,78,2303.3559794,208.2373752,190.8937375,1.8,212.291894,189.3898381,-0.2704508,172.1115433,135.9792604,901838.0294235,2267803.2831748,27.4013317,16677.5674194,5239.8462787,16226.6042972,74.533638,112.8210042,0.3274002,588.7052006),(16489,'umzc_hippo_femur-cleaned.tif',250,7,79,2301.3386967,208.2688904,190.5721701,1.8,212.1308286,189.0344118,-0.2788909,173.4154978,135.55173,896027.7186143,2203438.1823262,29.0675704,16255.3305869,5166.9414216,15807.5063001,74.7325808,111.792012,0.3883187,578.3208047),(16490,'umzc_hippo_femur-cleaned.tif',250,7,80,2303.7258669,208.2669864,190.1253245,1.8,211.8977883,188.1827404,-0.290681,173.2173462,135.7406309,913123.1817238,2154043.364858,31.5388743,15868.8179819,5271.5458455,15745.0483602,74.2304374,110.0419744,0.3816402,559.3732499),(16491,'umzc_hippo_femur-cleaned.tif',250,7,81,2323.27273,208.4835201,189.6485876,1.8,211.8531641,187.8771184,-0.3063905,170.9317842,137.1060882,916265.0639902,2084901.5583296,35.2262861,15206.4841595,5360.41362,15919.4848946,74.2006742,108.7960515,0.3862403,449.9680946),(16492,'umzc_hippo_femur-cleaned.tif',250,7,82,2357.9235645,208.4990234,189.0014217,1.8,211.3538986,187.3341267,-0.3178518,168.4240106,138.5665996,922254.3596439,2015810.8931516,38.3842104,14547.5958799,5475.789091,15631.0444726,74.1892695,107.8103011,0.3967087,448.5568176),(16493,'umzc_hippo_femur-cleaned.tif',250,7,83,2433.7204268,208.5101821,187.9093126,1.8,211.447137,186.0619765,-0.3336928,174.1897792,135.1391953,967609.4571741,1989668.8612252,43.5144106,14723.1072153,5554.9152285,15477.4255676,0.9501748,1.9003496,2.3561945,3.8006992),(16494,'umzc_hippo_femur-cleaned.tif',250,7,84,2468.1300957,208.3603709,187.2111417,1.8,211.4118961,185.6972363,-0.3471796,171.5535967,140.1661974,994618.6442552,1949881.2113637,47.6217751,13911.2086078,5797.7137379,15655.1288108,75.2064581,105.9476854,0.1849584,471.0349643),(16495,'umzc_hippo_femur-cleaned.tif',250,7,85,2447.3380082,208.0712509,187.0363782,1.8,211.2718746,185.3666721,-0.3572103,176.1161192,141.2841704,996569.6558401,1893841.5195656,49.8700357,13404.4848376,5658.59423,15089.7904093,74.5777585,104.6163595,0.1482548,452.8861458),(16496,'umzc_hippo_femur-cleaned.tif',250,7,86,2402.2000944,207.9406751,187.0235539,1.8,211.3585255,184.6369101,-0.3689287,173.752397,139.4635663,999379.3347752,1871276.9635416,52.0653817,13417.6761194,5751.7441616,15073.5534658,74.3404702,104.227289,0.2011882,420.0515737),(16497,'umzc_hippo_femur-cleaned.tif',250,7,87,2365.5802651,207.7675588,187.0468263,1.8,210.8959463,184.2388128,-0.3543482,174.7770964,141.0337118,1005595.3553881,1838710.8859431,47.4671484,13037.3856191,5753.5877185,14904.1416269,74.5763295,101.7641199,0.1390959,455.4781486),(16498,'umzc_hippo_femur-cleaned.tif',250,7,88,2348.6290444,207.6018282,187.0624699,1.8,210.6271038,184.0392046,-0.3756533,174.5631639,140.4954315,996887.2064053,1808635.1918921,52.6880451,12873.2669276,5710.7535398,14748.1655063,74.8914069,101.5954157,0.4370267,440.3033224),(16499,'umzc_hippo_femur-cleaned.tif',250,7,89,2334.7649625,207.557773,186.9982362,1.8,210.3684186,183.9757682,-0.3617697,174.8135203,140.9728066,985511.2532415,1776985.9612124,48.7445887,12605.1683594,5637.5001864,14598.9196854,73.7507034,101.098777,0.1400174,443.6149489),(16500,'umzc_hippo_femur-cleaned.tif',250,7,90,2310.9728732,207.5352768,186.930934,1.8,209.9233962,184.1749178,-0.358789,174.6896928,140.3326553,968111.4547495,1721655.7207759,47.4903859,12268.3898267,5541.8922508,14079.5869107,0.671875,0.9501748,2.3561945,1.9003496),(16501,'umzc_hippo_femur-cleaned.tif',250,7,91,2304.6527746,207.6169502,186.5574684,1.8,210.9791409,182.7462134,-0.3988573,176.6551845,143.352825,988830.2907576,1778852.0375747,57.9342858,12408.9081474,5597.51639,14747.325125,0.671875,0.9501748,2.3561945,1.9003496),(16502,'umzc_hippo_femur-cleaned.tif',250,7,92,2296.0720391,207.3718495,186.5179781,1.8,209.8965391,182.970789,-0.3682498,174.7502933,141.6153597,991985.3914391,1702067.7263424,49.5905022,12018.9485809,5676.5878469,14335.1381687,74.0531074,98.8843948,0.4879589,442.962852),(16503,'umzc_hippo_femur-cleaned.tif',250,7,93,2287.466544,207.4289658,186.2766663,1.8,210.6686503,182.344053,-0.3993147,176.7496652,143.7949145,995296.7912095,1718591.5166114,57.627146,11951.6849597,5631.1099081,14245.9744787,74.0478255,98.3901299,0.3411866,428.5472058),(16504,'umzc_hippo_femur-cleaned.tif',250,7,94,2278.7312326,207.3720491,186.1176419,1.8,210.8627121,181.8495047,-0.3964742,171.8521048,143.5622849,999015.3620488,1720341.9612232,56.63638,11983.2445041,5813.2273857,14608.0781089,74.0600645,98.0339134,0.2000837,436.7727306),(16505,'umzc_hippo_femur-cleaned.tif',250,7,95,2271.5939341,207.2236178,186.1411368,1.8,210.0554391,182.0518175,-0.376078,173.3526419,142.3873962,992223.9712495,1666203.8683225,51.069686,11701.905594,5723.7314681,14078.0021099,74.781998,97.5121948,0.2082059,450.4967235),(16506,'umzc_hippo_femur-cleaned.tif',250,7,96,2250.7582098,207.2779245,186.1430401,1.8,210.1362127,181.8487034,-0.3845069,176.9806214,142.7419374,983663.5073093,1637900.1463075,52.7808577,11474.5545463,5558.0294598,13772.0824836,74.1163348,96.1626655,0.4480239,449.6140756),(16507,'umzc_hippo_femur-cleaned.tif',250,7,97,2232.6943169,207.2621042,186.2260894,1.8,209.4631906,182.437031,-0.3652884,176.6329861,140.391985,959449.9843214,1560577.7305704,47.4838952,11115.8605702,5431.8845292,13106.9612074,0.671875,0.9501748,2.3561945,1.9003496),(16508,'umzc_hippo_femur-cleaned.tif',250,7,98,2213.8591865,207.2734652,186.142893,1.8,209.4373318,182.1926567,-0.3703899,171.4176511,142.689408,961157.157608,1520653.9470659,48.3465202,10657.0905916,5607.1072705,13408.7910463,0.671875,0.9501748,2.3561945,1.9003496),(16509,'umzc_hippo_femur-cleaned.tif',250,7,99,2213.0801518,207.1861804,185.9561269,1.8,209.895831,181.8278826,-0.3650358,172.4969568,141.8675113,962716.9576948,1529467.2568343,47.0046003,10780.9550147,5581.0663316,13494.4998768,74.3098312,93.5668921,0.1804958,449.9121535),(16510,'umzc_hippo_femur-cleaned.tif',250,7,100,2207.5605643,206.9941531,185.8664054,1.8,209.7214644,181.7011466,-0.3658235,169.2719393,140.7837022,958619.4425905,1500528.9220502,47.0808047,10658.3993646,5663.1917039,13755.0650224,73.731141,93.3132607,0.2921464,439.7862792),(16511,'umzc_hippo_femur-cleaned.tif',250,7,101,2201.9701183,207.0597369,185.6772026,1.8,210.4154101,180.8610603,-0.3939593,173.5034716,142.432302,970555.5288545,1521529.4100269,54.0726164,10682.47433,5593.868064,13227.6771114,72.323273,92.9545859,0.3697685,425.5616278),(16512,'umzc_hippo_femur-cleaned.tif',250,7,102,2193.7603646,206.8942419,185.7931037,1.8,209.6691742,181.7670579,-0.357846,173.6458725,141.7418742,950122.0862485,1444982.8236591,44.8552009,10194.4667472,5471.6076616,12650.3214506,0.9501748,1.9003496,2.3561945,3.8006992),(16513,'umzc_hippo_femur-cleaned.tif',250,7,103,2181.8469473,206.8088191,185.7797737,1.8,209.5033199,181.5346888,-0.3725377,174.5841156,142.1960511,947375.6892827,1423742.6656902,48.1757554,10012.5330804,5426.471281,12436.2975232,73.1638111,92.4603568,0.3953501,420.6477296),(16514,'umzc_hippo_femur-cleaned.tif',250,7,104,2175.9978262,206.7826721,185.6972268,1.8,209.5898709,181.2531721,-0.4046769,174.3133912,144.654202,946056.4411255,1399972.4521989,56.2193848,9678.0628088,5427.3308252,12650.115347,0.671875,0.9501748,2.3561945,1.9003496),(16515,'umzc_hippo_femur-cleaned.tif',250,7,105,2168.9625751,206.7784325,185.8247653,1.8,209.2843672,181.6148288,-0.4082456,179.4376539,143.3923667,932655.0899363,1358595.7206802,56.9745964,9474.6725513,5197.6553962,11926.7487124,73.6324874,89.8455464,0.4736807,416.9145572),(16516,'umzc_hippo_femur-cleaned.tif',250,7,106,2150.0585011,206.8450241,185.9012281,1.8,209.3232086,181.5285151,-0.4068706,178.2056561,142.642621,920556.6742849,1332848.2632682,56.1194172,9343.9692434,5165.6984089,11782.3646712,73.4605692,90.1214623,0.3500449,422.969625),(16517,'umzc_hippo_femur-cleaned.tif',250,7,107,2135.036195,206.8273404,185.9906262,1.8,209.1203771,181.6209459,-0.4194402,178.7986641,144.9324393,912750.9515629,1292129.1198712,59.0166478,8915.3893105,5104.909234,11525.836703,0.671875,0.9501748,2.3561945,1.9003496),(16518,'umzc_hippo_femur-cleaned.tif',250,7,108,2126.8791066,206.6997309,186.0624326,1.8,208.9345661,181.8219824,-0.4346431,177.1249421,146.0365093,899491.4174719,1262355.8219347,62.8542349,8644.1111736,5078.2877158,11664.6358583,73.5387522,87.8385081,0.5115561,408.6494762),(16519,'umzc_hippo_femur-cleaned.tif',250,7,109,2118.0227336,206.4368933,186.0777025,1.8,208.2483198,181.8674664,-0.395705,175.9729935,141.5894716,911954.3428649,1219927.7385044,52.4487656,8615.9495117,5182.3539765,11348.5449633,74.1623591,87.0227328,0.2337432,407.9973793),(16520,'umzc_hippo_femur-cleaned.tif',250,7,110,2107.9781788,206.3894735,186.0770282,1.8,208.5207632,181.7502624,-0.4652678,178.8897985,144.1886403,892842.1261841,1213324.019552,70.721859,8414.8377927,4991.0175626,11276.4915854,0.671875,0.9501748,2.3561945,1.9003496),(16521,'umzc_hippo_femur-cleaned.tif',250,7,111,2103.6567591,206.2373384,186.178323,1.8,208.0209297,182.3445101,-0.4500075,166.3300703,140.5467958,873916.128214,1171820.5767501,66.3356106,8337.5830082,5254.1078497,11604.2924115,73.4954921,85.9685055,0.4356829,425.2635498),(16522,'umzc_hippo_femur-cleaned.tif',250,7,112,2103.2422771,206.0742582,186.2054245,1.8,208.1269324,182.4876494,-0.4320102,176.6585949,144.8718539,868536.5696453,1162896.7021989,61.4522825,8027.0713117,4916.4693628,10880.9878087,72.873616,85.3360655,0.4566055,407.2777556),(16523,'umzc_hippo_femur-cleaned.tif',250,7,113,2100.2086243,205.9319295,186.3441884,1.8,207.2913374,183.3070049,-0.3782002,172.9998553,143.2526248,854699.6674575,1104875.8827465,47.7252823,7712.7793239,4940.4646369,10667.6394892,72.9418437,84.91448,0.2641702,411.9890732),(16524,'umzc_hippo_femur-cleaned.tif',250,7,114,2099.1317917,205.8246465,186.3167683,1.8,207.4982027,182.9478179,-0.3814227,166.8999984,143.0148985,855246.5947729,1104166.3416181,48.4772078,7720.6385688,5124.3055891,10889.697028,0.671875,0.9501748,2.3561945,1.9003496),(16525,'umzc_hippo_femur-cleaned.tif',250,7,115,2100.9687816,205.6565207,186.2691627,1.8,207.0106557,182.8355836,-0.3435205,171.2286125,141.2112101,868399.8246582,1085893.0059017,39.7212292,7689.849874,5071.5812736,10403.6112345,73.1558004,84.1749765,0.2914568,385.9407784),(16526,'umzc_hippo_femur-cleaned.tif',250,7,116,2102.1438313,205.5963639,186.2874922,1.8,207.3403626,182.9499906,-0.3772376,176.7238101,142.7255966,857770.6732358,1082430.6991081,47.5380317,7583.9984205,4853.7357414,10174.711243,73.4884997,83.2176301,0.3805064,397.5734271),(16527,'umzc_hippo_femur-cleaned.tif',250,7,117,2090.3717209,205.3828374,186.4640806,1.8,206.8118978,183.6961802,-0.3263925,172.5327897,141.0012462,833919.8992018,1038986.4500587,35.8158563,7368.6331014,4833.3994976,9823.8914284,0.671875,0.9501748,2.3561945,1.9003496),(16528,'umzc_hippo_femur-cleaned.tif',250,7,118,2089.3838037,205.2899997,186.5333282,1.8,206.7217941,183.8540344,-0.3184865,164.5247169,139.8362855,829412.6742982,1026218.5191022,34.1440479,7338.7140906,5041.264861,10363.5290099,0.671875,0.9501748,2.3561945,1.9003496),(16529,'umzc_hippo_femur-cleaned.tif',250,7,119,2088.592868,205.1925676,186.6292485,1.8,206.5276006,183.9910848,-0.3189479,171.3952666,138.7316653,823827.0755671,1012498.2461904,34.2267154,7298.249062,4806.5917579,9749.0129234,71.8906295,82.4410115,0.3320595,397.5734271),(16530,'umzc_hippo_femur-cleaned.tif',250,7,120,2085.3655166,205.0761283,186.6577924,1.8,206.5052291,183.8009358,-0.2961032,163.8845798,140.9009618,824423.6475859,1011349.16427,29.5928862,7177.7307342,5030.5138434,10080.4530847,71.5291378,82.2463971,0.2984989,406.6140729),(16531,'umzc_hippo_femur-cleaned.tif',250,7,121,2081.8320231,204.9883968,186.8506176,1.8,206.012003,184.6046336,-0.2356988,162.7215189,132.7954054,799069.7781016,973434.4995391,18.9213513,7330.3326751,4910.6583056,9595.3145498,71.8268103,81.5269909,0.1488899,397.2753491),(16532,'umzc_hippo_femur-cleaned.tif',250,7,122,2071.5378216,204.9576343,186.9923851,1.8,205.6807629,185.0242613,-0.190979,158.7173271,129.4962896,781869.7915616,950696.3676827,12.4401746,7341.4950368,4926.1779156,9108.2087805,0.671875,0.9501748,2.3561945,1.9003496),(16533,'umzc_hippo_femur-cleaned.tif',250,7,123,2061.5979133,204.9085351,187.1195056,1.8,205.5885238,185.2972538,-0.1817068,154.9804272,133.3216322,768271.9690759,932256.1083423,11.2204474,6992.5344657,4957.219326,9212.4773623,71.5811265,80.3698487,0.4037941,406.2204976),(16534,'umzc_hippo_femur-cleaned.tif',250,7,124,2054.057213,204.8916059,187.1356769,1.8,205.8721111,184.9408229,-0.2196007,157.1822882,130.2637569,769424.1546597,932625.6585361,16.2456253,7159.5175856,4895.1072251,9267.4913533,71.2187545,80.023674,0.0419921,405.0397717),(16535,'umzc_hippo_femur-cleaned.tif',250,7,125,2043.3325247,204.7985149,187.300705,1.8,205.6065443,185.3900045,-0.1640467,153.1429887,125.5147616,751960.8038349,912627.1515498,9.0828804,7271.0742554,4910.1875975,9124.1242286,70.1611572,79.1102549,0.3647348,393.8682252),(16536,'umzc_hippo_femur-cleaned.tif',250,7,126,2027.9140667,204.7928614,187.4732294,1.8,205.5422179,185.6820775,-0.1658633,156.2477843,127.6317195,735781.297831,895263.1592613,9.2132508,7014.4252769,4709.0670843,9023.3941759,70.6939486,78.8272937,0.3298366,414.8116271),(16537,'umzc_hippo_femur-cleaned.tif',250,7,127,2021.7248788,204.7273332,187.6169868,1.8,205.4666215,185.841758,-0.1569075,154.3034082,126.1532001,726771.185048,883211.1550045,8.2279404,7001.0998875,4710.0138187,8731.8649751,69.3601528,78.6409574,0.348771,401.3065994),(16538,'umzc_hippo_femur-cleaned.tif',250,7,128,2016.5099288,204.6807708,187.7401044,1.8,205.6097011,185.9801278,-0.1555216,152.99485,129.2538026,721996.8486228,875664.169033,8.0635518,6774.7652421,4719.0924971,8817.3087275,69.0329771,77.8563743,0.3708913,405.2423523),(16539,'umzc_hippo_femur-cleaned.tif',250,7,129,2012.5603118,204.7007569,187.9155128,1.8,205.4930414,186.0740584,-0.152593,152.1816234,128.80569,710982.6600309,860129.1212734,7.7498535,6677.726127,4671.9350467,8663.9668431,0.671875,1.5023583,2.0344439,3.2440997),(16540,'umzc_hippo_femur-cleaned.tif',250,7,130,2005.2190553,204.6351421,188.047476,1.8,205.4889684,186.500094,-0.1473908,146.1719111,125.1248364,694412.2374456,841704.4750758,7.20782,6726.9176869,4750.654432,9239.4340008,0.671875,0.9501748,2.3561945,1.9003496),(16541,'umzc_hippo_femur-cleaned.tif',250,7,131,1986.6636661,204.6401354,188.0929782,1.8,205.5228729,186.5309187,-0.1291464,141.6158141,127.1019796,684204.7118238,827961.3962347,5.4918881,6514.1502814,4831.4146008,8509.3869489,68.9096301,76.6055412,0.266252,370.8055085),(16542,'umzc_hippo_femur-cleaned.tif',250,7,132,1976.2791813,204.5757317,188.3224171,1.8,205.4029388,186.7592087,-0.1073983,150.5551006,119.9441968,677632.006805,817475.6234605,3.7846148,6815.4662374,4500.8903998,8052.8116325,0.671875,2.7702118,1.815775,5.9315998),(16543,'umzc_hippo_femur-cleaned.tif',250,7,133,1971.2810479,204.5776009,188.4782417,1.8,205.5304648,187.024959,-0.1331099,150.4329068,124.0596985,664982.0699489,807325.1056425,5.7869693,6507.5533413,4420.4561631,7942.7633376,0.671875,4.0868563,1.735945,8.6191),(16544,'umzc_hippo_femur-cleaned.tif',250,7,134,1960.6129917,204.5486573,188.6306441,1.8,205.378719,187.1712765,-0.1284773,153.9028571,116.6297978,657284.9270993,797601.1472391,5.3641668,6838.7424351,4270.7779396,7759.2859022,67.5865463,75.6568291,0.3442187,405.7034544),(16545,'umzc_hippo_femur-cleaned.tif',250,7,135,1957.2473429,204.5130075,188.7636471,1.8,205.4039986,187.5244053,-0.12693,131.4595527,126.9136354,644544.1734559,785770.2933879,5.2274423,6191.3780245,4902.9846824,8276.4234921,67.6656788,76.4462718,0.2215288,373.003936),(16546,'umzc_hippo_femur-cleaned.tif',250,7,136,1952.6703943,204.4996098,188.8576248,1.8,205.18948,187.4320542,-0.0858143,147.4445462,122.498985,643583.327144,781415.3645459,2.39073,6378.9537875,4364.9178203,7623.2041733,67.3665301,75.9426872,0.2321038,382.2076061),(16547,'umzc_hippo_femur-cleaned.tif',250,7,137,1952.5338752,204.5859285,189.005362,1.8,205.3919587,187.7120814,-0.1169438,149.7375953,112.5347457,631547.5850316,769085.7825035,4.4301759,6834.2073182,4217.6955218,7686.5054438,1.3437501,5.4168298,1.6951513,12.4197992),(16548,'umzc_hippo_femur-cleaned.tif',250,7,138,1944.3769235,204.5971937,189.1113952,1.8,205.3723219,187.8987097,-0.1073676,151.4749862,122.1254704,621922.8095615,758753.2275546,3.7214005,6212.8991199,4105.7789475,7210.1623657,66.5156292,74.6265374,0.3587707,383.090254),(16549,'umzc_hippo_femur-cleaned.tif',250,7,139,1934.5688834,204.5907681,189.215249,1.8,205.2748448,187.9767244,-0.0832966,149.4373758,124.4656211,616704.6982199,751714.2522779,2.2319418,6039.5332111,4126.8437367,7143.5259716,66.4516615,74.7262793,0.5805214,395.5775801),(16550,'umzc_hippo_femur-cleaned.tif',250,7,140,1922.6437019,204.5620429,189.343613,1.8,205.2844828,188.2736395,-0.0868828,149.8829287,123.9861821,607108.2947245,739780.6513694,2.4128036,5966.6378858,4050.549987,7027.6580794,1.3437501,9.4302156,1.6421038,19.9257002),(16551,'umzc_hippo_femur-cleaned.tif',250,7,141,1913.2645071,204.5460252,189.4890469,1.8,205.3395763,188.4993332,-0.1046378,148.3303565,125.2743225,596808.5970507,730173.4936081,3.4786884,5828.5966254,4023.5094894,7568.3567664,1.3437501,9.501748,1.7126934,19.9257002),(16552,'umzc_hippo_femur-cleaned.tif',250,7,142,1905.7220285,204.5969345,189.6335045,1.8,205.2269081,188.6223961,-0.1051374,137.9461836,118.5628408,589952.69719,722922.6402021,3.498017,6097.3795436,4276.6873409,7314.5894565,65.1718791,73.3698621,0.3652014,404.6577822),(16553,'umzc_hippo_femur-cleaned.tif',250,7,143,1900.5838193,204.5783046,189.7309182,1.8,205.0943053,188.7040395,-0.09187,142.7031581,114.0285193,587356.779235,716441.3430953,2.6660037,6283.0013728,4115.9339923,7220.0707531,0.671875,0.9501748,2.3561945,1.9003496),(16554,'umzc_hippo_femur-cleaned.tif',250,7,144,1896.0216443,204.5920038,189.8132602,1.8,205.114888,188.8629866,-0.0947783,144.6361175,128.3754989,581645.6021439,710441.7958849,2.8301477,5534.0918012,4021.4409254,7060.2836928,65.1177265,72.6743974,0.3392926,371.890737),(16555,'umzc_hippo_femur-cleaned.tif',250,7,145,1892.3175702,204.6611998,189.9241632,1.8,205.1315254,189.0553998,-0.0874396,110.5776701,90.8256586,574720.7735114,701021.9265835,2.4052022,7718.3247295,5197.4397068,8939.4004344,1.3437501,10.8336595,1.6951513,23.7263994),(16556,'umzc_hippo_femur-cleaned.tif',250,7,146,1886.0986983,204.6514289,189.994558,1.8,205.1422791,189.1442175,-0.0688854,128.1174548,121.5431152,569717.595512,694495.1638585,1.4892934,5713.9819284,4446.8382269,7158.7085997,64.8663782,72.6029302,0.1955807,347.7032355),(16557,'umzc_hippo_femur-cleaned.tif',250,7,147,1885.3557768,204.6920566,190.0523445,1.8,205.0980149,189.1496924,-0.0551502,138.9829151,117.9290462,568892.7867093,690974.9778774,0.9547638,5859.2433348,4093.2569741,6911.9757124,1.3437501,7.4211024,1.6614562,16.4510495),(16558,'umzc_hippo_femur-cleaned.tif',250,7,148,1881.4203862,204.6969772,190.1403746,1.8,205.1684091,189.116761,-0.0752591,137.1037464,123.4384135,569144.021776,685372.8122559,1.7726887,5552.3462508,4151.1923398,7019.5319197,1.3437501,6.0840873,1.6814535,14.3201488),(16559,'umzc_hippo_femur-cleaned.tif',250,7,149,1878.7028615,204.6639674,190.224473,1.8,205.0780656,189.1918028,-0.0541017,138.5760994,126.3254556,565494.4126071,681801.8779016,0.9155995,5397.1851904,4080.749964,7015.1295054,63.1562539,72.1444891,3.057678,369.7878069),(16560,'umzc_hippo_femur-cleaned.tif',250,7,150,1879.043749,204.6592032,190.3108785,1.8,205.0359477,189.473207,-0.0531107,114.5232167,112.234308,558778.7610093,674315.7601563,0.8825531,6008.1072532,4879.1745191,7854.8016236,64.500004,71.5759806,2.9718144,349.373034),(16561,'umzc_hippo_femur-cleaned.tif',250,7,151,1874.0434269,204.6230545,190.373878,1.8,204.9444114,189.5374829,-0.029383,128.2418895,119.4165496,557509.4824358,670733.6190951,0.2695848,5616.7559784,4347.3274169,7180.1075935,62.4843789,71.269444,0.037718,378.637458),(16562,'umzc_hippo_femur-cleaned.tif',250,7,152,1869.6557994,204.5948949,190.42971,1.8,204.9637471,189.6012034,-0.0212535,125.9489229,126.0248188,553742.5978398,663188.3314951,0.1407365,5262.3629063,4396.5647759,6830.0773548,62.8907424,70.9074905,2.921896,369.13571),(16563,'umzc_hippo_femur-cleaned.tif',250,7,153,1864.6253829,204.6649996,190.5690948,1.8,204.8378915,189.7649946,-0.0134473,141.270348,130.2146193,549857.6712128,656960.4172531,0.0561929,5045.2124413,3892.2369698,6281.3241866,2.0156251,8.1737127,1.735945,19.6951491),(16564,'umzc_hippo_femur-cleaned.tif',250,7,154,1853.3622783,204.6385273,190.6878542,1.8,204.7453311,189.8467275,0.0077327,136.646663,129.0011203,542426.6845745,646762.5905082,0.018468,5013.6199501,3969.5567586,6419.5410561,1.3437501,7.5117913,1.7506498,16.4510495),(16565,'umzc_hippo_femur-cleaned.tif',250,7,155,1844.7705993,204.6343341,190.7742018,1.8,204.8081505,189.8653081,-0.0009145,142.5131614,131.2782763,539669.0731411,641498.2133766,0.0002569,4886.5526829,3786.8016399,6240.6644355,63.12545,70.7641045,0.2104302,360.4211126),(16566,'umzc_hippo_femur-cleaned.tif',250,7,156,1842.9918832,204.6213199,190.835173,1.8,204.7745958,190.0428921,-0.008244,142.1892267,129.5472735,536502.9148105,636089.800401,0.0208767,4910.0979376,3773.1614925,6095.9968219,63.12631,70.4187869,3.0172377,366.0546345),(16567,'umzc_hippo_femur-cleaned.tif',250,7,157,1841.7012436,204.5952823,190.8698861,1.8,204.6781351,190.0501529,-0.0065944,141.3335794,131.8285677,536359.3782038,633186.9596733,0.0133475,4803.1088458,3794.9889929,6110.071995,1.3437501,6.8518079,1.3734008,15.6638989),(16568,'umzc_hippo_femur-cleaned.tif',250,7,158,1839.4873898,204.5644353,190.9484291,1.8,204.6665557,190.2102729,0.0109246,139.9260007,134.1573622,532146.5867797,628690.9509,0.0365879,4686.2202771,3803.0572176,6097.7039796,63.6630697,70.0621036,2.7165525,392.3730367),(16569,'umzc_hippo_femur-cleaned.tif',250,7,159,1838.3320382,204.5552143,191.0429073,1.8,204.6548162,190.2964369,0.0125991,134.4362534,128.2865886,528303.5189448,622922.416869,0.0486331,4855.7095763,3929.7697283,6262.7040508,2.0156251,6.0840873,1.6814535,14.1571246),(16570,'umzc_hippo_femur-cleaned.tif',250,7,160,1837.1493281,204.5218691,191.1057156,1.8,204.6435112,190.3868587,0.0148195,142.8058617,129.7603676,527475.0618157,620263.8225547,0.0672405,4780.071403,3693.6513367,6049.5447339,0.671875,0.9501748,2.3561945,1.9003496),(16571,'umzc_hippo_femur-cleaned.tif',250,7,161,1837.8822636,204.5654463,191.1919013,1.8,204.5902039,190.2814461,0.0640185,141.4557085,141.3677856,527730.2075683,619373.3896934,1.2536737,4381.2908793,3730.7098677,5944.3514832,62.6593618,70.1136294,0.3217506,374.2126324),(16572,'umzc_hippo_femur-cleaned.tif',250,7,162,1834.2817417,204.5387535,191.2953452,1.8,204.5710045,190.4622148,0.0758812,144.5795921,141.2517638,522813.4756461,613450.0412333,1.7569114,4342.9549105,3616.0945534,6006.0345372,63.0708847,69.748914,2.9082957,353.3087869),(16573,'umzc_hippo_femur-cleaned.tif',250,7,163,1826.9809759,204.5144988,191.3579516,1.8,204.583955,190.4813923,0.0807297,138.9177324,142.1662644,520009.9185157,608636.090451,1.9801829,4281.1569472,3743.2940301,5874.1209884,62.8774155,69.9686165,0.2030452,362.6475106),(16574,'umzc_hippo_femur-cleaned.tif',250,7,164,1822.6256315,204.477191,191.4136974,1.8,204.6134058,190.4515703,0.0803454,144.8551379,136.7262125,519568.2809068,605531.3125387,1.9567408,4428.7872936,3586.8129263,5967.9495984,62.7507055,70.0331038,0.0672063,352.3865826),(16575,'umzc_hippo_femur-cleaned.tif',250,7,165,1820.9805619,204.4520219,191.5006674,1.8,204.572698,190.6602833,0.0503271,135.1871094,121.2726772,515918.2403165,600148.2025777,0.7680527,4948.7503385,3816.3271819,6348.2252085,0.671875,0.9501748,2.3561945,1.9003496),(16576,'umzc_hippo_femur-cleaned.tif',250,7,166,1816.8819776,204.4499806,191.5595167,1.8,204.6474095,190.7603014,0.0534311,140.50524,121.4190276,512864.4086695,596860.1188383,0.8636745,4915.70498,3650.1443546,6769.1509392,0.671875,3.4259039,1.7681919,7.2753499),(16577,'umzc_hippo_femur-cleaned.tif',250,7,167,1816.0212776,204.3914272,191.6074413,1.8,204.4601494,190.8262667,0.1002865,132.6009664,142.1475792,513018.5246077,595801.9118696,3.0338768,4191.431999,3868.8897863,6010.1470631,0.671875,4.750874,1.7126934,9.9628501),(16578,'umzc_hippo_femur-cleaned.tif',250,7,168,1813.1405591,204.3640387,191.6627358,1.8,204.4362385,190.7972853,0.0981824,142.3801218,145.0807983,512834.1876797,593566.4934538,2.903701,4091.2822408,3601.8664776,5711.9254721,0.671875,10.1004966,1.6373645,20.7128508),(16579,'umzc_hippo_femur-cleaned.tif',250,7,169,1812.1222739,204.4562225,191.7970142,1.8,204.525171,191.0759382,0.1114015,127.888308,122.6841976,506660.1380145,588108.8789304,3.7326783,4793.6807724,3961.739317,6177.4670075,1.3437501,9.501748,1.7126934,20.4822997),(16580,'umzc_hippo_femur-cleaned.tif',250,7,170,1806.8792814,204.442487,191.869001,1.8,204.5078972,191.0896518,0.1314226,141.4236801,146.8442145,505373.2479103,584532.6115644,5.1714927,3980.6308575,3573.4697859,5748.9724961,1.3404768,10.1673143,1.7033479,21.2694503),(16581,'umzc_hippo_femur-cleaned.tif',250,7,171,1799.6995772,204.3993865,191.9410299,1.8,204.5482861,191.2435909,0.1477487,124.1972765,125.4227988,501908.0124541,578841.2448825,6.5003045,4615.1198215,4041.2159329,7482.2522344,1.3437501,7.4211024,1.6614562,15.8944499),(16582,'umzc_hippo_femur-cleaned.tif',250,7,172,1793.7252907,204.3400366,191.9919133,1.8,204.4907169,191.2943158,0.1755277,135.6696884,137.7392786,501172.1177554,576013.9016987,9.116567,4181.9146098,3694.0610962,6099.8330898,1.3437501,7.4211024,1.6614562,15.8944499),(16583,'umzc_hippo_femur-cleaned.tif',250,7,173,1792.2126364,204.3112656,192.0079218,1.8,204.4777989,191.3902433,0.1845546,146.7580297,75.1107288,500504.7997501,574041.3201264,10.0589281,7642.6008498,3410.4082813,6555.4257598,0.671875,6.7522606,1.670465,13.9941003),(16584,'umzc_hippo_femur-cleaned.tif',250,7,174,1790.0608865,204.2648711,192.0170159,1.8,204.3693065,191.3847428,0.2057383,142.9828794,143.7942654,500512.406732,573652.3161613,12.4511767,3989.3963393,3500.505857,6127.7896067,61.7954562,69.2552941,0.2449787,342.2607083),(16585,'umzc_hippo_femur-cleaned.tif',250,7,175,1792.3583207,204.2785037,192.0164891,1.8,204.4902535,191.2324588,0.1970672,153.4765758,150.3164396,504543.1253014,574526.2272296,11.4517746,3822.1117327,3287.427561,6212.9802754,62.3959827,68.2044179,2.8104966,338.9211113),(16586,'umzc_hippo_femur-cleaned.tif',250,7,176,1792.2193393,204.2499865,192.0068201,1.8,204.3125967,191.4384519,0.2380634,102.1170787,154.0672056,500587.1486313,573799.8433581,16.6113639,3724.3477027,4902.0903745,5812.6284211,0.671875,6.7522606,1.670465,13.9941003),(16587,'umzc_hippo_femur-cleaned.tif',250,7,177,1795.1272795,204.4114478,192.0299357,1.8,204.5875732,191.3295734,0.2166117,153.4312522,127.7087618,505130.7720022,574573.4330728,13.819892,4499.0917228,3292.2287002,6681.8672617,63.6637048,68.944987,0.266252,375.3258314),(16588,'umzc_hippo_femur-cleaned.tif',250,7,178,1794.3218438,204.4321042,192.0180561,1.8,204.5731088,191.3530312,0.2371097,146.138205,128.2334117,504142.5551159,574245.345371,16.5003748,4478.1257706,3449.7656181,6747.1063153,62.9459987,69.1770322,0.1954908,371.7556833),(16589,'umzc_hippo_femur-cleaned.tif',250,7,179,1793.7094227,204.4374937,192.0033914,1.8,204.4788687,191.2184587,0.2703337,150.812645,153.0696941,505920.3327453,576935.5182405,21.3204244,3769.1034898,3354.6280724,5854.3971883,1.3437501,6.1943818,1.3521274,14.3201488),(16590,'umzc_hippo_femur-cleaned.tif',250,7,180,1790.8333551,204.4475679,192.0090645,1.8,204.5589658,191.3873014,0.2406789,155.0581906,81.3671331,504701.674478,572661.9919593,16.9581363,7038.0013421,3254.9178626,6626.3143477,0.671875,0.9501748,2.3561945,1.9003496),(16591,'umzc_hippo_femur-cleaned.tif',250,7,181,1789.3574982,204.4298916,191.9626849,1.8,204.4203888,191.4516677,0.2795477,103.1422751,143.0167915,503291.4913329,574716.2367276,22.7046769,4018.5227938,4879.5849287,6164.2984182,63.373192,68.7417154,3.0633215,366.4482098),(16592,'umzc_hippo_femur-cleaned.tif',250,7,182,1788.1870994,204.4443463,191.9316956,1.8,204.4688886,191.3605377,0.2599718,152.009707,161.2432308,506188.7236445,575562.1651125,19.6928297,3569.5276155,3329.9763134,5809.208831,0.9501748,1.9003496,2.3561945,3.8006992),(16593,'umzc_hippo_femur-cleaned.tif',250,7,183,1790.3726372,204.444746,191.9236421,1.8,204.4465055,191.3717679,0.2615412,155.1664709,145.2536205,508135.1434422,577373.8441099,19.950206,3974.9359917,3274.7741206,6100.7171998,62.7897788,68.518079,0.1973956,346.3594854),(16594,'umzc_hippo_femur-cleaned.tif',250,7,184,1790.7590767,204.4686366,191.8971823,1.8,204.4613792,191.3905888,0.2606692,152.0390069,132.5429826,509075.3756675,579649.5350802,19.8246926,4373.2947884,3348.3208429,6376.7040431,63.9087469,68.4422719,0.2378359,346.3315149),(16595,'umzc_hippo_femur-cleaned.tif',250,7,185,1790.744987,204.5829289,191.9239436,1.8,204.5423983,191.4179666,0.2823502,152.1176998,161.2113491,507375.8570702,580129.443403,23.1679117,3598.5645351,3335.4163107,5866.1541214,62.2917604,68.9286164,3.0341647,339.4101839),(16596,'umzc_hippo_femur-cleaned.tif',250,7,186,1786.1253591,204.6077297,191.9386417,1.8,204.6373495,191.5012614,0.2505927,155.5941006,149.8528483,504353.8349338,576665.4784595,18.3057587,3848.2116634,3241.4714508,5818.3781225,63.2298245,69.3204449,0.0581867,359.5664352),(16597,'umzc_hippo_femur-cleaned.tif',250,7,187,1786.9697807,204.6308458,191.9150786,1.8,204.6184231,191.4905448,0.2743027,106.6667126,155.3003136,504407.6234672,578765.2819647,21.8527641,3726.7489586,4728.8194334,5794.9430643,0.671875,0.9501748,2.3561945,1.9003496),(16598,'umzc_hippo_femur-cleaned.tif',250,7,188,1783.9552789,204.6603395,191.8876023,1.8,204.6965486,191.4990306,0.2589817,127.1181209,150.806742,505724.9726602,579093.7016261,19.5002136,3839.9722317,3978.3861593,5839.0169238,0.671875,1.5023583,2.677945,2.8505244),(16599,'umzc_hippo_femur-cleaned.tif',250,7,189,1781.1596455,204.6724453,191.8341385,1.8,204.6744718,191.317287,0.2691382,156.2704197,145.1091152,512152.0602473,580935.9429068,20.9889523,4003.4421133,3277.3448821,6152.3481129,63.7088191,69.5025423,0.515549,360.0950642),(16600,'umzc_hippo_femur-cleaned.tif',250,7,190,1781.5047736,204.7071579,191.8003914,1.8,204.6611255,191.5206417,0.2567087,135.8475339,148.6007857,508527.8619969,582472.8553025,19.1406203,3919.7158526,3743.3720535,5967.540809,64.2492622,69.6938802,0.3339451,375.6914362),(16601,'umzc_hippo_femur-cleaned.tif',250,7,191,1788.7220959,204.7188934,191.7385544,1.8,204.6108703,191.2525727,0.2804897,147.4205561,161.1415797,514715.0904264,591097.7985201,22.8457889,3668.1891766,3491.4743505,5808.5631141,63.6271718,69.7715624,0.2730087,373.9541108),(16602,'umzc_hippo_femur-cleaned.tif',250,7,192,1790.2725049,204.777165,191.7256163,1.8,204.7414966,191.2834045,0.2348747,153.9618354,158.5497228,519311.7965593,591189.4578847,16.1599374,3728.7322066,3372.9904251,5822.6214438,63.4437647,68.8401476,0.3279233,345.9379396),(16603,'umzc_hippo_femur-cleaned.tif',250,7,193,1793.6006725,204.9558097,191.7638192,1.8,205.004327,191.3869242,0.1939388,149.7464024,126.3049911,517541.9760322,589979.6533227,11.1032972,4671.0715714,3456.1229363,6949.9871246,64.0894555,69.7197839,0.4808873,362.4844864),(16604,'umzc_hippo_femur-cleaned.tif',250,7,194,1790.1637546,205.0009207,191.7214007,1.8,204.7913817,191.0958884,0.2820976,150.5635398,164.7599079,522001.1986402,602345.5681484,23.1200748,3655.8989121,3466.9827713,5858.9813032,63.3228928,69.515531,0.355377,348.259835),(16605,'umzc_hippo_femur-cleaned.tif',250,7,195,1788.1962645,205.0828849,191.7011744,1.8,205.1944143,191.1430947,0.1531909,146.3190468,152.0724185,523889.6258932,595129.6063192,6.9395259,3913.4618384,3580.4609,5760.6240912,63.9215077,70.5052749,0.133811,370.4119332),(16606,'umzc_hippo_femur-cleaned.tif',250,7,196,1792.0430134,205.1292082,191.6534713,1.8,205.0398742,190.9975169,0.1754215,147.6865794,155.5376219,528000.7630239,600731.8731248,9.0971069,3862.2930317,3575.1438285,5782.4713466,63.6678142,69.9944186,0.3733764,386.0758321),(16607,'umzc_hippo_femur-cleaned.tif',250,7,197,1795.0409633,205.183338,191.6043827,1.8,205.1262451,191.2011566,0.1350958,148.5726148,147.5619883,525037.0918267,600227.6210851,5.4270367,4067.6303433,3533.8752885,6095.4732177,0.671875,0.9501748,2.3561945,1.9003496),(16608,'umzc_hippo_femur-cleaned.tif',250,7,198,1799.6500582,205.2165681,191.5368987,1.8,205.1766272,190.9733161,0.1435588,148.4387916,152.3399431,533803.7408858,608975.0931426,6.1391926,3997.4748615,3596.1202256,5856.2311751,64.3997274,70.7545351,0.5273909,351.7344858),(16609,'umzc_hippo_femur-cleaned.tif',250,7,199,1802.9530559,205.2763172,191.5123046,1.8,205.2426922,191.2101101,0.113833,147.4364982,144.7941915,531807.9836246,608419.8177256,3.8769741,4201.9628789,3607.0307563,6094.0660732,63.0714797,70.5500787,0.3398209,331.2917424),(16610,'umzc_hippo_femur-cleaned.tif',250,7,200,1804.8056401,205.3704994,191.4325934,1.8,205.3945081,190.8542579,0.0176923,143.8474257,131.6739721,543545.0827168,614604.6900623,0.094146,4667.6247415,3778.6222462,6388.1134584,1.3437501,10.7709763,1.6332151,22.6132004),(16611,'umzc_hippo_femur-cleaned.tif',250,7,201,1809.2836876,205.5783065,191.4331224,1.8,205.4386792,190.9664871,0.0465156,144.6083819,136.0895752,542469.3467459,618049.6900106,0.6519895,4541.4918014,3751.2994717,6379.032084,1.3437501,8.8371364,1.418147,19.1385496),(16612,'umzc_hippo_femur-cleaned.tif',250,7,202,1812.230477,205.71943,191.3778057,1.8,205.6750743,190.8808833,-0.0089823,141.1958123,129.3245182,544791.4651746,621134.7012782,0.0243688,4802.9152553,3858.4109284,6406.5506258,1.3437501,10.1004966,1.6373645,22.9392488),(16613,'umzc_hippo_femur-cleaned.tif',250,7,203,1815.1798654,205.8516966,191.3385538,1.8,205.8826345,190.7237617,-0.0740416,144.5625273,120.0677655,550064.8171045,627729.5345947,1.6554883,5228.1270656,3805.0304427,6692.0757805,2.0156251,10.1673143,1.7033479,24.8395984),(16614,'umzc_hippo_femur-cleaned.tif',250,7,204,1817.7079322,205.9490157,191.3277403,1.8,205.9012156,190.8760443,-0.0644873,145.1081874,122.9890312,549366.0500875,631976.4127969,1.2581096,5138.4778529,3785.9066391,6226.654757,1.3437501,8.8371364,1.418147,19.1385496),(16615,'umzc_hippo_femur-cleaned.tif',250,7,205,1821.496681,205.9945953,191.2585327,1.8,205.6510891,190.8032158,0.0231086,139.8088053,137.3231267,554188.6898172,639931.8806107,0.1620852,4660.0444939,3963.904051,6139.649164,1.3437501,6.7522606,1.670465,14.5506999),(16616,'umzc_hippo_femur-cleaned.tif',250,7,206,1823.6233979,206.0942843,191.1851712,1.8,205.8160483,190.8888883,0.0030041,141.0646354,134.6260117,553731.3879989,641335.6166811,0.0027428,4763.8313628,3925.3735443,6143.2289579,1.3272063,4.8913241,1.2924967,10.5194496),(16617,'umzc_hippo_femur-cleaned.tif',250,7,207,1832.1466805,206.2060865,191.1136329,1.8,205.9123078,190.8168943,-0.0807834,151.1027394,122.521705,558362.3722104,645396.6642886,1.9884212,5267.6108634,3695.249831,6187.9002463,64.7216514,72.565615,0.6342421,358.7513141),(16618,'umzc_hippo_femur-cleaned.tif',250,7,208,1842.323377,206.3017863,190.9815072,1.8,206.3113258,190.4243013,-0.1849423,160.4818527,124.1478897,570579.3662918,659295.5080964,10.3831729,5310.565566,3555.4136289,6690.797047,61.8125039,72.3038694,0.6602282,307.7283672),(16619,'umzc_hippo_femur-cleaned.tif',250,7,209,1850.6610319,206.5312343,190.9749529,1.8,206.3800433,190.3375642,-0.1949713,162.3384882,128.6892858,576390.1602567,662411.7243807,11.5772876,5147.3727601,3550.5453247,6737.2072874,1.3437501,6.0840873,1.6814535,13.7635493),(16620,'umzc_hippo_femur-cleaned.tif',250,7,210,1858.0984537,206.6597616,190.9449516,1.8,206.4966339,190.3112336,-0.2400375,163.7313951,126.5201671,575805.9376045,667812.2846532,17.503246,5278.3070089,3516.7717055,6696.9497907,66.0087718,72.612256,0.6805212,378.7049848),(16621,'umzc_hippo_femur-cleaned.tif',250,7,211,1863.3692151,206.751103,190.9491197,1.8,206.3160219,190.6196844,-0.1719862,161.2509706,125.8177748,573363.4590371,666940.3901373,9.0959632,5300.8439486,3555.720979,6622.9965753,0.9501748,1.9003496,2.3561945,3.8006992),(16622,'umzc_hippo_femur-cleaned.tif',250,7,212,1874.927108,206.9612114,190.8744716,1.8,206.6551703,190.2774448,-0.2287995,164.8852524,124.1501723,584989.5289581,682782.830632,16.0750222,5499.6527036,3547.858408,6617.8325512,66.4048977,73.1356892,0.4060981,381.9490845),(16623,'umzc_hippo_femur-cleaned.tif',250,7,213,1885.5792962,207.0353216,190.8200784,1.8,206.5612877,190.6061149,-0.2383296,165.8823539,130.185706,583228.1466221,680244.6194999,17.5150372,5225.1866998,3515.914338,6860.6445511,66.9416692,73.4313624,0.570238,379.0030627),(16624,'umzc_hippo_femur-cleaned.tif',250,7,214,1885.817726,207.0636219,190.7609642,1.8,206.6626108,190.290021,-0.2837664,168.5437834,132.5977017,591687.7884458,686313.6578255,24.636676,5175.9091506,3510.5880301,6940.5563077,0.671875,0.9501748,2.3561945,1.9003496),(16625,'umzc_hippo_femur-cleaned.tif',250,7,215,1878.3039738,206.9931113,190.802806,1.8,206.8791926,190.2687475,-0.3405052,169.4969445,137.7815617,595558.5879801,687610.7404641,34.915005,4990.5860556,3513.6833273,6938.1856654,65.6407798,73.6523383,0.6234308,341.4176167),(16626,'umzc_hippo_femur-cleaned.tif',250,7,216,1869.622422,206.8634843,190.8007636,1.8,206.9393602,190.0892654,-0.3682707,173.495212,142.6207447,604688.8135648,689068.8188802,40.3844408,4831.4767974,3485.3343022,7005.0323288,0.671875,6.7522606,1.670465,13.9941003),(16627,'umzc_hippo_femur-cleaned.tif',250,7,217,1868.0592913,206.8640216,190.9302561,1.8,206.7308689,190.4485652,-0.3011992,158.6639052,138.1956294,603214.9117779,672940.4560724,27.4014775,4869.4771235,3801.8408232,7116.8287013,2.0156251,12.8361547,1.6756733,27.7576496),(16628,'umzc_hippo_femur-cleaned.tif',250,7,218,1868.7640475,206.9082748,190.8720081,1.8,206.8044341,190.3502792,-0.3464769,179.8792407,133.2578417,614389.0815006,675509.8000781,35.917266,5069.1936148,3415.5641265,6570.9335808,1.3437501,12.1123996,1.6262948,26.4138995),(16629,'umzc_hippo_femur-cleaned.tif',250,7,219,1871.1007413,206.9224428,190.8353924,1.8,206.8695378,190.2944798,-0.327895,167.7083644,138.1719009,622205.4460493,674947.3047329,32.3440873,4884.837658,3710.0442083,6982.5754261,67.8593792,74.6053629,0.6705216,412.1241269),(16630,'umzc_hippo_femur-cleaned.tif',250,7,220,1871.3845862,206.9155296,190.8051179,1.8,207.0342527,190.0273034,-0.4029673,178.8744909,142.4516137,631710.9748396,685139.7395651,47.9640066,4809.6312963,3531.5878289,6989.4847158,1.3437501,3.4259039,1.7681919,8.3885489),(16631,'umzc_hippo_femur-cleaned.tif',250,7,221,1871.6252047,206.9245834,190.8225944,1.8,207.1467799,190.2363872,-0.4425207,179.0085596,138.3097461,631654.6329101,681337.3302235,57.2003862,4926.1700599,3528.6280964,6926.4023521,0.671875,2.1246554,1.8925469,4.5878498),(16632,'umzc_hippo_femur-cleaned.tif',250,7,222,1866.2101269,206.9744687,190.7506964,1.8,207.2171983,190.0329018,-0.5710399,189.4495086,152.4409395,642445.6122096,690416.2909819,90.8682838,4529.0739707,3391.1178601,6908.7155989,67.9470319,75.1359395,0.6202495,362.0909111),(16633,'umzc_hippo_femur-cleaned.tif',250,7,223,1866.7533309,207.0700462,190.6596792,1.8,207.4021029,189.8734129,-0.6875602,180.8222567,154.736064,647250.4812539,705001.2814576,125.3167594,4556.1536405,3579.4845892,7431.4911887,68.186837,75.1359395,0.5557557,354.2589617),(16634,'umzc_hippo_femur-cleaned.tif',250,7,224,1875.3627929,207.1304651,190.5411305,1.8,207.3531328,189.9250706,-0.7217491,191.6517371,155.8350519,652602.3207126,708810.0623657,136.4397474,4548.4636076,3405.1469116,7094.516582,0.671875,0.9501748,2.3561945,1.9003496),(16635,'umzc_hippo_femur-cleaned.tif',250,7,225,1891.3202143,207.3936417,190.4849201,1.8,207.536376,189.9146711,-0.7261093,194.7829822,156.8240488,655800.7300293,717681.2667928,138.9647356,4576.3470103,3366.8276497,7046.3193563,1.3437501,11.4416197,1.6295521,23.9569504),(16636,'umzc_hippo_femur-cleaned.tif',250,7,226,1897.5215768,207.4909806,190.3983535,1.8,207.522072,189.8348675,-0.7789286,187.2684485,158.8120976,668290.8196402,716621.9080607,156.0808473,4512.3886583,3568.6247475,7394.4801601,1.3437501,10.8336595,1.4464413,23.1697999),(16637,'umzc_hippo_femur-cleaned.tif',250,7,227,1908.8920637,207.5733395,190.3349277,1.8,207.6080984,189.7070131,-0.842172,187.1470631,161.1964962,674809.2125769,723941.5251608,177.098075,4491.0500049,3605.7697151,7467.3473574,0.671875,0.9501748,2.3561945,1.9003496),(16638,'umzc_hippo_femur-cleaned.tif',250,7,228,1922.8932119,207.6878902,190.210522,1.8,207.7662391,189.2987462,-0.8879256,192.728264,159.8928075,696270.8903314,738585.2434847,192.869535,4619.2524542,3612.707736,7398.0786613,68.5312543,77.9143333,1.0067126,365.7285861),(16639,'umzc_hippo_femur-cleaned.tif',250,7,229,1936.6577087,207.8242088,190.1052458,1.8,208.0752715,189.1947739,-0.9291437,182.0640592,161.513568,698531.0398933,752044.9145543,207.1492943,4656.2336768,3836.7322076,7834.5423596,0.9501748,1.9003496,0.7853982,3.8006992),(16640,'umzc_hippo_femur-cleaned.tif',250,7,230,1947.7008506,207.872889,190.0892951,1.8,208.0881449,189.4099068,-0.9923217,185.3927645,162.7435323,698848.3825206,755398.8656266,227.5782153,4641.6521447,3769.5558637,7622.4396084,68.0904945,77.7112875,0.9947836,355.5351849),(16641,'umzc_hippo_femur-cleaned.tif',250,7,231,1961.8795558,207.8788348,189.9837789,1.8,208.0505148,189.1364845,-1.089219,175.1509795,157.1203102,711009.266159,765100.9514073,256.831756,4869.5229194,4059.4078794,7924.9796363,68.6551936,78.5059465,1.0612041,356.5808571),(16642,'umzc_hippo_femur-cleaned.tif',250,7,232,1975.7280433,208.0412987,189.8609274,1.8,208.3421259,188.9295774,-1.075319,179.6673665,161.7515556,715596.7957646,786756.8052005,254.8510615,4863.9829298,3982.8980049,7977.9185109,68.7239879,78.353421,1.0303768,367.0048093),(16643,'umzc_hippo_femur-cleaned.tif',250,7,233,1992.0623287,208.1761367,189.896041,1.8,208.1726551,189.4009986,-1.1954937,171.9875292,160.7701151,716283.2759909,781972.1718195,287.4008469,4863.9149846,4164.7396141,7966.1654693,1.3437501,12.1681745,1.4601391,26.9704991),(16644,'umzc_hippo_femur-cleaned.tif',250,7,234,2003.3165418,208.256954,189.8465046,1.8,208.2913199,189.3822729,-1.3302952,161.6576017,154.1470626,722557.5007188,785875.5657727,314.9433325,5098.2195338,4469.6784633,7916.7732399,1.3437501,8.0904469,1.6539376,17.7947995),(16645,'umzc_hippo_femur-cleaned.tif',250,7,235,2016.4862637,208.2344503,189.7689973,1.8,207.762691,188.9875417,1.4505794,123.0878807,155.0909444,738804.6651908,804899.3917633,331.2473182,5189.8542155,6002.2535203,8106.9456296,1.3437501,5.4168298,1.6951513,11.8631997),(16646,'umzc_hippo_femur-cleaned.tif',250,7,236,2025.5348305,208.3152214,189.7638726,1.8,208.0779515,189.0066139,1.5194629,129.2684118,146.1712241,731973.5040988,809551.910326,336.7003305,5538.3808616,5662.4313233,8270.7597928,1.3437501,3.0047165,1.1071487,7.6013984),(16647,'umzc_hippo_femur-cleaned.tif',250,7,237,2033.232432,208.3503644,189.7330726,1.8,208.4053922,189.0737845,1.5482451,132.0153048,143.278076,727049.4307314,814649.5750242,338.6997652,5685.7936519,5507.3116847,8042.3758715,69.7047924,78.5203204,1.156916,350.8122815),(16648,'umzc_hippo_femur-cleaned.tif',250,7,238,2034.7958364,208.3451736,189.6755658,1.8,208.5436164,188.9452764,-1.5537451,137.7368458,139.9321458,725920.352863,827941.6832813,339.0340465,5916.7368476,5270.3425057,8229.950158,1.3437501,4.8913241,1.849096,10.5194496),(16649,'umzc_hippo_femur-cleaned.tif',250,7,239,2028.5408511,208.3270814,189.7786602,1.8,208.6514689,189.0515615,1.5345115,128.2985202,145.3692784,725373.7033992,827247.6021159,337.645212,5690.6631948,5653.7963364,8076.9695193,0.671875,10.7709763,1.6332151,22.0566009),(16650,'umzc_hippo_femur-cleaned.tif',250,7,240,2021.4611424,208.2538259,189.8939442,1.8,208.4081727,189.2903569,1.4226806,124.3698531,157.9709464,720898.7123479,827642.2210325,329.5728592,5239.2053098,5796.4104182,8055.1349786,1.3437501,8.0904469,1.6539376,17.2382),(16651,'umzc_hippo_femur-cleaned.tif',250,7,241,2006.8486673,208.232263,190.1070185,1.8,208.3315044,189.1982137,1.3472481,132.3000066,166.345719,707284.2137835,841568.5476019,318.0363898,5059.1536261,5346.0633316,8048.0180046,69.4103726,79.3609289,1.076855,358.7792846),(16652,'umzc_hippo_femur-cleaned.tif',250,7,242,1991.196841,208.1107485,190.1736562,1.8,208.4263717,189.3145697,1.3765205,139.0775596,163.0837542,693143.1115305,840539.0770775,319.497282,5154.0331604,4983.8601829,8050.0780404,70.5468794,79.5994723,1.1902899,424.842004),(16653,'umzc_hippo_femur-cleaned.tif',250,7,243,1992.7858256,208.1230025,190.2725862,1.8,208.5847319,189.9902994,1.3766666,128.5181391,157.7988089,674988.6901662,832749.610354,319.7706206,5277.2870487,5252.088886,8195.5459572,2.0156251,13.5045212,1.4711277,33.5541958),(16654,'umzc_hippo_femur-cleaned.tif',250,7,244,1998.5988334,208.2300025,190.1853984,1.8,208.7202496,189.6895758,1.389988,127.6601234,158.1244156,678437.7356317,847337.7092789,322.328371,5358.6772553,5314.4060777,8008.4320913,70.5468794,80.831901,1.0959968,383.8494341),(16655,'umzc_hippo_femur-cleaned.tif',250,7,245,2015.8724746,208.3038641,190.1747231,1.8,208.6136827,189.7464087,1.3558883,128.5938716,161.9477101,682045.5102542,857801.969938,320.6988441,5296.7835683,5303.8725866,8040.7409413,2.6875002,20.8389602,1.6030432,55.2172214),(16656,'umzc_hippo_femur-cleaned.tif',250,7,246,2025.6275759,208.2246846,190.1245977,1.8,208.1259879,189.7460929,1.3139947,133.0822056,167.626045,676418.0649349,872481.2791574,315.8256974,5204.9267113,5082.7085532,8070.4556692,0.671875,0.9501748,2.3561945,1.9003496),(16657,'umzc_hippo_femur-cleaned.tif',250,7,247,2031.2037956,208.2175623,190.0930432,1.8,208.2384016,189.908851,1.3116585,129.9811289,170.9258825,669180.3922297,883835.4329311,316.3049256,5170.8695029,5148.2888173,7954.829578,2.6875002,9.501748,1.4288993,25.7222464),(16658,'umzc_hippo_femur-cleaned.tif',250,7,248,2032.7406621,208.2323053,190.0637904,1.8,208.673228,189.6613327,1.342717,127.931144,168.1927352,673471.2584892,893571.3201653,321.4696693,5312.7819039,5264.3260846,7989.0012068,69.8750044,79.3523962,1.1336577,410.358831),(16659,'umzc_hippo_femur-cleaned.tif',250,7,249,2030.730903,208.2011515,190.1790852,1.8,208.4173456,189.9688298,1.3122981,133.1228126,167.3906936,658431.9610549,895578.4535952,316.3383978,5350.2284646,4946.0490511,8038.0437186,71.3801693,79.63916,1.1260144,426.253281),(16660,'umzc_hippo_femur-cleaned.tif',250,7,250,2026.0305674,208.1584158,190.2757769,1.8,208.539642,190.053066,1.3130855,133.1029016,165.886085,653750.537106,899942.3820797,315.737439,5425.0625201,4911.6174711,8321.0132616,70.9477456,79.1359284,1.1603305,408.3234277),(16661,'umzc_hippo_femur-cleaned.tif',250,7,251,2012.3526604,208.0771525,190.5696114,1.8,208.5112482,190.3601309,1.2766349,134.4479831,170.7798319,637799.6632418,897502.3174899,307.1978095,5255.3179572,4743.8395766,8178.7758384,70.5468794,79.738293,1.8525682,400.4914783),(16662,'umzc_hippo_femur-cleaned.tif',250,7,252,1993.8653939,207.9286979,190.8325456,1.8,208.4330612,190.5559506,1.2353069,140.9576185,173.9193186,623926.3747097,898762.414527,296.2906299,5167.6974243,4426.3402087,8017.2850744,70.7126723,79.5540906,1.8444556,430.5430528),(16663,'umzc_hippo_femur-cleaned.tif',250,7,253,1981.6324288,207.8436172,190.9776958,1.8,208.2407977,190.9792138,1.1912623,144.0192693,172.4669963,610049.4657683,902718.0414668,284.938546,5234.1494931,4235.8877997,8049.0897795,70.5127397,79.63916,1.1260144,459.7795062),(16664,'umzc_hippo_femur-cleaned.tif',250,7,254,1978.345983,207.7861453,191.012205,1.8,208.3217238,190.8230998,1.1878092,143.6458252,173.1065087,610353.9435305,914427.3895535,283.67954,5282.4552725,4249.0197168,8113.7173751,70.1816052,79.6844933,1.81782,465.7786329),(16665,'umzc_hippo_femur-cleaned.tif',250,7,255,1981.2528289,207.8106796,191.022359,1.8,208.2088581,190.7768419,1.1782648,143.9341901,167.1767323,611313.2028438,929036.9853752,281.8899735,5557.2146461,4247.1715902,8640.0764398,69.3612898,80.8291087,1.8056947,447.2921802),(16666,'umzc_hippo_femur-cleaned.tif',250,7,256,1986.0796978,207.825245,191.0195063,1.8,208.0238198,190.7800656,1.1667997,144.608453,181.6018422,614861.6302846,942247.9409017,279.8635418,5188.537349,4251.9065635,8092.0695169,69.6208425,81.0382688,2.438362,456.1418312),(16667,'umzc_hippo_femur-cleaned.tif',250,7,257,1985.1448562,207.9199459,191.094444,1.8,207.7854121,191.0476085,1.1383593,144.9793913,182.0377577,602510.476751,950276.6714567,272.7482979,5220.2174067,4155.8353308,8032.4783484,0.671875,0.9501748,2.3561945,1.9003496),(16668,'umzc_hippo_femur-cleaned.tif',250,7,258,1977.2896694,207.9286268,191.0456672,1.8,207.6964733,191.1598164,1.1298574,142.5736742,184.6534537,593349.0520012,960384.7461874,269.5214951,5201.011555,4161.7013459,7959.8498537,69.2893681,83.1525103,1.782454,445.2172206),(16669,'umzc_hippo_femur-cleaned.tif',250,7,259,1976.5271866,207.9265256,190.9319361,1.8,207.7801157,190.8438656,1.1319073,145.7223001,178.5234785,602522.1117541,977401.1085022,269.9379717,5474.9163342,4134.7282567,8402.1925037,69.826709,83.106353,2.4592761,444.6326505),(16670,'umzc_hippo_femur-cleaned.tif',250,7,260,1968.3151075,207.8677873,190.886726,1.8,207.6616725,190.9189823,1.1170747,146.9159968,174.9108766,593246.0091512,994574.1820974,265.0274382,5686.1768774,4037.9946501,8600.8988652,0.671875,0.9501748,2.3561945,1.9003496),(16671,'umzc_hippo_femur-cleaned.tif',250,7,261,1963.3336627,207.7408077,190.7172444,1.8,207.6001299,190.8030334,1.1164475,147.2075509,175.1381834,591666.0037993,1012206.8150795,264.1949251,5779.4753571,4019.2639596,8987.5969674,69.0566307,85.0923839,1.9425053,436.6097063),(16672,'umzc_hippo_femur-cleaned.tif',250,7,262,1963.7381589,207.6171815,190.5418251,1.8,207.3219023,190.5685669,1.1063023,146.2405816,182.1983234,585827.3845975,1043660.9170761,261.6099918,5728.158731,4005.9153098,8497.9436649,69.0178314,85.224906,1.9674067,431.9823003),(16673,'umzc_hippo_femur-cleaned.tif',250,7,263,1972.3272388,207.5870487,190.2642145,1.8,207.4517904,190.5717988,1.1062533,146.4437171,181.9301449,592008.4331795,1063182.312148,262.7413258,5843.9040572,4042.5662848,8765.9838498,68.9747445,86.1494727,2.2954957,441.5515751),(16674,'umzc_hippo_femur-cleaned.tif',250,7,264,1983.4424704,207.5111253,189.9794085,1.8,207.2703598,190.336258,1.108632,142.9548433,160.8413257,593558.6237923,1089497.5902609,264.8508233,6773.7416689,4152.0707539,10413.6539272,68.3562803,86.4032349,2.2127422,383.444273),(16675,'umzc_hippo_femur-cleaned.tif',250,7,265,1991.5541437,207.5082093,189.6931005,1.8,206.8362822,190.1826158,1.1087952,145.5305916,172.5653651,589083.3445759,1118587.218965,265.9772152,6482.1073362,4047.8317167,9675.2869191,69.9201736,87.4986662,2.3996454,438.7569918),(16676,'umzc_hippo_femur-cleaned.tif',250,7,266,1988.4909436,207.4357203,189.3923891,1.8,206.8583369,189.9927249,1.1085267,146.9988811,176.1609109,592721.1435151,1140153.0269062,265.4970913,6472.2248586,4032.1473146,9450.2837863,69.8458406,87.511563,1.8269477,409.3970704),(16677,'umzc_hippo_femur-cleaned.tif',250,7,267,1987.958683,207.3968124,189.0688596,1.8,206.638794,189.8209868,1.1026414,147.738418,168.2820866,586471.4119406,1163971.6043694,263.8624225,6916.7885199,3969.6608366,10154.2103606,0.671875,0.9501748,2.3561945,1.9003496),(16678,'umzc_hippo_femur-cleaned.tif',250,7,268,1987.9231169,207.4188533,188.7305559,1.8,206.8601539,189.5538706,1.107719,142.5321653,179.2098464,593188.5433603,1187842.7531543,265.2074989,6628.2225963,4161.7872143,9603.3839643,69.2018072,89.9259001,2.472686,415.7222456),(16679,'umzc_hippo_femur-cleaned.tif',250,7,269,1990.9261281,207.4646666,188.4950124,1.8,206.7921252,189.4535123,1.1020051,145.4060702,182.0145459,592668.4652379,1206718.6878614,264.0861708,6629.7925908,4075.9540801,9522.7033188,69.172722,89.6317568,2.2232927,369.1241242),(16680,'umzc_hippo_femur-cleaned.tif',250,7,270,1997.4292554,207.5323584,188.1554555,1.8,206.8796662,189.1604752,1.1028057,146.862638,176.6012057,603970.1494375,1227395.0518422,265.1635016,6950.094408,4112.483321,9933.4118636,68.651842,89.8731761,2.0611934,389.836975),(16681,'umzc_hippo_femur-cleaned.tif',250,7,271,2005.0808946,207.6156693,187.951408,1.8,206.7504997,189.2094826,1.0894424,144.3735092,176.6081893,603118.3784401,1246805.4717705,262.5485711,7059.7262612,4177.4864506,10016.088144,68.7517796,90.9516329,2.1403584,399.0126745),(16682,'umzc_hippo_femur-cleaned.tif',250,7,272,2012.0462446,207.7303221,187.6750706,1.8,207.0591338,188.6528747,1.095478,146.8011864,176.9728135,624085.3143389,1268479.7645701,265.1147768,7167.6532657,4251.2280019,10226.3437318,68.7729135,91.5329574,2.2730533,392.946021),(16683,'umzc_hippo_femur-cleaned.tif',250,7,273,2017.9420121,207.9020507,187.4422494,1.8,206.7999919,188.6674631,1.0893616,147.0426317,173.5644918,625891.2937774,1288071.7156371,264.2103119,7421.2858986,4256.5294608,10519.6175124,0.671875,1.5023583,2.0344439,3.2440997),(16684,'umzc_hippo_femur-cleaned.tif',250,7,274,2021.1421417,207.9839072,187.1665042,1.8,206.8970733,188.4649146,1.0913988,143.7630463,170.7568696,638445.943841,1305364.146124,265.1918213,7644.5776328,4440.960039,11222.5090193,70.3555083,93.5813646,2.1309177,422.0753912),(16685,'umzc_hippo_femur-cleaned.tif',250,7,275,2028.0895718,208.0492896,186.7899679,1.8,207.0225391,188.1368353,1.094152,144.3000861,180.9305525,652862.4814608,1327230.4592075,266.8636246,7335.5795405,4524.3388222,10454.0749947,69.5474376,93.5813646,1.8471236,447.539116),(16686,'umzc_hippo_femur-cleaned.tif',250,7,276,2027.8111986,208.0486618,186.5889071,1.8,206.8950129,188.2425157,1.0899661,141.9376064,111.6355183,649478.6382303,1344353.2704351,265.6701302,12042.3436092,4575.8037964,12698.7830037,0.9501748,2.8505244,0.7853982,5.7010488),(16687,'umzc_hippo_femur-cleaned.tif',250,7,277,2030.1027507,208.0873624,186.3460012,1.8,207.0419272,187.9215607,1.0835547,141.5220543,173.4129287,656604.117863,1362743.5447593,264.1833191,7858.3733939,4639.5886581,11444.3075983,69.9939767,94.507769,2.1331635,410.8758742),(16688,'umzc_hippo_femur-cleaned.tif',250,7,278,2034.893096,208.1203057,186.1393555,1.8,207.0692781,187.6776467,1.0818325,143.3555462,162.6252483,664576.4130783,1379442.0107714,264.3228474,8482.3360775,4635.8611905,12237.4503012,0.671875,2.1246554,1.8925469,4.5878498),(16689,'umzc_hippo_femur-cleaned.tif',250,7,279,2037.175483,208.2184242,185.8087345,1.8,207.198165,187.2514477,1.0801877,139.3285668,165.7955579,676720.3948773,1401846.7449702,264.1556538,8455.2732456,4857.0110952,12353.5735919,70.2559255,95.6094946,2.176341,446.425917),(16690,'umzc_hippo_femur-cleaned.tif',250,7,280,2044.6070227,208.2863493,185.4918944,1.8,207.4004581,187.0139307,1.0759135,145.031272,170.465748,689786.3332261,1426873.3704361,263.9052417,8370.4403231,4756.1213785,11941.6367648,71.0311598,96.8991966,2.1587989,419.33195),(16691,'umzc_hippo_femur-cleaned.tif',250,7,281,2047.5984065,208.4383527,185.1537207,1.8,207.3609897,186.817069,1.0747776,145.2671158,178.684416,702349.8216145,1446020.5445863,263.9670573,8092.5946254,4834.885154,11481.9851583,72.6247035,96.8642507,2.2628703,456.6193181),(16692,'umzc_hippo_femur-cleaned.tif',250,7,282,2043.9511015,208.5753334,184.9209963,1.8,207.5756052,186.5246206,1.0738575,142.8700284,159.9669502,714876.4895642,1452139.4538555,263.2343237,9077.7466968,5003.6841012,12552.4766372,72.3059406,97.6532873,2.1454409,434.697771),(16693,'umzc_hippo_femur-cleaned.tif',250,7,283,2041.3342562,208.6682697,184.7004864,1.8,207.7173288,186.360814,1.0712435,145.5387638,181.8624624,728605.9650736,1472341.2420894,262.1506386,8095.9051285,5006.2673744,11596.8037081,0.671875,0.9501748,2.3561945,1.9003496),(16694,'umzc_hippo_femur-cleaned.tif',250,7,284,2040.8883118,208.783925,184.4332704,1.8,207.9547377,186.0678086,1.0703507,142.9022444,175.9936331,743211.5383638,1486130.7938037,261.8378391,8444.2304379,5200.8388066,12116.6308497,73.3243606,98.0937561,2.2883377,429.7163459),(16695,'umzc_hippo_femur-cleaned.tif',250,7,285,2041.3296052,208.9838271,184.251968,1.8,208.2651287,185.8865932,1.0691004,141.8016393,157.3758282,759125.3756694,1498172.8533543,261.5360201,9519.7138598,5353.4315941,13104.1764263,73.632963,98.2064376,2.1663889,407.8227693),(16696,'umzc_hippo_femur-cleaned.tif',250,7,286,2041.4309687,209.0516532,183.9678787,1.8,208.3188173,185.5053982,1.0632582,143.7576699,174.1967168,773340.7898814,1521507.2937431,259.8665379,8734.420037,5379.4749907,12774.0512803,73.6830188,98.4359994,2.3127436,407.1031456),(16697,'umzc_hippo_femur-cleaned.tif',250,7,287,2044.9027686,209.1974629,183.6026398,1.8,208.7455082,185.2900394,1.0639152,135.9929369,174.1140845,793322.9503797,1536515.8560273,260.4986355,8824.7648682,5833.5599525,12883.7074861,73.5837094,99.439776,2.1100571,424.4088724),(16698,'umzc_hippo_femur-cleaned.tif',250,7,288,2047.2062217,209.3631318,183.200361,1.8,209.1110562,184.8069164,1.0660004,143.2018846,178.1195278,819027.5072763,1563166.9036695,261.3951896,8775.9434522,5719.3905603,12942.8993755,73.9550364,99.4738172,2.2413179,432.0777976),(16699,'umzc_hippo_femur-cleaned.tif',250,7,289,2048.8705791,209.8006334,182.8937847,1.8,209.3703778,184.637825,1.0616374,143.2733497,169.0017064,838913.9608526,1578149.2153623,260.3429266,9338.0667498,5855.3385025,13769.7973016,74.9234301,100.453745,2.175495,441.675043),(16700,'umzc_hippo_femur-cleaned.tif',250,7,290,2055.2090079,210.1220074,182.6292448,1.8,209.5477669,184.2871196,1.0514653,139.6882792,169.5745795,859962.1699392,1600534.210628,258.1640043,9438.5267865,6156.2943931,13674.2632086,75.6385368,101.7729914,2.1349939,448.1352718),(16701,'umzc_hippo_femur-cleaned.tif',250,7,291,2066.6351695,210.496708,182.3115169,1.8,209.8241421,183.9131488,1.0453067,129.4395887,177.468158,889503.5350024,1626365.9026992,257.7647481,9164.2687973,6871.9589136,13622.9425138,76.1157409,101.4197546,2.0907641,444.1319921),(16702,'umzc_hippo_femur-cleaned.tif',250,7,292,2077.0705411,210.7948992,181.9172492,1.8,210.1811645,183.487359,1.0457364,143.0576635,177.2544973,922241.7217421,1656168.3673437,259.1953984,9343.449065,6446.6432566,13965.9177638,76.9884247,101.7552477,2.0964944,436.8566422),(16703,'umzc_hippo_femur-cleaned.tif',250,7,293,2083.7817302,211.0753832,181.5176006,1.8,210.5845478,182.9576884,1.041845,142.3717612,168.1126841,954462.6171236,1685700.8792894,258.8579036,10027.208167,6704.0163648,14942.0734734,77.6905687,102.4956332,2.1697076,423.3911708),(16704,'umzc_hippo_femur-cleaned.tif',250,7,294,2096.1748797,211.3761054,181.0498436,1.8,210.9865441,182.3451539,1.0386014,140.1388592,182.0032825,990922.8430276,1726336.3986931,259.4082527,9485.1937575,7071.0069203,14362.2308112,78.4835678,102.7287931,2.3099312,440.1682687),(16705,'umzc_hippo_femur-cleaned.tif',250,7,295,2113.5262192,211.6369728,180.6266292,1.8,211.2943864,181.9491826,1.0327333,134.3400926,160.6699605,1026199.1648156,1770987.5611412,259.7420724,11022.5181867,7638.8153772,16925.7990787,0.671875,0.9501748,2.3561945,1.9003496),(16706,'umzc_hippo_femur-cleaned.tif',250,7,296,2128.5575536,211.9275615,180.0683922,1.8,211.7586425,181.5009979,1.0295393,140.4765983,176.3741772,1061229.5545652,1819278.0402384,260.5903614,10314.8775455,7554.4935402,15723.635803,80.3349111,104.0539018,2.1211823,454.7189685),(16707,'umzc_hippo_femur-cleaned.tif',250,7,297,2156.037165,212.4315998,179.4003204,1.8,211.9672872,180.7608447,1.0213435,138.5516341,174.7712812,1108180.8784352,1876988.1991208,261.3424657,10739.6832373,7998.3241293,16493.6780962,82.5318156,105.9093318,2.1939957,485.5181373),(16708,'umzc_hippo_femur-cleaned.tif',250,7,298,2178.3944351,212.8342714,178.8826737,1.8,212.3068365,180.3473577,1.0138199,140.4485617,166.1329534,1147839.7726367,1936267.9903571,261.6101837,11654.9302903,8172.6701818,17569.8833484,84.0826293,106.474707,2.1220379,467.3297625),(16709,'umzc_hippo_femur-cleaned.tif',250,7,299,2206.4801752,213.2707175,178.1531788,1.8,212.686142,179.2783391,1.012544,137.5322676,184.0394585,1204253.9950473,2034358.8118545,264.561732,11053.927391,8756.1560359,16959.2871127,85.6413818,107.369752,2.2230582,480.9302876),(16710,'umzc_hippo_femur-cleaned.tif',250,7,300,2292.0693464,213.4526322,175.5481082,1.8,212.9236185,177.150201,1.1325898,129.0195554,171.5179496,1309328.6228663,2466987.3684201,313.2325874,14383.260613,10148.2958838,20535.5373886,87.6338071,109.4682194,2.1196367,504.5216333),(16711,'umzc_hippo_femur-cleaned.tif',250,7,301,2376.9696294,213.5393871,173.0088155,1.8,213.3719975,175.0548768,1.1939433,149.4905059,158.3714739,1416660.9024916,2887734.5864806,342.5129211,18233.9313731,9476.5944779,25101.927124,0.671875,0.9501748,2.3561945,1.9003496),(16712,'umzc_hippo_femur-cleaned.tif',250,7,302,2473.9280563,214.699498,170.2278133,1.8,214.8394561,172.1138774,1.2577663,144.3356295,155.8660708,1715519.753241,3228250.4491256,373.2214163,20711.694546,11885.6290691,26777.9677604,90.8449994,111.9634955,2.2371026,516.7784082),(16713,'umzc_hippo_femur-cleaned.tif',250,7,303,2576.1681882,215.8444705,167.6697799,1.8,216.0264629,169.7938229,1.3102194,119.4654855,138.7670206,2010961.8759546,3557982.6099217,400.8614955,25639.97262,16832.9946274,32731.6663299,92.7299689,114.9083117,2.2318395,503.3409074),(16714,'umzc_hippo_femur-cleaned.tif',250,7,304,2702.4097021,217.1046518,165.3120906,1.8,217.4418058,167.2470257,1.3411115,128.2874481,143.9359899,2315006.613661,3915545.5873669,427.0555353,27203.3810985,18045.4646806,34637.1130551,94.711329,116.908188,1.5765434,551.7438809),(16715,'umzc_hippo_femur-cleaned.tif',250,7,305,2879.010646,218.8425864,162.4574443,1.8,218.9796863,164.6982527,1.3509882,132.0419892,141.6213255,2697744.1999658,4405214.3365334,457.0225592,31105.5861221,20430.9569748,39518.808193,99.5887878,121.700293,1.5321416,561.8697553),(16716,'umzc_hippo_femur-cleaned.tif',250,7,306,3110.8889925,221.1179641,160.0464472,1.8,221.0127977,162.2621159,1.3094067,160.4431649,137.4834018,3161819.0655945,4892272.8718599,483.8559825,35584.4618802,19706.7856866,44836.8490146,118.6679908,160.6132711,1.5917138,917.7473734),(16717,'umzc_hippo_femur-cleaned.tif',250,7,307,3340.4630652,223.2208487,157.7921705,1.8,222.6429211,159.9293274,1.2746698,160.0762949,142.2475517,3634932.0791372,5349677.8141084,509.3329327,37608.2241768,22707.4975798,49624.2838484,119.482007,161.2724044,1.5541312,906.9298459),(16718,'umzc_hippo_femur-cleaned.tif',250,7,308,3362.9044629,223.2640167,156.3444751,1.8,223.2263474,158.3818846,1.2924341,122.0634235,136.823335,3777315.8299362,5586758.529896,518.164866,40831.9131479,30945.5176684,53478.5233662,122.5534772,163.4038226,1.5296673,907.5935286),(16719,'umzc_hippo_femur-cleaned.tif',250,7,309,3422.434205,223.3229418,154.6311949,1.8,223.6246534,156.7402742,1.3110867,139.9142905,138.3432508,3946721.9784484,5849488.9590903,532.7895992,42282.4310197,28208.140594,55177.7731204,124.7114426,163.7129392,1.4968573,898.417829),(16720,'umzc_hippo_femur-cleaned.tif',250,7,310,3489.2727838,223.8042047,153.3417837,1.8,224.2716851,155.5748078,1.3268137,149.910578,135.1445282,4127521.4246619,6052975.9233355,547.6089934,44788.9086011,27533.2233316,56915.1735077,128.2129652,165.3481612,1.5992439,913.3900747),(16721,'umzc_hippo_femur-cleaned.tif',250,7,311,3558.7044058,224.2580373,152.2298265,1.8,224.6116749,154.6304707,1.3251803,163.0608615,135.0128895,4318018.6545383,6295086.2863098,558.0500371,46625.8170658,26481.0244137,59349.4742548,128.8098485,168.6620485,1.5548614,921.3570778),(16722,'umzc_hippo_femur-cleaned.tif',250,7,312,3648.0478541,224.552991,151.0832749,1.8,224.6884285,153.8776533,1.3288547,155.9987352,135.0051627,4525977.9389914,6531911.4045837,573.106803,48382.6786554,29012.9143273,61582.5274694,131.5812253,168.7062042,1.5429151,989.1011816),(16723,'umzc_hippo_femur-cleaned.tif',250,7,313,3734.0335875,225.0089956,150.2281826,1.8,225.0094976,153.2333682,1.3298883,147.1407408,132.6958759,4791632.3913199,6804766.3358931,586.9137876,51280.9180561,32564.9603488,65020.896846,0.671875,0.9501748,2.3561945,1.9003496),(16724,'umzc_hippo_femur-cleaned.tif',250,7,314,3766.8783473,225.1984892,149.7079432,1.8,225.0057292,152.9085082,1.3316228,154.5559222,129.3070821,4975060.8064898,6977564.2551028,592.5792398,53961.1917634,32189.3896848,66217.0052085,136.0601749,173.8131774,1.4972856,993.7333866),(16725,'umzc_hippo_femur-cleaned.tif',250,7,315,3820.4225859,225.3496616,149.2574034,1.8,225.299148,152.4524117,1.3549829,155.0847907,130.0285458,5217474.490508,7198410.5680828,607.5383525,55360.2328059,33642.721932,68794.717952,0.671875,0.9501748,2.3561945,1.9003496),(16726,'umzc_hippo_femur-cleaned.tif',250,7,316,3877.9015311,225.4849579,149.0291414,1.8,225.3685698,152.2917687,1.375658,144.9770197,128.2655407,5417349.9645682,7432098.4303817,622.0166435,57943.0639826,37366.9563415,70402.3940973,139.9839462,177.2591766,1.4530233,1019.7537109),(16727,'umzc_hippo_femur-cleaned.tif',250,7,317,3941.1612012,225.7732689,148.6814957,1.8,225.6597669,152.1780764,1.3871918,156.3641241,123.4599515,5616206.5588852,7612845.9533257,634.9647272,61662.4732388,35917.4880457,73655.5059731,141.4226095,178.0887149,1.4459734,1068.3872355),(16728,'umzc_hippo_femur-cleaned.tif',250,7,318,4016.7950065,225.9711949,148.3163794,1.8,225.5897955,151.9090708,1.3948695,161.8296699,123.366984,5804680.4092591,7803827.1383573,648.9585862,63257.0148656,35869.0740367,77036.5155289,141.5173293,179.4220883,1.4469058,1013.5635894),(16729,'umzc_hippo_femur-cleaned.tif',250,7,319,4109.2930323,226.0994442,148.0502968,1.8,225.7093231,151.8049421,1.4018985,141.6970595,121.3706891,6005558.2710605,7999795.4042646,665.5299841,65912.0868675,42383.0832536,77879.8180519,142.8872391,180.5632144,1.4963075,1136.7043235),(16730,'umzc_hippo_femur-cleaned.tif',250,7,320,4184.5234358,226.1994055,147.8452759,1.8,225.8831492,151.7202311,1.407899,157.8347321,120.6451497,6211512.2887834,8155538.563472,679.0772482,67599.3903209,39354.5337252,79961.2936543,144.4718941,182.121518,1.4821404,1023.6219369),(16731,'umzc_hippo_femur-cleaned.tif',250,7,321,4285.5630745,226.4468137,147.6717145,1.8,226.1517974,151.7225482,1.4378784,145.5171057,118.5475342,6480183.9597511,8422096.9491302,701.7156943,71044.0500129,44532.1113952,82129.065967,145.3248195,184.7986166,1.4834281,1126.0777907),(16732,'umzc_hippo_femur-cleaned.tif',250,7,322,4347.8582188,226.4240396,147.6916144,1.8,226.2134182,151.7985869,1.4550344,154.7394237,114.4833465,6690318.8390023,8618269.6470224,714.9755269,75279.6796264,43236.0330699,85629.9171525,148.1302862,186.0911942,1.4513674,1155.207161),(16733,'umzc_hippo_femur-cleaned.tif',250,7,323,4405.2366214,226.5721578,147.8673559,1.8,226.3776209,151.924074,1.4749332,147.766679,113.3266276,6945777.7741276,8815782.3799077,727.4795831,77790.9178984,47005.0340111,87847.7898011,147.4766164,187.0577825,1.4700555,1133.7862722),(16734,'umzc_hippo_femur-cleaned.tif',250,7,324,4451.4292073,226.6067524,148.1231536,1.8,226.5140016,152.1013734,1.5219205,157.5215545,106.6436441,7117714.3971849,9055749.4809746,740.1339804,84915.979363,45185.6535998,89488.255404,0.671875,0.9501748,2.3561945,1.9003496),(16735,'umzc_hippo_femur-cleaned.tif',250,7,325,4480.558676,226.7730394,148.3739036,1.8,226.4862968,152.1518118,1.5614486,154.393086,111.2377573,7249898.6165087,9283372.8866433,746.6945222,83455.2323879,46957.4046511,90772.514029,0.671875,0.9501748,2.3561945,1.9003496),(16736,'umzc_hippo_femur-cleaned.tif',250,7,326,4510.7476046,227.093429,148.7276702,1.8,226.6459218,152.3901831,-1.5461622,157.4289686,114.1172412,7383247.0664292,9462399.9128,751.3351482,82918.2322937,46898.9102337,93291.7063533,0.671875,0.9501748,2.3561945,1.9003496),(16737,'umzc_hippo_femur-cleaned.tif',250,7,327,4544.5776826,227.3020587,149.1404265,1.8,226.5288558,152.5691604,-1.5175002,156.3092365,116.4912943,7513766.1734796,9645331.7397634,755.2801853,82798.7344148,48069.8795575,98787.7016218,151.2178234,192.2983369,1.5323537,1227.8535771),(16738,'umzc_hippo_femur-cleaned.tif',250,7,328,4592.9720846,227.6081861,149.6085064,1.8,226.5726424,152.7637966,-1.4863744,161.1808356,120.2549654,7670255.1053939,9908376.8884342,760.052557,82394.7423381,47587.8852348,97232.6909528,152.0833153,193.2502306,1.5046907,1145.3234235),(16739,'umzc_hippo_femur-cleaned.tif',250,7,329,4618.2511111,228.2626717,150.0347448,1.8,226.7820617,153.0008657,-1.4648592,163.0478566,122.8728144,7827717.4517369,10133379.4665716,761.102602,82470.4758286,48008.7111613,100059.8668243,153.1858696,194.691952,1.4323156,1166.8118391),(16740,'umzc_hippo_femur-cleaned.tif',250,7,330,4626.967545,228.6587154,150.3460789,1.8,226.9534498,153.1842813,-1.4605756,164.6657693,123.2207607,7893913.8346642,10240351.3374938,761.8305976,83105.7305439,47939.0092181,101609.8515538,154.0195519,194.3484937,1.4773195,1177.0447965),(16741,'umzc_hippo_femur-cleaned.tif',250,7,331,4637.0111423,228.952229,150.4852669,1.8,227.1888358,153.3153476,-1.4460042,168.298847,122.6248097,7984434.0546846,10328455.3908547,760.8621166,84228.1053603,47442.0009118,98326.7610458,0.671875,0.9501748,2.3561945,1.9003496),(16742,'umzc_hippo_femur-cleaned.tif',250,7,332,4607.9586878,229.0966942,150.5798435,1.8,227.1093019,153.6235771,-1.4325609,166.1269433,122.850207,8030371.8271689,10351508.2336059,753.4107401,84261.2193386,48338.7683315,102431.7217445,155.4117126,196.1783083,1.4540877,1189.1665178),(16743,'umzc_hippo_femur-cleaned.tif',250,7,333,4638.0834606,229.2142375,150.6633522,1.8,227.1318524,153.8190731,-1.4171777,165.7380862,125.7162772,8101359.1392904,10464125.6101383,754.9148438,83236.0442436,48880.4916594,103677.6434613,155.2365768,196.1794588,1.4885083,1106.1472915),(16744,'umzc_hippo_femur-cleaned.tif',250,7,334,4675.2560694,229.3721505,150.799022,1.8,227.080606,154.0122843,-1.4206758,169.6999584,122.7316431,8229725.816363,10626177.5187171,761.7804626,86580.585476,48495.744449,100977.2042772,0.671875,0.9501748,2.3561945,1.9003496),(16745,'umzc_hippo_femur-cleaned.tif',250,7,335,4687.5689216,229.6069464,151.0967068,1.8,227.1762326,154.2027535,-1.4159834,169.1597747,124.7447812,8239940.0419714,10715921.7267795,762.6860736,85902.765794,48710.9897018,102131.776592,0.671875,0.9501748,2.3561945,1.9003496),(16746,'umzc_hippo_femur-cleaned.tif',250,7,336,4710.5042779,229.6558573,151.4077406,1.8,227.1376096,154.3836574,-1.4221667,170.3878107,120.1839516,8285269.1308764,10840586.5697443,767.8682865,90199.9511906,48625.9498094,103275.7483905,155.6499491,196.2944769,1.4816859,1195.9923514),(16747,'umzc_hippo_femur-cleaned.tif',250,7,337,4736.3526357,229.7540062,151.6916303,1.8,227.1808821,154.537025,-1.4320002,169.337831,124.5680546,8319450.1772402,10931061.4058817,774.2823835,87751.7228955,49129.306351,104802.0328892,155.5671331,196.5518732,1.4680665,1270.2690097),(16748,'umzc_hippo_femur-cleaned.tif',250,7,338,4752.0190989,229.7198479,151.8270997,1.8,227.2575551,154.5507378,-1.4463262,167.9502342,120.7752287,8327273.0906276,10985066.1137587,779.7960583,90954.6289431,49581.7890914,104930.916791,155.0080608,196.2059189,1.5844941,1168.5607502),(16749,'umzc_hippo_femur-cleaned.tif',250,7,339,4776.6941854,229.8172254,151.798525,1.8,227.4750528,154.529231,-1.4591636,164.9709777,117.4630175,8338143.0218243,11070705.9167241,786.2357492,94248.437972,50543.0903,106325.5277274,156.8317941,195.3065746,1.5019398,1258.1357027),(16750,'umzc_hippo_femur-cleaned.tif',250,7,340,4799.981099,229.846178,151.9661475,1.8,227.4347342,154.5253288,-1.4647537,167.3216339,118.8557293,8353061.0058747,11123387.0904022,791.034528,93587.3025117,49922.1816644,104970.6855988,155.2872084,194.6838366,1.4982595,1282.7167795),(16751,'umzc_hippo_femur-cleaned.tif',250,7,341,4822.6721434,229.8070914,152.0658627,1.8,227.4659752,154.5275328,-1.4855128,164.4926787,114.7827711,8364262.6509363,11147075.8244482,797.9467506,97114.5383477,50848.8445665,105126.2163236,155.3159028,194.8622958,1.5570041,1219.6791945),(16752,'umzc_hippo_femur-cleaned.tif',250,7,342,4827.0330963,229.7780784,152.129701,1.8,227.4093695,154.3902595,-1.4973137,162.5547152,116.1486026,8324607.4918361,11117826.9687889,800.169245,95720.7122854,51211.1105569,105829.7178448,155.5550883,193.9194793,1.9320001,1147.8874557),(16753,'umzc_hippo_femur-cleaned.tif',250,7,343,4829.1771858,229.7771578,152.2832456,1.8,227.3918035,154.2711506,-1.5074898,164.0589217,106.2081906,8286727.6428959,11097080.5796192,801.6415025,104484.2258642,50510.6796711,102954.5386113,155.415913,194.6189018,1.8903635,1212.7974198),(16754,'umzc_hippo_femur-cleaned.tif',250,7,344,4827.6132343,229.7713713,152.5718652,1.8,227.3366621,154.3309435,-1.5139331,163.3564162,113.3625265,8225553.2905867,11013100.1423579,802.0033914,97149.3885926,50353.4142345,102696.3414185,0.671875,0.9501748,2.3561945,1.9003496),(16755,'umzc_hippo_femur-cleaned.tif',250,7,345,4847.893033,229.9326538,152.693505,1.8,227.5621465,154.2161041,-1.5267114,161.7554182,112.050964,8200733.604614,10959604.6534983,806.4128928,97809.1063072,50698.3549251,101880.4321052,154.4211281,193.0106509,1.9487171,1213.6241267),(16756,'umzc_hippo_femur-cleaned.tif',250,7,346,4843.7017031,229.8198104,152.7554583,1.8,227.5002494,154.0167453,-1.5363784,159.8312215,110.6881036,8097078.6772452,10861535.372878,806.327687,98127.395952,50660.1814267,101847.8511299,154.4033959,193.3903347,1.9145214,1180.9525789),(16757,'umzc_hippo_femur-cleaned.tif',250,7,347,4856.4455892,229.8083772,153.006077,1.8,227.6506436,153.997122,-1.5474379,157.6913836,110.5715115,8026891.6649897,10774951.3563708,808.9660412,97447.8074035,50902.5381198,107736.0462109,153.7925157,192.6360771,1.9532457,1178.8100924),(16758,'umzc_hippo_femur-cleaned.tif',250,7,348,4857.4495112,229.8395912,153.2326687,1.8,227.734601,153.9129452,-1.562203,157.390793,108.1673008,7947799.3154145,10658495.8455321,809.5151361,98537.134341,50497.231543,102414.7626745,152.829026,192.156262,1.9655874,1154.2406014),(16759,'umzc_hippo_femur-cleaned.tif',250,7,349,4862.310168,229.7330605,153.4327902,1.8,227.6152671,153.795486,1.5612195,157.034989,105.1849528,7860288.1054184,10523577.4249471,810.3107088,100048.316255,50054.3742194,99186.8673094,152.4721875,191.6434492,1.959115,1228.7873671),(16760,'umzc_hippo_femur-cleaned.tif',250,7,350,4856.7431135,229.6459799,153.6673529,1.8,227.6720574,153.6924208,1.5569384,154.9747356,106.1089999,7784199.460568,10353538.5339517,809.3017495,97574.5558248,50228.828791,96960.8931365,151.2861105,190.7675572,1.9571888,1142.5124554),(16761,'umzc_hippo_femur-cleaned.tif',250,7,351,4833.4214545,229.6459351,153.8218386,1.8,227.7073631,153.6003092,1.5448382,153.9184193,106.0525118,7642109.1191708,10154893.1043378,805.0275593,95753.4425928,49650.3872188,97495.0462246,151.0692528,190.4004252,1.9617872,1197.5270962),(16762,'umzc_hippo_femur-cleaned.tif',250,7,352,4799.6620983,229.7106617,153.8261581,1.8,227.8594146,153.4058517,1.5195685,152.4368241,113.2220426,7495414.1205724,9945561.7830415,797.8462275,87841.2149693,49170.6263508,92982.1977518,149.9013335,189.2697156,1.9565762,1167.0935322),(16763,'umzc_hippo_femur-cleaned.tif',250,7,353,4772.2422653,229.7474415,154.0604402,1.8,227.837322,153.5001305,1.500935,149.7857587,113.6660198,7292612.6714622,9737883.1771757,791.4981172,85671.0139989,48686.9562011,94092.7030964,150.3604986,188.7980823,1.9691462,1166.9189222),(16764,'umzc_hippo_femur-cleaned.tif',250,7,354,4728.5958029,229.738859,154.2927569,1.8,227.8824195,153.5450297,1.4830551,148.430593,114.1985108,7075362.2859463,9499778.2580663,782.0476457,83186.533629,47667.8166088,88566.3430418,148.3132018,186.7788448,1.9426189,1090.1177879),(16765,'umzc_hippo_femur-cleaned.tif',250,7,355,4686.1796544,229.7817419,154.4666014,1.8,227.9527485,153.561565,1.4597186,144.3514084,118.1014802,6904947.9294269,9259865.5672342,771.4329509,78406.0077102,47834.2955407,92009.4484226,146.478912,185.7537049,1.9177132,1151.8116228),(16766,'umzc_hippo_femur-cleaned.tif',250,7,356,4615.011722,229.6997233,154.6551546,1.8,227.8866423,153.5510773,1.4336721,141.0197265,124.7883522,6677417.5298996,8997849.0015583,754.7963148,72104.8787478,47350.9465355,83864.2452378,0.671875,0.9501748,2.3561945,1.9003496),(16767,'umzc_hippo_femur-cleaned.tif',250,7,357,4551.660948,229.6626334,154.768105,1.8,227.8340342,153.4874156,1.4047447,140.5704342,126.4692881,6469228.3701123,8729438.4882374,737.8844469,69024.1766864,46021.2590715,83461.1924236,144.0688409,183.0671478,1.9308557,1084.7707581),(16768,'umzc_hippo_femur-cleaned.tif',250,7,358,4483.921589,229.7056815,154.7811536,1.8,227.7967667,153.3468296,1.3735471,132.3181887,128.9471684,6246164.524505,8489932.9683639,718.6192384,65840.3986302,47205.6380556,80904.6417609,143.027891,181.9094697,1.9451299,1112.337413),(16769,'umzc_hippo_femur-cleaned.tif',250,7,359,4419.8496436,229.6919609,154.8982659,1.8,227.7111248,153.4017854,1.3381461,147.4338264,134.219957,6048967.4235296,8215221.0261103,697.4842576,61207.1498848,41028.3553736,77816.2228894,142.054534,180.554464,1.9361,1075.4040638),(16770,'umzc_hippo_femur-cleaned.tif',250,7,360,4363.4264648,229.5996566,155.0468764,1.8,227.7057661,153.232853,1.3007797,157.9732953,134.0176228,5870241.6727574,7928988.5338445,675.4917073,59163.7753886,37159.7089277,76830.147053,141.7656339,179.0594257,1.9352762,1042.8280134),(16771,'umzc_hippo_femur-cleaned.tif',250,7,361,4285.6000085,229.7846086,155.3193654,1.8,227.7689975,153.4267362,1.2540846,163.0378116,145.0757893,5584400.635699,7604319.1043543,644.9848787,52416.1828803,34252.1810246,71392.652939,140.1594669,177.4271755,1.9632571,1043.6151639),(16772,'umzc_hippo_femur-cleaned.tif',250,7,362,4204.6189746,229.9079507,155.5534131,1.8,227.7582362,153.4662548,1.2176791,135.4527247,151.8596714,5318407.8953376,7276163.3593179,616.9615955,47913.7304291,39263.9417767,68008.2665558,0.671875,0.9501748,2.3561945,1.9003496),(16773,'umzc_hippo_femur-cleaned.tif',250,7,363,4121.143525,229.917268,155.7104511,1.8,227.813377,153.7635681,1.1670422,141.1116032,145.647766,5033738.1943247,6976621.0939348,580.8411992,47900.6392448,35672.0360333,71250.7638179,0.671875,0.9501748,2.3561945,1.9003496),(16774,'umzc_hippo_femur-cleaned.tif',250,7,364,4027.6558036,230.1359937,155.9268376,1.8,227.8476683,153.7683018,1.1212285,154.2924949,160.6498101,4757490.1569824,6650841.8128459,544.5010684,41399.6244896,30834.2292256,62445.2538498,0.9501748,1.9003496,2.3561945,3.8006992),(16775,'umzc_hippo_femur-cleaned.tif',250,7,365,3954.1552812,230.1792272,155.8848231,1.8,227.7392511,153.7078314,1.0536699,156.8703982,161.2973785,4483298.0587939,6390047.9519147,497.9495065,39616.5642057,28579.6307682,60166.5812366,133.7031334,169.3898119,1.9829797,981.0666516),(16776,'umzc_hippo_femur-cleaned.tif',250,7,366,3883.7392985,230.2915454,155.9932878,1.8,227.8548266,153.7589592,0.995519,163.0047581,155.3458752,4230164.8629754,6123892.3687963,455.6859783,39421.0168756,25951.1741381,59248.3100214,131.6875082,167.3562374,1.975161,1060.2687939),(16777,'umzc_hippo_femur-cleaned.tif',250,7,367,3790.185643,230.6087607,156.2026182,1.8,227.9224645,153.7632763,0.9482204,166.9193784,177.8831529,3944375.5683109,5811007.7288577,416.8949635,32667.5552739,23630.4232973,51490.8961981,129.8246853,165.1583106,1.9853032,991.4510475),(16778,'umzc_hippo_femur-cleaned.tif',250,7,368,3711.0928963,230.706289,156.2858797,1.8,227.9309828,153.9890147,0.8872273,159.5705669,182.40537,3641557.363267,5553183.6474669,371.8061561,30444.1894802,22820.9840607,48169.5794873,128.4069726,163.3153961,1.9902738,1009.5043686),(16779,'umzc_hippo_femur-cleaned.tif',250,7,369,3625.2632434,231.4240437,156.6974943,1.8,228.205011,154.6506826,0.8136868,159.2133639,179.8351824,3321793.9818162,5278180.3166295,319.1884501,29350.0985021,20863.7886992,46763.7904293,126.178196,160.3882673,1.9800885,986.9702809),(16780,'umzc_hippo_femur-cleaned.tif',250,7,370,3524.1397508,231.7988319,156.9710134,1.8,228.2440305,155.0079977,0.76222,157.3827178,181.8140011,2971437.2358084,4988884.4387651,280.0693324,27439.4953556,18880.3273813,42752.4122053,123.7925398,156.6981998,1.9903267,974.1173501),(16781,'umzc_hippo_femur-cleaned.tif',250,7,371,3336.4867736,231.6335755,157.6577295,1.8,228.1132776,155.8198248,0.7509884,118.5765283,177.4601874,2554306.7554385,4548995.8991565,258.9210231,25633.8954966,21541.4196444,39045.5124958,0.671875,1.5023583,2.0344439,3.2440997),(16782,'umzc_hippo_femur-cleaned.tif',250,7,372,2879.6472794,227.3375059,158.9029479,1.8,225.327983,156.583541,0.8773911,151.3516556,176.7972928,1772974.1739501,3876111.1356745,283.8731487,21924.0412221,11714.270098,31048.8734669,0.671875,0.9501748,2.3561945,1.9003496),(16783,'umzc_hippo_femur-cleaned.tif',250,7,373,2498.6466429,224.4200316,160.7239551,1.8,220.8554809,158.0358684,0.932288,119.4869773,171.6336912,1106370.8386293,3274325.809414,268.5153918,19077.4071587,9259.3424294,24689.3831732,87.0075454,147.5328057,2.0385172,714.8874538),(16784,'umzc_hippo_femur-cleaned.tif',250,7,374,2168.8479427,223.6644686,162.2253882,1.8,219.4063787,159.4293003,0.9235318,123.3572883,126.0794405,741320.5243986,2732650.7308353,230.0363809,21674.0391602,6009.5397239,26946.9869561,81.3236319,144.2576893,2.0552743,671.0839158),(16785,'umzc_hippo_femur-cleaned.tif',250,7,375,1819.3353556,224.1690602,163.2543706,1.8,219.6114506,160.0542816,0.8787232,118.9151281,183.2132468,587704.5368181,2211091.4519177,179.7454983,12068.4038434,4942.2184224,14850.3882379,40.5385679,110.0419744,1.6686424,372.8013555),(16786,'umzc_hippo_femur-cleaned.tif',250,7,376,1499.1447045,225.454662,165.2848075,1.8,220.6058521,161.4732488,0.799991,127.3023649,126.3966412,455963.9857636,1678563.649846,128.5743278,13280.1286057,3581.7401058,16622.3063809,35.6093772,62.1765811,1.6790669,209.4552021),(16787,'umzc_hippo_femur-cleaned.tif',250,7,377,1156.573255,228.5787813,169.7899555,1.8,223.3385157,165.6006126,0.5780763,43.6205315,72.3222037,287892.1718039,1042282.1410601,57.5526426,14411.6479874,6599.9235185,16177.0401764,31.5602444,54.6247218,1.6570019,166.7253068),(16788,'umzc_hippo_femur-cleaned.tif',250,7,378,904.8343796,231.6607703,173.2100271,1.8,228.0480583,172.3544221,0.3128118,56.5122802,56.3044296,109556.2405139,680789.2953972,14.2814462,12091.220897,1938.6271474,9910.6875306,26.8750017,45.8108428,1.6441937,135.0714606),(16789,'umzc_hippo_femur-cleaned.tif',250,7,379,680.4915352,234.2858601,173.6732547,1.8,230.6200726,172.5904903,0.2859056,22.6085882,47.9412548,65462.0312393,507366.5117753,9.0209222,10583.0878712,2895.4497568,11769.1552398,22.1718764,37.8403459,1.4640607,104.435316),(16790,'umzc_hippo_femur-cleaned.tif',250,7,380,441.4608429,240.7293451,175.0753637,1.8,236.3263735,174.0521919,0.2433353,20.3942329,49.8211217,32779.4812006,281665.8641175,4.2713225,5653.5432042,1607.2916949,6284.7801195,17.2052395,26.3405866,1.4685896,73.1075183),(16791,'umzc_hippo_femur-cleaned.tif',250,7,381,230.707811,254.9435267,177.723787,1.8,250.5350709,176.9632554,0.1841898,17.4154289,59.3804939,15489.0449161,20839.2098273,1.2898093,350.9436929,889.3863601,611.5673924,18.3685199,35.8368348,1.6835239,106.3356656),(16792,'umzc_hippo_femur-cleaned.tif',250,7,382,122.6716336,257.4165254,177.436067,1.8,256.9953432,177.7297862,-1.3213535,7.2749745,15.0122007,1016.1709312,5675.3296064,19.1992989,378.0478097,139.6803424,430.7981253,14.2347463,30.4204363,1.4601391,95.0965923),(16793,'umzc_hippo_femur-cleaned.tif',250,7,383,20.737644,258.5932245,174.9044048,1.8,257.9820653,176.6005597,-1.2592179,5.5845887,10.2353814,88.8976711,687.3557436,3.1314536,67.1548737,15.9183918,74.6913213,11.2451385,21.3525229,1.3487144,64.1623698),(16794,'umzc_hippo_femur-cleaned.tif',250,7,384,0.3904065,260.305202,168.9841063,1.8,260.3515788,168.9765731,0.7804875,0.5177325,1.4528984,0.0623701,0.2892808,0.0322144,0.199106,0.1204678,0.241979,1.9003496,3.8006992,2.3561945,7.6013984),(16795,'umzc_hippo_femur-cleaned.tif',250,7,385,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16796,'umzc_hippo_tibia-cleaned.tif',250,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16797,'umzc_hippo_tibia-cleaned.tif',250,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16798,'umzc_hippo_tibia-cleaned.tif',250,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16799,'umzc_hippo_tibia-cleaned.tif',250,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16800,'umzc_hippo_tibia-cleaned.tif',250,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(16801,'umzc_hippo_tibia-cleaned.tif',250,8,6,0.4784388,125.3496619,120.8264499,1.8,125.3482615,120.8295677,1.2240198,0.6258586,1.8434443,0.0542912,0.4556984,0.070529,0.2471994,0.0867467,0.2766423,1.7518021,4.2100974,2.0344439,9.0910243),(16802,'umzc_hippo_tibia-cleaned.tif',250,8,7,18.0597549,124.9697697,120.4108806,1.8,124.8638778,120.6994866,1.18273,2.5078065,7.3408749,14.8865776,144.5471403,2.5789747,19.6907238,5.9360951,21.6997189,5.0525916,14.3158789,2.0491488,32.0943168),(16803,'umzc_hippo_tibia-cleaned.tif',250,8,8,53.9707955,124.7834572,121.2082835,1.8,124.6629529,121.3172008,1.1747166,3.8854598,10.2639382,125.4305433,1046.0246566,7.656249,101.9126031,32.2820337,113.8224948,7.1505135,20.6305512,2.0446477,48.1651292),(16804,'umzc_hippo_tibia-cleaned.tif',250,8,9,131.7775913,130.0585019,124.7625209,1.8,133.7273787,126.6856055,0.6227755,9.9980449,29.358373,2124.8886578,23846.3907633,7.47243,812.25178,212.5304168,884.2741607,11.2599024,27.8153332,1.9890207,73.9453327),(16805,'umzc_hippo_tibia-cleaned.tif',250,8,10,243.0950426,134.916247,127.4730889,1.8,135.7980906,127.7141832,0.5572031,11.4287603,25.7387285,6285.9927618,61033.8363762,11.3300325,2371.2840526,550.0152757,2572.8827386,13.5806002,32.8448313,2.0152155,109.0449841),(16806,'umzc_hippo_tibia-cleaned.tif',250,8,11,333.2379185,136.0563664,128.0237751,1.8,136.2383606,127.7509005,0.5423716,12.8425111,28.6051044,11245.536598,91123.3438996,14.7974227,3185.5623602,875.6493581,3492.7713999,0.8424969,1.6971445,2.1587989,3.6041058),(16807,'umzc_hippo_tibia-cleaned.tif',250,8,12,417.9836881,136.8261998,128.1743493,1.8,136.7971245,127.6327222,0.5257498,14.8094088,30.5885267,17556.3815284,122220.6269043,17.5459045,3995.6362764,1185.4883459,4421.0859073,0.4707032,0.6656748,2.3561945,1.3313497),(16808,'umzc_hippo_tibia-cleaned.tif',250,8,13,501.7078572,137.152555,127.9028622,1.8,137.2586249,127.3807319,0.5164214,16.5863591,31.8903228,25595.9901604,154831.3848892,20.3868968,4855.1212746,1543.1952235,5519.3921244,0.6656748,1.3313497,0.7853982,2.6626994),(16809,'umzc_hippo_tibia-cleaned.tif',250,8,14,593.427446,137.6188278,127.7909345,1.8,137.710852,127.2544843,0.5132135,17.9188573,33.0384852,35799.3590835,190455.6808311,23.8419801,5764.6614206,1997.8594874,6671.1081399,22.0278591,39.2494218,1.9646649,137.9251384),(16810,'umzc_hippo_tibia-cleaned.tif',250,8,15,685.1242074,137.8344244,127.49924,1.8,137.9160369,126.9459705,0.5167699,19.1670652,34.3883156,47947.8754245,229468.0960244,27.8742017,6672.8506995,2501.5762719,7932.0370734,0.6656748,1.3313497,2.3561945,2.6626994),(16811,'umzc_hippo_tibia-cleaned.tif',250,8,16,778.7116277,137.9379803,127.1364877,1.8,137.9354783,126.5968958,0.5244216,23.385539,35.0511491,63149.1819189,271778.9489055,32.5388192,7753.7814367,2700.3517849,9372.0404093,38.4265634,67.9265651,2.4592761,320.3443965),(16812,'umzc_hippo_tibia-cleaned.tif',250,8,17,885.3923318,138.0219236,126.5992075,1.8,137.9870874,126.0348155,0.5331838,22.1143483,36.2724165,84456.3828129,321877.9317463,38.1229469,8873.9037321,3819.0762647,10968.0193055,0.4707032,0.6656748,2.3561945,1.3313497),(16813,'umzc_hippo_tibia-cleaned.tif',250,8,18,999.6819313,138.0787923,125.7952567,1.8,137.9872232,125.182137,0.5450345,30.7647369,90.1758899,112166.6065265,373541.3592133,44.7837021,4142.3639905,3645.9472054,5365.0450688,0.4707032,0.6656748,2.3561945,1.3313497),(16814,'umzc_hippo_tibia-cleaned.tif',250,8,19,1136.0842518,137.9761229,124.2616986,1.8,137.6988851,123.6941211,0.5941681,30.6594871,38.3010712,162106.4230074,447601.5128705,59.3410575,11686.3967184,5287.3168612,15918.4845385,53.7926706,76.2437478,2.5450286,373.6179799),(16815,'umzc_hippo_tibia-cleaned.tif',250,8,20,1251.7913085,137.8595909,122.3974673,1.8,137.8102381,122.2585182,0.6652166,31.5190275,40.6168223,230032.8325916,538142.9787068,79.4829385,13249.2634248,7298.2211438,18912.575803,57.9515406,78.6426584,2.6217041,357.2045322),(16816,'umzc_hippo_tibia-cleaned.tif',250,8,21,1344.4309823,137.9965372,121.1552697,1.8,137.7856572,121.1589733,0.7063079,32.9074348,86.3569829,306466.6732182,628466.2046138,94.3877739,7277.5377677,9312.9918856,10492.925208,62.2544088,80.9787362,2.6181207,383.3550834),(16817,'umzc_hippo_tibia-cleaned.tif',250,8,22,1467.3250275,138.0142007,119.6786218,1.8,137.6740804,119.7281894,0.7837317,37.3377914,87.7635745,411939.3376002,745203.6832888,121.8694946,8491.0361413,11032.771963,12512.2611852,67.8041095,84.3714966,2.1293956,402.9549811),(16818,'umzc_hippo_tibia-cleaned.tif',250,8,23,1601.1576362,137.9507203,118.3931506,1.8,137.5047162,118.7387238,0.840662,96.6018384,46.7067308,539204.0936729,885639.9559591,148.1474229,18961.7200825,5581.7166874,14594.4860631,73.1274789,89.2662274,1.7671578,485.9521469),(16819,'umzc_hippo_tibia-cleaned.tif',250,8,24,1715.0366083,137.6311948,117.8393986,1.8,137.2558227,118.2026288,0.8351432,60.7763645,80.5405884,680573.7745822,1021767.8513318,157.115307,12686.3718213,11198.0007446,18993.5021465,0.4707032,0.6656748,2.3561945,1.3313497),(16820,'umzc_hippo_tibia-cleaned.tif',250,8,25,1838.9669575,137.3038648,117.8348335,1.8,136.9185646,117.8281423,0.7488358,103.9197718,53.6935813,855020.0521358,1171796.0362375,142.050994,21823.7638261,8227.6937046,19309.3498429,83.5428635,96.1940461,1.7777885,573.4785914),(16821,'umzc_hippo_tibia-cleaned.tif',250,8,26,1967.2426669,136.6419577,117.9503953,1.8,136.4239568,117.6718867,0.6065739,88.839745,93.2861047,1046726.1523789,1335186.7467772,106.5470168,14312.8148659,11782.1832164,24777.007591,88.4000272,99.3284129,1.7663332,652.6351111),(16822,'umzc_hippo_tibia-cleaned.tif',250,8,27,2122.843569,135.7259221,118.1585798,1.8,135.6878642,117.7623304,0.3563476,83.9961743,95.5544271,1255485.4305576,1570193.4508739,43.0578755,16432.4511016,14946.9358654,27843.1081385,94.1991149,103.845276,2.7509856,617.2320157),(16823,'umzc_hippo_tibia-cleaned.tif',250,8,28,2331.2354846,133.6941097,118.2894662,1.8,133.8585705,117.7140502,0.1820348,77.9711177,92.8188955,1455626.4547,1988449.6585773,12.733277,21422.8972219,18668.7904198,32428.2343045,100.9477584,120.1612244,2.5231647,675.1342485),(16824,'umzc_hippo_tibia-cleaned.tif',250,8,29,2522.9724802,131.494836,117.900461,1.8,131.9642858,117.3737557,0.1706036,79.2307269,93.9070863,1639532.8035725,2472419.7947863,12.1204489,26328.3623387,20693.1435183,37459.3250222,102.431956,122.2179742,2.6038152,734.7023494),(16825,'umzc_hippo_tibia-cleaned.tif',250,8,30,2647.8105606,131.0254913,118.3367675,1.8,131.4618693,117.8058065,0.1415106,78.1517645,94.1189279,1802494.5125574,2813310.0401294,8.7783204,29891.0124027,23064.0283691,42165.3080803,104.3494075,124.5906107,2.6238523,794.688106),(16826,'umzc_hippo_tibia-cleaned.tif',250,8,31,2731.7033179,131.134318,119.3237608,1.8,131.1315709,118.6988473,0.0825846,74.0073815,91.2745263,1949611.9531868,3088275.7072292,3.0980641,33835.0231226,26343.4797227,45925.1497989,105.7877106,127.8762938,2.8349748,731.1928597),(16827,'umzc_hippo_tibia-cleaned.tif',250,8,32,2869.0707071,130.917251,120.6864366,1.8,130.7987433,119.8973679,0.007295,69.5488862,90.6459962,2153179.558519,3518315.6408927,0.0254453,38813.8008118,30959.2241641,50757.0993421,107.2436324,132.3555121,2.8715976,753.5892642),(16828,'umzc_hippo_tibia-cleaned.tif',250,8,33,3104.1106425,131.3899462,122.7131819,1.8,131.4448053,121.6700067,-0.0854321,64.6270832,95.6330691,2444436.4687816,4389138.5782207,3.7668137,45895.6155974,37823.7164347,61018.0180956,0.4707032,0.6656748,2.3561945,1.3313497),(16829,'umzc_hippo_tibia-cleaned.tif',250,8,34,3332.0980036,132.3088614,124.5879284,1.8,132.1062986,123.6533731,-0.162224,67.9873669,98.1288313,2815445.9262815,5292265.8724633,14.4872196,53931.8139408,41411.3099936,72118.8302326,0.4707032,0.6656748,2.3561945,1.3313497),(16830,'umzc_hippo_tibia-cleaned.tif',250,8,35,3572.606818,131.5295637,127.8362725,1.8,132.0656458,126.230212,-0.289705,73.0501747,106.7970793,3378551.8392231,5977954.0048823,48.5917382,55974.8828911,46249.7434774,81370.1090021,0.4707032,0.6656748,2.3561945,1.3313497),(16831,'umzc_hippo_tibia-cleaned.tif',250,8,36,3739.9126854,131.9109091,130.1212732,1.8,132.6369571,127.3701384,-0.3509192,74.5263588,109.1581164,3824568.7898508,6387089.7384215,73.6587372,58512.2751314,51318.3369176,87184.0607637,0.4707032,1.0525243,2.677945,1.9970245),(16832,'umzc_hippo_tibia-cleaned.tif',250,8,37,3803.0437105,133.1354717,130.4210634,1.8,133.3538157,127.7468639,-0.3112304,76.3815317,105.6238385,4082970.8305382,6545484.1249213,59.4396874,61969.7619239,53454.9483626,93441.4092298,1.5714473,3.5847688,1.1659045,10.2608542),(16833,'umzc_hippo_tibia-cleaned.tif',250,8,38,3834.9659036,134.271275,130.2674243,1.8,134.1128242,127.9842923,-0.2441874,97.8129659,103.0160104,4254151.8593907,6679437.1058864,37.3601176,64838.8253542,43492.7191991,91815.0862508,0.4707032,0.6656748,2.3561945,1.3313497),(16834,'umzc_hippo_tibia-cleaned.tif',250,8,39,3832.3633604,135.4422125,129.8474843,1.8,134.696924,127.9722539,-0.1989024,91.8606428,98.8719814,4346671.8988952,6675644.5861712,24.9380112,67518.0621682,47318.1088694,96854.9705482,0.4707032,0.6656748,2.3561945,1.3313497),(16835,'umzc_hippo_tibia-cleaned.tif',250,8,40,3842.9667617,136.0547811,129.312636,1.8,134.996557,127.819434,-0.1674726,90.19156,98.0916626,4400306.9707321,6702393.2694929,17.7967123,68327.8587723,48788.4561773,95431.3130773,0.4707032,0.6656748,2.3561945,1.3313497),(16836,'umzc_hippo_tibia-cleaned.tif',250,8,41,3866.6450504,136.5591097,128.7783428,1.8,135.3829548,127.6989195,-0.1453734,89.4932062,97.8567776,4410125.0171306,6726480.2397395,13.5236318,68738.0108145,49278.8805149,92920.7569647,0.4707032,0.6656748,2.3561945,1.3313497),(16837,'umzc_hippo_tibia-cleaned.tif',250,8,42,3909.3148613,136.3817626,128.6739356,1.8,135.6042985,127.8464722,-0.1472728,86.6345428,96.2959229,4409351.6893114,6767357.1940285,14.0298607,70276.6741605,50896.0000122,96976.5076529,0.4707032,0.6656748,2.3561945,1.3313497),(16838,'umzc_hippo_tibia-cleaned.tif',250,8,43,3952.1435251,136.396851,128.4789056,1.8,135.9034223,127.782763,-0.1577553,79.0492078,96.9891856,4403908.0699063,6832015.6418037,16.257168,70441.0043155,55710.9703116,100156.0921484,0.4707032,0.6656748,2.3561945,1.3313497),(16839,'umzc_hippo_tibia-cleaned.tif',250,8,44,3947.3659184,136.6207646,128.0957056,1.8,136.0654595,127.5459128,-0.1687261,78.988174,96.9627753,4394757.4173254,6846049.4578754,18.552255,70604.9247873,55638.1695265,100256.1120131,1.2637454,2.1050487,2.0344439,5.3253988),(16840,'umzc_hippo_tibia-cleaned.tif',250,8,45,3899.0694498,137.0231729,127.4659848,1.8,136.1806757,127.2564328,-0.1684362,88.5418504,99.3107996,4338535.523744,6819170.9843203,18.2629409,68664.9489567,48999.8289633,94759.3279098,132.686383,157.7558098,0.6136592,1077.5850746),(16841,'umzc_hippo_tibia-cleaned.tif',250,8,46,3820.0787094,137.4472111,126.5256277,1.8,136.2334979,126.6717957,-0.1505113,74.8231927,98.5422438,4255271.9260854,6693973.140475,14.3145768,67929.9849839,56871.0285394,99203.0777301,0.4707032,0.6656748,2.3561945,1.3313497),(16842,'umzc_hippo_tibia-cleaned.tif',250,8,47,3721.0880058,137.8121588,125.5850624,1.8,136.1279664,126.234279,-0.1275768,84.1541536,94.8683696,4142979.5503361,6474629.6184177,10.0393676,68248.5600483,49230.8385743,93666.127046,132.0612689,157.333908,0.6045986,1099.2570173),(16843,'umzc_hippo_tibia-cleaned.tif',250,8,48,3606.4616326,137.8627034,124.7494291,1.8,135.8479645,125.6505872,-0.0850784,74.5874253,97.5676938,3976150.2676791,6194941.9790877,4.340338,63493.7830327,53308.5872603,93138.0880849,0.4707032,0.6656748,2.3561945,1.3313497),(16844,'umzc_hippo_tibia-cleaned.tif',250,8,49,3436.1364177,136.9672085,123.9967056,1.8,135.1569838,124.9503209,-0.054122,72.6754676,94.0788475,3753602.298249,5753183.7538778,1.6758924,61152.7873253,51648.8220826,88384.4131264,0.4707032,0.6656748,2.3561945,1.3313497),(16845,'umzc_hippo_tibia-cleaned.tif',250,8,50,3297.8617673,136.3763186,123.7252518,1.8,134.591993,124.6182393,-0.0143557,72.4825215,91.4733073,3583518.7904574,5405596.4554252,0.1132696,59094.7962129,49439.7644817,83857.8417553,130.4118288,155.7309276,0.6265741,1108.7102725),(16846,'umzc_hippo_tibia-cleaned.tif',250,8,51,3181.7530799,136.4789424,123.1274552,1.8,134.4849836,124.1333447,0.0813419,76.0090947,95.8970914,3366030.5214731,5093344.2789612,3.5009344,53112.6043899,44284.5758993,75280.9359372,0.4707032,0.6656748,2.3561945,1.3313497),(16847,'umzc_hippo_tibia-cleaned.tif',250,8,52,3076.8521869,136.5003235,122.5664446,1.8,134.3480554,123.5051103,0.1668776,82.5555085,92.5140026,3168116.3372858,4827480.5540388,14.1486538,52181.0798335,38375.5898758,74407.0733544,122.9309287,153.7874583,0.5871537,1060.5924514),(16848,'umzc_hippo_tibia-cleaned.tif',250,8,53,3019.0948364,136.1830987,122.1808807,1.8,134.0059943,123.0517784,0.2024518,83.7243869,94.9936788,3042881.498291,4665069.6110179,20.343525,49109.2636051,36344.0284554,71057.8119043,120.8844959,151.1477734,0.472004,1099.8003636),(16849,'umzc_hippo_tibia-cleaned.tif',250,8,54,2928.89892,135.5363079,121.3843845,1.8,133.5018228,122.5949551,0.1993805,84.8279208,101.1382513,2864500.9205203,4419655.0083547,19.1494041,43699.1439965,33768.3735781,65378.9676632,0.4707032,1.0525243,2.677945,1.9970245),(16850,'umzc_hippo_tibia-cleaned.tif',250,8,55,2825.0828732,133.9360307,120.0221426,1.8,132.5004768,121.9412499,0.1547525,77.803726,91.3608072,2646282.0369895,4079495.8974209,11.1862446,44652.5816041,34012.2790072,62245.4866995,0.4707032,0.6656748,2.3561945,1.3313497),(16851,'umzc_hippo_tibia-cleaned.tif',250,8,56,2705.5056724,132.1871129,119.0820043,1.8,131.3878662,121.1231365,0.1078425,78.8627092,92.085188,2439565.8508596,3687578.1640641,5.2238558,40045.2911387,30934.3398861,56350.6830336,0.4707032,1.0525243,2.677945,1.9970245),(16852,'umzc_hippo_tibia-cleaned.tif',250,8,57,2572.2699372,130.0684378,118.8501579,1.8,129.3940761,120.5848887,0.1205668,79.7769191,91.8588674,2236048.2559463,3209352.2840353,6.2017418,34937.8603673,28028.7617177,49244.7476318,0.4707032,1.0525243,2.677945,1.9970245),(16853,'umzc_hippo_tibia-cleaned.tif',250,8,58,2466.5450364,128.8224393,118.9785364,1.8,128.1914158,120.4521041,0.2016228,80.8800862,100.7688806,2084733.4088005,2887700.845669,16.4862923,28656.6728517,25775.6081322,44418.018806,0.4707032,1.0525243,2.677945,1.9970245),(16854,'umzc_hippo_tibia-cleaned.tif',250,8,59,2397.5287309,127.770289,119.1553486,1.8,127.0286963,120.5717764,0.2763478,89.6794423,104.5975154,1981330.4192603,2661656.3526354,29.7467983,25446.6498811,22093.4739054,40974.2664317,0.4707032,0.6656748,2.3561945,1.3313497),(16855,'umzc_hippo_tibia-cleaned.tif',250,8,60,2329.8767749,126.6559337,119.1016327,1.8,125.9668185,120.5114293,0.3904293,96.81838,107.0557975,1887425.9239178,2455476.7222393,56.2451977,22936.4198907,19494.5001606,38025.3270581,0.4707032,0.6656748,2.3561945,1.3313497),(16856,'umzc_hippo_tibia-cleaned.tif',250,8,61,2272.2059006,125.8777029,118.9391111,1.8,125.042431,120.4987047,0.4832178,102.2861432,107.4889397,1805759.7615514,2313433.4773595,81.7546086,21522.5257974,17654.0018505,35839.422308,103.8787079,119.5928908,2.314436,707.4292763),(16857,'umzc_hippo_tibia-cleaned.tif',250,8,62,2226.95248,125.3729258,118.6725325,1.8,124.5917818,120.231573,0.5660241,104.8725452,96.8885701,1741899.0610289,2200108.5777376,106.7439622,22707.617379,16609.6766031,34384.2492726,0.4707032,0.6656748,2.3561945,1.3313497),(16858,'umzc_hippo_tibia-cleaned.tif',250,8,63,2191.1159647,124.8951303,118.4396118,1.8,124.0915667,119.9951172,0.6422603,107.0396879,66.1777363,1694772.4245564,2106280.2592651,131.0320407,31827.6262843,15833.1218861,33416.6312356,102.7353802,115.633105,2.3072423,752.2856269),(16859,'umzc_hippo_tibia-cleaned.tif',250,8,64,2163.9960857,124.606895,118.2000901,1.8,123.811699,119.7718315,0.733875,110.5087088,88.4238535,1658458.8050635,2034656.7961039,161.78315,23010.2706058,15007.4941875,32170.9578642,0.4707032,1.0525243,2.677945,1.9970245),(16860,'umzc_hippo_tibia-cleaned.tif',250,8,65,2129.5178773,124.4768641,118.0249567,1.8,123.5557994,119.6368869,0.8540779,114.1206589,81.6341915,1595284.0413818,1961862.1912111,201.7589513,24032.3589187,13978.9242035,30956.1628186,0.4707032,0.6656748,2.3561945,1.3313497),(16861,'umzc_hippo_tibia-cleaned.tif',250,8,66,2104.6721604,124.2556792,117.6763791,1.8,123.314602,119.4495938,0.9538889,115.4151183,61.640274,1529854.8681833,1919393.031837,233.3799692,31138.6193758,13255.2380503,29882.5491419,0.4707032,0.6656748,2.3561945,1.3313497),(16862,'umzc_hippo_tibia-cleaned.tif',250,8,67,2086.1735792,124.0236805,117.195581,1.8,123.0873093,119.2738781,1.0363114,115.1296833,71.7145862,1463354.2861675,1898513.6804053,257.4733226,26473.1874208,12710.4865091,29177.557573,97.3936897,110.2541233,2.3954492,709.3316848),(16863,'umzc_hippo_tibia-cleaned.tif',250,8,68,2066.8077522,123.8762987,116.8588472,1.8,122.8329633,119.2215032,1.0934242,112.811079,70.9123205,1401724.224219,1866720.7904499,271.7537234,26324.3506573,12425.4127982,28739.9015248,95.6818413,108.5560366,2.3868597,656.1723132),(16864,'umzc_hippo_tibia-cleaned.tif',250,8,69,2039.448721,123.736047,116.6160047,1.8,122.6573181,118.9946012,1.1288876,111.4019354,70.7351576,1336340.276997,1832188.2955945,277.7395798,25902.0882609,11995.6648188,28057.9505918,95.2569166,107.6552856,1.3279386,626.4649643),(16865,'umzc_hippo_tibia-cleaned.tif',250,8,70,2017.4270417,123.6375223,116.4621028,1.8,122.463217,118.7586433,1.1541196,112.8891167,67.8240034,1283611.5575476,1796098.2454212,281.1615764,26481.7491834,11370.5518769,26872.9380508,0.8424969,1.6971445,0.9827937,3.6041058),(16866,'umzc_hippo_tibia-cleaned.tif',250,8,71,2000.8773298,123.5313434,116.4096073,1.8,122.4248291,118.6274102,1.1830746,113.1220492,66.238812,1236158.564732,1764727.7366704,285.8103874,26641.8989688,10927.6535678,26079.1871861,91.8653857,106.7261764,1.3889704,690.1494428),(16867,'umzc_hippo_tibia-cleaned.tif',250,8,72,1976.1321213,123.5039268,116.4630679,1.8,122.273816,118.4609997,1.2070152,112.5672626,66.8445677,1193787.4070834,1725194.5455115,287.6585688,25809.0463499,10605.1029342,25435.4366367,0.4707032,0.6656748,2.3561945,1.3313497),(16868,'umzc_hippo_tibia-cleaned.tif',250,8,73,1950.715514,123.5326917,116.6920097,1.8,122.2598423,118.5919906,1.2314984,112.3492997,71.9033652,1146270.5115329,1679315.1547548,289.1049171,23355.1677415,10202.7383751,24493.2660252,90.2315336,106.7261764,1.3889704,724.6307274),(16869,'umzc_hippo_tibia-cleaned.tif',250,8,74,1922.1255402,123.3834327,116.7549515,1.8,122.0572746,118.6768372,1.2564532,111.8332297,67.679144,1094493.3708308,1634931.3788194,289.7284801,24157.0930283,9786.835036,23699.6138306,0.4707032,0.6656748,2.3561945,1.3313497),(16870,'umzc_hippo_tibia-cleaned.tif',250,8,75,1899.1191203,123.2468258,116.7372127,1.8,121.7706024,118.5946153,1.2713239,101.2652867,75.591243,1050486.2351492,1598868.9485785,288.9716444,21151.5102187,10373.6064861,24671.5182464,0.4707032,0.6656748,2.3561945,1.3313497),(16871,'umzc_hippo_tibia-cleaned.tif',250,8,76,1881.7678926,123.1370074,116.7554511,1.8,121.6315225,118.5432563,1.2835843,110.5641209,54.0446433,1015447.4519517,1564481.3700374,288.4601361,28947.9451655,9184.2402756,22423.5626991,86.5165675,105.714531,1.418824,564.7497979),(16872,'umzc_hippo_tibia-cleaned.tif',250,8,77,1861.6287484,122.9894987,116.861846,1.8,121.4268359,118.5570083,1.290449,110.7277168,59.0447958,987622.8202815,1520322.2997681,286.5179478,25748.6248875,8919.3821452,21711.1250689,0.6656748,1.3313497,2.3561945,2.6626994),(16873,'umzc_hippo_tibia-cleaned.tif',250,8,78,1842.2177362,122.7840366,116.7543126,1.8,121.2837236,118.4689638,1.3026155,110.3293834,64.7200765,957601.4619877,1484652.3664326,285.4782471,22939.5953753,8679.4780583,20983.4350067,84.1888576,104.1520574,1.3521274,610.3941518),(16874,'umzc_hippo_tibia-cleaned.tif',250,8,79,1823.3831199,122.544928,116.6259434,1.8,121.0312952,118.2978484,1.3123816,110.5373383,63.1463714,932250.6734156,1451949.7883942,284.0511704,22993.4001997,8433.8078639,20717.6942066,0.4707032,0.6656748,2.3561945,1.3313497),(16875,'umzc_hippo_tibia-cleaned.tif',250,8,80,1814.7299307,122.3832564,116.6923438,1.8,120.9621598,118.1240386,1.3193992,111.0685053,76.2643797,909435.3195154,1426795.7510927,283.7389707,18708.5472542,8188.0576057,20056.7680565,82.8755868,102.6888409,1.4003726,633.0940003),(16876,'umzc_hippo_tibia-cleaned.tif',250,8,81,1802.304286,122.2588585,116.8347643,1.8,121.073586,118.2281546,1.3310221,108.9788334,63.6704757,877481.1995162,1402409.9852668,283.442852,22026.0642013,8051.8498158,19813.2763932,0.4707032,0.6656748,2.3561945,1.3313497),(16877,'umzc_hippo_tibia-cleaned.tif',250,8,82,1783.9401188,121.9731669,116.8876346,1.8,120.7136487,118.3366319,1.3432488,44.3454627,61.0297568,838561.2709154,1380217.1015146,282.192421,22615.4776463,18909.7422967,33488.2794161,0.4707032,0.6656748,2.3561945,1.3313497),(16878,'umzc_hippo_tibia-cleaned.tif',250,8,83,1768.7775168,121.7205771,116.9700237,1.8,120.4768693,118.248611,1.3543624,105.110845,54.3710088,805829.6311737,1361493.4257999,281.2011733,25040.7975843,7666.4746775,19074.2557854,80.6465268,101.2668457,1.3743123,615.9756865),(16879,'umzc_hippo_tibia-cleaned.tif',250,8,84,1755.1759842,121.5093222,117.0740482,1.8,120.3078622,118.2805656,1.3630803,109.1515856,67.3845211,781029.5184132,1341884.5324716,280.0883228,19913.8394087,7155.4573747,18319.6799813,79.532831,100.5257182,1.415655,544.3700136),(16880,'umzc_hippo_tibia-cleaned.tif',250,8,85,1744.7768896,121.3225865,117.180708,1.8,120.1142698,118.3255718,1.3656763,104.1267487,56.6626142,755833.913253,1320414.6375678,278.7317301,23303.1012689,7258.7872223,18325.2370193,78.5010612,99.6702212,1.4095296,549.4196808),(16881,'umzc_hippo_tibia-cleaned.tif',250,8,86,1730.6273613,121.2140171,117.3927301,1.8,120.0020252,118.2870298,1.3638047,107.7596197,53.0385262,734916.6176836,1291500.3812261,276.2550795,24350.2313301,6819.962985,17852.2439359,77.4557508,98.9798283,1.3939203,597.6909049),(16882,'umzc_hippo_tibia-cleaned.tif',250,8,87,1719.1418762,121.1309121,117.5381785,1.8,119.9273938,118.3442437,1.3647056,110.5713776,68.8617921,715844.3954393,1268736.7337906,274.5253058,18424.3931951,6474.0479038,16890.7013867,77.4236175,98.4535123,1.4268709,620.103543),(16883,'umzc_hippo_tibia-cleaned.tif',250,8,88,1715.6181739,121.0320038,117.6618899,1.8,119.9281275,118.3792427,1.3639563,45.4181589,52.8053301,699755.7373483,1250078.7023195,273.8766377,23673.3431903,15406.9595721,36313.0290959,76.2283048,97.9707393,1.3969591,594.7328784),(16884,'umzc_hippo_tibia-cleaned.tif',250,8,89,1716.3500657,121.0289511,118.0338939,1.8,120.1046762,118.5423743,1.3596895,107.5210321,53.7508205,686555.5192631,1224331.6900653,273.4980783,22777.9163034,6385.3136982,16461.3109285,76.1280369,97.8123057,1.4064388,606.5061977),(16885,'umzc_hippo_tibia-cleaned.tif',250,8,90,1707.4867959,120.9007271,118.3042382,1.8,119.9468384,118.6925751,1.3585645,111.0649557,68.7751327,668244.5633102,1201784.3714402,271.9542032,17474.1119888,6016.7004014,15878.0936599,0.8424969,2.1050487,2.0344439,4.5455122),(16886,'umzc_hippo_tibia-cleaned.tif',250,8,91,1700.5456065,120.7526353,118.4548814,1.8,119.7437161,118.8715953,1.3596301,105.1205636,52.921326,651006.4961433,1181839.7782523,270.9727574,22332.0137078,6192.9509671,16045.5114103,74.9378237,96.8070676,1.4096444,602.9298044),(16887,'umzc_hippo_tibia-cleaned.tif',250,8,92,1693.082136,120.5801051,118.6766987,1.8,119.6625324,119.0587936,1.3589946,111.079598,53.0951671,638549.636893,1159203.4480596,269.7098871,21832.5605187,5748.5771303,15233.1464343,0.4707032,0.6656748,2.3561945,1.3313497),(16888,'umzc_hippo_tibia-cleaned.tif',250,8,93,1682.8809026,120.4334787,118.8519914,1.8,119.5204158,119.1875171,1.3570217,108.6743674,59.0351591,623640.9262834,1136138.658059,267.8563685,19245.1189318,5738.6202585,15251.0619535,0.4707032,0.6656748,2.3561945,1.3313497),(16889,'umzc_hippo_tibia-cleaned.tif',250,8,94,1674.8775603,120.3416183,118.990543,1.8,119.5707278,119.2339383,1.3543888,112.113642,52.9412761,610284.4040497,1117235.5489661,266.2759992,21103.2984502,5443.4446442,14596.9527925,73.3292853,95.5469521,1.4721081,597.1394418),(16890,'umzc_hippo_tibia-cleaned.tif',250,8,95,1668.0053908,120.1890983,119.1689807,1.8,119.4199206,119.2757757,1.3520449,109.0199846,65.5931188,599540.1205119,1097303.0618824,264.908757,16728.9356305,5499.3597985,14794.0844462,71.8292868,94.0523413,1.4805895,575.4479035),(16891,'umzc_hippo_tibia-cleaned.tif',250,8,96,1660.3865586,120.0791705,119.3423953,1.8,119.3906851,119.3765948,1.3462469,110.3931493,64.9282137,588258.1379437,1078700.7665241,263.0105557,16613.744692,5328.7558299,14378.9832739,0.8424969,1.6971445,2.1587989,3.6041058),(16892,'umzc_hippo_tibia-cleaned.tif',250,8,97,1647.7233058,120.1195797,119.5307303,1.8,119.635775,119.2462961,1.3363851,68.4952565,69.1043497,572940.0226909,1052537.8902759,259.8048755,15231.1380628,8364.6671659,20590.5426542,0.4707032,0.6656748,2.3561945,1.3313497),(16893,'umzc_hippo_tibia-cleaned.tif',250,8,98,1629.1566447,120.0162693,119.8095009,1.8,119.5254974,119.2984018,1.3264758,110.3294485,52.3068125,557201.9974817,1021845.6826819,255.6379479,19535.6136828,5050.3469827,13403.8296002,70.6416782,94.0959121,1.4756075,571.9384138),(16894,'umzc_hippo_tibia-cleaned.tif',250,8,99,1617.6187906,119.8978141,120.0059175,1.8,119.4320651,119.4316436,1.3183165,114.4438585,52.2561359,542777.6515181,999262.593465,252.7790562,19122.3973402,4742.7416237,12850.8206366,70.7447478,93.1148011,1.4796788,562.4574462),(16895,'umzc_hippo_tibia-cleaned.tif',250,8,100,1606.6239638,119.7709816,120.2269414,1.8,119.2747158,119.5796205,1.3118786,62.5658844,52.2374431,527457.0662444,980081.6168141,250.2172776,18762.0518651,8430.426118,19402.6149408,69.7522089,92.4305764,1.5096482,554.165904),(16896,'umzc_hippo_tibia-cleaned.tif',250,8,101,1599.4847118,119.6668218,120.3731763,1.8,119.1306271,119.6533972,1.3064835,113.5247105,52.0713768,515912.0751474,965470.4465589,248.3867466,18541.289001,4544.4914411,12377.4242243,68.6662335,91.3940291,1.5295826,496.0433646),(16897,'umzc_hippo_tibia-cleaned.tif',250,8,102,1593.3020688,119.6117554,120.4824301,1.8,119.157596,119.7000368,1.2976341,114.8993484,52.1758969,504621.638555,951250.7248418,246.2235474,18231.6123178,4391.8581406,12008.9370594,68.1943172,91.3940291,1.5295826,518.1721543),(16898,'umzc_hippo_tibia-cleaned.tif',250,8,103,1589.1365092,119.5556638,120.5496427,1.8,119.0671556,119.7733663,1.289644,40.93688,52.1225091,494450.4917412,939730.2971874,244.4659352,18029.2605376,12078.3628868,26686.0848891,68.1972077,91.3758455,1.5347295,531.7694996),(16899,'umzc_hippo_tibia-cleaned.tif',250,8,104,1584.0013826,119.5318594,120.600248,1.8,119.1003104,119.7739438,1.2813026,114.4067777,51.9187875,484531.4062382,928718.6254839,242.4864309,17887.9105414,4235.1634743,11731.2503891,67.8638643,90.8652261,1.5500739,540.3955601),(16900,'umzc_hippo_tibia-cleaned.tif',250,8,105,1578.8027417,119.647642,120.6818159,1.8,119.3463487,119.5735796,1.2738494,57.9716721,51.7500915,472837.4603963,915222.8687388,240.6053008,17685.4348085,8156.3536663,22974.0425953,67.2343063,91.5212135,1.503886,587.7253779),(16901,'umzc_hippo_tibia-cleaned.tif',250,8,106,1568.5716311,119.6291359,120.7719996,1.8,119.2512394,119.6493885,1.2630103,63.3543479,63.6677725,459163.0103089,900874.6837328,237.435085,14149.6183781,7247.5374673,17166.4973194,66.8755653,91.7086394,1.6633149,571.5484705),(16902,'umzc_hippo_tibia-cleaned.tif',250,8,107,1562.6464695,119.6200396,120.8427729,1.8,119.2703429,119.7475675,1.2553034,113.3423091,51.4839792,448676.5460196,889115.2744263,235.3665936,17269.7466011,3958.5971887,11600.0943926,66.5749213,90.1123132,1.6387543,532.3878663),(16903,'umzc_hippo_tibia-cleaned.tif',250,8,108,1560.1248299,119.5776481,121.0061404,1.8,119.2844253,119.8764146,1.249289,114.750484,56.9730814,439874.928798,878592.6413377,234.0566144,15421.1887355,3833.3165454,11211.524728,65.6983371,89.6427022,1.6391109,524.8762108),(16904,'umzc_hippo_tibia-cleaned.tif',250,8,109,1552.9743655,119.5893131,121.0637285,1.8,119.2977441,119.9578541,1.2421208,62.1760443,51.3518032,427703.1243087,870210.0317912,231.860789,16946.0462474,6878.905357,16304.40103,0.9414064,1.3313497,2.3561945,2.6626994),(16905,'umzc_hippo_tibia-cleaned.tif',250,8,110,1552.3791705,119.5173964,121.0829975,1.8,119.1981829,119.9868636,1.23604,61.7937889,51.2572742,418719.3273331,864669.0889061,230.8030715,16869.1976545,6776.0746638,16109.5942802,0.8424969,1.6971445,0.9827937,3.6041058),(16906,'umzc_hippo_tibia-cleaned.tif',250,8,111,1551.081558,119.486532,121.0808749,1.8,119.222938,119.9521512,1.2282712,60.573862,51.1586589,410013.9065953,858482.0432245,229.3515771,16780.7769298,6768.8255824,16277.6613773,0.4707032,0.6656748,2.3561945,1.3313497),(16907,'umzc_hippo_tibia-cleaned.tif',250,8,112,1546.9507098,119.4640438,121.1591078,1.8,119.1698299,120.0777599,1.2212016,63.2084855,51.1254697,401250.8060962,850327.6796403,227.5775686,16632.1734493,6348.0528415,15422.1001935,0.6656748,1.3313497,2.3561945,2.6626994),(16908,'umzc_hippo_tibia-cleaned.tif',250,8,113,1549.3168534,119.5345284,121.2054411,1.8,119.3989381,119.9151801,1.2169144,112.5919275,51.2949975,393979.8153509,845098.0735825,227.2095438,16475.2532279,3499.1835027,10745.5569495,0.4707032,1.0525243,2.0344439,2.2727561),(16909,'umzc_hippo_tibia-cleaned.tif',250,8,114,1546.2660173,119.496053,121.2560633,1.8,119.4197432,119.8771465,1.2126911,116.3333495,51.4344992,385906.6902478,837747.378503,226.0510496,16287.6550081,3317.2490264,10357.4394244,0.8424969,1.6971445,2.1587989,3.6041058),(16910,'umzc_hippo_tibia-cleaned.tif',250,8,115,1541.4457767,119.4482585,121.3041726,1.8,119.4161871,119.9191812,1.2057735,118.5119441,51.946396,379328.6714799,831945.3325402,224.17035,16015.4581762,3200.7632178,9953.7580635,61.5836696,88.1723964,1.7859911,501.9479389),(16911,'umzc_hippo_tibia-cleaned.tif',250,8,116,1540.1110359,119.3591288,121.3351144,1.8,119.2799775,119.9490769,1.2003758,60.2004308,52.2750097,370796.3727194,828562.4043053,223.0466957,15850.0669674,6159.3641107,15042.8775307,0.4707032,1.0525243,2.0344439,2.2727561),(16912,'umzc_hippo_tibia-cleaned.tif',250,8,117,1541.030718,119.2724864,121.3803143,1.8,119.1709116,119.9902067,1.196662,116.7138637,53.9266035,364507.2477051,825381.3940437,222.533522,15305.6439898,3123.0844054,9917.7716007,0.4707032,0.6656748,2.3561945,1.3313497),(16913,'umzc_hippo_tibia-cleaned.tif',250,8,118,1536.9771477,119.2240933,121.4626041,1.8,119.1076486,120.0986826,1.1921199,117.4941647,51.5794123,357483.2378376,820616.8279878,221.1526659,15909.7746736,3042.5616341,9875.500915,60.3244065,87.4203685,1.7713598,565.3174945),(16914,'umzc_hippo_tibia-cleaned.tif',250,8,119,1538.5161952,119.13385,121.5555179,1.8,119.0312348,120.2558442,1.1873183,114.6623439,51.4782828,352719.5819059,817272.6337405,220.5239925,15876.0663707,3076.1588311,9988.9984374,3.2949224,9.8285713,1.2793395,38.4753337),(16915,'umzc_hippo_tibia-cleaned.tif',250,8,120,1539.0451903,119.0850904,121.6604478,1.8,119.1537083,120.4405287,1.1829423,117.4040569,56.0223622,349060.3678968,813744.2027852,219.8173419,14525.3461471,2973.1542251,9670.0163782,59.3779882,86.8252846,1.5002614,537.4733628),(16916,'umzc_hippo_tibia-cleaned.tif',250,8,121,1541.0989992,119.0766329,121.7864343,1.8,119.0918413,120.3348233,1.17629,73.7070183,89.9675556,342841.1844361,807502.5809096,218.9061738,8975.4864988,4651.4048764,9890.7388294,0.4707032,0.6656748,2.3561945,1.3313497),(16917,'umzc_hippo_tibia-cleaned.tif',250,8,122,1537.1382834,119.0235457,121.8616008,1.8,119.0724214,120.307418,1.1710619,32.4970428,51.1715748,336667.6852482,799611.2102295,217.3881545,15626.0817406,10359.9483715,21410.5805394,59.4208669,87.5153583,1.7766305,467.3524425),(16918,'umzc_hippo_tibia-cleaned.tif',250,8,123,1535.6336787,119.0018988,121.9897551,1.8,119.0501575,120.4298429,1.1654329,120.5186157,65.0386004,332564.4039576,789514.2445354,216.1367948,12139.1641182,2759.4442738,9164.223324,0.4707032,0.6656748,2.3561945,1.3313497),(16919,'umzc_hippo_tibia-cleaned.tif',250,8,124,1535.2886468,118.9039286,122.1018213,1.8,119.0154091,120.6450109,1.1619847,115.5438976,50.6052928,328766.3857418,783328.2094851,215.4466348,15479.1755239,2845.3807828,9431.6650714,0.4707032,0.6656748,2.3561945,1.3313497),(16920,'umzc_hippo_tibia-cleaned.tif',250,8,125,1534.2868527,118.8439489,122.2741977,1.8,118.9350002,120.8304311,1.1555305,115.6649202,50.4071499,324878.4868326,773870.5727989,214.0947728,15352.396925,2808.7901359,9267.3277434,59.046628,89.0736623,1.724651,529.6109552),(16921,'umzc_hippo_tibia-cleaned.tif',250,8,126,1531.5265308,118.7717274,122.4403237,1.8,118.8505312,121.0995328,1.1476374,31.5622291,58.6857562,321107.4298489,764764.4350237,212.2114512,13031.5170837,10173.7880727,17830.2194259,0.4707032,0.6656748,2.3561945,1.3313497),(16922,'umzc_hippo_tibia-cleaned.tif',250,8,127,1534.8614358,118.6912992,122.5882536,1.8,118.8096965,121.3193367,1.1417082,31.4660805,49.5783481,318812.6348952,759400.534681,211.5318005,15317.1810564,10131.9462171,20893.6461464,0.4707032,0.6656748,2.3561945,1.3313497),(16923,'umzc_hippo_tibia-cleaned.tif',250,8,128,1531.4461644,118.6090318,122.7251649,1.8,118.8242079,121.4763068,1.1357181,31.8769194,49.154316,315691.8883866,752094.1298547,209.8983091,15300.6732813,9903.4628834,20829.7386958,57.5016094,87.2529353,1.788295,582.8926553),(16924,'umzc_hippo_tibia-cleaned.tif',250,8,129,1536.122457,118.5877228,122.8873982,1.8,118.7698948,121.486894,1.1336972,33.1996673,53.4593557,313095.4516665,746657.7535828,210.1430382,13966.8303728,9430.6803972,18161.6262756,0.4707032,0.6656748,2.3561945,1.3313497),(16925,'umzc_hippo_tibia-cleaned.tif',250,8,130,1530.968397,118.5488403,123.0059958,1.8,118.7836877,121.5231887,1.1284812,41.726244,49.029393,308564.044921,738022.9580041,208.4126718,15052.6635855,7394.963342,20382.9735439,57.8972395,84.7121918,1.8063413,508.167436),(16926,'umzc_hippo_tibia-cleaned.tif',250,8,131,1528.0769509,118.5158575,123.1275672,1.8,118.7984526,121.5811201,1.1249966,31.8590834,48.8749088,305155.9039557,732621.6387804,207.3304869,14989.7290306,9578.3014227,20302.7210369,0.4707032,0.6656748,2.3561945,1.3313497),(16927,'umzc_hippo_tibia-cleaned.tif',250,8,132,1529.856762,118.4447504,123.2492965,1.8,118.7318072,121.7031909,1.1221642,120.5199593,48.6937154,302215.0759595,729294.5331373,207.0087711,14977.1798446,2507.5935787,8488.3710177,56.9878426,85.9648898,1.819759,460.7625978),(16928,'umzc_hippo_tibia-cleaned.tif',250,8,133,1529.3232685,118.3851177,123.4385366,1.8,118.7044568,122.0288239,1.1180504,32.2105465,48.3806801,299011.2187752,722216.8007969,206.1143373,14927.7934637,9283.0222064,19674.9328305,56.914513,86.2325175,1.7853208,573.5340162),(16929,'umzc_hippo_tibia-cleaned.tif',250,8,134,1527.9395156,118.3161155,123.6402679,1.8,118.5767974,122.2729945,1.1119858,30.6835478,48.2147745,296389.1998269,715269.0342985,204.7070769,14835.0591976,9659.5479098,20014.4117986,0.4707032,0.6656748,2.3561945,1.3313497),(16930,'umzc_hippo_tibia-cleaned.tif',250,8,135,1525.4244557,118.2833431,123.8138701,1.8,118.5058779,122.4370419,1.1067038,116.2958345,48.0667905,293364.9463862,709559.6785502,203.2993631,14761.9524928,2522.5748416,8623.3784083,0.4707032,1.4884942,1.8925469,3.2141625),(16931,'umzc_hippo_tibia-cleaned.tif',250,8,136,1524.497791,118.2296698,124.0149815,1.8,118.4900312,122.6650808,1.0998636,30.4188753,47.5041171,291132.7734992,701293.4147824,201.7774626,14762.7923219,9570.7934898,19914.8844559,57.4154486,84.2926791,1.7846198,519.7204486),(16932,'umzc_hippo_tibia-cleaned.tif',250,8,137,1524.4298455,118.2867108,124.2603474,1.8,118.556176,122.7079804,1.0935614,37.4726708,47.0453761,288235.7712006,692848.1823575,200.4677405,14727.2323081,7691.8929293,19801.749422,56.620798,83.9133246,1.7626914,492.7900108),(16933,'umzc_hippo_tibia-cleaned.tif',250,8,138,1524.6824928,118.2509291,124.4675682,1.8,118.5560514,122.8797083,1.0875365,37.1255567,46.6985653,285776.600048,685973.8384674,199.2463405,14689.3985793,7697.5707775,19747.5189969,56.6119877,84.2019478,1.7506498,503.1650768),(16934,'umzc_hippo_tibia-cleaned.tif',250,8,139,1520.1274548,118.2465679,124.7236836,1.8,118.5623673,123.0536121,1.0825211,123.6491855,46.4633473,283932.8315086,677142.1653293,197.6018421,14573.6845129,2296.2774102,7721.4571079,0.4707032,0.6656748,2.3561945,1.3313497),(16935,'umzc_hippo_tibia-cleaned.tif',250,8,140,1519.5228602,118.2037374,124.948004,1.8,118.4781486,123.2720842,1.076878,33.109532,46.3123425,280918.9319162,671559.292617,196.3346157,14500.6548189,8484.5334585,19511.2944739,0.4707032,0.6656748,2.3561945,1.3313497),(16936,'umzc_hippo_tibia-cleaned.tif',250,8,141,1516.0121159,118.2015349,125.1868831,1.8,118.4451423,123.4518572,1.0684926,120.1830318,46.0237626,278408.9652092,662838.1185934,194.1025041,14402.0845056,2316.5413714,7806.4815242,55.6816049,82.3501937,1.7547398,461.7317166),(16937,'umzc_hippo_tibia-cleaned.tif',250,8,142,1514.9459346,118.1726611,125.4351378,1.8,118.4066581,123.7993827,1.0610737,30.3956575,60.4789768,275862.6392171,654422.7819872,192.3777042,10820.6655754,9075.7253399,15213.2595631,55.8586787,80.1025658,1.9818609,483.4313717),(16938,'umzc_hippo_tibia-cleaned.tif',250,8,143,1514.2524467,118.1697104,125.7453513,1.8,118.3468157,124.1771956,1.051743,32.5922442,53.5855797,274270.8107683,644572.6333,190.2723435,12028.845019,8415.2171097,16642.7606455,54.7818974,78.7819923,1.7998343,439.4887151),(16939,'umzc_hippo_tibia-cleaned.tif',250,8,144,1507.7551863,118.1959147,126.0917215,1.8,118.390304,124.531525,1.0405542,63.5538042,96.2514039,271722.3727607,631729.5529337,187.0180777,6563.3281937,4275.4698384,7832.9150537,55.1550883,78.6201166,1.9190558,435.2858382),(16940,'umzc_hippo_tibia-cleaned.tif',250,8,145,1510.4232579,118.3133883,126.4327629,1.8,118.5635554,124.736334,1.0311353,35.3615067,43.932583,270004.0725,620355.2104378,185.2692316,14120.6177145,7635.5364265,19113.4094883,0.4707032,0.6656748,2.3561945,1.3313497),(16941,'umzc_hippo_tibia-cleaned.tif',250,8,146,1505.4268423,118.3427941,126.789004,1.8,118.4553552,125.1435137,1.0188371,31.2500688,43.2601473,267177.1591264,606117.4489931,181.9182991,14010.9890088,8549.650272,19024.4163387,54.0688635,80.2531697,1.8684328,500.5023774),(16942,'umzc_hippo_tibia-cleaned.tif',250,8,147,1500.9104769,118.3944568,127.127779,1.8,118.5644221,125.4759223,1.0077672,31.3182489,67.6518171,264991.9326704,593420.8471065,178.8861526,8771.6911711,8461.2627465,11938.4509128,54.2066788,78.3236543,1.8011988,439.7367342),(16943,'umzc_hippo_tibia-cleaned.tif',250,8,148,1495.5276713,118.4447945,127.4437762,1.8,118.6010178,125.7770381,0.9959393,50.8445721,42.1780082,262902.2027029,581310.0951087,175.5684702,13782.3031404,5170.7034207,14367.167777,54.8350534,78.4437859,1.8944444,398.1810455),(16944,'umzc_hippo_tibia-cleaned.tif',250,8,149,1491.602741,118.4924004,127.7798794,1.8,118.6557064,126.1922941,0.9841939,34.2829991,49.2374836,260702.5070578,569207.5823622,172.4290723,11560.452339,7604.4253464,16840.5815145,53.8488031,77.1091721,1.8809644,407.9654571),(16945,'umzc_hippo_tibia-cleaned.tif',250,8,150,1486.5085026,118.5337533,128.0946074,1.8,118.6842603,126.5926396,0.9733746,35.4622886,48.6641117,257884.5447116,558714.965712,169.3577381,11481.0472457,7272.0784501,16751.9323624,53.8783657,75.5196304,1.8550891,423.0279594),(16946,'umzc_hippo_tibia-cleaned.tif',250,8,151,1483.8204232,118.5925284,128.4250687,1.8,118.7508632,126.9254365,0.9593703,122.2561786,40.480105,256668.8064027,548348.1339153,165.8126796,13546.1144214,2099.4342321,6583.6539917,52.6132969,75.6442153,1.920099,354.8256811),(16947,'umzc_hippo_tibia-cleaned.tif',250,8,152,1481.9506447,118.6383322,128.7286696,1.8,118.7642253,127.2822064,0.947344,36.001357,39.9315389,255214.2816436,539351.0870374,162.7994149,13506.8945981,7089.0183774,15888.9916647,52.5773628,74.6521026,1.9384229,469.5191036),(16948,'umzc_hippo_tibia-cleaned.tif',250,8,153,1481.3230882,118.7965455,129.049703,1.8,119.0064706,127.4599969,0.936305,126.7068961,39.5454983,254334.8566226,530229.5793913,160.137427,13408.0894743,2007.2692521,6191.7948718,54.1338696,74.2831688,1.906574,405.9015288),(16949,'umzc_hippo_tibia-cleaned.tif',250,8,154,1477.7486282,118.839111,129.3295745,1.8,119.0371187,127.7326919,0.9246484,122.993175,38.9799271,252075.6342164,520871.8289464,157.0001796,13362.5655133,2049.5091224,6282.3487808,53.558644,73.6044958,1.9370519,486.8935533),(16950,'umzc_hippo_tibia-cleaned.tif',250,8,155,1475.2194689,118.892269,129.6184695,1.8,119.1002536,128.0344737,0.9140592,31.0256598,38.720182,250246.8501298,512366.1069351,154.2208386,13232.533531,8065.8026831,18514.4450024,4.2890448,33.58196,1.4725224,99.9343641),(16951,'umzc_hippo_tibia-cleaned.tif',250,8,156,1470.0175381,118.9334442,129.9105999,1.8,119.175488,128.3683131,0.9001461,126.3481276,38.7261044,248723.1713938,503719.7980779,150.3688621,13007.2416585,1968.5544695,5954.3270897,0.4707032,0.6656748,2.3561945,1.3313497),(16952,'umzc_hippo_tibia-cleaned.tif',250,8,157,1470.184045,118.9680878,130.1946277,1.8,119.1562635,128.7234785,0.8894953,30.280302,37.6926863,247488.6184755,497896.7864783,147.8384012,13209.3738847,8173.2546258,18484.2670023,52.8290951,71.7648735,1.9610466,474.2734437),(16953,'umzc_hippo_tibia-cleaned.tif',250,8,158,1468.7188514,119.021088,130.4629107,1.8,119.1610237,128.987693,0.8770137,73.6719938,37.6365061,246714.8615812,491463.2696764,144.6941425,13058.1533937,3348.8283524,9983.6457699,53.5863396,69.1180806,1.8537732,377.2106068),(16954,'umzc_hippo_tibia-cleaned.tif',250,8,159,1468.5881301,119.066408,130.7644763,1.8,119.201219,129.3588482,0.8643904,117.4432082,37.2122893,246349.1568368,485463.7535922,141.6364711,13045.7911273,2097.602413,6227.9395634,2.3162691,2.7446477,2.1112158,8.4253495),(16955,'umzc_hippo_tibia-cleaned.tif',250,8,160,1468.6862886,119.116535,131.0484754,1.8,119.2409575,129.674838,0.8527386,32.5753835,36.6600693,245217.6007712,479310.7995915,138.8243395,13074.4651869,7527.6965045,18132.0210536,53.245984,70.2972809,1.9264322,404.8932188),(16956,'umzc_hippo_tibia-cleaned.tif',250,8,161,1469.278328,119.2590367,131.3510843,1.8,119.5066605,129.8329989,0.8391939,32.0817718,36.9144026,244933.8392739,472784.276851,135.5878884,12807.5830459,7634.673082,18221.944265,53.6158991,70.8013343,1.9451299,422.4569007),(16957,'umzc_hippo_tibia-cleaned.tif',250,8,162,1468.4890316,119.2823935,131.6125664,1.8,119.5072555,130.1082592,0.8274447,30.4551595,36.4529525,244158.6634245,468458.7098235,132.6527185,12851.0498645,8016.9884965,17989.6807264,53.6033097,70.9779219,2.0018146,464.945879),(16958,'umzc_hippo_tibia-cleaned.tif',250,8,163,1468.4131635,119.3438915,131.8573931,1.8,119.6023003,130.3601418,0.817002,29.1441941,36.2529335,243765.5671129,463610.4446663,130.0971452,12788.218779,8364.1210334,18203.3146128,53.326241,70.9404533,2.0314766,436.7787077),(16959,'umzc_hippo_tibia-cleaned.tif',250,8,164,1463.8009895,119.4040269,132.1268935,1.8,119.6431939,130.6712561,0.8027448,72.0534353,35.9055989,242744.5497357,457138.9302838,126.2145055,12731.6893105,3368.9517884,9635.2808311,0.4707032,0.6656748,2.3561945,1.3313497),(16960,'umzc_hippo_tibia-cleaned.tif',250,8,165,1462.3688287,119.4617955,132.3870337,1.8,119.7097625,130.9515498,0.7888308,49.0177364,45.3359963,241709.541316,452647.8102753,122.7006406,9984.2916621,4931.0628996,12501.9784218,53.1217973,69.3021547,1.9979859,471.4019164),(16961,'umzc_hippo_tibia-cleaned.tif',250,8,166,1460.9550642,119.5175586,132.6344564,1.8,119.8224882,131.2131758,0.7740721,35.3481599,49.1002666,240710.5558398,447861.1465973,118.9886192,9121.3587571,6809.7054224,11381.2282792,0.6656748,1.3313497,2.3561945,2.6626994),(16962,'umzc_hippo_tibia-cleaned.tif',250,8,167,1461.6284772,119.5891317,132.8827511,1.8,119.8945811,131.4714319,0.7600577,123.8969855,50.0839287,240287.1102149,444000.5805262,115.6319132,8865.1308255,1939.410465,5484.726341,3.7570354,19.8199026,1.4994889,64.417057),(16963,'umzc_hippo_tibia-cleaned.tif',250,8,168,1458.5584391,119.6497476,133.1360184,1.8,119.8902365,131.8059168,0.7459233,45.6004592,36.5484224,239620.2104402,439911.0294695,111.9603691,12036.3890177,5254.7762584,13478.4639736,2.8307437,20.8442343,1.4576453,65.8626185),(16964,'umzc_hippo_tibia-cleaned.tif',250,8,169,1460.4098884,119.7731463,133.3930169,1.8,120.1184859,131.8945739,0.733963,39.4065832,36.7676004,239931.739818,436095.6144229,109.2034239,11860.8668916,6088.6207426,16044.0964076,53.4583723,68.2194936,2.0128424,463.3861059),(16965,'umzc_hippo_tibia-cleaned.tif',250,8,170,1457.3189026,119.8413901,133.6465916,1.8,120.2044683,132.1666391,0.7180087,35.1813067,38.5993298,238746.9325197,432014.9728989,105.1246947,11192.2920837,6786.1871761,17369.5200439,52.5739887,69.6656634,2.1100571,422.8664396),(16966,'umzc_hippo_tibia-cleaned.tif',250,8,171,1455.4086387,119.9037065,133.9051885,1.8,120.3317395,132.4104407,0.6982681,30.3977667,36.1484314,238191.4097873,427647.9558793,100.2558302,11830.3323017,7835.8193938,17472.9272529,54.5374758,68.9511905,2.0924827,425.985986),(16967,'umzc_hippo_tibia-cleaned.tif',250,8,172,1452.0875645,119.9732483,134.1652717,1.8,120.3553976,132.7162029,0.6801384,32.7591971,34.9636443,237298.0681133,425002.1130192,95.7205903,12155.5439094,7243.7083077,17456.1968936,53.0888656,68.8611591,2.0619599,381.0823273),(16968,'umzc_hippo_tibia-cleaned.tif',250,8,173,1450.7422828,120.0573822,134.4038874,1.8,120.452591,132.9979635,0.6629907,124.9932701,38.1169085,237025.6073716,422859.5995551,91.592957,11093.7538169,1896.3069548,5163.9145116,52.4377374,69.1869656,2.0983811,403.0773097),(16969,'umzc_hippo_tibia-cleaned.tif',250,8,174,1447.7297163,120.1318853,134.6614679,1.8,120.5399115,133.2394622,0.6408604,31.6456017,34.8460763,235942.6301214,419452.0227807,86.2525144,12037.2813005,7455.7795647,15045.4177269,0.4707032,1.4884942,2.8198421,2.9384309),(16970,'umzc_hippo_tibia-cleaned.tif',250,8,175,1443.8760215,120.2137235,134.9073203,1.8,120.616151,133.5635552,0.6228627,30.9886235,36.9468977,235418.1667521,418123.6079162,81.8946634,11316.8800041,7596.9223609,17168.1256728,51.8456127,67.8090393,2.062387,394.557344),(16971,'umzc_hippo_tibia-cleaned.tif',250,8,176,1444.0252063,120.2910514,135.1244196,1.8,120.6503345,133.7866504,0.6064726,123.3957742,37.7769276,235686.0430424,417724.4894542,78.1864187,11057.6618169,1910.0009262,5094.7297731,1.8828128,4.3396691,1.7894653,12.9708617),(16972,'umzc_hippo_tibia-cleaned.tif',250,8,177,1444.1722427,120.4075046,135.356995,1.8,120.7896413,133.8010085,0.590155,36.7522731,34.2973457,235817.010902,417290.0221618,74.5387163,12166.8313847,6416.3925321,14849.2024606,2.3898251,8.3408819,1.8568478,21.9476743),(16973,'umzc_hippo_tibia-cleaned.tif',250,8,178,1439.3434753,120.4798581,135.5699302,1.8,120.8924555,134.0845703,0.5738663,35.4022444,35.4357915,234165.1302844,416372.3675716,70.7009699,11750.0512784,6614.4148183,16408.7700764,4.1045432,27.8352397,1.5031033,89.0274307),(16974,'umzc_hippo_tibia-cleaned.tif',250,8,179,1437.4115253,120.5383642,135.7449143,1.8,120.9956643,134.2453776,0.5568234,122.1006649,42.5977985,233682.3420011,416839.6476568,66.9123973,9785.4739616,1913.8498727,5030.4056346,3.8908911,24.5894558,1.4749372,77.273707),(16975,'umzc_hippo_tibia-cleaned.tif',250,8,180,1434.4873149,120.5840135,135.9373927,1.8,120.9819951,134.5320939,0.543228,31.2512139,35.3073848,232032.4462293,417716.0990499,63.8795098,11830.8422268,7424.749857,17435.6345516,0.4707032,1.0525243,2.677945,1.9970245),(16976,'umzc_hippo_tibia-cleaned.tif',250,8,181,1432.7278472,120.6613725,136.1344489,1.8,121.0412333,134.7371584,0.5287515,114.6924839,56.3378525,232221.218528,419083.8409435,60.7656713,7438.7613755,2024.7291775,5269.7504205,0.4707032,1.0525243,2.677945,1.9970245),(16977,'umzc_hippo_tibia-cleaned.tif',250,8,182,1427.5337047,120.7333828,136.3845932,1.8,121.0593049,135.0511865,0.511822,119.319571,45.101895,231198.3787464,419482.6698699,57.0706734,9300.7770509,1937.6400436,5107.7494082,2.8242192,9.9851227,1.7126934,26.9973415),(16978,'umzc_hippo_tibia-cleaned.tif',250,8,183,1427.1178403,120.8411386,136.6190189,1.8,121.1456134,135.274377,0.4921576,119.3776171,47.9814543,230223.6644646,420297.6021429,53.108515,8759.5844797,1928.532919,5097.675742,2.353516,6.6567485,1.7126934,16.850699),(16979,'umzc_hippo_tibia-cleaned.tif',250,8,184,1421.0376527,120.9740185,136.8825863,1.8,121.2330395,135.5553246,0.4675625,117.5592686,46.0999292,229328.9752972,419541.7632843,48.1117998,9100.7029923,1950.7519747,5138.5511455,1.9767301,8.125597,1.7454685,23.9446988),(16980,'umzc_hippo_tibia-cleaned.tif',250,8,185,1415.7269553,121.1696937,137.2058396,1.8,121.5618422,135.6471408,0.4385947,43.8864945,35.0424031,228134.4127539,417687.0826595,42.5525979,11919.4759909,5198.2828707,13865.1541519,0.4707032,0.6656748,2.3561945,1.3313497),(16981,'umzc_hippo_tibia-cleaned.tif',250,8,186,1407.6220304,121.307606,137.5033519,1.8,121.7192304,136.1188076,0.4080091,108.2708997,60.518591,224790.3790987,415827.9848744,36.9351245,6871.0784283,2076.1846409,5164.7511086,3.1672333,15.245262,1.7257931,42.6782106),(16982,'umzc_hippo_tibia-cleaned.tif',250,8,187,1403.7719611,121.4354506,137.7729021,1.8,121.9053146,136.4809958,0.3817297,113.3981737,60.4933648,223167.5433992,415512.2459107,32.4682146,6868.7243205,1967.999449,4969.3163735,3.8505862,23.5774851,1.6307245,80.2121379),(16983,'umzc_hippo_tibia-cleaned.tif',250,8,188,1395.6575024,121.5722956,138.0448784,1.8,122.0202694,136.8915694,0.3544368,45.031946,34.0532933,220110.9367674,414791.7142512,28.018303,12180.6637257,4887.8841909,13795.3900036,3.7656256,22.2478851,1.6767807,67.2412762),(16984,'umzc_hippo_tibia-cleaned.tif',250,8,189,1392.3509976,121.714613,138.3154544,1.8,122.1827897,137.3272181,0.3254704,112.1765293,66.2187084,218747.746315,415250.1164376,23.7263173,6270.8881901,1950.0313274,4867.7903368,3.5771895,20.2894373,1.6404509,69.124089),(16985,'umzc_hippo_tibia-cleaned.tif',250,8,190,1388.8305179,121.8425906,138.577301,1.8,122.2707276,137.6318785,0.3000531,101.5381009,71.1426882,216447.6438928,416849.8413401,20.2218483,5859.3490302,2131.6889126,5108.0238438,49.9204946,69.0330813,2.9910169,413.6334911),(16986,'umzc_hippo_tibia-cleaned.tif',250,8,191,1388.5577957,121.9782408,138.7993282,1.8,122.4666193,137.9171013,0.2766287,102.2845022,73.5674008,216196.4603759,420471.809761,17.2623641,5715.46371,2113.677592,5074.2724624,3.1828991,21.228662,1.6373645,64.1886335),(16987,'umzc_hippo_tibia-cleaned.tif',250,8,192,1384.8356279,122.1076244,139.0123985,1.8,122.6144214,138.201483,0.2552255,97.6911874,75.4927831,214831.7446728,423288.8921086,14.7110532,5607.0113588,2199.090321,5168.582281,48.5925481,68.9174425,3.0663923,393.7970531),(16988,'umzc_hippo_tibia-cleaned.tif',250,8,193,1388.4222403,122.3329659,139.2515982,1.8,123.0804837,138.057733,0.2310224,44.2201115,36.9916441,215285.7894867,426078.8731583,12.1321408,11518.2464535,4868.5039935,13634.0848843,51.5144201,70.1774111,3.0205654,421.1370298),(16989,'umzc_hippo_tibia-cleaned.tif',250,8,194,1383.2299105,122.4415811,139.5158531,1.8,123.2535817,138.5300206,0.2101991,89.0252504,82.4999668,212366.0144135,427999.3099793,10.0368694,5187.8725105,2385.4582106,5275.9514237,50.2222544,70.7622068,0.0665682,394.2816125),(16990,'umzc_hippo_tibia-cleaned.tif',250,8,195,1380.2824698,122.5749093,139.7355865,1.8,123.3527604,138.8799883,0.1899521,38.1962059,38.3135918,210399.537032,431229.7741391,8.2011415,11255.2687969,5508.3883817,15727.7969906,0.4707032,0.6656748,2.3561945,1.3313497),(16991,'umzc_hippo_tibia-cleaned.tif',250,8,196,1378.2725704,122.715726,139.9591988,1.8,123.5409595,139.2110116,0.1708479,99.2325229,81.416706,208844.4993155,435280.2196299,6.6400638,5346.3255992,2104.5972954,5018.1895062,49.4162631,72.5142682,3.0244839,424.9776759),(16992,'umzc_hippo_tibia-cleaned.tif',250,8,197,1379.7336013,122.869116,140.1391563,1.8,123.8257782,139.5578907,0.1500298,98.6020428,85.8513935,208407.140447,442626.8878198,5.1373196,5155.7332936,2113.6188926,5047.6047083,49.4805277,73.4357332,0.0128198,412.1210259),(16993,'umzc_hippo_tibia-cleaned.tif',250,8,198,1376.7155294,123.0071574,140.3302035,1.8,123.8990032,139.8002188,0.1336594,46.5876699,40.3275675,207161.5035601,448548.7067528,4.0747643,11122.6323466,4446.7023979,11944.6971002,2.8242192,9.703795,1.815775,30.6014473),(16994,'umzc_hippo_tibia-cleaned.tif',250,8,199,1380.6209891,123.1759052,140.500245,1.8,124.1023813,140.0818991,0.1171948,44.187619,41.2302327,206950.0006874,457648.6374741,3.1459315,11099.8315532,4683.4386063,13564.3442798,2.8002164,5.6875284,1.9974238,18.9619353),(16995,'umzc_hippo_tibia-cleaned.tif',250,8,200,1380.5055085,123.3415911,140.66013,1.8,124.1919618,140.342038,0.1006263,63.0091901,41.6669287,206894.3069744,466475.7186286,2.3218872,11195.3468342,3283.5576306,10683.1324613,2.0546043,8.3408819,1.8568478,26.0559351),(16996,'umzc_hippo_tibia-cleaned.tif',250,8,201,1380.6215262,123.6073234,140.9014503,1.8,124.7784835,140.1552717,0.0834047,45.7963405,42.152795,207391.0597498,472962.3760199,1.5969615,11220.1901802,4528.5509168,14150.8208745,49.4348633,76.8919283,0.1289108,382.1852535),(16997,'umzc_hippo_tibia-cleaned.tif',250,8,202,1381.2868824,123.8314943,141.1120705,1.8,125.0972497,140.4834193,0.068571,90.2779331,86.238341,205542.4446697,481804.9491189,1.0807612,5586.8995598,2276.7739325,5505.4502222,2.353516,5.0696286,1.1902899,18.7335118),(16998,'umzc_hippo_tibia-cleaned.tif',250,8,203,1380.5955431,124.0378506,141.3117226,1.8,125.4783595,140.8271983,0.0531174,46.4264316,43.8810158,204366.9581252,493171.0443821,0.6486,11238.8247018,4401.9527468,13191.4235208,2.335655,11.8051761,1.6506263,35.0327477),(16999,'umzc_hippo_tibia-cleaned.tif',250,8,204,1385.8971094,124.24238,141.4910618,1.8,125.7168278,141.1807936,0.0385418,88.1196558,96.673167,203967.5978219,506629.6784007,0.342944,5240.6442647,2314.6663015,5599.9371235,2.2314911,14.0424263,1.8076451,41.0711294),(17000,'umzc_hippo_tibia-cleaned.tif',250,8,205,1381.8441434,124.4543172,141.6589492,1.8,125.8399877,141.454648,0.0250749,45.2849467,92.2783238,202845.1736713,516710.8501549,0.1447725,5599.4824027,4479.3068893,7506.3032152,1.4121096,6.2799639,1.7975952,16.4134477),(17001,'umzc_hippo_tibia-cleaned.tif',250,8,206,1380.3131527,124.6860466,141.8151138,1.8,126.0959546,141.7011903,0.0104164,50.7906062,96.6064708,203351.8461515,530433.4699912,0.0249599,5490.6619154,4003.7294551,7583.5522763,0.4707032,0.6656748,2.3561945,1.3313497),(17002,'umzc_hippo_tibia-cleaned.tif',250,8,207,1383.1053661,124.9543353,141.9389736,1.8,126.2461,141.8556932,-0.0024102,89.9372334,94.1396851,204675.0349471,551056.3042945,0.0013395,5853.6025871,2275.7541803,5804.6384523,0.4707032,1.4884942,2.8198421,2.9384309),(17003,'umzc_hippo_tibia-cleaned.tif',250,8,208,1388.6300383,125.1934024,142.0691611,1.8,126.4092002,141.9485787,-0.0138237,62.2603614,94.662524,207404.8759935,569360.325985,0.0442252,6014.6328444,3331.2507564,7773.7211243,49.5477467,80.3469815,0.1410686,389.3934651),(17004,'umzc_hippo_tibia-cleaned.tif',250,8,209,1389.3638771,125.453556,142.3114333,1.8,127.0897908,141.6922473,-0.0239888,80.7380216,95.3874967,209586.0014995,582480.0466144,0.1332309,6106.4611923,2595.877349,6338.0694526,0.4707032,0.6656748,2.3561945,1.3313497),(17005,'umzc_hippo_tibia-cleaned.tif',250,8,210,1389.8108945,125.6588119,142.4994483,1.8,127.600295,142.0336403,-0.0347476,50.0672233,91.1702087,208861.2843771,600662.3992338,0.2795644,6588.3626637,4171.6170876,8336.3133088,0.9414064,1.3313497,2.3561945,2.6626994),(17006,'umzc_hippo_tibia-cleaned.tif',250,8,211,1391.6791959,125.9038969,142.7146478,1.8,127.817822,142.532265,-0.043963,85.3112292,97.7582801,208381.8938972,621558.8987479,0.448008,6358.1202362,2442.6080343,6396.5321374,50.6291148,82.3528841,0.2130893,446.5550025),(17007,'umzc_hippo_tibia-cleaned.tif',250,8,212,1394.1919059,126.0333305,142.8752925,1.8,127.9809289,142.7833276,-0.0506615,82.3756301,99.9676282,209956.553155,641009.5636723,0.5958824,6412.1713711,2548.7702222,6569.4002413,49.5856982,83.6369517,0.204018,391.06745),(17008,'umzc_hippo_tibia-cleaned.tif',250,8,213,1404.1382763,126.1587337,143.0434496,1.8,128.0320752,143.1739592,-0.0560442,48.4093293,93.7812935,212838.9367563,662810.6608375,0.7342914,7067.6212295,4396.6512218,8775.9601016,0.4707032,1.0525243,2.677945,1.9970245),(17009,'umzc_hippo_tibia-cleaned.tif',250,8,214,1407.3850938,126.2987558,143.2169137,1.8,128.0995307,143.376877,-0.0627222,49.99229,93.021199,215844.5162184,681133.8398473,0.9215896,7322.3506823,4317.5560939,9636.4436276,0.4707032,0.6656748,2.3561945,1.3313497),(17010,'umzc_hippo_tibia-cleaned.tif',250,8,215,1419.961199,126.4872802,143.3818311,1.8,128.4206164,143.5236432,-0.0682408,85.155587,97.4817614,221470.6282297,709556.8354505,1.1003779,7278.8676075,2600.7762503,7192.8509617,49.8945389,84.2019478,0.1798535,396.9639075),(17011,'umzc_hippo_tibia-cleaned.tif',250,8,216,1432.4709029,126.6529332,143.4729542,1.8,128.5432884,143.4768889,-0.0733533,73.737311,94.5924978,229312.5610368,740298.7243626,1.2823238,7826.1885584,3109.8579243,9865.831357,50.8038814,86.1399712,2.9935133,403.6010603),(17012,'umzc_hippo_tibia-cleaned.tif',250,8,217,1453.9530461,127.0824264,143.7472615,1.8,129.527408,143.3065525,-0.0762483,83.5532535,95.1406875,237380.5778214,780613.8506011,1.4061119,8204.8371874,2841.069232,8039.6918911,52.6209341,86.9387659,3.0058211,439.5083107),(17013,'umzc_hippo_tibia-cleaned.tif',250,8,218,1457.1485016,127.2680086,144.0143532,1.8,129.747677,143.9103344,-0.0800461,54.9471101,87.1990244,238458.7205353,807494.553515,1.552771,9260.3622482,4339.7863901,11373.8340006,52.7030706,91.4013016,2.9603573,480.3233042),(17014,'umzc_hippo_tibia-cleaned.tif',250,8,219,1465.289682,127.4509272,144.1877116,1.8,130.0971737,144.1980507,-0.0808173,61.427177,92.1558071,243855.1540174,832194.7959308,1.591616,9030.302288,3969.8251783,11304.3045771,53.5287683,92.6819258,2.9422051,507.407145),(17015,'umzc_hippo_tibia-cleaned.tif',250,8,220,1468.0612163,127.5449095,144.3837384,1.8,130.2087627,144.493965,-0.0839723,48.0447382,91.5244584,249371.9921067,854102.8817751,1.7212611,9331.9632488,5190.4121318,11252.0833355,53.1567156,93.1433501,2.943206,487.4368996),(17016,'umzc_hippo_tibia-cleaned.tif',250,8,221,1481.6789968,127.7815174,144.5135983,1.8,130.3767581,144.6592081,-0.08774,84.4382767,98.4024014,257722.1337079,888216.2087425,1.8962088,9026.3672016,3052.1955644,8837.7256339,0.4707032,0.6656748,2.3561945,1.3313497),(17017,'umzc_hippo_tibia-cleaned.tif',250,8,222,1493.5190475,127.9787551,144.6929747,1.8,130.5649158,144.8897739,-0.0933517,62.0856179,91.3993201,268131.5920595,918981.8409869,2.1629395,10054.5807156,4318.7392016,12138.5741344,53.4653694,94.8125242,2.9315395,462.8542384),(17018,'umzc_hippo_tibia-cleaned.tif',250,8,223,1504.8594432,128.2280665,144.8312889,1.8,130.7055746,144.9239698,-0.0968444,63.568761,94.5685598,280473.6271929,947645.1423427,2.3449719,10020.7208909,4412.1298382,12953.6275673,54.6015709,96.2918856,2.9298165,459.6123635),(17019,'umzc_hippo_tibia-cleaned.tif',250,8,224,1520.0106314,128.4134003,144.8885946,1.8,130.6393824,144.7917575,-0.1011119,73.507815,92.8297643,296141.8021449,978166.3664823,2.5812007,10537.2061799,4028.711805,13159.3096336,0.4707032,1.4884942,2.8198421,2.9384309),(17020,'umzc_hippo_tibia-cleaned.tif',250,8,225,1531.1751207,128.5585003,145.1411802,1.8,131.1060055,144.6432349,-0.1022851,81.588473,101.0602409,311273.4404205,996692.9453282,2.6606361,9862.3646273,3815.1644353,10070.2663339,0.4707032,0.6656748,2.3561945,1.3313497),(17021,'umzc_hippo_tibia-cleaned.tif',250,8,226,1535.2777702,128.7405232,145.3946938,1.8,131.3407628,145.2128315,-0.1074079,80.1510381,100.4514069,318771.1190878,1011583.6402599,2.940626,10070.3780253,3977.130259,10478.2671784,0.4707032,0.6656748,2.3561945,1.3313497),(17022,'umzc_hippo_tibia-cleaned.tif',250,8,227,1549.6150216,129.1772726,145.5957714,1.8,131.7252462,145.5065834,-0.1119877,70.0566912,98.6172605,330014.0660912,1044645.5685139,3.2255117,10592.9282872,4710.671606,11363.8104752,58.1921824,98.9798283,2.9647166,505.2959087),(17023,'umzc_hippo_tibia-cleaned.tif',250,8,228,1563.6914346,129.2714597,145.7738086,1.8,131.7867345,145.7173769,-0.1174026,82.4412865,100.3823685,346045.355395,1064329.033657,3.5756952,10602.7487644,4197.476412,10916.393925,0.4707032,1.4884942,1.8925469,3.2141625),(17024,'umzc_hippo_tibia-cleaned.tif',250,8,229,1578.1714254,129.3715744,145.9216153,1.8,131.8027794,145.8504909,-0.1307502,53.3291114,95.6537499,363487.9281455,1084747.8424482,4.4710847,11340.3587734,6815.9382071,14843.3003458,0.4707032,1.940759,1.815775,4.1555689),(17025,'umzc_hippo_tibia-cleaned.tif',250,8,230,1596.9982535,129.5458418,146.08674,1.8,131.9254,145.9768077,-0.1393605,73.2662792,102.3839767,384781.6962436,1105578.3724168,5.1359519,10798.3534926,5251.8252684,11837.7927344,59.3548386,100.9381275,2.8773856,465.3081099),(17026,'umzc_hippo_tibia-cleaned.tif',250,8,231,1618.9190215,129.8080253,146.2742486,1.8,131.978968,145.9652832,-0.1432102,85.6658737,90.5548986,411901.4228599,1135638.354747,5.4960655,12540.8826234,4808.2323224,16501.5354281,0.4707032,1.0525243,2.677945,1.9970245),(17027,'umzc_hippo_tibia-cleaned.tif',250,8,232,1649.4429595,130.0736074,146.2830523,1.8,131.884548,145.6195154,-0.1531835,87.0167849,103.6477683,445174.756887,1162253.7304333,6.4004648,11213.4949862,5115.9642048,12627.1292552,63.0356162,99.0771531,0.4105062,491.2694289),(17028,'umzc_hippo_tibia-cleaned.tif',250,8,233,1670.5529464,130.5521666,146.5261343,1.8,132.1596431,145.8246361,-0.1612232,86.4542707,102.8985555,470875.0478367,1188461.758399,7.1746219,11549.8390909,5446.5215399,13362.89137,64.5059827,98.9977343,2.9162193,496.4610203),(17029,'umzc_hippo_tibia-cleaned.tif',250,8,234,1697.1510142,130.8840965,146.8300079,1.8,132.3970371,146.5126226,-0.1646407,82.3148822,100.2174287,489466.001599,1222662.2930068,7.5983131,12200.0964244,5946.2637671,13682.3411078,0.8424969,1.6971445,2.5535901,3.3283742),(17030,'umzc_hippo_tibia-cleaned.tif',250,8,235,1724.1423874,131.0760759,147.0700014,1.8,132.3646462,146.9310098,-0.1746944,76.4004138,104.5540051,511768.8291049,1249936.6086514,8.6807714,11954.9376138,6698.5085996,13604.5871959,66.317397,101.0916624,0.4324078,516.3447664),(17031,'umzc_hippo_tibia-cleaned.tif',250,8,236,1757.9761872,131.3754111,147.2721682,1.8,132.4565779,147.2701748,-0.1887406,72.4933251,104.3684734,538941.1091593,1293316.6490624,10.3140742,12391.8325804,7434.3549293,14418.7093098,67.2425678,101.3160614,0.4989759,524.3328645),(17032,'umzc_hippo_tibia-cleaned.tif',250,8,237,1804.3494339,131.7592784,147.3432026,1.8,132.2610829,147.3222156,-0.2045559,66.1551558,98.7073611,575518.4805364,1335893.0556707,12.4087608,13533.8746801,8699.5257316,17327.9767843,69.3033821,100.1890402,2.7410192,536.0196845),(17033,'umzc_hippo_tibia-cleaned.tif',250,8,238,1831.8199172,132.0026983,147.4871076,1.8,132.4821144,147.3877915,-0.2279447,82.4914945,107.6968895,609619.4659815,1374861.4155953,15.5903725,12766.0271467,7390.0887548,15403.4966629,0.4707032,0.6656748,2.3561945,1.3313497),(17034,'umzc_hippo_tibia-cleaned.tif',250,8,239,1862.275104,132.4144215,147.4645383,1.8,132.3490016,147.2220133,-0.2457914,90.9267593,107.1374605,645279.6668158,1395920.9811325,18.3765287,13029.2520954,7096.6970756,16614.4394388,69.9793112,105.0343362,0.5258164,626.9218112),(17035,'umzc_hippo_tibia-cleaned.tif',250,8,240,1901.7641631,132.9103709,147.3486101,1.8,132.1516512,146.8011973,-0.2530387,91.3279053,109.0644959,685305.0206524,1418594.4962831,19.8651144,13006.932135,7503.7855963,16429.331346,0.4707032,0.6656748,2.3561945,1.3313497),(17036,'umzc_hippo_tibia-cleaned.tif',250,8,241,1949.7379573,133.5059271,147.5536549,1.8,132.4477248,147.2794516,-0.2594513,95.77823,107.18628,721264.6730155,1440903.087515,21.3880303,13442.9806409,7530.5700804,17038.046576,0.4707032,0.6656748,2.3561945,1.3313497),(17037,'umzc_hippo_tibia-cleaned.tif',250,8,242,1997.8633535,134.1240552,147.4366708,1.8,132.5428167,147.7603613,-0.2548111,86.5452343,107.4377387,746858.8604606,1472050.3779021,21.1559366,13701.4274155,8629.693665,17668.5183277,73.4428421,106.2851573,0.6408439,653.8995571),(17038,'umzc_hippo_tibia-cleaned.tif',250,8,243,2041.9039593,135.1279608,147.457797,1.8,132.9996026,148.4527786,-0.2231764,87.0878602,104.518852,771493.3007745,1526369.454575,16.6708981,14603.7717156,8858.7927027,18141.995138,75.9146196,104.3231636,0.6606474,595.1228217),(17039,'umzc_hippo_tibia-cleaned.tif',250,8,244,2066.9344451,135.1119523,147.5196499,1.8,132.9425816,148.491769,-0.2579567,111.8232765,106.3029637,792221.1815415,1529857.0365026,22.4189617,14391.4805673,7084.5820846,18320.61035,75.0685783,107.3368437,0.6610432,611.7059059),(17040,'umzc_hippo_tibia-cleaned.tif',250,8,245,2107.1618415,135.0946621,147.7075508,1.8,132.7459184,148.7542814,-0.2887996,80.5995739,106.2931082,826919.8602091,1528611.7075352,28.4860718,14381.0989628,10259.6058588,19017.793263,0.4707032,1.0525243,2.677945,1.9970245),(17041,'umzc_hippo_tibia-cleaned.tif',250,8,246,2168.1038379,135.2415144,147.7944969,1.8,132.7882845,148.9695346,-0.2916711,84.2055091,108.5241837,868009.8339326,1566116.8262243,29.878967,14431.0399145,10308.2309314,19186.9670941,0.4707032,0.6656748,2.3561945,1.3313497),(17042,'umzc_hippo_tibia-cleaned.tif',250,8,247,2248.7391025,135.4643746,148.1266314,1.8,132.6393488,148.5965329,-0.304547,93.7472304,107.1952839,914715.7017137,1617694.560418,33.6998998,15091.0982412,9757.2557382,20378.672784,0.4707032,0.6656748,2.3561945,1.3313497),(17043,'umzc_hippo_tibia-cleaned.tif',250,8,248,2271.3740375,135.3795627,148.0166376,1.8,132.2359595,147.992002,-0.3316443,97.7230672,110.9902246,951484.2762631,1615497.1906328,40.1330284,14555.3105821,9736.5371701,20339.3084599,0.4707032,0.6656748,2.3561945,1.3313497),(17044,'umzc_hippo_tibia-cleaned.tif',250,8,249,2211.3875087,133.8394184,148.452389,1.8,131.7690821,148.4606068,-0.3966003,98.5093358,115.5991774,944857.015614,1519500.219438,54.9957728,13144.5591017,9591.5479263,19192.7567739,81.0164885,109.4594959,0.6787705,735.9194873),(17045,'umzc_hippo_tibia-cleaned.tif',250,8,250,2145.0399462,131.9884174,148.846925,1.8,130.8424428,148.9952531,-0.5160612,91.4757109,121.394043,911186.1939641,1414563.3346994,87.0532577,11652.6585672,9960.9632472,18445.8643528,0.4707032,0.6656748,2.3561945,1.3313497),(17046,'umzc_hippo_tibia-cleaned.tif',250,8,251,2081.5637551,129.6493638,149.0434771,1.8,128.8234922,149.117301,-0.6667389,82.2292065,129.4763243,833766.9221077,1314857.2163281,132.6829164,10155.1941882,10139.5472179,16409.9552092,82.1350384,105.479535,0.7095943,734.2846937),(17047,'umzc_hippo_tibia-cleaned.tif',250,8,252,2047.6695965,127.2815938,149.2806797,1.8,126.6826954,148.8554624,-0.8090279,82.8335848,132.6896067,754836.1057847,1233893.1723649,178.7005353,9299.0943557,9112.6818663,14984.91022,0.4707032,0.6656748,2.3561945,1.3313497),(17048,'umzc_hippo_tibia-cleaned.tif',250,8,253,2059.9051682,126.0302152,149.7996997,1.8,125.6536177,148.6670012,-0.8978227,87.7184683,130.4691999,744288.1292894,1189822.2742664,209.931751,9119.5644301,8484.9649527,14689.0107213,0.4707032,0.6656748,2.3561945,1.3313497),(17049,'umzc_hippo_tibia-cleaned.tif',250,8,254,2086.0486319,125.0177237,150.3774273,1.8,124.769959,148.6548379,-0.9813616,92.5450947,133.0979817,750538.1862872,1148536.4350207,240.2381135,8629.2550854,8109.972641,13988.79929,82.9195308,98.8756856,0.9034902,745.8768976),(17050,'umzc_hippo_tibia-cleaned.tif',250,8,255,2061.2129188,124.1156316,150.8197223,1.8,123.9352306,148.5128811,-1.0902851,96.0714196,130.7759003,744212.1487272,1080780.4647755,270.136127,8264.3702902,7746.4468788,13410.8900917,0.4707032,0.6656748,2.3561945,1.3313497),(17051,'umzc_hippo_tibia-cleaned.tif',250,8,256,2019.021211,123.4490469,150.9742931,1.8,123.5735554,148.1479752,-1.2207198,99.6413139,124.9055791,734570.5273265,1026728.2283819,296.9212753,8220.0349688,7372.1481435,12828.9112333,0.4707032,0.6656748,2.3561945,1.3313497),(17052,'umzc_hippo_tibia-cleaned.tif',250,8,257,1910.0853455,123.0459337,151.1796702,1.8,123.1532961,148.8934783,-1.4486879,100.1953109,109.4578028,682310.465985,918066.0886347,313.6244106,8387.3973818,6809.8043679,11619.9653228,78.6358467,94.9946227,0.6553935,707.2677565),(17053,'umzc_hippo_tibia-cleaned.tif',250,8,258,1723.6107738,122.8763757,151.2164592,1.8,122.8538524,149.6509527,1.4310093,110.5283964,87.4683232,583103.9301585,826218.9545431,281.6915627,9445.9219525,5275.6029142,10220.512632,72.5789909,92.3346443,1.2167989,656.6210434),(17054,'umzc_hippo_tibia-cleaned.tif',250,8,259,1517.130532,122.1360755,151.1581919,1.8,122.6127116,149.7733398,1.3065503,121.0821168,81.7441189,490988.845301,764200.5356923,235.6063476,9348.6913252,4055.0071163,9028.8206601,70.3440119,89.9671314,1.3385073,875.9950533),(17055,'umzc_hippo_tibia-cleaned.tif',250,8,260,1333.2922748,120.8833053,151.1828808,1.8,121.8317744,150.1842355,1.2120998,127.3698465,58.8430244,404457.8403183,727946.3773137,194.8297549,12370.9884946,3175.4599032,8093.4157925,69.9267255,87.2262685,2.1797539,842.5970993),(17056,'umzc_hippo_tibia-cleaned.tif',250,8,261,1137.2528214,119.4589796,151.1056073,1.8,119.8060511,150.6531878,1.1586115,107.5551426,58.9858584,326150.3071738,687377.9797178,159.1224721,11653.267391,3032.400863,9418.7721681,1.3606726,4.8002496,1.7681919,10.5838938),(17057,'umzc_hippo_tibia-cleaned.tif',250,8,262,954.7659558,117.771259,151.8677699,1.8,118.4033302,151.6166281,1.1109867,133.9901296,62.5558953,253928.2341888,632195.4224681,127.78927,10106.0886332,1895.1264166,6342.6846858,0.4707032,0.6656748,2.3561945,1.3313497),(17058,'umzc_hippo_tibia-cleaned.tif',250,8,263,760.93903,115.3494356,154.2532599,1.8,116.3531504,154.4440466,1.0304746,110.0969117,46.8440985,159430.6047753,555035.4267282,93.2632412,11848.5667202,1448.0933411,6377.9644847,0.4707032,0.6656748,2.3561945,1.3313497),(17059,'umzc_hippo_tibia-cleaned.tif',250,8,264,630.8649118,112.8732358,155.8042439,1.8,114.4542454,157.2036427,0.9803903,113.2358811,47.0478545,95881.3802083,490616.5513022,72.5585808,10428.0324156,846.740267,5145.7017872,18.9988503,38.7380438,1.4856369,115.0441745),(17060,'umzc_hippo_tibia-cleaned.tif',250,8,265,533.5649918,110.3878332,155.6857082,1.8,112.2974607,158.1123407,0.9657821,114.32715,48.4226126,63998.4572357,424359.1736846,60.1591154,8763.6571217,559.7835441,4219.7866561,18.035827,36.4392381,1.674321,95.8065077),(17061,'umzc_hippo_tibia-cleaned.tif',250,8,266,448.5657692,107.6512995,154.5941235,1.8,110.1665376,157.6165204,0.9614755,117.484376,49.7384025,43857.5525399,355749.273793,50.2737824,7152.40651,373.3054047,3359.4970102,16.3827155,36.5485196,1.441649,96.0349312),(17062,'umzc_hippo_tibia-cleaned.tif',250,8,267,365.7091816,103.8928323,152.4034743,1.8,107.0606169,156.0909983,0.9586723,116.618176,52.2578358,24069.5132513,277905.8228724,40.8269462,5317.97421,206.3958987,2512.4413555,0.4707032,0.6656748,2.3561945,1.3313497),(17063,'umzc_hippo_tibia-cleaned.tif',250,8,268,276.3917905,98.7295379,147.4654306,1.8,101.5756063,151.4979376,0.9657154,16.0603397,59.7020641,9046.8127031,166223.5642238,31.1601235,2784.2180472,563.3014529,2926.9337298,0.8944479,2.1050487,2.0344439,4.5455122),(17064,'umzc_hippo_tibia-cleaned.tif',250,8,269,222.9062149,94.2257974,141.7010708,1.8,96.9397288,145.2929523,1.0244593,115.7330169,64.3747712,6499.1407795,66761.2117566,27.1223429,1037.0710527,56.1563239,605.7727692,15.5332055,31.5932676,1.5111656,88.9409314),(17065,'umzc_hippo_tibia-cleaned.tif',250,8,270,191.6237306,91.6862415,137.9214046,1.8,91.9879733,138.4973959,1.5705681,36.8035899,54.6046966,2913.3929007,10141.8792055,31.9372868,185.732727,79.1605631,198.2593188,15.7800328,29.8182209,1.3641131,93.1160959),(17066,'umzc_hippo_tibia-cleaned.tif',250,8,271,171.6662669,91.7837382,137.4582455,1.8,91.6495224,137.6051588,-1.4612653,7.8016024,15.2163746,2028.3456667,7073.2451942,28.2691687,464.844313,259.9909041,597.5288189,15.0625023,27.9781483,1.3503026,101.7698689),(17067,'umzc_hippo_tibia-cleaned.tif',250,8,272,135.6333003,92.238038,136.3051176,1.8,91.9194822,137.0947116,-1.4842167,7.8248701,14.4681394,1521.7975642,3863.5609067,22.436522,267.0392368,194.4821515,371.1763564,0.9414064,3.426771,1.849096,8.149618),(17068,'umzc_hippo_tibia-cleaned.tif',250,8,273,72.7163172,93.8129204,134.3882476,1.8,93.2592648,135.3388301,1.2442023,11.7974165,71.8303445,484.6901357,1541.0605556,10.8719988,21.4541719,41.0844303,27.8290356,12.7089863,18.6685897,2.1587989,74.9536428),(17069,'umzc_hippo_tibia-cleaned.tif',250,8,274,43.3007243,106.9898531,130.560399,1.8,122.5124742,126.7089725,-0.2357704,7.8863903,79.3624549,482.8678745,40652.4573495,0.3937868,512.2379015,61.2279961,518.3128177,7.4575321,16.3192194,2.1507991,42.1267475),(17070,'umzc_hippo_tibia-cleaned.tif',250,8,275,20.1386742,95.5472488,133.8326318,1.8,95.4901701,133.7369085,1.0203204,2.6466087,6.5100342,18.3734951,149.6398629,2.4380335,22.9860334,6.9422787,25.7557694,4.6313431,13.3218153,2.1293956,30.0972922),(17071,'umzc_hippo_tibia-cleaned.tif',250,8,276,7.9562772,95.844542,133.8040614,1.8,95.7544791,133.8504657,0.8681415,1.8283559,4.4153809,4.5055944,23.7339405,0.7722442,5.3752873,2.4642873,6.3668931,3.9567975,9.0419132,2.2455373,20.4548048),(17072,'umzc_hippo_tibia-cleaned.tif',250,8,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17073,'umzc_hippo_tibia-cleaned.tif',250,8,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17074,'umzc_hippo_tibia-cleaned.tif',250,8,279,2.2646282,152.2923424,165.1186148,1.8,152.2706016,165.137822,-0.9302615,2.5954841,3.2435312,3.7147841,5.6438034,0.2426343,1.7400182,1.431249,2.8260926,5.6582362,7.1849725,0.551655,19.9033417),(17075,'umzc_hippo_tibia-cleaned.tif',250,8,280,24.3692923,152.2520457,165.1696253,1.8,152.2298677,165.2230431,-0.6948532,6.2268143,6.9452168,197.0266059,228.4338581,1.6650294,32.8908173,31.6416381,60.83154,12.8427007,14.4084394,0.6696389,43.7338288),(17076,'umzc_hippo_tibia-cleaned.tif',250,8,281,77.3309754,148.3325235,176.7816554,1.8,146.8681668,176.3070008,-0.0679641,24.8618072,104.2853365,17699.5801934,114883.8363812,0.0594423,1101.6298194,711.9184879,1269.0279324,0,0,0,0),(17077,'umzc_hippo_tibia-cleaned.tif',250,8,282,83.1263556,148.676231,175.9401124,1.8,147.5493148,175.1027047,-0.0725446,25.7478897,104.7510839,19207.8943524,115684.3776891,0.0727844,1104.3740402,745.9987819,1284.7757749,0,0,0,0),(17078,'umzc_hippo_tibia-cleaned.tif',250,8,283,125.9391744,139.0526477,176.5100512,1.8,140.2768865,175.7148022,-0.0678509,25.7920862,95.0764254,20372.8795136,144452.717865,0.0964843,1519.3326548,789.8887807,1727.9592529,8.9220365,22.9681939,2.3417028,55.4402444),(17079,'umzc_hippo_tibia-cleaned.tif',250,8,284,247.8053752,130.3697101,175.6892214,1.8,135.5579294,175.0830275,-0.0306924,25.9314498,88.5352057,24695.3023745,172808.3559493,0.0388948,1951.8603313,952.3301836,2196.1506015,16.180416,28.3400854,2.2974387,77.5021305),(17080,'umzc_hippo_tibia-cleaned.tif',250,8,285,387.6484803,128.5090792,173.8686053,1.8,134.0390294,173.6783363,0.0080257,27.0091281,90.9551338,32779.983385,185208.6482439,0.0041609,2036.2638214,1213.6631479,2368.1590406,22.9158376,29.3085983,2.6204545,90.3114723),(17081,'umzc_hippo_tibia-cleaned.tif',250,8,286,510.0189687,128.6790889,172.1137805,1.8,133.996191,172.6056665,0.0209279,29.3391232,91.4576758,42942.1865,195087.4684467,0.0372232,2133.0901608,1463.6492786,2571.5639403,29.3290646,56.3154625,0.2105096,188.4576398),(17082,'umzc_hippo_tibia-cleaned.tif',250,8,287,566.6760979,128.9668433,171.3087713,1.8,133.9501613,172.3573665,0.0107887,29.6915481,91.029371,48736.5997408,197904.6615984,0.0109925,2174.0748001,1641.4300634,2668.6037327,29.6283596,56.8791792,0.1746722,177.7595342),(17083,'umzc_hippo_tibia-cleaned.tif',250,8,288,573.2923974,128.941362,171.4058127,1.8,133.9812953,172.4779905,0.0087418,29.5033561,91.021079,49207.692828,200645.416064,0.0073011,2204.3840634,1667.8676378,2703.1422478,29.5621299,57.5125346,0.18937,177.0938594),(17084,'umzc_hippo_tibia-cleaned.tif',250,8,289,577.243915,128.8101554,171.6245275,1.8,133.852579,172.8255678,-0.0001435,28.9007595,91.0059138,48985.7383062,202453.2015183,0.0000024,2224.6158851,1694.9637027,2717.6713164,0.4707032,0.6656748,2.3561945,1.3313497),(17085,'umzc_hippo_tibia-cleaned.tif',250,8,290,577.3847745,128.6681281,171.8112242,1.8,133.8722237,173.0286751,-0.0015402,28.7697664,91.596942,48417.1674627,202785.9392712,0.0002291,2213.8942064,1682.9183405,2703.2123804,0.4707032,0.6656748,2.3561945,1.3313497),(17086,'umzc_hippo_tibia-cleaned.tif',250,8,291,578.0706755,128.6260103,172.011631,1.8,133.8578677,173.2405348,0.0035009,28.658241,91.7161868,48096.2117313,206531.2936485,0.0011806,2251.8521627,1678.2681034,2739.8189664,29.7490186,58.4601244,0.2274023,181.6393715),(17087,'umzc_hippo_tibia-cleaned.tif',250,8,292,579.767636,128.4595484,172.1674361,1.8,133.7353731,173.4222805,-0.0014483,28.4108812,93.222312,47539.5316127,205936.2636081,0.0002028,2209.0877084,1673.2860627,2691.2833804,29.8518161,58.3558074,0.2195438,195.3901198),(17088,'umzc_hippo_tibia-cleaned.tif',250,8,293,581.6098872,128.3174255,172.3204666,1.8,133.6826328,173.5866645,-0.0043838,28.3771856,93.325295,46982.018703,206195.5262824,0.0018634,2209.4280691,1655.6264405,2684.7170852,29.8100412,58.3558074,0.2195438,184.1878592),(17089,'umzc_hippo_tibia-cleaned.tif',250,8,294,585.0223387,128.3168148,172.5139114,1.8,133.6684359,173.8161981,0.0012491,28.0572322,92.460844,46914.3516191,211432.3584915,0.0001524,2286.723215,1672.0947828,2761.5614056,29.7799595,58.4601244,0.2274023,181.9151031),(17090,'umzc_hippo_tibia-cleaned.tif',250,8,295,587.8101208,128.1980512,172.663772,1.8,133.7341958,173.9481146,-0.0015787,27.9194912,93.0113964,46525.6988614,211772.6434485,0.0002441,2276.8461887,1666.4235966,2748.6367207,29.85768,58.4601244,0.2274023,179.3193074),(17091,'umzc_hippo_tibia-cleaned.tif',250,8,296,590.887343,128.1959736,172.8186617,1.8,133.6634468,174.0568397,0.0018493,27.7752427,93.0586132,46319.7330027,215607.5009439,0.0003371,2316.8999996,1667.6625857,2787.8367657,29.7933124,58.4373802,0.1863376,180.3080218),(17092,'okapi_radius.tif',236,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17093,'okapi_radius.tif',236,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17094,'okapi_radius.tif',236,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17095,'okapi_radius.tif',236,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17096,'okapi_radius.tif',236,3,5,10.4517922,122.1149574,54.2108592,1.8,121.973601,54.3880991,-0.104087,2.0517902,7.3374745,7.1645037,74.9819593,0.0188046,10.2190418,3.4918305,11.1816721,8.0860138,20.9821003,0.5461666,52.9987923),(17097,'okapi_radius.tif',236,3,6,25.8216518,120.9177253,54.943954,1.8,121.1524838,55.0830847,-0.0588065,3.4725843,9.9555158,41.4445,364.216652,0.0148656,36.584408,11.9347716,40.4171762,10.9509465,26.9077067,0.5045604,68.9793425),(17098,'okapi_radius.tif',236,3,7,42.2563461,120.6344041,56.0098071,1.8,120.7889193,56.3028905,-0.0593117,5.2542302,12.4078253,169.9750285,970.7440619,0.0247464,78.2364383,32.3501297,90.5331816,15.2549266,30.6988372,0.5148848,82.6445801),(17099,'okapi_radius.tif',236,3,8,68.2031293,120.3691809,57.3254955,1.8,120.4658396,57.8026621,-0.1257481,7.7238389,15.0468492,497.0080294,2014.6488074,0.1787992,133.8917388,64.3472809,164.8875674,23.7940708,34.318292,0.6619416,108.1569264),(17100,'okapi_radius.tif',236,3,9,108.9166991,120.7330702,58.6029866,1.8,120.8817277,58.9761227,-0.2043606,8.4678632,16.8107647,1335.3509923,4127.3714172,0.7476243,245.5195513,157.6963357,322.3277329,28.1717142,39.5018736,1.2912742,116.3385061),(17101,'okapi_radius.tif',236,3,10,139.1214728,120.6548034,59.5942214,1.8,120.6833349,59.9970905,-0.2719297,9.4038024,18.6137869,2437.0601192,6519.5655734,1.6727266,350.2546582,259.1568831,479.4875161,30.6034709,43.4929302,1.2158099,123.5756876),(17102,'okapi_radius.tif',236,3,11,166.195076,120.345432,60.7453941,1.8,120.5282457,60.9894514,-0.336262,11.2113003,20.6753616,3865.9705318,9669.3547534,3.015724,467.6752416,344.8280239,654.0578332,32.2441345,46.9490039,1.2111492,130.0244417),(17103,'okapi_radius.tif',236,3,12,192.9935097,120.0947951,61.9140372,1.8,120.4001613,61.9498091,-0.4155116,13.1294855,22.3466878,5511.5129712,13333.8944361,5.2410539,596.6832561,419.7813381,843.2826578,0.3515621,1.1117369,1.8925469,2.4006159),(17104,'okapi_radius.tif',236,3,13,213.9663826,119.9057086,63.0604289,1.8,120.5821279,62.6479544,-0.4866051,15.2391499,23.9107986,7092.5639498,16297.8322536,7.7982091,681.6096998,465.4172976,976.644928,34.4530819,52.396902,1.2851235,143.3131325),(17105,'okapi_radius.tif',236,3,14,232.6586868,119.8647739,64.1659813,1.8,120.6743936,63.4376833,-0.5891018,16.234495,24.2939151,8447.9617578,19261.8467482,11.9705785,792.86713,520.3710828,1132.5215177,1.4062482,9.5181816,1.4968573,23.182398),(17106,'okapi_radius.tif',236,3,15,250.5274304,119.7509303,65.5406843,1.8,120.6534329,64.4547823,-0.7080819,16.8821233,24.7575213,9400.53348,22879.9349395,17.6618289,924.1609706,556.8335995,1280.0189341,34.8749453,57.9811004,1.3258177,200.7719435),(17107,'okapi_radius.tif',236,3,16,269.3673006,119.5430823,66.9891151,1.8,120.4522675,65.7047492,-0.8158521,35.0622154,69.5337488,10444.4066184,28101.6128666,23.8136459,404.143504,297.8821076,549.8349472,34.8609917,61.3976743,1.3397057,221.8803029),(17108,'okapi_radius.tif',236,3,17,293.3782727,119.2949407,68.6704814,1.8,120.122319,67.221747,-0.9133481,29.1439281,68.9564099,11377.570986,35111.3334036,30.6364206,509.1815753,390.3925015,674.1741487,34.591852,65.3640762,1.3649621,239.1111305),(17109,'okapi_radius.tif',236,3,18,312.840317,118.8950063,70.3283001,1.8,119.7201747,68.7302548,-0.9883718,17.3840918,56.8619075,11922.5426375,42860.2106003,36.3647989,753.7596337,685.830631,927.8353505,34.4539358,69.4395144,1.3565205,285.9731103),(17110,'okapi_radius.tif',236,3,19,333.1176822,118.3709576,72.1844092,1.8,119.1793964,70.5639947,-1.0499634,23.1265064,42.1108406,12369.7089944,53652.0420239,41.7724814,1274.0672298,534.8714931,1402.5387708,34.7713124,73.7585246,1.335066,317.3870574),(17111,'okapi_radius.tif',236,3,20,352.8942594,117.6538422,74.4799895,1.8,118.4239233,72.6702659,-1.0871926,29.6708349,74.8087323,12362.4378764,67536.1935757,46.0997767,902.7848959,416.6528481,992.8011848,34.0012283,78.1970759,1.311642,299.6030141),(17112,'okapi_radius.tif',236,3,21,374.3559727,116.8633798,76.9277404,1.8,117.6061929,75.0171908,-1.1143369,14.9018039,60.8874544,12490.8425448,84862.2621471,50.270973,1393.756118,838.2100989,1571.6537219,33.9234618,82.2820469,1.3247814,325.1713922),(17113,'okapi_radius.tif',236,3,22,397.1649561,116.1080941,79.380689,1.8,116.7098332,77.6028536,-1.1372127,25.911986,32.6847553,13083.2760191,105269.5472895,54.5105299,3220.7537247,504.9121291,2924.5062888,34.2165494,86.1240947,1.314927,368.6676598),(17114,'okapi_radius.tif',236,3,23,429.1267764,114.989171,82.3679315,1.8,115.6169516,80.4060511,-1.1442302,24.4865795,35.664791,14552.5642241,134776.5836533,59.2776655,3778.9814523,594.3077614,3902.6012137,34.8388381,89.3659417,1.3888316,343.1406778),(17115,'okapi_radius.tif',236,3,24,441.1069628,114.9221938,83.3045487,1.8,115.5147455,81.3024079,-1.1702454,40.5468611,66.5352304,16460.1037146,140910.1351116,62.3400228,2117.8274151,405.9526008,2021.9250349,34.812193,88.7476625,1.4317004,357.5443732),(17116,'okapi_radius.tif',236,3,25,432.9068254,115.4449712,82.0318473,1.8,115.8372202,80.3440471,-1.1639253,42.1343044,68.1559279,17467.064043,126654.5236545,60.8516655,1858.305324,414.5568387,1805.5738181,34.5132645,84.9369864,1.5003736,357.8855863),(17117,'okapi_radius.tif',236,3,26,418.2606384,115.7148058,80.9104193,1.8,116.0079424,79.4547929,-1.1472436,13.9509505,33.436492,17540.588337,113827.0797734,57.9345003,3404.2769702,1257.3041784,3857.4183485,0.3515621,0.4971838,2.3561945,0.9943677),(17118,'okapi_radius.tif',236,3,27,407.4940513,115.7879527,80.2894888,1.8,115.9337291,79.015804,-1.1333136,14.5509374,32.4830387,17937.2555795,103925.7287503,55.725603,3199.384448,1232.7216491,3703.6985398,32.3300367,78.275275,1.4943689,311.152817),(17119,'okapi_radius.tif',236,3,28,393.9661449,115.6781438,80.0829065,1.8,115.8623348,78.9543878,-1.1231041,15.0893455,31.9395999,18166.7889303,95544.521523,53.3567654,2991.4125948,1203.9481087,3530.5735076,30.7358684,70.3976143,1.3645861,222.0448471),(17120,'okapi_radius.tif',236,3,29,381.4949833,115.4594006,80.0343245,1.8,115.6259016,79.010973,-1.1079922,15.9484482,31.7388811,18363.6975421,89936.4277995,50.9088758,2833.6357378,1151.4410275,3394.4573665,32.2623502,67.7019446,1.329596,206.446906),(17121,'okapi_radius.tif',236,3,30,373.9296044,115.201208,79.9093743,1.8,115.26717,79.2423467,-1.0942424,17.1559622,67.6896537,18652.8146717,87648.9414258,49.207651,1294.8646746,1087.2496942,1522.2954874,33.3386438,65.4340015,1.2932347,208.3150043),(17122,'okapi_radius.tif',236,3,31,370.4980209,114.8922658,79.8477867,1.8,114.8599685,79.5528975,-1.0864931,17.7207937,68.8607851,19230.6484748,86210.45786,48.3638405,1251.9528755,1085.2024364,1482.90572,33.6757507,63.9466166,1.2751268,298.4027061),(17123,'okapi_radius.tif',236,3,32,370.9319548,114.6095751,80.2426547,1.8,114.9266708,80.9984005,-1.1162256,52.533981,68.0004223,25325.3106453,88007.0183747,49.9034325,1294.2128213,482.0748433,1613.2616405,1.7190422,7.5237567,0.9179497,21.4142386),(17124,'okapi_radius.tif',236,3,33,377.2629853,114.32354,80.4301759,1.8,114.4736191,81.3511303,-1.1224176,53.1442635,37.0357508,27971.5734836,90268.7751952,51.0608683,2437.3415756,526.3328843,1866.4430376,2.7345111,18.3958019,0.7853982,51.4365732),(17125,'okapi_radius.tif',236,3,34,0.1315734,68.6484718,134.751246,1.8,68.4886839,134.7141871,0.1470406,1.1736486,13.4261573,0.041926,2.0518902,0.0004707,0.1528278,0.0357228,0.1553581,0.4971838,0.9943677,2.3561945,1.9887353),(17126,'okapi_radius.tif',236,3,35,1.6086191,52.0336815,126.8909766,1.8,52.3609109,127.3397088,0.7827471,6.3952651,18.9244531,4.9391277,20.0680409,0.1333408,1.0604291,0.7723101,1.2518704,5.1025986,14.0492927,2.5882983,45.9175816),(17127,'okapi_radius.tif',236,3,36,74.4842346,87.1506875,94.7100225,1.8,88.8977512,97.1777926,0.5426275,50.3971252,72.920302,978.5730155,4196.112016,3.3102833,57.5438102,19.4172388,70.9004946,10.6069787,25.9227856,2.7812347,66.6140604),(17128,'okapi_radius.tif',236,3,37,172.9402276,96.3497694,96.3260312,1.8,99.8023296,98.2487205,0.2677889,46.3905364,48.5311028,3010.761089,35462.3219321,2.018012,730.7132927,64.9003293,716.2037995,15.4950398,41.9199983,2.9474866,116.4944769),(17129,'okapi_radius.tif',236,3,38,374.2880699,100.9790386,101.9584474,1.8,103.2756969,105.1870329,0.3693548,46.8339948,52.0203066,32855.4552247,119122.4741892,8.13022,2289.9225706,701.5300605,2746.8932684,21.8288758,27.6842567,0.3097029,115.1381981),(17130,'okapi_radius.tif',236,3,39,714.6577967,105.834589,109.4284286,1.8,105.2899101,110.2946915,0.3844658,40.1151766,45.161329,81383.1707035,277895.8079061,16.7555069,6153.4019092,2028.737691,6980.9257921,0.9438749,1.267575,2.1587989,2.983103),(17131,'okapi_radius.tif',236,3,40,1056.5238202,102.7080763,111.726737,1.8,100.6292057,111.4947719,0.1989978,29.6958833,44.7365578,128082.9575531,454117.1334272,6.8815165,10150.9180774,4313.1553442,12417.6442039,44.9950857,87.2129039,0.129355,365.1934353),(17132,'okapi_radius.tif',236,3,41,1180.561689,97.6062199,111.8600849,1.8,100.0759504,111.4244376,0.0588156,26.2262892,46.8832949,144694.0455196,627783.799732,0.6798617,13390.3515205,5517.1375709,16044.6423795,47.6653183,86.1951024,0.0980453,414.8411512),(17133,'okapi_radius.tif',236,3,42,1138.7316738,101.966604,111.6812801,1.8,102.4191635,112.2193834,0.0401292,26.5222335,48.2994679,156586.5568162,679541.6870323,0.305463,14069.3410679,5903.973246,15474.5761256,0.3515621,1.4495275,2.896614,2.8977997),(17134,'okapi_radius.tif',236,3,43,1116.4486096,98.9809004,110.7415885,1.8,101.6102866,111.3913634,0.0295856,26.8421192,47.5996526,168839.0306014,551084.7083226,0.1628265,11577.4943323,6290.078259,14973.7682648,55.9128349,88.0513833,0.1402031,555.9035762),(17135,'okapi_radius.tif',236,3,44,1005.6338898,98.2887785,110.3389806,1.8,101.3094692,110.347133,-0.0189236,26.3989432,48.4094146,144048.310123,560489.969044,0.0600127,11578.1191177,5456.5938139,13900.534102,50.5327885,88.6194446,0.2199598,440.4241651),(17136,'okapi_radius.tif',236,3,45,927.3527897,100.2537775,110.2289212,1.8,101.7913887,109.8987851,-0.0121861,26.0413204,46.0592009,133340.5933936,515061.4723304,0.0229498,11182.5967876,5120.346869,13998.5056951,46.8420456,85.9438021,0.1685111,263.4085332),(17137,'okapi_radius.tif',236,3,46,916.2156771,99.6465589,110.6189593,1.8,101.3604568,109.9512672,-0.0378255,27.1674178,45.777233,131299.1010737,477000.8108108,0.2183787,10420.0446321,4832.9621243,13203.9736548,47.6148356,83.016302,0.1874291,255.4535918),(17138,'okapi_radius.tif',236,3,47,886.6056243,98.9927899,110.5732007,1.8,100.5025976,109.9914857,-0.0528375,26.6823821,45.8352762,123068.6275542,445471.5693154,0.4121524,9718.9677132,4612.3553315,12326.3639313,46.2396195,82.4800858,0.2191313,312.4152191),(17139,'okapi_radius.tif',236,3,48,841.7978847,98.806582,110.8935389,1.8,99.7913462,110.2596898,-0.0745409,27.3573599,45.4708462,115556.53453,402670.4692542,0.7781115,8855.574576,4223.9651359,11332.2402391,45.9632859,81.6426723,0.2125971,256.3565939),(17140,'okapi_radius.tif',236,3,49,825.0835266,98.4984379,111.0374029,1.8,99.2515097,110.609348,-0.0816043,25.1576711,45.0934765,110666.7050266,371738.4624186,0.9137106,8243.7303874,4398.9248692,10648.0425974,48.0689857,80.5077119,0.2651031,316.5219002),(17141,'okapi_radius.tif',236,3,50,807.558829,97.9413986,111.3572957,1.8,98.7675427,111.0007201,-0.0905984,25.9449101,43.9640387,103889.4232066,340965.8637746,1.1017327,7755.5628134,4004.2313862,10068.5459432,45.5311965,78.2744855,0.2449787,282.8133384),(17142,'okapi_radius.tif',236,3,51,779.0004648,97.456728,111.8402241,1.8,98.1367252,111.5772996,-0.102172,25.5506147,39.8533982,97478.2333271,299785.93469,1.3506362,7522.2176419,3815.1032565,9932.4993511,45.6633922,72.7393713,0.2590457,279.2124146),(17143,'okapi_radius.tif',236,3,52,746.5208526,97.1326935,112.2359968,1.8,97.8370085,112.0240458,-0.1151311,26.3716399,37.6550072,91416.3915801,262986.2683799,1.641936,6984.0982081,3466.4659463,8397.9604226,43.8336932,68.7310572,0.2586255,282.6073982),(17144,'okapi_radius.tif',236,3,53,705.4620009,96.9455114,112.5071529,1.8,97.6391821,112.3377102,-0.113864,25.6814095,36.0418672,82742.4795117,231051.0156415,1.5178111,6410.6283413,3221.8823319,7713.0408599,43.8870584,65.6555679,0.2488747,245.7743983),(17145,'okapi_radius.tif',236,3,54,660.7465837,96.8482856,112.7500338,1.8,97.4377323,112.59388,-0.10984,25.4963636,38.5608427,72974.6569821,204820.1911489,1.3232963,5311.610863,2862.1594092,6542.2217534,40.2593286,62.7673669,0.2259592,257.0097486),(17146,'okapi_radius.tif',236,3,55,625.3134794,96.7610727,112.7476281,1.8,97.1331675,112.6802448,-0.0926666,24.4030138,37.8131883,65771.2894909,185061.4758155,0.8923801,4894.0987041,2695.2117435,5959.7518639,38.5668498,60.5268994,0.1164301,245.5891561),(17147,'okapi_radius.tif',236,3,56,594.4955577,96.7838292,112.6959285,1.8,97.0480646,112.6415167,-0.0744999,20.5426634,32.426285,60129.0460353,168047.0269312,0.5489154,5182.4323074,2927.0326223,7031.0990283,35.7397045,58.8695893,0.1317623,197.8741438),(17148,'okapi_radius.tif',236,3,57,560.0793479,97.0279539,112.6080865,1.8,97.2987182,112.4257375,-0.0595872,26.7582062,31.0805939,53131.1631996,151514.7203291,0.331047,4874.8978435,1985.6025759,6519.1175016,34.6844921,57.0809482,0.1297025,207.2353333),(17149,'okapi_radius.tif',236,3,58,535.1583356,97.0185506,112.5353332,1.8,97.413155,112.371739,-0.0441411,18.6184975,30.2965848,49046.3628841,139443.4762712,0.1736736,4602.6137002,2634.2814679,6220.7808297,33.755512,55.5979588,0.1204334,149.9678269),(17150,'okapi_radius.tif',236,3,59,519.2082495,96.9186441,112.4153637,1.8,97.3952044,112.2716234,-0.0301994,18.8442851,29.3611509,46496.08578,130064.2897265,0.0788961,4429.8089805,2467.3839104,6001.5984462,33.263432,54.1599582,0.1171087,146.5728433),(17151,'okapi_radius.tif',236,3,60,506.6097467,96.8489418,112.3864207,1.8,97.3486606,112.2707562,-0.0220513,18.3764036,29.4142123,43824.5986466,122076.5713564,0.0410504,4150.2580504,2384.8300029,5626.5090481,32.6627782,52.9027897,0.07983,181.3464402),(17152,'okapi_radius.tif',236,3,61,495.538889,96.8883119,112.4010389,1.8,97.3163903,112.2650505,-0.0208845,18.3443171,28.6404056,41460.5720608,114534.7213032,0.0360168,3999.0607325,2260.1316759,5445.0154582,31.9921475,51.6748395,0.1159164,140.0741197),(17153,'okapi_radius.tif',236,3,62,490.0212692,96.8240682,112.3781131,1.8,97.276353,112.2509683,-0.0155103,25.8602573,27.9752095,39827.6466113,108674.7685841,0.0196457,3884.6811279,1540.1102249,5307.3105957,31.2890234,50.6273781,0.1183258,137.1763199),(17154,'okapi_radius.tif',236,3,63,485.3993824,96.7698821,112.3454731,1.8,97.1596666,112.2908707,-0.0085189,17.811342,27.341198,38525.7128132,103738.3602054,0.0058705,3794.2141489,2162.9876561,5199.6761147,30.5858993,49.5802229,0.120837,134.2785202),(17155,'okapi_radius.tif',236,3,64,478.8623962,96.7151806,112.3770302,1.8,96.9573359,112.3266555,-0.0021584,17.815977,25.6387149,37322.1492133,98508.9454895,0.0003719,3842.1951276,2094.8696319,5209.4726719,30.2343372,48.6986426,0.0867383,132.3750881),(17156,'okapi_radius.tif',236,3,65,474.9294254,96.6745853,112.3045032,1.8,97.0106205,112.1646233,0.0035788,18.0656421,26.0248809,36136.5503187,92980.9166056,0.0010136,3572.7701094,2000.2914942,4956.4137322,29.5312131,47.7529479,0.1106572,129.2713481),(17157,'okapi_radius.tif',236,3,66,467.0700756,96.5199607,112.2890984,1.8,96.8868243,112.1847845,0.0105591,17.3420743,25.4840161,34886.3824413,87893.4470901,0.0086788,3448.9637208,2011.6614601,4814.2366585,29.4696555,46.8356672,0.1355277,127.5738563),(17158,'okapi_radius.tif',236,3,67,463.2734348,96.445702,112.2741302,1.8,96.8245595,112.1719067,0.0163832,17.676594,24.7974973,33935.605378,83939.047657,0.0207223,3384.9806166,1919.8045358,4719.2300847,0.3515621,0.7861167,2.0344439,1.6974918),(17159,'okapi_radius.tif',236,3,68,463.5329113,96.4103287,112.2595657,1.8,96.8028738,112.1518883,0.0195704,18.0083486,37.841921,33193.1853049,81036.6282737,0.0295853,2141.4512293,1843.2109475,2797.9315625,28.7312532,45.5473038,0.0927563,124.6760565),(17160,'okapi_radius.tif',236,3,69,464.3609662,96.4503065,112.261867,1.8,96.8071214,112.16017,0.0217986,18.7315764,35.7500685,32477.0642439,78414.0572235,0.0367696,2193.395998,1733.8137261,2821.2049749,28.1249648,44.9188466,0.1097929,122.6873212),(17161,'okapi_radius.tif',236,3,70,463.4514503,96.4459649,112.2780756,1.8,96.7440471,112.2030235,0.0292776,18.0173766,34.4797669,31648.3402856,75751.4872648,0.0661911,2196.9837434,1756.5454176,2811.4306259,28.1249648,44.4972588,0.0949517,122.1901374),(17162,'okapi_radius.tif',236,3,71,462.8803999,96.4069252,112.2967625,1.8,96.638608,112.23184,0.0395834,24.1735525,23.1280113,30976.030066,73571.6222664,0.1208143,3181.0613316,1281.4016486,3959.4513973,27.7734028,44.3651263,0.0554985,121.0751327),(17163,'okapi_radius.tif',236,3,72,463.2804011,96.4612544,112.3016075,1.8,96.5446689,112.2215583,0.0439025,22.2339368,22.6742356,30214.7952088,71883.6304779,0.1487282,3170.2780084,1358.9494086,3340.2665441,27.7734028,44.0141098,0.0559416,120.1660683),(17164,'okapi_radius.tif',236,3,73,465.5121308,96.5861469,112.2586367,1.8,96.6904727,112.1306799,0.0522955,22.9402717,22.2791621,29532.4010934,69736.1482234,0.2119883,3130.1064127,1287.3605627,3501.3494701,27.7734028,43.6446989,0.0483494,119.0510636),(17165,'okapi_radius.tif',236,3,74,463.4768811,96.5958807,112.3071704,1.8,96.6856021,112.1720227,0.0595404,23.0125009,21.9513996,28734.9020392,67567.9157381,0.2735192,3078.0686923,1248.6648942,3400.5310812,27.4218407,43.3121034,0.0568492,117.8507556),(17166,'okapi_radius.tif',236,3,75,460.0299043,96.5189393,112.365497,1.8,96.6781431,112.1561268,0.0692627,18.7672474,22.2648455,28035.7723015,65415.6137436,0.3672313,2938.0672662,1493.8670376,3932.1427834,27.4218407,42.9826855,0.06548,116.9416912),(17167,'okapi_radius.tif',236,3,76,457.7302719,96.4377631,112.4594247,1.8,96.6471179,112.2346414,0.0826408,23.7805737,22.1408973,27524.4345806,63798.1474852,0.5198273,2881.4617019,1157.4335825,3287.7890522,27.4218407,42.631883,3.075573,116.2385671),(17168,'okapi_radius.tif',236,3,77,458.2906481,96.4119554,112.5207674,1.8,96.6245955,112.2147693,0.0906157,23.4447928,21.7611048,27056.3900864,62801.6230689,0.6254711,2885.9574731,1154.0468838,3624.070671,27.4218407,42.3643224,3.0501815,115.7413833),(17169,'okapi_radius.tif',236,3,78,459.0595643,96.3498182,112.5820865,1.8,96.4342206,112.2979211,0.0964209,21.5034264,21.6913867,26649.9966641,61997.4741719,0.7091102,2858.1609429,1239.337216,3621.9604566,27.4218407,42.2591636,3.0833254,115.535443),(17170,'okapi_radius.tif',236,3,79,459.5245844,96.2756661,112.6211155,1.8,96.5095252,112.2903383,0.1001479,21.8730154,21.6125298,26399.8498439,61584.791255,0.7655766,2849.4947942,1206.9597768,3459.8057537,27.4218407,42.0142404,3.0494176,114.8323188),(17171,'okapi_radius.tif',236,3,80,460.1976202,96.2131395,112.662156,1.8,96.5047901,112.2921587,0.1058475,22.4647658,23.3062003,26235.6658564,61137.5630906,0.856114,2623.2316857,1167.8584177,2699.1680857,27.4218407,41.7752781,3.0235006,114.335135),(17172,'okapi_radius.tif',236,3,81,464.5236634,96.2813188,112.6400335,1.8,96.8195674,112.1056884,0.105432,17.9207821,21.6441389,26223.0239952,61015.7873146,0.8574171,2819.044344,1463.2745274,3429.5149646,27.4218407,41.7752781,3.0235006,115.4148059),(17173,'okapi_radius.tif',236,3,82,464.2910035,96.2424185,112.6853712,1.8,96.8561399,112.075212,0.1027703,23.3671823,21.6157397,26071.1317142,60590.0805443,0.8144139,2803.0537641,1115.7156817,3313.1171169,27.4218407,41.5795527,3.0738996,114.335135),(17174,'okapi_radius.tif',236,3,83,462.9468421,96.1715255,112.7546796,1.8,96.6581485,112.2661708,0.1076675,19.4563289,21.5802207,25731.5545597,60095.886798,0.8909853,2784.7670161,1322.5287605,3548.7144621,27.4218407,41.5646875,2.9973033,114.455772),(17175,'okapi_radius.tif',236,3,84,462.7878528,96.1141246,112.7973707,1.8,96.4943297,112.3483689,0.1090289,23.5548327,21.5636953,25754.0178506,59836.3632371,0.9132562,2774.8659239,1093.3644989,3626.7963193,27.7429531,41.5155944,3.0056836,118.1419992),(17176,'okapi_radius.tif',236,3,85,461.4723432,96.0325829,112.8598747,1.8,96.3248996,112.5010112,0.109912,19.7613636,21.526861,25514.8810925,59711.730774,0.9254114,2773.8243302,1291.1498209,3870.6427549,27.7734028,41.508151,2.9541635,119.0510636),(17177,'okapi_radius.tif',236,3,86,461.4470248,95.9826351,112.8930438,1.8,96.3012871,112.4947175,0.1098703,19.6044482,21.7532362,25583.3128426,59757.7037751,0.9246614,2747.0718976,1304.9748987,3865.5065526,27.7734028,41.6715988,2.9806048,114.9529559),(17178,'okapi_radius.tif',236,3,87,459.6277683,95.8932801,112.9408283,1.8,96.2143798,112.543528,0.111709,18.8140755,21.7058845,25583.9641633,60002.840413,0.9519727,2764.3582272,1359.8310529,3936.1465181,27.7734028,41.6448967,2.9375747,115.1588962),(17179,'okapi_radius.tif',236,3,88,458.3282138,95.7943711,112.9791823,1.8,96.024705,112.630528,0.1153792,22.6985861,21.6476643,25656.987771,60232.6996856,1.0124008,2782.4110139,1130.3341842,3709.0591111,27.7734028,41.6448967,2.9375747,114.8676526),(17180,'okapi_radius.tif',236,3,89,461.5830926,95.8269336,112.9382468,1.8,96.0409961,112.5973134,0.1195098,22.3749311,21.6709451,25920.5323068,60627.6582677,1.0935467,2797.6471725,1158.46311,3788.5838254,30.9374613,41.6448967,2.9375747,186.7447949),(17181,'okapi_radius.tif',236,3,90,458.9915117,95.7881982,112.9844703,1.8,96.001006,112.6542954,0.1242685,21.8225044,21.6763409,25865.1841124,60561.6844888,1.1752726,2793.907187,1185.2527851,3829.7365028,27.7734028,41.7175457,2.9293222,115.776717),(17182,'okapi_radius.tif',236,3,91,458.301959,95.7404243,113.0232057,1.8,95.9847381,112.7750123,0.1288075,20.9965517,41.6541682,26039.5540842,60870.5285121,1.2603154,1461.3310297,1240.1824125,1988.7122378,28.1249648,41.7175457,2.9293222,115.776717),(17183,'okapi_radius.tif',236,3,92,458.1066775,95.6847693,113.0445574,1.8,95.9571528,112.7562723,0.133225,22.8211819,31.3829232,26216.4883111,61404.2788925,1.3471493,1956.6143836,1148.7787302,2435.4801435,28.1249648,41.7930259,2.9210989,116.4798411),(17184,'okapi_radius.tif',236,3,93,456.854389,95.621443,113.0640863,1.8,95.8930965,112.7778481,0.1383564,23.2860015,21.6541666,26328.4526666,61843.5940448,1.4482791,2855.9674125,1130.655801,3622.8064529,28.1249648,41.8727977,2.8782861,116.6857814),(17185,'okapi_radius.tif',236,3,94,456.9479474,95.5688979,113.0651822,1.8,95.8514313,112.7574845,0.1436669,19.7633555,21.6525562,26556.9372225,62592.257898,1.5611291,2890.756056,1343.7463708,4074.8028167,28.1249648,41.9656732,2.8701974,116.8917217),(17186,'okapi_radius.tif',236,3,95,458.1551421,95.4955396,113.0715452,1.8,95.730019,112.7574299,0.1502992,18.9964696,21.6876444,26874.6545551,63558.5891628,1.7119935,2930.6358965,1414.7183733,4166.6096281,28.1249648,42.1596061,2.8541294,117.097662),(17187,'okapi_radius.tif',236,3,96,458.939077,95.4175961,113.0691465,1.8,95.5804833,112.8088318,0.1574206,18.6003447,21.6157883,27192.7541157,64436.5863713,1.8799084,2980.9963645,1461.9489338,4236.7485427,28.1249648,42.2606259,2.7935324,117.3036023),(17188,'okapi_radius.tif',236,3,97,463.4008884,95.4989432,112.940619,1.8,95.7787214,112.6499569,0.1624875,19.0019225,21.6273831,27781.5436337,65547.0401185,2.0212498,3030.7430098,1462.0385736,4271.3116842,28.1249648,42.358487,2.8119682,125.1232709),(17189,'okapi_radius.tif',236,3,98,462.1269519,95.4677568,112.9071597,1.8,95.7398545,112.6269897,0.1686871,21.0217323,21.6521776,28052.9112617,66124.1445457,2.1709525,3053.9258318,1334.4719109,3649.4996271,31.6405854,42.631883,2.7702744,192.5610924),(17190,'okapi_radius.tif',236,3,99,461.0606565,95.4317135,112.8566755,1.8,95.6855635,112.6055927,0.1747991,18.6734559,22.2329941,28406.9782864,66683.6899685,2.324115,2999.3121731,1521.2491186,4276.4738834,31.6405854,42.7607002,2.762613,199.6423031),(17191,'okapi_radius.tif',236,3,100,459.4712509,95.3911431,112.8014114,1.8,95.7224924,112.4247236,0.1836634,18.2390804,22.1790281,28792.0993492,67229.6811721,2.5542507,3031.2275575,1578.5938068,4327.8381898,0.6292499,1.5722333,2.0344439,3.3949836),(17192,'okapi_radius.tif',236,3,101,455.3999277,95.3343764,112.7522106,1.8,95.731882,112.3318442,0.1934637,20.9867737,43.28446,29006.7076987,67584.9005129,2.8055353,1561.4125834,1382.1423039,2163.2071479,0.7031241,1.267575,2.1587989,2.6918595),(17193,'okapi_radius.tif',236,3,102,453.3016441,95.289732,112.6912187,1.8,95.6891687,112.3061237,0.2013597,18.1316061,21.7694797,29425.9339548,68153.2384931,3.0220638,3130.6783383,1622.908296,4323.9025285,1.2283373,6.0074951,1.929567,13.9918149),(17194,'okapi_radius.tif',236,3,103,451.5302904,95.2501703,112.6231199,1.8,95.5543268,112.2756995,0.2083097,25.5374581,21.8234096,29854.3112735,69003.6952512,3.2185752,3161.9117551,1169.0400475,3713.6719338,28.5652916,43.4118649,2.7069224,120.3927066),(17195,'okapi_radius.tif',236,3,104,452.027408,95.2172197,112.534444,1.8,95.5139441,112.2301439,0.2155033,25.9711406,21.8791373,30534.4357399,70082.1604728,3.4449887,3203.1500832,1175.7063803,3641.0964591,28.6503422,43.7182654,2.6563657,121.0105275),(17196,'okapi_radius.tif',236,3,105,453.6812333,95.2887328,112.3652175,1.8,95.690864,111.9617992,0.2267074,19.8913624,31.9507774,31225.8513998,71106.5937126,3.8201288,2225.5043411,1569.8196418,2842.8287317,0.9752978,8.2298568,1.9195673,17.798679),(17197,'okapi_radius.tif',236,3,106,451.5290919,95.2506146,112.2562732,1.8,95.6714415,111.8400527,0.2359,18.4077357,22.1691693,31591.2828867,71630.7617196,4.1107331,3231.0981482,1716.1960293,4549.6431288,1.1585015,6.2296956,1.8568478,13.7005713),(17198,'okapi_radius.tif',236,3,107,451.416732,95.2372181,112.1511043,1.8,95.7488508,111.6633264,0.2433137,18.5963312,22.3885219,32319.4220905,72308.8178865,4.3668887,3229.7271817,1737.9461455,4572.1000126,1.1404725,7.9003747,1.9347753,17.0955549),(17199,'okapi_radius.tif',236,3,108,450.1950803,95.2286133,112.0432988,1.8,95.7562566,111.4900063,0.249781,18.6869311,22.4485575,33067.5907744,73006.2484506,4.5847694,3252.1576745,1769.5570589,4608.6980876,1.073251,7.3408313,1.8622531,16.1011873),(17200,'okapi_radius.tif',236,3,109,447.7640617,95.2184018,111.9818075,1.8,95.5664059,111.5324259,0.2623305,17.8833584,22.3319259,33700.3385066,73415.0027733,5.0189186,3287.4461026,1884.4524523,4652.2416982,0.891156,3.4624847,1.9890207,7.4930913),(17201,'okapi_radius.tif',236,3,110,448.099456,95.2339224,111.906489,1.8,95.5786358,111.5353121,0.2754149,17.4511104,22.4307481,34538.4660076,74297.5533742,5.5231796,3312.3083065,1979.1557849,4682.841205,1.1660102,8.5610956,1.9055332,18.7930467),(17202,'okapi_radius.tif',236,3,111,448.5122288,95.2755409,111.7774894,1.8,95.6014862,111.3234475,0.281769,17.4167712,22.5070124,35404.1164388,75306.9418543,5.7794342,3345.9323912,2032.760034,4732.0297028,0.7253181,4.3485825,1.815775,9.3112201),(17203,'okapi_radius.tif',236,3,112,449.9517837,95.307852,111.6504748,1.8,95.6709805,111.2193335,0.2882078,17.3906046,49.3850738,36298.7039506,76530.786151,6.0585406,1549.6744316,2087.2594616,2261.137385,0.6687108,2.2234737,1.8925469,4.8012318),(17204,'okapi_radius.tif',236,3,113,450.536954,95.4645984,111.4283825,1.8,95.9330727,110.9349374,0.3000683,19.388703,22.5985149,37139.9345743,77100.6455624,6.5606254,3411.7571884,1915.5450779,4643.4120928,0.6822383,2.5594104,1.849096,5.5043559),(17205,'okapi_radius.tif',236,3,114,449.0614814,95.501611,111.2948678,1.8,95.9044921,110.8197017,0.3111189,19.4164424,22.8352873,37661.3172885,77454.0381487,7.0137346,3391.8573921,1939.6610588,4699.3012055,0.8541733,5.1188209,1.849096,11.0087119),(17206,'okapi_radius.tif',236,3,115,449.9024577,95.5401481,111.1519024,1.8,96.0887804,110.7345999,0.3209124,19.6366771,23.1707565,38525.351762,78231.7331916,7.4607069,3376.3132947,1961.9078885,4731.894765,0.3515621,0.4971838,2.3561945,0.9943677),(17207,'okapi_radius.tif',236,3,116,452.2690567,95.5963805,111.0072439,1.8,96.1189258,110.5906731,0.3327107,19.7638547,23.4047489,39359.9882201,79416.5981803,8.040713,3393.1830918,1991.5137366,4856.9820987,0.9502202,7.6782313,1.849096,16.5130678),(17208,'okapi_radius.tif',236,3,117,453.5382741,95.6198255,110.8171209,1.8,96.0926368,110.3803573,0.337866,21.4435757,23.3635575,40152.0364139,80428.2736689,8.3054461,3442.4669079,1872.4506068,4587.3524702,1.1502103,9.2280856,1.8804993,20.199295),(17209,'okapi_radius.tif',236,3,118,456.0140494,95.5743738,110.6102974,1.8,96.0398447,110.1683794,0.3474991,22.099755,34.8257645,41051.4725602,81658.5970163,8.8141866,2344.7754318,1857.5532885,3254.5789753,1.1149321,10.3457254,1.7415315,21.8468172),(17210,'okapi_radius.tif',236,3,119,457.8404595,95.5694526,110.4071442,1.8,96.0048963,109.9402852,0.3488393,22.1421367,23.5920693,41996.7230453,82965.8375464,8.915084,3516.6833572,1896.6879086,4616.2032219,31.3418863,46.7260234,2.4574513,131.4367522),(17211,'okapi_radius.tif',236,3,120,462.1375512,95.6550515,110.2420032,1.8,96.0079909,109.8712063,0.3537669,30.7507153,23.2813118,43164.3303417,84613.5137254,9.244015,3634.3963054,1403.6854098,3921.021032,0.6680515,1.8932196,1.9513027,4.0981077),(17212,'okapi_radius.tif',236,3,121,467.7135607,95.8332982,109.9161355,1.8,96.3166719,109.4333714,0.3641387,22.4820413,24.0715727,44472.0065288,86455.7931975,9.8873853,3591.6138264,1978.1124863,4853.2576155,0.7031241,1.8932196,1.9513027,4.0981077),(17213,'okapi_radius.tif',236,3,122,469.0231527,95.9480297,109.7373423,1.8,96.3118036,109.2241611,0.3735284,22.8683323,24.775653,45023.3734704,87529.4426428,10.4087236,3532.8813653,1968.8087792,4794.5812757,0.8924182,5.6796589,1.9513027,12.2943231),(17214,'okapi_radius.tif',236,3,123,471.6834605,96.0406363,109.5272789,1.8,96.4179821,108.9402224,0.3823355,23.0950177,48.904543,46045.4343394,88790.9634462,10.942657,1815.597447,1993.7388595,2747.9577346,1.0975134,6.9249695,1.9890207,15.2774261),(17215,'okapi_radius.tif',236,3,124,474.4162778,96.1267428,109.3091404,1.8,96.4736364,108.6984399,0.39342,23.289557,24.977229,47069.5044898,89747.9903666,11.6197808,3593.1924392,2021.056242,4947.3427875,0.3515621,0.4971838,2.3561945,0.9943677),(17216,'okapi_radius.tif',236,3,125,476.0817885,96.2540465,109.0192132,1.8,96.5461118,108.3914404,0.4049756,23.789937,25.2891833,48138.1528301,91000.5931347,12.3172762,3598.3998336,2023.4670158,5006.9230615,1.6293426,10.0672054,1.7818897,23.8002188),(17217,'okapi_radius.tif',236,3,126,480.2200782,96.2699954,108.7017967,1.8,96.5932591,108.2456923,0.4203581,23.8552221,25.6472665,49092.1196061,92717.3285149,13.3289355,3615.0959279,2057.9191995,5069.4627233,2.2663475,13.3870844,1.8094056,32.5789213),(17218,'okapi_radius.tif',236,3,127,485.9198709,96.3453164,108.4243066,1.8,96.7387537,108.0225873,0.4256438,23.822365,25.7889329,50254.1799223,94691.5991998,13.8076058,3671.7920615,2109.5378218,5185.5297178,1.4785266,6.1397674,1.801887,14.9008793),(17219,'okapi_radius.tif',236,3,128,491.5734087,96.4157197,108.1542206,1.8,96.7497584,107.9203608,0.4305208,24.0551437,32.037167,51378.4282774,96469.1998762,14.2700581,3011.1651195,2135.8603796,4168.6473887,0.7821282,4.4469474,1.8925469,9.6024636),(17220,'okapi_radius.tif',236,3,129,497.1202047,96.6494033,107.7389821,1.8,96.9177803,107.2892074,0.4364499,21.9469658,26.9491393,52698.8016089,98358.3552687,14.8055881,3649.7772357,2401.1884837,5492.9558241,1.5592075,5.8193876,2.0074235,13.8711779),(17221,'okapi_radius.tif',236,3,130,504.3131854,96.7584651,107.4929411,1.8,97.0296887,107.0911933,0.4435902,21.357893,26.7978714,53484.7895524,99691.6910089,15.482393,3720.1346884,2504.2165662,5252.9806697,1.9399734,11.348432,1.8533513,31.5492199),(17222,'okapi_radius.tif',236,3,131,510.6681861,96.8415346,107.128746,1.8,97.0317494,106.6922186,0.4482148,21.6805807,27.8463595,54503.9781907,101290.1468425,15.9837951,3637.4645992,2513.9537982,5484.3444066,2.457834,16.6278077,1.8055189,47.7003766),(17223,'okapi_radius.tif',236,3,132,512.3879291,97.0114474,106.8035989,1.8,97.2752712,106.4892575,0.4538685,21.5235113,27.402333,55412.9672628,102634.385872,16.4164484,3745.4615919,2574.5319343,5524.4814058,3.081403,17.2408845,1.8603,47.9916202),(17224,'okapi_radius.tif',236,3,133,515.5121334,97.123158,106.4423369,1.8,97.4791076,106.0150556,0.4578394,25.1954074,41.7492828,56508.3968457,103593.418472,16.7862595,2481.3221122,2242.8054462,3811.7606611,2.376651,17.915873,1.849096,45.3350945),(17225,'okapi_radius.tif',236,3,134,519.5051793,97.2112589,106.0643291,1.8,97.5616271,105.5851956,0.4603663,32.0970659,46.5819388,58055.264542,104839.7708886,17.09011,2250.6527995,1808.7405477,3496.9330595,2.359232,17.2408845,1.8603,47.7003766),(17226,'okapi_radius.tif',236,3,135,522.3235774,97.3832918,105.72982,1.8,97.6487204,105.3924049,0.4620183,23.8495116,27.6271746,59502.0820945,106181.4204268,17.2974557,3843.3687894,2494.8972979,5659.1159758,2.1726582,12.6024089,1.9720251,41.201653),(17227,'okapi_radius.tif',236,3,136,528.8641591,97.5912135,105.3448665,1.8,97.9876726,105.1076015,0.4587652,22.3805554,27.4556852,61540.2413275,107617.644104,17.2857884,3919.6852397,2749.7191286,5945.4084607,0.3515621,0.4971838,2.3561945,0.9943677),(17228,'okapi_radius.tif',236,3,137,534.3405803,97.8542751,104.7633139,1.8,98.1391642,104.2534658,0.4596568,22.8477728,30.9145959,63359.9657642,109079.939609,17.5278811,3528.4284521,2773.135322,5566.8308453,38.3053959,51.6317692,2.2742528,213.975331),(17229,'okapi_radius.tif',236,3,138,539.6792483,98.0743691,104.3816345,1.8,98.3946511,103.8632914,0.4620314,22.283071,30.6300554,64723.6028556,109917.2504196,17.8731482,3588.5423323,2904.6087492,5684.4243534,0.4971838,0.9943677,0.7853982,1.9887353),(17230,'okapi_radius.tif',236,3,139,547.7481867,98.1723562,104.041648,1.8,98.4568224,103.5408416,0.4640592,23.8461163,33.7391063,66181.7966675,112077.472667,18.2883457,3321.8862276,2775.3700342,5054.7814958,0.3515621,0.4971838,2.3561945,0.9943677),(17231,'okapi_radius.tif',236,3,140,551.7419442,98.2829996,103.6723328,1.8,98.5597781,103.1482411,0.4640374,25.9022588,30.9766809,67617.3899675,114343.8862867,18.4200782,3691.2891554,2610.4823751,5325.5408004,1.9424273,9.1406136,1.9655874,27.4157784),(17232,'okapi_radius.tif',236,3,141,557.191399,98.5325056,103.3051017,1.8,98.7733522,102.7477755,0.4660997,25.3662194,28.52454,69335.6099994,116620.3651933,18.7555495,4088.4222966,2733.3836761,5657.6096857,1.8048329,13.2525375,1.9513027,32.9201343),(17233,'okapi_radius.tif',236,3,142,563.5573361,98.7779636,102.953841,1.8,98.9862778,102.3246456,0.4616118,26.0123211,29.0524485,71339.8125509,118808.4029609,18.6325092,4089.4454334,2742.5392825,6375.6669637,1.6908116,11.3211718,2.0205559,31.2226426),(17234,'okapi_radius.tif',236,3,143,569.0927462,98.9917589,102.5500412,1.8,99.1608648,101.9351649,0.4557687,33.3303653,30.1492847,73610.8446229,121673.3251019,18.3754716,4035.6952532,2208.5219899,5820.2344753,0.3515621,0.4971838,2.3561945,0.9943677),(17235,'okapi_radius.tif',236,3,144,570.782639,99.2684135,102.2388747,1.8,99.3735461,101.6949773,0.4465339,27.7994215,31.044704,75621.3832638,124542.6901119,17.7406329,4011.7209759,2720.2502488,6443.9625349,40.1237786,53.6555579,2.4443376,231.3974632),(17236,'okapi_radius.tif',236,3,145,588.034377,99.5759461,101.7056052,1.8,99.6372165,101.0459259,0.4320035,33.8966482,30.4437292,78799.7609726,128708.3033599,17.1806237,4227.7443309,2324.7065741,6035.3763123,40.8328,54.0262932,2.4668517,191.9579072),(17237,'okapi_radius.tif',236,3,146,589.7911614,99.8500801,101.3387969,1.8,99.946478,100.757476,0.415818,27.549962,30.0221046,81006.8602192,130827.9152723,16.0389997,4357.7196573,2940.3619633,6664.1978501,1.9699141,18.8044628,1.9339433,45.3350945),(17238,'okapi_radius.tif',236,3,147,593.7173156,100.0571618,100.9520503,1.8,100.1837195,100.40903,0.4049232,23.5085388,33.2968728,83152.2584806,133230.0531849,15.3570111,4001.2782536,3537.1087568,5992.2131594,1.9893372,20.4994146,1.957672,47.9063169),(17239,'okapi_radius.tif',236,3,148,602.1952816,100.2446133,100.5211808,1.8,100.3678985,99.9267815,0.3872333,42.281539,29.8595779,85559.6058711,136711.7590745,14.3124639,4578.4893322,2023.568866,4328.9885639,2.0126114,22.7186356,1.9513027,58.2119047),(17240,'okapi_radius.tif',236,3,149,606.1228965,100.403164,100.1315505,1.8,100.4619422,99.5999068,0.3605517,35.4319343,31.5792367,87646.2545618,139251.7059594,12.5731225,4409.596955,2473.6514213,5778.250704,2.2925367,10.4112242,1.7748143,31.5492199),(17241,'okapi_radius.tif',236,3,150,617.3018445,100.6354671,99.6905245,1.8,100.5420372,99.1355915,0.3352493,37.7993798,35.7470373,90607.3663822,143726.7303839,11.1365408,4020.661322,2397.0596037,5459.4173917,0.6292499,1.5722333,0.4636476,3.1890433),(17242,'okapi_radius.tif',236,3,151,627.1467434,100.9053958,99.2508853,1.8,100.8463996,98.7144834,0.3145377,42.0489351,45.6013786,93557.3421116,149206.4236442,10.0044629,3271.9717719,2224.9634096,4931.1006103,0.3515621,0.7861167,2.677945,1.4915515),(17243,'okapi_radius.tif',236,3,152,640.3333005,100.943054,98.706852,1.8,100.2489335,98.0097231,0.3211755,40.608544,49.2550322,98128.0888027,157850.1696116,10.6354284,3204.752133,2416.4394786,4820.7420758,0.3515621,0.4971838,2.3561945,0.9943677),(17244,'okapi_radius.tif',236,3,153,659.324407,101.2365553,97.8977894,1.8,100.2167403,96.6516042,0.304797,45.1393285,49.9102554,105202.5604995,167387.5809532,9.8964274,3353.7712789,2330.6186445,4949.9992904,0.3515621,0.7861167,2.677945,1.4915515),(17245,'okapi_radius.tif',236,3,154,662.06273,101.8186932,97.5400909,1.8,101.684441,96.8783761,0.2136962,41.4685813,35.1795518,104835.9322532,164107.9159155,4.9627296,4664.8665894,2528.0809917,5569.852904,0.3515621,0.4971838,2.3561945,0.9943677),(17246,'okapi_radius.tif',236,3,155,676.4061071,102.3121689,96.6818725,1.8,102.173825,95.9475759,0.1313525,24.3570916,30.6922558,110738.3819896,171805.8816528,1.9339004,5597.6948311,4546.4534024,8513.7584146,0.7796037,2.6774169,1.9756881,5.7955995),(17247,'okapi_radius.tif',236,3,156,689.8161105,102.7555497,95.7776162,1.8,102.6394569,95.1143624,0.0637803,25.0476906,31.2824893,117234.5008265,180958.3166077,0.4670527,5784.6520805,4680.4514937,8704.9029348,46.8948062,60.1263633,0.6610432,254.6798002),(17248,'okapi_radius.tif',236,3,157,711.6538924,103.1312777,94.8521825,1.8,103.0407916,94.2685106,0.0272503,25.5358377,30.9260921,124895.2392926,191707.9876781,0.088054,6198.9076106,4890.9787322,8933.3238892,0.7031241,1.5722333,2.0344439,3.3949836),(17249,'okapi_radius.tif',236,3,158,730.58204,103.253334,94.0926091,1.8,103.1574666,93.4955172,0.0162626,36.3418222,36.7753772,129513.0941087,202371.0956986,0.0322007,5502.8965354,3563.747941,7564.1686006,0.7682058,2.6774169,1.9756881,5.7955995),(17250,'okapi_radius.tif',236,3,159,768.8154524,103.5557979,92.9648519,1.8,103.2641763,92.489002,-0.0126519,27.019917,32.8383365,139783.5624844,222188.2481397,0.0205098,6766.123739,5173.3527771,9979.2484841,0.3515621,0.4971838,2.3561945,0.9943677),(17251,'okapi_radius.tif',236,3,160,801.6383615,103.4499813,92.1582924,1.8,102.9548244,91.7825322,0.0408928,27.1972466,33.0191087,146127.8074532,239195.2355837,0.2232948,7244.1457433,5372.889754,10673.1071148,0.6292499,1.5722333,2.0344439,3.3949836),(17252,'okapi_radius.tif',236,3,161,878.8070237,103.6233149,90.9410424,1.8,102.7142457,90.7794359,0.0904964,38.0138092,33.8309047,159097.3053144,275828.6366491,1.1962409,8153.1557987,4185.250269,11417.0230041,51.1738398,66.5381703,3.0887319,255.0210132),(17253,'okapi_radius.tif',236,3,162,916.320022,102.8787226,90.7878846,1.8,102.4406336,90.5644922,0.1695352,29.3053492,33.5786328,159598.3561235,300731.5750053,4.3476153,8956.0398841,5446.0485958,12297.9864237,50.8811426,67.6791209,3.0688048,249.2607475),(17254,'okapi_radius.tif',236,3,163,926.9224513,101.8219213,91.1269613,1.8,102.2852258,90.2354122,0.2050176,28.2361039,34.2778299,160783.8246675,298504.0386881,6.4029665,8708.3703822,5694.2638171,11715.7810677,0.3515621,0.4971838,2.3561945,0.9943677),(17255,'okapi_radius.tif',236,3,164,915.7882975,102.0794854,91.5255605,1.8,102.227573,89.7865599,0.1442882,28.0546315,34.8269605,173106.5635955,289077.0146323,3.1556539,8300.3802251,6170.3381771,11662.3434978,0.6680515,2.35835,2.0344439,5.0924754),(17256,'okapi_radius.tif',236,3,165,868.9418251,101.7910595,90.9297065,1.8,101.786276,89.517859,0.2177976,27.8013015,34.1759753,172566.446311,276092.7510436,6.7618834,8078.5624528,6207.135522,11559.9241518,0.3515621,0.4971838,2.3561945,0.9943677),(17257,'okapi_radius.tif',236,3,166,806.976992,101.9761608,89.5148707,1.8,101.6308663,89.2272242,0.18266,26.8148873,34.9228763,151502.2905672,263413.7564259,4.4377348,7542.7279956,5649.9320287,10471.1124377,0.3515621,0.4971838,2.3561945,0.9943677),(17258,'okapi_radius.tif',236,3,167,770.4440716,102.6722813,89.6378743,1.8,101.7796736,89.5224276,0.0429333,27.6394288,36.1056604,124856.1886269,255301.9380199,0.2365444,7070.9671286,4517.3215902,9915.3443373,49.970792,69.013701,0.1534239,281.4716954),(17259,'okapi_radius.tif',236,3,168,708.1801365,100.2510397,90.3770837,1.8,99.7971593,90.0905883,0.2273585,26.6042268,34.1886498,96049.8804134,199989.8148332,5.9967903,5849.5967601,3610.324066,8122.6978133,0.3515621,0.4971838,2.3561945,0.9943677),(17260,'okapi_radius.tif',236,3,169,722.0047854,100.3227318,89.5577711,1.8,99.496321,89.1593807,0.1985816,23.7215902,31.0417992,86261.9233521,194937.3167946,4.6832836,6279.8330599,3636.4308952,8375.9419077,0.3515621,1.1117369,1.8925469,2.4006159),(17261,'okapi_radius.tif',236,3,170,695.4978132,99.3498203,89.4368931,1.8,98.2258112,88.8137066,0.2975511,22.4065019,28.8930654,68752.6863945,173129.1114415,9.9635162,5992.0645062,3068.4257051,8144.0434377,43.6530009,58.267103,2.9595805,224.7160085),(17262,'okapi_radius.tif',236,3,171,649.4688714,98.3060322,88.9397775,1.8,97.3595188,88.4378948,0.3562462,21.7518631,28.6602861,56056.7797815,146931.434548,13.1660954,5126.6562405,2577.1024535,6819.7138602,41.4022488,56.7334467,3.0733757,184.3527524),(17263,'okapi_radius.tif',236,3,172,556.2709468,94.9774872,87.8414435,1.8,95.6951368,87.7543,0.4847048,20.5369933,29.5927938,43061.8044061,93218.6321532,20.1283659,3150.044997,2096.7920569,4495.6360768,38.845027,53.4212404,2.6102023,217.1875834),(17264,'okapi_radius.tif',236,3,173,435.5506911,90.6921585,85.6276181,1.8,92.7102432,85.8395688,0.6423706,17.8709855,30.34174,27447.0538313,40688.6402791,26.0542872,1341.0120946,1535.844445,2205.3240436,34.7720902,50.2291026,2.5302933,169.4226016),(17265,'okapi_radius.tif',236,3,174,277.8550793,87.7819739,82.5559008,1.8,89.497656,83.9783927,0.8600833,14.1570644,17.5510646,11980.0960349,16453.9860812,26.6003514,937.4921951,846.2274158,1581.047632,27.3145253,33.6344037,2.4227627,101.4729605),(17266,'okapi_radius.tif',236,3,175,136.9989195,85.4571771,79.2071654,1.8,86.9926246,79.7512162,-0.0210195,12.4437321,15.6658141,2288.8789682,5083.7776973,0.0100867,324.5141081,183.9383033,421.4695875,20.8387771,28.6172381,2.4956345,96.1745449),(17267,'okapi_radius.tif',236,3,176,33.7412265,80.3542912,79.2887009,1.8,81.1244958,79.4096171,-1.4859655,14.8495143,7.0149066,158.2703303,252.4030388,5.5831663,35.980955,10.6582833,27.5088855,9.8437377,13.308377,1.357858,38.3745208),(17268,'okapi_radius.tif',236,3,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17269,'okapi_radius.tif',236,3,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17270,'okapi_radius.tif',236,3,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17271,'okapi_radius.tif',236,3,180,0.0075656,105.8201802,130.0779624,1.8,105.8201802,130.0779624,0.7853982,0,0,0.0000779,0.0000779,0.0006305,0,0,0,0.3515621,0.4971838,2.3561945,0.9943677),(17272,'okapi_radius.tif',236,3,181,115.1949579,84.1962251,114.1181013,1.8,87.6715001,111.6625855,-0.2937109,15.2253105,33.3366595,3170.8663358,21180.2422506,1.609155,635.3438703,208.2628355,728.864969,17.7749719,28.6991805,2.6011732,81.6002429),(17273,'okapi_radius.tif',236,3,182,488.0330234,85.3651137,109.9651474,1.8,90.5720731,108.4114477,-0.1938101,20.748036,34.4536259,21956.5471275,70594.3063963,3.017215,2048.9659522,1058.2470115,2686.2431769,28.828089,29.5395824,0.9034902,95.6273916),(17274,'okapi_radius.tif',236,3,183,573.810813,87.0373214,109.164938,1.8,92.8050669,107.9668239,-0.1936553,16.62021,34.5189488,27613.0017216,97370.2669584,3.5419331,2820.7772906,1661.4111246,3620.6863549,0.3515621,0.7861167,2.0344439,1.6974918),(17275,'okapi_radius.tif',236,3,184,593.75593,87.6493887,109.3767842,1.8,93.4367412,108.2441081,-0.1744585,24.0542162,35.109931,29081.0674548,109027.2023207,2.9814695,3105.3095039,1208.9800462,3685.3378096,29.179651,29.6398302,1.1814796,96.1245754),(17276,'okapi_ulna.tif',236,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17277,'okapi_ulna.tif',236,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17278,'okapi_ulna.tif',236,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17279,'okapi_ulna.tif',236,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17280,'okapi_ulna.tif',236,4,5,40.7572778,126.2643232,50.7855154,1.8,126.4599675,50.4136045,-0.5011461,3.8075903,10.3014627,118.5586685,1007.0286937,1.5678917,97.7558937,31.1374546,108.3322858,8.0860138,20.9821003,0.5461666,52.9987923),(17281,'okapi_ulna.tif',236,4,6,83.2875573,125.9213301,50.417587,1.8,126.1736746,50.1500656,-0.5059202,5.412361,13.2968926,517.2394081,3888.5104505,3.2600048,292.4375306,95.5663169,328.8444176,10.9509465,26.9077067,0.5045604,68.7734022),(17282,'okapi_ulna.tif',236,4,7,121.3981229,125.4895989,50.4186608,1.8,125.3562583,50.417372,-0.5648701,11.4765788,15.6469223,1426.8988066,7697.9944199,5.7978253,491.9813807,124.3313741,576.8360824,15.2549266,30.6988372,0.5148848,82.6445801),(17283,'okapi_ulna.tif',236,4,8,196.7953191,124.5057426,49.1956516,1.8,124.2602299,48.9721348,-0.848334,12.9526932,16.9855005,5486.7422349,14799.0292543,18.4584083,871.274251,423.5985646,1180.154981,23.7940708,34.318292,0.6619416,108.1569264),(17284,'okapi_ulna.tif',236,4,9,323.6379529,123.886925,47.9119481,1.8,123.7923303,48.6053015,-1.1273501,14.5602519,21.3882286,12992.8509455,30542.2051931,44.0100071,1427.9913368,892.3506958,2030.8382241,28.1717142,39.5018736,1.2912742,116.3385061),(17285,'okapi_ulna.tif',236,4,10,373.5721127,123.2558998,48.4654242,1.8,123.4807644,48.8861261,-1.1986624,16.3662826,23.3519235,18500.963799,43161.003755,54.0304833,1848.2847353,1130.4316504,2633.7704996,30.6034709,43.4929302,1.2158099,123.5756876),(17286,'okapi_ulna.tif',236,4,11,414.6709646,122.8196031,49.2478463,1.8,123.1597628,49.4786091,-1.2238626,17.3601443,25.0910252,23836.7005221,57515.8501654,61.1217576,2292.2877675,1373.0704121,3229.0446844,32.2441345,46.9490039,1.2111492,130.0244417),(17287,'okapi_ulna.tif',236,4,12,454.3639695,122.5204567,50.0970007,1.8,122.8399221,50.1854033,-1.2404571,18.3135088,26.8195157,28553.6836503,72730.5353833,67.7599071,2711.8511809,1559.1596311,3754.8725768,0.3515621,0.7861167,2.0344439,1.6974918),(17288,'okapi_ulna.tif',236,4,13,477.8579362,122.2444759,50.9161522,1.8,122.7079389,50.686981,-1.270957,19.2087828,28.1022885,32077.2304913,85896.9914275,72.6948141,3056.5835016,1669.9252046,4179.9640679,0.7031241,0.9943677,2.3561945,1.9887353),(17289,'okapi_ulna.tif',236,4,14,491.934084,122.2068775,51.7933395,1.8,122.6278722,51.2324139,-1.2945929,19.3294198,29.5460908,33432.1535076,99267.6538554,75.8916571,3359.7559334,1729.5994277,4471.0936002,35.4144771,55.0079485,1.3056654,153.0862026),(17290,'okapi_ulna.tif',236,4,15,506.7991855,122.0490095,52.7619112,1.8,122.5072834,51.9951012,-1.3150708,19.3252649,31.3152941,34480.5842664,116255.9079636,79.0621595,3712.4322542,1784.2231122,4789.5500183,34.8749453,57.9811004,1.3258177,200.7719435),(17291,'okapi_ulna.tif',236,4,16,527.4397728,121.8444674,53.7402479,1.8,122.2786774,52.8334419,-1.3292679,22.7087982,77.6965006,35473.4111234,137629.4563549,82.8774554,1771.3726526,1562.0998857,2138.4685987,34.8609917,61.3976743,1.3397057,221.8803029),(17292,'okapi_ulna.tif',236,4,17,558.8792694,121.6515841,54.7882151,1.8,122.0593046,53.8893583,-1.3420798,25.6651011,74.8293079,36602.5371252,168453.7108133,88.3583064,2251.172911,1426.1598637,2629.6508907,34.591852,65.3640762,1.3649621,239.1111305),(17293,'okapi_ulna.tif',236,4,18,576.3765512,121.2646412,56.0619644,1.8,121.6629228,55.0375858,-1.350471,18.2774933,38.2028124,36221.3994189,197618.0846071,91.4745292,5172.8674412,1981.7487503,6087.2480132,0.3515621,0.4971838,2.3561945,0.9943677),(17294,'okapi_ulna.tif',236,4,19,592.3280605,120.6805658,57.5528569,1.8,121.0807698,56.5021804,-1.3596828,18.4625689,61.30969,35524.1817727,232225.5565433,94.3864188,3787.7463848,1924.1191167,4330.3806586,34.7713124,73.7585246,1.335066,317.5929977),(17295,'okapi_ulna.tif',236,4,20,604.5156632,119.9666792,59.4602381,1.8,120.3401133,58.2721973,-1.3616076,18.7296285,58.4559904,34837.3129306,273627.4649209,96.4076226,4680.9140222,1860.010891,5193.3330495,34.0012283,78.1970759,1.311642,299.6030141),(17296,'okapi_ulna.tif',236,4,21,615.4638613,119.1817827,61.7926101,1.8,119.5493968,60.4807243,-1.3599686,19.1790106,45.0382675,34253.8380375,317613.4896073,98.0850725,7052.0805417,1786.0065276,7762.9370956,33.9234618,82.2820469,1.3247814,325.1713922),(17297,'okapi_ulna.tif',236,4,22,632.37219,118.4571859,64.1266874,1.8,118.6654509,63.2133783,-1.3590414,19.5519866,51.4322399,34818.2567449,366998.109954,100.7396381,7135.5653704,1780.8040397,7312.2981963,34.2165494,86.1240947,1.314927,368.6676598),(17298,'okapi_ulna.tif',236,4,23,660.3819384,117.5086461,67.0398982,1.8,117.6875107,66.3543605,-1.3464847,20.1898052,49.7097013,36688.3103877,436131.4228898,104.6179857,8773.5675612,1817.1701001,8937.3830626,34.8388381,89.3659417,1.3888316,343.1406778),(17299,'okapi_ulna.tif',236,4,24,668.7242484,117.2667771,68.2004983,1.8,117.4245717,67.9244751,-1.3611483,31.1954219,46.2015268,37519.7445748,448892.2836302,106.6267298,9715.962102,1202.7323964,8725.3385378,34.812193,88.7476625,1.4317004,357.5443732),(17300,'okapi_ulna.tif',236,4,25,646.0151904,117.4945059,67.9449123,1.8,117.554669,68.1916254,-1.3697237,19.6596528,42.6779421,36779.7385187,396735.9700707,103.374462,9296.042649,1870.8234026,10016.6635484,34.5132645,84.9369864,1.5003736,357.8855863),(17301,'okapi_ulna.tif',236,4,26,602.4152822,117.6222769,68.5064979,1.8,117.5368033,68.5683661,-1.354107,19.6379358,40.8904411,33134.0903534,332383.0061715,95.7615439,8128.6236304,1687.2491397,8412.6435344,33.6882686,81.4054079,1.5016427,372.6451305),(17302,'okapi_ulna.tif',236,4,27,552.8730338,117.6703319,70.3146626,1.8,117.4125038,70.0842616,-1.3099887,19.271424,41.3322813,27820.0111868,265075.1520074,86.0185402,6413.2717521,1443.5887628,6598.7866793,32.3300367,78.275275,1.4943689,311.152817),(17303,'okapi_ulna.tif',236,4,28,506.473604,117.488547,72.2407278,1.8,117.268433,72.1700298,-1.2594473,17.378681,40.3356528,23426.5380182,210499.1743606,76.4905055,5218.6876813,1348.0043744,5362.3593172,30.7358684,70.3976143,1.3645861,222.0448471),(17304,'okapi_ulna.tif',236,4,29,478.7820214,117.1510767,73.058224,1.8,116.9056121,73.2945866,-1.240127,17.4054526,36.6313378,22521.4480065,186196.907958,71.385235,5082.9950331,1293.9306182,5535.2367687,32.2623502,67.7019446,1.329596,206.446906),(17305,'okapi_ulna.tif',236,4,30,458.589488,116.7743177,73.7281506,1.8,116.4574956,74.265248,-1.2205077,17.9134982,35.5880353,22043.862881,168637.55243,67.4306217,4738.6024843,1230.5727565,5233.1227403,33.3386438,65.4340015,1.2932347,208.3150043),(17306,'okapi_ulna.tif',236,4,31,444.0919157,116.3326865,74.4413399,1.8,115.9095961,75.3823812,-1.2020762,18.0982248,35.0027303,21953.8441242,155199.4976506,64.4004373,4433.9254787,1213.0385367,4953.5306441,33.6757507,63.9466166,1.2751268,298.4027061),(17307,'okapi_ulna.tif',236,4,32,431.9625528,115.7548053,75.3216494,1.8,115.2536811,76.6639542,-1.1810954,18.2474474,34.395783,22462.2120563,145313.9563869,61.6026839,4224.7608209,1230.9783139,4780.0724728,34.2005072,62.7338831,1.2809498,253.6854325),(17308,'okapi_ulna.tif',236,4,33,427.9323533,115.2810775,76.2392673,1.8,114.7414814,77.6308551,-1.1600136,36.8082159,34.5335027,23560.2507425,137327.4483688,59.948891,3976.6440626,640.0813022,4111.0652675,2.7345111,18.3958019,0.7853982,51.4365732),(17309,'okapi_ulna.tif',236,4,34,429.4900359,114.7684016,77.0537915,1.8,114.4467693,77.8662636,-1.1387016,38.8909723,34.04679,26095.7783812,132594.2476474,59.0282792,3894.4713312,670.9983544,4044.2095671,34.6938646,61.9567665,1.1808066,389.1728341),(17310,'okapi_ulna.tif',236,4,35,404.3818695,114.9343872,76.6313227,1.8,114.6821147,77.7017162,-1.1248015,41.1739599,32.2843519,23312.695842,113258.6985771,54.8565784,3508.1608267,566.1999933,3244.479874,34.5851774,60.8974092,1.1484689,271.6986253),(17311,'okapi_ulna.tif',236,4,36,373.57024,115.8964927,76.0960781,1.8,115.0591151,77.8671755,-1.2127368,23.7001863,30.4359719,22755.8955863,88136.1797658,54.6146965,2895.7898914,960.1568237,3527.7750661,0.3515621,0.4971838,2.3561945,0.9943677),(17312,'okapi_ulna.tif',236,4,37,374.2655605,116.1929715,77.1575181,1.8,115.6185721,78.3820378,-1.2980159,40.4176841,30.2959577,24195.9840003,82856.2808574,57.8501145,2734.8955845,598.6484519,2515.4931152,0.4971838,0.9943677,0.7853982,1.9887353),(17313,'okapi_ulna.tif',236,4,38,395.3080965,115.2880611,77.9356018,1.8,115.1839203,77.830688,-1.2343282,32.345473,31.5775069,29701.9249678,77799.0818504,58.7030837,2463.7499741,918.2714692,3113.7390453,0.7031241,2.8343839,3.0172377,6.0015398),(17314,'okapi_ulna.tif',236,4,39,327.4496125,115.9956153,76.7585185,1.8,115.3532743,77.6730491,-1.2170545,40.8519174,29.3474839,20609.3611174,57987.9335301,48.0259361,1975.9081788,504.4894442,1790.5533671,0.3515621,0.4971838,2.3561945,0.9943677),(17315,'okapi_ulna.tif',236,4,40,287.6963078,116.438667,75.733095,1.8,115.8020276,76.2343408,-1.1981084,42.1783151,29.7520012,16572.5390347,45289.5311687,41.5920869,1522.2347881,392.9160992,1381.9082173,0.3515621,0.4971838,2.3561945,0.9943677),(17316,'okapi_ulna.tif',236,4,41,254.3918617,116.8488785,75.3611814,1.8,117.4836551,76.0318066,-1.1879318,46.8806467,35.7997681,14811.5282035,35889.990526,36.4814302,1002.520196,315.9412091,1003.1832155,1.2269075,3.5156206,0.9272952,7.7843348),(17317,'okapi_ulna.tif',236,4,42,251.4892311,117.8344912,75.9139197,1.8,121.0672163,78.4245829,-1.3207159,40.0698863,23.5614188,18319.0876796,30138.6146595,39.3477006,1279.1510948,457.1784295,1160.879437,1.4180437,3.8027251,0.5880026,9.1552493),(17318,'okapi_ulna.tif',236,4,43,222.9762978,115.7103398,74.8200526,1.8,112.9260318,75.5763591,-1.0248173,37.6661699,21.0748879,11396.5883755,24765.1034391,27.1426899,1175.1001241,302.5682834,952.5359288,0.3515621,0.4971838,2.3561945,0.9943677),(17319,'okapi_ulna.tif',236,4,44,183.8130697,116.3432491,74.2664499,1.8,115.6143168,74.8610421,-1.103269,35.8407651,19.1440837,3975.5310405,18500.5244676,24.4130473,966.3833887,110.9220473,617.9818287,0.3515621,0.7861167,2.0344439,1.6974918),(17320,'okapi_ulna.tif',236,4,45,169.5441124,116.3008905,74.2225879,1.8,116.0407233,74.418657,-1.0996835,20.7427561,18.9153096,2520.3867877,15729.4817303,22.436185,831.5741088,121.5068421,676.8734733,20.9571319,38.2960669,0.75943,153.2921429),(17321,'okapi_ulna.tif',236,4,46,160.4608637,116.1717811,74.5126601,1.8,115.8712494,74.6147562,-1.0964894,28.591117,18.9438303,2011.7213789,13771.8253604,21.1649227,726.9820892,70.3617623,490.9581894,0.3515621,0.4971838,2.3561945,0.9943677),(17322,'okapi_ulna.tif',236,4,47,151.9193396,116.1177745,74.762744,1.8,115.735436,74.9297126,-1.1031712,19.9412762,18.4485005,1593.3272862,11961.232267,20.1751047,648.3579673,79.9009688,528.7120001,17.1962178,35.3874763,0.8557046,147.4258759),(17323,'okapi_ulna.tif',236,4,48,142.9944434,116.154345,74.8297132,1.8,115.8257971,74.8373062,-1.1129901,32.724795,18.5773855,1290.2136648,10148.3275731,19.1768072,546.2731877,39.4261802,323.3316707,0.7031241,2.5594104,1.2924967,5.5043559),(17324,'okapi_ulna.tif',236,4,49,134.9527335,116.2615234,74.856747,1.8,115.9297867,74.825904,-1.1306676,14.2984752,17.196266,1035.8810913,8294.9610817,18.4092701,482.3698969,72.4469622,460.0884662,13.9910727,31.8527644,0.9184654,135.0815833),(17325,'okapi_ulna.tif',236,4,50,128.2670203,116.2330341,75.0522535,1.8,116.0246115,74.8666543,-1.1456649,15.1884007,15.5663503,872.1741979,6946.3787007,17.7413134,446.2432474,57.4237023,359.4979104,12.4420367,29.9653815,1.0283648,129.5418936),(17326,'okapi_ulna.tif',236,4,51,122.7527338,116.1251044,75.3495771,1.8,115.9529685,75.066771,-1.1499597,16.7725247,17.0098951,778.8313115,5915.3249563,17.0443793,347.7578733,46.4349479,280.2266071,11.9473592,28.3982945,1.0240075,121.842862),(17327,'okapi_ulna.tif',236,4,52,117.8659773,115.9919684,75.7156573,1.8,115.8177832,75.4679888,-1.1487903,17.2458266,16.4642786,695.9959724,5136.7559509,16.3486983,311.9939895,40.3573564,244.6311219,11.7917239,26.9077067,1.0662359,102.2260542),(17328,'okapi_ulna.tif',236,4,53,113.3674992,115.8384803,76.1292127,1.8,115.6356029,75.9527978,-1.1481825,9.6998558,13.0234953,629.6469586,4549.4470524,15.7161464,349.3261176,64.9130226,397.1763925,12.1213318,25.8152861,1.0584069,115.4294417),(17329,'okapi_ulna.tif',236,4,54,109.9022452,115.6916841,76.59503,1.8,115.5575397,76.4576299,-1.1434084,15.18283,15.0777306,588.9693421,4092.6031444,15.1700593,271.4336297,38.7918025,218.7898453,12.1213318,24.9014165,1.0376406,108.2629277),(17330,'okapi_ulna.tif',236,4,55,106.593471,115.5393178,77.1026329,1.8,115.3888201,76.9507183,-1.1411949,7.7626155,12.1372572,523.2336415,3692.5025549,14.6836182,304.2287485,67.4042971,346.6177764,10.7743653,23.9398017,1.0480072,103.7882732),(17331,'okapi_ulna.tif',236,4,56,104.1243249,115.3886056,77.6628938,1.8,115.261301,77.5646672,-1.1387623,9.9030467,11.9214804,501.1305665,3377.9914675,14.3114467,283.3533557,50.6036759,324.3927241,0.9153203,2.5351501,0.9827937,5.3837189),(17332,'okapi_ulna.tif',236,4,57,100.8075358,115.3454802,78.1820164,1.8,115.2584243,78.2085721,-1.1383576,13.1245612,14.4275576,497.4262637,3048.4261743,13.8503963,211.2919081,37.9004111,181.8006947,11.758443,22.3705102,1.0438531,107.3038938),(17333,'okapi_ulna.tif',236,4,58,97.6864776,115.2281868,78.7310269,1.8,115.1850346,78.7574448,-1.1413334,9.138901,11.0708251,469.3987793,2799.0514045,13.4583562,252.8313274,51.3627162,293.7560437,0.3515621,0.7861167,2.0344439,1.6974918),(17334,'okapi_ulna.tif',236,4,59,94.4927974,115.0911451,79.3140797,1.8,114.9759172,79.4446496,-1.1402087,9.0056637,10.6981877,451.7042503,2551.399636,13.0049364,238.4889576,50.1577967,279.9263056,0.3515621,0.4971838,2.3561945,0.9943677),(17335,'okapi_ulna.tif',236,4,60,90.8227113,114.9782825,79.8788463,1.8,114.9020383,79.9558468,-1.1442967,7.896146,10.4766661,416.4181973,2316.9446243,12.5466045,221.1528551,52.7368919,259.9038406,3.5280439,17.2945666,1.1071487,44.8878801),(17336,'okapi_ulna.tif',236,4,61,87.7476832,114.8325327,80.5004943,1.8,114.7185388,80.6027836,-1.146689,8.3556165,9.9994656,389.7057307,2126.8020069,12.1481071,212.6915664,46.6399734,250.6454487,0.3515621,0.4971838,2.3561945,0.9943677),(17337,'okapi_ulna.tif',236,4,62,84.8293223,114.6631683,81.1643451,1.8,114.5642276,81.2465746,-1.1532017,12.352548,11.3007647,367.6987335,1971.4941354,11.8127475,174.4567021,29.7670355,139.7204963,0.4971838,1.4915515,0.7853982,2.983103),(17338,'okapi_ulna.tif',236,4,63,82.6400647,114.4908534,81.8648816,1.8,114.4217882,81.9853404,-1.1556131,9.0383282,9.6812198,342.6122194,1856.222604,11.532457,191.734372,37.9065918,217.5685739,0.9438749,1.4915515,0.7853982,2.983103),(17339,'okapi_ulna.tif',236,4,64,80.4586723,114.2908416,82.56518,1.8,114.1459306,82.5561627,-1.1531125,9.6855434,9.5773883,315.5786973,1749.750426,11.2032333,182.6959886,32.5824464,188.4830393,2.8316247,12.6024089,1.1695675,40.7897724),(17340,'okapi_ulna.tif',236,4,65,78.1294142,114.1714906,83.2447446,1.8,114.0480624,83.3178954,-1.1582358,8.3251593,9.4668004,317.2800735,1639.8142884,10.9281439,173.217372,38.1109911,205.6351623,0.7457758,2.4859192,0.7853982,4.9718383),(17341,'okapi_ulna.tif',236,4,66,75.9646136,113.9817818,83.9723343,1.8,113.8422947,84.1394366,-1.1566807,7.9300037,9.4225371,296.813201,1555.4034889,10.6108634,165.0726836,37.4291377,195.1201645,2.9534923,13.6793335,1.1186425,34.3263826),(17342,'okapi_ulna.tif',236,4,67,74.3425862,113.7872492,84.7331255,1.8,113.674696,85.0017417,-1.151609,9.8227846,9.2273021,302.4277899,1481.7138583,10.3377839,160.5793166,30.7883967,141.3122184,10.7743759,18.6824723,1.2252407,86.6220507),(17343,'okapi_ulna.tif',236,4,68,72.7878249,113.5680165,85.4731722,1.8,113.3976501,85.7099587,-1.1385038,9.1406168,9.1927693,290.7539965,1414.1693373,10.0019928,153.8349643,31.8090126,166.9298022,4.255916,13.0504837,1.0951011,36.6916647),(17344,'okapi_ulna.tif',236,4,69,71.5223529,113.324186,86.2466692,1.8,113.0954641,86.5510637,-1.124467,12.5106701,14.0450474,285.7000424,1362.3552973,9.6992885,96.9989817,22.8365099,87.6203562,11.2189494,18.3520783,1.218752,80.5352077),(17345,'okapi_ulna.tif',236,4,70,70.7093541,113.066581,87.0260715,1.8,112.7970623,87.2680435,-1.1083554,12.7155222,15.0054989,279.7954439,1328.3244816,9.4392799,88.5225135,22.0042432,83.7911294,4.4555416,13.5248625,1.0838971,35.4913568),(17346,'okapi_ulna.tif',236,4,71,70.3776303,112.8130055,87.8408083,1.8,112.6007505,88.0969683,-1.0873043,13.4825472,15.0767772,265.439262,1323.3527539,9.1947476,87.7742462,19.6876197,78.5522311,0.9943677,2.0499415,1.0303768,5.966206),(17347,'okapi_ulna.tif',236,4,72,70.7783431,112.5382564,88.6475345,1.8,112.3838375,88.8091538,-1.076337,13.4573841,14.3832495,254.0873221,1340.0215044,9.1398054,93.1654217,18.880885,80.9307988,3.1243194,13.6928797,1.0612041,36.897605),(17348,'okapi_ulna.tif',236,4,73,71.7828406,112.2705585,89.5276963,1.8,111.9359193,89.8756881,-1.0358055,13.5076004,14.6839894,300.339796,1378.5964043,8.8540567,93.8843232,22.2348742,84.1495589,0.3515621,1.1117369,1.8925469,2.4006159),(17349,'okapi_ulna.tif',236,4,74,71.4511916,111.9514275,90.291597,1.8,111.4323529,90.6041526,-1.0029393,12.8631996,14.1151964,303.5153217,1367.2796538,8.4638995,96.8657901,23.5956319,87.4892872,4.8849417,14.0492927,1.017502,44.4406658),(17350,'okapi_ulna.tif',236,4,75,71.2303295,111.6262305,91.0521946,1.8,110.8740899,91.4247253,-0.9487597,13.7682733,15.4982688,328.0999585,1377.7351324,7.8409235,88.8960663,23.8301456,82.2854779,4.6387654,14.6310652,0.9561334,39.1422501),(17351,'okapi_ulna.tif',236,4,76,70.7690922,111.3916681,91.7917881,1.8,110.8946034,92.1488415,-0.9448304,10.5797433,11.0771174,308.5113431,1339.3147963,7.7461993,120.908242,29.1605697,107.5762444,4.9711497,14.7236944,0.9894161,46.1381576),(17352,'okapi_ulna.tif',236,4,77,71.5432893,111.0508955,92.5979147,1.8,110.3465103,93.2833113,-0.9099054,10.3199869,11.8584286,346.1862502,1389.8860135,7.4312544,117.2065925,33.5452217,110.4358127,5.9628126,16.388223,0.6177557,50.030325),(17353,'okapi_ulna.tif',236,4,78,70.8139238,110.8374054,93.2240007,1.8,110.1316141,93.9201075,-0.8703523,10.9870646,11.64095,350.272057,1337.4528021,6.8989992,114.8920664,31.8804039,109.5867157,0.3515621,0.4971838,2.3561945,0.9943677),(17354,'okapi_ulna.tif',236,4,79,68.888637,110.6772739,93.7817415,1.8,109.9988844,94.2277195,-0.8610681,9.7568569,10.7860591,298.24162,1234.4366037,6.6062071,114.4474166,30.567387,108.1734005,5.1350281,15.7105371,0.7061991,43.3256611),(17355,'okapi_ulna.tif',236,4,80,67.636386,110.5837157,94.367797,1.8,110.1962187,94.7968912,-0.8830403,9.3615059,8.2782236,282.4593665,1135.0129106,6.7300765,137.1082687,30.1724283,131.9561183,0.3515621,0.7861167,2.0344439,1.6974918),(17356,'okapi_ulna.tif',236,4,81,68.9541053,110.4528145,95.1056968,1.8,110.248924,95.8053527,-0.9156476,9.6538542,8.3387901,344.4836685,1127.8726109,7.2261753,135.2561452,35.6835374,140.2190758,15.6796448,18.6327892,2.5849933,112.8521569),(17357,'okapi_ulna.tif',236,4,82,67.3790069,110.3677408,95.6042397,1.8,110.2661715,96.1287006,-0.9305761,9.7919489,8.0840721,350.2354555,1020.7500479,7.2224297,126.2668165,35.7676962,131.0118745,15.1218834,18.576321,2.6271413,108.2921992),(17358,'okapi_ulna.tif',236,4,83,65.6307993,110.2333925,96.0860649,1.8,110.0915558,96.420552,-0.9350502,10.3718429,7.912891,352.1467037,921.7048883,7.0818659,116.4814336,33.9521824,117.5716005,12.4225194,16.0336969,0.266252,65.2224478),(17359,'okapi_ulna.tif',236,4,84,65.0340185,110.0581396,96.6406663,1.8,110.1008047,97.054182,-0.94656,10.1531471,7.8888434,348.9640961,886.1064647,7.1362443,112.324002,34.3700424,117.5593488,12.2958747,15.5205791,0.2284966,67.2111832),(17360,'okapi_ulna.tif',236,4,85,62.3254335,109.9505931,96.9572429,1.8,110.0443631,97.3548601,-0.9293382,9.7418749,7.7272865,317.0324268,811.1063395,6.6684072,104.9665157,32.5432659,110.9621646,4.8556818,10.2195167,0.8584387,28.4954493),(17361,'okapi_ulna.tif',236,4,86,59.4162486,109.8449872,97.1851818,1.8,109.920049,97.5147376,-0.8970628,9.826389,7.7081044,288.5175035,734.8301601,6.0479677,95.3321489,29.3614981,101.8321355,3.7288788,9.6982713,0.8110336,25.5976496),(17362,'okapi_ulna.tif',236,4,87,57.7198763,109.6012588,97.4802167,1.8,109.5394775,97.5340153,-0.8411116,7.6520306,7.6039659,230.9924484,710.5386409,5.3448433,93.4431651,30.1870785,113.4559499,3.5047186,8.4958811,0.4266275,21.4142386),(17363,'okapi_ulna.tif',236,4,88,55.3320788,109.5447622,97.7031747,1.8,109.4379466,97.6919997,-0.8270491,8.2256985,7.5249659,211.2095737,631.4133945,4.9946684,83.9091371,25.6767948,95.0308719,3.8914635,9.1406136,0.3947911,26.5920173),(17364,'okapi_ulna.tif',236,4,89,52.3124441,109.6252672,97.8056316,1.8,109.5804551,97.9238085,-0.801022,8.2581102,7.0619634,213.6562338,540.7274266,4.4955682,76.5689927,25.8722915,85.8316411,4.0097506,9.6982713,0.7597628,27.4657479),(17365,'okapi_ulna.tif',236,4,90,50.4847981,109.6174568,98.0532713,1.8,109.6253467,98.2763812,-0.8212529,9.2166701,6.997728,223.9905665,478.8713772,4.5084944,68.432408,24.3027649,73.839265,3.9500782,8.7042677,0.7568345,25.0151625),(17366,'okapi_ulna.tif',236,4,91,48.5041554,109.5540985,98.2432402,1.8,109.5948691,98.4515079,-0.8019181,8.6817368,6.6765238,211.0777248,431.5303152,4.1755363,64.6339815,24.3128453,70.7696561,11.5894097,17.2587971,2.5592397,92.432286),(17367,'okapi_ulna.tif',236,4,92,47.2259867,109.4658668,98.4535494,1.8,109.4698561,98.6260308,-0.7872101,9.3063924,6.6320738,199.8348714,401.5842539,3.9497604,60.5518372,21.472861,61.8873676,4.4068742,8.0168484,0.266252,24.8092222),(17368,'okapi_ulna.tif',236,4,93,47.1280088,109.3884133,98.7453612,1.8,109.4540292,98.9259055,-0.8274453,9.5518805,6.6488107,205.4830509,390.255598,4.2572114,58.6955492,21.5123138,60.8404998,3.0159887,7.7423513,0.6889244,18.8430162),(17369,'okapi_ulna.tif',236,4,94,45.0403246,109.2391138,98.7942295,1.8,108.9149029,98.6624743,-0.7244012,9.2172742,6.5272841,175.2261578,358.9469588,3.2966083,54.9917778,19.0106265,55.1409711,4.0387456,8.2971626,0.6350267,25.306406),(17370,'okapi_ulna.tif',236,4,95,42.7343625,109.219986,98.8105586,1.8,108.9410097,98.8113348,-0.643653,6.8390908,6.082224,151.90206,321.5069304,2.5651007,52.8600933,22.2108559,58.239746,4.2260626,7.4743119,0.71883,22.2379998),(17371,'okapi_ulna.tif',236,4,96,40.0749536,109.2266784,98.7940255,1.8,108.9802242,98.8084384,-0.5564049,6.8311399,5.9058094,131.2332584,281.9630172,1.8630079,47.7433316,19.2110337,51.1321182,3.2316949,6.9783077,0.7140907,20.540508),(17372,'okapi_ulna.tif',236,4,97,38.2162588,109.2017528,98.7159802,1.8,108.7318057,98.5537959,-0.4898727,7.5650935,5.7709078,119.1016385,267.221125,1.4100719,46.3048685,15.7435779,41.6256737,4.2762574,7.2476375,0.2449787,22.9411239),(17373,'okapi_ulna.tif',236,4,98,35.1759874,109.1966611,98.6051366,1.8,108.7282295,98.4902615,-0.4080496,6.9966095,6.1117038,97.6468693,246.1034886,0.9231704,40.2675746,13.9563127,37.2535571,8.4374895,14.8199151,2.7522759,68.6880989),(17374,'okapi_ulna.tif',236,4,99,33.2052698,109.2312182,98.5262598,1.8,108.8697622,98.4555181,-0.3693574,6.242809,6.1947013,85.9715104,231.3178929,0.7212888,37.3412507,13.7712863,36.2304723,4.1364901,8.2747881,0.2140607,23.4383077),(17375,'okapi_ulna.tif',236,4,100,31.3367622,109.2475302,98.4375017,1.8,108.8977997,98.4522135,-0.3431723,5.2090775,6.3959921,74.1906359,219.9408794,0.5913047,34.387297,14.2425671,36.6181001,3.5210803,8.2747881,0.2140607,22.0320595),(17376,'okapi_ulna.tif',236,4,101,29.9807656,109.3072691,98.3160604,1.8,109.0077197,98.3649773,-0.3243863,5.915644,6.5611778,67.1606965,212.0210961,0.5076094,32.3144871,11.353066,37.0555114,3.2421724,8.5610956,0.3347368,23.4383077),(17377,'okapi_ulna.tif',236,4,102,29.131175,109.3417649,98.2003831,1.8,109.0148673,98.2349624,-0.3291114,5.2536684,6.8251908,61.1263623,208.971238,0.5071722,30.6176404,11.6349868,31.806596,2.9440308,8.2298568,0.348771,20.661145),(17378,'okapi_ulna.tif',236,4,103,28.1648799,109.3992204,98.0516339,1.8,108.9941619,98.1184194,-0.3442401,4.9561786,6.6649677,53.0093298,204.5193691,0.5346337,30.6857254,10.6956053,33.3155537,2.8225167,8.6829424,0.3729877,21.9467562),(17379,'okapi_ulna.tif',236,4,104,27.4763384,109.5239184,97.8923579,1.8,109.1896212,98.0236885,-0.3637982,5.6827309,6.8473345,47.377107,200.4003387,0.5798077,29.2669123,8.3370316,30.6827933,2.7375861,8.2298568,0.348771,24.9298592),(17380,'okapi_ulna.tif',236,4,105,26.9412806,109.5153266,97.6087744,1.8,108.3746912,97.5873896,-0.258103,6.2522639,14.5338047,51.707648,235.6801933,0.2925416,16.2160011,8.270228,18.1642987,3.9844153,12.893272,0.192048,31.2579763),(17381,'okapi_ulna.tif',236,4,106,26.269331,109.5616742,97.455527,1.8,108.5533129,97.4823875,-0.2840956,6.4937679,14.4538441,48.2609464,238.8496967,0.3439626,16.5249947,7.4318866,18.1192808,3.9439484,13.2385408,0.1869793,36.0238744),(17382,'okapi_ulna.tif',236,4,107,26.0922893,109.5385558,97.2475164,1.8,108.1932241,97.2087798,-0.2715406,6.0109088,14.229072,49.4969381,262.518337,0.3128456,18.4494348,8.2345183,20.199606,3.5790995,12.2795349,0.2310907,28.6514201),(17383,'okapi_ulna.tif',236,4,108,26.0585439,109.5923777,97.0690599,1.8,108.192299,97.0921895,-0.2857676,6.1957813,14.2440629,49.8264055,275.8939314,0.3451204,19.3690476,8.0419891,21.0437218,3.7169589,14.2761903,0.1732457,38.21855),(17384,'okapi_ulna.tif',236,4,109,25.6332991,109.5807827,96.7974523,1.8,107.7481416,96.6895755,-0.2887053,5.9716576,14.2924238,44.2464577,297.3841056,0.3463081,20.807115,7.4094097,22.1298108,4.146319,15.6632636,0.1577687,39.418858),(17385,'okapi_ulna.tif',236,4,110,25.0354696,109.6847448,96.5294344,1.8,107.7877937,96.4489722,-0.2848164,6.3247794,15.5022842,41.186845,308.1235958,0.3294271,19.8760125,6.5119813,21.0828262,4.3414066,15.7890118,0.2017623,41.9047771),(17386,'okapi_ulna.tif',236,4,111,24.7911243,109.8544332,96.3025505,1.8,108.0528961,96.3082169,-0.3217714,5.6988312,14.2854898,36.3792777,308.6953915,0.4132371,21.6090169,6.3836384,22.5549986,4.2800286,15.4447419,0.2063239,37.9273065),(17387,'okapi_ulna.tif',236,4,112,24.1971899,110.1203352,96.0282575,1.8,108.4139115,96.1260137,-0.3381086,5.637003,13.8726326,34.1473785,301.1897429,0.4437246,21.7110733,6.0577187,22.5570198,4.4558115,16.1335963,0.1973956,48.0269539),(17388,'okapi_ulna.tif',236,4,113,23.5896599,110.3635824,95.5053936,1.8,108.0125603,95.6669947,-0.2486379,5.144299,17.8901024,37.7784935,355.6793706,0.2380877,19.8813491,7.3437593,21.1365618,4.7430716,19.8873534,0.1418971,57.4234773),(17389,'okapi_ulna.tif',236,4,114,22.9246392,110.4729914,95.1997943,1.8,107.6242645,95.3947125,-0.224116,5.0378626,19.1356265,38.3260264,391.290959,0.188718,20.4482962,7.6075966,21.719764,4.8461522,19.9401092,0.1593516,59.2562418),(17390,'okapi_ulna.tif',236,4,115,21.4197282,111.3251735,94.8627745,1.8,110.4551067,95.0163781,-0.3825349,6.1280935,13.0204502,26.9167346,228.0188971,0.4974125,17.5123666,4.3923505,17.8170123,0.7031241,1.8932196,0.3805064,4.183411),(17391,'okapi_ulna.tif',236,4,116,21.0126109,111.5166104,94.5379366,1.8,110.4965137,94.6331725,-0.3830337,6.4301725,14.1633245,24.5636275,233.2032096,0.4891687,16.4652875,3.8200573,16.5716988,0.3515621,0.7861167,2.677945,1.4915515),(17392,'okapi_ulna.tif',236,4,117,21.141188,111.7165397,94.2580817,1.8,110.5734197,94.4580257,-0.3678958,6.8083329,14.8742769,27.5893326,249.8070302,0.4557692,16.7945663,4.052289,17.1988076,1.0233575,2.4859192,2.9996956,6.086843),(17393,'okapi_ulna.tif',236,4,118,20.6234711,112.1502689,93.9100835,1.8,111.5511588,94.0333728,-0.4184341,6.8251285,13.6544283,22.0119845,223.9195792,0.5675037,16.3990446,3.2251385,16.2464682,0.3515621,0.4971838,2.3561945,0.9943677),(17394,'okapi_ulna.tif',236,4,119,20.2853053,112.5010992,93.5815305,1.8,112.10977,93.8362483,-0.4540237,4.3620632,10.3907836,17.9442769,211.9089963,0.6503364,20.3939381,4.1137132,20.3965027,1.470018,6.8261005,0.6022873,14.9508488),(17395,'okapi_ulna.tif',236,4,120,20.0907354,112.7821434,93.2252651,1.8,112.4448323,93.3942447,-0.4621454,3.7439259,8.5591035,16.3334181,210.1141593,0.6656716,24.5486177,4.3626446,26.2846902,0.7031241,0.9943677,0.7853982,1.9887353),(17396,'okapi_ulna.tif',236,4,121,20.1068029,113.1393795,92.7590718,1.8,112.7557082,92.9393881,-0.4607278,4.0020077,8.3036633,18.1466683,213.7480949,0.6624163,25.7414212,4.5343912,27.5803131,0.3515621,0.7861167,2.0344439,1.6974918),(17397,'okapi_ulna.tif',236,4,122,19.8053413,113.4569713,92.3927249,1.8,113.1564253,92.534935,-0.4698729,4.059872,7.9542374,17.4358232,204.3795743,0.6766935,25.6944272,4.2946732,27.5729933,1.7143917,7.1185892,0.5743048,18.4311356),(17398,'okapi_ulna.tif',236,4,123,20.2243313,113.7415905,92.0558212,1.8,113.3480028,92.3272283,-0.4675662,4.6893041,8.3629086,20.0698096,213.8133649,0.684742,25.5668661,4.2799122,27.7641935,0.7845703,2.2510956,0.6747409,4.6805948),(17399,'okapi_ulna.tif',236,4,124,20.5162049,114.120487,91.634926,1.8,113.7254065,91.7997421,-0.4734657,4.2779506,8.2524317,19.6783819,214.1111379,0.7109268,25.9452179,4.5999554,27.9715616,2.1470559,7.2391059,0.5070985,20.7111145),(17400,'okapi_ulna.tif',236,4,125,21.0702515,114.4636192,91.2552708,1.8,114.1116101,91.4927525,-0.4881916,4.353708,7.8009566,21.3787921,221.435127,0.7725363,28.3856375,4.9104791,31.0488398,1.9614257,8.3860633,0.5763752,19.5461403),(17401,'okapi_ulna.tif',236,4,126,21.4204773,114.8827601,90.7929182,1.8,114.4197978,91.0673733,-0.4874231,4.2719576,9.4469572,21.0272433,229.3164176,0.7831053,24.2741036,4.9221563,26.1598028,1.8312621,6.8261005,0.6022873,18.9283195),(17402,'okapi_ulna.tif',236,4,127,22.0146364,115.2455411,90.384476,1.8,114.8247053,90.7728006,-0.5055682,4.3370099,9.3177165,20.9589752,239.2540477,0.8605923,25.6773263,4.8325864,27.7064108,0.3515621,0.4971838,2.3561945,0.9943677),(17403,'okapi_ulna.tif',236,4,128,22.1261723,115.6785816,89.8930062,1.8,115.4595664,90.0318477,-0.5076056,4.2875876,8.9763873,19.9923919,232.6952971,0.8713277,25.9230455,4.6628532,27.881246,0.7457758,1.4915515,0.7853982,2.983103),(17404,'okapi_ulna.tif',236,4,129,22.8484966,116.2248078,89.3615823,1.8,115.8600613,89.6076008,-0.5091297,4.5248044,9.7104449,23.0261195,250.9817598,0.9047083,25.8465768,5.0888652,28.0493835,0.9786104,2.7457875,0.6947383,5.6749625),(17405,'okapi_ulna.tif',236,4,130,22.8738525,116.7504055,88.8214601,1.8,116.6100457,89.0161818,-0.5106864,4.6080791,9.1675208,24.5195393,238.5603879,0.9107688,26.022345,5.3209893,28.5394163,1.6926026,6.5394323,0.6327488,17.0248874),(17406,'okapi_ulna.tif',236,4,131,23.0326919,117.165428,88.3251772,1.8,116.7709478,88.6420767,-0.5019511,4.684868,9.9172502,25.9846424,241.5541348,0.88865,24.356967,5.5465047,26.8047646,1.6251906,6.2593845,0.6659692,14.2477247),(17407,'okapi_ulna.tif',236,4,132,23.1038532,117.725828,87.7010793,1.8,117.4710277,87.9131444,-0.5146557,5.285008,8.6879693,25.975501,233.5121135,0.9329933,26.8776404,4.9149407,29.8548454,0.7031241,0.9943677,0.7853982,1.9887353),(17408,'okapi_ulna.tif',236,4,133,22.9174856,118.2023161,87.1422133,1.8,117.9515471,87.3862794,-0.513798,5.1364342,8.6866702,26.5169061,220.1651275,0.9226611,25.3451694,5.1625126,28.1229579,0.9154959,2.2510956,0.8960554,4.6805948),(17409,'okapi_ulna.tif',236,4,134,23.2990223,118.5716345,86.6610731,1.8,118.0749633,87.0416214,-0.5326115,5.0945454,9.7060923,28.5837081,219.5736772,1.0012578,22.6222532,5.6106494,25.424634,0.3515621,0.4971838,2.3561945,0.9943677),(17410,'okapi_ulna.tif',236,4,135,23.2714942,118.9857346,86.1708922,1.8,118.7543736,86.4288482,-0.5479632,4.9007167,8.0142102,27.856972,202.7142311,1.0526031,25.2943491,5.6842649,28.7702868,0.9812986,3.3166298,1.012197,7.0812107),(17411,'okapi_ulna.tif',236,4,136,23.1299582,119.3942296,85.6402084,1.8,119.1469194,85.6941583,-0.5660237,4.3357365,7.6718658,28.4954561,184.3420132,1.108682,24.0283158,6.5722297,27.7388686,0.7031241,2.2234737,1.2490458,4.8012318),(17412,'okapi_ulna.tif',236,4,137,23.1734414,119.8898174,84.9901033,1.8,119.5101243,85.3163089,-0.5987742,4.848194,8.5316702,30.4197628,181.5655641,1.2269533,21.2813622,6.2744524,24.7840634,1.7401434,6.7532867,0.6747409,18.5164389),(17413,'okapi_ulna.tif',236,4,138,22.2950867,120.3198827,84.4274059,1.8,120.1537143,84.5788542,-0.620614,4.5479021,7.2729927,28.5176199,159.525897,1.2566353,21.9340103,6.2705,25.8244019,0.3515621,0.7861167,2.0344439,1.6974918),(17414,'okapi_ulna.tif',236,4,139,21.6696915,120.7392529,83.8577435,1.8,120.6286829,83.9366076,-0.6408215,4.1202223,6.7612365,27.1860805,147.469858,1.290898,21.8110782,6.5982072,25.8319129,1.4915515,6.9783077,0.7140907,15.5333359),(17415,'okapi_ulna.tif',236,4,140,21.3493535,121.165509,83.274899,1.8,120.9586556,83.2911536,-0.6510883,3.9107341,6.4010594,25.8482067,142.9115712,1.3069345,22.3262372,6.6095537,26.2894267,1.5572817,6.7165837,0.748378,15.5333359),(17416,'okapi_ulna.tif',236,4,141,21.1907762,121.6112266,82.7391279,1.8,121.4785955,82.7878997,-0.6548423,4.058813,5.0261792,25.0006551,140.3150442,1.310023,27.9168409,6.1595977,31.0366276,1.3893788,6.4633898,0.7853982,14.6242715),(17417,'okapi_ulna.tif',236,4,142,21.6281558,122.0260552,82.2242737,1.8,121.8799987,82.2510347,-0.6625196,4.2972033,5.1693643,26.6866582,144.4745657,1.3638521,27.9482268,6.2102387,30.2004015,1.7401434,6.4633898,0.7853982,13.8358441),(17418,'okapi_ulna.tif',236,4,143,22.5191323,122.396922,81.7476417,1.8,122.2702359,81.7672377,-0.6764456,3.911636,6.8449169,27.833401,155.4294149,1.4709032,22.7072755,7.1155396,26.6782773,1.6251906,5.7230157,0.7419473,12.3442926),(17419,'okapi_ulna.tif',236,4,144,23.8097355,122.7217924,81.3382281,1.8,122.5641308,81.4166059,-0.6717736,3.9620489,6.5257051,31.0710181,173.1723122,1.5371203,26.5369505,7.8421591,30.6156673,1.375658,4.781761,0.942,12.053049),(17420,'okapi_ulna.tif',236,4,145,25.1878671,123.1698882,80.8412215,1.8,123.0740649,81.02568,-0.6686383,4.9337176,6.5272187,40.5192328,187.8877158,1.6132765,28.7852645,8.2127183,34.7986754,5.3615818,11.4081753,0.5880026,27.827659),(17421,'okapi_ulna.tif',236,4,146,26.6513921,123.5752737,80.3826339,1.8,123.3155212,80.713556,-0.6909121,5.2042059,7.4634749,49.5879013,214.8135948,1.8037453,28.7819811,9.528428,35.4240892,1.4915515,6.7165837,0.748378,14.7449085),(17422,'okapi_ulna.tif',236,4,147,27.2054387,124.029712,79.9183331,1.8,123.8899313,80.2699697,-0.7149354,5.451563,7.6110246,61.0486782,227.6186461,1.9486815,29.9064393,11.1983809,37.908642,0.7031241,1.8932196,1.1902899,4.6805948),(17423,'okapi_ulna.tif',236,4,148,34.0877069,124.7461807,79.211884,1.8,124.4980288,79.3921213,-0.7319287,6.5462474,6.2838088,121.1641725,275.6768946,2.5374459,43.8709868,18.5089509,51.8513596,10.8984239,13.529431,1.9995744,66.7493331),(17424,'okapi_ulna.tif',236,4,149,30.209755,125.186713,78.9179235,1.8,124.8246208,79.1451873,-0.6818527,4.9054118,6.9953404,108.1925074,275.6183076,1.9998507,39.4002709,22.0557442,54.4043553,1.4915515,4.9966357,0.6857295,11.0586814),(17425,'okapi_ulna.tif',236,4,150,32.0278505,125.7628003,78.3058627,1.8,125.5330943,78.4731291,-0.6276245,38.5576765,25.7655814,185.9947641,316.591681,1.8407026,12.2873874,4.8238063,10.8376477,1.4915515,3.4802868,0.7853982,8.6580655),(17426,'okapi_ulna.tif',236,4,151,35.8004837,126.1322975,77.6299046,1.8,124.7392742,76.9920913,0.3026863,14.1248344,48.4975929,335.3727579,648.7058833,0.5301749,13.3760429,23.7434824,20.148692,9.5801733,13.782847,0.658806,38.9570079),(17427,'okapi_ulna.tif',236,4,152,38.7591444,125.9772121,76.6759933,1.8,123.6247955,75.9830819,0.3612331,10.353675,50.7920178,352.656586,1283.0616854,0.8069094,25.2610891,34.0610061,31.9211476,12.0158517,14.786518,2.646041,62.1040721),(17428,'okapi_ulna.tif',236,4,153,45.0686018,126.4384837,75.2144913,1.8,121.3925322,72.4177435,0.5172233,12.1571506,50.427412,498.0442863,3191.5024609,1.8365388,63.2890393,40.9671891,73.0510412,13.1824365,14.5675712,0.14531,55.775955),(17429,'okapi_ulna.tif',236,4,154,48.583444,127.3621306,74.9668377,1.8,125.8127129,74.676918,0.3197259,11.22084,50.9107446,391.8721693,1019.2457996,0.7999142,20.0202493,34.9236038,27.4639339,4.549266,6.5677213,1.2998495,24.844556),(17430,'okapi_ulna.tif',236,4,155,39.4218805,128.1768019,74.0915818,1.8,127.6397761,74.0488964,0.1395087,6.0527506,9.2398203,237.4623859,394.7175122,0.1270484,42.7191764,39.2321442,67.9404029,10.7852289,16.5495763,2.927532,71.2093519),(17431,'okapi_ulna.tif',236,4,156,29.745072,129.1256004,72.7813876,1.8,128.9048991,72.8399708,0.2083971,5.4771499,6.9278716,100.1952933,272.4715917,0.2122028,39.329769,18.293327,50.1123867,9.2361192,12.9649682,0.2186689,37.3448194),(17432,'okapi_ulna.tif',236,4,157,25.9232251,129.7261063,71.8045923,1.8,129.6650285,71.7777591,0.2739894,4.5293346,7.7542054,60.99487,218.8803081,0.3163083,28.2273033,13.4666294,35.800067,0.4971838,0.9943677,0.7853982,1.9887353),(17433,'okapi_ulna.tif',236,4,158,27.4673497,129.9029024,71.3136585,1.8,129.568271,71.2001431,0.2359368,3.7359009,8.362856,65.2745743,222.7907589,0.25014,26.6405113,17.4722448,33.4046611,2.5703005,7.3155326,0.614663,18.0545888),(17434,'okapi_ulna.tif',236,4,159,24.839439,130.4483278,70.9118489,1.8,130.2847636,70.8771385,0.289513,3.8539506,7.5012699,64.6906412,186.3373751,0.3374106,24.8407772,16.7855398,32.3609394,1.3296692,6.3378752,0.5880026,13.9564811),(17435,'okapi_ulna.tif',236,4,160,28.5423717,130.8694828,71.1959344,1.8,130.8017666,71.1869811,0.4621294,4.3661337,8.3238111,116.6081477,230.3085626,0.9456411,27.6686435,26.7074158,37.0411967,8.2488388,13.8544002,2.5183933,37.9273065),(17436,'okapi_ulna.tif',236,4,161,29.2593776,130.8463036,70.4003608,1.8,130.3805223,70.2964579,0.1120496,4.5706063,13.389534,105.1210039,313.8198198,0.06097,23.4376954,22.9993567,31.1902961,7.9660245,16.2062102,3.0764675,58.7090885),(17437,'okapi_ulna.tif',236,4,162,32.8631339,131.2973674,70.2384811,1.8,131.1973155,70.283158,0.141193,4.8738191,10.5451104,132.9996193,382.2874672,0.1084667,36.2525808,27.2885832,48.0676989,0.7031241,0.9943677,2.3561945,1.9887353),(17438,'okapi_ulna.tif',236,4,163,37.1823231,131.5746295,70.0828816,1.8,131.3664049,70.167242,0.2158525,5.1447779,9.997869,170.4714581,451.4908343,0.2842785,45.1587069,33.134853,60.4534802,0.3515621,0.4971838,2.3561945,0.9943677),(17439,'okapi_ulna.tif',236,4,164,43.4498703,131.6051486,70.3496921,1.8,131.1756308,70.3079517,0.1366005,5.9399173,9.4328919,246.682967,512.159414,0.1342886,54.2950582,41.5296971,75.265768,9.2237685,16.0105546,2.8059541,61.8981318),(17440,'okapi_ulna.tif',236,4,165,41.811326,132.1173353,70.5820466,1.8,131.6463029,70.4792846,0.1088006,5.4424368,10.0183589,242.6696281,471.7676186,0.0821658,47.0903091,44.5884142,70.3484785,0.3515621,0.7861167,2.0344439,1.6974918),(17441,'okapi_ulna.tif',236,4,166,43.9481115,132.1305032,70.733696,1.8,131.5751886,70.6034594,0.1583543,5.6178958,10.6614995,266.9163544,603.9646609,0.1821443,56.6491291,47.5118022,80.3006482,1.4915515,3.9774707,0.7853982,9.7730702),(17442,'okapi_ulna.tif',236,4,167,61.2749434,132.197454,71.4269208,1.8,131.6407755,71.219039,0.4825462,7.5817839,10.8029758,537.6852991,1143.0150628,2.1990513,105.8055747,70.9180464,144.0802327,12.4477842,19.9679823,2.6858189,56.6350499),(17443,'okapi_ulna.tif',236,4,168,85.5890999,131.4162215,71.6912724,1.8,131.063368,71.4638946,0.2585085,8.9765019,11.0730625,1070.2327174,1647.4524227,0.9322257,148.7801968,119.2260338,242.0219169,14.9431675,19.8157543,2.7017501,57.0822642),(17444,'okapi_ulna.tif',236,4,169,102.1666785,131.3391286,72.38673,1.8,130.9920238,72.7154091,-1.0436014,9.7563375,10.8991637,1397.4908208,2069.5530492,12.7176939,189.8818208,143.2392859,312.0816297,17.5088631,21.0995822,1.3864719,64.7959315),(17445,'okapi_ulna.tif',236,4,170,61.8556942,132.9492212,70.4809809,1.8,132.3456266,71.1676031,-1.1810591,6.6978886,8.6816976,455.6901222,795.9395313,8.8210502,91.6801724,68.0348914,144.0098231,12.2162862,17.62024,1.0714496,49.6744762),(17446,'okapi_ulna.tif',236,4,171,33.5216752,134.0262055,69.9426876,1.8,133.8956293,69.8238564,-1.3998602,5.4527725,6.6228213,131.8522581,240.058387,5.4252838,36.2471485,24.1807738,55.1482316,9.3206441,12.6220083,1.3460852,35.9739049),(17447,'okapi_ulna.tif',236,4,172,8.6512623,134.4223218,70.0883672,1.8,134.5138883,69.9947846,-1.5225899,2.657453,4.068711,11.1162714,27.1343414,1.4385289,6.6690265,4.1830548,8.8639819,5.2734309,8.3565348,1.3156139,22.1880303),(17448,'okapi_ulna.tif',236,4,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17449,'okapi_ulna.tif',236,4,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17450,'okapi_ulna.tif',236,4,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17451,'okapi_ulna.tif',236,4,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17452,'okapi_ulna.tif',236,4,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17453,'okapi_ulna.tif',236,4,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17454,'okapi_ulna.tif',236,4,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17455,'okapi_ulna.tif',236,4,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17456,'okapi_ulna.tif',236,4,181,55.7066492,94.3211165,112.9545983,1.8,96.8755642,110.7490392,-0.5209615,12.5832008,23.7722788,677.4997647,10265.560439,2.2999373,431.8290452,53.8416082,460.1490704,17.7749719,28.6991805,2.6011732,81.3943026),(17457,'okapi_ulna.tif',236,4,182,289.0482969,92.4717039,109.611619,1.8,97.4992303,107.4506057,-0.3782467,18.2708514,27.3842816,11199.0795259,33597.7321338,6.5698911,1226.8984306,612.9478757,1632.1532506,28.828089,29.5395824,0.9034902,95.6273916),(17458,'okapi_ulna.tif',236,4,183,363.0007321,93.9796983,108.5194548,1.8,99.4337226,107.0364289,-0.3028592,18.1504019,27.5633387,16308.273609,47277.7286164,5.3816886,1715.239548,898.5075734,2304.8490415,28.828089,29.6648392,1.0222469,95.5420883),(17459,'okapi_ulna.tif',236,4,184,379.3850143,94.7628242,108.7040038,1.8,100.0544031,107.3259431,-0.2599435,17.3012201,28.0713069,17600.1800746,53000.199501,4.177178,1888.0560033,1017.2797071,2513.5216172,29.179651,29.6398302,1.1814796,96.1245754),(17460,'okapi_femur.tif',236,7,1,0.0188604,35.7615975,166.3535028,1.8,35.757824,166.351616,0.4733869,0.0085053,0.8732745,0.0002388,0.0144815,0.0006533,0.016583,0.0280743,0.0168556,0,0,0,0),(17461,'okapi_femur.tif',236,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17462,'okapi_femur.tif',236,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17463,'okapi_femur.tif',236,7,4,0.0675219,77.3581128,172.570368,1.8,77.345728,172.570368,0.021189,0.0249672,1.1781363,0.000868,0.0409242,0.0000051,0.0347364,0.0347663,0.0354652,0.388672,2.7483261,2.9996956,5.5357156),(17464,'okapi_femur.tif',236,7,5,0.1171905,118.0691405,166.5811754,1.8,117.8000053,166.5783413,-0.0376732,12.6488575,42.8620769,2.5714256,66.3699928,0.0000277,1.5484549,0.2032931,1.6001229,0,0,0,0),(17465,'okapi_femur.tif',236,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17466,'okapi_femur.tif',236,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17467,'okapi_femur.tif',236,7,8,0.0278785,76.6564575,170.674874,1.8,75.9205973,170.627008,0.0649906,0.0128365,59.1148477,0.0003539,50.5348435,0.0000196,0.8548587,0.0275686,0.8548647,0,0,0,0),(17468,'okapi_femur.tif',236,7,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17469,'okapi_femur.tif',236,7,10,73.3528516,120.8546896,130.0857386,1.8,119.1744451,130.7161177,-0.4389252,9.9633043,66.1691536,1285.4996488,35701.5393455,2.2078812,539.549585,129.0234259,557.8628353,19.044928,21.3451359,2.9584818,67.0106142),(17470,'okapi_femur.tif',236,7,11,278.2847178,113.9323252,132.7728268,1.8,114.5465978,132.2654384,-0.4371132,14.5814488,86.0231911,10923.300415,232705.5428039,8.311657,2705.148922,749.1231178,2822.8191955,27.6549296,31.4079684,0.2119576,97.9481202),(17471,'okapi_femur.tif',236,7,12,450.1305832,110.9066154,133.382243,1.8,112.4952608,132.796347,-0.4324731,17.4193532,83.9479193,28592.247465,422140.660776,13.1782811,5028.6018294,1641.4069494,5352.0759237,33.9311728,37.4115728,0.4171695,126.5535941),(17472,'okapi_femur.tif',236,7,13,599.679988,110.0552809,133.6181929,1.8,110.7367014,133.5422161,-0.4370443,21.0461485,81.4027168,52055.7823961,574795.8358944,17.9056381,7061.1382375,2473.4113434,7691.1334819,38.478528,45.3698609,0.4521539,137.5307178),(17473,'okapi_femur.tif',236,7,14,768.1334163,107.9797317,134.781475,1.8,108.1059392,134.7928946,-0.4404144,32.9642086,68.0193606,84911.9997997,777882.2666387,23.2672626,11436.1890412,2575.8846728,12482.2057691,41.976576,52.8836784,0.2449787,154.6484664),(17474,'okapi_femur.tif',236,7,15,918.3827141,105.6861385,136.0356528,1.8,105.697905,135.7833252,-0.4305807,33.2626482,65.831578,122416.0623001,966782.1446988,26.6670182,14685.6899738,3680.2861139,16272.4171673,22.5037625,50.9694093,2.2860395,146.0747995),(17475,'okapi_femur.tif',236,7,16,1066.6921423,103.9736491,136.4194279,1.8,103.188541,136.6354726,-0.4156511,28.1978183,73.1866133,156355.9494759,1121144.9968737,28.9860903,15318.9899905,5544.9661968,17450.7365868,33.5492319,55.7361611,2.2673203,163.8984674),(17476,'okapi_femur.tif',236,7,17,1268.5292629,102.5804626,136.2002509,1.8,101.0031549,136.8090225,-0.3867348,31.3119202,63.6724256,186133.1551039,1277959.661718,30.0756667,20070.8493588,5944.4822858,22277.6587616,55.535231,108.9530187,0.1287797,402.0703873),(17477,'okapi_femur.tif',236,7,18,1250.3509509,101.8712995,136.0056308,1.8,100.0051315,136.906933,-0.3752974,35.4736845,70.0820422,197710.0675127,1301319.1683734,27.9991894,18568.5109616,5573.4291629,21208.3275389,57.3315669,110.35342,0.1164915,348.2517382),(17478,'okapi_femur.tif',236,7,19,1197.2986128,100.857588,136.1575176,1.8,99.053656,136.9877776,-0.3613912,36.6006408,69.9876178,198713.9108375,1294412.4684112,24.9468968,18494.8782335,5429.2467745,21169.981686,58.7531618,111.3156879,0.129552,343.399059),(17479,'okapi_femur.tif',236,7,20,1141.4506395,99.824391,136.3968119,1.8,98.1956022,137.0902611,-0.3486595,39.1630524,62.6076069,191801.9393267,1248256.6359716,22.2043923,19937.7790871,4897.5227278,22236.7922075,59.6927027,111.9429341,0.1183258,371.0938178),(17480,'okapi_femur.tif',236,7,21,1096.3411187,98.9218345,136.9833886,1.8,97.4052342,137.0045516,-0.3313276,36.9149588,58.9588675,184558.3742483,1186282.5721171,19.3356624,20120.5115021,4999.555194,21992.3783705,59.8135373,112.3927601,0.0900337,354.3761826),(17481,'okapi_femur.tif',236,7,22,1033.6026167,97.1896374,137.593148,1.8,96.1403584,137.2293494,-0.3138205,32.4291518,70.7563316,170127.0994514,1087013.4987138,16.4157573,15362.7735375,5246.1162305,17663.434387,59.4283107,112.3255356,0.0831412,341.6166922),(17482,'okapi_femur.tif',236,7,23,970.8007585,95.520549,137.8643116,1.8,94.5047264,137.7539635,-0.3118231,49.2979089,60.8696239,156489.2269962,990780.3370059,15.2290769,16277.089838,3174.358312,16023.5545794,57.9962353,111.6544461,0.0941266,335.6646825),(17483,'okapi_femur.tif',236,7,24,912.541773,93.7536858,138.4513717,1.8,92.5845416,138.5459102,-0.308923,55.9776264,56.5265411,143250.9242522,881098.8111004,14.0586111,15587.347016,2559.0746429,14451.8541588,56.3307461,110.6295979,0.0668019,338.5463797),(17484,'okapi_femur.tif',236,7,25,869.4558948,92.2893494,138.8949247,1.8,91.1215883,139.0038471,-0.3267006,37.4999962,55.644397,132169.5544635,768028.2994568,14.924147,13802.4372657,3524.5218119,16043.3042508,54.6004828,107.7070354,0.0288728,342.5502902),(17485,'okapi_femur.tif',236,7,26,840.6612191,90.7764955,139.4664446,1.8,89.6875899,139.5223778,-0.3488377,35.7523272,53.3026151,124703.4664099,679960.367417,16.3692343,12756.6042676,3487.9817997,14831.4708084,52.4599228,103.405015,3.1227979,314.0000603),(17486,'okapi_femur.tif',236,7,27,817.2039771,89.7608736,139.8045824,1.8,88.590152,139.9387964,-0.3685109,37.132858,51.3140851,118607.0130921,605944.2095043,17.6738492,11808.5357615,3194.1256165,13946.097871,51.3856279,97.1749958,0.0119994,324.3722746),(17487,'okapi_femur.tif',236,7,28,803.0457125,89.2810887,140.1124168,1.8,88.2083807,140.2798506,-0.3853369,36.7598068,64.2315058,114657.1250154,552163.8214328,18.9089531,8596.4639116,3119.0894354,10342.0447458,50.3599131,93.1394689,0.2358696,316.0491694),(17488,'okapi_femur.tif',236,7,29,791.8012807,89.1511591,140.3882821,1.8,88.1415136,140.542214,-0.4006644,28.6796206,48.2585212,111082.8513123,508711.5930205,20.0752748,10541.3837915,3873.2329441,12699.8474771,49.4434157,90.4403916,0.2741675,299.2143437),(17489,'okapi_femur.tif',236,7,30,779.6560383,89.3484229,140.6524322,1.8,88.4953676,140.8315149,-0.4173745,27.2658514,48.3062278,109155.7671507,471668.5547863,21.3519407,9764.1355212,4003.3874505,11410.7502747,49.007014,87.6444587,0.306324,298.3817556),(17490,'okapi_femur.tif',236,7,31,777.8495187,89.6158033,140.9161826,1.8,89.0546276,141.0827509,-0.4262783,26.8972496,48.0669763,111666.582679,441726.32685,22.1648071,9189.8089008,4151.5985546,10985.6030897,48.745666,84.8427443,0.3507279,280.6362147),(17491,'okapi_femur.tif',236,7,32,795.2591797,90.0485513,141.417702,1.8,89.6282408,141.750013,-0.4393307,51.7835579,59.2509381,115226.6278569,415678.0744027,23.9782355,7015.5526271,2225.1585759,7147.8837939,48.3044943,82.8819687,0.1080679,252.219356),(17492,'okapi_femur.tif',236,7,33,792.0848727,90.9239506,141.578533,1.8,90.7143176,141.9504206,-0.4416704,25.8115486,42.9799342,118013.9673109,387844.6524782,24.1207889,9023.8540336,4572.1381926,11625.0582125,47.5381944,80.9940599,0.1154267,277.5982635),(17493,'okapi_femur.tif',236,7,34,763.7085123,91.7653336,141.2387467,1.8,91.7013313,141.7948979,-0.4438229,25.7243827,42.5780885,116310.4856832,362667.1294566,23.4687828,8517.6940143,4521.410167,10941.4257494,46.9720715,78.8956293,0.0986883,257.2768312),(17494,'okapi_femur.tif',236,7,35,740.0844111,92.8911967,140.8788168,1.8,92.8456993,141.6158833,-0.4459095,26.1386511,47.2998345,114608.3534802,336044.1731686,22.9427738,7104.5528294,4384.6315176,9123.1417553,46.9665155,76.5002868,0.0915799,282.9777251),(17495,'okapi_femur.tif',236,7,36,722.7181014,94.459034,140.4031158,1.8,94.3269525,141.3893589,-0.4490085,35.2923446,38.6667942,113522.8019218,308490.2220401,22.6956299,7978.1690886,3216.6409788,9901.9397304,46.3117373,73.7914034,0.0949517,250.0301735),(17496,'okapi_femur.tif',236,7,37,696.4691612,96.4749245,139.7519522,1.8,96.0384563,140.9840607,-0.4552239,25.4576257,36.5358907,111472.4169539,272949.9278405,22.4383722,7470.7341842,4378.7436591,10251.6670842,44.9269314,70.8215419,0.1155057,241.879503),(17497,'okapi_femur.tif',236,7,38,693.0784179,97.8916805,139.3076361,1.8,97.7498776,140.5287176,-0.4255827,24.7860636,35.0864135,113981.3779857,257385.3723174,19.6887854,7335.7561204,4598.6075018,10357.2548429,44.3313376,69.0754457,0.0901505,221.047469),(17498,'okapi_femur.tif',236,7,39,704.0933668,99.4785449,138.8948448,1.8,99.3791534,140.0665851,-0.3551355,24.6697384,33.3536294,120004.9686448,254944.6790348,14.1883535,7643.6862764,4864.4605277,10410.1712611,45.1383862,68.88382,0.0508037,244.8945713),(17499,'okapi_femur.tif',236,7,40,715.5370683,100.7791838,138.5200237,1.8,100.660673,139.568515,-0.2836869,59.4166819,43.9254699,125229.571875,253181.0936293,9.3428098,5763.8789961,2107.6500371,5121.2436542,45.6412365,68.5397478,3.0791738,230.5642123),(17500,'okapi_femur.tif',236,7,41,725.4147655,102.0391129,138.1313921,1.8,102.0207417,139.1147367,-0.2090224,24.8601745,33.7717547,128260.25365,245289.9727959,5.2057921,7263.1693166,5159.2660247,10318.091235,46.0775428,68.2670033,3.0560874,254.9219163),(17501,'okapi_femur.tif',236,7,42,725.1552068,102.8095829,137.8399045,1.8,103.01909,138.6964661,-0.1482823,24.5917729,34.0734922,128959.7132328,233103.1600441,2.6379892,6841.1878205,5244.0185385,10110.6227107,46.5208703,67.1773201,3.0430754,287.508418),(17502,'okapi_femur.tif',236,7,43,724.6262472,103.6425913,137.4101375,1.8,103.8406749,138.2209587,-0.0775597,24.9078836,33.8273228,129180.5754095,221806.5839719,0.7250442,6557.0244842,5186.3328676,9956.0561641,47.2923706,66.0170576,3.0413382,273.67248),(17503,'okapi_femur.tif',236,7,44,722.5488161,104.3001219,136.7960657,1.8,104.4634041,137.6087175,-0.0178203,26.4095671,63.1456061,126981.8237856,211065.2013394,0.0382382,3342.5160434,4808.1751235,4938.8981528,46.9916071,64.5382805,2.9843646,267.7595338),(17504,'okapi_femur.tif',236,7,45,714.9216807,104.5846653,135.9738231,1.8,104.9122903,136.8443591,0.0130587,25.6036028,63.6570935,122947.0470648,195046.4490803,0.0203177,3064.0175079,4801.9432282,4642.8764762,46.6636102,62.6835279,2.9733859,218.5268217),(17505,'okapi_femur.tif',236,7,46,708.3070532,104.5730263,134.963826,1.8,105.0583972,135.9383234,0.0253345,35.4750269,31.7352074,117802.8796125,179687.4735087,0.0757535,5662.085994,3320.7270016,8169.3026612,46.0401426,60.9806426,2.9491971,232.5351944),(17506,'okapi_femur.tif',236,7,47,695.5507262,104.3343708,133.8648037,1.8,104.79408,134.848447,0.0171639,24.2728163,31.056243,111144.7006165,164392.4519208,0.0341491,5293.3786021,4578.9783584,8479.8581876,44.6433167,58.85526,2.9623298,211.7812874),(17507,'okapi_femur.tif',236,7,48,681.6268885,104.0581471,132.7964168,1.8,104.4898312,133.8092981,-0.0171038,53.8464211,29.1036129,105330.7142381,151061.5851109,0.0332312,5190.4753341,1956.1321279,4752.3078269,44.0640748,56.1762151,2.9957817,224.8789449),(17508,'okapi_femur.tif',236,7,49,662.9311071,103.7979749,131.6298479,1.8,104.2893068,132.7534948,-0.0619222,22.6631743,27.4672634,98085.2947954,136058.3564724,0.4231114,4953.4733266,4327.9592512,7997.0848807,43.2647345,53.6099729,3.025331,202.3588517),(17509,'okapi_femur.tif',236,7,50,641.1143037,103.6161674,130.7132055,1.8,103.9428022,131.9730344,-0.0946825,22.7100784,25.7829851,91988.4328904,124235.0581425,0.955048,4818.4900833,4050.5554912,7649.0436348,42.1431574,51.4487815,2.9975589,201.6205712),(17510,'okapi_femur.tif',236,7,51,625.5839944,103.4108242,129.8546988,1.8,103.7524052,131.0536985,-0.1403703,23.1542667,25.2769965,86648.3743461,114660.4852701,2.0409406,4536.1594081,3742.2206147,7519.8953714,41.9115404,49.5812038,3.0473842,210.8705722),(17511,'okapi_femur.tif',236,7,52,611.9823848,103.2808982,129.0818271,1.8,103.5767937,130.2181166,-0.1975768,38.6193181,30.613437,82300.0341284,105906.6187036,3.9300756,3459.4814874,2131.0587064,3819.0374088,0.388672,0.869097,2.0344439,1.8766744),(17512,'okapi_femur.tif',236,7,53,598.9369268,103.1684042,128.3741764,1.8,103.3301595,129.3367297,-0.262308,22.2269701,22.7348865,78801.769439,98127.771227,6.7122708,4316.1759827,3545.3221518,7074.8915107,41.0086272,46.2323669,3.0151522,175.2528216),(17513,'okapi_femur.tif',236,7,54,587.8578435,102.993422,127.6138832,1.8,103.1047275,128.5030747,-0.3712904,23.2436598,22.2470234,75036.7338687,91464.693494,12.8973152,4111.3227586,3228.2667393,6956.1874953,1.3424729,5.4135745,1.2036225,12.8147346),(17514,'okapi_femur.tif',236,7,55,580.43982,102.9451161,126.8458053,1.8,102.9239009,127.7044842,-0.5168903,20.4324194,21.9661797,71881.8632496,86439.6522952,23.6251567,3935.1245243,3518.0299422,7030.5504297,0.8021456,4.0578548,1.2793395,8.7393993),(17515,'okapi_femur.tif',236,7,56,570.9623101,102.9296963,126.0236614,1.8,102.8785922,126.7952974,-0.6399922,20.635359,22.5060786,68797.970223,82740.2600402,33.9375152,3676.3516948,3333.9846512,6725.8221581,39.0979844,41.9423733,1.0033564,158.4408788),(17516,'okapi_femur.tif',236,7,57,560.5959376,102.9698265,125.1118167,1.8,102.9432023,125.6061227,-0.7690442,20.9153069,21.2166295,65165.4222746,78656.8893247,45.1886033,3707.3225613,3115.6809015,6727.3475082,38.8672,41.5297442,1.0191413,147.9191127),(17517,'okapi_femur.tif',236,7,58,554.0748337,102.8611425,124.4789158,1.8,102.7454462,124.9111018,-0.8895392,19.7788329,21.0805187,62039.1995873,75762.641086,55.7205111,3593.9647483,3136.6461295,6359.0827928,1.511205,10.8271491,1.2036225,24.5301387),(17518,'okapi_femur.tif',236,7,59,554.3555416,102.6845262,123.8820424,1.8,102.5070348,124.1624785,-0.986936,19.6126623,22.0117488,59138.2985747,74082.9017582,64.3167623,3365.6072646,3015.312133,6052.2760652,3.2868616,21.4369433,1.1801893,49.931929),(17519,'okapi_femur.tif',236,7,60,555.3191133,102.6117258,123.2879271,1.8,102.4143482,123.463796,-1.052086,19.4684666,21.530094,56790.0836813,72753.8799705,69.8056049,3379.1714974,2917.0291077,6010.9189816,1.3589805,6.033812,1.3101939,14.691409),(17520,'okapi_femur.tif',236,7,61,556.0434515,102.5410528,122.6928122,1.8,102.3401348,122.724039,-1.0869296,19.0139569,21.1511189,54818.1543876,71632.36613,72.6177799,3386.6939391,2883.048215,5962.0079898,0.777344,5.4552715,1.6421038,11.5267889),(17521,'okapi_femur.tif',236,7,62,548.5508564,102.4746841,122.0667361,1.8,102.2818719,122.1270621,-1.1333664,18.3481551,21.1246713,52851.3613648,70332.906468,75.0191035,3329.4201646,2880.4727783,5796.3883668,0.777344,3.5833788,1.3521274,7.6400689),(17522,'okapi_femur.tif',236,7,63,546.7491435,102.4561374,121.4612792,1.8,102.2885531,121.5133322,-1.1789533,17.9503674,21.0729021,51709.1154528,70007.1884095,77.835042,3322.142718,2880.6717052,5758.5446501,0.388672,5.4552715,1.6421038,11.2048024),(17523,'okapi_femur.tif',236,7,64,542.9138543,102.4953467,120.8743019,1.8,102.3816689,120.9594397,-1.2222951,18.4543398,20.3255691,50705.2536666,69569.6930362,79.9336535,3422.767292,2747.6059337,5858.9144732,0.6956719,1.4013768,0.9827937,2.9760049),(17524,'okapi_femur.tif',236,7,65,545.3581925,102.6688424,120.2361384,1.8,102.5011296,120.2671392,-1.274599,18.3315072,22.5820845,49829.1421176,69346.5062122,83.1492202,3070.8638117,2718.223961,5207.9005504,0.388672,5.8430214,1.6373645,11.9821464),(17525,'okapi_femur.tif',236,7,66,543.2808988,102.6875563,119.7884111,1.8,102.5156721,119.7615474,-1.3056262,17.7200101,20.4060179,49150.4754815,68814.6720952,84.327836,3372.2734413,2773.7272908,5695.5512716,33.5498859,40.206423,1.2765618,120.7740191),(17526,'okapi_femur.tif',236,7,67,541.0453062,102.7405812,119.3254935,1.8,102.572855,119.2465158,-1.3391284,35.8599029,56.776395,48722.0616282,68505.1244141,85.420527,1206.5775656,1358.6780129,1745.6796374,0.777344,4.3454851,1.3909428,9.1947569),(17527,'okapi_femur.tif',236,7,68,537.8475153,102.7851331,118.9150079,1.8,102.6128576,118.8477692,-1.3749357,18.1247337,21.2183371,48414.3624214,68627.5204189,86.2462361,3234.349609,2671.1764858,5468.5301369,0.777344,6.2671477,1.4464413,13.0814769),(17528,'okapi_femur.tif',236,7,69,535.8984902,102.8471764,118.531599,1.8,102.7064337,118.4502746,-1.4129482,17.8375709,20.8428177,48320.3968141,69139.116447,87.1094266,3317.1674435,2708.9112665,5598.1442746,0.388672,3.9061053,1.670465,8.0954264),(17529,'okapi_femur.tif',236,7,70,534.2521921,102.9346855,118.1364845,1.8,102.7940352,118.1086669,-1.4515744,49.6652959,52.1605344,48601.0830335,69898.4039316,87.7823867,1340.0630333,978.5723047,1645.2926279,0.388672,2.7483261,1.7126934,5.7633944),(17530,'okapi_femur.tif',236,7,71,534.5871006,103.0587373,117.7353004,1.8,103.0126922,117.7373815,-1.4881763,17.8436333,21.1040128,49261.9660855,71176.3556377,88.4910443,3372.64559,2760.758717,5682.5584095,33.03712,40.5785481,1.2793395,122.4620782),(17531,'okapi_femur.tif',236,7,72,532.4078145,103.1344058,117.3246538,1.8,103.1384976,117.3563881,-1.5249489,18.0116324,21.3830826,49855.6156478,72401.9499422,88.5482475,3385.9453844,2767.9676406,5713.2097566,0.388672,0.869097,2.0344439,1.8766744),(17532,'okapi_femur.tif',236,7,73,531.2364584,103.3063346,116.8781671,1.8,103.3629122,116.927733,1.5688983,24.4809209,45.2446044,50316.1889182,73916.6093862,88.5390906,1633.7110322,2055.3225543,2414.9568063,33.3632654,41.0835681,1.9794148,123.9224586),(17533,'okapi_femur.tif',236,7,74,524.537051,103.3673154,116.5497094,1.8,103.4727397,116.5701863,1.5301316,18.0048293,21.9636154,50429.340555,74480.1433925,87.2783578,3391.0693715,2800.8785777,5504.7673444,34.7204213,41.6042468,2.0887837,154.404607),(17534,'okapi_femur.tif',236,7,75,520.4205503,103.4743525,116.2705137,1.8,103.6393701,116.2702106,1.4882029,18.3173642,50.9420613,50856.8431449,75923.2422075,86.1464123,1490.3841784,2776.4280138,2377.0805927,35.369152,42.9618837,2.0708651,176.5084061),(17535,'okapi_femur.tif',236,7,76,517.0777361,103.5763049,116.0521971,1.8,103.8054905,116.1034985,1.4535905,18.5087021,22.250852,51295.5720397,77712.783375,85.0011655,3492.5756283,2771.4299816,5632.4494508,35.369152,43.6785021,2.0822163,179.201488),(17536,'okapi_femur.tif',236,7,77,542.5936861,104.2358059,115.317118,1.8,104.5575398,115.2768076,1.4985042,19.2437039,25.1516062,55318.440006,83934.7802082,89.9604904,3337.1538819,2874.6253992,5148.9527205,35.5850146,46.361255,2.1774014,223.6300627),(17537,'okapi_femur.tif',236,7,78,544.0067476,103.2564484,115.2974835,1.8,104.0852703,115.2899136,1.3886897,21.7044117,50.2666335,56217.8476321,86176.1206454,87.6940816,1714.3801897,2590.1576291,2802.4632426,39.7061375,48.1263207,1.0276068,300.0792931),(17538,'okapi_femur.tif',236,7,79,494.8076892,103.5280175,116.3679692,1.8,104.7895057,117.397761,1.2935699,79.6543406,63.4427097,53785.9197859,78920.0952168,76.2906324,1243.9584557,675.2415418,1549.2390766,36.4620109,53.0149178,2.0344439,255.9107585),(17539,'okapi_femur.tif',236,7,80,540.2719402,104.1524519,114.6040351,1.8,103.9788382,114.9070147,1.4719212,65.7576853,32.584268,56917.4021288,90227.6554966,89.1678796,2769.0557771,865.5627385,2121.1796518,0.388672,0.869097,2.0344439,1.8766744),(17540,'okapi_femur.tif',236,7,81,551.619692,103.4945762,114.1018392,1.8,102.9708203,113.8150662,1.4223826,21.5212022,24.9293048,56661.4326792,91110.3320155,89.9263863,3654.7482128,2632.8191251,5903.0678108,3.1207623,12.4617723,1.6332151,32.3588228),(17541,'okapi_femur.tif',236,7,82,514.665076,103.9554796,114.017878,1.8,104.0824357,113.9959131,1.4737523,19.1110041,23.9018593,55003.9968855,88860.0841753,84.9722317,3717.7059399,2878.1322355,6017.1542068,0.388672,1.2290888,1.8925469,2.6540184),(17542,'okapi_femur.tif',236,7,83,516.4410161,103.8809524,113.6145828,1.8,103.9486852,113.5098796,1.4954804,25.5944882,53.7133223,56019.204979,90729.4222083,85.5861752,1689.1418814,2188.7214371,2467.4761369,34.5224092,45.5808035,1.9924838,146.3873076),(17543,'okapi_femur.tif',236,7,84,519.8162866,103.8180348,113.3008164,1.8,103.9347894,113.2370428,1.506145,19.2358025,24.1464824,57520.6267287,93007.1152141,86.274431,3851.7873434,2990.2899344,6183.884978,0.388672,0.869097,2.0344439,1.8766744),(17544,'okapi_femur.tif',236,7,85,526.1916348,103.7377735,112.9911971,1.8,103.8513714,112.9712176,1.5162973,19.1757234,24.6814934,59377.8544579,95784.8129058,87.4383856,3880.8353806,3096.5118287,6221.050252,0.388672,2.7483261,1.7126934,5.7633944),(17545,'okapi_femur.tif',236,7,86,534.2485756,103.6615445,112.6349641,1.8,103.6979883,112.6430011,1.5249547,19.9941392,24.7638252,61258.309493,98590.9741471,88.8544437,3981.2497996,3063.8132876,6446.7434434,0.388672,3.9061053,1.670465,8.0954264),(17546,'okapi_femur.tif',236,7,87,542.8889056,103.6331746,112.2766004,1.8,103.5728449,112.1951095,1.5256654,20.49138,24.3002176,63311.7120916,102044.0982459,90.2973167,4199.3080039,3089.6753726,6697.8821955,0.388672,0.869097,2.0344439,1.8766744),(17547,'okapi_femur.tif',236,7,88,551.9306131,103.5728817,111.9562548,1.8,103.3888876,111.9258819,1.5222853,19.9085657,24.6472973,65487.2504246,105149.2298239,91.7721275,4266.1565844,3289.4007317,6746.3193684,35.757824,47.3606042,1.9756881,139.2025963),(17548,'okapi_femur.tif',236,7,89,559.2078706,103.5982899,111.4194122,1.8,103.437084,111.2280911,1.5214124,19.8002551,25.3871086,67497.762595,107349.7367838,92.9742001,4228.5137178,3408.933991,6824.206653,0.777344,2.3641995,1.735945,5.6300233),(17549,'okapi_femur.tif',236,7,90,561.9132324,103.5420128,111.0438418,1.8,103.4347376,110.7963576,1.521156,20.4047481,25.3579627,68748.0128243,108582.7463662,93.4216206,4281.9980359,3369.2164496,6898.3368153,0.388672,1.6025357,1.815775,3.4313624),(17550,'okapi_femur.tif',236,7,91,565.6918032,103.5231841,110.5841524,1.8,103.3500056,110.3704175,1.5029954,20.3659841,25.4157192,70109.4698654,110051.2213775,93.8492205,4330.0455293,3442.478861,7074.7384919,0.388672,2.3641995,1.735945,4.9860504),(17551,'okapi_femur.tif',236,7,92,574.9674798,103.5303785,110.2587173,1.8,103.3026349,110.0659428,1.4891328,20.0363059,25.3914515,72001.1167184,112160.638218,95.1902626,4417.2598067,3593.5325228,7208.2671493,0.388672,2.3641995,1.735945,4.9860504),(17552,'okapi_femur.tif',236,7,93,592.6887486,103.5619977,109.9136101,1.8,103.4455031,109.8889,1.4676969,20.646238,25.5340364,73870.3210894,114754.7062102,97.735177,4494.1858869,3577.9070793,7371.1819371,38.4037568,49.0851344,1.7138132,155.8421045),(17553,'okapi_femur.tif',236,7,94,599.7326322,103.6932468,109.6314487,1.8,103.6614385,109.7494319,1.444493,21.0790325,25.2185993,75464.9359577,117231.2731481,98.3693562,4648.6036747,3580.094856,7416.1825404,0.388672,1.9818461,1.7681919,4.2087064),(17554,'okapi_femur.tif',236,7,95,613.5468785,103.7608426,109.3078691,1.8,103.8072205,109.5239129,1.4254673,21.1522957,25.528546,78411.185029,120386.6187781,100.1132368,4715.764799,3706.9822685,7679.0609844,39.255872,50.1868722,1.7028361,151.4057193),(17555,'okapi_femur.tif',236,7,96,617.5594183,103.8543086,108.899534,1.8,103.8260837,109.1284936,1.4054118,20.7690784,26.1557989,80040.9113445,123296.4427395,100.1368915,4713.9237974,3853.8499251,7270.6893168,39.255872,50.7793683,1.670465,157.1691137),(17556,'okapi_femur.tif',236,7,97,624.9895271,104.0383797,108.5415554,1.8,104.0095948,108.7658273,1.3920371,21.8298108,26.1330258,81583.8685305,127853.3856468,100.8716507,4892.4065156,3737.2686936,7981.4143647,39.644544,51.8115958,1.6383625,173.4704548),(17557,'okapi_femur.tif',236,7,98,622.4268997,104.2126777,108.2063381,1.8,104.1005438,108.5523867,1.3762654,21.6732316,26.8267471,81729.9369883,130676.8183507,99.861412,4871.1391628,3771.0083369,7900.5513315,40.3100582,52.3655292,1.6748963,166.60773),(17558,'okapi_femur.tif',236,7,99,624.8016102,104.3026717,107.958979,1.8,104.2181724,108.3399858,1.3799407,53.4856179,50.7958821,83664.503852,135226.6019215,100.3862763,2662.1567807,1564.2430087,2969.5480657,40.7061322,53.3897267,1.6436598,169.9057213),(17559,'okapi_femur.tif',236,7,100,631.6396321,104.4357616,107.761331,1.8,104.3182649,108.175347,1.3820407,22.8499436,27.6306559,86677.7897841,140929.2123933,101.5668576,5100.4656887,3793.3480894,8153.6616644,41.2146632,54.5264013,1.506599,169.1283773),(17560,'okapi_femur.tif',236,7,101,640.9276229,104.5857438,107.598906,1.8,104.4349702,108.0289632,1.3790659,22.3740585,27.897715,89852.5978764,147051.5078168,102.9423441,5271.0950544,4015.9275542,8426.9703876,41.7735168,55.4222286,1.4795015,166.9297164),(17561,'okapi_femur.tif',236,7,102,653.6154209,104.7023789,107.4461523,1.8,104.4872118,107.8522948,1.3821795,23.8958168,28.1997073,94320.5286256,154327.3664081,105.1061069,5472.6584403,3947.1564931,8413.5590468,42.6092439,56.8538263,1.5092304,172.0100745),(17562,'okapi_femur.tif',236,7,103,668.138441,104.7816382,107.2633395,1.8,104.4914918,107.5878253,1.3937857,23.649735,29.804593,99951.839729,162930.7277569,107.903592,5466.6315271,4226.3407939,8674.0729096,43.5535814,57.8181444,1.4697899,179.1947858),(17563,'okapi_femur.tif',236,7,104,681.9184457,104.8282292,107.132452,1.8,104.538173,107.3695664,1.4113338,24.3948715,29.8362938,105713.8916088,172495.6811523,110.7874847,5781.4044396,4333.4473702,9211.4752843,44.1482215,59.4045451,1.4659194,190.7215746),(17564,'okapi_femur.tif',236,7,105,701.5268941,105.0189981,107.1145064,1.8,104.7333789,107.2560859,1.4373953,62.929505,62.3308047,112451.3600029,184402.1785142,114.8527539,2958.4437312,1786.9417538,3351.4966226,44.9553978,61.4212448,1.4566451,201.431956),(17565,'okapi_femur.tif',236,7,106,711.7782735,105.0992059,106.9545531,1.8,104.9435215,106.7473063,1.4593771,63.843795,60.6531174,117714.1042212,195703.2906999,117.163099,3226.5990433,1843.7830048,3559.073302,45.3599055,63.5867867,1.485117,204.0469109),(17566,'okapi_femur.tif',236,7,107,767.9281955,105.6020301,105.1878719,1.8,105.7959543,103.6709138,-1.5370359,56.1364723,58.1491455,130968.6674017,262919.5976883,127.8422121,4521.4696662,2333.0405727,4873.9361988,46.5685441,79.5107404,1.3590202,284.4219248),(17567,'okapi_femur.tif',236,7,108,833.2721727,106.0859508,103.3970268,1.8,106.3278067,101.9569123,-1.4634951,25.9362222,47.3304803,145704.6098634,345434.1182632,137.2858339,7298.3438233,5617.803877,10251.1575774,49.7428599,83.5536326,1.2976084,363.5480566),(17568,'okapi_femur.tif',236,7,109,885.1981084,106.4713278,102.4400451,1.8,106.636027,101.0329125,-1.4311836,26.9943054,49.1847455,160724.3783219,415522.1842056,144.6759807,8448.1922203,5954.0105131,11658.530249,50.916032,87.0286861,1.3041526,346.1083215),(17569,'okapi_femur.tif',236,7,110,941.4735983,106.7222355,101.944975,1.8,106.8774254,100.5970427,-1.4088361,28.8357598,50.4198678,178434.446448,480776.1594972,152.8321467,9535.4506162,6187.9571628,13032.5800248,1.0435078,1.4013768,2.1587989,3.2979913),(17570,'okapi_femur.tif',236,7,111,986.799418,106.8946265,101.8330107,1.8,106.9984745,100.5609474,-1.3897414,35.4737155,51.80023,199397.4245884,539389.9164243,159.1338628,10412.8865132,5620.9906941,12177.124043,55.0651322,92.3126684,1.3023286,301.1004965),(17571,'okapi_femur.tif',236,7,112,1034.4305953,106.7442718,102.2604839,1.8,106.8212721,100.9297289,-1.3768824,37.7493054,66.3840104,225435.2828603,589248.4612688,166.0030715,8876.3613057,5971.9054581,11899.5720334,58.1515729,94.7674478,1.3009472,332.7991659),(17572,'okapi_femur.tif',236,7,113,1099.6416803,106.4087976,103.0870002,1.8,106.5528995,101.8410176,-1.3561342,58.1626501,75.8402295,265265.9772827,648652.9301706,174.9573234,8552.887222,4560.761534,9562.2937294,0.388672,0.5496652,2.3561945,1.0993304),(17573,'okapi_femur.tif',236,7,114,1169.8707633,105.6126965,104.480484,1.8,105.9022238,103.1134848,-1.3033842,36.6814005,67.6907213,315498.868079,713266.0684775,181.3648886,10537.1320439,8601.0584053,14865.8171208,67.5777396,100.1251058,1.209754,377.3058676),(17574,'okapi_femur.tif',236,7,115,1246.1506316,105.1380905,106.020651,1.8,105.5114854,104.6000176,-1.286391,39.546634,66.4230612,371014.5308321,776277.3781904,191.3404331,11686.8654295,9381.6968205,16922.0726151,70.9941085,103.8096273,1.2111492,427.7483983),(17575,'okapi_femur.tif',236,7,116,1316.7165458,105.0441935,107.5485351,1.8,105.2638198,106.2599977,-1.2880267,40.8733249,58.4024967,421175.4603318,836632.5770784,202.3683316,14325.2878629,10304.4090845,21418.5377097,0.388672,1.2290888,1.8925469,2.6540184),(17576,'okapi_femur.tif',236,7,117,1395.7084595,105.0993058,109.3688828,1.8,104.9828185,107.8492298,-1.3003906,77.081344,59.6720724,485579.96992,901776.4876663,216.0197502,15112.2032777,6299.5784037,16675.3065079,75.3675206,110.7606094,1.2679115,363.2813143),(17577,'okapi_femur.tif',236,7,118,1491.8735016,104.9627197,111.3091336,1.8,104.2952131,109.8960309,-1.3025083,76.632239,60.8027049,552092.917633,1006880.2422057,231.173751,16559.7935869,7204.4471707,18979.7864839,0.388672,0.5496652,2.3561945,1.0993304),(17578,'okapi_femur.tif',236,7,119,1573.2723532,104.6106356,113.2627799,1.8,103.9314331,112.1246976,-1.3119034,42.6271257,61.9903296,614040.0217,1105228.0388748,245.0263102,17829.0395525,14404.9126234,27586.6617678,0.388672,0.5496652,2.3561945,1.0993304),(17579,'okapi_femur.tif',236,7,120,1687.3878265,104.81834,115.6343853,1.8,104.0258007,114.3160899,-1.4075742,47.5327019,63.5441615,707834.7550063,1241516.075215,273.8051907,19537.8465419,14891.5320797,30646.1675917,79.5322828,118.8758252,1.2686916,434.4292101),(17580,'okapi_femur.tif',236,7,121,1771.0406275,104.660158,117.2970836,1.8,104.1130506,115.8415733,-1.460588,47.8977973,64.0302105,772844.4506809,1376196.3194196,291.6027879,21492.9219929,16135.2816634,33516.6729637,81.1622401,119.1677479,1.2830883,463.5129245),(17581,'okapi_femur.tif',236,7,122,1793.9290833,104.3374946,118.7215376,1.8,104.0804032,117.0994321,-1.4848454,42.5740228,64.214943,808416.1164386,1440200.4883738,296.784823,22427.8091963,18988.4832062,34902.0742213,82.7391903,118.9920455,1.2655732,459.0765393),(17582,'okapi_femur.tif',236,7,123,1789.5359947,104.0398062,119.8712561,1.8,104.0597683,118.3289289,-1.4974778,43.0863981,63.7903251,836881.0949506,1471459.2714127,296.6555669,23067.122956,19423.3245708,35985.99581,83.391096,118.3664187,1.2397003,526.7701899),(17583,'okapi_femur.tif',236,7,124,1775.1707241,104.2213036,120.9558461,1.8,104.1205119,119.4868648,-1.5097099,43.0773373,63.1990687,852864.3147226,1475605.4323269,294.7591396,23348.5312688,19798.445518,36620.7184788,83.9345576,117.4387739,1.176769,532.3773303),(17584,'okapi_femur.tif',236,7,125,1771.3835014,104.5478393,121.8443319,1.8,104.1758785,120.6335407,-1.5285532,72.5212563,62.0378415,851634.5756399,1461763.4068557,294.7040615,23562.4478831,11743.240799,29278.282512,84.0285479,116.4901274,1.1878116,569.2116018),(17585,'okapi_femur.tif',236,7,126,1783.542294,104.6486777,122.6612748,1.8,104.140717,121.5944881,-1.5452807,71.0877004,60.4002264,868673.8500935,1425772.0267776,297.0635644,23605.4086586,12219.748917,29465.5865368,83.9221178,114.8820021,1.1601294,598.3438582),(17586,'okapi_femur.tif',236,7,127,1765.1338583,104.6242321,123.1319752,1.8,104.0822795,122.4467499,-1.5566002,44.6475894,58.7820613,857270.8540775,1357213.2934102,294.1296939,23088.9026753,19200.8318004,36968.0105103,84.993747,113.0661478,1.1455913,525.6022108),(17587,'okapi_femur.tif',236,7,128,1732.5543861,104.5322728,123.508911,1.8,104.0677978,122.9369256,-1.5644578,45.2834813,57.6473975,850324.7997225,1263673.1810839,288.747464,21920.732532,18777.8142146,32999.2836458,86.3919876,111.1098979,1.1337465,537.5224109),(17588,'okapi_femur.tif',236,7,129,1683.0087458,104.3236952,123.7511213,1.8,104.095536,123.3404565,-1.5546506,58.5614974,53.9755387,836414.6365255,1142900.0207663,280.428341,21174.4069497,14282.6716099,28724.5955084,86.4187007,109.2914979,1.0578257,661.9325883),(17589,'okapi_femur.tif',236,7,130,1649.4920698,104.4108163,123.8863756,1.8,104.0967913,123.8329488,1.5698338,70.8498253,52.7925325,815394.0434112,1026808.2622582,274.9150908,19449.8769612,11508.7657531,23740.3114499,86.0289302,106.3982057,2.1638647,764.4046991),(17590,'okapi_femur.tif',236,7,131,1568.1107052,104.7571505,124.04185,1.8,104.1234627,124.3251556,1.5058273,55.0257925,55.0370873,762161.8523938,892815.0971247,260.2501793,16222.0630009,13850.9927439,24809.8182372,85.4306858,105.2748803,2.1936209,685.6786808),(17591,'okapi_femur.tif',236,7,132,1446.4426224,104.8660809,123.988867,1.8,104.4409268,124.7345799,1.4479833,43.7707254,49.9585376,700775.7233069,754605.0441616,237.4558859,15104.6263642,16010.1464426,27417.8351755,85.3937135,102.4539687,2.2135387,668.5218686),(17592,'okapi_femur.tif',236,7,133,1296.825833,104.4357035,124.6948188,1.8,104.7623004,126.0410257,-0.0408423,47.6595808,49.4057886,585897.770889,635117.9494609,0.3603378,12855.1323215,12293.3890983,19428.9430007,86.3406595,102.4097249,2.1535358,757.8963219),(17593,'okapi_femur.tif',236,7,134,1145.3308822,104.907561,124.9920299,1.8,104.7564045,125.3389856,0.023724,48.2514362,54.9722602,426489.2542056,571330.5096361,0.1074177,10393.0692872,8838.8924313,17939.9884776,79.9795731,93.8471865,2.2358351,652.5586946),(17594,'okapi_femur.tif',236,7,135,964.6927054,104.5105714,126.3190596,1.8,104.4224048,126.0532132,0.0277842,43.5988213,44.7655715,296499.8394419,495921.9290083,0.1240861,11078.1994339,6800.6388902,15678.7066863,75.5124613,88.0854583,2.2310655,548.9481899),(17595,'okapi_femur.tif',236,7,136,704.1163014,100.960904,129.1860381,1.8,102.3231814,127.761433,0.0662719,46.6722648,47.4200497,175065.3863699,377310.190682,0.5146553,7956.764974,3750.9511694,10234.1640058,34.5288058,74.5044788,1.4030748,298.2969263),(17596,'okapi_femur.tif',236,7,137,463.8125781,95.2857074,130.3077237,1.8,97.2430192,129.4496751,-0.0412906,44.9501744,49.4101734,87303.6020382,195088.2990461,0.1317184,3948.3427351,1942.2305503,5602.7896355,32.0959924,65.8096419,1.3444402,240.9593094),(17597,'okapi_femur.tif',236,7,138,279.8846433,87.7640436,130.6767257,1.8,90.1214457,129.6001555,-0.8410584,45.2984787,46.3946122,20720.490068,54589.9539369,25.9147666,1176.6442566,457.4213235,1419.8766702,27.9635403,58.9411829,1.2970256,219.2003797),(17598,'okapi_femur.tif',236,7,139,136.495661,85.2897032,133.3626396,1.8,86.9488055,130.8698488,-0.9135165,78.8584421,88.6848717,2936.5444841,13839.7539313,14.2574476,156.055409,37.2381752,178.2586242,20.3184298,48.5015315,1.1932661,161.5340741),(17599,'okapi_femur.tif',236,7,140,27.8739518,83.1138401,135.737346,1.8,83.1887246,135.4512135,-0.9801574,19.6227701,42.6386513,206.8924496,395.7522947,3.2049076,9.2815388,10.5434884,12.839364,11.9224123,17.0396216,0.7853982,47.8275758),(17600,'okapi_femur.tif',236,7,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17601,'okapi_femur.tif',236,7,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17602,'okapi_femur.tif',236,7,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17603,'okapi_femur.tif',236,7,144,22.0395111,98.9803452,152.6790099,1.8,100.3898925,152.8508081,0.3273576,9.9748562,23.1856916,171.1593219,3860.4901461,0.379775,166.5031264,17.1590767,160.041989,10.3920157,12.0676241,2.8809903,37.078131),(17604,'okapi_femur.tif',236,7,145,435.0813501,110.3161015,148.7589271,1.8,106.2267508,148.4331043,-0.0092455,15.0401249,34.9311555,19618.9135584,69562.5782994,0.0061984,1991.4193301,1304.4382048,2549.1459369,28.761728,64.3953384,0.0906599,249.3309566),(17605,'okapi_femur.tif',236,7,146,564.4459213,109.3243987,148.0685187,1.8,103.2732904,148.2349096,-0.0202349,22.226016,35.8898191,26955.3666362,102097.1469576,0.0385141,2844.7384071,1212.7844543,3594.8029406,23.32032,24.1101985,2.7790484,77.6657514),(17606,'okapi_femur.tif',236,7,147,592.0112408,108.0839515,148.2748709,1.8,101.8474603,148.4302315,-0.0301765,29.9054844,43.7817715,28847.7722785,120093.687376,0.0898224,2743.0065828,964.6315015,2809.1256285,26.041024,26.7732667,2.4487131,86.1774719),(17607,'okapi_femur.tif',236,7,148,603.0154778,107.5795017,148.5326929,1.8,101.4684859,148.7256793,-0.049785,31.1474217,40.5594377,29604.2356153,127315.6398158,0.2488953,3138.9892755,950.455414,3068.4780524,27.595712,28.2957487,0.9218008,91.25783),(17608,'okapi_femur.tif',236,7,149,608.4818211,107.345287,148.7327944,1.8,101.3384576,149.0304212,-0.0594229,31.6005287,38.15205,29979.0386286,130799.4929133,0.3576789,3428.3739106,948.6878827,3245.4545377,28.761728,29.202177,1.1011964,94.5558212),(17609,'okapi_femur.tif',236,7,150,609.0515228,107.2068312,148.8671027,1.8,101.2238939,149.2134571,-0.0623399,21.3580855,36.5668288,29938.2848506,132610.1710699,0.3939781,3626.5154942,1401.7307348,4441.0532919,28.761728,29.4622606,0.9352106,95.0111788),(17610,'okapi_femur.tif',236,7,151,611.1505151,107.0774911,148.9664149,1.8,100.9168133,149.2685494,-0.0614607,16.1946292,36.7952991,29958.4892085,135015.0916542,0.3842779,3669.3570938,1849.902758,4481.9271698,28.761728,29.5237257,0.280108,95.4274729),(17611,'okapi_femur.tif',236,7,152,613.6990888,106.915465,149.044903,1.8,100.6638216,149.3413776,-0.0587626,21.8627541,37.0168997,30161.2554913,137905.3857923,0.3527819,3725.470989,1379.572552,4540.2668228,28.761728,29.4622606,0.9352106,95.3331652),(17612,'okapi_tibia.tif',236,8,1,3.5021838,160.3579695,173.6727704,1.8,159.8354207,172.8675351,-0.0132241,19.8532622,32.5051661,20.992418,46.7159152,0.0001021,1.4371843,1.0573788,2.0787209,10.2032488,147.2129397,3.1147894,314.3531064),(17613,'okapi_tibia.tif',236,8,2,3.1313011,160.9354148,174.0346451,1.8,160.8724209,174.0170391,-0.1606211,0.6752465,7.0961054,0.2929661,28.8019671,0.0133488,4.0588415,0.4338655,4.0937119,10.3466435,147.2240414,3.1121106,315.3336269),(17614,'okapi_tibia.tif',236,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17615,'okapi_tibia.tif',236,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17616,'okapi_tibia.tif',236,8,5,0.0196691,113.0326584,166.492082,1.8,113.0331315,166.492082,0.2940026,0.0573018,0.1892539,0.0003194,0.0009563,0.0002753,0.0050527,0.0055741,0.0064512,0.394531,0.8821981,2.677945,1.6738533),(17617,'okapi_tibia.tif',236,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17618,'okapi_tibia.tif',236,8,7,6.2542534,103.5056832,121.1292977,1.8,103.9044587,121.6728763,0.9808256,12.4632267,60.561356,23.1532969,114.5147195,0.7197493,1.8908876,1.8577289,2.2265392,3.4953072,10.4159173,1.141034,23.5529029),(17619,'okapi_tibia.tif',236,8,8,37.8974409,103.2478624,120.8178622,1.8,104.0521835,121.6584648,1.3444971,36.3866336,53.6872176,309.4093413,891.2776758,5.9982612,16.6013013,8.5033791,19.3804119,8.8666072,17.3054807,1.1479424,46.1813622),(17620,'okapi_tibia.tif',236,8,9,97.0773616,104.5615004,120.0618943,1.8,105.9193141,119.6741247,-0.9050069,61.2049927,25.3999933,1747.0907722,3395.3048406,10.0065919,133.6734542,28.5449061,83.1329923,13.414054,21.6273531,1.3125441,69.9257236),(17621,'okapi_tibia.tif',236,8,10,184.9190218,107.3582786,118.7481427,1.8,108.756423,118.2409032,-0.5916268,57.7383657,18.6712094,4636.6019525,12364.4390042,9.5862867,662.2195044,80.3036576,293.5084829,20.8410356,33.7664145,0.5263924,115.7009409),(17622,'okapi_tibia.tif',236,8,11,274.6958002,108.5890712,117.7798803,1.8,108.5368931,117.7291402,-0.6062973,57.5337936,18.6578453,9590.8274816,23808.5625571,14.8658357,1276.0617412,166.6990283,575.8234955,25.0432614,37.2199801,0.3686959,137.2531504),(17623,'okapi_tibia.tif',236,8,12,367.0031468,106.7541416,118.3312715,1.8,104.5228995,118.7189352,-0.4051823,57.5947015,30.0600335,20726.8350073,50342.9634358,9.5043298,1674.747415,359.8739894,1229.162184,32.4246827,53.843003,0.1470784,207.5453666),(17624,'okapi_tibia.tif',236,8,13,576.5371215,101.2808966,119.0979804,1.8,100.0101875,119.3475118,-0.1532002,54.4022,30.0962905,46500.6015356,140028.4600734,2.2376617,4652.6817083,854.7559026,3144.4030593,38.5939764,60.9738694,3.0573767,213.9139395),(17625,'okapi_tibia.tif',236,8,14,740.6394484,99.6420395,118.2860157,1.8,99.1278915,119.0613132,0.0150367,51.6979447,34.8783346,87188.434593,218593.1126459,0.0279077,6267.3036273,1686.497116,4933.3391339,46.7771774,67.0110642,2.7993608,280.8748737),(17626,'okapi_tibia.tif',236,8,15,933.4138445,100.8126743,119.4850402,1.8,100.9077762,121.1816431,0.4126352,55.3739479,50.2408852,185907.7101758,328603.1675276,25.0187341,6540.5528973,3357.3136344,8510.5154965,61.1892363,81.5840122,2.2568661,323.262732),(17627,'okapi_tibia.tif',236,8,16,1144.1854628,105.3603276,120.9687458,1.8,107.2205165,122.4359178,0.4372944,53.244857,51.2057668,293399.4044487,546611.8416819,34.2004301,10674.8102049,5510.3801734,14677.4217374,64.4128919,95.5726409,2.8093986,399.1508837),(17628,'okapi_tibia.tif',236,8,17,1457.3511359,112.4328423,122.6247384,1.8,111.5537221,122.6858123,0.2543492,51.2640707,47.6641077,468722.9151231,849203.3584176,15.3775811,17816.4115438,9143.3026731,23297.6179109,71.552294,95.8198764,2.8276544,439.1551315),(17629,'okapi_tibia.tif',236,8,18,1585.5103847,113.0151583,121.7884481,1.8,112.9897321,122.3607594,0.172929,49.8550125,49.4502259,558027.7927816,954254.4221248,7.8238413,19297.2712417,11193.012796,28179.4970627,75.3059951,95.5139914,0.0951475,400.2339368),(17630,'okapi_tibia.tif',236,8,19,1612.9849975,113.8949653,121.1549974,1.8,114.2443253,122.2760331,0.0962178,50.2932634,48.691972,620545.8879955,938698.6263651,2.4811269,19278.3037408,12338.5488669,29226.0321917,77.5414344,94.5599535,0.0751719,378.6653028),(17631,'okapi_tibia.tif',236,8,20,1615.3886364,115.312103,121.760343,1.8,115.265888,122.5505098,-0.1044497,50.7893723,49.7208154,637218.539235,904996.0387411,2.926581,18201.5526528,12546.2967933,28604.1429605,78.3690855,93.410578,0.6806775,442.3181828),(17632,'okapi_tibia.tif',236,8,21,1617.9126011,116.2029998,122.6397581,1.8,115.8641365,122.9737759,-0.3011253,50.4077364,50.8592917,627200.379067,896560.4334301,23.7209238,17628.252438,12442.5420239,29288.8062448,79.4997127,95.2708636,0.691557,388.5962686),(17633,'okapi_tibia.tif',236,8,22,1554.28355,116.1740527,123.5520784,1.8,115.8145325,123.4805758,-0.4380899,48.939754,51.4250355,584908.0993975,878027.8510237,46.6167317,17073.9376712,11951.5945936,27073.1257972,0.394531,0.5579511,2.3561945,1.1159022),(17634,'okapi_tibia.tif',236,8,23,1438.7002583,115.3109865,124.4237052,1.8,115.1951117,124.1791754,-0.5429424,49.3591276,51.8926025,511691.0682709,832398.4397172,64.0065629,16040.7919247,10366.695949,25769.3182288,2.5171019,14.3014086,1.9974238,37.2705693),(17635,'okapi_tibia.tif',236,8,24,1354.2533331,113.6209665,124.9544091,1.8,113.9534314,124.6152892,-0.6248567,60.3929859,51.9626516,454252.9982308,789106.5150495,77.2382221,15186.0324793,7521.6184698,20579.3722246,75.0234126,95.2226539,0.8293581,393.0763018),(17636,'okapi_tibia.tif',236,8,25,1280.530923,112.344668,125.5859517,1.8,112.7922299,125.3739857,-0.6687103,59.6537763,51.9000992,403883.1622017,744255.6127471,82.0326115,14340.157801,6770.4542306,19164.7083251,71.7519589,94.233463,0.8535417,403.2151508),(17637,'okapi_tibia.tif',236,8,26,1206.0778791,111.0085325,126.42339,1.8,111.5005558,125.9458076,-0.7010844,47.2347817,51.1774378,365925.2653594,682644.1823196,83.6385304,13338.7721472,7746.9452055,20232.3933565,69.592292,92.2308511,0.8459302,410.5245918),(17638,'okapi_tibia.tif',236,8,27,1144.5949762,109.4860549,127.3161832,1.8,110.2358694,126.6583056,-0.7430774,37.3279991,51.1852869,333914.5141319,610122.3197974,87.319186,11919.8769187,8945.4169113,17792.8663871,67.3726663,90.2726242,0.6863445,359.8960455),(17639,'okapi_tibia.tif',236,8,28,1075.5466883,107.4594734,128.314849,1.8,108.3597072,127.4707295,-0.8405322,36.8476759,50.394004,304529.8340396,517491.2100408,99.4920798,10268.9044087,8264.5601619,15250.1174585,64.835161,88.8571053,0.6879163,353.4153188),(17640,'okapi_tibia.tif',236,8,29,1014.6831497,105.8579246,129.0363285,1.8,106.4710804,128.2603631,-0.9456636,48.4779768,43.7581273,278404.6388718,454895.0972632,111.1983215,10395.6710448,5742.9096165,14522.5890531,62.242895,82.3209518,0.8091225,312.0476333),(17641,'okapi_tibia.tif',236,8,30,952.7977614,104.8201589,129.3724736,1.8,105.4988807,128.5777478,-1.0095154,34.0140049,42.9357995,255221.5831948,414509.2292057,113.80971,9654.1635146,7503.4264167,14607.679633,60.3487403,78.955501,0.8703,386.0937009),(17642,'okapi_tibia.tif',236,8,31,906.5892552,103.9231556,129.4033182,1.8,104.7544648,128.6640745,-1.0391888,33.8032738,42.6325326,235815.5787454,383296.2181465,112.2708679,8990.6978338,6976.1165742,14100.250257,58.3947109,76.4789974,0.8767186,347.8822635),(17643,'okapi_tibia.tif',236,8,32,863.9047244,103.2281911,129.2428658,1.8,104.0924847,128.5769038,-1.0570186,32.6914401,42.8766174,219111.0246372,356720.1796483,109.2056996,8319.690349,6702.3974433,13290.1621224,1.2459389,6.6135447,1.8736812,15.5665536),(17644,'okapi_tibia.tif',236,8,33,831.7430181,102.7106516,128.6816786,1.8,103.7165683,128.2977162,-1.0536449,31.9960543,36.9581505,204764.644873,329274.7533886,104.7389964,8909.3947769,6399.6842606,13072.7820968,55.7647908,71.6809736,0.871125,358.3479526),(17645,'okapi_tibia.tif',236,8,34,795.5525905,102.4848846,128.275478,1.8,103.4794107,128.3266787,-1.034834,31.5387862,34.8777796,192160.3005026,304234.2120711,98.0144053,8722.8664014,6092.8248469,12676.7902758,54.3035422,69.9667109,0.8652281,358.2125709),(17646,'okapi_tibia.tif',236,8,35,763.7813416,101.9839307,127.8943581,1.8,102.9895012,128.3670831,-1.0319803,30.8401389,34.1733935,180639.3541785,282282.4051811,93.7806086,8260.2977336,5857.2808181,12281.5494203,53.6455546,68.2550033,0.8590353,343.2996977),(17647,'okapi_tibia.tif',236,8,36,744.1280006,101.556686,127.645963,1.8,102.3780107,128.312816,-1.0328684,30.6356688,33.9553743,172765.9962939,268277.3355429,91.464452,7900.8799412,5639.3740729,12012.4444012,52.9821323,66.7224127,0.8230373,370.3192642),(17648,'okapi_tibia.tif',236,8,37,731.0510711,101.1008572,127.6980236,1.8,101.9556936,128.4338221,-1.0533803,30.0166954,33.7019225,165982.1268325,261763.2276918,92.0314299,7767.0117437,5529.660234,11910.2318741,52.095685,65.659489,0.840661,364.9312118),(17649,'okapi_tibia.tif',236,8,38,719.1306089,100.7189546,127.6981159,1.8,101.4629799,128.3937676,-1.0787405,29.7988958,33.8254208,159524.6572243,255704.5692823,93.1036302,7559.5384602,5353.3747731,11855.9769059,2.5890019,24.6920939,1.7963976,63.1906582),(17650,'okapi_tibia.tif',236,8,39,704.6976438,100.3191092,127.4418081,1.8,101.0590964,128.2773176,-1.0902035,61.9322262,32.9544244,153635.6780152,245291.7865073,92.3475918,7443.3643171,2480.7065324,6415.9153449,0.5579511,1.1159022,2.3561945,2.2318044),(17651,'okapi_tibia.tif',236,8,40,695.792685,99.8327126,127.2165186,1.8,100.5872572,128.0891522,-1.0824282,28.9620178,31.959396,148124.1868322,236251.7789127,90.4373976,7392.2479187,5114.429105,11407.7793439,1.6789167,9.5993535,1.735945,26.47804),(17652,'okapi_tibia.tif',236,8,41,684.082734,99.4743391,126.7818398,1.8,100.2023952,127.4872121,-1.0627644,28.628409,31.4338645,141892.6552783,225739.8750639,87.0333292,7181.4229132,4956.3583924,11073.2799977,2.162252,7.3704473,1.8417432,20.4923842),(17653,'okapi_tibia.tif',236,8,42,673.4551021,99.047334,126.6090772,1.8,99.8015173,127.2462079,-1.051765,28.9201672,30.6264467,136561.9515656,216873.3834701,84.6246894,7081.2453589,4722.0318886,10905.8617231,2.1295094,17.8936228,1.815775,45.854522),(17654,'okapi_tibia.tif',236,8,43,665.55322,98.6389679,126.3423632,1.8,99.3531448,126.8717558,-1.0412797,28.1459371,30.4457918,131796.0880551,208521.2582692,82.623728,6848.9352986,4682.5972612,10693.3660484,2.5177824,25.5502613,1.8045395,67.1359682),(17655,'okapi_tibia.tif',236,8,44,660.965038,98.2504685,126.0720154,1.8,98.9903486,126.5134114,-1.0269519,29.73033,30.315966,127110.0013445,201877.6277656,80.6671106,6659.1190802,4275.4318974,10461.9109294,3.2522166,28.0366953,1.812362,74.699748),(17656,'okapi_tibia.tif',236,8,45,656.5857635,97.8902249,125.7223038,1.8,98.6406327,126.1847122,-1.0100904,38.3861541,30.1514048,122855.802038,195163.8085141,78.4845023,6472.7932207,3200.5238549,7136.0668759,2.4936083,21.6669011,1.7539071,56.0726756),(17657,'okapi_tibia.tif',236,8,46,655.3894863,97.5553144,125.3291395,1.8,98.3169201,125.6672644,-0.9912375,38.9715637,29.6791024,119646.2802733,189255.8956429,76.4702095,6376.739193,3070.0918523,6881.6858254,3.0776906,8.688644,1.6162196,27.4585605),(17658,'okapi_tibia.tif',236,8,47,650.5386723,97.2142381,124.9108937,1.8,97.8538346,125.1905988,-0.978079,28.1009769,29.133323,116215.6717545,182372.744428,74.5893739,6259.9362392,4135.645256,9462.1846414,3.2623622,15.0388262,1.6495803,39.1987613),(17659,'okapi_tibia.tif',236,8,48,650.2873607,96.9220271,124.5192286,1.8,97.5648874,124.8484059,-0.9609207,26.4663771,28.7134247,113366.8348319,176940.4501035,72.8256481,6162.2900114,4283.4285261,9879.9960663,1.7394063,7.929975,1.670465,20.5320365),(17660,'okapi_tibia.tif',236,8,49,648.4938883,96.7270393,123.9993858,1.8,97.3686729,124.0117107,-0.9347483,26.0549254,28.5932135,109646.8576848,170761.1379261,69.9442989,5972.0862758,4208.2967476,9449.9171757,1.578124,5.6488243,1.7818897,13.0079091),(17661,'okapi_tibia.tif',236,8,50,642.5639155,96.5094568,123.5569258,1.8,97.1716942,123.4569655,-0.9143707,25.7594935,28.8216051,106030.6448752,163982.6896895,67.2065138,5689.5752037,4116.177395,9259.508948,1.9689756,8.4341095,1.7590178,21.0899876),(17662,'okapi_tibia.tif',236,8,51,635.6202533,96.2522122,123.0769999,1.8,96.9451736,122.9659131,-0.8979274,25.3572822,27.5331619,102858.8983495,157076.7233541,64.7889487,5705.0012514,4056.3849635,8706.9968618,1.5553131,7.5375042,1.4659194,20.0698147),(17663,'okapi_tibia.tif',236,8,52,629.2390705,96.0979391,122.519431,1.8,96.6987678,122.3382278,-0.8774222,24.8132599,27.0945032,99594.8173857,150558.6122898,62.0330464,5556.7954601,4013.7739973,8976.0437591,2.2550212,9.6720464,1.7761917,27.5939422),(17664,'okapi_tibia.tif',236,8,53,623.7958725,96.00513,122.0456219,1.8,96.5748192,121.8731212,-0.85606,24.8978896,26.7070753,96416.5634283,144235.8334417,59.3049883,5400.6600077,3872.4793589,8744.7829002,1.7366636,10.5274001,1.7975952,24.3419649),(17665,'okapi_tibia.tif',236,8,54,617.5790233,95.8221785,121.6064183,1.8,96.4109443,121.4625946,-0.8356342,24.5716052,26.707946,93177.2405958,138524.886401,56.6270071,5186.6544329,3792.0697496,8549.0517677,0.7061587,1.7643963,1.1071487,3.8099284),(17666,'okapi_tibia.tif',236,8,55,616.7083003,95.6460318,121.1753475,1.8,96.1450775,121.083074,-0.8079221,24.1584651,26.3364016,90875.0776328,134073.0728954,53.7066915,5090.7893483,3761.6246437,8441.4967032,0.394531,0.5579511,2.3561945,1.1159022),(17667,'okapi_tibia.tif',236,8,56,614.6401681,95.5562631,120.7347686,1.8,96.0315326,120.6507617,-0.7812647,23.769,25.91792,87761.9530678,130187.9239298,50.7965876,5023.0853393,3692.286307,7632.8077848,1.8355575,9.9340367,1.6902253,23.5925553),(17668,'okapi_tibia.tif',236,8,57,613.0814513,95.530194,120.1381138,1.8,95.8652176,120.0485087,-0.7511913,23.2197982,26.3442551,84388.4182099,125110.1470895,47.5975803,4749.048577,3634.3303927,7952.3364415,1.972655,5.2637001,1.7975952,18.9142602),(17669,'okapi_tibia.tif',236,8,58,605.8171403,95.4411857,119.7622146,1.8,95.7119077,119.6661026,-0.7306316,22.798218,25.1344628,80845.7901361,120019.2142818,44.966057,4775.0857146,3546.1451417,7065.864774,0.394531,0.8821981,2.677945,1.6738533),(17670,'okapi_tibia.tif',236,8,59,600.4618164,95.3450458,119.4339585,1.8,95.5670696,119.4060149,-0.7099443,22.9838793,24.8031074,77446.6232462,115359.9360141,42.5159191,4651.0275542,3369.6062462,7665.4589999,1.972655,5.9703374,1.7033479,16.9135667),(17671,'okapi_tibia.tif',236,8,60,596.8753904,95.2844888,119.0670698,1.8,95.4806452,119.013817,-0.6862185,22.0528067,24.3577638,74388.5339078,111531.225121,39.937871,4578.8778489,3373.2002803,7474.143341,0.789062,1.1159022,2.3561945,2.2318044),(17672,'okapi_tibia.tif',236,8,61,594.1386976,95.2093476,118.7380036,1.8,95.388767,118.6825809,-0.6666459,22.0288811,24.4401609,71791.3976581,107920.9399873,37.8625848,4415.7213381,3258.9670568,7247.9889772,0.394531,0.5579511,2.3561945,1.1159022),(17673,'okapi_tibia.tif',236,8,62,593.0066161,95.1778232,118.3411745,1.8,95.3546167,118.3499199,-0.6401374,21.6477639,24.1427351,69344.1982351,104801.2450589,35.2615595,4340.9019093,3203.2961245,7119.2702699,0.789062,3.6373961,1.3521274,7.7552384),(17674,'okapi_tibia.tif',236,8,63,593.927526,95.1474955,118.0010461,1.8,95.2808871,118.058885,-0.6110529,21.3039545,24.2712472,67354.5096065,102216.5098307,32.5834886,4211.4238705,3161.5965777,6872.7892387,1.183593,5.1440549,1.6475682,12.8164505),(17675,'okapi_tibia.tif',236,8,64,595.0306934,95.1569039,117.6566269,1.8,95.2181699,117.7583671,-0.5852057,21.1179881,50.4360008,65331.8552038,99835.9554908,30.2586539,1979.4582031,3093.6590604,3233.1165174,38.2781933,45.1302768,0.5419187,234.7331638),(17676,'okapi_tibia.tif',236,8,65,597.8406382,95.2551746,117.2449213,1.8,95.2551484,117.2833436,-0.560076,20.4428785,23.5932274,63025.5534175,97132.1390764,28.1211465,4116.9500656,3083.0077805,6399.7581375,2.0337159,17.6439627,1.7506498,43.5269884),(17677,'okapi_tibia.tif',236,8,66,595.0759748,95.2280538,116.9487725,1.8,95.1740882,116.9841589,-0.5406541,19.9774696,23.3715143,60786.0282027,94386.3285772,26.2738864,4038.5200321,3042.729106,5658.1982137,2.2538032,18.7474888,1.7186457,45.2008416),(17678,'okapi_tibia.tif',236,8,67,596.3131939,95.2455085,116.6185854,1.8,95.1287567,116.6352613,-0.5200207,20.3006822,23.5090955,58885.4033608,92033.5319925,24.5390529,3914.8053089,2900.6613054,6389.5478183,3.5873843,21.0917321,1.7021118,54.5902809),(17679,'okapi_tibia.tif',236,8,68,596.6158244,95.2762171,116.2987567,1.8,95.1722867,116.264776,-0.4994834,19.7903999,23.1502921,57232.1816676,89872.4288962,22.8120308,3882.1293758,2891.9163744,6113.4280787,3.6600222,20.610233,1.6666555,54.9567735),(17680,'okapi_tibia.tif',236,8,69,595.4148775,95.314652,115.9397762,1.8,95.204275,115.8923759,-0.4736962,19.8003075,23.0650113,55745.5226154,87440.3240024,20.6508665,3791.0375568,2815.3867168,6108.8099272,2.9481378,17.9674113,1.7251151,45.7587927),(17681,'okapi_tibia.tif',236,8,70,594.4390168,95.3328947,115.6319557,1.8,95.268502,115.5682012,-0.4521212,19.922837,22.7452696,54452.0631126,85289.2284374,18.9090494,3749.7567667,2733.1480557,6062.3407566,0.394531,0.5579511,2.3561945,1.1159022),(17682,'okapi_tibia.tif',236,8,71,595.022722,95.3626841,115.3343315,1.8,95.3707273,115.2710852,-0.4350633,19.1539462,22.5622667,53454.9615568,83753.8333159,17.616153,3712.1196322,2790.8067115,5865.7506024,0.394531,0.5579511,2.3561945,1.1159022),(17683,'okapi_tibia.tif',236,8,72,594.6694801,95.3597481,115.061345,1.8,95.3891296,115.0254679,-0.4183042,18.9715655,22.7221505,52424.6759802,82131.9516885,16.3541753,3614.6205302,2763.3289382,5848.8126699,0.394531,0.5579511,2.3561945,1.1159022),(17684,'okapi_tibia.tif',236,8,73,600.6369987,95.483064,114.6912485,1.8,95.4797033,114.6016219,-0.3979941,18.9551652,22.6461738,51381.5475798,80724.5705224,15.0369962,3564.6008529,2710.6884602,5676.5100316,2.367186,17.7714211,1.6152115,47.432646),(17685,'okapi_tibia.tif',236,8,74,601.1222169,95.5075982,114.4586989,1.8,95.5585037,114.334675,-0.3835245,18.885692,22.2609383,50279.8809742,79074.3049278,14.0280946,3552.1550731,2662.3266386,5659.9299682,2.8567993,18.2169109,1.6575347,47.3369167),(17686,'okapi_tibia.tif',236,8,75,600.4634673,95.5532461,114.1987453,1.8,95.5915951,114.0788711,-0.3675264,18.8619562,22.5681319,49196.7910394,77496.4201014,12.9202065,3433.8872429,2608.2549704,5576.3324438,2.761717,17.3638467,1.5935197,40.1792818),(17687,'okapi_tibia.tif',236,8,76,598.6990976,95.6049212,113.9735844,1.8,95.6812381,113.8158189,-0.3539762,27.8507962,31.3582419,48308.0366634,76153.7139632,11.9892004,2428.5071299,1734.5298253,2980.450089,2.424211,16.2190154,1.6438369,42.6421971),(17688,'okapi_tibia.tif',236,8,77,597.2969788,95.6874063,113.758047,1.8,95.7953096,113.5963641,-0.3348336,18.7943534,22.1374371,47426.7174108,75057.906596,10.7499395,3390.5418382,2523.4556613,5439.1923125,3.156248,20.1249486,1.5904017,49.3376102),(17689,'okapi_tibia.tif',236,8,78,594.9397533,95.7695323,113.5384406,1.8,95.8066861,113.3355738,-0.3165431,18.8523275,22.7621875,46717.3078228,74138.8311332,9.6080079,3257.1048402,2478.0657929,5301.6314783,2.9983058,18.9744392,1.6332151,45.4319525),(17690,'okapi_tibia.tif',236,8,79,595.2677131,95.8660813,113.3253389,1.8,95.9324253,113.1131596,-0.2975616,19.4619508,22.1964326,46280.5034337,73888.8099086,8.5282275,3328.8596984,2377.9992004,5365.3255791,3.045599,17.7714211,1.6152115,48.8753884),(17691,'okapi_tibia.tif',236,8,80,596.2506961,95.9683446,113.1168863,1.8,95.9911161,112.9607266,-0.2824309,28.1980088,45.0014118,45875.3195174,73867.1058488,7.7183357,1641.4397425,1626.8992555,2274.5566428,3.156248,17.7582781,1.5930149,46.6832364),(17692,'okapi_tibia.tif',236,8,81,600.6459606,96.1674891,112.8270162,1.8,96.2417623,112.6088484,-0.263465,30.697958,42.6629862,45483.7139138,73582.1809385,6.7895526,1724.7311443,1481.652753,2288.6388365,2.6348929,18.1655714,1.6142472,43.7580993),(17693,'okapi_tibia.tif',236,8,82,599.8726869,96.2528017,112.6364048,1.8,96.2157781,112.3911913,-0.248305,50.6827682,40.0416933,44976.0260267,73092.2562101,6.0385786,1825.4037282,887.4027126,2274.5941054,3.0499439,17.377288,1.6162196,43.2001482),(17694,'okapi_tibia.tif',236,8,83,596.5477136,96.377899,112.4591743,1.8,96.3753445,112.2471125,-0.2373053,51.0385953,22.204298,44630.9987741,72627.4838828,5.4946649,3270.8750253,874.4558603,2250.924333,3.1549001,20.5497257,1.5131679,51.9359071),(17695,'okapi_tibia.tif',236,8,84,593.5023528,96.5227397,112.2797514,1.8,96.5407962,111.9873023,-0.228482,33.5229416,49.6080363,43897.9809861,72488.5674576,5.0746339,1461.2263026,1309.4907213,1957.3718392,2.7435354,19.8249374,1.670465,47.7594862),(17696,'okapi_tibia.tif',236,8,85,591.7195404,96.6505374,112.106067,1.8,96.6270298,111.836502,-0.222954,36.7322517,49.2043364,43591.6447537,72561.9617388,4.8215548,1474.7066432,1186.7403357,1954.634561,3.1204817,20.610233,1.4749372,51.5694145),(17697,'okapi_tibia.tif',236,8,86,590.0542236,96.7729201,111.9319061,1.8,96.7601839,111.611025,-0.2085583,39.7901621,46.7233939,43198.998796,72549.4048903,4.2158941,1552.7426179,1085.6703403,1974.6700437,2.4193683,14.2523471,1.6539376,41.3512609),(17698,'okapi_tibia.tif',236,8,87,587.8193522,96.9153881,111.7474506,1.8,96.9584509,111.3823439,-0.1984086,35.5559017,48.6252223,42948.7823842,72755.328303,3.8063389,1496.2466983,1207.9227454,1942.6668601,2.0291093,14.2905206,1.6814535,37.349874),(17699,'okapi_tibia.tif',236,8,88,585.5717925,97.0567303,111.5862846,1.8,97.1421044,111.274132,-0.1889897,18.9129542,23.0369391,42673.6444891,73087.2252125,3.4445169,3172.6100807,2256.3182935,5022.3615124,1.7699277,13.0434121,1.6313283,29.634288),(17700,'okapi_tibia.tif',236,8,89,585.3505741,97.2897635,111.3526007,1.8,97.3288568,110.9889433,-0.1810426,30.9729648,43.5636598,42411.2798126,73274.5461085,3.1628333,1682.0107977,1369.2999717,2189.4296635,2.367186,13.4198547,1.6001996,37.4456033),(17701,'okapi_tibia.tif',236,8,90,580.6510754,97.4530697,111.2061632,1.8,97.5272915,110.8250481,-0.1783273,37.9448672,49.3265176,41903.7445824,73223.5673183,3.045028,1484.4665892,1104.3323551,1891.4642868,3.156248,21.3083268,1.5893127,57.0928485),(17702,'okapi_tibia.tif',236,8,91,575.2516022,97.6377029,111.0720174,1.8,97.6829465,110.6793954,-0.1734173,38.9183232,41.8558792,41417.8207635,73216.5542744,2.8545234,1749.2537666,1064.2241831,2005.7194177,3.5986833,22.5193926,1.5182133,59.4600345),(17703,'okapi_tibia.tif',236,8,92,570.8454419,97.8182153,110.9422867,1.8,97.7817808,110.5776007,-0.1716464,43.3448369,38.8770435,41110.7839014,73613.503947,2.7756666,1893.4954225,948.4586123,2038.0032528,4.1876987,20.9250257,1.5330784,59.4203822),(17704,'okapi_tibia.tif',236,8,93,565.0378232,98.0195524,110.8335564,1.8,97.9704587,110.509897,-0.1707847,57.9844804,45.923905,40781.068033,73773.125616,2.7201793,1606.421006,703.3100537,1840.1856033,3.550779,20.9138647,1.589662,59.4203822),(17705,'okapi_tibia.tif',236,8,94,558.8059746,98.2377954,110.7254459,1.8,98.1938396,110.3760144,-0.170838,42.4566868,49.3094322,40396.5599096,74020.3747693,2.6918429,1501.1402785,951.476975,1914.5044937,5.128903,22.0972583,1.5886516,60.5759367),(17706,'okapi_tibia.tif',236,8,95,552.6594059,98.4516857,110.645702,1.8,98.4136024,110.3447032,-0.1659143,40.3808947,49.629913,40085.93384,74467.5647735,2.5123804,1500.4572913,992.6955351,1934.3158752,2.367186,17.4309493,1.6614562,43.66237),(17707,'okapi_tibia.tif',236,8,96,548.055234,98.6755999,110.5435874,1.8,98.7140171,110.2962518,-0.1584587,57.417773,33.7601899,40176.4759173,75107.5588494,2.2744016,2224.737453,699.7219468,1935.2138534,1.6303434,9.5993535,1.4056476,22.8034933),(17708,'okapi_tibia.tif',236,8,97,546.2769025,98.9937086,110.3355439,1.8,99.0430111,110.0128912,-0.1486122,56.0362425,40.3136622,39946.9299694,75779.012531,1.9960471,1879.7352659,712.8766697,1676.4391626,1.8996857,13.8592176,1.485291,33.8667858),(17709,'okapi_tibia.tif',236,8,98,541.3714679,99.1800746,110.2410785,1.8,99.1490842,109.9563341,-0.143305,39.3779592,41.0786575,39926.7407349,76192.0287365,1.8403129,1854.7838069,1013.9362621,2081.3106445,1.8613018,12.6496262,1.6332151,34.2332784),(17710,'okapi_tibia.tif',236,8,99,538.1134261,99.3955435,110.1330381,1.8,99.3710663,109.8654178,-0.1331255,43.3579094,38.4202313,40084.6476353,76889.9915106,1.5800767,2001.289135,924.5060057,2019.1997478,2.3952827,13.898471,1.6845883,35.2137989),(17711,'okapi_tibia.tif',236,8,100,536.5990945,99.5992232,110.0383895,1.8,99.49593,109.8126582,-0.1232578,38.5023352,29.0603879,40349.7881848,77904.7858203,1.3518466,2680.7896047,1047.9828822,2497.4634599,1.9149664,11.3868509,1.815775,31.037378),(17712,'okapi_tibia.tif',236,8,101,534.9127408,99.7972472,109.9577127,1.8,99.6831448,109.8764204,-0.1163026,54.9829052,60.227929,41062.1214913,79147.2236972,1.2004708,1314.1282634,746.8161484,1505.3303999,2.2121888,13.3966369,1.8086323,32.7112313),(17713,'okapi_tibia.tif',236,8,102,532.8475801,99.9667201,109.8531335,1.8,99.8973611,109.6969655,-0.1028616,54.3568472,44.5490237,41170.6853761,80164.3511902,0.9363236,1799.4637021,757.4148884,1981.1152402,2.4681882,15.7861709,1.5957911,43.9495578),(17714,'okapi_tibia.tif',236,8,103,533.1777568,100.1703138,109.752184,1.8,100.1126921,109.6132951,-0.0958266,40.820999,37.4267303,41712.0932807,82106.5243384,0.8135102,2193.7936784,1021.8293112,2264.338323,1.994672,15.121401,1.7016237,37.9078251),(17715,'okapi_tibia.tif',236,8,104,534.6009125,100.3729151,109.6670292,1.8,100.2315193,109.5590497,-0.0893733,41.0160311,37.5077358,42478.1855816,84260.5301316,0.7098026,2246.4840497,1035.6483661,2280.2903617,1.5182797,5.9703374,1.7033479,14.028082),(17716,'okapi_tibia.tif',236,8,105,539.7347822,100.6677434,109.5053305,1.8,100.4778657,109.3063011,-0.0861797,44.0762809,42.6726747,43525.9058747,86697.8297452,0.6664435,2031.6942953,987.5131245,2124.3667058,2.8233239,17.1291894,1.7094361,44.6428905),(17717,'okapi_tibia.tif',236,8,106,536.089396,100.9093379,109.3988048,1.8,100.8296945,109.1784349,-0.0779916,44.4744067,42.5600672,43682.626354,88089.818001,0.5423772,2069.776291,982.1969445,2141.4106027,2.2468484,14.0100175,1.7405746,37.6767142),(17718,'okapi_tibia.tif',236,8,107,534.5777058,101.1613969,109.3473853,1.8,101.1059459,109.1246612,-0.0724462,53.8922602,35.1647093,44343.9325411,89817.0420375,0.4668006,2554.1812787,822.8256221,2484.8261767,2.5732882,15.7911002,1.7975952,43.7184469),(17719,'okapi_tibia.tif',236,8,108,533.2414337,101.3730946,109.29777,1.8,101.2917666,109.1245221,-0.0683069,36.2777881,35.5993136,45270.7777693,91636.6117378,0.4140244,2574.1117551,1247.8924463,2737.7553919,1.8619915,11.5024564,1.6738779,28.5183858),(17720,'okapi_tibia.tif',236,8,109,533.2338396,101.5936758,109.2549962,1.8,101.5304273,109.0222714,-0.0662008,36.266827,24.7829391,46145.941469,93584.7542899,0.3889183,3776.1765774,1272.4008497,3373.7759312,34.718728,45.8267754,0.0516781,188.7500635),(17721,'okapi_tibia.tif',236,8,110,533.5475546,101.8652622,109.1950121,1.8,101.7591197,108.9890484,-0.0661679,42.4230857,24.9016125,47138.9090086,96012.6629778,0.3887607,3855.680546,1111.1617241,3083.4329075,1.0759321,10.3784902,1.7234457,21.8229727),(17722,'okapi_tibia.tif',236,8,111,538.3422385,102.1546548,109.1574687,1.8,101.9815364,108.9547137,-0.0687299,36.1665177,30.1615663,48456.5550389,99596.129123,0.4231698,3302.0874399,1339.8181018,3326.0439559,0.394531,2.3998384,1.735945,5.0612122),(17723,'okapi_tibia.tif',236,8,112,542.1912493,102.4488448,109.10516,1.8,102.3076303,108.9328933,-0.066815,41.464401,32.4346357,49740.0924793,103028.3089101,0.4028121,3176.4903947,1199.5854597,3078.7904962,33.0832653,47.3847992,0.0416426,134.8531153),(17724,'okapi_tibia.tif',236,8,113,547.5872321,102.9199991,109.0174204,1.8,102.7821982,108.8304352,-0.0643959,20.1006598,25.4360156,50869.6850444,106508.6698167,0.3779369,4187.3173686,2530.747027,6179.7157372,1.2340553,4.9904663,1.8925469,11.3340558),(17725,'okapi_tibia.tif',236,8,114,549.8642719,103.1951004,109.0193694,1.8,103.0505591,108.8177654,-0.0647042,36.3483783,34.9975393,51934.4088022,108792.1943336,0.3831452,3108.5669631,1428.7957591,3185.3400823,33.7103483,48.1537975,0.1314687,136.9891904),(17726,'okapi_tibia.tif',236,8,115,550.8720182,103.3917658,108.9796426,1.8,103.3193645,108.7325072,-0.0662754,19.6919068,25.8046821,53178.6120986,111086.077171,0.4026875,4304.8806736,2700.5313672,6347.8685603,0.394531,0.8821981,2.677945,1.6738533),(17727,'okapi_tibia.tif',236,8,116,553.1995278,103.6516465,108.9574051,1.8,103.5172065,108.7211227,-0.069302,31.5975604,26.2821522,54538.2966393,114304.3452098,0.4421068,4349.1242368,1726.0287196,4723.3129391,0.394531,0.8821981,2.677945,1.6738533),(17728,'okapi_tibia.tif',236,8,117,557.4162139,103.9320497,108.9215042,1.8,103.7683226,108.7664563,-0.0744675,19.5743011,39.3177661,56114.6624909,118030.376931,0.5142323,3001.9604011,2866.7517715,4260.6402254,0.394531,0.8821981,2.677945,1.6738533),(17729,'okapi_tibia.tif',236,8,118,562.7227188,104.2629904,108.8745678,1.8,104.0937894,108.6821446,-0.0818989,51.3911863,26.5276994,58042.1608064,121389.2841157,0.6276661,4575.9446505,1129.4185831,3290.4131513,0.394531,0.8821981,2.0344439,1.9049642),(17730,'okapi_tibia.tif',236,8,119,573.662179,104.5560878,108.8410365,1.8,104.3515786,108.6109177,-0.0930257,50.6396422,26.6758209,60728.8553948,126106.169412,0.8250073,4727.3585284,1199.235475,3618.3515698,0.394531,0.5579511,2.3561945,1.1159022),(17731,'okapi_tibia.tif',236,8,120,583.945531,104.8633726,108.80458,1.8,104.6216269,108.5090638,-0.0996168,19.9272243,26.767815,63329.8111773,131126.0476358,0.9626071,4898.6459215,3178.0548235,7257.2123204,35.50779,51.1127054,0.1549967,145.4377615),(17732,'okapi_tibia.tif',236,8,121,597.9091263,105.3297753,108.7268136,1.8,105.0454798,108.419472,-0.1110211,20.4466219,26.787173,66742.81724,136638.257309,1.2232361,5100.8838131,3264.2466637,7521.6126879,0.394531,0.8821981,2.677945,1.6738533),(17733,'okapi_tibia.tif',236,8,122,604.6133633,105.634763,108.7524724,1.8,105.420997,108.496594,-0.121265,20.8166179,26.8942774,69152.846215,140304.4100233,1.4745764,5216.887151,3322.0019956,7778.3368271,36.296852,52.0541755,0.2449787,149.0562313),(17734,'okapi_tibia.tif',236,8,123,612.7282094,105.9506268,108.7817327,1.8,105.7563399,108.4605341,-0.1346645,21.8401439,27.0448427,72233.7431677,144327.6237424,1.8407565,5336.6042899,3307.3840342,7899.0538703,36.691383,52.6325648,0.2577052,150.8654662),(17735,'okapi_tibia.tif',236,8,124,624.1607648,106.3087184,108.8704522,1.8,106.0736584,108.5785651,-0.1457405,21.0599186,27.4228575,75784.3080959,149080.2649223,2.1939592,5436.3504939,3598.5090641,8131.2223861,0.789062,1.2476166,1.8925469,3.0208664),(17736,'okapi_tibia.tif',236,8,125,639.9708496,106.6195249,108.9241391,1.8,106.3807812,108.6468044,-0.1568628,51.2930555,28.2108091,80198.8545773,154792.0877603,2.6030595,5486.9779679,1563.5421573,4472.9108935,0.394531,0.8821981,2.0344439,1.9049642),(17737,'okapi_tibia.tif',236,8,126,652.1011154,107.0000315,109.0018698,1.8,106.7319687,108.7357808,-0.1651982,21.9818449,31.4550074,84199.686439,160393.0767368,2.9391399,5099.1269688,3830.4194584,7721.0754202,38.5196652,54.9093046,0.2990272,158.5810522),(17738,'okapi_tibia.tif',236,8,127,667.3406549,107.4111656,109.119212,1.8,107.0116244,108.7603072,-0.1673296,22.9626883,31.832777,88855.5118213,166595.0045167,3.0852092,5233.442386,3869.5605047,7961.8946635,0.789062,1.4225018,0.5880026,2.7897555),(17739,'okapi_tibia.tif',236,8,128,678.5056258,107.8074231,109.2709796,1.8,107.3161076,108.8733457,-0.1744724,22.9261233,32.2818287,93279.4036021,172371.005443,3.4075658,5339.5675722,4068.6950162,8043.0531238,0.394531,0.5579511,2.3561945,1.1159022),(17740,'okapi_tibia.tif',236,8,129,698.0573667,108.3587351,109.3800806,1.8,107.8380391,109.0151516,-0.1769143,23.7494384,29.796356,99370.6832316,180653.2833897,3.6035445,6062.9320968,4184.1277065,9322.6358616,0.789062,1.1159022,2.3561945,2.2318044),(17741,'okapi_tibia.tif',236,8,130,713.4212413,108.7165572,109.4491973,1.8,108.1742475,109.0592689,-0.1773978,24.1645397,32.3135252,104492.3512071,187211.8697407,3.7028052,5793.6071303,4324.2020206,7677.1898046,0.394531,3.1808106,1.6951513,6.6393362),(17742,'okapi_tibia.tif',236,8,131,730.4333105,108.9305547,109.6097631,1.8,108.4829406,109.1742936,-0.1794168,24.1074722,34.7080137,110552.8966103,193569.5994251,3.8769535,5577.0866453,4585.8352887,8547.6235923,0.394531,0.8821981,2.0344439,1.9049642),(17743,'okapi_tibia.tif',236,8,132,756.8178687,109.2442319,109.6914241,1.8,108.8703431,109.2235453,-0.186829,24.4979839,35.8639851,116771.5592953,206185.94392,4.351808,5749.1085657,4766.5783385,8807.1270963,44.187472,61.2946795,0.2871412,211.4578275),(17744,'okapi_tibia.tif',236,8,133,805.6103375,109.7493452,109.5522349,1.8,109.2904521,109.2018168,-0.2092604,25.0600754,35.2479954,125225.0733158,230017.1046964,5.7942804,6525.6790412,4996.9950834,9621.9001512,45.3434982,63.461878,0.2706141,206.125852),(17745,'okapi_tibia.tif',236,8,134,888.0087053,110.463907,109.4391323,1.8,109.565533,109.3810434,-0.2268919,25.4035056,33.1591806,137586.5896862,265744.0323233,7.4892553,8014.1917786,5416.0473775,12163.2263003,46.1133262,66.2295231,0.2652071,252.9212422),(17746,'okapi_tibia.tif',236,8,135,1007.0279095,111.1281364,109.4753227,1.8,109.5971104,109.6115751,-0.2521465,26.1265152,35.1445337,152367.7707659,321554.8504787,10.4465435,9149.4982635,5831.9209308,13480.1937668,48.6210577,69.3836355,0.3001712,311.4568331),(17747,'okapi_tibia.tif',236,8,136,1141.2549091,111.3394251,109.5121969,1.8,109.1885259,109.843409,-0.2819999,27.0399023,36.7660818,169542.0503556,380180.0026838,14.7294476,10340.5090808,6270.0688846,14677.4545993,48.921844,71.2125723,0.3743336,296.0653135),(17748,'okapi_tibia.tif',236,8,137,1078.868407,108.9120679,110.3298248,1.8,108.2573538,110.1789438,-0.2862966,36.4375973,35.5641822,179019.0266755,345420.4538872,14.3400675,9712.5937463,4913.0304965,11856.4007887,0.789062,1.4225018,2.5535901,3.0208664),(17749,'okapi_tibia.tif',236,8,138,982.4202206,104.7644444,111.4395891,1.8,104.6476409,111.2121754,-0.1014451,34.2068645,36.72921,178069.3943522,271977.7691596,1.6792611,7404.9447154,5205.6625681,10404.326897,0.394531,0.8821981,2.677945,1.6738533),(17750,'okapi_tibia.tif',236,8,139,896.2618482,100.5106272,112.0973516,1.8,100.9608302,112.4835249,0.5763224,36.9929828,33.0980349,148367.746094,202322.7634382,44.3595845,6112.8331122,4010.6997318,8558.6310116,0.394531,0.8821981,2.0344439,1.9049642),(17751,'okapi_tibia.tif',236,8,140,792.8066999,98.7130169,113.1014198,1.8,98.545615,113.009059,0.8983626,30.9542184,35.67612,117938.7196154,166954.7092359,80.8670582,4679.73281,3810.101678,7923.4044468,1.4979888,4.617867,1.2220253,10.871834),(17752,'okapi_tibia.tif',236,8,141,621.2869544,97.5119573,115.0679964,1.8,97.4739532,114.9271655,0.9925769,28.5403663,29.0490771,94369.9462767,129064.1047183,72.618191,4442.9674702,3306.5429227,6444.0526518,0.394531,0.5579511,2.3561945,1.1159022),(17753,'okapi_tibia.tif',236,8,142,439.6096542,97.0016723,118.6122902,1.8,96.867999,117.8254312,0.9974429,36.6229799,54.8618809,69372.3414807,85597.1674384,51.7087606,1560.2302731,1894.2298417,2813.2384907,31.6016182,56.0247912,2.8042532,273.0307093),(17754,'okapi_tibia.tif',236,8,143,339.5408448,96.8258013,121.9989077,1.8,97.4081689,120.712034,0.1888172,43.7149431,34.0639707,42072.6914722,57586.9952983,1.9936862,1690.5543912,962.4327181,2206.7964218,23.458455,52.5496928,2.788973,214.5347707),(17755,'okapi_tibia.tif',236,8,144,238.9226687,96.7639198,124.8688702,1.8,96.9306545,125.0190599,0.0694802,46.5150091,30.5092039,4771.8507446,41849.6363925,0.1919242,1371.7052891,102.5873334,945.3075897,22.7285421,48.2845342,2.7474301,228.3317418),(17756,'okapi_tibia.tif',236,8,145,186.1332229,97.5675791,124.1693189,1.8,98.0039362,124.3506587,0.0617781,13.8782635,23.1130779,2460.6279329,32113.9897131,0.1182469,1389.4293918,177.3008519,1282.4598653,8.285151,18.9744392,1.5083775,57.2282302),(17757,'okapi_tibia.tif',236,8,146,142.1729367,97.7999968,123.7990431,1.8,98.5578162,124.0168926,0.0302747,36.1600236,33.8998651,1453.0047715,23788.4132248,0.0217117,701.7258957,40.1826278,509.2528037,7.89062,18.5806928,1.507053,64.0754495),(17758,'okapi_tibia.tif',236,8,147,60.0753598,92.6421667,123.4621653,1.8,97.3633664,123.6740827,-0.0168538,11.5920405,25.2121824,493.8600352,9931.3212312,0.0028438,393.9096218,42.6033738,397.8704874,6.9191324,15.5677353,1.418147,50.3181307),(17759,'okapi_tibia.tif',236,8,148,18.4198954,88.4659421,123.8397506,1.8,95.5416903,123.6486229,-0.0340623,10.7944029,28.8844093,140.0231685,2172.3073491,0.0035605,75.2069162,12.9718308,77.8340599,5.2898105,12.6803515,1.6642731,36.6565413),(17760,'okapi_tibia.tif',236,8,149,1086.0588999,114.3327887,102.2080804,1.8,114.1405663,102.1720383,-0.9575531,33.4783499,53.5994367,217931.8871539,308717.1840074,121.054579,5759.7094814,6509.6364676,8333.6187645,1.1861154,3.0813856,2.4468544,6.5996838),(17761,'okapi_tibia.tif',236,8,150,1148.4868628,115.1901739,101.8125902,1.8,115.2467708,101.8026317,-0.8991254,40.7585776,49.2044647,213650.6008961,353371.0978305,117.2890627,7181.6876721,5241.8561571,8927.2503168,0.7061587,1.4225018,2.5535901,2.7897555),(17762,'okapi_tibia.tif',236,8,151,1247.0311521,115.4912959,102.0889624,1.8,114.9222615,102.3750952,-0.8920081,35.5299455,44.2707986,225795.4900092,404286.8404793,125.9094078,9132.1334435,6355.0756068,14093.8232583,61.7540893,120.7219733,1.1319974,682.3272451),(17763,'okapi_tibia.tif',236,8,152,1289.8141227,114.8101747,103.133356,1.8,114.1884548,103.3104269,-0.9306825,49.7313186,42.3816673,235042.2774489,438915.6211768,138.2785072,10356.261309,4726.2426152,11074.5825795,0.394531,0.5579511,2.3561945,1.1159022),(17764,'okapi_tibia.tif',236,8,153,1334.8422945,114.2812681,105.8493817,1.8,114.1842446,105.5257459,-1.0276504,57.0810055,60.18083,251870.3353442,492196.5830608,163.0476464,8178.6273657,4412.506986,12285.3499736,0.394531,0.5579511,2.3561945,1.1159022),(17765,'okapi_tibia.tif',236,8,154,1356.4464608,113.3165238,106.9732454,1.8,113.1876741,106.2837117,-1.0903659,57.2739019,51.0029601,262669.1509388,528300.3718131,177.7865567,10358.2296102,4586.1927006,13577.3056018,59.9960145,118.4808846,1.1742122,808.6468486),(17766,'okapi_tibia.tif',236,8,155,1396.1611468,112.2600687,108.2311097,1.8,112.3097703,107.5833359,-1.1405532,46.0549098,53.2270728,286585.9642755,582447.9417346,192.2128607,10942.7009748,6222.7016686,15278.6862964,63.4504979,131.5280203,1.297441,753.4453577),(17767,'okapi_tibia.tif',236,8,156,1407.0479202,111.9319014,109.8004507,1.8,112.1695312,109.3905007,-1.2218383,44.0537391,58.5661238,292829.344373,628228.0074741,207.0920174,10726.8155586,6647.0939884,15624.9568905,4.1846332,9.8869185,2.6422459,27.1877973),(17768,'okapi_tibia.tif',236,8,157,1467.194268,111.0805191,113.0020862,1.8,111.3525677,111.7882366,-1.2369948,56.1699856,62.9908562,313374.487391,686628.8072984,218.2827916,10900.4520368,5579.0380575,15835.1404122,66.2213342,116.3886511,1.4279405,648.1171946),(17769,'okapi_tibia.tif',236,8,158,1541.8210792,111.0086949,116.0587784,1.8,111.4239695,114.8054405,-1.2918353,61.9043693,55.5241447,320548.3177367,816198.7820388,237.4863153,14699.8893304,5178.1210525,17670.9371482,0.394531,0.5579511,2.3561945,1.1159022),(17770,'okapi_tibia.tif',236,8,159,1635.1363136,110.6510512,119.1582523,1.8,110.8160176,117.7953278,-1.2999636,57.6419544,55.0735041,335087.0066299,987982.2947295,253.0170657,17939.3396451,5813.248527,20523.7761662,62.0798737,124.2628607,1.3758914,612.6162079),(17771,'okapi_tibia.tif',236,8,160,1694.809424,110.6734544,120.8957444,1.8,111.0850924,119.1750442,-1.3014026,59.0497815,55.8338771,367482.9071252,1056680.7908831,262.4598029,18925.4417846,6223.272932,23226.7216087,0.394531,0.5579511,2.3561945,1.1159022),(17772,'okapi_tibia.tif',236,8,161,1739.4952026,110.4620096,122.4035755,1.8,110.2188135,120.5552862,-1.3010553,65.1936613,55.6697067,402394.3926773,1035712.9857067,269.3281986,18604.6064693,6172.2932035,19322.4422612,0.394531,0.5579511,2.3561945,1.1159022),(17773,'okapi_tibia.tif',236,8,162,1550.417653,111.1935801,125.2513326,1.8,110.6200812,124.1558145,-1.2290811,66.2710398,58.6822182,371126.4324551,868391.5362384,229.385719,14798.2057029,5600.1299186,16731.0097022,63.0816957,98.593289,1.2237347,714.2397931),(17774,'okapi_tibia.tif',236,8,163,1316.5315461,111.5888314,128.0625737,1.8,110.7094754,127.15963,-1.1239328,70.3879552,61.1760445,329003.7985485,691574.6787446,178.4461341,11304.664827,4674.1491179,14194.9521989,62.4590035,97.2764966,1.2913825,626.8918253),(17775,'okapi_tibia.tif',236,8,164,1135.3095595,112.1769912,130.4858707,1.8,110.9339014,130.7006271,-1.0723645,71.4352576,54.075664,289034.8171615,561685.8000582,145.9761004,10387.0347218,4046.1087011,11762.4595064,58.5144258,95.0557745,1.2976278,546.8272528),(17776,'okapi_tibia.tif',236,8,165,1122.173151,109.4715729,130.3115311,1.8,108.6626768,131.373126,-0.9594086,71.5687531,46.7055919,327714.0747852,459310.6470892,125.4064112,9834.1682163,4579.01054,10978.4670122,62.2057025,84.6956156,1.0967324,529.0124702),(17777,'okapi_tibia.tif',236,8,166,1040.0686876,108.2708185,129.7436469,1.8,108.1324302,131.0132234,-0.8100104,72.6480664,39.1887598,312825.3407959,347348.3838963,90.9370665,8863.4696631,4306.0380839,9045.6132997,61.7822063,78.7956539,0.9994588,528.9892424),(17778,'okapi_tibia.tif',236,8,167,869.7280973,107.7888613,129.8215861,1.8,107.451783,130.7823545,0.1406033,45.337605,63.6427463,238018.849608,261633.4480924,2.8468157,4110.9704268,5249.9211083,6815.1627549,49.4134354,72.0912971,2.2515201,277.6296997),(17779,'okapi_tibia.tif',236,8,168,722.353416,106.578532,130.9413309,1.8,106.5935465,131.6040049,0.2641002,38.2781259,68.5174672,155552.5947044,214937.3734386,8.2037989,3136.9719606,4063.7463587,5033.6771177,48.1870242,70.9815984,2.2498775,236.4698973),(17780,'okapi_tibia.tif',236,8,169,607.8934326,105.7169615,132.3204433,1.8,105.4767965,132.863571,0.3297446,31.8703191,70.5018813,84501.1368838,178885.2323487,10.6226675,2537.3114728,2651.4054201,3583.9337926,48.387202,69.3297731,2.2917677,279.9736578),(17781,'okapi_tibia.tif',236,8,170,574.2609307,106.2848178,132.0689182,1.8,105.5072231,132.8398222,0.3513256,26.345386,70.4865378,69051.0747281,153762.9527259,11.3353608,2181.4513449,2620.9930944,3044.9638332,46.3876689,67.3632078,2.294034,245.9154135),(17782,'okapi_tibia.tif',236,8,171,537.7582504,106.9260726,131.9309351,1.8,106.3862862,132.3512297,0.439531,25.4751082,71.4220231,51521.444958,129649.2409631,16.2280285,1815.2557905,2022.4230052,2490.795893,43.7969718,65.0736996,2.3090192,219.7874415),(17783,'okapi_tibia.tif',236,8,172,464.9186383,106.3857764,132.7252612,1.8,106.2209791,132.4330699,0.4351288,20.1982147,71.349555,35457.6029986,105047.7824997,13.7681893,1472.2976539,1755.4820287,1938.4427926,38.7832587,61.7601706,2.2974387,218.9587271),(17784,'okapi_tibia.tif',236,8,173,368.6131825,104.8863429,133.5018912,1.8,104.9741986,133.0728767,0.4115299,32.8353305,72.0919013,22375.5188256,77787.4296792,9.8302738,1079.0037193,681.4464325,1366.8587629,36.174742,56.4882426,2.2869982,221.8442118),(17785,'okapi_tibia.tif',236,8,174,308.7732858,103.978347,133.4075803,1.8,103.74312,133.1807917,0.4423811,16.7062954,73.1549896,14095.2164094,63463.6933022,9.4311312,867.5237826,843.7068841,1049.9433732,32.9441715,49.999703,2.4064315,190.1531535),(17786,'okapi_tibia.tif',236,8,175,237.2343811,102.9498474,132.6034762,1.8,102.9749321,132.6908727,0.4766116,15.0978637,74.7457143,8395.1693287,51241.7480527,8.3218198,685.5476403,556.0501486,793.3518576,29.2705364,46.3233832,2.3321028,155.2497702),(17787,'okapi_tibia.tif',236,8,176,109.8600094,98.006892,129.1934077,1.8,101.4388723,131.1935268,0.5679304,12.7059359,81.1635065,3216.2344672,26834.7910248,5.2975234,330.6263146,253.1284982,370.2017365,10.652337,26.8744833,1.5120405,73.3923873),(17788,'okapi_tibia.tif',236,8,177,44.0098599,95.7690457,126.6420116,1.8,97.8023104,128.2601036,0.6329307,8.1082261,84.1599563,484.375595,15465.8535641,2.5663942,183.7673668,59.7387874,189.3581977,8.7180878,16.5890786,1.1284221,45.1447647),(17789,'okapi_tibia.tif',236,8,178,8.598602,110.7839226,137.6141537,1.8,107.9232791,135.5957571,0.6192622,4.1101983,65.6047372,29.1928874,11925.1750031,0.4828176,181.7730779,7.1025496,182.0774693,0,0,0,0),(17790,'okapi_tibia.tif',236,8,179,2.243173,161.7310219,173.9184932,1.8,161.6367205,173.9040044,-0.2161098,0.7062366,6.3237348,0.2431073,15.2455966,0.0171905,2.4108533,0.3442292,2.4413977,12.4543935,148.3567715,3.1282956,315.7397718),(17791,'okapi_tibia.tif',236,8,180,2.4700516,156.4756114,172.0969355,1.8,149.1515052,169.5356069,0.3281074,5.2849912,44.5481574,4.7172204,600.0402557,0.042751,13.4694742,0.8925692,13.5749655,12.1708558,147.9575414,3.1309264,314.6238696),(17792,'okapi_tibia.tif',236,8,181,38.7019399,117.8041631,158.7532916,1.8,117.7422637,158.7638994,0.3307506,8.0696181,50.1221319,492.1531718,5222.4703825,0.6802805,104.1948973,60.9884093,113.9616323,16.175771,16.7756882,0.71883,54.5902809),(17793,'okapi_tibia.tif',236,8,182,87.3958745,116.3708419,158.3155247,1.8,116.5935176,158.3769764,0.3301345,10.9523212,51.6208896,2166.5039635,6961.5623016,1.5306856,134.8594019,197.8123107,176.750393,21.699205,22.5435718,0.9973558,71.8703402),(17794,'okapi_tibia.tif',236,8,183,124.2024117,116.0291977,158.4715592,1.8,115.9012066,158.3713788,0.2635955,24.6109561,51.8981704,4373.7374845,10106.7030997,1.4053123,194.741029,177.715058,278.8742828,24.855453,25.7444704,2.8780288,83.204396),(17795,'okapi_tibia.tif',236,8,184,347.8910597,98.2790719,162.3527664,1.8,101.5922513,161.4857157,-0.161681,22.3540367,64.925615,14512.8705418,97853.1867694,1.5025268,1507.1584113,649.2281788,1643.8706583,30.773418,146.7660623,3.1389045,411.9520769),(17796,'okapi_tibia.tif',236,8,185,552.3283331,95.3653519,162.9294309,1.8,101.7136746,161.6673432,-0.1305261,20.3370156,68.4540379,22730.192389,123924.9523337,1.5594552,1810.3380908,1117.6759067,2061.4570461,38.2377081,145.9770031,3.13889,497.7151175),(17797,'okapi_tibia.tif',236,8,186,552.7108663,95.3831748,163.0259847,1.8,101.6854263,161.8911551,-0.1211093,19.6364424,68.6233836,22687.0598947,124889.6220843,1.344551,1819.9280703,1155.3548996,2075.3451408,38.3099774,145.9770031,3.13889,505.2953218),(17798,'okapi_tibia.tif',236,8,187,551.2946915,95.3923583,163.1334407,1.8,101.6550975,162.0638593,-0.1103456,18.8812479,68.8180362,22476.7662138,125390.5014923,1.1142414,1822.058698,1190.4280024,2078.4333548,37.9056623,145.187944,3.1388753,495.3082791),(17799,'okapi_tibia.tif',236,8,188,553.5560242,95.3961511,163.2073545,1.8,101.6439406,162.1854691,-0.1035666,18.4092347,68.897185,22489.3016858,126423.2737164,0.9860448,1834.9555744,1221.6315386,2093.5673609,37.6991807,144.398885,3.1388604,476.7208591),(17800,'okapi_tibia.tif',236,8,189,556.0825832,95.4470582,163.2521881,1.8,101.7042882,162.2550285,-0.1007216,18.2532755,68.8997182,22597.6896253,127405.7525407,0.9370533,1849.1476573,1238.0073745,2110.5983677,37.2816822,144.0059768,0.0054794,479.3752329),(17801,'okapi_tibia.tif',236,8,190,559.6887726,95.5287101,163.2796445,1.8,101.8014303,162.308805,-0.0999813,18.247708,68.8337514,22801.3328035,129047.2678538,0.9293639,1874.7673225,1249.5450259,2137.2903505,36.7856358,143.6098259,3.1388454,471.2370775),(17802,'okapi_tibia.tif',236,8,191,567.3739645,95.6246682,163.2624465,1.8,101.9724783,162.3108978,-0.1027393,18.5602815,68.6492733,23300.617422,131397.1125759,0.9946318,1914.0350118,1255.4021559,2180.2180235,36.3014077,142.8207669,3.1388302,466.869198),(17803,'okapi_tibia.tif',236,8,192,576.5585358,95.8330867,163.1688522,1.8,102.226859,162.1637428,-0.1133718,19.4381816,68.2420421,24162.8309156,134471.2008155,1.2298178,1970.5037637,1243.0602496,2239.7176181,35.8737663,142.4278768,3.1360525,464.9245815),(17804,'metatarsus-pes',236,10,1,0.1490641,93.7807535,132.1619607,1.8,93.9040605,132.1318022,-0.2107451,1.4962957,30.0839987,0.0658543,71.6992449,0.0010872,2.3833017,0.0440115,2.3847911,0,0,0,0),(17805,'metatarsus-pes',236,10,2,0.2099631,92.5507973,131.8731889,1.8,91.7014321,131.9904373,-0.1740107,6.2988205,39.6767059,0.9081941,127.7355618,0.001049,3.2194094,0.1441848,3.2021984,0,0,0,0),(17806,'metatarsus-pes',236,10,3,0.2300755,95.1464238,130.6633998,1.8,94.2576784,130.7550224,-0.1523365,9.3893815,54.983411,2.6196459,171.4920833,0.000883,3.1189786,0.2790009,3.121437,0,0,0,0),(17807,'metatarsus-pes',236,10,4,0.151124,97.4306816,130.8324696,1.8,96.7186124,130.9763762,-0.1635731,9.5081549,55.1339568,1.1817455,110.1589837,0.0006679,1.9980243,0.1242876,1.9900818,0,0,0,0),(17808,'metatarsus-pes',236,10,5,0.1303749,94.6289568,131.262505,1.8,93.8450814,131.3523522,-0.1438724,6.7954331,48.4521889,0.98335,102.7455388,0.0004467,2.1205552,0.1447075,2.1201006,0,0,0,0),(17809,'metatarsus-pes',236,10,6,0.0074907,75.234268,136.757618,1.8,75.234268,136.757618,0.7853982,0,0,0.0000772,0.0000772,0.0006242,0,0,0,0.351562,0.4971837,2.3561945,0.9943675),(17810,'metatarsus-pes',236,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(17811,'metatarsus-pes',236,10,8,0.0719103,58.9003679,133.7625661,1.8,58.7889789,133.7498098,0.1702573,0.9596072,16.9516798,0.010665,6.2159268,0.0003441,0.366685,0.0111139,0.3673042,0,0,0,0),(17812,'metatarsus-pes',236,10,9,0.3103754,79.4505514,124.9964755,1.8,76.1633961,126.0098654,-0.258165,10.2949337,36.9149939,1.1339669,71.6984021,0.0033718,1.9422569,0.1101481,1.9646538,0,0,0,0),(17813,'metatarsus-pes',236,10,10,11.191079,86.5242167,124.4196956,1.8,85.0196366,124.9158153,-0.2079301,9.9592512,47.0303373,67.7363412,167.6639261,0.0794854,3.5650164,6.8013488,4.9891938,4.4720459,10.7844186,1.9028558,26.9892575),(17814,'metatarsus-pes',236,10,11,34.2672462,85.5920529,124.9065642,1.8,84.1497692,124.906412,0.1959773,14.165903,28.1918389,260.6956315,361.7924676,0.216557,12.8332341,18.4030366,19.7496274,11.5543384,14.956887,0.5162307,50.6335014),(17815,'metatarsus-pes',236,10,12,82.7400739,83.9539364,125.2525467,1.8,84.1013481,125.6042123,0.0266578,11.8083688,41.2692618,609.2816247,2367.8544029,0.0097973,57.3757392,51.5974421,72.0574027,13.353076,27.1067753,3.0896913,97.0129251),(17816,'metatarsus-pes',236,10,13,156.1146544,84.6671369,125.1769544,1.8,84.2745427,125.0485444,-0.1057841,20.5853153,37.9861452,2578.4937926,16417.9859211,0.2900766,432.2098449,125.2588924,489.5019105,15.82029,42.8227915,0.1151903,131.3100303),(17817,'metatarsus-pes',236,10,14,249.8500764,83.5220789,121.9333763,1.8,82.680568,118.8047954,-0.1646032,39.0472292,32.9759029,25827.2600815,41345.7420067,1.1180956,1253.8168279,661.4364356,1716.1501893,17.7284345,44.3037869,0.1273077,194.705765),(17818,'metatarsus-pes',236,10,15,512.3015726,83.1844482,111.0874087,1.8,82.1859706,110.5729254,-1.3836855,33.597347,30.4082957,82951.8157476,126241.5951319,82.4289998,4151.5511505,2468.998986,5490.0337431,51.4006865,57.5800174,0.2153577,412.8816162),(17819,'metatarsus-pes',236,10,16,935.0941392,80.97309,107.3482158,1.8,80.2857097,108.8679557,-0.3114666,37.0094764,36.9309822,168382.9552904,228417.3462136,14.6365123,6184.9789102,4549.7254127,9077.3476938,50.9686383,58.4196194,0.2245436,222.3214166),(17820,'metatarsus-pes',236,10,17,1035.8451981,80.5519057,106.6360019,1.8,80.2267816,108.6037215,-0.2686737,36.8093999,39.3054458,176603.3345047,252280.4592758,12.1651885,6418.4606969,4797.7781549,9535.750471,50.996229,58.4450017,0.7556197,276.91169),(17821,'metatarsus-pes',236,10,18,992.7695386,80.3223714,106.7378643,1.8,80.0004794,108.6999365,-0.2607278,36.5528365,48.0485936,166798.3754257,234387.1060896,10.9953381,4878.1262558,4563.2129114,8112.492563,50.8674549,58.322218,2.5753258,299.1057787),(17822,'metatarsus-pes',236,10,19,925.859882,79.9617781,107.0991472,1.8,79.7313944,108.8554559,-0.214321,35.0333201,42.5894696,155851.6802882,213797.9834633,6.9801301,5019.9729065,4448.6700053,8099.2658098,50.1656424,58.1821833,2.6022094,309.0640894),(17823,'metatarsus-pes',236,10,20,865.1041746,79.7591596,107.3977575,1.8,79.6135937,108.9413406,-0.1861721,29.4359037,30.8458456,145191.8504075,197212.8914898,4.9399532,6393.4992671,4932.4746999,9098.0633337,49.7942632,57.6497366,2.5823469,292.862966),(17824,'metatarsus-pes',236,10,21,823.3207283,79.7472063,107.5604359,1.8,79.5379771,108.9568877,-0.1851199,32.9538259,37.1528693,136787.6893082,185182.6167296,4.648976,4984.3422639,4150.889485,6552.3097719,48.0701225,56.9161397,2.6032918,218.9971011),(17825,'metatarsus-pes',236,10,22,790.0441589,79.7501019,107.7936554,1.8,79.5586727,108.9576149,-0.2118826,33.2971438,39.0647062,128097.934502,175727.178036,5.8234717,4498.3616904,3847.1147948,5968.6778876,48.0655007,55.6001722,2.5816529,259.9721088),(17826,'metatarsus-pes',236,10,23,765.2801219,79.6622456,108.0216335,1.8,79.5109461,109.0207274,-0.2600533,35.0292097,37.5010401,120082.2874238,167117.7030284,8.4329914,4456.3484781,3428.0615628,5627.1161224,0.703124,3.1835293,1.6814535,6.910603),(17827,'metatarsus-pes',236,10,24,739.5427489,79.496542,108.1325691,1.8,79.4188269,108.9794625,-0.3039493,36.742605,36.4724431,112010.9739834,158202.1616395,11.0407529,4337.5806032,3048.5310978,5235.8398806,0.703124,2.1384682,1.735945,4.801231),(17828,'metatarsus-pes',236,10,25,714.0550396,79.514755,108.2184613,1.8,79.447518,108.9655253,-0.3343548,35.9372032,48.093211,104268.1526194,148539.106346,12.8159568,3088.5670431,2901.3986448,5193.0088985,0.351562,0.7861165,2.0344439,1.6974915),(17829,'metatarsus-pes',236,10,26,691.6332186,79.5109326,108.3006477,1.8,79.4460973,108.9319493,-0.3510162,27.1595406,48.1804745,98048.3884859,139789.3218758,13.6291317,2901.3687274,3610.0901007,4889.7328589,1.3804113,3.5331544,1.670465,8.4874575),(17830,'metatarsus-pes',236,10,27,667.4422918,79.5673565,108.3318474,1.8,79.5792839,108.8308619,-0.3579053,35.9443618,39.9923156,92346.8333247,130382.5823764,13.6513305,3260.1908772,2569.1604695,5360.786902,1.6472196,9.5505879,1.4601391,22.8911505),(17831,'metatarsus-pes',236,10,28,646.6663929,79.563321,108.4252402,1.8,79.6305817,108.7638101,-0.3694739,34.2519844,37.2588563,87689.2921612,123728.738111,14.0554209,3320.7873349,2560.1229743,5393.2667255,1.3859215,9.2012581,1.4559197,22.47927),(17832,'metatarsus-pes',236,10,29,624.3156958,79.5717188,108.4560671,1.8,79.7069967,108.7206194,-0.379703,34.3206517,35.0922556,83478.2871845,116735.8676857,14.2944847,3326.542155,2432.3048379,5365.701568,1.7370016,12.3247429,1.5137155,28.807386),(17833,'metatarsus-pes',236,10,30,602.9618927,79.6062364,108.4583564,1.8,79.6318062,108.7073108,-0.3848185,27.6238255,34.0163765,79263.7111917,110110.912639,14.1614018,3236.9971181,2869.3966121,5182.7882755,1.75781,8.7960784,1.610775,21.6055395),(17834,'metatarsus-pes',236,10,31,584.6431166,79.5705143,108.4697673,1.8,79.5455302,108.6307305,-0.3941911,26.478322,25.0738051,75678.6167841,104979.9839027,14.3727869,4186.8389537,2858.1349271,6380.9618542,41.4401276,49.6549435,0.9513699,193.8259722),(17835,'metatarsus-pes',236,10,32,571.0799713,79.5815154,108.4816335,1.8,79.5331338,108.754522,-0.411332,26.0066437,36.3006769,72845.8233225,100430.6249032,15.2159016,2766.6322948,2801.0466887,4575.3417277,1.054686,10.5702715,1.5042282,24.9152192),(17836,'metatarsus-pes',236,10,33,556.470943,79.6533876,108.4610941,1.8,79.4861886,108.810356,-0.4358685,35.0657436,34.3975758,69525.4150204,95436.3293206,16.531917,2774.5074212,1982.7161151,4570.601335,1.3702562,6.1397664,1.801887,15.3627267),(17837,'metatarsus-pes',236,10,34,546.7718906,79.6768341,108.5082893,1.8,79.4725235,108.8894669,-0.4498983,24.5548989,26.4251409,66884.8844977,92043.5264561,17.233828,3483.1801566,2723.8916644,5670.616763,1.7199312,14.7823356,1.6183794,35.5120487),(17838,'metatarsus-pes',236,10,35,535.489538,79.7267597,108.5572284,1.8,79.5453661,109.0021144,-0.4656427,23.6591242,33.1594055,64336.5132354,88908.2068802,17.9923084,2681.2364567,2719.3108503,4403.1602714,1.9853937,12.3247429,1.6278771,33.2820397),(17839,'metatarsus-pes',236,10,36,525.9558043,79.7451136,108.5736882,1.8,79.5838267,109.0151512,-0.4767399,39.7492998,32.8097265,62151.2232486,86097.3181554,18.4588989,2624.1400788,1563.5803295,3473.4356522,1.6651794,15.4846998,1.6162196,36.3004759),(17840,'metatarsus-pes',236,10,37,518.1807646,79.7383604,108.5993484,1.8,79.5324401,109.0452356,-0.4899763,38.1328824,24.8977666,59957.2358169,83863.1950987,19.1268342,3368.3019242,1572.3237289,3586.4513864,1.6450394,16.5383673,1.6133239,39.0276687),(17841,'metatarsus-pes',236,10,38,513.8088801,79.7680606,108.6031967,1.8,79.5113533,109.0820196,-0.5076137,39.0115646,30.8223665,58202.827219,81883.4605473,20.2343582,2656.6247144,1491.9377817,3408.3114299,0.351562,0.7861165,2.0344439,1.6974915),(17842,'metatarsus-pes',236,10,39,512.274007,79.816025,108.652076,1.8,79.5787127,109.1384147,-0.5212961,34.3915275,30.1975976,56937.7632191,80359.6379078,21.1747153,2661.1268529,1655.575294,3963.3592433,1.406248,8.5538726,1.735945,21.073022),(17843,'metatarsus-pes',236,10,40,509.1815267,79.8806665,108.7285212,1.8,79.6277421,109.2055635,-0.5302176,23.3368496,30.1790324,55672.5082264,78552.8996314,21.7041829,2602.8965581,2385.6051302,4208.5457362,1.406248,14.4183287,1.5951817,32.1523995),(17844,'metatarsus-pes',236,10,41,508.3536219,80.0048714,108.7547192,1.8,79.8101663,109.1907366,-0.5449154,35.1509654,28.7983863,54482.8800493,76571.9502639,22.764271,2658.897255,1549.968244,3675.1264282,37.265572,45.9847934,0.9318823,209.1033956),(17845,'metatarsus-pes',236,10,42,505.9580349,80.0213402,108.8222811,1.8,79.8060792,109.2865961,-0.5583885,35.4232631,32.5025109,53278.5470619,74712.1636163,23.6711927,2298.6582106,1504.0553144,3551.4765079,1.6835851,13.728935,1.6220335,34.1911039),(17846,'metatarsus-pes',236,10,43,503.2735707,80.046532,108.864768,1.8,79.8229756,109.3795241,-0.5660359,34.6694164,22.671025,52116.8725151,73075.6527575,24.1242054,3223.3060862,1503.2520858,3571.4614787,1.406248,9.5957751,1.7178747,24.6739452),(17847,'metatarsus-pes',236,10,44,502.5780257,80.0544078,108.9383216,1.8,79.8322169,109.4486385,-0.5775335,34.3661619,22.5099067,51154.596858,71750.626515,24.9673515,3187.5132732,1488.5164374,3539.0534251,1.6585845,11.2719352,1.6332151,26.115527),(17848,'metatarsus-pes',236,10,45,501.1159244,80.0908737,108.9989145,1.8,79.9041539,109.4773049,-0.5878619,31.0308504,22.7535338,50141.2618811,70507.743651,25.6874035,3098.7601413,1615.8520067,3887.8232565,1.5455428,14.4311812,1.6195382,32.323006),(17849,'metatarsus-pes',236,10,46,501.2320296,80.0983826,109.0677631,1.8,79.9049397,109.5615342,-0.6025041,31.7587419,22.5565485,49415.3199116,69491.1296626,26.8290554,3080.7519066,1555.9596176,3743.7361534,1.75781,12.3096913,1.59936,30.2989372),(17850,'metatarsus-pes',236,10,47,500.8851373,80.1097959,109.1077056,1.8,79.889534,109.606259,-0.6090266,33.0420659,22.5548309,48822.3517881,68419.855527,27.3202248,3033.4900645,1477.5816954,3536.2373714,1.75781,12.6611139,1.598567,31.619882),(17851,'metatarsus-pes',236,10,48,499.9647228,80.1291943,109.1541414,1.8,79.9730432,109.6290985,-0.6171602,33.0140671,22.9543618,48166.817989,67399.3496242,27.9079182,2936.2327778,1458.9786185,3490.7532439,1.406248,10.5527177,1.6041173,24.3327322),(17852,'metatarsus-pes',236,10,49,499.1250201,80.2089071,109.1531881,1.8,80.0242885,109.64139,-0.6279095,29.3025859,22.9439113,47251.0827745,66090.1108576,28.7082171,2880.5075933,1612.5226288,3816.4958094,1.6467738,15.4846998,1.525373,36.421113),(17853,'metatarsus-pes',236,10,50,496.7270736,80.1881266,109.1766837,1.8,79.9596625,109.6464723,-0.6362881,19.8009861,22.8719857,46394.9614725,64853.5893091,29.2315877,2835.5032343,2343.0631818,4780.9409864,0.351562,0.4971837,2.3561945,0.9943675),(17854,'metatarsus-pes',236,10,51,495.6189807,80.1924468,109.208948,1.8,79.9907033,109.690088,-0.6435622,20.0474805,22.8162267,45714.2517905,63926.2431665,29.7419857,2801.788575,2280.2991051,4370.2779808,1.3529214,7.9316002,1.3473197,18.5018),(17855,'metatarsus-pes',236,10,52,495.2995416,80.2090389,109.2336013,1.8,80.0132962,109.7212791,-0.6522729,33.6750121,22.8535695,45247.1320768,63114.0206583,30.4148642,2761.6701431,1343.6411528,3214.040741,1.976193,15.5046415,1.5027199,39.9867024),(17856,'metatarsus-pes',236,10,53,495.0530616,80.2254191,109.266934,1.8,80.0512415,109.7732641,-0.6598082,35.220782,22.9740979,44754.5133489,62463.191953,31.0007571,2718.8528639,1270.6848276,3034.2777661,1.8768443,16.5383673,1.5282688,42.8845017),(17857,'metatarsus-pes',236,10,54,495.0162824,80.2268705,109.2800885,1.8,80.0307308,109.7524573,-0.6678742,19.5548827,22.8610173,44215.0742146,61882.5105164,31.6443475,2706.900996,2261.0759089,4063.0046384,1.9233453,15.8554072,1.5042282,38.0333012),(17858,'metatarsus-pes',236,10,55,495.3387552,80.2336452,109.3094158,1.8,80.0158586,109.7746981,-0.6721433,20.013252,23.1322823,43787.1575613,61309.5480222,32.0080596,2650.3890589,2187.9081702,3972.8906554,1.1600305,8.1544198,1.4410938,18.5018),(17859,'metatarsus-pes',236,10,56,495.7455728,80.2577868,109.3359614,1.8,80.1296727,109.7921055,-0.6729893,46.0224756,22.6939464,43387.0647569,60746.5947928,32.1024682,2676.7752796,942.7364385,2085.2773381,1.3617962,5.6687669,1.4464413,13.4946287),(17860,'metatarsus-pes',236,10,57,496.4110802,80.318495,109.3212728,1.8,80.137548,109.7836503,-0.6846283,20.1116656,22.7393293,42763.0911702,59874.2731953,33.0867051,2633.071199,2126.2829223,3883.622975,1.7699961,15.8554072,1.5042282,37.8773304),(17861,'metatarsus-pes',236,10,58,494.6035098,80.3156823,109.3615579,1.8,80.1623284,109.8547798,-0.6870104,20.0395383,21.9049119,42179.5452581,58953.1050322,33.1587054,2691.3189692,2104.8162153,4483.238291,1.8478894,13.751423,1.4940244,36.7623259),(17862,'metatarsus-pes',236,10,59,494.3565428,80.3195431,109.3942235,1.8,80.1491143,109.9324343,-0.691866,37.6029697,26.1611452,41810.0516575,58256.7735056,33.5348737,2226.8434019,1111.8816409,2640.5843202,2.618273,15.1335089,1.5243182,41.2723134),(17863,'metatarsus-pes',236,10,60,493.8168784,80.3307653,109.4086405,1.8,80.1886546,109.9478343,-0.6967516,18.9589677,23.7483526,41379.9727714,57659.1187827,33.8937104,2427.9207851,2182.6068506,3565.1014977,0.703124,0.9943675,2.3561945,1.988735),(17864,'metatarsus-pes',236,10,61,494.7892406,80.3396808,109.4176106,1.8,80.2227013,109.9822041,-0.7006741,19.2822446,23.2261915,41138.5082857,57273.3213627,34.2790628,2465.8937839,2133.4916732,3541.4219363,1.7154337,8.6186484,1.3654009,21.2789622),(17865,'metatarsus-pes',236,10,62,495.9132886,80.3466613,109.4241676,1.8,80.1943493,109.9918434,-0.7031722,19.2796957,22.7289771,40943.6505958,56932.1990966,34.5605418,2504.8289179,2123.666844,3547.2319973,1.9187214,14.1019753,1.4959365,37.0035999),(17866,'metatarsus-pes',236,10,63,496.3756869,80.3462223,109.4442907,1.8,80.2235006,110.0121263,-0.7009201,18.7459424,21.5627331,40660.8349497,56523.6790634,34.4090351,2621.3596711,2169.0472607,4385.0184049,1.054686,6.4154045,1.735945,14.98618),(17867,'metatarsus-pes',236,10,64,498.1167403,80.3585178,109.4500314,1.8,80.2258825,109.9936311,-0.7002202,18.7336021,21.7933191,40443.1420299,56312.8925979,34.4724511,2583.9521005,2158.8556158,4397.840171,1.7336574,13.7828446,1.4685896,33.6939202),(17868,'metatarsus-pes',236,10,65,499.1342336,80.4555775,109.4124225,1.8,80.3289126,109.9834973,-0.7077839,18.8530403,21.6436984,39999.7961565,55736.8753385,35.1637592,2575.2010699,2121.6629035,3517.8004589,2.163172,14.4525766,1.4977558,39.6101557),(17869,'metatarsus-pes',236,10,66,499.1357318,80.4507666,109.4296432,1.8,80.3204019,110.0084092,-0.7134703,20.2396445,21.413501,39691.8088831,55169.3699366,35.6316302,2576.3825308,1961.0921938,3464.5076038,1.6634043,10.5702715,1.6373645,27.5717445),(17870,'metatarsus-pes',236,10,67,497.9302604,80.4429634,109.4364068,1.8,80.2631817,110.0079472,-0.7133526,18.6517672,21.5971717,39377.0231923,54578.0381426,35.5359143,2527.0919262,2111.1684918,4290.6093969,2.1930248,15.3161648,1.4094212,39.1629414),(17871,'metatarsus-pes',236,10,68,497.6934058,80.4561753,109.4451767,1.8,80.3035921,109.9882348,-0.7178175,18.805127,21.6146624,39131.2619919,54308.1440119,35.8857618,2512.5603654,2080.8826217,4266.7922326,2.2685263,16.9334683,1.4876551,47.4797924),(17872,'metatarsus-pes',236,10,69,497.6542296,80.4645936,109.4589399,1.8,80.3154055,110.0671329,-0.722335,20.9745757,21.7188351,38944.0251621,54067.4242431,36.2544361,2489.4256032,1856.7252918,3402.9378953,1.9865162,13.9300204,1.3932002,34.2764072),(17873,'metatarsus-pes',236,10,70,496.9104449,80.4812833,109.4797238,1.8,80.3538067,110.1052895,-0.7233721,28.0820047,21.5956657,38752.346515,53723.5559831,36.2854713,2487.7008487,1379.9708003,3156.5711663,2.1715171,16.9662816,1.467004,42.0960744),(17874,'metatarsus-pes',236,10,71,496.030817,80.4930553,109.4967327,1.8,80.3686208,110.1019613,-0.7229036,27.1660966,21.7159198,38547.6150358,53284.2166767,36.1828055,2453.6937442,1418.9603917,3167.8515743,1.8189333,15.5325168,1.4801364,36.6270532),(17875,'metatarsus-pes',236,10,72,496.0148994,80.508547,109.4969282,1.8,80.3682919,110.0726581,-0.7235486,18.5642337,21.2012419,38335.0413344,53018.499814,36.2345568,2500.7261401,2064.9945408,3380.7722207,1.876777,16.2671046,1.4625257,41.5988907),(17876,'metatarsus-pes',236,10,73,495.6878198,80.5948622,109.4508145,1.8,80.4711864,110.0338544,-0.7308296,19.5439288,21.3080832,37976.8172461,52451.1226675,36.8081008,2461.5598824,1943.1516405,3346.9134943,1.9292663,15.2190211,1.4550371,37.7920272),(17877,'metatarsus-pes',236,10,74,494.2513365,80.609218,109.4814548,1.8,80.4832407,110.100891,-0.7324279,18.77658,22.2165023,37732.297504,51903.6556359,36.832332,2336.265848,2009.5404735,3321.2370803,2.0970587,16.6166515,1.464812,39.6954589),(17878,'metatarsus-pes',236,10,75,493.3953792,80.6292806,109.4905779,1.8,80.4763313,110.1228941,-0.7363251,18.4621827,21.0622054,37521.9693212,51538.7334574,37.0873539,2446.9770648,2032.3690878,3332.4286084,2.1344087,13.0835866,1.4631065,32.0817319),(17879,'metatarsus-pes',236,10,76,492.6912949,80.6515633,109.4932922,1.8,80.5106414,110.1483108,-0.7383553,18.7990401,21.8841179,37356.5685062,51222.8740851,37.2003712,2340.6414828,1987.1529748,3267.6475782,1.9441685,16.2671046,1.4625257,38.7010914),(17880,'metatarsus-pes',236,10,77,492.4405077,80.6775819,109.482156,1.8,80.4900512,110.1192064,-0.742333,18.4365062,33.2638529,37282.0475712,51058.3687078,37.5065689,1534.9505318,2022.186156,2649.9332414,2.0064739,15.2190211,1.4550371,37.7920272),(17881,'metatarsus-pes',236,10,78,492.0629786,80.7072315,109.4800267,1.8,80.5444833,110.1320886,-0.7450302,18.5158895,33.8498903,37110.3268655,50836.5058222,37.6982437,1501.8218766,2004.2421854,2597.697692,2.3388806,13.9964069,1.3684747,36.9682662),(17882,'metatarsus-pes',236,10,79,492.3191965,80.7315424,109.4740697,1.8,80.5778731,110.1259781,-0.746547,18.7410705,25.9764031,37045.5044016,50721.134301,37.8419428,1952.5849681,1976.7016199,3060.2321742,2.3016877,15.3161648,1.4094212,39.0776382),(17883,'metatarsus-pes',236,10,80,492.1953385,80.7496265,109.4656201,1.8,80.5744367,110.0987017,-0.7519239,18.722158,25.8011437,36910.6320968,50589.5006488,38.2723532,1960.7464409,1971.4945288,3063.2977002,1.8835201,11.9995481,1.482789,29.1839327),(17884,'metatarsus-pes',236,10,81,493.527814,80.8239598,109.4295329,1.8,80.7048247,110.0940471,-0.7562946,18.3729753,28.5174172,36704.1264798,50287.9067823,38.7347634,1763.4102859,1997.7236093,2930.3344523,2.0812801,16.4145951,1.3986055,40.6544927),(17885,'metatarsus-pes',236,10,82,492.8315574,80.8397285,109.4506177,1.8,80.6921052,110.1753345,-0.7589834,18.4114253,28.2813564,36436.1021436,49986.8543735,38.9006376,1767.484333,1978.994108,2929.6628111,2.3816392,18.0977616,1.4343937,49.5538307),(17886,'metatarsus-pes',236,10,83,492.4896838,80.8647824,109.4569055,1.8,80.6924645,110.1453566,-0.7640467,18.9681485,29.098736,36274.9382114,49743.551361,39.288776,1709.4746435,1912.4132333,2862.6806239,2.2734025,16.6575106,1.4438235,42.8845017),(17887,'metatarsus-pes',236,10,84,491.9255999,80.8947831,109.4570754,1.8,80.7303058,110.1730881,-0.7683114,18.8653091,23.3289221,36155.3975369,49603.5124117,39.5931713,2126.2667957,1916.5017286,3179.6683473,2.3119783,15.6632609,1.4130276,43.3463517),(17888,'metatarsus-pes',236,10,85,491.6205055,80.9236467,109.445934,1.8,80.7617165,110.0964187,-0.7692258,19.3246984,21.0931651,36040.6572068,49479.9096942,39.6434919,2345.7792847,1865.0049035,3171.736032,2.0778589,18.4025162,1.4559197,47.0679119),(17889,'metatarsus-pes',236,10,86,491.6311796,80.9439838,109.4412013,1.8,80.7567168,110.1562828,-0.7734434,21.1992355,29.7326579,36004.9034096,49355.4738864,39.9898045,1659.9751731,1698.4057502,2790.66804,2.1702574,17.7042099,1.4513674,42.7991984),(17890,'metatarsus-pes',236,10,87,492.2766496,80.9663193,109.4273205,1.8,80.7723356,110.1121194,-0.7768055,21.3830319,30.7851707,35958.9359903,49298.0839204,40.3180958,1601.3581478,1681.657498,2716.7611208,1.8762715,12.0355442,1.4536876,36.4357487),(17891,'metatarsus-pes',236,10,88,492.821445,80.9992586,109.4276425,1.8,80.838681,110.079849,-0.7790274,18.5008715,21.1633794,35933.7703934,49187.6350558,40.5451912,2324.1862378,1942.2744722,3931.7284873,1.9448739,15.6118864,1.4352686,39.4895187),(17892,'metatarsus-pes',236,10,89,494.2733591,81.0646008,109.3972602,1.8,80.8658392,110.1023881,-0.788614,18.6447304,21.2465084,35828.3932853,48919.1403226,41.4543658,2302.4555078,1921.6364323,3217.9554517,2.1284261,15.7223306,1.3909428,43.2610484),(17893,'metatarsus-pes',236,10,90,493.8756426,81.0852917,109.4146765,1.8,80.8858154,110.1526583,-0.7915435,32.7530804,32.4312695,35706.7651141,48690.7904451,41.6621325,1501.3532046,1090.1803645,2046.7348409,2.1731539,16.6575106,1.4438235,43.1757452),(17894,'metatarsus-pes',236,10,91,493.4816715,81.127491,109.394462,1.8,80.9351006,110.1214847,-0.7956796,27.7928289,21.338879,35596.6088888,48393.5890853,41.9690312,2267.8599511,1280.7839416,2939.0720679,2.2469208,14.7572311,1.3547114,37.9626337),(17895,'metatarsus-pes',236,10,92,492.7191227,81.1639263,109.3830058,1.8,80.9304397,110.12808,-0.7986485,23.6986827,33.2352495,35541.0941122,48203.5505913,42.1479186,1450.3742671,1499.7075784,2518.7511017,2.4117602,17.4014312,1.4288993,44.7525997),(17896,'metatarsus-pes',236,10,93,492.5486728,81.2005815,109.3586954,1.8,81.0196528,110.0866729,-0.7978224,24.2032074,21.4092909,35535.7609677,48072.6533697,42.0655394,2245.4108163,1468.2252823,3084.1648664,2.3079621,17.053475,1.4259838,44.9585399),(17897,'metatarsus-pes',236,10,94,492.0317051,81.2256678,109.351694,1.8,81.0130232,110.0681081,-0.7994297,24.1774207,34.7216412,35464.607971,47981.1602238,42.1531507,1381.8805376,1466.8482815,2368.4256806,1.8608725,16.4145951,1.3986055,39.2835784),(17898,'metatarsus-pes',236,10,95,491.4145498,81.2536649,109.3353881,1.8,81.0575566,110.0618455,-0.7964421,23.1876092,34.7705814,35423.3440835,47914.9775689,41.8556631,1378.0321082,1527.6841968,2363.2140563,2.0293764,17.0063008,1.4464413,45.3704204),(17899,'metatarsus-pes',236,10,96,490.6958588,81.2879033,109.3189845,1.8,81.0738182,110.0240437,-0.7958916,23.1821673,33.3597573,35371.7646325,47834.7109562,41.7494406,1433.9046451,1525.8178497,2490.2475453,1.6568378,15.5682832,1.4576453,37.9979674),(17900,'metatarsus-pes',236,10,97,491.6163856,81.3683427,109.2747414,1.8,81.132259,109.9908784,-0.7975174,22.3783879,21.3397062,35230.9023186,47639.7872281,41.9609354,2232.4481289,1574.327094,3101.6797214,2.5069518,16.5831464,1.4858945,46.0382107),(17901,'metatarsus-pes',236,10,98,490.4107269,81.4002237,109.2688931,1.8,81.1816336,109.9740207,-0.7972988,21.1051909,32.0154377,35038.9702489,47417.5457074,41.8401666,1481.0837848,1660.2062659,2574.2072289,0.351562,0.4971837,2.3561945,0.9943675),(17902,'metatarsus-pes',236,10,99,489.4166044,81.4295162,109.2729568,1.8,81.2386031,110.0296622,-0.7999032,20.7878345,31.0700744,34920.1577258,47300.4851542,41.9677219,1522.3808129,1679.8362405,2634.6893673,2.1743142,15.3161648,1.4094212,42.2666809),(17903,'metatarsus-pes',236,10,100,488.208661,81.448261,109.2437654,1.8,81.2405315,109.9355292,-0.7967473,18.3455723,30.6031735,34815.3600558,47167.3945606,41.6074307,1541.2582785,1897.7527412,2661.2757917,2.1126471,18.4025162,1.4559197,49.6391339),(17904,'metatarsus-pes',236,10,101,487.7692965,81.4710781,109.2167288,1.8,81.2650993,109.8512098,-0.79723,18.5665447,23.5285586,34758.1386685,47083.5521854,41.6092211,2001.1235242,1872.0843955,3109.0924761,2.5092725,15.2636221,1.4321566,42.1460439),(17905,'metatarsus-pes',236,10,102,487.6488093,81.493324,109.2004419,1.8,81.3123459,109.841673,-0.797329,18.5087942,22.3288801,34746.9488956,47087.6016875,41.6069876,2108.8205696,1877.3210433,3162.0869148,2.1179403,15.9602953,1.4382448,42.3519842),(17906,'metatarsus-pes',236,10,103,487.5701949,81.5233687,109.1873159,1.8,81.3591364,109.8633129,-0.7973853,18.496311,24.3187887,34743.8907766,47100.1440045,41.6048476,1936.78002,1878.422715,3088.3196309,1.8216246,13.9300204,1.3932002,36.8829629),(17907,'metatarsus-pes',236,10,104,487.9936043,81.5457326,109.1667231,1.8,81.3687237,109.8111694,-0.7948125,21.6047118,21.45887,34764.5004583,47094.5597996,41.43178,2194.6430406,1609.1166049,3013.1993709,1.6315576,9.6535622,1.3876855,23.182394),(17908,'metatarsus-pes',236,10,105,488.9598241,81.6108419,109.0988081,1.8,81.3894679,109.75119,-0.7955071,18.310202,21.7267288,34689.2962766,46844.126478,41.5704095,2156.0597975,1894.5337819,3132.4785257,2.511551,17.3552027,1.4489539,44.8732367),(17909,'metatarsus-pes',236,10,106,488.4125942,81.6326137,109.0856024,1.8,81.4019923,109.7560545,-0.7963892,19.8251036,21.5782361,34580.5864237,46655.1495528,41.595669,2162.1391728,1744.2827606,3083.5582933,2.8210551,17.3552027,1.4489539,48.5947969),(17910,'metatarsus-pes',236,10,107,487.5599701,81.6658826,109.0592303,1.8,81.4354602,109.7311332,-0.7970636,20.3109802,22.7868844,34458.7189991,46438.2447871,41.5778407,2037.9374337,1696.5561801,3060.6465707,2.2283662,15.9602953,1.4382448,41.2723134),(17911,'metatarsus-pes',236,10,108,487.1617668,81.7000808,109.0353217,1.8,81.4441185,109.7285853,-0.7927388,21.8751708,21.674387,34424.8816285,46378.9867471,41.1928083,2139.8061565,1573.6965873,2989.0286076,2.1241248,15.2636221,1.4321566,36.8829629),(17912,'metatarsus-pes',236,10,109,486.7070465,81.7384266,109.0053459,1.8,81.4836915,109.669593,-0.7882476,18.0095274,21.2400768,34444.4520895,46258.2198197,40.7900559,2177.8744117,1912.5683499,3138.2625362,2.0799704,11.4460295,1.3854484,31.8404579),(17913,'metatarsus-pes',236,10,110,486.5402296,81.7730048,108.9772633,1.8,81.5481159,109.6163707,-0.7833402,18.006031,30.721162,34474.3546827,46278.7860523,40.3781388,1506.4139191,1914.6004279,2599.0746681,2.1356206,14.5675687,1.4254863,40.1219752),(17914,'metatarsus-pes',236,10,111,486.1980189,81.8020981,108.9550761,1.8,81.5532497,109.5972908,-0.7779264,18.270103,21.8236801,34471.6205541,46142.766994,39.9110658,2114.3439954,1886.7775742,3691.8211711,2.3326101,15.2636221,1.4321566,41.8548004),(17915,'metatarsus-pes',236,10,112,486.4252854,81.8443594,108.930441,1.8,81.6494851,109.564858,-0.7752703,17.9948826,21.8679378,34458.2229699,46124.8464996,39.7144208,2109.2453722,1914.8901237,3684.8502646,2.0432222,15.2190211,1.4550371,36.3857792),(17916,'metatarsus-pes',236,10,113,487.5022921,81.9176343,108.8870476,1.8,81.65215,109.5399264,-0.7736843,18.1808651,21.9567718,34336.9335178,45943.5976969,39.673526,2092.4568588,1888.6303475,3654.5926416,2.3321634,15.6118864,1.4352686,39.5748219),(17917,'metatarsus-pes',236,10,114,486.8122153,81.9521874,108.8872526,1.8,81.7002206,109.5640565,-0.769841,18.4056426,21.2469645,34202.6884779,45712.8149379,39.3056525,2151.4986277,1858.2718978,3086.8480764,2.17334,12.4841641,1.4010181,33.9498299),(17918,'metatarsus-pes',236,10,115,486.3900419,81.979755,108.8787497,1.8,81.7186057,109.5291537,-0.7637838,18.3791756,20.7111753,34062.0044399,45558.8423827,38.7808816,2199.7227017,1853.2933734,3101.8278599,2.5687566,17.4014312,1.4288993,42.4726212),(17919,'metatarsus-pes',236,10,116,486.40154,82.0214735,108.8523465,1.8,81.7686249,109.4938881,-0.759395,18.0046631,21.1655714,34036.1599904,45498.0134936,38.4264172,2149.6236797,1890.408048,3066.4798186,2.3832777,15.8826669,1.4821404,42.2666809),(17920,'metatarsus-pes',236,10,117,486.1952848,82.0574502,108.8201471,1.8,81.7984261,109.4343673,-0.7577796,17.9947122,22.4663998,34050.6050628,45386.7228308,38.2794081,2020.2045375,1892.2561591,3011.9086656,2.1122025,14.9692771,1.4056476,42.2313472),(17921,'metatarsus-pes',236,10,118,486.1516892,82.0861019,108.7929001,1.8,81.7931164,109.3934255,-0.7526602,18.3590762,20.8052719,33995.8251647,45372.0642959,37.8619296,2180.7965121,1851.7176399,3754.2678414,2.34776,16.7056699,1.422947,42.1460439),(17922,'metatarsus-pes',236,10,119,486.8243127,82.1205023,108.7693371,1.8,81.9067295,109.3655097,-0.7501271,18.605356,20.6168673,34020.4438496,45385.1136876,37.7092667,2201.3583877,1828.5295853,3769.9732729,2.1550471,14.9692771,1.4056476,39.0776382),(17923,'metatarsus-pes',236,10,120,486.8882829,82.1466701,108.7407398,1.8,81.9600041,109.3542162,-0.7452257,18.3421768,20.6243667,34000.3475995,45328.2737535,37.317615,2197.8019701,1853.6702544,3775.2596298,2.0512054,15.3765679,1.3868529,36.6770227),(17924,'metatarsus-pes',236,10,121,487.6317306,82.2143481,108.6825484,1.8,81.9743215,109.2940511,-0.7424105,18.3125318,20.6628034,33828.2993457,44989.8854223,37.1465899,2177.3369537,1847.2759378,3749.1202443,2.1768449,14.4952726,1.3258177,37.1742064),(17925,'metatarsus-pes',236,10,122,486.859781,82.2364261,108.6636674,1.8,81.9909923,109.3548392,-0.7426429,18.070337,23.5495885,33669.7371911,44769.4263652,37.1065688,1901.0704333,1863.2600636,2930.5438251,2.0266375,12.5483505,1.3734008,35.1501377),(17926,'metatarsus-pes',236,10,123,485.9465201,82.2658635,108.6194094,1.8,82.0330586,109.3057885,-0.7448295,29.201887,33.7495903,33556.036988,44549.7509661,37.2134495,1320.0086452,1149.1050893,2308.5682435,2.4018051,15.3161648,1.4094212,41.1516764),(17927,'metatarsus-pes',236,10,124,484.8492512,82.283278,108.5711744,1.8,82.0210124,109.2641133,-0.7419485,33.4211731,36.746725,33462.6783059,44361.6137288,36.8974352,1207.2263252,1001.2418837,2112.5691642,2.3719718,15.7223306,1.3909428,40.6544927),(17928,'metatarsus-pes',236,10,125,483.4406706,82.3095522,108.5113424,1.8,82.0575939,109.2221563,-0.7441399,17.7456861,26.5500139,33285.3739592,44286.3277817,36.9661767,1668.0340736,1875.688198,2713.2683838,2.349841,14.6226127,1.4016951,39.9513687),(17929,'metatarsus-pes',236,10,126,482.6766611,82.3252051,108.4448427,1.8,82.0754025,109.1491378,-0.7479857,29.0437304,25.3587271,33194.7757261,44245.6637899,37.2161764,1744.7904086,1142.9239733,2655.9553892,2.0860683,12.5483505,1.3734008,35.4767149),(17930,'metatarsus-pes',236,10,127,484.1901857,82.3414283,108.3988701,1.8,82.1275581,109.0488807,-0.7449217,35.1501077,25.8625144,33260.6598678,44276.0878448,37.0863615,1711.9792431,946.2463141,2161.3017859,2.1993047,14.6858687,1.3780956,36.5563857),(17931,'metatarsus-pes',236,10,128,483.0435909,82.3547607,108.3484539,1.8,82.1538696,108.9560357,-0.7453958,34.9231751,24.3422347,33168.8737557,44096.7736669,37.0365849,1811.5335032,949.7668424,2164.9763478,2.0866329,13.9964069,1.3684747,34.7735909),(17932,'metatarsus-pes',236,10,129,483.5740418,82.3847885,108.2795953,1.8,82.1778524,108.8721316,-0.7511348,17.7056101,21.1805675,32947.827601,43776.8443589,37.5385165,2066.8400069,1860.8693735,3614.6457502,2.3961254,14.6226127,1.4016951,38.0832707),(17933,'metatarsus-pes',236,10,130,482.3037387,82.3904398,108.2567609,1.8,82.1903583,108.9238309,-0.7563839,23.920468,39.3436273,32788.1243903,43504.137929,37.861003,1105.7480195,1370.7141668,1912.0951234,2.2688774,14.9692771,1.4056476,41.0310394),(17934,'metatarsus-pes',236,10,131,480.6465057,82.3996179,108.23277,1.8,82.2145287,108.9268169,-0.759949,27.6855513,23.1110259,32665.4626553,43186.9919546,38.0160775,1868.6748088,1179.8740199,2684.6229371,2.5859775,15.6632609,1.4130276,39.3688817),(17935,'metatarsus-pes',236,10,132,479.4840307,82.3859772,108.2058331,1.8,82.1646599,108.8732141,-0.75885,17.9345229,45.2527081,32540.8472798,42927.7253849,37.836428,948.6222406,1814.425028,1600.4813002,2.7708588,17.053475,1.4259838,42.5932582),(17936,'metatarsus-pes',236,10,133,478.604665,82.3857812,108.1814535,1.8,82.179747,108.8588322,-0.7557079,27.0327555,45.5665684,32541.5603317,42756.3889876,37.5167945,938.3280433,1203.7825857,1585.9665335,2.0866329,14.6226127,1.4016951,40.7397959),(17937,'metatarsus-pes',236,10,134,477.558445,82.3848793,108.1425787,1.8,82.2192935,108.7740861,-0.7537619,27.7800436,22.8159658,32501.6390962,42415.6456092,37.2801928,1859.0335349,1169.963574,2653.7577956,2.0154326,14.414042,1.3494819,38.1685739),(17938,'metatarsus-pes',236,10,135,477.1695675,82.3790611,108.1108145,1.8,82.2323046,108.7084733,-0.7470458,25.4707059,23.474382,32451.9872418,42265.0925237,36.7170265,1800.477325,1274.0906104,2637.0039792,2.0801713,14.2761879,1.3975507,32.4936125),(17939,'metatarsus-pes',236,10,136,476.0853324,82.3778779,108.0733263,1.8,82.2073327,108.6737098,-0.7400566,27.1909384,22.6310373,32425.8003148,42051.344989,36.0809628,1858.1271557,1192.5222975,2671.8372463,2.0079222,16.068345,1.3948567,39.6954589),(17940,'metatarsus-pes',236,10,137,476.8349973,82.4153952,107.9776223,1.8,82.2541314,108.5801671,-0.7382013,17.7891595,20.0864705,32321.7896863,41756.2209302,35.9909621,2078.8231977,1816.93743,3623.6257015,2.2978768,14.9692771,1.4056476,38.5804544),(17941,'metatarsus-pes',236,10,138,475.7299007,82.4114462,107.9386377,1.8,82.2745911,108.5696016,-0.7381829,34.3071452,23.7561643,32223.2559147,41584.1324915,35.9060988,1750.456515,939.2578636,2081.1014336,2.5474515,15.7223306,1.3909428,38.2892109),(17942,'metatarsus-pes',236,10,139,474.781209,82.4186492,107.8931998,1.8,82.2909133,108.5673225,-0.7385979,24.3904687,25.0749783,32185.230558,41451.4707886,35.8671906,1653.1009627,1319.5822886,2529.9180217,2.3817212,16.8236284,1.3815973,43.9641724),(17943,'metatarsus-pes',236,10,140,473.8670867,82.4243676,107.8399324,1.8,82.3037486,108.5093857,-0.7312133,24.9600289,25.2666753,32153.5885119,41438.7706861,35.217895,1640.0563268,1288.2031766,2514.7301899,1.9043885,12.8932697,1.3787483,32.0463982),(17944,'metatarsus-pes',236,10,141,473.6394456,82.4297111,107.7890167,1.8,82.3309867,108.4559188,-0.7207057,35.3408749,29.9344618,32236.1915302,41430.7285122,34.3773733,1384.0478848,912.1503532,1977.3542266,2.2222283,15.3161648,1.4094212,36.5917194),(17945,'metatarsus-pes',236,10,142,473.1587701,82.4256463,107.7458561,1.8,82.2870805,108.3801359,-0.7134793,24.7660773,19.9343262,32251.8533173,41517.9696127,33.7779289,2082.73754,1302.2592509,2704.9502841,1.9044215,13.1777143,1.4100336,32.0817319),(17946,'metatarsus-pes',236,10,143,472.7971587,82.4241836,107.6925423,1.8,82.3175628,108.2941371,-0.7007603,24.1283256,19.8801047,32295.5491629,41591.4377297,32.7621473,2092.1136164,1338.491103,2686.3722668,1.8442039,11.3864848,1.4157996,30.0576632),(17947,'metatarsus-pes',236,10,144,471.9825872,82.4192288,107.6439159,1.8,82.2976847,108.2654784,-0.6916003,17.9970709,19.7365726,32360.994444,41625.7664596,31.9965888,2109.0676299,1798.1256287,3658.2550505,1.7323386,9.943675,1.4288993,26.2861335),(17948,'metatarsus-pes',236,10,145,471.2033341,82.4467106,107.5643256,1.8,82.3514619,108.2198141,-0.6872893,31.5136301,19.7943375,32289.0458272,41474.1274886,31.6114229,2095.252115,1024.6057259,2326.6705222,1.9714256,15.7223306,1.3909428,37.3801467),(17949,'metatarsus-pes',236,10,146,469.3306325,82.4360917,107.5453816,1.8,82.3705296,108.2168314,-0.682119,24.4257037,19.7293093,32168.9961213,41372.8640721,31.0895361,2097.0254701,1317.0140961,2686.5487517,2.0629161,12.0252706,1.3045443,31.8757917),(17950,'metatarsus-pes',236,10,147,468.0236252,82.4334829,107.5035377,1.8,82.3306159,108.1887687,-0.6733514,24.7866914,24.2045536,32177.3471282,41266.420799,30.3348484,1704.9031968,1298.1703205,2559.3348356,1.7985583,9.7237245,1.3521274,25.171129),(17951,'metatarsus-pes',236,10,148,466.0612603,82.4392662,107.4607939,1.8,82.3292418,108.1511023,-0.6691795,23.9936737,25.5497891,32190.0209104,41257.4819068,29.8920029,1614.7875727,1341.6045127,2501.9936652,2.3238738,16.7610663,1.4021994,39.233609),(17952,'metatarsus-pes',236,10,149,464.9782611,82.4494445,107.4221595,1.8,82.3371058,108.1608989,-0.660455,34.2594238,39.6458901,32306.8111579,41273.4768513,29.1660023,1041.0531024,943.0050948,1854.6943124,2.4824014,16.068345,1.3948567,41.3929504),(17953,'metatarsus-pes',236,10,150,463.3698298,82.4596048,107.3746224,1.8,82.3367589,108.0706874,-0.6493545,34.364759,27.4317342,32384.5557096,41142.4615625,28.2368884,1499.8126357,942.3769201,2002.1333813,1.9119949,14.2761879,1.3975507,32.323006),(17954,'metatarsus-pes',236,10,151,461.402184,82.4723375,107.3368402,1.8,82.3422524,108.0462449,-0.6427192,34.3006782,47.4950273,32453.1856445,41160.3874629,27.626423,866.6251976,946.1383081,1534.6621246,1.3303439,5.4577099,1.3101939,13.0827482),(17955,'metatarsus-pes',236,10,152,459.8681724,82.4900863,107.2838714,1.8,82.3420313,107.9773959,-0.6391006,34.3572868,20.2431394,32522.9686988,41087.256775,27.2687227,2029.6879855,946.6105088,2008.9719265,1.553924,6.4154045,1.4056476,16.1864877),(17956,'metatarsus-pes',236,10,153,458.8442371,82.5344636,107.2093223,1.8,82.3615913,107.930012,-0.6382271,19.0816549,22.065975,32427.0613344,40881.7556121,27.1440662,1852.705609,1699.3841198,2669.9893686,1.7635047,10.1466908,1.3258177,25.171129),(17957,'metatarsus-pes',236,10,154,456.4259908,82.5437102,107.1742327,1.8,82.4072566,107.8559562,-0.6343903,34.5030436,20.6586852,32355.569662,40583.6961095,26.7220198,1964.485919,937.7598682,2000.1955348,1.8103327,10.755729,1.3734008,26.4920737),(17958,'metatarsus-pes',236,10,155,454.8004059,82.5463647,107.1450905,1.8,82.4027491,107.8705288,-0.6318827,32.4391539,30.2201118,32340.3118977,40440.6949123,26.4455175,1338.2046746,996.9530043,2189.2263417,1.9712996,12.7777191,1.4327903,32.5789157),(17959,'metatarsus-pes',236,10,156,453.0539218,82.5565797,107.0941376,1.8,82.4152592,107.7786673,-0.6280479,30.4584917,31.062302,32382.547971,40375.6408509,26.0682768,1299.8277083,1063.1697817,2176.2260631,2.109372,10.5702715,1.6373645,27.4864412),(17960,'metatarsus-pes',236,10,157,451.363243,82.5633616,107.034208,1.8,82.4240842,107.6583151,-0.6217139,33.8770464,19.4040351,32375.1936539,40261.0190673,25.5188556,2074.8786985,955.6675422,2064.0421785,1.4960632,6.8260993,1.3633001,17.1808552),(17961,'metatarsus-pes',236,10,158,450.0551871,82.5808046,106.995585,1.8,82.4283546,107.6161984,-0.6187266,18.6296345,32.3331053,32491.1792888,40181.1928782,25.2329457,1242.7260702,1744.0588692,2129.3512511,1.8224059,11.2554758,1.3182421,29.6811165),(17962,'metatarsus-pes',236,10,159,448.9772066,82.5945837,106.9563458,1.8,82.4618282,107.5604474,-0.6140429,18.3788409,31.2838738,32612.2455935,40159.4250277,24.8418604,1283.7101087,1774.4451763,2155.6333872,30.937456,37.0677077,0.9538544,113.7026588),(17963,'metatarsus-pes',236,10,160,448.8537606,82.6027088,106.9112006,1.8,82.4858496,107.5206515,-0.6122668,36.2025443,32.615982,32777.7604938,40248.9523885,24.7099694,1234.0254679,905.3993608,1886.8406948,31.2646064,37.0677077,0.9538544,180.863861),(17964,'metatarsus-pes',236,10,161,449.0616263,82.6459934,106.8434775,1.8,82.5413861,107.4950367,-0.6215596,18.2352435,19.295905,32793.3156002,40074.5710629,25.3777975,2076.8433052,1798.3481041,3687.9590982,31.289018,37.1260125,0.9197196,194.4437929),(17965,'metatarsus-pes',236,10,162,448.5338721,82.6702452,106.8229381,1.8,82.6248235,107.5122267,-0.6150045,27.1427937,19.2670493,32867.1730339,39862.9454951,24.8850633,2068.9699277,1210.898677,2600.1968572,1.540923,9.9000758,1.4640607,24.5033387),(17966,'metatarsus-pes',236,10,163,447.386678,82.6815908,106.7794623,1.8,82.5904365,107.4647929,-0.6154828,27.2525797,37.9236616,32950.664104,39838.2237797,24.8550342,1050.4846343,1209.0842197,1895.5853219,1.75781,9.1473703,1.6092389,26.8686205),(17967,'metatarsus-pes',236,10,164,446.4291848,82.7108588,106.7228266,1.8,82.5990344,107.4306011,-0.6134311,26.4551744,37.9677575,33050.2784599,39891.2429411,24.6580189,1050.6610229,1249.2935374,1896.5718831,1.8322883,13.2385385,1.3838171,33.5732832),(17968,'metatarsus-pes',236,10,165,446.9326693,82.7343672,106.66882,1.8,82.5856181,107.406734,-0.6126285,27.4189319,38.0131118,33297.3765946,40024.6425035,24.6295573,1052.9167596,1214.3936417,1903.7646563,1.4008968,9.9000758,1.4640607,23.5089712),(17969,'metatarsus-pes',236,10,166,446.5069752,82.7591711,106.6124189,1.8,82.5863876,107.3287393,-0.6029263,32.0775235,38.3834483,33420.949008,40097.9941704,23.9291723,1044.6688858,1041.8805867,1893.1079105,1.677696,9.038631,1.3352513,22.3939667),(17970,'metatarsus-pes',236,10,167,447.2297862,82.7998324,106.5389247,1.8,82.6471099,107.1671661,-0.5870836,27.8773188,38.6523406,33612.2169673,40115.9058293,22.8716527,1037.8648533,1205.7191429,1882.1864792,1.5449912,6.4154045,1.4056476,17.4720987),(17971,'metatarsus-pes',236,10,168,448.7157078,82.8270568,106.4741585,1.8,82.6005721,107.1045277,-0.5798885,23.635581,45.4382204,33870.4408293,40211.9020218,22.4528404,884.9796864,1433.0276369,1630.0213845,1.3436345,8.5538726,1.4056476,19.4108642),(17972,'metatarsus-pes',236,10,169,450.5253007,82.917293,106.3830629,1.8,82.7526982,107.0293061,-0.5647027,25.4888787,45.2461625,33991.1415305,40098.8028252,21.5051699,886.2365477,1333.5675511,1636.0705157,1.5749015,5.798109,1.3258177,13.9918125),(17973,'metatarsus-pes',236,10,170,449.8917409,82.976599,106.3098766,1.8,82.817076,106.9536509,-0.5488364,19.4036069,24.688431,34127.7999104,39968.0263262,20.4075056,1618.8969751,1758.8379351,2419.5157229,1.358704,8.2072975,1.3986055,18.2105565),(17974,'metatarsus-pes',236,10,171,450.0018536,83.0038453,106.236903,1.8,82.8328364,106.9134404,-0.5325972,20.3524302,23.7213757,34289.7889568,39943.087967,19.3375497,1683.8436578,1684.8007142,2422.1308661,1.8009207,13.5248602,1.4141944,32.4083092),(17975,'metatarsus-pes',236,10,172,450.7392713,83.0331419,106.1707923,1.8,82.863583,106.81704,-0.5068027,29.0298041,22.8265842,34545.2056554,39986.201374,17.6988774,1751.7382777,1189.9909995,2418.5262191,1.5784393,11.3375338,1.4464413,26.6127107),(17976,'metatarsus-pes',236,10,173,450.9497213,83.0768326,106.1023383,1.8,82.8761681,106.7482605,-0.4952921,21.3383174,22.0391152,34753.2910023,40034.6305019,16.9782055,1816.5262162,1628.6800107,2437.9564742,0.9682273,5.5586833,1.2490458,12.294321),(17977,'metatarsus-pes',236,10,174,450.3318545,83.1013943,106.0113794,1.8,82.8762801,106.6027171,-0.4695987,19.1271758,19.7124938,34885.9709385,40034.0988067,15.3699746,2030.8997513,1823.8955559,3628.5898023,1.2963133,6.7165826,1.6756733,15.809941),(17978,'metatarsus-pes',236,10,175,450.0458612,83.1326398,105.9510614,1.8,82.8952607,106.5314146,-0.4518978,18.9554429,18.7469418,35152.7235479,40052.9964589,14.3027452,2136.5082864,1854.4923321,3671.1787568,31.992142,36.9875973,0.9406024,135.1522275),(17979,'metatarsus-pes',236,10,176,448.6966815,83.166419,105.8692854,1.8,82.9136213,106.4156892,-0.4305175,25.3627652,22.1749465,35271.01618,40112.641844,13.02519,1808.9171852,1390.6613058,2577.0780443,1.2345165,8.1544198,1.4410938,17.6280695),(17980,'metatarsus-pes',236,10,177,449.0410645,83.2126279,105.7891343,1.8,82.9911262,106.3925192,-0.4382935,24.3865049,26.3060429,35314.902344,40073.3912848,13.4795415,1523.3530712,1448.1329941,2284.2538433,2.1576497,11.3864848,1.4157996,27.1098945),(17981,'metatarsus-pes',236,10,178,447.1479507,83.2543268,105.7136721,1.8,83.034322,106.3000223,-0.4212722,18.9845271,18.6895363,35287.9093223,39883.9503599,12.4617902,2134.0256816,1858.7720974,3691.0523703,0.351562,0.4971837,2.3561945,0.9943675),(17982,'metatarsus-pes',236,10,179,445.2798184,83.2762036,105.627262,1.8,83.0872747,106.2233541,-0.4128649,24.021183,41.9538232,35277.3201984,39819.6025845,11.9475706,949.129293,1468.5921271,1723.4469213,0.351562,0.4971837,2.3561945,0.9943675),(17983,'metatarsus-pes',236,10,180,444.5770075,83.2792694,105.5420634,1.8,83.1106696,106.1370658,-0.4006174,18.9033057,18.9001026,35329.2458046,39954.4724403,11.2692697,2113.9817752,1868.9453796,3720.0055143,1.3435699,9.5505879,1.4601391,21.5202362),(17984,'metatarsus-pes',236,10,181,442.8310102,83.3300022,105.4657223,1.8,83.1349189,106.0828227,-0.373748,18.7063343,19.2692345,35372.5531863,39935.1828945,9.8384712,2072.4841378,1890.9398568,3780.3364026,1.406248,4.6240762,1.418147,11.00871),(17985,'metatarsus-pes',236,10,182,441.8857642,83.392897,105.3812277,1.8,83.1674234,105.9744188,-0.3663648,31.9583922,18.876767,35479.0209731,39938.9296724,9.4507844,2115.7717176,1110.1628888,2356.9548854,0.9079989,7.8611653,1.3909428,16.9249455),(17986,'metatarsus-pes',236,10,183,441.2554254,83.4167994,105.2797491,1.8,83.1639615,105.7843792,-0.3579714,32.0305709,23.7576179,35577.1603913,40002.3349423,9.0282784,1683.7687635,1110.7251419,2329.6162902,1.1470295,6.482483,1.3521274,14.403693),(17987,'metatarsus-pes',236,10,184,439.8127998,83.4650914,105.1951278,1.8,83.1780865,105.7415382,-0.3402798,18.7599654,19.2271321,35719.6522867,40027.6949892,8.1650997,2081.833875,1904.0361479,3791.3166427,1.406248,3.585243,1.3734008,9.1905815),(17988,'metatarsus-pes',236,10,185,439.5393534,83.5776596,105.0860693,1.8,83.2861393,105.6734336,-0.320711,19.6177482,19.2586615,35727.6138856,39885.0346724,7.2800248,2071.0180029,1821.1883186,3590.3313085,1.2723195,6.0689011,1.3961241,14.1124495),(17989,'metatarsus-pes',236,10,186,437.3000589,83.6281571,105.0140762,1.8,83.3394267,105.6707695,-0.3093875,19.4759163,19.1540489,35674.1857009,39773.3992659,6.7566656,2076.5008679,1831.7076933,3616.568516,1.5058236,7.170486,1.3734008,16.5983682),(17990,'metatarsus-pes',236,10,187,436.4724163,83.666685,104.9161783,1.8,83.4311689,105.5548916,-0.297304,19.3148464,19.0723172,35590.6105265,39800.8607659,6.2427123,2086.839279,1842.6556288,3704.4853791,0.351562,1.4495273,1.815775,3.1037395),(17991,'metatarsus-pes',236,10,188,435.8085568,83.7131263,104.8136487,1.8,83.4677258,105.4340152,-0.2994638,35.057942,41.8102564,35656.2773192,39871.355466,6.3213788,953.6261878,1017.0670414,1685.6675356,1.406248,3.2412415,1.3521274,8.4874575),(17992,'metatarsus-pes',236,10,189,435.5338369,83.759073,104.6879193,1.8,83.4432506,105.2698544,-0.2898549,29.7908776,19.0607793,35624.10583,39882.9205782,5.9297333,2092.4076632,1195.8058545,2500.4128537,0.703124,2.55941,1.2924967,5.504355),(17993,'metatarsus-pes',236,10,190,435.6339496,83.7764143,104.5953529,1.8,83.4483557,105.1544372,-0.2739594,30.1402982,19.0667278,35655.8498842,39961.8532892,5.3143519,2095.8946726,1182.9959235,2488.8273986,1.054686,3.9305827,1.3909428,9.602462),(17994,'metatarsus-pes',236,10,191,436.752417,83.7695799,104.5136613,1.8,83.5207522,105.0741075,-0.2607697,28.6822259,45.0919224,35632.5520181,40408.1294913,4.838734,896.1278949,1242.3217133,1590.5764916,0.703124,1.8932193,1.1902899,4.098107),(17995,'metatarsus-pes',236,10,192,440.9560613,83.6908991,104.4426699,1.8,83.482339,104.9644135,-0.2692843,18.6074967,18.9547762,35755.3080603,41012.8106772,5.2016749,2163.719072,1921.5539063,3778.214871,0.703124,1.8932193,1.1902899,4.098107),(17996,'metatarsus-pes',236,10,193,442.4961779,83.6717198,104.3169352,1.8,83.5568548,104.8738087,-0.2541965,32.2874199,19.2960771,35799.8692301,41324.8184287,4.6636185,2141.6176016,1108.7869303,2359.9892848,0.703124,4.9344078,1.6421038,10.426223),(17997,'metatarsus-pes',236,10,194,445.7939396,83.6011705,104.2728211,1.8,83.5723445,104.8241888,-0.2687156,34.9339392,24.3655372,35709.849349,41887.4287003,5.2370911,1719.1260066,1022.2107828,1821.884001,0.351562,2.1384682,1.735945,4.5099875),(17998,'metatarsus-pes',236,10,195,447.4824086,83.5907903,104.2295248,1.8,83.5665661,104.7994372,-0.2758016,35.2395452,27.0132602,35654.6523366,42383.1948988,5.5306787,1568.9774076,1011.779582,1757.5281461,0.351562,0.4971837,2.3561945,0.9943675),(17999,'metatarsus-pes',236,10,196,441.2346014,83.7145854,104.0449983,1.8,83.6183914,104.600785,-0.2572714,34.8799188,27.4949071,35406.6548414,41966.0447687,4.7610028,1526.3206585,1015.1014135,1742.0899918,33.2502459,38.0483649,0.9494727,143.8102915),(18000,'metatarsus-pes',236,10,197,436.2178088,83.8673226,103.8900308,1.8,83.6221914,104.4936071,-0.2288463,33.3743222,48.3258045,35337.7833486,41438.3205118,3.7414949,857.4781302,1058.8314901,1508.2646652,0.351562,0.4971837,2.3561945,0.9943675),(18001,'metatarsus-pes',236,10,198,432.6554396,83.9573792,103.7792565,1.8,83.685371,104.3463151,-0.2029419,32.9997771,29.8874551,35309.2718013,41300.993656,2.9293007,1381.8839215,1069.9851603,1720.7123391,0.351562,0.7861165,2.677945,1.4915512),(18002,'metatarsus-pes',236,10,199,431.6812797,83.9975569,103.7214274,1.8,83.6883495,104.3102526,-0.2090418,30.5715996,39.8561065,35364.5935458,41481.0832102,3.0984383,1040.771085,1156.7793004,1718.3278358,0.351562,1.7926215,1.7681919,3.8068635),(18003,'metatarsus-pes',236,10,200,431.5167849,84.0677341,103.6650754,1.8,83.7179556,104.2597891,-0.1905459,32.2273355,42.1821292,35404.1179714,41688.6028557,2.579784,988.300108,1098.5741583,1653.8557651,31.992142,37.7745148,0.8975089,136.0612918),(18004,'metatarsus-pes',236,10,201,430.6356589,84.1175463,103.5616823,1.8,83.7871094,104.1560708,-0.1732296,30.734776,40.9208931,35216.2080213,41732.1375447,2.1323296,1019.8247011,1145.8098155,1669.8813167,0.351562,0.7861165,2.0344439,1.6974915),(18005,'metatarsus-pes',236,10,202,429.2307113,84.131983,103.4959682,1.8,83.8524249,104.0546973,-0.1653959,30.3072563,25.5216295,35139.6168352,41793.0575772,1.9392113,1637.5544372,1159.4456598,2101.153027,31.64058,37.903536,0.8641821,119.9954411),(18006,'metatarsus-pes',236,10,203,430.5252466,84.1422716,103.4310632,1.8,83.8388733,103.9862486,-0.1602269,30.3425744,19.4080386,35146.8096477,42040.5626978,1.8264118,2166.1417549,1158.3331461,2337.8773315,31.992142,37.9459027,0.8772443,120.4926248),(18007,'metatarsus-pes',236,10,204,434.0505745,84.1448773,103.386519,1.8,83.9015398,103.9480944,-0.1532835,18.4569165,20.4031457,35222.43597,42459.2049703,1.6864595,2081.0126796,1908.3597223,3807.3343036,31.992142,38.0743431,0.8311179,120.9045053),(18008,'metatarsus-pes',236,10,205,434.5413623,84.1667172,103.303963,1.8,83.9200024,103.8365381,-0.1425912,18.0369975,19.3446055,35303.8639408,42755.8003747,1.4625799,2210.2182634,1957.3027073,3616.6568396,0.351562,1.7926215,1.7681919,3.8068635),(18009,'metatarsus-pes',236,10,206,437.791858,84.1646628,103.2548129,1.8,83.9545469,103.8281876,-0.1273231,29.9833579,19.4836006,35507.2016495,43269.3194158,1.1764742,2220.8071449,1184.2303262,2513.3281708,31.64058,38.3121938,0.8243395,121.4016891),(18010,'metatarsus-pes',236,10,207,438.7716734,84.1968479,103.155139,1.8,84.0329363,103.7385212,-0.1246947,30.1415952,19.471757,35777.711168,43818.0614442,1.1311793,2250.3393729,1186.9879776,2485.1273394,0.351562,0.7861165,2.0344439,1.6974915),(18011,'metatarsus-pes',236,10,208,438.4308111,84.2395063,103.0541982,1.8,84.0053678,103.5588449,-0.1247246,29.7577516,36.7162992,35786.1966691,44487.7786352,1.1308389,1211.6629299,1202.5840236,1796.495138,31.9234296,38.571014,0.8305288,122.6019968),(18012,'metatarsus-pes',236,10,209,439.9101784,84.2510786,102.9394419,1.8,84.0100964,103.4840398,-0.1187088,29.9150397,19.9753309,35749.1409369,44889.248888,1.0283422,2247.2343079,1195.0223454,2628.0655797,31.64058,38.6286497,0.7145492,122.5166936),(18013,'metatarsus-pes',236,10,210,438.7754936,84.2929343,102.8802869,1.8,84.0388159,103.4367611,-0.1081427,28.5514789,20.1198664,35721.3189151,45513.0299759,0.8519061,2262.0940482,1251.1197415,2772.3835293,0.351562,0.4971837,2.3561945,0.9943675),(18014,'metatarsus-pes',236,10,211,439.4777427,84.3040785,102.7937306,1.8,84.0421964,103.3826424,-0.1093514,29.4859996,36.1019936,35700.8338787,46198.174912,0.8723743,1279.6571696,1210.7723794,1824.7079297,31.5964244,38.9837716,0.6831914,123.3051208),(18015,'metatarsus-pes',236,10,212,438.542272,84.3038252,102.712549,1.8,84.0570648,103.2369118,-0.110259,29.2611122,36.1348618,35657.3303265,46705.5151174,0.884968,1292.5333799,1218.5910816,1832.7993029,31.289018,39.162492,0.7027841,124.0082448),(18016,'metatarsus-pes',236,10,213,433.0161148,84.2853815,102.6418339,1.8,84.067682,103.1196281,-0.1002087,27.89769,41.029899,35579.0019141,47403.3349989,0.7222859,1155.3363812,1275.3386378,1709.8228432,31.5872206,39.3765134,0.6524294,124.5054286),(18017,'metatarsus-pes',236,10,214,429.0588007,84.2919558,102.5630413,1.8,84.0977156,103.0694575,-0.0899335,27.7985075,39.0558737,35565.6026337,48136.8739981,0.5768166,1232.5130489,1279.4069118,1764.4045518,31.5933564,39.5315798,0.6719632,125.4144928),(18018,'metatarsus-pes',236,10,215,427.947337,84.3150892,102.516008,1.8,84.1046374,103.0335249,-0.0787683,29.1407659,48.0026783,35596.4240033,49125.58855,0.4416148,1023.3926582,1221.5335774,1687.6881383,31.5933564,39.8073142,0.6664653,125.7057363),(18019,'metatarsus-pes',236,10,216,430.0371554,84.3348481,102.4422253,1.8,84.0505754,102.9695646,-0.0793315,29.1473668,48.7374005,35702.6532235,50271.1568174,0.4501264,1031.4698009,1224.9014977,1689.0746137,31.2540795,40.0117097,0.6294423,125.8263733),(18020,'metatarsus-pes',236,10,217,428.1821317,84.4149113,102.3114094,1.8,84.1627806,102.8195575,-0.0591276,28.4249584,47.8374358,35528.6346044,50910.7397545,0.2492017,1064.2447467,1249.909819,1711.6953674,31.523541,40.2964284,0.6243063,143.3837753),(18021,'metatarsus-pes',236,10,218,423.2354891,84.4313891,102.2232082,1.8,84.1810998,102.7273989,-0.04814,28.8695432,47.6605706,35141.6351666,51256.0314657,0.163346,1075.4388969,1217.256362,1713.6887438,31.4640868,40.6415404,0.6504214,144.001596),(18022,'metatarsus-pes',236,10,219,421.4073942,84.4676393,102.1802643,1.8,84.2055263,102.6497379,-0.0390149,27.8526313,34.3547535,34911.0277341,52038.508403,0.1068542,1514.7396839,1253.4193741,1965.987845,31.4732896,40.9218772,0.6452193,128.0210486),(18023,'metatarsus-pes',236,10,220,419.9043939,84.4895346,102.1598734,1.8,84.2202546,102.5640292,-0.031828,27.9450289,35.2342741,34758.9493866,52891.9910307,0.0708714,1501.151716,1243.8330095,1957.0918243,0.351562,0.7861165,2.0344439,1.6974915),(18024,'metatarsus-pes',236,10,221,417.642665,84.5274652,102.1187414,1.8,84.2569873,102.4808724,-0.0406852,28.915911,38.2732302,34616.717094,53905.341163,0.1151563,1408.4345879,1197.1511852,1846.0866556,31.2510116,41.5379095,0.5926974,130.0950868),(18025,'metatarsus-pes',236,10,222,413.726924,84.5407551,102.0098276,1.8,84.2768651,102.3363471,-0.034408,28.9324056,36.6906645,34218.7595814,54933.7834014,0.0816039,1497.2141878,1182.7139463,1907.9989305,31.1494566,41.8491702,0.5577088,132.1191556),(18026,'metatarsus-pes',236,10,223,409.6395347,84.5339642,101.9493892,1.8,84.271027,102.2681609,-0.0267164,28.3960034,21.3767947,33699.4694691,56018.369537,0.0487196,2620.5224143,1186.7680444,2992.0556846,32.2626544,42.2255087,0.5718377,188.0864055),(18027,'metatarsus-pes',236,10,224,406.1418099,84.588861,101.9175184,1.8,84.3034102,102.2110161,-0.0198269,27.1897718,21.822987,33325.6995274,57358.333478,0.0266058,2628.3447593,1225.6704402,2975.6974427,31.136785,42.6318757,0.5559769,136.6791126),(18028,'metatarsus-pes',236,10,225,405.9994125,84.622716,101.9004286,1.8,84.3619383,102.2125652,-0.0204271,28.7263052,22.8231214,33071.2499737,58923.6162876,0.0282309,2581.7509872,1151.2531734,3000.5454655,30.899463,43.1204802,0.41988,135.6847451),(18029,'metatarsus-pes',236,10,226,407.8289306,84.6013663,101.8911457,1.8,84.3219839,102.2551931,-0.016186,27.3341508,22.1067984,33096.5363422,60509.5125881,0.0178061,2737.144998,1210.812678,3236.2098219,30.8963951,43.5440441,0.3805064,136.1819288),(18030,'metatarsus-pes',236,10,227,408.3955239,84.557618,101.8918321,1.8,84.3376345,102.2477119,-0.0174886,18.200044,23.1547755,33340.7750461,62301.3249092,0.0208162,2690.6469011,1831.9062913,3968.3145488,30.8963951,44.0856505,0.4101273,136.1819288),(18031,'metatarsus-pes',236,10,228,409.9653034,84.4708379,101.9220061,1.8,84.28999,102.2589727,-0.0239576,28.4756667,31.3727958,33614.320175,64353.4128695,0.0392103,2051.2489013,1180.4577038,2312.5696861,30.899463,44.6539101,0.3790444,136.5085061),(18032,'metatarsus-pes',236,10,229,414.4848287,84.4082155,101.92876,1.8,84.2171819,102.2623862,-0.0260032,28.0555833,31.3590452,34128.7476001,66654.8376974,0.0466994,2125.5378535,1216.4690086,2395.5435536,30.9055988,45.160325,2.9457238,136.8350833),(18033,'metatarsus-pes',236,10,230,419.9552555,84.3627167,101.9594169,1.8,84.2202832,102.2382809,-0.0263613,27.7868138,42.6793817,34702.6273834,69101.6864803,0.0486279,1619.0882763,1248.8883255,2230.3675647,31.2387399,45.7976135,2.9170953,138.3266346),(18034,'metatarsus-pes',236,10,231,424.2912972,84.4100068,101.9897249,1.8,84.14476,102.1959007,-0.0206689,28.8834617,23.3850795,35189.7829698,71264.2336472,0.0302058,3047.4231934,1218.336753,2972.702439,31.5780169,46.4128419,2.9664817,140.9831598),(18035,'metatarsus-pes',236,10,232,428.7688748,84.3320349,102.0195055,1.8,84.0754829,102.2364709,-0.0179431,28.5214615,25.5508105,35626.7106898,73346.3627845,0.023005,2870.6080742,1249.1193946,2845.8051729,31.64058,46.9910978,2.8766529,140.7272501),(18036,'metatarsus-pes',236,10,233,434.186455,84.3384975,102.0022605,1.8,84.0872063,102.2480145,-0.0149783,27.3489675,38.9139497,36129.0886528,75394.9378516,0.0162336,1937.478421,1321.0403134,2775.2657377,32.1897443,47.6428127,2.9485386,142.595348),(18037,'metatarsus-pes',236,10,234,435.6582942,84.310008,102.1026106,1.8,84.0277467,102.3224644,-0.017741,27.0320685,24.3236526,36174.2763093,77283.1421068,0.0228514,3177.2835899,1338.1986023,3739.5307688,32.343704,48.3790701,2.9883908,144.2928395),(18038,'metatarsus-pes',236,10,235,441.1626537,84.2447492,102.2117434,1.8,83.9562862,102.416149,-0.0154071,28.3843205,24.932164,36664.2152604,80025.0555302,0.0174523,3209.7115798,1291.7066417,3851.5907131,32.5412528,49.1847677,2.976444,145.990331),(18039,'metatarsus-pes',236,10,236,448.1318485,84.1727431,102.3010238,1.8,83.8955738,102.5017354,-0.0178796,28.712142,32.3892467,37227.8473614,83327.7585944,0.0238739,2572.6982614,1296.5889935,2785.2636445,33.2135917,49.822674,2.9857245,148.0643693),(18040,'metatarsus-pes',236,10,237,457.9742722,84.141563,102.441887,1.8,83.8264563,102.6053156,-0.0165417,27.1043473,25.5470766,38099.9981039,88166.217592,0.0208837,3451.1274668,1405.6784964,4252.0941119,33.5528289,50.4708853,2.9523936,149.967801),(18041,'metatarsus-pes',236,10,238,472.4828133,84.146564,102.4869696,1.8,83.8020901,102.6638904,-0.019135,30.0625164,38.6196153,39308.6006678,93734.4026943,0.0288296,2427.1190157,1307.5618884,2816.2177837,33.7125126,51.4122615,3.0113005,152.4537198),(18042,'metatarsus-pes',236,10,239,492.8738796,84.0795323,102.5587673,1.8,83.8014149,102.7551707,-0.0209718,27.7675863,26.2303023,41394.7704508,99212.2878708,0.0361238,3782.3539673,1490.7586858,4715.2709579,34.0664684,51.918221,2.9508371,154.186545),(18043,'metatarsus-pes',236,10,240,525.4098852,84.0683761,102.7916473,1.8,83.8159505,102.8647857,-0.0191402,28.2407255,26.539347,44253.0254963,106956.6459127,0.032076,4030.1159564,1566.9932241,5113.672125,34.3877872,52.5252924,3.0679008,155.1809125),(18044,'metatarsus-pes',236,10,241,555.4994797,84.2329474,102.746178,1.8,83.932355,102.9178692,-0.0239563,28.5984226,38.8508322,45108.3611341,114172.2688329,0.0531233,2938.7341874,1577.3024173,3315.0325452,34.6270606,52.7635887,3.0213699,157.0843443),(18045,'metatarsus-pes',236,10,242,582.8340105,84.3090117,102.8257191,1.8,83.9528692,103.015319,-0.0223824,28.5268747,27.4082648,46132.4044661,121317.4811329,0.0486558,4426.3101729,1617.1559243,5550.4123301,34.0726043,53.160313,3.088662,158.284652),(18046,'metatarsus-pes',236,10,243,611.3567469,84.0515465,103.0282293,1.8,83.9440645,103.3741203,-0.0245324,30.6869171,28.4488615,48544.6120932,127566.0153303,0.0613107,4484.0464051,1581.9318666,4885.637119,34.6419975,53.4212312,3.0294819,192.8669384),(18047,'metatarsus-pes',236,10,244,619.9448225,83.8470553,103.2286582,1.8,83.821381,103.9231554,-0.0297137,28.9891745,28.0692246,49401.203663,128376.7354141,0.0911985,4573.5761197,1704.12592,4797.3569769,0.351562,0.4971837,2.3561945,0.9943675),(18048,'metatarsus-pes',236,10,245,605.7063945,83.831279,103.4554227,1.8,83.7505819,104.2169491,-0.0235307,30.7766089,36.676622,46684.4683548,124134.0162491,0.0558852,3384.5542351,1516.8814902,3725.0820885,0.351562,0.7861165,2.0344439,1.6974915),(18049,'metatarsus-pes',236,10,246,569.3567082,84.159701,103.3190743,1.8,83.751808,103.5933372,-0.0209367,31.112391,35.8892083,42494.5345527,115432.0007211,0.04159,3216.3429148,1365.8395634,3463.6497303,34.5582986,55.0281571,0.4636476,279.1770327),(18050,'metatarsus-pes',236,10,247,532.3125256,84.3312572,102.7145731,1.8,84.5909461,102.1221401,-0.0611224,31.4507773,35.1230494,38807.3333124,107592.6071952,0.331036,3063.3048378,1233.9069681,3872.3724612,0.351562,0.4971837,2.3561945,0.9943675),(18051,'metatarsus-pes',236,10,248,515.3059628,84.5041456,102.743326,1.8,84.34842,102.3219282,-0.0403734,31.4303109,33.6775091,38517.4864305,103430.8187585,0.1399167,3071.2134455,1225.4885599,3186.3013881,33.9793944,53.9541733,3.0633215,202.8106134),(18052,'metatarsus-pes',236,10,249,517.9004642,84.5898223,102.7544254,1.8,84.6511792,102.3569712,-0.0423329,31.4634148,33.5505426,37828.1661212,104313.37761,0.154594,3109.1413012,1202.2905464,3812.0003331,0.9648305,3.8027245,2.1587989,8.075577),(18053,'metatarsus-pes',236,10,250,517.020312,84.6991428,103.0075287,1.8,84.6867907,102.9924057,-0.0196881,31.2837639,36.4118959,37758.0230475,103976.1486966,0.0333969,2855.5543786,1206.9526914,3143.3272415,35.7495572,53.6969957,3.0432269,271.769246),(18054,'metatarsus-pes',236,10,251,515.8731179,84.8134224,103.2209174,1.8,84.6705278,103.4069746,-0.0202802,31.3528142,50.9017486,39389.8078058,105338.26772,0.0353573,2069.4430076,1256.3404229,2528.4221454,0.351562,1.1117367,1.8925469,2.4006155),(18055,'metatarsus-pes',236,10,252,516.2095607,84.7231206,103.4654169,1.8,84.5018832,103.7369145,-0.0286722,31.3533073,38.9216847,42401.7195068,107279.9497594,0.0707093,2756.3028328,1352.3842656,3761.6659283,1.75781,4.3485818,1.815775,11.47056),(18056,'metatarsus-pes',236,10,253,524.98318,84.5014049,103.4937498,1.8,84.4731802,103.8221533,-0.0305156,31.7989227,50.836134,46521.7011516,110052.5910136,0.0814522,2164.849731,1462.9961386,2762.8850482,27.4521903,37.6417681,0.9983365,128.6181713),(18057,'metatarsus-pes',236,10,254,528.2245745,84.5264596,103.4381026,1.8,84.6653945,103.7166336,-0.0284854,31.5006304,28.756271,49343.5341901,110995.3243889,0.0714155,3859.8650178,1566.4300549,4220.1082544,24.191824,36.7596697,1.3490154,125.0525818),(18058,'metatarsus-pes',236,10,255,541.0767066,84.6051327,103.1675824,1.8,85.9646804,102.7926581,-0.0857014,32.1657194,46.1579289,53766.1521606,117218.8383627,0.6607242,2539.5168527,1671.5358224,3124.5350456,2.6305109,6.9070974,1.3134726,19.546137),(18059,'metatarsus-pes',236,10,256,536.0306256,83.9746583,103.2607342,1.8,84.4231855,103.3436425,-0.0469245,32.1976984,39.3163802,53058.8930456,111821.2434453,0.1965707,2844.1388257,1647.909501,3594.7763401,2.4840297,6.4154045,1.4056476,18.843013),(18060,'metatarsus-pes',236,10,257,553.310485,84.1056746,103.3034198,1.8,84.5196954,102.9290776,-0.0233772,31.9478678,48.1478757,54090.0069588,118893.7098512,0.0503876,2469.3448722,1693.0709526,3180.293149,2.687269,6.0689011,1.3961241,16.3570942),(18061,'metatarsus-pes',236,10,258,558.3502365,83.8632824,103.5931429,1.8,83.9285014,103.5916574,-0.0159454,32.0360575,45.2620972,51852.7359349,121906.7220774,0.0236585,2693.3511601,1618.5741951,3325.0866163,26.6655578,40.379157,0.9586438,158.263954),(18062,'metatarsus-pes',236,10,259,557.8455535,84.218692,103.8387458,1.8,84.0753683,104.0481016,-0.0090797,32.1301238,39.2957787,48124.5681905,119874.6152901,0.0076651,3050.5723321,1497.8021398,3576.6165968,29.4573806,40.42963,0.9272952,163.20652),(18063,'metatarsus-pes',236,10,260,571.3520319,83.8718094,104.0902317,1.8,83.6748399,104.7433045,0.0072089,31.2270106,46.0737348,45440.7295936,123288.6021591,0.0049484,2675.8977267,1455.17386,3130.9533655,27.2648065,38.3911499,0.9218008,151.1181393),(18064,'metatarsus-pes',236,10,261,574.8513672,83.7623172,104.0807265,1.8,83.8265175,104.3485275,-0.0043511,30.1831541,46.6048326,41212.0569159,125211.4943053,0.0018139,2686.6633191,1365.39928,3154.0905989,24.960902,37.2804938,0.8990009,124.9879766),(18065,'metatarsus-pes',236,10,262,568.8655084,83.4504961,104.2067128,1.8,83.6068209,104.1065079,-0.0155173,31.8988701,36.7924297,35675.2607604,126325.2184997,0.0228274,3433.4568176,1118.3863461,4158.5124606,0.703124,1.2675748,2.1587989,2.691859),(18066,'metatarsus-pes',236,10,263,543.5777246,83.2409418,104.2384449,1.8,83.6015789,103.9719901,-0.0146062,31.5724769,32.7530549,29047.6529478,120148.0021155,0.0193264,3668.2991133,920.0308574,4165.80046,24.960902,35.4258685,0.8697049,126.1675863),(18067,'metatarsus-pes',236,10,264,503.9925239,83.0170898,104.3312762,1.8,83.4603418,104.3189191,-0.0147202,22.5890626,47.4954138,22314.2993949,108757.6000078,0.0182,2289.8547711,987.8364492,2492.1674415,24.9334272,33.8669366,0.844154,135.4081373),(18068,'metatarsus-pes',236,10,265,434.1324848,82.7909562,104.4307529,1.8,83.4079798,104.1979618,0.0102087,27.7534697,46.6924896,15493.8455366,88046.7322035,0.0075403,1885.6722543,558.2669729,1977.9759353,0.351562,0.7861165,2.0344439,1.6974915),(18069,'metatarsus-pes',236,10,266,289.6120191,80.4170039,104.0408332,1.8,80.298522,103.8850808,-0.0352995,17.0217142,22.7101941,8730.8185236,36545.0479541,0.0601203,1609.1913506,512.9224001,1972.9729678,24.60934,29.4851342,2.457541,152.6889315),(18070,'metatarsus-pes',236,10,267,197.4225563,82.1134115,104.3589727,1.8,82.9955716,104.6182959,0.0191511,25.8406677,19.8423008,5185.4277756,16645.4137404,0.0120664,838.8852656,200.6692646,763.3811842,13.2776018,26.4513903,1.9809237,98.1132938),(18071,'metatarsus-pes',236,10,268,135.6941872,80.0885963,106.2742287,1.8,81.8082646,106.1621488,0.3611105,33.6736683,33.4758707,2470.7462635,9342.2579338,2.8231248,279.0743825,73.3732435,319.0914298,13.5352579,24.6845598,2.0280746,90.6202038),(18072,'metatarsus-pes',236,10,269,22.0716327,72.4424788,103.8992906,1.8,72.4512289,103.7408873,-1.4756285,33.0805366,27.3364281,47.4943084,219.2261632,3.6453891,8.0195614,1.4357176,6.2152476,5.976554,18.0977616,1.7071989,50.3069242),(18073,'metatarsus-pes',236,10,270,689.1369946,83.625706,100.0197607,1.8,83.7723412,99.7508041,0.0084675,34.4062848,32.7301955,53475.8298309,151640.4928565,0.0082342,4633.0457409,1554.2459786,4474.6112563,0.351562,0.7861165,2.677945,1.4915512),(18074,'metatarsus-pes',236,10,271,668.4115079,83.1795848,100.0754253,1.8,83.7958367,99.6155885,0.0074808,34.7838254,28.9924477,54179.0725364,147306.8443269,0.0062339,5080.8695332,1557.5938509,4507.3864692,26.5186398,37.6877088,1.3258177,146.6873927),(18075,'metatarsus-pes',236,10,272,627.2154789,83.2424545,100.0879933,1.8,83.9031757,99.4436719,0.0063254,34.389862,31.7085012,52643.0794775,140623.3918842,0.0041825,4434.8798076,1530.7732113,4245.6022536,26.6903386,38.5437673,1.3125441,125.8056753),(18076,'metatarsus-pes',236,10,273,598.4744648,83.3382419,100.078104,1.8,83.9473681,99.6575153,0.0007837,28.9225638,44.9955624,51588.1465839,135851.6426119,0.0000612,3019.2231293,1783.664374,3514.6395661,27.0648489,40.5684878,2.0189413,125.017248),(18077,'metatarsus-pes',236,10,274,579.197746,83.4444496,100.148564,1.8,83.8459243,99.8915885,0.0086643,28.9099762,44.5238191,51510.7133039,132775.8182758,0.0072471,2982.1300341,1781.7625647,3471.4505997,26.718712,38.1327295,1.3571273,117.0269743),(18078,'metatarsus-pes',236,10,275,575.4967997,83.540969,100.2576513,1.8,83.7643024,99.985646,0.0096523,33.1308542,28.2945476,52067.9721293,132652.6372218,0.0089361,4688.2756046,1571.5855625,5078.0783354,0.351562,0.4971837,2.3561945,0.9943675),(18079,'metatarsus-pes',236,10,276,586.338477,83.5398185,100.3051929,1.8,83.7067081,99.9070449,0.0068542,30.4094449,43.6082177,52942.1762144,133526.4984367,0.0045906,3061.9572552,1740.9780541,3520.1428228,26.261247,39.508124,1.364675,142.5393162),(18080,'metatarsus-pes',236,10,277,575.3443648,83.469458,99.9720472,1.8,83.743577,99.6500405,0.0139156,33.1031767,43.3197875,51835.8717257,126557.1265267,0.0185677,2921.4623147,1565.8881378,3359.4473016,36.8757894,53.9862344,2.6313316,229.9558416),(18081,'metatarsus-pes',236,10,278,539.1316077,83.3085657,99.5475151,1.8,83.6755107,99.417252,0.0159517,37.8556847,40.1708379,49715.3119164,113773.8061559,0.022862,2832.2487702,1313.2852373,2961.9007832,36.5242408,53.6463338,2.6427689,239.8142134),(18082,'metatarsus-pes',236,10,279,503.1737577,83.3114718,98.8991114,1.8,83.9810313,98.8874684,0.0143697,32.1584668,43.4789261,46595.6235412,104331.1226789,0.017315,2399.5791077,1448.9379659,2790.8349892,35.8272794,52.9401479,2.6125622,253.7353583),(18083,'metatarsus-pes',236,10,280,479.8597246,83.4392395,98.2625388,1.8,84.0946526,98.6539989,0.0207396,26.7617259,30.5164887,43030.7065065,98154.4756673,0.0343956,3216.4406793,1607.9197105,4158.7520734,36.5307398,52.073916,0.6029828,233.8126746),(18084,'metatarsus-pes',236,10,281,451.3658648,83.1635216,97.5046051,1.8,83.503685,97.918232,-0.0022794,33.1789655,43.5127525,38616.3494733,91211.4146072,0.0003906,2096.1996027,1163.8804544,2372.6552638,34.453076,50.6456757,2.650002,219.2383751),(18085,'metatarsus-pes',236,10,282,434.5679916,82.7346872,97.1605561,1.8,83.430316,97.8551631,-0.0282652,25.3158419,26.2092253,36666.8703028,85810.7016174,0.0578492,3274.0647895,1448.3764908,4285.661222,24.5018053,36.9742287,1.6278771,151.3180172),(18086,'metatarsus-pes',236,10,283,424.8413736,83.1877528,96.8036814,1.8,83.3630517,97.4841632,0.0094551,35.4040647,38.3542075,33374.6915728,83645.0021556,0.0063296,2180.8559612,942.6796582,2507.5571061,23.9182022,33.11408,1.6345396,116.6150938),(18087,'metatarsus-pes',236,10,284,411.8317129,83.1752647,96.282374,1.8,83.3117457,96.9402526,0.0148454,17.9398305,25.1715875,30878.7338001,81052.5457407,0.015126,3220.0013461,1721.2388809,4384.8805865,23.3799881,32.3169436,1.9614034,95.5774056),(18088,'metatarsus-pes',236,10,285,402.0661434,83.0930961,95.8796875,1.8,83.2856237,96.4685131,0.0128878,20.2969467,24.8763986,29444.5823742,78632.937436,0.0111295,3160.9453894,1450.690232,4257.1589916,22.8890943,31.963154,2.0885782,93.5033674),(18089,'metatarsus-pes',236,10,286,391.2795974,83.0609675,95.4181775,1.8,83.2371427,95.9851889,0.0143195,18.0552669,24.8941466,27974.5482275,76603.6558173,0.0133709,3077.1754075,1549.3843672,4145.6348029,22.4263049,31.6581532,2.0940746,92.0971194),(18090,'metatarsus-pes',236,10,287,380.7872844,82.9294784,94.9301278,1.8,83.0397106,95.45326,0.0085022,16.6241968,25.3835092,26551.2875712,74455.6318842,0.0045875,2933.2284754,1597.1470942,3938.8726445,22.0215399,31.3127098,2.0746233,90.6908714),(18091,'metatarsus-pes',236,10,288,369.7135466,82.7958528,94.4144647,1.8,82.8451805,94.94014,0.0053031,16.2947257,25.1341535,25068.5646107,72930.8919615,0.0017331,2901.6649353,1538.4465587,3899.0538299,21.7655771,30.6988319,2.0856811,87.5371624),(18092,'metatarsus-pes',236,10,289,354.8829447,82.6557043,93.8088026,1.8,82.676296,94.2230948,0.002628,15.7877523,24.2943274,23274.6421567,70658.7858753,0.0004084,2908.4479114,1474.2213892,3856.3554733,21.3830526,29.7854149,2.1031188,85.5130936),(18093,'metatarsus-pes',236,10,290,342.2377794,82.5299958,93.2229144,1.8,82.4344714,93.5856567,-0.0004488,15.4130942,24.3451917,21639.3077941,69049.1573562,0.0000115,2836.2544097,1403.9561079,3669.7768368,21.2785421,29.7418128,2.0767467,85.1365469),(18094,'metatarsus-pes',236,10,291,332.953597,82.4209722,92.6367537,1.8,82.3622559,92.9881186,-0.0019857,37.1129774,24.4534788,20229.4203896,68158.6556077,0.0002188,2787.2784913,545.0767309,2270.9757761,20.9395555,28.8237963,2.094481,83.2331151),(18095,'metatarsus-pes',236,10,292,325.349906,82.3955671,92.0223521,1.8,82.2419668,92.2903104,-0.0046168,14.6353324,24.1432916,18937.5628729,67795.7094286,0.0011559,2808.0557782,1293.9619242,3514.0625647,20.9647969,27.017717,2.1335335,79.9234354),(18096,'metatarsus-pes',236,10,293,318.7601504,82.3016174,91.4633683,1.8,82.2417119,91.6590488,-0.0063835,14.0635668,24.2372497,17815.847783,67857.2669187,0.0021649,2799.7098532,1266.8086303,3505.4953197,20.742158,26.0488226,2.1251038,77.7287602),(18097,'metatarsus-pes',236,10,294,315.658569,82.2248131,90.9073294,1.8,82.1363494,91.0648295,-0.0069814,14.1950051,24.3164878,16958.4519592,68651.9626976,0.0025641,2823.2680345,1194.6774141,3476.1619382,20.742158,25.3831659,2.1088405,76.5284524),(18098,'metatarsus-pes',236,10,295,314.6766562,82.0912699,90.3987218,1.8,81.9402156,90.6155558,-0.0088455,39.1284859,24.7892463,16360.1449585,69383.2703491,0.0041035,2798.9261798,418.1134173,2003.0126679,20.742158,24.9708032,2.1861359,75.8253284),(18099,'metatarsus-pes',236,10,296,315.8270713,82.0864505,89.9281778,1.8,82.0345576,90.1057211,-0.0119916,39.6525174,24.8405593,15781.1928895,70672.5173449,0.0075688,2845.0453322,397.9871622,2005.140796,20.742158,24.4834602,2.1309177,75.4134479),(18100,'metatarsus-pes',236,10,297,317.9488748,82.0107664,89.3285059,1.8,81.9934819,89.4379966,-0.0128822,13.2327427,25.2320756,15198.9758097,72113.8213666,0.0087936,2858.0217738,1148.5884752,3457.0270443,20.742158,24.1172557,2.1062159,74.9162642),(18101,'metatarsus-pes',236,10,298,327.0344424,81.9902994,88.8959967,1.8,82.0003898,88.994409,-0.0113597,13.8661784,25.2459042,15085.6009141,75065.3702984,0.0070332,2973.3682576,1087.9422238,3543.6904149,21.09372,24.1761189,0.8574382,74.8309609),(18102,'metatarsus-pes',236,10,299,339.254026,81.9342934,88.5759079,1.8,81.9062694,88.6719527,-0.0112988,13.4792644,25.3393388,15106.451563,78620.1899866,0.0072182,3102.6930293,1120.7178046,3692.7288074,21.445282,24.4885078,0.887087,75.7046914),(18103,'metatarsus-pes',236,10,300,352.8882951,81.9387245,88.287507,1.8,81.9267968,88.3581129,-0.0133727,12.8972638,25.3437717,15152.7601538,81608.7793231,0.0105172,3220.0723877,1174.8817737,3757.2082951,0.351562,1.4495273,1.815775,3.1037395),(18104,'metatarsus-pes',236,10,301,363.5646161,81.9067014,87.9491493,1.8,81.9448979,88.0400364,-0.0142197,13.296571,25.689505,15085.0531575,83287.587721,0.0122515,3242.0861298,1134.5070192,3825.7891093,0.351562,0.4971837,2.3561945,0.9943675),(18105,'metatarsus-pes',236,10,302,373.9077152,81.8627903,87.5626443,1.8,81.9226655,87.6646764,-0.0136177,13.2183566,25.7322694,14930.2845281,84113.3852065,0.0115555,3268.7900106,1129.5114078,3845.6229735,22.002774,24.3290049,0.6521714,76.7843621),(18106,'metatarsus-pes',236,10,303,378.2163786,81.793929,87.0485754,1.8,81.8188175,87.0991833,-0.0166364,13.6211029,25.7957113,14383.2019496,83634.127896,0.0174449,3242.1718049,1055.9498766,3797.4065671,21.6973466,24.2679661,0.6724785,76.3724816),(18107,'metatarsus-pes',236,10,304,374.744122,81.6870986,86.4415398,1.8,81.6692345,86.4470133,-0.0197313,45.0799741,25.9057999,13418.3640078,81511.4782251,0.0243135,3146.4567217,297.6568701,2104.7255073,20.9544158,24.0505412,0.6610432,75.5840544),(18108,'metatarsus-pes',236,10,305,366.3852979,81.5345689,85.7503288,1.8,81.6300532,85.7163181,-0.0228198,12.4289862,26.0439415,12063.3786736,79175.6761661,0.031793,3040.0804006,970.5842851,3503.0804194,20.5948695,24.1940054,0.6202495,74.5043836),(18109,'metatarsus-pes',236,10,306,358.9630306,81.2442616,85.0261186,1.8,81.2884824,85.0569736,-0.0240051,12.7205304,26.3501935,10813.030076,78288.043605,0.0344685,2971.0614344,850.0455356,3381.0860159,0.351562,0.7861165,2.0344439,1.6974915),(18110,'metatarsus-pes',236,10,307,359.2106717,81.02263,84.5451911,1.8,81.2812552,84.7284354,-0.0227416,13.1262413,26.5523481,10376.2161692,78465.7827911,0.0309575,2955.1353588,790.4940906,3345.4727103,0.351562,0.7861165,2.0344439,1.6974915),(18111,'metatarsus-pes',236,10,308,374.0803749,81.0135993,84.4662986,1.8,81.3489475,84.8053074,-0.0195752,19.2234793,26.8850416,11443.8149733,81895.5528234,0.0238873,3046.13822,595.3040444,3463.6805737,0.351562,0.4971837,2.3561945,0.9943675),(18112,'metatarsus-pes',236,10,309,382.3104346,80.8187775,84.2303012,1.8,81.0381795,84.7599019,-0.0246674,45.6005656,32.8391826,11774.5596639,84806.2691869,0.0387638,2582.4719897,258.2108251,2063.1746816,26.2055158,52.2977279,3.0405862,310.7383718),(18113,'metatarsus-pes',236,10,310,374.5860317,80.9184405,84.0189677,1.8,81.807089,84.3567845,-0.0188625,22.8042816,31.8144728,12421.8285036,84244.675651,0.0222099,2647.9984803,544.7147475,2972.8129188,21.445282,26.9214785,2.2822555,106.7067526),(18114,'metatarsus-pes',236,10,311,368.8454544,80.4534278,83.7236195,1.8,81.3392453,83.9942469,-0.0289982,25.4602626,30.5064672,11599.6014464,84786.406175,0.0516791,2779.2928517,455.5962997,3029.780127,21.445282,27.3631796,2.3198469,111.5579531),(18115,'metatarsus-pes',236,10,312,368.3533556,80.4715697,83.5542844,1.8,81.3326092,84.0983875,-0.0320249,35.8718716,28.3591874,11767.7702031,85762.7557136,0.0629419,3024.1612576,328.0500764,2512.5808595,25.0629392,30.0950214,2.488746,131.6512433),(18116,'metatarsus-pes',236,10,313,374.8291784,80.6965621,83.6380241,1.8,81.5206842,83.8505973,-0.0335928,25.9603022,28.8552153,12021.57437,88973.3472721,0.0704713,3083.4407676,463.0752868,3312.3940154,0.351562,0.4971837,2.3561945,0.9943675),(18117,'metatarsus-pes',236,10,314,382.589499,80.841678,83.7365865,1.8,81.4165399,83.7861624,-0.0328245,26.7554784,28.4001182,11933.2898139,92761.6971314,0.0686784,3266.2433451,446.0129487,3539.4074576,0.7783414,1.75781,0.9272952,3.6862265),(18118,'metatarsus-pes',236,10,315,388.6404517,81.0795127,83.7025877,1.8,81.3225531,83.824823,-0.0353252,42.8399455,41.1338751,11531.280623,95072.4277219,0.0807952,2311.2927604,269.1712253,1794.955906,1.2573079,3.7864386,1.1902899,10.184949),(18119,'metatarsus-pes',236,10,316,383.3145572,80.955285,83.4086334,1.8,81.0070637,83.5219195,-0.0318563,44.1967604,27.281171,10461.8067329,93363.8139825,0.0648108,3422.2803006,236.7098095,2121.7006983,1.75781,2.5351496,2.5535901,7.5783932),(18120,'metatarsus-pes',236,10,317,382.6258662,80.9552189,82.9416607,1.8,81.3230605,83.1250317,0.0029269,19.701263,28.031018,9993.4992519,95070.7639166,0.0005464,3391.6272347,507.2517049,3747.1416948,1.406248,2.55941,1.2924967,6.5840257),(18121,'metatarsus-pes',236,10,318,356.1151203,81.2249623,82.957913,1.8,81.5901748,83.2389509,0.0595044,27.1249941,30.7826149,10970.6759074,95201.2700641,0.2099062,3092.696003,404.4489692,2876.5765313,0.351562,0.4971837,2.3561945,0.9943675),(18122,'metatarsus-pes',236,10,319,345.5017208,81.8201987,83.2587219,1.8,82.4810597,83.9199296,0.1031625,47.536491,34.4674088,14682.9745912,93300.7492581,0.6106624,2706.9267018,308.8779645,2149.9412918,23.760237,32.0693153,1.3497493,119.9394093),(18123,'metatarsus-pes',236,10,320,393.7439861,80.9648927,83.4027798,1.8,81.6692218,83.9815182,0.0794748,24.3181682,29.6486795,19331.5320417,109107.9051372,0.4136251,3680.0257882,794.9419485,4170.9064335,23.554654,33.4649355,1.412556,120.7631703),(18124,'metatarsus-pes',236,10,321,550.7944108,81.2005472,83.4499949,1.8,81.9882175,84.9226564,0.0383776,27.4885548,34.0805018,26210.650653,157474.5453262,0.1351389,4620.6639294,953.51141,4831.1233616,23.203092,34.2750413,1.39553,124.1081838),(18125,'metatarsus-pes',236,10,322,572.2197871,80.9604321,83.3564631,1.8,81.457558,84.8359555,0.0259212,35.1107551,30.5008766,26010.5136359,156078.3511769,0.0640653,5117.1759118,740.8132799,5184.7513558,23.906216,34.7495519,1.377369,140.0887313),(18126,'metatarsus-pes',236,10,323,514.7837142,80.4799107,83.4571216,1.8,81.0998552,84.5427183,0.029983,28.2522489,29.9457055,23907.9485157,140073.2418139,0.0771065,4677.5736165,846.2316974,5474.352713,0.703124,2.4859187,1.7126934,5.504355),(18127,'metatarsus-pes',236,10,324,486.0913519,80.6446697,83.3499082,1.8,80.8763598,84.2508368,0.0177676,21.6287135,29.4515298,22283.4272147,137005.4464299,0.0255728,4651.8957572,1030.2705798,5381.34196,24.5769753,33.9926096,1.3835424,121.380991),(18128,'metatarsus-pes',236,10,325,423.438823,81.3668467,83.446134,1.8,80.9098466,83.9937918,0.0145507,42.3574332,44.1927701,18951.9112535,117067.6812042,0.0149408,2649.0233789,447.4282277,2222.0342658,0.351562,1.4495273,1.815775,3.1037395),(18129,'metatarsus-pes',236,10,326,370.7094669,81.2140369,83.5334308,1.8,81.1045622,83.7492981,0.0298344,17.8554564,29.7182337,16347.0264268,101367.6662136,0.0549781,3410.9586457,915.5199454,3884.3439723,0.351562,0.7861165,2.0344439,1.6974915),(18130,'metatarsus-pes',236,10,327,334.70098,80.8617636,83.4921658,1.8,81.088425,83.5968821,0.0356354,28.3749747,31.2097955,14699.7309689,93230.488921,0.0708086,2987.2188386,518.0526553,3370.6968379,23.8755867,30.9693997,1.525373,98.2339308),(18131,'metatarsus-pes',236,10,328,311.9972482,80.8525266,83.2629226,1.8,81.3481159,83.6217461,0.0417506,26.1369872,30.6279657,13660.0750007,88960.9598798,0.0905886,2904.5663977,522.6338796,3224.9851966,23.2715334,32.1386128,1.9167636,109.6691571),(18132,'metatarsus-pes',236,10,329,303.4861016,81.839198,83.2351244,1.8,81.4179596,83.5387692,0.0557007,28.7637274,30.4773813,13353.7353865,90552.8905325,0.1567688,2971.150628,464.2560826,3131.9606037,22.064339,32.8686969,2.1350645,109.0013668),(18133,'metatarsus-pes',236,10,330,300.9880049,82.039953,83.2003695,1.8,82.0914139,83.5385931,0.075051,26.7354899,36.9952619,13204.8653441,92313.0120306,0.28203,2495.2658069,493.9077377,2726.4852367,21.5900887,30.6988319,2.0856811,100.4785756),(18134,'metatarsus-pes',236,10,331,285.3796856,80.057309,82.8917054,1.8,80.8741567,83.1965776,0.0377872,24.4849669,36.6718592,12063.5827543,90002.8851307,0.0678819,2454.276577,492.6934479,2704.8378071,21.3096263,34.1901953,1.6428364,130.3656323),(18135,'metatarsus-pes',236,10,332,282.4215502,81.3683917,82.2770769,1.8,81.8303909,82.4875709,0.0629914,16.8998186,28.6255187,10282.8282665,93283.2757304,0.1865241,3258.7453476,608.4579095,3549.1046463,0.351562,0.7861165,2.0344439,1.6974915),(18136,'metatarsus-pes',236,10,333,278.9944998,81.491605,81.9786877,1.8,82.2359719,82.2294669,0.0663486,54.2062055,29.6796031,9768.8072025,95786.6711342,0.2043949,3227.3568783,180.2156618,1909.9402638,20.7442526,27.2545592,2.0979423,80.2999821),(18137,'metatarsus-pes',236,10,334,275.3354262,81.6280153,81.7015172,1.8,82.498631,82.0000667,0.0645646,17.326724,29.9978031,9115.6557069,97095.470215,0.1910279,3236.7526983,526.1038209,3415.7868039,20.5773878,27.2885495,1.3101939,81.0530756),(18138,'metatarsus-pes',236,10,335,267.8042448,81.7133697,81.4915866,1.8,82.4617346,81.6686627,0.0678494,16.0692522,30.1505313,8626.7840647,95247.4037628,0.2051595,3159.0622038,536.8503755,3396.5101389,20.4358889,29.3148746,1.666885,96.5364393),(18139,'metatarsus-pes',236,10,336,255.7475081,81.4274228,81.2462121,1.8,82.6059232,81.6064981,0.0513684,38.4846766,31.3319632,7888.8113643,92897.4612665,0.112375,2964.9422449,204.9857778,2030.9074847,20.3801672,28.2696074,1.3831566,81.0884094),(18140,'metatarsus-pes',236,10,337,271.3396851,81.1997109,81.5150791,1.8,82.7024547,82.1960977,0.0654271,23.1140133,32.93227,8989.2162635,99331.531414,0.1933117,3016.2370074,388.9076351,3201.6371833,20.039034,29.9385542,1.735945,89.8671104),(18141,'metatarsus-pes',236,10,338,299.0580746,83.4563764,83.0699407,1.8,84.1482995,83.6590929,0.1457957,29.0256096,32.3930791,13811.9417167,109238.6044489,1.0519964,3372.2822153,475.8536316,3719.5548693,19.687472,34.2822526,1.4680665,116.8210341),(18142,'metatarsus-pes',236,10,339,351.2509498,84.977913,84.4219223,1.8,84.9874982,84.4671294,0.2196662,24.9893007,34.5735485,18464.2157414,125999.5772039,2.7796893,3644.3923895,738.8848531,3785.4579007,19.687472,33.7078115,1.8562592,116.3238503),(18143,'metatarsus-pes',236,10,340,365.5119622,85.0362877,84.4032354,1.8,84.8292809,84.4927822,0.2225066,25.9378887,35.0433253,19021.450196,131256.4070252,2.9665865,3745.5465789,733.3461274,4286.417072,19.33591,32.0616063,1.6366351,100.9611236),(18144,'metatarsus-pes',236,10,341,371.934826,84.8871561,84.2762662,1.8,85.1571571,84.6805647,0.2100423,39.6219043,35.4451152,18542.6715235,134342.1366328,2.6948398,3790.1453006,467.9904175,3606.1575543,19.687472,30.8894785,1.7771202,99.8814529),(18145,'metatarsus-pes',236,10,342,372.4992096,84.9803343,84.4269167,1.8,85.4173327,84.8879508,0.2079492,27.6467917,36.1821803,18623.6214152,139732.4126862,2.6461814,3861.9124488,673.6268584,4376.6283498,19.33591,28.5891463,1.2840509,87.5371624),(18146,'metatarsus-pes',236,10,343,410.8426466,85.8388503,85.0738399,1.8,86.2379992,86.1473864,0.214125,29.0367338,37.99412,21222.5077765,150553.0723349,3.0918004,3962.5361057,730.8848129,4516.5357049,22.3183753,34.101514,2.305144,119.6688638),(18147,'metatarsus-pes',236,10,344,411.8811513,86.1945643,85.6859902,1.8,86.377514,86.9527583,0.2375623,52.530244,40.706129,22803.7739833,155000.9757778,3.8018097,3807.8043671,434.1075209,3048.9758228,19.2794142,29.0863116,1.7041466,99.7108464),(18148,'metatarsus-pes',236,10,345,372.6533673,85.1300008,84.6390046,1.8,86.4360325,85.8863674,0.234184,33.224201,38.3997322,21395.7989362,153901.3053667,3.3443702,4007.8744449,643.9823466,4553.6596049,22.0281534,39.3011095,1.9463194,163.6330362),(18149,'metatarsus-pes',236,10,346,333.3631861,84.0692984,82.4760076,1.8,85.746541,83.7183779,0.1744235,31.9953189,36.9634664,15124.9149498,139123.8414952,1.6732769,3763.8202019,472.7227447,4171.929042,19.358162,37.6450515,1.3734008,130.9334835),(18150,'metatarsus-pes',236,10,347,321.3939028,83.7228524,81.6756606,1.8,85.4872834,83.1701858,0.1590819,53.8825594,36.2416372,14210.6116417,135258.7829089,1.3441927,3732.137768,263.7330483,2459.9663601,20.9696343,37.6368426,1.4302203,136.8996885),(18151,'metatarsus-pes',236,10,348,309.8361188,82.5567623,81.0318651,1.8,83.8331869,82.5693995,0.1124323,50.0370463,34.7020999,13823.1896879,131390.5917757,0.6500287,3786.2432617,276.2591063,2465.166302,23.0279525,39.0249656,1.3804678,160.6292357),(18152,'metatarsus-pes',236,10,349,271.2229057,82.4073105,80.9589321,1.8,81.7575749,81.8569101,0.0298485,47.3603049,34.6768717,11169.314084,114128.9195341,0.0402615,3291.2115175,235.8370393,2136.2009835,20.9123447,40.6126394,1.3615168,179.5721876),(18153,'metatarsus-pes',236,10,350,258.4398,76.9485032,80.5582183,1.8,79.7597239,81.678909,0.0283323,47.2122384,38.0624513,9203.1009427,117787.4033457,0.0345665,3094.5827001,194.9304088,2279.611322,19.33591,42.422624,1.4042853,120.1806833),(18154,'metatarsus-pes',236,10,351,272.5851191,78.5874604,80.186098,1.8,80.5112682,82.1170423,-0.0010636,37.9478595,38.466243,9538.5848971,132725.035056,0.0000513,3450.4288641,251.3602878,3398.0784813,21.6338593,44.7976077,1.4211303,132.2337303),(18155,'metatarsus-pes',236,10,352,256.6402446,78.8575173,80.4504485,1.8,80.137267,81.8273668,-0.0154865,51.1838364,44.8805927,9521.1074565,126303.3967011,0.0102576,2814.2096426,186.017855,2610.9460155,17.929662,47.2324561,1.4288993,120.4719268),(18156,'metatarsus-pes',236,10,353,251.8253626,79.1434706,81.1624945,1.8,81.6721045,83.9060906,-0.0011184,41.5443656,40.0265322,12974.1403338,120910.8086296,0.0000525,3020.7665277,312.2960271,3031.2407003,21.0349633,47.7399967,1.408069,145.62842),(18157,'metatarsus-pes',236,10,354,236.1231479,78.6635748,81.6261187,1.8,80.5593308,82.8078382,-0.0002945,37.5566324,39.8106622,10345.8278382,114090.8612385,0.0000035,2865.8368139,275.4727242,2964.2962812,21.3611452,48.2293863,1.4392082,135.443471),(18158,'metatarsus-pes',236,10,355,228.0802797,78.2170858,82.1400186,1.8,79.7782562,82.3780435,0.0078151,37.3143217,39.1961633,9029.6136257,111192.8316178,0.0023217,2836.8294828,241.9878806,3065.6765829,19.5801683,48.1845188,1.4464413,127.9150473),(18159,'metatarsus-pes',236,10,356,237.8510552,78.312841,82.4456545,1.8,79.9936467,82.3555608,0.0167397,33.9916859,36.6280134,8806.3108595,115277.7723993,0.0111071,3147.2570188,259.0724948,3149.8789732,20.6052462,48.1023671,1.4609462,127.2472571),(18160,'metatarsus-pes',236,10,357,248.022843,78.2683048,82.543226,1.8,80.0124558,82.329065,0.0192471,34.1868241,34.8754806,8519.1181491,118531.9124276,0.0153116,3398.7176738,249.193026,3625.6950726,18.2962632,47.9981922,1.482789,125.2231883),(18161,'metatarsus-pes',236,10,358,258.764108,77.939516,82.2497584,1.8,80.0639338,82.1011047,0.0241707,49.1981568,40.055005,8307.4207151,123501.508358,0.0251912,3083.2977878,168.8563404,2262.7815763,18.3839196,47.466078,1.5856101,128.3269278),(18162,'metatarsus-pes',236,10,359,259.6029867,77.8509575,81.6517529,1.8,80.4479212,82.159157,0.0273663,40.8110244,45.3931279,8079.9582294,126137.2321012,0.0323954,2778.7737488,197.9846954,2929.0897527,20.390596,47.5441302,1.5116063,171.1200639),(18163,'metatarsus-pes',236,10,360,246.8861358,77.968849,81.1468385,1.8,80.5199625,84.5932934,0.0339017,54.0454534,47.5555146,12164.1651744,125221.3362712,0.047274,2633.1612098,225.0728677,2437.6924244,19.107746,46.5670378,1.4876551,153.803936),(18164,'metatarsus-pes',236,10,361,211.5844298,79.7245975,80.084218,1.8,84.2405581,85.462131,0.0596299,55.3370193,46.8425475,12578.82914,113402.5084002,0.1252407,2420.9295702,227.3130951,2162.9360625,26.8462913,44.1570829,1.4108832,189.7571366),(18165,'metatarsus-pes',236,10,362,162.0228726,79.0628715,78.4967518,1.8,81.50618,83.2936487,0.0415267,57.6398315,46.340299,7689.0682224,86264.1291903,0.0465405,1861.5358789,133.3985202,1429.6946159,33.7977748,49.7183748,1.0691923,326.8506408),(18166,'metatarsus-pes',236,10,363,125.8206773,79.7171655,77.7973987,1.8,82.4780061,82.3283883,0.032808,56.0616901,45.5264218,5059.6533943,69614.4532554,0.0225634,1529.1000382,90.2515316,1113.0978836,27.4742844,47.7982123,1.4008109,310.4289414),(18167,'metatarsus-pes',236,10,364,58.1413932,85.70031,74.9550702,1.8,83.9296186,76.574093,0.0207701,29.1942439,37.5954357,561.5558211,28916.8809621,0.0041797,769.1593526,19.2351555,782.4281809,17.0541215,36.4168005,1.3468918,95.2654641),(18168,'metatarsus-pes',236,10,365,19.4299402,97.2729512,75.8320897,1.8,96.1189245,76.2603557,0.0921767,7.4726857,47.8788254,180.3719672,3503.5835384,0.0274367,73.1760546,24.1375022,76.941855,19.6017704,42.9136111,1.8873656,176.6390546),(18169,'metatarsus-pes',236,10,366,0.1772664,102.7027511,75.4123888,1.8,102.7565503,75.4519016,1.072061,7.1505839,12.4990034,0.8233388,2.520667,0.0227851,0.2016694,0.1151429,0.2322249,0,0,0,0),(18170,'metatarsus-pes',236,10,367,0.8572308,105.5760439,97.7936796,1.8,105.341368,97.9786553,-0.6751932,23.6787235,28.2587688,35.8183679,177.9546186,0.0558179,6.2973238,1.5126815,6.1746158,0.351562,0.4971837,2.3561945,0.9943675),(18171,'metatarsus-pes',236,10,368,1.1192165,111.4307541,92.8266267,1.8,110.9475586,93.1017306,-0.4147616,34.3823048,38.2289294,54.4710166,189.9039276,0.0302909,4.967545,1.5842747,5.283227,0.4971837,0.9943675,2.3561945,1.988735),(18172,'metatarsus-pes',236,10,369,7.6967998,99.2042823,116.4937512,1.8,99.6341057,113.6487542,-1.3672423,42.4181396,47.3912282,569.316232,3090.2720745,1.2303782,65.2076807,13.4215276,66.3883206,0,0,0,0),(18173,'metatarsus-pes',236,10,370,23.9736978,93.7907562,128.5290699,1.8,91.1686154,122.8346029,1.0154043,33.4319763,47.1460415,581.1433554,3727.7532549,2.8847531,79.0682131,17.3828598,90.605413,13.1215134,13.728935,0.2325569,43.9288387),(18174,'metatarsus-pes',236,10,371,35.8215201,96.0401208,132.2231092,1.8,96.0943429,132.016866,-0.0049778,6.3711514,8.3721177,292.1957687,614.7110555,0.0001479,73.4236043,45.8623176,98.4153595,16.874976,17.4652378,0.6998929,56.0525532),(18175,'metatarsus-pes',236,10,372,50.8368416,96.0079247,131.6300445,1.8,96.0472818,131.3982831,-0.0066996,7.188923,9.8952337,539.6561724,1202.8509849,0.0003803,121.5586227,75.0677357,161.1001087,19.9753553,20.3936265,0.9445349,65.7403184),(18176,'metatarsus-pes',236,10,373,69.9786911,94.8314839,131.2820765,1.8,93.5998012,131.1573965,-0.0559488,7.9254091,19.52173,860.8438615,3235.2540256,0.0364706,165.7257845,108.6182242,204.7085129,5.488282,19.8686968,1.3386925,47.8210054),(18177,'metatarsus-pes',236,10,374,189.5917112,82.6858018,130.2883889,1.8,82.9677536,129.8844089,0.0476884,10.405843,25.1722611,3302.1196944,27946.9102185,0.0718065,1110.2264535,317.3332236,1215.0135315,30.0631184,153.6651724,0.0205921,410.1261921),(18178,'metatarsus-pes',236,10,375,351.6179171,74.9510479,129.4452141,1.8,79.2631009,129.5739561,0.0456037,11.0009848,33.8677606,7390.5445561,67121.0639282,0.1217919,1981.8571637,671.8075399,2183.6331245,30.234332,153.6651724,0.0205921,420.7230216),(18179,'metatarsus-pes',236,10,376,395.8322315,73.833187,129.392945,1.8,79.7921556,129.4203685,0.0310569,11.8233869,35.3518527,8387.5697576,81461.6340704,0.0636116,2304.3101789,709.4049953,2506.6866281,0.351562,0.4971837,2.3561945,0.9943675),(18180,'metatarsus-pes',236,10,377,399.9596958,74.0652753,129.3956276,1.8,80.0782751,129.3938223,0.0327033,12.8069683,35.7862637,8581.1168568,82856.5082403,0.0712675,2315.3159787,670.0349862,2535.6932112,30.585894,153.3068325,0.0183466,497.8485967),(18181,'metatarsus-pes',236,10,378,399.4601439,74.1611971,129.4308473,1.8,80.0918516,129.4455396,0.0350745,11.8174731,36.026274,8571.5921855,82812.495633,0.0818702,2298.6694537,725.332069,2519.2862037,30.585894,152.9492693,0.0160906,485.9308225),(18182,'metatarsus-pes',236,10,379,398.067406,74.248998,129.4557659,1.8,80.1503416,129.460053,0.0369382,11.5291491,36.0221671,8536.8384401,82419.6020518,0.0904812,2288.0245324,740.4569398,2494.7921088,30.234332,152.9440167,0.0137922,417.8898276),(18183,'metatarsus-pes',236,10,380,397.450513,74.3149109,129.4800297,1.8,80.1443119,129.4972524,0.0389439,11.9207202,36.2220483,8490.3283044,81826.8795653,0.1004135,2259.0351319,712.2328336,2477.3120126,30.234332,152.597753,0.0161276,413.9976608),(18184,'metatarsus-pes',236,10,381,396.7459043,74.3983464,129.4991082,1.8,80.222362,129.5416135,0.0402534,11.6768237,36.2126236,8445.3861467,81437.8425597,0.1070859,2248.8799348,723.2605704,2461.012005,30.234332,152.597753,0.0161276,413.1738998),(18185,'metatarsus-pes',236,10,382,396.4533942,74.4824784,129.5062196,1.8,80.2709183,129.5584456,0.0411498,12.2539966,36.161439,8428.1392051,81260.4089614,0.1118231,2247.1563964,687.7869704,2452.8595275,30.234332,152.2409599,0.0138559,412.0942291),(18186,'metatarsus-pes',236,10,383,397.0950064,74.5720454,129.5091707,1.8,80.3672605,129.5587235,0.0411973,11.5794654,36.0865628,8428.8594601,81335.0063071,0.112262,2253.8862088,727.9143861,2456.2903467,30.234332,152.2364947,0.0115468,412.3001693),(18187,'metatarsus-pes',236,10,384,396.8069532,74.6762425,129.5147224,1.8,80.4748634,129.5860296,0.040956,12.154703,36.260128,8412.2063415,81364.2603065,0.1108719,2243.9043876,692.0947692,2460.9436841,30.2235916,151.8947208,0.0162023,411.3911051),(18188,'metatarsus-pes',236,10,385,396.7083761,74.8267397,129.4970154,1.8,80.6733457,129.531676,0.0400801,11.8283753,36.149201,8474.5475977,81301.2539808,0.1061564,2249.0470554,716.4591402,2459.0032674,30.1718224,151.8947208,0.0162023,411.3058018),(18189,'metatarsus-pes',236,10,386,395.6835794,74.9474214,129.5086134,1.8,80.7533136,129.5279962,0.0396368,12.1335792,36.0537465,8441.5862623,81092.1900178,0.1035537,2249.2028687,695.7210351,2451.5525566,0.351562,0.7861165,2.0344439,1.6974915),(18190,'metatarsus-pes',236,10,387,394.6389323,75.0825514,129.5113422,1.8,80.9051469,129.5283945,0.0390052,11.8944251,36.1976749,8418.9334066,80999.804177,0.100017,2237.7073803,707.8049862,2454.74533,30.1595507,151.5379037,0.0139202,410.3114343),(18191,'metatarsus-pes',236,10,388,395.1818926,75.2045851,129.5118965,1.8,81.0430248,129.5350958,0.0385594,11.8926088,36.1145458,8420.3531653,81235.0610819,0.097879,2249.3723597,708.0324697,2457.6261401,0.351562,0.4971837,2.3561945,0.9943675),(18192,'metatarsus-pes',236,10,389,395.1754132,75.3231467,129.5121584,1.8,81.1635513,129.5371853,0.0379602,13.1900745,36.0196495,8408.3380736,81341.9159637,0.0948609,2258.265061,637.474648,2459.1220201,0.351562,0.4971837,2.3561945,0.9943675),(18193,'metatarsus-pes',236,10,390,395.5160508,75.4516877,129.5169143,1.8,81.3075771,129.5443574,0.0374452,12.2982916,36.1734952,8396.812546,81514.1047295,0.092385,2253.4207495,682.7625174,2469.4914901,0.351562,0.4971837,2.3561945,0.9943675),(18194,'metatarsus-pes',236,10,391,396.2195359,75.5886928,129.5198583,1.8,81.4624797,129.5490575,0.0368796,11.2316223,36.0600571,8391.7368204,81703.4074202,0.0897758,2265.759235,747.1526906,2476.1168451,0.351562,0.4971837,2.3561945,0.9943675),(18195,'metatarsus-pes',236,10,392,396.6174396,75.7150322,129.517173,1.8,81.5711345,129.5480654,0.0363707,11.8910113,35.9569905,8398.0701303,81898.0070336,0.0874047,2277.6657852,706.2536497,2481.4685045,30.1258036,151.1782005,0.0093021,406.9517851),(18196,'metatarsus-pes',236,10,393,396.7608482,75.9202722,129.5034562,1.8,81.8039598,129.5103982,0.0356112,12.175699,36.0619049,8461.5160308,81883.9201908,0.0838233,2270.6487744,694.9511491,2485.436406,30.110464,151.1782005,0.0093021,407.7048786),(18197,'metatarsus-pes',236,10,394,395.9138422,76.0541825,129.5115602,1.8,81.9415559,129.4920761,0.0347968,11.8705476,35.948524,8431.2498598,81888.318325,0.0798643,2277.9326999,710.2662932,2485.6454337,30.0828528,150.8237857,0.0069929,405.7514774),(18198,'metatarsus-pes',236,10,395,394.9998697,76.2121643,129.5183783,1.8,82.1101667,129.4936385,0.0335511,11.8801633,35.8073638,8387.9481417,81915.6937211,0.0740791,2287.677309,706.0465383,2486.7819797,30.1012603,150.8237857,0.0069929,406.3339643),(18199,'metatarsus-pes',236,10,396,395.8675499,76.3772839,129.5171225,1.8,82.2561721,129.479085,0.0324972,11.6205542,35.9188254,8396.3467008,82364.2319521,0.0696526,2293.0658535,722.5427106,2510.5330934,30.0981924,151.1720688,3.1392671,406.9164513),(18200,'metatarsus-pes',236,10,397,397.0181148,76.5405483,129.5095938,1.8,82.4512491,129.4798449,0.0312644,11.8543222,35.783928,8410.6134806,82878.9449653,0.0646571,2316.0941127,709.497628,2525.835058,30.1012603,150.8237857,3.1345998,406.1280241),(18201,'metatarsus-pes',236,10,398,398.5471077,76.71324,129.500813,1.8,82.6241466,129.4729163,0.0293359,11.3173936,35.632646,8431.7152042,83622.3114371,0.0571483,2346.789276,745.022706,2545.0047578,0.351562,0.4971837,2.3561945,0.9943675),(18202,'metatarsus-pes',236,10,399,400.4623189,76.9074104,129.4912616,1.8,82.8355037,129.4621141,0.0271697,11.9050377,35.7098393,8451.8578742,84456.6760529,0.049258,2365.081379,709.9396135,2582.0693318,31.2699576,150.8237857,3.1345998,411.4764083),(18203,'metatarsus-pes',236,10,400,402.0586902,77.1413299,129.4752696,1.8,83.1584208,129.4314902,0.0242603,11.1984985,35.4991752,8476.5855161,85372.2756149,0.039432,2404.9087113,756.939471,2613.9736052,30.2331808,150.8237857,3.1345998,407.2929981),(54822,'okapi_humerus.tif',236,2,141,611.595123,82.22975,107.543889,1.8,88.16019,106.87931,-0.094757,17.270472,35.213103,30114.254009,124482.026556,0.912514,3535.105242,1743.68446,4381.216555,28.828089,29.46627,2.195207,95.627392),(54821,'okapi_humerus.tif',236,2,140,600.554827,81.759757,107.344865,1.8,87.694843,106.64694,-0.113129,22.136468,34.955055,29336.585406,117603.869214,1.27554,3364.430976,1325.260431,4201.611849,28.828089,29.485139,2.254848,95.542088),(54820,'okapi_humerus.tif',236,2,139,566.310453,80.547742,107.361314,1.8,86.297999,106.719001,-0.114773,22.668379,34.953951,27053.980462,99287.954926,1.237864,2840.535948,1193.467823,3614.338961,28.828089,29.46627,2.195207,95.421451),(54819,'okapi_humerus.tif',236,2,138,218.627745,83.41661,108.900048,1.8,83.994292,107.037825,-0.206173,16.837207,30.289831,8589.629991,45352.964731,1.527056,1497.300025,510.157661,1780.440252,28.828089,29.181769,2.597041,94.924267),(54816,'okapi_humerus.tif',236,2,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54817,'okapi_humerus.tif',236,2,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54818,'okapi_humerus.tif',236,2,137,17.557432,103.547297,104.64359,1.8,103.556271,104.65653,-1.481014,6.254933,6.472425,143.030033,146.738909,2.902714,22.671396,22.866757,44.768873,12.656234,13.177717,1.410034,41.854808),(54815,'okapi_humerus.tif',236,2,134,56.1474,77.947347,103.415126,1.8,80.14609,103.425181,-0.013395,8.266887,40.905964,640.012691,14000.40595,0.001679,342.258303,77.418829,357.624782,16.171855,24.918782,0.286051,67.352518),(54814,'okapi_humerus.tif',236,2,133,375.467287,88.23015,103.723922,1.8,90.903066,103.584788,-0.009247,29.829482,47.500155,13029.524985,160361.087041,0.005351,3376.011843,436.800246,3644.267359,30.951267,37.152642,0.514451,124.875935),(54813,'okapi_humerus.tif',236,2,132,702.556936,94.163634,103.420501,1.8,94.741162,103.185661,-0.007376,28.047794,45.116401,44926.601685,352136.662495,0.00637,7805.069864,1601.787353,8660.144139,39.726513,83.315016,0.260331,298.829222),(54812,'okapi_humerus.tif',236,2,131,948.004576,95.022348,102.747842,1.8,95.034711,102.34074,0.00512,32.67085,45.56001,101755.990591,465833.643678,0.004141,10224.616816,3114.580482,12180.380282,54.264559,85.632609,0.295782,368.717629),(54811,'okapi_humerus.tif',236,2,130,1084.779,95.600759,102.395205,1.8,95.537699,101.795512,-0.003451,36.028531,45.76241,154782.395701,556065.495991,0.002152,12151.140919,4296.106188,15061.562275,58.760903,88.03173,0.406465,424.393645),(54810,'okapi_humerus.tif',236,2,129,1169.986263,96.164784,101.900635,1.8,95.824991,101.134431,-0.008862,38.455007,45.643332,203412.782581,625250.001474,0.015314,13698.605559,5289.630586,17322.782524,0.351562,1.111737,1.892547,2.400616),(54809,'okapi_humerus.tif',236,2,128,1267.020604,95.675092,101.126157,1.8,95.391452,100.177026,0.006632,41.242793,45.913302,269854.33584,691554.53191,0.009288,15062.182339,6543.066453,18519.645423,68.24865,91.53045,0.487698,459.31464),(54808,'okapi_humerus.tif',236,2,127,1320.663876,94.614755,99.810568,1.8,95.04729,99.11613,0.037084,43.385047,46.616519,345519.805933,724331.656795,0.302569,15538.089818,7964.029787,21696.961643,1.406248,2.899055,1.815775,7.287151),(54807,'okapi_humerus.tif',236,2,126,1323.742949,94.689371,98.49239,1.8,94.982871,98.128844,0.054221,44.296387,47.220085,407267.361465,736529.32702,0.647981,15597.797597,9194.143991,23199.562486,2.761706,10.570273,1.637364,29.972365),(54806,'okapi_humerus.tif',236,2,125,1386.637186,94.324595,97.432095,1.8,94.844865,97.163715,0.027916,45.437298,48.12441,451974.4442,760288.665682,0.180057,15798.39973,9947.212113,24216.544421,1.054686,2.485919,1.712693,6.086843),(54805,'okapi_humerus.tif',236,2,124,1462.161049,94.645885,96.716297,1.8,95.215986,96.289946,-0.059627,46.810067,49.644457,477042.700977,806966.401683,0.8654,16254.914331,10191.027859,25538.751884,3.377065,11.386487,1.725793,32.422951),(54804,'okapi_humerus.tif',236,2,123,1456.224589,95.185701,96.147613,1.8,95.584094,95.517795,-0.14734,47.621727,49.997811,480565.84371,831128.988217,5.230871,16623.307545,10091.315008,25965.790302,77.125382,95.965496,0.608325,503.734607),(54803,'okapi_humerus.tif',236,2,122,1416.39709,95.284292,95.473157,1.8,95.559661,94.904619,-0.191737,47.197517,50.152922,467347.887824,832364.377138,8.57271,16596.52806,9901.959166,25677.147021,76.305101,96.265113,0.655918,449.514809),(54802,'okapi_humerus.tif',236,2,121,1361.603065,95.221237,95.229559,1.8,95.381057,94.581559,-0.204041,46.577557,50.376909,436202.360231,817140.039052,9.317471,16220.5274,9365.075908,24287.799313,76.653309,95.842421,0.631763,470.105287),(54801,'okapi_humerus.tif',236,2,120,1288.688311,95.099789,94.850726,1.8,95.365804,94.213315,-0.204555,45.42373,50.490434,391097.12787,774323.861992,8.86237,15336.050769,8609.973839,22612.944201,73.438036,94.660982,0.6643,443.904452),(54800,'okapi_humerus.tif',236,2,119,1205.426147,95.020052,93.841513,1.8,95.766724,93.393645,-0.206704,43.8099,50.489334,341925.063125,739409.042232,8.462355,14644.856404,7804.744183,21200.977786,71.742977,92.882936,0.645772,536.963132),(54799,'okapi_humerus.tif',236,2,118,1037.880692,95.199476,90.907122,1.8,96.422708,90.87232,-0.168071,42.029702,49.802052,255300.618512,669188.803823,4.840461,13436.972504,6074.290481,18523.860462,66.543061,89.367325,0.645861,434.928383),(54798,'okapi_humerus.tif',236,2,117,950.326081,96.30942,89.290882,1.8,98.105264,88.615059,-0.110992,42.325165,48.546377,207043.672985,624029.429345,1.943211,12854.294419,4891.739308,17094.911908,61.514205,86.835829,0.394791,589.732775),(54797,'okapi_humerus.tif',236,2,116,908.261645,97.292953,88.565927,1.8,99.362581,88.09234,-0.076268,42.179638,47.247243,181107.704538,592143.122539,0.878835,12532.860807,4293.723527,16361.034656,58.806521,85.112877,0.224941,402.688163),(54796,'okapi_humerus.tif',236,2,115,876.92537,97.941848,88.044381,1.8,100.219899,87.760388,-0.047029,42.547472,46.105167,161683.335997,553407.629173,0.32302,12003.158642,3800.069152,14526.233368,56.083647,83.426944,0.05059,395.280375),(54795,'okapi_humerus.tif',236,2,114,860.824946,98.085787,87.659238,1.8,100.434977,87.481667,-0.031571,40.895816,44.607763,149323.348496,516376.537795,0.14295,11575.934339,3651.311138,12625.802849,2.108179,11.451429,1.258754,28.274873),(54794,'okapi_humerus.tif',236,2,113,851.375142,97.649327,87.358573,1.8,99.910483,87.211128,-0.036879,41.389196,43.017399,139519.043403,473823.450088,0.192897,11014.693115,3370.90493,13295.930015,0.62925,1.267575,0.982794,2.691859),(54793,'okapi_humerus.tif',236,2,112,836.407381,96.982627,87.166441,1.8,98.888634,87.047497,-0.05255,41.948676,40.845884,128286.196183,420490.61409,0.384609,10294.565276,3058.170348,11728.712891,0.703124,1.267575,2.158799,2.691859),(54792,'okapi_humerus.tif',236,2,111,818.556016,96.293977,86.826352,1.8,97.816191,86.824112,-0.065949,41.058315,63.206489,118813.109517,377189.660806,0.592497,5967.578141,2893.764846,7119.313352,2.220335,14.340974,1.373401,36.506422),(54791,'okapi_humerus.tif',236,2,110,788.348433,95.440363,86.361438,1.8,96.841878,86.442808,-0.086749,41.664626,63.342445,108210.592054,336829.188008,0.986287,5317.590526,2597.181407,6407.559671,2.562684,25.85595,1.365401,72.856874),(54790,'okapi_humerus.tif',236,2,109,766.648217,94.526482,85.974716,1.8,96.027891,86.021975,-0.109424,25.836044,38.416563,100679.374571,304195.015765,1.523821,7918.329836,3896.85724,10428.327856,2.67743,23.375573,1.358653,61.933466),(54789,'okapi_humerus.tif',236,2,108,750.708431,93.758934,85.758127,1.8,95.22502,85.750504,-0.140412,24.507578,37.733318,95559.094262,277760.844052,2.450615,7361.15602,3899.165172,9793.283187,2.881536,21.926878,1.360823,61.145038),(54788,'okapi_humerus.tif',236,2,107,741.770576,92.948545,85.621148,1.8,94.502609,85.432113,-0.176172,41.938149,37.052281,92284.993156,254788.425932,3.797492,6876.45723,2200.502287,8237.83402,2.587469,20.754076,1.383367,59.73879),(54787,'okapi_humerus.tif',236,2,106,739.765102,92.308215,85.539258,1.8,93.701202,85.300754,-0.212973,28.538681,35.881273,90270.434865,233576.83445,5.508297,6509.71419,3163.090656,8957.532188,41.675437,64.719892,0.407745,256.200623),(54786,'okapi_humerus.tif',236,2,105,731.907662,91.838065,85.448733,1.8,93.154554,85.106373,-0.247517,28.873427,34.557779,89186.277705,214966.706601,7.321999,6220.50114,3088.870565,8708.203525,2.172909,14.17192,1.446441,39.333555),(54785,'okapi_humerus.tif',236,2,104,709.314822,91.038419,85.63986,1.8,92.521088,85.173753,-0.298895,29.322545,33.705913,88283.249398,195766.601508,10.250693,5808.078922,3010.763557,8369.167374,1.054686,2.049941,2.111216,4.389351),(54784,'okapi_humerus.tif',236,2,103,693.239642,90.427596,85.75556,1.8,91.821993,85.029688,-0.352412,30.049579,32.853895,87708.586463,180011.390019,13.765104,5479.149206,2918.795879,8089.151187,1.054686,2.223474,1.892547,5.589659),(54783,'okapi_humerus.tif',236,2,102,678.478885,89.952771,85.955029,1.8,91.131892,85.136365,-0.421547,22.828811,32.139428,86177.159583,165658.13033,18.932042,5154.358351,3774.92976,7821.172941,1.968613,13.652201,1.3633,34.567657),(54782,'okapi_humerus.tif',236,2,101,665.11435,89.38708,86.112488,1.8,90.509933,85.280647,-0.486247,22.24756,31.38287,84354.059534,154391.596438,24.207885,4919.613752,3791.609548,7604.487914,1.828906,14.685871,1.378096,35.803298),(54781,'okapi_humerus.tif',236,2,100,660.971678,88.852503,86.230665,1.8,89.985202,85.419674,-0.546229,22.17825,30.578293,83164.813929,145092.108236,29.726937,4744.938064,3749.836662,7464.665486,1.820889,11.859684,1.361773,32.784862),(54780,'okapi_humerus.tif',236,2,99,659.746094,88.475897,86.402351,1.8,89.600984,85.654262,-0.607338,22.036687,29.776099,81178.148711,136702.56676,35.810996,4591.016718,3683.772837,7312.319752,1.485495,10.830166,1.341564,24.709283),(54779,'okapi_humerus.tif',236,2,98,660.095982,88.120954,86.633133,1.8,89.123911,85.911232,-0.662368,21.781483,29.199696,79378.573099,129502.823808,41.608844,4435.074459,3644.314372,7142.430921,0.351562,2.138469,1.735945,4.509988),(54778,'okapi_humerus.tif',236,2,97,653.272741,87.796901,86.806646,1.8,88.703427,86.038291,-0.71305,21.893644,28.3746,77997.695238,123776.725407,46.589643,4362.236772,3562.572543,7088.489948,39.540799,51.393035,0.570926,222.498124),(54777,'okapi_humerus.tif',236,2,96,643.710015,87.278061,87.144431,1.8,88.134398,86.461785,-0.769257,40.074362,27.791794,76298.213465,117191.891104,51.911086,4216.780316,1903.915872,4305.795198,39.419051,50.431697,0.617008,233.798079),(54776,'okapi_humerus.tif',236,2,95,633.830621,86.806893,87.334125,1.8,87.589209,86.722792,-0.818263,21.08031,27.167932,74065.246118,111762.348105,56.288521,4113.759888,3513.479968,6794.541388,0.905226,6.482484,1.352127,13.821208),(54775,'okapi_humerus.tif',236,2,94,620.96208,86.228247,87.543555,1.8,86.96482,86.936334,-0.874205,20.914675,26.64026,71624.634264,106595.302024,60.889552,4001.286098,3424.611354,6637.069174,0.351562,4.934409,1.642104,10.134981),(54774,'okapi_humerus.tif',236,2,93,605.535404,85.731809,87.808901,1.8,86.493073,87.244745,-0.934612,20.763584,26.021602,69315.060041,101636.802564,65.297824,3905.862577,3338.299401,6487.651514,0.351562,2.485919,1.712693,5.213112),(54773,'okapi_humerus.tif',236,2,92,597.211896,85.354063,88.140903,1.8,85.984081,87.662093,-1.000071,20.455809,25.321693,67606.169761,97272.936604,70.484742,3841.486323,3304.986437,6380.052664,0.699887,3.930583,1.390943,8.316852),(54772,'okapi_humerus.tif',236,2,91,595.729269,84.897431,88.554479,1.8,85.469916,88.233205,-1.073236,20.188723,24.620621,66495.497041,93824.299769,76.670401,3810.801565,3293.695073,6212.947043,0.702455,7.76626,1.480136,16.051218),(54771,'okapi_humerus.tif',236,2,90,594.533498,84.427022,88.920438,1.8,84.949994,88.72345,-1.145943,20.117681,25.424768,65498.210678,91618.504239,82.253886,3603.513932,3255.753487,6033.343903,38.416809,44.771397,0.752077,180.693286),(54770,'okapi_humerus.tif',236,2,89,600.609209,83.959134,89.289878,1.8,84.490168,89.186268,-1.233692,19.963111,25.535129,65394.971007,89888.671486,89.150478,3520.196554,3275.790507,6069.758359,0.351562,1.111737,1.892547,2.400616),(54769,'okapi_humerus.tif',236,2,88,607.388294,83.337289,89.76368,1.8,83.736396,89.792512,-1.3359,27.157143,24.576347,65396.703271,87974.785225,95.747792,3579.652599,2408.084812,4796.574409,0.351562,4.934409,1.642104,10.134981),(54768,'okapi_humerus.tif',236,2,87,615.705285,82.945899,90.158242,1.8,83.390996,90.160191,-1.428572,19.638263,24.598732,64925.860732,86747.537351,100.555782,3526.504454,3306.089822,6114.69635,36.099991,42.933774,1.280124,144.463471),(54767,'okapi_humerus.tif',236,2,86,623.298567,82.564725,90.642863,1.8,83.050996,90.607718,-1.520428,26.402693,40.816152,64348.246382,85571.000509,103.619773,2096.498493,2437.184975,3084.039828,0.351562,2.485919,1.712693,5.213112),(54766,'okapi_humerus.tif',236,2,85,627.162811,82.265628,91.107663,1.8,82.818023,91.008818,1.544069,28.453602,38.61257,63406.006698,84939.772757,104.452485,2199.795897,2228.400001,3113.152114,0.351562,0.786117,2.034444,1.697492),(54765,'okapi_humerus.tif',236,2,84,620.408221,82.060625,91.555409,1.8,82.48562,91.495858,1.481513,66.521346,27.779995,62460.72908,84964.924665,102.579298,3058.493195,938.957685,2045.051861,0.351562,2.834384,1.695151,5.916237),(54764,'okapi_humerus.tif',236,2,83,607.17908,81.834244,91.980174,1.8,82.275675,92.029763,1.409813,19.802301,22.903852,61577.123514,84788.250737,98.596516,3701.920959,3109.594411,6364.731648,36.082665,42.305933,1.495936,148.490911),(54763,'okapi_humerus.tif',236,2,82,601.192694,81.580754,92.44013,1.8,82.026055,92.511163,1.345287,20.402072,22.704227,61113.988696,85391.093714,95.189039,3761.021827,2995.479572,6403.884574,35.466528,42.473586,1.908252,129.612561),(54762,'okapi_humerus.tif',236,2,81,598.126355,81.321639,92.804105,1.8,81.79318,93.020652,1.289694,20.268924,22.5837,61297.666077,86582.810433,92.015871,3833.862929,3024.219013,6428.641695,0.351562,1.111737,1.892547,2.400616),(54761,'okapi_humerus.tif',236,2,80,579.840307,80.922509,93.337924,1.8,81.320778,93.523844,1.233095,20.804319,22.960908,60757.227769,87200.538577,86.031616,3797.782604,2920.414094,6409.02309,35.221039,43.24785,1.884835,129.491924),(54760,'okapi_humerus.tif',236,2,79,570.154622,80.74555,93.77328,1.8,81.058026,93.945427,1.190357,20.439084,23.239838,60058.293054,88178.437553,81.923156,3794.279354,2938.404288,6162.086075,35.065065,43.616371,1.933341,130.074411),(54759,'okapi_humerus.tif',236,2,78,563.276549,80.64546,94.146026,1.8,80.988612,94.314501,1.146642,20.54654,41.22718,59550.02286,89085.644339,77.978703,2160.847371,2898.299307,3362.442493,35.06699,44.070236,1.93797,130.571595),(54758,'okapi_humerus.tif',236,2,77,557.894323,80.531098,94.483649,1.8,80.890228,94.700106,1.109238,20.997559,41.699959,59352.966254,90555.234472,74.541088,2171.590488,2826.660359,3383.664559,34.909785,44.408286,1.977767,131.154082),(54757,'okapi_humerus.tif',236,2,76,554.202364,80.45007,94.91573,1.8,80.783194,95.161246,1.070124,24.427588,28.424209,59352.863763,92607.678364,71.084284,3258.056453,2429.747233,4096.405143,0.351562,1.111737,1.892547,2.400616),(54756,'okapi_humerus.tif',236,2,75,546.664663,80.307292,95.244446,1.8,80.648502,95.463853,1.024561,20.849875,24.898371,59251.035692,94333.754426,66.524244,3788.752025,2841.793313,6153.523009,34.647991,45.243729,1.961403,132.936877),(54755,'okapi_humerus.tif',236,2,74,542.802067,80.144773,95.475658,1.8,80.509099,95.736965,0.984502,20.007079,25.971587,59330.820675,97163.603029,62.773549,3741.150003,2965.491434,6019.190046,34.541704,45.703068,2.1033,134.016548),(54754,'okapi_humerus.tif',236,2,73,542.39229,80.029122,95.69232,1.8,80.430761,95.984718,0.956616,20.247506,25.902353,59829.544811,100548.952581,60.376533,3881.846343,2954.909332,6169.580695,34.472992,46.323555,2.139854,135.216856),(54753,'okapi_humerus.tif',236,2,72,538.288532,79.888465,96.075195,1.8,80.359971,96.504288,0.928635,22.001248,25.185012,60111.109602,104145.253179,57.532773,4135.207589,2732.16812,6395.348894,34.472992,47.030542,2.121472,136.417164),(54752,'okapi_humerus.tif',236,2,71,539.041756,79.79747,96.326386,1.8,80.310181,96.918119,0.905694,20.203856,26.388366,60181.096661,107869.74167,55.623576,4087.776523,2978.693633,6332.416631,34.472992,47.61168,2.193621,137.617472),(54751,'okapi_humerus.tif',236,2,70,540.277527,79.654682,96.481178,1.8,80.255673,97.143018,0.889852,20.382659,26.686898,60145.980957,112017.852772,54.360517,4197.484912,2950.840758,6371.503376,34.512,48.317726,2.237583,138.903083),(54750,'okapi_humerus.tif',236,2,69,545.508517,79.541255,96.565897,1.8,80.154335,97.327624,0.877562,21.368195,27.264237,61048.067402,116696.859503,53.791075,4280.217269,2856.959546,6518.744458,34.551009,49.164669,2.188552,140.515272),(54749,'okapi_humerus.tif',236,2,68,550.543851,79.464278,96.623651,1.8,79.978019,97.326447,0.866499,54.369701,27.679304,62055.241699,121617.761541,53.287692,4393.815739,1141.357045,3360.91094,34.656574,49.966357,2.256526,142.006823),(54748,'okapi_humerus.tif',236,2,67,562.301527,79.385574,96.575285,1.8,79.831222,97.006733,0.848722,30.97247,60.679632,63131.523294,127148.061356,52.777149,2095.399348,2038.310879,2793.005744,1.403543,5.0703,2.158799,11.761805),(54747,'okapi_humerus.tif',236,2,66,566.697608,79.337977,96.617753,1.8,79.777832,97.032629,0.833723,21.517672,28.008814,64201.053337,133211.869663,51.781954,4756.069591,2983.643086,6924.098882,0.351562,0.497184,2.356194,0.994368),(54746,'okapi_humerus.tif',236,2,65,563.0246,79.31639,96.712521,1.8,79.65655,97.179091,0.822905,29.916766,28.27972,65002.4891,138100.532786,50.434918,4883.376871,2172.777972,5504.672187,34.887095,52.665123,2.446,147.681786),(54745,'okapi_humerus.tif',236,2,64,585.381635,78.700704,96.468735,1.8,79.241732,96.920042,0.81995,40.063744,29.93283,66358.066477,150318.93485,52.150166,5021.875109,1656.312145,5246.517662,37.693927,56.078281,2.096163,407.100724),(54744,'okapi_humerus.tif',236,2,63,657.765264,78.905716,95.130425,1.8,79.769878,92.40606,0.911315,79.842124,70.938447,101058.293221,200018.764544,68.472272,2819.610125,1265.726509,3707.099966,0.351562,0.786117,2.677945,1.491552),(54743,'okapi_humerus.tif',236,2,62,624.705912,78.816358,95.711176,1.8,79.056091,93.157714,0.863133,42.121164,58.404753,73625.37596,189086.217711,60.119839,3237.514196,1747.942563,4249.421768,37.534182,56.4747,2.316568,228.714177),(54742,'okapi_humerus.tif',236,2,61,685.120553,78.768591,96.383104,1.8,78.939742,97.292074,0.793928,42.939248,33.502454,79824.304871,179365.778929,58.067371,5353.810231,1859.005661,5995.089083,45.54566,62.179791,2.324205,512.551155),(54741,'okapi_humerus.tif',236,2,60,598.269127,79.229199,96.886802,1.8,79.923163,97.694313,0.770784,21.479886,30.845557,69506.234703,167108.599087,48.398785,5417.590667,3235.875346,7603.847066,2.92292,28.853802,2.321725,78.07856),(54740,'okapi_humerus.tif',236,2,59,601.075241,79.109352,96.73838,1.8,79.681191,97.346042,0.7653,21.034358,32.517528,70471.112342,173555.961145,48.076678,5337.304924,3350.285823,7503.99495,2.859667,28.343839,2.338652,74.683576),(54739,'okapi_humerus.tif',236,2,58,600.414827,79.118776,96.689884,1.8,79.590558,97.249822,0.762747,23.222011,32.786071,71271.067661,181126.862473,47.768624,5524.506459,3069.116939,7695.424805,2.459779,23.648919,2.303611,64.036776),(54738,'okapi_humerus.tif',236,2,57,601.519999,79.285591,96.809878,1.8,79.769452,97.401978,0.762686,23.11961,32.814112,72241.010154,190001.892304,47.850447,5790.249382,3124.663825,7983.105269,2.696306,28.597796,2.330113,76.416402),(54737,'okapi_humerus.tif',236,2,56,600.452093,79.375627,96.868517,1.8,80.114217,97.605179,0.754035,27.491199,33.253182,73455.894082,196714.560495,46.90107,5915.661277,2671.978507,8124.577678,0.351562,0.786117,2.034444,1.697492),(54736,'okapi_humerus.tif',236,2,55,597.923958,79.439302,96.748502,1.8,80.189749,97.511829,0.75085,23.139824,33.528644,73669.361256,201903.329564,46.386893,6021.816114,3183.661242,8218.564474,0.745776,1.491552,2.356194,2.983103),(54735,'okapi_humerus.tif',236,2,54,599.270216,79.414742,96.525322,1.8,80.182936,97.339153,0.748444,21.939503,34.691254,74146.716216,207297.716265,46.251594,5975.503684,3379.598659,8111.546922,0.351562,1.111737,1.892547,2.400616),(54734,'okapi_humerus.tif',236,2,53,605.61724,79.505852,96.467118,1.8,80.37856,97.338198,0.74876,21.740106,34.885435,75312.713278,213645.87815,46.773258,6124.214193,3464.229354,8275.764197,0.703124,1.449528,1.815775,3.394984),(54733,'okapi_humerus.tif',236,2,52,613.255989,79.656821,96.372687,1.8,80.432303,97.178876,0.746425,20.754032,35.312642,76603.232986,221858.750021,47.125269,6282.700461,3691.004817,8435.095546,2.983103,32.316949,2.356194,87.063203),(54732,'okapi_humerus.tif',236,2,51,618.984883,79.706625,96.203165,1.8,80.498852,96.918824,0.747872,20.494508,35.118219,77922.647162,227561.960596,47.714373,6479.883262,3802.123366,8665.511224,2.734511,32.316949,2.356194,89.840365),(54731,'okapi_humerus.tif',236,2,50,618.596568,79.598268,95.933322,1.8,80.269764,96.633591,0.748756,42.323752,34.811748,79165.555832,231933.836155,47.775277,6662.516185,1870.475867,7316.258727,0.497184,0.994368,2.356194,1.988735),(54730,'okapi_humerus.tif',236,2,49,621.727776,79.475763,95.584796,1.8,80.198574,96.246793,0.753063,24.479238,35.068072,81008.783314,237943.838337,48.462322,6785.198803,3309.28534,7832.559884,38.527604,65.338544,2.474415,222.003451),(54729,'okapi_humerus.tif',236,2,48,619.631327,79.182361,95.286147,1.8,79.966243,96.044018,0.75857,29.867317,39.024238,82876.541929,242972.988848,48.866693,6226.207057,2774.823804,7672.114775,1.515103,7.742351,2.259721,17.728012),(54728,'okapi_humerus.tif',236,2,47,622.752985,78.938582,94.938983,1.8,79.839939,95.759202,0.763587,25.518798,35.618827,84546.847104,247721.416815,49.632939,6954.788756,3313.120331,9315.300131,1.000533,8.963109,2.300696,18.310499),(54727,'okapi_humerus.tif',236,2,46,626.694794,78.760703,94.569833,1.8,79.62489,95.444334,0.770564,22.125526,36.030676,86827.509086,253978.544659,50.675382,7048.953105,3924.313928,9456.496182,1.483381,10.761475,2.240435,24.191401),(54726,'okapi_humerus.tif',236,2,45,631.788443,78.514996,94.099074,1.8,79.322019,94.987901,0.77803,21.117801,36.305246,89657.958694,261293.049452,51.873164,7197.115577,4245.610581,9643.287386,1.683882,12.738971,2.258468,32.26698),(54725,'okapi_humerus.tif',236,2,44,638.27895,78.238114,93.680014,1.8,79.209291,94.603623,0.788459,21.397105,37.284883,92804.190279,270968.688329,53.515496,7267.52142,4337.231214,9756.163569,0.351562,0.497184,2.356194,0.994368),(54724,'okapi_humerus.tif',236,2,43,650.543294,78.08121,93.290293,1.8,79.016291,94.257799,0.797045,35.967728,38.440753,97382.234082,282502.381712,55.474592,7349.033447,2707.48919,8933.985305,40.728157,69.222918,2.298704,245.562396),(54723,'okapi_humerus.tif',236,2,42,663.947455,77.84986,92.836838,1.8,78.758683,93.83976,0.805716,35.906782,37.744338,102998.021702,296038.331551,57.57672,7843.25136,2868.483754,9242.203965,43.006402,70.245584,2.292451,299.826101),(54722,'okapi_humerus.tif',236,2,41,679.439712,77.676054,92.363646,1.8,78.487848,93.356855,0.816262,42.555234,60.301898,108740.215669,311845.809081,60.112744,5171.40949,2555.272431,6927.761951,43.677392,71.437203,2.258603,254.788313),(54721,'okapi_humerus.tif',236,2,40,699.256364,77.340483,91.916605,1.8,77.935521,92.965282,0.831188,27.598588,38.141162,116239.913399,331674.585572,63.600424,8695.974739,4211.806466,11669.064543,43.645079,72.921802,2.260596,221.200388),(54720,'okapi_humerus.tif',236,2,39,724.070747,77.006848,91.297125,1.8,77.616462,92.252436,0.848029,46.538421,39.149722,124621.720211,354231.679844,67.877662,9048.127479,2677.824415,9856.44844,44.091036,74.506278,2.249222,232.87689),(54719,'okapi_humerus.tif',236,2,38,756.534554,76.672705,90.581839,1.8,77.215065,91.5381,0.865138,25.288933,64.401439,135154.328181,382377.151019,73.056345,5937.400737,5344.4061,7888.363724,45.692541,76.580837,2.126963,240.199375),(54718,'okapi_humerus.tif',236,2,37,793.912233,76.269704,89.77883,1.8,76.709394,90.674258,0.889085,27.676564,41.438641,147629.247467,417340.281079,79.780915,10071.282993,5334.088627,12009.325227,47.457127,79.057702,2.092149,241.208378),(54717,'okapi_humerus.tif',236,2,36,850.186187,75.686981,88.630312,1.8,76.076648,89.551389,0.921933,26.922122,43.130438,164923.460896,465674.876479,89.955921,10796.896572,6125.945891,13081.963946,49.392681,81.816581,2.072887,261.407673),(54716,'okapi_humerus.tif',236,2,35,903.307885,75.080588,87.288238,1.8,75.246371,87.521066,0.964865,27.077153,44.91786,186613.798798,534300.530255,101.718228,11895.057675,6891.92841,15281.074595,52.825421,88.756714,1.922613,274.717062),(54715,'okapi_humerus.tif',236,2,34,1001.425899,74.101109,84.346914,1.8,74.049355,84.663085,1.037977,29.545848,48.422573,222390.162702,666022.300794,123.83843,13754.376439,7526.951496,18346.714286,56.969305,95.516895,1.963606,327.801158),(54714,'okapi_humerus.tif',236,2,33,1110.020238,72.602116,81.799868,1.8,72.449636,82.875075,1.040601,36.673876,53.742577,261501.225878,801862.228462,137.691676,14920.427681,7130.449604,18646.109129,59.733573,97.995678,2.003956,341.828306),(54713,'okapi_humerus.tif',236,2,32,1211.844893,71.393409,80.21945,1.8,71.852728,82.59414,1.026996,34.025544,67.824737,313869.419366,918285.807514,147.906852,13539.098762,9224.523283,18165.272243,63.218296,99.727195,2.11968,311.670699),(54712,'okapi_humerus.tif',236,2,31,1285.479986,70.93036,79.280352,1.8,71.713522,82.494643,1.033276,33.679934,56.620136,355925.566681,980319.411949,158.081461,17313.971327,10567.882067,23134.340897,65.18022,100.87871,2.124963,300.597382),(54711,'okapi_humerus.tif',236,2,30,1360.16542,70.59114,78.822183,1.8,71.711836,82.571756,1.03088,35.356599,57.673287,404764.058744,1027329.590729,166.787486,17812.918882,11448.048584,24080.462704,67.588501,101.329188,2.13859,309.034871),(54710,'okapi_humerus.tif',236,2,29,1421.84587,70.037874,78.748526,1.8,71.491979,82.508034,1.042182,37.08985,56.115562,455557.764553,1048054.054501,176.698412,18676.709745,12282.545348,26785.161539,69.982571,101.780708,2.099368,296.584577),(54709,'okapi_humerus.tif',236,2,28,1453.449337,69.473912,78.76948,1.8,71.350437,82.560943,1.068795,40.588952,67.018062,487525.135216,1045366.386093,186.154113,15598.278439,12011.276744,22868.238813,71.340574,101.997236,2.082247,305.142704),(54708,'okapi_humerus.tif',236,2,27,1458.944186,69.673899,79.365091,1.8,70.929817,83.62526,1.093545,56.215957,66.431175,505475.85481,1052421.311054,191.852859,15842.28044,8991.679282,23440.817045,75.213411,101.958453,2.102346,331.905328),(54707,'okapi_humerus.tif',236,2,26,1525.49525,69.373197,81.956914,1.8,70.44812,85.917728,1.200526,39.722937,64.657497,575113.254636,1151491.101692,220.955702,17809.088617,14478.115181,26001.500351,78.207934,101.846868,2.1272,324.774147),(54706,'okapi_humerus.tif',236,2,25,1551.974881,69.298787,83.25914,1.8,70.113923,86.913631,1.229759,48.840506,64.674381,614972.474354,1167607.52234,229.726734,18053.632657,12591.443538,25790.746402,80.410818,101.605693,2.149202,338.424749),(54705,'okapi_humerus.tif',236,2,24,1532.72104,69.215914,84.692808,1.8,69.674057,87.835047,1.231686,42.992315,61.529329,638835.360056,1135572.646233,227.186339,18455.794527,14859.291818,27557.73252,81.989345,100.925257,2.170393,326.57764),(54704,'okapi_humerus.tif',236,2,23,1535.35101,69.415703,85.709929,1.8,69.562544,88.624664,1.229984,44.042685,60.183605,669755.608614,1103473.929384,227.30232,18335.125181,15206.965861,28224.57014,83.430382,100.00504,2.193906,317.181117),(54703,'okapi_humerus.tif',236,2,22,1538.291581,69.545774,86.569583,1.8,69.387437,89.575498,1.220935,55.690364,59.853616,687383.676187,1077793.903083,226.259793,18007.164483,12342.955261,27959.993124,85.238817,98.894601,2.260528,314.16268),(54702,'okapi_humerus.tif',236,2,21,1523.105917,69.950082,87.64707,1.8,69.188718,90.643142,1.196138,47.25032,59.14684,689453.19513,1006194.318967,219.854508,17011.801907,14591.503317,27531.315139,86.281852,97.138703,2.261364,310.853),(54701,'okapi_humerus.tif',236,2,20,1509.196586,70.111831,89.097181,1.8,69.026793,91.827237,1.141109,49.050596,56.353008,674389.579469,915464.712136,207.880716,16245.179086,13748.855906,28004.388837,87.223363,94.617232,2.264107,313.644798),(54700,'okapi_humerus.tif',236,2,19,1473.857789,70.279695,90.917001,1.8,68.757625,93.268948,0.997616,50.792908,55.519195,641094.318645,809517.711605,173.400144,14580.861963,12621.728899,26127.966318,86.626074,91.189533,2.844228,330.875626),(54699,'okapi_humerus.tif',236,2,18,1267.40289,71.150281,94.644571,1.8,68.741478,95.887066,0.458103,48.562812,45.942519,556713.617462,642618.240346,41.313644,13987.44028,11463.784586,23357.527762,83.097681,91.071539,0.375488,326.500911),(54698,'okapi_humerus.tif',236,2,17,899.996489,71.380028,103.508756,1.8,68.943635,101.733624,0.032682,46.358105,45.308628,259925.571708,543392.525205,0.160155,11993.135717,5606.906691,16185.191718,58.868276,92.055571,0.391853,338.50399),(54697,'okapi_humerus.tif',236,2,16,706.208707,70.632572,108.39394,1.8,67.973911,108.228134,0.027394,31.188615,44.194215,117751.524258,470073.422454,0.088304,10636.537423,3775.464982,11674.389973,54.294429,92.380583,0.3904,311.876639),(54696,'okapi_humerus.tif',236,2,15,579.222552,72.162005,110.764136,1.8,68.503189,109.853321,-0.051133,34.268784,46.606057,69816.045798,365445.89876,0.252182,7841.167443,2037.307334,8547.870069,51.185427,91.854629,0.376242,311.98264),(54695,'okapi_humerus.tif',236,2,14,446.050199,73.574613,112.971027,1.8,69.867686,112.52319,-0.116335,28.112492,48.932896,32249.553217,273302.21788,1.001591,5585.245149,1147.16095,5968.576664,40.812132,90.488141,0.369684,298.708585),(54694,'okapi_humerus.tif',236,2,13,335.689713,72.160275,114.091807,1.8,68.571341,113.585909,-0.067047,25.35957,50.292525,18398.92554,203889.799604,0.251126,4054.077641,725.521989,4279.317367,23.963231,39.819739,0.240696,130.315685),(54693,'okapi_humerus.tif',236,2,12,213.732562,69.258461,115.837462,1.8,65.930566,115.361192,0.009589,20.749719,48.029342,7211.133357,121437.243924,0.003275,2528.39697,347.529202,2566.434253,14.478996,24.11726,0.930211,66.528757),(54692,'okapi_humerus.tif',236,2,11,149.553227,69.604804,115.911838,1.8,65.041269,115.801727,0.00637,20.267652,49.48124,3627.68393,90445.327695,0.001011,1827.871066,178.988858,1834.833245,12.807243,19.678056,1.243396,55.71135),(54691,'okapi_humerus.tif',236,2,10,107.276732,68.157883,115.70408,1.8,62.600333,115.647686,-0.007771,13.656178,49.618902,1619.739104,63869.045403,0.00108,1287.191841,118.608521,1283.562653,10.898424,16.71307,1.959115,47.309194),(54690,'okapi_humerus.tif',236,2,9,57.760026,60.062164,115.440064,1.8,57.897125,115.527153,-0.022157,7.083921,33.332434,501.516943,38022.105923,0.004725,1140.693964,70.796521,1153.515291,9.640176,15.018738,1.929567,40.157316),(54688,'okapi_humerus.tif',236,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54689,'okapi_humerus.tif',236,2,8,12.140374,33.136593,115.650278,1.8,32.771976,115.432384,1.033084,3.580046,5.760219,31.517987,77.182399,1.492617,13.399213,8.803795,18.707559,7.232804,11.606873,2.184004,30.966733),(54685,'okapi_humerus.tif',236,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54686,'okapi_humerus.tif',236,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54687,'okapi_humerus.tif',236,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54684,'okapi_humerus.tif',236,2,3,0.015506,63.082462,133.410159,1.8,62.929609,133.417802,-0.049866,0.000985,10.713081,0.00016,1.728901,0.000006,0.161382,0.162188,0.161397,0,0,0,0),(54683,'okapi_humerus.tif',236,2,2,0.055206,69.74977,132.187335,1.8,69.759957,132.187335,0.010995,0.021648,1.968772,0.000575,0.052267,0.000001,0.026548,0.026555,0.026839,0.351562,2.138469,2.976444,4.304048),(54682,'okapi_humerus.tif',236,2,1,23.083329,73.358223,136.485078,1.8,73.354667,136.483033,0.007864,5.270688,73.254093,62.696197,53397.530866,0.000238,728.935798,11.895258,728.647334,54.843681,175.061316,2.95168,437.448164),(18348,'okapi-metacarpal.tif',236,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(18349,'okapi-metacarpal.tif',236,5,2,2.4857599,46.7862989,43.795872,1.8,45.8269868,44.8149834,-0.8798699,3.8422377,6.709657,1.227147,11.265728,0.2460532,1.6790319,0.3193834,1.7833349,0.3845632,1.9304307,0.5070985,4.0418155),(18350,'okapi-metacarpal.tif',236,5,3,22.6352024,54.9398575,42.7825185,1.8,54.5484776,42.9584669,0.1271859,9.7881621,13.7218253,75.3950764,858.6231723,0.0606972,62.5735392,7.7026796,65.1187544,3.2679793,8.14061,0.2561514,27.8455627),(18351,'okapi-metacarpal.tif',236,5,4,19.634201,52.214891,39.9639454,1.8,51.9309534,39.9494181,-0.2639814,11.2807401,18.3223977,129.3043284,1538.2818114,0.2227907,83.9563595,11.4623977,87.8925868,1.6257005,5.1995342,0.44752,13.4512716),(18352,'okapi-metacarpal.tif',236,5,5,28.3130114,48.4073248,38.7477774,1.8,48.6801387,38.4829417,-0.4823509,10.7381214,22.1010276,253.9880716,4403.4471159,1.015347,199.2417364,23.6529336,205.8912666,0.9264712,4.4725727,0.5763752,9.4094562),(18353,'okapi-metacarpal.tif',236,5,6,71.0679972,46.1811845,47.4903869,1.8,46.5616712,46.6119317,-1.0542021,15.5292965,26.0947541,2904.1598206,11954.8347135,8.9550578,458.1317245,187.0116792,563.900167,2.4375,3.3225085,2.8555412,9.1631358),(18354,'okapi-metacarpal.tif',236,5,7,101.0634268,45.6164447,49.9958023,1.8,45.7149567,49.4512674,-1.1939235,19.0721306,31.9418889,4576.9678863,15214.7584522,14.5626547,476.3261969,239.9819912,617.8407933,0.7897112,2.4375,1.1760052,5.4319805),(18355,'okapi-metacarpal.tif',236,5,8,121.2507528,44.6032713,49.3655266,1.8,44.5463466,49.1026047,-1.3707483,20.2875807,33.8317751,7285.0988087,17552.9076278,19.4104628,518.8290461,359.0915513,699.7696033,0.7125891,2.0194368,1.1902899,4.3713203),(18356,'okapi-metacarpal.tif',236,5,9,209.939201,39.9338801,45.8011809,1.8,39.8182367,46.2748522,0.7721185,34.7370133,29.7782762,16492.8176254,32418.7263456,17.0303334,1088.6703476,474.7908952,1381.3358512,2.5470263,2.9646353,2.536048,8.4131358),(18357,'okapi-metacarpal.tif',236,5,10,418.551733,38.5251383,43.2159684,1.8,38.2749701,43.7565847,0.5450705,33.1314167,28.3735972,28140.1786865,74792.3946399,18.7525001,2635.9856325,849.3502994,3074.1373531,0.375,0.8385255,2.0344439,1.8106602),(18358,'okapi-metacarpal.tif',236,5,11,448.9430753,37.4346773,42.423967,1.8,38.1342524,42.8918837,0.5569724,31.1532505,27.0743157,38082.1609458,77804.2946924,20.9085982,2873.7307956,1222.4137231,3681.1335848,0.4746106,0.9375,0.9272952,1.9659903),(18359,'okapi-metacarpal.tif',236,5,12,628.229478,40.3918701,39.3796473,1.8,40.5175544,39.6520294,0.0134458,24.7715107,35.496976,91115.1957191,111970.3957066,0.0189288,3154.364353,3678.2252396,5684.8231751,26.559936,52.3675785,2.5575622,179.9364447),(18360,'okapi-metacarpal.tif',236,5,13,828.7710831,46.5866577,37.8111077,1.8,45.5061332,38.9654225,0.0075032,25.0076988,33.9544754,128110.0953111,250041.1869515,0.0077764,7364.0126725,5122.8262221,10109.398103,27.6172292,51.9537429,2.5435804,177.6032602),(18361,'okapi-metacarpal.tif',236,5,14,891.8848509,47.9161584,38.388693,1.8,47.0756117,39.1428251,0.0995431,25.7628144,33.6695469,151440.5679424,273361.9031292,1.4680626,8118.9658934,5878.261808,11515.5193109,28.0505825,51.4317661,2.5586456,170.3417748),(18362,'okapi-metacarpal.tif',236,5,15,868.1721413,48.5597254,38.812415,1.8,47.821198,39.6251937,0.1009489,26.0409727,33.2923763,141902.5085752,278639.0042871,1.4695428,8369.4537712,5449.2015432,11545.6777815,44.4550129,53.9563626,0.8542547,255.5103759),(18363,'okapi-metacarpal.tif',236,5,16,834.7847195,48.7663761,39.3570205,1.8,48.3119634,40.0721915,0.0160149,26.1623355,32.6446001,129348.5464734,275254.3264872,0.0356799,8431.8486331,4944.0748992,11209.5854442,43.9878652,54.2082573,0.8809296,229.2479977),(18364,'okapi-metacarpal.tif',236,5,17,805.9766442,47.4525837,39.3055472,1.8,47.8766873,40.0236463,-0.0659965,26.207882,32.5606872,124595.6229169,259578.8351125,0.5842279,7972.1546785,4754.1278957,10368.3524827,42.6786876,54.3507489,0.9052146,224.145522),(18365,'okapi-metacarpal.tif',236,5,18,812.9040661,46.9386666,38.6333572,1.8,47.2752265,39.6615932,-0.118723,25.2937685,32.502267,120039.0765947,256073.3280502,1.900711,7878.6297633,4745.7964359,9935.530815,42.4988331,54.235165,0.9079339,269.5140556),(18366,'okapi-metacarpal.tif',236,5,19,774.9708771,46.7054555,38.1612967,1.8,47.2436337,39.0888091,-0.0835687,24.3433901,32.0945745,98909.0740326,251043.7824988,0.8999336,7822.0006369,4063.0772327,9244.7346393,38.5326302,52.9195291,0.9109962,210.5655708),(18367,'okapi-metacarpal.tif',236,5,20,690.3838317,46.1847043,37.7918361,1.8,47.6519315,38.6850034,-0.0683248,24.2772259,32.0306515,85547.5235131,247998.7800008,0.5363153,7742.5456121,3523.7767252,8734.5266465,19.3922072,35.1346183,1.9651769,98.2448728),(18368,'okapi-metacarpal.tif',236,5,21,675.1564027,47.9195702,38.0804716,1.8,49.6012853,39.2454426,-0.022239,22.5538258,31.7072611,84384.5789311,253300.8089413,0.0556426,7988.7319225,3741.4751579,9327.4075815,20.9318441,34.4495215,1.8977103,119.0564258),(18369,'okapi-metacarpal.tif',236,5,22,605.5749716,52.1412673,38.9386937,1.8,52.295508,39.9002302,-0.0371122,21.9019035,35.2108729,69837.4152285,176231.9480318,0.138948,5005.0434351,3188.6459169,6455.4984996,23.0477148,32.9029112,1.1913482,139.4097943),(18370,'okapi-metacarpal.tif',236,5,23,616.9696982,50.7722718,39.3332278,1.8,49.7566711,39.9953365,0.0922603,20.2741774,34.7066755,56358.2283744,197902.9450028,0.8727895,5702.1579311,2779.8034561,7081.5883518,23.4695169,43.5403907,0.3517143,241.4235117),(18371,'okapi-metacarpal.tif',236,5,24,696.4844638,50.8102344,38.8573196,1.8,49.3896221,39.1991249,0.1326861,21.26871,34.5973238,52415.6131455,219928.332746,2.031706,6356.8018678,2464.4472204,7838.5907331,35.5284426,63.221152,3.1089633,338.3269478),(18372,'okapi-metacarpal.tif',236,5,25,669.7959268,49.6730007,38.1693106,1.8,48.7495029,38.4162686,0.2141261,20.8110966,33.1392789,52281.2864971,184763.0911747,5.0406046,5575.3503772,2512.1831695,6997.2021411,24.3803321,32.2728843,0.2886744,99.5063582),(18373,'okapi-metacarpal.tif',236,5,26,746.520032,52.9796996,37.4876363,1.8,50.8313972,37.7840588,0.119802,22.2842843,36.7390408,72139.544654,207513.7248537,1.7772152,5648.3163547,3237.2385769,7513.6474777,26.1547318,32.040014,0.2847304,109.8556006),(18374,'okapi-metacarpal.tif',236,5,27,836.8576065,52.454216,38.3881793,1.8,50.5074199,38.6320547,-0.0015478,22.2694664,36.1498749,97472.0831731,241823.9253485,0.0003326,6689.481672,4376.9384311,9288.6149678,44.3928387,64.4697422,2.9276555,249.1165312),(18375,'okapi-metacarpal.tif',236,5,28,816.5046839,51.5019299,38.535277,1.8,50.1332933,38.9583201,-0.0621079,22.8423255,35.4530079,102032.6981228,238202.5051542,0.5242558,6718.8235736,4466.8262084,9559.2483018,45.75,63.7954801,2.8616781,260.0714825),(18376,'okapi-metacarpal.tif',236,5,29,819.9240128,50.6399995,38.8843986,1.8,50.0715881,39.4706265,-0.066105,22.4680706,34.6317295,99616.3212688,244005.2665704,0.5962908,7045.7141495,4433.6838299,9872.994481,45.1455468,64.4675609,0.1283232,261.0112687),(18377,'okapi-metacarpal.tif',236,5,30,759.9888494,50.6930029,38.9750022,1.8,50.0884905,39.7418518,-0.0498841,22.042584,34.6755595,88238.7970744,240252.1374455,0.3149351,6928.5727679,4003.1058573,9374.2909255,26.8395404,37.8921681,1.4267999,111.9691152),(18378,'okapi-metacarpal.tif',236,5,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(18379,'okapi-metacarpal.tif',236,5,32,447.5549361,46.1203764,29.510977,1.8,47.0738918,30.4360211,-0.2766994,23.1075041,30.6875567,15680.8516799,119956.6083541,5.5667212,3908.9657611,678.6043014,4257.558606,26.727995,60.7317681,0.2719384,281.2957249),(18380,'okapi-metacarpal.tif',236,5,33,755.1412607,51.825541,33.6886808,1.8,50.7873155,34.5793351,-0.0857932,24.2876791,35.1665405,65487.9572241,216262.5838192,0.9240955,6149.6689921,2696.3447951,7821.5081169,37.3115843,62.1443003,0.1973956,230.8812498),(18381,'okapi-metacarpal.tif',236,5,34,744.1431818,52.0797141,33.7614439,1.8,51.0251876,35.2536057,-0.0509459,23.0998402,35.39132,80235.882954,205889.8818793,0.3216243,5817.5247978,3473.4388764,7867.9103832,39.9859475,61.8138903,0.2015597,180.0306682),(18382,'okapi-metacarpal.tif',236,5,35,751.2349325,51.2025486,33.9432682,1.8,50.6831137,35.467267,-0.0502189,24.3942265,34.4073173,83703.7755873,203332.2208341,0.3154957,5909.5633428,3431.29451,8090.3148665,40.1867017,61.0023693,2.9779599,182.5724837),(18383,'okapi-metacarpal.tif',236,5,36,708.3390874,51.7175169,34.0470658,1.8,50.6751747,35.4916283,-0.0810082,24.3050509,34.4677232,80377.0677644,181683.9760828,0.7730323,5271.1336702,3307.0108836,7416.1161415,39.6205649,59.3697366,2.9702135,305.4822779),(18384,'okapi-metacarpal.tif',236,5,37,689.9873011,51.1755271,34.0955323,1.8,50.4138318,35.6772581,-0.0848501,23.5944466,32.4659579,76204.420629,163660.8765348,0.8259477,5040.9994613,3229.7608759,7038.760603,38.7049074,57.2870036,0.4870694,183.458969),(18385,'okapi-metacarpal.tif',236,5,38,628.9212678,50.4186728,34.5957194,1.8,50.2576094,35.6919082,-0.1053812,24.8314385,30.1365269,68465.7343681,148375.7339259,1.159746,4923.4516719,2757.2198155,6634.8838424,37.8009449,56.2831153,0.4889775,260.1280166),(18386,'okapi-metacarpal.tif',236,5,39,630.8126207,50.8304252,34.1524756,1.8,50.4936028,35.5155629,-0.1531217,23.2489454,29.6557902,62178.0372669,126588.8394227,2.4458266,4268.6044968,2674.4454889,5945.9586964,36.4852792,54.3119246,0.5362751,171.204843),(18387,'okapi-metacarpal.tif',236,5,40,598.3513743,50.5196036,34.2505598,1.8,50.4279399,35.2859815,-0.1759261,24.5581517,26.6625212,56346.9822539,108587.1107516,3.054783,4072.6497719,2294.4309073,6095.3741493,35.6435073,49.1722101,0.5011726,174.2958332),(18388,'okapi-metacarpal.tif',236,5,41,577.0133736,50.1848221,34.7897145,1.8,50.1149322,35.2731292,-0.1818753,24.4522846,25.2130166,53162.6103558,99284.7286136,3.1462147,3937.8361657,2174.1367414,5995.7437999,34.8181498,47.004197,0.4190344,203.630357),(18389,'okapi-metacarpal.tif',236,5,42,541.6089631,50.1525847,34.8053452,1.8,50.0570838,35.0435512,-0.1806539,19.8834743,24.2192533,47708.8787932,89253.7874609,2.9140667,3685.2410838,2399.4236625,5607.3322975,33.9928579,45.2531939,0.4135967,174.6142991),(18390,'okapi-metacarpal.tif',236,5,43,544.7284837,49.9890132,34.6268877,1.8,50.0260899,34.7837133,-0.1798015,19.7273171,23.3164826,45189.9445989,82117.3257043,2.9035586,3521.8573528,2290.7293642,5069.3631921,33.4231845,43.8417342,0.5998644,135.6851054),(18391,'okapi-metacarpal.tif',236,5,44,529.4345028,49.7912984,34.6037305,1.8,49.86538,34.6909048,-0.1795534,23.493565,22.4878822,42657.6891477,76760.1255104,2.8143367,3413.3994781,1815.718014,4997.2941623,32.974592,42.7039225,0.5343955,132.7760957),(18392,'okapi-metacarpal.tif',236,5,45,515.5467827,49.6674368,34.5883588,1.8,49.7406821,34.679809,-0.1683344,19.1528092,21.9565534,40461.9100752,72215.8943175,2.4118847,3289.035983,2112.583571,5028.8883049,32.6500441,41.8998527,0.5457917,130.4994453),(18393,'okapi-metacarpal.tif',236,5,46,505.8864524,49.4912534,34.6841097,1.8,49.5469001,34.8209856,-0.1684691,18.9007062,21.5510609,39126.0963314,68508.7802107,2.370445,3178.9052375,2070.0864778,4782.3661227,32.4005157,41.5188681,0.5566845,129.39329),(18394,'okapi-metacarpal.tif',236,5,47,497.6374645,49.319029,34.8984675,1.8,49.3260236,35.0502559,-0.1793516,18.7035108,21.2308556,38365.8208122,65645.3639166,2.6394329,3091.9792069,2051.2630583,4688.9460309,32.1419399,40.936021,0.6096003,128.3781249),(18395,'okapi-metacarpal.tif',236,5,48,496.1135476,49.2605693,35.1358953,1.8,49.2035528,35.3247721,-0.1907303,18.5912101,20.9298512,38200.8791451,63421.9315804,2.9716434,3030.2141654,2054.7817484,4639.9549106,32.1962304,40.2915643,0.5428137,127.8556006),(18396,'okapi-metacarpal.tif',236,5,49,495.9335156,49.2422534,35.2433202,1.8,49.2196577,35.429882,-0.1929311,18.4745092,20.6481005,38325.0512763,61719.6006412,3.0386549,2989.1176034,2074.4827787,4634.3136766,32.2093032,39.8454044,0.611497,127.4806006),(18397,'okapi-metacarpal.tif',236,5,50,498.3089382,49.2048812,35.3210941,1.8,49.2025604,35.5166457,-0.1937535,18.5971468,20.4529432,38543.3313487,60228.9620556,3.0789695,2944.7577079,2072.540037,4611.9784038,32.2655596,39.4770998,0.6064458,126.8859307),(18398,'okapi-metacarpal.tif',236,5,51,501.8738352,49.1643539,35.3936148,1.8,49.1725241,35.5882291,-0.1911447,18.8058469,20.2069325,38942.3620066,58869.604921,3.0190645,2913.3370397,2070.7582211,4596.3278039,32.526173,39.0814954,0.625269,126.2002705),(18399,'okapi-metacarpal.tif',236,5,52,506.8745135,49.0746452,35.5046895,1.8,49.0903,35.7287033,-0.1963787,18.8360099,20.0100212,39223.2353029,57905.4836625,3.2162377,2893.8242013,2082.3537156,4569.7195873,32.6477579,38.744052,0.6618921,126.4654355),(18400,'okapi-metacarpal.tif',236,5,53,512.4632919,49.0633061,35.6466388,1.8,49.0639029,35.8810818,-0.2043346,18.9502542,19.8997228,39284.7608607,56975.9719659,3.5167593,2863.1540521,2073.0466471,4546.0731934,32.6804413,38.5087754,0.6853869,126.2002705),(18401,'okapi-metacarpal.tif',236,5,54,515.8399858,49.062596,35.7067015,1.8,49.0520287,35.9259298,-0.2112386,18.9098408,19.7754525,39443.2035572,56113.1171912,3.7795575,2837.5136829,2085.8559264,4543.4709387,32.7250636,38.1381637,0.6494007,125.9351054),(18402,'okapi-metacarpal.tif',236,5,55,518.7454261,49.0370397,35.7051529,1.8,49.038625,35.9386538,-0.2159562,18.9547842,19.6306588,39572.4660281,55389.8606312,3.9698351,2821.5996847,2087.7297058,4547.4111014,32.7740887,37.8917042,0.6731953,125.7342802),(18403,'okapi-metacarpal.tif',236,5,56,522.4099325,48.9500477,35.7004768,1.8,48.9457957,35.927543,-0.2237774,18.9576173,19.5439061,39591.8362929,54752.2978624,4.2877689,2801.5023023,2088.4394771,4571.6127791,32.8231138,37.7261928,0.6514532,125.2949404),(18404,'okapi-metacarpal.tif',236,5,57,527.0886328,48.879715,35.7386866,1.8,48.8659277,35.9761839,-0.224798,19.0011835,19.4716169,39537.0972835,54040.4630712,4.3650512,2775.3454398,2080.7702499,4557.0494857,32.9047947,37.6282183,0.6724063,125.3404355),(18405,'okapi-metacarpal.tif',236,5,58,527.9060156,48.8355711,35.8482916,1.8,48.842437,36.0783559,-0.2319093,19.0075983,19.349944,39337.1820831,53447.6300889,4.6477404,2762.1594174,2069.5503657,4563.3254519,32.9793033,37.5117169,0.6684959,124.9654355),(18406,'okapi-metacarpal.tif',236,5,59,528.9573793,48.8718781,35.9162703,1.8,48.8666429,36.1464234,-0.2436038,18.8697297,19.3686869,39178.0862845,52788.4869933,5.1289646,2725.4551274,2076.2399273,4536.3289362,32.8067721,37.335577,0.6786625,124.3252705),(18407,'okapi-metacarpal.tif',236,5,60,529.9188707,48.8896892,35.886842,1.8,48.8888267,36.10966,-0.246631,18.7313512,19.3159576,39016.5102816,52278.2880014,5.2641693,2706.4818125,2082.9522551,4519.4911427,32.7027059,37.132575,0.6637004,124.2154355),(18408,'okapi-metacarpal.tif',236,5,61,531.3030469,48.8447234,35.8510946,1.8,48.853329,36.0770036,-0.2444584,18.5357627,19.2248801,38845.0745837,51781.3570617,5.187193,2693.4553991,2095.6825602,4501.4861933,32.6057095,36.9950377,0.6992807,123.4842802),(18409,'okapi-metacarpal.tif',236,5,62,531.6892543,48.7771749,35.8205246,1.8,48.7627113,36.0439063,-0.2424485,18.3419373,19.1576968,38689.0598182,51261.130812,5.1076283,2675.7460153,2109.3224356,4476.4059227,32.4709836,36.8746292,0.6953893,122.6887851),(18410,'okapi-metacarpal.tif',236,5,63,531.7510973,48.7345805,35.8488972,1.8,48.7286981,36.0838156,-0.235593,18.2444884,19.120628,38508.8853906,50866.4932623,4.828719,2660.2940745,2110.7133602,4445.0982963,32.5797824,36.8517405,0.7025557,123.3101054),(18411,'okapi-metacarpal.tif',236,5,64,531.1810334,48.7537807,35.918649,1.8,48.7498968,36.1529842,-0.2324261,18.1115856,19.0640823,38115.3183065,50389.6975176,4.6970659,2643.1745644,2104.4716455,4407.329176,32.4317456,36.7308624,0.6986598,122.8896103),(18412,'okapi-metacarpal.tif',236,5,65,532.5943786,48.8074123,35.9036939,1.8,48.7920443,36.1356913,-0.2275857,17.9899241,18.998097,37945.3299629,50138.1957348,4.5188117,2639.1167299,2109.2545832,4398.6665047,32.3231784,36.5874915,0.701956,121.7191152),(18413,'okapi-metacarpal.tif',236,5,66,535.3889489,48.8375175,35.8510585,1.8,48.8420743,36.0928327,-0.2197688,17.7651124,18.9558949,37753.627173,49991.3632891,4.2407926,2637.246275,2125.155545,4393.3140592,32.1492145,36.4667014,0.6980299,121.0789501),(18414,'okapi-metacarpal.tif',236,5,67,535.5990447,48.8035272,35.7778187,1.8,48.7923046,36.0195938,-0.2145238,17.5904403,18.8701316,37482.2013518,49674.1075456,4.0454523,2632.4197712,2130.8279174,4360.7720105,32.0181482,36.4276359,0.6723294,120.9691152),(18415,'okapi-metacarpal.tif',236,5,68,534.573196,48.7448474,35.7470553,1.8,48.7329872,35.9775488,-0.2152865,17.4771566,18.8634907,37101.852026,49426.0469712,4.066018,2620.1962103,2122.8769033,4325.7500322,31.9360125,36.3111553,0.6682894,120.8592802),(18416,'okapi-metacarpal.tif',236,5,69,533.1532777,48.7267077,35.7758259,1.8,48.7286524,35.9956192,-0.2097752,17.2805607,18.7699021,36819.4279205,49288.7674246,3.8532704,2625.946968,2130.6847972,4311.4991659,31.6667409,36.2811289,0.675548,120.4842802),(18417,'okapi-metacarpal.tif',236,5,70,532.23538,48.7612435,35.769054,1.8,48.7513825,35.9932008,-0.2136784,17.1969088,18.7466369,36515.6548249,48915.7375812,3.9889081,2609.3073526,2123.3848008,4290.213652,31.5066915,36.2025552,0.6973908,120.01829),(18418,'okapi-metacarpal.tif',236,5,71,530.2966193,48.7799992,35.6977236,1.8,48.7811498,35.9122435,-0.2138899,17.0806013,21.0347043,36111.0676399,48580.6207617,3.9821265,2309.5461684,2114.1567009,3627.4911884,31.3096355,36.1077489,0.6860949,119.3781249),(18419,'okapi-metacarpal.tif',236,5,72,526.8665305,48.7488083,35.5999968,1.8,48.7617416,35.810745,-0.2155143,17.0315235,18.6139388,35596.7403922,48141.8322174,4.0157561,2586.3323623,2090.0502793,4223.0611742,31.3154675,35.9892562,0.6820638,119.0031249),(18420,'okapi-metacarpal.tif',236,5,73,524.3470632,48.6724386,35.5432552,1.8,48.6689732,35.741185,-0.2236138,17.0433242,18.6175554,35159.4644072,47860.6955797,4.2974809,2570.7293256,2062.9464117,4193.2493294,31.1690958,35.9628715,0.6893979,118.7379599),(18421,'okapi-metacarpal.tif',236,5,74,522.8260014,48.6111391,35.5374361,1.8,48.6072338,35.7264605,-0.2280685,24.3692168,20.8946545,34810.0931258,47689.026952,4.4544434,2282.3553705,1428.4452989,3356.4979276,31.0063543,35.9848601,0.730104,118.5826298),(18422,'okapi-metacarpal.tif',236,5,75,520.7308594,48.61795,35.5699981,1.8,48.6032022,35.7499965,-0.2385753,17.0131499,18.5464606,34404.8610176,47474.5028605,4.8468259,2559.7608043,2022.2510935,4142.6727609,30.8336431,35.9711799,0.7374644,117.8969696),(18423,'okapi-metacarpal.tif',236,5,76,519.8641832,48.6321412,35.5160049,1.8,48.608365,35.6944248,-0.2465557,17.1050258,18.5650991,34125.8050733,47268.2862719,5.1611993,2546.0831647,1995.0747551,4132.4375111,30.8287349,35.8953557,0.7114591,117.8326298),(18424,'okapi-metacarpal.tif',236,5,77,518.672397,48.6135726,35.4411095,1.8,48.5946508,35.6124174,-0.2577376,17.1924765,20.8289782,33912.4188688,47103.621449,5.6164212,2261.4465788,1972.5150659,3479.5202349,30.7992859,35.8953557,0.7114591,117.6129599),(18425,'okapi-metacarpal.tif',236,5,78,517.4233061,48.5411071,35.3858497,1.8,48.5060488,35.5522105,-0.2728459,17.2580238,18.6618889,33633.5248315,46879.4030986,6.2621812,2512.0395539,1948.8630498,4076.1212458,30.6667808,36.0004883,0.7227496,117.1469696),(18426,'okapi-metacarpal.tif',236,5,79,516.3924716,48.4355382,35.3635715,1.8,48.3972289,35.5349424,-0.2882425,17.3862182,18.7033936,33322.9248556,46605.1998964,6.9547812,2491.804477,1916.628709,4030.6527573,30.6602361,36.1101829,0.733973,116.9272997),(18427,'okapi-metacarpal.tif',236,5,80,513.4358949,48.3727347,35.4192044,1.8,48.3324513,35.5924091,-0.2976149,17.4520723,18.7182808,32945.2732537,46341.6269881,7.3584051,2475.7416326,1887.757092,4002.3956708,30.5253393,36.0180619,0.715402,116.2871347),(18428,'okapi-metacarpal.tif',236,5,81,511.5469709,48.4030346,35.4374421,1.8,48.353254,35.6068496,-0.3032759,17.5768379,18.7196757,32752.2195971,46030.1226451,7.6042081,2458.9166652,1863.3738219,3974.3076048,30.6569638,36.037578,0.7080619,116.6621347),(18429,'okapi-metacarpal.tif',236,5,82,508.9234091,48.4204076,35.3618489,1.8,48.3724677,35.5302436,-0.307518,17.5981554,18.7265147,32502.8145625,45824.8423622,7.771573,2447.0566532,1846.9444018,3946.1321476,30.5187944,36.0180619,0.715402,116.5068046),(18430,'okapi-metacarpal.tif',236,5,83,507.9530753,48.4202279,35.2840869,1.8,48.3621485,35.4555159,-0.312968,17.5836547,18.7802123,32372.6085945,45607.8093705,8.0250198,2428.5033996,1841.062573,3924.8899155,30.6948337,36.0780404,0.7559949,116.4613094),(18431,'okapi-metacarpal.tif',236,5,84,505.8658061,48.3915325,35.223419,1.8,48.3242601,35.3807933,-0.3167697,17.6643085,18.7897167,32161.1822387,45366.9105084,8.1808111,2414.4542036,1820.6873033,3898.9658057,30.5625,36.0868094,0.74865,116.8363094),(18432,'okapi-metacarpal.tif',236,5,85,503.4653267,48.3821893,35.2218991,1.8,48.3340673,35.395803,-0.3103003,17.6356039,21.9077062,32021.1330322,45229.6777409,7.823458,2064.5556099,1815.7094689,3243.29771,30.375,36.0180619,0.715402,116.5711444),(18433,'okapi-metacarpal.tif',236,5,86,500.5511399,48.4448745,35.2500407,1.8,48.406175,35.4210014,-0.3109879,17.6569359,18.7457647,31866.9000384,45040.4193944,7.8115674,2402.6984296,1804.7808614,3872.1818557,30.5057046,36.0180619,0.715402,116.5711444),(18434,'okapi-metacarpal.tif',236,5,87,499.8601172,48.5450024,35.199156,1.8,48.5138092,35.3544032,-0.3100603,17.6063452,18.7302788,31827.5125209,44993.2346573,7.7558136,2402.1657793,1807.7296648,3870.2195974,30.375,36.037578,0.7080619,116.059659),(18435,'okapi-metacarpal.tif',236,5,88,500.121456,48.5641983,35.1098316,1.8,48.514749,35.2598644,-0.3181393,17.6642873,20.5289103,31848.8250524,45112.8619332,8.1556215,2197.5283236,1803.0065139,3434.5863253,30.4664352,36.1101829,0.733973,116.3703192),(18436,'okapi-metacarpal.tif',236,5,89,497.4643466,48.5783012,35.0259039,1.8,48.5497352,35.1709951,-0.3226315,17.7038273,18.7087464,31732.3617417,44934.3256523,8.3349467,2401.7817442,1792.4012244,3859.2914241,30.4746163,36.1101829,0.733973,116.4801541),(18437,'okapi-metacarpal.tif',236,5,90,495.0516264,48.5889478,34.9821238,1.8,48.5666081,35.1253617,-0.3212426,17.6751044,18.7248121,31602.302555,44795.7171247,8.2257311,2392.318648,1787.9556397,3819.060434,30.3844119,36.2146919,0.7524431,116.434659),(18438,'okapi-metacarpal.tif',236,5,91,490.5810511,48.5842792,35.0216811,1.8,48.5614635,35.1604797,-0.3169231,17.6156804,21.2158778,31290.2503061,44642.6023677,7.9410557,2104.2071776,1776.2725882,3279.9164792,30.2067574,36.1413242,0.719318,116.434659),(18439,'okapi-metacarpal.tif',236,5,92,488.479272,48.6744249,35.0185321,1.8,48.6467527,35.1530507,-0.3099797,17.6673247,18.6082408,31203.7466601,44367.7999613,7.5754163,2384.309213,1766.1840281,3773.2339987,30.2034851,36.2069248,0.8110336,116.169494),(18440,'okapi-metacarpal.tif',236,5,93,487.0690483,48.7472573,34.9370174,1.8,48.706723,35.0713696,-0.2937453,17.6271323,21.6057847,31262.344406,44268.3181507,6.8054008,2048.9104587,1773.5354714,3204.6915108,30.3432463,36.0975242,0.7413091,116.059659),(18441,'okapi-metacarpal.tif',236,5,94,484.4535831,48.7796269,34.8490238,1.8,48.7410533,34.9705136,-0.2797535,17.5648682,18.3832233,31210.9192524,44073.3810204,6.1559142,2397.478417,1776.8945874,3749.0583848,30.2854872,36.0975242,0.7413091,115.8588338),(18442,'okapi-metacarpal.tif',236,5,95,480.7686009,48.7717934,34.7823801,1.8,48.7298742,34.904133,-0.2588346,17.5010543,18.2348797,31077.116665,43843.0169829,5.2493932,2404.3491154,1775.7282564,3744.3232815,30.1875,35.9848601,0.730104,116.6543289),(18443,'okapi-metacarpal.tif',236,5,96,478.2488352,48.7664347,34.7778073,1.8,48.704339,34.8954811,-0.2363718,17.4464195,18.0358451,30957.1743937,43757.8976449,4.3710982,2426.1628598,1774.4141902,3734.2616373,30.1875,35.9159174,0.7040963,115.684659),(18444,'okapi-metacarpal.tif',236,5,97,474.7966726,48.8346284,34.7838679,1.8,48.772694,34.9097478,-0.2181812,17.3332105,17.8941987,30748.1291452,43500.6490939,3.7075654,2430.9917257,1773.9431031,3709.9613964,30,35.8600796,0.7262081,115.419494),(18445,'okapi-metacarpal.tif',236,5,98,469.7805682,48.9491115,34.7033292,1.8,48.8859418,34.8269621,-0.1981135,17.2337768,17.7006366,30634.2428523,43093.2863694,3.0330727,2434.5613919,1777.5698991,3683.1435039,30.1297557,35.8218247,0.748378,115.3739988),(18446,'okapi-metacarpal.tif',236,5,99,466.7266726,49.0345743,34.5673732,1.8,48.9703548,34.6858665,-0.182383,17.0765848,17.6268245,30573.6766203,42870.272784,2.5589364,2432.1041323,1790.385899,3682.6674977,29.9488078,35.6309206,0.7109094,114.4231736),(18447,'okapi-metacarpal.tif',236,5,100,464.9462962,49.05154,34.4393673,1.8,48.9852361,34.5552006,-0.1623707,16.8781012,17.4263802,30445.1536654,42587.2096805,2.0251023,2443.8356747,1803.8257578,3669.6437952,29.9242644,35.5677171,0.7406519,114.2678435),(18448,'okapi-metacarpal.tif',236,5,101,463.6148864,49.0456542,34.3879614,1.8,48.9702364,34.5034569,-0.1446644,16.7999975,19.6834237,30460.2907886,42416.4641459,1.6058241,2154.933244,1813.1128176,2872.7062048,29.9226282,35.547943,0.7555563,113.8928435),(18449,'okapi-metacarpal.tif',236,5,102,460.1314986,49.0657319,34.4065112,1.8,49.0171878,34.5015968,-0.1284627,16.7658346,17.1703759,30268.2110301,42261.1855165,1.2586199,2461.2848183,1805.3506863,3642.4609599,29.8593322,35.4553526,0.7292774,113.5633387),(18450,'okapi-metacarpal.tif',236,5,103,455.7514347,49.1829681,34.381775,1.8,49.147386,34.466949,-0.1193041,16.7151847,17.1085646,30199.1790108,42072.492498,1.0760344,2459.1479979,1806.6913182,3634.9287792,30.0075025,35.441468,0.7367474,114.0293289),(18451,'okapi-metacarpal.tif',236,5,104,451.7549041,49.2672726,34.2976489,1.8,49.2390316,34.3876018,-0.1112834,16.5906791,17.0439111,30222.8013841,41882.252674,0.9285788,2457.3146653,1821.6735554,3629.1541403,29.8298831,35.411697,0.7591869,113.6088338),(18452,'okapi-metacarpal.tif',236,5,105,448.5546413,49.3128193,34.1801909,1.8,49.30251,34.2323062,-0.1037761,16.5892344,17.0040046,30199.9985351,41576.0376711,0.80223,2445.0733039,1820.4576382,3612.9865506,29.7737599,35.3664963,0.7103514,112.8321834),(18453,'okapi-metacarpal.tif',236,5,106,447.3873473,49.3245682,34.1012073,1.8,49.3045102,34.1314178,-0.0957454,16.4563763,16.9869934,30190.3647323,41529.1805502,0.6814609,2444.7634456,1834.5694195,3600.3753559,29.6768046,35.4553526,0.7292774,112.9420183),(18454,'okapi-metacarpal.tif',236,5,107,448.3283203,49.3530162,34.0872558,1.8,49.3442688,34.1118859,-0.0798166,16.302278,16.9169023,30332.7878568,41615.9174718,0.4750173,2460.019969,1860.6471948,3606.4841033,29.8151586,35.4295626,0.7442229,113.6276785),(18455,'okapi-metacarpal.tif',236,5,108,450.7352876,49.4262436,34.1081095,1.8,49.4295261,34.116592,-0.0721624,16.1953098,16.9254592,30472.7754078,41786.0410021,0.3905155,2468.8276084,1881.5802702,3616.0983692,29.7660768,35.547943,0.7555563,113.7375135),(18456,'okapi-metacarpal.tif',236,5,109,452.5719141,49.5237647,34.0790766,1.8,49.5086314,34.0860569,-0.062991,15.9571075,16.8733004,30711.6845976,42021.8427367,0.2988947,2490.4341008,1924.6398213,3643.2299361,29.6179064,35.4890498,0.7143569,113.1161931),(18457,'okapi-metacarpal.tif',236,5,110,453.6044318,49.5398686,33.9877492,1.8,49.5177735,33.9727133,-0.0546053,15.9239709,16.8266897,30893.757562,42269.7830307,0.2251975,2512.0676667,1940.0787526,3674.3793328,29.7611686,35.4712141,0.7218136,113.4268533),(18458,'okapi-metacarpal.tif',236,5,111,455.5448757,49.548539,33.8832747,1.8,49.5054978,33.868604,-0.0382341,15.694595,16.8037019,31058.8547218,42506.2834116,0.1109355,2529.5785272,1978.9522843,3682.7259728,29.7562604,35.5677171,0.7406519,113.6465232),(18459,'okapi-metacarpal.tif',236,5,112,458.1949325,49.5625881,33.8838378,1.8,49.5304907,33.8730859,-0.0237486,15.5203349,16.7506473,31314.564778,42890.8032011,0.0430621,2560.5460167,2017.6474935,3715.608242,29.8364615,35.547943,0.7555563,113.6010281),(18460,'okapi-metacarpal.tif',236,5,113,455.6124609,49.5560693,33.9501901,1.8,49.4870219,33.9446093,-0.0140111,15.3432899,16.6672275,31220.4686215,42958.286611,0.0149058,2577.4104665,2034.7962413,3741.7897811,29.5884574,35.5306316,0.699468,113.7563582),(18461,'okapi-metacarpal.tif',236,5,114,454.0630398,49.5762411,33.9444101,1.8,49.4688734,33.9183285,-0.0187721,15.4052557,16.692856,31363.9073961,43040.0499502,0.0266649,2578.3514857,2035.9225517,3752.3945226,29.6443431,35.5543708,0.6920374,113.710863),(18462,'okapi-metacarpal.tif',236,5,115,457.003924,49.6607037,33.873413,1.8,49.5577978,33.8627525,-0.0132658,23.9255252,16.7421677,31584.8579159,43153.0691098,0.013403,2577.5078707,1320.1322687,2855.8479372,29.6522624,35.6077261,0.677208,113.710863),(18463,'okapi-metacarpal.tif',236,5,116,458.5542933,49.6273792,33.8237189,1.8,49.5095595,33.8636471,-0.0159283,15.1254362,16.7345938,31635.6927746,43455.3324794,0.0193883,2596.7366141,2091.5557328,3790.7324207,29.4778802,35.6516348,0.7034923,113.7752029),(18464,'okapi-metacarpal.tif',236,5,117,457.8452344,49.6571016,33.7630623,1.8,49.5648908,33.7943886,-0.0145101,14.9860387,16.907932,31718.5510704,43739.468817,0.0160651,2586.9200742,2116.5400466,3791.8512865,29.4778802,35.8438998,0.6853615,114.3055329),(18465,'okapi-metacarpal.tif',236,5,118,459.4964808,49.6672736,33.7232817,1.8,49.5741474,33.7687803,-0.0086758,14.9510769,16.9210653,31970.5474122,44262.5631256,0.0057643,2615.8260311,2138.3441288,3820.6583103,29.668624,35.9320648,0.6633315,114.6350378),(18466,'okapi-metacarpal.tif',236,5,119,456.4587145,49.7599651,33.7225363,1.8,49.7041207,33.8061524,-0.0047265,14.901491,16.9855131,31964.0692369,44559.4837077,0.0016996,2623.3816648,2145.024899,3821.6096448,29.6653517,36.1077489,0.6860949,114.6993776),(18467,'okapi-metacarpal.tif',236,5,120,453.1173686,49.8653702,33.6484701,1.8,49.7557236,33.7271627,-0.0018368,14.9374414,17.0685257,32076.5910885,44863.4278676,0.0002549,2628.4301617,2147.3952768,3798.3890452,29.6718963,36.3716171,0.6868176,115.3850378),(18468,'okapi-metacarpal.tif',236,5,121,454.3566371,49.9216676,33.5581153,1.8,49.8387988,33.6539597,-0.0033431,21.5120745,17.3166439,32513.5275815,45395.447341,0.0008465,2621.4922235,1511.4082805,2878.118848,29.678441,36.458506,0.6651027,115.6047077),(18469,'okapi-metacarpal.tif',236,5,122,454.7308274,49.9687109,33.4808119,1.8,49.9048038,33.5845414,-0.0003346,14.9192208,17.3466233,32636.0281006,46103.5551538,0.0000085,2657.7826881,2187.5155966,3862.0327487,29.8528231,36.6398221,0.6547596,116.710863),(18470,'okapi-metacarpal.tif',236,5,123,453.201733,49.9575775,33.4303724,1.8,49.8910283,33.5249046,0.0007777,25.0711425,18.6302406,32816.1917911,46836.7024017,0.0000455,2514.0148919,1308.9228691,2956.7410218,30.0501116,36.8693852,0.6628273,117.3510281),(18471,'okapi-metacarpal.tif',236,5,124,456.0851527,50.0072111,33.4396175,1.8,49.9879757,33.5255675,0.011312,15.0600372,17.7462976,33092.6216826,47816.8736761,0.0097265,2694.4703985,2197.3798143,3907.2162019,30.0533839,37.1656974,0.6566184,118.3018533),(18472,'okapi-metacarpal.tif',236,5,125,453.1371413,50.0980584,33.4415664,1.8,50.0251296,33.542818,0.0205512,15.0588011,18.0864317,32991.9268146,48602.4320098,0.0318925,2687.2316711,2190.8734103,3921.537185,29.9603841,37.4033129,0.614422,118.7411931),(18473,'okapi-metacarpal.tif',236,5,126,455.3832848,50.1392414,33.359829,1.8,50.0582956,33.4481784,0.0215064,15.3425303,18.4193495,33324.9887386,50066.0304452,0.0350987,2718.1215364,2172.0660218,3974.9542273,30.1445832,37.7546044,0.5838704,119.7563582),(18474,'okapi-metacarpal.tif',236,5,127,455.1616406,50.1436854,33.2772151,1.8,50.0703708,33.357109,0.0315946,15.2611031,18.8402765,33499.1488678,51475.0341801,0.0756996,2732.1804004,2195.0673281,4000.8013888,30.1347663,38.170874,0.5825531,121.4383387),(18475,'okapi-metacarpal.tif',236,5,128,458.3314986,50.173241,33.224313,1.8,50.084872,33.2746929,0.0326965,15.5689667,19.1806485,33965.007469,53405.0857964,0.0816353,2784.3211813,2181.5839215,4067.6962076,30.3189654,38.6677555,0.3002815,122.5178435),(18476,'okapi-metacarpal.tif',236,5,129,462.1502024,50.1817032,33.2362711,1.8,50.0994875,33.2754924,0.0345055,15.5849291,19.6972731,34445.3249398,55815.0641454,0.0916718,2833.6442265,2210.1688629,4151.594946,30.4402556,39.4271975,0.2449787,124.3739988),(18477,'okapi-metacarpal.tif',236,5,130,464.2330291,50.2183329,33.2620457,1.8,50.1708612,33.2797708,0.0420849,15.592978,20.0752309,34581.4502058,58230.2796112,0.1369564,2900.6032349,2217.7579,4220.7730024,30.3188848,40.2300028,0.2065361,125.2338338),(18478,'okapi-metacarpal.tif',236,5,131,464.8898118,50.2781623,33.185128,1.8,50.2484731,33.1640706,0.0396739,15.7118084,20.5123621,34545.0524867,60392.8332094,0.1218939,2944.2164174,2198.668141,4248.7794568,30.4337107,41.1480274,0.2018638,127.309659),(18479,'okapi-metacarpal.tif',236,5,132,469.7077415,50.2676853,33.0971975,1.8,50.2686816,33.0655231,0.0376116,15.8071229,20.9315642,35071.1587484,63638.595266,0.1106917,3040.3172337,2218.693372,4351.0115445,30.5129226,42.0142275,0.1658824,128.6543289),(18480,'okapi-metacarpal.tif',236,5,133,470.5589063,50.2341798,33.0411869,1.8,50.1883208,32.978268,0.029097,15.939654,21.3077001,35154.2810569,66345.3455145,0.0663794,3113.6793366,2205.4607312,4414.8146026,30.697143,42.8025992,0.1939591,130.7756493),(18481,'okapi-metacarpal.tif',236,5,134,474.6172585,50.1841515,33.0986941,1.8,50.1608407,33.000027,0.0333944,15.9981505,21.9130751,35596.204469,69905.9511126,0.0881814,3190.1479257,2225.0199832,4520.8202905,30.75,43.7586599,0.1940342,133.0522997),(18482,'okapi-metacarpal.tif',236,5,135,481.058821,50.1958925,33.2752084,1.8,50.1437112,33.193543,0.0305893,16.1551673,22.2922104,36331.4278144,73811.1023367,0.0749981,3311.0714923,2248.9044623,4646.5467005,30.9375,44.6962404,0.1685969,135.1924647),(18483,'okapi-metacarpal.tif',236,5,136,486.0906712,50.2653204,33.3379056,1.8,50.2537962,33.3535481,0.0276137,16.2170088,22.7836293,37427.8567512,77542.9542556,0.0617601,3403.4504945,2307.9383609,4742.5422047,31.125,45.620719,0.1651487,137.0674647),(18484,'okapi-metacarpal.tif',236,5,137,486.6489418,50.3569042,33.4052669,1.8,50.3552035,33.4926895,0.0213258,16.4962406,23.3011175,38194.7265747,80893.1480584,0.0368819,3471.6424297,2315.3594536,4818.9758494,31.6607869,46.7240068,0.1328167,149.4125811),(18485,'okapi-metacarpal.tif',236,5,138,487.5125071,50.2630424,33.3290118,1.8,50.3354763,33.5384573,0.0134357,16.4372369,24.0861748,38826.4557936,84135.6610742,0.0146664,3493.1101244,2362.1035664,4847.6253634,31.8384624,48.0237978,0.0938412,155.356047),(18486,'okapi-metacarpal.tif',236,5,139,500.3701065,50.2947361,33.6636067,1.8,50.4284931,33.7677712,0.0132251,16.9417953,24.9710777,41009.3445524,91882.6191277,0.014585,3679.5616154,2420.602059,5131.7315742,32.5501276,49.5227221,0.0302938,146.0564258),(18487,'okapi-metacarpal.tif',236,5,140,517.2237891,50.1903008,34.0093446,1.8,50.4124926,34.0763908,0.0073704,17.484434,25.9749237,43336.0962377,100834.3516039,0.0046827,3881.9883725,2478.5529938,5399.6883394,33.617239,51.4163839,0.0401244,149.1019209),(18488,'okapi-metacarpal.tif',236,5,141,561.341772,50.205468,34.5410804,1.8,50.4446473,34.4670731,0.0027279,18.4064151,26.6831308,48017.3060377,114610.6713256,0.0006961,4295.2482717,2608.7266676,5928.9813149,34.5415069,52.9152108,0.0389873,152.9429112),(18489,'okapi-metacarpal.tif',236,5,142,637.8748082,50.4248699,35.0101634,1.8,50.4864768,34.7011496,0.0034104,18.8767838,26.8475335,54277.4341762,133798.9973975,0.0012367,4983.6606877,2875.3539166,6734.6336608,34.7780632,53.8960588,0.0556915,155.8064258),(18490,'okapi-metacarpal.tif',236,5,143,733.3744496,50.8379112,34.9785761,1.8,50.5885581,34.6932917,0.0140084,18.8067198,27.6979684,56061.2158862,151944.9687484,0.0239848,5485.7802775,2980.9140775,7277.3063754,34.5873195,54.7962134,3.1005199,161.0187364),(18491,'okapi-metacarpal.tif',236,5,144,637.5689169,50.1914812,33.8931746,1.8,50.5048807,34.6753993,-0.0078326,26.0389272,27.9257885,46948.6490891,128012.7982922,0.006519,4584.0352309,1803.0177968,5854.2642088,33.9107012,55.5914576,3.0842232,166.6781925),(18492,'okapi-metacarpal.tif',236,5,145,546.6386719,50.8449215,33.935941,1.8,50.8367418,34.4981915,-0.001684,25.8616277,27.9831458,37990.6534856,111382.3091279,0.0002589,3980.3355171,1468.9970014,5051.9968505,32.1936009,55.7657279,3.0439314,183.8073186),(18493,'okapi-metacarpal.tif',236,5,146,501.8897301,51.5344466,34.2472817,1.8,51.2551334,34.7024574,-0.0070833,25.7071151,28.3492765,35660.6110677,105621.8982655,0.0041971,3725.7352313,1387.1883702,4747.4896522,34.0085435,54.8635381,0.1960551,275.0636768),(18494,'okapi-metacarpal.tif',236,5,147,516.0944212,51.1604395,33.970454,1.8,51.1435035,34.9275016,-0.0323692,20.8469998,27.6359557,39598.1829377,110942.8308296,0.0900927,4014.4380041,1899.4667484,5178.0198385,24.8751254,36.1466739,1.3723835,150.083969),(18495,'okapi-metacarpal.tif',236,5,148,512.1261754,51.2776557,34.4593663,1.8,51.3317826,35.2336639,-0.0118348,19.8488219,27.0099823,49253.7400409,117221.8984299,0.011954,4339.9472504,2481.4440059,5478.029664,23.9189309,38.7993637,0.9988781,170.7544642),(18496,'okapi-metacarpal.tif',236,5,149,519.3033132,52.2910253,33.7305328,1.8,51.6723544,35.1146874,0.0695598,21.1135621,33.3765347,51218.4836973,114400.6302326,0.4181053,3427.5766314,2425.8570649,4601.8829542,1.6499215,4.1420104,1.4801364,13.3147862),(18497,'okapi-metacarpal.tif',236,5,150,505.4096911,51.1562128,33.6970147,1.8,51.233942,34.9760304,0.0395108,20.8339734,28.9598837,50662.0824844,121713.0055076,0.1314316,4202.8140237,2431.7052444,5505.3070561,24.3050898,37.5487184,1.4204249,218.0214149),(18498,'okapi-metacarpal.tif',236,5,151,478.1131214,51.6407593,35.2466163,1.8,51.537076,35.4698484,-0.0551982,18.0325453,28.4584488,44928.3074985,113705.4333942,0.2425426,3995.4894954,2491.5122549,4937.0691257,26.5082262,39.3861591,0.9511002,208.8537066),(18499,'okapi-metacarpal.tif',236,5,152,496.1754013,50.9039193,35.9334161,1.8,50.6907948,36.1994481,-0.0318565,17.3246415,27.6434409,40583.3091187,124560.0366382,0.0838946,4505.9526868,2342.5194241,5449.2383829,26.0625,38.4008972,0.9204594,222.3426676),(18500,'okapi-metacarpal.tif',236,5,153,480.8321058,49.1606598,36.6363342,1.8,50.2595067,36.5103642,0.0026785,16.1795965,30.9326688,28483.4292789,130437.4616507,0.0005754,4216.818872,1760.453621,4817.2154405,25.9376691,36.0780404,0.8148015,115.8211444),(18501,'okapi-metacarpal.tif',236,5,154,425.0990305,49.3253353,36.5980861,1.8,49.5996208,36.4717768,-0.0075743,13.9812923,29.2394359,15878.7646456,102125.6587657,0.0040648,3492.7369671,1135.7150867,3981.9309584,25.9276529,32.7969606,0.680098,117.1924647),(18502,'okapi-metacarpal.tif',236,5,155,187.2727095,50.9680067,35.9659658,1.8,50.3413033,35.9535216,0.0041314,10.9653572,15.7076617,4260.5302994,16109.4387454,0.0005327,1025.5784099,388.5445991,1163.1860396,14.0625,22.6750999,1.0516502,75.6727272),(18503,'okapi-metacarpal.tif',236,5,156,18.1871591,39.8212207,37.1621288,1.8,39.948394,37.0932385,-1.4371355,4.048581,6.0128447,27.0696774,121.320455,2.977362,20.1768816,6.6862137,24.451253,5.9552769,11.9603838,1.3334221,37.6566693),(18504,'okapi-metacarpal.tif',236,5,157,701.3840305,51.0692104,32.3120697,1.8,51.0890206,32.6847422,-0.0145913,27.6812373,28.4680641,83355.2951307,165195.0839893,0.0248863,5802.8211239,3011.256121,7829.0343909,27.5793763,38.13632,1.1665501,115.14329),(18505,'okapi-metacarpal.tif',236,5,158,554.5521413,50.9511695,30.1010968,1.8,51.2503354,30.7126436,0.0012182,29.3306118,28.0728457,56062.5826737,138467.2157718,0.000137,4932.4253497,1911.4017494,6282.2156485,27.75,38.3825827,1.1639802,117.01829),(18506,'okapi-metacarpal.tif',236,5,159,187.1873118,57.1043868,31.1871227,1.8,57.1317267,30.9740344,-0.0044545,28.3911936,34.0663287,22291.9042955,56048.2957641,0.000619,1645.2696245,785.1696763,2242.6997375,20.5297087,38.2316132,1.1993972,206.6316963),(18507,'okapi-metacarpal.tif',236,5,160,538.6341051,52.0469176,29.7293949,1.8,51.7735254,29.6901322,-0.0139811,30.2634956,28.8896343,50955.4835377,144405.6974088,0.0175468,4998.5297777,1683.7276258,5802.8888784,35.7496329,55.7635213,2.9692578,289.6256762),(18508,'okapi-metacarpal.tif',236,5,161,520.3591513,51.7098563,28.3903616,1.8,51.4217056,28.904763,0.0022979,24.1017272,27.7078078,48719.7150042,129604.5740148,0.0004581,4677.5470219,2021.4200664,5939.3859613,35.1923531,54.4363878,0.254168,273.0411524),(18509,'okapi-metacarpal.tif',236,5,162,538.3734482,51.117789,28.3383968,1.8,51.0436267,28.9121252,0.0063242,30.7349057,26.9109418,49062.3192676,129977.7819179,0.0035884,4829.9231838,1596.3061585,5817.3164182,34.4224568,53.0836972,3.1133316,302.9170453),(18510,'okapi-metacarpal.tif',236,5,163,537.0438707,50.8593038,27.687919,1.8,50.7463046,28.359252,-0.0093279,16.742815,26.3207242,44338.3067457,126527.6886411,0.0077882,4807.1507352,2648.1990512,6350.670043,25.875,35.4528736,1.1686823,106.7788825),(18511,'okapi-metacarpal.tif',236,5,164,503.7036009,50.8371359,26.9320703,1.8,50.7707115,27.4094593,-0.0032988,15.6172743,26.0958774,38520.0883754,118143.2589804,0.0009135,4527.2767406,2466.5052061,5973.6435654,25.4511937,33.494869,1.1923689,103.1842126),(18512,'okapi-metacarpal.tif',236,5,165,473.0932564,50.7270045,26.2848709,1.8,50.6425146,26.6593328,-0.0031442,33.7087463,26.3030503,34298.5065779,111494.8251976,0.0007797,4238.8553464,1017.4957629,4315.386273,24.9375,32.3984592,2.0784569,100.9985524),(18513,'okapi-metacarpal.tif',236,5,166,439.7541051,50.5195968,25.4038586,1.8,50.295757,25.551764,-0.0005306,14.7188077,25.3956391,28145.5684487,104250.2961449,0.0000207,4105.047163,1912.2179549,5197.9096154,24,31.8385821,2.0950556,96.0514069),(18514,'okapi-metacarpal.tif',236,5,167,400.8425604,50.4543197,24.5789229,1.8,50.1320035,24.5407486,-0.0083983,13.6358112,25.3267139,22393.6216619,97741.2708959,0.0047119,3859.2164483,1642.2654534,4730.4302719,23.5770971,31.0169435,2.1973704,91.8276109),(18515,'okapi-metacarpal.tif',236,5,168,366.2946307,50.3675495,23.7953551,1.8,49.9954293,23.7019113,-0.0065417,11.8016383,25.4112329,17661.8313565,92622.7774524,0.0026125,3644.9541023,1496.5575854,4272.6926247,23.2377627,28.9194058,2.1390173,86.9071158),(18516,'okapi-metacarpal.tif',236,5,169,336.8669318,50.4656762,23.0264553,1.8,50.2040541,22.9519455,-0.0060605,10.7832447,25.7074681,13717.2344263,89281.3477324,0.0020622,3472.9731952,1272.0878351,3971.9427699,23.3928845,26.9171907,2.0406744,84.4186011),(18517,'okapi-metacarpal.tif',236,5,170,314.828608,50.4270676,22.314765,1.8,50.1662049,22.18367,-0.0085635,15.1253587,28.2897709,11022.8174799,86333.9815405,0.003848,3051.7737956,728.7640382,3436.2125125,23.5934388,25.7449176,2.1749591,82.0132711),(18518,'okapi-metacarpal.tif',236,5,171,307.1572053,50.4666543,21.7105182,1.8,50.3230521,21.5884522,-0.0049181,11.7278253,26.4526962,9169.18844,86674.048119,0.0012382,3276.5676265,781.8319421,3586.21084,23.9306269,25.3513591,0.6331464,81.4640963),(18519,'okapi-metacarpal.tif',236,5,172,308.6079119,50.4470698,21.2103156,1.8,50.3913417,21.0749854,-0.0055454,11.2727076,26.8090539,7774.4929269,88180.4111618,0.0015815,3289.2026463,689.6739608,3555.848491,23.6545573,28.3298788,2.6068485,90.6649215),(18520,'okapi-metacarpal.tif',236,5,173,319.813956,50.5136597,20.6128396,1.8,50.3933474,20.3733076,-0.0115345,8.5236421,27.231709,6707.5735641,91624.8027361,0.0070912,3364.6365268,786.9374984,3582.5035687,23.3319715,26.078682,0.3831766,81.7292613),(18521,'okapi-metacarpal.tif',236,5,174,314.0510795,50.2851696,19.9350188,1.8,50.2921954,19.659365,-0.0086858,7.7798965,27.2129786,5269.2969762,92169.5345629,0.0039489,3386.9697245,677.2965378,3559.5649798,22.5,26.7442313,0.6210645,81.6571158),(18522,'okapi-metacarpal.tif',236,5,175,288.6533416,50.3113284,19.0205099,1.8,50.4470827,18.779333,-0.009763,7.2421366,27.4268882,3750.3562847,86416.8904901,0.0045855,3150.8091549,517.8521879,3274.6005981,21.9532479,27.9871622,0.614019,85.5812905),(18523,'okapi-metacarpal.tif',236,5,176,259.9680575,50.4879689,18.5440536,1.8,50.6588489,18.4601241,-0.008272,38.4819558,27.987164,3243.124205,77858.4719501,0.0029647,2781.9350319,84.276491,1876.3463574,21.9929912,28.8390604,0.6330984,98.9038825),(18524,'okapi-metacarpal.tif',236,5,177,213.7335405,49.9436009,17.9909197,1.8,51.0142403,17.8215017,-0.0014341,17.8537318,27.8712776,2509.8417297,64646.0738715,0.0000733,2319.4514038,140.5779898,2344.0768566,22.1222102,29.6255933,0.6371721,130.3896103),(18525,'okapi-metacarpal.tif',236,5,178,218.2678125,49.4160399,17.6552564,1.8,49.7437143,17.6218143,-0.0026587,42.1279062,30.725173,2316.881173,72639.8602909,0.0002572,2364.1806761,54.9963524,1714.4355861,22.1047167,29.4762881,0.7313967,95.5100378),(18526,'okapi-metacarpal.tif',236,5,179,224.1269957,50.5040144,17.7378095,1.8,50.4061836,17.5412713,0.0054955,41.9919888,29.9293578,2388.03309,76321.2449713,0.0011281,2550.0461982,56.868778,1671.2094434,22.2934534,29.4327225,0.8801363,88.6800865),(18527,'okapi-metacarpal.tif',236,5,180,238.4018075,50.1506218,17.1434411,1.8,50.3354145,17.1415581,0.0120584,9.9854392,28.596063,2088.629338,76928.9986055,0.0057773,2690.195455,209.1674982,2745.8343153,21.2440459,28.8390604,0.7163835,89.9415719),(18528,'okapi-metacarpal.tif',236,5,181,214.9493821,50.8359481,18.1821167,1.8,51.0353163,18.3708612,0.0351727,35.8195228,31.4148585,4028.5312598,75627.2438236,0.0443015,2407.3717815,112.4674744,1672.0548395,20.843242,29.4034437,0.9119903,139.3031925),(18529,'okapi-metacarpal.tif',236,5,182,274.7892401,50.6213334,18.6610288,1.8,50.7384534,19.0806968,0.0204916,23.8517403,30.1237159,5209.6709964,92438.0503821,0.0192281,3068.6138011,218.4189051,2541.3727265,23.1113273,33.0558831,1.0741658,137.5679112),(18530,'okapi-metacarpal.tif',236,5,183,345.903473,50.2861401,18.8816151,1.8,50.2914977,19.496782,0.0217418,11.5117296,30.1297331,7201.330364,108757.9591911,0.0272476,3609.6555741,625.5645844,3814.6155646,24.3354513,32.8788615,1.0841936,96.6993776),(18531,'okapi-metacarpal.tif',236,5,184,285.2355682,49.2047669,18.8981938,1.8,49.690916,19.2912711,0.0074606,40.3372414,31.2358272,5812.9593721,97201.428495,0.0026461,3111.8570275,144.1089965,2217.8264847,25.3842304,32.0317835,1.1097665,96.5440476),(18532,'okapi-metacarpal.tif',236,5,185,208.5229474,49.618546,19.1134644,1.8,49.6875121,18.9823183,0.0086814,38.2581701,30.3568916,3771.2749929,64652.6762712,0.0026192,2129.7528469,98.5743693,1547.7541177,25.721165,30.4611048,1.1456971,96.6993776),(18533,'okapi-metacarpal.tif',236,5,186,153.689723,48.9732064,18.9040866,1.8,49.220492,18.4450406,0.0174048,24.6257717,29.5331816,2276.5923005,49614.3015639,0.0077587,1679.9511213,92.4475515,1538.466164,24.535987,27.6973741,1.2254955,211.9037742),(18534,'okapi-metacarpal.tif',236,5,187,143.3010724,51.9941332,18.6055037,1.8,51.6345858,18.0742104,0.0186911,41.55303,31.8550366,2425.1022515,46916.8355822,0.0083429,1472.8231585,58.3616225,1091.9656498,23.0358535,26.5813903,1.1103033,251.4009874),(18535,'okapi-metacarpal.tif',236,5,188,169.6654581,50.0920294,17.9534634,1.8,50.2637575,17.482881,0.018668,11.1107217,30.1284295,1911.8052741,58655.1315555,0.0098534,1946.8366773,172.0685059,1982.9873826,21.1800008,26.0490073,1.2103407,87.2899215),(18536,'okapi-metacarpal.tif',236,5,189,153.2584943,51.4390807,17.4790457,1.8,50.613992,17.0555889,0.020399,18.0170445,31.6616241,1428.8944668,57366.4682823,0.0106275,1811.8612024,79.3079279,1669.2678072,19.6260235,26.1352402,0.7498801,99.3698728),(18537,'okapi-metacarpal.tif',236,5,190,144.1686541,52.4654279,17.6013155,1.8,52.9174036,17.3901543,0.0272932,31.9908595,33.2161248,1553.2207636,53663.5268573,0.0178945,1615.5866221,48.5520173,1369.458964,17.9763955,27.0585303,0.7559949,106.7301541),(18538,'okapi-metacarpal.tif',236,5,191,130.4920419,52.6832092,17.2296997,1.8,52.8058116,17.2366087,0.0526126,10.1895665,33.0181122,1195.6521734,53243.8018364,0.0601466,1612.563476,117.3408287,1641.4510638,17.0262454,28.5203464,0.7528515,148.220008),(18539,'okapi-metacarpal.tif',236,5,192,141.1141726,53.748302,18.1609216,1.8,54.3575948,18.3433601,0.0904044,32.3680265,34.6308029,2196.5993362,59222.600225,0.1916969,1710.1134033,67.8632458,1376.7286676,15.7285588,29.0866835,0.726107,173.0655708),(18540,'okapi-metacarpal.tif',236,5,193,177.9721449,56.0808549,19.2514138,1.8,56.3763872,19.5770507,0.1179106,12.6504011,37.6943781,4145.6922971,69120.1883605,0.4104809,1833.70019,327.7123199,1939.5585468,15.4506753,28.8073477,0.7347503,137.4658819),(18541,'okapi-metacarpal.tif',236,5,194,216.9455966,57.0936935,19.5458143,1.8,57.7559183,20.0474193,0.1237034,12.1830372,39.6797519,5504.4243897,78455.1302803,0.5504859,1977.2081844,451.8105198,2112.4073472,22.8667866,33.2657975,1.8800698,132.6019209),(18542,'okapi-metacarpal.tif',236,5,195,178.3219389,58.8633184,19.3480148,1.8,59.409156,19.9400507,0.1172586,43.7061618,41.7709118,5138.3705658,56373.9950759,0.4067722,1349.5993414,117.5662733,1200.4628527,0.1875,0.265165,2.3561945,0.5303301),(18543,'okapi-metacarpal.tif',236,5,196,139.0334553,62.4999233,20.2260413,1.8,62.7806284,20.6208253,0.1246363,11.2396082,36.2005416,4505.084213,20882.1759176,0.3581021,576.8470573,400.8221747,698.2633662,21.7061482,31.3753113,1.8679772,144.0040178),(18544,'okapi-metacarpal.tif',236,5,197,109.9496058,67.0198803,21.2865583,1.8,66.8078329,21.1711492,-0.3250298,22.2426763,38.0993036,3545.3727581,7624.6258533,1.868706,200.1250713,159.3950617,253.1913962,14.959817,19.9632475,3.0475314,103.8289501),(18545,'okapi-metacarpal.tif',236,5,198,176.3197159,55.2763776,32.3029196,1.8,54.5357525,32.4281076,-0.6108937,37.7053922,31.9505483,10920.8851831,49911.1992397,9.6686887,1562.139052,289.6372256,1439.1727213,10.1342411,25.1697363,1.1404697,78.4342126),(18546,'okapi-metacarpal.tif',236,5,199,616.2833736,56.1002762,42.3582822,1.8,53.0638386,40.2278307,-0.2208918,37.7668513,35.1696517,66942.5370527,103379.0432439,4.9307545,2939.4389249,1772.521,3470.6488293,18.7200329,19.2029661,2.1967211,68.3202516),(18547,'okapi-metacarpal.tif',236,5,200,646.6305362,53.8416315,42.6947727,1.8,49.2697572,41.1081888,0.0096343,30.5727887,37.8194961,70371.8575348,134364.8694929,0.0100034,3552.7937486,2301.7807805,4243.5564449,23.057926,23.7799975,2.5185934,83.6653679),(18548,'okapi-metacarpal.tif',236,5,201,668.7134233,53.0989396,42.2500504,1.8,47.6306674,41.475269,-0.1354393,34.5432513,36.2382011,79790.5916916,150692.7729597,2.0319869,4158.3955214,2309.874976,4878.5683208,25.875,26.4128875,2.4668517,89.7563582),(18549,'okapi-metacarpal.tif',236,5,202,648.8935653,52.0293826,44.361246,1.8,46.2811329,43.5573231,-0.0231024,32.6858363,35.735101,48643.0365847,134579.479515,0.0577112,3766.0304767,1488.1992341,4135.6101192,27.5625,28.1924192,2.6422459,94.5403679),(18550,'okapi-metacarpal.tif',236,5,203,651.4054581,51.291361,44.9938264,1.8,45.4642553,44.5540871,0.0407403,33.5650264,35.2550528,35509.9215581,130390.2759638,0.1800971,3698.4847785,1057.9440981,4024.5673502,28.9615268,57.4083849,2.9973861,187.8004057),(18551,'okapi-metacarpal.tif',236,5,204,658.1732493,51.1956353,45.0925149,1.8,45.2219598,44.7360662,0.051386,15.7269694,35.2655906,32629.8050525,128635.7166261,0.2893986,3647.6268937,2074.7674996,4496.2280536,28.9419277,57.4913037,3.0107653,186.4290854),(18552,'okapi-metacarpal.tif',236,5,205,656.4439453,51.038984,45.0486412,1.8,45.0618407,44.7382666,0.0435117,15.7725248,35.0790574,32518.9891453,127327.4204343,0.2070063,3629.727535,2061.7491271,4460.0993752,28.9912069,57.4821304,3.0403012,186.0085902),(18553,'okapi-metacarpal.tif',236,5,206,657.3886577,50.7697718,45.0431603,1.8,44.7997854,44.7717853,0.0386094,15.721885,34.7878942,32665.0243546,127248.2572289,0.1632448,3657.8315571,2077.6786269,4482.8495163,29.0265891,57.4111406,3.0532982,186.6299106),(18554,'okapi-metacarpal.tif',236,5,207,663.385728,50.4013821,45.1330491,1.8,44.3546082,44.9414758,0.0215213,15.8273583,34.3098075,33474.9737886,131348.7618327,0.0512022,3828.315327,2115.0070105,4615.7822373,28.6875,32.2309173,2.3273959,110.0063582),(18555,'okapi-metacarpal.tif',236,5,208,674.3516335,50.0150069,45.0404145,1.8,44.0494254,44.8767487,0.0171525,15.81653,33.8847668,35267.9111961,136729.8294432,0.0330632,4035.1415206,2229.8134467,4855.1200298,29.311611,58.5159233,3.0581853,234.1606871),(18556,'okapi-metacarpal.tif',236,5,209,689.6993182,49.703765,44.8832798,1.8,43.8431593,44.6525344,0.0274646,16.4013831,33.6844051,38288.4970594,140235.7760512,0.0866856,4163.2255472,2334.467578,5071.9446208,30.5392672,59.0029462,3.0109311,221.3606195),(18557,'okapi-metacarpal.tif',236,5,210,699.9435831,49.3224002,44.7991735,1.8,43.5617821,44.5977958,0.0349637,17.064625,33.428402,40532.1553732,142661.7152829,0.1425513,4267.679778,2375.2151261,5187.4528039,31.2190021,58.8669381,3.0298802,168.867086),(18558,'okapi-metacarpal.tif',236,5,211,706.7774787,49.0952339,44.8262497,1.8,43.4383241,44.7097969,0.0359152,16.258387,33.2199076,41404.8066519,144001.5137967,0.1518808,4334.7957415,2546.6737096,5270.2438391,30.6742411,59.0764864,3.0589786,222.3757845),(18559,'humerus',241,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(18560,'humerus',241,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(18561,'humerus',241,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(18562,'humerus',241,2,4,7.964441,100.8368281,108.3225147,1.8,100.9167973,108.5411155,0.6479168,3.1651491,6.5626911,11.8727842,50.6099138,0.4835005,7.7117623,3.7510979,9.517729,6.4395052,11.532091,2.485897,29.7310859),(18563,'humerus',241,2,5,53.6040401,101.0844055,109.136565,1.8,101.3899039,109.0992708,0.7017271,6.3346931,7.9359356,377.6404884,679.3336305,3.7229698,85.6022105,59.6146466,127.9066138,12.1793646,15.6039676,2.7485346,45.1291464),(18564,'humerus',241,2,6,76.1292695,100.2257766,110.0299772,1.8,100.7078825,109.8992709,0.938603,7.4921832,8.4181152,962.9829858,1402.0254133,8.2577259,166.5486136,128.5316919,257.0194188,15.0035814,17.5710674,2.7945311,54.1990909),(18565,'humerus',241,2,7,97.3314243,99.2471594,111.0689097,1.8,99.7738664,110.7869786,1.1243787,8.552665,9.8406196,1496.5929195,2273.2627512,13.1981919,231.008091,174.9855652,356.8317929,16.9656846,19.8001516,1.677532,60.6978134),(18566,'humerus',241,2,8,107.1270313,98.0310565,111.8897647,1.8,98.4047305,111.775465,1.2131432,8.7292229,10.6060931,1675.2195349,2918.6285379,15.6663678,275.1841344,191.9093557,391.0622871,17.0847199,21.1989262,1.670465,63.8015529),(18567,'humerus',241,2,9,109.8280498,96.6360356,112.5763488,1.8,96.9999277,112.5224897,1.2123658,8.2444432,10.7565337,1751.0940834,3449.2751043,16.052027,320.667903,212.3968877,423.2225461,16.5691189,21.9775463,1.6991196,66.4081086),(18568,'humerus',241,2,10,112.4640494,95.4483477,112.9287349,1.8,95.6430122,112.9260828,1.1996366,8.162758,11.2393547,1867.7030868,3950.4871987,16.2782586,351.487013,228.8078471,465.9909451,16.1876506,22.4256878,1.7282132,67.2318696),(18569,'humerus',241,2,11,116.0539093,94.8222496,113.0179096,1.8,95.3777999,112.9546866,0.7762066,29.5663429,26.3135817,3373.673347,4674.5136502,9.4933833,177.6464227,114.1051958,208.9923243,16.2659773,22.6668901,1.9858711,70.1296689),(18570,'humerus',241,2,12,125.223672,96.5117724,112.80273,1.8,96.934045,112.7559664,-0.0028775,11.6587454,38.1392105,4495.4790911,15802.9227675,0.0001728,414.3484503,385.5885813,532.0718227,16.243125,24.2169829,2.4487131,69.7531221),(18571,'humerus',241,2,13,133.5093498,97.5230861,112.5168025,1.8,98.4505207,112.4723,-0.0200739,12.563337,38.1654374,5128.61674,24612.0329608,0.0089654,644.877529,408.2209006,778.6744465,16.3974989,25.6351142,2.4047001,71.5712506),(18572,'humerus',241,2,14,145.7241019,99.2036599,112.1140438,1.8,100.5159461,112.0202905,-0.0323614,12.9876552,37.1476847,5964.1381744,36105.7470655,0.0254263,971.9514788,459.2159293,1130.3539468,16.6627571,26.8663303,2.3191744,73.0981356),(18573,'humerus',241,2,15,159.5357872,100.818134,111.639446,1.8,102.6771012,111.5408712,-0.041655,13.6838153,35.843199,6943.9067265,47552.7417582,0.0461095,1326.6879921,507.4539927,1509.91083,17.0541215,27.3857546,2.301703,74.2131402),(18574,'humerus',241,2,16,184.4912105,101.1728154,110.3337178,1.8,103.0763603,109.8105357,-0.0002987,22.8017915,35.935191,10679.1512586,63291.4157408,0.0000028,1761.2656013,468.3470278,2038.9028317,17.8223271,28.6409774,2.2953999,77.3168796),(18575,'humerus',241,2,17,225.4429317,101.3361455,108.3888191,1.8,103.4086545,107.8573314,0.0419894,22.9266078,36.3833842,16297.5172971,88443.3246117,0.066208,2430.8713042,710.8560253,2847.605034,18.9111731,46.614788,2.0918133,116.3092146),(18576,'humerus',241,2,18,270.6604323,103.3838694,106.9757677,1.8,105.3383746,106.4950938,0.0189284,23.1518114,34.3937407,22226.2579567,112189.1396886,0.0161603,3261.9057284,960.0224176,3737.0488361,19.9612555,48.3177174,2.080015,117.3888853),(18577,'humerus',241,2,19,306.7715412,104.4343646,105.9750486,1.8,106.3137823,105.5203003,0.0009425,24.0348975,34.0739444,28518.7021544,128099.6203435,0.0000454,3759.459692,1186.5539341,4244.5187655,20.7757318,49.3703713,2.0439978,120.9191411),(18578,'humerus',241,2,20,350.2819585,105.2462981,105.1024339,1.8,106.8659898,104.7412326,-0.0322434,24.4726689,34.2147977,36675.0540781,145040.566275,0.0606733,4239.1180469,1498.6127674,4818.4208249,22.2125131,50.00591,2.0533096,121.5869313),(18579,'humerus',241,2,21,412.68988,105.752864,104.4690045,1.8,107.1756008,104.314562,-0.0788132,25.5610846,34.9988148,46007.3824722,164521.7857989,0.4263544,4700.7816302,1799.8994615,5506.6002461,44.648374,71.9972883,2.5860989,269.1480545),(18580,'humerus',241,2,22,526.9582789,107.2277504,101.3879326,1.8,108.3858067,101.1960226,-0.1969144,26.3912974,34.0158603,77630.0431584,186655.5701316,3.3617037,5487.3099849,2941.5015811,6902.2062778,48.9391686,72.2962272,2.5886634,308.4109349),(18581,'humerus',241,2,23,638.6071202,106.9789283,99.3513243,1.8,108.0429555,99.3709504,-0.2665281,29.4979422,34.4266825,106609.0687306,207616.2239405,7.3834663,6030.6776355,3614.1188461,8421.3852991,52.3170741,72.4814788,2.5845358,307.4165674),(18582,'humerus',241,2,24,713.9130541,106.1233101,98.1389461,1.8,107.5252131,98.0825886,-0.2986099,31.1836308,35.5759768,131995.5643223,224800.3092667,10.2980638,6318.8794734,4232.8478414,9616.0485678,54.9446576,72.412385,2.5953447,261.1577808),(18583,'humerus',241,2,25,744.6822759,106.0424424,97.0925325,1.8,107.7021664,97.1103024,-0.3632116,41.4002111,36.2645219,155318.3046188,241422.6881656,15.6659478,6657.269292,3751.6307364,9416.5227528,57.0912427,72.0736398,2.5752375,257.6275251),(18584,'humerus',241,2,26,742.2848912,106.1321284,96.2328855,1.8,107.7676851,96.354167,-0.4507313,33.9241983,39.2888756,173794.9765941,254485.903284,23.4770078,6477.3017645,5123.0385836,10244.267451,58.7502609,71.4812956,2.5699597,270.2837571),(18585,'humerus',241,2,27,763.0697039,106.0744514,95.3831124,1.8,107.8291551,95.637574,-0.5485689,35.6716798,34.8410797,189113.1913313,269967.78705,34.5832712,7748.5482577,5301.4938545,12381.0421657,60.4118249,71.3774762,0.9923563,261.0078723),(18586,'humerus',241,2,28,772.9472213,105.9679042,94.6042559,1.8,108.0442644,94.9017197,-0.6400535,36.9179975,35.655889,200830.5957918,280473.5783544,45.9508943,7866.122148,5439.9103285,12859.8571645,61.8837111,72.7801272,1.0162933,261.8316333),(18587,'humerus',241,2,29,789.8585404,105.9541089,93.7454118,1.8,108.1905516,94.3059164,-0.7287269,37.5209023,36.8747921,211739.2893924,292815.9318378,58.3771337,7940.8158057,5643.2355341,13057.9065334,62.9365355,73.9125139,0.9920283,245.4392054),(18588,'humerus',241,2,30,799.7827995,106.1741463,92.8998578,1.8,108.3608999,93.7511088,-0.8416965,37.58208,38.3267165,219580.8309204,302836.4322456,74.1371205,7901.4447421,5842.7003258,13517.6029641,64.0551583,74.8298705,0.9489084,243.0385899),(18589,'humerus',241,2,31,807.6006858,106.5008299,92.0701628,1.8,108.6207639,93.2537115,-0.9393201,36.7155388,40.8683971,224189.1120287,313069.9385367,87.692281,7660.4408407,6106.1098238,13027.484588,63.5510627,75.7695636,0.9969498,234.2952226),(18590,'humerus',241,2,32,812.8391269,106.7075277,91.2167473,1.8,108.6058745,92.6519803,-1.0338103,46.20373,42.6801999,224103.380719,323549.0557613,100.0223027,7580.7764832,4850.3309278,11474.7889248,62.0489914,76.4693819,1.0082984,233.8480084),(18591,'humerus',241,2,33,820.5986985,107.1605349,90.2308561,1.8,108.8198782,91.9878279,-1.1185979,37.6281808,49.4307665,222461.1199333,334629.1927791,110.654985,6769.6541378,5912.0880924,10760.6117569,0.351562,0.4971837,2.3561945,0.9943675),(18592,'humerus',241,2,34,825.3619323,107.3840034,89.4576486,1.8,108.848659,91.3727459,-1.1533417,33.3361702,43.5710062,218542.8694913,345741.6072792,114.9484951,7935.1301971,6555.7281528,12931.5639117,60.0266383,77.7150842,0.9915764,229.9412059),(18593,'humerus',241,2,35,824.7642902,107.7548826,88.8125429,1.8,108.880529,90.771081,-1.1859334,32.3259792,43.8113548,213216.1999016,352019.798544,118.0857292,8034.8987246,6595.8156685,12872.8861926,59.0459642,78.1140385,1.0002701,231.2621507),(18594,'humerus',241,2,36,826.5725723,107.9455533,88.0426131,1.8,108.7924425,90.1900235,-1.2012151,31.6994724,43.2370302,207983.8060041,358802.3939479,119.7864191,8298.4976537,6561.1125417,12982.8424868,58.1835543,78.3107807,0.9641159,230.0618429),(18595,'humerus',241,2,37,817.8796649,108.2045437,87.3882864,1.8,108.7274987,89.6157267,-1.2017215,31.2937552,43.5675213,201485.3289354,358396.1856956,118.5731276,8226.2239112,6438.5155278,12642.4278743,56.8452783,78.4960088,0.9927313,230.8003007),(18596,'humerus',241,2,38,812.1404359,108.2647506,86.8559274,1.8,108.6297024,89.0859122,-1.2014951,30.5093455,44.4578051,193562.4765399,360327.5393404,117.7204485,8104.9331737,6344.366734,12411.470716,56.0948692,78.4101489,1.0026916,237.7109037),(18597,'humerus',241,2,39,808.5297894,108.2077003,86.7392067,1.8,108.4170439,88.7210189,-1.1996034,40.5803544,43.9901727,186632.4572764,364094.2955646,117.0250971,8276.7189401,4599.0839695,12313.5877738,54.5227771,77.9818089,0.939017,225.863797),(18598,'humerus',241,2,40,804.8678694,108.1927056,86.53781,1.8,108.2758259,88.4580891,-1.2116309,41.1663006,46.2974372,181533.3271591,360517.7426912,117.5714325,7786.9913512,4409.7556605,11176.7968544,53.6381753,77.568632,0.9463319,255.4742459),(18599,'humerus',241,2,41,802.7831447,108.1370041,86.1433687,1.8,108.2034836,88.2032941,-1.216431,38.352988,46.2024251,175615.9089514,349496.0347051,117.6872474,7564.4521758,4578.9368231,11073.6255668,0.351562,0.7861165,2.0344439,1.6974915),(18600,'humerus',241,2,42,775.7475659,108.4401885,86.1904185,1.8,108.4353377,87.8610769,-1.2224481,30.3546517,47.0625677,159473.1018225,337071.2364149,114.226649,7162.1939192,5253.6627193,10352.2407876,0.703124,2.2234733,1.2490458,5.0924745),(18601,'humerus',241,2,43,754.8191947,108.725187,86.149139,1.8,108.7445372,87.6749253,-1.2223072,27.4541482,43.2977624,144327.3151795,327160.2762364,111.1336232,7556.0550546,5257.0312524,10887.4423486,49.579091,76.048801,1.0533704,278.0327568),(18602,'humerus',241,2,44,732.8266259,108.9888311,86.2452862,1.8,108.9375621,87.4643218,-1.222313,25.3956084,42.1254612,131952.1431308,314505.0933509,107.8960654,7465.9145364,5195.8646172,10570.9925284,0.351562,0.4971837,2.3561945,0.9943675),(18603,'humerus',241,2,45,716.0257939,109.3097577,86.5093027,1.8,109.0600004,87.4635416,-1.2154371,24.0749902,41.7647909,121412.0311253,303923.2525991,104.8914133,7277.0208147,5043.0770663,10166.2669308,0.351562,0.4971837,2.3561945,0.9943675),(18604,'humerus',241,2,46,680.9515418,108.9669554,87.2711532,1.8,108.9228023,87.7989068,-1.2296666,23.2927018,40.6575167,106059.103239,288644.6989653,100.7893399,7099.4178317,4553.3190611,9533.745216,0.4971837,0.9943675,2.3561945,1.988735),(18605,'humerus',241,2,47,635.3513436,108.2071143,88.36199,1.8,108.1467251,88.418103,-1.2507466,35.4154039,40.7701982,90465.3078872,265499.0139512,95.4105167,6512.0854426,2554.4056516,8711.8359494,42.4039044,73.1958501,1.0254345,253.5647518),(18606,'humerus',241,2,48,613.1293734,107.899672,89.4285221,1.8,107.7424073,89.199931,-1.2484775,39.5904779,40.1107921,82246.3818071,249928.0491306,91.9345351,6230.9427452,2077.4283649,7956.7230064,1.2584997,3.003747,0.3587707,7.5783932),(18607,'humerus',241,2,49,586.0211727,107.8360469,90.6534737,1.8,107.6333799,90.1266587,-1.2279401,43.8560255,36.7638604,73064.8426473,231143.8879111,86.6319074,6287.2583476,1666.0160571,6618.6141536,0.351562,0.7861165,2.677945,1.4915512),(18608,'humerus',241,2,50,562.0398719,107.7751345,91.8572538,1.8,107.5200041,91.1802992,-1.1929883,41.5081336,35.2025248,64258.153008,211554.1159758,80.926678,6009.6290555,1548.0858197,6318.3234919,40.080212,70.7836715,1.033784,316.5218457),(18609,'humerus',241,2,51,502.9886635,107.1882919,95.4459412,1.8,106.6493559,94.4068637,-1.0931511,22.7959636,37.081687,54995.7601842,156658.1904261,66.1166687,4224.6780898,2412.5218412,5471.5154216,38.7024654,68.4824367,1.1921965,291.7272634),(18610,'humerus',241,2,52,469.5004082,106.7621305,97.6575633,1.8,106.0197011,97.806874,-0.9573448,19.0264473,29.6763857,46804.4402843,126050.2887053,52.3162351,4247.4946249,2459.967407,5750.9811407,1.6926023,5.7660455,0.9151007,15.44803),(18611,'humerus',241,2,53,455.4672991,106.4517096,98.5324311,1.8,105.8751506,98.6046558,-0.9136447,18.6884327,29.037535,43919.484552,117232.3052907,47.584565,4037.2678119,2350.0892384,5515.1277903,0.7457756,2.2510952,0.6747409,4.4746537),(18612,'humerus',241,2,54,443.1798127,106.2395523,99.2834718,1.8,105.7197515,99.2746568,-0.8805605,18.146705,27.7088517,41118.666864,109341.4798639,43.9182946,3946.0848454,2265.9026449,5404.4796734,33.4305407,55.07867,1.0643178,172.4763424),(18613,'humerus',241,2,55,430.1487662,106.0572371,99.8875593,1.8,105.4693614,99.8623753,-0.8611195,17.5568168,27.0801824,38189.8218408,103699.232692,41.2535785,3829.3402587,2175.2133305,5237.0908127,32.6348314,53.8154041,1.0662359,180.1900084),(18614,'humerus',241,2,56,423.0292338,105.8713309,100.5139256,1.8,105.3940576,100.373066,-0.8410053,37.5780278,26.520068,36068.5679602,99191.7965705,39.1649355,3740.2542389,959.8313172,3567.7591179,32.0353879,52.5887869,1.0533086,167.0219569),(18615,'humerus',241,2,57,412.7329139,105.9033165,100.9160057,1.8,105.3969846,100.7719537,-0.8305461,33.0656941,26.5142585,33660.8422729,94146.8546779,37.4958655,3550.8009711,1017.9989629,3736.5045005,0.351562,0.4971837,2.3561945,0.9943675),(18616,'humerus',241,2,58,406.0327459,105.8203467,101.3514797,1.8,105.3068707,101.1713046,-0.8261196,16.5424777,26.4115982,31599.784547,90415.9354061,36.5887219,3423.3420737,1910.2207746,4582.2458779,30.8112026,50.6468959,1.0232341,156.1338839),(18617,'humerus',241,2,59,401.9309371,105.7070994,101.7955927,1.8,105.1731416,101.6000459,-0.8252274,16.3057983,25.8323888,30263.1409345,86869.358047,36.1595266,3362.8077815,1855.9741967,4522.9524511,0.351562,0.4971837,2.3561945,0.9943675),(18618,'humerus',241,2,60,396.7890505,105.6162596,102.174544,1.8,105.1328939,102.0449014,-0.8170508,16.155284,25.5552447,29154.9037907,83783.1932202,35.1575932,3278.5126637,1804.6667495,4419.0149682,29.8692599,49.1546038,1.0046157,205.9022283),(18619,'humerus',241,2,61,393.4885922,105.5391402,102.503739,1.8,105.0435342,102.5057013,-0.8125115,15.9441183,24.8348111,28128.0920759,82095.6927533,34.5679747,3305.6701122,1764.1672949,4408.876495,2.6202897,23.1203808,0.7961504,60.4358413),(18620,'humerus',241,2,62,390.9417688,105.4348271,102.8127471,1.8,104.9670619,102.9427395,-0.8066096,15.6317565,24.9709468,27381.5885119,80273.884272,33.9601386,3214.6912477,1751.664216,4285.8534849,2.7525605,29.5918321,0.8106029,75.9691745),(18621,'humerus',241,2,63,389.4318771,105.3512061,103.0863765,1.8,104.9652133,103.2267386,-0.8003434,15.4924094,25.4824367,26698.6229986,79019.2523379,33.4225402,3100.929994,1723.3357477,4146.1307979,2.7188084,29.8972426,0.8519663,76.963542),(18622,'humerus',241,2,64,387.327377,105.240932,103.3941586,1.8,104.8478527,103.6910598,-0.7939835,15.3334339,24.1894028,26143.8966062,77376.3328291,32.8314786,3198.7698708,1705.0255513,4272.2123329,1.6410595,4.9966348,0.8850668,15.2420897),(18623,'humerus',241,2,65,384.7483438,105.1927455,103.5767115,1.8,104.8114191,103.7290822,-0.791887,15.3107647,24.5068705,25516.3663736,75502.3616733,32.4784424,3080.8650867,1666.5638068,4088.0788283,3.38008,27.9530481,0.8744477,81.2675893),(18624,'humerus',241,2,66,384.083548,105.1791716,103.7440183,1.8,104.8640029,103.8507733,-0.7914003,15.9473044,24.3786147,25146.3293676,74216.5330063,32.3911733,3044.3293786,1576.8388691,4074.0886108,3.180413,29.1817638,0.9393428,80.1026153),(18625,'humerus',241,2,67,384.3190543,105.106054,103.9737216,1.8,104.7287207,104.1601473,-0.7888213,15.000992,24.674957,24872.6163176,73277.1555433,32.2458481,2969.697399,1658.0647658,3953.7499637,2.5153542,14.1413602,0.962107,41.2516154),(18626,'humerus',241,2,68,384.971453,105.0500832,104.1928186,1.8,104.6711987,104.3541225,-0.7860067,15.2121033,23.7572106,24569.7066248,72835.9030262,32.1200021,3065.8440638,1615.1419827,4033.0470355,2.6372041,20.3845337,1.0067126,52.9281156),(18627,'humerus',241,2,69,387.2517588,105.0392581,104.3763898,1.8,104.5778712,104.6246208,-0.7857142,15.0799699,24.0856783,24418.6514638,72718.3236092,32.2913759,3019.1519923,1619.2772071,3987.6338353,0.4971837,0.9943675,0.7853982,1.988735),(18628,'humerus',241,2,70,388.0362179,105.1079637,104.5016383,1.8,104.7001551,104.7726243,-0.7860336,16.4569439,24.2916208,24285.1769245,72247.5750332,32.3774483,2974.1767958,1475.6796297,3919.9435582,2.1689236,11.1173666,0.9652517,32.3023079),(18629,'humerus',241,2,71,390.2951378,105.1708812,104.6071659,1.8,104.7507935,104.9165865,-0.7898199,14.7498754,24.4967167,24199.3009456,72342.0088942,32.8122241,2953.1308102,1640.6444364,3901.0403465,2.7256045,22.3705064,1.0438531,54.4550006),(18630,'humerus',241,2,72,391.9691498,105.2476785,104.6864106,1.8,104.8074765,105.04072,-0.7943953,14.6486545,24.5223875,24029.0130354,72372.9837898,33.251832,2951.3025084,1640.3563212,3893.2532391,2.5919277,20.5986533,1.0918827,53.1693896),(18631,'humerus',241,2,73,392.558702,105.4184428,104.7054282,1.8,105.0399543,104.9465471,-0.8028069,16.1691068,24.3320417,23760.661028,71682.5140242,33.8519871,2946.0131176,1469.5098108,3867.3796741,2.277567,17.777361,1.1425322,46.0028769),(18632,'humerus',241,2,74,393.4438355,105.5037816,104.789211,1.8,105.0482554,105.0699479,-0.8096948,19.1967928,24.8830871,23582.4532976,71276.1016668,34.3795846,2864.4396621,1228.4579792,3811.7964778,2.9807722,25.6278812,1.1010138,64.8105561),(18633,'humerus',241,2,75,393.3971687,105.6441395,104.8450726,1.8,105.2434457,105.1567151,-0.8204205,14.9323584,24.3563207,23440.7519816,70372.1420842,35.0775026,2889.2763815,1569.7956954,3785.6556623,0.351562,0.7861165,2.677945,1.4915512),(18634,'humerus',241,2,76,393.7906154,105.7631561,104.8906692,1.8,105.3714887,105.2324403,-0.8328478,15.01222,24.5108755,23376.7189925,69285.6695136,35.9254146,2826.7317334,1557.179355,3751.438534,26.8479224,46.5988767,0.7159911,168.0869919),(18635,'humerus',241,2,77,393.2861572,105.9312165,104.890058,1.8,105.5457721,105.2314082,-0.8460813,16.8742712,24.4099584,23325.6516483,68212.4940371,36.7417302,2794.4535127,1382.3205401,3703.2683699,0.351562,0.4971837,2.3561945,0.9943675),(18636,'humerus',241,2,78,392.3182145,106.1233641,104.8863963,1.8,105.7896271,105.2133208,-0.8587893,15.3261461,24.3300662,23197.2406086,67027.451528,37.4747539,2754.9226951,1513.5729782,3668.0284851,1.8984625,15.1212534,1.2637506,37.4654499),(18637,'humerus',241,2,79,389.9319533,106.3697932,104.7965419,1.8,106.0180663,105.1355447,-0.8713715,15.2752709,24.2903809,23184.0010918,65152.2970098,38.0541319,2682.2262415,1517.7472928,3594.6484779,0.7846525,6.3378741,1.2315037,13.700569),(18638,'humerus',241,2,80,387.0815711,106.5995482,104.6981351,1.8,106.3392884,104.9698803,-0.8824757,14.7198386,24.0762364,23142.885572,63204.9261904,38.4803446,2625.1995974,1572.2241386,3561.1517954,0.8532562,2.6774164,1.1659045,5.7955985),(18639,'humerus',241,2,81,385.4618663,106.8534253,104.5945332,1.8,106.5922448,104.8336047,-0.8958474,15.5783869,23.8938133,23017.660385,61027.033551,39.1599149,2554.0935157,1477.5381167,3506.1086551,0.6687107,2.2234733,1.2490458,4.801231),(18640,'humerus',241,2,82,382.0729433,107.0310296,104.5308743,1.8,106.827415,104.7087847,-0.9083283,15.5524346,23.1617977,22908.9882158,58850.8144321,39.5888329,2540.856936,1473.0162055,3524.3699198,2.0154326,11.2554758,1.3182421,27.1951977),(18641,'humerus',241,2,83,377.0281731,107.2643421,104.3469913,1.8,107.0732258,104.5032768,-0.9197822,15.3965805,22.860494,22819.5816598,56456.2313225,39.7621445,2469.598047,1482.1201158,3467.4882811,0.6680513,1.8932193,1.1902899,4.098107),(18642,'humerus',241,2,84,376.3620664,107.4722855,104.2203725,1.8,107.3244066,104.3393896,-0.928844,15.4065148,22.1695813,22850.9488951,54880.6086373,40.2385122,2475.4914342,1483.200394,3506.223422,1.4600007,11.5160035,1.3554386,25.412403),(18643,'humerus',241,2,85,376.1831521,107.6598843,104.0781939,1.8,107.5787743,104.1725411,-0.9379895,15.4601731,21.6195899,23008.1330718,53463.2808772,40.7678252,2472.9091136,1488.219627,3536.5988338,0.6680513,1.5722331,1.1071487,3.394983),(18644,'humerus',241,2,86,375.1252466,107.8610445,103.9542347,1.8,107.7363314,104.067524,-0.9465906,15.4133142,21.4107964,23129.8095394,51987.1294154,41.1646659,2428.0801404,1500.6382935,3475.7202364,0.7590988,3.003747,1.2120257,6.4987225),(18645,'humerus',241,2,87,373.6651678,108.0433126,103.8350258,1.8,107.9466042,103.9507607,-0.9571173,15.7753612,21.6429955,23134.5280192,50646.3959105,41.6240149,2340.0825433,1466.4975196,3383.9993079,0.6949552,3.003747,1.2120257,6.4987225),(18646,'humerus',241,2,88,372.4308199,108.1948748,103.7667849,1.8,108.1047755,103.8670398,-0.969392,15.187108,21.6168224,23138.5857353,49427.2005276,42.2007141,2286.5155479,1523.5676076,3333.3784974,0.351562,1.1117367,1.8925469,2.4006155),(18647,'humerus',241,2,89,369.4101375,108.4367424,103.6258822,1.8,108.3343917,103.6277353,-0.9805298,16.268407,21.0167266,22997.9084398,47583.760682,42.4954628,2264.0900048,1413.6546039,3327.0413208,0.6831551,3.33521,1.2490458,7.2018465),(18648,'humerus',241,2,90,366.0981061,108.6242736,103.5699931,1.8,108.4972609,103.6254529,-0.9841177,16.3935309,20.1026942,22853.5117172,46136.2477876,42.3166186,2295.0280875,1394.0567053,3386.200136,0.8550901,5.2263449,1.2277724,11.2999535),(18649,'humerus',241,2,91,362.9708692,108.7954588,103.4960603,1.8,108.6656866,103.5014063,-0.9874706,16.0029024,20.4678674,22739.6958472,44716.2069257,42.1419049,2184.7027886,1420.9732296,3256.0662387,0.6831551,3.670415,1.2793395,7.9049705),(18650,'humerus',241,2,92,361.252063,108.9561754,103.414898,1.8,108.801762,103.4579515,-0.9933395,16.08725,20.6420502,22806.0280319,43456.4000903,42.2664144,2105.2366245,1417.6461522,3176.8574433,0.8340649,6.482483,1.3521274,13.821206),(18651,'humerus',241,2,93,360.383821,109.127173,103.2912248,1.8,108.981974,103.3112207,-1.0009564,15.9674103,19.9035337,22880.6627582,42451.6861939,42.5819148,2132.8718261,1432.9601595,3271.723065,0.6944674,3.585243,1.3734008,7.613727),(18652,'humerus',241,2,94,359.5286127,109.2844625,103.173921,1.8,109.094341,103.1976745,-1.0069876,15.8289388,19.7008924,22970.3148044,41440.7217083,42.8082736,2103.4946459,1451.1594974,3263.3085182,1.0353084,5.798109,1.3258177,12.7062015),(18653,'humerus',241,2,95,358.3795834,109.4689244,103.0329351,1.8,109.3121773,103.0653499,-1.0152771,15.7413059,19.835141,22993.5862439,40450.8321184,43.11698,2039.3518786,1460.71656,3196.7534486,26.8812027,37.2804938,1.2042995,106.1535371),(18654,'humerus',241,2,96,357.6380832,109.6163072,102.8900415,1.8,109.4355851,102.8641146,-1.0204234,15.3027407,19.431002,23032.4099376,39467.8588613,43.3019638,2031.1798072,1505.1166531,3171.2711401,0.351562,1.1117367,1.8925469,2.4006155),(18655,'humerus',241,2,97,357.3163221,109.8377907,102.6801206,1.8,109.6486451,102.6780855,-1.0258647,16.8503599,19.4539869,22953.5846837,38406.5460594,43.5511003,1974.2249322,1362.2014525,3095.4576532,27.0437898,36.584414,1.2277724,104.7472891),(18656,'humerus',241,2,98,357.5896936,109.9909628,102.522153,1.8,109.7861225,102.5329979,-1.0307067,16.8918966,19.0233523,22951.1381711,37563.9555562,43.8396079,1974.623348,1358.7070006,3110.2606409,0.7650454,4.7817602,1.2722974,10.305586),(18657,'humerus',241,2,99,359.203256,110.1391202,102.3286147,1.8,109.9687312,102.3061932,-1.0382473,16.3732023,18.6356863,23049.9870039,36889.27846,44.4339941,1979.496644,1407.7873459,3132.6409984,27.3320852,35.9711669,1.1902899,104.0441651),(18658,'humerus',241,2,100,361.793675,110.2761153,102.1417169,1.8,110.0885074,102.2000889,-1.0432732,16.3943671,18.7107285,23223.9540063,36382.2918331,45.0188158,1944.4615379,1416.5813085,3096.4801969,0.351562,2.1384682,1.735945,4.5099875),(18659,'humerus',241,2,101,365.120051,110.3779817,101.9467468,1.8,110.1841332,102.0469918,-1.0563852,16.3800454,18.5092437,23414.1790121,35956.756085,46.1216049,1942.6377767,1429.4330992,3119.9990224,27.3634423,35.4729368,1.2271057,102.8438573),(18660,'humerus',241,2,102,368.7830572,110.5056783,101.731581,1.8,110.3597524,101.8057155,-1.0669409,16.3825677,18.3273149,23606.8950728,35581.9671445,47.1365563,1941.471912,1440.9764983,3142.1570159,27.3643348,35.1878264,1.1921452,102.8438573),(18661,'humerus',241,2,103,372.3354638,110.6097447,101.5263791,1.8,110.4472325,101.6578918,-1.0831972,16.3564199,18.9174505,23806.280302,35191.3320257,48.4347623,1860.257649,1455.4701148,3014.8093298,0.725318,4.3485818,1.3258177,9.3112185),(18662,'humerus',241,2,104,375.8107166,110.7081221,101.3335854,1.8,110.5510644,101.4970009,-1.0985657,15.5899662,18.7423762,23932.7691304,34840.8810672,49.6752669,1858.936171,1535.1392591,3063.9562713,27.4463925,34.692597,1.2298174,101.7641866),(18663,'humerus',241,2,105,379.0279913,110.8628962,101.069772,1.8,110.6326916,101.1831063,-1.105306,16.066531,19.0746971,23929.4585255,34252.5939163,50.4438111,1795.7084016,1489.3979646,2987.2195028,27.4779886,34.5354869,1.1846189,101.2670028),(18664,'humerus',241,2,106,381.2976229,110.9765681,100.8546165,1.8,110.7878743,100.9942658,-1.1113127,16.0656754,17.7755874,23913.2726982,33841.3705225,51.0507148,1903.8116625,1488.4698065,3109.0160452,27.4772691,34.2479856,1.2685238,101.3523061),(18665,'humerus',241,2,107,382.5571394,111.075552,100.6431809,1.8,110.894811,100.8133199,-1.1191899,16.3228912,17.9657858,23919.1148688,33389.5554039,51.6162071,1858.5079274,1465.3724383,3083.0594816,0.351562,0.4971837,2.3561945,0.9943675),(18666,'humerus',241,2,108,382.1439922,111.1760812,100.4736174,1.8,110.995287,100.5682025,-1.1275255,16.0798099,17.6619335,23904.2609515,32889.8002908,51.9746295,1862.1857176,1486.6009715,3152.865988,0.703124,2.8990545,1.3258177,6.207479),(18667,'humerus',241,2,109,381.8258265,111.2764745,100.2934281,1.8,111.1646796,100.4222075,-1.1404895,16.2403046,18.2566843,23918.9942919,32484.1145919,52.5638089,1779.299792,1472.8168556,3088.5449982,0.703124,2.8990545,1.3258177,6.207479),(18668,'humerus',241,2,110,381.8476243,111.3634354,100.0911861,1.8,111.2432243,100.2356264,-1.1543503,15.8724448,18.845954,23958.7301937,32083.1418191,53.2276133,1702.3888385,1509.4543103,2889.5391545,0.7650454,3.003747,1.2120257,6.4987225),(18669,'humerus',241,2,111,382.0174001,111.4596988,99.8518952,1.8,111.3504196,99.9472035,-1.1757696,15.2432391,17.2507328,23992.7661966,31753.9788169,54.2403397,1840.7321654,1573.9939531,3162.5472621,0.6902056,3.585243,1.3734008,7.613727),(18670,'humerus',241,2,112,381.4877732,111.5653873,99.6440462,1.8,111.449427,99.7661789,-1.1902284,15.1836083,17.6606789,23952.940043,31385.8246243,54.8087622,1777.1584437,1577.552552,3101.4137303,0.703124,2.2234733,1.2490458,4.801231),(18671,'humerus',241,2,113,381.3831662,111.7139665,99.3809103,1.8,111.5126165,99.4711189,-1.205205,16.4300688,16.9856026,23812.4500999,30822.0729601,55.4399308,1814.5999135,1449.3213846,3074.7018123,0.703124,3.585243,1.3734008,7.613727),(18672,'humerus',241,2,114,380.8744756,111.8044384,99.1795669,1.8,111.6254439,99.2550722,-1.2210395,16.5778012,17.1132615,23743.6887944,30387.6151937,56.0252213,1775.6764357,1432.2580226,2977.2389399,0.703124,3.8831292,1.6614562,8.6080945),(18673,'humerus',241,2,115,380.6672841,111.8932941,98.9432037,1.8,111.736146,99.0334254,-1.2492616,15.8157997,17.2277652,23756.8920862,30021.3554171,57.1083057,1742.6146154,1502.0986944,3079.7634152,0.703124,4.5838077,1.6475682,10.0143425),(18674,'humerus',241,2,116,382.0547785,111.9630844,98.6964479,1.8,111.8412744,98.7929418,-1.2899471,16.0752873,17.1218036,23833.1396634,29892.7598412,58.7839563,1745.8884896,1482.5949401,2990.7954551,0.703124,0.9943675,2.3561945,1.988735),(18675,'humerus',241,2,117,383.1439949,112.0133518,98.458273,1.8,111.8500061,98.5226798,-1.3191196,16.0913302,17.0774358,23867.6145132,29782.5363395,59.8972162,1743.9700364,1483.25926,3133.0186831,0.703124,4.6240762,1.7234457,9.723099),(18676,'humerus',241,2,118,382.5268771,112.0852076,98.2654242,1.8,111.9858651,98.3590767,-1.3524538,15.8789329,16.9717344,23919.8632471,29588.2091975,60.763077,1743.3815855,1506.3898418,3075.4261244,0.703124,4.6240762,1.7234457,9.723099),(18677,'humerus',241,2,119,382.494892,112.1281973,98.0629413,1.8,111.9467925,98.122061,-1.3898897,15.9219135,17.0021242,24054.4725889,29403.669507,61.6854787,1729.411521,1510.7777487,3098.0563694,1.054686,2.4859187,1.7126934,6.4987225),(18678,'humerus',241,2,120,383.0170283,112.15025,97.8469253,1.8,111.9858428,97.9333168,-1.4402279,15.2621409,16.9402717,24183.5739796,29239.5620294,62.7540561,1726.0385488,1584.5466291,3119.0153114,1.5495619,8.9631075,1.7681919,20.4052317),(18679,'humerus',241,2,121,384.4131369,112.235919,97.5534888,1.8,112.0851612,97.6035828,-1.5065976,15.6480527,17.3093852,24186.3203917,28970.6527357,63.8051605,1673.696231,1545.6441048,3049.0185072,0.703124,3.2412415,1.7894653,7.2018465),(18680,'humerus',241,2,122,385.0317903,112.2739849,97.3416898,1.8,112.1075044,97.4149672,-1.566391,15.9503078,17.2617135,24204.3432986,28817.3734488,64.1707197,1669.438749,1517.4843982,3062.1948461,1.8978846,11.4514273,1.8828384,27.5717445),(18681,'humerus',241,2,123,385.0137003,112.2987903,97.1661184,1.8,112.1395142,97.2129265,1.5196157,15.9609681,17.3765823,24249.0412563,28733.8370628,64.0010092,1653.5954246,1519.2713348,3033.8394788,0.351562,0.7861165,2.0344439,1.6974915),(18682,'humerus',241,2,124,385.280143,112.2960263,96.9789782,1.8,112.1446522,97.0358323,1.4578849,15.5300851,16.7630645,24329.5616017,28744.8629815,63.3981752,1714.7737496,1566.6083879,3122.3385774,1.6010486,11.5160035,1.786154,25.1211595),(18683,'humerus',241,2,125,387.2057662,112.2924604,96.7721832,1.8,112.1759908,96.7532186,1.4019379,15.6027495,16.7636842,24474.5946537,28985.8652248,62.711639,1729.0868084,1568.6078079,3167.5554654,0.351562,0.7861165,2.0344439,1.6974915),(18684,'humerus',241,2,126,389.5100795,112.2689687,96.5711566,1.8,112.159154,96.5488972,1.3303866,15.1735063,16.5366613,24644.550972,29222.7892581,61.2380039,1767.1517055,1624.1829989,3207.7100303,0.351562,2.4859187,1.7126934,5.2131115),(18685,'humerus',241,2,127,391.9972773,112.2292672,96.3531951,1.8,112.128879,96.3385168,1.2715865,15.3444925,16.6238537,24763.0047166,29571.3415568,59.6563316,1778.8499604,1613.8040888,3062.9565324,1.0853584,9.1270804,1.843805,19.6168045),(18686,'humerus',241,2,128,394.1193429,112.2148295,96.1698646,1.8,112.1282698,96.1812371,1.2282195,15.8943661,16.8939565,24838.8910902,29896.5550961,58.2745449,1769.6597695,1562.7481452,3231.2019955,0.8550901,6.5677202,1.8417432,14.1124495),(18687,'humerus',241,2,129,395.7115195,112.2680544,95.9300353,1.8,112.1649091,95.9064394,1.1702621,15.8484653,17.3057288,24752.7880694,29987.5478064,55.9252459,1732.8104509,1561.8413303,3119.5827759,0.351562,1.1117367,1.8925469,2.4006155),(18688,'humerus',241,2,130,397.1576657,112.247401,95.7523923,1.8,112.1362673,95.6978572,1.1178028,15.9791051,16.9984202,24718.498861,30255.8526545,53.5139824,1779.9214498,1546.9263629,3164.4395294,0.8853491,7.3408301,1.8622531,15.809941),(18689,'humerus',241,2,131,398.1216384,112.2104448,95.5628087,1.8,112.1179528,95.5069109,1.063809,15.5209112,16.9950489,24647.9166099,30548.1885827,50.7104334,1797.4757654,1588.0457197,3137.7798522,0.725318,4.0084235,1.8370484,8.6080945),(18690,'humerus',241,2,132,399.8242273,112.1670688,95.3772697,1.8,112.0861249,95.3327442,1.011302,16.173976,17.0905482,24617.0318381,31018.2096498,47.8653774,1814.9335738,1522.0148639,3136.8851248,0.351562,0.7861165,2.0344439,1.6974915),(18691,'humerus',241,2,133,402.3668559,112.128324,95.2008242,1.8,112.0238533,95.1614475,0.9682769,15.4375153,17.1990888,24632.941532,31608.4220287,45.5230062,1837.7963113,1595.6545504,3193.4869005,28.3383309,32.0153135,2.1130991,98.3192341),(18692,'humerus',241,2,134,403.8179459,112.081537,95.0442631,1.8,111.9650264,94.9998573,0.931707,16.091752,17.3542847,24634.2394937,32120.2680329,43.3585953,1850.855198,1530.8612477,3190.2619685,0.9924546,4.7817602,1.8692953,10.5968295);
INSERT INTO `slices_w` VALUES (18693,'humerus',241,2,135,407.0903518,112.0380169,94.8846296,1.8,111.9196591,94.8575057,0.8978644,15.4981595,18.070239,24727.4949609,32757.2816022,41.4906698,1812.7752305,1595.5117071,3138.5238272,0.7691226,3.7864386,1.9513027,8.196214),(18694,'humerus',241,2,136,409.5157141,111.9868289,94.7228971,1.8,111.9031015,94.7192576,0.8648573,16.8842392,18.1826684,24759.7073328,33422.2966264,39.5268083,1838.1403549,1466.4390267,3015.1137346,0.351562,0.4971837,2.3561945,0.9943675),(18695,'humerus',241,2,137,411.196243,111.9983452,94.536272,1.8,111.8944911,94.498632,0.8292438,15.1413863,17.9925974,24657.4743723,33882.4294629,37.2673613,1883.131644,1628.4819535,3208.3238911,0.703124,2.2234733,1.8925469,5.0924745),(18696,'humerus',241,2,138,411.9169191,111.9185659,94.3570329,1.8,111.8165516,94.2931096,0.7956217,15.2315974,18.2770348,24573.5034209,34380.3357502,35.0282341,1881.0674745,1613.3241115,3093.570276,0.7590988,3.003747,1.929567,6.4987225),(18697,'humerus',241,2,139,412.9750868,111.8233795,94.2001212,1.8,111.7380912,94.1726114,0.7650879,15.4180985,17.7285355,24515.1376574,34989.6760585,33.0170375,1973.6360095,1590.0234188,3259.5159372,0.351562,0.7861165,2.0344439,1.6974915),(18698,'humerus',241,2,140,413.2561362,111.7418033,94.0496145,1.8,111.6468056,94.090528,0.7313443,15.5090121,18.295774,24510.089626,35810.2707731,30.7222465,1957.2973927,1580.3772288,3244.7552765,0.84871,3.33521,1.8925469,7.49309),(18699,'humerus',241,2,141,415.2128831,111.654917,93.9033755,1.8,111.584676,93.9305314,0.7024914,15.0544365,18.9690792,24544.3869649,36770.375433,28.8899984,1938.4375562,1630.3756693,3161.6284737,27.8422899,34.2606143,2.4652491,100.8404866),(18700,'humerus',241,2,142,417.9375721,111.5657305,93.7740531,1.8,111.5079607,93.8081363,0.6747831,15.0058066,18.923145,24562.7120156,37829.8979224,27.1857949,1999.1337518,1636.880489,3240.5380989,0.8541732,3.670415,1.8622531,8.196214),(18701,'humerus',241,2,143,422.1762353,111.4654137,93.6659355,1.8,111.3989619,93.6600157,0.6527587,15.1212882,19.5415128,24675.7026967,39155.5302044,25.9575582,2003.7102875,1631.8518914,3180.520202,0.6680513,1.8932193,1.9513027,4.098107),(18702,'humerus',241,2,144,425.5875554,111.3914194,93.5797503,1.8,111.320709,93.5590377,0.6344283,15.1268526,18.8224462,24807.3300903,40312.1161202,24.9191208,2141.7044177,1639.9531856,3441.401382,0.8924181,4.1149277,1.9195673,9.1905815),(18703,'humerus',241,2,145,428.062843,111.3930527,93.4578411,1.8,111.2642138,93.4135366,0.6147091,15.1378203,19.9615511,24819.5868633,41228.8329114,23.7294505,2065.4122883,1639.5746793,3290.3996982,0.351562,0.4971837,2.3561945,0.9943675),(18704,'humerus',241,2,146,427.795052,111.3064847,93.3603844,1.8,111.1848856,93.2652665,0.5929127,15.1720144,19.8703877,24805.3372051,42201.9040758,22.2620213,2123.859112,1634.9402572,3334.9846578,0.351562,0.4971837,2.3561945,0.9943675),(18705,'humerus',241,2,147,429.3196254,111.2149823,93.2797576,1.8,111.1250397,93.2491356,0.5721681,15.5562819,19.3414351,24760.0177393,43410.5502881,20.977612,2244.4327407,1591.6411058,3453.1163487,0.9383068,4.1149277,1.9195673,9.1905815),(18706,'humerus',241,2,148,433.1562275,111.0871523,93.1837854,1.8,111.0101785,93.1935606,0.550943,15.173777,19.651523,24834.3168736,44915.3809801,19.7838846,2285.5928769,1636.6602004,3537.5093013,1.1502117,6.0689011,1.7454685,13.700569),(18707,'humerus',241,2,149,437.7690115,110.9807457,93.1168028,1.8,110.898996,93.1853582,0.5322646,16.7185708,20.6433232,24917.3281035,46483.6932938,18.7906492,2251.7543759,1490.3982187,3426.7726339,1.0086012,5.5586833,1.8925469,12.5855645),(18708,'humerus',241,2,150,442.6279385,110.8969759,93.0922119,1.8,110.8125839,93.1665751,0.5171642,15.6926425,19.4660824,25040.288015,48152.1440588,18.0332751,2473.6432895,1595.670581,3714.2164851,1.0233573,5.4577099,1.8313987,12.5855645),(18709,'humerus',241,2,151,442.4434811,110.8237603,93.0712001,1.8,110.7138885,93.163635,0.5020302,15.1245993,20.6988494,25122.7357457,49789.3637974,17.0753291,2405.4169842,1661.0513294,3589.9478911,27.4265577,39.3765134,2.4891632,108.2336376),(18710,'humerus',241,2,152,439.1240714,110.8128582,93.0977156,1.8,110.7283759,93.1590096,0.4891967,15.27043,20.258395,25191.3302005,51222.9625343,16.1613749,2528.4807824,1649.6804791,3743.6753917,0.351562,0.4971837,2.3561945,0.9943675),(18711,'humerus',241,2,153,438.7537333,110.8101958,93.0870868,1.8,110.6916764,93.1511989,0.4755492,15.5075167,20.1598062,25155.8184857,52753.8595568,15.3275213,2616.7840648,1622.1693603,3842.167905,0.703124,1.5722331,1.1071487,3.394983),(18712,'humerus',241,2,154,440.6248994,110.7265257,93.1478289,1.8,110.6342791,93.2104538,0.4611458,16.8216143,21.3604667,25232.5669235,54551.6130928,14.5407931,2553.8586737,1500.0086484,3734.6012227,0.351562,0.4971837,2.3561945,0.9943675),(18713,'humerus',241,2,155,441.6631419,110.6530295,93.2221845,1.8,110.591912,93.356566,0.4446367,16.4600626,21.2873507,25385.4242767,56135.372342,13.6188106,2637.0295264,1542.2434799,3805.7562672,0.351562,0.4971837,2.3561945,0.9943675),(18714,'humerus',241,2,156,439.4849338,110.6143921,93.3506903,1.8,110.4720382,93.4639029,0.4317014,16.6010655,21.4491776,25660.9583078,57822.473077,12.8236246,2695.7897526,1545.7416474,3861.4906206,28.7593072,42.4167967,2.5627852,155.4014885),(18715,'humerus',241,2,157,441.1234026,110.4957795,93.5017407,1.8,110.3767552,93.6198406,0.4165165,16.255662,21.619739,26028.063306,60315.7847822,12.0340479,2789.8479579,1601.1690726,3963.863559,28.2408347,43.1978008,2.5648763,149.14404),(18716,'humerus',241,2,158,444.5138238,110.3808533,93.6905638,1.8,110.1880192,93.829196,0.4014418,16.4551866,22.2725953,26488.3576576,62678.9896939,11.3115718,2814.1754018,1609.7269742,3980.6086599,0.6292498,1.2675748,2.1587989,2.691859),(18717,'humerus',241,2,159,446.1266746,110.3252306,93.9175185,1.8,110.0962048,94.0103009,0.3841645,16.5899814,23.002848,26884.0576605,64801.0785865,10.4440914,2817.0893756,1620.4995629,3985.7390321,30.771971,44.8679066,2.5796711,227.6758631),(18718,'humerus',241,2,160,450.226049,110.226389,94.1447111,1.8,109.9760732,94.1931811,0.3641848,17.0732509,30.3712872,27272.6823065,67440.5706722,9.5200026,2220.5371212,1597.3924651,2911.452586,0.351562,0.4971837,2.3561945,0.9943675),(18719,'humerus',241,2,161,458.4612772,110.1651718,94.3972795,1.8,109.9906812,94.5065956,0.3435279,17.2956411,23.5199982,27773.4810217,70572.283859,8.6681001,3000.5225086,1605.8081214,4143.3502038,0.703124,1.5722331,2.0344439,3.394983),(18720,'humerus',241,2,162,464.1446259,110.1095666,94.710505,1.8,109.9326956,94.7739999,0.3267832,17.6720787,23.7799075,28376.4861915,74230.7229977,7.9708945,3121.5732393,1605.7242976,4192.443482,0.9812984,3.1444661,2.0344439,6.9959062),(18721,'humerus',241,2,163,472.8116906,110.0650622,95.0467832,1.8,109.9017832,95.1230354,0.3139124,17.2467597,24.6382143,29050.0641619,78670.9558472,7.5134854,3193.0461777,1684.3780867,4265.1950692,0.9383068,1.8932193,1.1902899,4.680594),(18722,'humerus',241,2,164,481.3534365,109.8866771,95.3451439,1.8,109.7346799,95.40661,0.2924472,17.4910477,25.0284957,29763.2657211,83579.0830914,6.6679341,3339.3570255,1701.6285268,4291.6852407,0.8898936,3.003747,1.929567,6.789966),(18723,'humerus',241,2,165,496.2895818,109.7007511,95.7617124,1.8,109.6564618,95.9047584,0.2820557,18.2142619,25.7868549,31059.2402405,90168.5304008,6.4077609,3496.6858368,1705.2154158,4450.0411979,0.703124,0.9943675,0.7853982,1.988735),(18724,'humerus',241,2,166,526.0276023,109.8131813,96.6244318,1.8,109.7631343,96.7271587,0.3128111,19.0040992,25.6617522,34326.3995201,102331.6219482,8.3025147,3987.7098482,1806.2629087,4862.7497935,0.703124,1.2675748,2.1587989,2.691859),(18725,'humerus',241,2,167,572.31563,110.0706088,97.7700139,1.8,109.9108401,97.7143007,0.3575602,20.1004549,28.516274,39406.5592066,118193.2306166,11.6840971,4144.7641615,1960.4809651,5526.6219419,36.1420202,53.999969,2.4993936,345.6351108),(18726,'humerus',241,2,168,619.3068807,110.2284382,98.8273075,1.8,110.1780103,98.7006236,0.3846479,21.829355,29.3717975,45129.9210355,132886.9602545,14.5330302,4524.3046525,2067.3959938,6060.7807404,37.0739879,55.6246191,2.4816581,357.3822786),(18727,'humerus',241,2,169,642.4087035,110.259029,99.7261924,1.8,110.5049041,99.7245749,0.3958342,22.600271,30.3877442,51060.8946216,144349.2067473,15.9178607,4750.2442349,2259.3045306,6362.8900082,38.9064137,56.8139855,2.5055172,359.3503155),(18728,'humerus',241,2,170,640.5632303,110.2610845,100.4365097,1.8,110.7291553,100.5040933,0.3860649,23.3057392,31.4324219,55803.1549945,150037.7900546,15.1372306,4773.3448704,2394.3954133,6546.8125272,39.9475659,57.8722737,2.5114565,351.7365885),(18729,'humerus',241,2,171,639.1445374,110.2023435,101.0765376,1.8,110.7756592,101.3400371,0.3660448,23.4588856,30.3570669,60632.8417077,155169.4440251,13.6468392,5111.4768352,2584.6428852,7079.0506966,41.2796395,58.6476651,2.5136778,358.8384961),(18730,'humerus',241,2,172,640.2144279,110.05048,101.5728587,1.8,110.8416894,102.0992703,0.3376066,24.5055449,31.2073682,65440.7448846,161341.639167,11.7066579,5169.9854426,2670.446425,7245.2735208,41.323847,59.2181118,2.520653,380.1881258),(18731,'humerus',241,2,173,643.710692,109.8457038,102.0825855,1.8,110.5465271,103.0600635,0.2996509,24.4746763,31.7256918,70720.3958854,166977.2601996,9.348305,5263.1558368,2889.5334477,7475.7838033,43.5002067,60.3674029,2.5342064,397.9014985),(18732,'humerus',241,2,174,702.1038087,108.9253949,103.4572651,1.8,109.3488941,104.4867872,0.213698,26.8288048,31.7919688,85702.0548483,175997.3325752,5.2629592,5535.9054171,3194.4045078,7342.8855644,46.224356,61.1455162,2.536048,344.3848336),(18733,'humerus',241,2,175,745.0041495,108.3079646,104.4927478,1.8,108.8326232,105.1905484,0.1246301,33.0292824,42.4304602,96888.4047226,186722.9381425,1.9186833,4400.6814242,2933.4093205,5274.4686072,46.7385063,61.7249168,2.542532,344.7114109),(18734,'humerus',241,2,176,742.5650043,108.3294795,105.1332303,1.8,108.7430245,105.6591217,0.08666,44.8442835,41.8774488,102891.7351247,190410.3488531,0.9271137,4546.8469196,2294.4225436,5142.2494923,47.4688023,62.3257062,2.5285562,275.8027478),(18735,'humerus',241,2,177,740.3321893,108.6358208,105.6149703,1.8,108.8835977,106.2143772,0.0621091,43.1318161,34.3316782,108277.6396148,190536.2564136,0.4753654,5549.8672485,2510.3890664,6533.9057638,49.375386,62.9020955,2.5349875,394.3858785),(18736,'humerus',241,2,178,755.7452646,108.3452624,106.1858255,1.8,108.6297746,106.6314386,0.029831,27.6944501,35.8396416,113567.2663921,199753.5504899,0.112054,5573.5365025,4100.7229255,8025.132123,50.3108511,63.1912525,2.5381592,410.025213),(18737,'humerus',241,2,179,781.6269077,108.0590219,106.7314392,1.8,108.3876716,107.0079415,0.011497,28.4590897,33.5482641,117462.4111786,208765.6781771,0.0172179,6222.8459104,4127.4127993,9511.8038458,0.703124,1.2675748,2.5535901,2.691859),(18738,'humerus',241,2,180,801.1472226,108.0939511,106.9781531,1.8,108.308824,107.1541928,0.0062108,28.3031214,31.8072087,120193.6736565,211699.2556647,0.0051515,6655.7005166,4246.6578875,9949.7496998,3.2180358,11.1672827,2.0626055,30.2282697),(18739,'humerus',241,2,181,805.8923665,108.0679774,107.2633734,1.8,108.3382541,107.3200152,0.015536,31.0395321,31.4297046,121883.1010731,211964.8830308,0.0324165,6744.0940307,3926.7054868,10097.5841032,48.9615731,63.9697949,2.5398714,380.0528531),(18740,'humerus',241,2,182,808.4287779,108.3146641,107.4392051,1.8,108.3637728,107.3449935,0.0214721,43.0927023,31.8676689,122459.3601397,210726.3330157,0.0621112,6612.5430689,2841.7656246,7729.9217242,48.8167261,63.8769869,2.5719086,306.0724135),(18741,'humerus',241,2,183,808.1655188,108.4307317,107.5682888,1.8,108.3668386,107.361495,0.0399938,48.5030063,32.537385,122805.9420309,206878.4263308,0.2153276,6358.176176,2531.924338,6343.2264316,48.4757097,63.7956692,2.5245462,292.1512686),(18742,'humerus',241,2,184,812.3041816,108.54397,107.70088,1.8,108.2631132,107.3427733,0.065043,47.3827323,37.766262,121723.9420417,203701.2463687,0.5719464,5393.7359784,2568.9515148,5892.7456327,48.163994,63.5928917,2.5290551,361.2805076),(18743,'humerus',241,2,185,813.3303642,108.6337245,107.6795728,1.8,108.2037636,107.1729387,0.0766991,48.3946652,34.1960019,119264.5262434,198261.9993005,0.7958735,5797.8122625,2464.4147392,5913.5634951,50.273366,63.5005061,2.5812328,368.7589619),(18744,'humerus',241,2,186,809.1605776,108.7735413,107.6560206,1.8,108.2556036,107.2054589,0.066693,33.1114742,31.4830358,115333.6077349,191824.9615041,0.5989628,6092.9626651,3483.1915726,8283.582379,49.921804,63.2029868,2.5782764,347.7505452),(18745,'humerus',241,2,187,803.7782035,108.7010837,107.6014135,1.8,108.1348986,107.1314983,0.0460036,28.1523021,30.9831419,110136.0806206,186432.7484679,0.2833096,6017.2318559,3912.1518439,8714.0819748,5.4021803,15.4567383,1.8709675,57.1821934),(18746,'humerus',241,2,188,791.0182814,108.5046706,107.5733682,1.8,108.1296185,107.0300043,0.0200718,27.5906787,30.2271962,103236.0505171,179827.9474302,0.0531063,5949.2103159,3741.7002872,8765.7401261,4.439133,15.35646,1.849096,50.8041079),(18747,'humerus',241,2,189,789.5624347,107.9534307,107.3470622,1.8,107.7290427,106.8838227,-0.0063359,27.8513204,29.1643257,97784.9720872,178002.9998361,0.0052832,6103.4498634,3510.9635978,8727.1939408,4.4007403,15.1212534,1.8778421,48.3681586),(18748,'humerus',241,2,190,765.8657789,107.4611185,107.1669673,1.8,107.3744613,106.6441757,-0.0620563,25.8573741,28.7271025,88655.2836379,171870.2705765,0.4909238,5982.8613241,3428.6267147,8531.3207022,3.5841241,13.5704754,1.8597717,37.5154194),(18749,'humerus',241,2,191,709.8918073,107.2763648,107.1101867,1.8,107.03084,106.6485324,-0.1631619,24.5926751,27.3627332,73900.7425066,158710.8209397,3.1219136,5800.2546587,3004.9899956,7739.7245833,3.1362738,11.6864624,1.8449638,36.8122954),(18750,'humerus',241,2,192,623.4871916,106.8712948,106.7935958,1.8,106.608794,106.6518744,-0.260116,43.8315577,26.5168333,57412.5676681,144520.4161609,6.8737457,5450.1385773,1309.8454786,4606.8390394,0.351562,0.4971837,2.3561945,0.9943675),(18751,'humerus',241,2,193,461.6217352,103.7856601,105.9532484,1.8,104.4524306,106.2539739,-0.410475,35.9696992,27.6716153,37584.2615418,112878.7272741,12.2512002,4079.2243686,1044.886736,4096.5090264,25.7044094,34.6623017,2.4351666,107.8156948),(18752,'humerus',241,2,194,321.807462,99.8952599,104.967365,1.8,99.7224547,105.8080723,-0.587871,19.9851497,30.977629,16170.1868731,85110.4158358,16.4964312,2747.4799946,809.1101193,3221.4570108,23.5870508,31.464308,2.4511462,125.2877935),(18753,'humerus',241,2,195,225.0024811,98.4383229,104.6176461,1.8,97.4605343,105.5648719,-0.5776511,13.9193832,31.298501,8181.9111759,65513.0090816,11.1818342,2093.167629,587.8070213,2351.2616524,20.7556062,28.6754795,2.4342962,97.9926568),(18754,'humerus',241,2,196,122.0781953,95.1727229,104.3443585,1.8,95.7071908,104.2673322,-0.5270963,13.6519546,33.0474645,2757.9221424,37896.0777797,5.1483429,1146.7166499,202.0166502,1223.4656923,11.7556618,20.3450846,1.8870825,59.9093861),(18755,'humerus',241,2,197,54.6749044,85.5809619,108.4415715,1.8,87.8798048,107.325427,-0.5846481,8.470071,41.5980219,865.5075916,2137.7260054,2.7756641,51.390088,102.1842187,72.1964615,9.551335,17.14383,2.0619599,48.4388262),(18756,'humerus',241,2,198,21.8479992,83.3904262,108.1955439,1.8,83.7814247,108.4055427,1.2866209,3.9314168,6.4892458,42.9107203,131.9266516,3.3551058,20.3300438,10.9148236,26.8300093,6.8174555,11.7023156,2.1421338,31.0873645),(18757,'humerus',241,2,199,0.3093641,82.5106225,108.1697113,1.8,82.5150036,108.1790296,1.3405731,0.6865755,1.5821061,0.0403923,0.211097,0.0488758,0.1334278,0.0588316,0.1586445,1.6770845,3.4624841,1.9890207,7.9902737),(18758,'humerus',241,2,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(18759,'humerus',241,2,201,0.628541,151.969619,133.8097511,1.8,151.6830229,133.769341,-0.0711704,0.4980605,2.9095972,0.0275207,0.7623403,0.0005297,0.2620089,0.0552557,0.2713851,11.2777108,162.4353406,3.1286064,342.3178978),(18760,'humerus',241,2,202,0.5962188,152.0180678,133.8133221,1.8,151.8078198,133.7609705,-0.067848,0.5082202,2.6071615,0.025679,0.6440988,0.0004567,0.2470498,0.0505274,0.2568609,11.8214591,162.7918081,3.126475,343.6035088),(18761,'humerus',241,2,203,0.5850952,152.0370849,133.8163525,1.8,151.8078198,133.7609705,-0.0677476,0.5126262,2.6259344,0.0247626,0.631206,0.0004469,0.2403739,0.0483054,0.2497602,11.8337303,162.7918081,3.126475,343.9800555),(18762,'humerus',241,2,204,0.5676794,152.0669289,133.818131,1.8,151.8078198,133.7609705,-0.064721,0.5191412,2.6557374,0.0240357,0.5822332,0.0003958,0.219236,0.0462989,0.2282539,11.9196287,162.7918081,3.126475,344.5625425),(18763,'humerus',241,2,205,7.4726419,122.1649731,112.733151,1.8,121.1543136,112.0288225,0.6146394,4.2679771,37.6534219,25.1028897,853.3589219,0.4141604,22.6635158,5.8816833,23.3271002,8.437488,8.8730237,0.9827937,27.8629879),(18764,'humerus',241,2,206,31.6578384,120.2765219,111.4641682,1.8,120.2300054,111.4490727,0.611847,7.0364594,39.9297322,324.1565807,1178.0172017,1.740721,29.5022565,46.0681376,37.6168054,14.06248,14.5335918,1.0096329,46.2441509),(18765,'humerus',241,2,207,55.8353944,120.0185878,111.3005005,1.8,120.0039853,111.3204742,0.6121753,8.89555,40.2346927,973.7900704,1770.2305822,3.073009,43.9976166,109.4693495,68.1932322,17.5781,18.2846041,0.9080668,58.5384719),(18766,'humerus',241,2,208,80.7389449,119.8973909,111.2536251,1.8,119.9259274,111.2800624,0.6156787,10.2588455,40.3584213,1897.0461108,2652.1697424,4.4880222,65.7153986,184.9180902,112.700666,20.390596,21.0732022,1.0847644,67.6437501),(18767,'humerus',241,2,209,104.2018548,119.9086911,111.1809683,1.8,119.9591901,111.1642269,0.6195301,11.3764268,40.3882041,3045.256561,3810.6288615,5.8554067,94.3500446,267.6812867,169.7126212,22.499968,23.1551021,1.0460006,74.4337161),(18768,'humerus',241,2,210,123.1778612,119.8715162,111.1748327,1.8,119.9450279,111.1805033,0.6155604,12.1696229,40.4251316,4209.4529954,4935.6150311,6.8447772,122.0927387,345.8983915,226.1883978,24.257778,24.7820041,1.018212,80.1440114),(18769,'humerus',241,2,211,327.5830956,105.3804663,112.0578816,1.8,104.5606117,111.8689941,-0.0585407,24.6522771,46.5585182,14545.826086,63419.6030538,0.1868917,1362.1482283,590.0398574,1480.4262457,27.6442483,28.9307972,1.1180179,93.3120628),(18770,'humerus',241,2,212,602.0059351,98.4747805,112.0913784,1.8,104.225672,111.8954968,-0.0415762,24.1128371,53.8651686,29918.2739045,123335.2467276,0.1733354,2289.7031603,1240.7612495,2597.4011554,28.828084,29.4011786,2.2885015,95.6273751),(18771,'humerus',241,2,213,622.54247,98.7086449,112.0627284,1.8,104.5872727,111.8754846,-0.0420458,24.1569159,53.6191428,31334.9142789,130724.0556547,0.1833184,2438.0109208,1297.1405128,2756.2864682,29.0852493,29.4851342,2.457541,95.9186186),(18772,'humerus',241,2,214,631.0114067,99.004086,112.0437633,1.8,104.9305547,111.8335666,-0.0426445,24.1953607,53.3088982,32085.3539125,134784.1177361,0.1911391,2528.3605992,1326.0952909,2851.0510391,29.0306698,57.3434157,0.1167506,185.8356984),(18773,'humerus',241,2,215,636.738838,99.2001462,112.0393071,1.8,105.1325612,111.8320798,-0.042999,24.2102759,53.1043717,32531.6771819,137082.7178544,0.1960916,2581.3829162,1343.7136095,2906.8941507,29.0306698,57.5467369,0.0917661,181.3257109),(18774,'humerus',241,2,216,637.82356,99.2543594,112.0668171,1.8,105.2507955,111.8383938,-0.0399061,24.0163057,53.1248404,32531.6291369,137126.6987052,0.1691982,2581.2162008,1354.5642495,2910.6688114,0.351562,0.4971837,2.3561945,0.9943675),(18775,'beisa_radius.tif',241,3,1,1.6289188,105.8075378,129.6853449,1.8,103.5679858,129.6494961,-0.0013179,0.3007602,34.4404637,0.0366661,479.3403608,0.0000005,13.9179415,0.1219114,13.919006,11.0212696,165.9406443,0.0063558,357.7099576),(18776,'beisa_radius.tif',241,3,2,2.9770128,97.048188,129.6592733,1.8,96.3528625,129.609213,-0.0003841,0.2944345,28.8451719,0.0872973,1235.3350386,0.00000007223,42.8264058,0.2964915,42.8293514,11.3728183,166.2948006,3.1331362,360.0752397),(18777,'beisa_radius.tif',241,3,3,4.3878411,92.0751915,129.6208972,1.8,92.6605092,129.577338,0.0007217,0.5839441,27.8075401,0.162154,1908.0073562,0.0000004,68.614748,0.2776876,68.6202555,11.6846987,166.2981451,3.1310222,360.9489704),(18778,'beisa_radius.tif',241,3,4,5.6393056,88.7178321,129.5581342,1.8,88.8175641,129.5114325,0.0026653,0.4979817,30.8136076,0.3101538,2441.6822866,0.0000067,79.2403902,0.6228217,79.250146,12.0933892,166.6585872,3.1268258,362.0286413),(18779,'beisa_radius.tif',241,3,5,6.5024543,86.6027286,129.4995936,1.8,86.4263171,129.4540363,0.0042232,0.7679832,32.9290362,0.4608019,2815.8459855,0.0000193,85.5125541,0.6000156,85.5262442,12.3728749,167.0156613,3.1247521,363.1083122),(18780,'beisa_radius.tif',241,3,6,7.0879991,84.7075567,129.4297584,1.8,83.742793,129.4067985,0.0063667,0.6820476,34.1216169,0.6364652,3041.35669,0.0000479,89.1328421,0.9331683,89.1512536,12.3912805,167.0289812,3.1205431,362.7317654),(18781,'beisa_radius.tif',241,3,7,7.3157152,82.8625652,129.369068,1.8,82.7669889,129.3587771,0.0081018,0.6184395,35.6155754,0.757645,3099.3102478,0.00008,87.0212039,1.2250916,87.0423144,12.8003457,167.3967098,3.1163879,364.5145605),(18782,'beisa_radius.tif',241,3,8,7.5787497,80.8715103,129.3011613,1.8,80.2935043,129.2701872,0.0098647,0.8768003,37.2557243,0.9851751,3139.2796009,0.0001229,84.2630136,1.1236026,84.289356,13.1425844,167.767316,3.112251,365.3029878),(18783,'beisa_radius.tif',241,3,9,7.8041436,79.0654554,129.2229126,1.8,79.16059,129.2118413,0.0115837,0.8094543,38.7110701,1.2303756,3198.5714525,0.0001745,82.6267898,1.5200063,82.6584897,13.1705384,167.777998,3.1101565,365.8001717),(18784,'beisa_radius.tif',241,3,10,7.7657915,76.6859881,129.1663335,1.8,77.3295281,129.1488341,0.0127448,1.0805749,40.7395695,1.4119408,2983.6912994,0.0002102,73.2381646,1.3066569,73.2727855,13.1950771,168.152909,3.1060428,366.006112),(18785,'beisa_radius.tif',241,3,11,7.5584875,74.2617597,129.0865539,1.8,75.5136472,129.0672215,0.0146403,1.0239993,42.4616617,1.511766,2616.0157918,0.00027,61.6088888,1.476335,61.6444862,13.4627488,168.1657714,3.1039535,366.006112),(18786,'beisa_radius.tif',241,3,12,7.1798721,72.1728272,128.9962464,1.8,73.7648488,128.9989747,0.0174441,1.001657,44.2002272,1.4258674,2150.4757362,0.0003641,48.6530472,1.4235087,48.6852856,13.7159419,168.5306529,3.1019475,366.7945393),(18787,'beisa_radius.tif',241,3,13,6.6449641,70.1054637,128.8933853,1.8,71.2855504,128.91817,0.0211902,1.1189588,45.5658766,1.286751,1614.2423629,0.0004972,35.4265622,1.1499539,35.4546517,13.683434,168.5449531,3.0998632,366.7945393),(18788,'beisa_radius.tif',241,3,14,6.1066104,68.0002953,128.7901313,1.8,70.1576484,128.8513165,0.025171,0.8954768,46.6177364,1.1584653,1068.749022,0.0006447,22.9258026,1.2936855,22.9503561,14.0190057,168.9269419,3.0957914,368.3713941),(18789,'beisa_radius.tif',241,3,15,5.6175827,66.1231422,128.7063667,1.8,69.2151123,128.7825095,0.0312691,0.9779724,47.7914976,1.0908011,612.2160181,0.0009151,12.8101451,1.1153701,12.8323372,14.1263501,168.9269419,3.0957914,367.788907),(18790,'beisa_radius.tif',241,3,16,5.1895289,63.8621998,128.623892,1.8,64.0345182,128.6238826,0.0794262,2.6484381,47.1699854,0.8364588,110.8304485,0.0054449,2.3495968,0.315831,2.3636071,14.4775776,168.9434033,3.0937126,367.788907),(18791,'beisa_radius.tif',241,3,17,5.1707648,64.6359068,126.9245812,1.8,64.9096971,126.3672816,-0.8964397,7.0072348,50.1146843,61.7670486,533.5407611,0.5258073,10.6463957,8.8147537,11.8624922,14.8134701,168.9605946,3.0916343,367.788907),(18792,'beisa_radius.tif',241,3,18,6.5545893,71.3557825,116.6116471,1.8,68.8602211,119.942588,-0.959245,6.9632585,38.0813258,57.8674984,3518.8740474,0.7323281,92.4041896,8.310405,93.8756025,0,0,0,0),(18793,'beisa_radius.tif',241,3,19,8.0417848,75.708146,109.5388755,1.8,71.0516426,116.1047957,-0.9685496,6.6999934,29.3759924,52.9917906,5171.1462348,0.9101733,176.0330738,7.9092303,177.6310557,0,0,0,0),(18794,'beisa_radius.tif',241,3,20,9.3595791,78.1498038,105.2958871,1.8,73.0370181,113.0002972,-0.9733031,41.6509758,31.1577473,61.6140973,5914.8470063,1.0662324,189.8355148,1.4792954,139.6390176,0,0,0,0),(18795,'beisa_radius.tif',241,3,21,10.8887972,80.1660607,101.8331088,1.8,74.1358682,110.6231127,-0.9723425,6.1206472,35.2516731,44.6801553,6373.5725243,1.2388168,180.8019867,7.2999071,180.8744868,0,0,0,0),(18796,'beisa_radius.tif',241,3,22,13.0541971,82.0920358,98.7017177,1.8,76.5613486,106.6436589,-0.968464,5.8430726,38.9386594,45.3483851,6662.0586961,1.4773067,171.091116,7.7610511,171.4687378,0,0,0,0),(18797,'beisa_radius.tif',241,3,23,15.7355536,83.7291893,96.1580475,1.8,78.5832979,103.3818361,-0.9622891,5.2960522,42.1849029,50.4727509,6658.384369,1.765592,157.8380868,9.5302593,158.4354214,0,0,0,0),(18798,'beisa_radius.tif',241,3,24,19.3120813,85.1317575,94.1871606,1.8,80.7990061,100.2567106,-0.9552605,5.5556008,44.6286667,63.608521,6472.8030312,2.1456164,145.03689,11.4494405,146.0432587,0,0,0,0),(18799,'beisa_radius.tif',241,3,25,23.272805,86.1717031,92.8953458,1.8,82.7651104,97.4916545,-0.9473971,9.9739613,46.3098274,88.4547127,6111.6439944,2.5568259,131.9729383,8.8685639,133.5798289,0,0,0,0),(18800,'beisa_radius.tif',241,3,26,27.7906465,86.8861269,92.0016267,1.8,83.9679614,95.7619897,-0.9393348,6.3428585,47.5528456,120.2955651,5622.0333261,3.0176765,118.227064,18.9655128,120.6150343,19.8496637,43.6078691,1.8568478,144.3928034),(18801,'beisa_radius.tif',241,3,27,33.2875172,87.4817142,91.3851351,1.8,85.2335314,94.0852303,-0.9306768,7.6027054,48.6311948,173.2704345,5004.662745,3.5686611,102.9105446,22.7906285,106.356078,18.0121069,44.431937,1.8349665,110.1017546),(18802,'beisa_radius.tif',241,3,28,39.8175746,87.9090564,91.0854724,1.8,86.2185731,92.8739851,-0.922635,8.3298821,49.2129073,253.9990828,4333.2814169,4.2174784,88.0517258,30.4925182,93.1660473,0.7457758,3.241242,2.2794226,6.6693301),(18803,'beisa_radius.tif',241,3,29,46.8950119,88.2298161,91.0699716,1.8,86.9040669,92.346728,-0.9183872,8.8542332,49.6395832,361.9895572,3672.1585388,4.9351257,73.9764176,40.883219,81.2106993,2.2593254,19.0558312,2.0922308,51.6778473),(18804,'beisa_radius.tif',241,3,30,54.6567958,88.4982922,91.2160608,1.8,87.6320136,91.8902386,-0.9202286,9.157348,49.9621439,513.0117778,2980.0316619,5.768135,59.6457924,56.021872,69.8545524,2.1270652,18.7155211,2.0596487,50.9747232),(18805,'beisa_radius.tif',241,3,31,63.1718405,88.7052976,91.4429537,1.8,88.0783189,91.764331,-0.9553327,9.2691584,49.7933781,704.7377835,2174.9001526,7.019253,43.6785018,76.0303961,57.6356945,0.8794879,1.9887353,2.3561945,3.9774707),(18806,'beisa_radius.tif',241,3,32,72.7828062,88.888358,91.8033219,1.8,88.4532288,91.8180779,-1.1665702,15.0458897,47.565408,936.9336395,1519.6441286,10.2539973,31.9485146,62.2717338,49.3232865,1.8869649,17.2945666,2.0344439,40.1219821),(18807,'beisa_radius.tif',241,3,33,83.4350109,89.0809699,92.2913821,1.8,88.8207519,92.0853847,1.2486767,42.6600436,25.6725089,956.0150816,1496.9742731,12.512171,58.3104005,22.4100821,49.4943035,2.4501099,19.9679823,2.0265701,58.9649983),(18808,'beisa_radius.tif',241,3,34,94.1830587,89.1840124,92.8973565,1.8,89.0369245,92.5845053,1.0636371,46.3690063,16.7095947,795.6082882,1918.2909878,11.9942028,114.8017661,17.1581915,55.1906687,0.3515621,0.4971838,2.3561945,0.9943677),(18809,'beisa_radius.tif',241,3,35,105.1906578,89.2626856,93.6265758,1.8,89.0561624,93.1490475,1.0612743,9.2092654,11.6696987,852.6088117,2515.6707772,13.3607935,215.5728992,92.5816306,260.8979387,0.3515621,0.4971838,2.3561945,0.9943677),(18810,'beisa_radius.tif',241,3,36,117.1827543,89.3569833,94.3741736,1.8,89.2152649,93.8528878,1.0997496,8.6814223,11.9980739,1030.3327045,3280.4702414,15.508123,273.4164052,118.6824774,327.6519691,2.7566049,22.666894,1.9858711,60.080003),(18811,'beisa_radius.tif',241,3,37,129.5359754,89.4370555,95.1310982,1.8,89.2182172,94.5360673,1.1313115,9.5969514,12.9895442,1237.9516438,4195.965065,17.6810661,323.0263523,128.9942599,374.3440208,0.3515621,0.4971838,2.3561945,0.9943677),(18812,'beisa_radius.tif',241,3,38,141.9595339,89.5331269,95.9329542,1.8,89.3772139,95.2689034,1.1620377,9.8077933,13.1391342,1469.3539612,5293.0995225,19.9220602,402.8499465,149.8149397,461.5241448,2.5572045,24.6118553,1.9513027,71.9624455),(18813,'beisa_radius.tif',241,3,39,154.3191596,89.6455215,96.7585909,1.8,89.389128,95.9776559,1.1846954,9.0111089,14.2115012,1722.6049635,6548.9054792,22.0724777,460.8172891,191.164592,525.8351195,17.1135443,52.8805904,1.8399638,237.2283965),(18814,'beisa_radius.tif',241,3,40,167.1258653,89.7725819,97.642786,1.8,89.5363158,96.8158023,1.2092363,10.3190749,14.9137232,2008.4661531,7891.2365341,24.3689681,529.1258541,194.63626,602.5029874,0.3515621,0.7861167,2.0344439,1.6974918),(18815,'beisa_radius.tif',241,3,41,182.496474,89.9365051,98.4506676,1.8,89.6784806,97.4648419,1.2340729,10.4175507,15.5545363,2425.1045007,9432.1516121,27.0958078,606.3923372,232.7902761,670.086842,18.127315,53.0392862,1.8736812,321.5765307),(18816,'beisa_radius.tif',241,3,42,199.5458518,90.1141574,99.3367034,1.8,89.8648512,98.3350699,1.2442738,10.851719,16.376972,2902.6150388,11246.9645787,29.8360511,686.7548277,267.4797456,791.0260424,18.5091532,53.3633688,1.8925469,270.972292),(18817,'beisa_radius.tif',241,3,43,222.8403048,90.3434095,100.2551406,1.8,90.0402071,99.0427878,1.2324699,10.492363,17.5199031,3563.8138289,13305.8584512,33.0485736,759.4710077,339.6578839,889.8268817,19.0084784,53.4802049,1.8779949,269.7013165),(18818,'beisa_radius.tif',241,3,44,231.4290201,90.470517,100.510753,1.8,90.1249007,99.1476246,1.2342961,10.4429745,17.7898913,3882.8243229,13701.4099587,34.3663387,770.1795222,371.8121052,914.2391435,0.3515621,0.7861167,2.0344439,1.6974918),(18819,'beisa_radius.tif',241,3,45,214.724737,90.5709025,99.6464277,1.8,90.3169154,98.7014239,1.1880466,11.0735734,17.344603,3509.936756,11611.6960192,30.7957563,669.4702671,316.9651414,810.1344613,17.8724253,51.4314989,1.8406455,191.3900559),(18820,'beisa_radius.tif',241,3,46,190.9588593,90.4694771,98.1978443,1.8,90.2212236,97.4579137,1.0903708,10.8942265,16.1420023,3098.0439507,8696.3840489,25.0287002,538.7425867,284.3748441,679.387834,0.3515621,0.4971838,2.3561945,0.9943677),(18821,'beisa_radius.tif',241,3,47,176.403946,90.385977,97.0382023,1.8,90.1894775,96.3145292,0.9886427,10.8738372,15.5069438,2780.608281,7045.9203221,20.5126463,454.3719519,255.7154596,616.1733705,18.6574603,44.6206911,1.8501782,234.4451715),(18822,'beisa_radius.tif',241,3,48,164.0745826,90.3313542,96.24867,1.8,90.1085654,95.6202124,0.8909595,10.7496106,15.1478035,2504.6426926,6022.9638982,16.5381402,397.6130204,232.9984575,554.5564305,2.0061323,15.2312006,1.899846,37.7213662),(18823,'beisa_radius.tif',241,3,49,152.9925263,90.3957961,95.5071274,1.8,90.2676355,94.7423942,0.802242,10.8562579,15.5675562,2232.5932416,5309.4919054,13.178794,341.0613618,205.6503502,477.7832013,2.2398811,17.578103,1.8545904,50.5482069),(18824,'beisa_radius.tif',241,3,50,143.410587,90.3703203,95.0290945,1.8,90.2141484,94.3409287,0.7343736,10.3601389,14.8985953,2006.4357511,4849.9259544,10.7334206,325.5290754,193.6688079,454.2850144,16.8465184,38.5181123,1.9445231,129.8331371),(18825,'beisa_radius.tif',241,3,51,136.3631124,90.3189985,94.5394644,1.8,90.1750721,93.930975,0.687958,10.484937,14.8187976,1815.7348718,4558.9245909,9.1630437,307.6447038,173.175564,428.5336309,2.1821391,4.5703068,1.9655874,14.6596052),(18826,'beisa_radius.tif',241,3,52,129.8768753,90.2137027,94.0856255,1.8,90.2243832,93.5707003,0.6343717,10.2377678,15.1543799,1651.9131565,4344.6901737,7.6034157,286.6953449,161.3548179,393.1952381,1.0014461,1.5722333,2.677945,3.6862271),(18827,'beisa_radius.tif',241,3,53,125.1327785,90.0772246,93.6985293,1.8,90.1635521,93.3257466,0.5912194,9.7656352,14.2054115,1513.5106397,4157.5234925,6.4790745,292.6718098,154.9833283,399.0388847,0.3515621,0.7861167,2.0344439,1.6974918),(18828,'beisa_radius.tif',241,3,54,120.215198,89.9859567,93.3528115,1.8,90.1185615,93.0887083,0.5469343,9.4651749,13.9524961,1365.0261921,4041.5751124,5.4191815,289.6668153,144.2156326,387.4988633,0.7031241,0.9943677,2.3561945,1.9887353),(18829,'beisa_radius.tif',241,3,55,116.9939147,89.9413653,93.0945424,1.8,90.0609846,92.8269986,0.4990312,9.1693046,13.7757649,1245.8749083,4050.3637621,4.4659338,294.0209712,135.8745256,384.2817188,15.4474976,33.6692951,2.0718097,84.6186797),(18830,'beisa_radius.tif',241,3,56,118.5463165,89.9589169,93.0109462,1.8,90.0978769,92.8071845,0.4740219,9.1876083,13.7384023,1225.7609732,4286.4207402,4.1167862,312.002854,133.414588,400.730428,15.8125204,33.0543129,2.082027,84.4127394),(18831,'beisa_radius.tif',241,3,57,122.1725073,90.1151069,92.9748387,1.8,90.3270509,92.8001847,0.4439075,8.8472597,13.8371735,1261.4969415,4670.044293,3.755701,337.4998733,142.5861773,427.5609389,16.5637539,32.5721822,2.1408368,85.5277441),(18832,'beisa_radius.tif',241,3,58,126.907503,90.1959068,93.0621752,1.8,90.4874527,92.9974259,0.4180727,9.2504905,13.9161271,1335.6694173,5137.339673,3.4864865,369.1644693,144.3890376,462.807946,17.2103184,32.1981717,2.1224513,86.607415),(18833,'beisa_radius.tif',241,3,59,136.2294415,90.2701301,93.248227,1.8,90.4064012,93.2547288,0.3936561,9.1095986,14.9917223,1504.5809894,5816.0448556,3.3404361,387.9504123,165.1643558,485.9544733,1.843122,8.963109,1.7681919,22.102727),(18834,'beisa_radius.tif',241,3,60,152.0593025,90.2541474,93.4469628,1.8,90.229328,93.5653929,0.359029,9.105559,14.7393699,1816.9910159,6701.5430049,3.1288128,454.6695719,199.547443,574.8563731,2.5556296,16.2328809,1.6575347,49.3478989),(18835,'beisa_radius.tif',241,3,61,163.168475,90.2542651,93.5551709,1.8,90.1759487,93.8144059,0.3199475,9.1413447,14.5899129,2041.923718,7583.0673263,2.6901255,519.7472651,223.3723577,646.3119445,2.2245784,16.889621,1.5291537,41.0164108),(18836,'beisa_radius.tif',241,3,62,24.9127351,90.830375,101.1126757,1.8,88.8660538,101.2014033,-0.0383479,3.6090877,18.3733599,41.6101282,2925.9225813,0.006103,159.2480958,11.529265,161.003843,4.9137991,8.8171316,2.7314653,24.3827059),(18837,'beisa_radius.tif',241,3,63,80.2149636,88.1445814,101.5649138,1.8,87.3246479,101.7082421,-0.0460918,4.8860184,17.8797072,225.518447,8615.0153272,0.0283821,481.8320147,46.1558734,494.1484793,8.4975604,35.408426,0.1194289,90.1937032),(18838,'beisa_radius.tif',241,3,64,152.5640981,86.8275081,103.849995,1.8,86.3965589,104.8162212,-0.2364295,20.7109255,20.9435108,4740.7443313,17614.0686403,1.3950741,841.027505,228.900651,940.1615889,13.1187649,38.0353757,0.1484329,107.8510471),(18839,'beisa_radius.tif',241,3,65,295.0311616,84.9988586,107.6764227,1.8,85.8365336,108.0967298,-0.328777,19.3401975,26.5450765,13931.608629,39044.6629343,5.1264229,1470.8815392,720.3446939,1983.0125216,29.3459824,45.8946732,0.3847738,228.0171154),(18840,'beisa_radius.tif',241,3,66,430.8277928,85.8093886,109.2443036,1.8,87.2487984,109.4068426,-0.2347296,18.516455,29.4605858,21387.0312321,60225.3458086,3.8841626,2044.2684396,1155.0283888,2769.5839021,27.4218407,49.9193367,0.2056827,176.0626603),(18841,'beisa_radius.tif',241,3,67,504.8633743,87.1443372,109.7791171,1.8,88.3600628,109.6452537,-0.1688082,17.4065697,29.4212166,26672.5060166,78717.9452095,2.3750928,2675.5503063,1532.3240841,3580.8500688,28.8388098,51.9075162,0.1495597,192.6610314),(18842,'beisa_radius.tif',241,3,68,555.7524433,88.6616623,110.0144888,1.8,89.5636402,109.8319167,-0.105081,17.4996808,29.0044844,30890.3261101,98230.8949619,1.0190132,3386.7485344,1765.1936939,4450.0540119,27.9772848,53.646343,0.1446774,170.9055797),(18843,'beisa_radius.tif',241,3,69,598.2619737,90.5426043,110.2781918,1.8,90.8028475,110.0772481,-0.0303519,17.5064213,27.9708811,34212.5993712,125482.9220592,0.0918289,4486.1984035,1954.2885936,5574.860444,30.0109486,55.9878448,0.0565434,194.0173101),(18844,'beisa_radius.tif',241,3,70,640.9860365,92.2193683,110.5667725,1.8,91.0290851,110.130603,0.0373643,17.6787573,31.2163442,35639.9482938,160210.1252547,0.149076,5132.2513727,2015.9758837,6211.3830999,28.828089,58.4756674,3.0150005,161.5943596),(18845,'beisa_radius.tif',241,3,71,625.9104849,92.2720255,110.6904168,1.8,90.9901263,110.1769644,0.0599787,17.4017935,31.5185795,35886.2893764,166002.3548504,0.3748295,5266.8095312,2062.2178598,6348.9659659,29.4102291,58.7792421,2.9793938,160.5999919),(18846,'beisa_radius.tif',241,3,72,603.0469321,92.0737782,110.5738564,1.8,90.9107204,109.8883974,0.0650751,23.3172219,31.2142844,36055.6604728,158759.6506156,0.425027,5086.1217475,1546.3103034,6195.8020678,31.0936663,59.014276,3.0401457,184.0736334),(18847,'beisa_radius.tif',241,3,73,595.0498665,92.0479691,110.278773,1.8,91.0415552,109.6874881,0.0615111,22.71593,31.0054119,35488.4658793,152768.3534512,0.3747662,4927.1512352,1562.2721961,5493.8512118,30.2343372,58.5115881,3.069429,172.8589813),(18848,'beisa_radius.tif',241,3,74,576.2139289,92.150211,110.0818639,1.8,91.107656,109.6085894,0.0671049,22.8552627,30.6786673,34860.9356911,142391.9727283,0.4318058,4641.4002026,1525.2914025,5777.5224945,31.7670739,57.5155961,3.0559134,228.8408765),(18849,'beisa_radius.tif',241,3,75,570.7930885,92.3062309,109.942055,1.8,91.397834,109.4784076,0.0738572,21.6797253,29.7437581,34785.9442482,132962.7281725,0.5179932,4470.2733096,1604.538052,5637.2832874,30.8075138,55.8308889,3.0406709,231.3914009),(18850,'beisa_radius.tif',241,3,76,569.2619227,92.7073731,109.7361493,1.8,91.7161295,109.5325871,0.0744001,19.4868953,29.0130944,34679.3122229,124560.3169827,0.5242109,4293.2448104,1779.6222396,5462.7655948,30.6977506,53.6636195,3.0497465,180.6725875),(18851,'beisa_radius.tif',241,3,77,547.5405082,93.0676009,109.7097789,1.8,92.0329137,109.4934473,0.0763446,19.3707529,27.9755005,34033.7906117,115099.9551152,0.5308568,4114.3126283,1756.9678741,5320.2931209,30.8308007,52.3343554,3.0339028,176.077296),(18852,'beisa_radius.tif',241,3,78,530.980645,93.3978168,109.8850173,1.8,92.4442703,109.6791667,0.0778249,21.8904396,27.7063532,32649.4380207,105223.5409091,0.5349181,3797.8127371,1491.4930249,4620.4642638,32.9256846,50.8648465,2.9889433,244.765395),(18853,'beisa_radius.tif',241,3,79,508.7989669,93.7565369,110.1084328,1.8,92.8029999,109.8503901,0.0820227,21.3071073,29.1550323,30476.7713241,95085.3504676,0.5692308,3261.3700926,1430.3570607,3477.1097318,31.7532362,49.5901933,2.9706165,165.5511322),(18854,'beisa_radius.tif',241,3,80,493.3705303,94.1259141,110.3764547,1.8,93.1820711,110.0791073,0.0882416,18.437138,27.9031622,28849.3331714,86756.7509947,0.6386179,3109.2085695,1564.7403166,4070.8273401,29.2422635,48.6287982,2.863293,211.4187443),(18855,'beisa_radius.tif',241,3,81,477.498834,94.5246592,110.590737,1.8,93.4228419,110.2351862,0.098455,19.4372001,27.1208954,26779.4766216,79031.6076852,0.7689414,2914.0486201,1377.7435287,3476.2698537,31.2890234,47.2834635,2.9923351,212.1158061),(18856,'beisa_radius.tif',241,3,82,457.3778363,94.6691014,110.8370016,1.8,93.5790895,110.3848938,0.1108149,18.6811968,25.4220271,24716.3977059,72224.754357,0.9322699,2841.0305053,1323.0628638,3654.0713459,33.7179935,46.0921861,3.0115613,317.3956308),(18857,'beisa_radius.tif',241,3,83,437.882496,94.7026097,111.1008261,1.8,93.6244574,110.5463539,0.1247826,19.6478603,24.9003248,22942.7916142,65656.7526529,1.1304702,2636.7829784,1167.6992433,3051.5220483,30.1852152,45.0987122,2.6011732,189.0394095),(18858,'beisa_radius.tif',241,3,84,410.1321118,94.6028235,111.298485,1.8,93.6718302,110.8040576,0.1353827,18.2639624,24.0796058,20913.8618995,59026.4933061,1.2452136,2451.3064639,1145.0889698,3035.403145,30.1205696,43.3548865,2.9951085,161.7942376),(18859,'beisa_radius.tif',241,3,85,390.1955716,94.4949843,111.4324287,1.8,93.805268,111.0966631,0.1382068,16.6934611,23.1870261,19358.2044088,53815.4120604,1.2343069,2320.927739,1159.6279726,2863.3792032,28.9426707,42.0186528,2.981946,147.3052389),(18860,'beisa_radius.tif',241,3,86,375.9082247,94.4951013,111.5832915,1.8,93.8938937,111.1805392,0.1407263,16.8989352,22.8636096,18000.6152433,50222.8048046,1.2325728,2196.62624,1065.1922737,2762.6939842,27.0202608,40.9218843,2.9863307,165.8923453),(18861,'beisa_radius.tif',241,3,87,359.818625,94.4657504,111.6877783,1.8,93.9684655,111.2462746,0.1358878,17.7751461,22.3022532,16834.5903749,46443.0540716,1.1005711,2082.4377523,947.0859086,2384.0004995,28.309223,40.2642172,3.0453992,197.1149878),(18862,'beisa_radius.tif',241,3,88,345.977684,94.4508476,111.8030376,1.8,94.0828063,111.3637059,0.1289124,18.3318774,21.8148048,15784.707965,43287.8997445,0.95297,1984.3358752,861.0524503,2178.4711574,24.6794195,39.5644013,3.0436923,106.80671),(18863,'beisa_radius.tif',241,3,89,339.4001358,94.4715293,111.8657126,1.8,93.895793,111.3507391,0.1297999,16.8126042,21.3734287,15025.6525126,40597.173142,0.9476957,1899.422583,893.7135698,2172.8879329,27.7959278,38.783526,2.9868758,186.7240968),(18864,'beisa_radius.tif',241,3,90,334.0831159,94.4705766,111.9563989,1.8,93.8141212,111.3811165,0.1276111,17.2021362,20.6832091,14449.3353373,38408.3019913,0.9018235,1856.9798283,839.9733121,2055.1617939,23.9033503,38.2863836,3.0126819,102.7086023),(18865,'beisa_radius.tif',241,3,91,326.0738031,94.4246309,112.0361909,1.8,93.7823372,111.4235215,0.1275558,17.4223489,20.4688005,13869.7884613,36454.9054714,0.8794444,1780.9986214,796.0917638,1995.449057,27.0627118,37.7810646,3.0484054,149.4645807),(18866,'beisa_radius.tif',241,3,92,317.8928793,94.4008046,112.1487118,1.8,93.9199355,111.751006,0.1139648,16.5263922,20.2205495,13226.4035052,34578.8464794,0.6851564,1710.0844093,800.3200764,2031.1328641,23.203096,37.106039,2.9702135,98.9370719),(18867,'beisa_radius.tif',241,3,93,315.8644461,94.4311723,112.2443069,1.8,94.1079142,111.8951512,0.103231,18.1945707,19.7803281,12802.3862421,33337.4024399,0.5590189,1685.3816696,703.6377196,1717.2318258,22.8515339,36.7007892,2.9780188,97.5308236),(18868,'beisa_radius.tif',241,3,94,314.5347042,94.5596303,112.3386156,1.8,94.4067564,111.9923209,0.0960255,17.6845219,20.0586275,12499.857033,32266.8405875,0.4818978,1608.6265397,706.8247063,1674.0732092,0.3515621,0.7861167,2.0344439,1.6974918),(18869,'beisa_radius.tif',241,3,95,317.4339265,94.6276407,112.4997607,1.8,94.3984442,112.2274146,0.0940174,19.5628527,20.9709537,12135.5956192,31622.8259245,0.4662712,1507.9345646,620.3387504,1525.7991288,23.78864,35.9505514,2.9844824,140.8918185),(18870,'beisa_radius.tif',241,3,96,318.2778617,94.7082433,112.6611182,1.8,94.6067202,112.5402173,0.0899899,14.756675,19.0279219,11734.2141618,30699.4703658,0.4284208,1613.3906031,795.1800919,2189.9015565,22.3737628,35.5495133,2.9927027,95.6273916),(18871,'beisa_radius.tif',241,3,97,318.6931064,94.8503176,112.8143741,1.8,94.8288674,112.731226,0.091456,15.5984694,17.9728559,11383.1870539,29731.7710316,0.4430313,1654.2596887,729.7630794,2260.2194249,22.0471889,35.1509322,3.00111,94.4270836),(18872,'beisa_radius.tif',241,3,98,316.2212637,94.9002864,113.0016896,1.8,94.902093,112.9476768,0.0892076,15.3652429,17.6881314,10872.8963611,28722.1158315,0.4183033,1623.8072379,707.6293203,2146.8701343,21.7629113,34.7548926,3.0097096,93.3474127),(18873,'beisa_radius.tif',241,3,99,314.5503597,94.9565731,113.1938258,1.8,94.9730242,113.1904024,0.082021,15.4911574,17.8697924,10402.9721108,27641.0824492,0.3518963,1546.804903,671.5426009,2109.982136,21.4452857,34.3614823,3.0185067,92.1471047),(18874,'beisa_radius.tif',241,3,100,312.4575818,95.0028901,113.3770532,1.8,95.0325335,113.3355768,0.073271,14.2438869,17.9494803,10025.7669255,26718.5605643,0.2790788,1488.5422928,703.8645421,2031.9214782,20.7421616,34.0126074,3.0172377,90.6555532),(18875,'beisa_radius.tif',241,3,101,311.1384017,95.0639542,113.5571234,1.8,95.0870698,113.4627975,0.0698878,15.8234144,17.6772228,9704.6911193,25895.5877682,0.2528706,1464.9126763,613.3120733,2009.0109478,0.3515621,0.4971838,2.3561945,0.9943677),(18876,'beisa_radius.tif',241,3,102,310.6099732,95.1118711,113.7433286,1.8,95.1714066,113.6409015,0.0698711,14.0979559,17.411883,9409.3187216,25089.5497231,0.2523202,1440.9440804,667.4243251,1979.8449236,0.3515621,1.1117369,1.8925469,2.4006159),(18877,'beisa_radius.tif',241,3,103,308.3451348,95.1523116,113.9166597,1.8,95.1583093,113.8546149,0.0686995,15.1727421,17.4649076,9096.8298837,24248.157477,0.242164,1388.3931164,599.5508133,1908.5165644,0.3515621,1.1117369,1.8925469,2.4006159),(18878,'beisa_radius.tif',241,3,104,308.1768946,95.2097389,114.0600613,1.8,95.2589291,114.0101195,0.0655131,13.9543704,16.7393832,8897.0985999,23583.9024761,0.2201322,1408.8871846,637.5850957,1910.8266171,20.0390375,32.5342149,3.0333221,87.0546294),(18879,'beisa_radius.tif',241,3,105,308.5004911,95.2905137,114.1361375,1.8,95.4138043,114.1150131,0.0664581,13.3475431,16.8468133,8800.404334,22844.8157162,0.2267573,1356.031865,659.3276603,1873.3172394,0.3515621,0.4971838,2.3561945,0.9943677),(18880,'beisa_radius.tif',241,3,106,307.9276054,95.3270765,114.2700726,1.8,95.5014857,114.2511432,0.06867,14.1586382,16.6354471,8675.915314,22242.7965419,0.2416292,1337.0723578,612.7648158,1737.2336336,0.3515621,0.4971838,2.3561945,0.9943677),(18881,'beisa_radius.tif',241,3,107,305.9623934,95.3790644,114.4324219,1.8,95.5163889,114.3926011,0.0680667,14.3644525,16.3952605,8469.1505954,21622.1037416,0.2358936,1318.8020868,589.5909073,1678.1523576,0.3515621,0.4971838,2.3561945,0.9943677),(18882,'beisa_radius.tif',241,3,108,306.0103711,95.4179491,114.5829221,1.8,95.6086381,114.5368957,0.0689964,13.4852524,16.3485616,8278.901882,21190.8507712,0.2424093,1296.1905344,613.9226498,1738.7189117,0.7031241,0.9943677,2.3561945,1.9887353),(18883,'beisa_radius.tif',241,3,109,305.9444533,95.4522647,114.7209916,1.8,95.6129509,114.6762906,0.0730959,13.6274764,16.1187272,8143.2558206,20857.094552,0.2719595,1293.9665964,597.5615424,1725.7295119,0.3515621,2.4859192,1.7126934,5.2131124),(18884,'beisa_radius.tif',241,3,110,306.0845661,95.5119941,114.8627831,1.8,95.712059,114.7969091,0.0745117,13.9602992,16.0594557,8013.4912869,20539.7292659,0.2827065,1278.9804107,574.0200258,1612.1176147,0.7031241,1.267575,2.1587989,2.6918595),(18885,'beisa_radius.tif',241,3,111,306.0728807,95.576642,115.0188121,1.8,95.751068,114.9641341,0.0743613,12.5932948,15.8633707,7867.7977675,20264.0307497,0.2815572,1277.4101474,624.7608661,1626.5456734,19.3359133,30.6323349,2.9802175,83.3684022),(18886,'beisa_radius.tif',241,3,112,306.0486484,95.6606579,115.166655,1.8,95.8328678,115.1064223,0.0740042,13.6034254,16.204485,7768.2389188,20050.7292086,0.2788425,1237.3567725,571.0502105,1526.5285961,0.3515621,2.4859192,1.7126934,5.2131124),(18887,'beisa_radius.tif',241,3,113,304.8734014,95.7861107,115.2742872,1.8,96.0374129,115.2578756,0.074499,13.3246727,15.7407744,7706.1662683,19730.3658693,0.2814917,1253.4558586,578.3381289,1683.3095112,19.4606014,30.3994476,3.037321,83.3684022),(18888,'beisa_radius.tif',241,3,114,304.4042239,95.8544451,115.4137358,1.8,96.0876062,115.342109,0.0746869,13.7566653,15.7407948,7630.2843062,19561.194106,0.2824754,1242.7068843,554.6608977,1615.5027742,1.0200321,4.624077,1.7234457,10.3055878),(18889,'beisa_radius.tif',241,3,115,304.3528005,95.9292487,115.5546265,1.8,96.157339,115.4777702,0.0746604,13.8916171,15.5539872,7544.2854354,19424.3345398,0.2822274,1248.833133,543.0818714,1666.0135366,19.3160302,30.1790997,3.001343,82.5799749),(18890,'beisa_radius.tif',241,3,116,305.1013421,95.9981216,115.6845604,1.8,96.2139083,115.576732,0.0747898,14.0158676,16.3336892,7470.5570299,19372.4908179,0.2839011,1186.0450236,533.0071048,1570.0139286,0.3515621,0.4971838,2.3561945,0.9943677),(18891,'beisa_radius.tif',241,3,117,305.3273353,96.0948959,115.8323334,1.8,96.3743281,115.744984,0.0703676,13.1599933,15.3580674,7322.9614486,19281.2780115,0.2515611,1255.4494948,556.456322,1633.3205934,0.3515621,1.1117369,1.8925469,2.4006159),(18892,'beisa_radius.tif',241,3,118,304.9574091,96.20671,115.9899936,1.8,96.5264476,115.846048,0.0661281,13.1245684,16.1531821,7190.5928019,19225.7505831,0.2219356,1190.2144423,547.8727065,1622.380332,18.9843513,30.0498173,3.0361033,82.2887313),(18893,'beisa_radius.tif',241,3,119,305.2787209,96.306987,116.131742,1.8,96.5370491,115.9156896,0.062989,12.4418843,15.490786,7069.5360104,19263.7367462,0.2016047,1243.5609647,568.2046082,1601.8997019,0.7031241,1.5722333,2.0344439,3.3949836),(18894,'beisa_radius.tif',241,3,120,304.773064,96.4084969,116.2861682,1.8,96.5892163,115.993058,0.0577212,13.0427195,15.5997869,6929.3505478,19251.8263684,0.1690494,1234.1082892,531.2811132,1558.782804,18.9038801,30.1299146,2.9419088,85.4777746),(18895,'beisa_radius.tif',241,3,121,304.1119384,96.5804626,116.3935328,1.8,96.8036258,116.1030727,0.0535347,13.3907868,15.907013,6843.2218291,19162.7062406,0.1451236,1204.6703108,511.0395645,1512.7844758,18.810369,30.230249,2.9898275,84.3627699),(18896,'beisa_radius.tif',241,3,122,304.1151968,96.6642905,116.4966769,1.8,96.862595,116.1074893,0.0546262,13.7631593,15.5718461,6829.4154032,19178.6332192,0.1510975,1231.6223161,496.2098654,1501.8162812,18.6327892,30.2772301,2.9191454,84.2774666),(18897,'beisa_radius.tif',241,3,123,303.9287917,96.7419456,116.606211,1.8,96.9297679,116.1894828,0.0540701,13.5752828,15.4552851,6791.2471093,19205.0629092,0.1479488,1242.6210717,500.2656085,1490.3389941,0.7031241,1.267575,2.1587989,2.6918595),(18898,'beisa_radius.tif',241,3,124,303.8082296,96.8529282,116.7433464,1.8,97.1621187,116.388152,0.0454182,13.2985802,15.4355038,6646.2495572,19185.3104232,0.1043782,1242.9338703,499.771365,1531.7379712,0.3515621,1.1117369,1.8925469,2.4006159),(18899,'beisa_radius.tif',241,3,125,303.8074431,96.9509025,116.8607103,1.8,97.2689447,116.5457727,0.0413788,13.127422,15.8342732,6531.4094692,19227.8479641,0.0866471,1214.3183142,497.5393836,1487.908179,0.3515621,1.1117369,1.8925469,2.4006159),(18900,'beisa_radius.tif',241,3,126,304.6892435,97.0045816,116.9442893,1.8,97.3100143,116.6655974,0.0447184,13.5569332,15.5482785,6518.8250571,19367.3587316,0.101482,1245.6272097,480.8480624,1569.4129044,0.3515621,0.4971838,2.3561945,0.9943677),(18901,'beisa_radius.tif',241,3,127,305.2516422,97.0748423,117.030838,1.8,97.3866356,116.7456546,0.046656,12.5847411,15.6249016,6505.1645637,19563.8220727,0.1106638,1252.0924941,516.9088914,1617.6040721,0.3515621,1.1117369,1.8925469,2.4006159),(18902,'beisa_radius.tif',241,3,128,304.517595,97.1727943,117.1548762,1.8,97.410225,116.8517023,0.0416021,12.7240283,15.4126309,6382.3913422,19651.0727376,0.087789,1274.9979484,501.6014714,1554.4057501,18.5283164,30.620228,2.9216784,85.2718343),(18903,'beisa_radius.tif',241,3,129,305.3443017,97.3163484,117.1882483,1.8,97.5632129,116.7965384,0.0423733,12.7209831,15.804381,6476.8233318,19717.9520097,0.0913194,1247.6257073,509.1448736,1497.7875322,22.0849444,30.7531412,2.9576492,138.8531137),(18904,'beisa_radius.tif',241,3,130,305.6793214,97.3965894,117.2734831,1.8,97.6085104,116.8541493,0.0419944,13.5058564,15.6841453,6463.2200738,19782.569273,0.0897932,1261.3100011,478.549443,1548.8478232,0.6680515,1.8932196,1.9513027,4.0981077),(18905,'beisa_radius.tif',241,3,131,304.7026143,97.5082676,117.3954146,1.8,97.7300845,117.0589027,0.036498,13.268269,15.9165019,6388.6324217,19824.3392074,0.0676195,1245.5211166,481.4970534,1451.2394477,0.6680515,1.8932196,1.9513027,4.0981077),(18906,'beisa_radius.tif',241,3,132,305.5088715,97.5786139,117.4639238,1.8,97.757541,117.0983807,0.0357562,12.9843751,15.7692602,6375.7571186,19952.9299227,0.0650713,1265.3053937,491.0330358,1489.4190585,22.1674291,31.0371762,2.9708574,130.2949872),(18907,'beisa_radius.tif',241,3,133,306.0797346,97.6655693,117.5444339,1.8,97.8617572,117.1914442,0.0339313,13.0775672,15.901752,6360.5466061,20069.8273995,0.0587109,1262.1142221,486.3707838,1470.6924285,18.4882908,31.1365718,3.0284417,84.8599537),(18908,'beisa_radius.tif',241,3,134,307.0448687,97.7244992,117.6098967,1.8,97.890533,117.2474963,0.0348774,12.787895,15.8810399,6343.078223,20269.8558231,0.0622247,1276.3557044,496.022074,1498.8501305,0.6292499,1.5722333,2.0344439,3.3949836),(18909,'beisa_radius.tif',241,3,135,309.6376481,97.7874381,117.6530418,1.8,97.9263557,117.3118765,0.0373784,12.7845941,15.9498611,6386.6693802,20549.5925922,0.0720675,1288.3869294,499.5598075,1500.4077226,18.3203016,31.2732189,2.9949262,84.8599537),(18910,'beisa_radius.tif',241,3,136,310.4803098,97.8937505,117.7274817,1.8,98.1264869,117.4001851,0.0322373,12.5534068,16.0395083,6365.5342636,20696.8958441,0.0537587,1290.3697178,507.0762362,1621.030867,18.2987119,31.5721522,3.0075695,86.2308682),(18911,'beisa_radius.tif',241,3,137,312.341102,98.0069303,117.736174,1.8,98.2213258,117.3971385,0.0358786,13.2786654,16.8091752,6518.3225528,20919.7747063,0.0669826,1244.5449865,490.8868749,1508.8966273,21.7968478,31.8352986,3.0309354,132.3543901),(18912,'beisa_radius.tif',241,3,138,313.8196459,98.0756601,117.7717326,1.8,98.2742929,117.4192679,0.0383125,13.2541257,16.5214984,6592.216986,21162.9332015,0.0767356,1280.93304,497.3709418,1519.8714583,0.3515621,0.4971838,2.3561945,0.9943677),(18913,'beisa_radius.tif',241,3,139,314.7566525,98.1400057,117.8080906,1.8,98.3487275,117.4694359,0.039311,12.9474903,16.4551346,6674.0113309,21348.1051578,0.0810268,1297.3522016,515.4675667,1659.3310292,0.3515621,0.4971838,2.3561945,0.9943677),(18914,'beisa_radius.tif',241,3,140,315.4886772,98.2144613,117.8544283,1.8,98.3867208,117.4909149,0.0390662,12.9640776,16.702925,6690.8369269,21519.1984982,0.0802072,1288.3491089,516.1058982,1506.2831686,22.2336557,32.1155358,3.053906,139.4356008),(18915,'beisa_radius.tif',241,3,141,316.2513012,98.2678787,117.8920914,1.8,98.419921,117.5092696,0.0385117,13.001567,16.6488917,6706.9714239,21676.1712372,0.0781361,1301.9588144,515.8586976,1535.2062041,0.6292499,1.5722333,2.0344439,3.3949836),(18916,'beisa_radius.tif',241,3,142,316.7184936,98.3364055,117.9355522,1.8,98.4897859,117.5788671,0.0351596,12.7276156,16.5836935,6715.6487866,21775.4542937,0.0652276,1313.0642027,527.6439052,1534.3168909,21.9000658,32.1155358,0.0876867,131.3246886),(18917,'beisa_radius.tif',241,3,143,317.4759491,98.3746821,117.9613606,1.8,98.5479878,117.5854572,0.033645,12.7327099,16.5349204,6722.3155298,21864.3425804,0.0598738,1322.3131408,527.9563898,1535.6539455,18.1741139,32.1847338,0.1094509,86.5574455),(18918,'beisa_radius.tif',241,3,144,318.4150531,98.4005575,117.9764022,1.8,98.5515403,117.5751437,0.0329428,12.4327344,16.8148774,6768.7106518,21942.8476606,0.0575713,1304.966263,544.4265482,1539.8876626,18.2256181,32.4657617,0.0867383,88.048997),(18919,'beisa_radius.tif',241,3,145,319.0983136,98.4510599,117.9343711,1.8,98.6184401,117.5417442,0.0329767,13.0801275,16.7656792,6917.4356602,21965.0514039,0.0578135,1310.1199896,528.8507806,1615.0596558,18.2256181,33.3706293,2.9400649,94.6683577),(18920,'beisa_radius.tif',241,3,146,318.84056,98.4578191,117.9434169,1.8,98.6123878,117.5231404,0.0309589,12.3593658,16.7541362,6962.3516897,21940.3138041,0.0509163,1309.5461015,563.3259653,1572.9850967,21.7629113,33.7151499,2.9421521,136.3671945),(18921,'beisa_radius.tif',241,3,147,317.9146396,98.4653624,117.9449864,1.8,98.6092517,117.5043174,0.0278621,12.7927899,16.7671136,7000.2342234,21880.2906983,0.0411221,1304.952731,547.201533,1571.1560431,21.9828078,32.4981048,0.0975158,123.8669311),(18922,'beisa_radius.tif',241,3,148,318.8118334,98.4740482,117.9394786,1.8,98.625918,117.5139076,0.0251343,12.4571646,17.1402037,7031.2006094,21946.0451945,0.0335604,1280.3841532,564.4302549,1501.1488173,21.7968478,34.7495579,2.9481653,160.7852342),(18923,'beisa_radius.tif',241,3,149,318.3362514,98.4854968,117.9395639,1.8,98.6461033,117.5432387,0.0201584,12.3965776,16.7633971,6998.4892234,21905.1178544,0.0215569,1306.7230777,564.5501094,1613.3161665,21.7216139,32.5740794,0.1190003,138.3059603),(18924,'beisa_radius.tif',241,3,150,317.972093,98.4997202,117.9288936,1.8,98.656839,117.5326922,0.016732,12.4104318,20.277632,6984.2627963,21892.5951771,0.0148352,1079.6425925,562.7735516,1268.0320158,21.574641,32.5342149,0.1082706,145.0106242),(18925,'beisa_radius.tif',241,3,151,318.6491362,98.5011193,117.9034043,1.8,98.6176811,117.5129002,0.0138009,12.4278706,16.7641746,6999.4349229,21968.1333457,0.0101144,1310.4214094,563.2046831,1590.151325,18.0927544,32.5342149,0.1082706,87.2605696),(18926,'beisa_radius.tif',241,3,152,318.9764406,98.5012269,117.8717176,1.8,98.6123557,117.4991895,0.0125842,12.0011155,16.7643191,7023.0498869,22001.2519104,0.0084186,1312.3856544,585.1997575,1594.6136437,18.0361362,32.4828885,0.1740452,85.6837149),(18927,'beisa_radius.tif',241,3,153,317.9571866,98.5645831,117.8050672,1.8,98.6627574,117.4377083,0.0095733,12.3010105,16.7130456,7067.9709012,21869.8216774,0.0048563,1308.5479544,574.584575,1587.8574822,18.0938961,32.4828885,0.1740452,86.0955955),(18928,'beisa_radius.tif',241,3,154,317.1618658,98.5702212,117.7649307,1.8,98.6428869,117.4078144,0.0091689,11.9333602,16.7360689,7103.2158727,21815.7195362,0.0044438,1303.5151628,595.2402139,1535.8713413,21.4139697,32.2671925,0.1973956,138.3912636),(18929,'beisa_radius.tif',241,3,155,315.8360565,98.5853558,117.7268987,1.8,98.712956,117.3881885,0.00754,11.886709,16.3753223,7095.771555,21718.8522194,0.0029926,1326.3160142,596.9500531,1637.9910109,21.3262564,32.200091,0.1866893,142.4394018),(18930,'beisa_radius.tif',241,3,156,315.2561671,98.5790962,117.6805098,1.8,98.6541794,117.3510318,0.0073491,12.5517383,16.3638516,7081.6758176,21693.2066163,0.0028379,1325.6785246,564.1988092,1610.2986561,0.3515621,0.7861167,2.0344439,1.6974918),(18931,'beisa_radius.tif',241,3,157,315.2037325,98.5810864,117.6336138,1.8,98.6291301,117.3419547,0.0067857,12.1422701,16.3635789,7107.4170187,21699.235912,0.0024188,1326.0690696,585.3449949,1586.5690529,18.0929963,32.1366954,0.1759396,85.7190486),(18932,'beisa_radius.tif',241,3,158,315.0973651,98.5855923,117.583595,1.8,98.6339818,117.2787591,0.0036471,12.1143557,16.3809131,7091.1467445,21679.2437571,0.0006986,1323.445377,585.3507129,1642.0640651,17.9296651,32.0770279,0.1651487,85.5131084),(18933,'beisa_radius.tif',241,3,159,316.0161694,98.5756758,117.5253497,1.8,98.6000574,117.2418196,0.0035772,11.6932815,16.3758393,7105.9772652,21726.9168937,0.0006739,1326.7666124,607.6974433,1693.4413807,17.9296651,32.0211093,0.1543188,85.2218648),(18934,'beisa_radius.tif',241,3,160,316.1036603,98.5597241,117.4678734,1.8,98.5507462,117.2398142,0.0020086,12.2523928,16.3952948,7135.9931933,21716.0999158,0.0002125,1324.5324434,582.4162925,1700.770387,18.1503803,31.9940791,0.2103259,85.5131084),(18935,'beisa_radius.tif',241,3,161,314.0796841,98.5899253,117.3730931,1.8,98.6417097,117.162594,0.0006295,12.0027241,16.3691254,7174.7505988,21503.765959,0.0000209,1313.6783691,597.7601872,1692.3988328,18.197064,31.922532,0.1995554,85.0159245),(18936,'beisa_radius.tif',241,3,162,312.825523,98.5759255,117.3170508,1.8,98.6711068,117.1034054,-0.0007794,12.5513869,16.7371657,7191.0655851,21386.9313711,0.0000319,1277.8108155,572.9299576,1691.6589948,18.2521881,31.922532,0.1995554,85.0159245),(18937,'beisa_radius.tif',241,3,163,311.3462675,98.5546568,117.2594236,1.8,98.6200453,117.0675341,-0.0014017,12.140056,16.4118067,7195.8426244,21283.7523005,0.0001021,1296.8561382,592.735536,1685.1653193,1.7127577,8.0168484,1.3045443,18.7930467),(18938,'beisa_radius.tif',241,3,164,310.6500856,98.5304925,117.1984351,1.8,98.5549183,116.9971453,-0.0030578,11.7407969,16.0930313,7188.934791,21241.624702,0.0004842,1319.9268887,612.3038203,1691.1830643,17.9296651,31.6503496,0.2126449,84.9306213),(18939,'beisa_radius.tif',241,3,165,310.5283999,98.4884407,117.1286987,1.8,98.4849119,116.9447739,-0.0022119,12.2475519,16.1309902,7219.7423756,21269.7732133,0.0002532,1318.5658723,589.4845302,1698.6172188,1.5361743,9.7237261,1.3521274,21.8967867),(18940,'beisa_radius.tif',241,3,166,309.7069741,98.4513792,117.0604588,1.8,98.452932,116.8741546,-0.003506,11.6111349,16.1833264,7228.6434628,21234.6722389,0.0006345,1312.1327287,622.5613203,1704.6891009,18.2812271,31.5780237,0.2017623,84.724681),(18941,'beisa_radius.tif',241,3,167,309.768847,98.4062677,116.9921103,1.8,98.3625862,116.84389,-0.0031591,11.5344426,16.2159641,7251.5379443,21256.3670068,0.0005153,1310.8296762,628.6855956,1683.7456866,0.7031241,3.8831299,1.6614562,8.3168524),(18942,'beisa_radius.tif',241,3,168,309.3464862,98.357984,116.9047473,1.8,98.2864196,116.7079785,-0.0016743,11.7700264,16.6042754,7268.5111655,21223.5213,0.0001446,1278.1961735,617.5441659,1690.776713,0.7031241,5.2851367,1.6373645,11.1293489),(18943,'beisa_radius.tif',241,3,169,307.8081669,98.3588836,116.791107,1.8,98.3576431,116.604009,-0.002093,11.8822171,16.2570868,7327.5390854,21029.1781695,0.0002249,1293.5391458,616.6811311,1711.3778416,0.3515621,4.2333678,1.6539376,8.728733),(18944,'beisa_radius.tif',241,3,170,306.3114207,98.3086789,116.7176364,1.8,98.2638753,116.533929,-0.0030522,12.2845144,16.0377197,7330.9049574,20910.0060386,0.0004756,1303.8016898,596.7598473,1687.9530085,0.7031241,5.6359686,1.6332151,11.832473),(18945,'beisa_radius.tif',241,3,171,305.1535895,98.2679003,116.633721,1.8,98.2499126,116.4710414,-0.0043952,12.3839998,16.0062388,7359.0581684,20864.5666892,0.0009824,1303.5271414,594.2392041,1575.9997353,1.0546862,4.2769371,1.735945,9.8937072),(18946,'beisa_radius.tif',241,3,172,304.021189,98.235702,116.5442014,1.8,98.2525804,116.4077691,-0.0062631,12.8294465,16.0425796,7351.8895911,20813.651945,0.0019876,1297.4005727,573.0480728,1606.7201617,0.7031241,1.4495275,1.815775,3.3949836),(18947,'beisa_radius.tif',241,3,173,303.0923847,98.1987093,116.4406626,1.8,98.2143684,116.2356621,-0.0080239,12.0385328,16.0816011,7350.8868542,20808.2058316,0.0032522,1293.9138141,610.6131868,1725.8315991,0.7031241,4.2333678,1.6539376,9.0199765),(18948,'beisa_radius.tif',241,3,174,302.28418,98.1575302,116.3555374,1.8,98.1069635,116.2112195,-0.0097875,12.3217666,15.7821191,7373.9020528,20796.3133793,0.0048261,1317.7136245,598.4451971,1668.5476203,0.7031241,4.2769371,1.735945,9.3112201),(18949,'beisa_radius.tif',241,3,175,301.7636166,98.1159296,116.2508857,1.8,97.985329,116.0338762,-0.0091331,11.8495782,15.8411748,7401.8472931,20860.8573315,0.0041951,1316.8756474,624.6506969,1549.5401224,0.7031241,2.5594104,1.849096,5.5043559),(18950,'beisa_radius.tif',241,3,176,301.4888218,98.0804765,116.1571325,1.8,97.9832258,115.9698334,-0.0112913,11.8028259,15.8619473,7450.2410489,20864.1395314,0.006406,1315.3580131,631.2251924,1751.3473061,0.7031241,1.7926218,1.7681919,4.0981077),(18951,'beisa_radius.tif',241,3,177,299.6150707,98.1001077,116.027427,1.8,97.9978118,115.8356005,-0.0132195,11.9967319,15.8516334,7500.4308041,20730.8189773,0.0087261,1307.8033352,625.2061725,1658.2581544,1.3529216,3.9305833,1.7506498,9.3965234),(18952,'beisa_radius.tif',241,3,178,297.8889606,98.0548064,115.9312536,1.8,97.9166604,115.7347497,-0.0137391,11.7092474,16.1211601,7523.3469394,20690.7710265,0.0093711,1283.454222,642.5132766,1495.8180697,0.7031241,2.1384685,1.735945,5.0924754),(18953,'beisa_radius.tif',241,3,179,295.6615755,98.0012887,115.8426232,1.8,97.8824824,115.676143,-0.0136204,11.8319233,16.5944716,7515.1760177,20636.3313926,0.0091413,1243.566645,635.1609841,1539.3129745,1.3323827,5.4577108,1.8313987,13.9918149),(18954,'beisa_radius.tif',241,3,180,295.1316488,97.9360426,115.7512587,1.8,97.7826329,115.6194799,-0.0135561,12.1658168,16.0051294,7558.1149991,20690.1136517,0.0090386,1292.7176715,621.2583274,1563.4756363,1.0546862,2.5594104,1.849096,6.5840269),(18955,'beisa_radius.tif',241,3,181,294.4118713,97.8896638,115.653424,1.8,97.7795633,115.5009989,-0.01507,11.6185691,16.3765849,7573.9847158,20730.8695781,0.0111431,1265.8847821,651.8861888,1590.735897,0.7031241,3.1835299,1.6814535,7.2018477),(18956,'beisa_radius.tif',241,3,182,293.5417938,97.8335029,115.5507677,1.8,97.7329714,115.3885078,-0.0154481,11.8292187,15.8976681,7596.9009293,20748.9864785,0.0116744,1305.1591185,642.2149357,1585.8090033,0.3515621,2.1384685,1.735945,4.5099883),(18957,'beisa_radius.tif',241,3,183,293.127373,97.7736917,115.4481138,1.8,97.5999461,115.2573954,-0.0149096,11.5111009,16.176019,7657.6816247,20826.3210072,0.0108595,1287.4812374,665.2432037,1647.7089284,1.0546862,1.7578103,2.2142974,3.8921674),(18958,'beisa_radius.tif',241,3,184,292.8483085,97.7176527,115.3458108,1.8,97.5399197,115.1413984,-0.0136239,11.5959825,15.8741948,7713.1858702,20880.0681032,0.0090586,1315.3465965,665.1601832,1510.6217913,0.7031241,3.241242,1.7894653,6.9106042),(18959,'beisa_radius.tif',241,3,185,291.5963197,97.6944986,115.213558,1.8,97.5072247,114.9688571,-0.0122136,12.3901491,16.0075853,7802.9972009,20808.7792233,0.0072494,1299.9324288,629.7742766,1503.419508,1.298687,5.0336027,1.7818897,12.2943231),(18960,'beisa_radius.tif',241,3,186,289.7665014,97.6444957,115.130498,1.8,97.4654165,114.8643253,-0.0134407,12.510234,15.9460617,7827.4773262,20681.5195087,0.008724,1296.967233,625.6859259,1504.8508663,1.1736934,4.4469474,1.8925469,9.8937072),(18961,'beisa_radius.tif',241,3,187,289.1174732,97.5883936,115.0341863,1.8,97.4222281,114.7534897,-0.0144102,12.252375,16.3221433,7867.4322245,20648.5094827,0.0100053,1265.0611593,642.1148713,1703.206281,1.4062482,4.6904229,1.7975952,10.8027716),(18962,'beisa_radius.tif',241,3,188,288.9666862,97.5402004,114.935729,1.8,97.3903042,114.6428205,-0.0141444,12.0145285,15.7304762,7942.1695586,20710.1971682,0.0096347,1316.5651754,661.0471266,1689.3047501,1.0546862,4.3485825,1.815775,9.6024636),(18963,'beisa_radius.tif',241,3,189,289.5459764,97.4753985,114.8318424,1.8,97.2293374,114.5045991,-0.0118722,12.0122436,15.9092361,8021.2863394,20872.5171749,0.006802,1311.9748179,667.7592139,1457.4359685,18.9559278,30.4380475,0.1157592,91.6706189),(18964,'beisa_radius.tif',241,3,190,288.879832,97.4642799,114.7628481,1.8,97.353242,114.4503177,-0.0199249,11.8375523,16.0831281,8002.320885,20833.7999776,0.0191117,1295.3823345,676.0114502,1711.3183996,1.1386985,6.4154056,1.735945,14.1124519),(18965,'beisa_radius.tif',241,3,191,288.9200943,97.4002459,114.6615872,1.8,97.2461519,114.2817049,-0.0182084,12.0742065,15.8522796,8064.558321,20919.2284939,0.0159633,1319.6353494,667.9162163,1700.1720534,0.3515621,1.7926218,1.7681919,3.8068642),(18966,'beisa_radius.tif',241,3,192,289.1431287,97.3513897,114.5863627,1.8,97.218,114.2765232,-0.0197575,11.9673145,16.3226555,8134.4085501,21001.8764606,0.0188093,1286.6703238,679.7187914,1573.6802016,1.1968508,8.2072989,1.7429871,17.6280725),(18967,'beisa_radius.tif',241,3,193,287.8409899,97.3604386,114.469514,1.8,97.2838981,114.1853473,-0.0227759,12.4496756,15.8993057,8180.5208677,20877.5997748,0.0248815,1313.113925,657.0870729,1735.56714,0.9492058,5.6687679,1.6951513,12.1237166),(18968,'beisa_radius.tif',241,3,194,287.5224121,97.3087224,114.3761196,1.8,97.2222297,114.1000424,-0.020537,11.8914397,15.7550104,8241.037755,20896.6099155,0.0202085,1326.3469429,693.0227069,1707.0000407,1.4785266,5.5586843,1.8925469,13.7858746),(18969,'beisa_radius.tif',241,3,195,286.3677644,97.2861718,114.3031102,1.8,97.2286714,114.0266406,-0.0223259,12.336814,16.2731822,8239.7768217,20828.9469884,0.023786,1279.9553752,667.9015177,1717.7159571,1.3908018,5.0336027,1.7818897,12.7915069),(18970,'beisa_radius.tif',241,3,196,286.3473898,97.2518011,114.2206422,1.8,97.1750908,113.9290066,-0.0248434,12.0420876,15.9758034,8271.5764416,20872.558068,0.0294492,1306.5107017,686.8889109,1728.8737393,1.5242708,6.5677213,1.8417432,15.3980631),(18971,'beisa_radius.tif',241,3,197,286.4168282,97.2106626,114.1305889,1.8,97.1283769,113.8090385,-0.0242241,12.1489371,16.0686594,8312.9475799,20945.3008853,0.0280063,1303.4877601,684.2530746,1464.6870365,1.4062482,4.2769371,1.735945,11.1793184),(18972,'beisa_radius.tif',241,3,198,285.9046169,97.1659451,114.0452019,1.8,97.136344,113.7229986,-0.0220133,12.1906164,16.0207378,8338.7728276,20951.1560079,0.023087,1307.7522595,684.0320898,1606.8162971,1.0546862,3.9305833,1.7506498,9.6877669),(18973,'beisa_radius.tif',241,3,199,285.5021063,97.1154416,113.9661031,1.8,97.0826038,113.6577725,-0.0199316,12.268591,16.3638505,8362.8249026,21017.9444277,0.018901,1284.41313,681.645098,1709.9417377,1.0546862,4.0084242,1.8370484,10.1849507),(18974,'beisa_radius.tif',241,3,200,285.47514,97.0741142,113.8825406,1.8,97.0853075,113.5536226,-0.0160426,11.9857258,16.1151363,8401.5160295,21042.2211563,0.0122441,1305.7426739,700.9601384,1792.6913036,0.7993293,3.9305833,1.7506498,8.608096),(18975,'beisa_radius.tif',241,3,201,284.5362982,97.0843911,113.7608944,1.8,97.0875434,113.4047332,-0.0138421,12.8384133,15.8497135,8430.2470837,20923.5463277,0.0090856,1320.121425,656.6424448,1746.3690759,1.0546862,7.4162098,1.665748,17.0102517),(18976,'beisa_radius.tif',241,3,202,283.1343463,97.0460941,113.6791624,1.8,97.0169413,113.305686,-0.010535,12.1681108,15.7909486,8427.1441476,20851.8661951,0.0052371,1320.4948462,692.5597786,1757.2143636,2.0181897,10.5994649,1.670465,25.9948944),(18977,'beisa_radius.tif',241,3,203,283.0001512,97.0398985,113.5816582,1.8,97.0448965,113.2107005,-0.0088643,12.3438433,15.8157349,8477.8477273,20867.5751333,0.003706,1319.4186175,686.8077883,1736.0134601,2.1592872,10.7557308,1.7681919,28.4808136),(18978,'beisa_radius.tif',241,3,204,283.4350214,97.0417159,113.4728974,1.8,97.0343645,113.1248003,-0.0124256,12.7280309,27.9226442,8553.6093361,21026.445738,0.0072934,753.0248785,672.0292719,985.8068695,2.0322698,12.0355463,1.6879051,30.2989424),(18979,'beisa_radius.tif',241,3,205,283.6664453,97.0320603,113.3590506,1.8,96.991811,112.9644267,-0.0113681,12.4833628,28.9572678,8620.7957041,21216.6591301,0.0061097,732.6885699,690.5828051,961.9424303,2.0229817,10.9493382,1.6672701,27.2805057),(18980,'beisa_radius.tif',241,3,206,282.5429213,97.0319913,113.2678549,1.8,97.0875958,112.8818268,-0.0101469,12.6156763,15.808981,8644.2985131,21255.5401786,0.0048484,1344.523106,685.2029428,1521.0456633,1.665203,6.7624313,1.7273982,15.3980631),(18981,'beisa_radius.tif',241,3,207,282.1065529,97.0161082,113.1843798,1.8,97.0675131,112.8340603,-0.0096311,12.322849,15.7945607,8685.4347422,21357.9201131,0.0043611,1352.2326129,704.8235977,1631.9257998,1.1386985,7.2476375,1.815775,16.3071275),(18982,'beisa_radius.tif',241,3,208,281.9910844,97.0017886,113.0924886,1.8,97.016928,112.7513622,-0.0050646,12.4151564,15.5240198,8768.5604353,21468.5543557,0.0012055,1382.9249516,706.2786956,1693.3228003,1.0966977,7.3408313,1.8622531,16.3071275),(18983,'beisa_radius.tif',241,3,209,281.2890972,97.0042189,112.9288228,1.8,97.0550264,112.4648094,0.0022004,13.0457729,17.9315044,8849.6720704,21440.182626,0.000227,1195.6711569,678.3555216,1365.9455194,1.5504318,9.1270819,1.843805,22.8911544),(18984,'beisa_radius.tif',241,3,210,280.2568844,96.9931915,112.8464794,1.8,97.0213193,112.3958096,0.0074484,12.6605424,25.2318964,8874.8764282,21428.356541,0.0025915,849.2566799,700.9870606,1170.2810998,1.9448743,9.0386325,1.8063413,22.2733335),(18985,'beisa_radius.tif',241,3,211,279.5540358,96.9684741,112.741656,1.8,96.9458805,112.2725309,0.0120601,12.8512108,26.9407395,8957.010198,21487.0510815,0.0067764,797.5672329,696.9779226,1105.4933321,2.087465,9.7237261,1.7894653,26.4920783),(18986,'beisa_radius.tif',241,3,212,279.2893908,96.9523435,112.6233945,1.8,96.999,112.152181,0.0224922,12.5672908,16.5952244,9054.7617893,21675.0655712,0.0235447,1306.10259,720.5022909,1532.1778591,1.800921,10.4881045,1.8076451,25.8742574),(18987,'beisa_radius.tif',241,3,213,279.9092429,96.9217315,112.5429641,1.8,96.9268548,112.0851356,0.0246218,12.6152683,16.6267114,9120.8075458,21807.8794643,0.0282761,1311.6171255,722.997506,1547.7895879,1.7999214,9.805998,1.8244704,26.5773815),(18988,'beisa_radius.tif',241,3,214,278.7915615,96.9263774,112.450921,1.8,96.9808413,112.0040021,0.0274568,13.039286,16.5655586,9162.1459799,21851.7066739,0.0350202,1319.1047289,702.6570289,1556.1854443,1.8225641,10.5761181,1.8399638,26.8686251),(18989,'beisa_radius.tif',241,3,215,278.7800259,96.8993571,112.3436077,1.8,96.8942729,111.8930649,0.0321564,12.8242316,16.2097971,9256.0800347,21987.6022608,0.0480282,1356.4390766,721.7648826,1626.0391301,2.1810553,11.2554778,1.8233506,31.3786134),(18990,'beisa_radius.tif',241,3,216,278.0187127,96.8916944,112.2582797,1.8,96.8697483,111.8474628,0.0331526,12.1017956,34.9429104,9308.5899534,22066.8327117,0.0509096,631.5110118,769.190807,895.0208305,1.6089207,8.7890515,1.8545904,22.1880303),(18991,'beisa_radius.tif',241,3,217,277.2603209,96.9108736,112.1310102,1.8,96.8628529,111.6633962,0.0366381,12.6863665,26.6608729,9373.6089706,21957.5719329,0.0620024,823.5878849,738.872628,1121.0710728,0.7079121,3.0242512,0.9505468,6.3780866),(18992,'beisa_radius.tif',241,3,218,277.2126429,96.8699428,112.0134297,1.8,96.7320754,111.5432123,0.0455864,13.1376858,27.9285819,9498.0151875,22012.5054156,0.095947,788.1712526,722.9595335,1126.820312,0.3515621,0.7861167,2.677945,1.4915515),(18993,'beisa_radius.tif',241,3,219,276.8142896,96.8516299,111.9518082,1.8,96.6367979,111.6174865,0.0445291,12.882547,31.9740091,9534.6424955,21976.3771597,0.091419,687.3200385,740.1209155,914.1130436,1.8356712,9.6727495,1.9040406,26.9539283),(18994,'beisa_radius.tif',241,3,220,276.3304679,96.8406116,111.8517266,1.8,96.6651679,111.4452564,0.0491272,13.2789595,20.0689739,9638.2299997,22003.1364954,0.1110636,1096.3757587,725.8272012,1546.2748397,2.0079201,12.2795349,1.801887,30.3842457),(18995,'beisa_radius.tif',241,3,221,277.4412203,96.7827775,111.7287098,1.8,96.4570632,111.3357521,0.0603938,14.608825,22.5692806,9834.8421119,22264.9985845,0.168452,986.5178688,673.2123966,1357.2771049,2.4026344,12.9649682,1.7894653,31.1726731),(18996,'beisa_radius.tif',241,3,222,277.3030926,96.7681174,111.6483368,1.8,96.3437462,111.3475923,0.0580358,13.7917165,34.6423153,9928.669472,22438.1003968,0.1554917,647.7078749,719.9009274,922.5233692,0.7031241,2.2234737,1.8925469,5.0924754),(18997,'beisa_radius.tif',241,3,223,276.8290837,96.7963398,111.5506513,1.8,96.3657656,111.2679062,0.0552793,14.3847254,36.3959368,10006.5487962,22516.8951791,0.1408455,618.6650801,695.63711,881.175858,1.7407034,3.3352106,1.8925469,8.5727622),(18998,'beisa_radius.tif',241,3,224,276.9941029,96.7737847,111.44517,1.8,96.25874,111.1745974,0.0596558,14.1796259,38.1365446,10110.9789182,22696.3154023,0.1641006,595.1329787,713.0638691,850.4803168,0.3515621,1.1117369,2.8198421,2.1946756),(18999,'beisa_radius.tif',241,3,225,277.5735054,96.8051865,111.2989524,1.8,96.3148854,111.0201269,0.0647558,14.4217341,39.9052211,10226.905152,22734.7647147,0.1937211,569.7190522,709.131446,817.1015926,2.6439028,11.564201,1.9117753,36.6416952),(19000,'beisa_radius.tif',241,3,226,276.4701687,96.8082403,111.2079348,1.8,96.3549212,110.99467,0.0610753,16.147794,39.6161867,10269.9863475,22776.9337206,0.1716674,574.9400845,635.9993421,827.2812591,0.7031241,1.267575,0.9827937,2.6918595),(19001,'beisa_radius.tif',241,3,227,276.104662,96.7883831,111.0885934,1.8,96.3479398,110.894586,0.0664374,16.4483681,39.5844267,10336.6710978,22806.845796,0.2028189,576.1570312,628.4314046,809.8529825,0.3515621,0.4971838,2.3561945,0.9943677),(19002,'beisa_radius.tif',241,3,228,276.0919653,96.7656535,110.9629581,1.8,96.3070478,110.7287655,0.0720565,16.5163714,39.7974275,10493.5317709,23034.1597101,0.2385048,578.7851421,635.3412315,831.3475074,0.3515621,0.7861167,2.677945,1.4915515),(19003,'beisa_radius.tif',241,3,229,276.6829034,96.7472993,110.846239,1.8,96.1789756,110.6229756,0.0795662,13.272176,38.9908639,10692.0987091,23262.5262119,0.2913207,596.6147934,805.6025383,856.2138132,0.3515621,0.7861167,2.677945,1.4915515),(19004,'beisa_radius.tif',241,3,230,277.0338408,96.7092712,110.7126225,1.8,96.1563946,110.5975085,0.0868894,15.8401056,40.2138548,10862.5955375,23639.1401002,0.3477136,587.8357146,685.7653464,854.6785476,3.327058,15.9448026,1.815775,49.4332022),(19005,'beisa_radius.tif',241,3,231,277.6653783,96.6841752,110.5626182,1.8,96.102161,110.4065693,0.0977248,16.4589257,38.7762398,11077.3676026,24010.0455486,0.4405524,619.1947872,673.0310246,873.5410213,0.3515621,0.7861167,2.0344439,1.6974918),(19006,'beisa_radius.tif',241,3,232,277.7990492,96.6961037,110.4438582,1.8,96.1437654,110.3146702,0.1019071,17.4630001,39.3156644,11243.7642449,24205.9939188,0.479164,615.6831962,643.8621203,896.6615652,3.7597285,18.7913128,1.8747973,58.7943918),(19007,'beisa_radius.tif',241,3,233,276.8522672,96.7445433,110.2969177,1.8,96.2014323,110.2495484,0.0983815,17.4871588,38.8301927,11372.4387882,24272.9462309,0.4451666,625.1049644,650.330845,878.9577328,0.3515621,0.4971838,2.3561945,0.9943677),(19008,'beisa_radius.tif',241,3,234,276.0388565,96.7457405,110.2045062,1.8,96.0851408,110.0884939,0.0955041,17.4711556,38.1561538,11535.9840585,24428.5372092,0.4183518,640.2253578,660.2874098,900.1210662,3.4980305,21.0262329,1.929567,60.6978238),(19009,'beisa_radius.tif',241,3,235,273.9957417,96.8223967,110.1466521,1.8,96.0913518,109.8531311,0.0865449,16.1203529,33.7608412,11579.8356034,24197.5482435,0.3411854,716.7341632,718.3363576,1037.3193749,0.3515621,0.4971838,2.3561945,0.9943677),(19010,'beisa_radius.tif',241,3,236,277.2877367,96.6587062,109.8721193,1.8,95.9991137,109.5877206,0.1256826,18.4659802,32.8692467,12092.1016622,25235.914945,0.7261763,767.7667562,654.8312904,1095.9447326,0.3515621,0.4971838,2.3561945,0.9943677),(19011,'beisa_radius.tif',241,3,237,275.5562708,96.6872673,109.7682573,1.8,96.0321661,109.4802272,0.1208373,18.3278089,38.7861397,12164.8533695,25501.75545,0.6673385,657.4966125,663.7374631,919.8744796,2.8176716,15.4727252,1.9428641,44.2554235),(19012,'beisa_radius.tif',241,3,238,273.9679139,96.7013224,109.6560025,1.8,95.9805353,109.4230858,0.1230392,15.9353041,34.4767071,12270.0987709,25792.4077912,0.6877688,748.1111148,769.9946402,1036.1651914,2.5036003,10.1223014,1.925502,30.0576684),(19013,'beisa_radius.tif',241,3,239,273.4143916,96.7528233,109.4989963,1.8,96.2095556,109.1992877,0.1268191,17.340191,39.538269,12425.0632615,26212.7476534,0.7289701,662.9715544,716.5470828,960.7327173,2.8999714,10.9040928,1.9333406,33.2467117),(19014,'beisa_radius.tif',241,3,240,271.8164466,96.7854563,109.3696798,1.8,96.2980731,109.1679897,0.1285447,17.8567117,37.2477462,12549.3557314,26477.8968437,0.7444562,710.8590325,702.7808894,1043.5315886,2.5517108,9.6022148,1.9853032,28.8573604),(19015,'beisa_radius.tif',241,3,241,270.5293266,96.84786,109.187412,1.8,96.3710043,108.9244666,0.1257849,17.5517712,36.2054701,12661.4464022,26635.046468,0.7096246,735.6636006,721.3771351,1074.5032955,3.558313,16.8493247,1.9784278,52.7428825),(19016,'beisa_radius.tif',241,3,242,274.0565658,96.6441949,108.8564243,1.8,96.1316202,108.5932891,0.162456,19.5817718,39.8870678,13231.6251168,27982.644332,1.1949138,701.5467897,675.7113309,1031.9308522,0.7031241,0.9943677,2.3561945,1.9887353),(19017,'beisa_radius.tif',241,3,243,274.1582515,96.6448011,108.6500774,1.8,96.1662266,108.4390594,0.1666893,21.2944894,39.786123,13485.0413186,28619.3459222,1.2578807,719.3298511,633.2643666,1055.7403726,0.3515621,0.7861167,2.0344439,1.6974918),(19018,'beisa_radius.tif',241,3,244,274.8718492,96.6536013,108.4849786,1.8,96.2615014,108.3172389,0.1696224,21.550475,39.293464,13808.8538271,29137.1326995,1.3054982,741.526192,640.7679574,1088.2201678,0.3515621,0.4971838,2.3561945,0.9943677),(19019,'beisa_radius.tif',241,3,245,277.7850791,96.5437452,108.2033666,1.8,96.3172239,108.0832569,0.1993743,21.7673806,34.5578485,14372.1286934,30378.3793282,1.8160757,879.0587569,660.2599082,1095.6999653,0.7031241,1.5722333,1.1071487,3.3949836),(19020,'beisa_radius.tif',241,3,246,279.1161318,96.5165782,107.9853853,1.8,96.290725,107.798555,0.2006768,22.3650723,34.4593944,14828.4965874,31413.0756347,1.8483761,911.5968568,663.0202837,1127.2326468,0.7031241,3.5852436,1.3734008,7.9049719),(19021,'beisa_radius.tif',241,3,247,285.0640526,96.4726493,107.6504391,1.8,96.3123831,107.5271024,0.2258736,23.8836129,33.697106,15500.1193909,33275.7671104,2.3829981,987.4962873,648.985539,1182.7727124,1.8900776,12.2795349,1.9832068,33.1614084),(19022,'beisa_radius.tif',241,3,248,290.0723075,96.3999394,107.4060971,1.8,96.2595195,107.3111903,0.2446441,24.729858,35.6722186,16183.5274477,35000.7461286,2.8362391,981.1766004,654.4124686,1240.3653012,0.3515621,0.4971838,2.3561945,0.9943677),(19023,'beisa_radius.tif',241,3,249,294.1686496,96.3470547,107.1026328,1.8,96.2175137,106.979738,0.2729738,23.9159988,36.6559138,16844.7057845,36876.1877727,3.5634702,1006.0092335,704.3279251,1307.6850803,2.0725738,14.345283,1.8692953,37.2241823),(19024,'beisa_radius.tif',241,3,250,299.8292287,96.2488471,106.8530603,1.8,96.1095119,106.7569601,0.3014337,18.6048178,35.8701275,17655.1132504,39239.7394292,4.4046614,1093.9392228,948.9538358,1414.9522357,0.3515621,0.4971838,2.3561945,0.9943677),(19025,'beisa_radius.tif',241,3,251,306.7330325,96.1918233,106.6388807,1.8,96.0886432,106.5856783,0.3136817,19.5528283,33.2742519,18453.8893886,41677.7487525,4.8673924,1252.5525403,943.7964217,1638.5688902,1.0546862,1.8932196,1.1902899,4.3893512),(19026,'beisa_radius.tif',241,3,252,320.3903775,96.280319,106.5290659,1.8,96.2269913,106.7549099,0.3134083,16.8813393,23.5994146,19184.2718824,43507.1751831,5.0755456,1843.570105,1136.4188304,2287.162146,0.7031241,1.8932196,1.1902899,4.0981077),(19027,'beisa_radius.tif',241,3,253,335.6981021,96.1566251,106.2485305,1.8,96.1139699,106.4699545,0.3328841,17.7219257,38.0698414,20459.5433611,47353.6422035,5.9742379,1243.8623443,1154.4763108,1714.7711647,2.5581291,8.1771249,2.0152155,25.0504963),(19028,'beisa_radius.tif',241,3,254,338.3092711,96.3165896,106.1475948,1.8,96.2215953,106.3094457,0.3180852,17.2572839,38.9043585,21319.1495347,49281.7278061,5.5150938,1266.740534,1235.3710882,1808.5759907,0.3515621,0.4971838,2.3561945,0.9943677),(19029,'beisa_radius.tif',241,3,255,345.8547622,96.2631906,105.8779992,1.8,96.1337885,106.1048668,0.3183994,25.0526684,37.1323077,22607.9632342,52582.3769514,5.6488648,1416.0815816,902.4173733,1836.1466005,0.3515621,0.4971838,2.3561945,0.9943677),(19030,'beisa_radius.tif',241,3,256,351.0187106,96.3585503,105.7696515,1.8,96.212324,105.9719781,0.3134234,22.0164233,30.8278086,24019.601019,55348.5815613,5.5612712,1795.4108333,1090.9856118,2297.5442871,0.6292499,1.267575,0.9827937,2.6918595),(19031,'beisa_radius.tif',241,3,257,365.3231362,96.0082459,105.1730068,1.8,96.1508111,105.4986281,0.3625833,21.4507527,29.0320105,26662.9541049,62030.6501539,7.6599461,2136.6295016,1242.9845466,2607.5999312,1.2489538,6.0074951,1.929567,13.5799343),(19032,'beisa_radius.tif',241,3,258,380.1975636,96.2660889,105.1943153,1.8,96.5151878,105.4478373,0.3355161,18.8197016,26.0893351,28454.3266202,64736.7096091,6.869527,2481.34762,1511.9435597,3424.5089288,2.3453009,7.1185892,2.1451012,21.4495724),(19033,'beisa_radius.tif',241,3,259,407.4931524,97.3165419,105.5780313,1.8,97.1970069,105.5565558,0.219665,18.6033273,26.5452019,29181.2683585,64167.3346335,3.2247363,2417.2856121,1568.6047944,3371.4075655,2.2032673,6.4633898,1.9614034,18.4664694),(19034,'beisa_radius.tif',241,3,260,422.6006891,97.2234344,105.4073838,1.8,97.4989744,105.4620969,0.1802923,18.5533088,26.4059832,31454.1820725,71644.2969249,2.2647632,2713.1842223,1695.3408362,3745.7456274,1.9802565,6.7624313,2.0576956,16.8542809),(19035,'beisa_radius.tif',241,3,261,470.0972384,96.7419405,105.0485439,1.8,97.7196991,105.453461,0.1495615,19.0066141,26.9975857,34515.4545872,85997.7045032,1.7395441,3185.3849978,1815.9707167,4463.6304173,33.8859364,52.5535307,2.764813,194.6290687),(19036,'beisa_radius.tif',241,3,262,533.0532356,96.5688309,104.7917243,1.8,97.9946398,105.4069267,0.1252028,19.7154269,31.0277171,38549.7873964,103170.8222894,1.3854048,3325.1180515,1955.3108083,4567.2819055,0.3515621,0.4971838,2.3561945,0.9943677),(19037,'beisa_radius.tif',241,3,263,526.1364729,97.8460946,105.2638764,1.8,98.146554,105.6419724,0.0471352,18.7224896,39.8705951,39320.9334656,100214.5958846,0.1946783,2513.4963662,2100.1979057,3426.9252942,0.4971838,0.9943677,2.3561945,1.9887353),(19038,'beisa_radius.tif',241,3,264,525.5332501,97.9815813,105.5190364,1.8,98.3167123,105.7857302,0.0506295,19.1224042,40.6938363,38943.3460971,94333.4562597,0.2243289,2318.126398,2036.5297999,3155.6422595,2.8351948,8.5827237,2.1815223,23.8501883),(19039,'beisa_radius.tif',241,3,265,506.9422196,97.562231,105.5763775,1.8,98.245327,105.8878852,0.1006779,19.0428286,38.3617147,34446.5175654,87337.7026805,0.8535077,2276.689229,1808.8971098,3120.3416692,3.3085946,9.2815047,2.221873,30.4342152),(19040,'beisa_radius.tif',241,3,266,480.0079802,97.1963883,106.288288,1.8,98.2079498,106.4145857,0.1647164,19.9133239,38.6132185,28768.4436353,80391.9407529,2.1509952,2081.9797942,1444.6831597,2763.7196446,30.963926,51.9182299,2.8177008,202.704647),(19041,'beisa_radius.tif',241,3,267,469.4015059,97.475321,106.7366919,1.8,98.371595,106.7537258,0.1882758,19.4329412,40.0937823,25421.6281547,73908.9342501,2.7405936,1843.4013965,1308.1719303,2391.7333157,29.8719153,49.704709,2.8399736,248.7721371),(19042,'beisa_radius.tif',241,3,268,471.0694511,97.9872843,107.0140364,1.8,98.9853144,106.9683989,0.1949221,17.6006896,25.5035783,23585.9225769,69637.1010978,2.9454284,2730.4835506,1340.0567351,3635.9803291,1.5749099,3.5156206,2.2142974,10.5614975),(19043,'beisa_radius.tif',241,3,269,471.6151456,98.5165816,107.0692752,1.8,99.5442078,107.0767198,0.1761039,16.2224464,23.0647158,21939.0035788,65426.174346,2.4125713,2836.6347474,1352.3856395,3754.4733473,27.8662965,46.0277853,2.7497392,153.2568091),(19044,'beisa_radius.tif',241,3,270,473.7240285,99.0908379,107.1872274,1.8,100.0637214,107.2300451,0.1450661,15.0995134,21.6734341,20719.2833592,60901.038438,1.6498998,2809.9394891,1372.1821879,3765.4329448,27.4557451,43.4147119,2.8710793,161.9502084),(19045,'beisa_radius.tif',241,3,271,442.4386897,100.6355983,107.5061483,1.8,100.6940098,107.3447948,0.0777619,13.9619608,21.8731378,18453.6302778,49589.3475532,0.4450002,2267.1345994,1321.7076377,3071.4389262,27.6569497,42.124412,3.0244839,148.5408806),(19046,'beisa_radius.tif',241,3,272,394.1541979,102.456164,107.8672777,1.8,102.1140714,107.6708634,-0.0006832,13.427291,21.947769,14833.5328567,37624.8956171,0.0000311,1714.292495,1104.730126,2385.6059404,26.0155925,40.6491495,0.1039716,184.564755),(19047,'beisa_radius.tif',241,3,273,327.5487139,105.0473828,108.0891236,1.8,104.0868158,108.0041059,-0.0861686,12.8193678,23.3841173,9906.4370123,24501.9509399,0.4043411,1047.8031129,772.7711067,1465.089035,25.1489831,39.9885424,0.1145407,178.1866684),(19048,'beisa_radius.tif',241,3,274,254.6992784,107.5876024,107.4089065,1.8,107.0191643,107.8618819,-0.007662,11.8267791,22.8779321,6684.2112582,12878.0089894,0.0024919,562.9009188,565.1759619,851.4788088,22.4435433,30.4400777,0.2449787,93.0208354),(19049,'beisa_radius.tif',241,3,275,204.3577017,109.0970427,106.7599321,1.8,108.591911,107.2548169,0.1858197,11.1017128,13.9749782,4642.1919695,8780.2175888,1.1625699,628.2813104,418.1509677,917.2805858,20.691924,27.0428703,0.2765139,94.5976901),(19050,'beisa_radius.tif',241,3,276,160.0355441,110.5326226,106.4004728,1.8,109.9546981,106.7940441,0.4919034,10.989438,12.8389477,2761.3608069,5636.5634429,5.949895,439.0206712,251.2740686,559.711496,18.7700091,25.4099368,0.25169,90.5495519),(19051,'beisa_radius.tif',241,3,277,103.4890046,112.1851349,106.3720332,1.8,111.6416537,106.4851911,0.8576833,11.524467,10.5611795,888.0888549,2431.0981467,9.8665307,230.1919169,77.0611651,224.1030983,0.9447674,2.8343839,1.0516502,6.086843),(19052,'beisa_radius.tif',241,3,278,43.8863885,114.1863602,107.6589943,1.8,113.1632839,106.794585,1.0956848,5.6244954,8.8739804,193.9818116,456.2621797,5.7838663,51.4157299,34.4887494,65.4635161,10.8823219,15.5722549,2.0647377,45.8322783),(19053,'beisa_radius.tif',241,3,279,13.4779063,115.529295,108.7663725,1.8,115.3109932,108.5509181,-1.1604393,3.0280198,4.533702,13.5926688,45.151906,1.8888151,9.9591693,4.488963,12.9469802,5.2605397,9.1676169,1.0040671,22.8058511),(19054,'beisa_radius.tif',241,3,280,1.5299298,116.0535546,108.7735373,1.8,115.9311051,108.8858014,-0.9889352,0.8646184,2.732056,0.1809645,1.9060174,0.1779722,0.6976495,0.2092999,0.7636475,2.0472936,5.366362,1.0191413,11.7618055),(19055,'beisa_radius.tif',241,3,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19056,'beisa_radius.tif',241,3,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19057,'beisa_radius.tif',241,3,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19058,'beisa_radius.tif',241,3,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19059,'beisa_radius.tif',241,3,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19060,'beisa_radius.tif',241,3,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19061,'beisa_radius.tif',241,3,287,4.0848065,117.4502461,111.1717862,1.8,117.4572171,111.1945327,-1.3998237,3.4827742,3.6314391,10.1578343,11.7225544,0.6610933,3.2280741,2.9165928,5.8284011,7.0312412,7.8059445,0.9453113,23.4736415),(19062,'beisa_radius.tif',241,3,288,26.9839774,117.3621632,111.2490129,1.8,117.2959916,111.2912866,-1.0457748,6.554954,6.8176216,238.2572942,254.889844,3.3674511,37.3869154,36.3476685,71.5648009,13.1753716,14.2241506,0.8728935,44.5466671),(19063,'beisa_radius.tif',241,3,289,130.2893485,99.0760831,112.6375083,1.8,96.1344146,112.3736835,-0.0793108,14.3686398,24.8415723,4579.8258518,28813.7876846,0.1363048,1159.9019332,318.7376066,1311.696886,27.7734028,28.5198966,2.6117436,93.5180192),(19064,'beisa_radius.tif',241,3,290,511.6393501,92.5625308,112.2996409,1.8,96.8172675,112.1510842,-0.0455893,16.7902457,31.2111588,24542.0070686,68174.4899202,0.1771076,2184.2985827,1461.6824263,2887.8539436,28.828089,29.3717425,2.3053908,96.1245754),(19065,'beisa_radius.tif',241,3,291,542.2242373,93.1680253,112.2471648,1.8,97.6107648,112.1233672,-0.0458761,16.8951904,30.6705429,26265.8537278,77578.5121991,0.1900628,2529.4143809,1554.6349636,3251.7508639,29.179651,29.4389933,0.8699419,96.1245754),(19066,'beisa_radius.tif',241,3,292,556.5726331,93.6709669,112.2239264,1.8,98.2635135,112.0703969,-0.0469404,16.7695172,30.2260053,27282.4580357,83530.3047376,0.2042425,2763.5244482,1626.9077851,3483.3987908,29.179651,29.4473889,2.5602125,96.1245754),(19067,'beisa_radius.tif',241,3,293,568.0685483,94.0669181,112.2137245,1.8,98.7604977,112.0878595,-0.0472751,16.7791215,29.86656,28187.9263162,88071.9566584,0.2114412,2948.8483664,1679.9405342,3667.7154973,29.179651,29.4473889,0.9894161,96.1245754),(19068,'beisa_radius.tif',241,3,294,578.3673438,94.3755903,112.1959462,1.8,99.1173791,112.04227,-0.0481297,16.9484788,29.6002824,29126.3074642,91747.0135793,0.2231222,3099.5316981,1718.5204552,3815.288075,29.179651,29.4011837,2.2885015,96.1245754),(19069,'beisa_radius.tif',241,3,295,587.5031768,94.5959808,112.1861876,1.8,99.3970525,112.0277421,-0.0493111,16.5727468,29.4103286,29977.4663252,94582.3659462,0.2379012,3215.9574688,1808.8411487,3939.3954545,29.179651,29.4389933,2.4407382,96.1245754),(19070,'beisa_radius.tif',241,3,296,593.7086639,94.7489135,112.1780414,1.8,99.5699793,112.015419,-0.0502947,16.7886539,29.2862599,30630.8650125,96552.5483899,0.2500933,3296.8548597,1824.4979779,4021.7831757,29.2616801,57.1966731,0.0923293,183.143871),(19071,'baisa_ulna.tif',241,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19072,'baisa_ulna.tif',241,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19073,'baisa_ulna.tif',241,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19074,'baisa_ulna.tif',241,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19075,'baisa_ulna.tif',241,4,5,2.160044,89.8593858,74.6329015,1.8,89.8141566,74.6107558,1.1586399,1.4411162,2.8551186,0.9932495,3.3008926,0.3022372,1.1561315,0.6892223,1.5023817,3.3022234,5.976555,2.0607537,14.4889987),(19076,'baisa_ulna.tif',241,4,6,23.2195839,89.62341,74.6049458,1.8,89.6356632,74.6361786,1.1429982,3.1173393,6.0822379,46.3510233,172.0226322,3.2038545,28.2827858,14.8687772,35.902681,6.6053393,12.2795349,1.9832068,30.5548522),(19077,'baisa_ulna.tif',241,4,7,48.4204847,88.2322313,73.1192197,1.8,88.2308533,73.1766834,1.0270707,4.224333,9.8130601,191.9449433,930.0207498,5.9102994,94.7737752,45.4379296,113.1476712,8.6226881,19.498229,2.0183163,47.288496),(19078,'baisa_ulna.tif',241,4,8,81.6087132,86.8156647,70.4972191,1.8,86.8922012,70.6475869,1.1347753,5.2559111,14.3471306,434.2871242,3494.7056563,11.1753909,243.5822022,82.6283232,272.7736428,10.4983413,27.6149705,1.9489386,67.1965474),(19079,'baisa_ulna.tif',241,4,9,119.838605,85.779694,68.4685284,1.8,86.1722221,69.3471515,1.1651122,6.5189776,15.6368447,892.3042328,6795.7918164,16.8623587,434.6012209,136.8779404,491.3558713,12.2582926,29.9653815,1.95566,74.1924549),(19080,'baisa_ulna.tif',241,4,10,147.5165171,85.0759843,67.6158968,1.8,85.4949268,68.5867521,1.1674611,7.2949288,16.8812771,1500.3971273,9320.0909567,20.7986745,552.0963206,205.6767335,640.7549611,13.8104973,31.4014004,1.9492237,78.2052593),(19081,'baisa_ulna.tif',241,4,11,176.890352,84.4184802,67.0307798,1.8,84.8779214,67.9039734,1.1637451,8.3913916,18.9273028,2365.519479,12191.7557253,24.8607793,644.1359259,281.8983537,768.0848998,15.4513696,32.776446,1.9672376,83.503675),(19082,'baisa_ulna.tif',241,4,12,197.2010506,84.1498678,66.5618381,1.8,84.5872705,67.4003481,1.1682928,9.1694444,18.8124018,3018.8312853,14930.1467599,27.8235259,793.6332082,329.227286,950.0956294,16.6984652,33.8395604,1.9879658,86.4368085),(19083,'baisa_ulna.tif',241,4,13,211.074651,84.2614914,66.5308931,1.8,84.5456645,67.1894248,1.18346,9.7010369,19.2337206,3531.9981992,17427.8584738,30.1599301,906.1095806,364.0846068,1085.1680566,17.5161707,34.9464006,1.9849349,88.8374244),(19084,'baisa_ulna.tif',241,4,14,223.0740509,84.5103173,66.6919048,1.8,84.5398432,67.0748984,1.2186141,10.5478907,19.4614189,4017.3141731,19517.3961344,32.7551385,1002.8763163,380.8642195,1204.7518361,18.606829,35.9711731,1.9513027,92.4383483),(19085,'baisa_ulna.tif',241,4,15,231.2452743,84.6880974,66.8866806,1.8,84.5570237,67.1641792,1.258071,10.9546369,19.6903013,4509.7604439,20905.1501746,34.8929734,1061.6978285,411.67594,1276.8558825,19.2796906,36.8386046,1.9832068,94.1358401),(19086,'baisa_ulna.tif',241,4,16,239.9769863,84.7852029,67.1645501,1.8,84.5745598,67.2903702,1.285667,11.2024372,19.8843711,4999.3250197,22353.8811403,36.8316955,1124.1935195,446.2711918,1351.0730903,0.3515621,0.4971838,2.3561945,0.9943677),(19087,'baisa_ulna.tif',241,4,17,249.7637202,84.8725267,67.2876495,1.8,84.6206073,67.3122701,1.3086057,11.451052,20.5323742,5560.5025254,24164.1146129,38.830638,1176.8787388,485.5887951,1423.4890778,20.4120128,38.5517897,1.9936503,97.7720977),(19088,'baisa_ulna.tif',241,4,18,259.4576449,84.8967888,67.4971874,1.8,84.5670092,67.5296273,1.3268323,11.8470817,21.1040806,6096.5542944,25854.6697728,40.7198459,1225.1028756,514.603886,1496.1711183,20.5858811,39.3011163,1.9463194,99.298983),(19089,'baisa_ulna.tif',241,4,19,263.5365712,84.8940621,67.5876155,1.8,84.4983733,67.5372094,1.347199,12.1583214,21.2104701,6480.0098017,26937.1400377,41.7631637,1269.9925975,532.9691134,1556.8044009,20.7421616,39.6283898,1.9430657,99.5049232),(19090,'baisa_ulna.tif',241,4,20,262.2933839,84.8757122,67.7549389,1.8,84.4301998,67.529063,1.3583264,12.3695274,21.1340268,6541.5749756,27904.4808907,41.7716098,1320.3579798,528.8459916,1618.7686313,20.7421616,39.5878237,1.915015,101.6642651),(19091,'baisa_ulna.tif',241,4,21,260.0641636,84.8244631,68.0100196,1.8,84.3950454,67.594647,1.3570661,12.3398332,21.2422934,6338.9276519,28870.1648614,41.3940112,1359.088885,513.6963799,1646.2809427,20.3905995,39.9189393,1.912043,100.4992909),(19092,'baisa_ulna.tif',241,4,22,262.9097528,84.7818068,68.221105,1.8,84.3750416,67.7919034,1.3620959,12.2540235,21.6468901,6255.4937207,30358.2137361,41.9372982,1402.4284126,510.4848789,1682.8421729,20.0390375,40.5822022,1.8788491,101.9055392),(19093,'baisa_ulna.tif',241,4,23,264.2359366,84.7704148,68.605856,1.8,84.2872428,68.0131154,1.3692609,11.8995819,21.944876,6058.2446459,31730.9649328,42.2746854,1445.9395868,509.1140774,1712.7120598,19.6874754,41.2527781,1.8736812,103.6883342),(19094,'baisa_ulna.tif',241,4,24,266.4117485,84.7502177,69.0220251,1.8,84.2517556,68.2639083,1.370764,11.7197592,22.2266568,5826.0108502,33300.9339157,42.6488754,1498.2430429,497.1101157,1751.1317272,19.5845281,41.9244206,1.8686787,105.1798857),(19095,'baisa_ulna.tif',241,4,25,265.0930554,84.9056411,69.5405441,1.8,84.5005044,68.839536,1.3762731,11.3628168,30.496958,5483.7803209,34688.3266513,42.5313354,1137.4356291,482.6074727,1308.7387664,19.2330196,42.9826855,1.8356137,107.0833178),(19096,'baisa_ulna.tif',241,4,26,264.2887458,84.8890515,70.1835144,1.8,84.4977515,69.2956853,1.3765644,10.6686693,22.7713399,5085.7673665,36107.2670803,42.4071561,1585.6452565,476.70119,1800.8829093,19.8496637,43.6078691,1.8568478,144.5987437),(19097,'baisa_ulna.tif',241,4,27,263.9572467,84.9540041,70.9177098,1.8,84.571139,69.9920011,1.3795312,10.3072214,23.0671228,4802.8503969,37714.2733461,42.403041,1634.9795209,465.9694591,1835.5612614,18.0121069,44.431937,1.8349665,110.1017546),(19098,'baisa_ulna.tif',241,4,28,263.3074694,85.0601706,71.7561077,1.8,84.6411673,70.6680774,1.3825142,10.4838695,23.3191365,4503.6396052,39424.7542352,42.3471603,1690.6609826,429.5779903,1874.0982251,17.7685124,45.3937281,1.8533513,111.2167593),(19099,'baisa_ulna.tif',241,4,29,266.0642194,85.1317639,72.6228932,1.8,84.6978773,71.3947868,1.3809975,10.0270534,23.4937311,4254.3922725,41319.646562,42.7656953,1758.7520022,424.2913742,1931.1297597,17.225332,46.2207186,1.8323786,112.8289478),(19100,'baisa_ulna.tif',241,4,30,265.8583386,85.2337676,73.6822247,1.8,84.7994491,72.307392,1.3765097,9.8450766,23.5471424,3961.686162,42821.703109,42.6580903,1818.552009,402.4027782,1976.7759304,0.3515621,0.4971838,2.3561945,0.9943677),(19101,'baisa_ulna.tif',241,4,31,267.7780448,85.3198033,74.78196,1.8,84.937333,73.3746447,1.3697905,9.6153436,23.8457262,3689.9020052,44420.084126,42.8506404,1862.8111272,383.7514452,2009.9910715,0.3515621,0.4971838,2.3561945,0.9943677),(19102,'baisa_ulna.tif',241,4,32,271.6414648,85.4241305,75.9277264,1.8,85.0621721,74.6381405,1.3637667,9.4683885,24.3795689,3540.9300268,46405.1528589,43.3606609,1903.4443581,373.9738841,2042.5371705,15.058491,48.6186307,1.7894653,117.1329958),(19103,'baisa_ulna.tif',241,4,33,275.734099,85.6612086,77.1789212,1.8,85.4448337,75.9214825,1.3584359,9.2909703,25.2244246,3525.1612502,48240.7121518,43.9141895,1912.4603628,379.4179886,2028.7368454,16.3491422,49.6487289,1.784857,213.9460596),(19104,'baisa_ulna.tif',241,4,34,278.4685643,85.8264139,78.5840465,1.8,85.6735549,77.3474931,1.3494506,9.0237655,26.0780293,3503.685014,49291.4412425,44.1744436,1890.1520751,388.2730556,2019.3863677,2.3234642,20.6346266,1.973451,59.7534257),(19105,'baisa_ulna.tif',241,4,35,282.6892513,85.981089,79.9461928,1.8,85.8467376,78.925719,1.3426889,9.1216274,26.8212977,3547.295491,50675.1441612,44.7055742,1889.3621276,388.8884434,2017.6161099,15.1512045,51.3328765,1.8058085,174.435836),(19106,'baisa_ulna.tif',241,4,36,285.7604592,86.2132858,81.4582205,1.8,86.0818343,80.4101369,1.3353381,8.9911711,27.4848699,3592.3075919,51375.9677116,45.0347253,1869.245437,399.5372293,1991.5001836,2.7566049,22.666894,1.9858711,60.080003),(19107,'baisa_ulna.tif',241,4,37,290.6549685,86.4463326,82.9224384,1.8,86.3321925,81.9958689,1.3284872,9.2851014,27.9203508,3688.7619263,52333.90156,45.6534873,1874.3998605,397.2775059,1997.9108317,17.8867499,52.4405223,1.8076451,292.0099838),(19108,'baisa_ulna.tif',241,4,38,295.9139358,86.6576251,84.2387859,1.8,86.5357557,83.4018352,1.3230513,9.7285887,28.0429117,3820.850914,54672.7669707,46.3533341,1949.6109263,392.7446247,2081.3975684,2.5572045,24.6118553,1.9513027,71.9624455),(19109,'baisa_ulna.tif',241,4,39,301.398784,86.8892114,85.5481414,1.8,86.7193204,84.7857291,1.3198539,9.749577,27.834589,3999.4838422,57185.9695572,47.1356883,2054.4930475,410.2212667,2197.0058063,17.1135443,52.8805904,1.8399638,237.2283965),(19110,'baisa_ulna.tif',241,4,40,307.3445325,87.1371543,86.8543476,1.8,86.9481294,86.1118134,1.319291,10.8806262,28.0518922,4198.1310167,60514.5347374,48.0516581,2157.2353978,385.835424,2305.1549441,15.3540301,53.0719,1.8527356,182.8733255),(19111,'baisa_ulna.tif',241,4,41,320.2885045,87.4185335,88.063291,1.8,87.3549867,87.4245624,1.3202976,11.3758048,28.1058731,4607.4236213,64587.4213256,50.1012345,2298.0044456,405.0195752,2459.0994141,18.127315,53.0392862,1.8736812,321.5765307),(19112,'baisa_ulna.tif',241,4,42,334.9812834,87.6903999,89.3490729,1.8,87.6336242,88.7242378,1.3191464,10.6882978,28.3097601,5063.8002419,69480.9843878,52.3686225,2454.3120157,473.7705051,2633.0999177,0.7031241,0.9943677,2.3561945,1.9887353),(19113,'baisa_ulna.tif',241,4,43,355.0006328,88.0269484,90.8047668,1.8,87.9025905,89.9141086,1.3145338,10.243461,28.9434994,5707.5322259,75024.9295384,55.3655753,2592.1167443,557.1878722,2787.9615977,19.0084784,53.4802049,1.8779949,269.7013165),(19114,'baisa_ulna.tif',241,4,44,360.0690752,88.1878449,91.3171417,1.8,88.0372917,90.3740017,1.3121247,10.5260242,28.5480609,5975.2118181,74199.2522794,56.0848461,2599.0995483,567.6608472,2808.2078508,18.8102781,52.7038316,1.8756708,245.7304912),(19115,'baisa_ulna.tif',241,4,45,342.8823936,88.2146285,90.6262469,1.8,88.1941429,90.1938094,1.2948209,11.2367552,27.1081948,5594.6044449,65610.902802,52.9039892,2420.3346331,497.8843383,2625.6746794,2.6700851,21.2484296,1.8559141,49.6391425),(19116,'baisa_ulna.tif',241,4,46,317.986138,88.0342946,89.3276204,1.8,88.0761416,89.1765338,1.2746602,10.1367423,25.0174612,5276.6688678,53127.785649,48.4842561,2123.6281844,520.5487821,2331.7121173,0.3515621,0.4971838,2.3561945,0.9943677),(19117,'baisa_ulna.tif',241,4,47,301.7047026,87.9242689,88.4558605,1.8,88.0141696,88.3771855,1.2556433,10.3128226,23.2401045,5054.7739057,44445.7042584,45.4530004,1912.4571563,490.1445629,2122.1577324,0.3515621,0.4971838,2.3561945,0.9943677),(19118,'baisa_ulna.tif',241,4,48,288.2135004,87.8327458,87.8601606,1.8,87.927363,87.9177323,1.2383444,10.2807745,21.8417086,4876.688562,38283.7388293,42.9192204,1752.7813198,474.3503077,1972.6731667,0.3515621,0.7861167,2.0344439,1.6974918),(19119,'baisa_ulna.tif',241,4,49,275.682039,87.8632279,87.3596123,1.8,88.0736984,87.3712549,1.2183518,10.245339,20.6926007,4696.9091333,33026.5918869,40.4720395,1596.058047,458.4435069,1814.0242267,2.2398811,17.578103,1.8545904,50.5482069),(19120,'baisa_ulna.tif',241,4,50,264.2674723,87.8230767,87.0796297,1.8,88.091992,87.1788554,1.201687,10.3914416,19.6845231,4527.5858183,29038.6178614,38.311485,1475.2004773,435.7033401,1692.5723842,0.7031241,0.9943677,2.3561945,1.9887353),(19121,'baisa_ulna.tif',241,4,51,254.0123849,87.7952107,86.8628445,1.8,88.0764007,87.001133,1.1838594,10.332615,18.7760222,4350.51628,25777.4845122,36.3070181,1372.8938056,421.0469753,1591.231329,0.3515621,0.7861167,2.0344439,1.6974918),(19122,'baisa_ulna.tif',241,4,52,245.7245319,87.7261154,86.6606103,1.8,88.1411038,86.9599097,1.1655062,10.0753414,17.8688432,4236.6689408,22910.0317948,34.5873255,1282.1217067,420.4987974,1504.685133,1.6717769,5.2263458,1.9138203,12.5855666),(19123,'baisa_ulna.tif',241,4,53,241.2462036,87.6215818,86.4694351,1.8,88.0213923,86.8689266,1.1496693,9.9274399,17.5127064,4118.8611248,20718.4918661,33.4886465,1183.0548297,414.8966075,1386.109316,1.782312,5.5586843,1.8925469,14.2830584),(19124,'baisa_ulna.tif',241,4,54,232.6384995,87.611656,86.4303513,1.8,88.0640818,86.8910835,1.1280856,9.6931262,17.4424969,4010.793709,18499.1060731,31.6575112,1060.5767149,413.7771058,1269.4940231,0.9878952,3.9305833,2.0344439,8.6933992),(19125,'baisa_ulna.tif',241,4,55,226.1704648,87.6244015,86.4438829,1.8,88.0279389,86.8682808,1.1017783,9.991803,17.3086039,3939.362843,16889.1221518,29.9934607,975.7645544,394.2594583,1178.8527608,0.7682058,3.3352106,1.8925469,7.2018477),(19126,'baisa_ulna.tif',241,4,56,226.2844726,87.6902348,86.6316225,1.8,88.1172464,87.1693823,1.0751297,9.6587643,17.1847936,3960.0780931,16231.877608,29.1826786,944.5488858,409.9984193,1154.9284852,0.8095301,4.0084242,1.8370484,8.608096),(19127,'baisa_ulna.tif',241,4,57,225.8641343,87.9200535,86.9582415,1.8,88.4535302,87.5498051,1.0413123,10.7161674,16.9141262,4095.8863378,15800.0792128,28.0405065,934.1351146,382.2155995,1161.6422905,0.9682274,3.6704157,1.8622531,7.9049719),(19128,'baisa_ulna.tif',241,4,58,227.16676,88.0676497,87.3648051,1.8,88.6523037,88.0137846,1.0094948,10.6344538,16.6790331,4259.467933,15675.8368603,27.1338958,939.8528558,400.5347157,1169.2536276,1.4540543,7.8611667,1.7506498,17.7133758),(19129,'baisa_ulna.tif',241,4,59,233.3034828,88.2525759,87.9105,1.8,88.7810108,88.6153019,0.9804423,11.8030997,17.2357982,4589.2321367,16020.4723058,26.835151,929.4882715,388.8158407,1187.9329281,1.843122,8.963109,1.7681919,22.102727),(19130,'baisa_ulna.tif',241,4,60,246.7069319,88.4064448,88.5566315,1.8,88.7861683,89.2404513,0.9538616,13.5927978,17.2569081,5168.6914808,16633.1685032,27.3554453,963.8556571,380.2522166,1242.7738588,2.5556296,16.2328809,1.6575347,49.3478989),(19131,'baisa_ulna.tif',241,4,61,255.3915277,88.5137907,89.0089992,1.8,88.8326939,89.7410065,0.9134742,14.4763538,17.1693929,5680.156684,16916.1593047,26.6747963,985.2508729,392.3748179,1263.2364857,2.2245784,16.889621,1.5291537,40.8104705),(19132,'baisa_ulna.tif',241,4,62,242.4059825,87.9728548,88.5267241,1.8,88.1667279,89.1984728,0.8656817,16.1242022,17.0638669,5874.8333635,13446.5152767,23.4301142,788.0110254,364.3487786,1071.1932122,2.6642876,17.6657749,1.4711277,45.0791847),(19133,'baisa_ulna.tif',241,4,63,239.3358607,87.6501181,88.5898105,1.8,87.6549366,89.2176181,0.8258656,16.8973107,18.0668238,6381.1007983,11917.2959274,21.5571107,659.6231882,377.6400239,950.966055,0.3515621,0.4971838,2.3561945,0.9943677),(19134,'baisa_ulna.tif',241,4,64,228.3950034,87.1089355,88.6136088,1.8,86.9604917,89.0720627,0.8162551,17.7011671,16.9921264,6994.5061459,9785.1784953,20.2067683,575.86545,395.1437849,907.8322943,0.3515621,0.4971838,2.3561945,0.9943677),(19135,'baisa_ulna.tif',241,4,65,220.2673756,86.9918396,88.670702,1.8,86.6782322,89.2222799,0.6418168,17.5267619,19.7368774,6945.716716,8960.3953354,13.1567114,453.9925514,396.2920669,774.9932873,6.8956464,20.9585249,1.1747149,68.8587055),(19136,'baisa_ulna.tif',241,4,66,213.3438714,86.8551616,88.8179485,1.8,86.6584118,89.3833757,0.4722598,15.7787247,24.0692222,6713.9534847,8283.9486387,7.358014,344.1718465,425.5067251,618.1007187,22.5383867,38.3605602,0.0458394,203.8489232),(19137,'baisa_ulna.tif',241,4,67,206.4697306,86.7703824,88.9320393,1.8,86.8341189,89.5979298,0.3062916,13.9910598,25.7392662,6317.1167735,7919.3204992,3.1286105,307.6746802,451.5109564,552.8836639,22.2301911,41.206313,0.0597578,197.7620801),(19138,'baisa_ulna.tif',241,4,68,195.772507,86.9206134,88.8481567,1.8,87.3321771,89.4307173,0.3922593,14.7167564,26.0588151,5275.7706093,7289.3446417,4.7682278,279.7266346,358.4873233,481.7025901,0.3515621,0.4971838,2.3561945,0.9943677),(19139,'baisa_ulna.tif',241,4,69,185.0062194,86.9419408,88.796904,1.8,87.1945053,89.0966161,0.4668769,15.001244,22.1210741,4478.5036541,6330.6572946,6.2467245,286.1821832,298.5421514,469.1754871,0.3515621,0.4971838,2.3561945,0.9943677),(19140,'baisa_ulna.tif',241,4,70,176.3415488,87.0381169,88.8278979,1.8,87.5962107,88.9262427,0.5046263,15.3639057,24.1733364,3839.1498641,5860.4655941,6.8700687,242.435115,249.8811129,389.4798979,5.2734309,15.5325195,1.4801364,55.6906517),(19141,'baisa_ulna.tif',241,4,71,169.0533618,87.077248,88.9258652,1.8,87.6217368,89.0853692,0.5487006,23.5890057,21.0351658,3281.9526922,5419.658141,7.6650114,257.6475123,139.1306072,365.6059824,19.2455935,32.9081619,2.8265988,186.0855779),(19142,'baisa_ulna.tif',241,4,72,161.5991069,87.1637523,89.0428415,1.8,87.8676772,89.2228254,0.5902662,27.1046295,20.2292269,2842.1419529,5025.1124623,8.3434632,248.4085274,104.8581738,290.2077447,0.3515621,0.4971838,2.3561945,0.9943677),(19143,'baisa_ulna.tif',241,4,73,153.6291575,87.3032327,89.0833319,1.8,87.8185016,89.2903842,0.6121271,22.9905301,20.2911051,2443.1303861,4697.648897,8.4541168,231.5127186,106.2668141,270.7344774,17.578103,32.3914409,3.0872982,178.4072444),(19144,'baisa_ulna.tif',241,4,74,145.1702553,87.3059996,89.1594182,1.8,87.4530258,89.3186605,0.7036861,12.5238494,17.0566397,1994.4920701,4202.8843615,10.1292834,246.4075247,159.2555142,312.2828021,0.6292499,1.267575,2.5535901,2.4859192),(19145,'baisa_ulna.tif',241,4,75,139.6113994,87.2640506,89.2903291,1.8,87.4173407,89.465678,0.7433155,12.2947869,16.8424556,1723.6038167,3959.0766777,10.6562352,235.0652879,140.1898077,281.1456705,17.578103,31.0092884,3.0735162,179.7574608),(19146,'baisa_ulna.tif',241,4,76,135.6453574,87.2502163,89.4675634,1.8,87.6208537,89.5994669,0.7836281,12.2554267,15.017062,1490.4934756,3784.9963332,11.2637619,252.0463946,121.6190603,290.2251343,0.4971838,0.9943677,2.3561945,1.9887353),(19147,'baisa_ulna.tif',241,4,77,133.4968115,87.261873,89.7027308,1.8,87.612521,89.8854663,0.8037494,11.8117622,14.8654149,1355.9228333,3754.3458744,11.5329486,252.5557414,114.7942883,272.3713383,0.3515621,0.4971838,2.3561945,0.9943677),(19148,'baisa_ulna.tif',241,4,78,130.1895355,87.2362829,89.8866612,1.8,87.7443094,90.036982,0.825963,15.0691805,14.0331572,1207.8632091,3603.7840007,11.7283489,256.8049337,80.1545383,267.0410649,17.5141547,29.2135169,3.0934371,167.4131682),(19149,'baisa_ulna.tif',241,4,79,125.6576865,87.1280671,90.0209503,1.8,87.6179878,90.1392663,0.8500157,13.4762882,16.3071585,1044.5490501,3393.0988169,11.8209908,208.0741918,77.5101451,211.487382,15.8139617,27.2545639,3.0252375,161.4469622),(19150,'baisa_ulna.tif',241,4,80,119.8929872,86.984192,90.1101043,1.8,87.4087166,90.2538677,0.8698447,23.1084486,19.6424263,890.8784431,3135.2519105,11.6704968,159.6163259,38.5520664,160.8366601,5.0920476,16.221456,2.0926306,49.5684749),(19151,'baisa_ulna.tif',241,4,81,114.9572793,86.9783507,90.2075523,1.8,87.5457685,90.3209695,0.8701696,23.4447093,13.4482435,828.9546356,2961.4829308,11.1961848,220.2133636,35.3578552,157.777069,15.5089928,25.9537581,2.9920329,132.5189343),(19152,'baisa_ulna.tif',241,4,82,109.7859527,86.8679169,90.3878818,1.8,87.4172817,90.5965993,0.8872597,14.0800998,12.1738296,712.6152381,2781.9161172,10.999791,228.5161042,50.6115191,221.8707653,15.0641215,24.3493213,2.8335399,141.9154576),(19153,'baisa_ulna.tif',241,4,83,107.5310394,86.7670086,90.6812356,1.8,87.1834068,91.2012318,0.9015946,11.9968737,12.137581,708.7056118,2724.5789441,11.0246802,224.4746248,59.0741914,216.4634929,16.1459959,24.4834644,2.8652654,147.8316941),(19154,'baisa_ulna.tif',241,4,84,102.7935344,86.6380809,90.8160406,1.8,87.182293,91.3078452,0.9191134,11.7039216,11.8472149,606.3144016,2538.8776403,10.8297626,214.3016445,51.80438,199.6619922,5.0817994,17.1690471,2.3127436,54.3697067),(19155,'baisa_ulna.tif',241,4,85,98.73311,86.5307611,90.9481094,1.8,87.0582144,91.3585444,0.9282063,9.8759164,11.2298608,529.2616963,2368.5677456,10.5459212,210.9169284,53.5911478,204.9915277,4.9339743,17.0860608,2.2101822,55.6906517),(19156,'baisa_ulna.tif',241,4,86,95.8154981,86.4667632,91.1496677,1.8,86.9005421,91.5851295,0.9283332,10.2670444,11.1058464,478.3077135,2287.4395717,10.2362284,205.967154,46.5866998,202.433997,14.3727499,22.17072,2.885076,149.1173054),(19157,'baisa_ulna.tif',241,4,87,93.7982635,86.4312894,91.381187,1.8,86.7658083,91.6971591,0.9344479,9.9046223,10.6829374,428.8373052,2258.2283679,10.1122659,211.3864638,43.2966843,202.1591952,0.3515621,0.4971838,2.3561945,0.9943677),(19158,'baisa_ulna.tif',241,4,88,91.883164,86.405284,91.6326373,1.8,86.6725028,91.8961141,0.9352643,8.7532306,10.3551013,393.7760917,2229.7490322,9.9177492,215.3285583,44.9863723,203.2522612,5.0237579,15.7105371,2.2769954,51.7631505),(19159,'baisa_ulna.tif',241,4,89,90.4618114,86.483107,91.8869521,1.8,86.8231103,92.3247566,0.9290648,9.2770946,10.2923009,406.2753513,2240.9058191,9.674859,217.7264184,43.7933825,211.35108,0.3515621,0.4971838,2.3561945,0.9943677),(19160,'baisa_ulna.tif',241,4,90,89.1305714,86.5441274,92.1823517,1.8,86.9746533,92.7019878,0.9216607,9.4876029,10.7818618,400.4391445,2236.3912193,9.4267775,207.4216179,42.2065668,191.9395307,5.6147677,16.388223,2.1885521,52.3809714),(19161,'baisa_ulna.tif',241,4,91,87.553413,86.5728833,92.4221451,1.8,86.9434108,92.8299141,0.9141182,9.1373704,10.6151282,384.9799965,2202.9625601,9.1537514,207.5304722,42.1324715,205.3070317,5.3267849,16.388223,2.1885521,43.4816319),(19162,'baisa_ulna.tif',241,4,92,85.7172651,86.5629965,92.660461,1.8,86.8912476,93.1293094,0.9139759,8.7053087,10.5843147,362.5138269,2140.2719354,8.9598153,202.2116694,41.6428459,191.033148,14.4421664,22.0673464,2.6066376,132.7248746),(19163,'baisa_ulna.tif',241,4,93,82.8332113,86.473,92.7985914,1.8,86.825144,93.1933949,0.9213737,9.6178429,10.3261152,331.8430717,1990.9193608,8.7569286,192.8042945,34.5028585,177.852796,4.5833716,16.102924,2.2011977,52.1396974),(19164,'baisa_ulna.tif',241,4,94,79.8833147,86.3486849,92.9147679,1.8,86.7118773,93.267879,0.934956,9.1980877,9.7904182,306.5170906,1824.2388083,8.6185794,186.3289968,33.3240019,174.3184189,0.3515621,0.4971838,2.3561945,0.9943677),(19165,'baisa_ulna.tif',241,4,95,76.1219549,86.1504685,92.9882582,1.8,86.4056203,93.3570411,0.9525561,9.7236929,9.4416194,278.337359,1629.4313395,8.4249436,172.5796457,28.6246555,170.9867886,0.3515621,0.4971838,2.3561945,0.9943677),(19166,'baisa_ulna.tif',241,4,96,71.5995441,85.8941902,93.0311998,1.8,86.0960969,93.4252507,0.9893011,9.6360274,9.0900301,242.3139053,1423.2866179,8.3329701,156.576667,25.1466601,155.1458175,0.4971838,0.9943677,2.3561945,1.9887353),(19167,'baisa_ulna.tif',241,4,97,67.7983715,85.8061107,93.1253789,1.8,86.1925723,93.5282459,1.010418,7.6792078,8.9708611,226.4815095,1275.7124492,8.1075625,142.2062421,29.4928222,140.3656362,3.948125,13.4561498,2.1515527,47.5797396),(19168,'baisa_ulna.tif',241,4,98,65.2189254,85.7039608,93.2644681,1.8,86.1294496,93.6522267,1.0222997,9.1680725,9.5368445,215.1183322,1170.8909367,7.9147173,122.7755092,23.4638558,116.9543128,0.4971838,0.9943677,2.3561945,1.9887353),(19169,'baisa_ulna.tif',241,4,99,63.4326278,85.6621102,93.463066,1.8,86.1884606,93.8847651,1.0254972,8.7162478,9.4744391,205.2102211,1102.7263229,7.7279703,116.3896149,23.543413,115.7170309,3.6532802,13.3639833,2.1879877,37.2741518),(19170,'baisa_ulna.tif',241,4,100,62.3543474,85.5950437,93.688514,1.8,85.85689,94.1354122,1.0369182,7.346073,9.797228,198.1130413,1050.6064819,7.7012363,107.2350754,26.9685642,109.3846511,4.3419026,13.4561498,2.1515527,43.9788157),(19171,'baisa_ulna.tif',241,4,101,61.1474898,85.5557863,93.9058351,1.8,85.8429981,94.3189288,1.0381453,7.6286367,9.9256095,190.7744208,997.0382371,7.5631293,100.4510841,25.0076689,97.7753765,4.5063877,13.2665194,2.1293956,46.0528543),(19172,'baisa_ulna.tif',241,4,102,59.3225029,85.4893949,94.0973439,1.8,85.7293219,94.4758728,1.0503213,8.2656956,8.1509708,175.5254969,918.1745343,7.4420114,112.6460342,21.2354175,106.7965896,3.7934415,12.1886115,2.1507991,35.0295067),(19173,'baisa_ulna.tif',241,4,103,57.9057196,85.4523558,94.3091917,1.8,85.694801,94.6154947,1.0515643,7.2193322,9.2859633,164.906815,857.2787682,7.2746192,92.3198531,22.8423919,86.9047491,3.2548777,11.7023176,2.1421338,32.0963732),(19174,'baisa_ulna.tif',241,4,104,56.5768766,85.4079654,94.5499996,1.8,85.5535419,94.8607918,1.0596504,8.3219299,7.5174864,158.6243894,797.3411607,7.1730602,106.0648629,19.06101,114.019974,0.3515621,0.4971838,2.3561945,0.9943677),(19175,'baisa_ulna.tif',241,4,105,55.0449244,85.4298694,94.7413276,1.8,85.6730921,94.990877,1.0576233,7.155207,7.9747141,160.3671126,750.8155162,6.9629442,94.1495219,22.4126448,95.7607162,3.2138105,11.1672846,2.0626055,29.9016976),(19176,'baisa_ulna.tif',241,4,106,53.9379547,85.4160469,95.0321296,1.8,85.6557826,95.4469244,1.0584034,6.9049887,8.5091668,160.5341292,717.7547776,6.8289131,84.3507707,23.2490068,87.5509206,3.4430602,11.4783801,2.0481417,37.3094856),(19177,'baisa_ulna.tif',241,4,107,52.9969406,85.3944601,95.292394,1.8,85.5902151,95.6918447,1.0581754,7.1035719,7.7198923,160.124856,684.4507497,6.708053,88.6606601,22.5414562,83.2204463,9.7498039,14.6352883,1.9914597,66.7493331),(19178,'baisa_ulna.tif',241,4,108,51.8902706,85.3760747,95.5408572,1.8,85.5380064,95.9230511,1.0546565,6.9692236,8.1062861,153.0961032,652.1667762,6.5419066,80.4519807,21.9674545,81.8868253,3.4565622,11.6387752,2.0074235,33.9498358),(19179,'baisa_ulna.tif',241,4,109,51.0739385,85.3705558,95.8113749,1.8,85.5233306,96.1405048,1.0536389,6.9084836,7.9215789,146.1939283,627.2779756,6.4315495,79.1859786,21.1615076,75.5648918,3.7683329,11.3375358,2.0899424,31.0167023),(19180,'baisa_ulna.tif',241,4,110,50.3461834,85.3785074,96.0882403,1.8,85.5809416,96.394885,1.0515796,6.5719613,7.3416989,140.6605504,604.1117198,6.3250354,82.2850039,21.4031314,78.6222424,3.559272,9.8500136,2.1785983,25.9242269),(19181,'baisa_ulna.tif',241,4,111,49.6237842,85.3664023,96.361232,1.8,85.503835,96.6795667,1.050676,6.5597738,7.2022097,132.9331348,584.195092,6.2278371,81.1133136,20.2648961,82.5316919,3.3040084,11.3211718,2.0205559,29.4398475),(19182,'baisa_ulna.tif',241,4,112,49.0667788,85.3795932,96.669756,1.8,85.5210896,96.9835068,1.0434981,6.1610371,6.9636604,129.0133872,571.0689659,6.1070916,82.0070097,20.9402063,81.9245187,2.9893835,10.5527196,2.0940746,26.627351),(19183,'baisa_ulna.tif',241,4,113,48.7193246,85.461348,96.9773918,1.8,85.6802597,97.3385817,1.0339135,7.2331574,7.7835035,138.0981616,570.3100866,5.9957966,73.2716423,19.0923761,68.6034569,0.3515621,0.4971838,2.3561945,0.9943677),(19184,'baisa_ulna.tif',241,4,114,48.2853532,85.503346,97.3020841,1.8,85.7702787,97.6104022,1.0266758,6.2622088,7.4696777,135.084717,569.8014299,5.8909907,76.2819298,21.571417,73.1974169,3.1489273,11.6440836,2.0749623,31.9257667),(19185,'baisa_ulna.tif',241,4,115,48.3454283,85.5695242,97.7170195,1.8,85.9504134,98.2584457,1.0205045,7.0708987,9.7201316,138.7830809,593.1404826,5.8541313,61.0218569,19.627361,60.8925296,3.7597926,11.2334944,1.9222411,34.4116859),(19186,'baisa_ulna.tif',241,4,116,48.3087615,85.6333953,98.092799,1.8,86.0481625,98.6127395,1.0174022,6.884783,9.2039859,135.2587366,609.2782911,5.8273889,66.1972211,19.646042,64.7757645,3.7768318,9.9498895,2.1293956,29.8163943),(19187,'baisa_ulna.tif',241,4,117,48.5838185,85.7077214,98.5002665,1.8,86.0870311,99.0143745,1.0217903,6.7920382,8.2863537,129.7231243,640.9111983,5.8922735,77.3453826,19.0992926,73.3866247,8.8927107,15.2636247,2.0756577,68.2408846),(19188,'baisa_ulna.tif',241,4,118,48.8103735,85.7741622,98.9323841,1.8,86.0190261,99.5042731,1.0383991,6.7051421,8.631258,120.2896206,686.8290391,6.0389982,79.5746157,17.9399061,85.5307516,3.3031159,11.8179248,1.9678758,33.9998053),(19189,'baisa_ulna.tif',241,4,119,49.2249815,85.8857204,99.3684536,1.8,86.1721873,99.8814276,1.0432115,6.6831754,8.3800082,115.9585756,746.6718088,6.1247372,89.1015603,17.3508203,85.6777204,8.6733089,16.221456,2.0926306,73.9158471),(19190,'baisa_ulna.tif',241,4,120,50.1415761,86.0027881,99.8427823,1.8,86.2800537,100.3703457,1.0474709,7.4553811,8.6975472,115.763636,826.1695583,6.2696753,94.9887982,15.5275275,87.2210108,8.3214915,16.7019731,2.1003859,77.5167709),(19191,'baisa_ulna.tif',241,4,121,49.7265561,86.1332045,100.1036717,1.8,86.6957444,100.7204079,1.0275632,7.8279774,8.5162706,127.4410751,824.196755,6.0733343,96.7790705,16.2802048,84.3784399,3.8069091,11.9995501,2.1262901,32.7994973),(19192,'baisa_ulna.tif',241,4,122,49.5658065,86.188749,100.4571031,1.8,86.6757427,100.9312703,1.0341413,7.1650965,8.1907571,123.2550573,844.3961241,6.1016254,103.0913394,17.202149,90.8718459,8.7283137,16.3580282,2.0632821,68.1555813),(19193,'baisa_ulna.tif',241,4,123,49.6734473,86.3169416,100.8356703,1.8,86.9933036,101.1908205,1.0249882,7.7295072,8.5760145,120.7503536,892.1427785,6.0479561,104.0276673,15.6219989,93.3252397,8.4921966,16.8346476,2.0718097,72.9214794),(19194,'baisa_ulna.tif',241,4,124,49.5485406,86.3853617,101.1603785,1.8,86.9799976,101.3755176,1.0201249,8.037095,8.4429869,113.5086997,915.2160934,5.997021,108.3995637,14.1231004,91.124721,2.89286,9.3610619,2.1692152,24.8092222),(19195,'baisa_ulna.tif',241,4,125,49.150824,86.4115881,101.405958,1.8,87.0112105,101.6341947,1.0128589,7.9009192,8.4028197,111.8704723,911.6405302,5.8956079,108.4922159,14.1591718,90.6715327,2.5349125,8.2373624,2.2655346,19.6314436),(19196,'baisa_ulna.tif',241,4,126,49.198914,86.4511352,101.7047143,1.8,87.0243477,101.9851359,1.0112232,7.8261751,8.4262644,113.3077969,924.531341,5.889318,109.720191,14.4780555,92.1518459,8.0189203,16.8823015,2.1183586,71.4299279),(19197,'baisa_ulna.tif',241,4,127,48.2067762,86.4488749,101.9112638,1.8,86.943321,102.1426893,1.0104728,7.4471398,8.2523031,102.0389675,892.5837507,5.7651287,108.1617754,13.701766,90.7468008,3.0964524,8.7890515,2.2142974,22.323303),(19198,'baisa_ulna.tif',241,4,128,46.9432517,86.4347196,102.0795296,1.8,86.6293636,102.0595603,1.0120295,6.1890221,8.3037426,84.7939227,856.821989,5.6249791,103.185037,13.7006979,113.3424017,3.0147718,9.0727536,2.1910458,24.5179787),(19199,'baisa_ulna.tif',241,4,129,47.2757621,86.5988593,102.3967313,1.8,86.8632404,102.3624281,1.0054944,7.2945455,8.2463331,96.3365892,879.9993772,5.6183836,106.7140229,13.206661,107.5591995,0.3515621,0.4971838,2.3561945,0.9943677),(19200,'baisa_ulna.tif',241,4,130,46.5591682,86.5790642,102.591882,1.8,86.6788369,102.8035105,1.0009889,6.4282388,8.0928153,101.4879614,847.0386175,5.5015262,104.6655077,15.7878332,116.580659,9.2809903,16.6760528,2.176341,68.4468249),(19201,'baisa_ulna.tif',241,4,131,45.3033591,86.5926475,102.7414935,1.8,86.6893448,102.9977745,0.98915,7.0533929,7.9613183,96.1156697,804.7475199,5.2714937,101.0821942,13.6268703,112.340389,2.5178879,8.2971626,2.2058231,18.9283195),(19202,'baisa_ulna.tif',241,4,132,46.0790543,86.7329787,103.0860377,1.8,87.2924775,103.4414043,0.9721597,8.4322289,8.075347,119.6809156,816.7166483,5.2410998,101.1370341,14.1932717,81.1923264,2.6041071,9.4986838,2.2513176,22.8204869),(19203,'baisa_ulna.tif',241,4,133,45.2539956,86.737155,103.3238966,1.8,87.2103368,103.5813281,0.9799642,8.4259227,7.9127734,111.0375505,769.8455937,5.2018925,97.2915002,13.1780879,76.6688576,9.4378565,15.9912439,2.1527014,75.116155),(19204,'baisa_ulna.tif',241,4,134,44.5439186,86.7471083,103.5302427,1.8,87.2411593,103.8572231,0.9761241,8.3062651,7.9968831,107.6444512,739.8605149,5.0938507,92.5186113,12.9594289,73.6755953,8.8086066,16.102924,2.2011977,71.3446246),(19205,'baisa_ulna.tif',241,4,135,43.519496,86.7133345,103.6974021,1.8,87.1184744,104.0252945,0.9817034,7.5945781,7.9169015,100.3364518,695.9303124,5.0141769,87.9043788,13.2115899,75.5908745,9.2457074,15.8202927,2.2142974,68.7380684),(19206,'baisa_ulna.tif',241,4,136,42.1441734,86.672498,103.7552115,1.8,87.1186269,103.9999813,0.9739546,7.8955676,7.6544795,91.8948637,631.4029234,4.8052706,82.4880289,11.6387913,66.6856304,8.4930891,15.3282671,2.2097103,61.742161),(19207,'baisa_ulna.tif',241,4,137,40.816042,86.750367,103.8721493,1.8,87.437759,104.2193952,0.9420399,7.9960203,7.6017965,101.9240732,586.3357187,4.4495744,77.1312047,12.7468502,64.0151599,8.4930891,15.5046442,2.146221,63.5602898),(19208,'baisa_ulna.tif',241,4,138,39.6807202,86.7691535,104.0389525,1.8,87.4301049,104.4292936,0.9308797,8.223915,7.9043021,99.3651281,545.428413,4.2553435,69.0039938,12.0824606,56.5280569,9.2260215,15.2109004,2.1587989,66.8346364),(19209,'baisa_ulna.tif',241,4,139,38.6639756,86.77978,104.1690759,1.8,87.3787299,104.364704,0.9207036,7.6536496,7.4519914,92.3641419,504.4589651,4.0833031,67.6945176,12.0679868,55.8705275,11.4165224,16.7905392,2.7999772,102.7378737),(19210,'baisa_ulna.tif',241,4,140,37.912213,86.7648131,104.3278406,1.8,87.3198774,104.5137699,0.9222759,7.7053389,7.344338,91.5869715,474.1955012,4.0134784,64.5661322,11.8861704,54.9484429,9.1721485,14.2761903,2.2339993,64.5546575),(19211,'baisa_ulna.tif',241,4,141,36.8316853,86.765733,104.4616723,1.8,87.4307037,104.6706517,0.9114502,7.7747136,7.2998329,85.2912675,444.4825543,3.8349215,60.8894151,10.9703421,49.6759121,8.8433146,14.2761903,2.2339993,59.9593659),(19212,'baisa_ulna.tif',241,4,142,35.3926547,86.724325,104.5292522,1.8,87.3074995,104.7489985,0.8968407,7.1923781,6.993207,78.2700851,406.675566,3.601333,58.1529431,10.8823652,48.4971732,10.372951,15.8865601,2.7076393,93.0854406),(19213,'baisa_ulna.tif',241,4,143,33.8749722,86.6780114,104.6462016,1.8,87.1287033,104.865376,0.9037517,6.5790434,6.7792274,67.8267103,365.6487393,3.4848958,53.9366384,10.3095094,46.2509545,8.6789363,13.4607416,2.2822555,60.3712465),(19214,'baisa_ulna.tif',241,4,144,32.9871792,86.7003405,104.8020327,1.8,87.2015479,105.0173682,0.8953908,7.0971852,6.6970927,63.252961,349.0999574,3.3487902,52.1270908,8.912401,42.7277177,10.0553989,15.100808,2.7091849,88.5401185),(19215,'baisa_ulna.tif',241,4,145,31.8744417,86.7666179,104.842846,1.8,87.4213889,105.0204048,0.8681928,7.078577,6.7238557,66.235945,328.3721031,3.0940351,48.8368752,9.3572402,41.1828983,2.341096,5.5586843,2.176341,13.7505408),(19216,'baisa_ulna.tif',241,4,146,30.7206555,86.7467031,104.9492526,1.8,87.3275447,105.1441446,0.8582928,6.9234775,6.5270163,60.834302,307.3838018,2.9319623,47.0940761,8.7866686,42.9610312,2.2461784,6.0485024,2.1910458,13.9564811),(19217,'baisa_ulna.tif',241,4,147,30.1175075,86.7543419,105.0727943,1.8,87.4300517,105.1857113,0.8453698,7.9229403,7.0845449,62.0313425,293.9484294,2.8101037,41.4915051,7.8293336,33.4931313,2.3964733,5.5586843,2.176341,14.9508488),(19218,'baisa_ulna.tif',241,4,148,28.8894888,86.6923477,105.119948,1.8,87.3241784,105.3052161,0.8354351,7.1724995,6.9585462,56.7341121,271.2300914,2.6479792,38.9779827,7.90995,32.8183974,8.8592758,12.7001034,2.4149503,52.2956682),(19219,'baisa_ulna.tif',241,4,149,27.7138673,86.6296579,105.1345905,1.8,87.2213079,105.3199055,0.8238625,5.8767216,6.3946224,49.926761,249.5994868,2.4869797,39.0327168,8.4956825,34.5442168,7.9549413,12.7001034,2.4149503,52.3809714),(19220,'baisa_ulna.tif',241,4,150,26.8783216,86.6365227,105.2209778,1.8,87.2836361,105.3937608,0.8151794,7.3713638,6.3735106,48.5583432,233.8167912,2.373193,36.6857146,6.58743,31.4037369,2.0322343,4.781761,2.1995926,12.2589893),(19221,'baisa_ulna.tif',241,4,151,26.5666353,86.6093187,105.3434112,1.8,87.1845841,105.496687,0.8303881,5.5550412,5.98179,45.0112683,222.2069749,2.4128228,37.1472375,8.1027785,33.3861983,1.9001865,4.5021911,2.2455373,11.6765022),(19222,'baisa_ulna.tif',241,4,152,25.7719887,86.5631779,105.3785233,1.8,87.1339243,105.5169579,0.829803,5.6094364,5.9901406,41.2884363,208.7704404,2.3381487,34.8523436,7.3605321,31.0778433,3.0748311,6.8261005,2.1730837,18.6370759),(19223,'baisa_ulna.tif',241,4,153,25.0447955,86.6204257,105.4019448,1.8,87.2932077,105.5786118,0.7998781,5.9078476,6.336472,44.2659385,199.2496285,2.1474991,31.4448842,7.4927354,29.2092033,8.4374895,13.9078236,2.7798634,68.3615216),(19224,'baisa_ulna.tif',241,4,154,24.4359921,86.6495515,105.4738175,1.8,87.4175554,105.6798361,0.7798801,6.3123525,6.8749595,43.3636399,191.9275878,2.0138601,27.9169044,6.869648,25.2098103,7.7045309,11.9427655,2.3145519,48.2828637),(19225,'baisa_ulna.tif',241,4,155,23.9390617,86.6386472,105.5253849,1.8,87.4519612,105.7439725,0.7682301,6.2764939,6.9200398,41.1677231,186.5194768,1.9264374,26.9535264,6.5590318,24.371258,2.8325037,6.2593845,2.2367656,16.1511567),(19226,'baisa_ulna.tif',241,4,156,23.5143413,86.608185,105.5806443,1.8,87.4098986,105.7630699,0.7629668,7.5380481,7.2132171,39.906859,178.8573597,1.8716481,24.7957821,5.2940574,20.9679874,7.3207375,11.7075973,2.2924512,47.5797396),(19227,'baisa_ulna.tif',241,4,157,23.1456885,86.5645224,105.6374668,1.8,87.2875098,105.8431082,0.7659268,6.1586792,6.4034374,37.3644765,170.6376748,1.8537133,26.6478243,6.0669626,23.8788908,7.5461051,11.7075973,2.4199378,47.3737993),(19228,'baisa_ulna.tif',241,4,158,22.4722782,86.5310006,105.618933,1.8,87.4155157,105.7826803,0.7434668,6.2449469,7.0892533,36.4866916,158.1909723,1.7158249,22.3141938,5.8425944,20.6060757,2.4402185,6.8261005,2.1730837,18.5517727),(19229,'baisa_ulna.tif',241,4,159,21.4303275,86.4511062,105.5929479,1.8,87.2281157,105.7412242,0.7511275,5.8547478,6.6034076,32.267201,140.6028619,1.6635513,21.2924707,5.511288,19.5883691,0.3515621,0.4971838,2.3561945,0.9943677),(19230,'baisa_ulna.tif',241,4,160,21.0885287,86.4232198,105.6407123,1.8,87.1581658,105.8047081,0.7556277,5.456128,6.5497371,30.4106938,134.127518,1.6528032,20.4783056,5.5736767,19.3230847,2.3073696,5.8511588,2.1421338,13.6652376),(19231,'baisa_ulna.tif',241,4,161,20.055005,86.4359217,105.5371182,1.8,87.3953696,105.6713755,0.6972721,5.5015117,6.9564813,31.3600073,119.9392368,1.3782118,17.2413656,5.7002528,17.1115655,1.9521967,4.781761,2.1995926,10.9733781),(19232,'baisa_ulna.tif',241,4,162,19.2821562,86.3689292,105.5097002,1.8,87.3085251,105.632559,0.6797759,6.071413,7.446069,30.2944603,110.6101365,1.2699277,14.8548363,4.9896886,14.6659498,2.3073696,4.781761,2.1995926,11.1793184),(19233,'baisa_ulna.tif',241,4,163,19.0868372,86.3288659,105.5336964,1.8,87.2390128,105.6848956,0.6650632,5.5709094,7.2149828,30.9128705,106.8261113,1.2114522,14.8061492,5.548981,15.3914826,6.9924844,9.7744369,2.483704,38.9216741),(19234,'baisa_ulna.tif',241,4,164,18.8304319,86.2844999,105.5393661,1.8,87.1712479,105.7295992,0.6678653,5.4046984,6.737688,28.8876806,103.5268886,1.2037245,15.3653431,5.34492,15.3301141,6.7119818,9.7744369,2.483704,36.4004212),(19235,'baisa_ulna.tif',241,4,165,18.36485,86.2469026,105.5137791,1.8,87.1370346,105.6467305,0.6662437,4.7450511,6.6736111,27.0644932,98.2306041,1.1691374,14.719258,5.7037306,15.664165,6.7119818,9.3610619,2.5431738,36.1944809),(19236,'baisa_ulna.tif',241,4,166,17.9631634,86.1736361,105.4612177,1.8,87.0595503,105.6100178,0.6565903,5.2702988,7.4267775,25.3503125,93.664266,1.1155489,12.6116968,4.8100333,13.0688172,2.2373273,4.781761,2.1995926,12.8414764),(19237,'baisa_ulna.tif',241,4,167,17.7011401,86.1466723,105.4434638,1.8,87.1009902,105.5977229,0.6197849,5.2808287,7.9341134,24.8957471,92.7176351,0.9953895,11.6859478,4.7143637,12.3990308,2.2023748,4.5021911,2.2455373,11.5558652),(19238,'baisa_ulna.tif',241,4,168,17.5109897,86.1312942,105.4207401,1.8,87.091967,105.5318993,0.6171327,5.3716192,8.2602787,23.8215862,91.2603245,0.9773838,11.0480926,4.4347124,11.6795913,2.2373273,4.2333678,2.2974387,11.7618055),(19239,'baisa_ulna.tif',241,4,169,17.2654833,86.2940962,105.3298387,1.8,87.7360822,105.5176733,0.4965121,4.4644466,8.7467772,26.1272988,100.1707461,0.6529819,11.4523034,5.852304,13.0274619,6.3281171,9.0727536,2.5213432,33.9998053),(19240,'baisa_ulna.tif',241,4,170,16.7587402,86.2605726,105.2411172,1.8,87.7653517,105.4713791,0.4669951,4.0408889,8.780598,24.4581876,97.4885354,0.5661234,11.1027216,6.0526751,12.9586673,3.9774707,9.0727536,2.5213432,21.2436321),(19241,'baisa_ulna.tif',241,4,171,16.3285142,86.2746134,105.1312373,1.8,88.0910154,105.3175563,0.3923233,4.1817306,9.8778269,24.2810879,101.6131344,0.3978197,10.2869928,5.8064687,12.073015,3.9700519,8.7890515,2.4980915,20.4552047),(19242,'baisa_ulna.tif',241,4,172,15.9813596,86.2068145,105.073127,1.8,87.9275717,105.30899,0.3842612,3.8620286,10.3150092,23.0102306,98.8960752,0.374312,9.5875896,5.9580684,11.235539,0.7031241,0.9943677,2.3561945,1.9887353),(19243,'baisa_ulna.tif',241,4,173,15.8946552,86.2530037,104.988566,1.8,88.2766724,105.1955966,0.3377178,3.9968569,11.1082538,22.7968678,107.5629449,0.2908263,9.6831552,5.7036987,11.3244811,4.1065089,8.3860633,2.5652174,19.9580209),(19244,'baisa_ulna.tif',241,4,174,15.7501604,86.1980476,104.923699,1.8,88.2275097,105.1694991,0.3374095,3.3583467,11.1825154,21.5682255,105.3127436,0.2876767,9.4176257,6.4222748,10.9654417,4.1065089,8.2971626,2.5065659,19.6667773),(19245,'baisa_ulna.tif',241,4,175,15.4105713,86.0732096,104.8620491,1.8,87.8915553,105.1087351,0.3599774,4.1555166,10.2640451,20.2878696,91.8458796,0.3186963,8.9483122,4.8821534,10.2327271,0.4971838,0.9943677,2.3561945,1.9887353),(19246,'baisa_ulna.tif',241,4,176,15.2399716,86.0138295,104.7646465,1.8,87.7733278,104.99459,0.36829,3.3930344,10.5319713,19.0655296,88.3853165,0.3292211,8.3920962,5.6190205,9.7330718,0.3515621,0.7861167,2.0344439,1.6974918),(19247,'baisa_ulna.tif',241,4,177,15.0542407,86.1797836,104.6549482,1.8,88.2263649,104.9304729,0.3001335,3.6378006,11.2785099,19.339457,101.7277457,0.2193091,9.0196087,5.3162499,10.4520705,3.9774707,7.9003747,2.5782764,18.7577129),(19248,'baisa_ulna.tif',241,4,178,14.7302322,86.157343,104.5418525,1.8,88.383105,104.7292298,0.2496414,3.7793238,17.1514343,19.6955319,108.6127242,0.1498479,6.3325738,5.2113904,7.3056473,3.9774707,8.0935664,2.5415424,18.9636532),(19249,'baisa_ulna.tif',241,4,179,14.6426664,86.1977319,104.447334,1.8,88.6864674,104.6815537,0.2290237,3.3468302,15.8382991,19.0919179,117.6351332,0.1257834,7.427258,5.7044775,8.4814349,3.9774707,7.9003747,2.5782764,18.7577129),(19250,'baisa_ulna.tif',241,4,180,14.6429285,86.1806313,104.3655506,1.8,88.746016,104.6380154,0.2202032,2.9990386,16.2418079,18.8462019,124.3271521,0.1164375,7.6547607,6.2840812,8.6810553,3.7288788,8.0245532,2.6387494,18.5517727),(19251,'baisa_ulna.tif',241,4,181,14.6560372,86.1891907,104.296718,1.8,88.7776525,104.611504,0.2113813,3.1227072,16.9600003,19.061329,131.644909,0.1075277,7.7620817,6.1041039,8.767271,3.9774707,8.0245532,2.6387494,19.0489565),(19252,'baisa_ulna.tif',241,4,182,14.5855126,86.113579,104.1870712,1.8,88.6627324,104.4301892,0.2210728,3.1669914,17.3728847,18.7700942,121.72118,0.1168839,7.0063885,5.9267904,7.9725901,3.9774707,7.9003747,2.5782764,19.0489565),(19253,'baisa_ulna.tif',241,4,183,14.3946506,85.9324119,104.0680732,1.8,88.1768503,104.2768449,0.2610889,3.2801529,15.0691214,17.7663542,100.0447553,0.1598586,6.6390569,5.4163189,7.6733221,3.9774707,7.7183687,2.6167969,18.5517727),(19254,'baisa_ulna.tif',241,4,184,14.3779465,85.8774123,103.962734,1.8,88.2512087,104.1924935,0.2662963,3.1470065,15.8127273,17.5027111,100.5411568,0.1659533,6.3582426,5.5617017,7.3241948,3.9774707,7.7183687,2.6167969,18.2605291),(19255,'baisa_ulna.tif',241,4,185,14.7375356,86.1069629,103.8212831,1.8,88.8254384,104.1087298,0.217669,2.8958989,15.7519512,18.9389745,134.4769004,0.1145505,8.5371583,6.5399293,9.6494491,3.9774707,7.7183687,2.6167969,18.5517727),(19256,'baisa_ulna.tif',241,4,186,14.8197456,86.1515665,103.7104365,1.8,89.0799206,104.0171559,0.205114,2.8431874,16.7176683,19.1917893,150.9481606,0.1024663,9.0292592,6.7500964,10.0739477,3.9774707,7.7183687,2.6167969,18.5517727),(19257,'baisa_ulna.tif',241,4,187,14.7080224,86.0467872,103.5846288,1.8,88.8041954,103.8718214,0.2179134,3.0483718,17.0823201,18.6580737,134.4113777,0.1145739,7.8684498,6.1206687,8.8314513,0.9943677,1.4915515,2.3561945,3.1890433),(19258,'baisa_ulna.tif',241,4,188,14.6882096,85.9852129,103.45316,1.8,88.7146376,103.7489176,0.2233532,3.0985412,16.4696185,18.8709587,138.0663023,0.1201069,8.3830905,6.090272,9.3982448,1.4915515,3.737156,2.2896263,8.3668219),(19259,'baisa_ulna.tif',241,4,189,14.535475,85.8002764,103.3313235,1.8,88.1308485,103.6561866,0.2599711,4.2427186,17.2472298,18.2411615,115.0772024,0.1600745,6.6722137,4.299404,7.5782173,0.4971838,1.4915515,2.3561945,2.983103),(19260,'baisa_ulna.tif',241,4,190,14.1551368,85.5401801,103.1674025,1.8,87.3564968,103.4271106,0.3211931,3.8889786,13.4099283,17.0049149,83.4430884,0.2351305,6.2224858,4.3725916,7.1941472,0.7457758,1.4915515,2.3561945,2.983103),(19261,'baisa_ulna.tif',241,4,191,14.2958863,85.5377013,103.0482171,1.8,87.4769127,103.3233277,0.3080291,4.5585776,16.6201788,17.4592286,91.1634012,0.2190101,5.4851035,3.8299729,6.3342591,1.7401434,3.9774707,2.3561945,9.1552493),(19262,'baisa_ulna.tif',241,4,192,14.2961859,85.4858849,102.9498019,1.8,87.3548543,103.2816138,0.3373423,4.8658706,17.2342143,17.5531311,88.7238915,0.2610198,5.1481251,3.6073978,5.9346265,1.7401434,3.9774707,2.3561945,9.3611896),(19263,'baisa_ulna.tif',241,4,193,14.0873089,85.5799954,102.7284343,1.8,87.7349756,102.9853116,0.2980394,4.8506429,16.7413729,17.1858461,95.8756109,0.2024542,5.7268667,3.5430038,6.4866288,1.4915515,3.4802868,2.3561945,7.8696381),(19264,'baisa_ulna.tif',241,4,194,14.2168598,85.604211,102.6213034,1.8,87.896594,102.8901587,0.2857803,4.0990256,16.5683495,17.9631978,104.8109322,0.1883049,6.325973,4.3823093,7.1932891,3.9396995,7.9003747,2.5782764,18.7577129),(19265,'baisa_ulna.tif',241,4,195,13.8446489,85.4016308,102.4386512,1.8,87.272552,102.6779578,0.3279911,4.5736224,16.2984194,16.3278192,82.4071071,0.2394557,5.056141,3.5699972,5.8326468,5.2734309,7.9003747,2.5782764,27.0392316),(19266,'baisa_ulna.tif',241,4,196,13.8429261,85.374783,102.3037816,1.8,87.3764385,102.6063723,0.3234102,3.5974782,14.0541648,16.0730086,88.1239123,0.2330179,6.2703059,4.4678544,7.1823847,1.4915515,3.9774707,2.3561945,8.8640058),(19267,'baisa_ulna.tif',241,4,197,13.8441621,85.280517,102.153433,1.8,87.1851155,102.4729453,0.3306736,5.6325605,19.0392303,15.5909013,86.437499,0.2432355,4.5399681,2.7679953,5.1386949,3.9774707,8.0245532,2.6387494,19.0489565),(19268,'baisa_ulna.tif',241,4,198,13.7713903,85.1013079,101.9722883,1.8,86.6095641,102.2242721,0.4031218,4.6026125,12.535323,14.7203442,69.0439783,0.3532197,5.5079537,3.1982584,6.2727943,3.9459991,8.0935664,2.5415424,19.2548968),(19269,'baisa_ulna.tif',241,4,199,13.8849112,85.0792372,101.8262108,1.8,86.6594397,102.0868101,0.3986779,3.9769778,12.581662,14.680618,72.7598636,0.3487414,5.7830089,3.6914005,6.6765724,1.2429596,3.4802868,2.3561945,7.3724543),(19270,'baisa_ulna.tif',241,4,200,14.0402301,85.0743612,101.7011938,1.8,86.7257439,101.9695695,0.4115833,4.2892837,13.0919291,15.1541092,74.5939171,0.3745202,5.6977025,3.5330163,6.5144947,3.9774707,8.0245532,2.6387494,19.3402),(19271,'baisa_ulna.tif',241,4,201,14.2751372,85.2404053,101.5489574,1.8,87.3100769,101.9478427,0.3450768,4.1616943,15.8899809,16.7312946,94.8598911,0.2722408,5.9697926,4.0203084,6.793599,3.7288788,8.0245532,2.6387494,19.1342597),(19272,'baisa_ulna.tif',241,4,202,14.125661,85.0993405,101.3637023,1.8,86.8478017,101.6504147,0.3896577,4.0047544,13.154368,16.1370476,79.0828543,0.3397283,6.0119083,4.0294725,6.9248465,3.9774707,8.0245532,2.6387494,19.0489565),(19273,'baisa_ulna.tif',241,4,203,14.2929275,85.0976382,101.2173649,1.8,86.9443229,101.5471885,0.3626372,3.7040513,13.6399654,17.2054699,87.0616434,0.2997733,6.3828346,4.6450409,7.3862532,0.4971838,0.9943677,2.3561945,1.9887353),(19274,'baisa_ulna.tif',241,4,204,14.3843884,85.0492483,101.0651492,1.8,86.9088537,101.4199168,0.383969,3.5401125,13.0092577,17.3351069,86.4551952,0.3364214,6.6456671,4.8967673,7.6982475,5.4385223,8.0168484,2.4805495,29.3192105),(19275,'baisa_ulna.tif',241,4,205,14.4205683,84.9130312,100.9050088,1.8,86.4595565,101.2128078,0.4481889,3.7094779,11.0463721,17.0911801,75.6841006,0.4513118,6.8514893,4.6074355,8.0335303,4.2195321,8.0935664,2.5415424,19.4608371),(19276,'baisa_ulna.tif',241,4,206,14.5327035,84.8605445,100.7470314,1.8,86.4220935,101.0882227,0.4759351,4.0403463,12.0051811,17.1735967,75.5968732,0.5084498,6.2970206,4.2505259,7.3238857,1.5799906,4.2333678,2.4149503,10.3555573),(19277,'baisa_ulna.tif',241,4,207,14.4680216,84.7177452,100.575549,1.8,85.9076565,100.8374875,0.5720669,3.9853688,10.0013166,15.9043685,64.9408519,0.706721,6.4932303,3.9906892,7.5144275,5.5875832,8.0935664,2.5415424,29.1132702),(19278,'baisa_ulna.tif',241,4,208,14.6570859,84.7232872,100.4722781,1.8,86.0420582,100.7770408,0.5769522,4.6166002,10.6228216,16.6959239,69.0588723,0.7268443,6.5009914,3.6164977,7.4809424,5.6565975,11.4945204,2.7326848,40.9957127),(19279,'baisa_ulna.tif',241,4,209,14.616112,84.7803644,100.2633846,1.8,86.2351468,100.5560622,0.5528906,4.5562956,10.1160917,16.9737807,72.2712118,0.6718097,7.1441831,3.7253467,8.1314024,4.2195321,8.3860633,2.5652174,20.2492644),(19280,'baisa_ulna.tif',241,4,210,14.8267493,84.8245748,100.1410817,1.8,86.5102284,100.4775186,0.5166835,4.7603059,11.3345525,19.3452166,81.2841309,0.6030416,7.1713578,4.06386,8.1855071,4.2260626,8.2971626,2.5065659,20.7464483),(19281,'baisa_ulna.tif',241,4,211,15.1124056,84.7452005,100.0110533,1.8,86.0791131,100.2144803,0.6015972,5.2270083,9.1818777,19.8959951,75.3421497,0.8067774,8.2055275,3.8063829,9.0141212,6.1496621,11.4945204,2.7326848,44.9731834),(19282,'baisa_ulna.tif',241,4,212,16.048813,84.8594457,100.0207468,1.8,86.4238264,100.2697305,0.6057149,5.2301467,10.328213,22.8179588,94.0196647,0.8670622,9.103188,4.362776,10.0922385,0.9943677,2.4859192,2.3561945,5.3837189),(19283,'baisa_ulna.tif',241,4,213,14.8987346,84.6016452,99.6404528,1.8,85.8837297,99.8413199,0.6434823,5.5371522,10.0655946,17.3133672,73.8300254,0.8938791,7.3348896,3.1267638,7.9337279,4.1642664,9.0043822,2.4668517,21.1583289),(19284,'baisa_ulna.tif',241,4,214,15.3737922,84.5937906,99.5270104,1.8,85.8332671,99.7305043,0.6772526,4.2482106,8.2526181,17.7419039,79.93254,1.0062036,9.685719,4.176324,10.6634868,6.6796792,13.3870844,2.7367009,56.7703227),(19285,'baisa_ulna.tif',241,4,215,14.2785829,84.3071064,99.1524136,1.8,85.3491495,99.3584436,0.6868329,5.1577058,9.0430748,15.2402015,62.6558529,0.9568361,6.9286005,2.9548412,7.4824294,5.4113504,11.0056333,2.677945,41.4075933),(19286,'baisa_ulna.tif',241,4,216,14.6728537,84.2976586,99.0421911,1.8,85.3157657,99.2163778,0.7189264,11.1021239,7.6298417,17.1755318,67.8099251,1.0606612,8.8874616,1.5470492,7.5477985,5.6455383,11.79175,2.677945,43.5169657),(19287,'baisa_ulna.tif',241,4,217,15.39162,84.4150779,98.9938409,1.8,85.5799411,99.4801641,0.6787902,16.3292619,9.0997861,34.0269366,81.5321898,1.0112242,8.9597919,2.0838013,7.0328617,5.7629881,12.7438216,2.7149652,46.0028848),(19288,'baisa_ulna.tif',241,4,218,15.8440183,84.4554573,98.9178979,1.8,85.6486845,99.4472464,0.5994703,19.6964677,11.2517443,43.3080185,94.1024549,0.8405978,8.363366,2.1987708,6.7304404,4.5674473,9.2280856,2.4370986,22.0673933),(19289,'baisa_ulna.tif',241,4,219,16.02312,84.4870804,98.7442312,1.8,85.8129224,99.0570796,0.6555958,23.3476339,14.5494698,33.6691495,101.4305695,0.9925006,6.9714272,1.4420797,4.9109346,6.0794162,13.2105029,2.7017501,52.672215),(19290,'baisa_ulna.tif',241,4,220,15.330234,84.2888515,98.4577887,1.8,85.4549393,98.7474432,0.6767546,11.1317463,9.1035044,20.8508428,84.7356106,1.0021102,9.3080211,1.8730972,9.4785078,5.6284653,12.1072175,2.6909313,44.2200898),(19291,'baisa_ulna.tif',241,4,221,15.6840928,84.2849102,98.3228727,1.8,85.4774199,98.6042577,0.7239104,12.0888104,21.2026677,27.7229617,102.50634,1.1466826,4.8345963,2.2932746,5.6289185,5.5054907,13.529431,2.7128146,53.5812794),(19292,'baisa_ulna.tif',241,4,222,15.2666383,84.1063832,98.0033757,1.8,85.15841,98.0822153,0.7149497,10.049804,20.474123,18.1806304,82.1840955,1.0935605,4.0140472,1.8090532,4.4004878,5.926407,12.1225205,2.6260436,52.5869117),(19293,'baisa_ulna.tif',241,4,223,16.0970903,84.141433,98.0361142,1.8,85.1682989,98.8197405,0.8185213,13.5464989,16.4065941,44.3820833,101.6835983,1.4302237,6.1977274,3.276277,6.9228198,5.9173346,13.9078236,2.7798634,59.3768789),(19294,'baisa_ulna.tif',241,4,224,16.511099,84.0467319,97.8722332,1.8,84.7178819,98.5499197,0.6794005,17.1375495,8.6049082,40.8822563,97.4837552,1.0864153,11.3288547,2.3855369,8.0160463,4.8903636,10.2195167,2.4292351,23.9708253),(19295,'baisa_ulna.tif',241,4,225,15.9627078,83.7625944,97.5478735,1.8,84.0233325,98.2950527,0.7495245,17.0126556,15.1104728,53.8442398,77.7232133,1.2348675,5.1436652,3.1649521,7.5097987,6.095149,9.0043822,2.4668517,27.3658089),(19296,'baisa_ulna.tif',241,4,226,16.507878,83.76609,97.4714653,1.8,84.0192086,98.3260318,0.7050057,17.0146076,8.8145114,55.8470554,81.0532372,1.1554235,9.1954317,3.2823005,7.8587598,6.6796792,14.1019777,3.0667328,62.4806189),(19297,'baisa_ulna.tif',241,4,227,17.0762693,83.8407563,97.259884,1.8,84.5098077,97.7381919,0.5632646,17.4183639,10.1856059,42.1384121,91.1913914,0.8114128,8.9529668,2.4191946,6.9213532,6.8545182,13.7514254,3.0648208,56.6850194),(19298,'baisa_ulna.tif',241,4,228,17.7017768,83.8353154,97.1105596,1.8,84.6619868,97.5166671,0.5523793,17.7078424,12.8820947,44.7700583,97.8148368,0.81229,7.5930847,2.5282616,6.7017306,7.0312412,12.893272,2.6901396,53.4606423),(19299,'baisa_ulna.tif',241,4,229,19.3824561,83.7188421,97.0579413,1.8,84.185051,97.6199952,0.5476499,18.3994728,10.76594,59.271326,104.3271537,0.8757964,9.6904825,3.22136,8.8730222,1.7578103,3.8831299,1.6614562,10.390891),(19300,'baisa_ulna.tif',241,4,230,20.5109989,83.899892,96.9000124,1.8,85.3621348,97.2798357,0.4470893,17.6396322,21.0366115,46.7818531,148.9726548,0.6389868,7.0815899,2.6520878,7.1303979,5.4690222,10.7154363,2.4258491,26.9539283),(19301,'baisa_ulna.tif',241,4,231,21.6750099,83.8726158,96.7913401,1.8,85.4594151,97.3117333,0.4032792,16.7000997,20.6131929,58.5585512,172.9640397,0.5563488,8.3909388,3.5064791,8.727094,1.9378352,3.5156206,2.2142974,8.7787025),(19302,'baisa_ulna.tif',241,4,232,22.4432519,83.890073,96.6512168,1.8,85.5629584,97.2123065,0.4118145,15.540694,21.4555885,61.6945517,196.3033329,0.5993032,9.1492868,3.9698711,9.7385053,0.3515621,0.4971838,2.3561945,0.9943677),(19303,'baisa_ulna.tif',241,4,233,23.7408963,84.1435578,96.5074772,1.8,86.5499005,97.1565473,0.4035511,16.3972487,19.120251,65.6407604,264.1860947,0.6101521,13.817083,4.003157,16.8568452,0.7031241,1.267575,2.1587989,2.6918595),(19304,'baisa_ulna.tif',241,4,234,22.2886447,83.9116801,96.0872247,1.8,85.8653005,96.7637244,0.3708619,21.6269982,18.8314972,75.6436072,227.4100182,0.487926,12.0760455,3.4976471,12.6442423,0.7031241,1.1117369,1.8925469,2.6918595),(19305,'baisa_ulna.tif',241,4,235,22.9522048,83.881341,95.9733321,1.8,85.904253,96.9188065,0.3086624,21.4840643,18.7282864,101.3500671,267.2858465,0.3530243,14.2717727,4.7174532,15.0335806,6.1546657,9.6535639,2.1486983,26.4214107),(19306,'baisa_ulna.tif',241,4,236,23.95453,83.8194236,95.7982067,1.8,85.8884298,96.7650326,0.3429765,20.3891885,19.4311357,105.1853626,295.4996557,0.4515114,15.2075339,5.1588793,16.6948694,6.4633898,10.1406003,2.1587989,27.3304751),(19307,'baisa_ulna.tif',241,4,237,25.0955447,83.719296,95.6395878,1.8,85.8162424,96.787696,0.2958193,21.8074795,23.3753524,136.941869,351.2744563,0.355462,15.0275577,6.2795826,19.4172781,6.9605737,10.43494,2.1401095,28.5307831),(19308,'baisa_ulna.tif',241,4,238,26.5255116,83.6662038,95.4250349,1.8,85.8195532,96.5019184,0.3217277,23.3116178,23.4150233,150.1032217,395.2538452,0.4420313,16.8803524,6.4389878,19.7388475,7.6321275,11.0336732,2.1057514,30.931399),(19309,'baisa_ulna.tif',241,4,239,28.1509847,83.5017544,95.1870698,1.8,85.5564069,96.3188731,0.2311321,22.3099552,25.871568,204.0042992,454.0483093,0.2462156,17.5500885,9.1440927,23.1122511,7.7063494,11.7023176,2.1421338,32.2170102),(19310,'baisa_ulna.tif',241,4,240,23.8180127,82.5514193,94.091056,1.8,82.5198992,95.1617839,-0.3349434,11.0367074,27.5708961,142.092816,240.2909916,0.4289386,8.7153856,12.8745658,13.0537604,0.3515621,0.4971838,2.3561945,0.9943677),(19311,'baisa_ulna.tif',241,4,241,26.0142366,82.7899473,93.8026031,1.8,83.7087769,94.6879423,0.2359513,19.8502041,19.6333661,155.0363982,251.4100065,0.2369354,12.8052421,7.8103176,15.2766314,8.3756556,11.6068735,2.1840037,32.5435875),(19312,'baisa_ulna.tif',241,4,242,27.5125183,82.7267723,93.5777494,1.8,83.8051572,94.6679079,0.1282623,20.6244209,23.8272646,198.6981725,303.7170504,0.0750229,12.7466185,9.6341213,18.1802088,8.8581454,11.9995501,2.1262901,34.035139),(19313,'baisa_ulna.tif',241,4,243,27.4840164,82.5919773,93.0867488,1.8,83.7877224,93.9020146,0.200116,21.7510778,17.7613261,177.9958872,277.5207431,0.1810038,15.6250013,8.1833134,17.9105705,0.3515621,0.4971838,2.3561945,0.9943677),(19314,'baisa_ulna.tif',241,4,244,29.9254845,82.571628,92.8633129,1.8,84.0912369,93.7380035,0.2394446,20.0018895,21.5566262,207.7112603,346.7544758,0.2805333,16.0857489,10.384582,19.1910025,10.1196925,18.9615511,2.9551058,54.4903438),(19315,'baisa_ulna.tif',241,4,245,31.7229432,82.192863,92.352633,1.8,83.2088632,92.9845566,0.1030664,19.9601851,20.4501435,212.6446388,263.1435041,0.0559652,12.8675627,10.6534402,17.8546882,10.0077291,14.9237991,2.8794728,45.0085172),(19316,'baisa_ulna.tif',241,4,246,33.4705889,82.126745,91.7561038,1.8,82.6500432,92.0601106,-0.3889105,10.8380804,24.6373379,172.3849653,254.0323599,0.8020547,10.3108689,15.9054886,15.9401743,9.9502011,12.0252727,2.8753406,36.9329388),(19317,'baisa_ulna.tif',241,4,247,30.0172076,81.9909158,91.3616313,1.8,82.7032816,91.5440515,-0.291718,9.0153196,16.0421442,150.1815915,213.1052605,0.4138005,13.2840883,16.6584878,20.5577278,10.1779751,11.8179248,2.1010121,37.8066694),(19318,'baisa_ulna.tif',241,4,248,28.0784377,81.8511364,90.8425012,1.8,82.4402672,90.9109098,-0.3889995,7.1638352,26.5160297,123.7983806,212.3945991,0.6731351,8.0100453,17.2810201,12.31873,9.6891759,11.2554778,3.1103528,34.4470196),(19319,'baisa_ulna.tif',241,4,249,27.0884721,81.8055089,90.4143405,1.8,82.5124263,90.5018031,-0.3407329,7.9898456,23.8275582,107.6420177,199.0719445,0.5041837,8.3546935,13.4723527,12.8125754,9.1406136,11.1728171,2.9195108,34.1557761),(19320,'baisa_ulna.tif',241,4,250,24.0840435,81.7321351,89.9090116,1.8,82.2817066,89.797582,-0.2496803,5.03681,9.4248076,73.4559946,159.8237066,0.2450775,16.9577686,14.5838327,21.8298445,7.594691,11.0392726,2.9816795,31.0873698),(19321,'baisa_ulna.tif',241,4,251,23.668574,81.635145,89.5975284,1.8,82.3102664,89.565229,-0.2338946,15.8420996,26.2562112,58.3456268,166.4437724,0.2118982,6.3392152,3.6829479,7.3304153,7.2392379,11.2993162,0.0934768,31.3432796),(19322,'baisa_ulna.tif',241,4,252,21.9803666,81.5310196,89.1551175,1.8,82.1968497,89.0774215,-0.1604434,3.9073938,7.3625555,43.5771867,147.8820094,0.0934969,20.0856902,11.1524942,23.9483624,6.6796792,11.6228353,0.060532,31.3432796),(19323,'baisa_ulna.tif',241,4,253,21.4389418,81.344999,88.7891253,1.8,81.9725538,88.823973,-0.1705862,6.9919957,24.5286818,43.6793302,175.8825264,0.1029729,7.1704843,6.2470477,8.6083215,6.8674566,11.6864644,3.020969,41.9900804),(19324,'baisa_ulna.tif',241,4,254,21.4957959,81.2889791,88.3104214,1.8,81.8821925,88.3617354,-0.1759768,19.3634026,24.102285,47.7772273,172.6288578,0.1098059,7.1623441,2.4673983,8.0756872,6.530145,12.3497902,3.0560874,33.573289),(19325,'baisa_ulna.tif',241,4,255,21.2341097,81.1866014,87.8352938,1.8,81.6274633,88.004904,-0.2805592,19.1832542,23.685406,53.6072759,192.271949,0.2713357,8.1177392,2.7944829,8.5363689,6.1937624,13.0504837,0.0809041,47.0325863),(19326,'baisa_ulna.tif',241,4,256,25.1441591,81.2004045,87.7851052,1.8,81.8059234,88.0738233,-0.2043553,19.0443581,23.3092436,67.9445192,273.8344672,0.1725852,11.7478916,3.567698,11.3718283,6.5205716,13.4331675,0.1048769,34.2764131),(19327,'baisa_ulna.tif',241,4,257,23.49936,81.4763038,87.3289463,1.8,82.352702,87.4024977,-0.1014433,22.5349928,21.2433382,49.1444548,254.3231581,0.0401663,11.9719017,2.1808063,9.904681,5.976555,13.782847,0.1022067,34.0704728),(19328,'baisa_ulna.tif',241,4,258,27.4236042,81.5110207,87.2328473,1.8,82.9463754,87.1794371,-0.0357926,3.9352641,15.0723928,51.9399735,329.5901519,0.005853,21.8671419,13.198599,24.839742,0.3515621,0.4971838,2.3561945,0.9943677),(19329,'baisa_ulna.tif',241,4,259,33.1724981,80.7495613,87.1761539,1.8,81.5051499,86.8072049,-0.2452323,5.7598375,11.0170991,66.1681221,384.3948366,0.3258808,34.8907488,11.4878453,39.6632653,6.451086,15.100808,0.2110933,49.6391425),(19330,'baisa_ulna.tif',241,4,260,43.6067247,81.1361414,87.1856617,1.8,82.0921713,86.9449158,-0.2427215,4.5044766,11.8438163,122.0274434,557.0845547,0.4198297,47.0358998,27.0902601,56.3660842,7.938576,15.1783637,0.2337432,38.5451273),(19331,'baisa_ulna.tif',241,4,261,50.5913902,81.2963132,87.0832028,1.8,82.3602992,86.8376965,-0.2864883,5.1606854,15.639176,181.2917853,681.1888005,0.6733252,43.556566,35.1294009,52.4487436,8.7817514,17.1726461,0.3995155,70.470894),(19332,'baisa_ulna.tif',241,4,262,54.4409525,81.4976881,86.8406466,1.8,82.9514867,86.533653,-0.3312707,11.2624384,25.6400536,242.2255105,778.3972596,0.9598327,30.3586441,21.5073772,36.5584631,0.3515621,0.4971838,2.3561945,0.9943677),(19333,'baisa_ulna.tif',241,4,263,64.8841304,81.359073,86.8706905,1.8,82.2931095,86.6780858,-0.5746555,16.5657516,33.4441702,342.1882109,1056.5185791,3.1949152,31.5905155,20.656365,40.6639482,0.4971838,0.9943677,2.3561945,1.9887353),(19334,'baisa_ulna.tif',241,4,264,73.558052,81.2785439,86.8616597,1.8,82.1928161,86.4986286,-0.7141117,19.2597169,25.7709894,431.8347003,1495.4207032,5.2588461,58.027291,22.4216536,63.7682499,0.3515621,0.7861167,2.0344439,1.6974918),(19335,'baisa_ulna.tif',241,4,265,83.2314148,81.2288019,86.9467486,1.8,82.0308774,86.454295,-0.7938481,15.6898863,25.6894543,534.2269375,1961.9029474,7.0531622,76.3699737,34.0491274,96.8389989,10.926816,20.7689583,0.9780989,52.5016084),(19336,'baisa_ulna.tif',241,4,266,95.023211,81.2240143,87.2057361,1.8,81.9023035,86.8733631,-0.9021375,15.7462119,21.8946961,678.6320419,2523.9849484,9.7506741,115.2783734,43.0981144,146.093274,0.7031241,1.7926218,1.7681919,4.3893512),(19337,'baisa_ulna.tif',241,4,267,96.0022402,81.4914626,87.0275939,1.8,81.9540287,86.8152287,-1.0259436,17.467753,16.9091271,733.2758645,2469.3284857,11.7022452,146.0352432,41.9788317,149.4334459,0.7031241,1.267575,2.1587989,2.6918595),(19338,'baisa_ulna.tif',241,4,268,91.9304675,81.5799949,86.6461789,1.8,81.9549118,86.6047272,-1.1834738,15.766033,11.8926305,615.6426437,2185.0226391,13.1358626,183.729129,39.0486716,174.1129335,0.7031241,1.5722333,1.1071487,3.3949836),(19339,'baisa_ulna.tif',241,4,269,72.2773365,81.531124,85.3816671,1.8,81.6893271,85.9705336,-1.2806957,8.0280388,12.491277,346.7130595,1389.8373198,11.0605546,111.2646304,43.1877659,133.6512629,10.8186984,20.1374797,1.2877005,80.7058142),(19340,'baisa_ulna.tif',241,4,270,49.0184266,81.3010044,83.7834211,1.8,81.4255026,84.0101432,-1.2405898,5.9749501,9.9288912,156.2826157,603.3082878,7.3108486,60.7629068,26.1563047,76.5025669,7.6483721,16.5271564,1.1547318,45.746975),(19341,'baisa_ulna.tif',241,4,271,33.4882294,81.0137003,83.1308484,1.8,81.0778866,83.287999,-1.261106,4.1831899,7.9687847,68.9440989,284.5347299,5.0629688,35.7061635,16.4812263,40.5790661,6.3256454,13.9078236,1.2090671,35.9385711),(19342,'baisa_ulna.tif',241,4,272,19.5027561,80.7675077,82.8632658,1.8,80.6823364,83.0923869,-1.2837038,2.8942029,14.2813592,21.920241,103.6387485,2.9898297,7.2569247,7.573844,8.7773645,5.031187,10.2497073,1.0303768,27.6570525),(19343,'baisa_ulna.tif',241,4,273,6.3653003,80.8297594,82.6890172,1.8,80.8292958,82.8296566,-1.3792694,1.4627391,3.987925,2.1507229,17.0364741,1.022441,4.2720147,1.4703394,4.7525516,2.9938932,7.6782313,1.2924967,17.798679),(19344,'baisa_ulna.tif',241,4,274,0.0517605,80.6722999,82.9577077,1.8,80.6834929,82.9686463,1.3524834,0.2563093,0.3943918,0.0022279,0.0044106,0.0082221,0.0111834,0.0086922,0.0162757,0.7031241,1.267575,2.1587989,2.6918595),(19345,'baisa_ulna.tif',241,4,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19346,'baisa_ulna.tif',241,4,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19347,'baisa_ulna.tif',241,4,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19348,'baisa_ulna.tif',241,4,278,21.6886429,112.3417082,106.8515174,1.8,111.2939795,105.6139403,1.1819486,4.9027068,7.1815255,40.3051678,242.4214272,3.0952087,33.756258,8.2210031,35.5623476,10.8823219,15.5722549,2.0647377,45.8322783),(19349,'baisa_ulna.tif',241,4,279,2.8579862,113.9337597,109.8479726,1.8,113.7560506,109.3272261,1.5702791,0.7321476,4.3791863,0.345176,9.3314983,0.4763309,2.1308749,0.4714568,2.2035929,5.2605397,9.1676169,1.0040671,22.8058511),(19350,'baisa_ulna.tif',241,4,280,0.0085768,114.2576697,110.7420491,1.8,114.2576697,110.7420491,0.7853982,0,0,0.0000883,0.0000883,0.0007147,0,0,0,2.0472936,5.366362,1.0191413,11.7618055),(19351,'baisa_ulna.tif',241,4,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19352,'baisa_ulna.tif',241,4,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19353,'baisa_ulna.tif',241,4,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19354,'baisa_ulna.tif',241,4,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19355,'baisa_ulna.tif',241,4,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19356,'baisa_ulna.tif',241,4,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19357,'baisa_ulna.tif',241,4,287,0.0509739,114.2576697,111.2514395,1.8,114.2576697,111.2693922,1.5413616,0.026395,0.8964693,0.0005404,0.0183255,0.0084883,0.0204419,0.0204753,0.0210356,7.0312412,7.8059445,0.9453113,23.4736415),(19358,'baisa_ulna.tif',241,4,288,3.7658542,113.0761564,110.1526019,1.8,112.8310999,109.9515425,-1.4191772,2.2183006,4.4611738,2.9460382,12.12795,0.6133241,2.7185559,1.3280608,3.3567569,13.1753716,14.2241506,0.8728935,44.5466671),(19359,'baisa_ulna.tif',241,4,289,47.5115306,93.172078,107.699924,1.8,91.6602265,107.3092359,0.0606551,8.5005677,21.359089,567.1636592,5981.0925656,0.0290971,280.0256395,66.7206801,301.6828551,27.7734028,28.5198966,2.6117436,93.5180192),(19360,'baisa_ulna.tif',241,4,290,247.4804923,90.2816097,106.777705,1.8,92.2681107,106.7553102,0.0370535,11.1217092,24.1846035,3781.5603703,19329.9427808,0.0566042,799.2664734,340.0161173,934.4245207,28.828089,29.3717425,2.3053908,96.1245754),(19361,'baisa_ulna.tif',241,4,291,260.5978357,90.6357696,106.7592755,1.8,92.9344583,106.7058174,0.0299204,11.0998712,23.7935794,3987.1542068,21792.8327346,0.0388707,915.9123276,359.2072492,1055.4674341,29.179651,29.4389933,0.8699419,96.1245754),(19362,'baisa_ulna.tif',241,4,292,265.4683749,90.9635994,106.7463011,1.8,93.512436,106.6575162,0.0228671,11.0884391,23.4275746,4067.8272768,23362.6566494,0.0231318,997.2289961,366.8530105,1129.0457898,29.179651,29.4473889,2.5602125,96.1245754),(19363,'baisa_ulna.tif',241,4,293,269.2168507,91.219794,106.736505,1.8,93.9207588,106.6457258,0.0148608,11.0870452,23.1262011,4122.2304928,24559.8889631,0.0099083,1061.9940935,371.8060518,1182.3853559,29.179651,29.4473889,0.9894161,96.1245754),(19364,'baisa_ulna.tif',241,4,294,272.9793341,91.4356932,106.712534,1.8,94.219914,106.5786021,0.0077164,11.0735314,22.8686669,4200.2860757,25591.9742497,0.0027089,1119.0846567,379.3086334,1227.2345026,29.179651,29.4011837,2.2885015,96.1245754),(19365,'baisa_ulna.tif',241,4,295,276.3632021,91.5897596,106.6919356,1.8,94.469606,106.5495133,0.0014277,10.0080812,22.676681,4270.4213906,26388.427121,0.0000938,1163.6811918,426.6973168,1264.4577077,29.179651,29.4389933,2.4407382,96.1245754),(19366,'baisa_ulna.tif',241,4,296,278.6390143,91.6956993,106.6737955,1.8,94.6092766,106.5226797,-0.0033419,11.0556955,22.5917196,4323.2037084,26932.0112012,0.0005187,1192.118691,391.0386012,1287.8946906,29.2616801,57.1966731,0.0923293,183.143871),(19367,'metacarpus.tif',241,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19368,'metacarpus.tif',241,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19369,'metacarpus.tif',241,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19370,'metacarpus.tif',241,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19371,'metacarpus.tif',241,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19372,'metacarpus.tif',241,5,6,14.4727447,66.8744519,76.4573533,1.8,66.3589002,75.5211054,-1.5607581,5.3732396,9.2572202,21.6560981,236.9627524,2.4118811,25.5976144,4.0303615,24.4634171,7.2480478,18.265474,1.82812,46.5231109),(19373,'metacarpus.tif',241,5,7,106.035603,65.0584795,76.4170255,1.8,64.2847866,77.8907672,0.9756596,23.2409876,22.3468615,2144.8314962,4012.857838,12.1181559,179.5714285,92.2865902,255.4248841,16.9567073,23.6019973,2.1314833,85.8439727),(19374,'metacarpus.tif',241,5,8,365.3003047,62.6852689,79.7728389,1.8,62.5281559,80.4845507,0.1568256,14.6578311,23.1884167,14267.3823835,39910.541687,1.4851465,1721.1413032,973.3624526,2209.1055157,26.9706895,44.1974812,2.9080931,173.0591181),(19375,'metacarpus.tif',241,5,9,515.533192,62.2944103,79.7388012,1.8,62.354072,80.9674093,0.1483453,16.8613389,23.7665668,22844.3642461,67359.9182265,1.8770066,2834.2300715,1354.8369062,3516.3429545,28.7238724,44.7706626,2.8411853,165.7053754),(19376,'metacarpus.tif',241,5,10,490.4266424,62.066377,79.7615987,1.8,62.1434871,81.0092633,0.1267125,17.3833518,24.0779444,24476.0413158,67463.0882085,1.3053806,2801.8624428,1408.0162197,3563.2078195,29.2552023,45.15572,2.9078495,163.7799282),(19377,'metacarpus.tif',241,5,11,465.6621867,61.9343109,79.8580275,1.8,62.2761789,81.1896624,0.1301139,16.8160222,24.2564697,25028.4184777,63835.6086811,1.3065173,2631.6941225,1488.367355,3423.3837398,0.4648441,0.8380096,0.9827937,1.7796217),(19378,'metacarpus.tif',241,5,12,447.4489005,62.0094768,80.1872074,1.8,62.4442384,81.4285826,0.1565909,16.4843442,24.1278031,25329.6890313,60190.4601175,1.813727,2494.6515018,1536.5906455,3364.7751834,30.3345744,44.4461192,2.9308646,215.0973054),(19379,'metacarpus.tif',241,5,13,432.7254703,62.1119352,80.467446,1.8,62.5912965,81.6311248,0.1957559,16.4932372,23.9925406,24914.1487814,56838.0561871,2.7285765,2368.9886378,1510.5675436,3285.9052349,0.232422,0.3286944,2.3561945,0.6573888),(19380,'metacarpus.tif',241,5,14,417.0942257,62.235024,80.6702601,1.8,62.6725279,81.7472812,0.2268456,16.1876041,23.4620019,23617.824558,53341.5716137,3.5162612,2273.5302751,1459.0068018,3184.0022863,27.9577189,42.3754521,2.9818542,129.1832539),(19381,'metacarpus.tif',241,5,15,397.0721697,62.4010688,80.7952213,1.8,62.696111,81.7089541,0.243258,16.2170356,22.6794507,21329.0364513,49476.6503962,3.8394492,2181.5629993,1315.2241221,3042.8897935,1.3241305,1.8152741,2.2655346,5.5314097),(19382,'metacarpus.tif',241,5,16,374.6159397,62.5004802,80.8662911,1.8,62.7374277,81.7383261,0.2404769,15.9267629,22.0054122,19110.9141978,45143.6486748,3.5415535,2051.479347,1199.9245769,2875.0789809,0.9035361,1.6760191,0.9827937,4.0804824),(19383,'metacarpus.tif',241,5,17,357.7897235,62.5961823,81.024272,1.8,62.6912049,81.971704,0.2132368,15.5120674,21.3930084,17525.606548,40302.986832,2.6705966,1883.9326378,1129.8046958,2697.3335544,0.4648441,1.039423,2.677945,2.1083161),(19384,'metacarpus.tif',241,5,18,341.8767892,62.5874434,81.222429,1.8,62.6188536,82.076253,0.1811971,15.5501832,20.5210557,16125.6478168,36115.5192457,1.850386,1759.9250185,1037.0069335,2522.2963181,0.232422,0.5197115,2.677945,0.9860832),(19385,'metacarpus.tif',241,5,19,330.082831,62.5498093,81.3774082,1.8,62.5679888,82.1505142,0.1495457,15.3889749,19.6792094,15005.5556428,32720.4822085,1.2211784,1662.6929223,975.0848079,2381.6444785,24.5796208,35.7544876,3.0373962,107.4523803),(19386,'metacarpus.tif',241,5,20,321.1524241,62.5284127,81.5519899,1.8,62.5702843,82.2836863,0.1157983,14.3319848,19.0724725,14107.4780888,30078.8024478,0.7145317,1577.0793422,984.3352689,2304.8968929,0.9296882,1.5591344,2.0344439,4.5453265),(19387,'metacarpus.tif',241,5,21,314.7811248,62.5613256,81.7126799,1.8,62.584336,82.3643677,0.0931593,14.6126349,18.5540823,13368.4553248,28207.0803721,0.4539952,1520.2627599,914.8559041,2131.9222738,0.4648441,0.8380096,0.9827937,1.9721664),(19388,'metacarpus.tif',241,5,22,310.4072069,62.6478906,81.871103,1.8,62.6699446,82.4827556,0.0842528,14.0695228,17.9760005,12784.8666626,26677.2496599,0.3663701,1484.0481152,908.6922733,2185.6446507,23.6277148,32.592167,3.0845119,100.0615943),(19389,'metacarpus.tif',241,5,23,306.5312553,62.7283899,82.0379044,1.8,62.7253443,82.6323451,0.0775238,13.665624,16.8564373,12261.4424699,25358.0585364,0.3064243,1504.3545719,897.2471739,2135.5910102,0.4648441,0.6573888,2.3561945,1.3147776),(19390,'metacarpus.tif',241,5,24,304.0406549,62.7846137,82.205857,1.8,62.7621176,82.7888025,0.0688056,13.6974925,16.8129319,11826.1418273,24173.7567131,0.23952,1437.8073295,863.3800535,2082.6515501,0.8087311,1.4882272,0.8960554,3.7517881),(19391,'metacarpus.tif',241,5,25,302.6920209,62.9412438,82.3621839,1.8,62.9073974,83.0831852,0.0603774,13.6770928,16.3639743,11503.2674461,22921.8710302,0.1836829,1400.7520827,841.0608624,2055.346285,22.7089894,30.5031235,3.0040059,94.7460889),(19392,'metacarpus.tif',241,5,26,300.3339496,62.985351,82.5354373,1.8,62.9256876,83.274426,0.0529399,13.4145186,16.3448028,11179.0766887,21897.7922014,0.140156,1339.7403762,833.3565326,1994.7074533,0.6240074,1.5591344,1.1071487,3.5592433),(19393,'metacarpus.tif',241,5,27,297.6031402,63.0380027,82.7061683,1.8,63.0023572,83.44443,0.0476247,13.3934455,16.0244068,10895.7535135,21017.5565299,0.1124134,1311.5965396,813.5138566,1934.1124016,0.4648441,0.734983,1.8925469,1.7796217),(19394,'metacarpus.tif',241,5,28,295.4425692,63.0840158,82.8530295,1.8,63.0526855,83.6083682,0.0406388,13.968724,15.4951264,10644.1812487,20255.5278996,0.0812757,1307.2192712,762.0009701,1908.3850144,1.3326817,7.5097859,1.1902899,18.068516),(19395,'metacarpus.tif',241,5,29,293.8800324,63.1265905,82.9915946,1.8,63.103358,83.7073293,0.0296699,12.891662,15.2621269,10421.2781678,19625.9196718,0.0431042,1285.9229749,808.3735171,1869.7182589,1.2711342,7.5097859,1.1902899,16.9696427),(19396,'metacarpus.tif',241,5,30,290.7974218,63.1568443,83.0965513,1.8,63.1178499,83.848744,0.016741,12.794695,15.4209506,10119.8361079,18961.2362842,0.0135811,1229.5763554,790.9400055,1840.441323,0.9296882,1.692058,1.2924967,4.0240874),(19397,'metacarpus.tif',241,5,31,289.8398109,63.1818627,83.2283087,1.8,63.1717843,83.9174668,0.006524,12.5578729,15.3884507,9951.9070281,18342.7920139,0.0020554,1191.9843251,792.4834952,1816.0882658,0.8386879,4.7061876,1.2178059,10.1798505),(19398,'metacarpus.tif',241,5,32,290.7705919,63.1891813,83.4120464,1.8,63.2148844,84.1263255,-0.0084457,12.9913816,15.1225329,9931.5811064,17698.1121961,0.0034563,1170.314015,764.4745899,1811.285506,0.9036857,6.691979,1.2160907,14.8613267),(19399,'metacarpus.tif',241,5,33,290.5110831,63.3100989,83.5340669,1.8,63.3102171,84.2772904,-0.0224383,13.7328066,14.7456027,9901.1329835,16974.1915983,0.0243728,1151.1358273,720.9839375,1758.1350256,1.5171622,9.1563664,1.152572,21.8436637),(19400,'metacarpus.tif',241,5,34,289.4759288,63.3518524,83.6836167,1.8,63.3287082,84.3993944,-0.0323018,13.3978169,14.6896012,9797.9126161,16439.6520567,0.0503225,1119.1353571,731.3066533,1756.4575051,1.1782148,5.2230357,1.2068174,13.0583454),(19401,'metacarpus.tif',241,5,35,288.5440838,63.4045149,83.8136633,1.8,63.393951,84.5387979,-0.0388574,13.5017623,15.2219289,9695.9823333,15976.9933192,0.0725752,1049.6037287,718.1271681,1670.3170271,1.4874097,8.3316088,1.1695675,19.4066532),(19402,'metacarpus.tif',241,5,36,287.2004262,63.4519482,83.9316293,1.8,63.4552376,84.6539777,-0.0468671,13.6053423,14.2062787,9601.4599117,15554.3551036,0.1050631,1094.8930028,705.7124866,1587.9202441,0.7687704,5.8105509,1.2870022,12.6966156),(19403,'metacarpus.tif',241,5,37,285.3647938,63.5015641,84.0303173,1.8,63.4942256,84.7180472,-0.0497088,13.4983618,14.0584614,9504.4357896,15161.0153669,0.117424,1078.4263617,704.117724,1672.5281588,1.3981013,7.1297141,1.2387369,17.2983371),(19404,'metacarpus.tif',241,5,38,284.8386062,63.5577169,84.1221121,1.8,63.5436969,84.7777688,-0.0509868,12.882893,14.0166739,9439.7883394,14795.0530571,0.1233064,1055.5323702,732.7382376,1662.4982285,1.2425986,10.7141265,1.1459642,23.1818008),(19405,'metacarpus.tif',241,5,39,284.270856,63.6074512,84.2077278,1.8,63.5938049,84.8618315,-0.0550175,12.8305234,14.1018805,9335.2058869,14456.9468027,0.1432658,1025.1786483,727.5779482,1616.2576619,1.0110924,7.2088309,1.2082521,15.9835595),(19406,'metacarpus.tif',241,5,40,284.0127713,63.6613639,84.2924869,1.8,63.6182626,84.9323868,-0.054058,12.3541866,13.9194125,9261.9224357,14164.5039976,0.1381912,1017.607894,749.6990868,1528.6835867,0.4648441,0.6573888,0.7853982,1.3147776),(19407,'metacarpus.tif',241,5,41,282.6403522,63.8170594,84.3255497,1.8,63.7956579,85.015671,-0.0551426,12.3930043,13.6197408,9162.7177548,13773.9975409,0.1430914,1011.325966,739.3459704,1589.5369171,0.6240074,0.9860832,0.7853982,1.9721664),(19408,'metacarpus.tif',241,5,42,281.2731386,63.8726191,84.4159041,1.8,63.8134936,85.1547817,-0.0519795,12.6128807,13.4718529,9081.3681245,13466.9586609,0.1265459,999.6367048,720.0074541,1506.7474787,1.3888141,7.1297141,1.2387369,16.4484036),(19409,'metacarpus.tif',241,5,43,279.9362418,63.9350376,84.4927733,1.8,63.9085975,85.2123629,-0.0527398,12.9221435,14.0598291,9011.9229402,13188.3825514,0.1296525,938.0186958,697.4015534,1472.9498715,2.522672,13.726681,1.076855,31.0140713),(19410,'metacarpus.tif',241,5,44,279.4537285,63.9884353,84.5698637,1.8,63.9548855,85.2892511,-0.0518856,12.9868339,13.2559363,8937.9353674,12950.3328275,0.125274,976.9459169,688.2305158,1439.3949064,1.8346863,11.2334647,1.1441688,25.4826616),(19411,'metacarpus.tif',241,5,45,279.1435555,64.0389154,84.6368832,1.8,64.0082262,85.2981527,-0.0565946,12.7917531,13.6754559,8876.4138252,12747.721995,0.1488536,932.1606614,693.916913,1529.9830463,0.9442815,7.1297141,1.2387369,16.1197092),(19412,'metacarpus.tif',241,5,46,279.3726003,64.0842605,84.7154192,1.8,64.0493604,85.3777077,-0.0585658,12.5030732,13.4130498,8866.323479,12569.6794743,0.1595227,937.1231476,709.1315339,1495.1820528,1.5979464,11.9984711,1.1938871,26.9335889),(19413,'metacarpus.tif',241,5,47,278.3943963,64.1251206,84.7864171,1.8,64.0750024,85.4221532,-0.0638741,12.6929017,13.1616814,8820.5743293,12400.8123098,0.1890452,942.1905846,694.9218193,1446.584577,0.6972661,3.3277771,1.359703,7.2779959),(19414,'metacarpus.tif',241,5,48,277.3069081,64.1725858,84.8481575,1.8,64.1269743,85.4417847,-0.0672712,12.1524291,13.3842593,8780.8473568,12223.0285673,0.2088377,913.2390746,722.5590292,1481.5249063,0.846917,6.8357372,1.259798,15.133626),(19415,'metacarpus.tif',241,5,49,275.5369345,64.2769483,84.8869265,1.8,64.21343,85.5702784,-0.075934,13.3942495,13.2936227,8749.5683872,11972.0661548,0.2642803,900.5871789,653.2331954,1409.9498404,2.0084847,10.8119974,1.1263771,25.0742126),(19416,'metacarpus.tif',241,5,50,274.2805275,64.3219767,84.9601793,1.8,64.284958,85.6906113,-0.0832399,13.4099018,13.1329745,8696.8687492,11767.245549,0.3160104,896.0076416,648.5408238,1427.8843632,1.5301642,10.8119974,1.1263771,25.459302),(19417,'metacarpus.tif',241,5,51,272.4389692,64.3663959,85.0223459,1.8,64.3064862,85.7251446,-0.0875005,12.5195713,13.1096206,8613.9921905,11570.5360572,0.3467606,882.5988503,688.0421063,1417.6412145,3.1788085,15.1520631,1.0040671,36.9305705),(19418,'metacarpus.tif',241,5,52,271.6825091,64.411034,85.0829378,1.8,64.3840066,85.7973136,-0.092524,12.8048158,13.4560825,8537.4716189,11418.2916895,0.3865254,848.559874,666.7391225,1365.1863985,1.8212893,8.3316088,1.1695675,20.6650357),(19419,'metacarpus.tif',241,5,53,270.9362145,64.4553969,85.1398275,1.8,64.4526498,85.8613019,-0.0938162,12.7720506,12.802393,8489.9988089,11280.5481977,0.3962738,881.1280978,664.7326302,1381.2827326,1.6120984,9.1563664,1.152572,21.3224245),(19420,'metacarpus.tif',241,5,54,269.8942014,64.5048037,85.1843655,1.8,64.4904097,85.8622251,-0.0921706,12.6010482,13.0378808,8431.5612816,11124.1872337,0.3810622,853.2205024,669.1158677,1376.6910885,1.5565724,7.2088309,1.2082521,17.7631812),(19421,'metacarpus.tif',241,5,55,269.2857725,64.5603949,85.2258337,1.8,64.5626303,85.8865879,-0.0892058,12.339401,12.8969626,8364.9385324,10994.9004198,0.3562004,852.5185953,677.9047462,1385.5272623,0.6972661,2.4265573,1.2793395,5.4186196),(19422,'metacarpus.tif',241,5,56,268.7862675,64.6104177,85.2640154,1.8,64.5918648,85.8740023,-0.0867688,12.3678716,12.8259646,8304.497337,10888.009491,0.3364272,848.9037562,671.4572718,1403.2424638,1.9544735,10.0829384,1.1174576,23.4871356),(19423,'metacarpus.tif',241,5,57,267.3516926,64.7197542,85.2834985,1.8,64.7358087,85.9816914,-0.0843937,12.4411287,12.9857095,8291.2507066,10723.5495541,0.316606,825.7961965,666.4387869,1340.0583772,0.6972661,2.4265573,1.2793395,5.6111644),(19424,'metacarpus.tif',241,5,58,265.9243696,64.7648747,85.3426341,1.8,64.7449579,86.0794802,-0.0844967,12.3945789,12.8728921,8211.731268,10585.8442659,0.3156823,822.3361267,662.5260418,1298.974772,2.4464384,13.003177,1.1471274,31.2863707),(19425,'metacarpus.tif',241,5,59,264.7021097,64.8126981,85.3901988,1.8,64.822223,86.1447279,-0.0833272,12.3614856,12.8342558,8138.8410955,10449.2590253,0.3056136,814.1694549,658.4031537,1314.0215155,0.9296882,2.9399321,1.2490458,6.8695469),(19426,'metacarpus.tif',241,5,60,263.8216164,64.862366,85.419818,1.8,64.8924934,86.1165059,-0.0860387,12.730097,12.6898169,8076.3360458,10350.1993085,0.3246933,815.6303098,634.4284761,1323.0007365,2.1514074,14.0533673,0.9736197,30.9343167),(19427,'metacarpus.tif',241,5,61,263.1866358,64.9135453,85.4504521,1.8,64.933526,86.132354,-0.0802723,12.9556984,13.1143035,8023.1589753,10275.0464662,0.2820386,783.4992112,619.2764559,1287.3195475,2.2572234,14.7894217,1.0438531,32.4649986),(19428,'metacarpus.tif',241,5,62,262.7243719,64.9614724,85.4740149,1.8,64.9839683,86.1386842,-0.0809584,12.2363815,12.9303958,7975.7765999,10206.4042888,0.2863665,789.3342489,651.8084282,1335.6073286,1.3888141,6.910404,1.2277724,15.6548651),(19429,'metacarpus.tif',241,5,63,262.7893759,65.0042514,85.4968407,1.8,65.0683075,86.1326354,-0.0872636,12.0227882,12.6957311,7944.7280442,10168.1270952,0.3326736,800.9091423,660.8057888,1294.1901747,0.5735511,1.9858148,1.2120257,4.2963868),(19430,'metacarpus.tif',241,5,64,262.9213812,65.0352156,85.5238673,1.8,65.0605778,86.1543278,-0.0916513,12.2992818,12.6712854,7924.2371064,10125.1161471,0.367058,799.0599075,644.2845372,1319.6708866,0.7759433,4.2856506,1.3521274,9.5224617),(19431,'metacarpus.tif',241,5,65,260.9876779,65.1327955,85.5190395,1.8,65.1631773,86.1886702,-0.0899106,12.2322655,12.843024,7878.3401881,9993.1046239,0.3506862,778.0959227,644.0622284,1263.7394005,1.9721695,11.0492175,1.1824776,25.5390567),(19432,'metacarpus.tif',241,5,66,259.9766526,65.1680691,85.5562774,1.8,65.1896462,86.2734431,-0.0905645,12.8026858,12.8178516,7846.2034378,9908.1499979,0.3544127,772.9961565,612.8560488,1279.0765521,0.9561252,6.6148472,1.2490458,14.2836925),(19433,'metacarpus.tif',241,5,67,259.0797405,65.2057072,85.5879561,1.8,65.2273359,86.3381521,-0.0947038,12.6019236,12.7584096,7805.5804886,9836.2793792,0.3861153,770.9643836,619.3959541,1282.3697717,1.0345652,6.4284759,1.3521274,14.0911478),(19434,'metacarpus.tif',241,5,68,258.9321349,65.2458806,85.6011305,1.8,65.2693193,86.2922187,-0.0940393,12.3405249,12.5749929,7772.2761607,9787.9602003,0.3805144,778.3670568,629.8173089,1248.0157759,0.8239107,4.5663685,1.3134726,9.9873057),(19435,'metacarpus.tif',241,5,69,258.3525821,65.2860124,85.6076439,1.8,65.313853,86.274031,-0.0971338,12.0455472,12.5214618,7726.9307922,9737.0231428,0.404981,777.6267088,641.4761127,1279.7930355,0.6203263,1.251631,1.1902899,2.9018545),(19436,'metacarpus.tif',241,5,70,257.8311417,65.3193812,85.6246343,1.8,65.3336615,86.3086595,-0.0939344,12.9563834,12.612863,7702.9944272,9683.1309572,0.3780541,767.7187112,594.5327637,1261.0376256,0.5841269,3.3841159,1.2924967,7.2779959),(19437,'metacarpus.tif',241,5,71,257.746052,65.3578438,85.6358807,1.8,65.3778769,86.2946634,-0.0937927,12.1935408,12.5271928,7684.0243283,9639.270844,0.3767935,769.4677468,630.1716977,1279.8875242,0.4648441,0.8380096,0.9827937,1.7796217),(19438,'metacarpus.tif',241,5,72,257.2799085,65.3882158,85.6482763,1.8,65.4158551,86.2756757,-0.0963607,11.9525147,12.4536751,7652.4957716,9586.2443616,0.3969257,769.7522472,640.2414873,1292.0397691,0.6620684,1.039423,1.1071487,2.4370105),(19439,'metacarpus.tif',241,5,73,255.5951392,65.4593139,85.633627,1.8,65.4785563,86.3660912,-0.1063916,12.0638677,12.475479,7610.3350859,9482.886125,0.48037,760.1220067,630.8370803,1248.2160436,0.6972661,1.1621102,0.9272952,2.6295552),(19440,'metacarpus.tif',241,5,74,254.1187889,65.4782545,85.6426108,1.8,65.4916685,86.3536497,-0.1159108,12.363508,12.3846088,7539.7827786,9396.8691914,0.5664822,758.7538153,609.8417056,1223.247879,0.701806,4.118529,1.2847449,9.0576176),(19441,'metacarpus.tif',241,5,75,253.0274047,65.5039323,85.6596667,1.8,65.540825,86.3903504,-0.1191999,12.5517257,12.4159816,7486.8118141,9329.084677,0.5963616,751.377133,596.476692,1245.6437024,20.0705053,23.4054877,0.5659676,73.3342339),(19442,'metacarpus.tif',241,5,76,252.8096714,65.5299053,85.6713275,1.8,65.569876,86.3666925,-0.1173955,12.7080025,12.666948,7479.8128482,9323.4891277,0.5780274,736.0485826,588.590759,1208.7177049,2.1946443,13.0860006,0.9877198,28.8260006),(19443,'metacarpus.tif',241,5,77,252.7574357,65.557854,85.673781,1.8,65.5837323,86.3556645,-0.1153393,12.1904276,12.2982171,7457.1107357,9334.5672479,0.5579298,759.0179274,611.7185513,1226.9571023,20.0380597,23.3743089,0.7291196,73.3342339),(19444,'metacarpus.tif',241,5,78,252.5647316,65.5758086,85.6739197,1.8,65.5789379,86.3364441,-0.1172262,12.1618235,12.5625599,7439.3548758,9335.1071273,0.5758102,743.0895615,611.6973225,1257.347165,0.5735511,3.1008967,1.3439975,6.6206071),(19445,'metacarpus.tif',241,5,79,252.6949853,65.5908541,85.6621128,1.8,65.5868853,86.2736377,-0.1195764,12.0125147,12.4197016,7390.0511113,9346.6504143,0.5993275,752.5664256,615.1960096,1239.4521259,0.4648441,0.8380096,0.9827937,1.7796217),(19446,'metacarpus.tif',241,5,80,253.0820959,65.6092318,85.6570586,1.8,65.6071321,86.2649634,-0.1213351,11.8810643,12.21639,7366.119672,9357.2235251,0.6179453,765.9565165,619.9882022,1229.3488556,19.6920194,23.4054877,0.5659676,72.4843004),(19447,'metacarpus.tif',241,5,81,252.3638263,65.7024026,85.6154477,1.8,65.7129053,86.2809027,-0.1221713,12.261148,12.3946386,7332.4564741,9311.9488344,0.6246711,751.2884517,598.0236483,1258.1784335,0.4648441,1.469966,1.2490458,3.1741539),(19448,'metacarpus.tif',241,5,82,251.6780669,65.7150481,85.6273541,1.8,65.7281035,86.3049618,-0.1301592,12.0990714,12.3035352,7297.4368867,9285.1254659,0.7066252,754.6713441,603.1402458,1240.9293311,0.4648441,0.9583006,1.815775,2.2444657),(19449,'metacarpus.tif',241,5,83,250.636152,65.7218657,85.633105,1.8,65.7101231,86.2713337,-0.1352835,12.5209485,12.5465176,7246.0529847,9263.6571497,0.7598549,738.344887,578.7143849,1233.8050066,0.4648441,2.1428253,1.3521274,4.5686861),(19450,'metacarpus.tif',241,5,84,250.2491723,65.7366858,85.6351094,1.8,65.7287494,86.3345138,-0.1418438,12.4259478,12.5029608,7210.4750457,9266.9414128,0.8335412,741.1797539,580.2756607,1216.279143,0.4648441,2.370249,1.3734008,5.2260749),(19451,'metacarpus.tif',241,5,85,250.3265683,65.7517133,85.6269966,1.8,65.7669819,86.2327539,-0.1487586,12.5847482,12.6037717,7180.9486417,9296.6032581,0.9164603,737.6048627,570.6072541,1186.6698863,0.5647046,2.2890916,1.152572,4.9537756),(19452,'metacarpus.tif',241,5,86,250.1518054,65.7657763,85.6199406,1.8,65.7659934,86.2050345,-0.1528673,11.9476918,12.523618,7144.0016078,9310.1712881,0.966708,743.4090791,597.9398985,1226.0516606,0.5610928,2.2049491,1.2490458,4.9537756),(19453,'metacarpus.tif',241,5,87,250.0050347,65.7822067,85.6065829,1.8,65.7868589,86.2302606,-0.1568643,11.9359401,12.4045044,7104.0835417,9325.9859966,1.016904,751.8225396,595.1842475,1215.1244827,0.4648441,1.039423,1.1071487,2.2444657),(19454,'metacarpus.tif',241,5,88,249.7464753,65.7933683,85.5831769,1.8,65.7844849,86.1907096,-0.1580608,11.8695575,12.3838396,7032.4548217,9342.5981856,1.0312792,754.4185367,592.4782615,1238.634856,0.4648441,1.692058,1.2924967,3.638998),(19455,'metacarpus.tif',241,5,89,248.0987997,65.8524687,85.5352886,1.8,65.8776105,86.195474,-0.1622328,11.9735931,12.4114563,6985.7337155,9284.228882,1.0787893,748.0370305,583.4283549,1201.4951121,0.5298221,2.650019,1.3045443,5.690919),(19456,'metacarpus.tif',241,5,90,246.4992183,65.8544556,85.5155047,1.8,65.8408705,86.1391644,-0.1694933,12.4308236,12.515269,6926.1090758,9250.6953053,1.168977,739.1527321,557.1721809,1179.480171,19.2910291,23.5939852,0.5961991,72.0194563),(19457,'metacarpus.tif',241,5,91,245.8160944,65.85937,85.4977124,1.8,65.8601465,86.1904784,-0.1697383,12.5593831,12.6746377,6882.8247325,9238.6693759,1.1690777,728.9099373,548.0225144,1199.3783399,0.4648441,1.1851245,1.7681919,2.7093098),(19458,'metacarpus.tif',241,5,92,244.9800284,65.8730419,85.4652363,1.8,65.8721645,86.166317,-0.1613479,12.2825844,12.4412695,6816.0645399,9224.8463598,1.0537405,741.4714651,554.9373262,1192.4875421,0.4648441,1.469966,1.2490458,3.1741539),(19459,'metacarpus.tif',241,5,93,244.2581248,65.8772254,85.4201779,1.8,65.8732223,86.0487688,-0.1558193,11.9314938,12.418018,6733.3291312,9245.8224981,0.9804424,744.5489667,564.3324498,1186.8405076,0.5481872,2.4265573,1.2793395,5.2260749),(19460,'metacarpus.tif',241,5,94,244.5124608,65.8755678,85.4039946,1.8,65.8835634,86.0899311,-0.1653581,12.0301836,12.4619432,6710.3095699,9297.3005149,1.1041766,746.0554418,557.7894576,1188.0604564,0.4648441,0.9583006,1.815775,2.2444657),(19461,'metacarpus.tif',241,5,95,244.7041663,65.8747213,85.3771696,1.8,65.8818114,85.9871188,-0.1749503,11.848659,12.4306069,6683.79128,9364.1355786,1.2356172,753.3128259,564.0968537,1160.5822288,0.5154057,1.1621102,0.9272952,2.4370105),(19462,'metacarpus.tif',241,5,96,244.644908,65.8742627,85.371645,1.8,65.8497911,85.988475,-0.1845685,11.8336691,12.5037767,6676.6978741,9396.8248796,1.3732909,751.5189299,564.2119808,1173.424306,18.826185,23.7571252,0.5337082,71.8269116),(19463,'metacarpus.tif',241,5,97,243.8987444,65.9249538,85.3641676,1.8,65.9393066,86.0250801,-0.1900018,12.6188777,12.4857928,6699.4778254,9376.1162281,1.4499096,750.9428007,530.9091634,1214.7504922,0.4648441,0.9583006,1.815775,2.2444657),(19464,'metacarpus.tif',241,5,98,243.3726878,65.9372202,85.3684408,1.8,65.9712718,85.99864,-0.1894014,12.2181032,12.6282267,6686.6553632,9385.4752624,1.4377632,743.214031,547.2744222,1182.5976478,0.6972661,1.469966,1.2490458,3.3666986),(19465,'metacarpus.tif',241,5,99,242.6141487,65.9464371,85.3624436,1.8,65.9716357,86.0043484,-0.1913189,12.2124763,12.6399678,6674.7471687,9392.8139651,1.4620927,743.1042635,546.5514962,1168.3729299,0.6807381,2.650019,1.3045443,6.0760084),(19466,'metacarpus.tif',241,5,100,242.2013049,65.9622222,85.344938,1.8,65.953246,85.9409717,-0.1879463,12.0857587,12.6559709,6673.9113872,9435.4397863,1.4092004,745.532673,552.2128615,1169.4077472,1.8443767,12.1860982,0.9616329,26.5815349),(19467,'metacarpus.tif',241,5,101,242.2496774,65.98517,85.3340058,1.8,65.9952197,85.9590796,-0.1810928,12.1766352,12.5487519,6689.1716157,9475.7557538,1.3096679,755.1153926,549.3448299,1217.1713988,0.6203263,1.692058,1.2924967,3.8315427),(19468,'metacarpus.tif',241,5,102,242.402554,66.0004963,85.3241654,1.8,65.9971566,85.9109789,-0.1752415,12.8332076,12.6853547,6710.340401,9533.1717214,1.2280311,751.5100662,522.88879,1221.5258665,0.5801274,3.1612815,1.2722974,6.8131519),(19469,'metacarpus.tif',241,5,103,243.0095424,66.0034083,85.3069649,1.8,65.9803694,85.8440693,-0.1710271,11.7691201,12.6866863,6719.935376,9618.5056681,1.1731754,758.1574461,570.9802688,1223.5657982,0.4648441,1.039423,1.1071487,2.2444657),(19470,'metacarpus.tif',241,5,104,243.6757728,66.0167471,85.2940395,1.8,66.0156153,85.8110335,-0.1660882,11.5824289,12.4274002,6733.5968325,9687.3622587,1.1100475,779.5163969,581.3631062,1244.5209767,0.232422,0.5197115,2.0344439,1.1222329),(19471,'metacarpus.tif',241,5,105,242.456885,66.0742696,85.242066,1.8,66.0960129,85.787703,-0.162466,13.3031104,12.5692329,6735.9450504,9701.5288504,1.0572647,771.8473323,506.3436164,1235.2009651,0.4648441,0.9583006,1.815775,2.2444657),(19472,'metacarpus.tif',241,5,106,241.3434018,66.0890068,85.2347032,1.8,66.0948147,85.8041765,-0.1564041,11.9406169,12.6926076,6724.2451841,9725.5019526,0.9759684,766.2335607,563.1405188,1254.4871863,0.4648441,0.734983,1.8925469,1.7796217),(19473,'metacarpus.tif',241,5,107,240.6311235,66.1176098,85.2189646,1.8,66.1134504,85.7870074,-0.1483948,12.4283008,12.7500759,6721.6278718,9764.2965327,0.8766918,765.8226193,540.8324096,1209.7549516,0.232422,1.643472,1.7126934,3.4464532),(19474,'metacarpus.tif',241,5,108,240.1365786,66.1393176,85.2059913,1.8,66.1602462,85.7732917,-0.1418367,12.1692826,12.7322047,6724.7094355,9830.6207281,0.7997782,772.1067132,552.597032,1243.8420907,0.232422,0.734983,1.8925469,1.5870769),(19475,'metacarpus.tif',241,5,109,240.0617527,66.1536379,85.1913536,1.8,66.1748665,85.7726073,-0.1350957,12.407086,12.8346196,6724.0380483,9913.9259569,0.7257888,772.436293,541.9514354,1232.3264349,19.4596801,24.1584792,0.5239193,72.7332401),(19476,'metacarpus.tif',241,5,110,240.1982596,66.1761597,85.1744302,1.8,66.1867548,85.6721386,-0.1268332,13.030184,12.8431101,6717.2340325,10002.7866632,0.6405512,778.8445749,515.5133655,1190.4925343,19.2910291,24.2265833,0.489393,72.5406954),(19477,'metacarpus.tif',241,5,111,239.8732556,66.1924984,85.1497509,1.8,66.2152048,85.6225134,-0.1219602,12.2676063,12.9089722,6707.9231328,10107.2722389,0.5917139,782.9649113,546.7996766,1196.3504569,19.2910291,24.245529,0.5108229,73.0619345),(19478,'metacarpus.tif',241,5,112,238.7982412,66.2245824,85.1265841,1.8,66.2757713,85.5948048,-0.1141377,12.2670144,12.7908007,6683.8832792,10205.2681499,0.516239,797.8599895,544.8663452,1268.8038053,0.232422,0.734983,1.8925469,1.5870769),(19479,'metacarpus.tif',241,5,113,237.2038817,66.294147,85.0810683,1.8,66.3127701,85.6231789,-0.0997555,11.8904349,12.9108896,6658.2414519,10224.9900608,0.3921049,791.9663477,559.9661851,1253.542634,19.2910291,24.3865992,0.3911254,73.3906289),(19480,'metacarpus.tif',241,5,114,235.9975659,66.3284859,85.0632537,1.8,66.3683459,85.5906141,-0.0922275,12.4537385,12.9280613,6615.9159903,10269.9032387,0.3336145,794.3885034,531.2393521,1232.0149577,19.2910291,24.4485447,0.4211201,73.3342339),(19481,'metacarpus.tif',241,5,115,234.5126542,66.354362,85.0417686,1.8,66.3818014,85.5763603,-0.0831724,11.9629317,12.8741575,6587.7459062,10305.2733637,0.2697563,800.4619598,550.6798902,1247.6242796,19.2910291,24.4761484,0.3999043,73.3342339),(19482,'metacarpus.tif',241,5,116,233.536038,66.3800036,85.0255629,1.8,66.4262927,85.5116709,-0.0780153,11.7424421,12.8879016,6577.6955045,10396.2244993,0.2364181,806.6654156,560.1641846,1247.4720315,0.232422,1.1851245,1.7681919,2.5167651),(19483,'metacarpus.tif',241,5,117,233.2185314,66.3864527,85.0052413,1.8,66.412005,85.4517261,-0.0751362,11.66532,13.0894166,6587.7931893,10534.5401629,0.2190243,804.813572,564.7331751,1238.0111107,0.232422,0.3286944,2.3561945,0.6573888),(19484,'metacarpus.tif',241,5,118,232.4761328,66.3963253,84.9794026,1.8,66.4176375,85.3797022,-0.0731658,11.6884862,13.1488655,6586.3650186,10631.2317412,0.2070465,808.5284436,563.491705,1288.3927547,0.4648441,0.6573888,0.7853982,1.3147776),(19485,'metacarpus.tif',241,5,119,232.2884542,66.3974559,84.9571165,1.8,66.452075,85.3279791,-0.0691528,11.6363452,13.2612995,6588.6760612,10741.6878694,0.1848428,810.0026585,566.2152479,1289.3369678,0.232422,0.3286944,2.3561945,0.6573888),(19486,'metacarpus.tif',241,5,120,232.091625,66.4008542,84.9312425,1.8,66.4487172,85.2727343,-0.0656854,11.4885119,12.9552595,6600.8968271,10832.8537925,0.1666559,836.1742051,574.5649972,1295.2396023,19.2680326,24.781029,0.4048918,74.3203171),(19487,'metacarpus.tif',241,5,121,230.4930912,66.4461083,84.8859891,1.8,66.4767768,85.2858239,-0.0606255,11.9223291,13.3207631,6587.9152312,10838.8887612,0.141021,813.6837722,552.5694843,1281.9871614,19.2910291,24.782119,0.3543799,74.5926164),(19488,'metacarpus.tif',241,5,122,229.5614426,66.4544128,84.8502085,1.8,66.4953626,85.2667114,-0.0585215,11.8045707,13.3692998,6556.6191071,10866.4229694,0.1308827,812.7892366,555.4305444,1282.9967654,19.2910291,24.8528614,0.4343673,74.4564668),(19489,'metacarpus.tif',241,5,123,228.7669229,66.4534386,84.8052127,1.8,66.456685,85.2102629,-0.0604424,11.9881768,13.7053467,6524.9883469,10906.3580396,0.139122,795.7739635,544.2852964,1261.615128,19.2910291,24.904973,0.3926375,74.4564668),(19490,'metacarpus.tif',241,5,124,228.4837272,66.455352,84.7538124,1.8,66.4587793,85.1329667,-0.0607375,11.7795661,13.3804753,6514.493784,10982.9822159,0.1403082,820.8215294,553.0334271,1277.9483936,19.2910291,25.0002288,0.2923473,74.6490115),(19491,'metacarpus.tif',241,5,125,227.88733,66.4655655,84.6909433,1.8,66.4926428,85.0778744,-0.0612286,11.4963857,13.4239712,6500.9710568,11065.650179,0.1422113,824.3201655,565.4795553,1285.0741897,19.2910291,25.0002288,0.2923473,74.6490115),(19492,'metacarpus.tif',241,5,126,227.4256881,66.4700305,84.6308041,1.8,66.4923564,84.9577265,-0.060418,12.1845203,13.5777575,6508.6253305,11130.9849149,0.1381948,819.795531,534.1716519,1293.7271858,19.0586071,25.0865111,0.2337432,74.9777059),(19493,'metacarpus.tif',241,5,127,227.588894,66.4796755,84.5906071,1.8,66.510313,84.9215494,-0.0602291,11.5884561,12.9424404,6515.3896477,11217.9506391,0.1374314,866.7569851,562.2310346,1327.5997403,19.2910291,25.1639123,0.3685001,75.3064003),(19494,'metacarpus.tif',241,5,128,227.3872357,66.479375,84.5370582,1.8,66.4941087,84.8383318,-0.0613218,12.0377135,13.6509237,6486.8829226,11278.3927791,0.1423311,826.1999729,538.8799916,1284.0159959,19.2910291,25.1810802,0.1575616,74.9777059),(19495,'metacarpus.tif',241,5,129,225.4816719,66.5255961,84.4615297,1.8,66.5066256,84.805226,-0.0603391,11.7926632,13.6433314,6437.0270186,11236.9162992,0.1366561,823.619684,545.8501557,1281.9793005,19.2910291,25.3116029,0.1289108,75.0341009),(19496,'metacarpus.tif',241,5,130,224.1183707,66.5189246,84.4111733,1.8,66.507079,84.7562483,-0.059704,12.5568652,13.680382,6376.6578833,11221.2609304,0.1329892,820.2447051,507.8224369,1270.5197352,19.2910291,25.3755481,0.1470784,74.8979512),(19497,'metacarpus.tif',241,5,131,222.7440854,66.5115484,84.3613628,1.8,66.4931598,84.7450867,-0.059292,11.5394606,13.3486842,6320.0369402,11202.5959488,0.1303576,839.2284788,547.6891139,1272.7791401,19.2910291,25.4870662,0.1741439,74.8979512),(19498,'metacarpus.tif',241,5,132,220.8468374,66.5096635,84.2924271,1.8,66.4587176,84.6351522,-0.0596548,11.9900122,13.0757214,6230.8040789,11214.9319336,0.1308319,857.6912605,519.666198,1281.5990434,19.2910291,25.5928221,0.0454233,75.0107413),(19499,'metacarpus.tif',241,5,133,219.9456364,66.5093242,84.2360768,1.8,66.4728727,84.5307766,-0.0594152,12.3195443,13.9263825,6163.375965,11255.2114378,0.1292546,808.1934704,500.2925269,1230.0779878,19.2910291,25.718105,0.1086612,75.146891),(19500,'metacarpus.tif',241,5,134,219.4702113,66.5069944,84.1866885,1.8,66.4579903,84.4726656,-0.0554016,11.5391755,13.3253604,6093.6227564,11304.6415623,0.1121561,848.3554077,528.0812961,1275.7972457,19.0586071,25.8030336,0.1355277,74.9543463),(19501,'metacarpus.tif',241,5,135,218.4754575,66.5107567,84.1287619,1.8,66.438071,84.419656,-0.0518514,11.5030826,13.9135786,6013.3085388,11350.8099042,0.0978094,815.8080815,522.7562676,1223.8599393,19.0586071,25.9064572,0.1621988,74.8181966),(19502,'metacarpus.tif',241,5,136,217.7955093,66.5180386,84.0769112,1.8,66.4423124,84.3054227,-0.0516229,11.4309555,13.526338,5930.3222974,11426.9226309,0.0966483,844.7905563,518.7949766,1251.0682746,18.826185,26.1151784,0.0801848,75.146891),(19503,'metacarpus.tif',241,5,137,215.9753953,66.571739,84.0065205,1.8,66.4977191,84.2730806,-0.0513622,11.1656877,13.4818313,5819.4642408,11368.310633,0.0948758,843.2319298,521.1917415,1242.4876741,19.0586071,26.2060357,0.1155543,75.0671364),(19504,'metacarpus.tif',241,5,138,214.6503501,66.5542806,83.9599677,1.8,66.4879847,84.2329522,-0.0558782,11.1306862,13.498841,5721.0615627,11383.298363,0.1115864,843.2796818,513.9900138,1226.0973801,19.0586071,26.3294266,0.1506359,75.0671364),(19505,'metacarpus.tif',241,5,139,213.2493332,66.5001132,83.9050608,1.8,66.4907589,84.1356576,-0.0615593,11.4934058,13.748605,5611.4823731,11433.4950762,0.1345163,831.6112833,488.234946,1207.9617336,18.826185,26.5978564,0.0874953,75.2596811),(19506,'metacarpus.tif',241,5,140,213.0883044,66.4754916,83.8498668,1.8,66.5158944,84.0948393,-0.0611777,11.4169662,13.7095518,5535.2619636,11545.4105429,0.1327556,842.1435466,484.8277426,1225.1187067,18.826185,26.695166,0.1221952,75.5319804),(19507,'metacarpus.tif',241,5,141,212.3542708,66.4389347,83.791013,1.8,66.4683096,83.9834998,-0.0620247,11.3091894,13.7708358,5450.7186743,11703.2540963,0.1359821,849.8579395,481.9725358,1240.7706983,18.8228571,26.8987719,0.1125656,75.7245252),(19508,'metacarpus.tif',241,5,142,212.1578017,66.4164027,83.7400471,1.8,66.4335678,83.9056704,-0.058828,11.2970141,13.8199962,5386.0159411,11938.1097677,0.1222291,863.8287281,476.7645589,1245.2907294,18.593763,27.0819052,0.0945449,75.7245252),(19509,'metacarpus.tif',241,5,143,211.926858,66.4089341,83.693928,1.8,66.4077385,83.8094593,-0.0580505,11.3484466,13.8164408,5320.1425362,12187.0147462,0.1188935,882.0661521,468.7991871,1246.299289,18.593763,27.3607238,0.1106572,76.7106084),(19510,'metacarpus.tif',241,5,144,211.4844342,66.4226215,83.6357372,1.8,66.4675511,83.7567586,-0.0580711,10.9770054,14.1450739,5268.9663937,12425.5143443,0.1187295,878.4340361,480.0003464,1236.4899142,18.361341,27.7206521,0.0671259,76.846758),(19511,'metacarpus.tif',241,5,145,210.7614992,66.4672316,83.5832465,1.8,66.4681659,83.7556471,-0.0605719,10.9203159,14.1166302,5216.8245832,12585.0090844,0.1287218,891.5023576,477.7173705,1241.8434838,18.5837789,27.8770833,0.1253891,76.9829077),(19512,'metacarpus.tif',241,5,146,210.2665941,66.4585021,83.5651991,1.8,66.4920354,83.7439106,-0.0617814,11.1252039,14.4333079,5205.0668898,12789.9100619,0.1335923,886.1385197,467.8626066,1245.6015604,18.361341,28.0798143,0.1161416,77.1190574),(19513,'metacarpus.tif',241,5,147,210.910709,66.4469008,83.5338408,1.8,66.465266,83.7031742,-0.0636108,11.1227707,14.5812278,5253.5633556,13046.1008608,0.1420443,894.7189506,472.3250617,1251.93614,0.232422,0.3286944,2.3561945,0.6573888),(19514,'metacarpus.tif',241,5,148,211.7222695,66.4563049,83.5130968,1.8,66.4898618,83.7100254,-0.0627448,10.6854049,14.5782212,5316.2661501,13366.2702185,0.1387399,916.8656446,497.5259423,1266.9812394,18.361341,28.6822355,0.0811224,78.5699847),(19515,'metacarpus.tif',241,5,149,213.8464506,66.4329952,83.5052431,1.8,66.477931,83.6659447,-0.0637046,11.3446617,14.7010872,5429.6132636,13759.7802067,0.1444455,935.970246,478.6051279,1291.1533781,18.593763,28.9335099,0.0884781,79.1709784),(19516,'metacarpus.tif',241,5,150,215.411803,66.4166608,83.5162002,1.8,66.4308844,83.6451132,-0.0647687,10.6215519,14.9347954,5560.6872448,14139.3618231,0.1503973,946.7395738,523.5287008,1313.7142188,18.593763,29.2094494,0.1036275,79.7719722),(19517,'metacarpus.tif',241,5,151,217.8569121,66.3919246,83.5378383,1.8,66.4415563,83.6290839,-0.0622832,10.6480587,15.1648813,5741.4533823,14610.2221356,0.1406692,963.4247622,539.2018915,1301.0819241,18.826185,29.6089621,0.078578,80.8144504),(19518,'metacarpus.tif',241,5,152,220.1699668,66.3528507,83.5486669,1.8,66.3864953,83.6014221,-0.0579557,11.3638875,15.2215037,5961.6223912,15094.7022658,0.1231148,991.6695844,524.6111757,1379.1224407,19.0586071,30.0400426,0.0619362,81.9930783),(19519,'metacarpus.tif',241,5,153,221.0384284,66.3914382,83.5222552,1.8,66.3759033,83.6526368,-0.0560866,11.3445986,15.2215677,6182.0767182,15518.3277682,0.1157651,1019.4960252,544.9356967,1398.5701271,19.276463,30.3433179,0.0920468,82.6738267),(19520,'metacarpus.tif',241,5,154,222.8719819,66.3202836,83.5247809,1.8,66.3552839,83.6573846,-0.0547893,11.629547,15.363622,6425.6438178,15974.7720495,0.1113932,1039.7790323,552.5274407,1434.450109,19.700889,30.7509376,0.0680765,83.9886043),(19521,'metacarpus.tif',241,5,155,222.2012826,66.1635365,83.4942444,1.8,66.2416789,83.6264655,-0.0591031,11.7593713,15.5027439,6615.2591558,16458.8503321,0.1292138,1061.6733673,562.5521128,1437.4081733,19.9730045,31.0829175,0.1048769,84.7821428),(19522,'metacarpus.tif',241,5,156,224.4278398,66.0553359,83.5034162,1.8,66.1711682,83.6511945,-0.0592663,11.5636476,15.8297081,6874.5880287,17203.0013244,0.1312296,1086.7541696,594.4999616,1501.8097414,20.2207173,31.6512396,0.0514252,87.6042427),(19523,'metacarpus.tif',241,5,157,228.6502725,65.9654271,83.5286582,1.8,66.1105109,83.6583248,-0.0607371,11.9400236,16.5334087,7221.7018566,18210.7513807,0.1404087,1101.4517187,604.8314569,1536.9343307,20.4531393,32.175975,0.079542,88.284991),(19524,'metacarpus.tif',241,5,158,232.3573215,65.9063413,83.5524527,1.8,65.9980582,83.689293,-0.0568709,11.5481693,16.6359022,7567.134829,19299.1607795,0.125117,1160.0910205,655.2670517,1607.3161318,20.7210616,32.6790675,0.0925916,90.3369121),(19525,'metacarpus.tif',241,5,159,239.1678198,65.9016165,83.5382696,1.8,65.9574388,83.692156,-0.0502096,12.3611508,17.2886204,8035.000541,20689.2073454,0.1004056,1196.6950984,650.0204309,1659.806717,20.9314624,33.4816832,3.113822,92.7175275),(19526,'metacarpus.tif',241,5,160,247.8268008,65.8395146,83.5426309,1.8,65.8765561,83.7405234,-0.0509745,12.3422922,17.0115677,8521.2603084,22255.7805553,0.1072321,1308.2733438,690.4114875,1766.5186614,21.2535492,34.0131209,3.0732063,94.5769038),(19527,'metacarpus.tif',241,5,161,262.5370698,65.8331133,83.5081216,1.8,65.8754183,83.7536357,-0.0483783,12.6861032,17.4430694,9201.8852395,24375.509381,0.1023295,1397.4323487,725.3515966,1874.8229966,21.9395866,34.9128538,3.0883098,98.2489372),(19528,'metacarpus.tif',241,5,162,286.1312067,65.7039063,83.5079538,1.8,65.7933798,83.8023082,-0.0453936,14.0347326,18.3522391,10229.4309471,27343.4335736,0.0981981,1489.9235687,728.8653991,2026.3044753,22.3787431,35.6962721,2.997854,100.7093073),(19529,'metacarpus.tif',241,5,163,316.669304,65.6708782,83.4964542,1.8,65.7365823,83.8753727,-0.0410882,13.6964624,18.5003887,11344.2565749,31147.282818,0.0890517,1683.6015312,828.2618006,2226.3679188,22.7429628,36.7204753,2.9826874,102.3994984),(19530,'metacarpus.tif',241,5,164,343.6080321,65.7004195,83.4426028,1.8,65.7017738,83.9175164,-0.0328417,14.0223781,19.1157764,12564.9917006,34737.2362392,0.0617458,1817.2024814,896.0671028,2415.8657953,23.1093969,37.6530874,3.0302538,105.653407),(19531,'metacarpus.tif',241,5,165,380.2929837,65.5717346,83.4919331,1.8,65.6524927,84.0160972,-0.0370159,14.045773,19.6639717,14211.0289571,38848.2728128,0.0868048,1975.6066237,1011.7655293,2626.6227679,23.3412528,38.8082169,3.0335809,109.46159),(19532,'metacarpus.tif',241,5,166,389.5207135,65.8249027,83.626968,1.8,65.5976053,84.103479,-0.0244786,13.9279977,20.5946796,14470.6685058,40425.9790555,0.0388924,1962.9331405,1038.9625887,2653.7758429,23.4207286,39.6107435,3.0121431,111.457116),(19533,'metacarpus.tif',241,5,167,390.7963222,65.5664325,83.6518502,1.8,65.4956526,84.1039237,-0.0253974,13.6984487,20.6732994,14006.1515579,42028.2768021,0.042003,2032.9738363,1022.4626095,2685.5435046,23.4174428,40.6625659,2.9576492,114.8238146),(19534,'metacarpus.tif',241,5,168,399.1576529,65.5584631,83.6759309,1.8,65.4871166,84.0886842,-0.0265943,13.3069488,20.8888412,13839.9970349,44717.188829,0.0470398,2140.7213687,1040.0578854,2776.7439659,25.304247,40.978187,2.9475341,158.8495122),(19535,'metacarpus.tif',241,5,169,406.4581617,65.418006,83.6659342,1.8,65.3106232,84.1808952,-0.0438254,15.0209309,21.2396745,14666.570316,46721.6085247,0.1300283,2199.7327955,976.408881,2817.3424369,26.2097391,41.0236418,2.9419749,182.6556664),(19536,'metacarpus.tif',241,5,170,412.0323386,65.3932303,83.6323183,1.8,65.2912693,84.1838714,-0.0511601,14.9747842,21.4786418,15930.1225965,48869.7136258,0.1795821,2275.2702044,1063.796473,3008.5556471,27.3702585,41.0236418,2.9419749,188.4360159),(19537,'metacarpus.tif',241,5,171,410.7913845,65.479402,83.4977324,1.8,65.3203248,84.1224857,-0.0446536,15.4846202,20.85953,17577.7320348,50492.6943238,0.1364249,2420.6055645,1135.1736001,3066.1733107,27.8793956,41.5281665,0.3305999,229.6202618),(19538,'metacarpus.tif',241,5,172,414.6421104,65.5027223,83.4461669,1.8,65.3604893,84.0792862,-0.039656,15.4739266,20.8038444,19082.5425233,52126.2792845,0.1086201,2505.6080124,1233.2062222,3172.1853569,1.9588173,6.0830669,1.4559197,15.8240503),(19539,'metacarpus.tif',241,5,173,419.8532401,65.5623481,83.3984531,1.8,65.4385931,84.064229,-0.0342016,15.6212425,20.7082812,20239.7601211,53956.5798812,0.0818219,2605.555685,1295.6562273,3267.9234082,1.9995401,6.0608252,1.4940244,14.9741168),(19540,'metacarpus.tif',241,5,174,430.8578023,65.5398684,83.4063761,1.8,65.4936869,84.0501469,-0.0318734,16.2009015,20.9047329,21119.5529399,56107.2046686,0.0729273,2683.9474506,1303.6035607,3390.4176842,0.232422,0.3286944,2.3561945,0.6573888),(19541,'metacarpus.tif',241,5,175,442.7533509,65.5659019,83.460372,1.8,65.5030631,84.0375667,-0.0298562,16.1608564,21.267785,21239.5667526,58496.5842999,0.0657591,2750.4784473,1314.259979,3500.9254326,0.4648441,0.8380096,2.1587989,1.7796217),(19542,'metacarpus.tif',241,5,176,453.1657557,65.5723883,83.5388745,1.8,65.5482436,83.9768296,-0.0297327,15.5109638,21.3056545,20582.5452647,60573.1833643,0.0667509,2843.0566792,1326.9675291,3578.0424245,19.4798524,27.6806743,0.8567056,84.8191861),(19543,'metacarpus.tif',241,5,177,454.5535295,65.709222,83.6284469,1.8,65.6853138,84.0418371,-0.0281258,15.500334,22.0390763,18881.9670967,61169.86197,0.0599168,2775.5184126,1218.1651737,3564.7693787,0.4648441,1.9166012,1.815775,4.2963868),(19544,'metacarpus.tif',241,5,178,443.6629659,65.8315351,83.6664503,1.8,65.7530816,83.9990772,-0.0244387,14.8240715,21.9541586,16336.3713891,60114.5369642,0.0441568,2738.1845126,1102.0164979,3445.1992691,0.6972661,0.8380096,2.5535901,2.1083161),(19545,'metacarpus.tif',241,5,179,418.3511239,66.0592433,83.660444,1.8,65.9462713,83.9245823,-0.0196649,14.1633345,21.28139,13172.4253916,55949.2526558,0.026958,2629.0224743,930.0370212,3169.4963843,19.037599,25.5632545,0.8690733,120.1159604),(19546,'metacarpus.tif',241,5,180,373.1110734,66.7359349,83.6029003,1.8,66.3803852,83.7365432,-0.0162921,13.1430124,21.9145675,9574.2368996,46830.4348355,0.0165039,2136.9545552,728.4659423,2561.9597834,19.0586071,24.0149445,0.7443254,107.5554946),(19547,'metacarpus.tif',241,5,181,292.7578241,68.3866308,83.5303258,1.8,67.7815165,83.597979,-0.0128475,12.2497314,23.0881369,6089.7791527,27981.3964097,0.0080521,1211.9382582,497.1357303,1471.6953754,18.761733,24.1584792,0.5239193,102.5549998),(19548,'metacarpus.tif',241,5,182,201.3264963,67.6265498,83.5177609,1.8,68.1647685,83.518747,-0.019436,10.0496982,18.3902407,3145.3223541,14125.4587905,0.0126737,768.0953742,312.9767957,934.5847806,11.1562578,18.087154,1.1186425,59.6378514),(19549,'metacarpus.tif',241,5,183,109.7094871,68.4832259,83.5382053,1.8,67.4473739,83.5391209,-0.0295141,8.7190968,14.8118149,1149.0618703,6338.3003405,0.0159229,427.9219247,131.7868004,493.7757666,9.9941476,13.4984989,1.5191182,40.9119466),(19550,'metacarpus.tif',241,5,184,35.8437783,71.6830334,83.629239,1.8,69.9181919,83.6022327,-0.021817,6.6431724,17.1114286,228.0567208,1510.0251595,0.0028431,88.2465862,34.3294902,100.8915527,2.7890645,8.187724,1.6845883,19.124678),(19551,'metacarpus.tif',241,5,185,4.0813586,75.1444291,83.7461616,1.8,75.0861614,83.7433359,1.4862797,1.4747623,4.1474737,1.3375092,11.8925714,0.6753791,2.8674254,0.906932,3.1828719,2.9989648,8.2534371,1.7405746,19.181073),(19552,'metacarpus.tif',241,5,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19553,'metacarpus.tif',241,5,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19554,'metacarpus.tif',241,5,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19555,'metacarpus.tif',241,5,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19556,'metacarpus.tif',241,5,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19557,'metacarpus.tif',241,5,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19558,'metacarpus.tif',241,5,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19559,'metacarpus.tif',241,5,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19560,'metacarpus.tif',241,5,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19561,'metacarpus.tif',241,5,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19562,'metacarpus.tif',241,5,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19563,'metacarpus.tif',241,5,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19564,'metacarpus.tif',241,5,198,2.2151312,81.8476131,80.9667645,1.8,81.8532438,80.9662765,-1.4858313,2.7961262,2.9385172,3.7824757,4.0426295,0.3665297,1.3757379,1.3527557,2.6005402,5.5781289,6.1756071,1.2252407,18.8854141),(19565,'metacarpus.tif',241,5,199,23.6636753,81.8354454,81.0849984,1.8,81.8327766,81.1164032,-1.0215507,6.2099964,6.4172563,188.5663102,195.5426526,2.8691027,30.4713794,30.3649631,59.8303561,12.4903871,13.0860006,0.9877198,41.9874603),(19566,'metacarpus.tif',241,5,200,48.4766181,81.5476753,81.1645372,1.8,80.8452899,81.3102433,-0.2353447,8.5076786,24.4276163,734.7308235,1006.3783561,0.4392956,41.1983856,86.3609051,69.6405589,2.0640403,3.1269187,2.3036114,11.6074181),(19567,'metacarpus.tif',241,5,201,450.9119593,58.3744619,81.923884,1.8,62.2424884,81.6880389,-0.0367193,16.2394039,32.4487138,20648.2116475,68064.4938251,0.1012849,2097.6022123,1271.4882776,2710.5821019,28.8203327,29.1678082,2.2828798,95.267328),(19568,'metacarpus.tif',241,5,202,550.0754321,58.0384453,81.7631272,1.8,63.0370605,81.6945213,-0.0292003,16.5682591,32.8011669,26274.2549459,87335.3421718,0.0781484,2662.56815,1585.8186889,3403.3092653,29.0527547,29.2934763,2.2381025,95.9247168),(19569,'metacarpus.tif',241,5,203,567.3965042,58.6715183,81.7427874,1.8,63.7774234,81.6509056,-0.0295969,16.5793072,32.2114934,27455.9393748,95490.3285511,0.0828132,2964.4800199,1656.0365939,3715.3623522,0.232422,0.5197115,2.0344439,1.1222329),(19570,'metacarpus.tif',241,5,204,580.9882809,59.1679954,81.7322925,1.8,64.3323191,81.6469359,-0.0299134,16.3458916,31.7520797,28517.0136679,101487.8949695,0.0866182,3196.2597662,1744.5982354,3947.6948408,28.8203327,29.283332,0.7404846,95.7321721),(19571,'metacarpus.tif',241,5,205,592.6228146,59.5590556,81.7232547,1.8,64.7682139,81.6298146,-0.0297026,16.6626602,31.3797891,29534.0060694,106077.9878408,0.0871113,3380.4557319,1772.4664454,4138.3581394,0.4648441,0.6573888,2.3561945,1.3147776),(19572,'metacarpus.tif',241,5,206,602.4539314,59.8500164,81.7109076,1.8,65.10219,81.6024577,-0.0307348,16.6816264,31.1197422,30491.9713057,109579.6840899,0.0948156,3521.227247,1827.8776095,4281.0944929,28.8203327,29.283332,2.3112809,95.5396274),(19573,'metacarpus.tif',241,5,207,610.6232456,60.055869,81.7045629,1.8,65.3382145,81.608468,-0.0314292,16.3536238,30.935407,31302.9312978,112175.0292881,0.1004913,3626.104843,1914.1281219,4389.8985174,28.8970697,57.1521962,0.0855053,185.6372756),(19574,'metacarpus.tif',241,5,208,615.4466426,60.1913187,81.7002767,1.8,65.4869321,81.59936,-0.0318889,16.3762664,30.8121446,31828.2811073,113716.0170072,0.1042677,3690.6232403,1943.5615137,4459.309626,28.9321386,57.346105,0.0770827,182.2472173),(19575,'beisa_femur.tif',241,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19576,'beisa_femur.tif',241,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19577,'beisa_femur.tif',241,7,3,28.3090581,139.150424,89.5867725,1.8,138.9545698,89.3735857,-0.936621,4.5421271,11.9292364,90.5948875,875.4021129,3.0617563,73.3829129,19.9454763,80.5657937,8.7032158,23.329014,1.0067126,55.3952212),(19578,'beisa_femur.tif',241,7,4,101.8598459,138.282596,89.7272347,1.8,138.5536049,89.6327633,-0.9979497,6.5577994,16.3645438,882.6147791,5884.5571676,11.989028,359.591885,134.5900845,413.5143437,13.5785915,31.9477351,1.028217,76.0005463),(19579,'beisa_femur.tif',241,7,5,130.9553499,138.7898458,89.3600721,1.8,139.1498664,89.0762361,-1.0333985,7.8069003,17.7088674,1805.5428987,10834.3603938,16.1065475,611.8042518,231.275259,713.7027304,14.9555888,35.7430055,1.0265158,86.6163027),(19580,'beisa_femur.tif',241,7,6,149.3925799,139.4395149,88.7733938,1.8,139.6117597,88.4856583,-1.032814,8.2312459,19.4219381,2796.54169,14908.2781217,18.3613878,767.5999196,339.7470706,910.6987032,16.8975055,38.4001464,0.9566369,95.9964335),(19581,'beisa_femur.tif',241,7,7,174.7852837,139.7667885,88.1490086,1.8,139.8497326,88.1340834,-1.0323477,9.8169861,21.1624452,4443.9792791,19476.6720705,21.4703719,920.3412871,452.6826479,1130.2886107,19.6172558,40.9719758,0.9528299,102.9625002),(19582,'beisa_femur.tif',241,7,8,196.7980167,139.8247456,88.1969116,1.8,139.9304503,88.2549437,-0.9926955,11.1535764,22.1414852,6295.6830516,23308.2939667,23.006,1052.6978545,564.4542003,1336.9716604,21.7691098,43.0526881,0.9179497,108.4572536),(19583,'beisa_femur.tif',241,7,9,213.0133606,139.6910384,88.5162895,1.8,139.8531296,88.4640766,-0.9302791,12.7780938,22.9842361,8215.4361683,26149.8449984,22.8230341,1137.7295678,642.9312757,1492.084392,23.8980143,44.1809621,0.9145455,111.7164432),(19584,'beisa_femur.tif',241,7,10,268.453574,130.6134332,84.7920213,1.8,127.9192027,83.5435111,0.3656869,23.3624038,57.1358361,26910.3215221,135420.832289,5.7212465,2370.1557823,1151.8644132,2841.1441769,25.5192066,44.614852,0.8876049,114.3661948),(19585,'beisa_femur.tif',241,7,11,473.9925105,113.4935489,77.2521702,1.8,117.4929184,78.5481809,0.3991129,23.5127444,42.6651627,34262.88049,383345.7363722,11.9296691,8984.9824007,1457.2046524,9423.6928634,27.8810167,44.4731191,0.8494131,116.5850088),(19586,'beisa_femur.tif',241,7,12,684.7799625,109.8425379,74.5951704,1.8,114.0189181,76.0242836,0.4090012,25.6800825,47.3959603,50990.2464189,449278.8155842,18.0507748,9479.2638945,1985.5951188,10310.2908652,40.2975707,88.3115293,2.9629616,321.0791334),(19587,'beisa_femur.tif',241,7,13,825.2642968,109.1698174,73.2671248,1.8,112.6648805,74.7475526,0.4034676,28.4220939,48.949664,72117.8801767,487226.3184252,21.2013825,9953.6192549,2537.3880106,11283.4999045,39.9346566,89.6875226,2.9107589,333.9067658),(19588,'beisa_femur.tif',241,7,14,841.6763503,107.2592437,72.3634176,1.8,111.2225837,73.8298689,0.404637,28.3123661,51.1589136,85880.9310543,515297.6393391,21.741613,10072.4898858,3033.3364165,11604.8082179,41.8968132,91.4675792,2.8699394,306.2781866),(19589,'beisa_femur.tif',241,7,15,828.9332001,106.1152711,71.7734269,1.8,110.003137,73.1526702,0.4097801,43.5746182,52.6301948,94239.7325749,526835.5038271,21.9292397,10010.1378344,2162.7207892,11236.50057,42.9930563,92.1218406,2.8308914,299.2312446),(19590,'beisa_femur.tif',241,7,16,821.3777866,105.702388,71.3624225,1.8,109.3660649,72.6554504,0.4215598,47.2582178,59.6228254,100590.2685527,532732.7238926,22.9207786,8935.0466106,2128.5243739,10587.2006905,44.1092659,91.8790207,2.8392303,278.0973568),(19591,'beisa_femur.tif',241,7,17,800.6838907,105.8544708,70.822956,1.8,108.9513581,72.0171748,0.4312451,46.2242452,59.0233162,102803.6386726,519992.080191,23.3166951,8809.9434899,2224.019848,10511.576062,44.3122966,91.2647104,2.7905618,290.5581769),(19592,'beisa_femur.tif',241,7,18,748.1395267,107.0078439,71.3756633,1.8,108.8386126,71.9018478,0.4421642,24.4268797,50.2203149,97208.1917016,485548.12177,22.8301602,9668.3607626,3979.5583001,11582.9155858,43.5890478,89.8318018,2.8085111,295.369555),(19593,'beisa_femur.tif',241,7,19,692.2813177,109.161602,72.3606303,1.8,109.0301257,71.9393904,0.4397854,24.3736611,45.7817743,88213.488266,433730.5969718,20.9137071,9473.8704123,3619.2136995,11396.7552317,42.7892612,86.9751967,2.7172622,273.447729),(19594,'beisa_femur.tif',241,7,20,648.0736132,111.1875208,73.336033,1.8,109.6143323,72.3634273,0.444806,35.7519924,42.206355,77187.1089895,377968.3283944,19.9977439,8955.2468602,2158.9596523,10700.3774471,42.4797512,84.1514764,2.7850604,299.5073699),(19595,'beisa_femur.tif',241,7,21,606.977599,113.5687321,74.9507763,1.8,111.7351548,73.8645868,0.4352742,23.503474,41.2349314,66900.5912062,313916.652306,17.9863968,7612.8816445,2846.4128838,8993.5900822,41.040385,79.811299,2.8501359,281.1612963),(19596,'beisa_femur.tif',241,7,22,576.7715445,115.7819212,76.328711,1.8,115.004339,75.9192272,0.4410491,25.5458293,38.9372162,61356.0093412,252202.6394694,17.5178693,6477.1615465,2401.8014292,7792.5108491,38.9174598,73.8934085,2.8715202,297.685994),(19597,'beisa_femur.tif',241,7,23,558.4185415,116.9714977,77.069692,1.8,116.6457921,76.8286928,0.4598786,25.0668468,36.0265876,57498.1693923,215042.6940013,18.3341257,5968.9997992,2293.793462,7249.2404691,38.0972601,69.1996591,2.8768704,282.5991101),(19598,'beisa_femur.tif',241,7,24,548.324201,117.4278716,77.5604798,1.8,117.3109204,77.4921376,0.480453,45.6114714,34.3408885,54812.6741489,190644.694737,19.5213674,5551.5364688,1201.7300143,4809.5193945,37.6698353,65.4943863,2.874263,260.8557843),(19599,'beisa_femur.tif',241,7,25,534.386077,117.1244946,77.685932,1.8,117.5278739,78.3493305,0.4955447,43.2961161,37.5221803,52690.0827493,166375.0341074,20.1383919,4434.044949,1216.9701939,4589.4839494,37.2108839,62.2581026,2.8934792,264.798349),(19600,'beisa_femur.tif',241,7,26,528.5610209,116.7057382,78.0712034,1.8,117.2807664,78.9332071,0.5075507,35.8769486,31.7200575,51807.9866961,146500.9733953,20.8106038,4618.5595093,1444.0466281,5358.4942236,36.8604073,59.6948886,2.8475536,273.5118544),(19601,'beisa_femur.tif',241,7,27,528.6367124,116.2058245,78.8600607,1.8,116.4334829,79.6428025,0.5311448,37.8406653,30.9087803,53440.1377461,131730.9153259,22.6047921,4261.9253899,1412.2409657,4787.1465213,37.6111716,56.9966821,2.9137356,284.3396107),(19602,'beisa_femur.tif',241,7,28,526.1379613,115.0569499,79.4292052,1.8,114.7731279,80.2061062,0.5635526,33.8348841,28.8845885,54820.5718221,115088.9072448,25.0232959,3984.4399047,1620.2382023,4912.9240072,37.7017757,53.662796,3.0665459,231.7657034),(19603,'beisa_femur.tif',241,7,29,506.9225266,113.9300076,79.5482634,1.8,113.8568239,80.5046767,0.5401078,30.3551821,27.8058351,56316.1099882,102182.5001294,22.340996,3674.8581616,1855.238744,4875.3822461,38.9158324,51.4198151,2.4949617,209.4938149),(19604,'beisa_femur.tif',241,7,30,478.2782774,113.1956892,79.2160328,1.8,112.9154133,80.3027988,0.4943533,36.6526365,27.0486331,55704.6002037,92412.9204011,17.9445748,3416.5467803,1519.7979052,3712.7205566,37.6699429,49.357295,2.6305353,199.2518087),(19605,'beisa_femur.tif',241,7,31,474.3637079,112.203427,79.164829,1.8,111.9130666,80.2607812,0.4099278,35.6305532,25.7436659,57633.2457359,87397.1420924,12.5577209,3394.8988672,1617.5231796,3455.1691349,0.402344,0.5690003,2.3561945,1.1380007),(19606,'beisa_femur.tif',241,7,32,481.5078463,110.9199493,79.208513,1.8,110.3060011,80.4036175,0.2264115,32.8262129,26.322302,60913.1629327,87303.9728209,4.044041,3316.7301576,1855.6256603,3835.8381062,37.3163847,49.008406,0.1151903,169.9566661),(19607,'beisa_femur.tif',241,7,33,512.1081049,109.2001093,79.5711421,1.8,108.8060744,80.6943003,-0.1303606,26.8719072,35.8885021,64928.7846879,93372.858177,1.4422529,2601.7485442,2416.2328456,3771.556008,0.9519561,4.3520158,0.9827937,9.2420681),(19608,'beisa_femur.tif',241,7,34,503.7459369,108.6116493,79.3770039,1.8,108.0741056,80.5609275,-0.2859922,24.6909366,37.2970454,63283.0891728,90541.8866602,6.6818349,2427.5887186,2563.0088568,3900.4348672,0.402344,0.8996685,2.0344439,1.9426887),(19609,'beisa_femur.tif',241,7,35,494.6536869,108.4138176,78.9296964,1.8,107.509366,80.1901841,-0.3883257,22.7165158,42.6291856,60719.0040218,85565.4406834,11.8195628,2007.203269,2672.9012756,3327.3238637,0.402344,0.8996685,2.0344439,1.9426887),(19610,'beisa_femur.tif',241,7,36,480.5444599,108.4393711,78.2247007,1.8,107.3619373,79.5830436,-0.4646925,21.3230019,43.6561461,57582.5228147,78612.7100373,16.0851478,1800.7249181,2700.4885705,3118.2832039,1.3999882,3.5986741,1.1071487,8.1040674),(19611,'beisa_femur.tif',241,7,37,467.2780918,108.3930371,77.4605027,1.8,107.394471,78.8731133,-0.5128207,20.7895069,44.858432,53959.096941,73532.2292624,18.7475647,1639.2064081,2595.4967202,2841.3362015,1.3999882,3.9626288,1.152572,9.4777558),(19612,'beisa_femur.tif',241,7,38,451.302037,108.615717,76.5838515,1.8,107.7722705,77.7943018,-0.5461851,20.3912142,42.2698455,50293.4645707,66894.5620768,20.2942008,1582.559892,2466.428141,2698.9386605,38.1560418,43.6946325,0.6416595,230.6750784),(19613,'beisa_femur.tif',241,7,39,438.3521701,108.918644,75.7233156,1.8,108.0954547,76.8532619,-0.5606441,20.3334873,45.6351578,47543.0383965,60584.6306441,20.6565217,1327.586745,2338.164511,2335.2606407,36.4073645,41.9384519,0.8600889,188.8382404),(19614,'beisa_femur.tif',241,7,40,434.7357554,108.9854343,75.0538848,1.8,108.2552345,75.9767791,-0.5843094,19.7110992,46.903853,45213.1771382,57247.1869397,22.0475118,1220.5220514,2293.7927878,2161.7006807,35.558109,40.740186,0.6099169,158.5599094),(19615,'beisa_femur.tif',241,7,41,431.6690483,109.2335091,74.2010683,1.8,108.7822622,74.9666097,-0.6237531,19.063073,46.2428733,42608.0577556,53469.5591135,24.5444159,1156.2767481,2235.1096109,2067.1027454,35.7218568,40.4630862,0.7291196,196.8446827),(19616,'beisa_femur.tif',241,7,42,423.1248871,109.5058908,73.5168451,1.8,109.0356487,74.2644466,-0.6974573,18.6879786,37.8087758,40504.8467229,49065.9298892,29.0906728,1297.7391832,2167.427922,2291.2863669,35.0952317,39.194997,0.6250227,173.589606),(19617,'beisa_femur.tif',241,7,43,416.1676473,109.8420037,72.7768932,1.8,109.431919,73.5620914,-0.8744584,18.0027492,20.642947,38530.195757,44435.73989,40.8253575,2152.5870299,2140.239548,3948.7038888,34.1314623,38.4001464,0.6141594,190.2928039),(19618,'beisa_femur.tif',241,7,44,408.0332896,110.1875095,71.9884582,1.8,109.9775653,72.5300256,-1.1937252,17.3957657,18.0125452,36469.9690994,40193.6929157,58.7860025,2231.427732,2096.485419,4058.2871503,2.2785808,14.8377136,1.3521274,36.8538976),(19619,'beisa_femur.tif',241,7,45,407.9257616,110.2807704,71.4247911,1.8,110.034359,71.9309481,-1.3654259,18.2157628,17.7078254,34808.7239707,38735.911803,65.1602003,2187.5024751,1910.9122374,3824.7037624,3.7766497,16.4124793,1.3734008,43.8199643),(19620,'beisa_femur.tif',241,7,46,406.5243653,110.3925758,70.9455506,1.8,110.2170869,71.3148402,-1.499149,18.3336935,17.5934172,33022.5618723,37545.9078227,67.4068511,2134.0884152,1801.1952621,3848.0502056,2.4185929,15.2307267,1.357858,35.1468965),(19621,'beisa_femur.tif',241,7,47,404.5198899,110.4852464,70.5049276,1.8,110.3897592,70.7388906,1.5571482,16.3229539,17.6418897,31441.1656159,36707.8198777,67.4074242,2080.7192757,1926.1933668,3804.1580403,2.0666766,11.5213788,1.359703,27.0023915),(19622,'beisa_femur.tif',241,7,48,404.4235463,110.5523994,70.0583171,1.8,110.5174087,70.2971982,1.4993074,15.8144146,17.4140255,30148.8077031,36069.9109415,67.0600321,2071.3137723,1906.4131339,3747.7827158,29.773456,33.8280154,2.039763,104.1241887),(19623,'beisa_femur.tif',241,7,49,405.9170184,110.7194198,69.323012,1.8,110.7316637,69.5303075,1.4566109,15.846133,17.381434,28895.5052399,35076.8072045,66.7745846,2018.0617579,1823.5051591,3644.5555823,0.402344,3.6433799,1.6814535,7.5755047),(19624,'beisa_femur.tif',241,7,50,403.2860156,110.7893219,68.8220774,1.8,110.8482722,69.0547892,1.4150758,15.6181512,17.46174,27737.8586701,34157.5349695,65.5975955,1956.1358124,1776.001416,3511.4341001,0.804688,4.4983427,1.3909428,9.5181934),(19625,'beisa_femur.tif',241,7,51,402.0099052,110.829023,68.305176,1.8,110.8767614,68.4818732,1.382414,15.5939531,17.2408899,26874.2948234,33374.5251948,64.6518972,1935.7774065,1723.3792242,3448.1149321,1.3432086,10.4454578,1.2977876,22.4503888),(19626,'beisa_femur.tif',241,7,52,400.0516393,110.8406324,67.8221093,1.8,110.8745245,68.0312886,1.3759522,15.6931828,17.2515329,26269.6334436,32647.1998105,64.1758696,1892.4231264,1673.9519229,3405.2584403,1.5577089,11.833292,1.259798,25.8643908),(19627,'beisa_femur.tif',241,7,53,399.5840494,110.8455346,67.3641609,1.8,110.8994656,67.6302559,1.372741,15.5490422,17.3092256,25762.0150644,32170.318457,64.018979,1858.5648618,1656.8232816,3333.6450022,2.0293967,12.1038022,1.1964627,28.2380172),(19628,'beisa_femur.tif',241,7,54,398.8311079,110.850171,66.9215842,1.8,110.9231533,67.1661688,1.3753827,15.4043224,17.5828792,25282.1578809,31827.3724111,63.9656701,1810.1342776,1641.2379081,3247.129707,1.6645971,11.9625471,1.2277724,27.3357042),(19629,'beisa_femur.tif',241,7,55,397.7930602,110.8472299,66.486695,1.8,110.875116,66.7478777,1.3723279,15.3309521,17.5394124,24971.7068703,31673.948158,63.72146,1805.8728186,1628.8425389,3208.5902106,0.79869,4.1031198,1.3734008,8.7135054),(19630,'beisa_femur.tif',241,7,56,397.8572729,110.853918,66.0580204,1.8,110.8961456,66.3176977,1.3523759,15.2876579,17.2947057,24664.0886929,31585.0009125,63.1960722,1826.2814939,1613.3333718,3228.0241277,0.402344,1.2723234,1.8925469,2.7473767),(19631,'beisa_femur.tif',241,7,57,402.5189954,110.9458329,65.4166181,1.8,111.0135553,65.7124658,1.3432061,15.1390752,17.2821555,24362.9874492,31707.8948622,63.6711833,1834.7187556,1609.2784531,3238.934988,1.14642,9.0772944,1.3473197,19.3696994),(19632,'beisa_femur.tif',241,7,58,402.8126862,110.9441886,65.0383192,1.8,111.0115635,65.2984429,1.338187,15.1096763,17.1200755,24082.5309013,31593.6602288,63.5679871,1845.415941,1593.848238,3227.7012839,1.7604398,13.7622822,1.3045443,29.8878308),(19633,'beisa_femur.tif',241,7,59,402.1330817,110.9448804,64.6582973,1.8,111.0150271,64.9355396,1.3372156,15.2803019,17.3982677,23801.1199399,31458.286358,63.4314761,1808.1275077,1557.6341464,3166.7385625,2.367186,14.6455427,1.2924967,32.6352075),(19634,'beisa_femur.tif',241,7,60,401.8949699,110.9531537,64.3233072,1.8,111.0306353,64.6273444,1.3386881,15.1485531,17.2576212,23632.9729991,31398.1717308,63.4382057,1819.3800462,1560.0812057,3184.2471007,1.5312372,11.833292,1.259798,25.8643908),(19635,'beisa_femur.tif',241,7,61,401.3941208,110.9671939,63.9957493,1.8,111.0426084,64.2465134,1.3416262,15.0544179,17.5753354,23509.0996923,31454.4511572,63.4466319,1789.6927975,1561.6080153,3124.7434554,1.4652842,9.1748548,1.3045443,20.0363248),(19636,'beisa_femur.tif',241,7,62,400.9098523,110.9761706,63.6863613,1.8,111.0282371,63.9127951,1.3429908,15.1054117,17.4552226,23438.9304858,31559.5303136,63.4103198,1808.0279459,1551.6909416,3145.855005,1.884284,12.4791517,1.2082521,28.3356422),(19637,'beisa_femur.tif',241,7,63,402.126214,110.9701343,63.411756,1.8,111.0158762,63.6765774,1.3381326,15.0763937,17.0381487,23569.0014013,32025.102929,63.4580191,1879.6116614,1563.3049829,3217.642502,0.402344,2.447363,1.735945,5.1614407),(19638,'beisa_femur.tif',241,7,64,402.7853137,110.9764714,63.1482333,1.8,110.9985473,63.3202492,1.3374455,14.9196215,17.1079583,23714.0985889,32381.6297508,63.5413038,1892.7816677,1589.457115,3230.8400295,1.4919736,12.3421932,1.2387369,27.3357042),(19639,'beisa_femur.tif',241,7,65,406.2142902,111.1467412,62.7256746,1.8,111.1802088,62.9293277,1.3419771,15.0989355,17.478189,23750.8106372,32816.1584339,64.2190405,1877.5491265,1573.0122568,3235.7025968,2.0536891,14.3778179,1.2578951,32.4971449),(19640,'beisa_femur.tif',241,7,66,406.6554396,111.18206,62.5206065,1.8,111.1681158,62.7595432,1.3418654,15.1801279,17.4606994,23754.3740602,33151.9707746,64.2854376,1898.6622507,1564.8335886,3237.3284755,2.235046,14.3778179,1.2578951,31.6924569),(19641,'beisa_femur.tif',241,7,67,408.117909,111.1980945,62.313794,1.8,111.2027742,62.5102031,1.3420382,15.1240655,17.6582868,23883.8698586,33696.7754279,64.5218221,1908.2698004,1579.1964092,3254.4772293,1.9892981,13.6144554,1.2397003,30.4163936),(19642,'beisa_femur.tif',241,7,68,409.0965024,111.1927403,62.1155191,1.8,111.1350959,62.3558039,1.3384058,15.2923664,17.9490192,24063.6779613,34402.6547613,64.5663283,1916.6871651,1573.5745135,3247.6222596,2.4511751,15.3998447,1.2242575,39.8941493),(19643,'beisa_femur.tif',241,7,69,407.9706957,111.1853379,61.9232763,1.8,111.1541861,62.1311483,1.3413474,15.3204693,17.3759016,24210.908529,34930.0145314,64.4777721,2010.2562323,1580.2981045,3347.7298475,2.3195171,15.2678813,1.2490458,37.9514606),(19644,'beisa_femur.tif',241,7,70,404.668722,111.1693701,61.7867847,1.8,111.1559396,62.0555954,1.3537795,15.2949009,17.8122883,24397.1915819,35231.4278083,64.3179402,1977.9282282,1595.1192994,3289.4834616,2.3622915,14.886728,1.240499,34.3017709),(19645,'beisa_femur.tif',241,7,71,401.526863,111.1744706,61.6438228,1.8,111.1992742,61.9280478,1.3595417,15.3375332,17.757073,24591.7521247,35738.0794143,63.9787182,2012.6109367,1603.3707546,3374.3165003,0.402344,2.447363,1.735945,5.1614407),(19646,'beisa_femur.tif',241,7,72,399.1874907,111.1323007,61.4940401,1.8,111.0958396,61.7967369,1.3655152,15.2773516,17.8197012,24876.6502804,36253.4454241,63.766761,2034.4586604,1628.335262,3390.3752107,0.402344,1.6589068,1.815775,3.5520647),(19647,'beisa_femur.tif',241,7,73,398.7791589,111.1342924,61.1161818,1.8,111.1176156,61.3989917,1.3761373,15.4716769,18.0523863,25111.7136451,36894.9907051,63.9764105,2043.7736135,1623.0764022,3417.311689,1.9084074,14.7940089,1.1801893,32.3590822),(19648,'beisa_femur.tif',241,7,74,395.0674308,111.0756121,60.9737357,1.8,111.0693496,61.2981904,1.3836356,15.4165329,18.2207875,25153.7556202,37323.0128031,63.5648982,2048.3753943,1631.6091141,3369.5233095,27.761736,35.2894911,2.070143,103.2218757),(19649,'beisa_femur.tif',241,7,75,391.8847583,111.0245397,60.8940457,1.8,111.0259562,61.2226395,1.3870437,15.5441958,18.4021879,25197.9176021,37959.7552841,63.1335026,2062.7849014,1621.0499329,3385.6572417,3.0011459,20.2335433,1.2679115,48.6076547),(19650,'beisa_femur.tif',241,7,76,389.7114364,110.9687871,60.8608343,1.8,110.9793366,61.212486,1.391064,15.6298028,18.3699623,25348.6902244,38846.0526548,62.876214,2114.6506479,1621.817657,3412.1526424,0.402344,4.0435072,1.670465,8.3801927),(19651,'beisa_femur.tif',241,7,77,386.7063911,110.9144579,60.8819467,1.8,110.9471459,61.2130154,1.3915626,15.642718,18.5021172,25549.4808625,39360.5823287,62.4026683,2127.3555845,1633.3146717,3447.7860166,0.402344,2.0515599,1.7681919,4.3567527),(19652,'beisa_femur.tif',241,7,78,385.2414199,110.8928645,60.9126944,1.8,110.9708483,61.2630146,1.3884506,15.7728857,19.0521573,25873.587032,40326.3754523,62.0955834,2116.6304093,1640.3838524,3474.6368672,28.16408,36.3626389,2.0047497,105.8311897),(19653,'beisa_femur.tif',241,7,79,384.759604,110.8768096,61.017855,1.8,110.8976857,61.2853321,1.3773351,15.783672,19.1704373,26342.7222743,41576.0197564,61.7563117,2168.7569817,1668.98566,3525.9908012,0.402344,1.2723234,1.8925469,2.7473767),(19654,'beisa_femur.tif',241,7,80,384.3334654,110.8763001,61.1407611,1.8,110.9387656,61.3970451,1.3648335,15.9716103,18.5134586,26924.7864011,42551.1769651,61.3765015,2298.3915558,1685.7903397,3576.906963,0.402344,1.6589068,1.815775,3.5520647),(19655,'beisa_femur.tif',241,7,81,384.4550231,110.9738341,61.1231013,1.8,111.0480266,61.4261577,1.3476458,16.0201718,19.076907,27349.9804937,43528.1619618,60.9377172,2281.7200959,1707.2214229,3655.8980337,0.855224,4.5874274,1.3045443,9.851506),(19656,'beisa_femur.tif',241,7,82,384.2145076,110.9909974,61.2414461,1.8,111.1036476,61.4946711,1.3336947,16.20452,19.0861513,27809.8861806,44422.9824526,60.5027966,2327.4981787,1716.1808032,3732.3428515,0.804688,6.0885695,1.4382448,12.7369454),(19657,'beisa_femur.tif',241,7,83,385.6605928,111.0200815,61.3677227,1.8,111.1502079,61.6203648,1.3155266,16.4584296,19.0310096,28443.5548735,45434.9237893,60.1785112,2387.4153217,1728.2058855,3713.1522258,0.402344,6.450065,1.6332151,13.2083207),(19658,'beisa_femur.tif',241,7,84,387.2005196,111.0724332,61.5092584,1.8,111.2299634,61.7331584,1.2960789,16.5000216,19.2030073,29064.0924077,46400.0458829,59.7843992,2416.2905984,1761.4578394,3771.4251158,0.804688,6.450065,1.6332151,13.5416334),(19659,'beisa_femur.tif',241,7,85,390.8931654,111.1327582,61.6801624,1.8,111.2642779,61.8344435,1.2819847,25.5072432,45.227414,29834.4960857,47654.8307545,59.8640766,1053.6713592,1169.6480053,1492.3503606,0.804688,8.4587982,1.6183794,17.5650734),(19660,'beisa_femur.tif',241,7,86,395.6231231,111.2461997,61.9207647,1.8,111.4007151,62.1201821,1.2572009,16.8657126,19.6712015,30718.8717977,48931.1969186,59.6625831,2487.4533929,1821.3800075,3893.3879835,1.2062967,11.2943343,1.4994889,24.1978274),(19661,'beisa_femur.tif',241,7,87,400.1691255,111.3556019,62.152932,1.8,111.4855524,62.2885962,1.2323141,17.0537824,19.9001389,31605.122748,50382.0606263,59.3410104,2531.7441676,1853.2617553,4030.9043668,0.8022074,7.2867598,1.6814535,15.1510094),(19662,'beisa_femur.tif',241,7,88,406.243723,111.4314172,62.3706969,1.8,111.561991,62.5444429,1.211377,17.3582483,20.1561514,32696.8249814,52066.8669726,59.3309128,2583.175024,1883.6477281,4122.4795443,0.402344,0.5690003,2.3561945,1.1380007),(19663,'beisa_femur.tif',241,7,89,411.4312635,111.5110364,62.3932491,1.8,111.6057601,62.5350072,1.2159206,17.6970643,20.0034898,34029.1755493,52951.332142,60.2926417,2647.1047146,1922.8712133,4228.9792539,1.459771,9.2888325,1.484058,20.4100751),(19664,'beisa_femur.tif',241,7,90,418.2941219,111.4946183,62.6512977,1.8,111.4534556,62.7960525,1.2255241,17.8126378,20.6677926,35730.423324,54165.5066583,61.7297337,2620.7688317,2005.9029857,4319.357795,1.207032,9.6646345,1.6124389,20.6457627),(19665,'beisa_femur.tif',241,7,91,423.8015975,111.2980466,62.7363655,1.8,111.2704227,62.9650251,1.2743008,18.258531,20.79178,38254.1700855,54053.8579132,64.6040646,2599.7705795,2095.1395297,4324.6149858,1.609376,10.4918479,1.4940244,23.9217021),(19666,'beisa_femur.tif',241,7,92,423.7274757,111.0012167,62.6359918,1.8,110.9860076,62.8199751,1.3656111,18.1491851,21.2325122,40166.3842511,53352.2464171,67.6895141,2512.7618441,2213.1232906,4385.0962765,2.0782923,17.1315411,1.4056476,40.0726496),(19667,'beisa_femur.tif',241,7,93,421.6144421,110.763877,62.3527181,1.8,110.7086353,62.6076995,1.4932483,18.2372179,21.0135296,41073.6198706,52447.8908599,69.8473428,2495.9105856,2252.1867093,4449.2554123,2.1185517,18.858735,1.3775848,47.372029),(19668,'beisa_femur.tif',241,7,94,421.0861715,110.4545207,62.1137164,1.8,110.3850232,62.362576,-1.4545403,18.2418115,21.0477594,41415.2318938,52398.7100848,69.2367652,2489.5148778,2270.346451,4446.5602951,34.5783369,39.4317647,1.0706353,202.4774987),(19669,'beisa_femur.tif',241,7,95,418.0816167,110.2350266,61.6791245,1.8,110.2879015,61.85991,-1.3231897,19.0142556,19.9224347,41053.6693811,52353.4083502,65.4948328,2627.8619578,2159.0994839,4514.4127722,1.8401544,18.8458548,1.2895641,43.7223393),(19670,'beisa_femur.tif',241,7,96,421.4656591,110.1224976,61.2808247,1.8,110.3781782,61.3256352,-1.2448983,19.0452871,19.9927891,41239.7697274,53707.6697307,63.0440817,2686.3520337,2165.353013,4684.0589947,1.450088,18.459655,1.2835149,41.739213),(19671,'beisa_femur.tif',241,7,97,427.5804815,110.015114,60.782975,1.8,110.2878818,60.9206754,-1.170357,19.3668518,20.2958048,40982.1372254,55766.9271071,60.4340891,2747.7071056,2116.0970091,4698.8930839,1.9580916,18.1946701,1.2560387,44.2104644),(19672,'beisa_femur.tif',241,7,98,431.083825,109.8565009,60.597551,1.8,110.1212226,60.7663085,-1.1440535,19.2960673,20.7282202,41132.2656743,57747.3861426,59.5384396,2785.9307552,2131.6398348,4657.88531,2.056782,18.7035874,1.2422432,49.1362174),(19673,'beisa_femur.tif',241,7,99,436.5198769,109.6948179,60.4682063,1.8,109.9888428,60.5026233,-1.1275892,19.9248081,21.8102612,42217.225626,60795.6607393,59.3737709,2787.479717,2118.8272156,4647.4452744,36.1315217,42.6750256,1.0691923,217.5406949),(19674,'beisa_femur.tif',241,7,100,442.1060853,109.66559,60.4841547,1.8,109.9609565,60.36734,-1.1242604,20.0327583,22.5556904,44108.6517444,65096.445742,59.9430251,2886.0320708,2201.8261832,4671.6089299,2.4783641,21.5207032,1.2076493,51.5098438),(19675,'beisa_femur.tif',241,7,101,452.5127574,109.6429866,60.5363016,1.8,110.0417657,60.1086484,-1.1266678,20.3884643,30.8896989,47502.7106351,70390.9950435,61.4951842,2278.785405,2329.8817338,3582.0018278,2.1809992,21.5207032,1.2076493,51.8835941),(19676,'beisa_femur.tif',241,7,102,479.2737946,109.6483268,59.6769983,1.8,109.9841262,58.0799447,-1.2915019,21.2095488,34.1581449,53991.3479902,90202.6837097,73.808317,2640.7371942,2545.6151092,4095.9282162,2.291655,20.6257719,1.2120257,48.4291544),(19677,'beisa_femur.tif',241,7,103,515.6186594,109.6342149,58.8550547,1.8,109.9153052,56.9710019,-1.4082444,22.1267381,36.8025505,62815.3777148,117038.8865994,83.685664,3180.1841176,2838.8900975,4842.3127229,2.3639362,24.5132849,1.1659045,58.4759105),(19678,'beisa_femur.tif',241,7,104,552.2116923,109.6426103,58.6294514,1.8,109.9183222,56.7615999,-1.4631667,30.6719669,59.5829786,73960.5787795,143338.9653052,90.973244,2405.7032503,2411.3412401,3262.1135686,43.1976093,63.7305784,1.3089739,255.8895936),(19679,'beisa_femur.tif',241,7,105,595.9935034,110.0502905,59.0484186,1.8,110.1456074,57.2970522,-1.5163613,39.4189474,57.8768208,92644.391943,172287.4203283,99.0382024,2976.7948191,2350.250275,3945.4812164,48.7446878,67.152889,1.3839762,277.4307314),(19680,'beisa_femur.tif',241,7,106,644.7840994,110.7235268,60.2852233,1.8,110.5689748,58.3889549,1.5586767,27.5044307,43.860002,118833.7630815,197335.2613311,107.4482326,4499.2077637,4320.5316391,7150.8964059,52.3102277,70.1891386,1.2980084,292.6961156),(19681,'beisa_femur.tif',241,7,107,690.1537639,110.7412259,61.1923481,1.8,110.6411248,59.5003044,-1.5340665,28.8186394,49.1444476,139393.015629,226559.4006128,114.8705183,4610.0711581,4836.9048148,7446.3336066,53.8947355,73.4219926,1.2646424,293.8578041),(19682,'beisa_femur.tif',241,7,108,763.0223472,110.9481953,62.8013432,1.8,111.1374744,62.1491419,-1.5277139,29.3055492,53.966457,169225.1947931,283115.2965027,126.9344963,5246.1345862,5774.5102784,7955.306429,54.90025,82.0801483,1.833609,330.6880138),(19683,'beisa_femur.tif',241,7,109,882.9303208,110.9815657,66.3817387,1.8,111.2176895,65.900629,-1.4614274,30.2273182,48.0388692,212288.1312283,412631.9983679,145.4018568,8589.5443766,7023.0554346,12753.7747472,0.8535005,2.01172,0.6435011,3.9830024),(19684,'beisa_femur.tif',241,7,110,1036.7809968,110.3615267,70.2351096,1.8,111.3570074,68.4115924,-1.3949153,36.1097862,50.9788078,262728.6466452,563734.2707942,167.5064054,11058.2082113,7275.8294655,14980.3646587,61.7514268,91.830556,1.8051484,391.4231759),(19685,'beisa_femur.tif',241,7,111,1125.7841308,111.0646344,72.0975657,1.8,111.5017497,70.1416738,-1.4398341,36.6322418,52.2256464,310296.6121518,654521.8682001,184.4309707,12532.5757143,8470.5875706,17234.276651,0.402344,1.2723234,1.8925469,2.7473767),(19686,'beisa_femur.tif',241,7,112,1190.9970818,111.4764931,73.4674389,1.8,111.4965601,71.340255,-1.4602066,41.1552961,54.6660165,355526.4971111,733717.3115783,196.081728,13421.817776,8638.6572572,19063.5550569,0.402344,0.8996685,2.0344439,1.9426887),(19687,'beisa_femur.tif',241,7,113,1255.2973199,111.5512785,74.6293391,1.8,111.2503118,72.6051446,-1.4634425,36.9097389,63.9414589,402258.7215771,795595.2553814,206.8142857,12442.5571241,10898.4439832,18354.4590091,1.7374963,3.9626288,1.152572,10.8514441),(19688,'beisa_femur.tif',241,7,114,1275.7629641,111.4005131,75.1053804,1.8,110.9811899,73.4386001,-1.4638402,37.0006652,52.2569229,417304.2198052,825713.0808638,210.204049,15801.0276099,11278.2896505,21555.6248935,1.7908563,5.5895415,1.0427219,14.0297585),(19689,'beisa_femur.tif',241,7,115,1300.6781689,111.536818,75.3197592,1.8,110.9465084,73.9752662,-1.4687714,36.9393467,51.0117426,436137.7652501,830302.7816201,214.5310354,16276.699042,11806.861887,22564.7009609,70.812544,94.0108419,0.9495518,614.3373114),(19690,'beisa_femur.tif',241,7,116,1283.0967973,111.8153212,75.39631,1.8,111.0246435,74.4992847,-1.474132,36.5578607,54.7841884,430171.8389558,789346.8383069,211.8574754,14408.2966417,11766.876683,20734.1858943,71.1559876,93.1841212,0.9324765,522.8830688),(19691,'beisa_femur.tif',241,7,117,1258.8905318,112.052024,75.2819155,1.8,111.1033964,74.6826566,-1.4882705,38.2023638,64.4873294,418450.6487475,719180.331738,208.3893813,11152.2734466,10953.5276592,17362.9229425,70.3058448,91.5825449,0.941354,575.7764128),(19692,'beisa_femur.tif',241,7,118,1244.6255069,112.080339,75.1450817,1.8,111.0721612,74.8805687,-1.4961889,36.7779907,44.1973467,415645.5044432,637445.4643781,206.2850719,14422.7088671,11301.4739703,21752.9240047,69.1601033,89.3348657,0.9453113,434.960077),(19693,'beisa_femur.tif',241,7,119,1214.4396628,112.1169637,74.6631769,1.8,111.0568646,74.9257599,-1.4986129,37.756065,64.0350327,410540.7620133,544577.0774093,201.3538125,8504.3616683,10873.5050189,14418.361594,0.402344,0.5690003,2.3561945,1.1380007),(19694,'beisa_femur.tif',241,7,120,1184.9812518,111.7649719,74.0791019,1.8,110.9790774,74.8915303,-1.4510921,37.1933758,62.6749068,393822.4363076,449625.8024892,194.6804142,7173.936515,10588.510118,12912.9561503,67.1906532,84.0205641,0.9110131,402.3081196),(19695,'beisa_femur.tif',241,7,121,1115.89013,111.5082215,73.4971249,1.8,110.9347057,74.6807334,-0.1516555,41.0211482,40.5644061,336554.9920021,360618.6220369,4.2447712,8890.0259287,8204.4264275,13547.4162224,0.804688,2.447363,2.976444,5.5923784),(19696,'beisa_femur.tif',241,7,122,975.3924037,111.5240595,73.9676446,1.8,110.9484793,74.7206731,-0.0454389,38.078519,37.8774376,235258.2841968,306547.7413218,0.335416,8093.1488635,6178.2414458,10891.1007027,0.804688,1.1380007,0.7853982,2.2760014),(19697,'beisa_femur.tif',241,7,123,714.402707,112.6277712,75.9462003,1.8,111.4159833,75.4019011,-0.0886646,30.0917839,37.625308,128009.3761678,215884.7918891,0.9335858,5737.7548131,4253.9643587,8719.35723,0.8930864,2.3460485,0.5404195,4.7876904),(19698,'beisa_femur.tif',241,7,124,350.4989777,120.0264265,76.9707144,1.8,117.0099108,78.2066579,0.3682488,28.6730076,34.5734051,52394.0743887,61854.9102052,7.5700303,1789.0893301,1827.2960823,2735.3984497,25.8130555,53.6009194,1.706324,198.0329328),(19699,'beisa_femur.tif',241,7,125,136.9078011,122.7490658,75.546577,1.8,123.8215336,76.9400755,1.1649884,12.2345129,23.1120408,2763.9376049,20829.7420103,19.262097,901.2506606,225.9131718,962.84747,16.1193996,23.5465789,1.2220253,66.579978),(19700,'beisa_femur.tif',241,7,126,7.3457535,116.3224475,65.1071134,1.8,116.3828691,64.8439005,-1.2379076,1.8076589,9.465576,3.5779436,108.8327576,1.0935604,11.4977427,1.9793245,11.8584699,3.9475226,16.8120104,1.2036225,37.2848353),(19701,'beisa_femur.tif',241,7,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19702,'beisa_femur.tif',241,7,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19703,'beisa_tibia.tif',241,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19704,'beisa_tibia.tif',241,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19705,'beisa_tibia.tif',241,8,3,4.9675071,74.3764912,59.9471832,1.8,74.3655779,59.8853643,1.0804533,1.6989115,3.8509121,2.2302952,15.3742266,0.6443075,3.9923598,1.3127789,4.5102165,3.6454969,8.125,1.9655874,18.8832521),(19706,'beisa_tibia.tif',241,8,4,34.2398793,75.6553054,60.0790153,1.8,77.056776,60.4606281,0.5835733,4.9391993,14.4113806,113.3485488,776.4964621,1.7326023,53.8807824,22.9487699,61.4681171,7.3296858,12.5778824,2.0344439,31.6107278),(19707,'beisa_tibia.tif',241,8,5,107.1007043,79.3658203,60.721512,1.8,79.8821682,60.3988061,0.5253644,7.8696777,12.7994971,909.4369128,5403.8077754,4.4898515,422.1890685,115.562155,481.3415912,14.3362951,25.7694102,2.4592761,105.4387851),(19708,'beisa_tibia.tif',241,8,6,214.6225438,80.0699952,58.8281003,1.8,80.4223118,58.0913672,0.6955318,26.644226,34.2488655,5280.7217887,14135.6282676,14.6879347,412.7327446,198.1938523,478.4532392,21.3807756,34.4714556,1.9614034,125.9067459),(19709,'beisa_tibia.tif',241,8,7,440.0226681,76.7269753,57.6800561,1.8,73.9763303,57.4402259,0.1090005,24.5086653,45.7056913,23209.2523859,134274.137043,0.8678805,2937.7990598,946.9814891,3415.1065747,34.1478279,51.8900581,0.1572281,224.7294145),(19710,'beisa_tibia.tif',241,8,8,794.2209103,76.6988139,57.724148,1.8,76.2732454,56.7487945,-0.0510572,30.1879183,46.0103118,80894.4641117,321455.7907964,0.3447683,6986.6031869,2679.6966681,8570.5837766,47.3363406,68.7677534,0.9045719,265.4952875),(19711,'beisa_tibia.tif',241,8,9,1068.4219342,82.5962741,57.8335726,1.8,80.9116061,57.5044284,-0.0846371,33.0374818,39.7042046,161554.4416629,486825.9810205,1.272553,12261.3205667,4890.0349802,13947.6118057,57.4712724,77.6818683,3.0287142,399.6158682),(19712,'beisa_tibia.tif',241,8,10,1146.2491418,83.7206904,59.2621482,1.8,81.4979927,58.9369078,-0.0031326,33.9435162,39.6573704,213376.4507687,517964.0272859,0.0018728,13060.9776314,6286.2211898,15106.3031424,60.88643,77.134344,3.0197502,409.8617421),(19713,'beisa_tibia.tif',241,8,11,1091.4171106,83.4358064,60.102447,1.8,81.7336571,59.4943293,0.1100386,35.4050941,40.2254538,239918.9094287,485742.3042727,2.1936916,12075.4959333,6776.3951941,17209.8978624,0.4419417,0.8838835,0.7853982,1.767767),(19714,'beisa_tibia.tif',241,8,12,1054.3031783,83.6655144,60.2420101,1.8,81.9869544,59.6156179,0.2352382,35.4690195,39.6977353,232756.7336713,453090.934461,9.5456196,11413.5209856,6562.2545238,17172.7260908,1.2864425,2.440703,0.6947383,5.9283009),(19715,'beisa_tibia.tif',241,8,13,949.3744673,83.1463199,59.2775029,1.8,82.4335102,58.7738829,0.3501055,33.8777656,40.7001666,203365.0592454,396293.3781712,18.6151578,9736.8981832,6002.9064986,14724.2141059,60.3756939,75.4782926,3.0752999,313.0971318),(19716,'beisa_tibia.tif',241,8,14,853.1603338,82.4030502,58.4996381,1.8,82.6675767,58.0376161,0.4793464,32.3411343,41.2797883,178032.6874866,340198.4560289,30.2452175,8241.2839286,5504.8374603,12461.3949508,56.7021378,73.5272058,2.8305944,300.6913553),(19717,'beisa_tibia.tif',241,8,15,790.4008049,81.8772639,57.7471917,1.8,82.2169603,57.2825908,0.5774,30.7813105,41.2447013,157752.1762163,310153.1355072,39.2498899,7519.8298405,5124.9337226,11176.5676065,54.4991749,73.7003276,2.2329552,282.3258701),(19718,'beisa_tibia.tif',241,8,16,742.2672822,81.109745,56.1442749,1.8,81.2465159,55.6786977,0.6821244,28.5228957,40.8022512,142853.746875,280384.874177,49.1701284,6871.799124,5008.3886407,10002.8696454,52.8563589,72.3017224,2.4418738,316.7084909),(19719,'beisa_tibia.tif',241,8,17,682.1819957,79.1648346,53.7046315,1.8,79.8995742,54.0454097,0.8848134,27.4821148,50.5471397,128621.7816234,226229.1110641,68.0773836,4475.6065809,4680.1995632,6403.9536824,51.0954843,71.1134931,2.4277233,350.131403),(19720,'beisa_tibia.tif',241,8,18,615.0573509,76.5200144,51.6465267,1.8,77.4033122,52.0242339,1.2855773,42.6697113,40.6524873,102782.5576719,169678.0875068,94.394108,4173.8673033,2408.794307,4641.5529286,46.6516734,60.026036,2.1183586,273.6386857),(19721,'beisa_tibia.tif',241,8,19,575.9631274,75.5490966,51.0512886,1.8,76.3876434,51.326031,1.4123955,24.8440547,31.687755,85528.9182155,149224.8416136,93.6053657,4709.2273155,3442.631211,7168.5695976,44.9227016,60.1795815,1.329596,275.6469379),(19722,'beisa_tibia.tif',241,8,20,547.5571141,74.9458523,50.9490382,1.8,75.7585105,50.9980303,1.4625101,24.550559,31.2143832,74984.5056769,132925.1854054,90.1935948,4258.4594613,3054.2891341,6480.8299214,43.3056365,58.2156551,1.3101939,295.6339283),(19723,'beisa_tibia.tif',241,8,21,521.8171461,74.50622,51.1119095,1.8,75.2485505,50.9727156,1.4876394,24.3560107,30.781691,67130.7115522,116901.5861549,86.369509,3797.763612,2756.2277087,5871.7603969,41.9408278,57.0917915,1.2992635,312.0930057),(19724,'beisa_tibia.tif',241,8,22,500.1896603,74.1084818,51.5647557,1.8,74.8207871,51.1264412,1.4860292,23.5539455,30.2565989,60912.2099314,101817.9199261,82.7673608,3365.1475556,2586.0724642,5245.0733397,40.8633951,55.9750223,1.2878955,289.883297),(19725,'beisa_tibia.tif',241,8,23,482.4987867,73.7465656,52.0521308,1.8,74.364633,51.4547639,1.4860854,22.7637343,29.2079068,55960.6531862,89836.3923341,79.8407793,3075.7559269,2458.3248266,4872.5505622,39.6671149,54.3507489,1.3090828,360.1628109),(19726,'beisa_tibia.tif',241,8,24,471.1901042,73.4480318,52.4259737,1.8,74.0084789,51.7127683,1.4981638,22.0619572,28.6633524,52289.3384243,81682.1254519,78.118119,2849.7059323,2370.1133066,4589.5827917,2.0585024,23.7376613,1.2074032,59.2883973),(19727,'beisa_tibia.tif',241,8,25,464.4739287,73.2201506,52.7356306,1.8,73.9071058,52.2328395,1.5180111,22.1057843,27.8821832,49061.0972952,75024.8349065,77.1968296,2690.7805042,2219.378264,4380.4319852,38.2470028,51.5549237,1.3508125,332.3648987),(19728,'beisa_tibia.tif',241,8,26,460.0543916,72.9159097,53.1519013,1.8,73.6448324,52.6916649,1.5254532,21.8076437,27.3758121,46847.7012828,69943.79599,76.5181948,2554.9487123,2148.2238952,4199.5990113,37.7817039,49.5379037,1.2829649,227.2294145),(19729,'beisa_tibia.tif',241,8,27,458.7577237,72.5849598,53.6012398,1.8,73.3257158,53.213127,1.5314777,21.595377,26.6229361,45258.172021,65882.4968371,76.3414786,2474.6518053,2095.7342875,4113.1831506,37.6126066,48.3769783,1.2960459,230.9480067),(19730,'beisa_tibia.tif',241,8,28,457.7597656,72.2829451,54.0758574,1.8,73.0717835,53.7132911,1.5304729,21.2989712,26.1450747,44150.389238,62197.3018179,76.1693102,2378.9299687,2072.8883441,4010.6376664,36.9123751,47.5267195,1.3114646,227.3810649),(19731,'beisa_tibia.tif',241,8,29,456.4485381,71.9959135,54.5699585,1.8,72.7625079,54.2504491,1.5289451,21.5470744,25.697811,43174.7111989,59002.4296341,75.9415871,2296.0099426,2003.7389031,3940.6004281,2.3085146,21.8034544,1.0943289,58.1272321),(19732,'beisa_tibia.tif',241,8,30,455.5419922,71.7560211,55.0489655,1.8,72.5327953,54.746545,1.5208404,21.4696186,24.9805652,42419.6328442,56376.469196,75.7343481,2256.8131942,1975.798152,3911.4546196,2.4528878,21.6619085,1.1071487,61.2208243),(19733,'beisa_tibia.tif',241,8,31,452.7022076,71.5241778,55.5530383,1.8,72.2102819,55.2182212,1.4892159,21.2684611,24.7401463,42014.8799708,53846.7102609,74.9493308,2176.4911781,1975.4546353,3837.6279589,0.3125,0.4419417,2.3561945,0.8838835),(19734,'beisa_tibia.tif',241,8,32,452.2620739,71.2980068,56.0285845,1.8,71.9996214,55.7579119,1.4476415,20.5919347,23.9381544,41839.9966113,52038.5841429,74.2395284,2173.8762023,2031.8633058,3871.5760653,35.380104,44.8783077,1.3460852,171.2176676),(19735,'beisa_tibia.tif',241,8,33,453.6073627,71.1926388,56.4457016,1.8,71.9214441,56.2069465,1.4018894,20.6693075,23.4902247,41546.5457465,50394.4227186,73.4647928,2145.3359113,2010.0598785,3830.8052694,2.8061901,21.5262376,1.0876707,59.0425234),(19736,'beisa_tibia.tif',241,8,34,449.2338127,71.0429262,56.8826525,1.8,71.761303,56.6340649,1.3214236,19.9468778,22.9716619,40864.0815787,48273.0310851,70.3119543,2101.4165776,2048.645502,3747.5860709,2.322788,19.8529752,1.0789872,55.140873),(19737,'beisa_tibia.tif',241,8,35,445.0329368,70.8974181,57.3301182,1.8,71.5391729,57.0926619,1.2144806,18.8034833,22.1191812,40085.1110045,46502.9096846,65.1470346,2102.3793493,2131.7917722,3671.6670326,2.6105523,20.9631373,1.1071487,51.2392225),(19738,'beisa_tibia.tif',241,8,36,440.4945549,70.7701993,57.7796613,1.8,71.4135133,57.5066256,1.1105303,18.7337746,21.1699808,39163.9042368,45164.6634136,58.9307087,2133.4295849,2090.5506227,3602.9751561,0.559334,1.1267348,2.1587989,2.392767),(19739,'beisa_tibia.tif',241,8,37,436.7384884,70.6522443,58.2390707,1.8,71.2388175,57.9148329,1.0109689,18.6151687,20.3698191,38198.400007,43966.9700366,52.262787,2158.4369405,2052.0039635,3530.32839,0.3125,0.4419417,2.3561945,0.8838835),(19740,'beisa_tibia.tif',241,8,38,432.8643762,70.529557,58.7335145,1.8,71.0313719,58.400631,0.9147968,18.0361307,19.3404969,37224.9219023,42923.4734534,45.3035169,2219.3573256,2063.9084188,3501.182054,4.7287048,28.7652813,1.2730961,71.3150478),(19741,'beisa_tibia.tif',241,8,39,430.37355,70.4292438,59.2242279,1.8,70.9035214,58.8259964,0.8313196,18.0371987,18.6510064,36377.3127235,42352.6852693,39.1537306,2270.7989272,2016.793926,3456.3180555,2.7050501,18.9185136,1.1810878,44.9317956),(19742,'beisa_tibia.tif',241,8,40,428.2816347,70.3225798,59.6426454,1.8,70.7689583,59.2949167,0.7610216,18.0027728,19.0106322,35498.1543243,41879.1359421,33.9508193,2202.932313,1971.815937,3466.4416212,1.0271356,8.8939059,1.2490458,19.2049513),(19743,'beisa_tibia.tif',241,8,41,428.835464,70.2935754,59.9985772,1.8,70.6580873,59.6723188,0.6751624,17.899986,19.3883142,34451.1808672,41180.935616,27.9211281,2124.0080564,1924.6484848,3471.9658551,0.3125,0.4419417,2.3561945,0.8838835),(19744,'beisa_tibia.tif',241,8,42,427.3978752,70.2274431,60.4159339,1.8,70.5816122,60.1282753,0.6054983,18.1881365,19.5976621,33432.8916207,40492.0715941,23.0763918,2066.1684718,1838.1702603,3477.2833578,2.5754203,17.3571176,1.1635405,46.4850965),(19745,'beisa_tibia.tif',241,8,43,426.2149029,70.1862033,60.8525645,1.8,70.5140294,60.57755,0.5433854,18.1177273,19.3879592,32373.6935032,39770.4254323,18.9897888,2051.2950845,1786.8517974,3490.4573829,2.7206199,17.4104853,1.2036225,43.6503878),(19746,'beisa_tibia.tif',241,8,44,425.5638909,70.1853357,61.3059305,1.8,70.4819184,61.089168,0.4861422,18.2005977,19.3234983,31467.5359503,39133.3260615,15.4829477,2025.1677743,1728.9287107,3524.2961934,3.0251247,18.2885936,1.2220253,45.8915043),(19747,'beisa_tibia.tif',241,8,45,424.0332919,70.1952738,61.7359606,1.8,70.4360347,61.5550957,0.4325112,17.9308694,18.9349114,30516.1062488,38391.6041975,12.416295,2027.556579,1701.8754407,3525.9074462,0.3125,0.4419417,2.3561945,0.8838835),(19748,'beisa_tibia.tif',241,8,46,422.1409209,70.2242931,62.1601511,1.8,70.4148562,62.0056709,0.3716428,17.615812,19.0717429,29442.7243424,37698.0217957,9.2783381,1976.6427179,1671.3804855,3388.6420459,2.6629763,17.3936501,1.2604089,43.3156791),(19749,'beisa_tibia.tif',241,8,47,420.5598662,70.2531373,62.5824058,1.8,70.4126971,62.4726268,0.3232084,17.0003488,18.708307,28453.9973952,37238.5928797,7.0707595,1990.4843808,1673.730209,3504.4581621,2.1280834,14.637548,1.2895641,35.2534947),(19750,'beisa_tibia.tif',241,8,48,420.3220585,70.289939,62.9916654,1.8,70.4279255,62.9660704,0.2883348,16.5790214,18.4036094,27585.0730987,36832.2165082,5.6644316,2001.3583027,1663.8541201,3469.0794599,1.631623,10.1790609,1.2587542,25.0260191),(19751,'beisa_tibia.tif',241,8,49,422.2762784,70.4184926,63.2877019,1.8,70.5823057,63.3033784,0.2470801,16.1732043,18.3545568,26502.6100655,36296.7494822,4.2098371,1977.5334165,1638.6740405,3407.7450515,2.1242843,14.8231765,1.2490458,35.6954365),(19752,'beisa_tibia.tif',241,8,50,421.8672467,70.4729777,63.6506604,1.8,70.5858593,63.6740136,0.2165115,16.087262,18.0363688,25503.0143637,35712.0413906,3.2448134,1980.0017306,1585.2924073,3361.7374936,2.2594072,15.8113883,1.2490458,36.1373782),(19753,'beisa_tibia.tif',241,8,51,422.2880563,70.549622,64.0250252,1.8,70.6499504,64.0481246,0.1905494,15.8755777,18.2113589,24565.181624,35214.5418918,2.5247004,1933.6581145,1547.3567046,3269.6793163,2.5372052,15.119963,1.2555816,36.7623782),(19754,'beisa_tibia.tif',241,8,52,422.3521248,70.6332428,64.3973983,1.8,70.7509628,64.4209645,0.1717577,15.7514668,18.3804644,23706.9873432,34744.6920859,2.0562745,1890.3054581,1505.0653801,3180.0907512,2.4673262,16.2259437,1.2977876,45.1148539),(19755,'beisa_tibia.tif',241,8,53,420.5923591,70.7255464,64.7467853,1.8,70.8045448,64.7756541,0.1590354,15.8538513,17.863343,22844.4999693,34241.1110257,1.7580574,1916.8366716,1440.9432478,3118.8242122,2.1507553,13.8349648,1.2490458,37.6148539),(19756,'beisa_tibia.tif',241,8,54,418.7824337,70.8237178,65.0831896,1.8,70.8684215,65.0989807,0.1475396,15.0261266,18.0408708,22096.8883231,33769.8622321,1.5083449,1871.8532247,1470.5645019,3095.219059,2.2774223,13.7393425,1.2706252,40.9229121),(19757,'beisa_tibia.tif',241,8,55,417.4493075,70.9382504,65.4087349,1.8,70.9702433,65.4395916,0.135907,14.6473102,17.9308482,21421.7124971,33397.6317664,1.2772047,1862.5795823,1462.5014537,3056.710697,2.1049205,13.4229572,1.359703,34.2937861),(19758,'beisa_tibia.tif',241,8,56,414.5541844,71.0669566,65.7173278,1.8,71.051963,65.7383564,0.1266851,14.30142,17.7665689,20789.8617307,32936.098749,1.1029518,1853.8243938,1453.6921339,3022.9531202,1.8276578,13.4918957,1.3370531,30.4993687),(19759,'beisa_tibia.tif',241,8,57,414.9482126,71.3255248,65.8990277,1.8,71.3249529,65.9563515,0.1202145,15.7302556,17.5281951,20215.0717956,32319.2525414,0.9946331,1843.8437258,1285.1076513,2996.9565591,0.3125,0.4419417,2.3561945,0.8838835),(19760,'beisa_tibia.tif',241,8,58,411.8855646,71.4783265,66.1626973,1.8,71.4568149,66.2126458,0.1163678,16.237162,17.3826974,19615.878203,31689.8699899,0.9254009,1823.0697642,1208.0853877,2951.5257608,2.3069138,11.9773549,1.3068326,30.1018443),(19761,'beisa_tibia.tif',241,8,59,409.3209635,71.6456865,66.4365085,1.8,71.6331613,66.5356896,0.1082625,16.390519,17.4297554,19107.7365706,31112.7158256,0.7964736,1785.034568,1165.7798342,2245.6413612,2.3548639,14.1006427,1.3473197,35.7712617),(19762,'beisa_tibia.tif',241,8,60,407.4041193,71.8158233,66.7023106,1.8,71.7815073,66.7648761,0.0979895,15.1246873,17.272555,18623.0801408,30658.8071239,0.6498944,1775.0012706,1231.3034802,2851.5696584,2.463214,13.9754249,1.3909428,37.4632034),(19763,'beisa_tibia.tif',241,8,61,405.8052794,71.9991997,66.9605529,1.8,71.9333147,67.0242746,0.0848929,15.0170677,17.1005858,18170.3488121,30312.2360243,0.4862567,1772.5846525,1209.9798129,2800.8163462,2.1550183,9.7877874,1.2793395,26.4590774),(19764,'beisa_tibia.tif',241,8,62,403.8425663,72.1961365,67.203511,1.8,72.15675,67.339988,0.0715836,14.8133391,17.0666708,17814.6383077,29970.1926332,0.3443068,1756.0655484,1202.6078818,2777.3311635,2.1946502,14.2316219,1.4164776,32.8921356),(19765,'beisa_tibia.tif',241,8,63,403.4223189,72.393683,67.4292713,1.8,72.3314937,67.5830733,0.0628875,14.2041192,16.9718333,17486.3926476,29790.4198114,0.2655612,1755.285904,1231.0789873,2777.3595868,1.6360725,9.7678123,1.4424731,24.53966),(19766,'beisa_tibia.tif',241,8,64,403.2433712,72.5934432,67.6385357,1.8,72.5220119,67.7317405,0.0530569,14.2185689,16.8168852,17254.4888755,29628.7603099,0.1890134,1761.8459009,1213.5179673,2787.6291844,1.1163978,9.0192936,1.3258177,20.0888348),(19767,'beisa_tibia.tif',241,8,65,404.2005208,72.9174117,67.7183447,1.8,72.8387694,67.9255829,0.03889,15.1560834,16.7732189,17044.062258,29374.9990063,0.1018365,1751.3036235,1124.5690429,2767.1541844,2.0909889,11.6675967,1.4364749,31.8251939),(19768,'beisa_tibia.tif',241,8,66,402.3096887,73.1171889,67.9185924,1.8,73.0287429,68.1559192,0.0288951,14.593152,16.8546415,16792.7370047,28991.6751095,0.0559677,1720.1003678,1150.7272011,2693.4149042,1.9029837,11.2889949,1.4876551,29.9501939),(19769,'beisa_tibia.tif',241,8,67,401.4910038,73.3352167,68.1172202,1.8,73.2534039,68.3720688,0.0163717,15.2909726,16.6677933,16625.0879852,28646.7945578,0.017934,1718.6914953,1087.2485655,2709.1038561,2.1764551,12.9074228,1.4494443,34.3696113),(19770,'beisa_tibia.tif',241,8,68,400.8133582,73.5456309,68.3110764,1.8,73.4158907,68.5915318,0.0061628,14.7931241,16.7577004,16388.4042396,28380.1671294,0.0025374,1693.5597593,1107.8393011,2537.7090462,1.9793099,11.0086968,1.4570043,30.2849026),(19771,'beisa_tibia.tif',241,8,69,399.7511541,73.759833,68.4949134,1.8,73.6359804,68.7839663,-0.0043538,14.6639193,16.5787288,16199.1301234,28127.7795778,0.0012628,1696.6186,1104.6930785,2441.571957,1.7221092,9.1108623,1.4677147,27.0840774),(19772,'beisa_tibia.tif',241,8,70,398.9973958,73.9742642,68.6683973,1.8,73.8380282,68.9905297,-0.0164501,14.5280641,16.4579563,16003.5906984,27867.9096039,0.0179935,1693.2788699,1101.5638821,2560.1626845,1.9544878,10.6662801,1.482789,25.6066017),(19773,'beisa_tibia.tif',241,8,71,399.0899621,74.188928,68.8329739,1.8,74.0767362,69.1547866,-0.028739,14.5140453,16.4945271,15800.6983127,27777.1384926,0.0549214,1684.0215164,1088.6488205,2626.4125457,0.9375,5.9703041,1.4659194,12.9105339),(19774,'beisa_tibia.tif',241,8,72,399.2353812,74.3992306,69.0032941,1.8,74.2699554,69.3147285,-0.0395715,15.4205279,16.5600688,15695.3795787,27634.8503678,0.1041393,1668.7642235,1017.8237533,2593.7089997,0.3125,0.4419417,2.3561945,0.8838835),(19775,'beisa_tibia.tif',241,8,73,399.7305279,74.7049744,69.0237808,1.8,74.5859611,69.3797596,-0.053564,15.7239723,16.2071719,15642.606052,27422.5237537,0.1909618,1691.999319,994.8253347,2653.0071953,1.3364873,10.331422,1.6313283,22.8791261),(19776,'beisa_tibia.tif',241,8,74,398.0309837,74.9180789,69.1571366,1.8,74.8035091,69.5050512,-0.0642423,16.2476683,16.464802,15472.0195621,27134.9678525,0.2734071,1648.0591702,952.2609195,2576.5045619,1.7647969,10.0438492,1.6642731,23.9460678),(19777,'beisa_tibia.tif',241,8,75,396.5540956,75.1612437,69.3046344,1.8,75.0418632,69.676592,-0.0759219,16.6438299,16.514592,15399.42481,26862.96235,0.3802338,1626.6198014,925.2332497,2538.1336827,1.25,1.5625,2.4980915,3.7185922),(19778,'beisa_tibia.tif',241,8,76,396.1445608,75.4117965,69.4425129,1.8,75.2880307,69.8159395,-0.0881898,14.9207581,16.3691209,15337.0184486,26702.301042,0.5121684,1631.2605472,1027.8980726,2487.9758103,23.125,31.0509284,0.504166,90.7972808),(19779,'beisa_tibia.tif',241,8,77,395.1042554,75.6619697,69.5696343,1.8,75.5237117,69.9213415,-0.100679,15.0407684,16.3075378,15237.1751152,26439.3372654,0.6652282,1621.2954776,1013.0582867,2239.3786836,1.1615481,8.8884142,1.7475052,20.0130096),(19780,'beisa_tibia.tif',241,8,78,394.1007043,75.9112939,69.6830864,1.8,75.7760442,70.0222681,-0.1109563,15.1572674,16.4178487,15177.6411521,26287.1295026,0.8053359,1601.1311832,1001.3441606,2524.9587818,1.6051847,8.2738764,1.7607846,20.0888348),(19781,'beisa_tibia.tif',241,8,79,394.6370739,76.1796117,69.7858927,1.8,76.085529,70.0903288,-0.1203809,14.8197201,16.2791371,15140.159591,26249.2953282,0.9485561,1612.4500467,1021.6225047,2531.0097973,1.1543899,5.0389111,1.6951513,11.2185922),(19782,'beisa_tibia.tif',241,8,80,395.5838068,76.4410778,69.8822652,1.8,76.3444983,70.2214595,-0.1285676,14.7198357,16.031486,15133.7186662,26252.3157806,1.0838177,1637.5472469,1028.1173615,2573.7852488,0.788631,5.7622153,1.7894653,12.2855339),(19783,'beisa_tibia.tif',241,8,81,396.4807351,76.7842288,69.8653506,1.8,76.7128241,70.1878545,-0.1380236,14.8226641,16.3302653,15179.1690952,26163.2608523,1.2508869,1602.1332389,1024.051346,2526.2662395,0.8808786,8.2205915,1.7234457,17.5444174),(19784,'beisa_tibia.tif',241,8,82,394.9576823,77.0419714,69.9423838,1.8,76.9916052,70.237818,-0.1482658,15.2049673,16.1750473,15089.2940178,25993.6295002,1.436471,1607.0203104,992.3924018,2531.4639921,0.3125,0.4419417,2.3561945,0.8838835),(19785,'beisa_tibia.tif',241,8,83,392.885683,77.2937707,70.0348024,1.8,77.2066736,70.4125341,-0.1580452,15.4910386,16.3906588,15029.021776,25791.5314918,1.6220298,1573.5506343,970.1752184,2484.5299104,1.501765,8.1129719,1.843805,18.1380096),(19786,'beisa_tibia.tif',241,8,84,391.0909683,77.5414206,70.1094531,1.8,77.4925451,70.4138459,-0.1646677,15.2467357,16.4170774,14915.7931679,25682.3622391,1.7515175,1564.3687149,978.2942034,2384.7931795,0.3125,0.9882118,1.8925469,2.1338835),(19787,'beisa_tibia.tif',241,8,85,388.8146603,77.7719641,70.1948437,1.8,77.7314815,70.5279287,-0.170361,15.0646218,16.2036107,14755.1147988,25568.3314401,1.8626284,1577.9403707,979.45471,2362.0459196,1.2416561,7.4280402,1.8259787,16.4460678),(19788,'beisa_tibia.tif',241,8,86,385.7913707,78.018182,70.266807,1.8,77.986877,70.5520833,-0.1751878,15.1063515,16.2265095,14535.5565219,25407.3813375,1.9532667,1565.7946238,962.2149037,2460.9117789,22.6077951,30.0666577,0.6601316,89.4400478),(19789,'beisa_tibia.tif',241,8,87,385.6636778,78.2412269,70.3289994,1.8,78.1941487,70.6562082,-0.1746658,15.0068536,16.126474,14532.6004948,25366.2476817,1.9411199,1572.95685,968.3975674,2400.600932,22.5854727,30.0146449,0.6747409,89.4400478),(19790,'beisa_tibia.tif',241,8,88,384.2378374,78.4605921,70.382408,1.8,78.3857073,70.7119905,-0.172925,14.7088028,16.0264867,14509.4326739,25289.9429834,1.8959687,1578.009174,986.4455224,2477.7469846,22.4968708,29.9234048,0.1256503,89.515873),(19791,'beisa_tibia.tif',241,8,89,382.7052557,78.7898381,70.2942173,1.8,78.750363,70.629045,-0.1738228,14.7475211,16.1180601,14501.5893908,25156.5797346,1.9078675,1560.7696917,983.3238626,2434.2200726,0.7165312,5.4575779,1.801887,11.6605339),(19792,'beisa_tibia.tif',241,8,90,379.1512784,79.0012598,70.3516056,1.8,78.9442188,70.6454688,-0.1719462,14.5497997,15.9963043,14350.6262387,25000.1208298,1.8499586,1562.8685498,986.3109139,2457.967692,0.9258928,5.4575779,1.801887,12.4371843),(19793,'beisa_tibia.tif',241,8,91,376.2323627,79.2153074,70.4232547,1.8,79.1696033,70.757048,-0.1687581,14.8301092,16.3138765,14273.6818799,24922.5714048,1.7689176,1527.691557,962.4798937,2280.2281339,0.3125,0.6987712,2.0344439,1.5088835),(19794,'beisa_tibia.tif',241,8,92,373.2715436,79.4232991,70.4680856,1.8,79.3451744,70.7895035,-0.1598533,14.4781133,16.1691298,14159.2100954,24875.0800261,1.5762121,1538.4303519,977.9734308,2311.3873862,1.5193473,10.0048816,1.8233506,22.4057765),(19795,'beisa_tibia.tif',241,8,93,369.3112275,79.6207315,70.4990746,1.8,79.5437542,70.7772382,-0.1474489,15.1338736,16.050665,13966.0644988,24787.615393,1.3285407,1544.3357261,922.8347554,2392.7637124,0.9915537,7.0503214,1.7942729,15.5621843),(19796,'beisa_tibia.tif',241,8,94,365.9746686,79.808852,70.5284128,1.8,79.7161659,70.715444,-0.1323855,14.721205,16.5732839,13828.5499783,24750.0071199,1.0627769,1493.3677178,939.3626363,2327.7154023,0.7456657,5.3491384,1.6879051,11.6605339),(19797,'beisa_tibia.tif',241,8,95,364.332416,79.990101,70.5424284,1.8,79.8899716,70.7069566,-0.1177879,14.8157881,16.578215,13694.9517324,24864.8296075,0.8385682,1499.8496282,924.3485159,2313.351338,0.6680059,3.8654115,1.815775,8.2766504),(19798,'beisa_tibia.tif',241,8,96,362.3733724,80.145473,70.5784942,1.8,80.0498554,70.7676083,-0.1034851,14.502719,16.2921136,13659.1323265,25009.4760842,0.6444806,1535.0663919,941.8325177,2354.8335482,22.1609369,30.5835178,3.0083659,89.1497564),(19799,'beisa_tibia.tif',241,8,97,360.4227628,80.375983,70.4903184,1.8,80.3332273,70.6501802,-0.0938074,14.2350377,16.4431322,13678.8686721,25066.0826644,0.527061,1524.4104605,960.9295705,2348.1824039,22.2451436,30.7840259,3.0399038,89.2255817),(19800,'beisa_tibia.tif',241,8,98,356.6657197,80.4818359,70.5203862,1.8,80.455116,70.6917722,-0.0855345,15.2838848,16.2532111,13677.8103828,25067.7766487,0.4338441,1542.3276358,894.9171363,2366.4467174,22.3134242,30.8932765,3.0097096,89.4086399),(19801,'beisa_tibia.tif',241,8,99,352.9269354,80.5551561,70.5394166,1.8,80.5712769,70.7100096,-0.079982,14.7445159,16.7221412,13736.5688892,25138.325889,0.3754846,1503.2958711,931.6391945,2323.8963621,0.3125,0.4419417,2.3561945,0.8838835),(19802,'beisa_tibia.tif',241,8,100,350.2622218,80.6178721,70.5548235,1.8,80.6742142,70.7043011,-0.076921,14.9301058,16.6593241,13857.3661862,25231.7929991,0.3447272,1514.5748317,928.1492314,2345.2137197,22.6462676,31.2905986,2.9912212,90.2925234),(19803,'beisa_tibia.tif',241,8,101,346.7610973,80.7054972,70.5634161,1.8,80.7764731,70.7689226,-0.0696926,15.5487703,16.8582514,14029.6403244,25456.9999039,0.2802526,1510.0617056,902.2990272,2341.8311991,0.3125,1.5934436,1.7681919,3.3838835),(19804,'beisa_tibia.tif',241,8,102,343.9263139,80.8230347,70.5461747,1.8,80.8997942,70.7351852,-0.0636322,15.5462992,16.7176879,14268.1685888,25754.9639695,0.2317832,1540.5816983,917.7855381,2394.0088268,0.3125,2.5194555,1.6951513,5.2588835),(19805,'beisa_tibia.tif',241,8,103,340.2722834,80.9416385,70.5503565,1.8,81.0171119,70.6577942,-0.0592085,14.9764247,17.148834,14475.3914262,26164.8279133,0.19858,1525.749678,966.5452013,2365.0690191,0.3125,1.5934436,1.7681919,3.3838835),(19806,'beisa_tibia.tif',241,8,104,336.9497514,81.0454223,70.551182,1.8,81.1149292,70.6738228,-0.0518495,15.1289459,17.052799,14784.1651022,26565.1148043,0.1508394,1557.8155127,977.2105193,2416.7449449,0.3125,0.9882118,1.8925469,2.1338835),(19807,'beisa_tibia.tif',241,8,105,335.8614169,81.2473363,70.4744345,1.8,81.2975843,70.6405615,-0.041702,15.5795678,17.1428852,15073.4137642,26979.6454981,0.0972907,1573.8100757,967.5116757,2434.2868695,23.9413068,32.0659111,2.9155243,93.5691738),(19808,'beisa_tibia.tif',241,8,106,331.4067827,81.3443534,70.4801724,1.8,81.3656922,70.6714343,-0.029563,15.5476949,17.1091081,15154.7964684,27207.419994,0.0482593,1590.2301786,974.7294745,2438.8313539,23.9800036,32.2647737,2.9859978,94.1941738),(19809,'beisa_tibia.tif',241,8,107,327.9052438,81.4139737,70.474677,1.8,81.3862022,70.744671,-0.0178711,16.7239772,17.3026496,15331.6546873,27406.5898968,0.0174523,1583.9533532,916.746925,2453.3396304,0.3125,3.4516753,1.6614562,7.1338835),(19810,'beisa_tibia.tif',241,8,108,323.9916844,81.4650005,70.4674435,1.8,81.4543989,70.7304493,-0.0074166,16.0930193,17.2787203,15496.9459315,27631.7356342,0.0029703,1599.1772094,962.9607471,2472.4997737,0.6215762,3.1868872,1.7681919,6.767767),(19811,'beisa_tibia.tif',241,8,109,320.5105646,81.5224127,70.5147407,1.8,81.4880753,70.8182008,0.0011321,16.3598496,17.5409085,15747.6576114,27821.1449695,0.0000687,1586.072069,962.5796051,2481.7763451,0.6241435,5.6596157,1.6814535,11.767767),(19812,'beisa_tibia.tif',241,8,110,317.3763909,81.5778177,70.5532719,1.8,81.5481389,70.8179477,0.0109742,16.0427259,17.4912753,16064.3406253,28087.1070239,0.0063702,1605.7781097,1001.3473202,2523.1477196,0.625,5.3216832,1.6295521,11.142767),(19813,'beisa_tibia.tif',241,8,111,314.5615826,81.6100432,70.623249,1.8,81.6015483,70.8704708,0.0272224,15.5797256,17.7924462,16453.1789155,28524.0504483,0.0388417,1603.1550804,1056.0634591,2525.533332,0.625,0.8838835,2.3561945,1.767767),(19814,'beisa_tibia.tif',241,8,112,313.9271129,81.6470739,70.7148791,1.8,81.654547,70.9106284,0.0340092,15.8838359,18.090693,17080.8063617,29135.7554311,0.0604926,1610.5383844,1075.3577672,2549.382636,0.3125,0.4419417,2.3561945,0.8838835),(19815,'beisa_tibia.tif',241,8,113,314.7770182,81.8254842,70.6534103,1.8,81.7619006,70.8941853,0.0399879,17.5805721,17.9840226,17918.3866779,30071.1814195,0.0838447,1672.1054042,1019.2152239,2639.0471185,0.625,2.2750343,1.2924967,4.892767),(19816,'beisa_tibia.tif',241,8,114,313.9902048,81.9172734,70.6976486,1.8,81.8590278,71.0131944,0.0404855,17.4527268,18.4531022,18698.6181716,31120.1984253,0.0857285,1686.4480613,1071.3866339,2695.3403104,0.625,2.2097087,1.7126934,5.1516504),(19817,'beisa_tibia.tif',241,8,115,318.2964607,82.0424656,70.7261113,1.8,81.9922382,70.9654163,0.0445596,17.48652,18.2195547,20018.7636063,32962.0747521,0.1052633,1809.1591833,1144.8111822,2895.2018227,26.4032105,35.2460658,2.9633252,103.0644164),(19818,'beisa_tibia.tif',241,8,116,322.3446082,82.1494435,70.7298395,1.8,82.0365453,71.0404236,0.0551203,18.0767778,18.7237336,21440.6735225,35349.3121969,0.1630618,1887.9414231,1186.0893419,3030.7929541,0.625,1.2884705,1.815775,3.017767),(19819,'beisa_tibia.tif',241,8,117,326.5352154,82.2158473,70.7919456,1.8,82.1599496,71.1123465,0.0749992,17.8862808,19.3265884,22844.6289445,38372.0826572,0.305547,1985.4555786,1277.2151574,3163.3152248,27.8225834,37.4543994,2.9229237,108.4749503),(19820,'beisa_tibia.tif',241,8,118,335.471295,82.2926196,71.0219601,1.8,82.2491682,71.4237705,0.1023069,18.0207758,19.4075322,24485.0150621,42791.9964408,0.5831739,2204.9169412,1358.7103771,3430.920059,28.0996844,38.8833391,2.9063603,112.7741251),(19821,'beisa_tibia.tif',241,8,119,354.9164299,82.2363538,71.1746685,1.8,82.2464203,71.8081298,0.121219,17.989207,20.4562534,26984.2382553,49741.1937821,0.8649446,2431.5886571,1500.0237824,3712.6693243,28.5577371,41.3185983,2.9204627,117.9257755),(19822,'beisa_tibia.tif',241,8,120,388.6443537,82.1918168,71.3840602,1.8,82.5498845,72.2660739,0.1413518,18.7378547,21.8966165,30780.208488,60086.2249498,1.2856109,2744.0871901,1642.6751604,4146.6547147,29.3753171,43.8948495,2.9190627,151.638979),(19823,'beisa_tibia.tif',241,8,121,466.0661399,82.6925024,71.5234672,1.8,83.07063,72.2430298,0.1188312,20.1242011,23.8405637,38046.7446603,77500.008294,1.0917223,3250.7624111,1890.5965279,4842.6423895,30.3125,47.2133621,2.9753558,162.8575711),(19824,'beisa_tibia.tif',241,8,122,617.6244081,83.4071806,72.0198458,1.8,82.8642046,72.2249847,0.1183879,20.1842302,24.6972104,47411.1912665,110634.7442939,1.4360104,4479.6453657,2348.9224453,6389.1425553,34.3599038,49.8013632,2.8813945,242.6637354),(19825,'beisa_tibia.tif',241,8,123,727.550367,82.6300875,72.1298073,1.8,82.328999,72.3022794,0.1064088,20.3202745,25.2996042,56901.180682,124737.9366177,1.3678126,4930.4303603,2800.2171204,7139.0315013,0.3125,0.4419417,2.3561945,0.8838835),(19826,'beisa_tibia.tif',241,8,124,635.0104167,78.4890651,71.1315433,1.8,80.1303688,71.5858406,-0.1006308,20.4510141,28.0734597,57492.9578773,79676.8266063,1.0681312,2838.1548825,2811.2521776,4794.8388897,0.625,1.1267348,2.1587989,2.392767),(19827,'beisa_tibia.tif',241,8,125,477.4887843,76.2670635,69.5461088,1.8,77.0410381,70.0147122,-1.297666,26.0945713,23.0476237,35620.1202315,47357.2741521,73.7908424,2054.7573457,1365.0394854,3119.2615014,37.0835505,44.0569589,0.5525844,266.0812588),(19828,'beisa_tibia.tif',241,8,126,344.7293146,75.7553343,66.8177981,1.8,76.0921035,67.8839756,-1.302082,17.2401204,24.5943755,22866.2577273,31724.4050025,53.4051172,1289.9048804,1326.3397909,2218.414769,30.9197807,41.6891866,0.9183,248.6754823),(19829,'beisa_tibia.tif',241,8,127,242.8439867,75.1832378,63.4054797,1.8,75.3759362,64.1068634,-0.1992018,24.9868306,17.2829388,12103.9006026,18185.1466457,1.5849322,1052.202224,484.4112008,1148.769129,17.6407169,33.3204728,0.3543799,166.6205807),(19830,'beisa_tibia.tif',241,8,128,179.1066525,74.7651294,61.6704865,1.8,74.9047686,61.4246412,-0.0415752,25.9993005,16.292769,2050.9983797,13873.7865045,0.0515678,851.5303038,78.8866753,603.7310789,14.9448301,32.2117627,0.2449787,96.4482999),(19831,'beisa_tibia.tif',241,8,129,125.8551136,74.1329265,62.0221466,1.8,74.6571935,61.6825823,-0.0199365,7.2152768,14.4147035,933.5225648,9400.9153904,0.008336,652.1754253,129.381393,697.0509883,7.1875,14.0346947,1.369034,34.9187861),(19832,'beisa_tibia.tif',241,8,130,74.6946319,72.5143014,62.5577466,1.8,73.4709979,62.4667225,0.0536197,6.1577664,13.7128629,339.6988972,5576.3266802,0.0357578,406.6493409,55.1659279,427.7388224,6.5625,12.022115,1.4141944,30.2849026),(19833,'beisa_tibia.tif',241,8,131,24.0475556,65.1401432,62.0815419,1.8,68.6166159,62.387304,0.1172541,4.4605725,18.4034636,83.8323244,481.365077,0.054851,26.1562219,18.794073,30.7101095,5.9375,9.3227712,1.8076451,24.5082521),(19834,'beisa_tibia.tif',241,8,132,23.8610618,82.6706436,89.6013963,1.8,83.1858466,89.9765212,0.2208011,26.1638829,46.2798936,4599.0415995,19652.6747097,0.1907532,424.6482255,175.7782519,521.8632763,12.3310857,159.0821452,3.1258769,337.831552),(19835,'beisa_tibia.tif',241,8,133,18.9256925,88.0398598,97.6027306,1.8,88.2271242,97.6008987,-0.0165927,2.2601104,46.7765295,15.72664,16661.9001921,0.0008683,356.2021463,6.9583504,356.2879099,12.1875,159.077541,3.1278411,338.349319),(19836,'beisa_tibia.tif',241,8,134,24.0545099,90.0746913,92.368118,1.8,92.6460391,86.8450798,-0.097009,24.1311599,49.0619235,2564.8045151,17612.4436376,0.0376103,358.9839611,106.286002,411.2604541,12.1875,159.077541,3.1278411,338.2734938),(19837,'beisa_tibia.tif',241,8,135,160.7569247,82.7239505,75.3592258,1.8,80.0079017,74.0146898,0.0322843,24.3642629,46.6562189,16471.9526584,42401.614113,0.0279159,908.8094818,676.0702225,1170.6779718,26.5736584,28.8923108,0.892677,108.1532512),(19838,'beisa_tibia.tif',241,8,136,567.5677379,75.8058573,72.6658105,1.8,81.5842769,73.4418714,0.0646478,27.5353237,54.3167724,38370.7327323,111123.5918759,0.3947919,2045.8430586,1393.5094121,2590.5329157,29.0625,29.3317501,0.8910637,95.7474747),(19839,'metatarsus.tif',241,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19840,'metatarsus.tif',241,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19841,'metatarsus.tif',241,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19842,'metatarsus.tif',241,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19843,'metatarsus.tif',241,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19844,'metatarsus.tif',241,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(19845,'metatarsus.tif',241,10,7,1.7744753,68.3962996,89.4343748,1.8,68.4074158,89.4263826,-0.2187484,1.1171764,2.5437139,0.3816049,1.9703249,0.0139274,0.7745859,0.3415798,0.9113038,2.3393097,5.0065239,0.3805064,12.0956218),(19846,'metatarsus.tif',241,10,8,10.8826898,68.6319269,89.1491896,1.8,68.6294611,89.023124,-0.2636148,2.4378841,4.9426149,9.4717665,48.6045228,0.1231518,9.8337669,3.8852407,11.7390212,4.5665262,10.1016725,0.4018706,24.9283871),(19847,'metatarsus.tif',241,10,9,29.488816,68.6546342,88.7245638,1.8,68.6056493,88.6069091,-0.2167576,11.7173928,7.4833561,82.993853,298.420754,0.2273226,39.8779302,7.0829624,29.8483661,7.097446,15.5913443,0.4636476,38.7472355),(19848,'metatarsus.tif',241,10,10,54.9098276,68.616029,87.8341688,1.8,68.7773603,87.3202398,-0.6266246,9.3810357,13.0967907,496.9798338,939.4111083,3.1470782,71.7283438,52.9770751,106.6943177,11.497619,18.6068321,0.4524749,54.7638305),(19849,'metatarsus.tif',241,10,11,103.5283382,69.6236656,85.4288287,1.8,70.1412897,84.8970987,-0.861292,8.8426546,14.0789382,1231.3482283,4091.7814765,9.931866,290.6313973,139.2509699,372.0231392,15.9744092,28.814709,0.5902397,103.7433036),(19850,'metatarsus.tif',241,10,12,201.9967209,71.0863715,82.7900511,1.8,71.2160742,82.4916519,-0.7685158,23.4002979,20.9640468,4797.1028006,15999.6177382,16.2648038,763.1931897,205.001783,853.94846,18.7744085,35.524855,0.3963009,144.9372254),(19851,'metatarsus.tif',241,10,13,351.2653676,71.3909488,79.6315916,1.8,70.7599922,79.1576542,-0.5757935,21.0725087,20.6866227,18133.5619199,40457.1467439,17.3572418,1955.7154047,860.5317105,2399.2732774,7.4851385,13.1354441,1.8029002,37.1698344),(19852,'metatarsus.tif',241,10,14,478.633339,69.5930326,77.5397275,1.8,68.8627847,77.6246915,-0.4818888,18.1372518,21.4490863,30139.6467235,62186.78911,17.1342233,2899.2745101,1661.7537831,4135.4777965,32.732989,41.0966594,0.942,213.1541666),(19853,'metatarsus.tif',241,10,15,565.4140028,68.1218529,76.0187837,1.8,67.7521754,76.1738773,-0.4439867,19.8516427,20.7330726,40775.1783231,69329.0086941,17.3871651,3343.8849136,2053.9951718,4879.3315456,35.1690249,41.322782,0.9937137,148.8952419),(19854,'metatarsus.tif',241,10,16,615.5408665,67.4026385,74.9163071,1.8,67.5158697,75.7375688,-0.3718508,20.1012965,21.3230119,48642.7475647,71387.2198127,13.5435655,3347.8956995,2419.8811078,5363.3411411,0.232422,0.5197115,2.0344439,1.1222329),(19855,'metatarsus.tif',241,10,17,603.6922336,67.2512499,74.2520207,1.8,67.4612183,75.4395418,-0.2677856,20.7356556,21.0851249,50726.5045139,68289.0207366,7.0442224,3238.7297255,2446.3419634,5191.3306814,0.232422,0.3286944,2.3561945,0.6573888),(19856,'metatarsus.tif',241,10,18,564.4083632,67.1686191,74.1814522,1.8,67.3307914,75.229837,-0.2343415,20.5612542,20.4645069,48743.1382965,62710.3591473,5.0719658,3064.347424,2370.6305981,4959.2035967,35.8900774,40.8071149,0.9717357,175.6830053),(19857,'metatarsus.tif',241,10,19,537.6368843,67.0368394,74.2872342,1.8,67.1971774,75.2423806,-0.2015711,21.0431268,20.6637442,46925.6561982,57072.2511381,3.5917357,2761.9511116,2229.9754553,4735.5421635,35.7126369,40.1633082,0.9956341,163.5309884),(19858,'metatarsus.tif',241,10,20,506.6462794,67.0471776,74.435574,1.8,67.1551766,75.3423258,-0.1865054,20.0489553,19.7219231,44333.2841846,51125.3930482,2.9033198,2592.3127737,2211.2515879,4346.7412252,0.4160049,0.8380096,0.9827937,1.7796217),(19859,'metatarsus.tif',241,10,21,478.2953211,67.2183648,74.7793851,1.8,67.2402963,75.5333362,-0.3227202,21.059162,18.7489001,41405.4281019,45744.8876503,8.0180272,2439.870472,1966.1479411,3900.3728977,34.3919404,37.9040369,0.9861951,135.2495865),(19860,'metatarsus.tif',241,10,22,451.578648,67.352828,75.10266,1.8,67.3308276,75.7666134,-0.5821942,18.9538728,18.8178138,37891.6508308,41517.3990265,22.7553353,2206.2817473,1999.1508472,3920.7649305,0.9296882,2.5671853,1.6614562,6.4047028),(19861,'metatarsus.tif',241,10,23,428.6308031,67.4821964,75.5089798,1.8,67.4456247,76.0571679,-0.7692088,18.1969047,19.3269875,34631.6637474,38284.1264414,34.5628935,1980.8636251,1903.1623439,3646.489451,30.912131,36.1003128,0.7079279,114.2228209),(19862,'metatarsus.tif',241,10,24,407.5520177,67.6328797,75.8937216,1.8,67.5929013,76.4241314,-0.8715696,17.811391,19.8634151,31736.1155851,35461.1347954,39.7869602,1785.248639,1781.7875937,3368.7541847,1.4017941,10.0372958,1.6635526,25.5060212),(19863,'metatarsus.tif',241,10,25,391.83881,67.868666,76.2676763,1.8,67.8351905,76.8077348,-0.9401518,16.9476336,19.12352,29084.5860276,33002.35779,42.5990629,1725.7470256,1716.1443726,3198.9876747,1.3945322,8.6121696,1.6247978,21.8903828),(19864,'metatarsus.tif',241,10,26,380.7656096,67.9591929,76.6074217,1.8,67.9086397,77.1482928,-0.9775265,16.6546469,18.407096,27006.4608379,31255.0665689,43.6252703,1697.9900873,1621.5570952,3041.9064732,1.6263967,9.772787,1.6183794,24.7124827),(19865,'metatarsus.tif',241,10,27,371.175422,68.0069959,76.8956144,1.8,67.9804542,77.4074771,-0.9967528,16.28129,18.7930311,25248.8635888,29812.1242617,43.620309,1586.3393272,1550.7901121,2916.2380262,1.3945322,10.4822081,1.5042282,25.8347156),(19866,'metatarsus.tif',241,10,28,364.3452474,68.0256223,77.1621145,1.8,67.9831345,77.6401747,-1.0191223,16.0366511,17.4884827,23851.1918913,28637.0193856,44.0435643,1637.4787814,1487.2925658,2892.3345501,1.3879703,9.772787,1.6183794,22.0498921),(19867,'metatarsus.tif',241,10,29,358.6640946,68.0498465,77.3843992,1.8,68.029513,77.8000346,-1.0492502,15.8550446,17.6774427,22642.3705351,27504.5984302,44.9391481,1555.9150091,1428.0862045,2774.0094739,1.2969681,11.6582301,1.6506263,27.7738465),(19868,'metatarsus.tif',241,10,30,354.3016683,68.084987,77.5847382,1.8,68.0969209,77.9697115,-1.091064,15.6965881,17.6181688,21615.9226672,26482.3921861,46.4713409,1503.1296642,1377.1096363,2725.3408123,1.3945322,10.2371288,1.6162196,23.4774598),(19869,'metatarsus.tif',241,10,31,349.9882528,68.1341851,77.7699112,1.8,68.1295848,78.1467909,-1.1317976,14.8771045,17.4183835,20725.0741041,25477.0597038,47.7936178,1462.6535026,1393.0851963,2625.7592831,0.6972661,7.9160094,1.5120405,17.3450563),(19870,'metatarsus.tif',241,10,32,347.6069365,68.1912934,77.9813836,1.8,68.171043,78.3544921,-1.1730392,15.0448394,17.3334697,19941.2645233,24692.7351272,49.2419299,1424.5696681,1325.4554568,2563.6105474,0.8422789,7.6840005,1.5102643,16.8802122),(19871,'metatarsus.tif',241,10,33,346.1963269,68.3359035,78.1698981,1.8,68.317554,78.5584564,-1.2211254,14.7438945,17.3055933,19118.578823,23887.1064484,50.9273866,1380.3113275,1296.7115855,2481.9551238,1.1599555,9.9372313,1.3825748,22.0265325),(19872,'metatarsus.tif',241,10,34,343.7172998,68.3765893,78.3999925,1.8,68.3607692,78.7747952,-1.2585373,14.5835047,21.795002,18398.9964711,23151.42384,51.8796885,1062.2354531,1261.6306507,1627.9400985,0.232422,0.3286944,2.3561945,0.6573888),(19873,'metatarsus.tif',241,10,35,341.8095424,68.406726,78.608759,1.8,68.3678774,78.9254801,-1.2861515,14.511293,16.7080397,17740.7437461,22562.7801294,52.4758589,1350.4145669,1222.5474123,2393.9320331,0.232422,0.3286944,2.3561945,0.6573888),(19874,'metatarsus.tif',241,10,36,340.1177669,68.4500623,78.7933282,1.8,68.4069361,79.0732881,-1.3187098,14.26614,16.6725833,17146.8615321,21952.2672772,53.1596786,1316.6686181,1201.9271865,2321.0914666,1.7936875,11.3957926,1.3654009,27.6940919),(19875,'metatarsus.tif',241,10,37,338.8321072,68.4990038,78.9844421,1.8,68.4704228,79.2823483,-1.3529034,14.1142138,16.5084141,16650.713449,21401.7455312,53.8330405,1296.4143885,1179.7124319,2257.1253915,1.56907,10.2107104,1.3644724,24.2709983),(19876,'metatarsus.tif',241,10,38,337.735583,68.5353732,79.1870529,1.8,68.4925944,79.4827541,-1.3815507,13.8637418,15.7839779,16194.3157901,20932.7596734,54.2972769,1326.2030495,1168.105701,2267.795236,1.0698369,8.6777811,1.4364749,18.5470438),(19877,'metatarsus.tif',241,10,39,336.9622457,68.5757088,79.3798759,1.8,68.5518761,79.5954351,-1.4040982,13.7108841,15.823883,15782.8637449,20510.5388583,54.6141764,1296.1760902,1151.1193288,2206.8970731,1.9350192,14.479352,1.2439697,33.0329569),(19878,'metatarsus.tif',241,10,40,336.3789279,68.6122658,79.5685878,1.8,68.5671946,79.7755035,-1.4271958,13.4698055,15.9962317,15393.9877822,20156.2874465,54.914994,1260.0647315,1142.8515254,2195.7701275,0.9592608,8.44751,1.4327903,18.4672892),(19879,'metatarsus.tif',241,10,41,335.0872277,68.7400995,79.6952916,1.8,68.7185204,79.9217968,-1.4447071,13.3788412,15.8467399,14918.5095199,19649.1008566,54.9646702,1239.9459404,1115.0823384,2145.9179841,1.252826,10.8941245,1.3775848,25.0081417),(19880,'metatarsus.tif',241,10,42,333.5285869,68.7639645,79.8782737,1.8,68.7379233,80.1281395,-1.4574036,13.8728961,15.7475982,14517.607455,19251.2406077,54.8764098,1222.4874173,1046.4727291,2126.2576538,0.6972661,2.5985574,1.3909428,5.690919),(19881,'metatarsus.tif',241,10,43,331.9913086,68.7832769,80.0517087,1.8,68.7690619,80.2780283,-1.4709612,13.6640257,16.2752336,14174.1333996,18893.4120066,54.7822186,1160.868871,1037.3321704,1945.627597,2.0868923,12.2148782,1.2008903,30.6853769),(19882,'metatarsus.tif',241,10,44,330.8474923,68.8076843,80.2009812,1.8,68.8286074,80.4381877,-1.4834212,13.5425256,15.2551065,13869.959986,18555.1911518,54.721348,1216.3265571,1024.1782361,2004.1480183,2.1494437,12.355587,1.2847449,30.3800421),(19883,'metatarsus.tif',241,10,45,329.9729903,68.8289737,80.3526237,1.8,68.8416114,80.5818024,-1.4950351,13.201879,15.0055313,13609.3710369,18262.6825962,54.680441,1217.0633766,1030.8662132,2034.7100799,1.7112877,12.9365363,1.2604089,29.5301086),(19884,'metatarsus.tif',241,10,46,329.7743604,68.8478814,80.5014627,1.8,68.8616862,80.7194873,-1.5001272,12.8751075,15.0393268,13378.8113065,18032.4516673,54.6883609,1199.0198707,1039.1223012,2021.3524863,1.3750655,11.6721227,1.3499676,25.9378298),(19885,'metatarsus.tif',241,10,47,329.793251,68.8739764,80.6240253,1.8,68.9013041,80.7768069,-1.5043528,13.2785209,14.9045303,13185.4203478,17795.2062892,54.7232398,1193.9461288,992.9886321,2036.2097974,1.5824984,9.7561901,1.3547114,22.820071),(19886,'metatarsus.tif',241,10,48,330.1538591,68.9023948,80.7529011,1.8,68.9210948,80.9494289,-1.5117546,13.0094176,14.97021,12978.0765708,17592.4013036,54.8340508,1175.1606189,997.5908946,1930.517761,1.3486138,4.5128197,1.3633001,11.6871728),(19887,'metatarsus.tif',241,10,49,329.7699733,69.0199327,80.8333439,1.8,69.0631063,81.0641734,-1.5162917,13.1108273,15.4166607,12703.4133876,17370.5717244,54.7985462,1126.7402211,968.9253825,1908.3722006,2.2424697,14.1853626,1.2542271,33.6903457),(19888,'metatarsus.tif',241,10,50,328.5009452,69.0559009,80.9601406,1.8,69.136728,81.1903489,-1.5213591,12.5625421,15.2452478,12456.7088264,17114.9506229,54.6164555,1122.6416797,991.5754861,1877.9594158,1.9449455,15.3627275,1.2633989,33.3286159),(19889,'metatarsus.tif',241,10,51,327.3774765,69.0774839,81.0712938,1.8,69.1139404,81.2958019,-1.5251897,13.1223574,15.5598454,12230.8996593,16868.5949709,54.4495026,1084.1107047,932.0657296,1860.4463562,0.7133523,4.9686157,1.3825748,11.2456883),(19890,'metatarsus.tif',241,10,52,327.1481042,69.109061,81.1863216,1.8,69.1622536,81.4459347,-1.5294796,12.9028853,15.6563321,12062.9789302,16661.3988348,54.4316592,1064.1955444,934.9055369,1816.8990028,2.2157957,14.2594282,1.2387369,32.1830234),(19891,'metatarsus.tif',241,10,53,327.0923327,69.1306827,81.2820186,1.8,69.1488801,81.5136569,-1.5319111,12.5613666,14.9604568,11910.0310886,16504.1590183,54.433,1103.1855009,948.1477183,1854.7894307,1.6407554,13.2296943,1.2490458,28.9524745),(19892,'metatarsus.tif',241,10,54,326.8936373,69.1529333,81.3897545,1.8,69.1818927,81.6281866,-1.5369247,12.4658761,15.2696108,11774.6807171,16370.3223392,54.4197902,1072.0851102,944.5530006,1837.25672,0.4648441,2.5985574,1.3909428,5.690919),(19893,'metatarsus.tif',241,10,55,326.6519878,69.1725987,81.4804263,1.8,69.1868023,81.7141851,-1.5425191,12.365967,14.6930593,11630.166466,16221.9899659,54.3984781,1104.0580205,940.4979351,1803.9990766,1.2876343,9.0763707,1.3382394,19.7820668),(19894,'metatarsus.tif',241,10,56,326.2139183,69.201407,81.5788247,1.8,69.2192809,81.7728372,-1.5522645,12.3247902,14.6445728,11490.6301083,16093.4474435,54.350317,1098.9359466,932.3185172,1837.0563704,1.3555334,7.7260665,1.2966289,17.3216967),(19895,'metatarsus.tif',241,10,57,325.0780577,69.2881266,81.6295636,1.8,69.3280014,81.8918846,-1.5573338,12.5766751,14.8433668,11315.2507449,15928.9158076,54.1698574,1073.1336125,899.7012831,1809.0415611,0.232422,0.5197115,2.0344439,1.1222329),(19896,'metatarsus.tif',241,10,58,323.5166013,69.3126471,81.7173407,1.8,69.3390185,81.9505867,-1.5594196,12.5997712,15.1890233,11137.8675507,15751.7179893,53.912456,1037.0461429,883.9737959,1764.0372564,2.3183845,12.7895493,1.237552,31.5820296),(19897,'metatarsus.tif',241,10,59,321.8144965,69.3446928,81.7989913,1.8,69.4258056,82.0742314,-1.5610227,12.259978,14.6812521,10972.1936537,15597.4875594,53.6306265,1062.4085335,894.960308,1784.1639951,1.7691318,11.6164525,1.2237347,26.5484994),(19898,'metatarsus.tif',241,10,60,320.7818141,69.3644076,81.8801691,1.8,69.4365885,82.1795966,-1.5657914,12.6536103,15.6345258,10843.8724905,15470.4294894,53.4622967,989.5042367,856.9785396,1678.8588737,0.4648441,0.6573888,2.3561945,1.3147776),(19899,'metatarsus.tif',241,10,61,319.5795252,69.384836,81.9488199,1.8,69.4489792,82.1951175,-1.5693718,12.4426116,14.9706677,10717.1141901,15327.885794,53.2631467,1023.8611996,861.3235356,1686.1745446,2.1371822,12.8674516,1.2776094,30.7087365),(19900,'metatarsus.tif',241,10,62,318.7688978,69.4107231,82.0366509,1.8,69.494295,82.3203836,1.5676085,12.4128582,14.6488856,10617.2386122,15242.289256,53.1276102,1040.5084508,855.341971,1714.4554359,1.2932195,10.5413067,1.3258177,23.3413101),(19901,'metatarsus.tif',241,10,63,318.3822946,69.4345921,82.116339,1.8,69.4874287,82.3643525,1.561034,12.7427326,14.8239476,10546.1490135,15147.2738741,53.0586592,1021.8110802,827.6206815,1717.570828,1.3064526,7.110747,1.3734008,16.0069191),(19902,'metatarsus.tif',241,10,64,317.6474753,69.4584095,82.1874076,1.8,69.5406682,82.4438296,1.5576101,12.5273677,14.5392121,10468.131124,15022.8123312,52.9320412,1033.2617923,835.62097,1720.1576127,0.7279236,5.2436802,1.3473197,11.381838),(19903,'metatarsus.tif',241,10,65,315.1690539,69.5326698,82.2158947,1.8,69.6055464,82.5143429,1.5525259,12.3516637,14.5195091,10319.3950778,14825.2166572,52.5106435,1021.054952,835.4659988,1695.4873323,1.1621102,2.1926651,1.012197,6.1324035),(19904,'metatarsus.tif',241,10,66,313.4852504,69.5592609,82.2877339,1.8,69.6327434,82.5593796,1.5468214,12.8666307,14.4234864,10221.6876932,14662.4727163,52.2175159,1016.569245,794.4339094,1666.5393143,2.6041468,15.6553108,1.2537406,35.6625121),(19905,'metatarsus.tif',241,10,67,311.4991149,69.5794743,82.3454013,1.8,69.6417049,82.6431206,1.5419165,12.3629604,14.6331619,10131.9835614,14514.816344,51.8732311,991.9125068,819.5434768,1574.1179232,1.242512,5.0173022,1.3370531,12.673256),(19906,'metatarsus.tif',241,10,68,310.6884547,69.6056387,82.4067681,1.8,69.6859856,82.690288,1.5357943,12.4664785,15.2786067,10056.6059572,14399.2452572,51.7179956,942.4449173,806.6917998,1591.079992,1.2951156,10.8518942,1.3986055,23.5008194),(19907,'metatarsus.tif',241,10,69,309.6343771,69.6288571,82.4590614,1.8,69.6951169,82.7207644,1.5294614,12.7247422,14.5390554,9977.8151125,14276.4755266,51.5176077,981.9396867,784.1270954,1621.6026096,2.8464174,15.214326,1.2442149,37.249589),(19908,'metatarsus.tif',241,10,70,308.5411105,69.6441302,82.520612,1.8,69.7101146,82.76803,1.5275774,12.4361162,15.1061941,9918.4938329,14172.0131709,51.327526,938.1590833,797.5555767,1594.7047985,1.9391523,11.3196929,1.2360595,27.6143373),(19909,'metatarsus.tif',241,10,71,307.9503935,69.6658692,82.5799972,1.8,69.7038242,82.8284483,1.5278005,12.5454193,14.2294497,9860.3950202,14074.9091058,51.2302433,989.1393827,785.9757236,1624.6333083,0.9296882,3.8332024,1.3258177,8.7853182),(19910,'metatarsus.tif',241,10,72,306.8260899,69.6939037,82.6292808,1.8,69.7646047,82.8882799,1.5257181,11.9423817,14.3230985,9804.958008,13963.2210223,51.0338384,974.8743274,821.021992,1642.212694,20.9179834,26.1988199,1.9430657,79.2176976),(19911,'metatarsus.tif',241,10,73,305.6334101,69.7598744,82.6474295,1.8,69.8320367,82.9476274,1.5215094,11.9386442,14.49718,9707.1100745,13858.7424524,50.8152618,955.9612618,813.0831193,1599.7674178,0.4648441,0.9583006,1.815775,2.2444657),(19912,'metatarsus.tif',241,10,74,303.6181857,69.7843956,82.7099486,1.8,69.8283687,83.0500977,1.521901,12.3402201,14.8185077,9620.8217551,13687.8996662,50.4821485,923.7029781,779.6312959,1556.2091633,1.5615954,7.2982,1.4108832,17.7865408),(19913,'metatarsus.tif',241,10,75,301.2742086,69.8136014,82.7497709,1.8,69.8600899,83.0636439,1.5161652,12.1670555,14.6710807,9556.4962829,13538.1024567,50.0626561,922.7747235,785.4403483,1574.1569358,0.6972661,1.039423,1.1071487,2.4370105),(19914,'metatarsus.tif',241,10,76,300.3795064,69.8405478,82.8002915,1.8,69.8679403,83.0979126,1.5120085,12.2436753,15.6236711,9519.413266,13414.6683893,49.8904322,858.6117998,777.4963833,1466.9212805,0.6972661,1.3552417,1.0303768,2.9018545),(19915,'metatarsus.tif',241,10,77,299.3778937,69.8697514,82.8241272,1.8,69.9227689,83.0932373,1.5073322,12.1845331,15.2120355,9481.570967,13275.745797,49.6956187,872.7133092,778.1644859,1495.9571508,2.1346575,13.4282825,1.1613591,30.5492273),(19916,'metatarsus.tif',241,10,78,299.5771457,69.8942191,82.8620954,1.8,69.9489231,83.1649493,1.502675,12.3277199,15.2508357,9470.9183288,13203.3093984,49.6981847,865.7433375,768.2619665,1486.6567832,1.7401161,13.0342975,1.1869787,29.3939589),(19917,'metatarsus.tif',241,10,79,299.3935595,69.9203097,82.887931,1.8,69.9685923,83.195527,1.4972159,11.9732969,13.9018343,9462.9469399,13115.1200147,49.6292582,943.4093202,790.337619,1530.491494,2.260371,14.0706543,1.1810878,32.2394184),(19918,'metatarsus.tif',241,10,80,298.9763778,69.94357,82.9093455,1.8,69.9856782,83.1882304,1.4935996,11.8091298,14.1229737,9454.0437299,13031.693306,49.533036,922.7301282,800.5707381,1571.2164183,20.6855613,25.794658,1.9981695,77.90292),(19919,'metatarsus.tif',241,10,81,297.6460288,70.0322864,82.8989484,1.8,70.0921498,83.2158826,1.4889012,12.4323361,14.5810793,9415.9581609,12898.9437603,49.2757059,884.6357338,757.3764162,1529.7555815,1.2498839,8.7119518,1.4100336,18.9321333),(19920,'metatarsus.tif',241,10,82,296.609303,70.0563021,82.9241509,1.8,70.1051586,83.2660424,1.4850047,12.1029045,14.242928,9380.4942825,12776.8336711,49.0719252,897.0651037,775.0614123,1525.7350708,2.019193,12.1261061,1.3583643,28.3514807),(19921,'metatarsus.tif',241,10,83,295.4767,70.0792825,82.9467414,1.8,70.1389984,83.2978326,1.4806175,12.5592737,14.5870382,9359.6261124,12657.0576401,48.8467214,867.6920888,745.2362583,1492.6800607,0.4648441,0.6573888,2.3561945,1.3147776),(19922,'metatarsus.tif',241,10,84,295.0141906,70.1010374,82.9590423,1.8,70.1517236,83.3327076,1.4771145,12.0096158,14.1785286,9340.2302286,12550.3470986,48.7387724,885.165691,777.7293146,1513.3053878,0.4648441,3.5171836,1.4382448,7.74284),(19923,'metatarsus.tif',241,10,85,294.9402159,70.121973,82.9676646,1.8,70.1480254,83.2774977,1.4750595,11.7659995,14.2991643,9335.8342898,12470.5127882,48.7075301,872.1147958,793.4586712,1523.3941523,1.1067174,8.8503675,1.332187,19.3172227),(19924,'metatarsus.tif',241,10,86,294.3860852,70.1483864,82.9783531,1.8,70.1796044,83.2760848,1.4712898,12.0920932,13.9458395,9324.8237089,12387.1774871,48.5801366,888.2346229,771.1504986,1466.2398357,0.4648441,2.8275361,1.4056476,6.1557631),(19925,'metatarsus.tif',241,10,87,293.6978704,70.1676538,82.9898697,1.8,70.1787429,83.2750758,1.4690026,11.9590968,13.8417747,9326.0467841,12295.8862248,48.4441808,888.3171774,779.8286888,1540.7403664,0.8764811,7.6664049,1.3258177,16.6079129),(19926,'metatarsus.tif',241,10,88,293.085349,70.1911412,83.0017167,1.8,70.2121443,83.2684687,1.4663192,12.3077744,13.6337212,9321.0288972,12218.5130622,48.3163018,896.1979579,757.3285482,1520.3081387,1.1621102,6.1536999,1.380808,13.8986031),(19927,'metatarsus.tif',241,10,89,291.0806012,70.261797,82.9683827,1.8,70.3162187,83.2489633,1.4603383,11.9412657,14.2175178,9267.4208021,12066.5212965,47.9239258,848.7080155,776.0836276,1490.8184609,0.4648441,2.7987319,1.6539376,6.1557631),(19928,'metatarsus.tif',241,10,90,289.661905,70.2829606,82.9903968,1.8,70.3374834,83.2890825,1.4566003,12.2284702,14.2902551,9222.9450957,11958.8035177,47.6501498,836.8502501,754.219046,1471.4935227,1.925075,13.0342975,1.1869787,28.6004205),(19929,'metatarsus.tif',241,10,91,288.5233597,70.3001141,83.005895,1.8,70.3445339,83.2893256,1.4534267,12.44674,14.1312055,9193.7751197,11849.3486704,47.4278318,838.5235575,738.6492471,1457.7865406,1.2887117,10.9928499,1.3360737,24.5432976),(19930,'metatarsus.tif',241,10,92,287.8560326,70.3206873,83.0214713,1.8,70.3572306,83.3417117,1.4503589,11.9521582,14.0336353,9173.6805614,11757.1707197,47.2834637,837.7851105,767.533398,1421.7401243,0.4648441,2.1046711,1.6814535,4.5686861),(19931,'metatarsus.tif',241,10,93,287.3142938,70.3441868,83.0241345,1.8,70.4029368,83.3663086,1.4395806,12.0499734,13.7645747,9168.1240825,11639.6080452,47.0659617,845.620612,760.8418498,1467.0449281,21.1504054,25.1800076,1.9890207,77.142417),(19932,'metatarsus.tif',241,10,94,286.9114356,70.3621157,83.0333635,1.8,70.3866863,83.3421503,1.4330089,12.00196,13.7751577,9156.598287,11560.8476635,46.9164505,839.2533826,762.9252478,1462.2408236,0.4648441,2.3358126,1.670465,5.0335302),(19933,'metatarsus.tif',241,10,95,286.8153946,70.3827431,83.0516571,1.8,70.4044888,83.3183028,1.4276816,11.8463935,13.6349697,9156.0481433,11465.3692481,46.8301495,840.8797009,772.8975166,1494.2030542,21.1504054,25.1574713,2.0509714,76.6211779),(19934,'metatarsus.tif',241,10,96,286.9201443,70.4032153,83.0745878,1.8,70.4390871,83.3712034,1.42236,11.7674585,13.4062093,9147.0251222,11379.0033626,46.774105,848.7860447,777.3152626,1470.3936669,0.232422,2.5671853,1.6614562,5.3058295),(19935,'metatarsus.tif',241,10,97,285.6184913,70.4723066,83.0481696,1.8,70.4908715,83.3524457,1.412566,12.7964734,13.6151514,9090.0939937,11289.6886441,46.4211653,829.2003759,710.359306,1450.5039997,1.9828091,12.8926161,1.0829599,28.9057553),(19936,'metatarsus.tif',241,10,98,283.8919138,70.4961835,83.0702627,1.8,70.5303114,83.3890985,1.4019479,12.0578612,13.7805065,9031.0386872,11154.2804357,45.9791413,809.4245618,748.9751728,1427.8358015,0.4648441,2.1428253,1.3521274,4.5686861),(19937,'metatarsus.tif',241,10,99,282.4206708,70.5172879,83.0852464,1.8,70.5386376,83.408512,1.3881764,12.0242435,13.7565626,8989.2380569,11067.9008747,45.5176962,804.5542476,747.5928141,1439.5472979,0.6049494,3.7835567,1.3854484,8.0151394),(19938,'metatarsus.tif',241,10,100,281.9109021,70.5391022,83.0993162,1.8,70.5939227,83.4151896,1.3792956,11.756497,13.804535,8976.1164797,11009.8466959,45.2830469,797.5528809,763.5026365,1430.2192689,0.4648441,1.039423,1.1071487,2.2444657),(19939,'metatarsus.tif',241,10,101,280.8855042,70.551587,83.1137187,1.8,70.581977,83.4283511,1.3623605,11.9728621,14.298634,8959.0373212,10923.9784603,44.8096669,763.9875545,748.2786716,1387.9049232,21.1504054,24.834379,2.1224513,75.9637891),(19940,'metatarsus.tif',241,10,102,280.3053293,70.5649252,83.1242812,1.8,70.592131,83.4175195,1.3392245,11.8810798,13.6361044,8941.6419511,10833.7105966,44.2567653,794.4872129,752.5950604,1435.7423466,21.1504054,24.7941049,2.1015698,75.3064003),(19941,'metatarsus.tif',241,10,103,279.628737,70.5846473,83.1404327,1.8,70.5970127,83.4448457,1.3162784,11.9640524,13.5072893,8936.7868771,10760.6511363,43.6503917,796.6551151,746.9698886,1455.1771642,0.6908661,5.470565,1.3567356,11.6541373),(19942,'metatarsus.tif',241,10,104,279.1729882,70.6089302,83.1435519,1.8,70.6283928,83.4248351,1.2908751,11.8526415,13.5491279,8940.7386816,10687.7927242,42.9772565,788.8177592,754.3245701,1440.187962,0.232422,0.9583006,1.815775,2.051921),(19943,'metatarsus.tif',241,10,105,277.2860531,70.6880542,83.1274027,1.8,70.7245392,83.4377213,1.2666361,11.9512889,13.8768905,8894.7981275,10584.61145,42.0691252,762.7509507,744.2543,1399.2188491,0.232422,0.734983,1.8925469,1.5870769),(19944,'metatarsus.tif',241,10,106,275.9010785,70.7098769,83.1449742,1.8,70.7367125,83.4450072,1.2380491,11.9817823,13.929122,8857.3329731,10496.1528484,41.0773406,753.5401616,739.2333393,1388.7202634,0.232422,1.4137681,1.735945,2.9816092),(19945,'metatarsus.tif',241,10,107,274.3747023,70.7259673,83.1609586,1.8,70.7294162,83.4784246,1.2143317,12.0217523,13.7017746,8832.5651638,10414.7119095,40.1604378,760.0994916,734.7152874,1404.7249989,0.4648441,2.8275361,1.735945,5.9632183),(19946,'metatarsus.tif',241,10,108,273.6154594,70.7521459,83.169493,1.8,70.7739941,83.4721523,1.1871564,12.0556923,13.6383297,8849.1263249,10360.3328228,39.2136932,759.6482176,734.0205846,1404.3723615,0.6972661,4.4404168,1.4659194,9.6022163),(19947,'metatarsus.tif',241,10,109,272.9428449,70.7770893,83.1753505,1.8,70.7844099,83.4857022,1.1479606,12.1089954,13.3640459,8863.6703551,10305.2561355,37.8305363,771.1179828,731.9905636,1369.1651818,0.4648441,3.2621988,1.6421038,6.8929065),(19948,'metatarsus.tif',241,10,110,272.3750782,70.803476,83.1875638,1.8,70.8440568,83.4674538,1.1055909,12.0928352,13.6724402,8895.3735125,10266.4658564,36.2600369,750.8876024,735.5904009,1401.2517678,0.4648441,1.8738464,1.6951513,4.103842),(19949,'metatarsus.tif',241,10,111,272.0948618,70.8208637,83.2004837,1.8,70.8384789,83.5004031,1.0653172,11.9558111,13.6774696,8916.6965463,10241.4299531,34.7158815,748.7810408,745.8044024,1383.2593099,21.3828275,24.5147413,2.1193457,75.090496),(19950,'metatarsus.tif',241,10,112,271.3104422,70.8362729,83.2098696,1.8,70.8635533,83.4792177,1.0124476,12.1741056,13.3293995,8905.0801896,10191.5163413,32.5267922,764.5893085,731.4771589,1418.3787614,0.4648441,0.6573888,2.3561945,1.3147776),(19951,'metatarsus.tif',241,10,113,269.9448165,70.8914912,83.183604,1.8,70.9202868,83.4752876,0.9706813,12.1094968,13.4148371,8863.5903648,10135.518699,30.6419594,755.5454156,731.953646,1387.5063292,0.4648441,0.6573888,2.3561945,1.3147776),(19952,'metatarsus.tif',241,10,114,268.6933858,70.8952601,83.1970108,1.8,70.9056254,83.4803142,0.9233325,12.0436617,13.3387524,8828.1540927,10075.1244809,28.4900737,755.3273508,733.0124576,1385.0055878,0.232422,0.9583006,1.815775,2.051921),(19953,'metatarsus.tif',241,10,115,267.2272338,70.8975759,83.2004688,1.8,70.9101541,83.4970429,0.8872978,12.2099608,13.8407726,8778.246388,10044.9401589,26.775978,725.7499599,718.9414038,1331.2496619,0.232422,1.4137681,1.735945,2.9816092),(19954,'metatarsus.tif',241,10,116,266.424562,70.9052277,83.1998122,1.8,70.9125635,83.4752285,0.8390938,12.1965899,13.2785024,8773.8352191,10029.1748249,24.5817725,755.2941212,719.3678951,1390.139584,0.232422,0.9583006,1.815775,2.051921),(19955,'metatarsus.tif',241,10,117,266.0298232,70.9124084,83.1846843,1.8,70.9211223,83.4706471,0.7964823,12.2008322,13.4860271,8803.4929521,10053.5807511,22.660566,745.4812786,721.5485654,1385.0071613,0.232422,0.3286944,2.3561945,0.6573888),(19956,'metatarsus.tif',241,10,118,265.2513785,70.921652,83.1658223,1.8,70.9262069,83.4497631,0.7592815,12.1188152,13.4334801,8796.3723469,10068.076574,20.9502243,749.4764204,725.8442532,1375.9421742,21.6408118,24.3600028,2.0899424,75.146891),(19957,'metatarsus.tif',241,10,119,265.6062408,70.9356949,83.1573335,1.8,70.9309771,83.432495,0.72101,12.723232,13.3615092,8809.72672,10111.3670735,19.2914103,756.7533664,692.412647,1344.6455664,21.6655512,24.3600028,2.0899424,75.2830407),(19958,'metatarsus.tif',241,10,120,265.2260873,70.9445024,83.1439375,1.8,70.965576,83.3991313,0.6812229,11.9484561,12.553307,8814.1627469,10138.5478674,17.5304187,807.6396045,737.6821439,1394.6003968,21.62557,24.394351,2.1112158,75.4755854),(19959,'metatarsus.tif',241,10,121,263.3240758,71.0053804,83.1071475,1.8,71.0278227,83.3978984,0.6471914,12.3187818,13.2320602,8790.1392009,10125.4410914,15.9550912,765.2203019,713.5558796,1389.5343884,21.5516767,24.394351,2.1112158,75.3394357),(19960,'metatarsus.tif',241,10,122,261.0509468,71.0066472,83.0869663,1.8,70.9896985,83.3828097,0.6049476,13.0291693,12.9930037,8754.0621802,10133.7304711,14.0724426,779.9374747,671.8818356,1368.9471314,0.4648441,0.734983,1.8925469,1.7796217),(19961,'metatarsus.tif',241,10,123,259.5856951,71.0182597,83.0704641,1.8,71.02231,83.373419,0.5788521,12.8820005,12.932686,8749.5482545,10144.7478725,12.9480654,784.4269828,679.2072603,1386.111713,21.5342789,24.4319676,2.1667143,75.8042798),(19962,'metatarsus.tif',241,10,124,259.5881178,71.0244424,83.0628288,1.8,71.0081967,83.3455986,0.5457159,12.4970337,12.7915255,8776.3635205,10217.8429075,11.6551716,798.7978367,702.2757354,1387.0637506,0.232422,0.734983,1.8925469,1.5870769),(19963,'metatarsus.tif',241,10,125,259.2905167,71.0219612,83.0408859,1.8,71.0125098,83.3422207,0.5053832,13.1480377,12.9050643,8808.2077733,10303.6591393,10.1293669,798.4198215,669.9256553,1393.5189634,21.5213395,24.439705,2.1324198,76.1329742),(19964,'metatarsus.tif',241,10,126,259.2814479,71.0152336,83.0275767,1.8,71.0278917,83.3000336,0.4691939,12.7924128,12.8111878,8854.5823841,10423.1697527,8.8352503,813.5990154,692.1745338,1392.0470181,21.5107829,24.439705,2.1324198,75.9404295),(19965,'metatarsus.tif',241,10,127,259.4435243,70.9982864,83.0167198,1.8,71.0055364,83.2851622,0.438461,12.9115213,12.674264,8894.0910621,10533.4682993,7.7936753,831.091121,688.8491943,1401.1793322,21.5252953,24.4960037,2.1535358,75.9404295),(19966,'metatarsus.tif',241,10,128,259.1808233,70.9850101,83.0054341,1.8,70.9870862,83.2562251,0.4174198,12.7533349,12.8784124,8918.7714304,10623.0581669,7.0994687,824.8732687,699.3285701,1448.8503299,0.232422,0.3286944,2.3561945,0.6573888),(19967,'metatarsus.tif',241,10,129,258.1737431,71.0349117,82.9592167,1.8,71.0217249,83.2682467,0.4134763,13.6205099,12.8118428,8941.2393323,10613.4164359,6.9465645,828.4067038,656.4540843,1433.4418848,21.6663503,24.4529634,2.2009902,76.5978183),(19968,'metatarsus.tif',241,10,130,256.9545608,71.0493769,82.9563367,1.8,71.0256586,83.2483606,0.4004892,12.7323278,12.7682734,8926.9926951,10618.4945836,6.5094185,831.6312045,701.1280892,1433.4735136,0.232422,0.734983,1.8925469,1.5870769),(19969,'metatarsus.tif',241,10,131,255.8358229,71.0451772,82.9567132,1.8,71.0117243,83.304964,0.3913724,13.1613329,12.8722191,8929.8986533,10630.2424157,6.2044336,825.8282683,678.4950067,1419.257954,21.6911966,24.4651106,2.2485046,76.5978183),(19970,'metatarsus.tif',241,10,132,255.0846502,71.0272558,82.9512508,1.8,71.0070552,83.2585782,0.3785746,13.1070787,12.7839855,8924.4758693,10638.8049863,5.8074915,832.1978308,680.8897765,1451.2955503,21.6960134,24.4960037,2.1535358,76.5978183),(19971,'metatarsus.tif',241,10,133,255.065645,71.0006727,82.9548732,1.8,70.9741908,83.2692407,0.3697095,13.21113,12.9710014,8921.1651421,10680.9636852,5.5506491,823.449426,675.2764628,1443.1415443,21.663268,24.5059254,2.1877382,76.5978183),(19972,'metatarsus.tif',241,10,134,254.3727156,70.9921194,82.9470657,1.8,70.9882869,83.2313347,0.3638056,13.6113985,12.8412729,8905.0918373,10688.3398808,5.368,832.3427085,654.2378335,1432.4957519,21.6294137,24.4651106,2.2485046,76.7339679),(19973,'metatarsus.tif',241,10,135,254.1234051,70.9916536,82.9362753,1.8,70.9883931,83.191188,0.3564319,12.6958073,12.9718288,8923.4456696,10693.0740956,5.1567571,824.3304988,702.8655543,1428.9146117,21.6677744,24.4651106,2.2485046,76.7339679),(19974,'metatarsus.tif',241,10,136,253.3131869,70.9921009,82.9378129,1.8,71.0241906,83.1723238,0.3462802,12.9508864,12.8614967,8911.7228267,10694.2208347,4.8633255,831.491164,688.1168232,1382.7865945,21.6677744,24.5059254,2.1877382,76.4616686),(19975,'metatarsus.tif',241,10,137,251.6452129,71.0431705,82.8915091,1.8,71.0606722,83.1859657,0.3489556,12.8199663,12.949656,8849.8010615,10578.957566,4.9031784,816.9296236,690.313909,1422.4238534,0.232422,0.734983,1.8925469,1.5870769),(19976,'metatarsus.tif',241,10,138,249.3656506,71.0436409,82.8891963,1.8,71.0401673,83.2140633,0.346321,13.6923132,12.8295329,8781.148039,10481.6013717,4.7886177,816.9900999,641.319541,1399.5230998,21.7435661,24.439705,2.1324198,76.9829077),(19977,'metatarsus.tif',241,10,139,246.7907953,71.0490964,82.8758699,1.8,71.0398843,83.1751902,0.3441033,13.0307397,13.1088086,8693.0162592,10379.5081241,4.6810809,791.7964498,667.116102,1380.760533,0.232422,0.9583006,1.815775,2.051921),(19978,'metatarsus.tif',241,10,140,245.1175012,71.0398133,82.8576252,1.8,71.0221067,83.1110743,0.3347764,12.9880151,13.1037282,8613.7550885,10310.6968645,4.4100862,786.8521599,663.2079647,1404.2270926,21.7409382,24.3167218,2.1243298,76.6542133),(19979,'metatarsus.tif',241,10,141,244.0866194,71.0350201,82.8210497,1.8,71.0356064,83.0685488,0.3225039,13.2007635,12.6998507,8560.2767572,10253.5604224,4.0865171,807.3764511,648.4683045,1379.2271145,21.7571511,24.2755889,2.1030058,76.381914),(19980,'metatarsus.tif',241,10,142,242.427436,71.0305671,82.7859583,1.8,71.0445813,83.0099108,0.3027724,12.6316319,12.5658838,8476.7130783,10177.0980469,3.5921268,809.8991039,671.0703054,1412.4767842,21.7409382,24.1953462,2.1161581,76.1096146),(19981,'metatarsus.tif',241,10,143,241.3243638,71.0135026,82.7589808,1.8,71.037518,82.9568583,0.2827606,12.4378214,12.6563079,8409.4187796,10132.9419558,3.1309946,800.6238525,676.1167028,1393.8155105,0.232422,0.5197115,2.0344439,1.1222329),(19982,'metatarsus.tif',241,10,144,239.5291809,70.9832692,82.7140373,1.8,70.9912548,82.9045164,0.2622605,12.3771531,12.5256843,8308.883086,10068.366213,2.6834462,803.8176582,671.3080946,1393.783597,21.4914728,23.9800529,2.1561108,75.7245252),(19983,'metatarsus.tif',241,10,145,236.5308743,70.9930889,82.6736491,1.8,70.9952894,82.8965027,0.246233,12.6065186,12.6578682,8140.4195245,9921.2464607,2.342254,783.8007413,645.7309742,1330.3018014,0.232422,0.9583006,1.815775,2.051921),(19984,'metatarsus.tif',241,10,146,233.7151389,70.9723797,82.6440814,1.8,70.9971574,82.8663911,0.226677,12.4833439,12.4981187,7994.395064,9801.3998936,1.9674295,784.2300212,640.4049346,1346.9273662,21.6152495,23.7866668,2.161509,76.02986),(19985,'metatarsus.tif',241,10,147,231.0429003,70.9626224,82.6108472,1.8,70.9783576,82.8246672,0.204927,12.5737533,12.5531177,7854.496882,9738.7426378,1.594599,775.802704,624.6740109,1345.5840351,21.3828275,23.6682791,2.1887627,75.8373152),(19986,'metatarsus.tif',241,10,148,229.6356628,70.9665035,82.5867051,1.8,70.9946969,82.756149,0.1865133,12.3883939,12.553105,7735.9743837,9762.9621009,1.3160291,777.7328498,624.4533775,1334.4029949,21.3828275,23.6260174,2.8727522,75.7011656),(19987,'metatarsus.tif',241,10,149,228.4825158,70.9669721,82.5623735,1.8,70.9874862,82.7009851,0.1643863,12.3425561,12.7347117,7627.5402928,9840.0838228,1.0198057,772.6978071,617.9870854,1349.6770687,0.232422,0.734983,1.8925469,1.5870769),(19988,'metatarsus.tif',241,10,150,227.4953903,70.9579665,82.5622778,1.8,70.9799488,82.6898374,0.1414156,12.2195368,12.7315502,7533.327781,9953.974079,0.753215,781.8351984,616.4986365,1347.7006594,0.232422,0.3286944,2.3561945,0.6573888),(19989,'metatarsus.tif',241,10,151,226.4501687,70.9568042,82.5742576,1.8,70.9635936,82.6652627,0.1253437,12.1953664,12.9600708,7425.9200357,10108.8890146,0.5898623,780.0026084,608.9132365,1340.0904435,20.9179834,24.1148365,2.9574288,75.2363215),(19990,'metatarsus.tif',241,10,152,226.655281,70.960488,82.5719252,1.8,70.9653315,82.6240989,0.1119554,12.3433536,12.9864391,7370.7080889,10316.6808149,0.4715081,794.4195294,597.1398337,1351.3677579,21.1504054,24.3322674,3.026716,76.086255),(19991,'metatarsus.tif',241,10,153,225.8914054,71.0048401,82.534702,1.8,71.0033825,82.6126664,0.1020929,12.5255612,13.1843491,7271.533958,10467.7759569,0.3910473,793.9547039,580.5355799,1345.3864009,21.1294055,24.5719673,2.9608931,76.086255),(19992,'metatarsus.tif',241,10,154,224.5981665,70.9949538,82.5397003,1.8,70.9916799,82.6005339,0.0941799,12.187488,13.3853452,7196.4810948,10676.7737502,0.3310446,797.6465027,590.4810811,1334.9488754,0.232422,0.5197115,2.0344439,1.1222329),(19993,'metatarsus.tif',241,10,155,224.434535,71.0006215,82.5492653,1.8,71.005484,82.6531529,0.0862992,12.2917795,13.4338349,7174.1756479,10919.7625479,0.2778896,812.8552025,583.6563906,1346.6065325,21.1309895,25.2089532,3.0492633,77.9786668),(19994,'metatarsus.tif',241,10,156,224.8932958,70.9775026,82.5513652,1.8,70.9608535,82.6103863,0.079415,12.1529841,13.7799164,7193.8053485,11262.6895963,0.235894,817.3264114,591.9373606,1337.0008603,21.1127372,25.4478251,2.976444,77.786122),(19995,'metatarsus.tif',241,10,157,226.6919164,70.9564245,82.5959785,1.8,70.9282088,82.6438865,0.0666721,12.2250309,13.7866951,7279.7699775,11655.0720625,0.1676981,845.3854947,595.4807012,1372.924271,20.9179834,25.7726592,3.0150005,78.3073612),(19996,'metatarsus.tif',241,10,158,228.1596726,70.9552547,82.6271686,1.8,70.9266113,82.649369,0.0650583,11.9627164,14.0805036,7389.5932908,12081.3075655,0.1607234,858.0167207,617.7186719,1381.582699,20.9179834,26.180256,3.034857,79.2370493),(19997,'metatarsus.tif',241,10,159,228.8853086,70.9763118,82.6445631,1.8,70.9435537,82.657916,0.0656063,12.1174474,13.7457991,7493.3288079,12557.3787461,0.1639589,913.5430142,618.3916904,1439.3556785,20.9179834,26.6191733,3.0453992,80.0869828),(19998,'metatarsus.tif',241,10,160,229.6296879,70.988358,82.6700242,1.8,70.9262339,82.7146187,0.0679758,11.9207575,13.5754203,7618.3718541,13040.4760741,0.1765695,960.594648,639.0845406,1474.9663963,21.1504054,27.0419819,3.0641616,81.3453654),(19999,'metatarsus.tif',241,10,161,228.9046412,71.015107,82.7184372,1.8,70.941067,82.7908885,0.0701084,12.2555843,13.807532,7748.002466,13462.2693916,0.1872113,974.9946203,632.2017992,1468.0009876,21.1504054,27.48581,2.9458555,81.8899641),(20000,'metatarsus.tif',241,10,162,229.4219237,70.9749895,82.7947786,1.8,70.9477946,82.9048886,0.0735724,13.0368805,14.0145777,7913.5125842,14043.3506449,0.206599,1002.0530758,607.0096736,1501.9552987,21.4103587,27.9873195,3.0584514,83.5898311),(20001,'metatarsus.tif',241,10,163,230.4351098,70.8934119,82.8429549,1.8,70.8848837,83.0022244,0.0682298,12.3738946,15.1947475,8088.2783246,14667.6258231,0.1785131,965.308956,653.6566371,1496.0597671,21.4995842,28.5690083,3.0192558,84.8482137),(20002,'metatarsus.tif',241,10,164,232.156891,70.8509903,82.8306255,1.8,70.8291507,83.0468422,0.0683127,12.5296314,15.2307264,8341.4915865,15434.9147964,0.1802835,1013.4063478,665.7411821,1559.2765509,21.8749196,29.0899184,3.0053453,86.3788956),(20003,'metatarsus.tif',241,10,165,235.1789828,70.739574,82.8389411,1.8,70.7314874,83.0667871,0.0628845,12.4914002,15.4394392,8659.6966763,16454.7148741,0.1547969,1065.7585864,693.2526809,1606.9530301,22.0214329,29.8596744,3.0558658,88.6233613),(20004,'metatarsus.tif',241,10,166,238.8302112,70.6842541,82.8313458,1.8,70.6137212,83.1003068,0.0604917,13.326421,15.5735783,9016.4621607,17643.8489547,0.1454788,1132.9348067,676.585422,1661.6825824,22.1235852,30.5544383,3.0578197,90.6188873),(20005,'metatarsus.tif',241,10,167,245.4845753,70.6344644,82.8618241,1.8,70.5598023,83.1250324,0.0581383,12.7244431,15.6148362,9518.5384561,19189.6416671,0.1381359,1228.9364661,748.0514777,1791.9315192,22.5353723,31.2907744,3.0448804,93.5207418),(20006,'metatarsus.tif',241,10,168,253.6579982,70.5401966,82.9089916,1.8,70.5095568,83.1642389,0.054099,12.9427851,16.0016019,10123.8953872,21039.8587817,0.1236094,1314.8595286,782.2037754,1934.6660584,23.123229,32.238872,3.0404893,96.502351),(20007,'metatarsus.tif',241,10,169,262.956265,70.4968995,82.9004567,1.8,70.5693728,83.1657006,0.047433,13.3548266,16.5131661,10687.4422685,22977.4572295,0.0985292,1391.4628567,800.2681449,2009.9096563,23.3021628,33.2777714,2.9304993,99.0988707),(20008,'metatarsus.tif',241,10,170,277.7933664,70.4143015,82.9470414,1.8,70.5767339,83.1509054,0.0525286,13.5321842,17.8117454,11283.6102189,25489.9182964,0.1276328,1431.0735788,833.8351044,2044.0971911,23.5324124,34.7360159,2.8706458,102.1602345),(20009,'metatarsus.tif',241,10,171,298.6080759,70.3772114,82.9286538,1.8,70.5549684,83.1824685,0.06132,13.6630729,17.9701377,12046.3234099,28959.388418,0.1868995,1611.5284661,881.6701432,2228.0444921,23.8418937,36.4280302,2.8703043,106.3768666),(20010,'metatarsus.tif',241,10,172,330.6660015,70.2944365,82.8640291,1.8,70.4733408,83.1407002,0.0598612,13.9066479,19.2875052,12862.756727,33506.4599218,0.1972465,1737.2106781,924.9358165,2396.6046104,23.8437725,38.6142479,2.8922345,110.8094031),(20011,'metatarsus.tif',241,10,173,359.9495578,70.0497119,82.8358175,1.8,70.251688,83.0948547,0.0548125,14.1245673,19.8342664,13669.7991632,38760.3973678,0.1800587,1954.2138104,967.8030427,2621.9627751,24.2441822,39.8120701,2.8697083,114.1994613),(20012,'metatarsus.tif',241,10,174,390.9324689,69.998603,82.9037099,1.8,70.216291,83.1606678,0.0442394,14.1482202,20.1850981,14897.9158866,44055.8227847,0.1274344,2182.5914661,1052.9886949,2886.938622,24.1235908,40.4233978,2.8798792,116.8290165),(20013,'metatarsus.tif',241,10,175,404.0872238,70.12974,82.9887969,1.8,70.3564734,83.2303781,0.0394142,13.8080411,20.8588238,15514.3882954,46184.4533757,0.104569,2214.1446652,1123.5763404,2910.8247665,0.4648441,0.8380096,2.5535901,1.643472),(20014,'metatarsus.tif',241,10,176,412.6906623,70.3390362,83.1448119,1.8,70.4764177,83.4449283,0.0395091,14.1007513,21.1411999,15820.235228,47554.1431297,0.107312,2249.3587574,1121.9427139,2935.1415467,0.4648441,0.6573888,0.7853982,1.3147776),(20015,'metatarsus.tif',241,10,177,426.2566403,70.575305,83.2332658,1.8,70.5245532,83.7103954,0.0348991,14.7211213,21.7300075,16565.4871997,49261.7603767,0.0864944,2266.9923325,1125.2870531,3012.8556719,0.9296882,2.0788459,0.4636476,4.8973805),(20016,'metatarsus.tif',241,10,178,429.8879959,70.4932728,83.311802,1.8,70.4970303,83.862515,0.0410298,14.8526281,21.1032197,17548.9230612,50204.1286054,0.1205509,2378.9795705,1181.5365555,3050.3990851,27.6350124,42.5249766,0.2767982,191.3942654),(20017,'metatarsus.tif',241,10,179,420.3555934,70.3742561,83.2973049,1.8,70.3826765,83.8440857,0.0548262,15.430606,21.183067,18649.1376574,50555.8323018,0.210383,2386.6153258,1208.5810275,3066.0724986,1.6604937,6.7762086,1.1839206,18.5567197),(20018,'metatarsus.tif',241,10,180,420.9044202,70.3156537,83.3276661,1.8,70.4131418,83.8522339,0.0606884,16.325324,21.5299553,20203.9437643,52211.5185955,0.2580563,2425.0639621,1237.5830185,3159.4672942,1.6477909,7.5025891,1.2882414,21.707514),(20019,'metatarsus.tif',241,10,181,420.6427834,70.2529387,83.3852282,1.8,70.3227852,83.8667464,0.0765561,15.2978071,21.7423423,21433.19215,54205.3804074,0.4100863,2493.0791517,1401.0630434,3278.7720836,1.6111782,7.057368,1.2698761,18.5333601),(20020,'metatarsus.tif',241,10,182,426.8350145,70.1567688,83.3903016,1.8,70.2549264,83.8857468,0.0844294,15.4401386,21.8977777,22052.4114714,56275.5061253,0.5059012,2569.9185906,1428.2521733,3382.7536413,1.4665007,7.5025891,1.2882414,18.7492644),(20021,'metatarsus.tif',241,10,183,434.116469,70.1993782,83.3700659,1.8,70.2976958,83.7702098,0.0882494,16.0830118,21.8857083,22076.26958,57882.1687735,0.5620208,2644.7473437,1372.6452413,3457.7688023,18.742394,27.5564727,0.8749781,84.6032818),(20022,'metatarsus.tif',241,10,184,443.4798708,70.2828369,83.3541682,1.8,70.3432879,83.6577002,0.0850641,16.0101986,21.7207669,21354.0533139,59202.7644896,0.5335417,2725.6295718,1333.7781616,3526.6413803,18.668554,27.1575976,0.8398896,83.6969532),(20023,'metatarsus.tif',241,10,185,446.258627,70.3936321,83.314762,1.8,70.4137445,83.5994053,0.0804116,14.936974,21.9312401,19747.020869,59099.0196334,0.4798862,2694.7413556,1322.0228484,3507.7027249,18.8092423,26.4369213,1.4562556,82.0301216),(20024,'metatarsus.tif',241,10,186,437.8336837,70.5627073,83.2844169,1.8,70.4651478,83.5058423,0.0786606,14.3884436,21.8024705,17370.4291895,57531.4410801,0.450586,2638.7578905,1207.2486534,3413.8368144,18.9004853,25.5790986,1.237552,99.2253445),(20025,'metatarsus.tif',241,10,187,414.0181794,70.8278378,83.2321102,1.8,70.6617413,83.3450433,0.0783708,13.8631167,21.8177017,14370.5748016,52896.0217911,0.4229486,2424.4543503,1036.6049041,3062.946466,18.6359189,24.2132009,1.19742,94.9289578),(20026,'metatarsus.tif',241,10,188,366.1978716,71.6724424,83.2209534,1.8,71.1811998,83.2492078,0.0800489,13.7165619,21.902168,10942.9433406,42047.0891245,0.3902529,1919.7683635,797.7905435,2415.2964162,18.3342035,24.711174,1.2847449,98.2255776),(20027,'metatarsus.tif',241,10,189,299.2117904,72.8804009,83.2330001,1.8,72.7168049,83.2676865,0.0819338,12.8238213,21.0768993,7566.0685495,26650.822361,0.3340261,1264.456499,590.0010915,1622.9008327,16.2239047,22.2008674,1.2291808,79.4763132),(20028,'metatarsus.tif',241,10,190,231.7623158,71.9632823,83.0976904,1.8,72.6249876,83.1592746,0.0825804,10.9148663,17.9302141,4437.7024053,17039.3194456,0.2628191,950.3132167,406.5741406,1194.0503799,10.8156188,19.3357815,1.1232764,61.8162462),(20029,'metatarsus.tif',241,10,191,153.6238539,71.890338,83.0645563,1.8,71.4225327,83.0130365,0.076003,9.0493529,14.1071447,1912.5027685,9352.2487923,0.1476155,662.9441301,211.3413838,774.9626351,9.9941476,15.0285606,1.017115,48.7111816),(20030,'metatarsus.tif',241,10,192,55.5673656,75.7413184,83.3732704,1.8,74.1093998,83.3091468,0.0729089,7.4257364,17.2390363,434.0021132,2428.2209003,0.0491428,140.8559538,58.4456663,166.0053883,3.7187526,9.6671923,1.4016951,22.7403164),(20031,'metatarsus.tif',241,10,193,8.4604165,79.8142981,83.5934418,1.8,79.7569241,83.6569852,-1.5490508,1.7436487,5.192583,3.7939399,36.7331482,1.4094027,7.0741572,2.1758625,7.8047489,3.4863306,10.2503125,1.5027199,23.4774598),(20032,'metatarsus.tif',241,10,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20033,'metatarsus.tif',241,10,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20034,'metatarsus.tif',241,10,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20035,'metatarsus.tif',241,10,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20036,'metatarsus.tif',241,10,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20037,'metatarsus.tif',241,10,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20038,'metatarsus.tif',241,10,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20039,'metatarsus.tif',241,10,201,14.3890628,85.4759927,80.7398908,1.8,85.4814651,80.7519566,-1.0704034,5.2183216,5.5216419,78.4440338,86.3451159,1.8461658,15.6375798,15.032426,29.7245979,10.6825679,11.3482901,0.9600704,35.2774226),(20040,'metatarsus.tif',241,10,202,70.004408,69.8462277,82.133181,1.8,64.2106787,82.4665607,-0.0775887,13.8532911,26.6549255,1657.8626446,21941.9483643,0.0700972,823.1855068,119.6728371,885.2085029,16.0246222,26.0354183,1.5886516,109.6034077),(20041,'metatarsus.tif',241,10,203,471.9696278,60.4020363,81.8187259,1.8,65.2789996,81.5753427,-0.0358903,16.5715678,34.2636729,22160.1512762,66156.1196792,0.1012837,1930.7947461,1337.2392759,2575.596373,28.925107,29.2085247,2.5315186,95.8449622),(20042,'metatarsus.tif',241,10,204,544.0567033,61.6809194,81.6626792,1.8,66.7430088,81.5227181,-0.0360347,16.4619088,34.1499197,25829.3135469,84095.8178244,0.1176904,2462.5480388,1569.0351479,3216.1593167,29.0527547,29.3202035,2.4235084,96.0608665),(20043,'metatarsus.tif',241,10,205,565.9309088,62.4879601,81.6377471,1.8,67.7476394,81.529252,-0.0365177,16.7633792,33.4534967,27069.5905273,95809.3857872,0.1257225,2863.9572876,1614.8051225,3641.5194148,29.0527547,29.29993,0.7292774,96.0608665),(20044,'metatarsus.tif',241,10,206,581.9528162,63.0636282,81.6138605,1.8,68.4371902,81.4719264,-0.0371781,16.2725686,32.9493607,28186.0359238,103894.4180175,0.1339966,3153.1542915,1732.1196565,3938.3450761,29.0527547,29.2565712,2.2492593,95.7885671),(20045,'metatarsus.tif',241,10,207,596.469399,63.4908015,81.6019971,1.8,68.952533,81.4461121,-0.0369673,16.278399,32.5550827,29326.1491124,110227.3322868,0.1357863,3385.8716687,1801.537679,4185.7955917,28.8203327,29.2676476,0.5990154,95.5960224),(20046,'metatarsus.tif',241,10,208,608.6314462,63.8132245,81.5912445,1.8,69.2875253,81.4329576,-0.0376475,16.4091531,32.2723589,30450.2508517,115346.5566882,0.1436978,3574.1594534,1855.6869217,4381.8212111,28.8203327,29.2704161,1.000413,95.5960224),(20047,'sheep_femur.tif',153,7,1,21.6045037,63.2690813,94.2995507,1.8,63.3694649,94.3510156,-0.0225867,1.8823791,33.4227647,11.1543148,7691.5818695,0.0018366,230.130031,5.9256473,230.2614932,7.3199352,126.7109234,0.0247883,266.5960183),(20048,'sheep_femur.tif',153,7,2,21.9173682,62.7932424,94.4445422,1.8,63.2421919,94.4957556,-0.0205567,1.9497551,32.9510535,10.7671012,7830.6882523,0.0015434,237.6460667,5.5222839,237.7507209,7.1938246,126.4430554,0.0227704,265.8557652),(20049,'sheep_femur.tif',153,7,3,22.1846926,62.4028252,94.5632419,1.8,63.4620939,94.6245885,-0.0169521,1.9431295,32.8773165,10.6415295,7934.9211156,0.0010625,241.3494156,5.4764901,241.6364799,7.2166627,126.4430554,0.0227704,265.8557652),(20050,'sheep_femur.tif',153,7,4,4.297782,81.5745383,83.0078194,1.8,81.533,83.0496522,-1.2970158,1.9089399,3.7472348,2.1784049,10.5852628,0.6639346,2.8248198,1.1411595,3.4058541,3.829796,7.5355077,1.2160907,18.5217365),(20051,'sheep_femur.tif',153,7,5,22.2533348,81.0449017,82.7201684,1.8,80.6955938,82.1111059,1.5352851,3.5723653,10.5410338,49.8414391,370.66346,3.704214,35.1638622,13.9519437,39.5591549,6.1840257,13.08595,1.2870022,32.3588352),(20052,'sheep_femur.tif',153,7,6,53.2363836,80.4071204,81.7835204,1.8,80.3994306,81.6133813,-1.5647071,4.6554748,10.601769,192.1611948,1788.7604897,8.8724016,168.7228318,41.2763899,186.1441804,8.8468468,21.2573192,1.4968573,53.8043846),(20053,'sheep_femur.tif',153,7,7,68.0541586,80.2580565,81.9111203,1.8,80.2232748,81.7264276,-1.5061657,5.3302914,11.1202572,390.7197291,2612.1714396,11.2950474,234.9020698,73.3017578,266.8262425,10.2424361,22.2075936,1.4288993,58.1452),(20054,'sheep_femur.tif',153,7,8,78.9711634,80.3648381,82.1277115,1.8,80.2427396,81.7668429,-1.4673738,6.3171116,11.9580959,669.2922698,3387.4230614,13.0215796,283.274453,105.9490963,336.1132307,12.0087331,23.8724458,1.3045443,62.3962077),(20055,'sheep_femur.tif',153,7,9,93.5361021,80.6955887,82.5228519,1.8,80.387423,82.0755624,-1.4551831,6.9934237,12.5914713,1103.0550235,4221.1475806,15.3819031,335.2386301,157.7274687,419.2795513,13.9546598,25.5963323,1.2910922,67.5779795),(20056,'sheep_femur.tif',153,7,10,99.1829811,80.5767755,82.5752881,1.8,80.2926278,82.0456849,-1.4408744,7.838146,13.0225947,1431.3545678,4680.8569287,16.2530333,359.44119,182.6139203,446.2589485,14.917983,26.6863559,1.1027628,77.1903746),(20057,'sheep_femur.tif',153,7,11,100.8275279,80.3401488,82.4345242,1.8,80.1306416,82.0008527,-1.4199614,8.232047,13.2069174,1641.5577256,4773.2126862,16.4251546,361.4176223,199.4106362,476.0117749,15.6211783,26.5422295,1.3521274,71.2792451),(20058,'sheep_femur.tif',153,7,12,109.0775565,78.0956009,82.1280137,1.8,75.7763235,81.7882627,0.0731965,13.6129779,37.7502573,4988.4813989,9221.6247152,0.0972274,244.2797845,366.4504157,376.0688748,16.155607,27.5601416,1.2520488,80.0615793),(20059,'sheep_femur.tif',153,7,13,165.5888776,67.7411217,80.9497079,1.8,69.1808275,81.1436268,0.1016776,13.6957232,29.9913186,5636.6564262,48920.828093,0.2843369,1631.1662974,411.5632548,1818.9144213,12.562512,15.9326479,0.2489627,47.1793061),(20060,'sheep_femur.tif',153,7,14,222.9115955,62.7099238,80.4555564,1.8,65.8595597,80.8614853,0.1025725,13.9217506,26.2189043,7199.1856413,69561.3043547,0.3895106,2653.0973011,517.1178434,2880.2817483,16.226578,20.8621401,0.3455556,61.5135387),(20061,'sheep_femur.tif',153,7,15,270.7687774,60.5761701,80.1436316,1.8,63.7302996,80.5183722,0.1036216,13.9933905,28.1687369,9114.9484598,80428.4530937,0.4828282,2855.2381777,651.375267,3128.8952957,18.843768,26.5383582,3.0527185,75.8477712),(20062,'sheep_femur.tif',153,7,16,309.6790272,59.5430691,79.9751766,1.8,62.5588177,80.2719126,0.1025749,14.3892351,29.1639969,11113.4000596,89102.8575871,0.5411512,3055.234779,772.3412643,3388.978186,27.7845518,55.1202831,3.0655491,174.404783),(20063,'sheep_femur.tif',153,7,17,360.9307668,58.5703985,79.5148025,1.8,61.4271798,79.7483624,0.089399,15.0200908,29.9427312,14084.4640589,100594.1719391,0.4794917,3359.5523153,937.7083192,3792.2173651,28.1604171,56.0958519,3.0855766,171.1897558),(20064,'sheep_femur.tif',153,7,18,376.9774581,57.9915122,79.4014874,1.8,60.9057525,79.4667946,0.082074,15.4967732,30.358694,16290.4448321,107726.8879922,0.4222798,3548.4691142,1051.2152808,4059.6963039,28.4556538,56.580355,3.0999501,173.8595539),(20065,'sheep_femur.tif',153,7,19,389.4059805,57.8163256,79.1061012,1.8,60.7340183,79.0680108,0.0782914,15.8776506,30.5455881,18078.1219933,113112.7826093,0.3970012,3703.0808623,1138.5892282,4279.3772181,28.7247701,56.8418482,3.1001418,169.4552348),(20066,'sheep_femur.tif',153,7,20,398.7704111,57.9713761,78.8411519,1.8,60.4651148,78.8836084,0.0695445,16.7602105,30.2049893,20453.43913,116420.4667633,0.3209206,3854.3455755,1220.3569338,4473.9735243,29.7468961,56.9303499,2.961328,171.8556097),(20067,'sheep_femur.tif',153,7,21,389.5210967,58.3194029,78.6538042,1.8,60.2962168,78.6388839,0.0657202,17.0400664,29.8578894,21281.1355825,113780.147297,0.2799965,3810.7230517,1248.888067,4455.9136234,30.8006836,56.9778553,2.956809,175.8371941),(20068,'sheep_femur.tif',153,7,22,382.9133315,58.4599297,78.495612,1.8,60.0319929,78.3922605,0.0591699,17.0932082,29.473686,21949.5939712,110358.6078546,0.2231739,3744.3096791,1284.1120122,4414.9604789,31.6032432,56.580355,3.0999501,180.1517054),(20069,'sheep_femur.tif',153,7,23,371.3924752,58.9312088,78.4386202,1.8,59.83251,78.2361234,0.0582519,17.1323482,28.7308621,21789.6829534,104659.1200995,0.2098027,3642.7420652,1271.8445075,4352.0110247,31.8633253,56.2750626,0.0139526,182.0395378),(20070,'sheep_femur.tif',153,7,24,357.7824655,59.6327028,78.3637193,1.8,59.7485488,78.0878678,0.0519706,17.174844,27.7654241,21358.7691405,97321.4423744,0.1609136,3505.1307733,1243.6077522,4258.7949568,32.0383531,55.5590665,0.0518403,182.779791),(20071,'sheep_femur.tif',153,7,25,345.6160784,60.4030498,78.2752961,1.8,59.9325449,78.014266,0.0492231,17.1332713,27.8913344,20700.6592684,89698.4587521,0.1394539,3215.997393,1208.2140614,3936.1918023,31.9216883,54.7749794,0.0525831,180.2787128),(20072,'sheep_femur.tif',153,7,26,336.9877189,61.0789545,78.2078438,1.8,60.2251793,78.0158704,0.0440004,17.3235606,28.096156,20169.2623252,81467.8829304,0.1086663,2899.6095775,1164.2677186,3597.2430769,31.7331895,54.0568541,0.0726873,179.3588442),(20073,'sheep_femur.tif',153,7,27,334.8867134,61.7092491,78.1705636,1.8,60.6691188,78.0523046,0.0364324,17.2521242,28.0921299,19939.1486602,75257.5916595,0.0740508,2678.9564181,1155.7503513,3349.1951719,31.4002363,53.2937263,0.0786551,175.6684741),(20074,'sheep_femur.tif',153,7,28,330.9576727,62.0317046,78.1883461,1.8,61.459331,78.2122699,0.0370905,17.2783003,27.3086761,19570.9425304,69402.1699296,0.0758482,2541.3963593,1132.6891081,3245.8623748,31.3101231,51.5127886,0.0915799,170.1165757),(20075,'sheep_femur.tif',153,7,29,322.2592389,62.7008568,78.2743553,1.8,62.5097126,78.4091514,0.0279253,17.2929301,26.8573789,19487.599251,60412.6414519,0.0418732,2249.3870925,1126.9113555,2959.5843694,31.1104336,49.9252574,0.0892361,168.646965),(20076,'sheep_femur.tif',153,7,30,309.3823943,63.8985712,78.1784617,1.8,64.3658824,78.6032249,0.0577267,17.5127037,24.2329249,19375.038359,49335.2480078,0.1716385,2035.8767341,1106.3419279,2696.803447,31.1817634,46.3833708,0.1586553,156.1261656),(20077,'sheep_femur.tif',153,7,31,308.0442775,64.3956639,78.229994,1.8,65.0802213,78.6895475,0.0696473,17.4142982,22.2214845,19837.9333696,44716.9295589,0.2486387,2012.3286344,1139.1750096,2829.8288241,31.2424337,42.8612309,0.1470784,147.3701355),(20078,'sheep_femur.tif',153,7,32,310.5566169,64.6062495,78.3340617,1.8,65.2618803,78.9877361,0.0775939,17.8577951,21.5238579,20716.2917279,42073.9969636,0.311009,1954.7609478,1160.0699614,2872.5921021,31.9834953,41.3648515,0.025311,146.5028751),(20079,'sheep_femur.tif',153,7,33,307.147737,64.5091581,78.1806607,1.8,65.0310853,78.9551457,0.0639668,30.3386906,24.4179268,21037.8275755,38211.9212897,0.2091765,1564.9125966,693.4322854,1521.3907785,32.3057834,39.812269,0.4342443,130.7779441),(20080,'sheep_femur.tif',153,7,34,306.6206642,64.4609744,78.2468139,1.8,64.8814664,79.0329526,0.0351976,17.8049901,19.759037,21536.8677844,36056.1277775,0.0632844,1824.7917538,1209.5972879,2848.615453,31.9509771,38.7432528,0.4545844,125.2260457),(20081,'sheep_femur.tif',153,7,35,303.7151738,64.3417502,78.1610481,1.8,64.6026416,79.0688755,-0.0250402,17.3881836,19.3420089,21722.7416811,33539.062642,0.0317319,1734.0009906,1249.2818248,2809.2121919,31.5082142,37.7538162,0.5225855,121.2181572),(20082,'sheep_femur.tif',153,7,36,297.8316485,64.0737202,78.5838169,1.8,64.2643087,79.1867331,0.003669,16.9548528,18.8041385,21835.3710518,30812.1899686,0.0006682,1638.585567,1287.8537671,2782.6040337,31.0802311,36.675228,2.8446677,118.0775292),(20083,'sheep_femur.tif',153,7,37,289.7928807,63.6771135,78.5030536,1.8,63.8425293,79.2659395,-0.1149261,17.0928222,17.9897938,21588.6731685,28201.3692604,0.635128,1567.6316039,1263.0256706,2620.0838781,30.5119397,35.7904919,0.5717768,116.6079185),(20084,'sheep_femur.tif',153,7,38,289.1000456,63.3027089,78.6955289,1.8,63.431026,79.4396754,-0.330577,15.5842425,17.6586808,22117.9970039,27260.3625477,5.0764954,1543.7372067,1419.2539072,2545.5970874,30.0204084,35.3562899,0.606481,114.7572857),(20085,'sheep_femur.tif',153,7,39,291.6003461,62.9889834,78.7422593,1.8,63.0390675,79.4884535,-0.5324456,15.933546,18.0937447,21930.1134685,27335.8486249,12.5242487,1510.7900034,1376.3485865,2570.9902678,29.6173998,35.7176924,1.0743736,111.0034119),(20086,'sheep_femur.tif',153,7,40,287.4585086,62.6801026,78.6789995,1.8,62.7169558,79.4232276,-0.6670961,15.9634734,18.6129467,21015.4388725,27308.1952453,18.3397869,1467.1613083,1316.4703156,2510.4345531,29.4116934,36.3930598,0.8668502,113.7739133),(20087,'sheep_femur.tif',153,7,41,281.4005655,62.5275382,78.5905339,1.8,62.5577979,79.1975932,-0.8182194,15.7181303,19.3114141,19898.7962477,27237.5675916,24.9882632,1410.4387912,1265.9773042,2395.5521835,29.2634121,36.954315,1.0024376,113.646906),(20088,'sheep_femur.tif',153,7,42,276.6078835,62.4645508,78.13991,1.8,62.5336233,78.8603662,-0.8867779,15.3860691,20.895637,18966.4199198,26504.6500455,27.6924377,1268.4298643,1232.7008124,2123.3579061,28.9871612,36.8977383,1.018212,108.3490223),(20089,'sheep_femur.tif',153,7,43,268.8532115,62.4197466,77.8845712,1.8,62.4692467,78.7598085,-0.9415145,14.9856298,19.7316074,18214.4716623,25360.4309291,29.2867193,1285.2693858,1215.4625399,2185.3400187,28.7770755,36.7833927,1.0657711,107.6722729),(20090,'sheep_femur.tif',153,7,44,257.304479,62.3521009,77.6030845,1.8,62.336335,78.6455846,-0.9802633,14.6080207,19.5870579,17367.4359495,24018.0490059,29.5887046,1226.2203526,1188.8972684,2050.1425425,28.78909,36.5405091,1.1423905,115.6136506),(20091,'sheep_femur.tif',153,7,45,248.6398785,62.245642,77.159201,1.8,62.2303614,78.2205151,-0.9998217,14.2777294,19.2967487,16490.2613995,22493.5038362,29.3358293,1165.6628865,1154.9638553,2001.397695,28.2347193,35.9556569,1.142964,104.3783334),(20092,'sheep_femur.tif',153,7,46,246.9129695,62.1952887,76.6815111,1.8,62.1865472,77.636813,-1.0182167,13.9854145,18.9992241,15743.4456899,21765.937393,29.8145786,1145.6224379,1125.7046205,1952.2870415,27.480495,35.4800625,1.136843,101.417321),(20093,'sheep_femur.tif',153,7,47,239.7272156,62.1693124,76.3871507,1.8,62.3884811,77.4297876,-1.0107144,13.8073805,18.4668692,14867.205911,20916.6716352,28.6780675,1132.6593284,1076.7578922,1924.7946524,26.957057,34.7653082,1.0936815,100.0638221),(20094,'sheep_femur.tif',153,7,48,232.6885016,62.0238416,76.1363909,1.8,62.3448771,77.107296,-1.034006,13.6282253,17.753276,14135.383503,19922.8329802,28.639694,1122.2060062,1037.2138092,1907.1750182,26.695338,33.9630196,1.1416178,97.8430627),(20095,'sheep_femur.tif',153,7,49,223.8916814,61.6757227,75.6003176,1.8,61.9360455,76.5686635,-1.0646858,13.1723723,17.7606794,13199.744223,18765.8881782,28.5457906,1056.5974265,1002.0779811,1762.6976806,25.910181,32.9994346,1.1888172,95.685807),(20096,'sheep_femur.tif',153,7,50,213.4929278,61.5729335,75.196931,1.8,61.7671348,76.2102322,-1.1001101,12.8938714,17.0258835,12384.2870959,17717.6426773,28.264314,1040.6298533,960.4785615,1745.9849011,25.648462,32.3199123,1.1978086,94.1789967),(20097,'sheep_femur.tif',153,7,51,207.4106372,61.4568486,74.7027341,1.8,61.5703729,75.7096852,-1.1165719,12.6540157,16.2965086,11708.9059127,16424.5458688,27.9134891,1007.8567327,925.3114759,1690.9979771,25.125024,31.6171284,1.2595166,92.4553713),(20098,'sheep_femur.tif',153,7,52,201.9507545,61.4097819,74.0279919,1.8,61.4502691,74.9052745,-1.1624972,12.7098817,15.4629638,11089.1655331,15267.0988847,28.3522788,987.3332864,872.4837727,1703.5405125,24.863305,30.6568927,1.0230563,91.2179842),(20099,'sheep_femur.tif',153,7,53,193.9484353,61.4397931,73.314206,1.8,61.5061131,74.0185803,-1.2186931,12.5478573,15.9103546,10418.1986419,13903.3945839,28.4801246,873.8582456,830.2771089,1527.5185971,24.601586,30.2248621,1.0645389,88.690602),(20100,'sheep_femur.tif',153,7,54,187.6405203,61.5899162,72.5693905,1.8,61.6533861,73.211652,-1.2842003,12.3326948,15.138099,9959.5090884,12578.4161391,28.7742702,830.9112063,807.5695733,1480.2554098,24.339867,29.417495,1.1588953,86.59685),(20101,'sheep_femur.tif',153,7,55,184.6836572,61.791817,71.8842379,1.8,61.8959933,72.3081759,-1.343079,11.9995897,14.1587072,9654.6604642,11660.5974228,29.2118743,823.563711,804.5825512,1424.6739317,24.078148,27.9059226,1.2164164,83.7628449),(20102,'sheep_femur.tif',153,7,56,183.689187,61.8925441,71.2880948,1.8,62.0048332,71.7625479,-1.3714716,11.8144946,13.7354872,9493.8259912,10898.4149025,29.4145492,793.4494598,803.5744526,1458.348263,23.816429,27.109086,1.3070845,82.3458423),(20103,'sheep_femur.tif',153,7,57,180.7595358,61.8314358,70.7867906,1.8,61.917804,71.3676091,-1.4087278,11.7494923,13.5268532,9167.5263399,10316.5829042,29.3421823,762.6742718,780.2487227,1378.7158797,23.55471,26.6606762,1.3329604,81.2989663),(20104,'sheep_femur.tif',153,7,58,181.7434202,61.7508421,70.3597547,1.8,61.8277425,70.7982919,-1.4873064,11.8201554,13.0609117,8902.5415263,10065.31558,30.0799175,770.6441794,753.1661977,1348.4098139,23.292991,26.1522637,1.3282448,80.0352752),(20105,'sheep_femur.tif',153,7,59,181.8331511,61.7400333,69.8603082,1.8,61.7436736,70.1158506,-1.5157914,11.6255779,14.5051098,8694.5512034,9777.1883335,30.2139271,674.0513142,747.8812028,1268.5914404,23.031272,25.7763322,1.3455195,79.1417106),(20106,'sheep_femur.tif',153,7,60,179.7364422,61.7608671,69.3715113,1.8,61.8320394,69.6605955,-1.5272098,11.5658344,12.8985145,8476.1562739,9377.7762277,29.8991996,727.0431193,732.8616332,1371.0410656,22.769553,25.5816098,1.3332617,78.6182726),(20107,'sheep_femur.tif',153,7,61,180.1917386,61.7760867,69.0095882,1.8,61.8289887,69.3089326,1.4679406,11.5163958,13.0004008,8375.9120596,9103.5566644,29.7153581,700.2520021,727.3032441,1344.3294152,22.769553,25.1318387,1.424481,77.7882118),(20108,'sheep_femur.tif',153,7,62,180.1691346,61.7221545,68.5995806,1.8,61.8094553,68.875944,1.4218591,11.4485599,12.879824,8229.0912619,8847.7077089,29.3670052,686.9432153,718.788331,1305.7860181,22.507834,24.6141119,1.4213806,76.984455),(20109,'sheep_femur.tif',153,7,63,182.7443665,61.6867012,68.1968138,1.8,61.8311324,68.5380642,1.4421269,11.4263594,13.1995775,8169.9050716,8740.769312,29.9559238,662.2006885,715.0050878,1278.5879186,22.246115,24.2496459,1.451796,76.2442018),(20110,'sheep_femur.tif',153,7,64,182.5377344,61.6858631,67.8655653,1.8,61.8065373,68.0900672,1.360388,11.3192108,11.9849719,8063.4483642,8544.7005991,29.0958403,712.95124,712.3684224,1317.162259,22.246115,24.1690093,1.484058,75.937579),(20111,'sheep_femur.tif',153,7,65,184.5333586,61.5751594,67.4392584,1.8,61.6839687,67.6448856,1.1466415,11.0802998,12.2582287,7963.5035674,8424.2668024,25.5463684,687.2336125,718.7083102,1316.9618946,21.984396,23.9326249,1.4722158,75.1973258),(20112,'sheep_femur.tif',153,7,66,184.816375,61.5785629,67.1607064,1.8,61.6610888,67.3511279,1.0467514,11.4576364,12.4234,7871.4254526,8331.1514119,23.0901422,670.6015566,687.0025524,1300.8233476,21.984396,23.6996634,1.4601391,74.8271993),(20113,'sheep_femur.tif',153,7,67,183.5951802,61.5633503,66.8198044,1.8,61.6567377,66.9689365,0.9685107,11.710647,12.3135869,7736.1883143,8154.3203564,20.7782846,662.2213688,660.6115206,1290.4797328,21.984396,23.4117849,1.4700153,74.3037613),(20114,'sheep_femur.tif',153,7,68,183.0879093,61.5489899,66.5370887,1.8,61.6585186,66.6796518,0.92852,11.5119462,12.1738881,7630.3113301,8060.4176458,19.5652427,662.1070922,662.8168015,1286.9635516,21.984396,23.3297203,1.5146755,74.1504498),(20115,'sheep_femur.tif',153,7,69,180.7273008,61.5670437,66.2843021,1.8,61.6972178,66.454036,0.8935881,11.7691253,12.1249517,7457.9266456,7954.4241238,18.294052,656.0375939,633.6857226,1161.9008891,21.722677,23.164719,2.1305932,73.1933816),(20116,'sheep_femur.tif',153,7,70,179.6060906,61.5988307,66.0144534,1.8,61.7400389,66.1367322,0.8443877,11.5975703,12.2150484,7334.0417457,7945.7080038,16.7288942,650.4851842,632.3774351,1241.2340962,21.722677,23.3414615,2.0996779,73.5635082),(20117,'sheep_femur.tif',153,7,71,178.4248108,61.6250627,65.7559143,1.8,61.7460842,65.944477,0.8337761,11.6258372,12.1602731,7211.2500691,7936.2138724,16.305129,652.6345113,620.2779171,1188.5129875,21.6360992,23.3062202,2.1806023,73.3466931),(20118,'sheep_femur.tif',153,7,72,177.8771682,61.6563733,65.5306384,1.8,61.7781543,65.6690382,0.8225117,11.5873068,12.0968005,7122.4856381,7968.2856072,15.9223629,658.710176,614.6799923,1185.5657186,21.4673404,23.3047507,2.1401095,73.4737004),(20119,'sheep_femur.tif',153,7,73,177.6405843,61.6872603,65.3212504,1.8,61.8324212,65.4770514,0.8091916,11.6419732,12.1979776,7064.8192418,8014.0494269,15.5075643,656.9982085,606.840363,1192.4083016,21.4673404,23.4570901,2.1897488,73.6270118),(20120,'sheep_femur.tif',153,7,74,177.2663633,61.7155433,65.1102815,1.8,61.8720636,65.2662638,0.8046955,11.6421957,12.1353921,6993.8646436,8053.4447514,15.3421836,663.6328432,600.7341566,1195.1325627,21.4099853,23.4570901,2.1897488,73.4101967),(20121,'sheep_femur.tif',153,7,75,177.3493275,61.7637903,64.9271499,1.8,61.919046,65.0566946,0.8065351,12.4474594,12.0478962,6946.201319,8136.990454,15.4036946,675.3868312,558.0416931,1200.2846699,21.2822772,23.4570901,2.1897488,73.0400702),(20122,'sheep_femur.tif',153,7,76,177.6030564,61.8070731,64.7649821,1.8,61.9575594,64.8751235,0.8139085,11.9023653,12.1354763,6924.885963,8229.5510238,15.6437179,678.1399252,581.8075449,1205.5733353,21.2822772,23.6098971,2.1987776,73.1933816),(20123,'sheep_femur.tif',153,7,77,179.2483503,61.8378101,64.6004653,1.8,61.9636951,64.743442,0.8225468,11.3831247,12.230258,6974.7147739,8384.2661153,16.0461464,685.5346916,612.7240961,1162.2141996,21.2009672,23.764604,2.2076896,73.3466931),(20124,'sheep_femur.tif',153,7,78,180.2965595,61.8921506,64.4538008,1.8,62.0257726,64.6000286,0.8285374,11.562979,12.3058165,7004.8478715,8538.0647458,16.3194164,693.8235071,605.7995821,1209.5565069,21.0972139,23.9755175,2.2011977,73.5635082),(20125,'sheep_femur.tif',153,7,79,181.7063489,61.9639469,64.315016,1.8,62.0988233,64.4501709,0.8199962,11.4415518,12.3381813,7049.9507162,8733.0813795,16.1891397,707.8094524,616.1708537,1217.3668225,21.0972139,24.0795703,2.2251666,73.9336347),(20126,'sheep_femur.tif',153,7,80,181.5484948,62.0329444,64.2098543,1.8,62.1499626,64.3170952,0.8070649,11.339545,12.5294904,7039.2542891,8867.8749102,15.7844287,707.7602214,620.7704351,1167.5321306,21.1338702,24.3412741,2.2035452,74.1767539),(20127,'sheep_femur.tif',153,7,81,183.1912565,62.0196585,64.0666325,1.8,62.1148763,64.1699157,0.7995866,11.2368951,12.6327819,7071.5217303,9139.7037401,15.6990791,723.4909766,629.3127838,1231.4468603,20.9121506,24.6071539,2.2355708,74.4570727),(20128,'sheep_femur.tif',153,7,82,182.9985936,62.0877889,63.9829851,1.8,62.1716123,64.1056319,0.7899419,11.1443903,12.8257143,7076.1221228,9291.2534893,15.3884645,724.423863,634.9492358,1275.6044858,21.0547453,24.8977179,2.2668805,74.4833768),(20129,'sheep_femur.tif',153,7,83,181.2789286,62.1485635,63.8849326,1.8,62.2231844,63.9908424,0.7819138,11.2260224,12.8542825,7044.8428217,9361.9908235,15.0013056,728.3168702,627.5457663,1272.5417687,21.080459,25.0171058,2.304389,74.8535034),(20130,'sheep_femur.tif',153,7,84,179.9099467,62.216284,63.8049059,1.8,62.3153331,63.916096,0.7764867,11.3153968,12.8705781,7037.3963771,9449.5439109,14.7252995,734.1973186,621.9310265,1241.6894288,20.9121506,25.0991114,2.2601942,74.9170071),(20131,'sheep_femur.tif',153,7,85,177.3657044,62.2803374,63.7251029,1.8,62.3884697,63.8148848,0.7627939,11.3966827,12.9029171,6995.7228752,9464.1806344,14.1124991,733.4915494,613.838522,1269.3888514,21.0972139,25.2365523,2.2827972,75.6572602),(20132,'sheep_femur.tif',153,7,86,176.30089,62.3330049,63.6573748,1.8,62.4399815,63.7949047,0.7490072,11.3288625,13.1051654,7019.7591996,9560.653038,13.6233924,729.5331813,619.6349524,1262.6495426,21.0972139,25.5414145,2.3417028,75.9638831),(20133,'sheep_femur.tif',153,7,87,175.1402008,62.3944715,63.5952831,1.8,62.5172014,63.7487057,0.7356254,11.2668316,13.1480272,7023.9793364,9693.2070198,13.1445453,737.2366095,623.4209925,1265.2241942,21.0972139,25.6351055,2.4429328,76.1806982),(20134,'sheep_femur.tif',153,7,88,174.568356,62.4675798,63.5510958,1.8,62.5895508,63.7515459,0.7260406,11.3223287,13.3303313,7029.8902196,9870.4639913,12.8244245,740.4515165,620.8873121,1236.3568198,21.0972139,25.9511249,2.4132753,76.4873211),(20135,'sheep_femur.tif',153,7,89,173.6419052,62.5411983,63.5079511,1.8,62.6553726,63.7021706,0.7103661,14.4006411,13.3764613,7048.4173372,10019.1511643,12.3068472,749.0135802,489.4516351,1046.7190911,21.2822772,26.077511,2.4699865,77.2910778),(20136,'sheep_femur.tif',153,7,90,172.6167774,62.624458,63.4811055,1.8,62.7617705,63.6574555,0.6932333,11.4247445,13.5243481,7064.1774215,10172.2223702,11.7481877,752.1414213,618.3225728,1269.3443099,21.2822772,26.3206571,2.412473,77.5977007),(20137,'sheep_femur.tif',153,7,91,172.801449,62.6928351,63.4391123,1.8,62.8044656,63.6056527,0.685712,10.7826103,13.5804579,7182.9274177,10313.4995322,11.5481174,759.4368059,666.1584902,1277.4773323,21.2822772,26.4452772,2.4683973,78.031331),(20138,'sheep_femur.tif',153,7,92,176.2214752,62.8311017,63.4423334,1.8,62.866144,63.5713225,0.6787585,10.8773386,13.6865451,7466.2041861,10645.3364501,11.5767809,777.7957383,686.3999045,1312.4854884,21.2822772,26.6966209,2.4882879,78.1846424),(20139,'sheep_femur.tif',153,7,93,176.3688679,62.8859125,63.4371024,1.8,62.9468506,63.5768114,0.6538088,10.9451835,13.8936469,7577.8843722,10861.4504584,10.8738595,781.756622,692.3487766,1319.0875315,21.4673404,26.9049169,2.4942005,78.9248955),(20140,'sheep_femur.tif',153,7,94,175.9223308,62.9739767,63.4225919,1.8,63.096242,63.5718406,0.6260819,11.0918997,14.0802516,7663.7624115,11093.7662353,10.067621,787.8954547,690.933261,1327.0068649,21.6524037,27.1810019,2.465348,79.3848298),(20141,'sheep_femur.tif',153,7,95,176.3323986,63.1181002,63.4460131,1.8,63.2411179,63.5858969,0.5902969,11.184904,14.2004509,7762.7315568,11436.1133296,9.1049857,805.3345224,694.0364968,1349.7087231,21.837467,27.3856139,2.4713293,80.125083),(20142,'sheep_femur.tif',153,7,96,177.2363285,63.2452063,63.4953393,1.8,63.4658252,63.6393252,0.5563296,11.3028485,14.3627278,7859.8419296,11857.0171623,8.2373807,825.5407561,695.3859412,1372.7260778,21.837467,27.7138054,2.4565276,80.8653361),(20143,'sheep_femur.tif',153,7,97,180.9377314,63.2985637,63.5740032,1.8,63.5760054,63.7227159,0.5177918,11.4274142,14.3597506,8062.2744092,12609.1340147,7.3879295,878.0886489,705.5204482,1437.4271141,22.0225303,27.9010131,2.5093481,81.6690929),(20144,'sheep_femur.tif',153,7,98,181.3286822,63.4775962,63.6511672,1.8,63.7880295,63.7977024,0.488935,11.5185465,14.4905441,8156.4777902,13039.4718668,6.666999,899.8607505,708.1169275,1459.1762518,22.3926568,28.112568,2.5148498,82.7159689),(20145,'sheep_femur.tif',153,7,99,180.859811,63.6482523,63.7042066,1.8,64.0474423,63.8720836,0.4581676,11.5057183,14.5411,8231.4883768,13365.2356887,5.8970567,919.1351226,715.4258575,1480.1378429,22.5777201,28.3249612,2.5202691,83.2394069),(20146,'sheep_femur.tif',153,7,100,180.2597995,63.8151905,63.7629852,1.8,64.2559846,63.9763037,0.4369535,11.5005551,14.6423348,8278.586682,13668.5226989,5.3802239,933.4933864,719.8423559,1489.2913792,22.6535266,28.4781061,2.5127964,83.97966),(20147,'sheep_femur.tif',153,7,101,177.6860206,63.937963,63.8458162,1.8,64.397932,64.0833953,0.4236308,11.454347,14.7540729,8244.6327502,13794.6005953,5.0042611,934.9689883,719.781996,1484.3093021,22.7081732,28.6997289,2.6371514,84.7199131),(20148,'sheep_femur.tif',153,7,102,177.4133201,64.0734726,63.9763329,1.8,64.5008683,64.1914948,0.4149258,11.4788352,14.8006979,8322.2808295,14056.1428624,4.805161,949.6945994,725.0109143,1509.0228442,22.8442135,28.9184692,2.7022318,84.8097209),(20149,'sheep_femur.tif',153,7,103,179.1536794,64.2671022,64.1695665,1.8,64.7058754,64.3415141,0.4158087,11.4880461,14.7063774,8448.4581224,14510.9870128,4.871765,986.7139036,735.4129739,1547.3817815,22.8529866,29.1085185,2.5610712,85.3331589),(20150,'sheep_femur.tif',153,7,104,180.0885574,64.4207244,64.2339801,1.8,64.8887695,64.4243041,0.3968407,11.5337772,14.9561019,8582.8550991,14918.5459904,4.4838231,997.488921,744.149547,1555.6111073,22.947442,29.4710004,2.797374,86.073412),(20151,'sheep_femur.tif',153,7,105,178.7109408,64.4475846,64.2194047,1.8,64.9967428,64.4188107,0.3723476,11.5647082,15.4183623,8717.3615366,15090.7076881,3.9421472,978.7490625,753.7900153,1533.0464832,22.9894392,29.8967423,2.7838466,86.8136651),(20152,'sheep_femur.tif',153,7,106,180.356899,64.5720976,64.294074,1.8,65.1306628,64.5272512,0.3534417,11.5871221,15.5177998,8933.9756441,15410.7246231,3.6012817,993.0998479,771.0262763,1555.9050293,23.0503489,30.1329395,2.8418166,87.9240448),(20153,'sheep_femur.tif',153,7,107,184.1272346,64.7539406,64.3627118,1.8,65.2214692,64.5602133,0.334705,11.681361,15.5195443,9193.339808,15929.1371113,3.3114069,1026.3920622,787.0093059,1604.8096253,23.1075061,30.279203,2.8882284,88.0510522),(20154,'sheep_femur.tif',153,7,108,185.8691506,64.792389,64.3547488,1.8,65.3255617,64.5264122,0.3082653,11.7969621,15.6246906,9448.4712474,16161.5438732,2.8517072,1034.3592913,800.9241018,1623.0782098,23.3082636,30.4146306,2.871567,89.0081204),(20155,'sheep_femur.tif',153,7,109,187.8744889,64.7008735,64.2931448,1.8,65.0994948,64.4831867,0.272098,11.9166194,15.6990924,9824.2336641,16255.3484257,2.2616355,1035.432367,824.4144865,1633.0445261,23.4504488,30.3379625,2.9594243,89.8381813),(20156,'sheep_femur.tif',153,7,110,190.206557,64.6283085,64.2801169,1.8,64.9118048,64.3692044,0.2333965,12.0526638,15.8137288,10150.4808137,16320.1947512,1.6957538,1032.0269761,842.1773779,1652.1000839,23.6283317,30.2916424,2.9679215,89.8381813),(20157,'sheep_femur.tif',153,7,111,194.817245,64.5997737,64.2233857,1.8,64.8906384,64.3012532,0.1813418,12.1863063,16.0805529,10482.21516,16654.7485498,1.0561032,1035.7074583,860.1634379,1667.2124444,23.8385104,30.4720051,3.0555984,90.8850573),(20158,'sheep_femur.tif',153,7,112,198.5428086,64.6073029,64.1602777,1.8,64.8238705,64.1584215,0.1250946,12.2481427,16.2298618,10764.7785135,16977.0128138,0.5151259,1046.0355751,878.8906856,1703.9397444,24.0787396,30.521418,3.038511,91.1916802),(20159,'sheep_femur.tif',153,7,113,206.8641363,64.292849,64.1364677,1.8,64.5359749,64.1595095,0.0406807,12.3415092,16.3024808,11479.8553048,17213.0856447,0.0570257,1055.8568254,930.1824502,1750.2668402,24.363497,30.3526347,0.1297025,91.4347994),(20160,'sheep_femur.tif',153,7,114,208.3504968,64.1558117,64.1295875,1.8,64.3450394,64.2206819,-0.0382029,12.7735035,16.521925,11745.2286899,17178.4673165,0.0506553,1039.7376425,919.4993906,1743.7160754,24.6434581,30.5987457,0.2595005,92.1115488),(20161,'sheep_femur.tif',153,7,115,213.1054433,64.1780475,64.1927209,1.8,64.3894789,64.2461624,-0.1118788,12.8769134,16.570425,11937.0847668,17690.9798258,0.4427171,1067.6237805,927.014446,1787.681042,24.7210645,30.7862097,0.2491024,92.3283639),(20162,'sheep_femur.tif',153,7,116,218.7927355,64.2117905,64.2201338,1.8,64.4343125,64.2827861,-0.1686024,13.0236932,16.6209328,12255.988811,18186.8559959,1.0268095,1094.2139161,941.0532493,1831.5785168,24.9777315,31.0399175,0.2470237,92.8518019),(20163,'sheep_femur.tif',153,7,117,220.6380195,64.0504901,64.2105265,1.8,64.3574291,64.2792127,-0.2430435,13.1922131,16.8496191,12320.228437,18100.5568513,2.1297509,1074.2413105,933.9015598,1803.1359424,25.0800887,31.4106417,0.4114562,93.0051134),(20164,'sheep_femur.tif',153,7,118,226.4822732,63.9472138,64.2108697,1.8,64.1772987,64.250733,-0.3153953,13.3622957,16.9288242,12605.9008047,18433.7985397,3.6319936,1088.9001101,943.3933408,1811.0494015,25.4501604,31.7888944,0.3973244,94.115493),(20165,'sheep_femur.tif',153,7,119,233.6401925,63.897213,64.0978162,1.8,64.081083,64.1551065,-0.3928545,13.5336713,16.7326769,12908.8928121,19055.3027429,5.7069168,1138.8077862,953.8352568,1865.6050551,25.7867634,32.1925009,0.4454678,94.7024347),(20166,'sheep_femur.tif',153,7,120,236.2740619,63.8107672,64.0677084,1.8,63.9698493,64.1018724,-0.4595546,13.7592449,16.5412247,13015.3704522,19582.4106467,7.7472577,1183.8549409,945.9363931,1893.5669649,26.0983094,32.4468235,0.4239573,95.5061915),(20167,'sheep_femur.tif',153,7,121,237.3112285,63.5723213,64.1539579,1.8,63.8289544,64.1063899,-0.5053026,13.8608214,16.4928774,13326.6571496,19759.2416601,9.2680309,1198.0469644,961.4622948,1909.1512418,26.4795265,32.6593434,0.3775302,96.3997561),(20168,'sheep_femur.tif',153,7,122,242.1360418,63.5270553,64.1461811,1.8,63.8265145,64.0454289,-0.5201433,14.0384137,16.4296042,13720.9824544,20296.1451578,9.9684772,1235.3398729,977.388385,1975.3889962,26.769582,32.9568553,0.3996781,96.5530675),(20169,'sheep_femur.tif',153,7,123,244.8535395,63.4226307,64.1252319,1.8,63.8141795,63.9700738,-0.5539913,14.2878755,16.3233984,14058.2240734,21068.956661,11.2945307,1290.721216,983.9268288,2020.4796866,26.9916614,33.2702397,0.4214192,97.7269509),(20170,'sheep_femur.tif',153,7,124,257.7347014,63.5169369,64.1231406,1.8,64.0042424,63.9515166,-0.5411911,14.4486788,16.6282014,14684.7764511,21898.4281883,11.3999049,1316.9450913,1016.3404336,2110.537247,27.4545779,33.4396595,0.393587,99.7943988),(20171,'sheep_femur.tif',153,7,125,261.4375366,63.6192493,64.2216335,1.8,64.1675716,63.9150005,-0.523311,14.5503958,16.9882406,15489.7150532,22890.9104669,10.8823719,1347.456223,1064.5562713,2202.5100754,28.0246474,33.8549485,0.422149,104.0454065),(20172,'sheep_femur.tif',153,7,126,270.070421,63.7368691,64.323124,1.8,64.2876618,63.8620568,-0.5219045,15.2299548,17.2974893,16590.342275,23946.2015187,11.1869556,1384.3744103,1089.323143,2319.4000438,28.8651887,34.09386,0.4190038,104.8754673),(20173,'sheep_femur.tif',153,7,127,274.270128,63.7648094,64.4475028,1.8,64.4302147,63.8071746,-0.5322365,16.0219886,17.5088664,17832.8413927,24890.8173723,11.7715552,1421.6121629,1113.0229713,2303.4914744,30.0823118,35.2884182,1.0074801,107.8627839),(20174,'sheep_femur.tif',153,7,128,278.553837,63.8723805,64.4594717,1.8,64.5671874,63.7469088,-0.5503072,16.8127503,17.9380759,19118.782895,26035.352733,12.6962882,1451.4016391,1137.1597474,2123.3957971,31.2756943,36.5208211,1.0943289,112.5211177),(20175,'sheep_femur.tif',153,7,129,287.1542166,63.8694022,64.4030711,1.8,64.6685939,63.4624256,-0.6149749,17.7294419,19.1375374,21246.4275217,28165.6454757,15.9302364,1471.7486852,1198.3697883,2180.2220924,33.3449574,40.5326607,1.0204104,122.9263741),(20176,'sheep_femur.tif',153,7,130,295.3672985,64.1116565,64.5276583,1.8,64.9741198,63.4490845,-0.6401748,18.9749989,19.8936405,23247.4784559,30248.3577053,17.5649957,1520.5038851,1225.1636262,2284.2165919,34.8604193,41.6988268,1.022842,129.9850828),(20177,'sheep_femur.tif',153,7,131,309.3019002,64.5656187,64.7573976,1.8,65.2425477,63.5644911,-0.599352,21.4021216,19.9816227,26914.7680158,33297.1927187,16.4042014,1666.3908264,1257.5747619,2518.9296173,36.7379104,42.865226,1.0251413,134.3258982),(20178,'sheep_femur.tif',153,7,132,319.4694458,64.7499218,64.930522,1.8,65.2990908,63.6965302,-0.6615073,23.3103776,20.9407264,29952.2583571,35998.1320704,20.0931896,1719.0488679,1284.9323552,2692.5416576,37.8628885,44.2483167,1.091277,140.364035),(20179,'sheep_femur.tif',153,7,133,323.992956,64.9115404,65.0497105,1.8,65.487171,63.978019,-0.8520653,22.5757778,23.1501232,33328.8168667,38008.8552578,30.5887048,1641.8424618,1476.3086857,2823.9871689,38.6269798,45.5556484,1.0737421,145.2019844),(20180,'sheep_femur.tif',153,7,134,335.6006995,65.0903493,65.2997596,1.8,65.5909408,64.5065387,-1.1372479,23.2506298,25.1734672,37240.9176778,41755.2484595,46.0623917,1658.7007308,1601.7165112,3021.6240166,39.5954674,48.3188847,2.2294642,152.7841311),(20181,'sheep_femur.tif',153,7,135,349.0919192,65.4848651,65.7708197,1.8,66.0694918,65.3753398,1.5223914,21.354761,25.4353124,42007.1503485,46584.088111,58.0457707,1831.4730098,1967.109361,3260.0614146,41.7895703,52.8776021,2.1230998,162.8038523),(20182,'sheep_femur.tif',153,7,136,374.6615801,65.9448776,66.6430371,1.8,66.4752906,66.3247169,1.2364636,23.075483,28.3228388,46735.9733649,55671.1941349,55.7199715,1965.5937206,2025.3518992,3606.1269005,42.3767847,54.9597437,2.1389865,171.0627484),(20183,'sheep_femur.tif',153,7,137,417.2899211,66.1193968,67.9522745,1.8,66.6955493,67.7477108,1.3554477,22.3142894,28.993867,51880.7984187,70107.1447152,66.3725649,2417.9991125,2325.003391,4130.5999159,42.7790333,56.1837,2.1639668,195.6335173),(20184,'sheep_femur.tif',153,7,138,467.1589796,66.2714037,69.4103501,1.8,66.7990124,68.7503577,1.4192054,22.9676449,30.0019274,57898.1752845,86081.9886954,76.084289,2869.2152855,2520.8581696,4669.2311667,43.1606768,57.0763477,2.1867814,190.8853757),(20185,'sheep_femur.tif',153,7,139,496.929323,66.2521108,70.2623683,1.8,66.8914826,69.3892516,1.4384477,24.0732556,30.4073689,62393.7571385,95230.5661731,81.3792878,3131.8252698,2591.8288007,5038.9221354,43.4359619,57.4763765,2.2042796,193.1324391),(20186,'sheep_femur.tif',153,7,140,518.2584487,66.2513605,70.7895321,1.8,67.0146867,69.8398861,1.442438,24.8979413,30.4484295,66282.6741516,101868.9541307,84.9610815,3345.6226036,2662.1748927,5342.0047751,43.7741066,57.7877686,2.2115801,194.3326265),(20187,'sheep_femur.tif',153,7,141,533.0632716,66.3883278,71.2371983,1.8,67.1533937,70.2660747,1.4524446,25.4769722,30.5369512,69970.5134448,108305.8114159,87.6052298,3546.7133128,2746.4218604,5641.0616161,44.1778251,57.7877686,2.2115801,194.9195682),(20188,'sheep_femur.tif',153,7,142,540.2063706,66.6671231,71.5164962,1.8,67.2672751,70.5741582,1.4441931,25.536393,30.396097,72986.6910188,111444.4781592,88.5989827,3666.4074992,2858.1441,5858.3876916,45.0095857,57.7877686,2.2115801,194.4596339),(20189,'sheep_femur.tif',153,7,143,548.2129034,66.8927217,71.8384939,1.8,67.3270072,70.9890025,1.4403949,25.6047723,30.2225786,76062.0044335,113366.8071107,89.8239205,3751.0633534,2970.6182666,6055.6102976,45.24962,57.6406018,1.3137037,195.4167021),(20190,'sheep_femur.tif',153,7,144,554.6913548,67.0516498,72.086039,1.8,67.3399124,71.3041237,1.4381201,25.6453374,29.7982398,78845.3577783,112030.565859,90.8307167,3759.6370266,3074.4519597,6146.1658408,45.4463235,57.2710306,1.3025403,194.5866413),(20191,'sheep_femur.tif',153,7,145,551.6953655,66.7451597,72.3754853,1.8,66.9621058,71.6452047,1.4980564,25.3748642,28.7230074,79251.3051385,107596.6354739,91.4635728,3746.0086925,3123.2208636,6109.0657521,45.9708715,57.5335515,1.2274664,201.8512696),(20192,'sheep_femur.tif',153,7,146,548.7796213,66.9618427,72.6025058,1.8,67.2033564,71.8774433,1.5118561,26.3079802,28.5192513,80188.0045153,101822.9615161,91.1458992,3570.3237934,3048.0486825,6033.1269213,46.4062202,57.0241199,1.2533999,194.5866413),(20193,'sheep_femur.tif',153,7,147,536.8347488,67.0427305,72.6961788,1.8,67.2440468,72.0653024,1.5603785,26.3343479,28.1456066,77987.3152421,93851.0760617,89.4627478,3334.4840388,2961.4295189,5831.7654194,46.7913707,56.1989374,1.2387369,193.8200841),(20194,'sheep_femur.tif',153,7,148,510.6774681,67.0215849,72.6199676,1.8,67.3422718,72.1546188,-1.5027818,26.5083902,27.4436727,73230.8300987,84323.7192449,84.7197877,3072.6105855,2762.5528974,5516.1838184,46.7265722,54.5305841,1.19742,195.0202715),(20195,'sheep_femur.tif',153,7,149,485.5146991,66.965013,72.6604915,1.8,67.3253995,72.279721,-1.3241336,26.4051582,27.0174444,67939.5386034,75492.1281345,76.0948364,2794.1994394,2572.9646454,5209.5915312,45.5636448,53.5149761,1.2057292,197.7272693),(20196,'sheep_femur.tif',153,7,150,469.8412533,67.0052133,72.5681422,1.8,67.2798512,72.3757849,-1.0426253,25.9192291,26.0890466,62048.0387975,68009.8586217,58.4192745,2606.8357236,2393.8998587,4958.4597102,44.4300995,51.3776462,1.1732623,192.7732081),(20197,'sheep_femur.tif',153,7,151,452.7284815,66.9940726,72.461975,1.8,67.1390844,72.4986763,-0.7184314,24.5431669,25.4994813,54872.6674894,61537.6252467,32.6895075,2413.2892976,2235.7614947,4515.7860823,43.4211524,49.8676006,1.1776201,187.1950056),(20198,'sheep_femur.tif',153,7,152,423.9742989,66.9910742,72.4516353,1.8,66.9853883,72.5819033,-0.4503768,23.3317323,23.4543538,46153.197661,54828.9014605,13.3898337,2337.685448,1978.129913,4012.5654703,40.8609232,48.2585991,1.1459642,181.6431072),(20199,'sheep_femur.tif',153,7,153,385.2210729,67.0585466,72.5923106,1.8,66.8950483,72.7828778,-0.3379247,21.2988625,22.0797399,34830.2380128,48696.6830291,7.0567413,2205.4916969,1635.3097722,3438.2906144,37.9494639,45.8934546,1.0841936,173.4477147),(20200,'sheep_femur.tif',153,7,154,310.9008654,66.8684794,73.1890718,1.8,66.6646707,73.1956919,-0.2913165,19.5514334,21.1072958,22825.6088711,39264.1976001,4.2744504,1860.2192325,1167.4647301,2727.930044,34.641124,42.8212596,1.0387624,173.548418),(20201,'sheep_femur.tif',153,7,155,214.2920991,66.4259086,74.0937452,1.8,66.1604212,73.9555071,-0.2703958,17.6469476,19.2461926,12046.9645439,27697.8411173,2.5482647,1439.1335301,682.6656272,1876.2665654,14.656264,30.7327652,1.4855335,79.8447642),(20202,'sheep_femur.tif',153,7,156,110.4059592,66.6818552,75.434916,1.8,66.8488425,74.8593622,-0.2802249,15.6575279,17.9660874,3856.9579178,15210.3996815,1.4075281,846.6172581,246.3324949,995.7001168,11.6589866,14.6047644,2.2035452,42.9019944),(20203,'sheep_femur.tif',153,7,157,16.5682428,67.1643658,77.2633086,1.8,67.7621379,76.8236601,-0.2332783,13.7243085,16.0637104,137.2681847,2372.913341,0.1475644,147.7188821,10.0018288,150.6608749,7.5875945,9.3195486,2.4756234,27.4310781),(20204,'sheep_femur.tif',153,7,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20205,'sheep_femur.tif',153,7,159,73.1023131,44.3305738,85.1616883,1.8,41.484286,83.3722528,0.3673346,14.8796615,51.0718108,4029.484921,21069.7886501,1.5713795,412.5522146,270.8048778,483.8194733,31.2760732,126.681729,0.0123961,416.7584463),(20206,'sheep_femur.tif',153,7,160,73.6914896,44.2511272,85.0860511,1.8,41.419232,83.3410186,0.3692432,20.5711997,51.1557267,4053.3467248,21151.3811179,1.5997915,413.470446,197.0398798,484.988527,31.4588634,126.681729,0.0123961,419.43914),(20207,'sheep_femur.tif',153,7,161,79.062368,47.0131035,84.7676143,1.8,45.0892933,83.2228996,0.2085052,21.8164989,49.3264375,5392.501091,30457.4595057,0.5646115,617.4672452,247.1753661,726.789876,31.3597937,126.681729,0.0123961,422.246841),(20208,'sheep_femur.tif',153,7,162,83.8471417,49.7542596,84.3467995,1.8,46.6071268,83.1156317,0.1121031,19.1496746,46.4179861,6318.7325916,39817.1655388,0.1748848,857.796058,329.9655328,977.9175121,29.859293,126.681729,0.0123961,340.9369792),(20209,'sheep_femur.tif',153,7,163,86.3405926,51.6670029,83.96382,1.8,47.7268273,83.018179,0.0659984,18.2352859,44.2318993,6725.082008,45788.2081641,0.0625893,1035.1852133,368.7949865,1135.7561578,29.8878058,126.681729,0.0123961,339.8901032),(20210,'sheep_femur.tif',153,7,164,90.855219,53.6301183,83.7185782,1.8,49.0461017,82.9373497,0.038642,17.006896,42.0506093,7022.6240928,52727.4217584,0.0225996,1253.9038693,412.9280321,1345.8485349,30.621123,126.681729,0.0123961,414.2682637),(20211,'sheep_femur.tif',153,7,165,96.1785647,55.5121228,83.4525435,1.8,50.7562264,82.783604,0.0225814,16.6948534,40.0101935,7400.9595672,59860.5369448,0.0081725,1496.1321518,443.3078489,1581.1205503,31.0556474,126.681729,0.0123961,484.0670026),(20212,'sheep_femur.tif',153,7,166,99.0796962,56.9148912,83.4309722,1.8,51.2124337,82.6851012,0.013044,16.8852885,38.5019306,7552.2432347,63509.9694215,0.0028095,1649.5268774,447.267646,1719.7455471,31.0967901,126.681729,0.0123961,467.4113074),(20213,'sheep_femur.tif',153,7,167,102.905535,58.3179939,83.3738399,1.8,52.4984508,82.5574955,0.0032572,17.0711842,36.9862607,7645.4495788,67903.0342657,0.000182,1835.898873,447.8570144,1879.1251917,31.0465463,126.681729,0.0123961,440.9744972),(20214,'sheep_femur.tif',153,7,168,104.6127045,59.5875811,83.2906313,1.8,54.4151208,82.6344257,-0.0030684,16.6434984,35.7271499,7389.3495416,72909.8328549,0.0001641,2040.7402488,443.9781438,2052.9871505,30.8178465,126.681729,0.0123961,457.503185),(20215,'sheep_femur.tif',153,7,169,59.0703005,81.133728,85.3790581,1.8,81.1086609,85.3900057,-0.3509733,14.1426985,51.6597081,2402.6350115,22120.9496795,1.1637502,428.2050844,169.8851892,468.9742141,29.7952354,126.681729,0.0123961,354.6207664),(20216,'sheep_femur.tif',153,7,170,61.8294568,81.5927392,85.1749623,1.8,81.5921729,85.1610683,-0.3535716,14.2008374,52.1397552,2548.793129,22159.7907031,1.2354506,425.0075709,179.4818894,468.1253811,29.7131641,126.681729,0.0123961,361.4100518),(20217,'sheep_femur.tif',153,7,171,70.7915827,82.7583856,84.6041517,1.8,82.0497451,84.9021535,-0.3587533,14.3742119,53.3883718,2788.4835454,23054.4442334,1.4544866,431.8251978,193.9920992,478.2365952,29.7166515,126.681729,0.0123961,343.6811766),(20218,'sheep_femur.tif',153,7,172,75.4275108,83.3987151,84.3354006,1.8,82.257238,84.8553611,-0.3621519,14.4256668,53.9609595,3039.3953237,23574.1579629,1.577938,436.8743289,210.6935766,486.8336627,29.6727603,126.681729,0.0123961,341.7670401),(20219,'sheep_femur.tif',153,7,173,70.3148032,83.10581,84.3388125,1.8,82.1346826,84.8137586,-0.3671255,14.56337,53.6421362,3073.8006157,23786.6867014,1.5098178,443.4328757,211.063827,493.9498161,29.7046558,126.681729,0.0123961,340.7201641),(20220,'sheep_femur.tif',153,7,174,60.0876861,81.9086326,84.804187,1.8,81.4590554,85.2393821,-0.3644351,14.5352232,52.3815217,2738.6156025,23228.8290422,1.2722198,443.454644,188.4123529,488.9080576,29.7450305,126.681729,0.0123961,339.5462807),(20221,'sheep_femur.tif',153,7,175,46.9756276,79.1415876,86.227901,1.8,80.2324677,86.0281511,-0.3426444,13.9298099,49.4759765,2150.9545523,21318.0354816,0.8837827,430.8764977,154.4137762,468.1896377,29.5031075,126.681729,0.0123961,340.4661494),(20222,'sheep_femur.tif',153,7,176,34.9461927,74.5354136,88.6764295,1.8,77.6350732,87.4662703,-0.3011136,14.5528035,44.642553,1585.9798401,17599.8404873,0.5123228,394.2391128,108.9810526,424.6293498,29.2473077,126.681729,0.0123961,338.9856431),(20223,'humerus',243,2,1,0.0026734,92.99788,83.802584,1.8,92.99788,83.802584,0.7853982,0.00000000000001005,0.00000000000001005,0.0000097,0.0000097,0.0002228,968284837.657453,968284838.277031,1369361550.09351,0.208984,0.295548,2.3561945,0.591096),(20224,'humerus',243,2,2,0.0026469,92.99788,84.011568,1.8,92.99788,84.011568,0.7853982,0,0,0.0000096,0.0000096,0.0002206,0,0,0,0.208984,0.295548,2.3561945,0.591096),(20225,'humerus',243,2,3,0.0188858,46.9020433,89.5346329,1.8,46.9019806,89.5347166,-0.0969417,0.0370532,1.3487899,0.0000776,0.0193048,0.0000295,0.0143127,0.0020933,0.0143697,0.208984,0.8616631,2.896614,1.72258),(20226,'humerus',243,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20227,'humerus',243,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20228,'humerus',243,2,6,0.027581,24.8961717,87.4160818,1.8,24.9108928,87.4180072,0.1454816,0.1167951,0.8627047,0.0002158,0.0078556,0.0000966,0.0091058,0.0018479,0.0093296,0.417968,1.9267373,2.9229237,3.985548),(20229,'humerus',243,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20230,'humerus',243,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20231,'humerus',243,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20232,'humerus',243,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20233,'humerus',243,2,11,1.8914021,48.6537895,75.0662564,1.8,49.0604867,75.2737977,0.5114157,1.4293364,3.8061719,0.4924871,5.7908577,0.0755062,1.5214388,0.3445565,1.5981929,2.6755064,7.1085286,2.7173982,17.3779243),(20234,'humerus',243,2,12,24.5978491,50.2170667,75.4096628,1.8,50.1508126,75.1619772,0.3361935,4.1007438,5.9505972,57.9582103,172.4062835,0.44617,28.9729379,14.1335849,37.9994712,7.7587009,11.9267445,2.9476335,32.1676285),(20235,'humerus',243,2,13,43.8231887,51.1419264,75.1859313,1.8,50.7987262,75.0116141,0.1131643,6.7142532,9.1913454,247.5515058,541.4873259,0.0931359,58.9127382,36.8695515,75.6933971,10.4492,15.2544005,0.1651487,43.5838846),(20236,'humerus',243,2,14,60.6289053,52.0883494,75.0438645,1.8,51.26513,74.9186021,0.0266296,13.0819165,28.7619813,530.3393631,1095.4576006,0.007164,38.0870007,40.5398828,51.4536998,12.34907,18.6289046,0.0561208,50.5249127),(20237,'humerus',243,2,15,79.2071636,52.9480143,74.9831251,1.8,52.1818813,74.8929037,0.0541141,13.8171396,16.1607466,947.118448,2051.0408709,0.0386197,126.9149825,68.5466365,141.0085938,14.1927046,23.3651215,0.1798535,63.9085888),(20238,'humerus',243,2,16,109.3631116,55.1927068,74.3839354,1.8,54.1031503,74.2730883,-0.1086108,10.4803885,29.5414307,1649.2917678,5039.1589019,0.2141693,170.579379,157.3693352,213.4304791,15.882784,29.611639,0.3909909,82.316581),(20239,'humerus',243,2,17,132.4547792,56.4400076,73.5809476,1.8,55.2297909,73.6407038,-0.2114434,9.5972931,15.6237329,2573.980607,7240.4127293,0.9723501,463.4239958,268.1986023,607.1543229,17.5464864,31.6167307,0.4222512,89.0337731),(20240,'humerus',243,2,18,147.9648907,56.8874855,73.0453709,1.8,55.9216015,73.161854,-0.2764401,9.8720348,16.5167916,3479.836974,8687.0947038,1.8370388,525.9553368,352.4943977,722.3722257,18.997386,33.3988863,0.4188597,88.9323571),(20241,'humerus',243,2,19,157.0123553,57.1620096,72.7394807,1.8,56.5976497,72.8802192,-0.3295345,10.7359472,17.8317606,4362.2215743,10102.1426347,2.7403537,566.5252497,406.3192078,801.680187,20.2955195,34.8709077,0.4395236,90.891077),(20242,'humerus',243,2,20,162.1080623,58.0537434,72.2556924,1.8,57.7837135,72.3160155,-0.4481108,23.5552773,24.7695628,4905.2413179,11597.5514016,5.0717507,468.2178484,208.2438368,640.8157804,21.079961,35.7338197,0.5474404,94.386945),(20243,'humerus',243,2,21,170.5362782,60.2779164,70.980938,1.8,59.8610869,71.1981701,-0.6065798,24.0010907,25.9676991,4980.5649682,16714.449284,9.2365072,643.6630846,207.5141094,806.1535388,21.5706245,44.9271857,0.7985553,117.8192534),(20244,'humerus',243,2,22,174.5434228,62.1631798,69.782358,1.8,62.2301824,69.7810613,-0.7308621,23.6449866,29.2829702,4868.0273729,21801.1865823,12.9619429,744.5005209,205.8798952,899.1802374,21.5454367,47.6575171,0.8412407,124.2408975),(20245,'humerus',243,2,23,184.3758869,64.3350016,68.1145022,1.8,64.3068288,68.1881345,-0.7920405,34.8493343,37.4585885,5163.3593306,29258.6984313,15.5687664,781.094526,148.1623519,811.1282757,21.7626367,51.5915428,0.865685,133.4956016),(20246,'humerus',243,2,24,206.6186583,62.4297135,66.7518578,1.8,63.1559801,66.713052,-0.3806243,24.2780306,37.94502,16924.8338719,47598.7800752,4.7526548,1254.4144145,697.1254844,1560.1946931,4.5803036,13.8324677,1.1003921,31.6989524),(20247,'humerus',243,2,25,235.7171453,60.4223901,65.3315173,1.8,61.5412454,65.2855789,-0.2002915,26.5784622,39.2934672,23827.9623789,73069.5194384,1.5550696,1859.5844218,896.5139603,2403.2503358,9.2944556,18.7853252,1.0074801,52.0533607),(20248,'humerus',243,2,26,287.1011647,56.280701,63.2968582,1.8,57.2856323,63.519463,-0.0244517,23.9647832,36.2176796,33698.0159794,115508.4018075,0.0286031,3189.2822271,1406.1473337,3960.189432,15.1590173,27.5304198,1.3018812,82.1731571),(20249,'humerus',243,2,27,330.3881123,54.3647331,62.2637631,1.8,55.6539203,62.6531766,0.0011739,24.2644427,35.982687,39730.755077,145672.9592116,0.0000757,4048.4180359,1637.4064549,4679.489027,0.208984,0.295548,2.3561945,0.591096),(20250,'humerus',243,2,28,375.0203346,53.8032037,61.6531589,1.8,54.6315806,62.030145,-0.0171993,28.3258802,36.138905,45142.9650995,169649.4400424,0.0184877,4694.3713475,1593.7003451,5280.8900294,21.5944109,31.5814862,1.3097677,92.5209411),(20251,'humerus',243,2,29,426.227579,53.4970423,61.2089311,1.8,53.9633672,61.4638558,-0.0281155,27.7048695,36.3851699,51465.119591,194433.9434934,0.0561399,5343.7690107,1857.6199947,5942.9027795,25.2582214,32.4901235,1.3304978,102.6412853),(20252,'humerus',243,2,30,502.2337861,52.6290989,60.7121974,1.8,53.0626043,60.989455,-0.0298236,28.2069712,37.5726139,59073.3598729,220857.579187,0.074429,5878.1531548,2094.2822734,6609.3817061,46.3955885,77.3028963,0.4805746,303.7195682),(20253,'humerus',243,2,31,626.2957389,51.8200019,58.298977,1.8,51.8008997,57.9146279,0.0223443,31.1720879,38.1902397,89568.4583374,252703.0497563,0.052106,6616.9537562,2873.35448,7510.598291,51.0570113,77.8063458,0.4984893,402.4731177),(20254,'humerus',243,2,32,817.5376512,51.352699,54.7468237,1.8,51.6901852,55.4831597,0.0761045,35.4215913,38.7422495,139583.187496,287864.3374022,0.7876576,7430.243245,3940.6244099,10261.7483509,53.098498,78.2733663,0.4982813,312.1383363),(20255,'humerus',243,2,33,891.8143688,51.505058,53.0187258,1.8,51.4706914,54.0375061,0.1113905,37.3263074,38.214736,174028.8647367,313334.9222464,1.8366329,8199.3219021,4662.3648788,11689.9372163,54.5348549,78.2733663,0.4982813,298.817672),(20256,'humerus',243,2,34,922.7980111,51.4885373,51.8568087,1.8,51.2724327,53.0537233,0.1662671,39.4851295,40.5569054,202030.4556469,332040.8705425,4.2127191,8187.0366459,5116.6213226,11058.3951319,55.8124692,78.0070398,0.5031953,292.5814598),(20257,'humerus',243,2,35,940.0190836,51.5311599,50.9632728,1.8,51.1692051,52.162999,0.2120688,41.4653165,37.0081513,225275.1048169,347265.862702,6.9409448,9383.4966252,5432.8562773,12698.6878623,58.0504607,77.4011398,0.5168018,302.946644),(20258,'humerus',243,2,36,948.9284713,51.4438357,50.1344582,1.8,51.0247056,51.3851234,0.2809121,43.6387887,35.8574793,245414.8206538,359461.3987241,12.1554051,10024.7258271,5623.7771069,13328.5548031,60.1333635,76.9370559,0.1830119,267.9372554),(20259,'humerus',243,2,37,953.978135,51.312528,49.3919543,1.8,50.912016,50.701539,0.3702106,44.9936901,35.5271728,262275.6522091,366521.7725818,20.8138572,10316.6602814,5829.1651883,13783.0294738,62.0187018,76.6564023,0.1781466,285.2224637),(20260,'humerus',243,2,38,961.6658727,51.2463153,48.7523685,1.8,50.8806261,50.1252143,0.4570568,36.7507577,48.0550242,276408.2326506,373550.2549371,31.2146484,7773.3860525,7521.1573744,12841.2892311,63.4412622,76.3215176,2.2806106,258.5811352),(20261,'humerus',243,2,39,965.4865809,51.3157711,48.0704463,1.8,50.9017232,49.5994597,0.5648812,38.3345902,49.9044612,283966.6761728,381628.3114758,46.1120702,7647.1782676,7407.5834617,13001.4101457,0.208984,0.4673024,2.0344439,1.009064),(20262,'humerus',243,2,40,973.5475487,51.1669931,47.4412019,1.8,50.8855759,49.0502017,0.6722561,49.8758647,48.4658558,286802.5854296,393819.3506446,62.9270361,8125.7071459,5750.3280874,13636.1533476,65.5987374,78.1678385,2.2956625,275.5200875),(20263,'humerus',243,2,41,986.9296624,51.1679905,46.8417294,1.8,50.98068,48.5524967,0.77283,53.5843523,49.4274608,284417.3097718,410540.36164,80.1770403,8305.9164961,5307.8426393,12964.9282812,66.6010479,79.1323925,2.2814278,257.5930751),(20264,'humerus',243,2,42,996.4834315,51.0735496,46.2429256,1.8,51.0008269,48.038192,0.8380677,44.3224976,55.2331849,279860.0918814,425121.5031988,91.7714979,7696.8493495,6314.1769377,12692.6323029,67.3415938,79.7443074,2.2782856,253.527115),(20265,'humerus',243,2,43,1000.8435704,51.0243637,45.6576444,1.8,51.0193401,47.5932294,0.8910468,48.9529511,57.1085878,273145.8017132,436074.8448972,100.895749,7635.8891356,5579.7617066,12182.4238777,67.0278708,80.1393013,2.2638652,254.118211),(20266,'humerus',243,2,44,1004.7359442,51.0245844,45.1615006,1.8,51.0808569,47.0836549,0.9265633,35.6768811,56.3978099,264347.0392621,443570.9674278,107.0541421,7865.0388759,7409.4772571,12301.7179356,65.7123237,80.4335951,2.2642039,248.6252188),(20267,'humerus',243,2,45,1004.735706,50.9636347,44.5119026,1.8,51.1242756,46.4813916,0.9499742,49.1825494,51.1296092,250150.9713924,448397.35508,110.792272,8769.8177577,5086.1733368,13434.0280259,64.3291793,80.5198836,2.2532388,246.1384148),(20268,'humerus',243,2,46,1003.439598,50.759703,43.8760952,1.8,51.0920283,46.0019953,0.9839638,48.1875517,56.2879655,237415.151033,447670.7268235,115.9620378,7953.2227396,4926.8979825,11879.790947,62.121261,80.5437458,2.2200057,247.7472749),(20269,'humerus',243,2,47,1001.4949264,50.5141669,43.3783897,1.8,51.0469355,45.605071,1.0282257,46.5298103,55.6887712,224380.9007875,445762.786081,122.4150386,8004.5362177,4822.3042277,11725.1833858,59.4444114,80.5117471,2.1976842,257.022983),(20270,'humerus',243,2,48,1006.8783148,50.319783,43.1301078,1.8,51.0196476,45.3741129,1.0622666,49.5205541,55.1831632,215511.2706745,447529.3215701,128.0303899,8109.8888849,4351.9559663,11680.0775391,0.208984,0.295548,2.3561945,0.591096),(20271,'humerus',243,2,49,1010.2672562,50.5128996,42.8411496,1.8,51.2963042,45.1078318,1.0872523,35.0435004,45.5156821,206550.5406728,449366.7999339,131.9829224,9872.7906372,5894.1183988,14215.9400633,55.6008517,80.3684104,2.1299469,244.6606748),(20272,'humerus',243,2,50,1014.3248115,50.7704243,42.7409803,1.8,51.5009594,44.9932733,1.1057951,33.6915965,45.5158427,201855.6504375,451021.8863479,135.0600486,9909.1186699,5991.2759006,14338.0223914,53.5159064,80.0678771,2.1139016,233.7130947),(20273,'humerus',243,2,51,1011.2289116,51.009007,42.6219107,1.8,51.7081849,44.823793,1.1200525,40.8322025,44.7384858,196542.5125397,451426.8461808,136.553314,10090.346998,4813.4193269,12555.7205954,52.6288216,79.7881097,2.0977396,228.7604905),(20274,'humerus',243,2,52,1004.9390165,51.258716,42.5725786,1.8,51.8887802,44.6931895,1.1312718,41.3900798,53.7077238,190791.793649,447019.8979489,137.1644384,8323.1957376,4609.601973,11775.6223069,0.417968,0.7535025,0.9827937,1.60016),(20275,'humerus',243,2,53,995.6107261,51.5502003,42.3860678,1.8,52.1281307,44.565586,1.1442188,35.3733394,52.9699894,183367.3990688,437057.0927119,137.5278238,8251.0322886,5183.7740588,11689.8352094,0.626952,1.5214265,1.2924967,3.6182881),(20276,'humerus',243,2,54,998.6377397,51.7667869,42.1923945,1.8,52.3972954,44.5253563,1.1581402,41.1491942,52.1349208,178644.8599472,423471.1668757,139.6700995,8122.6011385,4341.3938858,11461.8601935,49.6088754,78.5638096,1.9725446,232.3664747),(20277,'humerus',243,2,55,953.8094198,52.3109704,42.6285211,1.8,52.8245747,44.6943099,1.1750886,40.3913887,53.5119256,157373.595705,405924.9182933,135.348663,7585.6907326,3896.2165182,9944.8451533,48.4570868,78.0898575,1.9985312,254.0638993),(20278,'humerus',243,2,56,901.1827205,52.9371584,43.3503224,1.8,53.2162164,45.3528974,1.1858872,43.1967126,42.7356477,137774.6267351,386034.2481516,129.0221141,9033.0735388,3189.4701821,9937.6775161,47.7205879,77.4386539,1.9728533,298.8857803),(20279,'humerus',243,2,57,856.7638936,53.2971144,44.1454794,1.8,53.4307585,45.7943776,1.1791061,36.0058889,41.8747657,123924.3401657,364763.7006253,121.9840449,8710.823684,3441.7797741,11668.1704168,47.3016846,76.6982669,1.971037,300.0172643),(20280,'humerus',243,2,58,810.8352854,53.5313427,44.9102494,1.8,53.5858041,46.1544571,1.1657976,44.7414035,40.7845174,111610.2827545,343850.120437,114.1588688,8430.8983473,2494.5637401,8774.3700817,46.3350063,75.8321129,1.9431146,324.0493688),(20281,'humerus',243,2,59,771.3030581,53.8395757,45.7470599,1.8,53.8370061,46.7593717,1.1525286,44.9435551,39.6029194,101655.3835072,322867.3975923,107.3421574,8152.6160823,2261.8456265,8282.4841539,45.6235896,74.9719724,1.9207581,334.0262891),(20282,'humerus',243,2,60,735.3176747,54.17207,46.8119602,1.8,54.0617093,47.4902988,1.1272024,24.1283756,38.409906,93737.4479496,301518.5171593,99.9783742,7850.0196617,3884.9464849,10289.6474611,45.2093986,73.9419533,1.9318826,323.9182487),(20283,'humerus',243,2,61,695.1221935,54.5134254,48.1337169,1.8,54.3901691,48.5778195,1.1043878,30.8234859,36.866802,86052.0192084,274576.6721696,92.4265444,7447.8028323,2791.7679227,9756.4701327,44.6601311,72.8332477,1.8798434,339.113617),(20284,'humerus',243,2,62,624.9275948,55.3133933,50.6936691,1.8,55.1885553,50.7076437,1.0666651,50.7959325,37.5961488,77109.9893347,223856.9490677,79.8517566,5954.2521312,1518.0347221,5761.7806325,0.6458083,1.7977483,0.9505468,3.9138361),(20285,'humerus',243,2,63,562.9434888,55.9339077,53.3203577,1.8,56.0924645,53.5184285,0.9889608,51.5955208,38.0036523,67993.6653447,177143.7025131,65.4877424,4661.2283807,1317.8210875,4730.7277308,0.8249426,1.6322172,2.4468544,3.6182881),(20286,'humerus',243,2,64,510.6031475,56.2556485,55.8663633,1.8,56.6523412,56.1407625,0.8401126,49.638269,44.5474353,55063.6320695,135355.8565809,47.1972069,3038.4657507,1109.2979898,3822.7121093,0.417968,1.3217309,1.8925469,2.854064),(20287,'humerus',243,2,65,479.5570641,56.3522386,56.9698168,1.8,56.9432716,57.5841028,0.7824658,46.9815504,31.5432985,47166.3605653,118678.6446974,39.7287185,3762.404385,1003.9336761,3502.1388433,35.1783926,53.0115423,2.0997221,245.0852319),(20288,'humerus',243,2,66,462.5819839,56.4551252,57.5440617,1.8,57.0705794,58.0886205,0.7666807,30.1058126,29.1144163,43680.0461894,112383.5243172,37.1057782,3860.0644792,1450.8841434,4637.9466924,34.3693833,51.843198,2.1901086,238.722996),(20289,'humerus',243,2,67,449.2802177,56.4972099,58.0141533,1.8,57.1703096,58.5715789,0.7561762,30.5225111,43.8173778,40889.5176492,107041.1095636,35.2531192,2442.8917246,1339.651167,3336.8197031,33.3820016,50.993809,2.222494,207.8005714),(20290,'humerus',243,2,68,439.0224982,56.6512616,58.5365434,1.8,57.4612249,59.1520342,0.7454495,43.0878964,42.9471501,38604.9845726,103549.0310311,33.6652555,2411.0803832,895.9589077,3267.243039,0.417968,2.131227,1.7681919,4.699064),(20291,'humerus',243,2,69,429.459756,56.7808117,59.0151467,1.8,57.6204192,59.649433,0.7382335,18.8205193,41.9240034,36812.5260201,99752.720828,32.4174331,2379.3701135,1955.9782249,3237.7392825,0.417968,1.5214265,1.849096,3.272032),(20292,'humerus',243,2,70,423.3380071,56.889668,59.4163244,1.8,57.8275196,60.0822729,0.7279294,30.2351191,41.1363045,35521.7834433,96694.6230767,31.2323024,2350.5909007,1174.8517792,3201.0748339,0.417968,1.3217309,1.8925469,2.854064),(20293,'humerus',243,2,71,418.911642,56.9834212,59.7891695,1.8,57.9569741,60.5593998,0.7202153,18.1375501,40.3376028,34601.0246982,93830.3141575,30.3712052,2326.1251946,1907.70112,3177.2513751,0.7099895,2.6434617,1.8925469,6.0543841),(20294,'humerus',243,2,72,414.3187455,57.0210911,60.1062955,1.8,58.058146,60.8812784,0.7175217,20.1886689,39.5350006,33659.2471819,90731.1367317,29.8538662,2294.95726,1667.2345966,3145.6391838,0.652846,2.2508266,1.9513027,5.0453201),(20295,'humerus',243,2,73,407.1920109,57.156472,60.3955537,1.8,58.2474328,61.2490776,0.71272,34.9211909,32.7585923,32558.8162474,87325.8768119,29.0176884,2665.7395987,932.3512587,3424.7792096,0.6873383,2.0582537,1.9890207,5.0453201),(20296,'humerus',243,2,74,400.643286,57.139616,60.6044804,1.8,58.2843229,61.4901781,0.7096266,33.1474499,30.343068,31686.8087233,84114.6180588,28.3467213,2772.1197521,955.9350359,3463.3127568,29.4070267,47.7696466,2.3964205,134.978438),(20297,'humerus',243,2,75,397.677509,57.2577982,60.8566218,1.8,58.4941879,61.7730835,0.7057027,17.5826192,25.8295762,30936.4395076,82629.890681,27.8799513,3199.0416685,1759.4898192,4331.7212969,0.626952,1.04492,2.4980915,3.2003201),(20298,'humerus',243,2,76,395.5582329,57.2667697,61.0278727,1.8,58.5824079,61.9797837,0.7014845,17.6648399,32.7165589,30487.4908275,81247.1938757,27.4569926,2483.3661208,1725.8854851,3325.6212984,29.2414897,47.5368551,2.421522,134.235218),(20299,'humerus',243,2,77,390.8476142,57.2600862,61.1934241,1.8,58.5181181,62.1451933,0.7003569,28.9080691,27.9815414,30061.4739256,78873.380593,27.0576076,2818.7646826,1039.8990611,3526.3062748,0.208984,0.295548,2.3561945,0.591096),(20300,'humerus',243,2,78,388.8657004,57.2501706,61.3426636,1.8,58.5552098,62.3351757,0.7000322,28.9248503,27.4092211,29695.3998842,77160.6185679,26.8996674,2815.1335724,1026.6397091,3503.2684322,0.5345713,1.7233262,1.815775,4.0362561),(20301,'humerus',243,2,79,386.5004187,57.2152729,61.4790352,1.8,58.5016489,62.4375143,0.6963546,17.3490445,26.9784618,29309.7655954,75965.3364365,26.5027455,2815.7771569,1689.4167065,3483.2152283,0.5502051,1.5214265,1.849096,3.6182881),(20302,'humerus',243,2,80,384.3261924,57.2566978,61.596996,1.8,58.5202387,62.525239,0.6965263,19.0008493,42.0616382,28884.2472008,75188.0015425,26.3644773,1787.5671239,1520.1555866,2440.2589699,0.7105346,2.2508266,1.9513027,5.8095441),(20303,'humerus',243,2,81,380.6271369,57.4333728,61.85642,1.8,58.5057687,62.6102471,0.6965041,18.0987341,39.7574109,28272.2293977,74063.7418447,26.10934,1862.8914738,1562.1108756,2556.6522003,0.5441067,1.5070051,2.1587989,3.2003201),(20304,'humerus',243,2,82,378.9008766,57.5097312,62.1330233,1.8,58.4616674,62.8109747,0.6996745,26.2023421,25.126757,27847.8330563,73628.3802111,26.1880924,2930.2778776,1062.7993854,3521.6759765,0.5610809,1.1254133,1.9513027,2.609224),(20305,'humerus',243,2,83,378.0358209,57.5074367,62.3711258,1.8,58.3442806,63.0032667,0.7052368,31.2875958,34.0780337,27573.9607174,72830.7842183,26.4739462,2137.1768346,881.3064739,2919.5601793,0.5755571,1.9267373,1.7894653,4.4542241),(20306,'humerus',243,2,84,375.247494,57.3838837,62.4676871,1.8,58.196912,63.0476338,0.7134546,26.757285,25.4636445,27344.6256473,71496.7465571,26.7866921,2807.7970777,1021.9506815,3421.7165733,28.8159307,46.7199612,2.3245595,131.6172938),(20307,'humerus',243,2,85,374.6342669,57.2023325,62.5386878,1.8,57.9889396,63.1274091,0.7233606,25.4326354,25.7077598,27138.1368725,70117.4885786,27.355885,2727.483416,1067.0595665,3407.6067647,0.417968,0.9346049,2.0344439,2.018128),(20308,'humerus',243,2,86,374.7460864,56.965429,62.5639274,1.8,57.7121109,63.1903616,0.7349939,24.477825,26.6324023,27038.2051643,68609.0222628,28.0860388,2576.1484656,1104.5999858,3279.863078,0.417968,1.1254133,1.9513027,2.436096),(20309,'humerus',243,2,87,373.2878937,56.6338968,62.5203532,1.8,57.2390235,63.0291843,0.7439261,32.7575043,26.7033591,27023.0075943,66831.9699808,28.5301092,2502.755172,824.9409764,2858.0186123,28.6681567,45.4207385,2.3073734,127.7331618),(20310,'humerus',243,2,88,370.3053088,56.2123418,62.3611482,1.8,56.8166712,62.8831853,0.7562743,21.7217438,27.5747147,26970.284177,64298.3139165,29.062338,2331.7852827,1241.6261041,3077.3572945,28.8159307,44.7952707,2.3265003,155.9659503),(20311,'humerus',243,2,89,365.6458949,55.8329709,62.1281247,1.8,56.2601313,62.5964749,0.7683131,25.4508997,28.2909368,26697.1090432,61195.6502402,29.4295124,2163.0832084,1048.9652369,2927.264126,28.8159307,44.1564944,2.2825027,124.3597137),(20312,'humerus',243,2,90,363.9228507,55.5235756,62.0583189,1.8,55.8237271,62.3293281,0.7748594,33.6607479,32.6684184,26677.1381175,59272.9844838,29.6877327,1814.3818206,792.5295727,2553.0363294,29.0153509,43.4309783,2.2778568,121.8432056),(20313,'humerus',243,2,91,362.1649331,55.1529453,61.9311548,1.8,55.3289131,62.1359628,0.7785798,24.8456869,31.5475333,26801.211802,57289.6501039,29.7688637,1815.9787487,1078.7068171,2622.085177,29.149281,42.854461,2.2386828,120.8341416),(20314,'humerus',243,2,92,362.8336663,54.7546861,61.8578422,1.8,54.9139955,62.1216991,0.7807505,25.0307957,32.488329,27188.6024463,55825.0080386,29.9550888,1718.3096155,1086.2060789,2526.8193474,29.2592527,42.2716313,2.1875976,119.2846896),(20315,'humerus',243,2,93,361.6907889,54.2978236,61.6864491,1.8,54.5045454,61.9801702,0.7751064,34.2293123,34.2592661,27624.4148848,53859.6648532,29.5205394,1572.1196353,807.0397277,2371.2919259,0.208984,0.295548,2.3561945,0.591096),(20316,'humerus',243,2,94,362.1469737,53.9638748,61.5834395,1.8,54.1616155,61.8368312,0.774557,33.6370929,33.97426,27950.0957675,52233.7065273,29.5246175,1537.4494267,830.9307775,2352.0872599,29.3053198,41.1316403,2.2010868,123.1268137),(20317,'humerus',243,2,95,364.6636993,53.6798651,61.5138525,1.8,53.7771324,61.7205256,0.7769322,35.9659648,26.7611466,28252.8849415,51039.9998647,29.8741291,1907.242637,785.5450313,2199.7552451,29.316021,40.7604528,2.1332,121.4252376),(20318,'humerus',243,2,96,367.7891125,53.402911,61.4249049,1.8,53.4572674,61.6621988,0.7754718,33.9389519,25.9497972,28581.6593974,50097.1143207,30.0406639,1930.5397236,842.1491475,2317.8448063,29.4026171,40.2954536,2.1343434,121.7207856),(20319,'humerus',243,2,97,371.1065471,53.2229934,61.2906858,1.8,53.3064614,61.492679,0.777232,45.1684581,24.856165,28632.3495695,49220.6907353,30.4204847,1980.2206329,633.9014171,1651.2868094,29.5068264,39.308996,2.1823934,115.9619495),(20320,'humerus',243,2,98,372.0974379,53.0178132,61.186647,1.8,53.1173115,61.3686406,0.783988,33.3872836,36.8739655,28681.7463842,48267.4839374,30.9206672,1308.9854388,859.0619929,2086.6918594,29.5960357,39.0705076,2.1736346,115.1977255),(20321,'humerus',243,2,99,373.7119051,52.8459219,61.1025766,1.8,52.9363325,61.3122462,0.8011015,44.278452,21.5945766,28767.24654,47293.7894119,32.1205869,2190.0771745,649.6895277,1672.0620284,29.5422356,38.72694,2.1797539,114.4335015),(20322,'humerus',243,2,100,375.3819844,52.7174041,61.007753,1.8,52.7940392,61.1944199,0.8223057,36.6395825,22.9444127,28788.5743541,46324.6502477,33.5888084,2018.9948114,785.7233196,2047.643827,29.4912898,38.4893839,2.1708465,114.1379535),(20323,'humerus',243,2,101,376.9489128,52.6033019,60.8765416,1.8,52.6796691,61.0338454,0.8478264,30.8300878,21.0010881,28879.6079329,45235.4959253,35.3242699,2153.9596337,936.7345356,2334.9461848,29.5507073,38.2126544,2.1299754,113.4751455),(20324,'humerus',243,2,102,381.1372926,52.4918341,60.777768,1.8,52.5442976,60.8262879,0.8750479,19.9912885,21.0347485,28910.334929,44602.7639611,37.4257839,2120.4324865,1446.1466554,2706.9078185,29.6062039,37.9246945,2.1282274,112.2422454),(20325,'humerus',243,2,103,380.6959306,52.2996121,60.6633749,1.8,52.3593246,60.6730789,0.8989185,18.3264382,21.0713767,28553.761631,43809.5511174,38.8657257,2079.1024623,1558.0638938,3433.9141767,29.6545226,37.7052544,2.1188202,112.1198255),(20326,'humerus',243,2,104,378.2617759,52.2907183,60.6168257,1.8,52.3430997,60.6990245,0.9422177,17.89405,22.4467054,28165.0456757,43054.7325191,41.2469947,1918.0869426,1573.9894324,2557.2581828,0.208984,0.4673024,2.0344439,1.009064),(20327,'humerus',243,2,105,372.6024188,52.2946237,60.4560457,1.8,52.3868225,60.6278855,0.9880282,20.1025624,22.7855039,27112.0674226,41797.4210627,43.2919873,1834.3865171,1348.6871396,2474.0623169,0.208984,0.6608654,1.8925469,1.427032),(20328,'humerus',243,2,106,367.5672603,52.221482,60.3765731,1.8,52.2782213,60.5058724,1.0206265,17.9751473,30.5330243,26394.8607992,40735.4025376,44.5152559,1334.1424083,1468.4085991,2198.5738554,0.208984,0.4673024,2.0344439,1.009064),(20329,'humerus',243,2,107,366.0334581,52.1381742,60.3254699,1.8,52.2593103,60.5013656,1.0472168,16.6377362,30.5753901,25908.625015,40064.0088187,45.7551977,1310.3351654,1557.2205667,2157.3276872,0.208984,1.2712,1.735945,2.680936),(20330,'humerus',243,2,108,364.0442255,52.0310241,60.2186324,1.8,52.1506251,60.3671927,1.0671359,18.5972322,30.923657,25432.1791449,39405.3729077,46.5408553,1274.2792013,1367.5249585,2092.08271,1.1634193,7.5956413,1.4327903,18.1334482),(20331,'humerus',243,2,109,361.72819,51.9144233,60.1449505,1.8,52.0223466,60.1265352,1.0787173,18.5717702,30.4121089,24882.7729993,38945.4481606,46.8306726,1280.5901859,1339.8169752,2097.8401327,29.25776,36.4765393,2.0728865,105.8836132),(20332,'humerus',243,2,110,358.9109189,51.7711899,60.032361,1.8,51.9750998,60.0246233,1.0851542,17.6028922,31.1676284,24487.9190571,38304.6702999,46.785225,1228.9889287,1391.1304296,2006.8498982,0.417968,1.0656135,1.7681919,2.436096),(20333,'humerus',243,2,111,357.2977751,51.6316606,59.9257474,1.8,51.8124272,59.8357484,1.095795,26.0579843,39.780197,24163.5238084,37938.5800945,47.0942588,953.7051838,927.2982709,1305.8992914,28.839792,36.2001069,1.9931238,105.6387732),(20334,'humerus',243,2,112,355.8179041,51.4687014,59.7909246,1.8,51.6465685,59.6623912,1.1085524,17.4271143,18.9269348,23962.1911225,37467.3072391,47.5089097,1979.5760688,1374.994775,3111.8888592,0.835936,2.9554801,1.7126934,7.6545441),(20335,'humerus',243,2,113,355.9332573,51.3155962,59.5924215,1.8,51.5090683,59.4880348,1.131354,21.7348428,18.8645029,23611.2157833,36911.67349,48.5851984,1956.6735287,1086.3301861,2775.5666603,0.208984,0.4673024,2.0344439,1.009064),(20336,'humerus',243,2,114,358.5120666,51.1590814,59.3975321,1.8,51.3912365,59.2628456,1.1498721,15.9764183,18.9106347,23575.3037109,36784.4039443,49.7759734,1945.1702413,1475.6313482,3141.8980686,2.0504863,13.9205935,1.4352686,42.3632884),(20337,'humerus',243,2,115,359.1168764,50.9975734,59.1322869,1.8,51.2551742,58.9852096,1.1668633,16.1221758,19.027014,23483.842407,36473.5571967,50.6068255,1916.9354276,1456.6174334,3098.6845236,0.3745845,1.2185757,2.1112158,2.609224),(20338,'humerus',243,2,116,361.9496585,50.8479005,58.9024109,1.8,51.1327505,58.7841307,1.1897758,27.5571587,19.1747682,23481.13885,36560.5131671,51.9828595,1906.6990898,852.0885293,1788.8575183,1.4435701,11.9285753,1.5182133,27.9198402),(20339,'humerus',243,2,117,363.0484645,50.7194567,58.6337258,1.8,50.9821167,58.5964713,1.2124039,28.9009623,19.725639,23342.4605989,36651.7703902,53.0632204,1858.0777231,807.6707047,1733.5729035,0.9958824,6.4919728,1.6352232,15.1062561),(20340,'humerus',243,2,118,365.5476674,50.5453693,58.3244324,1.8,50.8287014,58.2717677,1.2367951,16.448795,20.0505581,23322.8342753,36641.9724347,54.3770616,1827.4789331,1417.9053375,2963.4534731,0.5610809,1.4019073,2.0344439,3.027192),(20341,'humerus',243,2,119,368.1579355,50.3775697,58.011459,1.8,50.6845688,57.9299411,1.2573411,18.6146912,26.7077835,23341.8810307,36637.2447648,55.525699,1371.7815519,1253.9494098,1942.9635688,1.3552483,9.5173801,1.7251151,23.6684482),(20342,'humerus',243,2,120,371.9667458,50.2129221,57.761929,1.8,50.5080107,57.7509399,1.279093,32.0228576,28.646179,23367.3934185,36786.3221897,56.8672314,1284.161569,729.7098128,1593.8327461,0.9522689,5.2910523,1.7294516,12.5984481),(20343,'humerus',243,2,121,373.8590346,50.1142628,57.3899547,1.8,50.3968862,57.3868456,1.302196,32.3069883,34.0451,23151.7854776,36567.8107464,57.9214979,1074.0990861,716.6185004,1557.0853178,0.76927,6.0316417,1.815775,13.0881281),(20344,'humerus',243,2,122,376.0028081,49.992144,57.12321,1.8,50.3060331,57.1059544,1.3233091,32.7722471,33.0176902,23053.5267025,36531.1897737,58.9065069,1106.4126408,703.4466282,1527.0610775,0.7838539,4.7655684,1.8370484,10.2340641),(20345,'humerus',243,2,123,377.52949,49.8563713,56.8606376,1.8,50.1967363,56.867213,1.344077,16.2418014,30.8313192,22931.5718618,36483.8231574,59.7423465,1183.3364274,1411.8859929,1856.9255321,1.0270346,9.5311368,1.8370484,21.1606402),(20346,'humerus',243,2,124,379.9766411,49.7096107,56.56932,1.8,50.0091783,56.6102074,1.3648502,16.0774149,31.3504487,22930.0685354,36665.4129679,60.6811576,1169.5339139,1426.2285748,1831.6127471,1.264978,7.1483526,1.8370484,17.0526722),(20347,'humerus',243,2,125,382.1654388,49.5545848,56.262921,1.8,49.8438597,56.2919407,1.3836384,16.8832069,31.7487349,22886.1422604,36763.8844542,61.4890821,1157.9637621,1355.5565848,1829.7839647,1.04492,3.8534746,1.7894653,10.8251601),(20348,'humerus',243,2,126,385.0364161,49.3982376,56.0019115,1.8,49.7065738,56.0788894,1.3950252,16.2180369,33.4759751,22913.2245014,36948.0548119,62.2104234,1103.7185545,1412.8235562,1786.2295158,0.9916101,7.754968,1.815775,16.9512562),(20349,'humerus',243,2,127,386.0155809,49.2733364,55.7248766,1.8,49.573836,55.8420364,1.4104328,42.2177416,34.1929693,22955.588652,37006.1565765,62.6955714,1082.2738521,543.7426959,1246.0297588,0.5855333,4.5113445,1.8045395,9.6429681),(20350,'humerus',243,2,128,389.1090722,49.1531316,55.4131049,1.8,49.4910037,55.4935798,1.425043,42.8761174,34.093886,23005.6280977,37148.5111501,63.4835322,1089.5945155,536.5604321,1252.6162203,0.5152813,3.5772299,1.6879051,7.62484),(20351,'humerus',243,2,129,392.98661,49.0675427,55.0680537,1.8,49.3976417,55.1501419,1.4441617,44.0626192,24.1036489,22915.3374689,37083.842806,64.4530277,1538.5157237,520.062989,1289.1776255,0.5832835,3.6497487,1.801887,7.7979681),(20352,'humerus',243,2,130,393.6700203,48.9510516,54.8033953,1.8,49.2808016,54.8590351,1.4646614,35.5211171,24.0819524,22819.6695583,36911.5683708,64.8753507,1532.7481652,642.425447,1544.4990396,0.626952,2.9554801,1.7126934,6.370936),(20353,'humerus',243,2,131,393.4458387,48.8307783,54.5255127,1.8,49.1767655,54.5675459,1.4842046,17.1996297,25.0999085,22695.4630749,36709.2044274,65.0838502,1462.5234378,1319.5320739,2364.6275293,0.417968,2.3083037,1.6614562,4.943904),(20354,'humerus',243,2,132,393.109176,48.7078935,54.2633825,1.8,49.0435642,54.3292446,1.5063912,28.0277715,18.5045312,22530.06132,36765.1750134,65.2468009,1986.8201294,803.8477588,1822.0025137,0.208984,0.4673024,2.0344439,1.009064),(20355,'humerus',243,2,133,393.846094,48.5956067,53.9809546,1.8,48.9268199,54.0349641,1.527478,17.3719822,18.1148079,22422.7060862,36984.0576303,65.5179186,2041.6477958,1290.7396393,2446.6311649,26.749952,34.5026192,1.6861358,101.3576772),(20356,'humerus',243,2,134,394.4275446,48.4754472,53.6835497,1.8,48.8136249,53.711306,1.5482719,23.505286,35.510851,22358.1768207,37039.1779435,65.7045775,1043.0383092,951.1978198,1455.0914167,26.540968,34.4360992,1.6680495,101.1128372),(20357,'humerus',243,2,135,394.4531934,48.3397417,53.3855237,1.8,48.6763434,53.4664915,-1.5699917,22.9504554,35.8545522,22236.8672819,37123.4464063,65.7421559,1035.390046,968.9074534,1473.2950137,1.9880148,14.2247351,1.7480217,31.2932883),(20358,'humerus',243,2,136,395.3682496,48.2472162,53.0881388,1.8,48.5588362,53.1599205,-1.5492261,28.5285361,36.2742389,22217.5878213,37174.6508069,65.8640537,1024.8223519,778.7847134,1375.6487318,1.020408,6.8456217,1.3554386,14.9331281),(20359,'humerus',243,2,137,396.5113784,48.2262146,52.7399262,1.8,48.5672513,52.8793392,-1.5303155,31.4428499,36.82803,22134.1342008,37363.7013035,65.9769953,1014.5452062,703.9480914,1337.0681766,3.9716929,21.8645609,1.0172628,50.6263287),(20360,'humerus',243,2,138,396.3962635,48.1310916,52.43565,1.8,48.4395028,52.5142983,-1.5040743,31.9563706,37.6982971,21947.5690224,37318.2388357,65.7723648,989.9184239,686.7979243,1331.6338348,3.9370994,21.1115219,1.0184928,50.6263287),(20361,'humerus',243,2,139,396.0452676,48.0515341,52.1234824,1.8,48.3838845,52.1917917,-1.4783044,16.0683266,37.872559,21777.6414326,37334.0672202,65.4444742,985.7814778,1355.3148323,1473.0908521,7.5251317,29.2114483,1.2580953,74.885873),(20362,'humerus',243,2,140,397.093107,47.9884289,51.80395,1.8,48.3501362,51.8705219,-1.4518217,23.4444734,18.4331494,21725.0906093,37586.0574221,65.2497909,2039.046972,926.6614872,2021.642075,1.294452,11.810832,1.3386925,25.4120322),(20363,'humerus',243,2,141,399.9760748,47.928859,51.4973436,1.8,48.2758542,51.544957,-1.4277893,16.6402478,18.5403653,21826.9871161,37994.2956919,65.3086285,2049.2743799,1311.6984415,3160.3260233,0.7278301,5.9109601,1.4288993,12.5687441),(20364,'humerus',243,2,142,401.6697647,47.8721749,51.1784085,1.8,48.1930574,51.2574711,-1.4067755,16.1321169,18.64773,21848.8890758,38339.4650996,65.1600455,2055.9856451,1354.3721053,3172.9458202,0.626952,2.9554801,1.4288993,6.5440641),(20365,'humerus',243,2,143,403.1387965,47.7826025,50.8523872,1.8,48.1206169,50.9215523,-1.3864379,18.0458353,18.6517828,21891.1554028,38670.9278756,64.9319051,2073.3100023,1213.0862894,3179.2928064,0.417968,0.9346049,1.1071487,2.018128),(20366,'humerus',243,2,144,404.3709018,47.7086235,50.5483399,1.8,48.041236,50.6035526,-1.3682294,19.1826536,34.4888371,21973.0541689,38871.3790329,64.66732,1127.0713154,1145.4647864,1541.7473967,26.2752991,34.9778288,1.3417583,102.3667412),(20367,'humerus',243,2,145,407.5077365,47.6842935,50.1550651,1.8,48.031622,50.2417246,-1.3395399,54.1764099,20.5705734,21998.2231352,39191.400488,64.3500247,1905.2167258,406.0480043,1056.2087328,0.9914555,8.2674239,1.2890245,18.1334482),(20368,'humerus',243,2,146,411.2052037,47.6905847,49.8009685,1.8,48.0323136,49.9456696,-1.3062544,28.3570773,29.7105714,22000.6523435,39854.8699644,63.8488551,1341.4373435,775.8434369,1506.0565872,1.9913756,15.3599686,1.3093175,35.3802523),(20369,'humerus',243,2,147,412.8945658,47.6860819,49.4895834,1.8,48.027611,49.6895156,-1.2791105,28.9066347,35.7352744,22045.8179012,40421.9698525,63.1250453,1131.1503968,762.6559841,1511.2328722,3.6445207,23.0034338,1.5344487,52.0359605),(20370,'humerus',243,2,148,415.5091484,47.6828415,49.1709301,1.8,48.0174616,49.4217858,-1.2483674,24.0100589,45.6363786,22155.2150467,41106.3395961,62.2981613,900.7362288,922.7472174,1226.7821936,2.0902554,15.786248,1.4513674,36.0640643),(20371,'humerus',243,2,149,421.235936,47.695406,48.8925161,1.8,48.0114514,49.2246422,-1.2226284,24.9538071,46.5764858,22402.7676149,42146.2139482,62.0339264,904.8817927,897.7695266,1242.8774845,2.0429111,14.3089195,1.4536876,33.5562563),(20372,'humerus',243,2,150,427.056663,47.7373224,48.5840813,1.8,48.0520675,48.764081,-1.1955458,21.3155354,47.1765884,22633.1960115,42539.6418281,61.6152802,901.7108537,1061.8169157,1263.8663624,1.164697,8.1154706,1.3633001,17.7871922),(20373,'humerus',243,2,151,429.1747481,47.726133,48.3508166,1.8,47.9968035,48.442407,-1.1740076,19.9115425,41.1126454,22917.9150448,43159.1144112,60.8462333,1049.7771177,1150.9864234,1571.9428512,4.2068513,24.0558649,0.9707461,59.8600289),(20374,'humerus',243,2,152,432.72498,47.7532759,48.1388548,1.8,48.0292464,48.2225092,-1.1515432,27.5558894,36.3274831,23270.3489479,44120.5426987,60.1694843,1214.5224204,844.4782387,1601.6275628,1.0289177,9.3460486,1.3909428,20.6412562),(20375,'humerus',243,2,153,436.9350116,47.8632353,47.8368504,1.8,48.1372219,47.9291143,-1.1257921,17.7840347,19.4905368,23433.9989715,44871.6540771,59.3286905,2302.2277182,1317.6986787,3495.335568,1.7410286,11.6825608,1.3909428,29.2034483),(20376,'humerus',243,2,154,432.6018184,47.8065445,47.7255696,1.8,48.0859599,47.7683558,-1.1118049,17.197858,20.0003368,23494.3232713,44891.5953025,57.9478684,2244.5419637,1366.11916,3418.9272241,1.7843378,11.8532807,1.4114447,28.1943843),(20377,'humerus',243,2,155,433.9694332,47.8244708,47.570233,1.8,48.1242774,47.550545,-1.0901709,19.1881595,36.3743153,23686.649953,45658.0352225,56.8678916,1255.227346,1234.4409528,1689.6978445,0.443322,1.04492,0.9272952,2.191256),(20378,'humerus',243,2,156,433.8197229,47.8182142,47.3927037,1.8,48.1730175,47.3149894,-1.063972,18.3050053,19.9143731,23979.3901605,46547.6254706,55.267453,2337.3884436,1309.9908883,3538.494719,1.810423,10.6561349,1.3734008,27.3881523),(20379,'humerus',243,2,157,430.7688207,47.7800848,47.2578366,1.8,48.1545157,47.1315469,-1.0463283,33.1388351,44.105677,24197.8163334,47369.8763308,53.79203,1074.0085984,730.1951399,1622.5388805,1.7271935,10.4950758,1.3499676,26.6239283),(20380,'humerus',243,2,158,427.4737659,47.7705982,47.1557168,1.8,48.1692003,46.9781668,-1.0270891,38.5385341,36.7282191,24496.8168824,48246.9210344,52.1794484,1313.619942,635.6447502,1617.344828,1.8136276,12.2090306,1.4506876,28.9586083),(20381,'humerus',243,2,159,425.190142,47.7312317,47.0561309,1.8,48.1658731,46.8788242,-1.0081903,37.7153065,41.3393053,24799.1152545,49251.9004383,50.703402,1191.4060971,657.5345013,1634.635356,1.1227667,9.226117,1.3422997,20.8143842),(20382,'humerus',243,2,160,422.175966,47.6960439,46.9440406,1.8,48.1430699,46.7694285,-0.983957,33.3242202,44.2037871,25087.7634746,50449.0329218,48.7881284,1141.2830489,752.8387269,1703.5372797,1.1688112,9.310935,1.4130276,20.8860962),(20383,'humerus',243,2,161,420.1547717,47.7046905,46.8076733,1.8,48.1354195,46.6698724,-0.9561022,38.0911974,45.2202909,25228.5665019,51404.8025751,46.7357164,1136.7640844,662.3201211,1688.9800331,1.1160871,4.7655684,1.3045443,11.1714161),(20384,'humerus',243,2,162,418.6436538,47.7037333,46.6960647,1.8,48.2168885,46.4819723,-0.9336769,51.7929949,39.8519878,25509.2922679,52406.1341966,45.0819782,1315.0193284,492.5239852,1478.8993581,1.6485934,9.7239337,1.419781,25.0447722),(20385,'humerus',243,2,163,419.0195043,47.7397809,46.5996124,1.8,48.2846615,46.3149946,-0.9112058,53.2576237,39.8928866,25846.0233697,53961.1357909,43.6118533,1352.6505711,485.3018512,1485.3643046,1.1564048,10.4512896,1.3694792,23.4236082),(20386,'humerus',243,2,164,420.939083,47.7228837,46.6054041,1.8,48.2593965,46.3183377,-0.8955059,53.1440474,39.2005642,26507.0624773,55532.1323716,42.7407499,1416.6156391,498.7776387,1530.6144178,1.1544878,11.4770086,1.3876855,25.5134482),(20387,'humerus',243,2,165,428.214972,47.7099705,46.6409319,1.8,48.2629453,46.2963007,-0.8859646,43.1007601,50.1367617,27422.7883034,58049.1328954,42.8136265,1157.8157605,636.248368,1704.6264854,1.5028974,7.5350253,1.5152978,17.7871922),(20388,'humerus',243,2,166,435.5923706,47.5756916,46.8587742,1.8,48.2111582,46.4794523,-0.8870861,42.5641335,36.9708228,28430.2538938,60754.9387935,43.6309942,1643.3212498,667.9392148,1970.3278679,0.9015355,6.7395315,1.4464413,15.1062561),(20389,'humerus',243,2,167,446.0761378,47.4619252,47.0777258,1.8,48.1742512,46.6741106,-0.8827644,41.581765,44.7292292,29413.3602001,64059.5771917,44.3661393,1432.1636719,707.3619945,2066.6206991,1.4676697,11.8882326,1.3940875,28.7137683),(20390,'humerus',243,2,168,449.0328093,47.4927036,47.0750012,1.8,48.2779459,46.6488241,-0.8531227,41.860768,44.4155486,29964.8470239,67155.232328,42.4723393,1511.975747,715.8217223,2147.9659991,1.3844646,4.4085223,1.4758446,12.3536082),(20391,'humerus',243,2,169,452.3944079,47.5806477,46.9504995,1.8,48.4024674,46.4821454,-0.8156941,42.5656363,44.6483295,30233.9510868,69381.9683173,39.9824244,1553.9656025,710.2901245,2180.4122787,2.3385356,17.7943464,1.6295521,43.0768044),(20392,'humerus',243,2,170,456.6054983,47.6206119,46.8647394,1.8,48.4369687,46.4398788,-0.7830595,42.8672401,51.0675634,30406.5783823,71970.7479227,37.8724878,1409.3241026,709.319711,2001.8440504,1.7133303,8.0750076,1.388628,23.0563483),(20393,'humerus',243,2,171,457.3531629,47.7035946,46.8423755,1.8,48.5435122,46.4455881,-0.7521588,43.1935169,53.2185918,30590.4025706,74622.5039979,35.5809381,1402.1886231,708.2174534,1976.7594179,1.003785,2.2215304,0.71883,5.3915761),(20394,'humerus',243,2,172,461.5388031,47.7215797,46.8705639,1.8,48.5850192,46.3776577,-0.7291385,41.9606642,45.9509271,30869.2872922,77979.3145343,34.1430258,1697.0128657,735.6720359,2290.5240731,30.9565533,48.4865399,0.8677801,206.4104508),(20395,'humerus',243,2,173,470.9927565,47.8289669,46.9991424,1.8,48.6816923,46.5062745,-0.711599,33.0318469,52.2555521,31604.7289642,82664.790464,33.4772619,1581.9331562,956.7956962,2178.1733065,2.5403182,17.9397884,1.7110459,58.9262806),(20396,'humerus',243,2,174,475.3864981,47.9478427,47.0915052,1.8,48.7545272,46.6829268,-0.6903623,33.7393441,51.8277655,31981.9374978,86938.5027882,32.1310062,1677.4503393,947.9122467,2278.4825036,0.626952,1.2185757,2.1112158,2.731644),(20397,'humerus',243,2,175,482.3219657,48.1610558,47.0879562,1.8,49.0636327,46.7765216,-0.6675663,45.2689112,50.0285382,32340.6765762,90823.0024011,30.8087791,1815.4238678,714.4125123,2414.3534233,1.0093152,3.7032059,1.2847449,8.7353201),(20398,'humerus',243,2,176,481.8309473,48.2395707,47.2207857,1.8,49.0830248,47.01645,-0.6498145,45.8985404,27.1900219,32925.292886,94380.4763539,29.3974585,3471.1438169,717.3494533,2763.8699544,0.9277672,1.9267373,0.7086263,4.8004801),(20399,'humerus',243,2,177,489.5201011,48.3868687,47.4405239,1.8,49.0606062,47.3984879,-0.637915,18.6430581,27.6632392,33771.5258353,98366.7392086,28.9344046,3555.8648187,1811.4799444,4776.3814239,2.2926536,19.0347602,1.7251151,56.2750486),(20400,'humerus',243,2,178,502.1935395,48.3962115,47.8777498,1.8,49.1529722,47.8197384,-0.6360505,46.8154951,28.375202,35398.4061798,103076.579918,29.5342757,3632.6289365,756.1258538,2957.2818776,1.671872,7.133062,1.482789,21.5279002),(20401,'humerus',243,2,179,529.2849007,48.2976158,48.6004193,1.8,49.1276512,48.5424016,-0.6526364,54.7421335,37.977911,38809.0265926,111833.8433083,32.5327413,2944.7076005,708.9425299,2657.9174242,2.4921564,19.4175266,1.7111713,59.3739527),(20402,'humerus',243,2,180,571.1255271,48.1333834,49.6653701,1.8,49.0075281,49.4050967,-0.6923274,46.8687396,39.0670535,44589.8824097,124287.9443436,38.7856868,3181.4005229,951.3778853,3601.9960848,0.8111051,1.4019073,1.1071487,3.6689961),(20403,'humerus',243,2,181,608.0313401,48.0194991,50.7248589,1.8,49.0219107,50.3034892,-0.725466,49.3602543,39.6598042,51150.0998568,135751.5320979,44.6103709,3422.8997028,1036.2608667,3781.0038818,0.626952,1.1254133,1.9513027,2.731644),(20404,'humerus',243,2,182,628.8057678,48.1448488,51.507473,1.8,49.1713372,51.3882351,-0.7348839,52.2571811,42.4702546,58491.4771361,144739.0836442,47.1155351,3408.0107341,1119.3002746,3835.9845417,0.5610809,1.04492,2.2142974,2.191256),(20405,'humerus',243,2,183,661.1504076,48.589901,52.4342779,1.8,49.5845019,52.412259,-0.7194961,43.5098362,45.7077443,68157.5854857,156095.8791737,47.8550157,3415.0860341,1566.486831,4854.9973122,0.7696308,2.0582537,1.9890207,4.4542241),(20406,'humerus',243,2,184,684.9454435,48.9490868,53.3191118,1.8,49.7098051,53.4845389,-0.6887591,38.1927231,40.2135597,78144.4614172,168207.4328728,46.1152614,4182.8535972,2046.0562946,5845.6619763,2.5020221,20.1710162,1.467004,62.7474007),(20407,'humerus',243,2,185,698.5169978,49.0654943,54.2003062,1.8,49.8176081,54.3723795,-0.6844438,25.3103542,33.2995981,86378.0559179,177744.8112809,46.5363915,5337.7464433,3412.7557192,7928.7241092,2.1223811,15.1394449,1.4601391,46.2561205),(20408,'humerus',243,2,186,742.9203269,49.9820592,55.3630305,1.8,51.027844,55.9627856,-0.6300935,35.4433835,33.4311969,104794.2345818,189109.3543796,42.9879166,5656.6731691,2956.6656529,8004.0661049,2.4813093,20.2185945,1.4464413,57.5079487),(20409,'humerus',243,2,187,809.3789456,51.4669881,56.5652122,1.8,52.028479,57.068938,-0.5238665,37.0785026,32.5837519,128090.1694108,207316.6809458,33.7554044,6362.578545,3454.5669476,9042.8308547,0.208984,0.4673024,2.0344439,1.009064),(20410,'humerus',243,2,188,855.9427371,52.3629693,57.4669559,1.8,52.3660634,57.8384385,-0.4449416,35.8677511,41.8471245,142598.6979887,225111.9268263,26.4270328,5379.3881732,3975.6799299,8642.688563,0.626952,1.8924306,1.6814535,4.281096),(20411,'humerus',243,2,189,880.142303,52.555138,58.3398689,1.8,52.361985,58.615623,-0.4063696,40.6410227,31.7887974,151632.6823662,236093.0378378,22.9194976,7426.9257489,3731.0252644,7720.9525505,1.463822,4.4332201,1.7126934,11.9863482),(20412,'humerus',243,2,190,883.7527128,52.2320688,59.114617,1.8,52.3019005,59.2231249,-0.3874031,34.4553042,32.5117288,158501.5969938,239772.1024891,21.0217793,7374.9416336,4600.2088942,11397.7357077,0.208984,0.4673024,2.0344439,1.009064),(20413,'humerus',243,2,191,901.2172629,52.2123288,59.7084124,1.8,52.4981087,59.5069553,-0.3496261,33.6598379,45.2790476,166611.2150312,246835.3628701,17.6245222,5451.4256807,4949.8519708,8824.9919522,1.253904,5.6772918,1.6814535,14.7179922),(20414,'humerus',243,2,192,932.5371975,52.431134,60.0853141,1.8,52.877621,59.6369387,-0.3266164,33.5146227,46.1971907,176207.7802065,257172.4992794,15.9989785,5566.8428186,5257.6387789,9077.8756021,0.208984,1.0656135,1.7681919,2.262968),(20415,'humerus',243,2,193,969.4047623,52.5746557,60.1084705,1.8,53.1769012,59.6039223,-0.3208555,33.3387233,45.4626852,185502.1446802,267092.5887098,16.0700877,5874.9848906,5564.1646146,9598.968524,1.462888,4.2005264,1.4711277,15.1359602),(20416,'humerus',243,2,194,1000.394969,52.763374,60.1132957,1.8,53.3196442,59.6359456,-0.3101153,36.3713444,34.2992248,191249.04881,273605.5501303,15.527423,7977.0184826,5258.2342533,10636.5760414,0.208984,0.4673024,2.0344439,1.009064),(20417,'humerus',243,2,195,1023.9760934,52.7296558,60.2477109,1.8,53.3096223,59.8162764,-0.3037174,33.6659541,45.6843596,194989.4607007,273213.7405471,15.2645126,5980.4655904,5791.8887505,9869.9822613,2.1026498,8.787274,1.5232132,24.7789283),(20418,'humerus',243,2,196,1011.3272714,52.6421483,60.4644371,1.8,53.1478629,60.0445289,-0.3044455,31.8885362,35.0449394,195505.191551,271674.7898018,15.1460701,7752.1831869,6130.8926316,13300.3603909,1.5882097,11.3160542,1.4968573,28.9376043),(20419,'humerus',243,2,197,991.3185999,52.5201173,60.6363958,1.8,52.9567165,60.2426114,-0.304697,33.9311885,34.9503349,193967.7955912,268382.1114227,14.8701919,7678.9567923,5716.5046128,12943.0373962,2.298824,12.3936498,1.4694498,38.1923085),(20420,'humerus',243,2,198,977.7464765,52.2588715,60.7992664,1.8,52.6597316,60.3136363,-0.3087762,35.8713533,34.7777625,191431.614048,264431.5796527,15.0492943,7603.4672881,5336.6153312,9400.1053358,53.7654367,65.3401769,0.8125408,269.8872751),(20421,'humerus',243,2,199,969.2792185,52.0592183,60.8164974,1.8,52.3866255,60.3373236,-0.303636,33.9238049,34.1513682,188287.2738287,263048.4293821,14.4416308,7702.4272642,5550.2993918,11777.6390482,0.9351348,1.6848829,0.5191461,4.1376721),(20422,'humerus',243,2,200,964.5019634,51.9186775,60.8436851,1.8,52.2841881,60.2751406,-0.2871852,35.5146085,34.0290714,184181.2835565,259791.8682352,12.8974379,7634.4095578,5186.0710694,11575.0694559,52.9250643,64.8248022,0.421825,365.9685888),(20423,'humerus',243,2,201,964.1718385,51.9177337,60.8023518,1.8,52.2431811,60.3486259,-0.2575684,34.3531033,33.6937996,177567.7489956,259330.7724439,10.4270897,7696.6912422,5168.8998034,9884.3916556,2.4959405,17.0305933,1.3228415,50.3010766),(20424,'humerus',243,2,202,961.5007705,52.0918675,60.6953286,1.8,52.270747,60.3012523,-0.2452511,33.4067731,34.2500501,169866.191018,257691.7841569,9.4470302,7523.8367001,5084.7829666,10722.6504247,0.208984,0.4673024,2.0344439,1.009064),(20425,'humerus',243,2,203,960.3962075,52.1559974,60.5484284,1.8,52.4153514,60.2200855,-0.2250059,32.9909649,32.5341493,161626.636258,258099.4746219,7.9679269,7933.1865294,4899.1181973,11215.3422514,2.162728,16.6401665,1.3684747,50.1786567),(20426,'humerus',243,2,204,954.6414551,52.2515876,60.3937073,1.8,52.61686,60.1582689,-0.190281,32.5652909,43.5461353,151245.6968204,257960.1349958,5.6915703,5923.8353388,4644.3834042,9358.4653376,0.5289921,1.4019073,1.1071487,3.027192),(20427,'humerus',243,2,205,943.7640633,52.4669834,60.2418447,1.8,52.8650989,60.1248867,-0.1471963,31.9814689,32.9683279,138964.8604616,256884.3902875,3.3835065,7791.8537823,4345.1681634,9677.5563092,50.0879833,62.5536277,0.2879368,438.0264981),(20428,'humerus',243,2,206,917.8546216,52.7964059,60.1497134,1.8,53.1559032,60.0195763,-0.1062231,31.4954889,34.5499421,124407.0060142,252856.6381926,1.7195956,7318.5835593,3949.9944449,8828.4711682,48.693272,62.0763394,0.5450384,382.3128414),(20429,'humerus',243,2,207,853.3808814,52.4731181,60.4172934,1.8,53.1860903,60.0382208,-0.0071853,29.3816126,38.8748177,104060.0825039,231040.2877238,0.0073422,5943.1863942,3541.6736226,7150.4076478,47.4620689,61.5949984,0.4757866,396.220998),(20430,'humerus',243,2,208,755.8030712,51.4104905,60.7948744,1.8,52.3563857,60.4850827,0.1219917,31.142611,43.3461346,79765.7441475,198516.8787077,1.8653592,4579.805802,2561.3056045,5809.2486055,45.3146089,60.9208971,0.4129997,427.9322543),(20431,'humerus',243,2,209,661.0858358,50.7852975,60.6102675,1.8,51.52041,60.5276051,0.1661221,31.8989777,33.7961076,57956.8134985,176746.6989888,3.0127467,5229.7945393,1816.8862351,6151.7682383,42.8891636,59.9270502,0.3636686,332.8774048),(20432,'humerus',243,2,210,511.0916513,48.8803217,60.0204856,1.8,50.4090285,60.0616896,0.2087466,24.3084753,35.1967836,36172.7761986,140226.3169179,3.6582136,3984.0662326,1488.0726051,4733.8431359,25.0162082,39.7975996,1.7609829,182.9745388),(20433,'humerus',243,2,211,294.8215391,46.8224433,58.6665187,1.8,47.343808,59.0454113,0.3069119,22.5975057,35.6778592,14827.7365256,83635.7104969,4.484937,2344.1908332,656.1669545,2552.3481212,18.7946837,34.5930073,1.7776703,126.7451017),(20434,'humerus',243,2,212,117.9884574,42.3899319,55.0109025,1.8,45.3171536,55.8299084,0.4402757,39.5990193,39.7502944,3002.4662781,30794.7118083,3.5718448,774.7039934,75.8217332,762.8165022,11.0364333,22.4791413,1.2784491,67.3957567),(20435,'humerus',243,2,213,54.1083834,38.1912694,53.8277029,1.8,39.6766714,54.3710442,0.4479042,39.3165301,30.7974932,769.8462807,9692.6176174,1.6913928,314.720992,19.5807279,263.2017035,8.0773447,17.7057678,1.3687712,45.5723085),(20436,'humerus',243,2,214,5.3549604,34.3044077,52.3613826,1.8,35.3029487,52.6172731,0.4212922,9.0430006,65.5832788,26.5435652,349.9586276,0.1492534,5.3360953,2.9352608,5.6880167,3.525135,10.6171277,1.3927034,24.6775122),(20437,'humerus',243,2,215,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20438,'humerus',243,2,216,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20439,'humerus',243,2,217,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20440,'humerus',243,2,218,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20441,'humerus',243,2,219,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20442,'humerus',243,2,220,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20443,'humerus',243,2,221,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20444,'humerus',243,2,222,0.0423641,77.5879052,88.6390522,1.8,77.5887931,88.6370805,-0.135764,0.1309036,1.1138886,0.0004349,0.0206041,0.0001293,0.0184975,0.0033221,0.0188817,0.4754258,2.3827842,0.266252,4.994612),(20445,'humerus',243,2,223,1.1128612,42.7550441,61.9254583,1.8,42.7718469,61.9361244,0.6806164,2.2253001,42.9772942,1.1829657,6.1247201,0.0734458,0.1425106,0.5315983,0.1700342,4.3646224,4.8608438,2.6971734,14.6672842),(20446,'humerus',243,2,224,21.0221935,42.68551,61.8426591,1.8,42.6654402,61.8494931,-1.2119284,9.1313691,26.4252738,152.9417564,161.0708962,3.071512,6.095335,16.7490499,11.2819737,11.912088,12.4147754,0.9407624,39.6193405),(20447,'humerus',243,2,225,47.1953618,42.7219416,61.8024964,1.8,42.7037504,61.8553757,-0.9380289,8.747936,26.97263,702.7272101,742.3683089,5.1149651,27.5230227,80.33063,51.5430482,16.509736,16.8863728,0.6360755,54.7553007),(20448,'humerus',243,2,226,138.218465,53.5612852,63.716438,1.8,56.2591765,64.598769,0.1532616,16.3221001,24.0873519,4368.0699689,20343.5843578,0.5368812,844.575379,267.6169082,865.4228328,19.226528,19.7917889,2.7630471,64.3265568),(20449,'humerus',243,2,227,517.0217626,65.698,67.1877045,1.8,61.1284695,66.2065985,0.2260187,16.6802352,34.4345016,24558.5275576,87540.4810937,4.3275142,2542.2316864,1472.3130256,3254.6854651,21.734336,22.1562467,0.9461609,72.2259409),(20450,'humerus',243,2,228,572.0655571,65.5697208,67.300263,1.8,60.073821,66.001411,0.2385562,16.16037,35.2794073,27274.0133971,106549.0192882,5.3237999,3020.1476606,1687.7097097,3793.1412214,23.7289027,24.0558649,0.6000502,79.044549),(20451,'humerus',243,2,229,589.5338527,64.9326538,67.1593431,1.8,59.2045225,65.7822157,0.2343079,16.5506366,35.3417209,28436.5308594,115970.8495714,5.2962581,3281.4148992,1718.153296,4085.9700022,25.07808,25.5174513,0.4489966,83.173521),(20452,'humerus',243,2,230,598.4400243,64.6198328,67.1819247,1.8,58.8089425,65.8397061,0.2170308,16.4296556,35.6514172,29078.3728088,120301.1697636,4.6246886,3374.3727223,1769.8711106,4189.7757013,26.331984,26.7972581,0.6637791,87.7291611),(20453,'humerus',243,2,231,604.8073685,64.3925245,67.2160863,1.8,58.5475297,65.9380801,0.2013953,16.0473277,35.8809605,29483.8506032,123183.1049823,4.0335248,3433.105007,1837.3059487,4246.883388,27.16792,27.7130435,0.5649941,90.4100971),(20454,'humerus',243,2,232,608.6414702,64.2137783,67.2385727,1.8,58.3801993,66.0326684,0.1902863,16.3320425,35.9825207,29720.18423,125060.6699538,3.6289202,3475.5950223,1819.7469346,4291.3115378,28.003856,28.3487393,1.1533205,92.4282251),(20455,'humerus',243,2,233,609.7909781,64.1564838,67.2352306,1.8,58.402903,66.1048174,0.182048,16.3801843,36.1603935,29749.0805253,125462.2428825,3.3311831,3469.6039111,1816.162745,4284.6105167,28.415365,28.8526613,1.0390723,94.1508052),(20456,'humerus',243,2,234,609.9420912,64.0981848,67.251811,1.8,58.3788738,66.1501296,0.1761848,16.3292617,36.2071989,29755.2296498,125484.638242,3.1230291,3465.7372548,1822.2030047,4279.5381204,28.7062884,29.0329851,1.0427219,95.2105772),(20457,'humerus',243,2,235,609.6197086,64.0512815,67.2617781,1.8,58.3507403,66.1904786,0.1714449,16.6482668,36.1874301,29762.2207773,125303.5087332,2.9573142,3462.6252414,1787.7068559,4272.9120716,28.7398588,29.114104,0.6837093,95.1598692),(20458,'humerus',243,2,236,609.5602718,63.9918246,67.2667704,1.8,58.2798344,66.2350829,0.16756,16.7809092,36.1858653,29749.0168876,125440.6730159,2.8257756,3466.5655225,1772.7893413,4278.0216034,28.630808,29.177789,0.9430532,95.2822892),(20459,'humerus',243,2,237,609.6646932,63.915966,67.2549139,1.8,58.1550962,66.2329245,0.1651775,16.4541888,36.138806,29717.4003905,125688.8266552,2.7471862,3477.946299,1806.0690031,4291.3301642,28.7393138,29.177789,0.9430532,95.2822892),(20460,'humerus',243,2,238,610.7006081,63.8319337,67.2398289,1.8,58.0640002,66.22815,0.1626495,26.2788561,42.3721109,29811.8332021,126219.7503655,2.6690054,2978.8402711,1134.4418158,3129.4226377,28.630808,29.1755436,1.0205491,95.1091612),(20461,'humerus',243,2,239,612.8961952,63.756129,67.2276491,1.8,57.9738857,66.225497,0.159911,16.1996435,36.1043431,29963.796257,126918.1839624,2.5899236,3515.3162522,1849.6577562,4338.959174,28.630808,29.1800341,0.9072406,94.9867412),(20462,'humerus',243,2,240,614.7655749,63.6732433,67.2144801,1.8,57.8506567,66.2308974,0.1578216,16.0802383,36.0491245,30140.8067339,127737.9474671,2.5309423,3543.4410452,1874.4004973,4371.2270135,28.630808,29.1800341,0.9072406,95.1091612),(20463,'PereDavidsDeer-radius.tif',243,3,1,0.0770501,61.2696053,82.1580028,1.8,61.2230124,82.154485,-0.0295105,3.5490237,33.8860053,0.3442291,63.330253,0.0000112,1.8689206,0.0969926,1.8781659,0.220703,0.3121212,2.3561945,0.6242424),(20464,'PereDavidsDeer-radius.tif',243,3,2,0.1201656,62.937496,81.5297923,1.8,62.657016,81.4733616,0.0261565,18.0968271,33.7666397,3.6396871,72.1713125,0.0000137,2.1373555,0.2011229,2.2416107,0,0,0,0),(20465,'PereDavidsDeer-radius.tif',243,3,3,0.1852892,62.1416173,82.7556608,1.8,62.0362469,82.7711068,-0.0384736,20.8299467,34.7235504,2.0397212,103.8296909,0.0000457,2.9901807,0.0979225,3.0439216,0.220703,0.4935069,2.677945,0.9363635),(20466,'PereDavidsDeer-radius.tif',243,3,4,0.1436054,61.7419424,82.951866,1.8,62.2526399,82.9507431,-0.0438136,4.0460296,34.3045372,0.6013439,85.2040901,0.0000459,2.4837557,0.1486257,2.4954113,0.5351499,1.8856873,2.782822,3.9504722),(20467,'PereDavidsDeer-radius.tif',243,3,5,0.1907801,58.8145066,83.1240756,1.8,58.9421736,83.1218154,-0.0434511,6.4322107,35.5996296,1.1652169,120.1295441,0.00006,3.3744605,0.1811534,3.4026015,0,0,0,0),(20468,'PereDavidsDeer-radius.tif',243,3,6,0.2377629,59.3069848,85.2993806,1.8,59.4598071,85.2094983,-0.0429023,7.3656118,34.5849528,1.6453045,66.6769245,0.0000729,1.9279172,0.2233765,1.940719,0.220703,0.4935069,2.677945,0.9363635),(20469,'PereDavidsDeer-radius.tif',243,3,7,0.3741652,65.8931799,85.3715322,1.8,66.5869128,85.2260986,-0.1126081,7.9260107,32.1669109,2.127983,88.744869,0.0007874,2.7588869,0.268481,2.7864266,0,0,0,0),(20470,'PereDavidsDeer-radius.tif',243,3,8,0.4946113,67.0542928,85.0930171,1.8,67.0432659,84.8902564,-0.0713398,27.2448568,33.9795206,6.593087,143.0501033,0.0004188,4.2098917,0.2419938,3.7159953,0,0,0,0),(20471,'PereDavidsDeer-radius.tif',243,3,9,0.4706549,62.4377137,85.0111953,1.8,62.2730145,84.9887953,-0.0847923,5.5727634,34.8209315,2.6353486,155.8805093,0.0005626,4.4766324,0.472898,4.4966093,0.6965513,3.0018854,2.8430937,6.3403386),(20472,'PereDavidsDeer-radius.tif',243,3,10,0.3702832,64.6049837,85.2712253,1.8,64.8073066,85.261054,-0.1067273,5.1753373,33.2447994,2.2360504,117.6123626,0.0007003,3.5377672,0.4320589,3.5621231,0.6430172,2.5832624,2.7928217,5.4575266),(20473,'PereDavidsDeer-radius.tif',243,3,11,11.1297941,63.7688053,44.2459835,1.8,63.551659,51.5244949,-1.5221815,35.5446617,45.4064604,212.4435856,1338.8994459,1.8505851,29.4869813,5.9768071,29.6541575,5.9231997,10.0510773,1.2351578,25.963415),(20474,'PereDavidsDeer-radius.tif',243,3,12,18.8396869,63.5559664,44.1099009,1.8,63.1256496,50.5229383,-1.4934512,39.9400768,45.7853322,321.1795849,1700.6631417,3.1212012,37.1442788,8.0415365,39.2728947,7.7600763,29.3460308,1.2966289,81.1537354),(20475,'PereDavidsDeer-radius.tif',243,3,13,22.5856045,63.1200239,43.9102351,1.8,61.9691471,48.8941284,-1.3233988,44.9154041,46.1456182,264.8599934,1595.9878457,3.5385356,34.5859024,5.8968632,36.9393273,8.4338399,31.6499184,1.2953702,75.0719665),(20476,'PereDavidsDeer-radius.tif',243,3,14,25.9639991,62.8887778,43.7303242,1.8,61.8035951,46.9077663,-1.2213693,44.2348584,49.928716,225.1834055,1183.8695725,3.8201262,23.711196,5.0906324,26.3507925,8.9883874,33.8942617,1.3005466,80.3466567),(20477,'PereDavidsDeer-radius.tif',243,3,15,30.2474959,62.8891523,43.8738079,1.8,62.3371614,46.1274062,-1.2811907,44.5035266,47.5084656,299.4013368,976.2628073,4.6301219,20.5492388,6.7275868,25.1370169,9.581181,35.6836554,1.2823016,84.3728623),(20478,'PereDavidsDeer-radius.tif',243,3,16,35.3668089,63.0016309,43.914532,1.8,62.6991458,45.2548702,-1.2679634,44.7341798,48.9065258,309.779832,756.2423958,5.3702236,15.4630161,6.9249025,19.905564,10.2906798,37.4837912,1.265804,89.3354313),(20479,'PereDavidsDeer-radius.tif',243,3,17,37.9307016,63.2308494,44.149191,1.8,62.9299724,45.2358882,-1.201728,43.9018846,46.3401396,260.1890129,824.1027139,5.4990782,17.7837771,5.9266024,21.682913,11.0234237,38.7489359,1.2220253,92.2959885),(20480,'PereDavidsDeer-radius.tif',243,3,18,40.0284119,63.3720471,44.4451732,1.8,63.1206246,45.5504544,-1.2516476,25.3291891,46.2733283,233.0435923,1000.9970783,6.0146403,21.6322689,9.2005943,26.667597,12.0510692,39.5113852,1.270244,95.0515276),(20481,'PereDavidsDeer-radius.tif',243,3,19,43.941847,63.4918501,44.7222251,1.8,63.2792595,45.7794788,-1.2494626,38.9568727,46.3273324,263.6237068,1184.8784704,6.5931075,25.5762292,6.7670654,31.2303089,0.5635176,2.2507378,1.3734008,4.9625691),(20482,'PereDavidsDeer-radius.tif',243,3,20,49.5829602,63.6512246,44.7978806,1.8,63.54063,45.4409185,-1.2199841,48.5775574,46.4172572,291.2958741,1175.5896745,7.2878466,25.3265648,5.9965113,27.1112877,0.9633942,8.8529143,1.4959365,19.4846036),(20483,'PereDavidsDeer-radius.tif',243,3,21,54.3742789,63.8185333,44.9741511,1.8,63.6498934,45.848432,-1.2299541,48.1209917,47.4460061,342.5611686,1409.257047,8.0497151,29.7023324,7.1187471,32.5235587,0.8247362,9.7209588,1.525373,20.5188822),(20484,'PereDavidsDeer-radius.tif',243,3,22,60.9776323,64.080053,45.2586823,1.8,63.8537185,45.9876681,-1.1861108,48.0507277,48.0193367,432.5642687,1638.3484045,8.7317342,34.1185139,9.0022418,39.0509353,0.220703,0.3121212,2.3561945,0.6242424),(20485,'PereDavidsDeer-radius.tif',243,3,23,67.4739865,64.3621364,45.5656133,1.8,64.0363876,46.1750498,-1.1615398,46.991683,48.5545774,468.1425283,1911.50707,9.4649566,39.3682156,9.9622422,46.0090553,0.9974949,6.060297,1.3876855,13.8220589),(20486,'PereDavidsDeer-radius.tif',243,3,24,72.8930272,64.5780429,45.9952203,1.8,64.2279818,46.8352645,-1.1930076,44.1646004,47.839388,528.5924358,2388.5292162,10.4958409,49.9280889,11.9686906,56.9205044,1.103515,12.5878126,1.535723,28.8612327),(20487,'PereDavidsDeer-radius.tif',243,3,25,76.4995461,64.9467488,46.0990646,1.8,64.7351031,46.7578405,-1.2167125,42.5651609,46.982548,589.9730371,2533.728397,11.2170968,53.9291398,13.8604677,63.7346186,1.5023159,22.7495446,1.5319809,53.4690599),(20488,'PereDavidsDeer-radius.tif',243,3,26,81.9153985,65.2434772,46.3394943,1.8,65.217675,46.614745,-1.2218075,41.8723677,48.0662207,669.5061532,2664.8701019,12.0561954,55.4416399,15.9892117,62.9049681,1.7257202,26.28683,1.5288042,58.863847),(20489,'PereDavidsDeer-radius.tif',243,3,27,88.85575,65.5089346,46.719515,1.8,65.5311417,46.836998,-1.230881,40.5129916,46.5643093,742.996921,3057.1752198,13.1630847,65.6549032,18.3397199,79.7178788,2.0654402,22.3183011,1.5213318,55.4488901),(20490,'PereDavidsDeer-radius.tif',243,3,28,96.0457172,65.7252415,47.2330545,1.8,65.8157581,47.0286819,-1.240633,22.6556273,38.9000584,774.0402536,3494.2064098,14.3251537,89.8252228,34.1654743,105.0400738,1.9199679,18.3236664,1.5467046,48.2035577),(20491,'PereDavidsDeer-radius.tif',243,3,29,104.8558318,65.9173184,47.8300331,1.8,66.0236916,47.6697092,-1.2741274,24.8677748,45.4373236,888.0964058,4298.2323365,15.9824665,94.5969523,35.7127412,111.3358835,2.356914,22.1099909,1.5108682,55.8902961),(20492,'PereDavidsDeer-radius.tif',243,3,30,115.3840892,66.1021656,48.4826827,1.8,66.2246859,48.5932599,-1.309421,36.3830316,45.1580509,1062.7663475,5451.0789784,17.9465443,120.7111218,29.2104946,141.2505457,1.945806,21.639026,1.5401936,52.8226358),(20493,'PereDavidsDeer-radius.tif',243,3,31,122.9473655,66.3316759,49.1862956,1.8,66.4425238,49.4515605,-1.3340681,37.8089556,44.8517851,1154.5231664,6523.9205822,19.3641849,145.4550932,30.5357064,165.7745131,0.220703,0.3121212,2.3561945,0.6242424),(20494,'PereDavidsDeer-radius.tif',243,3,32,131.491495,66.5405061,49.8532352,1.8,66.5909339,49.9831321,-1.3449637,27.8108995,44.1770026,1227.1207993,7719.4001235,20.8164356,174.7379783,44.1237364,192.7329888,1.5719486,10.6304642,1.4876551,26.4491846),(20495,'PereDavidsDeer-radius.tif',243,3,33,141.1122591,66.8998195,50.6086364,1.8,67.0671345,50.3026495,-1.3695254,29.7778221,44.0738901,1345.9373934,8942.7300154,22.5787634,202.9031244,45.1993228,193.4306411,1.0546405,7.0762765,1.6332151,15.8462525),(20496,'PereDavidsDeer-radius.tif',243,3,34,152.3501151,67.1515053,51.4255532,1.8,67.3015783,51.1250516,-1.3889178,32.8067211,43.0221659,1549.7090087,10745.7787021,24.5609547,249.7730756,47.2375464,230.5788483,0.220703,0.9099818,1.815775,1.9484604),(20497,'PereDavidsDeer-radius.tif',243,3,35,164.627173,67.3734785,52.3104199,1.8,67.4717258,51.8887386,-1.4054706,32.9968557,42.0972888,1747.9577383,12577.2723716,26.694722,298.7668026,52.9734638,270.9795295,2.5864039,26.9293839,1.5544044,78.8304144),(20498,'PereDavidsDeer-radius.tif',243,3,36,175.9043364,67.6094196,53.1931444,1.8,67.8212008,52.5183083,-1.4273705,34.2530754,41.0725352,1907.2223792,14244.0711947,28.7184262,346.8028238,55.6803253,307.8960735,2.2571809,26.9402345,1.5380212,74.1891545),(20499,'PereDavidsDeer-radius.tif',243,3,37,200.6514167,68.0645667,54.6515422,1.8,68.3941245,53.9453297,-1.4751671,26.4510415,39.1490214,2494.3472491,17494.9536577,33.1370098,446.8809951,94.3005306,437.6382334,1.765624,13.6907037,1.5385494,36.2450379),(20500,'PereDavidsDeer-radius.tif',243,3,38,231.607611,68.387252,56.4630953,1.8,68.6014304,55.5283061,-1.5132809,12.3087814,31.0773406,3102.8559828,22455.6690821,38.4737152,722.5737037,252.0847424,820.1377607,1.8700997,13.0513686,1.5031033,42.0996069),(20501,'PereDavidsDeer-radius.tif',243,3,39,269.4459115,68.3736282,58.5858479,1.8,68.4466527,56.9866386,-1.5024354,38.5323349,31.0757739,4100.0156138,29490.3800053,44.6981151,948.9829629,106.4045464,678.5669117,18.2073861,60.8340108,1.4617417,298.6109689),(20502,'PereDavidsDeer-radius.tif',243,3,40,281.3875064,68.3770954,58.7608611,1.8,68.4204853,57.0098189,-1.48436,37.7630484,33.2733044,4658.6441481,30055.815587,46.5484038,903.3011935,123.3651505,705.2394978,19.1383998,60.4452295,1.4536876,303.4626291),(20503,'PereDavidsDeer-radius.tif',243,3,41,258.5425,68.5531796,57.0352102,1.8,68.6024456,55.8825523,-1.4707827,27.8205628,35.1496565,4550.9586979,23419.6918839,42.6608301,666.2850848,163.5825533,746.1916672,19.7184323,58.0276836,1.4870234,318.1323245),(20504,'PereDavidsDeer-radius.tif',243,3,42,235.8778233,68.613183,55.3766441,1.8,68.6241376,54.2827557,-1.4384833,36.44218,37.1542125,4213.918133,18116.5481752,38.6287359,487.6041486,115.6329872,429.0776944,18.4948332,52.1130214,1.4732347,214.6221553),(20505,'PereDavidsDeer-radius.tif',243,3,43,215.4852232,68.54971,54.3755935,1.8,68.5816895,53.3235033,-1.3990713,35.1889626,39.6121581,3923.5978195,14530.7124713,34.8654818,366.8245601,111.5008095,348.4592764,0.3950294,0.795756,2.1587989,1.6898907),(20506,'PereDavidsDeer-radius.tif',243,3,44,200.6032235,68.4903199,53.6373948,1.8,68.5244179,52.5599775,-1.3618133,33.4400792,41.6038435,3681.4400272,12052.7712404,31.9948172,289.703312,110.0906492,294.7743611,18.6093525,45.6641922,1.4350509,263.6106099),(20507,'PereDavidsDeer-radius.tif',243,3,45,189.1021573,68.4625022,53.017123,1.8,68.465862,51.9624675,-1.3118864,25.4443309,42.1286845,3497.1076343,10421.08958,29.4510914,247.3632801,137.4415248,321.2330241,0.220703,0.3121212,2.3561945,0.6242424),(20508,'PereDavidsDeer-radius.tif',243,3,46,180.2106235,68.4186197,52.5035711,1.8,68.4760774,51.4908756,-1.2486232,10.9547033,38.4775617,3329.9296485,9333.5773135,27.0239739,242.5719534,303.9726008,328.7103922,2.4288955,24.1415188,1.3213831,77.7701482),(20509,'PereDavidsDeer-radius.tif',243,3,47,177.1567838,68.403006,52.0167237,1.8,68.3826787,51.0561299,-1.2012226,11.2169661,44.2987232,3292.7976427,8843.6708554,25.673608,199.63715,293.5551034,271.4744766,0.220703,0.3121212,2.3561945,0.6242424),(20510,'PereDavidsDeer-radius.tif',243,3,48,177.7871479,68.3779639,51.6484919,1.8,68.3460924,50.8430259,-1.1715191,10.4948131,38.04454,3312.7909161,8729.286125,25.1530725,229.4491174,315.659831,310.5916241,2.4592543,28.201664,1.2688452,84.6054443),(20511,'PereDavidsDeer-radius.tif',243,3,49,179.5474615,68.411805,51.0836029,1.8,68.3362127,50.2410022,-1.1343819,20.715694,32.4428535,3379.7460178,8590.3453851,24.5779804,264.7839035,163.149061,313.5947743,18.2432318,36.4026167,1.381724,169.7318338),(20512,'PereDavidsDeer-radius.tif',243,3,50,182.7705752,68.3674174,50.6774486,1.8,68.2408726,50.0478568,-1.0971564,23.5877083,45.3319031,3463.0264287,8526.752408,24.1240954,188.0960609,146.8148744,264.0183155,18.0960908,35.2379141,1.3562034,165.9198343),(20513,'PereDavidsDeer-radius.tif',243,3,51,186.0475206,68.2663293,50.3755646,1.8,68.0981167,49.7523103,-1.047179,22.6946084,45.1302302,3502.8148678,8347.0329182,23.2554422,184.9543617,154.3456845,260.5791841,18.4446194,34.2096771,1.3430304,164.3370467),(20514,'PereDavidsDeer-radius.tif',243,3,52,189.3403188,68.1700304,50.0910851,1.8,68.0028825,49.5830981,-1.008888,22.8748352,33.3756992,3524.2641714,8318.3013573,22.5984587,249.2322723,154.0673035,297.6564521,18.1000222,33.2412717,1.3225971,164.7876407),(20515,'PereDavidsDeer-radius.tif',243,3,53,190.9366575,68.0988032,49.875778,1.8,67.9195382,49.5219123,-0.9738473,37.2366178,47.8818575,3529.5519993,8322.1208503,21.7673874,173.805305,94.7871264,245.2619134,2.1390465,7.6102542,1.2765618,21.0857672),(20516,'PereDavidsDeer-radius.tif',243,3,54,194.3607804,68.0473554,49.6266837,1.8,67.8356158,49.45861,-0.9517016,21.4456306,48.2831661,3559.3063362,8397.2134611,21.4850951,173.9159657,165.9688355,244.9125451,18.3671382,31.8363601,1.2753555,153.2483451),(20517,'PereDavidsDeer-radius.tif',243,3,55,198.0790072,67.9713458,49.5543812,1.8,67.7774694,49.3948743,-0.9321042,34.4263047,40.9894306,3665.4124228,8461.2325789,21.2806196,206.4247407,106.4712711,274.6269187,2.239632,7.0105779,1.0789872,22.9049428),(20518,'PereDavidsDeer-radius.tif',243,3,56,203.9580161,67.8581016,49.5471355,1.8,67.690741,49.4613684,-0.9163866,32.8414625,52.700868,3814.5895998,8768.6910715,21.3984322,166.3860844,116.1516361,238.561539,0.220703,0.3121212,2.3561945,0.6242424),(20519,'PereDavidsDeer-radius.tif',243,3,57,203.8352821,67.790747,49.5635775,1.8,67.5476606,49.4767655,-0.884381,33.5138983,30.1705111,3966.9641577,8929.5337855,20.3270504,295.9689268,118.3677328,310.2460958,19.6428379,30.5344815,1.2010278,163.1604895),(20520,'PereDavidsDeer-radius.tif',243,3,58,207.0445504,67.705961,49.7464442,1.8,67.4848042,49.7212964,-0.8618799,46.7350117,13.9357367,4184.823568,9182.8088406,19.882622,658.9396049,89.5436508,281.2551114,19.8956524,30.4921784,1.1849137,160.0706475),(20521,'PereDavidsDeer-radius.tif',243,3,59,1.1850803,65.2287476,61.887574,1.8,66.3130012,62.5352671,1.3654106,41.1342361,31.3054614,26.4086056,38.0081537,0.1892981,1.2141062,0.6420104,1.3872139,2.0829914,5.9426102,0.2629947,16.3725798),(20522,'PereDavidsDeer-radius.tif',243,3,60,4.7015894,65.2691335,61.0042124,1.8,66.1083059,60.90502,-0.116209,31.1045855,8.3334877,10.3441399,38.0325638,0.0105346,4.5638231,0.33256,1.5496777,3.0538291,12.5955495,0.1939591,42.2602615),(20523,'PereDavidsDeer-radius.tif',243,3,61,15.5070352,65.8005288,61.0757651,1.8,66.228346,61.0391948,-0.1822371,31.164976,10.6995145,11.7014411,187.8189616,0.0848864,17.5539705,0.3754677,6.4002991,0.220703,0.3121212,2.3561945,0.6242424),(20524,'PereDavidsDeer-radius.tif',243,3,62,31.5719158,66.7654193,61.2686729,1.8,67.3919319,61.5133926,0.0211911,30.6723728,38.3195944,102.5251774,876.5404181,0.0023626,22.8744701,3.3425904,19.9958925,6.600245,19.4419176,0.0454233,46.7500548),(20525,'PereDavidsDeer-radius.tif',243,3,63,65.4453113,68.1668953,61.7543091,1.8,69.0719031,62.1226539,0.1275117,34.2839811,34.7600978,290.3077416,4474.4001261,0.1763892,128.7223113,8.4677372,97.8603039,9.2125048,22.0879493,0.0399787,58.7399444),(20526,'PereDavidsDeer-radius.tif',243,3,64,110.8533385,68.4350621,62.4033038,1.8,69.0881719,62.8791356,0.1480705,34.3054912,36.6283064,604.9304664,12302.963859,0.4021222,335.8867788,17.6336337,257.2079937,10.9567782,23.9185445,3.0584514,69.0085735),(20527,'PereDavidsDeer-radius.tif',243,3,65,170.5232451,68.3277901,63.8103879,1.8,68.8590433,64.9002455,0.1684513,34.6965369,29.1913344,3792.3051109,22831.3825178,0.7988574,782.1287721,109.29924,589.235396,13.728944,29.5395941,3.0292853,95.3376612),(20528,'PereDavidsDeer-radius.tif',243,3,66,269.7861717,69.2649825,66.9840617,1.8,69.8366779,68.2315953,0.2632298,25.8741607,25.5270413,13557.72366,42243.990941,3.04428,1654.872197,523.9869922,2066.1136382,17.5845677,31.2947205,3.0356083,137.8434986),(20529,'PereDavidsDeer-radius.tif',243,3,67,423.5817875,69.2930039,69.7982297,1.8,68.5139747,70.53319,0.211827,23.4485469,27.6761353,27790.1589169,70815.7539192,3.1206374,2558.7298618,1185.1548443,3529.5149503,33.4360586,50.9001604,3.0678138,342.3814376),(20530,'PereDavidsDeer-radius.tif',243,3,68,541.7814959,67.7144974,70.945582,1.8,67.1502817,71.5960146,0.1080482,22.3242365,27.2007155,36801.0218871,89776.6500363,1.050068,3300.5253131,1648.4784111,4305.8048002,34.3827278,54.337778,0.040628,291.4391404),(20531,'PereDavidsDeer-radius.tif',243,3,69,660.7655505,65.7952172,71.8063689,1.8,65.6672443,71.9406879,0.0019205,21.7695934,30.2036011,43821.50664,118915.202605,0.0004074,3937.1200216,2012.9685402,4945.5867246,35.2877039,56.3108472,0.1297025,221.5569429),(20532,'PereDavidsDeer-radius.tif',243,3,70,750.8331859,64.2707973,72.3241861,1.8,65.6459003,71.8871884,-0.0589958,31.2311505,32.2085133,44882.1406497,148789.2040921,0.4350411,4619.5613832,1437.0953336,5474.9689084,35.7068996,57.1190282,0.1473615,362.5881986),(20533,'PereDavidsDeer-radius.tif',243,3,71,719.6953484,64.2309152,72.0524557,1.8,65.6902402,71.7410607,-0.0701841,21.9090175,32.2336085,42703.2277793,148127.5106476,0.5898774,4595.4368042,1949.116508,5905.7114643,0.441406,0.795756,0.9827937,1.6898907),(20534,'PereDavidsDeer-radius.tif',243,3,72,677.2111204,64.2574943,71.6359827,1.8,65.5511668,71.5468847,-0.0814909,31.4793105,36.1926087,40951.2741914,142561.7018908,0.7478768,3938.9728222,1300.8948899,4586.1576091,30.7231357,56.5361657,0.1805518,206.2538173),(20535,'PereDavidsDeer-radius.tif',243,3,73,655.9433526,64.4678059,71.1923729,1.8,65.618027,71.3678872,-0.0896919,31.4411053,35.2814251,40541.5456442,138531.4754497,0.8771159,3926.4705186,1289.4440354,4545.3941157,30.4095623,55.8849459,0.1826793,180.0448264),(20536,'PereDavidsDeer-radius.tif',243,3,74,633.5239667,64.3422365,70.9253845,1.8,65.4953348,71.2261578,-0.095108,26.9293264,30.1996916,39592.5413871,130381.9115211,0.9522167,4317.3259289,1470.2388326,5172.4743469,0.441406,0.6242424,2.3561945,1.2484847),(20537,'PereDavidsDeer-radius.tif',243,3,75,597.1441708,64.2204247,70.7034054,1.8,65.1735289,70.9785884,-0.1096301,23.1965937,29.7957199,37764.3565269,119910.1535593,1.1913708,4024.4086705,1628.0130168,5030.9993295,30.0133312,53.8623854,0.2231134,165.4286826),(20538,'PereDavidsDeer-radius.tif',243,3,76,569.9542785,63.9248255,70.1862049,1.8,64.7547093,70.5556391,-0.1142976,23.9709354,28.8168279,37321.0505562,109180.7975233,1.2355804,3788.7861193,1556.9292555,5064.7084554,0.220703,0.9099818,1.815775,1.9484604),(20539,'PereDavidsDeer-radius.tif',243,3,77,539.9171056,63.2713109,70.1762046,1.8,64.1576693,70.345932,-0.0957044,24.0273624,26.9141548,34306.754813,102411.180649,0.8216996,3805.104834,1427.8202606,4023.3217914,0.441406,1.9985507,1.6814535,4.3383267),(20540,'PereDavidsDeer-radius.tif',243,3,78,514.8411455,62.7034972,70.0456044,1.8,63.7086635,70.1768247,-0.116594,24.1539642,33.2958087,32667.8900307,96777.1928103,1.1611974,2906.5878434,1352.4856551,3400.1063492,29.9699411,49.5344273,0.1475681,158.646938),(20541,'PereDavidsDeer-radius.tif',243,3,79,489.5814608,61.9021798,70.0851918,1.8,62.7695202,70.1416607,-0.1162304,25.081928,32.462997,30773.9111777,89043.618973,1.0973789,2742.926627,1226.9356332,3214.9311452,0.69641,1.8199636,1.3258177,4.4454298),(20542,'PereDavidsDeer-radius.tif',243,3,80,465.677813,61.8043944,70.0955276,1.8,62.4086049,70.0159115,-0.138812,32.0114347,25.2086609,28472.757743,79817.3310404,1.4859268,3166.2662081,889.4558462,3316.1139468,0.441406,0.6979242,1.8925469,1.6898907),(20543,'PereDavidsDeer-radius.tif',243,3,81,423.4685298,61.4520391,70.521213,1.8,62.1652111,69.9909679,-0.13676,23.5565879,36.5870837,24428.4937922,67669.4904531,1.3118338,1849.5458959,1037.0132508,2346.0521946,0.220703,0.4935069,2.0344439,1.0656484),(20544,'PereDavidsDeer-radius.tif',243,3,82,388.0129215,60.9391397,70.9983975,1.8,61.5709154,70.358377,-0.1303172,23.1231717,23.8008421,21023.3683921,58984.2093691,1.0920402,2478.2404377,909.190515,3106.6664915,29.4280804,44.0190462,3.020969,190.5774073),(20545,'PereDavidsDeer-radius.tif',243,3,83,366.4422524,60.5669275,71.1980218,1.8,61.2233995,70.5750617,-0.1331547,22.8630287,23.1270959,19193.1695261,53114.8603757,1.0764624,2296.6506691,839.4849941,2799.4638971,26.4843601,42.86925,0.4244971,139.880686),(20546,'PereDavidsDeer-radius.tif',243,3,84,355.3422008,60.2387508,71.1623567,1.8,60.7785186,70.4933542,-0.1349009,22.8716294,22.5003172,18925.7513803,48610.6548174,1.0712463,2160.4430924,827.4771788,2631.3740738,27.8955917,41.7752946,0.2782997,164.519883),(20547,'PereDavidsDeer-radius.tif',243,3,85,340.1625694,59.9742661,71.4004131,1.8,60.5347459,70.8424017,-0.1350946,22.7646076,33.1015596,17400.4990045,45147.9982255,1.0284121,1363.9235983,764.366306,1730.0226753,0.220703,0.4935069,2.0344439,1.0656484),(20548,'PereDavidsDeer-radius.tif',243,3,86,325.619782,59.727774,71.60126,1.8,60.2320475,71.1163528,-0.1257717,22.7825772,21.7809067,15957.3262069,42008.3053739,0.8539536,1928.6756948,700.4179591,2281.5617797,25.5780128,40.093906,0.1714834,118.9999369),(20549,'PereDavidsDeer-radius.tif',243,3,87,320.6153208,59.4411191,71.6874671,1.8,59.9637162,71.2610786,-0.1206993,22.4868162,31.8575255,15355.771742,39959.7491684,0.7746976,1254.3268354,682.8788748,1490.7846903,25.1601421,40.418186,0.2595472,156.8775082),(20550,'PereDavidsDeer-radius.tif',243,3,88,320.7440033,59.1470519,71.6696748,1.8,59.5809111,71.2819537,-0.1138307,22.5647716,20.9701284,15312.5162969,38422.6038388,0.6896829,1832.2541071,678.6027596,2013.1543457,25.5800424,39.1497513,0.1642219,105.2092478),(20551,'PereDavidsDeer-radius.tif',243,3,89,311.8722191,58.8755656,72.0001003,1.8,59.4122238,71.5785143,-0.0986377,15.2537953,20.8062358,13710.7519588,36906.6758102,0.5040839,1773.8276202,898.8420071,2207.0548908,24.4230162,38.6438287,0.1548204,104.4779024),(20552,'PereDavidsDeer-radius.tif',243,3,90,305.0446529,58.5243511,72.2316156,1.8,59.1214207,71.8291475,-0.0759703,14.0915229,20.3971078,12696.8174089,35327.4222171,0.2928628,1731.9819381,901.0252134,2303.1205134,23.6152211,38.1414122,0.1451704,101.4859755),(20553,'PereDavidsDeer-radius.tif',243,3,91,299.2000951,58.227581,72.4220936,1.8,58.8300069,72.043329,-0.0583096,20.0010298,20.7763301,11873.3232454,33763.6327609,0.1693555,1625.1009043,593.6355972,1856.2218666,22.7324091,37.5856627,0.1236267,100.1839392),(20554,'PereDavidsDeer-radius.tif',243,3,92,292.3527646,57.9725355,72.6136463,1.8,58.5191555,72.2943128,-0.0364269,20.6477189,20.6243432,11046.4215748,32133.6406964,0.0646265,1558.0443175,534.9947678,1773.5532855,21.9749805,37.070878,0.1073699,99.1182909),(20555,'PereDavidsDeer-radius.tif',243,3,93,286.9205723,57.7954299,72.7596153,1.8,58.2774764,72.5131127,-0.0139637,20.7182133,20.3674204,10256.0291493,30894.3570072,0.0093235,1516.85174,495.0247873,1709.901711,21.4081911,36.5868066,0.0966675,96.6213215),(20556,'PereDavidsDeer-radius.tif',243,3,94,282.7408717,57.6958965,72.8608846,1.8,58.1541885,72.64634,-0.0005037,19.1793331,37.4205472,9687.2094041,29916.6855217,0.000012,799.4721553,505.0858323,999.6411522,20.9667851,35.9502088,0.1045556,94.9536125),(20557,'PereDavidsDeer-radius.tif',243,3,95,278.8984644,57.6445826,72.9253311,1.8,58.056191,72.7065147,0.011139,20.5123547,34.7560455,9212.4849267,29023.7598555,0.0057675,835.0708329,449.1188385,1030.5754984,20.7460821,35.4673224,0.0934768,93.7586793),(20558,'PereDavidsDeer-radius.tif',243,3,96,275.3124921,57.6875571,72.9676818,1.8,58.0484666,72.838926,0.0187261,15.1161032,27.560928,8801.0431507,28044.6955305,0.0160886,1017.5526585,582.2296296,1181.730039,20.5054646,34.9889092,0.0820936,92.693031),(20559,'PereDavidsDeer-radius.tif',243,3,97,271.6606583,57.814804,72.9703514,1.8,58.1516147,72.8339996,0.0223322,20.9758006,19.1829499,8464.8937006,26908.2737692,0.0225771,1402.7182451,403.5552135,1552.5231866,20.2290346,34.5151552,0.0703963,91.6273826),(20560,'PereDavidsDeer-radius.tif',243,3,98,268.1326359,57.9180062,73.0641311,1.8,58.2285235,72.98172,0.0253329,20.8924906,18.6540658,8167.3187645,25868.4785042,0.028673,1386.7474647,390.9212604,1294.0065036,20.0385532,34.0598436,0.064844,90.4324494),(20561,'PereDavidsDeer-radius.tif',243,3,99,264.3549093,57.9922733,73.1713558,1.8,58.2690129,73.0737027,0.0301683,20.3074719,18.5663144,7873.6522044,24818.389705,0.0400876,1336.742938,387.7219312,1334.0919329,19.8476084,33.634587,0.0722425,89.3668011),(20562,'PereDavidsDeer-radius.tif',243,3,100,261.0873369,58.016692,73.2778284,1.8,58.2579283,73.2354346,0.0347747,19.1131259,42.5558266,7621.8506321,23978.1325136,0.0526002,563.4512223,398.7757243,722.8694431,19.6967115,33.3524517,0.0397142,88.6668254),(20563,'PereDavidsDeer-radius.tif',243,3,101,259.7828142,58.0452177,73.3505252,1.8,58.1773402,73.3377741,0.0357457,20.6718246,17.8861009,7471.0957273,23265.2000762,0.0552997,1300.7418567,361.4144313,1423.8532863,19.4877575,32.9742397,0.0736918,87.4718923),(20564,'PereDavidsDeer-radius.tif',243,3,102,258.9156615,58.0769368,73.4169841,1.8,58.2149182,73.3687254,0.0359651,20.4540557,22.2771008,7362.0400563,22661.6161705,0.0557932,1017.2605663,359.930576,1000.8054996,19.3709374,32.5901443,0.0949517,86.6648135),(20565,'PereDavidsDeer-radius.tif',243,3,103,259.115785,58.1204417,73.4778608,1.8,58.2202672,73.4331618,0.0349677,20.6197698,19.5111891,7309.7114068,22164.2914148,0.0527839,1135.9785048,354.5001461,1138.9249215,19.3666041,32.3312948,0.0820074,86.2769591),(20566,'PereDavidsDeer-radius.tif',243,3,104,260.5150556,58.1830659,73.5110562,1.8,58.2906433,73.4755889,0.033068,20.5949619,36.0188966,7308.9391756,21773.7867851,0.0474609,604.5101007,354.8896669,768.560478,19.2011611,31.9768108,0.1106572,85.287044),(20567,'PereDavidsDeer-radius.tif',243,3,105,263.3050652,58.2973065,73.459422,1.8,58.4455178,73.344852,0.0296928,20.1849729,17.8318398,7360.9158164,21339.1430746,0.03868,1196.6876836,364.6730598,1277.3468792,19.4711938,31.8738232,0.0762408,86.954753),(20568,'PereDavidsDeer-radius.tif',243,3,106,263.9404036,58.330236,73.4753695,1.8,58.5789691,73.2723948,0.0260058,12.6612632,17.5861351,7431.8574267,20989.0430132,0.0297438,1193.4994763,586.9759831,1568.7833103,19.931622,31.6537657,0.0767719,86.071941),(20569,'PereDavidsDeer-radius.tif',243,3,107,266.7766432,58.3734337,73.45347,1.8,58.6414211,73.1870165,0.0199688,20.5461188,16.671889,7629.4215241,20750.2805589,0.0177273,1244.6268445,371.3315207,1169.2023036,20.2073551,31.5882977,0.0419334,85.9962077),(20570,'PereDavidsDeer-radius.tif',243,3,108,264.6214849,58.2997094,73.6215257,1.8,58.4800636,73.447883,0.0301097,20.488057,26.4133123,7329.994272,20433.0633318,0.0399721,773.5895862,357.7691274,860.118539,19.6357025,31.2511085,0.0919387,86.954753),(20571,'PereDavidsDeer-radius.tif',243,3,109,267.6246368,58.35302,73.5724621,1.8,58.5850929,73.3626777,0.0148612,20.2178864,16.4623146,7669.0865381,20330.1495822,0.0098502,1234.9508636,379.3218731,1135.015531,19.9370655,31.0752647,0.1067357,84.7699047),(20572,'PereDavidsDeer-radius.tif',243,3,110,265.2229477,58.2880184,73.7106122,1.8,58.5360809,73.4948108,0.0219493,19.8604921,20.4394741,7473.0617249,20101.457628,0.0212928,983.4625659,376.2777721,1037.3328689,19.7167512,30.8802856,0.1146035,84.1456624),(20573,'PereDavidsDeer-radius.tif',243,3,111,264.6858851,58.276371,73.7861508,1.8,58.5677154,73.5689447,0.0222639,20.0181819,35.576336,7477.5394244,19971.1524453,0.0218629,561.3605758,373.5373902,731.4455805,19.8202511,30.8558266,0.1074977,83.8870927),(20574,'PereDavidsDeer-radius.tif',243,3,112,264.3345103,58.2578569,73.8538527,1.8,58.5296934,73.647986,0.0208317,17.4166698,16.9263514,7475.3526149,19805.1943201,0.0191157,1170.0805354,429.2067718,1124.1882694,19.8632701,30.6872424,0.1225709,83.8335412),(20575,'PereDavidsDeer-radius.tif',243,3,113,265.6306637,58.3158231,73.8557419,1.8,58.6200225,73.554182,0.0164371,19.869222,16.8201934,7537.5886925,19680.2489599,0.0119605,1170.0370195,379.3600325,1192.9593462,20.0458876,30.6364067,0.1082706,83.7578079),(20576,'PereDavidsDeer-radius.tif',243,3,114,266.8071533,58.3120135,73.9043697,1.8,58.5846629,73.5956445,0.010275,19.9868077,16.2850611,7606.4163547,19605.0435108,0.0046946,1203.866748,380.571848,1213.5635132,20.0102198,30.5719467,0.0867383,84.1456624),(20577,'PereDavidsDeer-radius.tif',243,3,115,268.5527507,58.3086484,73.9509051,1.8,58.5518682,73.6628107,0.0044354,19.8840852,18.0758798,7707.5683572,19598.1195445,0.0008803,1084.2138695,387.6249915,1191.4132417,20.0839731,30.3721331,0.0946072,84.0921108),(20578,'PereDavidsDeer-radius.tif',243,3,116,269.906913,58.3065051,74.0046639,1.8,58.5721591,73.6722747,-0.0011849,19.5652395,15.9301283,7778.5992791,19653.032566,0.0000631,1233.7020921,397.5724036,1217.9135699,20.0839731,30.3336183,0.0801201,84.2213957),(20579,'PereDavidsDeer-radius.tif',243,3,117,267.5416825,58.214462,74.1837573,1.8,58.4772342,73.9446129,0.0098061,18.4170512,16.3582884,7571.1834117,19551.944081,0.0042878,1195.2316562,411.0963972,1211.4946106,19.6663587,30.1524243,0.0952987,83.4678685),(20580,'PereDavidsDeer-radius.tif',243,3,118,269.0675839,58.1973262,74.2265124,1.8,58.4258125,73.9859154,0.0036086,19.5989677,15.9680816,7704.9870776,19609.8785087,0.0005844,1228.0672801,393.1322906,1290.1160879,19.7243251,30.1322243,0.0880074,83.7264381),(20581,'PereDavidsDeer-radius.tif',243,3,119,274.7947953,58.2879511,74.140381,1.8,58.522521,73.789393,-0.0222912,19.8301076,16.344613,8221.5546296,19931.5169641,0.0227536,1219.4548114,414.5995966,1306.408849,20.4913604,30.0966395,0.0733973,84.7920865),(20582,'PereDavidsDeer-radius.tif',243,3,120,273.1190301,58.1836952,74.324743,1.8,58.3583399,74.1059599,-0.00589,19.3067751,16.4198268,8015.270035,19815.5853914,0.0015792,1206.808428,415.1532301,1253.2462073,19.8632701,30.0034345,0.1179682,83.9850078),(20583,'PereDavidsDeer-radius.tif',243,3,121,275.0036719,58.2286723,74.3329016,1.8,58.3927332,74.1294476,-0.0082609,19.3213929,16.3789591,8097.5488455,19804.8428356,0.0031277,1209.1637052,419.0975714,1262.6833426,19.8632701,29.9351709,0.155452,84.297129),(20584,'PereDavidsDeer-radius.tif',243,3,122,274.812198,58.2263566,74.4091501,1.8,58.4141326,74.2051553,-0.0074096,19.0199434,16.1634327,8114.9745462,19783.2484681,0.0025147,1223.9509292,426.6560838,1256.5841244,19.8632701,29.9546907,0.1033343,84.4264138),(20585,'PereDavidsDeer-radius.tif',243,3,123,271.9281489,58.1150242,74.5756667,1.8,58.2549543,74.4536021,0.0081503,19.2698097,16.0354339,7912.2383562,19591.1860343,0.0030107,1221.7434325,410.6028282,1232.6505415,0.220703,0.3121212,2.3561945,0.6242424),(20586,'PereDavidsDeer-radius.tif',243,3,124,272.4451077,58.0753826,74.6388055,1.8,58.2110269,74.5261596,0.0077643,19.2110368,16.2921495,7998.8374864,19656.4724516,0.0027374,1206.4996345,416.3667779,1204.8178559,19.5352451,29.9123818,0.0886559,84.3728623),(20587,'PereDavidsDeer-radius.tif',243,3,125,273.1036939,58.0491498,74.6927917,1.8,58.2193467,74.5425069,0.0096593,18.9633172,37.3963453,8076.95557,19747.7821706,0.0042468,528.0671678,425.9252475,717.0500322,19.6999421,29.811249,0.1261915,84.6849834),(20588,'PereDavidsDeer-radius.tif',243,3,126,277.4927582,58.0724306,74.6317285,1.8,58.232752,74.2656084,-0.0026907,18.4810427,35.6960209,8518.3488764,20001.6742769,0.000335,560.3334423,460.9236069,761.6045693,20.1466427,29.811249,0.1261915,87.3647892),(20589,'PereDavidsDeer-radius.tif',243,3,127,278.8862279,58.0337107,74.6717017,1.8,58.213357,74.3309779,0.0011191,17.8149345,33.792218,8619.4718619,20091.4784195,0.0000581,594.5593271,483.8340475,800.4478198,20.7460821,29.811249,0.1261915,85.179941),(20590,'PereDavidsDeer-radius.tif',243,3,128,281.4829481,58.0281666,74.6636885,1.8,58.1862443,74.3328214,-0.0036074,18.2203697,35.5085122,8824.3475885,20238.0064792,0.0006106,569.9480278,484.3122129,778.3952872,20.9724159,29.7842768,0.1188403,85.4920621),(20591,'PereDavidsDeer-radius.tif',243,3,129,277.4767134,57.8946872,74.8276477,1.8,58.1817067,74.5056073,0.0331774,16.6419769,21.6468113,8475.8826544,19812.1366326,0.0508865,915.2450367,509.3074413,1059.8723625,20.9056384,29.758917,0.1114762,85.5456137),(20592,'PereDavidsDeer-radius.tif',243,3,130,279.377149,57.8817974,74.8108513,1.8,58.1279615,74.4918469,0.0268527,18.5190456,22.2169111,8737.6157869,19850.5610982,0.0335671,893.4887931,471.8178228,1054.7018361,21.3013558,29.7130508,0.0967123,85.5456137),(20593,'PereDavidsDeer-radius.tif',243,3,131,278.7683206,57.820348,74.8547701,1.8,58.0657943,74.5867548,0.0285445,18.0850729,16.3218663,8746.2105768,19785.3985097,0.0378457,1212.2019743,483.6148915,1219.381387,21.0592513,29.6515118,0.1418971,85.3092258),(20594,'PereDavidsDeer-radius.tif',243,3,132,278.7924246,57.7799674,74.8928833,1.8,58.0718127,74.6918248,0.0315632,17.8779792,16.3378714,8774.3020665,19805.3146886,0.0462752,1212.2334826,490.7882477,1382.6478249,20.6957276,29.592314,0.1271302,85.2556743),(20595,'PereDavidsDeer-radius.tif',243,3,133,274.6604153,57.6358559,75.0630854,1.8,57.9536515,74.8380273,0.0587545,18.0961241,16.2960301,8471.0700333,19642.7606664,0.1578433,1205.3709093,468.1151596,1422.7703186,20.3885322,29.592314,0.1271302,84.9435531),(20596,'PereDavidsDeer-radius.tif',243,3,134,288.3928191,57.9575492,74.6257415,1.8,58.2159851,74.3908925,-0.0188236,18.1256282,16.2212439,9849.8089902,20572.1260299,0.0170288,1268.2212388,543.4189019,1309.3587001,21.8495971,29.6038339,0.3500449,86.8920134),(20597,'PereDavidsDeer-radius.tif',243,3,135,287.9612944,57.9010991,74.6385174,1.8,58.1868912,74.3877674,-0.0186235,18.3578778,16.7067116,9921.6093888,20603.2953027,0.0166436,1233.2346275,540.4551384,1508.4696647,21.8495971,29.6038339,0.3500449,86.8920134),(20598,'PereDavidsDeer-radius.tif',243,3,136,281.5599834,57.6697407,74.8673063,1.8,57.9634282,74.6561629,0.0251945,17.2656725,21.2669465,9407.2172716,20180.4365978,0.0297808,948.910864,544.8509037,1080.1101183,21.3856248,29.6268604,0.0596307,86.504159),(20599,'PereDavidsDeer-radius.tif',243,3,137,277.490426,57.5439587,75.0114707,1.8,57.9194531,74.7562079,0.0590679,18.1954752,16.3515573,8953.0304205,19882.7673964,0.1611737,1215.9555871,492.0470781,1260.3454254,20.8767596,29.5346468,0.1651487,85.6970803),(20600,'PereDavidsDeer-radius.tif',243,3,138,278.1113285,57.5221857,75.0368078,1.8,57.942479,74.7884884,0.0610331,18.4834184,35.5874423,9031.0141624,19908.2056346,0.1724484,559.4165907,488.6008621,786.6270061,20.9835454,29.4999923,0.2649397,85.8263651),(20601,'PereDavidsDeer-radius.tif',243,3,139,283.4582639,57.6311222,74.8679245,1.8,58.0282523,74.6472303,0.0306522,18.9972089,32.5639013,9668.4828766,20208.7577541,0.0443735,620.5877343,508.9422826,864.8160191,21.6018971,29.5478378,0.2413555,86.4506074),(20602,'PereDavidsDeer-radius.tif',243,3,140,280.4171478,57.5061684,75.0013253,1.8,57.897046,74.8028438,0.0584935,18.9273428,44.0582837,9381.890228,20017.0100362,0.1597248,454.3302265,495.6792053,659.0899415,21.1874881,29.445453,0.2267988,85.7728136),(20603,'PereDavidsDeer-radius.tif',243,3,141,280.6686381,57.4864778,75.00369,1.8,57.8590329,74.8126163,0.0615443,18.969496,16.9139664,9429.1819958,20106.3358322,0.1769578,1188.74162,497.0707716,1263.5696763,21.1874881,29.453723,3.0590737,85.9556499),(20604,'PereDavidsDeer-radius.tif',243,3,142,280.9719378,57.4487533,74.9787815,1.8,57.7456142,74.7608491,0.0641717,19.0119382,19.2492164,9502.8558282,20186.692525,0.1925763,1048.7020431,499.8362466,1123.4958485,0.441406,0.6242424,2.3561945,1.2484847),(20605,'PereDavidsDeer-radius.tif',243,3,143,281.0216661,57.4182262,74.9778378,1.8,57.7176336,74.7599681,0.0687484,19.0214894,26.7458824,9534.1729028,20271.3170297,0.2210187,757.9229096,501.2316714,1001.6567969,0.3121212,0.6242424,2.3561945,1.2484847),(20606,'PereDavidsDeer-radius.tif',243,3,144,280.7018936,57.3606566,74.972201,1.8,57.6652867,74.694734,0.0741338,18.5893139,26.6698086,9555.3221482,20291.7026676,0.2566443,760.8492044,514.0223145,1003.9681016,0.220703,0.3121212,2.3561945,0.6242424),(20607,'PereDavidsDeer-radius.tif',243,3,145,283.0642458,57.3431901,74.85486,1.8,57.6884735,74.4735039,0.0825252,18.3702385,17.4967588,9871.3849519,20107.8203083,0.3205689,1149.231155,537.3574731,1186.0705797,22.5117061,29.565142,3.0218673,87.1819528),(20608,'PereDavidsDeer-radius.tif',243,3,146,289.2729168,57.5596866,74.6555655,1.8,57.9221092,74.3172251,0.0226299,18.6202056,22.6973302,10445.8006986,20828.5368641,0.0246859,917.6646201,560.9927701,1131.6964362,22.2910031,29.7130508,3.0448804,87.8819285),(20609,'PereDavidsDeer-radius.tif',243,3,147,288.9300588,57.5398023,74.6409564,1.8,57.9320629,74.2707328,0.0285083,18.700274,24.5622253,10470.8007304,20803.2140873,0.0391259,846.959665,559.9276625,1083.6289456,22.8777513,30.0626329,2.5759896,146.826891),(20610,'PereDavidsDeer-radius.tif',243,3,148,288.2005186,57.5030291,74.6399954,1.8,57.927472,74.3153659,0.0318935,16.8884611,24.6501664,10487.4285843,20838.9303119,0.0488431,845.3870044,620.9818951,1084.2679368,22.4311312,29.758917,3.0301164,88.3233345),(20611,'PereDavidsDeer-radius.tif',243,3,149,288.1350703,57.4763081,74.6427284,1.8,57.9188651,74.3612172,0.0363238,18.1520788,24.5227352,10548.3662633,20920.7620576,0.063334,853.11699,581.1106489,1095.4085978,22.4260517,29.758917,3.0301164,88.3233345),(20612,'PereDavidsDeer-radius.tif',243,3,150,287.2556811,57.4273768,74.6445607,1.8,57.80525,74.40994,0.0366082,18.8118264,24.4278063,10587.9782585,20971.2351446,0.0641329,858.4985022,562.8362728,1087.9420649,22.4260517,29.7842768,3.0227523,88.269783),(20613,'PereDavidsDeer-radius.tif',243,3,151,281.3352393,57.2392085,74.8354803,1.8,57.6044212,74.5355008,0.0790958,18.6296457,23.8212238,9947.6813566,20663.0663345,0.2927349,867.422535,533.9705054,1086.2537068,22.0703001,29.7891826,2.9703539,87.6455406),(20614,'PereDavidsDeer-radius.tif',243,3,152,280.1445205,57.1888471,74.8317501,1.8,57.495598,74.5093424,0.0805273,18.4044447,23.2924376,9897.5267365,20617.1148805,0.3021188,885.1420034,537.7791559,1074.2463306,22.0703001,29.752369,2.9776635,87.7748254),(20615,'PereDavidsDeer-radius.tif',243,3,153,282.2422455,57.2633318,74.7096116,1.8,57.6370044,74.252506,0.0814825,18.3514555,25.1601508,10070.5267343,20624.8105308,0.3116293,819.7411323,548.7590201,1070.0861777,22.2910031,29.8757199,2.9181161,87.9576618),(20616,'PereDavidsDeer-radius.tif',243,3,154,290.0747542,57.4667781,74.4121271,1.8,57.8111498,74.0580394,0.0334066,18.3205342,25.8123093,10963.7739052,21058.5656379,0.0539338,815.8342367,598.4418245,1072.5936222,0.3121212,0.6242424,2.3561945,1.2484847),(20617,'PereDavidsDeer-radius.tif',243,3,155,289.067878,57.4441954,74.4020737,1.8,57.7882394,74.0408034,0.0425086,18.1665275,27.0639123,10929.3328683,20974.6517934,0.0870043,775.0044263,601.6192608,1038.9751139,0.220703,0.3121212,2.3561945,0.6242424),(20618,'PereDavidsDeer-radius.tif',243,3,156,282.6663752,57.288627,74.6051881,1.8,57.6567882,74.190151,0.0846759,18.3760258,27.7892588,10195.0205657,20707.8562097,0.3369807,745.174829,554.8000785,1005.3443317,22.5061998,30.0836892,2.8894967,92.3273583),(20619,'PereDavidsDeer-radius.tif',243,3,157,282.2096542,57.2808598,74.5658617,1.8,57.6537778,74.0965576,0.0886974,18.5965068,29.9927946,10230.0328713,20687.5083082,0.3690655,689.7492753,550.1050815,954.7485645,22.5651801,30.0836892,2.8894967,91.810219),(20620,'PereDavidsDeer-radius.tif',243,3,158,281.9457504,57.2828453,74.5320839,1.8,57.6078208,74.0722824,0.0948048,18.5735697,17.4841027,10248.061284,20622.8772443,0.4210894,1179.5216259,551.7550729,1233.3118449,22.541935,30.0431833,2.8663202,90.6152858),(20621,'PereDavidsDeer-radius.tif',243,3,159,286.5567247,57.3928946,74.3258673,1.8,57.6929314,73.819207,0.0807439,18.595178,16.1392435,10854.0139739,20686.6072512,0.3106954,1281.7581684,583.7004622,1377.6746006,0.220703,0.4935069,2.0344439,1.0656484),(20622,'PereDavidsDeer-radius.tif',243,3,160,285.4437498,57.3905646,74.3098568,1.8,57.7098288,73.8811341,0.089874,19.1099978,16.0860932,10852.6825103,20576.0554838,0.3832377,1279.1207401,567.9060058,1397.6802755,0.441406,0.795756,2.1587989,1.6898907),(20623,'PereDavidsDeer-radius.tif',243,3,161,285.3924421,57.4363755,74.218718,1.8,57.7889804,73.7660011,0.0971189,18.9624021,16.3272737,10848.7302343,20332.8873,0.4472319,1245.3326668,572.1179289,1379.0179146,25.0748512,29.9782601,2.6087488,141.0664312),(20624,'PereDavidsDeer-radius.tif',243,3,162,284.0702511,57.463208,74.1593101,1.8,57.7882903,73.6817603,0.1027987,19.0962004,18.6730973,10810.1821667,20137.9417055,0.4985618,1078.4467844,566.090737,1408.2176843,22.8854594,29.7130508,2.8785979,90.044595),(20625,'PereDavidsDeer-radius.tif',243,3,163,282.3280929,57.490522,74.1062389,1.8,57.8084172,73.7135844,0.1072118,19.0370014,16.8566324,10808.8338643,19931.9487354,0.5387947,1182.439541,567.7802729,1366.614802,22.9156182,29.7130508,2.8785979,89.3981708),(20626,'PereDavidsDeer-radius.tif',243,3,164,281.0850332,57.522104,74.0642634,1.8,57.8102399,73.6646211,0.113097,19.0458786,17.7413448,10818.4929177,19788.9032039,0.5966723,1115.4116779,568.0227804,1334.1317521,22.9090247,29.7105917,2.9092259,88.82748),(20627,'PereDavidsDeer-radius.tif',243,3,165,280.3910512,57.5694163,74.0134274,1.8,57.8435839,73.5824639,0.121463,18.8609622,17.7527463,10831.3055462,19609.7539704,0.6860634,1104.6039687,574.2711007,1326.5118211,22.9717077,29.4999923,2.8766529,88.0204013),(20628,'PereDavidsDeer-radius.tif',243,3,166,279.2795375,57.5915215,74.0042946,1.8,57.8372316,73.6796662,0.1317295,18.8594617,17.1417506,10768.6512982,19451.1168795,0.8030458,1134.7217261,570.9946283,1324.4400225,22.908307,29.445453,2.9147938,87.5789953),(20629,'PereDavidsDeer-radius.tif',243,3,167,279.6824414,57.6666251,73.9148313,1.8,57.8678603,73.6332512,0.1273552,19.3384845,16.5400758,10920.3211402,19360.5868779,0.7519667,1170.525883,564.6937413,1332.4429037,22.9440422,29.2870471,2.8746797,87.5789953),(20630,'PereDavidsDeer-radius.tif',243,3,168,280.2831073,57.7391099,73.7823723,1.8,57.9300047,73.4330961,0.1340695,19.1498777,18.6758473,11219.8588788,19183.4291337,0.8346446,1027.1785146,585.8971563,1263.6458307,23.1668234,29.1545239,2.7287487,87.944668),(20631,'PereDavidsDeer-radius.tif',243,3,169,280.4611195,57.8449608,73.6714592,1.8,58.1024582,73.2460389,0.1490977,19.2101694,16.0065102,11259.6848312,18945.2165207,1.0314373,1183.5944414,586.1314706,1518.6544662,0.4681818,0.9363635,2.3561945,1.8727271),(20632,'PereDavidsDeer-radius.tif',243,3,170,280.4386392,57.8805263,73.621899,1.8,58.1527647,73.2424625,0.1578531,19.4054981,25.0801929,11329.3390939,18776.8829599,1.1550025,748.6737845,583.8210907,1060.33407,23.4156168,28.952499,2.7256903,87.1911408),(20633,'PereDavidsDeer-radius.tif',243,3,171,280.9767203,57.9239134,73.5328667,1.8,58.1845212,73.2371084,0.1598178,19.5096735,22.7510776,11536.4621996,18651.1757912,1.1859558,819.79307,591.3201071,1126.1102264,23.555614,28.8412466,2.7155985,87.1375893),(20634,'PereDavidsDeer-radius.tif',243,3,172,282.1259176,57.9754323,73.4422709,1.8,58.2590226,73.1536597,0.1631368,19.830162,26.8278772,11774.5196457,18646.9983882,1.2403365,695.0605248,593.768203,1019.2142965,23.6771841,28.776997,2.739722,87.3204257),(20635,'PereDavidsDeer-radius.tif',243,3,173,282.2825566,58.0006936,73.3856506,1.8,58.2891873,73.158003,0.1693671,20.2276418,26.893512,11873.6663809,18632.5575164,1.3367012,692.8272328,587.0020098,1021.6342647,23.7163683,28.6404134,2.7124141,86.8790197),(20636,'PereDavidsDeer-radius.tif',243,3,174,281.9462079,58.0227889,73.3272323,1.8,58.280391,73.0781801,0.1723152,20.213324,38.5946544,11948.1411421,18599.2843781,1.381527,481.9134838,591.1022424,779.9336927,0.441406,0.6242424,2.3561945,1.2484847),(20637,'PereDavidsDeer-radius.tif',243,3,175,282.5945061,58.066202,73.2636366,1.8,58.3099602,73.0247312,0.1720597,20.2057099,15.1263808,12112.773495,18593.8547584,1.380641,1229.2335475,599.4728014,1414.5370739,0.4940669,0.9363635,2.3561945,1.8727271),(20638,'PereDavidsDeer-radius.tif',243,3,176,283.2368704,58.0937933,73.2196893,1.8,58.2995775,72.9900041,0.1719094,20.3385712,15.324433,12236.185652,18600.6160026,1.3813866,1213.788203,601.6246445,1447.9485901,0.220703,0.6979242,1.8925469,1.5070544),(20639,'PereDavidsDeer-radius.tif',243,3,177,282.9638593,58.1754664,73.1407154,1.8,58.4090303,72.9244508,0.1783605,20.4990777,25.2441607,12229.61059,18502.6478683,1.4844537,732.9476335,596.5932111,955.4087988,24.0064654,28.4398747,2.7091849,86.1254925),(20640,'PereDavidsDeer-radius.tif',243,3,178,285.4268637,58.2637529,72.9431264,1.8,58.5246023,72.6667277,0.1575537,20.6499504,26.8687538,12803.3296843,18478.9600691,1.1711285,687.7490555,620.0174551,941.8875492,24.3054169,28.4398747,2.7091849,87.1911408),(20641,'PereDavidsDeer-radius.tif',243,3,179,285.2506375,58.2900984,72.881089,1.8,58.5279134,72.5978586,0.1584686,20.7191028,26.8672642,12896.313374,18436.9752225,1.1839224,686.2245102,622.4358997,944.8001641,24.4335581,28.3334864,2.6988479,86.8790197),(20642,'PereDavidsDeer-radius.tif',243,3,180,284.9733605,58.3156484,72.8277509,1.8,58.5182922,72.5841826,0.1579099,20.9567577,19.2983994,13033.2710185,18467.2449253,1.1745158,956.9314284,621.9125691,1478.1895091,24.5989571,28.2396368,2.7059098,87.061856),(20643,'PereDavidsDeer-radius.tif',243,3,181,284.6635661,58.3297967,72.7781355,1.8,58.5289077,72.5874751,0.1610105,20.837417,19.767241,13175.7260964,18540.0644537,1.2193636,937.9186741,632.3109106,1348.279677,24.659284,28.2396368,2.7059098,87.1911408),(20644,'PereDavidsDeer-radius.tif',243,3,182,286.9803525,58.3750417,72.6477082,1.8,58.5535252,72.4733255,0.1441619,21.137625,19.1155274,13648.4687247,18680.2565248,0.9871679,977.2294622,645.6954693,1336.8582334,0.220703,0.3121212,2.3561945,0.6242424),(20645,'PereDavidsDeer-radius.tif',243,3,183,287.2738808,58.3774085,72.6062899,1.8,58.5293307,72.5085707,0.1459837,21.1438561,19.1068238,13862.0215262,18803.4317993,1.0131327,984.1212726,655.605176,1385.7551305,0.220703,0.3121212,2.3561945,0.6242424),(20646,'PereDavidsDeer-radius.tif',243,3,184,288.3108685,58.3933549,72.5680635,1.8,58.5172243,72.5545802,0.1503259,21.043465,16.8761186,14093.3986252,18946.0700546,1.0777144,1122.6556578,669.7280436,1395.9990994,25.1283446,28.2534324,2.6360116,88.1275044),(20647,'PereDavidsDeer-radius.tif',243,3,185,288.245184,58.4222303,72.4638465,1.8,58.5580622,72.4171389,0.1530374,21.0421691,22.0175924,14158.8576951,18961.9689544,1.1163819,861.2190031,672.8801403,1477.4308841,25.1797531,28.2396368,2.7059098,88.0739528),(20648,'PereDavidsDeer-radius.tif',243,3,186,288.1322068,58.4217945,72.4186913,1.8,58.4824863,72.282084,0.1492642,20.7619058,37.1717521,14192.0980417,19058.1212672,1.0619997,512.7044105,683.5643224,871.8937722,25.2734897,28.2577421,2.7233683,88.2567892),(20649,'PereDavidsDeer-radius.tif',243,3,187,286.962507,58.4152822,72.3691954,1.8,58.458151,72.2352402,0.1586061,20.3997984,22.014724,14270.5099444,19016.3775389,1.1930783,863.8026794,699.5417126,1507.8445709,25.247102,28.3480955,2.7162538,88.386074),(20650,'PereDavidsDeer-radius.tif',243,3,188,290.0884225,58.4924043,72.181233,1.8,58.5747671,72.039854,0.1349741,20.5982728,15.715879,14961.0021036,19171.5701928,0.8754697,1219.8853245,726.3231365,1581.2256916,0.4193881,0.9870138,2.0344439,2.1312967),(20651,'PereDavidsDeer-radius.tif',243,3,189,290.4189997,58.4924921,72.1259213,1.8,58.648662,71.9534648,0.1617591,20.2753704,21.6182141,15199.447907,19271.814862,1.2555092,891.4619285,749.6508121,1574.1068146,0.441406,0.9870138,2.0344439,2.1312967),(20652,'PereDavidsDeer-radius.tif',243,3,190,290.6617517,58.4797777,72.0595999,1.8,58.6230873,71.8880918,0.1821244,21.3153172,22.2569261,15439.2532872,19379.6474305,1.5891528,870.7243451,724.3266975,1561.3254884,0.3121212,0.6242424,2.3561945,1.2484847),(20653,'PereDavidsDeer-radius.tif',243,3,191,290.0843633,58.4395792,72.0244672,1.8,58.5912018,71.8792784,0.2051235,21.6476134,20.7054789,15642.0677225,19472.8031432,2.0058764,940.4662058,722.5770091,1380.4329383,26.0599216,28.4398747,2.7091849,90.3880859),(20654,'PereDavidsDeer-radius.tif',243,3,192,292.062646,58.482702,71.8596592,1.8,58.6473798,71.6819041,0.1863068,21.7860137,19.5852771,16224.9232827,19638.9649402,1.6701355,1002.7412361,744.7403422,1426.7912379,26.5175418,28.5330657,2.7021618,91.0123283),(20655,'PereDavidsDeer-radius.tif',243,3,193,291.3167364,58.4979387,71.7561525,1.8,58.688835,71.5661861,0.2274935,22.2300996,39.6552369,16319.906243,19640.7902263,2.4697158,495.2886878,734.1355446,896.7299771,26.4438009,28.553544,2.6329926,91.1416131),(20656,'PereDavidsDeer-radius.tif',243,3,194,285.2432129,58.3080626,71.9095923,1.8,58.5924629,71.7267846,0.3651119,25.0918485,39.3486488,15567.5953891,19572.1103743,6.0608207,497.4023498,620.4244142,892.7057278,25.9356631,28.5799734,2.6157417,91.0123283),(20657,'PereDavidsDeer-radius.tif',243,3,195,289.2503037,58.4084241,71.6867953,1.8,58.6421163,71.4873987,0.3347597,25.2550783,39.9653012,16418.1246717,19794.8341001,5.2036129,495.300511,650.0920127,905.1940704,0.5890486,1.8199636,1.815775,4.0797571),(20658,'PereDavidsDeer-radius.tif',243,3,196,289.0187254,58.3551708,71.6393436,1.8,58.5711533,71.3776679,0.3884991,23.0044761,19.0502074,16528.0893384,19921.5725479,6.9118482,1045.7404569,718.472755,1576.1433228,0.3950294,0.795756,2.1587989,1.6898907),(20659,'PereDavidsDeer-radius.tif',243,3,197,288.7916048,58.30775,71.5826355,1.8,58.531319,71.3373747,0.433483,22.5480567,17.350818,16659.2386534,20152.946935,8.4918567,1161.498378,738.8325688,1632.1174113,0.3121212,0.6242424,2.3561945,1.2484847),(20660,'PereDavidsDeer-radius.tif',243,3,198,288.4745482,58.2683008,71.5243273,1.8,58.544353,71.2854693,0.4800093,16.0198129,15.7488311,16748.3926143,20402.7956539,10.2527528,1295.5117421,1045.4799124,1659.1221096,0.4193881,1.188522,1.9513027,2.5727027),(20661,'PereDavidsDeer-radius.tif',243,3,199,293.3831838,58.380256,71.2299168,1.8,58.6264389,71.0379127,0.475297,16.6136707,16.4395554,17952.2348965,20680.8102343,10.2390794,1257.9908492,1080.570046,1741.0293357,0.3121212,0.6242424,2.3561945,1.2484847),(20662,'PereDavidsDeer-radius.tif',243,3,200,295.9522575,58.4300505,71.0223571,1.8,58.6578985,70.8454846,0.5090226,22.2767701,23.7787569,18691.3926259,20970.0989326,11.7140224,881.8837328,839.0530832,1518.8588714,0.441406,1.188522,1.9513027,2.5727027),(20663,'PereDavidsDeer-radius.tif',243,3,201,294.4256772,58.398123,70.9258855,1.8,58.6721559,70.7202975,0.58536,21.8743315,24.9802848,18553.5351591,21193.0771731,14.979184,848.392135,848.1875293,1501.3819512,0.5205468,2.0937725,1.8925469,4.5211631),(20664,'PereDavidsDeer-radius.tif',243,3,202,296.9041802,58.4833094,70.6968594,1.8,58.7856745,70.398277,0.5859859,21.6205335,42.5247299,19347.1891717,21486.1714518,15.1338156,505.2629728,894.8525318,935.8464255,0.6894551,2.5164014,1.8370484,5.5868114),(20665,'PereDavidsDeer-radius.tif',243,3,203,298.4595436,58.4931928,70.4833876,1.8,58.8271475,70.2044774,0.6746762,19.2798188,42.720949,19914.3905889,21791.0558187,19.4088586,510.0789268,1032.9137833,922.6263709,1.752853,13.0289564,2.0268683,31.3765781),(20666,'PereDavidsDeer-radius.tif',243,3,204,296.8229971,58.4125259,70.4100697,1.8,58.6927398,70.154694,0.7437413,20.2227128,24.0757273,19937.5551689,22168.979323,22.6768494,920.8020619,985.8991413,1656.9502325,2.2014995,13.0289564,2.0268683,35.0149291),(20667,'PereDavidsDeer-radius.tif',243,3,205,301.3520505,58.5069303,70.1060681,1.8,58.7515354,69.874991,0.8603045,25.5997344,26.7543258,21164.5867868,22695.0647214,28.8608078,848.2764571,826.7502502,1625.1895513,0.9611968,3.9787799,1.9100889,9.4079989),(20668,'PereDavidsDeer-radius.tif',243,3,206,301.2814212,58.4250337,70.0329064,1.8,58.6426359,69.8329572,0.8770995,24.9354004,24.5768343,21270.3598896,23218.4085303,29.6856673,944.727392,853.018582,1677.6420131,0.441406,1.3958483,1.8925469,3.1969451),(20669,'PereDavidsDeer-radius.tif',243,3,207,300.8939568,58.3194134,69.9582478,1.8,58.4891322,69.7032019,0.8792973,25.5910418,25.8712877,21325.8564631,23726.024072,29.7558111,917.0793649,833.3328745,1673.9725902,0.441406,1.188522,1.9513027,2.5727027),(20670,'PereDavidsDeer-radius.tif',243,3,208,303.709576,58.2998153,69.7719351,1.8,58.4827797,69.4755762,0.9474542,24.3402696,17.1029962,21888.5783518,24388.5856908,33.3692597,1425.9832283,899.2742788,1739.6314947,0.6068087,3.5655661,1.9513027,7.9009445),(20671,'PereDavidsDeer-radius.tif',243,3,209,310.4340544,58.5075613,69.4078493,1.8,58.731508,69.0942069,1.0549421,19.8191165,18.6451591,23614.6960155,24983.7072939,39.1497017,1339.9567794,1191.511033,1995.2739408,5.1588981,23.0420698,2.2066348,67.747095),(20672,'PereDavidsDeer-radius.tif',243,3,210,306.1586316,58.4055585,69.5156477,1.8,58.7252997,69.3452357,0.8013772,21.3050994,27.6082738,23113.3601508,25139.8659968,26.328434,910.5917383,1084.8745511,1721.8176362,0.9563948,4.6557349,1.665748,10.7322169),(20673,'PereDavidsDeer-radius.tif',243,3,211,307.0217548,58.3378776,69.373938,1.8,58.6557765,69.1530797,0.8868759,20.8102665,28.8444462,23281.5196471,25813.2401607,30.7422166,894.9119685,1118.7516359,1701.3532648,0.9970926,1.7237455,2.4468544,4.316145),(20674,'PereDavidsDeer-radius.tif',243,3,212,305.8000241,58.2542464,69.3374525,1.8,58.5652591,69.1489677,0.86835,21.7039657,19.1106335,23241.7520153,26418.9155407,29.6917454,1382.4196604,1070.8527785,2015.9342295,1.9750638,15.8230353,1.9720251,38.7290135),(20675,'PereDavidsDeer-radius.tif',243,3,213,306.2069134,58.201331,69.2501462,1.8,58.5086966,69.1148902,0.8662869,27.6381663,29.3067867,23487.6968346,27087.8618328,29.6273755,924.2863133,849.8283358,1725.2868944,0.220703,0.3121212,2.3561945,0.6242424),(20676,'PereDavidsDeer-radius.tif',243,3,214,310.2896225,58.2161701,69.0891188,1.8,58.5112782,69.0499693,0.922983,26.6913331,30.9445093,24380.8593409,28221.5594726,32.8832065,912.0053966,913.4373049,1674.3207339,2.2209671,15.3305204,2.0988708,39.4381772),(20677,'PereDavidsDeer-radius.tif',243,3,215,312.4646485,58.2177518,69.0037673,1.8,58.5632916,69.0490822,0.9255244,29.2813415,33.6108962,25174.9851936,29162.9627717,33.2409877,867.663945,859.7620148,1542.2693737,0.6242424,0.795756,0.5880026,1.8727271),(20678,'PereDavidsDeer-radius.tif',243,3,216,317.2193316,58.2259877,68.7391348,1.8,58.5025083,68.7517692,0.986396,29.4559978,33.6732489,26374.1810191,30189.4123163,36.7777685,896.5399338,895.375577,1532.9881662,0.4298022,1.103515,2.2142974,2.3141331),(20679,'PereDavidsDeer-radius.tif',243,3,217,317.6243316,58.2276305,68.5319716,1.8,58.4803647,68.4332091,0.970844,31.1087011,34.0738208,26919.23168,30799.6736896,36.0621835,903.9101869,865.3280503,1559.650253,0.3955897,1.103515,2.2142974,2.3141331),(20680,'PereDavidsDeer-radius.tif',243,3,218,318.5901439,58.2152905,68.3006415,1.8,58.4364492,68.1462668,0.9958982,31.7421386,30.1141267,27614.0332213,31561.2904659,37.3991203,1048.0559781,869.9487322,1849.399269,2.2737556,14.3456951,1.9655874,46.7148793),(20681,'PereDavidsDeer-radius.tif',243,3,219,318.0570223,58.1614442,68.1562345,1.8,58.4008263,67.9885439,0.9817665,29.0803664,29.5998851,28005.0586402,32284.7349297,36.6486035,1090.7047398,963.0228946,2013.0506037,0.220703,0.3121212,2.3561945,0.6242424),(20682,'PereDavidsDeer-radius.tif',243,3,220,319.4529718,58.1417925,67.9307928,1.8,58.3473328,67.7256089,0.987727,28.4667229,34.7427589,28947.9991416,33111.1710004,37.1019114,953.0380455,1016.906625,1648.2460861,2.1998508,15.306672,2.0021971,42.5815707),(20683,'PereDavidsDeer-radius.tif',243,3,221,320.0896681,58.0937574,67.7970349,1.8,58.3699544,67.7320444,0.9460403,28.0200505,35.5245381,29666.4392596,34044.3486292,35.0974422,958.3333234,1058.7575211,1704.8367913,0.441406,0.795756,2.1587989,1.6898907),(20684,'PereDavidsDeer-radius.tif',243,3,222,323.0256744,58.0904225,67.5553842,1.8,58.3289155,67.4422875,0.9636833,26.5644346,29.2690633,30932.9961909,35033.7047251,36.3151445,1196.9533962,1164.4515182,2253.0239663,1.9428832,15.4964314,2.0280746,47.8340792),(20685,'PereDavidsDeer-radius.tif',243,3,223,324.0165796,57.9675633,67.3953505,1.8,58.1928572,67.4238733,0.9205245,26.8412955,29.1926417,31549.2600613,36132.077969,34.2100761,1237.7118296,1175.4000514,2315.0154683,2.6259799,17.7731018,2.0066733,53.6259087),(20686,'PereDavidsDeer-radius.tif',243,3,224,329.5731886,58.0322703,67.0624664,1.8,58.3266866,67.0980529,0.9601171,21.779678,28.6365976,33482.0325894,37394.1329549,36.8674222,1305.8161971,1537.3061348,2467.4278473,2.2453015,16.4834264,2.028456,50.7189031),(20687,'PereDavidsDeer-radius.tif',243,3,225,328.7462583,57.9949792,66.9251822,1.8,58.3692701,66.974282,0.886274,22.3886686,28.8784171,33932.096542,38248.4980586,32.8851971,1324.466569,1515.5924245,2483.5098562,0.3950294,0.795756,2.5535901,1.5606059),(20688,'PereDavidsDeer-radius.tif',243,3,226,326.5089575,57.9161671,66.8687854,1.8,58.2642458,66.960712,0.8276521,22.2548183,28.5822396,34078.1942929,39102.5158814,29.5057262,1368.0703988,1531.272639,2520.4288541,2.7436513,21.8138988,2.0434935,67.1450344),(20689,'PereDavidsDeer-radius.tif',243,3,227,331.8262242,58.0225661,66.5124165,1.8,58.3254847,66.6924326,0.8332996,22.6373744,28.8028503,36253.2844674,40114.9165922,30.2972944,1392.7412101,1601.4792079,2608.2017369,2.7995941,21.2207972,2.0344439,70.6854704),(20690,'PereDavidsDeer-radius.tif',243,3,228,332.2643468,57.9114832,66.337319,1.8,58.1521339,66.5274053,0.7708558,27.4299075,28.6289477,36650.8335992,41241.487065,26.8834922,1440.5519716,1336.1632209,2647.7589861,2.6597481,23.2000744,2.0557173,72.2460763),(20691,'PereDavidsDeer-radius.tif',243,3,229,337.2862401,57.8279676,66.0568056,1.8,58.1160651,66.307673,0.7699824,29.1181638,29.0417691,37776.106461,42668.0181495,27.2407346,1469.1948678,1297.3382072,2650.6713704,2.3841499,26.6676451,2.0714641,76.1965485),(20692,'PereDavidsDeer-radius.tif',243,3,230,344.6452599,57.9152877,65.4851795,1.8,58.1735597,65.8717561,0.7429762,28.1762563,29.1734994,40156.7240982,43943.3108104,26.2866034,1506.2749307,1425.1972885,2786.0711789,2.0747448,19.83996,2.0443939,59.899702),(20693,'PereDavidsDeer-radius.tif',243,3,231,346.2280779,57.8002081,65.184463,1.8,58.0661946,65.5559853,0.6830586,37.4337464,21.6332962,40556.0539478,45103.5970231,22.9880155,2084.9156115,1083.408899,2224.0973278,1.7950327,16.582126,2.0403962,46.2734733),(20694,'PereDavidsDeer-radius.tif',243,3,232,349.429346,57.6902014,65.0429036,1.8,57.9935697,65.3873451,0.6303729,30.4546398,37.3733608,41110.6787103,46578.1037807,20.2346722,1246.2915511,1349.8987013,2341.7991594,0.441406,0.6979242,1.8925469,1.8727271),(20695,'PereDavidsDeer-radius.tif',243,3,233,356.6167153,57.7879924,64.5204706,1.8,58.1400052,65.1077585,0.5028023,31.9216357,37.2215034,43142.2699612,47842.6129396,13.8017276,1285.3487513,1351.5056186,2400.52005,2.33035,11.6618096,2.0852476,38.350347),(20696,'PereDavidsDeer-radius.tif',243,3,234,361.3554274,57.6192214,64.2427207,1.8,58.000823,64.778084,0.488457,29.3789136,27.6987622,43680.6493064,49471.2375927,13.2622615,1786.0450649,1486.8027411,2957.1637589,1.4810801,5.428576,2.0344439,15.02618),(20697,'PereDavidsDeer-radius.tif',243,3,235,370.3960133,57.6766328,63.7585903,1.8,58.0494351,64.307183,0.3754764,32.6939691,30.2293771,46015.1051106,51172.2455752,8.3018365,1692.7985424,1407.4493346,2837.4820392,0.220703,0.3121212,2.3561945,0.6242424),(20698,'PereDavidsDeer-radius.tif',243,3,236,384.3188725,57.8157505,63.1284503,1.8,58.2340725,63.7477188,0.2325948,32.5615964,27.8528489,49149.9034564,53499.4647781,3.4032546,1920.7896818,1509.4439118,2853.7837427,2.1134365,26.0064564,2.0952056,78.1228271),(20699,'PereDavidsDeer-radius.tif',243,3,237,395.3620812,57.8852662,62.6198417,1.8,58.1773334,63.2859174,0.0613431,30.9096642,25.8115137,51313.1429225,56028.9811067,0.2476457,2170.6972191,1660.1003033,2973.9507444,1.9511593,10.7873883,2.1077071,28.7816936),(20700,'PereDavidsDeer-radius.tif',243,3,238,414.4043123,58.099758,61.8161197,1.8,58.3543677,62.4416142,-0.2814798,34.0141925,36.6676149,55136.6093857,60251.9767341,5.3292636,1643.1932348,1620.988337,2807.8541341,1.086611,6.4345429,2.1112158,15.6504224),(20701,'PereDavidsDeer-radius.tif',243,3,239,435.322506,58.3521764,61.063097,1.8,58.4924032,61.7252323,-0.5031275,35.6246436,38.5003204,58251.7377953,66721.6442986,16.8677173,1733.0153003,1635.1528567,3107.0862022,0.5925441,2.7654007,2.070143,5.9524841),(20702,'PereDavidsDeer-radius.tif',243,3,240,449.9833336,58.3881985,60.4284934,1.8,58.5113015,61.0030189,-0.5179334,35.5338109,39.5067269,60486.8848501,71218.3574474,18.3825532,1802.6893909,1702.2346718,3199.1972748,40.6756747,49.5250846,0.9691975,234.0991473),(20703,'PereDavidsDeer-radius.tif',243,3,241,455.2643189,58.1919506,60.0570309,1.8,58.29438,60.8237643,-0.4043902,27.9222053,37.5005377,61681.8962633,72603.654189,11.7465289,1936.0696869,2209.0624895,3275.3494074,0.5925441,0.9363635,2.3561945,1.8727271),(20704,'PereDavidsDeer-radius.tif',243,3,242,455.6561377,57.8803027,59.8083746,1.8,57.9992874,60.4645053,-0.2687032,33.8474652,34.5255698,62074.2407135,73854.4332785,5.3524702,2139.1227947,1833.9406025,3316.5207079,41.951,49.7032762,0.9335118,222.3586395),(20705,'PereDavidsDeer-radius.tif',243,3,243,455.7750487,57.6528776,59.5886042,1.8,57.8373342,60.2483001,-0.1680455,32.2551235,25.1939881,61838.355455,74773.660198,2.1250102,2967.9167889,1917.1638069,3724.1903177,42.2670972,49.79091,0.9237491,214.7919979),(20706,'PereDavidsDeer-radius.tif',243,3,244,482.9178696,57.7913028,59.2841396,1.8,58.0639942,59.9995624,-0.1671995,26.3089659,35.3003259,63588.5200921,78272.7995966,2.2291595,2217.3392905,2416.9904823,3278.7967456,41.8661158,50.1170788,0.9008697,159.7569499),(20707,'PereDavidsDeer-radius.tif',243,3,245,508.4033021,57.2862516,59.7120159,1.8,57.5535441,60.3390858,0.0401377,34.3574184,44.6066113,62014.7939475,76840.9417269,0.1364357,1722.6357154,1804.9899241,2720.345488,41.6748537,49.6012502,0.8578265,204.7283869),(20708,'PereDavidsDeer-radius.tif',243,3,246,504.4911512,57.1863967,59.1866294,1.8,57.3616506,60.0513954,-0.0056101,33.7620972,43.7428073,61477.5396571,78743.4352492,0.002646,1800.1459013,1820.9040549,2711.7971874,41.1647914,49.5599879,0.8452635,198.4324119),(20709,'PereDavidsDeer-radius.tif',243,3,247,518.8540076,57.2691212,58.7187141,1.8,57.2821956,59.7192675,-0.0571057,34.5888713,30.9676224,61825.4280673,84559.2848623,0.2816962,2730.5707834,1787.4369942,3428.8255664,40.7134781,50.05727,0.8540402,158.9276894),(20710,'PereDavidsDeer-radius.tif',243,3,248,530.4233119,56.9509717,58.5572538,1.8,57.1159058,59.662922,-0.037862,34.9502512,25.8820688,60652.1872036,89259.7496548,0.1266692,3448.7100107,1735.3863042,4089.1965301,39.6821952,49.948166,0.804146,172.683203),(20711,'PereDavidsDeer-radius.tif',243,3,249,519.2723216,56.4224803,58.8482387,1.8,56.8077972,59.6249502,-0.0156575,34.5786798,26.0128079,55722.3825795,88643.4057858,0.0212154,3407.6830982,1611.4664568,3952.3138721,38.731114,49.9320725,0.2867998,196.546691),(20712,'PereDavidsDeer-radius.tif',243,3,250,505.8057553,56.3204441,59.1681579,1.8,56.51685,59.5426773,-0.0498075,34.2113578,34.6907933,51569.1679546,85955.6679576,0.208959,2477.7659961,1507.3698095,3561.5904786,38.1626797,49.4911409,0.1702806,214.1769435),(20713,'PereDavidsDeer-radius.tif',243,3,251,496.315017,56.2668939,59.1440751,1.8,56.303102,59.4483367,-0.0522425,22.1878301,26.0627903,48729.8573556,84712.8543127,0.2255578,3250.3371038,2196.2425898,4043.9104556,37.2834177,49.9320725,0.2867998,214.7476344),(20714,'PereDavidsDeer-radius.tif',243,3,252,495.7318129,55.8148279,59.0184168,1.8,55.9104495,59.32371,-0.018127,34.7584188,26.7287067,46330.3547127,85152.1409522,0.027145,3185.7935329,1332.9246946,3616.7685093,36.3551201,50.1437995,0.168043,166.8248281),(20715,'PereDavidsDeer-radius.tif',243,3,253,489.7872671,55.5442285,58.7943408,1.8,55.5877133,59.1562545,0.023235,32.7820459,27.3385257,43136.3095438,85188.9873016,0.0440615,3116.0783217,1315.8516604,3330.187825,36.4016776,50.2088413,0.1991197,219.6658399),(20716,'PereDavidsDeer-radius.tif',243,3,254,486.5710909,55.1451126,58.6654966,1.8,55.3017661,59.0472867,0.0466833,33.9625881,25.9421795,40515.2257701,84788.0198339,0.1766045,3268.3460492,1192.9369365,3237.431857,36.2712755,49.5575307,0.307667,212.7418167),(20717,'PereDavidsDeer-radius.tif',243,3,255,481.5928003,54.7916487,58.5968145,1.8,54.989674,58.8482363,0.0752737,33.9342019,34.8961271,37762.9439289,82080.9569932,0.4539359,2352.1509049,1112.8284102,2636.4906486,35.2302447,49.9125582,0.3007746,223.6568699),(20718,'PereDavidsDeer-radius.tif',243,3,256,475.9539159,54.0900694,58.6331077,1.8,54.4764825,58.7595452,0.1236723,34.7189244,37.613308,34038.377194,78137.2860685,1.2070994,2077.3840479,980.3983784,2416.5877598,0.220703,0.4935069,2.0344439,1.0656484),(20719,'PereDavidsDeer-radius.tif',243,3,257,476.89589,53.3947334,58.5636612,1.8,53.8194041,58.6440369,0.1587176,31.8161521,34.3680683,30409.9188574,75385.1573045,1.9855121,2193.4650717,955.8012798,2403.5424917,0.441406,0.795756,2.1587989,1.6898907),(20720,'PereDavidsDeer-radius.tif',243,3,258,483.3836978,52.9982238,58.4426311,1.8,53.2326455,58.4525228,0.162574,27.8550362,35.7559072,27327.613564,74969.7179752,2.1106367,2096.708594,981.0654465,2274.5750216,0.220703,1.5606059,1.7126934,3.2726784),(20721,'PereDavidsDeer-radius.tif',243,3,259,499.8244558,52.5937687,58.2476062,1.8,52.6682577,58.2124089,0.1660759,36.3926992,23.3396792,25872.014112,72083.2297972,2.2765789,3088.441332,710.9122071,2617.252543,1.7014091,8.1391245,1.7894653,18.8381795),(20722,'PereDavidsDeer-radius.tif',243,3,260,487.0369486,51.8759276,58.0895116,1.8,52.1158953,57.9998812,0.1907946,36.3999202,27.3476636,22949.2570735,63844.804702,2.9192167,2334.5615827,630.4754771,2096.2620715,1.9405627,8.7310286,1.8525682,22.3250639),(20723,'PereDavidsDeer-radius.tif',243,3,261,450.5590098,50.9322086,57.6449795,1.8,51.4679944,57.692503,0.1853869,36.650758,25.3686666,19518.3970351,53877.4895177,2.5513933,2123.780899,532.5509782,1796.4263884,2.0670276,10.2240531,1.8105394,25.0270515),(20724,'PereDavidsDeer-radius.tif',243,3,262,375.4024228,49.5513209,56.6572454,1.8,50.505921,57.0965174,0.1291951,37.2705768,26.0924685,14473.0304419,41068.8767634,1.038533,1573.9743737,388.3232216,1299.765765,1.9930482,10.9753985,1.8352847,26.3512695),(20725,'PereDavidsDeer-radius.tif',243,3,263,273.0217286,46.7870229,55.4108314,1.8,48.0848248,55.7889637,0.0349141,37.5940701,32.1522738,8065.6565893,22461.6341592,0.055446,698.6017328,214.5459794,639.33574,24.6053767,34.7514379,3.0653079,158.7594233),(20726,'PereDavidsDeer-radius.tif',243,3,264,189.2357256,44.4505677,54.7584989,1.8,44.8763273,54.9976858,0.0080021,38.8490053,24.4996923,3799.2552142,10162.036244,0.0020196,414.7821996,97.795431,303.9947793,21.897016,29.9416789,2.826835,135.3908927),(20727,'PereDavidsDeer-radius.tif',243,3,265,100.9560946,43.6589065,54.5469193,1.8,44.2303998,54.3055111,-0.0583848,39.0286013,14.5722553,1241.9234657,5819.351354,0.0572911,399.3445916,31.8208551,178.554784,18.0746144,28.0327565,2.7625483,96.5639641),(20728,'PereDavidsDeer-radius.tif',243,3,266,26.782693,37.1977136,55.9944474,1.8,38.9726571,55.7712545,0.2545976,9.0391679,20.1619823,128.2665933,330.3233876,0.2831441,16.3834777,14.1900886,22.5481042,6.9921773,11.9465374,2.0096556,30.720966),(20729,'PereDavidsDeer-radius.tif',243,3,267,3.1257826,36.2172326,56.2087081,1.8,36.4363785,56.2841853,0.6319565,13.3291553,70.6317627,3.5031488,21.2265874,0.1817932,0.3005247,0.2628185,0.3440494,3.1613558,7.3065694,2.0074235,17.6210645),(20730,'PereDavidsDeer-radius.tif',243,3,268,0.0059337,100.8623694,87.2874878,1.8,100.8612714,87.2880368,-0.4189894,0.0110707,0.2477338,0.0000248,0.0003846,0.0001637,0.0015527,0.0022407,0.0016511,0.220703,0.4935069,2.677945,0.9363635),(20731,'PereDavidsDeer-radius.tif',243,3,269,0.0562525,62.3243615,93.518365,1.8,62.3240752,93.516766,0.1813002,0.19364,1.7025421,0.0008488,0.0760494,0.0003048,0.0446682,0.0043834,0.045161,0.5586559,1.4805207,2.677945,3.0676602),(20732,'PereDavidsDeer-radius.tif',243,3,270,0.0712935,63.5392516,93.5125012,1.8,63.5528685,93.5109019,0.0088327,0.6824926,9.728496,0.0060433,0.6788032,0.0000009,0.0697747,0.0088547,0.0702233,0.441406,1.188522,2.7610863,2.4434179),(20733,'PereDavidsDeer-radius.tif',243,3,271,0.0425989,67.9048684,93.4359078,1.8,67.9292308,93.4361919,-0.0731828,0.2219003,5.6122874,0.0012091,0.7779544,0.000038,0.1386163,0.0054488,0.1388051,0.3950294,0.795756,0.5880026,1.5606059),(20734,'PereDavidsDeer-radius.tif',243,3,272,0.0394254,58.5281057,84.9834629,1.8,58.7409525,85.0555411,0.3219164,13.8839888,35.5493755,1.092945,20.6435609,0.0006577,0.5807011,0.0787198,0.6021046,0,0,0,0),(20735,'PereDavidsDeer-radius.tif',243,3,273,18.2183858,42.5063744,65.2085604,1.8,42.5449007,65.2101985,0.2549308,8.2180464,38.953861,121.0107311,123.9558119,0.1930965,3.1821188,14.7249998,6.1531913,11.476556,11.7781812,1.3439975,37.8148318),(20736,'PereDavidsDeer-radius.tif',243,3,274,42.5820461,42.5315097,65.2086102,1.8,42.5289613,65.2209255,-0.6136089,27.117418,10.382083,577.841124,595.9099457,2.3531599,57.397918,21.3088548,40.4227297,15.8906161,16.3156102,0.5241796,52.6268057),(20737,'PereDavidsDeer-radius.tif',243,3,275,66.6398678,42.5639661,65.2116511,1.8,42.5465538,65.2086374,-0.6120124,9.4327969,9.533411,1344.0938244,1376.6279786,3.6659523,144.4003603,142.4915473,284.4155352,18.9804581,19.3779246,0.6480569,62.6054954),(20738,'PereDavidsDeer-radius.tif',243,3,276,97.982936,45.1408497,65.1931604,1.8,47.964125,65.2286688,-0.0001228,10.728305,39.3877323,2441.5041884,11040.4107842,0.0000002,280.3007473,227.5759486,335.298799,21.4081911,21.8083156,0.9434881,70.7650095),(20739,'PereDavidsDeer-radius.tif',243,3,277,345.7190308,63.9400548,68.4530328,1.8,59.5420468,69.2979165,0.1811233,26.2593078,33.244519,12293.5783101,89922.9928006,1.8696747,2704.8967884,468.1607909,3074.0699661,23.1738151,23.6595264,0.9310265,76.8467785),(20740,'PereDavidsDeer-radius.tif',243,3,278,579.5159118,64.5444807,71.3781984,1.8,58.9260788,69.9049122,0.2732002,27.0626326,35.2554621,27710.818882,113866.0741364,7.031436,3229.7427814,1023.9513385,3789.6578118,24.7187361,25.3001121,2.7286827,82.2507535),(20741,'PereDavidsDeer-radius.tif',243,3,279,597.1731015,64.2822333,71.4557274,1.8,58.4989505,69.8993677,0.2563938,25.7649626,36.5141655,29029.4077778,119444.1366222,6.4006882,3271.1725669,1126.7009497,3948.9809098,26.0429541,26.5761606,0.5603599,86.513347),(20742,'PereDavidsDeer-radius.tif',243,3,280,604.4117194,64.1310163,71.4570573,1.8,58.3338524,70.0071392,0.2389864,25.6169857,35.9190986,29562.987025,123130.9751147,5.6447407,3428.0084897,1154.0384701,4243.4206107,27.1464691,27.5463517,1.1322331,90.0224132),(20743,'PereDavidsDeer-radius.tif',243,3,281,608.7879273,64.0830897,71.4168071,1.8,58.2956627,70.0724691,0.2251945,25.534515,36.2339247,29842.0395087,125581.176127,5.0591379,3465.8452598,1168.6941955,4287.5299944,27.997257,28.2715289,2.9212302,92.4658311),(20744,'PereDavidsDeer-radius.tif',243,3,282,609.9548225,64.0275041,71.408431,1.8,58.2543458,70.1079531,0.2150748,25.2071334,36.3848856,29897.3318387,127018.806696,4.6304017,3490.977221,1186.0663143,4306.3138048,28.2499841,28.730411,0.752801,93.9193339),(20745,'PereDavidsDeer-radius.tif',243,3,283,609.2403086,64.0292172,71.3852817,1.8,58.2661645,70.1203427,0.2078712,24.9102401,36.4648322,29802.389179,127576.775716,4.3247554,3498.6250606,1196.391086,4309.2353365,28.6872798,29.0004079,0.9257731,94.8556974),(20746,'PereDavidsDeer-radius.tif',243,3,284,609.800501,64.0744408,71.3546793,1.8,58.3060332,70.106169,0.201638,25.2397416,36.5361739,29809.4869467,128016.1688059,4.0764987,3503.8197844,1181.0535695,4312.8487175,28.6913901,29.0725421,2.6167969,95.1678186),(20747,'PereDavidsDeer-radius.tif',243,3,285,610.6088625,64.1294708,71.3268434,1.8,58.328644,70.091324,0.1966669,23.3529611,36.5308781,29842.1476048,128271.3115934,3.8856859,3511.3120237,1277.8742468,4319.8259223,28.6913901,29.0943149,0.9470195,94.8556974),(20748,'PereDavidsDeer-radius.tif',243,3,286,611.6432671,64.1624096,71.2933097,1.8,58.3603508,70.0771674,0.19303,16.1720506,36.4646215,29945.795067,128717.0976524,3.7514193,3529.9172871,1851.7005494,4335.2564294,28.6913901,29.1545239,1.056345,95.0385338),(20749,'PereDavidsDeer-radius.tif',243,3,287,612.6462317,64.2076875,71.2554684,1.8,58.3680298,70.0601434,0.1909832,19.7768961,36.4984411,29998.0523916,129002.77858,3.6792738,3534.4736573,1516.8230737,4348.1276315,28.6913901,29.0876173,0.849825,94.9849823),(20750,'PereDavidsDeer-radius.tif',243,3,288,613.4875092,64.2138423,71.2102465,1.8,58.3584487,70.0253192,0.1865008,16.0077821,36.4472927,30048.1744251,129737.3523826,3.5154006,3559.5881812,1877.0979198,4377.7747067,28.6913901,29.0943149,0.9470195,95.5334913),(20751,'PereDavidsDeer-ulna.tif',243,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20752,'PereDavidsDeer-ulna.tif',243,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20753,'PereDavidsDeer-ulna.tif',243,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20754,'PereDavidsDeer-ulna.tif',243,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20755,'PereDavidsDeer-ulna.tif',243,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20756,'PereDavidsDeer-ulna.tif',243,4,6,0.0029669,93.5780724,77.2460503,1.8,93.5780724,77.2460503,0.7853982,0.00000000000001005,0.00000000000001005,0.000012,0.000012,0.0002472,1198474016.10633,1198474016.25271,1694898207.83283,0.220703,0.3121212,2.3561945,0.6242424),(20757,'PereDavidsDeer-ulna.tif',243,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(20758,'PereDavidsDeer-ulna.tif',243,4,8,0.0128269,87.7839202,76.4871774,1.8,87.3432126,76.418414,0.1557331,0.0347911,20.7202563,0.0000596,1.6789075,0.0000514,0.0810274,0.0017127,0.0810302,0.220703,1.1253689,2.9441971,2.2605815),(20759,'PereDavidsDeer-ulna.tif',243,4,9,0.0096977,94.0268687,77.4667533,1.8,94.0194784,77.4667533,0.1221509,0.0277926,0.2263938,0.0000441,0.0003505,0.000024,0.0015482,0.0015851,0.0017298,0.5446319,1.6067421,0.2782997,3.5090662),(20760,'PereDavidsDeer-ulna.tif',243,4,10,3.2622144,68.8488139,25.0163235,1.8,68.8016956,25.0509282,1.3587209,1.6761457,2.7783679,1.7074931,4.1688147,0.5196132,1.5004546,1.0187021,2.097324,3.531248,5.6268445,1.7681919,14.8655255),(20761,'PereDavidsDeer-ulna.tif',243,4,11,32.3243053,66.9635572,30.9213945,1.8,66.1670426,33.3103335,-1.2851139,3.3660594,15.4973808,63.0004647,2244.4002951,4.9595281,144.8244918,18.7163851,148.8465995,0,0,0,0),(20762,'PereDavidsDeer-ulna.tif',243,4,12,65.0987778,66.7392846,31.6509444,1.8,66.078358,33.3401437,-1.2955959,4.3313389,16.4887363,204.2357909,4455.8181388,10.0486197,270.2340588,47.1530383,282.5878263,7.7600763,29.3460308,1.2966289,81.1537354),(20763,'PereDavidsDeer-ulna.tif',243,4,13,89.7544609,66.6338466,31.5809556,1.8,66.0237037,33.016934,-1.3002656,5.288653,17.6722623,362.3086671,6188.3386193,13.8907181,350.1724056,68.5067953,370.0402826,1.3769658,6.5842034,1.3339476,16.2968465),(20764,'PereDavidsDeer-ulna.tif',243,4,14,100.3012575,66.4976726,31.320062,1.8,65.9172279,32.769908,-1.298414,5.290282,46.2349054,487.4119155,8092.1441516,15.5069867,175.0224009,92.1334472,184.4657158,8.9883874,33.8942617,1.3005466,80.3466567),(20765,'PereDavidsDeer-ulna.tif',243,4,15,112.4830655,66.3746003,31.2728567,1.8,65.8288049,32.579984,-1.2997348,21.1526472,32.21626,640.8101201,10298.1021776,17.4031478,319.655422,30.2945591,283.8336288,9.581181,35.6836554,1.2823016,84.3728623),(20766,'PereDavidsDeer-ulna.tif',243,4,16,128.7885579,66.3799795,31.1191687,1.8,65.8961987,32.2693558,-1.3032361,22.2355661,46.9604559,858.5414141,13089.1783853,19.9644503,278.7276687,38.6111787,295.9372176,10.2906798,37.4837912,1.265804,89.3354313),(20767,'PereDavidsDeer-ulna.tif',243,4,17,143.029994,66.6414967,30.7187973,1.8,66.2414075,31.7210087,-1.305637,22.0698623,47.2669403,1116.9827087,15546.8122844,22.2011867,328.9151398,50.6112223,352.474648,11.0234237,38.7489359,1.2220253,92.2959885),(20768,'PereDavidsDeer-ulna.tif',243,4,18,156.2677127,66.7341054,30.502145,1.8,66.4237115,31.3233949,-1.3104547,22.9890258,45.2141746,1449.8689756,17319.4515905,24.3188961,383.0535828,63.0678737,413.8313397,12.0510692,39.5113852,1.270244,95.0515276),(20769,'PereDavidsDeer-ulna.tif',243,4,19,170.4669336,66.7522714,30.5537802,1.8,66.5215092,31.1445815,-1.3197759,26.2850895,45.2923825,1892.6854839,19306.7674356,26.6582195,426.269637,72.0060507,466.4579527,0.220703,0.6979242,1.8925469,1.5070544),(20770,'PereDavidsDeer-ulna.tif',243,4,20,186.0608198,66.7443799,30.8456256,1.8,66.58914,31.1188957,-1.3293999,21.3254626,45.1271658,2443.2753782,21317.575903,29.237935,472.3889816,114.5708032,523.4602594,0.5018015,3.1599861,1.359703,6.7281931),(20771,'PereDavidsDeer-ulna.tif',243,4,21,194.3230081,66.7161286,31.1753939,1.8,66.6118633,31.1752137,-1.3494941,20.6226176,33.4685304,2827.8721118,22826.1622795,30.8267427,682.01866,137.12479,658.7888057,0.441406,4.4360754,1.4711277,9.1937927),(20772,'PereDavidsDeer-ulna.tif',243,4,22,200.9439708,66.7124224,31.7377361,1.8,66.6170649,31.4622135,-1.3703744,20.6497564,32.7167141,3119.0619076,24842.8599358,32.1632935,759.3323658,151.0459422,730.4724509,0.441406,3.5381383,1.6332151,7.6110051),(20773,'PereDavidsDeer-ulna.tif',243,4,23,208.6336859,66.8016948,32.2158291,1.8,66.7177716,31.7200396,-1.3888586,18.4614427,34.0864765,3423.2675988,27046.9793718,33.6339162,793.481233,185.427957,786.0279508,0.56349,3.7778268,1.6879051,8.0524111),(20774,'PereDavidsDeer-ulna.tif',243,4,24,216.2353249,66.9357129,32.5811148,1.8,66.8574307,31.9094297,-1.398003,18.067986,39.2961561,3678.5283455,29270.706676,34.9738456,744.8745522,203.5937127,836.7414073,0.882812,8.1779322,1.6247978,17.7947129),(20775,'PereDavidsDeer-ulna.tif',243,4,25,220.5910746,67.2399839,32.8510825,1.8,67.1317051,32.095894,-1.4023373,9.7239044,24.4117541,3856.3620735,30365.7062095,35.7316732,1243.8969378,396.5857659,1394.6384953,1.5023159,22.7495446,1.5319809,53.4690599),(20776,'PereDavidsDeer-ulna.tif',243,4,26,224.8135217,67.4880244,33.3633897,1.8,67.3764451,32.5191575,-1.4038985,17.2992706,42.9764652,3963.4265842,32067.8756299,36.4348826,746.1729462,229.1094626,829.2724704,0.662109,0.9870138,2.0344439,2.3141331),(20777,'PereDavidsDeer-ulna.tif',243,4,27,232.6430488,67.6905797,33.8856617,1.8,67.6058812,33.115949,-1.4088903,10.2908074,25.4112099,4107.3968175,34777.4080222,37.766291,1368.585286,399.1326088,1527.2070228,2.0654402,22.3183011,1.5213318,55.4488901),(20778,'PereDavidsDeer-ulna.tif',243,4,28,240.3679973,67.885494,34.5575381,1.8,67.8123282,33.7400334,-1.4089152,10.1331805,25.9796828,4198.5540798,37845.3765714,39.0206442,1456.7297412,414.3372442,1617.0634152,1.4296372,2.7916967,1.2490458,7.954496),(20779,'PereDavidsDeer-ulna.tif',243,4,29,250.6285869,68.0091283,35.2328965,1.8,68.0007746,34.3597999,-1.413169,14.3850902,41.2246081,4325.7687913,41615.5232447,40.7421298,1009.4825671,300.711969,1109.0454677,2.356914,22.1099909,1.5108682,55.8902961),(20780,'PereDavidsDeer-ulna.tif',243,4,30,260.9432296,68.1270851,36.0532301,1.8,68.1546228,35.1685818,-1.4152303,15.8317042,41.6890435,4366.0979693,45645.1219921,42.4464965,1094.8949215,275.781932,1198.8789291,1.945806,21.639026,1.5401936,52.8226358),(20781,'PereDavidsDeer-ulna.tif',243,4,31,267.9458411,68.2574146,36.8491372,1.8,68.2777658,35.9998033,-1.4209356,14.3714246,40.9621803,4319.581696,48940.2605439,43.6621947,1194.7669831,300.5673976,1299.9919083,1.103515,6.8560171,1.6352232,16.7068828),(20782,'PereDavidsDeer-ulna.tif',243,4,32,274.6067607,68.3469291,37.7502692,1.8,68.4139829,36.7816366,-1.4286813,15.2763681,39.9937459,4303.7946945,52219.0741026,44.8496417,1305.6809989,281.7289214,1412.9435852,1.324218,3.8544122,1.3397057,10.7857684),(20783,'PereDavidsDeer-ulna.tif',243,4,33,280.3689841,68.5259225,38.8860049,1.8,68.6359185,38.0552069,-1.4379793,14.6700041,33.4983509,4219.3451329,55725.2359204,45.9086975,1663.5217698,287.617174,1652.1159071,2.0722235,17.4578724,1.621386,45.3944671),(20784,'PereDavidsDeer-ulna.tif',243,4,34,288.9428709,68.6346698,39.9798692,1.8,68.7322183,39.1525374,-1.445342,9.4057135,28.9025014,4165.8327283,59825.91329,47.4031776,2069.9216478,442.9044887,2214.0323372,2.3910471,27.3814073,1.5385494,75.4506329),(20785,'PereDavidsDeer-ulna.tif',243,4,35,297.6701051,68.741722,41.1982672,1.8,68.8754654,40.2802,-1.4528609,14.7973872,30.1017262,4109.795305,64244.6490498,48.9248404,2134.2513237,277.7379037,2037.8664205,2.5864039,26.9293839,1.5544044,78.8304144),(20786,'PereDavidsDeer-ulna.tif',243,4,36,304.0088314,68.8372275,42.5187503,1.8,69.0048091,41.616917,-1.4598735,9.6307559,29.0532579,4065.1846048,67781.0676917,50.0472768,2332.9937033,422.1044168,2471.5635669,2.2571809,26.9402345,1.5380212,74.1891545),(20787,'PereDavidsDeer-ulna.tif',243,4,37,324.8195092,69.0482422,44.5487476,1.8,69.2787173,43.7962219,-1.4796767,14.5139453,29.3610379,4438.5127449,76316.0747796,53.6883425,2599.2294674,305.8102167,2595.6818973,1.103515,7.0934645,1.4773195,15.7705192),(20788,'PereDavidsDeer-ulna.tif',243,4,38,352.05141,69.1951378,46.9266375,1.8,69.3589211,46.1075818,-1.4945764,9.819111,31.1404058,4899.7454488,88923.9359791,58.3350215,2855.5805178,499.0009236,3001.2362431,1.492191,7.5330561,1.6588037,17.5896948),(20789,'PereDavidsDeer-ulna.tif',243,4,39,385.3703255,69.1060156,49.6420959,1.8,69.1990061,48.3147686,-1.4936578,17.2654227,33.0740102,5644.4770108,105708.3328138,63.8469632,3196.1147765,326.9237668,3363.4309796,18.2073861,60.8340108,1.4617417,298.6109689),(20790,'PereDavidsDeer-ulna.tif',243,4,40,392.3385006,69.0661035,50.3876726,1.8,69.1224125,48.9935002,-1.4884266,21.3840745,33.2249419,5970.390392,103863.2516173,64.9470982,3126.0626974,279.1979794,3304.9482366,19.1383998,60.4452295,1.4536876,303.4626291),(20791,'PereDavidsDeer-ulna.tif',243,4,41,362.7648976,69.2050139,49.1771393,1.8,69.1992621,48.6405852,-1.4841029,20.584399,30.9613929,5685.4690526,82416.4312848,60.0075458,2661.9096719,276.2028198,2680.9909495,19.7184323,58.0276836,1.4870234,318.1323245),(20792,'PereDavidsDeer-ulna.tif',243,4,42,331.1427074,69.2017022,48.1833097,1.8,69.1534043,47.6749844,-1.4782296,15.4855389,28.3915547,5179.1790773,63280.6164502,54.718896,2228.8535109,334.4526202,2336.8347333,0.220703,0.3121212,2.3561945,0.6242424),(20793,'PereDavidsDeer-ulna.tif',243,4,43,304.7475821,69.1330425,47.5032083,1.8,69.0817803,47.1402089,-1.4691049,10.3774952,26.7703496,4791.52733,51426.8104948,50.267832,1921.0361918,461.722914,2097.801954,18.5297722,48.403947,1.4611462,197.754618),(20794,'PereDavidsDeer-ulna.tif',243,4,44,284.6437132,69.0867201,47.0890561,1.8,69.0241212,46.7566999,-1.4564635,10.8152413,25.4946028,4517.4163967,43022.1719341,46.823173,1687.501164,417.6898408,1862.7745627,18.6093525,45.6641922,1.4350509,263.6106099),(20795,'PereDavidsDeer-ulna.tif',243,4,45,268.4575156,69.0617684,46.7829272,1.8,68.9708169,46.5175754,-1.4424498,10.349238,23.9186383,4312.9071523,36725.6383289,44.0099152,1535.440181,416.7366876,1714.6910711,2.7222766,25.4507979,1.3699994,86.1124987),(20796,'PereDavidsDeer-ulna.tif',243,4,46,255.6181103,69.0195161,46.5795123,1.8,68.9784919,46.3485838,-1.4245915,9.7769409,22.7669805,4170.8611263,31916.3693654,41.6988129,1401.870985,426.6018558,1581.6090011,2.4288955,24.1415188,1.3213831,77.6408634),(20797,'PereDavidsDeer-ulna.tif',243,4,47,248.051203,68.9829988,46.5280353,1.8,68.8930282,46.3135878,-1.4085101,10.2051411,21.6772119,4135.2341886,28359.3314281,40.2625788,1308.2554884,405.2108775,1496.6729066,2.0310481,12.1567092,1.2949904,31.7644326),(20798,'PereDavidsDeer-ulna.tif',243,4,48,243.890204,68.9328866,46.6467839,1.8,68.850181,46.4484358,-1.3919396,9.5715365,21.0890725,4129.5896793,25757.9750056,39.3618442,1221.3896559,431.4448013,1412.9164595,2.4592543,28.201664,1.2688452,84.6054443),(20799,'PereDavidsDeer-ulna.tif',243,4,49,240.6541158,68.928595,46.6299133,1.8,68.8081992,46.3167761,-1.3708927,10.1089412,20.1688768,4190.675328,22972.5147582,38.527442,1139.0081353,414.5513595,1340.8185714,18.2432318,36.4026167,1.381724,169.7318338),(20800,'PereDavidsDeer-ulna.tif',243,4,50,239.476032,68.8663301,46.6897868,1.8,68.7193412,46.3653077,-1.3450926,10.0519631,19.423667,4250.3850889,20800.9413285,37.9137267,1070.9070185,422.841294,1284.5302913,18.0960908,35.2379141,1.3562034,165.9198343),(20801,'PereDavidsDeer-ulna.tif',243,4,51,238.9462759,68.763408,46.8013392,1.8,68.5968701,46.485998,-1.3166597,10.2489277,18.8035864,4319.6273267,19089.3466079,37.3072033,1015.1971129,421.4711465,1235.8932409,18.4446194,34.2096771,1.3430304,164.3370467),(20802,'PereDavidsDeer-ulna.tif',243,4,52,238.5015996,68.6561109,46.8885029,1.8,68.4848206,46.6084975,-1.2848674,11.054952,18.0508764,4341.2695095,17691.9461127,36.5880734,980.1156313,392.6990829,1210.5371587,18.1000222,33.2412717,1.3225971,164.7876407),(20803,'PereDavidsDeer-ulna.tif',243,4,53,236.3260126,68.572596,46.9924863,1.8,68.3768573,46.8168814,-1.251985,10.3273531,17.4605495,4330.4593982,16433.3373207,35.5180915,941.1695403,419.3193888,1175.4961207,2.1390465,7.6102542,1.2765618,21.0857672),(20804,'PereDavidsDeer-ulna.tif',243,4,54,235.8601106,68.499608,47.0738421,1.8,68.3024977,47.006168,-1.2206795,10.954717,16.8513422,4332.2212944,15321.0301607,34.6850314,909.1875281,395.4662897,1149.0349679,18.3671382,31.8363601,1.2753555,153.2483451),(20805,'PereDavidsDeer-ulna.tif',243,4,55,236.1812707,68.4042274,47.2756746,1.8,68.1924714,47.2227307,-1.1915694,10.444518,16.4859261,4389.3938539,14627.5258835,33.9687777,887.2735335,420.2581559,1128.8382188,2.2789907,17.3851776,1.0673969,49.6532547),(20806,'PereDavidsDeer-ulna.tif',243,4,56,238.5219544,68.2721632,47.5423796,1.8,68.0795226,47.5731752,-1.1595667,14.6147085,16.1451382,4495.4159753,14242.1290284,33.4014424,882.131134,307.5953225,1134.064626,2.0504421,7.4190357,1.0405806,23.3999003),(20807,'PereDavidsDeer-ulna.tif',243,4,57,235.2559023,68.1932229,47.7460019,1.8,67.9142169,47.7883429,-1.1225984,11.0109868,15.7209911,4638.0280372,13760.7688964,31.8463795,875.3117944,421.2181984,1135.7755837,19.6428379,30.5344815,1.2010278,163.0312047),(20808,'PereDavidsDeer-ulna.tif',243,4,58,234.9903452,68.081289,48.1316342,1.8,67.8090663,48.2084491,-1.0911565,11.0369492,15.8442248,4812.6618685,13485.8243445,30.8250542,851.1507811,436.0500165,1136.0819597,0.220703,0.3121212,2.3561945,0.6242424),(20809,'PereDavidsDeer-ulna.tif',243,4,59,234.5490343,67.9553313,48.5521374,1.8,67.7280503,48.5412454,-1.0590687,11.1516244,15.4579252,5076.0392434,13343.8001342,29.7177259,863.2335827,455.1838409,1154.5120484,20.5887178,30.3424489,1.1592189,150.9655818),(20810,'PereDavidsDeer-ulna.tif',243,4,60,235.2665741,67.8864443,48.8908397,1.8,67.6378037,48.7617871,-1.019883,11.7833945,15.6036009,5474.1770605,13106.219787,28.4666187,839.9484107,464.5670716,1170.5858901,2.4826714,24.1203239,0.9675665,69.5754585),(20811,'PereDavidsDeer-ulna.tif',243,4,61,238.719111,67.762782,49.3146536,1.8,67.5379057,49.1855081,-0.9635236,12.9660395,15.3435442,6046.4028022,13209.9204498,26.8312907,860.9432274,466.3261125,1208.5842024,2.5595468,24.2351593,0.9145455,66.7441862),(20812,'PereDavidsDeer-ulna.tif',243,4,62,242.2816288,67.6753218,49.6840372,1.8,67.6687475,49.5687269,-0.8685717,18.0722922,16.011638,6952.1713645,13418.9359807,23.5332394,838.0739028,384.686751,1127.0545046,3.0703334,22.6476124,0.9097532,74.6765004),(20813,'PereDavidsDeer-ulna.tif',243,4,63,248.7794295,67.704777,50.0416362,1.8,67.9110695,49.9265918,-0.7400507,17.7507832,16.7531824,8105.9184715,13542.1291074,18.8539412,808.3317416,456.6513135,1199.9410418,26.6279622,30.9181195,0.8915961,198.6443886),(20814,'PereDavidsDeer-ulna.tif',243,4,64,250.7509223,67.9812532,50.3807907,1.8,68.1825299,50.2128673,-0.5742914,16.0346418,19.1329119,9366.087272,13091.1925679,12.3331713,684.2237423,584.1157789,1141.6959248,4.3751634,24.8533531,0.8419416,103.016788),(20815,'PereDavidsDeer-ulna.tif',243,4,65,247.8143847,68.6249998,50.5991634,1.8,68.7827898,50.3701864,-0.1014488,14.6664218,21.0038874,10329.3242039,12267.8383058,0.4236221,584.0746568,704.283862,1058.730217,27.106973,31.5304189,2.9798962,177.0101123),(20816,'PereDavidsDeer-ulna.tif',243,4,66,242.4510504,68.9736006,50.7977852,1.8,69.228675,50.6610611,0.2937032,14.8386167,18.7635502,9946.8251488,12216.3721323,3.3866192,651.0693342,670.3337197,1027.5719566,27.49974,34.2459663,3.0188364,174.1161004),(20817,'PereDavidsDeer-ulna.tif',243,4,67,236.3133628,68.9525618,50.942436,1.8,69.1517017,50.8170709,0.2965166,14.5570202,18.9156782,9386.277411,12194.3039949,3.3625556,644.6664955,644.7938712,1000.6002438,26.4038855,37.9615577,3.1357788,254.0359213),(20818,'PereDavidsDeer-ulna.tif',243,4,68,232.8700513,68.8909006,51.084166,1.8,69.2132072,50.9196916,0.2756707,14.3697465,18.9995912,8893.7896997,12122.6362667,2.8755059,638.0472166,618.9246061,994.3829107,0.662109,1.103515,2.4980915,2.6262542),(20819,'PereDavidsDeer-ulna.tif',243,4,69,228.4738872,68.6538393,51.1229742,1.8,68.7963677,50.9065612,0.127916,13.9408549,19.912073,8231.11497,12079.4862807,0.6196768,606.6413214,590.4311482,965.9529791,0.6242424,0.9363635,2.3561945,2.0020119),(20820,'PereDavidsDeer-ulna.tif',243,4,70,223.2970524,68.3781152,51.1023677,1.8,68.6106505,50.755049,0.0039989,14.232656,20.0365344,7344.0356825,11977.0168677,0.0005952,597.7589041,515.9989609,953.5148297,0.220703,0.4935069,2.677945,0.9363635),(20821,'PereDavidsDeer-ulna.tif',243,4,71,216.6846508,68.0354539,51.029713,1.8,68.4984563,50.7725358,-0.1052429,12.2514947,19.9924774,6272.8509741,11624.0966545,0.398528,581.4235246,512.0069938,891.9168605,0.220703,0.4935069,2.0344439,1.0656484),(20822,'PereDavidsDeer-ulna.tif',243,4,72,205.5967766,67.3382327,50.8453173,1.8,67.910036,50.6515834,-0.2155825,18.1778548,19.8479448,4988.146053,12339.5868135,1.5680267,621.7060211,274.4078506,823.9087328,0.441406,0.795756,2.5535901,1.5606059),(20823,'PereDavidsDeer-ulna.tif',243,4,73,195.6855397,67.3116923,50.8379734,1.8,68.463564,50.8268813,-0.1858491,14.1035648,20.4817619,4552.5544262,12765.1854882,1.1135828,623.2464544,322.7945912,696.3889463,0.662109,1.2869086,1.0303768,2.9383754),(20824,'PereDavidsDeer-ulna.tif',243,4,74,191.2216542,67.361253,51.0668201,1.8,68.5286417,50.967305,-0.1693022,13.1625185,19.9626327,4378.809732,12708.7476835,0.9048109,636.6268358,332.6726376,716.9591002,19.9059879,36.3671402,3.0443395,178.7887301),(20825,'PereDavidsDeer-ulna.tif',243,4,75,184.8053318,67.5430269,51.2921878,1.8,68.4810935,51.0967951,-0.1538754,12.5362285,20.066045,4181.1220875,12123.9082159,0.7235543,604.2001894,333.5231228,703.6428383,0.220703,0.3121212,2.3561945,0.6242424),(20826,'PereDavidsDeer-ulna.tif',243,4,76,174.6355195,67.67634,51.4230002,1.8,68.2907203,51.1993129,-0.1580588,12.3285247,19.9698743,3878.5593802,10946.6704949,0.7211053,548.1592095,314.6004467,668.0310296,0.220703,0.6979242,1.8925469,1.5070544),(20827,'PereDavidsDeer-ulna.tif',243,4,77,170.622805,68.4101815,51.7835893,1.8,68.6009206,51.4443496,-0.1475423,10.9158988,19.6429865,3916.0983251,7989.902583,0.6145617,406.7559989,358.751798,591.4708048,18.538808,31.4213181,2.8932068,153.935327),(20828,'PereDavidsDeer-ulna.tif',243,4,78,156.5244134,68.3408177,51.786144,1.8,68.5085798,51.5898241,-0.2017047,11.5470293,17.4202876,3490.4890315,6830.056123,1.0470444,392.0748208,302.2845913,514.2411149,0.6242424,0.6979242,1.8925469,1.8727271),(20829,'PereDavidsDeer-ulna.tif',243,4,79,145.6983914,68.0159832,51.7978241,1.8,68.1496125,51.7178626,-0.3164084,12.547103,18.3639518,3023.0271973,5986.9370291,2.3510281,326.0157231,240.9342784,481.3732045,0.220703,0.3121212,2.3561945,0.6242424),(20830,'PereDavidsDeer-ulna.tif',243,4,80,133.5161701,67.8050067,51.6812843,1.8,68.0664374,51.7180963,-0.444861,18.4289551,16.5848122,2434.3196071,5084.6910442,4.1208878,306.587194,132.0921124,359.821058,3.5904693,21.0606641,0.6665578,74.1501731),(20831,'PereDavidsDeer-ulna.tif',243,4,81,116.5815979,67.5602556,51.2810684,1.8,67.8931016,51.7153566,-0.5933938,14.3471625,15.8578076,1595.4769797,4107.2202344,6.0754538,259.0030317,111.2050542,326.2559322,0.220703,0.3121212,2.3561945,0.6242424),(20832,'PereDavidsDeer-ulna.tif',243,4,82,101.9215969,67.890822,50.9496985,1.8,68.1848929,51.5265697,-0.7670134,15.9468643,10.5386439,1107.6939312,2927.4776162,8.1812352,277.7850402,69.4615511,248.2706524,0.662109,1.103515,2.2142974,2.6262542),(20833,'PereDavidsDeer-ulna.tif',243,4,83,95.2729138,67.8180793,50.891618,1.8,67.7814424,51.4129023,-0.7662364,16.1837713,10.5195407,879.3973274,2670.8546297,7.6352177,253.8946043,54.3382201,214.0360768,0.220703,0.3121212,2.3561945,0.6242424),(20834,'PereDavidsDeer-ulna.tif',243,4,84,91.860747,67.8622532,50.9523452,1.8,67.7246027,51.3884638,-0.7920011,14.312918,9.9246585,761.2872572,2429.6871622,7.7561509,244.8131753,53.1888227,221.9298929,0.220703,0.3121212,2.3561945,0.6242424),(20835,'PereDavidsDeer-ulna.tif',243,4,85,89.5219822,67.8681912,51.0277638,1.8,67.6398099,51.4585966,-0.7914338,12.8456792,9.8755138,693.3287368,2265.119877,7.5502171,229.3672931,53.9736922,230.0077197,0.6915816,1.2869086,1.0303768,3.7454541),(20836,'PereDavidsDeer-ulna.tif',243,4,86,86.972171,67.8796412,51.1083631,1.8,67.6092941,51.5504455,-0.7893793,12.9348501,9.8276519,632.0155334,2119.0190218,7.3053884,215.6180384,48.8614502,212.4746121,0.220703,0.3121212,2.3561945,0.6242424),(20837,'PereDavidsDeer-ulna.tif',243,4,87,92.2465878,67.5567842,51.7413437,1.8,67.2933178,52.1248808,-0.8357998,11.1107021,10.0325055,638.5313919,2426.8446099,8.4607998,241.8981593,57.4699406,252.8087656,2.8379112,15.7999304,0.8545944,49.7917275),(20838,'PereDavidsDeer-ulna.tif',243,4,88,89.2857691,67.5641022,51.8325473,1.8,67.3417386,52.2213061,-0.8283382,11.0354812,9.9350123,581.7912951,2293.2198929,8.0786844,230.8220483,52.7200657,243.7037419,2.671613,15.4885712,0.8559878,47.8432672),(20839,'PereDavidsDeer-ulna.tif',243,4,89,87.2771387,67.5686725,51.9444503,1.8,67.3380509,52.3944184,-0.8183516,12.4096991,9.3442002,569.9774864,2185.7115309,7.7520951,233.911035,45.9300006,194.1830279,3.0136351,15.4885712,0.8559878,52.2129636),(20840,'PereDavidsDeer-ulna.tif',243,4,90,91.6989862,67.1962794,52.5843805,1.8,66.9770241,53.0920663,-0.8339009,13.602876,9.9192027,579.059398,2553.0576575,8.3816948,257.3853694,42.568895,229.956237,0.220703,0.3121212,2.3561945,0.6242424),(20841,'PereDavidsDeer-ulna.tif',243,4,91,87.3952231,67.2978457,52.5643735,1.8,66.9426203,53.0575578,-0.8177794,9.0404623,9.9745865,525.9438879,2280.8413147,7.7542664,228.6652494,58.1766583,242.1603304,0.6915816,1.2869086,2.1112158,3.3797814),(20842,'PereDavidsDeer-ulna.tif',243,4,92,81.7530915,67.5100227,52.4632832,1.8,67.1312265,53.0125421,-0.7906,12.6979319,10.1740954,465.4514906,1960.5918457,6.8836347,192.704292,36.6556928,190.2301538,3.300998,16.9007205,0.7114591,45.8412553),(20843,'PereDavidsDeer-ulna.tif',243,4,93,77.337414,67.7368126,52.4094829,1.8,67.3406224,52.8608595,-0.7810483,10.3324221,10.3883657,416.0115583,1679.9070727,6.3887171,161.7104294,40.2627336,173.928041,2.7217041,16.6992122,0.7760526,46.0998249),(20844,'PereDavidsDeer-ulna.tif',243,4,94,73.6899788,67.9329907,52.4481837,1.8,67.5392985,52.8611943,-0.7866042,8.8160815,10.3196202,373.8291062,1463.5174616,6.1556441,141.8189267,42.403091,162.5754623,0.220703,0.3121212,2.3561945,0.6242424),(20845,'PereDavidsDeer-ulna.tif',243,4,95,72.0153353,68.0031097,52.5794888,1.8,67.6292958,52.998857,-0.7793021,11.0835726,10.3105936,346.6631078,1351.4352249,5.9281111,131.0724944,31.2771993,120.8699219,2.9912072,15.4570903,0.7551044,42.5907587),(20846,'PereDavidsDeer-ulna.tif',243,4,96,70.4702895,68.0620018,52.7304387,1.8,67.7682407,53.0499637,-0.7787895,7.5817398,9.9305732,323.2161917,1255.5455307,5.7949077,126.4323324,42.6308734,148.0584727,3.3642465,14.5144737,0.7746459,44.2806494),(20847,'PereDavidsDeer-ulna.tif',243,4,97,68.4521681,68.1160018,52.8539614,1.8,67.7827154,53.1757627,-0.7692164,7.5884713,10.227207,311.7986801,1164.2796105,5.5197667,113.8414048,41.0884706,136.1492116,3.7174827,14.9850674,0.7645678,49.8674608),(20848,'PereDavidsDeer-ulna.tif',243,4,98,67.1847683,68.1675403,53.0276793,1.8,67.9485674,53.3998811,-0.7635304,9.3734566,9.6999514,298.1770572,1080.265967,5.3539456,111.3681833,31.8107897,132.0045499,3.4932423,14.9818165,0.7853982,43.3442859),(20849,'PereDavidsDeer-ulna.tif',243,4,99,66.2458645,68.1958545,53.2080468,1.8,68.0334201,53.5175668,-0.7555661,10.7926691,10.2606479,285.7626683,1006.7317129,5.1913093,98.1158037,26.4774788,116.4428921,3.0783075,14.0593182,0.7409829,41.4715588),(20850,'PereDavidsDeer-ulna.tif',243,4,100,65.644992,68.2168804,53.3901326,1.8,68.0707489,53.6415201,-0.7489236,8.4229295,9.5447618,272.6418008,947.6313547,5.0717079,99.282871,32.3689997,117.8056419,3.005597,14.0593182,0.7409829,40.2008923),(20851,'PereDavidsDeer-ulna.tif',243,4,101,64.8448816,68.2174127,53.5916363,1.8,68.0919282,53.8473769,-0.7425542,8.381291,8.4854674,258.1511998,899.0536945,4.9412709,105.9521715,30.8008874,124.2433803,0.220703,0.3121212,2.3561945,0.6242424),(20852,'PereDavidsDeer-ulna.tif',243,4,102,64.2078163,68.1918933,53.8182031,1.8,68.0616994,54.0387632,-0.7411726,7.6745787,8.4817802,245.4860818,870.3103399,4.8779969,102.6093954,31.986913,118.2897629,0.220703,0.3121212,2.3561945,0.6242424),(20853,'PereDavidsDeer-ulna.tif',243,4,103,63.9637211,68.1506074,54.0909543,1.8,68.061964,54.321747,-0.74327,7.2033283,8.0562066,235.9343526,851.4466088,4.8817289,105.688279,32.7535191,118.0047206,3.5659246,12.800774,0.8097836,41.4937406),(20854,'PereDavidsDeer-ulna.tif',243,4,104,64.0150583,68.0880156,54.3740092,1.8,67.9637612,54.6378357,-0.7470123,7.0382625,7.866155,230.2793539,850.3049109,4.9254445,108.0966388,32.7182107,124.6850425,3.7272105,12.1205941,0.9928944,33.4099597),(20855,'PereDavidsDeer-ulna.tif',243,4,105,64.1024112,68.0232834,54.675079,1.8,67.8366266,55.0853252,-0.7607197,7.8190457,9.6955023,235.3963773,878.026918,5.0783161,90.5602299,30.1055123,106.2874456,3.7562478,13.7475118,0.8308214,41.3644557),(20856,'PereDavidsDeer-ulna.tif',243,4,106,65.1262915,67.8800608,55.1051342,1.8,67.6576242,55.5575209,-0.7967344,9.7757865,9.1387429,240.4519684,949.2049797,5.5502277,103.866034,24.5966878,116.7282961,4.3847009,13.4248394,0.7621465,50.7724546),(20857,'PereDavidsDeer-ulna.tif',243,4,107,66.187516,67.7457425,55.5421143,1.8,67.4830347,55.9808155,-0.8286125,8.4775529,10.651556,246.694403,1027.4042262,5.9917408,96.4557881,29.0997186,108.8987462,4.0002442,14.9850674,0.8062285,52.6987332),(20858,'PereDavidsDeer-ulna.tif',243,4,108,67.7784671,67.6075978,56.0196296,1.8,67.2749158,56.5454748,-0.8569304,8.9321522,11.3058338,252.0995018,1133.3974121,6.4535091,100.2489011,28.223825,108.9615899,3.5411483,15.1451153,0.7544802,57.2290842),(20859,'PereDavidsDeer-ulna.tif',243,4,109,68.5730127,67.4706975,56.4480497,1.8,66.9519292,57.0980099,-0.875489,10.0591605,12.5199984,256.3194354,1218.8348831,6.7384894,97.3510412,25.4811955,103.3825575,3.4556668,7.8868519,1.2578951,29.4281177),(20860,'PereDavidsDeer-ulna.tif',243,4,110,62.9301431,67.7310737,56.2143638,1.8,67.5685829,56.7728688,-0.8266834,11.3224986,9.2062891,224.0528327,909.38291,5.6767009,98.7784441,19.7882852,95.7254814,3.1566104,8.6187277,0.8760581,30.395851),(20861,'PereDavidsDeer-ulna.tif',243,4,111,61.4560365,67.7260435,56.3897857,1.8,67.5544616,56.8800416,-0.8172073,10.4436492,9.5720095,209.8119972,860.0010785,5.4469268,89.8454062,20.0899123,96.6486015,4.7228549,12.8311797,0.8584387,50.620988),(20862,'PereDavidsDeer-ulna.tif',243,4,112,62.9556641,67.5983327,56.8678977,1.8,67.4547702,57.4315993,-0.8726321,10.8933209,9.3551819,220.5191365,937.7244383,6.1569806,100.2358316,20.2435178,98.2834499,3.7486826,12.916312,0.9922721,44.1199948),(20863,'PereDavidsDeer-ulna.tif',243,4,113,62.1439224,67.6263748,57.0879148,1.8,67.5256608,57.8927099,-0.8793065,10.7889703,9.1686891,245.2476665,901.1614563,6.1455902,98.2868374,22.731332,99.9033715,4.5571718,13.6515109,0.9693416,48.8997275),(20864,'PereDavidsDeer-ulna.tif',243,4,114,62.1382986,67.4575699,57.3939747,1.8,66.9798436,57.8352653,-0.8578578,8.289548,10.1949125,218.2259298,936.6210025,5.9259874,91.8714117,26.3254317,91.5821681,6.0601335,10.9420622,0.8424789,45.8856188),(20865,'PereDavidsDeer-ulna.tif',243,4,115,60.8383665,67.462337,57.5817617,1.8,67.0591165,57.9965439,-0.8524416,7.4188266,10.1594424,214.3376898,880.1910696,5.7476305,86.6377339,28.8910498,90.5118101,4.5004958,14.7227265,0.7004964,51.3745152),(20866,'PereDavidsDeer-ulna.tif',243,4,116,59.9412794,67.4467364,57.7887425,1.8,67.038967,58.2388541,-0.8478311,7.7023544,10.1505939,210.3818187,837.8517411,5.6172052,82.5421402,27.3139623,84.5663403,5.5637498,15.1451153,0.7544802,58.3169144),(20867,'PereDavidsDeer-ulna.tif',243,4,117,60.239782,67.4410664,58.1132071,1.8,67.1971031,58.6999045,-0.8821526,9.058029,9.2557573,226.506866,823.8788787,5.9853422,89.0125846,25.0061979,91.2756564,3.8718499,13.9602281,0.6846172,49.0825639),(20868,'PereDavidsDeer-ulna.tif',243,4,118,59.6046207,67.4047884,58.3213414,1.8,67.064909,58.8392733,-0.8770278,8.9638591,9.0234534,220.5156372,790.7582365,5.8722239,87.6336592,24.6005248,91.5318582,3.9036727,14.6148054,0.6676656,49.1139336),(20869,'PereDavidsDeer-ulna.tif',243,4,119,59.1701439,67.389813,58.5338458,1.8,67.1065026,59.0217147,-0.8738242,14.4725065,8.870405,221.243953,761.1846686,5.7983371,85.811715,15.2871898,67.8654802,5.1402544,14.3048919,0.6651027,47.8654489),(20870,'PereDavidsDeer-ulna.tif',243,4,120,58.7563762,67.3519067,58.7506214,1.8,67.0680804,59.1786441,-0.870921,14.5840187,8.6981365,218.0835672,732.8939781,5.7297888,84.2587354,14.953599,65.1727729,3.8458635,14.7227265,0.7004964,45.6048674),(20871,'PereDavidsDeer-ulna.tif',243,4,121,61.970545,67.2573607,59.2763849,1.8,66.9278074,59.7999396,-0.9152166,9.4403303,8.5691895,278.8831949,812.0542532,6.4900186,94.7644174,29.5416778,92.5494825,5.4552658,15.6761288,0.6153395,51.6109031),(20872,'PereDavidsDeer-ulna.tif',243,4,122,65.4622269,67.1464233,59.8850092,1.8,66.7527534,60.3735788,-0.9987683,12.489754,10.0526434,342.8603266,911.6670149,7.7131171,90.6892825,27.4513275,78.2477161,4.9929335,15.3686008,0.6119024,50.0724789),(20873,'PereDavidsDeer-ulna.tif',243,4,123,63.0752836,67.0570543,59.881649,1.8,66.471094,60.1495236,-0.9197488,9.7366045,10.1030574,296.9912939,836.1156322,6.6517068,82.758674,30.5025529,80.7565123,4.6818177,15.1402902,0.6405857,50.8038244),(20874,'PereDavidsDeer-ulna.tif',243,4,124,62.6196549,67.0146475,60.0717062,1.8,66.4062906,60.2905232,-0.9059719,7.9058409,8.7364723,296.9041263,802.4703531,6.4645252,91.852904,37.5550344,94.7607394,4.8378782,15.3686008,0.6119024,50.0724789),(20875,'PereDavidsDeer-ulna.tif',243,4,125,62.2950704,66.9687227,60.2476902,1.8,66.3495403,60.3867057,-0.893357,14.7640476,10.0158971,296.4466522,771.5082256,6.3034512,77.0283698,20.0789553,60.6120524,0.220703,0.3121212,2.3561945,0.6242424),(20876,'PereDavidsDeer-ulna.tif',243,4,126,64.0432804,66.989707,60.6397073,1.8,66.561618,60.8264759,-0.9670702,9.4320126,7.9101208,360.3189869,772.7408738,7.2336993,97.690148,38.2017074,92.0448353,4.4899636,15.3686008,0.6119024,47.6290611),(20877,'PereDavidsDeer-ulna.tif',243,4,127,64.2434187,66.9083069,60.8285411,1.8,66.4745034,60.9499506,-0.9355152,9.22429,8.0034645,365.7569846,760.8325628,6.9369179,95.0629021,39.6515053,92.2495641,0.220703,0.3121212,2.3561945,0.6242424),(20878,'PereDavidsDeer-ulna.tif',243,4,128,64.0191174,66.8291186,61.003049,1.8,66.4734988,61.0803731,-0.8951846,8.9414321,8.1831817,370.703578,747.1866901,6.4969415,91.307601,41.4590831,92.2291209,3.5207921,14.202371,0.5750723,42.0422496),(20879,'PereDavidsDeer-ulna.tif',243,4,129,65.4683082,66.7183517,61.2635049,1.8,66.231348,61.2647026,-0.8459079,9.4433424,9.0769474,425.8196475,777.4500305,6.1143271,85.6510449,45.0920478,91.8639722,0.220703,0.4935069,2.677945,0.9363635),(20880,'PereDavidsDeer-ulna.tif',243,4,130,64.61844,66.6521582,61.4016798,1.8,66.2083866,61.3637295,-0.7991274,9.4887988,8.6110485,424.3521996,747.2761103,5.5327118,86.7810826,44.7213823,100.1378306,3.4629945,14.0852787,0.618428,41.342274),(20881,'PereDavidsDeer-ulna.tif',243,4,131,63.2963228,66.5940308,61.5116994,1.8,66.1146659,61.4088506,-0.753064,8.8216917,9.6428225,418.9057959,714.6057948,4.9338258,74.1075338,47.4858802,88.8851972,0.220703,0.3121212,2.3561945,0.6242424),(20882,'PereDavidsDeer-ulna.tif',243,4,132,62.2228766,66.5554023,61.6142257,1.8,66.0433165,61.5001776,-0.7114831,8.8479673,9.0032932,406.8748412,678.3593134,4.4214941,75.3456869,45.9851203,96.9749078,3.568977,14.4589946,0.5456551,44.2049161),(20883,'PereDavidsDeer-ulna.tif',243,4,133,61.0189914,66.5506059,61.6975633,1.8,66.0677658,61.6277301,-0.6716918,8.9258898,10.3831677,398.3869772,645.4002616,3.9384828,62.1583199,44.6327464,78.1176458,0.5925441,0.795756,2.1587989,1.8727271),(20884,'PereDavidsDeer-ulna.tif',243,4,134,44.7166578,66.7609507,60.6197701,1.8,65.8556988,60.5791102,-0.4467497,5.9942928,11.3464671,166.4416592,415.7927488,1.391102,36.6451288,27.7666882,48.8602286,3.2958276,14.6198039,0.504166,44.7442372),(20885,'PereDavidsDeer-ulna.tif',243,4,135,49.642578,66.4884211,61.1432394,1.8,65.5369444,61.1233231,-0.4397199,6.7925821,12.476391,213.929048,519.2438914,1.499277,41.6181163,31.4945103,56.3596742,3.065467,16.0992212,0.5004408,43.0543465),(20886,'PereDavidsDeer-ulna.tif',243,4,136,53.5424186,66.239105,61.5762612,1.8,65.2825139,61.5374246,-0.4215293,6.9959863,13.0325011,255.9200384,619.2947478,1.4939135,47.5192553,36.5809806,64.3250929,3.2139163,17.7731018,0.4914182,50.4381516),(20887,'PereDavidsDeer-ulna.tif',243,4,137,51.2839364,66.283053,61.5288856,1.8,65.2094985,61.4801263,-0.3605837,6.6136496,14.258912,241.001193,576.1719812,1.0639901,40.4078502,36.4399698,55.4960718,3.3578395,15.0288859,0.5227891,47.1876551),(20888,'PereDavidsDeer-ulna.tif',243,4,138,53.4653685,66.0928036,61.8214024,1.8,64.8775224,61.7585619,-0.3279132,6.5350304,14.652771,265.003133,647.698166,0.9243082,44.203118,40.5511704,60.2487543,0.220703,0.3121212,2.3561945,0.6242424),(20889,'PereDavidsDeer-ulna.tif',243,4,139,52.1006229,66.0787397,61.8560942,1.8,64.8536446,61.7546955,-0.2946805,6.4678553,14.7036984,253.9405394,625.2819311,0.732465,42.5254868,39.261939,57.3983672,0.441406,0.6979242,1.8925469,1.8727271),(20890,'PereDavidsDeer-ulna.tif',243,4,140,59.10967,66.1713295,62.5288783,1.8,65.7592247,62.3221769,-0.3465727,8.7066616,10.4333459,378.6670757,613.4110308,1.136679,58.7933186,43.4916498,86.4435555,3.2874892,13.7226872,0.485227,38.7695713),(20891,'PereDavidsDeer-ulna.tif',243,4,141,64.7200074,66.1506963,63.0169656,1.8,65.6568191,62.7355952,-0.3225367,8.7760157,11.0694292,487.3968279,662.8068099,1.0837603,59.8772347,55.5373696,96.7915976,3.2793648,15.0029348,0.4570688,48.0482853),(20892,'PereDavidsDeer-ulna.tif',243,4,142,64.5485045,66.1284614,63.0816416,1.8,65.6501445,62.809388,-0.27051,7.9022321,12.8811632,477.7702074,656.5512595,0.7682145,50.9698736,60.4601587,83.239076,2.9571575,14.2160832,0.4844779,41.4180073),(20893,'PereDavidsDeer-ulna.tif',243,4,143,66.0639997,66.0415374,63.2594047,1.8,65.5428868,62.9898173,-0.2387753,7.6382067,11.1159109,498.5688179,689.5742724,0.6159185,62.0348866,65.2730202,102.8192072,2.7638101,14.1267162,0.5055811,44.2270979),(20894,'PereDavidsDeer-ulna.tif',243,4,144,65.029049,66.0345109,63.3160219,1.8,65.5563026,63.0781232,-0.1992591,7.6444904,11.3395964,482.3364033,666.7597566,0.4246559,58.7992493,63.0959525,97.4559046,2.9937195,13.2495348,0.5232783,39.8574014),(20895,'PereDavidsDeer-ulna.tif',243,4,145,64.7852785,66.0213736,63.3442987,1.8,65.3471051,63.0757034,-0.0937458,7.0369298,12.4936558,480.7049735,676.3954078,0.0946141,54.13911,68.3117475,91.6243036,3.2285777,14.5094389,0.456845,43.1836313),(20896,'PereDavidsDeer-ulna.tif',243,4,146,62.4060107,66.0969047,63.3159326,1.8,65.3683325,63.0241062,0.0107834,6.8310767,12.2539015,452.8254896,620.8120242,0.0012094,50.6623971,66.2890364,87.4630729,3.021268,13.5278518,0.4928364,37.2311471),(20897,'PereDavidsDeer-ulna.tif',243,4,147,61.4076809,66.0680359,63.3204682,1.8,65.3160915,63.0223372,0.0469983,7.1438284,12.4743172,437.8619396,612.918867,0.02259,49.1344621,61.2923375,84.1688362,11.6730275,18.9881555,2.7977869,86.2731533),(20898,'PereDavidsDeer-ulna.tif',243,4,148,60.6223606,66.0255025,63.3234171,1.8,65.2518386,63.0128118,0.0517311,7.2761349,14.4178741,422.3467144,600.4545113,0.0270145,41.6465359,58.0454759,70.9200794,3.4363599,14.5211841,0.4228539,46.9290854),(20899,'PereDavidsDeer-ulna.tif',243,4,149,59.801187,66.0062049,63.3268302,1.8,65.3242197,63.0688323,0.0612877,6.7144367,12.1850094,405.2613351,581.0933989,0.0373905,47.6892041,60.356714,80.9441702,2.9760163,14.1198184,0.4356829,40.2988074),(20900,'PereDavidsDeer-ulna.tif',243,4,150,56.8847385,66.036616,63.1975859,1.8,65.391324,62.9317658,0.0762142,6.6058183,11.3761158,359.6740865,519.0407934,0.0549636,45.6254842,54.4480744,77.1564506,3.2395855,13.0289564,0.456072,39.1038742),(20901,'PereDavidsDeer-ulna.tif',243,4,151,56.5537479,65.994796,63.1989425,1.8,65.4180082,62.9438786,0.0772355,6.3577626,11.0809634,353.8977334,507.7120226,0.0561152,45.8184008,55.6638798,77.7522938,2.7372894,13.1276549,0.4711663,37.1018623),(20902,'PereDavidsDeer-ulna.tif',243,4,152,55.6110506,65.932987,63.1835064,1.8,65.3281975,62.9150979,0.0615622,6.5627391,11.2627409,346.3436858,491.8991143,0.0350824,43.6749029,52.7742581,74.2848577,2.8379955,13.2274583,0.4487233,36.7897411),(20903,'PereDavidsDeer-ulna.tif',243,4,153,55.0338246,65.8527214,63.1580541,1.8,65.1855574,62.835892,0.0940608,6.4011098,11.6987185,346.6852178,500.0573604,0.0809122,42.7446273,54.1601732,72.1521161,2.8667906,13.9200446,0.4423742,38.0604076),(20904,'PereDavidsDeer-ulna.tif',243,4,154,46.7248601,65.9036507,62.6599055,1.8,65.3937591,62.3825993,-0.0281555,5.7511074,11.5756006,237.5013031,352.8579648,0.0061718,30.4829076,41.2966207,50.6260171,2.8820377,12.347539,0.4236689,37.2846987),(20905,'PereDavidsDeer-ulna.tif',243,4,155,45.6635913,65.8153531,62.6422835,1.8,65.2985298,62.3569726,-0.0429782,6.3401478,12.117983,229.8594002,339.8672768,0.0140491,28.046522,36.2545805,46.4996086,3.0463719,10.6761869,0.5191461,34.5291596),(20906,'PereDavidsDeer-ulna.tif',243,4,156,45.5074838,65.5374273,62.633686,1.8,65.0709074,62.3791387,-0.1678786,6.1214724,10.9097008,216.6841933,369.5742348,0.2117573,33.8757442,35.3973979,51.9083288,2.8079996,10.0680248,0.453844,32.6878023),(20907,'PereDavidsDeer-ulna.tif',243,4,157,44.4454622,65.4522133,62.5955542,1.8,65.0514217,62.3891209,-0.2119371,6.4114703,9.4469877,208.2504596,356.3898714,0.3277765,37.7252392,32.4809211,57.1050489,2.9139022,9.9927534,0.5328439,28.3402876),(20908,'PereDavidsDeer-ulna.tif',243,4,158,36.0691454,65.633958,61.9658405,1.8,65.3072791,61.8140235,-0.3105649,5.4919611,7.2496228,118.7049544,232.3172918,0.5614118,32.0454318,21.6143107,44.3615223,2.5285527,9.3766313,0.4636476,26.0261545),(20909,'PereDavidsDeer-ulna.tif',243,4,159,35.5837594,65.5734962,61.9237337,1.8,65.2645334,61.8188157,-0.3256531,5.9603805,7.784793,114.3215018,231.4025178,0.6070216,29.7249416,19.1802354,39.6501087,2.7641801,8.37509,0.3217506,23.0120458),(20910,'PereDavidsDeer-ulna.tif',243,4,160,34.8631789,65.5298709,61.8669352,1.8,65.287872,61.8145159,-0.3463465,6.1152965,7.6801072,108.9128767,228.5458842,0.6695792,29.7581631,17.8099094,38.9301581,2.760563,8.4934819,0.428778,27.0696211),(20911,'PereDavidsDeer-ulna.tif',243,4,161,33.8876985,65.4144078,61.7180378,1.8,65.0620374,61.6717855,-0.3352583,6.6643517,7.6009694,98.6902826,241.5103404,0.6113885,31.7736235,14.8086847,40.9106033,2.914828,8.607417,0.3947911,25.7675849),(20912,'PereDavidsDeer-ulna.tif',243,4,162,33.1970671,65.3840126,61.6795865,1.8,65.0362509,61.6371761,-0.3261263,7.8623341,7.7523647,97.6557229,239.7512941,0.567895,30.9262145,12.4207038,36.2738763,2.9926794,8.8115518,0.3851575,25.1433425),(20913,'PereDavidsDeer-ulna.tif',243,4,163,32.6743517,65.348923,61.6467472,1.8,65.0109357,61.6045694,-0.3330034,6.1102111,7.698312,96.3621879,237.554654,0.581889,30.8580184,15.7706807,38.2044197,2.7696882,9.7734306,0.4434483,29.2009178),(20914,'PereDavidsDeer-ulna.tif',243,4,164,32.4438658,65.2843063,61.6179796,1.8,64.9700073,61.5789251,-0.3354571,6.3856812,7.646155,96.3720724,240.3467619,0.5860076,31.4336765,15.0919016,40.2168644,2.9627205,9.5923323,0.4018706,30.2665662),(20915,'PereDavidsDeer-ulna.tif',243,4,165,27.2301,65.519041,61.1169108,1.8,65.1361807,61.1458779,-0.3204293,5.9535624,7.8676941,57.2975527,174.3436858,0.4502435,22.1594387,9.6240787,27.7101842,2.7264627,9.8824682,0.4136892,31.9564569),(20916,'PereDavidsDeer-ulna.tif',243,4,166,27.2196939,65.4738446,61.0859891,1.8,65.1374218,61.1246569,-0.3269911,5.7427248,8.0923592,56.8193691,176.8807806,0.4680256,21.8577519,9.8941481,26.5785152,2.337341,8.4934819,0.428778,23.0655973),(20917,'PereDavidsDeer-ulna.tif',243,4,167,27.1291526,65.4270569,61.0429829,1.8,65.0502644,61.0544583,-0.3424863,6.0638536,7.8754306,55.4136194,178.6106922,0.509946,22.6794826,9.1383505,27.5553421,2.6672889,8.8115518,0.3851575,26.6503969),(20918,'PereDavidsDeer-ulna.tif',243,4,168,27.0364269,65.4084034,61.0000821,1.8,65.1168966,61.0568932,-0.3593411,6.1702305,7.818356,54.0682504,181.518956,0.5572342,23.2170238,8.7627602,27.8058265,2.3696161,9.0810636,0.4527785,25.2726274),(20919,'PereDavidsDeer-ulna.tif',243,4,169,27.1359868,65.3665061,60.9393544,1.8,65.0446917,60.9690673,-0.3413752,6.3255556,7.8565944,58.1399603,192.1084615,0.5068996,24.4518746,9.1912812,28.7860295,2.7879464,10.5407347,0.3416155,31.9029054),(20920,'PereDavidsDeer-ulna.tif',243,4,170,22.8623648,65.8171573,60.5192487,1.8,65.5505377,60.5717312,-0.3016798,4.9009276,6.8687914,42.407865,123.2492749,0.3363931,17.9433712,8.6530283,21.6867063,2.307653,7.4026037,0.4636476,22.3878035),(20921,'PereDavidsDeer-ulna.tif',243,4,171,22.7858166,65.8027625,60.4761018,1.8,65.5324918,60.5488331,-0.3017825,4.9467397,6.7084617,42.6452655,125.9489027,0.3354881,18.7746325,8.6208832,23.7479829,2.2611372,7.4026037,0.4636476,22.0756823),(20922,'PereDavidsDeer-ulna.tif',243,4,172,22.014445,65.941901,60.3506648,1.8,65.8263907,60.4375208,-0.2848456,4.7599631,6.3059461,40.8003806,115.0042868,0.2897329,18.2374359,8.5715749,22.7918856,2.1055771,7.2058769,0.4773454,23.765573),(20923,'PereDavidsDeer-ulna.tif',243,4,173,22.0932958,65.9006472,60.3199636,1.8,65.7900248,60.4518584,-0.301575,4.855334,6.586571,40.9393805,118.9752671,0.3248582,18.063309,8.4318362,22.0382886,2.0072492,6.9090968,0.4636476,20.0736704),(20924,'PereDavidsDeer-ulna.tif',243,4,174,20.2807003,66.0876199,60.0562408,1.8,65.6805305,60.4198355,-0.158655,6.680892,10.8754772,36.9625748,111.5230801,0.0843708,10.2545459,5.5325808,13.5845853,0.3121212,0.6242424,0.7853982,1.2484847),(20925,'PereDavidsDeer-ulna.tif',243,4,175,20.3729538,66.0567663,60.0042606,1.8,65.5836995,60.3938489,-0.1714339,6.35552,13.4110264,36.5033554,120.077521,0.0988183,8.9536414,5.7435671,11.5664061,2.370865,9.0810636,0.4527785,25.1655243),(20926,'PereDavidsDeer-ulna.tif',243,4,176,20.5548185,66.0073184,59.9590879,1.8,65.4186974,60.3016744,-0.1826742,6.8898793,13.3490047,37.4517624,126.2477378,0.1130526,9.4574645,5.4357647,12.1350734,2.399221,8.8115518,0.3851575,25.8654999),(20927,'PereDavidsDeer-ulna.tif',243,4,177,19.0015953,66.253585,59.7367818,1.8,65.8376732,60.136179,-0.1057632,6.2643016,13.1951175,35.022454,105.9203289,0.035293,8.0272365,5.5907995,10.6086257,0.3121212,0.6242424,0.7853982,1.2484847),(20928,'PereDavidsDeer-ulna.tif',243,4,178,19.0688592,66.1920098,59.7092136,1.8,65.674514,60.0837536,-0.0934879,6.5094493,14.6925741,36.8877118,112.9556076,0.0276961,7.6879386,5.6667945,10.1460107,0.441406,0.6242424,2.3561945,1.2484847),(20929,'PereDavidsDeer-ulna.tif',243,4,179,19.5332999,65.8585863,59.6294625,1.8,64.4740908,59.9433109,-0.1259635,5.4319154,17.3282094,31.3377771,162.4964637,0.0513826,9.3775681,5.7691946,11.1710103,0.220703,0.3121212,2.3561945,0.6242424),(20930,'PereDavidsDeer-ulna.tif',243,4,180,19.9671715,65.7947369,59.6100492,1.8,64.3628749,59.9206577,-0.1322496,5.4881453,15.2924988,33.0094346,173.2180012,0.0578656,11.3269914,6.0146795,13.4706553,2.6160473,15.4318594,0.2900869,44.5522128),(20931,'PereDavidsDeer-ulna.tif',243,4,181,20.5360283,65.7442354,59.592493,1.8,64.3638779,59.8686255,-0.1444256,5.2863081,15.4535691,35.4418512,177.8367641,0.0708977,11.5078118,6.7044619,13.7772765,0.3121212,0.6242424,0.7853982,1.2484847),(20932,'PereDavidsDeer-ulna.tif',243,4,182,17.7710969,66.0651705,59.2157129,1.8,64.5710056,59.4751529,-0.1073202,4.8338025,14.8639205,23.208741,134.1093461,0.0339827,9.0224746,4.8013424,10.5693045,2.6224647,13.6800259,0.3115468,44.9936188),(20933,'PereDavidsDeer-ulna.tif',243,4,183,18.2403347,66.0509876,59.1941982,1.8,64.6226225,59.5004022,-0.112387,4.9031853,14.8480914,25.2796095,139.4530111,0.0382371,9.3919823,5.1557524,11.0770942,2.2166125,12.0075414,0.2984989,36.7583714),(20934,'PereDavidsDeer-ulna.tif',243,4,184,17.474646,66.5083713,59.0614539,1.8,65.9994165,59.3436845,-0.0105828,5.6547826,12.6547149,29.3998847,87.1226189,0.0003262,6.8845976,5.1991184,9.2057738,0.220703,0.3121212,2.3561945,0.6242424),(20935,'PereDavidsDeer-ulna.tif',243,4,185,18.4040735,66.4463336,59.0546272,1.8,65.719594,59.2804785,0.0213161,5.5068995,12.8247067,35.0073087,106.9479062,0.0013935,8.3392087,6.3569907,11.0659577,0.220703,0.4935069,2.677945,0.9363635),(20936,'PereDavidsDeer-ulna.tif',243,4,186,17.4004742,66.6288477,58.8367776,1.8,65.8778775,59.0258498,0.0782065,15.4315457,18.9432177,28.8535583,97.205395,0.0177015,5.1314088,1.8697776,5.1593441,0.220703,0.3121212,2.3561945,0.6242424),(20937,'PereDavidsDeer-ulna.tif',243,4,187,18.4494622,66.6497184,58.8467773,1.8,65.8938586,59.0435578,0.0894655,5.4831056,14.7575922,32.192383,109.1460533,0.0245462,7.3959256,5.8711951,9.5570575,0.220703,0.6979242,2.8198421,1.3777695),(20938,'PereDavidsDeer-ulna.tif',243,4,188,19.5076608,66.6378212,58.8388104,1.8,65.7559963,58.9497242,0.103626,5.7909087,16.7055062,37.0209887,125.1621947,0.0347885,7.4922719,6.3929499,9.6752711,0.220703,0.3121212,2.3561945,0.6242424),(20939,'PereDavidsDeer-ulna.tif',243,4,189,20.0963853,66.5056668,58.7435545,1.8,65.2220032,58.8315328,0.0616185,4.4609644,13.7066096,36.5167738,147.9640951,0.0127011,10.7950908,8.1858474,13.4035282,2.5729736,12.5023916,0.3608368,36.2855956),(20940,'PereDavidsDeer-ulna.tif',243,4,190,21.4634632,66.4929117,58.7238759,1.8,65.1769643,58.7537536,0.071133,4.6743897,14.6546584,41.3844868,164.4415365,0.01807,11.2211102,8.8534523,14.0444305,2.5122752,14.100832,0.3019512,42.8936919),(20941,'PereDavidsDeer-ulna.tif',243,4,191,23.2821548,66.3686735,58.7556581,1.8,64.9122043,58.8061577,0.0563505,5.3165688,15.1069556,48.0141078,203.0736638,0.0123086,13.442395,9.031033,16.5428985,0.220703,0.3121212,2.3561945,0.6242424),(20942,'PereDavidsDeer-ulna.tif',243,4,192,19.6756506,66.6782681,58.2943001,1.8,65.0487456,58.2920667,0.0660447,3.8222725,14.9737532,28.9463555,153.8782799,0.0142831,10.2765337,7.5730748,12.1563545,0.6242424,1.2484847,0.7853982,2.7555391),(20943,'PereDavidsDeer-ulna.tif',243,4,193,21.2917537,66.5925813,58.2553967,1.8,64.6467783,58.2250329,0.0731107,4.6008942,16.8400587,35.8863594,204.9040384,0.0189342,12.1676558,7.7998663,14.2078123,2.5737955,15.5826322,0.2724631,48.3734002),(20944,'PereDavidsDeer-ulna.tif',243,4,194,21.1552629,66.8455864,58.1496714,1.8,65.0777256,58.0422722,0.1363192,4.3003925,17.0422017,37.3466007,190.7779403,0.0651163,11.1944421,8.6844633,13.2725225,0.220703,0.3121212,2.3561945,0.6242424),(20945,'PereDavidsDeer-ulna.tif',243,4,195,22.8467481,66.8445258,58.1484236,1.8,64.901032,57.9895114,0.1425665,4.1028206,17.1521323,44.6098753,234.2640886,0.0768712,13.6580155,10.8729772,16.1998222,0.220703,0.3121212,2.3561945,0.6242424),(20946,'PereDavidsDeer-ulna.tif',243,4,196,19.7209655,67.3505832,57.7452791,1.8,65.724581,57.5228325,0.2188117,3.769245,14.5006039,30.8582704,160.5753567,0.154873,11.0737013,8.1868571,12.9138093,5.1751497,10.1259153,2.785373,28.2239966),(20947,'PereDavidsDeer-ulna.tif',243,4,197,21.3599327,67.3802591,57.7042295,1.8,65.6696742,57.521292,0.2130714,4.5387966,17.389292,36.7635026,190.0177524,0.1591903,10.9272852,8.0998348,12.7944298,0.220703,0.3121212,2.3561945,0.6242424),(20948,'PereDavidsDeer-ulna.tif',243,4,198,21.775516,67.6158438,57.5763966,1.8,66.1621918,57.3634367,0.268242,4.3256814,17.3879548,38.1405394,179.8232465,0.254935,10.3418285,8.8172327,12.2661061,5.548577,10.6966983,2.7610863,30.0431721),(20949,'PereDavidsDeer-ulna.tif',243,4,199,23.2640289,67.650588,57.5056201,1.8,66.1173706,57.2847648,0.2609945,3.9173965,14.8706065,43.8322781,202.5877627,0.2581741,13.6233692,11.1891348,16.2581878,5.7901827,10.9576317,2.8134728,31.8623476),(20950,'PereDavidsDeer-ulna.tif',243,4,200,24.6603916,67.6587434,57.429949,1.8,66.1613547,57.2268511,0.2593548,5.7735734,15.5473527,51.3159608,228.3970253,0.2703198,14.6904125,8.8880763,17.4640721,6.0876161,11.8852203,2.7610863,34.4350503),(20951,'PereDavidsDeer-ulna.tif',243,4,201,27.0403384,67.5258,57.3109764,1.8,65.618613,57.0428829,0.2261159,5.7394054,17.545139,63.7842838,302.7796383,0.2265212,17.257181,11.1133957,20.5043502,6.4103618,12.8425633,2.808973,37.890565),(20952,'PereDavidsDeer-ulna.tif',243,4,202,23.2118798,67.7372554,56.7656001,1.8,65.6613352,56.4293934,0.2142505,4.2012444,17.6003905,43.0107877,236.524771,0.174883,13.4386093,10.2376305,15.6406559,2.9786271,16.5938718,0.2417529,56.8985871),(20953,'PereDavidsDeer-ulna.tif',243,4,203,24.9960318,67.6419609,56.6601496,1.8,65.3309057,56.3356149,0.1926638,3.9883269,18.2470551,50.6122729,290.6118735,0.1527354,15.9265082,12.6901015,18.2981481,0.220703,0.3121212,2.3561945,0.6242424),(20954,'PereDavidsDeer-ulna.tif',243,4,204,24.7542097,67.8535089,56.39734,1.8,65.6173668,56.0552123,0.2116357,5.3966691,17.8141736,48.8381466,269.1865796,0.1820463,15.1108093,9.0496833,17.4779994,5.8817267,11.6555426,2.8138541,32.3573051),(20955,'PereDavidsDeer-ulna.tif',243,4,205,26.9634507,67.8757662,56.2833896,1.8,65.7769788,55.9933919,0.2003644,4.6945721,17.8539528,58.6821541,309.7617283,0.1780106,17.3497562,12.5000007,20.224621,0.220703,0.4935069,2.677945,0.9363635),(20956,'PereDavidsDeer-ulna.tif',243,4,206,28.9938381,67.8339746,56.1362154,1.8,65.7471141,55.8282185,0.1814708,5.1168309,17.8515232,69.3610388,350.1204787,0.1573966,19.612919,13.5554681,23.0784086,2.5147983,15.7999304,0.2110933,45.9299824),(20957,'PereDavidsDeer-ulna.tif',243,4,207,30.9485925,67.7794394,55.9914212,1.8,65.6805325,55.7388507,0.1559862,4.8759689,17.925107,81.0564864,397.9914877,0.1244906,22.2030188,16.6236676,26.4347326,0.662109,0.795756,2.1587989,2.0020119),(20958,'PereDavidsDeer-ulna.tif',243,4,208,28.6538584,68.2922502,55.5643995,1.8,66.5444506,55.3629377,0.2150783,5.1302139,18.8874378,69.0222457,299.18257,0.2175294,15.8402941,13.4540677,19.0810198,6.7453508,12.3376728,2.9617392,36.1784926),(20959,'PereDavidsDeer-ulna.tif',243,4,209,31.2333973,68.0727088,55.3195707,1.8,65.819408,55.0255579,0.1602939,5.4232565,19.8674419,86.9608208,401.2151964,0.1326109,20.1946077,16.0347978,24.4260944,0.662109,1.680824,2.7367009,3.5090662),(20960,'PereDavidsDeer-ulna.tif',243,4,210,32.9802051,67.9159556,55.1101663,1.8,65.5376738,54.8551269,0.1287502,5.8301134,19.0304219,107.337889,475.2769225,0.0906143,24.9745867,18.4109435,30.4328375,8.9991969,24.7817139,3.0702852,105.1243265),(20961,'PereDavidsDeer-ulna.tif',243,4,211,34.3341165,67.6236385,54.8341518,1.8,65.1409178,54.6263515,0.0885202,6.1575897,19.5208623,132.157719,557.1386068,0.0447224,28.540676,21.462573,35.2849932,3.3677813,20.1904046,0.2767982,63.6267802),(20962,'PereDavidsDeer-ulna.tif',243,4,212,27.6304357,67.6563008,53.8410606,1.8,64.9830221,53.8304768,-0.0252503,4.983916,19.5705146,68.2418185,412.0963228,0.0029355,21.0569998,13.6924095,24.5213482,0.220703,0.3121212,2.3561945,0.6242424),(20963,'PereDavidsDeer-ulna.tif',243,4,213,24.3788932,67.8254972,53.1342045,1.8,64.9353466,53.193707,-0.0775384,4.4206733,19.742772,34.996347,350.1657811,0.0243796,17.736404,7.9165197,19.5055635,0.628686,1.103515,2.4980915,2.6262542),(20964,'PereDavidsDeer-ulna.tif',243,4,214,26.8863121,67.6247855,52.9734681,1.8,64.6642526,53.0173816,-0.096024,4.6902154,19.5693127,43.3869892,427.4594822,0.0411912,21.843357,9.2505322,24.0568701,0.662109,0.795756,2.5535901,1.8727271),(20965,'PereDavidsDeer-ulna.tif',243,4,215,30.4355158,67.5032536,52.9087793,1.8,64.7258588,52.9391538,-0.114101,5.0233554,19.446636,57.7770998,510.1698335,0.0657541,26.2343489,11.5016947,29.1908994,0.220703,0.4935069,2.677945,0.9363635),(20966,'PereDavidsDeer-ulna.tif',243,4,216,29.9955776,68.105001,52.5693697,1.8,66.1400962,52.4223518,-0.1061052,4.9861776,18.1191674,63.3058613,355.2978658,0.0560723,19.608951,12.6962708,22.9671784,0.3121212,0.6242424,2.3561945,1.2484847),(20967,'PereDavidsDeer-ulna.tif',243,4,217,31.6411428,68.1502553,52.3056631,1.8,65.6904196,52.2306431,-0.089579,5.4137182,19.1169627,80.1300608,442.1176045,0.0422038,23.1269795,14.8012988,27.258186,0.5586559,0.9870138,2.0344439,2.3141331),(20968,'PereDavidsDeer-ulna.tif',243,4,218,28.0549786,68.6449748,51.6715818,1.8,66.506559,51.4532818,-0.115068,4.6317419,18.2257398,63.293576,286.2383182,0.0616383,15.7051687,13.6651778,19.0733034,0.441406,0.9870138,0.4636476,2.1312967),(20969,'PereDavidsDeer-ulna.tif',243,4,219,31.070987,68.4761262,51.4621644,1.8,66.3540302,51.2719993,-0.136949,5.0421951,17.6036016,76.2202253,369.7830545,0.0965173,21.0061022,15.1164767,25.1708768,0.6242424,0.9363635,0.7853982,2.0020119),(20970,'PereDavidsDeer-ulna.tif',243,4,220,32.8798481,68.587662,51.2007196,1.8,66.2632245,51.1399364,-0.1343464,5.2998756,19.882366,90.6530247,406.6460211,0.0983142,20.4525971,17.1047458,24.8224516,0.441406,0.6979242,1.8925469,1.8727271),(20971,'PereDavidsDeer-ulna.tif',243,4,221,35.4144707,68.6353935,50.9816984,1.8,66.3677087,50.9428332,-0.1336526,6.002542,19.7712361,114.6630846,456.6879002,0.1048086,23.0986014,19.1024211,28.7528798,0.4193881,0.9870138,0.4636476,2.0020119),(20972,'PereDavidsDeer-ulna.tif',243,4,222,34.8863973,68.7435858,50.4772245,1.8,67.0547403,50.4204781,-0.1422677,6.5427406,20.2437642,109.0691469,460.26071,0.1168922,22.7359253,16.6702538,27.892451,0.3121212,0.6242424,0.7853982,1.2484847),(20973,'PereDavidsDeer-ulna.tif',243,4,223,34.9987841,68.5114411,50.0237557,1.8,66.7480494,50.0047982,-0.2199248,7.2418576,20.0678584,97.3082564,498.6154249,0.2776111,24.8464692,13.4369193,29.1954434,0.441406,0.795756,2.5535901,1.6898907),(20974,'PereDavidsDeer-ulna.tif',243,4,224,35.7820084,68.6320613,49.7750848,1.8,66.6243243,49.8832134,-0.2298374,4.9991962,19.9388214,111.8179458,490.4673407,0.3095238,24.5986125,22.3671851,29.6508967,0.3121212,0.6242424,0.7853982,1.2484847),(20975,'PereDavidsDeer-ulna.tif',243,4,225,39.2922443,68.605647,49.5293982,1.8,66.2678237,49.6292142,-0.2270392,5.7604404,20.24388,145.8583767,613.5532243,0.3318046,30.3080844,25.3206987,36.9913978,0.441406,0.9870138,0.4636476,2.0020119),(20976,'PereDavidsDeer-ulna.tif',243,4,226,42.9670308,68.7165849,49.3641667,1.8,66.2155509,49.4735652,-0.2163436,9.2788846,20.2074776,188.0967664,739.4124247,0.3299788,36.5910303,20.2714847,45.3983026,0.5925441,0.795756,2.1587989,1.8727271),(20977,'PereDavidsDeer-ulna.tif',243,4,227,44.6102785,69.1865083,49.0929821,1.8,67.622065,49.0111828,-0.2358114,5.3558326,20.622101,225.1986698,601.5311576,0.4058339,29.169247,42.0473692,39.2171345,0.441406,0.6242424,0.7853982,1.2484847),(20978,'PereDavidsDeer-ulna.tif',243,4,228,45.266754,69.0282785,48.7599746,1.8,67.2574244,48.7419444,-0.2805398,10.1979543,20.5293847,229.0281986,710.6860347,0.5783538,34.6179899,22.4582491,44.8055949,4.6668672,17.7278234,0.3296244,62.2895684),(20979,'PereDavidsDeer-ulna.tif',243,4,229,42.5444657,69.3902042,48.1162541,1.8,67.3770664,48.2112992,-0.2086321,10.3065784,21.2720655,214.3117073,680.0700229,0.3041891,31.9700983,20.7936813,41.8115126,0.220703,0.3121212,2.3561945,0.6242424),(20980,'PereDavidsDeer-ulna.tif',243,4,230,45.5955009,69.4437031,47.9648134,1.8,67.5457625,48.0082248,-0.2325136,5.5854112,20.9432225,259.8181453,786.5093995,0.4034847,37.5543639,46.5172819,49.0178586,3.7338057,12.9031061,0.2242348,46.3713884),(20981,'PereDavidsDeer-ulna.tif',243,4,231,40.2055533,70.4925804,47.0923045,1.8,69.5972696,47.1489761,-0.1410265,6.0560257,17.338282,249.3582721,457.6463169,0.13239,26.3951363,41.1752333,40.3448062,0.220703,0.3121212,2.3561945,0.6242424),(20982,'PereDavidsDeer-ulna.tif',243,4,232,42.7770773,70.5342126,46.8316689,1.8,69.6907545,46.9224941,-0.2106524,5.9585799,21.7928949,301.2522338,539.4673554,0.3117162,24.7542769,50.5577231,37.8637081,0.6242424,0.795756,2.1587989,1.8727271),(20983,'PereDavidsDeer-ulna.tif',243,4,233,40.3681555,70.8402415,45.9599227,1.8,69.6634191,46.1075214,-0.1191574,6.2240228,22.7431037,295.8188667,564.6340069,0.0950765,24.826603,47.5285645,37.7791644,0.441406,0.6979242,1.8925469,1.6898907),(20984,'PereDavidsDeer-ulna.tif',243,4,234,44.2888233,70.7950386,45.7297064,1.8,69.3850203,45.8198392,-0.1622585,6.5734283,22.697606,390.1803105,727.8117904,0.1926384,32.0655751,59.357202,49.1106018,0.220703,0.3121212,2.3561945,0.6242424),(20985,'PereDavidsDeer-ulna.tif',243,4,235,43.4362244,70.9341441,44.9459421,1.8,69.3513342,45.1471756,-0.143303,6.7054286,22.9762635,407.3791908,780.8765928,0.147651,33.9862308,60.7536398,51.7012502,0.3121212,0.6242424,2.3561945,1.2484847),(20986,'PereDavidsDeer-ulna.tif',243,4,236,53.9090264,70.6999808,44.9072772,1.8,68.991802,44.9173078,-0.1574181,7.4119787,22.7408477,569.2158672,1203.1545285,0.2208154,52.9071978,76.7967488,77.8882911,0.220703,0.3121212,2.3561945,0.6242424),(20987,'PereDavidsDeer-ulna.tif',243,4,237,42.9473697,71.0480793,43.0138993,1.8,69.6577133,43.2388315,-0.2381875,6.7656438,20.1295228,324.5253745,785.5623165,0.3984692,39.025382,47.9666656,54.8387526,3.1593904,7.7529292,0.0855053,34.0028323),(20988,'PereDavidsDeer-ulna.tif',243,4,238,50.7507411,71.5059013,42.4514904,1.8,70.533572,42.4590742,0.0175944,6.9483328,20.0492765,466.2593782,686.5856003,0.0026181,34.2449065,67.1037773,57.2045978,0.441406,0.9870138,2.0344439,2.3141331),(20989,'PereDavidsDeer-ulna.tif',243,4,239,53.9398464,70.7947034,41.7920773,1.8,69.8615142,41.8375306,-0.4253073,7.7311452,21.1555786,436.8154526,858.9040049,1.5304474,40.5994097,56.5007439,57.5262531,0.220703,0.3121212,2.3561945,0.6242424),(20990,'PereDavidsDeer-ulna.tif',243,4,240,44.0960357,70.999014,40.2842637,1.8,69.3963239,40.5345578,-0.3109851,5.8530677,22.6978777,285.1818393,747.5076638,0.6881477,32.932932,48.7234819,44.747548,0.441406,0.795756,2.1587989,1.6898907),(20991,'PereDavidsDeer-ulna.tif',243,4,241,51.524002,70.7450702,40.2813537,1.8,68.9249298,40.4073412,-0.2992208,6.5514461,22.5686428,365.780519,1064.9383098,0.7461771,47.1866349,55.8320277,62.5956379,11.1297643,22.9796236,3.0935527,86.5668985),(20992,'PereDavidsDeer-ulna.tif',243,4,242,48.2448277,71.2698047,39.3883695,1.8,70.6581502,39.1884462,-0.3699719,6.3483485,16.693723,334.7739073,684.8966555,1.0513094,41.0271967,52.7340151,57.0922095,2.9354899,3.9295052,0.6659692,14.4019377),(20993,'PereDavidsDeer-ulna.tif',243,4,243,40.31887,71.5642018,38.1653986,1.8,71.2045831,38.0352238,-0.3856796,5.3920403,12.5384746,214.3149645,535.3506275,0.950975,42.6966312,39.7465436,57.1140926,2.7383138,7.2395967,0.6556956,25.1655243),(20994,'PereDavidsDeer-ulna.tif',243,4,244,49.2949671,72.3324495,38.7900294,1.8,71.9430365,38.5502294,0.0199126,6.6067972,12.0638826,411.2489177,702.7215646,0.0032572,58.2500335,62.2463358,92.0506026,1.9273246,2.304207,1.2793395,7.2009688),(20995,'PereDavidsDeer-ulna.tif',243,4,245,55.1195096,72.5405232,38.6153899,1.8,72.0865203,38.3471022,0.1162162,6.8329648,10.8383571,472.6726184,771.3900038,0.1235183,71.1722263,69.1753336,112.8857615,1.9284866,2.4675346,0.4636476,8.1373324),(20996,'PereDavidsDeer-ulna.tif',243,4,246,60.0567659,72.5557548,38.3469722,1.8,72.1267021,38.1914019,0.2404586,6.9682211,14.3996631,535.6294288,875.7536712,0.5676814,60.81765,76.8674558,95.773828,1.9657122,5.1665248,1.2220253,18.2766766),(20997,'PereDavidsDeer-ulna.tif',243,4,247,63.5704115,72.9156367,38.111259,1.8,72.4630998,38.0609488,0.4510146,11.2838957,21.2084732,585.4778022,930.4161873,2.0129613,43.870022,51.8861411,63.3243745,0.220703,0.6979242,1.8925469,1.5070544),(20998,'PereDavidsDeer-ulna.tif',243,4,248,74.0337667,73.3803547,38.6899787,1.8,72.8066532,38.5190435,0.7851559,18.5953456,17.1380848,796.5683831,1217.6937322,6.1664907,71.0519143,42.8369766,79.6517696,0.441406,0.795756,2.1587989,1.6898907),(20999,'PereDavidsDeer-ulna.tif',243,4,249,77.1406116,73.4783399,38.5508329,1.8,72.6610419,38.3156507,0.8737183,17.5503106,13.8473819,867.315789,1305.7872758,7.5579999,94.2984955,49.4188284,97.5039066,0.220703,0.4935069,2.0344439,1.0656484),(21000,'PereDavidsDeer-ulna.tif',243,4,250,87.7049438,73.1156849,38.8546431,1.8,72.1792217,38.6064005,0.8493346,14.5829359,39.0404129,1220.7649137,1505.3613602,8.24079,38.5590533,83.7118756,67.7536397,14.4175515,19.7402765,2.9617392,97.7497093),(21001,'PereDavidsDeer-ulna.tif',243,4,251,91.4119082,72.9824351,38.7605712,1.8,72.0312135,38.4468475,0.7773432,12.0943322,12.4740876,1277.1631951,1565.5448024,7.4949448,125.503752,105.6001421,163.6955474,0.220703,0.4935069,2.0344439,1.0656484),(21002,'PereDavidsDeer-ulna.tif',243,4,252,101.3396032,72.8327881,39.0622149,1.8,71.8674888,38.7160851,0.7111694,11.7067859,11.2242354,1571.1312068,1856.9640765,7.1958486,165.4423669,134.2068802,232.6692616,1.0860507,1.2869086,2.1112158,3.5626178),(21003,'PereDavidsDeer-ulna.tif',243,4,253,110.0529034,72.7653457,39.3048681,1.8,72.1592456,38.936803,1.3275563,13.053457,10.4976188,1739.2188884,2023.2776284,17.2781589,192.7368174,133.2381826,269.6676969,0.220703,0.3121212,2.3561945,0.6242424),(21004,'PereDavidsDeer-ulna.tif',243,4,254,109.4601492,72.8974812,39.2235269,1.8,72.3218364,38.844198,1.4482623,12.0360123,10.899269,1609.1581124,2038.6855515,17.97081,187.0479161,133.6952862,302.9780356,16.6662102,20.0985197,2.1130991,102.5164483),(21005,'PereDavidsDeer-ulna.tif',243,4,255,109.6754613,73.0583662,39.1810174,1.8,72.5921003,38.9251419,1.5566182,14.1275919,11.1538249,1399.435372,2133.8468356,18.2755694,191.3107697,99.0568941,249.9723899,2.6943986,13.8340472,0.978369,35.0684807),(21006,'PereDavidsDeer-ulna.tif',243,4,256,102.9140963,73.1795602,39.0275511,1.8,72.7802354,38.8451627,-1.5014972,20.7161594,10.9936515,1012.5232085,2039.6410107,17.0701092,185.5289855,48.8760098,145.3961046,2.3608172,13.0588308,1.0390723,37.016941),(21007,'PereDavidsDeer-ulna.tif',243,4,257,75.3621719,73.726182,37.6889526,1.8,73.4598568,38.4167815,-1.5547516,7.2929515,9.6582456,522.8899725,1259.0901748,12.5571288,130.3642745,71.6979913,181.1733305,12.4442681,19.1312714,1.3734008,62.9803561),(21008,'PereDavidsDeer-ulna.tif',243,4,258,52.5070398,74.1815018,36.2866965,1.8,73.9622891,36.0862587,1.3399211,5.9680879,7.7659213,254.595021,547.9935227,8.2929355,70.5638784,42.6593951,101.5332327,2.4799107,8.0002935,1.1441688,26.3069059),(21009,'PereDavidsDeer-ulna.tif',243,4,259,37.8676741,74.3606941,35.9201828,1.8,74.1573585,35.5967341,1.323587,4.9701462,6.8990807,130.7560483,304.6220279,5.9333746,44.154003,26.30829,62.0110454,8.2679672,12.525746,1.8200485,34.8764563),(21010,'PereDavidsDeer-ulna.tif',243,4,260,22.3765951,74.50406,35.8301047,1.8,74.476071,35.6359242,1.367831,3.8668186,5.8542377,48.1178523,112.0932437,3.5778969,19.1473681,12.4437832,27.3033471,6.7921432,10.616709,1.9320001,29.0310753),(21011,'PereDavidsDeer-ulna.tif',243,4,261,6.9480713,74.5902048,35.9407714,1.8,74.5784665,35.9514103,1.3501101,2.6105859,3.2439481,7.0789698,11.0720361,1.1025236,3.413136,2.7116403,5.5276719,4.855466,6.4345429,1.957672,17.7503493),(21012,'PereDavidsDeer-ulna.tif',243,4,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21013,'PereDavidsDeer-ulna.tif',243,4,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21014,'PereDavidsDeer-ulna.tif',243,4,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21015,'PereDavidsDeer-ulna.tif',243,4,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21016,'PereDavidsDeer-ulna.tif',243,4,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21017,'PereDavidsDeer-ulna.tif',243,4,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21018,'PereDavidsDeer-ulna.tif',243,4,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21019,'PereDavidsDeer-ulna.tif',243,4,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21020,'PereDavidsDeer-ulna.tif',243,4,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21021,'PereDavidsDeer-ulna.tif',243,4,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21022,'PereDavidsDeer-ulna.tif',243,4,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21023,'PereDavidsDeer-ulna.tif',243,4,273,0.0398387,48.1132542,65.2119718,1.8,48.1132542,65.2177368,1.5635356,0.0088554,1.2195993,0.0001629,0.022431,0.0066394,0.0183921,0.018394,0.0185252,11.476556,11.7781812,1.3439975,37.8148318),(21024,'PereDavidsDeer-ulna.tif',243,4,274,3.3125036,48.8624334,65.1358179,1.8,49.0021204,65.138757,1.5685159,1.4604283,5.5477017,1.1545274,18.9033203,0.5520811,3.4074147,0.7905403,3.5840753,15.8906161,16.3156102,0.5241796,52.6268057),(21025,'PereDavidsDeer-ulna.tif',243,4,275,9.3062905,49.514541,65.1366644,1.8,49.6550084,65.1429511,1.5694448,2.3530879,7.693425,9.1381355,106.4244062,1.5510456,13.8331636,3.8834654,14.7742863,18.9804581,19.3779246,0.6480569,62.6054954),(21026,'PereDavidsDeer-ulna.tif',243,4,276,22.8592798,58.7823013,65.1208996,1.8,63.9643304,65.2441785,0.0107695,9.1496826,25.8332514,332.7308978,4208.9609678,0.0004419,162.9280381,36.3652939,168.1683077,21.4081911,21.8083156,0.9434881,70.7650095),(21027,'PereDavidsDeer-ulna.tif',243,4,277,223.2744097,71.4245347,67.8756202,1.8,67.7158587,68.3800285,0.2107694,12.0977013,25.4523765,4794.9580271,19816.3968998,1.628779,778.5676468,396.3528216,927.1128888,23.1738151,23.6595264,0.9310265,76.8467785),(21028,'PereDavidsDeer-ulna.tif',243,4,278,342.6389026,69.0791618,69.0089244,1.8,66.8011568,68.421137,0.1171501,12.3837666,22.568037,8622.4895936,28448.9510622,0.7801588,1260.5859816,696.2735864,1440.0895806,24.7187361,25.3001121,2.7286827,82.2507535),(21029,'PereDavidsDeer-ulna.tif',243,4,279,352.4394797,68.8537756,68.9585049,1.8,66.3987533,68.3313358,0.1197594,12.9590725,22.4495823,9055.2727208,30303.4069718,0.8384468,1349.8427967,698.7593217,1518.3829382,26.0429541,26.5761606,0.5603599,86.513347),(21030,'PereDavidsDeer-ulna.tif',243,4,280,358.1399893,68.7628698,68.91121,1.8,66.2245629,68.2771026,0.1175327,13.6302623,22.4024859,9331.3852462,31364.0701793,0.8207634,1400.0263322,684.6078974,1551.8883604,27.1464691,27.5463517,1.1322331,90.0224132),(21031,'PereDavidsDeer-ulna.tif',243,4,281,363.3070231,68.7529193,68.8719616,1.8,66.15182,68.2308743,0.1128308,13.9665636,22.3486944,9590.2886423,32198.3416043,0.7675989,1440.7258464,686.6605786,1587.2547309,27.997257,28.2715289,2.9212302,92.4658311),(21032,'PereDavidsDeer-ulna.tif',243,4,282,364.9688396,68.7583024,68.8613385,1.8,66.1658234,68.2148461,0.1079712,14.4530011,22.3325735,9688.434929,32460.8378272,0.7063698,1453.5198034,670.340705,1584.4773038,28.2499841,28.730411,0.752801,93.9193339),(21033,'PereDavidsDeer-ulna.tif',243,4,283,365.7777915,68.7937264,68.846097,1.8,66.1958593,68.2247177,0.1041499,14.542337,22.3108294,9746.7914466,32614.8247212,0.6588898,1461.8382927,670.2355643,1591.3887357,28.6872798,29.0004079,0.9257731,94.8556974),(21034,'PereDavidsDeer-ulna.tif',243,4,284,367.4507227,68.8576583,68.8213623,1.8,66.2686709,68.2047882,0.100217,14.5981018,22.314689,9839.004496,32784.4852036,0.6130212,1469.1885319,673.9920454,1599.174212,28.6913901,29.0725421,2.6167969,95.1678186),(21035,'PereDavidsDeer-ulna.tif',243,4,285,369.2890164,68.914078,68.7979305,1.8,66.2968416,68.2071565,0.0975816,14.6274615,22.3300676,9929.19564,33022.9216679,0.584215,1478.85453,678.805114,1609.7371318,28.6913901,29.0943149,0.9470195,94.8556974),(21036,'PereDavidsDeer-ulna.tif',243,4,286,370.8211614,68.9618734,68.7710706,1.8,66.3407463,68.1865145,0.0956174,14.6184928,22.3463472,10020.3865475,33255.6912043,0.5633304,1488.1936141,685.4596197,1620.6341534,28.6913901,29.1545239,1.056345,95.0385338),(21037,'PereDavidsDeer-ulna.tif',243,4,287,372.5136799,69.0075763,68.7515454,1.8,66.3653453,68.1920724,0.0937685,14.4576614,22.3422901,10107.0289631,33476.7362053,0.5442915,1498.3574195,699.0777211,1639.1262693,28.6913901,29.0876173,0.849825,94.9849823),(21038,'PereDavidsDeer-ulna.tif',243,4,288,373.8924038,69.0620925,68.7271637,1.8,66.4175016,68.1823887,0.092254,14.4411838,22.3724697,10193.1341506,33692.6277076,0.5288511,1505.9860664,705.8378517,1648.7593765,28.6913901,29.0943149,0.9470195,95.5334913),(21039,'metacarpus-maybe',243,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21040,'metacarpus-maybe',243,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21041,'metacarpus-maybe',243,5,3,0.0025617,22.55858,87.15815,1.8,22.55858,87.15815,0.7853982,0.000000000000002512,0.000000000000002512,0.000009,0.000009,0.0002135,3573814073.17396,3573814073.23343,5054136331.7245,0.205078,0.2900241,2.3561945,0.5800482),(21042,'metacarpus-maybe',243,5,4,0.012923,23.1313422,87.2398576,1.8,23.1327984,87.2401812,0.2129975,0.0454877,0.6689221,0.0000575,0.0030816,0.0000962,0.0046069,0.0012633,0.004691,0.205078,0.6485136,2.8198421,1.2802283),(21043,'metacarpus-maybe',243,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21044,'metacarpus-maybe',243,5,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21045,'metacarpus-maybe',243,5,7,0.5574717,63.2255118,69.0032476,1.8,63.21941,69.0588938,0.8410673,1.7845326,23.752395,0.2355149,1.7255808,0.0516176,0.0726487,0.1319757,0.0823321,2.255858,3.7814515,1.7894653,9.4918858),(21046,'metacarpus-maybe',243,5,8,39.0034322,55.3598448,64.7761438,1.8,52.6712248,63.3969155,0.5103302,7.8980298,20.3822147,235.7489874,4660.2680142,1.5510263,228.6438486,29.8490881,236.8382081,8.20312,10.5709702,1.886412,30.4766771),(21047,'metacarpus-maybe',243,5,9,203.4529642,51.976857,63.7450641,1.8,51.568008,64.1828618,0.5372061,11.7503599,18.219975,3905.7698838,18957.0864968,8.879889,1040.4562296,332.3957666,1235.2793601,21.7279671,33.9693616,2.7644495,121.4844784),(21048,'metacarpus-maybe',243,5,10,447.8024603,48.4443674,65.1704978,1.8,46.6599575,66.5063359,0.0357256,15.6148822,23.1739221,19431.1387313,46296.9152987,0.0952164,1997.8023198,1244.3986758,2617.4271872,28.5917118,42.1449012,0.1563489,217.628803),(21049,'metacarpus-maybe',243,5,11,513.8656887,46.7116275,66.102324,1.8,46.3956667,67.0569798,-0.1734342,25.2379939,25.6063152,24705.0482776,65599.6965104,2.5504041,2561.8561678,978.883201,2511.7234605,29.9143402,42.924545,0.3973637,183.9291758),(21050,'metacarpus-maybe',243,5,12,520.1313385,46.5704682,66.5299887,1.8,46.4068848,67.2790907,-0.2115048,17.4323176,23.3912988,27577.647203,65514.7587787,3.8204684,2800.8174908,1581.9839778,3904.1345828,32.2550775,43.760493,0.3944306,191.2089269),(21051,'metacarpus-maybe',243,5,13,522.5286377,46.4443603,66.5437612,1.8,46.298504,67.2084347,-0.2311501,17.0156737,23.792159,29545.1585084,64435.1220357,4.570864,2708.2503124,1736.3496121,3886.356571,32.4583241,43.3258521,0.1760432,175.4360317),(21052,'metacarpus-maybe',243,5,14,508.9881999,46.1132821,66.2433782,1.8,46.0685119,66.8920442,-0.2610788,18.0660389,25.83046,30363.1170005,63048.1999291,5.6520982,2440.8469634,1680.6737318,3129.4055987,0.410156,0.6485136,2.8198421,1.4501204),(21053,'metacarpus-maybe',243,5,15,494.6589896,45.9014526,66.3469872,1.8,45.8125324,66.9697683,-0.3045659,19.0900056,23.9419956,29143.4084587,61007.6389701,7.413905,2548.1434352,1526.6317412,3727.2107902,0.7786576,1.2970272,2.8198421,3.1405047),(21054,'metacarpus-maybe',243,5,16,467.4629925,45.973764,66.4505174,1.8,45.8159701,67.0838536,-0.34017,18.6672041,27.947436,27264.4271174,57055.6637037,8.6730393,2041.5348172,1460.5522564,2777.4500509,29.5774632,42.0724902,0.5203553,187.0576066),(21055,'metacarpus-maybe',243,5,17,438.8883419,46.0717791,66.5033372,1.8,45.8954136,67.2208505,-0.3569015,17.5410181,28.4074468,25210.1854205,51840.1403966,8.9285421,1824.8785543,1437.2133493,2522.2998061,0.7250602,2.9002409,0.7853982,6.0407456),(21056,'metacarpus-maybe',243,5,18,411.515578,46.1320109,66.6449661,1.8,45.9619314,67.3414511,-0.3615062,27.946519,27.5785345,23485.6846155,47382.6607701,8.5795493,1718.0993003,840.3796044,2150.9419046,0.6692802,3.0487036,0.8329813,6.2106378),(21057,'metacarpus-maybe',243,5,19,382.023142,46.3060816,66.7422859,1.8,46.0773968,67.4418424,-0.3643541,17.5155275,28.4325286,21596.3819572,43478.4392102,8.085034,1529.1794774,1232.9849625,2139.9127368,1.0091621,1.5618275,1.9756881,4.3006011),(21058,'metacarpus-maybe',243,5,20,362.6399182,46.3566989,66.773338,1.8,46.099763,67.4508039,-0.3409273,16.6330849,29.7431264,19955.0758732,39479.0933237,6.7570324,1327.3350205,1199.7218771,1890.0525809,0.6165451,2.2182577,0.9827937,4.7107571),(21059,'metacarpus-maybe',243,5,21,345.3439062,46.2614827,66.9864432,1.8,45.9233532,67.6436718,-0.3072911,15.9940313,29.5567379,18241.2980553,36174.0960841,5.2660802,1223.8866203,1140.5065896,1730.9614525,0.66113,3.9818945,0.968509,8.43131),(21060,'metacarpus-maybe',243,5,22,330.7878177,46.0551073,67.0822841,1.8,45.7451163,67.7305849,-0.2924005,15.3506109,26.9706117,16611.7558781,33624.3093842,4.5808059,1246.7017728,1082.1560133,1676.395868,0.5516353,2.1114072,1.0636978,4.5408649),(21061,'metacarpus-maybe',243,5,23,318.7543071,45.7901388,67.0750177,1.8,45.5193639,67.6413843,-0.291536,25.7423226,20.0085717,15193.4527978,32019.3910781,4.3888448,1600.2836926,590.2129744,1540.7223085,0.4350361,1.4501204,0.7853982,2.9002409),(21062,'metacarpus-maybe',243,5,24,314.8825792,45.6017533,67.1822675,1.8,45.336221,67.764304,-0.2904528,25.6754933,26.9541243,14563.3814984,30936.854488,4.3042866,1147.7595843,567.2094137,1455.8326631,0.5511147,1.3131399,0.8960554,2.7303487),(21063,'metacarpus-maybe',243,5,25,315.6549876,45.6626813,67.361113,1.8,45.4529316,68.0441296,-0.2830518,25.1070517,25.4080603,14463.2355276,29863.9655354,4.1035876,1175.3736884,576.0626818,1464.5218647,0.5516353,1.934702,1.012197,4.1307089),(21064,'metacarpus-maybe',243,5,26,313.1393172,45.568032,67.5027055,1.8,45.3766188,68.1192499,-0.291543,14.7690476,18.8476885,14098.1039006,29093.6460407,4.311735,1543.6187896,954.5709594,2205.4352173,0.7854748,6.3342217,1.0636978,13.7924868),(21065,'metacarpus-maybe',243,5,27,308.6137178,45.4644204,67.5698708,1.8,45.3340287,68.1707564,-0.3001084,14.6817628,18.50762,13462.6364002,28185.8121182,4.4951348,1522.9301263,916.9632137,2152.6773557,26.0299797,33.848433,0.5695173,135.409171),(21066,'metacarpus-maybe',243,5,28,304.3418113,45.3894483,67.5940351,1.8,45.2733324,68.171427,-0.3096181,14.6276965,18.2066141,13014.3389215,27468.180259,4.7091321,1508.6923996,889.705285,2156.9003532,25.7102212,33.4823987,0.5404195,160.3341677),(21067,'metacarpus-maybe',243,5,29,301.2534776,45.3884776,67.6245962,1.8,45.2573969,68.1866076,-0.3120142,14.7044031,18.0032003,12726.7381934,26759.3545671,4.7314069,1486.3665455,865.5052602,2134.1609372,0.4590887,1.1958,1.0303768,2.5604565),(21068,'metacarpus-maybe',243,5,30,297.6093545,45.3809551,67.6650352,1.8,45.2446175,68.2551429,-0.3152501,19.0007137,17.7383171,12396.1098095,26055.9376461,4.7683785,1468.9069698,652.4023265,1847.0187649,0.6184164,5.1433301,1.160669,11.1325098),(21069,'metacarpus-maybe',243,5,31,294.0274884,45.4134051,67.7154403,1.8,45.2835395,68.2469007,-0.3155166,24.949697,17.4919369,12104.7791946,25465.4311088,4.7186896,1455.8382645,485.1673836,1332.8616017,0.6431407,2.0197841,1.152572,4.5408649),(21070,'metacarpus-maybe',243,5,32,291.8400791,45.4706218,67.7901317,1.8,45.3707739,68.3572473,-0.3139511,25.020302,28.1051661,11937.7490267,24844.210791,4.6387577,883.9731005,477.1224991,1227.7374739,0.410156,0.9171367,1.1071487,1.9804084),(21071,'metacarpus-maybe',243,5,33,290.4519054,45.5504152,67.8239493,1.8,45.4487287,68.4415487,-0.31323,22.1998931,17.6419583,11721.358048,24049.6736343,4.5962073,1363.2088506,527.9916436,1519.9368254,0.7444044,3.3946449,1.1341692,7.3415852),(21072,'metacarpus-maybe',243,5,34,288.6488332,45.5419813,67.899141,1.8,45.4556238,68.5148427,-0.316156,24.7927564,17.4924372,11520.3537384,23485.8838647,4.6505355,1342.6307382,464.6661134,1190.1741654,0.7878455,5.2565616,1.2120257,11.3727736),(21073,'metacarpus-maybe',243,5,35,287.8493809,45.5377003,67.99409,1.8,45.4578842,68.6157097,-0.322866,24.9398343,16.509909,11429.5302474,23035.2881315,4.8296454,1395.2401603,458.2841294,1161.4106644,23.975796,31.134731,0.6593101,95.9211358),(21074,'metacarpus-maybe',243,5,36,287.828123,45.5577984,68.0994055,1.8,45.4790321,68.747523,-0.3239496,24.91629,27.8042993,11393.7020773,22649.6441335,4.8606166,814.6094208,457.2792371,1144.1533475,0.5863861,3.2425679,1.2490458,7.1716931),(21075,'metacarpus-maybe',243,5,37,288.0394147,45.5657988,68.1921685,1.8,45.4594349,68.7595651,-0.3253005,14.0484518,16.8729561,11351.3275926,22303.136964,4.9033923,1321.8274773,808.0127094,1920.7208123,0.8267747,7.1630666,1.1583859,15.5034825),(21076,'metacarpus-maybe',243,5,38,287.9126066,45.591953,68.2462861,1.8,45.4969263,68.7783967,-0.3254078,13.9871592,16.7519432,11296.2906753,21931.7340785,4.9043533,1309.2053734,807.6186552,1959.7161815,0.6484272,4.8007529,1.2220253,10.3825694),(21077,'metacarpus-maybe',243,5,39,288.5969374,45.6197907,68.2985977,1.8,45.5277093,68.7579948,-0.3220028,14.1668822,16.2348834,11305.6589984,21615.8260872,4.8172306,1331.4432586,798.0343741,1892.4329406,0.6117954,3.0487036,1.2277724,6.5916449),(21078,'metacarpus-maybe',243,5,40,289.2694669,45.6178905,68.3698907,1.8,45.5307264,68.8490111,-0.3276543,24.1652861,16.4163992,11307.7120371,21412.403714,4.9932754,1304.3301101,467.9320569,1185.1709773,23.7003704,30.4601243,0.6852558,94.2513629),(21079,'metacarpus-maybe',243,5,41,291.0459412,45.6811575,68.4207581,1.8,45.6059235,68.9916115,-0.3383062,24.283731,16.3556095,11261.4978769,21186.3887111,5.3431597,1295.3591671,463.7466083,1198.9720732,0.6476415,3.4377337,1.2679115,7.5818491),(21080,'metacarpus-maybe',243,5,42,291.3257094,45.6618724,68.487466,1.8,45.5488764,69.0490156,-0.3452341,14.6253398,16.8304433,11113.3231771,21018.6716865,5.5607315,1248.8483704,759.8676912,1847.4378563,0.6227149,3.6339914,1.2847449,7.8221129),(21081,'metacarpus-maybe',243,5,43,291.4388682,45.6302426,68.5596351,1.8,45.4516783,69.1411594,-0.3531492,14.0507961,17.3131305,10967.9830387,20985.7710149,5.8100894,1212.1303536,780.595131,1777.5558694,1.1351642,3.8530658,1.1309537,8.9118376),(21082,'metacarpus-maybe',243,5,44,291.0867365,45.675971,68.6212441,1.8,45.5074138,69.2164616,-0.3464306,13.5264272,17.2424504,10913.461904,20668.9451504,5.5931938,1198.7243493,806.8251702,1767.9222681,1.0956739,4.4175153,1.1902899,10.4323297),(21083,'metacarpus-maybe',243,5,45,291.2337958,45.7101908,68.6467225,1.8,45.566631,69.1918461,-0.344732,13.7089113,16.473573,10824.2258355,20357.3723322,5.5434647,1235.7593808,789.5758883,1849.8697529,0.5849135,2.0197841,1.152572,4.3709727),(21084,'metacarpus-maybe',243,5,46,293.6290049,45.6573286,68.7521386,1.8,45.4442682,69.3153925,-0.3600401,13.8335396,16.936772,10863.089945,20653.6623554,6.074381,1219.4568348,785.2719034,1766.1008493,0.8757594,4.7345933,1.2627435,10.3825694),(21085,'metacarpus-maybe',243,5,47,293.5069376,45.6951146,68.7686755,1.8,45.4741529,69.3387841,-0.3576091,24.3417436,17.1447664,10797.5266125,20325.489798,5.9936514,1185.5215336,443.5806564,1058.2484783,0.6803557,5.3201834,1.089909,11.4722941),(21086,'metacarpus-maybe',243,5,48,290.2340375,45.8662859,68.6765209,1.8,45.7205185,69.191423,-0.3244216,23.6954776,16.3390609,10601.7943676,19381.5960891,4.9150311,1186.2123686,447.4184712,1041.7177426,0.5849135,2.0197841,1.152572,4.3709727),(21087,'metacarpus-maybe',243,5,49,288.2503624,46.0243597,68.6550891,1.8,45.8863264,69.1869864,-0.3125639,23.4266711,15.4594053,10482.1955458,18715.4355814,4.5426261,1210.6180817,447.447079,1062.4705398,0.7184125,4.152513,1.2178059,9.1521014),(21088,'metacarpus-maybe',243,5,50,287.6749209,46.0462225,68.732847,1.8,45.9119604,69.3228211,-0.3158395,23.0143852,15.5148396,10462.4200139,18405.1120955,4.6258801,1186.2908431,454.6034984,1103.6486163,0.8444661,4.4175153,1.1902899,9.7321496),(21089,'metacarpus-maybe',243,5,51,286.8195965,46.0876897,68.7679104,1.8,45.9486143,69.3399491,-0.3152534,13.6103236,27.9444027,10396.4380956,18157.2260607,4.5955963,649.7625399,763.8641372,964.2423804,0.7713345,4.4175153,1.1902899,9.7321496),(21090,'metacarpus-maybe',243,5,52,285.4158362,46.1235364,68.769516,1.8,45.9830052,69.3614512,-0.3137335,13.4698823,15.9997571,10246.0062507,17899.4534466,4.5305669,1118.7328212,760.660416,1663.0245142,0.6880714,3.3131365,1.1902899,7.3415852),(21091,'metacarpus-maybe',243,5,53,284.3729887,46.1780719,68.7279449,1.8,46.0483672,69.2593888,-0.3073751,23.3974826,15.293658,10109.096958,17641.210853,4.3386418,1153.4984535,432.0591726,1041.2036298,22.6844796,28.8752446,0.7502368,89.0600782),(21092,'metacarpus-maybe',243,5,54,284.8112224,46.2063016,68.7350298,1.8,46.1008128,69.280066,-0.3065238,23.4238944,28.5054805,10092.1190838,17534.4565854,4.3220486,615.1258039,430.8471908,917.9268285,0.7135854,2.856406,1.2036225,6.3513811),(21093,'metacarpus-maybe',243,5,55,285.4663683,46.2528407,68.7532565,1.8,46.1548763,69.3247057,-0.3047996,23.1855374,28.5277122,10088.2447147,17449.9166674,4.284907,611.6830022,435.1093759,914.1762307,0.410156,0.9171367,1.1071487,1.9804084),(21094,'metacarpus-maybe',243,5,56,286.668255,46.3023082,68.7490501,1.8,46.1889027,69.3033402,-0.3012587,23.1861958,28.3459241,10073.0327801,17358.0337601,4.2065812,612.3643625,434.4409438,914.3527375,0.6633105,3.5815333,1.1583859,7.7517412),(21095,'metacarpus-maybe',243,5,57,288.4703077,46.3930014,68.7555451,1.8,46.2662544,69.376798,-0.3055567,23.3448122,16.5001716,10045.8505149,17218.2874794,4.3508616,1043.5217249,430.324752,957.3717537,0.6967195,3.6339914,1.2847449,7.8221129),(21096,'metacarpus-maybe',243,5,58,286.6690325,46.449444,68.7671674,1.8,46.380266,69.3915599,-0.2996581,23.2956934,17.8830108,9934.0684519,17035.5082141,4.163353,952.6085057,426.4336875,920.5495256,0.8382544,2.856406,1.2036225,6.7615371),(21097,'metacarpus-maybe',243,5,59,283.5788126,46.5157275,68.7409014,1.8,46.4250991,69.3199918,-0.2906996,23.1570681,18.1555061,9776.2130963,16753.958219,3.8827846,922.8031493,422.1697268,901.5984479,0.5647997,1.7521872,1.2120257,3.7909245),(21098,'metacarpus-maybe',243,5,60,281.3098637,46.5641327,68.7157903,1.8,46.4609383,69.2469858,-0.2854033,22.7823601,17.2404707,9649.4700959,16566.4083716,3.7164442,960.902324,423.5500641,917.5876512,0.684655,2.4003764,1.2220253,5.3611769),(21099,'metacarpus-maybe',243,5,61,280.3680421,46.6165396,68.7203413,1.8,46.5224489,69.2435608,-0.2770828,15.4200773,15.7424681,9615.9381384,16450.3634883,3.496661,1044.9672406,623.5985679,1618.6541744,0.410156,0.9171367,1.1071487,1.9804084),(21100,'metacarpus-maybe',243,5,62,280.4333196,46.6624285,68.7614776,1.8,46.6146022,69.3316694,-0.2687455,23.4422168,23.0366359,9693.5150173,16447.936071,3.2951874,713.990365,413.5067551,797.8532956,0.5647997,2.1410772,1.2793395,4.6112365),(21101,'metacarpus-maybe',243,5,63,280.4582352,46.6951693,68.7931581,1.8,46.6889601,69.3258523,-0.2694755,23.2765089,23.4464484,9704.7503812,16390.9068678,3.3129702,699.0784537,416.9332454,791.3515951,0.410156,1.2970272,1.2490458,2.8007204),(21102,'metacarpus-maybe',243,5,64,278.927055,46.711595,68.7908215,1.8,46.6386863,69.3317302,-0.2745294,14.0834701,15.4919273,9574.0777327,16206.7024195,3.4164819,1046.138556,679.809568,1598.3086554,0.410156,0.9171367,1.1071487,1.9804084),(21103,'metacarpus-maybe',243,5,65,276.9914778,46.7693335,68.7274817,1.8,46.6720882,69.2412162,-0.2761071,15.2740411,16.4202359,9388.2542047,15979.2672875,3.4308822,973.1448093,614.6542451,1519.8443662,0.410156,0.9171367,1.1071487,1.9804084),(21104,'metacarpus-maybe',243,5,66,274.9180557,46.7867664,68.7370147,1.8,46.678428,69.2534,-0.2750386,15.2907308,26.377032,9254.9290245,15836.91607,3.3795643,600.4055366,605.2640096,877.3019935,0.5473461,1.9455407,1.2490458,4.2010805),(21105,'metacarpus-maybe',243,5,67,273.6097648,46.8010947,68.754374,1.8,46.7102026,69.2506128,-0.2781309,13.8103152,15.6648964,9188.1547923,15762.9866153,3.4375677,1006.2617877,665.3110126,1401.1214291,0.410156,1.8907257,1.3521274,4.0311884),(21106,'metacarpus-maybe',243,5,68,272.4814651,46.8395649,68.748679,1.8,46.7260864,69.2753822,-0.269505,22.223424,18.2436499,9123.6038353,15636.3099086,3.2194317,857.0823274,410.5399702,861.1368634,21.7697458,27.3685024,0.6150231,84.3990814),(21107,'metacarpus-maybe',243,5,69,271.2479209,46.8702346,68.7440944,1.8,46.7636488,69.2753292,-0.2616159,22.0612356,17.5421517,9034.4667027,15501.0540624,3.0242138,883.6461064,409.5177108,870.4999958,0.615234,0.8455583,1.815775,2.1503005),(21108,'metacarpus-maybe',243,5,70,270.9664195,46.8833636,68.746272,1.8,46.7690595,69.2489832,-0.2611339,14.0643644,16.3729956,8997.6039441,15448.5112568,3.0102087,943.5360296,639.7447985,1471.7822128,0.7661098,1.5618275,1.1659045,3.8406848),(21109,'metacarpus-maybe',243,5,71,270.1915004,46.9020721,68.7529713,1.8,46.7827415,69.2608121,-0.2573047,21.9270285,15.794002,8957.0835289,15373.3387548,2.9161528,973.3656307,408.4950925,930.8479326,0.410156,1.1043788,1.1902899,2.3905644),(21110,'metacarpus-maybe',243,5,72,269.2210291,46.9334138,68.7332059,1.8,46.8067439,69.2207844,-0.248708,12.6752121,14.7039284,8867.4189012,15266.102296,2.7187173,1038.2329017,699.5874165,1563.4925848,0.205078,0.6485136,1.8925469,1.4003602),(21111,'metacarpus-maybe',243,5,73,268.1092718,46.9808754,68.6792515,1.8,46.8560156,69.210038,-0.2480002,21.9942955,16.0769525,8775.8026137,15093.7657042,2.69242,938.8449531,399.0035784,880.85228,0.5245799,1.7521872,1.2120257,3.7909245),(21112,'metacarpus-maybe',243,5,74,267.2179695,46.9933335,68.6946337,1.8,46.8493192,69.2335437,-0.2469168,21.9594211,14.6627746,8699.8417945,15009.3832307,2.6605507,1023.6386784,396.1781036,924.319887,0.6469848,1.6533917,1.0516502,3.5506607),(21113,'metacarpus-maybe',243,5,75,266.4187593,46.9893232,68.7152068,1.8,46.8275644,69.2633309,-0.2512729,12.5471933,14.5196041,8641.6640152,14966.0751169,2.7450186,1030.7495284,688.7328344,1541.0746564,0.410156,0.9171367,1.1071487,1.9804084),(21114,'metacarpus-maybe',243,5,76,265.7428908,47.0143071,68.7111586,1.8,46.8992951,69.2808233,-0.2467554,12.6495431,15.4723373,8580.9341036,14889.6811854,2.6424772,962.3420741,678.3592104,1483.907556,0.5849135,1.7521872,1.2120257,3.7909245),(21115,'metacarpus-maybe',243,5,77,264.611252,47.0454404,68.6936714,1.8,46.9462356,69.2471169,-0.2337289,21.3915198,16.5718387,8497.6671864,14786.6263838,2.3656971,892.2743344,397.2446682,864.3142677,21.0984556,27.0462042,0.5417199,82.5594164),(21116,'metacarpus-maybe',243,5,78,263.2190511,47.0532391,68.6979427,1.8,46.9206069,69.295474,-0.2312561,13.0173935,14.5448363,8432.1319162,14711.3766198,2.3046061,1011.4501332,647.7588535,1504.5672024,20.9332729,27.0345391,0.6237768,82.2693923),(21117,'metacarpus-maybe',243,5,79,261.9765093,47.0746704,68.7115131,1.8,46.9536833,69.2792635,-0.2265674,12.7984933,15.0003486,8354.9682162,14649.6344848,2.2032409,976.6196032,652.8087356,1473.7520701,20.922131,26.9152668,0.6175923,82.1492604),(21118,'metacarpus-maybe',243,5,80,260.793013,47.0947772,68.7250093,1.8,47.0105753,69.2749959,-0.2205168,22.0850914,26.4841227,8299.4939634,14585.5954271,2.0795865,550.7297942,375.7962242,664.3032927,20.7834786,26.8370245,0.5286245,81.9793682),(21119,'metacarpus-maybe',243,5,81,259.9369112,47.1383195,68.6931981,1.8,47.0374322,69.2225689,-0.2171755,14.8795164,19.4140243,8220.5377599,14420.7976167,2.0114055,742.803109,552.4734489,926.6549287,20.7121602,26.7648397,0.5391054,81.5692122),(21120,'metacarpus-maybe',243,5,82,258.7916867,47.1541907,68.7197184,1.8,47.0575843,69.2671688,-0.2132815,12.9120105,15.1580475,8154.1592588,14303.4034494,1.9324582,943.6178024,631.5173944,1449.5535112,20.7014236,26.7341808,0.5220005,81.2791881),(21121,'metacarpus-maybe',243,5,83,258.2040104,47.1820948,68.7328475,1.8,47.1034501,69.3404207,-0.2097936,21.4648356,24.8282693,8122.0805772,14264.7668513,1.8664445,574.5373008,378.3900664,685.8495993,0.7609824,3.8910815,1.2490458,9.0319695),(21122,'metacarpus-maybe',243,5,84,258.0159647,47.2155129,68.7251335,1.8,47.1781652,69.3059407,-0.2073028,21.3631091,24.8466808,8083.0025933,14222.7081172,1.8216937,572.4188377,378.3626507,683.9022629,0.410156,0.9171367,1.1071487,1.9804084),(21123,'metacarpus-maybe',243,5,85,258.8483489,47.249199,68.7297728,1.8,47.1538261,69.3046918,-0.2107304,21.3496828,21.5250002,8092.4883085,14229.1522875,1.8876022,661.0523648,379.044896,887.9954719,20.5428142,26.66014,0.5325041,80.989164),(21124,'metacarpus-maybe',243,5,86,259.0470108,47.2901255,68.7355238,1.8,47.1678188,69.2729452,-0.207785,14.3422451,29.0553907,8073.4089684,14226.7139688,1.8373703,489.6411168,562.9110995,725.8986338,1.2326904,2.856406,1.2036225,7.3415852),(21125,'metacarpus-maybe',243,5,87,259.2219169,47.3304314,68.7312544,1.8,47.262784,69.2520129,-0.2032374,20.9856691,22.7296929,8043.8297812,14237.9102608,1.7601108,626.4013464,383.3010868,720.2523472,20.4692821,26.6293605,0.560232,80.8192718),(21126,'metacarpus-maybe',243,5,88,259.0573976,47.3721657,68.7000962,1.8,47.3066729,69.2024922,-0.1976388,20.3969723,19.3410614,8014.5034011,14193.0407931,1.6646661,733.8294666,392.9261305,790.0523948,0.205078,0.4585683,2.0344439,0.9902042),(21127,'metacarpus-maybe',243,5,89,258.4276134,47.4508933,68.6442452,1.8,47.3678102,69.1778695,-0.1908303,21.4053016,29.4135923,7943.1782779,14047.0647791,1.5495442,477.5705266,371.0846234,604.4957721,0.615234,1.7521872,1.2120257,3.9608167),(21128,'metacarpus-maybe',243,5,90,257.3524456,47.4938099,68.6439911,1.8,47.4347861,69.1796984,-0.185618,14.9321307,18.5765254,7852.3105519,13937.1122481,1.4609104,750.253989,525.8667173,914.2189488,0.5060739,1.7521872,1.2120257,3.7909245),(21129,'metacarpus-maybe',243,5,91,256.2567337,47.5427812,68.6527002,1.8,47.4564487,69.2062594,-0.1800592,20.1982121,19.0800288,7759.5150817,13864.923298,1.3697965,726.6720305,384.1684118,778.2728681,0.6967195,1.1958,2.6011732,2.8504806),(21130,'metacarpus-maybe',243,5,92,255.6710201,47.5821661,68.6365055,1.8,47.4781215,69.1700887,-0.1761649,18.5439996,16.5397447,7731.4071285,13843.8784785,1.3087956,837.0067796,416.9223095,947.2260317,0.5473461,1.9455407,1.2490458,4.2010805),(21131,'metacarpus-maybe',243,5,93,255.4729827,47.6140737,68.6255706,1.8,47.4606121,69.1078473,-0.1725569,18.3475697,16.3496253,7697.5160594,13852.6972142,1.2552882,847.2791866,419.5387294,943.129895,0.410156,0.7394192,0.9827937,1.5702524),(21132,'metacarpus-maybe',243,5,94,255.1340033,47.645414,68.621283,1.8,47.5007119,69.1232733,-0.17129,16.1567417,15.5526947,7677.676094,13852.4481083,1.2354619,890.6783251,475.1995315,961.1295971,0.410156,1.4929904,1.2924967,3.2108764),(21133,'metacarpus-maybe',243,5,95,255.0920101,47.6858988,68.6028395,1.8,47.5739621,69.0990522,-0.1645961,13.1263307,14.7186605,7631.6613393,13864.433754,1.1414566,941.9630086,581.4009631,1406.9159362,0.442808,1.7521872,1.2120257,3.7909245),(21134,'metacarpus-maybe',243,5,96,254.8192642,47.7317091,68.5957826,1.8,47.6672696,69.1106475,-0.1565402,20.442835,17.2965809,7597.6417004,13874.3070242,1.0322448,802.1415987,371.6530367,820.1415242,19.7569097,26.2026773,0.393587,79.0791273),(21135,'metacarpus-maybe',243,5,97,254.6299695,47.8159742,68.5607074,1.8,47.6759201,69.1951266,-0.1588588,20.6535903,14.6599471,7559.1149458,13786.8295436,1.0620002,940.4419682,365.9952009,881.3416602,19.86158,26.2820079,0.4007934,79.4189117),(21136,'metacarpus-maybe',243,5,98,253.6192891,47.8765242,68.5423121,1.8,47.768901,69.1182405,-0.1530635,13.1628484,14.5877406,7478.4809117,13720.0977677,0.9826079,940.5224694,568.1506538,1369.6158594,19.6589436,26.2387664,0.3761523,79.1288876),(21137,'metacarpus-maybe',243,5,99,253.1485568,47.9446745,68.5401956,1.8,47.8378267,69.1573579,-0.1476692,13.203028,14.6273443,7434.966034,13650.3000127,0.9133666,933.2042595,563.1258267,1356.943374,0.7157942,4.9939756,1.2360595,10.9626176),(21138,'metacarpus-maybe',243,5,100,253.0729052,48.0192231,68.506215,1.8,47.8804782,69.0654791,-0.1420076,19.9413493,19.2841766,7389.7667254,13654.705527,0.844883,708.0782243,370.5750607,758.6183093,0.8459387,6.3607248,1.2082521,14.3931464),(21139,'metacarpus-maybe',243,5,101,252.6706619,48.084199,68.477662,1.8,47.9613324,68.9900753,-0.1386692,13.3677837,14.7263893,7321.756183,13648.5507611,0.8045968,926.8090391,547.7165378,1336.4274996,19.5572703,26.2026773,0.393587,78.6689713),(21140,'metacarpus-maybe',243,5,102,252.3793727,48.1427786,68.4562304,1.8,48.03703,68.9071752,-0.1326852,13.340869,14.9712404,7282.7238302,13631.5106148,0.7362033,910.5131094,545.8957588,1348.6724362,0.5928237,3.6339914,1.2847449,7.9920051),(21141,'metacarpus-maybe',243,5,103,252.7024341,48.1978521,68.4575138,1.8,48.0945697,68.8852271,-0.1283092,13.8358028,22.8809607,7291.1519363,13643.733276,0.689587,596.2919757,526.9771498,782.9379448,0.6406441,2.5940543,1.2490458,5.6014407),(21142,'metacarpus-maybe',243,5,104,252.9028802,48.247269,68.4575145,1.8,48.1566229,68.894775,-0.1233992,15.6678547,18.9428746,7288.8821154,13657.611907,0.6385893,720.9894065,465.2125165,852.07918,0.205078,0.6485136,1.8925469,1.4003602),(21143,'metacarpus-maybe',243,5,105,253.397687,48.3429878,68.4273714,1.8,48.2445944,68.8737064,-0.1205689,15.9927381,19.9657179,7301.15145,13622.9848285,0.6109658,682.3188064,456.5291694,833.6686939,0.410156,0.9171367,1.1071487,1.9804084),(21144,'metacarpus-maybe',243,5,106,252.6767283,48.3977839,68.4249059,1.8,48.3085598,68.8801923,-0.1105428,20.4500095,27.4433598,7275.6757264,13565.5546017,0.5125136,494.3109998,355.7785983,608.9500944,0.7157942,3.5815333,1.1583859,7.7517412),(21145,'metacarpus-maybe',243,5,107,251.5297579,48.4627839,68.4134286,1.8,48.3835662,68.8920584,-0.0990228,20.3618539,27.8153755,7254.3744296,13518.2728583,0.4097212,486.0000139,356.2727872,602.8855686,0.7180031,6.0974073,1.2277724,13.1832898),(21146,'metacarpus-maybe',243,5,108,250.9975586,48.50984,68.3939315,1.8,48.4290639,68.8247398,-0.0910874,20.0252062,26.4775748,7189.9361283,13440.7791341,0.3461251,507.6287858,359.0443001,621.4547731,0.410156,1.1043788,1.1902899,2.3905644),(21147,'metacarpus-maybe',243,5,109,250.5980809,48.5586981,68.3797792,1.8,48.4800939,68.83018,-0.084664,15.1031634,25.1084285,7158.9847657,13412.6543155,0.2986661,534.1893187,474.0056476,702.5120743,0.410156,0.9171367,1.1071487,1.9804084),(21148,'metacarpus-maybe',243,5,110,250.5590571,48.5992,68.3693562,1.8,48.5080681,68.80211,-0.0802421,15.7268439,25.0827588,7136.5580507,13424.6695045,0.268306,535.2150297,453.7819595,701.2239278,0.410156,0.8455583,1.815775,1.9804084),(21149,'metacarpus-maybe',243,5,111,250.6957678,48.6341175,68.3617926,1.8,48.5042914,68.8203694,-0.0785216,15.5193144,26.5070327,7132.052405,13472.6418899,0.2570875,508.2666943,459.5597605,677.4228362,0.5118765,2.9859808,1.2924967,6.4217527),(21150,'metacarpus-maybe',243,5,112,250.2077794,48.6873005,68.3422727,1.8,48.5969128,68.7886556,-0.0729575,15.3894027,26.8871517,7074.6562076,13458.424195,0.2215745,500.5522475,459.7096046,666.380546,0.5060739,1.9455407,1.2490458,4.2010805),(21151,'metacarpus-maybe',243,5,113,249.4235313,48.7867431,68.2752137,1.8,48.6918925,68.718853,-0.0695566,15.011343,27.7437489,7009.3397259,13357.5228538,0.2007994,481.4606314,466.9362172,646.348387,0.410156,1.1043788,1.1902899,2.3905644),(21152,'metacarpus-maybe',243,5,114,248.5487077,48.8257952,68.2563822,1.8,48.7399489,68.686843,-0.0688069,12.6331813,16.2597949,6938.0528356,13327.2152184,0.1958119,819.6422704,549.1928501,1225.3119857,0.809423,5.712812,1.2036225,12.53287),(21153,'metacarpus-maybe',243,5,115,247.8448649,48.8805105,68.2247862,1.8,48.7755003,68.6611633,-0.0644226,15.1266027,27.7635008,6872.7226889,13288.8908438,0.1712003,478.64608,454.3467452,637.6854312,18.9154056,25.9939904,0.1664457,78.0391629),(21154,'metacarpus-maybe',243,5,116,247.7550924,48.9329017,68.2062629,1.8,48.8546224,68.6743898,-0.0608192,20.1183941,26.9559039,6849.9170733,13291.7554104,0.152552,493.0925504,340.480311,647.7930927,0.4977332,1.9455407,1.2490458,4.2010805),(21155,'metacarpus-maybe',243,5,117,248.4233906,48.9807964,68.1942837,1.8,48.8728964,68.6758761,-0.0600525,20.1825459,16.2825421,6839.1235832,13338.5097454,0.1491357,819.1908662,338.8632744,778.1049554,18.8095781,25.9413537,0.1989459,77.3389828),(21156,'metacarpus-maybe',243,5,118,248.957183,49.0286737,68.1895465,1.8,48.8915743,68.7439223,-0.059513,20.334208,18.9188463,6844.1241395,13373.2502571,0.1467858,706.8745113,336.5817901,728.1386337,18.8024199,25.9413537,0.1989459,77.388743),(21157,'metacarpus-maybe',243,5,119,249.9539718,49.079855,68.1706443,1.8,48.9630481,68.6742352,-0.0576751,20.3153455,27.2198638,6831.0485778,13419.4991428,0.1384216,493.0039042,336.2506717,729.962309,0.3979726,1.1043788,1.1902899,2.3905644),(21158,'metacarpus-maybe',243,5,120,250.0419729,49.1345028,68.1487432,1.8,48.9869882,68.6426481,-0.0561233,13.2763746,14.521334,6797.8904799,13442.6477446,0.1311269,925.71714,512.0291263,1342.5883847,0.205078,1.0456967,1.7681919,2.2206722),(21159,'metacarpus-maybe',243,5,121,249.987286,49.225413,68.1013687,1.8,49.0694192,68.6137831,-0.0546024,13.2798835,14.0277759,6782.7894566,13385.4005657,0.124096,954.2069032,510.7567002,1361.3916612,0.3670627,0.7394192,0.9827937,1.5702524),(21160,'metacarpus-maybe',243,5,122,248.8432978,49.2929695,68.0633649,1.8,49.1899953,68.4898773,-0.0477482,13.3051854,13.9270551,6689.4445556,13328.0728938,0.094484,956.9914692,502.7697367,1391.3898705,0.5106773,2.338249,1.3045443,5.1912847),(21161,'metacarpus-maybe',243,5,123,248.5496381,49.33376,68.0406125,1.8,49.2269031,68.4797274,-0.0468949,19.8957014,20.5080311,6664.3563087,13308.7817283,0.0910324,648.9546296,334.9646322,699.0205521,0.410156,0.7394192,0.9827937,1.5702524),(21162,'metacarpus-maybe',243,5,124,248.8948749,49.3816669,68.0325286,1.8,49.2725629,68.4647131,-0.0474662,12.9893564,14.0068133,6678.1897288,13369.5787828,0.0933914,954.5053917,514.1278373,1411.0981015,0.205078,0.6485136,1.8925469,1.4003602),(21163,'metacarpus-maybe',243,5,125,249.095423,49.4336494,68.0065484,1.8,49.3380443,68.3827278,-0.0464047,19.5148379,20.6403036,6656.5506603,13449.1644891,0.0893356,651.5972234,341.102022,707.8200277,0.205078,0.6485136,1.8925469,1.4003602),(21164,'metacarpus-maybe',243,5,126,249.5347911,49.487041,67.9945446,1.8,49.4016824,68.3741618,-0.0461908,19.5199495,26.5788525,6679.6430197,13541.2272406,0.0886713,509.4737342,342.1957123,621.4432048,0.205078,0.4585683,2.0344439,0.9902042),(21165,'metacarpus-maybe',243,5,127,250.3658372,49.5335976,68.0026093,1.8,49.4823026,68.421701,-0.0449668,19.2981478,27.7941043,6732.1764501,13687.7210803,0.084317,492.4685082,348.8509121,610.8010198,18.561582,26.073956,0.1341108,77.1690906),(21166,'metacarpus-maybe',243,5,128,250.5557181,49.5807764,67.9835946,1.8,49.5196956,68.3735452,-0.0460332,18.7726988,27.9311337,6733.1793135,13716.1525109,0.0884276,491.0703819,358.6686909,609.039997,18.561582,26.131959,0.149666,77.1690906),(21167,'metacarpus-maybe',243,5,129,250.8050778,49.6650975,67.9191755,1.8,49.5695593,68.3331801,-0.0477883,18.5678193,25.6629646,6753.7931776,13702.2000416,0.095389,533.9289619,363.7364768,671.7697754,18.5794776,26.1609123,0.0942085,77.4591147),(21168,'metacarpus-maybe',243,5,130,250.5759691,49.7211411,67.9218299,1.8,49.6503561,68.3651778,-0.0427936,18.4076131,21.5739435,6768.8198317,13734.5010092,0.076433,636.6245011,367.7184984,737.9290705,18.5830567,26.2026773,0.1097929,77.6993785),(21169,'metacarpus-maybe',243,5,131,250.6612301,49.7705714,67.9116942,1.8,49.7183217,68.3342522,-0.0395839,13.5185229,14.0077915,6787.9479533,13804.7722336,0.0654254,985.506688,502.122014,1357.286973,0.410156,0.9171367,1.1071487,1.9804084),(21170,'metacarpus-maybe',243,5,132,249.9661938,49.8124219,67.9033261,1.8,49.7445563,68.3165368,-0.0368934,13.3137269,14.1713553,6782.5459711,13849.6355042,0.0566801,977.2978781,509.4400708,1421.5963679,0.205078,0.2900241,2.3561945,0.5800482),(21171,'metacarpus-maybe',243,5,133,250.3581267,49.8645728,67.8842424,1.8,49.7808249,68.2481923,-0.0340738,13.6905004,14.2425171,6811.4368935,13921.993125,0.0484265,977.4952733,497.5301634,1429.1677522,18.7773661,26.365088,0.0934768,77.9894026),(21172,'metacarpus-maybe',243,5,134,250.3918742,49.9262435,67.8690087,1.8,49.8069374,68.2154622,-0.0304093,12.7187379,14.0376979,6829.7357593,14001.2116121,0.0385787,997.4008319,536.9821941,1451.4078342,0.410156,0.9171367,1.1071487,1.9804084),(21173,'metacarpus-maybe',243,5,135,250.4243728,49.9713298,67.8435192,1.8,49.8620178,68.1560661,-0.0290955,12.868027,14.1553624,6838.3518849,14126.9182415,0.0353227,997.9905726,531.4219399,1453.4617098,18.7809452,26.3347622,0.1485049,78.5694508),(21174,'metacarpus-maybe',243,5,136,250.7319368,50.0256241,67.8258526,1.8,49.9414421,68.1374973,-0.0265574,19.2009328,17.9668959,6875.4807735,14248.3771457,0.0294667,793.0349902,358.0805608,803.3074652,18.662098,26.40653,0.108942,78.3995586),(21175,'metacarpus-maybe',243,5,137,250.4200907,50.1236323,67.763487,1.8,50.0153652,68.1291754,-0.0239852,13.3200972,14.2681304,6910.5487521,14239.2997715,0.0240063,997.979372,518.8061787,1474.4070763,18.867176,26.5058852,0.0619362,79.1494989),(21176,'metacarpus-maybe',243,5,138,249.5733688,50.1910364,67.7459043,1.8,50.0699876,68.1145781,-0.0198735,13.3194721,16.0403514,6932.0458114,14279.9882524,0.0164262,890.2540793,520.4444869,1268.2262949,18.867176,26.5193688,3.0719381,78.8594749),(21177,'metacarpus-maybe',243,5,139,249.2640716,50.2561538,67.733907,1.8,50.1419232,68.1527793,-0.0188274,13.3156544,14.7366091,6971.4873961,14342.3832934,0.0147243,973.2485403,523.5557488,1424.3084597,0.205078,0.2900241,2.3561945,0.5800482),(21178,'metacarpus-maybe',243,5,140,249.4493517,50.3191504,67.7234275,1.8,50.1560097,68.1929597,-0.0193263,13.5310493,14.2575126,7029.3580625,14494.0088698,0.0155266,1016.5874871,519.4983695,1432.5899081,18.867176,26.6104016,3.0334886,79.3897628),(21179,'metacarpus-maybe',243,5,141,250.2061098,50.3876751,67.6973726,1.8,50.242246,68.1234795,-0.016613,13.539927,14.9578665,7090.9092824,14691.8789856,0.0115081,982.2175467,523.7036569,1431.301671,0.205078,0.2900241,2.3561945,0.5800482),(21180,'metacarpus-maybe',243,5,142,249.9828,50.4444959,67.6767733,1.8,50.3134988,68.1482224,-0.0152983,13.5451517,15.0583516,7129.634709,14853.1053568,0.0097504,986.3699406,526.3606395,1358.5655271,18.867176,26.7734807,3.0495458,79.7501585),(21181,'metacarpus-maybe',243,5,143,249.9268387,50.4992823,67.6352474,1.8,50.4136795,68.0010267,-0.0138665,13.3828007,14.4303235,7132.4268951,15049.9915199,0.0080089,1042.9420761,532.9547269,1526.8194748,0.410156,0.5800482,2.3561945,1.1600964),(21182,'metacarpus-maybe',243,5,144,249.3176369,50.5567999,67.593066,1.8,50.4774925,67.9298099,-0.0143162,16.5405625,25.3664745,7142.3606995,15217.4635296,0.0085159,599.9045514,431.8088154,738.406126,18.8414029,26.9597632,3.0578197,80.2804464),(21183,'metacarpus-maybe',243,5,145,249.0474653,50.6743592,67.5436893,1.8,50.5967219,67.9443736,-0.0125082,16.4263024,25.4521359,7161.7111765,15275.2327239,0.0064938,600.1552406,435.9904632,740.6769079,18.6434912,27.0407611,3.0275854,80.5207102),(21184,'metacarpus-maybe',243,5,146,248.0954099,50.7358492,67.5453816,1.8,50.6546871,67.9688375,-0.0103007,13.2728184,14.4587441,7157.9081768,15385.8893117,0.004387,1064.1234981,539.2907481,1529.8274765,18.6417016,27.1641275,3.0584514,80.7609741),(21185,'metacarpus-maybe',243,5,147,247.1807724,50.8293012,67.5417371,1.8,50.8135666,68.0384165,-0.005032,19.785273,26.3953477,7191.9254047,15567.1465717,0.0010432,589.7685733,363.4989221,713.5736275,18.8167363,27.2445177,3.0284417,80.7609741),(21186,'metacarpus-maybe',243,5,148,246.6083768,50.9230108,67.5328159,1.8,50.9501879,68.0001256,-0.0016375,19.8594978,30.2587218,7210.4784099,15805.5635934,0.00011,522.347365,363.0745589,655.3392824,18.8238945,27.4053582,3.0441578,81.0509981),(21187,'metacarpus-maybe',243,5,149,246.3024568,51.001049,67.5097077,1.8,50.9912218,67.9851673,-0.0037372,19.9210629,32.1969274,7221.3957965,16054.3523427,0.0005733,498.6299519,362.5005277,638.4348479,18.8203154,27.5728877,0.0819059,81.5812861),(21188,'metacarpus-maybe',243,5,150,245.8838496,51.064855,67.4861561,1.8,50.9342212,67.9785658,-0.0107564,18.6829422,20.6943771,7201.7636085,16224.132453,0.0047415,783.9874755,385.4726697,870.6710433,18.662098,27.7272737,3.0080636,81.5812861),(21189,'metacarpus-maybe',243,5,151,245.1876408,51.1384408,67.4615945,1.8,51.0210179,67.9156168,-0.0108251,19.8419478,25.8893955,7177.2529474,16494.4268245,0.0047886,637.1113144,361.7211882,770.4324487,18.662098,27.8792963,3.0236244,81.8713101),(21190,'metacarpus-maybe',243,5,152,244.5663444,51.2247681,67.4423496,1.8,51.1954896,67.8513391,-0.0055589,19.8843391,20.6533914,7146.5168095,16671.5833228,0.0012595,807.2080255,359.4042908,852.7101118,18.629585,28.0597369,3.0317425,82.111574),(21191,'metacarpus-maybe',243,5,153,244.7116959,51.3471393,67.3901051,1.8,51.3097122,67.81188,-0.0047756,18.4337741,21.1626812,7112.454077,16869.1563055,0.0009301,797.1181025,385.8381922,854.4921778,18.6556766,28.3111646,3.0181361,82.7413824),(21192,'metacarpus-maybe',243,5,154,243.3263643,51.4350821,67.3713351,1.8,51.3925067,67.796003,-0.0036414,19.4453766,26.8856472,7084.5896059,17046.1091957,0.0005376,634.0226471,364.3328558,766.1299475,18.6592557,28.5404924,3.0118901,82.6916221),(21193,'metacarpus-maybe',243,5,155,243.1068523,51.4995475,67.3617414,1.8,51.422404,67.7762328,-0.0051478,19.7337322,20.1387429,7085.3773326,17307.6498959,0.0010737,859.4205684,359.0490271,902.3656725,0.410156,0.9171367,1.1071487,1.9804084),(21194,'metacarpus-maybe',243,5,156,243.3413646,51.5679071,67.347671,1.8,51.4506068,67.8243813,-0.0041068,19.9686833,19.3117711,7086.0922059,17640.5785297,0.0006843,913.4624918,354.8602637,915.9181999,0.410156,1.4501204,1.7126934,3.2108764),(21195,'metacarpus-maybe',243,5,157,243.2304489,51.6504179,67.2976319,1.8,51.5932232,67.6537732,-0.0001422,19.2476505,17.663238,7054.8472911,17948.947467,0.0000006,1016.1753705,366.5303092,962.6710164,18.6578867,29.3290221,3.0224414,83.8517185),(21196,'metacarpus-maybe',243,5,158,243.6465199,51.7368322,67.2647808,1.8,51.6646437,67.6335607,0.0018831,20.1008363,27.9168379,7066.9845924,18236.7138305,0.0001441,653.2514146,351.5766443,780.7888149,18.6507296,29.588854,3.0791738,84.4317667),(21197,'metacarpus-maybe',243,5,159,244.2434615,51.8071681,67.2094138,1.8,51.7150099,67.5794789,0.0043882,19.8825096,18.0022185,7071.8112082,18528.2147716,0.000784,1029.2184116,355.6800104,982.2969172,18.8223825,29.8745929,0.0962534,84.771551),(21198,'metacarpus-maybe',243,5,160,244.9938983,51.8674986,67.1546055,1.8,51.769949,67.5135017,0.0071044,20.2298441,17.7883248,7087.6654398,18858.8288072,0.0020609,1060.1801474,350.3568983,1000.5658609,18.662098,30.2161399,0.0679226,85.3018389),(21199,'metacarpus-maybe',243,5,161,245.8746863,51.9510885,67.0799164,1.8,51.7034528,67.5519774,0.0072215,20.3010334,17.8767135,7098.0577973,19079.7550994,0.0021371,1067.2965761,349.6402202,1280.7052216,0.410156,1.2970272,1.2490458,2.8007204),(21200,'metacarpus-maybe',243,5,162,245.7382687,52.0021357,67.0323931,1.8,51.8660538,67.4855523,0.0105878,20.1832918,16.2891248,7108.3399945,19318.4437633,0.0045912,1185.9718661,352.1893297,1070.5815054,0.205078,0.6485136,1.8925469,1.4003602),(21201,'metacarpus-maybe',243,5,163,247.3654535,52.02847,66.9964456,1.8,51.8322085,67.5226063,0.0125207,20.4080679,19.3648231,7179.9780726,19678.8599141,0.0064626,1016.2168696,351.8205688,1300.4965379,18.662098,31.0813283,3.0557117,86.7021991),(21202,'metacarpus-maybe',243,5,164,248.7356192,52.0937703,66.9164754,1.8,51.9514475,67.3177675,0.0188502,14.1139648,16.5670888,7248.7209721,20051.9384582,0.014729,1210.3477403,513.5850243,1601.0039071,0.205078,0.2900241,2.3561945,0.5800482),(21203,'metacarpus-maybe',243,5,165,249.6469813,52.1474061,66.8649697,1.8,51.9840624,67.2311865,0.0207397,18.5747615,25.7228253,7399.627314,20440.3376744,0.0178945,794.6381245,398.3699763,877.4487835,0.4540328,1.375705,1.1071487,2.9706125),(21204,'metacarpus-maybe',243,5,166,253.2120883,52.2106614,66.8023904,1.8,52.1063175,67.149256,0.0210359,14.2287012,16.8633636,7641.8364849,20920.6132618,0.0186718,1240.5955158,537.0719623,1646.6100633,19.0549818,32.2390182,3.0906813,89.4119365),(21205,'metacarpus-maybe',243,5,167,258.3747745,52.2707817,66.7567271,1.8,52.2046497,67.0885504,0.0221635,14.2723183,17.1278583,7937.0935349,21605.5979332,0.0211496,1261.4302092,556.1180297,1688.8325704,19.2600796,32.5480172,3.0469396,90.4519009),(21206,'metacarpus-maybe',243,5,168,263.5030887,52.320405,66.7498199,1.8,52.2803048,67.0223743,0.0246479,19.7528399,22.17375,8243.9469243,22328.0280478,0.0266752,1006.9576879,417.3550218,1060.268422,19.4687054,32.95636,3.0481159,91.8728725),(21207,'metacarpus-maybe',243,5,169,263.8624083,52.4950429,66.8043137,1.8,52.5314047,67.0961044,0.0274923,19.4973737,24.3050226,8497.8241158,23038.7535679,0.0332303,947.9009335,435.8445522,1037.4464385,19.6760006,33.3647473,3.0492633,103.7261737),(21208,'metacarpus-maybe',243,5,170,269.6688468,52.5999438,66.6732902,1.8,52.5646826,66.9961377,0.0336469,24.2464648,25.9492895,9000.440483,23647.296997,0.0508633,911.2888057,371.2063006,1034.1204743,20.0577542,33.7731775,3.050383,92.6725731),(21209,'metacarpus-maybe',243,5,171,277.2849719,52.6911703,66.6593045,1.8,52.6573282,67.0535521,0.0381706,21.3691802,30.432519,9536.941224,24542.0386168,0.0673011,806.4412484,446.2942026,973.5243533,20.2822631,34.2007149,3.0455039,94.2428254),(21210,'metacarpus-maybe',243,5,172,281.69494,52.7107053,66.8170281,1.8,52.6846663,67.1804024,0.0390669,20.7089428,25.7181557,10083.0888354,25734.540201,0.0716184,1000.6370794,486.8953937,1105.4200437,0.550594,0.7394192,0.5880026,1.7401445),(21211,'metacarpus-maybe',243,5,173,288.1598889,52.7125611,66.9486203,1.8,52.7032295,67.2195846,0.0384756,20.7472364,26.1385714,10756.0193943,26944.270313,0.0710624,1030.8241359,518.4314282,1154.1786917,25.429672,35.1408199,3.0773537,179.6356474),(21212,'metacarpus-maybe',243,5,174,293.892957,52.6957127,67.0356783,1.8,52.7176182,67.2034686,0.0394782,19.6837484,26.310437,11411.3156837,28362.3421885,0.0763,1077.9882592,579.7328572,1213.7207864,21.53319,35.5377157,3.0838534,99.1355485),(21213,'metacarpus-maybe',243,5,175,297.1299941,52.7593456,67.1115876,1.8,52.7805989,67.1759275,0.0442685,14.3212805,18.4863693,12033.9385976,29743.1882,0.0969842,1608.9253484,840.2837017,2197.7554071,21.738268,36.1082903,3.1131912,101.1365683),(21214,'metacarpus-maybe',243,5,176,301.1774947,52.8549,67.2546158,1.8,52.9214264,67.2197679,0.053186,14.3076923,18.844068,12523.2863366,31099.756125,0.1418592,1650.3737977,875.283454,2226.4572049,0.410156,0.5800482,2.3561945,1.1600964),(21215,'metacarpus-maybe',243,5,177,301.0905896,53.0172072,67.310012,1.8,53.0486537,67.305054,0.0633594,14.8904112,19.2574382,12825.5271982,32215.4502172,0.2011812,1672.8834777,861.3279377,2233.4962463,22.8311227,37.8506437,3.0111893,106.2574813),(21216,'metacarpus-maybe',243,5,178,299.3496216,53.154064,67.3375048,1.8,53.1101228,67.3000098,0.0690178,14.7929412,19.4781158,12951.7441968,33233.0743884,0.2372793,1706.1750119,875.5354335,2175.0032419,0.550594,2.2928417,1.1071487,4.9510209),(21217,'metacarpus-maybe',243,5,179,302.8856455,53.3095521,67.3071944,1.8,53.123244,67.4006813,0.0667691,14.9391407,19.7718995,13189.9207378,34405.9941719,0.2247156,1740.1461186,882.9102665,2175.1436033,0.205078,0.4585683,2.0344439,0.9902042),(21218,'metacarpus-maybe',243,5,180,312.8946347,53.4483927,67.2883698,1.8,53.2189553,67.4497361,0.067376,14.9784496,20.126173,13645.4667869,36163.6128022,0.2363743,1796.8449757,911.006622,2373.0436384,24.2755052,39.6097951,3.0326507,111.2788739),(21219,'metacarpus-maybe',243,5,181,330.6645142,53.6038975,67.2922142,1.8,53.2233342,67.5403945,0.0653806,14.8700214,20.6415467,14600.1184004,38501.7687605,0.2352428,1865.2559974,981.8491886,2405.7136335,24.7555737,40.2209146,3.1058935,113.6488269),(21220,'metacarpus-maybe',243,5,182,355.0209001,53.6539808,67.4043364,1.8,53.2735133,67.6644934,0.068359,20.3154323,28.5439372,16119.0712145,41797.8981289,0.2760696,1464.335416,793.4397347,1653.1026784,25.8608137,40.6799495,0.060532,117.4689003),(21221,'metacarpus-maybe',243,5,183,377.91355,53.675697,67.573509,1.8,53.2935676,67.8693231,0.0756336,19.6695446,21.2543625,17752.0718855,45139.687107,0.3596186,2123.7845676,902.5156528,2720.9795626,26.068751,41.1159654,0.069886,131.9118069),(21222,'metacarpus-maybe',243,5,184,395.008606,53.5676206,67.7572096,1.8,53.265057,68.0735738,0.0646559,24.7543012,21.4163828,18617.3382483,47501.2623718,0.274832,2217.9871771,752.0849854,2450.8675069,0.410156,0.5800482,0.7853982,1.1600964),(21223,'metacarpus-maybe',243,5,185,401.7067801,53.3857611,67.6875367,1.8,53.2973351,68.1292452,0.0519663,15.634775,22.0886591,18970.4947079,47928.7130626,0.1806389,2169.8335219,1213.3525892,2989.2801436,0.615234,1.1043788,2.7610863,2.6102168),(21224,'metacarpus-maybe',243,5,186,409.4702321,53.364771,67.5653861,1.8,53.2543019,68.1034616,0.0508375,16.8248932,21.478059,19499.7399385,47696.6603019,0.1762245,2220.7155811,1158.981497,2973.9717788,0.205078,0.2900241,2.3561945,0.5800482),(21225,'metacarpus-maybe',243,5,187,418.8525594,53.4634326,67.5324409,1.8,53.3935685,68.0666055,0.0428654,16.1133061,21.7321474,20625.2261348,48025.5885596,0.1281913,2209.8869289,1280.0120596,2983.028037,28.095686,41.6313391,0.2437839,195.2230402),(21226,'metacarpus-maybe',243,5,188,431.0884787,53.5819883,67.5103926,1.8,53.5442757,68.0347119,0.0374589,17.039435,21.8017062,22112.7108519,49168.2895851,0.100768,2255.2496169,1297.7373258,3064.6843265,0.410156,0.7394192,2.1587989,1.5702524),(21227,'metacarpus-maybe',243,5,189,444.1459367,53.5708943,67.3867463,1.8,53.5611766,67.96869,0.0265238,16.9939901,21.6488242,23701.496586,51087.1524825,0.0520642,2359.8118771,1394.6987409,3208.8703773,0.615234,1.02539,2.4980915,2.1503005),(21228,'metacarpus-maybe',243,5,190,441.1500009,53.6291145,67.2888481,1.8,53.6411713,67.9567394,0.0205496,18.8419299,30.4362155,24606.5250735,53116.1195696,0.0310441,1745.1617664,1305.945046,2171.3770731,30.8007214,42.8554142,0.4293998,198.6862542),(21229,'metacarpus-maybe',243,5,191,437.4245166,53.8763677,67.2972344,1.8,53.7494434,67.972118,0.0249242,17.9562438,22.2064462,25026.0031838,55427.3699477,0.0452795,2496.003617,1393.7215047,3339.9796231,0.550594,1.02539,2.2142974,2.1503005),(21230,'metacarpus-maybe',243,5,192,440.4465787,53.9398345,67.3372088,1.8,53.773316,67.989806,0.0174805,20.46364,29.0522601,24842.3862968,58291.4390464,0.0224286,2006.4338865,1213.9768997,2375.1452281,1.3432913,2.5366748,1.3258177,6.6414052),(21231,'metacarpus-maybe',243,5,193,448.0222909,54.058884,67.3690223,1.8,53.8322941,67.9189862,0.0093766,21.2589947,23.2413655,24046.9620259,61604.3171946,0.0065646,2650.6324356,1131.1429509,3530.7682577,1.3767454,2.7360818,1.3439975,8.5514419),(21232,'metacarpus-maybe',243,5,194,454.3163992,54.0285994,67.42335,1.8,53.7629032,67.91869,0.0061432,15.7667619,22.8320846,22470.75755,65196.1262058,0.0028575,2855.4609618,1425.1980026,3643.7674211,19.6427746,29.6973904,0.8734055,86.2628942),(21233,'metacarpus-maybe',243,5,195,449.2285362,53.6879098,67.4758146,1.8,53.5527947,67.9470558,0.0066887,15.3557657,22.4936375,20098.1801071,65297.7652009,0.0033501,2902.9437824,1308.8360762,3632.8603949,19.838712,29.2514851,0.8697745,85.2933014),(21234,'metacarpus-maybe',243,5,196,430.3978266,53.0855702,67.502183,1.8,53.1526383,67.8764234,0.0053803,14.5743533,21.9003262,16974.4363472,60928.3176004,0.002077,2782.0735236,1164.678529,3447.1462984,19.8889409,28.4593295,0.8363744,105.2964261),(21235,'metacarpus-maybe',243,5,197,392.3446656,52.046497,67.4254283,1.8,52.4776319,67.7466088,-0.0084345,13.7148964,22.1750006,13352.7680538,50142.781207,0.0046519,2261.2302061,973.5959849,2811.1761702,19.9717626,27.4168655,0.811847,104.3062219),(21236,'metacarpus-maybe',243,5,198,321.5035596,50.4364894,67.2340982,1.8,51.0747989,67.5203182,-0.0522486,13.2771141,22.2055124,9614.0872344,30292.3032495,0.1461462,1364.1794301,724.109712,1773.2511889,19.7715839,25.7591357,0.7008544,96.894265),(21237,'metacarpus-maybe',243,5,199,252.7426941,51.6417983,67.0329774,1.8,50.9779142,67.2235756,-0.0546554,11.6648414,18.9819543,6159.6383785,17991.262038,0.1257076,947.8087303,528.0516204,1263.2661108,19.0071882,23.544705,0.6556956,96.0327302),(21238,'metacarpus-maybe',243,5,200,191.2337402,52.2341355,66.8814085,1.8,52.4463121,67.0156169,-0.0393659,12.8298382,13.2411214,3242.8292496,10749.06251,0.0493659,811.7939688,252.7568306,977.6326675,11.5665356,20.7564873,1.0541012,70.0883805),(21239,'metacarpus-maybe',243,5,201,99.6299541,49.6777305,66.8318055,1.8,51.5368205,66.8584144,-0.0419578,7.7200839,15.1384198,918.7602535,4066.7806793,0.0292153,268.6397085,119.0091017,323.7416349,0.410156,0.9171367,1.1071487,1.9804084),(21240,'metacarpus-maybe',243,5,202,20.0969308,45.9716407,67.0388664,1.8,46.5118819,66.9659283,-0.2952865,5.0390112,6.3498766,69.2307453,168.0407928,0.2836653,26.4636311,13.7389546,36.4876116,9.5740455,12.9134019,0.7517031,37.159305),(21241,'metacarpus-maybe',243,5,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21242,'metacarpus-maybe',243,5,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(21243,'metacarpus-maybe',243,5,205,0.0107819,31.6879447,74.443314,1.8,31.684551,74.443314,0.0682024,0.0211953,0.3102877,0.0000403,0.0005858,0.0000083,0.0018881,0.0019035,0.0020134,0.205078,0.8455583,2.896614,1.6903843),(21244,'metacarpus-maybe',243,5,206,13.670687,38.2875141,61.3493776,1.8,38.3059044,61.3346257,-0.9703686,5.1558635,5.2362293,71.6256806,74.3600923,1.551122,14.2010763,13.8920823,27.7707116,10.2539,10.7524255,0.9616329,34.2178413),(21245,'metacarpus-maybe',243,5,207,38.3996214,38.3387281,61.3368294,1.8,38.3394545,61.3297499,-0.5887377,7.5179782,7.6026476,468.3029583,484.4521153,1.9735551,63.7215007,62.2910772,123.7571883,14.970694,15.5710798,0.8693128,50.1314798),(21246,'metacarpus-maybe',243,5,208,62.4973313,38.3568257,61.3494317,1.8,38.3389146,61.3456937,-0.6132567,9.2042181,9.2859528,1189.9544851,1219.2606997,3.4502597,131.3016261,129.2836037,258.8539839,18.45702,18.8682905,0.6543702,61.4338818),(21247,'metacarpus-maybe',243,5,209,88.3730067,38.426623,61.2900131,1.8,38.4007754,61.2984328,-0.7228881,10.5445273,10.6326427,2221.4088096,2262.3106001,6.446113,212.7703025,210.6693588,420.5743606,21.123034,21.4794119,0.7448798,70.1260669),(21248,'metacarpus-maybe',243,5,210,251.8025803,57.2117521,63.3335915,1.8,55.0487796,64.3539693,0.1331067,17.7660375,30.3872411,8179.6240144,76802.4904564,0.7391668,2527.4584919,460.4079007,2796.4804118,23.0883938,23.3905821,0.5539525,76.3573161),(21249,'metacarpus-maybe',243,5,211,557.9915599,60.692443,67.0053207,1.8,55.0400005,65.8118659,0.2580525,17.63485,35.2988028,25912.1730182,112588.9355141,6.0566294,3189.5964342,1469.3730354,3923.4464074,24.60936,25.0807963,0.5221887,81.8386249),(21250,'metacarpus-maybe',243,5,212,594.0435731,60.3669016,67.3194251,1.8,54.5862605,65.8314332,0.2479546,16.3586459,35.7492023,28807.8574523,119579.9237291,5.9633822,3344.9676098,1761.0172374,4150.352646,26.044906,26.3921921,1.1801893,86.3297295),(21251,'metacarpus-maybe',243,5,213,601.5000473,60.1971929,67.3226682,1.8,54.3693268,65.9083449,0.2299008,16.3790724,36.0622294,29311.3746356,123447.7737543,5.2059553,3423.1875225,1789.5625527,4232.2405183,26.865218,27.4107289,0.7695265,89.6607378),(21252,'metacarpus-maybe',243,5,214,607.3071612,60.0731067,67.3247504,1.8,54.2378658,65.9855272,0.2164601,16.3630128,36.2984794,29736.5344114,126489.2050853,4.6689525,3484.6970792,1817.3019056,4301.8191893,27.68553,28.1226176,0.6872688,92.1010624),(21253,'metacarpus-maybe',243,5,215,611.1344744,60.0096236,67.3215799,1.8,54.1495778,66.0489166,0.2062699,25.1030496,36.4673959,29960.6652996,128619.5306115,4.2725691,3526.9732672,1193.506993,4343.9496069,28.300764,28.6324437,1.1423905,93.7914467),(21254,'metacarpus-maybe',243,5,216,612.421775,59.9917266,67.3064847,1.8,54.1223504,66.0835597,0.1988249,24.791436,36.5551941,29991.4324226,129723.5940893,3.9820875,3548.7048322,1209.7497059,4364.3131114,28.505842,28.9225423,1.0595656,94.6117587),(21255,'metacarpus-maybe',243,5,217,610.9683748,60.1175352,67.2582642,1.8,54.2799502,66.0654015,0.1922201,16.9883752,36.6603972,29859.4910279,129408.3708189,3.7162913,3529.9227705,1757.6425454,4334.9630609,28.71092,29.0400876,0.9357696,95.5315912),(21256,'metacarpus-maybe',243,5,218,610.2977188,60.1758229,67.2406605,1.8,54.3435852,66.057247,0.1873798,16.2018277,36.6688626,29812.5792671,129297.8759363,3.5297785,3526.0945328,1840.0750672,4328.9855832,28.71092,29.1217981,0.9808406,95.0716749),(21257,'metacarpus-maybe',243,5,219,609.8950423,60.2040865,67.2150922,1.8,54.375553,66.050513,0.1838217,16.5340893,36.686865,29829.3277926,129402.2734209,3.3962542,3527.2099039,1804.1107244,4336.4101884,28.71092,29.1946379,1.01592,95.1918069),(21258,'metacarpus-maybe',243,5,220,610.0783725,60.2401861,67.1814615,1.8,54.3960668,66.037397,0.1820899,16.4165619,36.6394011,29845.646266,129602.5541339,3.3342694,3537.2454325,1818.0205102,4344.6638083,28.7083386,29.12974,1.0062269,95.5315912),(21259,'metacarpus-maybe',243,5,221,610.9337096,60.2444123,67.1414029,1.8,54.3784992,66.0177138,0.1781075,17.2775021,36.5954907,29897.022466,130338.9813121,3.1960234,3561.6131566,1730.4019017,4367.8576032,28.7083386,29.139123,1.2112019,95.1918069),(21260,'metacarpus-maybe',243,5,222,612.0723197,60.2577039,67.0948487,1.8,54.3409053,65.9761169,0.1750312,17.1363982,36.538139,29981.2371271,131011.5265468,3.0934487,3585.6102708,1749.5646833,4399.1256811,28.7004318,29.0950686,1.1955255,94.9017828),(21261,'metacarpus-maybe',243,5,223,614.4783234,60.2926649,67.0550214,1.8,54.3698115,65.9573436,0.1724101,16.2652934,36.5254507,30157.0550005,131920.9879595,3.0142083,3611.7552383,1854.073835,4432.3023053,28.505842,29.1102424,1.1575791,94.9017828),(21262,'metacarpus-maybe',243,5,224,616.4020227,60.3103979,67.0180225,1.8,54.3878648,65.944165,0.1701218,16.8937243,36.4693215,30331.7210404,132714.9408433,2.9446852,3639.0844561,1795.4431143,4458.2010377,28.6178745,29.0950686,0.7055682,95.361699),(21263,'femur',243,7,1,0.0554181,67.5480045,106.8237801,1.8,67.4796875,106.8453125,0.0212276,5.2860799,41.5991653,0.6513738,43.8194165,0.0000042,1.0533725,0.1232244,1.060503,0,0,0,0),(21264,'femur',243,7,2,0.0576882,77.6527416,108.695421,1.8,78.7708333,108.4913194,-0.1848239,0.2439367,29.4219823,0.0016811,11.6553703,0.0003247,0.396145,0.0068917,0.396202,0,0,0,0),(21265,'femur',243,7,3,0.0557119,69.5373472,109.5175575,1.8,69.528125,109.5171875,0.0691157,0.2552849,12.7097426,0.0014635,5.6314685,0.0000443,0.4430828,0.0057328,0.4431086,0,0,0,0),(21266,'femur',243,7,4,0.0571274,56.9711314,108.397959,1.8,56.6140625,108.359375,0.1035996,0.2065966,22.3671302,0.000937,6.325692,0.0001018,0.282812,0.0045355,0.282851,0,0,0,0),(21267,'femur',243,7,5,2.6240123,47.2438958,90.8254208,1.8,47.0960553,91.7781762,-1.5698589,17.4921179,18.4112512,17.7921873,31.5738109,0.437335,1.7149193,1.0171545,1.944032,3.7786019,5.7105046,2.0576956,15.4920556),(21268,'femur',243,7,6,22.3391718,46.2437842,87.4761007,1.8,46.0814654,87.171516,1.304473,20.687448,25.47795,70.9475762,505.8385445,3.465301,19.8539735,3.4294987,20.8840314,7.1234895,18.6842663,1.8774726,46.3197398),(21269,'femur',243,7,7,51.1052376,46.0861184,85.8247286,1.8,46.2548233,86.2715866,1.3055652,19.6772164,26.3230422,264.4851841,1917.4387913,7.9322708,72.8425983,13.441189,79.6831309,10.0442069,24.4268779,1.8541043,60.5820988),(21270,'femur',243,7,8,78.3229358,46.2669836,87.0141139,1.8,46.3525355,87.1265775,1.3548489,8.9089576,24.7189616,637.342009,4384.9378597,12.4544838,177.3916691,71.5394592,191.1400045,11.951493,29.0892056,1.8182502,71.7614775),(21271,'femur',243,7,9,98.7839291,46.5030763,87.3671824,1.8,46.4647027,87.2120589,1.3470897,38.6185893,29.8816011,1010.763288,7106.3928942,15.6537067,237.8183442,26.1729728,168.5083516,12.5631687,32.2652732,1.7934573,78.9585114),(21272,'femur',243,7,10,113.5024617,46.5435087,87.4823223,1.8,46.3611592,86.9567784,1.3508324,37.7130258,28.9118218,1284.8227933,9840.9529762,18.0164573,340.3781692,34.0684092,234.127482,13.0180864,34.2733155,1.815775,83.8824168),(21273,'femur',243,7,11,129.0693581,46.4384097,87.3173938,1.8,46.2621089,86.6019838,1.3460323,31.0078768,29.3423201,1653.5699788,12496.0692454,20.4429976,425.8718874,53.3274171,333.3942036,14.5162776,36.3753658,1.8434907,89.4422686),(21274,'femur',243,7,12,142.68439,46.3331104,86.9276328,1.8,46.1315557,86.1479482,1.3518647,11.9195271,20.1393724,2077.7987357,14743.121192,22.6589911,732.0546486,174.31889,741.426955,15.6942216,38.2508202,1.8458977,93.4966472),(21275,'femur',243,7,13,152.9849137,46.1895769,86.4498179,1.8,46.0186965,85.6625106,1.3479828,11.9599721,20.3863854,2522.1242396,16481.6079264,24.2524504,808.4615112,210.8804456,822.9088402,16.6264519,39.2425631,1.8231143,96.7833705),(21276,'femur',243,7,14,166.3708486,46.0477548,86.0275422,1.8,45.998095,85.3608946,1.330578,32.7944528,32.3125523,3187.1366452,18374.2370841,26.1589492,568.6408468,97.1852364,470.9832112,0.296875,0.6638327,2.0344439,1.4334393),(21277,'femur',243,7,15,179.4916849,46.0419111,85.7768041,1.8,45.9855379,85.1540711,1.3252936,30.985756,32.7897659,3960.7680739,19750.1420708,28.1481739,602.3264137,127.8254459,527.4014766,18.5131576,40.2536665,1.8014647,100.7060403),(21278,'femur',243,7,16,190.8554343,46.0412992,85.5650056,1.8,45.9636787,84.9946132,1.3115635,50.778146,33.588636,4826.4485676,20733.815769,29.7190626,617.286626,95.0497201,455.6456494,0.296875,0.9388012,1.8925469,2.0271893),(21279,'femur',243,7,17,203.3487777,45.9670983,85.236351,1.8,45.9542292,84.8813748,1.2880193,34.1132965,34.918888,5777.6757406,21979.4458758,31.2528737,629.4428936,169.3672655,568.6018126,0.296875,0.6638327,2.0344439,1.4334393),(21280,'femur',243,7,18,212.7405252,46.04886,85.2223558,1.8,46.0522108,84.9150372,1.2651903,43.8608014,35.4108898,6656.9070801,22789.6339078,32.2470868,643.5769904,151.7734941,579.5564797,0.7816011,2.448094,1.815775,5.7337572),(21281,'femur',243,7,19,253.362266,53.7442353,84.6159997,1.8,54.7061986,84.3747377,-0.0452969,28.609095,65.5484497,22542.5275207,104979.9642284,0.0865824,1601.5628849,787.9496891,1841.9621434,21.9328472,41.0386067,1.9177132,105.888244),(21282,'femur',243,7,20,343.2165142,66.2019615,83.510763,1.8,62.5166834,83.7892185,-0.0743736,28.865574,46.9387607,24632.7657531,268267.0067094,0.3158301,5715.2554284,853.3613703,6237.558062,22.7525627,41.1811748,1.9472867,107.4657512),(21283,'femur',243,7,21,419.5476844,71.8120535,83.0226485,1.8,67.4234554,83.4951633,-0.0823602,27.655285,43.0706669,28525.5267785,353206.8785503,0.4732408,8200.6363898,1031.4674676,8854.5840193,23.7907957,41.3594931,1.9766306,108.8271565),(21284,'femur',243,7,22,490.1377026,75.6023102,82.6908912,1.8,71.0743518,83.2421911,-0.0862133,29.6679192,43.0174565,33026.4389184,412466.6366074,0.6056736,9588.354834,1113.2037517,9140.3670047,24.8008427,41.5974741,1.9897453,110.5065351),(21285,'femur',243,7,23,575.6717449,78.1346474,82.4171146,1.8,73.910241,82.9061744,-0.0929699,29.8881726,45.6632912,38706.2521648,458567.379882,0.8269062,10042.3637345,1295.035754,10534.4913537,26.2858324,41.7191245,1.996246,112.3598191),(21286,'femur',243,7,24,680.607721,79.5429348,82.1202577,1.8,75.5783262,82.6155373,-0.0994864,31.7879208,47.4049682,46160.9658537,490806.423822,1.1190267,10353.4806994,1452.1542999,11040.9515405,28.5069259,41.7244056,2.0758216,116.066387),(21287,'femur',243,7,25,776.3555677,80.1394248,81.8434164,1.8,76.3507638,82.2788041,-0.1034194,30.2147745,48.7044372,54816.9709847,520820.4509458,1.3790015,10693.4907998,1814.2439239,11664.8051393,38.0547668,88.5006235,3.1147535,358.618124),(21288,'femur',243,7,26,825.5945116,80.9244023,81.7502286,1.8,77.232025,82.1553135,-0.1081065,33.5269105,49.0979072,62301.1394778,541957.3479999,1.6018681,11038.2983426,1858.2427843,12078.9272408,36.9424388,89.6877014,3.1151088,346.2738431),(21289,'femur',243,7,27,863.2944246,81.3612269,81.6485775,1.8,77.8078386,81.9915551,-0.1104769,30.3154468,49.6533843,70516.8309458,560167.0512887,1.748973,11281.548272,2326.1023135,12487.2536329,36.9746177,90.0490928,0.0461718,350.2983843),(21290,'femur',243,7,28,878.6269627,81.9461616,81.6288632,1.8,78.4489382,81.9532106,-0.1125481,30.438885,50.3543397,77223.1740085,569345.3150935,1.8471185,11306.777507,2536.9908956,12685.7320397,37.681972,90.6713796,0.052411,353.8012094),(21291,'femur',243,7,29,895.0900829,82.7942833,81.524146,1.8,79.1901777,81.919458,-0.1145798,30.2293013,51.1954079,83606.3324585,577149.5876441,1.949982,11273.4639863,2765.7381729,12790.5573253,38.3817447,91.1580297,3.1220512,377.3474666),(21292,'femur',243,7,30,905.1032072,83.3914471,81.4558306,1.8,79.7851837,81.8490354,-0.1135548,30.1982101,51.6765106,89007.7744886,581486.2825617,1.9368251,11252.4293031,2947.4519879,12911.8619405,38.4744304,91.7579106,0.0226498,284.2459459),(21293,'femur',243,7,31,909.5180913,83.9909837,81.407165,1.8,80.1990966,81.7414383,-0.110219,41.1420348,52.2606872,93588.227793,582974.1905143,1.8340596,11155.1191032,2274.7593345,12930.3890408,39.2208837,91.6497891,0.0680765,291.820628),(21294,'femur',243,7,32,911.5120202,84.3421473,81.4574583,1.8,80.5498055,81.6717899,-0.1046689,44.5254307,52.4779217,97576.6420673,585682.8454673,1.6582861,11160.5571689,2191.4811517,13018.2296383,40.2363417,91.870222,0.0970963,281.1928028),(21295,'femur',243,7,33,905.3721785,84.3999015,81.4236526,1.8,80.9050109,81.5457423,-0.0987039,42.8525784,52.2474395,98723.4350582,582321.2682891,1.4653248,11145.4508295,2303.7921797,13034.4350368,40.8804402,91.870222,0.0970963,281.1928028),(21296,'femur',243,7,34,884.890113,84.2491758,81.4965549,1.8,81.1867318,81.5988103,-0.0905953,35.1131312,51.259663,98154.4333789,563701.7326508,1.2071487,10996.9847536,2795.3768267,12911.0735362,41.1516899,91.0753278,0.1077775,267.9440384),(21297,'femur',243,7,35,858.9081977,84.052445,81.5410212,1.8,81.4559934,81.602179,-0.0844595,33.4048033,50.2181458,96847.4002266,540096.8749321,1.0187333,10755.0142683,2899.2058196,11881.9975553,41.5004396,90.106331,0.1288503,277.8762421),(21298,'femur',243,7,36,833.9625604,83.6509283,81.6594261,1.8,81.6112359,81.633124,-0.0801057,27.637387,48.8186021,94583.0757519,521242.965571,0.8900058,10677.1382826,3422.2871983,11682.2843601,41.7560248,88.946148,0.103654,275.6031135),(21299,'femur',243,7,37,801.9021773,83.4041581,81.7701973,1.8,81.8206697,81.6411467,-0.0757417,30.4285288,47.7182388,91016.2511505,491340.1193313,0.7652618,10296.6943402,2991.1485991,12199.4645327,41.8104393,87.8629637,0.1151348,287.7364119),(21300,'femur',243,7,38,770.4758571,83.0841105,81.9452899,1.8,81.9774844,81.7839043,-0.071061,30.3475094,45.644287,86176.1975707,462700.8771346,0.6473503,10137.103833,2839.6464554,11913.3231568,0.296875,0.6638327,2.0344439,1.4334393),(21301,'femur',243,7,39,741.1881403,82.3341862,82.116304,1.8,81.7636549,81.8578918,-0.0673585,39.3907142,44.032376,81206.9408648,437265.4844282,0.5596355,9930.5448469,2061.5757402,11617.748096,41.7602885,85.0048051,0.193286,277.4687566),(21302,'femur',243,7,40,714.6770159,81.47823,82.2677828,1.8,81.3317196,82.0216296,-0.0668372,42.218602,42.5918242,76330.0227654,415406.8781055,0.5313095,9753.2070144,1807.9713489,10193.2986222,41.3421526,84.0738259,0.1918555,283.4062566),(21303,'femur',243,7,41,691.7897793,80.2553515,82.4459483,1.8,80.542074,82.2214282,-0.066087,29.951839,41.9380539,70899.2004875,391211.2305217,0.5028313,9328.3115022,2367.1067565,9437.2409839,40.9948703,82.6752902,0.198804,294.7718996),(21304,'femur',243,7,42,669.9992864,79.1133383,82.6432786,1.8,79.5431901,82.5251887,-0.0663854,27.9424848,47.4485417,66150.8836095,364608.8105265,0.491395,7684.2996071,2367.3944544,8214.8884976,40.6379937,81.1778075,0.2174789,283.7118708),(21305,'femur',243,7,43,646.3265288,78.0522691,82.7471037,1.8,78.3670698,82.7879442,-0.068149,29.8770211,41.8906235,63159.4726217,331164.9596792,0.4995128,7905.4674377,2113.9815945,9378.1979135,0.296875,0.4198447,2.3561945,0.8396893),(21306,'femur',243,7,44,620.6869503,76.9267255,82.9015894,1.8,77.3367505,82.9985576,-0.0778689,23.788596,42.8022725,61154.4100867,296540.9988972,0.6259959,6928.1601578,2570.7448222,8332.4204219,39.6385602,79.7069293,0.2025087,275.8788903),(21307,'femur',243,7,45,601.2938566,76.1084168,83.0109284,1.8,76.5999612,83.0627015,-0.0931797,29.8444635,42.9155725,60037.4338568,267360.496023,0.867602,6229.917958,2011.6774361,7627.0398486,39.1725928,78.3862445,0.175111,272.664201),(21308,'femur',243,7,46,581.9385807,75.0482875,83.2198853,1.8,75.5718788,83.2763658,-0.1162078,29.8774333,42.2533974,58858.2309014,238711.1171323,1.3038884,5649.5129881,1969.9895317,6916.0573317,38.7600398,75.9518585,0.1490832,262.1084098),(21309,'femur',243,7,47,569.219185,74.3382924,83.4145108,1.8,74.757858,83.5296521,-0.1476314,30.9669476,40.82843,57914.4920696,216828.3884401,2.0527144,5310.7207005,1870.2034421,6675.7169309,38.1153167,73.3521595,0.129877,265.9590456),(21310,'femur',243,7,48,560.1250393,73.8403048,83.4767924,1.8,74.1579345,83.6558161,-0.1795107,31.4998583,39.1260638,56699.9704133,198875.9824545,2.9760791,5082.9540028,1800.0071607,6410.8009952,0.4198447,0.8396893,0.7853982,1.6793786),(21311,'femur',243,7,49,541.0419396,73.3102366,83.5102824,1.8,73.2766882,83.7863674,-0.220573,31.1345795,36.3068373,54607.5714551,176156.1450936,4.3164794,4851.8724852,1753.9203136,6106.4345238,37.7713021,67.3304384,0.0838736,251.2222863),(21312,'femur',243,7,50,525.5581569,73.0067728,83.6705895,1.8,72.5152743,84.0730299,-0.2552079,29.0786867,33.1213104,53239.1566034,161285.8355236,5.5822389,4869.5487421,1830.8652386,6263.3341234,36.686985,62.798712,0.0709707,242.4601042),(21313,'femur',243,7,51,517.6656085,72.7887908,83.8801849,1.8,72.1192321,84.3952504,-0.2826424,32.2222462,43.2059965,52432.7025839,150893.4489514,6.71084,3492.4191332,1627.2205941,4525.4568154,36.4291167,60.408774,0.0688565,211.4461556),(21314,'femur',243,7,52,501.0917857,72.8882925,83.9593346,1.8,71.8628338,84.6803302,-0.3061581,32.4628103,31.3920728,51370.6581478,141146.5205727,7.5865735,4496.2472318,1582.4464261,5453.9193179,36.2308803,58.8891056,0.060532,203.1933305),(21315,'femur',243,7,53,486.428511,73.0509761,84.0432245,1.8,71.7735704,84.8771768,-0.3241039,24.7115795,30.9571873,50642.3538948,132445.6417587,8.2219755,4278.3486917,2049.3369918,5299.8123731,36.0227449,57.6702134,0.0515008,201.6281824),(21316,'femur',243,7,54,470.6682789,73.2693643,84.0617112,1.8,71.6743381,85.0564594,-0.3424656,21.0486668,29.9479857,49845.4578724,124806.708892,8.8461075,4167.4491973,2368.1052251,5593.9466064,35.7758569,56.8343132,0.067958,192.9977091),(21317,'femur',243,7,55,462.1583865,73.4992566,84.0397603,1.8,71.7814899,85.2265295,-0.3516201,34.1966043,29.5312027,49842.3168517,118213.048262,9.1372288,4002.9879372,1457.5224012,4147.2344541,35.7309158,55.8630091,0.0425275,181.9922359),(21318,'femur',243,7,56,450.2958744,73.7166184,83.8824888,1.8,71.993805,85.1584203,-0.3613027,31.0240869,29.7997011,49800.9303894,111406.6902143,9.3779678,3738.5170314,1605.2343661,4714.4010117,35.789868,54.7056131,0.0542944,165.9784642),(21319,'femur',243,7,57,438.9359441,74.0594555,83.670137,1.8,72.4523295,85.0033784,-0.3637393,26.3866005,28.49623,49425.3460464,104703.6745267,9.2595914,3674.2991794,1873.1229153,5331.6285282,35.8102452,53.8719751,0.2222553,167.9459786),(21320,'femur',243,7,58,430.780033,74.3099391,83.5250127,1.8,72.7969902,84.9942616,-0.3594556,30.4138132,28.1993671,49447.5200988,99455.2395922,8.8840058,3526.8607049,1625.8244174,4895.7780346,36.0575727,52.782004,0.232701,160.7067482),(21321,'femur',243,7,59,423.8740064,74.5652587,83.4975222,1.8,73.2690129,85.0010575,-0.3529045,20.5847066,33.6977486,49741.2313466,94879.3278297,8.4390835,2815.5984248,2416.4168275,4252.4002553,36.2279419,51.7900118,0.2727879,150.0068891),(21322,'femur',243,7,60,414.889495,74.924182,83.3648855,1.8,73.5935873,84.9036258,-0.3476439,20.4085,29.1696929,50047.0775051,91336.3951857,8.0257144,3131.2086699,2452.2663309,4050.3585964,36.6341187,50.9051901,0.1699425,167.9161412),(21323,'femur',243,7,61,414.8193344,75.2873033,83.2476405,1.8,74.0828888,84.8126367,-0.3288623,29.093623,44.1396803,51021.281004,88894.6635455,7.2114521,2013.9399041,1753.6929288,3088.2086652,37.0162042,50.0874845,0.1427353,149.8031463),(21324,'femur',243,7,62,416.3253439,76.1092304,83.3187486,1.8,74.8727747,84.9712374,-0.3086255,31.9362058,44.4927371,52514.5324092,86777.0032544,6.401952,1950.3633377,1644.3572755,3036.5473162,37.7578914,49.2633627,0.2683662,160.0111268),(21325,'femur',243,7,63,417.7361945,76.8670523,83.3310524,1.8,75.6448839,84.8792046,-0.3002842,31.1620543,44.3553912,54310.4311825,84380.5688372,6.0914802,1902.3745817,1742.8386007,3020.9551995,38.41621,48.5687863,0.2850166,149.9770517),(21326,'femur',243,7,64,421.7921297,77.3742231,83.3500392,1.8,76.06675,84.6899876,-0.2618639,26.4992027,24.7532597,56945.8963821,82006.0578081,4.7113875,3312.9397359,2148.9664074,5107.1431054,38.7408951,47.3457456,0.2860514,142.0000033),(21327,'femur',243,7,65,428.9803211,78.0226126,83.4217329,1.8,76.9039777,84.6976168,-0.1824804,28.8748606,25.384741,59905.4376367,79756.0057338,2.3544685,3141.8877122,2074.6572043,3931.6304689,39.0648148,46.466391,0.212432,144.722814),(21328,'femur',243,7,66,438.6061331,78.747893,83.5291779,1.8,77.8091739,84.7290602,-0.0411923,28.906615,26.9419876,62262.1011933,78792.394292,0.1239684,2924.5204675,2153.9049537,4817.0694138,39.1875,46.3172574,2.7813216,146.2581247),(21329,'femur',243,7,67,439.8465632,79.1393555,83.4760168,1.8,78.4209853,84.72319,0.0885284,28.3302873,27.4088431,63453.2441212,78126.3411988,0.5730341,2850.4063756,2239.767054,4031.7458517,39.1875,46.4919899,2.7895483,146.6357728),(21330,'femur',243,7,68,440.5835033,79.4864383,83.3496598,1.8,78.8348452,84.6084097,0.1949504,28.3074968,32.8832829,63576.4613662,76715.4260643,2.7556001,2332.9612858,2245.9231178,3766.8691519,39.1875,46.1991301,2.7527332,145.4781103),(21331,'femur',243,7,69,438.8856539,79.6637259,83.190675,1.8,79.0293959,84.4413346,0.2848149,24.7801096,32.2834346,63008.5396319,75406.5079866,5.7749775,2335.7647292,2542.7062502,3863.4033547,39.0430673,45.9964678,2.3881471,144.566387),(21332,'femur',243,7,70,424.9363241,79.6959896,83.0264265,1.8,79.1880899,84.3121524,0.4200104,22.9702668,24.2621716,61641.8833919,72617.3058729,11.776141,2993.0258109,2683.551042,4559.8462798,39.1163219,45.8573386,2.4203266,144.4645156),(21333,'femur',243,7,71,410.3209894,79.5794012,82.6379683,1.8,79.1444335,84.0550784,0.5050117,25.6365385,23.859635,59866.6726389,68858.8692476,16.0079604,2885.9984302,2335.2088927,4395.7768975,38.9636153,45.5652354,2.3331571,143.306853),(21334,'femur',243,7,72,404.9951123,79.7201269,82.3651171,1.8,79.3853519,83.6696883,0.6571626,24.8203852,24.3617027,58300.9918975,67018.4247896,25.1883786,2750.974573,2348.9156733,4188.9692992,38.8684418,45.2430098,2.2865399,162.9253212),(21335,'femur',243,7,73,399.0695984,79.9350825,81.8861777,1.8,79.7016388,83.1410473,0.7531209,23.9949453,24.9133578,56614.7954502,64332.3143637,31.1104773,2582.2418188,2359.4467422,4006.251069,0.5313673,1.070398,2.1587989,2.2731286),(21336,'femur',243,7,74,385.7355294,79.8751275,81.5035144,1.8,79.6099776,82.623277,0.8771366,24.0841364,23.1322736,54310.4035777,61657.7987939,38.0093913,2665.4448164,2255.0280686,3920.1800756,0.5761131,2.448094,1.3258177,5.2418786),(21337,'femur',243,7,75,375.4947504,79.9525909,81.0704731,1.8,79.8509206,82.0355921,0.9407736,22.5448921,23.9139314,51780.8516672,59836.6912916,40.8592591,2502.1687281,2296.7886216,3762.7211715,0.59375,1.070398,2.1587989,2.2731286),(21338,'femur',243,7,76,366.7424607,79.9277046,80.6020701,1.8,79.8751189,81.535374,1.028887,21.5616449,25.8317702,49808.7031429,57613.9227423,44.8635154,2230.3513198,2310.0604551,3560.30812,0.296875,0.6638327,2.0344439,1.4334393),(21339,'femur',243,7,77,366.1123506,80.0291319,80.2833033,1.8,79.9984153,81.0062041,1.0588731,21.688068,25.9465771,48192.9945569,56739.6942728,46.3768101,2186.7891873,2222.0971701,3514.4141148,0.9977487,2.9238797,1.152572,6.9932912),(21340,'femur',243,7,78,358.667874,80.000361,79.8125845,1.8,79.9955939,80.3332907,1.1209492,20.9548554,28.0240449,46227.618175,55429.6166658,48.4754404,1977.9306241,2206.0576075,3347.0306811,0.59375,1.070398,2.1587989,2.2731286),(21341,'femur',243,7,79,352.4250215,79.8568829,79.2937499,1.8,79.833501,79.8288504,1.2467486,20.8248379,21.7019818,44546.4057273,53853.9132782,52.7825483,2481.5205214,2139.0997536,4382.3876947,36.7515636,41.1704726,2.1507991,157.4549817),(21342,'femur',243,7,80,349.9194035,79.8572503,78.7884034,1.8,79.778037,79.1372359,1.2895714,20.5135718,21.7367393,43058.7040167,53082.4214741,53.8278472,2442.0599915,2099.0349446,4341.7251083,0.296875,1.5137714,1.7681919,3.2146893),(21343,'femur',243,7,81,347.6112875,79.9145399,78.2902556,1.8,79.666492,78.5238767,1.3202611,20.6689256,32.4095807,41537.232921,51738.5989632,54.3741929,1596.3982845,2009.6464462,2613.7382217,0.59375,1.8776024,1.2490458,4.3003179),(21344,'femur',243,7,82,343.0937131,79.8940696,77.7916692,1.8,79.6707909,78.0593759,1.3451049,20.6371073,20.9985445,40097.921878,50383.6675974,54.3187334,2399.3885648,1943.0010893,4105.0321915,1.1875,6.8538916,1.484058,15.7976698),(21345,'femur',243,7,83,339.5922524,79.856042,77.2395199,1.8,79.6419531,77.5510655,1.3948322,49.6843204,31.0685635,38858.8725294,49022.628219,54.8642348,1577.8852568,782.1154081,1600.489193,0.7985583,2.6553307,1.1071487,5.9796965),(21346,'femur',243,7,84,334.4554912,79.7630656,76.5998962,1.8,79.6307851,76.930111,1.4619756,44.8636409,32.5815926,37390.205656,47644.7558308,55.0850819,1462.3212702,833.4188871,1594.4108509,0.296875,0.6638327,2.0344439,1.4334393),(21347,'femur',243,7,85,329.2583443,79.5856259,75.8900116,1.8,79.4362223,76.3942447,1.5429412,27.1084506,34.1025814,35868.842287,46257.138463,54.8338226,1356.4116431,1323.160916,1885.1640623,32.65625,38.6222851,0.8888526,122.6151154),(21348,'femur',243,7,86,328.1355341,79.4804175,75.2377834,1.8,79.3406489,75.7356021,-1.542089,19.9567513,30.1862029,34522.3518851,45582.6573438,54.6441982,1510.0493933,1729.8582961,2213.6575865,32.359375,39.4397069,1.127348,169.066564),(21349,'femur',243,7,87,327.9393407,79.4118064,74.5976485,1.8,79.2638168,75.110905,-1.4891184,24.7812346,27.9980013,33554.0558089,44810.0856322,54.2927376,1600.4744439,1354.0106604,2096.8860784,0.296875,1.224047,1.815775,2.6209393),(21350,'femur',243,7,88,327.2651365,79.3290417,73.9553484,1.8,79.1584732,74.4310013,-1.4361949,27.237258,33.139101,32557.4300116,43925.6115319,53.5619357,1325.4919491,1195.3270035,2000.2786836,0.8841494,1.991498,2.0344439,4.5462572),(21351,'femur',243,7,89,327.5154926,79.3508351,73.3165387,1.8,79.2171465,73.8669894,-1.3984023,28.8538796,33.4190394,31504.498269,43017.1516354,52.9796466,1287.2049121,1091.8635099,1917.827514,0.296875,0.6638327,2.0344439,1.4334393),(21352,'femur',243,7,90,326.303426,79.3356344,72.8644284,1.8,79.1434457,73.3785318,-1.3720349,49.6104227,30.1521174,30659.159409,42128.5416796,52.2635515,1397.2001083,617.9983505,1253.7786591,31.46875,37.410962,0.9431669,112.7549456),(21353,'femur',243,7,91,325.8858541,79.3648459,72.466221,1.8,79.1933451,72.8619174,-1.3456001,50.4505062,29.2249713,29928.2767575,41382.7232643,51.6060977,1416.0056083,593.2205449,1223.0900262,1.1094949,3.0565152,2.0778948,7.0653251),(21354,'femur',243,7,92,325.350609,79.4090877,72.0710839,1.8,79.1750584,72.422913,-1.3285919,48.3981815,29.3977614,29360.7657635,40800.1468174,51.105814,1387.86577,606.6501854,1239.0019759,1.1875,4.7592683,1.6332151,11.4675144),(21355,'femur',243,7,93,327.6496979,79.4734176,71.6191285,1.8,79.3199901,71.974364,-1.3122088,50.6486997,29.1302335,29141.6887695,40543.1476156,51.0374309,1391.7893123,575.3689423,1198.0515418,0.296875,0.4198447,2.3561945,0.8396893),(21356,'femur',243,7,94,328.3646311,79.52869,71.2284166,1.8,79.3798327,71.6103288,-1.2982305,51.381367,28.5189967,28926.8309514,40005.3431959,50.7613142,1402.7612418,562.9828995,1176.0966989,0.59375,1.070398,0.9827937,2.2731286),(21357,'femur',243,7,95,329.0076676,79.5662516,70.8716858,1.8,79.3552763,71.1320477,-1.2818682,51.9015109,28.1304452,28674.6270822,39524.9980355,50.3830153,1405.0612328,552.4815484,1159.1817043,0.296875,0.4198447,2.3561945,0.8396893),(21358,'femur',243,7,96,326.3090078,79.6414683,70.4897323,1.8,79.4740942,70.7772935,-1.277786,50.9156089,41.9695634,28171.3787302,38646.4388786,49.8477268,920.8206077,553.2955281,1147.7582294,0.296875,2.3934828,1.6951513,4.9959393),(21359,'femur',243,7,97,326.0259617,79.7342014,69.9925101,1.8,79.5197712,70.2786031,-1.278931,52.8423331,28.7869546,27744.6213124,37842.8850271,49.8388366,1314.5845238,525.0453503,1097.5573392,1.1875,2.448094,1.815775,6.1536019),(21360,'femur',243,7,98,325.7119349,79.782648,69.6179155,1.8,79.5710135,69.9010633,-1.2771224,17.0411875,19.0860271,27346.5035146,37223.0385097,49.736575,1950.276938,1604.7299215,3365.301817,1.1875,4.2506031,1.359703,9.8900072),(21361,'femur',243,7,99,325.3909641,79.8543773,69.2110102,1.8,79.7322265,69.414998,-1.2870552,16.8326228,18.9845832,27036.471874,36647.3418824,49.9815951,1930.3737969,1606.1948369,3291.3775158,0.59375,4.492534,1.7033479,9.6440679),(21362,'femur',243,7,100,325.1296845,79.8916897,68.8443724,1.8,79.7152912,69.0113847,-1.2838662,16.8145167,18.7051143,26868.3294306,36072.0618651,49.8481141,1928.4598476,1597.9245712,3250.7276476,0.8839864,2.7370523,1.3521274,6.5734465),(21363,'femur',243,7,101,324.7671569,79.9520499,68.5163508,1.8,79.784899,68.7014409,-1.2826933,16.6331454,18.9668908,26629.9397093,35646.2139936,49.7580046,1879.3915332,1601.0164715,3239.6366451,0.8176153,3.099466,1.2793395,6.9212572),(21364,'femur',243,7,102,324.4752171,79.9947473,68.1894406,1.8,79.8725769,68.3463537,-1.2843744,16.850277,18.4195316,26420.9815855,35213.1571505,49.7626811,1911.729245,1567.9850038,3270.6560134,0.59375,1.5987208,1.1902899,3.4606286),(21365,'femur',243,7,103,324.1795116,80.0124961,67.8436027,1.8,79.8287956,67.9954012,-1.2838375,16.3423315,18.4062007,26245.1698657,34778.2662171,49.7015939,1889.4864139,1605.9623971,3257.0846165,29.6875,35.5122565,0.9456878,106.5715063),(21366,'femur',243,7,104,324.8017965,80.0491287,67.5316983,1.8,79.8611595,67.7195718,-1.2787862,31.4442245,51.774666,26100.7783673,34586.1305304,49.6473817,668.0126254,830.0658943,1001.8440763,1.1875,2.5365011,1.929567,7.1671965),(21367,'femur',243,7,105,324.3138237,80.12133,67.1454004,1.8,79.9742071,67.3060634,-1.2823378,31.9562941,51.8533856,25713.5893029,34102.5667434,49.6780713,657.6729048,804.6486635,982.0482231,0.296875,0.6638327,2.0344439,1.4334393),(21368,'femur',243,7,106,324.1029679,80.195352,66.8002912,1.8,80.0484756,66.9305909,-1.286158,33.3513694,52.1314694,25550.0676747,33667.611995,49.7576667,645.8212741,766.0875146,956.8674381,0.296875,1.224047,1.815775,2.6209393),(21369,'femur',243,7,107,324.4477351,80.2218845,66.4572426,1.8,80.0335834,66.6308716,-1.2797248,33.7954434,52.9367673,25473.1996284,33405.3556665,49.6212071,631.0426076,753.7465727,937.4860963,29.6875,35.2094251,0.9289816,105.066033),(21370,'femur',243,7,108,325.3344243,80.2587024,66.1097532,1.8,80.122679,66.2760854,-1.2698368,16.5934018,18.979516,25339.8723598,33129.4007409,49.4576237,1745.5345433,1527.1053334,3049.3212425,0.296875,0.4198447,2.3561945,0.8396893),(21371,'femur',243,7,109,326.4850103,80.3146,65.7509314,1.8,80.1769132,65.9934008,-1.2732962,16.1784242,19.4647918,25333.3866316,33043.8639487,49.7385853,1697.6222647,1565.8747897,2959.329681,0.296875,0.9388012,1.8925469,2.0271893),(21372,'femur',243,7,110,328.201288,80.3941769,65.4004559,1.8,80.2662684,65.5845961,-1.2834864,16.2807603,28.1888256,25292.6408167,32997.6693376,50.3077595,1170.593971,1553.5294635,1994.6536981,29.390625,35.0765068,0.9780989,104.2263437),(21373,'femur',243,7,111,328.5144334,80.4539592,65.048497,1.8,80.3891655,65.2223157,-1.2964347,16.2622375,20.1798348,25224.2420076,32758.9729353,50.7333383,1623.3518894,1551.0929525,2821.596424,29.390625,34.7546682,0.9614699,103.878533),(21374,'femur',243,7,112,329.7422843,80.4725966,64.7180654,1.8,80.3944988,64.9165024,-1.3010928,16.3335069,28.8367591,25167.7647448,32744.6232733,51.0554656,1135.516762,1540.8671788,1905.3659084,29.3838385,34.9254228,0.9544994,104.3704116),(21375,'femur',243,7,113,330.8997074,80.5333346,64.2844858,1.8,80.4721501,64.4876317,-1.295588,34.9880555,27.053291,25009.093745,32485.6220204,51.0773097,1200.8011159,714.789473,1301.4364125,29.09375,34.7939526,0.9307082,103.878533),(21376,'femur',243,7,114,331.7260643,80.5575657,63.9441834,1.8,80.4960181,64.1362708,-1.2911094,39.2853286,55.0231911,25005.0607412,32339.0910054,51.0744111,587.73565,636.4987036,848.1815359,29.09375,34.3785865,0.9324765,103.284783),(21377,'femur',243,7,115,332.3098102,80.5804897,63.6376621,1.8,80.5175867,63.8288903,-1.2757127,36.796362,45.4245892,24991.8412359,32164.5478438,50.70072,708.0867086,679.1932642,1247.8795772,29.09375,34.6174581,0.9375864,103.7766616),(21378,'femur',243,7,116,333.6227245,80.6136387,63.3393658,1.8,80.4999882,63.5338135,-1.2634339,24.4180479,48.6753262,24964.1798469,32314.9208257,50.5141553,663.887093,1022.3659127,1134.7111409,0.296875,0.9388012,1.8925469,2.0271893),(21379,'femur',243,7,117,333.736899,80.6464986,63.039328,1.8,80.5618913,63.2291009,-1.261946,23.0095132,33.7757324,24895.9433632,32253.1989772,50.4836119,954.9222691,1081.9847929,1400.9204119,29.0412988,35.2094251,0.9289816,105.7740135),(21380,'femur',243,7,118,333.8586853,80.6735098,62.697926,1.8,80.6243756,62.8942184,-1.263728,16.3724322,26.0674499,24791.2185086,32148.5352601,50.5593162,1233.2827088,1514.2049865,1867.318683,28.9923003,35.2094251,0.9289816,104.6163509),(21381,'femur',243,7,119,334.4926146,80.710729,62.3844967,1.8,80.648881,62.5565512,-1.2579686,22.4264173,54.0136801,24801.8306412,32111.6650669,50.4687871,594.5098534,1105.9203239,973.1402289,28.796875,35.1680987,0.9593788,104.1244723),(21382,'femur',243,7,120,334.9889736,80.7669686,62.0728513,1.8,80.6949705,62.2585572,-1.2596311,38.9234271,49.251319,24778.5669238,32081.3001007,50.5979112,651.379511,636.5977714,1128.2368279,28.9390608,35.0325079,0.9357696,104.6163509),(21383,'femur',243,7,121,334.5401005,80.9011506,61.6856947,1.8,80.8091001,61.8618321,-1.2506514,15.8393807,19.5325703,24610.7901605,31806.9420502,50.2346133,1628.4053522,1553.7722521,2765.7451935,28.9329277,34.68359,0.9495518,103.7046277),(21384,'femur',243,7,122,333.6849529,80.96656,61.3912588,1.8,80.8839702,61.530269,-1.2428888,15.5996406,46.7864281,24556.6340211,31592.6791153,49.845611,675.2530679,1574.1794708,1200.1196614,0.296875,3.5748484,1.6539376,7.3709393),(21385,'femur',243,7,123,333.5505608,81.0069967,61.1316967,1.8,80.9013252,61.3542264,-1.2294775,16.2378462,17.718328,24578.8520973,31428.8809431,49.3630229,1773.8062499,1513.6768624,2900.8086481,28.796875,34.7800181,0.8760581,103.950567),(21386,'femur',243,7,124,333.283005,81.0334882,60.8917324,1.8,80.9453976,61.127432,-1.2131673,18.7898625,54.8432001,24581.1948233,31585.3692248,48.7405294,575.9213393,1308.2157924,968.8448332,0.59375,1.070398,0.9827937,2.2731286),(21387,'femur',243,7,125,332.1513813,81.0758251,60.624928,1.8,80.9575625,61.0102201,-1.2094053,28.9816993,55.2085969,24571.5703802,31658.9892645,48.4378684,573.4431056,847.8305616,973.753581,0.59375,1.5987208,1.1902899,3.4606286),(21388,'femur',243,7,126,332.1960363,81.1103982,60.3530133,1.8,80.9839862,60.6127921,-1.1888502,24.493176,42.373794,24579.4717093,31590.9011819,47.6742566,745.5292107,1003.5232534,1274.2215169,0.296875,1.8058201,1.735945,3.8084393),(21389,'femur',243,7,127,332.6395678,81.1660755,60.1019265,1.8,81.016473,60.3844517,-1.1779411,18.030683,40.6265851,24706.8576407,31693.3470603,47.3148164,780.1134886,1370.2674305,1286.9239864,28.8210847,35.6163401,0.8739236,105.6299456),(21390,'femur',243,7,128,332.6976299,81.2446914,59.8352217,1.8,81.0906425,60.0905549,-1.1530038,25.5335776,61.5023839,24861.8764817,31706.5923253,46.3210446,515.5343637,973.69342,849.477266,0.296875,1.5137714,1.7681919,3.2146893),(21391,'femur',243,7,129,332.7962073,81.353569,59.4989057,1.8,81.1716465,59.7586887,-1.148453,15.8706945,18.0272119,24949.8257215,31411.9123702,46.1467854,1742.4720267,1572.0689281,2995.5508415,28.9947298,35.515979,0.9038881,105.5579116),(21392,'femur',243,7,130,331.4370357,81.4252665,59.2550874,1.8,81.2449738,59.5057452,-1.1376506,16.1703744,18.3307942,24911.8376788,31275.5657033,45.5078688,1706.1762537,1540.585088,2951.7228232,0.5761131,2.448094,1.3258177,5.2418786),(21393,'femur',243,7,131,330.2725351,81.5060593,59.0169456,1.8,81.2823493,59.2837092,-1.1296565,15.8073,18.6773506,24966.4942454,31133.3730785,45.0104329,1666.9052115,1579.4281238,2928.1748732,0.59375,2.448094,1.3258177,5.2418786),(21394,'femur',243,7,132,330.7420797,81.5414894,58.7905073,1.8,81.3541315,59.053947,-1.1214751,15.8771651,18.873306,25148.3165164,31186.2219577,44.723848,1652.3984708,1583.9298993,2910.2311815,0.6859791,4.8327749,1.3854484,10.2378179),(21395,'femur',243,7,133,331.4516981,81.5563127,58.5927433,1.8,81.3609978,58.8282177,-1.1144367,16.2211448,18.5541882,25399.6722389,31255.8956412,44.5138715,1684.5736042,1565.8372174,2947.8860332,0.7146249,4.5413143,1.3734008,10.1359465),(21396,'femur',243,7,134,332.6186825,81.5905737,58.3719322,1.8,81.3968735,58.6548655,-1.1049151,16.0345858,18.2785111,25659.753358,31426.3722925,44.2499349,1719.3070111,1600.2754127,2974.0251798,0.59375,4.1984465,1.4288993,9.0503179),(21397,'femur',243,7,135,333.5785235,81.6476378,58.1809888,1.8,81.4377811,58.4643958,-1.1080412,42.057656,29.2549098,25859.052613,31575.3235131,44.5168064,1079.3170712,614.8476901,1122.7250452,0.6525612,4.492534,1.4382448,9.6440679),(21398,'femur',243,7,136,333.4988283,81.6812286,58.0168476,1.8,81.4596203,58.3001598,-1.116166,43.058804,52.6477133,25961.4382348,31589.7209841,44.8647428,600.0207609,602.9298499,1090.6624833,0.296875,1.224047,1.815775,2.6209393),(21399,'femur',243,7,137,330.7592259,81.7808131,57.7145661,1.8,81.6240041,57.9998352,-1.1089949,16.281727,53.2016807,25830.5135971,31201.2263374,44.182537,586.4706895,1586.4725931,1068.8164852,0.8613615,7.1804483,1.4464413,15.2337572),(21400,'femur',243,7,138,326.2194041,81.8436934,57.4453358,1.8,81.6240783,57.6939493,-1.1099455,44.6769701,29.6900334,25718.5940166,30641.9938243,43.617314,1032.0632978,575.6566298,1050.6682383,1.503005,7.8095619,1.418147,18.5925144),(21401,'femur',243,7,139,324.3202869,81.8786758,57.2154787,1.8,81.6647782,57.4698062,-1.0991841,44.2737483,47.1843972,25715.9766122,30403.2980845,42.8962499,644.3506735,580.8402863,1051.1804049,1.3729949,9.6152675,1.4157996,21.2134537),(21402,'femur',243,7,140,323.3325365,81.9036865,57.0139479,1.8,81.7060098,57.2585715,-1.076516,21.0057427,67.9602824,25747.8695702,30450.8062667,41.7608923,448.0676827,1225.7538302,790.0555688,1.3613092,12.4616795,1.3547114,27.0490823),(21403,'femur',243,7,141,324.1658107,81.8891179,56.8380844,1.8,81.6523171,57.1829244,-1.0379752,21.2163518,68.9681957,25859.5492984,30911.2827819,40.0869468,448.1961935,1218.8499477,796.8509911,0.6873453,6.5916947,1.4352686,14.0462572),(21404,'femur',243,7,142,324.0645091,81.8825633,56.6345567,1.8,81.6498453,56.9050595,-1.0272002,16.6362873,69.2744483,25885.9679699,31026.6729163,39.5621449,447.8804767,1555.9942818,799.5940397,0.8706759,8.9850679,1.4382448,19.5340751),(21405,'femur',243,7,143,324.1705646,81.9055625,56.4241783,1.8,81.6348866,56.7325526,-1.0180751,16.6871917,69.4559907,25980.7825115,31073.8163803,39.1365478,447.3885701,1556.9295896,802.0462118,1.4922051,10.1633629,1.4536876,23.4145484),(21406,'femur',243,7,144,323.9930131,81.9573175,56.22409,1.8,81.7075762,56.5374644,-1.0129738,24.1813016,44.9637141,26068.4827765,31124.6044837,38.8683139,692.2160486,1078.0429946,1120.2555326,1.2861697,11.7143429,1.418147,25.4715751),(21407,'femur',243,7,145,325.2533937,82.050797,55.9730109,1.8,81.8448027,56.2609977,-0.9880842,16.6896557,67.412994,26121.8656829,31284.7861526,37.7933811,464.0764974,1565.1530591,847.5742982,1.0603508,9.7923759,1.3258177,21.459393),(21408,'femur',243,7,146,326.0631652,82.0517332,55.827981,1.8,81.7647371,56.1228714,-0.9683059,16.7007097,67.6493881,26168.2094605,31436.3198044,36.8916265,464.6948141,1566.8920602,849.07352,1.8857088,13.0422428,1.3644724,30.8276842),(21409,'femur',243,7,147,324.9393669,82.0654892,55.6769863,1.8,81.7963649,56.0063218,-0.9635111,34.1558232,68.4827122,26093.7225551,31669.4698824,36.5215497,462.4447378,763.9611682,840.5537342,1.4663927,9.3739192,1.3796119,23.5586163),(21410,'femur',243,7,148,325.9789031,82.028077,55.5664547,1.8,81.7855153,55.8161382,-0.9410421,35.0530507,38.677318,26153.7913926,31704.1960185,35.4851106,819.7103027,746.1202629,1108.428947,1.5472678,9.0826285,1.3734008,25.3100288),(21411,'femur',243,7,149,326.1704226,82.0076898,55.4399505,1.8,81.7653125,55.7085474,-0.9299812,18.4801498,37.4052996,26226.1260519,31797.7769461,34.9315738,850.0874814,1419.151163,1471.6905059,1.651799,10.5963999,1.3734008,31.2897254),(21412,'femur',243,7,150,327.1837587,81.9839198,55.2991102,1.8,81.7446765,55.6126929,-0.916255,40.9755519,72.5572566,26337.2485282,32085.6912145,34.319837,442.2120226,642.7551875,799.8941378,1.9423552,13.33296,1.369034,33.5206574),(21413,'femur',243,7,151,326.9845475,81.9352151,55.1730762,1.8,81.700743,55.4104908,-0.9206444,38.9942597,38.2388512,26328.0885008,32193.7406618,34.5297309,841.9118169,675.1785699,1426.8229148,1.5472678,12.9846758,1.3868529,30.1619002),(21414,'femur',243,7,152,329.2216749,81.9036162,55.0289469,1.8,81.6667625,55.3201303,-0.9229749,39.0805559,33.8742948,26464.8122636,32536.0240094,34.8891216,960.4930296,677.1861783,1432.2111072,1.6985343,15.1377142,1.3734008,35.0559681),(21415,'femur',243,7,153,331.1308609,81.9376368,54.7995781,1.8,81.6871624,55.0693572,-0.9289138,25.0168085,38.2858193,26449.1302424,32770.6976742,35.4063365,855.9487105,1057.2543764,1430.8112882,2.0445392,14.5559602,1.3654009,33.2747181),(21416,'femur',243,7,154,331.2755621,81.9254163,54.6520683,1.8,81.6442208,54.8839397,-0.9395809,40.595764,38.505845,26405.5955444,32889.033699,35.9848518,854.1309432,650.4519914,1412.0099716,1.9348396,15.1987243,1.354246,41.8156791),(21417,'femur',243,7,155,332.4303412,81.931114,54.5146875,1.8,81.6411115,54.7865499,-0.9493556,24.8186727,38.9414023,26380.9583646,33089.9378621,36.624673,849.7366782,1062.9479952,1436.9928264,1.9671754,15.1987243,1.354246,37.719104),(21418,'femur',243,7,156,333.6193059,81.9239896,54.3742448,1.8,81.6989976,54.6430086,-0.9608401,16.6437131,57.2665001,26418.6389441,33433.22333,37.3578002,583.8181709,1587.3043956,1009.2504548,2.0263628,15.5540969,1.3397057,42.7870772),(21419,'femur',243,7,157,335.7360893,81.9118423,54.2789432,1.8,81.6442773,54.4991077,-0.9708577,25.1766208,56.3939094,26509.6853827,33716.940933,38.1192584,597.8826664,1052.9485109,1022.3840909,2.0650038,14.6885638,1.3258177,37.3290968),(21420,'femur',243,7,158,337.3018702,81.9336963,54.140842,1.8,81.6738431,54.3728242,-0.9793385,24.8449411,34.3208153,26618.6375344,33851.6929638,38.7398872,986.3312582,1071.3906487,1427.207756,1.794635,14.0412774,1.3360737,36.0397254),(21421,'femur',243,7,159,336.3333492,81.9453946,54.005594,1.8,81.6727209,54.2438792,-0.9835284,16.5570952,18.5023793,26573.5576346,33953.318556,38.8456997,1835.0785025,1604.9649574,3084.3335718,1.6220945,14.3301781,1.3408919,34.6062861),(21422,'femur',243,7,160,339.1455961,81.9320392,53.9405792,1.8,81.6671828,54.2087556,-0.9854297,37.3898807,57.6816105,26798.4928786,34388.0403278,39.2695683,596.1699066,716.7311686,1043.4402168,1.6024041,10.369398,1.3397057,24.2244002),(21423,'femur',243,7,161,341.139525,81.9838735,53.7544518,1.8,81.6925022,53.9700006,-0.9880754,36.1569826,28.0758721,26808.717764,34539.1204163,39.6388366,1230.2065025,741.4534014,1486.8077971,2.0030982,13.8262181,1.3101939,38.24082),(21424,'femur',243,7,162,341.2446991,82.014631,53.6110172,1.8,81.6851089,53.8760516,-0.9950316,25.8563224,34.8716568,26816.3876128,34644.1104101,40.0135265,993.4747458,1037.1307718,1431.9771248,2.2259541,14.1132764,1.3156139,39.2966112),(21425,'femur',243,7,163,342.9239869,82.0248348,53.4890549,1.8,81.7513847,53.6902581,-0.9890811,34.4205996,22.7831093,26911.6500888,35061.8565498,39.8989808,1538.9408012,781.8472196,1501.3801795,2.0851192,14.7633762,1.3063079,43.1050505),(21426,'femur',243,7,164,341.8270295,82.029917,53.3694289,1.8,81.6617839,53.613405,-0.9997442,16.5652643,18.836241,26902.6795626,35358.5721483,40.3265179,1877.1564952,1624.0416732,3117.4673394,2.0928621,15.1289784,1.2924967,39.4705165),(21427,'femur',243,7,165,342.9620184,81.9885007,53.2682288,1.8,81.6510163,53.5415005,-1.0026838,17.3038478,72.7086135,27088.2203872,35657.9372151,40.6130349,490.4224614,1565.44491,849.1598911,1.7691223,14.1911219,1.2953702,35.937854),(21428,'femur',243,7,166,344.2302242,81.9881772,53.1562722,1.8,81.6632004,53.3526219,-1.0033577,16.5929148,18.8391368,27265.8023104,35900.4413516,40.7982737,1905.6309063,1643.2195719,3123.7156826,1.7356271,14.2747181,1.2753555,34.5044147),(21429,'femur',243,7,167,344.8314102,82.0029299,53.0614588,1.8,81.6409845,53.3873917,-1.0123985,36.4346679,69.4576514,27355.5428196,36379.2425858,41.3385171,523.761484,750.8108184,914.540782,1.6749759,13.6207078,1.2835149,31.7394074),(21430,'femur',243,7,168,346.3149586,81.9872738,52.961161,1.8,81.6000506,53.3591415,-1.0203934,33.4870972,69.6022605,27546.814187,36829.6402432,41.9294406,529.1443117,822.6097956,919.5901876,1.8294048,13.9909726,1.2691773,32.5790968),(21431,'femur',243,7,169,347.7978661,81.9860562,52.8420007,1.8,81.6824024,53.2354766,-1.0303821,34.6312216,70.3381668,27666.4479479,37307.5299144,42.6225578,530.4023633,798.8874393,913.6545966,0.296875,0.4198447,2.3561945,0.8396893),(21432,'femur',243,7,170,347.5149802,81.9702504,52.7531456,1.8,81.6057848,53.0935007,-1.0062771,40.6243047,72.6765714,27628.2755136,37354.054725,41.3406516,513.976568,680.0922686,880.0556228,0.296875,0.6638327,2.0344439,1.4334393),(21433,'femur',243,7,171,346.6118126,81.9154886,52.6942856,1.8,81.451202,53.06518,-0.9930249,16.846504,72.9381153,27727.8254819,37754.1401938,40.5368858,517.6188068,1645.9097717,884.5342585,1.8356953,15.6782608,1.2430578,41.2219291),(21434,'femur',243,7,172,350.356632,81.8718845,52.6624703,1.8,81.5356843,52.9529282,-0.9933258,16.781885,41.7197533,28062.1239939,38244.9131536,40.9909197,916.7099547,1672.167579,1587.3272386,1.7725777,16.2415317,1.2548261,39.2966112),(21435,'femur',243,7,173,353.4049732,81.8123859,52.6099729,1.8,81.4208768,52.9494517,-0.9950886,16.6976266,19.2251239,28410.4393662,38922.4489791,41.4424792,2024.5616737,1701.4657216,3403.060637,1.9231502,16.0998244,1.1731683,36.9514486),(21436,'femur',243,7,174,356.8164563,81.7610764,52.5784929,1.8,81.3558553,52.855559,-0.9920634,17.567723,19.3893032,28689.6741501,39707.8418083,41.6779909,2047.9251522,1633.090079,3314.5885748,1.7720378,17.5859288,1.1902899,43.3211523),(21437,'femur',243,7,175,358.7713389,81.7219216,52.5501405,1.8,81.3163966,52.8078109,-0.99129,16.8075335,19.5003706,28882.1548037,40500.6276435,41.8639669,2076.9157939,1718.4053099,3466.7468506,1.6932988,16.4892617,1.1635405,38.6308272),(21438,'femur',243,7,176,361.5656382,81.6750643,52.5364206,1.8,81.2812683,52.7733493,-0.9893452,24.4290481,50.7446595,29111.0224698,41216.2401405,42.0825375,812.2281353,1191.656029,1248.7367535,1.6673034,13.5428375,1.1169523,31.4337933),(21439,'femur',243,7,177,363.0395453,81.6244665,52.4629744,1.8,81.2868262,52.61748,-0.9841978,17.020418,19.7836232,29202.6741878,41822.834489,41.9675519,2114.0128957,1715.7436524,3536.4950774,1.7810728,15.4032071,1.089909,37.9774023),(21440,'femur',243,7,178,362.0310699,81.5544969,52.3870888,1.8,81.2487032,52.5740946,-0.9806645,17.0401433,19.9222788,29425.1911534,42036.8791254,41.6541182,2110.0437122,1726.8159454,3542.4433926,1.7911514,16.7306908,1.091277,40.2803684),(21441,'femur',243,7,179,360.4660903,81.5630402,52.2708969,1.8,81.18535,52.4824187,-0.9946938,44.3251802,66.8853358,29667.8363891,41951.8329153,42.2488409,627.2201886,669.3224094,1070.7828323,1.7265668,13.6755977,1.0974403,36.0520844),(21442,'femur',243,7,180,362.4527814,81.5571635,52.2082115,1.8,81.131261,52.4662591,-1.0021255,17.0354359,58.849303,30093.1910886,42526.3649446,42.8905026,722.6315817,1766.5054967,1210.5500086,1.7371184,17.3944431,1.0918827,43.0453756),(21443,'femur',243,7,181,363.9803439,81.5821407,52.1046777,1.8,81.1914949,52.3039364,-1.008414,52.7686568,59.1805215,30629.1377198,42398.0500111,43.4164527,716.4190002,580.4418682,1184.9838532,1.8108237,15.5427601,1.072974,37.3116184),(21444,'femur',243,7,182,365.2690611,81.6131151,52.0346749,1.8,81.1831062,52.198903,-1.0306491,39.4789941,60.3523591,31119.2568347,42446.479451,44.777991,703.3110238,788.2484727,1210.4861082,1.8117432,17.272411,1.0687061,42.1038149),(21445,'femur',243,7,183,366.1379898,81.6567702,51.9367009,1.8,81.2082787,52.173971,-1.0476562,35.4965521,52.7706873,31682.6626808,42652.7681896,45.7914789,808.2662996,892.5560603,1289.3564055,1.5134914,15.1726072,1.0370881,35.6322398),(21446,'femur',243,7,184,366.4775757,81.6507703,51.8670896,1.8,81.2041066,52.1255232,-1.0543879,37.6292588,57.4924967,32291.4454582,42769.9347449,46.1884511,743.9220278,858.1472624,1260.2290219,1.6484159,15.5795746,1.0303768,35.7042737),(21447,'femur',243,7,185,369.8403977,81.6928906,51.6900326,1.8,81.2457275,51.9564465,-1.0696574,37.4001424,52.5040358,32951.2104615,43133.8608128,47.4130495,821.5341962,881.0450524,1299.9240824,2.0291783,18.4445167,0.9917221,47.2139847),(21448,'femur',243,7,186,370.0134357,81.7309457,51.5665053,1.8,81.2720514,51.7796028,-1.0823429,32.6334759,51.8162226,33476.4393329,42986.2263092,48.0890668,829.5901196,1025.8312476,1311.4255999,2.1088268,18.8556529,0.9871605,49.241174),(21449,'femur',243,7,187,371.927883,81.7130746,51.5055368,1.8,81.2174513,51.7456507,-1.0949187,25.9895267,52.7298833,34190.9789452,43358.2115346,48.9783914,822.2701975,1315.5675851,1347.2178491,0.59375,0.8396893,0.7853982,1.6793786),(21450,'femur',243,7,188,374.4200137,81.7139831,51.4000521,1.8,81.2507042,51.5372147,-1.1179725,39.0170685,44.3525256,35087.7433607,43485.289601,50.4585932,980.4467515,899.2921483,1348.460198,1.9949308,17.8767072,0.9505468,49.1393026),(21451,'femur',243,7,189,376.2673718,81.7610056,51.3415891,1.8,81.2675259,51.6428032,-1.1892849,34.2322769,52.90552,35968.5433989,43766.8742943,54.017892,827.2647982,1050.7201597,1363.1092897,1.8221268,20.0165093,0.9539951,49.6610186),(21452,'femur',243,7,190,379.5019978,81.8773393,51.3245154,1.8,81.3706077,51.6669542,-1.2758564,31.2349033,56.6148998,36865.9361487,44231.5039871,57.9059161,781.2696687,1180.2801432,1378.870808,1.4825133,14.0820177,0.9652517,32.3156791),(21453,'femur',243,7,191,385.1427029,82.0138317,51.3920762,1.8,81.4528686,51.6236872,-1.3850709,23.0454438,56.6930589,38248.3278941,44825.0204802,62.0016117,790.6615268,1659.6915271,1416.3468857,33.9526692,38.1157904,1.2539718,156.3343963),(21454,'femur',243,7,192,391.3595958,82.1207577,51.4267515,1.8,81.4818033,51.636183,-1.4986688,46.8847168,58.0874019,39495.5377991,46001.749812,64.8878536,791.94022,842.3968504,1145.3393941,0.7146553,3.801855,0.8960554,7.9050144),(21455,'femur',243,7,193,397.8256162,82.3851871,51.4323379,1.8,81.7792933,51.6603728,1.4851068,55.9900102,57.4636551,40160.8066488,47649.2759969,65.8186077,829.2071901,717.285218,1170.361739,0.5313673,1.070398,0.9827937,2.2731286),(21456,'femur',243,7,194,404.9892367,82.6281151,51.5288065,1.8,82.0130927,51.6554896,1.3504834,68.9057832,40.9815536,40743.1029994,49950.1247355,64.2746572,1218.8440991,591.2871333,1131.2380262,35.8874651,39.6803174,1.7285651,142.7378212),(21457,'femur',243,7,195,409.0797848,82.8550906,51.6104967,1.8,82.2380185,51.6273722,1.272688,32.5488655,41.142824,41335.4818624,52103.2815843,62.2982806,1266.4002255,1269.9515415,2064.099798,36.6452013,40.1001097,1.6969879,160.8508161),(21458,'femur',243,7,196,418.1454069,83.0345789,51.7036093,1.8,82.3736546,51.6207383,1.2183437,22.0703426,22.0077611,42246.1702515,54723.9854031,61.3862865,2486.576676,1914.1601462,4242.0371662,37.1607086,40.7065318,1.746736,151.3806535),(21459,'femur',243,7,197,424.9528294,83.1229984,51.8025506,1.8,82.4563611,51.6910303,1.179805,22.1430653,21.3915261,43589.8084907,56944.475114,60.5387028,2662.010878,1968.5534902,4326.9030696,37.6828783,41.3435079,1.7512921,166.5547359),(21460,'femur',243,7,198,432.897858,83.1336626,51.8089215,1.8,82.4487118,51.6264632,1.1578658,56.8444377,56.9994102,45346.7950701,58753.162396,60.5308157,1030.7679003,797.7349577,1540.8541108,38.1859905,41.689538,1.7570192,163.1363038),(21461,'femur',243,7,199,443.6779417,83.2003885,51.736804,1.8,82.5797848,51.4811122,1.1502173,57.6045969,49.5612338,46995.0930869,60916.0592186,61.6194703,1229.106997,815.8219235,1585.3298513,38.0745119,42.2377074,1.7047413,172.3008521),(21462,'femur',243,7,200,455.7509089,83.2374652,51.8028025,1.8,82.7185115,51.6161204,1.1441939,43.4796287,60.9245994,49397.0085142,64048.6778434,62.9533264,1051.2777835,1136.0954533,1854.8575829,38.6613471,42.7881232,1.6960119,188.7519468),(21463,'femur',243,7,201,458.969003,83.4146781,51.6855655,1.8,82.9794863,51.365082,1.1634308,43.3984924,61.0956136,50157.1055337,65953.5455954,64.4875941,1079.5135968,1155.7338236,1886.4661402,38.7845401,43.5152323,1.6596032,167.7844324),(21464,'femur',243,7,202,464.1344481,83.4906022,51.6433284,1.8,83.0959917,51.3017643,1.1760997,48.3409821,62.8313327,51745.7601575,68122.9777338,65.9177716,1084.2198443,1070.4325379,1891.430456,39.1405886,43.8672369,1.6724852,187.0252524),(21465,'femur',243,7,203,470.4327187,83.5333949,51.5945885,1.8,83.1582171,51.2091961,1.1942486,71.1775271,51.2311687,53397.4367771,70076.4973897,67.8040683,1367.8488925,750.2007861,1595.7815301,39.5710212,44.429206,1.664481,186.6774417),(21466,'femur',243,7,204,478.056002,83.5469375,51.5083668,1.8,83.1937924,51.0372448,1.2200079,69.5035884,43.1714181,55391.019955,72174.0709368,70.2672774,1671.8021814,796.9519444,1656.05874,39.6667164,44.9694585,1.6500999,180.0319612),(21467,'femur',243,7,205,486.7275015,83.5783939,51.521179,1.8,83.199959,51.021048,1.2473778,24.5006849,52.9862374,57632.8640431,74762.7388916,72.9277593,1410.984107,2352.2960408,2267.9575674,40.254484,45.5613667,1.4925252,169.9556896),(21468,'femur',243,7,206,495.8680649,83.5268505,51.4360845,1.8,83.166472,50.9385173,1.2619515,24.2854709,43.0532975,60395.3796297,77513.5928628,75.0090827,1800.4101277,2486.8934958,3080.2043749,40.8548045,46.4493171,1.4940244,179.8878933),(21469,'femur',243,7,207,500.840842,83.5409296,51.3380092,1.8,83.1393004,50.8483464,1.3059995,51.7136856,52.6040392,62663.6865687,80101.3485131,77.7560579,1522.7223946,1211.7428078,2081.4462001,41.1314429,46.9822861,1.5138958,190.4436845),(21470,'femur',243,7,208,508.9961388,83.4818354,51.281628,1.8,83.0351868,50.8222019,1.3458659,72.4537648,59.4892101,65121.2205701,82965.7836609,80.6125871,1394.6358258,898.7969191,1794.1227793,41.3920872,47.3606354,1.4892168,147.0504982),(21471,'femur',243,7,209,510.2875001,83.5121754,51.117682,1.8,83.1617372,50.6417738,1.3920872,58.3100436,59.7349163,66798.1448515,84780.4995126,82.3605378,1419.2787871,1145.5684255,2028.4970903,41.8176322,48.1386268,1.6139793,254.8887782),(21472,'femur',243,7,210,515.6335146,83.3726586,51.1411219,1.8,83.2090727,50.4404722,1.4059071,50.9278979,61.9548682,69266.6382043,87062.680545,83.6234705,1405.259716,1360.0922296,2200.5273051,41.7482983,48.8176614,1.6438369,182.610704),(21473,'femur',243,7,211,525.5857724,83.3520646,51.0684612,1.8,83.3335179,50.1607928,1.4635026,49.1284706,60.1119463,72465.1423807,92185.2542016,86.5930736,1533.5596307,1475.0131939,2300.8448306,42.7877556,49.8829514,1.5886516,220.0962277),(21474,'femur',243,7,212,534.2285079,83.3849098,51.0929203,1.8,83.4602366,49.8385022,1.4716282,24.9530308,59.7341883,75194.1857487,96539.609764,88.1653232,1616.1533707,3013.4289677,2873.3117151,43.4488666,50.5394266,1.6236881,257.551914),(21475,'femur',243,7,213,543.8326869,83.4366527,50.9323352,1.8,83.5967499,49.4511726,1.5425799,32.4976549,59.7239553,78541.1197227,102088.4762791,90.5666365,1709.3388362,2416.8242256,2770.0657205,43.5989616,54.444803,1.5053163,196.351347),(21476,'femur',243,7,214,559.5109269,83.3521264,50.7813933,1.8,83.6324472,49.2059681,-1.5275579,25.1289558,47.3455574,83628.8411448,109211.865289,93.0775896,2306.6972107,3327.9871107,3755.2894913,44.6922342,55.6298124,1.5067131,252.8914263),(21477,'femur',243,7,215,566.6987711,83.2704818,50.8441108,1.8,83.5758167,49.0712411,-1.5052842,46.4300281,61.3596889,86736.3513349,114802.2228556,94.045012,1870.9713984,1868.1089566,3040.8165241,45.2450035,56.5591677,1.497245,254.8167442),(21478,'femur',243,7,216,579.8873375,82.9846887,50.9728952,1.8,83.3333167,49.0568087,-1.4696725,29.188853,61.7666489,92624.67804,121016.8735881,95.6629303,1959.2591764,3173.2894077,3430.7983841,2.0327191,11.0443884,0.9380475,29.9705165),(21479,'femur',243,7,217,598.538844,82.9320614,50.9317982,1.8,83.3218653,48.9443584,-1.4193921,50.1120935,63.9359692,98133.4759335,131827.7738558,97.4871507,2061.8718295,1958.2793105,2830.8353248,0.296875,0.6638327,2.0344439,1.4334393),(21480,'femur',243,7,218,614.9977444,82.8297128,50.9267647,1.8,83.1691439,48.8801043,-1.3807869,27.8215727,59.9650649,102416.5917045,144271.4561937,98.8433404,2405.9251219,3681.1934711,4100.3046518,47.4442267,60.4525273,1.4921412,191.7206968),(21481,'femur',243,7,219,634.7383027,82.645886,51.1411864,1.8,82.9879785,48.9976998,-1.3404199,46.2619307,67.1817313,109025.8965975,156661.7340394,100.2737362,2331.909747,2356.7087442,3257.2011732,47.7434182,63.011675,1.4622203,237.5187205),(21482,'femur',243,7,220,654.0521018,82.4432333,51.4020417,1.8,82.8293015,49.1270129,-1.300436,44.5582263,68.9889274,116371.5562979,169683.60742,101.2329827,2459.5774113,2611.6738938,3483.0666792,0.4198447,0.8396893,0.7853982,1.6793786),(21483,'femur',243,7,221,669.5172961,82.3530863,51.5558075,1.8,82.7012567,49.2800765,-1.2840725,44.3186547,69.5358052,121851.7125669,183610.5590877,102.6612995,2640.5181998,2749.4452043,3705.691231,48.984375,64.2410336,1.630909,202.1920949),(21484,'femur',243,7,222,684.9565574,82.2050636,51.6859125,1.8,82.5372767,49.4517811,-1.2744239,43.9130572,69.7205799,127020.7796113,197979.9493317,104.4222193,2839.619947,2892.5515048,3950.7276212,2.8373584,16.2062211,1.0743736,43.6092882),(21485,'femur',243,7,223,696.8909661,82.0822156,51.9756003,1.8,82.4453807,49.6378858,-1.273476,43.647513,64.787514,130566.3071974,210562.7480682,106.1800405,3250.0513601,2991.3802233,5163.9421545,0.59375,0.8396893,2.3561945,1.6793786),(21486,'femur',243,7,224,716.7885646,81.8773412,52.3200906,1.8,82.1686866,50.1066533,-1.2591989,53.0247448,64.1383888,137835.7726404,227331.8644887,108.2361473,3544.3962459,2599.4613122,5377.6582023,0.59375,0.8396893,0.7853982,1.6793786),(21487,'femur',243,7,225,746.6334533,81.669847,52.6316242,1.8,81.9112203,50.6623195,-1.2286512,52.9077701,62.8088086,147728.6010113,249697.4132023,110.4313129,3975.5158374,2792.1910271,5906.3735077,3.3008487,18.5350834,1.0138948,54.0333705),(21488,'femur',243,7,226,772.7889941,81.3561092,53.2926634,1.8,81.4788184,51.4655098,-1.2048725,34.3069102,50.4512986,156326.5782575,272785.4392632,112.3081996,5406.9062061,4556.7081766,8168.3287081,2.6369253,15.6754498,0.9197196,47.1419507),(21489,'femur',243,7,227,850.1006235,79.3122189,55.7660044,1.8,79.2029062,54.4013366,-1.0598591,40.7872588,69.2206797,172965.4520482,366567.4400638,107.8046495,5295.6347929,4240.6736098,7550.2282622,0.629767,1.9009275,0.8960554,3.9525072),(21490,'femur',243,7,228,893.0003542,78.4211242,57.0022679,1.8,78.2623814,55.8589882,-1.0344863,31.5731594,47.3519394,185283.8325691,421864.2126977,109.9747955,8909.1221595,5868.3969599,12691.9091457,0.5313673,1.070398,0.9827937,2.2731286),(21491,'femur',243,7,229,929.7463286,77.9718269,57.992555,1.8,77.6391441,56.9710846,-1.0333426,61.1672974,48.4260191,198889.8273627,467005.1844028,114.3443539,9643.6831523,3251.5712768,10158.840416,56.6106454,95.6840606,0.9707461,342.771018),(21492,'femur',243,7,230,982.646364,77.6359275,59.2080891,1.8,77.2469897,58.4027564,-1.0550966,59.8510968,49.6975154,221513.0838403,519836.157209,123.9459771,10460.0029405,3701.0697477,11455.2961257,0.296875,0.9388012,1.8925469,2.0271893),(21493,'femur',243,7,231,1059.140637,77.5627796,61.1310662,1.8,77.0726171,60.0143793,-1.1288139,57.1045547,51.698562,260618.6750882,586198.435353,144.2276144,11338.7764204,4563.8859536,13328.1779693,59.3602603,97.8679406,1.0147694,300.3790673),(21494,'femur',243,7,232,1138.9810131,77.4823526,62.7865386,1.8,76.9325825,61.5275437,-1.1786827,60.1487226,56.9378881,301252.4694976,653384.8551295,162.108724,11475.3967267,5008.4599737,14784.821604,61.2773213,98.8433264,1.0102868,338.5602124),(21495,'femur',243,7,233,1213.0196112,77.3808318,64.1092435,1.8,76.7190693,62.7061251,-1.2200247,58.414203,54.672784,343001.3910977,713636.7787186,178.2984242,13052.8706633,5871.8834371,16585.322283,63.1156831,99.639052,1.025778,402.6451364),(21496,'femur',243,7,234,1239.1388831,77.0975082,65.0310637,1.8,76.4344206,63.3940999,-1.2382615,55.4023936,55.2463189,369104.8603066,749306.7342537,184.5154038,13563.0164823,6662.2547599,17980.6006885,66.0340614,100.2598345,1.0156496,451.3398761),(21497,'femur',243,7,235,1268.6373488,76.7560361,65.806705,1.8,76.1656776,64.1066618,-1.2505818,56.91683,55.807205,393140.8002737,789250.0879733,190.4900707,14142.4407028,6907.285605,18901.3058801,66.9451898,100.7084718,1.0253213,409.9440417),(21498,'femur',243,7,236,1289.379305,76.5162659,66.5518456,1.8,75.9758665,64.7796681,-1.2689629,52.1296538,56.301182,415260.5972642,829182.0094465,195.9060991,14727.6128126,7965.9189528,20629.4742316,68.4594917,101.1206977,1.0414539,441.7678422),(21499,'femur',243,7,237,1315.1268352,76.1242605,67.1732959,1.8,75.776735,65.3558262,-1.2775411,52.3471768,56.6296344,437486.0073173,860955.0841851,200.8721451,15203.2604936,8357.3944921,21519.5366526,69.3921369,101.3700978,1.0258565,440.3765994),(21500,'femur',243,7,238,1331.0253587,75.7712512,67.840147,1.8,75.6069181,66.0184211,-1.2838717,57.613394,56.8738143,459759.0458452,885883.8245771,204.0703165,15576.3040678,7980.072236,21350.2280879,70.654662,101.4709022,1.0298751,387.3990201),(21501,'femur',243,7,239,1350.1798476,75.8138768,68.3513226,1.8,75.5572522,66.6388017,-1.3006287,52.483534,56.8149285,480736.4098895,906794.6878628,209.0006665,15960.5003884,9159.7568457,22999.1096472,71.5087196,101.377053,1.0429327,389.6896271),(21502,'femur',243,7,240,1369.1539006,75.6466162,68.777359,1.8,75.3960018,67.0813809,-1.3066857,54.8309203,56.7516007,497642.1867199,923079.274938,212.6415731,16265.255326,9075.9407944,23177.0331778,72.4933299,101.1734146,1.0177957,369.3580591),(21503,'femur',243,7,241,1387.5922811,75.488757,69.1341967,1.8,75.2844844,67.4481685,-1.3099141,39.8990862,56.5489415,511464.1768516,930571.9897358,215.8794171,16456.0461231,12818.9446364,25409.6567308,73.5857183,100.8256733,1.012197,447.752658),(21504,'femur',243,7,242,1397.8507405,75.4480614,69.4310894,1.8,75.2262995,67.7029676,-1.3125165,38.7470078,56.1838393,525304.091779,930314.8593488,217.7762269,16558.4066704,13557.2814792,25802.7698126,74.4711477,100.4166248,1.0131372,419.7023401),(21505,'femur',243,7,243,1410.1021139,75.4226831,69.6587351,1.8,75.1718884,67.8311864,-1.3203471,39.1983613,55.582369,539174.8378065,925410.0166516,220.5812676,16649.3446398,13755.0351496,26196.0385883,1.7556476,4.9141557,1.1341692,13.8847109),(21506,'femur',243,7,244,1413.9103904,75.4269639,69.8152659,1.8,75.1358267,68.0110427,-1.3264948,38.5702503,54.9048619,546827.9168652,914446.8662136,221.8648614,16655.1164093,14177.4531563,26430.9260611,75.1212564,99.3041328,0.9919145,515.8744822),(21507,'femur',243,7,245,1422.9428418,75.4765829,69.843991,1.8,75.0704865,68.1502826,-1.3293807,38.8074246,54.0371498,555358.0500136,896904.4677598,223.6017015,16597.923306,14310.6133905,26664.8659936,0.296875,0.9388012,1.8925469,2.0271893),(21508,'femur',243,7,246,1428.0386871,75.5029333,69.8650046,1.8,75.0492964,68.30166,-1.3250288,52.394762,53.1441164,561725.1237326,874999.4979511,223.9175805,16464.6541896,10721.0167928,24052.0618594,0.8052581,3.3848958,1.3045443,7.5150072),(21509,'femur',243,7,247,1429.4255277,75.5972152,69.8839118,1.8,75.0498715,68.4447956,-1.3294715,51.9534081,52.0995105,565113.1465169,847421.9123414,224.6304353,16265.4486545,10877.3065481,23685.3437178,0.59375,0.8396893,2.3561945,1.6793786),(21510,'femur',243,7,248,1419.5689896,75.7045154,69.9304482,1.8,75.0793763,68.5377679,-1.3369408,51.3292825,51.0587344,561052.1502396,810351.1299619,223.8899881,15870.9599729,10930.4498866,23121.980573,0.629767,1.259534,0.7853982,2.5190679),(21511,'femur',243,7,249,1389.8375543,75.8400952,69.7415872,1.8,75.272778,68.5121293,-1.348042,40.2815516,49.3775412,548557.7355668,758455.9047201,220.3346098,15360.3416806,13618.0885124,26050.5537531,0.296875,0.4198447,2.3561945,0.8396893),(21512,'femur',243,7,250,1346.0716725,75.8585474,69.5114406,1.8,75.2668357,68.3028805,-1.3741482,49.1284714,47.5707924,529473.0072796,706066.1859344,215.7809922,14842.4306111,10777.3149173,18914.5249399,72.8585697,92.5112232,1.9626252,434.2899122),(21513,'femur',243,7,251,1300.1454207,75.9786003,69.3262712,1.8,75.3798509,68.2446533,-1.4130663,50.9503273,45.4995155,506772.0984469,649618.3337035,211.3444591,14277.4780455,9946.3953545,19062.8853328,72.2889349,91.6243019,1.9561161,466.8442908),(21514,'femur',243,7,252,1260.9418484,76.2594143,69.1357669,1.8,75.5680629,68.2337284,-1.4894435,49.4564727,43.9187318,479200.3694666,595025.639266,208.769164,13548.3338171,9689.3357518,17524.59016,70.8855875,90.6383247,1.9640757,473.7233515),(21515,'femur',243,7,253,1219.0548395,76.4794199,69.0933201,1.8,75.892901,68.3434257,1.5201163,44.036456,43.3014383,448410.163521,539135.3237779,202.6544049,12450.7486338,10182.7032369,16146.9477216,69.2560475,89.3139939,1.9630306,413.9336261),(21516,'femur',243,7,254,1168.5064,76.6291555,69.0516506,1.8,76.3433825,68.4836222,1.3254409,43.6369093,45.4009872,412893.9795393,482830.4067824,183.260567,10634.7997345,9462.0353755,16711.3543691,66.872593,87.9035796,1.9770185,459.7738464),(21517,'femur',243,7,255,1102.5919845,76.8917171,69.2241532,1.8,76.7825429,68.7512488,1.07969,44.3070933,45.2410225,369405.4231658,431751.3414565,142.8944151,9543.3594997,8337.3878883,16042.3404188,65.6711192,86.3053972,1.9774948,453.662441),(21518,'femur',243,7,256,1014.9350161,77.2388414,69.6581654,1.8,77.2657652,69.2207772,0.8384159,57.7481648,43.9817994,319505.6437276,377281.8867793,93.5293859,8578.1366751,5532.7410821,12065.1328636,64.8411313,84.1293676,1.9886624,450.7904431),(21519,'femur',243,7,257,918.262983,77.9036307,70.3064829,1.8,78.0895948,69.8317239,0.6370703,37.5723369,40.8360802,261401.7160933,326735.9268002,54.1527506,8001.157925,6957.2919325,13936.0479629,63.5555089,81.8411741,1.9971236,432.7546015),(21520,'femur',243,7,258,810.9965634,78.6198448,71.1095192,1.8,78.7788278,70.3445119,0.5575579,35.1698609,38.2468752,203483.488237,278633.5018126,37.841543,7285.1311559,5785.734798,11726.6883079,62.3659661,79.4033798,2.0193949,388.0596847),(21521,'femur',243,7,259,680.2774827,79.4085249,72.2772885,1.8,79.4031409,71.6605898,0.5125605,31.8111596,35.6310938,149000.5821907,233076.2451487,27.2680496,6541.3721563,4683.9091749,9637.524691,60.7999515,76.620211,2.0153821,418.4376868),(21522,'femur',243,7,260,541.4633306,79.8837193,73.307863,1.8,79.8313499,73.0560675,0.5116086,30.5540898,33.8285431,103684.4333003,187686.0381857,21.6304718,5548.1561181,3393.4715154,7406.0401688,23.4359913,57.7839562,1.2084177,158.1753212),(21523,'femur',243,7,261,380.1883273,79.402733,74.2404209,1.8,79.2895888,74.0260818,0.5602881,26.7091824,33.1154482,62395.1276627,136392.7458678,17.8953463,4118.7045065,2336.0927609,5227.9894617,20.0740297,53.5857319,1.1964627,141.2498263),(21524,'femur',243,7,262,216.7599512,80.1538271,75.7826431,1.8,79.7037478,75.3107804,0.6650385,25.1312532,30.7249128,26089.6472734,88562.6207289,13.7570087,2882.4368462,1038.1355475,3085.3147156,11.1097101,16.8801569,0.5977584,46.709747),(21525,'femur',243,7,263,94.8140722,85.5722474,77.377455,1.8,83.2266738,76.6381936,0.7890847,25.8127903,34.2346864,3895.5314873,39992.4108737,7.9594286,1168.1839393,150.9147771,1217.4462949,5.34375,6.9306167,1.7429871,19.9961163),(21526,'femur',243,7,264,9.2816591,97.62993,87.9550323,1.8,96.4966518,86.6941964,0.8727724,3.5027903,43.0248812,21.1335933,380.1557822,0.9079476,8.8357195,6.0333596,9.3268833,6.8029912,8.9850679,1.7033479,25.2081574),(21527,'femur',243,7,265,0.0055017,62.34375,111.328125,1.8,62.34375,111.328125,0.7853982,0.00000000000001005,0.00000000000001005,0.0000404,0.0000404,0.0004585,4021252472.28721,4021252470.16831,5686909782.53662,0.296875,0.4198447,2.3561945,0.8396893),(21528,'femur',243,7,266,0.0115643,108.5115834,111.625,1.8,108.5078125,111.625,0.2941503,0.0441293,0.1456709,0.0001063,0.0003182,0.000162,0.0021842,0.0024097,0.002789,0.296875,0.6638327,2.677945,1.259534),(21529,'femur',243,7,267,0.0835678,65.5679131,88.9243568,1.8,65.55,89.0229167,-1.420577,0.7650088,22.6784041,0.0164208,6.3859268,0.013616,0.2815862,0.0214648,0.2823058,0,0,0,0),(21530,'femur',243,7,268,17.6780179,65.8701897,85.5644044,1.8,65.8401914,85.5673538,-0.9795362,5.6043998,5.6868612,112.8943343,116.0754512,2.0308999,20.411163,20.1438759,39.6534991,11.28125,11.8527135,1.1856388,36.9514486),(21531,'femur',243,7,269,42.293684,65.8319566,85.537484,1.8,65.8445513,85.53539,-0.6403497,7.7669368,7.9326789,567.5499055,586.694796,2.5163153,73.9592261,73.0725538,145.2736291,15.734375,16.2740582,0.9017533,51.981463),(21532,'femur',243,7,270,66.2856498,65.831275,85.5297081,1.8,65.8184524,85.531157,-0.7016365,9.4403709,9.4598853,1337.2563186,1361.9959915,4.6027606,143.9759522,141.6529425,283.8010429,19,19.3607117,0.622032,62.4353828),(21533,'femur',243,7,271,135.5913842,72.4403631,88.1076813,1.8,72.555286,87.8926729,0.4114716,11.6106597,27.0646702,3002.5085714,17136.0201745,3.6150208,633.1508944,258.5993084,735.5695953,21.078125,21.8500807,0.6407837,70.54414),(21534,'femur',243,7,272,317.7266313,81.3004795,89.42624,1.8,78.9567178,88.1856304,0.322787,16.512474,27.486937,10467.6583002,53925.26604,5.3284196,1961.8506826,633.9242858,2335.6487967,23.453125,23.8333498,0.8824375,77.2914919),(21535,'femur',243,7,273,518.9466607,86.7407251,88.6119862,1.8,82.7272867,87.5760865,0.1858823,15.8886032,33.5067054,23861.3555356,98760.1504744,2.9541983,2947.4742216,1501.7906406,3659.3292033,24.9375,25.4170776,1.1751067,82.8513437),(21536,'femur',243,7,274,600.7878028,88.3518393,88.1956673,1.8,82.4308516,87.5408759,0.104989,15.6581732,35.6261787,29296.0876898,123095.7967197,1.0996679,3455.2062849,1870.9773722,4276.5903086,26.3733294,26.6857435,1.0074801,86.9057223),(21537,'femur',243,7,275,609.3034907,88.0649643,88.300083,1.8,82.1737921,87.6997975,0.0925918,16.1628664,35.8169825,29839.5038174,126735.8933063,0.8681332,3538.4302258,1846.1764763,4367.3292365,27.015625,27.6986125,1.2659933,89.700567),(21538,'femur',243,7,276,614.342449,87.7953513,88.4125366,1.8,81.9416734,87.870138,0.0856087,16.2875406,35.8926679,30187.1571031,128627.8408361,0.7485716,3583.6801306,1853.38952,4413.814149,27.90625,28.334071,0.6141594,92.1476009),(21539,'femur',243,7,277,617.6714594,87.5794468,88.5057758,1.8,81.749665,87.9966247,0.0809193,16.1738515,35.920683,30388.6827256,129615.2249938,0.6726096,3608.3730653,1878.877321,4446.1299091,28.203125,28.7984052,0.65381,93.5810403),(21540,'femur',243,7,278,619.0128705,87.404629,88.5937106,1.8,81.5556012,88.095641,0.0781701,16.245227,35.927169,30451.568448,129524.7111092,0.6291375,3605.2022686,1874.4932598,4447.9702396,29.3472291,58.0791002,2.9772843,190.5208377),(21541,'femur',243,7,279,620.1209382,87.2595456,88.676161,1.8,81.3994336,88.1609972,0.077608,22.7335074,35.9034954,30444.8464782,129276.949911,0.6212483,3600.6786628,1339.205865,4438.0828232,29.3485985,58.1086839,3.0083659,187.1322431),(21542,'femur',243,7,280,620.8157606,87.1084901,88.7485143,1.8,81.2573647,88.2453245,0.0783928,16.3217318,35.9402219,30504.7337845,129272.7094447,0.634562,3596.8812227,1868.9642784,4439.0917984,29.325513,58.0791002,2.9772843,184.5113038),(21543,'tibia',243,8,1,0.2629534,49.3651486,86.3166259,1.8,49.5019959,86.3176236,0.026881,3.3231968,40.8260645,1.0785205,188.7292208,0.0000317,4.622763,0.3245431,4.6338544,0.425782,0.9520775,2.677945,1.9311487),(21544,'tibia',243,8,2,0.2674307,46.5773627,86.0265176,1.8,47.0585879,86.0781213,0.0455228,17.2330373,43.1484684,2.0916645,211.119001,0.0000923,4.8928504,0.1213753,4.5888721,0,0,0,0),(21545,'tibia',243,8,3,0.1579011,31.8331948,84.7023054,1.8,32.21614,84.7388061,0.016121,4.4626755,56.2933876,0.1908857,115.0714552,0.0000068,2.044138,0.0427738,2.0471437,0.212891,0.8777721,2.896614,1.754784),(21546,'tibia',243,8,4,0.0663495,56.4782945,86.1930483,1.8,56.6382621,86.1560621,0.003349,8.3331519,38.387955,0.7821338,41.3115104,0.0000001,1.0761581,0.0938581,1.0956436,0,0,0,0),(21547,'tibia',243,8,5,0.160126,44.391179,85.9997106,1.8,44.6066897,85.8914765,0.0627359,14.8712762,43.4076402,2.5446294,93.2592841,0.0001049,2.1484532,0.1711104,2.2004985,0,0,0,0),(21548,'tibia',243,8,6,2.2267257,61.0992298,63.8814786,1.8,59.1948608,66.4020584,-0.4096208,30.7325784,48.360851,48.7735008,196.8177665,0.0588643,4.0697747,1.5870293,5.0765627,2.4768051,5.814692,1.1562895,13.6641462),(21549,'tibia',243,8,7,17.4347854,62.2099043,62.9818462,1.8,62.7428889,65.346061,1.3753002,43.1957847,27.3716472,193.35812,253.4784782,2.7961493,9.260622,4.4763192,9.8370756,4.8836466,10.7736309,1.0541012,25.698217),(21550,'tibia',243,8,8,36.9858056,61.2705438,62.9262077,1.8,60.5270939,64.8565632,-0.3540257,31.6243338,44.0105399,508.1162523,925.8303422,0.7408545,21.0365595,16.0672555,32.1268206,2.12891,5.1798616,1.4056476,12.4812494),(21551,'tibia',243,8,9,74.4964466,58.8954008,62.5086768,1.8,57.789681,63.3222767,-0.2134707,29.1956839,40.5103914,932.5922065,3944.0892466,0.5572548,97.3599393,31.9428108,113.4349455,6.599621,9.8137902,1.3521274,26.175655),(21552,'tibia',243,8,10,141.1611654,57.9033939,61.3914759,1.8,57.248422,61.0311991,-0.3368489,33.8096938,27.8630536,2932.9777069,8099.2392503,2.5700735,290.6802452,86.7496087,251.8111409,22.5190609,30.1990217,0.4289612,134.9383337),(21553,'tibia',243,8,11,271.2871209,58.2247512,56.8595823,1.8,57.779948,56.6034435,-1.2116603,41.5366666,38.7990322,12645.8335182,20594.6337617,39.6292612,530.8027702,304.4498888,753.2792989,1.1226388,3.0703577,2.5535901,8.2020328),(21554,'tibia',243,8,12,405.6493503,61.3459443,55.6177073,1.8,62.1345431,55.3284086,-0.1905252,35.860484,24.9492915,31627.2320767,43680.0913588,2.4246171,1750.7547793,881.952181,1757.2548198,1.1721956,2.3801937,0.4636476,5.8451021),(21555,'tibia',243,8,13,543.9930583,63.8099339,55.1086336,1.8,63.4388172,54.5483146,-0.0268684,36.2856229,47.9946351,50885.789299,79559.5801312,0.0654355,1657.6765305,1402.3678026,2331.1934986,42.761542,51.2643119,2.5005832,249.3358193),(21556,'tibia',243,8,14,601.2055887,63.9134225,55.6871694,1.8,63.2692421,54.9212795,0.0839154,36.2689717,26.5309054,66770.2082997,103666.9559077,0.7039397,3907.403627,1840.9732958,4071.5521528,0.638673,1.5053667,1.7126934,3.6859327),(21557,'tibia',243,8,15,648.6334004,63.3885416,56.5914472,1.8,63.0159838,55.4592529,0.230608,36.831238,30.3897785,81840.3979162,134548.2059379,5.6478682,4427.4164679,2222.0376591,5313.3994851,48.2745071,65.203408,2.3815932,264.4876066),(21558,'tibia',243,8,16,730.300126,62.3438848,57.148487,1.8,61.9871071,55.9471902,0.3184271,41.7169547,46.9431813,102169.3131049,182004.146104,11.9300334,3877.11572,2449.1076527,5049.7251312,49.8423142,69.3122879,2.3127436,266.1479414),(21559,'tibia',243,8,17,911.8390113,56.70398,56.7504726,1.8,56.3323382,55.9625762,0.2219984,37.1470549,43.9442197,133547.2149048,369951.1497619,7.3675059,8418.6532867,3595.0956312,9791.1746727,52.6187857,82.5852457,2.8540865,474.6285647),(21560,'tibia',243,8,18,1012.1556618,54.3668114,56.7881095,1.8,54.9100311,56.1959315,0.1947241,36.2597427,42.008887,167449.57854,453851.5443853,6.3159593,10803.7031338,4618.0575441,12029.98977,54.5292929,82.956496,2.8393202,427.4560203),(21561,'tibia',243,8,19,1070.0567108,53.7041737,57.0709889,1.8,54.3484065,56.6044743,0.1737157,35.5083948,41.3770072,202361.0573958,495133.0072533,5.3279596,11966.3803844,5698.9638183,13283.7280987,56.8956675,82.4064185,2.8615187,407.043552),(21562,'tibia',243,8,20,1112.6939534,53.2740156,57.5055321,1.8,53.9473467,56.9598208,0.1467313,35.0303088,41.7558399,228486.2662767,525980.9558231,3.9641589,12596.5842647,6522.5307423,14552.7698583,59.4425723,81.8014103,2.878308,361.9556037),(21563,'tibia',243,8,21,1133.935492,52.9933796,57.9730907,1.8,53.6762265,57.3713086,0.120194,36.4254072,41.5775382,249134.5881871,535306.8216215,2.7171293,12874.9042156,6839.5827828,16324.8892815,60.9656132,81.5814312,2.8991456,358.7043157),(21564,'tibia',243,8,22,1144.3512385,52.5471799,58.4377025,1.8,53.3020192,57.685424,0.0798801,37.6699944,41.4460441,268566.9569865,523237.2766804,1.214399,12624.540833,7129.4663418,16108.421105,62.8269405,81.3811874,2.9093037,356.7429076),(21565,'tibia',243,8,23,1133.7988651,51.8494849,58.6433798,1.8,52.7343235,57.7841693,-0.0069983,37.9645336,42.1173551,279060.1525012,493952.6294989,0.0092519,11728.0068684,7350.548686,16280.7794513,64.0912081,79.7364192,2.9153942,347.9298654),(21566,'tibia',243,8,24,1115.9340508,51.5228231,58.7361367,1.8,52.348333,57.8060524,-0.0983078,38.6363757,42.6379325,278671.5301146,475491.6956219,1.7916905,11151.846907,7212.672642,16333.283922,64.6257697,78.531101,3.0165652,370.8151103),(21567,'tibia',243,8,25,1099.9418419,51.1015369,58.5018606,1.8,51.9263314,57.7530031,-0.2310104,37.1327536,42.9630071,268100.5080588,459042.8705689,9.6104177,10684.6075744,7220.0545914,16057.4391103,65.8880778,77.6176762,0.4881826,436.9730006),(21568,'tibia',243,8,26,1080.5864642,50.5348673,58.3743299,1.8,51.4393999,57.5704638,-0.3532682,41.0921482,43.230965,249614.3749657,448538.1655053,21.5563484,10375.3909999,6074.502938,14060.2662365,64.2645289,77.6877151,0.512688,449.2653515),(21569,'tibia',243,8,27,1040.0896421,50.5903441,58.041747,1.8,51.3134211,57.3952497,-0.426413,42.6130266,44.2000085,233188.0141402,446477.0509893,29.6549141,10101.2887982,5472.2237056,14437.2038892,60.4494872,77.4273767,0.5658857,422.6425179),(21570,'tibia',243,8,28,1003.3023494,50.8094987,57.5893391,1.8,51.3984787,57.1359366,-0.4790137,44.8189887,45.9306341,223186.5171308,443546.9218277,35.5223489,9656.8865331,4979.7312197,13477.3017993,58.6695946,77.3852196,0.7698352,354.9113999),(21571,'tibia',243,8,29,981.5083286,50.9900717,57.1153705,1.8,51.535771,56.8500603,-0.5244983,47.3134927,43.0860708,217450.5418482,438193.4913627,41.0236802,10170.1891933,4595.9520119,12394.2420242,2.2624672,11.7572898,0.8366353,34.1068739),(21572,'tibia',243,8,30,966.4708054,51.1106068,56.7039435,1.8,51.6791668,56.629919,-0.5649101,48.7416224,43.8619198,213721.7448543,429217.6857038,46.1632875,9785.6566204,4384.7893132,12044.4328344,2.5591234,11.2046214,0.6777083,31.3455578),(21573,'tibia',243,8,31,953.6422223,51.2866702,56.4106622,1.8,51.9682263,56.2981699,-0.6006356,47.7868199,44.9707864,211995.5969955,419112.0305185,50.7677297,9319.6509068,4436.2775606,12674.3547466,0.212891,0.3010733,2.3561945,0.6021467),(21574,'tibia',243,8,32,940.4222169,51.5499357,56.1045834,1.8,52.2693645,55.9757458,-0.6444343,48.9528746,45.8186968,208991.6025456,414032.6017654,56.5657808,9036.3242656,4269.2406601,12285.5706115,55.6018052,78.6213698,1.0113359,307.6997333),(21575,'tibia',243,8,33,923.7840101,51.7936134,55.669445,1.8,52.482105,55.4968326,-0.6866279,46.9641711,43.8959251,202066.3336997,415558.7937659,61.8736472,9466.9104788,4302.5636103,13053.719375,0.212891,0.6732205,1.8925469,1.4537107),(21576,'tibia',243,8,34,903.7407318,52.042426,55.2992074,1.8,52.898087,55.1266147,-0.7219368,47.6922674,50.3357664,194114.9915888,413101.6541456,65.7785991,8206.9209182,4070.1564847,12063.3237399,0.425782,0.6021467,2.3561945,1.2042934),(21577,'tibia',243,8,35,888.73878,52.2468603,54.8300002,1.8,53.3061697,54.6103509,-0.7426503,47.248938,51.2633543,185884.8461775,410913.6248531,67.7373337,8015.7381541,3934.15924,11638.257208,0.212891,0.4760387,2.0344439,1.0279287),(21578,'tibia',243,8,36,847.6907255,53.3527738,53.4746562,1.8,54.253776,53.5696506,-0.7689823,50.2773517,52.7964631,179205.6875903,371862.0198756,68.3220518,7043.3130961,3564.3422267,10428.005067,54.8156575,76.747427,1.1232764,368.1925573),(21579,'tibia',243,8,37,778.0899689,55.2842929,51.370303,1.8,56.3157304,51.4748197,-0.8307403,46.6394668,46.3278885,167807.638027,300326.7058984,70.7128215,6482.6331491,3597.975049,9880.1117613,0.638673,0.7675894,2.1587989,1.80644),(21580,'tibia',243,8,38,739.1627775,56.4039191,50.3052798,1.8,57.5798316,50.3031823,-0.9089647,43.0962813,44.5639859,159517.1243924,268101.7179536,76.6650509,6016.1072342,3701.412738,8882.8227484,0.425782,0.6021467,2.3561945,1.2042934),(21581,'tibia',243,8,39,718.409267,57.1818447,49.5954094,1.8,58.2965617,49.65947,-0.9757326,43.4799052,43.7778763,152615.5586276,249508.9271215,82.1106815,5699.4296677,3510.0251001,8260.2925677,0.9786861,2.5635471,3.0584514,6.2192281),(21582,'tibia',243,8,40,694.169063,58.0130474,49.064974,1.8,58.9578097,49.2004385,-1.052432,44.8908303,42.7005103,143910.7613768,229550.6370867,87.2940023,5375.8288903,3205.7941515,7577.187312,0.425782,0.9520775,2.677945,1.9311487),(21583,'tibia',243,8,41,665.1354334,59.1241779,48.4891677,1.8,59.6972216,48.7198614,-1.1628743,31.4258613,40.8607782,132052.0042311,205875.7893379,93.4101729,5038.4696164,4202.0170209,6761.8444052,3.8112049,22.0524661,0.7033907,79.633138),(21584,'tibia',243,8,42,635.4333506,59.9799797,47.9664405,1.8,60.457151,48.1762428,-1.3087842,38.0122971,36.0220854,117242.3835622,186097.8884071,98.7999646,5166.2163979,3084.3277685,6033.566693,0.425782,0.7675894,0.5880026,1.5053667),(21585,'tibia',243,8,43,610.3695256,60.6500904,47.5034766,1.8,61.0651128,47.6909181,-1.4104625,38.4909125,41.6169618,103995.8273168,171681.3715337,99.1354642,4125.2740294,2701.8280534,5503.2317981,4.3458814,20.9684126,0.7207402,73.8610885),(21586,'tibia',243,8,44,587.8635145,61.0271874,47.2522477,1.8,61.5008027,47.3221077,-1.4333271,26.6547393,31.9154237,96546.8097914,162151.6952796,96.1373334,5080.66873,3622.125454,7714.2314912,0.212891,0.3010733,2.3561945,0.6021467),(21587,'tibia',243,8,45,569.4321955,61.3954429,47.0756569,1.8,61.9115179,47.1270552,-1.4460183,27.4100723,31.4101572,90952.8904618,154810.5026528,93.4353845,4928.6764613,3318.2287704,7437.8711113,3.7643032,22.5151734,0.6983702,75.8438932),(21588,'tibia',243,8,46,551.2513456,61.7095527,46.9419604,1.8,62.1979031,46.9642284,-1.4573702,26.4880684,31.898584,85655.821427,147826.0097541,90.6982656,4634.2499054,3233.7511438,7157.7955456,0.5325804,1.2413572,2.6011732,2.5332954),(21589,'tibia',243,8,47,533.4057179,61.9704206,46.8680076,1.8,62.4936966,46.7425954,-1.4654417,40.4499126,46.8467782,80800.2732134,141358.2655894,87.917833,3017.4597072,1997.5388801,3589.3628254,3.3446153,24.940978,0.6947383,88.4284547),(21590,'tibia',243,8,48,518.2038935,62.2418982,46.8093614,1.8,62.7354965,46.7140661,-1.4749406,40.0573741,46.8667488,76307.365038,135690.1775793,85.5761724,2895.233423,1904.9517517,3438.5632329,0.212891,0.3010733,2.3561945,0.6021467),(21591,'tibia',243,8,49,501.8994669,62.5891134,46.6644371,1.8,62.8052271,46.6717473,-1.483637,25.4588652,43.8146347,71904.5360769,129616.7002801,83.0160508,2958.2969501,2824.3417541,4595.0585974,0.3010733,0.6021467,0.7853982,1.2042934),(21592,'tibia',243,8,50,487.5603372,62.800289,46.5865087,1.8,62.9216498,46.5160684,-1.488169,25.0338149,44.6233738,67945.9163494,124625.392948,80.7065327,2792.8276696,2714.1654881,4311.7526939,0.425782,0.7675894,2.1587989,1.6300754),(21593,'tibia',243,8,51,475.6949,62.9309084,46.5655105,1.8,63.0681055,46.5121507,-1.4829126,24.1872079,29.5341788,64790.4254495,120248.26177,78.6717165,4071.4950153,2678.70627,6035.1524347,0.3010733,0.6021467,2.3561945,1.2042934),(21594,'tibia',243,8,52,466.4708902,63.1227843,46.5259967,1.8,63.2115815,46.4257451,-1.4827835,44.6256979,45.2829352,62037.9279628,116930.3733403,77.1444676,2582.2171831,1390.1839277,2814.9981612,3.9728958,28.0062945,0.8069002,90.8459042),(21595,'tibia',243,8,53,462.022438,63.3330455,46.5630249,1.8,63.3595399,46.4115089,-1.4862261,44.7818329,45.2860667,60110.8524093,114481.6145543,76.4543111,2527.9655071,1342.3044226,2747.2933841,0.212891,0.3010733,2.3561945,0.6021467),(21596,'tibia',243,8,54,460.5929226,63.521761,46.6399685,1.8,63.5417486,46.5199996,-1.4826405,47.721405,46.7039017,58784.5985338,112687.0214359,76.1704522,2412.7967346,1231.8287471,2648.8745616,11.0687846,37.5564102,1.1934478,130.9565193),(21597,'tibia',243,8,55,458.9719812,63.7279047,46.6989636,1.8,63.7193049,46.5498991,-1.4868635,23.5319822,45.9636992,57542.071585,111051.9572106,75.9577065,2416.0796284,2445.2709119,3452.2109418,0.212891,0.3010733,2.3561945,0.6021467),(21598,'tibia',243,8,56,454.3197285,63.9047397,46.7562869,1.8,63.933388,46.6034034,-1.4813711,22.4229958,43.3083612,56362.4109443,108693.1403371,75.1160442,2509.7495548,2513.5986064,3782.4680806,0.425782,0.6732205,2.8198421,1.80644),(21599,'tibia',243,8,57,447.2072701,64.1079414,46.6660544,1.8,64.0295242,46.6738069,-1.4772708,22.8351181,46.3606759,54507.9167684,105854.1963916,73.8844888,2283.2755213,2387.0214544,3103.0212858,10.5276968,35.3841238,1.2014627,132.2427281),(21600,'tibia',243,8,58,445.0431582,64.2881789,46.7028981,1.8,64.2006752,46.8292622,-1.474782,22.6251475,39.5078857,53533.5784041,103774.3878233,73.4921673,2626.6753045,2366.1095875,3459.2516349,10.924797,37.2029687,1.2019791,139.9282007),(21601,'tibia',243,8,59,441.623762,64.3957229,46.7607075,1.8,64.2288198,46.9000429,-1.4695106,22.2981271,46.4068374,52405.1577523,101712.4831473,72.85145,2191.7564063,2350.2044621,2997.4907477,10.6786605,37.0044733,1.199905,134.165014),(21602,'tibia',243,8,60,439.3447093,64.5318278,46.7622879,1.8,64.4211109,46.8843767,-1.4603344,22.2904801,46.6683677,51539.504145,100012.837479,72.3342768,2143.0541146,2312.1756027,2930.904966,0.425782,0.6021467,2.3561945,1.2042934),(21603,'tibia',243,8,61,435.4888154,64.6662665,46.7724281,1.8,64.5854707,46.860801,-1.4521344,24.157423,46.8958667,50692.83584,98063.6894471,71.564262,2091.0945101,2098.4372311,2819.9068506,10.6727806,35.6597191,1.1980503,124.0406953),(21604,'tibia',243,8,62,435.5033049,64.8542601,46.8084286,1.8,64.7290511,46.8841204,-1.4485716,21.6502776,44.9296467,50163.8490984,96602.3610814,71.5049498,2150.0805837,2317.0071982,3107.3800639,10.6309186,36.8467521,1.1795607,131.661978),(21605,'tibia',243,8,63,435.8743183,65.0599239,46.9030814,1.8,64.9611014,46.903337,-1.4448628,22.6434652,27.507093,49848.3661105,95340.7197173,71.49969,3466.0412732,2201.4460049,5160.7391292,0.425782,0.6021467,0.7853982,1.2042934),(21606,'tibia',243,8,64,435.9483314,65.2279989,46.9903838,1.8,65.0744339,46.972654,-1.4439855,21.4643158,43.0487321,49489.664089,94234.2365406,71.4958917,2189.013055,2305.6716356,3292.171985,0.212891,0.4760387,2.0344439,1.0279287),(21607,'tibia',243,8,65,435.9335261,65.4286725,47.0512949,1.8,65.1850901,47.2985724,-1.4439669,22.1924642,34.4120638,48790.5908653,92811.8986371,71.4931245,2697.0744649,2198.5206548,3521.8778775,0.425782,0.6021467,2.3561945,1.2042934),(21608,'tibia',243,8,66,436.0171531,65.6039982,47.1261094,1.8,65.3268632,47.3809358,-1.441638,21.4537627,26.8676981,48307.0236488,91656.1829976,71.4639878,3411.3894868,2251.6807137,5002.6286966,0.212891,0.4760387,2.0344439,1.0279287),(21609,'tibia',243,8,67,436.9412942,65.7758984,47.1971618,1.8,65.5144426,47.4598665,-1.4398026,21.8731839,27.0090837,47889.9565781,90801.9200503,71.5810743,3361.9030249,2189.4369265,4946.6252964,10.7015009,36.454126,1.2065575,145.8552182),(21610,'tibia',243,8,68,437.7576087,65.9440373,47.2745736,1.8,65.6370078,47.402731,-1.4400373,21.6187929,26.8038281,47551.6643403,90104.5730661,71.719236,3361.6307673,2199.5522442,4898.1214556,1.5951948,3.3118067,0.7853982,9.6040875),(21611,'tibia',243,8,69,439.4422078,66.0870533,47.3979804,1.8,65.819931,47.4619981,-1.4381158,21.6169663,27.3163631,47380.2348076,89387.5969741,71.9585843,3272.3095968,2191.8077793,4868.2874739,10.9536871,36.5305076,1.201112,129.6275173),(21612,'tibia',243,8,70,439.0684201,66.2198056,47.5206404,1.8,65.9816625,47.509787,-1.4366008,21.2694626,26.8613627,47012.8731014,88761.4644806,71.8681391,3304.428947,2210.3460683,4815.4576499,10.9160054,36.5305076,1.201112,134.8704727),(21613,'tibia',243,8,71,441.5855262,66.3740098,47.5440626,1.8,66.1475867,47.4868643,-1.433862,21.394658,42.9031294,46811.3570564,88802.7626641,72.2261634,2069.8434791,2187.992768,3152.8992799,11.0360465,37.0044733,1.199905,139.1888115),(21614,'tibia',243,8,72,444.3133823,66.5145037,47.6157727,1.8,66.2198172,47.3684538,-1.4346458,21.1681078,42.9065278,46560.8716052,88640.0538471,72.6879878,2065.8873675,2199.5764543,3139.5934571,10.9427009,36.2315214,1.2230293,141.8896088),(21615,'tibia',243,8,73,447.0289601,66.6674856,47.5846902,1.8,66.3178836,47.4731767,-1.4382829,46.7268834,42.8438139,46038.6396065,88373.7525316,73.2041754,2062.6957409,985.2709254,2120.2185518,11.4400596,36.3601375,1.2305294,134.3841719),(21616,'tibia',243,8,74,448.6054304,66.8111876,47.6955871,1.8,66.5156189,47.5803345,-1.4421458,21.3540557,43.4774729,45736.8127969,87679.2222732,73.5369091,2016.6586625,2141.8326084,3040.4687086,11.4081127,37.0332446,1.230866,127.7694212),(21617,'tibia',243,8,75,450.0736485,66.9007031,47.7681413,1.8,66.5495153,47.658831,-1.445444,20.9382478,26.6553497,45326.1395678,87536.163799,73.8397513,3283.9998209,2164.7532301,4644.864049,0.425782,0.6021467,0.7853982,1.2042934),(21618,'tibia',243,8,76,454.8580234,67.0372998,47.8108139,1.8,66.6958916,47.6390239,-1.4503997,21.3719145,27.2170887,45362.9391226,88031.4788523,74.7160821,3234.4193739,2122.5491578,4660.1052522,0.425782,0.6021467,2.3561945,1.2042934),(21619,'tibia',243,8,77,456.1486181,67.1774402,47.9065047,1.8,66.8383099,47.7131157,-1.4544803,27.2034697,45.1829813,45193.2097835,87775.8628845,75.0008289,1942.6753267,1661.3031463,2521.2082651,0.3010733,0.6021467,0.7853982,1.2042934),(21620,'tibia',243,8,78,458.2024863,67.3197607,47.9945752,1.8,66.9469375,47.7820018,-1.4534588,21.048412,43.2192173,44832.1193228,87542.864764,75.3204686,2025.5541436,2129.9525731,3051.4640556,11.7931977,34.6724873,1.2587542,118.4236139),(21621,'tibia',243,8,79,459.3328451,67.4621885,48.1709112,1.8,67.0967729,47.9102861,-1.4480059,21.7303115,43.052649,44548.3057787,86957.290397,75.4069994,2019.7895463,2050.0537145,3032.7146605,12.0307394,35.4423556,1.2908465,139.1371555),(21622,'tibia',243,8,80,457.5349671,67.617809,48.3602095,1.8,67.2839914,47.9800917,-1.4361323,20.5383114,29.4685351,44000.8178572,85393.5045112,74.8813127,2897.785869,2142.3775746,4388.0556685,0.425782,0.6021467,2.3561945,1.2042934),(21623,'tibia',243,8,81,457.4497332,67.7693395,48.4300469,1.8,67.4154281,48.1951085,-1.4292446,20.831815,28.9616871,43261.1885272,84337.3134693,74.7241518,2912.0304055,2076.6883957,4385.8090478,11.7947264,35.2172166,1.2700752,127.6019193),(21624,'tibia',243,8,82,455.3886684,67.9017659,48.5666674,1.8,67.5471361,48.3745792,-1.421662,20.4128464,28.4873967,42448.2917286,83243.3467724,74.2225354,2922.1114039,2079.4891098,4376.5051115,36.9909345,50.7971488,1.9894462,287.4296992),(21625,'tibia',243,8,83,455.2157559,68.0352911,48.7499788,1.8,67.6309188,48.549587,-1.4142353,20.6301332,43.3951529,41868.6232153,82316.4604555,74.0247788,1896.9044933,2029.4887528,2822.2476178,11.5548992,35.4838912,1.2661219,154.005595),(21626,'tibia',243,8,84,454.7092967,68.1649201,48.8972885,1.8,67.7362683,48.729333,-1.4112345,21.7888304,26.2025727,41479.0831874,81839.9120548,73.8717197,3123.3540676,1903.6856263,4293.7096761,11.7714431,35.5483349,1.2604089,157.5882157),(21627,'tibia',243,8,85,452.7523639,68.323928,49.1559779,1.8,67.8942644,48.8867067,-1.3972423,20.9407518,26.565658,40804.7449737,80489.2175613,73.2085651,3029.82209,1948.5807065,4235.6307971,11.4016764,35.5483349,1.2604089,160.8786258),(21628,'tibia',243,8,86,451.3840478,68.4820388,49.4609254,1.8,68.0580383,49.1836612,-1.383014,21.6069798,45.5194203,40192.1258766,78901.597952,72.6089115,1733.3612193,1860.145481,2376.3280642,0.212891,0.3010733,2.3561945,0.6021467),(21629,'tibia',243,8,87,449.4032589,68.6692878,49.7808522,1.8,68.2401132,49.4944332,-1.3713601,21.1026265,27.0590206,39777.8126866,77012.8273289,71.9606785,2846.1055019,1884.9697559,3809.2450124,0.212891,0.3010733,2.3561945,0.6021467),(21630,'tibia',243,8,88,448.9581637,68.8296783,50.0738911,1.8,68.4277839,49.668807,-1.3545508,21.6470358,40.0274694,39406.7322591,75449.5168161,71.3815216,1884.9434632,1820.4216319,2862.3084488,0.425782,0.6021467,2.3561945,1.2042934),(21631,'tibia',243,8,89,444.7718957,69.0690011,50.3528612,1.8,68.5720121,50.136805,-1.3325009,21.0336589,24.4936056,38523.9832509,72923.0508478,69.9983493,2977.2281007,1831.5397929,3984.3427713,9.8690212,33.5652892,1.2008903,130.9137261),(21632,'tibia',243,8,90,444.0292509,69.2311743,50.5547721,1.8,68.7163045,50.4101673,-1.3270664,21.709206,30.9710326,38046.3238803,72067.9508186,69.6950323,2326.9469834,1752.5433132,2960.2707406,9.5180992,33.4076111,1.1784562,145.9887897),(21633,'tibia',243,8,91,442.815581,69.361341,50.7557513,1.8,68.8397428,50.6198882,-1.3210195,21.2564837,30.8938195,37587.0962669,71321.08526,69.2931278,2308.5874951,1768.2650058,2963.067462,9.4903494,33.4076111,1.1784562,144.3801109),(21634,'tibia',243,8,92,439.9720424,69.5193119,51.1487595,1.8,68.9908737,50.972532,-1.2928154,22.6170006,23.7670964,36883.6146255,69442.9011852,67.8067751,2921.8083743,1630.7915995,3978.0102803,8.3034574,33.3227123,1.1071487,131.236196),(21635,'tibia',243,8,93,437.4044635,69.6496682,51.492706,1.8,69.1520779,51.2849247,-1.2699288,32.0895557,48.9933352,36273.3950225,67837.163335,66.498409,1384.6202346,1130.3800953,1777.6335597,0.425782,0.7675894,2.1587989,1.6300754),(21636,'tibia',243,8,94,435.4177689,69.7651507,51.8262587,1.8,69.2896458,51.6055888,-1.2524042,42.7515716,49.6334495,35792.711323,66558.7033145,65.4582416,1341.0049881,837.2256265,1562.4483754,0.212891,0.3010733,2.3561945,0.6021467),(21637,'tibia',243,8,95,434.5838746,69.9010197,52.1689861,1.8,69.42943,51.953415,-1.2346446,42.7076489,50.3167755,35494.5802245,65241.622721,64.5498,1296.6177203,831.1059284,1526.3549568,0.3815874,1.064455,2.2142974,2.232222),(21638,'tibia',243,8,96,431.9431615,70.0060283,52.5113545,1.8,69.5776893,52.2951365,-1.2157363,21.6255012,29.7219944,35115.2077976,63857.9631447,63.2898837,2148.5086828,1623.7870057,2869.9576024,6.2751959,32.8597793,1.0259324,128.5995886),(21639,'tibia',243,8,97,430.9191322,70.1760375,52.7969132,1.8,69.6441619,52.7145911,-1.2014449,20.9913472,23.6233936,34756.3530311,62443.6374996,62.4596665,2643.2966595,1655.7466644,3805.1117323,6.2199891,32.7111715,0.9845988,117.6878957),(21640,'tibia',243,8,98,428.2419824,70.2946114,53.0580203,1.8,69.7591683,52.9689682,-1.190318,21.2123964,27.1695029,34277.3930612,61103.1528477,61.530403,2248.9610184,1615.913279,2867.0498849,0.3810469,0.7675894,2.1587989,1.6300754),(21641,'tibia',243,8,99,426.7649059,70.3628569,53.3329515,1.8,69.8438178,53.3113957,-1.1796585,21.5944356,35.9057613,33808.6108048,60272.8879995,60.7895056,1678.6411396,1565.616785,2619.4611211,5.910268,33.361453,0.9898733,106.2257122),(21642,'tibia',243,8,100,425.7825047,70.4320024,53.6036133,1.8,69.9343331,53.5788328,-1.1652281,22.6808733,35.556384,33532.6473631,59518.3612809,59.9173517,1673.9149066,1478.4548596,2616.0837911,5.5131882,31.3586347,0.9639636,92.9142954),(21643,'tibia',243,8,101,425.2350079,70.5156209,53.8379237,1.8,70.0422525,53.76656,-1.1507867,19.5396865,22.5113874,33255.0371165,58877.9443382,59.0881217,2615.4738133,1701.9227539,3856.005828,5.4537128,31.0623946,0.9656851,107.1075356),(21644,'tibia',243,8,102,423.2870985,70.5733349,54.1034106,1.8,70.0811472,54.0612539,-1.1376916,17.8268625,22.3242242,32947.6926413,58069.9422282,58.1215185,2601.2076216,1848.2047909,3832.9212736,5.1582747,31.7271879,0.9474267,95.5509028),(21645,'tibia',243,8,103,422.3869097,70.6229577,54.3873163,1.8,70.1912434,54.33094,-1.1287639,17.6868458,22.1926768,32703.9107416,57542.1242757,57.5154747,2592.8428883,1849.0527394,3794.8177511,0.212891,0.3010733,2.3561945,0.6021467),(21646,'tibia',243,8,104,420.9587403,70.6822045,54.6530263,1.8,70.2881969,54.5160431,-1.1190099,24.6208053,37.7128237,32453.0513639,56628.4331744,56.7875917,1501.5696965,1318.1149402,2349.2782544,5.1856749,30.6629561,0.9481255,97.2842902),(21647,'tibia',243,8,105,419.5255717,70.7720068,54.8769649,1.8,70.2641432,54.9303361,-1.1084885,26.1895733,22.0142489,32120.3071052,55615.2284422,56.0116079,2526.3286837,1226.4540075,2647.5515634,4.8968081,31.465405,0.9245889,95.2712261),(21648,'tibia',243,8,106,418.5499414,70.8384944,55.1445703,1.8,70.3557039,55.2243681,-1.0969178,23.2105624,30.6095532,31866.8077886,54875.3782765,55.2313661,1792.7533278,1372.9442357,2660.8993125,4.7295859,31.2565751,0.9109479,93.2153687),(21649,'tibia',243,8,107,417.3257511,70.8697406,55.417825,1.8,70.3337653,55.5379366,-1.0830447,18.2605584,43.7505409,31708.7645777,54284.2568125,54.2784821,1240.767674,1736.4619352,1842.0299046,5.2374552,32.219771,0.8836721,102.4969863),(21650,'tibia',243,8,108,416.9042512,70.8989849,55.6663428,1.8,70.4189358,55.7356387,-1.0670786,19.3256476,43.184906,31513.6622788,53955.6002406,53.2953265,1249.4087702,1630.665267,1874.718801,5.7114584,31.352853,0.8960554,106.2043156),(21651,'tibia',243,8,109,416.5555969,70.8825933,55.9035896,1.8,70.4722136,55.9596162,-1.0494158,18.4909008,21.6186394,31280.5302985,53732.7494741,52.2026527,2485.4824815,1691.6715202,3646.9163597,0.638673,1.2413572,1.0303768,3.083786),(21652,'tibia',243,8,110,416.3157306,70.8942071,56.154881,1.8,70.5006255,56.1534408,-1.0367358,17.6304265,22.1499304,31042.8551886,53296.5759314,51.4070708,2406.1735215,1760.7546361,3636.0831076,4.1690701,31.1563633,0.8821822,90.5359681),(21653,'tibia',243,8,111,415.2298566,70.907159,56.3920577,1.8,70.550778,56.3289769,-1.025262,23.2453374,21.9656312,30822.2702101,52740.927141,50.5728348,2401.0658577,1325.9549485,2780.9592345,4.7835949,30.8037902,0.8636693,94.7723915),(21654,'tibia',243,8,112,415.2009051,70.907536,56.6230651,1.8,70.6010343,56.5341168,-1.0107297,17.5768826,40.6452384,30682.5862464,52425.7876357,49.6705705,1289.8383584,1745.6216178,1999.379593,5.4590789,30.6215417,0.8493502,103.9934902),(21655,'tibia',243,8,113,415.3119042,70.9547806,56.8475901,1.8,70.6134392,56.8220101,-1.0001073,20.6792849,21.4628359,30345.9796204,51872.9922578,49.0186402,2416.8750337,1467.4578846,2850.2242247,4.6012565,31.3636929,0.8430266,97.5034481),(21656,'tibia',243,8,114,412.9622307,70.9480407,57.1014389,1.8,70.6196122,57.132446,-0.9869304,18.4558361,30.0668976,29931.9399838,51228.6169766,47.911849,1703.8211824,1621.8143564,2662.7690482,0.4286814,1.5351788,0.5880026,3.1354421),(21657,'tibia',243,8,115,411.6331117,70.9313734,57.32891,1.8,70.6587091,57.331294,-0.9707215,20.2628033,30.7465321,29560.4784194,50643.0139906,46.7278436,1647.1130435,1458.8543378,2587.1025277,0.212891,0.3010733,2.3561945,0.6021467),(21658,'tibia',243,8,116,410.9010148,70.8969234,57.5653567,1.8,70.5755414,57.5861828,-0.9524932,31.7163906,56.4211873,29324.9546098,50357.3341989,45.4731904,892.5252483,924.5993654,1231.0965553,0.212891,0.3010733,2.3561945,0.6021467),(21659,'tibia',243,8,117,410.0194906,70.8637028,57.8026416,1.8,70.6177682,57.7860107,-0.9357232,31.3488715,56.8155923,29107.5672108,49962.6735773,44.2869269,879.3831335,928.5044652,1218.5199617,4.2834545,29.8305798,0.8257802,92.4368574),(21660,'tibia',243,8,118,408.9642162,70.8581764,58.0212113,1.8,70.6174239,57.9502465,-0.9191266,30.7392287,57.5784051,28863.4572915,49555.2992309,43.0870895,860.6577264,938.9779287,1201.45176,0.212891,0.3010733,2.3561945,0.6021467),(21661,'tibia',243,8,119,407.83806,70.8453254,58.2511507,1.8,70.6387162,58.1553347,-0.9069723,30.4675566,57.7222143,28519.6499948,49086.1008318,42.1690798,850.3849238,936.0662015,1189.002263,4.3655634,29.9602012,0.8004724,99.2493694),(21662,'tibia',243,8,120,407.7141508,70.8125676,58.4879122,1.8,70.6486489,58.3656764,-0.8942457,17.3639693,38.3715609,28250.9118811,48801.7515408,41.314342,1271.8208598,1626.9846755,1992.1984868,0.7526833,1.064455,0.6435011,2.7096601),(21663,'tibia',243,8,121,406.3683038,70.7979179,58.7276828,1.8,70.6353983,58.7249289,-0.8804117,17.7268433,29.2642362,27812.6150163,48246.9332834,40.260447,1648.6653863,1568.9547513,2544.8829354,0.7526833,2.8641555,0.7328151,6.7483221),(21664,'tibia',243,8,122,405.6000861,70.7399172,58.9721671,1.8,70.6113516,58.9959126,-0.8641446,18.2759227,23.9893625,27431.1314461,47830.2032798,39.1012867,1993.8088508,1500.9437214,2683.7922793,4.451597,31.0470705,0.7368926,89.1767067),(21665,'tibia',243,8,123,404.6752308,70.6658377,59.2435608,1.8,70.5301741,59.322107,-0.8476091,18.3107855,23.2304075,27091.4117787,47329.7003217,37.907989,2037.4029307,1479.5330203,2669.46592,30.2606396,40.2183724,0.9622386,116.6067904),(21666,'tibia',243,8,124,404.6319271,70.572504,59.4940363,1.8,70.4808939,59.5709868,-0.8299635,27.9240603,40.1421668,26729.2064737,47166.7636497,36.720773,1174.9929659,957.2106,1822.2037665,30.1435337,40.166501,0.9548598,115.9529877),(21667,'tibia',243,8,125,405.0758686,70.4722232,59.7140245,1.8,70.4566922,59.7769683,-0.8143091,29.062248,28.7352016,26402.0728158,46985.5385203,35.7070918,1635.1212391,908.4662974,2437.8547324,30.0054493,39.9929215,0.9517845,115.7035704),(21668,'tibia',243,8,126,403.5031752,70.4087143,59.9398538,1.8,70.3331356,60.0073582,-0.8014744,29.2020471,39.2573828,26022.4271784,46555.2397466,34.7062151,1185.897693,891.1165393,1839.3112448,29.8466095,39.8697727,0.9561334,114.8003504),(21669,'tibia',243,8,127,400.4274752,70.3651462,60.1743824,1.8,70.3416233,60.2290929,-0.7920392,26.4046126,39.2452345,25649.4990214,46017.0854465,33.8121514,1172.5521853,971.402208,1817.171342,29.7068244,39.800939,0.967958,113.6691097),(21670,'tibia',243,8,128,399.2387738,70.3005189,60.3954295,1.8,70.3082217,60.3863227,-0.7787246,29.5065514,21.3444019,25385.1258574,45491.1567883,32.8258565,2131.2921731,860.3216803,2395.8038755,29.6335357,39.6829052,0.9262223,113.441089),(21671,'tibia',243,8,129,398.4328697,70.2829727,60.6205306,1.8,70.2618935,60.7181906,-0.7662622,28.9010306,27.6190602,25099.1556781,44784.1483927,31.9323182,1621.4942905,868.4519259,2357.6585063,29.4801939,39.5662377,0.9036183,112.7142336),(21672,'tibia',243,8,130,397.5145107,70.196415,60.8561477,1.8,70.1565696,60.9764006,-0.7534493,31.2200153,26.5011541,24835.5536517,44287.4731386,31.0109626,1671.1526221,795.5010091,2195.1757902,29.4382987,39.4348614,0.9078592,112.1851396),(21673,'tibia',243,8,131,393.9278604,70.1736136,61.0751112,1.8,70.1176479,61.2635934,-0.7462205,17.5184963,26.5587555,24404.3975449,43518.9082591,30.257759,1638.5898888,1393.0646326,2410.8863877,29.2804574,39.3041991,0.9121285,111.5313369),(21674,'tibia',243,8,132,391.8873556,70.1123313,61.3097721,1.8,70.0339056,61.5236973,-0.7340531,17.5291767,25.9235791,24155.7767818,42946.5480189,29.3095878,1656.6596684,1378.0325942,2418.8878742,29.1414178,39.0868108,0.9283845,111.3335756),(21675,'tibia',243,8,133,390.7533709,70.0443171,61.5248872,1.8,69.9470271,61.7169972,-0.7195963,17.1008752,25.4250645,23966.7624107,42447.8659706,28.2897548,1669.5283485,1401.4933233,2421.9491565,0.425782,0.9520775,1.1071487,2.0558574),(21676,'tibia',243,8,134,389.651634,69.9895615,61.7378883,1.8,69.9125016,61.8541581,-0.703915,17.4565734,26.8456375,23743.5095752,41894.8926467,27.202684,1560.5847586,1360.1472107,2260.6297946,0.425782,1.5053667,1.7126934,3.3332034),(21677,'tibia',243,8,135,389.0532386,69.9029042,61.9558893,1.8,69.816156,62.0797008,-0.6891217,23.1764574,52.8813307,23538.3093859,41568.0568122,26.2168276,786.0629873,1015.6129099,1186.7196091,0.638673,1.5498699,1.849096,3.8622974),(21678,'tibia',243,8,136,388.7638883,69.854614,62.1409727,1.8,69.7853771,62.2758062,-0.6783324,23.4724696,48.6737663,23385.4243877,41178.7739285,25.5126667,846.0157715,996.291605,1298.1921572,28.6446376,38.5168008,0.8675657,109.1744062),(21679,'tibia',243,8,137,388.9999228,69.8481167,62.3191113,1.8,69.7126354,62.5475957,-0.6661842,22.4743992,27.8058678,23188.902627,40597.635031,24.760648,1460.0384101,1031.7918815,2186.7221484,0.212891,0.4760387,2.677945,0.90322),(21680,'tibia',243,8,138,387.647346,69.7913819,62.5157174,1.8,69.651213,62.7607975,-0.6516242,23.4208024,25.9201126,22972.9180189,39882.6373064,23.7638351,1538.675308,980.8766413,2306.0211783,0.5715704,0.90322,0.7853982,1.80644),(21681,'tibia',243,8,139,387.5869296,69.7049053,62.7165529,1.8,69.5405636,62.9521084,-0.6369019,25.2248059,59.0021733,22859.8578256,39424.8935376,22.8467725,668.193921,906.2451428,1009.1326653,0.6021467,0.7675894,0.5880026,1.80644),(21682,'tibia',243,8,140,386.9788792,69.6541095,62.9162717,1.8,69.5029093,63.1284712,-0.6188042,25.3349927,59.0632961,22736.3760779,38854.2654362,21.7012212,657.8411297,897.4297482,1003.9565849,0.212891,0.3010733,2.3561945,0.6021467),(21683,'tibia',243,8,141,385.8784882,69.5688422,63.1197642,1.8,69.4052383,63.3018751,-0.6028661,23.9039044,42.7940828,22591.5671337,38313.4281341,20.6763622,895.297331,945.099458,1420.3767136,28.2971,37.5201891,0.8295462,107.3163102),(21684,'tibia',243,8,142,384.5130425,69.4819368,63.3163837,1.8,69.3424856,63.4494437,-0.5897368,17.0039444,26.0447294,22453.8958282,37786.7297146,19.8212779,1450.8397883,1320.511011,2238.4644942,0.8359184,3.0997397,1.2924967,7.4449181),(21685,'tibia',243,8,143,384.785651,69.4231592,63.5046879,1.8,69.2762691,63.6276025,-0.5788614,16.6578874,26.2046041,22349.0669902,37422.6806862,19.1935504,1428.0956335,1341.6507425,2203.0981485,1.0113154,3.0997397,1.2924967,8.0987208),(21686,'tibia',243,8,144,382.4195652,69.3285565,63.6902711,1.8,69.2015879,63.8403085,-0.5668931,17.055575,23.0246864,22117.680858,36936.1210944,18.3806008,1604.1964898,1296.8006588,2220.3639088,0.7753212,2.2226473,1.2793395,5.6687374),(21687,'tibia',243,8,145,381.2238182,69.2963704,63.8195424,1.8,69.0915404,64.0280791,-0.5539119,16.7328626,19.5708278,21836.9531248,36319.0902918,17.5804661,1855.7769074,1305.0339144,2970.4637206,0.795626,2.0084097,1.012197,4.5891527),(21688,'tibia',243,8,146,377.2540686,69.1896869,64.0006756,1.8,68.9579194,64.2208194,-0.5401235,29.1300023,36.2214581,21528.3031338,35639.0081126,16.6271456,983.919752,739.0422726,1563.8257226,0.8359184,1.8189415,1.2120257,4.7138614),(21689,'tibia',243,8,147,374.7951814,69.0863902,64.1445913,1.8,68.8500918,64.4441225,-0.5253576,29.7771918,19.3695311,21278.517992,35164.3535679,15.7117119,1815.4468208,714.5911585,1882.342353,0.736177,4.5956851,1.3370531,9.9996101),(21690,'tibia',243,8,148,370.9638029,68.9506149,64.2904978,1.8,68.6872694,64.5673891,-0.512384,30.6888347,36.7523232,20979.0954463,34847.5482189,14.8602806,948.172665,683.606779,1502.4717742,0.6328108,2.8956307,1.2722974,6.2406247),(21691,'tibia',243,8,149,368.091258,68.8230082,64.4166486,1.8,68.6020533,64.6978235,-0.4990697,30.9028056,19.5143176,20677.7353958,34506.3930899,14.0528937,1768.2603019,669.1216216,1734.3662839,27.2633857,36.1168813,0.6977571,104.0561594),(21692,'tibia',243,8,150,366.2455166,68.6664683,64.5788721,1.8,68.4447508,64.8776985,-0.4855047,29.4144496,25.6932825,20483.7952956,34315.3973605,13.2926799,1335.5785653,696.3854696,1838.5866712,1.14243,4.7603875,1.1071487,11.7329975),(21693,'tibia',243,8,151,363.9160597,68.4991352,64.7143304,1.8,68.2937819,64.8969283,-0.4675381,27.1669371,61.1391338,20180.1519001,34156.4029767,12.3198581,558.6667791,742.8202822,878.9258104,0.425782,0.9520775,1.1071487,2.0558574),(21694,'tibia',243,8,152,362.8678995,68.3437058,64.863439,1.8,68.166354,65.1151499,-0.4550661,16.8131735,60.945819,20050.6896816,34025.0675844,11.6830954,558.2838679,1192.5583069,879.3945191,0.8691522,3.3661023,1.2490458,7.8707001),(21695,'tibia',243,8,153,361.7909252,68.2388783,64.9660919,1.8,67.9736488,65.2698051,-0.4427571,16.7802638,60.5184362,19766.8066222,33482.1745905,11.0680437,553.2557794,1177.9794935,873.5609744,0.8102303,5.7912613,1.2722974,13.0103435),(21696,'tibia',243,8,154,359.5432412,68.0841238,65.1037607,1.8,67.833115,65.3939291,-0.4287681,17.8618256,58.3586353,19528.1623263,33084.6645389,10.3577627,566.9197779,1093.2903904,898.4291203,0.8262689,4.0393227,1.2490458,9.1997021),(21697,'tibia',243,8,155,357.3438739,67.9292105,65.2388943,1.8,67.7090399,65.5411735,-0.4175807,26.4285919,19.7662447,19308.3217169,32734.3486474,9.7954518,1656.0732291,730.5845792,1965.8836337,0.7232629,2.9652285,1.2036225,6.4169894),(21698,'tibia',243,8,156,355.5770075,67.7806379,65.363465,1.8,67.5757834,65.6958743,-0.4058185,21.9797026,58.4922176,19135.8926164,32407.9079615,9.2357601,554.0550401,870.6165397,878.8529819,1.2715871,7.435963,1.3397057,17.7242049),(21699,'tibia',243,8,157,354.4238638,67.6373826,65.4890095,1.8,67.4261852,65.7960807,-0.3969418,21.4751116,53.7045918,19027.9093317,32207.0991617,8.8286603,599.7084807,886.0447239,954.015237,0.6726126,2.767583,1.1760052,5.9912074),(21700,'tibia',243,8,158,353.0130681,67.4908845,65.6246983,1.8,67.2456193,66.0075395,-0.3865511,24.3967125,54.6180292,18940.8890157,31942.6195711,8.3620665,584.8365461,776.3705457,931.6169249,0.6307656,2.2226473,1.2793395,5.1396434),(21701,'tibia',243,8,159,351.024382,67.3391331,65.7404825,1.8,67.1615167,66.0667,-0.3763183,23.7973006,24.6358625,18787.4330057,31576.6409493,7.9012923,1281.7347466,789.4774828,1942.8288061,26.4400286,34.4502108,0.6274333,101.5014674),(21702,'tibia',243,8,160,349.6230903,67.1970486,65.8594286,1.8,67.003971,66.1393084,-0.3634072,21.9315058,23.9649976,18608.1208995,31237.1559245,7.3626257,1303.449156,848.4652656,2005.8986196,26.2805799,34.3256618,0.6224124,101.0240294),(21703,'tibia',243,8,161,348.2727796,67.0846059,65.9551432,1.8,66.8658847,66.2488434,-0.3528213,21.2809447,23.7351273,18385.2447923,30702.0197104,6.930776,1293.526648,863.929918,1894.3281336,0.3010733,0.6021467,0.7853982,1.2042934),(21704,'tibia',243,8,162,346.8604182,66.9210661,66.070815,1.8,66.7115728,66.3507038,-0.3443671,17.8872249,23.8727564,18189.7304524,30288.464611,6.5888721,1268.7460174,1016.911824,1799.163904,0.6731041,4.9836505,1.2220253,10.9544861),(21705,'tibia',243,8,163,345.6294982,66.7414317,66.1860011,1.8,66.5212987,66.4578101,-0.3361319,22.6365378,23.8694615,18027.9191914,29962.7125141,6.2670164,1255.273919,796.4079746,1856.3234584,0.7018914,3.7179815,1.3397057,9.0019408),(21706,'tibia',243,8,164,344.3279711,66.5810855,66.2952985,1.8,66.3670887,66.575699,-0.3241254,25.7969294,37.8491772,17915.5473626,29664.7440205,5.8208314,783.7619269,694.4837152,1210.9437908,0.8756724,5.930457,1.2036225,14.2146368),(21707,'tibia',243,8,165,342.2292474,66.4082004,66.3898746,1.8,66.2370011,66.6509748,-0.3154464,22.4954722,18.7981084,17757.9393641,29380.6682809,5.4898924,1562.9587612,789.4006046,1785.7237074,0.663125,2.8403202,1.3439975,6.7697188),(21708,'tibia',243,8,166,340.5876773,66.2334112,66.4919697,1.8,66.0475894,66.7401832,-0.3090796,25.835102,19.9017939,17642.6138006,29091.5970638,5.2522411,1461.7575254,682.8931353,1734.865229,0.5262057,2.1710707,1.3734008,4.786914),(21709,'tibia',243,8,167,337.8254585,66.0680743,66.5907119,1.8,65.9194557,66.8318902,-0.2996853,25.6371495,21.1704695,17475.482661,28705.0931909,4.9071733,1355.9025302,681.6468673,1669.9272919,0.425782,1.7555442,1.3258177,3.7589854),(21710,'tibia',243,8,168,335.7123826,65.8857522,66.673206,1.8,65.6938623,66.9708013,-0.2886403,26.4086948,31.000894,17359.844985,28380.5569889,4.5335199,915.4754377,657.3533872,1339.8661581,0.425782,0.9520775,1.1071487,2.0558574),(21711,'tibia',243,8,169,334.8234832,65.7570959,66.755199,1.8,65.5416289,67.0957846,-0.2816082,26.3446678,30.9577353,17297.2417712,27910.2141994,4.3096754,901.5586563,656.5746778,1323.8908197,0.638673,1.962758,1.3521274,4.5374967),(21712,'tibia',243,8,170,333.2972523,65.579454,66.854455,1.8,65.4183301,67.2058875,-0.2694524,26.5700773,30.2855513,17153.6671652,27458.1335346,3.9364833,906.6413644,645.6009507,1315.4621712,0.7740747,5.7912613,1.2722974,13.0103435),(21713,'tibia',243,8,171,332.1587216,65.4064601,66.9633922,1.8,65.2315794,67.2998504,-0.2623775,26.234159,17.2140535,17044.5275203,27054.3824827,3.72442,1571.6450789,649.7074113,1433.9210157,1.1549117,2.8403202,1.3439975,7.7976474),(21714,'tibia',243,8,172,329.6408327,65.2813556,67.0535121,1.8,65.1075691,67.318664,-0.2597986,15.4781918,17.6718085,16896.369748,26610.5150623,3.6255197,1505.8173078,1091.6242661,2444.099914,0.212891,0.3010733,2.3561945,0.6021467),(21715,'tibia',243,8,173,327.0904076,65.1641184,67.1605252,1.8,64.9906902,67.4545367,-0.2512024,24.2820049,16.9943571,16852.2838925,26159.6950097,3.3682933,1539.3165439,694.0235757,1632.3299149,0.6269388,2.6928818,1.2490458,5.8148427),(21716,'tibia',243,8,174,324.7456921,65.0140479,67.2459128,1.8,64.7996924,67.5146831,-0.2454821,24.6927671,28.6917391,16785.4881236,25779.0602098,3.1966176,898.4837096,679.7734754,1483.4300256,1.1468435,7.876967,1.240499,18.4510602),(21717,'tibia',243,8,175,321.7981589,64.9110481,67.3248465,1.8,64.7096834,67.5675361,-0.2404052,24.7457738,16.9613462,16655.943061,25396.6760315,3.0404445,1497.3266717,673.0823279,1576.5651702,0.425782,1.1464531,1.1902899,2.658004),(21718,'tibia',243,8,176,319.6165222,64.7804803,67.3824205,1.8,64.5670626,67.6052178,-0.2389081,19.9357871,16.9633612,16552.3474686,25045.3060195,2.9830559,1476.4353428,830.2831173,1724.8567361,0.212891,0.8777721,1.815775,1.8794927),(21719,'tibia',243,8,177,318.5562486,64.6946211,67.4052036,1.8,64.4049577,67.6402075,-0.2314463,24.1135969,16.9391086,16454.9867611,24547.61173,2.793615,1449.1678586,682.3945357,1643.9673229,1.1723933,8.0786454,1.2490458,18.2230395),(21720,'tibia',243,8,178,315.6869723,64.5799515,67.4684295,1.8,64.2768168,67.7870187,-0.2235717,24.0452347,16.9575728,16350.0335777,24038.7139029,2.5863709,1417.5798693,679.9698075,1624.9602917,0.8528584,7.5448763,1.2847449,16.5929641),(21721,'tibia',243,8,179,314.0249522,64.4652531,67.5308648,1.8,64.1160877,67.8829824,-0.2196987,24.0309911,49.4895323,16352.7668474,23720.6503345,2.4858168,479.3064156,680.4865765,799.6593157,0.4131345,1.3464409,1.2490458,2.9074214),(21722,'tibia',243,8,180,312.0406748,64.3323405,67.5879806,1.8,63.9696521,68.0107358,-0.2069451,23.6731251,50.6141408,16345.1492809,23367.0252055,2.1956423,461.6698976,690.4516934,775.5441951,24.2379054,30.8478986,0.3523087,92.5600454),(21723,'tibia',243,8,181,310.4439879,64.1902139,67.6228764,1.8,63.796227,68.0573811,-0.1916839,24.094879,52.3524541,16289.2631597,23072.7543452,1.877922,440.7196326,676.046688,743.8613791,0.425782,1.0855354,1.7681919,2.4816394),(21724,'tibia',243,8,182,308.9900121,64.0378469,67.6399857,1.8,63.6118681,68.001604,-0.1774796,24.097948,55.743885,16189.8684283,22885.681648,1.6051865,410.5505323,671.8359767,695.2899141,24.4006828,30.4486232,0.357134,91.9881582),(21725,'tibia',243,8,183,307.7224495,63.9060528,67.6818061,1.8,63.5917963,68.0124209,-0.1631595,23.9670758,55.0442602,16151.7602218,22509.5929549,1.3532417,408.9362427,673.9145131,695.4470329,0.425782,0.8777721,1.815775,2.0558574),(21726,'tibia',243,8,184,306.8691352,63.7607722,67.7338398,1.8,63.4776185,68.0064282,-0.1477136,23.2247214,23.7506208,16121.5556198,22315.8680237,1.1078526,939.5909349,694.1549618,1363.9765306,0.212891,0.3010733,2.3561945,0.6021467),(21727,'tibia',243,8,185,306.6941763,63.6539423,67.7701514,1.8,63.3559657,68.1055308,-0.1328545,23.5120274,32.3095028,16053.7709612,22081.6440705,0.8969125,683.4411591,682.7897355,1068.5888585,24.6432938,30.1629811,0.3083585,91.7173442),(21728,'tibia',243,8,186,306.7254901,63.4895302,67.8280984,1.8,63.1484663,68.1773423,-0.1182339,23.2629548,30.2231314,16037.7020879,21939.2303169,0.7113084,725.9085769,689.4095008,1113.7240553,24.6432938,30.1201268,0.2792705,91.8937089),(21729,'tibia',243,8,187,306.057298,63.3467937,67.842802,1.8,63.0329784,68.1719672,-0.1019392,22.8821161,42.2270603,15934.7077576,21773.4626356,0.5282381,515.6281892,696.3826096,846.686221,0.212891,0.4760387,2.0344439,1.0279287),(21730,'tibia',243,8,188,305.0425117,63.2089677,67.8556745,1.8,62.9529054,68.1950033,-0.085851,21.193122,16.2514253,15857.9643819,21640.7286408,0.3737947,1331.620353,748.2599478,1547.2807822,0.212891,0.6732205,1.8925469,1.4537107),(21731,'tibia',243,8,189,305.0360429,63.0252468,67.8797805,1.8,62.798937,68.2529936,-0.0712463,22.2365087,20.4357893,15885.6677338,21641.4806129,0.2576261,1058.9990104,714.3957678,1263.4756978,24.695356,29.9602012,0.3105151,90.8657802),(21732,'tibia',243,8,190,306.3441624,62.8539869,67.9079337,1.8,62.6804341,68.2863353,-0.0509939,22.3611264,27.2594828,15992.1701851,21684.428667,0.1326534,795.4820278,715.1773094,1218.1359859,24.8707971,29.9602012,0.3105151,91.0938009),(21733,'tibia',243,8,191,308.0437453,62.701466,67.9457054,1.8,62.586099,68.3983414,-0.042135,23.3103129,27.3722936,16090.0593696,21797.2054171,0.0910946,796.3236753,690.2549718,1107.914694,24.695356,29.8958398,0.3037345,90.6680189),(21734,'tibia',243,8,192,309.4352446,62.5521455,67.9663206,1.8,62.401281,68.304611,-0.0441914,23.2183693,28.9881725,16101.7423631,21745.4512326,0.1006492,750.1490915,693.4915267,1074.9909885,24.695356,29.8328588,0.296925,90.3152895),(21735,'tibia',243,8,193,311.6024467,62.4154439,67.9531049,1.8,62.2556862,68.2947712,-0.0352804,23.1685048,24.3439684,16034.9018941,21646.4722257,0.0646154,889.1924222,692.099124,1227.5654409,24.695356,29.7712669,0.2900869,90.2422369),(21736,'tibia',243,8,194,312.0791578,62.2776306,67.9692856,1.8,62.1265988,68.2549136,-0.0232243,22.866776,17.7268681,15923.5521963,21570.5298165,0.0280489,1216.8268904,696.3619279,1388.4277828,24.8774202,29.7590855,0.3353244,90.5433102),(21737,'tibia',243,8,195,312.970392,62.122679,67.980295,1.8,61.9732809,68.2643159,-0.0188151,22.8442131,25.7765707,15891.8720836,21561.0349393,0.0184631,836.4586282,695.6629242,1409.1647152,24.8734868,29.7110728,0.2832209,90.4186016),(21738,'tibia',243,8,196,314.2415804,62.0051112,67.9746204,1.8,61.893539,68.2710144,-0.0084723,22.7788022,30.2284952,15913.1295479,21629.8707922,0.0037591,715.5457334,698.5937812,1045.9922214,24.9970906,29.7590855,0.3353244,90.4186016),(21739,'tibia',243,8,197,315.551499,61.8814915,67.985555,1.8,61.8025888,68.2748013,-0.0069481,22.5389161,32.3017399,15941.6422586,21711.8650609,0.002539,672.1577583,707.2940938,1009.2234981,25.0238325,29.7446137,0.2606024,90.4702576),(21740,'tibia',243,8,198,316.2877025,61.7505771,67.9816503,1.8,61.6318045,68.2448327,-0.0127628,22.5656793,23.4735921,15924.1705326,21739.4136402,0.0085862,926.1221528,705.6809731,1433.9780939,25.0600835,29.7712669,0.2900869,90.2938929),(21741,'tibia',243,8,199,316.9110665,61.6409266,67.9801112,1.8,61.5628765,68.1854372,-0.0151089,22.3585796,21.2493044,15908.896154,21799.2636889,0.0120566,1025.8812825,711.5342939,1505.5277847,25.0482886,29.7712669,0.2900869,90.1691843),(21742,'tibia',243,8,200,317.5163564,61.5688591,67.9675087,1.8,61.4740921,68.2045353,-0.0157241,22.1355304,30.5504508,15946.0246398,21810.9482827,0.0130832,713.9321268,720.3814104,1074.6858451,25.0051356,29.7712669,0.2900869,90.1175282),(21743,'tibia',243,8,201,318.9672969,61.5138974,67.9436633,1.8,61.4340788,68.2084204,-0.0228368,22.2301242,48.8669261,15921.46828,21743.0517215,0.0277197,444.9441259,716.2113951,767.5064019,25.0051356,29.8571563,0.274382,89.6917462),(21744,'tibia',243,8,202,318.8278545,61.4437756,67.9376148,1.8,61.3148469,68.2663129,-0.0383335,22.4699163,17.3773145,15837.5041128,21721.70629,0.0780454,1250.0036339,704.8314679,1483.2926068,24.908247,29.9503666,0.2587709,89.6917462),(21745,'tibia',243,8,203,318.5477197,61.3777032,67.9413725,1.8,61.2349449,68.2356697,-0.0529634,22.0366102,51.25933,15752.336108,21748.7674238,0.1487881,424.2889522,714.8257348,710.437215,24.906237,30.062139,0.2724631,89.9928196),(21746,'tibia',243,8,204,318.7701574,61.2947592,67.9371404,1.8,61.0378094,68.2282697,-0.0749047,21.9017071,52.486641,15696.740993,22025.1211514,0.297531,419.6328955,716.6902971,702.8869378,24.695356,30.1795051,0.2860514,89.8164549),(21747,'tibia',243,8,205,318.3773068,61.2675319,67.929931,1.8,61.1346277,68.1507212,-0.0906369,20.7644008,21.8682959,15695.3050132,21993.5910247,0.4347219,1005.729533,755.8756524,1468.4524416,24.8611481,30.207275,0.2347226,90.1175282),(21748,'tibia',243,8,206,319.8509636,61.2212506,67.9267536,1.8,61.1001625,68.1299276,-0.1097679,20.8550761,42.8722668,15781.9322179,22178.2000795,0.6397375,517.3087805,756.7429682,848.2918232,24.8698243,30.1562187,0.2569644,90.2422369),(21749,'tibia',243,8,207,320.7030555,61.1816984,67.9301479,1.8,61.1165857,68.104813,-0.1224364,22.5645491,39.6888476,15885.7041242,22280.0830194,0.797264,561.3688565,704.0115901,911.5808802,24.908247,30.1028175,0.2501244,90.1175282),(21750,'tibia',243,8,208,320.9874478,61.1484013,67.930719,1.8,61.0666749,68.1117564,-0.1378695,22.0436832,22.9307072,15940.7529895,22321.8537314,1.0104625,973.448117,723.1438085,1436.6577731,24.908247,30.0055496,0.2656298,89.9928196),(21751,'tibia',243,8,209,321.4733059,61.1564967,67.8879258,1.8,61.0592757,68.0768869,-0.1487043,22.1823669,39.7960669,15959.2222798,22286.6011687,1.1760816,560.0201955,719.4553393,917.7953583,24.908247,29.975325,0.2880554,90.0658722),(21752,'tibia',243,8,210,320.860421,61.1052194,67.8781333,1.8,61.018456,68.0702028,-0.1561848,19.6603408,22.6998885,15969.782242,22277.8642989,1.2939228,981.4085361,812.2840991,1598.2616132,0.212891,0.6732205,1.8925469,1.4537107),(21753,'tibia',243,8,211,320.6735684,61.0898347,67.8804766,1.8,61.0240589,68.1651332,-0.1585761,22.9702821,23.9671271,16117.1343401,22297.4045674,1.3327354,930.3328028,701.6515618,1277.5046879,0.212891,0.4760387,2.0344439,1.0279287),(21754,'tibia',243,8,212,320.7765056,61.0881622,67.8709564,1.8,61.0159496,68.1418451,-0.1596926,23.1779287,24.5820526,16249.1304221,22348.0404645,1.3518421,909.1201964,701.060506,1268.476511,25.0697351,29.9155415,0.2812322,90.2938929),(21755,'tibia',243,8,213,320.9919114,61.0760791,67.8601212,1.8,60.9544872,68.0671299,-0.1728858,24.4361562,29.2134282,16391.4591451,22468.8554516,1.5831809,769.1276516,670.7871317,1200.0752863,25.121138,29.9503666,0.2587709,90.8443836),(21756,'tibia',243,8,214,321.3546568,61.0550459,67.8741526,1.8,60.9527688,68.1207275,-0.1795,24.3406522,31.1672176,16626.7032729,22660.6808009,1.7072333,727.067815,683.08372,1157.7219093,25.265884,29.9511233,0.2294627,91.0207483),(21757,'tibia',243,8,215,322.0590109,61.0617588,67.8521575,1.8,61.0419944,68.0083703,-0.1786305,24.4875574,29.5278479,16788.3980671,22778.4761534,1.6946163,771.4235134,685.5889227,1211.0518264,25.2881677,29.9511233,0.2294627,91.0938009),(21758,'tibia',243,8,216,322.9549009,61.0434,67.8516406,1.8,61.0052133,67.9748878,-0.1801173,24.4255817,16.2307478,17023.5185382,22975.2876788,1.727428,1415.5409245,696.9544786,1580.138531,25.4854603,30.0651541,0.2140607,91.3948742),(21759,'tibia',243,8,217,323.657291,61.0979287,67.8393556,1.8,61.0007192,67.9741049,-0.1840336,24.4825283,20.1545833,17192.2443449,23022.625799,1.8064253,1142.302247,702.2250368,1504.9960113,25.5453344,30.1028175,0.2501244,91.3948742),(21760,'tibia',243,8,218,324.0536988,61.1069991,67.8512127,1.8,61.0053552,68.0051288,-0.1810064,24.0549972,31.8708775,17376.3521826,23170.0347662,1.7502722,726.9970773,722.3593509,1174.4063344,25.572703,30.2110257,0.2637799,91.6959476),(21761,'tibia',243,8,219,324.1256381,61.1197395,67.8495215,1.8,61.0197417,67.9736656,-0.1727802,24.6648868,16.5933593,17551.9957513,23290.5815053,1.5967021,1403.6085811,711.6187448,1527.5162504,25.6948129,30.2672309,0.2705703,92.1733856),(21762,'tibia',243,8,220,325.2295587,61.1390029,67.8611828,1.8,61.0240546,68.0559649,-0.1713331,24.4254274,23.9130729,17839.8814918,23572.4491495,1.5756781,985.7557529,730.3815499,1596.3646777,25.7119739,30.4143686,0.2330947,92.5991676),(21763,'tibia',243,8,221,326.1274127,61.153155,67.8450046,1.8,61.0244159,68.0182508,-0.1595738,24.6933992,21.0531881,18099.059344,23903.6835838,1.3723664,1135.3949587,732.9513133,1633.0251562,25.759811,30.4813524,0.2110933,92.7755323),(21764,'tibia',243,8,222,326.473897,61.1595804,67.8550978,1.8,61.0430236,68.1042603,-0.1400022,24.7224962,43.8810862,18442.9203813,24168.4112572,1.0595647,550.7705795,745.997501,937.0324789,25.759811,30.6710845,0.2382448,93.1496583),(21765,'tibia',243,8,223,327.7152412,61.1652016,67.8536208,1.8,61.0277679,68.1023763,-0.1285299,24.564257,22.9985126,18763.1966059,24514.7270281,0.8973475,1065.9266299,763.841405,1628.0150964,25.942738,30.8280576,0.2583782,93.8248576),(21766,'tibia',243,8,224,328.8117866,61.1852793,67.8628364,1.8,61.0333159,68.1137626,-0.1189179,24.7152354,32.3304494,19005.248171,24914.476749,0.7713341,770.6195628,768.9689325,1231.4982204,25.972702,30.878003,0.2366177,94.6764216),(21767,'tibia',243,8,225,329.8272321,61.266825,67.8234157,1.8,61.1415705,67.968337,-0.1151159,24.2467406,21.8324462,19162.3618159,25183.1720103,0.7252486,1153.4745919,790.3067122,1626.7506474,25.972702,30.9886234,0.2216496,95.1022036),(21768,'tibia',243,8,226,329.8810423,61.3084773,67.8234257,1.8,61.1555578,67.939896,-0.1079029,24.9807457,19.645006,19368.0088945,25477.6263774,0.6376555,1296.9009194,775.317483,1658.2482033,25.9348874,31.1963414,0.2201493,95.2269122),(21769,'tibia',243,8,227,329.2006131,61.3296518,67.8135293,1.8,61.2003837,67.8854613,-0.1100631,24.915897,16.6018101,19524.3097296,25837.0915496,0.6619703,1556.2816003,783.6085431,1656.3839287,26.0262421,31.3933027,0.2466234,95.4763296),(21770,'tibia',243,8,228,328.3808788,61.3573625,67.8084359,1.8,61.2301283,67.8832506,-0.1064071,22.5844557,16.8528456,19782.7969222,26256.1709068,0.6173458,1557.9666166,875.947473,1920.8918012,26.0980461,31.5229681,0.204018,95.9021116),(21771,'tibia',243,8,229,328.3492903,61.3808874,67.7724213,1.8,61.2820354,67.8100798,-0.0968405,22.6525861,16.8355992,20081.9321368,26782.6615477,0.5116117,1590.8350674,886.5183015,1926.7195623,26.4012322,31.7064678,0.2303217,97.1580609),(21772,'tibia',243,8,230,328.4773884,61.3941603,67.7632986,1.8,61.3161269,67.7666493,-0.0852115,21.9375019,18.4342267,20543.577384,27308.9467924,0.3965513,1481.426224,936.4592857,1976.2893075,26.5218664,31.8661632,0.2222921,98.0096249),(21773,'tibia',243,8,231,328.3774864,61.4037294,67.7259785,1.8,61.3241338,67.745991,-0.0752664,23.5688348,26.9532053,20905.2170878,27928.660991,0.30946,1036.1907107,886.9856014,1363.9017544,26.7384404,32.1070403,0.1934944,98.5601156),(21774,'tibia',243,8,232,328.2177999,61.4116429,67.6939331,1.8,61.3609472,67.7400295,-0.0649816,23.2665513,26.3344322,21354.2073883,28530.6113121,0.2306642,1083.3957255,917.8071618,1419.5934294,27.037157,32.3769348,0.2322202,99.4116796),(21775,'tibia',243,8,233,327.5295559,61.4717232,67.6535627,1.8,61.4422666,67.8242787,-0.0407452,24.3789832,22.9653198,21844.8807514,29136.1863308,0.0905762,1268.7037056,896.0538092,1556.4842576,27.2322902,32.6195978,0.1705134,100.3879523),(21776,'tibia',243,8,234,326.3969722,61.4767761,67.6513399,1.8,61.4331781,67.7591747,-0.041781,24.6021355,27.438356,22124.440689,29772.3455549,0.0949072,1085.0630259,899.2894397,1456.904588,27.462939,32.938304,0.1492095,101.467537),(21777,'tibia',243,8,235,325.1258799,61.478683,67.6299149,1.8,61.3550124,67.6221214,-0.0370175,23.1814654,25.8258334,22332.8227113,30400.5518223,0.0742192,1177.137299,963.3913254,1519.7839656,27.8165178,33.2491852,0.1672539,102.848195),(21778,'tibia',243,8,236,325.2257406,61.4810742,67.6204959,1.8,61.3601012,67.5351168,-0.0236501,21.9690426,20.0665605,22813.2997852,31210.5619284,0.0303126,1555.3518503,1038.429401,1815.9055504,28.0368073,33.5396241,0.1401017,103.5233943),(21779,'tibia',243,8,237,327.0770855,61.4518501,67.6227008,1.8,61.4205916,67.6142251,-0.0027469,16.4799106,18.2392123,23522.1223641,32285.9517057,0.000411,1770.1395825,1427.3209969,3038.5047543,28.3782975,33.9051894,0.1259126,105.1018137),(21780,'tibia',243,8,238,330.0837029,61.3775169,67.5997267,1.8,61.3159394,67.5532088,0.0205062,24.1186765,18.3414378,24312.2946393,33551.6187219,0.0231301,1829.2796384,1008.0277256,2268.54319,28.7668604,34.2774344,0.112029,106.8565977),(21781,'tibia',243,8,239,332.3435553,61.3184301,67.5427762,1.8,61.2266945,67.4184937,0.0486165,24.3447329,19.016232,25118.5263597,34888.6041159,0.1308161,1834.6749295,1031.7848418,2025.29838,29.2235608,34.623434,0.1418971,108.7360904),(21782,'tibia',243,8,240,335.5785024,61.2506799,67.4888517,1.8,61.1729009,67.3724293,0.0778646,17.6092,18.5227975,26121.2626479,36334.5957762,0.3384115,1961.6149147,1483.3872436,3296.187532,29.7177543,35.1237892,0.1093185,110.9683124),(21783,'tibia',243,8,241,336.6348206,61.2658601,67.4151257,1.8,61.1857948,67.311215,0.099758,17.7542349,36.6177553,26884.6500832,37586.6310341,0.5564964,1026.4591778,1514.2668944,1597.8440062,30.365433,35.6292027,0.1680956,112.5983878),(21784,'tibia',243,8,242,339.7860857,61.2396463,67.424393,1.8,61.124262,67.3811497,0.1095958,17.8313017,19.0611126,27767.0487482,39081.8197381,0.6774887,2050.3430509,1557.208171,3112.8555572,30.8501344,36.0848675,0.1719381,114.3531718),(21785,'tibia',243,8,243,344.9154067,61.2106859,67.4007772,1.8,61.0960018,67.4147764,0.1300851,17.5193691,19.9514252,28897.3407612,40909.181311,0.9673096,2050.4390456,1649.4509916,3494.6202275,31.4724397,36.6054916,0.1048769,116.4606851),(21786,'tibia',243,8,244,348.3158086,61.187495,67.3647442,1.8,61.032885,67.4374436,0.1464372,18.2011481,19.9492843,29882.4170888,42956.4663775,1.2360001,2153.2835824,1641.787481,3560.1135936,31.9579088,37.2194115,0.097392,118.8692719),(21787,'tibia',243,8,245,354.1462424,61.1608052,67.2791632,1.8,60.9378838,67.3821307,0.1502515,18.5529411,19.8533922,31092.1920664,45538.1514184,1.3225086,2293.7214464,1675.8632472,3728.3907644,32.5014802,37.9459919,0.118092,121.3509112),(21788,'tibia',243,8,246,359.9341553,61.1943121,67.2460988,1.8,61.0257356,67.2863931,0.155427,18.3322415,20.8076717,32422.1545036,48444.3747001,1.4375564,2328.197765,1768.5864812,3741.3042844,33.1373559,38.9351973,0.2317168,124.3099886),(21789,'tibia',243,8,247,370.5179112,61.2674087,67.1620567,1.8,61.1083299,67.2865526,0.1525924,18.8631497,36.9643502,33939.6221983,52388.3637216,1.4267586,1417.2672696,1799.255305,2143.9595285,33.5719034,39.9203267,0.2643811,127.5184833),(21790,'tibia',243,8,248,383.5196403,61.2955936,67.1211078,1.8,61.0689288,67.2438541,0.1451511,19.087493,35.8308667,35361.7500968,57111.9008552,1.3372872,1593.9302073,1852.6136471,2335.1796268,33.7106612,40.7429103,0.2589195,151.3888636),(21791,'tibia',243,8,249,399.0136992,61.3344536,66.9098346,1.8,61.2620537,66.9850391,0.1344384,19.2079975,35.6379862,36956.8523315,63044.0109958,1.1947174,1769.0116007,1924.0346261,2519.8661747,0.3010733,0.6021467,2.3561945,1.2042934),(21792,'tibia',243,8,250,413.630052,61.3311119,66.9000085,1.8,61.2425497,66.9671798,0.1246824,19.3038532,24.8208568,38320.8195285,68768.9902663,1.0661538,2770.613066,1985.1383638,4288.5558854,33.9740231,43.5308739,0.2319308,164.4722597),(21793,'tibia',243,8,251,426.8721419,61.347342,66.949835,1.8,61.2630305,66.9274584,0.1088024,19.5450204,24.2836868,39702.277525,74385.5780718,0.8388978,3063.1912911,2031.3244307,4697.327169,36.1326649,44.5924072,0.2067586,242.6464953),(21794,'tibia',243,8,252,443.6621792,61.4616141,66.9115627,1.8,61.3172739,66.9236851,0.0937914,19.7472533,24.6236646,41441.6629381,80553.2228357,0.6485647,3271.3742778,2098.6039097,4910.2800686,34.8733946,45.6808727,0.1827714,151.0789275),(21795,'tibia',243,8,253,466.5868885,61.5480896,66.8862144,1.8,61.3428204,66.9735482,0.0844421,26.0253697,24.8331902,43898.6292335,87430.1012894,0.5531801,3520.6955129,1686.7629455,3732.6442377,35.2954106,46.8771286,0.1412548,173.9213791),(21796,'tibia',243,8,254,525.9369416,61.4910342,66.9163251,1.8,61.3903081,66.937822,0.0820665,25.9546767,24.5081959,47363.0754521,96478.8640148,0.589032,3936.5959166,1824.8378133,4756.2976155,35.8965456,47.8791812,0.1607627,177.2545825),(21797,'tibia',243,8,255,577.6635997,61.5814258,66.8482069,1.8,61.4141251,66.8721616,0.0806095,25.9906336,26.1693242,50625.0783398,104581.0215425,0.6242455,3996.3210673,1947.8200954,4691.2123672,36.3529271,48.7190251,0.127065,152.6484841),(21798,'tibia',243,8,256,599.2152821,61.5116787,66.7233634,1.8,61.3555724,66.7917414,0.0781364,26.0225162,25.9862909,53464.1771498,112785.6856012,0.6084914,4340.199462,2054.5352661,4985.3430994,36.6243631,49.9477857,0.0725222,198.98719),(21799,'tibia',243,8,257,631.6387109,61.6034354,66.732187,1.8,61.3402015,66.7023891,0.0761934,26.1547434,27.4035567,57689.6569134,123190.8505693,0.6099748,4495.4329081,2205.7053285,5170.6657447,37.2364846,51.207256,0.0665682,177.1726671),(21800,'tibia',243,8,258,680.0283638,61.2830788,66.7856727,1.8,61.1576567,66.6920518,0.0490511,25.6239297,27.3099942,63291.671702,135424.6361192,0.2724739,4958.7940284,2470.0220675,6457.2177801,40.5515551,52.1561226,0.0899208,356.0839132),(21801,'tibia',243,8,259,778.5637271,60.9209577,67.1687372,1.8,60.9758743,66.8915938,0.0158019,24.6309134,27.5121652,70654.0474011,158094.8121319,0.0323982,5746.3602468,2868.5110591,7782.4249703,39.5348602,53.2163629,0.0881246,242.7926006),(21802,'tibia',243,8,260,850.5948178,61.0615388,67.6050015,1.8,61.0148745,67.2008976,-0.0165851,24.0449197,28.2104487,76027.0443477,172724.7621965,0.038993,6122.7229655,3161.8755826,8721.3129669,39.2912095,53.721558,0.1032175,219.0860511),(21803,'tibia',243,8,261,824.8203484,61.6013333,67.5866266,1.8,61.1896246,67.3717119,-0.0531489,24.2353153,28.9510605,78903.1465765,165168.2293007,0.387962,5705.0839039,3255.7095194,8414.7592737,39.384835,54.1747991,0.4038598,232.0838608),(21804,'tibia',243,8,262,723.1198485,62.8917967,67.3332444,1.8,62.2356351,67.2846129,-0.1717678,23.2969552,29.3879447,72955.6657652,133725.1743688,3.5210098,4550.341157,3131.5536852,6996.5318336,39.0746522,54.6499946,0.468874,196.4413608),(21805,'tibia',243,8,263,595.1530469,64.8006835,66.6631621,1.8,64.233336,66.7271153,-0.3654327,22.6252946,30.7369551,61778.1789777,92823.6978891,12.6669884,3019.9379752,2730.4916909,5001.8958947,39.2511585,55.1687629,0.5033504,176.7343512),(21806,'tibia',243,8,264,496.3420399,66.1390096,65.3464114,1.8,65.6803284,65.5460275,-0.6377996,23.3354717,30.7165201,47824.355036,66111.2871958,29.3285018,2152.3039356,2049.4273936,3613.6392009,0.425782,0.6732205,2.8198421,1.5053667),(21807,'tibia',243,8,265,416.4579748,67.2823434,63.5434895,1.8,66.6477797,63.849059,-0.7983972,23.3338373,30.3661819,35577.9976228,49320.7634629,35.6069871,1624.2003586,1524.7383923,2633.4221588,37.3153837,44.2982128,2.133471,270.1991373),(21808,'tibia',243,8,266,321.1650986,69.1505461,60.7406559,1.8,68.2751284,61.169259,-0.5644305,25.0207385,33.1264711,26686.5565125,30894.6557933,15.3171779,932.6274363,1066.5774913,1738.2082971,22.5931859,38.1953984,2.6480288,193.3664375),(21809,'tibia',243,8,267,263.6520108,70.2186536,58.2891968,1.8,69.6067065,58.4578717,0.0089362,33.3283862,19.8098743,14263.4143059,24830.0865327,0.003509,1253.41969,427.9659456,1139.1477196,1.80644,6.7891871,2.2896263,18.4813196),(21810,'tibia',243,8,268,216.6866543,70.8640036,56.8777668,1.8,70.4009407,56.7448993,0.0612003,28.1416521,19.5056727,4880.8665897,20949.0651228,0.1350968,1073.998595,173.439234,917.7705897,1.58697,6.173839,2.3318091,14.3696049),(21811,'tibia',243,8,269,180.3187465,71.1544206,56.9765073,1.8,70.7727847,56.5808298,0.06984,35.5510264,18.3919902,2578.546496,17282.7555647,0.1463498,939.6892531,72.5308594,509.9057211,0.8423458,4.4299747,2.1854593,9.3546701),(21812,'tibia',243,8,270,162.1773409,71.5666235,57.1138244,1.8,71.2801741,56.8988182,0.0661898,10.5884877,16.8335061,1954.4207264,14849.9609039,0.118246,882.1668407,184.5797788,988.625325,0.472556,1.5351788,2.1587989,3.2601507),(21813,'tibia',243,8,271,146.8342337,71.6522559,57.1156419,1.8,71.5465618,56.9877139,0.064927,9.8042249,15.5218509,1434.8663216,13186.0866203,0.1030187,849.5176713,146.3518364,917.733702,11.070332,16.0813752,3.0221637,47.3275125),(21814,'tibia',243,8,272,130.6324559,71.5029651,57.1034302,1.8,71.4146324,56.9918603,0.0587986,30.3271343,23.7794433,1036.1645294,11632.0647381,0.0751854,489.1647216,34.1662526,328.7183011,10.618611,14.8429462,2.9976672,43.7448918),(21815,'tibia',243,8,273,109.986662,71.7388293,57.2148266,1.8,71.5685797,57.1397466,0.0502516,7.0212401,15.295501,759.3978645,10095.7737584,0.0462512,660.0485841,108.1572281,706.9756823,9.7742754,13.6947007,2.9380996,39.3321037),(21816,'tibia',243,8,274,82.6628197,72.6517453,57.4147907,1.8,72.1708618,57.3245764,0.0244066,6.4413758,14.7861554,507.9833023,8114.8040612,0.0082051,548.8109564,78.8625467,580.228377,8.760144,12.2888091,2.896614,34.1710637),(21817,'tibia',243,8,275,45.3991456,75.4462291,57.6147081,1.8,74.2091081,57.6244625,-0.0153454,5.926123,16.6777564,242.2617106,4112.5652934,0.0017816,246.5898404,40.8803044,260.022305,6.1720035,8.0251718,2.7610863,22.6144309),(21818,'tibia',243,8,276,12.7737978,82.0898557,57.0226835,1.8,80.7095049,57.4637246,-0.5691813,28.6076975,18.0279504,64.8823543,112.9273933,0.6183776,6.2640173,2.2680034,5.3819507,1.6525378,2.12891,2.4980915,5.6901341),(21819,'tibia',243,8,277,1.2286401,83.4167736,57.7093816,1.8,83.5068295,59.1930706,1.5240812,2.60636,32.1370383,0.6653226,34.7093997,0.2043268,1.0800435,0.2552689,1.1005458,1.5381367,6.7657818,1.1493771,14.9414922),(21820,'tibia',243,8,278,0.0114817,75.3677431,91.3814245,1.8,75.363414,91.3834618,-0.1905824,0.0510788,0.661992,0.0000577,0.0018885,0.0000687,0.0028528,0.0011302,0.0029354,0.212891,0.6732205,2.8198421,1.329002),(21821,'tibia',243,8,279,0.6170051,45.0938395,64.6955348,1.8,45.1949852,64.8153302,0.7711521,19.9415632,40.269933,1.535184,24.1204901,0.0499523,0.5989702,0.0769841,0.6363108,3.3839191,3.7724381,1.8568478,11.6599448),(21822,'tibia',243,8,280,19.7402763,44.3447974,63.8235708,1.8,44.3268389,63.8099866,-0.8513917,5.8274411,5.8832296,135.8849106,139.1021133,1.8615149,23.6438357,23.3181098,45.8621706,11.709005,12.1776629,0.6365082,39.0826864),(21823,'tibia',243,8,281,45.8610238,44.3537236,63.7554709,1.8,44.3736255,63.7628227,-0.3007069,35.2701162,20.7003857,675.0978205,683.2515762,0.6705782,33.0067075,19.1407881,33.2405965,16.179716,16.6450268,1.2045408,53.6197932),(21824,'tibia',243,8,282,69.810147,44.4415302,63.7937222,1.8,44.6123255,63.9026571,0.4255268,9.683291,24.1419639,1479.3590588,1593.1465452,1.9826592,65.99076,152.7744084,125.8529325,19.16019,19.7254742,0.8082949,63.847424),(21825,'tibia',243,8,283,164.1420884,53.4206449,67.1633712,1.8,52.5298823,66.4206572,0.4058588,12.8815885,26.2538292,3696.0201854,24482.191966,4.2642281,932.5189,286.9227036,1061.651236,21.714882,22.0298471,0.8537845,71.7697801),(21826,'tibia',243,8,284,352.997988,61.2594801,67.8312772,1.8,58.3671683,66.4850895,0.3124087,16.7187603,29.0806546,12283.5986137,62746.2755085,5.5576617,2157.6637909,734.719465,2578.1624179,23.41801,23.938644,0.8988332,77.7609875),(21827,'tibia',243,8,285,533.5933808,65.8074599,66.9632702,1.8,61.3307331,65.9163137,0.1799129,15.5524592,34.1858316,24721.0589779,105138.8117378,2.8476902,3075.508385,1589.5273334,3795.7316498,25.121138,25.4989745,1.1856388,82.9006309),(21828,'tibia',243,8,286,602.92065,67.0437244,66.6125422,1.8,61.0390461,65.909115,0.1090108,25.6145752,35.9741877,29452.5816859,126144.03584,1.1893974,3506.5151965,1149.8368181,4325.2094815,26.3922121,26.7006395,0.6610432,87.1370542),(21829,'tibia',243,8,287,611.6828777,66.7340463,66.7344033,1.8,60.7065629,66.0890951,0.0979969,23.2931082,36.1190997,29995.7868911,129577.5523124,0.9759077,3587.5078112,1287.7537257,4416.8178914,27.250048,27.6266576,1.0726796,90.3455489),(21830,'tibia',243,8,288,616.9208218,66.4672437,66.8405801,1.8,60.4637201,66.2368933,0.0916749,23.245861,36.1276503,30342.2073174,131509.5963655,0.8617134,3640.1369926,1305.2735404,4470.6329384,27.9998206,28.3080995,0.5107508,92.577771),(21831,'tibia',243,8,289,618.8728652,66.3342819,66.9088836,1.8,60.4121106,66.340692,0.0870365,23.7105946,36.2229713,30464.8563709,131696.3500852,0.7793928,3635.7136212,1284.862608,4468.1914413,28.314503,28.8001475,0.8429262,94.1045343),(21832,'tibia',243,8,290,618.5740933,66.1785224,67.0082553,1.8,60.2878615,66.4515534,0.0847655,16.5511334,36.2290507,30413.7117662,131126.7467893,0.7389916,3619.381254,1837.5606691,4451.1103993,28.527394,29.0851494,0.8319965,94.9560983),(21833,'tibia',243,8,291,617.8941036,66.0145614,67.098676,1.8,60.1616675,66.5527795,0.0843112,16.5878249,36.2128962,30350.0581257,130630.1612215,0.7303058,3607.2829045,1829.6586973,4436.7459378,28.527394,29.2847028,0.525458,95.132463),(21834,'tibia',243,8,292,618.0232317,65.8632206,67.1765802,1.8,60.0126013,66.6393018,0.0851476,22.585642,36.1963206,30372.9192559,130471.2663711,0.7449871,3604.5450009,1344.7888404,4432.3974302,28.527394,29.2428863,0.836899,95.2571716),(21835,'tibia',243,8,293,618.494202,65.7160327,67.2391481,1.8,59.8355857,66.6898103,0.0868674,23.2186734,36.2161813,30411.5074789,130625.9967504,0.7759003,3606.8406996,1309.7866069,4440.1947719,28.740285,29.2250574,0.6770163,95.3088277),(21836,'tibia',243,8,294,618.7989482,65.5559644,67.2991229,1.8,59.6717046,66.7398745,0.0885913,23.0879919,36.2020516,30433.2557374,130811.6845906,0.8073171,3613.3776645,1318.1421693,4448.2616943,28.6600003,29.2591554,0.6667866,95.3604837),(21837,'tibia',243,8,295,620.4209884,65.3833884,67.3735491,1.8,59.4927986,66.8326157,0.0898735,23.2145168,36.1528581,30567.9277183,131241.8412375,0.8329701,3630.1926929,1316.7591637,4465.8817809,28.6600003,29.2467607,0.551655,95.609901),(21838,'tibia',243,8,296,621.4551672,65.1990802,67.4377431,1.8,59.2897136,66.8689019,0.092203,22.8159507,36.1143172,30641.3144273,131518.1901722,0.8780471,3641.718861,1342.9777657,4486.1525521,28.527394,29.2591554,0.6667866,95.0077543),(21839,'Metatarsal-PD-deer',243,10,1,0.062152,53.578045,82.757113,1.8,53.576389,82.756944,-0.272589,0.234979,3.516268,0.00093,0.13028,0.000751,0.037051,0.003959,0.037289,0.616679,2.371708,0.321751,5.011485),(21840,'Metatarsal-PD-deer',243,10,2,0.09229,40.000072,81.394977,1.8,40.14375,81.4125,0.096747,0.470391,14.60107,0.003404,8.979615,0.000144,0.614997,0.007237,0.615094,0,0,0,0),(21841,'Metatarsal-PD-deer',243,10,3,0.066019,53.826206,82.848889,1.8,53.806034,82.855603,-0.319459,0.21913,1.978003,0.000952,0.057922,0.001085,0.029283,0.004344,0.02976,0.63684,2.371708,0.321751,5.166815),(21842,'Metatarsal-PD-deer',243,10,4,0.056229,51.003659,82.605225,1.8,51.0375,82.605,0.069537,0.700242,19.555029,0.007213,4.057828,0.000045,0.207508,0.010301,0.207876,0.587063,2.019437,0.380506,4.261485),(21843,'Metatarsal-PD-deer',243,10,5,0.019442,53.028801,82.522295,1.8,53.020833,82.520833,0.079698,0.169773,23.667468,0.00031,1.358602,0.000021,0.057404,0.001828,0.057417,0,0,0,0),(21844,'Metatarsal-PD-deer',243,10,6,0.019964,30.171391,80.855023,1.8,30.166667,80.854167,0.17586,0.110293,0.779657,0.000161,0.006379,0.000102,0.008182,0.001457,0.008388,0.375,0.676041,2.55359,1.43566),(21845,'Metatarsal-PD-deer',243,10,7,0.030884,64.693321,80.837142,1.8,64.6875,80.839286,-0.174266,0.13452,3.455382,0.000261,0.167873,0.000155,0.048583,0.001942,0.048625,0,0,0,0),(21846,'Metatarsal-PD-deer',243,10,8,0.050518,51.475353,80.80048,1.8,51.432065,80.796196,0.034069,0.908607,27.872103,0.008674,16.451709,0.00001,0.590257,0.009547,0.590558,0.1875,0.592927,2.819842,1.170495),(21847,'Metatarsal-PD-deer',243,10,9,2.447216,60.05817,64.527549,1.8,58.817402,65.072304,-0.436079,1.477808,39.506154,0.838077,47.197057,0.072769,1.194676,0.567108,1.21504,2.519068,5.776096,0.624023,13.515611),(21848,'Metatarsal-PD-deer',243,10,10,15.077109,60.210236,64.690614,1.8,59.996449,64.891572,-0.569315,5.69398,38.456619,13.439777,74.521073,0.730187,1.937796,2.360349,2.262608,4.615219,8.528674,0.581905,21.572592),(21849,'Metatarsal-PD-deer',243,10,11,26.747536,60.360921,65.00849,1.8,60.285358,65.108421,-0.608533,3.695345,34.448506,44.7755,156.214202,1.456851,4.534716,12.116731,5.816879,6.121613,10.661152,0.597758,26.913582),(21850,'Metatarsal-PD-deer',243,10,12,35.119741,60.357476,65.489283,1.8,59.972355,65.751658,-0.585144,11.252038,35.223993,82.751472,298.005504,1.785588,8.460299,7.354354,10.766438,6.982549,11.626512,0.659629,29.538582),(21851,'Metatarsal-PD-deer',243,10,13,42.963217,60.491379,65.983124,1.8,60.547952,66.336045,-0.49731,21.023216,34.437395,172.411729,355.115255,1.629662,10.311908,8.201016,15.3178,7.967891,12.152835,0.665103,32.428747),(21852,'Metatarsal-PD-deer',243,10,14,51.64321,60.036646,66.475429,1.8,58.712027,66.692747,-0.132235,15.849725,30.127509,263.807019,900.145006,0.149631,29.877843,16.644264,35.509048,3.528128,4.213538,1.00748,14.595116),(21853,'Metatarsal-PD-deer',243,10,15,73.881967,57.503404,67.089904,1.8,56.605724,67.138452,-0.027263,6.085575,18.137957,461.430322,4077.175695,0.00915,224.786931,75.823614,250.222919,5.748552,7.75126,1.009633,22.011932),(21854,'Metatarsal-PD-deer',243,10,16,95.347564,56.125056,67.241627,1.8,54.950422,67.245237,0.018707,18.347539,17.329245,701.292153,6464.750862,0.00556,373.054386,38.222683,378.870708,8.029583,9.787787,0.934958,35.417708),(21855,'Metatarsal-PD-deer',243,10,17,123.683363,54.245925,67.129703,1.8,53.490178,67.088508,0.028649,18.455739,25.078759,1097.868671,9513.626652,0.016915,379.349975,59.486574,374.691142,10.853773,13.131695,0.755104,42.523864),(21856,'Metatarsal-PD-deer',243,10,18,149.00821,53.062584,67.01306,1.8,52.492964,66.987405,0.037151,18.522936,16.547219,1553.890789,11775.26358,0.034262,711.615873,83.89009,674.775984,13.214159,30.364003,0.154997,95.237067),(21857,'Metatarsal-PD-deer',243,10,19,177.061097,52.056778,66.94306,1.8,51.53822,66.947306,0.029185,19.055891,18.523566,2077.493265,14448.948834,0.025129,780.030629,109.02105,630.541146,13.829664,32.119467,0.164189,124.858834),(21858,'Metatarsal-PD-deer',243,10,20,213.897795,51.200091,66.867772,1.8,51.017597,66.849283,-0.000004,18.069753,22.137659,2789.865915,19610.084031,0.000002,885.824644,154.394243,803.492001,17.33943,38.942265,0.273009,198.327056),(21859,'Metatarsal-PD-deer',243,10,21,260.202848,50.946532,66.648347,1.8,50.674153,66.671995,-0.066543,18.788409,27.548446,3896.784399,29209.944533,0.191745,1060.311888,207.40364,1038.68943,18.538083,42.060643,0.289322,187.06925),(21860,'Metatarsal-PD-deer',243,10,22,293.999606,49.946662,66.514706,1.8,49.542943,66.475158,-0.085896,19.35955,26.301425,4956.384081,38442.084491,0.360638,1461.597043,256.017521,1381.445365,20.373931,44.844262,0.292658,192.73194),(21861,'Metatarsal-PD-deer',243,10,23,328.970795,48.884998,66.174535,1.8,48.640065,66.030458,-0.080306,19.718633,23.684464,6257.990938,48942.431016,0.352836,2066.43611,317.364342,2192.511516,20.201054,47.389675,0.231544,162.962649),(21862,'Metatarsal-PD-deer',243,10,24,363.633835,48.358178,65.563632,1.8,48.135603,65.257125,-0.074673,26.432399,24.570915,8514.533692,59028.982636,0.337312,2402.392572,322.124894,2534.952024,21.738226,48.834302,0.204926,166.152435),(21863,'Metatarsal-PD-deer',243,10,25,404.599773,48.490156,63.804889,1.8,48.106153,63.537299,-0.082055,25.821348,25.183923,18238.101892,64968.119523,0.453009,2579.74577,706.318749,3088.178235,25.150642,49.020763,0.184643,192.846347),(21864,'Metatarsal-PD-deer',243,10,26,464.220043,48.935691,61.618689,1.8,48.479313,61.156655,-0.123924,24.834035,25.893171,31619.899862,67589.776324,1.182115,2610.332166,1273.248599,3348.330088,38.563255,48.957252,0.092047,276.478598),(21865,'Metatarsal-PD-deer',243,10,27,567.567464,49.361942,58.950472,1.8,48.764536,58.692959,-0.260276,28.123329,27.161105,47987.086224,74898.05051,6.264789,2757.547989,1706.308901,3677.443443,38.858221,48.467934,0.061936,250.508036),(21866,'Metatarsal-PD-deer',243,10,28,697.023068,49.197449,56.689586,1.8,47.607233,57.008395,-0.29404,31.93562,29.752596,67556.851863,89702.447438,9.75792,3014.945244,2115.407584,4194.539701,38.913812,47.93147,0.070471,239.700609),(21867,'Metatarsal-PD-deer',243,10,29,766.045984,48.293175,55.82269,1.8,47.024888,56.517418,-0.113447,26.000748,26.022734,76896.365497,99545.54874,1.636165,3825.330145,2957.467405,4852.596366,39.581453,47.107673,0.043797,211.66526),(21868,'Metatarsal-PD-deer',243,10,30,795.400142,47.141947,55.657662,1.8,46.774739,56.706298,0.132471,31.064125,25.286273,77974.073004,104733.858146,2.312765,4141.925428,2510.100452,4903.747686,38.570201,46.545718,3.097267,189.050852),(21869,'Metatarsal-PD-deer',243,10,31,773.991829,46.554991,56.150089,1.8,46.497147,56.972236,0.238645,23.111305,23.994774,78071.902818,100412.914827,7.20823,4184.782694,3378.082853,6607.743393,41.10229,45.745773,3.014187,246.930871),(21870,'Metatarsal-PD-deer',243,10,32,769.392763,46.288059,56.602114,1.8,46.040633,57.316815,0.275506,24.31512,24.179672,79810.074073,96992.758298,9.48952,4011.334718,3282.322828,7041.419637,38.868048,45.661544,2.997373,211.797172),(21871,'Metatarsal-PD-deer',243,10,33,767.468491,46.468648,56.903637,1.8,45.892761,57.516594,0.308256,32.115213,24.947331,82095.448393,92482.825685,11.774205,3707.123034,2556.27909,5280.737485,41.096586,45.202669,2.898626,245.025987),(21872,'Metatarsal-PD-deer',243,10,34,755.774446,46.533465,57.109724,1.8,45.73679,57.590235,0.454068,32.189791,24.173663,81575.725774,86956.697974,24.234185,3597.166734,2534.211108,5231.793367,41.446345,45.244647,2.562785,244.776434),(21873,'Metatarsal-PD-deer',243,10,35,749.561538,46.22108,57.300096,1.8,45.550394,57.50211,0.733904,32.323447,23.027166,79002.751959,84875.099905,56.041852,3685.868304,2444.131424,5031.030456,41.719229,45.375387,2.123263,277.580181),(21874,'Metatarsal-PD-deer',243,10,36,748.038398,45.818689,57.247294,1.8,45.374641,57.315745,1.013988,31.111539,23.418427,78282.934045,85452.502326,89.853087,3648.942828,2516.202524,4970.798991,41.204175,45.448546,2.783305,269.413366),(21875,'Metatarsal-PD-deer',243,10,37,757.445998,46.219266,56.833759,1.8,45.548656,57.056464,1.56258,22.742309,22.650836,81825.531792,85684.462042,126.232478,3782.838763,3597.943069,6712.939129,41.626155,45.787638,2.495635,287.000676),(21876,'Metatarsal-PD-deer',243,10,38,736.920884,46.316784,56.494283,1.8,45.705175,56.95573,-0.970174,23.22812,36.798783,80480.171213,82721.630732,83.591179,2247.944754,3464.773385,4279.058699,40.196299,45.056605,2.771132,230.219007),(21877,'Metatarsal-PD-deer',243,10,39,719.670149,46.127314,56.133906,1.8,45.60412,56.842554,0.091063,28.370511,23.112982,77003.699978,82124.622068,0.991888,3553.181625,2714.21621,4582.940405,40.587048,45.112749,2.494767,233.521861),(21878,'Metatarsal-PD-deer',243,10,40,720.890295,45.936569,56.099828,1.8,45.506415,56.878162,-0.182788,31.667896,27.558323,75555.849164,82692.748175,3.969833,3000.645129,2385.881531,4231.783167,41.04376,44.795237,2.101884,236.275541),(21879,'Metatarsal-PD-deer',243,10,41,713.954851,46.085208,56.367696,1.8,45.579518,57.033476,-0.366743,24.183787,31.683963,72201.958984,83304.085672,15.299742,2629.219264,2985.552191,4456.570006,41.355745,44.795237,2.101884,239.920278),(21880,'Metatarsal-PD-deer',243,10,42,684.765266,46.525767,56.631426,1.8,45.926713,57.10485,-0.312608,25.154965,25.096959,68408.75746,80375.843587,10.794378,3202.612904,2719.493257,4613.165309,1.593388,2.855915,1.975688,8.833631),(21881,'Metatarsal-PD-deer',243,10,43,697.51207,46.496653,56.204272,1.8,46.070848,57.051295,0.161475,30.447302,22.489719,71721.916971,82255.660345,3.004923,3657.478351,2355.608301,4795.394345,0.8904,1.728665,1.352127,4.681981),(21882,'Metatarsal-PD-deer',243,10,44,704.627738,46.756661,55.933416,1.8,46.114423,57.059202,0.087151,30.19658,31.349816,73411.797658,84222.906165,0.889712,2686.551871,2431.12957,4020.141943,0.771866,1.612936,2.521343,3.931981),(21883,'Metatarsal-PD-deer',243,10,45,695.312312,46.668556,56.090029,1.8,46.16954,57.194571,0.063397,29.771339,31.046714,73027.447984,82706.77561,0.465147,2663.946191,2452.944716,3961.405493,0.375,2.281036,1.405648,4.96599),(21884,'Metatarsal-PD-deer',243,10,46,682.110192,46.511369,56.283536,1.8,46.140466,57.345738,-0.018371,29.311211,22.22846,71096.372292,79250.332105,0.038363,3565.264251,2425.569224,4677.828048,0.5625,0.795495,2.356194,1.81066),(21885,'Metatarsal-PD-deer',243,10,47,659.709631,46.336752,56.526541,1.8,46.095726,57.502261,-0.136114,28.847175,22.914461,68550.472345,75071.818963,2.024515,3276.176517,2376.33224,4399.733167,1.288386,2.096314,1.75065,6.867641),(21886,'Metatarsal-PD-deer',243,10,48,638.310533,46.058475,56.827278,1.8,45.962104,57.66159,-0.438087,28.697552,22.788,65533.71544,71053.220077,19.144281,3118.010339,2283.599534,4647.808878,38.800153,42.560848,2.36554,190.823823),(21887,'Metatarsal-PD-deer',243,10,49,610.134407,46.017152,57.130168,1.8,45.962955,58.009663,-0.758258,31.631202,30.815699,61174.312734,67337.104415,48.085998,2185.155813,1933.986354,3942.920353,38.819195,42.353839,2.302953,200.278774),(21888,'Metatarsal-PD-deer',243,10,50,574.832216,46.07094,57.527081,1.8,45.975698,58.372972,-0.971179,32.116814,31.306137,55783.08173,62877.778442,65.294769,2008.480889,1736.880918,3516.897969,38.209649,41.468032,1.060624,164.057765),(21889,'Metatarsal-PD-deer',243,10,51,541.188995,46.139641,57.853507,1.8,46.036694,58.704128,-1.0878,20.987404,31.572971,50518.547376,58560.256854,70.742434,1854.759144,2407.088895,3269.793282,0.78088,1.352082,0.982794,3.136485),(21890,'Metatarsal-PD-deer',243,10,52,513.736577,46.251571,58.121025,1.8,46.183581,58.912153,-1.203804,19.886675,24.309337,46043.920993,54724.540108,74.599297,2251.173706,2315.315216,3627.426816,1.368501,5.824584,1.635223,15.326272),(21891,'Metatarsal-PD-deer',243,10,53,487.60582,46.32939,58.343001,1.8,46.315616,59.049365,-1.266718,18.742628,24.547862,42313.293696,51269.895985,73.982087,2088.568709,2257.5966,3339.282095,1.307535,4.531142,1.144169,11.988961),(21892,'Metatarsal-PD-deer',243,10,54,465.694251,46.351313,58.500714,1.8,46.333769,59.23207,-1.285697,34.825356,28.708963,39334.577539,48422.894769,71.476072,1686.682155,1129.480982,2346.611332,1.125,5.148574,1.753907,13.314786),(21893,'Metatarsal-PD-deer',243,10,55,449.764304,46.401667,58.73992,1.8,46.411756,59.389725,-1.325216,17.880125,28.215305,37364.194057,46399.968379,70.530031,1644.496406,2089.705362,2878.249058,1.569098,10.000977,1.458069,27.307427),(21894,'Metatarsal-PD-deer',243,10,56,433.662209,46.369296,58.848767,1.8,46.414837,59.467354,-1.322319,17.463197,28.116974,35231.288903,43987.023506,67.905667,1564.4295,2017.459319,2765.080603,1.485402,7.028124,1.410034,19.561107),(21895,'Metatarsal-PD-deer',243,10,57,418.650863,46.410373,58.862046,1.8,46.494621,59.508069,-1.298226,17.801364,28.247364,33050.056032,41325.990122,64.718348,1463.003419,1856.602433,2613.071238,1.741512,7.954951,1.428899,25.860728),(21896,'Metatarsal-PD-deer',243,10,58,407.671065,46.479979,58.959606,1.8,46.608672,59.584726,-1.336955,17.536457,20.020658,31523.245223,39282.610429,64.297037,1962.103836,1797.583421,3266.082995,1.963287,11.462064,1.505316,35.133699),(21897,'Metatarsal-PD-deer',243,10,59,398.666325,46.555646,59.050663,1.8,46.721557,59.730108,-1.37962,23.342159,25.728401,30341.482805,37464.294406,64.0454,1456.14548,1299.857612,1951.856078,2.487812,11.087895,1.503103,36.387378),(21898,'Metatarsal-PD-deer',243,10,60,393.810618,46.626285,59.159797,1.8,46.824474,59.823415,-1.408554,19.797783,25.89354,29461.993075,36276.362087,63.922516,1400.981189,1488.146076,2162.415146,2.032227,10.933035,1.467715,34.182873),(21899,'Metatarsal-PD-deer',243,10,61,389.210103,46.67175,59.271252,1.8,46.882496,59.959573,-1.431921,29.310293,25.896177,28655.447445,35308.318751,63.625292,1363.45682,977.658165,1842.587636,2.131618,13.769446,1.461643,41.069359),(21900,'Metatarsal-PD-deer',243,10,62,386.974368,46.675771,59.388313,1.8,46.904081,60.001082,-1.429887,17.48184,19.786341,27892.884543,34660.791836,63.223593,1751.753519,1595.534817,2769.140606,0.375,0.53033,2.356194,1.06066),(21901,'Metatarsal-PD-deer',243,10,63,382.505433,46.663528,59.451576,1.8,46.889091,60.051098,-1.406721,30.951319,27.001815,27036.644666,33870.22009,62.050022,1254.368251,873.521556,1726.964072,1.285711,4.638494,1.815775,11.083631),(21902,'Metatarsal-PD-deer',243,10,64,374.461268,46.556801,59.362252,1.8,46.7833,60.042997,-1.285524,33.023095,28.481333,25464.424929,32379.700834,57.467533,1136.874495,771.109579,1632.156093,1.251823,4.377232,1.742987,12.500446),(21903,'Metatarsal-PD-deer',243,10,65,366.530007,46.4103,59.205715,1.8,46.542158,59.78079,-1.125634,35.188088,29.686417,23123.589269,31101.073895,49.761304,1047.653323,657.14253,1508.359316,1.875,12.380681,1.60109,34.220563),(21904,'Metatarsal-PD-deer',243,10,66,362.142656,46.302119,59.208104,1.8,46.257116,59.592016,-1.058365,20.477967,28.333664,21581.949881,30704.655955,45.847765,1083.681108,1053.910787,1833.305576,2.062186,12.210555,1.632257,38.929194),(21905,'Metatarsal-PD-deer',243,10,67,360.793498,46.290232,59.29557,1.8,46.274869,59.676877,-1.04226,21.040619,28.412276,20920.213758,30407.449702,44.841307,1070.222252,994.277497,1796.948532,2.082593,11.885193,1.460139,35.216883),(21906,'Metatarsal-PD-deer',243,10,68,359.732056,46.325425,59.401848,1.8,46.31939,59.728375,-1.04778,16.08466,18.570879,20502.837047,30038.45449,44.996763,1617.503123,1274.682621,2624.17655,0.1875,0.265165,2.356194,0.53033),(21907,'Metatarsal-PD-deer',243,10,69,357.40973,46.446423,59.480791,1.8,46.455454,59.804995,-1.06292,20.901752,20.167313,20314.896452,29263.566701,45.479828,1451.039418,971.923127,2249.648392,1.875,13.505207,1.543026,37.247213),(21908,'Metatarsal-PD-deer',243,10,70,350.585604,46.585019,59.434516,1.8,46.629407,59.787639,-1.069037,15.758158,19.132725,19729.084795,28070.09913,44.914056,1467.125015,1251.991822,2453.537338,1.272785,7.708052,1.497756,18.254126),(21909,'Metatarsal-PD-deer',243,10,71,346.160913,46.634736,59.419157,1.8,46.624745,59.776091,-1.053689,15.859135,18.181831,19066.033001,27318.148691,43.593232,1502.4971,1202.211422,2321.549317,1.590697,7.186413,1.701624,19.186107),(21910,'Metatarsal-PD-deer',243,10,72,341.557596,46.673886,59.388055,1.8,46.67934,59.666741,-1.039631,15.653526,18.143502,18449.4634,26486.036738,42.320045,1459.808384,1178.61393,2402.150384,0.736456,6.198853,1.510264,13.15165),(21911,'Metatarsal-PD-deer',243,10,73,338.191726,46.706812,59.359846,1.8,46.698487,59.743003,-1.026927,17.360428,21.53886,17767.061699,25835.292217,41.273177,1199.47352,1023.423007,1644.044712,1.422991,8.685926,1.331053,21.042262),(21912,'Metatarsal-PD-deer',243,10,74,334.400827,46.655753,59.380715,1.8,46.644181,59.748045,-1.008791,18.129322,20.527438,16982.666987,25353.744031,39.907104,1235.114905,936.751355,1595.060429,0.1875,0.419263,2.677945,0.795495),(21913,'Metatarsal-PD-deer',243,10,75,332.167095,46.664201,59.426388,1.8,46.60201,59.768172,-1.005309,16.423143,29.908688,16541.903991,24980.277489,39.466378,835.218094,1007.231332,1388.284741,1.5,8.071216,1.617274,21.636932),(21914,'Metatarsal-PD-deer',243,10,76,330.788363,46.67097,59.48077,1.8,46.608433,59.813142,-0.996545,19.083437,19.438592,16132.435132,24714.042313,38.86359,1271.390575,845.363178,1540.031796,0.692634,4.721129,1.451367,10.617641),(21915,'Metatarsal-PD-deer',243,10,77,329.46946,46.695883,59.533238,1.8,46.62969,59.830558,-0.990552,34.6074,30.437753,15857.413363,24363.935314,38.407682,800.451171,458.208744,1159.115797,0.615288,3.606635,1.414194,7.90165),(21916,'Metatarsal-PD-deer',243,10,78,329.575163,46.728387,59.626039,1.8,46.654072,59.906364,-0.992584,34.210202,18.40447,15757.768686,24183.87115,38.522232,1314.021628,460.61606,1163.784611,0.665012,3.768703,1.471128,8.27665),(21917,'Metatarsal-PD-deer',243,10,79,332.27608,46.793562,59.803024,1.8,46.729359,60.045757,-1.012415,33.463171,32.478775,15982.223677,24187.84198,39.834211,744.727649,477.606365,1192.487523,24.889833,32.653544,1.060909,96.096902),(21918,'Metatarsal-PD-deer',243,10,80,334.014194,46.841808,59.922806,1.8,46.772621,60.180311,-1.033429,33.563022,33.997503,16043.747114,24176.793818,41.082805,711.13439,478.018557,1101.56131,0.840174,5.466517,1.467715,12.272971),(21919,'Metatarsal-PD-deer',243,10,81,334.948082,46.909891,59.950227,1.8,46.808353,60.237459,-1.039946,15.578452,34.641608,15817.715673,23938.043588,41.516481,691.019995,1015.35866,1046.664877,24.736956,32.372406,1.089016,95.657562),(21920,'Metatarsal-PD-deer',243,10,82,334.016612,46.927689,60.020567,1.8,46.825445,60.352459,-1.043423,28.792958,31.774028,15651.759045,23674.695387,41.569721,745.095818,543.59678,1199.986191,1.19675,5.117754,1.717875,12.738961),(21921,'Metatarsal-PD-deer',243,10,83,333.937479,46.968102,60.092404,1.8,46.923301,60.490246,-1.054141,32.162874,31.573266,15609.02165,23487.101881,42.075483,743.892054,485.311774,1193.833966,1.303072,6.198853,1.510264,14.632806),(21922,'Metatarsal-PD-deer',243,10,84,334.503643,47.011304,60.170067,1.8,46.97233,60.593486,-1.064401,32.648747,30.053382,15646.596042,23413.272264,42.635151,779.056166,479.240319,1184.469192,0.75,5.637486,1.504228,12.181981),(21923,'Metatarsal-PD-deer',243,10,85,334.748864,47.04203,60.22969,1.8,46.988806,60.548319,-1.061944,32.840312,18.864987,15630.461553,23323.240268,42.549923,1236.324208,475.953509,1176.682949,0.642068,3.052279,1.385448,6.931981),(21924,'Metatarsal-PD-deer',243,10,86,336.085217,47.091682,60.323004,1.8,47.040686,60.742276,-1.071968,33.037867,29.686007,15742.375372,23266.737577,43.194608,783.761111,476.494906,1171.014289,0.701001,6.011707,1.508378,13.087311),(21925,'Metatarsal-PD-deer',243,10,87,336.069109,47.132688,60.367749,1.8,47.136626,60.755367,-1.072987,32.97611,19.769726,15692.591186,23132.373057,43.24043,1170.090723,475.87757,1167.570358,0.5625,3.209483,1.453688,6.99632),(21926,'Metatarsal-PD-deer',243,10,88,336.458555,47.149995,60.406158,1.8,47.135235,60.74222,-1.06986,33.76239,19.789603,15641.378107,23129.916781,43.143095,1168.79132,463.27816,1142.967006,24.285533,31.908071,1.159732,95.941572),(21927,'Metatarsal-PD-deer',243,10,89,336.479915,47.21144,60.390159,1.8,47.205827,60.71789,-1.070839,33.62302,19.607737,15415.821623,22978.208032,43.192069,1171.894982,458.49009,1136.776624,1.387844,9.953407,1.62734,21.848796),(21928,'Metatarsal-PD-deer',243,10,90,335.652017,47.206457,60.418631,1.8,47.138562,60.751843,-1.070932,14.588979,19.506948,15167.263399,22903.613872,43.09017,1174.125932,1039.638407,1602.735053,0.375,1.365021,1.292497,2.93566),(21929,'Metatarsal-PD-deer',243,10,91,334.792383,47.238118,60.468662,1.8,47.173771,60.782632,-1.069685,14.69214,17.262596,15083.869912,22721.497296,42.921222,1316.227121,1026.662547,2062.590417,0.719533,5.466517,1.467715,11.962311),(21930,'Metatarsal-PD-deer',243,10,92,334.240536,47.264779,60.519471,1.8,47.232545,60.876196,-1.071833,36.445023,23.870521,15139.224377,22663.925198,42.951202,949.452492,415.398947,1037.080647,1.299727,2.281036,1.735945,6.757806),(21931,'Metatarsal-PD-deer',243,10,93,333.031364,47.264278,60.535251,1.8,47.271543,60.900143,-1.06769,36.202259,27.006952,14944.907106,22615.288514,42.602044,837.387652,412.816982,1037.212107,0.5625,1.912132,1.373401,4.37132),(21932,'Metatarsal-PD-deer',243,10,94,331.991623,47.263433,60.510175,1.8,47.219846,60.793519,-1.057928,14.549924,21.557625,14659.46427,22596.223889,42.009897,1048.177798,1007.528578,1568.494568,1.055352,3.052279,1.756144,8.212311),(21933,'Metatarsal-PD-deer',243,10,95,330.920135,47.254115,60.514931,1.8,47.183,60.839354,-1.04671,22.506107,29.043251,14404.284902,22608.855765,41.341744,778.454705,640.016713,1259.769692,0.5625,1.325825,1.712693,3.09099),(21934,'Metatarsal-PD-deer',243,10,96,329.749165,47.2559,60.536665,1.8,47.181971,60.822845,-1.041684,23.4101,28.89785,14181.125219,22610.533059,40.955385,782.429599,605.769538,1264.895839,0.375,2.83739,1.438245,6.24632),(21935,'Metatarsal-PD-deer',243,10,97,329.000199,47.30395,60.478489,1.8,47.233967,60.793391,-1.03412,13.756605,27.401588,13869.308634,22530.567015,40.499374,822.235805,1008.192691,1328.299271,0.5625,1.140518,1.735945,2.71599),(21936,'Metatarsal-PD-deer',243,10,98,325.422198,47.274293,60.435332,1.8,47.181601,60.714259,-1.011565,15.103178,17.950001,13411.456475,22360.854869,38.971103,1245.729989,887.98905,1549.43013,23.999039,32.591038,1.199905,129.037135),(21937,'Metatarsal-PD-deer',243,10,99,323.355842,47.28126,60.4552,1.8,47.197405,60.751045,-1.003757,17.508303,17.911025,13190.27165,22159.237218,38.343737,1237.184205,753.37238,1533.872416,0.534105,0.956066,1.768192,2.34099),(21938,'Metatarsal-PD-deer',243,10,100,321.077141,47.283899,60.513327,1.8,47.176304,60.837503,-0.996626,16.164032,17.551433,12999.635038,21960.059696,37.726615,1251.183297,804.232179,1550.017123,0.5625,1.140518,1.735945,2.71599),(21939,'Metatarsal-PD-deer',243,10,101,320.227884,47.294059,60.584128,1.8,47.211037,60.862218,-0.991054,18.713961,17.365909,12905.884446,21773.904783,37.354886,1253.830428,689.639378,1486.06326,0.75,1.728665,1.352127,4.15165),(21940,'Metatarsal-PD-deer',243,10,102,319.110298,47.318234,60.669955,1.8,47.227258,61.023671,-0.98601,20.64547,17.364348,12892.915955,21558.391991,36.978084,1241.531888,624.491288,1433.951505,0.5625,1.365021,1.292497,3.09099),(21941,'Metatarsal-PD-deer',243,10,103,319.613065,47.360131,60.749926,1.8,47.268881,61.071795,-0.982918,29.653862,22.423528,12921.749128,21471.393047,36.884518,957.538558,435.752657,1154.796446,0.5625,1.957557,1.27934,4.37132),(21942,'Metatarsal-PD-deer',243,10,104,320.056001,47.399229,60.809322,1.8,47.296474,61.161174,-0.985009,28.748812,21.634715,12950.365348,21422.460689,37.038527,990.189187,450.466101,1186.455405,0.516389,1.511673,1.695151,3.46599),(21943,'Metatarsal-PD-deer',243,10,105,320.997752,47.463762,60.826488,1.8,47.354055,61.179968,-0.98491,15.39927,23.835256,12932.327255,21277.659575,37.142623,892.696903,839.80133,1376.956945,0.601777,4.889402,1.494024,10.837311),(21944,'Metatarsal-PD-deer',243,10,106,320.644229,47.504266,60.856786,1.8,47.401044,61.142449,-0.982415,14.972114,25.532432,12907.39156,21221.047847,36.978717,831.140876,862.095453,1324.762021,0.653008,2.319247,1.325818,5.431981),(21945,'Metatarsal-PD-deer',243,10,107,321.399716,47.551497,60.889257,1.8,47.447071,61.250985,-0.986274,13.724378,17.624832,12940.635923,21293.950893,37.256441,1208.17892,942.894155,1859.051102,0.794388,5.253347,1.606495,11.852476),(21946,'Metatarsal-PD-deer',243,10,108,321.986911,47.602916,60.945251,1.8,47.489581,61.382037,-0.988435,20.803157,28.661137,12988.852664,21365.870386,37.431116,745.464861,624.36929,1183.037506,0.786946,4.008292,1.382575,8.806981),(21947,'Metatarsal-PD-deer',243,10,109,321.110433,47.642546,60.968991,1.8,47.564772,61.348561,-0.984476,21.73922,28.006656,12975.940608,21348.939303,37.134275,762.280921,596.890796,1213.721395,0.858648,7.314903,1.596432,16.178301),(21948,'Metatarsal-PD-deer',243,10,110,321.000405,47.673336,60.988112,1.8,47.585887,61.32765,-0.980716,22.522169,17.043026,12950.725568,21264.314721,36.935811,1247.684258,575.021244,1385.467303,0.1875,0.265165,2.356194,0.53033),(21949,'Metatarsal-PD-deer',243,10,111,320.553686,47.692966,61.022444,1.8,47.587168,61.362513,-0.97457,22.96407,25.861573,12898.605528,21150.884233,36.580018,817.849889,561.686387,1316.385339,23.766694,31.535694,1.128422,91.744426),(21950,'Metatarsal-PD-deer',243,10,112,318.900224,47.703236,61.041846,1.8,47.592272,61.372449,-0.964537,35.022398,17.216315,12769.106974,20986.645803,35.893853,1218.997521,364.598311,958.648003,0.500431,1.325825,1.712693,3.24632),(21951,'Metatarsal-PD-deer',243,10,113,317.380728,47.739946,61.026909,1.8,47.642563,61.374238,-0.956721,35.737649,20.498114,12586.367838,20722.268769,35.334546,1010.935394,352.187906,924.959171,0.265165,0.53033,2.356194,1.06066),(21952,'Metatarsal-PD-deer',243,10,114,315.004741,47.737476,61.052801,1.8,47.604761,61.426711,-0.949983,35.192962,28.069044,12367.083258,20550.336761,34.736022,732.135247,351.407853,929.050087,0.75,4.328774,1.484058,10.799621),(21953,'Metatarsal-PD-deer',243,10,115,313.147628,47.733516,61.074804,1.8,47.609776,61.476276,-0.944766,33.44795,30.027118,12227.408753,20342.114188,34.273103,677.458087,365.56527,970.25649,0.1875,0.265165,2.356194,0.53033),(21954,'Metatarsal-PD-deer',243,10,116,311.425185,47.740696,61.087079,1.8,47.591939,61.437783,-0.937698,33.978442,28.495567,12077.28354,20192.204279,33.735447,708.608618,355.439587,945.365097,23.657381,31.050928,1.06663,90.005912),(21955,'Metatarsal-PD-deer',243,10,117,310.550572,47.757311,61.12072,1.8,47.647744,61.440889,-0.935769,34.502827,35.244876,12019.533539,20123.70125,33.545371,570.968144,348.363731,839.567385,23.599424,31.001638,1.044899,89.850582),(21956,'Metatarsal-PD-deer',243,10,118,309.227216,47.795299,61.146896,1.8,47.681672,61.437843,-0.935782,23.445361,35.134915,11971.53159,19971.149885,33.403077,568.413212,510.614096,837.434011,0.1875,0.265165,2.356194,0.53033),(21957,'Metatarsal-PD-deer',243,10,119,309.20495,47.815615,61.19145,1.8,47.717774,61.464486,-0.935028,22.72613,28.718815,11980.193878,19866.550782,33.363542,691.760821,527.155042,1098.433182,23.537561,30.978382,1.058407,89.274756),(21958,'Metatarsal-PD-deer',243,10,120,308.77304,47.816043,61.253645,1.8,47.702306,61.547767,-0.93395,21.905524,24.750333,11979.733469,19747.734092,33.263936,797.877515,546.881838,1266.723096,0.265165,0.53033,2.356194,1.06066),(21959,'Metatarsal-PD-deer',243,10,121,308.447749,47.873194,61.267248,1.8,47.717249,61.587408,-0.940494,16.07205,23.8726,11904.278168,19432.215793,33.549906,813.996618,740.682019,1289.18068,1.156022,9.75,1.176005,22.852922),(21960,'Metatarsal-PD-deer',243,10,122,306.797418,47.916245,61.303211,1.8,47.766502,61.607743,-0.93883,13.378193,16.902133,11821.30254,19189.388535,33.289295,1135.323489,883.624779,1833.802475,0.375,0.53033,2.356194,1.06066),(21961,'Metatarsal-PD-deer',243,10,123,306.293991,47.965048,61.333686,1.8,47.810787,61.687183,-0.942343,27.999192,23.59203,11822.270845,19044.795734,33.405448,807.255492,422.236142,1099.314011,0.713946,1.200586,2.466852,2.761485),(21962,'Metatarsal-PD-deer',243,10,124,305.68565,47.999973,61.360307,1.8,47.850989,61.76986,-0.945885,27.905275,16.598874,11815.770777,18896.649116,33.510551,1138.429588,423.424274,1096.314818,0.727722,2.019437,1.951303,4.90165),(21963,'Metatarsal-PD-deer',243,10,125,305.981005,48.035192,61.397732,1.8,47.925109,61.83635,-0.94544,28.463975,18.818015,11857.668588,18857.588937,33.521385,1002.102966,416.585121,1076.41931,0.952159,8.362164,1.227772,18.390611),(21964,'Metatarsal-PD-deer',243,10,126,305.929645,48.059658,61.42047,1.8,47.940298,61.769457,-0.940944,30.147362,19.181011,11866.283364,18771.159403,33.297837,978.632426,393.609344,1016.167442,1.49111,8.362164,1.227772,20.136932),(21965,'Metatarsal-PD-deer',243,10,127,304.49331,48.100887,61.458966,1.8,48.000832,61.766842,-0.933683,28.468735,16.024185,11806.797116,18592.109693,32.789913,1160.253053,414.728544,1064.973899,1.024557,9.071978,1.255582,19.735281),(21966,'Metatarsal-PD-deer',243,10,128,303.883445,48.120758,61.519342,1.8,47.978013,61.855153,-0.933043,30.454535,15.988206,11750.685521,18445.961019,32.693235,1153.722986,385.843537,991.530957,0.898587,9.735566,1.297788,21.235281),(21967,'Metatarsal-PD-deer',243,10,129,302.467809,48.176359,61.527674,1.8,48.012581,61.845333,-0.931121,15.046844,15.827936,11581.598847,18087.248757,32.448183,1142.742123,769.702836,1388.146008,1.348347,9.787787,1.27934,22.652097),(21968,'Metatarsal-PD-deer',243,10,130,300.301896,48.199172,61.563638,1.8,48.051675,61.857613,-0.926044,14.484425,16.025911,11461.595631,17745.340488,31.972084,1107.290606,791.304843,1364.1846,1.253421,11.087895,1.243698,24.572592),(21969,'Metatarsal-PD-deer',243,10,131,298.158516,48.226926,61.597617,1.8,48.092259,61.912689,-0.926504,13.788627,17.035481,11354.285971,17442.387768,31.765823,1023.885831,823.452979,1353.391245,1.204976,11.33251,1.285679,24.856602),(21970,'Metatarsal-PD-deer',243,10,132,296.762067,48.24699,61.608292,1.8,48.100596,61.901268,-0.925968,13.504033,17.970921,11283.501392,17238.486252,31.591594,959.243343,835.565322,1326.725496,0.1875,0.265165,2.356194,0.53033),(21971,'Metatarsal-PD-deer',243,10,133,295.203271,48.279986,61.620837,1.8,48.134946,61.881792,-0.926295,15.30485,26.019955,11232.741,17061.227996,31.441097,655.697819,733.933411,1085.869901,0.265165,0.53033,2.356194,1.06066),(21972,'Metatarsal-PD-deer',243,10,134,294.834663,48.314503,61.648494,1.8,48.18558,61.882819,-0.930124,14.241031,26.059096,11204.740648,16925.25332,31.582344,649.495019,786.792773,1079.219578,1.18426,9.967525,1.284745,22.076272),(21973,'Metatarsal-PD-deer',243,10,135,293.909798,48.352236,61.682879,1.8,48.240355,61.897131,-0.926475,14.047725,26.465258,11190.284721,16807.841375,31.311777,635.090774,796.590528,1057.870008,1.299727,3.824265,1.373401,10.598796),(21974,'Metatarsal-PD-deer',243,10,136,292.612234,48.380263,61.717571,1.8,48.227206,61.915184,-0.921493,15.544216,26.527478,11158.020491,16713.001447,30.939884,630.026015,717.824588,1050.552293,0.740464,2.096314,1.390943,4.90165),(21975,'Metatarsal-PD-deer',243,10,137,291.75131,48.466553,61.699651,1.8,48.315477,61.935809,-0.921048,14.22056,29.059355,11066.555105,16437.06477,30.827985,565.637627,778.208109,936.848209,1.157241,6.947628,1.624798,17.576272),(21976,'Metatarsal-PD-deer',243,10,138,289.160369,48.506249,61.712121,1.8,48.312441,61.966758,-0.918451,14.511817,29.347107,10952.279785,16133.94187,30.433539,549.762593,754.714575,913.665913,1.125,6.791539,1.460139,16.470116),(21977,'Metatarsal-PD-deer',243,10,139,287.927791,48.552502,61.73273,1.8,48.368465,61.975428,-0.917582,14.617946,29.476416,10917.389344,15885.904231,30.26359,538.936081,746.848362,899.589905,0.1875,0.265165,2.356194,0.53033),(21978,'Metatarsal-PD-deer',243,10,140,286.531822,48.592749,61.74605,1.8,48.444926,61.992162,-0.914883,14.439894,30.153907,10888.312674,15717.579175,29.99235,521.24519,754.043806,868.215805,0.75,3.19301,1.629552,7.772971),(21979,'Metatarsal-PD-deer',243,10,141,285.987891,48.622372,61.760332,1.8,48.479047,62.002896,-0.914929,14.518633,29.965963,10879.540131,15614.73821,29.937521,521.082474,749.35016,872.110121,1.2421,12.200474,1.524675,27.481602),(21980,'Metatarsal-PD-deer',243,10,142,285.481289,48.652161,61.77877,1.8,48.51533,62.024528,-0.91111,22.503922,30.021518,10836.155598,15518.264724,29.708692,516.904724,481.522982,867.531853,0.503401,0.676041,0.588003,1.59099),(21981,'Metatarsal-PD-deer',243,10,143,284.794996,48.674325,61.803099,1.8,48.534067,62.053523,-0.90537,17.335452,16.751721,10807.425204,15402.424665,29.372998,919.453292,623.429082,1163.903697,22.996402,28.29014,1.154591,85.104261),(21982,'Metatarsal-PD-deer',243,10,144,284.616616,48.696356,61.796005,1.8,48.577915,62.028854,-0.90234,19.100847,33.615062,10796.385388,15301.002905,29.214878,455.182945,565.230707,747.322428,0.375,3.380204,1.626295,7.681981),(21983,'Metatarsal-PD-deer',243,10,145,285.001172,48.7591,61.777273,1.8,48.634057,62.136091,-0.909442,21.368841,16.128173,10784.368999,15192.510431,29.581943,941.985801,504.6773,1070.599784,0.375,0.676041,0.588003,1.59099),(21984,'Metatarsal-PD-deer',243,10,146,284.203956,48.783611,61.805218,1.8,48.654162,62.287161,-0.91264,22.698455,16.169436,10761.381462,15094.166918,29.645911,933.499927,474.101936,1045.875068,1.125,3.395769,1.460139,8.367641),(21985,'Metatarsal-PD-deer',243,10,147,283.450408,48.801827,61.816523,1.8,48.661948,62.323896,-0.912864,30.099627,16.55268,10718.663106,14974.767919,29.577576,904.673319,356.10618,851.861331,0.997013,6.629126,1.712693,14.678301),(21986,'Metatarsal-PD-deer',243,10,148,282.9781,48.834899,61.798868,1.8,48.691916,62.211754,-0.900799,26.131977,19.52547,10691.480266,14837.255346,28.975968,759.892368,409.134006,952.563147,0.375,0.773082,1.815775,1.81066),(21987,'Metatarsal-PD-deer',243,10,149,282.852241,48.864633,61.790487,1.8,48.714029,62.15654,-0.889781,14.437572,23.749735,10668.611865,14744.694526,28.456155,620.836176,738.947779,1017.189003,22.881831,27.791776,1.055834,84.134591),(21988,'Metatarsal-PD-deer',243,10,150,283.13234,48.903997,61.794432,1.8,48.753711,62.199314,-0.886498,13.255138,24.548881,10704.86788,14669.790056,28.33267,597.5747,807.601416,999.010658,22.894016,27.687218,1.022247,84.024756),(21989,'Metatarsal-PD-deer',243,10,151,282.126104,48.929058,61.781714,1.8,48.788661,62.120992,-0.871377,15.865485,16.536302,10670.461764,14528.91163,27.533442,878.607068,672.558179,1120.728858,22.892112,27.444902,1.064361,83.850582),(21990,'Metatarsal-PD-deer',243,10,152,281.399968,48.95942,61.767224,1.8,48.848186,62.017115,-0.857999,31.330674,15.230564,10638.641165,14372.894284,26.84301,943.687578,339.559919,798.23618,0.375,1.009718,1.19029,2.18566),(21991,'Metatarsal-PD-deer',243,10,153,281.673228,49.039409,61.745013,1.8,48.913482,62.024309,-0.852025,15.000677,29.797524,10613.039118,14206.399778,26.591352,476.764432,707.504018,831.124886,0.375,0.773082,1.815775,1.81066),(21992,'Metatarsal-PD-deer',243,10,154,281.156165,49.080213,61.759095,1.8,48.94715,62.049514,-0.848197,16.235297,30.069265,10602.370705,14097.934292,26.364663,468.848652,653.044445,819.305436,0.375,0.773082,1.815775,1.81066),(21993,'Metatarsal-PD-deer',243,10,155,279.984695,49.116286,61.756306,1.8,48.978837,62.06622,-0.843719,14.651566,28.500043,10573.815889,13975.00588,26.04737,490.350344,721.685043,861.360659,22.976644,27.026029,1.063698,82.589096),(21994,'Metatarsal-PD-deer',243,10,156,279.854457,49.153095,61.759509,1.8,49.030031,62.12424,-0.835771,35.02397,30.142543,10621.421494,13944.279384,25.666727,462.61124,303.261493,690.555662,0.375,1.546165,1.815775,3.77665),(21995,'Metatarsal-PD-deer',243,10,157,279.401229,49.189225,61.758723,1.8,49.053204,62.164938,-0.823625,35.342536,27.562869,10646.8618,13904.053848,25.061801,504.448713,301.247817,680.382124,0.375,1.884352,1.670465,4.06066),(21996,'Metatarsal-PD-deer',243,10,158,279.694006,49.224367,61.750277,1.8,49.124898,62.09364,-0.805041,35.046562,30.496088,10677.36413,13828.324878,24.223285,453.445864,304.662243,682.645851,1.011805,7.293244,1.257176,16.204951),(21997,'Metatarsal-PD-deer',243,10,159,279.759258,49.261908,61.746042,1.8,49.133964,62.002759,-0.787911,14.975351,30.54695,10687.621908,13746.651917,23.430454,450.017166,713.680918,799.455139,0.375,1.140518,1.735945,2.56066),(21998,'Metatarsal-PD-deer',243,10,160,279.611026,49.309274,61.751214,1.8,49.18263,61.950892,-0.769561,15.085793,14.506204,10729.273885,13654.273342,22.563015,941.271298,711.217085,1614.19912,0.598617,3.052279,1.385448,6.931981),(21999,'Metatarsal-PD-deer',243,10,161,279.775526,49.42247,61.731459,1.8,49.295441,61.964652,-0.75408,16.817324,14.283407,10738.979522,13515.822823,21.855219,946.260434,638.566487,1184.223697,0.1875,0.265165,2.356194,0.53033),(22000,'Metatarsal-PD-deer',243,10,162,278.893413,49.469826,61.74001,1.8,49.322514,61.984275,-0.734962,16.791036,14.521304,10751.494393,13423.808849,20.900726,924.421696,640.311546,1407.923506,0.375,0.676041,0.982794,1.43566),(22001,'Metatarsal-PD-deer',243,10,163,277.985977,49.510628,61.746786,1.8,49.369413,62.024077,-0.710272,15.301369,14.532245,10768.778238,13365.90324,19.697925,919.741138,703.77873,1575.09361,1.119989,8.844357,1.2021,19.716437),(22002,'Metatarsal-PD-deer',243,10,164,277.621236,49.551971,61.743158,1.8,49.4196,62.019548,-0.693232,17.707699,14.550991,10809.314433,13345.22507,18.894662,917.135114,610.430223,1112.826831,0.909047,7.946108,1.234122,17.174621),(22003,'Metatarsal-PD-deer',243,10,165,277.048445,49.590342,61.765792,1.8,49.450693,62.018685,-0.676944,18.775594,14.54847,10878.048153,13320.567734,18.1187,915.599239,579.371703,1114.819772,23.313755,26.18832,1.062307,82.039921),(22004,'Metatarsal-PD-deer',243,10,166,277.388896,49.614624,61.784503,1.8,49.48701,62.059661,-0.66122,27.283553,13.943586,10962.80883,13360.495297,17.433626,958.182178,401.810164,886.647469,23.396941,26.172878,1.078311,81.930087),(22005,'Metatarsal-PD-deer',243,10,167,278.032766,49.650619,61.804821,1.8,49.551059,62.133869,-0.639659,26.027263,16.516502,11078.140186,13401.590774,16.511231,811.406103,425.635999,940.47413,23.397893,26.117074,1.052541,81.774756),(22006,'Metatarsal-PD-deer',243,10,168,278.14549,49.691137,61.829409,1.8,49.607309,62.257653,-0.616711,25.235772,20.601273,11208.476582,13426.558275,15.50636,651.7344,444.150335,975.239855,0.375,0.773082,1.815775,1.81066),(22007,'Metatarsal-PD-deer',243,10,169,278.552248,49.753142,61.774514,1.8,49.604958,62.196465,-0.587285,24.126703,20.537926,11156.94749,13413.222312,14.253991,653.095267,462.431494,1000.174124,23.564741,25.982115,1.032852,81.930087),(22008,'Metatarsal-PD-deer',243,10,170,277.657756,49.795848,61.785181,1.8,49.646639,62.104988,-0.549177,24.186349,19.240699,11093.285965,13372.916319,12.608831,695.032767,458.658975,1008.269507,0.375,1.140518,1.735945,2.56066),(22009,'Metatarsal-PD-deer',243,10,171,276.145057,49.832252,61.775328,1.8,49.676684,62.097121,-0.515267,19.702194,19.724768,11040.094462,13362.927476,11.175554,677.469421,560.348494,999.932538,0.375,0.53033,2.356194,1.06066),(22010,'Metatarsal-PD-deer',243,10,172,274.893622,49.876657,61.772064,1.8,49.723682,62.060767,-0.483767,23.983493,29.701169,11032.346832,13352.230537,9.91146,449.552358,459.997491,801.796956,0.452646,2.868198,1.373401,6.09099),(22011,'Metatarsal-PD-deer',243,10,173,273.823647,49.936442,61.768048,1.8,49.811136,62.004199,-0.46183,19.455501,13.770452,11039.628727,13364.978597,9.061181,970.554828,567.429689,1126.20264,23.79513,25.660798,1.025364,82.085417),(22012,'Metatarsal-PD-deer',243,10,174,272.359304,49.983831,61.75097,1.8,49.837901,61.99198,-0.433705,19.384018,14.408491,11030.140444,13340.482022,8.016337,925.876424,569.032713,1133.281493,23.77643,25.599072,1.015303,81.975582),(22013,'Metatarsal-PD-deer',243,10,175,271.37413,50.033873,61.752702,1.8,49.907725,61.967341,-0.405497,19.247547,18.741956,11041.958577,13367.508164,7.038138,713.239756,573.681339,1023.81267,0.1875,0.265165,2.356194,0.53033),(22014,'Metatarsal-PD-deer',243,10,176,270.4893,50.080194,61.750263,1.8,49.964126,61.969428,-0.376199,18.125458,27.771834,11048.821093,13407.018626,6.084841,482.755977,609.574718,832.966082,23.737554,25.545456,0.952253,82.240747),(22015,'Metatarsal-PD-deer',243,10,177,270.28255,50.168182,61.723115,1.8,50.026294,61.954553,-0.343312,27.05382,21.205062,11054.476544,13370.410558,5.104043,630.529178,408.610561,724.89526,0.1875,0.265165,2.356194,0.53033),(22016,'Metatarsal-PD-deer',243,10,178,268.938345,50.210676,61.741588,1.8,50.07525,62.021221,-0.311168,26.65078,27.163581,11076.018284,13358.133677,4.201724,491.766295,415.598275,709.631212,0.61175,3.092329,1.325818,6.77665),(22017,'Metatarsal-PD-deer',243,10,179,268.282393,50.253974,61.746616,1.8,50.114787,62.08362,-0.290797,26.524855,23.486856,11096.681197,13421.937452,3.675746,571.465899,418.350304,701.18312,0.375,1.009718,1.19029,2.18566),(22018,'Metatarsal-PD-deer',243,10,180,267.625057,50.284438,61.762769,1.8,50.087051,62.09976,-0.278305,25.132471,28.059811,11106.355848,13493.864712,3.366489,480.896498,441.912616,812.183989,0.375,1.912132,1.373401,4.21599),(22019,'Metatarsal-PD-deer',243,10,181,267.626921,50.347435,61.775239,1.8,50.224888,62.033556,-0.24188,24.284467,22.220389,11153.635822,13556.769191,2.559124,610.104935,459.290952,931.075015,0.375,1.546165,1.325818,3.46599),(22020,'Metatarsal-PD-deer',243,10,182,268.011861,50.392097,61.778735,1.8,50.248489,61.991263,-0.212949,23.953012,37.109571,11185.262814,13675.754691,1.99517,368.523649,466.966866,641.085242,0.375,0.838525,1.107149,1.81066),(22021,'Metatarsal-PD-deer',243,10,183,267.603739,50.462784,61.776368,1.8,50.323439,61.952892,-0.186945,22.891554,27.189537,11199.428683,13791.911558,1.540646,507.250689,489.238473,823.652969,0.1875,0.773082,1.815775,1.65533),(22022,'Metatarsal-PD-deer',243,10,184,267.649144,50.521311,61.785172,1.8,50.362658,61.932694,-0.172518,23.408674,28.863548,11264.037619,13929.296661,1.314529,482.591285,481.190757,792.387618,0.612213,4.921652,1.261093,10.727476),(22023,'Metatarsal-PD-deer',243,10,185,267.768931,50.623119,61.761905,1.8,50.437223,61.984447,-0.161884,22.371609,29.319074,11299.886629,13970.567685,1.15937,476.500982,505.099407,786.083103,0.375,2.257799,1.653938,5.12132),(22024,'Metatarsal-PD-deer',243,10,186,267.422962,50.669445,61.763803,1.8,50.46408,61.976954,-0.142454,21.804236,17.853298,11280.822189,14043.171317,0.89837,786.586951,517.368379,898.621559,0.5625,2.444701,1.647568,5.49632),(22025,'Metatarsal-PD-deer',243,10,187,266.924936,50.725488,61.761002,1.8,50.538037,62.001975,-0.116214,22.670911,27.54991,11314.861102,14159.719176,0.598133,513.96607,499.091596,809.50049,0.375,2.257799,1.653938,4.96599),(22026,'Metatarsal-PD-deer',243,10,188,267.298285,50.799026,61.753467,1.8,50.615529,62.001826,-0.096171,21.968038,16.250766,11406.705176,14330.780253,0.410763,881.852625,519.240954,966.620816,0.651204,4.275658,1.304544,9.337311),(22027,'Metatarsal-PD-deer',243,10,189,267.728746,50.85857,61.762862,1.8,50.682265,62.024034,-0.090333,22.156523,17.335798,11522.99653,14548.80961,0.363125,839.235045,520.072411,975.460595,0.651204,4.413226,1.356736,10.022971),(22028,'Metatarsal-PD-deer',243,10,190,267.810543,50.896944,61.758494,1.8,50.666458,62.010033,-0.085045,22.07558,18.582116,11547.86792,14737.218348,0.322049,793.086118,523.10598,951.836841,0.530931,2.684591,1.359703,5.71599),(22029,'Metatarsal-PD-deer',243,10,191,266.930273,50.960021,61.706158,1.8,50.765666,61.892991,-0.073533,21.56915,18.801697,11524.163386,14909.575699,0.240121,792.990948,534.289174,962.3225,0.1875,0.265165,2.356194,0.53033),(22030,'Metatarsal-PD-deer',243,10,192,265.964862,51.01997,61.693945,1.8,50.768835,61.900874,-0.072587,21.076305,15.683683,11494.495704,15060.975885,0.233144,960.295832,545.375285,1099.472179,23.4375,26.154066,0.224112,84.581737),(22031,'Metatarsal-PD-deer',243,10,193,264.926516,51.108866,61.653168,1.8,50.881131,61.836637,-0.071216,21.013532,16.274731,11448.2497,15122.732665,0.223564,929.215535,544.803674,1130.070888,0.1875,0.265165,2.356194,0.53033),(22032,'Metatarsal-PD-deer',243,10,194,263.24217,51.165886,61.612888,1.8,50.961277,61.751452,-0.066089,21.068529,37.280602,11372.639199,15236.667028,0.191352,408.702283,539.792741,658.141756,0.1875,0.265165,2.356194,0.53033),(22033,'Metatarsal-PD-deer',243,10,195,261.684386,51.230168,61.588542,1.8,51.030952,61.737432,-0.059328,21.113069,36.314832,11309.35535,15377.215102,0.153332,423.441722,535.656637,671.380558,0.375,0.676041,2.55359,1.325825),(22034,'Metatarsal-PD-deer',243,10,196,260.28733,51.288977,61.558496,1.8,51.078389,61.722498,-0.045864,20.998974,14.742695,11257.914872,15608.197648,0.09119,1058.707224,536.117369,1235.172673,23.543282,26.793481,0.112203,86.877232),(22035,'Metatarsal-PD-deer',243,10,197,259.095543,51.337205,61.504772,1.8,51.150717,61.615471,-0.03228,20.936716,14.639966,11182.113464,15905.803546,0.04498,1086.464493,534.09108,1076.729322,23.4375,27.001302,0.118326,87.828057),(22036,'Metatarsal-PD-deer',243,10,198,257.308306,51.367233,61.421433,1.8,51.207011,61.563471,-0.021077,21.194328,34.877444,11092.226924,16184.719803,0.019049,464.045464,523.358264,695.712921,23.527921,27.219163,2.968517,88.422727),(22037,'Metatarsal-PD-deer',243,10,199,257.339787,51.417448,61.36886,1.8,51.306825,61.585245,-0.014381,21.245721,24.990529,11143.453749,16673.431967,0.008869,667.190043,524.503428,875.552822,23.4375,27.483305,3.052786,89.373552),(22038,'Metatarsal-PD-deer',243,10,200,257.381101,51.457742,61.310255,1.8,51.32821,61.539054,-0.010512,21.335775,26.15027,11145.531711,17088.085422,0.00474,653.457326,522.387002,864.083264,0.1875,0.265165,2.356194,0.53033),(22039,'Metatarsal-PD-deer',243,10,201,257.421989,51.546167,61.230161,1.8,51.296842,61.489025,-0.008745,21.606441,28.347273,11120.213487,17435.405346,0.003281,615.064651,514.671229,828.015336,0.1875,0.592927,1.892547,1.28033),(22040,'Metatarsal-PD-deer',243,10,202,256.808448,51.593461,61.161953,1.8,51.413041,61.378453,0.010171,21.597218,25.521076,11099.114763,17757.702158,0.004428,695.8054,513.914098,897.844696,23.4375,28.451851,3.04258,92.244873),(22041,'Metatarsal-PD-deer',243,10,203,256.793874,51.64655,61.088234,1.8,51.483343,61.272653,0.023986,21.99859,24.737733,11083.702424,18109.676477,0.024619,732.06693,503.836941,918.644051,23.625,28.796972,2.997854,93.104708),(22042,'Metatarsal-PD-deer',243,10,204,256.341328,51.705391,60.975201,1.8,51.556823,61.141699,0.03843,22.566653,24.126765,11030.604417,18630.651415,0.063065,772.198476,488.801085,938.705102,23.625,29.180808,3.051514,94.960863),(22043,'Metatarsal-PD-deer',243,10,205,256.826431,51.748609,60.863615,1.8,51.594753,61.037403,0.042379,22.531737,26.153032,11031.685221,19172.355486,0.076831,733.083464,489.606512,908.723384,0.1875,0.592927,1.892547,1.28033),(22044,'Metatarsal-PD-deer',243,10,206,256.619201,51.790298,60.726869,1.8,51.645677,60.889803,0.0449,22.933844,20.441453,10890.999479,19767.021443,0.086165,967.006673,474.887648,1171.719361,0.1875,0.265165,2.356194,0.53033),(22045,'Metatarsal-PD-deer',243,10,207,256.583789,51.847424,60.538449,1.8,51.704615,60.676785,0.047046,23.175984,20.656393,10748.73651,20397.382028,0.09458,987.46096,463.787704,1230.786048,23.228658,30.375579,3.030254,90.828057),(22046,'Metatarsal-PD-deer',243,10,208,256.577717,51.870831,60.37214,1.8,51.722518,60.560379,0.047725,23.527893,19.891862,10622.401435,21010.508341,0.097326,1056.236362,451.481208,1234.12536,23.041337,30.815099,3.013464,90.672727),(22047,'Metatarsal-PD-deer',243,10,209,255.248416,51.980695,60.154649,1.8,51.810008,60.428434,0.057195,23.8046,16.818606,10491.359728,21449.615513,0.139015,1275.350358,440.728256,1202.891676,22.919902,31.307447,3.033581,90.782562),(22048,'Metatarsal-PD-deer',243,10,210,255.241875,52.04186,60.067256,1.8,51.864723,60.520973,0.071415,23.891433,16.887363,10606.646017,21933.956603,0.216592,1298.838451,443.951862,1208.323869,22.920469,31.768941,3.011381,91.532562),(22049,'Metatarsal-PD-deer',243,10,211,256.104034,52.131208,60.004909,1.8,51.861633,60.500041,0.083176,24.068034,17.554928,10726.050095,22534.705022,0.294619,1283.668354,445.655427,1220.23298,23.033761,32.281053,3.025163,93.214543),(22050,'Metatarsal-PD-deer',243,10,212,257.626662,52.272307,59.964631,1.8,51.988179,60.337835,0.098828,25.324882,17.196343,10846.712816,23092.640525,0.418008,1342.880925,428.302604,1295.635112,23.18815,32.799104,3.038511,93.699378),(22051,'Metatarsal-PD-deer',243,10,213,261.155263,52.405781,59.98412,1.8,52.088851,60.229821,0.109518,25.259134,17.526484,11131.122297,23976.143906,0.519974,1367.995051,440.677123,1237.745725,23.41545,33.305405,3.006065,94.869873),(22052,'Metatarsal-PD-deer',243,10,214,266.362798,52.511001,60.038885,1.8,52.190262,60.219206,0.113882,25.064255,18.216225,11554.83984,25072.620106,0.573264,1376.38944,461.008711,1268.232513,23.637892,33.792681,3.024808,96.241193),(22053,'Metatarsal-PD-deer',243,10,215,273.815678,52.556281,60.079078,1.8,52.280337,60.247457,0.109809,17.01738,18.083802,12170.516913,26316.080345,0.548071,1455.229372,715.181578,1978.432098,23.843834,34.330938,3.108818,97.832183),(22054,'Metatarsal-PD-deer',243,10,216,279.781768,52.563408,60.153108,1.8,52.318334,60.337224,0.105335,24.135375,18.499343,12837.02713,27655.036366,0.515471,1494.919912,531.876024,1449.378316,0.375,0.676041,0.982794,1.43566),(22055,'Metatarsal-PD-deer',243,10,217,284.6356,52.525082,60.207319,1.8,52.291031,60.436612,0.103956,24.094884,18.586575,13430.544457,29005.995032,0.510827,1560.588459,557.402326,1529.343482,24.417721,35.469232,3.030352,101.123999),(22056,'Metatarsal-PD-deer',243,10,218,289.446658,52.508846,60.364145,1.8,52.303156,60.516738,0.105235,21.909435,21.1596,13934.342782,30345.232251,0.532274,1434.111799,635.997361,1453.742511,24.655339,36.0083,3.037261,102.934659),(22057,'Metatarsal-PD-deer',243,10,219,297.23935,52.514866,60.507488,1.8,52.356078,60.714509,0.114499,23.181101,19.151685,14602.718844,32162.732463,0.646631,1679.36825,629.940706,1581.118877,24.9264,36.531237,3.049074,106.226474),(22058,'Metatarsal-PD-deer',243,10,220,301.49152,52.575255,60.694061,1.8,52.492558,60.883029,0.12453,25.485946,27.866737,15114.853116,33827.850934,0.775221,1213.915029,593.066192,1440.624205,25.043447,37.5,2.857799,110.222795),(22059,'Metatarsal-PD-deer',243,10,221,303.001342,52.56416,60.880514,1.8,52.57966,61.125406,0.131593,24.907156,28.361579,15778.47194,35704.385632,0.869457,1258.8998,633.491509,1508.100001,25.241693,38.108654,2.893034,116.5523),(22060,'Metatarsal-PD-deer',243,10,222,310.444496,52.503045,61.162365,1.8,52.528063,61.346855,0.134538,24.50403,30.087275,16818.770134,37393.292538,0.930895,1242.827509,686.367521,1541.330315,25.92988,38.400897,2.864634,112.949824),(22061,'Metatarsal-PD-deer',243,10,223,326.537727,52.40512,61.507069,1.8,52.35198,61.552129,0.129238,24.282014,20.826055,18084.784365,39132.773489,0.903952,1879.029584,744.781075,1920.773955,25.925899,38.658208,3.034685,110.555533),(22062,'Metatarsal-PD-deer',243,10,224,332.975689,52.328904,61.597627,1.8,52.300264,61.720628,0.123689,24.867997,20.34084,18835.705818,40948.445511,0.844704,2013.114768,757.427528,2064.026454,26.152195,39.366517,3.046189,113.801853),(22063,'Metatarsal-PD-deer',243,10,225,333.05968,52.274755,61.566146,1.8,52.224979,61.76761,0.121775,24.860273,21.03892,18934.637244,42122.592777,0.819103,2002.12715,761.642374,2303.413179,26.372737,40.93688,3.086602,115.173174),(22064,'Metatarsal-PD-deer',243,10,226,333.168931,52.179565,61.646326,1.8,52.154907,61.842823,0.115812,24.779344,21.144063,18977.613819,44032.905981,0.741448,2082.518634,765.864249,2338.209591,26.515691,41.4375,3.046426,116.783009),(22065,'Metatarsal-PD-deer',243,10,227,334.674418,52.180084,61.687365,1.8,52.090827,61.909609,0.104216,24.800961,21.519788,19040.929864,45831.503229,0.603624,2129.737702,767.749671,2180.734368,26.806234,42.164577,3.012274,121.044494),(22066,'Metatarsal-PD-deer',243,10,228,341.176694,52.229608,61.736901,1.8,52.066043,62.051416,0.097242,24.789646,21.792566,19505.594785,48013.512812,0.535999,2203.206071,786.844415,2241.674548,27.513669,42.770143,2.929581,126.412135),(22067,'Metatarsal-PD-deer',243,10,229,356.513448,52.370827,61.773546,1.8,52.137616,62.154374,0.105121,24.801706,22.197345,20165.612931,50955.154653,0.654184,2295.551765,813.073632,2387.066892,28.585269,43.170628,2.949308,137.230601),(22068,'Metatarsal-PD-deer',243,10,230,383.995153,52.373433,61.813384,1.8,51.94594,62.222803,0.133084,23.772121,22.663501,21877.405995,55794.659814,1.126831,2461.87295,920.296753,2677.930434,0.375,0.773082,1.815775,1.81066),(22069,'Metatarsal-PD-deer',243,10,231,416.015199,52.304019,61.809694,1.8,51.818026,62.259134,0.163145,20.785757,23.440017,24558.474576,61239.035448,1.829139,2612.584989,1181.504927,2908.85937,0.503401,0.795495,0.785398,1.59099),(22070,'Metatarsal-PD-deer',243,10,232,443.096325,52.262395,61.742221,1.8,51.830969,62.266149,0.171574,24.072658,23.536233,27248.301042,65516.450083,2.152709,2783.642132,1131.919075,3156.422,29.708802,45.42069,2.479101,182.591328),(22071,'Metatarsal-PD-deer',243,10,233,454.403129,51.943757,61.913901,1.8,51.768363,62.484189,0.187714,23.487851,23.481689,27783.980376,67965.629985,2.637391,2894.409752,1182.908589,3526.965536,0.5625,0.838525,2.677945,1.96599),(22072,'Metatarsal-PD-deer',243,10,234,450.930138,51.673325,62.202348,1.8,51.607247,62.927339,0.172984,23.356299,23.48324,26811.32778,67698.326557,2.226547,2882.835833,1147.927061,3778.857066,0.455071,1.093303,1.030377,2.34099),(22073,'Metatarsal-PD-deer',243,10,235,445.231523,51.731411,62.540362,1.8,51.766898,63.247829,0.167791,22.915912,22.99931,25989.83575,66585.346826,2.069622,2895.101953,1134.139282,3175.24285,0.503401,0.9375,0.927295,1.96599),(22074,'Metatarsal-PD-deer',243,10,236,438.975128,51.913078,63.043194,1.8,52.047037,63.742949,0.135271,20.200204,22.959877,24949.360524,65609.410358,1.330593,2857.567977,1235.104414,3121.98199,0.375,1.009718,1.19029,2.18566),(22075,'Metatarsal-PD-deer',243,10,237,436.777947,52.361426,63.282281,1.8,52.43312,63.90856,0.104953,20.254181,23.023511,25017.540318,64120.626398,0.798926,2785.006485,1235.17904,3095.015483,1.875,2.371708,1.892547,10.360281),(22076,'Metatarsal-PD-deer',243,10,238,433.563004,52.82699,63.364259,1.8,52.766276,63.960333,0.065179,24.855986,23.45687,25704.159993,63286.478654,0.306548,2697.993301,1034.123545,3115.826901,0.375,0.838525,1.107149,1.81066),(22077,'Metatarsal-PD-deer',243,10,239,435.44104,52.925778,63.351134,1.8,52.762141,64.112046,0.026607,22.321952,23.724504,26820.945886,65197.453172,0.051364,2748.106009,1201.550174,3219.73976,30.659945,47.213155,0.378294,240.741085),(22078,'Metatarsal-PD-deer',243,10,240,441.690096,52.88301,63.336663,1.8,52.759082,64.177525,0.004171,29.916793,23.995911,28121.46377,67859.590876,0.001281,2827.964749,939.989238,3016.996745,2.30038,7.946108,1.234122,24.095563),(22079,'Metatarsal-PD-deer',243,10,241,444.996946,52.947847,63.195729,1.8,52.75842,64.027665,0.005403,22.38235,24.274221,28600.957743,69235.562262,0.002165,2852.225865,1277.835345,3201.44331,2.604415,7.485924,1.185639,23.656223),(22080,'Metatarsal-PD-deer',243,10,242,448.360036,52.995791,63.154393,1.8,52.765227,63.931371,0.009626,22.486518,24.826927,28237.225759,70186.311053,0.006924,2827.023667,1255.740241,3061.781053,2.595553,7.485924,1.185639,23.034903),(22081,'Metatarsal-PD-deer',243,10,243,446.23517,53.030485,63.152928,1.8,52.75366,63.845272,0.017981,22.592358,24.247404,27158.400965,70108.918578,0.024043,2891.399006,1202.105633,3124.88587,2.833985,10.147544,1.289959,33.020184),(22082,'Metatarsal-PD-deer',243,10,244,444.922692,53.012117,63.202366,1.8,52.651915,63.795119,0.024143,22.624866,23.64692,25417.178758,70371.578065,0.043213,2975.93003,1123.417893,3083.192675,1.295122,5.815523,1.208252,14.201272),(22083,'Metatarsal-PD-deer',243,10,245,439.757056,52.74422,63.22784,1.8,52.462309,63.637833,0.023886,22.504506,23.942068,23050.08537,69422.055735,0.041809,2899.584778,1024.243119,2916.450333,20.866666,29.880818,0.843112,99.967776),(22084,'Metatarsal-PD-deer',243,10,246,427.676357,52.328427,63.224145,1.8,52.08127,63.474108,0.018622,22.523668,22.637328,20155.628744,65563.63433,0.024714,2896.262014,894.864389,3163.612458,0.652421,2.194631,1.222025,4.90165),(22085,'Metatarsal-PD-deer',243,10,247,401.700352,51.496715,63.21027,1.8,51.608517,63.334179,0.010674,22.429856,22.223301,16742.534395,56721.233637,0.007628,2552.331568,746.439659,2438.346992,0.375,1.009718,1.19029,2.18566),(22086,'Metatarsal-PD-deer',243,10,248,350.640075,49.819928,63.137029,1.8,50.550685,63.219113,-0.003613,22.165365,22.927708,13140.866282,39592.837175,0.000762,1726.855424,592.855861,2290.059486,0.1875,0.419263,2.034444,0.90533),(22087,'Metatarsal-PD-deer',243,10,249,301.00712,49.611102,62.999785,1.8,49.480621,63.106811,-0.011267,22.413037,18.529293,9310.735606,27847.338633,0.006368,1502.881857,415.416065,1556.329233,20.165455,25.078782,1.130556,125.654329),(22088,'Metatarsal-PD-deer',243,10,250,233.767362,51.327923,62.832381,1.8,50.610117,62.971974,-0.016308,22.334189,19.117869,5743.468702,16607.124271,0.010361,868.670284,257.160392,923.680305,19.224478,23.51238,1.160669,112.574824),(22089,'Metatarsal-PD-deer',243,10,251,172.94902,51.299297,62.684431,1.8,51.610123,62.75047,-0.008961,22.733006,13.960756,2767.059879,10326.404988,0.002314,739.673779,121.719931,532.953048,0.761252,5.466517,1.467715,12.894291),(22090,'Metatarsal-PD-deer',243,10,252,80.219616,47.656237,62.604144,1.8,49.410959,62.615021,-0.018633,7.782114,17.059358,737.195624,3130.880591,0.004641,183.528626,94.729476,223.554267,11.205584,17.111879,0.964559,58.721009),(22091,'Metatarsal-PD-deer',243,10,253,14.909233,43.061088,62.772397,1.8,43.928779,62.675291,-1.374923,19.237126,19.099957,37.360939,81.543297,2.39075,4.269292,1.942127,4.444838,5.538228,11.253125,1.386472,27.489407),(22092,'Metatarsal-PD-deer',243,10,254,0.033004,57.996328,84.799447,1.8,57.9625,84.8,0.006552,0.214444,3.435307,0.000468,0.151199,0.0000002361,0.044013,0.002183,0.044064,0.3356,0.676041,2.55359,1.325825),(22093,'Metatarsal-PD-deer',243,10,255,0.006616,56.061292,84.75,1.8,56.0625,84.75,0.123644,0.023273,0.187267,0.000022,0.000171,0.000017,0.000911,0.000933,0.001019,0.1875,0.592927,2.819842,1.170495),(22094,'Metatarsal-PD-deer',243,10,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22095,'Metatarsal-PD-deer',243,10,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22096,'Metatarsal-PD-deer',243,10,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22097,'Metatarsal-PD-deer',243,10,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22098,'Metatarsal-PD-deer',243,10,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22099,'Metatarsal-PD-deer',243,10,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22100,'Metatarsal-PD-deer',243,10,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22101,'Metatarsal-PD-deer',243,10,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22102,'Metatarsal-PD-deer',243,10,264,0.011388,76.872895,83.0625,1.8,76.875,83.0625,0.042891,0.01617,0.376758,0.000035,0.000808,0.000003,0.002144,0.002152,0.002235,0.1875,0.956066,2.944197,1.920495),(22103,'Metatarsal-PD-deer',243,10,265,0.017781,79.547633,82.758613,1.8,79.546875,82.757812,-0.170403,0.109957,0.519469,0.000141,0.001611,0.000085,0.003102,0.001278,0.003371,0.437059,2.550276,0.298499,5.386485),(22104,'Metatarsal-PD-deer',243,10,266,0.004347,68.53079,84.75,1.8,68.53125,84.75,0.294007,0.027301,0.090167,0.000016,0.000048,0.000061,0.000529,0.000584,0.000676,0.1875,0.419263,2.677945,0.795495),(22105,'Metatarsal-PD-deer',243,10,267,3.092259,37.916453,57.508346,1.8,37.975702,57.541643,0.749223,3.238193,40.62696,6.754277,21.052452,0.239061,0.518189,2.085816,0.684369,6.375,6.708204,1.107149,20.996767),(22106,'Metatarsal-PD-deer',243,10,268,25.387596,37.723,57.392438,1.8,37.706471,57.392764,-0.781554,6.403335,6.511959,216.33206,223.491483,2.099369,34.32016,33.784277,67.180609,12.9375,13.300611,0.705568,42.898864),(22107,'Metatarsal-PD-deer',243,10,269,49.764194,37.705087,57.37747,1.8,37.708589,57.373437,-0.63971,8.341543,8.463299,777.930116,799.451901,2.955699,94.461023,93.259738,185.581402,16.875,17.243885,0.754639,56.012825),(22108,'Metatarsal-PD-deer',243,10,270,76.421847,38.237016,57.632543,1.8,38.936108,58.003601,0.471553,9.921776,27.005277,1664.601453,2559.774503,2.628419,94.787936,167.772528,155.478718,19.6875,20.125485,0.977626,65.2403),(22109,'Metatarsal-PD-deer',243,10,271,189.16582,48.214282,61.047962,1.8,47.036778,60.144563,0.388623,13.85876,26.075863,4519.760068,29956.202403,4.526624,1148.809633,326.130188,1311.129723,21.9375,22.374651,0.690446,72.748106),(22110,'Metatarsal-PD-deer',243,10,272,381.602216,55.435984,61.291643,1.8,52.541875,59.986208,0.289384,20.775757,30.018865,14189.613643,69388.356112,5.179076,2311.491636,682.989001,2777.313382,23.8125,24.132204,0.603088,78.664921),(22111,'Metatarsal-PD-deer',243,10,273,552.896335,59.629816,60.36759,1.8,54.380922,59.42577,0.158065,24.583749,34.693295,26439.034604,110271.380094,2.283201,3178.463757,1075.467988,3936.614817,25.3125,25.731258,1.182171,84.252232),(22112,'Metatarsal-PD-deer',243,10,274,592.7025,60.108692,60.189743,1.8,53.982964,59.506149,0.107716,25.114775,35.763728,29415.612606,122606.481841,1.141744,3428.235541,1171.247304,4250.718927,26.4375,26.885172,1.169568,88.047727),(22113,'Metatarsal-PD-deer',243,10,275,599.908636,59.837519,60.315104,1.8,53.740157,59.718661,0.09762,25.579119,35.931317,29883.48022,125766.154983,0.949796,3500.182187,1168.276348,4329.721433,27.375,27.816432,1.040781,91.028883),(22114,'Metatarsal-PD-deer',243,10,276,605.632756,59.624839,60.423336,1.8,53.560499,59.867416,0.090857,25.432547,36.026268,30200.923936,127956.023946,0.830956,3551.742421,1187.491115,4387.795093,28.107495,28.386906,1.163303,92.994873),(22115,'Metatarsal-PD-deer',243,10,277,609.612379,59.475628,60.513643,1.8,53.43921,59.943626,0.086887,24.895408,36.117921,30295.51515,129096.690333,0.765108,3574.311268,1216.91176,4409.253637,28.5,28.807348,0.836046,94.494873),(22116,'Metatarsal-PD-deer',243,10,278,612.083033,59.358337,60.605078,1.8,53.349391,60.035604,0.084614,16.457782,36.084481,30322.629533,129485.428345,0.728632,3588.396553,1842.449338,4417.026863,28.679553,29.060081,0.744325,95.290368),(22117,'Metatarsal-PD-deer',243,10,279,614.822631,59.25624,60.693171,1.8,53.257897,60.127429,0.083919,23.213293,42.648079,30390.211835,129970.686663,0.719941,3047.51564,1309.172818,3302.575655,28.679553,29.187433,0.821746,95.244873),(22118,'Metatarsal-PD-deer',243,10,280,616.514116,59.143182,60.76933,1.8,53.129024,60.217886,0.084446,16.156951,36.193909,30442.31934,130532.526743,0.730998,3606.477734,1884.16244,4440.545132,28.680029,29.33701,0.735665,95.510038),(22119,'red-deer-radius.tif',246,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22120,'red-deer-radius.tif',246,3,2,0.0022079,67.445268,78.812448,1.8,67.445268,78.812448,0.7853982,0,0,0.0000066,0.0000066,0.000184,0,0,0,0.189453,0.267927,2.3561945,0.535854),(22121,'red-deer-radius.tif',246,3,3,0.0043941,68.20308,78.9071745,1.8,68.20308,78.9071745,1.276795,0.0274502,0.090662,0.0000165,0.0000493,0.0006709,0.0005433,0.0005994,0.0006937,0.189453,0.4236298,2.0344439,0.91476),(22122,'red-deer-radius.tif',246,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22123,'red-deer-radius.tif',246,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22124,'red-deer-radius.tif',246,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22125,'red-deer-radius.tif',246,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22126,'red-deer-radius.tif',246,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22127,'red-deer-radius.tif',246,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22128,'red-deer-radius.tif',246,3,10,0.8046759,39.0763746,34.5515789,1.8,39.0443475,34.6975719,0.0929499,1.0655385,1.4110619,0.1211708,0.2497219,0.0011554,0.1769744,0.1137179,0.2563198,8.4454365,19.6930903,1.4357019,47.9575802),(22129,'red-deer-radius.tif',246,3,11,2.8311956,39.1601201,35.1905279,1.8,39.1381301,35.2543436,-0.2476324,1.7596608,1.9749082,1.5242342,1.7717061,0.028349,0.8971081,0.8662091,1.5913729,8.9551237,31.6545293,1.4568344,87.0354873),(22130,'red-deer-radius.tif',246,3,12,4.7918582,39.2873352,35.6717965,1.8,39.2156331,35.6751946,-1.090997,2.4680429,2.3506525,3.7364936,5.8833555,0.6284717,2.5028606,1.51395,3.7675506,9.2080528,34.1025925,1.465047,83.0546642),(22131,'red-deer-radius.tif',246,3,13,7.0780434,39.2852782,36.1183,1.8,39.25257,36.1191541,-1.2113561,2.5469829,2.9471318,7.6547114,13.554282,1.0337149,4.5991434,3.0054035,6.470632,9.4894137,36.0483808,1.4549157,83.7395792),(22132,'red-deer-radius.tif',246,3,14,9.8546172,39.4276359,36.4983209,1.8,39.3804882,36.4614856,-1.2001755,2.8305443,3.4144927,13.2561546,26.7914911,1.4269738,7.8464046,4.6832528,10.8200848,10.419915,37.7425374,1.4601391,87.9535142),(22133,'red-deer-radius.tif',246,3,15,12.7232389,39.580951,36.7814764,1.8,39.5493019,36.7926158,-1.1281576,2.9117919,3.7263245,18.1487659,42.6867765,1.7314999,11.4554642,6.2328513,14.9948541,11.8610841,39.1031176,1.4542537,91.8804812),(22134,'red-deer-radius.tif',246,3,16,15.9707541,39.7363199,37.1937548,1.8,39.7132995,37.2607361,-1.164416,25.0988263,18.4203126,25.1411509,70.4684893,2.2458825,3.825586,1.0016863,3.0710138,13.8400565,40.4205867,1.4580687,97.1090013),(22135,'red-deer-radius.tif',246,3,17,18.7401712,39.999518,37.5776738,1.8,39.8605775,37.5550717,-1.103734,3.8704049,4.9519846,27.8039188,101.6460503,2.4901355,20.5263258,7.1837236,24.8092394,0.6354408,3.6785119,1.3633001,7.983954),(22136,'red-deer-radius.tif',246,3,18,21.9362189,40.3190135,38.0151883,1.8,40.1510237,37.9883472,-1.1077926,4.2597332,5.6324185,35.8091109,148.1058027,2.9267116,26.295241,8.406421,29.8046864,15.5250295,42.9105817,1.455751,103.0224363),(22137,'red-deer-radius.tif',246,3,19,26.3886107,40.6667736,38.6118168,1.8,40.5663406,38.5704167,-1.1758463,4.6475717,6.0106636,51.6159791,215.7769516,3.7469987,35.8990234,11.1060103,40.5880904,0.568359,1.4428311,1.1659045,3.123186),(22138,'red-deer-radius.tif',246,3,20,31.063068,40.9765919,39.2858234,1.8,40.9414317,39.0905051,-1.2694599,5.3901993,6.4526191,68.0842484,325.4131668,4.7211292,50.4311758,12.6311188,54.302527,0.964863,5.0160343,1.380808,12.0219),(22139,'red-deer-radius.tif',246,3,21,34.969612,41.2631489,39.6050946,1.8,41.1919356,39.3500473,-1.3212664,5.4047621,7.0549573,85.0705724,441.1364495,5.4728402,62.5285778,15.739929,67.3895121,2.076332,24.6507403,1.7018242,61.0702292),(22140,'red-deer-radius.tif',246,3,22,39.3642496,41.5622922,40.0273351,1.8,41.4300565,39.7396175,-1.3516769,5.7966056,7.75193,105.982583,577.4556455,6.2507161,74.4918553,18.2835594,86.6174301,0.378906,0.6830825,0.9827937,1.450614),(22141,'red-deer-radius.tif',246,3,23,45.5729455,41.7703432,40.4992335,1.8,41.6013749,40.2310837,-1.3772725,5.8944224,8.3826555,132.7334931,766.6640172,7.3145622,91.4583709,22.5184903,107.2659519,0.378906,1.198206,1.8925469,2.587332),(22142,'red-deer-radius.tif',246,3,24,52.4058761,41.9742106,41.0523848,1.8,41.794849,40.7697932,-1.3901217,9.2626831,33.2090634,166.8821285,1019.0715499,8.4522848,30.6865489,18.0166077,35.2482243,2.1210511,27.7870141,1.6663944,71.0216102),(22143,'red-deer-radius.tif',246,3,25,58.5719797,42.2243691,41.6055249,1.8,42.0337778,41.1806967,-1.4043007,10.2498367,22.325974,214.2332991,1307.4334198,9.4938777,58.5610922,20.9011427,62.7378513,2.0946299,27.9422302,1.6522484,71.7144122),(22144,'red-deer-radius.tif',246,3,26,66.163372,42.3920135,42.1564945,1.8,42.2337366,41.6811529,-1.4121983,6.5926046,10.170165,270.2296539,1661.3839652,10.752175,163.358605,40.9898167,189.5664504,2.373245,28.2513747,1.611043,72.8051612),(22145,'red-deer-radius.tif',246,3,27,74.097189,42.5466198,42.7346918,1.8,42.4152906,42.1960106,-1.4244957,6.6145315,11.1826602,333.9155578,2116.5735985,12.0870841,189.2728171,50.4821176,217.5626594,2.4675571,31.477147,1.61294,78.6266583),(22146,'red-deer-radius.tif',246,3,28,81.2989199,42.7140652,43.3251637,1.8,42.5943142,42.7215698,-1.4335274,6.9785922,11.7521813,397.4870847,2598.14997,13.2961034,221.0781055,56.9580619,254.8686588,2.3320152,31.8483961,1.6064954,77.9719382),(22147,'red-deer-radius.tif',246,3,29,88.8710717,42.8568967,43.8493341,1.8,42.713209,43.2476463,-1.4516024,8.5598055,21.1467385,473.576231,3131.2951014,14.6024052,148.0746118,55.3255833,160.063999,2.1448713,34.6885287,1.6035715,85.6039143),(22148,'red-deer-radius.tif',246,3,30,97.1527735,43.0057974,44.4173212,1.8,42.8689323,43.8406833,-1.4680748,7.2378969,13.1127443,566.4473475,3759.4649265,16.0218744,286.7031365,78.2613174,329.6085799,2.1984883,37.9478663,1.625741,101.3577513),(22149,'red-deer-radius.tif',246,3,31,105.6054538,43.1241892,45.0218995,1.8,43.0163961,44.339885,-1.4812672,6.7913401,13.6279654,658.6286164,4477.0678079,17.4602059,328.520632,96.9806556,376.476084,0.7543232,2.7125542,1.7818897,6.40332),(22150,'red-deer-radius.tif',246,3,32,114.0944942,43.2412824,45.6470583,1.8,43.1349729,44.8832299,-1.491853,6.970084,13.9660498,759.7133366,5278.2091678,18.897488,377.9314293,108.9962963,431.1535056,1.0521428,9.1429476,1.6745887,21.7434361),(22151,'red-deer-radius.tif',246,3,33,123.6692374,43.4025154,46.214448,1.8,43.3540427,45.3956991,-1.4956168,9.7627158,19.6687094,907.5387061,6199.3486549,20.4952631,315.1883806,92.9596563,343.5800039,1.7353016,12.0089892,1.6814535,36.2226481),(22152,'red-deer-radius.tif',246,3,34,134.00018,43.4811414,46.7731682,1.8,43.4404316,45.8916034,-1.4931057,8.3102099,14.9383462,1046.9940984,7406.8828126,22.1988339,495.8301762,125.9888873,564.0579901,2.2976236,41.4940997,1.5570986,120.1888054),(22153,'red-deer-radius.tif',246,3,35,146.837448,43.5006706,47.5596702,1.8,43.366326,46.6162394,-1.4868445,8.8259142,17.9318793,1225.2737435,8764.9912024,24.3008301,488.7937887,138.8268368,506.2656906,2.6647547,43.615356,1.5273454,123.0440644),(22154,'red-deer-radius.tif',246,3,36,166.2682768,43.4851093,48.5658851,1.8,43.3209655,47.5287292,-1.4755107,9.136315,15.1282006,1520.5345444,10753.3215036,27.4605385,710.8129899,166.427552,749.7405449,0.189453,0.267927,2.3561945,0.535854),(22155,'red-deer-radius.tif',246,3,37,184.280669,43.5967931,49.4489354,1.8,43.5112229,48.2448839,-1.4934417,8.9164108,15.9146533,1929.3666797,12240.9026828,30.53003,769.1592439,216.3837815,820.177169,15.028288,52.8791119,1.5421303,238.4626867),(22156,'red-deer-radius.tif',246,3,38,191.4676405,43.8397147,49.5083481,1.8,43.8043931,48.2380293,-1.5238852,9.8302614,15.7327752,2298.314781,11925.5134504,31.8410992,758.0044412,233.799967,821.4963152,2.3468795,40.702424,1.4822435,106.0884994),(22157,'red-deer-radius.tif',246,3,39,174.9065863,43.7954806,48.5502879,1.8,43.7343735,47.5017696,-1.4900941,9.1241372,15.0558815,2204.8624651,9313.8375854,28.9616525,618.6178864,241.6516111,695.0921025,2.2323253,38.6270462,1.4774721,100.1560234),(22158,'red-deer-radius.tif',246,3,40,158.4972048,43.6648752,47.6167411,1.8,43.5903055,46.7029853,-1.4400166,15.8623014,14.3762038,2034.2309368,7305.3755605,25.9669658,508.1574857,128.2431147,526.0288599,2.4013113,34.6678284,1.4667775,90.6945273),(22159,'red-deer-radius.tif',246,3,41,147.2803716,43.604429,46.651242,1.8,43.5092049,45.7043741,-1.3849949,10.112793,13.8680489,1912.9153416,6089.273761,23.7090288,439.0865525,189.1579646,531.7338491,2.4842832,34.0277841,1.4367731,94.5453304),(22160,'red-deer-radius.tif',246,3,42,139.3545053,43.5150556,46.0268664,1.8,43.4306944,45.0379844,-1.3345591,9.0067618,13.4259166,1806.1238586,5378.2551327,21.9535009,400.5875585,200.529769,494.0960434,0.189453,0.267927,2.3561945,0.535854),(22161,'red-deer-radius.tif',246,3,43,134.6314627,43.4281815,45.5403697,1.8,43.3166185,44.5009834,-1.2889317,11.0157369,13.3993594,1722.3895765,4931.2835691,20.7025978,368.0238307,156.3571813,460.8439066,2.6179462,32.2671331,1.4056476,86.6263863),(22162,'red-deer-radius.tif',246,3,44,130.9031519,43.3864435,45.1830451,1.8,43.2786144,44.1234218,-1.2389025,10.1826194,13.1984051,1651.7141673,4556.0950533,19.5009078,345.2004244,162.2091627,441.2892581,2.6571258,30.0610037,1.386997,78.7914933),(22163,'red-deer-radius.tif',246,3,45,126.8385942,43.3921326,44.8708418,1.8,43.2980268,43.8777457,-1.1910043,8.9615069,13.0895164,1582.213131,4311.0414851,18.2343424,329.3507078,176.5565933,430.0926765,2.4319891,28.6092849,1.3708034,74.8264443),(22164,'red-deer-radius.tif',246,3,46,126.2656965,43.4044033,44.6421947,1.8,43.2734395,43.7482074,-1.1480788,9.2151242,12.9467856,1568.4024276,4140.0905652,17.5025911,319.777486,170.1987295,428.8943214,0.6489463,2.8856621,1.1659045,6.717216),(22165,'red-deer-radius.tif',246,3,47,126.5201739,43.3805022,44.4361653,1.8,43.2588936,43.654368,-1.1110289,9.1850722,12.7941611,1541.6598092,4011.7973136,16.9346215,313.5647017,167.8440595,425.6977063,2.3148457,22.666371,1.3602868,64.4042192),(22166,'red-deer-radius.tif',246,3,48,128.6770484,43.303179,44.2085912,1.8,43.1719798,43.4772796,-1.0707727,10.0664597,12.4666355,1540.5289252,3983.9958489,16.5163704,319.5726597,153.0358218,436.796243,2.4739845,24.6972896,1.2830133,61.2810332),(22167,'red-deer-radius.tif',246,3,49,130.3347027,43.4051881,43.97816,1.8,43.2240559,43.343165,-1.0407817,9.26069,12.6577195,1603.7271329,3988.5357088,16.1706984,315.1069767,173.1757709,433.8150298,2.8825847,24.2655201,1.2613908,66.6474603),(22168,'red-deer-radius.tif',246,3,50,127.0732437,43.4217472,44.0073383,1.8,43.239314,43.4040741,-1.004637,9.501848,12.6084238,1645.9915328,3934.6498275,15.0853052,312.0651639,173.2285687,440.019142,2.6233247,24.2040574,1.2440953,61.1319723),(22169,'red-deer-radius.tif',246,3,51,130.5455544,43.4626796,44.0292271,1.8,43.2818205,43.4262219,-0.9658585,10.373493,12.6468154,1758.6029724,4031.4588714,14.7204879,318.7726512,169.5285256,456.8333561,2.696857,23.9716072,1.224051,60.2822223),(22170,'red-deer-radius.tif',246,3,52,140.008161,43.5755856,43.9691849,1.8,43.4074935,43.5452966,-0.9419847,9.6355149,12.8824734,1951.4787244,4325.7726307,15.2618097,335.7874307,202.5297818,485.9885621,2.867122,24.0635143,1.1917519,57.6489212),(22171,'red-deer-radius.tif',246,3,53,2.7676334,45.1096021,52.1953647,1.8,45.1547693,52.1985545,-0.4588034,1.6652872,5.7917247,0.2674568,8.5146845,0.0904734,1.4701466,0.160607,1.4913867,1.592989,8.1376625,0.4324078,17.9622631),(22172,'red-deer-radius.tif',246,3,54,9.9643393,44.9979162,52.1776245,1.8,45.2959929,52.1880293,-0.4573163,3.4458514,7.4246153,3.4050712,45.3398744,0.3237731,6.1066968,0.9881654,6.5639558,3.0979418,9.9132991,0.4551008,24.1626661),(22173,'red-deer-radius.tif',246,3,55,16.8689026,44.7931452,52.491088,1.8,44.9705117,52.622936,-0.4776072,4.4497571,6.563958,12.6250666,87.7477959,0.5940192,13.3681226,2.8372485,12.6572607,4.1979487,10.2023563,0.3805064,23.8297291),(22174,'red-deer-radius.tif',246,3,56,30.7148678,45.7445453,52.8809606,1.8,46.9335545,53.0462642,-0.1126901,3.8775326,14.7921694,67.2313957,713.9333032,0.0647336,48.264273,17.3387053,52.8088194,6.6465384,13.7884825,0.2216496,34.4279432),(22175,'red-deer-radius.tif',246,3,57,59.1041558,47.9354821,53.3031182,1.8,48.5464832,53.825466,-0.066738,20.4995684,14.846104,226.7067009,2904.9207243,0.0438095,195.6688922,11.0590963,152.0381676,10.1188535,18.2229758,3.0791738,76.3847704),(22176,'red-deer-radius.tif',246,3,58,114.8689552,49.0928742,56.2375146,1.8,49.9692708,57.5655825,0.2010928,18.9455712,18.9631779,3870.3077802,9321.1338668,0.7638051,491.5385975,204.2856214,624.3503913,12.4133011,22.6410207,3.0494176,88.0087234),(22177,'red-deer-radius.tif',246,3,59,225.720872,51.0844042,59.3300844,1.8,51.2387392,60.0885508,0.3067585,17.445094,22.8796971,9419.6376077,22829.36405,3.4304266,997.8001011,539.9591193,1408.3313788,20.3496558,39.8599387,2.7566732,152.8568587),(22178,'red-deer-radius.tif',246,3,60,346.3330416,50.5660222,60.9697844,1.8,49.8389855,61.6986444,0.1793078,16.585223,23.2922314,14852.3542733,34382.1434122,1.836037,1476.120635,895.5173067,2093.0769358,27.3839004,40.7112413,2.7800987,174.2594707),(22179,'red-deer-radius.tif',246,3,61,430.7459896,49.4203864,61.708199,1.8,48.5213201,62.1090141,0.0621899,17.0810644,23.0848684,18972.1538314,43070.0980245,0.2773005,1865.7285503,1110.7126239,2661.9821872,26.3034194,41.869113,0.6860479,150.2077836),(22180,'red-deer-radius.tif',246,3,62,502.4605079,48.0281111,62.3775558,1.8,47.0461035,62.5728015,-0.0711854,15.3215642,25.4139865,22071.0285076,55208.9350866,0.4236422,2172.3839003,1440.5205772,2874.2761814,25.686876,44.250154,0.2377098,140.5814525),(22181,'red-deer-radius.tif',246,3,63,545.3346465,46.3777376,62.838785,1.8,45.9190037,62.7185035,-0.1594182,16.1241487,23.1866235,23102.674404,69296.4807143,2.2903702,2988.6404368,1432.7996377,3771.2583032,25.4899286,46.6846944,0.3782456,140.5085555),(22182,'red-deer-radius.tif',246,3,64,566.7076913,44.9875299,63.1585536,1.8,45.4096151,62.8341239,-0.2090047,21.2876033,25.3755786,22808.3013809,82975.1605411,4.0661829,3269.882511,1071.4358525,3980.2503037,25.1342247,47.8791625,0.3430239,128.7276544),(22183,'red-deer-radius.tif',246,3,65,542.9418825,44.7249903,63.0048985,1.8,45.5045608,62.5285139,-0.2373152,18.8283577,26.5650879,22148.0492784,84500.979695,5.0013232,3180.9034508,1176.3133899,3275.3729904,24.7905605,48.1732452,0.3366748,129.9563105),(22184,'red-deer-radius.tif',246,3,66,516.9877552,44.8664566,62.6829023,1.8,45.5844291,62.2285656,-0.2509099,17.9453307,25.6383815,21698.7340589,81248.2172663,5.3116751,3169.0072665,1209.1576576,3988.4044645,27.9295564,47.8337874,0.2891806,214.6008489),(22185,'red-deer-radius.tif',246,3,67,486.7820379,45.423011,62.3680165,1.8,45.9156913,61.7676578,-0.2721144,21.9521318,24.7994119,21063.3602214,76354.1972014,5.8605795,3078.8712895,959.5132005,3638.3302067,0.568359,1.0202356,2.7610863,2.522322),(22186,'red-deer-radius.tif',246,3,68,452.0884605,45.4367037,62.3889779,1.8,46.0153968,61.9492005,-0.2710692,21.991891,25.1970237,19877.1201051,68774.6672298,5.4021825,2729.4758271,903.8386041,3316.8212426,27.5908022,46.5946549,0.2548403,167.0871847),(22187,'red-deer-radius.tif',246,3,69,408.3756788,44.8643598,62.5513283,1.8,45.7092475,62.1891611,-0.2604441,18.8910107,23.8041126,18496.7440555,58265.7609629,4.5133173,2447.7182581,979.1294026,3096.5848512,26.7432476,44.9227381,0.2081478,155.7771277),(22188,'red-deer-radius.tif',246,3,70,359.80057,44.0248798,62.6471615,1.8,44.9285946,62.1925845,-0.2323276,23.6305306,23.4649729,17549.124403,48926.9315745,3.1789551,2085.1049719,742.6462267,2617.5742799,26.9914564,43.1037843,0.2577711,176.0128268),(22189,'red-deer-radius.tif',246,3,71,340.789052,43.5439744,62.7611223,1.8,44.3542639,62.3372343,-0.2125713,23.8154437,23.0226151,16592.5334384,43138.6779957,2.528088,1873.7522985,696.7131772,2311.8709128,26.5394393,41.7734199,0.2614788,165.5906017),(22190,'red-deer-radius.tif',246,3,72,326.6857053,43.1051271,62.9709372,1.8,43.8581892,62.5410417,-0.1984535,21.1037846,23.5579221,15442.7228009,39368.0162467,2.11635,1671.1158162,731.7513457,2064.9432857,0.5231772,2.1181489,1.1071487,4.5738),(22191,'red-deer-radius.tif',246,3,73,309.8320407,42.8979117,63.2400914,1.8,43.5603771,62.6377999,-0.2016078,20.8772661,26.0384188,13777.1072285,35856.6759241,2.0706073,1377.0681021,659.9095473,1831.9504621,25.8967622,39.6133493,0.2612185,150.6865147),(22192,'red-deer-radius.tif',246,3,74,292.663099,42.6297194,63.5262677,1.8,43.1079581,62.9052313,-0.2018301,26.2889002,21.5359388,12562.2618607,32241.0063857,1.9601239,1497.0792137,477.8542183,1704.1159168,27.3088092,38.5982301,0.2378359,201.5801379),(22193,'red-deer-radius.tif',246,3,75,285.0119621,42.4583328,63.7134021,1.8,42.97104,63.0185067,-0.2018007,18.1362532,20.9438331,11702.1031776,29493.3778672,1.9083307,1408.2129943,645.2326756,1890.1540864,24.7706467,37.5451682,0.2290681,167.4851317),(22194,'red-deer-radius.tif',246,3,76,276.5378443,42.2736608,63.9206155,1.8,42.6689177,63.2867824,-0.1984314,16.9874612,20.42453,10820.3423752,27365.100809,1.7910862,1339.8154505,636.9605355,1799.1808843,23.9521654,36.8348475,0.3738207,163.4202577),(22195,'red-deer-radius.tif',246,3,77,269.9505702,42.0779695,64.1005411,1.8,42.3796191,63.547699,-0.1894067,17.7305184,20.7148812,10167.7035218,25626.6357923,1.5948651,1237.1123701,573.4577676,1723.4598299,23.3761761,35.8146353,0.3736303,154.8163987),(22196,'red-deer-radius.tif',246,3,78,264.0868876,41.8756117,64.3022339,1.8,42.1669673,63.763873,-0.178961,15.8170586,19.8145817,9575.9743745,24017.2352733,1.3946683,1212.0990288,605.4206793,1637.049994,22.73436,35.11224,0.1899883,148.8569946),(22197,'red-deer-radius.tif',246,3,79,257.1677607,41.7291265,64.5077496,1.8,41.954213,64.0899264,-0.1699403,16.7147411,19.574198,8983.2591864,22516.1900606,1.225952,1150.2994959,537.4453079,1584.6110401,22.2634852,34.4210607,0.2276239,94.3312594),(22198,'red-deer-radius.tif',246,3,80,254.6942713,41.6500568,64.6968485,1.8,41.9220051,64.2950292,-0.1601728,14.8037806,18.5958336,8542.3694571,21401.1961026,1.0797626,1150.8597309,577.0397229,1576.4661397,21.7861777,33.8872056,0.20836,89.6005114),(22199,'red-deer-radius.tif',246,3,81,250.5987265,41.5581051,64.8824529,1.8,41.970171,64.4367904,-0.1556346,14.3382466,18.3584856,7986.4548711,20375.2918362,1.0035302,1109.8568971,557.0035918,1413.7329825,20.5158241,33.3313467,0.2118873,87.5680744),(22200,'red-deer-radius.tif',246,3,82,245.513638,41.4231281,65.1283207,1.8,41.8156251,64.6754222,-0.1447827,14.5307842,17.74862,7422.6182161,19460.1247513,0.8517679,1096.4303017,510.8202071,1340.8123086,20.082018,32.9942068,0.1906389,86.2934494),(22201,'red-deer-radius.tif',246,3,83,240.9021339,41.2980635,65.3774207,1.8,41.6776413,64.9516574,-0.1328345,14.7469609,17.3448792,6913.3518375,18645.5183175,0.7042961,1074.9869204,468.7984121,1231.4173896,19.324206,32.5506498,0.2110933,84.7508973),(22202,'red-deer-radius.tif',246,3,84,237.5768408,41.1764325,65.5926449,1.8,41.4846683,65.237004,-0.1215794,14.4897597,16.8985737,6465.5925264,17964.8877382,0.5824138,1063.1008318,446.2180642,1246.8708162,18.6698471,32.1802526,0.2135604,83.5872513),(22203,'red-deer-radius.tif',246,3,85,235.107441,41.0750085,65.7712523,1.8,41.2958537,65.3884527,-0.1090453,13.8311752,16.583384,6074.5648207,17430.1975074,0.4640954,1051.063978,439.1936851,1324.2727153,18.1229019,31.9165054,0.2032162,82.4695743),(22204,'red-deer-radius.tif',246,3,86,233.0996288,40.9842025,65.9591409,1.8,41.1790105,65.6462624,-0.0986564,15.5285663,16.467959,5739.2988992,16948.5442268,0.3769045,1029.1830476,369.5961868,1210.3657681,17.733714,31.4817078,0.2245436,81.5088453),(22205,'red-deer-radius.tif',246,3,87,231.2625124,40.8816027,66.1349301,1.8,40.9638503,65.8755723,-0.0839119,13.7973281,15.8218531,5431.8648685,16419.9186806,0.2707584,1037.7999698,393.6896221,1248.13345,17.3911917,31.0985816,0.1962008,80.9729913),(22206,'red-deer-radius.tif',246,3,88,229.6943282,40.8053536,66.3107346,1.8,40.845922,66.221467,-0.072225,13.6037055,15.3995705,5176.8565385,15910.5042172,0.1993509,1033.178442,380.5475301,1204.98006,17.0768968,30.7649739,0.2046418,79.7443353),(22207,'red-deer-radius.tif',246,3,89,226.5599937,40.7784289,66.4364852,1.8,40.7358582,66.3024168,-0.0595933,13.2386209,15.7937542,4932.9489137,15243.3657982,0.1339408,965.1515145,372.6180363,1145.7951552,16.7836039,30.2822709,0.1888068,78.6726273),(22208,'red-deer-radius.tif',246,3,90,223.5375132,40.7415708,66.5738308,1.8,40.732099,66.3447039,-0.0467438,17.8176979,15.2637334,4693.8020673,14602.1835501,0.0813449,956.6587119,263.4348213,1053.2904802,16.482411,29.8747618,0.1849584,77.9798253),(22209,'red-deer-radius.tif',246,3,91,222.3835169,40.7044403,66.7225225,1.8,40.6300884,66.4573347,-0.0335102,13.6458738,15.9405789,4491.912526,14022.9868896,0.0416048,879.703739,329.1773452,1003.1431871,16.2699822,29.3707147,0.1619674,77.0650653),(22210,'red-deer-radius.tif',246,3,92,220.661365,40.6563844,66.8876114,1.8,40.4984234,66.7100541,-0.0233488,18.0462851,16.1753554,4288.8633553,13525.9393166,0.0200459,836.2066218,237.6590718,984.2257648,15.914052,28.874651,0.1780929,75.5684822),(22211,'red-deer-radius.tif',246,3,93,219.6795654,40.6183564,67.0568236,1.8,40.4114201,67.0319105,-0.0153509,11.8119345,15.0672697,4119.9373016,13081.4810524,0.0086274,868.2051443,348.7944584,1061.0013345,15.8639649,28.5074834,0.1400174,75.0785972),(22212,'red-deer-radius.tif',246,3,94,218.3254851,40.5957395,67.1959051,1.8,40.4255725,67.1142861,-0.0066478,14.5531899,14.721294,3946.1268566,12666.2625274,0.0016081,860.4041576,271.152021,1073.9023755,15.535146,28.1061683,0.1352241,74.2748162),(22213,'red-deer-radius.tif',246,3,95,217.1145286,40.568761,67.3378428,1.8,40.3818411,67.2977693,-0.001175,13.3473206,14.8050498,3793.8262866,12315.6494154,0.0000499,831.8546405,284.2387931,983.2195306,15.345693,27.7850765,0.1505757,73.4710352),(22214,'red-deer-radius.tif',246,3,96,216.3166396,40.5457666,67.4680714,1.8,40.3466348,67.3724231,0.0026963,13.655189,14.5973548,3669.7834438,12019.8515765,0.0002621,823.4266941,268.7464414,1039.2483939,15.15624,27.5176814,0.1311867,72.9351812),(22215,'red-deer-radius.tif',246,3,97,215.4043735,40.5597901,67.5440534,1.8,40.3570521,67.3992409,0.0037604,17.5232872,14.1973545,3596.3120481,11701.9303791,0.0005077,824.2331605,205.2304462,870.2152713,15.1262498,27.2825476,0.1183258,72.5103062),(22216,'red-deer-radius.tif',246,3,98,215.2954671,40.5442153,67.6670023,1.8,40.268016,67.5185899,0.0048083,15.5581318,14.0371855,3511.9652354,11474.8300102,0.0008295,817.459453,225.7318096,938.7657225,14.956699,27.0944286,0.1191512,71.9744522),(22217,'red-deer-radius.tif',246,3,99,214.6425728,40.5206521,67.7988069,1.8,40.2441948,67.6292749,0.0069917,13.6031506,14.0033356,3432.543432,11257.4541685,0.0017489,803.9123312,252.3344439,961.8504554,14.9120652,26.9543086,0.1339449,71.5955462),(22218,'red-deer-radius.tif',246,3,100,213.4676718,40.473871,67.9540965,1.8,40.2028222,67.8336551,0.0077074,18.3130182,13.9568787,3349.2209587,11041.4380351,0.0021134,791.110838,182.8874367,784.7260231,14.7641253,26.7665646,0.1348902,71.1706712),(22219,'red-deer-radius.tif',246,3,101,213.0924436,40.4721099,68.0974896,1.8,40.2481802,67.9951642,0.006076,18.0785409,13.7675502,3268.2393094,10874.7845653,0.0013112,789.8852278,180.7800384,781.8688881,14.7174214,26.5788448,0.1358487,70.9027442),(22220,'red-deer-radius.tif',246,3,102,212.6180325,40.4510745,68.2428951,1.8,40.2484673,68.1094737,0.0041485,20.5040876,15.8169512,3242.6052421,10712.5756268,0.0006098,677.2844852,158.1443324,680.1320739,14.6144544,26.4454945,0.1510153,70.4128592),(22221,'red-deer-radius.tif',246,3,103,212.105532,40.4420479,68.3941352,1.8,40.2887351,68.340866,0.0017981,20.4640371,16.0149174,3171.6616841,10523.1510283,0.0001144,657.0843158,154.9870959,668.6745269,14.5959659,26.2301767,0.1449614,70.1449322),(22222,'red-deer-radius.tif',246,3,104,212.6509122,40.4180871,68.5437906,1.8,40.2394114,68.4691875,0.0000429,19.4754852,13.5158082,3151.4897339,10378.3178491,0.0000004,767.865133,161.8182912,694.4781353,14.4518897,26.0427251,0.1460123,69.7660262),(22223,'red-deer-radius.tif',246,3,105,211.7943228,40.4256465,68.6401843,1.8,40.2888473,68.4741994,-0.0014115,22.4134644,13.5669227,3155.8183739,10174.8124789,0.0000704,749.9720229,140.8001152,594.7468145,14.4178353,25.9135417,0.1615429,69.2301722),(22224,'red-deer-radius.tif',246,3,106,211.7320657,40.4030607,68.7750141,1.8,40.235474,68.674113,-0.0042462,18.9456969,13.9666218,3147.5119468,10094.5322881,0.0006362,722.7611989,166.133342,698.3424795,14.3183997,25.8553027,0.1470784,69.1842032),(22225,'red-deer-radius.tif',246,3,107,212.3566377,40.3815616,68.8881326,1.8,40.2525078,68.7233387,-0.0068522,19.4367411,13.802472,3175.8546808,10072.5726759,0.0016619,729.7658477,163.3944016,681.2089141,14.371572,25.7781423,0.1252666,69.0732242),(22226,'red-deer-radius.tif',246,3,108,213.5420997,40.3509736,69.0127671,1.8,40.2236074,68.8581747,-0.0101998,20.3106691,14.2167856,3172.7284189,10085.7086248,0.0037026,709.4225726,156.2099408,651.3521724,14.3329495,25.7551581,0.1179682,68.7402872),(22227,'red-deer-radius.tif',246,3,109,215.4015565,40.3120197,69.140828,1.8,40.1303437,69.0386985,-0.0141928,14.9766853,14.7452707,3189.8561538,10148.145379,0.0072313,688.2305229,212.9881276,809.4249572,14.3237074,25.7551581,0.1179682,69.1191932),(22228,'red-deer-radius.tif',246,3,110,217.2247075,40.2845337,69.2500586,1.8,40.0935876,69.0967239,-0.01941,21.5061899,14.1538061,3222.0147004,10253.226026,0.0136382,724.4147602,149.8180161,626.5152641,14.3540425,25.7781423,0.1252666,69.2761412),(22229,'red-deer-radius.tif',246,3,111,219.0497184,40.2769575,69.3533964,1.8,40.1248168,69.1831128,-0.0202683,21.4235157,13.9628889,3223.6529589,10347.5554477,0.0149957,741.0755434,150.4726399,633.4605221,14.3435452,25.7781423,0.1252666,69.3871202),(22230,'red-deer-radius.tif',246,3,112,220.5217326,40.2611706,69.4628772,1.8,40.1655164,69.3118199,-0.0220229,19.0450344,13.7734286,3221.7677725,10439.0465099,0.017823,757.9119778,169.1657632,714.9284399,14.4025843,25.8024971,0.1325515,69.5440682),(22231,'red-deer-radius.tif',246,3,113,221.058368,40.2936295,69.5147496,1.8,40.1803391,69.2938662,-0.0243983,20.577433,14.1776112,3276.7999324,10495.3280303,0.0219274,740.2747799,159.2424054,663.8149789,14.4340919,25.9218509,0.1098501,69.7010162),(22232,'red-deer-radius.tif',246,3,114,222.0228631,40.2605203,69.6138857,1.8,40.0135928,69.4361728,-0.0284792,21.9794578,13.9616539,3307.3094334,10575.1072678,0.0300044,757.4394374,150.4727486,625.0879556,14.4593124,25.9903002,0.1315881,69.8579642),(22233,'red-deer-radius.tif',246,3,115,222.6074966,40.247335,69.6915724,1.8,40.0689159,69.3848953,-0.0280831,17.1767248,14.1087049,3332.095852,10635.0452327,0.0292524,753.7931612,193.9890103,809.9102333,14.5180331,26.0709632,0.1532018,70.1258912),(22234,'red-deer-radius.tif',246,3,116,223.8655483,40.2388421,69.7828864,1.8,40.1841506,69.4649085,-0.0272295,21.3890772,14.3097434,3338.655083,10759.990969,0.0276572,751.9345838,156.0915908,651.2101279,14.4887328,26.1781272,0.1306386,70.0149122),(22235,'red-deer-radius.tif',246,3,117,225.2659299,40.2132928,69.8734123,1.8,40.1670516,69.5500342,-0.0259522,15.7153461,15.1009945,3334.6536195,10883.6876231,0.025281,720.7265472,212.1909118,901.1463584,14.4452521,26.2301767,0.1449614,70.0149122),(22236,'red-deer-radius.tif',246,3,118,226.1668845,40.1814621,69.9571176,1.8,40.1093447,69.618662,-0.0244015,14.8500409,13.8328378,3332.5881775,11005.7962302,0.0224401,795.6282266,224.4160945,923.9236898,14.4844048,26.3196519,0.1154267,70.3938182),(22237,'red-deer-radius.tif',246,3,119,227.6322532,40.1555973,70.0395507,1.8,40.0963757,69.6819794,-0.022241,15.2710252,14.0426154,3337.7403675,11149.9789881,0.0187637,794.0101358,218.5668818,946.4875699,14.5577596,26.3911497,0.136821,70.5507662),(22238,'red-deer-radius.tif',246,3,120,229.1501553,40.1397064,70.1100856,1.8,40.0812187,69.6706126,-0.0225107,20.5675184,14.2106213,3390.5189416,11293.9421936,0.0193497,794.7535817,164.8482272,697.6985247,14.6300516,26.4868574,0.1074977,71.0866202),(22239,'red-deer-radius.tif',246,3,121,229.8080093,40.1651388,70.1599808,1.8,40.1474469,69.7495577,-0.0238895,15.9718904,13.8581886,3389.6732517,11418.7104549,0.0218548,823.9684695,212.2274303,926.8898237,14.5751961,26.5538503,0.1287797,71.6224742),(22240,'red-deer-radius.tif',246,3,122,230.3811572,40.1320645,70.2407476,1.8,40.0805316,69.782528,-0.020793,14.0010334,13.8935321,3396.2556594,11523.16897,0.0165984,829.3908893,242.5717845,942.1006421,14.676579,26.6206747,0.0855053,71.8904012),(22241,'red-deer-radius.tif',246,3,123,230.6382885,40.0980004,70.3214419,1.8,40.0178955,69.885108,-0.0168333,12.5672787,15.044754,3384.4666902,11638.6806869,0.0108912,773.6039213,269.3078414,871.1702418,14.6115126,26.637523,0.0925916,72.1583282),(22242,'red-deer-radius.tif',246,3,124,231.9277298,40.0739935,70.3952585,1.8,40.0403588,69.9148843,-0.014228,13.1994009,14.8566293,3386.7957475,11802.6678002,0.0078246,794.4377955,256.5870818,983.9792727,14.5323697,26.718247,0.120837,72.0663902),(22243,'red-deer-radius.tif',246,3,125,233.3247396,40.0515852,70.4621055,1.8,40.0257965,69.9501689,-0.0106129,12.5137287,14.6973404,3383.5921384,11984.9092072,0.0043797,815.4474804,270.3904015,940.6876504,14.5984174,26.863607,0.1059844,72.3343172),(22244,'red-deer-radius.tif',246,3,126,235.074235,40.0385018,70.5172947,1.8,40.0179501,70.0708715,-0.0081371,12.9406324,14.1526277,3394.4860513,12193.4047814,0.0025941,861.5647243,262.312222,976.4787741,14.5831373,26.9689523,0.0703065,72.5562752),(22245,'red-deer-radius.tif',246,3,127,236.7217959,40.0328228,70.5727362,1.8,39.957954,70.1686918,-0.0030416,13.7404071,14.1705542,3392.0211983,12395.5927651,0.000365,874.7429751,246.8646791,999.8255985,14.5523457,27.1453822,0.0628542,72.5562752),(22246,'red-deer-radius.tif',246,3,128,237.5958529,40.0302901,70.6310526,1.8,39.9644213,70.2611119,-0.0000514,11.3324709,14.3427872,3374.0217383,12601.0675779,-0.00000003455,878.5647722,297.7304572,1017.5286959,14.587881,27.2034982,3.0509328,72.6672542),(22247,'red-deer-radius.tif',246,3,129,238.8125848,40.0907906,70.6100333,1.8,40.000987,70.0828821,-0.0022658,11.700686,15.0390085,3452.4303211,12800.4651794,0.0002042,851.150869,295.0622135,1028.8443734,0.378906,0.6830825,2.1587989,1.450614),(22248,'red-deer-radius.tif',246,3,130,239.3124795,40.0915377,70.64022,1.8,39.943907,70.0827498,-0.0007725,11.344445,14.8943041,3465.5128025,12970.7107281,0.000024,870.8504028,305.4810359,1026.0030408,0.5931775,1.6945191,2.0344439,3.65904),(22249,'red-deer-radius.tif',246,3,131,239.5605071,40.0952477,70.6742026,1.8,39.9393625,70.1568351,0.000574,10.8045913,14.8981097,3464.0880573,13117.693668,0.0000132,880.4938284,320.6125967,998.0621599,0.568359,1.2708894,2.0344439,2.74428),(22250,'red-deer-radius.tif',246,3,132,240.1575615,40.1308029,70.6849533,1.8,40.0719448,70.132011,0.0022065,10.0479195,27.87728,3466.330956,13282.2196502,0.0001948,476.4532133,344.9799683,598.3107547,0.7627255,1.6945191,2.0344439,3.815988),(22251,'red-deer-radius.tif',246,3,133,240.7354081,40.1431942,70.6961385,1.8,40.0175095,70.1468939,0.0057136,11.7610282,15.1342411,3471.9910411,13431.3196767,0.0013098,887.4789037,295.2115233,1019.1346975,0.6698175,1.366165,2.1587989,3.058176),(22252,'red-deer-radius.tif',246,3,134,240.4389365,40.1586385,70.7152497,1.8,39.9088423,70.2600147,0.0068641,10.6233234,28.0252367,3467.653672,13541.7373145,0.001888,483.1979638,326.418912,603.7207454,14.6818231,28.0140712,3.0331759,75.8364092),(22253,'red-deer-radius.tif',246,3,135,237.6122655,40.2156932,70.733069,1.8,39.6492351,70.3233389,0.0016961,11.8076187,15.5849665,3483.2655998,13499.1570277,0.0001141,866.1652881,295.0015313,959.0316231,14.7982087,28.0352035,3.0264579,75.9473882),(22254,'red-deer-radius.tif',246,3,136,236.4115003,40.2556553,70.7443502,1.8,39.4874234,70.415322,0.0029032,11.8153511,35.3197648,3494.1526391,13534.527398,0.000332,383.1998166,295.7299029,476.0232886,14.8457666,28.1061683,3.0063685,76.0583672),(22255,'red-deer-radius.tif',246,3,137,236.1816473,40.2849904,70.6727856,1.8,39.4625131,70.3151985,0.0058676,10.9797406,16.566436,3543.0872124,13618.0336228,0.0013552,822.0255461,322.6931627,967.4212418,14.9870776,28.1884164,2.9863884,76.9081172),(22256,'red-deer-radius.tif',246,3,138,236.0332157,40.3056549,70.6559327,1.8,39.5140378,70.2463974,0.0093465,12.0865424,18.664605,3560.784229,13671.5941102,0.0034363,732.4877277,294.6073512,890.6460316,15.0215425,28.2024193,3.0339028,77.0190962),(22257,'red-deer-radius.tif',246,3,139,235.8377107,40.3204914,70.6481448,1.8,39.491107,70.252453,0.0112866,12.0811103,19.5916842,3576.8240941,13754.2304055,0.0050069,702.0443101,296.0674971,832.2303862,15.1261458,28.2939033,3.0072712,79.1815532),(22258,'red-deer-radius.tif',246,3,140,236.5125321,40.3413719,70.6348997,1.8,39.5390364,70.2412731,0.0147621,11.4741476,20.1839758,3604.5840657,13854.4473488,0.0085895,686.4082436,314.1483081,837.085174,15.2056752,28.4116342,3.0279899,80.0772723),(22259,'red-deer-radius.tif',246,3,141,237.4363273,40.3791984,70.6090316,1.8,39.6167293,70.184607,0.0166818,11.8385967,20.2080792,3653.6344519,14002.7389596,0.0110113,692.9277551,308.6205681,842.9550058,15.2237496,28.4570767,3.0147604,79.2734913),(22260,'red-deer-radius.tif',246,3,142,237.9196027,40.4101288,70.600864,1.8,39.6367481,70.1956548,0.0190671,11.6344326,22.0981605,3686.5382363,14099.3338184,0.0144146,638.0320117,316.8644638,769.849512,15.339454,28.4570767,3.0147604,78.3127623),(22261,'red-deer-radius.tif',246,3,143,238.5213666,40.4478351,70.5919975,1.8,39.6742577,70.2245267,0.0226467,10.6599013,14.7625894,3711.8595737,14193.1154986,0.0203849,961.4245279,348.2076855,1077.6881332,15.3989113,28.4816611,3.008162,79.1815532),(22262,'red-deer-radius.tif',246,3,144,239.2680708,40.4708208,70.5755714,1.8,39.7136963,70.2420142,0.0260925,17.8095113,17.7496502,3761.8215662,14292.2492279,0.0271436,805.2130094,211.225423,781.2696544,15.4431457,28.5018171,2.9272496,78.8026472),(22263,'red-deer-radius.tif',246,3,145,239.3077809,40.532037,70.4965059,1.8,39.8272585,70.0405454,0.0244777,11.8223806,14.6797476,3872.9199112,14350.0386708,0.0238926,977.5398775,327.5922194,1078.9331624,15.6321372,28.5018171,2.9272496,79.0705743),(22264,'red-deer-radius.tif',246,3,146,239.9017681,40.5563007,70.4506859,1.8,39.8336572,69.9249887,0.0236886,11.0856273,20.1439031,3960.3516871,14449.7619061,0.0224325,717.326819,357.2510212,871.4793996,15.6928584,28.5427151,2.9207639,79.0705743),(22265,'red-deer-radius.tif',246,3,147,240.3771145,40.5910221,70.4087474,1.8,39.9121474,69.8388986,0.0241963,12.4465458,23.015418,4032.9872801,14506.0269655,0.0234505,630.2743203,324.0246213,775.3305491,15.8475599,28.5848103,2.914297,79.4954493),(22266,'red-deer-radius.tif',246,3,148,240.9657505,40.5928017,70.387402,1.8,39.8618021,69.8427699,0.0268602,12.0075968,24.2898092,4076.0822955,14622.4856843,0.0289681,602.0008463,339.4586249,731.8181577,15.9611434,28.6475238,2.9351182,83.0625513),(22267,'red-deer-radius.tif',246,3,149,241.8981926,40.5925312,70.361411,1.8,39.8700246,69.8248047,0.0321357,11.2372787,24.4550756,4122.1461445,14758.7549057,0.0416207,603.5047765,366.827793,739.4245802,16.0632143,28.6882141,2.9623298,80.4752193),(22268,'red-deer-radius.tif',246,3,150,243.1917126,40.6076903,70.3253975,1.8,39.896936,69.7780264,0.0362238,11.2668182,17.6640187,4183.0307242,14883.4874488,0.0531612,842.5878462,371.2699223,1010.0831923,16.0980482,28.7275974,2.9222084,80.7891153),(22269,'red-deer-radius.tif',246,3,151,244.7774623,40.6415426,70.3010777,1.8,39.9372044,69.8166086,0.0369218,11.5456388,17.5523178,4237.1865174,15005.7049679,0.0555893,854.9130148,366.9945514,1054.4837922,16.2971567,28.7225994,2.9558395,80.2992303),(22270,'red-deer-radius.tif',246,3,152,246.1669021,40.6725331,70.2700582,1.8,39.9557345,69.7560666,0.0378001,11.9973728,15.442108,4305.989246,15089.9092053,0.0585947,977.1923104,358.911014,1147.4443748,16.284124,28.7219746,2.9959643,80.7431463),(22271,'red-deer-radius.tif',246,3,153,246.3853131,40.7049878,70.193609,1.8,39.7889829,69.7252047,0.0346169,20.1865477,15.0706358,4405.9245832,15100.178863,0.0491888,1001.9603044,218.2604296,966.2796245,19.7034417,29.487798,0.2933029,158.0997996),(22272,'red-deer-radius.tif',246,3,154,246.4359867,40.7726048,70.1441813,1.8,39.9856564,69.6160886,0.0325337,11.9744617,17.8038864,4443.1678433,15050.306276,0.0434577,845.3382556,371.0536603,1090.1139306,16.187285,28.7275974,2.9222084,82.4807283),(22273,'red-deer-radius.tif',246,3,155,246.6300125,40.8408119,70.0840092,1.8,40.1912311,69.4980333,0.0291785,12.0920185,17.8868668,4498.9321053,15006.4440401,0.0349862,838.9643753,372.057992,1087.6443443,16.1326207,28.7275974,2.9222084,80.2072923),(22274,'red-deer-radius.tif',246,3,156,247.0498888,40.8607618,70.0489752,1.8,40.1119562,69.5034219,0.0274256,12.9476668,17.7782089,4553.4842123,15046.4944865,0.0309626,846.3447917,351.6837658,1044.0056922,16.2475294,28.7275974,2.9222084,79.6064283),(22275,'red-deer-radius.tif',246,3,157,246.8272577,40.8931007,70.0270298,1.8,40.1853238,69.6050835,0.0293378,12.7968607,16.4056115,4547.8374201,15040.3002563,0.0353976,916.7777876,355.3869606,1148.0567436,16.2192048,28.686963,2.9286543,80.2342203),(22276,'red-deer-radius.tif',246,3,158,245.9127401,40.9339015,69.9823601,1.8,40.3046762,69.527784,0.0346789,16.3719947,22.00112,4543.0187327,14999.4091263,0.0492704,681.7566159,277.4871855,712.5956705,16.2524076,28.7275974,2.9222084,80.6590953),(22277,'red-deer-radius.tif',246,3,159,246.1541331,40.9775059,69.9354032,1.8,40.4249186,69.5058574,0.0371413,12.1711713,19.5984215,4560.2850684,15008.1769091,0.0565682,765.7849856,374.6792267,971.14075,16.3001657,28.6280973,2.9078495,80.4102093),(22278,'red-deer-radius.tif',246,3,160,246.2709141,41.0336243,69.874864,1.8,40.4741798,69.5184511,0.039814,11.9772939,17.2245906,4590.9933352,14964.0239641,0.0650285,868.7593384,383.3080652,1022.6655771,16.3001657,28.6092849,2.9415997,79.3844703),(22279,'red-deer-radius.tif',246,3,161,245.5233398,41.1344239,69.7639505,1.8,40.5519428,69.3484332,0.0382417,12.4274657,20.4066017,4679.9752876,14854.2329273,0.059814,727.9131101,376.5832378,900.3145437,16.4134974,28.5364269,2.9546134,79.8093453),(22280,'red-deer-radius.tif',246,3,162,244.8962771,41.187653,69.6895944,1.8,40.6178488,69.1929049,0.0404925,15.191495,22.1176439,4749.1768191,14762.571973,0.0668869,667.4568067,312.6207677,727.1742399,16.4354825,28.4621214,2.9337536,79.7633763),(22281,'red-deer-radius.tif',246,3,163,244.7284419,41.2474529,69.5977064,1.8,40.710169,69.0509113,0.0396193,15.1998511,20.9489279,4815.4720425,14679.1087998,0.0639911,700.709311,316.8104753,895.939882,16.5280091,28.4438301,2.9063067,81.2599593),(22282,'red-deer-radius.tif',246,3,164,244.2085019,41.2985094,69.5436809,1.8,40.80724,69.0596697,0.0410272,12.6611273,14.9242601,4818.980446,14646.4208906,0.0684715,981.3833847,380.6122748,1126.3710927,16.5110074,28.3578931,2.9193005,79.7633763),(22283,'red-deer-radius.tif',246,3,165,244.1951238,41.3308492,69.4772161,1.8,40.804367,69.0356092,0.0449734,12.975388,16.5483294,4850.0347624,14662.1265221,0.0822629,886.018534,373.7872626,1061.4780366,16.5840075,28.2818494,2.9665324,80.3451993),(22284,'red-deer-radius.tif',246,3,166,244.0257115,41.3605662,69.399694,1.8,40.8269225,68.9939818,0.049451,13.1131431,17.8141708,4866.505672,14653.3733988,0.0993757,822.5683676,371.1166459,941.2944281,16.6659147,28.2596315,2.9047439,79.0055643),(22285,'red-deer-radius.tif',246,3,167,244.3451759,41.400695,69.3337862,1.8,40.8611035,69.0193641,0.0508906,12.1463927,18.3403785,4885.3420563,14676.8800675,0.1053788,800.2495727,402.205181,996.6481725,16.7018007,28.2380316,2.938934,79.3194603),(22286,'red-deer-radius.tif',246,3,168,244.6504031,41.4434504,69.2458239,1.8,40.9243378,68.959577,0.0512246,15.602816,20.1206676,4934.8051408,14680.5885832,0.1068985,729.6273094,316.2765707,928.9368972,19.4286271,28.1731326,2.917818,110.8382884),(22287,'red-deer-radius.tif',246,3,169,243.1648803,41.5087315,69.0959277,1.8,40.9005268,68.8142702,0.0504832,12.3904623,15.2825454,5000.7658787,14592.9936601,0.1031989,954.8797859,403.5980061,1199.7500787,16.8124592,28.2005102,2.9455146,79.2544503),(22288,'red-deer-radius.tif',246,3,170,242.3106511,41.5593216,69.000108,1.8,40.9461133,68.7720524,0.0501676,12.1446444,20.9698329,5059.4837136,14534.2216778,0.1015557,693.1014556,416.6020484,934.2577847,17.8453787,28.1731326,2.917818,98.6403994),(22289,'red-deer-radius.tif',246,3,171,241.6257472,41.6309587,68.8844613,1.8,41.0373863,68.6181319,0.0482131,12.6908934,15.6058361,5139.920015,14425.7391028,0.0935378,924.3810479,405.0085262,1172.074075,16.9544295,28.0914786,2.9309704,78.9865233),(22290,'red-deer-radius.tif',246,3,172,241.2305932,41.6968383,68.7943359,1.8,41.1035148,68.5670554,0.0479502,12.7356697,15.0557242,5170.816845,14373.808528,0.0923698,954.7072141,406.0105957,1183.9910615,16.9835463,28.0147118,2.9441971,78.2937213),(22291,'red-deer-radius.tif',246,3,173,240.8538422,41.7703474,68.6931194,1.8,41.191184,68.499283,0.0483684,12.7210048,14.9779898,5182.3266219,14325.2505143,0.0938399,956.4201035,407.3834353,1206.459448,16.9682564,27.9781738,2.9508371,78.8755443),(22292,'red-deer-radius.tif',246,3,174,240.7157869,41.8396471,68.5861789,1.8,41.2393205,68.4343216,0.0450444,12.3703476,15.7065755,5222.787994,14295.3523935,0.0813471,910.1508116,422.2022026,1198.4312707,17.5166956,27.9088126,2.9641678,79.5683463),(22293,'red-deer-radius.tif',246,3,175,241.4549318,41.9296192,68.4530452,1.8,41.389026,68.2388104,0.0458855,12.0984538,15.9933517,5265.2345601,14274.4308719,0.0846701,892.5227874,435.1989634,1183.6888834,17.4202131,27.8759988,2.9708574,78.7645653),(22294,'red-deer-radius.tif',246,3,176,240.612384,42.0042554,68.3529286,1.8,41.515102,68.1609813,0.0498551,11.5148664,19.1590072,5250.8728998,14207.3864165,0.0995926,741.5512862,456.008147,1005.6615661,17.2726018,27.8289626,2.942862,78.3396903),(22295,'red-deer-radius.tif',246,3,177,238.277918,42.0878824,68.2086591,1.8,41.530819,68.0689959,0.048507,11.9862745,21.1773992,5274.1647448,14048.8205056,0.0933686,663.387433,440.017017,899.3470167,17.3805664,27.7210592,2.9281127,78.5885763),(22296,'red-deer-radius.tif',246,3,178,237.025794,42.1381946,68.1006495,1.8,41.4938533,68.1206208,0.0443993,15.9313184,21.0121557,5313.6238867,13940.5754787,0.0778234,663.4528937,333.5332167,870.4143543,17.2947092,27.7210592,2.9281127,78.0067533),(22297,'red-deer-radius.tif',246,3,179,234.7591864,42.1973416,67.9936834,1.8,41.5511617,68.0233881,0.0471518,16.6090122,21.2452545,5306.8926515,13834.3353944,0.0869251,651.1729679,319.5188602,856.8799298,19.6730402,27.6192326,2.9132514,113.9884024),(22298,'red-deer-radius.tif',246,3,180,233.3532361,42.2573932,67.8832295,1.8,41.6576038,67.9395394,0.0515423,12.3055256,20.4927013,5284.2992526,13769.0227508,0.1032298,671.8988665,429.4249135,873.8367606,17.1792312,27.6062341,2.9482348,78.1177323),(22299,'red-deer-radius.tif',246,3,181,232.4226539,42.316295,67.7643602,1.8,41.7304267,67.8320385,0.0551463,16.7408717,22.5036166,5271.0839554,13731.6740442,0.1176846,610.1985428,314.8631709,809.6868375,17.2497102,27.5704566,2.9549783,77.6928573),(22300,'red-deer-radius.tif',246,3,182,231.5883613,42.377307,67.6532015,1.8,41.8361464,67.7266988,0.0591549,16.6199057,15.3021114,5264.5886097,13683.3359443,0.1349088,894.2122811,316.7640487,1134.2721725,17.3066372,27.5704566,2.9549783,77.5818783),(22301,'red-deer-radius.tif',246,3,183,232.1177966,42.4407547,67.522,1.8,41.9223483,67.6520427,0.0614046,11.725864,15.1418216,5305.9072567,13696.1795779,0.1456842,904.5265447,452.4960597,1141.1643168,17.3531885,27.5359361,2.926655,77.5818783),(22302,'red-deer-radius.tif',246,3,184,231.5956486,42.4892521,67.3973834,1.8,41.9574983,67.5200771,0.06417,16.9038255,14.1797228,5323.5424656,13693.0125512,0.1587257,965.6756137,314.9312244,1116.5053817,17.2930737,27.5769651,2.9199431,77.2220133),(22303,'red-deer-radius.tif',246,3,185,230.4086421,42.594341,67.1998625,1.8,42.1205356,67.3074259,0.0645183,16.1320355,16.5761212,5399.5629253,13605.7353942,0.1596289,820.8033261,334.7105769,1123.8045546,17.4969162,27.5769651,2.9199431,77.6928573),(22304,'red-deer-radius.tif',246,3,186,229.2078442,42.6407778,67.0678954,1.8,42.1120253,67.2325623,0.0676294,15.4618179,17.2923324,5415.7754245,13548.5734036,0.1744567,783.5017899,350.267702,1078.4423228,17.6015147,27.6432638,2.9415089,77.1110343),(22305,'red-deer-radius.tif',246,3,187,227.7702542,42.6799798,66.936843,1.8,42.0682554,67.1094725,0.0733593,12.147582,16.1705581,5438.7304223,13514.3132959,0.2039284,835.7357357,447.721237,1046.4700766,17.7974517,27.7210592,2.9281127,77.5818783),(22306,'red-deer-radius.tif',246,3,188,228.9150816,42.7457957,66.774797,1.8,42.2143475,66.8892369,0.0760729,12.3159623,14.2748159,5482.8610981,13551.1120377,0.2203662,949.3020525,445.1833291,1171.3240363,18.0188282,27.7618146,2.9214433,77.8957743),(22307,'red-deer-radius.tif',246,3,189,228.5572775,42.8011098,66.6273974,1.8,42.2523528,66.7492937,0.0815988,15.0233495,14.528571,5513.727808,13588.8828664,0.2530735,935.3213678,367.0105518,1176.5952089,17.940332,27.8005736,2.886697,78.0067533),(22308,'red-deer-radius.tif',246,3,190,229.7296877,42.8633201,66.4638062,1.8,42.4084977,66.5265767,0.0890464,12.3409627,14.2772567,5559.4342716,13685.8898735,0.3027966,958.5798004,450.4862709,1321.8259076,18.0674399,27.8038011,2.9147938,78.1637013),(22309,'red-deer-radius.tif',246,3,191,233.4968058,42.900411,66.2770509,1.8,42.7684962,66.1322854,0.0931164,11.3616969,14.4167913,5645.9293713,13947.1442772,0.3364546,967.4236102,496.9265944,1291.9987907,0.189453,0.267927,2.3561945,0.535854),(22310,'red-deer-radius.tif',246,3,192,233.2069581,42.9611255,66.1437997,1.8,42.891631,65.9924755,0.0915137,11.3984528,14.4672644,5657.4388751,13995.3936755,0.3246007,967.3835577,496.3339286,1349.9966133,18.4280029,27.9062404,2.929551,78.3856593),(22311,'red-deer-radius.tif',246,3,193,231.5280185,43.0641329,65.9560471,1.8,42.9640761,65.7489544,0.092896,11.4573883,15.1513901,5709.6850546,13930.6716683,0.332045,919.4319199,498.3408857,1290.8917835,0.4952475,2.013913,2.2896263,4.129884),(22312,'red-deer-radius.tif',246,3,194,230.6744963,43.1045211,65.8045702,1.8,42.9742967,65.6018696,0.0959178,12.39219,21.5554781,5761.9623506,13926.3853976,0.3526261,646.0717474,464.9672363,894.2411379,18.2574754,27.9839461,2.888404,78.0257943),(22313,'red-deer-radius.tif',246,3,195,231.2470569,43.1527436,65.6203474,1.8,42.9931245,65.419919,0.095748,12.4382517,15.3739629,5896.0691892,13980.1482185,0.3522546,909.3392689,474.0271637,1281.6847255,0.4795542,0.947265,2.2142974,1.986468),(22314,'red-deer-radius.tif',246,3,196,231.2696473,43.1838757,65.484341,1.8,43.0084908,65.3616057,0.0979483,11.5507149,15.9496162,5943.3917719,14075.1167122,0.368614,882.4736927,514.5475251,1254.8850472,0.4739465,1.2130911,2.2455373,2.522322),(22315,'red-deer-radius.tif',246,3,197,232.008727,43.2254939,65.3255228,1.8,43.0135993,65.2282189,0.0991807,11.3674652,15.2958698,6032.2395926,14187.417633,0.3791254,927.5325859,530.6582854,1321.5651993,0.4018905,1.7466704,2.2794226,3.59403),(22316,'red-deer-radius.tif',246,3,198,233.0579718,43.2919624,65.1371058,1.8,43.1610748,65.003011,0.0995372,11.5430916,24.3758305,6159.6040977,14296.0054384,0.3835735,586.4828059,533.6182284,833.1719068,18.7067631,28.1642132,2.8411155,79.3194603),(22317,'red-deer-radius.tif',246,3,199,235.4722387,43.353236,64.9289841,1.8,43.2109382,64.7614668,0.0984396,11.394785,15.3837608,6370.8015938,14471.4048996,0.379075,940.6935712,559.0980057,1354.8115395,19.4866903,28.220867,2.834703,80.8810533),(22318,'red-deer-radius.tif',246,3,200,235.1145216,43.3905064,64.7984782,1.8,43.2770837,64.6584217,0.1041864,11.2438573,15.2576955,6383.3285392,14564.2465623,0.4238171,954.5508726,567.7169661,1372.8729458,0.378906,0.6830825,2.1587989,1.450614),(22319,'red-deer-radius.tif',246,3,201,233.1929383,43.4789872,64.6020328,1.8,43.3844708,64.4310788,0.1096263,11.9575533,15.3453318,6408.3664675,14578.2907647,0.4652146,950.0146958,535.9262315,1367.6230537,0.4933509,1.7466704,2.2794226,3.59403),(22320,'red-deer-radius.tif',246,3,202,232.3419938,43.5175328,64.4623209,1.8,43.3877784,64.3668882,0.11316,11.802334,15.5517946,6464.4936082,14639.1711322,0.4937511,941.3171597,547.7300999,1346.8781428,0.189453,0.267927,2.3561945,0.535854),(22321,'red-deer-radius.tif',246,3,203,231.1619265,43.5601553,64.3006577,1.8,43.4406633,64.21667,0.1186448,11.7469495,15.5331284,6503.5763693,14714.4006679,0.5397885,947.2915113,553.6395957,1364.0780822,19.048495,28.3597916,2.7437183,80.8541253),(22322,'red-deer-radius.tif',246,3,204,233.177548,43.6308792,64.0706511,1.8,43.5542106,63.9350077,0.116492,12.2196613,15.578371,6752.4472989,14851.7715396,0.5250041,953.358443,552.5887439,1383.8208277,0.4739465,1.2130911,2.2455373,2.522322),(22323,'red-deer-radius.tif',246,3,205,233.3880735,43.6565205,63.9320246,1.8,43.5919656,63.8394472,0.122736,11.9736594,15.3457322,6812.286739,15002.9809458,0.5830279,977.6647187,568.9394101,1413.7768447,0.509125,1.787296,2.1293956,3.815988),(22324,'red-deer-radius.tif',246,3,206,233.9749801,43.7043529,63.7749553,1.8,43.6706543,63.783565,0.1254765,11.8383842,15.1573748,6942.9263281,15148.6613409,0.610749,999.4251357,586.4758421,1381.9045825,0.4018905,1.2130911,2.2455373,2.522322),(22325,'red-deer-radius.tif',246,3,207,234.0072072,43.7428217,63.6232748,1.8,43.6816864,63.5518349,0.132668,11.6143135,15.7619099,6972.7322972,15288.5267954,0.6824344,969.9666424,600.3568185,1411.2970102,19.6116238,28.5848103,2.7253872,81.6119373),(22326,'red-deer-radius.tif',246,3,208,234.6692487,43.7709678,63.4619245,1.8,43.7357049,63.4268066,0.1375529,13.3438781,15.7645096,7104.1386409,15453.1423214,0.7353661,980.2488423,532.389352,1315.5194128,19.5829166,28.6825836,2.734099,81.7229163),(22327,'red-deer-radius.tif',246,3,209,234.0486466,43.8638733,63.1828484,1.8,43.7814611,63.0593594,0.1367601,12.4642002,15.5798258,7299.0010077,15500.0294821,0.7250438,994.8782285,585.5972207,1456.8589964,0.339577,1.2708894,2.0344439,2.74428),(22328,'red-deer-radius.tif',246,3,210,232.3083528,43.8892137,63.0435497,1.8,43.8225585,62.945575,0.1429443,12.3798346,15.548658,7317.8931272,15586.5485248,0.7857553,1002.4368989,591.113965,1380.5120403,0.339096,0.6830825,2.1587989,1.450614),(22329,'red-deer-radius.tif',246,3,211,230.5391166,43.9270193,62.8901376,1.8,43.9246284,62.7748219,0.1437127,12.7156145,15.9943367,7374.4325417,15679.7473385,0.7881189,980.3312047,579.9509352,1360.3714304,19.9405902,28.8995012,2.7014012,82.9246442),(22330,'red-deer-radius.tif',246,3,212,231.2348426,43.9622141,62.6953757,1.8,43.9343301,62.5611878,0.1384539,12.9926181,15.4059509,7588.058115,15860.3961409,0.7340665,1029.4980344,584.0284121,1496.1867726,20.2085339,28.9912616,2.7100977,84.3562173),(22331,'red-deer-radius.tif',246,3,213,230.8424185,43.9953993,62.5239568,1.8,43.9782849,62.4256805,0.1340479,13.7978917,15.5438704,7703.1060796,16058.1617189,0.687197,1033.0864363,558.2813841,1387.6635694,20.435197,28.9807363,2.6954871,84.7351233),(22332,'red-deer-radius.tif',246,3,214,230.2952002,44.0416122,62.316745,1.8,44.0248692,62.1442206,0.1308994,13.3665943,15.6071713,7871.9368864,16208.0835662,0.6539236,1038.5023159,588.9261485,1432.6952975,20.6515859,28.9317745,2.730682,85.3169463),(22333,'red-deer-radius.tif',246,3,215,229.4464528,44.0655701,62.1589999,1.8,44.0527725,62.0150921,0.1287175,13.5605863,15.7460676,7983.670405,16407.6368978,0.6300943,1042.014893,588.7407993,1439.1536459,20.8648588,28.9640118,2.863293,86.0557173),(22334,'red-deer-radius.tif',246,3,216,229.2393861,44.0788824,61.9649231,1.8,44.1552863,61.7697529,0.1226199,14.4091059,15.8204509,8186.1386709,16668.595225,0.5715868,1053.6106272,568.1225994,1420.2101172,21.3014581,29.2034287,2.7767476,86.3236443),(22335,'red-deer-radius.tif',246,3,217,226.9781189,44.1632434,61.6796835,1.8,44.109214,61.4416772,0.1169728,13.4306082,15.8600665,8395.1114865,16731.078449,0.515253,1054.9185585,625.0730699,1506.9922406,21.6338819,29.2519358,2.8526172,86.8594983),(22336,'red-deer-radius.tif',246,3,218,225.0819431,44.2023636,61.4649795,1.8,44.1129565,61.2067424,0.1082363,13.0214864,15.9669801,8584.5667046,16831.1074603,0.4377623,1054.1196486,659.2616564,1528.5222464,21.7423908,29.2715614,2.7707014,87.4413213),(22337,'red-deer-radius.tif',246,3,219,223.4684583,44.2659748,61.2511716,1.8,44.2670591,61.0040735,0.0949563,13.8405896,16.1683048,8833.4788772,16997.7039188,0.334816,1051.2978414,638.229953,1534.1283105,22.1220094,29.4110147,2.8809903,88.1341233),(22338,'red-deer-radius.tif',246,3,220,223.2323839,44.3258493,61.0130167,1.8,44.2512844,60.7120495,0.0837952,13.4611697,16.2319166,9155.1039967,17232.6955125,0.2606319,1061.6550078,680.112073,1549.9687822,22.3452616,29.5461657,2.8888381,88.9569453),(22339,'red-deer-radius.tif',246,3,221,222.456955,44.3603724,60.8043847,1.8,44.2894841,60.5255061,0.080174,13.0702859,23.0784015,9345.0668723,17444.1422227,0.2378103,755.8644067,714.9856487,1044.7112476,22.3103798,29.7350693,2.916704,89.1138933),(22340,'red-deer-radius.tif',246,3,222,221.597951,44.4070578,60.6137985,1.8,44.3647761,60.4054561,0.076636,12.9138019,16.4786693,9530.0028455,17688.3276457,0.2164858,1073.4075284,737.970345,1592.3291393,22.4835938,29.8783659,2.9242992,90.0286533),(22341,'red-deer-radius.tif',246,3,223,222.1788647,44.4878825,60.4334201,1.8,44.5173117,60.2323363,0.0657621,13.2862339,16.5376449,9817.3069815,17962.7769451,0.1599101,1086.175033,738.9081848,1564.3724021,22.6667182,29.979104,2.8598208,90.8324343),(22342,'red-deer-radius.tif',246,3,224,221.0632298,44.5016459,60.3195121,1.8,44.5704474,60.1500701,0.0724539,12.7636388,16.5618738,9937.7457975,18118.7468293,0.1930763,1094.0034366,778.5981688,1679.0810548,22.7952824,30.1563713,2.7820867,90.5835483),(22343,'red-deer-radius.tif',246,3,225,220.4407353,44.598487,59.9991613,1.8,44.6561039,59.7294764,0.0663428,13.5210291,16.7961599,10233.6255263,18286.7975599,0.1614694,1088.7487175,756.8673537,1651.1729453,22.9910991,30.3432505,0.2782997,91.9691523),(22344,'red-deer-radius.tif',246,3,226,220.0693029,44.6026348,59.7426796,1.8,44.7264836,59.5136487,0.0641323,13.9241152,16.819902,10547.7552698,18416.3212826,0.1506491,1094.9125205,757.5170928,1721.2406225,23.2368937,30.6855381,0.2944136,92.0341623),(22345,'red-deer-radius.tif',246,3,227,218.4392641,44.5703221,59.6068871,1.8,44.7382642,59.4736499,0.0727442,14.208081,17.2244499,10598.2328127,18539.8571338,0.1923139,1076.3686079,745.9299237,1677.8954648,23.2332863,30.8127701,0.2867454,93.3278283),(22346,'red-deer-radius.tif',246,3,228,218.2810002,44.5505216,59.4420999,1.8,44.7427294,59.2480175,0.0778219,13.8537955,16.7940835,10764.6197085,18703.154169,0.2198827,1113.6751909,777.0159229,1658.5332183,23.3721777,31.0483354,0.2908723,93.1899213),(22347,'red-deer-radius.tif',246,3,229,217.2941104,44.5311834,59.3250879,1.8,44.6871064,59.1591681,0.0853663,13.6352593,16.9249248,10829.3744231,18858.8648481,0.263278,1114.2657986,794.2184411,1655.3712916,23.2482826,31.3583347,0.2816191,93.7717443),(22348,'red-deer-radius.tif',246,3,230,223.5333257,44.7098843,58.8784946,1.8,44.9046469,58.7793206,0.01717,13.9279447,17.0757973,11887.4120782,19552.0122867,0.0109822,1145.0131402,853.493632,1775.342813,24.3133535,31.5932404,0.285713,95.0844513),(22349,'red-deer-radius.tif',246,3,231,224.863902,44.6561664,58.7388637,1.8,44.899587,58.7249364,0.0112098,14.1947881,17.1972383,12173.8315496,19922.4090625,0.0047091,1158.4656018,857.6268602,1678.1918647,24.5729845,31.9569644,0.2823713,96.6920133),(22350,'red-deer-radius.tif',246,3,232,225.5749747,44.6220171,58.5413089,1.8,44.8419015,58.4511035,0.00624,14.5855282,17.1817372,12414.7997442,20239.3683247,0.0014639,1177.9582071,851.1724456,1748.4895529,24.7112705,32.1919617,0.2863836,97.4957943),(22351,'red-deer-radius.tif',246,3,233,228.9068916,44.8313037,58.0710553,1.8,45.0573604,57.8757771,-0.0699708,14.7767054,17.2715198,13253.0483118,20827.4620556,0.1864801,1205.8847315,896.8879009,1780.4287884,25.6434013,32.3737428,0.2847304,99.3982114),(22352,'red-deer-radius.tif',246,3,234,232.3849016,44.9103891,57.7555634,1.8,45.1678717,57.6157483,-0.1124165,14.5433564,17.3327197,13900.844443,21417.1931308,0.487401,1235.6510427,955.8209322,1847.3565728,26.2077215,32.7189225,0.2997761,100.3129714),(22353,'red-deer-radius.tif',246,3,235,237.2692099,44.9360102,57.4386226,1.8,45.1730274,57.299563,-0.1517023,15.1540059,17.5204432,14519.8280237,22217.5655938,0.903109,1268.0938113,958.1511402,1875.937276,26.6035222,33.1851144,0.4048918,102.2534704),(22354,'red-deer-radius.tif',246,3,236,240.1241163,44.9032276,57.2349561,1.8,45.1886628,57.0773137,-0.1544981,15.1563782,18.672362,14991.2852976,22753.9984586,0.9477035,1218.592404,989.1073668,1768.3247778,27.0942513,33.6080224,0.405632,105.3766564),(22355,'red-deer-radius.tif',246,3,237,248.0070749,44.9824409,56.7762387,1.8,45.2459211,56.6357328,-0.2356933,15.9930311,18.3886844,16123.2621908,23954.8930787,2.2539821,1302.6974911,1008.1429916,1967.1594106,27.9679567,34.3244711,0.4389613,106.7162914),(22356,'red-deer-radius.tif',246,3,238,254.9411134,45.0073564,56.4423075,1.8,45.20455,56.2968861,-0.2777445,16.2736232,19.6405086,16990.1878045,25163.3062233,3.1943558,1281.1942244,1044.0322728,1995.364341,28.5934248,35.3343812,0.4492601,110.4213004),(22357,'red-deer-radius.tif',246,3,239,261.996773,45.0490951,56.1069019,1.8,45.2552492,56.0084262,-0.3126337,16.2658298,19.147102,17774.0153505,26571.7015981,4.1306705,1387.7662316,1092.7210938,2137.9064854,29.050568,36.1219856,1.0672638,111.8909554),(22358,'red-deer-radius.tif',246,3,240,269.2969688,45.0406928,55.8454617,1.8,45.2528891,55.7441438,-0.339683,16.9031259,20.2624998,18765.4423296,28137.4164298,4.9826408,1388.6448718,1110.1758595,2210.625997,29.436001,36.836309,0.9942055,113.7664444),(22359,'red-deer-radius.tif',246,3,241,274.1645492,45.027447,55.5724164,1.8,45.2769061,55.3831065,-0.3345799,17.42678,20.7031253,19362.0617855,29223.1401643,4.9271228,1411.5327897,1111.0521744,2229.4809593,29.8550973,37.8152174,1.0690506,115.7069434),(22360,'red-deer-radius.tif',246,3,242,282.1164756,44.9634098,55.2832206,1.8,45.2180239,55.0631022,-0.3470373,18.0450581,20.8101943,20114.7439516,30835.7249186,5.4390639,1481.7605478,1114.6954355,2191.8447898,30.2985229,39.5171892,0.9694966,119.9858884),(22361,'red-deer-radius.tif',246,3,243,293.6252448,44.9701141,54.9175498,1.8,45.1745342,54.6919132,-0.3653399,17.9209958,21.8342092,21132.6332633,32972.3576157,6.2463652,1510.1237389,1179.2108788,2249.3156334,31.1041268,40.7883113,0.9570262,123.8478454),(22362,'red-deer-radius.tif',246,3,244,308.1358401,44.9466398,54.5494977,1.8,45.0820321,54.3313262,-0.3650982,17.962037,23.2575825,22183.9922008,35580.1785362,6.5467711,1529.831339,1235.0488005,2261.2160843,31.6603918,41.3029266,0.9713438,129.2983235),(22363,'red-deer-radius.tif',246,3,245,332.9502085,44.7726363,54.2472355,1.8,44.8050365,54.0357979,-0.3364255,18.095876,22.0274678,23475.5890521,37868.0857472,6.0472621,1719.1302278,1297.2894497,2557.8099199,32.2853732,41.4586195,0.5372847,154.0697406),(22364,'red-deer-radius.tif',246,3,246,348.6454175,44.5930592,53.8561993,1.8,44.5250158,53.6984472,-0.3070891,17.9530777,22.4469389,24740.9029884,40628.1065519,5.3096572,1809.9620047,1378.087001,2650.067353,31.8828545,41.776427,0.3518706,131.3307605),(22365,'red-deer-radius.tif',246,3,247,370.0804909,44.2592422,53.3723994,1.8,44.0659441,53.3440497,-0.2607775,18.3020454,21.9759803,26670.0142056,44438.7770677,4.1003231,2022.1522034,1457.2149522,2959.4003568,32.5873512,42.6669019,0.3442187,148.1641926),(22366,'red-deer-radius.tif',246,3,248,402.2685367,44.1340181,52.9577925,1.8,43.7022116,53.2133124,-0.2155487,18.1675075,21.7838184,28467.526818,50203.5598153,3.0670392,2304.6262544,1566.9472998,3332.2054735,32.0272458,43.0875437,0.3453901,132.2264795),(22367,'red-deer-radius.tif',246,3,249,444.9524672,43.801732,52.6902532,1.8,43.3244156,53.1082241,-0.1288042,19.0182749,22.8303287,30453.0918664,57423.8737697,1.2235431,2515.2451625,1601.2541629,3691.1869785,31.7789808,43.4607825,0.3562197,132.2914895),(22368,'red-deer-radius.tif',246,3,250,445.6187831,43.4015488,53.0219335,1.8,43.051065,53.1538066,-0.0949934,19.1349949,21.7259363,30841.0834024,56493.521209,0.6681793,2600.2801614,1611.7633498,3621.787658,31.449239,43.723848,0.448145,132.7813745),(22369,'red-deer-radius.tif',246,3,251,432.54022,43.3194649,53.4443989,1.8,42.8856003,53.2845066,-0.1045742,19.2897048,21.698995,29651.1105496,52483.5188355,0.7854897,2418.7073589,1537.1469287,3439.0424208,31.0417707,43.6667589,0.4248322,149.8748466),(22370,'red-deer-radius.tif',246,3,252,411.4310716,43.4751127,53.7299754,1.8,42.8449395,53.3711891,-0.1714054,18.7188955,22.4612574,25750.2315632,49142.3191246,1.9949747,2187.8703537,1375.6277247,3119.9442311,30.1126061,43.6091836,0.4111667,133.2062495),(22371,'red-deer-radius.tif',246,3,253,379.4675493,43.5042443,53.6610926,1.8,42.8357307,53.5246954,-0.2260403,18.1746431,22.7659225,21000.9201491,46352.0692002,3.1767699,2036.0285948,1155.5066045,2869.976327,28.1900695,42.9369217,0.408368,126.5730845),(22372,'red-deer-radius.tif',246,3,254,364.8009306,43.2101759,53.4908531,1.8,42.5775042,53.416589,-0.2235792,18.4059485,22.5726384,18657.8696238,44079.2554952,2.988951,1952.7737375,1013.6869421,2633.0583961,27.0978751,43.6334567,0.401471,133.8451955),(22373,'red-deer-radius.tif',246,3,255,362.5913268,42.420082,53.4211208,1.8,41.9040623,53.2310972,-0.1602393,16.8264197,20.3304857,17245.8533861,41551.9262148,1.5384521,2043.8235859,1024.9270883,2683.3188036,26.8252801,40.4370109,0.4301172,132.5863445),(22374,'red-deer-radius.tif',246,3,256,362.8849596,41.9337188,53.3355715,1.8,41.2935832,53.1839229,-0.0937547,17.0998737,20.9303241,15721.2578101,39543.8957432,0.5300668,1889.3112033,919.3785948,2618.7584423,26.4697825,37.9549594,0.2522425,119.2359635),(22375,'red-deer-radius.tif',246,3,257,380.4106721,41.6181206,53.1774608,1.8,40.8555937,52.965735,-0.072989,17.0734083,19.8056755,14819.3839511,39364.2461213,0.3371666,1987.5235327,867.9804106,2690.0027956,25.8997827,37.8550609,0.0902068,112.8326434),(22376,'red-deer-radius.tif',246,3,258,391.8095343,40.8980636,53.2089644,1.8,40.4831846,52.9466585,-0.0688963,17.3062576,19.7566879,13670.9114185,37695.9886964,0.3094772,1908.0115523,789.9403651,2512.5836007,25.3377906,38.0611973,0.0947157,129.5472095),(22377,'red-deer-radius.tif',246,3,259,366.8285054,39.3993304,53.2967409,1.8,39.8588439,53.0277749,-0.0382335,17.2047225,20.1561995,11407.1305903,30552.8689552,0.0893278,1515.8050482,663.0232257,2076.9148125,24.7920394,37.5351291,3.1062538,164.5917907),(22378,'red-deer-radius.tif',246,3,260,297.2806178,37.3494852,53.4338016,1.8,38.3854408,53.2170681,0.0229574,12.7652086,20.8156145,8136.5465821,20030.8062614,0.0261089,962.2971383,637.4002058,1353.1659445,23.5079881,36.1080719,3.0628087,155.4553447),(22379,'red-deer-radius.tif',246,3,261,202.5099386,34.6556032,52.9464372,1.8,35.8881333,53.3114145,0.0079489,14.0082262,21.0632891,5264.1279356,9641.2072469,0.0021325,457.7256285,375.7883302,703.1110456,20.9926913,33.7056002,2.9949262,108.5806264),(22380,'red-deer-radius.tif',246,3,262,133.7119419,32.5794398,52.3228506,1.8,32.9484848,52.4204732,-0.5795639,10.463217,12.0480721,2600.9384418,4219.7117322,6.6840481,350.2395824,248.5792314,510.5907173,19.0328215,23.5295745,0.0563918,107.6356715),(22381,'red-deer-radius.tif',246,3,263,72.2852952,31.2845378,52.802191,1.8,31.9093337,52.5609037,-0.5376929,9.4977714,12.1453834,979.7821309,2171.55332,3.1601155,178.7966051,103.1591613,242.6175204,8.6913732,16.634146,2.2188532,43.5216872),(22382,'red-deer-radius.tif',246,3,264,31.0145915,28.3442316,53.9705171,1.8,29.3052475,53.6520679,0.9685779,13.0931229,7.9744945,218.6706989,286.8261283,3.5103834,35.9679384,16.7011874,37.7413647,5.9494333,14.096118,2.2035452,34.5389222),(22383,'red-deer-radius.tif',246,3,265,11.7856413,27.6392152,53.99914,1.8,27.6478067,53.9386143,0.938207,1.9550507,5.2435162,5.3764223,64.9135859,1.2776444,12.3797817,2.7500167,13.3373476,3.609062,10.5346771,2.2286849,24.3655831),(22384,'red-deer-radius.tif',246,3,266,1.278282,27.511022,53.6849565,1.8,27.5735037,53.8084601,0.9239985,0.7831015,3.3665507,0.1339479,2.4105037,0.1356752,0.7160159,0.171048,0.7489584,1.7932769,6.4106819,2.1669955,14.2382131),(22385,'red-deer-radius.tif',246,3,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22386,'red-deer-radius.tif',246,3,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22387,'red-deer-radius.tif',246,3,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22388,'red-deer-radius.tif',246,3,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22389,'red-deer-radius.tif',246,3,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22390,'red-deer-radius.tif',246,3,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22391,'red-deer-ulna.tif',246,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22392,'red-deer-ulna.tif',246,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22393,'red-deer-ulna.tif',246,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22394,'red-deer-ulna.tif',246,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22395,'red-deer-ulna.tif',246,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22396,'red-deer-ulna.tif',246,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22397,'red-deer-ulna.tif',246,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22398,'red-deer-ulna.tif',246,4,8,8.03669,39.4945501,27.0088893,1.8,39.4795342,27.1121577,-1.3514154,2.7879822,4.0245163,12.1075589,21.8895224,1.2760109,5.4390442,4.3427677,8.3512521,5.494138,7.8113488,1.3258177,21.8163372),(22399,'red-deer-ulna.tif',246,4,9,25.1037906,39.8540582,26.1966195,1.8,39.8671107,26.2245571,-1.3337036,3.8006298,7.7059062,76.6579218,258.281915,3.953146,33.5173965,20.1697945,43.4490522,7.3886684,15.4563956,1.3734008,37.2103122),(22400,'red-deer-ulna.tif',246,4,10,47.2193713,40.333962,23.7577282,1.8,40.3214135,23.3431319,-1.4088769,4.2971336,16.3376285,171.557767,1620.8095391,7.66536,99.2071489,39.9237682,109.6834177,8.4454381,19.693094,1.4357019,47.9575892),(22401,'red-deer-ulna.tif',246,4,11,81.9111998,40.6863245,20.0382472,1.8,40.5173894,21.0312049,-1.4567844,5.1864226,17.0271839,299.8721894,5133.8915934,13.4751774,301.51149,57.8186958,319.1172032,8.9551254,31.6545353,1.4568344,87.0355037),(22402,'red-deer-ulna.tif',246,4,12,111.6339466,40.8437442,18.8101447,1.8,40.7191178,19.8941435,-1.4757685,5.3716395,19.3733014,494.6470604,8088.5865034,18.4381484,417.5120365,92.084932,443.0277095,9.2080546,34.1025989,1.465047,83.0546799),(22403,'red-deer-ulna.tif',246,4,13,129.4240625,40.968302,18.2725009,1.8,40.8446814,19.2930926,-1.4922082,5.7141144,20.8728931,734.4432145,10686.0753368,21.4377287,511.9594711,128.5314157,546.8529723,9.4894155,36.0483877,1.4549157,83.739595),(22404,'red-deer-ulna.tif',246,4,14,147.0877066,41.0482415,18.0407333,1.8,40.9717874,18.8347856,-1.5099511,6.4620181,21.861614,1045.5482877,13593.3343361,24.4239732,621.7900622,161.7990345,668.5024428,0.5279194,3.9965162,1.4758446,8.4278716),(22405,'red-deer-ulna.tif',246,4,15,165.0780154,41.1001507,17.9148408,1.8,41.1143338,18.4802351,-1.5241019,7.5141452,22.709042,1472.3053691,16524.5122806,27.4530575,727.6622365,195.9378397,791.38494,0.189453,0.7811349,1.815775,1.6725723),(22406,'red-deer-ulna.tif',246,4,16,179.5821121,41.2012256,17.9954406,1.8,41.3200791,18.3225327,-1.5295759,16.1935986,45.4109411,1966.9741796,19188.4026566,29.8795254,422.5502088,121.4661566,438.8000018,0.5300535,1.7466707,1.3521274,3.8809987),(22407,'red-deer-ulna.tif',246,4,17,190.9829038,41.5301106,18.1345586,1.8,41.549646,18.3886769,-1.5285266,8.786664,24.0564406,2430.2290031,21564.2622933,31.7736454,896.4028642,276.5815319,991.5379625,0.5396686,1.7973093,1.8925469,4.1948948),(22408,'red-deer-ulna.tif',246,4,18,198.6241024,41.6335041,18.6286869,1.8,41.6033244,18.7160877,-1.5301013,8.7863587,24.5015373,2682.1790501,23751.8724193,33.0492243,969.4033552,305.2662815,1073.0377388,0.5683591,4.751458,1.6506263,10.257392),(22409,'red-deer-ulna.tif',246,4,19,199.6569567,41.6947813,19.5074198,1.8,41.6767137,19.3422627,-1.5412609,8.6010055,24.5417695,2747.0690959,25490.7681249,33.2471398,1038.6687136,319.3892953,1142.7007476,0.3789061,1.0202358,1.9513027,2.2084264),(22410,'red-deer-ulna.tif',246,4,20,200.7273458,41.7497323,20.5167391,1.8,41.7700367,20.0327258,-1.55603,8.9603301,24.8000353,2790.6546789,27111.9987776,33.4472636,1093.2242002,311.4455206,1200.3439071,1.4047183,14.6406874,1.7529646,37.0073951),(22411,'red-deer-ulna.tif',246,4,21,204.7206422,41.8832364,21.1644374,1.8,41.9150527,20.5233229,-1.5660672,9.0636587,25.4488551,2977.056686,28577.76763,34.119344,1122.9490485,328.460811,1237.4911137,2.0763324,24.6507449,1.7018242,61.0702407),(22412,'red-deer-ulna.tif',246,4,22,208.1831653,42.0246797,21.8904364,1.8,42.0311243,21.1303459,1.5691232,9.3239093,25.8492133,3046.3599908,30187.5718461,34.6970971,1167.8332903,326.7256132,1283.4529087,2.2167383,26.1541271,1.6942528,67.0486869),(22413,'red-deer-ulna.tif',246,4,23,214.5719132,42.2125377,22.685023,1.8,42.1919298,21.7495928,-1.5707156,9.2486688,26.0045878,3088.573513,32619.4559939,35.7619853,1254.3731225,333.9478996,1368.0960173,2.0556332,26.1101752,1.679851,69.5440814),(22414,'red-deer-ulna.tif',246,4,24,219.3145679,42.4505188,23.602678,1.8,42.3821306,22.5697661,-1.5643586,8.8623067,41.5391177,3012.5234452,35256.9025845,36.5509132,848.7638777,339.9254327,915.193163,2.1210515,27.7870193,1.6663944,71.0216237),(22415,'red-deer-ulna.tif',246,4,25,223.4831065,42.7318578,24.3900846,1.8,42.6263584,23.5587273,-1.5612363,9.3261145,40.7319983,2993.0656261,37814.2999485,37.2437803,928.3683964,320.9338262,993.1606931,2.0946303,27.9422355,1.6522484,71.7144258),(22416,'red-deer-ulna.tif',246,4,26,231.383242,42.8816134,25.2296276,1.8,42.7613816,24.5321411,-1.5608912,9.1759151,26.8955565,3036.6665389,40891.6881488,38.5600902,1520.3882503,330.9388226,1626.5524607,2.3732454,28.25138,1.611043,72.805175),(22417,'red-deer-ulna.tif',246,4,27,239.1874685,43.0374046,26.1509497,1.8,42.9157124,25.4855096,-1.5593596,9.0073473,27.8503723,3045.1789836,43989.4640926,39.8593642,1579.4928551,338.0772261,1688.5921916,0.3789061,0.5358541,0.7853982,1.0717082),(22418,'red-deer-ulna.tif',246,4,28,243.6035562,43.1775994,27.1407494,1.8,43.0426662,26.410068,-1.559499,9.4185567,27.8243403,2981.2833562,46378.0295524,40.5954111,1666.8150644,316.5329314,1769.6586605,0.59472,1.3661653,2.1587989,3.3261037),(22419,'red-deer-ulna.tif',246,4,29,249.6980621,43.2965091,28.0399456,1.8,43.1446706,27.3380285,-1.5606213,8.7505643,37.4790505,2921.5743027,49050.7393139,41.6120353,1308.7508542,333.8726729,1370.4363794,2.1448717,34.6885353,1.6035715,85.4929514),(22420,'red-deer-ulna.tif',246,4,30,255.4472173,43.4241159,28.9811979,1.8,43.2555817,28.4153701,-1.5605684,8.444933,28.4452402,2856.7803011,51943.1861439,42.5700826,1826.076554,338.2833603,1921.6586335,2.1984887,37.9478734,1.625741,101.3577705),(22421,'red-deer-ulna.tif',246,4,31,260.9894471,43.5568779,30.0257453,1.8,43.4038081,29.4967845,-1.5581448,8.2627376,28.5415033,2771.0688123,54649.1640018,43.4912792,1914.7261951,335.3693354,2007.3947685,2.1139597,31.884445,1.63025,81.5009737),(22422,'red-deer-ulna.tif',246,4,32,263.326459,43.6205028,31.3867211,1.8,43.4702965,30.7537152,-1.5600847,8.2086506,28.126797,2657.9740838,55506.9098683,43.8827078,1973.4529305,323.801588,2061.6097992,1.874619,30.530755,1.6142472,81.0760986),(22423,'red-deer-ulna.tif',246,4,33,265.02365,43.7231964,32.7946317,1.8,43.5609113,32.3445773,-1.5603593,8.9938699,33.464228,2589.4863635,56267.6595843,44.165797,1681.42709,287.9168142,1739.9752775,2.0309994,31.0795381,1.5951817,80.5941005),(22424,'red-deer-ulna.tif',246,4,34,268.4916875,43.7698262,34.1364325,1.8,43.6029368,33.6543693,-1.5574791,8.7629322,27.4687745,2536.6265503,57508.6250098,44.740679,2093.5999541,289.4723457,2178.369649,2.297624,41.4941075,1.5570986,120.1888282),(22425,'red-deer-ulna.tif',246,4,35,272.3725427,43.7780775,35.8253782,1.8,43.5908344,35.2772855,-1.5517653,8.3085428,30.1659412,2525.9590522,58955.5291948,45.3789845,1954.3739342,304.0195012,1985.3240447,2.6647552,43.6153642,1.5273454,123.0440877),(22426,'red-deer-ulna.tif',246,4,36,283.0208002,43.7769103,37.9357095,1.8,43.5848219,37.2369139,-1.541873,8.3774919,29.1589551,2665.0116535,61525.2707036,47.1306836,2109.995726,318.1156929,2187.6438568,13.1804308,54.7679859,1.595013,235.3855142),(22427,'red-deer-ulna.tif',246,4,37,294.5407004,43.8534731,39.6757158,1.8,43.7466531,38.8576588,-1.5429715,8.7925681,28.4581024,2946.5253207,63717.566905,49.0521198,2238.9956274,335.1154375,2335.5529909,15.0282909,52.8791219,1.5421303,238.4627318),(22428,'red-deer-ulna.tif',246,4,38,295.2955731,44.0255142,40.4807372,1.8,43.9450352,39.6276782,-1.5517603,9.6737954,28.152596,3213.3816537,60081.714533,49.1980967,2134.1447351,332.1738293,2245.1254968,2.3468799,40.7024317,1.4822435,106.0885194),(22429,'red-deer-ulna.tif',246,4,39,275.0655643,44.0438768,39.7100098,1.8,43.9346167,39.1887274,-1.5414352,8.8614399,26.2726705,3081.6311151,50108.665546,45.8047508,1907.2543674,347.7573777,2023.405002,2.2323258,38.6270535,1.4774721,100.1560423),(22430,'red-deer-ulna.tif',246,4,40,252.8125807,44.0180708,38.9677489,1.8,43.8950187,38.7058953,-1.5255277,15.1616654,24.584075,2891.4923227,41564.9977863,42.0491429,1690.7285649,190.7107326,1808.2656009,0.189453,0.5991031,1.8925469,1.2936662),(22431,'red-deer-ulna.tif',246,4,41,238.2864809,44.0480047,38.305151,1.8,43.8996496,38.0038639,-1.5082995,9.4057323,23.1451176,2778.2958287,34944.8118888,39.5594967,1509.8135367,295.3832571,1628.9169785,2.4842837,34.0277905,1.4367731,94.5453483),(22432,'red-deer-ulna.tif',246,4,42,226.8551045,44.0295351,37.9990844,1.8,43.8523129,37.6995389,-1.4925373,8.8700919,22.0855154,2662.9183596,30285.7782226,37.5780949,1371.2959673,300.2131631,1490.7434088,2.6112334,33.5465641,1.4177176,86.5725467),(22433,'red-deer-ulna.tif',246,4,43,218.0973025,43.9982923,37.8834463,1.8,43.7880531,37.5642897,-1.4764901,10.0768531,21.18443,2559.2714215,26752.3328547,36.0272268,1262.8299577,253.9752644,1381.0888926,2.6179467,32.2671392,1.4056476,86.6264027),(22434,'red-deer-ulna.tif',246,4,44,211.4685756,43.992372,37.8639358,1.8,43.7851154,37.5722818,-1.4617503,9.505235,20.2646106,2477.1621642,23879.9815232,34.827324,1178.4081147,260.6103033,1299.2989994,2.6571263,30.0610094,1.386997,78.7915082),(22435,'red-deer-ulna.tif',246,4,45,202.7898022,44.0010562,37.9070508,1.8,43.8080467,37.7183394,-1.4483398,8.4784691,19.5631336,2385.2713521,21257.0838432,33.2940027,1086.5889034,281.3327876,1207.1556223,2.4319895,28.6092903,1.3708034,74.8264585),(22436,'red-deer-ulna.tif',246,4,46,196.5405564,43.9988778,38.1450726,1.8,43.7931988,37.9025344,-1.4355702,8.4866645,19.0349254,2343.8211533,19124.6803127,32.161408,1004.7152777,276.1769553,1125.9474431,2.4979175,28.3863623,1.3760186,74.6695104),(22437,'red-deer-ulna.tif',246,4,47,194.1847281,43.9769577,38.45721,1.8,43.7732273,38.3770589,-1.4191877,8.4927558,18.6056066,2289.7686469,17414.2040144,31.6259086,935.9654009,269.614329,1057.045369,2.3148461,22.6663753,1.3602868,64.4042314),(22438,'red-deer-ulna.tif',246,4,48,192.9364756,43.9243247,38.6942163,1.8,43.7199168,38.6594583,-1.3968638,9.2267053,18.1926651,2272.8911017,16035.0627806,31.1930475,881.402625,246.338321,1001.3340009,2.473985,24.6972942,1.2830133,61.2810448),(22439,'red-deer-ulna.tif',246,4,49,189.7179558,44.0108551,38.906387,1.8,43.7739082,38.8644329,-1.38026,9.6223409,17.7512894,2320.1772244,14720.5907553,30.4855611,829.2688173,241.1239906,957.1675783,2.8825853,24.2655247,1.2613908,66.6474729),(22440,'red-deer-ulna.tif',246,4,50,183.6965945,44.0419988,39.1476821,1.8,43.804713,39.1857154,-1.3641606,9.1919793,17.3617254,2346.7792046,13650.5334565,29.3273435,786.2429078,255.3072763,916.529243,2.6233252,24.2040619,1.2440953,61.1319838),(22441,'red-deer-ulna.tif',246,4,51,183.9120144,44.0604518,39.5355504,1.8,43.8197901,39.4912537,-1.3478558,9.3046215,17.1081664,2460.6859935,12983.478709,29.1535954,758.9053322,264.458474,895.0946205,2.6968575,23.9716117,1.224051,60.2822337),(22442,'red-deer-ulna.tif',246,4,52,191.4654724,44.1168467,39.9789574,1.8,43.9264553,39.9420017,-1.3322,10.0540487,16.9312714,2653.8264773,12544.0467901,30.1284925,740.8803787,263.9559997,892.8540693,2.8671226,24.0635189,1.1917519,57.6489321),(22443,'red-deer-ulna.tif',246,4,53,193.7388677,44.1363987,40.4081629,1.8,43.9704873,40.2915858,-1.3117185,10.82071,16.8869152,2851.5198833,12193.0056297,30.1705365,722.0386615,263.5242874,882.6550427,2.9691573,24.0314287,1.1741859,62.5825981),(22444,'red-deer-ulna.tif',246,4,54,193.9257042,44.1661445,40.9676832,1.8,44.0803819,40.8571886,-1.2905152,12.6480189,16.8697584,3203.9772172,11934.9929036,29.847692,707.4785916,253.3185035,887.5941317,2.8952969,23.9895725,1.1389401,59.0154954),(22445,'red-deer-ulna.tif',246,4,55,198.2324831,44.2453864,41.5523766,1.8,44.2115677,41.4338174,-1.270401,14.7247277,16.8639783,3732.3047373,11801.8113466,30.1460222,699.8236776,253.4719013,909.1056597,3.0369491,24.574184,1.1243884,59.4403705),(22446,'red-deer-ulna.tif',246,4,56,203.4687026,44.4498322,42.1160085,1.8,44.514219,41.9627088,-1.2573009,16.2593573,16.8807141,4546.928691,11702.6673924,30.6864142,693.2566543,279.6499638,943.6018855,3.263106,21.8725971,1.1420183,57.5458402),(22447,'red-deer-ulna.tif',246,4,57,209.1910689,45.0740259,42.7852499,1.8,45.3236524,42.5472601,-1.2920321,16.9916708,17.018283,6266.2037964,11290.6517353,32.2252797,663.4424709,368.7809088,1015.1453485,3.31253,22.7090898,1.122073,60.9369538),(22448,'red-deer-ulna.tif',246,4,58,204.2884644,45.460177,42.9749024,1.8,45.8262494,42.5786334,-1.3521447,16.7214033,16.9041276,6782.7873732,10283.7853432,32.446065,608.3594237,405.635056,999.6767178,3.764321,22.4563791,1.088283,62.119641),(22449,'red-deer-ulna.tif',246,4,59,200.5144709,45.704691,43.2668115,1.8,46.2956474,42.8392364,-1.3953243,19.8952457,16.6766001,7080.9272478,9689.1449351,32.4006083,581.002416,355.9105194,839.5371381,3.6480024,25.3421321,1.0803992,72.9477022),(22450,'red-deer-ulna.tif',246,4,60,200.8234505,45.9210096,43.6186457,1.8,46.5870329,43.1353455,-1.4675962,19.7293405,16.6978856,7251.8925211,9210.3681583,33.1153681,551.5888883,367.5689279,820.6602788,4.125178,24.8421986,1.0696237,73.2615982),(22451,'red-deer-ulna.tif',246,4,61,194.6454893,46.1669068,43.7017384,1.8,46.7552229,43.2328367,1.5072537,17.9296726,16.2065349,6765.2513732,8423.5006723,32.3101054,519.7595107,377.3215237,807.0468373,0.5936586,1.0717082,2.3561945,2.6333015),(22452,'red-deer-ulna.tif',246,4,62,185.2255151,46.1943852,43.7508658,1.8,46.6128002,43.3829565,1.5518435,18.8948183,15.8978042,6239.5330897,7692.3071267,30.8598313,483.8597219,330.2245619,713.8112142,4.0712814,25.065861,0.9953717,81.1536157),(22453,'red-deer-ulna.tif',246,4,63,174.0654638,46.1364633,43.655842,1.8,46.1924115,43.2743169,-1.5122691,16.3705201,15.272474,5329.9942081,6918.4440175,28.9116491,453.0008695,325.5849041,682.8745497,24.2123951,30.8389741,0.1479786,249.3394683),(22454,'red-deer-ulna.tif',246,4,64,159.6948327,45.8991967,43.372962,1.8,46.1426355,43.2765325,-1.3154311,17.870364,14.4253785,4463.4219773,6111.0148102,24.9175532,423.6294252,249.7667076,591.6198005,4.727409,24.7256172,1.0316909,90.9290096),(22455,'red-deer-ulna.tif',246,4,65,137.9825091,45.3374071,42.6521414,1.8,45.4211508,42.6463977,-1.0524292,17.3077722,14.2402281,2786.0165101,5289.665668,17.3516915,371.4593364,160.9690999,380.9191365,0.4018906,0.8037812,2.3561945,1.6075623),(22456,'red-deer-ulna.tif',246,4,66,128.6761291,45.2412812,42.5763895,1.8,45.3219205,42.5065325,-1.0460159,15.4875716,13.2274928,2155.1570401,4768.2028845,16.0625544,360.4766955,139.1539676,418.2511197,0.5086441,0.8472597,2.677945,1.9864684),(22457,'red-deer-ulna.tif',246,4,67,118.0381608,44.967176,42.4354525,1.8,45.5217933,42.4227836,-1.0376818,17.3321116,13.0373929,1505.798344,4331.7847446,14.5917665,332.2585113,86.8791051,322.7751981,4.1347787,22.7256794,1.066127,76.6257839),(22458,'red-deer-ulna.tif',246,4,68,109.4389273,44.9031064,42.3604518,1.8,45.235961,42.3095903,-1.065472,16.051709,12.2270402,1092.973059,3813.679969,13.9654216,311.9054097,68.0907596,295.5159628,0.5683591,0.6830826,2.1587989,1.9864684),(22459,'red-deer-ulna.tif',246,4,69,102.5529711,45.0404942,42.2634188,1.8,45.0660829,42.1891089,-1.0932541,16.1966451,11.88301,865.086887,3270.3656605,13.4817831,275.2135738,53.4114864,253.7892412,0.189453,0.2679271,2.3561945,0.5358541),(22460,'red-deer-ulna.tif',246,4,70,96.7414501,45.281269,42.1510507,1.8,45.0014928,42.0849539,-1.1366016,16.1548914,10.8237616,719.8244083,2753.3290881,13.2701596,254.3782083,44.5576756,214.9576128,4.4063249,13.8144914,1.1316837,57.9786023),(22461,'red-deer-ulna.tif',246,4,71,92.4547057,45.4433681,42.220825,1.8,45.2215568,42.1991371,-1.1670163,14.8489297,10.5092378,594.8390082,2450.3042226,13.0304401,233.157178,40.0593861,189.386755,0.189453,0.4236299,2.0344439,0.9147602),(22462,'red-deer-ulna.tif',246,4,72,89.9073639,45.4784628,42.4249062,1.8,45.1598333,42.4228095,-1.1615996,19.6155542,11.2903675,519.4001486,2319.3725305,12.6124671,205.4293216,26.4789943,144.0568305,0.6698176,1.2130913,2.4668517,2.5223225),(22463,'red-deer-ulna.tif',246,4,73,88.6663987,45.5504489,42.781687,1.8,45.4112506,42.9783766,-1.1667506,16.7526705,10.3853996,489.8978446,2294.0863939,12.4936831,220.8953421,29.2429702,163.9634076,3.2043336,18.3025753,1.1210367,54.1816545),(22464,'red-deer-ulna.tif',246,4,74,85.8384867,45.6219351,43.0289241,1.8,45.3522849,43.276475,-1.1720161,15.1518399,10.2448207,430.0585406,2181.7783571,12.1493984,212.9640358,28.3832553,167.5476946,3.8528817,18.9907179,1.0714496,58.5065694),(22465,'red-deer-ulna.tif',246,4,75,83.0420404,45.7205913,43.2988558,1.8,45.5258915,43.7076591,-1.1914015,15.3096136,10.2064056,382.7992983,2066.9383043,11.9419253,202.5138311,25.003851,157.4772093,3.0970287,17.1221948,1.136843,61.1398709),(22466,'red-deer-ulna.tif',246,4,76,80.8642822,45.7667294,43.5917706,1.8,45.5267585,43.9769425,-1.1960166,13.0944347,10.1152976,334.7141678,2007.4046129,11.6713378,198.4523526,25.5615592,168.7450178,3.0191748,18.062735,1.1493771,52.1032481),(22467,'red-deer-ulna.tif',246,4,77,79.3018076,45.7835783,43.9042747,1.8,45.4653785,44.2623882,-1.1965148,11.9766731,10.1172165,299.9208217,1973.718805,11.4503056,195.0851596,25.0420814,150.337309,3.1412078,16.6761723,1.1987286,50.2087178),(22468,'red-deer-ulna.tif',246,4,78,79.0326577,45.7774558,44.3203694,1.8,45.4894494,44.9934646,-1.2007188,15.3191446,17.6728569,298.7078726,2012.967361,11.4489608,113.9016386,19.4989917,111.1877373,3.5704595,18.4976418,0.9969973,59.8921736),(22469,'red-deer-ulna.tif',246,4,79,77.3827578,45.8029632,44.5649755,1.8,45.5396093,45.0229274,-1.1983452,14.375044,10.0905663,262.5366784,1945.0818722,11.1892509,192.7624098,18.2633652,145.3173101,3.8036808,18.8636629,0.9855792,62.6824232),(22470,'red-deer-ulna.tif',246,4,80,74.9895904,45.8728717,44.717938,1.8,45.6126054,45.0237131,-1.1978828,12.9140504,9.9233146,238.4725958,1821.6449094,10.8392884,183.5722223,18.4661348,146.691457,3.52957,17.5630219,1.1602389,64.0680275),(22471,'red-deer-ulna.tif',246,4,81,72.9237296,45.9747161,44.8851887,1.8,45.7823935,45.3647577,-1.1995297,12.7493605,9.6901949,249.0816975,1705.2771544,10.5542391,175.9796543,19.5367992,141.0672676,2.9315433,16.6912318,1.1122248,45.0990628),(22472,'red-deer-ulna.tif',246,4,82,71.3074381,46.0389626,45.053154,1.8,45.8775655,45.5219803,-1.2054519,12.8832285,9.5832015,242.9657732,1611.1220267,10.3675953,168.1193943,18.859075,133.9874417,0.4018906,0.9472652,0.9272952,1.9864684),(22473,'red-deer-ulna.tif',246,4,83,69.6749405,46.0960006,45.1990991,1.8,45.8856212,45.6108424,-1.2086318,11.3876656,9.4148513,225.39645,1519.7516258,10.1547987,161.4206731,19.7930337,139.9062719,3.3774797,17.2402263,1.1760052,47.1045721),(22474,'red-deer-ulna.tif',246,4,84,68.5400864,46.1467111,45.3830849,1.8,45.9661358,45.8159022,-1.2126528,11.36614,9.4596509,213.8941833,1450.8406379,10.0196969,153.371478,18.8185421,135.1891618,3.3045032,15.5916511,1.0908458,49.9677187),(22475,'red-deer-ulna.tif',246,4,85,67.6403714,46.1805171,45.5935221,1.8,46.0204978,46.0088234,-1.213272,11.3221747,9.557681,201.5867369,1409.7603588,9.8927502,147.5002523,17.8045952,124.1009281,3.3034545,16.1846569,1.1228542,43.0206563),(22476,'red-deer-ulna.tif',246,4,86,66.5325889,46.2252486,45.8054165,1.8,46.0997419,46.1906623,-1.2127783,11.1427765,9.2201074,190.9769386,1361.7911545,9.7271396,147.6979706,17.13908,122.7409558,3.4492579,15.2506752,1.1071487,48.8690825),(22477,'red-deer-ulna.tif',246,4,87,65.4334315,46.2610447,46.0187244,1.8,46.124078,46.31726,-1.206887,10.5121087,9.058734,176.2545449,1319.4092131,9.5239848,145.6505085,16.7668115,126.8444782,2.9652354,15.1680791,1.0903905,49.5428436),(22478,'red-deer-ulna.tif',246,4,88,64.5330204,46.2820208,46.2481821,1.8,46.1192298,46.4935025,-1.2003407,9.0416694,8.975977,169.0827347,1286.3884924,9.3457465,143.3145928,18.700389,141.2627973,2.5106072,12.6423531,1.0535089,33.9380646),(22479,'red-deer-ulna.tif',246,4,89,63.3903678,46.3470878,46.5104057,1.8,46.2621073,46.8358421,-1.1927064,9.760908,9.0155324,175.7376618,1252.4367318,9.1253739,138.9198861,18.004233,126.0130081,3.089604,14.9139374,1.1241925,42.4197922),(22480,'red-deer-ulna.tif',246,4,90,62.6829276,46.3561403,46.822775,1.8,46.341636,47.3422794,-1.1884287,11.1377219,10.7272488,182.5415417,1246.6849659,8.9927311,116.2166546,16.3894864,114.2293443,2.9482181,15.0003262,1.0845537,44.5632087),(22481,'red-deer-ulna.tif',246,4,91,61.7917615,46.3562477,47.076926,1.8,46.2944973,47.5091405,-1.1771914,10.271688,10.1657339,173.7720845,1226.8957584,8.7838257,120.6893439,16.9175782,115.3131437,3.0443692,15.7917941,1.0427219,50.5876238),(22482,'red-deer-ulna.tif',246,4,92,60.6841422,46.3912776,47.3032195,1.8,46.3249788,47.6748593,-1.1766939,11.2484727,10.4622074,164.8418412,1181.4339783,8.6228091,112.9239679,14.6545976,104.5733685,3.2498577,15.5536212,0.9760371,45.994782),(22483,'red-deer-ulna.tif',246,4,93,59.0903976,46.480184,47.4800122,1.8,46.4442669,47.8034041,-1.1874525,9.5185193,8.9489337,152.1187801,1119.4487254,8.4706706,125.0929735,15.9813491,112.30331,0.3789061,0.8472597,1.1071487,1.8295204),(22484,'red-deer-ulna.tif',246,4,94,57.3728241,46.5963119,47.6448841,1.8,46.5598143,48.0342008,-1.2022314,7.5576962,9.46885,140.9959647,1053.5299644,8.320976,111.2627151,18.6559451,101.9860203,2.8932128,13.9322067,1.1801893,38.7607515),(22485,'red-deer-ulna.tif',246,4,95,55.9037786,46.6832893,47.8045934,1.8,46.6458506,48.0657817,-1.2140705,8.075856,9.2915479,127.3973764,994.6153254,8.1810869,107.0451704,15.7750926,100.4324859,3.076378,13.7258692,1.1133215,42.2897722),(22486,'red-deer-ulna.tif',246,4,96,54.8659538,46.7522997,48.0012855,1.8,46.7460282,48.2290044,-1.2212989,6.6947322,8.7298775,120.2153991,950.3345425,8.0721045,108.8600095,17.9567153,98.1091895,2.7697717,12.1042551,1.2688452,36.211501),(22487,'red-deer-ulna.tif',246,4,97,54.0766353,46.8346952,48.2045457,1.8,46.8328413,48.5456086,-1.2266932,7.9958912,8.5144167,129.2263789,913.6110838,7.9870582,107.3016638,16.1615979,99.2526153,0.3789061,0.8472597,0.4636476,1.8754894),(22488,'red-deer-ulna.tif',246,4,98,53.2573411,46.8795113,48.442181,1.8,46.8757213,48.7918889,-1.2309769,7.2358004,8.4188521,128.04282,881.4338454,7.8900741,104.6976282,17.6957368,107.8102687,3.5237645,13.1598284,1.1715756,40.4333238),(22489,'red-deer-ulna.tif',246,4,99,52.8009957,46.9367985,48.6786939,1.8,46.9981574,49.0380413,-1.2349793,7.2132213,8.3297156,131.0263977,858.1009943,7.8444937,103.0168413,18.1647549,100.3043674,3.4024719,12.3508269,1.2102303,36.9233441),(22490,'red-deer-ulna.tif',246,4,100,52.1991772,46.9718175,48.91526,1.8,46.9746209,49.3093943,-1.2401308,6.7423118,8.2463964,128.1897044,831.5096702,7.7827907,100.8330946,19.0127228,105.8326475,4.1773268,11.752198,1.2082521,39.5106766),(22491,'red-deer-ulna.tif',246,4,101,51.7074071,47.0116144,49.1539301,1.8,46.9997834,49.5793913,-1.2451334,7.682765,11.4504765,123.8671529,810.7473962,7.7357756,70.8046865,16.122731,74.414315,3.6303713,10.7321424,1.2099595,36.100522),(22492,'red-deer-ulna.tif',246,4,102,51.2547054,47.0482635,49.3947272,1.8,47.0294479,49.8205703,-1.2498043,7.1990244,10.1958818,121.1672633,784.7973988,7.6920895,76.9719982,16.8310673,83.9270424,3.7414366,10.6667275,1.2265776,37.9760114),(22493,'red-deer-ulna.tif',246,4,103,50.6118498,47.0822544,49.6171462,1.8,47.0451935,49.926966,-1.2563348,8.0080228,10.2333541,114.6914664,757.6768911,7.6283089,74.0399366,14.3220703,67.5552145,3.0130946,9.1095198,1.2753555,32.3305023),(22494,'red-deer-ulna.tif',246,4,104,50.1609209,47.116513,49.8629145,1.8,47.1399648,50.1670637,-1.2654208,7.5294805,9.7795313,112.7737848,735.7976923,7.6044689,75.2385437,14.9776315,73.1537629,3.7078162,11.9295254,1.2138844,44.2033436),(22495,'red-deer-ulna.tif',246,4,105,49.5871203,47.1909261,50.0923036,1.8,47.2572515,50.507452,-1.2826518,7.4724473,8.2999791,122.259742,712.5887083,7.5971209,85.8542776,16.3614057,79.1546241,3.9087686,12.2852661,1.1071487,43.9544575),(22496,'red-deer-ulna.tif',246,4,106,49.0547155,47.2229342,50.3569986,1.8,47.3263815,50.8697949,-1.2916955,7.6804871,9.4699466,121.9887777,692.7492961,7.5552804,73.1523971,15.8829481,68.2534775,0.3789061,0.5358541,0.7853982,1.0717082),(22497,'red-deer-ulna.tif',246,4,107,48.7721658,47.2521405,50.6334041,1.8,47.3225256,51.2798501,-1.3116934,8.6557365,9.5413353,126.1148989,688.7531525,7.5950829,72.1862432,14.5700945,67.4400227,3.6608129,10.1759386,1.0655061,35.0288138),(22498,'red-deer-ulna.tif',246,4,108,48.3839835,47.2815254,50.8887437,1.8,47.3675816,51.4474747,-1.3279748,8.6960509,8.3529095,121.0798986,679.1236696,7.5977973,81.3038464,13.9235499,68.1466058,3.6731251,10.3421231,1.0743736,40.6283539),(22499,'red-deer-ulna.tif',246,4,109,48.1875321,47.3048795,51.1631771,1.8,47.3918843,51.7015952,-1.350497,8.7694302,8.9476544,115.9586306,677.8641239,7.647749,75.7588626,13.2230519,65.9636138,0.189453,0.2679271,2.3561945,0.5358541),(22500,'red-deer-ulna.tif',246,4,110,48.0166079,47.3214458,51.4153514,1.8,47.3586213,51.9423188,-1.3681202,8.7415512,8.3595416,116.3548502,670.9795178,7.6785099,80.265109,13.3105495,67.3205203,3.5953164,10.8518725,1.2877005,33.1342834),(22501,'red-deer-ulna.tif',246,4,111,47.9241468,47.3577751,51.7031319,1.8,47.460512,52.4973186,-1.393256,8.0964469,9.9708781,112.62623,687.0710383,7.7382259,68.9077761,13.9105748,63.8544886,3.1244567,9.7287408,1.4536876,29.1153776),(22502,'red-deer-ulna.tif',246,4,112,47.5620246,47.3760467,51.9454016,1.8,47.4947524,52.6175227,-1.4056594,6.4968005,9.6536637,107.0182998,677.766851,7.7127909,70.2082517,16.4724621,74.3040564,3.4445791,11.5814548,1.305979,37.2832092),(22503,'red-deer-ulna.tif',246,4,113,47.0813267,47.4480065,52.2396427,1.8,47.5567544,53.1413744,-1.4242376,9.7360119,9.3466545,112.9296558,677.3812668,7.6795442,72.4731255,11.5991699,60.9223731,3.786934,9.9404186,1.4369853,31.3697731),(22504,'red-deer-ulna.tif',246,4,114,46.8763264,47.451871,52.5394582,1.8,47.5583054,53.3820615,-1.4336223,11.0905282,9.070597,114.6079932,674.2577682,7.666631,74.3344419,10.3338625,58.3292141,3.6639598,11.0680143,1.4506876,35.4536889),(22505,'red-deer-ulna.tif',246,4,115,47.0347209,47.4211253,52.9170903,1.8,47.3170045,53.9752966,-1.4300052,11.6763571,9.1580576,123.7144986,699.5273445,7.6847561,76.3838114,10.5952994,57.0404952,3.7644905,10.0320705,1.380808,30.4359719),(22506,'red-deer-ulna.tif',246,4,116,47.4154528,47.4294987,53.2448727,1.8,47.3449147,54.3046529,-1.439761,11.3350147,9.0320054,121.1380783,721.0384497,7.7676611,79.83149,10.6870685,58.8220544,4.4377218,11.9295254,1.3952042,36.6823451),(22507,'red-deer-ulna.tif',246,4,117,47.4073498,47.4325828,53.4972936,1.8,47.3689669,54.3701994,-1.4461331,11.4956351,8.7511559,115.6526253,711.9922069,7.7790674,81.3597902,10.0605686,59.0598948,3.9524377,14.1190185,1.3681377,41.5700421),(22508,'red-deer-ulna.tif',246,4,118,47.3201421,47.4287928,53.7548225,1.8,47.3710136,54.482388,-1.4436671,10.7053717,8.5072623,110.9421748,703.0581118,7.7599121,82.6421104,10.3632249,61.1475643,3.4695079,12.5583214,1.3734008,43.0206563),(22509,'red-deer-ulna.tif',246,4,119,47.7577798,47.4238342,54.0393699,1.8,47.3253955,54.7295628,-1.4369745,11.0860245,8.257197,108.9363811,715.127971,7.8179355,86.6066259,9.8264604,61.4026862,3.2333976,13.7101705,1.3761108,40.8962809),(22510,'red-deer-ulna.tif',246,4,120,48.1978104,47.4088176,54.3487312,1.8,47.2981198,55.1537528,-1.4299686,12.0804118,8.5174525,110.751787,731.4170558,7.8747054,85.8727482,9.1678817,57.2535643,2.9864183,13.3775846,1.3567356,39.2887186),(22511,'red-deer-ulna.tif',246,4,121,48.3276758,47.3805423,54.6197024,1.8,46.9788885,55.5503499,-1.4007505,11.8524352,8.5656848,131.0500506,734.0819268,7.823945,85.7003196,11.0568038,59.7409406,3.2478659,10.7455116,1.4114447,35.2967408),(22512,'red-deer-ulna.tif',246,4,122,48.2804066,47.364261,54.8647983,1.8,46.953543,55.7606897,-1.3826316,11.9157019,8.5115938,137.3584994,726.921713,7.7651787,85.4037125,11.5275206,59.1379488,3.5977082,11.6725212,1.3415644,40.7662609),(22513,'red-deer-ulna.tif',246,4,123,47.7975443,47.3703473,55.0418706,1.8,47.1260831,55.5675952,-1.3832772,7.6666454,8.2070325,112.7088604,704.014494,7.6894046,85.7818574,14.7011966,93.551498,0.5086441,0.8037812,0.7853982,1.6075623),(22514,'red-deer-ulna.tif',246,4,124,47.8948237,47.3489429,55.2880532,1.8,47.0810356,55.7347357,-1.3713972,8.1464753,8.4402847,113.1626523,701.7820936,7.6692716,83.1467329,13.8909955,91.4505637,0.3789061,0.6830826,2.1587989,1.4506143),(22515,'red-deer-ulna.tif',246,4,125,47.9858927,47.34613,55.516613,1.8,47.0902617,55.8636979,-1.3622135,7.6907659,8.0194107,111.4893956,698.4833613,7.6547136,87.0990888,14.496527,96.5343308,0.3789061,0.8472597,2.677945,1.9864684),(22516,'red-deer-ulna.tif',246,4,126,48.5407465,47.3494036,55.8029461,1.8,47.1595579,56.4564842,-1.3584074,8.8687705,8.3727768,116.6382446,719.4820628,7.7306411,85.9311167,13.1515687,86.8531968,2.7316721,13.6103251,1.2886726,38.8907715),(22517,'red-deer-ulna.tif',246,4,127,48.1126365,47.3780126,55.9936682,1.8,47.2451822,56.6014567,-1.3560491,8.1644934,8.7756187,110.2854961,698.8239744,7.6546257,79.6324448,13.5079411,91.4133574,2.6751854,13.6103251,1.2886726,40.9232089),(22518,'red-deer-ulna.tif',246,4,128,47.8298475,47.4009649,56.1619004,1.8,47.2393618,56.7347674,-1.355148,8.0178311,7.8152753,107.9165463,684.219279,7.6066374,87.5489665,13.4595683,90.8910707,2.5212911,13.5627733,1.359703,39.6216557),(22519,'red-deer-ulna.tif',246,4,129,48.1907516,47.3921137,56.4442609,1.8,47.069074,56.9460352,-1.3368199,11.0644231,7.961735,119.5226513,702.6892892,7.6000573,88.2583119,10.8024296,67.2960335,0.3789061,0.5358541,2.3561945,1.0717082),(22520,'red-deer-ulna.tif',246,4,130,48.1764055,47.389969,56.6629122,1.8,47.0353271,57.0992667,-1.3305189,10.0712795,7.9368906,121.2026246,699.8985582,7.57469,88.1829669,12.0344813,72.4971415,3.388446,12.9675033,1.364805,41.275187),(22521,'red-deer-ulna.tif',246,4,131,47.8962486,47.3873094,56.8441064,1.8,47.0269004,57.1751231,-1.3225359,8.2842097,7.855824,120.9537863,688.6506483,7.5007332,87.6611602,14.6005221,89.0833906,0.189453,0.4236299,2.0344439,0.9147602),(22522,'red-deer-ulna.tif',246,4,132,48.0876315,47.387319,57.0810639,1.8,47.0434926,57.5241581,-1.3146844,7.9094492,7.8197652,124.6272204,690.6578138,7.5002947,88.3220654,15.7567509,90.4273214,4.7856423,13.4191071,1.3429393,51.9003311),(22523,'red-deer-ulna.tif',246,4,133,47.3063942,47.4187794,57.2109925,1.8,47.1796157,57.5957931,-1.3104506,9.1333239,7.5718155,118.3625826,656.6893405,7.3619608,86.7281219,12.9594202,77.09363,3.0225089,12.5454536,1.3111667,35.943574),(22524,'red-deer-ulna.tif',246,4,134,46.7569895,47.4300817,57.3470029,1.8,47.0855211,57.7747678,-1.2979075,22.8791468,7.3702639,121.6424294,626.4001016,7.2267755,84.9901867,5.316738,32.0339489,0.5683591,1.1982062,1.2490458,2.7442805),(22525,'red-deer-ulna.tif',246,4,135,46.8425549,47.4417571,57.5959654,1.8,47.2032527,57.9627661,-1.2925344,9.7309231,8.2299816,115.1282867,635.8782811,7.2180335,77.2636334,11.8311783,70.9731125,2.8480269,13.192517,1.353685,34.9828448),(22526,'red-deer-ulna.tif',246,4,136,46.7999408,47.4432887,57.7442124,1.8,47.1833493,57.9707203,-1.2833829,9.5542865,8.0127892,116.5309305,630.3729789,7.1732079,78.6708548,12.1967172,71.9747319,3.4179955,13.1434537,1.3083369,42.1709062),(22527,'red-deer-ulna.tif',246,4,137,46.3124886,47.4325622,57.8457857,1.8,47.0120842,58.0343579,-1.2630575,9.0804441,8.121577,128.5492967,615.7429613,7.0105445,75.8156896,14.1567192,72.4376283,5.549751,13.376243,1.2983332,49.3129986),(22528,'red-deer-ulna.tif',246,4,138,46.2673512,47.3357922,58.0346425,1.8,46.5245662,58.2743337,-1.2201063,10.5059958,8.1088423,137.4858257,627.5137602,6.8011171,77.3863566,13.0864155,64.4968534,7.2568609,14.0719104,0.7568345,49.3051115),(22529,'red-deer-ulna.tif',246,4,139,46.1075971,47.3041892,58.2122206,1.8,46.454518,58.3677558,-1.2025144,11.1231148,8.1207752,142.803258,622.3209066,6.6886028,76.63319,12.8384234,59.9242046,7.4060658,14.0719104,0.7568345,60.2441517),(22530,'red-deer-ulna.tif',246,4,140,45.6165884,47.306748,58.3262992,1.8,46.4200535,58.4882119,-1.1905169,10.9159022,8.72223,142.1170416,605.7173354,6.5552972,69.4452376,13.0192666,59.5074122,0.5683591,0.8472597,0.4636476,1.9864684),(22531,'red-deer-ulna.tif',246,4,141,45.1565341,47.3187093,58.4612073,1.8,46.5329156,58.6633927,-1.1874045,9.6602093,7.5006756,129.1917516,591.6061316,6.472986,78.8737128,13.3735976,66.821957,5.8661409,13.5097418,1.1824776,52.6850712),(22532,'red-deer-ulna.tif',246,4,142,44.7340908,47.3120689,58.573142,1.8,46.54631,58.7660981,-1.172251,9.1274363,7.934371,126.6074539,579.3425708,6.3328218,73.0168237,13.8710861,67.5604467,12.8499833,17.1022688,3.0639711,122.4018747),(22533,'red-deer-ulna.tif',246,4,143,43.9046054,47.3347551,58.6379219,1.8,46.646912,58.8079381,-1.169579,8.562903,7.0608799,113.9765675,557.253069,6.2013723,78.9211936,13.3105055,67.6303795,5.4425511,13.2413984,1.2354719,44.0004265),(22534,'red-deer-ulna.tif',246,4,144,43.1964908,47.354562,58.7018017,1.8,46.7025757,58.8825653,-1.1588503,11.9561689,6.9434936,109.0943287,531.1849661,6.0452423,76.5011098,9.1245222,53.2088369,0.189453,0.4236299,2.677945,0.8037812),(22535,'red-deer-ulna.tif',246,4,145,41.917969,47.3915945,58.6500783,1.8,46.5751809,58.7205465,-1.1371261,11.0741315,7.6293877,113.8703217,491.8347616,5.7527417,64.4658234,10.282551,49.8366039,6.2094403,12.6423531,1.2348287,42.1249372),(22536,'red-deer-ulna.tif',246,4,146,40.6154428,47.4122431,58.6348845,1.8,46.5001382,58.7138173,-1.1184767,9.383938,7.6050924,110.84429,457.5668925,5.4762116,60.1658554,11.8121294,52.2373298,6.3678255,12.6650453,1.1875122,46.9095421),(22537,'red-deer-ulna.tif',246,4,147,39.7434519,47.4163095,58.6797324,1.8,46.5085842,58.8015228,-1.0966034,12.9292149,7.2184779,110.1430454,435.114805,5.242808,60.2779158,8.5189276,38.6677368,6.0771683,12.6380938,1.1540941,43.1125944),(22538,'red-deer-ulna.tif',246,4,148,38.791595,47.4149794,58.7013389,1.8,46.5155185,58.6766544,-1.0912257,8.8466154,7.2385251,100.5386535,417.154303,5.0888857,57.6297378,11.3646461,50.2637558,0.5358541,0.6830826,0.5880026,1.6075623),(22539,'red-deer-ulna.tif',246,4,149,37.9470238,47.4270049,58.7414666,1.8,46.5851913,58.7210368,-1.0821372,8.8277715,7.2682026,93.6508241,401.7179784,4.9307341,55.2706081,10.6086597,48.0507384,0.4241106,0.8037812,2.3561945,1.6075623),(22540,'red-deer-ulna.tif',246,4,150,37.1363982,47.4366064,58.7789793,1.8,46.6024789,58.7748777,-1.073411,8.8977023,7.2052703,89.7648669,380.835456,4.7803681,52.8551242,10.0885447,45.6144406,5.6865483,12.0313865,1.1141909,42.6227093),(22541,'red-deer-ulna.tif',246,4,151,36.368626,47.4550194,58.8208169,1.8,46.7140884,58.867518,-1.0636031,9.0482289,7.0637059,82.4897737,366.0464648,4.6313656,51.82074,9.1166763,42.6542168,0.8596638,1.7973093,0.3217506,4.7307489),(22542,'red-deer-ulna.tif',246,4,152,35.9409511,47.4681051,58.8439973,1.8,46.7177999,58.8773441,-1.0619466,8.3462487,6.5036015,79.4766551,355.1753234,4.5684687,54.6120978,9.5224403,46.2743587,0.5683591,0.9472652,2.4980915,1.9864684),(22543,'red-deer-ulna.tif',246,4,153,34.9337654,47.443378,58.7842048,1.8,46.4443069,58.7377815,-1.0176095,9.8335091,6.3394455,82.2841256,341.2313605,4.2150695,53.8266891,8.3677276,39.5584104,6.4736527,12.5110746,0.5585993,47.3074892),(22544,'red-deer-ulna.tif',246,4,154,34.1406401,47.4360996,58.7839256,1.8,46.4736877,58.7102176,-1.007068,8.155992,6.8940071,78.672863,329.3133735,4.0654637,47.7680642,9.6460201,41.9053654,5.0783607,11.747616,0.6596287,40.7931889),(22545,'red-deer-ulna.tif',246,4,155,33.3329511,47.33614,58.7794953,1.8,46.15571,58.7663276,-0.9397679,9.1851479,6.8507304,80.1580329,330.8340485,3.621786,48.2917923,8.726918,36.2421469,0.189453,0.2679271,2.3561945,0.5358541),(22546,'red-deer-ulna.tif',246,4,156,32.7976967,47.2876385,58.8391173,1.8,46.1609507,58.8434606,-0.9157832,8.2566169,6.5787409,75.986958,329.5106132,3.4378124,50.0871853,9.203159,42.2820867,5.7655367,12.1383079,0.5966604,41.6429391),(22547,'red-deer-ulna.tif',246,4,157,32.7371799,47.2608883,58.8934237,1.8,46.1451937,58.8587946,-0.910738,11.6903919,6.7784157,74.880965,330.235187,3.4048371,48.7186393,6.4053426,30.0556435,5.5903004,12.7722824,0.5633163,43.4074495),(22548,'red-deer-ulna.tif',246,4,158,32.8392885,47.0164997,58.9486223,1.8,45.0234274,59.0600251,-0.7660338,10.8184238,12.386192,99.6868218,373.3846941,2.6306488,30.145237,9.2145421,29.6176256,0.3789061,0.5358541,2.3561945,1.0717082),(22549,'red-deer-ulna.tif',246,4,159,32.3257871,47.1225144,58.9451851,1.8,45.5374165,59.0055521,-0.8335096,11.237784,11.3725509,80.8998774,338.4367266,2.9526223,29.7590866,7.1989173,26.7387743,9.638239,17.8297351,0.2578645,86.4123317),(22550,'red-deer-ulna.tif',246,4,160,31.9478396,47.1108663,58.9450812,1.8,45.5875657,59.0133564,-0.8218067,11.8646372,12.0038184,76.8910535,332.5194065,2.8560112,27.7011359,6.4806915,25.1448487,5.7271326,15.6800287,0.4906681,55.0964147),(22551,'red-deer-ulna.tif',246,4,161,30.4001244,47.1908247,58.7551256,1.8,45.6125237,58.6803265,-0.7932222,10.296308,11.0343719,77.4935605,297.4652249,2.5729841,26.9580569,7.5263444,24.9943645,0.3789061,0.6830826,2.5535901,1.3396353),(22552,'red-deer-ulna.tif',246,4,162,29.1962589,47.2155916,58.6801533,1.8,45.5619273,58.6181443,-0.7789606,12.1279418,11.3850354,71.2584877,276.397643,2.401697,24.2772757,5.8755631,22.5752013,5.9088671,14.1532957,0.4875951,46.105761),(22553,'red-deer-ulna.tif',246,4,163,28.6120059,47.1751302,58.6294512,1.8,45.3866261,58.6021733,-0.7314375,10.5588737,12.4036419,74.6765665,275.4164714,2.1275126,22.2044843,7.0723989,22.2128629,6.3916007,15.8519104,0.4315731,48.4901764),(22554,'red-deer-ulna.tif',246,4,164,27.9777319,47.2092676,58.605429,1.8,45.5131362,58.6450863,-0.7536994,12.0415562,11.3518586,65.5681126,263.7606815,2.1837669,23.2350217,5.4451527,19.9004278,0.5936586,1.0717082,2.3561945,2.2543954),(22555,'red-deer-ulna.tif',246,4,165,27.2055112,47.2343202,58.5119996,1.8,45.4712901,58.5371458,-0.7292733,11.8279719,12.4208166,65.036114,252.7002622,2.0131756,20.3448992,5.4985009,20.0904726,0.189453,0.2679271,2.3561945,0.5358541),(22556,'red-deer-ulna.tif',246,4,166,26.6484277,47.3087786,58.4230665,1.8,45.8418687,58.4219621,-0.7544314,10.1769085,9.9804512,56.9341727,240.9357962,2.0832545,24.1407718,5.5944468,21.5641331,0.5683591,0.7811349,2.896614,2.1434164),(22557,'red-deer-ulna.tif',246,4,167,26.2986612,47.3334734,58.3961272,1.8,46.0319674,58.4463682,-0.7651629,9.8534444,10.1961321,51.7116009,236.6080358,2.102886,23.2056659,5.2480736,20.3338956,0.3789061,0.5358541,2.3561945,1.0717082),(22558,'red-deer-ulna.tif',246,4,168,25.1053459,47.4169502,58.2272237,1.8,46.1730963,58.2071063,-0.7820248,12.2425809,10.6136568,43.841066,210.2375307,2.0779975,19.8082088,3.5810314,16.2853076,5.4789113,12.3842017,0.5115561,42.8715953),(22559,'red-deer-ulna.tif',246,4,169,25.237974,47.3233284,58.1596115,1.8,45.8525006,58.1408201,-0.7299573,10.9847595,10.5456154,50.5165102,222.2984577,1.8704397,21.0797046,4.5987816,18.8373982,0.189453,0.2679271,2.3561945,0.5358541),(22560,'red-deer-ulna.tif',246,4,170,24.9811036,47.2837205,58.11809,1.8,45.7948886,58.1505438,-0.6886993,9.3845821,10.6961133,53.5707559,228.5393983,1.6816565,21.3665834,5.7083795,19.95239,0.9472652,1.9320495,2.9441971,5.044645),(22561,'red-deer-ulna.tif',246,4,171,23.5275463,47.3042819,57.9038896,1.8,45.6721622,57.9101018,-0.6552457,8.8349161,10.9609632,47.2732761,208.5065497,1.4560115,19.0226484,5.3507329,18.573443,0.189453,0.2679271,2.3561945,0.5358541),(22562,'red-deer-ulna.tif',246,4,172,23.1385918,47.3725934,57.8045326,1.8,45.8962211,57.7766901,-0.6767799,9.630815,10.862869,43.7401996,195.8602847,1.5126238,18.0302537,4.5416924,16.6056899,0.5683591,0.8037812,2.3561945,1.7185413),(22563,'red-deer-ulna.tif',246,4,173,23.7839163,47.2822708,57.8546842,1.8,45.8070454,57.8947149,-0.6706491,8.8721309,10.6961667,45.496334,213.4407876,1.5311116,19.9548861,5.1280053,19.095456,0.3600058,0.8472597,0.4636476,1.7185413),(22564,'red-deer-ulna.tif',246,4,174,23.0822841,47.3872334,57.6573593,1.8,46.0192582,57.6328328,-0.6667115,9.1372615,10.3696058,40.9485078,197.7441257,1.4712063,19.0695894,4.4814858,18.2156545,0.189453,0.2679271,2.3561945,0.5358541),(22565,'red-deer-ulna.tif',246,4,175,22.517152,47.464704,57.5191568,1.8,46.2396366,57.5136512,-0.6915492,8.4238897,8.8813661,33.9292837,189.0713697,1.5262918,21.2885458,4.0277455,19.2927021,0.5683591,1.1982062,2.8198421,2.6333015),(22566,'red-deer-ulna.tif',246,4,176,21.8216759,47.5435605,57.3068762,1.8,46.3503257,57.2483925,-0.6889042,7.7730053,9.2942192,29.4895332,177.2715113,1.4697042,19.0733087,3.7938393,17.064853,0.3390961,0.6830826,2.5535901,1.3396353),(22567,'red-deer-ulna.tif',246,4,177,22.5383612,47.4606242,57.2365827,1.8,46.1338271,57.1891986,-0.6496629,8.2855935,10.5098999,35.216987,199.3596511,1.3745614,18.9687489,4.250388,17.5571494,0.5086441,0.6830826,2.1587989,1.6075623),(22568,'red-deer-ulna.tif',246,4,178,21.8250694,47.5188268,57.000947,1.8,46.1529067,56.8772115,-0.631628,9.5620751,11.5069549,32.3756804,191.0121883,1.2681905,16.5997164,3.3858425,14.9309535,0.4241106,0.9472652,2.4980915,1.9864684),(22569,'red-deer-ulna.tif',246,4,179,22.3033853,47.4592343,56.9411314,1.8,46.0966757,56.8360336,-0.6164931,9.6188464,9.9103885,34.1868046,208.7583244,1.2426297,21.0645955,3.5541481,17.703645,0.5358541,0.8037812,2.3561945,1.6075623),(22570,'red-deer-ulna.tif',246,4,180,22.9343746,47.4383164,56.8653487,1.8,46.2047578,56.7314702,-0.6258275,9.3290183,10.3312807,34.9337096,223.6387122,1.311557,21.6467559,3.7446287,18.9611192,0.3600058,0.8472597,2.677945,1.7185413),(22571,'red-deer-ulna.tif',246,4,181,22.0901297,47.5966228,56.6158461,1.8,46.4424351,56.4889652,-0.6413866,8.0697013,7.9107787,29.6098615,202.7702601,1.3179387,25.6321492,3.6692637,22.5865315,4.2678892,12.708896,0.4636476,42.2247622),(22572,'red-deer-ulna.tif',246,4,182,22.4235162,47.5581281,56.5292489,1.8,46.370475,56.4571297,-0.6304215,9.2316814,11.5635728,30.3991224,217.4265141,1.2986688,18.8027107,3.2929129,16.7487931,4.0849652,13.0489002,0.4506613,37.6969304),(22573,'red-deer-ulna.tif',246,4,183,21.1680961,47.8591785,56.2043565,1.8,46.8212048,56.0506437,-0.6646989,5.9298973,7.0751529,25.0918404,178.5453746,1.3423028,25.23555,4.2314123,22.0956485,0.6446549,1.3396353,2.3561945,2.7902495),(22574,'red-deer-ulna.tif',246,4,184,21.4022237,47.8865849,56.0922786,1.8,46.8329858,55.9969044,-0.6669698,8.4335831,8.3549375,25.970858,186.0070188,1.365019,22.2631252,3.0794572,19.3581789,4.0193264,12.0313865,0.4566055,34.9526498),(22575,'red-deer-ulna.tif',246,4,185,21.9090142,47.8842704,55.9435328,1.8,46.6554958,55.8613461,-0.6453906,8.2167636,9.918087,30.9948047,204.3262385,1.3211681,20.601376,3.7721427,18.8877124,0.5086441,0.9472652,2.4980915,1.9864684),(22576,'red-deer-ulna.tif',246,4,186,21.9993,47.9730766,55.7966994,1.8,46.8878675,55.6994438,-0.6681879,7.0125816,8.5659985,31.2076474,201.4903999,1.4074431,23.5221148,4.4502366,21.4652798,0.3789061,0.5358541,2.3561945,1.0717082),(22577,'red-deer-ulna.tif',246,4,187,20.8740499,48.109256,55.4727692,1.8,46.8446145,55.4241497,-0.6423034,8.0604677,9.5708238,28.6333263,188.5006069,1.2484443,19.6953378,3.5523158,17.3528542,0.189453,0.2679271,2.3561945,0.5358541),(22578,'red-deer-ulna.tif',246,4,188,21.1953852,48.1684637,55.3179833,1.8,47.0045908,55.2542194,-0.6657923,8.9530894,11.0960042,28.8776124,194.7688448,1.3477849,17.5530616,3.2254355,15.6861238,4.3404614,12.5397303,0.4704043,47.3153762),(22579,'red-deer-ulna.tif',246,4,189,21.066825,48.4922414,55.0803072,1.8,48.1902407,55.0644518,-0.7045686,10.0041453,10.3833193,29.1645827,175.9786722,1.4729995,16.9482096,2.9152498,14.2276745,3.0765201,10.3230176,0.8243395,32.0054522),(22580,'red-deer-ulna.tif',246,4,190,20.4579367,48.6425547,54.79111,1.8,48.3458242,54.7499346,-0.7224419,8.9431291,9.4951084,24.730014,163.2727346,1.4907355,17.1954577,2.7652529,14.4261371,2.2700191,9.6602473,0.8408967,24.3734748),(22581,'red-deer-ulna.tif',246,4,191,20.5614375,48.6662282,54.6670234,1.8,48.3959114,54.7283569,-0.7432719,4.9345561,5.9859547,21.8991278,171.001153,1.5692612,28.5670642,4.4379125,28.3566707,3.0548043,8.4492656,0.8329813,28.4573906),(22582,'red-deer-ulna.tif',246,4,192,20.0369618,48.7953861,54.3796353,1.8,48.5304443,54.4523596,-0.7365602,5.1714386,6.1540775,20.4730133,164.5224463,1.506912,26.7338926,3.9588623,27.2912443,0.5358541,0.6830826,2.1587989,1.6075623),(22583,'red-deer-ulna.tif',246,4,193,20.633255,48.8069525,54.2231317,1.8,48.4215682,54.2830276,-0.740536,5.032726,6.276252,23.2571096,180.6868533,1.5653694,28.7889735,4.6211754,29.9514533,2.9471976,8.577851,0.816638,29.1501927),(22584,'red-deer-ulna.tif',246,4,194,20.1913102,48.9644262,53.9538514,1.8,48.6640122,53.991603,-0.7617368,5.547035,5.8770358,22.317073,169.4426144,1.6030133,28.8313055,4.0232436,26.1966347,2.8902977,9.3812736,0.8139618,31.6725152),(22585,'red-deer-ulna.tif',246,4,195,19.2605319,49.0846256,53.5796824,1.8,48.6502023,53.6658785,-0.7367058,4.6941499,6.3964817,21.1557165,162.8107023,1.4489844,25.4531646,4.506826,26.1700579,3.3096418,8.9845493,0.7406519,32.0973903),(22586,'red-deer-ulna.tif',246,4,196,20.1091165,49.0663747,53.4903248,1.8,48.5856889,53.5649841,-0.7646288,4.7485881,6.1927787,22.8756843,177.1430469,1.6061707,28.6047761,4.8173655,27.7909585,3.0548043,9.7379598,0.6473921,27.0067763),(22587,'red-deer-ulna.tif',246,4,197,20.7257053,49.0722102,53.3565919,1.8,48.6230095,53.4205714,-0.7815677,5.2642331,6.2291397,23.3651897,193.1843169,1.7139108,31.0130011,4.4384793,29.3611806,2.8450141,10.3854138,0.669043,36.2463161),(22588,'red-deer-ulna.tif',246,4,198,19.6120713,49.3316496,52.9114309,1.8,48.8851575,53.0053785,-0.7901064,4.88691,6.3041328,21.0468513,168.8916426,1.6497289,26.7906227,4.306781,24.5773358,0.189453,0.2679271,2.3561945,0.5358541),(22589,'red-deer-ulna.tif',246,4,199,20.3798217,49.3603834,52.7672497,1.8,48.8964169,52.9111868,-0.8092347,5.533177,6.401801,22.0891885,183.9874917,1.779252,28.7399579,3.9921348,25.4286749,3.217896,9.7213594,0.5771922,32.1164313),(22590,'red-deer-ulna.tif',246,4,200,19.7404684,49.5570568,52.3993818,1.8,49.1312738,52.5853085,-0.8217166,5.7537802,6.6099041,20.2551066,174.3940309,1.7644244,26.383746,3.5203129,22.4362254,0.7632066,1.3396353,0.7853982,3.4370827),(22591,'red-deer-ulna.tif',246,4,201,20.6063901,49.5844905,52.2013375,1.8,49.0286479,52.3775415,-0.8185293,5.7294653,6.8079398,24.9193485,196.5720755,1.8309013,28.8739445,4.3493323,26.6958137,0.3789061,0.5991031,1.8925469,1.4506143),(22592,'red-deer-ulna.tif',246,4,202,20.4000411,49.7629316,51.9097304,1.8,49.3457036,52.0396368,-0.8639713,5.2283916,6.2855401,23.1125847,188.13921,1.9660543,29.9320673,4.4205918,27.1259155,3.152846,9.5631569,0.5880026,34.3708267),(22593,'red-deer-ulna.tif',246,4,203,19.1966759,50.0143447,51.3821704,1.8,49.3649487,51.5313738,-0.8700317,5.5957492,6.4071109,22.3367421,164.5366974,1.8692121,25.6803261,3.991734,23.639344,0.5086441,0.8037812,2.3561945,1.6075623),(22594,'red-deer-ulna.tif',246,4,204,20.052265,50.0414314,51.2303937,1.8,49.5173674,51.3789996,-0.8911665,5.6687494,6.5031115,22.7766901,185.5163191,2.0218741,28.5273165,4.0179392,26.162779,0.3789061,0.5358541,0.7853982,1.0717082),(22595,'red-deer-ulna.tif',246,4,205,20.9501854,50.0412692,51.0708533,1.8,49.5479975,51.231039,-0.8982582,6.0179559,6.6145834,24.5461724,211.9061048,2.1365841,32.0361981,4.0788223,27.9829391,3.8153388,10.6667275,0.5830765,46.400616),(22596,'red-deer-ulna.tif',246,4,206,21.8309101,50.0531414,50.9158186,1.8,49.6750517,51.0569767,-0.9178544,6.1599924,6.7086231,24.1589359,239.3298227,2.2955654,35.6749543,3.92191,32.1943472,0.189453,0.2679271,2.3561945,0.5358541),(22597,'red-deer-ulna.tif',246,4,207,20.5957855,50.3433811,50.3646875,1.8,50.053677,50.5101217,-0.9410516,5.671894,6.7097336,19.5369637,211.180395,2.2420278,31.4737376,3.444522,29.7723059,2.4736276,10.4628859,0.734161,34.1219406),(22598,'red-deer-ulna.tif',246,4,208,21.5218652,50.3233883,50.2167625,1.8,50.0047842,50.3494354,-0.9439108,5.9645249,6.7006916,20.2344149,240.447613,2.3525937,35.8839994,3.3924605,30.3577878,0.189453,0.2679271,2.3561945,0.5358541),(22599,'red-deer-ulna.tif',246,4,209,20.6159288,50.6417443,49.6279013,1.8,50.2346968,49.8752659,-0.9526895,6.4856698,6.9506258,23.2328711,214.8899699,2.2821405,30.9166363,3.5821853,26.9153655,0.189453,0.2679271,2.3561945,0.5358541),(22600,'red-deer-ulna.tif',246,4,210,21.1472785,50.6431942,49.4248306,1.8,50.1778517,49.7129185,-0.9482042,6.9219732,6.9937848,24.0739655,238.1828682,2.3260047,34.0563623,3.4779051,31.6414839,0.189453,0.2679271,2.3561945,0.5358541),(22601,'red-deer-ulna.tif',246,4,211,20.6133511,50.819059,48.9641482,1.8,50.3621011,49.2899188,-0.9541174,6.6123172,7.0431601,23.3040186,226.8952287,2.2864863,32.2149752,3.5243346,30.1574333,5.952651,14.0246441,0.9002748,65.8706198),(22602,'red-deer-ulna.tif',246,4,212,18.9054468,51.1935312,48.2421815,1.8,50.6339362,48.7262304,-0.9697884,6.8036487,7.628478,21.6097573,179.8478968,2.1433707,23.5758557,3.1762012,22.1027908,0.3390961,0.6830826,0.9827937,1.4506143),(22603,'red-deer-ulna.tif',246,4,213,19.0848111,51.3347527,47.9321519,1.8,51.2188631,48.3481016,-0.9965044,5.9375674,6.9662526,19.5308174,188.8674668,2.2421149,27.1117742,3.2893635,27.6539203,1.6409715,10.1547534,0.9310265,26.2680051),(22604,'red-deer-ulna.tif',246,4,214,19.4791387,51.3931608,47.595192,1.8,51.1291851,47.9736666,-0.9868834,5.8160991,7.6055914,20.3218799,207.1473546,2.2598278,27.2361929,3.4940739,25.7256039,2.1906804,10.2462395,0.9827937,31.9785242),(22605,'red-deer-ulna.tif',246,4,215,19.0051951,51.7058306,47.0230827,1.8,51.5018933,47.2966571,-1.0370601,5.9007577,7.5806203,18.246352,179.9666662,2.3476799,23.7403616,3.0922049,22.1213217,1.386053,8.6776936,0.9403949,22.6549334),(22606,'red-deer-ulna.tif',246,4,216,19.2535383,51.9197611,46.6111409,1.8,51.6686618,46.9046747,-1.0912979,5.6768432,7.1530799,17.827838,171.6180514,2.5259702,23.99219,3.1404493,24.6762346,0.189453,0.4236299,2.0344439,0.9147602),(22607,'red-deer-ulna.tif',246,4,217,19.7460915,52.1069981,46.2314532,1.8,51.8729617,46.5148958,-1.1267407,5.8254997,7.0678891,20.3687448,177.1133678,2.6836231,25.0588776,3.4964803,24.7761795,0.189453,0.2679271,2.3561945,0.5358541),(22608,'red-deer-ulna.tif',246,4,218,20.1635751,52.1974002,45.9871536,1.8,52.0102531,46.2869943,-1.1489067,6.1644483,7.2701935,21.4467728,185.7628521,2.7970977,25.5512939,3.4791066,24.2118552,1.3467173,6.7833712,0.9440534,18.6360276),(22609,'red-deer-ulna.tif',246,4,219,20.2862077,52.2752162,45.6130294,1.8,52.0337579,45.8139185,-1.1459583,8.3199051,7.2892808,21.4898542,192.5838395,2.8066415,26.4201427,2.5829446,21.4916664,0.189453,0.2679271,2.3561945,0.5358541),(22610,'red-deer-ulna.tif',246,4,220,20.510927,52.3906093,45.2538203,1.8,52.1838046,45.4000622,-1.1522723,5.9094577,6.9949561,21.4224625,198.1615943,2.8538529,28.3292118,3.6251148,26.9387596,1.7037823,7.1114321,0.8419416,19.1449537),(22611,'red-deer-ulna.tif',246,4,221,21.2647447,52.4993796,44.9828229,1.8,52.2602662,45.1171792,-1.1656064,6.2442102,7.2317683,23.9154991,209.6655092,2.9934083,28.992288,3.8300278,27.6701313,1.5780269,6.7275837,1.0062269,21.3803082),(22612,'red-deer-ulna.tif',246,4,222,22.5660092,52.6299412,44.7318397,1.8,52.4126006,44.938671,-1.1858206,5.6821649,7.4885625,28.1502629,229.8932057,3.2305959,30.6992437,4.954144,31.1822915,1.5151902,7.8958971,1.0427219,19.8837249),(22613,'red-deer-ulna.tif',246,4,223,24.5562675,52.713022,44.5763732,1.8,52.4495238,44.7540239,-1.2077026,6.4448075,7.8595305,34.2821641,266.310612,3.5764391,33.8837811,5.3193465,36.485925,2.7401581,8.1552875,1.0343609,30.2409419),(22614,'red-deer-ulna.tif',246,4,224,24.4235742,52.9130732,44.0724678,1.8,52.8890915,44.1871009,-1.2213973,5.6692671,7.8135991,36.3916427,260.2368474,3.5935542,33.3056307,6.4191088,37.8897364,0.8017749,4.8412572,1.0370881,10.8011331),(22615,'red-deer-ulna.tif',246,4,225,26.080881,52.9949031,43.9089343,1.8,52.7430894,44.1061925,-1.2188042,6.4513294,8.2294213,46.732658,300.1962357,3.8301282,36.4784139,7.2438803,42.0648995,1.5903621,4.9148368,1.089909,18.3411726),(22616,'red-deer-ulna.tif',246,4,226,27.464274,53.0306256,43.6839721,1.8,52.8108082,43.7672259,-1.2066401,5.7005229,8.639889,53.2593051,335.3712562,3.9967354,38.8166165,9.3428807,44.6551827,0.5683591,0.9472652,2.2142974,2.4113435),(22617,'red-deer-ulna.tif',246,4,227,28.1799478,53.2007591,43.2248468,1.8,52.9684905,43.2661409,-1.2131949,6.8357755,8.6444885,61.9584239,342.2485879,4.1212241,39.591537,9.0638471,44.5663694,0.189453,0.2679271,2.3561945,0.5358541),(22618,'red-deer-ulna.tif',246,4,228,30.7047861,53.2845969,43.0351437,1.8,53.0355986,43.0778484,-1.2276849,9.3833654,8.8046392,73.99989,395.6350834,4.5382821,44.9348431,7.8862846,41.0608029,1.1735998,3.5946186,1.2490458,9.7294249),(22619,'red-deer-ulna.tif',246,4,229,33.0246784,53.437867,42.8252884,1.8,53.2230454,42.7868347,-1.2625096,5.954287,9.121642,89.792283,437.660344,4.9973622,47.980434,15.0802745,57.6398635,0.189453,0.2679271,2.3561945,0.5358541),(22620,'red-deer-ulna.tif',246,4,230,34.9627947,53.5156317,42.7144536,1.8,53.3255599,42.6605254,-1.2670626,6.4473736,9.357415,105.0982504,502.1049251,5.3058843,53.6585077,16.3009401,64.6282302,0.3789061,0.5358541,0.7853982,1.0717082),(22621,'red-deer-ulna.tif',246,4,231,32.8106507,53.8020119,41.8749793,1.8,53.5794557,41.9904627,-1.2804791,6.656294,9.0261366,104.1499119,439.7879311,5.0203433,48.7238286,15.6468317,58.9089871,0.5086441,0.9472652,0.9272952,1.9864684),(22622,'red-deer-ulna.tif',246,4,232,31.9265434,54.0708178,41.0729418,1.8,53.8832738,41.2319637,-1.3128376,6.6012392,8.8048023,97.6355688,412.5539432,4.9747953,46.8555602,14.790491,56.7383118,0.3789061,0.6830826,0.9827937,1.4506143),(22623,'red-deer-ulna.tif',246,4,233,31.9510808,54.3327111,40.1485696,1.8,53.6023491,40.804065,-1.2734103,14.1760616,10.5735663,124.6350852,407.3392639,4.8679503,38.5243022,8.7919401,30.1517663,0.5086441,0.8037812,0.7853982,1.6075623),(22624,'red-deer-ulna.tif',246,4,234,32.9139013,54.6696028,39.7299929,1.8,54.4249744,39.9362117,-1.4110463,6.906733,8.1822244,124.6596142,380.0753592,5.3468429,46.4513488,18.0489986,50.097393,1.6996855,5.5719809,0.9544994,17.8512875),(22625,'red-deer-ulna.tif',246,4,235,35.414485,54.6999224,39.8324171,1.8,54.4684594,40.0270682,-1.3952654,8.1951697,8.4619842,156.9747945,422.6487935,5.7224143,49.9467716,19.1545508,55.2065521,1.9467859,5.5071883,1.1071487,18.5900586),(22626,'red-deer-ulna.tif',246,4,236,33.5226264,54.8135069,39.123752,1.8,54.5841988,39.252888,-1.3176467,7.9837152,7.9300853,149.6735153,345.212544,5.2366396,43.532009,18.7473515,53.0726351,0.7578121,1.0717082,0.7853982,2.3653745),(22627,'red-deer-ulna.tif',246,4,237,30.366516,55.1043649,38.2329804,1.8,54.8096116,38.2205382,-1.3685981,7.0053651,7.3979025,134.0259763,264.4809416,4.8569726,35.7508014,19.1319046,48.2517917,8.5181408,13.9797856,1.1071487,39.7135937),(22628,'red-deer-ulna.tif',246,4,238,30.562826,55.3019237,37.5998606,1.8,55.0586059,37.5277388,-1.4175072,7.3540938,7.1910618,143.4986425,257.2361112,4.9750469,35.771645,19.5127566,44.2288701,0.5997829,1.6945195,1.1071487,3.6590407),(22629,'red-deer-ulna.tif',246,4,239,29.6656561,55.4499906,36.8531193,1.8,55.1736715,36.7915382,-1.4050763,6.3398711,6.8040029,136.1562743,233.4176321,4.8097291,34.305928,21.4761897,48.5080863,0.6698176,0.9472652,0.6435011,2.2543954),(22630,'red-deer-ulna.tif',246,4,240,28.4520887,55.575042,36.234551,1.8,55.3814166,36.125789,-1.486345,6.6414794,6.4777654,134.9015164,201.3342207,4.7082749,31.0808141,20.3119679,45.676054,0.6795738,2.4261827,0.8960554,5.312572),(22631,'red-deer-ulna.tif',246,4,241,27.0291922,55.6879598,35.5127829,1.8,55.4692447,35.3708167,1.4945645,7.4361016,6.172138,135.2533026,171.3648782,4.4787369,27.7642656,18.1887378,41.1456731,0.9377447,2.160097,0.6610432,5.377582),(22632,'red-deer-ulna.tif',246,4,242,27.2027486,55.6583997,34.9685614,1.8,55.352395,34.8373559,1.3267558,8.1152523,5.8866873,144.3283415,167.1753699,4.2690958,28.3988875,17.784825,36.6534361,0.5358541,1.0717082,0.7853982,2.2543954),(22633,'red-deer-ulna.tif',246,4,243,28.5252006,55.6257924,34.597544,1.8,55.3419141,34.5701044,0.856626,7.2073204,5.7055729,153.3261393,184.9461237,2.7145871,32.4149964,21.2736678,41.4390982,0.189453,0.2679271,2.3561945,0.5358541),(22634,'red-deer-ulna.tif',246,4,244,30.3160817,55.5987419,34.3177165,1.8,55.3223735,34.2144762,0.6872597,8.0169376,7.0679167,165.969462,213.5330149,2.0336555,30.2115918,20.7023516,36.7137154,0.5358541,0.8037812,0.7853982,1.8295204),(22635,'red-deer-ulna.tif',246,4,245,33.2124612,55.5617198,34.1796624,1.8,55.2290006,34.1285344,0.6111212,7.5891966,7.4858412,184.0710457,249.2601767,1.8224255,33.2975506,24.2543521,41.952939,0.189453,0.4236299,2.677945,0.8037812),(22636,'red-deer-ulna.tif',246,4,246,35.9501635,55.620786,34.0721143,1.8,55.2029818,33.9464933,0.622549,6.7293063,7.8509195,195.4311738,292.3983938,2.0372645,37.2438407,29.0418008,54.6319302,0.189453,0.2679271,2.3561945,0.5358541),(22637,'red-deer-ulna.tif',246,4,247,38.4783735,55.6688126,34.0037802,1.8,55.148298,33.8778286,0.6265287,6.9178423,7.1883209,208.2953288,334.7463688,2.2047485,46.5680893,30.1098693,63.0452663,1.460203,3.3731154,0.6659692,8.5467377),(22638,'red-deer-ulna.tif',246,4,248,41.7616084,55.7992364,34.0193581,1.8,55.3667957,33.9103417,0.6453429,6.6123042,8.7732961,223.3821736,412.0845795,2.5180097,46.9703262,33.7828037,61.2990521,1.8380371,3.084072,0.8288491,9.1476018),(22639,'red-deer-ulna.tif',246,4,249,46.188018,55.8766477,33.9149037,1.8,55.3570927,33.7183641,0.7175601,7.5215083,8.9826349,253.1545722,522.1153865,3.3283846,58.1249703,33.6574209,72.4172144,1.1367182,2.0492479,0.9827937,5.266603),(22640,'red-deer-ulna.tif',246,4,250,52.372516,55.8265908,33.7382516,1.8,55.3789545,33.509034,0.8160947,6.2350892,9.0541364,272.6072715,685.010099,4.6321506,75.657144,43.7214709,100.3533038,9.9325397,15.652536,2.2360858,58.8125784),(22641,'red-deer-ulna.tif',246,4,251,59.2626052,55.6274547,33.6282532,1.8,55.129543,33.3506783,0.8096703,6.5059183,9.4404866,324.690721,836.648871,5.178195,88.6234903,49.9069782,113.4881768,0.189453,0.5991031,2.8198421,1.1826872),(22642,'red-deer-ulna.tif',246,4,252,64.5466704,55.558259,33.5723498,1.8,55.0268812,33.438035,0.8091553,8.0465439,9.6479237,375.750769,957.9185223,5.6343676,99.2875309,46.6971627,131.8567598,0.3789061,0.5358541,0.7853982,1.0717082),(22643,'red-deer-ulna.tif',246,4,253,66.4682327,55.5499165,33.5953249,1.8,55.1485929,33.4660078,0.8871687,7.8633438,9.1028359,398.2517151,949.7398567,6.658669,104.3345032,50.646611,136.7988547,2.6010905,8.137664,1.359703,23.0909625),(22644,'red-deer-ulna.tif',246,4,254,64.3903316,55.433062,33.5252847,1.8,54.9994414,33.4434028,1.0471814,8.9174242,8.0400933,361.4745728,827.3469095,8.0486411,102.9026506,40.5357607,119.1086596,1.6759335,4.8708224,1.8063413,14.8850489),(22645,'red-deer-ulna.tif',246,4,255,51.049096,55.3966502,32.702694,1.8,55.2700408,33.0863856,1.1508038,6.0615062,7.4248486,194.0719103,539.7145684,7.0935862,72.6903133,32.0171097,95.940851,8.6213768,14.7578929,2.0803886,40.1765507),(22646,'red-deer-ulna.tif',246,4,256,34.040598,55.3840144,31.4615061,1.8,55.2890878,31.7017326,1.0467603,4.1934278,7.3356374,80.4801084,227.7473507,4.2529261,31.0467023,19.1919624,42.0083667,6.9514693,11.2545309,2.2008302,30.1601578),(22647,'red-deer-ulna.tif',246,4,257,20.3280713,55.4011944,30.6476967,1.8,55.3905373,30.7821947,1.0717105,3.1467953,4.6866626,25.2242607,93.1419378,2.6118859,19.8738306,8.0158568,25.0584045,5.1724174,9.3005812,2.1531493,24.2276807),(22648,'red-deer-ulna.tif',246,4,258,10.1201599,55.3915714,30.0633534,1.8,55.4565369,30.1762353,1.1242305,1.8661597,3.7388624,6.0693468,29.053881,1.3721042,7.7707811,3.2523191,9.2547209,3.7300567,7.4731959,2.1025204,18.7391196),(22649,'red-deer-ulna.tif',246,4,259,1.3193522,55.3409243,29.8849088,1.8,55.3908481,29.8736506,1.1876417,0.9828953,2.3544697,0.2156893,1.4428267,0.1891594,0.6128032,0.2194428,0.7036481,2.0978798,4.8301236,2.0169019,11.3560282),(22650,'red-deer-ulna.tif',246,4,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22651,'red-deer-ulna.tif',246,4,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22652,'red-deer-ulna.tif',246,4,262,98.2270604,34.6679686,52.0302884,1.8,35.0958522,52.2364041,-1.0306508,9.9150734,11.9183618,1665.2427069,3009.4377649,12.0415866,252.5043143,167.9506188,382.3179281,19.0328251,23.5295789,0.0563918,107.6356919),(22653,'red-deer-ulna.tif',246,4,263,44.5255231,34.0955156,52.643953,1.8,34.5174806,52.2078437,-0.8944577,8.1478365,9.7468771,443.5921499,1528.9249133,4.5133804,156.8630548,54.442937,189.769873,8.6913748,16.6341492,2.2188532,43.5216954),(22654,'red-deer-ulna.tif',246,4,264,11.3926017,30.9060676,55.446191,1.8,32.2418087,54.2338507,-1.0077985,5.0068312,10.9506016,31.7797829,190.4813677,1.3578823,17.394603,6.3472846,18.8055702,5.9494344,14.0961207,2.2035452,34.5389287),(22655,'red-deer-ulna.tif',246,4,265,2.4217399,29.5349989,56.4267792,1.8,29.6397573,56.2244426,1.4816865,0.7211328,3.5871888,0.1930598,4.0874536,0.4004268,1.1394587,0.2677174,1.1932032,3.6090627,10.5346791,2.2286849,24.3655877),(22656,'red-deer-ulna.tif',246,4,266,0.0366538,29.2309731,56.0228368,1.8,29.2389185,56.0465231,1.4811127,0.1457265,0.7046713,0.0003635,0.0049776,0.00606,0.0070638,0.0024945,0.0075792,1.7932773,6.4106831,2.1669955,14.2382158),(22657,'red-deer-ulna.tif',246,4,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22658,'red-deer-ulna.tif',246,4,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22659,'red-deer-ulna.tif',246,4,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22660,'red-deer-ulna.tif',246,4,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22661,'red-deer-ulna.tif',246,4,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22662,'red-deer-ulna.tif',246,4,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22663,'metacarpus-maybe',246,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22664,'metacarpus-maybe',246,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22665,'metacarpus-maybe',246,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22666,'metacarpus-maybe',246,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22667,'metacarpus-maybe',246,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22668,'metacarpus-maybe',246,5,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22669,'metacarpus-maybe',246,5,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22670,'metacarpus-maybe',246,5,8,0.0444567,33.8597682,50.6032531,1.8,33.8602941,50.6029412,-1.4516438,0.3148636,0.4069821,0.0016516,0.0025822,0.0073047,0.0063448,0.0052453,0.0095843,0.75,1.0933035,1.0303768,2.6061553),(22671,'metacarpus-maybe',246,5,9,26.1707706,40.669912,57.2941853,1.8,40.6612219,57.6830833,0.6909683,8.732008,15.784586,162.7330534,2469.1631916,1.7714579,156.4287585,18.6363838,165.9173734,7.4574124,15.0152266,1.2924967,40.7775433),(22672,'metacarpus-maybe',246,5,10,196.4130575,40.2494341,60.2490935,1.8,38.3233156,60.6949672,0.5554169,16.8167353,16.561243,6621.2702313,12546.9928913,9.1018709,757.6117856,393.7310142,955.5781802,23.1304218,32.1408035,0.1286965,175.1901243),(22673,'metacarpus-maybe',246,5,11,397.910657,37.9935032,60.2084254,1.8,37.5287063,60.944686,-0.0583695,14.517282,18.4923685,15737.2543713,32019.2778801,0.2256898,1731.4860385,1084.0358665,2378.3766045,25.839654,35.7265001,0.5836358,148.2875811),(22674,'metacarpus-maybe',246,5,12,420.9616619,37.7432267,60.1220475,1.8,37.5843306,60.9479529,-0.0948549,14.8492319,18.6113819,18306.675102,34336.6603544,0.6293719,1844.9280418,1232.8365042,2627.4654057,0.7508496,1.2005858,0.6747409,2.9811553),(22675,'metacarpus-maybe',246,5,13,398.3563423,37.6799513,60.3114223,1.8,37.6254724,61.1548601,-0.1043852,14.9380124,19.27047,18412.8347177,33364.018577,0.7208092,1731.3546864,1232.6161076,2496.8300513,25.5623929,35.8943763,0.5619216,129.39329),(22676,'metacarpus-maybe',246,5,14,384.4067685,37.540304,60.5730271,1.8,37.5098694,61.394548,-0.1165682,15.0777679,18.1077103,18495.516917,32473.7113198,0.8666263,1793.3637577,1226.6747337,2502.8393373,0.375,0.5303301,0.7853982,1.0606602),(22677,'metacarpus-maybe',246,5,15,373.7433878,37.3614872,60.7565736,1.8,37.3393956,61.5522712,-0.1530895,17.0111237,17.9968672,18552.7663434,31153.4171062,1.4484967,1731.0466703,1090.6255594,2553.1838177,1.0361774,5.8846331,1.0358413,13.2959415),(22678,'metacarpus-maybe',246,5,16,363.3059446,37.2439413,60.941708,1.8,37.208225,61.6375831,-0.1764455,23.1545871,18.7960326,18274.0184263,29294.9144046,1.8656523,1558.5690343,789.2180642,1595.0289131,26.4375,33.970633,0.4389613,103.7788825),(22679,'metacarpus-maybe',246,5,17,346.3606001,37.2477124,61.1231911,1.8,37.2548053,61.7541355,-0.1770097,14.9819405,17.6374024,17110.4380419,26619.9309299,1.7899079,1509.2886348,1142.0708872,2395.7700319,0.5303301,1.0606602,0.7853982,2.1213203),(22680,'metacarpus-maybe',246,5,18,328.2717507,37.1533281,61.2056493,1.8,37.1899133,61.808392,-0.1530508,14.9574969,17.1517945,15758.0083275,23764.6871317,1.2716271,1385.5510641,1053.519078,2274.7219695,0.6629126,1.0606602,0.7853982,2.2311553),(22681,'metacarpus-maybe',246,5,19,308.28,37.1621293,61.2562832,1.8,37.2433933,61.8558094,-0.1000756,14.5378321,16.2008112,14366.079011,20853.3035554,0.5128611,1287.1765033,988.185787,2115.4971955,24.9345258,31.1690201,0.6230467,96.8923971),(22682,'metacarpus-maybe',246,5,20,294.8476918,37.1752699,61.3583084,1.8,37.2375504,61.9519791,-0.0347211,19.653119,21.5930038,13198.5969383,18712.6568799,0.0592189,866.6073983,671.5777247,1092.9390304,0.7119159,3.2745467,1.1583859,7.0873106),(22683,'metacarpus-maybe',246,5,21,287.1456818,37.1648286,61.337423,1.8,37.2168967,61.9285318,0.0148775,14.320171,15.3688626,12328.3256066,17312.2421598,0.010592,1126.4491501,860.9063138,1845.1545633,0.5935999,2.8559149,1.1659045,6.1819805),(22684,'metacarpus-maybe',246,5,22,280.49038,37.2176208,61.3920219,1.8,37.2564166,61.9912536,0.0712498,17.3083973,22.3838479,11646.2750911,16184.3170584,0.2369185,723.035517,672.8684844,983.5806376,23.3150982,28.0855974,0.5713375,91.862067),(22685,'metacarpus-maybe',246,5,23,275.5433203,37.1962371,61.4319173,1.8,37.2675873,62.0286223,0.0995167,16.6456513,23.9635864,11057.6504103,15458.2921482,0.4533111,645.0742352,664.2966504,917.7203614,0.375,0.6760409,0.9827937,1.4356602),(22686,'metacarpus-maybe',246,5,24,271.151527,37.1582704,61.455512,1.8,37.2397762,62.0965451,0.1114296,16.0558577,23.8374644,10557.3430086,14832.1573159,0.5588096,622.2204281,657.5384027,883.4055318,22.625287,27.203659,2.5325606,87.6915719),(22687,'metacarpus-maybe',246,5,25,266.0738778,37.2152273,61.4508708,1.8,37.2961597,62.0965527,0.1260828,13.2672429,14.1085431,10015.0631589,14120.8847668,0.7012291,1000.8747636,754.8714701,1525.1749352,0.265165,0.5303301,0.7853982,1.0606602),(22688,'metacarpus-maybe',246,5,26,261.0402912,37.2184251,61.5107208,1.8,37.2645013,62.1249857,0.1446719,13.3364354,14.0992704,9610.520724,13509.1192329,0.904258,958.1431435,720.6213977,1441.3088261,22.1721651,26.73963,2.4854695,85.4604166),(22689,'metacarpus-maybe',246,5,27,257.0890803,37.2216569,61.5817844,1.8,37.2696924,62.2679474,0.163004,12.7323957,13.7016947,9324.9548317,13002.9994059,1.1284415,949.0066515,732.380225,1394.5824448,23.7654335,27.3942569,2.4337088,149.6023673),(22690,'metacarpus-maybe',246,5,28,255.0485263,37.2081458,61.6680636,1.8,37.2078805,62.328307,0.1795997,13.4998202,13.5559429,9117.9573228,12613.4272555,1.3564638,930.4721407,675.4132441,1372.4102209,0.375,1.1858541,1.2490458,2.5606602),(22691,'metacarpus-maybe',246,5,29,253.0227166,37.1956233,61.7627845,1.8,37.1844431,62.3584292,0.2024339,13.6704903,13.4327999,8892.6984045,12293.0965535,1.704647,915.1551893,650.5032508,1380.7133382,0.4626964,1.7787812,1.2490458,3.8409903),(22692,'metacarpus-maybe',246,5,30,251.5593857,37.1850025,61.8651826,1.8,37.1799123,62.4696028,0.226297,13.4969566,15.2450758,8776.2242446,12016.582566,2.1106723,788.2271435,650.2372747,1260.1405039,0.5034006,1.0933035,1.0303768,2.3409903),(22693,'metacarpus-maybe',246,5,31,251.4524041,37.1544794,62.0053074,1.8,37.1489798,62.5510584,0.2499701,13.1722935,13.9433391,8692.7986,11815.5564851,2.5645784,847.3979144,659.9305257,1255.5855566,0.375,0.9560662,1.7681919,2.1856602),(22694,'metacarpus-maybe',246,5,32,251.5299396,37.1245856,62.1395218,1.8,37.1070641,62.6369466,0.2783256,13.6213479,15.0203451,8652.0681958,11626.929835,3.1644732,774.0787419,635.1844364,1286.2013501,0.4626964,2.1378289,1.3045443,4.5909903),(22695,'metacarpus-maybe',246,5,33,250.9342543,37.1509283,62.2532408,1.8,37.1407794,62.8291429,0.3129725,13.5424626,13.2912573,8572.0124909,11348.3800226,3.9645561,853.8229115,632.9729499,1367.2705892,0.375,1.3650206,1.2924967,3.0909903),(22696,'metacarpus-maybe',246,5,34,249.9222443,37.1040203,62.4146363,1.8,37.1187919,62.9987898,0.3389579,12.8612479,13.4416575,8480.9517393,11133.8994299,4.6052024,828.3129816,659.4190404,1269.8060439,0.5386935,4.0950618,1.2924967,8.8069805),(22697,'metacarpus-maybe',246,5,35,248.9989134,37.0643359,62.575562,1.8,37.0384008,63.1955822,0.3769159,13.6001877,16.0883461,8368.0285744,10947.9629128,5.6217402,680.4902647,615.2877264,1199.3428703,0.8004604,5.3033009,1.4288993,11.5873106),(22698,'metacarpus-maybe',246,5,36,248.1866655,37.0475307,62.7132373,1.8,37.051053,63.2717046,0.4086229,13.197443,13.3115142,8254.8363851,10798.9732586,6.5307777,811.2505523,625.4875573,1263.6018474,0.5539544,3.4573292,1.3521274,7.5266504),(22699,'metacarpus-maybe',246,5,37,247.5490589,37.0294254,62.8327221,1.8,37.0364926,63.3759089,0.4354872,14.2087652,14.584769,8159.3484462,10685.4675023,7.3422762,732.645646,574.2475372,1263.5335355,0.5625,2.0963137,1.3909428,4.5909903),(22700,'metacarpus-maybe',246,5,38,247.4746449,37.0241021,62.9506827,1.8,37.0160342,63.4889091,0.4709576,13.1045594,13.2309424,8060.003707,10578.5457855,8.4916744,799.5307854,615.0533938,1246.4095779,21.9155768,25.2589712,2.2826432,81.3087662),(22701,'metacarpus-maybe',246,5,39,247.7878125,37.0168012,63.0602295,1.8,36.9861396,63.567936,0.4993683,12.8692946,13.3244646,7990.5342748,10503.7672511,9.470349,788.3068882,620.8991665,1236.5065293,0.375,1.0097184,1.1902899,2.3409903),(22702,'metacarpus-maybe',246,5,40,247.852777,37.0198724,63.16012,1.8,37.0016682,63.6554496,0.530747,13.5147089,13.3816445,7927.9555423,10439.7093531,10.5839694,780.1514485,586.6168196,1235.2650671,21.8794593,25.14598,2.1112158,81.3542613),(22703,'metacarpus-maybe',246,5,41,247.3405398,37.0572833,63.2459818,1.8,37.0305128,63.8653241,0.5626613,12.7279885,14.0255262,7866.655279,10312.5267045,11.7304242,735.2684365,618.0595834,1247.8378809,0.7148068,5.6406034,1.3016288,12.2729708),(22704,'metacarpus-maybe',246,5,42,247.1001456,37.0492756,63.3535415,1.8,36.9986688,64.0470942,0.5950737,13.2593248,14.2306374,7802.7643058,10227.5435271,12.9413942,718.6989044,588.4737277,1224.2721691,22.0072269,25.1627515,2.2187683,81.7104166),(22705,'metacarpus-maybe',246,5,43,245.9577912,37.0427193,63.4324537,1.8,37.0073224,64.0353924,0.6083155,12.6627494,14.223099,7725.4838905,10132.335225,13.3881466,712.3859027,610.0953002,1218.1371566,0.7980863,6.5945645,1.3120254,14.4586309),(22706,'metacarpus-maybe',246,5,44,246.3924503,37.0372386,63.5262497,1.8,36.9892066,64.1274731,0.6268649,12.9442839,27.3598012,7735.1930397,10117.956056,14.1310042,369.8110222,597.5759704,652.5283076,21.9375,25.1312959,2.1919131,81.4452516),(22707,'metacarpus-maybe',246,5,45,247.5507209,37.0179057,63.6351985,1.8,36.9376311,64.3118609,0.6463053,13.1888632,14.266986,7791.4331274,10109.2749656,14.9642012,708.5781771,590.7585045,1198.6720077,21.9375,25.1173029,2.094572,82.331737),(22708,'metacarpus-maybe',246,5,46,248.1620241,37.0085048,63.7265787,1.8,36.9532454,64.3357195,0.658113,13.6579738,13.6488828,7774.1069535,10107.1923774,15.4722884,740.5142619,569.1991395,1205.4754824,0.375,0.7730823,1.815775,1.8106602),(22709,'metacarpus-maybe',246,5,47,249.0189098,36.997015,63.8052043,1.8,36.9534104,64.3364753,0.6678883,13.0670719,14.3797231,7772.2789066,10086.991455,15.9193184,701.4732762,594.7988168,1202.0500908,0.4550706,1.7787812,1.2490458,3.8409903),(22710,'metacarpus-maybe',246,5,48,249.9302131,36.987362,63.903074,1.8,36.9526448,64.4181738,0.6882972,12.9104315,14.3376493,7772.9140225,10101.2809588,16.8081482,704.5283869,602.0646188,1196.3330198,0.4422347,1.4279575,1.1659045,3.0909903),(22711,'metacarpus-maybe',246,5,49,248.8476776,37.0294446,63.954618,1.8,36.9832597,64.5408825,0.7122959,13.0442557,14.3738583,7730.1211668,10040.0037909,17.7162094,698.4905232,592.6072996,1187.4741981,0.5341052,1.0933035,1.0303768,2.3409903),(22712,'metacarpus-maybe',246,5,50,248.0687003,37.0214153,64.0508071,1.8,36.9860652,64.6726395,0.7268718,13.3467575,27.1261974,7692.2429098,10014.1027744,18.2581546,369.1672164,576.3379535,648.9215469,1.1278793,5.3985675,1.2160907,12.8942911),(22713,'metacarpus-maybe',246,5,51,247.9252947,36.9995451,64.1478583,1.8,36.9726223,64.7522198,0.734991,13.0334427,14.5977213,7711.9842112,9985.3755609,18.5811002,684.0365956,591.7073765,1194.9030388,0.9375,2.9646353,1.2490458,6.9319805),(22714,'metacarpus-maybe',246,5,52,248.4102273,36.9817128,64.2445592,1.8,36.9682299,64.8570839,0.7445945,12.8293689,14.4178735,7754.4945,9982.5328092,19.0133862,692.3720632,604.4330421,1212.1693514,0.4746106,0.8385255,1.1071487,1.9659903),(22715,'metacarpus-maybe',246,5,53,248.8080043,36.9676449,64.3289975,1.8,36.8979014,64.895501,0.7570025,13.7917335,26.6080863,7772.1761518,9989.5783266,19.5571221,375.4339266,563.5387411,660.0802192,0.5303301,0.8385255,1.1071487,1.9659903),(22716,'metacarpus-maybe',246,5,54,249.5186719,36.9625525,64.407086,1.8,36.8771838,65.005894,0.7740984,13.4514597,14.836168,7787.2665754,10024.6526675,20.3233446,675.6901546,578.9160975,1106.5161692,0.375,0.7730823,1.815775,1.8106602),(22717,'metacarpus-maybe',246,5,55,250.2263459,36.9510049,64.4734868,1.8,36.891823,65.056763,0.7828095,12.8877527,14.4616011,7804.9512791,10067.6513095,20.7442359,696.164364,605.609953,1235.5405295,21.375,25.3735375,2.097275,82.6800865),(22718,'metacarpus-maybe',246,5,56,250.8418572,36.9392832,64.5301302,1.8,36.8914423,65.0688353,0.7870786,12.9743992,14.4282062,7827.8182082,10094.2130099,20.973742,699.6166307,603.3279922,1212.9543626,0.375,0.8385255,1.1071487,1.8106602),(22719,'metacarpus-maybe',246,5,57,250.5349219,36.9716879,64.5910383,1.8,36.9338822,65.2397081,0.8077695,13.7181772,14.6324494,7829.3598624,10083.0965744,21.8117333,689.0915058,570.7288751,1221.58261,0.9096522,1.0933035,2.6011732,2.9811553),(22720,'metacarpus-maybe',246,5,58,250.0704972,36.9628577,64.6616802,1.8,36.9099939,65.2831547,0.8262279,13.7431161,14.58455,7811.2078172,10082.2181693,22.5390367,691.2944308,568.3723973,1226.6258725,0.622561,3.2745467,1.3397057,6.9963203),(22721,'metacarpus-maybe',246,5,59,249.628157,36.9667078,64.7385733,1.8,36.9260694,65.4224649,0.840718,13.5999642,14.4593935,7793.4414154,10098.4020875,23.0992169,698.3973473,573.0486694,1208.7253237,0.8745185,5.6933349,1.2698761,12.738961),(22722,'metacarpus-maybe',246,5,60,250.0857528,36.9650021,64.80499,1.8,36.8765019,65.4880552,0.8536426,13.8232272,14.3631171,7789.8521856,10150.6517048,23.6761483,706.7164916,563.5335415,1211.2501423,0.375,0.5303301,2.3561945,1.0606602),(22723,'metacarpus-maybe',246,5,61,250.7114169,36.9638167,64.8616138,1.8,36.8528067,65.5696778,0.8597872,13.6288169,26.1840651,7790.6479522,10169.8605747,23.9895257,388.398843,571.6305381,661.9731464,21.375,25.6676474,2.0083061,83.2104166),(22724,'metacarpus-maybe',246,5,62,251.3356108,36.9647012,64.9197626,1.8,36.8517263,65.6568888,0.8649867,13.730127,14.1683661,7795.6968033,10203.5473933,24.2644783,720.1640129,567.780387,1245.0477576,0.5625,1.9575575,1.2793395,4.2159903),(22725,'metacarpus-maybe',246,5,63,252.0742862,36.9652493,64.9718642,1.8,36.8125551,65.6910414,0.8678254,13.8071971,14.3071699,7780.4679227,10240.0388267,24.4534927,715.727772,563.5081357,1222.3094996,0.5163886,1.7787812,1.2490458,3.9963203),(22726,'metacarpus-maybe',246,5,64,252.1066406,36.9610184,65.0113169,1.8,36.8354405,65.606137,0.8578185,13.9880508,14.6116971,7758.1176311,10232.0936138,24.0411997,700.2672972,554.6246393,1201.9066222,21.375,25.7776702,1.9823738,83.4112418),(22727,'metacarpus-maybe',246,5,65,251.5933168,37.0092139,65.0441022,1.8,36.9209142,65.7062654,0.8632971,14.7466965,14.5730249,7760.7759265,10192.9884112,24.2193886,699.4421892,526.2721664,966.5133294,0.828621,6.2327888,1.2014627,13.9549513),(22728,'metacarpus-maybe',246,5,66,251.5674929,36.9906948,65.1269592,1.8,36.8458093,65.9002175,0.8749432,13.8718549,14.9179562,7791.7490114,10179.5188467,24.6983581,682.3668528,561.6948192,1187.9370996,1.3081358,7.1766222,1.2242575,16.7352814),(22729,'metacarpus-maybe',246,5,67,251.1192294,36.9899072,65.1702481,1.8,36.8710161,65.9142581,0.8780263,14.0227108,15.1323276,7759.680692,10159.7218757,24.7812478,671.3918795,553.3652378,1172.4043144,1.7893379,10.7596251,1.1773457,26.7849026),(22730,'metacarpus-maybe',246,5,68,250.8396839,36.9912635,65.1943167,1.8,36.9218805,65.8395357,0.8712739,14.1261592,15.0072019,7729.9915789,10134.7690143,24.4758564,675.3270272,547.2111313,1186.7430692,1.2887691,10.9859641,1.0918827,24.2697375),(22731,'metacarpus-maybe',246,5,69,250.8409091,36.9869522,65.2231124,1.8,36.9127639,65.8467183,0.8707724,14.1701488,14.1947636,7719.6281706,10130.2419286,24.4553146,713.6604904,544.7810221,1183.7156438,0.5245892,1.7286646,1.3521274,3.8409903),(22732,'metacarpus-maybe',246,5,70,250.7666335,36.9897004,65.2479175,1.8,36.9072979,65.8274927,0.8713879,14.0681363,14.4025042,7691.8411403,10139.454037,24.4734244,704.0063241,546.7562279,1183.9899736,1.0609365,6.1675816,1.2298174,13.7996212),(22733,'metacarpus-maybe',246,5,71,251.3902308,36.9887853,65.2895373,1.8,36.9018838,65.870465,0.8723858,14.6134267,14.736744,7682.5680858,10174.5304994,24.5754689,690.419168,525.7198224,1138.1517076,0.4781335,2.7300412,1.2924967,6.3373106),(22734,'metacarpus-maybe',246,5,72,251.7069141,36.9835057,65.3270722,1.8,36.887196,65.8536316,0.8707039,13.2859391,14.6310425,7684.2349353,10189.1426543,24.536915,696.4057864,578.3734868,1197.8580013,21.5625,25.7776702,1.9823738,83.7862418),(22735,'metacarpus-maybe',246,5,73,251.235554,37.0357829,65.3524703,1.8,36.9404274,66.0128837,0.8758006,13.2136015,15.0782414,7681.5668179,10155.6884253,24.7010907,673.5326857,581.3378617,1173.1267386,1.1821116,9.0195101,1.2095926,19.8262716),(22736,'metacarpus-maybe',246,5,74,250.6960014,37.0282957,65.3983982,1.8,36.9401106,66.0460048,0.8723718,13.1768547,14.7132138,7661.1025786,10137.3614157,24.5070235,688.9970867,581.4060152,1192.4121458,0.7949739,5.2298721,1.3171222,11.5229708),(22737,'metacarpus-maybe',246,5,75,250.0509375,37.0281083,65.4349187,1.8,36.934497,66.0746816,0.871039,13.1525331,14.3534917,7619.4668207,10117.3192471,24.3892481,704.868159,579.315539,1193.2121368,1.6612315,10.2423752,1.1562895,24.7545725),(22738,'metacarpus-maybe',246,5,76,250.1505575,37.0296487,65.4704651,1.8,36.9480595,66.1442799,0.8702172,13.1303553,14.2673298,7601.8762732,10145.4080058,24.3651992,711.0936784,578.9543473,1194.4612017,1.1565597,9.7877874,1.218752,21.8566017),(22739,'metacarpus-maybe',246,5,77,250.0813104,37.029001,65.4865987,1.8,36.9273451,66.1189546,0.8658569,13.1168012,15.0817563,7564.4467558,10131.0571964,24.1791908,671.742534,576.6990487,1164.3578349,21.375,25.8532517,1.9890207,83.1460768),(22740,'metacarpus-maybe',246,5,78,250.1033523,37.0302183,65.5012457,1.8,36.9487805,66.0955827,0.8585979,13.1225648,14.9527402,7542.5323614,10128.6981089,23.8823085,677.3807315,574.7757753,1167.1084158,0.8017151,6.2861455,1.2679115,13.5533009),(22741,'metacarpus-maybe',246,5,79,249.8599219,37.0313193,65.5068475,1.8,36.9415244,66.0714205,0.853766,14.0930512,14.8491315,7496.8184634,10112.7495693,23.6598595,681.0330675,531.9514101,1127.2763505,21.375,25.7312583,1.9594216,82.7710768),(22742,'metacarpus-maybe',246,5,80,249.3859624,37.0292248,65.5129685,1.8,36.9294285,66.0708234,0.8457806,13.100027,14.8402235,7455.1059256,10075.2459285,23.2858223,678.9147026,569.0908811,1101.3431549,0.375,0.8385255,2.0344439,1.8106602),(22743,'metacarpus-maybe',246,5,81,248.6163814,37.0627772,65.5108764,1.8,36.9571509,66.1375566,0.8418445,13.6556932,14.6119358,7455.128871,9987.9380057,23.051982,683.5465311,545.9355854,1117.8133901,1.6886537,9.4049522,1.160669,21.572592),(22744,'metacarpus-maybe',246,5,82,248.1384908,37.04553,65.5418498,1.8,36.9422322,66.2226438,0.8350949,13.5240608,13.9919149,7455.1964664,9922.6658791,22.7301061,709.1713975,551.2542855,1227.5275642,1.5856212,9.9957022,1.1659045,23.5385822),(22745,'metacarpus-maybe',246,5,83,247.4983487,37.0306936,65.5587147,1.8,36.9238086,66.3289067,0.8290482,14.1422815,14.6949473,7453.3312847,9850.0252637,22.4231292,670.3001441,527.0246717,1158.7286893,1.868448,10.7596251,1.1773457,24.8832521),(22746,'metacarpus-maybe',246,5,84,247.4111612,37.0114775,65.5537665,1.8,36.8435034,66.3216799,0.8162788,13.7726475,13.8569237,7462.6490371,9804.7086245,21.8901552,707.5674852,541.8456423,1184.3403941,2.0414397,11.079965,1.152572,29.171388),(22747,'metacarpus-maybe',246,5,85,247.3344141,37.0004353,65.5404671,1.8,36.849936,66.2770184,0.8031966,13.5941653,14.279076,7457.1693524,9760.4502602,21.3447389,683.5491516,548.5566183,1156.2185262,1.7110985,10.4899505,1.1471274,25.2849026),(22748,'metacarpus-maybe',246,5,86,247.2425178,36.9824689,65.5348647,1.8,36.8440598,66.2818613,0.7873331,13.7552933,14.2274043,7454.6032561,9716.9016689,20.6832752,682.9707997,541.9443333,1145.8163403,1.5505911,10.9330348,1.1839206,24.8832521),(22749,'metacarpus-maybe',246,5,87,243.9509553,36.9992919,65.5012813,1.8,36.8924197,66.0586943,0.7769725,14.0019419,14.0579497,7317.8255051,9577.783886,19.9866873,681.3073093,522.6293289,1107.9543409,21.5625,25.4399569,1.9088624,81.956737),(22750,'metacarpus-maybe',246,5,88,242.7919709,36.9845353,65.5247405,1.8,36.6785564,66.1220392,0.8071901,14.5228247,16.9439716,7369.9375188,9567.8868768,21.1142015,564.6779342,507.4727314,999.4565151,21.5625,25.4958636,1.8925469,82.221902),(22751,'metacarpus-maybe',246,5,89,242.9636825,36.9819275,65.5049878,1.8,36.5994884,66.3751748,0.8295335,15.1900954,18.3934474,7420.0065068,9548.6598305,22.0318667,519.1337789,488.4766243,922.5386634,21.5625,25.4565346,1.9321532,81.581737),(22752,'metacarpus-maybe',246,5,90,242.1258878,36.9724682,65.4953755,1.8,36.6052812,66.2972218,0.8237815,17.0001567,17.8090205,7362.8664544,9493.2314983,21.7245691,533.057475,433.1057982,945.1957704,21.5625,25.4171448,1.948563,81.581737),(22753,'metacarpus-maybe',246,5,91,241.2414205,36.9733622,65.4793272,1.8,36.6627114,66.2188161,0.8140322,15.7716784,18.1016396,7297.8250447,9421.0668514,21.2541074,520.4537868,462.7170836,923.5002995,21.5625,25.3485854,1.9416876,81.0059117),(22754,'metacarpus-maybe',246,5,92,240.7624219,36.9629851,65.4690692,1.8,36.6288594,66.1475026,0.8006053,17.9795759,18.228319,7267.6017475,9378.5468576,20.6736578,514.5042085,404.2143044,885.770672,21.7317297,25.2812307,1.9347753,81.3165719),(22755,'metacarpus-maybe',246,5,93,240.2446875,36.9638488,65.4518095,1.8,36.641163,66.0942853,0.7814252,14.7296833,24.8378485,7218.6968179,9323.6031363,19.8613101,375.3788556,490.0782108,657.4566338,21.6978148,25.24296,1.9513027,81.2522321),(22756,'metacarpus-maybe',246,5,94,239.6166158,36.9661871,65.4382025,1.8,36.6643627,66.0469935,0.7761742,14.7515273,17.2339453,7173.959788,9277.8681336,19.5997029,538.348474,486.3197975,944.5276866,21.6705868,25.1396879,1.9609977,80.831737),(22757,'metacarpus-maybe',246,5,95,238.572326,36.970743,65.4091831,1.8,36.7154956,65.89711,0.7515021,14.7560859,15.3667084,7104.4559656,9210.6559902,18.5342824,599.390304,481.4593793,1042.8967527,21.5625,25.1396879,1.9609977,80.5665719),(22758,'metacarpus-maybe',246,5,96,237.7379084,36.9732506,65.3992482,1.8,36.7233989,65.9191763,0.7427092,14.8993858,16.0363196,7067.567178,9148.2560711,18.122081,570.4710508,474.3529225,987.264245,21.375,25.1124036,1.9776489,80.3014069),(22759,'metacarpus-maybe',246,5,97,236.3946733,36.9841437,65.363852,1.8,36.6546574,66.0074974,0.7518452,14.7806853,17.5850812,7055.2497357,9062.7406086,18.378591,515.3652983,477.3289995,914.5552479,21.5625,25.038798,1.9707717,80.1915719),(22760,'metacarpus-maybe',246,5,98,234.7713068,36.9785577,65.3652652,1.8,36.6459004,66.0785396,0.7418596,14.9277052,23.7088231,6998.528888,8954.9196596,17.862825,377.7040993,468.8281815,669.1875759,21.375,24.9663836,1.9638543,79.3505817),(22761,'metacarpus-maybe',246,5,99,233.7460866,36.9688276,65.3574074,1.8,36.6110034,66.0835273,0.7381561,19.0892478,18.4725541,6973.0241838,8866.6884742,17.6411354,479.9925574,365.2854345,802.872283,21.375,24.8951708,1.9568971,79.2407467),(22762,'metacarpus-maybe',246,5,100,233.1313849,36.9638529,65.3463391,1.8,36.657839,66.0362777,0.7203566,18.5970541,17.5127753,6943.995818,8802.1022094,16.9075331,502.6103559,373.3922467,812.9144606,21.375,24.793286,1.9667509,79.1309117),(22763,'metacarpus-maybe',246,5,101,232.3030078,36.9482683,65.3352997,1.8,36.5706558,65.9696313,0.6993471,20.1968648,19.8769423,6927.6164112,8744.3856466,16.043353,439.9260969,343.0045452,708.8209985,21.375,24.768459,1.9836402,78.8014069),(22764,'metacarpus-maybe',246,5,102,232.0101882,36.9518423,65.3188238,1.8,36.6284087,65.8831451,0.6833074,19.8655529,17.6740817,6900.1831677,8702.5017414,15.4138707,492.3877728,347.3441295,702.1445212,21.375,24.6510807,1.9527151,78.956737),(22765,'metacarpus-maybe',246,5,103,232.2176101,36.9410869,65.3035771,1.8,36.6210282,65.8789323,0.6671457,19.4440436,24.636185,6893.6556973,8676.1145769,14.8172959,352.1695661,354.5381731,631.9574364,21.375,24.6510807,1.9527151,78.4907467),(22766,'metacarpus-maybe',246,5,104,232.1236044,36.9344986,65.2765131,1.8,36.6457439,65.7995707,0.6479952,17.5325156,14.5049795,6868.6452549,8631.6845772,14.094541,595.0842326,391.7660993,776.6669852,21.375,24.5481829,1.9626497,78.1612418),(22767,'metacarpus-maybe',246,5,105,231.6040163,36.9430555,65.2762984,1.8,36.5454531,66.1086966,0.656258,16.2380517,18.4735459,6960.191445,8569.2712088,14.3706741,463.8671563,428.6346387,829.1701953,21.4550838,24.5574899,1.9215243,78.1157467),(22768,'metacarpus-maybe',246,5,106,230.4343679,36.9330541,65.2706196,1.8,36.4951515,66.1625368,0.6390808,15.0704036,18.2946274,6931.564692,8484.4982756,13.6632979,463.7699403,459.9455247,829.664802,21.375,24.4771896,1.9555701,77.8505817),(22769,'metacarpus-maybe',246,5,107,229.2178551,36.9383468,65.2336773,1.8,36.5672595,65.9834318,0.6340485,18.2121657,24.8403499,6860.0159324,8438.8790899,13.4073753,339.7246466,376.6721675,614.7745344,21.375,24.3814895,1.9241665,77.5854166),(22770,'metacarpus-maybe',246,5,108,228.8664844,36.9283926,65.2101031,1.8,36.5719146,65.9193975,0.6042758,17.7894066,16.0676142,6850.1915048,8392.4228144,12.3135082,522.3191637,385.0713889,725.556377,21.375,24.3035009,1.9584659,77.7407467),(22771,'metacarpus-maybe',246,5,109,229.3913246,36.9035453,65.201475,1.8,36.4787513,65.9788005,0.5796344,17.3514458,23.7940379,6906.2868941,8387.1742192,11.4693793,352.4905804,398.0237127,639.1749174,21.375,24.2752768,1.9756881,77.5399215),(22772,'metacarpus-maybe',246,5,110,228.7592259,36.9051231,65.1800268,1.8,36.5537814,65.9661738,0.5673914,15.6306635,12.9970312,6871.2482358,8353.2203177,11.0122911,642.7021825,439.6005484,924.2022412,21.375,24.2020305,1.9685672,77.4755817),(22773,'metacarpus-maybe',246,5,111,228.0802628,36.9107274,65.1377793,1.8,36.6285235,65.7219025,0.5395797,15.9676807,13.9023354,6791.6837149,8333.3583332,10.0342086,599.4214723,425.3393997,947.1572043,21.3074489,24.1030502,1.9787525,77.5854166),(22774,'metacarpus-maybe',246,5,112,227.0839879,36.9061672,65.1122111,1.8,36.6473524,65.655219,0.5180566,15.893658,24.1564128,6717.9778174,8311.7638594,9.2807643,344.0810492,422.6829217,612.9819747,21.2632946,24.029279,1.9715898,77.3202516),(22775,'metacarpus-maybe',246,5,113,225.8850852,36.917031,65.1026039,1.8,36.6253403,65.7944261,0.5150947,16.8912556,24.4041209,6712.1385609,8249.4320254,9.135989,338.0343863,397.3735713,603.6472438,21.1511501,24.0065909,1.9890207,77.1005817),(22776,'metacarpus-maybe',246,5,114,224.3872479,36.9043253,65.0956049,1.8,36.6143564,65.760359,0.4990189,13.8265527,24.137394,6636.648998,8183.2696383,8.5650032,339.0287132,479.9930361,604.0612076,21.1511501,23.9310533,1.9818609,77.1005817),(22777,'metacarpus-maybe',246,5,115,222.7780185,36.9050206,65.0695782,1.8,36.6378813,65.711568,0.494913,14.7737423,17.8477509,6580.251817,8120.2799426,8.3757973,454.9749701,445.4018281,787.0984937,21.0795587,23.9567481,1.9643834,77.0550865),(22778,'metacarpus-maybe',246,5,116,221.5882138,36.9062841,65.0388145,1.8,36.6303573,65.6612379,0.4976333,13.8865526,15.3634489,6498.0519339,8082.7266159,8.4151965,526.1010524,467.9384538,877.0846588,21.0070959,23.8854689,1.9571335,76.7899215),(22779,'metacarpus-maybe',246,5,117,221.059549,36.9159056,64.9934688,1.8,36.6722852,65.5673824,0.4973573,17.4073609,14.0443772,6427.1925011,8059.6367202,8.3865886,573.8692856,369.2226826,747.4244212,21.0254419,23.901654,2.0169019,76.5702516),(22780,'metacarpus-maybe',246,5,118,220.207745,36.9102257,64.9498311,1.8,36.6427342,65.5059994,0.4937588,13.8268203,21.6244907,6353.4680955,8020.1711902,8.2437793,370.8837032,459.503193,649.9674354,20.8626767,23.83906,2.0801867,76.2595914),(22781,'metacarpus-maybe',246,5,119,219.5634162,36.9168233,64.9046711,1.8,36.680107,65.4119652,0.4842638,13.552255,13.0239358,6282.9680734,7997.5028005,7.9314818,614.0619047,463.6105252,1010.1622957,20.8236933,23.8353729,1.9922155,76.3050865),(22782,'metacarpus-maybe',246,5,120,218.2724361,36.9245228,64.8538871,1.8,36.682049,65.3481357,0.4665322,13.7775999,12.9495639,6213.6557684,7945.9610103,7.3598782,613.6083865,450.9969668,942.4948092,20.7612216,23.8235703,2.0626055,75.7747564),(22783,'metacarpus-maybe',246,5,121,216.7019638,36.9601993,64.7779891,1.8,36.669633,65.4057046,0.4666355,14.8628514,24.9786074,6198.0927874,7869.6865274,7.309924,315.0570563,417.0190913,554.1763924,20.7457264,23.7000297,2.1017181,75.4640963),(22784,'metacarpus-maybe',246,5,122,215.564233,36.9630262,64.7486361,1.8,36.6478563,65.4077202,0.4547547,16.1913089,23.2443095,6147.3108526,7835.6885348,6.9315933,337.1013687,379.6673199,572.7368898,20.7067429,23.7422685,2.0026525,75.6837662),(22785,'metacarpus-maybe',246,5,123,215.1869744,36.9618963,64.7155255,1.8,36.6080592,65.4652891,0.4500878,14.2674267,25.2768483,6139.5130605,7804.7343826,6.7878498,308.7700761,430.3167753,536.055973,20.6287761,23.6755412,2.0840486,75.1989312),(22786,'metacarpus-maybe',246,5,124,214.8875817,36.9778285,64.6681061,1.8,36.6192203,65.3801031,0.4476364,15.7992105,25.3367075,6087.9275884,7815.6182049,6.7097589,308.4701594,385.3311261,532.4140057,20.5614938,23.6056468,2.0948685,75.0890963),(22787,'metacarpus-maybe',246,5,125,214.1722479,36.9996286,64.6135555,1.8,36.6567323,65.2802108,0.4440566,14.6154237,15.2251398,6007.2814434,7784.4889595,6.5879898,511.2917902,411.0234195,723.984416,20.4843568,23.5840419,2.0771226,74.9337662),(22788,'metacarpus-maybe',246,5,126,213.3723366,37.0162992,64.5532637,1.8,36.6524421,65.1994261,0.4445874,15.6679332,14.5890473,5934.9875659,7747.6737334,6.5780358,531.0609783,378.7983707,710.4971043,20.3506222,23.5123804,2.0879642,74.357941),(22789,'metacarpus-maybe',246,5,127,212.8990909,37.0297732,64.5010439,1.8,36.6121401,65.1763111,0.4399381,13.6305757,19.3652705,5871.4501447,7729.9391197,6.4358246,399.1650486,430.7558454,655.3595642,20.2336719,23.4434992,2.0988708,74.1837662),(22790,'metacarpus-maybe',246,5,128,211.4695419,37.0567609,64.4322917,1.8,36.6963619,64.9879706,0.4345303,13.9134803,12.177139,5740.605877,7677.4410468,6.2463824,630.4798732,412.5930923,843.5480163,21.6952551,23.7118938,1.960113,130.3142315),(22791,'metacarpus-maybe',246,5,129,209.2466761,37.105051,64.3344696,1.8,36.7533441,64.9080872,0.4347815,13.5098708,11.8585852,5641.43504,7565.2918638,6.1874147,637.9590611,417.5787543,820.0206712,22.1017881,24.5703709,0.2782997,133.0757169),(22792,'metacarpus-maybe',246,5,130,206.9118537,37.1131492,64.3156895,1.8,36.730306,64.9790309,0.4242605,14.9240236,20.5353847,5565.5161764,7492.8759496,5.843646,364.8763367,372.9233024,603.8759077,19.8278831,23.1651678,2.0778948,72.4374458),(22793,'metacarpus-maybe',246,5,131,205.0104013,37.1228909,64.2960081,1.8,36.6850274,65.121177,0.4210647,13.9958376,24.9101187,5521.8420884,7429.6806589,5.7082471,298.2595444,394.5345919,505.0870446,19.7109328,23.0564016,2.1181892,72.6837662),(22794,'metacarpus-maybe',246,5,132,203.5865092,37.1514991,64.2370258,1.8,36.8085469,64.9354551,0.4197906,14.2445284,25.5525502,5398.608916,7388.2045322,5.6363849,289.137658,378.9952714,484.5960749,19.6170115,22.8965063,2.1224513,71.998106),(22795,'metacarpus-maybe',246,5,133,202.3055859,37.1695182,64.1768784,1.8,36.8443324,64.7849265,0.4105271,14.896468,24.7124443,5291.1954831,7364.38015,5.3703703,298.0029029,355.1979905,500.0747688,19.5390447,22.7987973,2.1154471,71.998106),(22796,'metacarpus-maybe',246,5,134,200.7691832,37.1800636,64.1229005,1.8,36.8781386,64.6805261,0.4015262,15.6616144,14.1575777,5193.3137255,7345.9752815,5.1110183,518.872325,331.5950445,606.3563479,19.5000612,22.6386354,2.1197383,71.4677759),(22797,'metacarpus-maybe',246,5,135,199.4646413,37.1930322,64.0583132,1.8,36.9050935,64.5427107,0.3952745,16.0033026,15.0733195,5104.7344295,7335.0967543,4.9291834,486.627831,318.9800606,579.2268033,19.4114097,22.5203033,2.1426341,71.6686011),(22798,'metacarpus-maybe',246,5,136,198.2299751,37.1998111,64.0032112,1.8,36.9018407,64.479417,0.3851029,14.7420797,14.0557489,5031.9576096,7304.9536843,4.6622476,519.7128769,341.3329549,773.816587,19.3449573,22.4013462,2.068139,70.9374458),(22799,'metacarpus-maybe',246,5,137,196.6947763,37.2398509,63.925725,1.8,36.925963,64.4706978,0.3801977,14.7830857,27.2624629,4991.6219862,7240.0910468,4.5147427,265.5699552,337.6576515,435.0022952,19.2181818,22.3502831,2.219331,70.7632711),(22800,'metacarpus-maybe',246,5,138,195.7524183,37.2397319,63.8909413,1.8,36.9132848,64.4174327,0.3729627,12.9985507,14.7871008,4926.7674063,7191.2391512,4.331671,486.3183968,379.0243641,707.1363351,19.1624167,22.2841206,2.2429092,70.607941),(22801,'metacarpus-maybe',246,5,139,195.2281108,37.2452905,63.8542943,1.8,36.9293502,64.3936271,0.3669145,12.6803941,29.6394119,4886.2971865,7165.9762335,4.18739,241.7718769,385.3426899,397.5391878,19.1257901,22.2375316,2.4997779,70.498106),(22802,'metacarpus-maybe',246,5,140,194.037294,37.2509382,63.7995413,1.8,36.9360794,64.3202198,0.3569746,13.5314201,24.8982542,4827.6209801,7155.9431516,3.9489548,287.4074265,356.7711997,461.4741969,18.97483,22.2209255,2.5910433,70.4526109),(22803,'metacarpus-maybe',246,5,141,192.8036932,37.2719106,63.7484306,1.8,36.9644437,64.219999,0.3479667,12.8915579,14.3558699,4750.5464143,7149.4301898,3.7362846,498.0144189,368.5005686,716.4512381,18.8539655,22.2367411,2.715663,70.0776109),(22804,'metacarpus-maybe',246,5,142,191.4623331,37.2930298,63.6932567,1.8,36.9988474,64.0974539,0.3344896,15.5307772,24.7309779,4666.5676032,7153.6230736,3.4390592,289.2575898,300.4722514,455.7098387,18.7427861,22.2564948,2.6214016,69.8124458),(22805,'metacarpus-maybe',246,5,143,193.5061896,37.3088593,63.6468753,1.8,37.2562909,64.07378,0.3272823,12.7472084,12.4977166,4581.9382357,7269.6276295,3.332934,581.6764651,359.4464042,884.5614762,18.4717304,22.3274635,2.6328628,69.2366206),(22806,'metacarpus-maybe',246,5,144,195.5496946,37.2947838,63.6004386,1.8,37.3159615,63.9981276,0.3116366,11.3820621,12.3925743,4581.6084641,7406.2709592,3.0640642,597.6378083,402.5288579,933.1009159,18.2873701,22.4287936,2.7377986,69.2366206),(22807,'metacarpus-maybe',246,5,145,193.7470952,37.3444206,63.5169566,1.8,37.3404551,63.9270424,0.3009301,11.3028232,12.3638622,4521.9880873,7369.1124358,2.837041,596.0202679,400.07598,923.3589895,0.375,0.5303301,0.7853982,1.0606602),(22808,'metacarpus-maybe',246,5,146,192.7565305,37.3534201,63.4731495,1.8,37.3327769,63.8991946,0.290739,11.3976516,11.7235672,4478.2281132,7373.8252269,2.6399333,628.9745374,392.907967,927.5839494,18.0726338,22.6036674,2.7857346,68.8161255),(22809,'metacarpus-maybe',246,5,147,192.239478,37.3658652,63.4394801,1.8,37.3483242,63.8885201,0.2793297,11.3781817,12.5793814,4449.453233,7414.7006265,2.4355698,589.4328508,391.0513437,918.2091398,17.9358194,22.6696727,2.7779818,68.8804653),(22810,'metacarpus-maybe',246,5,148,192.518331,37.3699152,63.4000694,1.8,37.3339818,63.8397576,0.2668536,10.9115816,11.868851,4437.3305093,7495.8436603,2.231175,631.5559664,406.662452,936.5831393,17.8059985,22.8450111,2.8587834,68.8804653),(22811,'metacarpus-maybe',246,5,149,192.5142188,37.3751355,63.3511752,1.8,37.2675846,63.8028546,0.2506502,11.3354268,11.8324578,4416.4866807,7617.3696252,1.9739382,643.7690064,389.6180312,938.9669633,17.7296945,23.0083205,2.8353048,69.0357954),(22812,'metacarpus-maybe',246,5,150,192.0414311,37.4001507,63.2729244,1.8,37.3658363,63.611227,0.240954,10.7061332,12.8484834,4352.0804627,7735.0849974,1.8225972,602.0231942,406.5034838,933.6977419,17.6593412,23.1545419,2.7686049,69.3009605),(22813,'metacarpus-maybe',246,5,151,192.9227557,37.4165358,63.2239545,1.8,37.3497506,63.586625,0.2290585,10.6813248,12.8239211,4339.6709559,7888.1644481,1.6577394,615.1132996,406.2858326,944.4038295,17.5634527,23.3744151,2.8985595,69.3009605),(22814,'metacarpus-maybe',246,5,152,192.3008842,37.4442347,63.1647122,1.8,37.4094572,63.4778971,0.2165417,10.6473622,12.0537553,4299.8414607,8021.0312642,1.4794981,665.4383698,403.8410066,940.9858359,17.4721653,23.6175584,2.8600215,69.7214556),(22815,'metacarpus-maybe',246,5,153,191.3291974,37.5127323,63.0704187,1.8,37.4946595,63.4158368,0.2043522,11.6844347,12.3031172,4256.6470205,8125.5623499,1.3132125,660.4474448,364.3006385,928.5449237,17.4625064,23.901654,2.9441971,70.0964556),(22816,'metacarpus-maybe',246,5,154,190.9104652,37.5380955,63.0276708,1.8,37.5340784,63.3761222,0.1951006,11.3085814,12.8266752,4235.6785225,8274.8285951,1.195854,645.1265423,374.554366,927.3481823,17.355116,24.1671426,2.9700665,70.6267857),(22817,'metacarpus-maybe',246,5,155,190.8135298,37.5575679,62.9753111,1.8,37.5403479,63.3171028,0.1880389,11.4022268,12.6383444,4239.2830658,8470.6890207,1.111293,670.237237,371.7943117,941.0420086,17.4200619,24.4764715,2.9877785,71.2026109),(22818,'metacarpus-maybe',246,5,156,192.4880753,37.5831068,62.9247092,1.8,37.5470057,63.2694695,0.1838607,12.0041063,12.8902216,4297.6794547,8751.4874748,1.0723368,678.9245177,358.0174447,963.9746987,17.3721537,24.8471106,2.9900908,71.732941),(22819,'metacarpus-maybe',246,5,157,194.1067116,37.6072025,62.8861228,1.8,37.5684251,63.2286888,0.1810804,11.6256816,12.7604983,4371.2354625,9069.6444749,1.0492525,710.7594267,375.9982081,946.5349326,17.4846286,25.1906791,2.9996956,72.6382711),(22820,'metacarpus-maybe',246,5,158,197.1577841,37.6245271,62.8530208,1.8,37.5893232,63.1576005,0.1768545,11.7389044,13.0356024,4475.3941914,9453.3117907,1.0170964,725.1917854,381.2446243,986.1339123,17.5189957,25.5887701,2.9945143,73.2784361),(22821,'metacarpus-maybe',246,5,159,200.6157528,37.6109241,62.845986,1.8,37.6077304,63.1308405,0.1743795,11.272313,13.2337988,4594.859587,9897.9750232,1.0064637,747.9315027,407.6234906,1013.639568,17.6634746,25.9597796,2.9966313,74.1837662),(22822,'metacarpus-maybe',246,5,160,204.6773544,37.573332,62.8369563,1.8,37.5686033,63.0844223,0.1693956,11.2368477,13.6022951,4726.6738747,10386.8114704,0.9695374,763.6072747,420.6405552,1002.2065234,17.8790243,26.3582589,2.9916475,75.7292613),(22823,'metacarpus-maybe',246,5,161,209.852152,37.6197121,62.8149865,1.8,37.5930527,63.0860802,0.165741,11.8202851,13.9573402,4900.1982171,10951.6744203,0.9520106,784.6533967,414.5583772,1080.6969986,18.0161273,26.8459145,2.9304993,76.8087662),(22824,'metacarpus-maybe',246,5,162,212.8610689,37.6461938,62.8393524,1.8,37.6263935,63.0605902,0.1672493,11.2536249,14.4043452,5085.4619088,11528.7601841,0.9831519,800.366837,451.8954538,1134.8316081,18.2936317,27.3132866,2.9899872,79.2595914),(22825,'metacarpus-maybe',246,5,163,215.7089382,37.6856612,62.8964662,1.8,37.689561,63.1275386,0.1680425,12.2903783,14.4793835,5295.3217305,12183.892856,1.0056879,841.4648922,430.8509948,1178.2229492,18.4568836,27.8056874,2.965358,81.1345914),(22826,'metacarpus-maybe',246,5,164,220.3219283,37.6844446,62.9369843,1.8,37.6756249,63.1402514,0.16513,11.8059503,14.6551354,5517.7473826,12979.3377388,0.9922187,885.6511667,467.3700322,1247.5280048,18.5577043,28.2777104,2.9480982,83.1649215),(22827,'metacarpus-maybe',246,5,165,225.436843,37.6930975,62.9840764,1.8,37.6851437,63.0719353,0.1654448,11.5120695,14.7932926,5745.1270047,13838.551612,1.0190928,935.4612252,499.0524959,1295.2354494,18.8290884,28.7615466,2.9646546,88.4415719),(22828,'metacarpus-maybe',246,5,166,232.4930007,37.6887765,63.0939589,1.8,37.6797363,63.1680176,0.1645927,13.3780396,14.9022429,6182.5940826,14752.9729281,1.0402892,989.9833913,462.1449988,1285.2564492,19.2241437,29.2884363,2.9090357,89.3280573),(22829,'metacarpus-maybe',246,5,167,242.8153551,37.7193705,63.119801,1.8,37.7218824,63.2186899,0.1641593,12.8107542,15.3907992,6902.9492023,15791.6273508,1.0808144,1026.0433629,538.8401879,1431.5399024,0.1875,0.265165,2.3561945,0.5303301),(22830,'metacarpus-maybe',246,5,168,247.5793359,37.7180591,63.2261134,1.8,37.7270791,63.2449924,0.1644529,13.0400196,15.7757119,7428.1492646,16882.7228252,1.1059304,1070.1718541,569.6424934,1495.3184369,0.1875,0.265165,2.3561945,0.5303301),(22831,'metacarpus-maybe',246,5,169,254.7081286,37.791711,63.349415,1.8,37.7924911,63.369909,0.1640136,13.4283511,16.1747551,8088.953835,18170.4769437,1.1317584,1123.3849836,602.378784,1576.6150479,0.415116,1.0933035,1.0303768,2.3409903),(22832,'metacarpus-maybe',246,5,170,263.072397,37.800624,63.4905028,1.8,37.7641423,63.4857407,0.161914,13.0947837,16.6334164,8793.9710228,19585.8861555,1.1394477,1177.5023062,671.5629056,1656.819035,0.5303301,0.7954951,0.7853982,1.5909903),(22833,'metacarpus-maybe',246,5,171,272.2003445,37.8122819,63.6402528,1.8,37.8287051,63.5408808,0.1649305,13.6187904,17.0640194,9450.4265525,21198.2555761,1.2229192,1242.2779814,693.9255475,1762.3077902,22.6882575,33.2599844,2.9773708,95.7485524),(22834,'metacarpus-maybe',246,5,172,285.1697727,37.8125751,63.8360928,1.8,37.8117271,63.7157483,0.1653292,13.8124721,17.3100828,10358.6380899,23113.1966948,1.2873325,1335.2447227,749.9481652,1863.4682212,23.3232112,34.1852147,2.9818542,98.2637175),(22835,'metacarpus-maybe',246,5,173,297.4717116,37.7970746,63.8952461,1.8,37.8116243,63.796707,0.1647932,13.9345539,17.6217915,11175.6801613,24844.628604,1.3342536,1409.8809783,802.012053,1977.7256724,23.7907915,35.0504658,2.9641315,100.6690476),(22836,'metacarpus-maybe',246,5,174,315.0249822,37.762017,63.8575813,1.8,37.7512138,63.8642006,0.1545585,14.6777358,17.9308666,12044.0734104,26580.9226615,1.2442816,1482.4114881,820.5675298,2087.7150643,24.2290403,35.672337,2.9297651,103.0100378),(22837,'metacarpus-maybe',246,5,175,346.5303835,37.7481293,63.8528503,1.8,37.6961872,63.9510924,0.1463294,14.098894,18.0075527,13179.40632,29055.2851302,1.2278662,1613.5054885,934.782993,2270.2916375,24.1116045,36.1685507,3.0011619,104.1538825),(22838,'metacarpus-maybe',246,5,176,370.9400604,37.738407,63.8683221,1.8,37.6893609,64.007677,0.1493535,14.2682348,18.0988876,13766.3674096,31683.0473273,1.3688365,1750.5521949,964.8262475,2393.9672476,24.0815835,36.3430917,2.9705068,105.1047077),(22839,'metacarpus-maybe',246,5,177,368.0921165,37.6544252,63.7280025,1.8,37.7730489,63.9781273,0.1607746,14.5900866,18.6794734,12899.4703359,31932.817411,1.5721536,1709.5137954,884.125689,2346.887959,23.9558544,36.0663451,2.9849908,105.6993776),(22840,'metacarpus-maybe',246,5,178,337.1359517,37.7607233,63.6743046,1.8,37.8418635,64.0193313,0.1723255,14.3458098,18.2344887,11464.4968566,29239.9521682,1.6521507,1603.5520696,799.1529934,2114.0326342,24.2672206,35.5345892,3.0676536,131.8064258),(22841,'metacarpus-maybe',246,5,179,313.8489311,37.9950031,63.741631,1.8,37.9655332,64.1294295,0.1726605,14.0671726,18.3821862,10585.9659354,26977.9698139,1.5439576,1467.6148684,752.5297514,1917.6071882,25.8190953,35.5721648,2.9721112,133.6092802),(22842,'metacarpus-maybe',246,5,180,309.9958168,38.0684505,63.8890783,1.8,38.0316382,64.25851,0.1664014,14.1936256,18.517057,10710.077024,26988.7178207,1.4174458,1457.5057942,754.569505,1899.0774907,25.9575043,35.9736231,2.968732,194.6147455),(22843,'metacarpus-maybe',246,5,181,314.2277024,38.2033618,64.0314084,1.8,38.0385478,64.3224428,0.1552087,13.1478604,18.5383974,11870.9828325,27933.7907171,1.2515122,1506.8072026,902.8832414,1968.1561992,1.3559189,4.732286,0.9827937,10.4246212),(22844,'metacarpus-maybe',246,5,182,311.7464382,38.1174179,64.0478825,1.8,38.0080379,64.3606659,0.1460841,14.455712,18.6530704,12966.8498456,28897.5765175,1.1009423,1549.2128621,897.0052686,2055.2693187,2.2208212,6.0466933,1.0516502,15.9020968),(22845,'metacarpus-maybe',246,5,183,311.3806854,38.1399804,64.0169038,1.8,37.9960396,64.3434306,0.1459317,14.3459855,18.6993056,13682.4559569,29757.5757972,1.0973737,1591.3733088,953.7480671,2118.1778794,2.2533907,5.4665174,1.1839206,16.3414367),(22846,'metacarpus-maybe',246,5,184,314.5934339,38.1977706,64.0460898,1.8,38.0440116,64.3781312,0.1502867,14.120344,18.7003107,14030.2399975,30453.4391848,1.175351,1628.4991002,993.6188555,2158.2534384,2.0967884,4.838808,0.9505468,13.6066017),(22847,'metacarpus-maybe',246,5,185,319.363093,38.2682096,63.9947037,1.8,38.06478,64.2986695,0.1581675,14.104176,18.6474697,13838.291205,30968.1616051,1.3205154,1660.7165563,981.1485058,2184.0570106,1.7814728,5.5399825,1.152572,14.6861066),(22848,'metacarpus-maybe',246,5,186,323.0114169,38.2724638,63.9879616,1.8,38.0070535,64.2648361,0.1574384,13.6145327,18.93615,13077.2057321,31566.2454697,1.3234169,1666.9832809,960.5328396,2181.5224981,1.0452946,3.9016223,0.9561334,8.613961),(22849,'metacarpus-maybe',246,5,187,325.9240909,38.1710442,63.9782713,1.8,37.9032102,64.2179385,0.1507762,14.1404991,18.5590708,11883.4642117,32115.8867397,1.2255673,1730.4684615,840.3850621,2182.8404061,1.0682105,4.0388736,1.1902899,10.0041261),(22850,'metacarpus-maybe',246,5,188,321.4060227,37.8667305,63.9498723,1.8,37.7236069,64.1937574,0.1422567,13.5360731,18.5684605,10116.6490101,31567.0991419,1.0767545,1700.0385717,747.3843357,2033.6277689,17.1282405,25.6875,0.697542,75.1189799),(22851,'metacarpus-maybe',246,5,189,300.8012855,37.2827315,63.8520203,1.8,37.4198988,64.1038349,0.1361153,12.6277493,18.5030098,7856.2521106,28231.7578529,0.9231207,1525.792735,622.1419142,1881.0370853,17.0805967,24.775555,0.6889244,81.5661255),(22852,'metacarpus-maybe',246,5,190,247.9935618,35.7174565,63.5547084,1.8,36.4265876,63.8775586,0.1224025,10.8861275,19.6724168,5327.0211004,18486.1613207,0.6161684,939.6995571,489.3403178,1199.7424862,16.9412585,23.3254823,0.6370703,83.8694264),(22853,'metacarpus-maybe',246,5,191,184.004233,35.7540339,63.4330475,1.8,35.3550443,63.5269829,0.1205686,10.6186344,15.4492903,2982.8030216,10565.534126,0.443649,683.8847575,280.9026964,852.0908092,16.7326515,21.3264251,0.5660549,90.0780573),(22854,'metacarpus-maybe',246,5,192,102.6331214,35.9331265,63.3430076,1.8,36.5111483,63.4920414,0.1423867,8.7759999,14.6450776,1143.4995182,4295.4360302,0.3444595,293.3023749,130.2984882,368.7510073,1.5102017,2.8620633,1.0191413,6.7123106),(22855,'metacarpus-maybe',246,5,193,31.4838814,32.3331768,62.8831412,1.8,33.869133,63.0107642,0.1004649,6.6946333,15.4897139,195.6848933,664.5133102,0.0527843,42.9002959,29.2301138,55.310308,9.2305187,13.6875,0.853255,40.046388),(22856,'metacarpus-maybe',246,5,194,2.3876953,29.4869992,62.8777856,1.8,29.4913732,62.8927817,-1.3562476,1.1802238,3.810372,0.5291857,5.9762347,0.3799105,1.5684124,0.4483775,1.7053937,2.4104562,7.5490583,1.3197936,16.9094562),(22857,'metacarpus-maybe',246,5,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22858,'metacarpus-maybe',246,5,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22859,'metacarpus-maybe',246,5,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22860,'metacarpus-maybe',246,5,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22861,'metacarpus-maybe',246,5,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22862,'metacarpus-maybe',246,5,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22863,'red-deer-femur.tif',246,7,1,0.0260028,70.9132881,85.3335867,1.8,70.0454883,85.3887858,-0.0628221,0.1280798,35.7882206,0.0003005,8.4246042,0.0000171,0.2354016,0.0023461,0.23541,0,0,0,0),(22864,'red-deer-femur.tif',246,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22865,'red-deer-femur.tif',246,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(22866,'red-deer-femur.tif',246,7,4,5.2034917,30.2076856,67.3042611,1.8,30.1530963,67.4676294,1.0525036,1.9256694,4.6151109,3.8307346,19.6903425,0.6544093,4.2664939,1.9893002,5.0903831,3.9074003,9.4511409,2.0736395,22.2847362),(22867,'red-deer-femur.tif',246,7,5,28.9569362,30.3747285,67.193364,1.8,30.091034,65.9782304,1.2034912,3.857181,20.9901392,78.9087222,431.8644699,4.2038041,20.5746358,20.4576146,24.0289707,7.7760971,20.4374309,1.8059473,51.5877187),(22868,'red-deer-femur.tif',246,7,6,66.6803255,30.0883165,64.8692975,1.8,29.9307264,64.382667,1.3208188,5.273745,13.1350327,333.16514,2493.9634938,10.4332711,189.8711297,63.1742979,214.9144469,9.8802031,25.2832238,1.8614688,62.3533307),(22869,'red-deer-femur.tif',246,7,7,88.2885221,30.0163006,64.2745191,1.8,29.949587,63.9434039,1.3525955,5.9046519,14.2844293,589.7903405,4395.0815162,14.0252091,307.6833822,99.8857089,348.0334694,11.162564,28.0716019,1.8014647,68.2714746),(22870,'red-deer-femur.tif',246,7,8,102.5671112,29.9843785,63.9251643,1.8,29.9593615,63.5513901,1.3621692,6.2040705,15.0867834,859.2856214,5998.0236928,16.361207,397.5680912,138.5035241,454.2955255,12.0081904,30.0772653,1.8141055,73.3406869),(22871,'red-deer-femur.tif',246,7,9,115.3036353,30.0107067,63.4896689,1.8,30.0731799,63.0907976,1.3609066,6.508159,15.8506931,1176.0527389,7637.943647,18.3830398,481.8681162,180.7043649,556.0136365,12.8596353,31.8868068,1.8267982,78.0963055),(22872,'red-deer-femur.tif',246,7,10,127.0003833,29.9892655,63.2518361,1.8,30.1074992,62.813976,1.3551286,41.4214671,31.6421499,1546.4513906,9041.1035319,20.1973814,285.7297483,37.3345393,203.1205048,13.7549132,33.1023082,1.8430823,80.9739318),(22873,'red-deer-femur.tif',246,7,11,139.594749,29.9047983,63.0965797,1.8,30.1064813,62.6842237,1.3405257,8.3088969,17.0360968,2009.5003248,10221.3722771,22.0537839,599.9832232,241.8492314,717.1440088,15.0274608,33.8702969,1.8558129,84.0230682),(22874,'red-deer-femur.tif',246,7,12,152.1103919,29.8258122,62.9732493,1.8,30.0765014,62.5576033,1.3125327,41.6302647,33.6581952,2523.0911139,11353.4345256,23.6980324,337.3156069,60.607136,259.2066908,0.207031,0.6546895,1.8925469,1.4136961),(22875,'red-deer-femur.tif',246,7,13,163.1524188,29.8007942,62.8668276,1.8,30.028629,62.5225652,1.2823476,40.7287746,35.2657983,3066.0942251,12376.3007638,24.991673,350.9434454,75.2807875,286.6340786,17.0129436,35.4960068,1.8667224,89.949831),(22876,'red-deer-femur.tif',246,7,14,206.1146154,37.7610379,62.42768,1.8,38.864976,62.0936358,-0.0222376,27.1391516,46.9515525,12755.0581746,72059.4396999,0.0169847,1534.7615979,469.9873579,1805.8955274,17.9302861,36.2114915,1.872658,91.9282915),(22877,'red-deer-femur.tif',246,7,15,286.285067,47.3013663,61.8762152,1.8,45.5493655,61.848119,-0.0476056,24.9349526,39.9108087,14715.0982634,161558.0451566,0.1080527,4047.9772347,590.1394111,4416.6475973,18.821603,36.8800028,1.9262819,94.44209),(22878,'red-deer-femur.tif',246,7,16,363.7710949,52.2304367,61.6172961,1.8,49.8619431,61.6996239,-0.0565132,27.1244312,37.0416973,17536.7065435,214755.9208047,0.193426,5797.6803545,646.5280845,6270.8959478,20.0364055,37.486906,1.9379702,96.4915924),(22879,'red-deer-femur.tif',246,7,17,454.4522296,55.2412626,61.4327065,1.8,52.8349597,61.5336888,-0.0624809,28.6495261,36.8242812,21291.7207266,254746.2799061,0.2953026,6917.888728,743.1788106,7135.9453658,21.3669092,37.9505386,1.9685249,99.7918995),(22880,'red-deer-femur.tif',246,7,18,535.1740403,56.4701215,61.4181045,1.8,54.0685943,61.5560937,-0.0687473,28.1711291,38.7143708,25352.5378734,277647.4762682,0.4208922,7171.6902763,899.9475248,7498.262033,35.0764968,75.5325586,2.9624746,243.1034031),(22881,'red-deer-femur.tif',246,7,19,607.4411592,57.2200668,61.3955737,1.8,54.7998208,61.5067897,-0.0757356,28.8650862,39.7933481,29709.1185275,298594.8135546,0.5795913,7503.636363,1029.2405975,7921.7572345,34.9850456,76.3428041,2.9809023,271.9664672),(22882,'red-deer-femur.tif',246,7,20,645.3146948,57.9878319,61.3534122,1.8,55.4461292,61.4303776,-0.080683,26.5744858,40.9571821,33865.6407053,315112.1269429,0.6986205,7693.6964594,1274.3667356,8233.258275,34.6703051,76.9314493,3.0850492,219.0985172),(22883,'red-deer-femur.tif',246,7,21,673.829128,58.664239,61.2788384,1.8,56.0408739,61.3584865,-0.0816547,28.3399569,41.9184243,37760.6687265,329290.7676792,0.7471299,7855.5139758,1332.4180021,8514.0658989,34.3875447,78.2360808,3.0727362,223.2599449),(22884,'red-deer-femur.tif',246,7,22,690.0732959,59.1495544,61.2832145,1.8,56.4999766,61.3226148,-0.087919,28.5065303,42.4531213,41243.0461152,337149.8663005,0.8867293,7941.697947,1446.7929147,8696.929212,33.9340216,78.7439354,3.0573597,219.8677882),(22885,'red-deer-femur.tif',246,7,23,692.5437741,59.5215723,61.2526164,1.8,56.9015763,61.3152446,-0.0943918,28.6983569,42.7729926,43758.7354523,341192.9550632,1.0253542,7976.8315102,1524.7819078,8792.300362,33.2049412,78.9678764,3.0549679,223.2097107),(22886,'red-deer-femur.tif',246,7,24,687.2191912,59.6860176,61.242897,1.8,57.2264484,61.2782484,-0.1017044,28.5594614,42.6523496,45241.8618786,338035.2980025,1.1806614,7925.3616995,1584.1286779,8820.4053692,33.3898968,78.6785899,3.067848,222.6241386),(22887,'red-deer-femur.tif',246,7,25,677.0376351,60.0347105,61.1680705,1.8,57.6606901,61.2076755,-0.1092467,28.6389392,42.2919982,45773.0086883,328140.1575977,1.3413731,7758.9182631,1598.278776,8687.5753015,33.6697502,78.1497464,3.0912374,222.9169247),(22888,'red-deer-femur.tif',246,7,26,657.4134738,60.2728556,61.1762736,1.8,57.9995424,61.2060299,-0.1126643,28.8086995,41.8225776,45143.2085866,312587.3055087,1.3849105,7474.128177,1566.9991836,8490.3871545,34.1830256,76.9091604,0.0511682,222.067993),(22889,'red-deer-femur.tif',246,7,27,636.5432801,60.3807509,61.1722197,1.8,58.3904289,61.1719841,-0.1148688,28.2217511,41.2479893,44038.0253449,294387.2374204,1.393702,7137.0081825,1560.4285214,8186.3191488,34.5901541,75.9129351,0.0955981,225.3388737),(22890,'red-deer-femur.tif',246,7,28,614.1691554,60.280799,61.1939854,1.8,58.814203,61.156075,-0.1193232,28.179013,40.2599664,43013.911051,273626.7285562,1.4505227,6796.4966862,1526.4520105,7681.1471001,34.8479989,74.7614139,0.1082107,220.349322),(22891,'red-deer-femur.tif',246,7,29,589.3919236,60.0996369,61.2434846,1.8,59.0968425,61.1388244,-0.1233102,28.0812029,38.2986848,41092.6477492,252587.1612967,1.4861017,6595.1915301,1463.3506928,7559.3893852,34.9665091,72.6419238,0.148749,217.2499514),(22892,'red-deer-femur.tif',246,7,30,568.8262567,59.5654448,61.4259407,1.8,59.0901696,61.2717807,-0.1287084,28.345425,39.4671166,39045.9395155,236144.5843971,1.5618623,5983.3249701,1377.5041112,6015.2142161,34.9015972,70.034643,0.1393887,214.0501126),(22893,'red-deer-femur.tif',246,7,31,546.4055815,58.9905749,61.5766142,1.8,58.8308272,61.46144,-0.1385818,28.3153334,34.3123483,36316.2812395,219057.5065464,1.7377783,6384.2178452,1282.5659071,7396.2324595,34.6334323,68.7542439,0.1572281,213.9704519),(22894,'red-deer-femur.tif',246,7,32,521.7714302,57.9725829,61.7901845,1.8,58.3657379,61.6881175,-0.1551669,19.4880804,34.5089932,33487.1730731,197620.6931055,2.0770129,5726.6432499,1718.3412871,6674.4621612,34.1711286,67.636112,0.1505548,207.6590537),(22895,'red-deer-femur.tif',246,7,33,486.8553352,56.5734694,62.0758628,1.8,57.365957,61.8988279,-0.1672653,29.5847363,35.061536,30914.7837823,166269.2093315,2.2490876,4742.2112172,1044.9572207,4998.5701394,33.7746074,66.5210932,0.1436576,208.2446258),(22896,'red-deer-femur.tif',246,7,34,458.4860218,55.3363482,62.3843942,1.8,55.7239179,62.3187427,-0.1739599,27.6625471,33.0230207,29563.9277149,140111.8431377,2.2892216,4242.8536289,1068.7348356,4245.8811769,33.2684869,62.3988137,0.0963672,198.9343252),(22897,'red-deer-femur.tif',246,7,35,443.3308953,54.5599908,62.5176942,1.8,54.4907434,62.5961097,-0.1877183,27.7046156,40.0777173,28668.1494494,124911.4891739,2.5732544,3116.7316311,1034.7788219,3443.1979134,32.807058,60.2986451,0.0928358,187.4324386),(22898,'red-deer-femur.tif',246,7,36,425.6785213,53.9961211,62.6918446,1.8,53.8704171,62.8281426,-0.2029622,28.135226,42.4560992,27799.1219957,114251.3989142,2.8826316,2691.0479576,988.0539785,3093.0381823,32.4384634,58.6000139,0.1204111,182.5347365),(22899,'red-deer-femur.tif',246,7,37,411.8060027,53.5888576,62.8012781,1.8,53.4577611,63.070405,-0.2181861,28.652826,32.5040363,27229.7004439,104421.4138535,3.2158295,3212.5675971,950.332104,3425.8373649,31.9634618,57.0433337,0.1054468,179.7575784),(22900,'red-deer-femur.tif',246,7,38,401.5693885,53.4087142,62.936529,1.8,53.1959463,63.3124651,-0.2375975,28.8321196,30.8779802,27025.0232381,96082.7220806,3.7077044,3111.6906446,937.3234978,3335.6508474,31.7588362,55.6728648,0.1192812,177.2229723),(22901,'red-deer-femur.tif',246,7,39,399.0011334,53.1766598,63.1443024,1.8,52.9231845,63.5681796,-0.2603615,28.9307206,30.2521848,27008.183366,90228.7089176,4.4069776,2982.5518272,933.5468597,3253.3934187,31.2992412,54.3451446,0.106871,176.9093786),(22902,'red-deer-femur.tif',246,7,40,398.2171774,53.027496,63.4313934,1.8,52.7503929,63.8431227,-0.281386,28.625343,28.5601851,26974.2123694,84729.7854958,5.1177752,2966.7099577,942.3192731,3220.7592974,30.7203594,53.1102109,0.1093658,172.6682903),(22903,'red-deer-femur.tif',246,7,41,394.3875634,53.2005026,63.5035638,1.8,52.7481532,64.0591412,-0.3027197,28.7173125,28.585933,26754.4543503,78875.7336744,5.8417952,2759.2499353,931.6489616,3061.2413856,30.5336909,51.5910286,0.1328167,163.2072873),(22904,'red-deer-femur.tif',246,7,42,386.9380726,53.2986751,63.6457499,1.8,52.6925441,64.379254,-0.3204579,29.0020913,26.9165015,26768.7110143,73663.6736257,6.3990373,2736.7476985,922.992439,3045.3451959,30.3984569,50.1211746,0.0951475,166.1057213),(22905,'red-deer-femur.tif',246,7,43,381.414312,53.4572672,63.7452415,1.8,52.8235784,64.559267,-0.3299423,28.805125,25.8279806,26868.3420505,69406.5836619,6.6727496,2687.2632719,932.7625576,2962.8794148,30.3712886,48.7666783,0.1148766,146.4352519),(22906,'red-deer-femur.tif',246,7,44,379.415327,53.6705871,63.8564228,1.8,53.0037848,64.7284772,-0.3340936,29.1756113,25.1260024,27254.7766015,66160.6021608,6.7995602,2633.1527483,934.1629997,2775.6964441,30.3542457,47.557684,0.1221952,142.2443977),(22907,'red-deer-femur.tif',246,7,45,374.0255162,53.8081487,63.9020799,1.8,53.1846164,64.8740048,-0.3337206,29.0290132,25.2841535,27527.0985358,62455.4832689,6.6885724,2470.143339,948.2616012,2643.1186068,30.4437834,46.1196114,0.1260254,136.317635),(22908,'red-deer-femur.tif',246,7,46,363.9833129,53.9937301,63.9738433,1.8,53.3484076,65.0752342,-0.3318594,23.2319483,24.167867,27702.6737053,58656.0034267,6.4392674,2427.0244231,1192.4386789,3111.322369,30.5208436,44.7881317,0.1111677,132.3693327),(22909,'red-deer-femur.tif',246,7,47,359.9287262,54.2681319,63.9651768,1.8,53.6961022,65.1553131,-0.3258383,23.2460263,23.7297234,28142.7715854,55829.1713434,6.1467436,2352.7105827,1210.6487018,2709.7981603,30.7332112,43.656059,0.1331783,129.6632165),(22910,'red-deer-femur.tif',246,7,48,352.4043311,54.5163534,63.9210869,1.8,54.0451435,65.1338649,-0.3223291,23.5251065,23.0289316,28217.1057954,52918.0356463,5.8938115,2297.8936491,1199.4464629,2963.0998033,31.0100459,42.5759642,0.1267675,126.61408),(22911,'red-deer-femur.tif',246,7,49,347.0624866,54.8590246,63.8377862,1.8,54.5609042,65.0552209,-0.3082864,24.8983178,22.5158661,28640.3288793,50165.8526934,5.3255306,2228.0223364,1150.2917235,3058.9261363,31.4256195,41.5493216,0.1299174,133.419201),(22912,'red-deer-femur.tif',246,7,50,341.3071033,55.1798372,63.8932882,1.8,54.9980844,65.1676003,-0.2815518,27.073184,23.0376329,29146.3879479,47660.195334,4.3914145,2068.7974127,1076.5777668,2590.1352064,31.8731059,40.5368601,0.1693468,122.6155437),(22913,'red-deer-femur.tif',246,7,51,340.1771354,55.60495,63.911771,1.8,55.6177445,65.2704487,-0.2450457,26.3912029,21.7235871,29818.013284,45472.1908706,3.3368597,2093.2174142,1129.8466918,2852.265737,32.5578271,39.7310775,0.1411601,121.4738259),(22914,'red-deer-femur.tif',246,7,52,341.2088848,56.0738923,63.9490627,1.8,56.1860923,65.4764594,-0.1893128,25.7011976,30.0956159,30590.7459863,43755.8756483,2.0138852,1453.8953392,1190.2459377,2031.6555325,32.710898,38.8694844,0.1712782,134.1468567),(22915,'red-deer-femur.tif',246,7,53,339.4228711,56.5064316,64.0317703,1.8,56.1638692,65.5760976,-0.1101076,25.891225,42.5433863,31144.0225162,41916.6348461,0.6830756,985.2679454,1202.8794516,1633.811382,32.917929,37.9635246,0.192048,126.1289762),(22916,'red-deer-femur.tif',246,7,54,338.7388611,56.7893639,63.9275747,1.8,56.4731095,65.3328093,0.0038442,26.8403886,41.1620776,32008.1114828,40669.1901019,0.0008342,988.0256892,1192.5353224,1491.4313018,32.9024436,37.2707554,2.7301364,118.3744554),(22917,'red-deer-femur.tif',246,7,55,334.5007608,56.9247622,63.8277656,1.8,56.6711527,65.3128711,0.1660742,31.6888961,39.3897986,32372.8177582,39177.7160179,1.5235393,994.6157995,1021.5823747,1468.919608,32.8708119,37.26558,2.2142974,117.3956289),(22918,'red-deer-femur.tif',246,7,56,331.9190886,57.0409969,63.6499501,1.8,56.7513173,65.2132219,0.375149,37.5361915,39.9947177,32553.5969021,38286.3265467,7.427087,957.2845804,867.2589196,1571.9093436,32.73054,37.8096652,2.1967746,116.6593544),(22919,'red-deer-femur.tif',246,7,57,328.3757916,57.2098933,63.31816,1.8,56.8877032,64.9250746,0.568243,44.33468,27.8286631,32037.0577072,37573.3514405,15.8500178,1350.1673183,722.6184496,1420.1964108,32.53791,38.1296924,2.1708465,116.3457607),(22920,'red-deer-femur.tif',246,7,58,320.4460534,57.3340822,63.0230142,1.8,57.0292723,64.7294216,0.7026645,42.6987487,39.0159779,30840.9543863,36791.2529851,22.3053615,942.9791329,722.2917605,1549.3575768,32.4001162,38.2514635,2.1362802,116.1032088),(22921,'red-deer-femur.tif',246,7,59,314.9194614,57.5167886,62.7083478,1.8,57.3503488,64.5356736,0.8294689,42.599494,27.8336505,29793.127925,36093.8608158,28.5534159,1296.7706396,699.3775067,1483.2775106,32.2156088,38.3012945,2.1483046,115.9611252),(22922,'red-deer-femur.tif',246,7,60,310.2173233,57.6518067,62.2557258,1.8,57.5587174,64.1557017,0.9154919,45.7620227,34.4451054,28805.8772443,35389.6736514,32.5020294,1027.4224244,629.4712409,1375.0281724,32.9152777,38.3828997,1.9232539,179.4942188),(22923,'red-deer-femur.tif',246,7,61,304.9645664,57.7537918,61.7488611,1.8,57.6531369,63.7375439,0.9730318,51.1171247,30.243134,27882.4664054,34126.5886852,34.7283773,1128.4078115,545.4623389,1212.8191032,32.4060177,37.8005951,1.928926,152.282354),(22924,'red-deer-femur.tif',246,7,62,296.25899,57.9449244,61.1726347,1.8,57.8684982,63.1208256,0.9927745,44.2965046,30.5115112,26553.4108716,32693.2214895,34.6367155,1071.5044967,599.4470924,1331.9506782,32.0253499,37.9386779,0.7506631,145.1342129),(22925,'red-deer-femur.tif',246,7,63,297.1503084,57.9548834,60.6466568,1.8,57.9441,62.4937435,1.0008235,43.1493947,33.1968902,25806.0350987,31572.0143733,35.1044434,951.0533733,598.0625059,1329.1239556,31.3539378,36.9165939,1.9742154,164.6504098),(22926,'red-deer-femur.tif',246,7,64,296.6882318,57.9979231,60.1566304,1.8,57.9676652,61.8246304,0.9949328,43.5137321,33.1757023,25100.7354289,30503.5365636,34.7844816,919.4541315,576.8463022,1276.1848813,30.9678709,36.0739265,1.8979915,162.692757),(22927,'red-deer-femur.tif',246,7,65,293.4865177,58.054397,59.5906546,1.8,57.918311,60.9529356,0.9838476,42.6401725,33.5085573,24114.2843031,29153.2634226,33.9113903,870.0244291,565.5297085,1248.4951838,30.5108606,35.8791353,1.8815984,139.7894522),(22928,'red-deer-femur.tif',246,7,66,290.3557074,58.0436054,59.1467863,1.8,57.9290435,60.4059702,0.9976425,42.5400952,32.0125605,23262.9763182,28069.2178616,34.1616776,876.8188919,546.8482429,1206.6526569,30.0904997,34.8452301,1.922613,131.6832923),(22929,'red-deer-femur.tif',246,7,67,287.9044391,57.9796191,58.6209564,1.8,57.7816336,59.8685361,1.0484081,49.8829457,25.7821289,22626.7170558,26922.4044934,36.0383259,1044.2273626,453.5962489,992.6897006,29.605433,34.6750659,1.7752175,139.7305992),(22930,'red-deer-femur.tif',246,7,68,286.9127721,57.9137016,58.1572258,1.8,57.6789018,59.3276211,1.0961853,50.3439789,32.2323155,21983.777188,25940.7462646,37.8322139,804.8055469,436.6714288,934.5174508,29.191371,37.6460698,1.9012423,207.8478014),(22931,'red-deer-femur.tif',246,7,69,287.839367,57.7862793,57.6969033,1.8,57.500846,58.7791758,1.1671722,52.1722688,28.9025616,21477.662206,25158.9763464,40.5730885,870.4756578,411.6681659,869.454216,28.777309,34.5499943,2.063926,143.5160102),(22932,'red-deer-femur.tif',246,7,70,286.3305655,57.6525062,57.2192111,1.8,57.2858804,58.2818257,1.2498907,50.9883037,31.5746963,20978.4156013,24282.0114668,42.9737494,769.0338889,411.4358407,840.9899728,28.363247,32.7665394,1.4440902,138.4381791),(22933,'red-deer-femur.tif',246,7,71,284.3299959,57.5940458,56.8119346,1.8,57.13689,57.8875529,1.3249398,49.4455527,31.4030767,20457.4430573,23578.9266563,44.5811751,750.8476607,413.7367658,815.7878284,27.949185,32.6164183,1.7108981,139.6007045),(22934,'red-deer-femur.tif',246,7,72,280.7217827,57.4838922,56.4240856,1.8,56.8864768,57.3548889,1.4407151,46.5539568,30.6561501,19859.813991,22762.8844809,45.9997316,742.5226076,426.5977668,787.3881837,27.742154,34.8415397,1.8662372,192.5605039),(22935,'red-deer-femur.tif',246,7,73,277.5286799,57.4721422,56.0280707,1.8,56.7260123,56.9891779,1.5557742,43.273084,33.6377164,19199.5779656,22120.1403903,46.2443426,657.5993483,443.6840688,759.5249477,27.4387702,35.9024228,1.8213693,185.2580903),(22936,'red-deer-femur.tif',246,7,74,276.6674947,57.4640066,55.67551,1.8,56.6985799,56.6266568,-1.5214226,41.5903827,36.4005854,18620.424327,21665.0986982,45.9989323,595.1854466,447.709858,737.1771437,27.121061,32.8527604,0.9600704,137.3588844),(22937,'red-deer-femur.tif',246,7,75,276.1890008,57.4350296,55.290081,1.8,56.6433029,56.1089225,-1.4778855,40.7841981,38.4296919,18185.5059987,21153.8049586,45.6352793,550.4547109,445.8958819,716.5813873,26.8372043,34.2171577,1.9423142,176.5957848),(22938,'red-deer-femur.tif',246,7,76,276.1748823,57.4228845,54.9170908,1.8,56.7319644,55.6891892,-1.4834841,40.2985652,38.3206062,17724.4644266,20757.6918097,45.6791383,541.6848493,439.8286718,698.5567593,0.207031,0.4629354,2.0344439,0.9996341),(22939,'red-deer-femur.tif',246,7,77,274.9313436,57.4200856,54.5025665,1.8,56.8880092,55.014974,-1.5135648,41.0897253,37.4805973,17066.9243554,20178.437212,45.6719676,538.3702139,415.3574699,674.1524346,26.292937,33.7511331,1.7934573,172.9402686),(22940,'red-deer-femur.tif',246,7,78,274.3415518,57.3802261,54.1434507,1.8,56.7527408,54.7142414,-1.4635476,39.5698282,39.2703493,16743.3622437,19938.6823424,45.1996793,507.7286737,423.1345701,659.3340362,0.207031,0.292786,2.3561945,0.5855721),(22941,'red-deer-femur.tif',246,7,79,271.9171435,57.3703197,53.7906018,1.8,56.7608736,54.4808752,-1.4337112,38.3329705,40.8183418,16331.3669322,19567.549195,44.4731857,479.3812868,426.039692,642.7984082,25.878875,29.0581856,0.9986027,90.8698045),(22942,'red-deer-femur.tif',246,7,80,273.2316381,57.3731729,53.4408018,1.8,56.8745979,54.0669129,-1.4378434,36.6393183,40.0054174,16051.7667277,19229.0135311,44.7383763,480.6602398,438.1022217,705.044531,25.7954546,31.1029197,1.9599551,136.5688057),(22943,'red-deer-femur.tif',246,7,81,271.292192,57.4011543,52.995232,1.8,56.7601016,53.7958707,-1.3809323,35.0404543,42.8224087,15782.124862,19100.128015,43.6049184,446.0311454,450.3972668,661.0997895,0.414062,1.1148961,1.9513027,2.4133302),(22944,'red-deer-femur.tif',246,7,82,269.4772401,57.3772884,52.6134009,1.8,56.6297257,53.362472,-1.3358054,33.2572115,42.4539386,15509.337117,18839.0048243,42.4780679,443.7516385,466.3450844,678.5417074,0.414062,1.7072214,1.815775,3.6555162),(22945,'red-deer-femur.tif',246,7,83,268.3190094,57.3645805,52.2442502,1.8,56.6141924,53.0052572,-1.322917,32.2583054,45.3584193,15250.0834992,18571.338432,42.0278815,409.4353089,472.7490579,631.5284233,25.5522299,30.0708519,1.929567,133.3481591),(22946,'red-deer-femur.tif',246,7,84,267.5043228,57.377489,51.8300993,1.8,56.7808911,52.4660624,-1.3376706,31.7375573,42.0088399,14977.6579098,18193.768046,42.2045953,433.0937983,471.9222021,664.5310723,25.257782,28.5507684,1.0129657,88.3351983),(22947,'red-deer-femur.tif',246,7,85,266.9686667,57.383314,51.4386637,1.8,56.8818679,51.9918173,-1.3339662,28.6008346,45.7799683,14768.7341184,17913.3994549,42.0454443,391.2934001,516.3742359,605.451758,25.050751,30.5291762,1.3241729,133.9251124),(22948,'red-deer-femur.tif',246,7,86,265.4559817,57.3799161,51.0858031,1.8,56.9601497,51.6432163,-1.3321535,30.6985009,42.3892799,14584.9896535,17622.1420399,41.7704965,415.7216653,475.1042961,643.9943995,24.84372,28.4266455,0.9666335,87.7496262),(22949,'red-deer-femur.tif',246,7,87,264.8708267,57.3759357,50.7009929,1.8,56.9535172,51.15444,-1.3260727,29.2057464,42.3533133,14420.0593693,17402.954525,41.5536598,410.8994829,493.7404842,645.6701042,25.050751,28.3753338,0.956484,87.6283503),(22950,'red-deer-femur.tif',246,7,88,263.9313212,57.3671491,50.3238668,1.8,56.9252155,50.7616896,-1.3059231,16.8886637,28.8389466,14260.7574183,17271.0342931,40.9739116,598.8788198,844.3982112,948.7626612,24.84372,28.3753338,0.956484,87.1640541),(22951,'red-deer-femur.tif',246,7,89,262.5039052,57.3734823,49.9107543,1.8,56.8084402,50.4620609,-1.2712245,31.6418599,44.66636,14174.9808368,17285.4738833,39.9403809,386.9908785,447.9819102,622.243568,24.636689,28.4266455,0.9666335,87.0427782),(22952,'red-deer-femur.tif',246,7,90,260.6851607,57.3515452,49.5667166,1.8,56.8202175,50.1896301,-1.2476833,30.9694331,45.3071065,13992.4751333,17129.354971,39.0671928,378.0721455,451.8156693,577.3593524,24.636689,28.4808748,0.9767454,87.0930123),(22953,'red-deer-femur.tif',246,7,91,259.5330346,57.3379605,49.2167098,1.8,56.7871414,49.865405,-1.2460218,30.1539337,45.5919318,13888.5146933,16978.5488979,38.8511569,372.402489,460.5871598,585.0167602,24.636689,28.3655137,0.9827937,86.8002263),(22954,'red-deer-femur.tif',246,7,92,259.7688786,57.3334092,48.8836557,1.8,56.6411733,49.6286534,-1.1978658,27.2580051,53.3417645,13823.4449627,17094.8870372,37.5475104,320.4784695,507.1334052,526.7956606,24.636689,28.4243837,0.9928944,86.7499921),(22955,'red-deer-femur.tif',246,7,93,260.040233,57.3435446,48.5393665,1.8,56.6151057,49.3088975,-1.1617672,25.4701996,54.4276276,13829.6407113,17217.791597,36.4845025,316.3428643,542.973394,526.7350444,24.636689,28.4266455,0.9666335,86.7499921),(22956,'red-deer-femur.tif',246,7,94,259.3905255,57.3152818,48.2286404,1.8,56.4934831,49.1752923,-1.1491168,25.255969,54.9761484,13789.2546246,17323.9970878,35.9895236,315.1184209,545.9800266,527.4817979,24.636689,28.3095495,0.9726521,86.6287162),(22957,'red-deer-femur.tif',246,7,95,260.4877235,57.312578,47.8969558,1.8,56.579162,48.7724711,-1.1508207,32.8988497,54.98818,13795.0152237,17099.1088632,36.1969215,310.9597167,419.3160357,524.3365056,24.636689,28.2565083,0.9624713,86.8504604),(22958,'red-deer-femur.tif',246,7,96,260.3648269,57.3265689,47.5643101,1.8,56.6701773,48.3284752,-1.1530445,22.5371987,55.3558761,13801.7767769,16816.5406417,36.251556,303.7896212,612.3998344,512.3434172,24.636689,28.2565083,0.9624713,86.4572061),(22959,'red-deer-femur.tif',246,7,97,258.8113971,57.343528,47.2035676,1.8,56.4980795,48.1803364,-1.0984601,20.3033481,56.3600502,13794.1722185,17116.0926745,34.2064184,303.6919345,679.4038169,521.3743423,24.6200005,28.2064067,0.9522533,86.3359301),(22960,'red-deer-femur.tif',246,7,98,257.3479902,57.3613131,46.876616,1.8,56.7388599,47.6378917,-1.1367986,22.2673612,56.2521795,13661.8163934,16600.4794135,35.3072299,295.1081995,613.5354905,502.1190066,24.636689,28.3753338,0.956484,86.5784821),(22961,'red-deer-femur.tif',246,7,99,256.8392592,57.3403503,46.5836375,1.8,56.6094372,47.4811369,-1.1084424,20.1594289,57.281124,13638.8105225,16868.4382498,34.2894951,294.4851127,676.5474639,503.3640657,24.6148343,28.4485003,0.9403949,86.8002263),(22962,'red-deer-femur.tif',246,7,100,256.6518101,57.3387285,46.2627377,1.8,56.7208489,47.0433608,-1.1365749,21.6183971,56.9922433,13634.5254197,16646.4741063,35.2044141,292.083153,630.690859,497.8002659,24.5751482,28.3753338,0.956484,86.285696),(22963,'red-deer-femur.tif',246,7,101,257.1962982,57.332732,45.9529676,1.8,56.7867002,46.6425949,-1.139967,23.6492213,54.6201235,13617.6192177,16479.2105593,35.3897744,301.7058457,575.816813,525.8540532,24.5952943,28.3753338,0.956484,86.4572061),(22964,'red-deer-femur.tif',246,7,102,257.616617,57.3212581,45.6695796,1.8,56.8849056,46.3030955,-1.1452421,26.4652482,53.681433,13618.1327015,16329.6199385,35.618717,304.1949333,514.5665978,542.395913,24.5754839,28.4266455,0.9666335,86.4572061),(22965,'red-deer-femur.tif',246,7,103,257.3133111,57.2952052,45.3766468,1.8,56.8387654,45.9912611,-1.122201,22.4358109,53.2227974,13601.3521989,16348.3562084,34.8189535,307.1683,606.2340351,520.0949662,24.577158,28.495168,0.9505468,86.5784821),(22966,'red-deer-femur.tif',246,7,104,257.6415028,57.2727047,45.1227064,1.8,56.7906448,45.8087042,-1.122892,42.0873058,55.0635283,13656.9098727,16343.4746833,34.8865414,296.8112502,324.4900004,531.7734631,24.429658,28.5447628,0.9606645,85.9426758),(22967,'red-deer-femur.tif',246,7,105,256.4398518,57.3393224,44.7729891,1.8,56.9696615,45.3488777,-1.1249764,41.7969022,52.3138422,13679.7013981,16160.3808686,34.7932646,308.9121388,327.2898388,564.165204,24.577158,28.5447628,0.9606645,86.406972),(22968,'red-deer-femur.tif',246,7,106,256.371078,57.3103933,44.5269669,1.8,56.8844001,45.1185211,-1.1167998,34.9282846,52.1303229,13632.9894879,16266.4433686,34.5103021,312.0341954,390.3137425,569.3956619,24.6204393,28.5972693,0.9707461,86.699758),(22969,'red-deer-femur.tif',246,7,107,255.8757381,57.2896389,44.2676097,1.8,56.8303888,44.8910665,-1.1047094,35.3681432,55.3071015,13604.0830552,16328.2881145,34.033391,295.2295034,384.6422744,531.9654815,24.5987986,28.7109528,0.9907936,86.8712681),(22970,'red-deer-femur.tif',246,7,108,257.6093435,57.2781446,44.0168514,1.8,56.9750803,44.5382648,-1.1006405,33.0531882,51.5461767,13651.5182197,16329.9277647,34.123284,316.8019205,413.0166848,579.9695373,24.5812549,28.6638887,0.954745,86.8712681),(22971,'red-deer-femur.tif',246,7,109,261.1397689,57.2414946,43.7790193,1.8,57.1270433,44.052889,-1.0727636,35.9556102,15.5641092,13757.9787054,16497.5423618,33.5914713,1059.9734419,382.637887,813.2036735,0.9067885,6.654042,1.4773195,16.3077392),(22972,'red-deer-femur.tif',246,7,110,261.309216,57.2202167,43.5738327,1.8,57.1255095,43.8309066,-1.0700925,14.3582293,15.8498492,13771.5689807,16574.2601153,33.5154604,1045.7045924,959.1411818,1905.3096032,0.828124,3.5437999,1.4536876,8.3106665),(22973,'red-deer-femur.tif',246,7,111,262.5907589,57.1898076,43.3729868,1.8,57.0886678,43.7436582,-1.0754706,39.1182643,48.2020602,13846.4616843,16746.3532381,33.8773832,347.4198647,353.9641124,630.5677842,0.621093,4.8020482,1.4410938,10.9665486),(22974,'red-deer-femur.tif',246,7,112,263.6181961,57.1672223,43.1479523,1.8,57.0772314,43.5255966,-1.068277,41.3153381,49.8252015,13897.6903528,16908.2353865,33.7443515,339.3510685,336.3808935,616.5558775,0.292786,0.5855721,0.7853982,1.1711442),(22975,'red-deer-femur.tif',246,7,113,262.3066239,57.2193126,42.8495841,1.8,57.1028778,43.2045561,-1.0581163,46.3699636,18.9091395,13847.6620121,16857.1853101,33.1990804,891.4834698,298.6343086,613.6186475,1.449217,12.0095826,1.588036,28.6377498),(22976,'red-deer-femur.tif',246,7,114,261.5146541,57.2074841,42.6215653,1.8,57.1028651,42.9286256,-1.0535853,13.904045,16.5645656,13809.8113229,16915.8414504,32.929552,1021.2064627,993.2225701,1843.4568714,0.207031,0.292786,2.3561945,0.5855721),(22977,'red-deer-femur.tif',246,7,115,260.6759129,57.1870399,42.3926544,1.8,57.054917,42.7607756,-1.0502517,13.9044676,54.6103517,13791.4112107,17005.8324932,32.6991979,311.4030944,991.8690603,563.5979877,0.292786,0.5855721,0.7853982,1.1711442),(22978,'red-deer-femur.tif',246,7,116,260.3643593,57.164848,42.1732695,1.8,56.9884975,42.5560079,-1.0453206,14.1740337,55.213203,13780.8707509,17103.5341627,32.4749338,309.7725403,972.2617438,558.9085933,0.6825713,4.6708323,1.3473197,10.1384246),(22979,'red-deer-femur.tif',246,7,117,260.3934534,57.1474305,41.9709104,1.8,57.0053051,42.3127,-1.0409535,14.3148571,55.1049697,13756.2272442,17182.1852696,32.3136623,311.8082698,960.9755172,561.1449293,0.6957976,5.4814365,1.380808,11.7946726),(22980,'red-deer-femur.tif',246,7,118,260.8441391,57.1280292,41.7532773,1.8,56.9955661,42.0526457,-1.0417849,14.6371107,55.1468226,13784.3908894,17212.8949834,32.4010996,312.1284994,941.7426163,561.9785566,1.449217,9.7392628,1.5282688,22.0543731),(22981,'red-deer-femur.tif',246,7,119,260.2025884,57.099835,41.5692532,1.8,57.0055846,41.9154179,-1.0472971,14.5064757,16.640405,13773.9709127,17315.0233002,32.5290611,1040.540977,949.5049819,1857.1840032,0.414062,1.1148961,1.1902899,2.4133302),(22982,'red-deer-femur.tif',246,7,120,261.019548,57.0636524,41.431732,1.8,56.9115661,41.8643223,-1.0554324,32.7109908,58.2319816,13792.0542872,17601.1830775,32.9362027,302.2597305,421.6336456,535.6116764,1.024671,12.0363201,1.5019398,25.730697),(22983,'red-deer-femur.tif',246,7,121,259.5973403,57.0845322,41.2068144,1.8,56.8117448,41.7143784,-1.0479121,24.1912362,62.7246154,13729.0911422,17851.7252709,32.4764314,284.6047786,567.523339,492.2370492,1.3511705,8.9119571,1.6172745,20.1053391),(22984,'red-deer-femur.tif',246,7,122,258.0233109,57.0557328,41.0153691,1.8,56.8503184,41.4663171,-1.0745149,24.0573422,62.3163136,13652.6599028,17761.2802399,33.2537317,285.0181473,567.5049141,489.871721,1.5150814,11.808029,1.535723,26.9520753),(22985,'red-deer-femur.tif',246,7,123,257.4239985,57.0166724,40.8453826,1.8,56.848469,41.2939503,-1.0811703,27.7507309,55.9197347,13610.0922001,17796.2394932,33.4145697,318.246136,490.440856,560.6141069,1.7690523,12.221845,1.6046817,30.1224877),(22986,'red-deer-femur.tif',246,7,124,257.4179589,56.9728574,40.6660515,1.8,56.819439,41.0151859,-1.0819913,22.3732217,38.6682557,13587.5402975,17891.1440997,33.4430074,462.6829885,607.3126392,711.3141941,1.201284,2.9278605,1.4288993,7.6540526),(22987,'red-deer-femur.tif',246,7,125,258.2003822,56.9247562,40.5102609,1.8,56.7923085,40.9387922,-1.0943046,20.4488716,41.2180644,13610.4333315,18185.2421107,33.9803264,441.1959262,665.5835868,708.2476703,1.3767325,10.1529657,1.61159,24.7604893),(22988,'red-deer-femur.tif',246,7,126,258.9011992,56.8771048,40.381638,1.8,56.7435297,40.7537566,-1.0998181,18.3075536,55.8179009,13605.6230547,18405.7220648,34.2657222,329.7458661,743.1699162,572.7350787,1.3394709,9.750259,1.507053,23.7608552),(22989,'red-deer-femur.tif',246,7,127,259.1647475,56.82979,40.2521958,1.8,56.7191035,40.537764,-1.1070683,17.9259628,56.3531841,13585.2268902,18580.7391035,34.5525215,329.7194186,757.8520052,569.2813609,0.6428024,2.7621381,1.3439975,6.0688464),(22990,'red-deer-femur.tif',246,7,128,258.5818915,56.7764608,40.1299247,1.8,56.6642928,40.440837,-1.1201832,19.5358094,40.4936999,13564.197412,18669.3555679,34.9225392,461.0434617,694.3248234,716.9409424,0.207031,0.4629354,2.0344439,0.9996341),(22991,'red-deer-femur.tif',246,7,129,256.3764942,56.7863978,39.9588227,1.8,56.672645,40.2872773,-1.1261215,17.9922562,62.0060655,13448.142165,18738.9242966,34.8227048,302.211149,747.4405679,498.5318132,0.621093,2.5186408,1.4056476,5.8262945),(22992,'red-deer-femur.tif',246,7,130,254.23726,56.7430935,39.8995775,1.8,56.6670855,40.2149869,-1.1332967,13.7383884,44.3617565,13333.2074211,18880.6102374,34.7668913,425.6055602,970.5073872,701.6925382,0.6048555,4.0198149,1.3633001,8.7247285),(22993,'red-deer-femur.tif',246,7,131,253.3091844,56.7283369,39.8376478,1.8,56.6353699,40.2183558,-1.1397412,13.8423696,52.2653552,13304.9639634,18995.7644224,34.8476776,363.4484899,961.1767587,618.012823,1.2244637,15.3886854,1.4764824,33.5562596),(22994,'red-deer-femur.tif',246,7,132,252.5566605,56.7013782,39.7646582,1.8,56.6172613,40.196035,-1.1515146,39.2098927,60.8518352,13263.9493133,19281.1954859,35.116568,316.8547903,338.2806841,510.3050146,1.4586666,10.8013849,1.3583643,25.2750196),(22995,'red-deer-femur.tif',246,7,133,252.6753748,56.6739593,39.7033496,1.8,56.662644,40.1868906,-1.1698847,40.5082259,51.6719007,13334.9581062,19562.6484189,35.6987681,378.5935517,329.1913629,636.6524889,0.8280297,9.8377855,1.422947,21.6905452),(22996,'red-deer-femur.tif',246,7,134,252.1994136,56.6410811,39.6217613,1.8,56.6296693,39.9733037,-1.1739225,41.2938085,32.6292092,13290.5297516,19589.0766089,35.7530134,600.3540111,321.8528449,646.0482767,0.8002441,10.5768327,1.5120405,22.832263),(22997,'red-deer-femur.tif',246,7,135,251.5862945,56.6193135,39.5525267,1.8,56.5865117,39.9231451,-1.1828076,34.5583542,45.3583058,13275.0773305,19758.8171851,35.9293909,435.6162965,384.1351139,692.6867747,24.5251011,30.3778753,0.969562,89.8995969),(22998,'red-deer-femur.tif',246,7,136,251.5811771,56.5882991,39.4866923,1.8,56.5252676,39.787948,-1.1838718,37.4173673,55.1403692,13234.8231167,19954.3133735,35.9598778,361.8821139,353.7080253,596.6401228,0.5295756,1.5767011,1.1659045,3.4129643),(22999,'red-deer-femur.tif',246,7,137,250.2439268,56.63187,39.3963781,1.8,56.4788152,39.7927566,-1.1943767,37.3382765,55.8093869,13202.0233113,20353.5481364,36.071631,364.6975763,353.5788085,593.5759683,0.6911751,1.7688736,1.2120257,3.9985364),(23000,'red-deer-femur.tif',246,7,138,248.9200935,56.6038529,39.3226991,1.8,56.4810205,39.6608051,-1.2051554,24.4055969,59.4856231,13200.9985669,20363.5075439,36.1830032,342.3265404,540.900459,539.7947713,0.897244,11.4542602,1.4621351,24.8315312),(23001,'red-deer-femur.tif',246,7,139,248.9277697,56.5704185,39.2927043,1.8,56.4999095,39.5039083,-1.2137058,13.7042776,55.167889,13190.7951034,20438.4999579,36.4187531,370.4781951,962.5312243,600.2876007,0.7425129,9.9912569,1.467004,21.590077),(23002,'red-deer-femur.tif',246,7,140,250.2297564,56.5243293,39.2773045,1.8,56.4264399,39.5704312,-1.219243,41.4406883,56.0902568,13315.4426948,20792.5735431,36.7595248,370.6984908,321.3132609,593.9896241,0.696131,6.8820293,1.4501727,15.0361268),(23003,'red-deer-femur.tif',246,7,141,249.3781437,56.505397,39.2449332,1.8,56.3847025,39.5795203,-1.2214909,42.8124112,57.2206089,13375.7391535,20983.1053108,36.6946714,366.7053833,312.4266717,580.1392339,0.499796,3.3702205,1.3854484,7.1395223),(23004,'red-deer-femur.tif',246,7,142,251.0207521,56.4760912,39.2175822,1.8,56.373195,39.5630803,-1.225409,43.6314116,59.8787892,13560.1411342,21387.5150101,37.041306,357.1801519,310.788504,548.5607865,0.5948747,5.855721,1.4288993,12.6227966),(23005,'red-deer-femur.tif',246,7,143,252.579702,56.4514179,39.1987781,1.8,56.3741298,39.4509365,-1.222595,44.4015069,60.1609464,13683.0579132,21687.9559065,37.1956168,360.498915,308.1665208,551.7640304,0.7129474,3.7779612,1.4056476,8.6536867),(23006,'red-deer-femur.tif',246,7,144,254.0184049,56.4520746,39.1490709,1.8,56.3783533,39.4498908,-1.232982,45.5235656,43.0634018,13856.2380834,21997.6536821,37.6860431,510.8201568,304.3750618,657.1806159,0.5588621,3.4144427,1.3258177,7.3110324),(23007,'red-deer-femur.tif',246,7,145,254.2361041,56.4953748,39.0573245,1.8,56.4406769,39.2862195,-1.2276957,49.3483374,42.8675761,13983.8122644,22182.6904065,37.5773348,517.4701354,283.3694709,641.0981269,0.3934081,0.9258708,1.1071487,1.9992682),(23008,'red-deer-femur.tif',246,7,146,255.5283494,56.4840822,39.0602777,1.8,56.3894619,39.2011515,-1.2166778,13.768829,57.252145,14051.0187076,22501.498762,37.4670529,393.0245544,1020.4948217,623.6013622,0.414062,1.5072084,1.2924967,3.2414542),(23009,'red-deer-femur.tif',246,7,147,256.0359115,56.4859874,39.056311,1.8,56.3718697,39.2165083,-1.2174547,14.0543835,16.8549965,14165.496006,22813.1815388,37.5630215,1353.4966617,1007.9058956,2141.3910008,25.1085419,31.5951284,1.2987972,93.5637319),(23010,'red-deer-femur.tif',246,7,148,257.5187751,56.489528,39.0247031,1.8,56.3277379,39.1609164,-1.2211674,43.2100874,40.5796462,14391.0338551,23122.8204765,37.8835892,569.8132596,333.0480153,858.18213,0.414062,1.7072214,1.3258177,3.8270263),(23011,'red-deer-femur.tif',246,7,149,260.259179,56.4633174,39.0118602,1.8,56.2858299,39.1899512,-1.2210253,17.6299836,43.9390318,14694.9977886,23485.3020534,38.2827614,534.497486,833.5230548,806.4442283,0.414062,0.6546895,1.8925469,1.5852062),(23012,'red-deer-femur.tif',246,7,150,262.490657,56.4480633,38.9877646,1.8,56.2550841,39.1632857,-1.2234059,18.5748954,43.1861165,14994.0235202,23780.7137503,38.6778679,550.6564531,807.2198072,824.7951612,25.3701044,31.9995193,1.3556361,95.4209165),(23013,'red-deer-femur.tif',246,7,151,261.7939964,56.4048741,38.98969,1.8,56.1801603,39.1471636,-1.220469,14.1488338,17.3868109,15209.0951701,24024.2688454,38.4928859,1381.7524644,1074.9363096,2209.0015632,0.6604273,6.5795481,1.1493771,14.4089393),(23014,'red-deer-femur.tif',246,7,152,266.3436892,56.3248624,38.964822,1.8,56.0019973,39.1295746,-1.2197798,21.239485,60.6456458,15609.2052232,24547.3340482,39.1421102,404.7666363,734.9144853,624.9327812,25.6657848,32.3193892,1.3708882,96.2282328),(23015,'red-deer-femur.tif',246,7,153,268.0429142,56.3367359,38.934034,1.8,56.0482957,39.0378319,-1.223707,22.3273427,60.6817698,15884.2788872,24896.3533057,39.5045974,410.2773103,711.4272004,630.7030211,0.5024732,1.1148961,1.1902899,2.5848403),(23016,'red-deer-femur.tif',246,7,154,272.2630255,56.2640852,38.9457981,1.8,55.9154859,39.1121216,-1.2244611,14.5386209,53.9528464,16325.6154947,25574.3447912,40.1484359,474.012893,1122.9136279,774.6755467,0.7309778,1.780948,0.9505468,3.8772604),(23017,'red-deer-femur.tif',246,7,155,276.3029613,56.2139472,38.9708238,1.8,55.9063476,39.1818195,-1.2385096,40.7004199,59.8576934,16942.1667302,26144.0687872,41.1502578,436.7704013,416.2651584,678.1901209,0.4634607,1.2071878,1.0303768,2.5848403),(23018,'red-deer-femur.tif',246,7,156,281.4123648,56.1113359,39.0183563,1.8,55.7837444,39.1808656,-1.2383558,41.2460651,59.700988,17543.7613641,26752.9192115,41.9067602,448.115184,425.34388,704.6254512,26.7589097,33.2470128,1.3061827,99.7832807),(23019,'red-deer-femur.tif',246,7,157,293.991521,56.0184894,39.0995203,1.8,55.6945516,39.2437593,-1.2386176,32.6264259,59.2512565,18590.7412563,27842.2763351,43.7879096,469.9018719,569.8062463,747.4347272,27.2223704,33.5013007,1.3018343,100.9544249),(23020,'red-deer-femur.tif',246,7,158,303.7741244,55.9512279,39.2059386,1.8,55.5884013,39.3453875,-1.2538914,36.1187449,58.5790466,19664.8795268,28933.8832508,45.7123623,493.928886,544.4507994,790.117416,0.414062,0.7464609,0.9827937,1.5852062),(23021,'red-deer-femur.tif',246,7,159,310.9084639,56.0199949,39.2116614,1.8,55.6586361,39.3366962,-1.2921182,19.853832,57.491177,20665.2622505,29521.5692509,47.8969107,513.4973888,1040.8702088,825.1322094,0.5574143,3.0567761,1.076855,6.5833767),(23022,'red-deer-femur.tif',246,7,160,315.711665,56.1480196,39.1566152,1.8,55.7796886,39.2340387,-1.3600425,25.2842355,56.3515546,21563.1922663,29684.8111712,50.3158399,526.7789221,852.831492,831.0874803,0.6321887,1.9531265,1.012197,4.1700465),(23023,'red-deer-femur.tif',246,7,161,318.6122293,56.2765427,38.9612532,1.8,55.9287181,38.9555773,-1.4278218,31.2690065,54.3577157,22377.2199957,29839.1242755,52.0239179,548.9399962,715.6357855,833.9907108,0.292786,0.8783581,0.7853982,1.7567163),(23024,'red-deer-femur.tif',246,7,162,322.1687745,56.3785594,38.9268487,1.8,56.0058304,38.8888344,-1.5011472,35.4791106,51.7037015,23110.958504,30325.6450816,53.4347429,586.5275446,651.3962201,852.7157448,30.3516541,34.7473025,1.3301529,106.8309535),(23025,'red-deer-femur.tif',246,7,163,323.9973253,56.5638696,38.8029089,1.8,56.1556367,38.7811341,1.5609699,39.0315835,49.4215442,23303.8042938,31000.634501,53.9943403,627.2696458,597.0499331,871.2286159,30.3367939,34.9980379,1.3258177,126.61051),(23026,'red-deer-femur.tif',246,7,164,326.9769891,56.6457452,38.7349843,1.8,56.2751508,38.6791341,1.5204776,41.4551739,46.8341145,23422.8447018,31846.4476197,54.358298,679.9839803,565.0161966,883.8827735,30.4463873,35.3028834,1.3400415,108.0020977),(23027,'red-deer-femur.tif',246,7,165,329.8094291,56.7096028,38.6326029,1.8,56.2879761,38.6196775,1.4921999,16.9349282,49.068086,23529.0248105,32850.3025337,54.6293762,669.4840821,1389.3784817,1148.9779642,30.7061817,35.5719987,1.3893811,108.2238419),(23028,'red-deer-femur.tif',246,7,166,340.7146878,56.8290517,38.6090437,1.8,56.4420518,38.6431194,1.4741759,44.988525,49.3722527,24190.0157178,34359.4514618,56.257305,695.9263472,537.6930162,923.9646578,30.8978598,35.9262917,1.437864,108.8596482),(23029,'red-deer-femur.tif',246,7,167,349.5099623,56.9537741,38.6097306,1.8,56.6523529,38.5613246,1.4549952,32.6394117,48.9226578,24633.7898012,35677.4419819,57.4739971,729.2621367,754.7252997,1025.5058268,30.6385401,36.2848038,1.4506876,109.5664962),(23030,'red-deer-femur.tif',246,7,168,354.104816,57.0830562,38.5708396,1.8,56.808788,38.484318,1.451574,19.8959559,48.6044439,24776.2427531,36875.1546124,58.1825647,758.6786658,1245.2903924,1262.9976738,30.3256841,36.6591049,1.4177176,110.6874063),(23031,'red-deer-femur.tif',246,7,169,361.3785992,57.1917755,38.5424873,1.8,56.9605208,38.397606,1.4651301,22.1405574,48.7090796,25202.8680626,38242.7789719,59.5597793,785.1262898,1138.3122646,1293.852338,30.2493116,37.1001632,1.4139043,111.3232125),(23032,'red-deer-femur.tif',246,7,170,367.490567,57.2636967,38.604727,1.8,57.0769837,38.4141036,1.4654851,17.2458831,19.8206874,25718.1475727,39459.8790753,60.5716623,1990.8431185,1491.2630115,3166.0417413,30.3092377,37.5091953,1.4156292,112.1513365),(23033,'red-deer-femur.tif',246,7,171,372.6986177,57.2679115,38.6728921,1.8,57.0989839,38.4283841,1.4778342,17.3885543,20.1191405,26243.7314362,40620.2338613,61.5811737,2018.9845523,1509.2532157,3139.7377856,30.5714278,38.1499209,1.5165019,113.5147985),(23034,'red-deer-femur.tif',246,7,172,379.9342929,57.2528244,38.737485,1.8,57.0849519,38.5337735,1.4954135,17.0192292,20.7065667,26710.6611423,41800.8062107,62.9632293,2018.7222126,1569.4401247,3304.5492061,30.7256373,38.6017058,1.5010173,114.5352402),(23035,'red-deer-femur.tif',246,7,173,388.0478044,57.1868568,38.8127899,1.8,57.0508451,38.6198426,1.5189466,17.1158025,49.5389751,27459.6673396,43232.6514653,64.5009189,872.6997559,1604.3458821,1426.1284205,30.831229,39.1835908,1.5179356,115.2923224),(23036,'red-deer-femur.tif',246,7,174,392.162112,57.1700444,38.8421674,1.8,57.0108427,38.7110582,1.5378877,25.3006313,48.55554,28171.8721567,44720.2697998,65.2895938,921.0127173,1113.4849487,1331.3189317,31.0321103,39.840963,1.5031912,116.6349767),(23037,'red-deer-femur.tif',246,7,175,398.5668001,57.1549766,38.9608122,1.8,56.9665267,38.75113,1.5488291,18.2642734,21.7723018,29033.9801504,46419.9682828,66.3957497,2132.0652589,1589.6597424,3464.8070418,31.3837875,40.3179252,1.4833907,117.9984387),(23038,'red-deer-femur.tif',246,7,176,405.1936424,57.1346339,39.001872,1.8,56.9399944,38.8251323,1.561525,39.9798627,49.4712346,30087.1376124,48219.6272307,67.5264692,974.7002999,752.5573024,1259.9861567,31.6168992,40.955002,1.4796788,119.3619006),(23039,'red-deer-femur.tif',246,7,177,410.1471068,57.126444,39.0132878,1.8,56.9138924,38.9081347,-1.5679438,26.8565693,49.3668574,31199.3926531,50067.8072905,68.3572956,1014.1987949,1161.7043219,1490.5249027,32.0750232,41.7001756,1.5062097,121.3611688),(23040,'red-deer-femur.tif',246,7,178,418.5481953,57.0890086,39.0916173,1.8,56.8771571,38.9036229,-1.550457,18.5555889,47.720596,32233.1473418,52271.4007484,69.7291786,1095.3635354,1737.1125999,1659.338877,32.4167234,42.3807172,1.4876551,123.0174168),(23041,'red-deer-femur.tif',246,7,179,422.2627837,57.0308712,39.1659703,1.8,56.8185313,38.9548802,-1.5396435,22.1924735,48.9094424,33470.0226662,54580.0233076,70.3088523,1115.9404113,1508.1699974,1642.0806693,32.6067051,43.1121863,1.5227564,125.430747),(23042,'red-deer-femur.tif',246,7,180,431.1518477,56.9467717,39.2182172,1.8,56.7373796,39.0158401,-1.5233409,18.7673344,23.6237528,35115.2988274,57751.9123951,71.6969357,2444.6544523,1871.0861118,3911.1580065,33.3007757,43.8128666,1.3613532,127.622333),(23043,'red-deer-femur.tif',246,7,181,438.1327678,56.8363527,39.3261415,1.8,56.6569158,39.0772518,-1.5039435,19.0026245,24.2353202,36800.774398,60766.53551,72.6962561,2507.3543462,1936.6153538,4002.428075,33.4600089,44.7996141,1.3471149,130.278215),(23044,'red-deer-femur.tif',246,7,182,448.8804768,56.7599327,39.5695072,1.8,56.5763778,39.2012257,-1.4903858,18.3782511,48.4916884,38989.5090599,64403.9786805,74.3307215,1328.1446934,2121.5026888,2076.0664222,33.9100254,45.7964552,1.3148532,132.9843313),(23045,'red-deer-femur.tif',246,7,183,455.1050933,56.6100465,39.708762,1.8,56.446753,39.3393284,-1.4715508,18.7716309,50.7629581,41073.811286,67801.414023,75.1061918,1335.6474191,2188.0789905,2086.3551108,34.6678236,46.8109864,1.3022169,136.3972956),(23046,'red-deer-femur.tif',246,7,184,461.5063005,56.4610748,39.8968405,1.8,56.348927,39.4728997,-1.4569955,35.6381959,46.2925358,43243.8176757,71615.7488803,75.9258762,1547.0258342,1213.4120858,2048.4386035,35.2858789,48.0316382,1.2913125,139.98177),(23047,'red-deer-femur.tif',246,7,185,468.7004907,56.3325991,40.0790013,1.8,56.2431373,39.5978681,-1.4342389,37.3317925,45.4648564,45358.7987324,75308.56774,76.6690642,1656.4127481,1215.0179686,2142.1047967,36.0655749,49.241182,1.2676606,142.6792674),(23048,'red-deer-femur.tif',246,7,186,479.1124616,56.1717916,40.3815094,1.8,56.1064959,39.7889875,-1.4043111,40.1819464,50.6546553,48088.8970921,79974.8571498,77.6591628,1578.825415,1196.778687,2269.0771201,36.851518,50.5528837,1.2283234,146.8493139),(23049,'red-deer-femur.tif',246,7,187,488.824317,56.0311989,40.5932907,1.8,55.9351117,40.0042107,-1.3793372,44.5150508,50.7014878,51116.7383272,84633.4807369,78.5205927,1669.2504388,1148.3023689,2353.0766698,0.292786,0.5855721,0.7853982,1.1711442),(23050,'red-deer-femur.tif',246,7,188,501.7971787,55.8435841,40.7473834,1.8,55.7462652,40.0464473,-1.3408957,48.9351261,49.600957,54530.1428376,92617.183116,79.2898387,1867.24589,1114.3353895,2502.5296553,39.2633062,55.7082683,1.1820086,160.5722128),(23051,'red-deer-femur.tif',246,7,189,520.5876123,55.4114842,40.9055505,1.8,55.3948783,40.1546027,-1.2901441,22.317254,50.2219846,60816.6727541,102488.7471556,80.1080878,2040.7147975,2725.0965841,3247.6923569,1.0917372,2.7776123,1.1071487,6.9974387),(23052,'red-deer-femur.tif',246,7,190,538.0969187,55.2169283,40.9841273,1.8,55.2143724,40.3238638,-1.2611817,23.9970653,47.4397782,65927.1327566,113985.3906485,81.3569379,2402.7386932,2747.2998071,3720.5534123,42.9808112,60.1833811,1.1148409,177.6197966),(23053,'red-deer-femur.tif',246,7,191,556.0249462,55.1100477,41.2985868,1.8,55.0204909,40.6613038,-1.248616,35.8818549,52.5604522,70323.9514551,125592.2384836,83.379833,2389.4816985,1959.8750303,3634.5087129,43.8409626,62.1482786,1.1339679,184.3746834),(23054,'red-deer-femur.tif',246,7,192,575.8783663,54.8853948,41.7180413,1.8,54.7263039,41.0745229,-1.231797,31.7893678,49.4633777,75305.7269551,138219.4448626,85.3657913,2794.3794247,2368.8966553,4232.6874455,44.8017637,64.6427569,1.0842301,187.1518414),(23055,'red-deer-femur.tif',246,7,193,593.8930917,54.7329717,42.1236669,1.8,54.4260708,41.594517,-1.2159026,41.3433409,49.0967189,80221.1646135,152230.9904376,87.0301044,3100.634701,1940.3648291,4711.5001249,45.6943175,67.2490738,1.076855,192.1916273),(23056,'red-deer-femur.tif',246,7,194,613.1814239,54.5081006,42.5969631,1.8,54.1338944,42.1197014,-1.1976233,46.2573985,45.785164,85869.4503593,167065.3969317,88.6136381,3648.8980762,1856.339812,4548.7496622,46.7234989,70.1037659,1.0516502,202.2676288),(23057,'red-deer-femur.tif',246,7,195,647.2497508,53.9730943,43.5939966,1.8,53.4714394,43.2652997,-1.1553449,26.0147854,51.1823357,94216.4875371,193227.0331286,90.3026287,3775.2679773,3621.651538,5570.7153232,47.6875704,77.7825138,1.055942,218.3033897),(23058,'red-deer-femur.tif',246,7,196,702.543687,53.5499945,45.4366622,1.8,53.1197708,45.0210916,-1.1856622,28.6888674,46.4598567,110054.2785117,235202.9574765,100.5646747,5062.4985591,3836.1318725,7378.5058775,48.3210289,79.8919726,1.0410431,224.1799183),(23059,'red-deer-femur.tif',246,7,197,762.1635383,53.2730794,47.2923324,1.8,52.9036137,46.4525486,-1.2215836,26.98795,44.6343089,128371.3727635,275862.6524122,112.1558919,6180.5068598,4756.6181504,9026.8737347,48.7796455,81.2598653,1.0683996,224.3722361),(23060,'red-deer-femur.tif',246,7,198,821.4087252,53.2927328,48.7236056,1.8,52.82233,47.690563,-1.2658896,40.8486639,44.8365421,146982.7092325,310893.5269117,124.5635417,6933.9318455,3598.2256248,9098.515287,49.6460161,82.2767867,1.0463444,290.0847269),(23061,'red-deer-femur.tif',246,7,199,881.0168479,53.5341919,49.9811986,1.8,52.7216139,48.6230345,-1.3268193,45.5790765,45.8983124,167690.4418132,342242.3773677,138.2678003,7456.5351014,3679.1101224,9648.5087875,51.3265207,83.1102478,1.0692627,292.3767811),(23062,'red-deer-femur.tif',246,7,200,924.848893,53.4740908,50.6479405,1.8,52.5266594,49.3256091,-1.3547637,37.3755529,46.369599,181260.0007745,369789.076057,147.0589007,7974.8172039,4849.6941624,11272.1618663,53.7300643,83.7544672,1.0706605,294.7398772),(23063,'red-deer-femur.tif',246,7,201,964.424589,53.2557674,51.1235051,1.8,52.3669846,49.9583217,-1.368107,43.9536866,46.6867017,192987.8184392,395869.4839622,154.2237989,8479.2771809,4390.7083436,11303.0087844,55.4679814,84.3571938,1.0577384,310.8552986),(23064,'red-deer-femur.tif',246,7,202,990.4943909,53.0733021,51.4492815,1.8,52.185003,50.4781645,-1.378714,31.4163715,46.7637346,203184.0683792,414663.6432901,159.0661209,8867.2054757,6467.4581655,13175.5709766,56.8164029,84.6976953,1.0655972,300.7792971),(23065,'red-deer-femur.tif',246,7,203,1020.5007406,52.823034,51.7572681,1.8,52.0465743,51.0485296,-1.3743382,39.5698017,46.6829422,215021.3188167,431726.7509511,163.6029705,9248.0621544,5433.9751429,12971.7493498,58.2287459,84.898867,1.0613293,291.3979547),(23066,'red-deer-femur.tif',246,7,204,1048.3287091,52.6698638,52.2860657,1.8,52.0232383,51.6198632,-1.3788983,41.4339124,46.7637629,228345.9930264,445332.1584117,168.3659508,9523.0180509,5511.0893463,13294.1508142,59.9763536,84.898867,1.0613293,326.8078288),(23067,'red-deer-femur.tif',246,7,205,1064.7354921,52.6399567,52.7318738,1.8,52.029804,52.0702878,-1.3865133,32.4789303,46.6507335,241757.8440221,452293.3255783,171.4973856,9695.3100603,7443.5285153,14249.7981816,60.8143811,84.7980881,1.0634607,297.9605237),(23068,'red-deer-femur.tif',246,7,206,1081.205334,52.5584503,52.9855519,1.8,51.9852513,52.3840489,-1.3967168,32.7221148,46.292479,252801.3556214,459527.9015606,174.7950765,9926.6211599,7725.7034648,14524.3557546,61.3004521,84.5165864,1.0644116,291.6699331),(23069,'red-deer-femur.tif',246,7,207,1084.0301108,52.459345,53.1964619,1.8,51.8782374,52.5965355,-1.4031144,32.7438194,45.7358016,259796.1616778,458177.2696421,175.6391299,10017.9127458,7934.2045661,14919.5974099,61.3039858,83.9966892,1.0553188,283.9154122),(23070,'red-deer-femur.tif',246,7,208,1083.8048004,52.3739041,53.3267474,1.8,51.8253545,52.7786637,-1.4053406,32.6502501,45.0821153,264127.9008131,452503.9191372,175.7341246,10037.3266999,8089.6134127,14726.7223698,61.4904556,83.4088306,1.0427219,286.1364246),(23071,'red-deer-femur.tif',246,7,209,1075.0715457,52.3231381,53.6079266,1.8,51.7965787,52.8803706,-1.4056352,32.6169492,44.5830692,267453.6315167,437100.2279798,174.3352019,9804.1753392,8199.8359149,14504.8842639,0.207031,0.4629354,2.0344439,0.9996341),(23072,'red-deer-femur.tif',246,7,210,1062.1982923,52.1847389,53.6729848,1.8,51.7092215,52.9995701,-1.4025068,32.40406,43.705896,265862.6127431,419376.1803222,172.0663861,9595.4143242,8204.608095,15279.1948693,61.5457482,81.4497949,1.0286331,307.7351204),(23073,'red-deer-femur.tif',246,7,211,1041.4205242,51.8728015,53.6780928,1.8,51.5227167,53.0167181,-1.3695895,32.6107227,42.9369194,260499.5813522,396929.3901058,166.6375583,9244.4776192,7988.1572719,15101.633295,60.4863094,80.3635036,1.0113778,304.6651763),(23074,'red-deer-femur.tif',246,7,212,1021.7896739,51.6526012,53.6919796,1.8,51.364881,53.0980784,-1.3364539,33.5894955,42.1038768,254474.276488,373222.4094673,161.1160657,8864.3240922,7576.0076911,12869.4990226,59.794621,79.1283749,0.9922274,296.3250833),(23075,'red-deer-femur.tif',246,7,213,991.4707965,51.5681988,53.5961867,1.8,51.3447484,53.1061609,-1.3069148,33.332112,41.0125288,248013.2599227,346938.7280792,154.0031592,8459.3351864,7440.6704256,14361.575551,59.0970153,77.5813971,0.969471,283.3800742),(23076,'red-deer-femur.tif',246,7,214,956.308207,51.623252,53.4701614,1.8,51.3904114,53.0398865,-1.2831905,33.8048864,39.5910877,238250.0668589,319637.1959769,146.5603855,8073.4633515,7047.7996519,13551.5524884,58.3268952,76.0032203,0.9518135,297.9483348),(23077,'red-deer-femur.tif',246,7,215,920.2411938,51.7312139,53.3660594,1.8,51.5076511,53.0390538,-1.2575684,34.0595696,38.4880684,225748.5278633,290323.3443563,138.8115195,7543.2038226,6628.0499265,12977.7721734,57.176271,74.2445034,1.9658019,278.2814355),(23078,'red-deer-femur.tif',246,7,216,883.9116713,51.8774842,53.2114133,1.8,51.7162017,53.0219929,-1.2487346,33.9343682,38.4633622,211085.609353,260091.136701,132.5592308,6762.0489128,6220.4078197,12013.8142993,56.0804212,72.8001778,1.9771818,276.0984683),(23079,'red-deer-femur.tif',246,7,217,842.2555268,52.1466143,53.0073993,1.8,52.2288193,52.9363133,-1.2416394,45.6166192,38.3378777,193636.1559811,223211.7200206,125.7083866,5822.2242141,4244.8598676,8274.1064244,55.1061039,70.8702525,1.973003,286.4966824),(23080,'red-deer-femur.tif',246,7,218,799.6391342,52.2197119,53.0137964,1.8,52.492646,52.9691661,-1.0462649,48.2204225,40.2409142,177697.2004162,189724.1939163,99.8471913,4714.7088346,3685.1025219,7366.6234419,53.978531,69.1799593,1.9285162,295.2092221),(23081,'red-deer-femur.tif',246,7,219,736.0637461,52.3909679,53.2584751,1.8,52.631069,53.0625286,-0.1522662,34.2501367,29.9212956,150784.4184063,160989.2557868,2.8223597,5380.4239676,4402.4471979,8506.705188,52.7839721,66.7205379,1.9928014,304.0344188),(23082,'red-deer-femur.tif',246,7,220,647.9077189,52.7726051,53.8846727,1.8,53.0165,53.5016527,0.0640519,34.089501,38.9791089,114890.4637194,136045.848763,0.4424179,3490.2247,3370.2594727,4996.2142438,51.4080854,64.1869558,2.0070338,308.2668883),(23083,'red-deer-femur.tif',246,7,221,535.5245462,52.9597591,54.5912102,1.8,53.3325776,54.3450854,0.1178186,33.5459032,38.5786759,80946.3477112,110152.6393641,1.2332336,2855.2726795,2413.0024835,3925.6038238,49.8900409,61.4812359,2.0239022,282.6402297),(23084,'red-deer-femur.tif',246,7,222,380.3230887,52.7438618,55.0226589,1.8,53.2650148,55.1727078,0.1468652,35.4343679,28.0528405,50867.1623384,77697.528021,1.3574209,2769.6848731,1435.531812,3053.0455833,21.7725623,48.9031588,1.1981514,138.3965638),(23085,'red-deer-femur.tif',246,7,223,208.3043876,51.6360614,54.4242804,1.8,52.3370785,55.2119586,0.1342303,35.4113479,35.5539087,26700.8713527,38122.9688853,0.6217821,1072.2581645,754.0201927,1387.2840211,17.9673249,45.0215079,1.1791888,125.0288738),(23086,'red-deer-femur.tif',246,7,224,66.7344223,46.5617612,49.3843677,1.8,47.8697069,52.264822,-1.0608733,32.5544231,22.3627475,2912.8673504,8177.85273,8.4724749,365.6908758,89.4768535,334.7321579,6.5944121,24.0726403,1.6396528,54.3476391),(23087,'red-deer-femur.tif',246,7,225,17.4040221,49.0702999,43.5763521,1.8,49.1054379,43.6810244,1.5476863,2.0633285,8.8072391,12.0881515,241.8827088,2.8991215,27.4640788,5.8585687,28.803614,3.933589,17.2147241,1.6309646,38.4539618),(23088,'red-deer-femur.tif',246,7,226,0.4289171,48.8197505,42.2096042,1.8,48.8306186,42.2384236,1.5051157,0.6362486,2.1066975,0.0433929,0.3978445,0.0711782,0.1888475,0.0682011,0.2091675,1.449217,4.1869429,1.7196863,9.6030866),(23089,'red-deer-femur.tif',246,7,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23090,'red-deer-femur.tif',246,7,228,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23091,'red-deer-femur.tif',246,7,229,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23092,'red-deer-femur.tif',246,7,230,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23093,'red-deer-femur.tif',246,7,231,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23094,'red-deer-femur.tif',246,7,232,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23095,'red-deer-tibia.tif',246,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23096,'red-deer-tibia.tif',246,8,2,0.0021753,21.787095,78.812448,1.8,21.787095,78.812448,0.7853982,0,0,0.0000065,0.0000065,0.0001813,0,0,0,0.189453,0.267927,2.3561945,0.535854),(23097,'red-deer-tibia.tif',246,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23098,'red-deer-tibia.tif',246,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23099,'red-deer-tibia.tif',246,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23100,'red-deer-tibia.tif',246,8,6,0.0022406,27.660138,81.46479,1.8,27.660138,81.46479,0.7853982,0,0,0.0000067,0.0000067,0.0001867,0,0,0,0.189453,0.267927,2.3561945,0.535854),(23101,'red-deer-tibia.tif',246,8,7,0.0022623,28.039044,81.654243,1.8,28.039044,81.654243,0.7853982,0.000000000000002512,0.000000000000002512,0.0000068,0.0000068,0.0001885,2693573841.8229,2693573841.5691,3809288658.17988,0.4932562,1.5274189,2.6224465,3.169155),(23102,'red-deer-tibia.tif',246,8,8,2.484268,49.4287934,57.8704924,1.8,49.39697,57.8522076,-1.2877023,1.0683931,3.7570075,0.5069861,7.3496115,0.3817392,1.9562408,0.4745314,2.0852145,2.276862,7.494776,1.2890245,17.2425331),(23103,'red-deer-tibia.tif',246,8,9,11.5460539,49.5135128,57.5983541,1.8,49.3952674,57.6279673,-1.3048659,1.7110054,5.4538031,6.675804,83.6818089,1.7914326,15.3437532,3.9016848,16.5588284,3.4918314,11.0874526,1.2760662,25.6973311),(23104,'red-deer-tibia.tif',246,8,10,24.3454282,48.1091623,57.5093478,1.8,46.5441381,57.9413273,-0.4711769,5.6845757,14.6727475,169.4832576,540.8899663,0.8360918,36.8635776,29.8145838,47.5190841,5.1949215,13.1215864,1.2627435,31.4078491),(23105,'red-deer-tibia.tif',246,8,11,52.6092231,45.4291715,57.7548922,1.8,44.8075586,57.9133895,-0.3550728,6.6666525,13.2774267,450.4633516,2562.7032134,1.0597824,193.0120402,67.5696461,225.790081,5.8127237,9.7802531,1.7263912,24.9664471),(23106,'red-deer-tibia.tif',246,8,12,96.3787693,44.6319579,57.4283555,1.8,44.2369528,57.4225743,-0.3960703,8.1304896,13.4271989,1070.8884616,5225.1623958,2.3908111,389.1476129,131.7126656,468.8906701,15.8192572,25.5670316,0.6909432,83.2812423),(23107,'red-deer-tibia.tif',246,8,13,167.770147,44.6125191,56.1389662,1.8,44.4351278,55.4050234,-0.5027632,16.2744757,22.7914827,3229.5232041,9853.1919922,6.4920939,432.3190439,198.4409986,572.4963869,22.878643,28.8721648,1.3592447,114.3909695),(23108,'red-deer-tibia.tif',246,8,14,307.1618063,47.099773,53.4900462,1.8,48.095888,52.9236191,-0.3693077,22.8419689,21.5330678,11039.2266145,30530.5138988,6.6704911,1417.8432072,483.2869993,1733.607354,28.2906696,40.8590874,0.2674721,188.5863549),(23109,'red-deer-tibia.tif',246,8,15,430.9277467,48.7528858,52.5693853,1.8,48.8896531,51.7754303,-0.2207538,24.5712062,21.8316909,24752.0438492,52410.9000962,3.4435268,2400.6798399,1007.3597397,3107.0168298,39.2959759,44.6377964,2.9924928,185.4473948),(23110,'red-deer-tibia.tif',246,8,16,540.2984587,48.7387199,52.191753,1.8,48.0292747,51.6666553,-0.0318539,25.5097615,31.0405304,45080.1233934,79911.6712582,0.0913406,2574.4299529,1767.1714992,4004.9439015,41.5791499,57.2762511,2.8114741,207.0877389),(23111,'red-deer-tibia.tif',246,8,17,679.4704673,45.2477592,52.7847443,1.8,44.0991619,52.0838764,0.0858276,26.9609909,36.3211295,62258.374947,168526.7681278,0.8321593,4639.9098952,2309.2020353,6253.4026577,45.7365329,65.2865594,2.9311073,252.6576371),(23112,'red-deer-tibia.tif',246,8,18,772.615578,43.6454475,53.1952085,1.8,43.0934281,52.5438337,0.107205,28.2755713,35.4360936,83494.6411577,219916.7958932,1.4742723,6206.0112673,2952.8896268,8221.8762842,47.3103774,66.1722745,3.1014995,250.8123431),(23113,'red-deer-tibia.tif',246,8,19,817.5561531,42.7820288,53.6330542,1.8,42.452388,52.9672093,0.0932054,29.4932796,35.0367883,103655.1971741,244021.2587892,1.1802962,6964.7153963,3514.5361424,9477.6551338,49.7622837,66.5249851,3.1131103,261.0126101),(23114,'red-deer-tibia.tif',246,8,20,845.5952613,42.1596892,53.8991044,1.8,41.9734011,53.2731685,0.0630484,30.4852993,34.6801894,121932.4749513,252604.1898731,0.5594792,7283.8180701,3999.7138892,10196.2058804,51.5064587,66.595357,0.0540783,260.7256421),(23115,'red-deer-tibia.tif',246,8,21,879.0996351,41.8468722,54.150495,1.8,41.591197,53.7377074,0.0215851,31.515612,34.8132387,141455.3621242,254064.2007288,0.0682532,7297.9191365,4488.4218751,10696.4401043,53.54844,66.275252,0.0686598,266.5740672),(23116,'red-deer-tibia.tif',246,8,22,909.0478731,41.9593081,54.5406524,1.8,41.3569574,54.181831,-0.0253213,32.6829845,35.6054811,160728.0832098,253116.4627288,0.0971223,7108.918485,4917.7908872,10996.9892095,55.3436748,65.9244719,3.0350611,255.3861431),(23117,'red-deer-tibia.tif',246,8,23,936.7867683,41.7388892,55.0820661,1.8,41.184687,54.5631033,-0.0689717,33.8583922,36.1308811,179974.9900181,253743.7042398,0.7415546,7022.9038509,5315.5208564,11429.4874775,58.0635304,65.8386656,0.0547004,271.7027622),(23118,'red-deer-tibia.tif',246,8,24,920.631701,40.9139922,55.2484572,1.8,41.0340335,54.7535706,-0.2394056,33.7630255,37.1902054,184567.7942647,247161.5936572,8.6276024,6645.8786932,5466.5656123,11391.2298241,58.075926,66.1649515,0.9645273,252.38509),(23119,'red-deer-tibia.tif',246,8,25,868.3988808,40.4523717,54.8856999,1.8,40.7622561,54.7912891,-0.4641863,31.2756829,38.0712965,176357.0421478,238240.2263374,29.0090335,6257.7387218,5638.7910967,10883.1500098,58.2319733,67.4721373,0.971112,243.3025),(23120,'red-deer-tibia.tif',246,8,26,823.1146737,40.1553048,54.5490547,1.8,40.2874334,54.5492397,-0.6103149,32.6214987,38.2588691,164166.4258423,232492.2872066,45.0618104,6076.8206933,5032.4611729,10354.7880621,0.84774,1.071708,0.7853982,2.790249),(23121,'red-deer-tibia.tif',246,8,27,789.2414779,40.0455227,54.297959,1.8,40.0467313,54.4160803,-0.69562,32.3247771,38.232574,153320.0214523,228560.8378092,54.0240329,5978.1702808,4743.1114852,9960.0377846,0.757812,1.1046913,2.1112158,2.522322),(23122,'red-deer-tibia.tif',246,8,28,751.4258674,40.0912515,54.2443837,1.8,40.0184735,54.3216489,-0.7550553,31.3548726,38.1041286,143889.742437,221153.4102324,58.8210884,5803.9225251,4589.071192,9510.9834038,0.7193312,1.071708,0.7853982,2.365374),(23123,'red-deer-tibia.tif',246,8,29,706.0727142,40.4914621,53.8203478,1.8,40.3680542,53.9631989,-0.861509,30.6901291,37.7904994,134787.7273443,205159.8534246,67.7614692,5428.8738382,4391.8918275,8790.12131,0.378906,0.599103,1.8925469,1.450614),(23124,'red-deer-tibia.tif',246,8,30,670.5253101,40.7532308,53.3584449,1.8,40.7369059,53.5257228,-0.9447102,29.1308217,37.0330146,127312.9119131,193223.2737904,73.3811827,5217.5950507,4370.3852007,8517.8000833,51.743705,69.1742171,1.0740725,222.3280299),(23125,'red-deer-tibia.tif',246,8,31,646.6574471,40.9155725,52.9019026,1.8,40.9816271,53.0162192,-1.0183887,44.444745,36.2916379,120368.9350321,187103.1687928,78.1000208,5155.5449084,2708.2827237,6847.8953157,50.7743009,69.0568529,1.119418,224.3604669),(23126,'red-deer-tibia.tif',246,8,32,631.5015927,41.056344,52.3506023,1.8,41.2087513,52.5588503,-1.0676082,28.6367918,35.9775381,114282.8175422,185023.4297207,80.7756811,5142.7484844,3990.768883,8161.8550476,0.378906,0.8472596,1.1071487,1.82952),(23127,'red-deer-tibia.tif',246,8,33,607.8494324,41.2938167,51.480176,1.8,41.4887145,51.7217283,-1.0985577,42.0763772,35.8855889,105821.5318187,178492.4340548,80.3458669,4973.9307474,2514.9867656,6481.8945347,1.3937479,3.1531263,0.9994588,10.3112461),(23128,'red-deer-tibia.tif',246,8,34,578.0637002,42.0464806,50.2424305,1.8,42.1167021,50.6917341,-1.204915,42.999673,35.5688495,95754.1773215,164012.6780092,84.0118164,4611.1325007,2226.8582683,5646.6133215,2.1708592,10.4044028,0.9928944,31.7565602),(23129,'red-deer-tibia.tif',246,8,35,553.8719895,42.872105,49.1772995,1.8,43.1207173,49.5388799,-1.3463304,38.959035,32.5530062,85494.5690366,154415.0516251,87.7384532,4743.4959075,2194.4734792,5264.571811,1.7893009,14.9319735,0.947597,43.0935452),(23130,'red-deer-tibia.tif',246,8,36,538.9694596,43.427148,48.2440719,1.8,43.5924231,48.7323222,-1.4376784,36.5642309,32.4524471,76839.6655815,151849.7231603,88.2458339,4679.1455472,2101.4982056,4975.0820643,2.0480678,14.2493343,0.9459101,38.4087662),(23131,'red-deer-tibia.tif',246,8,37,521.4478693,43.8295428,47.6878427,1.8,43.9615676,48.1629311,-1.487191,34.0152198,32.1762164,69627.8322142,146947.6093424,86.3019184,4566.9636046,2046.9611111,4768.6037103,2.0039756,12.0134715,0.90837,34.4548712),(23132,'red-deer-tibia.tif',246,8,38,506.2560137,44.1891333,47.3811321,1.8,44.2839657,47.7438796,-1.5121468,22.9777419,31.8218147,64603.0083213,141657.3952807,84.0861009,4451.5812962,2811.5473013,6446.7712987,0.378906,0.599103,1.8925469,1.450614),(23133,'red-deer-tibia.tif',246,8,39,492.7069007,44.4560681,47.098289,1.8,44.5933288,47.3855628,-1.5293897,22.2161613,31.4917418,60302.7865214,137621.9772782,81.9771052,4370.0973526,2714.3657081,6264.1470965,0.568359,0.803781,0.7853982,1.718541);
INSERT INTO `slices_w` VALUES (23134,'red-deer-tibia.tif',246,8,40,481.0324824,44.7416989,46.9729784,1.8,44.8641119,47.2146868,-1.5419147,22.7020093,31.0286714,56726.6487385,132718.2564424,80.1052229,4277.2780923,2498.7501366,6049.3384532,0.568359,0.8472596,1.1071487,1.986468),(23135,'red-deer-tibia.tif',246,8,41,463.5208985,44.9693622,46.9366175,1.8,45.0644159,47.1078439,-1.5454995,23.3904212,30.6033575,52788.7535047,124560.3368053,77.2040571,4070.1526521,2256.8534824,5717.5926193,0.535854,0.803781,0.7853982,1.607562),(23136,'red-deer-tibia.tif',246,8,42,445.9686474,45.2600973,47.168392,1.8,45.2528481,47.1205623,-1.541619,21.8111577,33.8847578,49613.5168644,115529.905563,74.2648492,3409.4948009,2274.6851643,4127.3165782,2.5428304,14.854855,0.9119903,48.2951373),(23137,'red-deer-tibia.tif',246,8,43,424.658882,45.5944022,47.7445029,1.8,45.5385909,47.1899276,-1.5290657,21.6641897,30.7483076,46670.9924743,103769.8757204,70.6532984,3374.8158411,2154.2920857,4836.2957937,2.0521584,13.6616501,0.9827937,35.4615692),(23138,'red-deer-tibia.tif',246,8,44,406.6862217,45.853682,48.1419526,1.8,45.7713425,47.355603,-1.5186766,21.3489024,30.0648599,44204.6871878,94612.8794825,67.5970785,3146.9589354,2070.5835966,4512.5352731,2.6451595,25.3506237,0.9392528,66.7472854),(23139,'red-deer-tibia.tif',246,8,45,400.097414,46.0709213,48.0602019,1.8,45.9476502,47.2551385,-1.5304115,21.2595386,30.072609,42518.2664358,92548.3262366,66.5742058,3077.4957468,1999.9618655,4405.952888,2.6383626,14.4742588,0.9246774,39.0555992),(23140,'red-deer-tibia.tif',246,8,46,393.0425593,46.2601858,47.8423724,1.8,46.2110269,47.0999234,-1.5345874,20.3860488,29.6726725,40625.1324141,90852.156783,65.4212456,3061.8124051,1992.790898,4358.5111355,2.4613991,15.270664,0.91737,47.5832943),(23141,'red-deer-tibia.tif',246,8,47,388.6484763,46.5199854,47.5387128,1.8,46.4859746,46.9211731,-1.5399575,20.3152098,29.2522799,38883.9637806,90194.8153096,64.7131626,3083.3430957,1914.0321007,4371.0599055,2.1576937,14.5138805,0.9429597,45.3210122),(23142,'red-deer-tibia.tif',246,8,48,385.6077341,46.7232459,47.5009766,1.8,46.7206463,46.9250371,-1.5421723,20.3248238,28.6649167,37565.6400828,88519.751514,64.215313,3088.0868264,1848.2639961,4342.4510542,2.4093182,14.6259679,0.9324765,37.2910892),(23143,'red-deer-tibia.tif',246,8,49,376.8344908,47.0331325,47.3649272,1.8,46.9271543,46.7702414,-1.5432221,20.0984235,28.1554173,35799.8898528,85335.5191826,62.7580067,3030.8738914,1781.2287503,4267.6158009,2.7151318,24.3364159,0.9568816,63.5860174),(23144,'red-deer-tibia.tif',246,8,50,368.3769596,47.2680279,47.3979355,1.8,47.1770988,46.7477437,-1.5388113,20.0776977,27.6109999,34206.4045251,82372.3420197,61.33337,2983.3161542,1703.7015401,4164.6144551,0.189453,0.4236298,2.0344439,0.91476),(23145,'red-deer-tibia.tif',246,8,51,364.5253855,47.4667398,47.3887006,1.8,47.2989799,46.8625763,-1.533021,22.3513379,32.9329371,33067.757986,79505.9540827,60.6675771,2414.1774471,1479.4531849,2865.5077706,7.094043,34.1541253,1.2315037,119.0724816),(23146,'red-deer-tibia.tif',246,8,52,362.3456485,47.6902252,47.487884,1.8,47.5266985,46.9828242,-1.5299326,24.267203,32.3765837,32183.1327749,77356.9535432,60.290154,2389.287095,1326.198689,2775.913633,3.0378823,17.663889,0.8994055,52.3521243),(23147,'red-deer-tibia.tif',246,8,53,359.472611,47.8953776,47.6710726,1.8,47.6744877,47.1715961,-1.5270435,23.3869483,31.3175344,31347.2966668,75195.5736467,59.7974844,2401.0694074,1340.3756753,2748.9825918,6.574581,34.5745237,1.229984,100.1685305),(23148,'red-deer-tibia.tif',246,8,54,355.8860645,48.1010023,47.82534,1.8,47.8987573,47.3736303,-1.5220461,24.6158725,30.6722189,30604.7440047,72869.9749852,59.1734901,2375.7647005,1243.293082,2675.8551073,2.5073944,16.6082328,1.004942,47.2884393),(23149,'red-deer-tibia.tif',246,8,55,354.0325354,48.300993,47.960277,1.8,48.1112734,47.4736148,-1.5161055,25.3422142,29.7415938,30051.9785397,70902.5097862,58.829108,2383.9512527,1185.8465991,2595.3023218,6.3842216,33.3937448,1.2113616,100.0115825),(23150,'red-deer-tibia.tif',246,8,56,351.197979,48.5041933,48.0599541,1.8,48.3407414,47.5148981,-1.5115769,26.190034,28.8853626,29413.346351,68949.8189036,58.3279643,2387.0158686,1123.0740053,2523.2654213,0.189453,0.4236298,2.0344439,0.91476),(23151,'red-deer-tibia.tif',246,8,57,347.9062725,48.7583241,48.0405219,1.8,48.4599893,47.4585638,-1.5048463,18.1309247,25.9795621,28712.7752687,66833.0008946,57.7325465,2572.522229,1583.6354603,3600.6939542,5.9554563,33.7487003,1.2153108,98.3770925),(23152,'red-deer-tibia.tif',246,8,58,344.4407161,48.8848092,48.1686612,1.8,48.5503814,47.5212055,-1.4973737,18.8312037,25.8987478,28095.3295823,65010.9799001,57.097868,2510.197807,1491.9561185,3521.5367208,6.0555877,33.460854,1.2060615,108.5964005),(23153,'red-deer-tibia.tif',246,8,59,340.3748641,49.008157,48.328365,1.8,48.6610395,47.6852384,-1.4880215,18.3238449,25.9046218,27463.7212498,63197.0382962,56.3413411,2439.6047479,1498.7968641,3447.735243,5.9668632,33.5711571,1.2133467,103.3297985),(23154,'red-deer-tibia.tif',246,8,60,337.1412599,49.1328344,48.4531904,1.8,48.7776019,47.7279088,-1.480622,18.2449166,25.9858934,26963.8202606,61605.7829145,55.7345408,2370.7394597,1477.8812596,3384.8986753,5.9633596,33.7056002,1.2028154,104.2524455),(23155,'red-deer-tibia.tif',246,8,61,334.6756994,49.2669404,48.5786011,1.8,48.9367067,47.8742405,-1.4732577,18.060238,25.4991116,26469.4688443,60194.1045744,55.2502917,2360.6353648,1465.6212647,3324.3338565,5.9270852,33.5288993,1.2007827,100.3445195),(23156,'red-deer-tibia.tif',246,8,62,332.9181772,49.4136309,48.6769529,1.8,49.1187269,47.944206,-1.4641443,17.9288524,25.3885494,26043.3414351,58985.7696199,54.8576143,2323.3217757,1452.593892,3276.7020032,0.189453,0.267927,2.3561945,0.535854),(23157,'red-deer-tibia.tif',246,8,63,331.1487343,49.5556027,48.769127,1.8,49.2293034,47.9859723,-1.4590732,17.7627463,25.2514812,25636.8114406,57894.24581,54.5054141,2292.7069271,1443.2909783,3231.719149,2.3847032,22.1789513,0.9614699,57.2207793),(23158,'red-deer-tibia.tif',246,8,64,332.5203911,49.6792448,48.9281472,1.8,49.4052001,48.1793271,-1.4512833,17.1949578,30.3374554,25375.2015118,57100.6853705,54.6322415,1882.1844018,1475.7350303,2467.1012998,5.234447,33.3878328,1.1808066,95.2539065),(23159,'red-deer-tibia.tif',246,8,65,331.0795163,49.8367411,49.0266594,1.8,49.4679865,48.1259283,-1.4425397,17.807322,25.1053126,24974.1779407,55907.2122397,54.2771889,2226.9076327,1402.4668046,3152.7777367,0.189453,0.599103,1.8925469,1.293666),(23160,'red-deer-tibia.tif',246,8,66,321.5375549,50.0719303,49.1577183,1.8,49.699119,49.2568687,-1.4423631,16.225438,25.0163987,23829.7427372,54049.7932352,52.7104768,2160.5745034,1468.6656041,2835.9750495,2.0522819,17.5087785,0.9467733,53.9216043),(23161,'red-deer-tibia.tif',246,8,67,321.7904443,50.1651153,49.3352479,1.8,49.7223923,49.5678243,-1.4354088,16.5902421,25.8682805,23590.2375279,53541.5223752,52.6546742,2069.7750838,1421.9344979,2819.6578023,6.0826564,30.783052,1.1925757,94.6340015),(23162,'red-deer-tibia.tif',246,8,68,321.4666292,50.2747729,49.5095109,1.8,49.8359747,49.7476043,-1.4288548,16.185629,25.0223743,23330.8709567,52792.8346375,52.5055484,2109.8251492,1441.4559356,2878.9334885,5.740748,31.7699746,1.1792162,100.2144995),(23163,'red-deer-tibia.tif',246,8,69,321.9427479,50.399957,49.6660511,1.8,50.0053453,49.9577854,-1.4243338,16.6833377,25.0049106,23090.6175312,52214.6425173,52.5143178,2088.1755331,1384.0526377,2946.6823444,5.752519,32.440196,1.1751067,101.9330405),(23164,'red-deer-tibia.tif',246,8,70,322.7493706,50.5372492,49.7796638,1.8,50.1632391,49.9836277,-1.4193233,22.2190092,30.3689648,22857.5043161,51609.1994396,52.5667738,1699.4059468,1028.7364358,2178.4368186,2.1834873,18.0378757,0.942,52.4519493),(23165,'red-deer-tibia.tif',246,8,71,322.986674,50.6727626,49.9383341,1.8,50.2988536,50.0984814,-1.4130574,23.443013,30.311321,22592.9660749,50851.7673049,52.5027822,1677.6493278,963.7398594,2146.0613378,1.9408896,15.5974021,0.8713925,41.3099942),(23166,'red-deer-tibia.tif',246,8,72,322.8861534,50.7951095,50.1077942,1.8,50.4152009,50.377686,-1.4076367,21.1224901,29.9478357,22262.5200647,50253.2299573,52.3944306,1678.0254306,1053.972327,2174.5078142,0.568359,0.6830825,2.1587989,1.718541),(23167,'red-deer-tibia.tif',246,8,73,320.806328,50.9500497,50.2144434,1.8,50.5182518,50.3664676,-1.4015162,20.8906813,31.6585222,21810.9904583,49338.4452242,51.9501425,1558.4569895,1044.0535747,2161.2855203,5.3028432,30.355077,1.1462349,93.0993365),(23168,'red-deer-tibia.tif',246,8,74,319.7959014,51.0602998,50.3750497,1.8,50.6227401,50.5984368,-1.3949942,15.6535786,31.8081644,21414.7967848,48594.1847099,51.6689277,1527.7267858,1368.0447979,2200.9219706,5.4053744,30.8570029,1.1401038,103.3646135),(23169,'red-deer-tibia.tif',246,8,75,318.3195693,51.1603028,50.5169832,1.8,50.6924863,50.6800165,-1.3892325,15.9150758,31.3452768,21064.4328252,47649.2536921,51.3234725,1520.1414247,1323.5521537,2188.9321689,0.4018905,0.947265,0.9272952,1.986468),(23170,'red-deer-tibia.tif',246,8,76,318.1653297,51.266211,50.6856764,1.8,50.8055815,50.9000297,-1.3822967,16.5038264,30.2283438,20788.2316494,46895.6064887,51.1655852,1551.3786261,1259.6007251,2184.3746842,0.378906,0.6830825,0.9827937,1.450614),(23171,'red-deer-tibia.tif',246,8,77,318.5961042,51.3800433,50.8454728,1.8,50.9866406,51.0332242,-1.375405,15.954617,24.0725094,20601.1987244,46098.2565943,51.0978036,1914.9751183,1291.237435,2739.552404,0.189453,0.267927,2.3561945,0.535854),(23172,'red-deer-tibia.tif',246,8,78,319.031175,51.4836334,51.0200657,1.8,51.1343824,51.1514488,-1.3686188,16.3617048,29.8150609,20394.9837903,45274.7113257,51.0278757,1518.5181572,1246.507255,2156.5726392,4.6150731,28.8926695,1.1159461,102.8287595),(23173,'red-deer-tibia.tif',246,8,79,318.4468352,51.5720408,51.2183306,1.8,51.2035495,51.3506283,-1.3591736,15.4574561,28.8914723,20154.3382902,44266.3872809,50.7328479,1532.1610063,1303.8586818,2153.5392969,4.2314094,28.2996112,1.0981669,80.5146544),(23174,'red-deer-tibia.tif',246,8,80,319.3663124,51.6953239,51.4035268,1.8,51.367661,51.5201062,-1.3518682,15.9786878,28.5568981,19981.9775415,43408.1433368,50.7170386,1520.0580682,1250.5393336,2124.3821322,0.378906,0.6830825,2.1587989,1.450614),(23175,'red-deer-tibia.tif',246,8,81,317.5178192,51.8506133,51.5314491,1.8,51.5048073,51.5555539,-1.3486029,15.4384479,30.2938035,19682.7965981,42229.8322027,50.3497106,1394.008918,1274.9206894,2042.8693799,4.5567573,28.7300961,1.0835543,74.6662294),(23176,'red-deer-tibia.tif',246,8,82,315.9644923,51.9469318,51.7691679,1.8,51.6026803,51.8021508,-1.3380396,16.9012614,28.0102662,19458.2848984,41130.8565479,49.8589654,1468.4207645,1151.2918758,2057.3143976,4.0456794,29.5157803,1.0612041,77.7053644),(23177,'red-deer-tibia.tif',246,8,83,314.5181358,52.0389742,52.0048093,1.8,51.6973495,52.0696223,-1.3284543,22.633327,29.5331486,19266.690511,40010.9743632,49.4008973,1354.7818726,851.2531309,1918.0694994,4.3136141,29.1154191,1.0460006,84.4225805),(23178,'red-deer-tibia.tif',246,8,84,313.4914598,52.1264806,52.2497774,1.8,51.7959855,52.3709196,-1.3146572,22.4562463,29.3507957,19083.7561261,38821.9543058,48.8950041,1322.6883072,849.819504,1892.0258802,3.746206,26.8843086,1.0630134,71.4780334),(23179,'red-deer-tibia.tif',246,8,85,313.4774073,52.2276024,52.496835,1.8,51.9342381,52.617064,-1.3028118,23.5338631,28.8746001,18993.8062775,37828.2995838,48.5830994,1310.0891254,807.08408,1853.4161577,3.8585563,27.9756079,1.0222469,74.4061894),(23180,'red-deer-tibia.tif',246,8,86,313.6397173,52.3135153,52.7352939,1.8,51.9971052,52.884495,-1.2903244,15.8883288,28.0916401,18879.5514292,36981.6175233,48.2679348,1316.4634534,1188.2654064,1957.9669427,0.7213822,3.0840714,0.8288491,6.384279),(23181,'red-deer-tibia.tif',246,8,87,314.4976118,52.3948058,52.9707275,1.8,52.0784834,53.1578814,-1.2771881,16.1638189,26.3563426,18792.9108669,36240.71306,48.0260432,1375.0281543,1162.6528936,1935.3137617,0.6521452,1.7466704,0.8621701,3.59403),(23182,'red-deer-tibia.tif',246,8,88,314.6389845,52.4724931,53.2094134,1.8,52.1929031,53.4368304,-1.2646446,28.572042,27.8346128,18703.7981484,35434.9670991,47.6763611,1273.0540705,654.6188795,1632.7132832,26.8835239,38.4967377,1.6151023,110.9460005),(23183,'red-deer-tibia.tif',246,8,89,311.8895802,52.5819504,53.4111273,1.8,52.2914359,53.5223131,-1.2530606,15.8403638,26.5513664,18454.606152,34376.7665595,46.9079843,1294.7268345,1165.0367651,1927.1255206,0.9225004,2.692633,0.8850668,6.116352),(23184,'red-deer-tibia.tif',246,8,90,310.0605885,52.6448965,53.6720285,1.8,52.3059673,53.9037077,-1.2388693,15.7026048,25.5456743,18236.2089867,33474.2785134,46.1892973,1310.3697356,1161.3492953,1896.3904359,26.7448634,40.7993095,1.2446405,182.3163218),(23185,'red-deer-tibia.tif',246,8,91,308.9880136,52.7029483,53.9211733,1.8,52.3614899,54.1646315,-1.2252335,16.7855557,25.4566472,18090.7098841,32763.0908564,45.5893533,1287.0151618,1077.7546013,1884.5252778,26.4003083,41.0234651,1.2022962,175.7829817),(23186,'red-deer-tibia.tif',246,8,92,308.9626279,52.7522422,54.186499,1.8,52.391918,54.4045023,-1.2105648,22.273772,25.4029132,18023.8245131,32019.7380005,45.0956766,1260.4750384,809.1949821,1789.3616605,26.3152389,40.5593166,1.2475687,169.4256307),(23187,'red-deer-tibia.tif',246,8,93,309.658963,52.8085441,54.4560576,1.8,52.4477158,54.7863572,-1.1963239,21.0322049,24.9744281,17996.9855562,31453.6830528,44.70463,1259.4355667,855.6870592,1850.1700467,26.2703184,36.0981302,1.1776201,105.5493784),(23188,'red-deer-tibia.tif',246,8,94,310.1895837,52.8646458,54.7247919,1.8,52.511247,55.1138308,-1.1814721,19.4054149,25.5731427,17950.3999395,30905.0916327,44.2501843,1208.4979947,925.0201587,1830.9306287,26.2229183,35.8146353,1.5919572,104.6346184),(23189,'red-deer-tibia.tif',246,8,95,311.0933989,52.9068398,54.9687612,1.8,52.482981,55.3039441,-1.1653174,24.828529,27.007296,17871.720072,30341.0591312,43.7813254,1123.4393527,719.8058371,1683.9007765,26.2314305,35.3993323,1.1694182,103.7198584),(23190,'red-deer-tibia.tif',246,8,96,310.2079868,52.9435708,55.1428301,1.8,52.554943,55.3026075,-1.1480327,25.139126,24.160725,17723.691461,29624.7656429,42.9983635,1226.1538365,705.0241699,1654.2749846,0.189453,0.267927,2.3561945,0.535854),(23191,'red-deer-tibia.tif',246,8,97,310.6789717,53.0183764,55.3473018,1.8,52.5092131,55.6187726,-1.1293994,26.1706977,25.7967847,17557.0560564,29150.6666381,42.3298874,1130.0116274,670.8669458,1604.4759412,26.0621292,34.8557481,1.1509164,102.2502034),(23192,'red-deer-tibia.tif',246,8,98,308.7385612,53.0693495,55.56648,1.8,52.631513,55.7503886,-1.1122814,26.6659949,21.03686,17356.2321939,28365.746461,41.3756117,1348.3830981,650.8751032,1560.7865501,26.0134404,34.4872115,1.1218897,101.0215474),(23193,'red-deer-tibia.tif',246,8,99,307.3536895,53.0903116,55.7998066,1.8,52.6419765,55.9921076,-1.0937658,20.2016241,24.8204418,17167.4589067,27711.4812441,40.4266152,1116.4781628,849.8058801,1723.4900583,25.9661868,34.1530744,1.1294775,100.2637354),(23194,'red-deer-tibia.tif',246,8,100,307.0672352,53.1198843,56.0170835,1.8,52.7348587,56.2169432,-1.0688676,18.1361867,25.3357412,17017.025346,27136.7941974,39.331534,1071.0874401,938.2912528,1677.7250748,25.7724779,33.8124513,1.0871013,99.0810484),(23195,'red-deer-tibia.tif',246,8,101,307.2638061,53.1341526,56.2231948,1.8,52.7541586,56.343514,-1.044084,27.821317,23.9149408,16883.9316649,26643.2118437,38.269641,1114.0822833,606.870323,1473.1036625,26.0656747,37.113451,1.0934509,132.9810246),(23196,'red-deer-tibia.tif',246,8,102,307.333394,53.1488193,56.4449048,1.8,52.7976575,56.5738249,-1.0205432,18.1470197,22.9951194,16732.2253737,26172.9878896,37.2166629,1138.1975221,922.0370976,1640.4240149,25.5627677,33.324885,1.0664587,97.4734864),(23197,'red-deer-tibia.tif',246,8,103,307.4304014,53.152476,56.6427151,1.8,52.807208,56.7125909,-0.9938607,24.3886287,25.5449957,16591.5344844,25743.8838712,35.9937149,1007.7857988,680.2979656,1548.9036033,25.5170812,33.0159564,1.0480915,96.6697054),(23198,'red-deer-tibia.tif',246,8,104,307.5218619,53.1515198,56.853834,1.8,52.8104457,56.9259284,-0.9720469,29.0917497,21.4924686,16491.1642991,25309.085993,34.9726098,1177.5792946,566.8673932,1394.8467203,25.4268581,32.7200195,1.0760706,96.1338514),(23199,'red-deer-tibia.tif',246,8,105,306.8626374,53.1892523,57.0262993,1.8,52.8062643,57.0878029,-0.9498897,28.760874,22.9058821,16307.8122847,24841.1395871,33.8336729,1084.4873586,567.0137937,1391.1129436,25.4100107,32.3942471,1.0233559,95.3950804),(23200,'red-deer-tibia.tif',246,8,106,305.6333214,53.172551,57.2432686,1.8,52.7968295,57.3684816,-0.9313626,26.5226886,21.9877033,16100.4655917,24404.8557994,32.7995497,1109.9320139,607.0450038,1453.1786169,25.2474439,32.2404255,1.0545657,94.7482474),(23201,'red-deer-tibia.tif',246,8,107,304.8750229,53.1519586,57.4392341,1.8,52.7092955,57.4756814,-0.9139348,21.7076948,25.8959816,15947.0789063,23995.3079388,31.8658209,926.6035293,734.6279321,1489.56986,25.232616,32.0108302,1.0090603,94.0094764),(23202,'red-deer-tibia.tif',246,8,108,304.6784955,53.1429973,57.6375055,1.8,52.7276708,57.6787731,-0.8926302,30.0610031,23.0507085,15799.7886622,23636.7586869,30.7934427,1025.4243894,525.5908659,1300.720789,25.1400439,31.8506499,1.0058919,93.5846014),(23203,'red-deer-tibia.tif',246,8,109,304.8841592,53.1332128,57.8373332,1.8,52.7380349,57.8477582,-0.8680993,24.1173185,27.4516693,15645.7808866,23285.4736073,29.5902553,848.2352506,648.7363376,1381.0489323,25.1306934,31.6341129,0.9944211,93.0487474),(23204,'red-deer-tibia.tif',246,8,110,304.8166052,53.1016202,58.033564,1.8,52.6792958,58.0682924,-0.8495108,21.7068818,26.8802224,15483.3479703,22982.331123,28.6495634,854.9903641,713.2921315,1399.8686636,24.9519296,31.3835056,0.9526521,92.7808204),(23205,'red-deer-tibia.tif',246,8,111,305.5912293,53.0735791,58.2526479,1.8,52.6461669,58.3105269,-0.8292033,21.3910868,24.9362563,15344.0893856,22716.2127962,27.6941606,910.9712577,717.3122882,1494.1762631,24.827543,31.2137832,0.9710098,92.3369044),(23206,'red-deer-tibia.tif',246,8,112,305.0851895,53.0407897,58.4433917,1.8,52.6167777,58.4918828,-0.8113797,27.7265373,18.039499,15172.0733158,22436.7460842,26.7442688,1243.7566072,547.2040436,1345.4652876,24.7182095,31.07549,0.9455859,91.5521643),(23207,'red-deer-tibia.tif',246,8,113,304.1278076,53.0386506,58.6029974,1.8,52.5708029,58.6493653,-0.7990499,19.2563859,24.5346478,15013.2873409,22121.8399584,26.0358784,901.6571216,779.6523942,1483.9382228,24.6892231,30.9220727,0.942,91.2842373),(23208,'red-deer-tibia.tif',246,8,114,303.0836313,52.9972428,58.815733,1.8,52.5110802,58.9467654,-0.7831744,27.1759155,25.6351293,14847.7849948,21782.724779,25.1446364,849.7216671,546.3582268,1340.1613068,24.5271137,30.7463016,0.9605752,90.4804563),(23209,'red-deer-tibia.tif',246,8,115,301.9720751,52.948777,58.9969094,1.8,52.4605266,59.1067333,-0.7694148,27.1171692,25.9300857,14661.0425525,21509.6011664,24.3600568,829.52295,540.6553489,1328.7130659,24.5220925,30.5466159,0.9483839,90.4344873),(23210,'red-deer-tibia.tif',246,8,116,303.2097116,52.91023,59.1666414,1.8,52.3897552,59.2593009,-0.7497698,27.0704859,25.2833016,14466.0769102,21285.807316,23.4685194,841.8919194,534.3855646,1317.1738119,24.6166409,34.1609554,0.9627964,150.2458656),(23211,'red-deer-tibia.tif',246,8,117,303.5893666,52.8681189,59.3224855,1.8,52.3610463,59.3016692,-0.7305204,24.2639098,25.5685842,14286.1086001,20983.5704164,22.5279667,820.6778382,588.7801555,1376.8166676,24.7189459,33.9882061,0.9317545,152.8982076),(23212,'red-deer-tibia.tif',246,8,118,302.5867603,52.8146122,59.4920232,1.8,52.2933245,59.5207092,-0.7200643,22.1376046,22.6331091,14046.3560745,20754.0113778,21.9300703,916.9757133,634.5020748,1478.5632647,24.6488917,34.2632442,0.9029637,159.2095896),(23213,'red-deer-tibia.tif',246,8,119,301.5057344,52.7796063,59.6382228,1.8,52.3348326,59.5120033,-0.7040089,21.1416017,22.3919761,13881.9907939,20397.2818967,21.0536263,910.9192433,656.6196349,1464.8976365,24.1376266,29.9083829,0.9564378,88.7159463),(23214,'red-deer-tibia.tif',246,8,120,300.6042142,52.7304902,59.8228484,1.8,52.30734,59.693086,-0.6901962,27.9108424,25.5872243,13705.507212,20165.9946654,20.3094327,788.1274825,491.0459883,1213.1734314,24.0157708,29.782108,0.9298397,88.4480193),(23215,'red-deer-tibia.tif',246,8,121,299.5845317,52.696236,59.9871585,1.8,52.2599422,59.9142795,-0.6807801,27.9160827,20.3301478,13599.2849359,19957.7448301,19.779748,981.682231,487.1487545,1200.8736982,23.9074443,29.6692108,0.9349579,87.9121653),(23216,'red-deer-tibia.tif',246,8,122,303.8260501,52.63021,60.160703,1.8,52.6733033,60.0362511,-0.6406775,14.5070126,15.6270179,13469.7689776,19837.1190925,18.0924131,1269.4116847,928.5005351,2098.0611062,23.8052922,29.4792764,0.9221539,87.7092483),(23217,'red-deer-tibia.tif',246,8,123,301.8312353,52.5878391,60.3224443,1.8,52.6723174,60.289117,-0.632092,28.276735,15.2433931,13217.8800912,19503.2619486,17.5607758,1279.4567298,467.4471822,1141.1708028,23.6520058,29.3285238,0.9182515,87.4872903),(23218,'red-deer-tibia.tif',246,8,124,301.4198101,52.5329142,60.4736,1.8,52.6307673,60.432648,-0.6230306,29.6461321,15.4388007,13066.2639135,19317.8727137,17.1041243,1251.2547524,440.7409334,1058.4856777,0.189453,0.4236298,2.0344439,0.91476),(23219,'red-deer-tibia.tif',246,8,125,301.5928551,52.4680743,60.6220222,1.8,52.5698998,60.5934178,-0.6146214,14.266157,15.9032829,12893.1330389,19151.2995565,16.7144963,1204.2356047,903.7565615,1978.5472983,23.4794156,29.1449904,0.9051922,86.7944883),(23220,'red-deer-tibia.tif',246,8,126,300.9806389,52.4131416,60.7660496,1.8,52.5011213,60.7286788,-0.6047814,27.5362054,15.4828296,12729.6280024,18956.7792624,16.217126,1224.3743419,462.2869354,1133.8449092,23.3553892,29.1141863,0.8960554,86.7025503),(23221,'red-deer-tibia.tif',246,8,127,301.3230962,52.3539952,60.9133209,1.8,52.4182567,60.9029653,-0.5941933,14.0182332,15.8702653,12598.1891238,18829.0166221,15.7401826,1186.4336398,898.7002121,1979.7438062,0.378906,0.599103,1.8925469,1.450614),(23222,'red-deer-tibia.tif',246,8,128,300.5335713,52.2988426,61.0376164,1.8,52.4136661,60.9745468,-0.5872236,24.0320623,15.8258565,12456.5227299,18664.2215974,15.3759705,1179.3498551,518.3293295,1294.9612524,23.1350935,28.8479132,0.897081,86.2586343),(23223,'red-deer-tibia.tif',246,8,129,298.7130416,52.2657081,61.1471565,1.8,52.3652429,61.1042326,-0.5823238,13.7128092,15.2184098,12260.2730616,18411.5268795,15.0582676,1209.8193643,894.0744996,1970.1203841,0.189453,0.267927,2.3561945,0.535854),(23224,'red-deer-tibia.tif',246,8,130,297.5712813,52.1887125,61.2884363,1.8,52.303488,61.243472,-0.5759112,14.1473229,14.9728182,12097.6165198,18211.7464249,14.7093638,1216.3205491,855.1170148,1906.0986249,22.9472024,28.6249628,0.8650415,85.8797283),(23225,'red-deer-tibia.tif',246,8,131,296.294696,52.1177149,61.4215561,1.8,52.2268516,61.4169084,-0.5688999,26.5591278,16.1397918,11927.4385131,18003.5884391,14.330967,1115.4783539,449.089993,1107.2484337,22.795789,28.581671,0.8981258,85.4548533),(23226,'red-deer-tibia.tif',246,8,132,296.5343161,52.0401728,61.5419315,1.8,52.1498901,61.5103216,-0.562366,13.5474531,15.3667538,11800.5412675,17899.021011,14.0503303,1164.7886891,871.0523783,1792.0823635,22.62576,28.4640129,0.9033318,85.1869263),(23227,'red-deer-tibia.tif',246,8,133,297.1163175,51.9675483,61.6632988,1.8,52.0631592,61.627044,-0.5543203,13.4010377,15.2178454,11700.4796454,17803.762838,13.7198719,1169.9266488,873.1025087,1724.8298624,22.6238361,28.41795,0.9272952,84.8080203),(23228,'red-deer-tibia.tif',246,8,134,297.887472,51.8979592,61.7856794,1.8,51.9602437,61.7613489,-0.5486301,13.395676,15.2366702,11618.7420664,17705.6253795,13.5033334,1162.0403397,867.3501868,1749.785147,22.45525,28.3471326,0.9085808,84.7620513),(23229,'red-deer-tibia.tif',246,8,135,298.5406056,51.829,61.9103244,1.8,51.9212001,61.8865008,-0.540633,23.9254629,15.2545232,11540.0741123,17637.1169206,13.1802827,1156.1893266,482.3344141,1215.8235701,22.3702356,28.304684,0.8374837,84.7620513),(23230,'red-deer-tibia.tif',246,8,136,297.8373204,51.7467485,62.0330813,1.8,51.8165677,62.0164873,-0.5335841,24.3592827,15.3359289,11446.4046632,17500.7808773,12.8415935,1141.1621024,469.8990861,1176.9142534,22.2847401,28.167399,0.895005,84.3831453),(23231,'red-deer-tibia.tif',246,8,137,295.9124089,51.7089686,62.1178738,1.8,51.7749044,62.0917138,-0.5262207,13.6189244,17.8383909,11320.4088324,17270.9632577,12.4418385,968.1906474,831.2263514,1602.7171621,22.2757677,28.0492828,0.9002748,84.1152183),(23232,'red-deer-tibia.tif',246,8,138,294.2207439,51.6224112,62.2465387,1.8,51.6589866,62.2603987,-0.5200277,25.8581059,15.8893851,11183.3938756,17100.8158514,12.1078582,1076.2415104,432.4908367,1060.9838875,22.1715723,27.9929229,0.8812573,83.9582703),(23233,'red-deer-tibia.tif',246,8,139,293.1177801,51.5394257,62.3620894,1.8,51.567954,62.398877,-0.516034,13.7781528,17.1667822,11060.8203248,16959.8045695,11.8945999,987.9431312,802.7796223,1630.9812834,22.0486083,28.0198361,0.8907756,83.9582703),(23234,'red-deer-tibia.tif',246,8,140,292.8774965,51.4518541,62.4779743,1.8,51.4847042,62.5016463,-0.5104203,13.140584,14.5950815,10978.0486489,16837.5206266,11.6504373,1153.6434823,835.4308037,1845.1472534,0.189453,0.4236298,2.0344439,0.91476),(23235,'red-deer-tibia.tif',246,8,141,293.1149522,51.3605622,62.5804908,1.8,51.3890214,62.565829,-0.5025461,13.4846702,15.2008752,10907.4860009,16726.3381537,11.3335234,1100.3536299,808.8804435,1814.928905,0.189453,0.4236298,2.0344439,0.91476),(23236,'red-deer-tibia.tif',246,8,142,292.7063549,51.2732574,62.6886562,1.8,51.2976129,62.715075,-0.4975811,13.3030415,14.546244,10839.8965131,16614.0973225,11.1138941,1142.1572035,814.8434687,1860.2312889,21.8095114,27.8850104,0.8238408,83.5984053),(23237,'red-deer-tibia.tif',246,8,143,293.2845603,51.186694,62.7981425,1.8,51.224836,62.8585042,-0.4924656,25.8496393,14.3936353,10808.2506326,16552.0080644,10.9267948,1149.9532738,418.1199785,998.425645,21.6884368,27.7262378,0.8821822,83.2654683),(23238,'red-deer-tibia.tif',246,8,144,293.4087808,51.1055883,62.8971701,1.8,51.1622768,62.9211821,-0.4885009,13.2766609,14.4922837,10769.9268082,16438.6171128,10.7703013,1134.3013564,811.1924297,1809.0120708,21.6259074,27.7016308,0.8725554,83.1085203),(23239,'red-deer-tibia.tif',246,8,145,291.9550717,51.0502045,62.9699533,1.8,51.0933665,63.0118039,-0.4847134,13.9675645,15.044639,10698.0272736,16240.8155679,10.5645826,1079.5084931,765.919302,1751.1495504,21.5710947,27.5567839,0.8681357,82.9975413),(23240,'red-deer-tibia.tif',246,8,146,290.6681102,50.9555569,63.0730737,1.8,50.9718825,63.0954709,-0.48245,13.2584691,14.464197,10602.7536227,16065.9286602,10.4277419,1110.7376793,799.6966725,1802.8016055,21.5051054,27.5176814,0.848728,82.6836453),(23241,'red-deer-tibia.tif',246,8,147,289.757084,50.8591107,63.1734277,1.8,50.8836492,63.2148054,-0.4791936,25.5644173,14.6947194,10541.2698767,15920.0973446,10.2660814,1083.3889976,412.3414891,948.4570337,0.189453,0.4236298,2.0344439,0.91476),(23242,'red-deer-tibia.tif',246,8,148,289.4912951,50.7641732,63.2703521,1.8,50.8371406,63.3502299,-0.4704702,25.5914912,14.5784309,10517.2870896,15819.4371252,9.9143937,1085.1261844,410.9681223,939.5442062,21.4563831,27.3134463,0.8787223,82.3507083),(23243,'red-deer-tibia.tif',246,8,149,289.4820827,50.6659172,63.3560587,1.8,50.710823,63.4052263,-0.4672558,25.3501282,14.6162832,10449.6374961,15749.4950549,9.7890453,1077.5307787,412.212412,949.6493397,21.3927911,27.3134463,0.8787223,82.3047393),(23244,'red-deer-tibia.tif',246,8,150,289.1209938,50.5768836,63.4352944,1.8,50.6040928,63.4642456,-0.4633196,12.5920863,14.4952645,10377.5034208,15640.9743422,9.6247234,1079.0402877,824.1289925,1740.7828768,21.3090244,27.2687305,0.8591557,82.1477913),(23245,'red-deer-tibia.tif',246,8,151,289.6540183,50.4864052,63.5239119,1.8,50.4878774,63.582358,-0.460925,13.1373559,14.341852,10351.6447532,15574.5234096,9.5502004,1085.9492504,787.9549635,1735.9214769,21.28615,27.220645,0.8938815,81.8798643),(23246,'red-deer-tibia.tif',246,8,152,289.5660818,50.3932037,63.6039977,1.8,50.4003452,63.6531917,-0.4553294,24.9456102,14.3705456,10325.5826286,15479.5824026,9.333065,1077.1743004,413.9238351,937.6605534,21.2556276,27.1453822,0.8644411,81.7688853),(23247,'red-deer-tibia.tif',246,8,153,287.6437046,50.3163182,63.6798631,1.8,50.2913811,63.8139568,-0.4575737,13.8619291,14.4770845,10259.6896887,15296.1806587,9.3562391,1056.578805,740.1343341,1640.2005835,21.1800859,27.0466967,0.8796455,81.6579063),(23248,'red-deer-tibia.tif',246,8,154,285.9849844,50.221645,63.7746309,1.8,50.2436734,63.9771222,-0.4545639,24.2009563,14.3451728,10192.7326191,15114.4819763,9.1888394,1053.6284358,421.1706557,971.1600212,0.378906,0.7811347,1.815775,1.82952),(23249,'red-deer-tibia.tif',246,8,155,284.2349452,50.1246172,63.8443401,1.8,50.1504641,63.9564688,-0.4502616,24.0505038,14.0617085,10113.335162,14930.8563295,8.9723497,1061.8095481,420.5040873,958.8776015,21.1423151,26.8783001,0.8652281,81.5469273),(23250,'red-deer-tibia.tif',246,8,156,283.3042325,50.0256831,63.908275,1.8,50.020414,64.0124176,-0.444727,23.4243699,14.3349177,10052.2919224,14772.5827662,8.73908,1030.5313958,429.1382002,998.2789887,21.0763871,26.7343626,0.8606328,81.1220523),(23251,'red-deer-tibia.tif',246,8,157,283.1362124,49.9266122,63.9703117,1.8,49.9295711,64.0549791,-0.4401756,23.5138113,19.0052035,10007.8799657,14671.0879852,8.5676916,771.9511139,425.6170904,969.4288284,0.378906,1.1523976,1.735945,2.587332),(23252,'red-deer-tibia.tif',246,8,158,282.7603207,49.8319669,64.0317414,1.8,49.8172705,64.1013502,-0.4352483,23.3818098,19.2341494,9957.67509,14556.7539864,8.3780246,756.8181827,425.8727265,972.9484996,21.0411366,26.5403301,0.8915961,80.9460633),(23253,'red-deer-tibia.tif',246,8,159,282.9905108,49.7308077,64.0915652,1.8,49.6823792,64.1785347,-0.4315583,23.1108392,17.5394751,9931.9497644,14470.8844665,8.2521809,825.0466078,429.7528833,988.8894244,20.9655949,26.48889,0.8714793,80.7891153),(23254,'red-deer-tibia.tif',246,8,160,282.6837393,49.6355372,64.1436198,1.8,49.6246221,64.2021896,-0.4225098,22.6173535,18.3881848,9898.3680075,14345.2470177,7.9218208,780.1339388,437.6448386,1002.9815363,20.9278241,26.3441873,0.8668502,80.3642403),(23255,'red-deer-tibia.tif',246,8,161,280.319526,49.5835516,64.1624949,1.8,49.5532369,64.2171678,-0.4152068,12.9101773,17.3602615,9826.4845485,14077.9384149,7.6020203,810.9289374,761.1424933,1368.4538406,20.8932578,26.1005459,0.8779168,80.1882513),(23256,'red-deer-tibia.tif',246,8,162,278.7568454,49.4934757,64.2194783,1.8,49.4984255,64.2433783,-0.4083269,12.858553,13.9891621,9767.5016885,13878.2545039,7.325173,992.0718937,759.6112628,1666.9545196,0.189453,0.7811347,1.815775,1.672572),(23257,'red-deer-tibia.tif',246,8,163,277.4052449,49.400473,64.2645007,1.8,49.40233,64.2652693,-0.3990516,13.1595341,14.178042,9711.1124885,13691.6988641,6.9798358,965.6974385,737.9526038,1614.3069931,20.836497,25.9329257,0.8629624,79.7633763),(23258,'red-deer-tibia.tif',246,8,164,277.0084485,49.3031396,64.3205823,1.8,49.3155555,64.3391784,-0.3943571,12.8127314,13.9705793,9690.2261017,13568.0689214,6.8153751,971.1887144,756.2966697,1633.7316049,0.189453,0.4236298,2.0344439,0.91476),(23259,'red-deer-tibia.tif',246,8,165,276.7701118,49.2035755,64.3671215,1.8,49.205589,64.3371215,-0.387918,13.3176181,13.7892144,9670.6307768,13448.8689352,6.6001418,975.3179935,726.1531822,1656.5286989,20.864252,25.7892788,0.858186,79.3844703),(23260,'red-deer-tibia.tif',246,8,166,276.6362983,49.1040588,64.4209052,1.8,49.127082,64.4198659,-0.3817094,12.6847272,13.8688392,9654.7371396,13351.5197547,6.3977552,962.6991498,761.1308479,1630.3062934,20.7927636,25.7133161,0.8845484,79.5414183),(23261,'red-deer-tibia.tif',246,8,167,277.132049,49.0076827,64.4646525,1.8,49.0514747,64.4559321,-0.3680839,23.0158259,14.6080676,9684.1857697,13257.4430867,5.9803441,907.5425629,420.762036,842.703983,20.8273299,25.6231243,0.9006743,79.1165433),(23262,'red-deer-tibia.tif',246,8,168,277.0155074,48.9130074,64.5106621,1.8,48.9669649,64.4984737,-0.3529584,24.1954945,20.7074682,9686.5012551,13148.5503665,5.516832,634.9665852,400.3431819,723.1942845,20.8320109,25.5670316,0.8798531,79.1165433),(23263,'red-deer-tibia.tif',246,8,169,274.8858132,48.8469357,64.5216924,1.8,48.8691948,64.5022354,-0.3424669,23.945743,20.6611732,9628.9735769,12930.046,5.1664587,625.8137365,402.1163002,713.278027,20.8618961,25.3987167,0.8645972,78.7376373),(23264,'red-deer-tibia.tif',246,8,170,273.0850895,48.7623517,64.5516979,1.8,48.7898411,64.4914909,-0.3254137,22.4917358,16.1883274,9559.901588,12733.8003871,4.6519401,786.6038325,425.0406318,805.5132416,20.8650374,25.1316385,0.8654407,78.5156793),(23265,'red-deer-tibia.tif',246,8,171,271.8045343,48.6795204,64.581173,1.8,48.714064,64.5642151,-0.3057013,23.2970399,20.8682339,9505.6433594,12577.3009216,4.103259,602.7007841,408.0193617,706.0497792,20.8955318,25.0264473,0.4128439,78.5156793),(23266,'red-deer-tibia.tif',246,8,172,271.0417873,48.5968024,64.6119781,1.8,48.6022049,64.5649865,-0.2965867,13.5620269,13.3375967,9441.0367351,12447.5515776,3.8584834,933.2679506,696.1375912,1326.6487376,20.8979514,24.9790745,0.3889569,78.1367733),(23267,'red-deer-tibia.tif',246,8,173,270.6819928,48.520676,64.6392815,1.8,48.5446632,64.5447748,-0.2862243,13.0995417,13.2047523,9423.3223571,12364.4968706,3.5960751,936.3671938,719.3627512,1582.436495,20.8979514,24.9790745,0.3889569,77.8688463),(23268,'red-deer-tibia.tif',246,8,174,270.4946343,48.4380983,64.6752806,1.8,48.4598443,64.6147105,-0.2757365,13.0362692,13.1352767,9405.611244,12276.2368829,3.3416516,934.600554,721.495628,1551.4332206,20.8855615,24.9078464,0.3819188,77.4899403),(23269,'red-deer-tibia.tif',246,8,175,270.6224657,48.3560469,64.7002901,1.8,48.3948846,64.612963,-0.2616239,12.829138,13.3565139,9370.9204899,12219.6677392,3.0174213,914.8845117,730.440384,1530.3240928,20.9017698,24.9078464,0.3819188,77.4899403),(23270,'red-deer-tibia.tif',246,8,176,270.3600267,48.2710994,64.7234984,1.8,48.2727645,64.6435461,-0.2491788,21.189632,16.1525773,9335.8971606,12147.0260626,2.7403506,752.0178237,440.5879793,806.2929699,20.9296606,24.8768454,0.3988919,77.3789613),(23271,'red-deer-tibia.tif',246,8,177,268.1702073,48.2298959,64.7109258,1.8,48.2271506,64.6204843,-0.2410922,13.7007804,18.4531035,9264.4650827,12000.2176728,2.5479723,650.3089136,676.1998108,1148.0814032,20.9556062,24.8378591,0.3748407,77.3789613),(23272,'red-deer-tibia.tif',246,8,178,266.8281781,48.1457041,64.7432434,1.8,48.1375291,64.6695038,-0.230335,14.3840556,18.0198828,9215.9674986,11900.8751104,2.317962,660.4302166,640.7071638,1164.3358798,20.9730175,24.8038767,0.3918534,76.9540863),(23273,'red-deer-tibia.tif',246,8,179,265.2737201,48.0631381,64.7714573,1.8,48.0504861,64.7092644,-0.2203972,13.9847363,17.5421198,9140.9428648,11802.8987531,2.1130597,672.8319529,653.6371269,1183.7447654,21.0034814,24.8038767,0.3918534,77.0000553),(23274,'red-deer-tibia.tif',246,8,180,264.8641656,47.9717714,64.792845,1.8,47.9167674,64.7506174,-0.2082476,13.0270977,25.5977139,9095.690928,11776.7574337,1.8868827,460.0706726,698.2131488,786.84986,21.0120996,24.7691232,0.367723,76.6211493),(23275,'red-deer-tibia.tif',246,8,181,264.3277585,47.885114,64.8100449,1.8,47.844465,64.7461057,-0.1928282,13.3347814,26.8652382,9035.967362,11730.9644076,1.6178685,436.6596082,677.623959,754.4164241,0.339096,0.8472596,2.0344439,1.82952),(23276,'red-deer-tibia.tif',246,8,182,263.4833617,47.8030963,64.8191597,1.8,47.7633237,64.7649186,-0.1847807,12.9745945,27.2159873,8979.9924134,11688.9003161,1.4824042,429.4865433,692.121238,743.6474987,21.001625,24.8038767,0.3918534,76.3072533),(23277,'red-deer-tibia.tif',246,8,183,262.7403556,47.7320682,64.8234212,1.8,47.7648722,64.7627888,-0.1736512,12.801492,13.3710527,8906.8100253,11636.4521594,1.3072587,870.2719552,695.7634353,1503.3992667,21.0131908,24.8378591,0.3748407,76.0852953),(23278,'red-deer-tibia.tif',246,8,184,261.8464489,47.6491221,64.8325756,1.8,47.6625987,64.8014718,-0.1704683,12.7171811,13.4914384,8825.8981287,11606.5498258,1.2559481,860.2900193,694.0137153,1500.1844676,21.0232597,24.8378591,0.3748407,76.1962743),(23279,'red-deer-tibia.tif',246,8,185,258.786836,47.6074073,64.8019157,1.8,47.622928,64.7469574,-0.171293,12.7871256,13.1089473,8715.7334825,11486.8023694,1.2531951,876.2566609,681.60224,1486.8036064,0.189453,0.4236298,2.0344439,0.91476),(23280,'red-deer-tibia.tif',246,8,186,256.6006493,47.5251989,64.8201588,1.8,47.5574417,64.7892592,-0.1702263,13.395038,13.2301287,8620.0912015,11403.3855268,1.2273283,861.9255168,643.5286866,1435.4978757,0.189453,0.4236298,2.0344439,0.91476),(23281,'red-deer-tibia.tif',246,8,187,254.5514521,47.4497099,64.8304809,1.8,47.5086862,64.8423837,-0.1763159,13.8497257,13.1067852,8529.1634029,11329.9840081,1.3052753,864.436538,615.8362681,1399.858355,20.83983,24.8378591,0.3748407,75.9283473),(23282,'red-deer-tibia.tif',246,8,188,253.3389728,47.3673505,64.8317688,1.8,47.3960773,64.7638732,-0.1855071,12.890904,13.1483394,8445.1525569,11289.6161906,1.4364291,858.6343788,655.1249281,1441.0045695,20.83983,24.8378591,0.3748407,76.1962743),(23283,'red-deer-tibia.tif',246,8,189,252.3068694,47.2908201,64.843172,1.8,47.3106842,64.80225,-0.1942369,13.0013684,13.7360524,8371.3837288,11275.4201604,1.5666523,820.8632167,643.8848181,1354.2007561,0.189453,0.4236298,2.0344439,0.91476),(23284,'red-deer-tibia.tif',246,8,190,251.802113,47.2266916,64.8550667,1.8,47.2887771,64.8501935,-0.1995872,22.0540343,25.2891734,8341.4894726,11302.5438747,1.6496783,446.9321198,378.2296416,585.9260544,20.83983,24.9460039,0.3649928,76.0852953),(23285,'red-deer-tibia.tif',246,8,191,251.2617469,47.1597808,64.859049,1.8,47.2120174,64.8514835,-0.2084126,12.5456066,13.488857,8275.7028673,11321.4281567,1.792776,839.3170835,659.6494784,1428.4774756,20.83983,24.9912852,0.3481233,76.3532223),(23286,'red-deer-tibia.tif',246,8,192,251.1358732,47.0997497,64.8673463,1.8,47.1861398,64.8764318,-0.2123545,12.9644757,13.8994654,8248.6036427,11366.9207387,1.8592696,817.7955321,636.2466061,1341.2951165,20.83983,25.056547,0.3552309,76.0852953),(23287,'red-deer-tibia.tif',246,8,193,249.1069497,47.0762147,64.8313996,1.8,47.1493651,64.8737629,-0.2188217,12.9296307,14.7129616,8190.1722193,11346.4277861,1.9564661,771.1858499,633.4420841,1207.6445206,20.650377,25.0837489,0.3791039,75.9283473),(23288,'red-deer-tibia.tif',246,8,194,247.6034698,47.0218839,64.8466326,1.8,47.0591245,64.8854299,-0.2326766,12.9019686,13.5549284,8136.0245676,11318.5019186,2.194115,835.0100877,630.6033462,1363.0913767,20.650377,25.1059181,0.3384554,75.8173683),(23289,'red-deer-tibia.tif',246,8,195,246.0383963,46.9818881,64.8533005,1.8,46.9926245,64.877787,-0.2399699,13.2328006,13.9984859,8092.9002923,11286.51352,2.3163956,806.266735,611.5788006,1384.2894887,20.650377,25.0837489,0.3791039,75.9283473),(23290,'red-deer-tibia.tif',246,8,196,245.2633589,46.9453614,64.8720815,1.8,46.9562072,64.9174763,-0.2491226,12.97205,13.8258787,8073.3213605,11300.8110186,2.4848763,817.3665667,622.3627996,1393.2961812,20.650377,25.1252109,0.4029116,75.9283473),(23291,'red-deer-tibia.tif',246,8,197,244.6083436,46.900666,64.8872179,1.8,46.9042285,64.9490188,-0.2568904,13.1695804,13.4048303,8059.9675772,11336.9965311,2.6317305,845.7396543,612.0139999,1434.2176281,20.650377,25.1908381,0.3693337,75.8173683),(23292,'red-deer-tibia.tif',246,8,198,244.0272777,46.8648188,64.8856984,1.8,46.8748823,64.9011877,-0.2630854,12.7190835,13.644411,8060.1198753,11375.9342902,2.7506648,833.743155,633.7028834,1384.1956703,20.650377,25.2000978,0.4098276,75.8173683),(23293,'red-deer-tibia.tif',246,8,199,243.3544141,46.8304431,64.8868865,1.8,46.8147138,64.9413895,-0.2654749,12.2447363,14.0334292,8056.5606461,11393.5943475,2.7919535,811.8895373,657.961141,1385.832179,0.189453,0.4236298,2.677945,0.803781),(23294,'red-deer-tibia.tif',246,8,200,241.5993717,46.8220023,64.8697097,1.8,46.8325514,64.9294727,-0.2678081,12.7289446,13.9333821,8041.2215145,11342.9184948,2.8195798,814.0822072,631.7272761,1377.2154917,20.7768471,25.2000978,0.4098276,75.9743163),(23295,'red-deer-tibia.tif',246,8,201,237.8205722,46.8554806,64.7912625,1.8,46.8332281,64.7978137,-0.2678174,12.5951929,14.5345421,7969.7791785,11183.3458807,2.775667,769.4322787,632.7635664,1306.5678881,0.189453,0.4236298,2.677945,0.803781),(23296,'red-deer-tibia.tif',246,8,202,234.8890953,46.8457573,64.7627644,1.8,46.789714,64.767585,-0.2623853,12.7223589,14.8879077,7910.1502831,11041.0270677,2.6339109,741.6103909,621.7518583,1262.4938428,20.8780314,25.0515329,0.3959546,75.9093063),(23297,'red-deer-tibia.tif',246,8,203,232.139158,46.8330142,64.7300342,1.8,46.7367281,64.7816927,-0.2576468,12.8948634,14.373346,7868.6607312,10921.5786863,2.5119758,759.8494258,610.2166818,1290.1511655,20.9073022,25.0264473,0.4128439,75.6873483),(23298,'red-deer-tibia.tif',246,8,204,230.0275405,46.8363375,64.6882966,1.8,46.8075459,64.7209002,-0.2511408,12.8570102,13.4768015,7838.1307838,10828.1978064,2.3676275,803.4694165,609.6386862,1359.8337789,20.953135,24.9790745,0.3889569,75.6873483),(23299,'red-deer-tibia.tif',246,8,205,228.9422728,46.8245905,64.6563678,1.8,46.7875237,64.6977741,-0.2462936,12.6715861,13.4778945,7844.4872499,10793.4414336,2.2682025,800.8254865,619.0611958,1371.2148973,20.9736997,25.0085136,0.2762185,75.5763693),(23300,'red-deer-tibia.tif',246,8,206,228.1553148,46.8125225,64.6113351,1.8,46.7572001,64.6118557,-0.2396487,12.4328601,13.7523783,7846.2648849,10781.4948601,2.1423947,783.9731174,631.0909013,1354.1051507,20.9944362,24.9912852,0.3481233,75.7333173),(23301,'red-deer-tibia.tif',246,8,207,227.2579929,46.7968847,64.5797782,1.8,46.7234534,64.6460298,-0.2345153,12.476031,13.574669,7848.4768079,10779.20729,2.045191,794.0677803,629.084429,1367.9467153,21.0262961,24.9912852,0.3481233,75.7333173),(23302,'red-deer-tibia.tif',246,8,208,226.3118138,46.7711458,64.543285,1.8,46.6744241,64.6005379,-0.2379863,13.0805402,13.5991044,7850.6216099,10777.2122998,2.0962611,792.494267,600.1756438,1348.2002899,21.0656856,24.9912852,0.3481233,75.7792863),(23303,'red-deer-tibia.tif',246,8,209,223.2650569,46.7937581,64.4663284,1.8,46.7141732,64.4871882,-0.2394395,13.0401644,13.6380037,7808.5834308,10685.8614866,2.092887,783.5356027,598.8102004,1353.4824123,21.1045442,25.0085136,0.2762185,76.0472133),(23304,'red-deer-tibia.tif',246,8,210,220.987301,46.7710876,64.4270478,1.8,46.7034165,64.4463728,-0.2340797,13.40318,13.4621521,7779.1370825,10623.9771086,1.9815132,789.1737538,580.3948813,1348.3297021,21.1673954,25.0142538,0.3720678,76.0472133),(23305,'red-deer-tibia.tif',246,8,211,218.5640393,46.7625005,64.3834592,1.8,46.7071543,64.4001879,-0.2295614,13.5424349,13.5048036,7748.7713015,10565.2476396,1.8861788,782.3325652,572.1844972,1350.9741083,21.2114261,25.056547,0.3552309,76.0472133),(23306,'red-deer-tibia.tif',246,8,212,217.3522126,46.7539023,64.3407383,1.8,46.6977596,64.3374897,-0.224123,13.3406713,13.7158941,7762.1455991,10546.1694504,1.7893768,768.9013472,581.8407062,1315.0206531,21.2697604,25.060844,0.2834917,76.0472133),(23307,'red-deer-tibia.tif',246,8,213,216.1223201,46.745197,64.3041575,1.8,46.7097948,64.3377551,-0.220572,13.6421088,13.2732691,7784.0836257,10547.0680225,1.7242284,794.6096761,570.5924027,1336.1123889,21.3203331,25.060844,0.2834917,76.0472133),(23308,'red-deer-tibia.tif',246,8,214,215.1671353,46.7368658,64.2622499,1.8,46.6859479,64.3053803,-0.2162047,13.4932893,13.5523424,7818.2382251,10558.1661094,1.650355,779.0657742,579.4167804,1239.0928294,21.3607254,25.1623256,0.3217506,76.1581923),(23309,'red-deer-tibia.tif',246,8,215,214.3359861,46.7235326,64.2255986,1.8,46.6501758,64.2977943,-0.2094509,14.0492796,13.2796803,7840.8805504,10580.7815256,1.5443582,796.7647752,558.0984044,1293.7558927,21.399546,25.1694567,0.3455556,76.2691713),(23310,'red-deer-tibia.tif',246,8,216,213.4390014,46.7130347,64.1847293,1.8,46.6479039,64.2370491,-0.205347,13.5563394,13.2431617,7884.7072559,10594.9229068,1.4790613,800.0297173,581.6250993,1352.4430447,21.4564122,25.1694567,0.2979455,76.5370983),(23311,'red-deer-tibia.tif',246,8,217,210.5605692,46.7477422,64.07778,1.8,46.7089615,64.0742726,-0.2017912,13.3527172,13.8364409,7868.9325208,10526.3381372,1.4097023,760.769203,589.3132008,1304.8347662,21.5248674,25.1694567,0.2979455,76.4261193),(23312,'red-deer-tibia.tif',246,8,218,208.6950433,46.7450266,64.0460191,1.8,46.7065498,64.0583293,-0.1958226,13.1132862,13.7358898,7869.9911395,10503.2199561,1.3168259,764.655228,600.1539987,1328.8772254,21.5484803,25.1908381,0.3693337,76.6480773),(23313,'red-deer-tibia.tif',246,8,219,207.0857134,46.7512936,63.9929081,1.8,46.7015358,64.0050341,-0.1880567,13.1657222,13.7992261,7885.9819574,10498.6332198,1.2062876,760.8131917,598.978303,1327.0052493,21.5905209,25.2427905,0.2813924,76.9160043),(23314,'red-deer-tibia.tif',246,8,220,206.5452385,46.7615,63.9505152,1.8,46.7357035,63.9769393,-0.182734,13.2395507,13.788907,7948.8122635,10550.7068285,1.1367462,765.1590415,600.3838377,1335.6446414,21.6547293,25.3003115,0.3596471,77.1839313),(23315,'red-deer-tibia.tif',246,8,221,206.4559533,46.7650306,63.9112712,1.8,46.7193081,63.9797541,-0.1765571,13.2755539,13.9393655,8025.3747594,10642.4644435,1.061522,763.4827037,604.5227805,1261.9590564,21.7075916,25.3229998,0.2649397,77.4058893),(23316,'red-deer-tibia.tif',246,8,222,206.0173695,46.7684038,63.8709442,1.8,46.708265,63.9598398,-0.1665497,13.3733517,14.2727896,8097.591025,10723.103243,0.9436715,751.2969475,605.5019854,1242.6473072,21.7499308,25.3676081,0.3666376,77.6738163),(23317,'red-deer-tibia.tif',246,8,223,205.8433673,46.7741507,63.8303222,1.8,46.7126865,63.8960177,-0.1584979,13.3753577,14.2137101,8201.1466502,10838.2111134,0.8546586,762.518095,613.1534462,1262.6494673,21.8373627,25.4777307,0.35703,78.0527223),(23318,'red-deer-tibia.tif',246,8,224,205.9298137,46.7729218,63.8044898,1.8,46.7098521,63.9257943,-0.147132,13.4956619,13.9982369,8311.3431177,10956.6014541,0.7376432,782.712959,615.8529434,1376.2079422,21.9076388,25.54456,0.363979,78.3666183),(23319,'red-deer-tibia.tif',246,8,225,204.218125,46.8341306,63.7107752,1.8,46.8110875,63.7919009,-0.1368798,13.3041977,14.0165025,8365.1210808,11007.8083297,0.6337354,785.3462976,628.7580268,1374.3904283,21.966588,25.6490257,0.3942229,78.5885763),(23320,'red-deer-tibia.tif',246,8,226,202.9447156,46.8482705,63.6772254,1.8,46.8437209,63.7560072,-0.1232255,13.5097648,14.0317422,8397.5219963,11090.6874316,0.5110085,790.3998878,621.5890608,1384.6490903,0.189453,0.4236298,2.0344439,0.91476),(23321,'red-deer-tibia.tif',246,8,227,202.3119646,46.850659,63.6179355,1.8,46.8126714,63.6294498,-0.1156545,13.1343933,14.2042989,8441.7972425,11251.8039337,0.4490123,792.1407452,642.7245688,1314.5923525,21.9401368,25.8726495,0.4145069,79.3004193),(23322,'red-deer-tibia.tif',246,8,228,202.2568751,46.8591326,63.5634189,1.8,46.8291244,63.5638968,-0.1029734,13.1728952,14.2523888,8501.7427267,11458.5176385,0.3561779,803.9717296,645.3966704,1368.2221513,21.787095,26.0461704,0.4115775,79.5683463),(23323,'red-deer-tibia.tif',246,8,229,203.2280049,46.8628781,63.5088542,1.8,46.8291353,63.556682,-0.0898891,13.1091155,14.4196245,8631.5696435,11735.1698346,0.2729461,813.8332491,658.440276,1409.4359087,22.0195448,26.2000553,0.4248322,80.2151793),(23324,'red-deer-tibia.tif',246,8,230,204.3278688,46.8715102,63.4719046,1.8,46.8874085,63.5970543,-0.0718566,13.5947783,14.5053322,8818.5929278,12031.2367459,0.1755342,829.4354507,648.6750091,1437.356857,22.1549031,26.4393863,0.4444192,81.2868873),(23325,'red-deer-tibia.tif',246,8,231,205.8559079,46.8717999,63.4412599,1.8,46.8513118,63.5693165,-0.0551021,13.3657888,14.5695451,9043.6938233,12371.0033072,0.1040661,849.1001775,676.6300097,1463.9289173,22.2590069,26.6044902,0.3037345,81.7767723),(23326,'red-deer-tibia.tif',246,8,232,207.7409679,46.8744011,63.4083982,1.8,46.8783985,63.5242929,-0.038702,13.3302857,14.7319695,9309.0217351,12743.409252,0.0518347,865.0173523,698.3362504,1490.3485035,22.4330794,26.8569257,0.2860514,82.5805533),(23327,'red-deer-tibia.tif',246,8,233,207.5735025,46.9085913,63.3129497,1.8,46.9858759,63.3519038,-0.0177607,13.2354156,17.8831502,9528.9434866,13044.9092333,0.0109117,729.4525341,719.9580083,1078.0478595,22.6036603,27.1473655,0.2974728,83.2923963),(23328,'red-deer-tibia.tif',246,8,234,208.455619,46.9033371,63.294753,1.8,46.9879232,63.3548585,0.0052449,14.0004598,14.8896415,9791.2332449,13421.3506639,0.0009557,901.3884361,699.3508332,1534.5544846,22.8742247,27.402659,0.280199,84.6780003),(23329,'red-deer-tibia.tif',246,8,235,210.5100587,46.9302925,63.2744971,1.8,47.0256847,63.3298955,0.025218,14.0117283,15.059099,10133.0047438,13877.6789478,0.0223076,921.5477625,723.1802183,1531.619478,23.0333393,27.7385331,0.3195907,85.4358123),(23330,'red-deer-tibia.tif',246,8,236,213.5855513,46.9628848,63.2399419,1.8,47.0531134,63.2645317,0.0401865,14.0294481,15.3027491,10540.0361736,14434.0036068,0.0574576,943.2294505,751.2794609,1595.8262955,23.3868549,28.0544008,0.2875758,86.5534893),(23331,'red-deer-tibia.tif',246,8,237,217.4306104,46.9978674,63.2111597,1.8,47.073988,63.2544258,0.0468234,13.8816138,15.4753264,10942.9312149,15101.1011617,0.0793923,975.81794,788.3039661,1641.1771248,23.6616657,28.3654862,0.2773822,87.8931243),(23332,'red-deer-tibia.tif',246,8,238,228.1821906,47.0580292,63.189421,1.8,47.1779504,63.2578105,0.0595796,14.0416358,15.6973348,11587.2543117,16011.5605739,0.1348377,1020.0177803,825.2068693,1716.0128009,23.9772981,28.7300961,0.2737707,88.9188633),(23333,'red-deer-tibia.tif',246,8,239,226.0874426,47.0862933,63.0991514,1.8,47.1874745,63.1259752,0.0638661,14.3159351,15.513601,11937.1310253,16594.2127375,0.153488,1069.6557617,833.8352314,1795.8523096,24.2084267,29.1462219,0.2765139,89.5847373),(23334,'red-deer-tibia.tif',246,8,240,232.1043206,47.1332875,63.060091,1.8,47.1434534,63.0826261,0.0672509,13.8365106,16.1864374,12473.9718937,17420.2209901,0.1746925,1076.2232965,901.5258463,1783.6916001,24.4610019,29.5109157,0.2730087,90.4994973),(23335,'red-deer-tibia.tif',246,8,241,236.8301367,47.24389,62.9880771,1.8,47.2820178,63.0113481,0.064134,14.3757492,16.3594423,12996.5873487,18198.0650637,0.1621312,1112.3890841,904.0633061,1897.8177157,24.7180806,29.979104,0.2817719,92.4859653),(23336,'red-deer-tibia.tif',246,8,242,241.5082049,47.2972642,62.985343,1.8,47.3589285,63.0325209,0.0473048,13.8959516,16.5645373,13407.5802422,19082.8807917,0.0900048,1152.0322266,964.8551369,1925.8089286,24.8451272,30.5601255,0.3021452,93.3737973),(23337,'red-deer-tibia.tif',246,8,243,247.2747168,47.3985249,63.0315377,1.8,47.470819,63.1196039,0.0151839,14.2325357,16.8880361,13811.6192088,20199.2407849,0.0095008,1196.0680709,970.4257571,2004.8036842,24.787153,31.1763894,0.283308,94.6405353),(23338,'red-deer-tibia.tif',246,8,244,253.9982626,47.5382796,63.036408,1.8,47.5272452,63.1519822,-0.0235256,17.4721467,33.3703223,14299.6876388,21490.2823884,0.0234248,643.9938525,818.42763,950.3069762,24.9853513,31.8286678,0.2897464,96.0451803),(23339,'red-deer-tibia.tif',246,8,245,262.3543269,47.6666005,63.0219244,1.8,47.6261731,63.1567689,-0.0438203,14.6031635,17.7437892,14864.5327147,22992.2679593,0.0839093,1295.7924424,1017.8981214,2071.8387028,25.3558662,32.5556115,0.2830958,98.4105543),(23340,'red-deer-tibia.tif',246,8,246,272.5097772,47.8512928,62.9219649,1.8,47.8234125,62.9882334,-0.0677079,14.8824517,17.5835091,15566.8650968,24769.2694811,0.2078956,1408.6647552,1045.9879483,2242.1887178,25.675333,33.440467,0.3468349,100.6189803),(23341,'red-deer-tibia.tif',246,8,247,282.3103056,48.0196179,62.850531,1.8,47.9793866,62.8940943,-0.0872099,15.0344941,18.5876781,16296.3178024,26816.6544316,0.3569491,1442.7113624,1083.9285747,2311.1342983,0.189453,0.267927,2.3561945,0.535854),(23342,'red-deer-tibia.tif',246,8,248,303.3646256,48.1996604,62.732132,1.8,48.0497024,62.6584075,-0.1194623,15.482508,18.26861,17260.3575589,30024.8832222,0.718139,1643.5231333,1114.8295613,2539.9942476,26.6763082,35.9511716,0.3050854,107.6881743),(23343,'red-deer-tibia.tif',246,8,249,317.9965917,48.3602496,62.5437427,1.8,48.1483705,62.4639403,-0.1380827,15.737348,19.8012992,18295.5230234,33428.8669089,1.0041255,1688.215841,1162.5543878,2593.2923244,27.2759209,37.110066,0.2846109,112.6599214),(23344,'red-deer-tibia.tif',246,8,250,341.8278444,48.471387,62.4288589,1.8,48.3311509,62.3815552,-0.1398832,16.7531451,19.5187094,19656.0187375,37250.5132144,1.1075233,1908.4516533,1173.2733535,2899.111653,27.910202,38.1511493,0.2714785,116.2079824),(23345,'red-deer-tibia.tif',246,8,251,379.4876273,48.52979,62.2878603,1.8,48.3320746,62.1866037,-0.1381361,16.6399562,20.2130283,21175.3750766,41684.6964909,1.1992134,2062.2687417,1272.5619491,3095.692192,28.4249607,39.1952571,0.2391171,120.1349494),(23346,'red-deer-tibia.tif',246,8,252,407.3845471,48.5925944,62.1311132,1.8,48.3080325,62.0791838,-0.1247092,17.3184613,21.3114502,22689.0140923,46906.0079084,1.0505034,2200.9768213,1310.1056576,3233.7804795,29.0237282,40.4143704,0.4615512,123.2312074),(23347,'red-deer-tibia.tif',246,8,253,420.5836436,48.4894067,62.0553153,1.8,48.1648287,62.0414454,-0.1016438,17.7022681,22.2612006,24264.1891325,51783.5684241,0.7217169,2326.1803932,1370.6825007,3402.5668481,29.6612046,41.8009058,0.4251271,129.4775794),(23348,'red-deer-tibia.tif',246,8,254,431.0385782,48.335688,62.020417,1.8,47.9789399,62.0230911,-0.0850836,19.1672842,23.1776486,25797.5668821,56991.7338402,0.5188098,2458.9092224,1345.9166453,3571.028883,30.4018253,43.1495584,0.4302612,133.2016294),(23349,'red-deer-tibia.tif',246,8,255,474.3086757,48.1525189,62.2484221,1.8,47.7710333,62.0532005,-0.0984664,17.3210964,23.7924876,27472.254229,66587.2260158,0.7639811,2798.6659925,1586.057467,3952.8627566,31.0181087,43.9567706,0.2083841,136.7496904),(23350,'red-deer-tibia.tif',246,8,256,515.4899202,47.8729164,62.3345244,1.8,47.6238634,62.0142238,-0.1049334,22.5476871,23.7703341,29503.4994919,74270.8952131,0.9425437,3124.5204539,1308.4933906,4190.2346858,31.7105376,44.5387846,0.1623515,138.1352944),(23351,'red-deer-tibia.tif',246,8,257,462.3386886,48.5734089,62.0692644,1.8,47.955651,61.8573223,-0.1311871,18.1197027,23.995926,28910.7032233,63047.9257947,1.3185554,2627.4429115,1595.5395988,3827.6094204,32.1062354,44.1234369,0.5463104,158.3027166),(23352,'red-deer-tibia.tif',246,8,258,370.6118839,50.5887127,61.2778181,1.8,49.6323506,61.3232456,-0.1970089,19.5322361,24.6972271,26440.2745303,38738.680838,2.366541,1568.5437332,1353.6737132,2618.7847414,32.3051287,43.3031707,0.6049913,140.8953485),(23353,'red-deer-tibia.tif',246,8,259,293.2143525,51.8490836,59.8789032,1.8,51.1635594,59.9513981,-0.8236046,19.8693864,23.5528483,19825.205665,23856.5976626,26.2998238,1012.8965003,997.7764404,1767.8193302,32.3328751,35.7122674,2.2471943,236.325244),(23354,'red-deer-tibia.tif',246,8,260,251.1075073,52.5488272,58.5548458,1.8,51.8071406,58.793417,-1.2243122,17.1673841,19.838739,14457.1090036,18481.6231142,37.0248235,931.5926326,842.1264946,1330.6642562,29.3315539,35.5086679,2.2313715,233.079925),(23355,'red-deer-tibia.tif',246,8,261,198.6671961,53.390315,56.3715185,1.8,52.6452806,56.6948802,-1.1646298,16.8453684,18.4116831,11585.2528738,13226.6140156,27.9426527,718.38158,687.7411423,1151.3686481,0.9377445,2.411343,2.3561945,5.802456),(23356,'red-deer-tibia.tif',246,8,262,159.5122647,54.0374135,54.1242598,1.8,53.4049236,54.3779379,-0.0664042,23.1935797,16.1910559,6921.2164157,10109.3563322,0.1170564,624.3790657,298.4108758,730.3750006,15.7997395,29.5504171,2.9152743,93.2437773),(23357,'red-deer-tibia.tif',246,8,263,124.5820365,53.9934444,52.701586,1.8,53.5964749,52.9809369,0.00376,23.4498035,15.1612976,1835.8942203,8574.5898867,0.0002935,565.5577851,78.2903881,440.9715702,10.776614,19.5439847,0.205,52.7802662),(23358,'red-deer-tibia.tif',246,8,264,108.9365005,54.124913,52.3970447,1.8,53.7100157,52.3309363,0.0119901,7.220187,14.1846806,792.7844391,7630.2348718,0.0026101,537.9208113,109.8010947,582.7255227,9.4342641,16.7245263,3.0622143,46.6639142),(23359,'red-deer-tibia.tif',246,8,265,95.4128385,54.2385625,52.3050376,1.8,53.7801476,52.2674974,0.0096721,6.9197557,13.7760977,602.8175581,6513.6166694,0.0014877,472.8201563,87.1154399,516.5761798,8.8897092,15.2141494,0.0872777,42.8019571),(23360,'red-deer-tibia.tif',246,8,266,83.8476964,54.2489494,52.285875,1.8,53.7959339,52.263626,-0.0013123,6.2371909,13.515801,483.5608194,5588.4613973,0.0000241,413.4761524,77.5286226,448.8363183,8.6698583,14.1012096,0.1076899,39.7707091),(23361,'red-deer-tibia.tif',246,8,267,68.0721754,54.4499674,52.3468167,1.8,53.9241389,52.3804668,-0.0436286,5.8409659,12.8209712,327.1693516,4457.6231426,0.0215817,347.6821752,56.0128846,373.1953723,7.957026,12.9328561,0.0880074,35.5567741),(23362,'red-deer-tibia.tif',246,8,268,47.6354991,55.0508642,52.3816184,1.8,54.24748,52.5176613,-0.1118417,4.5913913,12.2322925,153.2923056,3178.8979641,0.0988953,259.8775312,33.3868962,271.9587478,6.630855,11.0923073,3.0045265,29.9572351),(23363,'red-deer-tibia.tif',246,8,269,24.9220566,57.382523,51.8986561,1.8,55.3052201,52.3256411,-0.149374,3.5794519,13.779069,52.1651484,1534.7074031,0.091992,111.3796156,14.5735019,115.1648167,4.546872,8.6590592,0.1759396,22.1492701),(23364,'red-deer-tibia.tif',246,8,270,8.8908074,63.0069678,50.8357444,1.8,62.9980894,50.9813056,-1.0401828,2.112433,3.3150904,7.3422488,17.108121,1.1023129,5.16068,3.475731,7.3671462,4.0495884,6.5683112,0.9907936,17.2234921),(23365,'red-deer-tibia.tif',246,8,271,1.8518541,62.5218634,50.8982461,1.8,62.6321603,50.8819013,-0.9353754,1.2886234,1.9535027,0.5946906,1.4017661,0.1999195,0.7175655,0.461493,0.9922172,2.6300149,4.098495,0.9827937,11.0690581),(23366,'red-deer-tibia.tif',246,8,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23367,'red-deer-metatarsus.tif',246,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23368,'red-deer-metatarsus.tif',246,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23369,'red-deer-metatarsus.tif',246,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23370,'red-deer-metatarsus.tif',246,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23371,'red-deer-metatarsus.tif',246,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23372,'red-deer-metatarsus.tif',246,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23373,'red-deer-metatarsus.tif',246,10,7,1.4300309,44.1312204,72.506314,1.8,44.000622,72.6822437,-0.7644794,1.4669842,6.3102247,0.4502593,19.3482323,0.114185,3.0661717,0.3069285,3.109552,0,0,0,0),(23374,'red-deer-metatarsus.tif',246,10,8,17.7477127,44.5149303,72.5184861,1.8,44.5696369,72.5138764,-0.707288,2.783889,7.3545477,14.1219322,285.642585,1.2488685,38.8389058,5.0727354,40.7518862,4.7979835,14.9187471,0.7044941,35.8975982),(23375,'red-deer-metatarsus.tif',246,10,9,43.1540561,45.8276992,71.6755311,1.8,47.0509509,70.7121418,-0.5443501,5.472619,15.3739216,102.4307675,1355.1909784,1.9288516,88.1486855,18.7169556,93.2646096,9.4901887,25.0880413,0.4366272,72.4610703),(23376,'red-deer-metatarsus.tif',246,10,10,91.2272798,48.3796834,69.8683373,1.8,48.1551455,69.3452321,-0.4364844,6.9413172,16.2297417,415.8472331,5637.0476063,2.7173976,347.3282388,59.9089796,370.6969903,11.9054959,29.6643714,0.5437054,87.9279394),(23377,'red-deer-metatarsus.tif',246,10,11,135.3123858,48.3904,68.5548052,1.8,48.5359304,68.0362268,-0.4426879,8.0277232,16.0016897,1137.6257131,9772.1978953,4.1383197,610.6978744,141.7121243,680.2768441,14.2309696,30.5483783,0.5191461,86.4234693),(23378,'red-deer-metatarsus.tif',246,10,12,171.8581326,48.453782,66.8512727,1.8,48.3722424,65.6275606,-0.5070349,22.6262704,25.5126874,3215.6317142,14209.3968839,6.7538831,556.9541412,142.1193888,663.5030852,19.640278,31.3703506,0.5963776,101.7635854),(23379,'red-deer-metatarsus.tif',246,10,13,276.6568114,48.005429,61.9588706,1.8,47.7436046,61.1465646,-0.8204123,17.6429636,19.1756481,14055.1949498,28715.0829714,24.6679,1497.4765258,796.6459173,2013.904268,31.6886543,39.2867238,1.3223089,152.8141566),(23380,'red-deer-metatarsus.tif',246,10,14,376.7984788,46.6502175,58.8043112,1.8,45.9632523,59.1136141,-1.0309098,18.18181,20.884835,24855.3206399,39460.2633481,46.205809,1889.4218428,1367.0432484,3044.2725456,32.407886,39.5816242,1.2944691,137.1522575),(23381,'red-deer-metatarsus.tif',246,10,15,440.2462832,45.2445956,57.1417766,1.8,45.3775442,58.2068703,-1.4508877,18.2088627,21.8826016,32586.2728884,41476.7943982,72.3244434,1895.4233697,1789.5830994,3339.0419241,32.3654162,39.900439,1.2520488,123.9397835),(23382,'red-deer-metatarsus.tif',246,10,16,441.1812812,44.9353761,56.9434658,1.8,45.2165528,57.9536951,1.5103655,17.5067072,21.8688851,31978.2914556,40728.812286,73.2620168,1862.4091765,1826.6308493,3150.9431563,32.1298962,39.6722001,1.2248813,145.4881895),(23383,'red-deer-metatarsus.tif',246,10,17,417.4968068,45.0213323,57.1517854,1.8,45.2447999,58.0887038,1.4295835,17.1163415,20.3568691,28887.9366001,38084.6736435,68.2044447,1870.8512335,1687.7401437,3065.3671222,30.9600098,38.9416943,1.2490458,123.1629305),(23384,'red-deer-metatarsus.tif',246,10,18,392.7980774,45.0919371,57.4411724,1.8,45.2246353,58.3128747,1.4075014,16.1647046,20.1870364,25625.3646664,35724.8250641,63.7361316,1769.6914174,1585.2665015,2825.8795982,29.7337772,37.8038259,1.2442915,139.4716625),(23385,'red-deer-metatarsus.tif',246,10,19,374.6596483,45.2139231,57.6524216,1.8,45.2558713,58.5888,1.4162311,16.1539809,19.9892778,23087.2492047,33837.8972763,60.9633213,1692.8023898,1429.1987452,2675.5473884,0.5941395,1.339635,2.3561945,3.058176),(23386,'red-deer-metatarsus.tif',246,10,20,356.6606559,45.2547504,57.7651955,1.8,45.320049,58.6214327,1.4094453,15.5251026,19.4123702,21034.8699528,31793.5369804,57.9092665,1637.7977863,1354.8941036,2500.4199441,0.568359,0.947265,2.2142974,2.522322),(23387,'red-deer-metatarsus.tif',246,10,21,336.943014,45.349473,57.9406442,1.8,45.4378513,58.715931,1.4051178,14.9919738,19.0170612,19239.6205095,29753.1125549,54.6297433,1564.5483908,1283.3280524,2337.9374052,0.378906,1.198206,1.8925469,2.901228),(23388,'red-deer-metatarsus.tif',246,10,22,321.6366941,45.43517,58.1496124,1.8,45.563995,58.9072909,1.4002954,14.4319763,18.3287922,17652.1207401,28127.6489736,52.0627983,1534.6155222,1223.1256776,2247.6470346,0.378906,0.8472596,2.0344439,1.82952),(23389,'red-deer-metatarsus.tif',246,10,23,307.728722,45.4502271,58.3527103,1.8,45.5651684,59.0050423,1.4091123,14.192195,27.4947138,16197.3520566,26630.2266517,49.9590026,968.5580603,1141.2859025,1550.553332,0.267927,0.535854,2.3561945,1.071708),(23390,'red-deer-metatarsus.tif',246,10,24,296.7211308,45.4690214,58.5552965,1.8,45.585663,59.1995627,1.4120989,23.4580383,27.2837064,15076.8877404,25205.7853196,48.2184613,923.8402207,642.7173295,1223.7660484,24.4328111,33.8124513,1.6437006,107.4281344),(23391,'red-deer-metatarsus.tif',246,10,25,288.4076697,45.591475,58.7199751,1.8,45.7458349,59.3735442,1.4093144,23.6166296,26.8441723,14048.6707714,23688.5587334,46.8253624,882.446979,594.8634916,1148.5108209,0.339096,0.6830825,2.1587989,1.450614),(23392,'red-deer-metatarsus.tif',246,10,26,281.3198374,45.6463504,58.904265,1.8,45.7832738,59.5005848,1.4052943,24.4794973,26.7754487,13284.2498161,22558.5150274,45.6140542,842.5074514,542.6684072,1079.465107,0.64497,2.2174905,1.9195673,5.48856),(23393,'red-deer-metatarsus.tif',246,10,27,276.249182,45.6852319,59.0430852,1.8,45.8126661,59.6152908,1.4023878,24.154361,25.9703062,12670.443612,21551.9714611,44.7480244,829.8697486,524.5613249,1045.3992018,23.053093,32.1601699,2.1718701,98.7704193),(23394,'red-deer-metatarsus.tif',246,10,28,272.6933725,45.715985,59.1105887,1.8,45.8515953,59.7051716,1.3972155,24.4735609,26.4531249,12174.333098,20741.6084419,44.0932048,784.0891582,497.4483752,989.6872575,1.2604306,7.5425139,1.773118,17.5564291),(23395,'red-deer-metatarsus.tif',246,10,29,270.8561364,45.7226279,59.2001624,1.8,45.8381816,59.7488105,1.391814,24.3954767,21.7454518,11727.3867919,20050.5985998,43.7119346,922.0594179,480.7197232,973.7249758,0.8732519,4.0500426,1.7590178,9.21261),(23396,'red-deer-metatarsus.tif',246,10,30,269.8258059,45.7067262,59.2455249,1.8,45.8063132,59.731689,1.3821193,12.7946969,17.0569666,11322.3342163,19520.5103582,43.3889522,1144.4303538,884.9239897,1763.0707679,0.189453,0.4236298,2.0344439,0.91476),(23397,'red-deer-metatarsus.tif',246,10,31,267.9975973,45.704338,59.3153489,1.8,45.8114201,59.7700053,1.3789288,12.6604763,26.1294593,10934.5237683,18940.8025618,43.0420389,724.8830649,863.6739685,1143.1699369,0.6994983,6.0536089,1.9222411,13.250556),(23398,'red-deer-metatarsus.tif',246,10,32,261.4703288,45.6991445,59.3497935,1.8,45.8017993,59.7369284,1.3768075,12.4027174,25.69587,10519.2005509,18264.0140089,41.9589285,710.7762447,848.1367612,1117.9446378,21.6675416,30.6451574,2.1313616,91.3873293),(23399,'red-deer-metatarsus.tif',246,10,33,258.380055,45.8024407,59.3403556,1.8,45.9531542,59.7216276,1.3688278,12.7875264,25.3754968,10118.5030103,17549.8452246,41.3304891,691.6059771,791.2791516,1088.5183601,0.378906,0.6830825,2.1587989,1.450614),(23400,'red-deer-metatarsus.tif',246,10,34,256.5686615,45.8153359,59.4268051,1.8,45.9327703,59.7930641,1.3649618,12.3527487,15.7375934,9801.7567423,17068.4006978,40.9751751,1084.5623096,793.4879102,1683.884035,0.267927,0.535854,2.3561945,1.071708),(23401,'red-deer-metatarsus.tif',246,10,35,255.2155274,45.8395514,59.5189163,1.8,45.9246694,59.8098593,1.3616116,12.3257579,15.7869973,9503.91332,16632.7494249,40.7016147,1053.5727048,771.0611712,1638.1732718,0.378906,0.6830825,2.1587989,1.450614),(23402,'red-deer-metatarsus.tif',246,10,36,254.7986313,45.8550819,59.6090507,1.8,45.950053,59.881248,1.3566719,12.4142025,15.6061835,9263.2719118,16255.7014744,40.5489585,1041.6192679,746.1834055,1626.0673528,1.7921305,16.3556213,1.8888839,37.4322631),(23403,'red-deer-metatarsus.tif',246,10,37,255.3079668,45.8752342,59.6825058,1.8,45.9774285,59.9391918,1.3506644,12.4308219,16.3461586,9073.3411058,15977.4549835,40.5224654,977.4440189,729.9067762,1531.045757,0.757812,2.3047952,1.735945,5.867466),(23404,'red-deer-metatarsus.tif',246,10,38,255.8653111,45.9022264,59.7648686,1.8,45.9816739,59.9878462,1.3488803,11.8286106,24.3088327,8906.6863412,15720.1353816,40.5783795,646.6840906,752.9782342,1009.5154577,0.7877899,6.2058511,1.786154,14.073378),(23405,'red-deer-metatarsus.tif',246,10,39,256.8221818,45.9270826,59.8593531,1.8,46.0364299,60.0730093,1.3473733,12.2319868,14.9794081,8768.7574442,15512.4523788,40.7023461,1035.5851367,716.8710654,1388.2766348,1.4379823,9.2366838,2.0160974,22.1302291),(23406,'red-deer-metatarsus.tif',246,10,40,256.857922,45.9356579,59.9573822,1.8,46.0526118,60.1470847,1.3462438,11.7800027,14.8138001,8600.3626058,15285.6242175,40.6870661,1031.8503063,730.081549,1562.1406445,0.7398488,2.3434042,1.815775,5.867466),(23407,'red-deer-metatarsus.tif',246,10,41,255.9867798,46.0455568,60.0268929,1.8,46.113696,60.2422142,1.3477137,25.1318751,25.0405434,8454.6663079,14965.3484314,40.5762183,597.6447142,336.4120777,729.5619748,2.49091,15.3503701,1.79482,38.3470231),(23408,'red-deer-metatarsus.tif',246,10,42,250.3587583,46.1001022,60.1741862,1.8,46.1752028,60.666238,1.3556663,25.7344382,24.8040425,8186.5380104,14534.5309657,39.824929,585.9742816,318.116057,699.0430181,0.3676509,1.0202356,1.9513027,2.208426),(23409,'red-deer-metatarsus.tif',246,10,43,248.4429396,46.0965106,60.2477588,1.8,45.9884494,60.3857612,1.3457171,25.8684914,24.6182844,8016.5615828,14378.4889906,39.3446279,584.0573109,309.8967571,693.3494103,0.378906,0.8472596,2.0344439,1.82952),(23410,'red-deer-metatarsus.tif',246,10,44,248.5877928,46.1074215,60.3302842,1.8,46.0235144,60.425481,1.3447833,13.446001,24.0685289,7908.2707348,14236.2707579,39.3507017,591.4890273,588.1503909,914.1038619,19.6532927,28.080616,2.1981045,83.9123013),(23411,'red-deer-metatarsus.tif',246,10,45,249.2300825,46.1254179,60.4269808,1.8,46.0261252,60.5689722,1.346255,25.5191496,23.8236622,7831.0886602,14178.1009907,39.4789945,595.1268472,306.8710663,686.022642,0.378906,0.6830825,2.1587989,1.450614),(23412,'red-deer-metatarsus.tif',246,10,46,249.5749436,46.1438682,60.5197737,1.8,46.0213263,60.6746713,1.3462825,14.8847137,23.781395,7753.2017663,14047.8261741,39.5341184,590.7065661,520.8835011,897.4643443,0.508644,0.8472596,2.0344439,1.986468),(23413,'red-deer-metatarsus.tif',246,10,47,249.1501076,46.1707695,60.6266154,1.8,46.0557105,60.68237,1.3456925,25.8990756,23.4627257,7693.0571115,13795.2591325,39.456175,587.9648979,297.0398333,667.2573737,0.378906,0.8472596,2.0344439,1.82952),(23414,'red-deer-metatarsus.tif',246,10,48,250.4012963,46.1721194,60.678909,1.8,46.0715658,60.8079927,1.3399227,25.9550725,22.8060311,7629.5282649,13809.7993239,39.548286,605.532775,293.9513374,669.5236513,19.3108519,27.8160621,2.1965881,83.5333953),(23415,'red-deer-metatarsus.tif',246,10,49,249.4058685,46.2414917,60.7618772,1.8,46.1572195,61.0702854,1.3392723,13.5263664,22.9503153,7530.3432287,13724.8222472,39.3790069,598.0232554,556.7159009,900.8653811,19.2117602,27.7747402,2.2061121,83.5333953),(23416,'red-deer-metatarsus.tif',246,10,50,248.3707088,46.2589528,60.8238661,1.8,46.1850221,61.0988523,1.3336935,17.2289,22.750445,7445.1597521,13603.4289941,39.1112616,597.9412264,432.1320418,864.3295084,19.1313612,27.750823,2.1815223,83.0435103),(23417,'red-deer-metatarsus.tif',246,10,51,247.3979475,46.2700415,60.908872,1.8,46.1526792,61.198114,1.3344024,25.7755496,22.7409404,7382.8958388,13433.3714227,38.9714083,590.7131002,286.430201,654.4422516,0.378906,0.6830825,2.1587989,1.450614),(23418,'red-deer-metatarsus.tif',246,10,52,248.2137392,46.2880119,60.9940417,1.8,46.1551696,61.2406562,1.3307395,24.9207461,22.7414905,7354.8551509,13353.2911133,39.0304206,587.1774801,295.129814,664.8912745,19.049351,27.6426145,2.1759075,83.3764473),(23419,'red-deer-metatarsus.tif',246,10,53,248.6562386,46.3026318,61.0787392,1.8,46.1405559,61.4208814,1.3285204,24.7266409,22.336731,7326.1438014,13311.8381915,39.0573431,595.9617914,296.2854455,669.5782068,0.378906,0.6830825,2.1587989,1.450614),(23420,'red-deer-metatarsus.tif',246,10,54,248.1184284,46.3324234,61.140057,1.8,46.1969217,61.5030934,1.3262564,24.5984816,22.4030489,7300.6715333,13159.0563453,38.9290688,587.3779241,296.7935844,667.0128855,18.9868561,27.6426145,2.1759075,83.0435103),(23421,'red-deer-metatarsus.tif',246,10,55,248.247043,46.3459058,61.1888852,1.8,46.2289467,61.448755,1.3203337,24.5239981,22.307148,7278.6628372,13042.9378969,38.8328423,584.6976898,296.7975619,665.7451804,18.9673407,27.5958309,2.1854593,82.8865623),(23422,'red-deer-metatarsus.tif',246,10,56,248.1051917,46.3592405,61.246389,1.8,46.251084,61.437189,1.3149751,26.3169124,22.4567119,7259.4520721,12943.1873337,38.7032016,576.3616424,275.8474085,636.5934109,0.189453,0.267927,2.3561945,0.535854),(23423,'red-deer-metatarsus.tif',246,10,57,246.5044216,46.4159032,61.2466245,1.8,46.2986665,61.460421,1.3090318,24.4635375,22.6147767,7186.5304233,12836.7743899,38.3326756,567.6277316,293.7649724,657.932885,18.9522898,27.750823,2.1815223,82.2587703),(23424,'red-deer-metatarsus.tif',246,10,58,245.0810036,46.4275606,61.3010657,1.8,46.2755602,61.5131006,1.3022594,24.5823758,22.6635328,7133.597196,12705.1215634,37.9714099,560.5975774,290.1915276,652.6250801,0.189453,0.4236298,2.0344439,0.91476),(23425,'red-deer-metatarsus.tif',246,10,59,243.6605875,46.4510987,61.370332,1.8,46.324784,61.6036969,1.2990894,26.2855486,22.518408,7085.2326031,12516.3117824,37.685125,555.8257837,269.5485916,623.1988912,0.378906,0.8472596,2.0344439,1.82952),(23426,'red-deer-metatarsus.tif',246,10,60,243.3093963,46.4660772,61.4356776,1.8,46.3108922,61.6006251,1.2972633,26.8610467,22.3547682,7090.7214294,12407.2687909,37.5924034,555.0166598,263.9778532,613.3143621,0.189453,0.599103,1.8925469,1.293666),(23427,'red-deer-metatarsus.tif',246,10,61,243.3025767,46.4892472,61.5119812,1.8,46.3540771,61.7748377,1.2936576,26.7413698,22.4669491,7082.7537459,12318.9361419,37.5148445,548.3137061,264.8612917,613.5249653,0.189453,0.4236298,2.0344439,0.91476),(23428,'red-deer-metatarsus.tif',246,10,62,243.0279669,46.506217,61.5814701,1.8,46.3822522,61.8994472,1.2854439,26.8758366,22.5542265,7035.3252426,12196.8148736,37.2950795,540.7773521,261.7713951,608.9408813,18.914519,27.2871518,2.1934671,81.1220523),(23429,'red-deer-metatarsus.tif',246,10,63,243.2548615,46.5325397,61.6518393,1.8,46.4361015,61.9303385,1.2802689,27.1478952,22.280286,7017.6820023,12100.8575453,37.2156452,543.1194878,258.4981987,603.5734287,18.9522898,27.1334796,2.1975392,81.0570423),(23430,'red-deer-metatarsus.tif',246,10,64,242.9433369,46.5562132,61.718127,1.8,46.4286768,61.9712309,1.2768134,27.2075766,22.1643111,7030.5110875,11983.3979602,37.0907803,540.6618739,258.4026942,600.896052,18.914519,27.0924414,2.2073045,80.6321673),(23431,'red-deer-metatarsus.tif',246,10,65,241.3460472,46.6271236,61.7402009,1.8,46.5142273,61.9929753,1.2736343,27.2646655,21.8934846,6985.3602932,11864.5614774,36.7756497,541.9220242,256.2056113,597.7461608,18.9522898,27.0924414,2.2073045,80.8350843),(23432,'red-deer-metatarsus.tif',246,10,66,240.1335354,46.6454919,61.8146166,1.8,46.4985853,62.1259925,1.2683038,27.2876716,21.9309187,6949.1261959,11759.0410873,36.4704927,536.1855217,254.66175,596.6662988,18.9522898,27.0679213,2.1820957,80.4561783),(23433,'red-deer-metatarsus.tif',246,10,67,239.4015036,46.6740798,61.8778564,1.8,46.5447191,62.1925617,1.2595527,15.6460848,21.6026609,6933.7108057,11660.5265851,36.1582202,539.7726998,443.1594787,859.0946022,0.189453,0.4236298,2.0344439,0.91476),(23434,'red-deer-metatarsus.tif',246,10,68,239.697377,46.6950715,61.9539709,1.8,46.5408799,62.2983148,1.2556167,14.6462347,21.5994215,6939.8742268,11610.5796893,36.1107263,537.5412352,473.833334,856.420857,19.0150495,27.1156157,2.172364,80.6321673),(23435,'red-deer-metatarsus.tif',246,10,69,240.1438898,46.7145387,62.0205677,1.8,46.5895223,62.397331,1.2492922,14.5777051,22.0046705,6925.8667651,11618.8678512,36.0275001,528.0182621,475.0999356,797.3417682,19.0083458,27.1156157,2.172364,80.1422823),(23436,'red-deer-metatarsus.tif',246,10,70,239.9528768,46.7289478,62.0715341,1.8,46.5874717,62.4883436,1.2451447,27.5742329,22.1646579,6934.580219,11607.3130946,35.8988376,523.6856421,251.4876926,596.4298119,18.9996799,27.0924414,2.2073045,80.4102093),(23437,'red-deer-metatarsus.tif',246,10,71,240.0883761,46.7467335,62.1130227,1.8,46.637235,62.4932294,1.2413659,14.4486948,22.2339453,6914.8769008,11519.6866773,35.8269908,518.112576,478.581423,742.2148645,19.0083458,27.1156157,2.172364,80.1882513),(23438,'red-deer-metatarsus.tif',246,10,72,239.7671606,46.7555028,62.1299223,1.8,46.608579,62.3848742,1.2361293,27.7706778,21.5811779,6902.9641957,11447.2439761,35.6500814,530.4272099,248.570245,588.1259524,18.9900607,27.1156157,2.172364,80.5671573),(23439,'red-deer-metatarsus.tif',246,10,73,238.3798308,46.8139591,62.1741942,1.8,46.6538686,62.7171022,1.2417741,27.7309646,21.586028,6878.509926,11431.787027,35.5819578,529.5919665,248.0443801,586.6875191,19.025788,27.1156157,2.172364,80.1422823),(23440,'red-deer-metatarsus.tif',246,10,74,237.1064649,46.8338507,62.2142019,1.8,46.6543583,62.6676993,1.2352231,27.8297799,21.8245151,6850.2630842,11285.7145053,35.2322268,517.1118098,246.1486621,581.3824654,18.9896386,27.0606272,2.1568572,80.0313033),(23441,'red-deer-metatarsus.tif',246,10,75,235.8056468,46.8441447,62.2643422,1.8,46.6684068,62.7247216,1.228411,26.8472577,22.080225,6808.8744702,11164.7075341,34.8710207,505.642833,253.6152682,591.4874176,19.0085439,27.0705732,2.1316212,80.1422823),(23442,'red-deer-metatarsus.tif',246,10,76,235.7134032,46.8596098,62.2941328,1.8,46.692768,62.6535608,1.2213626,24.9283429,22.2679223,6786.2334633,11153.1732944,34.6807359,500.8627718,272.2296255,621.5563625,19.025788,27.0705732,2.1316212,80.0772723),(23443,'red-deer-metatarsus.tif',246,10,77,235.6617725,46.8786925,62.3260404,1.8,46.74024,62.6976941,1.2161389,25.366128,22.4387009,6792.3964112,11081.7088766,34.5403241,493.8658845,267.7742699,614.3642388,0.189453,0.267927,2.3561945,0.535854),(23444,'red-deer-metatarsus.tif',246,10,78,235.9488359,46.8924086,62.3490755,1.8,46.7202981,62.6100818,1.2056284,26.5808299,22.8635201,6796.8580914,11037.4662135,34.3099166,482.754456,255.7052629,597.7772321,19.025788,27.0705732,2.1316212,79.7633763),(23445,'red-deer-metatarsus.tif',246,10,79,236.4469468,46.9156189,62.3825171,1.8,46.800352,62.6314309,1.1964371,26.537271,20.1473998,6792.0861666,10984.5245509,34.1382471,545.2080508,255.9451637,598.5721843,19.0310361,27.0705732,2.1316212,80.1232413),(23446,'red-deer-metatarsus.tif',246,10,80,236.1250242,46.9337974,62.4188455,1.8,46.8354758,62.6950315,1.1869761,23.0811614,19.9999596,6777.7726035,10920.3761723,33.8357565,546.0199129,293.6495477,652.0211665,19.0928611,26.9702831,2.1256727,79.9662933),(23447,'red-deer-metatarsus.tif',246,10,81,234.6676172,46.987691,62.4273182,1.8,46.8252214,62.8083178,1.1851105,27.6141853,23.6245137,6780.2123107,10887.7795661,33.5761482,460.8678805,245.5336719,582.0327653,19.1072385,27.0121713,2.141291,79.6983663),(23448,'red-deer-metatarsus.tif',246,10,82,233.8460936,46.992495,62.4771319,1.8,46.744917,62.8543841,1.1837145,28.5660994,23.6262436,6824.9547108,10842.1611103,33.4206203,458.9032978,238.9179779,567.7041375,19.1250654,27.0705732,2.1316212,79.3844703),(23449,'red-deer-metatarsus.tif',246,10,83,233.0256142,47.0052309,62.5294763,1.8,46.7575868,63.0253004,1.1801115,28.6022094,23.9523217,6813.9414244,10790.2880389,33.2051712,450.4902778,238.2312966,566.2669898,19.1703853,26.9702831,2.1256727,79.6523973),(23450,'red-deer-metatarsus.tif',246,10,84,232.871342,47.0076694,62.5559646,1.8,46.6948886,62.9248862,1.1703603,28.7115518,20.4843074,6824.310435,10739.9777918,32.9140537,524.3027043,237.6851826,565.2942572,19.2065347,26.9702831,2.1256727,79.7443353),(23451,'red-deer-metatarsus.tif',246,10,85,232.9243649,47.0331855,62.5904424,1.8,46.821678,62.9412589,1.1556019,28.7403035,20.6509681,6772.5679085,10675.3241043,32.5043769,516.9406134,235.6470563,566.5619799,19.2544566,26.9103299,2.1353657,79.5873873),(23452,'red-deer-metatarsus.tif',246,10,86,232.8598782,47.0408355,62.6176656,1.8,46.8465771,62.9130476,1.1435147,28.789096,23.1560718,6748.2554552,10618.4012732,32.1452958,458.5579689,234.4031731,566.6280018,19.3049053,26.8709546,2.11968,79.2084813),(23453,'red-deer-metatarsus.tif',246,10,87,233.390314,47.0535173,62.6644964,1.8,46.8638072,63.0039775,1.1346795,24.3962005,22.718347,6781.4155842,10585.4895319,31.957314,465.9445301,277.9701526,631.261547,19.3267938,26.8529161,2.1451012,79.3194603),(23454,'red-deer-metatarsus.tif',246,10,88,234.127523,47.057911,62.72355,1.8,46.833698,63.2710227,1.1334943,23.7037258,22.2041391,6830.6323527,10611.0001949,32.0228074,477.8838828,288.1670336,645.7007174,19.4084805,26.8709546,2.11968,79.1625123),(23455,'red-deer-metatarsus.tif',246,10,89,232.4704452,47.1210989,62.7475197,1.8,46.9280201,63.3598213,1.1257012,21.7092989,22.1415501,6796.6039844,10536.7017394,31.5629818,475.8791373,313.0733988,671.6993089,19.4746726,26.8094404,2.1293956,78.8295753),(23456,'red-deer-metatarsus.tif',246,10,90,231.7970922,47.1130407,62.7876249,1.8,46.9304109,63.3781677,1.1170435,22.3152863,24.3709339,6788.4185925,10480.2218636,31.209799,430.0295543,304.2048627,662.373797,19.5470097,26.8094404,2.1293956,78.8295753),(23457,'red-deer-metatarsus.tif',246,10,91,231.4506105,47.0898473,62.8462692,1.8,46.8326367,63.5983759,1.1196604,21.7219952,24.3915152,6819.6565332,10453.0603999,31.2425303,428.5531386,313.9516631,671.9656324,19.5847805,26.8094404,2.1293956,78.8295753),(23458,'red-deer-metatarsus.tif',246,10,92,231.0101885,47.0812565,62.8497041,1.8,46.7770045,63.3770286,1.1065914,21.9753523,24.4903393,6811.7244347,10349.7191765,30.7841865,422.6041567,309.9711137,662.0439664,19.6210182,26.7725981,2.113643,78.6076173),(23459,'red-deer-metatarsus.tif',246,10,93,230.6733652,47.083234,62.8715573,1.8,46.8210199,63.3598879,1.0974621,19.1996294,21.5582928,6776.9793658,10243.0243909,30.4563764,475.1315172,352.9744892,729.8381282,19.6571177,26.7504684,2.1391551,78.6076173),(23460,'red-deer-metatarsus.tif',246,10,94,230.6837631,47.0866716,62.8956243,1.8,46.8907579,63.3334348,1.0897184,19.9220986,19.3209788,6756.8880686,10167.2131477,30.2148183,526.2266095,339.1654765,685.0742705,19.6668511,26.7725981,2.113643,78.5616483),(23461,'red-deer-metatarsus.tif',246,10,95,231.3169492,47.0863152,62.944281,1.8,46.8709017,63.547186,1.0850557,29.4188726,23.5927746,6779.9655448,10159.2263516,30.1497946,430.6075273,230.4631327,551.4378186,19.6948885,26.6489738,2.1331635,78.1177323),(23462,'red-deer-metatarsus.tif',246,10,96,231.0841813,47.0780702,62.9597251,1.8,46.8462523,63.544472,1.0749278,29.4922894,23.5194107,6789.9092742,10107.2566387,29.7951624,429.7410658,230.2265916,550.3690989,19.727253,26.6489738,2.1331635,78.2746803),(23463,'red-deer-metatarsus.tif',246,10,97,229.410158,47.1090916,62.9585811,1.8,46.8411154,63.5920053,1.0713981,28.7940106,23.656345,6757.5483309,10008.5785828,29.466103,423.0822045,234.685901,557.8706391,19.7585167,26.6105606,2.1173208,78.1177323),(23464,'red-deer-metatarsus.tif',246,10,98,233.3716826,47.0988294,62.947847,1.8,47.243428,63.3276107,1.0346221,15.7723381,18.1354113,6767.7399279,10028.8615383,28.7448347,552.9988482,429.0891981,800.8419412,1.1889201,7.7768091,1.6195382,18.2223031),(23465,'red-deer-metatarsus.tif',246,10,99,232.6778056,47.0876676,62.9629467,1.8,47.2600501,63.3495459,1.0241736,29.2111661,27.6534984,6739.0384306,9958.7526879,28.3014827,360.1263228,230.7007675,548.1965751,0.757812,2.3047952,1.735945,5.331612),(23466,'red-deer-metatarsus.tif',246,10,100,232.7429776,47.0648265,62.95286,1.8,47.17203,63.3243892,1.0244226,26.6052086,22.2938194,6745.2747731,9974.6314805,28.3179868,447.4168955,253.5321134,598.0383265,0.947265,2.3047952,1.735945,5.756487),(23467,'red-deer-metatarsus.tif',246,10,101,232.9467814,47.0595682,62.965895,1.8,47.193145,63.3158767,1.0182665,24.4262061,27.6788558,6737.3582077,9957.2055895,28.1298999,359.7405056,275.8249966,546.7518918,0.5441672,3.0840714,1.7561443,6.690288),(23468,'red-deer-metatarsus.tif',246,10,102,232.7074223,47.0441361,62.9673238,1.8,47.1776389,63.2837662,1.0130243,24.8269565,14.8305432,6721.5878526,9934.684898,27.9188587,669.8800436,270.7374884,619.3909494,0.5537589,4.3943296,1.7004989,9.499578),(23469,'red-deer-metatarsus.tif',246,10,103,232.7124473,47.0306296,62.9824313,1.8,47.1644218,63.2871696,1.006684,12.7375273,24.2465031,6707.9221151,9886.7471646,27.697917,407.7597138,526.6267101,674.7938348,0.378906,3.0548378,1.6951513,7.004184),(23470,'red-deer-metatarsus.tif',246,10,104,232.3023598,47.0261721,63.0059882,1.8,47.1804604,63.2960507,0.9997359,29.9811888,24.7575053,6689.2290794,9784.879809,27.4052217,395.2288277,223.1142039,537.8058128,0.378906,0.9660245,1.7681919,2.208426),(23471,'red-deer-metatarsus.tif',246,10,105,230.0030902,47.0573828,63.0070684,1.8,47.2003335,63.3560126,0.9951451,30.1384355,14.3158537,6654.5704388,9625.3061386,26.9735782,672.3529293,220.8001284,528.7961671,0.378906,1.5274189,1.6951513,3.345144),(23472,'red-deer-metatarsus.tif',246,10,106,228.7213603,47.0407523,63.0316078,1.8,47.1894861,63.372763,0.9899145,30.1435254,14.2516022,6605.1078042,9527.1215281,26.6407393,668.4947714,219.1219412,524.4958965,0.6661887,4.3943296,1.4410938,9.499578),(23473,'red-deer-metatarsus.tif',246,10,107,227.3822025,47.0304225,63.0545858,1.8,47.1811653,63.3975624,0.9796416,25.5181704,16.7298608,6547.7772576,9411.558734,26.1259983,562.5604915,256.5927395,587.0110934,1.2964919,9.741643,1.3352513,21.7703641),(23474,'red-deer-metatarsus.tif',246,10,108,226.8552362,47.0326483,63.0772191,1.8,47.2016403,63.4772449,0.9707286,12.0442308,17.4768561,6531.1594099,9319.7173313,25.7524451,533.2605171,542.2645533,802.368242,0.5992201,4.5822568,1.4464413,10.035432),(23475,'red-deer-metatarsus.tif',246,10,109,226.7767732,47.0277567,63.0752709,1.8,47.2079286,63.4434311,0.9622489,11.6948603,18.0067283,6526.765088,9275.2639432,25.4438336,515.0999008,558.0883342,802.2873821,0.378906,3.9830212,1.6183794,8.584818),(23476,'red-deer-metatarsus.tif',246,10,110,226.4711654,47.021767,63.0774966,1.8,47.2103923,63.4452503,0.9551869,23.7993909,26.2508957,6513.4814238,9232.418276,25.1588465,351.6991714,273.6826939,580.0490983,0.378906,1.339635,1.7126934,2.966238),(23477,'red-deer-metatarsus.tif',246,10,111,226.1843522,47.0126745,63.0873106,1.8,47.2272844,63.5139928,0.9508271,11.7390015,21.479853,6485.6597459,9208.5782259,24.9717797,428.7076931,552.4881969,721.1543213,19.9514091,25.6049076,2.1239055,76.1122233),(23478,'red-deer-metatarsus.tif',246,10,112,225.9228812,47.0050031,63.0941663,1.8,47.1990658,63.4902219,0.9472748,16.367133,27.2966135,6471.7669899,9166.8450861,24.8162546,335.8235291,395.4123787,549.1746652,19.9514091,25.54456,2.1341126,75.6873483),(23479,'red-deer-metatarsus.tif',246,10,113,224.228943,47.0432602,63.072903,1.8,47.2301153,63.5944057,0.9564098,13.5312706,21.5387784,6422.7170533,9101.5149654,24.9528301,422.5641203,474.6573521,710.4928823,0.5169892,4.1851536,1.4801364,9.27762),(23480,'red-deer-metatarsus.tif',246,10,114,222.6663711,47.028255,63.0739087,1.8,47.1906534,63.5172206,0.9551467,16.9031183,20.2932252,6365.9907441,9002.5629446,24.7347637,443.6240603,376.6163506,734.2612597,19.8912947,25.3845812,2.138098,75.6873483),(23481,'red-deer-metatarsus.tif',246,10,115,220.9794699,47.0090654,63.0765175,1.8,47.1647016,63.5316424,0.9567875,22.2713348,18.8915419,6319.3676166,8907.3664308,24.6043219,471.5002345,283.7444482,618.3339415,19.880986,25.3845812,2.138098,75.4653903),(23482,'red-deer-metatarsus.tif',246,10,116,220.2998738,47.0001649,63.0649703,1.8,47.1446938,63.4781414,0.956145,21.3487984,20.8043696,6265.6264639,8851.1681908,24.5064326,425.4475565,293.4884839,627.4847964,0.378906,1.9039791,1.670465,4.102956),(23483,'red-deer-metatarsus.tif',246,10,117,219.4709325,46.9793281,63.0447426,1.8,47.124925,63.3924306,0.9509517,21.2470643,21.0723421,6212.3912603,8773.1282608,24.2348966,416.3338009,292.3882178,624.0368982,0.5628278,1.7466704,1.7894653,3.880998),(23484,'red-deer-metatarsus.tif',246,10,118,218.959748,46.9576155,63.0309003,1.8,47.1018445,63.3683553,0.9545771,21.550961,28.1723538,6171.5319243,8720.3180715,24.3034097,309.5345933,286.3692213,504.2103625,19.7710661,25.2456341,2.1150768,74.8185573),(23485,'red-deer-metatarsus.tif',246,10,119,218.7718783,46.9366776,63.0268024,1.8,47.0718817,63.3211894,0.9524519,27.6481503,21.2286724,6132.5054685,8654.39778,24.2094075,407.6749407,221.8052712,525.3182619,19.711632,25.1830004,2.1254084,74.5506303),(23486,'red-deer-metatarsus.tif',246,10,120,218.2475985,46.9152979,63.026467,1.8,47.0630275,63.3498377,0.9557797,27.5038369,27.8348004,6089.4241223,8583.3612592,24.2656109,308.3679835,221.4027138,499.3401702,19.6521979,25.0837489,2.1189877,74.3936823),(23487,'red-deer-metatarsus.tif',246,10,121,216.4538793,46.9365816,62.991316,1.8,47.0576806,63.335873,0.9651305,23.5015727,15.5499379,6041.6147389,8466.0619239,24.3830464,544.443456,257.072785,578.665687,0.378906,0.7811347,1.815775,1.82952),(23488,'red-deer-metatarsus.tif',246,10,122,214.8073952,46.919563,62.9947805,1.8,46.9923644,63.371558,0.9751803,23.6545292,15.5733883,6001.6733571,8346.83743,24.5330766,535.967979,253.7219538,572.0653471,19.5927637,24.9222523,2.1229493,73.7468493),(23489,'red-deer-metatarsus.tif',246,10,123,213.197554,46.9104627,62.983633,1.8,47.0141222,63.3730683,0.9715404,24.3092719,15.9206693,5906.9852381,8239.25988,24.2289134,517.5196938,242.9930955,553.0692259,0.189453,0.7811347,1.815775,1.672572),(23490,'red-deer-metatarsus.tif',246,10,124,212.3231272,46.8984391,62.9600557,1.8,47.0328384,63.2573846,0.9704068,15.764736,28.4006231,5841.6059451,8156.3602784,24.0921549,287.1894834,370.5489234,460.3008398,19.5293526,24.7256126,2.1099018,73.3679433),(23491,'red-deer-metatarsus.tif',246,10,125,211.8833578,46.8856575,62.9447245,1.8,46.9919064,63.2275687,0.9734228,27.1654935,25.8677644,5816.0913013,8073.7464973,24.1414364,312.1161298,214.0984957,500.2142479,19.5182138,24.6616581,2.1204382,73.3679433),(23492,'red-deer-metatarsus.tif',246,10,126,211.7076263,46.8833576,62.9394126,1.8,46.9403317,63.2613275,0.9752508,29.5137206,25.367199,5840.3565161,8010.310376,24.1813645,315.7743347,197.8861491,462.968188,0.189453,0.7811347,1.815775,1.672572),(23493,'red-deer-metatarsus.tif',246,10,127,211.5416835,46.8769008,62.9199576,1.8,46.9394078,63.1719938,0.9757867,29.4104585,24.5361152,5800.5711378,7958.1995271,24.1799554,324.3463545,197.2281775,461.7726595,0.189453,0.599103,1.8925469,1.293666),(23494,'red-deer-metatarsus.tif',246,10,128,211.1095495,46.8767931,62.9125813,1.8,46.9715202,63.1561012,0.9774412,25.6368809,24.2225789,5763.4037454,7901.9175109,24.1845697,326.2211484,224.8090849,512.274356,19.4659934,24.4012228,2.1178735,72.7211103),(23495,'red-deer-metatarsus.tif',246,10,129,209.3066505,46.9200644,62.8621353,1.8,46.9701822,63.10867,0.9857316,24.7957877,27.7280101,5705.0590535,7784.94554,24.2452532,280.7610614,230.0817831,458.2452207,0.378906,0.599103,1.8925469,1.607562),(23496,'red-deer-metatarsus.tif',246,10,130,207.8075864,46.9089279,62.8643251,1.8,46.9343774,63.1093612,0.9956636,23.53198,23.1039711,5650.1288803,7689.3912614,24.3870006,332.816867,240.1042698,523.697201,0.378906,1.7155699,1.6814535,3.880998),(23497,'red-deer-metatarsus.tif',246,10,131,206.1745457,46.9037222,62.8604901,1.8,46.9903967,63.120352,0.9943655,21.7949361,26.4127878,5583.6346832,7595.8467645,24.1546162,287.5821677,256.1895414,476.3701974,0.5882252,1.9779474,1.2793395,4.5738),(23498,'red-deer-metatarsus.tif',246,10,132,205.0246934,46.8952994,62.8519262,1.8,47.0235497,63.1171246,0.9933487,11.1969415,26.7359704,5525.370389,7490.5509357,23.9881331,280.167536,493.4714008,459.4405512,19.3883202,24.0157366,2.0909209,71.8063503),(23499,'red-deer-metatarsus.tif',246,10,133,204.239345,46.8687109,62.8458853,1.8,46.9792901,63.0988141,0.9985913,16.5391179,25.8258474,5488.235232,7415.8561671,24.059111,287.1486093,331.8336111,489.2233583,0.378906,0.6830825,0.9827937,1.450614),(23500,'red-deer-metatarsus.tif',246,10,134,203.1240691,46.8648079,62.8364689,1.8,46.9847312,63.1219865,1.0030077,17.0199032,25.6522248,5449.4120933,7342.2096003,24.0635833,286.2211623,320.1787941,487.2745893,0.3752185,1.5622695,1.815775,3.345144),(23501,'red-deer-metatarsus.tif',246,10,135,202.9758985,46.8544016,62.8248772,1.8,46.9554641,63.1354803,1.0102987,18.3104893,25.3838414,5427.2047759,7255.549889,24.2689203,285.8334082,296.3986754,490.1332001,19.2080287,23.6876867,2.0988708,71.2054863),(23502,'red-deer-metatarsus.tif',246,10,136,202.240332,46.8403473,62.8050715,1.8,46.8819252,63.0829654,1.015225,16.3122419,25.0999944,5405.9342352,7147.4331366,24.3301476,284.7583562,331.4035104,487.4142563,19.2075345,23.5927944,2.0919345,70.6696323),(23503,'red-deer-metatarsus.tif',246,10,137,199.8132417,46.8791718,62.7520218,1.8,46.9086859,62.9779749,1.025275,20.8459335,21.868765,5329.3865284,7024.3917674,24.3365984,321.206605,255.655931,502.8019277,0.378906,1.339635,1.7126934,2.966238),(23504,'red-deer-metatarsus.tif',246,10,138,198.0559153,46.8724667,62.7406926,1.8,46.9501251,62.9587203,1.0247185,18.066133,17.2210502,5260.9609358,6922.855848,24.1062604,401.9996314,291.2057015,529.4097428,0.378906,2.67927,1.4288993,5.61858),(23505,'red-deer-metatarsus.tif',246,10,139,196.1799588,46.8600811,62.7304406,1.8,46.9198631,62.9819029,1.0247992,19.8755596,14.2099565,5207.911272,6828.755665,23.8802723,480.5613357,262.0258944,499.6377323,0.378906,1.5622695,1.3258177,3.502092),(23506,'red-deer-metatarsus.tif',246,10,140,195.2146698,46.8580343,62.7023223,1.8,46.9133486,62.8934612,1.0203532,11.4055494,21.9184394,5173.6224419,6761.3371194,23.6340893,308.477123,453.6057204,542.3376208,0.568359,1.7466704,1.3521274,4.037946),(23507,'red-deer-metatarsus.tif',246,10,141,194.8915726,46.8531616,62.6705612,1.8,46.9248806,62.8274712,1.0213313,21.6263112,12.7813778,5160.9075879,6700.4578052,23.6232854,524.2359571,238.640216,476.2859663,19.1001686,23.1698773,2.092985,69.4869453),(23508,'red-deer-metatarsus.tif',246,10,142,194.8594978,46.8380556,62.643208,1.8,46.9009828,62.7984992,1.0241647,28.8053876,23.7593033,5163.6099792,6635.5965299,23.7012426,279.2841374,179.2584792,397.5029782,19.1001686,23.0759665,2.0858691,69.2649873),(23509,'red-deer-metatarsus.tif',246,10,143,195.1684882,46.8258188,62.6363677,1.8,46.8468127,62.8752385,1.037809,24.5809489,15.3675502,5193.2483416,6603.5303637,24.1301652,429.7061204,211.2712724,440.3024836,19.1001686,22.9832336,2.0786955,69.3109563),(23510,'red-deer-metatarsus.tif',246,10,144,194.8731804,46.8272977,62.6187683,1.8,46.8672996,62.8889803,1.0237186,29.6564198,29.5037278,5195.254287,6567.5324226,23.6900351,222.600089,175.1814387,353.0057342,19.1001686,22.8422501,2.1012588,69.1540083),(23511,'red-deer-metatarsus.tif',246,10,145,192.947464,46.8718681,62.5457116,1.8,46.9223107,62.7459457,1.0243131,29.6297783,27.5930015,5131.5218888,6445.3806325,23.4729131,233.5875142,173.187995,380.2399516,19.0927284,22.7469867,2.0940746,68.7291333),(23512,'red-deer-metatarsus.tif',246,10,146,191.5532385,46.8684466,62.538588,1.8,46.9694752,62.7355978,1.0059281,15.5709946,27.9678015,5082.3479443,6359.6437075,22.7772474,227.3916205,326.3984152,381.195322,0.189453,0.267927,2.3561945,0.535854),(23513,'red-deer-metatarsus.tif',246,10,147,190.0947656,46.8597584,62.5366375,1.8,46.9346069,62.771388,0.9967842,30.0118419,30.1767773,5091.0393048,6289.2809687,22.3407282,208.4145997,169.6343504,341.0084189,0.568359,1.7466704,1.3521274,4.037946),(23514,'red-deer-metatarsus.tif',246,10,148,189.5224552,46.8597579,62.5128916,1.8,46.8942105,62.6693447,1.0038868,29.8758005,17.041768,5066.2955773,6177.6067253,22.4774064,362.4979956,169.5785719,367.5169729,0.378906,0.7811347,1.815775,1.82952),(23515,'red-deer-metatarsus.tif',246,10,149,189.4282647,46.8644482,62.4845319,1.8,46.8980015,62.6377327,0.9912576,26.116909,17.116908,5064.2770648,6118.0106011,22.102886,357.4249851,193.9079797,404.8640679,0.189453,1.1523976,1.735945,2.430384),(23516,'red-deer-metatarsus.tif',246,10,150,189.1519038,46.8709023,62.4548169,1.8,46.9328891,62.6227843,0.9892974,12.3374554,17.9970144,5062.2812432,6074.5178922,22.0139615,337.5292002,410.3180981,532.1093031,0.189453,0.599103,1.8925469,1.293666),(23517,'red-deer-metatarsus.tif',246,10,151,188.7355189,46.8654693,62.4264149,1.8,46.8991146,62.5145211,0.971706,23.5049564,17.739718,5062.9822629,6012.9100391,21.4537683,338.9518386,215.4006232,430.6136172,19.134753,22.1603329,2.0994862,67.6574252),(23518,'red-deer-metatarsus.tif',246,10,152,187.7930487,46.8640165,62.4126978,1.8,46.8692245,62.4728381,0.943978,20.0767288,11.887657,5062.931236,5943.888929,20.529993,500.0050822,252.1790915,525.37109,19.134753,22.0653787,2.0920724,67.5464462),(23519,'red-deer-metatarsus.tif',246,10,153,186.4859222,46.9361728,62.3690848,1.8,46.990487,62.4693918,0.9389137,18.2137199,11.6501446,5033.9841326,5871.3468344,20.2372938,503.9720148,276.3841849,583.2615631,19.134753,22.0653787,2.0920724,67.7033943),(23520,'red-deer-metatarsus.tif',246,10,154,185.0532374,46.9391449,62.3688537,1.8,46.970901,62.4964308,0.9196382,10.7949686,11.8440364,5012.8165199,5799.0002092,19.5118022,489.6135092,464.3660103,863.5875029,19.134753,21.9315886,2.1156602,67.7033943),(23521,'red-deer-metatarsus.tif',246,10,155,183.576666,46.9521864,62.3570071,1.8,46.9674286,62.4906602,0.9032909,11.2274139,23.2307521,4996.5322499,5753.4724485,18.8717858,247.6662156,445.0296664,453.327291,19.134753,21.9012912,2.0963801,67.4354672),(23522,'red-deer-metatarsus.tif',246,10,156,183.1800654,46.9697068,62.3496082,1.8,46.9937634,62.4736078,0.8605934,19.004736,22.7736401,4995.8341642,5717.4052818,17.5520737,251.0536412,262.8731155,453.2884203,19.134753,21.8339959,2.1082396,67.4354672),(23523,'red-deer-metatarsus.tif',246,10,157,182.7959728,46.9783452,62.3243161,1.8,46.9804038,62.3550247,0.801637,12.3226861,22.900893,5003.9829622,5662.5256325,15.7276431,247.262219,406.0789134,444.70829,19.134753,21.7376163,2.1007528,67.1675402),(23524,'red-deer-metatarsus.tif',246,10,158,182.834791,47.0054669,62.3248941,1.8,46.9998408,62.3902912,0.7543779,20.3389596,19.7655241,5016.2623537,5652.6591533,14.2915755,285.9857972,246.6331834,458.6722024,19.134753,21.6979521,2.0617809,67.4354672),(23525,'red-deer-metatarsus.tif',246,10,159,183.1967065,47.0286056,62.3232991,1.8,47.0299253,62.2828576,0.6768637,22.1168907,18.2814354,5023.9214287,5648.9021961,11.9784971,308.9966438,227.153152,450.5890461,19.324206,21.5743633,2.1051918,67.5924153),(23526,'red-deer-metatarsus.tif',246,10,160,183.3071899,47.0509374,62.3378335,1.8,47.0691918,62.3285697,0.6182972,22.4219751,21.4142338,5049.9802336,5656.526427,10.2649679,264.1479722,225.2245942,442.506598,19.324206,21.5485611,2.0855804,67.4814363),(23527,'red-deer-metatarsus.tif',246,10,161,181.6500686,47.1204728,62.3170133,1.8,47.1517699,62.3318351,0.5533327,18.2725548,10.9843679,5030.4066861,5631.8846572,8.3612632,512.7181383,275.2984865,506.4236027,19.324206,21.4784897,2.0976009,67.3244883),(23528,'red-deer-metatarsus.tif',246,10,162,180.8250755,47.1426615,62.3211516,1.8,47.1826509,62.3266145,0.4899946,13.8782372,20.0584643,5013.3908505,5634.0552605,6.6749838,280.881686,361.2411838,437.4298087,0.568359,1.1523976,1.735945,2.901228),(23529,'red-deer-metatarsus.tif',246,10,163,180.3012851,47.1525126,62.3172116,1.8,47.1774805,62.3127001,0.4031015,11.0906948,10.9721658,5002.7374585,5652.7485292,4.6240733,515.1898559,451.0752068,896.6711465,0.189453,0.599103,1.8925469,1.293666),(23530,'red-deer-metatarsus.tif',246,10,164,179.1565774,47.1617123,62.3016895,1.8,47.2155011,62.2829171,0.3267597,15.497418,20.4678155,4979.507207,5693.9530898,3.0762825,278.1905623,321.3120547,415.7469876,0.189453,0.4236298,2.0344439,0.91476),(23531,'red-deer-metatarsus.tif',246,10,165,178.4976248,47.1628512,62.2886721,1.8,47.2067464,62.2754731,0.2655087,16.1535913,21.2615433,4961.778318,5759.2395495,2.0483755,270.8758935,307.1625515,402.4122944,19.324206,21.0770188,2.1837314,67.2594783),(23532,'red-deer-metatarsus.tif',246,10,166,178.2243202,47.1856684,62.2869748,1.8,47.2217348,62.2739159,0.2047466,23.7475817,11.0768814,4938.8570644,5836.1338096,1.227925,526.875173,207.9730525,419.5046941,19.2428806,20.9917002,2.2088823,67.6843533),(23533,'red-deer-metatarsus.tif',246,10,167,178.1997176,47.2220013,62.2960074,1.8,47.259749,62.2931211,0.1613613,23.3629463,25.9060053,4921.2706871,5949.3882176,0.7666234,229.6528603,210.6442661,359.54796,19.2088669,20.9223371,2.1889406,68.0632593),(23534,'red-deer-metatarsus.tif',246,10,168,177.4238644,47.2339301,62.3012858,1.8,47.2551944,62.3448781,0.1138487,22.833085,25.3121935,4899.4660095,6041.9307697,0.3816276,238.6964517,214.5774874,360.3115637,0.189453,0.599103,1.8925469,1.293666),(23535,'red-deer-metatarsus.tif',246,10,169,176.0694143,47.3027421,62.2644875,1.8,47.3324,62.2699978,0.0794592,22.2716211,13.9402511,4838.3060065,6111.2142123,0.1848873,438.3862352,217.2408547,416.7337074,19.1446776,20.9617566,0.172578,68.3311863),(23536,'red-deer-metatarsus.tif',246,10,170,174.95813,47.3393752,62.2838806,1.8,47.3288493,62.319991,0.0571256,10.8691906,11.3221664,4798.9778533,6213.4587398,0.0950542,548.7870878,441.521178,899.1710356,0.189453,0.4236298,2.0344439,0.91476),(23537,'red-deer-metatarsus.tif',246,10,171,173.822689,47.3882311,62.2933603,1.8,47.4003191,62.3187159,0.0441598,21.10507,15.8572064,4751.3057781,6333.4438302,0.0564585,399.4047678,225.126274,429.192852,18.9453,21.3712725,0.2234766,68.8670403),(23538,'red-deer-metatarsus.tif',246,10,172,173.86452,47.4080817,62.3043639,1.8,47.3621581,62.3260166,0.0339939,20.8807281,11.6260846,4744.385549,6490.5788501,0.033473,558.277277,227.2136073,538.0489074,18.9453,21.5718677,0.1232657,69.2459463),(23539,'red-deer-metatarsus.tif',246,10,173,174.1484727,47.4211723,62.3038547,1.8,47.3500873,62.316725,0.0291057,20.8754004,11.7301686,4756.9460709,6664.7050746,0.0245811,568.1678847,227.8732849,547.1342483,18.9453,21.7376163,0.1135446,69.7818003),(23540,'red-deer-metatarsus.tif',246,10,174,173.9798979,47.4372957,62.3098836,1.8,47.3683984,62.3666702,0.022621,21.0028733,11.8974817,4782.7995268,6842.1817463,0.0148352,575.0949573,227.7212006,550.2164949,19.0893405,21.9479481,0.121143,70.3636233),(23541,'red-deer-metatarsus.tif',246,10,175,191.5430473,47.5740172,62.3380734,1.8,47.5679362,62.4223182,0.0097234,22.4478835,11.9618924,4916.4901079,7126.2748173,0.0030182,595.7481146,219.0179807,488.2274635,19.134753,22.2177568,0.0682698,71.1674043),(23542,'red-deer-metatarsus.tif',246,10,176,192.7646736,47.6273249,62.3360425,1.8,47.6287236,62.3913922,0.0036117,22.1881746,12.0536911,4959.5323955,7348.3528751,0.0004193,609.6350752,223.5214242,523.5902946,19.134753,22.4355871,3.0570489,71.9902263),(23543,'red-deer-metatarsus.tif',246,10,177,194.4474417,47.707617,62.3062758,1.8,47.7328687,62.4068454,-0.0021379,21.987777,12.1602625,5014.213472,7565.8394801,0.0001482,622.1773164,228.0454939,551.4863211,19.3078743,22.7477756,3.0079404,72.9049863),(23544,'red-deer-metatarsus.tif',246,10,178,195.5777816,47.7402852,62.3074932,1.8,47.7726194,62.439,-0.0040623,21.0824449,12.318721,5067.7348984,7791.8887635,0.0005377,632.5241666,240.377002,574.7346259,0.189453,0.267927,2.3561945,0.535854),(23545,'red-deer-metatarsus.tif',246,10,179,195.3487878,47.7991741,62.3136433,1.8,47.7950479,62.4104507,-0.0125529,21.9334181,12.4063661,5101.1624278,8021.7934459,0.00513,646.5868721,232.5748961,584.0302073,19.4859741,23.3365803,3.0031399,75.2243913),(23546,'red-deer-metatarsus.tif',246,10,180,196.0188018,47.8285974,62.3475207,1.8,47.8434563,62.4575955,-0.0175095,21.5421663,12.781439,5197.7143392,8294.7011522,0.0100149,648.9645773,241.2809497,622.6055032,19.688476,23.6634305,3.0212098,76.6750053),(23547,'red-deer-metatarsus.tif',246,10,181,197.527535,47.8601326,62.3839009,1.8,47.8924624,62.4325458,-0.0230473,21.6767146,12.8023179,5281.4817174,8615.3921397,0.0174839,672.9556494,243.6477032,634.9682166,0.378906,0.599103,1.8925469,1.450614),(23548,'red-deer-metatarsus.tif',246,10,182,198.4550174,47.913378,62.4212236,1.8,47.95075,62.464095,-0.0266785,21.7921467,12.759144,5362.3531741,8946.8359195,0.0235358,701.209729,246.068148,646.9351753,19.892565,24.3946027,3.0326507,80.5560033),(23549,'red-deer-metatarsus.tif',246,10,183,199.6270796,47.9367269,62.4586614,1.8,47.9899428,62.4939931,-0.0262685,21.7556582,12.9646906,5475.4562788,9320.1904016,0.022953,718.8903068,251.679642,666.2265604,19.892565,24.7922976,3.026716,83.0323563),(23550,'red-deer-metatarsus.tif',246,10,184,200.915716,47.9930793,62.5287862,1.8,48.0544068,62.5436125,-0.0268046,12.0386662,12.6225146,5607.8485306,9715.4779566,0.0240534,769.6943332,465.8197553,1171.429134,20.271471,25.2143367,3.0135098,86.3124903),(23551,'red-deer-metatarsus.tif',246,10,185,202.2003608,48.0746035,62.5359172,1.8,48.1458789,62.5014094,-0.0292356,12.1404108,13.5255617,5770.0979362,10098.7999588,0.0287961,746.6455154,475.2802895,1158.3791206,20.5984624,25.7133161,3.0382583,89.3246974),(23552,'red-deer-metatarsus.tif',246,10,186,200.3931221,48.1032118,62.4871223,1.8,48.173559,62.5169562,-0.0389815,22.0956711,13.6801279,5822.8528561,10530.9042805,0.0507258,769.7957488,263.5291243,640.5781873,20.7940759,26.1314687,3.025331,104.2937944),(23553,'red-deer-metatarsus.tif',246,10,187,203.3668107,48.1583762,62.5715791,1.8,48.2533697,62.6303803,-0.0436209,12.7515323,13.9510584,6085.8547858,11020.1744526,0.0644532,789.9167298,477.2645861,1210.5760728,21.1016711,26.637523,3.049001,103.3330654),(23554,'red-deer-metatarsus.tif',246,10,188,206.9462114,48.2351435,62.6904789,1.8,48.3590907,62.7930889,-0.0451573,12.6756681,14.0248442,6516.6256406,11552.9565291,0.0702858,823.7493688,514.1051036,1281.3707661,21.3620886,27.1453822,3.0787385,110.1343324),(23555,'red-deer-metatarsus.tif',246,10,189,211.0448887,48.2748939,62.7128515,1.8,48.4459731,62.8947774,-0.0526851,13.530607,14.4029004,6946.4172791,12176.0870982,0.0975429,845.3913263,513.3854883,1279.7352241,0.189453,0.4236298,2.0344439,0.91476),(23556,'red-deer-metatarsus.tif',246,10,190,213.911509,48.3095757,62.8130356,1.8,48.5052667,62.9624133,-0.0600552,21.0377553,20.1828458,7248.8254791,12805.7665261,0.1284287,634.4876557,344.5626855,687.8933699,21.9325064,28.0147118,0.1973956,83.3843343),(23557,'red-deer-metatarsus.tif',246,10,191,215.5587545,48.359662,62.9495165,1.8,48.5677905,63.026398,-0.0567054,13.0513832,14.8682984,7500.2769123,13415.0496129,0.1153984,902.258566,574.6729518,1365.952139,22.166001,28.4816611,3.008162,85.0569063),(23558,'red-deer-metatarsus.tif',246,10,192,217.3539746,48.4121929,63.0815818,1.8,48.6200121,63.1583843,-0.0577305,13.3678725,15.1060021,7781.6554039,14067.3399638,0.1205994,931.2417601,582.1162193,1392.934657,22.6868951,28.99807,3.0237206,86.9514363),(23559,'red-deer-metatarsus.tif',246,10,193,219.765903,48.5324326,63.1887405,1.8,48.7568333,63.2076209,-0.0618712,13.2804697,15.4106347,8095.6667859,14825.6511086,0.1400333,962.0402683,609.5919024,1413.9692951,23.0805492,29.6540851,2.9617392,88.7349873),(23560,'red-deer-metatarsus.tif',246,10,194,222.9279943,48.6161932,63.3421259,1.8,48.8391535,63.3161233,-0.0640867,13.8303454,15.1295569,8450.7156952,15614.3870283,0.1523893,1032.0452331,611.0270913,1510.9958979,23.482068,30.3556682,2.9405251,91.0543923),(23561,'red-deer-metatarsus.tif',246,10,195,228.6461493,48.6696698,63.4729918,1.8,48.8925179,63.3876065,-0.0680685,13.7642633,15.36467,8909.4921958,16537.7275175,0.1762926,1076.3477172,647.2916149,1553.4824755,23.7574329,31.1360688,2.9394239,93.3737973),(23562,'red-deer-metatarsus.tif',246,10,196,237.7407387,48.7705891,63.6030556,1.8,48.9729881,63.4818859,-0.0659432,13.9039106,15.757517,9442.6728317,17781.6468576,0.1720529,1128.4548762,679.1379135,1603.981855,23.9581505,32.0265239,2.896614,96.6079623),(23563,'red-deer-metatarsus.tif',246,10,197,249.9668782,48.8944235,63.7373661,1.8,49.0405276,63.5179701,-0.0624165,14.0505574,16.0735143,10019.4400945,19464.7264816,0.1620942,1210.9813794,713.0991206,1670.2558532,24.3365372,33.1331578,2.8813586,99.5472723),(23564,'red-deer-metatarsus.tif',246,10,198,269.0109061,48.9641794,63.8608149,1.8,49.0336503,63.5730764,-0.068943,14.2290803,16.4046367,10852.3767474,21602.0204154,0.2127706,1316.8240707,762.6899639,1799.6866616,24.5704356,33.8824389,2.864061,101.6177913),(23565,'red-deer-metatarsus.tif',246,10,199,292.5470468,49.1036861,63.8529564,1.8,49.0437703,63.5617861,-0.0678407,14.1345945,16.7492194,11737.4101529,23995.5540459,0.224057,1432.6371578,830.4030308,1964.2929866,24.6384494,34.4294016,2.868584,104.3430303),(23566,'red-deer-metatarsus.tif',246,10,200,305.2032538,49.1120304,63.7561871,1.8,49.0089087,63.5952671,-0.0788339,22.1039411,17.1332143,12491.4501741,25724.134255,0.3154743,1501.4190451,565.1232105,1595.3330606,24.7593227,34.9272419,2.878195,106.0425304),(23567,'red-deer-metatarsus.tif',246,10,201,303.7314898,49.019617,63.5817535,1.8,49.0805712,63.6144648,-0.079407,13.777037,17.7114569,12604.1077376,26347.5188219,0.3185244,1487.5974901,914.8634612,2046.2951255,25.177525,35.3810769,2.8927179,109.6634884),(23568,'red-deer-metatarsus.tif',246,10,202,293.2528009,48.8666549,63.8425017,1.8,49.0912198,63.9049965,-0.0942639,13.6855041,18.2640172,12049.215087,25425.7438146,0.4330069,1392.122204,880.4363339,1928.0419827,25.8620513,35.4783307,0.053425,112.1779234),(23569,'red-deer-metatarsus.tif',246,10,203,287.0834127,49.0471084,64.2326322,1.8,49.1412563,64.4131439,-0.0798279,14.3136002,17.9625235,11530.4448084,24467.6991697,0.3042587,1362.1526624,805.5586751,1857.9001391,25.8802095,35.8567018,0.0528608,115.4659444),(23570,'red-deer-metatarsus.tif',246,10,204,281.4049895,49.1894187,64.5172996,1.8,49.2077247,64.8110912,-0.0535258,13.5148096,17.9919706,11202.4710426,23714.1837831,0.1342428,1318.0426039,828.903356,1800.9637577,0.8575624,2.3434042,1.3258177,5.645508),(23571,'red-deer-metatarsus.tif',246,10,205,278.2420282,49.2667576,64.8176095,1.8,49.2997332,65.1602743,-0.0454488,20.7677421,18.3069737,11309.368504,23548.3441527,0.0957235,1286.3045792,544.5641826,1483.4072912,1.6740517,2.9955149,1.8925469,10.0433191),(23572,'red-deer-metatarsus.tif',246,10,206,286.1076169,49.3139709,65.0902838,1.8,49.4611791,65.4624846,-0.0288452,20.1409004,18.7204421,12361.4587553,24747.1431952,0.0396647,1321.9315613,613.7490626,1549.299026,1.7079996,5.2022014,1.3876855,15.6888271),(23573,'red-deer-metatarsus.tif',246,10,207,292.9719372,49.2408423,64.9970838,1.8,49.4710625,65.4129068,-0.0012129,19.8941806,19.1477882,13515.5385319,26385.4103659,0.0000718,1377.9873749,679.3714617,1661.7909424,1.5918265,3.9558948,1.2793395,13.4804011),(23574,'red-deer-metatarsus.tif',246,10,208,299.1739657,49.2024223,64.9413099,1.8,49.4990715,65.438328,0.006155,27.0283828,19.2308128,14233.926542,27769.2095642,0.0018893,1443.995627,526.6288653,1539.5966106,1.286898,3.8314498,1.4219064,10.1083291),(23575,'red-deer-metatarsus.tif',246,10,209,306.2518786,49.2595806,64.9157862,1.8,49.6032739,65.4331347,-0.0058423,14.5409738,19.1001388,14514.2436036,28805.2111542,0.0017425,1508.1152777,998.1617359,2113.1936054,1.0993686,5.6962062,1.5042282,13.4075041),(23576,'red-deer-metatarsus.tif',246,10,210,310.798102,49.2772743,64.9740914,1.8,49.5966189,65.400047,-0.0147711,17.6325108,25.8673991,14246.2350676,29548.6229058,0.0113012,1142.3113238,807.9527211,1398.9555987,1.1051566,4.2362979,1.3909428,11.4939331),(23577,'red-deer-metatarsus.tif',246,10,211,312.1892603,49.3556259,64.9918452,1.8,49.6439369,65.3947179,-0.0201912,18.074575,25.5078841,13437.2644792,29975.4994076,0.0212096,1175.1464499,743.4346022,1401.8700851,0.6578386,2.1181489,1.3909428,4.952706),(23578,'red-deer-metatarsus.tif',246,10,212,310.8971542,49.4334379,65.0104928,1.8,49.6769591,65.3242044,-0.0238861,20.0226543,22.8897222,12221.4407658,29645.2196524,0.029558,1295.1323453,610.3806496,1433.40007,17.3277712,25.8219644,1.5047162,78.8138012),(23579,'red-deer-metatarsus.tif',246,10,213,298.7864579,49.5397808,65.0092769,1.8,49.7220815,65.2228348,-0.0305475,20.0981885,18.3329616,10363.8929166,27678.1314116,0.0464545,1509.7468718,515.663038,1570.929409,17.3363828,24.8537498,1.517412,101.6447193),(23580,'red-deer-metatarsus.tif',246,10,214,274.6637042,49.8252651,64.9513312,1.8,49.8635194,65.1062851,-0.0293655,19.4465743,17.7063021,8077.4791018,23726.1488521,0.0394641,1339.9832868,415.3677136,1271.5443439,17.1742312,23.3650166,1.4977558,96.0911493),(23581,'red-deer-metatarsus.tif',246,10,215,219.4506695,50.901142,64.7923175,1.8,50.402788,64.8685239,-0.0219376,19.6248927,18.2045412,5617.5009867,14520.316117,0.0175992,797.6205465,286.2436534,846.1341502,16.6512731,21.8167284,1.5186697,71.4655262),(23582,'red-deer-metatarsus.tif',246,10,216,160.0512604,50.5766957,64.6821937,1.8,50.9535943,64.6164202,-0.0190664,11.1745747,15.7088239,3469.0511744,6688.3237465,0.009696,425.7685864,310.4414503,642.9801052,9.6242609,19.7149493,1.2277724,53.5223041),(23583,'red-deer-metatarsus.tif',246,10,217,117.6586678,50.5052516,64.5723274,1.8,50.4943565,64.5602473,-0.0168923,11.652075,10.3370661,1522.2350287,4748.7659223,0.0055951,459.3920424,130.6406824,439.28162,9.093744,16.8910923,1.1673773,50.2231291),(23584,'red-deer-metatarsus.tif',246,10,218,44.5710244,50.8768514,64.7740318,1.8,50.7363721,64.6309908,-0.0192543,19.7530892,11.2644189,266.6554314,2314.2731958,0.0027536,205.4498517,13.4994293,113.5012448,8.335932,12.5168086,1.525373,38.6339911),(23585,'red-deer-metatarsus.tif',246,10,219,1.2695591,52.0589252,65.7905987,1.8,51.9626799,66.1869334,0.0618321,18.4231202,11.7738186,13.6956941,92.2446286,0.0008079,7.8347248,0.7433971,4.9596713,1.515624,4.7514571,1.4909663,10.728234),(23586,'red-deer-metatarsus.tif',246,10,220,0.0132802,59.6106649,84.4957277,1.8,59.614544,84.496038,-0.0229767,0.1869006,2.5335968,0.0001704,0.0464886,0.0000012,0.0183488,0.0009116,0.0183915,0.189453,0.599103,2.8198421,1.182687),(23587,'red-deer-metatarsus.tif',246,10,221,0.0131932,59.0774742,84.4969751,1.8,59.0777605,84.496038,-0.0249967,0.1987238,3.3772134,0.0002999,0.0864528,0.0000014,0.0255988,0.001509,0.0256794,0.189453,0.4236298,2.677945,0.803781),(23588,'red-deer-metatarsus.tif',246,10,222,0.0090928,62.042005,84.306585,1.8,62.0458575,84.306585,0.0674459,0.0194118,0.2873771,0.000029,0.0004262,0.0000069,0.0014829,0.0014948,0.0015803,0.189453,0.7811347,2.896614,1.561593),(23589,'red-deer-metatarsus.tif',246,10,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23590,'red-deer-metatarsus.tif',246,10,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23591,'humerus.tif',244,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23592,'humerus.tif',244,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23593,'humerus.tif',244,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23594,'humerus.tif',244,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23595,'humerus.tif',244,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23596,'humerus.tif',244,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23597,'humerus.tif',244,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23598,'humerus.tif',244,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23599,'humerus.tif',244,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23600,'humerus.tif',244,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23601,'humerus.tif',244,2,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23602,'humerus.tif',244,2,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23603,'humerus.tif',244,2,13,0.8621366,16.2567162,14.6266857,1.8,16.3634386,14.6157866,0.3326722,0.6396108,1.3658764,0.0390189,0.2486945,0.0153242,0.1820768,0.0610041,0.2003126,1.2312673,2.5995112,2.9533711,7.475562),(23604,'humerus.tif',244,2,14,16.4717338,16.4009184,14.3293938,1.8,15.8765383,15.9631979,-1.2874512,2.9357723,8.3046253,25.3169656,231.6710538,2.5307205,27.8966292,8.6236134,30.7011947,2.6397032,5.7711982,2.7865211,14.1391193),(23605,'humerus.tif',244,2,15,40.8341196,15.9513153,16.1982409,1.8,15.9740025,16.1426538,-1.2683973,3.6216539,7.5776404,93.8314037,739.7595324,6.2020797,97.6239955,25.9084403,109.1698242,7.2277162,15.107057,1.4619169,50.0195822),(23606,'humerus.tif',244,2,16,56.6832267,15.6385196,16.6104316,1.8,15.7022417,16.5866589,-1.1871792,5.12507,7.7216687,264.3412975,1055.3358096,8.1238084,136.6719876,51.5780853,163.5384934,9.1096163,15.7772197,1.632494,53.6798037),(23607,'humerus.tif',244,2,17,69.9030899,15.1347986,16.7730157,1.8,15.3168491,16.729087,-1.1584348,6.0820367,8.1446973,539.8816558,1408.9717647,9.7792113,172.9925273,88.7665896,228.3143896,11.3833322,16.4272558,0.6805212,59.1421136),(23608,'humerus.tif',244,2,18,76.6165405,14.9582037,16.7008813,1.8,15.099859,16.7218973,-1.2516383,6.7732598,8.5038173,770.7278315,1600.2620416,11.5122758,188.1816121,113.7897939,272.0022292,12.3828706,16.9060087,1.8663868,60.3911983),(23609,'humerus.tif',244,2,19,78.1868873,15.0270793,16.7243664,1.8,15.121884,16.6718438,-1.3034611,7.2857923,8.7503164,895.2029196,1645.2641574,12.121812,188.0233899,122.8696729,283.7028645,13.0112572,17.2176759,1.950647,59.6763508),(23610,'humerus.tif',244,2,20,77.7550051,15.1796445,16.7060909,1.8,15.2286511,16.6535688,-1.3226184,7.5914749,8.9217036,966.8482781,1652.9821108,12.1772361,185.2765104,127.3597405,285.7814951,13.3993106,17.4279787,1.9798109,61.9536662),(23611,'humerus.tif',244,2,21,78.0819639,15.2430528,16.5920123,1.8,15.2581852,16.5703634,-1.3762073,7.8345842,9.0164537,1021.943495,1719.5574863,12.527088,190.713282,130.4400423,298.8011992,13.6542641,17.6236122,2.0128424,61.7435509),(23612,'humerus.tif',244,2,22,77.5331442,15.2811873,16.5086372,1.8,15.2621485,16.5471574,-1.4193779,8.0157234,9.0297987,1024.6605043,1737.0660188,12.628174,192.3704027,127.8313202,303.6379214,13.8005076,17.71629,2.0758948,61.5568299),(23613,'humerus.tif',244,2,23,77.2888977,15.225372,16.4351581,1.8,15.1678893,16.5279335,-1.4933305,8.1437395,9.1380176,1010.6833704,1729.6383954,12.8043363,189.2793899,124.1055617,299.6374249,13.833739,17.7296391,2.0912185,62.8048662),(23614,'humerus.tif',244,2,24,77.2961564,15.176329,16.301763,1.8,15.1141117,16.4257096,-1.5260753,8.1746974,8.9805678,976.4815399,1732.6822887,12.856945,192.936831,119.4517045,299.8275218,13.7711134,17.6739863,2.1129857,64.0356188),(23615,'humerus.tif',244,2,25,77.3755207,15.0337702,16.123896,1.8,15.0140386,16.3749714,-1.5218535,8.0250352,8.6241919,929.9765991,1696.399877,12.865054,196.7024722,115.8844261,294.7525884,13.5980866,17.5241173,2.1385899,63.6891509),(23616,'humerus.tif',244,2,26,74.0974541,14.7187391,16.1469247,1.8,14.7459658,16.3118565,-1.5580755,7.8295864,8.2561136,862.3542698,1575.1435011,12.3475774,190.7851057,110.140463,276.8710622,13.3243044,17.1884519,2.13427,63.2912662),(23617,'humerus.tif',244,2,27,66.8253668,14.0288255,16.5436001,1.8,14.1249097,16.6054273,1.4256417,7.3197262,8.5650292,687.2079484,1405.6313278,10.9045379,164.112848,93.8843785,236.6446486,12.6263099,16.8291944,2.1608029,72.542991),(23618,'humerus.tif',244,2,28,62.144771,13.4746286,16.7790304,1.8,13.5192367,16.898005,1.3658312,6.7285672,8.7080503,562.9074028,1301.5312547,9.9283968,149.4629922,83.6593267,210.8363506,11.4719627,16.3773356,2.1793933,67.9908914),(23619,'humerus.tif',244,2,29,59.0835386,13.0747461,16.8007841,1.8,13.0899929,16.8085798,1.3499827,6.282967,8.5626738,463.7453544,1225.2423105,9.3748705,143.0910878,73.8099296,194.7105175,10.8401186,15.8745067,2.1874839,64.2457341),(23620,'humerus.tif',244,2,30,56.2896067,12.6679463,16.6615615,1.8,12.6916562,16.6425892,1.371647,5.8164354,8.212523,367.5207426,1138.1751961,9.0144156,138.5901981,63.1865943,180.7301317,10.2355713,15.3843228,2.0874915,59.773508),(23621,'humerus.tif',244,2,31,53.0365078,12.2488869,16.4156041,1.8,12.3500019,16.422758,1.4226919,5.3213674,7.7501863,283.064386,1023.7138475,8.6469395,132.0889334,53.1939188,165.3701053,9.5955854,15.0828126,2.0849425,58.9665656),(23622,'humerus.tif',244,2,32,51.7317556,12.042892,16.2124646,1.8,12.182501,16.2171306,1.4424348,5.0121164,7.3985249,245.3012492,931.4500669,8.4806765,125.8967271,48.941651,155.0023409,9.1309201,14.8472807,2.0472637,56.3453135),(23623,'humerus.tif',244,2,33,51.7226485,11.9812286,16.050353,1.8,12.1523474,16.0593265,1.4324616,4.9538565,7.1146344,235.405342,851.5176051,8.4565261,119.6853634,47.5196122,148.4412078,8.9139524,14.5526807,2.062474,58.4837452),(23624,'humerus.tif',244,2,34,52.3699686,11.9525477,15.9310045,1.8,12.1407837,15.9206495,1.4193048,4.8741447,6.8741738,236.5034579,776.7366694,8.5295434,112.993458,48.522043,143.2970891,8.7668211,14.2084804,2.0803886,49.7097786),(23625,'humerus.tif',244,2,35,52.5173909,11.9248671,15.836503,1.8,12.0525796,15.7935176,1.4079929,4.6778265,6.6435019,238.8423402,708.2994534,8.5229456,106.6153758,51.0584009,138.4127893,8.7637583,13.7420109,2.0740272,52.0608567),(23626,'humerus.tif',244,2,36,52.046069,11.9147862,15.7945695,1.8,11.9752048,15.7297654,1.3848669,4.6138061,6.4597309,245.6270978,656.1881909,8.3779146,101.5813512,53.2374129,135.7246854,8.71668,13.3573328,2.1057514,37.0924491),(23627,'humerus.tif',244,2,37,51.1407308,11.9177135,15.7612349,1.8,11.9200977,15.6985804,1.3587489,4.6304075,6.2912618,253.7594939,610.4024103,8.1459153,97.0238455,54.8028425,133.4132655,8.8673921,13.0249725,2.1264268,36.7276491),(23628,'humerus.tif',244,2,38,50.7835805,11.9564914,15.7378724,1.8,11.9476211,15.6900821,1.3296679,4.5821017,6.1600704,260.626658,570.6903879,7.9812767,92.6434844,56.8792828,130.8367126,8.8565395,12.7221733,2.1243298,36.6564174),(23629,'humerus.tif',244,2,39,50.778839,12.0109107,15.7159726,1.8,11.9822998,15.681659,1.2958819,4.567347,6.0467493,267.4138308,536.7036202,7.8394657,88.7590335,58.5490505,129.1486258,8.8768002,12.4320765,2.1330244,35.8678072),(23630,'humerus.tif',244,2,40,50.5638559,12.0803202,15.6960747,1.8,12.0402461,15.6859464,1.2727919,4.5291119,5.9170425,271.6736811,504.9161311,7.7008021,85.3325167,59.9838742,127.2605202,8.9437036,12.1590883,2.1712809,36.0397756),(23631,'humerus.tif',244,2,41,49.793812,12.1567606,15.6853532,1.8,12.118249,15.7064955,1.2419828,4.5242485,5.8328619,275.472081,477.8649848,7.4335725,81.9263331,60.8879198,125.544936,8.9611035,11.9243979,2.1785983,35.633249),(23632,'humerus.tif',244,2,42,49.4167511,12.2380826,15.6753431,1.8,12.2089078,15.693024,1.20743,4.5295978,5.7307493,276.0975664,454.3521667,7.1956941,79.2832035,60.9541024,123.7352582,0.0608,0.1359529,2.0344439,0.2935684),(23633,'humerus.tif',244,2,43,49.0449701,12.3234036,15.6580693,1.8,12.2922896,15.6913934,1.1767875,4.5528781,5.662112,276.0706718,434.9807016,6.9695035,76.8230482,60.636517,122.7923561,8.9984002,11.4918437,2.2248791,33.7563495),(23634,'humerus.tif',244,2,44,48.761114,12.4183659,15.6494165,1.8,12.3773818,15.7082651,1.1431276,4.5183376,5.5739722,276.5059219,415.3804551,6.7288867,74.5214433,61.1963842,121.4507642,8.9851772,11.2899889,2.2455373,34.1150388),(23635,'humerus.tif',244,2,45,48.3761127,12.522604,15.641747,1.8,12.4853776,15.7117325,1.1045883,4.5066306,5.4543205,276.5481872,396.4501808,6.4336019,72.6855308,61.3647333,121.1033682,8.9780896,11.0625933,2.254979,32.7774387),(23636,'humerus.tif',244,2,46,47.8168529,12.6337961,15.6415466,1.8,12.597612,15.709708,1.0609572,4.5005437,5.354497,276.2348945,378.534746,6.0713063,70.6947347,61.3781161,120.4057391,8.9541631,10.8558228,2.2927875,33.3584648),(23637,'humerus.tif',244,2,47,47.475122,12.7516815,15.6328348,1.8,12.7216117,15.7025532,1.0108958,4.5071797,5.2765777,276.0941172,364.6753022,5.6806414,69.1120878,61.2565139,120.181694,8.968252,10.6675851,2.3239476,32.3622704),(23638,'humerus.tif',244,2,48,47.4405018,12.8639019,15.6037724,1.8,12.8458518,15.6929396,0.9685711,4.5065532,5.2030543,274.3331639,355.0005981,5.3694983,68.2292704,60.8742759,119.7346205,8.8591286,10.5352561,2.3357892,31.6891494),(23639,'humerus.tif',244,2,49,47.0111629,13.0017374,15.6124919,1.8,12.9808286,15.6741326,0.9047328,4.525411,5.2018158,274.3856238,345.4879181,4.8437555,66.4167923,60.6321995,117.7489441,8.8380157,10.4168698,2.4057407,31.4103336),(23640,'humerus.tif',244,2,50,47.0558876,13.1297461,15.5874506,1.8,13.1137142,15.6562746,0.8402617,4.5282014,5.1708361,272.8440646,340.3529802,4.3507368,65.8216536,60.2544011,118.4129711,8.8535114,10.330992,2.4061529,31.3599652),(23641,'humerus.tif',244,2,51,47.0595357,13.280714,15.5763443,1.8,13.258505,15.6317765,0.7822344,4.5270906,5.14406,271.9678673,336.1906029,3.8968136,65.3551095,60.0756404,114.4491347,8.8370895,10.2369943,2.452938,30.9595494),(23642,'humerus.tif',244,2,52,46.7493592,13.4313028,15.579728,1.8,13.3982811,15.6136932,0.7334769,4.5267852,5.1713955,271.4270919,329.4300601,3.4919587,63.7023523,59.9602327,116.1872415,8.8373982,10.1825028,2.4407382,30.8170861),(23643,'humerus.tif',244,2,53,46.9086155,13.538825,15.5500601,1.8,13.5333188,15.5914606,0.6880137,4.4991111,5.0965973,270.2589307,326.6793687,3.1524941,64.0975433,60.0694064,114.6778662,8.8641446,10.1045139,2.449936,30.7606071),(23644,'humerus.tif',244,2,54,46.516006,13.6817201,15.5227464,1.8,13.6870126,15.5709244,0.6662306,4.480218,5.0635615,267.9987016,323.4106143,2.9611889,63.8701859,59.818228,113.1923403,8.8160002,10.0465449,2.4763032,30.6390071),(23645,'humerus.tif',244,2,55,45.4528563,13.8591463,15.522586,1.8,13.8501125,15.5559427,0.6064937,4.4704414,5.0418667,265.1500269,316.7430738,2.4611862,62.8225805,59.3118222,114.9615711,8.8160002,9.9611855,2.4773375,30.3958071),(23646,'humerus.tif',244,2,56,45.0075572,14.0207266,15.5154431,1.8,14.003881,15.5381151,0.5472505,4.4509007,5.1108581,262.4976078,313.9014407,2.0310037,61.4185401,58.976289,111.7939562,8.7552002,9.9105868,2.5042264,30.274207),(23647,'humerus.tif',244,2,57,45.0475453,14.1709281,15.4955691,1.8,14.1659021,15.5204779,0.5023673,4.4341033,4.9513978,260.9280189,313.324798,1.7406665,63.2800703,58.8457243,114.5778063,8.7552002,9.8387103,2.5141594,30.2385912),(23648,'humerus.tif',244,2,58,45.2201978,14.3226254,15.4661355,1.8,14.3241996,15.4982012,0.4677139,4.4009725,5.1506753,259.7820859,312.6113946,1.5319316,60.6932829,59.0283372,110.8294431,8.6944002,9.7767083,2.5018229,30.1673596),(23649,'humerus.tif',244,2,59,45.3484618,14.4785324,15.4421162,1.8,14.485849,15.4724494,0.4298709,4.4122467,4.8593423,258.6555457,312.7485137,1.3127126,64.3602558,58.6221864,115.5831403,8.7151318,9.7327491,2.5293314,30.4044489),(23650,'humerus.tif',244,2,60,45.6331269,14.6309378,15.4161694,1.8,14.6407464,15.4480046,0.3868211,4.3961856,5.0955241,258.0918104,313.5934421,1.0823779,61.5429221,58.7081244,112.1935775,8.6710053,9.6994584,2.5796711,30.1612489),(23651,'humerus.tif',244,2,61,45.7615339,14.7942032,15.3924117,1.8,14.8102687,15.4185643,0.3407913,4.3815288,5.101318,257.1783239,314.284389,0.8520161,61.6084683,58.6960256,111.9822729,8.6336002,9.6870641,2.5936383,30.2828489),(23652,'humerus.tif',244,2,62,45.8343198,14.9643095,15.3693954,1.8,14.982476,15.3905572,0.29444,4.3592768,5.1400581,256.1420422,316.3465571,0.6433485,61.5453266,58.7579209,111.0001181,8.5728002,9.6765643,2.6076386,30.0752647),(23653,'humerus.tif',244,2,63,45.7962897,15.1353873,15.345832,1.8,15.1504222,15.3668892,0.2483964,4.3268779,4.8328907,254.7493302,318.058375,0.4613377,65.8112082,58.8760158,116.8453208,8.560522,9.6765643,2.6076386,30.3688331),(23654,'humerus.tif',244,2,64,45.9140196,15.3077303,15.3140555,1.8,15.3168069,15.3307948,0.2139552,4.3105235,5.1252227,253.7224162,321.4150072,0.3449869,62.7123981,58.8611601,111.0492848,8.5120002,9.6929772,2.7960371,30.1108805),(23655,'humerus.tif',244,2,65,46.0965191,15.4777247,15.2831162,1.8,15.4860364,15.2964147,0.1858696,4.2759291,5.0843646,253.073901,325.9274209,0.2623775,64.103865,59.1857103,112.2811779,8.4512002,9.7348378,2.784284,30.1464963),(23656,'humerus.tif',244,2,66,46.2817479,15.6463663,15.2468777,1.8,15.6518047,15.2563101,0.1650951,4.2552255,5.0958413,252.5068703,330.5013767,0.2083424,64.8570775,59.3404203,112.8034411,8.4512002,9.7560797,2.744884,30.3332173),(23657,'humerus.tif',244,2,67,46.4070802,15.8137708,15.2116172,1.8,15.8145798,15.2192127,0.1470187,4.2372693,5.0772288,252.2227708,335.4785986,0.1659767,66.0751393,59.5248388,113.3403339,8.3904002,9.7872896,2.8060905,30.2533438),(23658,'humerus.tif',244,2,68,46.4303127,15.9798924,15.1717117,1.8,15.9800243,15.1802543,0.1260415,4.220063,5.0934007,251.7604099,339.8795723,0.1222858,66.7293996,59.657975,113.5249066,8.3904002,9.8279963,2.7944073,30.6120331),(23659,'humerus.tif',244,2,69,46.2805591,16.1536762,15.1361557,1.8,16.1527938,15.1464258,0.0998395,4.1937169,5.0409156,250.7296975,343.3537578,0.0766317,68.1133717,59.7869866,113.9459248,8.3296002,9.9021907,2.8295505,30.4904331),(23660,'humerus.tif',244,2,70,46.2151375,16.3192546,15.0969615,1.8,16.3197273,15.1089798,0.0862306,4.1707591,5.0424675,250.457948,348.643111,0.057132,69.1413697,60.050926,114.2600499,8.3296002,9.9468877,3.0559134,30.7840015),(23661,'humerus.tif',244,2,71,46.1717211,16.4777531,15.0544612,1.8,16.477642,15.0698833,0.0719843,4.1520116,5.0428485,250.4558212,353.5789047,0.0398062,70.1149178,60.3215607,119.2190089,8.3296002,10.007466,3.0564333,30.8552331),(23662,'humerus.tif',244,2,72,46.1348512,16.6379293,15.0122819,1.8,16.6427637,15.0307482,0.0587439,4.1527465,5.0699509,250.6252278,359.0388663,0.0265035,70.8170308,60.3516795,115.6085389,8.3296002,10.068047,3.0569469,31.163554),(23663,'humerus.tif',244,2,73,46.0664894,16.794727,14.9695849,1.8,16.791785,14.9898746,0.0526167,4.1422249,5.1946522,250.9481784,364.6292064,0.0212364,70.1931893,60.5829431,115.1560477,8.2688002,10.1237023,3.0634389,31.3207698),(23664,'humerus.tif',244,2,74,46.0747842,16.9551043,14.9282042,1.8,16.950993,14.9460621,0.0425186,4.1282808,5.1578889,251.7902855,370.6552424,0.0138742,71.8618121,60.9915598,117.1610468,8.2688002,10.1843179,3.063905,31.2347857),(23665,'humerus.tif',244,2,75,46.0769177,17.1076323,14.8897915,1.8,17.1040426,14.9039357,0.0359619,4.1465614,5.2375309,252.2312555,377.2185551,0.0099273,72.0222115,60.8290178,117.1225345,8.2688002,10.2550337,3.0525431,31.1844173),(23666,'humerus.tif',244,2,76,46.0911634,17.2539806,14.8477149,1.8,17.24773,14.8585874,0.0320692,4.1608021,5.1781547,253.187488,383.1663365,0.0078976,73.9966959,60.8506447,117.488122,8.3296002,10.3268762,0.1477255,31.528354),(23667,'humerus.tif',244,2,77,46.0612258,17.4008152,14.8016214,1.8,17.3903109,14.8152745,0.0263644,4.1710776,5.2749721,253.8535453,388.6051071,0.0053348,73.6696048,60.8604233,118.0043673,8.3296002,10.3661774,0.076322,31.5639699),(23668,'humerus.tif',244,2,78,46.0316531,17.5351567,14.7560157,1.8,17.5289474,14.7685965,0.0191516,4.1779041,5.2790209,254.3601008,393.5864441,0.0028136,74.5567132,60.8822262,118.9173591,8.3296002,10.4315865,3.0599035,31.5995857),(23669,'humerus.tif',244,2,79,46.0725341,17.6725651,14.7079115,1.8,17.6660563,14.7242865,0.0103098,4.1355954,5.2828162,255.3554202,398.4491263,0.0008161,75.4236214,61.7457447,119.6382349,8.2688002,10.4904232,0.1337005,32.0651224),(23670,'humerus.tif',244,2,80,45.9622663,17.8032624,14.6604311,1.8,17.7998944,14.6805868,0.0009078,4.1426464,5.2796812,255.744394,402.9467991,0.0000063,76.3202904,61.7345462,120.3540998,8.3296002,10.5147094,0.1042716,31.6708173),(23671,'humerus.tif',244,2,81,45.8909842,17.9292737,14.6159019,1.8,17.9291511,14.6358813,-0.0086801,4.1623085,5.3327098,256.6002626,406.3073225,0.0005763,76.1915311,61.6485446,120.5352862,8.3296002,10.6031089,0.1264887,31.771554),(23672,'humerus.tif',244,2,82,45.7724981,18.0516517,14.5716587,1.8,18.0544838,14.5909202,-0.0156391,4.1780581,5.3858921,257.3756941,409.4903989,0.0018657,76.0301906,61.6017507,120.4617923,8.3296002,10.6356565,3.038511,32.7529959),(23673,'humerus.tif',244,2,83,45.7634841,18.1718377,14.5255212,1.8,18.1748025,14.5491408,-0.0217146,4.1447496,5.377604,258.4491664,413.4104945,0.0035959,76.8763359,62.3557972,121.609072,8.3296002,10.6900858,3.0447536,33.0969327),(23674,'humerus.tif',244,2,84,45.6326553,18.2938287,14.4825237,1.8,18.3036769,14.5076204,-0.0250769,4.1602901,5.374784,259.1573985,416.7219816,0.0047817,77.5327868,62.2931081,121.9554497,8.3296002,10.7395936,3.0565708,32.323075),(23675,'humerus.tif',244,2,85,45.5816411,18.4147005,14.4371912,1.8,18.4219279,14.4636409,-0.0288677,4.1740739,5.4296388,260.3857907,419.7946125,0.0063291,77.3153848,62.3816919,121.6596334,8.3296002,10.7823622,3.0795256,32.5810275),(23676,'humerus.tif',244,2,86,45.4822363,18.5288435,14.3907288,1.8,18.5368393,14.4217813,-0.0291292,4.1829695,5.4839775,261.3887765,421.8499625,0.0064303,76.9240865,62.4888084,121.2827211,8.3296002,10.8001752,3.0570489,32.3734433),(23677,'humerus.tif',244,2,87,45.4021377,18.6376939,14.3445265,1.8,18.6436401,14.3781379,-0.0324418,4.1878159,5.4686096,262.9734282,423.3604326,0.0079613,77.416466,62.7948881,121.7621299,8.3904002,10.8430458,3.0798734,32.782501),(23678,'humerus.tif',244,2,88,45.3374331,18.7385363,14.29195,1.8,18.743341,14.3249639,-0.0383153,4.1779007,5.503451,263.9670083,425.0217381,0.0110877,77.2282231,63.1817337,121.6263458,8.3904002,10.8607593,0.084071,32.4238117),(23679,'humerus.tif',244,2,89,45.2469184,18.8367233,14.244513,1.8,18.8410722,14.2791219,-0.0435863,4.1797093,5.5338795,264.8409827,426.1699088,0.0143174,77.0110563,63.3634928,121.6486522,8.3904002,10.8775944,0.100781,32.2874592),(23680,'humerus.tif',244,2,90,45.2912331,18.9365306,14.1975093,1.8,18.9460416,14.2347345,-0.049654,4.1847421,5.5068669,266.8602448,427.5832037,0.0185959,77.6454578,63.7698192,122.1392793,8.3904002,10.9164367,0.0780534,32.3734433),(23681,'humerus.tif',244,2,91,45.2639954,19.0241202,14.1541917,1.8,19.0289907,14.1864476,-0.0566823,4.186251,5.5846295,268.5759574,428.5390967,0.0242121,76.7354574,64.1566781,121.6770732,8.3904002,10.9047477,0.1229719,32.5810275),(23682,'humerus.tif',244,2,92,45.3395299,19.1188207,14.1074823,1.8,19.1349514,14.1419822,-0.065588,4.2064011,5.5452524,270.5803945,430.1706685,0.0324603,77.5745871,64.3258655,122.3565327,8.4481252,10.9443381,0.1057493,32.2223382),(23683,'humerus.tif',244,2,93,45.3773279,19.2085818,14.0632874,1.8,19.2214636,14.097926,-0.0717964,4.2098702,5.5645154,272.661504,431.8301246,0.0389178,77.6042645,64.7672004,122.5778781,8.4512002,10.9578404,0.1167846,32.2223382),(23684,'humerus.tif',244,2,94,45.5349151,19.2976309,14.0160247,1.8,19.3024082,14.0507932,-0.076131,4.2191617,5.5901825,275.0364482,433.5101574,0.0439014,77.548481,65.1874635,122.6378196,8.4644536,10.9927008,0.0941651,32.323075),(23685,'humerus.tif',244,2,95,45.6559306,19.3774937,13.9720314,1.8,19.3820187,14.0087455,-0.0795618,4.2387578,5.6031053,277.7894271,434.9614969,0.0480661,77.6286493,65.5355745,123.3572062,8.4874179,11.0182286,0.1161416,32.3943066),(23686,'humerus.tif',244,2,96,45.7333191,19.4579264,13.9262719,1.8,19.4591085,13.9620484,-0.0830453,4.2380418,5.5659711,279.3090373,436.368562,0.0524461,78.399358,65.9052103,124.4539774,8.4512002,11.0182286,0.1161416,32.3439382),(23687,'humerus.tif',244,2,97,46.0256086,19.5277682,13.884516,1.8,19.5332507,13.9142206,-0.0933526,4.2559084,5.6198271,283.2513764,440.8969808,0.0666561,78.4538334,66.5548568,124.8131553,8.5120002,11.0329808,0.1270891,32.5515224),(23688,'humerus.tif',244,2,98,45.8742201,19.5931112,13.8445364,1.8,19.6006242,13.8748107,-0.1048441,4.2805487,5.5578911,284.680544,441.1243662,0.0837364,79.3690195,66.5056192,125.7631257,8.5120002,11.0254395,0.121619,32.5367699),(23689,'humerus.tif',244,2,99,45.9706583,19.6642791,13.8082717,1.8,19.6652291,13.8393892,-0.1154767,4.3651596,5.6039988,289.1120529,442.7074495,0.1017156,78.9984908,66.2317258,125.6551301,8.5728002,11.0349909,0.1660545,32.7234908),(23690,'humerus.tif',244,2,100,46.1055798,19.7283067,13.7938776,1.8,19.7311069,13.8275728,-0.1282166,4.4426808,5.5815283,296.3075492,445.3869553,0.1256348,79.7965956,66.6956643,127.3336489,8.6944002,11.077787,0.187708,32.9519383),(23691,'humerus.tif',244,2,101,46.2646017,19.7847162,13.7661633,1.8,19.7895364,13.8087036,-0.1460871,4.5146932,5.5672321,301.8887557,447.9340656,0.1633915,80.4590242,66.8680554,128.7015507,8.7552002,11.077787,0.187708,33.0587857),(23692,'humerus.tif',244,2,102,46.4207776,19.8351856,13.7391878,1.8,19.8405145,13.7774878,-0.1609951,4.5541864,5.5731717,307.4635299,450.7109381,0.1988067,80.8715331,67.5122856,129.9831683,8.8160002,11.1011213,0.1984697,33.2455066),(23693,'humerus.tif',244,2,103,46.5968729,19.8795749,13.7045996,1.8,19.8868756,13.7434114,-0.1839166,4.5954739,5.5844892,312.2934398,453.8506215,0.2597439,81.2698546,67.9567431,131.6007892,8.8768002,11.0922934,0.2210471,33.3167383),(23694,'humerus.tif',244,2,104,46.7790595,19.9153748,13.658443,1.8,19.9276579,13.7019822,-0.2043756,4.6092398,5.5828226,315.247101,457.3418737,0.3211463,81.9194716,68.3945974,132.1066455,8.9330194,11.1337072,0.2370318,33.539075),(23695,'humerus.tif',244,2,105,46.9440003,19.9432925,13.6077738,1.8,19.9541111,13.6566207,-0.2271357,4.6002166,5.5950331,317.1612527,460.3048427,0.3967512,82.2702627,68.9448519,133.6362594,8.8962784,11.1385205,0.2145245,33.4887066),(23696,'humerus.tif',244,2,106,47.1956543,19.9548514,13.5557625,1.8,19.9652432,13.6034509,-0.2526678,4.5914864,5.601687,317.9528797,466.1207603,0.491574,83.2107824,69.2483548,134.7275772,8.8561388,11.1650392,0.2251662,33.7171541),(23697,'humerus.tif',244,2,107,47.442029,19.9737507,13.4969854,1.8,19.9919442,13.5440108,-0.2742841,4.5574624,5.6015703,317.9662221,471.2629079,0.5800893,84.1304989,69.7682601,135.4154494,8.7974162,11.1195873,0.2317168,33.5955541),(23698,'humerus.tif',244,2,108,47.6745753,19.9892709,13.4373879,1.8,20.017504,13.4884098,-0.2918467,4.5815332,5.6062099,316.4062475,477.651901,0.6577783,85.2005032,69.061214,137.2908083,8.7299993,11.178771,0.2304678,33.7024015),(23699,'humerus.tif',244,2,109,47.8961744,20.006359,13.3861234,1.8,20.0403608,13.43963,-0.3032857,4.494463,5.6181853,316.3881672,483.8813158,0.7120274,86.1276884,70.3950986,138.1625706,8.6858727,11.1628869,0.2476207,33.7232648),(23700,'humerus.tif',244,2,110,48.1545743,20.0258907,13.3428771,1.8,20.0621737,13.4025235,-0.3127973,4.7763704,5.6294388,318.7312641,491.0680869,0.7599791,87.2321568,66.7308521,139.7189737,8.6918582,11.2071738,0.2410313,33.809249),(23701,'humerus.tif',244,2,111,48.4303635,20.0593411,13.3057761,1.8,20.1019927,13.3677625,-0.3231411,4.5491841,5.6702966,322.3140035,499.2961024,0.8139195,88.0546714,70.8509481,144.8774627,8.7152904,11.2415898,0.4176752,33.9603541),(23702,'humerus.tif',244,2,112,48.6864762,20.0864983,13.2726857,1.8,20.1311751,13.3400502,-0.3324566,4.5621686,5.6858053,325.0544897,506.7911099,0.864305,89.132688,71.2499943,146.2276969,8.7423852,11.2836023,0.2671972,34.1679383),(23703,'humerus.tif',244,2,113,48.9074777,20.1262352,13.2369538,1.8,20.1706349,13.3087937,-0.3452915,4.5874637,5.7119145,328.4925502,515.111396,0.933828,90.1819164,71.6065727,147.5000583,8.7727278,11.342908,0.2215759,34.3399067),(23704,'humerus.tif',244,2,114,48.9349395,20.1571657,13.213565,1.8,20.198918,13.2904981,-0.3469201,4.6170258,5.7278001,331.7206402,518.8139462,0.9428299,90.5782217,71.8472567,148.221438,8.8126332,11.4286214,0.2527204,34.511875),(23705,'humerus.tif',244,2,115,49.1713648,20.1935148,13.1758108,1.8,20.2324371,13.2575502,-0.353945,4.6630813,5.7724063,337.1328598,525.8441269,0.9845111,91.0961733,72.2983013,149.2042164,8.8702123,11.4875002,0.2513971,34.4910118),(23706,'humerus.tif',244,2,116,49.2559512,20.2131957,13.1597855,1.8,20.2509816,13.240271,-0.3594595,4.7051885,5.7943721,342.5603415,530.8030994,1.0158299,91.6066639,72.8048067,150.3900003,8.9449939,11.5342266,0.2667144,34.6838434),(23707,'humerus.tif',244,2,117,49.2395062,20.2322768,13.1564928,1.8,20.2697068,13.2389772,-0.3606701,4.7309237,5.8129141,348.0499173,535.7325315,1.0220422,92.1624721,73.5691258,151.6821009,9.0159148,11.577093,0.2602641,34.9000694),(23708,'humerus.tif',244,2,118,49.2572326,20.2561992,13.1505007,1.8,20.2860268,13.2329215,-0.3675953,4.768891,5.8563439,355.5396252,544.2545828,1.06025,92.9341915,74.5539425,153.132496,9.1035693,11.6204376,0.2538617,35.0216694),(23709,'humerus.tif',244,2,119,49.2753774,20.2649706,13.1522415,1.8,20.2956326,13.2259114,-0.3640843,4.8101239,5.878749,363.3778993,551.966831,1.0413754,93.8918857,75.5443954,155.1342821,9.2019766,11.7392822,0.2299044,35.2292536),(23710,'humerus.tif',244,2,120,49.5596419,20.2644931,13.1513159,1.8,20.2870709,13.2234882,-0.365785,4.8688729,5.9562928,373.7549575,564.1126054,1.0567498,94.7086767,76.7641643,156.9532212,9.3061722,11.8266553,0.2387443,35.4663429),(23711,'humerus.tif',244,2,121,50.1273711,20.2537237,13.1577475,1.8,20.2770452,13.2301265,-0.3742944,4.937801,6.0063209,386.0982554,584.5077928,1.1167954,97.3154451,78.1923487,161.1851552,9.4028511,11.9299767,0.2523951,35.8163904),(23712,'humerus.tif',244,2,122,50.6239575,20.2272519,13.1652457,1.8,20.2567602,13.237588,-0.3819215,5.0025233,6.032452,399.5656673,603.6715228,1.1720154,100.0706719,79.8728244,165.7534314,9.5368045,11.9762114,0.2252768,35.8458955),(23713,'humerus.tif',244,2,123,51.3309589,20.1999175,13.1762071,1.8,20.2431018,13.2397149,-0.3841606,5.0719055,6.0583996,415.0468543,624.7502972,1.2016645,103.1213421,81.8325286,171.1301746,9.666422,12.1083627,0.2279279,36.2966797),(23714,'humerus.tif',244,2,124,51.9361797,20.165753,13.1974757,1.8,20.2044636,13.2552146,-0.3805892,5.1408973,6.0881224,432.9528007,640.0556183,1.1944293,105.1318584,84.21736,175.3783711,9.8163514,12.2405972,0.2305218,36.5190164),(23715,'humerus.tif',244,2,125,51.7959356,20.1588532,13.1994863,1.8,20.1407031,13.2616929,-0.3898038,5.2261656,6.1775778,450.7873822,650.9872672,1.2466012,105.3790484,86.2558546,177.5900252,9.969959,12.3729124,0.2330603,36.9280741),(23716,'humerus.tif',244,2,126,50.8410907,20.2059853,13.2111139,1.8,20.193003,13.2613157,-0.4245922,5.2881952,6.2778464,467.7029857,663.8460002,1.437974,105.7442241,88.4428376,178.0167348,10.1265562,12.5101821,0.2155061,37.4648425),(23717,'humerus.tif',244,2,127,50.7506991,20.1749437,13.2122941,1.8,20.1560967,13.2648268,-0.4450265,5.3700113,6.393797,486.8258641,692.2727431,1.5674742,108.2725552,90.656395,181.6631268,10.2786219,12.7013808,0.2171113,38.0814844),(23718,'humerus.tif',244,2,128,51.0936194,20.1158038,13.2263694,1.8,20.1038089,13.2687734,-0.4604164,5.4671985,6.4530112,511.3133009,730.6933842,1.6811614,113.2329322,93.5238223,188.0287458,10.4424754,12.9378346,0.1891008,38.6330053),(23719,'humerus.tif',244,2,129,51.6043429,20.022739,13.2399684,1.8,20.0115922,13.2872446,-0.4668955,5.5807831,6.5726013,539.0667204,779.3411596,1.7425465,118.5742335,96.5933835,195.354678,10.6537073,13.2365388,0.1847836,39.406863),(23720,'humerus.tif',244,2,130,52.1080088,19.8989294,13.2424914,1.8,19.8949252,13.2944569,-0.4548011,5.7395944,6.7512839,571.2675283,836.1386838,1.6758815,123.8488401,99.5309919,202.8728583,10.877285,13.6063014,0.18425,40.2163365),(23721,'humerus.tif',244,2,131,53.1046378,19.7259043,13.2349837,1.8,19.7618185,13.2985601,-0.4260626,5.9238759,6.9921107,613.2465365,907.7009241,1.5117783,129.8178718,103.5211649,213.8180604,11.1301881,13.9936457,0.165863,41.2481467),(23722,'humerus.tif',244,2,132,55.64027,19.4734074,13.224911,1.8,19.5487795,13.2772679,-0.3718355,6.1200514,7.2038195,667.2499172,1011.2287079,1.2241404,140.3739656,109.0268478,230.7961177,11.4784291,14.4546809,0.1520097,42.3511886),(23723,'humerus.tif',244,2,133,57.7910157,19.211382,13.1531112,1.8,19.2849413,13.1301878,-0.3595148,6.4012203,7.4627959,743.0321444,1105.5042309,1.1922035,148.1353961,116.0766403,245.4261151,12.0647788,15.0932254,0.1618374,44.2194463),(23724,'humerus.tif',244,2,134,60.5010601,18.9464855,13.0770963,1.8,19.0477258,13.0612223,-0.3374941,6.698183,7.8463434,826.1776298,1240.3568075,1.1055843,158.0808724,123.3435443,261.6965113,12.5112192,15.7443832,0.1511813,45.7315458),(23725,'humerus.tif',244,2,135,63.1076124,18.5639829,13.0504974,1.8,18.6727096,13.0354184,-0.266651,6.8899221,11.1681278,909.8026966,1428.7867515,0.7302963,127.9343129,132.0483281,194.3888226,12.9617904,16.7192266,0.1202955,47.7656612),(23726,'humerus.tif',244,2,136,71.9011892,16.9926294,12.9691034,1.8,17.010606,12.8902963,-0.0107338,6.9178412,11.3197551,1028.5271497,2389.8928065,0.0013805,211.1258402,148.6774729,297.8393285,13.4541294,21.3479879,3.0617627,69.60879),(23727,'humerus.tif',244,2,137,82.1098913,15.6625382,12.8896522,1.8,15.6204934,12.7540863,0.0494962,7.1495545,11.2520391,1139.0802019,3274.8140356,0.033499,291.0418275,159.3218441,391.5338867,13.715605,21.9365866,3.0750245,78.7842208),(23728,'humerus.tif',244,2,138,87.6742472,15.1714583,12.8938876,1.8,15.1038515,12.796739,0.0792675,7.3617326,11.7786255,1300.7666256,3652.6926148,0.0916223,310.1119569,176.693001,420.4368134,13.9576856,22.4206962,3.0438128,75.5880534),(23729,'humerus.tif',244,2,139,92.0933072,14.9458108,12.8936099,1.8,14.9723097,12.8523293,0.0772344,7.4259887,12.1206908,1485.1437903,4016.9648089,0.0913764,331.4138517,199.9927338,453.7730807,14.2272004,22.8329709,3.0509328,74.299339),(23730,'humerus.tif',244,2,140,96.3685637,14.7982679,12.9136039,1.8,14.9134686,12.8406033,0.0677603,7.5054856,12.3822323,1747.6750045,4364.9061615,0.0736326,352.5136718,232.8530227,493.4289748,14.6576738,23.1500347,3.0785185,66.5276775),(23731,'humerus.tif',244,2,141,101.3330374,14.7273274,12.9244396,1.8,14.8927823,12.9149151,0.0393579,7.6741079,12.58469,2012.7379378,4735.6105767,0.026148,376.2993443,262.2764695,536.2244749,15.2395754,23.4006561,3.0739875,74.0866925),(23732,'humerus.tif',244,2,142,103.4431153,14.6758623,12.9601192,1.8,14.8737657,12.9686765,0.0147766,8.3831073,12.7532856,2191.3677076,4927.664955,0.0037642,386.3839576,261.4027974,557.83186,16.0082749,23.6186682,0.04893,71.8144394),(23733,'humerus.tif',244,2,143,105.5093511,14.5526001,12.9942502,1.8,14.8061529,13.0308131,-0.0009764,9.2058582,12.8682373,2376.0233118,4911.2543281,0.0000168,381.6571154,258.0990571,565.1899286,16.7098571,23.6562016,0.0746036,73.5046181),(23734,'humerus.tif',244,2,144,107.5081661,14.4688491,12.9867084,1.8,14.6997772,13.1094447,-0.0191711,9.7899953,12.9444399,2559.2497,4825.0043712,0.0065845,372.74725,261.4148027,569.1628844,17.4487919,23.6099018,0.0824997,74.3705706),(23735,'humerus.tif',244,2,145,109.297555,14.395217,12.8740266,1.8,14.7436785,13.0767362,-0.0482826,10.3749138,12.9313166,2743.1629299,4779.2661777,0.042433,369.5885223,264.4034442,571.8678874,18.0123061,23.4762025,0.1272461,74.1716283),(23736,'humerus.tif',244,2,146,111.8503061,14.5448863,12.9634685,1.8,14.8748657,13.2397433,-0.0810078,10.5934738,12.6889467,2957.906331,4684.1024251,0.1220646,369.1482475,279.2196763,586.3432391,18.4080803,23.2875912,0.1256503,76.2032125),(23737,'humerus.tif',244,2,147,112.1282987,14.7349603,13.0812547,1.8,14.9966149,13.4358045,-0.1258086,10.8188989,12.41341,3054.0609125,4530.3344135,0.2942334,364.9548671,282.2894405,595.0159875,18.7722839,23.0546679,0.0791991,72.2591129),(23738,'humerus.tif',244,2,148,110.511903,14.9966809,13.1386902,1.8,15.2480552,13.5886086,-0.1654765,10.9943836,12.065574,3050.249555,4347.8583825,0.4997613,360.3523868,277.4370691,593.8754566,19.0275536,22.761705,0.0855813,74.9541278),(23739,'humerus.tif',244,2,149,108.5620601,15.3384512,13.2433467,1.8,15.4841064,13.7397871,-0.2309236,11.1363476,11.5674473,2975.2887663,4071.0041267,0.9478292,351.9362588,267.1691728,584.7505892,19.2251707,22.3853023,0.1088576,71.908017),(23740,'humerus.tif',244,2,150,109.0637328,15.6799559,13.4086255,1.8,15.7922206,13.8501594,-0.3147101,11.144902,11.0680226,2815.2295114,3870.2878008,1.7416659,349.6819576,252.6024474,571.7881881,19.0911188,21.8823421,0.1029863,71.7655538),(23741,'humerus.tif',244,2,151,109.6473458,16.1294328,13.5863737,1.8,16.1705354,13.903658,-0.4414159,10.9875909,10.4037638,2546.2502998,3577.3883504,3.3354172,343.8552053,231.7387234,544.8385827,18.4700917,21.2974517,0.0857491,71.0089798),(23742,'humerus.tif',244,2,152,105.2718236,16.4613164,14.011751,1.8,16.415579,14.3148064,-0.5135172,10.3572294,10.0221709,2077.3351256,3243.2890592,4.234042,323.6114317,200.5686114,490.4151668,17.6834095,20.5522892,0.1096771,77.2955157),(23743,'humerus.tif',244,2,153,94.4463301,16.4900383,14.5908281,1.8,16.4733474,14.8579814,-0.5937669,9.6049592,10.0986962,1574.4947869,2853.9020171,4.9273571,282.6010368,163.9251922,410.8938718,10.293433,16.9418307,2.4298523,48.2139143),(23744,'humerus.tif',244,2,154,80.9508226,17.2657119,14.9984464,1.8,17.4380919,15.0226302,-0.6435692,8.3700249,9.4503051,1091.4122709,2426.8558793,4.8579311,256.8018556,130.3953438,352.4400154,7.6648311,14.8462848,2.3996454,40.90421),(23745,'humerus.tif',244,2,155,48.5486289,19.9352733,14.7217801,1.8,19.4379651,14.644237,-0.8411332,6.8169722,9.3759807,439.2111929,1450.737772,4.4957627,154.7291772,64.4290722,198.7470209,4.1206542,10.6790145,2.1287921,37.8372359),(23746,'humerus.tif',244,2,156,29.7077587,22.6845666,13.6620045,1.8,22.7507854,13.6418976,-1.2538988,5.617902,10.0540056,195.2996855,271.1253631,4.4704877,26.9668999,34.7638111,42.4384987,6.6080494,10.7397657,2.2358117,30.3947586),(23747,'humerus.tif',244,2,157,27.3438871,23.0853997,13.757584,1.8,23.1636473,13.9094959,1.0784342,3.2858506,4.8653568,92.3497681,182.2980551,3.5389662,37.4685895,28.1052848,56.4372716,6.607895,9.6029363,2.0655953,27.0561279),(23748,'humerus.tif',244,2,158,26.6448375,23.0382389,13.9949681,1.8,23.0797819,14.150779,1.1612259,3.2553384,4.774872,88.0960619,169.9934392,3.7366033,35.6016745,27.0620286,53.9696491,6.5747461,9.4206655,1.9824677,26.7834228),(23749,'humerus.tif',244,2,159,26.1992959,23.0648833,14.2223811,1.8,23.0916252,14.4208721,1.2102935,3.2106265,4.7430227,81.8404283,169.4724853,3.8232244,35.7309036,25.4904859,51.9600807,6.4412506,9.4398733,2.0027543,26.9197753),(23750,'humerus.tif',244,2,160,25.8559585,23.1231107,14.4827863,1.8,23.1901885,14.6979228,1.2882314,3.14719,4.7895055,74.9926673,158.0118287,3.9743173,32.9912616,23.8284524,47.8049524,6.2691495,9.4257652,1.7327637,26.0329595),(23751,'humerus.tif',244,2,161,25.0237274,23.2172005,14.8437807,1.8,23.2343991,15.0442399,1.3816077,3.1410609,4.8224473,65.7075975,141.8283115,4.0231174,29.4100283,20.9189186,43.0352175,6.1297012,9.2067345,1.7500592,25.1227493),(23752,'humerus.tif',244,2,162,23.1118044,23.2376403,15.1623601,1.8,23.2570235,15.3843887,1.5042435,3.0235118,4.4774468,54.3792229,106.2715233,3.8349312,23.7348491,17.9854512,35.3391498,5.8607914,8.5494834,1.7640078,23.5333074),(23753,'humerus.tif',244,2,163,20.6499576,23.2721269,15.4386942,1.8,23.2730544,15.6534347,-1.5549136,2.7830695,3.8303334,40.1142596,74.1219044,3.4407915,19.3512933,14.4136753,29.0577088,5.4112001,7.4734555,1.6931332,21.0631604),(23754,'humerus.tif',244,2,164,17.9459049,23.2327445,15.6406831,1.8,23.2566418,15.7587613,-1.5656744,2.4391892,3.3289103,27.0588079,50.8595868,2.9909057,15.2781488,11.0933614,23.223763,4.8368024,6.5398874,1.4683525,18.785845),(23755,'humerus.tif',244,2,165,14.3740303,23.2945043,15.7694386,1.8,23.305971,15.7944722,1.4826434,1.9602181,2.7292748,12.7790778,24.8975191,2.3771033,9.1223937,6.5192123,13.8017309,3.9296728,5.331713,1.6965657,15.277777),(23756,'humerus.tif',244,2,166,5.0408552,23.548566,15.7554532,1.8,23.5400512,15.7599043,1.39265,1.1972169,1.5060095,1.5591825,2.7245379,0.8137605,1.8091107,1.3023392,2.8088142,2.3972416,3.1126988,1.354246,9.1632095),(23757,'humerus.tif',244,2,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23758,'humerus.tif',244,2,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23759,'humerus.tif',244,2,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23760,'humerus.tif',244,2,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23761,'humerus.tif',244,2,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23762,'humerus.tif',244,2,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23763,'humerus.tif',244,2,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23764,'humerus.tif',244,2,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23765,'reeves_muntjac-radius.tif',244,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23766,'reeves_muntjac-radius.tif',244,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23767,'reeves_muntjac-radius.tif',244,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23768,'reeves_muntjac-radius.tif',244,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23769,'reeves_muntjac-radius.tif',244,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23770,'reeves_muntjac-radius.tif',244,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23771,'reeves_muntjac-radius.tif',244,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23772,'reeves_muntjac-radius.tif',244,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23773,'reeves_muntjac-radius.tif',244,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23774,'reeves_muntjac-radius.tif',244,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23775,'reeves_muntjac-radius.tif',244,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23776,'reeves_muntjac-radius.tif',244,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23777,'reeves_muntjac-radius.tif',244,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23778,'reeves_muntjac-radius.tif',244,3,14,1.8075837,12.655962,17.932348,1.8,12.6546962,17.9329441,1.3104846,0.5779292,1.1660028,0.1198514,0.6142478,0.2813066,0.5267979,0.2073807,0.6251115,1.1639205,2.405253,1.9325256,5.9487099),(23779,'reeves_muntjac-radius.tif',244,3,15,10.164687,13.1124274,17.5925046,1.8,13.1485676,17.5556288,-1.3407241,1.9337354,2.4534503,5.9286398,17.6714695,1.6060107,7.2027011,3.0659003,8.8425209,3.7199656,5.0467664,1.0262446,15.3907352),(23780,'reeves_muntjac-radius.tif',244,3,16,21.3477044,14.0662012,17.5503595,1.8,14.0832974,17.5331532,0.1714462,3.2662389,3.984916,48.0229013,64.4821435,0.103561,16.1815566,14.7028136,27.8203226,5.8194611,7.4573625,2.7217127,26.0034544),(23781,'reeves_muntjac-radius.tif',244,3,17,30.5836711,14.8601509,17.9483483,1.8,14.9090022,17.9029661,0.3308597,3.422832,5.6326337,71.9604548,167.8359095,0.5379238,29.7970574,21.0236599,41.4742436,6.2637955,10.1158486,2.8426518,27.7353595),(23782,'reeves_muntjac-radius.tif',244,3,18,36.9401276,15.6740298,18.0809158,1.8,15.6335927,17.9891675,0.2632743,3.6777287,5.6461446,103.1432827,281.4083359,0.4169718,49.8407952,28.0453755,65.7040161,6.9030964,10.9743582,2.8724252,30.6303652),(23783,'reeves_muntjac-radius.tif',244,3,19,39.8863811,16.4668514,17.8966855,1.8,16.3493694,17.8175814,0.096523,4.0246063,5.6457016,159.2809292,389.819642,0.0617427,69.0471566,39.5767728,91.7496846,7.5185474,11.29719,2.9135836,32.7418229),(23784,'reeves_muntjac-radius.tif',244,3,20,40.2335471,16.9920358,17.8597355,1.8,16.8151516,17.8369463,-0.0475339,4.1612672,5.9869856,186.6968907,453.5351895,0.0151397,75.7535127,44.865394,103.5049541,7.7073832,11.5802857,0.2169605,34.0941755),(23785,'reeves_muntjac-radius.tif',244,3,21,41.6112345,17.2347617,18.002148,1.8,17.1409184,17.930134,-0.1694845,4.197793,6.3093267,223.3182805,492.4112608,0.1973137,78.0449772,53.1989734,109.8752949,8.0943177,12.311062,0.2905107,36.4157486),(23786,'reeves_muntjac-radius.tif',244,3,22,44.6296365,17.3744473,18.0939637,1.8,17.3697831,17.9590867,-0.2189809,4.5185736,6.7822959,267.9968975,556.0537581,0.3510199,81.9860661,59.310066,112.8777595,8.7780485,13.3290744,0.3491607,38.4941216),(23787,'reeves_muntjac-radius.tif',244,3,23,49.5156879,17.4687662,17.9383229,1.8,17.4424907,17.8648213,-0.1988258,4.8737424,6.806103,317.5112375,636.9430652,0.3219636,93.584106,65.1473159,129.4624262,9.4975581,13.5992357,0.3514448,40.1573263),(23788,'reeves_muntjac-radius.tif',244,3,24,51.7964601,17.637544,17.7110083,1.8,17.5899436,17.6823119,-0.2098831,5.2868678,6.7215313,376.6154008,636.6941716,0.3747291,94.7245717,71.2360163,139.965907,9.9286059,13.6387292,0.3838176,40.9016788),(23789,'reeves_muntjac-radius.tif',244,3,25,48.7051352,17.9100894,17.6685158,1.8,17.9428152,17.6338373,-0.2831512,5.4312897,6.7806769,376.8352556,565.6305642,0.6336108,83.4180089,69.3822781,132.5508749,9.9574443,13.5006126,0.3445386,40.8721737),(23790,'reeves_muntjac-radius.tif',244,3,26,42.5272582,18.0479265,17.6823031,1.8,18.0735155,17.5047843,-0.3957071,5.5327305,6.9189548,372.5264108,532.4091517,1.0531167,76.949361,67.3313859,126.9674235,10.0510664,13.4281315,0.4048918,40.00369),(23791,'reeves_muntjac-radius.tif',244,3,27,38.9706663,18.1631245,17.9650198,1.8,18.2436231,17.7593178,-0.4455825,5.3868572,7.0683978,336.8242902,507.089061,1.2064465,71.7403116,62.5270504,116.045917,9.7008624,13.3899494,0.4209906,40.1191793),(23792,'reeves_muntjac-radius.tif',244,3,28,37.0340196,18.2701179,18.2737055,1.8,18.3254783,18.0846965,-0.4577666,5.1755182,7.0998567,302.7143885,479.7292166,1.2055564,67.5688586,58.4896769,105.6897822,9.1835665,13.2057827,0.9291368,39.0665058),(23793,'reeves_muntjac-radius.tif',244,3,29,35.867765,18.204168,18.6463349,1.8,18.2677125,18.4595228,-0.3593763,4.8986746,6.5890755,280.0425507,436.1148871,0.7393912,66.187569,57.1670046,103.3613363,8.9750228,12.6745766,0.3475415,37.4414481),(23794,'reeves_muntjac-radius.tif',244,3,30,35.5342306,18.1793153,18.8868918,1.8,18.2452794,18.7273836,-0.3413941,4.7713529,6.3407334,271.0111815,411.8580801,0.6638489,64.9543283,56.7996514,102.073805,8.8241547,12.3065571,0.3373743,36.4538955),(23795,'reeves_muntjac-radius.tif',244,3,31,35.7586254,18.135761,19.1244677,1.8,18.1859079,18.9737509,-0.320895,4.6547164,6.1830892,266.115161,395.3346986,0.5929213,63.9380552,57.17108,100.4095092,8.7246161,11.9794519,0.3361958,35.766022),(23796,'reeves_muntjac-radius.tif',244,3,32,35.6240902,18.1154052,19.3766764,1.8,18.1618004,19.2345305,-0.3099665,4.5837903,6.0293869,258.4591782,375.5081955,0.5524185,62.2796651,56.3854716,98.4694052,8.6520977,11.6718585,0.3069246,34.7993327),(23797,'reeves_muntjac-radius.tif',244,3,33,35.2237589,18.0741331,19.6469284,1.8,18.1126702,19.5162038,-0.2457545,4.5720465,5.7979143,249.4100496,356.9831334,0.3474774,61.570957,54.5510751,95.4300296,8.5431842,11.4033641,0.3032029,34.025475),(23798,'reeves_muntjac-radius.tif',244,3,34,34.9817157,18.102197,19.8661149,1.8,18.1418916,19.7348254,-0.2309816,4.5309003,5.5926093,241.7854327,342.6412914,0.3055677,61.2668023,53.3636624,93.4483676,8.4481566,11.1531136,0.3045109,33.4235857),(23799,'reeves_muntjac-radius.tif',244,3,35,34.586783,18.1331271,20.0737224,1.8,18.1591457,19.9518596,-0.2411173,4.4480388,5.4788478,234.960247,328.8041289,0.3286873,60.0133719,52.8233354,92.1895278,8.3749021,10.8905006,0.2829009,32.9224331),(23800,'reeves_muntjac-radius.tif',244,3,36,34.1501603,18.1650397,20.2543044,1.8,18.1844531,20.1475177,-0.2472812,4.3855988,5.3596366,227.9375944,315.5392552,0.3409992,58.8732557,51.9741094,91.1209264,8.2803898,10.6746866,0.2947301,32.4568964),(23801,'reeves_muntjac-radius.tif',244,3,37,33.7632829,18.1982648,20.4445588,1.8,18.2149018,20.3507113,-0.2472027,4.3116137,5.2255602,220.4452905,303.878012,0.3369266,58.1522364,51.1282561,90.1071186,8.1681903,10.4650209,0.2886744,31.9557438),(23802,'reeves_muntjac-radius.tif',244,3,38,33.179286,18.2050697,20.6139702,1.8,18.2182812,20.5216369,-0.2244866,4.2695742,5.1105465,211.0802446,290.8453642,0.2740244,56.9108145,49.4382429,87.2349937,8.0388894,10.2728615,0.2880554,31.5405754),(23803,'reeves_muntjac-radius.tif',244,3,39,32.7329428,18.2103214,20.77809,1.8,18.2329967,20.6905113,-0.2017813,4.2368162,5.0574703,202.5103769,279.8469254,0.2191258,55.3333796,47.7977724,85.4125316,7.938388,10.0636401,0.2816191,31.1106545),(23804,'reeves_muntjac-radius.tif',244,3,40,32.3634537,18.2086618,20.9436292,1.8,18.2325982,20.8618028,-0.1731363,4.2057537,5.0176367,194.85804,269.1875007,0.1600797,53.6482641,46.3313008,84.2717738,7.8561666,9.8662874,0.2300321,30.6095019),(23805,'reeves_muntjac-radius.tif',244,3,41,32.1591719,18.2128259,21.0996779,1.8,18.2367998,21.0206752,-0.1518891,4.1630621,4.9525335,187.738529,260.4318155,0.1227057,52.5855737,45.0962598,82.9989259,7.7660806,9.7030783,0.2404194,30.1439652),(23806,'reeves_muntjac-radius.tif',244,3,42,32.1317749,18.222702,21.2534695,1.8,18.2451526,21.1793775,-0.1338792,4.1016596,4.9180473,181.2794037,253.6966482,0.0954143,51.584833,44.1965991,81.7328912,7.7128684,9.5659098,0.1724631,29.7644126),(23807,'reeves_muntjac-radius.tif',244,3,43,32.0360803,18.231014,21.4035064,1.8,18.24854,21.3317773,-0.1192197,4.0438611,4.8568022,174.8153094,247.8872735,0.0755311,51.0391951,43.2298005,80.6534594,7.6451322,9.4523962,2.7383901,29.3996126),(23808,'reeves_muntjac-radius.tif',244,3,44,32.0781783,18.2431746,21.5486033,1.8,18.2567634,21.4781174,-0.1020379,3.9849136,4.8130505,169.2523792,243.0884885,0.055472,50.506116,42.4732867,80.1168381,7.5710457,9.3649767,2.7273235,29.1060442),(23809,'reeves_muntjac-radius.tif',244,3,45,32.1838042,18.2656802,21.6865079,1.8,18.2829573,21.6182975,-0.0906711,3.9469498,4.7722282,164.8465789,238.7458214,0.0439778,50.0281658,41.7655628,79.2262665,7.5121823,9.3166951,2.7392716,28.9279652),(23810,'reeves_muntjac-radius.tif',244,3,46,32.2014382,18.2815418,21.8221704,1.8,18.2977523,21.7563298,-0.0802046,3.8852481,4.7056399,160.3266661,234.7606917,0.0344501,49.8892176,41.2654894,78.4404735,7.4476334,9.2697573,2.7513424,28.6196442),(23811,'reeves_muntjac-radius.tif',244,3,47,32.2594641,18.3025562,21.946886,1.8,18.3200196,21.8833087,-0.0718852,3.8353917,4.6709049,156.0009328,231.0536425,0.0277355,49.4665691,40.6740552,77.8984999,7.3687796,9.2049275,2.734099,28.3408284),(23812,'reeves_muntjac-radius.tif',244,3,48,32.3044841,18.3164497,22.0655181,1.8,18.3328329,22.0049169,-0.0680513,3.808804,4.632963,152.7253518,228.1115321,0.024895,49.2366405,40.0979814,77.4494102,7.3004063,9.1677048,2.7610863,28.16886),(23813,'reeves_muntjac-radius.tif',244,3,49,32.2370953,18.3339683,22.1929483,1.8,18.3520323,22.1374659,-0.069696,3.7571931,4.5960282,148.2324237,225.0248223,0.0260565,48.9607142,39.4529688,76.5180648,7.2320974,9.1372107,2.7882736,27.9612759),(23814,'reeves_muntjac-radius.tif',244,3,50,32.2411628,18.3386422,22.3008634,1.8,18.3538288,22.2436872,-0.0713825,3.72237,4.573968,144.8430613,223.3943584,0.0273341,48.8403852,38.9115163,76.3886933,7.1955742,9.1015389,2.7796946,27.869181),(23815,'reeves_muntjac-radius.tif',244,3,51,32.2576291,18.3497173,22.4178236,1.8,18.3679041,22.3634848,-0.0718484,3.674232,4.5546272,141.3081108,221.8653921,0.0277055,48.7120856,38.4592234,75.8205173,7.1185287,9.0789693,2.8494944,27.68246),(23816,'reeves_muntjac-radius.tif',244,3,52,32.378125,18.3596364,22.5337372,1.8,18.3754765,22.4795177,-0.0729465,3.6273928,4.555059,138.1328293,221.0960491,0.028664,48.5385697,38.0804723,75.4521961,7.0501435,9.0789693,2.8494944,27.43926),(23817,'reeves_muntjac-radius.tif',244,3,53,32.435092,18.3641445,22.6463863,1.8,18.3795383,22.5974775,-0.0666003,3.6069751,4.5262356,135.0588532,219.9099943,0.0239426,48.5856274,37.4438001,74.7985023,6.9856721,9.0867021,2.8706458,27.3532758),(23818,'reeves_muntjac-radius.tif',244,3,54,32.4623454,18.3746451,22.7497398,1.8,18.3911891,22.7045981,-0.0649813,3.5682651,4.5350722,131.6485825,219.0832767,0.0228135,48.3086637,36.8942825,74.1960092,6.9147047,9.0867021,2.8706458,27.1456916),(23819,'reeves_muntjac-radius.tif',244,3,55,32.4819608,18.3746491,22.852626,1.8,18.3855491,22.8097093,-0.0617478,3.5307852,4.531071,128.6107483,217.75572,0.0206149,48.0583332,36.4255379,73.896317,6.8487788,9.0706185,2.8771043,27.0388442),(23820,'reeves_muntjac-radius.tif',244,3,56,32.392904,18.3803702,22.9557952,1.8,18.3961222,22.9131215,-0.0543631,3.4926338,4.5371111,124.8215824,217.2632562,0.0159396,47.8858135,35.7385251,73.2216773,6.7656561,9.0875157,2.9258265,26.95286),(23821,'reeves_muntjac-radius.tif',244,3,57,32.3556064,18.3784037,23.0525622,1.8,18.3919302,23.0108962,-0.0472754,3.4515828,4.4990222,121.6569653,217.368446,0.0120432,48.3145974,35.2467174,72.69386,6.6881023,9.1098613,2.9468149,26.8668758),(23822,'reeves_muntjac-radius.tif',244,3,58,32.3491314,18.3827114,23.1514545,1.8,18.3936248,23.1085947,-0.043173,3.3795477,4.5061786,118.1083457,217.261387,0.010043,48.2141094,34.9479744,72.0918771,6.6098505,9.1258757,2.9742534,26.6089233),(23823,'reeves_muntjac-radius.tif',244,3,59,32.4157766,18.3935357,23.2585393,1.8,18.4049351,23.2207665,-0.0458598,3.3312019,4.5137122,115.1076717,217.6046755,0.0113544,48.2096926,34.5543968,71.4242887,6.5467572,9.1580223,2.9546134,26.5585549),(23824,'reeves_muntjac-radius.tif',244,3,60,32.3855435,18.4021448,23.357116,1.8,18.4118277,23.3194631,-0.0456518,3.3075707,4.5234635,112.2470055,218.2054757,0.0112412,48.2385847,33.9363885,70.91095,6.4809204,9.1960882,2.9688354,26.4517074),(23825,'reeves_muntjac-radius.tif',244,3,61,32.3615662,18.4108173,23.4520261,1.8,18.421615,23.416518,-0.0456845,3.278449,4.5361074,109.471466,218.8375424,0.011249,48.2434658,33.3912365,70.2365722,6.4403357,9.2457993,2.976444,26.4517074),(23826,'reeves_muntjac-radius.tif',244,3,62,32.4446801,18.4180313,23.5400853,1.8,18.4238778,23.5061952,-0.0471703,3.2257501,4.5878665,106.9127821,219.9750962,0.0120228,47.9471442,33.1435419,69.7330862,6.3660127,9.3061746,3.0237206,26.3804758),(23827,'reeves_muntjac-radius.tif',244,3,63,32.4466047,18.4280695,23.6334195,1.8,18.4365572,23.6041015,-0.0473724,3.1986826,4.6019668,104.2712699,221.0145105,0.0121267,48.0260985,32.5981923,68.857967,6.2728383,9.3468015,2.9914161,26.3301074),(23828,'reeves_muntjac-radius.tif',244,3,64,32.5408416,18.438476,23.7088766,1.8,18.4473947,23.675037,-0.0483372,3.2065154,4.6139841,102.4425311,222.5798213,0.012662,48.2402663,31.9482425,68.6109157,6.2649322,9.3815407,3.0116107,26.3952284),(23829,'reeves_muntjac-radius.tif',244,3,65,32.4944647,18.4436111,23.7854,1.8,18.4514388,23.7521828,-0.0494531,3.162966,4.6236907,100.5091263,223.8321085,0.0132339,48.4098356,31.7768594,68.3478655,6.2048808,9.3896149,3.00519,26.34486),(23830,'reeves_muntjac-radius.tif',244,3,66,32.4313086,18.4433717,23.8580427,1.8,18.4472236,23.8268594,-0.0488217,3.1234949,4.6681371,98.5761537,225.4899075,0.0128734,48.3040459,31.5595693,68.2576694,6.148679,9.4269417,3.0252375,26.2944916),(23831,'reeves_muntjac-radius.tif',244,3,67,32.5115824,18.4416792,23.9373628,1.8,18.4471123,23.9090337,-0.0472341,3.1330001,4.6792452,96.6746114,227.2510354,0.0120802,48.5657459,30.8568808,67.8495427,6.1086358,9.4805121,3.0323519,26.34486),(23832,'reeves_muntjac-radius.tif',244,3,68,32.443933,18.443281,24.0041681,1.8,18.4511831,23.9744536,-0.0456309,3.0919735,4.6830624,95.046655,228.5685642,0.0112512,48.8074993,30.7398029,67.5907519,6.0477639,9.4945388,3.0196205,26.2797391),(23833,'reeves_muntjac-radius.tif',244,3,69,32.4503144,18.4380525,24.0718971,1.8,18.4457246,24.0440011,-0.0452318,3.0439531,4.7326885,93.6442489,230.174224,0.0110575,48.6349824,30.7640247,67.519349,5.9997357,9.5285455,3.0457335,26.2797391),(23834,'reeves_muntjac-radius.tif',244,3,70,32.441915,18.4287531,24.1340661,1.8,18.4326843,24.1057555,-0.0447354,3.0455089,4.7474652,92.2608796,231.6185576,0.0108135,48.7878368,30.2940769,67.6566359,5.9766116,9.540952,3.0330466,26.3153549),(23835,'reeves_muntjac-radius.tif',244,3,71,32.7628554,18.4504704,24.1874559,1.8,18.472252,24.1570998,-0.0449135,3.0361331,4.7470419,91.6351842,234.1634705,0.0110076,49.3282923,30.1815442,67.2595088,5.9476581,9.6013964,3.0337326,26.3153549),(23836,'reeves_muntjac-radius.tif',244,3,72,32.8436728,18.4298827,24.2502483,1.8,18.4354805,24.2262668,-0.0426734,2.9877067,4.7535693,90.2162917,235.7513164,0.0099621,49.5945896,30.1958331,67.4188279,5.8950675,9.6152468,3.0211592,26.2649865),(23837,'reeves_muntjac-radius.tif',244,3,73,32.7674907,18.4309797,24.3017859,1.8,18.4471172,24.2755322,-0.0417713,2.9792081,4.7543205,89.079676,236.5103409,0.0095235,49.7464023,29.900454,67.188344,5.8711233,9.6306128,3.0086239,26.3006023),(23838,'reeves_muntjac-radius.tif',244,3,74,32.8907249,18.4344115,24.3579371,1.8,18.4535589,24.3333488,-0.0419853,2.9458233,4.7838559,87.696968,237.9991471,0.0096574,49.7504843,29.7699347,67.0065647,5.8329617,9.6618453,3.0344101,26.2858498),(23839,'reeves_muntjac-radius.tif',244,3,75,32.9416068,18.4432833,24.4146322,1.8,18.4635605,24.391526,-0.0415001,2.9369212,4.8008684,86.2493274,239.1246892,0.0094503,49.8086321,29.3672599,66.4844114,5.7921149,9.7101238,3.0475314,26.3362181),(23840,'reeves_muntjac-radius.tif',244,3,76,33.0775377,18.4427619,24.4610046,1.8,18.4498539,24.4364496,-0.0368345,2.905236,4.8061409,85.1596496,240.4044413,0.0074764,50.0202653,29.3124725,66.4213256,5.7676391,9.735977,3.0226598,26.2354814),(23841,'reeves_muntjac-radius.tif',244,3,77,33.1283283,18.4523452,24.5081004,1.8,18.4554214,24.4850929,-0.0367707,2.9073954,4.8162573,84.2577087,240.7160393,0.007462,49.9798958,28.9804779,66.0583134,5.7471627,9.7433781,3.0164637,26.2710972),(23842,'reeves_muntjac-radius.tif',244,3,78,33.2322814,18.4677854,24.552417,1.8,18.4755159,24.5308591,-0.0357538,2.8714482,4.8328316,83.3175267,241.15473,0.0070773,49.8992615,29.0158553,65.7941284,5.7062266,9.7827561,3.0357398,26.2710972),(23843,'reeves_muntjac-radius.tif',244,3,79,33.3138253,18.4831491,24.5919622,1.8,18.4894341,24.5696538,-0.0336318,2.8716508,4.850009,82.384797,241.7505053,0.0062778,49.8453728,28.6890027,65.7149221,5.67894,9.7827561,3.0357398,26.2710972),(23844,'reeves_muntjac-radius.tif',244,3,80,33.3502846,18.4929201,24.6320388,1.8,18.4958509,24.6113627,-0.0302718,2.8461219,4.8602021,81.2948794,241.5782023,0.005092,49.7053824,28.5633859,65.5018007,5.6494322,9.7827561,3.0357398,26.1494972),(23845,'reeves_muntjac-radius.tif',244,3,81,33.5014461,18.5028337,24.663715,1.8,18.5029013,24.6440884,-0.0277976,2.821321,4.8705036,80.3220982,241.9060517,0.0043133,49.6675649,28.469677,65.2976193,5.6265111,9.7827561,3.0357398,26.1347447),(23846,'reeves_muntjac-radius.tif',244,3,82,33.4758801,18.5182954,24.6927212,1.8,18.5213673,24.6737723,-0.0255798,2.7979551,4.8848491,79.3181609,241.2979687,0.0036499,49.3972204,28.3486182,65.1000865,5.5936001,9.7651692,3.0543149,26.0843763),(23847,'reeves_muntjac-radius.tif',244,3,83,33.5599106,18.5218737,24.7160124,1.8,18.5234565,24.6981192,-0.0231442,2.8148871,4.8384472,78.5212961,241.1287532,0.0029955,49.8359785,27.8950075,65.0874232,5.5608964,9.735977,3.0226598,25.9983921),(23848,'reeves_muntjac-radius.tif',244,3,84,33.670082,18.5288204,24.7355828,1.8,18.5362058,24.7184033,-0.0221946,2.8037649,4.8451495,78.3232286,240.4627271,0.0027638,49.629578,27.9350202,64.9097678,5.5634475,9.7289502,3.028865,26.0131447),(23849,'reeves_muntjac-radius.tif',244,3,85,33.7411319,18.533005,24.757444,1.8,18.5412636,24.7406172,-0.02014,2.7858378,4.8481086,77.5833722,238.6119297,0.0022807,49.2175295,27.8492066,64.5230305,5.5328001,9.7222986,3.0350791,25.8767921),(23850,'reeves_muntjac-radius.tif',244,3,86,33.7637854,18.5451192,24.7732126,1.8,18.5542922,24.7569669,-0.0181622,2.7731279,4.803025,76.9984462,236.6666716,0.001856,49.274503,27.7659193,64.3618796,5.5328001,9.6756092,3.0219142,25.8767921),(23851,'reeves_muntjac-radius.tif',244,3,87,33.7617682,18.5537433,24.7897005,1.8,18.5649424,24.7750747,-0.0145217,2.7566829,4.8117951,76.2424209,234.8022727,0.0011865,48.7972304,27.657305,63.9292188,5.5300553,9.6685385,3.0281577,25.7908079),(23852,'reeves_muntjac-radius.tif',244,3,88,33.7893397,18.5530395,24.7987713,1.8,18.5628797,24.783384,-0.0108576,2.7479905,4.810058,75.678818,232.5210432,0.0006639,48.3405905,27.5396943,63.6461722,5.4720001,9.6495943,3.0469396,25.7048237),(23853,'reeves_muntjac-radius.tif',244,3,89,33.8513498,18.5494085,24.8077054,1.8,18.5604796,24.7932931,-0.0075444,2.7382463,4.7481219,75.2215722,230.831656,0.0003211,48.6153604,27.4707109,63.7114669,5.4720001,9.6013964,3.0337326,25.6692079),(23854,'reeves_muntjac-radius.tif',244,3,90,33.8901492,18.5527467,24.8156261,1.8,18.5650531,24.8056685,-0.0054076,2.7296465,4.751027,74.9542672,229.1192023,0.0001652,48.225195,27.4593316,63.7336641,5.4720001,9.5690009,3.0716433,25.6188395),(23855,'reeves_muntjac-radius.tif',244,3,91,33.9772829,18.549358,24.8147059,1.8,18.5601219,24.8040322,-0.0026815,2.7289749,4.6872446,74.7070134,226.8609833,0.0000407,48.3996469,27.3754857,63.6808601,5.4112001,9.4873332,3.0259815,25.4321186),(23856,'reeves_muntjac-radius.tif',244,3,92,33.9477266,18.545395,24.8155458,1.8,18.5581338,24.8068161,-0.0001414,2.7269149,4.6830019,74.4736486,224.7848038,0.00000008674,48.0001519,27.3105881,63.6296212,5.4112001,9.457088,3.0579175,25.3965028),(23857,'reeves_muntjac-radius.tif',244,3,93,33.9363811,18.5443533,24.8073032,1.8,18.5618062,24.7974419,0.0021648,2.7364081,4.6827337,74.3787533,223.1607431,0.0000265,47.6560825,27.1811628,63.3573177,5.4707886,9.4435928,3.0771658,25.482487),(23858,'reeves_muntjac-radius.tif',244,3,94,34.0276797,18.5336508,24.7923722,1.8,18.5479911,24.7815411,0.0026977,2.7504827,4.6725077,74.3342384,222.9462596,0.0000412,47.7144764,27.0258887,63.3175383,5.470865,9.4135997,3.038068,25.4321186),(23859,'reeves_muntjac-radius.tif',244,3,95,34.0213479,18.5148763,24.7808136,1.8,18.5297475,24.7718438,0.0045067,2.7050125,4.7139348,74.2930696,222.2593198,0.0001151,47.1494262,27.4649632,62.8837351,5.4112001,9.4398733,3.0835933,25.3965028),(23860,'reeves_muntjac-radius.tif',244,3,96,33.9639415,18.5017073,24.7644862,1.8,18.5133456,24.755218,0.0051193,2.7202862,4.7023208,74.2109585,221.7074827,0.0001483,47.1485234,27.2805698,62.6802763,5.4112001,9.4135997,3.038068,25.3965028),(23861,'reeves_muntjac-radius.tif',244,3,97,34.1301434,18.4845278,24.7429257,1.8,18.4935329,24.7349295,0.0063631,2.7394017,4.6866843,74.5370767,221.525823,0.0002303,47.2670673,27.2092539,62.7001085,5.4720001,9.4135997,3.038068,25.3965028),(23862,'reeves_muntjac-radius.tif',244,3,98,33.8765554,18.4718675,24.7214117,1.8,18.4853545,24.7164493,0.0082454,2.7173268,4.6744208,74.806225,219.5216552,0.0003838,46.9623225,27.5293439,62.6301331,5.4720001,9.3596463,3.0309354,25.3461344),(23863,'reeves_muntjac-radius.tif',244,3,99,33.8830046,18.4549419,24.6953635,1.8,18.4684066,24.689986,0.0067874,2.7264206,4.6570201,75.5609194,218.1187378,0.0002601,46.8365462,27.7143292,62.6630244,5.4720001,9.3212569,3.0107653,25.2601502),(23864,'reeves_muntjac-radius.tif',244,3,100,33.7477198,18.4433168,24.6720977,1.8,18.4577913,24.6648623,0.0063323,2.7288851,4.6450079,75.8661366,217.2293699,0.0002255,46.7662002,27.8011472,62.7292615,5.4720001,9.3061746,3.0237206,25.2957661),(23865,'reeves_muntjac-radius.tif',244,3,101,33.6804131,18.4279099,24.6454032,1.8,18.4395569,24.6374699,0.0060662,2.7617444,4.6296737,76.2790235,216.066803,0.0002065,46.6699853,27.6198704,62.7200681,5.5328001,9.2691591,3.0034062,25.2957661),(23866,'reeves_muntjac-radius.tif',244,3,102,33.5165087,18.4172721,24.6148719,1.8,18.4313597,24.6087106,0.0042358,2.7899859,4.6771638,76.6773382,215.132533,0.0001002,45.9963651,27.4830554,62.3567911,5.5328001,9.2657686,3.0693502,25.3461344),(23867,'reeves_muntjac-radius.tif',244,3,103,33.4583515,18.4124937,24.5759224,1.8,18.4279335,24.5670283,0.0043386,2.7526957,4.6722321,77.2824961,214.4607885,0.0001049,45.9011416,28.0752046,62.4233544,5.5328001,9.2147613,3.0557117,25.3313819),(23868,'reeves_muntjac-radius.tif',244,3,104,33.3590912,18.4005636,24.5302652,1.8,18.4104712,24.5232547,0.0043733,2.7676562,4.6606382,78.1671617,213.952081,0.0001065,45.9061766,28.2430895,62.6259932,5.5328001,9.1717362,3.0353278,25.2810135),(23869,'reeves_muntjac-radius.tif',244,3,105,33.2307623,18.3917621,24.4778528,1.8,18.402734,24.4695679,0.0042944,2.7762747,4.652119,79.4168925,213.3647348,0.0001021,45.8639893,28.6055595,62.8374451,5.5328001,9.1541868,3.055142,25.3166293),(23870,'reeves_muntjac-radius.tif',244,3,106,33.1176403,18.3792076,24.4271841,1.8,18.3881137,24.422077,0.0034221,2.7860521,4.6399953,80.7245567,213.7166707,0.0000646,46.059674,28.9745322,63.1528447,5.5936001,9.1404466,3.008162,25.3166293),(23871,'reeves_muntjac-radius.tif',244,3,107,33.1542797,18.3693954,24.3668855,1.8,18.3769128,24.3572896,0.0035655,2.8471077,4.6302503,82.4340883,214.2721798,0.0000702,46.2765869,28.9536253,63.771483,5.6544001,9.0885326,3.0006417,25.4234768),(23872,'reeves_muntjac-radius.tif',244,3,108,33.2282275,18.3567733,24.3000772,1.8,18.3663285,24.2865849,-0.0011385,2.9582309,4.6767926,84.4686535,215.4224546,0.0000072,46.0620075,28.5537731,64.0505604,5.7760001,9.0936154,3.0545647,25.5745819),(23873,'reeves_muntjac-radius.tif',244,3,109,33.259001,18.3526332,24.2334783,1.8,18.3660945,24.2218295,-0.0029564,3.0111823,4.673048,86.5891059,216.6230814,0.0000484,46.3558432,28.7558498,64.5779849,5.8976002,9.0722486,3.0139127,25.6605661),(23874,'reeves_muntjac-radius.tif',244,3,110,33.1968861,18.3374851,24.1719069,1.8,18.3485192,24.1639428,-0.0055934,2.8920663,4.6585803,87.8657267,217.5077174,0.0001731,46.6897004,30.3816434,65.0610292,5.7760001,9.0647073,3.0205654,25.631061),(23875,'reeves_muntjac-radius.tif',244,3,111,33.3888108,18.3291784,24.0986689,1.8,18.3411411,24.0866554,-0.0120775,2.938928,4.7101047,89.9949185,219.0918229,0.0008116,46.5152767,30.6216816,65.4673155,5.8368001,9.0991016,0.0936847,25.6961819),(23876,'reeves_muntjac-radius.tif',244,3,112,33.452338,18.3087576,24.0223346,1.8,18.3134314,24.0104722,-0.0186033,2.927769,4.693152,92.1306126,220.5194775,0.0019293,46.9874996,31.4678552,66.4616195,5.8368001,9.115946,0.1607627,25.7674135),(23877,'reeves_muntjac-radius.tif',244,3,113,33.5104316,18.2916044,23.9469971,1.8,18.2989227,23.9369111,-0.0305662,2.9711859,4.679763,94.3256995,222.1289423,0.0052165,47.4658534,31.7468184,67.459802,5.9584002,9.1361992,0.1739012,25.9393819),(23878,'reeves_muntjac-radius.tif',244,3,114,33.7714845,18.2797363,23.8632785,1.8,18.2862034,23.8527946,-0.043578,3.0165059,4.7288043,97.4530179,224.9239916,0.0106821,47.5646648,32.3065894,68.1659228,6.0192002,9.185832,0.1662368,26.090487),(23879,'reeves_muntjac-radius.tif',244,3,115,34.3508742,18.2692173,23.7614902,1.8,18.2764151,23.7533355,-0.0609003,3.0905013,4.7323758,102.0976056,227.8211914,0.0212074,48.1409762,33.0359367,69.6466693,6.1408002,9.2291919,0.1922276,26.1261028),(23880,'reeves_muntjac-radius.tif',244,3,116,34.5651661,18.2535685,23.6637339,1.8,18.2628913,23.6553614,-0.0747994,3.1542945,4.7780815,105.7498529,231.2329859,0.0321716,48.3945251,33.5256757,70.5056267,6.2016002,9.3127265,0.2037975,26.2624554),(23881,'reeves_muntjac-radius.tif',244,3,117,34.9677336,18.2228598,23.5734232,1.8,18.2335592,23.5679687,-0.0823519,3.2030688,4.8112467,109.4589716,237.2630947,0.0394349,49.3142649,34.1731566,72.0467697,6.2624002,9.3846925,0.2088309,26.4847921),(23882,'reeves_muntjac-radius.tif',244,3,118,35.3727672,18.1811361,23.4605885,1.8,18.1895475,23.4511703,-0.0936192,3.2892462,4.8416988,114.8996383,244.0245399,0.0515203,50.4006032,34.9319058,74.0892132,6.4206186,9.483436,0.2263183,26.7931131),(23883,'reeves_muntjac-radius.tif',244,3,119,36.0367612,18.1538671,23.3453917,1.8,18.1622452,23.3340236,-0.1049371,3.3460837,4.9236528,120.613052,252.2150895,0.0658958,51.2251981,36.0460354,75.7206633,6.5056002,9.5988935,0.1911845,27.0510656),(23884,'reeves_muntjac-radius.tif',244,3,120,36.5664033,18.1381598,23.2304527,1.8,18.14642,23.2139132,-0.1185182,3.4226899,4.9351944,126.7972526,259.2147774,0.0852054,52.5237212,37.0460824,78.1837251,6.6272002,9.674845,0.2282119,27.3237707),(23885,'reeves_muntjac-radius.tif',244,3,121,37.239318,18.139578,23.1209763,1.8,18.14797,23.1043565,-0.1417908,3.4968062,4.9540419,133.3499936,265.082137,0.1239465,53.508255,38.1347962,80.395603,6.7488002,9.7205874,0.2207042,27.5669707),(23886,'reeves_muntjac-radius.tif',244,3,122,37.257704,18.1646348,23.0108581,1.8,18.1647775,22.9808889,-0.1684062,3.5666118,4.9888618,137.3387646,267.079506,0.1744502,53.5351579,38.5067881,81.0604786,6.8704002,9.7799217,0.2706141,27.7033233),(23887,'reeves_muntjac-radius.tif',244,3,123,37.1373924,18.2168903,22.9141585,1.8,18.216204,22.8781267,-0.2065696,3.6120033,4.9985326,140.8142735,268.6613267,0.2603794,53.7480396,38.9850902,81.9157008,6.9312002,9.8131278,0.282555,27.7389391),(23888,'reeves_muntjac-radius.tif',244,3,124,37.2223668,18.2632934,22.8219796,1.8,18.263589,22.7729402,-0.24207,3.6530908,4.9872969,145.2800179,272.472287,0.3564798,54.6332595,39.7690683,83.7029212,7.0528002,9.8477235,0.2944136,28.0263968),(23889,'reeves_muntjac-radius.tif',244,3,125,37.3302279,18.287876,22.7395508,1.8,18.2850814,22.6851437,-0.2738283,3.7443603,4.9661897,149.4164362,280.1235084,0.4549712,56.4061237,39.9043956,86.1660675,7.1229942,9.9236331,0.2984989,28.4710703),(23890,'reeves_muntjac-radius.tif',244,3,126,37.2896732,18.316421,22.6566851,1.8,18.3162975,22.5945279,-0.2987894,3.8551269,4.971876,153.2814486,289.9023365,0.538524,58.3084404,39.7604154,87.9872545,7.2218713,10.0202018,0.3466974,28.815007),(23891,'reeves_muntjac-radius.tif',244,3,127,37.1478156,18.3220798,22.5779266,1.8,18.3196583,22.5027407,-0.3111074,3.9420918,5.1151363,157.0081293,304.1693796,0.5801571,59.4645695,39.8286333,89.3885575,7.3310842,10.1761477,0.3538756,29.3960331),(23892,'reeves_muntjac-radius.tif',244,3,128,36.823143,18.3384506,22.4836779,1.8,18.3398622,22.4047279,-0.3226806,3.9423397,5.2483373,160.9432427,321.0562823,0.6171481,61.172951,40.824296,91.1029724,7.3775969,10.3645725,0.3848636,29.5237438),(23893,'reeves_muntjac-radius.tif',244,3,129,36.6486189,18.3588027,22.3916573,1.8,18.3581119,22.3005928,-0.3305647,3.96435,5.4146235,165.3321975,341.7211026,0.6434908,63.1107776,41.7047424,93.377859,7.4247964,10.5968316,0.3453396,29.974528),(23894,'reeves_muntjac-radius.tif',244,3,130,36.5035074,18.4178509,22.2994945,1.8,18.417269,22.2015137,-0.3488974,4.0110393,5.5472128,169.0423972,362.4035863,0.7110244,65.3307521,42.1442887,95.6678999,7.5019829,10.8097547,0.3502126,30.798754),(23895,'reeves_muntjac-radius.tif',244,3,131,36.7847582,18.445532,22.2215213,1.8,18.4486913,22.1174223,-0.3542326,4.0789514,5.6816258,174.9870001,387.3198517,0.7376527,68.1706019,42.8999964,98.9501918,7.5750771,11.0229246,0.3548972,31.4215066),(23896,'reeves_muntjac-radius.tif',244,3,132,38.2526267,18.5118481,22.131526,1.8,18.5270504,22.0065359,-0.3800383,4.1200716,5.7993785,186.469648,424.1309168,0.8773136,73.1338563,45.2588368,105.2493169,7.7088849,11.3146826,0.3625442,32.2604852),(23897,'reeves_muntjac-radius.tif',244,3,133,39.1870436,18.5665047,22.0566431,1.8,18.5874047,21.9306725,-0.405692,4.2044466,5.9694033,197.9974526,472.4161585,1.0172453,79.1395951,47.0923929,112.1051531,7.8065324,11.6558535,0.4076315,33.1116852),(23898,'reeves_muntjac-radius.tif',244,3,134,41.8410619,18.6517374,21.8914436,1.8,18.6552888,21.7649451,-0.4263969,4.3141591,6.1528303,220.5196731,543.548986,1.1928828,88.3412938,51.1153316,123.5408064,7.9774849,12.0745803,0.4816637,34.2859587),(23899,'reeves_muntjac-radius.tif',244,3,135,47.2504319,18.7471811,21.6896823,1.8,18.7492656,21.5985775,-0.4246739,4.4120956,6.3950879,249.3690374,651.0751573,1.3368997,101.8086337,56.5194095,139.1820295,8.1384646,12.5916201,0.4442116,35.739048),(23900,'reeves_muntjac-radius.tif',244,3,136,56.447835,18.5794877,21.6449232,1.8,18.5502908,21.5600123,-0.3925853,4.371234,7.01106,267.4917719,808.0065245,1.3770085,115.2474119,61.1936514,150.4994828,8.1744182,13.4402388,0.5792199,37.4500899),(23901,'reeves_muntjac-radius.tif',244,3,137,60.0641382,18.4702679,21.745414,1.8,18.538264,21.6336551,-0.3481494,4.3061922,7.6510495,272.2562381,997.3749364,1.1651375,130.3579257,63.2243585,164.4058668,8.0311807,14.4251127,0.3484109,39.2618686),(23902,'reeves_muntjac-radius.tif',244,3,138,65.7938126,18.2895927,21.8394503,1.8,18.4597718,21.6921011,-0.2994764,4.1507587,8.3070409,285.4426225,1118.0976035,0.9544133,134.5963761,68.7687828,168.3727632,7.9235758,15.2754483,0.2865007,40.6289737),(23903,'reeves_muntjac-radius.tif',244,3,139,69.8399082,18.7505105,21.7164749,1.8,18.7757027,21.5960891,-0.2569118,4.1653719,7.7805266,292.4156275,1053.4985247,0.7515263,135.4019557,70.201566,170.142669,8.0407787,15.0328542,0.2744108,40.5134844),(23904,'reeves_muntjac-radius.tif',244,3,140,57.6721346,19.7270797,21.3816117,1.8,19.6857692,21.2624723,-0.1385076,4.2497841,7.4553986,272.8048907,656.8058631,0.1832241,88.0980212,64.1926474,122.3127163,8.1566146,13.8605336,0.0922484,41.9726845),(23905,'reeves_muntjac-radius.tif',244,3,141,38.8733697,20.6482167,20.8110859,1.8,20.5268952,20.694757,0.049949,5.1884152,7.8621429,198.3917245,410.4515433,0.0161508,52.2060649,38.237442,77.1689552,8.184186,12.8142404,2.9795641,50.8865832),(23906,'reeves_muntjac-radius.tif',244,3,142,23.5779979,21.6284377,20.1211844,1.8,21.5321662,20.0619284,0.1893705,6.0638381,7.4742548,76.402634,219.5951506,0.139246,29.3802066,12.5997154,39.5656301,2.1752747,5.7875087,0.1582403,13.9045612),(23907,'reeves_muntjac-radius.tif',244,3,143,8.2496067,21.9820389,18.9662517,1.8,21.8549935,18.9697892,0.3549831,2.9659121,5.0320731,13.9908668,43.8636061,0.1661032,8.7168061,4.7172223,10.6021326,0.9295492,3.4842168,0.5104883,7.7986355),(23908,'reeves_muntjac-radius.tif',244,3,144,2.8124479,22.5985374,18.0202098,1.8,22.5772806,18.0160005,-0.3425227,0.6984182,1.5568165,0.2777777,1.5179003,0.0528763,0.9750027,0.3977241,1.1377717,1.3848626,3.1551628,0.4377913,7.8820885),(23909,'reeves_muntjac-radius.tif',244,3,145,0.7708812,22.5193582,17.7699514,1.8,22.527016,17.7641851,-0.5496413,0.3890585,0.835756,0.0241893,0.1067565,0.03506,0.1277365,0.0621739,0.156507,0.8097497,1.6595171,0.4964228,4.0031098),(23910,'reeves_muntjac-radius.tif',244,3,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23911,'reeves_muntjac-radius.tif',244,3,147,22.2887038,18.0353509,15.1488962,1.8,18.0463426,15.1539798,-0.9588846,2.9306272,4.0096437,39.2232461,89.6391862,2.4890031,22.355898,13.3839085,31.6857824,5.3507857,8.5822815,1.1705557,23.5038023),(23912,'reeves_muntjac-radius.tif',244,3,148,21.39463,17.9834516,15.1083967,1.8,17.9940939,15.091991,-0.9787292,2.7570854,3.9327356,37.0546904,84.9387229,2.4552104,21.5978727,13.4398049,30.7070502,5.1461714,8.6944002,1.1760052,23.3318339),(23913,'reeves_muntjac-radius.tif',244,3,149,20.733795,17.9331289,15.1334195,1.8,17.9339634,15.1059656,-1.0052789,2.7666468,3.9879812,35.7080495,82.9978496,2.4633886,20.8119963,12.9066168,29.6923879,5.0120176,8.8526139,1.2055949,23.4030655),(23914,'reeves_muntjac-radius.tif',244,3,150,20.8106324,17.8716043,15.2386307,1.8,17.8649841,15.19708,-1.0363467,2.7876869,4.1301812,35.6697211,84.0376606,2.568534,20.3472089,12.7954546,28.8083332,4.9050935,9.1163515,1.2237347,23.9042181),(23915,'reeves_muntjac-radius.tif',244,3,151,20.7969564,17.8329603,15.4095121,1.8,17.8140447,15.3508342,-1.0757819,2.852562,4.2777097,36.9972745,87.4187385,2.6839611,20.4358744,12.9698408,28.8285447,4.8212119,9.4873332,1.2916164,24.6485707),(23916,'reeves_muntjac-radius.tif',244,3,152,21.764908,17.8081722,15.6303487,1.8,17.7853384,15.578096,-1.1378533,2.8769105,4.4448786,40.2899549,94.8066529,2.9889849,21.3294135,14.004591,29.9526467,4.8411024,9.980279,1.3745955,26.6740442),(23917,'reeves_muntjac-radius.tif',244,3,153,23.825668,17.8159544,15.9059283,1.8,17.7985804,15.8260282,-1.2170698,2.845145,4.6261731,44.5926663,109.2124934,3.4944703,23.607524,15.6732493,32.4783689,4.9948265,10.6003194,1.3745256,27.7745549),(23918,'reeves_muntjac-radius.tif',244,3,154,25.622024,17.8193797,16.2745399,1.8,17.8163645,16.1717127,-1.3008872,2.7327176,4.8633303,48.7428313,130.4481641,3.9667209,26.8228056,17.836761,35.7104792,5.0770543,11.4104936,1.4371885,29.3431335),(23919,'reeves_muntjac-radius.tif',244,3,155,28.1639773,17.8597982,16.8860621,1.8,17.8597533,16.745138,-1.3902436,2.715783,5.3279725,53.0806326,168.9098554,4.542631,31.7024635,19.5452405,40.0758779,5.2221749,12.6792423,1.4988056,31.4545913),(23920,'reeves_muntjac-radius.tif',244,3,156,31.1323237,17.8720382,17.7119023,1.8,17.8703811,17.5069153,-1.4740634,2.5705317,5.9973309,57.0633952,244.2641774,5.1403197,40.7288142,22.1990628,48.1150156,5.1079126,14.4919708,1.5162287,34.8888965),(23921,'reeves_muntjac-radius.tif',244,3,157,30.0816945,17.8368462,17.8905009,1.8,17.830488,17.6604214,-1.4535226,2.4581061,6.2074853,51.4842732,247.3593794,4.9449784,39.8485647,20.944691,46.5571329,4.6896184,14.9067916,1.472751,35.5508444),(23922,'reeves_muntjac-radius.tif',244,3,158,27.7305404,17.865117,17.4394557,1.8,17.8415914,17.2507155,-1.474474,2.3307937,5.7085298,41.8819663,216.1272564,4.5790086,37.8604059,17.9689716,43.4044084,4.4004504,14.8194937,1.4927658,34.6111291),(23923,'reeves_muntjac-radius.tif',244,3,159,24.150931,17.8273676,17.2133626,1.8,17.8087899,17.0396288,-1.4918262,2.1963176,5.4517027,34.9835076,170.0676279,4.0001053,31.195323,15.9282552,35.8101304,4.2849953,14.7418377,1.5088921,34.0804714),(23924,'reeves_muntjac-radius.tif',244,3,160,22.5639848,17.7377487,16.9915507,1.8,17.7117158,16.7953638,-1.4712208,2.2008699,5.2627351,29.7933667,148.6838876,3.7234991,28.2522084,13.5370868,32.3973365,4.1565978,14.7869054,1.5296673,34.0804714),(23925,'reeves_muntjac-radius.tif',244,3,161,21.3999085,17.6493316,16.7616764,1.8,17.6254039,16.5917139,-1.4478005,2.1804563,5.0746844,25.5226437,135.6384719,3.5129668,26.7284545,11.7051846,30.354798,4.0636532,14.8562412,1.517568,34.5103923),(23926,'reeves_muntjac-radius.tif',244,3,162,20.8176105,17.5613759,16.5014804,1.8,17.5355945,16.3584874,-1.4299925,2.1386398,4.8393282,22.3827822,127.279545,3.4012677,26.3010775,10.4658963,29.585633,4.0024463,14.9277315,1.5055828,34.4808872),(23927,'reeves_muntjac-radius.tif',244,3,163,21.4382696,17.4769414,16.0952188,1.8,17.4564929,15.973758,-1.4213158,2.0922326,4.7826187,20.2876665,127.0501298,3.4938002,26.5649716,9.6966592,30.7798269,4.0231658,15.147012,1.5386789,34.9611765),(23928,'reeves_muntjac-radius.tif',244,3,164,20.4242819,17.3838117,15.9120835,1.8,17.3538962,15.7845171,-1.4090006,2.0800619,4.5744551,18.5240717,115.9902866,3.3157112,25.3560883,8.9055385,29.4054391,4.0368354,15.1376132,1.4823183,35.3910975),(23929,'reeves_muntjac-radius.tif',244,3,165,19.6825142,17.2970987,15.71552,1.8,17.2680515,15.6036119,-1.3981589,2.1090674,4.4742046,17.1248421,103.6631865,3.1836179,23.1690758,8.1196276,26.9964791,4.1344001,15.1273532,1.4903253,35.9573709),(23930,'reeves_muntjac-radius.tif',244,3,166,18.8211735,17.212646,15.5934882,1.8,17.1842436,15.4742899,-1.3775994,2.1440957,4.3729612,16.2167075,93.4392153,3.0212282,21.3674925,7.5634251,25.0756798,4.2560001,15.192946,1.4866581,35.7497868),(23931,'reeves_muntjac-radius.tif',244,3,167,18.4723173,17.10503,15.4758271,1.8,17.0798948,15.3729569,-1.3657733,2.1730261,4.3347263,15.7073085,88.3473584,2.9511104,20.3813003,7.228311,23.9799927,4.3494827,15.3313687,1.5350972,35.7854026),(23932,'reeves_muntjac-radius.tif',244,3,168,17.9376108,16.9825711,15.511608,1.8,16.9551732,15.3693733,-1.3499883,2.2300001,4.3165408,15.2578568,85.0329767,2.8461938,19.6993337,6.8420878,23.2265011,4.5444134,15.4863464,1.4961322,36.4020444),(23933,'reeves_muntjac-radius.tif',244,3,169,18.0435806,16.8436122,15.4619021,1.8,16.8229586,15.3291925,-1.3478696,2.2088219,4.4341402,15.1916677,86.5202741,2.8602729,19.5123001,6.8777242,22.9301074,4.6779764,15.6827473,1.4854014,36.7520919),(23934,'reeves_muntjac-radius.tif',244,3,170,17.5689511,16.6796451,15.4859166,1.8,16.6514165,15.3590707,-1.3384976,2.3207324,4.5202718,15.0269475,85.3249978,2.7729691,18.8760768,6.4750884,22.2003196,4.8538113,15.9302966,1.4829008,37.1525077),(23935,'reeves_muntjac-radius.tif',244,3,171,17.1252424,16.503338,15.46162,1.8,16.4768884,15.3377573,-1.333815,2.2764282,4.6778101,14.2964164,87.2867106,2.6968926,18.6597378,6.2801964,21.7156864,5.0495466,16.157822,1.4954674,38.0123496),(23936,'reeves_muntjac-radius.tif',244,3,172,16.6092737,16.3425415,15.3698895,1.8,16.3207737,15.2702242,-1.3521373,2.2204968,4.6850993,13.5792384,87.2327667,2.6379551,18.6191927,6.1154055,21.5175702,5.1922784,16.1230095,1.4763809,38.1782073),(23937,'reeves_muntjac-radius.tif',244,3,173,15.6260838,16.1888571,15.0928987,1.8,16.1691938,15.0469767,-1.3851373,2.2752144,4.6760089,13.3185948,79.0287142,2.515604,16.9008904,5.8537757,19.7476697,5.2899266,15.7720642,1.4665247,37.3478705),(23938,'reeves_muntjac-radius.tif',244,3,174,14.1356645,15.9779597,14.7936774,1.8,15.976019,14.747432,-1.4266852,2.2059371,4.3986745,12.7173525,61.3314548,2.3073535,13.9431674,5.7650567,16.8337654,5.3611702,15.0401066,1.4654962,35.7019495),(23939,'reeves_muntjac-radius.tif',244,3,175,12.2124816,15.7722545,14.4903681,1.8,15.7937681,14.4149152,-1.4566339,2.2189195,3.9439211,10.0092629,41.8737673,2.009001,10.6172935,4.5108725,13.1490025,5.3970644,14.1688791,1.4762515,33.9135653),(23940,'reeves_muntjac-radius.tif',244,3,176,8.8897715,15.7012625,14.1999308,1.8,15.698003,14.1553314,-1.4263773,1.9678003,3.5023976,5.6455979,24.1770271,1.4509407,6.9029933,2.8689893,8.5027878,5.2225116,13.3706102,1.4797247,31.9384601),(23941,'reeves_muntjac-radius.tif',244,3,177,6.6779967,15.5288073,13.9403204,1.8,15.5194969,13.9536004,-1.4728084,1.553835,3.137771,3.1321308,14.0826598,1.102347,4.4881095,2.0157422,5.4720146,4.7702938,12.6330933,1.484058,30.0554499),(23942,'reeves_muntjac-radius.tif',244,3,178,4.7012537,15.3965391,13.8244129,1.8,15.4096829,13.8082887,-1.5058382,1.2614608,2.5988795,1.6194937,7.428675,0.7802407,2.8584145,1.2838241,3.4813647,4.2158332,11.7499837,1.4567105,27.7425187),(23943,'reeves_muntjac-radius.tif',244,3,179,3.3774979,15.2543284,13.6207866,1.8,15.2590137,13.5733245,1.5412014,0.846945,1.9469522,0.6530701,3.5561362,0.5624234,1.8265144,0.7710892,2.1605308,3.7752977,10.6420846,1.4620318,25.4885977),(23944,'reeves_muntjac-radius.tif',244,3,180,1.5543016,15.2902783,12.8552916,1.8,15.2924215,12.874561,1.4447558,0.5169453,1.1389786,0.084083,0.4794061,0.2549567,0.4209088,0.1626536,0.4947136,1.0195556,3.0672381,1.8109673,7.1290941),(23945,'reeves_muntjac-radius.tif',244,3,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23946,'reeves_muntjac-radius.tif',244,3,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23947,'reeves_muntjac-radius.tif',244,3,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23948,'reeves_muntjac-radius.tif',244,3,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23949,'reeves_muntjac-radius.tif',244,3,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23950,'reeves_muntjac-radius.tif',244,3,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23951,'reeves_muntjac-radius.tif',244,3,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23952,'reeves_muntjac-radius.tif',244,3,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23953,'reeves_muntjac-radius.tif',244,3,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23954,'reeves_muntjac-radius.tif',244,3,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23955,'reeves_muntjac-radius.tif',244,3,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23956,'reeves_muntjac-radius.tif',244,3,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23957,'reeves_muntjac-ulna.tif',244,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23958,'reeves_muntjac-ulna.tif',244,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23959,'reeves_muntjac-ulna.tif',244,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23960,'reeves_muntjac-ulna.tif',244,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23961,'reeves_muntjac-ulna.tif',244,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23962,'reeves_muntjac-ulna.tif',244,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23963,'reeves_muntjac-ulna.tif',244,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23964,'reeves_muntjac-ulna.tif',244,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23965,'reeves_muntjac-ulna.tif',244,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23966,'reeves_muntjac-ulna.tif',244,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23967,'reeves_muntjac-ulna.tif',244,4,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23968,'reeves_muntjac-ulna.tif',244,4,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23969,'reeves_muntjac-ulna.tif',244,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(23970,'reeves_muntjac-ulna.tif',244,4,14,1.450018,12.7561233,18.0247135,1.8,12.774319,18.0288152,1.4364102,0.4893782,1.2197311,0.0695497,0.4421865,0.2373314,0.3625279,0.1421185,0.4144855,1.1639205,2.405253,1.9325256,5.9487099),(23971,'reeves_muntjac-ulna.tif',244,4,15,7.9944337,13.3982539,17.5716747,1.8,13.4524987,17.5255506,-1.3504078,1.5843109,2.5370753,2.8111481,14.7632629,1.2687302,5.8190085,1.7743664,6.6994873,3.7199656,5.0467664,1.0262446,15.3907352),(23972,'reeves_muntjac-ulna.tif',244,4,16,17.6472131,14.51279,17.5886856,1.8,14.5255549,17.5659017,0.2076235,3.3391595,3.5623198,40.6829255,43.4876265,0.1249765,12.2076706,12.1835825,23.3012786,5.8194611,7.4573625,2.7217127,25.9678386),(23973,'reeves_muntjac-ulna.tif',244,4,17,25.8402403,15.4102044,18.0959303,1.8,15.4068543,18.0228346,0.3306849,3.4617632,5.0646915,62.0088884,112.0523565,0.454031,22.1242215,17.9125159,33.343397,6.2637955,10.1158486,2.8426518,27.6997437),(23974,'reeves_muntjac-ulna.tif',244,4,18,32.0282403,16.265136,18.258851,1.8,16.150712,18.1327869,0.2006329,3.5585482,5.112484,92.2346882,188.3842702,0.2120074,36.8478941,25.9191901,50.2640281,6.9030964,10.9743582,2.8724252,30.6303652),(23975,'reeves_muntjac-ulna.tif',244,4,19,1.0858706,21.6505758,10.2655656,1.8,21.6486223,10.2698151,1.4601018,0.4969438,0.8504856,0.0536889,0.1853116,0.1787699,0.2178892,0.1080381,0.2807971,1.0066177,1.7547938,1.815775,4.5103731),(23976,'reeves_muntjac-ulna.tif',244,4,20,3.1665809,21.715061,10.6525048,1.8,21.6998042,10.6415419,1.2264877,0.835123,1.4706134,0.4799851,1.560541,0.4676316,1.0611497,0.5747478,1.3665134,1.6922496,2.9816807,1.9247938,7.6032727),(23977,'reeves_muntjac-ulna.tif',244,4,21,6.0909441,21.7734067,11.3208477,1.8,21.7489198,11.3553273,1.2394096,1.2607166,2.1068703,2.1814345,5.9518578,0.9076972,2.8249758,1.7303132,3.8296402,2.499681,4.0261355,1.830426,11.0609723),(23978,'reeves_muntjac-ulna.tif',244,4,22,7.8925546,21.8481797,11.7481967,1.8,21.7940991,11.7499256,1.0206672,1.906899,2.4739925,4.8762754,9.7547266,0.9558975,3.9429088,2.5571755,5.8162979,3.244139,4.8943057,2.0344439,13.2375509),(23979,'reeves_muntjac-ulna.tif',244,4,23,6.3392453,21.9208704,11.7211101,1.8,21.8824832,11.7059164,0.9517093,1.6815294,2.2812899,3.6313768,6.6767425,0.7007627,2.9267401,2.1595678,4.2694138,2.9661735,4.6243987,2.0638472,12.6946718),(23980,'reeves_muntjac-ulna.tif',244,4,24,4.685339,22.0256632,11.6335659,1.8,21.9844244,11.6079755,0.9460851,1.6306729,2.121681,2.4073504,4.2582708,0.5137749,2.0070268,1.4762927,2.9232242,2.7870598,4.2233031,2.0988708,11.6272458),(23981,'reeves_muntjac-ulna.tif',244,4,25,4.2947684,22.013055,11.6493576,1.8,21.9764475,11.628737,0.9241904,1.7552529,2.0619878,2.3828858,3.9977778,0.4559732,1.938798,1.357574,2.8567984,2.89801,4.2158565,2.1507991,11.9208141),(23982,'reeves_muntjac-ulna.tif',244,4,26,4.3890053,21.9700543,11.6793816,1.8,21.9381549,11.6577443,0.9439095,1.7356192,2.1140278,2.3848207,4.1923459,0.4797691,1.9831083,1.374046,2.9818125,2.9189524,4.2158565,2.1507991,12.1431509),(23983,'reeves_muntjac-ulna.tif',244,4,27,4.1695238,21.999527,11.7889271,1.8,21.9754006,11.7726803,0.9972724,1.8389076,2.0399442,2.3797161,4.1109988,0.4903291,2.0152506,1.2940922,2.9654431,3.012027,4.1348471,2.1995926,11.891309),(23984,'reeves_muntjac-ulna.tif',244,4,28,4.1193392,21.9682606,11.9075309,1.8,21.9469447,11.8914233,1.1198152,2.060685,2.0478795,2.745965,3.991834,0.5561354,1.9492524,1.3325496,3.0579999,3.2375918,4.1651329,2.1587989,12.2769723),(23985,'reeves_muntjac-ulna.tif',244,4,29,4.5559551,21.8762579,12.143444,1.8,21.8579367,12.1229153,1.4150784,2.1145322,2.3019858,3.7554285,4.8916013,0.741062,2.1249485,1.7760092,3.750623,3.5005405,4.4116676,2.0899424,13.3947667),(23986,'reeves_muntjac-ulna.tif',244,4,30,4.9508665,21.8286306,12.4795499,1.8,21.807642,12.4665294,-1.4860133,1.9401512,2.5249619,4.1079165,6.2144431,0.8192273,2.4612028,2.1173177,4.0855836,3.6321938,4.4388165,1.9792852,13.5016142),(23987,'reeves_muntjac-ulna.tif',244,4,31,5.0971796,21.8694986,12.8441077,1.8,21.8381142,12.8183812,-1.4246477,2.0254311,2.7176446,4.1459115,7.1931584,0.8315133,2.6468356,2.046928,4.172344,3.6178585,4.6212001,1.0010399,13.8725249),(23988,'reeves_muntjac-ulna.tif',244,4,32,5.0574125,21.8370778,12.9810403,1.8,21.8085294,12.9860625,-1.4124465,1.9337993,2.7279542,3.8029986,7.8106983,0.8219426,2.8632073,1.9665943,4.2556319,3.5448939,4.8415282,0.9549264,14.3171984),(23989,'reeves_muntjac-ulna.tif',244,4,33,5.150928,21.8474304,13.2831974,1.8,21.812745,13.2747807,-1.3129136,1.7744155,2.764483,3.456278,7.9794186,0.80265,2.8864054,1.9478403,4.1326745,3.2645663,4.9755803,1.0031299,14.0739984),(23990,'reeves_muntjac-ulna.tif',244,4,34,5.19867,21.8133936,13.3793834,1.8,21.7706453,13.3892841,-1.2926958,1.6666809,2.6879088,2.8588624,7.2254424,0.8011441,2.6881278,1.7153029,3.7385683,3.0472269,4.9755803,1.0031299,13.8664142),(23991,'reeves_muntjac-ulna.tif',244,4,35,4.8661599,21.7638778,13.6268949,1.8,21.732061,13.6105662,-1.2400907,1.4478545,2.6962762,2.2866888,6.355198,0.7255145,2.3570278,1.5793637,3.168915,2.7842992,4.8491575,1.0454295,13.3505091),(23992,'reeves_muntjac-ulna.tif',244,4,36,4.5111733,21.7393679,13.8296423,1.8,21.710001,13.8372443,-1.1733683,1.4142309,2.4054268,1.7974625,5.231892,0.6392285,2.1750368,1.2709823,2.7789207,2.6750938,4.4885063,1.1374425,12.2057407),(23993,'reeves_muntjac-ulna.tif',244,4,37,4.3038021,21.6991442,14.0429671,1.8,21.6738632,14.0477545,-1.1084316,1.392722,2.2319468,1.4733025,4.479779,0.5745757,2.0071172,1.0578582,2.4986874,2.5539683,4.2425159,1.1263771,11.4970039),(23994,'reeves_muntjac-ulna.tif',244,4,38,4.1611284,21.653962,14.1988017,1.8,21.6349263,14.2020316,-1.0441241,1.3363126,2.0989594,1.2974094,4.2916605,0.5182919,2.044661,0.9708877,2.484592,2.4413953,4.1708978,1.0353768,11.3397881),(23995,'reeves_muntjac-ulna.tif',244,4,39,4.0495089,21.6123942,14.355818,1.8,21.5959862,14.362573,-0.9941291,1.3029251,2.0412751,1.1517799,4.2000665,0.4742791,2.0575701,0.8839954,2.4091816,2.3633502,4.150463,1.0153026,11.1469565),(23996,'reeves_muntjac-ulna.tif',244,4,40,3.9752999,21.5761572,14.4850166,1.8,21.55977,14.4939604,-0.9600659,1.233315,2.0755222,1.0089257,4.0919067,0.4446616,1.9715071,0.81806,2.3063146,2.253221,4.0993812,0.9539951,10.8533881),(23997,'reeves_muntjac-ulna.tif',244,4,41,3.8929509,21.5523654,14.6226331,1.8,21.5345346,14.6368777,-0.9471037,1.2590594,2.1077077,0.8900111,3.9223575,0.4275117,1.8609589,0.7068857,2.1549269,2.2464717,4.0993812,0.9539951,10.7674039),(23998,'reeves_muntjac-ulna.tif',244,4,42,3.8199341,21.502872,14.7714072,1.8,21.4844119,14.7846817,-0.9345881,1.1979731,2.1138388,0.7817081,3.8009363,0.4119073,1.7981202,0.6525255,2.0721101,2.1498829,4.1146825,0.9745972,10.7821565),(23999,'reeves_muntjac-ulna.tif',244,4,43,3.7328375,21.4442313,14.9242383,1.8,21.423827,14.9342394,-0.917559,1.1279748,2.1969169,0.6863483,3.7838484,0.3923382,1.7223448,0.6084784,1.9720321,2.042039,4.1991635,0.9707461,10.6249406),(24000,'reeves_muntjac-ulna.tif',244,4,44,3.599936,21.3851077,15.0942049,1.8,21.3567772,15.1174051,-0.9082338,1.1442594,2.2124678,0.5808987,3.6629387,0.3729556,1.6555896,0.5076635,1.8648777,1.9902109,4.1841711,0.9505468,10.7551825),(24001,'reeves_muntjac-ulna.tif',244,4,45,3.4451464,21.311081,15.2534349,1.8,21.2723427,15.2865492,-0.9010616,0.9773016,2.225874,0.4909246,3.5909485,0.3529177,1.6132757,0.5023266,1.7907742,1.7634071,4.1708978,0.9302107,10.1532932),(24002,'reeves_muntjac-ulna.tif',244,4,46,3.3598862,21.2386366,15.4267472,1.8,21.2004647,15.466581,-0.8988592,0.9542456,2.2364551,0.4416787,3.6467415,0.3429827,1.6305901,0.4628564,1.7964178,1.6981158,4.2198004,0.9388221,10.1680457),(24003,'reeves_muntjac-ulna.tif',244,4,47,3.3070809,21.1904287,15.5871412,1.8,21.1572874,15.6193985,-0.904242,0.9205582,2.2596549,0.4166479,3.5812609,0.3404794,1.5848707,0.4526035,1.744627,1.644557,4.2560001,0.9272952,10.1680457),(24004,'reeves_muntjac-ulna.tif',244,4,48,3.2272397,21.1499013,15.7353188,1.8,21.1142365,15.7720189,-0.9096172,0.9152081,2.2492026,0.4013265,3.4093581,0.3350656,1.5158075,0.4385084,1.66422,1.644557,4.2351031,0.887087,10.1680457),(24005,'reeves_muntjac-ulna.tif',244,4,49,3.2239489,21.0830685,15.9062609,1.8,21.0468617,15.946315,-0.9170988,0.9150992,2.2628933,0.3846064,3.5185086,0.338613,1.5548717,0.4202893,1.7065832,1.609867,4.2560001,0.9272952,10.1176774),(24006,'reeves_muntjac-ulna.tif',244,4,50,3.1404157,21.027103,16.0549669,1.8,20.9871555,16.0964277,-0.9128388,0.8954181,2.2938358,0.3583896,3.4188213,0.3276842,1.4904385,0.4002483,1.6326833,1.5844485,4.2560001,0.9272952,10.1176774),(24007,'reeves_muntjac-ulna.tif',244,4,51,3.0639246,20.9856044,16.1853065,1.8,20.9399625,16.2367169,-0.9184878,0.8484243,2.3083438,0.3247602,3.3408464,0.3224901,1.4472915,0.3827804,1.5788148,1.5136737,4.2560001,0.9272952,10.0820615),(24008,'reeves_muntjac-ulna.tif',244,4,52,3.0659552,20.9369617,16.3351341,1.8,20.8917329,16.3892939,-0.9190873,0.8216223,2.3414713,0.3181178,3.349883,0.3229993,1.4306744,0.3871826,1.5590748,1.4844205,4.2927557,0.9159643,10.1176774),(24009,'reeves_muntjac-ulna.tif',244,4,53,3.0506022,20.892219,16.4818727,1.8,20.8453658,16.5373731,-0.9207452,0.8072007,2.4159922,0.3076397,3.3879668,0.3221945,1.4023087,0.3811193,1.5199817,1.4570158,4.3678782,0.8938815,10.2392774),(24010,'reeves_muntjac-ulna.tif',244,4,54,2.9764803,20.8577791,16.6053394,1.8,20.8061318,16.6678447,-0.9239973,0.7724408,2.4413673,0.2878819,3.2574167,0.3159191,1.3342592,0.3726912,1.4464384,1.3973743,4.3780223,0.9134072,10.1680457),(24011,'reeves_muntjac-ulna.tif',244,4,55,2.9829367,20.8136986,16.747273,1.8,20.7608354,16.8142577,-0.9255072,0.7218073,2.483421,0.2720067,3.4102099,0.3173261,1.3731904,0.3768411,1.4774265,1.3456836,4.4263069,0.9218008,10.2687825),(24012,'reeves_muntjac-ulna.tif',244,4,56,2.9936448,20.7712668,16.8842113,1.8,20.7141238,16.9583732,-0.9246924,0.6988472,2.5675555,0.2615146,3.5167881,0.3180745,1.3697029,0.3742086,1.4649445,1.3476892,4.5388738,0.8897793,10.4259983),(24013,'reeves_muntjac-ulna.tif',244,4,57,2.9986999,20.7234794,17.022167,1.8,20.6666139,17.0983243,-0.9293079,0.6640536,2.6097966,0.2477022,3.7125865,0.3208264,1.4225578,0.3730154,1.5110996,1.3290789,4.5967375,0.9167136,10.5475983),(24014,'reeves_muntjac-ulna.tif',244,4,58,2.9253315,20.6802874,17.1453874,1.8,20.6181175,17.2309878,-0.9265951,0.6140278,2.7048453,0.2215623,3.8314587,0.3117076,1.4165168,0.3608342,1.4915566,1.2902677,4.7099403,0.8859751,10.7343192),(24015,'reeves_muntjac-ulna.tif',244,4,59,2.8997273,20.6327007,17.2726549,1.8,20.5629898,17.3711058,-0.9268391,0.6113574,2.8054289,0.2032829,4.0968156,0.3090926,1.460317,0.3325108,1.5288355,1.2641624,4.8525867,0.9097532,11.078256),(24016,'reeves_muntjac-ulna.tif',244,4,60,2.878776,20.5644485,17.4222929,1.8,20.4893102,17.5270667,-0.9294454,0.575397,2.8630626,0.1858192,4.5119024,0.3080592,1.5759007,0.3229408,1.6354401,1.218871,4.9755803,0.8979638,11.2502243),(24017,'reeves_muntjac-ulna.tif',244,4,61,2.8986798,20.517238,17.5472329,1.8,20.4482195,17.6443685,-0.9276563,0.5635756,2.8689502,0.1796707,4.8962953,0.30936,1.7066505,0.3188049,1.763128,1.1954151,5.0232724,0.9055069,11.5437927),(24018,'reeves_muntjac-ulna.tif',244,4,62,2.841879,20.4987446,17.6341128,1.8,20.4214809,17.7421488,-0.9288916,0.5423274,2.9217909,0.1661171,4.7640231,0.3038593,1.6305147,0.306304,1.6809071,1.1540926,5.099232,0.8867447,11.4369453),(24019,'reeves_muntjac-ulna.tif',244,4,63,2.9197453,20.441496,17.773106,1.8,20.3667983,17.8789217,-0.9323246,0.552755,2.9090431,0.1663912,5.3469059,0.3137855,1.8380291,0.3010217,1.8865275,1.1663399,5.1464966,0.8942104,11.6089136),(24020,'reeves_muntjac-ulna.tif',244,4,64,2.9121777,20.4243346,17.8633438,1.8,20.3511725,17.971616,-0.9393591,0.5651151,2.8731115,0.165689,5.3647789,0.3162331,1.8672366,0.2931951,1.9142425,1.1768187,5.099232,0.8867447,11.5585453),(24021,'reeves_muntjac-ulna.tif',244,4,65,2.9021556,20.4031494,17.9405785,1.8,20.3261316,18.0521999,-0.9446629,0.5519741,2.8949948,0.1628941,5.3241329,0.3175854,1.839082,0.2951119,1.88681,1.146438,5.1086475,0.9034902,11.6089136),(24022,'reeves_muntjac-ulna.tif',244,4,66,2.9016736,20.3812429,18.0312003,1.8,20.3073747,18.1423837,-0.9539769,0.5472958,2.855303,0.160984,5.3337396,0.321797,1.8680118,0.2941445,1.9137126,1.1534023,5.099232,0.8867447,11.5585453),(24023,'reeves_muntjac-ulna.tif',244,4,67,2.893899,20.3599899,18.1022555,1.8,20.283478,18.2184452,-0.9545634,0.5463761,2.8489492,0.1585338,5.2200062,0.3212017,1.8322567,0.2901552,1.8829118,1.1414356,5.071245,0.9129077,11.4873136),(24024,'reeves_muntjac-ulna.tif',244,4,68,2.9417665,20.3292767,18.1884017,1.8,20.2622941,18.2917267,-0.9599955,0.5642684,2.8094015,0.1654533,5.3113377,0.3290222,1.8905584,0.2932174,1.9439021,1.1641092,5.0342989,0.9224643,11.4013295),(24025,'reeves_muntjac-ulna.tif',244,4,69,3.0219791,20.2844214,18.2969887,1.8,20.2215611,18.3936658,-0.9724001,0.5589989,2.741799,0.1746648,5.6427746,0.3438371,2.0580555,0.3124599,2.1138696,1.1753642,5.0342989,0.9224643,11.4725611),(24026,'reeves_muntjac-ulna.tif',244,4,70,3.0058747,20.2685582,18.3535779,1.8,20.2098058,18.4477529,-0.9771499,0.5580508,2.684861,0.1736613,5.4293947,0.3442157,2.0222256,0.3111926,2.0765382,1.1803757,4.9491351,0.9248382,11.3005927),(24027,'reeves_muntjac-ulna.tif',244,4,71,3.0229271,20.2478996,18.4113235,1.8,20.1902906,18.5017322,-0.9872157,0.5656464,2.5889476,0.1792518,5.3106974,0.350852,2.0512958,0.3168972,2.1099606,1.1832485,4.8640001,0.9272952,11.2858402),(24028,'reeves_muntjac-ulna.tif',244,4,72,3.0760163,20.2163087,18.4847325,1.8,20.1624359,18.5730544,-0.9937425,0.5750746,2.6257366,0.1855423,5.4585628,0.3600823,2.0788692,0.3226404,2.1297509,1.1880339,4.9281767,0.8902751,11.3718244),(24029,'reeves_muntjac-ulna.tif',244,4,73,3.0946399,20.1962335,18.5378891,1.8,20.1395927,18.6307853,-0.9964634,0.5701322,2.6052443,0.1887174,5.4061653,0.3635441,2.0751088,0.3310064,2.1406219,1.1853937,4.876903,0.9447498,11.2502243),(24030,'reeves_muntjac-ulna.tif',244,4,74,3.1159396,20.1905578,18.5704917,1.8,20.134524,18.6639799,-1.0020137,0.5978423,2.5919939,0.1964143,5.2501898,0.368669,2.025541,0.3285387,2.0976681,1.2287047,4.8277652,0.9373704,11.1138718),(24031,'reeves_muntjac-ulna.tif',244,4,75,3.165885,20.1706215,18.6231472,1.8,20.1116651,18.7236293,-1.0053139,0.5934611,2.6715826,0.2023389,5.4329686,0.3761565,2.0336143,0.3409473,2.1056217,1.2308815,4.9127756,0.9347208,11.2207192),(24032,'reeves_muntjac-ulna.tif',244,4,76,3.2005627,20.1665036,18.6482216,1.8,20.1035618,18.7542419,-1.0097856,0.6333801,2.698903,0.2129981,5.3098363,0.3824305,1.9674054,0.336288,2.0432334,1.2933068,4.8912836,0.962107,11.1347351),(24033,'reeves_muntjac-ulna.tif',244,4,77,3.2734013,20.1487322,18.6976631,1.8,20.0895376,18.7983933,-1.0164129,0.6083885,2.6341489,0.2247637,5.4075628,0.394381,2.0528691,0.3694411,2.1379249,1.281287,4.8227855,0.9827937,11.1138718),(24034,'reeves_muntjac-ulna.tif',244,4,78,3.331947,20.1429642,18.7234075,1.8,20.0864316,18.8227253,-1.0234663,0.6329567,2.5682476,0.2412549,5.313251,0.4049284,2.0688235,0.3811554,2.1536783,1.3167523,4.7567988,0.9579761,11.0991192),(24035,'reeves_muntjac-ulna.tif',244,4,79,3.3963663,20.1327301,18.7539965,1.8,20.0831,18.8446581,-1.034164,0.645282,2.4817997,0.2553813,5.3132909,0.4181091,2.1409024,0.3957669,2.2274271,1.3383672,4.6938231,0.9324765,11.1138718),(24036,'reeves_muntjac-ulna.tif',244,4,80,3.4746276,20.1097044,18.8048049,1.8,20.0614564,18.8978451,-1.0467223,0.6544642,2.5333804,0.2648926,5.4864353,0.43409,2.1656579,0.4047474,2.2691658,1.3371589,4.7443484,1.0325746,10.9775192),(24037,'reeves_muntjac-ulna.tif',244,4,81,3.5946923,20.0874232,18.8469612,1.8,20.0425122,18.9348074,-1.0532171,0.6978489,2.516252,0.2871659,5.7465492,0.4524489,2.2837733,0.4115015,2.39789,1.3921019,4.7443484,1.0325746,11.0991192),(24038,'reeves_muntjac-ulna.tif',244,4,82,3.668758,20.0787232,18.8548147,1.8,20.0295966,18.9489878,-1.0594746,0.7210823,2.5581601,0.3032688,5.7397093,0.4650492,2.2436865,0.4205744,2.3621308,1.4283759,4.7661152,1.0500679,11.1494876),(24039,'reeves_muntjac-ulna.tif',244,4,83,3.7764675,20.0703654,18.8698208,1.8,20.0253315,18.9599091,-1.0698467,0.7105645,2.5944262,0.3236049,5.9054366,0.4842386,2.2762014,0.4554195,2.4008028,1.4266809,4.8189515,1.056345,11.1199825),(24040,'reeves_muntjac-ulna.tif',244,4,84,3.88023,20.062563,18.882966,1.8,20.0216619,18.9689882,-1.078554,0.7312531,2.5505562,0.3472911,6.0180373,0.502261,2.3595,0.474926,2.4950046,1.434521,4.8189515,1.056345,11.1555983),(24041,'reeves_muntjac-ulna.tif',244,4,85,3.9693279,20.0548643,18.8855824,1.8,20.0196517,18.9604712,-1.0873691,0.7253387,2.4912458,0.3688143,6.019542,0.518623,2.4162778,0.5084717,2.5624806,1.4392019,4.7661152,1.0500679,11.2059667),(24042,'reeves_muntjac-ulna.tif',244,4,86,4.057366,20.0506582,18.8787823,1.8,20.0229479,18.9427055,-1.0956762,0.7406812,2.4135161,0.3949531,5.9837384,0.5347228,2.4792619,0.5332295,2.6386825,1.4546734,4.6831791,1.0548708,11.0843667),(24043,'reeves_muntjac-ulna.tif',244,4,87,4.1286519,20.0473181,18.8563088,1.8,20.0211095,18.915012,-1.099768,0.7268435,2.3779332,0.4159759,5.9550006,0.5464016,2.5042759,0.5723047,2.679207,1.4504549,4.6534845,1.0662359,10.8620299),(24044,'reeves_muntjac-ulna.tif',244,4,88,4.2171002,20.0509434,18.8163067,1.8,20.0292896,18.8640828,-1.1026816,0.7909713,2.307351,0.4491544,5.9130312,0.5597599,2.5626925,0.5678517,2.7488759,1.5183215,4.5886885,1.012197,10.8976458),(24045,'reeves_muntjac-ulna.tif',244,4,89,4.2748183,20.0535693,18.7735201,1.8,20.0373089,18.8110497,-1.1069485,0.7731482,2.2372179,0.4688825,5.9240806,0.5698616,2.6479676,0.6064588,2.8550918,1.5122371,4.5254156,1.0349851,10.8116616),(24046,'reeves_muntjac-ulna.tif',244,4,90,4.3429967,20.0488871,18.7473155,1.8,20.0305867,18.7882488,-1.1163186,0.7821015,2.2310479,0.4931973,6.0196252,0.5843394,2.6981156,0.6306052,2.9122199,1.5151511,4.5474174,1.0533086,10.8828932),(24047,'reeves_muntjac-ulna.tif',244,4,91,4.3670617,20.0510885,18.6976198,1.8,20.0349982,18.738674,-1.122356,0.7894424,2.2337401,0.5060275,5.9914677,0.5910273,2.6822582,0.6409936,2.8945928,1.5308823,4.5254156,1.0349851,10.8177723),(24048,'reeves_muntjac-ulna.tif',244,4,92,4.4075119,20.0477399,18.6565801,1.8,20.0322354,18.6968022,-1.1298018,0.7938737,2.2513276,0.5208448,6.1275053,0.60075,2.7217297,0.6560802,2.9374202,1.5264035,4.4732442,1.0280458,10.8325248),(24049,'reeves_muntjac-ulna.tif',244,4,93,4.4705102,20.0439544,18.6155665,1.8,20.0219376,18.6651331,-1.1367967,0.8568619,2.2691881,0.5418059,6.3259684,0.613337,2.7877673,0.6323141,3.0092391,1.5937412,4.4946789,1.0466167,11.0548616),(24050,'reeves_muntjac-ulna.tif',244,4,94,4.5392523,20.0433107,18.5551821,1.8,20.0271253,18.5976945,-1.1329586,0.8272267,2.2742644,0.5524211,6.4737913,0.6205454,2.846543,0.667799,3.0582802,1.563639,4.5372447,1.0050949,11.1408458),(24051,'reeves_muntjac-ulna.tif',244,4,95,4.5887509,20.040324,18.502585,1.8,20.0219178,18.5522178,-1.1319721,0.8281016,2.3088884,0.5642826,6.6753267,0.6267323,2.891143,0.6814172,3.1160197,1.5702773,4.5701222,0.9938634,11.2624458),(24052,'reeves_muntjac-ulna.tif',244,4,96,4.6163369,20.0305877,18.456002,1.8,20.0120283,18.5023067,-1.1321394,0.8287053,2.3258693,0.5676883,6.807274,0.630599,2.9267655,0.6850304,3.1509247,1.5801117,4.5886885,1.012197,11.2268299),(24053,'reeves_muntjac-ulna.tif',244,4,97,4.6865015,20.0221667,18.4030797,1.8,20.0013385,18.4563222,-1.1288556,0.8533608,2.3630907,0.5865325,7.0397327,0.6382057,2.9790362,0.6873206,3.1978613,1.6146009,4.6630074,1.1830262,11.4344141),(24054,'reeves_muntjac-ulna.tif',244,4,98,4.6971746,20.0149331,18.3353876,1.8,19.9934806,18.389296,-1.1195314,0.8147817,2.3618626,0.5790175,7.1261389,0.6339723,3.0171691,0.7106413,3.2332778,1.556788,4.6630074,1.1830262,11.3987983),(24055,'reeves_muntjac-ulna.tif',244,4,99,4.7074767,20.0028398,18.2683093,1.8,19.9825009,18.3239759,-1.1115639,0.8285348,2.3900133,0.5724965,7.2128561,0.6304256,3.0179146,0.6909746,3.2407534,1.5764873,4.7349892,1.1473569,11.3631825),(24056,'reeves_muntjac-ulna.tif',244,4,100,4.7643549,19.9907936,18.207631,1.8,19.9680174,18.2673785,-1.1059702,0.817371,2.4240982,0.5809155,7.4911075,0.634498,3.0902658,0.7107122,3.3055826,1.5494345,4.8461072,1.1576675,11.5855192),(24057,'reeves_muntjac-ulna.tif',244,4,101,4.8419881,19.9721683,18.1477524,1.8,19.9466955,18.2089897,-1.1003248,0.8279767,2.4349871,0.5973717,7.7502135,0.6411705,3.1828561,0.7214838,3.4029452,1.5771809,4.8961936,1.1349194,11.7218718),(24058,'reeves_muntjac-ulna.tif',244,4,102,4.9180511,19.9588395,18.0786183,1.8,19.9353851,18.1371861,-1.0929387,0.8360348,2.4638048,0.6147388,7.9665148,0.646324,3.2334196,0.7353029,3.4485448,1.5983019,4.9018528,1.0516502,11.7783509),(24059,'reeves_muntjac-ulna.tif',244,4,103,4.9742676,19.945991,17.9971893,1.8,19.9213484,18.0564416,-1.0841854,0.8410469,2.4798478,0.6320481,8.0396474,0.6477487,3.2419923,0.7515016,3.4769164,1.5995019,4.9221723,1.1237218,11.7931034),(24060,'reeves_muntjac-ulna.tif',244,4,104,5.0743864,19.9339067,17.9252204,1.8,19.9081816,17.9878771,-1.0777925,0.8403796,2.5021627,0.6651516,8.3559001,0.6562971,3.3394711,0.7914895,3.5956174,1.6432607,4.9498819,1.0851742,11.8434718),(24061,'reeves_muntjac-ulna.tif',244,4,105,5.1790813,19.9184656,17.842205,1.8,19.892543,17.9002226,-1.0674161,1.2830261,2.521253,0.6978155,8.5299236,0.6623187,3.3832081,0.5438826,3.3797456,1.6614958,4.9547338,1.0577384,11.8287193),(24062,'reeves_muntjac-ulna.tif',244,4,106,5.3132498,19.9029303,17.7753682,1.8,19.8820034,17.827293,-1.069213,0.8769853,2.5470798,0.7344439,8.8619184,0.6808199,3.4792465,0.8374643,3.7588528,1.7115858,5.003733,1.0908458,11.9147034),(24063,'reeves_muntjac-ulna.tif',244,4,107,5.4273976,19.8855111,17.6924752,1.8,19.8614057,17.7452997,-1.0610547,1.2548452,2.5672959,0.7742362,9.1260625,0.6891918,3.5547373,0.6169974,3.6419579,1.7162165,5.0376021,1.0531472,11.9503193),(24064,'reeves_muntjac-ulna.tif',244,4,108,5.5384973,19.8676663,17.6102687,1.8,19.8443724,17.6610772,-1.055343,1.2910199,2.5816807,0.8108011,9.3470239,0.6987928,3.620519,0.6280314,3.606322,1.7390786,5.0610295,1.0695321,12.051056),(24065,'reeves_muntjac-ulna.tif',244,4,109,5.6683652,19.8494875,17.5251308,1.8,19.8313336,17.5696709,-1.0520158,0.9526532,2.6002245,0.8458874,9.5128923,0.7124767,3.6584888,0.887928,3.9679469,1.794613,5.1108179,1.0058919,12.1874086),(24066,'reeves_muntjac-ulna.tif',244,4,110,5.8533345,19.8290563,17.445563,1.8,19.8051874,17.4914826,-1.0451492,1.2188311,2.5957787,0.9243331,9.9611709,0.7299342,3.83745,0.7583766,3.9960318,1.8239217,5.1303098,1.0222469,12.2021611),(24067,'reeves_muntjac-ulna.tif',244,4,111,5.9982036,19.8081907,17.3680499,1.8,19.7866499,17.414068,-1.0476868,1.2288633,2.6133974,0.9825006,10.2804262,0.7501989,3.9337402,0.7995198,4.2514891,1.8770649,5.1822863,1.0283648,12.3385137),(24068,'reeves_muntjac-ulna.tif',244,4,112,6.1819128,19.7932237,17.276211,1.8,19.7764678,17.312082,-1.0481872,1.0245809,2.5938759,1.0510348,10.5825565,0.7736216,4.0798238,1.0258192,4.4687371,1.9499821,5.1622746,1.012197,12.5964662),(24069,'reeves_muntjac-ulna.tif',244,4,113,6.3723601,19.767918,17.2010647,1.8,19.7513238,17.2389067,-1.049714,1.1018525,2.6161531,1.1254326,11.0244641,0.7988562,4.2139981,1.0214005,4.6342143,1.9592363,5.2036419,1.044404,12.4097453),(24070,'reeves_muntjac-ulna.tif',244,4,114,6.5851014,19.7369466,17.1269471,1.8,19.7157103,17.1685071,-1.0468033,1.2047736,2.6428289,1.2189485,11.5570712,0.8227629,4.3729926,1.0117656,4.8296907,1.9889276,5.2344529,1.0343609,12.4957295),(24071,'reeves_muntjac-ulna.tif',244,4,115,6.8519033,19.7057724,17.0492593,1.8,19.6822303,17.084303,-1.0453356,1.1883175,2.6440219,1.3406759,12.2069133,0.8546445,4.6167974,1.1282135,5.1160564,2.0542136,5.2657856,1.0244363,12.9256504),(24072,'reeves_muntjac-ulna.tif',244,4,116,7.0966805,19.6767205,16.9784464,1.8,19.6547175,17.0169872,-1.0475254,1.0900535,2.6495403,1.4560091,12.8301394,0.8874209,4.8424021,1.3357227,5.3792563,2.1219588,5.2976308,1.0146301,13.0828662),(24073,'reeves_muntjac-ulna.tif',244,4,117,7.4042594,19.6463411,16.9032926,1.8,19.6248714,16.9408503,-1.0437954,1.155725,2.6530737,1.6252718,13.6771988,0.9218894,5.1552276,1.406279,5.7505836,2.177234,5.3455616,0.9796392,14.1207872),(24074,'reeves_muntjac-ulna.tif',244,4,118,7.7277142,19.6133742,16.8314101,1.8,19.5892868,16.8719223,-1.0458038,1.1692444,2.6826112,1.8018447,14.5541834,0.9644084,5.4253793,1.5410333,6.0719682,2.2100329,5.4642257,0.9673628,13.8124663),(24075,'reeves_muntjac-ulna.tif',244,4,119,7.9801099,19.5989099,16.7380211,1.8,19.5732271,16.7839171,-1.0533882,1.2135673,2.754693,1.9943109,15.0487925,1.0046186,5.4629655,1.643346,6.1697599,2.3105465,5.4979475,0.9981299,13.9696821),(24076,'reeves_muntjac-ulna.tif',244,4,120,8.3272392,19.5734333,16.6614218,1.8,19.543812,16.7144972,-1.0550244,1.2314304,2.7855185,2.2349654,15.9324869,1.0502694,5.7197563,1.8149344,6.4993861,2.3442639,5.5491452,1.0040671,14.5715714),(24077,'reeves_muntjac-ulna.tif',244,4,121,8.6855914,19.5474051,16.5774039,1.8,19.5203458,16.6297788,-1.0589742,1.2624203,2.7986177,2.546484,16.6072574,1.1003611,5.9340928,2.0171443,6.7923302,2.4129494,5.5647781,0.9797634,14.6931714),(24078,'reeves_muntjac-ulna.tif',244,4,122,9.147514,19.5096956,16.5053597,1.8,19.4756288,16.5674346,-1.0567491,1.3412477,2.8435718,2.9475667,17.6092193,1.1559802,6.1926411,2.1976305,7.1965173,2.51119,5.600535,1.0098955,15.5738765),(24079,'reeves_muntjac-ulna.tif',244,4,123,9.6172326,19.4643391,16.4294934,1.8,19.4263651,16.4900681,-1.0531364,1.3832356,2.8425209,3.4039705,18.6089577,1.2103696,6.5466389,2.4608754,7.6861191,2.5957343,5.6153665,0.9857967,15.0371081),(24080,'reeves_muntjac-ulna.tif',244,4,124,10.1293462,19.4055251,16.3652347,1.8,19.3717704,16.421159,-1.0456564,1.4561061,2.8490474,3.9464676,20.0587114,1.2639131,7.0404976,2.7102885,8.3701673,2.6798416,5.6491676,0.9768236,15.072724),(24081,'reeves_muntjac-ulna.tif',244,4,125,10.7488061,19.317718,16.310296,1.8,19.2797898,16.3674308,-1.0224588,1.4963451,2.7936319,4.7763821,21.9151869,1.3046873,7.8446939,3.1920324,9.5381311,2.8152812,5.6413097,1.0396187,15.5235081),(24082,'reeves_muntjac-ulna.tif',244,4,126,11.3080604,19.247313,16.2455633,1.8,19.2176163,16.2980477,-1.0108655,1.5606161,2.7951482,5.6667471,23.6493942,1.353016,8.460873,3.6310963,9.7487721,2.944668,5.654727,0.9380475,15.6598607),(24083,'reeves_muntjac-ulna.tif',244,4,127,11.8157689,19.1874789,16.1644654,1.8,19.1588636,16.2182263,-1.0034389,1.5700762,2.8276505,6.5404418,25.0423161,1.4005535,8.8562274,4.1656844,11.1452287,3.0683833,5.6843937,1.0065281,15.5738765),(24084,'reeves_muntjac-ulna.tif',244,4,128,12.3749389,19.1271399,16.0959126,1.8,19.1023054,16.1509,-0.9959494,1.6545222,2.8524798,7.6427273,26.8495868,1.4527837,9.4127175,4.6192957,12.074892,3.1875714,5.7503432,0.9886588,15.8674449),(24085,'reeves_muntjac-ulna.tif',244,4,129,12.8485191,19.0949094,16.0066202,1.8,19.0749778,16.0544763,-1.004199,1.7460904,2.8655613,8.8469645,28.1022486,1.5244429,9.8068914,5.0667275,12.8356469,3.3437833,5.8028179,0.9566369,15.923924),(24086,'reeves_muntjac-ulna.tif',244,4,130,13.2927228,19.0448304,15.9192931,1.8,19.0204733,15.9679663,-0.9960949,1.8374786,2.947238,9.9524658,29.9083921,1.5608232,10.1479391,5.4163711,13.463504,3.4802547,5.9188731,0.9827937,16.0811398),(24087,'reeves_muntjac-ulna.tif',244,4,131,13.7158311,19.0119314,15.8174157,1.8,18.9864126,15.870911,-0.9900657,1.9609233,3.0318899,11.2993879,31.1121135,1.5978937,10.2616238,5.7622794,13.9133688,3.6704615,6.0032112,0.9799847,16.3599556),(24088,'reeves_muntjac-ulna.tif',244,4,132,14.1571765,18.9726574,15.7332427,1.8,18.9397181,15.7912825,-0.9836672,2.0281878,3.0650384,12.7750478,33.4374649,1.6354222,10.9093135,6.29875,14.8234772,3.7639805,6.0571572,0.94938,16.8906133),(24089,'reeves_muntjac-ulna.tif',244,4,133,14.5112004,18.9557216,15.6303987,1.8,18.9272564,15.6875276,-0.9737298,3.2627249,3.1958667,14.4935898,35.1599274,1.6540589,11.0016876,4.4421735,15.2123925,3.9571296,6.1914585,0.9528299,17.8069342),(24090,'reeves_muntjac-ulna.tif',244,4,134,14.8777041,18.9181968,15.531092,1.8,18.8943524,15.596087,-0.9473182,2.3414666,3.3917326,16.2863984,37.5561903,1.6343275,11.0728629,6.9556398,15.6858539,4.2132252,6.3840002,0.9272952,17.7713184),(24091,'reeves_muntjac-ulna.tif',244,4,135,15.3318514,18.8674349,15.4318042,1.8,18.8504934,15.501583,-0.9163766,2.5211225,3.516027,18.6920281,40.5174942,1.6085298,11.5236584,7.4141689,16.6462158,0.1216,0.2719059,1.1071487,0.5871368),(24092,'reeves_muntjac-ulna.tif',244,4,136,15.7041002,18.8072284,15.341391,1.8,18.7892853,15.4214186,-0.8786668,2.6683929,3.7483894,21.4597029,43.6958472,1.5513784,11.6572325,8.0421825,17.138417,4.7190068,6.76166,0.9129077,19.002071),(24093,'reeves_muntjac-ulna.tif',244,4,137,16.6845061,18.7171232,15.3212154,1.8,18.6969475,15.4079974,-0.8374062,2.9574779,4.1023268,25.6960119,51.7767147,1.5347361,12.6213043,8.6884881,18.7371239,5.0494098,7.2259977,0.8986835,20.5055287),(24094,'reeves_muntjac-ulna.tif',244,4,138,17.6279899,18.6760572,15.3096085,1.8,18.6594557,15.408359,-0.7899675,3.0599024,4.4850449,31.9655429,60.2929856,1.4824237,13.4431174,10.4465891,20.4677961,5.4423971,7.6533172,0.8923333,21.6650497),(24095,'reeves_muntjac-ulna.tif',244,4,139,18.575538,18.6188681,15.3031014,1.8,18.6105154,15.4218688,-0.7696394,3.2938294,4.8033128,38.4491507,70.5759751,1.4991817,14.6931874,11.673085,22.5853497,5.801752,8.0900565,0.8972291,23.4707176),(24096,'reeves_muntjac-ulna.tif',244,4,140,20.44651,18.7592986,15.3436215,1.8,18.8011344,15.4704745,-0.6173128,3.7667261,4.996378,57.7945913,75.0069778,1.1418105,15.0122705,15.3434549,26.5668977,6.4754391,8.2567208,0.9317135,25.1817595),(24097,'reeves_muntjac-ulna.tif',244,4,141,22.4071807,18.7500497,15.3449885,1.8,18.8226081,15.4441362,-0.4722263,3.6783274,4.9945141,70.8410765,87.1371136,0.7726996,17.4465648,19.2590462,31.1240176,6.9157926,8.586803,0.1779536,26.6521325),(24098,'reeves_muntjac-ulna.tif',244,4,142,24.3337733,18.647406,15.3564297,1.8,18.7354545,15.4585261,-0.5924707,4.0223061,5.1112235,80.0039478,102.6123198,1.2646436,20.0758821,19.8900696,35.524532,7.3001636,8.7859684,0.9923904,29.2525214),(24099,'reeves_muntjac-ulna.tif',244,4,143,26.9050656,18.5131653,15.4138142,1.8,18.5321707,15.4900882,-0.8217552,4.3694444,5.0639876,83.7625564,124.3871702,2.4049765,24.5630876,19.1700704,40.9194936,7.2385477,8.9582566,1.0129164,28.4908851),(24100,'reeves_muntjac-ulna.tif',244,4,144,27.7294408,18.3606561,15.3551762,1.8,18.3714652,15.4143289,-0.998184,4.5661757,4.5426378,75.666565,134.7191954,3.2647755,29.6566004,16.5711023,43.8809214,7.1380585,8.7275009,1.0291821,27.7943698),(24101,'reeves_muntjac-ulna.tif',244,4,145,26.0137635,18.2092784,15.0646323,1.8,18.201793,15.1135163,-1.0848277,3.7318082,4.3491811,54.5232021,128.2862788,3.3898111,29.4966512,14.6103976,39.6605409,6.0569929,8.5848655,1.0024376,25.5023018),(24102,'reeves_muntjac-ulna.tif',244,4,146,25.7004985,18.1532421,14.8522931,1.8,18.160159,14.8943543,-1.1256282,3.3906423,4.3105854,48.7860741,126.85487,3.4891654,29.4286871,14.388446,39.4383648,5.6418247,8.5440769,1.1453467,23.9988441),(24103,'reeves_muntjac-ulna.tif',244,4,147,25.462056,18.1065063,14.6695918,1.8,18.1125495,14.6975305,-1.1627946,3.1821423,4.3175063,45.5706236,127.4377828,3.5755895,29.5165249,14.3207373,38.7572554,5.3507857,8.5822815,1.1705557,23.5038023),(24104,'reeves_muntjac-ulna.tif',244,4,148,25.2285746,18.0693039,14.517921,1.8,18.0741875,14.5317213,-1.2020297,3.0190582,4.3527241,43.9879859,131.155376,3.6584157,30.1317919,14.5701021,39.0859278,5.1461714,8.6944002,1.1760052,23.3318339),(24105,'reeves_muntjac-ulna.tif',244,4,149,25.2902226,18.0335929,14.4135398,1.8,18.0300109,14.4197462,-1.2412872,2.9068435,4.3997769,43.3438892,140.2912683,3.7737094,31.8859958,14.9109813,40.4802601,5.0120176,8.8526139,1.2055949,23.4030655),(24106,'reeves_muntjac-ulna.tif',244,4,150,26.1260901,17.9864427,14.3864784,1.8,17.9758701,14.3889671,-1.2781685,2.7885297,4.5574667,44.0761146,156.710555,3.9920032,34.3854527,15.8062204,43.4186242,4.9050935,9.1163515,1.2237347,23.9042181),(24107,'reeves_muntjac-ulna.tif',244,4,151,26.8668092,17.9557638,14.4033354,1.8,17.9351319,14.4042261,-1.318404,2.6676863,4.8070359,46.2319377,179.7445622,4.1985628,37.3919745,17.3303501,46.6831466,4.8212119,9.4873332,1.2916164,24.6485707),(24108,'reeves_muntjac-ulna.tif',244,4,152,28.4979128,17.9252872,14.4970971,1.8,17.9035012,14.5074589,-1.3643044,2.6306552,5.1488665,50.0829346,213.2874141,4.5499941,41.424149,19.0381978,50.6070617,4.8411024,9.980279,1.3745955,26.6740442),(24109,'reeves_muntjac-ulna.tif',244,4,153,30.9891936,17.9116908,14.6985867,1.8,17.8952087,14.6849103,-1.409627,2.6581041,5.5882446,54.7815765,260.6247574,5.0318629,46.6380367,20.6092666,56.3033057,4.9948265,10.6003194,1.3745256,27.7745549),(24110,'reeves_muntjac-ulna.tif',244,4,154,33.1735368,17.8976934,14.9646954,1.8,17.8920159,14.9442622,-1.4494024,2.6853245,6.1301725,59.0896487,326.1940036,5.4478453,53.2112278,22.0046586,62.6207137,5.0770543,11.4104936,1.4371885,29.3431335),(24111,'reeves_muntjac-ulna.tif',244,4,155,36.035752,17.9103299,15.4577636,1.8,17.9078096,15.4181788,-1.4920428,2.705633,6.8847763,63.3977175,436.1429893,5.9687859,63.3488975,23.4317505,72.5000563,5.2221749,12.6792423,1.4988056,31.4545913),(24112,'reeves_muntjac-ulna.tif',244,4,156,39.4196628,17.9019864,16.1250832,1.8,17.8988976,16.0495434,-1.526906,2.5724399,7.855545,67.2528082,623.5814771,6.5572959,79.381059,26.1435874,87.9028319,5.1079126,14.4919708,1.5162287,34.8888965),(24113,'reeves_muntjac-ulna.tif',244,4,157,38.86636,17.8595402,16.1019026,1.8,17.8527039,16.0324499,-1.5264647,2.3847339,8.1298018,63.047316,680.4777587,6.4650044,83.7016418,26.4378826,91.3554958,4.6896184,14.9067916,1.472751,35.5508444),(24114,'reeves_muntjac-ulna.tif',244,4,158,37.1858714,17.8681127,15.4920345,1.8,17.8492164,15.4732217,-1.5432977,2.2901933,7.8284685,53.6698971,639.4936642,6.1929599,81.6882211,23.434658,88.3865578,4.4004504,14.8194937,1.4927658,34.6111291),(24115,'reeves_muntjac-ulna.tif',244,4,159,34.1405929,17.8240499,14.9836335,1.8,17.8092066,14.9367938,-1.555598,2.2291199,7.6267299,47.1661834,593.4932748,5.6887846,77.8175294,21.1591057,83.6703224,4.2849953,14.7418377,1.5088921,34.0804714),(24116,'reeves_muntjac-ulna.tif',244,4,160,33.1258998,17.7446955,14.5629444,1.8,17.7237885,14.5025236,-1.5515453,2.1767901,7.5697127,42.8433761,582.2416196,5.5189375,76.9172675,19.6819047,82.25183,4.1565978,14.7869054,1.5296673,34.0804714),(24117,'reeves_muntjac-ulna.tif',244,4,161,32.6673652,17.6683225,14.1420148,1.8,17.6457446,14.1045189,-1.5468866,2.1146529,7.5147055,39.6154282,581.5815438,5.4414489,77.3924603,18.7337731,82.4637235,4.0636532,14.8562412,1.517568,34.5103923),(24118,'reeves_muntjac-ulna.tif',244,4,162,32.8276853,17.5958952,13.7430018,1.8,17.572426,13.6677803,-1.5423306,2.0816248,7.4837902,38.0802291,585.5843102,5.4668487,78.2470242,18.2935125,83.220271,4.0024463,14.9277315,1.5055828,34.4808872),(24119,'reeves_muntjac-ulna.tif',244,4,163,33.7754906,17.5163549,13.3983767,1.8,17.4945555,13.2876486,-1.5395168,2.1012929,7.6146588,37.4936389,586.9055215,5.6237425,77.075748,17.8431286,81.8915998,4.0231658,15.147012,1.5386789,34.9611765),(24120,'reeves_muntjac-ulna.tif',244,4,164,33.7516115,17.4413954,13.0054592,1.8,17.4178817,12.8737693,-1.5372141,2.1229449,7.606584,38.0950999,595.5479549,5.618927,78.2937461,17.9444598,83.2607146,4.0368354,15.1376132,1.4823183,35.3910975),(24121,'reeves_muntjac-ulna.tif',244,4,165,33.798451,17.3649545,12.6619378,1.8,17.3420097,12.5156103,-1.5394654,2.1767904,7.5613001,38.9744482,594.5664187,5.6275474,78.6328296,17.9045477,83.741747,4.1344001,15.1273532,1.4903253,35.9573709),(24122,'reeves_muntjac-ulna.tif',244,4,166,34.3325832,17.2947256,12.3143817,1.8,17.2721334,12.1626327,-1.5426891,2.2451693,7.5906339,41.4021625,606.3534727,5.7175778,79.8817963,18.4405526,84.9479913,4.2560001,15.192946,1.4866581,35.7497868),(24123,'reeves_muntjac-ulna.tif',244,4,167,33.7366352,17.1755153,12.1666485,1.8,17.157685,11.9764967,-1.5471861,2.3246866,7.6588637,43.1529849,602.6351488,5.6196387,78.6846679,18.5629257,84.1132653,4.3494827,15.3313687,1.5350972,35.7854026),(24124,'reeves_muntjac-ulna.tif',244,4,168,33.8365014,17.0660247,12.0728371,1.8,17.0484796,11.9060127,-1.5476231,2.4169172,7.7529808,46.539199,614.842275,5.6363891,79.3039851,19.255603,85.0758965,4.5444134,15.4863464,1.4961322,36.4020444),(24125,'reeves_muntjac-ulna.tif',244,4,169,34.2228311,16.9274104,11.9511536,1.8,16.918562,11.7199808,-1.5464734,2.497433,7.8352405,48.858947,637.7190741,5.7004315,81.3911292,19.5636671,86.9357871,4.6779764,15.6827473,1.4854014,36.7520919),(24126,'reeves_muntjac-ulna.tif',244,4,170,34.2287167,16.7857822,11.8287841,1.8,16.7782116,11.5833816,-1.5433865,2.6333024,8.0815879,52.4114765,656.4307867,5.7005012,81.225471,19.9033259,87.1245814,4.8538113,15.9302966,1.4829008,37.1525077),(24127,'reeves_muntjac-ulna.tif',244,4,171,33.9763941,16.643191,11.7184368,1.8,16.6315693,11.5072994,-1.5369146,2.6572518,8.3227185,53.7128735,664.7007138,5.6562342,79.8658175,20.2136938,85.7280174,5.0495466,16.157822,1.4954674,38.0123496),(24128,'reeves_muntjac-ulna.tif',244,4,172,33.2586617,16.4954274,11.6798391,1.8,16.4869453,11.5145955,-1.5357116,2.7335903,8.2986515,53.8951557,634.4651545,5.5362899,76.4540062,19.7158863,82.4825635,5.1922784,16.1230095,1.4763809,38.1782073),(24129,'reeves_muntjac-ulna.tif',244,4,173,32.9735805,16.3543308,11.4490018,1.8,16.3495699,11.3366958,-1.5311007,2.7903324,8.2822707,57.2356086,568.1249931,5.4869417,68.5953183,20.5121112,75.2788819,5.2899266,15.7720642,1.4665247,37.3478705),(24130,'reeves_muntjac-ulna.tif',244,4,174,32.209066,16.1980973,11.1367382,1.8,16.1965246,11.0682375,-1.5258497,2.8378121,8.0438179,57.8960282,492.7186111,5.3573402,61.2543218,20.4016429,68.3427813,5.3611702,15.0401066,1.4654962,35.7019495),(24131,'reeves_muntjac-ulna.tif',244,4,175,31.583297,16.0384478,10.8199205,1.8,16.0426401,10.7963286,-1.5204092,2.8392745,7.6228113,58.5914006,407.1080413,5.2505299,53.4065487,20.6360466,61.069352,5.3970644,14.1688791,1.4762515,33.9135653),(24132,'reeves_muntjac-ulna.tif',244,4,176,29.5952717,16.014141,10.2672676,1.8,15.9924083,10.3362536,-1.5187163,2.6931698,7.4483511,50.5573128,313.3521253,4.9191787,42.0699991,18.7724194,48.8314509,5.2225116,13.3706102,1.4797247,31.9384601),(24133,'reeves_muntjac-ulna.tif',244,4,177,27.2145139,15.8869442,9.8550596,1.8,15.8592468,9.9162602,-1.4989963,2.4373568,7.2429467,36.1900618,248.2430958,4.5124096,34.2737708,14.8480773,39.2682,4.7702938,12.6330933,1.484058,30.0554499),(24134,'reeves_muntjac-ulna.tif',244,4,178,23.5922239,15.7443556,9.4712228,1.8,15.7494014,9.5841952,-1.4813481,2.1368426,6.9656403,22.5820377,190.7297266,3.900661,27.3815069,10.5679463,30.6214961,4.2158332,11.7499837,1.4567105,27.7425187),(24135,'reeves_muntjac-ulna.tif',244,4,179,19.5752553,15.6684349,9.1063809,1.8,15.6526687,9.2507106,-1.4460769,1.9267822,6.4740893,13.3365794,138.589196,3.2120565,21.4067476,6.9216848,23.4450923,3.7752977,10.6420846,1.4620318,25.4885977),(24136,'reeves_muntjac-ulna.tif',244,4,180,12.4571397,15.7657343,8.3245187,1.8,15.7557035,8.395376,-1.4211056,1.6500252,5.6805623,6.4766097,57.2716822,2.0300145,10.0820446,3.925158,11.2081217,3.2286513,4.810506,1.2090671,12.8223825),(24137,'reeves_muntjac-ulna.tif',244,4,181,5.8132969,15.9110756,7.513486,1.8,15.9097049,7.5155929,-1.3159464,1.1882805,1.6879048,1.9188448,3.8056747,0.907306,2.2546738,1.6148079,3.3847513,2.4333035,3.3917465,1.3171222,9.3794355),(24138,'reeves_muntjac-ulna.tif',244,4,182,0.6787074,15.9818601,7.7623455,1.8,15.9823296,7.7565736,-1.3107689,0.4291474,0.6085179,0.0266423,0.0567623,0.1056404,0.0932795,0.0620818,0.1358655,0.8975666,1.2883289,1.2341215,3.4368363),(24139,'reeves_muntjac-ulna.tif',244,4,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24140,'reeves_muntjac-ulna.tif',244,4,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24141,'reeves_muntjac-ulna.tif',244,4,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24142,'reeves_muntjac-ulna.tif',244,4,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24143,'reeves_muntjac-ulna.tif',244,4,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24144,'reeves_muntjac-ulna.tif',244,4,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24145,'reeves_muntjac-ulna.tif',244,4,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24146,'reeves_muntjac-ulna.tif',244,4,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24147,'reeves_muntjac-ulna.tif',244,4,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24148,'reeves_muntjac-ulna.tif',244,4,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24149,'mc.tif',244,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24150,'mc.tif',244,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24151,'mc.tif',244,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24152,'mc.tif',244,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24153,'mc.tif',244,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24154,'mc.tif',244,5,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24155,'mc.tif',244,5,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24156,'mc.tif',244,5,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24157,'mc.tif',244,5,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24158,'mc.tif',244,5,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24159,'mc.tif',244,5,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24160,'mc.tif',244,5,12,9.9917428,14.2914014,13.2689229,1.8,14.270267,13.0593161,1.4580561,2.1345038,3.8437099,6.5013741,43.4377804,1.6442136,11.3010038,3.045848,12.531018,2.7548319,4.0499373,0.625485,11.4613881),(24161,'mc.tif',244,5,13,25.3900387,14.241415,13.2885569,1.8,14.2019468,13.363513,1.5184537,2.7681157,5.1676996,40.7697224,166.0767844,4.22009,32.1374685,14.7283301,39.3499493,3.2140066,5.8762502,0.4960437,15.8389882),(24162,'mc.tif',244,5,14,38.6530245,14.142178,12.8294906,1.8,14.1026168,12.8767432,1.480631,3.289239,6.1082229,90.440057,410.5740716,6.389939,67.2166162,27.495739,80.0055164,0,0,0,0),(24163,'mc.tif',244,5,15,42.9552626,14.1336246,12.6277353,1.8,14.0496458,12.7566478,1.4640642,3.5758021,5.9391386,132.0042471,476.2487497,7.0779637,80.1881858,36.9159823,95.4320953,0,0,0,0),(24164,'mc.tif',244,5,16,42.8247243,14.1174527,12.5433199,1.8,14.0081952,12.6750309,1.4580175,3.7130963,5.9782487,153.8467289,473.3553622,7.0470565,79.1796041,41.4335414,96.707909,0,0,0,0),(24165,'mc.tif',244,5,17,40.2935518,14.1126945,12.5529986,1.8,13.991213,12.5972219,1.4503343,3.7255974,5.8994056,154.190683,436.6572981,6.6186117,74.0171681,41.3868345,92.338975,0,0,0,0),(24166,'mc.tif',244,5,18,37.7811887,14.1388053,12.5528744,1.8,14.0949832,12.567592,1.442386,3.6626776,5.781829,133.8806005,388.7088482,6.1936038,67.229392,36.5526579,84.4358785,0.4901561,1.403677,1.6575347,3.6235573),(24167,'mc.tif',244,5,19,36.5888927,14.257801,12.559422,1.8,14.249141,12.5548453,1.4548581,3.4639589,5.8986628,105.8950437,358.0672164,6.0165461,60.703117,30.5705259,75.7400063,6.7154541,11.6663147,1.7968139,32.8573122),(24168,'mc.tif',244,5,20,36.02686,14.2547251,12.7025811,1.8,14.2795433,12.6977777,1.4772623,3.4037617,5.9116692,99.315595,359.9193333,5.9520988,60.882861,29.1781865,75.9525251,6.3385015,11.8052249,1.7782926,31.8316127),(24169,'mc.tif',244,5,21,38.3721952,14.1685915,12.9153227,1.8,14.2659356,12.8501085,1.4804175,3.5507486,6.0253698,103.5951488,394.3992622,6.3432685,65.4564405,29.17558,80.0198351,6.3547798,11.795357,1.7469615,31.665755),(24170,'mc.tif',244,5,22,41.1489645,14.134246,12.8057851,1.8,14.2427363,12.8395225,1.4681621,3.6335137,5.9187516,119.4157133,424.3730235,6.7861716,71.6997522,32.8650789,88.6923408,6.5208045,11.7644468,1.6951513,31.9506816),(24171,'mc.tif',244,5,23,40.5428161,14.1526636,12.6836797,1.8,14.2517426,12.7873302,1.467883,3.6439118,5.8892214,129.5949809,418.5962947,6.6858225,71.0783767,35.5647959,89.6643887,6.6421199,11.7041187,1.6957957,32.0010499),(24172,'mc.tif',244,5,24,39.2641185,14.1258252,12.6767761,1.8,14.2297802,12.727444,1.4748406,3.626935,5.8661342,126.1066091,402.1543544,6.4839504,68.5552595,34.7694702,86.7186217,6.635811,11.5491199,1.6709888,31.7578499),(24173,'mc.tif',244,5,25,35.4724699,14.1016151,12.685438,1.8,14.2462015,12.6950275,1.4741002,3.5862857,5.7670098,119.3235451,373.9709024,5.8569716,64.8465872,33.2721808,82.4545933,6.5346502,11.3272541,1.6891594,31.2714499),(24174,'mc.tif',244,5,26,33.0868694,14.1099339,12.7101623,1.8,14.2377918,12.7077675,1.472086,3.5280096,5.6121023,114.2049029,344.8086171,5.4609209,61.4401875,32.370916,78.5829086,6.4855456,11.0652662,1.6753857,30.6130815),(24175,'mc.tif',244,5,27,31.8000889,14.094209,12.7507335,1.8,14.2167936,12.7369836,1.4667053,3.4807342,5.4228356,109.132517,316.3652565,5.2427966,58.3394515,31.3533041,75.346664,6.4164653,10.7851046,1.7350182,29.8687289),(24176,'mc.tif',244,5,28,31.342561,14.0936629,12.7745389,1.8,14.1842697,12.7698708,1.46836,3.407404,5.3091612,106.2841598,293.2335419,5.1691376,55.2316139,31.1921216,72.3206217,6.345759,10.5506837,1.7037287,29.2963447),(24177,'mc.tif',244,5,29,30.4157707,14.0832594,12.8092282,1.8,14.1471214,12.8271808,1.4680233,3.3465706,5.1774111,101.6924392,272.3167365,5.01594,52.5970861,30.3870595,69.2017081,6.285625,10.2953273,1.7369159,28.6674815),(24178,'mc.tif',244,5,30,29.478053,14.028602,12.8407563,1.8,14.0840205,12.8542759,1.4669976,3.3307525,5.0354767,97.0444584,254.9091833,4.860265,50.6226514,29.1358959,66.9690957,6.2114503,10.0660274,1.7468681,28.101208),(24179,'mc.tif',244,5,31,28.8686421,13.9569532,12.8928462,1.8,14.0063361,12.9011902,1.4598847,3.2968565,4.8874382,93.4212692,239.6334458,4.7524952,49.0304806,28.3364678,65.1796612,6.1235101,9.8460342,1.7257931,27.6504238),(24180,'mc.tif',244,5,32,28.4677753,13.9006269,12.9349744,1.8,13.9444669,12.9472432,1.4572979,3.2758711,4.8004211,90.4654345,225.0351725,4.6837714,46.8782148,27.615688,62.6683298,6.0875476,9.6472955,1.7545957,27.1492712),(24181,'mc.tif',244,5,33,27.9913402,13.8475506,12.9708098,1.8,13.891133,12.9659686,1.4602786,3.246574,4.7385899,87.2193943,212.5342532,4.6084732,44.8517927,26.8650566,60.3883028,6.061418,9.4740762,1.6736578,26.8139763),(24182,'mc.tif',244,5,34,27.6494459,13.783379,13.0123985,1.8,13.8054875,13.0011438,1.4622076,3.2480211,4.6827717,84.4259608,201.9853804,4.5541161,43.1337236,25.9930459,58.2681149,6.0211835,9.3293833,1.7080851,26.5204079),(24183,'mc.tif',244,5,35,27.1784845,13.7265732,13.0397235,1.8,13.7498701,13.0350145,1.4648507,3.2472136,4.6396858,81.2011523,192.7451803,4.4790933,41.542723,25.0064094,56.3567982,5.9852367,9.2089425,1.7098923,26.1764712),(24184,'mc.tif',244,5,36,26.7278155,13.6747761,13.0678822,1.8,13.6936206,13.0651341,1.4692936,3.1993937,4.5957527,78.25149,185.2866672,4.4088981,40.3169357,24.4582249,54.5041677,5.9069524,9.1112814,1.677769,25.9332712),(24185,'mc.tif',244,5,37,26.5012084,13.6280483,13.0931812,1.8,13.6428055,13.0902191,1.4726264,3.1813623,4.5572434,76.2414776,179.3929376,4.3744379,39.3643529,23.9650411,53.1556909,5.8283265,9.0283396,1.7126934,26.4847921),(24186,'mc.tif',244,5,38,26.372905,13.5680216,13.1177937,1.8,13.5679608,13.1160394,1.4722593,3.1830636,4.5218186,74.9101736,175.4096206,4.3529439,38.7918302,23.5339858,52.1105584,5.8354232,8.9597008,1.7069353,25.968887),(24187,'mc.tif',244,5,39,26.3842566,13.5070552,13.137992,1.8,13.5039096,13.1403153,1.4717224,3.185312,4.4821482,74.1240675,171.8459351,4.354354,38.3400834,23.270583,51.5731557,5.83575,8.8913636,1.7010885,25.6188395),(24188,'mc.tif',244,5,40,26.4318394,13.4441783,13.1563717,1.8,13.4265962,13.1549556,1.4689994,3.1835385,4.4435237,73.6228941,169.5805774,4.3598135,38.1635362,23.12612,51.4059941,5.8298817,8.8233351,1.6951513,26.063513),(24189,'mc.tif',244,5,41,26.5867272,13.3845054,13.1745563,1.8,13.3556807,13.1721066,1.4663265,3.194387,4.4049496,73.4143366,167.6221666,4.3829359,38.0531408,22.9822927,51.3480998,5.8543424,8.7630079,1.6960119,26.0278972),(24190,'mc.tif',244,5,42,26.7716284,13.3327578,13.1956424,1.8,13.29755,13.1929792,1.4657863,3.1715479,4.3735214,73.1716316,165.7015235,4.4129164,37.8874386,23.071268,51.218765,5.8446261,8.7173294,1.7531451,25.9210498),(24191,'mc.tif',244,5,43,26.9042478,13.2757398,13.2117563,1.8,13.2327064,13.2068192,1.4629651,3.1697796,4.3547668,73.0763983,164.4181993,4.4321046,37.7559138,23.0540948,51.3320111,5.8460439,8.6688522,1.7613144,25.9062972),(24192,'mc.tif',244,5,44,27.1441308,13.2244478,13.2332969,1.8,13.1804159,13.230898,1.4614029,3.1834469,4.331736,73.1503974,163.571629,4.4700988,37.7612182,22.9783624,51.2323368,5.8620235,8.633172,1.776479,25.7134656),(24193,'mc.tif',244,5,45,27.3551702,13.1756941,13.2508709,1.8,13.1277619,13.250678,1.4609877,3.1866215,4.2972541,73.2795782,162.4105399,4.5044412,37.7940272,22.9960095,51.3649373,5.8940754,8.5900311,1.7056865,25.7846972),(24194,'mc.tif',244,5,46,27.6246867,13.128065,13.272181,1.8,13.0758381,13.2724064,1.4588511,3.1824629,4.2757964,73.5891485,161.3760963,4.5466575,37.7417635,23.1233327,51.521301,5.9185693,8.5494834,1.7640078,25.2540395),(24195,'mc.tif',244,5,47,27.8594334,13.0864874,13.2866922,1.8,13.0364301,13.2913307,1.458852,3.1649819,4.2516108,73.6280442,159.9971871,4.5852947,37.6321341,23.2633382,51.5741812,5.877638,8.5070045,1.6853999,25.3695288),(24196,'mc.tif',244,5,48,27.935406,13.0445161,13.3026898,1.8,12.9911117,13.310551,1.4564625,3.1807083,4.2256574,73.4355631,158.1901149,4.5953027,37.4356227,23.0878019,51.4648288,5.8971746,8.4695515,1.7076173,25.5058814),(24197,'mc.tif',244,5,49,28.0202667,13.0095229,13.3249982,1.8,12.9600794,13.3308163,1.4537374,3.1640765,4.2079013,73.123257,155.9883924,4.6063436,37.0703548,23.1104578,51.1321782,5.8745516,8.4301784,1.7667775,25.4702656),(24198,'mc.tif',244,5,50,28.0418104,12.977412,13.3465081,1.8,12.9299335,13.35078,1.4505246,3.1521753,4.1859172,72.7714329,153.682549,4.606355,36.7141874,23.0860999,50.7504656,5.8691131,8.3826865,1.7753041,25.0403446),(24199,'mc.tif',244,5,51,28.0394029,12.9450296,13.3656387,1.8,12.8989209,13.3721753,1.4466796,3.1639066,4.1742117,72.5637597,151.7474338,4.6016117,36.3535548,22.9348612,50.6289587,5.8938002,8.3491044,1.7096038,25.3191605),(24200,'mc.tif',244,5,52,28.0367841,12.9132047,13.3861018,1.8,12.8660751,13.3996484,1.4471017,3.1527737,4.1372815,72.3318458,149.8885533,4.6016657,36.2287542,22.942289,50.382986,5.873455,8.3031524,1.7997906,24.8683763),(24201,'mc.tif',244,5,53,28.1013113,12.8842037,13.4135436,1.8,12.8374097,13.4292333,1.4466611,3.1623316,4.1086294,72.1559867,147.8316815,4.6117504,35.9807776,22.8173372,50.124754,5.900912,8.2580638,1.8086323,24.509687),(24202,'mc.tif',244,5,54,28.117671,12.8557864,13.4423386,1.8,12.8080867,13.4577977,1.4497413,3.1563961,4.0933631,72.0376953,146.3338836,4.617939,35.7490604,22.822768,49.8864671,5.8940754,8.2286912,1.8247353,24.4384553),(24203,'mc.tif',244,5,55,28.1900135,12.8321761,13.4686448,1.8,12.7867505,13.4841313,1.4486821,3.1608033,4.0793947,71.9570013,145.1980573,4.6286221,35.5930395,22.7654154,49.9572633,5.8970287,8.1865797,1.7273982,24.8978814),(24204,'mc.tif',244,5,56,28.2238093,12.808379,13.4937288,1.8,12.7574102,13.5056873,1.4489101,3.1419487,4.0555991,71.8196175,144.0418081,4.6344303,35.5167765,22.858304,49.9233578,5.8856852,8.1465196,1.7433068,24.5956711),(24205,'mc.tif',244,5,57,28.2763775,12.788779,13.5127909,1.8,12.7323138,13.5225669,1.44742,3.1487459,4.0438643,71.8160078,143.1538076,4.641357,35.4002501,22.8078134,49.9992589,5.9163606,8.1267566,1.835736,24.3672237),(24206,'mc.tif',244,5,58,28.2949062,12.7755718,13.5338778,1.8,12.7249451,13.5463362,1.4476911,3.1495458,4.0249924,71.7027309,142.2746465,4.6447103,35.3478051,22.7660542,49.8865139,5.922673,8.1083134,2.0713399,24.7467763),(24207,'mc.tif',244,5,59,28.3458813,12.7535155,13.5644471,1.8,12.6929027,13.5782334,1.4508983,3.1372771,4.0129822,71.9237177,141.8073091,4.6567238,35.3371387,22.9255227,50.1232233,5.9097089,8.0845714,2.0815471,24.9126339),(24208,'mc.tif',244,5,60,28.4199689,12.7394121,13.5881992,1.8,12.6800786,13.5991751,1.4536404,3.139847,4.0009591,72.0172792,141.152508,4.6719453,35.2796674,22.9365571,50.1213866,5.9215599,8.0396364,1.7073458,24.4384553),(24209,'mc.tif',244,5,61,28.5714845,12.7269988,13.6058807,1.8,12.6654126,13.6190296,1.456159,3.1405204,3.9937858,72.0862334,140.9072343,4.699608,35.28162,22.953595,50.0714428,5.9711253,8.0239879,1.6923318,24.2603762),(24210,'mc.tif',244,5,62,28.6456641,12.7142599,13.6278887,1.8,12.6507031,13.6442535,1.4580546,3.1423312,3.9796741,72.1671534,140.6634526,4.7138497,35.3454702,22.9661194,50.1700207,5.9613952,8.0064622,1.7309513,24.4532079),(24211,'mc.tif',244,5,63,28.742207,12.7048854,13.6464419,1.8,12.6330722,13.6576066,1.4554336,3.1276156,3.9787024,72.4515791,140.450934,4.7268973,35.3006882,23.1651161,50.3281252,5.9315883,7.9879726,1.6469844,24.0589028),(24212,'mc.tif',244,5,64,28.8055783,12.6955475,13.6687511,1.8,12.6232462,13.6843096,1.4507256,3.1323929,3.9650443,72.7382027,140.0210655,4.7320468,35.3138719,23.2212893,50.3076264,5.9550412,7.9673525,1.849096,24.1596395),(24213,'mc.tif',244,5,65,28.9252776,12.6835968,13.6880572,1.8,12.6089811,13.7057167,1.4473059,3.1390486,3.97108,73.0501724,140.0674127,4.7477347,35.2718688,23.2714374,50.3764121,5.9613952,8.0258305,2.0683293,24.4532079),(24214,'mc.tif',244,5,66,29.0831615,12.6700147,13.7058451,1.8,12.5946704,13.722437,1.4418335,3.1387087,3.9758241,73.5164687,140.175187,4.7670238,35.2568888,23.4225203,50.6534205,5.9726014,7.9969916,2.0616481,24.3672237),(24215,'mc.tif',244,5,67,29.0851864,12.6621137,13.728682,1.8,12.5856065,13.7489696,1.4416229,3.1337803,3.9686288,73.608941,140.1105289,4.7670951,35.3045183,23.4888648,50.6780864,5.9805374,8.0018438,2.0786328,24.0589028),(24216,'mc.tif',244,5,68,29.2427534,12.6524051,13.7481149,1.8,12.5725546,13.7679389,1.4376462,3.1367066,3.9740469,73.9130837,140.247235,4.7878945,35.2907849,23.563914,50.9623863,5.9956681,7.9969916,2.0616481,24.0736553),(24217,'mc.tif',244,5,69,29.4065087,12.6403712,13.7741464,1.8,12.5556827,13.7886625,1.4369804,3.1240618,3.9662996,74.4256949,140.816131,4.8138451,35.5031505,23.8233745,51.0736008,5.995809,7.9969916,2.0616481,24.4679604),(24218,'mc.tif',244,5,70,29.4808626,12.6317195,13.7971857,1.8,12.5457528,13.8126138,1.4355611,3.1274266,3.9776105,74.7261618,141.2571519,4.8241631,35.5130675,23.8938183,51.1603715,6.0085613,8.0506641,2.0580882,24.4175921),(24219,'mc.tif',244,5,71,29.5776974,12.6228595,13.8196355,1.8,12.5346427,13.8385062,1.4321898,3.1304699,3.9930813,74.8709248,141.8124951,4.8355146,35.5145526,23.9168323,51.3301031,6.0026918,8.0018438,2.0786328,24.3819763),(24220,'mc.tif',244,5,72,29.7058537,12.6138008,13.8355768,1.8,12.5265756,13.8546732,1.4260387,3.1318399,3.9946672,75.1791733,142.287913,4.8479517,35.6194659,24.0047943,51.5995762,6.0124518,8.0258305,2.0683293,24.604313),(24221,'mc.tif',244,5,73,29.8240916,12.602308,13.8530534,1.8,12.5139023,13.8712271,1.4212254,3.1355673,4.0040831,75.4068796,143.0653368,4.8603073,35.7298621,24.0488791,51.7254229,6.0113921,8.0550251,2.0749623,24.2456237),(24222,'mc.tif',244,5,74,29.9838752,12.591419,13.8724769,1.8,12.5023562,13.8937982,1.4148124,3.1284784,4.0119984,75.6934853,143.6344771,4.876706,35.80123,24.194984,51.8815643,6.0133445,8.0184576,2.1125162,24.2812395),(24223,'mc.tif',244,5,75,30.2162842,12.5788651,13.8967328,1.8,12.4897552,13.9158775,1.4089448,3.1422573,4.0384838,76.304098,144.9965549,4.9052715,35.9037108,24.2832112,52.1818134,6.0377806,8.0845714,2.0815471,24.6902972),(24224,'mc.tif',244,5,76,30.4172587,12.5667263,13.9173196,1.8,12.4733338,13.9348215,1.4048165,3.1361005,4.0598467,76.6173893,146.0644465,4.9311586,35.9778227,24.4307828,52.2548474,6.0377535,8.1083134,2.0713399,24.8118972),(24225,'mc.tif',244,5,77,30.4661522,12.5591314,13.9353936,1.8,12.4661902,13.9523523,1.3991103,3.1328943,4.0803921,76.7728483,147.4096117,4.9294863,36.1263349,24.5054066,52.4595777,6.0519394,8.1083134,2.0713399,25.0846023),(24226,'mc.tif',244,5,78,30.5412154,12.5516622,13.9546504,1.8,12.4541749,13.9726499,1.3947632,3.1410149,4.1009819,77.1493057,148.3352949,4.9340917,36.1706775,24.5619036,52.6027367,6.0826516,8.1083134,2.0713399,24.7615288),(24227,'mc.tif',244,5,79,30.5907909,12.545816,13.975738,1.8,12.4492037,13.9954647,1.3939879,3.1436398,4.1212202,77.5246226,149.5319217,4.9407349,36.2834097,24.6607844,52.927959,6.0934377,8.1144658,2.0880837,24.9273865),(24228,'mc.tif',244,5,80,30.6486038,12.5406385,13.99478,1.8,12.4411093,14.013296,1.3929449,3.1410738,4.1289587,77.8822079,150.6960662,4.9482221,36.4973539,24.7947719,52.9571736,6.0928884,8.1865797,2.0576956,25.0698497),(24229,'mc.tif',244,5,81,30.724785,12.5311723,14.01271,1.8,12.4324385,14.0317469,1.388738,3.1523124,4.1582528,78.5260452,152.6171912,4.9529344,36.7022396,24.9106165,53.3265761,6.0855951,8.1673663,2.0844023,25.2209549),(24230,'mc.tif',244,5,82,30.7761093,12.5185448,14.028842,1.8,12.4223737,14.0473487,1.3813327,3.153965,4.1875054,79.2299301,154.2903385,4.9474186,36.8454061,25.1207388,53.7812111,6.1105529,8.2203761,2.0807684,25.5648916),(24231,'mc.tif',244,5,83,30.7799785,12.5148657,14.0472652,1.8,12.4197322,14.0690486,1.3736563,3.158301,4.2213534,79.5028146,155.8246616,4.9331928,36.9134364,25.1726527,54.0220576,6.1184889,8.273493,2.0771811,25.2713232),(24232,'mc.tif',244,5,84,30.8187147,12.5010834,14.0603613,1.8,12.4054154,14.0822552,1.3622297,3.1698655,4.2382892,80.221349,157.7003801,4.9162376,37.2084987,25.3074926,54.270513,6.1233469,8.3762898,2.053922,25.98006),(24233,'mc.tif',244,5,85,30.7054724,12.4955287,14.0768288,1.8,12.403818,14.1014616,1.3555144,3.1704645,4.2699122,80.2924927,159.7012596,4.8840394,37.4015321,25.3251511,54.5127353,6.1535698,8.3561855,2.080015,25.73686),(24234,'mc.tif',244,5,86,30.4259044,12.4967361,14.0944653,1.8,12.404144,14.1193658,1.3478276,3.1675378,4.3052498,80.7301514,161.5922867,4.8230301,37.5337772,25.4867207,54.563173,6.1354406,8.4047069,2.0603281,25.4137865),(24235,'mc.tif',244,5,87,30.2430557,12.4952296,14.1121751,1.8,12.3989398,14.1347141,1.3377504,3.1655802,4.3391717,81.4317771,164.3332057,4.7716773,37.8720223,25.7241241,55.058662,6.1478696,8.4625652,2.07301,26.1667809),(24236,'mc.tif',244,5,88,30.051651,12.4950459,14.1200079,1.8,12.4009911,14.141541,1.3257503,3.1732456,4.3717024,82.4434086,167.9501561,4.7138257,38.4175641,25.9807843,55.4464011,6.1742013,8.4939582,1.6711772,25.98006),(24237,'mc.tif',244,5,89,30.6085133,12.4846909,14.1346469,1.8,12.3921306,14.1578892,1.3153635,3.1793551,4.4228782,84.2791813,173.4549235,4.7757483,39.2176574,26.5082626,56.7629225,6.1850231,8.627818,2.0785793,26.4455967),(24238,'mc.tif',244,5,90,31.1713738,12.4812627,14.1517735,1.8,12.3890746,14.174638,1.3053813,3.1955852,4.4476695,86.5422984,178.742106,4.8377639,40.1878122,27.0818308,57.9991097,6.2083816,8.6575445,2.084716,26.5463335),(24239,'mc.tif',244,5,91,31.6301963,12.4775971,14.170135,1.8,12.3847202,14.1923953,1.2973792,3.2148281,4.5041581,88.7639288,184.5317587,4.8873264,40.9692006,27.6107858,59.2797272,6.2195143,8.7587884,2.062387,27.0622386),(24240,'mc.tif',244,5,92,32.3332029,12.4700166,14.2151037,1.8,12.3761679,14.2393475,1.2958072,3.2423037,4.572381,91.2731685,191.8597335,4.9915348,41.9605749,28.150715,60.5549179,6.3046179,8.8310825,1.701983,27.0413753),(24241,'mc.tif',244,5,93,32.8232684,12.4677697,14.2503452,1.8,12.383865,14.2874977,1.2980984,3.2721613,4.6366185,94.1733234,199.0398772,5.0737169,42.9278102,28.7801594,61.9197121,6.3269063,8.9460751,1.7415315,27.0118702),(24242,'mc.tif',244,5,94,33.1583983,12.4602755,14.2917267,1.8,12.3751343,14.3234101,1.3048788,3.3056785,4.6949601,96.4562584,205.7141742,5.1447408,43.8159582,29.1789595,63.073105,6.3801218,9.0659306,1.7392526,27.6137595),(24243,'mc.tif',244,5,95,33.593495,12.4538133,14.3521217,1.8,12.3640676,14.3752291,1.3097262,3.3472054,4.7948026,99.9507169,214.4422944,5.2258986,44.7239044,29.8609455,64.2571486,6.4348299,9.1904587,2.0374025,27.9785595),(24244,'mc.tif',244,5,96,33.6587992,12.4441382,14.3882925,1.8,12.3528816,14.4011345,1.314012,3.396651,4.8664769,104.3241721,224.8824378,5.2479588,46.210522,30.7138327,66.4194614,6.5302642,9.356091,2.0576956,28.4440963),(24245,'mc.tif',244,5,97,33.4149984,12.4447255,14.4309541,1.8,12.3456844,14.4355024,1.3255285,3.4300554,4.9414414,107.9041579,235.5772651,5.2408102,47.673795,31.4584297,68.0606769,6.599883,9.5205891,2.0630076,28.7732805),(24246,'mc.tif',244,5,98,34.0265382,12.4344272,14.4800224,1.8,12.3370752,14.4804909,1.3375737,3.4789236,5.0380864,113.4127013,250.8986285,5.3681756,49.8003819,32.5999403,70.5665353,6.6759807,9.7342682,2.0372372,29.7755856),(24247,'mc.tif',244,5,99,34.5672797,12.4044315,14.5119666,1.8,12.3016909,14.5149999,1.3282096,3.5499758,5.1413578,121.122389,270.3676998,5.4287741,52.5868286,34.1192155,74.4488462,6.7917926,9.952275,1.6625624,29.7903382),(24248,'mc.tif',244,5,100,35.2094922,12.3871205,14.5351954,1.8,12.2760538,14.5386395,1.313204,3.6061615,5.2608883,129.8391105,293.0997676,5.4874046,55.712981,36.0047963,78.5821279,6.9270503,10.1810506,1.7025586,30.2263698),(24249,'mc.tif',244,5,101,36.1285387,12.3542067,14.5456234,1.8,12.2458254,14.5450082,1.2943678,3.6688512,5.4186793,140.8838126,322.0701351,5.5729106,59.4370171,38.3999799,83.3362166,7.0637761,10.5027493,1.6635526,31.3650275),(24250,'mc.tif',244,5,102,37.2507252,12.2848004,14.5458524,1.8,12.2015932,14.5426362,1.2702291,3.7720356,5.5772021,155.6476474,355.702382,5.6642661,63.777926,41.2635683,89.3359044,7.1662623,10.9118642,1.6432947,33.212422),(24251,'mc.tif',244,5,103,39.1819471,12.1952306,14.507304,1.8,12.1260998,14.517189,1.2324968,3.8620813,5.8083504,172.583679,415.557295,5.8110311,71.5448041,44.6867031,95.8119011,7.3285613,11.421665,2.1898082,34.9946955),(24252,'mc.tif',244,5,104,41.7540862,12.2077784,14.5366164,1.8,12.0774078,14.5372376,1.2154413,3.9242614,6.1507377,191.8305669,489.6818627,6.1166219,79.6135173,48.8832289,106.387151,7.5365414,12.013348,1.6976623,35.0450638),(24253,'mc.tif',244,5,105,43.8066004,12.2991338,14.6887284,1.8,12.0804487,14.6921885,1.2138829,4.0196356,6.5264652,215.5880384,556.7040961,6.4098616,85.2994819,53.6337268,114.3471988,7.8280315,12.4163071,1.7182335,37.2450369),(24254,'mc.tif',244,5,106,46.6808405,12.3969777,14.7455782,1.8,12.193861,14.7578263,1.1972178,4.1749632,6.7341827,230.6801581,596.9305505,6.7439179,88.6418706,55.2532191,119.1957711,8.0307771,12.5386645,1.8710778,37.7965578),(24255,'mc.tif',244,5,107,47.3037932,12.5727559,14.8317762,1.8,12.4261482,14.7900442,1.2094973,4.0274133,6.7923403,215.1326,562.6150918,6.8988251,82.8308169,53.4170653,110.9776536,7.7433962,12.4988005,1.8771635,36.8654843),(24256,'mc.tif',244,5,108,51.6522089,12.70624,14.97912,1.8,12.6360014,15.0420221,1.2863154,3.8972577,6.588846,197.0179103,526.2080148,7.9305974,79.8634559,50.5529595,104.8442682,7.5450352,12.2123277,1.9161645,35.5106006),(24257,'mc.tif',244,5,109,14.7953915,13.9953301,14.962502,1.8,13.8995789,15.0296363,-1.2848752,2.8570949,5.762018,18.400749,91.6923216,2.2697429,15.9132307,6.4403703,19.0928886,0.1216,0.2192175,2.1587989,0.4655368),(24258,'mc.tif',244,5,110,0.8936182,14.4758321,12.7087379,1.8,14.4423539,12.7226945,-0.3558392,0.5308824,0.986511,0.0449079,0.1196939,0.0180759,0.1213305,0.084591,0.166815,1.0944,1.6893212,0.5280744,4.4243889),(24259,'mc.tif',244,5,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24260,'mc.tif',244,5,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24261,'mc.tif',244,5,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24262,'mc.tif',244,5,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24263,'mc.tif',244,5,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24264,'mc.tif',244,5,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24265,'mc.tif',244,5,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24266,'mc.tif',244,5,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24267,'mc.tif',244,5,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24268,'mc.tif',244,5,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24269,'femur.tif',244,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24270,'femur.tif',244,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24271,'femur.tif',244,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24272,'femur.tif',244,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24273,'femur.tif',244,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24274,'femur.tif',244,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24275,'femur.tif',244,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24276,'femur.tif',244,7,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24277,'femur.tif',244,7,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24278,'femur.tif',244,7,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24279,'femur.tif',244,7,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24280,'femur.tif',244,7,12,1.940784,15.8588658,20.401103,1.8,15.8109128,20.3124473,1.3853561,0.8790232,1.1032554,0.3280337,0.4215066,0.3124676,0.3820571,0.3731798,0.6241269,1.8326848,2.231408,1.925502,6.5884454),(24281,'femur.tif',244,7,13,10.4147044,15.2552317,18.7540486,1.8,15.3061618,18.8692305,1.3875762,1.6036308,3.3921127,5.6970878,28.5243072,1.6781636,8.4090094,3.552618,10.0175215,3.1195703,6.8292413,1.730348,16.8813127),(24282,'femur.tif',244,7,14,12.343577,15.1235038,18.494177,1.8,15.2303112,18.6269744,1.4028705,1.8817111,4.20665,11.0460504,57.9687546,1.9997932,13.7802655,5.8702159,16.275795,3.7053693,8.2896028,1.8067049,20.4197192),(24283,'femur.tif',244,7,15,15.0530361,15.043095,18.2028423,1.8,15.1755773,18.3933568,1.3854917,2.0659988,4.9401497,18.2663012,89.8318582,2.4236729,18.1840356,8.8413902,21.6986937,4.0770679,9.2721882,1.8502441,23.3115317),(24284,'femur.tif',244,7,16,16.5079516,15.1012857,17.966019,1.8,15.2049655,18.1739241,1.4013658,2.2481328,5.6615411,25.3798815,120.3431422,2.6730967,21.2562516,11.289316,25.6814796,4.4567776,10.0624736,1.7802759,25.3641412),(24285,'femur.tif',244,7,17,27.4031807,20.6642914,17.4077631,1.8,19.7244958,17.613864,-0.0647849,6.1996423,11.8166353,153.8555062,1506.8642156,0.0191421,127.5205827,24.8168359,140.5086858,4.9702536,10.9593338,1.7557099,27.4465708),(24286,'femur.tif',244,7,18,44.7498812,24.1552216,17.1050731,1.8,23.5119407,17.2402801,-0.0675256,6.5741554,11.6567345,248.3201577,2539.0232406,0.0339561,217.8159965,37.7721762,232.9784706,5.4628233,11.4306596,1.7548948,28.9355941),(24287,'femur.tif',244,7,19,59.2960171,25.05033,16.9494386,1.8,24.8056875,17.1228259,-0.0811993,6.9314833,12.8314931,371.3851208,2925.0191624,0.0650166,227.9562592,53.5794585,252.7698859,6.3364128,11.5973261,1.7590178,29.7968283),(24288,'femur.tif',244,7,20,74.5394674,25.3261707,16.8037835,1.8,25.1620318,16.9675835,-0.0919004,7.1887376,13.2658592,513.9876872,3333.6565493,0.1046277,251.2959398,71.4990191,288.31751,11.6489616,23.5360255,3.0360263,72.8613443),(24289,'femur.tif',244,7,21,83.8142102,25.6874945,16.7178309,1.8,25.5304141,16.8822404,-0.0988886,7.3365185,13.7869628,659.4269334,3716.5508782,0.136158,269.5699507,89.8828144,317.3070945,11.8074919,24.1573868,0.0674218,72.0831179),(24290,'femur.tif',244,7,22,87.10616,25.9616495,16.7150488,1.8,25.7408845,16.8516857,-0.117263,7.2856202,14.0285475,793.6219004,3991.6586447,0.1987139,284.5382704,108.9299029,341.0920221,11.6800842,24.438567,0.0920954,72.8659071),(24291,'femur.tif',244,7,23,84.4042248,26.1653677,16.6620228,1.8,25.955485,16.7893717,-0.1412516,7.1900189,13.9338368,859.5433484,3904.1246553,0.2788106,280.1902094,119.5467442,341.3803249,12.1060872,24.2340917,0.1735607,73.4028994),(24292,'femur.tif',244,7,24,80.1759282,25.9853315,16.650154,1.8,25.8405272,16.7908691,-0.1701133,7.0804213,13.5928099,858.6451712,3797.0494268,0.3829799,279.3424941,121.2703502,342.4747877,12.4766579,24.0815599,0.1550961,73.9243134),(24293,'femur.tif',244,7,25,74.9590702,25.7258201,16.6126151,1.8,25.7038054,16.6618884,-0.1949722,7.034741,13.0772547,800.7009243,3575.9048886,0.46893,273.4446153,113.8209536,334.6475338,12.8885032,23.736393,0.1672957,75.4775398),(24294,'femur.tif',244,7,26,70.3360502,25.2843259,16.627416,1.8,25.3878899,16.5971961,-0.2096999,7.0036529,12.395011,730.3635577,3356.6772287,0.5079817,270.8087326,104.2832317,329.6334008,12.997971,23.3286601,0.1635102,75.7421414),(24295,'femur.tif',244,7,27,67.9086556,24.6522087,16.906258,1.8,24.9402314,16.7594605,-0.2261809,6.8527462,11.5293185,688.2951138,3167.2093381,0.5692032,274.7091549,100.4407715,334.4066591,12.9410597,22.8613192,0.1840985,73.8523211),(24296,'femur.tif',244,7,28,68.034612,24.2213866,17.1279988,1.8,24.4763173,16.9714458,-0.2261586,6.9018715,11.2934395,670.7725867,2974.8417183,0.5701484,263.4132611,97.1870575,321.1882435,12.7483493,22.4115757,0.1702652,71.7167039),(24297,'femur.tif',244,7,29,67.4792614,23.7981278,17.3512385,1.8,23.6987406,17.2920823,-0.2422808,6.8302832,11.2904675,640.3707625,2702.9073173,0.6473551,239.3972888,93.7546427,295.843202,12.4728869,21.8896016,0.2140607,71.4786962),(24298,'femur.tif',244,7,30,62.1304479,22.633672,17.8271708,1.8,22.4411342,17.7958998,-0.2376438,6.8041228,11.4771673,632.4474135,1972.6878602,0.5738724,171.8793333,92.9506172,226.6198075,12.2068601,18.8594315,0.053447,63.0788755),(24299,'femur.tif',244,7,31,59.5448073,22.2026198,18.0222497,1.8,21.8172109,18.1711902,-0.2483045,6.7394111,9.1780945,628.6530079,1681.894801,0.5994015,183.2509782,93.2801095,243.6315728,12.0594688,18.18742,0.1195982,60.2668443),(24300,'femur.tif',244,7,32,57.9294528,22.1477475,18.1868547,1.8,21.6910834,18.4473661,-0.2645999,6.6240206,8.7869501,630.0125937,1504.2969129,0.6603411,171.196706,95.1103012,236.705633,11.8807512,17.648914,0.1232657,58.2142348),(24301,'femur.tif',244,7,33,56.3710308,22.0979802,18.3489998,1.8,21.5849033,18.6570333,-0.2759418,6.5189153,8.52388,627.8825374,1362.3425487,0.6974109,159.8265757,96.3170259,226.2618676,11.7923691,17.0535234,0.192048,55.5195943),(24302,'femur.tif',244,7,34,55.6711677,22.0839499,18.5611811,1.8,21.6150825,18.8852826,-0.3092591,6.2872985,8.2588806,651.592035,1245.7283046,0.8594769,150.8350057,103.6362494,222.0678672,11.7221303,16.3105752,0.1815535,53.4481803),(24303,'femur.tif',244,7,35,54.9806576,22.1052183,18.7490539,1.8,21.7132579,19.0443667,-0.3431163,6.1248361,8.0253208,669.9749819,1135.3244054,1.0371246,141.4677916,109.3865976,217.6479336,11.7738454,15.8570389,0.6884805,51.2185398),(24304,'femur.tif',244,7,36,54.3773607,22.1086592,18.8980938,1.8,21.8026182,19.2177931,-0.3831221,6.0111111,7.8916139,686.2514793,1060.2862676,1.2664481,134.3560752,114.1638321,218.9390416,11.8638399,15.4598427,0.6966638,49.6419459),(24305,'femur.tif',244,7,37,54.1477831,22.1396503,18.9894488,1.8,21.8792866,19.301401,-0.4112006,5.9938543,7.6967555,702.1854522,984.911549,1.4418487,127.9645099,117.1509044,218.4277316,11.8941563,15.0232115,0.6940778,48.4927427),(24306,'femur.tif',244,7,38,53.4038125,22.2207148,19.0535482,1.8,22.0784373,19.362449,-0.4484487,6.0060247,7.4345352,725.6382716,937.5516452,1.6731537,126.1076336,120.8183952,221.0768138,11.9866051,14.5454523,0.7288547,47.2793364),(24307,'femur.tif',244,7,39,53.3721325,22.2976524,19.1076629,1.8,22.276677,19.4242069,-0.5277523,6.2607511,7.1535077,756.4975144,897.9809993,2.2559124,125.5301642,120.8317504,225.7401203,12.1608418,14.2549456,0.7546386,46.2663286),(24308,'femur.tif',244,7,40,53.1676021,22.4483632,19.1520808,1.8,22.5188274,19.4893671,-0.8571703,6.6044693,7.1325259,789.7872738,859.7792193,5.0644433,120.5434418,119.5837609,228.8368318,12.4452295,13.9983546,0.844154,43.7299145),(24309,'femur.tif',244,7,41,52.9075161,22.6506344,19.2175564,1.8,22.7336244,19.5520688,-1.4835151,6.6097887,6.9198763,768.8775911,868.5917895,8.7509148,125.5212881,116.3240801,230.278174,12.4697652,13.812623,0.8767764,43.3369067),(24310,'femur.tif',244,7,42,52.7532399,22.829982,19.3056527,1.8,22.9313809,19.6926458,1.5128313,6.670257,6.8751725,728.9204179,921.6806777,8.7626984,134.0592812,109.2792103,235.2338672,12.2427487,13.6769395,0.8978253,43.6546959),(24311,'femur.tif',244,7,43,53.0348261,22.9194429,19.3463348,1.8,23.0418399,19.7818374,1.4653495,6.6350244,7.2524244,700.0748184,967.8578436,8.7412188,133.4530066,105.512019,221.6198967,12.044795,14.3383387,1.9763978,44.5315083),(24312,'femur.tif',244,7,44,53.1191426,22.9756833,19.4018401,1.8,23.096176,19.8597857,1.4339871,6.5654178,7.7434638,669.3572154,1027.8130012,8.6885186,132.7329774,101.9519608,216.0434768,11.8684108,14.8124387,1.9289546,44.7507115),(24313,'femur.tif',244,7,45,53.5866039,23.0317512,19.3669087,1.8,23.1506405,19.830245,1.4299366,6.5260513,7.8086835,644.9400771,1036.8982084,8.7550635,132.7878394,98.825468,213.9216672,11.6773889,14.8723297,1.8397906,44.4861099),(24314,'femur.tif',244,7,46,52.4156969,22.9673385,19.2229804,1.8,23.061819,19.6628121,1.4705202,6.3887699,7.7911833,610.147154,1020.7421302,8.6484009,131.0124659,95.5030729,207.6075535,11.3955581,14.7805737,1.8743068,43.930313),(24315,'femur.tif',244,7,47,50.8770235,22.9074709,18.914318,1.8,22.9834791,19.3424985,1.5113699,6.2161634,7.7578421,586.3920753,937.0923296,8.4495937,120.7929111,94.3334401,192.8966626,11.1972096,14.5866868,1.8673421,43.0723052),(24316,'femur.tif',244,7,48,50.3820643,22.8801861,18.7443908,1.8,22.9268712,19.1194401,1.5327386,6.0970326,7.5721157,566.4994242,901.5050537,8.3848544,119.0559002,92.9139573,190.3118009,10.9770565,14.3081465,1.8394237,42.2785005),(24317,'femur.tif',244,7,49,49.3315587,22.8625737,18.498355,1.8,22.8885417,18.7881441,1.5587562,5.980494,7.33101,548.2684206,846.6782546,8.2207346,115.4927164,91.6761087,184.9551936,10.8195784,13.9682875,1.8346153,41.5035004),(24318,'femur.tif',244,7,50,48.7130961,22.8531314,18.2749522,1.8,22.858355,18.4806217,-1.5604734,5.8801617,7.1325717,533.2938779,798.6293887,8.1179842,111.9693457,90.6937444,183.5964078,10.7465237,13.534794,1.801887,40.6000941),(24319,'femur.tif',244,7,51,47.941031,22.8187352,18.0162719,1.8,22.8180769,18.1980116,-1.5149355,5.7531071,6.835103,519.1077093,740.0153959,7.965265,108.2668973,90.2308433,179.6063985,10.6106227,13.1050652,1.7913896,39.6512894),(24320,'femur.tif',244,7,52,47.5247396,22.7810791,17.7996036,1.8,22.7722057,17.9710629,-1.4589566,5.6154225,6.5538468,505.725315,693.8698566,7.8221281,105.872151,90.0600648,178.9918857,10.5117788,12.6391555,1.7309047,38.9482816),(24321,'femur.tif',244,7,53,47.019931,22.7552069,17.5756697,1.8,22.7476482,17.7346024,-1.400782,5.4804497,6.3273746,493.4293954,649.5755532,7.6123117,102.6611494,90.034472,176.3237243,10.450343,12.2817336,1.7805675,38.3360707),(24322,'femur.tif',244,7,54,46.8538331,22.7135381,17.3813296,1.8,22.6999618,17.5355826,-1.3259806,5.3118325,6.1461735,482.3120521,619.049724,7.3502195,100.7211596,90.7995605,174.3675816,10.3981035,12.0949677,1.0325746,37.8898754),(24323,'femur.tif',244,7,55,46.8878913,22.6850807,17.2169139,1.8,22.6701481,17.3616116,-1.2604111,5.1695564,6.0735144,472.9679398,595.7237594,7.0856614,98.08551,91.4910115,170.0244036,10.3291396,12.0162502,1.0436504,37.4514691),(24324,'femur.tif',244,7,56,47.0258636,22.6648444,17.0728018,1.8,22.6463622,17.2221154,-1.2140069,5.1582844,6.0842654,466.0255213,575.5109744,6.8815461,94.5900509,90.3450622,167.0163733,10.2947561,11.8959352,1.0225558,36.922266),(24325,'femur.tif',244,7,57,47.4196345,22.6478399,16.95964,1.8,22.6297427,17.0992806,-1.2045811,5.1631858,6.0321421,460.4112926,562.4311322,6.8898807,93.2390394,89.1719393,165.1833813,10.2601757,11.8158918,1.0337514,36.6388598),(24326,'femur.tif',244,7,58,47.7871172,22.6350393,16.8495862,1.8,22.6235431,16.9809651,-1.1949951,5.1510729,5.9683383,455.6765217,549.9439624,6.8916812,92.1435633,88.4624479,164.76285,10.2255954,11.6829811,1.0269639,36.2192582),(24327,'femur.tif',244,7,59,48.3266563,22.6107566,16.7350951,1.8,22.5952146,16.8430196,-1.1814119,5.1545071,5.9484364,452.0236635,539.9685722,6.8937121,90.7748756,87.6948369,164.4131588,10.1910151,11.5929231,1.0533086,35.8450551),(24328,'femur.tif',244,7,60,49.0904622,22.5894572,16.6194446,1.8,22.5760638,16.7175455,-1.1830453,5.1467729,5.9875176,449.2964666,533.4091308,7.0120394,89.0868584,87.2967347,162.7789501,10.156238,11.5477608,1.0741277,35.6900551),(24329,'femur.tif',244,7,61,49.7406887,22.5657477,16.4879531,1.8,22.5477794,16.5795001,-1.1930356,5.1620194,5.9082423,445.8039184,522.87767,7.1623029,88.4997,86.3623104,162.3985278,10.1216576,11.4117277,1.0676556,35.4254535),(24330,'femur.tif',244,7,62,50.116144,22.5402765,16.3680553,1.8,22.5274819,16.4528056,-1.2017605,5.1746014,5.8304001,443.0502183,512.3337793,7.2658699,87.8728344,85.6201642,162.0592026,10.1210674,11.2761841,1.0610276,35.2704535),(24331,'femur.tif',244,7,63,49.5968112,22.5296492,16.3080642,1.8,22.5188377,16.3842282,-1.1737186,5.1403005,5.786634,437.0762988,502.6661683,7.0298827,86.8667641,85.0293278,160.6303198,10.1208706,11.2185105,1.0422246,34.9416488),(24332,'femur.tif',244,7,64,48.9884952,22.5210632,16.2666404,1.8,22.5067063,16.3342295,-1.1386901,5.1094294,5.7643075,429.9122737,492.842766,6.7328125,85.4990409,84.1409558,159.116837,10.086487,11.1645744,1.0792057,34.8508519),(24333,'femur.tif',244,7,65,48.7862342,22.4993268,16.2134977,1.8,22.4817141,16.2817804,-1.1298103,5.0773127,5.7092655,424.5551894,486.5211722,6.6496856,85.2160703,83.6180896,158.1523829,10.0519067,11.1125387,1.0447299,34.6770472),(24334,'femur.tif',244,7,66,48.7235467,22.4737711,16.1451363,1.8,22.4535221,16.2061615,-1.1296602,5.0672643,5.6862393,420.2352376,481.4907855,6.6402003,84.6764899,82.9313825,157.6355766,10.0177199,11.0922516,1.091525,34.5220472),(24335,'femur.tif',244,7,67,48.9314242,22.4528852,16.08117,1.8,22.4407218,16.1279335,-1.1215102,5.0717861,5.6662514,418.3346122,478.7457144,6.6168651,84.4907289,82.4827,157.4430843,10.0177199,11.059715,1.0820756,34.5220472),(24336,'femur.tif',244,7,68,48.9279728,22.4272747,16.0253871,1.8,22.4154614,16.0710611,-1.1219184,5.0805591,5.6353271,414.830357,476.0351453,6.6190017,84.4733838,81.650532,156.7345931,10.0173264,11.0281717,1.0725713,34.3028441),(24337,'femur.tif',244,7,69,48.9470575,22.3946004,15.9775624,1.8,22.3847089,16.028235,-1.1182293,5.0639403,5.6303693,412.5037546,474.2647034,6.5979827,84.2333201,81.4590473,156.0092332,10.0171296,11.0355217,1.0568766,34.3028441),(24338,'femur.tif',244,7,70,49.1615257,22.3570347,15.9266332,1.8,22.3457124,15.9648259,-1.1144726,5.0483183,5.627673,411.2586697,474.6921263,6.6026115,84.3496282,81.4644896,156.4340862,9.9827461,11.0281717,1.0725713,34.1932426),(24339,'femur.tif',244,7,71,49.4450938,22.327261,15.8717334,1.8,22.3161818,15.9039948,-1.110533,5.0622175,5.6304441,411.8384501,475.0619769,6.6149337,84.3738021,81.3553441,156.408265,9.9827461,11.0281717,1.0725713,34.2574457),(24340,'femur.tif',244,7,72,49.4230872,22.3001478,15.8189308,1.8,22.2946113,15.8570578,-1.1022485,5.0733331,5.6009934,411.2519968,473.8670161,6.5573357,84.6041017,81.0615008,157.0777555,10.0074842,10.9976303,1.0630134,34.1478441),(24341,'femur.tif',244,7,73,49.5245815,22.2696924,15.7673271,1.8,22.2662365,15.8014922,-1.1041544,5.0891504,5.5629776,411.3227349,473.3740271,6.5834608,85.0936425,80.8234585,158.0778525,10.0084879,10.9601558,1.0691923,34.2120472),(24342,'femur.tif',244,7,74,49.6727571,22.2409014,15.7128932,1.8,22.2315115,15.739902,-1.1088034,5.1053904,5.5271626,411.7045769,474.1536108,6.6339796,85.7860797,80.641155,159.2819917,10.0171296,10.9615257,1.1482648,34.0382425),(24343,'femur.tif',244,7,75,49.811391,22.2133118,15.6764628,1.8,22.2082388,15.7030563,-1.1095576,5.0774629,5.5128053,412.0031478,476.9879503,6.6574885,86.5236344,81.1435065,160.5798424,9.9827461,10.9615257,1.1482648,34.1666488),(24344,'femur.tif',244,7,76,50.0146992,22.1738709,15.642571,1.8,22.1640515,15.656434,-1.120552,5.0946346,5.5576793,413.4434804,479.082719,6.7570986,86.2019366,81.1527255,160.4308605,10.0169329,11.0009066,1.1575791,34.1666488),(24345,'femur.tif',244,7,77,49.8779693,22.1381665,15.5965413,1.8,22.1325196,15.6029104,-1.1243304,5.0831996,5.4794293,414.0265365,476.8325173,6.7631658,87.0222953,81.4499863,162.0038989,9.9827461,10.9395862,1.1705557,34.0382425),(24346,'femur.tif',244,7,78,49.9026661,22.1019212,15.5537471,1.8,22.0903754,15.5569571,-1.1230496,5.0975846,5.4662347,415.4656264,476.7605055,6.7582088,87.2191788,81.5024486,162.8689354,10.0169329,10.9299738,1.1547318,34.1666488),(24347,'femur.tif',244,7,79,49.8949798,22.0658846,15.5165929,1.8,22.0536413,15.5266001,-1.1190692,5.1092039,5.4827294,416.5853576,479.7830883,6.7312508,87.5080738,81.5362565,162.863837,10.0171296,10.9615257,1.1482648,34.2308519),(24348,'femur.tif',244,7,80,50.0636157,22.028243,15.4916654,1.8,22.0182936,15.4992077,-1.115601,5.119274,5.4896841,418.46132,483.8515988,6.7312088,88.1383323,81.7423172,163.8826386,10.0173264,10.9700155,1.1640493,34.2574457),(24349,'femur.tif',244,7,81,50.2204068,21.993691,15.473509,1.8,21.9839561,15.4795153,-1.1181877,5.1231197,5.4882804,420.0727563,489.2120108,6.7693539,89.1375764,81.9954995,165.2049505,10.0410555,10.9951724,1.1955255,34.3216488),(24350,'femur.tif',244,7,82,50.3036033,21.9533883,15.466923,1.8,21.9474676,15.4852558,-1.1082291,5.0915463,5.5150127,421.2787741,495.7083346,6.7143874,89.8834431,82.7408308,165.8657701,10.0175231,11.0719275,1.1603899,34.3670472),(24351,'femur.tif',244,7,83,50.4367483,21.9114575,15.4465045,1.8,21.8992523,15.448591,-1.1189313,5.1392685,5.5101973,423.9088275,498.9817505,6.8034291,90.5560593,82.4842738,166.6388719,10.0519067,11.0640588,1.1447485,34.5220472),(24352,'femur.tif',244,7,84,50.427511,21.8748098,15.4356696,1.8,21.8568775,15.447273,-1.1126793,5.1075971,5.5089971,425.539952,503.6630225,6.7606986,91.4255385,83.3150984,167.4003577,10.05171,11.1246931,1.1851154,34.5862503),(24353,'femur.tif',244,7,85,50.3528723,21.8364442,15.4330041,1.8,21.8268345,15.4567083,-1.102413,5.1414639,5.5309199,427.5234991,508.3895619,6.6818099,91.9177221,83.1520964,167.8435524,10.0758576,11.1570402,1.2160907,34.5674457),(24354,'femur.tif',244,7,86,50.427185,21.7891239,15.4268433,1.8,21.7816517,15.4486774,-1.0990259,5.1525471,5.5861239,429.9150331,514.5798947,6.6686795,92.1175233,83.4373798,168.1808028,10.0862903,11.19922,1.1350053,34.8508519),(24355,'femur.tif',244,7,87,50.4398303,21.7436139,15.4290432,1.8,21.7327873,15.4574356,-1.0914889,5.1619332,5.6029578,432.3088788,520.2449185,6.6187742,92.8518356,83.7494143,169.107378,10.1186823,11.269524,1.1379082,34.9604535),(24356,'femur.tif',244,7,88,50.5020501,21.6884622,15.4251688,1.8,21.6627632,15.4350161,-1.0855096,5.1779522,5.65236,434.4730188,526.5310808,6.5855788,93.1524319,83.9082722,169.5436301,10.1210674,11.3022538,1.1316837,35.0512504),(24357,'femur.tif',244,7,89,50.7678444,21.6418085,15.429065,1.8,21.6255304,15.4216264,-1.0841062,5.1893213,5.6719171,437.2708216,535.9780137,6.6104301,94.4967999,84.263586,169.9466894,10.1556477,11.3872274,1.1650109,35.225055),(24358,'femur.tif',244,7,90,50.6192805,21.5899768,15.4479366,1.8,21.5791705,15.4419745,-1.0717722,5.1932899,5.7079136,437.5036789,541.7214289,6.5043396,94.9070826,84.2440321,170.0643906,10.155451,11.4180418,1.1587745,35.2704535),(24359,'femur.tif',244,7,91,50.5209516,21.5450448,15.476813,1.8,21.5397248,15.4933769,-1.06817,5.2060417,5.731173,438.5924444,549.4020045,6.4661554,95.8620512,84.2468173,171.2542026,10.1752998,11.4754977,1.1313132,35.4442581),(24360,'femur.tif',244,7,92,50.8180644,21.4979495,15.4891373,1.8,21.4923935,15.4972094,-1.0624668,5.2178201,5.7837898,442.704807,557.6827673,6.4632527,96.4216869,84.8447813,171.3142772,10.1871755,11.551661,1.149166,35.535055),(24361,'femur.tif',244,7,93,50.989027,21.4544415,15.5117435,1.8,21.464918,15.5170907,-1.0542251,5.2246368,5.8364101,445.9402729,567.2758801,6.4251374,97.1960275,85.3533542,172.3966721,10.1904248,11.6456491,1.1011964,35.7354535),(24362,'femur.tif',244,7,94,51.1276529,21.4057855,15.5446438,1.8,21.425452,15.5538487,-1.0426538,5.2300283,5.8659737,449.3125617,576.1817637,6.357338,98.2244035,85.9101582,173.4793019,10.2252019,11.6842663,1.0804488,35.8450551),(24363,'femur.tif',244,7,95,51.3877139,21.3380118,15.5755253,1.8,21.3518184,15.5642128,-1.0350297,5.2560316,5.8997272,453.3894739,586.6678736,6.3325877,99.4398303,86.2607973,174.7149957,10.2253986,11.758056,1.0688194,36.0000551),(24364,'femur.tif',244,7,96,51.6917178,21.2758504,15.6188334,1.8,21.295054,15.5989622,-1.0331251,5.2743144,5.9113469,458.0462289,598.0599912,6.3556302,101.1715275,86.8446963,176.3477887,10.2597822,11.8044491,1.0483929,36.1738597),(24365,'femur.tif',244,7,97,51.9524602,21.2119693,15.6639835,1.8,21.2410219,15.6332887,-1.0364999,5.2923016,5.9312795,461.7748969,610.4719092,6.4133498,102.9241514,87.2540785,178.0501925,10.2601757,11.8941679,1.0750897,36.2192582),(24366,'femur.tif',244,7,98,51.9622863,21.1524063,15.7270258,1.8,21.1894122,15.7232608,-1.0317295,5.2969445,5.928992,465.8101458,618.8924402,6.3782563,104.3840912,87.9394039,179.8063728,10.2945593,11.9312258,1.069376,36.3742582),(24367,'femur.tif',244,7,99,52.1112137,21.0952592,15.7809924,1.8,21.1349413,15.7890634,-1.0332964,5.3054705,5.9316433,470.7388829,627.9937621,6.4085173,105.8718021,88.7270758,181.0764784,10.3275257,11.9583788,0.8909947,36.5746567),(24368,'femur.tif',244,7,100,52.4268596,21.0336611,15.8201811,1.8,21.0650972,15.8001868,-1.0380008,5.3238586,5.9448845,476.7185605,638.3481145,6.4833989,107.3777153,89.5438065,182.7739961,10.3291396,12.0072496,0.8859751,36.7484613),(24369,'femur.tif',244,7,101,52.5832418,20.9706116,15.8714524,1.8,20.9939987,15.8460859,-1.042312,5.3407982,5.9932775,482.4886791,648.2226529,6.5357213,108.1582908,90.3401815,183.9147407,10.3639167,12.0554241,1.0380944,36.922266),(24370,'femur.tif',244,7,102,52.9689314,20.9111925,15.9202855,1.8,20.948122,15.8578241,-1.0479318,5.3685858,6.0307905,488.3586417,661.1843034,6.6267275,109.6347649,90.9659755,185.7009928,10.3984971,12.1210107,0.8260997,37.0130629),(24371,'femur.tif',244,7,103,53.0587526,20.8449657,15.9831,1.8,20.8731135,15.8993158,-1.0531686,5.395925,6.0547829,494.4516313,671.0050956,6.6779137,110.8223214,91.6342674,187.3692141,10.4334709,12.1781092,0.8304128,37.2776645),(24372,'femur.tif',244,7,104,52.5453744,20.7809979,16.0865643,1.8,20.7801362,16.100009,-1.0531452,5.400308,6.1286255,500.0718919,676.2449686,6.6131246,110.3420291,92.6006235,189.2800093,10.4737871,12.2265929,0.816778,37.387266),(24373,'femur.tif',244,7,105,52.6552742,20.7231938,16.1707943,1.8,20.7269106,16.1891283,-1.0535983,5.4078505,6.182022,506.8169165,687.9370651,6.630375,111.2802675,93.7187368,191.4245875,10.5024348,12.2562772,1.0477287,37.5610707),(24374,'femur.tif',244,7,106,52.7483002,20.6591493,16.2505367,1.8,20.6626126,16.264887,-1.0591996,5.4236503,6.2181498,513.5203764,698.8142643,6.6842742,112.3829902,94.6816902,193.4868174,10.5374086,12.2981056,1.0055171,37.7160707),(24375,'femur.tif',244,7,107,52.9942543,20.596927,16.3361789,1.8,20.5995517,16.337464,-1.0649391,5.4432667,6.2807222,522.4460405,710.2996269,6.7585695,113.0920314,95.9802389,195.3148698,10.5723825,12.3772142,1.081944,37.8898754),(24376,'femur.tif',244,7,108,53.1772016,20.5357315,16.4260896,1.8,20.5323995,16.4272258,-1.0732674,5.4523374,6.3258079,531.358889,721.8627111,6.8441466,114.113916,97.4552468,197.4383727,10.6413464,12.4292709,1.0485566,38.06368),(24377,'femur.tif',244,7,109,53.3005201,20.4690117,16.5209631,1.8,20.4592643,16.5280689,-1.0740864,5.4714041,6.3733027,541.1157771,732.5520627,6.8661182,114.9407305,98.8988879,199.3084696,10.6761235,12.4965003,1.0516502,38.3470862),(24378,'femur.tif',244,7,110,53.4272734,20.4209513,16.6118481,1.8,20.4177534,16.6229316,-1.0821872,5.4928433,6.4112599,551.3843073,745.2132132,6.9425652,116.2350662,100.3823112,201.8835748,10.7419687,12.5559575,1.0684939,38.6382816),(24379,'femur.tif',244,7,111,53.740463,20.3618722,16.7153946,1.8,20.3502852,16.7393053,-1.0876031,5.5122359,6.4311159,563.0352865,761.3390583,7.0233256,118.3836625,102.1428147,204.9733976,10.8146416,12.6022729,1.0493619,38.9216878),(24380,'femur.tif',244,7,112,54.2248951,20.3149,16.8125237,1.8,20.3095548,16.8329666,-1.1008234,5.5080543,6.471974,575.7369906,781.4961228,7.1840383,120.7508123,104.5263834,208.9128687,10.8494186,12.6768784,1.3614109,39.0766878),(24381,'femur.tif',244,7,113,54.7927095,20.2522369,16.9330649,1.8,20.2424626,16.966884,-1.1100798,5.5418173,6.5403946,590.6614682,803.4535451,7.3270607,122.844812,106.5826309,212.5214971,10.9151076,12.7689343,1.3567356,39.450891),(24382,'femur.tif',244,7,114,55.5695033,20.1830906,17.0555264,1.8,20.1709365,17.0929264,-1.1137207,5.5508175,6.6130528,607.3817142,833.6446664,7.4577195,126.0604888,109.4220283,217.4274236,10.9535531,12.9136963,1.1635405,39.8892972),(24383,'femur.tif',244,7,115,56.6921611,20.096569,17.1843274,1.8,20.0711368,17.2204811,-1.1072389,5.6025175,6.6946409,630.1685709,868.6645253,7.5596368,129.7552085,112.4795356,223.4302482,11.0229106,13.0885555,0.7015615,40.3088988),(24384,'femur.tif',244,7,116,58.1972494,19.992772,17.3287015,1.8,19.9574466,17.3649485,-1.0789024,5.6576619,6.7975956,658.8658495,913.1260949,7.5359267,134.3307462,116.4555,227.480889,11.0917594,13.4162335,0.7036138,41.057305),(24385,'femur.tif',244,7,117,59.7225049,19.9053207,17.4738417,1.8,19.8615223,17.5192394,-1.0652981,5.7200202,6.8883778,689.486138,961.012794,7.6196792,139.512208,120.5391094,233.913515,11.1272418,13.6543044,0.7492693,41.6585004),(24386,'femur.tif',244,7,118,61.1225283,19.8165709,17.6182528,1.8,19.7596521,17.6548652,-1.0611361,5.7763771,6.9882245,723.2972498,1001.4514098,7.7622798,143.3055575,125.2164173,243.590783,11.1965992,13.7439654,0.7055682,42.1611097),(24387,'femur.tif',244,7,119,62.4514367,19.7846691,17.7604134,1.8,19.7580132,17.8106292,-1.0873593,5.7623109,7.0396541,758.8544717,1031.9844548,8.1596721,146.5959035,131.6927328,252.8519608,11.2663502,13.677159,0.7172309,42.4899144),(24388,'femur.tif',244,7,120,63.5162892,19.7455387,17.9141326,1.8,19.6915314,17.978378,-1.1301667,5.7766193,7.1329451,797.6845596,1059.6792581,8.6603404,148.5612526,138.0884765,260.0867596,11.4390551,13.6760611,0.6162969,42.8453129),(24389,'femur.tif',244,7,121,63.7417396,19.7403962,18.0600645,1.8,19.697471,18.1329572,-1.1749717,5.8623546,7.1946557,826.6109132,1078.5449885,9.0442772,149.9091868,141.0032256,264.7614199,11.6800097,13.8230552,1.4471367,43.2649145),(24390,'femur.tif',244,7,122,64.2280244,19.7000117,18.2180176,1.8,19.6317663,18.2697235,-1.2141118,6.0251275,7.2737348,859.3295238,1109.6774205,9.3995656,152.5595111,142.6242883,270.258393,11.8938413,13.9895559,1.4038262,43.7299145),(24391,'femur.tif',244,7,123,65.4032666,19.652867,18.4308564,1.8,19.5950261,18.5205625,-1.2541524,6.298714,7.3957767,909.2950249,1156.1971337,9.8436612,156.3320762,144.3620118,276.1264122,12.3026686,14.342527,1.0442777,44.493899),(24392,'femur.tif',244,7,124,66.8924959,19.6499184,18.6691147,1.8,19.6066398,18.8362226,-1.3500912,6.6432239,7.4747417,960.4999361,1219.6355292,10.6144461,163.1675816,144.583405,285.7872309,12.6136779,14.7274481,1.0412067,45.4050944),(24393,'femur.tif',244,7,125,69.0178821,19.5282816,18.8989864,1.8,19.5068309,19.0569234,-1.3300242,6.7893283,7.6730697,1041.4825914,1289.4325849,10.8489253,168.0465111,153.3999451,300.1688171,12.9299284,14.9496686,1.067726,46.3273054),(24394,'femur.tif',244,7,126,69.8667611,19.475321,19.0252162,1.8,19.448273,19.1438174,-1.3788074,7.030732,7.7013952,1084.7094619,1334.8978133,11.2204958,173.3319448,154.2811566,308.5590511,13.1537194,14.912459,1.0722791,46.7579224),(24395,'femur.tif',244,7,127,69.6461019,19.4879132,19.0482094,1.8,19.4411167,19.1218016,-1.4711111,7.1975714,7.5062631,1091.2416841,1359.1825994,11.492718,181.0731363,151.6124846,309.8177481,13.1698728,14.9189019,1.445797,47.0867271),(24396,'femur.tif',244,7,128,68.9151784,19.4913334,19.1397591,1.8,19.424084,19.2012428,-1.5234737,7.2788425,7.5360818,1079.7196462,1385.5650674,11.4601604,183.8574873,148.3367234,309.0515435,13.2038571,15.0543635,1.4572966,47.3967271),(24397,'femur.tif',244,7,129,69.071808,19.4269619,19.2551611,1.8,19.3296251,19.2956152,-1.5423175,7.3239532,7.6822966,1100.8966054,1419.5734478,11.5026338,184.785036,150.3145328,310.6830743,13.2417231,15.2265323,1.4483353,47.7975241),(24398,'femur.tif',244,7,130,68.8652978,19.361669,19.4189959,1.8,19.2731141,19.4541844,-1.5586757,7.3435257,7.7752579,1121.8675014,1448.6695437,11.4758635,186.3178771,152.7696023,312.1669665,13.2975382,15.4320395,1.4246379,48.198321),(24399,'femur.tif',244,7,131,68.8286257,19.3031558,19.5659213,1.8,19.1889561,19.5761095,1.5560871,7.4557205,8.0459276,1152.2189336,1480.0859137,11.4689558,183.9546636,154.5415945,316.287365,13.4075008,15.6981038,1.4966749,48.7729226),(24400,'femur.tif',244,7,132,67.9391166,19.2478215,19.7348995,1.8,19.1207143,19.7179661,1.5443132,7.4885072,8.208703,1180.1191478,1494.8248998,11.3152463,182.1024474,157.5907076,319.7209756,13.4850008,15.9146972,1.5123265,49.3021257),(24401,'femur.tif',244,7,133,68.0942265,19.1738027,19.8736248,1.8,19.0156122,19.8454284,1.5317333,7.658517,8.339126,1224.1581223,1545.9596196,11.3317289,185.386289,159.8427107,323.9503102,13.7950009,16.1603771,1.8576597,50.0239382),(24402,'femur.tif',244,7,134,68.8408026,19.0990226,20.0514648,1.8,18.9380288,19.9753435,1.562023,7.8716028,8.4108133,1291.1360734,1620.1371112,11.472584,192.6254983,164.0245465,334.6996726,14.1816983,16.4499123,1.867217,50.8099537),(24403,'femur.tif',244,7,135,68.9108346,19.0405677,20.2921123,1.8,18.8929537,20.188407,-1.5324897,7.925023,8.4772657,1348.2357321,1693.0549526,11.4682941,199.7171046,170.1238884,344.6891159,14.3375009,16.740898,1.8764429,51.6303522),(24404,'femur.tif',244,7,136,69.247289,18.9738365,20.4961029,1.8,18.8634889,20.3532619,-1.4832029,7.9576272,8.5647303,1408.9311941,1783.9987454,11.4528899,208.2959637,177.0541842,354.0541359,14.5700009,17.1182056,1.8553148,52.7341569),(24405,'femur.tif',244,7,137,69.3235001,18.9191129,20.7651285,1.8,18.8078478,20.5678315,-1.4339473,7.9746283,8.6952473,1473.2182395,1878.3368474,11.3388862,216.0187947,184.7381697,363.444565,14.7250009,17.5499441,1.8757887,53.7095555),(24406,'femur.tif',244,7,138,70.2360216,18.8374524,21.0889568,1.8,18.811061,20.813199,-1.3931025,7.9551138,9.1325324,1541.0973954,2032.5653073,11.3402593,222.5631649,193.7241168,378.1641836,14.9575009,18.0400302,1.876244,55.2141571),(24407,'femur.tif',244,7,139,71.8444728,18.7872486,21.4869989,1.8,18.7502028,21.1274007,-1.3766259,8.0225338,9.6115691,1639.1934707,2212.376073,11.5282755,230.1784503,204.3236606,387.0659647,15.1125009,18.6214627,1.0382282,56.9379619),(24408,'femur.tif',244,7,140,73.5679439,18.7047896,21.8338439,1.8,18.6773032,21.474793,-1.3780656,8.057784,10.1761394,1736.1042628,2463.3254121,11.8114868,242.0687558,215.4567895,399.733888,15.4086804,19.5252338,1.0378648,61.7948133),(24409,'femur.tif',244,7,141,77.8391772,18.4532712,22.5048964,1.8,18.4136139,22.156554,-1.303296,8.7658792,11.319561,1969.4542418,2817.0994669,12.0668125,248.8700291,224.6727568,415.1398037,16.4251287,20.8025085,1.0437946,67.955868),(24410,'femur.tif',244,7,142,84.8781079,17.952986,23.4133687,1.8,17.954285,23.0750919,-1.1894601,8.8888211,12.7836591,2303.6420621,3390.2168154,12.1870274,265.1992512,259.1617098,444.461737,17.2284957,22.4362179,1.0220832,70.2996728),(24411,'femur.tif',244,7,143,96.6385619,17.0329048,25.0867687,1.8,16.9985546,24.7748988,-1.0197472,9.9004802,14.7998899,2700.7830975,5093.2664079,11.6910531,344.142183,272.7931427,525.6827566,18.1037985,28.3073475,0.9448181,80.5173215),(24412,'femur.tif',244,7,144,108.364511,17.0234208,26.7068387,1.8,16.8465746,26.3150979,-1.1892054,9.546044,16.330924,3500.4013007,6220.5144086,15.5560889,380.9040091,366.6860653,594.4891509,19.0226594,29.4601974,0.9536049,91.705806),(24413,'femur.tif',244,7,145,118.6110186,17.156943,27.7871576,1.8,16.9144427,27.2193656,-1.2952032,10.7071476,17.0693933,3957.8228151,7150.8268349,18.3046843,418.9268302,369.6430594,644.5018059,19.8232564,30.1191981,0.9406758,95.6404466),(24414,'femur.tif',244,7,146,127.1078091,17.1813517,28.4634861,1.8,16.9735756,27.8430334,-1.3076605,11.7655279,17.6303115,4401.3856217,7798.7549259,19.7513448,442.3492417,374.0916387,685.1502241,21.1329909,30.567735,0.9166465,97.228056),(24415,'femur.tif',244,7,147,136.8951264,17.2943416,28.6612095,1.8,17.0779222,27.9535565,-1.3068289,12.3382405,17.6643671,4905.426602,8626.691915,21.2626569,488.3668829,397.5791028,757.9729233,22.0193622,30.8323423,0.9137214,98.425884),(24416,'femur.tif',244,7,148,143.0857525,17.3994778,28.7083373,1.8,17.2524214,27.9156653,-1.3262757,12.6428668,17.4645795,5192.7011321,9134.3452353,22.4499595,523.0211946,410.7218112,807.8058977,22.5822337,30.9410459,0.9132681,100.0057042),(24417,'femur.tif',244,7,149,143.2066766,17.3835963,28.8606363,1.8,17.2340949,28.2156584,-1.3532995,12.7128114,17.3203239,5481.4564925,9224.5265112,22.7564091,532.5839505,431.1757891,830.9837303,22.7895266,30.9015174,0.886655,100.3688919),(24418,'femur.tif',244,7,150,139.7402932,17.3908409,28.9745388,1.8,17.2688753,28.3453735,-1.3519382,12.4845876,17.1657729,5456.8023764,8905.1413691,22.1921798,518.7731071,437.0831108,816.743832,22.7559151,30.7113266,0.8783198,100.1684934),(24419,'femur.tif',244,7,151,138.2346676,17.4403057,28.9316162,1.8,17.2797092,28.4083126,-1.3390957,12.1684805,16.7992982,5354.1083832,8479.4253665,21.8242283,504.7487861,439.9981051,803.7329087,22.3200014,30.2962576,0.8868667,99.1476964),(24420,'femur.tif',244,7,152,136.6020861,17.5003428,28.8338651,1.8,17.3503774,28.4621215,-1.3508551,12.0930982,16.1935323,5133.8230989,7948.4924671,21.6833237,490.8436493,424.5250499,784.1727822,22.0089276,29.7190036,0.8777275,97.8888917),(24421,'femur.tif',244,7,153,133.9032222,17.5577013,28.570667,1.8,17.4595955,28.3209217,-1.3303982,11.862932,15.4544577,4682.635679,7294.6416077,21.052119,472.008901,394.728359,752.9218118,21.8190664,28.8854693,0.874684,97.117118),(24422,'femur.tif',244,7,154,131.0639235,17.6347765,28.3123339,1.8,17.5951278,28.14086,-1.2878445,11.2092728,14.6009985,4284.4900953,6478.2810706,20.1412967,443.6875379,382.2273011,719.51412,21.026746,27.8072782,0.8603563,95.1066807),(24423,'femur.tif',244,7,155,127.0071022,17.6676941,28.1485064,1.8,17.7397944,27.9920052,-1.2108299,11.1621172,13.7152886,3899.9583913,5469.6970708,18.5414486,398.8029136,349.3923513,672.5547735,20.045361,26.5042085,0.8371118,92.0520789),(24424,'femur.tif',244,7,156,117.0900313,17.6166864,28.0781122,1.8,17.7646128,27.9145665,-1.0862816,11.6340668,12.7617256,3393.6978004,4223.7330543,15.2812241,330.9688049,291.7034827,583.3631794,19.2595696,24.8422273,0.7478882,89.8600478),(24425,'femur.tif',244,7,157,99.4433753,17.6188615,28.1669169,1.8,17.89038,28.0784553,0.0243328,11.1489773,10.1410257,2726.6383925,2821.3700329,0.0098112,278.2134772,244.5639919,453.4091488,18.2751023,23.1137187,1.9413404,87.8606259),(24426,'femur.tif',244,7,158,74.6216986,17.9018473,28.3578778,1.8,18.0132717,28.3887877,0.4090775,9.195958,9.5566833,1457.3114268,2111.0685882,1.9677178,220.8997128,158.4730404,330.5838022,6.3508101,16.9740935,1.1623074,46.1787581),(24427,'femur.tif',244,7,159,22.2163867,16.7838368,26.3037382,1.8,17.3362917,27.1691604,0.4033406,7.1873157,9.0985211,266.0432503,398.6144455,0.5704087,43.8109051,37.0156622,62.2600037,2.9450002,8.5422445,1.5072457,19.7167114),(24428,'femur.tif',244,7,160,3.1623171,15.5422588,23.8457699,1.8,15.5552638,23.8145185,-1.4519839,0.663903,2.3162847,0.2238072,3.3244104,0.5196477,1.4352339,0.3371082,1.5318505,1.3950001,4.4722271,1.4141944,10.0814534),(24429,'femur.tif',244,7,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24430,'femur.tif',244,7,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24431,'femur.tif',244,7,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24432,'femur.tif',244,7,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24433,'femur.tif',244,7,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24434,'femur.tif',244,7,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24435,'femur.tif',244,7,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24436,'femur.tif',244,7,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24437,'femur.tif',244,7,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24438,'tibia.tif',244,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24439,'tibia.tif',244,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24440,'tibia.tif',244,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24441,'tibia.tif',244,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24442,'tibia.tif',244,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24443,'tibia.tif',244,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24444,'tibia.tif',244,8,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24445,'tibia.tif',244,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24446,'tibia.tif',244,8,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24447,'tibia.tif',244,8,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24448,'tibia.tif',244,8,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24449,'tibia.tif',244,8,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24450,'tibia.tif',244,8,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24451,'tibia.tif',244,8,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24452,'tibia.tif',244,8,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24453,'tibia.tif',244,8,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24454,'tibia.tif',244,8,17,2.6521878,15.3602108,20.8506348,1.8,15.3595875,20.8538369,0.9020828,0.7902822,1.4044913,0.3436539,1.0078463,0.272127,0.7175881,0.4348496,0.9597103,1.6440234,2.7520687,2.1353657,7.0644609),(24455,'tibia.tif',244,8,18,10.4743798,17.9063101,20.1049071,1.8,17.9837816,20.0693508,-0.3483872,1.9572992,4.4767369,6.0323451,87.9295508,0.2034507,19.6414382,3.0819739,20.9403991,2.1669173,4.0008322,2.1211823,9.9296797),(24456,'tibia.tif',244,8,19,15.7799944,17.9129002,20.0502278,1.8,17.9448411,20.0159739,-0.3873245,2.422294,4.8068866,13.0357324,138.5175847,0.3752133,28.8164867,5.381565,31.3412362,2.6659617,4.7217796,1.9756881,11.9102969),(24457,'tibia.tif',244,8,20,18.9769248,17.9870952,19.9576602,1.8,18.0170894,19.9079182,-0.3932023,2.7658653,5.0813206,18.6435291,173.8976413,0.4643105,34.2229227,6.7405775,37.3581487,2.8774474,5.1226272,1.8781938,13.0141016),(24458,'tibia.tif',244,8,21,25.5981038,18.4415552,20.3351164,1.8,18.5301562,20.3203844,-0.3103849,7.6165991,5.6502626,121.2705982,231.4153671,0.3979844,40.9565683,15.9218828,46.2256459,2.9815819,5.6335627,1.7088024,14.4733048),(24459,'tibia.tif',244,8,22,38.394228,18.9795476,20.8936512,1.8,19.0720165,20.8983045,0.4497294,5.9147805,5.495834,277.3528252,336.5303708,1.20931,61.2337224,46.8914826,83.3283362,9.8260691,12.1301744,1.3583643,49.051766),(24460,'tibia.tif',244,8,23,52.8459003,19.7791749,21.4076015,1.8,19.8829392,21.3832034,0.3929316,6.1471897,8.1725344,404.6709997,541.5785318,1.2912989,66.2681249,65.8302444,112.36453,10.6288603,12.44569,1.3061827,50.3559692),(24461,'tibia.tif',244,8,24,71.3165223,20.6639433,21.7338612,1.8,20.7474652,21.7225327,-0.0226785,6.325435,8.2492363,559.5002407,938.6360486,0.0061123,113.7845995,88.4524535,181.5762756,11.3645034,15.0423896,2.87037,55.0234377),(24462,'tibia.tif',244,8,25,86.5780738,21.5145774,21.5540543,1.8,21.5713517,21.5155684,-0.199972,6.2091168,8.1927086,638.5892872,1465.2279292,0.5693748,178.8453617,102.8470399,256.611337,11.2855152,15.738799,2.9983028,48.7229613),(24463,'tibia.tif',244,8,26,88.1870177,21.7722494,21.3925157,1.8,21.7950743,21.4303085,-0.2357721,6.2773099,8.216999,671.0474177,1609.007347,0.8020029,195.8144763,106.9004767,275.8820738,11.2531901,16.1015469,0.1303251,49.3695552),(24464,'tibia.tif',244,8,27,81.4972315,21.8428487,21.364022,1.8,21.9315545,21.3956908,-0.2626958,6.0388115,8.1909903,605.8183526,1515.1883389,0.9159776,184.9823139,100.3207919,257.4168172,10.9532291,16.1015469,0.1303251,48.4927427),(24465,'tibia.tif',244,8,28,66.0147415,21.8054656,21.3449605,1.8,21.8920064,21.4015527,-0.2659676,5.9095489,8.1248165,584.938176,1345.1136646,0.7601202,165.5561907,98.9818663,236.3391482,10.684025,15.7561532,0.1133731,46.9505318),(24466,'tibia.tif',244,8,29,58.0027888,21.9266641,21.3541525,1.8,21.9777862,21.3739423,-0.2828942,5.6893433,7.9351088,509.3333293,1198.103448,0.7532327,150.9876526,89.5240986,214.3946217,10.3996389,15.4102285,0.1362072,45.5821255),(24467,'tibia.tif',244,8,30,53.2179435,22.0921581,21.3350662,1.8,22.132276,21.3445569,-0.3054857,5.4585127,7.6612741,459.0183259,1053.1528787,0.8022999,137.4644562,84.0921975,196.5923274,10.0660857,15.0373977,0.1448125,44.0587192),(24468,'tibia.tif',244,8,31,50.2253416,22.2443573,21.2708473,1.8,22.2726249,21.2700624,-0.3334761,5.260615,7.4292537,419.5155921,938.5597053,0.8968964,126.3329721,79.7464913,182.2705662,9.7321613,14.5891572,0.1546687,42.6449144),(24469,'tibia.tif',244,8,32,48.1109845,22.4081003,21.2061755,1.8,22.4200754,21.2063245,-0.348767,5.0953706,7.1708925,386.319631,843.4151556,0.9364463,117.616483,75.8177694,170.6938817,9.4424083,14.1058525,0.2103259,41.3861097),(24470,'tibia.tif',244,8,33,47.202568,22.5508345,21.1551336,1.8,22.5725126,21.1464431,-0.3548589,4.9901985,6.9155688,365.8568755,785.5658388,0.9497718,113.5938137,73.3150953,165.5348796,9.2554389,13.7647078,0.2736593,40.2369065),(24471,'tibia.tif',244,8,34,46.9267068,22.6548796,21.1256796,1.8,22.6784282,21.1094189,-0.3577178,4.9120387,6.7330397,350.8429106,741.7531267,0.9588392,110.1661591,71.4251107,160.8032577,9.1218614,13.4593658,0.2324095,39.3523049),(24472,'tibia.tif',244,8,35,46.6213953,22.7167653,21.1149307,1.8,22.741127,21.094868,-0.3511566,4.8590991,6.6031108,336.2615087,705.2948635,0.9194132,106.8125135,69.2024391,156.4804091,8.9884029,13.1977753,0.2250383,38.4223049),(24473,'tibia.tif',244,8,36,46.3628137,22.763559,21.093099,1.8,22.7797216,21.0691182,-0.3466095,4.8057762,6.4553455,322.4711816,673.851822,0.8917385,104.3866395,67.1007487,153.3180657,8.867829,12.9452849,0.1562906,37.6285002),(24474,'tibia.tif',244,8,37,46.1598508,22.8192754,21.0565762,1.8,22.8423168,21.0296382,-0.3437729,4.7640511,6.3402115,310.2212515,642.7067972,0.8739371,101.3699296,65.1171128,149.0787506,8.764514,12.7545796,0.1771361,36.944297),(24475,'tibia.tif',244,8,38,45.9418913,22.8675991,21.0083531,1.8,22.8894064,20.9843796,-0.3405442,4.7243199,6.2080985,299.0780288,613.4133482,0.8541825,98.8085717,63.3060494,145.7909276,8.6611991,12.5399223,0.1864869,36.4150939),(24476,'tibia.tif',244,8,39,45.7927043,22.9042657,20.9504872,1.8,22.918289,20.9251185,-0.3381563,4.6966488,6.0911242,289.5926748,589.2432015,0.8399677,96.7380051,61.6594267,142.5380006,8.5625164,12.3332194,0.1196785,35.9312892),(24477,'tibia.tif',244,8,40,45.5727247,22.9374963,20.8972063,1.8,22.9500744,20.8765257,-0.3319834,4.6480144,5.9961163,280.2301664,567.6211017,0.8068122,94.6647925,60.2902969,139.8504441,8.4411844,12.1440307,0.1473122,35.1828829),(24478,'tibia.tif',244,8,41,45.3337726,22.9560495,20.8427397,1.8,22.963749,20.8252327,-0.3273383,4.5782372,5.938403,270.9527875,548.4091399,0.7810826,92.3496002,59.1827761,136.7467149,8.3092816,12.0254937,0.1227563,34.8540783),(24479,'tibia.tif',244,8,42,45.029218,22.9867381,20.7937694,1.8,23.0016748,20.7800775,-0.3210283,4.5707736,5.8944263,263.8666002,529.1317389,0.7472379,89.7681497,57.7290901,133.5421561,8.2568875,11.8815368,0.1308274,34.415672),(24480,'tibia.tif',244,8,43,44.9144589,23.0051917,20.7551191,1.8,23.0217181,20.7471511,-0.3122894,4.5359618,5.8434123,258.4862846,514.8620684,0.7066185,88.1098309,56.9859928,131.9534184,8.1984099,11.7608651,0.1521483,33.9772658),(24481,'tibia.tif',244,8,44,44.7813822,23.0196878,20.7106241,1.8,23.0335094,20.7047218,-0.3071442,4.5045938,5.7980389,253.2703065,501.4666267,0.6822303,86.4890064,56.2248935,129.2804438,8.1486224,11.6963402,0.1597021,33.6672658),(24482,'tibia.tif',244,8,45,44.6833091,23.0302029,20.6664812,1.8,23.0515378,20.6568107,-0.3042058,4.4678323,5.749249,249.0229231,489.2089492,0.6681757,85.0909315,55.7368554,127.8575159,8.1183407,11.5693257,0.1750602,33.4026642),(24483,'tibia.tif',244,8,46,44.4773927,23.0319982,20.6227465,1.8,23.0595549,20.6188178,-0.3040069,4.4351979,5.7070023,244.3960478,478.223877,0.664254,83.7959843,55.1037525,126.0324139,8.0921505,11.5081636,0.1418971,33.1834611),(24484,'tibia.tif',244,8,47,44.3179205,23.0351367,20.5768733,1.8,23.0635017,20.5763331,-0.2994701,4.4067038,5.6693696,240.2434947,466.9246913,0.6428554,82.3591906,54.5177316,124.2667031,8.0618689,11.4033034,0.1707352,32.7450549),(24485,'tibia.tif',244,8,48,44.1757224,23.0277396,20.536313,1.8,23.0562744,20.5412228,-0.2985547,4.3285005,5.6421619,236.7903398,457.4413392,0.6369981,81.0755428,54.7049356,122.3481495,8.0295414,11.3661096,0.1505757,32.5900549),(24486,'tibia.tif',244,8,49,44.1953829,23.02392,20.4840646,1.8,23.0516537,20.4925443,-0.3005103,4.2989404,5.6062149,233.7763698,449.4290818,0.6454039,80.1662244,54.3799982,120.821912,7.9932159,11.3014566,0.1583844,32.3254533),(24487,'tibia.tif',244,8,50,44.4249455,23.0140482,20.4258381,1.8,23.0338555,20.4237226,-0.2993386,4.2611013,5.5709928,231.0938168,441.8193712,0.643859,79.3071156,54.233354,120.0486976,7.9601793,11.2128875,0.1526493,32.1062502),(24488,'tibia.tif',244,8,51,44.3162084,23.0134452,20.3811872,1.8,23.0395324,20.3883522,-0.2972048,4.2082311,5.531092,228.9379484,434.047584,0.6334289,78.4741216,54.4024186,119.4171063,7.9448473,11.0979357,0.1754813,31.8682424),(24489,'tibia.tif',244,8,52,44.5187866,22.9983732,20.3374335,1.8,23.0209832,20.3426764,-0.2956491,4.1748028,5.4593639,227.7363784,428.5097784,0.6298749,78.4907891,54.550212,119.4729248,7.9448473,11.0161834,0.1269728,31.7586409),(24490,'tibia.tif',244,8,53,44.8486305,22.9873021,20.2951391,1.8,23.01031,20.2979832,-0.2911879,4.1307018,5.4302405,226.6686899,425.4877712,0.6160772,78.3552345,54.8741351,119.5334136,7.9155334,10.9601558,0.1418971,31.5848362),(24491,'tibia.tif',244,8,54,45.052262,22.9747963,20.2578929,1.8,22.9920089,20.2631891,-0.2855737,4.0898116,5.3899243,225.9573612,421.9447329,0.5958865,78.2839814,55.248843,119.6906753,7.897639,10.8834402,0.1429041,31.5848362),(24492,'tibia.tif',244,8,55,45.2775558,22.9570084,20.224433,1.8,22.9745226,20.2282644,-0.2816206,4.0633088,5.3467413,226.326109,418.2877977,0.5828393,78.2322866,55.699953,119.7079357,7.909948,10.8436327,0.1146035,31.3656331),(24493,'tibia.tif',244,8,56,45.4671302,22.9341618,20.1989795,1.8,22.9498414,20.2098876,-0.2777965,4.0425331,5.3100254,226.9509483,415.2032796,0.5699008,78.192334,56.1407765,119.7063858,7.9167739,10.7855952,0.1297025,31.2106331),(24494,'tibia.tif',244,8,57,45.8314316,22.9108854,20.1758444,1.8,22.9252408,20.1848284,-0.2766122,4.0393226,5.2942682,228.4567247,413.0911958,0.5697048,78.026118,56.5581773,120.0631465,7.9652413,10.7300429,0.1449614,31.2560315),(24495,'tibia.tif',244,8,58,46.2447152,22.8841677,20.1464499,1.8,22.8960573,20.1465982,-0.2766474,4.0215062,5.2797172,229.7791357,410.931605,0.5749845,77.8321243,57.1375807,120.4396539,7.9699692,10.6989311,0.1234565,31.1918284),(24496,'tibia.tif',244,8,59,46.5457881,22.8454423,20.1186024,1.8,22.8487104,20.1167908,-0.27665,4.0165362,5.2670279,230.793347,407.9562497,0.5787387,77.4547349,57.4607913,120.8791877,7.9889203,10.6423621,0.1388075,30.9914299),(24497,'tibia.tif',244,8,60,46.7799559,22.8096725,20.0920902,1.8,22.810758,20.0908773,-0.2777513,4.0196362,5.2513908,231.951597,405.4959864,0.5861705,77.2168749,57.7046242,120.9829093,8.0074671,10.6132571,0.1687501,30.9914299),(24498,'tibia.tif',244,8,61,46.9169023,22.7780045,20.0614247,1.8,22.7836362,20.0568896,-0.2785881,4.0046581,5.2411567,232.6991138,404.4978039,0.5913418,77.1772013,58.1071113,120.7252663,8.0264182,10.6126912,0.1171087,31.0102346),(24499,'tibia.tif',244,8,62,47.0692006,22.74299,20.0370708,1.8,22.7502908,20.0393671,-0.280605,4.0052095,5.2144322,233.8599309,402.7246772,0.6016553,77.2327004,58.3889379,121.2106851,8.0451672,10.5656129,0.1398224,30.9460315),(24500,'tibia.tif',244,8,63,47.2370698,22.6992303,20.0188873,1.8,22.7033028,20.0245161,-0.2803542,4.0134033,5.2199281,235.0611129,400.7539454,0.6027505,76.7738437,58.5690243,121.6624893,8.0784426,10.5240327,0.1627274,30.8364299),(24501,'tibia.tif',244,8,64,47.4318137,22.6528636,19.9984967,1.8,22.6545097,20.0020087,-0.2816402,4.0141725,5.2155793,236.8672424,399.3122797,0.6106529,76.561444,59.0077387,121.6525283,8.101414,10.5186095,0.1033343,30.9194377),(24502,'tibia.tif',244,8,65,47.6288555,22.5999717,19.9780003,1.8,22.6032114,19.9820905,-0.2814856,4.0270352,5.2078199,238.4961123,397.5255798,0.6125346,76.3324367,59.2237473,121.7171077,8.1369809,10.5000352,0.14816,30.8098361),(24503,'tibia.tif',244,8,66,47.8274647,22.5444706,19.9554866,1.8,22.5463244,19.9589377,-0.2824958,4.0388584,5.2114007,240.4640011,396.1443209,0.6193932,76.0149413,59.5376158,121.7545123,8.1586715,10.4888748,0.1408521,30.9194377),(24504,'tibia.tif',244,8,67,47.9978126,22.4930935,19.9338697,1.8,22.4963316,19.9385749,-0.2826095,4.0566349,5.2138713,242.986437,395.0830402,0.6220861,75.7753726,59.8985224,122.3633888,8.1864414,10.4498634,0.1114762,30.8552346),(24505,'tibia.tif',244,8,68,48.3110048,22.4433373,19.9102913,1.8,22.4437538,19.9136469,-0.2826287,4.0729335,5.2118505,245.2118563,395.19852,0.6262281,75.8269108,60.2052199,122.7565348,8.2107542,10.4587685,0.1188403,30.8286408),(24506,'tibia.tif',244,8,69,48.5317841,22.3877405,19.8888807,1.8,22.3871108,19.8950643,-0.2837734,4.1020847,5.2062607,247.7427875,395.3639748,0.6340586,75.9401038,60.3943622,123.4552924,8.2495976,10.4498634,0.1114762,30.8286408),(24507,'tibia.tif',244,8,70,48.767331,22.3313671,19.8637045,1.8,22.331571,19.8661223,-0.2801422,4.1141381,5.2010288,250.1639643,395.653011,0.6213605,76.0720663,60.8059233,124.1477049,8.2823549,10.412148,0.1418971,30.9382424),(24508,'tibia.tif',244,8,71,49.0299395,22.2750614,19.8383278,1.8,22.278296,19.8379963,-0.2759897,4.1368724,5.1952138,252.6401262,397.2305575,0.6067935,76.4608688,61.0703217,125.0565654,8.3053825,10.4265593,0.089314,30.9382424),(24509,'tibia.tif',244,8,72,49.2071059,22.2149895,19.8097717,1.8,22.2181688,19.8107501,-0.2735195,4.1458532,5.191696,254.9166491,398.5427933,0.5984059,76.7654339,61.4871383,125.4761825,8.332875,10.4415259,0.1040999,30.9836408),(24510,'tibia.tif',244,8,73,49.4640327,22.1496206,19.7819324,1.8,22.15129,19.7790047,-0.2709172,4.1547854,5.193172,257.2932178,398.9562753,0.5904187,76.8232361,61.9269566,126.1060818,8.3334315,10.4337575,0.0967123,30.9836408),(24511,'tibia.tif',244,8,74,49.6893274,22.0811586,19.7519636,1.8,22.0799414,19.7495646,-0.2680305,4.1689743,5.2098759,259.6700761,399.8415926,0.5808382,76.7468559,62.2863225,126.4042747,8.3636417,10.412148,0.1418971,30.9836408),(24512,'tibia.tif',244,8,75,49.7797439,22.0134653,19.7181869,1.8,22.0173717,19.7123486,-0.2636141,4.1922042,5.2120836,261.3111983,400.2568269,0.5633199,76.7940156,62.3326505,126.7159822,8.387919,10.4265593,0.089314,31.0478439),(24513,'tibia.tif',244,8,76,50.1050795,21.9471115,19.685394,1.8,21.9523823,19.6726138,-0.2598622,4.1975295,5.2127912,263.8724815,401.6530026,0.5513394,77.0514274,62.8637581,127.1147835,8.4066484,10.4415259,0.1040999,31.0478439),(24514,'tibia.tif',244,8,77,50.2931927,21.8815476,19.6524547,1.8,21.8906698,19.6417578,-0.2568569,4.2077541,5.2282621,265.9114255,402.9465054,0.5409639,77.0708311,63.1955709,127.8734994,8.4224993,10.4337575,0.0967123,31.112047),(24515,'tibia.tif',244,8,78,50.4578796,21.8155068,19.6144763,1.8,21.8266717,19.597123,-0.2531222,4.2089782,5.2274951,267.9369193,404.3674676,0.5274036,77.3539643,63.6584243,128.3277448,8.4312395,10.4415259,0.1040999,31.2028439),(24516,'tibia.tif',244,8,79,50.5863574,21.746022,19.5793561,1.8,21.7562352,19.562719,-0.2487117,4.2322418,5.2482749,270.5324186,406.3240313,0.5108594,77.4204929,63.9217773,128.5165339,8.4555523,10.4857249,0.0665682,31.267047),(24517,'tibia.tif',244,8,80,50.7092058,21.6756889,19.5435255,1.8,21.6834411,19.5312466,-0.2429983,4.2365212,5.2532775,273.4048955,408.2311594,0.489302,77.7098033,64.5352363,129.1939186,8.4576699,10.4911651,0.073939,31.2858517),(24518,'tibia.tif',244,8,81,51.364121,21.6109992,19.4946646,1.8,21.6244854,19.4700213,-0.2376481,4.2492651,5.26836,277.3003348,411.4035657,0.474445,78.0894938,65.2584224,130.4277725,8.5047346,10.4587685,0.1188403,31.267047),(24519,'tibia.tif',244,8,82,51.5597097,21.5372087,19.4523632,1.8,21.5416881,19.4300139,-0.2336784,4.2667211,5.2922176,281.3443859,413.9436835,0.4607624,78.2174342,65.9392487,130.839115,8.5266338,10.4971747,0.0813019,31.3766486),(24520,'tibia.tif',244,8,83,51.8468379,21.4677142,19.4079825,1.8,21.47547,19.3838708,-0.2322898,4.2969398,5.3142531,285.8699479,417.7806491,0.4579372,78.615121,66.5287304,131.9831011,8.5614109,10.510898,0.0960003,31.4862501),(24521,'tibia.tif',244,8,84,52.3748026,21.3985139,19.3566243,1.8,21.4089562,19.3288422,-0.2296085,4.3061521,5.3308852,290.473175,422.5855288,0.4521697,79.2711748,67.4553911,133.5346112,8.5930381,10.510898,0.0960003,31.6412502),(24522,'tibia.tif',244,8,85,52.8110245,21.3315373,19.3150058,1.8,21.3449885,19.2920042,-0.2242689,4.3321736,5.3646542,294.8014998,426.7544222,0.4353293,79.5492873,68.0493282,134.2124469,8.6307683,10.5630545,0.0660801,31.7508517),(24523,'tibia.tif',244,8,86,52.9780809,21.2658994,19.2676062,1.8,21.2765443,19.2431347,-0.2236423,4.3574957,5.3838259,298.608838,430.2914126,0.4343103,79.9229799,68.5276271,135.1753239,8.6653486,10.5684549,0.0733973,31.8604533),(24524,'tibia.tif',244,8,87,53.2339771,21.204184,19.2184294,1.8,21.2180475,19.1914419,-0.2216844,4.3714033,5.3922752,303.1812715,434.1584809,0.4289255,80.5148967,69.3555935,136.1974465,8.699929,10.6245695,0.0364802,32.0154533),(24525,'tibia.tif',244,8,88,53.6398351,21.1393372,19.1651149,1.8,21.1554788,19.1339798,-0.2180628,4.3976671,5.4111515,307.885931,438.6778951,0.4184126,81.0692324,70.0111949,137.624998,8.7345093,10.5809505,3.0535853,32.0154533),(24526,'tibia.tif',244,8,89,53.9234019,21.0692492,19.1057987,1.8,21.0884354,19.064255,-0.2154504,4.40033,5.4419151,312.3787396,442.3204876,0.4107621,81.2802995,70.9898431,138.5917128,8.7694831,10.5956991,3.0390128,32.0874455),(24527,'tibia.tif',244,8,90,54.0890153,21.0039682,19.0507166,1.8,21.0277736,19.0128975,-0.2140393,4.4248585,5.4613559,317.0947862,447.6825672,0.4067266,81.972787,71.6621297,139.6439576,8.8042602,10.6516701,3.0614726,32.2612502),(24528,'tibia.tif',244,8,91,54.4835056,20.9398453,18.9890512,1.8,20.9680824,18.939813,-0.2141539,4.4431732,5.4845435,322.2994628,452.3557352,0.4101252,82.4782842,72.5381268,141.1088556,8.8640594,10.6651946,3.0469854,32.3520471),(24529,'tibia.tif',244,8,92,54.5365525,20.872831,18.9347526,1.8,20.8944971,18.9020017,-0.212188,4.4517314,5.4796393,327.4925257,457.2922657,0.4031348,83.4529861,73.5652027,142.7134936,8.8953456,10.7129566,3.0836864,32.4804533),(24530,'tibia.tif',244,8,93,54.6147405,20.806463,18.878467,1.8,20.8213859,18.844555,-0.2076811,4.4750153,5.501879,332.9940554,461.0831725,0.38699,83.8046741,74.4118243,143.9492743,8.9384957,10.7289233,3.0620507,32.5712502),(24531,'tibia.tif',244,8,94,54.7770593,20.7480587,18.8142394,1.8,20.7696256,18.77627,-0.2064096,4.4955219,5.5181791,338.5707329,467.0664992,0.3834693,84.6414175,75.3128863,145.8768504,8.9946091,10.719122,3.0037856,32.6620471),(24532,'tibia.tif',244,8,95,54.9265369,20.6842048,18.7508804,1.8,20.6993422,18.7160823,-0.2010625,4.5240232,5.5382566,344.8279302,472.6130567,0.3651176,85.3360699,76.2215206,147.1740506,9.0437913,10.7579945,3.0333221,32.8624456),(24533,'tibia.tif',244,8,96,55.3166614,20.6266484,18.6843944,1.8,20.648594,18.6458287,-0.1994449,4.5386063,5.5369193,351.5314937,479.4781955,0.3618964,86.5965662,77.4536219,149.8328669,9.0926953,10.7855952,3.0118901,33.0362502),(24534,'tibia.tif',244,8,97,55.5993307,20.5713247,18.615469,1.8,20.6035794,18.5742531,-0.1951879,4.5666608,5.5490803,358.4049551,485.8147254,0.3485794,87.5486934,78.4829383,151.4520013,9.1421557,10.8270031,3.0412118,33.1912502),(24535,'tibia.tif',244,8,98,56.2069299,20.5212359,18.5455946,1.8,20.5633765,18.500797,-0.1939839,4.5945532,5.5541645,366.3630254,494.1492843,0.3481092,88.9691474,79.7385531,154.535668,9.2156508,10.8436327,3.0269891,33.3462503),(24536,'tibia.tif',244,8,99,56.4255509,20.4635791,18.4736364,1.8,20.4944956,18.4275957,-0.1923176,4.6186761,5.5955848,373.9091181,502.1779454,0.3435591,89.7453914,80.9559086,156.2879999,9.2831378,10.8834402,3.0631823,33.5466487),(24537,'tibia.tif',244,8,100,56.3972465,20.4019964,18.4037464,1.8,20.4135589,18.3586043,-0.189191,4.6581094,5.6397616,381.6703493,507.8541684,0.332445,90.0488721,81.9367517,157.2778407,9.354663,10.920628,3.0278006,33.7016487),(24538,'tibia.tif',244,8,101,56.5693743,20.3401615,18.3344294,1.8,20.3254432,18.2952913,-0.1820115,4.7097061,5.6997684,389.7717336,515.2497821,0.3089062,90.3983716,82.7592481,158.296152,9.4118232,10.9494644,3.0067025,33.8112503),(24539,'tibia.tif',244,8,102,56.7419568,20.304019,18.2591817,1.8,20.3059873,18.2208198,-0.1752324,4.7436708,5.7198317,397.9976791,522.1792056,0.28743,91.2927566,83.9007806,160.5775731,9.4855966,10.9713842,2.9927027,34.0570472),(24540,'tibia.tif',244,8,103,57.0451333,20.25756,18.1828593,1.8,20.2506805,18.1447771,-0.1654712,4.7890329,5.7499423,407.0688028,530.1730358,0.2579555,92.204932,85.0002103,162.282308,9.5811289,11.0066379,3.0216044,34.2120472),(24541,'tibia.tif',244,8,104,57.3973864,20.2158888,18.1035663,1.8,20.1971694,18.0676999,-0.151601,4.854011,5.78661,416.6772518,538.6043275,0.2181802,93.0776961,85.8418433,164.8030281,9.6812125,11.0442266,3.0572859,34.4312503),(24542,'tibia.tif',244,8,105,57.6919383,20.1841734,18.0247497,1.8,20.1638468,17.9914831,-0.1414606,4.9052819,5.8140925,426.6353463,546.6083202,0.1911331,94.0143835,86.9746851,167.0158241,9.7749215,11.059715,2.9868123,34.5220472),(24543,'tibia.tif',244,8,106,57.9625589,20.1531037,17.9365873,1.8,20.1317613,17.9062203,-0.12533,4.982548,5.8268278,436.7802493,554.356995,0.1509492,95.1387298,87.6620252,169.711779,9.8876173,11.0930638,3.0155046,34.7412503),(24544,'tibia.tif',244,8,107,58.4669424,20.1149375,17.8420206,1.8,20.0911511,17.7945285,-0.1062025,5.0401138,5.8461567,447.6337002,562.5929626,0.1094952,96.2329606,88.8142058,172.3843908,9.9975006,11.136295,2.9878851,34.7866488),(24545,'tibia.tif',244,8,108,58.5643213,20.0662622,17.7548935,1.8,20.0442225,17.7184546,-0.0915796,5.1214254,5.8871697,458.4672194,568.5398975,0.0816328,96.5727039,89.5194574,173.8749686,10.1319601,11.1516556,3.030168,35.070055),(24546,'tibia.tif',244,8,109,58.7503558,20.0210148,17.6675844,1.8,19.9968475,17.6351779,-0.0760609,5.1661425,5.9175174,470.5902594,574.4059494,0.0565384,97.0687378,91.0912271,176.0172225,10.2300006,11.201365,2.9957817,35.2704535),(24547,'tibia.tif',244,8,110,58.8746375,19.9872268,17.5773966,1.8,19.9709847,17.5518204,-0.0491653,5.2524391,5.9394199,483.0916505,581.1107385,0.0236997,97.8396458,91.9747268,177.9398736,10.3850006,11.2375007,2.9753102,35.4630628),(24548,'tibia.tif',244,8,111,59.1548607,19.9519623,17.47733,1.8,19.9295761,17.4508988,-0.0121861,5.3049685,5.9444169,496.1686737,588.8476198,0.0014639,99.0589372,93.529051,180.4816417,10.4293473,11.2783145,2.9549783,35.6634613),(24549,'tibia.tif',244,8,112,59.4132583,19.9145283,17.3803662,1.8,19.8895712,17.3626859,0.032773,5.4371879,5.9818367,510.1723854,596.7915835,0.0106318,99.7672815,93.8301922,183.45621,10.4334709,11.3343591,2.8999307,35.9280628),(24550,'tibia.tif',244,8,113,59.4860829,19.8845899,17.2869957,1.8,19.8622546,17.2815944,0.0808581,5.5253309,6.032652,523.2794412,604.6060881,0.064679,100.2222713,94.7055398,185.0200444,10.4686415,11.3914462,2.9081646,36.2568675),(24551,'tibia.tif',244,8,114,59.7504494,19.8539009,17.1805738,1.8,19.8390982,17.178001,0.1576153,5.6395186,6.0574932,537.3507055,613.8685577,0.2453508,101.3403627,95.2830813,187.7846118,10.5038121,11.4471993,2.8391117,36.5402737),(24552,'tibia.tif',244,8,115,60.0268096,19.8220921,17.0788878,1.8,19.8060906,17.0727567,0.2418489,5.7379304,6.0837135,551.2741566,623.6480488,0.5738498,102.5110815,96.0754347,190.9042293,10.572776,11.521204,2.8411155,36.6952737),(24553,'tibia.tif',244,8,116,60.1828235,19.803915,16.9772305,1.8,19.793923,16.9765514,0.3272412,5.7922832,6.032226,563.6129562,635.5170031,1.0363325,105.3536468,97.3041093,193.9705345,10.6079466,11.6087143,2.5702552,36.97868),(24554,'tibia.tif',244,8,117,60.5833985,19.7834509,16.876021,1.8,19.7695141,16.8713352,0.4073402,5.8246265,5.9992148,576.4139996,649.1338885,1.5847563,108.2031409,98.9615378,195.6707936,10.6627615,11.6870932,2.5020703,37.3074846),(24555,'tibia.tif',244,8,118,61.0345813,19.7676346,16.7792228,1.8,19.7549873,16.7836611,0.4899142,5.812244,5.9445651,589.1745464,665.9879441,2.2523538,112.0330802,101.3678273,199.4687974,10.6864789,11.8006323,2.557233,37.5266877),(24556,'tibia.tif',244,8,119,61.4900598,19.749325,16.6779764,1.8,19.7294753,16.6831118,0.5799041,5.7896363,5.9142896,600.5448607,683.8313893,3.0769867,115.6235893,103.727562,201.5696377,10.7129939,11.8921478,2.5228583,37.8554924),(24557,'tibia.tif',244,8,120,61.8823899,19.7346715,16.5763698,1.8,19.7170408,16.5819359,0.6483849,5.7687795,6.0734201,612.5228024,701.9351389,3.7613672,115.5749362,106.1789242,204.4182577,10.7427523,12.0147505,1.7327637,38.1388986),(24558,'tibia.tif',244,8,121,62.3329156,19.7248884,16.4689329,1.8,19.6987239,16.4764704,0.7136588,5.7484086,6.2161544,624.153887,722.038352,4.4516773,116.1551513,108.5785529,205.7692708,10.7693941,12.2209423,1.7557547,38.4223049),(24559,'tibia.tif',244,8,122,62.9096375,19.721128,16.3615751,1.8,19.6968636,16.3719516,0.7770518,5.7298361,6.3787268,636.0761993,744.0160882,5.1549623,116.6402177,111.0112372,206.6373206,10.7921721,12.4225038,1.7400475,38.8153126),(24560,'tibia.tif',244,8,123,63.2616047,19.7271602,16.2529224,1.8,19.7015944,16.2543444,0.827003,5.7220886,6.5598076,645.7942384,768.2488521,5.7099592,117.1145403,112.8598801,207.8183819,10.816804,12.6517423,1.7369521,39.1441173),(24561,'tibia.tif',244,8,124,63.6965228,19.730608,16.1498714,1.8,19.6986037,16.1545264,0.8709273,5.7159247,6.7509777,656.5846003,795.3659617,6.2116067,117.8149291,114.869358,207.5318898,10.8414359,12.9220655,1.7152379,39.6013282),(24562,'tibia.tif',244,8,125,63.8730239,19.7493199,16.0356892,1.8,19.7255707,16.0304377,0.9177936,5.7227787,6.9610076,664.3503494,824.3838471,6.7157555,118.4288092,116.0887715,207.2132046,10.8797301,13.1995955,1.735945,40.1039375),(24563,'tibia.tif',244,8,126,64.0431064,19.7676411,15.9163215,1.8,19.7604508,15.9121254,0.970694,5.7007919,7.230671,670.7539035,855.4479999,7.2697841,118.3082452,117.6597763,205.8973795,10.937347,13.5181426,1.73783,40.4781407),(24564,'tibia.tif',244,8,127,64.4943053,19.7730385,15.7873509,1.8,19.7596912,15.7727733,1.0126742,5.8295299,7.4956187,678.9981598,894.3773486,7.7342641,119.3200172,116.4756289,205.4972364,10.9943149,13.8761805,1.7221718,41.0449531),(24565,'tibia.tif',244,8,128,64.8027606,19.7764457,15.6358761,1.8,19.7618141,15.6011469,1.0440607,5.9347109,7.746658,685.5802444,937.2735257,8.0709519,120.9906937,115.5204115,205.3662984,11.0576776,14.1827126,1.7188757,41.6837578),(24566,'tibia.tif',244,8,129,65.3896189,19.7936208,15.493178,1.8,19.784757,15.454126,1.0719944,6.0325826,8.1370883,694.9210611,988.4704448,8.4042937,121.4771681,115.1946196,202.417969,11.1694312,14.7086761,1.7082225,42.6325625),(24567,'tibia.tif',244,8,130,65.9237016,19.8106286,15.3396231,1.8,19.7960598,15.2897913,1.1015635,6.1407077,8.4976561,704.5975204,1047.5370535,8.7405292,123.2736458,114.7420714,200.2908015,11.2795899,15.2769397,1.677532,43.8913672),(24568,'tibia.tif',244,8,131,66.4361699,19.8351761,15.1628028,1.8,19.8177121,15.0872018,1.1376842,6.2641591,9.0114052,714.7032107,1118.3653957,9.1222835,124.105549,114.0940379,199.1875115,11.4216415,15.833158,1.6836157,45.2221642),(24569,'tibia.tif',244,8,132,66.7877389,19.8850869,15.0230473,1.8,19.8765299,14.9408497,1.1571677,6.3268781,9.1198977,725.9833159,1170.7855841,9.333014,128.3770526,114.7458996,203.6447088,11.5892388,16.0400672,1.6675804,46.2805705),(24570,'tibia.tif',244,8,133,67.2763639,19.9415559,14.936337,1.8,19.9257961,14.8514882,1.1583196,6.323946,9.1139064,739.5037572,1198.6984707,9.4107923,131.5241141,116.9370759,208.0434714,11.6510028,16.0965103,1.652738,46.6281798),(24571,'tibia.tif',244,8,134,67.5631336,19.9977128,14.8475427,1.8,20.0001381,14.772508,1.1626005,6.3634412,9.1743855,754.5927056,1232.4899719,9.4861737,134.3403295,118.5824904,211.9121536,11.7306649,16.1871149,1.6618897,47.312383),(24572,'tibia.tif',244,8,135,67.9276549,20.0543727,14.7767209,1.8,20.0539946,14.7126435,1.1647919,6.4237763,9.2477157,770.0437667,1257.0523847,9.5553953,135.9311231,119.8740001,214.3861396,11.7912073,16.3282413,1.6515726,47.7961877),(24573,'tibia.tif',244,8,136,68.225306,20.1209266,14.7083639,1.8,20.1318783,14.6289655,1.1722723,6.4637789,9.2776543,785.1685485,1286.2252134,9.6585501,138.6368984,121.4720606,217.8189253,11.8778906,16.4054898,1.6511914,48.1891954),(24574,'tibia.tif',244,8,137,68.3754039,20.1681905,14.6648368,1.8,20.1818723,14.5724954,1.1805156,6.503784,9.3439503,797.9549808,1305.6378788,9.7464497,139.7308245,122.6908807,219.9020368,11.9465886,16.5294993,1.6223937,48.298797),(24575,'tibia.tif',244,8,138,68.1263291,20.2171235,14.6304766,1.8,20.2247894,14.5482295,1.1871453,6.5694483,9.4151957,808.4660578,1311.4751943,9.7635599,139.2934616,123.0645285,219.9285199,11.9953609,16.6155745,1.6314694,48.453797),(24576,'tibia.tif',244,8,139,67.7370212,20.2861802,14.5769026,1.8,20.3072965,14.4892769,1.1922652,6.6035715,9.4733227,817.3505221,1317.9442093,9.7476774,139.1216417,123.7740087,219.5416223,12.0366062,16.7616942,1.6216783,48.4726017),(24577,'tibia.tif',244,8,140,67.2556662,20.3698975,14.5375155,1.8,20.4031577,14.4449273,1.1900946,6.604632,9.5350095,827.8704686,1320.6094387,9.6616604,138.5011135,125.3469486,219.7562219,12.0848511,16.8390943,1.6214442,48.6541955),(24578,'tibia.tif',244,8,141,66.8275986,20.4575065,14.5597541,1.8,20.4885964,14.5124273,1.1802499,6.6126492,9.5081897,838.4497174,1305.8782392,9.5237375,137.3424681,126.7948279,219.0712744,12.1014157,16.8353487,1.524746,48.4991955),(24579,'tibia.tif',244,8,142,66.2797021,20.5565546,14.5308885,1.8,20.5992998,14.478542,1.1624652,6.5491131,9.4781807,846.1452123,1298.858622,9.3048847,137.0367014,129.1999691,219.4346337,12.1645909,16.8390943,1.5201484,48.5633986),(24580,'tibia.tif',244,8,143,65.9712281,20.6454987,14.4796792,1.8,20.6811304,14.4425636,1.1618039,6.5561851,9.5266247,854.5042161,1309.4317174,9.2562759,137.4497007,130.3355845,220.2506572,12.2104168,16.9788697,1.5434059,48.7826017),(24581,'tibia.tif',244,8,144,65.9119981,20.7560759,14.4189413,1.8,20.8113378,14.3820189,1.1577625,6.5487174,9.5552418,863.3517982,1334.4252369,9.2154442,139.6537379,131.8352504,222.5094792,12.2706457,17.0642621,1.6116826,49.0926017),(24582,'tibia.tif',244,8,145,65.6915822,20.8617055,14.3863718,1.8,20.9049004,14.3630136,1.1622203,6.5663971,9.6179914,872.3466968,1356.500544,9.220365,141.0378204,132.8501291,224.549915,12.3164716,17.2224472,1.6158109,49.2664064),(24583,'tibia.tif',244,8,146,65.6966762,20.9587803,14.3302802,1.8,21.0050664,14.3102353,1.1590619,6.585256,9.638162,884.2061477,1385.5514389,9.1957877,143.7568119,134.2705798,228.1173681,12.4019031,17.3035141,1.6200837,49.6218048),(24584,'tibia.tif',244,8,147,65.6097917,21.0549605,14.2683539,1.8,21.1057837,14.2303447,1.163897,6.6331286,9.68075,895.7390763,1415.4528792,9.2222336,146.2131419,135.0402092,230.6020807,12.4761975,17.4547148,1.6152115,50.0602111),(24585,'tibia.tif',244,8,148,65.5493016,21.1698424,14.2231403,1.8,21.2184522,14.1791075,1.1630019,6.6582401,9.753773,914.0177514,1451.4109643,9.2066164,148.8050788,137.276177,234.0466108,12.5752957,17.4583275,1.6196463,50.5518049),(24586,'tibia.tif',244,8,149,65.5249398,21.2772535,14.1715795,1.8,21.3127897,14.0965147,1.1630893,6.6915316,9.7993399,938.1844334,1490.5740346,9.2038897,152.1096364,140.2047387,238.0194214,12.7097188,17.6095633,1.6148207,51.0356096),(24587,'tibia.tif',244,8,150,65.4808836,21.375019,14.1313053,1.8,21.3966017,14.042318,1.1569347,6.7407082,9.826013,965.0504354,1528.2715648,9.14852,155.5332331,143.1675139,243.1974134,12.8432028,17.5485751,1.5089285,51.5726019),(24588,'tibia.tif',244,8,151,65.5604974,21.4764491,14.0954783,1.8,21.487419,14.0126323,1.1509871,6.8262661,9.8584531,998.5542964,1576.2416157,9.1115262,159.887317,146.281185,248.6303455,12.9669913,17.6944579,1.5182133,52.3476019),(24589,'tibia.tif',244,8,152,65.8463888,21.5927268,14.031428,1.8,21.6017669,13.9224705,1.1358264,6.8683641,9.8789743,1037.3218968,1646.7744113,9.0257428,166.6948777,151.0289623,259.1407421,13.1365406,17.7907672,1.5010407,53.0772035),(24590,'tibia.tif',244,8,153,66.4432581,21.7093701,13.987077,1.8,21.7025263,13.8394604,1.1174667,7.0075724,9.9129819,1086.186699,1724.3772401,8.9497954,173.9514154,155.0018519,269.4866215,13.3222233,17.9629564,1.48873,53.9806098),(24591,'tibia.tif',244,8,154,66.8609732,21.8780016,13.9620853,1.8,21.8651055,13.7968151,1.0948162,7.2225518,9.9728369,1139.6450283,1814.3848914,8.8038487,181.9326742,157.7898039,280.2297201,13.5070262,18.1885758,1.4940244,55.2206098),(24592,'tibia.tif',244,8,155,67.5691599,22.0771973,13.9803434,1.8,22.0558645,13.8204696,1.0728196,7.4759617,10.1006705,1203.545062,1923.2047157,8.6922255,190.4036692,160.9886617,291.1989954,13.7566524,18.432786,1.4866076,56.4982192),(24593,'tibia.tif',244,8,156,68.3032974,22.2758047,14.0149133,1.8,22.2593098,13.8465837,1.0553143,7.6992251,10.2724942,1272.9256333,2034.4781166,8.6175542,198.0510352,165.3316567,302.2799656,14.047941,18.7006404,1.5210449,57.912024),(24594,'tibia.tif',244,8,157,69.1097379,22.4782937,14.0082174,1.8,22.4481165,13.8339177,1.0233951,7.98676,10.3710789,1358.6718398,2176.0932272,8.3981121,209.8232253,170.1155205,318.8954523,14.3427207,19.3424238,2.2824647,59.6468442),(24595,'tibia.tif',244,8,158,71.0800149,22.7122603,14.097378,1.8,22.7073387,13.9104158,0.994012,8.2871914,10.5215783,1473.3176053,2369.1552987,8.3236328,225.1710941,177.7825009,342.1379063,14.6895688,20.1584947,2.2881797,61.5444537),(24596,'tibia.tif',244,8,159,74.2530157,22.9704318,14.1209287,1.8,23.075912,14.0785524,0.9681977,8.6380786,10.7385813,1623.8187237,2665.8860431,8.3999275,248.253094,187.9837869,367.9311764,15.1379709,21.2521067,2.2916846,64.054274),(24597,'tibia.tif',244,8,160,78.0226754,23.2867478,14.1392771,1.8,23.4478919,14.2186299,0.9080254,9.1318663,13.239337,1798.3577301,3092.3919741,8.0805694,233.5760445,196.9321143,352.3474124,15.6679983,22.7322192,2.2934749,67.4221021),(24598,'tibia.tif',244,8,161,83.1449479,23.9581913,14.4583716,1.8,24.2629904,14.6545196,0.7973432,9.626835,14.0676725,1994.5680622,3917.6663278,7.0942582,278.4871712,207.1883494,411.470181,16.4482451,25.3712811,2.2913505,75.2427584),(24599,'tibia.tif',244,8,162,85.4624912,24.1169475,14.555149,1.8,24.6148065,14.8253515,0.7811886,9.8870774,14.2616559,2195.0308467,4147.6921872,7.0619152,290.828233,222.0100794,431.8422549,17.3718469,25.6582374,2.3262889,78.3427586),(24600,'tibia.tif',244,8,163,92.7876571,24.8172836,14.9040534,1.8,25.2580093,15.1137271,0.6143015,10.1870914,14.2565163,2593.6864639,4947.9250932,5.1376991,347.0641076,254.605201,506.9118427,18.4592202,25.6392693,2.4847912,81.4647899),(24601,'tibia.tif',244,8,164,97.8804251,24.8361265,15.1743772,1.8,25.2136837,15.3042909,0.6414407,10.3385784,13.7387441,2903.229877,5059.3747686,5.8405764,368.2559879,280.815192,544.7207883,18.9459632,25.445153,2.4316449,81.106165),(24602,'tibia.tif',244,8,165,103.3096429,24.8736562,15.5226061,1.8,25.0819606,15.4816127,0.5824103,10.3936438,13.3840315,3236.0182193,5048.9826496,5.209256,377.2392982,311.3458854,588.5515652,19.4133887,25.0949276,2.4480406,80.7695712),(24603,'tibia.tif',244,8,166,110.813328,24.8621476,15.7571046,1.8,24.951201,15.6278088,0.4746723,10.8789731,13.1156158,3567.8582635,5056.4509693,3.8580021,385.5290561,327.9591044,638.8598379,20.0559953,24.6057328,2.423059,79.7831572),(24604,'tibia.tif',244,8,167,120.3112326,24.8983148,15.8809903,1.8,24.7230739,15.7690964,0.1767925,12.2863884,12.9341986,3948.248535,5131.4161457,0.6202306,396.7324395,321.351434,675.7863198,21.2246022,23.9770787,2.4638229,79.7501106),(24605,'tibia.tif',244,8,168,123.9259011,24.7458001,15.7257506,1.8,24.3968906,15.5800762,-0.1132867,12.7789276,12.4644412,3872.7132828,5174.1205316,0.263943,415.1105101,303.0546377,685.9499121,20.673851,23.7110755,0.1608499,80.9589541),(24606,'tibia.tif',244,8,169,126.4793272,24.4040913,15.7411181,1.8,24.1869783,15.4117433,-0.3348685,12.3503825,12.1834258,3557.1124701,5396.2849841,2.2767859,442.9201653,288.0163814,685.2100266,19.7800406,24.0255015,0.227766,81.3020007),(24607,'tibia.tif',244,8,170,124.4035228,23.8807586,15.6488926,1.8,23.7931719,15.2094917,-0.4230044,11.5186821,12.0934853,2982.6467769,5339.1217577,3.4939104,441.4874325,258.9399344,646.4602024,18.9482828,23.7318378,0.3744422,79.1508052),(24608,'tibia.tif',244,8,171,117.8932654,23.2073489,15.4382683,1.8,23.0175998,15.0429839,-0.5826348,10.6404643,11.5236121,2448.2150672,4338.8370703,5.9486699,376.5171037,230.0853609,558.1893318,17.9137162,22.9946576,0.5496678,74.2563444),(24609,'tibia.tif',244,8,172,107.5304914,22.1371151,15.5153874,1.8,22.0448947,15.0944901,-0.8079538,8.881582,11.0250221,1775.7534999,2827.3056785,9.3649737,256.4444454,199.9366219,412.7533421,15.579238,20.9973531,1.1848068,65.8014462),(24610,'tibia.tif',244,8,173,94.5009228,21.8281289,15.6510013,1.8,21.8538332,15.2768099,-0.7915217,8.3937432,9.7968073,1177.6953683,1810.2626576,7.9715207,184.7808791,140.3063381,299.8641654,14.5918529,18.8758258,0.963434,62.0905715),(24611,'tibia.tif',244,8,174,57.8020108,22.2347791,15.4757162,1.8,22.086833,15.1136691,1.4204536,7.9556792,9.1722043,484.4176511,812.8334856,9.4175551,88.6192084,60.8895408,141.4084603,13.154405,15.5019383,2.1352249,64.8169221),(24612,'tibia.tif',244,8,175,16.9615484,21.6577634,14.4627204,1.8,21.6793306,13.950641,1.4914304,5.6531386,7.2193655,18.6402403,315.1577332,2.8091554,43.654492,3.2973259,46.2112291,0,0,0,0),(24613,'tibia.tif',244,8,176,1.2018502,22.03631,18.1766524,1.8,21.9639857,17.6212945,1.4359632,0.7116403,9.4934671,0.121627,5.0571454,0.1966888,0.5326974,0.1709108,0.5454856,0.9690501,2.3621615,2.2865399,5.4126484),(24614,'tibia.tif',244,8,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24615,'tibia.tif',244,8,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24616,'tibia.tif',244,8,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24617,'tibia.tif',244,8,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24618,'tibia.tif',244,8,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24619,'tibia.tif',244,8,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24620,'tibia.tif',244,8,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24621,'tibia.tif',244,8,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24622,'tibia.tif',244,8,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24623,'tibia.tif',244,8,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24624,'tibia.tif',244,8,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24625,'tibia.tif',244,8,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24626,'tibia.tif',244,8,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24627,'tibia.tif',244,8,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24628,'mt.tif',244,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24629,'mt.tif',244,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24630,'mt.tif',244,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24631,'mt.tif',244,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24632,'mt.tif',244,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24633,'mt.tif',244,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24634,'mt.tif',244,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24635,'mt.tif',244,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24636,'mt.tif',244,10,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24637,'mt.tif',244,10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24638,'mt.tif',244,10,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24639,'mt.tif',244,10,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24640,'mt.tif',244,10,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24641,'mt.tif',244,10,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24642,'mt.tif',244,10,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24643,'mt.tif',244,10,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24644,'mt.tif',244,10,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24645,'mt.tif',244,10,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24646,'mt.tif',244,10,19,6.5757846,13.0781548,19.9777465,1.8,12.8457272,19.9518893,0.1012451,1.9461554,4.7070274,3.8288985,21.1376066,0.0111959,4.4906487,1.9674166,5.2483317,0.775,2.1153385,1.423718,4.9178282),(24647,'mt.tif',244,10,20,26.3918618,12.3968258,19.9304746,1.8,12.4937603,19.8984472,0.0794782,3.0220412,5.2431932,48.3943392,190.9597652,0.0277268,36.4205092,16.013792,44.9844195,3.0525502,5.9088354,1.8635094,15.7366723),(24648,'mt.tif',244,10,21,39.9456047,11.880395,19.8246148,1.8,11.8632101,19.7670247,0.1175838,3.6418712,6.392092,115.6216799,455.8932686,0.0916242,71.3214501,31.7478776,86.3160086,5.7007596,7.3787982,2.1995926,23.9237426),(24649,'mt.tif',244,10,22,43.8478423,11.6529573,19.8076659,1.8,11.6979518,19.7405336,0.1293666,4.029431,6.2989452,176.7950236,539.7126331,0.1216233,85.6830181,43.8759281,104.8965448,5.794476,8.2674744,2.1015698,25.2921489),(24650,'mt.tif',244,10,23,42.5217702,11.568446,19.7701105,1.8,11.5877437,19.663344,0.1160894,4.1915984,6.4869208,203.725431,529.8856409,0.095081,81.6852337,48.60328,104.8414351,5.6575004,8.5619093,2.0506369,25.511352),(24651,'mt.tif',244,10,24,39.5104885,11.6029886,19.7886457,1.8,11.6178383,19.685134,0.1154188,4.1488613,6.3929491,194.8626432,468.4297212,0.0873343,73.2728686,46.9677414,96.7955769,5.3475003,8.5619093,2.0506369,25.0917505),(24652,'mt.tif',244,10,25,36.9827366,11.5415991,19.9684812,1.8,11.5104443,19.9417603,0.1435361,3.9373894,6.2642283,162.0706618,396.4551419,0.1261205,63.2887443,41.161959,83.8872119,7.8114806,12.3597323,2.8555412,47.5595163),(24653,'mt.tif',244,10,26,34.9948824,11.5739686,20.1938781,1.8,11.5463055,20.2201889,0.1310575,3.7898474,6.2947226,140.2171698,362.5969112,0.0996068,57.6033186,36.9981046,76.9603033,7.3282923,12.3738169,2.9269998,36.6012505),(24654,'mt.tif',244,10,27,36.8732377,11.5326215,20.2965701,1.8,11.5159094,20.3810625,0.1547968,3.9612606,6.323792,148.4227394,420.6149391,0.1460872,66.5130892,37.4685618,87.0535007,7.3541811,12.5753161,2.9744176,36.2082427),(24655,'mt.tif',244,10,28,45.7855113,11.4849412,20.3386273,1.8,11.542929,20.4283014,0.1459968,3.9943491,6.3872458,175.4253801,534.420457,0.1615012,83.6699373,43.91839,107.7044109,7.4321127,12.6922674,2.95737,36.0234225),(24656,'mt.tif',244,10,29,43.367804,11.5119543,20.3160998,1.8,11.5285491,20.4149946,0.1634886,4.1101114,6.3733997,175.6834249,534.5485964,0.1914777,83.8718149,42.7442002,108.6748832,7.5337275,12.7215733,2.9453918,35.9138209),(24657,'mt.tif',244,10,30,36.7303436,11.5037633,20.3231806,1.8,11.5418698,20.4287909,0.1828819,4.1003626,6.2511166,165.4029932,487.0307667,0.2024734,77.9110029,40.3386259,102.1924908,7.5694498,12.4661835,2.8709786,35.2108131),(24658,'mt.tif',244,10,31,34.2647554,11.4916284,20.3966014,1.8,11.5395494,20.4987233,0.1700066,4.0318055,6.0169396,161.340168,450.0813588,0.1634707,74.8023724,40.0168527,98.6729036,7.5491967,12.1832867,2.7977129,33.8690007),(24659,'mt.tif',244,10,32,33.5274513,11.5641545,20.5234159,1.8,11.5664945,20.5818404,0.1715624,3.9202668,5.909015,160.9980022,415.6531158,0.1628651,70.3422007,41.0681239,95.2357357,7.5110857,11.7955415,2.8551704,33.0297975),(24660,'mt.tif',244,10,33,32.9782371,11.543712,20.5953631,1.8,11.5317224,20.6145517,0.1759907,3.8440388,5.6868285,160.3852833,382.8351046,0.1684873,67.3196151,41.7231182,93.4555975,7.5053081,11.3378031,2.8717435,32.1075866),(24661,'mt.tif',244,10,34,32.6050515,11.5312113,20.5706243,1.8,11.52055,20.5651402,0.1798298,3.860181,5.5075983,159.7240941,358.5781178,0.1738483,65.1060763,41.3773584,92.2637489,7.5602811,11.0393309,2.8642573,31.5517897),(24662,'mt.tif',244,10,35,32.6218903,11.5275258,20.5403935,1.8,11.5239417,20.5235847,0.1782065,3.8958289,5.3521442,158.7201584,340.3571714,0.1708451,63.5926754,40.7410493,91.7846091,7.5472653,10.7535271,2.9823681,31.6270083),(24663,'mt.tif',244,10,36,32.4132938,11.5443052,20.4655965,1.8,11.5454855,20.4336996,0.1810388,3.9869946,5.2600253,156.4068334,325.5293474,0.1751319,61.8874109,39.2292568,90.6408259,7.5981239,10.550253,2.9643673,35.259438),(24664,'mt.tif',244,10,37,32.1552451,11.5555794,20.4357547,1.8,11.5560088,20.4035544,0.1783393,4.0175625,5.1599453,154.3979133,306.1287689,0.1686496,59.32791,38.4307434,88.1598619,7.6280124,10.3658973,2.9383321,33.8268286),(24665,'mt.tif',244,10,38,31.654499,11.5813288,20.4476079,1.8,11.5802007,20.4137445,0.172788,3.9854946,5.094156,150.5425237,287.6890431,0.1559498,56.4743287,37.7726071,85.0533707,7.5964985,10.1835124,2.9501672,32.6776254),(24666,'mt.tif',244,10,39,31.1814415,11.5888598,20.4350476,1.8,11.5898272,20.402101,0.1697466,3.9577949,5.0081511,145.158189,270.9754761,0.1483105,54.1068888,36.6765314,82.1387226,7.5741455,10.0026059,2.9624322,31.6568284),(24667,'mt.tif',244,10,40,30.7947893,11.5907698,20.4175068,1.8,11.5904819,20.3843832,0.1630953,3.9209327,4.9144852,139.9756634,257.087802,0.1353177,52.3122551,35.6995832,79.7472135,7.4976766,9.8232594,2.975147,30.4622268),(24668,'mt.tif',244,10,41,30.771481,11.5909268,20.3911682,1.8,11.5905039,20.3556945,0.1569162,3.8784115,4.8027922,136.6101325,245.302653,0.1252464,51.0750084,35.2232173,78.2752922,7.4212213,9.6362148,2.9473517,29.7780237),(24669,'mt.tif',244,10,42,30.6700366,11.5948558,20.3654832,1.8,11.5939595,20.3336597,0.1473212,3.8315996,4.7181766,133.0604581,236.0500216,0.1101411,50.0299249,34.7271302,76.878232,7.3130192,9.4841769,2.9441971,29.0296174),(24670,'mt.tif',244,10,43,30.6282916,11.5957431,20.3375856,1.8,11.5943323,20.3041465,0.1397408,3.8201115,4.6399013,130.7837141,228.1669256,0.0990352,49.1749527,34.2355755,75.7344977,7.2850005,9.3650026,2.9669205,28.5458127),(24671,'mt.tif',244,10,44,30.6016447,11.6106557,20.2903191,1.8,11.6060357,20.2530005,0.1295608,3.7948965,4.5703244,129.9452324,221.3580586,0.0851353,48.4337739,34.2421019,75.1780339,7.2075005,9.2410429,2.9474866,28.062008),(24672,'mt.tif',244,10,45,30.4504155,11.6187241,20.2570424,1.8,11.6192561,20.2185827,0.1210967,3.7542596,4.5323147,128.5565202,215.1129068,0.0740599,47.4620409,34.2428425,74.2924773,7.1300004,9.1518942,3.0056836,27.752008),(24673,'mt.tif',244,10,46,30.2079297,11.6237354,20.2270526,1.8,11.6234988,20.1899674,0.1120881,3.7499765,4.4767691,127.0907666,209.1352282,0.0629896,46.7156616,33.8910838,73.2596422,7.1300004,9.0618685,2.9173579,27.5140003),(24674,'mt.tif',244,10,47,29.835854,11.6186478,20.199313,1.8,11.6192685,20.1608723,0.1041307,3.7100093,4.4361321,125.7160112,202.6445458,0.0537248,45.6804575,33.8856322,72.4543513,7.1300004,8.9568684,2.976444,27.4043987),(24675,'mt.tif',244,10,48,29.4651807,11.6144243,20.1714889,1.8,11.6161491,20.131928,0.0895039,3.7094825,4.3615162,124.493971,196.8516684,0.0392358,45.1337698,33.5610075,71.5960478,7.1300004,8.8611351,2.9390513,27.1663909),(24676,'mt.tif',244,10,49,29.397613,11.6207807,20.134233,1.8,11.6244916,20.099018,0.0708912,3.6647966,4.3344257,124.2881364,193.1569839,0.024582,44.5634548,33.9140614,71.4822793,7.0525004,8.77942,2.9909567,27.0113909),(24677,'mt.tif',244,10,50,29.4305502,11.6305924,20.0891514,1.8,11.6329145,20.0522833,0.0540347,3.6794592,4.3229975,124.3003313,190.7224779,0.0143077,44.1181093,33.7822287,71.2403793,7.1300004,8.7255507,2.9267773,26.9017894),(24678,'mt.tif',244,10,51,29.5752114,11.6459216,20.0539372,1.8,11.6459307,20.0178852,0.0391301,3.6301484,4.3134676,124.0620146,189.4739323,0.0075435,43.9261283,34.1754663,71.0558764,7.0525004,8.6914105,2.9984346,26.7279847),(24679,'mt.tif',244,10,52,29.8523859,11.6543397,20.0204339,1.8,11.6540155,19.9871476,0.0331434,3.5899587,4.3074512,124.6412639,189.0263551,0.0054634,43.8835746,34.7194145,71.5650931,7.0525004,8.6806925,3.0072712,26.7921878),(24680,'mt.tif',244,10,53,29.9384009,11.6526156,19.9911393,1.8,11.6538332,19.9596934,0.0306993,3.6132259,4.3080932,124.9118001,187.7791245,0.0047011,43.5875258,34.5707143,71.7270269,7.0525004,8.6612974,3.0250066,26.6371878),(24681,'mt.tif',244,10,54,30.1362477,11.6463326,19.9688272,1.8,11.6424972,19.9411826,0.025391,3.6975471,4.2503038,125.5899625,187.3127414,0.0032374,44.0704362,33.9657501,72.2900541,7.2075005,8.6512364,2.970553,26.8109925),(24682,'mt.tif',244,10,55,30.2388008,11.6452504,19.9489577,1.8,11.647838,19.9251861,0.0194317,3.7108288,4.2468619,126.1811913,186.191261,0.0019027,43.8420803,34.0035061,72.5567544,7.2075005,8.6038968,3.0060649,26.7279847),(24683,'mt.tif',244,10,56,30.5666752,11.6449311,19.9303018,1.8,11.6475232,19.9028978,0.0143452,3.7237798,4.2452849,127.5165897,185.7934795,0.0010483,43.7646668,34.2438587,73.0070382,7.270788,8.5748774,2.9690147,26.6559924),(24684,'mt.tif',244,10,57,30.6139214,11.6466608,19.9166841,1.8,11.6499986,19.893568,0.0032912,3.6479602,4.241075,127.797429,185.018546,0.0000553,43.6253892,35.0325724,73.274047,7.2075005,8.5418929,2.9406384,26.5917893),(24685,'mt.tif',244,10,58,30.7317494,11.653302,19.8976765,1.8,11.6612014,19.8661521,-0.0050471,3.6578329,4.2356096,128.4701577,184.0338511,0.0001305,43.4492002,35.121932,73.5037491,7.2850005,8.498539,2.9674487,26.5463909),(24686,'mt.tif',244,10,59,30.7639083,11.6546513,19.8826608,1.8,11.6609944,19.861904,-0.0121651,3.6653946,4.1631033,129.0132318,182.4862826,0.0007588,43.8341949,35.1976377,73.2612034,7.2850005,8.4506995,2.9477942,27.0567894),(24687,'mt.tif',244,10,60,30.7632272,11.6637693,19.8554796,1.8,11.6686407,19.8324544,-0.0212189,3.6089394,4.1571371,129.3568569,181.461803,0.0023081,43.6506658,35.8434547,73.0153299,7.2811739,8.422935,2.9189317,27.1021878),(24688,'mt.tif',244,10,61,30.8003571,11.6746221,19.8221438,1.8,11.6823459,19.8010227,-0.0264345,3.6331861,4.1478011,130.0986509,180.5184791,0.0035863,43.5214889,35.8084193,72.9269125,7.2850005,8.3965095,2.9840311,26.39918),(24689,'mt.tif',244,10,62,30.8939362,11.6868333,19.781042,1.8,11.6929641,19.7559021,-0.0383439,3.6607174,4.1416442,130.8496353,179.9652502,0.0075666,43.4526103,35.7442601,72.94466,7.3210579,8.3735877,3.0023134,26.9017894),(24690,'mt.tif',244,10,63,30.9839198,11.6981503,19.7421227,1.8,11.7083571,19.7167356,-0.0480662,3.6178966,4.1321884,131.9975426,178.9888857,0.0119215,43.3157609,36.4846085,73.1079862,7.2850005,8.3362054,3.0391488,26.2895785),(24691,'mt.tif',244,10,64,31.1295172,11.7040334,19.7068834,1.8,11.7141797,19.6827214,-0.0625077,3.6477498,4.1235217,133.483172,178.4371324,0.0202452,43.2729948,36.5932914,73.2070773,7.3501722,8.3080584,0.6397698,26.6371878),(24692,'mt.tif',244,10,65,31.2526933,11.7121659,19.678231,1.8,11.7254701,19.6573236,-0.0684101,3.6459254,4.1142754,134.3130258,177.5762931,0.0243388,43.1610126,36.8392136,73.3735342,7.2850005,8.2982929,0.6061353,26.3349769),(24693,'mt.tif',244,10,66,31.5118515,11.7144566,19.6455614,1.8,11.7278673,19.6252578,-0.0815045,3.6804074,4.103976,135.5792808,177.9740237,0.0348116,43.3662434,36.8381177,73.5561155,7.3501722,8.3156458,0.6863852,26.39918),(24694,'mt.tif',244,10,67,31.8439476,11.7249731,19.6139453,1.8,11.7413684,19.5965027,-0.102651,3.7193954,4.0959507,137.1081849,178.8201717,0.0557283,43.6577945,36.8630301,73.7535779,7.3790905,8.3649759,0.8772443,26.39918),(24695,'mt.tif',244,10,68,32.1367878,11.7377899,19.5761877,1.8,11.7555489,19.556344,-0.1190374,3.7462843,4.0856932,138.9404143,179.6586822,0.075538,43.9726316,37.0875254,73.4390062,7.3625005,8.4506995,0.8372996,26.5353754),(24696,'mt.tif',244,10,69,32.4536678,11.7509331,19.5402754,1.8,11.7727515,19.5166939,-0.1253978,3.7755434,4.0769454,140.7283187,180.707168,0.0846087,44.3241566,37.2736595,74.6039792,7.4263149,8.4361167,0.8960554,26.4257738),(24697,'mt.tif',244,10,70,32.706692,11.7542625,19.5110214,1.8,11.7700881,19.4930332,-0.1404866,3.801256,4.0782352,142.3204693,181.8316715,0.1068799,44.5858718,37.4403797,74.675447,7.4400005,8.4741214,0.8760581,26.7279847),(24698,'mt.tif',244,10,71,32.9235216,11.7608345,19.478392,1.8,11.7722788,19.4611166,-0.1466183,3.8300325,4.0887604,144.0539036,182.8815891,0.1171163,44.7278815,37.611666,74.8132436,7.4400005,8.5154839,0.8562471,26.5807738),(24699,'mt.tif',244,10,72,33.2708735,11.7841173,19.4452223,1.8,11.7993568,19.4256675,-0.1681885,3.8685944,4.0716444,145.8617896,184.4000105,0.1553841,45.2888294,37.7040795,75.2618006,7.5032372,8.5450565,0.894639,26.6903754),(24700,'mt.tif',244,10,73,33.6148173,11.7960484,19.4130026,1.8,11.808145,19.3985027,-0.1821612,3.8892643,4.0807797,147.697853,186.1232689,0.1838578,45.6097322,37.9757816,75.6129279,7.4400005,8.5937686,0.8876049,26.7357738),(24701,'mt.tif',244,10,74,33.8078903,11.8179942,19.3732483,1.8,11.831339,19.3552864,-0.2047701,3.9319527,4.0687527,149.3305958,187.3896532,0.2329815,46.0557985,37.9787367,76.0142032,7.5175005,8.6188926,0.9129077,26.7811723),(24702,'mt.tif',244,10,75,34.1599014,11.8235178,19.3335059,1.8,11.8311942,19.3185242,-0.2222352,3.9636167,4.0940951,151.6718459,189.2930626,0.2765856,46.2356287,38.2660228,76.5299247,7.5856129,8.6664967,0.9058316,26.8907739),(24703,'mt.tif',244,10,76,34.5283939,11.8387918,19.2863267,1.8,11.8491386,19.2680439,-0.2477581,3.990101,4.0960532,153.2775257,191.075251,0.3460799,46.648625,38.4144471,76.3616362,7.5812717,8.7341508,0.8544705,26.9361723),(24704,'mt.tif',244,10,77,34.7502693,11.8525247,19.2467407,1.8,11.8671442,19.2308242,-0.2686411,4.0224361,4.1257317,155.0681677,192.5475873,0.4080178,46.6699242,38.5508098,76.7501356,7.5950005,8.7629856,0.8919118,26.9173676),(24705,'mt.tif',244,10,78,34.9101037,11.8658718,19.2046115,1.8,11.8783294,19.1943613,-0.2845628,4.0457476,4.1545994,156.645112,193.6970937,0.4585659,46.6223279,38.7184587,77.0413883,7.6625352,8.8016261,0.8726759,27.0911723),(24706,'mt.tif',244,10,79,35.2107617,11.8813736,19.1498638,1.8,11.8914235,19.129349,-0.3065105,4.0790328,4.1845777,158.1975378,194.9193786,0.5342832,46.5804185,38.7831003,77.5247432,7.6725005,8.823436,0.8974271,27.1365708),(24707,'mt.tif',244,10,80,35.5967878,11.9055173,19.0923849,1.8,11.9205926,19.0592238,-0.3363258,4.1159637,4.2205869,159.6812299,196.3614486,0.6461637,46.5246787,38.7955871,77.4551202,7.7285076,8.8885444,0.8347408,27.3103754),(24708,'mt.tif',244,10,81,35.7857333,11.920947,19.0468256,1.8,11.9321408,19.0258922,-0.3493318,4.1365785,4.2387782,161.3146633,198.6664733,0.698709,46.8688058,38.9971235,77.9333957,7.7489024,8.9209205,0.8838443,27.419977),(24709,'mt.tif',244,10,82,36.0882598,11.9452554,18.9938622,1.8,11.9579832,18.9667153,-0.3606685,4.1644382,4.2677084,162.2667983,200.5597719,0.7490614,46.9947221,38.9648717,78.4916985,7.7500005,8.9451256,0.9082334,27.2915708),(24710,'mt.tif',244,10,83,36.2756763,11.966459,18.9445037,1.8,11.9810992,18.9238225,-0.3741974,4.2015531,4.3059729,164.0652726,201.5502047,0.8077927,46.8071233,39.0487205,78.2695231,7.8163799,8.9980142,0.83414,27.6203754),(24711,'mt.tif',244,10,84,36.4863285,11.9885534,18.8893982,1.8,12.0020529,18.8673739,-0.3810226,4.2031116,4.318299,165.3839077,203.1127447,0.8409322,47.0353594,39.34797,78.8445164,7.8163799,9.0200151,0.8705576,27.4919692),(24712,'mt.tif',244,10,85,36.7125245,12.0090688,18.8316994,1.8,12.0210194,18.8102394,-0.382687,4.229347,4.3378205,167.2784015,204.4655467,0.8531889,47.1355484,39.5518269,79.6400755,7.8275005,9.0200151,0.8705576,27.6015708),(24713,'mt.tif',244,10,86,37.0070944,12.0381579,18.7776479,1.8,12.0572097,18.7596791,-0.3921896,4.2631949,4.3628943,169.2747374,206.1574649,0.9010396,47.252455,39.7060756,80.56192,7.8275005,9.050262,0.827797,27.5827661),(24714,'mt.tif',244,10,87,37.2221781,12.0535495,18.7216946,1.8,12.0672422,18.7013315,-0.4022758,4.2899353,4.3826101,171.0792714,207.891165,0.9509199,47.4354691,39.879219,81.2247292,7.9027471,9.0701498,0.8640236,27.6281646),(24715,'mt.tif',244,10,88,37.417581,12.0740862,18.6721794,1.8,12.0870453,18.6547331,-0.4092715,4.2933414,4.3933085,172.4749273,209.7021893,0.9875569,47.7321791,40.1726562,81.7886688,7.9050005,9.0794158,0.8760581,27.8207739),(24716,'mt.tif',244,10,89,37.5836251,12.0908651,18.6142365,1.8,12.1008668,18.5947266,-0.4196695,4.317586,4.4290413,174.5209582,211.3372092,1.0399548,47.7162431,40.4209573,82.5154232,7.9749038,9.1206673,0.8575618,27.9303755),(24717,'mt.tif',244,10,90,37.8325798,12.1155673,18.5558744,1.8,12.128672,18.5327625,-0.4296642,4.3444747,4.4584071,176.559027,213.1439737,1.0941616,47.8072036,40.6399025,82.5500005,7.9803168,9.1715616,0.8511714,27.9569693),(24718,'mt.tif',244,10,91,38.0939799,12.1381337,18.5023755,1.8,12.1531042,18.4797807,-0.4232356,4.3760966,4.4536718,178.5522094,215.3685094,1.0709798,48.3575172,40.8017066,83.4579331,7.9825005,9.1715616,0.8511714,27.9381646),(24719,'mt.tif',244,10,92,38.0988594,12.1543652,18.4469413,1.8,12.1644066,18.423878,-0.4338365,4.4021816,4.4854173,179.965879,216.4323635,1.1220005,48.2524473,40.8810663,83.836138,8.0600005,9.2169632,0.8329813,28.3045786),(24720,'mt.tif',244,10,93,38.3465129,12.1842262,18.3891649,1.8,12.2001771,18.3641109,-0.4407186,4.4320394,4.507829,182.3217513,218.7557377,1.1630407,48.527958,41.1372134,84.9238765,8.1051794,9.2384427,0.8685394,28.349977),(24721,'mt.tif',244,10,94,38.5052187,12.2112825,18.3322863,1.8,12.2268987,18.3086997,-0.4529718,4.4608507,4.5110767,183.9803207,220.7576765,1.2291401,48.9368036,41.2433266,85.7473111,8.0600005,9.2592237,0.8921338,28.2857739),(24722,'mt.tif',244,10,95,38.6902532,12.2336272,18.2755216,1.8,12.2458477,18.2503162,-0.4630943,4.4877372,4.57805,185.8118805,223.4478221,1.2868217,48.808515,41.4043585,85.8398672,8.1291591,9.3322364,0.844154,28.5503755),(24723,'mt.tif',244,10,96,38.8973742,12.2581516,18.21494,1.8,12.2685539,18.1939826,-0.4715704,4.4812215,4.5749535,188.2263283,225.8120602,1.3379119,49.3583295,42.0033527,86.9221424,8.1211594,9.3476701,0.8675657,28.5315709),(24724,'mt.tif',244,10,97,39.0755331,12.2875554,18.1506809,1.8,12.3031448,18.1268817,-0.4883226,4.5103096,4.6088109,190.3971281,227.6964361,1.4334029,49.4045947,42.2137605,87.0367934,8.0600005,9.3979741,0.8612756,28.6865709),(24725,'mt.tif',244,10,98,39.1685873,12.3125423,18.0850876,1.8,12.3226204,18.0649054,-0.4957705,4.5541823,4.6379309,192.3504298,229.4528818,1.4773056,49.4731131,42.235997,87.921896,8.1375005,9.448646,0.8550527,28.8415709),(24726,'mt.tif',244,10,99,39.2853517,12.3393511,18.0259142,1.8,12.3498461,18.0044344,-0.5044705,4.5806483,4.6641761,193.9570335,231.5607842,1.52965,49.6466636,42.3427036,88.6718653,8.1375005,9.4772081,0.8896698,28.8869693),(24727,'mt.tif',244,10,100,39.3292622,12.3630519,17.9782611,1.8,12.3709532,17.9553474,-0.5179713,4.5943398,4.7112521,196.0415568,234.0681287,1.6068783,49.6827854,42.6702345,88.6612071,8.1375005,9.5579848,0.8542547,29.215774),(24728,'mt.tif',244,10,101,39.4825428,12.3902823,17.9234198,1.8,12.4035543,17.8954155,-0.5049959,4.6582477,4.7134118,198.6724247,236.2065096,1.5402547,50.1137009,42.6496051,89.5582651,8.1375005,9.5862212,0.8884798,29.2611724),(24729,'mt.tif',244,10,102,39.5941647,12.4175029,17.86301,1.8,12.4249599,17.8275379,-0.5204678,4.6745614,4.7538692,201.7546335,238.8511848,1.6318963,50.2435333,43.1601209,89.9928849,8.1375005,9.6464938,0.893546,29.370774),(24730,'mt.tif',244,10,103,39.9377854,12.4400864,17.8086683,1.8,12.4487549,17.7744377,-0.529712,4.7140854,4.7843222,205.8023742,242.7719526,1.6994378,50.7432276,43.6569042,91.5856813,8.2150005,9.6847102,0.8760581,29.4615709),(24731,'mt.tif',244,10,104,40.2161979,12.458692,17.76262,1.8,12.4668024,17.7303435,-0.5384091,4.7487174,4.8201489,209.5860156,247.3271878,1.7623673,51.3111096,44.1352892,93.0755135,8.2150005,9.7199961,0.9097532,29.6619694),(24732,'mt.tif',244,10,105,40.426894,12.4782861,17.7131274,1.8,12.4869148,17.6783212,-0.5430584,4.7816523,4.8621675,212.5725969,251.9995943,1.7992501,51.828653,44.455888,93.5585754,8.2925005,9.7938667,0.8750449,29.7715709),(24733,'mt.tif',244,10,106,40.5574171,12.4994749,17.6562502,1.8,12.5069093,17.6157343,-0.5428903,4.8102999,4.8808292,216.6380799,256.25846,1.8040538,52.5030584,45.0362939,95.1721852,8.2925005,9.8042867,0.8861792,29.9265709),(24734,'mt.tif',244,10,107,40.6160206,12.5157729,17.6001264,1.8,12.5259566,17.5593152,-0.5616515,4.8315021,4.9436664,220.1763297,262.47706,1.9200986,53.0936022,45.5709888,96.0796131,8.3700005,9.903033,0.874054,30.1457741),(24735,'mt.tif',244,10,108,40.7485508,12.5402146,17.5456675,1.8,12.5488058,17.500948,-0.5623216,4.8808699,4.977028,224.3990184,269.1336286,1.9304677,54.0751683,45.9752102,98.063124,8.3700005,9.9625947,0.8790461,30.2819694),(24736,'mt.tif',244,10,109,40.8281454,12.559025,17.4984603,1.8,12.5659716,17.4501191,-0.5510986,4.9029022,5.0087462,228.042475,277.0388115,1.865721,55.31101,46.5117321,99.2340848,8.5250005,10.0538149,0.8563173,30.6107741),(24737,'mt.tif',244,10,110,41.0519972,12.5851081,17.4384919,1.8,12.5913418,17.3881576,-0.5476184,4.9469286,5.0585933,233.6942944,286.4554382,1.8547432,56.6274896,47.2402802,101.1993932,8.6025005,10.1501339,0.8340085,30.8111725),(24738,'mt.tif',244,10,111,41.3098882,12.6065001,17.3990208,1.8,12.6198037,17.3426461,-0.5396234,4.9910009,5.1188285,239.6228221,296.7476264,1.8176609,57.9717848,48.0109758,103.0081708,8.6800005,10.2724787,0.8548052,31.0757741),(24739,'mt.tif',244,10,112,41.4186602,12.6283659,17.366888,1.8,12.6336823,17.3082495,-0.5326447,5.0687415,5.1830077,246.4016874,307.2266137,1.7801361,59.2757399,48.6120046,104.8777299,8.7575005,10.3899155,0.8645972,31.5141803),(24740,'mt.tif',244,10,113,41.6657962,12.6598223,17.3390228,1.8,12.6608,17.2767787,-0.511331,5.1666202,5.2463415,253.9058792,320.4226764,1.6628269,61.0754517,49.1435153,107.428048,8.9188029,10.5268859,0.816638,32.1075866),(24741,'mt.tif',244,10,114,41.8278137,12.694952,17.3117231,1.8,12.697592,17.23898,-0.4965937,5.2629,5.3000727,262.2161627,334.0942371,1.5824076,63.0357844,49.8235121,110.045946,9.022538,10.6516701,0.8471751,32.5459928),(24742,'mt.tif',244,10,115,41.8364855,12.7354391,17.2914189,1.8,12.7401053,17.2172862,-0.4861182,5.3337262,5.3758348,269.3991764,347.7095884,1.5219649,64.6801104,50.5086252,112.5278466,9.1183994,10.7766815,0.8668502,32.984399),(24743,'mt.tif',244,10,116,41.7499216,12.7726009,17.2613188,1.8,12.7723373,17.1782385,-0.4722959,5.4213215,5.4565903,276.7311736,364.7051937,1.440116,66.8375624,51.0449665,114.4508308,9.2483339,10.9738474,0.8353566,33.6232037),(24744,'mt.tif',244,10,117,41.717191,12.7937789,17.2123468,1.8,12.7957916,17.1263124,-0.4534611,5.6224172,5.5696257,289.6994833,381.3843817,1.3343493,68.4757647,51.5257892,117.2116083,9.3875104,11.1354859,0.7410922,34.428024),(24745,'mt.tif',244,10,118,41.8845635,12.797542,17.1399921,1.8,12.8042475,17.0479396,-0.4502287,5.7652457,5.7076484,306.8586421,401.7918236,1.3219759,70.3953349,53.2255965,121.2209966,9.55752,11.3150007,0.7175413,35.4598364),(24746,'mt.tif',244,10,119,42.1925541,12.7995267,17.1014332,1.8,12.8062385,16.9994534,-0.4418849,5.9053655,5.8904549,325.9681383,425.7800742,1.2860254,72.2830548,55.198639,125.2023914,9.7544293,11.5337089,0.71883,37.0020474),(24747,'mt.tif',244,10,120,42.9422717,12.7932217,17.0894422,1.8,12.800715,16.9776877,-0.4395486,6.1346787,6.1286098,353.4412546,462.3120341,1.295974,75.4350581,57.613654,131.1671961,10.0506357,11.8618055,0.7206739,69.1050712),(24748,'mt.tif',244,10,121,44.6976671,12.7686112,17.1081523,1.8,12.7748237,16.989259,-0.4648585,6.4556428,6.4213908,393.8559284,515.4862877,1.4971451,80.2764235,61.0095604,139.9041252,10.3451725,12.2560322,0.7093121,57.523579),(24749,'mt.tif',244,10,122,47.5571833,12.7789207,17.1418095,1.8,12.7865792,16.9963732,-0.4760874,6.7022077,6.7140734,439.1808072,581.1663492,1.6648472,86.5594278,65.5277825,150.6382188,10.7791858,12.6856406,0.7205541,40.1616879),(24750,'mt.tif',244,10,123,52.4375247,12.764837,17.2274146,1.8,12.7610777,17.0487823,-0.4290349,7.0030924,7.0040808,502.3501561,676.9167414,1.5123896,96.6460498,71.7326187,165.7412676,11.1960198,13.0651309,0.7266423,41.5223051),(24751,'mt.tif',244,10,124,60.4693934,12.6024291,17.4287592,1.8,12.6111466,17.2252324,-0.393187,7.2826387,7.3966327,554.769109,787.6375124,1.4794018,106.4859577,76.176937,177.7546297,11.6083246,13.3985383,0.6747409,42.134516),(24752,'mt.tif',244,10,125,65.1740451,12.4360507,17.3164341,1.8,12.4851179,17.1154656,-0.3136496,7.0946226,7.4916412,585.5815888,805.0690567,1.0340095,107.462309,82.5387935,180.3804182,11.5768759,13.5945701,0.6560432,42.5353129),(24753,'mt.tif',244,10,126,32.8005554,14.4635119,14.9690677,1.8,14.1556211,15.0442652,0.013351,7.410937,6.9940691,123.1619763,291.7894781,0.0009744,41.7195589,16.6189479,47.9212256,0.3875,0.4962422,2.2455373,1.2322109),(24754,'mt.tif',244,10,127,6.6482946,15.5123005,14.0697215,1.8,15.5185323,14.0842389,0.2364302,1.2581225,3.7990043,1.5160582,39.053539,0.0607935,10.2799407,1.2050164,10.6690178,1.7895862,3.8164326,2.7233683,9.1890626),(24755,'mt.tif',244,10,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24756,'mt.tif',244,10,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24757,'mt.tif',244,10,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24758,'mt.tif',244,10,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24759,'mt.tif',244,10,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24760,'mt.tif',244,10,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24761,'mt.tif',244,10,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24762,'mt.tif',244,10,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24763,'mt.tif',244,10,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24764,'mt.tif',244,10,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24765,'mt.tif',244,10,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24766,'mt.tif',244,10,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24767,'alpaca_femur.tif',78,7,1,29.9007286,68.4555194,106.9456527,1.8,69.800457,107.0582047,-0.0447602,3.2052672,37.9899993,68.1971296,13828.5016126,0.0099775,364.003734,21.2765818,365.798282,9.5480121,150.8801482,0.0650811,363.5392772),(24768,'alpaca_femur.tif',78,7,2,29.7601984,68.4702982,106.9277772,1.8,69.8616365,107.0466659,-0.0452322,3.2106032,37.9744552,69.4524213,13782.8215078,0.010141,362.9498157,21.6322032,364.7786039,9.7604812,150.8801482,0.0650811,365.1994971),(24769,'alpaca_femur.tif',78,7,3,29.3847675,68.3767663,106.9134072,1.8,69.6035645,107.0310698,-0.0455312,3.4201545,38.0672443,70.7113807,13558.6001448,0.0101458,356.1749846,20.6749081,358.0325223,9.9060415,150.8801482,0.0650811,367.5474025),(24770,'alpaca_femur.tif',78,7,4,29.1213446,68.4559665,106.8980761,1.8,69.669901,107.0159327,-0.0456389,3.4242439,37.9874271,71.6536018,13417.6362407,0.0101025,353.2125562,20.9253793,355.0987809,9.6001475,150.9004009,0.0671089,368.2659071),(24771,'alpaca_femur.tif',78,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24772,'alpaca_femur.tif',78,7,6,7.2678204,50.1208657,86.1164502,1.8,50.0912257,85.9303992,-0.4896876,2.9429398,5.626476,10.6346649,38.6251188,0.2679758,6.8648864,3.6136196,8.7307481,5.761338,10.7280535,0.5404195,26.5018798),(24773,'alpaca_femur.tif',78,7,7,67.762611,60.3032879,87.8252531,1.8,61.2371197,87.5026222,0.2206137,12.7764201,21.8665408,1013.3008384,11470.0272562,0.5408126,524.5469492,79.3102319,563.5345899,10.1644679,20.496835,0.8913825,53.332193),(24774,'alpaca_femur.tif',78,7,8,159.9341616,63.2435589,87.741291,1.8,62.8697404,86.990566,0.2431419,15.6971246,21.5098255,5300.7216439,26987.876697,1.5450217,1254.6766934,337.6874289,1474.5093405,13.1495897,26.3871663,0.8924256,69.7239465),(24775,'alpaca_femur.tif',78,7,9,251.9907691,63.350382,86.8352158,1.8,63.4519038,86.2109983,0.2530034,17.4924966,22.3898227,12502.1913359,38380.8331555,2.6314781,1714.2088899,714.7173793,2176.8048739,31.007851,44.732816,2.8567018,157.140614),(24776,'alpaca_femur.tif',78,7,10,326.6984541,63.2923013,86.2625665,1.8,63.5792777,85.8940288,0.2693965,19.2658908,23.1678169,22137.8439368,48426.4416655,3.8569836,2090.246214,1149.0693133,2839.1132229,34.8557784,46.290605,2.8596533,167.2815593),(24777,'alpaca_femur.tif',78,7,11,375.5848601,63.2535954,85.9796535,1.8,63.5894895,85.638466,0.3106876,21.2297179,23.8491163,32549.9808582,56613.1508152,5.8504013,2373.8049676,1533.227194,3444.2399632,38.0557966,47.3906696,2.6200388,176.4063857),(24778,'alpaca_femur.tif',78,7,12,406.6313996,63.086887,85.7719023,1.8,63.4020508,85.3404061,0.3637203,23.346938,24.4480318,42662.5551648,62864.9779722,8.5772546,2571.3717384,1827.3297813,3946.332717,40.9066131,49.1927098,0.6260465,186.2008444),(24779,'alpaca_femur.tif',78,7,13,434.7972132,62.9150508,85.6945393,1.8,63.0825718,84.979208,0.4532725,25.281137,25.3070644,52114.2356195,69256.0669797,13.8964882,2736.6298177,2061.3881282,4439.8131472,43.0892759,51.42983,1.9302648,192.0924003),(24780,'alpaca_femur.tif',78,7,14,455.456345,62.7597339,85.446903,1.8,62.8432216,84.6491442,0.5970395,26.8578788,26.8283307,60197.4904483,75305.2979865,23.992301,2806.9319252,2241.334506,4815.532998,45.4384896,53.7260935,1.8781075,195.9644841),(24781,'alpaca_femur.tif',78,7,15,474.2042437,62.6464154,85.2211196,1.8,62.6476523,84.3346049,0.7280956,28.0562903,28.0950074,67003.768667,80825.9909611,34.9980746,2876.8809326,2388.1905978,5167.6607121,47.1242866,54.9255578,1.8536972,196.3853743),(24782,'alpaca_femur.tif',78,7,16,480.9771311,62.5504583,85.0701991,1.8,62.4680987,84.1200746,0.8647881,28.3784328,28.7440437,71983.7396693,83471.1007668,46.4188403,2903.9442588,2536.5650122,5361.8273571,47.4821191,55.8945228,1.854371,198.3304429),(24783,'alpaca_femur.tif',78,7,17,483.4688633,62.2795061,84.808052,1.8,62.1378305,83.8473535,1.232249,27.9009101,28.4993152,77343.2960356,85817.5540568,71.6902239,3011.2146016,2772.0707235,5463.1010097,47.9149846,56.9898713,1.8431833,202.2025266),(24784,'alpaca_femur.tif',78,7,18,480.7450512,62.2772772,84.5612151,1.8,62.0673498,83.6198997,-1.5556694,26.9954719,29.3527576,77859.582361,87802.5255508,80.1058418,2991.2871119,2884.1719337,5448.3183369,47.9643207,57.6631858,1.8454437,202.8158086),(24785,'alpaca_femur.tif',78,7,19,473.9646129,62.4112623,84.1936426,1.8,62.0044717,83.2983878,-1.3403181,26.3476748,28.6511658,75653.9333169,89327.8704407,74.8716934,3117.7743731,2871.3703885,5372.8936987,48.0383985,58.1163575,0.7704739,201.7996897),(24786,'alpaca_femur.tif',78,7,20,468.6593711,62.6537691,83.9227813,1.8,61.9970736,83.0260114,-1.2824988,26.090175,29.1296974,72998.5411567,90689.4905209,71.7956407,3113.3001204,2797.9322143,5287.6723454,48.08714,58.5836808,0.8224183,203.2802835),(24787,'alpaca_femur.tif',78,7,21,461.390126,62.7870944,83.4659029,1.8,61.9472366,82.686284,-1.1982189,25.160983,29.8020961,69232.1985194,89725.4463407,66.7086628,3010.7092495,2751.5697001,5137.3637623,48.0603819,59.0027007,0.8148015,204.1784142),(24788,'alpaca_femur.tif',78,7,22,446.3552783,62.8611417,83.0016442,1.8,61.9168443,82.2927214,-1.1667979,24.5342852,30.0215882,65294.2812665,87122.8461283,62.8969607,2902.0065682,2661.3484277,4943.5728914,47.3847523,59.0345648,0.8294872,202.2025266),(24789,'alpaca_femur.tif',78,7,23,429.4344713,63.0277404,82.4579384,1.8,61.9221858,81.9403652,-1.157694,24.2206972,29.7955862,60678.4003893,83241.9864147,60.0375035,2793.7690449,2505.2293026,4712.2544618,46.3192811,59.0170417,0.8221463,199.9290248),(24790,'alpaca_femur.tif',78,7,24,404.1269024,63.1229023,82.1233781,1.8,61.9606665,81.6366226,-1.1226483,23.3564145,29.9166984,56395.7331283,77141.1750109,54.7089198,2578.5323669,2414.5715115,4383.6377398,45.1119255,58.827939,0.8333319,195.8900805),(24791,'alpaca_femur.tif',78,7,25,367.5140061,63.1170876,81.7002919,1.8,61.9059351,81.2761203,-1.047697,22.7681481,30.0114474,51453.8040939,70095.1365651,45.9657372,2335.6133313,2259.9029087,4026.0783447,43.620843,58.2133529,0.8450289,193.3317299),(24792,'alpaca_femur.tif',78,7,26,318.5756279,62.8777678,80.8853359,1.8,61.9074581,80.8336472,-0.8320192,23.5354119,29.5772411,42940.3130061,60748.0605495,29.0197714,2053.8785302,1824.4980422,3493.3162745,42.2367238,57.7169722,0.8229745,195.2767985),(24793,'alpaca_femur.tif',78,7,27,280.9005492,62.6633362,80.5321724,1.8,61.8639266,80.2959517,-0.6813634,22.8479422,42.7531293,35675.3767071,53212.8659174,18.5728749,1244.6542943,1561.4262508,2072.645221,41.8349428,56.8155381,0.8006642,174.6664746),(24794,'alpaca_femur.tif',78,7,28,254.0813976,62.913657,80.6712618,1.8,62.2522291,80.310819,-0.5123523,24.5018944,26.6755616,31344.0789197,43603.3314548,10.1769907,1634.5797006,1279.251245,2630.6937818,41.581966,55.3119508,0.8128423,172.0645394),(24795,'alpaca_femur.tif',78,7,29,237.7985041,63.1633458,80.6182424,1.8,62.6639595,80.2933204,-0.3359085,25.4891618,26.2710968,27550.4783359,37921.8492951,4.3062913,1443.4817673,1080.8703136,2486.3390901,41.159574,52.3853767,0.7149754,168.3540284),(24796,'alpaca_femur.tif',78,7,30,221.628787,63.7474375,80.2522853,1.8,63.159072,80.0913782,-0.1806687,25.4956287,25.874805,24175.6218456,32574.1512581,1.1926424,1258.9138831,948.2261495,2187.3007352,40.5743959,51.1208347,0.7047226,165.3800754),(24797,'alpaca_femur.tif',78,7,31,204.6741866,64.690999,79.7222312,1.8,64.2888232,79.501871,0.090908,22.8709515,23.8626169,20660.5664762,27094.8444584,0.2811376,1135.4515123,903.354041,1877.6759082,38.3916912,48.1191938,0.5349551,154.2538301),(24798,'alpaca_femur.tif',78,7,32,191.8904431,65.349414,79.3355251,1.8,65.0104987,79.1872818,0.25038,20.1236986,20.6291475,18582.9776101,23655.812472,1.9633922,1146.7178863,923.4374865,1786.4347643,36.2173457,45.3839039,0.5392608,145.7603391),(24799,'alpaca_femur.tif',78,7,33,183.8587392,65.9208791,78.6203525,1.8,65.5041972,78.436171,0.3275769,19.3686175,19.121737,16452.4697248,20732.0407302,3.1722644,1084.213256,849.4395495,1648.9808273,34.5183055,43.0707822,0.5465244,136.8023731),(24800,'alpaca_femur.tif',78,7,34,179.0636458,66.2610243,78.1292517,1.8,65.7840961,77.7891393,0.3492597,18.4044576,18.3926212,15187.2530911,19248.202346,3.4947971,1046.5176292,825.194278,1624.9861631,32.6751365,40.7601908,0.5546121,129.2197784),(24801,'alpaca_femur.tif',78,7,35,177.7270136,66.4122674,77.8258384,1.8,65.9901088,77.2570118,0.3699466,17.7333542,18.1716806,14510.1968701,18457.0719757,3.8723667,1015.7052852,818.2432198,1623.7317491,30.9136986,39.4042634,2.0831858,123.4770296),(24802,'alpaca_femur.tif',78,7,36,177.4676653,66.5308516,77.5926863,1.8,66.1852488,76.8786194,0.3827411,17.1712896,17.8441133,14115.9964073,17820.1790446,4.1254083,998.6587014,822.0696741,1607.1381152,29.8597637,38.4220072,2.070143,118.2731593),(24803,'alpaca_femur.tif',78,7,37,174.4773816,66.673797,77.2992449,1.8,66.3266452,76.5290986,0.4041257,16.7157639,17.6193648,13538.6947429,16878.234402,4.4962259,957.9365997,809.9357469,1567.6588577,29.0051226,37.3498305,2.0858691,113.9366007),(24804,'alpaca_femur.tif',78,7,38,171.7165564,66.9636493,77.0156196,1.8,66.4844906,76.2116764,0.4838531,16.5527643,17.6943961,12955.413314,16158.8108092,6.1933837,913.2162905,782.6737001,1540.0459685,28.3321991,36.3663815,2.0721619,110.616161),(24805,'alpaca_femur.tif',78,7,39,170.4884846,67.1192326,76.8011169,1.8,66.6937459,75.9594314,0.5509514,16.3270564,17.7312661,12391.1425896,15602.9996771,7.7870687,879.9709859,758.9330404,1508.9307426,27.7089256,35.5624247,2.0845949,107.58057),(24806,'alpaca_femur.tif',78,7,40,168.9389485,67.1649041,76.4239935,1.8,66.8855237,75.6495431,0.5258219,15.7172356,17.2250193,11969.0185476,14879.8337591,7.0934015,863.8500469,761.5218619,1459.0644733,27.1179483,34.7642189,2.0976009,104.1113231),(24807,'alpaca_femur.tif',78,7,41,167.9609645,67.2040244,76.2148457,1.8,66.9164338,75.345071,0.528759,15.2648282,16.8498685,11635.0656808,14220.283086,7.1238443,843.9403021,762.213993,1432.3240042,26.576621,33.9721695,2.1112158,102.0918509),(24808,'alpaca_femur.tif',78,7,42,165.5140812,67.310987,75.8689315,1.8,67.0722466,75.0756626,0.5028167,14.6400481,16.270927,11300.3714322,13324.5659773,6.406037,818.9186728,771.8807585,1380.1840278,25.9610583,33.2885605,2.1127956,98.9818563),(24809,'alpaca_femur.tif',78,7,43,164.3115681,67.4411694,75.7325518,1.8,67.1605989,74.9403098,0.5508743,14.5049467,16.1272232,10883.6077577,12798.432003,7.503053,793.591793,750.3376604,1356.8998292,25.4569841,32.5574195,2.0934471,96.9623842),(24810,'alpaca_femur.tif',78,7,44,162.1847243,67.5574991,75.4956649,1.8,67.1918269,74.7111568,0.5840328,14.1890757,16.1048613,10469.8187057,12147.6128764,8.2182767,754.2823664,737.8788407,1310.9096874,24.9439637,31.9216079,2.1161581,94.8685085),(24811,'alpaca_femur.tif',78,7,45,163.6506888,67.6400473,75.2584773,1.8,67.2428172,74.4946778,0.6022865,13.8413846,15.7603383,10282.6301438,11830.3309673,8.7540615,750.6394051,742.8902868,1309.1646389,24.579803,31.1885705,2.0960399,93.0286625),(24812,'alpaca_femur.tif',78,7,46,162.9400312,67.7460975,75.1077022,1.8,67.3953002,74.4100803,0.6015454,13.560089,15.5014257,9982.0746016,11435.7045958,8.6972601,737.7195352,736.1363658,1282.311173,24.2452959,30.6595,2.1060701,91.876502),(24813,'alpaca_femur.tif',78,7,47,161.7506536,67.8626836,74.9688888,1.8,67.4431948,74.2457432,0.6085805,13.2477008,15.2735987,9641.715473,11003.5769614,8.8112262,720.4311931,727.8029323,1258.2537839,23.9501627,30.1336221,2.1164514,90.1418786),(24814,'alpaca_femur.tif',78,7,48,160.6348464,67.9685435,74.8107618,1.8,67.4892197,74.0801819,0.6045716,13.0343005,14.8256439,9348.5973882,10542.6387059,8.649907,711.1083191,717.2304625,1231.2751921,23.8009966,29.6666253,2.0899424,88.5560623),(24815,'alpaca_femur.tif',78,7,49,161.3699514,68.0279892,74.6319605,1.8,67.4993063,73.9436736,0.5948495,12.8297655,14.3004293,9088.6517036,10198.1550519,8.4458443,713.1362845,708.4035723,1236.8215806,23.6306869,28.7164017,2.0965649,86.2825605),(24816,'alpaca_femur.tif',78,7,50,160.2948614,68.1751582,74.5592781,1.8,67.6062326,73.8571176,0.628533,12.7817289,14.0484432,8857.4917206,9903.9361216,9.2355363,704.9845989,692.9807244,1237.3807509,23.4300808,28.1459024,2.0831858,84.8019667),(24817,'alpaca_femur.tif',78,7,51,159.901166,68.2703516,74.4120284,1.8,67.7274688,73.7298751,0.6738416,12.7944675,14.0336515,8650.3638178,9587.1103757,10.3766971,683.1515201,676.1019011,1226.48997,23.3558976,27.6130178,2.0940746,83.7550289),(24818,'alpaca_femur.tif',78,7,52,158.4528391,68.3677555,74.3549266,1.8,67.8209771,73.6437195,0.7413038,12.8217598,13.8849024,8425.1061704,9291.9534786,12.0414326,669.2127305,657.0943684,1226.3292661,23.251403,27.0435806,2.0800975,82.2744352),(24819,'alpaca_femur.tif',78,7,53,156.1742672,68.3970406,74.3147979,1.8,67.8494789,73.6212133,0.7983452,12.5281921,13.8323876,8188.2484743,8914.891136,13.3514835,644.4940227,653.585802,1204.1480578,23.084409,26.6266111,2.0756577,81.3763045),(24820,'alpaca_femur.tif',78,7,54,156.2347875,68.487312,74.2395007,1.8,67.9710886,73.6707847,0.839886,12.4338602,13.7455191,8003.8818319,8734.1865456,14.4355756,635.4206398,643.7165672,1189.8088105,22.9860095,26.3586435,2.0812846,80.5833963),(24821,'alpaca_femur.tif',78,7,55,155.9443812,68.6040142,74.127715,1.8,68.094222,73.6692817,0.854407,12.1922873,13.5938594,7885.3999041,8493.5310553,14.7832654,624.8064521,646.7531218,1173.0696582,22.8887108,26.064485,2.0607537,79.5364585),(24822,'alpaca_femur.tif',78,7,56,154.2202367,68.7284884,74.0131629,1.8,68.2369618,73.6346439,0.9308016,12.1054152,13.5690361,7710.4154484,8273.9459928,16.5365891,609.7666721,636.939363,1163.8127113,22.8887108,25.6737455,2.0825352,78.99758),(24823,'alpaca_femur.tif',78,7,57,154.6041873,68.7829014,73.9368675,1.8,68.260685,73.5921589,1.0291939,11.8462172,13.5914396,7596.8882716,8102.1437452,18.9196797,596.1210863,641.2923313,1151.0900667,22.6842502,25.3790586,2.0074235,78.0558647),(24824,'alpaca_femur.tif',78,7,58,153.0497504,68.8660469,73.9752519,1.8,68.3751464,73.7373642,1.1508483,11.7126216,13.2792778,7471.058277,7923.9946437,21.2680514,596.718794,637.8638814,1156.5933583,22.5624198,25.1090114,2.0672191,77.4425827),(24825,'alpaca_femur.tif',78,7,59,153.3707017,68.9644349,73.9857582,1.8,68.4191692,73.673854,1.2535843,11.5855855,13.0122671,7422.4400654,7810.6023867,23.0747902,600.2491589,640.6616281,1162.2510835,22.3795357,24.8454912,1.9902738,76.575271),(24826,'alpaca_femur.tif',78,7,60,154.0107807,69.0730714,73.9783807,1.8,68.5984831,73.6579976,1.355059,11.6312233,12.6390741,7365.9854112,7742.0399225,24.4922059,612.5480301,633.2941253,1178.0717649,22.078152,24.4852406,1.9559538,75.961989),(24827,'alpaca_femur.tif',78,7,61,155.7001346,69.15683,73.9617867,1.8,68.6942501,73.6833923,1.419571,11.6189471,12.4303413,7386.9184546,7718.2292843,25.3610792,620.9185347,635.7648776,1189.5581269,22.1407682,24.2614855,1.9325256,76.0363926),(24828,'alpaca_femur.tif',78,7,62,156.3703028,69.2622605,73.9525573,1.8,68.7690574,73.6880636,1.559636,11.3434697,11.9476778,7378.328885,7649.8307674,26.0584712,640.2776264,650.4472693,1202.9087721,22.0891853,24.0376034,1.9773632,75.4975142),(24829,'alpaca_femur.tif',78,7,63,157.5612475,69.3441533,73.9065775,1.8,68.8203762,73.7014851,-1.4435956,10.9910141,11.5187615,7324.6579802,7618.7528576,25.8376037,661.4211802,666.4223961,1205.3676218,22.0150021,23.8017423,1.953695,74.9894547),(24830,'alpaca_femur.tif',78,7,64,155.9933331,69.381737,73.9685271,1.8,68.8766859,73.8940843,-1.2550521,11.2406883,11.4001651,7244.6231562,7504.6889679,23.4919416,658.2965166,644.4999619,1206.4945953,21.940819,23.661084,1.9007434,74.6302025),(24831,'alpaca_femur.tif',78,7,65,157.8717987,69.3538683,74.028724,1.8,68.9304759,73.9061296,-1.0594862,11.4821386,11.6552535,7189.9859405,7633.5926137,20.0119797,654.9486547,626.1887427,1236.036842,21.9296477,23.4815739,0.8593372,74.6302025),(24832,'alpaca_femur.tif',78,7,66,157.1001934,69.3967219,74.0669826,1.8,69.0441629,74.0373893,-0.9639314,11.5029289,11.650677,7083.4570337,7657.6774057,17.6675817,657.2731694,615.7959522,1242.5335077,21.865836,23.5075879,0.5337082,74.4505763),(24833,'alpaca_femur.tif',78,7,67,152.806387,69.5794207,74.0963464,1.8,69.3465266,74.1658378,-0.9849867,11.3102541,29.9378695,6808.4809211,7572.374973,17.6830122,252.9363341,601.9741779,475.1558233,21.8338902,23.4033586,0.551655,74.0169205),(24834,'alpaca_femur.tif',78,7,68,150.4339858,69.7549315,74.1038362,1.8,69.5107664,74.2159973,-0.9870116,11.5422877,11.8219898,6601.8996398,7542.7972522,17.455212,638.0311092,571.9749701,1140.8269761,21.8621135,23.4033586,0.551655,74.0169205),(24835,'alpaca_femur.tif',78,7,69,149.05997,69.8366448,74.1376097,1.8,69.6010875,74.354023,-0.9850054,11.5476341,12.0932112,6433.9768524,7581.8871409,17.2498988,626.9540003,557.1684045,1156.7240233,21.771511,23.5655155,1.0080591,73.7628907),(24836,'alpaca_femur.tif',78,7,70,149.2110713,69.894363,74.1913874,1.8,69.6897801,74.4458175,-0.9707684,12.1090252,12.0694209,6323.8982909,7700.9520377,16.9392576,638.05481,522.2466862,1136.8405693,21.7233293,23.6431943,0.9791966,74.0169205),(24837,'alpaca_femur.tif',78,7,71,149.1763377,69.98247,74.1988999,1.8,69.7582389,74.4840308,-0.9731933,12.0829237,12.1957731,6239.3088404,7752.4064399,16.9914549,635.6633888,516.3740997,1099.1198212,21.6260307,23.7720951,1.0436504,73.9116979),(24838,'alpaca_femur.tif',78,7,72,148.6211124,70.0713949,74.2225803,1.8,69.8328607,74.5663258,-0.9607643,11.4668421,12.2874785,6160.3559779,7758.173882,16.6404326,631.388603,537.232129,1121.5367665,21.6260307,23.8865269,1.0612041,73.8372943),(24839,'alpaca_femur.tif',78,7,73,147.929802,70.191819,74.2434948,1.8,69.9581437,74.5951107,-0.9515602,11.43871,12.3245211,6077.0350829,7735.5166305,16.3492115,627.6525147,531.2692687,1110.2592492,21.6249297,23.9278242,1.0325746,73.9116979),(24840,'alpaca_femur.tif',78,7,74,147.5305504,70.2751605,74.2854059,1.8,70.0376911,74.5878002,-0.9447919,11.3865391,12.3278345,5977.014488,7759.1277305,16.1474072,629.3990848,524.919332,1104.3119661,21.529833,23.9278242,1.0325746,73.6576682),(24841,'alpaca_femur.tif',78,7,75,146.6201246,70.391658,74.2998255,1.8,70.1624312,74.6232776,-0.951979,11.5995562,12.4293171,5891.514291,7721.7284736,16.2141397,621.2512247,507.9085937,1090.6742723,21.4659651,23.9906167,0.9579761,73.478042),(24842,'alpaca_femur.tif',78,7,76,145.0901637,70.5068578,74.2473037,1.8,70.2680111,74.5667365,-0.9478985,11.4840437,12.5376106,5782.0757124,7642.4403896,15.9515691,609.5611566,503.4877845,1066.8659013,21.3956965,24.0376034,1.0500679,73.4036385),(24843,'alpaca_femur.tif',78,7,77,145.5076511,70.5902847,74.2304944,1.8,70.3384803,74.5260225,-0.9351959,11.290073,12.7246762,5724.6207276,7700.0516968,15.7043233,605.1275135,507.0490467,1049.4886775,21.2491372,24.1916235,1.0390723,73.478042),(24844,'alpaca_femur.tif',78,7,78,146.3548497,70.6901695,74.2400299,1.8,70.4645097,74.5518826,-0.9225841,11.1856629,12.7671084,5717.4727617,7716.4047813,15.5007138,604.3972152,511.1429503,1046.6992335,21.1220514,24.247917,1.0108565,73.6576682),(24845,'alpaca_femur.tif',78,7,79,146.6830384,70.7873118,74.2135954,1.8,70.5481094,74.5656157,-0.9036079,10.5212647,12.8122389,5693.3933143,7704.4931447,15.086635,601.3385477,541.1320287,1038.0049557,20.9836719,24.3234167,0.9827937,73.478042),(24846,'alpaca_femur.tif',78,7,80,145.8906614,70.8837658,74.204163,1.8,70.6476753,74.5754312,-0.8951813,11.0981326,12.8662855,5617.7349451,7660.9824602,14.8055466,595.4307859,506.1874044,1024.1419134,20.8476279,24.3485312,0.9373704,73.1496087),(24847,'alpaca_femur.tif',78,7,81,146.9719345,70.9241878,74.2177303,1.8,70.7245117,74.5673705,-0.9045137,11.2210254,12.9465315,5606.6289063,7693.1797012,15.1379141,594.2270888,499.6538828,1016.7048856,20.843733,24.4121674,1.0002136,72.9699826),(24848,'alpaca_femur.tif',78,7,82,145.4472733,71.0251275,74.1837227,1.8,70.8367334,74.5532285,-0.9083216,10.3831978,13.0956405,5494.3000072,7607.6696944,15.0704938,580.9314701,529.1529732,986.716296,20.7092483,24.5714937,1.0624857,72.9699826),(24849,'alpaca_femur.tif',78,7,83,144.5832065,71.1201728,74.1492237,1.8,70.9428234,74.5142338,-0.913818,10.3814884,13.1928727,5409.562061,7549.0742446,15.1092478,572.2085281,521.0776982,970.3845147,20.7084699,24.6116416,1.0346503,72.9699826),(24850,'alpaca_femur.tif',78,7,84,143.7034682,71.2337123,74.1075891,1.8,71.0455043,74.5128219,-0.9170535,10.3456047,13.3015984,5342.4877746,7457.3588865,15.0921998,560.6362984,516.4016931,951.9838636,20.5724258,24.6707883,1.006927,72.7903565),(24851,'alpaca_femur.tif',78,7,85,142.5247472,71.3348624,74.07492,1.8,71.1330264,74.4870986,-0.9178593,11.1211633,13.3905748,5266.3506618,7342.5405921,14.9868851,548.3364749,473.5431446,932.3801394,20.5590019,24.6707883,1.006927,72.7159529),(24852,'alpaca_femur.tif',78,7,86,142.2930662,71.4044618,74.0720599,1.8,71.2144192,74.4635224,-0.9151729,10.2871517,13.4301469,5216.6555119,7306.0732969,14.900991,544.0054627,507.1039757,923.4982774,20.4348248,24.7696848,1.0240075,72.7159529),(24853,'alpaca_femur.tif',78,7,87,141.9166665,71.4823815,74.0801933,1.8,71.3122682,74.5467907,-0.9206479,11.1231371,13.5393635,5174.1508823,7274.7709979,14.9865502,537.3052444,465.1701071,907.9583166,20.3899775,24.8757491,1.0409473,72.7903565),(24854,'alpaca_femur.tif',78,7,88,141.5847451,71.5843262,74.0749807,1.8,71.3931011,74.490018,-0.9159437,11.0205148,13.7820236,5146.5734414,7237.3449362,14.844392,525.1293398,466.999367,890.0950091,20.3899775,25.0940276,1.0031299,72.9699826),(24855,'alpaca_femur.tif',78,7,89,141.0829168,71.6905131,74.1220332,1.8,71.4888165,74.588492,-0.9176449,11.7626683,13.8124052,5111.5629197,7233.3008458,14.8304066,523.6814822,434.5581127,886.5155984,20.3296809,25.0940276,1.0031299,73.1496087),(24856,'alpaca_femur.tif',78,7,90,140.8500105,71.8176707,74.1366903,1.8,71.6414055,74.5520336,-0.9195686,10.3103077,13.9392117,5084.632064,7225.9847827,14.8494884,518.3926417,493.1600682,873.6610114,20.2972238,25.2564986,1.0636978,72.895579),(24857,'alpaca_femur.tif',78,7,91,141.1357153,71.9301921,74.1138683,1.8,71.7554071,74.5654194,-0.9214612,11.4491551,14.0881254,5077.5238337,7248.6616254,14.9225131,514.5227914,443.484589,862.6193811,20.1604012,25.4068307,1.0531472,73.6576682),(24858,'alpaca_femur.tif',78,7,92,141.4103646,72.0283425,74.1057452,1.8,71.8316026,74.5199274,-0.9238455,10.2758391,14.1594239,5073.2734903,7252.3054221,15.005642,512.1893008,493.7089245,859.3963746,20.1604012,25.4068307,1.0531472,73.478042),(24859,'alpaca_femur.tif',78,7,93,143.232128,72.1203161,74.104233,1.8,71.9102432,74.5202536,-0.9233015,10.2883503,14.2148641,5137.5001099,7301.6490388,15.1864629,513.6629518,499.3512019,864.6252884,20.0243571,25.4530502,1.0262446,73.4036385),(24860,'alpaca_femur.tif',78,7,94,144.3105802,72.2283348,74.100563,1.8,72.0724897,74.485786,-0.9133478,10.6543954,14.2610055,5172.1158761,7315.8149649,15.0698191,512.9943311,485.4443316,864.7321385,20.1446409,25.4530502,1.0262446,73.8372943),(24861,'alpaca_femur.tif',78,7,95,145.5618458,72.3336802,74.1163887,1.8,72.1782227,74.4788173,-0.9068596,10.7630257,14.1619787,5203.0566358,7356.0820305,15.0479504,519.4247334,483.4195142,868.22076,20.0235787,25.4068307,1.0531472,73.478042),(24862,'alpaca_femur.tif',78,7,96,145.7771716,72.4305509,74.1276779,1.8,72.2506771,74.5236496,-0.8980176,10.5777585,14.1869039,5208.7828735,7329.8560831,14.8612433,516.6635467,492.4278493,864.8266331,20.0235787,25.4068307,1.0531472,73.4036385),(24863,'alpaca_femur.tif',78,7,97,148.1293993,72.4052039,74.1792873,1.8,72.2876946,74.5047627,-0.8955059,10.1641501,14.1232233,5287.7290583,7375.3770315,15.0405641,522.2162744,520.2332695,876.8889294,20.0228002,25.3790586,1.0801283,73.6576682),(24864,'alpaca_femur.tif',78,7,98,148.2262489,72.4714981,74.2122253,1.8,72.3091009,74.5074568,-0.9003834,10.1920731,14.0123642,5293.2907204,7354.1687645,15.1678526,524.8342569,519.3536833,875.0646349,20.0243571,25.3697945,1.1071487,74.1657276),(24865,'alpaca_femur.tif',78,7,99,148.399917,72.5627226,74.2264035,1.8,72.4205166,74.5406175,-0.908497,10.2243355,14.0855598,5315.0894562,7322.8738403,15.380639,519.8851824,519.8469332,872.9112973,20.0243571,25.3697945,1.1071487,74.8534132),(24866,'alpaca_femur.tif',78,7,100,148.6466426,72.6486646,74.2648628,1.8,72.5402172,74.6265238,-0.9176339,10.2451084,14.0080758,5349.7563204,7290.0996927,15.6252288,520.4212038,522.1766415,870.8407497,20.0259141,25.3790586,1.1341692,73.3728195),(24867,'alpaca_femur.tif',78,7,101,147.1743526,72.7521427,74.2776672,1.8,72.6211865,74.6470583,-0.9178612,11.6538523,13.8180677,5329.2286965,7148.0830325,15.4758487,517.2997542,457.2933115,875.0060562,20.1611797,25.0546527,1.1948354,72.9391636),(24868,'alpaca_femur.tif',78,7,102,146.5348719,72.8318054,74.3129034,1.8,72.7182788,74.6482492,-0.9193998,10.2481736,13.5998948,5325.0100947,7076.1937583,15.444855,520.3123882,519.6057663,887.1903358,20.0266926,24.7221878,1.1626472,72.9391636),(24869,'alpaca_femur.tif',78,7,103,146.499312,72.9132757,74.3870488,1.8,72.8097706,74.699145,-0.9191252,11.1018576,13.4034869,5347.133465,7030.9521747,15.4346401,524.5614235,481.6431325,895.6666056,20.1619582,24.6020885,1.1740877,72.0718519),(24870,'alpaca_femur.tif',78,7,104,146.1506935,72.982826,74.4702305,1.8,72.890333,74.8704773,-0.9252747,10.9560733,13.2148585,5370.7991251,6971.9328392,15.5421323,527.582861,490.2120473,904.1464834,20.1627367,24.4852406,1.1856388,72.0718519),(24871,'alpaca_femur.tif',78,7,105,146.17497,73.059035,74.5656202,1.8,72.9683542,74.9473858,-0.9362299,10.8122504,13.0381492,5396.9994009,6936.3244063,15.8004048,532.0022278,499.1559755,915.1914589,20.1603458,24.3195506,1.1692158,71.9666293),(24872,'alpaca_femur.tif',78,7,106,146.931901,73.1568898,74.670489,1.8,73.084207,75.0144767,-0.9384392,11.0327452,12.8376534,5440.7639491,6925.6770361,15.9338483,539.4815396,493.1468889,929.6350348,20.169743,24.2013386,1.1808785,72.1462555),(24873,'alpaca_femur.tif',78,7,107,147.2227631,73.2652,74.7403298,1.8,73.1282626,75.1075049,-0.9435013,11.1193081,12.8621629,5491.8987541,6874.6971355,16.0836344,534.489977,493.9065203,926.0748706,20.2170536,24.1780158,1.3012072,71.7870032),(24874,'alpaca_femur.tif',78,7,108,146.8080966,73.3751681,74.8126922,1.8,73.2643657,75.1858906,-0.9529463,11.2237261,12.792087,5525.5712428,6796.8499228,16.2572861,531.3323731,492.3116617,925.0376601,20.2998213,24.1546704,1.2209407,71.7870032),(24875,'alpaca_femur.tif',78,7,109,147.6594837,73.4982419,74.8971416,1.8,73.3909,75.272134,-0.9709884,11.2728494,12.6837232,5595.6668972,6791.5009449,16.7681589,535.4501057,496.3844295,939.726355,20.3444165,23.974934,1.2045408,71.6073771),(24876,'alpaca_femur.tif',78,7,110,148.1673812,73.6126429,74.9743585,1.8,73.5261601,75.3464267,-0.9819032,10.4769431,12.8061394,5645.0231823,6780.723219,17.0759294,529.4900367,538.804414,931.4382632,20.4159426,24.1780158,1.3012072,71.8614068),(24877,'alpaca_femur.tif',78,7,111,149.2133508,73.7086187,75.0746527,1.8,73.6264321,75.4662781,-1.0046442,11.003753,12.6901709,5721.1079412,6779.2943266,17.7137965,534.2161579,519.9233344,948.2516629,20.4159426,23.9670888,1.2854669,71.4277509),(24878,'alpaca_femur.tif',78,7,112,148.5525285,73.801279,75.1858458,1.8,73.7258043,75.5638132,-1.0365004,11.1892782,12.7489077,5751.5125108,6707.9338877,18.3383018,526.1575393,514.0199768,950.8618563,20.498732,23.8825901,1.2977876,71.6073771),(24879,'alpaca_femur.tif',78,7,113,149.011702,73.7831689,75.368688,1.8,73.7074454,75.6858651,-1.0841684,11.5349798,12.8362179,5845.1028331,6655.417985,19.4039419,518.4874596,506.7284832,952.0732124,20.562664,23.9494277,1.3382394,71.5021545),(24880,'alpaca_femur.tif',78,7,114,147.7790711,73.8720133,75.4613029,1.8,73.8083151,75.7365394,-1.1129796,10.5506084,12.7310847,5844.8742173,6556.4872872,19.8182628,514.9983245,553.9845664,938.6167907,20.6675748,23.815565,1.3633001,71.2481248),(24881,'alpaca_femur.tif',78,7,115,146.8090368,73.9571316,75.5699539,1.8,73.9364539,75.7951579,-1.0963367,10.5446033,12.4891224,5850.9116592,6460.118667,19.361199,517.2596158,554.8726197,960.1365931,20.5986534,23.5874508,1.2942824,71.1429022),(24882,'alpaca_femur.tif',78,7,116,146.4363698,74.0517983,75.6787331,1.8,74.0182857,75.8903179,-1.103088,10.6687575,12.4540222,5876.2955008,6399.2306924,19.4453229,513.8284333,550.7947369,951.6256917,20.7939662,23.651147,1.3352513,71.0684987),(24883,'alpaca_femur.tif',78,7,117,144.6162305,74.1450879,75.8015606,1.8,74.1084622,76.0278726,-1.1324089,10.6767206,13.5836806,5840.6537836,6275.0345911,19.7598014,461.9539277,547.0456713,865.4068856,20.8154813,23.5475532,1.4270577,70.8888725),(24884,'alpaca_femur.tif',78,7,118,144.0904961,74.2513175,75.9586598,1.8,74.2082347,76.1879688,-1.2056324,10.7083041,12.4311937,5855.2723119,6198.5852424,20.9526279,498.6315369,546.7973499,956.3642679,20.8407889,23.3410005,1.3991683,70.8888725),(24885,'alpaca_femur.tif',78,7,119,142.6845675,74.3598363,76.1278606,1.8,74.3103525,76.310904,-1.3134982,10.7346178,12.5872289,5849.4156218,6084.1983099,22.2408559,483.3628071,544.9114017,932.3907648,20.8154813,23.4334723,1.4659194,70.78365),(24886,'alpaca_femur.tif',78,7,120,141.6076824,74.4751405,76.2824158,1.8,74.4538911,76.4544203,-1.5092618,10.5517053,12.6171694,5850.9284414,5992.0366868,23.5120269,474.9113301,554.5007459,936.6816182,20.8154813,23.3410005,1.3991683,70.2755905),(24887,'alpaca_femur.tif',78,7,121,141.3430344,74.5446543,76.4472615,1.8,74.5336558,76.5999245,1.2205646,10.3710544,11.7381059,5852.1834684,5954.5353153,20.7838276,507.2824673,564.2804698,958.7338849,20.8154813,23.1285384,1.4645315,70.5296202),(24888,'alpaca_femur.tif',78,7,122,141.7413742,74.6377155,76.5917143,1.8,74.5948475,76.7680409,1.0227502,10.2879849,10.9561168,5824.5034103,5994.9622324,17.2106537,547.1794738,566.1461881,956.2804062,20.8154813,22.9878514,1.4100336,70.4552167),(24889,'alpaca_femur.tif',78,7,123,144.2540206,74.7111443,76.7312382,1.8,74.6690222,76.84976,0.983609,10.250659,10.7993811,5824.2810148,6191.1780749,16.662783,573.2900822,568.1860094,996.1988639,20.5986534,22.8586417,1.4497691,70.2755905),(24890,'alpaca_femur.tif',78,7,124,144.7137069,74.7737492,76.8650109,1.8,74.7805973,76.9876034,0.9439008,10.2123045,10.8009641,5797.4458081,6244.3021473,15.8186841,578.1245179,567.692219,990.9153976,20.5986534,22.8976865,1.4364749,70.3499941),(24891,'alpaca_femur.tif',78,7,125,145.1874691,74.8570481,77.0291025,1.8,74.8979604,77.1433481,0.8769854,10.1422009,10.7901175,5777.7663139,6283.936168,14.3028037,582.3788442,569.6757929,1001.4807544,20.3818255,22.8236503,1.4631065,69.9163382),(24892,'alpaca_femur.tif',78,7,126,145.5239494,74.9254133,77.1780861,1.8,74.9360626,77.2824413,0.815962,10.0906519,10.8652651,5737.8574403,6335.7576936,12.8678288,583.1203966,568.6309948,995.5348982,20.3818255,22.8586417,1.6918235,70.0959644),(24893,'alpaca_femur.tif',78,7,127,145.8841648,74.9782972,77.3258973,1.8,74.9888292,77.442282,0.7734094,10.1251469,10.7967591,5706.4530582,6373.7801853,11.8655466,590.3419851,563.5921234,1004.499027,20.3818255,22.7927309,1.6651103,70.0959644),(24894,'alpaca_femur.tif',78,7,128,145.7118074,75.0462402,77.4722706,1.8,75.0331189,77.6105608,0.7482957,10.0074672,10.9421094,5659.3886786,6381.8080551,11.2424319,583.2337984,565.5165878,993.4018046,20.1649975,22.8236503,1.6784862,70.0959644),(24895,'alpaca_femur.tif',78,7,129,146.8191521,75.0220671,77.717318,1.8,74.9956972,77.8461238,0.726039,10.0023687,10.9634826,5655.2698342,6435.2148222,10.7858295,586.9681231,565.3930561,1015.3402933,20.1649975,22.6375005,1.7203561,69.6623085),(24896,'alpaca_femur.tif',78,7,130,146.5646762,75.1172808,77.8967887,1.8,75.0933177,78.0350836,0.7285721,10.0458175,10.9464011,5623.9302108,6412.5562238,10.8285927,585.8141108,559.8280288,1004.4100769,20.1649975,22.7927309,1.6651103,69.9163382),(24897,'alpaca_femur.tif',78,7,131,147.0014823,75.1760139,78.0735963,1.8,75.1082942,78.1970112,0.7553499,9.9008657,11.0262581,5598.5185509,6430.1445782,11.5143766,583.1665186,565.4574801,1015.8384825,19.9481696,22.6852175,1.7337228,69.6623085),(24898,'alpaca_femur.tif',78,7,132,147.1018365,75.2258816,78.2297606,1.8,75.2101171,78.353631,0.7877647,9.9326935,10.9368212,5546.7510584,6455.6994953,12.3165058,590.272014,558.4337253,1004.8986684,19.9481696,22.7927309,1.7602765,69.9163382),(24899,'alpaca_femur.tif',78,7,133,145.1245839,75.2689351,78.4046914,1.8,75.2870245,78.5533684,0.7906347,9.8150689,10.8755099,5423.4204763,6404.2433192,12.2203716,588.8683292,552.5606119,980.4409184,19.7313417,22.8236503,1.6784862,69.7367121),(24900,'alpaca_femur.tif',78,7,134,143.7939922,75.3145739,78.5727024,1.8,75.3157221,78.6920318,0.7929496,9.9009754,10.815777,5336.3436213,6379.0560106,12.163802,589.7917457,538.9715065,983.7487389,19.9481696,22.6852175,1.7337228,69.4826824),(24901,'alpaca_femur.tif',78,7,135,142.8050667,75.3614369,78.7362728,1.8,75.3468016,78.8757189,0.7990119,9.7796508,10.751312,5252.4680856,6362.5613368,12.2244017,591.7939468,537.0813546,984.7791308,19.7313417,22.6167227,1.7894653,69.0490265),(24902,'alpaca_femur.tif',78,7,136,143.2052301,75.4250121,78.9307742,1.8,75.4349909,79.0605314,0.813553,9.8754169,10.9212834,5235.4703562,6378.3122296,12.6054013,584.0258877,530.1518312,976.0096853,19.7313417,22.6852175,1.802661,69.2286527),(24903,'alpaca_femur.tif',78,7,137,143.1205473,75.5050177,79.1382009,1.8,75.4753669,79.2732367,0.8088879,9.7659254,10.9157916,5207.9744297,6372.3816708,12.4868172,583.7764145,533.2801774,967.9085526,19.7313417,22.6852175,1.7337228,69.4826824),(24904,'alpaca_femur.tif',78,7,138,142.2914706,75.5540158,79.3486432,1.8,75.5364442,79.4623312,0.814128,9.8583883,10.8925443,5163.207757,6357.6256718,12.5385829,583.6676444,523.7375135,972.2908811,19.7313417,22.6852175,1.802661,69.2286527),(24905,'alpaca_femur.tif',78,7,139,141.8462019,75.5950444,79.5737636,1.8,75.5870065,79.7446686,0.8213502,9.8077062,10.8635581,5125.0823178,6369.0132897,12.6697287,586.273229,522.5566718,963.9477326,19.726551,22.7576382,1.815775,69.2286527),(24906,'alpaca_femur.tif',78,7,140,141.1267114,75.6438568,79.7810518,1.8,75.6420957,79.9578023,0.8163444,9.880257,11.0197819,5076.5610402,6365.6179276,12.4879837,577.6537126,513.8086008,948.688247,19.7313417,22.8339475,1.8288036,69.4082788),(24907,'alpaca_femur.tif',78,7,141,142.1478631,75.6812693,80.0045134,1.8,75.6736371,80.113395,0.8246442,9.8161056,10.9799735,5091.7800683,6434.2702936,12.7744901,586.0005304,518.7169185,969.5909357,19.7313417,22.703862,1.8583722,69.1542491),(24908,'alpaca_femur.tif',78,7,142,142.5322695,75.7115698,80.2370546,1.8,75.6932404,80.4273413,0.8238222,9.7428983,10.9633599,5082.0007243,6475.2921751,12.7895683,590.630265,521.6107735,961.9542616,19.5145137,22.8853638,1.8840725,68.9746229),(24909,'alpaca_femur.tif',78,7,143,142.9621232,75.7592269,80.479159,1.8,75.7590707,80.6893319,0.8193404,9.8549453,10.9644968,5077.0336888,6517.4394597,12.7216316,594.4130024,515.1762409,960.7746807,19.7313417,22.9141065,1.8417432,69.3338752),(24910,'alpaca_femur.tif',78,7,144,142.9769398,75.7948865,80.7308039,1.8,75.8118602,80.9230357,0.8258096,9.8100825,10.9664848,5064.8325998,6555.0714151,12.8766801,597.7367889,516.2884815,972.068798,19.7313417,22.8976865,1.9264322,69.3338752),(24911,'alpaca_femur.tif',78,7,145,143.322595,75.694926,81.0540054,1.8,75.6939609,81.2256659,0.8413643,9.8551229,11.0736625,5056.84874,6642.3095939,13.2776293,599.8295158,513.1187899,971.144594,19.7313417,23.0450453,2.0106389,69.7675311),(24912,'alpaca_femur.tif',78,7,146,142.9588749,75.7208808,81.2929732,1.8,75.7220471,81.4823526,0.8480244,9.8153238,11.1610023,5032.8594083,6693.5390331,13.4015038,599.7256233,512.7553108,961.6629958,19.7313417,23.2340006,1.963557,69.9471572),(24913,'alpaca_femur.tif',78,7,147,143.2418158,75.7429707,81.5431338,1.8,75.7467256,81.7123615,0.8530418,9.7908584,11.3858865,5023.1909389,6771.667479,13.5467964,594.7422269,513.0490832,970.573608,19.5145137,23.3228653,2.0638472,69.9471572),(24914,'alpaca_femur.tif',78,7,148,143.501335,75.7682669,81.7897696,1.8,75.7537589,81.92409,0.8640297,9.7368771,11.461053,5009.4986968,6861.829072,13.8313243,598.708434,514.4872047,973.1423148,19.5145137,23.3530828,2.0931998,70.1267833),(24915,'alpaca_femur.tif',78,7,149,143.1954283,75.7858091,81.984056,1.8,75.7885134,82.1707023,0.869832,9.7409845,11.7208519,4990.7763576,6916.4988292,13.9384792,590.1020571,512.3482508,968.2112109,19.7313417,23.4695578,2.0753568,70.4860356),(24916,'alpaca_femur.tif',78,7,150,144.3355121,75.8174558,82.1716117,1.8,75.8179515,82.3315014,0.8724134,9.7947846,11.8007856,5024.829066,7030.7082907,14.1106408,595.7830732,513.010676,972.2795258,19.7313417,23.5075879,2.1045045,70.7400653),(24917,'alpaca_femur.tif',78,7,151,145.148433,75.8175543,82.3820868,1.8,75.8296709,82.5379613,0.8822826,9.8733129,11.9099527,5074.9416444,7119.815244,14.4248335,597.8038201,514.0059551,981.3335046,19.7313417,23.5934296,2.0576956,70.6656618),(24918,'alpaca_femur.tif',78,7,152,146.3051,75.8011348,82.5732107,1.8,75.8035895,82.7063417,0.8947629,9.9524245,12.0536673,5165.2852164,7204.0756872,14.8376475,597.6667113,518.9976787,986.4259061,19.7313417,23.6650577,2.1156602,70.9196915),(24919,'alpaca_femur.tif',78,7,153,147.5094082,75.800166,82.7535337,1.8,75.813839,82.9333252,0.9026347,10.0407273,12.2687904,5252.551609,7284.7596161,15.148363,593.7634723,523.1246168,999.6001136,19.7313417,23.7404306,2.1910458,71.0993176),(24920,'alpaca_femur.tif',78,7,154,148.2489582,75.8135765,82.9645063,1.8,75.781879,83.1409505,0.9005788,10.157943,12.3804413,5319.3729749,7374.2740271,15.1748768,595.639026,523.6663519,998.9313062,19.9374363,23.8983334,2.1552402,71.4585699),(24921,'alpaca_femur.tif',78,7,155,147.9079475,75.8494282,83.2277941,1.8,75.8772399,83.4240942,0.8951702,10.2041302,12.5679513,5351.3741997,7459.1082438,15.0100036,593.5023185,524.432173,995.8054619,19.9481696,24.1682913,2.1939957,71.638196),(24922,'alpaca_femur.tif',78,7,156,147.6923368,75.8551767,83.5097387,1.8,75.8589614,83.7215671,0.880493,10.2399764,12.7369373,5372.4005147,7577.7512159,14.6344036,594.9429648,524.649697,994.4173924,20.1057166,24.4179443,2.1866663,72.4311042),(24923,'alpaca_femur.tif',78,7,157,148.2893621,75.8436178,83.821261,1.8,75.8266477,83.9922108,0.86633,10.323904,12.8645219,5429.5834507,7738.5054117,14.3489463,601.5385164,525.9234738,1008.7389232,20.1799895,24.6631644,2.2416538,72.7903565),(24924,'alpaca_femur.tif',78,7,158,149.0153776,75.805866,84.1399579,1.8,75.7916665,84.3506264,0.8587538,10.3410904,13.0632561,5502.2493247,7906.9181382,14.2332722,605.2792732,532.0763224,1014.1291176,20.3108523,24.9040825,2.2339993,73.2240123),(24925,'alpaca_femur.tif',78,7,159,150.0870484,75.768887,84.460923,1.8,75.7417166,84.6616346,0.8542912,10.3237366,13.0674845,5562.4850344,8129.5307145,14.2251319,622.1190269,538.805402,1034.9386341,20.3818255,25.0490226,2.2608324,73.6576682),(24926,'alpaca_femur.tif',78,7,160,151.1346991,75.7552803,84.8403269,1.8,75.7451323,85.1478386,0.8467094,10.3948435,13.1825158,5602.6041316,8386.3273608,14.1350661,636.170475,538.9791691,1054.8634236,20.4887186,25.2453273,2.2702002,74.2709502),(24927,'alpaca_femur.tif',78,7,161,154.7631243,75.5825166,85.4128289,1.8,75.5828667,85.7026111,0.8609096,10.3787961,13.1453659,5764.1001931,8840.8229013,14.8372616,672.5429283,555.3727178,1104.9181523,20.6732597,25.4807416,2.2624529,74.8842322),(24928,'alpaca_femur.tif',78,7,162,153.1448333,75.4596123,85.7158555,1.8,75.4861377,86.0253531,0.851649,10.3247031,13.388949,5814.3721677,8953.3471899,14.4481214,668.7117255,563.151514,1101.2382084,20.7939662,25.8471262,2.2974387,75.4975142),(24929,'alpaca_femur.tif',78,7,163,150.7699532,75.3616253,85.989169,1.8,75.3683238,86.2810735,0.8385932,10.3910734,13.4913263,5832.4588203,9048.1312935,13.8983459,670.6628459,561.2951242,1097.8103888,20.8469549,26.0518555,2.3062361,76.3648259),(24930,'alpaca_femur.tif',78,7,164,149.5396874,75.2936591,86.2994159,1.8,75.3323386,86.5242765,0.8273393,10.3507522,13.7084388,5886.2892608,9226.9607685,13.5057253,673.0861833,568.6822709,1100.8297332,20.9817003,26.3443705,2.4468544,76.7984818),(24931,'alpaca_femur.tif',78,7,165,149.0722222,75.2774112,86.6889471,1.8,75.4054152,87.003924,0.8203312,10.4396599,13.8624232,5939.5834629,9462.8128461,13.289903,682.6232833,568.9441514,1110.2042368,21.0323093,26.7411347,2.4292351,77.6657935),(24932,'alpaca_femur.tif',78,7,166,147.682364,75.2380767,87.0020683,1.8,75.3639402,87.2954317,0.8119097,10.4233932,14.0906366,6007.8569017,9694.5472752,12.9591046,688.0134331,576.3820652,1113.9027023,21.0323093,27.1736527,2.4280705,78.2790755),(24933,'alpaca_femur.tif',78,7,167,147.8771744,75.2735696,87.3375973,1.8,75.4270742,87.7675011,0.7913842,10.5686711,14.24399,6068.3883788,10052.3247101,12.4706269,705.723937,574.18651,1131.3605657,21.2491372,27.4884459,2.4668517,79.1463872),(24934,'alpaca_femur.tif',78,7,168,149.7348397,75.2591213,87.7038217,1.8,75.4827429,88.2382451,0.7825847,10.4976405,14.2186426,6230.8278949,10480.3619306,12.4076922,737.0859658,593.545559,1167.8897404,21.2491372,27.9110695,2.520066,80.0881025),(24935,'alpaca_femur.tif',78,7,169,151.342702,75.2396939,88.0476212,1.8,75.5098676,88.713074,0.7746929,10.6660263,14.4378894,6422.4407821,10885.9444983,12.3418845,753.9844767,602.1399744,1190.1380238,21.4659651,28.3390041,2.5175696,81.1350404),(24936,'alpaca_femur.tif',78,7,170,150.5930368,75.2013372,88.3601207,1.8,75.6243792,89.2836378,0.754994,10.8131461,14.9005049,6512.8516649,11265.8166404,11.786781,756.0694548,602.3086699,1192.1519517,21.682793,28.8307775,2.4768182,82.3616044),(24937,'alpaca_femur.tif',78,7,171,149.3688971,75.149435,88.7005725,1.8,75.6972897,89.8235258,0.7416245,10.9363718,15.1678798,6595.1438221,11734.5419245,11.3590622,773.6441782,603.0467796,1205.2101002,21.8636371,29.315906,2.4897235,84.1706314),(24938,'alpaca_femur.tif',78,7,172,149.2792564,75.1338695,89.1252172,1.8,75.7751867,90.4333237,0.7328761,11.0248553,15.4744249,6694.6154548,12290.4559879,11.1355963,794.2431498,607.2293288,1226.1790869,22.0351086,29.8010251,2.4363146,85.5768215),(24939,'alpaca_femur.tif',78,7,173,150.3370508,75.139845,89.5041344,1.8,75.8453,91.0616998,0.7196482,11.1430145,15.850444,6879.607165,12976.1662253,10.8853885,818.6626344,617.3919226,1252.0244613,22.2849895,30.4193436,2.4920432,87.3858486),(24940,'alpaca_femur.tif',78,7,174,151.2992493,75.1856857,89.9002399,1.8,75.9732719,91.5634908,0.7067369,11.3337643,16.4161823,7088.0718469,13671.3023295,10.6328773,832.7942587,625.3943241,1264.1402048,22.5117084,31.3704384,2.4531121,89.6593504),(24941,'alpaca_femur.tif',78,7,175,153.7558774,75.2243945,90.3884731,1.8,75.9498724,92.1780962,0.7019677,11.5318004,17.0953012,7397.6721775,14535.2839589,10.6849101,850.2502431,641.5019248,1281.2229082,22.7963966,32.4300947,2.4432224,91.4991964),(24942,'alpaca_femur.tif',78,7,176,155.6348843,75.3258458,90.8584705,1.8,76.2319372,92.8620874,0.6985882,11.7682811,18.994346,7634.4314338,15456.1971047,10.7290926,813.7262079,648.7295294,1208.5968864,23.0521002,34.7601616,2.4186133,96.6594822),(24943,'alpaca_femur.tif',78,7,177,160.9090113,75.3160132,91.585732,1.8,76.2795466,93.6790144,0.6987758,11.8725442,20.1403034,8147.054111,17420.5796762,11.097633,864.9611325,686.2096259,1269.1861622,23.3114714,36.4954323,2.4812864,101.1012633),(24944,'alpaca_femur.tif',78,7,178,164.7787198,75.3840941,92.0895163,1.8,76.3492272,94.3150245,0.6847405,11.9502917,20.6674125,8490.3232625,18878.9391411,10.9858207,913.4640895,710.4699623,1324.2706293,23.6225214,37.4717309,2.5013649,102.4022309),(24945,'alpaca_femur.tif',78,7,179,167.7967277,75.3847741,92.5197643,1.8,76.5524516,94.8831597,0.6745407,12.1035191,21.4983514,8844.6770205,20354.2837293,10.9081463,946.7834709,730.7525143,1358.1373452,23.8155433,38.7121359,2.5250264,105.5122255),(24946,'alpaca_femur.tif',78,7,180,169.3025262,75.3902822,92.9198921,1.8,76.3911522,95.3259116,0.6615738,12.206923,22.1373308,9127.2378475,21624.5044328,10.6501856,976.8343184,747.7099527,1386.3344321,24.1182766,39.7499475,2.47649,107.5316976),(24947,'alpaca_femur.tif',78,7,181,167.4370537,75.2524081,93.2720723,1.8,75.9505783,95.5769237,0.6487801,12.3311925,22.7475911,9244.662281,22497.5669473,10.187861,989.008763,749.6973448,1394.6093937,24.4106588,40.6030202,2.5116859,109.086695),(24948,'alpaca_femur.tif',78,7,182,165.0645955,75.0088587,93.399995,1.8,75.6874278,95.7264171,0.6217842,12.5159302,23.3777829,9436.2529099,22821.8561939,9.3341382,976.2198715,753.9394012,1375.3893686,24.6147386,41.3499448,2.5247914,110.6725112),(24949,'alpaca_femur.tif',78,7,183,163.7524677,74.7505095,93.5212962,1.8,75.2936102,95.8819998,0.5881579,12.72267,23.6190735,9726.9476176,23004.172231,8.4014756,973.9659034,764.5366562,1368.3046522,24.8975008,41.8517225,2.5332676,112.5867608),(24950,'alpaca_femur.tif',78,7,184,163.3625336,74.3467217,93.4259826,1.8,74.642235,95.5778849,0.5427787,12.9485763,23.7137142,9987.5875485,22467.3712502,7.2639187,947.4421013,771.3270798,1337.4423029,25.094423,42.1037188,2.5374298,113.7389212),(24951,'alpaca_femur.tif',78,7,185,162.6962405,73.9592714,93.4328308,1.8,74.3755656,95.748013,0.4884737,13.1254088,23.3234828,10075.1688797,22437.4411811,5.9715602,962.0107484,767.6080051,1348.4183814,25.2345125,42.0277192,2.5272803,112.4687726),(24952,'alpaca_femur.tif',78,7,186,160.0002096,73.2170069,93.1681136,1.8,73.5034936,95.4301738,0.3833341,13.5109764,22.427558,9866.5050358,21553.9065178,3.7303234,961.0456256,730.2584756,1321.8984557,25.4074655,41.5099504,2.5720306,110.9445943),(24953,'alpaca_femur.tif',78,7,187,156.3997081,72.6228004,93.1736026,1.8,72.4335419,95.1192876,0.2917553,13.7444784,20.4471719,9599.0654911,21171.833717,2.1565749,1035.4406873,698.3943098,1423.0811648,25.4698131,39.5233961,2.6397692,109.1047483),(24954,'alpaca_femur.tif',78,7,188,155.9863237,72.2634832,93.1735937,1.8,71.7467422,94.8844986,0.2418842,13.9264696,20.25143,9388.0676692,21896.2995476,1.4916396,1081.2223899,674.1168378,1481.4028466,25.442585,39.6433568,2.7021618,108.8815375),(24955,'alpaca_femur.tif',78,7,189,157.2171595,71.9701769,93.1905692,1.8,71.047734,94.6579188,0.1979194,14.0820697,20.3033293,9319.2377235,22824.2001481,1.013088,1124.1604654,661.7804001,1521.3734149,25.4370252,40.2261103,2.7256903,110.3621313),(24956,'alpaca_femur.tif',78,7,190,158.0739889,71.6936551,93.3076599,1.8,70.6001004,94.7267247,0.1706039,14.0734363,20.7279077,9251.7862739,23959.0023018,0.7593982,1155.881365,657.3935504,1560.8100558,25.5104086,40.9489177,2.7416172,112.2019773),(24957,'alpaca_femur.tif',78,7,191,160.4018831,71.4530121,93.4734317,1.8,70.176915,94.7778688,0.1476482,14.0091242,21.3034416,9233.8959837,25406.1167324,0.5785706,1192.5827406,659.1344224,1606.5191641,25.5925228,42.000863,2.8452408,114.4010755),(24958,'alpaca_femur.tif',78,7,192,162.3271351,71.239289,93.5331853,1.8,69.8313666,94.8012177,0.1325089,14.2301273,22.0491182,9153.5020435,26875.801701,0.4722661,1218.9059631,643.2480786,1627.0182201,25.757844,43.4457384,2.8332342,117.7215153),(24959,'alpaca_femur.tif',78,7,193,166.992013,70.8945332,93.5361249,1.8,69.3884656,94.6521308,0.1183947,14.6767801,22.9783687,9077.1228595,29498.1675615,0.3883101,1283.736369,618.4682731,1674.814604,26.064485,45.1876898,2.8241339,123.2102343),(24960,'alpaca_femur.tif',78,7,194,171.4975835,70.5011419,93.5420416,1.8,69.2669482,94.5626576,0.107338,14.8920269,23.926898,9044.3058394,31738.8651614,0.3280537,1326.4931003,607.325375,1701.5193804,26.3057468,46.3393298,2.880564,126.0661992),(24961,'alpaca_femur.tif',78,7,195,178.1493734,70.0248247,93.5295195,1.8,69.2704649,94.4559098,0.097096,15.123876,25.1533985,9104.9294134,34032.4035105,0.2790424,1352.9942476,602.0235449,1714.9702047,26.3672795,47.3311087,2.9327618,130.2975352),(24962,'alpaca_femur.tif',78,7,196,185.265893,69.6858888,93.6496423,1.8,69.4130363,94.3773726,0.0896557,15.1985574,26.0902607,9185.2059087,36559.4831168,0.2475349,1401.2693652,604.3472213,1753.3242691,26.4354653,48.2986345,2.9628749,136.3251327),(24963,'alpaca_femur.tif',78,7,197,181.4945157,69.8269311,93.5161279,1.8,69.811188,94.1296441,0.0960158,15.8866274,26.9071784,9134.0736619,39314.1747653,0.2780116,1461.1035822,574.9536025,1800.5245217,26.6122156,49.5061425,2.9672793,162.5113448),(24964,'alpaca_femur.tif',78,7,198,189.0249611,70.3074378,93.6514571,1.8,70.7840212,94.1030889,0.094914,16.424545,28.1164521,9337.052206,45322.5483573,0.2829594,1611.9582994,568.481635,1939.9956525,27.0618744,51.5530919,2.9196979,162.3317187),(24965,'alpaca_femur.tif',78,7,199,198.5573061,71.0488515,93.8384472,1.8,72.0258003,94.1116064,0.096047,16.7166372,29.0063292,9787.6840285,51668.1825295,0.3043449,1781.2727041,585.5055591,2109.2868996,27.5701333,53.4831485,2.916083,165.2493215),(24966,'alpaca_femur.tif',78,7,200,205.2812416,71.8103208,94.1059414,1.8,72.9565699,94.2056743,0.0978047,17.1591849,29.328087,10377.5616239,58207.6429379,0.3262362,1984.7064313,604.7817364,2336.7204068,28.8005064,54.8167425,2.9101817,171.7849784),(24967,'alpaca_femur.tif',78,7,201,215.5107667,72.5870966,94.4374329,1.8,73.3576824,94.503323,0.08351,18.037665,29.3979167,11645.9240206,64811.1955423,0.2499106,2204.6186568,645.6447656,2599.4602373,29.7423236,56.449435,3.0327351,179.0827245),(24968,'alpaca_femur.tif',78,7,202,231.235842,73.4251359,94.8592734,1.8,73.4805971,94.7619737,0.0711313,18.5350851,29.1517498,13373.9215246,73074.3306707,0.194667,2506.6876323,721.5462692,2951.2043981,30.8491492,58.0783235,3.0198572,181.4306299),(24969,'alpaca_femur.tif',78,7,203,249.8750093,74.3871994,94.9797176,1.8,73.4635031,94.9245908,0.0590698,18.4805177,29.8509367,14956.5099508,80897.4935711,0.1451433,2710.0487468,809.3122806,3140.3766965,31.5402741,58.983574,2.9849908,184.2430102),(24970,'alpaca_femur.tif',78,7,204,269.7614816,74.9090717,94.9809361,1.8,73.4596067,95.0126564,0.0554176,18.5359152,30.6328637,16092.4046746,88961.9464256,0.1379366,2904.1341773,868.1742722,3348.5357304,31.7402818,59.497837,2.9967802,184.9306958),(24971,'alpaca_femur.tif',78,7,205,290.2841578,75.4799421,95.0982479,1.8,73.3681058,95.1032579,0.0492394,18.3061957,31.5637032,16967.6462986,96591.3751695,0.1172052,3060.2041342,926.8799793,3548.4430764,31.4771681,60.0217937,0.0869596,182.1799534),(24972,'alpaca_femur.tif',78,7,206,312.0467022,76.0117239,95.2353474,1.8,73.4582277,95.2008396,0.0437458,18.0636655,32.3246743,17386.8809052,102153.071963,0.099463,3160.2196829,962.5333752,3652.4622688,30.8867703,60.3015588,0.081452,181.4922679),(24973,'alpaca_femur.tif',78,7,207,333.1063678,76.3270975,95.3775683,1.8,73.4539995,95.2870028,0.0380571,17.7381896,32.7024665,17351.5747721,105353.9638484,0.0803703,3221.5907545,978.2043834,3723.3262943,30.0954657,60.2547614,0.0713075,178.8903327),(24974,'alpaca_femur.tif',78,7,208,349.2338005,76.5461834,95.5401965,1.8,73.5307496,95.4109629,0.0308616,17.4169734,32.9171455,16825.9824057,105650.4616759,0.0554193,3209.587591,966.0681006,3699.7211286,29.4600154,60.1962135,0.0560636,178.3514543),(24975,'alpaca_femur.tif',78,7,209,367.2659698,76.2219093,95.4649181,1.8,73.5862453,95.6175041,0.0201832,17.236135,32.6247324,15718.293856,104656.530442,0.0249314,3207.8893169,911.938428,3671.4210333,28.1952907,59.9081093,0.061461,175.6442966),(24976,'alpaca_femur.tif',78,7,210,358.5856673,76.2038182,95.5138352,1.8,73.8612021,95.7966151,0.0153411,16.1690129,32.0413169,13624.9798412,98583.5176644,0.0140642,3076.7623522,842.6599663,3441.8239037,26.0973624,59.3332507,0.124355,172.7575127),(24977,'alpaca_femur.tif',78,7,211,312.001369,77.3020561,95.9051011,1.8,74.4615804,96.1682886,-0.0138383,14.7703697,32.913363,10547.2224014,86275.1360484,0.0099573,2621.2798744,714.0797855,2906.5305322,23.803719,58.5836808,0.1048769,174.8769197),(24978,'alpaca_femur.tif',78,7,212,228.2851928,79.9514344,96.9751471,1.8,76.4228335,96.972957,-0.0680844,11.3109547,34.9143642,6707.2088848,66865.5420871,0.1760965,1915.1298775,592.9834453,2106.4224632,13.185563,21.2292151,1.7596935,57.1915111),(24979,'alpaca_femur.tif',78,7,213,185.3260144,80.8609738,97.061151,1.8,77.76892,97.2608173,-0.0792301,9.941127,34.8882005,4446.9479015,53148.7697906,0.1934889,1523.4024408,447.3283482,1650.0638679,10.425794,19.0067955,1.8823432,50.2530173),(24980,'alpaca_femur.tif',78,7,214,134.6873694,82.6055815,97.0127197,1.8,79.7494348,97.2839258,-0.1011515,8.7042677,35.6503767,2336.6005107,33961.3795219,0.2288963,952.6233007,268.4430895,1016.2460495,8.2682086,15.1717588,1.815775,39.1703567),(24981,'alpaca_femur.tif',78,7,215,81.151415,85.5439855,96.7347185,1.8,82.2745949,97.1514641,-0.1118628,7.1791597,36.8502675,855.4743724,13996.7395938,0.1685405,379.8273539,119.1607949,402.706056,5.212897,10.5868888,1.7454685,26.7867285),(24982,'alpaca_femur.tif',78,7,216,18.3519239,90.1191658,96.2556908,1.8,90.2133761,96.3181719,0.5071282,4.5472175,5.1066688,71.2302361,91.0604656,0.7214578,17.8316763,15.6645764,31.324996,9.2642771,10.488736,2.8753406,31.8853763),(24983,'alpaca_femur.tif',78,7,217,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24984,'alpaca_femur.tif',78,7,218,23.534843,74.0790281,110.7029404,1.8,74.2883472,110.675678,-0.0733762,1.7448996,32.5085827,7.3119459,8252.0610334,0.021081,253.8425351,4.1904679,253.8628284,5.6843546,113.9223934,0.1377098,239.9442594),(24985,'alpaca_femur.tif',78,7,219,23.3875313,74.1427327,110.6721181,1.8,74.4923173,110.636905,-0.0727079,1.6973801,32.4419275,7.2483352,8204.7507269,0.0205698,252.9057726,4.2703076,252.9258569,5.6843546,113.9223934,0.1377098,240.1982891),(24986,'alpaca_femur.tif',78,7,220,27.0937439,68.977868,110.7512625,1.8,69.2207773,110.7149547,-0.0534387,2.3573158,37.5725536,15.8621852,12795.7892212,0.012883,340.5621386,6.7289182,340.6237859,9.6113414,149.7416263,0.0737878,315.5395182),(24987,'alpaca_femur.tif',78,7,221,26.907567,69.0964625,110.7292159,1.8,69.0044005,110.7031763,-0.0532237,2.3335859,37.5065662,15.2921062,12610.8396486,0.0126918,336.2301841,6.5530505,336.4909054,9.5471708,149.7416263,0.0737878,315.5395182),(24988,'alpaca_femur.tif',78,7,222,27.0040177,69.0107063,110.720928,1.8,68.8452007,110.6917622,-0.0526398,2.2989358,37.5529055,15.0867465,12439.4854199,0.0124596,331.2522758,6.5624914,331.1672628,9.5407395,149.7416263,0.0737878,315.5395182),(24989,'alpaca_femur.tif',78,7,223,26.9794278,68.6273667,110.7192755,1.8,68.7898862,110.6644517,-0.0519567,2.2518574,37.9342418,14.8958659,12293.813679,0.0121276,324.0822297,6.6149243,324.0063146,9.5193493,149.7416263,0.0737878,315.2854885),(24990,'alpaca_femur.tif',78,7,224,26.6923553,68.1898168,110.7398947,1.8,68.9112547,110.6565871,-0.0512675,2.2245402,38.3708577,14.5888487,12084.2527996,0.0116826,314.9330907,6.5581412,314.8575733,9.4979591,149.7416263,0.0737878,315.2854885),(24991,'windfallLgGiraffe_humerus-cleaned.tif',247,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24992,'windfallLgGiraffe_humerus-cleaned.tif',247,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(24993,'windfallLgGiraffe_humerus-cleaned.tif',247,2,3,0.3753455,92.4599598,138.1204323,1.8,92.4541914,138.0767164,0.5938126,0.8106641,1.9912105,0.0687015,0.4492461,0.0195848,0.2256146,0.0847472,0.2566157,2.1301488,4.5117212,2.4980915,9.9899143),(24994,'windfallLgGiraffe_humerus-cleaned.tif',247,2,4,27.7064776,97.1952911,138.1343463,1.8,97.6302514,138.8585298,0.1959704,10.7468681,15.8961325,184.085101,853.9209201,0.1750831,53.7187848,17.1291859,64.6338422,8.9646037,26.5923773,2.8842689,66.7391316),(24995,'windfallLgGiraffe_humerus-cleaned.tif',247,2,5,119.2711523,94.7107332,139.7529308,1.8,94.2756142,139.3751077,0.3677916,10.7505063,26.8274788,2543.9577236,10759.4339574,2.5699005,401.0601981,236.636086,494.5153944,19.5299266,46.0107091,2.6954871,133.1045),(24996,'windfallLgGiraffe_humerus-cleaned.tif',247,2,6,226.9014143,97.3356895,141.6164693,1.8,97.9874202,142.187827,0.4298043,15.6860375,37.0752445,9217.4692565,52694.2322569,6.5662608,1421.2780776,587.6225432,1648.3124697,26.5776178,67.0245003,2.7110655,197.5103621),(24997,'windfallLgGiraffe_humerus-cleaned.tif',247,2,7,346.8674337,101.033243,144.5921587,1.8,99.9922192,144.3837128,0.4268805,23.2617131,54.4837054,21764.9063036,117213.1802002,9.9102052,2151.3437718,935.6536298,2349.421674,33.8918341,75.7068973,2.5469786,201.1650842),(24998,'windfallLgGiraffe_humerus-cleaned.tif',247,2,8,562.9905427,110.7195043,134.9187884,1.8,113.5318367,131.3457771,-0.6876081,50.2072819,77.3936938,245848.7176443,460967.6621496,37.7984545,5956.1398297,4896.6745108,8319.3411059,39.6170822,80.9612,2.5504989,225.1092705),(24999,'windfallLgGiraffe_humerus-cleaned.tif',247,2,9,1166.5951288,124.509213,119.3541694,1.8,125.8694142,121.3163214,-0.817825,61.3158373,59.4486623,728831.6335269,1381101.9372035,103.5166759,23231.8421368,11886.515223,28508.9779677,45.9598566,85.9124605,2.5127964,237.8703452),(25000,'windfallLgGiraffe_humerus-cleaned.tif',247,2,10,1686.3825157,129.6267338,114.9871588,1.8,130.7672548,117.4449516,-0.7243582,61.2372989,67.8748714,1200327.0553395,1996532.3620137,123.4183423,29414.8971724,19601.2410309,45558.7389239,56.4594005,89.9644453,2.5021036,276.5351125),(25001,'windfallLgGiraffe_humerus-cleaned.tif',247,2,11,2110.6795524,129.8250337,112.8944926,1.8,131.4582611,115.7246439,-0.7109739,63.9587885,70.581076,1589194.4696283,2505193.2559285,149.8055696,35493.8376842,24847.1634189,57114.9293115,109.9781663,137.2305112,0.0328829,689.7575395),(25002,'windfallLgGiraffe_humerus-cleaned.tif',247,2,12,2398.4941977,129.5875003,111.3479313,1.8,131.81609,114.4896352,-0.7186287,66.7597317,72.0322727,1943053.9198883,2924163.2868378,173.262764,40595.1829081,29105.1786866,66143.0049232,114.4382817,139.0561961,0.9188593,675.3653767),(25003,'windfallLgGiraffe_humerus-cleaned.tif',247,2,13,2567.6109793,129.6853995,109.8178477,1.8,131.9624989,113.3025113,-0.7691916,69.2724212,74.2202609,2208190.1152665,3244418.3093479,207.0334503,43713.3778405,31876.9010273,71438.8603768,117.639839,143.7080595,0.9549264,676.9511197),(25004,'windfallLgGiraffe_humerus-cleaned.tif',247,2,14,2676.0787211,130.0540418,108.1274071,1.8,131.9354129,112.1820087,-0.8319605,71.3815675,76.8767139,2403067.9446586,3499825.6639646,243.7439786,45525.1725392,33665.1046999,75421.5096664,122.1594194,146.7807912,0.9844988,655.1666026),(25005,'windfallLgGiraffe_humerus-cleaned.tif',247,2,15,2738.463109,130.1439228,106.7562057,1.8,131.8573288,111.3083729,-0.9036831,73.4006962,83.2763089,2578881.537155,3716249.331004,281.6896125,44625.5289235,35134.2926074,75587.827551,124.7954144,149.0405298,0.9727185,661.9850308),(25006,'windfallLgGiraffe_humerus-cleaned.tif',247,2,16,2790.7101472,130.1044686,105.4980812,1.8,131.8241816,110.4402835,-0.9627328,74.7534359,84.2003687,2723051.7910536,3895720.8658009,313.3223777,46267.2661309,36427.1121123,78551.9938359,127.0384534,150.8035649,0.9985601,520.1479413),(25007,'windfallLgGiraffe_humerus-cleaned.tif',247,2,17,2852.5953904,129.8711966,103.8695756,1.8,131.7173809,109.1856459,-0.9956208,76.0307439,88.4392527,2850288.5340669,4093222.6120277,334.7442358,46282.8719845,37488.6314327,77673.9955741,129.1745665,152.5662399,1.0024794,532.4711252),(25008,'windfallLgGiraffe_humerus-cleaned.tif',247,2,18,2907.8906531,129.5086418,102.9731677,1.8,131.550113,108.434057,-1.0163096,76.6129723,81.759296,2947069.4932974,4236161.863633,350.2992396,51812.6019858,38466.9776397,87823.0922891,130.738017,153.7921288,0.9901166,538.4137717),(25009,'windfallLgGiraffe_humerus-cleaned.tif',247,2,19,2950.7471465,129.3408399,102.077063,1.8,131.3250733,107.769223,-1.0351195,77.3155153,91.0178563,3039852.4293289,4395885.1661797,363.6639154,48296.9534029,39317.495543,77296.676305,132.4486956,154.6757277,0.9407133,570.8262569),(25010,'windfallLgGiraffe_humerus-cleaned.tif',247,2,20,3039.967593,129.4317277,101.3905706,1.8,131.1636338,107.0759925,-1.0411146,77.1294053,88.1577373,3133092.4977902,4506576.8222254,377.3175593,51119.4701698,40621.2453559,84603.5876748,132.8084125,155.4770818,0.9336793,562.7958488),(25011,'windfallLgGiraffe_humerus-cleaned.tif',247,2,21,3181.3430456,129.3471654,100.5112917,1.8,130.8060643,106.3658414,-1.0220885,105.8069941,93.7802146,3194973.5159429,4625880.6034791,385.9758413,49326.8289452,30196.2412215,73179.768446,133.0966898,156.0436038,0.989209,543.7637095),(25012,'windfallLgGiraffe_humerus-cleaned.tif',247,2,22,3268.6019498,128.9720396,99.4003569,1.8,130.417336,105.6289239,-0.9997226,93.4177584,85.2114017,3165354.1286529,4691935.0120883,385.5975832,55062.2911567,33883.8587171,84077.7351987,132.7646735,156.1739976,0.99321,577.60712),(25013,'windfallLgGiraffe_humerus-cleaned.tif',247,2,23,3280.6131276,128.7845945,98.8983168,1.8,130.095419,105.0595257,-1.0227157,76.8120782,95.0825243,3140361.6302207,4652615.6017242,398.3249079,48932.39461,40883.6957113,79229.0035753,131.4394875,156.1374983,0.9475237,547.4184316),(25014,'windfallLgGiraffe_humerus-cleaned.tif',247,2,24,3258.654956,128.6869504,98.3239483,1.8,129.6354951,104.4790566,-1.0295756,75.3854771,85.3505657,3079430.3530646,4649160.7834001,398.9608574,54471.3529174,40849.1193584,90472.3489174,129.6868282,155.245174,0.9505468,564.9743006),(25015,'windfallLgGiraffe_humerus-cleaned.tif',247,2,25,3311.7307767,128.1969538,97.9139518,1.8,129.0714002,103.696764,-1.0465057,72.8427909,82.8370849,3032279.4632887,4639090.402655,413.6355299,56002.5791361,41627.7222003,90573.8467871,127.252556,154.6651992,0.986839,576.2403224),(25016,'windfallLgGiraffe_humerus-cleaned.tif',247,2,26,3303.0528639,128.0127221,97.421097,1.8,128.5615927,103.2232932,-1.027969,69.8085203,92.4116988,2922710.1295726,4601324.3126844,403.6148296,49791.5780383,41867.5273171,78651.5917633,123.3627804,153.8027171,0.9689622,531.5312158),(25017,'windfallLgGiraffe_humerus-cleaned.tif',247,2,27,3281.3534556,127.5902176,97.2172576,1.8,128.1727522,102.9818778,-1.0067827,67.5325425,84.95698,2823507.1749464,4584377.5806087,390.6022257,53961.1645718,41809.57909,87166.3129,119.7734922,153.1142853,1.059691,519.6271403),(25018,'windfallLgGiraffe_humerus-cleaned.tif',247,2,28,3257.3088322,127.1354474,98.2645363,1.8,127.925468,102.9585175,-1.0190546,64.7718393,82.1669952,2780199.724852,4549328.6419938,393.7242045,55366.861494,42922.9701215,89120.3952734,116.5294887,152.7522496,1.0172064,514.058257),(25019,'windfallLgGiraffe_humerus-cleaned.tif',247,2,29,3252.2629803,126.7419552,100.0199613,1.8,127.8354645,103.1119787,-1.039785,112.2138996,89.598939,2730459.0581382,4608892.6716985,403.0384932,51439.1433968,24332.6278421,62564.2022284,112.7507037,151.435975,1.0431508,492.319085),(25020,'windfallLgGiraffe_humerus-cleaned.tif',247,2,30,3154.8015885,126.733592,101.031826,1.8,128.0667584,102.9063567,-1.0756524,59.1586223,78.6566805,2545330.2940697,4543675.2977899,407.0874832,57765.9172575,43025.516762,90079.2251337,109.6668693,149.3052556,1.0557731,498.0615686),(25021,'windfallLgGiraffe_humerus-cleaned.tif',247,2,31,2976.4274372,126.5659284,101.4666762,1.8,127.8311423,103.0857191,-1.0819366,57.6629452,92.1317806,2277251.1103452,4325521.1008212,386.6664609,46949.2836359,39492.4522559,70384.0309141,108.426034,147.7311429,1.1290032,462.1491791),(25022,'windfallLgGiraffe_humerus-cleaned.tif',247,2,32,2762.7579216,126.5620623,102.2040127,1.8,127.8212921,103.6773688,-1.0752753,56.9150259,74.893223,1952111.5986241,4058303.6140385,356.3539446,54187.8617873,34298.7035065,80167.2611297,105.3265523,145.683192,1.1154588,503.5961093),(25023,'windfallLgGiraffe_humerus-cleaned.tif',247,2,33,2551.2694191,126.5671399,103.0889598,1.8,128.0181143,104.2211877,-1.0977245,53.2576173,82.115588,1626071.7040308,3760780.5754449,336.9409713,45798.6195726,30532.1902638,61071.4678872,99.2169793,142.4311161,1.1979369,500.4621883),(25024,'windfallLgGiraffe_humerus-cleaned.tif',247,2,34,2351.1362114,125.8211123,104.7269228,1.8,127.4209504,105.4770563,-1.1193917,57.8345232,71.4018084,1364175.3791507,3437871.6881203,317.2871887,48148.2439303,23587.5616115,67168.9882375,94.1673063,140.8423228,1.0138948,527.3135702),(25025,'windfallLgGiraffe_humerus-cleaned.tif',247,2,35,2166.5883214,125.0555654,107.3528988,1.8,126.6762389,107.4682066,-1.1101,55.6520102,100.1522118,1155058.0344731,3100085.4503269,289.7291145,30953.7392442,20755.0101302,41387.4051715,90.9504572,138.3929579,1.0560982,483.9634814),(25026,'windfallLgGiraffe_humerus-cleaned.tif',247,2,36,1978.2822272,124.7239954,109.5523094,1.8,125.7736426,109.9932575,-1.1032291,47.4930468,97.0385955,998718.6692875,2661604.2177655,262.7340426,27428.3052401,21028.7344577,35096.4863418,0.8075389,1.6267242,0.9827937,3.4545592),(25027,'windfallLgGiraffe_humerus-cleaned.tif',247,2,37,1831.0845097,124.5962593,110.7588757,1.8,124.8861976,111.6128274,-1.1153816,46.1632684,88.1640929,900315.8041125,2328766.4551278,246.1421146,26414.0011824,19502.8609469,32447.0178324,84.0697877,131.8349338,1.2577036,415.1819333),(25028,'windfallLgGiraffe_humerus-cleaned.tif',247,2,38,1670.4117363,124.4391765,113.2827859,1.8,124.2036176,114.1493827,-1.0648809,43.6472187,100.9535892,782360.0377352,1959695.1195047,213.0205599,19411.841959,17924.6252276,25585.4241897,81.3003031,125.1382633,1.3932002,446.027458),(25029,'windfallLgGiraffe_humerus-cleaned.tif',247,2,39,1546.7019467,124.3033285,115.0414847,1.8,123.4924014,117.0873648,-1.0274924,50.0252272,103.3945524,695449.6918777,1710313.639212,188.889728,16541.6223461,13901.9796767,22678.3666544,77.7330886,118.2742363,1.0028968,379.4243616),(25030,'windfallLgGiraffe_humerus-cleaned.tif',247,2,40,1472.84525,124.1423246,116.4856479,1.8,122.9955825,118.8433179,-1.00979,44.1379002,104.3764342,635687.5409552,1567060.8270529,175.9890497,15013.550129,14402.3059134,20548.7155585,75.3620304,116.1327911,0.995724,369.6080476),(25031,'windfallLgGiraffe_humerus-cleaned.tif',247,2,41,1416.6394122,124.1183698,117.6897645,1.8,122.6365763,120.3683864,-0.9970394,47.4460401,110.8348755,583244.7177592,1454956.5088244,166.5443187,13127.2444911,12292.8007555,18360.7528068,0.4511721,0.6380537,2.3561945,1.2761075),(25032,'windfallLgGiraffe_humerus-cleaned.tif',247,2,42,1371.3730591,124.0552652,118.6155461,1.8,122.3414725,121.5397137,-0.98972,46.9954223,105.128267,541734.9639396,1369212.3078747,159.6924051,13024.2069714,11527.3985662,17466.3828627,70.8594749,111.8843189,0.9660168,359.6634784),(25033,'windfallLgGiraffe_humerus-cleaned.tif',247,2,43,1340.4112847,123.9246564,119.5608222,1.8,121.9569311,122.7602379,-0.9821205,38.6674203,109.8242257,509361.3346987,1303747.3612511,154.5239794,11871.2183301,13172.8812095,16282.3899605,68.7204087,110.0055341,0.9987196,340.9144121),(25034,'windfallLgGiraffe_humerus-cleaned.tif',247,2,44,1309.3460667,123.8719071,120.2908346,1.8,121.8076642,123.7130537,-0.9743257,36.2240826,111.1041105,478817.4014418,1237632.3194607,149.366683,11139.3927211,13218.2064123,15447.2148383,66.7376249,108.3790193,0.9989586,334.7528202),(25035,'windfallLgGiraffe_humerus-cleaned.tif',247,2,45,1282.3978054,123.7681533,121.0826077,1.8,121.6028569,124.6229854,-0.9722381,36.4850769,112.7870149,451254.1708415,1184039.5757375,145.8774311,10498.0132414,12368.1847342,14445.2887926,65.2707222,106.7915932,1.0144361,320.8892384),(25036,'windfallLgGiraffe_humerus-cleaned.tif',247,2,46,1261.0760248,123.7815658,121.647175,1.8,121.433716,125.2900267,-0.9681492,54.9011188,111.1183759,428258.7218445,1135486.6248468,142.6506348,10218.7114971,7800.5463513,14032.1539194,64.5351675,105.2633971,1.0553716,327.0054852),(25037,'windfallLgGiraffe_humerus-cleaned.tif',247,2,47,1245.5130983,123.7730262,122.1553755,1.8,121.2453077,125.9688546,-0.9618577,37.8467273,113.1211164,410136.8930837,1090583.8962863,139.667526,9640.8516026,10836.7862254,13175.2350257,62.2782071,103.6969829,1.0467933,306.2781301),(25038,'windfallLgGiraffe_humerus-cleaned.tif',247,2,48,1226.711838,123.7157725,122.6710275,1.8,121.0105706,126.5266534,-0.9565767,58.3174374,113.1009312,394334.221705,1043885.2147118,136.5440922,9229.6783404,6761.8578425,12596.4861051,60.635847,102.2410185,1.0538396,281.4581621),(25039,'windfallLgGiraffe_humerus-cleaned.tif',247,2,49,1216.662696,123.8668443,123.1070156,1.8,121.0320337,126.9896115,-0.9539947,47.7343036,113.5697746,377887.8810256,1001812.3001549,134.9319049,8821.1172727,7916.484635,12147.8159819,60.2886909,100.6184643,1.0549872,291.7123669),(25040,'windfallLgGiraffe_humerus-cleaned.tif',247,2,50,1196.4742922,123.9560106,123.4771109,1.8,120.9770765,127.325767,-0.9511195,36.796512,113.1794072,361280.5144632,960284.090067,132.1513276,8484.6184843,9818.3359006,11540.3632133,58.0027452,98.9960469,1.0561725,264.4496566),(25041,'windfallLgGiraffe_humerus-cleaned.tif',247,2,51,1184.0573588,123.9950364,123.8825603,1.8,121.1198543,127.540276,-0.9482258,33.6008196,110.8064206,347795.5692245,921387.7913048,130.2393767,8315.2924398,10350.806133,11309.8971931,57.3795582,97.2042983,1.0510745,270.4564308),(25042,'windfallLgGiraffe_humerus-cleaned.tif',247,2,52,1166.5493595,124.0765173,124.107018,1.8,121.1680008,127.8089584,-0.9470313,31.127074,50.7812263,334623.9308576,889314.6502777,128.0934791,17512.6659073,10750.2533242,23894.8073958,57.4566982,95.5814291,1.0522357,276.025314),(25043,'windfallLgGiraffe_humerus-cleaned.tif',247,2,53,1154.2659714,124.1411464,124.3607427,1.8,121.1891213,128.0401238,-0.9465114,31.4935668,116.7880831,323890.7628403,856929.2614132,126.6498366,7337.4717598,10284.3467865,10110.7583583,57.9581131,94.1210364,1.0040671,293.8454735),(25044,'windfallLgGiraffe_humerus-cleaned.tif',247,2,54,1135.6696244,124.106113,124.7021037,1.8,121.2429497,128.3469476,-0.9452876,35.7525486,115.4396147,313991.9503711,825869.9041795,124.3895765,7154.129079,8782.3655211,9868.6580086,55.7887641,92.7375491,1.0003358,262.799786),(25045,'windfallLgGiraffe_humerus-cleaned.tif',247,2,55,1129.3941692,124.1571475,124.8628685,1.8,121.3209361,128.4476464,-0.9476051,43.1424231,117.3349374,307575.5583324,802048.7088557,124.1160204,6835.5489562,7129.3065283,9454.27712,0.4511721,0.6380537,2.3561945,1.2761075),(25046,'windfallLgGiraffe_humerus-cleaned.tif',247,2,56,1121.8061461,124.1941056,124.9826434,1.8,121.3243929,128.5395666,-0.9484658,54.3518465,49.6661712,301520.6515219,778560.2355707,123.434616,15675.8658242,5547.5696032,19705.3469417,53.6551174,90.2457031,1.0063677,241.9629581),(25047,'windfallLgGiraffe_humerus-cleaned.tif',247,2,57,1116.946394,124.2771953,125.1522204,1.8,121.763526,128.2869486,-0.9506585,44.2206049,114.4126953,293260.0041585,760612.5273636,123.2862635,6647.9731559,6631.7501748,9175.6432189,54.1286243,88.9083865,1.0208036,255.7811949),(25048,'windfallLgGiraffe_humerus-cleaned.tif',247,2,58,1102.7519209,124.2904775,125.3532397,1.8,121.7302366,128.5833083,-0.953248,40.5249189,46.4600769,285653.5958323,738925.2229395,122.169272,15904.5199992,7048.8381854,21684.1905965,53.3140249,87.9033364,1.0198138,238.7726895),(25049,'windfallLgGiraffe_humerus-cleaned.tif',247,2,59,1083.9723115,124.2769063,125.4996607,1.8,122.0049511,128.6631011,-0.9567471,34.0695683,110.8428074,278698.4226375,715942.0775571,120.6849005,6459.0756414,8180.274548,8966.3342396,53.8813657,86.9931925,1.0072493,269.4446138),(25050,'windfallLgGiraffe_humerus-cleaned.tif',247,2,60,1081.6154999,124.2571126,125.5820933,1.8,122.1010875,128.7275653,-0.9611722,29.9905519,46.407944,274391.9982972,700849.5567387,121.1726291,15101.9307677,9149.2813967,20853.9953938,53.4464206,86.0426758,1.0249812,246.9579153),(25051,'windfallLgGiraffe_humerus-cleaned.tif',247,2,61,1076.3541251,124.3534324,125.7078868,1.8,122.4545704,128.6339274,-0.9653755,31.4656008,117.7768408,269941.1552346,684678.7673226,121.2900238,5813.3565373,8578.929014,8102.3570102,52.604587,84.9857875,1.0048814,241.2154317),(25052,'windfallLgGiraffe_humerus-cleaned.tif',247,2,62,1068.8709026,124.3810399,125.7814609,1.8,122.6269016,128.6617869,-0.9658785,34.2368987,116.9357703,265489.3420709,666782.9923713,120.5306184,5702.1302446,7754.4798736,7970.393832,0.4511721,0.6380537,2.3561945,1.2761075),(25053,'windfallLgGiraffe_humerus-cleaned.tif',247,2,63,1071.8032234,124.4966695,125.7901369,1.8,122.8791093,128.6705868,-0.9691333,101.2408266,117.4953853,263817.6919114,653086.0271569,121.4045585,5558.3972533,2605.8429257,7801.0351118,52.5839892,83.2226085,0.9978302,257.8048288),(25054,'windfallLgGiraffe_humerus-cleaned.tif',247,2,64,1076.8566007,124.6005431,125.6998154,1.8,122.9477372,128.3659913,-0.9744509,43.5652307,117.1179476,262550.2953928,638381.680273,122.865783,5450.7587725,6026.6017429,7680.4603833,0.4511721,1.0088515,2.677945,1.9141612),(25055,'windfallLgGiraffe_humerus-cleaned.tif',247,2,65,1080.5378852,124.9093412,125.5786298,1.8,123.5087776,127.8724573,-0.9740808,39.7409547,109.5101005,258517.9233227,619129.1170251,123.2238612,5653.6256882,6505.0758237,7796.8234582,52.3155052,81.3524767,1.0027911,263.7021302),(25056,'windfallLgGiraffe_humerus-cleaned.tif',247,2,66,1079.1403171,125.085339,125.4974039,1.8,123.8559099,127.6972421,-0.976416,35.6040545,112.4605311,253862.0603479,601482.8633454,123.4545689,5348.3907394,7130.1446882,7597.1301196,52.0013794,80.2490509,1.0139849,243.7676466),(25057,'windfallLgGiraffe_humerus-cleaned.tif',247,2,67,1083.4390558,125.2694149,125.4162866,1.8,124.2084196,127.441651,-0.9776567,32.692968,112.0063908,251229.4352269,585885.4203226,124.1541242,5230.8213506,7684.50988,7436.742379,0.4511721,1.0088515,2.0344439,2.1784517),(25058,'windfallLgGiraffe_humerus-cleaned.tif',247,2,68,1083.2344509,125.4874635,125.3147753,1.8,124.5829954,127.1797673,-0.9772746,28.6880896,115.387079,248672.9319314,569066.8277719,124.066726,4931.8072052,8668.1593327,7085.0906255,0.4511721,1.0088515,2.677945,1.9141612),(25059,'windfallLgGiraffe_humerus-cleaned.tif',247,2,69,1081.3774007,125.7455268,125.266863,1.8,124.8834384,126.9286596,-0.9765469,28.4763878,115.7404713,246492.7704042,552721.8798693,123.7323833,4775.5281609,8656.0406532,6888.8606999,51.6627759,77.4230292,0.9342881,269.3351411),(25060,'windfallLgGiraffe_humerus-cleaned.tif',247,2,70,1088.1262168,125.9444952,125.2103843,1.8,125.1342266,126.8508943,-0.9743301,28.4957805,46.297211,246664.4666197,537731.3757112,124.1312513,11614.7682361,8656.17515,16893.0496753,0.4511721,1.4267315,1.8925469,3.080796),(25061,'windfallLgGiraffe_humerus-cleaned.tif',247,2,71,1091.7265723,126.1609307,125.1384692,1.8,125.3168491,126.7915283,-0.976994,31.0006238,39.9332051,246833.0369872,524674.6828639,124.9920148,13138.8072093,7962.1958241,19218.7019332,51.5568515,75.2862852,1.0293491,241.6986676),(25062,'windfallLgGiraffe_humerus-cleaned.tif',247,2,72,1091.5370182,126.361696,125.0960049,1.8,125.6317356,126.6997698,-0.9741567,100.4402342,39.3175559,246775.5460764,511167.5781792,124.491022,13001.0008661,2456.9391738,7533.6274541,50.7252719,74.2805267,1.0282935,223.5688725),(25063,'windfallLgGiraffe_humerus-cleaned.tif',247,2,73,1101.0858435,126.7171691,124.9716194,1.8,126.0425183,126.2080143,-0.9734264,40.4786709,38.7229669,247280.0638193,498620.8265609,125.4554663,12876.6173147,6108.8978048,18416.7961684,51.6891743,73.2206625,0.9605752,266.3184728),(25064,'windfallLgGiraffe_humerus-cleaned.tif',247,2,74,1099.6818603,126.9276978,124.8967209,1.8,126.3474279,125.9882049,-0.9716542,31.1025303,113.3430161,246186.3571552,485330.2964745,124.9931654,4281.9603109,7915.3160448,6453.7074843,51.9502661,73.20259,0.9827937,297.8286137),(25065,'windfallLgGiraffe_humerus-cleaned.tif',247,2,75,1104.8781588,127.1455391,124.7374792,1.8,126.639525,125.6519062,-0.9696671,30.1376516,106.7617828,246473.2957056,473013.2817443,125.2427172,4430.5487359,8178.2515502,6599.5463116,0.8755408,2.4296362,1.1902899,5.2592477),(25066,'windfallLgGiraffe_humerus-cleaned.tif',247,2,76,1109.50598,127.3264755,124.7063611,1.8,126.8636538,125.5621628,-0.9703419,99.1412891,103.3657586,247522.0492928,462227.7238575,125.8836643,4471.768312,2496.6595805,6715.1894139,52.9596917,70.5705891,1.0413413,254.4597423),(25067,'windfallLgGiraffe_humerus-cleaned.tif',247,2,77,1124.1989194,127.5320251,124.6230773,1.8,127.1829032,125.3476207,-0.9715178,29.3481481,109.0688593,249106.840192,454439.5016556,127.7560429,4166.5375865,8487.9917882,6381.2234525,0.4511721,1.8602303,1.815775,3.9831402),(25068,'windfallLgGiraffe_humerus-cleaned.tif',247,2,78,1130.2454663,127.695175,124.5392783,1.8,127.342245,125.1379585,-0.9729782,28.9426755,35.7488163,249856.1619274,444078.1032462,128.6993017,12422.1764289,8632.7942196,18919.5492385,51.7254437,68.7871051,1.0337514,232.830043),(25069,'windfallLgGiraffe_humerus-cleaned.tif',247,2,79,1147.3314256,127.8598022,124.4074638,1.8,127.5799501,124.908552,-0.977274,29.2326667,35.2172079,252600.6432633,437019.4711589,131.4078736,12409.259485,8641.0400359,19271.9898231,51.6982916,68.0208375,1.0804488,264.5137843),(25070,'windfallLgGiraffe_humerus-cleaned.tif',247,2,80,1161.2238953,127.926347,124.3064892,1.8,127.6080462,124.7779161,-0.9809322,30.6123287,34.7224795,254623.0263554,430396.5561265,133.6545509,12395.3289633,8317.6627573,18973.5802408,51.7814149,67.2670249,1.0591376,243.941247),(25071,'windfallLgGiraffe_humerus-cleaned.tif',247,2,81,1173.2564157,128.1965039,124.2629741,1.8,127.7850424,124.7940139,-0.9810022,32.8173487,34.1562894,255812.9746028,422489.815557,135.0521245,12369.3124492,7795.0530667,19547.6629316,51.8056737,66.4817088,1.052492,245.2626995),(25072,'windfallLgGiraffe_humerus-cleaned.tif',247,2,82,1177.0265248,128.2269566,124.2325539,1.8,127.9654905,124.7161807,-0.9833612,31.0748575,106.3073068,256045.1371705,414313.3282308,135.9134939,3897.3175089,8239.6238591,6195.3862028,0.4511721,1.4267315,1.8925469,3.080796),(25073,'windfallLgGiraffe_humerus-cleaned.tif',247,2,83,1188.7764103,128.2831621,124.1630964,1.8,128.0330175,124.5690472,-0.9887443,29.9713609,103.698805,256985.2362,407591.5116133,138.2520771,3930.5323891,8574.3599333,6214.9735499,0.4511721,3.1902687,1.7126934,6.6901729),(25074,'windfallLgGiraffe_humerus-cleaned.tif',247,2,84,1206.3991414,128.3708898,124.0359249,1.8,128.3003787,124.3405248,-0.9927977,32.4169915,33.59681,258472.082976,402587.0514483,141.0487778,11982.8951325,7973.3519803,19243.6703035,0.4511721,1.4267315,1.8925469,3.080796),(25075,'windfallLgGiraffe_humerus-cleaned.tif',247,2,85,1217.1653567,128.3768137,123.9437694,1.8,128.1452932,124.1484811,-0.9933394,29.28188,104.9695495,260166.2563283,397380.6703811,142.4080812,3785.6756779,8884.8891009,6071.8378358,52.4580964,63.9869604,1.0787652,235.7560211),(25076,'windfallLgGiraffe_humerus-cleaned.tif',247,2,86,1218.9596128,128.3556241,123.8302774,1.8,128.0749793,124.0831385,-0.9966612,30.0463338,32.7668935,261138.053922,391348.8691338,143.2344305,11943.422972,8691.1786149,19871.3458141,52.4094038,63.4598891,1.0498865,222.8401286),(25077,'windfallLgGiraffe_humerus-cleaned.tif',247,2,87,1223.6277136,128.3644914,123.6346282,1.8,128.1117485,123.8412125,-1.0080856,30.6195733,32.6187481,263049.4190744,387852.7011759,145.8968234,11890.4839552,8590.8910691,19857.6990688,0.4511721,1.8602303,1.815775,3.9831402),(25078,'windfallLgGiraffe_humerus-cleaned.tif',247,2,88,1223.2223898,128.4373655,123.4604204,1.8,128.2519275,123.5758112,-1.0138603,29.3029834,31.6379203,263362.3880903,382751.2967272,146.9079943,12097.8652555,8987.5622798,19602.604242,0.4511721,0.6380537,2.3561945,1.2761075),(25079,'windfallLgGiraffe_humerus-cleaned.tif',247,2,89,1223.8297894,128.5906339,123.2376682,1.8,128.4317849,123.3801812,-1.0135429,33.3253073,95.8009088,263326.9638807,375957.6704442,146.9228384,3924.3643427,7901.711497,6302.6117065,54.2070346,61.6143222,1.058008,245.9648809),(25080,'windfallLgGiraffe_humerus-cleaned.tif',247,2,90,1219.0200012,128.6027946,123.0273871,1.8,128.4134436,123.2429952,-1.0097707,29.7885581,31.7267182,261853.9411634,368654.8769736,145.6561494,11619.6977756,8790.4201353,19457.4465913,0.4511721,1.4267315,1.8925469,3.080796),(25081,'windfallLgGiraffe_humerus-cleaned.tif',247,2,91,1209.0548107,128.5818867,122.8463819,1.8,128.4567027,123.0708164,-1.0092364,29.1218437,31.5515939,260423.8894014,360480.8254771,144.3684172,11425.1225035,8942.5618769,19671.7847824,53.4725332,60.6067088,1.1571071,226.4495056),(25082,'windfallLgGiraffe_humerus-cleaned.tif',247,2,92,1196.9153925,128.5272759,122.7210747,1.8,128.4186119,122.9314037,-1.0031496,29.4323732,31.0729904,260031.8371856,352510.6359686,141.8211521,11344.5996335,8834.8919576,19407.5134292,0.4511721,1.0088515,2.0344439,2.1784517),(25083,'windfallLgGiraffe_humerus-cleaned.tif',247,2,93,1192.3154522,128.4106378,122.5435637,1.8,128.2363578,122.6297188,-1.0025115,29.3830505,30.8828318,260809.374633,346059.2932904,141.1610969,11205.5557543,8876.1844015,19118.946577,0.4511721,2.7443729,1.735945,5.7878287),(25084,'windfallLgGiraffe_humerus-cleaned.tif',247,2,94,1194.1778072,128.2650961,122.3365314,1.8,128.1007517,122.3764274,-1.0059912,31.4668299,106.8431293,263177.3902034,341657.5644468,142.0088592,3197.7495114,8363.6448489,5495.8350022,53.9061743,59.3698629,1.1479424,218.3737525),(25085,'windfallLgGiraffe_humerus-cleaned.tif',247,2,95,1191.7741159,128.1367735,122.1816475,1.8,127.8963261,122.1770847,-0.9982763,30.7511175,30.1859284,264988.3559043,337831.6010532,140.33236,11191.6915977,8617.1943567,19594.1656312,53.575789,58.9863337,1.2030733,232.0825165),(25086,'windfallLgGiraffe_humerus-cleaned.tif',247,2,96,1184.573775,128.0230886,122.00526,1.8,127.8528883,121.9478172,-0.9811532,30.0366878,108.1180685,266913.6157415,332740.1929401,136.3824207,3077.5632364,8886.2532879,5437.7686425,53.3842524,58.6523759,1.1760052,222.5758381),(25087,'windfallLgGiraffe_humerus-cleaned.tif',247,2,97,1193.4437092,127.9230633,121.7813153,1.8,127.7061205,121.6512968,-0.973129,30.6973638,29.9236021,270789.4459516,328496.7960676,135.9234979,10977.8493675,8821.2605931,19487.5631221,0.9023442,1.2761075,2.3561945,2.5522149),(25088,'windfallLgGiraffe_humerus-cleaned.tif',247,2,98,1195.9406663,127.7801715,121.6342248,1.8,127.6171798,121.4934105,-0.9584655,29.6569611,30.0336306,272447.7399704,325271.3285123,133.4733753,10830.236702,9186.6371431,19626.0209297,0.4511721,2.7443729,1.735945,5.7878287),(25089,'windfallLgGiraffe_humerus-cleaned.tif',247,2,99,1200.482192,127.576033,121.4378066,1.8,127.4349843,121.1695419,-0.9449682,30.1327948,30.0323572,275635.7817319,322248.8987295,131.4278058,10730.0567944,9147.3686217,19719.3399379,0.4511721,2.3005355,1.7681919,4.8854845),(25090,'windfallLgGiraffe_humerus-cleaned.tif',247,2,100,1210.8712113,127.3886991,121.274325,1.8,127.2900067,121.0668136,-0.9267052,30.660084,106.8608308,280551.7997442,321882.3697455,129.045268,3012.1642082,9150.392414,5561.5161756,0.4511721,1.0088515,2.0344439,2.1784517),(25091,'windfallLgGiraffe_humerus-cleaned.tif',247,2,101,1222.1931352,127.244016,121.0929905,1.8,127.1163228,120.7877867,-0.8904445,30.4814286,108.3687095,285838.6171201,322812.0855362,123.0901849,2978.831132,9377.4678513,5571.1298857,55.0159778,57.7094825,1.1176378,246.4293343),(25092,'windfallLgGiraffe_humerus-cleaned.tif',247,2,102,1233.1595758,127.0627007,120.9524386,1.8,126.9968758,120.6154638,-0.8427932,49.8740297,108.9579993,291270.7378352,323797.2385812,114.5336186,2971.7619693,5840.1284055,5628.8119476,0.8075389,1.6267242,2.5535901,3.1902687),(25093,'windfallLgGiraffe_humerus-cleaned.tif',247,2,103,1248.1030744,126.8230223,120.7400638,1.8,126.667688,120.3875186,-0.7591621,30.5532953,30.5649881,298133.5538781,326789.2367299,98.5535317,10691.6199456,9757.8199205,20338.7049957,0.4511721,0.6380537,2.3561945,1.2761075),(25094,'windfallLgGiraffe_humerus-cleaned.tif',247,2,104,1268.8004924,126.627356,120.544211,1.8,126.5965613,120.0089514,-0.6365353,30.7202917,106.8093976,305938.5358172,331042.1961362,74.7168283,3099.3733108,9958.8421589,5757.0938634,0.4511721,0.6380537,2.3561945,1.2761075),(25095,'windfallLgGiraffe_humerus-cleaned.tif',247,2,105,1291.5764667,126.3806248,120.3852692,1.8,126.3272836,119.8597381,-0.4315078,48.3794072,99.7039104,313925.2112816,336668.3368662,37.6549286,3376.6813695,6488.8188933,5870.636134,56.3965153,58.86197,1.6552106,266.3450353),(25096,'windfallLgGiraffe_humerus-cleaned.tif',247,2,106,1296.9460347,126.1670082,120.3475288,1.8,126.1023879,119.8522457,-0.2648712,64.7080103,90.1772672,317221.1188099,340932.8677564,14.8135767,3780.696383,4902.3469756,5929.7805774,56.0575723,59.0277301,2.3399797,210.3433445),(25097,'windfallLgGiraffe_humerus-cleaned.tif',247,2,107,1294.9756099,125.865547,120.3455069,1.8,125.7723207,119.8184649,-0.1241437,64.5911943,86.2750595,320046.3019379,347223.020617,3.309236,4024.6048217,4954.9525343,6191.3295181,0.4511721,0.6380537,2.3561945,1.2761075),(25098,'windfallLgGiraffe_humerus-cleaned.tif',247,2,108,1298.2913567,125.5501484,120.2671256,1.8,125.5023541,119.6034547,-0.0229536,29.5735203,30.6360586,323723.6794527,357797.6574206,0.1139844,11678.9715843,10946.4032765,20985.0723293,55.7490175,58.8965418,2.9877785,189.442389),(25099,'windfallLgGiraffe_humerus-cleaned.tif',247,2,109,1308.5956842,125.2059446,120.2107685,1.8,125.1068545,119.4285562,0.0442184,29.6594051,30.8207231,327066.5570497,371237.1486923,0.4261662,12045.0499384,11027.4146028,21349.4245216,57.7463433,59.6588772,2.7456381,264.3026188),(25100,'windfallLgGiraffe_humerus-cleaned.tif',247,2,110,1319.5259782,124.9135983,120.1983592,1.8,124.801135,119.3928477,0.0840236,29.6705885,31.2835535,331315.7950681,385643.6238227,1.5489823,12327.3599456,11166.4719779,22009.1294662,57.7241884,61.63249,2.5068761,272.906953),(25101,'windfallLgGiraffe_humerus-cleaned.tif',247,2,111,1347.7902617,124.6162282,120.1907278,1.8,124.3011363,119.3314569,0.1057776,85.6721404,70.2095154,337998.7859043,403408.52642,2.5040207,5745.7813853,3945.2590339,6693.4597942,57.0383828,61.5482124,2.694337,236.0280916),(25102,'windfallLgGiraffe_humerus-cleaned.tif',247,2,112,1383.195053,124.3315764,120.1770272,1.8,124.0018166,119.2761414,0.130688,98.5318491,61.8170736,345442.1958996,422946.7961573,3.9149795,6841.9090647,3505.8937685,6781.1884924,57.2009719,63.1399226,2.4523438,252.5721437),(25103,'windfallLgGiraffe_humerus-cleaned.tif',247,2,113,1414.4271254,124.1413247,120.099736,1.8,123.8946723,119.0147254,0.1457366,29.6942343,33.4781894,353403.7246431,443666.2294474,4.9715243,13252.3961945,11901.4257348,23300.2909578,57.5648979,65.0892998,2.5285953,265.6616365),(25104,'windfallLgGiraffe_humerus-cleaned.tif',247,2,114,1427.9783608,123.813048,120.1031176,1.8,123.4822452,118.9026225,0.154393,29.8810171,32.7282778,358215.3200184,461571.5843052,5.6282328,14103.1430713,11988.0564607,24010.3243734,58.1118727,65.2517187,2.4787302,269.9997574),(25105,'windfallLgGiraffe_humerus-cleaned.tif',247,2,115,1431.1512481,123.5557283,120.1874294,1.8,123.1805671,118.910644,0.1610062,31.1673144,33.5353473,363807.0060688,480540.3299946,6.1300465,14329.3679286,11672.7094788,24241.109766,58.5332063,66.7871908,2.6719028,317.4158966),(25106,'windfallLgGiraffe_humerus-cleaned.tif',247,2,116,1441.6712836,123.2005038,120.2377541,1.8,122.673111,118.9552577,0.1641822,30.54821,34.3295066,369455.0475072,503201.1654178,6.4189071,14657.9783591,12094.16353,24621.4826741,58.1686661,67.1170662,2.8623696,254.2673594),(25107,'windfallLgGiraffe_humerus-cleaned.tif',247,2,117,1442.2147172,123.002069,120.3240741,1.8,122.3269075,118.9743901,0.1659333,30.7538524,35.5628042,375050.1190492,524555.9480237,6.557769,14750.1289649,12195.2240052,24759.545273,58.4176801,69.2178031,2.6604541,325.0084138),(25108,'windfallLgGiraffe_humerus-cleaned.tif',247,2,118,1447.6889008,122.7217065,120.4725544,1.8,121.8168728,119.1028452,0.1621079,31.0624463,36.9356899,379605.0950459,547981.4724758,6.2852809,14836.0968558,12220.7082864,24956.5923847,59.473035,69.9680544,2.7790484,305.0098026),(25109,'windfallLgGiraffe_humerus-cleaned.tif',247,2,119,1446.0304106,122.495719,120.6308648,1.8,121.4813842,119.2655547,0.1559857,31.7190984,36.9781096,384981.343813,575553.2176824,5.816615,15564.7009579,12137.2095573,25198.609275,58.2012038,71.4648667,2.7599139,298.5839202),(25110,'windfallLgGiraffe_humerus-cleaned.tif',247,2,120,1448.3962281,122.256489,120.8087834,1.8,121.202128,119.4192927,0.1536374,89.9048687,70.2583567,390879.7407731,605675.4499511,5.6534062,8620.6890986,4347.703818,8798.2883526,59.1035481,73.0843136,2.7886023,317.2235137),(25111,'windfallLgGiraffe_humerus-cleaned.tif',247,2,121,1462.4134839,122.0702155,120.9491106,1.8,120.9575553,119.4984863,0.1470088,31.8164541,39.0512467,397105.7317082,646442.4200923,5.2296739,16553.6948123,12481.143574,25926.7236189,59.471204,74.9339716,2.7912784,327.2509932),(25112,'windfallLgGiraffe_humerus-cleaned.tif',247,2,122,1467.023787,121.725617,121.1405404,1.8,120.5123602,119.6455764,0.1373268,40.9232697,40.7097497,399486.6752161,680811.6655294,4.5820977,16723.5532017,9761.8464471,18715.0658994,0.9023442,1.2761075,2.3561945,2.5522149),(25113,'windfallLgGiraffe_humerus-cleaned.tif',247,2,123,1468.8493168,121.3701412,121.2947079,1.8,120.0693324,119.787022,0.1240921,81.4441563,79.1538138,402442.0379924,719964.735729,3.7504562,9095.7681103,4941.324907,9978.2521435,61.1353813,78.6192506,2.8325456,341.7338462),(25114,'windfallLgGiraffe_humerus-cleaned.tif',247,2,124,1474.9310851,121.0027282,121.4990756,1.8,119.6019767,119.9428044,0.1084123,32.633653,42.5474782,406501.3204221,765581.2739794,2.8778963,17993.5757921,12456.5067894,27278.2421505,60.3658446,80.3808436,2.857125,300.7811544),(25115,'windfallLgGiraffe_humerus-cleaned.tif',247,2,125,1480.3898478,120.6336241,121.7271697,1.8,119.1335808,120.1513446,0.0921952,38.4017921,43.2979487,412081.0121207,816314.7271745,2.091271,18853.4272619,10730.7755666,21604.5135088,61.1572551,82.4695251,2.8302223,320.1041468),(25116,'windfallLgGiraffe_humerus-cleaned.tif',247,2,126,1487.374419,120.1814235,121.9955702,1.8,118.5599184,120.3779881,0.0723619,37.2622838,44.0663222,417955.2757561,871848.57575,1.2957785,19784.9181222,11216.5770235,22894.8994249,61.6784534,84.4861211,2.8434863,394.7376512),(25117,'windfallLgGiraffe_humerus-cleaned.tif',247,2,127,1499.2434159,119.6230524,122.1782913,1.8,117.7154108,120.5263761,0.0506143,35.213742,45.1460252,424346.0697763,934659.9702405,0.6395819,20703.0401037,12050.5815647,29684.2576656,61.3594087,86.8843185,2.9003923,368.4226303),(25118,'windfallLgGiraffe_humerus-cleaned.tif',247,2,128,1508.8604634,119.0505348,122.40815,1.8,117.1285841,120.733339,0.0306438,41.1658077,46.2060242,429547.6745824,1002897.7427585,0.2360754,21704.9131697,10434.5741841,30157.5650011,61.2793308,89.2112302,2.9223752,441.3233539),(25119,'windfallLgGiraffe_humerus-cleaned.tif',247,2,129,1538.8158061,118.5102746,122.6766915,1.8,116.5412437,121.0376243,0.0140201,40.8417994,47.7721792,437043.0709264,1096158.4103989,0.0504096,22945.5391847,10700.8769759,31494.7266263,61.7229577,92.291997,2.9547432,415.9748048),(25120,'windfallLgGiraffe_humerus-cleaned.tif',247,2,130,1553.9980824,117.8375539,122.9605073,1.8,115.7515022,121.388799,0.0015115,41.2797697,49.2665199,441483.8277203,1173213.1009968,0.0005918,23813.5980396,10694.919825,32506.394693,62.2214394,95.1374279,3.0084144,417.4057301),(25121,'windfallLgGiraffe_humerus-cleaned.tif',247,2,131,1570.1320152,117.2345566,123.2536622,1.8,115.0817953,121.6857846,-0.0115578,87.573301,81.8476038,446189.8072454,1265059.118305,0.0349545,15456.275564,5095.0438354,14276.2227859,62.2944784,98.2685612,3.0126819,429.5740961),(25122,'windfallLgGiraffe_humerus-cleaned.tif',247,2,132,1596.8928814,116.5665498,123.5205322,1.8,114.4693987,122.0010826,-0.019541,38.7753341,52.5008671,452100.9958666,1370232.2573882,0.1016176,26099.2309728,11659.4996941,34692.7677345,64.2566452,101.4686003,2.9808299,446.2541834),(25123,'windfallLgGiraffe_humerus-cleaned.tif',247,2,133,1632.6334171,116.0737371,123.8461196,1.8,113.8768241,122.2979566,-0.0279899,86.3758581,88.3851424,461845.399087,1485099.4752456,0.2131211,16802.5918671,5346.9268998,16134.5898767,62.8091434,105.0330252,2.9863307,465.1127224),(25124,'windfallLgGiraffe_humerus-cleaned.tif',247,2,134,1661.6748539,115.3951442,124.2566932,1.8,112.4861967,122.7653134,-0.0245887,90.7694018,78.6084428,475317.117941,1609630.3564036,0.1674084,20476.5582207,5236.5346538,17363.4896073,63.9267409,110.0434612,0.0862056,476.5523445),(25125,'windfallLgGiraffe_humerus-cleaned.tif',247,2,135,1679.1481253,114.5668329,124.6779372,1.8,111.271533,123.2654952,-0.0156483,93.2301311,91.8161822,490831.7702033,1772367.52494,0.0685239,19303.4330316,5264.7332394,18554.7747686,63.7147415,114.5390873,0.0828141,490.9898524),(25126,'windfallLgGiraffe_humerus-cleaned.tif',247,2,136,1686.2035095,113.7578,125.0901046,1.8,110.3966476,123.7733057,-0.0115505,86.7101065,96.8555272,505999.7181794,1928675.2820951,0.0374922,19912.908813,5835.5333482,20344.7002628,64.5811815,117.9502344,3.0841845,550.4195399),(25127,'windfallLgGiraffe_humerus-cleaned.tif',247,2,137,1690.5557279,113.7042851,125.3788636,1.8,110.1057805,124.3740921,-0.0075769,94.1016997,90.861817,522129.5188226,2079720.7775326,0.016173,22888.8310426,5548.5662922,21054.0728278,68.0152729,121.2176158,3.0708156,544.6129287),(25128,'windfallLgGiraffe_humerus-cleaned.tif',247,2,138,1659.6276328,114.1214008,125.6569894,1.8,110.1007901,124.8544707,-0.0006997,88.6018055,84.4563457,527007.1796045,2145017.3071087,0.0001342,25397.9412479,5948.0410863,21829.2496676,69.0293348,123.3318424,0.0512372,572.6043828),(25129,'windfallLgGiraffe_humerus-cleaned.tif',247,2,139,1638.8750696,114.8193022,125.9800996,1.8,110.6064936,125.3670672,0.0081791,47.4542993,65.1521299,539060.8465513,2203929.2237291,0.0182725,33827.4316721,11359.578673,41427.9552122,70.3828511,125.3576689,3.026166,623.0294104),(25130,'windfallLgGiraffe_humerus-cleaned.tif',247,2,140,1643.4586637,115.8807231,126.3453314,1.8,111.6235478,125.9163512,0.0241994,97.0441811,74.443384,576963.4995843,2312856.193334,0.1603737,31068.6600824,5945.3693448,23627.2837248,73.5889429,127.2953181,2.9921769,589.0765272),(25131,'windfallLgGiraffe_humerus-cleaned.tif',247,2,141,1659.9436385,116.8386628,126.9479499,1.8,113.1186344,126.7746799,0.0437697,45.7399221,66.9553226,630250.1928927,2433922.5478632,0.529677,36351.4423466,13778.9957561,44792.2192349,79.0713439,130.4082563,2.8285946,589.0123996),(25132,'windfallLgGiraffe_humerus-cleaned.tif',247,2,142,1671.8036295,117.6097336,127.9892454,1.8,115.0900693,127.819933,0.0725003,103.0149904,67.3669516,685249.7128536,2555490.2872023,1.4620167,37933.8863624,6651.9417242,28289.0451353,84.6777002,134.6837582,2.8177235,637.0743726),(25133,'windfallLgGiraffe_humerus-cleaned.tif',247,2,143,1672.6098358,117.9231568,128.7004656,1.8,116.3305984,128.3610046,0.0889583,53.8734998,67.2644687,732565.8890884,2630482.0782358,2.2002411,39106.5614331,13597.8893408,45905.7172228,87.9928885,136.9959467,2.7990118,574.756272),(25134,'windfallLgGiraffe_humerus-cleaned.tif',247,2,144,1692.3378323,118.7751883,129.5739022,1.8,118.143582,129.2461159,0.1040512,58.3830549,67.5288942,789151.1832384,2702980.9287796,3.0427221,40027.0278634,13516.7847089,47294.2273029,91.8700145,138.4591306,2.7889241,597.7793315),(25135,'windfallLgGiraffe_humerus-cleaned.tif',247,2,145,1748.0617352,120.3271057,131.018068,1.8,120.1957198,130.7222021,0.12254,58.3795776,68.6060424,877175.931548,2794761.9318023,4.3529785,40736.3817344,15025.3901827,49308.8469667,94.6283086,140.7317156,2.7152305,632.7815968),(25136,'windfallLgGiraffe_humerus-cleaned.tif',247,2,146,1857.5995663,120.8616967,133.2933829,1.8,121.0729224,132.8608233,0.1225398,57.3121325,69.1323998,999213.8687306,2861315.5373629,4.6257323,41388.9224988,17434.5958841,52246.5147229,97.2679489,141.5537705,2.7178668,684.82671),(25137,'windfallLgGiraffe_humerus-cleaned.tif',247,2,147,1993.0353699,121.4460432,135.5270621,1.8,121.7037074,134.7394299,0.1213352,59.4447451,91.3916126,1137234.7790793,2917976.3968051,4.8663755,31928.2734476,19130.9555856,43386.615852,99.107412,142.6453284,2.625585,673.6967234),(25138,'windfallLgGiraffe_humerus-cleaned.tif',247,2,148,2076.4704384,122.3298427,137.1452081,1.8,122.376006,136.3948915,0.1264332,60.8316699,70.6436166,1226464.963071,2931466.2691695,5.50277,41496.5485686,20161.6191753,57631.7099395,100.3713855,143.5620903,2.6399886,649.9714825),(25139,'windfallLgGiraffe_humerus-cleaned.tif',247,2,149,2147.9906174,122.6052279,138.74667,1.8,122.5313432,137.728248,0.1155529,61.9027852,70.7522686,1297920.4065672,2963175.8676056,4.7589261,41881.001485,20967.0760688,59253.0665634,100.8389589,143.9246143,2.6485005,649.2505186),(25140,'windfallLgGiraffe_humerus-cleaned.tif',247,2,150,2193.8821349,122.8064614,139.8092201,1.8,122.6104403,138.393916,0.099075,67.1975301,86.2915101,1322396.2348313,2998275.8738238,3.5774115,34745.8964586,19679.2387003,50051.9600044,100.9760268,143.9345142,2.6162258,630.9205607),(25141,'windfallLgGiraffe_humerus-cleaned.tif',247,2,151,2243.5226657,123.0061404,140.4964134,1.8,122.5821203,138.9538147,0.0873754,70.5460693,70.6429482,1329090.0546672,3049270.8978557,2.8474209,43164.5475621,18840.0298837,60054.0121912,99.9690328,144.104828,2.7017501,588.3899059),(25142,'windfallLgGiraffe_humerus-cleaned.tif',247,2,152,2295.8507564,122.7799362,141.1028167,1.8,122.5753291,139.4665189,0.0754667,85.7916009,69.8299793,1322815.5125996,3069070.0195113,2.1750943,43950.6076312,15418.9396055,50010.2438484,99.0414804,144.0730419,2.666741,581.9186783),(25143,'windfallLgGiraffe_humerus-cleaned.tif',247,2,153,2360.3671188,122.4368702,141.4991851,1.8,122.7493758,140.2382677,0.0570322,76.538153,69.0109784,1307914.1781289,3055032.2759853,1.2781935,44268.7866289,17088.3948296,54860.5336769,0.4511721,1.0088515,2.677945,1.9141612),(25144,'windfallLgGiraffe_humerus-cleaned.tif',247,2,154,2328.531286,122.720337,141.9826122,1.8,123.0071382,141.044612,0.0473661,67.7238551,68.1056011,1240065.3245203,2959744.0499101,0.8700421,43458.1591317,18310.6133491,58102.7928605,0.9023442,1.6267242,2.1587989,3.8283224),(25145,'windfallLgGiraffe_humerus-cleaned.tif',247,2,155,2236.1355465,122.5561221,142.8329167,1.8,123.0882565,141.9587414,0.0493436,75.0625008,71.6039117,1140288.9505537,2867411.7372667,0.9066836,40045.4621816,15191.193184,51224.3118167,1.2761075,4.7960255,2.2896263,10.3636776),(25146,'windfallLgGiraffe_humerus-cleaned.tif',247,2,156,2159.4173419,122.4640146,143.9370947,1.8,123.1334177,142.973706,0.057079,56.3323997,67.3762731,1010616.6095705,2755688.4945132,1.1713026,40899.9840657,17940.2371354,53363.3368104,88.3277845,140.0037331,2.7515115,611.231585),(25147,'windfallLgGiraffe_humerus-cleaned.tif',247,2,157,2105.6581889,122.3737005,145.0227079,1.8,123.155312,144.0086136,0.0573824,48.1626748,66.8266861,890588.8864578,2628268.0402823,1.1542987,39329.6180489,18491.2671678,50285.6030324,82.638331,138.6574594,2.7580651,614.5047639),(25148,'windfallLgGiraffe_humerus-cleaned.tif',247,2,158,2043.6479128,122.565404,146.0144434,1.8,123.2867016,144.8387898,0.0524794,60.4297795,65.9007863,774918.1521539,2479112.6827034,0.9372024,37618.8634747,12823.4482826,47452.3420114,79.5335953,136.1867368,2.7863117,651.4743154),(25149,'windfallLgGiraffe_humerus-cleaned.tif',247,2,159,1970.4520338,122.9065859,146.8986313,1.8,123.5400597,145.4699549,0.0305898,72.5993891,64.9084933,667549.6441412,2329427.0849414,0.3072094,35887.8625587,9194.9760542,40021.812683,76.200434,134.6043881,2.7890989,499.1828583),(25150,'windfallLgGiraffe_humerus-cleaned.tif',247,2,160,1898.4551014,123.3576716,147.4592387,1.8,123.8812825,146.0139589,0.0112494,74.9304132,63.5905518,572589.136254,2191758.5208571,0.0400391,34466.732204,7641.6118866,36608.4735807,73.7192311,132.7550492,2.7875952,509.3088078),(25151,'windfallLgGiraffe_humerus-cleaned.tif',247,2,161,1820.8184878,124.105168,147.6390875,1.8,124.170998,146.3749512,-0.009081,60.9089187,61.6842161,473772.5228281,2043102.4137468,0.0250276,33121.9644648,7778.376841,35031.564062,1.0950143,2.6307629,2.1112158,5.6330109),(25152,'windfallLgGiraffe_humerus-cleaned.tif',247,2,162,1719.2502554,124.7838885,147.891363,1.8,124.4956052,146.7454187,-0.0325068,39.3557005,59.7535646,381788.7204999,1885304.5535508,0.3026783,31551.3319612,9700.9763662,35161.6312801,64.9659049,126.6966513,2.8265988,436.9288853),(25153,'windfallLgGiraffe_humerus-cleaned.tif',247,2,163,1580.8239633,125.337068,148.1390554,1.8,124.629953,147.3395155,-0.05857,34.4657894,58.0858099,283570.8652021,1680580.0970024,0.9027904,28932.7135316,8227.6039609,31508.4711183,58.9697688,122.7320864,2.8430937,459.9065998),(25154,'windfallLgGiraffe_humerus-cleaned.tif',247,2,164,1397.1212019,125.5864938,148.1896172,1.8,124.2595619,147.7626968,-0.0827756,27.2894118,56.4372933,193819.7661291,1450599.9873648,1.591822,25702.8624591,7102.3797538,27513.780485,51.8999253,118.4006661,2.9030834,401.3902591),(25155,'windfallLgGiraffe_humerus-cleaned.tif',247,2,165,1134.1901403,125.5259091,148.1456066,1.8,123.8706335,147.8602244,-0.1108625,24.5946859,55.519443,112443.9027273,1217581.3964062,2.3137883,21930.7206607,4571.8779644,23272.4278364,46.0922813,114.0823306,2.9666914,338.6342677),(25156,'windfallLgGiraffe_humerus-cleaned.tif',247,2,166,781.6027133,121.6432461,148.3903564,1.8,122.0536616,148.1032708,-0.1242609,20.4396941,58.0305641,49144.1021082,881611.3342983,2.001093,15192.1896232,2404.3462595,15942.4736144,36.0937698,49.9356033,2.536048,155.7537963),(25157,'windfallLgGiraffe_humerus-cleaned.tif',247,2,167,347.6589593,100.1746071,150.601056,1.8,109.4928715,149.4086011,-0.1068108,14.9569821,72.8103653,13064.6744234,161163.354272,0.6585372,2213.4671851,873.4833205,2391.9208602,28.5376252,44.152673,2.7648813,129.1744849),(25158,'windfallLgGiraffe_humerus-cleaned.tif',247,2,168,53.1577984,95.9702427,150.9913961,1.8,94.5683966,151.0416451,-0.0692222,8.6227721,19.9038271,711.9282208,6533.6213685,0.042385,328.2595516,82.5637294,361.8607228,14.2836213,16.2984954,2.4149503,51.2710242),(25159,'windfallLgGiraffe_humerus-cleaned.tif',247,2,169,5.26816,93.9963546,163.7444395,1.8,94.0395643,163.738775,0.4830885,4.16548,4.764439,19.631266,25.8203137,0.1894567,5.4193817,4.712846,9.5251631,8.5620035,10.1388325,2.5782764,29.1127438),(25160,'windfallLgGiraffe_humerus-cleaned.tif',247,2,170,44.7111378,94.0034728,163.6932874,1.8,94.0153152,163.6969333,0.1636893,8.5711367,8.9057268,679.4238197,712.5772629,0.1978895,80.0133752,79.2688112,154.6551699,17.5464777,18.4319136,2.7656317,58.4444331),(25161,'windfallLgGiraffe_humerus-cleaned.tif',247,2,171,117.5111924,100.770154,164.6836825,1.8,104.5440874,164.9873768,0.1335874,11.0697949,34.4793831,2828.4914515,23260.1924258,0.3474351,674.6116176,255.5143505,734.4536028,22.107434,23.0583827,1.0370881,73.7389402),(25162,'windfallLgGiraffe_humerus-cleaned.tif',247,2,172,566.8785295,116.333684,163.2114669,1.8,112.8307532,164.162609,-0.0392883,21.4991134,93.7115733,39145.0513607,211771.8297113,0.1457613,2259.8257863,1820.7751458,2669.1805719,25.2656389,26.0783731,0.9203749,83.993145),(25163,'windfallLgGiraffe_humerus-cleaned.tif',247,2,173,666.7045051,115.5911985,162.2703979,1.8,111.7646263,164.206729,-0.0601836,23.5914217,94.2302917,48954.1349973,234160.6277331,0.4019892,2484.9825196,2075.0820192,2986.6605373,29.3533668,56.8995844,0.1833996,184.6663773),(25164,'windfallLgGiraffe_humerus-cleaned.tif',247,2,174,682.7515872,115.0179865,162.4021492,1.8,111.3186475,164.2270115,-0.0626386,23.493135,94.757802,50012.9954416,242551.7815588,0.44589,2559.7024891,2128.83446,3067.2591437,29.4803247,57.5133864,0.0863985,179.9998382),(25165,'windfallLgGiraffe_humerus-cleaned.tif',247,2,175,689.5562887,114.9449454,162.521624,1.8,111.222442,164.3109572,-0.0592706,23.4066025,94.8725635,50342.8508657,246550.80525,0.4032635,2598.7577023,2150.7970221,3110.4845826,29.4875268,57.6971357,0.1175656,181.6497089),(25166,'windfallLgGiraffe_humerus-cleaned.tif',247,2,176,691.4417751,114.943604,162.629644,1.8,111.210671,164.3534757,-0.0595006,23.2988691,94.8511826,50325.4878873,246920.0128336,0.4075075,2603.2359961,2159.9970244,3113.4838221,29.3533668,57.7517941,0.125324,180.3736015),(25167,'windfallLgGiraffe_radius-cleaned.tif',247,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25168,'windfallLgGiraffe_radius-cleaned.tif',247,3,2,0.0114511,25.5820568,180.8087746,1.8,25.5820568,180.8087746,0.7853982,0,0,0.0001794,0.0001794,0.0009543,0,0,0,0.4335942,0.6131948,2.3561945,1.2263896),(25169,'windfallLgGiraffe_radius-cleaned.tif',247,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25170,'windfallLgGiraffe_radius-cleaned.tif',247,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25171,'windfallLgGiraffe_radius-cleaned.tif',247,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25172,'windfallLgGiraffe_radius-cleaned.tif',247,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25173,'windfallLgGiraffe_radius-cleaned.tif',247,3,7,29.9030483,144.2156007,142.5744576,1.8,142.3977147,142.7601817,-0.1473919,7.8050596,22.6838861,291.4341777,5670.8059094,0.107489,249.9926986,37.3391357,254.4683562,8.5847269,15.6334606,2.1587989,40.9607916),(25174,'windfallLgGiraffe_radius-cleaned.tif',247,3,8,176.5776077,139.9829534,142.796438,1.8,139.9903483,142.7609737,-0.1028111,14.2391892,22.1092657,4562.825363,27421.5577345,0.30998,1240.2744658,320.4413745,1288.0507068,27.1879946,45.5748534,2.7716866,145.6832658),(25175,'windfallLgGiraffe_radius-cleaned.tif',247,3,9,345.489954,139.6570176,142.3397807,1.8,138.9663692,141.9274118,-0.0503772,22.4408838,25.2338098,18666.0495438,49808.4658867,0.1460107,1973.8781497,831.7876294,2492.7346494,36.441523,50.4033423,2.7626837,167.591441),(25176,'windfallLgGiraffe_radius-cleaned.tif',247,3,10,468.6719429,137.4595792,141.750102,1.8,134.9569781,141.4194563,-0.1312695,25.1423847,83.2044017,40146.6909629,109592.9239062,1.3382876,1317.1529587,1596.7733974,1774.7842739,43.9896069,55.1687901,2.7377329,203.4362592),(25177,'windfallLgGiraffe_radius-cleaned.tif',247,3,11,689.3076986,130.5514605,141.1017028,1.8,127.4610537,140.6498595,-0.2204633,27.9004414,79.7810733,83377.7967371,348555.0339405,5.4939783,4368.893766,2988.4042202,5364.9063707,49.961227,74.3484441,2.9716501,260.8481021),(25178,'windfallLgGiraffe_radius-cleaned.tif',247,3,12,917.9954342,126.633432,139.3359177,1.8,124.704562,138.8290867,-0.2623892,28.295975,77.9008108,144511.929027,567690.9184009,10.2941744,7287.3557134,5107.1549675,9055.8820327,53.4025093,80.8696743,2.8979144,276.7114863),(25179,'windfallLgGiraffe_radius-cleaned.tif',247,3,13,1136.4310314,122.4548342,137.0934432,1.8,120.2203644,136.4857228,-0.2337467,36.7140965,74.4359285,235337.5585814,818681.0307764,10.161519,10998.4660303,6410.0054551,13841.1388952,56.1469961,96.1181587,2.8955199,353.665882),(25180,'windfallLgGiraffe_radius-cleaned.tif',247,3,14,1390.5056764,115.5274784,134.3620978,1.8,115.338498,134.2725394,-0.1047571,37.2131124,66.2144188,380278.112279,1167140.3026963,2.5339559,17626.6789653,10218.9278899,21067.1258528,59.0205858,99.1680233,2.8987349,372.2976681),(25181,'windfallLgGiraffe_radius-cleaned.tif',247,3,15,1527.3830099,111.7568998,133.5105923,1.8,113.259162,133.6383213,-0.1161039,37.9931111,64.143223,452407.2950852,1391737.6577807,3.4161528,21697.3453069,11907.6138119,26771.1426067,61.2965122,103.5128359,2.922015,365.1242183),(25182,'windfallLgGiraffe_radius-cleaned.tif',247,3,16,1640.8932228,109.0592164,132.9084647,1.8,110.7103762,132.8341334,-0.1525417,53.4350976,63.1854611,528836.9716164,1592127.6857545,6.3144447,25197.6903674,9896.8093082,30690.3325192,63.7392701,108.9909512,2.977752,384.1407332),(25183,'windfallLgGiraffe_radius-cleaned.tif',247,3,17,1774.9126119,105.4631281,132.8250196,1.8,107.8743321,132.4439428,-0.1730591,38.4977831,61.8317996,590458.5505494,1858410.0461551,8.7715165,30055.8945323,15337.4688794,37566.171145,75.7052443,122.1020006,0.2329207,542.7010893),(25184,'windfallLgGiraffe_radius-cleaned.tif',247,3,18,1851.7965285,102.5457434,132.7193084,1.8,105.6032863,131.8793154,-0.1698623,38.9515606,62.6754754,619455.2634208,2107440.63413,8.8197242,33624.6453645,15903.2206833,43395.6993246,77.205719,123.3146737,0.2125668,471.5194401),(25185,'windfallLgGiraffe_radius-cleaned.tif',247,3,19,1893.0255025,100.6893541,132.3484629,1.8,105.4885519,131.2534289,-0.159196,41.2873429,65.3915573,635505.4058823,2305153.0818234,7.9286162,35251.539733,15392.2573003,44832.4893212,78.8331676,124.8811469,0.1183258,501.1451538),(25186,'windfallLgGiraffe_radius-cleaned.tif',247,3,20,1857.84752,101.2221055,131.7488979,1.8,105.8153976,130.5376718,-0.1570936,41.9541539,65.2782865,655612.6410708,2286807.9989615,7.5788005,35031.6793123,15626.8826979,44936.1303267,79.6607646,125.4017048,0.1492319,494.2512252),(25187,'windfallLgGiraffe_radius-cleaned.tif',247,3,21,1836.2975427,102.2478766,131.5581959,1.8,106.1767362,130.4706116,-0.1424986,41.0051384,64.4885753,689573.5459256,2258433.4879524,6.1726431,35020.6757693,16816.7593635,45562.2709666,80.3706335,125.6862325,0.2617135,450.6708178),(25188,'windfallLgGiraffe_radius-cleaned.tif',247,3,22,1846.0252641,103.9544822,131.7755818,1.8,106.7473881,130.8990467,-0.1112537,47.1978819,63.2116211,753002.2807911,2266362.2428973,3.7924722,35853.5693606,15954.1541063,47509.0828355,81.8759115,126.2287919,0.2216496,453.6932133),(25189,'windfallLgGiraffe_radius-cleaned.tif',247,3,23,1899.8126717,105.2811789,132.3889131,1.8,107.4518081,131.5882228,-0.0706872,55.8654683,62.985782,848716.8940023,2309401.303126,1.579495,36665.4382844,15192.1557368,48865.6698454,83.3929749,126.2831429,0.2074962,464.9050329),(25190,'windfallLgGiraffe_radius-cleaned.tif',247,3,24,1983.4431943,106.5234351,133.1920731,1.8,108.0756457,132.0619073,-0.0260223,57.5316811,82.5750969,964389.4892562,2371606.7341745,0.2238025,28720.6049253,16762.75525,35464.983303,85.1688563,126.0215966,0.1973956,469.4949683),(25191,'windfallLgGiraffe_radius-cleaned.tif',247,3,25,2126.1226136,108.6140636,133.2927846,1.8,108.4573554,132.2462985,-0.0012706,57.8233833,84.3919928,1053815.4690228,2521227.4378897,0.0005727,29875.1973432,18224.7286344,37077.7593099,86.4061174,127.1702987,0.1713145,525.6804216),(25192,'windfallLgGiraffe_radius-cleaned.tif',247,3,26,2327.4283764,110.4217154,133.4025444,1.8,108.6453986,132.5404347,0.0265512,55.7808963,66.8276247,1139312.0548243,2685650.8791116,0.2733959,40187.7351146,20424.7713974,56295.1109961,87.0388366,127.2471503,0.1539447,514.0732993),(25193,'windfallLgGiraffe_radius-cleaned.tif',247,3,27,2485.7247112,107.0786836,131.7635838,1.8,108.3719873,132.3301256,0.0158584,50.4825149,63.2013017,1180803.2451305,2682120.3118086,0.1041811,42437.7384323,23390.3411559,59508.1828323,87.0354097,126.3158911,0.1724849,518.4453427),(25194,'windfallLgGiraffe_radius-cleaned.tif',247,3,28,2436.4777121,103.0158805,130.1967694,1.8,107.1671747,130.9745365,-0.0744672,45.6183442,80.9846756,1026579.0066113,2507811.1745433,2.2477043,30966.4903547,22503.6446415,38206.6718419,86.6984992,125.8304963,0.1487196,486.8387356),(25195,'windfallLgGiraffe_radius-cleaned.tif',247,3,29,2296.81906,104.6430039,131.0315306,1.8,106.8886119,131.1628134,-0.038539,45.9527981,62.5151188,957813.8044232,2257769.8823772,0.5682772,36115.5817319,20843.4272565,50338.9840401,85.9465484,125.7109111,0.2190431,494.0918653),(25196,'windfallLgGiraffe_radius-cleaned.tif',247,3,30,2260.6285341,108.4589487,131.4075856,1.8,108.1285106,131.690007,0.0195489,45.3850128,65.0028922,951272.9700098,2196441.7140867,0.1439683,33789.907498,20960.0683211,47357.5995953,85.1574715,124.8307037,0.1148766,414.2202817),(25197,'windfallLgGiraffe_radius-cleaned.tif',247,3,31,2263.1150852,109.1833798,131.567899,1.8,108.7866464,132.095142,0.0143477,50.0141424,83.7595707,933325.5403736,2234027.9317622,0.0776477,26671.9124004,18661.2325055,32467.187563,84.1350952,125.1736169,0.1600234,436.1465076),(25198,'windfallLgGiraffe_radius-cleaned.tif',247,3,32,2207.7446846,109.437715,131.4160294,1.8,108.8505804,132.0197899,0.0277274,43.345255,66.3070369,911900.3807966,2145068.9093763,0.2828176,32350.5469179,21038.0670361,45377.356794,81.8251906,124.4143337,0.1857761,497.0090532),(25199,'windfallLgGiraffe_radius-cleaned.tif',247,3,33,2169.2215998,108.5123983,130.7750126,1.8,108.4447203,131.340484,0.0204738,43.5496872,62.8174156,888443.6454677,2119822.26655,0.1515312,33745.773301,20400.689501,46554.2304717,78.5986799,121.4559149,3.113029,416.3319104),(25200,'windfallLgGiraffe_radius-cleaned.tif',247,3,34,2131.2799028,107.7808378,130.4901812,1.8,107.9469005,130.9721991,0.0072362,42.4299939,62.6570066,845327.6112028,2062898.1858338,0.0186026,32923.6632491,19922.8784396,45290.6073231,77.8572952,119.9936161,3.0293393,408.4039567),(25201,'windfallLgGiraffe_radius-cleaned.tif',247,3,35,2059.3260755,107.4986738,130.4463462,1.8,107.9247064,131.1796782,0.0009295,41.5531026,61.9683757,778026.4280352,1917333.3185771,0.0002965,30940.5127758,18723.6663511,42094.839933,76.5445599,118.7905633,0.0840506,445.4932152),(25202,'windfallLgGiraffe_radius-cleaned.tif',247,3,36,1963.1198001,107.7849082,130.2828133,1.8,108.618008,131.1196433,0.0034018,40.0720037,61.780013,707398.059241,1735827.4709573,0.0037857,28096.9100939,17653.1741416,38643.2898599,73.8779328,117.3022532,0.06288,388.0558447),(25203,'windfallLgGiraffe_radius-cleaned.tif',247,3,37,1871.3248941,108.0295056,130.2390161,1.8,109.1265657,131.1033157,0.0074156,38.7137306,58.5511197,650188.256262,1590695.4663814,0.0171498,27167.6353055,16794.7714375,37302.729742,71.8703345,113.3307705,0.0535885,429.3577867),(25204,'windfallLgGiraffe_radius-cleaned.tif',247,3,38,1786.9339242,108.3953447,130.1385649,1.8,109.5663475,131.0483977,0.0157448,37.7237585,57.5494022,605846.873204,1463801.6466002,0.0738217,25435.5664888,16060.0877893,35213.2423635,70.6143209,111.2166968,3.0791738,397.5077599),(25205,'windfallLgGiraffe_radius-cleaned.tif',247,3,39,1695.7151077,108.8041092,130.0806595,1.8,110.1158802,130.9522826,0.0247648,38.2872642,56.1179981,564526.2261227,1344087.6876393,0.1732936,23951.098258,14744.4910891,33187.6278848,68.8062714,109.2967009,3.1177876,354.1993968),(25206,'windfallLgGiraffe_radius-cleaned.tif',247,3,40,1614.7672301,109.0950078,130.0796161,1.8,110.4955522,130.8862678,0.0339277,35.8718016,54.6876925,526489.3699537,1247894.2068347,0.3096691,22818.556587,14676.9704105,31510.9554946,67.2906963,107.4141533,3.0648208,353.6914096),(25207,'windfallLgGiraffe_radius-cleaned.tif',247,3,41,1547.0345465,109.6214723,129.9661071,1.8,110.9972498,130.7027236,0.0464112,35.3476733,53.8165387,493568.0722953,1162990.6988194,0.554988,21610.2842393,13963.240761,30133.8199155,66.0707025,105.5381069,3.0840431,361.8117277),(25208,'windfallLgGiraffe_radius-cleaned.tif',247,3,42,1487.0010221,109.9563167,129.9579554,1.8,111.3680377,130.6522487,0.0522422,34.7811663,82.4871809,466370.1660644,1093466.3679181,0.6757857,13256.1975828,13408.6983367,17793.7108669,65.4200981,103.7821967,3.0872529,384.376676),(25209,'windfallLgGiraffe_radius-cleaned.tif',247,3,43,1437.9995675,110.3401731,129.9592133,1.8,111.6949581,130.690168,0.0566309,35.6371025,51.4206716,443393.6057704,1031671.6794447,0.7678045,20063.3645259,12441.9095397,27862.1190356,64.5522672,101.7284403,3.0690705,332.3964293),(25210,'windfallLgGiraffe_radius-cleaned.tif',247,3,44,1392.5083169,110.6750521,129.9558512,1.8,112.022935,130.7157098,0.0627749,36.4049658,50.4320277,421941.2601087,974118.4394549,0.9133715,19315.47239,11590.2117025,26840.1484683,64.4403473,100.4311212,3.068132,363.9669348),(25211,'windfallLgGiraffe_radius-cleaned.tif',247,3,45,1354.9327148,111.0358514,129.8971548,1.8,112.3463757,130.6870214,0.06926,36.5703679,49.6893449,403949.8254463,925827.125627,1.0815274,18632.3069525,11045.8233872,26093.3758848,61.8576435,98.8832426,3.1196663,301.9651565),(25212,'windfallLgGiraffe_radius-cleaned.tif',247,3,46,1328.2071036,111.3948662,129.824244,1.8,112.6261334,130.6416166,0.0765086,34.7334578,48.3638343,389516.1065829,885878.7369529,1.2932615,18316.9665905,11214.435048,25500.7448153,61.8976708,96.5903429,2.9838239,300.7387669),(25213,'windfallLgGiraffe_radius-cleaned.tif',247,3,47,1303.8538739,111.7463374,129.7412439,1.8,112.9727535,130.5706955,0.0852166,35.0849782,47.4729577,375387.5095046,848581.6378606,1.5742521,17875.053055,10699.379875,24780.7141828,61.0526176,95.0481572,3.0364769,308.2894687),(25214,'windfallLgGiraffe_radius-cleaned.tif',247,3,48,1290.3087615,112.0361956,129.6583031,1.8,113.3047695,130.4944713,0.0934152,41.0501252,46.4941546,365384.0268339,819303.7930574,1.8711731,17621.6515651,8900.9235769,24613.0892313,59.5212225,93.3708605,3.0299098,301.6059553),(25215,'windfallLgGiraffe_radius-cleaned.tif',247,3,49,1276.8065481,112.391058,129.5207785,1.8,113.6027114,130.5592211,0.0965364,49.8761502,45.934435,352718.8770337,786268.8530242,1.9770007,17117.1987436,7071.8946019,22150.7810101,59.3340057,92.1221839,3.0756507,311.5042285),(25216,'windfallLgGiraffe_radius-cleaned.tif',247,3,50,1255.6450552,112.7109184,129.4517307,1.8,113.8830194,130.590198,0.0983371,31.3097726,45.1137763,340506.2984085,753397.1627361,2.0172028,16699.9356941,10875.399933,23410.3633065,58.5447975,90.4062069,3.0214018,319.7297542),(25217,'windfallLgGiraffe_radius-cleaned.tif',247,3,51,1234.7257455,113.0768844,129.3832305,1.8,114.2016809,130.6451101,0.1042475,34.4182649,44.6857501,328705.0029336,722013.3752163,2.2283156,16157.5753706,9550.307184,22685.0356237,60.5580256,89.1750506,2.9804408,307.4222803),(25218,'windfallLgGiraffe_radius-cleaned.tif',247,3,52,1214.5550332,113.4635618,129.320036,1.8,114.4670367,130.6486373,0.1103332,33.8177517,44.0778719,317862.5223196,692661.6984483,2.4542294,15714.4995675,9399.2801549,22232.3627181,59.4802535,87.8785347,3.0129537,322.6288913),(25219,'windfallLgGiraffe_radius-cleaned.tif',247,3,53,1201.3120944,113.8624202,129.3294924,1.8,114.8216254,130.6706102,0.1195555,35.6295467,43.3988644,309319.3138836,669123.5442565,2.8482212,15417.9966285,8681.5394087,21791.0252472,58.0169,86.5332767,3.0159947,346.3150216),(25220,'windfallLgGiraffe_radius-cleaned.tif',247,3,54,1189.1177046,114.2020715,129.3245461,1.8,115.132583,130.6561417,0.130329,30.114093,42.690578,301489.5926295,645901.2121577,3.3473051,15129.8305715,10011.5780498,21332.6539212,56.6910253,84.8693468,3.0083659,339.2723071),(25221,'windfallLgGiraffe_radius-cleaned.tif',247,3,55,1178.1749652,114.5844104,129.3862209,1.8,115.5116258,130.6545356,0.1455625,35.9304646,42.2737752,294272.0051137,628069.5266691,4.1313118,14857.1904049,8190.0417437,21032.0666171,55.9642229,83.8452767,3.0223691,303.5762749),(25222,'windfallLgGiraffe_radius-cleaned.tif',247,3,56,1168.6512565,114.8858012,129.4958552,1.8,115.788387,130.6261488,0.1579658,41.4209648,41.9083102,287955.4582486,611479.519716,4.8199722,14590.8894305,6951.9254252,20002.6252578,55.1068252,82.7937847,3.041924,306.029054),(25223,'windfallLgGiraffe_radius-cleaned.tif',247,3,57,1163.0810423,115.2584681,129.5720528,1.8,116.0036348,130.7186964,0.1685139,48.7259723,41.3777569,280448.3367838,595912.7128447,5.4527507,14401.7645564,5755.6231983,17326.0385712,55.0808408,81.8103869,3.0566909,316.8125663),(25224,'windfallLgGiraffe_radius-cleaned.tif',247,3,58,1154.1878873,115.5346243,129.6798839,1.8,116.2769343,130.8193934,0.1769153,37.8321033,41.1577518,273640.4081128,581042.7415307,5.9582712,14117.4557787,7233.0212823,19933.1169746,54.5981549,80.6997872,2.9905773,285.7245203),(25225,'windfallLgGiraffe_radius-cleaned.tif',247,3,59,1145.4012679,115.7642819,129.8402792,1.8,116.4232635,130.9751556,0.1854288,29.3481472,40.5356038,267916.3822615,564933.4009682,6.4889956,13936.7210176,9128.9027841,18900.37043,54.0578659,79.5417864,3.0158854,303.5507472),(25226,'windfallLgGiraffe_radius-cleaned.tif',247,3,60,1140.0698187,116.0830333,129.9424858,1.8,116.6487314,131.0703124,0.1995584,30.0209499,40.2131452,262926.9939215,552115.6876076,7.467022,13729.7315248,8758.1170637,19320.2087342,53.5730014,78.5870768,2.924719,295.6844227),(25227,'windfallLgGiraffe_radius-cleaned.tif',247,3,61,1133.8190303,116.3844871,130.0186858,1.8,116.8643316,131.1504794,0.2097959,34.313228,39.7106142,258346.5724005,538955.9892825,8.1960667,13572.0889778,7529.0664223,17701.9034368,53.4616671,77.7005132,2.9847007,301.4571693),(25228,'windfallLgGiraffe_radius-cleaned.tif',247,3,62,1125.902926,116.5984609,130.0734461,1.8,116.9954949,131.1607496,0.217667,30.4953268,39.395251,255179.3958521,526232.3086892,8.7511518,13357.7600115,8367.8196871,19239.2544373,52.9135897,76.9064575,3.0172377,343.9163948),(25229,'windfallLgGiraffe_radius-cleaned.tif',247,3,63,1118.1157469,116.8205409,130.0930282,1.8,117.1303027,131.0432198,0.2257961,33.1809685,38.9410669,251309.0094498,516663.4596988,9.3406077,13267.8301133,7573.8901296,18204.5861791,52.3795311,75.9198529,2.9867722,285.8733063),(25230,'windfallLgGiraffe_radius-cleaned.tif',247,3,64,1116.0926538,117.0436462,130.1110445,1.8,117.2412549,130.9371068,0.2361074,48.5339214,38.5581433,248866.5898118,508507.7386357,10.1784836,13188.0763734,5127.6835333,15039.6002765,51.883734,75.0055277,2.9555345,277.4554163),(25231,'windfallLgGiraffe_radius-cleaned.tif',247,3,65,1117.8672399,117.3793986,130.1208816,1.8,117.4537126,131.0118775,0.2464527,44.0198156,38.2958635,246120.4976406,499157.9199221,11.0890753,13034.2515838,5591.1296869,16615.7063318,51.7471574,74.3206233,2.9419088,300.8439745),(25232,'windfallLgGiraffe_radius-cleaned.tif',247,3,66,1113.3142978,117.6015221,130.164272,1.8,117.6664204,131.0657653,0.2547509,32.0575696,38.0237743,242043.52463,490278.2063779,11.7837237,12893.9910793,7550.2768084,18839.0045197,51.5537087,73.5693193,2.9638477,306.7655071),(25233,'windfallLgGiraffe_radius-cleaned.tif',247,3,67,1119.1476605,117.8411335,130.2120456,1.8,117.9424961,131.0609154,0.2618073,30.3097106,37.7164355,239235.0969053,481841.9839459,12.4955211,12775.3849833,7893.0181839,18743.4070095,51.4487998,72.8967125,2.9196979,298.1116742),(25234,'windfallLgGiraffe_radius-cleaned.tif',247,3,68,1133.1262074,118.1154667,130.2975247,1.8,118.2473866,131.1584448,0.2689267,29.8538619,37.286003,237028.5473245,475686.0541429,13.3321449,12757.7647327,7939.6276543,18766.5530132,0.4335942,0.9695461,2.0344439,2.0935779),(25235,'windfallLgGiraffe_radius-cleaned.tif',247,3,69,1122.7741421,118.2718066,130.3260719,1.8,118.4856606,131.2502791,0.2752463,29.6469386,36.9358278,234716.7475447,468682.5089028,13.8225733,12689.102605,7917.0652528,18675.6289437,0.4335942,0.6131948,2.3561945,1.2263896),(25236,'windfallLgGiraffe_radius-cleaned.tif',247,3,70,1128.599244,118.442056,130.4215362,1.8,118.5973216,131.3480523,0.2800409,73.6165186,76.805575,233598.4050635,464388.7513815,14.3697354,6046.2896292,3173.1791938,6560.7459499,0.4335942,0.6131948,2.3561945,1.2263896),(25237,'windfallLgGiraffe_radius-cleaned.tif',247,3,71,1133.4749262,118.5652613,130.4040189,1.8,118.7045638,131.2676067,0.2816111,31.1209828,36.4286001,232759.9360942,461320.5030437,14.5897908,12663.6901085,7479.1961916,18760.6688583,50.4825456,70.4680597,2.8801976,269.9918714),(25238,'windfallLgGiraffe_radius-cleaned.tif',247,3,72,1138.0356163,118.655382,130.3586084,1.8,118.7586708,131.0730138,0.2826176,31.0803776,36.1850923,232682.6216252,458579.4226924,14.7505849,12673.1588468,7486.4798884,16985.9630183,0.4335942,0.9695461,2.0344439,2.0935779),(25239,'windfallLgGiraffe_radius-cleaned.tif',247,3,73,1149.0866574,118.8652424,130.2709998,1.8,119.0093264,131.1100949,0.2825524,43.6351372,36.0075946,232855.0298495,455318.9295627,14.8871391,12645.0804176,5336.4110901,14718.5485395,50.3522394,69.5185491,2.8829991,274.3894424),(25240,'windfallLgGiraffe_radius-cleaned.tif',247,3,74,1153.9520848,118.9738584,130.2511893,1.8,119.1343436,131.2061968,0.2831407,26.7415538,36.071171,231819.0361342,450563.5240866,15.0108153,12490.9591836,8668.8693564,18694.3585754,50.3232992,69.0994606,2.8813945,298.576083),(25241,'windfallLgGiraffe_radius-cleaned.tif',247,3,75,1160.5812738,119.1020117,130.2417014,1.8,119.3082848,131.2510814,0.2830846,29.2511535,35.5494258,230819.0212076,446437.8359552,15.0912341,12558.2291512,7890.9374109,18684.0345199,50.6235686,68.6805522,2.8797703,254.6800528),(25242,'windfallLgGiraffe_radius-cleaned.tif',247,3,76,1164.9577771,119.1927666,130.1914243,1.8,119.4025614,131.1864122,0.2799793,29.6061001,35.5740046,229817.3610361,443214.4718093,14.8263069,12458.942325,7762.5003109,18654.6573019,50.5883842,68.1956954,2.8580529,255.3548767),(25243,'windfallLgGiraffe_radius-cleaned.tif',247,3,77,1168.9125819,119.3235066,130.1396908,1.8,119.6484321,131.0453961,0.2776343,29.7998371,35.5747737,228721.5180583,439576.1994603,14.634896,12356.4018634,7675.260683,18622.6378585,50.286777,67.7309645,2.8826397,252.3941104),(25244,'windfallLgGiraffe_radius-cleaned.tif',247,3,78,1167.9607124,119.3832417,130.1268783,1.8,119.6492389,131.0600209,0.2787766,30.2512779,34.9280619,227902.6869521,434331.7968312,14.7404169,12435.0385658,7533.6548587,18342.6937942,50.2902615,67.2420566,2.8606358,288.957331),(25245,'windfallLgGiraffe_radius-cleaned.tif',247,3,79,1168.4381284,119.4325104,130.0846862,1.8,119.5732915,130.9317558,0.2783289,30.3627422,34.6534693,227883.0904561,430768.39556,14.7003413,12430.7437117,7505.3527385,18578.6173472,50.0769592,66.786173,2.8383205,280.2673965),(25246,'windfallLgGiraffe_radius-cleaned.tif',247,3,80,1167.0702575,119.5111614,130.0398602,1.8,119.5534082,130.7848428,0.2786985,29.5385282,34.5903538,227429.753004,427745.7207107,14.7211426,12366.0406538,7699.4273749,18573.6898712,49.9072011,66.3639943,2.9108761,253.094462),(25247,'windfallLgGiraffe_radius-cleaned.tif',247,3,81,1169.830041,119.6468438,129.9232776,1.8,119.6637595,130.7452678,0.2785077,30.8138634,34.7302602,226828.1623871,424104.4656626,14.7362824,12211.3817391,7361.237348,18362.8481112,50.2099261,66.0843625,2.9634997,255.0828324),(25248,'windfallLgGiraffe_radius-cleaned.tif',247,3,82,1158.7669221,119.6987652,129.8255145,1.8,119.7282311,130.6467019,0.2776779,26.3762427,35.1812993,224817.8604162,418285.9364502,14.5123135,11889.4396958,8523.49831,18199.3471358,50.1857958,65.8178261,2.949365,250.8520981),(25249,'windfallLgGiraffe_radius-cleaned.tif',247,3,83,1152.1020124,119.7444669,129.7864372,1.8,119.7743051,130.5872999,0.2766201,30.9245699,34.5470994,223328.6241331,413151.7955579,14.3219347,11959.0878241,7221.7212615,18011.0676909,49.9774067,67.4960065,2.7873332,301.1160189),(25250,'windfallLgGiraffe_radius-cleaned.tif',247,3,84,1149.2818967,119.7881071,129.7294293,1.8,119.8260029,130.5541689,0.2768596,26.0889531,34.5217723,221898.1697817,408717.3203954,14.3109874,11839.4072208,8505.4455239,18112.1437934,50.0128481,65.3246729,2.9207639,244.8869871),(25251,'windfallLgGiraffe_radius-cleaned.tif',247,3,85,1151.7477674,119.8391633,129.6717448,1.8,119.864797,130.4848048,0.2779117,28.8389456,34.2553327,221090.4361032,405791.2641041,14.4480779,11846.0756961,7666.3841849,17941.1818049,49.8996984,65.0521341,2.9402755,256.6864739),(25252,'windfallLgGiraffe_radius-cleaned.tif',247,3,86,1149.7228513,119.9055638,129.6132694,1.8,119.8553324,130.3735507,0.2806115,29.7342937,34.0975768,219801.8104497,401970.8098573,14.6968301,11788.8380159,7392.1988202,18150.7375468,49.9003546,64.6869628,2.8771043,260.8555789),(25253,'windfallLgGiraffe_radius-cleaned.tif',247,3,87,1149.5184967,119.9939926,129.5240837,1.8,120.1094958,130.2306273,0.281888,28.4225198,34.2282031,218911.8538078,399722.8765045,14.8246441,11678.1729744,7702.0565086,17839.9117188,49.2542219,64.3839914,2.9243846,243.1345596),(25254,'windfallLgGiraffe_radius-cleaned.tif',247,3,88,1149.2924363,120.0795845,129.4396893,1.8,120.2139356,130.0792091,0.2842091,25.6709037,33.5045123,217857.1730288,396899.6659667,15.0601853,11846.155609,8486.5408487,18119.6249568,49.0836462,64.2553811,2.9031605,252.8840468),(25255,'windfallLgGiraffe_radius-cleaned.tif',247,3,89,1158.9691118,120.302535,129.3954396,1.8,120.3440617,130.1895109,0.288358,32.366722,33.4334997,216996.4052534,393967.5332379,15.6211825,11783.6163393,6704.3058966,17776.3687081,49.2986091,63.9606536,2.9229237,244.825358),(25256,'windfallLgGiraffe_radius-cleaned.tif',247,3,90,1159.6249036,120.4081799,129.3640613,1.8,120.4752742,130.1384482,0.2908894,32.0807549,32.8490787,215373.2851576,389822.0015627,15.8978237,11867.0604164,6713.4731045,17644.260313,49.071552,63.7368702,2.8801138,238.6498318),(25257,'windfallLgGiraffe_radius-cleaned.tif',247,3,91,1157.569736,120.4704558,129.3117462,1.8,120.5037617,130.0886007,0.2919798,26.319672,33.140914,213794.1541296,385254.988237,15.9854499,11624.7544781,8122.9794145,17579.9435479,49.7883375,63.5182182,2.8933027,240.5946237),(25258,'windfallLgGiraffe_radius-cleaned.tif',247,3,92,1155.8618628,120.5510429,129.2295951,1.8,120.6087904,129.9955625,0.2934389,25.4673621,33.0985744,212082.4110682,381775.8155668,16.1171785,11534.5093289,8327.6159432,17481.8613943,49.7801667,63.3537339,2.9348014,241.6722273),(25259,'windfallLgGiraffe_radius-cleaned.tif',247,3,93,1153.728645,120.6326113,129.1535797,1.8,120.6398347,129.9124828,0.295179,31.7868037,32.6970671,210272.9708988,378441.3558329,16.2732062,11574.1682405,6615.1026885,17402.1498701,0.4335942,0.6131948,2.3561945,1.2263896),(25260,'windfallLgGiraffe_radius-cleaned.tif',247,3,94,1152.2035915,120.7342855,129.0799398,1.8,120.74081,129.8112377,0.2972147,26.7646538,32.9361188,208595.3752891,375531.5641023,16.4699668,11401.8159238,7793.6885264,17125.2290081,49.2961979,62.9921475,2.8982834,246.1133767),(25261,'windfallLgGiraffe_radius-cleaned.tif',247,3,95,1151.1777737,120.8396493,128.9804914,1.8,120.8349008,129.6378834,0.2978393,25.3539929,32.7729618,207295.2069182,374001.6441556,16.5224803,11411.8963675,8176.0378954,17668.9637774,48.669857,62.7888694,2.9116882,240.6382021),(25262,'windfallLgGiraffe_radius-cleaned.tif',247,3,96,1150.1563997,120.934017,128.9088311,1.8,120.9349638,129.4843319,0.2998442,25.1658177,32.3254664,206156.7967176,371984.6286752,16.7240872,11507.4790823,8191.9371416,17694.8935636,48.390626,62.6914816,2.9184226,248.7585202),(25263,'windfallLgGiraffe_radius-cleaned.tif',247,3,97,1159.2492376,121.1502823,128.8181397,1.8,121.1090828,129.4281638,0.3026803,32.9402527,32.5384045,205195.8869313,370512.8298591,17.1668394,11386.9390713,6229.3355374,12642.3896922,48.6378218,62.4812077,2.874732,242.0133777),(25264,'windfallLgGiraffe_radius-cleaned.tif',247,3,98,1156.3331829,121.226274,128.7630607,1.8,121.2174627,129.4051908,0.3029067,33.2756887,32.1209507,203043.4643354,366585.380573,17.1485001,11412.6566017,6101.8561035,16690.5851383,48.7725332,62.3682694,2.8814381,253.1380404),(25265,'windfallLgGiraffe_radius-cleaned.tif',247,3,99,1151.6545061,121.3020442,128.72002,1.8,121.2600797,129.4325537,0.3043421,25.4806611,32.2502398,200839.710917,362557.6803169,17.2363197,11242.0150164,7882.0447462,17079.6415893,0.4335942,0.6131948,2.3561945,1.2263896),(25266,'windfallLgGiraffe_radius-cleaned.tif',247,3,100,1151.040303,121.4000548,128.6828315,1.8,121.3966513,129.3557171,0.3057789,25.1112263,32.2843007,199184.1475797,360128.4036237,17.3850636,11154.90797,7932.0756923,16852.4422869,48.7356564,61.9493659,2.8796377,267.0927343),(25267,'windfallLgGiraffe_radius-cleaned.tif',247,3,101,1151.8036559,121.4749624,128.6270031,1.8,121.4390152,129.258939,0.3060387,24.9484136,31.991832,197965.179146,358184.0612306,17.4252346,11196.1097143,7934.9806544,16551.4205283,45.8627644,61.9493659,2.8796377,182.4643784),(25268,'windfallLgGiraffe_radius-cleaned.tif',247,3,102,1149.7619333,121.5469872,128.5620505,1.8,121.5351236,129.1960376,0.3040585,78.1435827,77.4212895,196505.3536391,356722.5070056,17.1769343,4607.5505745,2514.6703896,5029.2453508,0.4335942,0.9695461,2.0344439,2.0935779),(25269,'windfallLgGiraffe_radius-cleaned.tif',247,3,103,1148.561215,121.6233144,128.4695225,1.8,121.6192184,128.9203458,0.3023627,31.983935,31.8517225,195477.2766199,356095.8818537,16.9739885,11179.7998231,6111.7331796,15218.3892266,45.7432497,61.7167671,2.7976235,181.9563913),(25270,'windfallLgGiraffe_radius-cleaned.tif',247,3,104,1150.6604781,121.6707105,128.4193743,1.8,121.670815,128.8745484,0.3010018,24.6974799,31.5118157,194718.7680588,355180.0068262,16.8569177,11271.327864,7884.1553489,16997.2130427,45.6819881,61.6451389,2.8710223,181.2379889),(25271,'windfallLgGiraffe_radius-cleaned.tif',247,3,105,1158.1506681,121.8285969,128.3409262,1.8,121.7870147,128.8260618,0.2975563,24.7954654,31.6659678,193686.4988068,354014.633944,16.5919256,11179.6562069,7811.3677357,17069.6565797,45.6237349,61.6451389,2.8710223,180.9839953),(25272,'windfallLgGiraffe_radius-cleaned.tif',247,3,106,1153.4103487,121.8701233,128.2798877,1.8,121.8589167,128.7935301,0.2958362,25.4318405,31.9658459,191440.7513515,351328.6371506,16.3391134,10990.7505099,7527.6011405,16640.3584162,45.5042202,61.530666,2.8778128,181.0892029),(25273,'windfallLgGiraffe_radius-cleaned.tif',247,3,107,1148.528001,121.9356632,128.2090859,1.8,121.930251,128.7522263,0.2939338,36.3849096,38.918803,189459.2210915,348713.4256393,16.067417,8960.0244214,5207.0823687,10101.2356618,47.8848752,61.4664681,2.8555412,256.7120015),(25274,'windfallLgGiraffe_radius-cleaned.tif',247,3,108,1149.4559997,121.9843224,128.1588523,1.8,121.9953113,128.6464489,0.2914135,24.4089675,31.7272604,188379.2274406,347725.7030348,15.81364,10959.8401853,7717.6237713,16518.1604513,47.8272371,61.4328138,2.8332342,267.6442999),(25275,'windfallLgGiraffe_radius-cleaned.tif',247,3,109,1149.4150946,122.0494443,128.0960921,1.8,122.1066123,128.5868546,0.2889748,32.9623566,31.8497689,187379.8281591,346578.5291938,15.5568923,10881.6654448,5684.6611553,15735.3807922,0.4335942,0.6131948,2.3561945,1.2263896),(25276,'windfallLgGiraffe_radius-cleaned.tif',247,3,110,1149.0551525,122.1203531,128.0251509,1.8,122.1320188,128.5040957,0.2862013,25.8702541,31.9245103,186423.9864645,345605.9254471,15.2630895,10825.7236297,7206.1134716,16549.9708181,48.2000887,61.3455327,2.8623221,279.5925726),(25277,'windfallLgGiraffe_radius-cleaned.tif',247,3,111,1150.302587,122.2007555,127.9250082,1.8,122.2097835,128.3125393,0.2823683,33.3436369,31.4157512,186136.2892233,345976.0634157,14.8839991,11012.8215841,5582.3631308,15701.8866054,45.1068313,61.3102789,2.8914682,179.2496186),(25278,'windfallLgGiraffe_radius-cleaned.tif',247,3,112,1153.280569,122.2795884,127.8294923,1.8,122.3121616,128.1711792,0.2787219,24.5167907,31.3466412,185661.6619269,346093.7834935,14.5495856,11040.8570075,7572.8370816,16538.1534449,44.9709162,61.2274292,2.8691295,178.3824302),(25279,'windfallLgGiraffe_radius-cleaned.tif',247,3,113,1161.7964058,122.4702487,127.7089677,1.8,122.4776621,128.1684112,0.2747365,24.7296463,31.6474373,184987.342332,346659.8444718,14.2513868,10953.8045927,7480.3877086,16323.962318,44.8831039,62.0812393,2.7091849,196.6730659),(25280,'windfallLgGiraffe_radius-cleaned.tif',247,3,114,1159.5805803,122.5268997,127.6478932,1.8,122.5010351,128.1254857,0.2712886,24.3418912,31.8093327,183049.5325762,345018.4438277,13.8781706,10846.4533728,7519.938824,16438.8655814,44.745144,61.1121738,2.8759629,198.004663),(25281,'windfallLgGiraffe_radius-cleaned.tif',247,3,115,1159.56554,122.6238667,127.5635582,1.8,122.61757,128.0313838,0.2688253,24.3638101,31.7250957,181338.6354713,343744.5795391,13.6331786,10835.099844,7442.950604,16338.2879179,44.5661393,61.1121738,2.8759629,177.7692354),(25282,'windfallLgGiraffe_radius-cleaned.tif',247,3,116,1161.5698326,122.734377,127.4937642,1.8,122.7150302,128.0563158,0.2658609,32.3891569,31.4431915,180083.5427628,343240.2407748,13.3643143,10916.2023325,5559.9947553,15957.7405136,46.758045,61.0013238,2.91213,249.1177214),(25283,'windfallLgGiraffe_radius-cleaned.tif',247,3,117,1161.9494296,122.8685584,127.4040755,1.8,122.8765166,127.9221629,0.2608212,23.9907561,31.782023,178733.4977683,342763.4835507,12.8780846,10784.8227205,7450.0985768,16379.9716106,46.8584326,60.9041646,2.9190627,262.7387417),(25284,'windfallLgGiraffe_radius-cleaned.tif',247,3,118,1163.4575059,122.9741534,127.3369286,1.8,122.9237093,127.876562,0.2584808,35.9177896,43.7018937,177455.128397,342551.8614355,12.6695759,7838.3757026,4940.591563,9192.593417,46.571839,60.9041646,2.9190627,258.7184226),(25285,'windfallLgGiraffe_radius-cleaned.tif',247,3,119,1164.6618134,123.0753156,127.2390128,1.8,123.0771984,127.6949513,0.2562317,23.7952261,31.2646739,176609.1654091,343235.4494973,12.467777,10978.3793296,7422.0419063,15974.0215059,46.2201731,60.9041646,2.9190627,239.2013974),(25286,'windfallLgGiraffe_radius-cleaned.tif',247,3,120,1164.3829409,123.1755994,127.1581426,1.8,123.2357096,127.5833284,0.2532188,23.4512927,31.0461815,175534.1380284,343608.548671,12.1796326,11067.6589636,7485.0516754,16319.2357904,45.9372265,60.8887282,2.9553698,244.5097352),(25287,'windfallLgGiraffe_radius-cleaned.tif',247,3,121,1173.3270278,123.4107946,127.0317082,1.8,123.3681926,127.5232928,0.2498615,24.7908681,31.500225,174623.9951815,343945.3571582,11.9566544,10918.8222285,7043.8838399,16344.056923,46.1540305,60.8099418,2.8672107,226.1319427),(25288,'windfallLgGiraffe_radius-cleaned.tif',247,3,122,1172.0590838,123.5132179,126.9733007,1.8,123.4624009,127.4793854,0.2471355,23.8122556,31.1485458,172775.5477576,342523.613923,11.6898426,10996.4560171,7255.7405312,15838.0653449,46.354641,60.8099418,2.9623769,236.1534743),(25289,'windfallLgGiraffe_radius-cleaned.tif',247,3,123,1171.2396146,123.6331435,126.9244625,1.8,123.6348878,127.4842531,0.2448325,24.7951608,31.7306276,171198.4315694,340990.0685515,11.4693155,10746.401631,6904.5098452,14809.4923646,46.2849648,60.7186692,2.9329931,242.1185853),(25290,'windfallLgGiraffe_radius-cleaned.tif',247,3,124,1173.2191819,123.736381,126.8662933,1.8,123.7911394,127.4456216,0.2424732,23.980771,31.6437243,170142.9164985,340737.1746478,11.272691,10767.9226271,7094.9727387,16143.4929407,46.4827416,60.8099418,2.9623769,238.0802154),(25291,'windfallLgGiraffe_radius-cleaned.tif',247,3,125,1175.3706874,123.8439024,126.8270432,1.8,123.8962519,127.3826778,0.2401603,34.3612745,31.6074071,169383.2162673,340862.528877,11.0830753,10784.2610292,4929.4800235,14801.0721188,45.5901518,60.8578438,0.0713075,229.3031242),(25292,'windfallLgGiraffe_radius-cleaned.tif',247,3,126,1175.5049677,123.9598255,126.7799196,1.8,124.0296928,127.3090862,0.2381733,25.3088797,31.5594364,168364.7104661,340939.8564575,10.9051572,10803.1034428,6652.3968099,15998.2532225,45.5244821,60.758908,0.0428309,221.4803781),(25293,'windfallLgGiraffe_radius-cleaned.tif',247,3,127,1179.5275109,124.0690107,126.7403504,1.8,124.1205633,127.2230397,0.2360615,23.4949364,31.6062622,168130.9820407,342660.8923636,10.7528896,10841.5506373,7156.051809,15195.1710434,45.1148512,60.7186692,2.9329931,234.2522608),(25294,'windfallLgGiraffe_radius-cleaned.tif',247,3,128,1181.969169,124.1566151,126.7024075,1.8,124.2362649,127.092157,0.2350535,23.6588421,31.0497029,167938.1186304,343832.8073446,10.6850202,11073.626315,7098.3236473,16307.707762,44.975713,60.783657,2.896614,217.757631),(25295,'windfallLgGiraffe_radius-cleaned.tif',247,3,129,1192.0155286,124.3555942,126.6505049,1.8,124.4556214,127.1456402,0.2333075,24.0673789,31.8651207,167830.2095421,345527.3534186,10.6192468,10843.4346185,6973.3480558,15814.4143802,45.2571029,60.8099418,2.9260173,252.3324813),(25296,'windfallLgGiraffe_radius-cleaned.tif',247,3,130,1192.8511206,124.4493785,126.6370761,1.8,124.522142,127.1154154,0.2320337,23.7481528,31.2169264,166741.5255554,345029.4027803,10.5130533,11052.63851,7021.2419141,16139.5025625,44.9897237,60.9041646,2.9190627,227.6123258),(25297,'windfallLgGiraffe_radius-cleaned.tif',247,3,131,1189.8378735,124.5538821,126.6257606,1.8,124.6633705,127.0726346,0.229982,24.2984123,32.0377614,165763.1142438,344523.4913808,10.3051421,10753.6692995,6821.9730718,15848.6268144,45.3043132,61.0059466,3.041924,237.9314294),(25298,'windfallLgGiraffe_radius-cleaned.tif',247,3,132,1190.2766063,124.6589278,126.6101347,1.8,124.7852707,127.0794502,0.2293067,23.8210651,31.6415498,165085.4369454,345456.7353064,10.2495456,10917.8196846,6930.2290329,15752.0740845,45.1241916,61.0506154,3.034857,237.3182347),(25299,'windfallLgGiraffe_radius-cleaned.tif',247,3,133,1190.7619413,124.7667156,126.6037598,1.8,124.9271927,127.0571339,0.2277581,23.7513131,31.7741968,164560.6769639,346287.188676,10.1180983,10898.3774272,6928.4875304,15322.7302313,45.1148512,61.2596618,3.0067025,240.7434097),(25300,'windfallLgGiraffe_radius-cleaned.tif',247,3,134,1188.8139359,124.8698663,126.5836699,1.8,125.0691464,127.0258095,0.2267193,24.4160787,31.404976,163998.1119384,346951.015778,10.0111938,11047.6446565,6716.8079729,16138.7790495,45.5678999,61.2596618,3.0067025,215.9180467),(25301,'windfallLgGiraffe_radius-cleaned.tif',247,3,135,1190.68429,124.9556887,126.5565215,1.8,125.1959154,126.9252695,0.2252709,33.9068845,39.0200526,163708.5472011,349919.5270374,9.901404,8967.6846504,4828.1801631,9935.9847384,44.7005501,61.5291383,3.0286008,224.2923584),(25302,'windfallLgGiraffe_radius-cleaned.tif',247,3,136,1190.48079,125.030124,126.5293743,1.8,125.2862554,126.8727853,0.2246939,32.6238741,31.5333467,163332.2677023,352020.0545754,9.8499191,11163.4219369,5006.5258024,15537.4154603,0.4335942,0.6131948,2.3561945,1.2263896),(25303,'windfallLgGiraffe_radius-cleaned.tif',247,3,137,1198.6396472,125.2420774,126.4782132,1.8,125.4769825,126.8880706,0.2231515,23.4878943,31.9428994,162958.403552,354969.6970073,9.7839997,11112.6323542,6937.974139,16183.9484552,0.4335942,0.6131948,2.3561945,1.2263896),(25304,'windfallLgGiraffe_radius-cleaned.tif',247,3,138,1196.2041989,125.3219973,126.4756908,1.8,125.534312,126.8867426,0.2215283,23.4936374,31.5622147,161452.2573191,355225.4261124,9.6249058,11254.7687085,6872.1694543,14906.1124026,44.3970404,62.0100322,3.0224414,217.2496438),(25305,'windfallLgGiraffe_radius-cleaned.tif',247,3,139,1195.0362958,125.4111762,126.4788661,1.8,125.6953837,126.8999745,0.2193325,33.5717528,46.3738563,160244.3406202,355904.3627353,9.4288871,7674.6768767,4773.1895726,9015.6502348,45.7522808,62.4405734,3.0232669,265.6123511),(25306,'windfallLgGiraffe_radius-cleaned.tif',247,3,140,1194.370591,125.4782283,126.4884521,1.8,125.7425909,126.9226574,0.2187013,23.9519119,32.0253322,159296.8958067,357429.6861697,9.3703417,11160.8424114,6650.6964756,15800.0997966,44.6038744,62.4932424,3.0163771,222.303988),(25307,'windfallLgGiraffe_radius-cleaned.tif',247,3,141,1193.4203167,125.5363723,126.4916454,1.8,125.8137927,126.9316149,0.2177015,23.6363355,32.0195467,158259.2787576,358888.8720749,9.2788283,11208.4307587,6695.5928303,16003.2649126,44.3785733,62.6914816,3.0515589,220.8671833),(25308,'windfallLgGiraffe_radius-cleaned.tif',247,3,142,1196.0214933,125.6125997,126.5046485,1.8,125.9157747,126.9270055,0.2172012,24.7195923,32.2288597,157515.2333893,361096.5896611,9.2570344,11204.1379399,6372.0805585,15999.9783242,0.4335942,0.6131948,2.3561945,1.2263896),(25309,'windfallLgGiraffe_radius-cleaned.tif',247,3,143,1196.6164402,125.6868367,126.4945112,1.8,126.0535917,126.8896071,0.216323,23.2479831,31.9660374,157213.6123489,364197.1594898,9.1880641,11393.2532605,6762.4624292,16310.9073225,0.4335942,0.6131948,2.3561945,1.2263896),(25310,'windfallLgGiraffe_radius-cleaned.tif',247,3,144,1195.3438246,125.7367054,126.4996657,1.8,126.1469088,126.8566822,0.2156335,24.1033612,32.4851656,156834.2895722,366419.5203985,9.1207875,11279.5952782,6506.7393867,16086.0594147,0.4335942,0.6131948,2.3561945,1.2263896),(25311,'windfallLgGiraffe_radius-cleaned.tif',247,3,145,1200.5395692,125.9171208,126.4797549,1.8,126.307196,126.8783919,0.2157829,23.9636358,32.0303291,156265.9230788,368656.4358666,9.1729313,11509.6050067,6520.9605356,16386.3312861,45.8317321,63.4086094,3.0113005,268.6166958),(25312,'windfallLgGiraffe_radius-cleaned.tif',247,3,146,1196.9617407,125.983228,126.5053846,1.8,126.3603339,126.8605088,0.2155378,23.6345818,32.0452996,154999.8931918,368728.2221264,9.1251571,11506.4682581,6558.1821787,16324.9156415,45.0937951,63.5270971,2.9977651,264.6835336),(25313,'windfallLgGiraffe_radius-cleaned.tif',247,3,147,1195.7516792,126.0533548,126.541773,1.8,126.3803054,126.9365935,0.2153477,23.4294799,32.5871837,154062.2210151,368914.7512039,9.100104,11320.854076,6575.5715267,15959.1073977,45.8350708,63.7914161,2.852089,265.5507219),(25314,'windfallLgGiraffe_radius-cleaned.tif',247,3,148,1194.5594495,126.1034029,126.5909804,1.8,126.4237037,126.9840517,0.2144911,24.1511874,32.2939101,153622.7969585,369589.1189899,9.0199635,11444.5453752,6360.8796777,16193.3994365,45.8871992,63.8385533,3.0121829,309.2618646),(25315,'windfallLgGiraffe_radius-cleaned.tif',247,3,149,1193.3799813,126.150901,126.6283201,1.8,126.5371111,127.0051863,0.213886,23.4646448,32.71934,153126.2793928,370447.6232673,8.9610635,11321.9772694,6525.829851,15948.1973238,0.4335942,0.9695461,2.0344439,2.0935779),(25316,'windfallLgGiraffe_radius-cleaned.tif',247,3,150,1192.1389845,126.1962424,126.6916811,1.8,126.6042327,127.0910704,0.2133251,24.1138465,32.1123362,152632.6220092,371062.9055792,8.9055641,11555.1513714,6329.6671423,16088.9771896,46.1016013,63.9562444,2.9987368,268.3627022),(25317,'windfallLgGiraffe_radius-cleaned.tif',247,3,151,1191.6034582,126.2583671,126.7265175,1.8,126.7130379,127.0880794,0.2126116,23.4882074,32.3353033,152659.415327,373382.7739938,8.8430232,11547.2173049,6499.4068256,16033.091436,45.2350108,63.8959548,3.0054537,268.4243314),(25318,'windfallLgGiraffe_radius-cleaned.tif',247,3,152,1189.5498288,126.2939283,126.7674893,1.8,126.7418881,127.085975,0.2130133,23.1220796,32.3119932,152683.3454278,374535.9650826,8.8606594,11591.2368301,6603.3569711,16040.7363102,44.0461828,64.1631495,3.0264579,241.1461893),(25319,'windfallLgGiraffe_radius-cleaned.tif',247,3,153,1194.5119358,126.5091983,126.8119149,1.8,126.8627416,127.1488248,0.2132073,23.936203,32.6454968,152459.8052324,375718.0645188,8.913593,11509.0319104,6369.423147,16111.3370821,43.4669873,64.069318,3.0399038,214.4376636),(25320,'windfallLgGiraffe_radius-cleaned.tif',247,3,154,1191.2586704,126.5460896,126.8701166,1.8,126.9020664,127.2158839,0.2133712,23.8862665,32.8341881,151686.3851606,374496.2482918,8.9027823,11405.6801857,6350.3597402,16024.8573659,0.4335942,1.7877546,1.815775,3.8279547),(25321,'windfallLgGiraffe_radius-cleaned.tif',247,3,155,1187.766925,126.6035578,126.9541111,1.8,126.9738575,127.312893,0.21358,24.7188752,32.5831373,151221.0726842,373316.9709278,8.8938021,11457.3672721,6117.6356728,15909.800818,45.8456431,64.3591662,2.896614,306.6167211),(25322,'windfallLgGiraffe_radius-cleaned.tif',247,3,156,1184.516736,126.6346406,127.0148741,1.8,126.9905653,127.3336726,0.2133122,23.890825,32.6466382,150819.2730326,372663.8399273,8.8475773,11415.0755087,6312.8532828,15862.5587827,0.4335942,1.7877546,1.815775,3.8279547),(25323,'windfallLgGiraffe_radius-cleaned.tif',247,3,157,1181.1589291,126.6727326,127.0879005,1.8,127.0380651,127.3969508,0.2123712,24.0125829,32.7230358,150523.7394715,372495.3413897,8.7459999,11383.2758069,6268.535966,15946.4698648,0.4335942,1.7877546,1.815775,3.8279547),(25324,'windfallLgGiraffe_radius-cleaned.tif',247,3,158,1177.3127108,126.7039519,127.1583786,1.8,127.0473209,127.4664062,0.2113679,23.7698466,32.9219491,150403.6557991,372195.0334545,8.6365721,11305.3766272,6327.49795,15799.8296472,45.8021019,63.8959548,3.0054537,285.9785139),(25325,'windfallLgGiraffe_radius-cleaned.tif',247,3,159,1175.6044389,126.7232859,127.2304647,1.8,127.0587629,127.5445667,0.211184,23.8856234,32.9190043,150804.384759,373417.2605568,8.6092602,11343.5162644,6313.6047245,15757.7737491,45.6043181,64.1631495,3.0264579,284.9009104),(25326,'windfallLgGiraffe_radius-cleaned.tif',247,3,160,1173.7715716,126.7376246,127.2994495,1.8,127.0871377,127.6111767,0.2107336,23.4590253,32.4375277,151273.0550393,374084.8180684,8.5597605,11532.470089,6448.3947363,15961.3195543,0.4335942,1.3711452,1.8925469,2.9607663),(25327,'windfallLgGiraffe_radius-cleaned.tif',247,3,161,1178.9472625,126.8726985,127.2488846,1.8,127.1961865,127.5690653,0.2096216,23.6934618,32.8970083,151610.2246348,375279.9036601,8.5083358,11407.7213581,6398.8211678,15865.3658988,1.0699864,4.5268562,1.8622531,10.1086884),(25328,'windfallLgGiraffe_radius-cleaned.tif',247,3,162,1174.8321416,126.9046036,127.3337095,1.8,127.2109491,127.6485379,0.209326,29.4924828,33.0033422,151101.727622,374117.69276,8.4550911,11335.7517139,5123.3980152,15659.2790323,0.4335942,0.9695461,2.0344439,2.0935779),(25329,'windfallLgGiraffe_radius-cleaned.tif',247,3,163,1171.5140434,126.9281655,127.4142935,1.8,127.2777099,127.6992147,0.2082717,24.0627955,33.197311,150964.4391884,373059.8751413,8.3477221,11237.6534226,6273.7697786,15777.7588063,0.4335942,1.3711452,1.8925469,2.9607663),(25330,'windfallLgGiraffe_radius-cleaned.tif',247,3,164,1168.1879123,126.9581464,127.4969411,1.8,127.2907615,127.792223,0.2061052,24.5095196,33.2028154,151068.5750895,373055.3992803,8.1541955,11235.6556035,6163.6693727,15626.5834824,0.8247451,2.7422904,1.8925469,5.9215326),(25331,'windfallLgGiraffe_radius-cleaned.tif',247,3,165,1166.0414203,126.9767813,127.5788908,1.8,127.3140523,127.8826266,0.205187,25.3024566,33.0838745,151493.9360855,373116.4486081,8.0678728,11277.8945675,5987.3212599,15663.3499166,1.0301374,7.0584019,1.7561443,14.9526174),(25332,'windfallLgGiraffe_radius-cleaned.tif',247,3,166,1163.4933975,126.9805616,127.6592496,1.8,127.3164163,127.9864252,0.2035634,24.1884453,33.3353223,151889.7840844,373394.1374978,7.9251044,11201.1557666,6279.4355844,15647.0934238,1.164115,2.5282668,2.1112158,5.667539),(25333,'windfallLgGiraffe_radius-cleaned.tif',247,3,167,1162.3715839,126.975879,127.7311927,1.8,127.3404103,128.0561722,0.2027397,25.0571933,33.0030879,152690.643572,374770.0522858,7.8544,11355.6056873,6093.6850165,15895.1088047,0.4335942,1.3711452,1.8925469,2.9607663),(25334,'windfallLgGiraffe_radius-cleaned.tif',247,3,168,1159.9006427,126.9474386,127.8049452,1.8,127.3113776,128.1422568,0.2017796,23.7085707,33.1814966,153506.8475815,375390.3620357,7.7646477,11313.2438307,6474.7406891,15887.1283258,0.4335942,1.3711452,1.8925469,2.9607663),(25335,'windfallLgGiraffe_radius-cleaned.tif',247,3,169,1165.8309129,127.076616,127.7735135,1.8,127.5398502,128.1494607,0.1994886,24.1215342,33.487569,154579.4678803,376535.683515,7.6304833,11244.0435443,6408.3597052,15695.5418006,45.6011547,64.8900894,3.047908,257.194461),(25336,'windfallLgGiraffe_radius-cleaned.tif',247,3,170,1160.6075944,127.0684024,127.8687467,1.8,127.5226434,128.2342721,0.1981536,31.3481786,33.5686918,154474.312559,375648.0348765,7.496291,11190.4281997,4927.6965869,15652.9765062,0.4335942,0.6131948,2.3561945,1.2263896),(25337,'windfallLgGiraffe_radius-cleaned.tif',247,3,171,1158.8252033,127.0659382,127.9752165,1.8,127.5167257,128.3593042,0.1960399,24.5230623,33.5597781,154942.3853353,374873.3857045,7.3279929,11170.3177702,6318.2315217,15645.9199353,45.8544324,65.0246728,3.0279899,273.9430844),(25338,'windfallLgGiraffe_radius-cleaned.tif',247,3,172,1157.6552493,127.0540039,128.0787237,1.8,127.457242,128.4566208,0.1938573,28.220817,33.4699826,155857.9629993,375344.1069592,7.160534,11214.3502283,5522.801227,15817.0894655,0.4335942,1.3711452,1.8925469,2.9607663),(25339,'windfallLgGiraffe_radius-cleaned.tif',247,3,173,1155.4640921,127.0560541,128.1765403,1.8,127.5038868,128.5423116,0.1915686,38.8628381,73.7752027,156567.4768854,375946.9825832,6.9812743,5095.8447971,4028.7195866,6386.194551,0.4335942,1.3711452,1.8925469,2.9607663),(25340,'windfallLgGiraffe_radius-cleaned.tif',247,3,174,1154.6184163,127.054709,128.2828515,1.8,127.4772117,128.6177041,0.1891865,26.6736322,33.6246874,157481.1371436,376531.2810744,6.8058143,11198.0604059,5904.0004717,15750.6958719,0.8671884,2.2109052,1.7681919,5.4135454),(25341,'windfallLgGiraffe_radius-cleaned.tif',247,3,175,1153.8885623,127.0312602,128.3537054,1.8,127.4262064,128.6763791,0.1877384,26.0108616,33.0740272,158798.1166445,378373.8158155,6.6990097,11440.2099676,6105.0694632,15830.4561483,0.4335942,0.6131948,2.3561945,1.2263896),(25342,'windfallLgGiraffe_radius-cleaned.tif',247,3,176,1153.8001435,127.02222,128.4225726,1.8,127.3535,128.7255072,0.1853829,25.3556607,33.1669513,160150.9780952,380257.3370191,6.533381,11464.9469466,6316.1824053,15901.761853,0.4335942,0.6131948,2.3561945,1.2263896),(25343,'windfallLgGiraffe_radius-cleaned.tif',247,3,177,1161.1606108,127.1546114,128.4480818,1.8,127.5295375,128.764781,0.1827818,25.3566513,33.4901182,161856.1675847,382273.1118929,6.3938859,11414.5047046,6383.1838676,16052.1196465,0.8414292,2.3349761,1.9513027,5.0543442),(25344,'windfallLgGiraffe_radius-cleaned.tif',247,3,178,1158.1531748,127.1463916,128.5432921,1.8,127.4993462,128.8445479,0.180758,25.8451162,33.4848379,162481.7682138,381719.0652417,6.2384202,11399.7584811,6286.7493721,16045.5495875,0.8671884,1.9390921,2.0344439,4.1871558),(25345,'windfallLgGiraffe_radius-cleaned.tif',247,3,179,1155.9796786,127.1420987,128.6392293,1.8,127.5430203,128.973519,0.1784382,26.0221266,33.4763854,163470.6187083,381462.6030985,6.0696062,11394.9758518,6281.9853783,15926.6438476,0.4335942,0.6131948,2.3561945,1.2263896),(25346,'windfallLgGiraffe_radius-cleaned.tif',247,3,180,1153.5528899,127.1170017,128.7245507,1.8,127.5164408,129.1058347,0.1771351,27.3229585,33.4885443,164696.2974011,382360.4543708,5.9696448,11417.6492826,6027.762231,15960.845516,0.4335942,0.9695461,2.0344439,2.0935779),(25347,'windfallLgGiraffe_radius-cleaned.tif',247,3,181,1149.7344164,127.1011007,128.7894264,1.8,127.5219318,129.172779,0.174715,27.2003648,33.4976118,165801.0042931,383351.2815134,5.7900609,11444.137697,6095.5434093,16012.295426,0.8671884,1.9390921,2.0344439,4.1871558),(25348,'windfallLgGiraffe_radius-cleaned.tif',247,3,182,1145.2086494,127.0741931,128.8468766,1.8,127.4794795,129.2212951,0.173033,25.2324756,33.7952943,166950.860183,383789.8917161,5.657864,11356.3115714,6616.507343,16043.9922149,46.8864828,65.7949707,3.0425797,284.3929232),(25349,'windfallLgGiraffe_radius-cleaned.tif',247,3,183,1143.4276826,127.0364558,128.8953354,1.8,127.4067828,129.2419954,0.1721,24.8824548,33.6224352,168884.0524028,386305.6781068,5.5889086,11489.5210893,6787.2745669,16154.1046593,0.8414292,2.3349761,1.9513027,5.0543442),(25350,'windfallLgGiraffe_radius-cleaned.tif',247,3,184,1140.0855997,127.0239976,128.9549239,1.8,127.3690801,129.3168802,0.1701281,24.7672289,33.3208635,170741.2227919,388150.4030996,5.4468334,11648.8698739,6893.8363545,16253.6903895,0.4335942,1.3711452,1.8925469,2.9607663),(25351,'windfallLgGiraffe_radius-cleaned.tif',247,3,185,1144.9778603,127.1291905,129.000735,1.8,127.5068081,129.3511224,0.168558,26.5781614,33.7278862,173008.5862854,390216.6726639,5.3706622,11569.5561399,6509.4264204,16428.0243731,0.4335942,0.6131948,2.3561945,1.2263896),(25352,'windfallLgGiraffe_radius-cleaned.tif',247,3,186,1140.4602402,127.1185446,129.0851178,1.8,127.5192274,129.4528109,0.1676624,24.8011382,34.1543876,174096.2800039,390074.354392,5.2933088,11420.9149013,7019.6891274,16454.2879985,0.4335942,1.3711452,1.8925469,2.9607663),(25353,'windfallLgGiraffe_radius-cleaned.tif',247,3,187,1136.5419537,127.1144302,129.1813003,1.8,127.4800387,129.5430707,0.1665476,35.3710966,69.6270272,175682.7867438,390400.8038019,5.2058504,5607.0296223,4966.8459193,7248.5296239,47.0136137,65.7535251,3.0491417,275.2746815),(25354,'windfallLgGiraffe_radius-cleaned.tif',247,3,188,1135.015134,127.1082523,129.2622185,1.8,127.5136972,129.658584,0.1652975,25.2641871,34.2851239,177621.4885286,392390.5785454,5.1218139,11444.9222751,7030.5641633,16589.8062495,47.9134789,65.7535251,3.0491417,292.6620273),(25355,'windfallLgGiraffe_radius-cleaned.tif',247,3,189,1133.2402062,127.1073667,129.3480618,1.8,127.5101215,129.7349626,0.1652606,27.3897578,34.4859495,179639.4285636,394637.8257087,5.1115466,11443.4380226,6558.6351494,16644.7110771,0.4335942,0.6131948,2.3561945,1.2263896),(25356,'windfallLgGiraffe_radius-cleaned.tif',247,3,190,1130.8645203,127.0713094,129.4526972,1.8,127.4773843,129.8497359,0.1621031,25.8846521,34.5078061,182015.1438021,396771.368199,4.9094714,11498.0177834,7031.7786488,16764.7881867,0.4335942,0.6131948,2.3561945,1.2263896),(25357,'windfallLgGiraffe_radius-cleaned.tif',247,3,191,1128.5003995,127.0438807,129.5211332,1.8,127.4111607,129.8556962,0.1592895,28.1019159,33.9766626,184576.0345889,400664.4396622,4.7320409,11792.3424208,6568.0943404,17078.5968041,46.0200807,66.0487916,3.0758979,208.516131),(25358,'windfallLgGiraffe_radius-cleaned.tif',247,3,192,1129.6405578,127.0201991,129.6024434,1.8,127.3397093,129.9831964,0.1575513,25.2352797,34.1310476,187585.8362053,404633.5326039,4.6348634,11855.2919258,7433.4756016,17254.3775856,47.261766,66.1113836,3.0628087,272.4446505),(25359,'windfallLgGiraffe_radius-cleaned.tif',247,3,193,1137.2846262,127.136411,129.6765683,1.8,127.5120131,130.0159496,0.154656,30.9349281,34.187852,191162.8981728,410105.8738391,4.4976564,11995.6607436,6179.5164802,17566.9128761,48.5625486,66.2264551,3.0432269,277.4554163),(25360,'windfallLgGiraffe_radius-cleaned.tif',247,3,194,1133.4221142,127.0999969,129.7653792,1.8,127.4418021,130.0166737,0.1521988,30.0215118,34.4433727,192808.5784931,411811.7531756,4.3421693,11956.1971212,6422.3474085,17229.0718909,46.436088,66.511143,3.0698207,211.7308909),(25361,'windfallLgGiraffe_radius-cleaned.tif',247,3,195,1132.5104661,127.0650452,129.8683116,1.8,127.4491999,130.1421434,0.1498092,30.7159616,34.4623355,195185.0478906,415398.4578823,4.2045196,12053.6943249,6354.5153011,17605.0386158,0.4335942,0.9695461,2.0344439,2.0935779),(25362,'windfallLgGiraffe_radius-cleaned.tif',247,3,196,1132.2740939,127.0305832,129.9687276,1.8,127.4243534,130.2107119,0.1483751,27.0983951,34.867627,198156.2688004,419604.61134,4.1241371,12034.2176098,7312.4724908,17701.4850558,46.9744914,66.8494808,3.0180422,216.0232543),(25363,'windfallLgGiraffe_radius-cleaned.tif',247,3,197,1133.2574114,126.973332,130.0554678,1.8,127.3292194,130.2524612,0.1473156,27.002442,34.8130733,201169.0668007,424378.5182582,4.0694025,12190.2055077,7450.0323543,17775.8336649,47.1608403,67.1791188,3.0316482,224.5027736),(25364,'windfallLgGiraffe_radius-cleaned.tif',247,3,198,1131.6221191,126.9410796,130.1189658,1.8,127.3492029,130.3687664,0.147088,41.2150489,70.6435686,203838.2684787,429498.7292642,4.051074,6079.7994423,4945.7242943,7743.6900551,47.2061633,67.443063,3.0579175,226.2371503),(25365,'windfallLgGiraffe_radius-cleaned.tif',247,3,199,1129.6522938,126.8951204,130.1718455,1.8,127.223525,130.4739429,0.1451855,36.1420109,69.8500875,206928.7036947,437109.7870482,3.940818,6257.8273378,5725.4341605,8189.0241692,47.5259535,67.9125325,3.0520888,201.8761961),(25366,'windfallLgGiraffe_radius-cleaned.tif',247,3,200,1131.0400476,126.8696385,130.2178251,1.8,127.1763909,130.5673852,0.1446351,38.5181965,71.5109405,210483.2764596,445529.6807954,3.9160087,6230.2310365,5464.5153572,8076.5118517,47.6172253,68.3072558,3.0589786,191.6623001),(25367,'windfallLgGiraffe_radius-cleaned.tif',247,3,201,1132.6445186,126.963873,130.2091048,1.8,127.3758185,130.5307911,0.1446746,26.4270233,35.3678318,212741.4021227,454800.4769923,3.9236906,12859.1563017,8050.146223,18729.3152159,47.6953602,68.7051841,3.0657888,240.6817805),(25368,'windfallLgGiraffe_radius-cleaned.tif',247,3,202,1124.6830085,126.9613447,130.2297409,1.8,127.3556717,130.5197418,0.1440834,27.1274588,35.5011899,213661.7226049,460604.2746393,3.8645542,12974.3334304,7876.2159003,18894.2329724,47.6953602,69.2475839,3.0475314,254.7236312),(25369,'windfallLgGiraffe_radius-cleaned.tif',247,3,203,1116.4752703,126.960647,130.2709517,1.8,127.2943589,130.5782252,0.1430569,36.2636796,69.2648446,214899.4770019,467383.0970087,3.7822521,6747.7679291,5926.0251367,8726.6727816,47.261766,69.7210818,3.041924,194.1586576),(25370,'windfallLgGiraffe_radius-cleaned.tif',247,3,204,1109.7036541,126.9817828,130.3045951,1.8,127.3563105,130.59596,0.1435796,26.7819328,36.5097222,216764.6167502,474846.3290781,3.7866464,13006.0241529,8093.6883107,18901.0240159,47.261766,70.3505728,3.0860941,251.0008841),(25371,'windfallLgGiraffe_radius-cleaned.tif',247,3,205,1105.9423224,127.0272838,130.3234118,1.8,127.3115753,130.6587039,0.1451023,32.0349563,36.2172677,218100.0738582,485122.1461833,3.8537154,13394.7748328,6808.1901546,19296.4792949,47.5799284,70.6279541,3.0370371,221.3315921),(25372,'windfallLgGiraffe_radius-cleaned.tif',247,3,206,1101.5599511,127.0530525,130.3014645,1.8,127.3251023,130.5488949,0.1452826,26.6940746,36.8017016,219400.601748,495754.2132362,3.8479253,13470.9590035,8219.075013,19369.2206595,47.5920593,71.4062617,3.050383,215.9180467),(25373,'windfallLgGiraffe_radius-cleaned.tif',247,3,207,1097.4423235,127.0712862,130.3036468,1.8,127.2897175,130.5694387,0.1437855,41.7304925,61.2159717,221925.774071,507658.6731048,3.7554832,8292.9121096,5318.072246,9847.7203921,47.6040554,71.9217613,3.0389246,199.3617878),(25374,'windfallLgGiraffe_radius-cleaned.tif',247,3,208,1096.406422,127.0665145,130.320294,1.8,127.206858,130.5594796,0.1407777,43.0600828,59.0677199,225451.5595337,519957.718901,3.5976349,8802.7389594,5235.7437516,10197.5407672,0.4335942,0.6131948,2.3561945,1.2263896),(25375,'windfallLgGiraffe_radius-cleaned.tif',247,3,209,1098.4968546,127.18494,130.3374867,1.8,127.2522368,130.5000643,0.1380305,40.8710326,69.4469743,228763.4788702,534586.2420882,3.4660728,7697.7614525,5597.2033063,9473.0543578,47.9211064,73.8142364,3.0887009,243.7477544),(25376,'windfallLgGiraffe_radius-cleaned.tif',247,3,210,1091.6358511,127.2145675,130.3644555,1.8,127.2906695,130.5684552,0.1377527,33.8020225,37.6213315,230010.3025171,543695.3955154,3.4306656,14451.7850311,6804.6313608,17167.0594651,48.1250314,74.4684598,3.048297,234.8038264),(25377,'windfallLgGiraffe_radius-cleaned.tif',247,3,211,1089.6701847,127.2687398,130.4153996,1.8,127.3127389,130.585104,0.1348877,29.5972266,39.4842119,233013.5272134,554948.9188001,3.2843764,14054.9574801,7872.8162618,19847.427755,0.4335942,0.6131948,2.3561945,1.2263896),(25378,'windfallLgGiraffe_radius-cleaned.tif',247,3,212,1092.0075291,127.2470565,130.4714587,1.8,127.3101441,130.6821085,0.1319277,39.9329154,70.0072745,237539.444632,569361.0141228,3.1493816,8132.8835895,5948.4623714,10130.4954081,48.6357888,76.0460417,3.0158232,255.5472411),(25379,'windfallLgGiraffe_radius-cleaned.tif',247,3,213,1092.5431694,127.2270313,130.5696844,1.8,127.1788922,130.752704,0.1303625,40.5222174,70.7229137,242261.0441598,583258.0674318,3.0770237,8247.0876453,5978.474523,10127.9020024,0.4335942,0.6131948,2.3561945,1.2263896),(25380,'windfallLgGiraffe_radius-cleaned.tif',247,3,214,1098.6969363,127.1916864,130.6301907,1.8,127.1006536,130.7832494,0.1269631,46.3212962,70.6121559,248125.676199,600341.4190977,2.9359396,8501.9556735,5356.6220427,10386.9456177,49.2811508,78.2201984,3.0750245,278.8305918),(25381,'windfallLgGiraffe_radius-cleaned.tif',247,3,215,1110.196851,127.1527553,130.7004689,1.8,126.9788204,130.5753394,0.1243811,44.4881028,70.5367503,256154.2615251,622338.986998,2.8478495,8822.9041521,5757.8149017,10780.459458,49.6722806,79.0069998,3.026087,227.9534763),(25382,'windfallLgGiraffe_radius-cleaned.tif',247,3,216,1127.5392438,127.1186584,130.7537769,1.8,126.8514524,130.2914862,0.1248145,51.0966616,69.2369793,265909.6246512,646770.2810962,2.9124184,9341.3994647,5204.0508391,11355.2065723,50.0729176,80.2512439,3.0333221,247.4088723),(25383,'windfallLgGiraffe_radius-cleaned.tif',247,3,217,1144.4113419,127.2965699,130.9036657,1.8,127.0522936,130.6471829,0.1224427,50.6757336,69.1644791,274629.9550779,675056.7050752,2.8452824,9760.1646685,5419.3582513,11981.7111763,50.6631989,81.4995605,3.0403359,275.7465672),(25384,'windfallLgGiraffe_radius-cleaned.tif',247,3,218,1156.2296099,127.2149712,130.9871915,1.8,127.0592232,130.5745128,0.1173398,42.6708709,69.8232356,280504.1412331,697565.7792916,2.6411289,9990.4533659,6573.668064,12008.4204973,51.1961601,82.7517652,3.0471377,225.0362884),(25385,'windfallLgGiraffe_radius-cleaned.tif',247,3,219,1176.964163,127.1801007,131.096706,1.8,127.1111477,130.6949303,0.115342,43.6904376,69.380538,289009.2015443,727449.0391611,2.5981259,10484.9149292,6614.930349,12497.4853786,51.8170554,84.0882113,3.0434633,267.5210415),(25386,'windfallLgGiraffe_radius-cleaned.tif',247,3,220,1201.6954514,127.0178168,131.1381835,1.8,126.9340662,130.5586686,0.1096563,41.9118111,65.2736058,297873.4478789,763563.6446641,2.3986611,11697.8928121,7107.1480838,13683.4454741,52.4542026,85.4257573,3.0399038,273.3989957),(25387,'windfallLgGiraffe_radius-cleaned.tif',247,3,221,1233.5552217,126.9761218,131.2210777,1.8,126.9790937,130.5657135,0.1090562,43.9121682,68.776207,309548.6938494,804691.8367694,2.4354846,11700.1485292,7049.2691819,13834.0333235,53.264049,87.0315447,3.0567965,263.0798921),(25388,'windfallLgGiraffe_radius-cleaned.tif',247,3,222,1264.8609502,126.728967,131.2485764,1.8,126.5951469,130.5157045,0.1016356,49.2269988,68.3189898,322946.9109512,847624.566548,2.1701382,12406.8662112,6560.3615633,14515.1610501,53.7656788,88.632633,3.0779532,239.7349122),(25389,'windfallLgGiraffe_radius-cleaned.tif',247,3,223,1295.7594508,126.5241351,131.2309417,1.8,126.3839966,130.4454318,0.1005696,52.9634355,69.8165823,337566.692561,896469.0434506,2.1769152,12840.3455773,6373.5799838,15028.7316298,54.9625682,90.3635661,3.0791738,317.3025027),(25390,'windfallLgGiraffe_radius-cleaned.tif',247,3,224,1315.9511283,126.4387004,131.2184185,1.8,125.9998162,130.0750925,0.1045617,53.915818,69.8938227,356782.014584,947743.4034632,2.3891883,13559.7591715,6617.3903715,16076.8312884,55.9336497,92.2170328,3.0615752,315.7604904),(25391,'windfallLgGiraffe_radius-cleaned.tif',247,3,225,1355.8664676,126.5041418,131.2699122,1.8,126.0232728,130.4018987,0.1006869,54.1577111,68.3690982,376008.8711522,1010343.5192332,2.2831953,14777.7804077,6942.8501285,17325.438096,56.8008381,94.0569629,3.0492633,313.2025037),(25392,'windfallLgGiraffe_radius-cleaned.tif',247,3,226,1372.1473789,126.4756688,131.4360518,1.8,126.0162141,130.7850274,0.0975883,47.8279501,70.0204656,388225.5907784,1053390.6931083,2.1710342,15044.0401054,8117.12795,17668.9270233,58.1016206,96.044782,3.0738233,339.0438411),(25393,'windfallLgGiraffe_radius-cleaned.tif',247,3,227,1390.6853626,126.5443068,131.5731931,1.8,125.9846877,130.8667391,0.0966516,43.6986666,67.3939132,405923.8697957,1099258.6762607,2.1584566,16310.9489346,9289.1591655,18836.682161,60.0769328,97.6357443,3.0392727,358.4376079),(25394,'windfallLgGiraffe_radius-cleaned.tif',247,3,228,1410.9725233,126.5798935,131.8332705,1.8,125.8245918,130.9623796,0.0968498,51.729147,66.9522143,425749.2413642,1152866.6236916,2.1989049,17219.2456233,8230.3549534,19820.5269135,63.6747572,99.5993305,3.0631513,464.6149377),(25395,'windfallLgGiraffe_radius-cleaned.tif',247,3,229,1432.813508,126.5309552,132.0724081,1.8,125.6581233,131.1693306,0.0958803,43.1502764,69.9574039,447048.9527209,1206399.9100287,2.1885979,17244.7781454,10360.2801653,20178.0389183,63.738345,101.6979421,3.0733228,437.9499904),(25396,'windfallLgGiraffe_radius-cleaned.tif',247,3,230,1454.0464993,126.4893608,132.4127043,1.8,125.6347532,131.3757017,0.0965435,53.430083,69.9106921,470285.6177845,1266367.6049877,2.2517656,18114.0762075,8801.8882129,21372.1536465,63.9796799,103.4283463,0.0671259,359.8308343),(25397,'windfallLgGiraffe_radius-cleaned.tif',247,3,231,1479.7430455,126.3177446,132.8012529,1.8,125.5383608,131.6423826,0.0984985,53.5470872,69.6926084,495780.0863359,1334662.4870471,2.3850054,19150.7036126,9258.7685419,22649.1999657,66.3145954,105.5639338,0.0616502,375.9662628),(25398,'windfallLgGiraffe_radius-cleaned.tif',247,3,232,1506.6540969,126.1101922,133.0541212,1.8,125.4579775,131.7327899,0.1022552,57.1930124,68.2569158,523794.3946297,1403452.5392386,2.616489,20561.3236866,9158.3634481,24340.2275707,67.650146,107.4141533,3.0648208,419.1513675),(25399,'windfallLgGiraffe_radius-cleaned.tif',247,3,233,1531.6851662,126.1541143,133.3729962,1.8,125.590403,132.2519047,0.1015808,57.6039029,64.7908701,548317.0122845,1473643.2737062,2.6251082,22744.613128,9518.7475937,26356.7498978,0.4335942,0.9695461,2.677945,1.8395843),(25400,'windfallLgGiraffe_radius-cleaned.tif',247,3,234,1533.9230965,126.2473585,133.571686,1.8,125.7270454,132.7704453,0.1002307,53.1538985,65.4421454,558705.3909088,1524436.6219498,2.55976,23294.4169473,10511.0896274,27075.3976814,68.9414752,112.0092198,3.0912476,373.5134837),(25401,'windfallLgGiraffe_radius-cleaned.tif',247,3,235,1552.8649468,126.3784559,133.5921705,1.8,125.6569181,133.1630932,0.0980911,46.7474716,69.4531298,571360.5245452,1601090.2586477,2.4822685,23052.8165291,12222.2765137,27222.8001922,70.2132289,114.0608215,0.1526493,413.4402502),(25402,'windfallLgGiraffe_radius-cleaned.tif',247,3,236,1580.4699036,126.1708119,133.5435579,1.8,125.5764416,133.5283463,0.0982485,40.3531516,69.7132558,581417.0484382,1711012.588609,2.5344777,24543.5759563,14408.2190564,28565.9703634,71.3632682,116.8172258,0.1340232,413.8175021),(25403,'windfallLgGiraffe_radius-cleaned.tif',247,3,237,1608.9895279,126.1365672,133.5316902,1.8,125.515902,133.7750654,0.0997723,41.2079925,69.8090067,596573.2342415,1820537.2273882,2.6606063,26078.8301294,14477.1244145,30106.5617284,72.0954397,119.8987883,2.9817947,466.0953209),(25404,'windfallLgGiraffe_radius-cleaned.tif',247,3,238,1661.9326841,126.4699402,133.4653635,1.8,125.5640331,133.8767039,0.1025759,40.9406254,68.8656411,614078.4351222,1925712.4436715,2.904219,27963.3270206,14999.2441191,31701.3253739,72.8438228,121.6701128,0.1071153,385.5053349),(25405,'windfallLgGiraffe_radius-cleaned.tif',247,3,239,1735.4296247,126.5127888,133.386128,1.8,125.2761202,133.8842276,0.1041181,49.8934487,69.2354331,635391.1762095,2060501.5524033,3.1241945,29760.7953263,12734.9620546,33713.5392878,72.4102287,123.6222566,0.1478494,403.0775682),(25406,'windfallLgGiraffe_radius-cleaned.tif',247,3,240,1883.2792086,126.5353264,133.6154912,1.8,124.7227944,133.8364757,0.1053708,57.4033262,69.6077836,678520.3336503,2263676.1068321,3.4721356,32520.4451073,11820.2267848,42192.5621586,72.4102287,126.3218444,0.0480729,391.7680179),(25407,'windfallLgGiraffe_radius-cleaned.tif',247,3,241,2104.1961726,127.0246343,134.4246943,1.8,124.6428987,133.7112937,0.1197211,58.9574293,71.0332473,763683.2259493,2494673.9606769,5.0026506,35119.8073534,12953.1296498,44192.0346248,74.7728373,127.6653261,3.0872245,477.0276192),(25408,'windfallLgGiraffe_radius-cleaned.tif',247,3,242,1973.605804,126.016929,133.3621502,1.8,124.5974367,133.4274223,0.1303351,47.7126301,70.8679418,729108.1710462,2454707.0858715,5.5561197,34637.7646209,15281.2403957,39359.4631559,71.9343451,128.0160668,0.0406556,508.0104576),(25409,'windfallLgGiraffe_radius-cleaned.tif',247,3,243,1860.2106153,126.4072574,132.9755708,1.8,124.590358,133.237985,0.1269642,60.5353094,93.0417342,691412.1054449,2373668.2217806,4.9709364,25511.8656531,11421.6332933,27613.0135824,70.8164329,128.0131296,0.0915799,416.1289721),(25410,'windfallLgGiraffe_radius-cleaned.tif',247,3,244,1838.1996865,127.2688397,133.0186333,1.8,124.8520057,133.2161793,0.134206,40.3126091,69.7853582,676851.875582,2344059.6044107,5.4849986,33589.5618441,16790.0785855,38884.3451766,72.315485,126.7994278,0.0547398,404.8119449),(25411,'windfallLgGiraffe_radius-cleaned.tif',247,3,245,1841.476139,127.9581493,132.981562,1.8,125.2406364,133.219366,0.1451466,38.0495538,70.3673972,653936.0586637,2323293.9107066,6.4206088,33016.6242293,17186.431711,37217.2962038,69.2327669,126.2421957,2.9724914,452.9897646),(25412,'windfallLgGiraffe_radius-cleaned.tif',247,3,246,1878.337725,128.7657686,132.8856438,1.8,125.6061886,132.960054,0.153117,45.6865934,69.8768045,625977.1603285,2341296.1212166,7.2823638,33506.0559504,13701.550372,42279.8653008,69.1244311,125.8588811,2.9333867,428.9189055),(25413,'windfallLgGiraffe_radius-cleaned.tif',247,3,247,1953.1016411,129.1014064,132.7072509,1.8,125.8857833,132.8960483,0.1615113,64.3412215,93.0832977,605886.540146,2391123.8933076,8.417825,25688.0015302,9416.7708606,26485.6387644,67.8993673,125.9492216,2.9300184,416.3393873),(25414,'windfallLgGiraffe_radius-cleaned.tif',247,3,248,2055.9184191,129.2463327,132.5807199,1.8,126.0147407,132.8397095,0.1711261,53.757763,69.1968281,598747.9571225,2448757.1716138,9.9367346,35388.2864166,11137.8882512,41583.0219222,67.1515253,125.2667029,2.9570952,493.6349334),(25415,'windfallLgGiraffe_radius-cleaned.tif',247,3,249,2157.4150108,129.2252032,132.4992027,1.8,126.2845276,132.7253094,0.1814488,51.3847251,67.857183,597389.1845326,2467927.5577183,11.7089806,36369.4372507,11625.8126114,43394.9933098,66.7645236,123.2239274,3.049977,410.0331259),(25416,'windfallLgGiraffe_radius-cleaned.tif',247,3,250,2021.2029263,124.8105311,132.4312088,1.8,125.8890276,132.8477675,0.2227041,36.3940167,62.4142935,570104.2475774,2099729.1219922,16.4332439,33641.7990987,15664.7795371,42492.0968699,66.0610116,121.9702828,2.9665086,445.4751645),(25417,'windfallLgGiraffe_radius-cleaned.tif',247,3,251,1748.4390969,118.9564113,133.2325717,1.8,120.3918958,133.5537157,0.3341135,40.0236412,61.2301432,479147.3464508,1610041.7617289,31.3376456,26294.9207314,11971.6080749,31338.253528,65.2031449,118.4672627,3.1013214,498.9538451),(25418,'windfallLgGiraffe_radius-cleaned.tif',247,3,252,1346.8369814,114.2566819,135.4981015,1.8,115.792075,135.7891223,0.4728069,48.5987268,61.7081336,314238.515963,1170914.8160609,46.5505805,18975.0483215,6465.9824815,21663.274738,61.6250529,113.4128561,2.7326848,420.4754878),(25419,'windfallLgGiraffe_radius-cleaned.tif',247,3,253,806.0526613,116.8093534,142.6645335,1.8,115.5573623,141.0407764,0.4342443,38.1732564,54.2235514,195287.3489276,665776.3153077,23.7798304,12278.360566,5115.8158145,15866.6070733,61.7221618,108.2015151,2.6761529,451.4072709),(25420,'windfallLgGiraffe_radius-cleaned.tif',247,3,254,525.6140562,119.130665,150.0287491,1.8,118.2005157,149.6706126,0.3493821,44.2301595,52.2462417,85560.1886908,379209.3881026,10.2653443,7258.118018,1934.4309339,8879.9170058,0.4335942,0.6131948,2.3561945,1.2263896),(25421,'windfallLgGiraffe_radius-cleaned.tif',247,3,255,365.2437533,120.7531535,155.2524034,1.8,119.2378273,154.5024607,0.3124963,48.0608859,51.7161389,18001.5121399,227153.8161393,5.7535788,4392.3197114,374.5563945,4712.4041677,23.4743456,93.6573473,2.8066657,228.2435714),(25422,'windfallLgGiraffe_radius-cleaned.tif',247,3,256,226.3478275,124.5585036,158.3924597,1.8,121.6239388,157.6897308,0.2803173,11.3464572,52.4536206,4065.5115601,112853.3378718,2.8874845,2151.4880501,358.3066919,2213.381619,20.4709111,87.7532928,2.8198421,213.886098),(25423,'windfallLgGiraffe_radius-cleaned.tif',247,3,257,53.69671,139.8675904,162.4257666,1.8,133.5400972,161.1700863,0.2072604,8.3913565,58.7153339,268.0655565,9187.6010808,0.378967,156.4770304,31.9454375,159.4564312,0.4335942,0.6131948,2.3561945,1.2263896),(25424,'windfallLgGiraffe_radius-cleaned.tif',247,3,258,9.7829832,144.9329925,163.8525248,1.8,144.7167404,163.8308973,0.2541185,3.4629219,6.8353774,18.2293744,69.4262993,0.1030443,10.1569079,5.2641598,12.7299118,6.8459187,12.8916819,2.7985687,32.9276303),(25425,'windfallLgGiraffe_radius-cleaned.tif',247,3,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25426,'windfallLgGiraffe_radius-cleaned.tif',247,3,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25427,'windfallLgGiraffe_radius-cleaned.tif',247,3,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25428,'windfallLgGiraffe_radius-cleaned.tif',247,3,262,52.9293122,112.2722898,172.7753301,1.8,106.0911433,172.0044134,0.0256556,12.654957,91.7574892,1687.259106,123393.1853246,0.0058052,1344.7750843,133.3279207,1354.4434476,23.4140859,202.0590766,0.0064377,441.1075009),(25429,'windfallLgGiraffe_radius-cleaned.tif',247,3,263,52.673456,112.1720109,172.7526183,1.8,105.7208184,172.0164481,0.0199591,12.6146214,91.5872284,1648.1670728,121863.6198221,0.0034967,1330.5743824,130.6552941,1339.7989692,22.9804917,201.6287549,0.0086019,439.7759038),(25430,'windfallLgGiraffe_radius-cleaned.tif',247,3,264,53.4749223,111.8429736,172.6750638,1.8,105.4958936,171.9690249,0.0151874,12.1617488,91.1993353,1619.5144024,123846.8204793,0.0020556,1357.9794197,133.1645985,1366.8315543,22.5468975,201.6254914,0.0064515,441.6154881),(25431,'windfallLgGiraffe_radius-cleaned.tif',247,3,265,52.865106,111.5203131,172.6293774,1.8,104.517913,171.9022317,0.0107976,11.3344003,90.8248642,1522.0311366,121055.8870375,0.0010272,1332.8496341,134.2842229,1340.9252416,21.8825367,201.1993817,0.0107754,439.311495),(25432,'windfallLgGiraffe_radius-cleaned.tif',247,3,266,63.4532587,109.4441489,169.6775902,1.8,104.2265852,167.0172603,0.0185843,19.9841214,88.7640032,4199.7891197,121586.0941862,0.0036521,1369.7680342,210.1563052,1413.5280129,21.246115,200.7583212,0.0064794,444.6198328),(25433,'windfallLgGiraffe_radius-cleaned.tif',247,3,267,108.6536729,106.6396565,163.3831415,1.8,104.1034416,162.5371319,0.0401336,17.5952451,85.8069302,10779.593627,122424.1848194,0.0291525,1426.7400602,612.6424241,1551.8442518,20.3789266,199.8911511,0.0065075,431.488749),(25434,'windfallLgGiraffe_radius-cleaned.tif',247,3,268,530.3786452,123.9895517,157.325239,1.8,117.6787087,158.4802178,-0.0526554,23.5426409,103.3799932,37374.4230644,224118.23632,0.2448611,2167.9072463,1587.5204144,2529.2798216,23.3014015,23.8476801,0.6435011,77.3571753),(25435,'windfallLgGiraffe_radius-cleaned.tif',247,3,269,648.0751355,123.3749689,157.183857,1.8,116.8547027,158.2721846,-0.0401824,23.8380825,102.7494013,44335.6451162,247006.9128155,0.1743066,2403.9742304,1859.866249,2834.5673615,26.015651,26.7461194,2.7942067,85.7750654),(25436,'windfallLgGiraffe_radius-cleaned.tif',247,3,270,665.8081776,122.822334,157.2352479,1.8,116.347122,158.2555883,-0.0445211,22.8996019,102.2245912,45403.0492229,258570.2115062,0.2198077,2529.432581,1982.7003721,2972.657945,29.1371929,56.9660916,3.0654045,183.6036112),(25437,'windfallLgGiraffe_radius-cleaned.tif',247,3,271,671.5177996,122.7131123,157.309021,1.8,116.4228708,158.4527456,-0.0519662,21.9834287,102.1503575,45457.0004692,261927.4017857,0.3019663,2564.1359279,2067.7848315,3008.468239,29.2147,57.4328191,3.0584514,179.8808641),(25438,'windfallLgGiraffe_radius-cleaned.tif',247,3,272,672.6474752,122.7441937,157.3370128,1.8,116.621514,158.5800139,-0.0565989,24.0366762,102.1886868,45481.0755446,264218.6063382,0.3587471,2585.5954762,1892.1532742,3030.2697066,29.1995677,57.5113284,3.0434244,178.6544746),(25439,'windfallLgGiraffe_ulna-cleaned.tif',247,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25440,'windfallLgGiraffe_ulna-cleaned.tif',247,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25441,'windfallLgGiraffe_ulna-cleaned.tif',247,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25442,'windfallLgGiraffe_ulna-cleaned.tif',247,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25443,'windfallLgGiraffe_ulna-cleaned.tif',247,4,5,23.6461395,89.0306899,116.9412573,1.8,88.8425674,116.8238446,0.8925154,5.1439475,9.9914455,92.1407545,491.5536419,2.3894412,49.1974502,17.91246,56.6407524,9.5501696,20.189582,2.1829488,50.8041166),(25444,'windfallLgGiraffe_ulna-cleaned.tif',247,4,6,91.9912168,87.7939769,116.5799699,1.8,87.2849949,116.337734,0.8387104,7.8619773,14.7001882,1013.977202,4455.8040755,8.4817636,303.112042,128.9722875,370.3539234,14.5894448,29.7085543,2.4483695,75.9752499),(25445,'windfallLgGiraffe_ulna-cleaned.tif',247,4,7,139.8300518,86.0212388,115.927736,1.8,85.4021896,115.6541049,0.8052299,10.90647,18.4755766,2678.4689806,10913.9309988,12.1145623,590.7220789,245.5853257,731.4186006,20.1609418,37.2805002,2.4697972,99.3635882),(25446,'windfallLgGiraffe_ulna-cleaned.tif',247,4,8,210.3728885,83.9167325,115.8907575,1.8,83.295567,116.2146499,0.7605007,14.4431225,20.8827645,7343.1445757,20189.34094,16.6584753,966.7944559,508.4180759,1303.2454793,26.8015463,42.1229449,2.5582196,124.7906313),(25447,'windfallLgGiraffe_ulna-cleaned.tif',247,4,9,341.2306283,82.3594437,117.9214654,1.8,82.2689645,118.0813171,0.8614384,15.9292971,23.0511439,20040.645619,39740.4955515,32.7437774,1724.0140353,1258.0998077,2578.0463402,31.4899824,46.4873532,2.610252,138.2499285),(25448,'windfallLgGiraffe_ulna-cleaned.tif',247,4,10,445.6159653,81.7203641,119.120051,1.8,81.2901362,118.4480616,0.9554809,18.1007274,27.141761,34937.6006007,64312.7015291,49.5243873,2369.5110128,1930.1766033,3656.1673282,35.2722296,50.2930386,2.4701268,152.9802013),(25449,'windfallLgGiraffe_ulna-cleaned.tif',247,4,11,539.8953164,81.2132368,119.6911552,1.8,80.7624169,119.1207011,0.9517222,19.7467635,29.4723483,51934.7680125,89683.426321,59.6830423,3042.9684592,2630.0395058,4790.3793481,38.7085913,54.9157494,2.4468544,160.8352037),(25450,'windfallLgGiraffe_ulna-cleaned.tif',247,4,12,613.099547,81.2538374,120.1296403,1.8,80.6519172,119.6562289,0.9354249,21.3250344,30.7177294,69864.6752849,111553.376755,66.1928503,3631.5632325,3276.1811324,5846.3904934,42.1939599,57.8103162,2.425051,168.1576884),(25451,'windfallLgGiraffe_ulna-cleaned.tif',247,4,13,665.70967,81.4653892,120.4376309,1.8,80.6193742,120.0866602,0.9591498,23.0582282,30.6739616,85222.0734443,131595.3861294,74.3681655,4290.1333617,3695.9506515,6956.799306,44.812701,58.3825937,2.4414574,178.4425782),(25452,'windfallLgGiraffe_ulna-cleaned.tif',247,4,14,706.7933158,81.6183315,120.4635831,1.8,80.7051355,120.4006152,1.0107882,37.1601099,30.6292441,99673.8565401,149154.2063244,84.5600352,4869.6665835,2682.2809916,6653.0877934,47.0589468,58.9797093,2.0077836,183.1731424),(25453,'windfallLgGiraffe_ulna-cleaned.tif',247,4,15,719.8260896,81.7795468,120.4784521,1.8,80.9190851,120.6906447,1.1310747,43.0540723,32.2732925,107957.0484212,163499.6496749,98.2310727,5066.0976074,2507.4758946,6260.9335921,48.8945098,61.1859402,1.9288945,183.1231729),(25454,'windfallLgGiraffe_ulna-cleaned.tif',247,4,16,743.0832766,81.7597101,120.4679062,1.8,81.1054775,120.7250451,1.2480156,37.5923669,48.4119602,113070.9304905,183543.9086777,111.3858383,3791.2926492,3007.8162079,5998.9082599,50.2155672,63.7956802,1.8384984,189.0394095),(25455,'windfallLgGiraffe_ulna-cleaned.tif',247,4,17,778.135743,82.0733285,120.4719444,1.8,81.4859684,120.4469597,1.3392416,26.2083179,50.7742573,119222.1536528,213089.6613329,122.8590565,4196.805091,4549.019674,6541.2466861,50.8080446,67.1787172,1.8627544,194.2025524),(25456,'windfallLgGiraffe_ulna-cleaned.tif',247,4,18,793.3163886,82.1323075,120.3834312,1.8,81.5317984,120.1772014,1.3936831,26.4837443,38.897201,118243.756833,242761.7747752,128.1149807,6241.1116628,4464.7673574,9277.7889402,50.2733747,70.3124121,1.8545904,197.0150488),(25457,'windfallLgGiraffe_ulna-cleaned.tif',247,4,19,799.1126609,81.8479211,120.0212491,1.8,81.4207699,119.8306602,1.4396249,26.4808183,40.3343424,115423.2926818,273164.3068937,130.906974,6772.4993365,4358.7509846,9518.2375074,49.3602258,73.4192565,1.8273889,205.005324),(25458,'windfallLgGiraffe_ulna-cleaned.tif',247,4,20,809.240557,81.3571565,119.4612597,1.8,81.0443829,119.3023266,1.481402,26.2717424,41.7594351,112391.7499108,304218.1243422,133.7984754,7285.0153156,4278.0470502,9832.086059,48.2325401,75.9146152,1.8427347,213.1162361),(25459,'windfallLgGiraffe_ulna-cleaned.tif',247,4,21,820.5595053,80.8205174,118.495582,1.8,80.545986,118.3626414,1.5174266,25.5921978,42.6883143,109249.2520661,333215.6482975,136.37075,7805.781368,4268.8499391,10192.3555458,0.9954941,3.9305833,1.7506498,8.8993395),(25460,'windfallLgGiraffe_ulna-cleaned.tif',247,4,22,840.0770929,80.150573,117.5499053,1.8,80.0515477,117.3851191,1.5544824,25.3052969,43.4963556,109685.06177,364711.7112492,139.9755882,8384.8797498,4334.4704569,10750.1346973,2.1093724,13.7514254,1.6475682,38.4244903),(25461,'windfallLgGiraffe_ulna-cleaned.tif',247,4,23,851.2272767,79.7828473,116.3431468,1.8,79.7421903,116.3084807,-1.5680378,24.9991043,48.8974145,108181.1514388,391668.1063646,141.8701329,8009.9962342,4327.4010919,9490.2328079,2.1687044,22.5246775,1.5239556,60.4065803),(25462,'windfallLgGiraffe_ulna-cleaned.tif',247,4,24,862.2714677,79.5377905,115.1481471,1.8,79.5853074,114.9794932,-1.5600814,42.3982853,60.4394705,106801.0898644,419568.3256516,143.6954125,6941.9589946,2518.9955005,8264.0482264,2.8520541,27.0725614,1.5837826,81.4442721),(25463,'windfallLgGiraffe_ulna-cleaned.tif',247,4,25,878.3245129,79.3999234,113.7570145,1.8,79.3960067,113.4370292,-1.5542579,40.9760632,64.6117746,106180.3528049,453029.1588055,146.3473828,7011.5572865,2591.277556,8639.1366617,44.2429324,85.1811004,1.4674316,382.3535955),(25464,'windfallLgGiraffe_ulna-cleaned.tif',247,4,26,872.7774548,79.2511387,112.2807061,1.8,79.2320843,112.1732134,-1.5575044,33.610643,48.6557048,103165.3691514,473417.5338688,145.4372108,9729.9491638,3069.4256347,10898.3243062,43.4394249,87.5297753,1.4823183,385.407366),(25465,'windfallLgGiraffe_ulna-cleaned.tif',247,4,27,883.5048658,79.2342206,110.4204677,1.8,79.1494433,110.6524953,1.5656963,28.1802599,46.111583,101261.6459021,507907.4889615,147.2469811,11014.7484761,3593.3538655,13128.4677042,4.0522104,53.1603222,1.5178657,143.1571617),(25466,'windfallLgGiraffe_ulna-cleaned.tif',247,4,28,902.4315152,79.2256052,108.1431485,1.8,79.0954517,108.6778122,1.5415663,22.3211412,46.0753478,100161.6232789,548269.2044779,150.2767836,11899.4045828,4487.2985009,13966.1659675,0.3515621,0.4971838,2.3561945,0.9943677),(25467,'windfallLgGiraffe_ulna-cleaned.tif',247,4,29,928.7557528,79.1072091,105.0836551,1.8,78.9743343,106.0381737,1.5135969,21.9035599,46.0977601,101060.8286055,595722.4729969,154.2867315,12923.0242911,4613.8997108,14631.0956408,41.1327611,92.6110828,1.5138238,349.6979443),(25468,'windfallLgGiraffe_ulna-cleaned.tif',247,4,30,960.1085075,79.3320805,102.349257,1.8,79.293596,103.9296056,1.5027174,28.0161873,47.1391771,102713.313332,622496.8814618,159.277588,13205.5101422,3666.2131187,14804.0135645,40.2968519,92.6717858,1.460558,325.6625137),(25469,'windfallLgGiraffe_ulna-cleaned.tif',247,4,31,947.6701925,79.8204152,102.5906698,1.8,79.665042,103.6251874,1.5029672,33.05542,45.257128,101689.8661364,559954.0891514,157.2194751,12372.7269847,3076.3447017,14062.0124989,39.6878937,88.6117735,1.479418,332.6730569),(25470,'windfallLgGiraffe_ulna-cleaned.tif',247,4,32,900.6876148,80.0219052,105.2606452,1.8,79.8011504,105.3863384,1.4901283,38.7881332,43.0176562,99043.058495,461895.8077282,149.1398733,10737.3541127,2553.437104,11574.3791612,0.3515621,0.4971838,2.3561945,0.9943677),(25471,'windfallLgGiraffe_ulna-cleaned.tif',247,4,33,864.493085,80.2725931,107.3740471,1.8,79.8660595,107.0263403,1.4739679,31.5483843,40.6019269,96506.411594,388170.601047,142.7355197,9560.3985027,3058.9969572,10628.0634767,41.6225366,75.8307222,1.4452912,340.6986658),(25472,'windfallLgGiraffe_ulna-cleaned.tif',247,4,34,838.3743162,80.357992,108.8578235,1.8,79.8481784,108.1000633,1.4576897,21.5922908,41.2354604,94988.3807934,341320.2987703,137.9490919,8277.3490497,4399.1803315,10544.7173879,41.0564498,71.1659221,1.451956,319.4903674),(25473,'windfallLgGiraffe_ulna-cleaned.tif',247,4,35,811.2831849,80.5666124,110.1989764,1.8,79.9846761,108.7582248,1.4502733,21.7673996,35.0842188,94561.7858011,302523.2435951,133.2592677,8622.7726753,4344.1930298,11212.6072867,42.5792722,68.0560952,1.6483606,317.6076334),(25474,'windfallLgGiraffe_ulna-cleaned.tif',247,4,36,788.9551768,80.7716817,111.4798676,1.8,80.1131559,109.3686333,1.4489723,22.5949469,33.7584329,94085.0390255,270457.4786596,129.5506724,8011.5531352,4163.9858499,10285.4412512,0.3515621,0.4971838,2.3561945,0.9943677),(25475,'windfallLgGiraffe_ulna-cleaned.tif',247,4,37,769.3496488,80.9603324,112.5011582,1.8,80.1388983,109.7272363,1.446485,23.4028047,32.6471061,96162.1318738,244646.7569247,126.2536298,7493.6735902,4109.0003067,9540.989508,45.5754901,65.0228263,1.9472867,253.0322779),(25476,'windfallLgGiraffe_ulna-cleaned.tif',247,4,38,730.0463455,81.2120184,113.3948922,1.8,80.1867476,110.0145451,1.4321296,31.2798075,32.1833258,99070.2127948,221103.4659684,119.3497377,6870.1248397,3167.2257791,8543.028602,46.7722432,64.3320148,2.0051125,310.1791474),(25477,'windfallLgGiraffe_ulna-cleaned.tif',247,4,39,708.5453436,81.3999501,114.0552577,1.8,80.2715384,110.3358117,1.4091412,25.9141465,39.9402977,103755.7506634,205428.4145124,115.0316816,5143.387163,4003.8266586,7189.7653361,48.0608759,64.1848732,2.0001437,242.5353856),(25478,'windfallLgGiraffe_ulna-cleaned.tif',247,4,40,708.400287,81.4458133,114.0760823,1.8,80.2893295,110.1431091,1.3780287,27.4577072,37.408947,110981.5439403,200815.4540511,113.7335051,5368.1129777,4041.9086425,7175.5481795,49.5671803,63.7191081,2.0714641,249.0341092),(25479,'windfallLgGiraffe_ulna-cleaned.tif',247,4,41,731.6207323,81.5799379,113.6701951,1.8,80.4679213,109.9051227,1.3410405,29.2643833,32.6045766,122390.2850035,203572.1508509,115.6124879,6243.6679864,4182.2266997,8471.8773557,0.3515621,0.4971838,2.3561945,0.9943677),(25480,'windfallLgGiraffe_ulna-cleaned.tif',247,4,42,766.6517754,81.7883861,113.1605163,1.8,80.7272941,109.5877913,1.3501049,31.1796664,32.1805315,133345.5071045,205859.8067217,121.6524163,6397.0294213,4276.6816452,8995.5400721,54.1938334,64.4059392,2.0906195,275.3348829),(25481,'windfallLgGiraffe_ulna-cleaned.tif',247,4,43,810.813146,81.7872335,112.3970585,1.8,81.0574955,109.3110816,1.3221114,33.3117202,33.9835398,147576.589521,213639.0339675,126.9490498,6286.5444555,4430.1701808,9716.1069477,56.4729987,64.7580751,2.1000431,296.6284845),(25482,'windfallLgGiraffe_ulna-cleaned.tif',247,4,44,858.2427663,81.7076861,111.4083462,1.8,81.5444407,108.8968503,1.2618445,36.0359782,34.0527994,168020.5283598,228173.8206167,129.815994,6700.5892205,4662.5771469,10680.1692771,58.625286,65.7261233,2.1736346,292.1891638),(25483,'windfallLgGiraffe_ulna-cleaned.tif',247,4,45,847.7636332,81.6087824,111.3476222,1.8,81.7053456,108.8909914,1.2018572,37.7396193,32.6108409,176330.0170808,230407.4144533,122.9184879,7065.3625736,4672.2786328,10712.8921824,59.3937885,65.2391585,2.1019739,282.8925794),(25484,'windfallLgGiraffe_ulna-cleaned.tif',247,4,46,784.6763622,82.6199374,112.8830182,1.8,82.2951221,109.6811192,1.5030447,34.2555454,32.5058496,161962.2180014,198655.8748126,130.179997,6111.3884844,4728.0583667,9458.8504949,56.8684841,65.1529016,1.9523047,413.7846894),(25485,'windfallLgGiraffe_ulna-cleaned.tif',247,4,47,719.7754528,83.3911406,114.9185947,1.8,83.3306553,111.6166334,-1.2380602,34.8057466,41.9873746,135999.9952693,164099.8434666,107.164089,3908.3139834,3907.4006015,7138.0038197,51.2056669,63.7103789,0.1161416,300.4000149),(25486,'windfallLgGiraffe_ulna-cleaned.tif',247,4,48,655.8187784,83.7348381,117.252775,1.8,83.9111958,114.4078693,-0.7761213,35.3946215,45.9482146,101553.9758377,132159.4912826,53.6376338,2876.2704344,2869.1923097,4872.1879917,49.3249436,62.8303468,0.0896467,324.7120533),(25487,'windfallLgGiraffe_ulna-cleaned.tif',247,4,49,612.2604433,83.7363546,118.7034175,1.8,83.8404428,116.8003149,-0.6836144,34.79842,45.0112434,82650.2076285,107797.3071463,40.7069249,2394.8973409,2375.1138015,4063.7413297,47.8359532,61.623725,0.0570808,337.6534687),(25488,'windfallLgGiraffe_ulna-cleaned.tif',247,4,50,565.8606015,83.6708895,119.6591597,1.8,83.6362389,117.84912,-0.7294125,34.950145,34.6717819,70036.7201372,90938.9108681,41.88606,2622.8507987,2003.9035666,4440.3234339,46.275917,59.4649325,0.0413965,315.9626222),(25489,'windfallLgGiraffe_ulna-cleaned.tif',247,4,51,526.3051251,83.5199809,120.5033853,1.8,83.4396389,118.7100655,-0.8104452,34.7995004,32.4694862,59082.8287782,77055.2838288,46.0549021,2373.1599344,1697.8068081,3854.4090566,44.5243823,56.9704123,3.1169063,348.3002695),(25490,'windfallLgGiraffe_ulna-cleaned.tif',247,4,52,488.6217143,83.266076,121.4952407,1.8,83.2123494,119.4930674,-0.9523411,32.6867249,30.3430651,47235.9915166,63311.2643015,54.0626043,2086.5151249,1445.1123997,3379.9058771,43.0111075,53.5113951,0.0525831,306.1395826),(25491,'windfallLgGiraffe_ulna-cleaned.tif',247,4,53,438.1330586,82.6127001,123.0427211,1.8,83.0063299,121.0076703,-1.2106236,27.6561274,26.5569485,34408.7809494,46542.5087678,63.9520131,1752.554846,1244.1648246,2651.6893046,40.4626031,48.4339741,0.8779168,276.0319447),(25492,'windfallLgGiraffe_ulna-cleaned.tif',247,4,54,383.2845018,81.4913699,124.8151115,1.8,81.3936664,123.3424546,1.3901688,23.694451,19.190572,20799.8055478,33369.0604916,61.8191249,1738.8257359,877.8344592,2106.9201587,35.0926121,41.5379166,2.1634937,219.4882604),(25493,'windfallLgGiraffe_ulna-cleaned.tif',247,4,55,351.7214093,81.0921455,125.923986,1.8,81.0847097,124.5487345,1.3156783,23.1591609,18.4015384,13613.5695452,27732.1058713,54.8869827,1507.0536663,587.8265447,1665.9052803,32.9780812,38.8949046,0.8621701,245.2333073),(25494,'windfallLgGiraffe_ulna-cleaned.tif',247,4,56,319.4477904,80.7801217,127.0826875,1.8,80.4976284,126.1814896,1.2344678,13.9313597,18.0487545,8257.8720446,22905.8680029,47.4424949,1269.1107271,592.7542047,1561.8316526,2.6416689,23.5021275,1.9540805,55.896592),(25495,'windfallLgGiraffe_ulna-cleaned.tif',247,4,57,295.5151706,80.9201936,127.8594532,1.8,80.4352368,127.2090766,1.2268887,10.7141444,16.9746096,6198.335331,19068.5027183,43.653374,1123.3544171,578.5189295,1374.5048538,19.9410846,33.5829187,2.1094205,129.2360143),(25496,'windfallLgGiraffe_ulna-cleaned.tif',247,4,58,274.7086277,81.086177,128.5184404,1.8,80.5951562,128.0822082,1.231999,9.9729176,16.1529217,5033.0427888,16096.3915094,40.7274517,996.5003116,504.6710491,1209.5685033,18.344008,31.8992931,2.1282274,119.4276104),(25497,'windfallLgGiraffe_ulna-cleaned.tif',247,4,59,252.4670618,81.2834568,129.2369134,1.8,80.8014799,128.8743203,1.2357194,9.5291657,15.4150272,4184.4213734,13277.9857374,37.5276736,861.3663534,439.1172849,1063.7501833,18.1262216,30.0888657,2.0971887,119.8894604),(25498,'windfallLgGiraffe_ulna-cleaned.tif',247,4,60,232.6467392,81.5575369,130.0094848,1.8,81.167086,129.7451503,1.2460856,9.9369947,14.8412896,3567.6491247,10639.9764113,34.8278713,716.9172435,359.0269738,925.5956598,17.9005926,28.3438395,1.9789454,115.7060495),(25499,'windfallLgGiraffe_ulna-cleaned.tif',247,4,61,213.3405755,81.8778028,130.7750209,1.8,81.5816105,130.507175,1.2643755,9.3904466,14.0478792,3128.5822853,8238.5880286,32.3213956,586.464896,333.1665054,783.4433827,2.2941124,15.3161674,1.7321714,37.9626402),(25500,'windfallLgGiraffe_ulna-cleaned.tif',247,4,62,196.9723608,82.1742448,131.3980015,1.8,82.0348049,131.1843969,1.2977294,9.1917279,12.9602874,2810.0487186,6459.3308105,30.4410753,498.3941036,305.7149579,682.6594758,1.4062482,9.8500136,1.6064954,21.7261802),(25501,'windfallLgGiraffe_ulna-cleaned.tif',247,4,63,185.1244221,82.3888204,131.8599792,1.8,82.3232462,131.6743411,1.3276943,8.7498359,11.9851584,2606.2136378,5260.7758333,29.0662766,438.9408674,297.8585742,637.3706095,0.3515621,2.4859192,1.7126934,5.2131124),(25502,'windfallLgGiraffe_ulna-cleaned.tif',247,4,64,176.4724107,82.544538,132.1665073,1.8,82.5027438,131.9949081,1.3521436,8.417261,11.0944046,2478.9269895,4453.6070113,28.0281731,401.4282116,294.5051811,614.3912309,15.8202927,21.6859939,1.9181823,60.1506705),(25503,'windfallLgGiraffe_ulna-cleaned.tif',247,4,65,167.7271031,82.7835801,132.3560549,1.8,82.8123965,132.2394795,1.3769714,8.3453604,10.4839157,2355.0212388,3803.5859786,26.9174051,362.8020393,282.1952696,582.5870259,15.4687307,20.3815054,1.8325098,57.7500546),(25504,'windfallLgGiraffe_ulna-cleaned.tif',247,4,66,161.4172337,82.8616281,132.4850929,1.8,82.9120404,132.4254958,1.3900032,10.2011616,15.3446095,2268.9272911,3396.8770506,26.03306,221.3726621,222.4185224,307.4881754,15.8202927,19.5678319,1.8811837,56.6350499),(25505,'windfallLgGiraffe_ulna-cleaned.tif',247,4,67,156.0472548,82.9229897,132.5576588,1.8,82.9734941,132.4873163,1.396548,8.3773987,10.130219,2198.4851307,3075.2229191,25.2261717,303.5692449,262.4305233,500.4394677,0.3515621,0.4971838,2.3561945,0.9943677),(25506,'windfallLgGiraffe_ulna-cleaned.tif',247,4,68,151.7027097,82.9678982,132.5704495,1.8,83.0368329,132.467702,1.3910545,8.3391433,9.9056461,2131.186257,2815.4835275,24.4756972,284.230176,255.5641731,499.0310923,15.7746983,18.4561711,1.8804993,54.7316178),(25507,'windfallLgGiraffe_ulna-cleaned.tif',247,4,69,148.3180177,83.0136242,132.5662741,1.8,83.1148444,132.5506088,1.3682022,11.0156684,10.0496123,2082.7412377,2634.2774431,23.7188719,262.1272712,189.0708001,415.6014654,15.7746983,18.0772651,1.8063413,54.4403743),(25508,'windfallLgGiraffe_ulna-cleaned.tif',247,4,70,145.1085697,83.0320076,132.5190827,1.8,83.0752609,132.5724569,1.3528506,8.7577901,9.9574176,2032.6611705,2471.0088698,23.0540513,248.1576012,232.0974979,450.159367,15.7207821,17.6797621,1.8736812,53.2400663),(25509,'windfallLgGiraffe_ulna-cleaned.tif',247,4,71,143.2057175,83.0435872,132.4321935,1.8,83.0477159,132.4861838,1.3132454,8.4359583,9.4714099,1979.0764437,2343.0504577,22.3191194,247.3813816,234.6000737,449.3129935,15.6547694,17.3943301,1.815775,52.8281858),(25510,'windfallLgGiraffe_ulna-cleaned.tif',247,4,72,141.027621,83.0602957,132.3291046,1.8,83.076582,132.3424098,1.243747,8.4066554,9.2888784,1920.4560236,2228.1081634,21.0788897,239.8683757,228.4447175,427.1547979,15.4687307,17.143833,1.8406455,52.0397584),(25511,'windfallLgGiraffe_ulna-cleaned.tif',247,4,73,137.6873861,83.1662559,132.1449573,1.8,83.2133175,132.1273337,1.1396276,8.2219756,9.3000565,1842.8834507,2119.8168775,18.9396365,227.9359149,224.1411978,400.2179186,15.4090618,16.9042504,1.8662372,51.7485148),(25512,'windfallLgGiraffe_ulna-cleaned.tif',247,4,74,134.3972262,83.172565,132.0084161,1.8,83.2180977,131.9483914,1.0340174,8.3499737,9.1714665,1762.4741744,2023.052305,16.5420612,220.5811159,211.0754174,408.507544,15.1641069,16.6760528,1.8925469,50.8394504),(25513,'windfallLgGiraffe_ulna-cleaned.tif',247,4,75,131.2687148,83.1846552,131.8652082,1.8,83.2076256,131.8238007,0.946208,8.5806978,9.0636447,1679.1778624,1946.6441987,14.396935,214.7749904,195.692461,386.172386,14.915515,16.4597137,1.9195673,50.6335101),(25514,'windfallLgGiraffe_ulna-cleaned.tif',247,4,76,128.7136883,83.1938774,131.7201587,1.8,83.2170709,131.7557117,0.8906745,8.2874397,8.5625551,1596.7564182,1885.0522173,12.9679081,220.1506681,192.6718599,372.9686457,14.6242596,16.2557066,1.9472867,50.2216296),(25515,'windfallLgGiraffe_ulna-cleaned.tif',247,4,77,126.5994122,83.1905485,131.5581159,1.8,83.1863589,131.6526477,0.8419799,9.1729678,8.4043837,1528.1491545,1846.8014231,11.7412744,219.742636,166.5926644,354.4715681,14.3397387,16.1297654,1.8580778,49.4332022),(25516,'windfallLgGiraffe_ulna-cleaned.tif',247,4,78,125.0278343,83.1818103,131.3717074,1.8,83.1794878,131.5282456,0.8222136,9.6362374,8.9720907,1475.6376242,1820.2701137,11.1854516,202.8813779,153.1342126,336.988985,14.153661,16.0645013,1.9756881,48.9360183),(25517,'windfallLgGiraffe_ulna-cleaned.tif',247,4,79,123.5201893,83.1715191,131.1660308,1.8,83.1711986,131.1157271,0.745207,7.7955245,8.8154864,1403.2959246,1779.0071736,9.4668365,201.8047663,180.013023,356.01754,13.9211474,15.8982257,2.1833339,48.4388345),(25518,'windfallLgGiraffe_ulna-cleaned.tif',247,4,80,122.4571898,83.1616558,130.9870863,1.8,83.1688771,130.9190347,0.7211423,7.6379167,8.0193035,1360.9582327,1744.4771511,8.8969395,217.5347465,178.1844834,368.7541663,13.839036,15.7576689,2.2455373,48.7300781),(25519,'windfallLgGiraffe_ulna-cleaned.tif',247,4,81,120.4565095,83.2467962,130.7133262,1.8,83.2634295,130.6387506,0.7178896,7.5776713,8.0031488,1315.0868834,1700.6678771,8.6868482,212.4998444,173.5476294,355.9206619,0.3515621,0.4971838,2.3561945,0.9943677),(25520,'windfallLgGiraffe_ulna-cleaned.tif',247,4,82,118.4987133,83.2475383,130.5148005,1.8,83.2663442,130.4665725,0.7162376,7.5930717,8.0304846,1275.0058444,1653.8733268,8.5133386,205.9493801,167.9170037,342.8882984,13.6584959,15.5722549,2.0647377,47.2385266),(25521,'windfallLgGiraffe_ulna-cleaned.tif',247,4,83,116.6991573,83.2457518,130.2957102,1.8,83.2683299,130.2304376,0.7309827,7.5236799,8.0068124,1243.1788412,1613.7171201,8.6686451,201.543017,165.2354777,336.3309118,13.4239635,15.4727252,2.7695249,47.2385266),(25522,'windfallLgGiraffe_ulna-cleaned.tif',247,4,84,115.5748842,83.2419587,130.0714039,1.8,83.2846273,130.0317601,0.7507697,7.5018733,8.6424201,1219.2197076,1578.7450975,8.9647428,182.6739594,162.522035,323.7255654,13.4239635,15.348412,2.7908647,47.3238298),(25523,'windfallLgGiraffe_ulna-cleaned.tif',247,4,85,114.5824842,83.2382494,129.8449937,1.8,83.2437584,129.8281541,0.781232,7.5653997,7.9337016,1202.8401556,1547.9732612,9.4689788,195.1136221,158.9922812,328.914993,13.1753716,15.2798109,2.739722,46.6207057),(25524,'windfallLgGiraffe_ulna-cleaned.tif',247,4,86,114.0189244,83.2333041,129.6151001,1.8,83.2453562,129.5869645,0.8066914,7.4597436,8.1088226,1195.7634813,1526.4904186,9.9060929,188.2505639,160.2955193,325.4951433,13.4239635,15.2514737,2.688254,46.7413427),(25525,'windfallLgGiraffe_ulna-cleaned.tif',247,4,87,114.5140944,83.2263131,129.3697529,1.8,83.258329,129.3255539,0.8408662,7.3521425,8.0141246,1197.1427125,1520.4177665,10.5993159,189.7172612,162.8290964,327.9447564,13.4239635,15.1457571,1.9513027,46.826646),(25526,'windfallLgGiraffe_ulna-cleaned.tif',247,4,88,114.7737207,83.2187231,129.1386434,1.8,83.2190929,129.123014,0.8636055,7.2828596,8.1077671,1202.701722,1511.0884707,11.0544089,186.375416,165.1414116,327.7343871,13.4239635,15.121256,1.8778421,46.826646),(25527,'windfallLgGiraffe_ulna-cleaned.tif',247,4,89,114.2044306,83.3222116,128.837598,1.8,83.3202083,128.8045142,0.8958348,7.310234,8.3117182,1203.1955415,1497.6049261,11.6020455,180.1799447,164.5905656,324.2170049,13.3670618,15.121256,1.8778421,46.3294621),(25528,'windfallLgGiraffe_ulna-cleaned.tif',247,4,90,113.4704208,83.320128,128.6126829,1.8,83.3141753,128.6116579,0.9310218,7.3484043,8.2067321,1201.3959948,1479.7569549,12.1710943,180.3101332,163.4907322,324.9692611,13.4239635,15.121256,1.8778421,46.5354024),(25529,'windfallLgGiraffe_ulna-cleaned.tif',247,4,91,112.9118424,83.3216405,128.3766851,1.8,83.3131554,128.3950218,0.9429725,7.4113341,8.1218709,1205.2246709,1473.1061193,12.3258132,181.3752196,162.6191253,322.5469469,13.524411,15.1457571,1.9513027,46.826646),(25530,'windfallLgGiraffe_ulna-cleaned.tif',247,4,92,113.6858897,83.3219946,128.13439,1.8,83.3258355,128.0998899,0.9379854,7.6944324,8.105611,1232.5288997,1487.9814305,12.3203246,183.5742474,160.1845124,323.713161,13.6725554,15.1457571,1.9513027,46.5354024),(25531,'windfallLgGiraffe_ulna-cleaned.tif',247,4,93,113.8209462,83.3402799,127.9595245,1.8,83.3223342,127.920227,0.8566481,7.7788911,8.4015821,1255.0171614,1473.810898,10.8321314,175.4206388,161.336255,321.9575619,13.6725554,15.1457571,1.9513027,46.7413427),(25532,'windfallLgGiraffe_ulna-cleaned.tif',247,4,94,112.9148386,83.3742006,127.8489354,1.8,83.3280449,127.8178048,0.6693526,7.625661,7.8303361,1252.9839971,1434.1751329,7.2452464,183.1562672,164.3115267,327.1214831,13.9211474,15.100808,2.7091849,46.4500992),(25533,'windfallLgGiraffe_ulna-cleaned.tif',247,4,95,112.4992943,83.4041073,127.7482426,1.8,83.375269,127.6855785,0.4475233,7.651375,7.6882968,1222.5655875,1425.7301095,3.5110805,185.4416073,159.7837762,327.842877,13.9322477,15.1457571,2.7610863,46.8619797),(25534,'windfallLgGiraffe_ulna-cleaned.tif',247,4,96,111.6246474,83.4541321,127.6684041,1.8,83.4418055,127.6150577,0.2924337,7.6668774,7.6865758,1182.0862635,1418.9856367,1.546138,184.6056919,154.180926,328.6033051,13.709307,15.1457571,2.7610863,46.1588556),(25535,'windfallLgGiraffe_ulna-cleaned.tif',247,4,97,110.072021,83.609644,127.5179511,1.8,83.5795027,127.424711,0.1802746,7.6646682,7.7499368,1145.1661028,1413.9792413,0.5897732,182.4504226,149.4084382,311.2377092,13.3593583,15.1457571,2.7610863,45.9529153),(25536,'windfallLgGiraffe_ulna-cleaned.tif',247,4,98,108.9437778,83.6544117,127.4312988,1.8,83.6478319,127.3996329,0.112019,7.4448924,7.9553618,1105.8462923,1421.0293406,0.2268912,178.6253562,148.5375789,308.0608919,13.3593583,15.3765706,2.9576492,46.2441589),(25537,'windfallLgGiraffe_ulna-cleaned.tif',247,4,99,107.80928,83.6782005,127.3424215,1.8,83.6117004,127.2347388,0.0628191,7.5544283,8.0150158,1072.8779407,1428.6876923,0.0708136,178.2513875,142.019739,299.6535978,13.0077962,15.5682859,0.113151,46.0382186),(25538,'windfallLgGiraffe_ulna-cleaned.tif',247,4,100,106.7476663,83.6929772,127.3103144,1.8,83.6640072,127.2549301,0.0356527,7.6853861,8.4298565,1026.7829117,1446.0986653,0.0226052,171.5448728,133.6019939,291.4665648,13.0077962,15.6632636,2.9838239,46.0382186),(25539,'windfallLgGiraffe_ulna-cleaned.tif',247,4,101,105.0157883,83.6760279,127.3240878,1.8,83.6448362,127.2623472,0.0273052,7.3695588,8.4210041,958.5497755,1460.3245988,0.0130463,173.414546,130.0688137,285.7057207,12.8756439,15.7890118,2.9398303,46.0382186),(25540,'windfallLgGiraffe_ulna-cleaned.tif',247,4,102,103.5521134,83.6626083,127.3426037,1.8,83.6198351,127.2372154,0.0211179,7.281572,8.1211354,907.135603,1463.565746,0.0076956,180.2168879,124.5796383,283.3227274,12.3046721,16.1335963,2.9441971,45.746975),(25541,'windfallLgGiraffe_ulna-cleaned.tif',247,4,103,102.1339069,83.6415762,127.3892281,1.8,83.5665389,127.30163,0.0245512,6.8539147,8.4509519,848.4249787,1459.330053,0.0102584,172.6823294,123.7869175,267.8678951,12.3046721,16.4145979,2.9694018,45.8322783),(25542,'windfallLgGiraffe_ulna-cleaned.tif',247,4,104,99.9677205,83.6322642,127.4696946,1.8,83.5324207,127.3996545,0.0226582,6.7925048,8.4402801,782.2398485,1438.1699884,0.0085524,170.3936331,115.1622081,257.4646166,11.9531101,16.4145979,2.9694018,45.5410348),(25543,'windfallLgGiraffe_ulna-cleaned.tif',247,4,105,96.5611558,83.7203282,127.5201965,1.8,83.5953304,127.4096806,0.021199,6.7536606,8.5268012,712.9041567,1399.2620908,0.0072313,164.1016427,105.5581846,242.1812196,11.2499859,16.6575135,3.0146199,44.8379106),(25544,'windfallLgGiraffe_ulna-cleaned.tif',247,4,106,92.8921559,83.6978592,127.6383647,1.8,83.5880347,127.5777169,0.0281629,6.6663364,8.8518443,646.3104861,1340.7268073,0.0122763,151.4629905,96.9513755,222.5128581,11.1765357,16.9334712,3.0584514,44.9232139),(25545,'windfallLgGiraffe_ulna-cleaned.tif',247,4,107,89.0011328,83.6815541,127.7806361,1.8,83.5539302,127.6934119,0.0214504,6.5223224,8.8304824,581.3842678,1277.5027869,0.0068241,144.6696485,89.137616,207.9807972,10.8096612,16.9334712,3.0584514,44.6319704),(25546,'windfallLgGiraffe_ulna-cleaned.tif',247,4,108,86.1651691,83.65635,127.9133891,1.8,83.5353684,127.8318528,0.0146816,6.3927263,8.7976818,529.8560712,1241.3444654,0.0030953,141.0990411,82.8842097,198.1805314,10.4591829,16.7056728,2.9937433,43.843543),(25547,'windfallLgGiraffe_ulna-cleaned.tif',247,4,109,83.5011909,83.6219409,128.0639869,1.8,83.5001254,128.0361451,0.0047005,6.2357222,8.7478365,482.7054378,1204.6712319,0.0003075,137.7107629,77.4097084,188.880793,10.1258629,16.7056728,2.9937433,43.5522994),(25548,'windfallLgGiraffe_ulna-cleaned.tif',247,4,110,81.4735068,83.5545955,128.2204794,1.8,83.4678786,128.1610952,0.0002194,6.076279,8.6722402,443.0519277,1184.2913128,0.0000007,136.5611757,72.9150069,184.3184024,9.7858095,16.6575135,3.0146199,42.8491753),(25549,'windfallLgGiraffe_ulna-cleaned.tif',247,4,111,79.9888581,83.4856232,128.3865745,1.8,83.3909584,128.2811302,-0.0057525,5.9171727,8.5983352,409.225267,1170.372142,0.0004411,136.1161333,69.1589192,179.6182823,9.4921756,16.6575135,3.0146199,42.5579318),(25550,'windfallLgGiraffe_ulna-cleaned.tif',247,4,112,78.6263071,83.4242335,128.5570492,1.8,83.3561593,128.4647126,-0.0138225,5.7473904,8.5325649,378.1722594,1162.4731697,0.0025036,136.2395935,65.7989505,177.1238326,9.1406136,16.4145979,2.9694018,42.1813849),(25551,'windfallLgGiraffe_ulna-cleaned.tif',247,4,113,76.3345773,83.4386477,128.7178548,1.8,83.3580922,128.6296631,-0.0226294,5.6065638,8.5447392,349.2118565,1135.0377362,0.0065139,132.834684,62.286254,171.0294708,9.0572696,16.3580282,2.9905773,41.9754447),(25552,'windfallLgGiraffe_ulna-cleaned.tif',247,4,114,73.900862,83.3859306,128.9288569,1.8,83.3006771,128.8814795,-0.0299222,5.4160709,8.4917122,318.3096367,1101.0890691,0.0110244,129.6663193,58.7713205,164.9733214,8.7556065,16.3088424,3.0118901,41.4782608),(25553,'windfallLgGiraffe_ulna-cleaned.tif',247,4,115,71.2443745,83.3380121,129.1595258,1.8,83.2296243,129.0687678,-0.0359635,5.4719135,8.4449269,289.7774052,1064.2703551,0.015351,126.0248152,52.9572346,158.5767477,8.6056611,16.2671074,3.0333221,41.2723205),(25554,'windfallLgGiraffe_ulna-cleaned.tif',247,4,116,68.996465,83.2688332,129.4105262,1.8,83.1638224,129.3364564,-0.0380338,5.2626446,8.3786925,263.9990322,1029.1952915,0.0166266,122.8348331,50.1647082,151.9764283,8.3523335,16.2328809,3.0548543,41.1870173),(25555,'windfallLgGiraffe_ulna-cleaned.tif',247,4,117,66.7330499,83.2231497,129.6745549,1.8,83.123501,129.585357,-0.0401981,5.0442384,8.3216484,241.2578944,990.2154212,0.0179625,118.9927014,47.8284087,145.7419027,8.0487014,16.0105546,2.9872739,40.3985899),(25556,'windfallLgGiraffe_ulna-cleaned.tif',247,4,118,64.6116577,83.1767169,129.9461866,1.8,83.116285,129.8995836,-0.0397105,5.0134861,8.2787338,219.8713551,950.7683952,0.0169724,114.8446628,43.855982,139.5056037,7.8757369,15.960298,3.0090411,40.1926496),(25557,'windfallLgGiraffe_ulna-cleaned.tif',247,4,119,63.037121,83.113006,130.2129012,1.8,83.0415695,130.1666407,-0.0381556,4.8047607,8.2191494,201.619248,918.4769488,0.015288,111.7484188,41.962391,134.6946458,7.6919957,15.9176493,3.0309354,39.4895255),(25558,'windfallLgGiraffe_ulna-cleaned.tif',247,4,120,61.5135958,83.0432045,130.4793232,1.8,82.939545,130.4318713,-0.0375396,4.8658394,8.4909874,185.7454552,890.0568279,0.0144409,104.8237137,38.1733635,126.2455742,7.3828033,16.1756757,3.1198569,39.2835852),(25559,'windfallLgGiraffe_ulna-cleaned.tif',247,4,121,59.3440011,83.0484975,130.7181578,1.8,82.9434328,130.6864169,-0.0364953,4.6528918,8.1626373,170.5625774,850.933962,0.0131676,104.2474307,36.657327,124.1822709,7.327773,15.6118891,0.1355277,38.7010981),(25560,'windfallLgGiraffe_ulna-cleaned.tif',247,4,122,57.3153433,82.9843928,130.9756354,1.8,82.8653321,130.9079035,-0.0363427,4.7111859,8.1020292,157.1913625,815.0366667,0.0126114,100.5966092,33.3655614,119.2734352,7.0312412,15.5682859,0.113151,38.2039143),(25561,'windfallLgGiraffe_ulna-cleaned.tif',247,4,123,55.701181,82.9409649,131.2434747,1.8,82.8479029,131.1331335,-0.0396352,4.4849364,8.0614564,148.2804236,783.7179624,0.0145763,97.2179127,33.061879,115.0721904,7.0312412,15.5682859,0.113151,38.2039143),(25562,'windfallLgGiraffe_ulna-cleaned.tif',247,4,124,54.2751467,82.8836089,131.5303566,1.8,82.7883836,131.4627982,-0.0377442,4.6232221,8.0067165,138.2487979,754.5116121,0.0128808,94.2348358,29.9031268,105.1964454,6.6796792,15.5682859,0.113151,37.7067304),(25563,'windfallLgGiraffe_ulna-cleaned.tif',247,4,125,52.8161161,82.8237929,131.814057,1.8,82.7166507,131.8013863,-0.0377079,5.5421271,7.9362477,129.8440681,719.9083472,0.0125105,90.7114264,23.4285618,106.6154539,6.6796792,15.2636247,0.1386397,37.4154869),(25564,'windfallLgGiraffe_ulna-cleaned.tif',247,4,126,51.5031158,82.7958024,132.090935,1.8,82.723236,132.083285,-0.0372325,6.8432493,7.9111877,121.7323122,690.7168999,0.011894,87.3088753,17.7886713,102.3711634,6.6796792,15.2190237,0.1157592,37.2095466),(25565,'windfallLgGiraffe_ulna-cleaned.tif',247,4,127,50.6984692,82.7653862,132.362283,1.8,82.7247945,132.3316775,-0.0385031,4.116288,7.8836236,113.7040779,672.5617484,0.0125205,85.3112458,27.6229645,99.5244036,6.3281171,15.2190237,0.1157592,36.7123628),(25566,'windfallLgGiraffe_ulna-cleaned.tif',247,4,128,50.0932988,82.7469834,132.6353803,1.8,82.7248745,132.6759839,-0.0394673,5.3065067,7.868205,109.4611478,661.9550206,0.0129981,84.130373,20.6277226,97.9325222,6.3281171,15.1824346,0.0927563,36.7123628),(25567,'windfallLgGiraffe_ulna-cleaned.tif',247,4,129,48.5933317,82.8080453,132.901698,1.8,82.7628124,132.955668,-0.0435628,5.1119975,7.9326283,103.0185749,636.2199937,0.0153597,80.2029247,20.1523133,93.1895938,5.976555,15.2190237,0.1157592,36.0092387),(25568,'windfallLgGiraffe_ulna-cleaned.tif',247,4,130,47.3786838,82.8159436,133.1602728,1.8,82.7894298,133.2042309,-0.0445778,4.7952385,7.9289866,97.6043596,613.8646968,0.0156813,77.4203226,20.3544326,89.6774407,5.976555,15.1824346,0.0927563,36.0092387),(25569,'windfallLgGiraffe_ulna-cleaned.tif',247,4,131,46.0575936,82.8227348,133.452852,1.8,82.8342255,133.560265,-0.0451038,5.1591385,7.6187845,92.2909874,592.2589046,0.0156056,77.736666,17.8888369,89.6567591,6.2121147,14.9692797,0.1651487,36.0092387),(25570,'windfallLgGiraffe_ulna-cleaned.tif',247,4,132,44.9943694,82.8498537,133.748442,1.8,82.9033319,133.8917576,-0.0480191,5.1689995,7.6331114,89.2901951,573.6231244,0.0172783,75.1493192,17.2741737,86.8223666,5.976555,14.915515,0.1418971,35.5120548),(25571,'windfallLgGiraffe_ulna-cleaned.tif',247,4,133,44.077625,82.8540046,134.0393252,1.8,82.8454008,134.2967071,-0.0496919,4.8972743,7.6405651,86.259621,555.7160911,0.0181251,72.7323289,17.6138021,83.9840733,5.976555,14.915515,0.1418971,35.3061145),(25572,'windfallLgGiraffe_ulna-cleaned.tif',247,4,134,42.9027151,82.8605354,134.3287004,1.8,82.6840767,134.5379985,-0.0520946,4.2782321,27.5162577,79.1073495,540.9256341,0.0193877,19.6584012,18.4906635,22.3451078,5.624993,14.915515,0.1418971,35.014871),(25573,'windfallLgGiraffe_ulna-cleaned.tif',247,4,135,41.9397533,82.8959132,134.6033659,1.8,82.797942,134.7352078,-0.055589,3.94915,7.6718253,71.7669752,517.9393097,0.0215777,67.5118751,18.172765,76.8659095,5.624993,14.86987,0.11849,34.8089307),(25574,'windfallLgGiraffe_ulna-cleaned.tif',247,4,136,40.7668659,82.943171,134.9031939,1.8,82.8434689,135.0191405,-0.054729,3.7250442,7.3900605,64.847836,500.2933364,0.020331,67.6981381,17.4086083,76.3635305,5.624993,14.5675712,0.14531,34.3117469),(25575,'windfallLgGiraffe_ulna-cleaned.tif',247,4,137,39.1708685,83.1170208,135.1727824,1.8,83.0799855,135.2083393,-0.0528276,3.6998068,7.5486661,59.6753826,476.7234189,0.0182024,63.1533323,16.1293242,71.0479303,5.2734309,14.803226,0.0713075,34.3117469),(25576,'windfallLgGiraffe_ulna-cleaned.tif',247,4,138,37.8182052,83.1482194,135.4716177,1.8,83.1147775,135.5412933,-0.051352,3.6041786,7.5823274,54.1612723,459.7322926,0.0166066,60.6320815,15.0273551,67.7530112,5.2734309,14.8324196,0.0949517,34.3117469),(25577,'windfallLgGiraffe_ulna-cleaned.tif',247,4,139,36.5583137,83.1773366,135.7996167,1.8,83.1162327,135.9215504,-0.0490367,3.549239,7.6120952,51.0301881,441.5288309,0.0146396,58.0035873,14.377783,64.6769636,5.2734309,14.8324196,0.0949517,34.3117469),(25578,'windfallLgGiraffe_ulna-cleaned.tif',247,4,140,35.283778,83.2400895,136.1201689,1.8,83.2335811,136.1808488,-0.0476399,3.7508074,7.3414987,46.4998582,422.8877864,0.0133363,57.6023783,12.3972931,63.6945381,5.2734309,14.5208325,0.121352,34.1058066),(25579,'windfallLgGiraffe_ulna-cleaned.tif',247,4,141,33.9363581,83.2509996,136.4586176,1.8,83.0812974,136.5618253,-0.0428572,7.8630045,34.4301668,42.3119249,411.7036923,0.0103824,11.9576444,5.3811396,12.8555817,4.5703068,14.5208325,0.121352,33.2320759),(25580,'windfallLgGiraffe_ulna-cleaned.tif',247,4,142,32.6335077,83.2541993,136.7920762,1.8,82.9985828,136.8336342,-0.0321799,7.0577035,32.4189697,39.2640425,405.4377453,0.0056303,12.5061885,5.5632887,13.4033856,4.5703068,14.4824795,0.0972532,33.0261356),(25581,'windfallLgGiraffe_ulna-cleaned.tif',247,4,143,31.5941413,83.2928277,137.1496993,1.8,83.2153003,137.3030032,-0.0453451,3.2637637,7.3778985,34.3735893,366.1188926,0.0108198,49.6237366,10.5318866,54.2289948,4.5703068,14.4824795,0.0972532,32.8201954),(25582,'windfallLgGiraffe_ulna-cleaned.tif',247,4,144,30.6587452,83.3657739,137.5031415,1.8,83.3491605,137.7296072,-0.0408033,3.5975632,7.1122106,32.211248,350.5121875,0.0085026,49.2831565,8.9536294,53.5364111,4.5703068,14.1719197,0.124355,32.5289518),(25583,'windfallLgGiraffe_ulna-cleaned.tif',247,4,145,29.1286656,83.5636958,137.8367855,1.8,83.6177499,138.0292673,-0.035346,3.6667337,7.294168,28.7433123,331.1442998,0.0060627,45.3985022,7.8389418,49.2570503,4.2187447,14.1719197,0.124355,32.031768),(25584,'windfallLgGiraffe_ulna-cleaned.tif',247,4,146,27.7252905,83.5905443,138.1726263,1.8,83.6278252,138.3405677,-0.0340557,3.3358136,7.3209867,25.3156961,311.7359547,0.0053572,42.5811396,7.5890619,45.9541444,4.2187447,14.1326199,0.0996687,31.8258277),(25585,'windfallLgGiraffe_ulna-cleaned.tif',247,4,147,26.6998941,83.6164163,138.5586132,1.8,83.6789269,138.8088675,-0.0270491,3.5487524,7.0006929,23.3555464,299.9908767,0.0032551,42.8515981,6.5813401,45.8722708,4.2187447,13.8231413,0.1275096,31.7405244),(25586,'windfallLgGiraffe_ulna-cleaned.tif',247,4,148,25.5450217,83.6825696,138.9314146,1.8,83.6623198,139.123125,-0.0247641,3.2290183,7.0644022,20.8081048,282.5621824,0.0026104,39.9980316,6.4440963,42.6601404,3.8671827,13.8231413,0.1275096,31.2433406),(25587,'windfallLgGiraffe_ulna-cleaned.tif',247,4,149,24.5646442,83.7364113,139.3258037,1.8,83.7203603,139.514879,-0.0196687,3.4963486,7.1131437,18.827065,271.5951238,0.0015836,38.1821507,5.3847792,40.5682397,3.8671827,14.1326199,0.0996687,31.5345841),(25588,'windfallLgGiraffe_ulna-cleaned.tif',247,4,150,23.4275246,83.7976607,139.7136837,1.8,83.718576,139.8270488,-0.0186658,3.7468859,7.1663291,15.7352059,258.4545434,0.0013602,36.0651233,4.1995423,38.193448,3.8671827,14.1019777,0.0748598,31.1227036),(25589,'windfallLgGiraffe_ulna-cleaned.tif',247,4,151,22.4219036,83.8589243,140.1077547,1.8,83.8335114,140.2103629,-0.0117379,3.3395194,7.223967,13.3275369,249.8155136,0.0005149,34.5814858,3.9908547,36.3613403,3.5156206,14.1019777,0.0748598,31.0374003),(25590,'windfallLgGiraffe_ulna-cleaned.tif',247,4,152,21.5061704,83.9194691,140.525246,1.8,83.8205082,140.6755303,-0.0074954,3.623781,6.9331998,12.0430119,239.1208504,0.0002014,34.4892485,3.3233277,36.0157192,3.5156206,14.1019777,0.0748598,31.2433406),(25591,'windfallLgGiraffe_ulna-cleaned.tif',247,4,153,20.2704738,84.0724435,140.8866165,1.8,83.8873951,141.0185737,-0.0068495,2.8825978,7.083209,10.5726659,224.6316939,0.0001585,31.7132665,3.6677562,33.1549568,3.5156206,14.1019777,0.0748598,31.3286439),(25592,'windfallLgGiraffe_ulna-cleaned.tif',247,4,154,19.1418936,84.1678645,141.2796068,1.8,84.0549478,141.3620929,0.0013503,2.5075699,6.8241397,8.6557157,211.5205978,0.0000058,30.995936,3.4518342,32.070141,3.1640585,13.782847,0.1022067,30.7461568),(25593,'windfallLgGiraffe_ulna-cleaned.tif',247,4,155,18.2741007,84.2667564,141.7134052,1.8,84.1649875,141.7374602,0.0066017,2.0816811,6.9208551,7.6023505,202.9542906,0.0001327,29.3250311,3.6520245,30.2725128,3.1640585,14.1019777,0.0748598,30.7461568),(25594,'windfallLgGiraffe_ulna-cleaned.tif',247,4,156,17.4851469,84.3329076,142.1664012,1.8,84.2329431,142.1902704,0.0126112,2.3204577,6.9859716,6.7031266,195.021993,0.0004635,27.9162306,2.8887088,28.7674092,3.1640585,14.1019777,0.0748598,30.7461568),(25595,'windfallLgGiraffe_ulna-cleaned.tif',247,4,157,16.8081411,84.4239372,142.6243949,1.8,84.3693362,142.6452639,0.0164056,2.2196799,6.7260151,6.047275,188.2573766,0.0007539,27.9894371,2.7243906,28.6684378,2.8124965,13.782847,0.1022067,30.1636697),(25596,'windfallLgGiraffe_ulna-cleaned.tif',247,4,158,16.5333088,84.7045699,143.0971344,1.8,84.9483551,143.0630341,0.0105129,1.4177758,7.0563145,5.4262892,200.5386273,0.0003045,28.4197407,3.8273253,29.1633403,3.141323,14.4824795,0.0972532,32.152405),(25597,'windfallLgGiraffe_ulna-cleaned.tif',247,4,159,15.5518826,84.577596,143.6146664,1.8,84.5630751,143.6138311,0.0195442,1.2553174,6.8776615,4.6151973,180.8680313,0.0009899,26.2978967,3.6765184,26.8721452,2.8124965,14.0800496,0.0499584,30.7461568),(25598,'windfallLgGiraffe_ulna-cleaned.tif',247,4,160,14.975364,84.5526086,144.1308777,1.8,84.5412587,144.1671259,0.0226428,2.0667024,6.8599466,3.958629,177.2821813,0.0012794,25.8430848,1.9154325,26.3934125,2.4609344,14.0800496,3.0916343,30.1636697),(25599,'windfallLgGiraffe_ulna-cleaned.tif',247,4,161,14.5592204,84.6934818,144.5427059,1.8,84.6529482,144.5351531,0.0244036,2.083026,6.7179967,3.8518243,173.2687447,0.0014448,25.7917282,1.8491485,26.3596086,2.4609344,13.7514254,0.0767719,29.6664858),(25600,'windfallLgGiraffe_ulna-cleaned.tif',247,4,162,14.4198192,84.7310642,145.0471776,1.8,84.7520765,145.1367746,0.0258496,3.329198,6.6873163,4.5793531,171.2022077,0.0016055,25.6010333,1.3755124,26.2246044,3.086125,13.7514254,3.0648208,30.4549132),(25601,'windfallLgGiraffe_ulna-cleaned.tif',247,4,163,13.5325506,84.8040659,145.6359959,1.8,84.7837929,145.7700029,0.0226047,2.7321984,7.1090529,3.9221555,166.1022357,0.0011523,23.3648896,1.435531,23.9153962,2.4609344,14.0800496,3.0916343,30.1636697),(25602,'windfallLgGiraffe_ulna-cleaned.tif',247,4,164,12.4658432,84.995471,146.2070102,1.8,85.0423764,146.3470233,0.0212897,2.4939327,6.9536916,3.0114442,151.737822,0.0009416,21.8211894,1.2075082,22.2344873,2.7320742,13.7514254,3.0648208,30.7461568),(25603,'windfallLgGiraffe_ulna-cleaned.tif',247,4,165,11.8082008,85.075561,146.7591784,1.8,84.996497,146.7746127,0.0154377,1.9350215,7.030382,2.3868355,146.4458245,0.000469,20.8304222,1.233493,21.1666982,2.1093724,13.7514254,0.0767719,29.3752423),(25604,'windfallLgGiraffe_ulna-cleaned.tif',247,4,166,11.2388732,85.1960816,147.3186501,1.8,85.1065719,147.3205646,0.0147364,1.0514354,7.1487363,2.0360136,139.3295686,0.0004067,19.4900976,1.9364134,19.7513495,2.4279223,13.7514254,0.0767719,29.9577294),(25605,'windfallLgGiraffe_ulna-cleaned.tif',247,4,167,10.9787226,85.226254,147.8803493,1.8,85.1214914,147.88855,0.0165893,1.8581285,6.8365274,1.9550594,132.8498698,0.0005035,19.4323612,1.0521658,19.6733653,2.1093724,13.4331675,3.0367157,29.3752423),(25606,'windfallLgGiraffe_ulna-cleaned.tif',247,4,168,10.6674483,85.1802694,148.4414503,1.8,85.1043388,148.43063,0.0194871,0.9810838,6.7890956,1.7518136,128.9824478,0.0006751,18.9984727,1.7855903,19.1965789,2.1093724,13.4331675,0.1048769,29.3752423),(25607,'windfallLgGiraffe_ulna-cleaned.tif',247,4,169,10.0495812,85.3256436,148.9360229,1.8,85.1455503,148.9312227,0.0193727,0.889373,6.9303681,1.4743797,124.991799,0.0006285,18.0353767,1.6577743,18.2465444,2.0781706,13.7289373,3.0903555,29.169302),(25608,'windfallLgGiraffe_ulna-cleaned.tif',247,4,170,9.0941101,85.7812658,149.4926707,1.8,85.583636,149.4751028,0.0222317,0.9912831,7.0391935,1.3541637,103.7596838,0.000749,14.7402801,1.3660716,14.9213597,2.1093724,13.400926,3.0628087,29.4605456),(25609,'windfallLgGiraffe_ulna-cleaned.tif',247,4,171,4.2799381,87.3581174,149.977146,1.8,87.0512003,149.9333008,0.0175826,0.8211251,5.453219,0.5199481,28.0779286,0.0002205,5.1488723,0.6332142,5.2250565,1.7578103,10.2497073,3.038511,21.8468172),(25610,'windfallLgGiraffe_ulna-cleaned.tif',247,4,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25611,'windfallLgGiraffe_ulna-cleaned.tif',247,4,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25612,'windfallLgGiraffe_ulna-cleaned.tif',247,4,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25613,'windfallLgGiraffe_ulna-cleaned.tif',247,4,175,26.0119894,83.7780346,156.251614,1.8,84.2096929,156.1257,0.0459305,4.7542782,41.9649792,66.2341036,14260.6615863,0.0091394,339.8229154,13.9314742,339.8010237,13.1704446,139.9433398,0.0175861,299.7332647),(25614,'windfallLgGiraffe_ulna-cleaned.tif',247,4,176,26.1900049,84.45436,156.3037643,1.8,84.2560739,156.1703187,0.0478905,4.2990636,42.0961472,62.6118841,14509.9254552,0.0100035,344.6853551,14.5640748,345.426523,12.8342355,139.937599,0.0150742,299.4420211),(25615,'windfallLgGiraffe_ulna-cleaned.tif',247,4,177,25.8376069,84.5977036,156.2246429,1.8,84.0382397,156.080304,0.0518693,4.3766925,42.2458777,55.8155483,14424.6703753,0.0115753,341.4456308,12.7529061,342.1612878,12.4642793,139.5812069,0.0125938,298.1564099),(25616,'windfallLgGiraffe_ulna-cleaned.tif',247,4,178,43.2758248,86.4438905,149.1080877,1.8,86.6036619,146.2840352,0.0040512,17.2865794,43.8947365,3590.2842127,15049.8005486,0.0001184,342.8611661,207.6919984,423.4893195,12.2699125,138.871019,0.0075948,296.1676746),(25617,'windfallLgGiraffe_ulna-cleaned.tif',247,4,179,91.6635004,87.8220721,143.3408647,1.8,87.5974942,142.7905306,-0.0474984,17.2893905,45.6538792,7565.9865875,16537.259472,0.0344409,362.2312002,437.6086362,522.3190848,19.6874754,20.3207737,1.0452125,66.0315733),(25618,'windfallLgGiraffe_ulna-cleaned.tif',247,4,180,137.0432268,88.2049431,141.634653,1.8,87.9202778,141.6457321,-0.0662731,19.0581808,46.2904,10519.0356027,18626.8773612,0.1001718,402.3917995,551.9433215,620.6693191,23.9062201,24.377223,0.9907936,78.7377769),(25619,'windfallLgGiraffe_ulna-cleaned.tif',247,4,181,280.6574848,99.1085215,137.9069867,1.8,100.7646404,138.3024664,-0.2620801,24.4963965,58.4389391,19304.4952817,78283.083162,3.139983,1339.5705734,788.0544919,1669.8488503,26.3507432,26.7603166,0.1716281,86.728052),(25620,'windfallLgGiraffe_ulna-cleaned.tif',247,4,182,587.5020532,106.5826314,136.8720331,1.8,100.4841812,138.3526495,-0.2097674,23.0116266,65.9102235,37298.2356529,136486.1438205,4.2457539,2070.788667,1620.8430784,2635.4388431,29.382271,57.1761409,0.1418971,181.7376227),(25621,'windfallLgGiraffe_ulna-cleaned.tif',247,4,183,602.8968942,106.2858798,136.8308677,1.8,100.1340686,138.2681224,-0.2089944,23.2484476,65.6268845,38729.415275,141806.2905859,4.3254249,2160.7957128,1665.8925303,2749.4269464,29.3900596,57.5241911,0.1410328,180.1254342),(25622,'windfallLgGiraffe_ulna-cleaned.tif',247,4,184,605.9969785,106.2072158,136.7425787,1.8,100.0461351,138.1357013,-0.2074206,23.4541141,65.564579,39184.4551134,142970.2633475,4.2833735,2180.6021731,1670.6857918,2776.4136079,29.3505805,57.5241911,0.1410328,178.719186),(25623,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25624,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25625,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,3,0.0272313,51.9484858,143.7231088,1.8,51.9434148,143.7742419,-1.4384308,0.2228565,8.7216382,0.0011894,1.0187227,0.0044595,0.1168041,0.0053369,0.1169404,0,0,0,0),(25626,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,4,0.0090621,55.4063091,141.209135,1.8,55.4063091,141.209135,0.7853982,0.0000000000000201,0.0000000000000201,0.0001118,0.0001118,0.0007552,5562985135.78274,5562985135.78274,7867249026.30388,0.384766,0.5441413,2.3561945,1.0882827),(25627,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,5,0.0369215,57.0379415,146.8899273,1.8,57.0415647,146.884434,-0.9176628,0.1804537,2.0520236,0.000925,0.054385,0.0038812,0.0265031,0.0051258,0.0269539,0,0,0,0),(25628,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,6,14.7633517,93.5755329,149.2458593,1.8,93.2119934,149.2469591,-1.229193,35.3530606,15.3491875,74.4549298,114.6172391,2.1844253,7.4673164,2.1060392,5.0552366,7.8227169,12.7902157,1.2966289,34.4742594),(25629,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,7,76.8374575,89.8171888,142.5197748,1.8,90.3411882,141.8936431,0.9189566,25.3292278,31.1417145,1159.9539355,15511.1715596,8.0932365,498.083417,45.795077,415.3043247,13.947278,19.1147801,2.4416998,54.9649108),(25630,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,8,336.1218631,87.8016609,140.259123,1.8,85.6226583,138.1732781,0.6462058,41.0336345,42.5538349,25494.269949,146046.6818215,20.3128839,3432.0451276,621.3017756,3685.0352374,23.9836305,63.6354634,2.9714738,182.555299),(25631,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,9,969.7717639,85.1458953,128.4676821,1.8,89.1405488,125.8908092,0.7301217,54.4796342,45.2206915,262880.0292793,524604.0214838,71.8982419,11600.9729988,4825.2899069,14425.1320131,63.189872,83.4685155,2.2844226,392.6750869),(25632,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,10,1827.9127819,95.3819279,118.7356367,1.8,94.9285822,121.2374815,-0.6859985,46.3559337,52.7239413,772957.674837,897328.0309444,122.2428231,17019.3655623,16674.4063386,31670.2551209,79.1058155,86.6065526,0.6941694,420.7903519),(25633,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,11,2033.5345444,95.8802,118.587314,1.8,94.2349725,121.435246,-0.7205855,45.9547647,52.0178065,838559.6400058,942355.6258034,147.5562135,18116.0200588,18247.5015535,34232.4550874,79.2714227,89.6934112,0.8491415,448.2228099),(25634,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,12,2003.7197816,94.8206531,118.6890217,1.8,93.4436048,121.7293949,-0.6466857,46.991394,53.7477578,800504.0544289,926248.463225,121.2450851,17233.2484419,17035.1204011,32089.897758,79.0884446,88.9775096,0.8006875,400.1063459),(25635,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,13,1967.0444386,94.1490539,118.9652436,1.8,92.9719492,121.9336815,-0.6024176,45.941413,55.7041648,747294.7395234,893773.0191188,105.261979,16044.9945257,16266.255019,29445.6561752,78.7023703,89.8121733,0.8672815,470.680654),(25636,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,14,1891.9804693,93.8588264,119.4291447,1.8,92.603561,122.1141241,-0.5644544,44.2039346,55.6346242,694495.6871279,852658.8340707,90.2401423,15326.0464501,15711.1735398,27745.931152,0.7695321,1.0882827,0.7853982,2.1765654),(25637,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,15,1806.1340309,93.7937788,119.8510629,1.8,92.5225627,122.1973253,-0.549409,48.0176687,55.1696792,650239.411335,804441.8740888,82.0813853,14581.2316922,13541.6697363,25572.2673761,75.8631654,87.2324937,0.7229794,434.9634281),(25638,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,16,1741.9153377,93.7140351,120.1301006,1.8,92.6909415,121.9187948,-0.5358952,56.4777337,59.3369114,617058.9027212,764110.9791061,75.693055,12877.4983676,10925.7022509,23004.1811465,74.4091005,88.3538776,0.717601,526.7432306),(25639,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,17,1698.7991891,93.8923848,120.235505,1.8,92.9640107,121.8075428,-0.4930335,54.1828566,58.2110436,580542.3502729,718245.5510829,63.4255463,12338.6475515,10714.5024644,21643.4630831,73.1183445,85.9812202,0.7727406,485.2724755),(25640,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,18,1656.4007442,93.9460795,120.4413371,1.8,92.9586187,122.137408,-0.4639486,52.8651291,53.0532086,548974.7216594,674305.3645508,55.2798485,12709.9827234,10384.4392457,22752.1247779,72.3392214,82.7738972,0.745945,476.4728541),(25641,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,19,1621.5505705,93.9573562,120.6777164,1.8,92.9204058,122.4144065,-0.4496502,47.2347094,51.9581583,522909.8821684,636566.1808304,51.0575209,12251.5154766,11070.4583293,21904.6726639,71.110251,77.6055066,0.9580395,428.4337319),(25642,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,20,1592.3939794,93.9545318,120.8604401,1.8,92.9207571,122.643693,-0.4494175,46.7661724,51.7556896,498101.2324457,603060.2380725,50.0911212,11652.0568684,10650.8873249,21092.7311166,70.0570435,80.9372526,0.8425748,527.7381534),(25643,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,21,1571.2677476,93.9125381,121.1236252,1.8,92.9622978,122.6815132,-0.439732,45.6313957,51.4611504,476646.5117753,574448.5787872,47.4569721,11162.7620878,10445.5825649,20057.7251721,68.522253,75.0806615,0.8688403,411.6040212),(25644,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,22,1556.8901202,93.9267337,121.3921586,1.8,93.0962648,122.7187582,-0.4330211,46.3626082,53.092761,456816.2309747,547299.6373991,45.6886935,10308.3664638,9853.1175964,18686.9256559,0.384766,0.860363,2.0344439,1.8578148),(25645,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,23,1519.5956355,94.0134741,121.443,1.8,93.1862579,122.7463276,-0.3915594,45.9628466,52.8834956,432584.0487281,520940.6185804,36.886063,9850.722092,9411.6026475,17666.7211345,2.0879601,9.7414979,1.4121411,33.0445732),(25646,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,24,1474.0638876,94.0925068,121.3751065,1.8,93.3590478,122.4923408,-0.3403453,43.4544339,52.9785639,409636.4824677,495932.9230429,27.3760347,9361.0110636,9426.8051684,16516.7944579,1.5390641,6.6420916,1.7454685,19.083618),(25647,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,25,1439.6067058,94.2217524,121.3345656,1.8,93.5216033,122.3894856,-0.3096993,46.7999785,51.249383,390006.4005481,470512.8926861,22.2865784,9180.8499047,8333.4739269,16394.5840105,0.384766,0.860363,2.0344439,1.8578148),(25648,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,26,1409.6383352,94.2422971,121.3778587,1.8,93.5126224,122.5835231,-0.2951975,43.7893584,50.8304921,374170.5551813,449084.7989453,19.8851927,8834.9488653,8544.7827801,15726.7889092,61.5625657,69.336932,0.9350642,332.2527446),(25649,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,27,1393.7685049,94.2551402,121.3750564,1.8,93.4427169,122.6571195,-0.2757455,35.4677743,43.6681977,363314.2658968,429332.9829668,17.2195145,9831.7083225,10243.5033796,17391.0269848,61.1777996,69.279259,0.856146,376.3895174),(25650,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,28,1371.3663504,94.3302075,121.2919214,1.8,93.6202491,122.6703356,-0.2688492,35.6809147,47.8390907,353946.3528177,411757.530792,16.126151,8607.1354001,9919.7667807,14783.5855031,0.7695321,1.586431,1.815775,4.0343801),(25651,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,29,1330.7488857,94.4129819,121.4340571,1.8,93.6759692,122.783613,-0.2721318,37.5134761,52.1859612,342669.7534463,397126.6918284,16.0234551,7609.8376337,9134.5774627,13436.5024403,60.0235015,68.5758435,0.8767764,339.0785385),(25652,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,30,1302.1891399,94.4651947,121.5437542,1.8,93.758985,122.7485249,-0.2715194,33.6427856,46.4717491,333370.4885907,384379.4660393,15.6108244,8271.2502383,9909.1226372,14202.6341836,60.8350012,67.651017,0.8578518,353.8703496),(25653,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,31,1286.9670733,94.4887888,121.6628671,1.8,93.8837558,122.7601444,-0.2683142,36.0557298,38.5407642,326137.7454464,374897.4608479,15.0749659,9727.2970167,9045.3791096,13282.9813552,1.0882827,1.632424,2.3561945,3.4902388),(25654,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,32,1279.2718788,94.4697605,121.8455982,1.8,93.8403353,122.9596084,-0.2723525,38.7082256,38.2586331,319980.2598232,366674.3925796,15.4279994,9584.0954868,8266.4667426,15593.2546235,1.5390641,3.1020829,1.6951513,9.157043),(25655,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,33,1287.6638265,94.5688832,122.080242,1.8,93.9753057,123.3070538,-0.2855857,38.5171603,37.0960805,315385.6165016,359005.9352615,17.0327565,9677.7322789,8188.1845468,15733.2587844,59.3664004,64.8385,0.8904947,361.4109865),(25656,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,34,1282.1565561,94.5763933,122.2855539,1.8,94.0477445,123.4729727,-0.2950204,32.7849021,32.7045213,308762.8459247,350614.9758421,18.065803,10720.6882179,9417.8364564,18946.9848996,56.9453732,64.3330652,0.9296876,301.8902072),(25657,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,35,1276.2720853,94.5749556,122.4871168,1.8,94.0694239,123.6492699,-0.3145396,33.2436554,32.5649885,302216.4420222,342695.4746027,20.3597608,10523.4330025,9090.9509899,19074.742511,56.5606072,63.5784398,0.9055069,301.7355235),(25658,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,36,1270.3052028,94.6122414,122.6400198,1.8,94.1576095,123.7336777,-0.3239649,32.7201681,32.3745836,296351.6283443,335265.343245,21.4538748,10355.8194652,9057.1548334,18763.648596,56.5158725,63.1074949,0.8760581,298.2839556),(25659,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,37,1260.9824116,94.6575437,122.7429792,1.8,94.2155189,123.8659163,-0.3306646,32.3684682,33.2779477,290210.6394652,328125.8486794,22.1537135,9860.1587805,8965.8441036,15947.5912074,1.7362608,11.7715771,1.3734008,31.6762108),(25660,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,38,1253.293094,94.6993004,122.8264993,1.8,94.2540906,123.9670514,-0.3374076,32.6808602,45.4746971,284621.8990052,321071.6944501,22.891148,7060.4471231,8709.1311876,12872.1723664,56.1758412,62.117971,0.7328151,315.9445223),(25661,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,39,1246.1285731,94.7459036,122.8448114,1.8,94.3337982,123.9193133,-0.3513819,32.8153911,31.8893638,279183.4879004,315025.9618907,24.6049288,9878.7157949,8507.6995358,17563.1002838,1.8049009,11.7715771,1.3734008,27.6805016),(25662,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,40,1239.8553274,94.7843965,122.8659292,1.8,94.4300934,123.897487,-0.3612227,31.6865004,31.6657492,273708.7997614,309277.2557574,25.8105807,9766.9331597,8638.0255339,17695.2191818,52.78281,61.5264833,0.8207816,272.5612635),(25663,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,41,1244.3624872,94.8897309,122.8460297,1.8,94.4667696,123.844782,-0.3875074,31.6046443,31.5937407,268744.3122968,303883.5499377,29.6147269,9618.4732432,8503.3171068,17548.9796608,1.530264,7.7049339,1.6207547,19.122289),(25664,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,42,1236.4039521,94.9014937,122.881393,1.8,94.4326294,123.9440388,-0.4052162,31.1967599,31.5494887,263040.1191245,297568.6556409,32.02439,9431.8059677,8431.6486671,17316.1456452,2.0657548,13.7335067,1.3734008,36.9309045),(25665,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,43,1229.6103959,94.9090069,122.8925151,1.8,94.4222616,123.969885,-0.4220545,31.0030984,31.6411344,257116.5455995,291100.0648392,34.3883671,9200.0514717,8293.2532141,16981.942573,2.0501638,11.7022021,1.4056476,34.6223083),(25666,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,44,1230.9515481,94.9524855,122.9165425,1.8,94.516921,123.9363552,-0.4440413,30.6622607,31.5907828,252451.235693,286033.4901587,37.8619401,9054.3337312,8233.2884004,16786.9019335,1.9691569,11.5686037,1.5042282,31.6762108),(25667,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,45,1230.7179512,95.0089801,122.9169204,1.8,94.5377704,123.9489708,-0.458536,30.4774243,31.5328534,247404.3999839,281557.698052,40.1883738,8929.0269439,8117.6282246,16563.2144068,2.5353407,17.5859546,1.3948567,51.6613918),(25668,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,46,1221.3585076,95.0312694,122.864868,1.8,94.5972116,123.922216,-0.4786777,30.671641,31.3131242,241924.7488518,277208.1325869,43.1867921,8852.7778494,7887.5710845,15870.1491758,2.3283838,19.6192952,1.3734008,56.0531935),(25669,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,47,1228.5829194,95.0225221,122.8479289,1.8,94.6413894,123.9250066,-0.5059177,31.1586406,31.0622106,237902.8874193,274239.3174883,48.0882098,8828.7121807,7635.2139553,16208.6468305,50.5564079,59.6337705,0.8264709,262.5026576),(25670,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,48,1211.2188226,95.0446681,122.7666823,1.8,94.7257361,123.8770384,-0.5223046,30.0848255,31.0336046,233375.0710221,270528.1243767,50.2413677,8717.2640082,7757.2353133,15934.4477984,1.3655347,6.5861336,1.4536876,16.0828316),(25671,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,49,1204.6492179,95.1511496,122.6507539,1.8,94.7320644,123.7097531,-0.5382475,29.8453694,31.0160713,228835.7859208,266433.9886612,52.7619651,8590.1913895,7667.3799148,15806.9735824,1.9355841,11.5686037,1.5042282,29.857067),(25672,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,50,1196.8240579,95.1792438,122.6184096,1.8,94.8147088,123.6739983,-0.5521999,29.7228927,30.9901482,223919.601287,262209.4341712,54.8872797,8461.0577684,7533.5736579,15465.7427736,1.9238302,6.2635373,1.3854484,17.2644742),(25673,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,51,1191.9306355,95.2115371,122.5882031,1.8,94.8423858,123.6692344,-0.5649672,29.6915977,30.8831576,220093.1203475,258398.7975006,56.942586,8366.9811475,7412.6398461,15375.4058462,2.3149664,19.8630225,1.4152015,53.107096),(25674,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,52,1186.9805972,95.2545028,122.547222,1.8,94.8827733,123.6047748,-0.5742765,29.3835594,30.7668587,216201.0758137,255038.8190664,58.3788996,8289.4006572,7357.892648,15179.0604973,1.8328532,11.6451333,1.4382448,31.4894911),(25675,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,53,1179.2439501,95.3123278,122.4733662,1.8,94.9702831,123.5449353,-0.5817687,29.09446,30.659068,212453.9738986,251694.8899195,59.3460502,8209.4762158,7302.2140152,15005.3004315,1.9453022,17.8034866,1.4625257,46.1266184),(25676,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,54,1175.3462418,95.375289,122.4291102,1.8,95.0194557,123.4825272,-0.5925097,29.2878234,30.5634363,209453.7508296,248836.1390597,61.0906643,8141.6283367,7151.5642511,14899.7942275,2.0077334,17.7159587,1.5273454,48.0777931),(25677,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,55,1170.5965128,95.4556553,122.355485,1.8,95.1718532,123.3765076,-0.6001362,28.6774997,30.4795039,206974.9160351,246720.237829,62.2265824,8094.6277419,7217.3278073,14817.4130145,1.4739324,8.2253584,1.3825748,20.2492426),(25678,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,56,1166.0426516,95.5222158,122.292978,1.8,95.2075021,123.3151316,-0.6070884,28.5601185,30.3963686,204701.0628672,244476.4824416,63.2472752,8042.9503264,7167.3744134,14663.6538576,1.5390641,2.581089,1.1071487,7.2058683),(25679,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,57,1171.9299487,95.6561577,122.2216697,1.8,95.2610375,123.2844481,-0.6308906,28.3117723,31.0336377,202848.5889976,242864.8721835,67.9601603,7825.8589661,7164.81423,13958.8051629,1.7121962,9.3617617,1.4056476,23.9262012),(25680,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,58,1165.3510576,95.7443437,122.184166,1.8,95.3648558,123.187223,-0.6354681,28.133463,30.6229087,199573.376189,239628.4393546,68.4268362,7825.1364594,7093.8076888,13954.4494347,2.2490935,15.050206,1.4940244,39.5969223),(25681,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,59,1159.2424558,95.8243243,122.14859,1.8,95.4150608,123.1730153,-0.6413143,28.0180763,30.1462448,196683.6424694,236727.9367378,69.149208,7852.6509162,7019.8838853,14063.2598631,1.9882699,14.8022449,1.4141944,39.5582513),(25682,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,60,1156.1908466,95.9082944,122.1010805,1.8,95.5380764,123.1008663,-0.6433955,28.0000459,30.1685153,194503.5222534,234403.749063,69.3519077,7769.8138889,6946.5429729,14123.9096256,1.9590028,14.666603,1.4920124,37.9258273),(25683,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,61,1153.2415229,95.9820082,122.0600568,1.8,95.626605,123.0665221,-0.6416455,27.8378265,30.0178961,192358.1145966,232268.2538819,68.8522816,7737.6593335,6909.954516,13917.5193305,1.9238302,13.104659,1.6295521,35.5238712),(25684,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,62,1149.2543148,96.043923,122.0187396,1.8,95.6537234,122.9982695,-0.6373187,27.7733517,30.0032122,190174.2850531,229925.4918484,67.8205148,7663.3625238,6847.3653081,13766.3165577,1.8735338,12.7902157,1.4501727,33.8914472),(25685,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,63,1146.2180036,96.1267247,121.9554168,1.8,95.7675272,122.917277,-0.6289261,27.5749107,29.9434923,188705.4461948,228110.4759079,66.1118416,7618.0317789,6843.3746982,13528.1066927,1.5107872,4.3018151,1.3909428,10.8281379),(25686,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,64,1142.3604918,96.205655,121.8937885,1.8,95.900962,122.7993238,-0.6170956,28.1638143,29.9555414,187192.199026,225854.2190496,63.754702,7539.6473838,6646.5499619,13363.2287704,1.5390641,7.4011225,1.4141944,18.5781476),(25687,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,65,1146.2835023,96.3627096,121.8497913,1.8,96.0069236,122.8152876,-0.6094348,29.2290511,29.4253323,185778.3322222,223750.3584026,62.5959495,7604.0044658,6355.9481097,13647.123303,1.9165094,11.7022021,1.4056476,31.4894911),(25688,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,66,1141.6780497,96.4210577,121.8353048,1.8,96.0641226,122.8226144,-0.6009143,29.2586373,29.3506208,183552.2115485,220674.0493737,60.8273797,7518.5479392,6273.4367843,13545.3931974,2.2140462,17.5859546,1.3948567,42.317629),(25689,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,67,1134.7103837,96.4680436,121.8295983,1.8,96.1164185,122.7874842,-0.5905955,27.0663235,29.2415383,181152.8497511,217163.3049242,58.6434152,7426.5348984,6692.9241248,13413.2898694,2.311694,19.0449471,1.4288993,48.8473251),(25690,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,68,1131.251337,96.5218866,121.8187644,1.8,96.1550509,122.7219478,-0.5771428,26.8365825,28.8012042,179280.2125117,214332.1059913,56.1315652,7441.7758649,6680.4412528,13364.0528687,2.3999741,15.1824212,1.418147,41.7348167),(25691,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,69,1125.8547863,96.5875025,121.8085331,1.8,96.2309329,122.755032,-0.5657479,26.6016079,28.7173124,177192.601207,211520.4532469,53.9184563,7365.6075481,6660.9733394,13292.5753025,2.0771807,13.7335067,1.3734008,37.5684057),(25692,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,70,1120.1019408,96.6645306,121.7604481,1.8,96.3561417,122.6207077,-0.5561599,26.5214702,28.7656601,175167.4693191,208552.7832989,52.0303713,7250.0607516,6604.7420405,13174.6001583,1.9017455,11.7715771,1.3734008,30.5879282),(25693,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,71,1118.4853354,96.7535885,121.7202702,1.8,96.4405181,122.6091216,-0.5452698,26.3866347,28.6818032,173664.4222642,206491.4314048,50.1447896,7199.3880618,6581.5297932,13025.7809445,1.3990693,6.2635373,1.3854484,16.9457236),(25694,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,72,1120.3289879,96.8344041,121.6852617,1.8,96.5598076,122.5188683,-0.5392013,26.2476241,28.5382986,172141.1635921,204455.3705708,49.2257038,7164.2452576,6558.352223,12980.1879207,1.5332075,6.9684093,1.4601391,16.5336131),(25695,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,73,1123.7287717,97.0039914,121.643365,1.8,96.629475,122.4893234,-0.5414363,26.1919098,28.387102,170811.1696059,202659.9314586,49.7443838,7139.1553703,6521.5240525,12931.9948451,2.0650693,14.747134,1.4399689,37.0629353),(25696,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,74,1118.3902277,97.0858016,121.6223897,1.8,96.7181372,122.4925437,-0.5426915,25.9693453,28.2759246,168607.8015944,199826.5562944,49.7148652,7067.0211237,6492.570367,12836.9797709,2.4049904,16.7052279,1.4321566,41.5867679),(25697,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,75,1113.6063137,97.1826248,121.6031892,1.8,96.7330225,122.5218277,-0.5477105,25.8064615,28.2648058,166897.5629384,197542.1151033,50.3282985,6988.9783357,6467.2780927,12313.6531396,0.384766,0.5441413,2.3561945,1.0882827),(25698,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,76,1111.9870165,97.2830346,121.5783679,1.8,96.8116611,122.5105619,-0.5519841,27.5377091,28.385601,165465.7425983,195705.23827,50.9608726,6894.5250855,6008.6967393,12272.6099781,2.7646039,18.9514361,1.4691075,47.7043535),(25699,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,77,1109.1501622,97.3683396,121.5457439,1.8,96.9331655,122.4141407,-0.5597758,27.2572879,28.3142166,164139.4085935,193862.8325666,52.1220992,6846.8372366,6021.8540139,12146.3663265,2.2286528,17.7368378,1.5056712,44.4008345),(25700,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,78,1108.6241542,97.4385232,121.4943498,1.8,97.0347742,122.2655828,-0.5664782,26.8839215,28.1019904,162856.9568107,192433.2497694,53.2154255,6847.673317,6057.782788,12478.3025373,2.2971049,16.3242404,1.4288993,42.317629),(25701,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,79,1105.8116151,97.5236632,121.4100538,1.8,97.1320864,122.1684251,-0.5592324,25.7034077,28.1849648,161991.5030125,191645.883054,51.8751183,6799.5785861,6302.3356537,12368.279421,2.2015461,17.0386635,1.4576453,42.5430197),(25702,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,80,1098.3897204,97.6124053,121.3123516,1.8,97.2486367,122.0973984,-0.5573637,25.878383,28.1799093,160967.4502277,190710.0540087,51.2195335,6767.5893476,6220.1510139,12254.4846979,1.7688167,6.345724,1.3258177,15.9508008),(25703,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,81,1105.4659526,97.7890998,121.2313903,1.8,97.380678,122.0625451,-0.5670609,26.2926545,28.0394368,160318.0407361,190530.1850911,53.1610839,6795.0788843,6097.4459939,12268.510506,2.3178768,17.4677,1.4382448,44.812945),(25704,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,82,1101.2553762,97.8801094,121.1892771,1.8,97.4812503,122.0075294,-0.5669864,27.8444952,27.9319388,158673.9298878,189122.603725,52.9462041,6770.8369646,5698.5744774,12019.6280592,2.2493079,17.5227032,1.4164776,41.9988784),(25705,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,83,1097.2200759,97.9602261,121.1360013,1.8,97.5274642,121.9579438,-0.5766104,26.3000531,27.8119968,157235.3078053,187978.6149584,54.3539509,6758.9039514,5978.5167493,12037.8851848,2.6547947,12.2280559,1.3487144,34.3035577),(25706,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,84,1095.6883047,98.0419237,121.0778625,1.8,97.6425029,121.9292377,-0.5806217,26.3721969,27.9420273,156299.7921789,187463.1973729,54.9488379,6709.0048634,5926.6883465,11992.7360588,2.4349828,19.3763224,1.4513674,50.4250602),(25707,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,85,1092.3719643,98.1358751,121.0063654,1.8,97.70983,121.9186043,-0.583975,25.0358783,28.2833603,155184.6832386,186851.5061784,55.3433524,6606.4111218,6198.4916833,11992.1334938,2.3373239,18.6124977,1.4464413,46.6160708),(25708,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,86,1088.8834432,98.2310575,120.9251241,1.8,97.7807802,121.7561047,-0.5788836,24.828693,28.4010308,154108.0468758,186367.0671848,54.3184375,6561.9824958,6206.8529683,11885.2551199,2.2971049,13.9368186,1.4601391,37.8324674),(25709,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,87,1090.1864178,98.3596769,120.8457937,1.8,97.9826875,121.6351489,-0.5747539,24.811708,28.2187973,153567.3292419,186539.6567876,53.6974431,6610.4750866,6189.3090623,11931.0789728,2.2568859,16.2742843,1.4523064,38.8273902),(25710,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,88,1089.7761539,98.4625778,120.758695,1.8,98.1020118,121.5349362,-0.5715566,24.7360592,28.1353044,152898.5949864,186625.0104245,53.1480423,6633.125685,6181.2026526,11971.6222683,1.614606,11.3228479,1.4000611,27.7738615),(25711,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,89,1091.4451583,98.6781478,120.6910955,1.8,98.2628168,121.5265313,-0.5757305,25.1249928,28.1538811,152143.4478502,186761.2274531,53.9216203,6633.5872702,6055.4623454,11975.6222226,1.8412169,12.4083318,1.4464413,31.5828509),(25712,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,90,1091.2877372,98.7879277,120.639028,1.8,98.3926615,121.4395619,-0.5727502,24.7016901,28.0384181,150640.6095857,185849.3724605,53.4194176,6628.3829595,6098.3928134,11843.6145568,1.6720371,16.5851569,1.5011418,41.7734877),(25713,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,91,1086.125591,98.887138,120.5969192,1.8,98.4728622,121.4534391,-0.5740333,24.6200022,27.8061897,149156.2814335,184917.2558576,53.3784195,6650.2191826,6058.337447,11718.4854834,2.3752395,13.8141188,1.3460852,33.3473058),(25714,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,92,1080.9928294,99.0158127,120.544516,1.8,98.5916607,121.4127765,-0.5742202,24.594128,27.8295169,148222.5830194,184562.2070311,53.1568771,6631.8868375,6026.7468409,11726.4128596,2.5188872,19.0449471,1.4288993,45.8465387),(25715,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,93,1073.6656385,99.128905,120.4846541,1.8,98.7236418,121.3662234,-0.575264,24.5827843,27.7530881,147079.0931146,184000.7091875,52.9670224,6629.9183894,5983.0119829,11630.679435,2.0687218,16.0729074,1.3780956,45.0383357),(25716,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,94,1070.9417469,99.2358485,120.4346447,1.8,98.8521379,121.2714664,-0.5761341,24.9218775,28.6962358,146104.1841197,183667.1446484,52.9744913,6400.3915345,5862.4870534,11117.6363635,1.814632,12.0818986,1.4108832,31.1320695),(25717,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,95,1066.8573227,99.3372082,120.3546311,1.8,98.977829,121.1649476,-0.5758717,25.697877,28.0015559,145384.2566242,183796.2106162,52.729819,6563.7856342,5657.4423134,11330.1521159,1.6847333,7.0947351,1.3521274,16.9457236),(25718,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,96,1062.2091165,99.4289475,120.2895495,1.8,99.1031928,121.034051,-0.5813176,24.5702615,27.9286697,144484.0170752,183739.7619763,53.3828892,6578.8941658,5880.4427964,11610.3920983,1.5194959,7.5594532,1.3134726,17.9406464),(25719,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,97,1066.6122411,99.6140822,120.2176777,1.8,99.2544924,121.0007633,-0.5934024,24.4291526,27.750399,144084.6022816,183895.6691059,55.5861225,6626.7756806,5898.059783,11620.9337214,1.650123,10.5653138,1.3876855,25.3719054),(25720,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,98,1063.2105281,99.7152645,120.1968702,1.8,99.3684903,121.0176936,-0.5900963,24.3875482,27.8302048,143138.0725249,183132.0007536,54.8663755,6580.3324891,5869.3096779,11540.6579608,1.5858551,10.5653138,1.3876855,26.3668282),(25721,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,99,1056.8060159,99.7936742,120.1523972,1.8,99.418462,120.9575743,-0.6009958,26.0284517,27.8709012,141583.2350142,182170.95123,56.3188861,6536.2418581,5439.55655,11147.8120665,2.0909115,13.6035336,1.4288993,35.6172311),(25722,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,100,1052.1090895,99.8839327,120.1217026,1.8,99.5055302,120.903297,-0.6020191,25.4544227,27.8491289,140306.1710235,181464.4765396,56.2360087,6515.9839247,5512.0547332,11239.8952518,2.1975621,15.6245334,1.3975507,40.0090328),(25723,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,101,1048.8411553,99.9809191,120.0968675,1.8,99.582815,120.8756801,-0.6056121,24.8370267,27.8603108,139458.1995712,180856.4467832,56.6484511,6491.5444859,5614.9313494,11317.2692817,2.0398206,13.8995898,1.4876551,38.6953594),(25724,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,102,1045.182248,100.0826715,120.0643467,1.8,99.6760997,120.8625552,-0.6078107,29.2118814,27.8761482,138522.6860702,180322.8491102,56.8096236,6468.7146854,4741.9980945,10267.9857814,1.5187859,12.0266317,1.4424731,28.7687843),(25725,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,103,1043.2368483,100.1902942,120.0257405,1.8,99.8265767,120.8114535,-0.6047984,24.2662958,27.7760895,138136.2231028,180157.7904704,56.2133807,6486.0746719,5692.5137781,11184.3100191,0.7695321,2.0720285,1.9513027,4.4851616),(25726,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,104,1040.4165032,100.2976116,119.9889099,1.8,99.9851981,120.7443573,-0.6035478,24.1374307,27.7577467,137703.1540381,180056.6044465,55.8586347,6486.7154515,5704.9632176,11211.9558123,1.5275922,3.6502111,1.8925469,8.9703232),(25727,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,105,1043.3690569,100.4997871,119.9468464,1.8,100.0889787,120.7497608,-0.6066713,24.0576585,27.8673114,137331.3816681,179928.9610286,56.5253761,6456.6315132,5708.4267668,11144.5951315,1.5390641,5.8857886,1.3734008,14.5437675),(25728,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,106,1037.6913106,100.5956381,119.9273799,1.8,100.1918797,120.7130744,-0.6031178,24.0189129,27.8175948,136051.8822238,178567.165169,55.6428353,6419.2165573,5664.3646911,11104.6776612,1.8185514,12.7902157,1.4501727,31.2641003),(25729,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,107,1032.0135194,100.6975287,119.9117941,1.8,100.2269005,120.7244158,-0.6023481,23.9739672,27.8076211,135255.1454928,177278.8895381,55.2147301,6375.1907731,5641.7506796,11027.831052,1.8089393,10.8828269,1.4288993,27.0043295),(25730,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,108,1029.6135321,100.7996509,119.8868132,1.8,100.3244363,120.6952484,-0.5985091,24.0525948,27.7697402,134759.3017037,176712.0600352,54.4721008,6363.4754461,5602.6928904,11043.9544589,1.988859,12.0818986,1.4108832,29.9504269),(25731,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,109,1026.0452013,100.8974617,119.8555505,1.8,100.4374916,120.649197,-0.5956891,24.1237397,27.7527153,134138.4997339,175834.7765644,53.8348772,6335.7683955,5560.4355391,10708.0787628,2.174137,12.461906,1.4157996,32.0336324),(25732,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,110,1022.9895546,101.0007118,119.8284651,1.8,100.5730898,120.6504521,-0.5919854,24.1920071,27.6196314,133505.1271647,175012.1222726,53.0888591,6336.5118819,5518.5634904,10983.1381567,1.7866254,13.2227467,1.4247841,32.0336324),(25733,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,111,1020.9443815,101.0955371,119.7804039,1.8,100.6476648,120.608428,-0.5844254,24.1811291,27.5888989,133109.4168639,174851.1433529,51.7950951,6337.7354844,5504.6816102,10755.7660562,1.7736009,6.4498541,1.2679115,15.3132995),(25734,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,112,1017.6718266,101.1934905,119.7304148,1.8,100.7856528,120.5211121,-0.5779622,24.1702296,27.4552567,132809.9490902,174529.9783151,50.623009,6356.8875076,5494.7739907,10785.2165506,1.3869186,7.4011225,1.4141944,17.6218958),(25735,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,113,1021.374295,101.3938989,119.6795817,1.8,101.0039687,120.4841579,-0.5767705,25.9536749,27.4362855,132638.138855,174125.1415023,50.6216271,6346.5275454,5110.5725646,10569.2788825,0.7695321,1.0882827,2.3561945,2.1765654),(25736,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,114,1016.1556224,101.4791764,119.6546575,1.8,101.1123476,120.4123432,-0.5723297,24.0796303,27.389687,131749.1599069,172733.5772794,49.6767725,6306.5188506,5471.3946253,10867.0154912,1.409976,7.470805,1.3633001,17.9406464),(25737,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,115,1011.5762347,101.5710191,119.6335585,1.8,101.1915088,120.4269557,-0.5687847,24.5226532,27.345953,130956.5578029,171701.5629013,48.9095535,6278.8655689,5340.2279431,10748.1514764,1.4517754,8.9824535,1.3986055,20.5679932),(25738,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,116,1008.3654997,101.656354,119.6017333,1.8,101.2166231,120.3850249,-0.559201,24.5138423,27.3045893,130453.6964845,170939.8894054,47.2990486,6260.4819953,5321.6339931,10723.1479517,1.7719757,4.0170753,1.2793395,11.6910299),(25739,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,117,1007.1680856,101.740854,119.5847669,1.8,101.2694824,120.3649024,-0.5526187,23.9537476,27.3073348,129950.8118589,170436.4963997,46.252321,6241.4181986,5425.0722683,10741.4649611,1.5390641,2.4637047,0.8960554,5.5734443),(25740,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,118,1004.9814624,101.8342849,119.5543537,1.8,101.3837207,120.3276377,-0.5418081,25.2831814,27.2710229,129545.2300213,170089.5787248,44.5427939,6237.0076535,5123.7709389,10662.238593,1.8224764,10.1872212,1.380808,24.921124),(25741,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,119,1005.0217486,101.9158406,119.503984,1.8,101.510471,120.2383885,-0.5319519,24.2892816,27.1771738,129603.6873741,170165.0261056,43.0934166,6261.3216197,5335.838637,10749.6066301,1.3400275,3.5473676,1.3521274,9.2890738),(25742,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,120,1004.3332949,102.003865,119.4653179,1.8,101.6620535,120.1894271,-0.5212629,24.4154885,27.1568382,129694.2611423,170240.9533816,41.5090668,6268.8061211,5311.9666691,10733.0295286,1.1542981,3.6502111,1.2490458,8.9703232),(25743,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,121,1007.3925307,102.1813637,119.3795066,1.8,101.7591648,120.1830389,-0.5200418,24.6569782,27.0613874,129968.6195808,170364.7559116,41.4585548,6295.4923042,5271.0684379,10776.6312405,1.661587,7.932155,1.3258177,18.0726772),(25744,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,122,1004.8666603,102.2539945,119.3605043,1.8,101.8309105,120.1665152,-0.5125681,23.9724899,27.0001076,129487.9419105,169522.553946,40.279877,6278.5880897,5401.5224286,10717.3520971,1.5240861,3.2874424,1.929567,8.2007911),(25745,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,123,1002.4735818,102.3279848,119.3380895,1.8,101.8898892,120.1370384,-0.5055716,23.9534231,26.9256871,129297.6591713,168903.3331187,39.1890033,6272.9442095,5397.8781585,10662.4168194,44.1417136,52.7845153,0.7957071,222.9990952),(25746,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,124,1001.3697949,102.3949999,119.3131664,1.8,101.9377568,120.1258611,-0.4940573,34.6342326,26.8928563,129071.7057076,168758.6116624,37.5292482,6275.2208208,3726.7089768,8457.7099836,1.5194959,4.0170753,1.2793395,9.2890738),(25747,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,125,999.6290111,102.4694332,119.3023395,1.8,102.0771783,120.1079118,-0.4804989,23.9939564,26.7164933,128761.452562,168547.0466649,35.5949326,6308.72641,5366.4118733,10670.8933408,2.1218471,7.5594532,1.3134726,21.617605),(25748,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,126,998.1887137,102.5271603,119.2845515,1.8,102.1167715,120.0934704,-0.4688348,23.8464606,26.68958,128549.3554004,168589.0173067,33.9660056,6316.6605511,5390.7100765,10654.1466886,1.4726922,10.8351099,1.2827409,26.2347974),(25749,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,127,998.5594092,102.585084,119.2478014,1.8,102.1870294,120.0347236,-0.4536219,23.8602614,26.4986256,128563.1567565,169310.5980638,31.9606011,6389.4105479,5388.1705098,10660.1169059,0.384766,1.216737,1.8925469,2.6273468),(25750,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,128,998.3231205,102.6495475,119.218649,1.8,102.2610195,119.9474643,-0.4398446,24.0285421,26.4703176,128533.5584352,169917.8921446,30.1667688,6419.1860029,5349.2033774,10740.2239888,0.7695321,1.586431,1.815775,3.7156295),(25751,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,129,1001.7465467,102.8208397,119.2006869,1.8,102.4144767,120.011532,-0.4317034,23.9496706,26.4205151,128567.3308669,170431.8521189,29.22997,6450.7391802,5368.2296201,10718.8067786,1.4709072,8.3059572,1.3370531,19.4797105),(25752,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,130,997.6460618,102.894744,119.2044463,1.8,102.4692811,120.0184408,-0.4238612,23.9126994,26.477321,127746.9611243,170108.4298776,28.1259259,6424.6843509,5342.222513,10399.5382688,44.7792096,53.6814122,0.8411778,218.1404941),(25753,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,131,994.2143362,102.9747719,119.2133923,1.8,102.5289337,120.0426704,-0.4126219,26.0899083,26.2683833,127198.1273907,169884.8364592,26.6467852,6467.2741562,4875.3765566,10503.0281482,1.3400275,3.6502111,1.2490458,8.2007911),(25754,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,132,991.8754061,103.0652373,119.2160825,1.8,102.6129695,120.0180547,-0.4016264,25.4060218,27.2510239,126771.5104871,169807.0915301,25.2622775,6231.2187586,4989.8213659,10675.0576778,1.4169879,6.7196499,1.3397057,15.5386903),(25755,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,133,988.3808287,103.1499682,119.2190941,1.8,102.6815013,120.0304165,-0.3881973,24.1440824,26.3564259,126241.2814229,169699.2381467,23.6021578,6438.6286245,5228.6634608,10637.2029489,1.5240861,4.3870078,1.3045443,10.2839966),(25756,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,134,985.2702707,103.2367412,119.213569,1.8,102.7851698,119.9797204,-0.3772836,24.0224616,26.0452012,125658.1205366,169566.1422797,22.2861447,6510.456223,5230.8594551,10474.2050228,1.3612553,8.3059572,1.3370531,19.3476797),(25757,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,135,984.4003499,103.3244271,119.2120201,1.8,102.9691426,119.9590664,-0.3655296,23.7395731,26.0721514,125432.6424721,170298.8544357,20.9621775,6531.8297663,5283.6941036,10676.0112675,0.7695321,1.0882827,2.3561945,2.1765654),(25758,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,136,981.4311972,103.4218119,119.2001537,1.8,103.0634047,119.9189368,-0.353788,23.6453582,25.951351,125129.584354,170756.1125674,19.633558,6579.8544498,5291.9301755,10659.9061939,45.2578003,52.5948571,0.7284649,227.2588661),(25759,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,137,984.4964445,103.6117647,119.1750459,1.8,103.1879918,119.9365666,-0.3457051,23.8807598,26.4643571,124873.3758709,171126.725411,18.8409994,6466.309565,5229.0369801,10708.6018263,0.384766,0.5441413,2.3561945,1.0882827),(25760,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,138,981.8656866,103.7144915,119.2026916,1.8,103.3273953,119.932222,-0.334824,23.8754619,26.1538042,124160.6911424,170746.7234211,17.6702907,6528.56165,5200.3471903,10749.0065764,1.5146753,5.1334192,1.3439975,12.9113434),(25761,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,139,977.0669681,103.8169131,119.2319508,1.8,103.389759,120.0228587,-0.3251222,24.2771672,26.8515603,123526.1239419,170251.723373,16.6153625,6340.4778441,5088.1605341,10686.0785204,2.1509518,12.051226,1.2793395,29.9504269),(25762,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,140,974.959347,103.9084901,119.2489354,1.8,103.4510474,120.0490477,-0.312897,24.8387908,26.6565764,123211.2001519,170381.1766733,15.3963673,6391.7126614,4960.434709,10308.8584505,1.378556,6.8180715,1.2847449,15.8574409),(25763,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,141,970.6653719,103.993692,119.260447,1.8,103.4962475,120.0744695,-0.3052086,26.5726804,26.3084837,122556.7225156,170830.6770378,14.6077915,6493.3684012,4612.1324833,10219.7427063,0.5441413,1.0882827,2.3561945,2.1765654),(25764,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,142,966.6080893,104.0792769,119.2863619,1.8,103.6163387,120.0133827,-0.2965363,25.8976714,26.3993994,121888.9603815,171037.8268118,13.7558599,6478.8529433,4706.5606214,10167.6867618,1.265477,3.172862,1.3258177,8.294151),(25765,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,143,966.1712222,104.1711705,119.3201105,1.8,103.7839058,120.0275234,-0.2899732,23.3469152,26.167559,121868.0006854,172428.2915849,13.1647216,6589.3915397,5219.8759389,10724.5629404,0.8859878,3.5473676,1.3521274,7.8820405),(25766,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,144,965.2952899,104.2566309,119.3567756,1.8,103.878755,120.0162345,-0.2840593,25.8468779,44.0905972,121867.676352,173340.7742232,12.6361381,3931.4680489,4714.9863365,6580.2251099,0.384766,1.9619295,1.7681919,4.166411),(25767,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,145,965.592905,104.4683219,119.3820725,1.8,103.977838,120.1232273,-0.2816063,26.1823173,26.6531354,121845.6631351,173787.8773442,12.4284485,6520.3539809,4653.7386906,10131.8799925,0.7695321,1.3872937,2.5535901,2.7207067),(25768,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,146,959.6654114,104.5674838,119.4225201,1.8,104.0721685,120.20468,-0.2759378,23.4043335,26.4545432,121137.536065,173113.1130624,11.8724502,6543.7952151,5175.8592424,10078.4989848,0.384766,1.586431,1.815775,3.3968789),(25769,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,147,954.2227425,104.676525,119.4660686,1.8,104.1791106,120.2355692,-0.2699308,25.4722179,26.575378,120606.4486582,172698.7480731,11.3091435,6498.4493456,4734.8232115,10647.3965242,45.3245037,51.8007128,0.6643005,219.1127639),(25770,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,148,948.2310064,104.7631385,119.5144084,1.8,104.2048824,120.3187547,-0.2642795,26.1572453,26.7958162,120075.0487436,172841.4570562,10.7833903,6450.3150607,4590.5081849,9540.4178573,1.3612553,2.4637047,0.8960554,6.661727),(25771,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,149,942.7052977,104.8811914,119.5577351,1.8,104.3553233,120.3761891,-0.2555554,25.7510957,26.6316008,119645.3033882,172983.4737136,10.0396763,6495.4215381,4646.2218393,10628.2975641,1.1456941,4.6808808,1.4056476,10.5093873),(25772,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,150,937.3579607,104.9949071,119.5872993,1.8,104.4823262,120.4250502,-0.2457736,25.3719424,26.5720384,119144.7214795,173096.8491481,9.2483117,6514.2480344,4695.9243328,10604.012475,1.3634388,4.3018151,1.3909428,10.2839966),(25773,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,151,934.2544012,105.1065278,119.6078022,1.8,104.64461,120.3640457,-0.234164,24.3478597,26.367586,118785.9659259,174218.8302853,8.3830429,6607.3105884,4878.7025887,10659.6370907,0.384766,0.860363,2.0344439,1.8578148),(25774,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,152,932.0244861,105.2160561,119.6468537,1.8,104.8088313,120.3595292,-0.2275645,23.5908379,25.6673669,118641.6987335,175156.0720824,7.9063367,6824.0763629,5029.1430674,10611.2837438,0.384766,1.216737,1.8925469,2.6273468),(25775,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,153,936.8948045,105.4519278,119.5965708,1.8,104.9647611,120.4071516,-0.2217755,23.4472614,26.1665891,118714.900154,175998.8316016,7.5550053,6726.0899337,5063.0603689,10658.6708663,0.7695321,1.586431,1.815775,3.7156295),(25776,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,154,934.0663394,105.569676,119.6743361,1.8,105.0792154,120.5238115,-0.217544,23.420465,26.7607903,118164.6811227,175924.9825939,7.2520183,6573.9830672,5045.3601664,10620.5073488,0.384766,0.860363,2.0344439,1.8578148),(25777,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,155,932.846898,105.6853756,119.7666232,1.8,105.1476068,120.6381023,-0.2174165,25.8007761,26.2725304,117837.5731187,176008.1143614,7.2341958,6699.3209827,4567.210403,10618.3543264,1.1542981,5.0608071,1.418147,12.1418114),(25778,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,156,933.3552752,105.8141232,119.8657288,1.8,105.2776867,120.7403037,-0.2122284,24.2490154,26.8114941,117872.449212,176663.6663145,6.9019648,6589.1018783,4860.9169095,10565.6250643,1.1330904,3.2874424,1.2120257,7.431259),(25779,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,157,934.1218338,105.9381668,119.96011,1.8,105.4074744,120.77657,-0.209057,24.4780377,26.684208,117810.5899524,177222.5864532,6.705719,6641.4782322,4812.9099021,10574.6031477,1.4373704,3.5473676,1.3521274,8.4261818),(25780,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,158,937.4353478,106.0660736,120.0615951,1.8,105.6321172,120.8193707,-0.206434,24.5166856,26.8551638,118053.4335298,178205.1788161,6.5640902,6635.7882016,4815.2281103,10684.1823115,44.6328601,52.7634758,0.6872688,232.0080894),(25781,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,159,943.7013259,106.17532,120.1393467,1.8,105.7596918,120.784715,-0.2025298,25.5158764,26.3750714,118315.7571308,179799.8045504,6.3637769,6817.035744,4636.9466324,10738.5629168,0.384766,3.1020829,1.6951513,6.4750072),(25782,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,160,948.5276794,106.3085876,120.2302692,1.8,105.9169556,120.8312064,-0.197441,25.3788345,26.4854525,118763.0642288,181543.6642901,6.0830682,6854.4671564,4679.610648,10874.4249613,0.7311469,1.720726,2.0344439,3.7156295),(25783,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,161,960.5262252,106.5863795,120.260031,1.8,106.0746322,120.9427297,-0.1983182,40.8113597,26.8300725,119748.8077612,183734.3004919,6.2141577,6848.0732092,2934.2028489,7386.2549951,1.9094902,5.8857886,1.7681919,17.8086155),(25784,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,162,965.1372407,106.7532004,120.3936739,1.8,106.2118288,121.108765,-0.1927723,24.4317114,27.3308263,119849.2080883,183977.8565645,5.903924,6731.514621,4905.4773928,10928.8478695,1.650123,10.5020689,1.423718,23.7781523),(25785,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,163,966.7943567,106.9253992,120.515825,1.8,106.3580226,121.2553342,-0.1882091,24.0248855,27.6272365,120079.1325772,184083.4980693,5.6406655,6663.116592,4998.1146619,10917.7364077,1.2208805,4.144057,1.1902899,9.7398553),(25786,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,164,971.8383362,107.0684595,120.6465446,1.8,106.4718692,121.3811575,-0.1852695,23.4763121,27.1013989,120562.0274958,184699.5726328,5.4963693,6815.1305797,5135.4755722,11005.6708987,1.4933474,3.6502111,1.2490458,9.6078244),(25787,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,165,975.5436758,107.2192347,120.7638118,1.8,106.6967298,121.5095809,-0.1792444,23.4389928,27.4120885,120879.9604032,185582.4038386,5.1680987,6770.0935576,5157.2165032,10508.4137411,1.8027948,8.4997595,1.4801364,23.3820598),(25788,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,166,972.3057992,107.4035044,120.8732383,1.8,106.8545026,121.6021005,-0.1795703,24.4361228,27.4354979,120786.0181966,185467.0325591,5.1694902,6760.1117754,4942.9289281,11020.2312297,0.7695321,1.216737,1.8925469,2.9460975),(25789,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,167,974.8933549,107.5680149,120.9798217,1.8,107.0273279,121.6815138,-0.1743003,23.2237038,28.0467094,121033.282641,186473.6864075,4.8865163,6648.6832361,5211.6270466,10913.3029779,0.8540685,1.9238302,0.9272952,4.0343801),(25790,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,168,974.96002,107.7362042,121.0955064,1.8,107.176767,121.830354,-0.1702642,27.6070737,27.6840803,121314.4337105,187190.9990543,4.6653218,6761.6838736,4394.3242591,9445.3927662,0.384766,0.860363,2.677945,1.632424),(25791,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,169,978.4653195,108.0572484,121.1000795,1.8,107.4269469,121.896374,-0.1680392,24.4256315,27.983376,121662.8439758,187845.6725424,4.5616668,6712.7594809,4980.9497757,11032.5788319,44.8536843,52.5948571,0.5291276,244.9194328),(25792,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,170,974.2203787,108.2175313,121.2105718,1.8,107.4901774,121.9517504,-0.1643321,24.0849485,27.4806687,121206.9821322,187473.9486344,4.3454826,6822.0300914,5032.4783694,11037.9724459,45.3186341,52.6131502,0.5981442,231.7826986),(25793,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,171,975.4508112,108.3823538,121.3619972,1.8,107.6343671,122.1029253,-0.1596959,23.9716534,27.9264323,121128.9468657,187289.8100605,4.1109944,6706.5426886,5053.0076084,11004.9372726,45.6093129,52.9315574,0.5940509,242.7975564),(25794,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,172,976.4292535,108.572083,121.4987963,1.8,107.9025695,122.2205515,-0.15482,23.6590856,27.819486,120967.2987987,187725.5767844,3.8696424,6747.9886981,5112.9321187,10998.5894039,0.384766,0.860363,2.677945,1.632424),(25795,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,173,978.1134212,108.7577675,121.6365751,1.8,108.0797121,122.3840163,-0.1493709,23.4984116,27.5273044,121134.7342796,188444.3562379,3.6102521,6845.7250215,5155.0179816,11038.7140296,45.3329255,52.9413457,0.567844,258.5456193),(25796,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,174,979.4120891,108.9679079,121.7762057,1.8,108.2563865,122.4841773,-0.1411819,24.1323321,27.8000552,121219.2262461,189328.4073805,3.2321014,6810.3608468,5023.1045116,10942.9235697,0.7695321,3.1020829,1.6951513,6.7937578),(25797,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,175,982.844712,109.1885905,121.9016795,1.8,108.4906413,122.5973577,-0.1349878,24.2784584,27.6823285,121760.0507765,190781.6134955,2.9667657,6891.8195833,5015.1475262,10928.433303,0.7695321,2.0720285,1.1902899,4.4851616),(25798,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,176,980.8444011,109.4145956,122.0195964,1.8,108.6940291,122.6500159,-0.1265444,43.2660137,28.6283692,121976.2366299,191480.754806,2.6038466,6688.4967752,2819.2159673,6800.0845284,0.7695321,1.3872937,0.9827937,2.9460975),(25799,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,177,984.5080638,109.772517,122.1386229,1.8,109.0247834,122.8467117,-0.1193075,33.0360179,28.5770224,122746.5822798,192767.2164443,2.3245674,6745.5319047,3715.5380721,8837.7911326,0.7695321,1.3872937,2.5535901,2.7207067),(25800,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,178,981.6169263,109.9896573,122.2952205,1.8,109.1727425,122.9757939,-0.1114717,44.2584468,28.3408684,122627.7612967,193163.7272101,2.0245129,6815.7307081,2770.7199474,7005.8462428,42.6138186,52.7901244,0.5354195,202.2670351),(25801,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,179,978.9742799,110.2133071,122.4481459,1.8,109.3410342,123.0920041,-0.1020435,23.6520061,28.1984736,122906.935934,193593.17132,1.6931009,6865.3776702,5196.4698223,11014.3197293,0.7695321,1.216737,1.8925469,2.9460975),(25802,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,180,977.1440412,110.434484,122.5861895,1.8,109.550578,123.1844757,-0.0939822,24.1919547,28.6569691,123200.6600403,195022.6922609,1.4342312,6805.4193608,5092.6294179,11008.385927,0.8307935,3.6502111,1.2490458,7.8820405),(25803,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,181,975.0734762,110.6470437,122.7415873,1.8,109.7244435,123.3464861,-0.0854345,23.6935251,28.8497843,123788.7942885,196700.0281903,1.1833023,6818.0762096,5224.5832545,11065.4488195,0.384766,1.586431,1.815775,3.3968789),(25804,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,182,971.480875,110.8820826,122.8735659,1.8,109.9033543,123.4318037,-0.0728181,23.1026685,28.6329391,124021.0432648,198363.8425186,0.8570263,6927.8198094,5368.2561931,11057.5542921,0.7695321,1.9619295,1.7681919,4.4851616),(25805,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,183,966.6898728,111.1270495,122.9855091,1.8,110.0759798,123.5044825,-0.0593571,23.1014929,28.5888667,124348.9511634,200501.3024725,0.5669844,7013.2651384,5382.7236025,10949.3388861,42.5917764,53.4534059,0.3992208,208.3299318),(25806,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,184,959.788513,111.3534299,123.0830577,1.8,110.2935062,123.571872,-0.0450243,22.7997875,28.9686711,124670.8061282,202464.4744087,0.3240607,6989.0839625,5468.0687681,11251.2304034,40.7851997,53.6607244,0.389827,161.6205011),(25807,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,185,956.6075664,111.7471757,123.2037958,1.8,110.6406066,123.6758617,-0.0296355,23.3997044,29.9590146,125355.0708037,205005.5625268,0.1399833,6842.8673431,5357.1219755,10865.1217708,45.5843089,53.9125733,0.3420638,300.5671506),(25808,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,186,948.4878419,111.9583714,123.3405986,1.8,110.7964941,123.8048291,-0.0131412,25.5010882,29.6737248,124920.4591977,206344.0371046,0.0272972,6953.7625693,4898.6324824,11062.8989675,42.3242639,54.131809,0.2294627,209.060793),(25809,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,187,939.8746343,112.163975,123.4709326,1.8,110.9540947,123.9305097,0.0051375,25.4579205,29.8115893,124453.5574598,208819.0611408,0.0041341,7004.6269264,4888.5987074,11040.8851403,42.2594004,54.8504193,0.1478494,213.2272039),(25810,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,188,933.347873,112.3751246,123.6123482,1.8,111.1277168,124.0581069,0.0198286,24.1259002,29.3305992,124077.727779,213089.654802,0.0611536,7265.0972116,5142.9263409,11290.7321399,42.6695846,55.5677291,0.0762408,219.1580698),(25811,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,189,930.6008325,112.5774747,123.739089,1.8,111.3544798,124.1141132,0.0322532,24.2787577,29.7701951,124126.9945971,219258.5820257,0.1612895,7365.0367853,5112.5760189,11360.2907199,42.6180306,56.666515,3.0804445,220.3397124),(25812,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,190,931.8674239,112.8035284,123.8645823,1.8,111.5540078,124.1783295,0.0445793,23.1843081,30.8849624,124469.5994761,227790.3933208,0.3084485,7375.4466682,5368.7002018,11405.4449662,42.5536158,57.6597291,3.03462,231.2612102),(25813,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,191,934.7498133,113.0454455,123.9675881,1.8,111.7812359,124.2700088,0.05281,23.4149408,31.192956,125355.3365391,238127.7002598,0.4340826,7634.0216031,5353.6473786,11645.2063959,40.4004337,58.8578857,2.9441971,169.8759812),(25814,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,192,936.666277,113.2787192,124.0589634,1.8,111.9803547,124.2977877,0.0585851,23.0198036,32.3416375,126406.6020379,248320.0217601,0.535194,7678.0287299,5491.2111413,11527.5901002,40.4004337,59.8481274,3.0579175,171.5470762),(25815,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,193,944.6015286,113.7101696,124.1449727,1.8,112.4442603,124.3767166,0.065432,23.0965923,31.8860962,127991.9154113,260743.0560116,0.6730666,8177.3276429,5541.593055,11965.0811648,41.0132983,61.6058366,3.1041102,174.998644),(25816,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,194,945.1943363,113.9612473,124.2378711,1.8,112.6712098,124.4770646,0.0673202,22.9141635,32.340565,128679.4013659,270461.4936043,0.712862,8362.9180034,5615.7145482,12153.1629102,40.7851997,62.4282151,0.0554985,176.5763791),(25817,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,195,946.9412661,114.1496205,124.3499158,1.8,112.8821832,124.6033884,0.0683187,23.3474194,32.9444325,130455.5296195,281342.2419454,0.7354883,8539.9025256,5587.5781054,12332.9962519,43.4203968,63.7737371,2.9962826,267.7253152),(25818,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,196,949.8037816,114.3229392,124.4744729,1.8,113.1779346,124.7393415,0.0670362,24.2236443,33.5860061,132698.1846709,293038.9211335,0.7103143,8725.0303084,5478.043801,12483.8573244,41.1699658,65.1176019,0.0532042,181.6990419),(25819,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,197,951.1842779,114.4837043,124.54781,1.8,113.4424117,124.8396136,0.0692118,24.643356,34.2287896,134984.1709773,304172.2252611,0.7581935,8886.4441056,5477.5076528,12724.4775075,41.5319642,66.5823144,3.1184754,186.0521727),(25820,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,198,956.7590657,114.6882773,124.6502366,1.8,113.6545195,124.9491993,0.0679924,23.5657525,34.7245233,137957.3674676,317565.5696988,0.7360436,9145.2823505,5854.1464914,12921.2280459,44.2478649,67.7887436,0.0454233,274.573762),(25821,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,199,966.6172411,114.8948105,124.7880259,1.8,113.9207733,125.0625439,0.0709696,24.4834338,35.1410085,141679.592404,333328.4826917,0.8100614,9485.4558054,5786.7533461,13282.958348,42.299353,68.4948388,3.0346575,190.801396),(25822,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,200,979.4038344,115.1505267,124.9872098,1.8,114.1938968,125.2367596,0.0734785,24.215934,36.0298451,146500.9867317,350049.4565347,0.8797307,9715.5415329,6049.7764245,13638.0742187,44.2480941,70.0791947,3.1031501,251.6585016),(25823,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,201,1000.2708082,115.6078803,125.238695,1.8,114.7238677,125.4953084,0.0762751,24.5774582,36.6385048,152454.4349035,372162.5079269,0.9680311,10157.6882098,6203.0187821,14141.8845424,45.4023922,71.5551042,2.9958933,244.1499007),(25824,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,202,1011.5141007,115.8165807,125.5101938,1.8,114.9383891,125.7594563,0.0736078,24.206564,37.4994043,156836.4975743,388791.6601129,0.9117667,10367.9423063,6479.0896275,14423.7880441,45.5843089,73.0498357,3.0466409,243.6057594),(25825,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,203,1031.4842365,116.0219925,125.8019772,1.8,115.1810422,126.0647689,0.0669349,24.9512917,38.1351799,163528.2751377,409291.6493287,0.7690715,10732.652914,6553.9001857,14895.0844435,46.1719242,74.403246,3.0223691,237.7135645),(25826,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,204,1056.6926046,116.1113275,126.0767907,1.8,115.297747,126.3267158,0.063744,25.108002,39.2829509,171303.371296,438236.0147366,0.7146401,11155.8832572,6822.6604043,15375.5961378,46.5566903,76.4320079,3.0609598,232.1561382),(25827,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,205,1083.8705979,116.270277,126.3894385,1.8,115.3847239,126.5447849,0.0621729,25.6927345,40.2852076,179840.996341,470060.3721448,0.6973762,11668.3120183,6999.6829664,16005.9251497,46.9414563,78.2249316,3.0282195,227.4682388),(25828,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,206,1124.0355387,116.5370343,126.7827256,1.8,115.5147704,127.0396011,0.0674496,26.7110786,41.2967341,192403.5896929,510890.651205,0.850998,12371.211967,7203.1381679,16792.8331415,49.7869309,80.272376,3.0166431,242.3467749),(25829,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,207,1167.7851401,116.7187318,127.0786995,1.8,115.5281864,127.2508985,0.0686322,26.1580852,42.8964314,205519.6961289,555741.0864467,0.9153459,12955.4153527,7856.8325702,17557.3314907,50.1797248,82.3911578,3.0386712,263.1628118),(25830,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,208,1218.9467665,116.8702033,127.3801189,1.8,115.5841629,127.5051091,0.0642606,26.9707354,44.1472191,220119.4114064,605146.7223995,0.8377716,13707.4709161,8161.4167413,18433.2251648,51.3091454,84.5172557,3.0641224,263.4589095),(25831,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,209,1296.5797634,117.1048947,127.7484552,1.8,115.9806119,127.7848791,0.0604728,27.3395601,45.3625273,240458.0872389,678513.208814,0.7892941,14957.5706785,8795.243466,20122.2445648,53.156249,87.1051159,3.0309354,307.5183404),(25832,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,210,1364.2407698,117.1799636,128.0535634,1.8,116.164407,128.0759007,0.0593434,28.7861717,46.5898131,262989.7877509,744552.6533005,0.7997906,15981.0182404,9135.9764954,21523.8964098,54.3404349,89.6711258,0.0214559,291.0620692),(25833,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,211,1444.3064585,117.3270661,128.377638,1.8,116.4614127,128.6091167,0.0585178,29.7746553,47.7315205,293898.6806971,825314.0257297,0.8233543,17290.7549764,9870.7668514,23170.4573409,57.3972207,92.5016281,3.0332322,334.5613408),(25834,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,212,1520.4590513,117.2332672,128.6309683,1.8,116.4969012,129.0275603,0.0474294,30.1999199,48.8429262,328178.6646979,902805.8531762,0.5696297,18483.8608684,10866.8720206,24913.0339451,59.4666186,94.4684854,0.0652135,353.4742571),(25835,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,213,1591.7694991,116.7941711,128.7861969,1.8,116.4048404,129.2975894,0.0223238,31.752516,48.641631,365136.7922703,976683.944025,0.1321956,20079.177545,11499.4601401,27230.7580622,61.0167119,95.5351674,0.2068739,362.8246547),(25836,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,214,1633.1546888,117.0678293,128.6334783,1.8,117.0435161,129.3569387,0.0357567,32.5386906,48.8547608,389457.6670143,1036787.2135946,0.3478612,21221.825587,11969.0638851,28750.9986704,61.6582513,96.5977335,3.0498509,366.2215336),(25837,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,215,1676.4986471,117.6964786,129.1978494,1.8,117.3447512,129.4963611,0.0681429,31.742599,49.2454253,420039.9727638,1083597.4611279,1.2954468,22004.0228195,13232.6900072,30023.1721618,62.1999461,97.7101207,2.8086346,363.1980943),(25838,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,216,1726.6447752,118.0724129,129.6934354,1.8,116.780756,129.556173,0.0592624,31.9926494,51.0316725,444780.6370935,1147821.218567,1.0094879,22492.3299909,13902.5884311,30618.0280863,62.3124393,99.3262919,0.2186689,337.8488418),(25839,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,217,1791.2856656,116.6910462,129.7705389,1.8,115.6127782,129.3900519,0.0173924,32.0867936,51.3852291,465931.7466019,1242372.2510313,0.0902959,24177.6143343,14520.9818241,31641.1531683,63.3031384,100.8710963,0.3301943,342.6140831),(25840,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,218,1766.5587575,116.7573502,129.7499084,1.8,114.940646,129.1449704,-0.0153503,32.9412208,51.4992523,432728.3769199,1193485.2445089,0.0693733,23174.8072185,13136.3794736,31000.4572264,61.5416967,99.4171703,0.2703253,345.3347898),(25841,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,219,1762.2043083,116.3262541,129.7677567,1.8,114.3647985,128.9896671,-0.0008784,32.4261046,50.5399409,401285.2189158,1121741.5521749,0.0002287,22195.1496707,12375.3754609,29264.8088396,61.1415157,97.9945537,0.2907046,340.9590061),(25842,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,220,1805.1069133,116.1050566,129.5341792,1.8,114.100267,129.0875521,0.0165161,32.8818884,49.8337004,385311.9751033,1067031.9660377,0.0820558,21411.8549809,11718.0610158,28676.76412,60.9295931,96.7722913,0.2449787,370.6613894),(25843,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,221,1717.2061052,115.4119968,129.1820817,1.8,113.8619793,129.5170097,0.0119808,31.1107772,48.3658445,353538.8846949,993331.7312465,0.0410782,20537.8762937,11363.8718328,27439.2548839,60.6631271,94.7282727,0.2587709,383.0285915),(25844,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,222,1550.9058313,115.3963041,128.9175341,1.8,113.8438345,130.0596054,0.0225214,32.9280311,58.7624179,308947.4270798,886705.198516,0.1310855,15089.6649511,9382.5053339,18090.1082282,58.6807479,93.1332527,0.2419727,455.3126654),(25845,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,223,1382.4975774,115.3405713,129.6548568,1.8,113.9142859,130.6453774,0.0388428,52.0447423,58.6535522,267452.108283,798594.7774673,0.3474687,13615.4546136,5138.8881318,16581.7960341,56.1345489,91.183868,0.2603306,454.1696938),(25846,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,224,1287.292503,115.6614908,130.5433378,1.8,114.0677158,131.3165739,0.0340555,53.0494694,67.5602928,247834.1258537,742311.9455433,0.2487353,10987.3997692,4671.7550369,13978.0984393,43.5172931,58.01935,1.1397781,202.0189915),(25847,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,225,1264.2773976,116.0007078,131.1046035,1.8,114.4585549,131.9457076,0.0162446,53.9134341,55.6265528,248417.6987961,734680.8393203,0.0556004,13207.3767311,4607.714253,13259.1662302,0.384766,0.860363,2.677945,1.632424),(25848,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,226,1261.7025379,116.4874731,131.2809789,1.8,115.1294792,132.2981378,0.0026449,54.6851247,44.5454283,260407.9007594,733386.0281525,0.0014708,16463.7776964,4761.9513029,17850.8278954,41.034768,56.6599832,1.3027575,253.4163216),(25849,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,227,1279.8915589,117.1616014,131.318121,1.8,115.9277959,132.5819398,-0.0050699,30.7352843,44.8341919,281016.2387706,748149.4940616,0.0054837,16687.0297447,9143.1150045,22439.0739002,39.9975527,57.5067563,0.8991902,209.147518),(25850,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,228,1308.7597764,117.8748722,131.3116686,1.8,116.4804615,132.8441743,-0.0037679,31.4842198,44.4316849,298561.187314,770036.4731183,0.0030958,17330.7961321,9482.883451,22678.1455832,39.0431743,58.7735629,0.8827637,246.490533),(25851,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,229,1337.7523965,118.5758083,131.541075,1.8,117.1478164,133.1609944,0.0113849,30.7325975,48.6928857,308544.676931,795628.0447431,0.0288972,16339.7184798,10039.6550166,20762.6563714,38.8511244,59.4086733,0.9324765,267.8827472),(25852,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,230,1372.1142463,119.164159,131.9656147,1.8,117.5626253,133.349216,0.0258563,30.61472,45.2504955,310936.4857265,830434.0863087,0.152852,18351.9335361,10156.4373505,23028.3394991,0.384766,0.860363,2.677945,1.632424),(25853,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,231,1388.700255,119.374367,132.4593607,1.8,117.7812739,133.456974,0.0313024,30.1178143,46.1401295,302454.8069525,863602.2152416,0.2267085,18716.9439046,10042.3890102,23288.1678079,40.577245,59.8072978,0.8719395,263.3815676),(25854,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,232,1395.2246836,119.0407236,132.8704282,1.8,117.7351176,133.475635,0.0337067,29.4072122,46.2934289,285119.0797799,888643.932065,0.2640976,19195.8978536,9695.5494428,23560.282708,41.4558744,59.0449777,0.7992222,234.822156),(25855,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,233,1399.6752274,118.457438,133.2242052,1.8,117.3660177,133.3955797,0.0353948,28.2288655,46.4973245,257648.8468422,907822.647069,0.2921289,19524.1910561,9127.1414069,23737.784665,42.4743571,60.4094929,0.8034142,285.3565941),(25856,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,234,1359.8428044,117.8600452,133.6021658,1.8,116.9361489,133.4383782,0.0370207,27.073483,45.1543228,221090.11281,878832.4394108,0.3104764,19462.8638871,8166.2973714,22843.1810632,42.7505806,59.333867,0.8129142,221.1026095),(25857,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,235,1270.7338601,116.6845679,133.922113,1.8,116.0371318,133.5009665,0.0340017,25.5935435,45.7902938,174903.0873599,800062.0193491,0.2447572,17472.3058802,6833.8753937,20987.584022,43.495766,58.6777665,0.7064926,216.1119775),(25858,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,236,1111.9385655,113.8414667,134.0428528,1.8,114.2718759,133.5073136,0.025046,24.4544171,47.4630248,124170.8909693,637271.4955157,0.1162287,13426.6936865,5077.6467353,16012.9831304,43.8833796,55.2832611,0.6769149,198.2260201),(25859,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,237,848.6033821,107.7945742,133.9261921,1.8,110.0459856,133.4223014,0.0091158,22.6536603,49.2192394,77717.0890211,339122.999344,0.0117522,6890.0495706,3430.6636606,8453.497682,43.2318789,51.1275741,0.6088764,180.6041244),(25860,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,238,614.9325839,106.8328358,133.7095945,1.8,107.1853984,133.3464903,0.0029876,19.7996125,34.3790094,37831.0648227,215609.3489405,0.0009146,6271.5404694,1910.697232,7331.1290849,37.9837673,46.0852706,0.3851575,169.5119248),(25861,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,239,244.3174698,106.8772749,133.7002836,1.8,107.7515644,133.4820867,0.0149353,16.9949018,32.8093391,11047.3409378,66717.4894591,0.0090821,2033.4908047,650.0385261,2369.3851739,12.0388587,16.0036771,1.4016951,46.5387289),(25862,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,240,68.4157662,100.4194644,133.596434,1.8,102.7165183,133.6592856,0.5634824,21.2567134,32.5572402,2207.3864316,2283.7969986,3.2531531,70.1471312,103.8442017,122.6979242,12.6972792,26.2347241,1.497399,64.9688277),(25863,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,241,3.5409649,99.2111301,134.5209136,1.8,99.2440862,134.4967712,-1.5180232,2.3918683,5.619548,3.7404633,24.7905257,0.5885187,4.4114804,1.563825,5.0643009,4.6171924,11.6005524,1.4711277,27.1363603),(25864,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25865,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25866,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25867,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,245,22.22634,102.7228695,144.2207349,1.8,102.7177473,144.1879443,-1.4113473,6.7969458,6.9570569,211.0333894,217.2262226,3.6110051,31.2238676,31.0482671,61.1739499,13.8515773,14.4069064,2.1662062,45.8078678),(25868,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,246,71.2743787,102.7478199,144.1999463,1.8,102.7229428,144.2307774,-0.8522273,10.1446231,10.1744422,1546.2271706,1574.7049097,6.731037,154.7706373,152.4183955,304.5114852,20.3925999,20.9335355,0.6287963,67.1453931),(25869,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,247,115.1373017,102.7572425,144.1776092,1.8,102.7109015,144.1948106,-0.8363814,12.0384287,12.1366929,3697.9343095,3749.3711944,10.5714257,308.9285711,307.1774891,610.1224396,24.2402602,24.8077137,2.7265179,79.8313458),(25870,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,248,174.2106271,103.7806197,147.0964775,1.8,103.207665,147.3718768,0.1220291,21.2154593,61.3545694,14109.5595782,45103.8855755,0.430223,735.1349058,665.0602925,960.0319172,26.5488564,27.255996,0.72547,87.938777),(25871,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,249,197.9113149,103.947354,146.7354274,1.8,103.7218316,147.0732841,0.127687,21.7334085,61.2699113,16417.7497084,46612.2792324,0.5348734,760.769491,755.4153189,1023.2528195,28.0879206,28.6515092,1.1853025,92.8360491),(25872,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,250,490.369039,119.9808992,143.5677315,1.8,117.2394825,144.4657551,-0.1190333,24.3264397,72.3427458,34283.0855854,155030.2818733,1.1525423,2142.9969255,1409.2931813,2607.8726127,28.4726866,29.2523424,0.9536049,94.0563626),(25873,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,251,660.8916432,123.7223144,143.1668826,1.8,117.2924334,144.5189714,-0.1230946,24.3160747,76.1289331,42999.5819964,191351.5317966,1.6605908,2513.5191592,1768.3603377,3069.8500017,28.4726866,29.348343,0.9718851,94.9192546),(25874,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,252,663.9698108,123.5783512,143.1333718,1.8,117.264418,144.4888074,-0.123134,24.3163141,76.0376568,43470.3600893,192774.062652,1.6693858,2535.2446507,1787.7035123,3096.9990122,28.4726866,29.3962258,0.9246774,94.2817534),(25875,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,253,663.3681204,123.437449,143.1423639,1.8,117.1583747,144.4724483,-0.1265162,24.3226064,75.9169336,43528.3163461,193781.4975243,1.7602631,2552.5464269,1789.6238447,3116.6780868,28.4726866,29.3659932,1.0191413,94.600504),(25876,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,254,664.4431507,123.3616095,143.1320094,1.8,117.0962026,144.4429254,-0.1273427,24.2566993,75.896696,43775.5129157,193134.7590991,1.7860999,2544.7057554,1804.6772334,3111.1609129,28.4726866,29.3962258,0.9246774,94.600504),(25877,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,255,666.6979643,123.2422192,143.1290129,1.8,116.960679,144.441012,-0.1309731,24.2541456,75.8006833,44039.1241309,195328.8312963,1.895212,2576.8742801,1815.7359499,3148.2388133,28.8394913,29.348343,0.9718851,94.9192546),(25878,'windfallLgGiraffe_metacarpus-cleaned.tif',247,5,256,667.8648273,123.1462391,143.1035982,1.8,116.908324,144.388168,-0.1323834,24.255678,75.7679738,44128.5975326,195296.4946715,1.9393919,2577.5599493,1819.3100007,3149.3049649,28.7402087,29.3029082,1.0483929,94.9192546),(25879,'windfallLgGiraffe_femur-cleaned.tif',247,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25880,'windfallLgGiraffe_femur-cleaned.tif',247,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25881,'windfallLgGiraffe_femur-cleaned.tif',247,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25882,'windfallLgGiraffe_femur-cleaned.tif',247,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(25883,'windfallLgGiraffe_femur-cleaned.tif',247,7,5,133.7553279,130.8069298,146.4253568,1.8,130.8067731,146.429901,-0.6454113,12.0351801,12.995783,3695.5649412,4276.4958287,8.0662223,329.0679623,307.0635359,611.6165138,24.7710412,26.9240039,0.6947383,82.8897714),(25884,'windfallLgGiraffe_femur-cleaned.tif',247,7,6,341.997594,131.1090534,146.3184219,1.8,131.3362826,146.296857,-0.5289714,17.0797873,17.745025,21050.2236642,23288.7853782,14.515929,1312.4120894,1232.4640408,2479.5548338,33.7832015,36.2864605,0.6777083,113.4909927),(25885,'windfallLgGiraffe_femur-cleaned.tif',247,7,7,518.7309311,131.6758651,146.1891144,1.8,132.0378853,146.2223827,-0.4463865,20.3813253,21.3552018,49941.6692042,54687.7480192,16.1128746,2560.863082,2450.3641628,4803.0472958,40.6777324,43.6048422,0.6055447,137.6015553),(25886,'windfallLgGiraffe_femur-cleaned.tif',247,7,8,671.7113943,132.3518632,146.2093501,1.8,132.7448193,146.2100554,-0.2404781,23.2723705,24.7833661,86459.0365852,94359.0668571,6.3503067,3807.3547559,3715.0936799,7059.6451572,46.8828102,49.8126876,3.0584514,158.7177226),(25887,'windfallLgGiraffe_femur-cleaned.tif',247,7,9,811.6685414,132.9832651,146.3712102,1.8,133.5557758,146.2977402,0.1046762,25.9448266,28.748246,128097.7169617,141977.5872468,1.4768499,4938.6521545,4937.3125081,9364.1222732,51.6564168,55.5854853,2.7334435,176.3376265),(25888,'windfallLgGiraffe_femur-cleaned.tif',247,7,10,929.683017,133.6238414,146.6131133,1.8,134.3809688,146.5074903,0.2360498,27.8999569,31.79885,169369.0028037,195563.913803,8.4744151,6150.031025,6070.5829521,11466.598996,54.4667942,60.9415696,2.7589854,188.3439099),(25889,'windfallLgGiraffe_femur-cleaned.tif',247,7,11,1064.2985763,137.0761775,148.1284975,1.8,139.7879296,148.7015348,0.388325,29.3627032,94.2488938,210906.3784672,544382.770896,25.4309233,5776.0123085,7182.7984366,8013.1236643,58.3099773,66.8307334,2.7610863,204.013746),(25890,'windfallLgGiraffe_femur-cleaned.tif',247,7,12,1215.2745217,141.2398247,149.8996449,1.8,144.5304962,150.6483766,0.391485,30.7123687,91.6320672,253192.8168433,1008112.9147459,29.4884706,11001.7480325,8244.0016147,13741.1045536,60.671872,72.2446836,2.7291822,216.5911911),(25891,'windfallLgGiraffe_femur-cleaned.tif',247,7,13,1357.0162313,144.4434195,151.233765,1.8,148.568419,152.328483,0.3868063,31.9717338,89.8506563,295541.8754547,1397018.5054992,32.1848968,15548.2281632,9243.8488636,18777.6469775,62.0507782,75.5572646,2.6575397,226.9819854),(25892,'windfallLgGiraffe_femur-cleaned.tif',247,7,14,1466.4275283,146.7997797,151.9994999,1.8,152.3299974,153.7799678,0.3758081,32.5393547,89.3271921,334752.8667994,1749937.6203727,32.9229792,19590.2006825,10287.6307732,23045.3112149,64.0591341,76.8639709,2.7261006,233.6399334),(25893,'windfallLgGiraffe_femur-cleaned.tif',247,7,15,1589.8697301,148.6440192,152.7318335,1.8,155.502781,154.7576313,0.3562665,33.3157149,90.0710071,372509.3190833,2089062.4082735,32.2335046,23193.5056044,11181.1894292,26815.0986314,64.8085906,78.0179464,2.5511391,239.8247156),(25894,'windfallLgGiraffe_femur-cleaned.tif',247,7,16,1599.1054063,151.2005937,153.2088729,1.8,158.7100498,155.7583674,0.3478115,33.3043995,90.009228,373636.5985541,2398619.5082028,30.9620652,26648.5954865,11218.8360842,30193.5812581,66.3995218,81.1389923,2.7121522,249.1711824),(25895,'windfallLgGiraffe_femur-cleaned.tif',247,7,17,1622.9154657,153.9724977,153.8958237,1.8,161.6722323,156.5278026,0.341877,114.1015758,89.4532188,366660.9380841,2635125.4853653,30.4016944,29458.1404897,3213.4607727,21833.6169543,66.542517,84.3756513,2.8172581,261.5120446),(25896,'windfallLgGiraffe_femur-cleaned.tif',247,7,18,1641.2594832,156.86877,154.4285582,1.8,164.2210137,156.8901019,0.3319041,150.5203312,87.8333012,359441.0734204,2775801.5551693,29.0432284,31603.0653071,2387.9901838,20094.3266261,65.4980437,90.3893775,2.7667519,266.623797),(25897,'windfallLgGiraffe_femur-cleaned.tif',247,7,19,1633.9839592,159.7934735,154.856,1.8,166.5341447,156.9282385,0.3190717,142.8700836,90.2170378,350615.6775423,2842461.405461,26.7969181,31506.9245831,2454.0874383,20508.2579468,66.590906,149.1913405,2.9179112,488.0208641),(25898,'windfallLgGiraffe_femur-cleaned.tif',247,7,20,1604.201687,162.5649247,155.1301375,1.8,168.5026899,156.9163025,0.3069107,143.7291642,88.687856,338274.2392839,2835301.0425623,24.4035335,31969.4394654,2353.5532348,21071.2806266,65.138302,149.6160865,2.9749288,477.5607763),(25899,'windfallLgGiraffe_femur-cleaned.tif',247,7,21,1566.3810331,165.620752,155.4302561,1.8,170.542655,156.997919,0.2964144,144.3130004,89.9843395,324297.2154962,2765900.4423099,22.2734787,30737.5756377,2247.179496,21197.3270643,64.8135713,149.7320059,2.970388,471.7105728),(25900,'windfallLgGiraffe_femur-cleaned.tif',247,7,22,1541.9469747,168.6789603,155.6099752,1.8,172.455941,156.7904531,0.2875267,136.4263648,109.7198466,312561.8726058,2663302.6257431,20.6668088,24273.66341,2291.0664887,20480.9333313,65.3433633,149.7320059,2.970388,461.3197785),(25901,'windfallLgGiraffe_femur-cleaned.tif',247,7,23,1507.6476232,171.8927532,156.0220765,1.8,174.3624422,156.8453664,0.280944,146.8959855,107.8585453,308613.5305755,2513713.6973048,19.3166442,23305.6517717,2100.8983301,18492.5215835,65.6835708,149.0048343,2.946012,453.1849285),(25902,'windfallLgGiraffe_femur-cleaned.tif',247,7,24,1455.5447077,175.1044873,156.6383399,1.8,176.8043551,157.2891136,0.2736,144.0239476,109.7850058,299693.6080704,2303389.1983444,17.7109844,20980.9088313,2080.8595593,17446.1329378,65.0808364,147.5187965,2.94878,531.1589392),(25903,'windfallLgGiraffe_femur-cleaned.tif',247,7,25,1423.076733,177.253436,157.1346019,1.8,179.0487721,157.9112821,0.2754336,150.5891971,120.7968272,290337.8089424,2124689.6033717,17.5428622,17588.9520654,1928.0121983,15549.2324383,5.2455049,19.742932,2.0032041,43.2766621),(25904,'windfallLgGiraffe_femur-cleaned.tif',247,7,26,1411.6361736,177.4643077,157.4485075,1.8,181.0150973,158.6413453,0.2684141,145.6088023,117.3533992,286215.6355499,2037295.9828668,16.5473068,17360.3491461,1965.6478938,15587.8505862,63.6508483,137.6318305,2.8832491,478.3685208),(25905,'windfallLgGiraffe_femur-cleaned.tif',247,7,27,1385.9366876,178.6201981,157.9172287,1.8,183.4015431,159.5980283,0.2667685,142.3822954,120.0170921,273158.6603115,1889111.3928184,16.0521936,15740.3529786,1918.4875447,14198.4808339,63.2755854,130.4360704,2.90687,481.5302055),(25906,'windfallLgGiraffe_femur-cleaned.tif',247,7,28,1350.7232322,179.9298419,158.6471866,1.8,184.8303717,160.1652288,0.2739533,136.3358192,122.848267,268461.583272,1739446.3874824,16.4769247,14159.3074952,1969.1199629,12378.7444128,62.811475,125.4823567,2.863293,460.4140381),(25907,'windfallLgGiraffe_femur-cleaned.tif',247,7,29,1332.2305612,181.3243272,159.5143112,1.8,185.5192325,161.0721619,0.2804332,122.4731504,121.1841446,265349.1310801,1611438.8606153,17.0087445,13297.4397393,2166.5902296,12705.7088191,62.5308797,122.1422145,2.7537489,446.0251124),(25908,'windfallLgGiraffe_femur-cleaned.tif',247,7,30,1325.8570414,182.4212719,160.4013714,1.8,185.9706424,161.8280696,0.2955006,148.518061,114.2285659,270112.0050149,1510452.1642992,18.7406371,13223.0686168,1818.714863,11642.0010734,62.5549082,119.2275519,2.7374602,426.3165535),(25909,'windfallLgGiraffe_femur-cleaned.tif',247,7,31,1346.4720584,183.4608535,161.4847077,1.8,186.5322584,162.9730278,0.3150884,106.8547532,126.7378063,275915.8481258,1457086.0931691,21.5521593,11496.8542976,2582.1579286,11019.4753307,62.0278683,116.2071089,2.8217183,461.9602337),(25910,'windfallLgGiraffe_femur-cleaned.tif',247,7,32,1362.9237684,184.3413738,162.434769,1.8,187.5058408,164.0124736,0.3257741,143.5244835,108.9345831,284986.4621324,1423772.7391654,23.2667156,13069.9792376,1985.6295955,11237.0219538,60.8865874,113.3935516,2.8390705,451.7080265),(25911,'windfallLgGiraffe_femur-cleaned.tif',247,7,33,1355.3682226,184.5215359,163.24016,1.8,187.725885,165.0277978,0.3330274,140.326279,55.2437897,283789.0066988,1367901.4579816,24.1407529,24761.1806654,2022.3511136,11379.7358708,59.6969025,110.9762508,2.8257359,428.9763701),(25912,'windfallLgGiraffe_femur-cleaned.tif',247,7,34,1374.3049816,184.503005,164.0636648,1.8,187.7380854,165.7754039,0.3395949,159.1663497,115.5304559,298008.9493938,1327702.0258034,25.415262,11492.2252798,1872.3112642,10133.4104424,58.3718718,109.240791,2.8338132,437.347803),(25913,'windfallLgGiraffe_femur-cleaned.tif',247,7,35,1419.7460011,184.0887794,165.1527682,1.8,187.3166429,167.4479813,0.3457475,148.7204704,81.4221684,301225.6936216,1287759.3013346,27.1770643,15815.8315775,2025.448769,10682.4112517,57.4327,107.5038452,2.8015885,394.7690007),(25914,'windfallLgGiraffe_femur-cleaned.tif',247,7,36,1439.8150908,183.364205,166.1665343,1.8,186.7616771,168.301307,0.3591802,142.1341102,108.4666131,312953.8913839,1236882.822121,29.6498831,11403.3506455,2201.8211594,10647.9918734,56.7654272,106.2585677,2.8588367,373.5835398),(25915,'windfallLgGiraffe_femur-cleaned.tif',247,7,37,1349.4274114,181.9601604,165.8661068,1.8,185.914732,168.5905376,0.3586136,159.1150632,135.0746368,310093.2017046,1131575.4901693,27.704741,8377.4090919,1948.8613808,8779.634081,56.8692539,105.179453,2.896614,377.414382),(25916,'windfallLgGiraffe_femur-cleaned.tif',247,7,38,1268.4227653,180.0247945,165.1697915,1.8,184.975159,168.459193,0.3432338,158.3067586,133.7455919,299877.7061142,1005841.3258326,23.9425731,7520.556839,1894.2823971,7948.3098381,56.0921838,103.0403734,2.8706458,365.1428134),(25917,'windfallLgGiraffe_femur-cleaned.tif',247,7,39,1234.4253303,178.962411,165.0838813,1.8,184.3599449,168.7335023,0.3509762,156.7854512,116.7399174,304711.0560765,936083.1834695,24.3199353,8018.535599,1943.4906349,7770.3639825,55.9036223,100.0158591,2.8765498,354.0828616),(25918,'windfallLgGiraffe_femur-cleaned.tif',247,7,40,1198.1433556,177.6813949,164.8652335,1.8,183.154878,168.7880344,0.3621322,152.7506893,132.0037058,306443.9809607,868219.0412724,25.062462,6577.2323273,2006.1708557,7251.4177728,56.4402683,97.2519959,2.9706165,371.2988933),(25919,'windfallLgGiraffe_femur-cleaned.tif',247,7,41,1190.4234556,176.8049836,164.6496988,1.8,181.7675989,168.4625676,0.3476737,159.9045267,50.2340587,310614.3111798,825502.9818375,23.0315998,16433.1332883,1942.4985499,6999.3665495,56.8884335,95.5035638,2.8335399,373.0816717),(25920,'windfallLgGiraffe_femur-cleaned.tif',247,7,42,1199.6716637,176.0617454,164.4592063,1.8,180.4624674,167.8789365,0.3512352,160.5502143,118.1549357,319380.0679263,796162.4307607,23.6686827,6738.2917672,1989.2845943,6842.8878499,57.816491,93.7504107,2.8198421,336.9648258),(25921,'windfallLgGiraffe_femur-cleaned.tif',247,7,43,1216.7936109,175.3136302,164.0292565,1.8,179.264318,167.049972,0.3392414,161.0369611,119.0954375,335702.9038553,776251.3940308,22.4573604,6517.8936369,2084.6326306,6720.2609772,57.7274691,92.8127811,2.9092259,341.3381272),(25922,'windfallLgGiraffe_femur-cleaned.tif',247,7,44,1229.7312208,174.4837552,163.8839744,1.8,177.8203967,167.0214958,0.329873,159.8055634,126.3892032,341725.9255954,754717.5093089,21.5051406,5971.3764348,2138.3856631,6780.8288794,58.1655812,91.1435083,2.9590328,320.1526664),(25923,'windfallLgGiraffe_femur-cleaned.tif',247,7,45,1259.8401851,173.7051669,163.4418304,1.8,176.2150429,166.2386949,0.3204026,153.7388214,126.2937232,351509.5210136,738735.0888876,20.8278179,5849.3412812,2286.407024,6666.3235886,59.5062772,89.0249213,3.0095529,345.5441393),(25924,'windfallLgGiraffe_femur-cleaned.tif',247,7,46,1264.679491,173.1652625,163.0672219,1.8,175.130283,165.7885577,0.3060796,142.9348883,115.4282032,353720.6505336,708663.8148447,19.1378504,6139.4338243,2474.6977779,6758.0153049,59.6024561,87.1715218,2.9907473,351.2963469),(25925,'windfallLgGiraffe_femur-cleaned.tif',247,7,47,1250.918525,172.7614924,162.57812,1.8,174.3419149,165.2432579,0.298949,156.9620721,122.4496916,362584.6614683,680142.6621488,18.0840454,5554.4661119,2310.014494,6427.7711757,59.3756326,84.6652888,3.0273383,324.8318442),(25926,'windfallLgGiraffe_femur-cleaned.tif',247,7,48,1247.9398368,172.2922212,162.2051282,1.8,173.3967962,164.8275475,0.2855551,154.4550597,111.7949939,366616.3917923,648918.3849627,16.5038589,5804.5388445,2373.6120562,6414.9587821,59.5298616,82.8377244,0.0499584,339.6939358),(25927,'windfallLgGiraffe_femur-cleaned.tif',247,7,49,1267.8827439,171.8878743,161.4231232,1.8,172.7808163,163.8609115,0.2956224,157.8720251,121.8995306,365991.4702927,614636.7039673,17.935528,5042.1580866,2318.2794416,6061.8505208,59.5829997,80.8543602,0.0682698,301.488435),(25928,'windfallLgGiraffe_femur-cleaned.tif',247,7,50,1203.6982727,172.0734606,160.8338419,1.8,172.949026,163.4169872,0.2803292,153.8348226,116.164326,352478.5577358,566730.3091939,15.3566655,4878.6949388,2291.279385,5865.8994259,59.6875475,77.8196794,0.124355,310.2350379),(25929,'windfallLgGiraffe_femur-cleaned.tif',247,7,51,1193.7579327,172.0936846,160.1636886,1.8,172.9600511,162.5415883,0.2823744,157.8525888,117.72389,347431.0939707,528973.9369788,15.4469232,4493.3440196,2200.9844535,5352.5193761,59.9824189,75.5667008,2.5839605,299.2037884),(25930,'windfallLgGiraffe_femur-cleaned.tif',247,7,52,1140.5660437,172.1061637,159.4923085,1.8,173.0011022,162.2360853,0.3010814,145.0745578,96.9309955,322335.4272146,490274.0365421,16.7176165,5057.9696801,2221.8604836,5367.3974201,58.9349637,73.7747024,2.488746,283.7705352),(25931,'windfallLgGiraffe_femur-cleaned.tif',247,7,53,1109.0690704,172.2393778,158.6466168,1.8,173.216426,161.1844697,0.3155321,144.3440673,112.7327855,309199.8146607,457098.3729628,17.8005545,4054.7066312,2142.1026883,5006.4393263,58.974227,72.2973017,2.5324292,303.5770898),(25932,'windfallLgGiraffe_femur-cleaned.tif',247,7,54,1090.6682995,172.3941598,157.8597125,1.8,173.2563158,160.2369485,0.3477323,151.597944,115.4022572,295755.9298914,430240.6157061,21.1084243,3728.1819809,1950.9230938,4598.9937603,58.9320605,70.6344608,2.4668517,308.146383),(25933,'windfallLgGiraffe_femur-cleaned.tif',247,7,55,1079.6572796,172.5219238,157.2159459,1.8,173.5808353,159.5938364,0.3620186,148.8780871,55.0566626,294218.7470275,410543.291644,22.5704556,7456.7413327,1976.2394367,4609.1093493,57.865299,69.361174,2.4901394,288.0745431),(25934,'windfallLgGiraffe_femur-cleaned.tif',247,7,56,1079.5433407,172.4382691,156.3832977,1.8,173.5069113,158.7870516,0.4120363,159.3784854,34.9562433,288220.5072186,394231.8683238,28.8563804,11277.8671694,1808.4028504,4226.8555331,57.7478121,67.9802147,2.5001199,288.1438366),(25935,'windfallLgGiraffe_femur-cleaned.tif',247,7,57,1073.2007905,172.5133918,155.628297,1.8,173.6377931,157.6545431,0.4464518,159.0818681,112.7624189,289032.8661499,379478.9873496,33.344968,3365.2966206,1816.8812675,4153.0292588,0.6894531,6.9289178,1.670465,14.3602235),(25936,'windfallLgGiraffe_femur-cleaned.tif',247,7,58,1070.5740021,172.4263802,154.9786747,1.8,173.4427891,157.0061601,0.492838,151.5781499,33.7704946,277675.2687528,363557.3114464,39.9413588,10765.5311511,1831.8950919,4193.0828397,0.6894531,9.6769353,1.6421038,19.8758482),(25937,'windfallLgGiraffe_femur-cleaned.tif',247,7,59,1069.0723422,172.4195013,154.263775,1.8,173.4008893,156.3156247,0.5416986,28.4389964,33.1540707,271538.8871884,350024.8500234,47.366185,10557.522566,9548.1177654,18234.2239065,56.3142237,64.6801076,2.5151475,288.7842918),(25938,'windfallLgGiraffe_femur-cleaned.tif',247,7,60,1070.5292043,172.3122859,153.5266943,1.8,173.2294664,155.3695921,0.5804711,33.8799996,117.8509745,268725.8589164,338210.9695907,53.6624665,2869.8190316,7931.6960487,5067.2941482,0.6894531,6.9289178,1.670465,14.3602235),(25939,'windfallLgGiraffe_femur-cleaned.tif',247,7,61,1071.4287598,172.4199413,152.898712,1.8,173.4093731,154.627088,0.6347513,29.2887192,32.2998628,264235.3163807,325069.8884672,62.7896669,10064.1259704,9021.743657,18130.8963687,56.8103883,62.4668852,2.4892618,265.4814737),(25940,'windfallLgGiraffe_femur-cleaned.tif',247,7,62,1054.5187014,172.424851,152.2273974,1.8,173.2791011,153.6415981,0.6929362,28.2329671,31.8214692,258293.5320467,312501.2692303,71.7185433,9820.4538227,9148.649922,17800.0323543,56.2708299,61.8051532,2.4668517,286.7649304),(25941,'windfallLgGiraffe_femur-cleaned.tif',247,7,63,1041.5990971,172.4878337,151.7074942,1.8,173.2868502,152.955404,0.7748261,28.2071358,31.1114948,253089.6592356,303374.2178945,84.9647532,9751.1938751,8972.5401686,17580.8908533,0.6894531,4.1937794,1.735945,8.8445987),(25942,'windfallLgGiraffe_femur-cleaned.tif',247,7,64,1030.9133288,172.526542,151.1096543,1.8,173.1619187,152.0448919,0.8614515,27.9213309,32.1083949,248827.0525162,296591.011178,98.9265117,9237.1796218,8911.7189098,16984.564332,55.1562473,61.2682946,2.252567,269.7854817),(25943,'windfallLgGiraffe_femur-cleaned.tif',247,7,65,1025.4426775,172.6699208,150.5016853,1.8,173.2435191,151.4444356,0.9599237,27.8229524,31.6286337,242647.3122504,290156.6470608,114.6792004,9173.8596673,8721.1201919,16836.4249473,55.1562473,60.8361781,2.2437674,268.9777371),(25944,'windfallLgGiraffe_femur-cleaned.tif',247,7,66,1018.469214,172.6548163,149.8934098,1.8,172.9074101,150.4950283,1.0375286,27.5463133,30.7179423,237111.1764081,285165.5051384,125.8794403,9283.3531094,8607.7281482,16969.6147237,0.6894531,4.1937794,1.735945,8.8445987),(25945,'windfallLgGiraffe_femur-cleaned.tif',247,7,67,1021.1488666,172.734887,149.444069,1.8,172.9548619,149.9221493,1.1051399,27.3520414,30.2028551,232925.2796194,282558.2568464,135.8792632,9355.3492154,8515.8279732,16975.0061383,53.7612158,58.9431992,1.9925836,272.4740005),(25946,'windfallLgGiraffe_femur-cleaned.tif',247,7,68,1024.9146118,172.8292045,148.9875554,1.8,173.0832977,149.305206,1.1498787,27.2603438,30.4230919,230092.492561,280235.7271687,142.3004384,9211.2836032,8440.5572481,16537.6842887,0.6894531,3.5155348,1.7681919,7.4656926),(25947,'windfallLgGiraffe_femur-cleaned.tif',247,7,69,1024.5717868,173.0102373,148.4288931,1.8,173.2249,148.8562145,1.19437,26.9958755,30.1915268,224078.9182934,277283.6458326,147.6870213,9184.1544616,8300.4871671,16449.6186842,51.7089819,59.3089975,2.1910458,260.2311342),(25948,'windfallLgGiraffe_femur-cleaned.tif',247,7,70,1019.2173791,173.0766335,147.8825058,1.8,173.2867518,148.1990631,1.2203117,26.782325,29.7728657,218328.6357097,274182.1329106,149.8434196,9209.1280527,8151.9672159,16242.6948302,0.6894531,1.541664,2.0344439,3.328974),(25949,'windfallLgGiraffe_femur-cleaned.tif',247,7,71,1015.236288,173.1291189,147.2993009,1.8,173.2849484,147.4694537,1.2445598,26.4638826,30.0958815,214667.2804311,271779.2474671,151.8272981,9030.4464974,8111.7077107,16001.1783292,0.6894531,7.6152583,1.6614562,15.7391297),(25950,'windfallLgGiraffe_femur-cleaned.tif',247,7,72,1010.3070985,173.1664495,146.7399396,1.8,173.2326623,146.8143304,1.2698826,26.2193005,29.4789251,211220.9083821,270189.1185068,153.5921323,9165.5010433,8055.9322571,16058.51403,51.6020333,58.7655131,2.1132279,261.8466233),(25951,'windfallLgGiraffe_femur-cleaned.tif',247,7,73,1008.0798885,173.236903,146.2030263,1.8,173.391479,146.4010669,1.3040652,26.1376494,29.3625399,206839.8031358,268516.5443177,156.3407282,9144.8677684,7913.4814313,15945.7511891,50.3300757,58.5385871,2.1293956,271.1930902),(25952,'windfallLgGiraffe_femur-cleaned.tif',247,7,74,1002.4948662,173.2857499,145.6537191,1.8,173.4011116,145.7677161,1.3296722,25.9053605,29.8763351,203580.121679,266559.00269,157.5549742,8922.0783591,7858.6098777,15680.1213843,0.6894531,2.1802421,1.8925469,4.7078802),(25953,'windfallLgGiraffe_femur-cleaned.tif',247,7,75,997.6369785,173.3196404,145.0949829,1.8,173.3987511,145.1667358,1.3504057,25.8358983,29.9252049,200781.4445411,266487.070937,158.326536,8905.1043178,7771.4133395,15611.2099401,0.6894531,4.8751696,1.7126934,10.2235049),(25954,'windfallLgGiraffe_femur-cleaned.tif',247,7,76,991.4270929,173.3281654,144.5305578,1.8,173.3910899,144.620348,1.3646726,25.5253828,29.6657526,198057.8055516,266211.6065737,158.3162563,8973.7014466,7759.249166,15643.6018607,50.3300757,57.7579014,1.9756881,257.0407473),(25955,'windfallLgGiraffe_femur-cleaned.tif',247,7,77,981.3440051,173.4177699,143.9055994,1.8,173.6071561,144.0867344,1.3765421,26.6314276,30.2696519,193405.6705496,264623.4025127,157.4627897,8742.2016965,7262.3095411,15127.5150491,49.9813499,57.402922,1.9914597,220.4507355),(25956,'windfallLgGiraffe_femur-cleaned.tif',247,7,78,971.0392335,173.4117631,143.3462549,1.8,173.6432626,143.5272724,1.3818602,26.3752501,30.534779,189836.6780109,263190.1642821,156.1311149,8619.3570904,7197.5309157,14818.1432916,49.8251741,58.8624993,1.8072525,251.1499526),(25957,'windfallLgGiraffe_femur-cleaned.tif',247,7,79,963.1310678,173.4158536,142.804684,1.8,173.7482984,142.9927751,1.3933112,27.6368162,31.1177377,187862.7082121,262586.4438371,155.518125,8438.4811672,6797.5524755,14452.858369,0.6894531,2.1802421,1.8925469,4.7078802),(25958,'windfallLgGiraffe_femur-cleaned.tif',247,7,80,958.3002604,173.408183,142.2971754,1.8,173.7656213,142.5133447,1.3952635,26.2264076,31.6221404,186171.3059744,263608.8390737,154.8458925,8336.2111478,7098.6201574,14201.3998219,0.6894531,1.541664,2.0344439,3.328974),(25959,'windfallLgGiraffe_femur-cleaned.tif',247,7,81,953.8062282,173.473174,141.6961428,1.8,173.8286079,141.9699813,1.3984911,27.2616195,32.0904629,183722.7475391,263458.3364297,154.2946231,8209.8640176,6739.2455439,13892.5023649,0.6894531,2.8426879,1.815775,6.0867864),(25960,'windfallLgGiraffe_femur-cleaned.tif',247,7,82,946.043259,173.4585913,141.1747724,1.8,173.8354488,141.5742844,1.4052424,27.23344,32.9642014,181913.5707818,262678.4569487,153.3916724,7968.5976303,6679.786716,13486.452367,0.6894531,3.5155348,1.7681919,7.4656926),(25961,'windfallLgGiraffe_femur-cleaned.tif',247,7,83,940.0732068,173.4572396,140.6855337,1.8,173.8532373,140.9682299,1.4073354,26.9013078,32.7816449,180727.8504091,262983.0980368,152.5296465,8022.2667031,6718.1808243,13091.1570646,48.9045788,60.7540806,1.0868469,252.4308629),(25962,'windfallLgGiraffe_femur-cleaned.tif',247,7,84,936.201157,173.4440438,140.199287,1.8,173.8383915,140.5412944,1.4093108,26.3668674,32.3477197,179897.0449916,264470.8751275,151.9997955,8175.8738321,6822.8448235,13722.9703044,0.6894531,0.9750339,2.3561945,1.9500678),(25963,'windfallLgGiraffe_femur-cleaned.tif',247,7,85,933.7472216,173.4825672,139.6370112,1.8,173.8452282,140.1345798,1.4102925,26.3199345,33.7990062,178559.7439729,265091.4110125,151.6497267,7843.1717528,6784.2016963,13125.5717104,48.1120088,61.0350981,1.3312971,242.3746474),(25964,'windfallLgGiraffe_femur-cleaned.tif',247,7,86,930.6485447,173.4953929,139.1528568,1.8,173.7703723,139.6618641,1.4066686,27.1894862,31.7820102,177747.424142,265752.9121522,150.9671891,8361.7401925,6537.3587007,13896.0404551,48.2617164,61.7012369,1.2525793,265.2735932),(25965,'windfallLgGiraffe_femur-cleaned.tif',247,7,87,929.261832,173.5345937,138.711626,1.8,173.742179,139.1121872,1.4003478,25.6897904,33.2214314,177986.6285836,267942.7283464,150.4207836,8065.3577209,6928.3020816,13412.5211968,48.9084571,61.2838095,1.2739517,254.4789266),(25966,'windfallLgGiraffe_femur-cleaned.tif',247,7,88,930.5585171,173.5500464,138.2452677,1.8,173.6845274,138.4667042,1.3960793,24.6709741,31.8749344,178585.8472918,270926.8206878,150.4066884,8499.6824643,7238.7027109,14102.1877783,47.9522451,60.8322712,1.259798,238.0013459),(25967,'windfallLgGiraffe_femur-cleaned.tif',247,7,89,933.9243958,173.6513055,137.7490977,1.8,173.7862648,138.0832896,1.3904314,24.7247115,31.4835221,178109.8405604,273535.5307429,150.6450785,8688.212524,7203.7176566,14290.5927074,48.0613126,60.8947514,1.2956071,243.9208429),(25968,'windfallLgGiraffe_femur-cleaned.tif',247,7,90,937.001178,173.7356428,137.3691798,1.8,173.8795861,137.6677851,1.3833478,24.7332442,31.3109442,178212.5882818,276066.2565659,150.7436029,8816.925326,7205.3866755,14433.8907944,49.2330203,60.1762621,1.4905095,269.6468946),(25969,'windfallLgGiraffe_femur-cleaned.tif',247,7,91,950.1712751,173.8380317,137.1056183,1.8,173.9393975,137.5728774,1.3744302,24.9940353,31.0349832,179704.4513981,280981.4792571,152.3335818,9053.7016825,7189.8934718,14746.8406195,48.2617164,60.203903,1.801887,280.539557),(25970,'windfallLgGiraffe_femur-cleaned.tif',247,7,92,957.1814698,173.8528663,136.7222837,1.8,173.8504453,137.1758962,1.3693756,24.9365818,31.1493822,181572.8316185,285433.7848583,153.1451066,9163.3850965,7281.3841596,14962.5663819,48.2987892,60.0457835,1.9470383,252.0269907),(25971,'windfallLgGiraffe_femur-cleaned.tif',247,7,93,966.5320933,173.9503914,136.3333801,1.8,173.9439327,136.856151,1.3601214,25.0891494,30.0335999,182418.8698736,288542.2372298,154.0440905,9607.3144195,7270.8272044,15551.9793473,49.4730816,60.2315312,1.849096,306.2656087),(25972,'windfallLgGiraffe_femur-cleaned.tif',247,7,94,963.9194212,173.9811109,135.9122607,1.8,174.0086711,136.4475636,1.3506377,25.1075403,30.8187961,182961.1778754,290489.2570673,152.9914007,9425.7172243,7287.1008363,15357.4352282,0.6894531,0.9750339,2.3561945,1.9500678),(25973,'windfallLgGiraffe_femur-cleaned.tif',247,7,95,963.7896375,174.0118423,135.5181412,1.8,173.9878102,135.8814614,1.3379044,24.9601708,30.3527529,184538.8222448,293495.4056,152.0755459,9669.4822582,7393.3317162,15574.9745187,48.9511695,60.8361781,1.9786643,260.2311342),(25974,'windfallLgGiraffe_femur-cleaned.tif',247,7,96,969.4092304,174.0740641,135.1844556,1.8,174.1667359,135.5565595,1.3298517,25.0713696,30.9754432,186551.1486336,297015.7180363,152.3685861,9588.7479541,7440.8040521,15605.3766673,48.2617164,60.7540806,2.0547457,236.0225758),(25975,'windfallLgGiraffe_femur-cleaned.tif',247,7,97,971.4670445,174.1912757,134.7683428,1.8,174.1160872,135.1483057,1.3196371,25.2701187,31.0139115,187317.0430193,299326.4730451,151.9106247,9651.3615398,7412.5905537,15691.0183072,0.6894531,8.3021146,1.6539376,17.1180358),(25976,'windfallLgGiraffe_femur-cleaned.tif',247,7,98,965.5917733,174.2489139,134.3821851,1.8,174.1906656,134.734299,1.3094059,25.4200415,30.4808086,188036.8795885,299675.2516814,150.184448,9831.6043981,7397.1901232,15682.6726046,0.6894531,8.9893685,1.6475682,18.496942),(25977,'windfallLgGiraffe_femur-cleaned.tif',247,7,99,967.2870285,174.3346974,134.0504542,1.8,174.3223309,134.3955092,1.2992352,25.6965388,30.9988344,189987.4183332,302785.5665262,149.6150612,9767.6435902,7393.5022845,15892.9182813,0.6894531,4.1937794,1.735945,8.8445987),(25978,'windfallLgGiraffe_femur-cleaned.tif',247,7,100,962.6119328,174.3428509,133.6757347,1.8,174.2266978,133.8372491,1.2908632,25.6953243,31.0684826,192514.4495456,305431.3424354,148.1881836,9830.906334,7492.1977084,16025.3952575,0.6894531,2.8426879,1.815775,6.0867864),(25979,'windfallLgGiraffe_femur-cleaned.tif',247,7,101,964.0180914,174.4155553,133.2537123,1.8,174.3809342,133.5433679,1.2811581,25.8830427,30.8646868,194232.7565456,307306.9948704,147.5637728,9956.5887828,7504.2474321,16216.0514616,50.3494533,61.8397532,2.1093038,256.7348708),(25980,'windfallLgGiraffe_femur-cleaned.tif',247,7,102,968.4465836,174.4170944,132.8629482,1.8,174.3072453,133.1230264,1.2749572,26.054444,31.3696284,196591.4216908,309327.995788,147.6885704,9860.7478559,7545.4084523,16125.2496726,51.0195288,62.592317,2.03937,264.6044357),(25981,'windfallLgGiraffe_femur-cleaned.tif',247,7,103,972.1629216,174.4357048,132.4951011,1.8,174.2833668,132.6570073,1.2727475,26.1241798,31.4627877,199235.8100416,312106.9301316,148.0549683,9919.8752944,7626.4905513,16223.6594234,51.0195288,62.9369096,2.0001437,269.4796052),(25982,'windfallLgGiraffe_femur-cleaned.tif',247,7,104,979.6595533,174.4285776,132.1305372,1.8,174.2967133,132.2210553,1.268317,26.3119788,31.368129,202662.0172463,315422.5575493,148.7878887,10055.5107106,7702.2719803,16464.3678944,51.0108556,62.0431172,1.8292513,230.743534),(25983,'windfallLgGiraffe_femur-cleaned.tif',247,7,105,983.244235,174.4698864,131.6928821,1.8,174.384641,131.8468138,1.2691823,26.4406574,31.5228779,205118.3762487,317687.9532539,149.412865,10078.0123709,7757.6882074,16461.2721381,0.6894531,1.541664,2.0344439,3.328974),(25984,'windfallLgGiraffe_femur-cleaned.tif',247,7,106,984.2061616,174.4610895,131.3634542,1.8,174.4682715,131.5733904,1.2722235,26.4815832,31.6761193,207811.1838877,319109.9321871,149.840786,10074.1485793,7847.3851958,16575.5161001,0.6894531,8.9893685,1.6475682,18.496942),(25985,'windfallLgGiraffe_femur-cleaned.tif',247,7,107,988.5416013,174.4110769,131.0494357,1.8,174.4221746,131.1354912,1.2673919,26.7809094,31.7494102,211398.0226198,321447.6425453,150.0500672,10124.5232792,7893.6088092,16736.545932,0.6894531,7.6152583,1.6614562,15.7391297),(25986,'windfallLgGiraffe_femur-cleaned.tif',247,7,108,991.9712915,174.34224,130.6775448,1.8,174.376701,130.7596702,1.2659587,26.6571072,31.9212392,214157.5197846,324474.3809097,150.4352619,10164.8428652,8033.7869313,16774.9358455,0.6894531,3.5155348,1.7681919,7.4656926),(25987,'windfallLgGiraffe_femur-cleaned.tif',247,7,109,999.1749375,174.4160221,130.283144,1.8,174.5286149,130.6088852,1.2688699,26.8513304,32.1092278,216061.1302539,327371.4716621,151.8041541,10195.5572894,8046.5707814,16894.1755842,52.5787942,64.2783296,1.9672376,297.3517164),(25988,'windfallLgGiraffe_femur-cleaned.tif',247,7,110,998.2907948,174.3649167,129.9353372,1.8,174.3802128,130.2974005,1.2673204,26.7374219,32.2084552,216905.5846013,328599.5795052,151.5231063,10202.2769457,8112.4345379,16936.6278251,52.5801009,64.1524895,1.9333406,273.7143196),(25989,'windfallLgGiraffe_femur-cleaned.tif',247,7,111,998.3596478,174.3299475,129.6004463,1.8,174.2437687,129.8419097,1.2619656,26.5725486,32.2723052,218854.5702984,330557.7130363,151.021449,10242.7673288,8236.1151562,16921.5775275,51.7089819,63.6690426,1.8788491,241.5669028),(25990,'windfallLgGiraffe_femur-cleaned.tif',247,7,112,1006.4111375,174.2570749,129.2938512,1.8,174.2166252,129.5998601,1.2650705,26.5753041,32.645278,220806.7129266,333508.7995015,152.539683,10216.1421265,8308.7181879,16975.8112547,52.3984349,64.6543804,1.9532829,265.2042996),(25991,'windfallLgGiraffe_femur-cleaned.tif',247,7,113,1008.5694944,174.1835897,128.9807173,1.8,174.1195861,129.6015437,1.2728523,26.6137986,32.5660307,221500.8224202,334867.3139746,153.6093719,10282.7181266,8322.7812043,17058.0540338,51.7089819,64.2191414,1.8313987,263.6581041),(25992,'windfallLgGiraffe_femur-cleaned.tif',247,7,114,1000.9285305,174.0516976,128.6444163,1.8,174.0167664,129.1714156,1.2792171,26.4992245,32.7387023,222227.7014456,333673.8982478,153.03593,10192.031914,8386.196424,16940.6652298,52.3984349,64.6543804,1.9532829,272.029537),(25993,'windfallLgGiraffe_femur-cleaned.tif',247,7,115,998.6065394,173.9816306,128.2915679,1.8,173.8833527,128.7657613,1.2845453,26.7878322,32.9536365,224709.9352986,335383.7066743,153.1652853,10177.4414787,8388.5076391,16956.2722674,0.6894531,2.8426879,1.815775,6.0867864),(25994,'windfallLgGiraffe_femur-cleaned.tif',247,7,116,999.4074247,173.9579782,127.9989659,1.8,173.9095436,128.5441226,1.2836231,26.9996778,32.3111606,227179.6004824,338514.5857504,153.2047885,10476.7077228,8414.1596801,17382.1039152,53.087888,64.1339627,2.0392516,273.0045709),(25995,'windfallLgGiraffe_femur-cleaned.tif',247,7,117,1001.2592558,173.9497627,127.5422554,1.8,173.9383905,128.2235723,1.281194,27.0030904,33.0275222,228527.0620138,339903.6933069,153.267617,10291.5287225,8462.9965945,17173.7289128,52.3984349,65.6285469,1.9025133,261.6387427),(25996,'windfallLgGiraffe_femur-cleaned.tif',247,7,118,1005.9653209,173.9719147,127.1445879,1.8,173.9258168,127.7391219,1.2836777,27.1348702,33.2018952,231230.3224673,342231.4674897,154.2150614,10307.5883205,8521.5193991,17255.3122873,53.087888,65.8490869,1.8793026,279.4952296),(25997,'windfallLgGiraffe_femur-cleaned.tif',247,7,119,1008.0585699,173.9506855,126.7438039,1.8,173.9432187,127.3603145,1.2848403,27.3127415,33.1236955,234406.3684315,345007.6071278,154.6418637,10415.7341811,8582.3083279,17451.8349526,0.6894531,1.541664,2.0344439,3.328974),(25998,'windfallLgGiraffe_femur-cleaned.tif',247,7,120,1014.0904171,173.9590548,126.312576,1.8,174.1226648,126.8678871,1.2883051,27.4433262,33.3352825,238743.0714654,348032.162174,155.8824257,10440.3543668,8699.4947105,17582.3638835,0.6894531,2.1802421,1.8925469,4.7078802),(25999,'windfallLgGiraffe_femur-cleaned.tif',247,7,121,1013.7745283,173.9841973,125.7584367,1.8,174.2430404,126.150954,1.2959767,27.8058609,33.3721822,242456.3530562,349632.1656266,156.519437,10476.7546709,8719.6132572,17691.7372345,0.6894531,6.9289178,1.670465,14.3602235),(26000,'windfallLgGiraffe_femur-cleaned.tif',247,7,122,1010.1463453,173.8743082,125.1578123,1.8,174.1084349,125.568467,1.3170496,27.9673045,33.7227178,246497.2130173,350877.7386964,157.7482727,10404.7882617,8813.7636796,17713.4445777,53.7773411,65.8490869,1.8793026,256.5962838),(26001,'windfallLgGiraffe_femur-cleaned.tif',247,7,123,1026.3582218,173.9140722,124.4892045,1.8,174.1278254,124.5005886,1.3470988,28.1961663,34.8195216,251685.8801967,357423.5292379,162.6416062,10265.0327369,8926.2446946,17448.1223832,53.7773411,67.3726562,1.8828384,249.3671741),(26002,'windfallLgGiraffe_femur-cleaned.tif',247,7,124,1034.7068745,173.9765893,123.9260834,1.8,174.274229,123.6176876,1.3660185,28.3887068,34.8838815,257815.3476304,362536.0533745,165.3201064,10392.6523656,9081.6164958,17735.8191695,53.7773411,67.3867656,1.9151967,234.3377932),(26003,'windfallLgGiraffe_femur-cleaned.tif',247,7,125,1039.1026686,174.0693479,123.3484957,1.8,174.3505777,123.2771215,1.3843697,28.622226,34.8609587,261698.03544,367103.8408754,167.234205,10530.5147945,9143.1755067,17934.8815707,55.7680814,67.0898439,1.9608444,286.0551817),(26004,'windfallLgGiraffe_femur-cleaned.tif',247,7,126,1038.6546914,174.1121394,122.8793837,1.8,174.2910815,123.0057217,1.3874459,28.7574705,35.1817297,265609.5294428,372409.1545262,167.354562,10585.2997372,9236.1923583,18118.1669359,0.6894531,6.9289178,1.670465,14.3602235),(26005,'windfallLgGiraffe_femur-cleaned.tif',247,7,127,1038.6773063,174.0650007,122.3874067,1.8,174.327912,122.2777281,1.397027,28.8499627,35.2176616,269727.1378035,379657.7066445,167.9380087,10780.3212686,9349.3063077,18359.2401097,0.6894531,6.2432633,1.6814535,12.9813173),(26006,'windfallLgGiraffe_femur-cleaned.tif',247,7,128,1044.1007111,174.0748306,121.8980799,1.8,174.3911748,121.4981869,1.4149934,29.0236609,35.6347445,275165.4781931,389673.9364264,169.8266759,10935.2246365,9480.7294944,18549.8535971,55.1562473,68.4609909,1.7326338,247.4863998),(26007,'windfallLgGiraffe_femur-cleaned.tif',247,7,129,1057.4815448,174.131515,121.4108257,1.8,174.4165934,121.1580088,1.4288304,29.2370792,35.5651635,281403.7152563,399397.0400562,172.7185878,11230.0071499,9624.891494,18764.5321332,57.1474673,68.8245491,1.762298,273.3104474),(26008,'windfallLgGiraffe_femur-cleaned.tif',247,7,130,1071.4375465,174.0682001,121.1411113,1.8,174.3303599,120.8329281,1.4375397,29.3746505,35.83232,288247.3490335,410704.3240545,175.4206696,11461.8401659,9812.792453,19260.0750963,56.8575168,70.2701198,1.849096,274.2854813),(26009,'windfallLgGiraffe_femur-cleaned.tif',247,7,131,1103.2295222,173.9858847,120.9405213,1.8,173.9743602,120.51387,1.4511715,29.451568,36.1871488,299708.9520648,427607.2750573,181.2528951,11816.550613,10176.3326138,20017.8001521,0.6894531,8.3021146,1.6539376,17.1180358),(26010,'windfallLgGiraffe_femur-cleaned.tif',247,7,132,1138.2892825,174.0638134,120.852183,1.8,174.2858909,120.2796389,1.4523307,29.7834362,36.4250767,311765.7584197,446328.4651717,187.0648319,12253.3294502,10467.7565296,20664.4565209,57.0197738,71.124029,1.7757963,246.3440766),(26011,'windfallLgGiraffe_femur-cleaned.tif',247,7,133,1172.2557481,174.1131898,120.8641032,1.8,174.3262282,120.4306782,1.4565511,30.0560821,35.868587,323585.1642422,463762.0976999,192.8369938,12929.4777417,10766.0460659,21484.5570748,58.3164761,72.2117778,1.7532117,270.552635),(26012,'windfallLgGiraffe_femur-cleaned.tif',247,7,134,1187.479194,174.1132066,120.7566481,1.8,174.291725,119.9690294,1.4639355,30.5707218,37.0123727,334258.2912818,477065.7598094,195.6617703,12889.3590135,10933.9352159,21658.7854724,0.6894531,12.4292924,1.6262948,25.3914729),(26013,'windfallLgGiraffe_femur-cleaned.tif',247,7,135,1208.5959165,174.085665,120.6765072,1.8,174.2555632,119.5147665,1.4621746,30.7951728,38.2916644,347244.9131527,491552.8556486,199.0653464,12837.0720615,11275.9527592,21670.4642658,59.2929659,74.4162337,1.8045395,257.4733219),(26014,'windfallLgGiraffe_femur-cleaned.tif',247,7,136,1225.8146614,174.0733401,120.6118394,1.8,174.2777805,118.9122223,1.4715599,31.2034901,39.7138014,359710.0473864,509205.7450951,202.297097,12821.8837707,11527.8786673,21654.3090358,60.4466396,75.8555078,1.7628443,255.1193818),(26015,'windfallLgGiraffe_femur-cleaned.tif',247,7,137,1236.1038763,174.1780674,120.4539947,1.8,174.3317777,118.4487271,1.4685422,71.1274992,101.3551524,371644.0963789,525749.3637899,203.8707137,5187.1991816,5225.0409565,7247.4239023,0.6894531,2.1802421,1.8925469,4.7078802),(26016,'windfallLgGiraffe_femur-cleaned.tif',247,7,138,1245.941801,174.2493349,120.3429834,1.8,174.355858,117.9354612,1.4703763,64.8759033,103.9290504,386065.7855459,543293.8256849,205.5699476,5227.5453629,5950.8348354,7585.6283781,62.6834106,79.5056308,1.7715932,278.6587827),(26017,'windfallLgGiraffe_femur-cleaned.tif',247,7,139,1253.8041607,174.3456251,120.2276927,1.8,174.4529256,117.2542567,1.4655618,32.9085165,59.4101484,400848.0930818,564579.6213066,206.6617195,9503.0838442,12180.6795114,14670.5079082,62.7402313,81.7692529,1.81782,266.3872141),(26018,'windfallLgGiraffe_femur-cleaned.tif',247,7,140,1266.6154439,174.4174748,120.2035318,1.8,174.4777185,116.5426267,1.4634198,33.8240499,62.0360232,419823.9678534,589131.3718423,208.6779599,9496.6011889,12411.9958801,16156.5365679,63.4296844,84.6540592,1.784165,254.1156455),(26019,'windfallLgGiraffe_femur-cleaned.tif',247,7,141,1285.0715277,174.5124289,119.6898712,1.8,174.3685449,114.7331833,1.4449841,92.7961044,105.517168,439912.711518,652555.348061,210.8062665,6184.3523689,4740.6377053,8636.0350938,64.8085906,88.1233255,1.815775,296.4865672),(26020,'windfallLgGiraffe_femur-cleaned.tif',247,7,142,1373.5990215,174.0254537,116.1063543,1.8,173.6175089,109.8571747,1.4180058,35.6209801,74.4375302,465958.1352001,996675.3949089,223.6302004,13389.4205326,13081.0026397,19645.763476,66.8769499,92.7564269,1.7652764,298.3673415),(26021,'windfallLgGiraffe_femur-cleaned.tif',247,7,143,1461.1841787,173.4683691,113.3439357,1.8,172.8698035,106.0918549,1.3958868,69.9121398,98.607909,501043.7203426,1301192.7942325,236.1559459,13195.623021,7166.7627674,14966.0863916,68.8735495,93.8517625,1.7854812,316.1258325),(26022,'windfallLgGiraffe_femur-cleaned.tif',247,7,144,1543.2413551,173.0372357,111.2056991,1.8,172.3318247,103.4169565,1.3815941,69.9807979,81.7003438,540930.0147716,1575259.9226046,248.1088785,19280.9460707,7729.6920149,19671.8673153,1.3789062,2.4858585,0.9827937,5.2790418),(26023,'windfallLgGiraffe_femur-cleaned.tif',247,7,145,1617.9279383,172.7073519,109.4925111,1.8,171.9800421,101.9344648,1.3717309,105.2143358,79.0365769,584650.0408587,1832023.5930348,259.1094455,23179.4400234,5556.7526627,19411.087578,71.4910109,132.7658248,1.9484098,499.4153946),(26024,'windfallLgGiraffe_femur-cleaned.tif',247,7,146,1675.1481649,172.5461271,108.5583193,1.8,171.911819,101.2341322,1.3668058,65.2353472,90.5574814,628956.1881609,2015193.2193679,267.7338712,22253.1941837,9641.3403929,23691.4325859,73.0820277,135.6559184,1.9182647,493.3979018),(26025,'windfallLgGiraffe_femur-cleaned.tif',247,7,147,1724.5678267,172.467662,108.2437107,1.8,171.7695368,100.9073579,1.36043,104.4937104,80.5383425,681238.1307869,2153468.2018297,274.8946679,26738.422148,6519.4175616,23456.9789052,73.7714808,138.0714811,1.9225537,445.6499424),(26026,'windfallLgGiraffe_femur-cleaned.tif',247,7,148,1760.6197629,172.5604221,108.3243558,1.8,171.7507122,100.6232839,1.3573899,68.4298976,97.3987901,738547.5988983,2255934.6946179,280.2744893,23161.8348934,10792.7620003,25517.472528,75.83984,140.3320755,1.9376174,596.3595131),(26027,'windfallLgGiraffe_femur-cleaned.tif',247,7,149,1802.1584833,172.821635,108.9176555,1.8,171.9346962,101.0507029,1.3540066,43.0266573,82.2837008,808226.149663,2340451.4775794,286.463273,28443.6827023,18784.3118544,38096.6394596,78.6371975,143.0378405,1.9718907,495.1113867),(26028,'windfallLgGiraffe_femur-cleaned.tif',247,7,150,1858.0233988,173.0570472,109.2130488,1.8,172.1873632,101.5122554,1.3505188,44.7803917,82.746439,887881.9557109,2449578.1921889,294.8861372,29603.4273104,19827.4718332,40180.9569177,0.6894531,2.1802421,1.8925469,4.7078802),(26029,'windfallLgGiraffe_femur-cleaned.tif',247,7,151,1915.7699626,173.4358783,110.263245,1.8,172.6881901,102.5995885,1.3310869,80.8450206,95.6800013,981638.6606051,2594048.0547167,301.2968297,27111.7058892,12142.2278539,33224.8219175,86.6955645,151.8801158,2.0831858,497.367331),(26030,'windfallLgGiraffe_femur-cleaned.tif',247,7,152,1995.5498015,173.8791038,111.4897777,1.8,173.0727153,103.9525352,1.3053133,104.0134289,85.168406,1092459.4604336,2782298.0603221,309.6957438,32668.1945768,10503.0616912,31576.5541159,90.6694785,157.5607739,2.0285732,501.059586),(26031,'windfallLgGiraffe_femur-cleaned.tif',247,7,153,2064.8723262,173.8848149,112.5690979,1.8,173.013134,105.0693934,1.3048019,107.7744758,86.5703636,1203746.1736546,2944410.2802279,320.36493,34011.7582725,11169.121118,34263.3712132,93.4099108,157.9434559,2.0032041,530.143314),(26032,'windfallLgGiraffe_femur-cleaned.tif',247,7,154,2164.7370998,173.8744538,113.7214001,1.8,173.2610583,106.7929023,1.3057834,108.6405386,88.4644313,1347820.3112041,3135367.8554186,336.0382792,35442.12977,12406.2373838,37041.6832564,98.2364238,162.2252504,2.0572537,539.766955),(26033,'windfallLgGiraffe_femur-cleaned.tif',247,7,155,2301.8388605,174.6661944,116.1462577,1.8,174.1513914,109.2740504,1.2763204,99.3979585,108.4739486,1558456.9484868,3505994.2301561,351.3226278,32321.0713206,15678.9633523,41734.7048507,102.2413781,174.8779792,2.0591303,532.8437218),(26034,'windfallLgGiraffe_femur-cleaned.tif',247,7,156,2417.6712119,175.5983932,117.7413273,1.8,174.9104327,111.0458228,1.2387572,114.302091,115.2851613,1739704.6551379,3831200.6238151,360.1293093,33232.3829017,15220.2347302,44101.9022984,106.0789822,177.7291858,2.0726198,564.3506834),(26035,'windfallLgGiraffe_femur-cleaned.tif',247,7,157,2508.2102817,176.4160312,120.0441928,1.8,175.3819102,113.5840214,1.2221989,113.8975508,93.8809821,1904585.3387228,4115516.1305705,369.2600426,43837.5913454,16721.9165422,46276.0517136,109.5443337,180.1518632,2.0652561,564.183394),(26036,'windfallLgGiraffe_femur-cleaned.tif',247,7,158,2660.9585458,176.7581566,122.874288,1.8,175.6421175,115.9704413,1.2419501,101.7231431,119.8404879,2116125.363089,4438068.6581617,397.2378587,37033.1324352,20802.7917682,50517.1549367,112.2082688,181.3667916,2.0616481,568.250819),(26037,'windfallLgGiraffe_femur-cleaned.tif',247,7,159,2782.4187005,176.9365429,125.367423,1.8,176.0390062,117.7577323,1.261283,99.3264801,98.6822575,2324085.8513172,4673429.2694755,420.711819,47358.3538619,23398.4517508,60679.7773012,113.8482846,182.5423899,2.0243091,578.837605),(26038,'windfallLgGiraffe_femur-cleaned.tif',247,7,160,2860.7386525,176.9448872,128.0853727,1.8,176.1369774,119.9674979,1.2930295,65.6033255,100.9333352,2521366.4716623,4895842.5832225,440.9397447,48505.7050169,38433.516201,72997.4664094,118.0202517,183.1935377,2.056326,696.8691885),(26039,'windfallLgGiraffe_femur-cleaned.tif',247,7,161,2946.8555681,177.0061106,130.4449265,1.8,176.4671809,121.4803021,1.3232639,65.7783871,104.8650831,2723119.6351648,5088518.5454641,461.6587887,48524.431539,41398.3947786,72072.4298094,120.7490853,183.5616256,2.0680447,694.1806697),(26040,'windfallLgGiraffe_femur-cleaned.tif',247,7,162,3023.8324527,177.1500943,132.0242882,1.8,176.8519511,122.6694797,1.3289652,95.0158156,114.9097148,2886866.2507157,5209894.5325342,475.0687378,45339.0258842,30383.0076292,65227.0916401,123.1393231,183.6910584,2.0848214,730.1589286),(26041,'windfallLgGiraffe_femur-cleaned.tif',247,7,163,3069.6962416,177.5823892,133.0844466,1.8,177.3417945,123.3960453,1.3286533,103.6492127,126.3849894,2998965.398696,5312076.037057,482.2000464,42030.9093811,28933.7981554,60886.315137,122.9657795,183.6198816,2.076436,753.490449),(26042,'windfallLgGiraffe_femur-cleaned.tif',247,7,164,3043.7037699,177.9693878,134.061348,1.8,177.7248987,124.3169707,1.3267087,101.0732881,126.685799,3075694.8316292,5401495.9994648,477.6560758,42636.9493918,30430.3430716,61086.66135,120.8689434,183.2337522,2.0647377,699.529005),(26043,'windfallLgGiraffe_femur-cleaned.tif',247,7,165,3055.5048718,178.2695729,135.0865859,1.8,177.8394102,125.6994764,1.3570592,109.2490502,129.6353911,3217737.7409357,5557425.8693521,486.3385309,42869.6656365,29453.2331034,61220.6706176,122.8793397,182.6829533,2.0749623,703.3598472),(26044,'windfallLgGiraffe_femur-cleaned.tif',247,7,166,3054.646945,178.3184872,136.3720057,1.8,177.7052067,127.1196165,1.4056011,103.0316731,122.4634437,3355785.3062457,5713642.2187154,495.3404732,46655.9002874,32570.4242712,66039.0009528,0.6894531,0.9750339,2.3561945,1.9500678),(26045,'windfallLgGiraffe_femur-cleaned.tif',247,7,167,3076.6881427,178.9689809,137.6670337,1.8,177.5824052,128.5114186,1.4396221,94.9293401,126.0263748,3474801.7706451,5831291.9464729,504.0085799,46270.4093076,36604.0864222,64247.5835591,126.9592325,181.6247675,2.0480254,728.0821626),(26046,'windfallLgGiraffe_femur-cleaned.tif',247,7,168,3115.4240528,179.5865265,138.6775968,1.8,177.8623914,129.4419637,1.4699606,93.0401592,124.5069131,3543506.4110447,5857501.1083245,513.9756884,47045.5893702,38085.7733116,65319.9754193,128.1595968,179.5015983,2.0584943,721.5628016),(26047,'windfallLgGiraffe_femur-cleaned.tif',247,7,169,3167.0926753,180.0554255,139.393698,1.8,178.2488676,130.4374278,1.5061353,79.8149327,124.1268245,3618646.1244319,5825753.6758002,525.6448934,46933.881539,45337.958741,63998.0060542,129.5958303,177.8334627,2.1125456,754.3100824),(26048,'windfallLgGiraffe_femur-cleaned.tif',247,7,170,3217.0009347,180.1182107,139.910707,1.8,178.5497368,131.2173265,1.5495943,82.2276343,118.9846911,3718437.0881365,5735384.5168736,535.925838,48202.7096246,45221.2582945,67416.7369601,0.6894531,1.541664,2.0344439,3.328974),(26049,'windfallLgGiraffe_femur-cleaned.tif',247,7,171,3229.0459033,180.2989125,140.136639,1.8,178.8108843,131.7202183,-1.5479691,92.9165661,118.2556689,3756842.4010489,5567393.458325,537.8939308,47079.294453,40432.4283469,66265.0052661,130.127196,174.4043789,2.1105379,721.8567892),(26050,'windfallLgGiraffe_femur-cleaned.tif',247,7,172,3247.8831278,180.3860644,140.2439525,1.8,178.8518419,132.2148286,-1.4863819,99.5951166,118.8281207,3782535.2325195,5414640.6729202,537.4657175,45566.9974625,37979.1235105,62355.4870673,130.6712229,172.0610274,2.0954096,698.790554),(26051,'windfallLgGiraffe_femur-cleaned.tif',247,7,173,3268.3856463,180.5010186,140.2268739,1.8,178.9373415,132.9477418,-1.4098298,104.2737538,121.8801786,3749107.1106561,5256140.4345635,530.7383142,43125.4736963,35954.4657651,65964.340848,131.4824329,169.8085314,2.1509162,708.777476),(26052,'windfallLgGiraffe_femur-cleaned.tif',247,7,174,3239.3620544,180.586256,139.9230433,1.8,178.8246858,133.6067947,-1.3402065,71.7354155,128.3798011,3644117.2673395,5061198.1139222,511.6918265,39423.6326282,50799.4167593,65131.0581231,132.1238202,166.9629919,2.1771245,713.5833521),(26053,'windfallLgGiraffe_femur-cleaned.tif',247,7,175,3170.840559,180.2997197,139.6765003,1.8,178.3096214,134.1773512,-1.2533401,98.1973744,137.0316509,3525827.8953207,4842306.5783934,476.9799327,35337.1395972,35905.5210846,58839.5732588,132.1435931,164.2360621,2.1133757,683.7898754),(26054,'windfallLgGiraffe_femur-cleaned.tif',247,7,176,3056.7710195,179.621011,139.4056606,1.8,177.2615975,134.8905799,-1.1519497,75.7859107,109.0234278,3381870.3584052,4608912.4865181,425.1914246,42274.5145831,44623.9984078,70656.5381388,132.5502389,161.0208802,2.1457355,673.9702427),(26055,'windfallLgGiraffe_femur-cleaned.tif',247,7,177,2856.5665589,178.6659426,139.2167566,1.8,176.4299957,135.5370246,-1.0765364,76.7567565,116.6380848,3180262.5431297,4210483.9056585,368.9557412,36098.7057637,41432.9980487,61829.4210411,133.1660602,158.6116769,0.9055595,675.4471448),(26056,'windfallLgGiraffe_femur-cleaned.tif',247,7,178,2627.9544389,177.7906864,139.0566833,1.8,175.0863849,136.6009069,-0.9672749,77.6756302,79.4425977,2949973.9907196,3817959.0313417,296.9116942,48059.3427689,37978.1146933,81874.6214393,132.7240193,154.7403701,0.9085808,714.5177948),(26057,'windfallLgGiraffe_femur-cleaned.tif',247,7,179,2454.9665368,177.5534989,139.0659706,1.8,174.3300957,137.6714459,-0.835881,131.4376392,80.7278196,2710772.4549139,3459952.0228877,225.2010759,42859.4757215,20624.0196556,45867.6855299,132.2567707,153.1594865,0.8714471,722.0814832),(26058,'windfallLgGiraffe_femur-cleaned.tif',247,7,180,2269.8786413,177.396343,139.2341375,1.8,173.7755599,138.7277575,-0.6776428,104.6028879,99.5938335,2417744.0988475,3106146.0335813,148.706128,31188.1360952,23113.5501734,46794.0378327,127.4657752,150.0174516,0.8536957,700.2268648),(26059,'windfallLgGiraffe_femur-cleaned.tif',247,7,181,2048.3660235,177.4674205,139.969442,1.8,173.6751522,140.0098572,-0.5360627,68.991892,78.9695509,2027719.2448835,2767865.3942477,89.0597641,35049.7800855,29390.6890588,60689.0528864,121.223568,145.6313602,0.9433923,700.5614436),(26060,'windfallLgGiraffe_femur-cleaned.tif',247,7,182,1797.6841851,177.6261179,141.4047944,1.8,173.7069098,141.963751,-0.4333051,65.3471813,76.1644693,1588818.454904,2455262.1948905,52.8198926,32236.3198597,24313.4963811,53048.0616281,53.3395032,79.8873554,1.1341692,237.8053542),(26061,'windfallLgGiraffe_femur-cleaned.tif',247,7,183,1511.4718503,177.6756713,144.0503977,1.8,173.8467417,144.2231525,-0.3491498,60.6192432,72.0441644,1105747.0233232,2133115.5504601,29.4816925,29608.443212,18240.8582622,44587.1763684,49.3540917,73.1112911,1.2042995,208.6523327),(26062,'windfallLgGiraffe_femur-cleaned.tif',247,7,184,1177.5169592,178.1204397,148.8461275,1.8,174.5208359,149.1668174,-0.3149542,54.6915414,68.9217546,590071.134922,1807719.3087378,18.8322814,26228.5735177,10789.0748722,34781.1973476,45.823778,62.6037074,1.2803944,185.1129318),(26063,'windfallLgGiraffe_femur-cleaned.tif',247,7,185,878.3183276,176.294929,150.6737933,1.8,174.0778525,151.0726997,-0.2842767,50.4459454,63.5429632,350900.6016253,1393382.3951811,11.5147,21928.1935509,6955.9723604,27069.1314252,40.9705741,57.2079908,1.3521274,178.2184008),(26064,'windfallLgGiraffe_femur-cleaned.tif',247,7,186,539.1594109,169.2077034,155.0754319,1.8,169.4462509,154.0358296,-0.2262733,49.4925606,61.5169955,146924.6269943,888774.4770321,4.5228072,14447.6249164,2968.6204374,15794.2970872,34.4726546,51.3816044,1.3681377,147.5191838),(26065,'windfallLgGiraffe_femur-cleaned.tif',247,7,187,223.5142548,146.3254445,163.2534121,1.8,152.5840509,161.9277852,-0.1505201,35.9999003,81.226498,13316.8147318,185043.395614,0.8376467,2278.1161344,369.912545,2441.744967,26.9552039,36.3845764,1.3994172,106.3598789),(26066,'windfallLgGiraffe_femur-cleaned.tif',247,7,188,61.4493616,135.6437434,165.27182,1.8,135.7813123,165.1710487,-0.7885615,9.0019704,11.6864934,961.8956113,1425.311407,5.1531773,121.9622821,106.853896,197.0444403,18.4190595,23.4819261,0.7022569,69.9084542),(26067,'windfallLgGiraffe_femur-cleaned.tif',247,7,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26068,'windfallLgGiraffe_femur-cleaned.tif',247,7,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26069,'windfallLgGiraffe_femur-cleaned.tif',247,7,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26070,'windfallLgGiraffe_femur-cleaned.tif',247,7,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26071,'windfallLgGiraffe_tibia-cleaned.tif',247,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26072,'windfallLgGiraffe_tibia-cleaned.tif',247,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26073,'windfallLgGiraffe_tibia-cleaned.tif',247,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26074,'windfallLgGiraffe_tibia-cleaned.tif',247,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26075,'windfallLgGiraffe_tibia-cleaned.tif',247,8,5,14.4183669,110.8388427,108.5711594,1.8,110.6574355,109.0157779,-1.1080554,2.5970152,10.6054249,14.6214816,250.0742508,1.9241907,23.5798427,5.63011,24.891969,5.3887435,20.3637455,1.0891326,45.4086624),(26076,'windfallLgGiraffe_tibia-cleaned.tif',247,8,6,82.5747355,110.781782,109.992158,1.8,110.9314274,110.100457,-1.1108437,4.8898475,13.6203079,318.6626211,3127.1015203,11.0505333,229.5911034,65.1682125,252.8870599,9.7111213,27.6999659,1.0939045,63.5138295),(26077,'windfallLgGiraffe_tibia-cleaned.tif',247,8,7,153.3478659,111.1980058,110.5124248,1.8,111.4532885,110.5906332,-1.12532,7.0235072,15.4456254,1290.9929005,7841.390816,20.8127746,507.6771328,183.8102896,589.7468581,13.5597646,31.4432221,1.0370881,75.6777699),(26078,'windfallLgGiraffe_tibia-cleaned.tif',247,8,8,230.0036252,111.6356619,110.6051606,1.8,111.7235143,110.5634044,-1.1343609,9.4482946,17.3875281,3885.8283235,15301.1958371,31.4842294,880.0098412,411.2729833,1090.6993988,18.7817424,34.5822667,0.9795043,92.5403948),(26079,'windfallLgGiraffe_tibia-cleaned.tif',247,8,9,377.9296032,108.6973124,112.389082,1.8,106.918485,113.3191537,-0.7307466,18.101465,30.9820419,14684.1893918,57479.7759974,28.0585742,1855.2610659,811.2155231,2313.0668895,31.1722777,53.8305495,0.7044941,168.4996513),(26080,'windfallLgGiraffe_tibia-cleaned.tif',247,8,10,592.7460083,105.8635857,113.4550538,1.8,105.0311189,113.8040306,-0.6643933,21.0356469,31.2795585,36101.7872919,125875.8771228,37.5576591,4024.2216648,1716.2194923,5166.2186065,37.997834,58.4209771,0.6659692,246.7720285),(26081,'windfallLgGiraffe_tibia-cleaned.tif',247,8,11,765.5688703,105.2386498,113.3417732,1.8,104.693001,113.3815948,-0.620781,26.2338976,34.0600414,74909.3432618,200724.4280303,43.1705209,5893.2526099,2855.4408602,8064.5122556,46.437616,64.5732166,0.5404195,247.3108541),(26082,'windfallLgGiraffe_tibia-cleaned.tif',247,8,12,1214.2921991,115.8502293,112.544698,1.8,121.202495,112.5210675,-0.1703551,32.8363593,56.2779507,192053.8701586,829262.7863198,5.8167063,14735.127632,5848.817408,17039.8977774,61.5097815,104.0091553,0.1904351,424.1231507),(26083,'windfallLgGiraffe_tibia-cleaned.tif',247,8,13,1820.3614607,123.688363,114.0269748,1.8,123.6440325,114.0928779,-0.0919242,41.3914104,57.6411132,386951.424353,1522648.0493941,2.5564838,26416.0070011,9348.5923891,32966.6398878,67.9386817,107.6282801,2.9382181,484.6130702),(26084,'windfallLgGiraffe_tibia-cleaned.tif',247,8,14,1999.1223648,122.9233772,116.4296136,1.8,123.4019793,116.0902642,-0.0637624,43.6604944,60.1902136,599500.0524765,1830332.3751704,1.3527854,30409.1357115,13730.9497073,39785.3477512,77.3932574,111.8907103,2.8592648,474.3783138),(26085,'windfallLgGiraffe_tibia-cleaned.tif',247,8,15,2117.4454068,120.1664594,118.3751831,1.8,121.1850526,117.3387988,-0.0574561,45.7971495,62.7734098,809267.6849718,2141933.9785699,1.1637384,34121.6764627,17670.6999162,46039.2090788,83.8929871,117.7840987,0.3371678,466.2747119),(26086,'windfallLgGiraffe_tibia-cleaned.tif',247,8,16,2264.3579383,115.5942315,119.309128,1.8,117.5086293,118.0432527,-0.0465043,47.0055426,64.6768028,996747.7439909,2558678.4408817,0.8155804,39560.9913935,21204.8981702,54731.7179897,88.022587,122.7600767,2.9055279,460.0519984),(26087,'windfallLgGiraffe_tibia-cleaned.tif',247,8,17,2424.4253931,112.4268564,120.4709977,1.8,114.2582297,118.7939127,-0.0680175,50.8980803,67.4127388,1145503.2847319,2997751.5737288,1.8665056,44468.6216096,22505.8249468,61456.9234808,90.2642847,128.7302285,2.9654439,490.6438153),(26088,'windfallLgGiraffe_tibia-cleaned.tif',247,8,18,2676.7695496,111.5671538,121.3413711,1.8,111.0140799,119.5813222,-0.0819607,50.7470448,90.8685674,1271068.7041497,3594835.4938821,2.9901826,39560.8250236,25047.1472435,48187.0183148,92.1831642,134.3873263,2.9729317,507.6542563),(26089,'windfallLgGiraffe_tibia-cleaned.tif',247,8,19,2836.1863696,108.4589232,122.0662524,1.8,107.2633311,120.3969729,-0.0936838,55.3443409,78.4458218,1387435.5287425,3991580.7942015,4.1365741,50883.2810043,25069.1489912,68266.8854066,93.8852831,142.7543654,0.252644,513.4547398),(26090,'windfallLgGiraffe_tibia-cleaned.tif',247,8,20,2905.0072901,106.3944999,121.560451,1.8,105.1070928,120.3374468,-0.1177252,57.7048402,77.95105,1549723.5756988,4047633.7455423,6.6792435,51925.3267827,26856.0413796,71627.0341273,94.5524809,143.894085,0.271252,476.7468026),(26091,'windfallLgGiraffe_tibia-cleaned.tif',247,8,21,2889.7483437,105.2350212,120.7846111,1.8,103.6042586,120.1923087,-0.1604475,58.5024012,77.3628165,1613556.8255893,4011134.2586938,12.2926314,51848.3483119,27581.0358519,72096.0404933,93.0625228,143.882978,0.346092,510.993803),(26092,'windfallLgGiraffe_tibia-cleaned.tif',247,8,22,2895.3737366,104.1989367,120.1522129,1.8,102.7795004,119.9321428,-0.1938343,58.7196411,76.7352602,1624726.5970264,4003388.1167122,17.904783,52171.4282143,27669.2187845,70661.4549098,92.6275827,143.834448,0.2802581,476.3828704),(26093,'windfallLgGiraffe_tibia-cleaned.tif',247,8,23,2971.1161195,102.3644903,119.203524,1.8,102.2460237,119.1046728,-0.2315579,58.1453539,80.6648126,1707331.3207406,3969355.9644968,26.0802257,49208.0231573,29363.1598541,68068.6992277,104.2679366,141.9857181,0.2659987,492.9127836),(26094,'windfallLgGiraffe_tibia-cleaned.tif',247,8,24,2923.6508827,101.4120938,117.9273953,1.8,101.6359636,118.5321266,-0.2567868,57.189395,73.7322388,1722421.1419418,3815162.0333178,31.4306207,51743.471995,30117.8416441,73563.7352724,104.971918,140.0843786,0.3968181,549.4760353),(26095,'windfallLgGiraffe_tibia-cleaned.tif',247,8,25,2869.6031884,101.1890125,116.5999666,1.8,101.1649441,117.6253137,-0.3009256,56.0376189,73.1312875,1727589.5816689,3626769.1260503,42.0184166,49592.5786135,30829.1040244,68205.8174711,104.5161714,137.991174,0.4357293,503.9437046),(26096,'windfallLgGiraffe_tibia-cleaned.tif',247,8,26,2727.1847926,101.8855568,115.4909008,1.8,101.0670117,116.512556,-0.3511802,54.5175664,74.0581009,1628298.4062714,3375340.3710707,53.789285,45576.9230983,29867.4081222,65244.5354509,102.0109596,136.1180815,0.4488239,501.1088333),(26097,'windfallLgGiraffe_tibia-cleaned.tif',247,8,27,2633.932725,103.2716182,114.1438477,1.8,101.908955,115.3569763,-0.3997478,52.7372183,75.1629763,1549865.0003544,3151925.8641287,66.491791,41934.5536596,29388.4480281,60118.8332459,99.9534203,133.9509864,0.5225643,479.3826328),(26098,'windfallLgGiraffe_tibia-cleaned.tif',247,8,28,2499.5963104,104.6311035,113.1461349,1.8,103.0484634,114.3587336,-0.4386435,51.9560747,75.6786197,1464876.37178,2841706.3403923,75.1462244,37549.6587119,28194.5158667,54638.414557,98.1314552,132.8456359,0.7176682,478.5623205),(26099,'windfallLgGiraffe_tibia-cleaned.tif',247,8,29,2409.009179,105.6954084,112.1237204,1.8,104.1481503,113.3177122,-0.4851185,51.2460564,75.3276597,1411441.1749056,2616908.1102787,87.3057024,34740.3347128,27542.434927,51372.0686532,96.878012,131.5175694,0.9092061,546.0781907),(26100,'windfallLgGiraffe_tibia-cleaned.tif',247,8,30,2296.3646491,106.2908113,111.5293109,1.8,104.7633072,112.4333938,-0.5131523,57.8583157,73.9910659,1358886.2465884,2412111.6724018,92.2404808,32600.0395179,23486.4466935,49395.480987,96.1887805,129.9418354,0.9355021,513.3069237),(26101,'windfallLgGiraffe_tibia-cleaned.tif',247,8,31,2244.1312688,107.050471,110.5782577,1.8,105.5296504,111.4412088,-0.5629505,49.9306798,73.7466698,1326047.1663772,2319576.4929508,106.5282865,31453.3049486,26557.7631014,48634.5598591,95.4802247,127.8055953,0.9311463,490.1049897),(26102,'windfallLgGiraffe_tibia-cleaned.tif',247,8,32,2196.2282822,107.9338421,109.6651234,1.8,107.0118718,110.2234483,-0.630016,49.8607549,72.8772449,1296830.8542879,2200664.6139981,127.054276,30196.8689704,26009.0497236,47706.9069762,94.7969213,123.5162535,0.8794594,608.1675119),(26103,'windfallLgGiraffe_tibia-cleaned.tif',247,8,33,2136.4092954,109.1618579,108.2670832,1.8,108.4707867,109.0621621,-0.7178538,50.7337141,73.1180031,1270538.417305,2015722.3355217,154.0567893,27568.07148,25043.2762629,43946.8618508,93.8110182,123.7040655,0.931274,589.9628242),(26104,'windfallLgGiraffe_tibia-cleaned.tif',247,8,34,2052.0161676,111.1193424,106.4296238,1.8,110.4445168,107.3034481,-0.8530173,51.3355118,73.5566389,1241315.1610348,1731192.0918594,194.0568474,23535.4975264,24180.4380152,40278.6319697,0.4101561,0.917137,2.0344439,1.9804089),(26105,'windfallLgGiraffe_tibia-cleaned.tif',247,8,35,2006.0081425,112.1771821,105.3800923,1.8,111.7247367,106.2021482,-0.9891783,51.0452754,58.7164227,1201058.8975839,1612587.4523358,233.4275772,27463.9935087,23529.2862471,44981.0513791,90.0543061,108.9634374,0.9054613,459.5714706),(26106,'windfallLgGiraffe_tibia-cleaned.tif',247,8,36,1976.3610594,113.0541202,104.7495279,1.8,112.6937568,105.575517,-1.0939256,50.0051386,54.8004185,1157070.5118573,1552129.2196099,259.9961809,28323.3096149,23139.0321965,44501.996214,88.7375074,106.3372758,0.9056936,519.9447945),(26107,'windfallLgGiraffe_tibia-cleaned.tif',247,8,37,1950.3854769,113.7715316,104.2583192,1.8,113.4544783,105.0572216,-1.1868773,48.8040084,50.2709766,1112920.9915172,1495273.2951642,279.4600141,29744.2659317,22803.8849449,44443.7011606,0.8203122,1.1600967,2.3561945,2.3201934),(26108,'windfallLgGiraffe_tibia-cleaned.tif',247,8,38,1917.4679386,114.3081635,104.2227575,1.8,114.050426,104.9996239,-1.2581963,47.2423048,69.4198663,1069477.007308,1438771.7595724,289.3532635,20725.6486796,22638.1209022,33012.4405243,0.4101561,0.5800484,2.3561945,1.1600967),(26109,'windfallLgGiraffe_tibia-cleaned.tif',247,8,39,1872.8082868,114.8076267,104.6314448,1.8,114.5409971,105.1093778,-1.2959789,46.442401,65.3340039,1024417.8087683,1357760.0196696,289.148392,20781.8278263,22057.8132804,31112.5248615,84.4218345,97.7824582,1.0433257,490.5855175),(26110,'windfallLgGiraffe_tibia-cleaned.tif',247,8,40,1827.9197938,115.4549455,105.4062663,1.8,115.1618496,105.3872706,-1.2850337,66.6248875,89.6873933,982923.2785116,1269044.9148771,280.4450827,14149.6465468,14753.094768,20156.165406,82.940213,95.8502475,1.0612041,469.024208),(26111,'windfallLgGiraffe_tibia-cleaned.tif',247,8,41,1758.9344177,116.13486,106.9790608,1.8,115.8069479,105.9951601,-1.1463733,44.6745055,49.210785,933444.3366053,1126457.7865876,243.4438073,22890.4656932,20894.3406756,37045.0303302,81.5659388,95.0368111,2.1001134,411.5682009),(26112,'windfallLgGiraffe_tibia-cleaned.tif',247,8,42,1660.9548363,117.0221363,109.7932879,1.8,116.5299503,107.3694916,-0.5617087,54.2889018,48.9881647,795997.8083703,988126.016606,78.5349332,20170.7090557,14662.256588,31020.1684719,79.7741892,93.7572397,2.057923,454.2585876),(26113,'windfallLgGiraffe_tibia-cleaned.tif',247,8,43,1609.1563509,117.8612205,111.366022,1.8,117.2672676,109.3323601,-0.401716,46.2896148,47.9815485,670014.9657541,949379.448934,41.0012218,19786.3445243,14474.4121968,33630.0238775,74.2382581,87.2023168,0.6519675,366.259059),(26114,'windfallLgGiraffe_tibia-cleaned.tif',247,8,44,1606.9588848,118.4009121,111.4267484,1.8,117.6910752,109.4045364,-0.4214365,67.0962807,52.7702253,668007.8915014,922482.4701187,44.8179863,17481.1167687,9955.960069,22319.0488274,72.9663594,86.1327856,0.6435011,351.9156687),(26115,'windfallLgGiraffe_tibia-cleaned.tif',247,8,45,1620.8772066,118.9741679,111.3671839,1.8,118.0766467,109.3095822,-0.4452142,45.7528755,46.5736597,675645.4256944,897018.9948464,50.1014456,19260.221353,14767.2778688,33720.0411919,74.0001953,85.205924,0.4162693,392.8488353),(26116,'windfallLgGiraffe_tibia-cleaned.tif',247,8,46,1626.5707063,119.4132046,111.207971,1.8,118.4768997,108.9541913,-0.5031264,45.3936166,45.9340625,689666.7314125,877646.1909228,63.0255149,19106.652946,15193.0333497,33974.0107799,75.027389,83.8164848,0.7022569,356.5560555),(26117,'windfallLgGiraffe_tibia-cleaned.tif',247,8,47,1640.0826299,119.88161,110.6688524,1.8,118.8099281,108.3221379,-0.657881,43.473284,44.791839,717475.7686298,866739.3854434,102.1937371,19350.3862394,16503.8318499,34621.2831035,0.4101561,0.5800484,2.3561945,1.1600967),(26118,'windfallLgGiraffe_tibia-cleaned.tif',247,8,48,1641.5630367,120.2566553,110.3447021,1.8,119.1862217,107.9866864,-0.8458419,41.2923612,43.3465341,731092.2622046,865879.2822856,153.2937023,19975.7443397,17705.2665705,34911.8982424,74.5015539,81.8186933,0.6966638,311.9677053),(26119,'windfallLgGiraffe_tibia-cleaned.tif',247,8,49,1616.0895384,120.546064,110.299928,1.8,119.5783805,107.8336596,-0.9571373,40.04242,41.4644465,718175.35627,853816.2106178,180.0275681,20591.5255675,17935.3634365,34284.6085304,0.4101561,0.5800484,2.3561945,1.1600967),(26120,'windfallLgGiraffe_tibia-cleaned.tif',247,8,50,1576.5318863,120.7656822,110.6047562,1.8,119.8018267,107.8171369,-1.0040574,40.3135716,40.604022,699414.5920933,832534.8081762,187.0176415,20503.7522556,17349.3581516,33427.1563699,73.6625856,81.4570471,2.1043075,352.935022),(26121,'windfallLgGiraffe_tibia-cleaned.tif',247,8,51,1553.6078075,121.0878721,110.8849821,1.8,120.054739,107.9787456,-1.0347859,40.0302262,40.5387298,680948.1808826,809441.5101344,191.3980862,19967.1157446,17010.8502061,32406.0440538,73.0745799,81.3144209,2.1112158,329.4103786),(26122,'windfallLgGiraffe_tibia-cleaned.tif',247,8,52,1540.6753531,121.4035582,111.1299218,1.8,120.5483118,108.0739448,-1.0535587,40.0512199,39.6124947,664129.7773086,791251.9597192,193.9937663,19974.8076117,16582.0112081,32113.6964413,73.1016654,80.7518139,2.1094737,324.0079773),(26123,'windfallLgGiraffe_tibia-cleaned.tif',247,8,53,1517.3796433,121.8437903,111.4418375,1.8,121.0492518,108.5438695,-1.0538279,38.801266,39.3257055,643663.912131,766657.9378086,191.1190027,19495.0841467,16588.7348044,31692.5191409,71.8141297,79.9225803,2.0918521,313.8656687),(26124,'windfallLgGiraffe_tibia-cleaned.tif',247,8,54,1492.8908908,122.2374969,112.2295153,1.8,121.6496388,109.2499571,-1.0185892,39.0323943,49.7143551,624398.0569136,737543.7953059,180.3484025,14835.630355,15996.9191688,27281.3160085,70.6803203,78.9590484,2.0809221,303.4830962),(26125,'windfallLgGiraffe_tibia-cleaned.tif',247,8,55,1472.113198,122.628554,113.0154091,1.8,121.8708858,110.2709018,-0.953379,38.6019459,39.8792602,606726.2169274,708712.5874096,163.1196292,17771.4577607,15717.5034378,29943.647403,70.7304854,77.8432666,2.0768713,308.7447541),(26126,'windfallLgGiraffe_tibia-cleaned.tif',247,8,56,1450.4306422,123.0018823,113.6649787,1.8,122.4154117,111.1466692,-0.8784916,37.7649472,40.0816526,586509.6096437,684817.4256161,143.2436763,17085.5586545,15530.5290589,29281.1160083,69.2307469,76.8875914,2.0058121,278.3590511),(26127,'windfallLgGiraffe_tibia-cleaned.tif',247,8,57,1435.1990202,123.4035095,114.3588438,1.8,122.6795625,112.1047926,-0.8172372,37.730501,40.3791155,567416.9237874,664016.6389704,127.2106742,16444.5563186,15038.6798188,28886.930955,69.5959685,75.402939,2.0149817,291.7001631),(26128,'windfallLgGiraffe_tibia-cleaned.tif',247,8,58,1417.1728245,123.7351865,114.9923505,1.8,123.1483845,112.9124574,-0.7529207,36.1874243,40.4802963,548953.9255877,646392.3749592,110.4321106,15968.0742193,15169.7429653,28567.0179541,68.1805708,74.8284854,0.2210471,274.7963154),(26129,'windfallLgGiraffe_tibia-cleaned.tif',247,8,59,1392.6283528,124.0354843,115.5162478,1.8,123.399788,113.6652477,-0.6935,54.9353055,59.6142993,526859.8835041,628450.8358075,94.8422534,10541.9478749,9590.5516198,19347.5633137,67.5163802,74.519848,0.2276239,279.3371817),(26130,'windfallLgGiraffe_tibia-cleaned.tif',247,8,60,1371.1486393,124.2703512,115.9756396,1.8,123.7502191,114.1006296,-0.6397113,37.1220576,40.6021848,506330.3884563,614674.5458268,81.4384229,15138.9524523,13639.6099992,27254.7741218,66.6950818,74.1668429,0.2060721,264.6952296),(26131,'windfallLgGiraffe_tibia-cleaned.tif',247,8,61,1360.1136443,124.5880016,116.6072531,1.8,123.9150065,114.9325928,-0.5945388,35.7999387,40.3170755,488628.7737759,600223.89272,71.1207847,14887.5851135,13648.8718116,26830.6255944,66.3276894,73.7654126,0.2072099,291.7996837),(26132,'windfallLgGiraffe_tibia-cleaned.tif',247,8,62,1347.8258091,124.8525862,117.1848612,1.8,124.1751818,115.7217161,-0.5523275,36.7981359,39.7817668,472529.0721711,586157.1324962,61.8379469,14734.3162426,12841.1143666,26344.0944819,65.7133556,73.3709576,0.1798535,272.8159065),(26133,'windfallLgGiraffe_tibia-cleaned.tif',247,8,63,1336.8605013,125.1875843,117.7007434,1.8,124.525213,116.3959846,-0.5130377,35.4396759,39.6956003,456849.5153058,571986.9782137,53.6772484,14409.3293608,12890.9055649,25670.3932562,65.1747955,73.0423452,0.1863828,301.9832151),(26134,'windfallLgGiraffe_tibia-cleaned.tif',247,8,64,1331.2256264,125.4045379,118.3182432,1.8,124.8986157,117.1009859,-0.487086,42.9281272,39.9477792,442952.2699553,561278.2820414,48.6060279,14050.2999904,10318.4624767,23348.4414957,64.5676721,72.7561931,0.1642219,281.5990773),(26135,'windfallLgGiraffe_tibia-cleaned.tif',247,8,65,1322.5789089,125.6007632,118.9070318,1.8,125.0507219,117.8113743,-0.4633275,34.1282476,39.537753,427055.4329295,551038.8308546,44.0295238,13937.0295278,12513.2540786,24711.8091916,63.8850404,72.3515864,0.1651487,324.8282896),(26136,'windfallLgGiraffe_tibia-cleaned.tif',247,8,66,1314.2258767,125.8105497,119.4809175,1.8,125.3701601,118.5391735,-0.4410046,33.5211312,38.6796381,413444.4713834,541440.4978509,39.9085213,13998.0755791,12333.8460414,23797.8434958,63.358806,72.015987,0.1717029,257.8924677),(26137,'windfallLgGiraffe_tibia-cleaned.tif',247,8,67,1306.1939562,126.086657,120.0608567,1.8,125.5822572,119.3476921,-0.4201262,33.0938356,38.3818268,400547.0486447,529691.8277493,36.2169578,13800.5892735,12103.3733619,24088.4765505,62.7870972,71.5813507,0.1321729,268.333338),(26138,'windfallLgGiraffe_tibia-cleaned.tif',247,8,68,1295.0686788,126.3063941,120.6328861,1.8,125.9349034,120.0065412,-0.3932647,32.6722026,38.5798349,388367.136992,519035.0555877,31.6961072,13453.5323235,11886.7754753,23520.0764303,62.0290829,71.1747926,0.1329323,262.433334),(26139,'windfallLgGiraffe_tibia-cleaned.tif',247,8,69,1282.380206,126.567022,121.1549025,1.8,126.1894061,120.5700542,-0.3743566,33.8766467,37.930667,375274.8753024,508692.7689396,28.5794004,13411.1210985,11077.6866047,21461.6242922,0.9104271,2.6262806,0.8960554,5.460699),(26140,'windfallLgGiraffe_tibia-cleaned.tif',247,8,70,1272.6187482,126.710693,121.6522407,1.8,126.3255222,121.1392292,-0.3609531,31.6936198,37.4214032,362970.2818446,501613.5089934,26.4548275,13404.4548335,11452.4716336,22984.699168,60.2784634,70.3618015,0.1344776,268.9133864),(26141,'windfallLgGiraffe_tibia-cleaned.tif',247,8,71,1270.7246534,126.8492508,122.2191695,1.8,126.3333549,121.7552377,-0.349336,31.2140268,64.0359373,351319.6298755,496103.1676264,24.8112187,7747.2617462,11255.1844608,12510.7622823,59.4345043,69.9553701,0.1352637,265.6733602),(26142,'windfallLgGiraffe_tibia-cleaned.tif',247,8,72,1269.5375241,127.0097607,122.7567204,1.8,126.6458763,122.3120023,-0.3417096,30.7767755,36.8517901,341718.9336906,490692.2750964,23.759591,13315.2900821,11103.1428037,22531.3283336,58.6474215,69.605802,0.1418971,258.8123005),(26143,'windfallLgGiraffe_tibia-cleaned.tif',247,8,73,1278.8373234,127.1772858,123.2541049,1.8,126.6601312,122.9362972,-0.3389104,30.6918701,36.4979701,332939.6425648,487210.7901573,23.5581972,13348.9832296,10847.8121956,22354.4651084,57.8343091,69.1997925,0.1427353,273.2722865),(26144,'windfallLgGiraffe_tibia-cleaned.tif',247,8,74,1292.0907365,127.250818,123.7055859,1.8,126.8172631,123.5538884,-0.3373092,29.9057386,40.4044911,325169.0178206,485907.796121,23.5865462,12026.0838145,10873.1311312,18084.0458973,57.1021337,68.8537182,0.149479,260.0719178),(26145,'windfallLgGiraffe_tibia-cleaned.tif',247,8,75,1315.6060604,127.2071301,124.1969615,1.8,126.7210291,124.1485566,-0.3308947,29.4951121,40.0778165,317526.5436797,485988.0923169,23.144378,12126.1120055,10765.395393,18067.5161046,56.4258157,68.5108069,0.1562906,281.0119562),(26146,'windfallLgGiraffe_tibia-cleaned.tif',247,8,76,1309.8118277,127.4110992,124.6216378,1.8,126.9978995,124.7239706,-0.3249834,29.8183627,35.8133681,309177.3104717,480098.1932418,22.2554599,13405.5582979,10368.6883626,22021.268282,55.7765661,68.2746723,0.1325515,243.1680701),(26147,'windfallLgGiraffe_tibia-cleaned.tif',247,8,77,1288.9649575,127.7696765,124.9741989,1.8,127.3470404,125.0364412,-0.3134961,29.2830817,35.5532416,300154.5209141,471563.2715847,20.4305319,13263.5802225,10250.1001792,21389.7906623,54.9609203,67.9820626,0.14531,225.6258763),(26148,'windfallLgGiraffe_tibia-cleaned.tif',247,8,78,1280.7440608,127.9792028,125.3898602,1.8,127.7374253,125.4503482,-0.3076581,28.5467801,36.3954278,292434.2076685,466375.4002911,19.5750051,12814.1205834,10244.0347757,20818.4745467,54.2812591,67.5762552,0.1461889,234.1275604),(26149,'windfallLgGiraffe_tibia-cleaned.tif',247,8,79,1279.270587,128.1555251,125.8336713,1.8,127.866651,125.9313388,-0.2985047,27.8890755,36.2991935,284020.8698963,461933.0836663,18.4406321,12725.7120243,10183.9471036,20538.7259387,53.6273619,67.4080075,0.1281286,229.1473892),(26150,'windfallLgGiraffe_tibia-cleaned.tif',247,8,80,1282.5454773,128.2297838,126.2550449,1.8,128.0570619,126.4130781,-0.2907874,27.8104845,35.119131,276984.4617743,459919.3537032,17.5710215,13095.9776057,9959.7136475,20894.416635,54.9878363,67.1116192,0.1410328,324.1245729),(26151,'windfallLgGiraffe_tibia-cleaned.tif',247,8,81,1286.2361457,128.323292,126.7043574,1.8,128.0706706,126.8661021,-0.2822759,27.7725522,35.8387463,269033.3032487,456558.73412,16.6322659,12739.2495748,9687.0212343,20230.8009542,51.9501096,66.9497424,0.1228352,257.2299739),(26152,'windfallLgGiraffe_tibia-cleaned.tif',247,8,82,1292.2616154,128.3420338,127.1275165,1.8,128.1639123,127.3040641,-0.2693235,26.9438468,34.6410786,262523.7848264,454776.1595482,15.2483042,13128.2332314,9743.3668981,20594.2694144,53.613374,66.6487923,0.1358049,302.1651812),(26153,'windfallLgGiraffe_tibia-cleaned.tif',247,8,83,1301.8371557,128.3575474,127.5833592,1.8,128.1693888,127.7856285,-0.2581841,27.3734741,35.461084,255926.5709734,452769.9408583,14.1446775,12768.0795505,9349.4369923,19947.5849939,53.6990694,66.6588879,0.0800753,309.2835797),(26154,'windfallLgGiraffe_tibia-cleaned.tif',247,8,84,1309.9752128,128.3303116,127.9857413,1.8,128.2484118,128.2429547,-0.2477913,26.7748482,35.1555229,249950.2368172,450889.6126161,13.1333933,12825.5697854,9335.2625032,19863.7710726,52.5971327,66.3604213,0.0990536,297.9058016),(26155,'windfallLgGiraffe_tibia-cleaned.tif',247,8,85,1315.9357873,128.3686844,128.3512114,1.8,128.2256116,128.6155068,-0.2373851,26.7127764,35.1232281,243555.1281636,447170.1427103,12.1287872,12731.4647986,9117.5520067,19652.4012677,52.295247,66.2500542,0.0805705,310.0455942),(26156,'windfallLgGiraffe_tibia-cleaned.tif',247,8,86,1317.0544528,128.408936,128.7082218,1.8,128.3550379,128.9711127,-0.2264972,26.2896694,34.0169722,237836.8335099,443449.2314718,11.0697711,13036.117037,9046.7791753,19915.091166,51.0912096,66.1890832,0.068217,305.8274374),(26157,'windfallLgGiraffe_tibia-cleaned.tif',247,8,87,1318.9044515,128.5167943,129.039856,1.8,128.4520379,129.3193187,-0.2145317,26.2406721,34.4634208,231885.3867632,438540.4250096,9.9625841,12724.8083543,8836.8692033,19435.6008351,50.9457825,65.8757211,0.0872777,310.1451147),(26158,'windfallLgGiraffe_tibia-cleaned.tif',247,8,88,1319.1032665,128.5724628,129.358059,1.8,128.5348136,129.6595021,-0.2025497,25.5117262,34.4338597,227110.8482402,434609.5399399,8.8969988,12621.5749116,8902.214071,19197.4690934,50.1231708,65.8412369,0.0810719,328.3739502),(26159,'windfallLgGiraffe_tibia-cleaned.tif',247,8,89,1321.1021215,128.6504449,129.6937174,1.8,128.5188713,129.9866998,-0.190511,25.1660575,34.1782032,222126.477691,429968.8599891,7.895232,12580.2066685,8826.4312871,19027.9309747,49.7260289,65.7798869,0.068642,297.2845305),(26160,'windfallLgGiraffe_tibia-cleaned.tif',247,8,90,1320.6717126,128.6697094,129.982194,1.8,128.6700308,130.270232,-0.1796964,25.0782317,34.2267495,217248.6358513,426141.5080679,7.0314187,12450.5398229,8662.8371123,18791.2751286,49.1426535,65.7069595,0.0499584,314.0476348),(26161,'windfallLgGiraffe_tibia-cleaned.tif',247,8,91,1320.7678575,128.7270738,130.2575214,1.8,128.6404293,130.546962,-0.1691008,25.5428899,34.6395919,212452.8413619,421500.9487029,6.2348073,12168.1846111,8317.4943109,18213.1491578,49.0550895,65.3707028,0.0690723,325.8064202),(26162,'windfallLgGiraffe_tibia-cleaned.tif',247,8,92,1315.4553688,128.7726008,130.5126972,1.8,128.7249732,130.8106391,-0.1581504,24.7273748,34.4285667,207914.8571373,417327.1358636,5.4380312,12121.5367281,8408.2867301,18160.3225434,48.3684763,65.2973183,0.0502721,259.7392061),(26163,'windfallLgGiraffe_tibia-cleaned.tif',247,8,93,1313.9408576,128.8343346,130.7717162,1.8,128.779209,131.1280355,-0.148135,24.9815119,33.8036148,203590.9530655,413087.2709371,4.7704681,12220.2099884,8149.6650078,18221.0619861,48.1523233,65.1360981,0.1009218,335.3928282),(26164,'windfallLgGiraffe_tibia-cleaned.tif',247,8,94,1311.6524464,128.790962,131.0086386,1.8,128.8095993,131.3502062,-0.1378198,24.6029589,33.9006301,199781.3198732,410332.6573587,4.1260969,12103.9832223,8120.2151606,16813.8540479,47.167954,65.0960537,0.094653,249.4390791),(26165,'windfallLgGiraffe_tibia-cleaned.tif',247,8,95,1312.3299976,128.779377,131.2602365,1.8,128.7368483,131.6058321,-0.1280406,24.5158872,33.7132177,195880.2263775,407133.8607222,3.5662598,12076.3868864,7989.9301627,17772.3576434,44.2238216,65.0236529,0.0820936,182.12225),(26166,'windfallLgGiraffe_tibia-cleaned.tif',247,8,96,1310.8459714,128.754169,131.457648,1.8,128.7797509,131.7588877,-0.1179829,24.0974422,33.7533739,192560.1240732,405338.438026,3.0270718,12008.8272966,7990.894751,17652.6134955,43.9611789,64.9913051,0.0758038,181.5422017),(26167,'windfallLgGiraffe_tibia-cleaned.tif',247,8,97,1308.6472308,128.7495297,131.681303,1.8,128.6936379,131.9477694,-0.1088563,24.2040661,33.7040884,188723.6675695,402637.9157583,2.5743173,11946.263327,7797.1885602,17484.6564743,46.4315197,64.9343338,0.0632068,252.7203281),(26168,'windfallLgGiraffe_tibia-cleaned.tif',247,8,98,1304.8726523,128.7293189,131.8785108,1.8,128.7098928,132.1666173,-0.0993705,23.9473593,33.7113329,185377.4581657,400758.9398227,2.140434,11887.9589081,7741.0396524,17232.1460646,43.4294607,64.8876837,0.0505897,245.2721474),(26169,'windfallLgGiraffe_tibia-cleaned.tif',247,8,99,1301.4888217,128.7363811,132.0691304,1.8,128.6854265,132.3198985,-0.0906936,24.5144359,33.7022877,181856.9092781,398240.1786383,1.7793085,11816.4138203,7418.3599485,17212.1470113,43.0785011,64.6500252,0.0889367,180.1830638),(26170,'windfallLgGiraffe_tibia-cleaned.tif',247,8,100,1297.5407134,128.701438,132.2352706,1.8,128.731763,132.5117788,-0.0827136,23.8872816,33.687995,178995.8337495,397009.223607,1.4761576,11784.8872605,7493.3530322,17068.331568,42.7638435,64.6500252,0.0889367,179.8432794),(26171,'windfallLgGiraffe_tibia-cleaned.tif',247,8,101,1297.1060733,128.6953326,132.414554,1.8,128.6762829,132.7487522,-0.0747559,23.8151528,33.6954244,176168.6820218,394888.4428104,1.2058844,11719.3491387,7397.3357986,16942.4416476,45.3247338,64.6148869,0.0826141,260.3434022),(26172,'windfallLgGiraffe_tibia-cleaned.tif',247,8,102,1297.6576064,128.6535254,132.5638993,1.8,128.6947713,132.8797678,-0.0669808,23.8897387,33.716033,173869.1649925,394123.3106947,0.9688574,11689.4923888,7277.9852004,16729.6406958,42.0791125,64.5523714,0.0699494,179.1637105),(26173,'windfallLgGiraffe_tibia-cleaned.tif',247,8,103,1298.8843457,128.6510049,132.7269629,1.8,128.6527761,133.0653993,-0.0591646,23.3819153,33.6398737,171302.0090442,392281.7147274,0.7568953,11661.2124565,7326.2607916,16737.7238279,41.8451346,64.5823343,0.0762848,179.8432794),(26174,'windfallLgGiraffe_tibia-cleaned.tif',247,8,104,1297.4373806,128.5945826,132.8477579,1.8,128.5963934,133.1707921,-0.0526141,23.1627527,34.9902827,169172.5801022,391324.5926823,0.5980506,11183.8076965,7303.6474566,13771.1963882,41.6171983,64.5523714,0.0699494,178.5836621),(26175,'windfallLgGiraffe_tibia-cleaned.tif',247,8,105,1295.3357025,128.5762466,132.9950402,1.8,128.5188461,133.338321,-0.0452661,23.282634,33.8836014,166371.3529886,389981.9665528,0.4420597,11509.4603265,7145.7272706,14054.8424443,41.2807173,64.5523714,0.0699494,178.2438777),(26176,'windfallLgGiraffe_tibia-cleaned.tif',247,8,106,1287.9993795,128.5134216,133.1162076,1.8,128.5099389,133.426775,-0.0392798,22.956266,33.8451977,163960.5211245,389364.1283002,0.3310397,11504.2651343,7142.299234,16336.3193259,41.083919,64.5523714,0.0699494,178.4841416),(26177,'windfallLgGiraffe_tibia-cleaned.tif',247,8,107,1280.0068651,128.4797309,133.2532137,1.8,128.4531627,133.5818401,-0.0325484,22.617552,33.8908645,161188.0722037,387942.1357292,0.2259272,11446.8055332,7126.6807512,13832.6122171,40.8073986,64.5523714,3.0716433,178.1443571),(26178,'windfallLgGiraffe_tibia-cleaned.tif',247,8,108,1272.5435044,128.4082384,133.3636221,1.8,128.4527422,133.7054818,-0.0262191,22.7251746,33.7242248,158850.3244307,387468.275284,0.145766,11489.3159846,6990.0595937,16160.8801053,40.5300835,64.5523714,3.0716433,178.384621),(26179,'windfallLgGiraffe_tibia-cleaned.tif',247,8,109,1267.4422693,128.338777,133.4861088,1.8,128.294463,133.8524349,-0.0201996,22.6722308,33.722951,156381.4462342,386575.4672901,0.0861783,11463.2751776,6897.4882653,13718.7470493,43.0663928,64.5823343,3.0653079,249.9608296),(26180,'windfallLgGiraffe_tibia-cleaned.tif',247,8,110,1260.2196786,128.2167414,133.5781772,1.8,128.2075697,133.9445289,-0.0149241,22.4087094,33.9035249,154293.1777873,386539.6281195,0.0467776,11401.1634289,6885.4111739,15940.9747386,43.0663928,64.8876837,3.0910029,234.2341537),(26181,'windfallLgGiraffe_tibia-cleaned.tif',247,8,111,1257.6662318,128.1315669,133.6800275,1.8,128.1494949,134.0696716,-0.0103581,22.6950558,33.8154075,152332.74669,386284.8615187,0.022488,11423.3389372,6712.1556374,14464.9088535,43.027384,64.9343338,3.0783858,269.565878),(26182,'windfallLgGiraffe_tibia-cleaned.tif',247,8,112,1255.0838804,128.007808,133.7607076,1.8,128.0410661,134.1954149,-0.0064966,22.5815293,33.7134997,150889.2280582,387222.9435342,0.0088289,11485.6940802,6681.9756018,15690.2558629,43.1527444,64.9097171,3.0846921,274.2474875),(26183,'windfallLgGiraffe_tibia-cleaned.tif',247,8,113,1253.1333017,127.9082584,133.8595177,1.8,127.9709347,134.2568921,-0.0026962,22.8146716,33.9852998,148770.948628,387293.3978832,0.0015182,11395.9094055,6520.8455129,15728.4085462,42.2460805,65.0585705,3.0532159,243.3983317),(26184,'windfallLgGiraffe_tibia-cleaned.tif',247,8,114,1250.9803395,127.7683959,133.9204189,1.8,127.838811,134.2687262,0.0011853,21.9548261,33.8433547,147388.4384222,388538.8655842,0.0002934,11480.5068377,6713.2592031,15812.4723461,42.380662,65.1360981,3.0406709,259.1833055),(26185,'windfallLgGiraffe_tibia-cleaned.tif',247,8,115,1250.8635995,127.6880457,134.0123378,1.8,127.7845289,134.3740437,0.0046684,23.2827302,33.7671627,145869.1655069,389307.183328,0.0045424,11529.1648048,6265.1228858,15818.9774947,41.8152362,65.2238513,3.0281577,238.956986),(26186,'windfallLgGiraffe_tibia-cleaned.tif',247,8,116,1249.8302205,127.5515793,134.0738295,1.8,127.6605698,134.4724398,0.0078247,22.1134235,34.0570373,144837.2631656,391074.418042,0.0127526,11482.9253757,6549.7440058,15691.5301006,42.2460805,65.5865161,3.0350791,248.6599896),(26187,'windfallLgGiraffe_tibia-cleaned.tif',247,8,117,1250.3099253,127.4362305,134.1348941,1.8,127.5568426,134.5309684,0.010696,22.58122,33.9320033,143573.3463494,392128.2697238,0.023839,11556.2958812,6358.0863266,15774.664,41.9920071,65.6313879,3.028865,262.4645544),(26188,'windfallLgGiraffe_tibia-cleaned.tif',247,8,118,1250.8425965,127.295802,134.2033018,1.8,127.4164925,134.6221258,0.0136668,22.2546167,34.1938987,142934.2493167,394048.1207109,0.0389373,11523.9307436,6422.6785406,15696.8156641,41.4257683,65.9522882,3.041924,237.2751388),(26189,'windfallLgGiraffe_tibia-cleaned.tif',247,8,119,1251.7280367,127.1734572,134.2959848,1.8,127.2946849,134.7300302,0.0170872,23.926467,34.0800494,141806.9746685,395669.1892223,0.0609054,11609.9946084,5926.7828644,15752.6997086,41.8359244,65.9943622,3.0357398,239.2555477),(26190,'windfallLgGiraffe_tibia-cleaned.tif',247,8,120,1249.2150156,127.0142313,134.3648036,1.8,127.2196899,134.8096514,0.0199586,23.9226584,34.3251628,141160.6359109,397364.5266263,0.0829253,11576.47901,5900.7085776,15685.2920108,41.4257683,66.3604213,3.042539,223.8515812),(26191,'windfallLgGiraffe_tibia-cleaned.tif',247,8,121,1249.3316537,126.873289,134.4585011,1.8,127.0767789,134.9054865,0.0229539,22.113878,34.2049887,140342.0429915,398815.7584757,0.1096887,11659.5787289,6346.333407,15758.4198694,41.8359244,66.421235,2.9865959,219.6092766),(26192,'windfallLgGiraffe_tibia-cleaned.tif',247,8,122,1248.0165183,126.6992453,134.5146663,1.8,126.8920459,134.9464654,0.0243928,22.3676324,54.125005,139911.0032724,401022.1714652,0.123739,7409.1849336,6255.0653868,9558.9444897,41.4257683,66.7055603,2.9996956,228.931273),(26193,'windfallLgGiraffe_tibia-cleaned.tif',247,8,123,1247.8591995,126.5713281,134.5955568,1.8,126.7889946,135.0508278,0.0258861,21.8739522,34.3188441,139130.4208051,402733.6849717,0.1393308,11735.059731,6360.5524882,15784.6411278,41.0156122,66.8265042,2.9875434,237.8139643),(26194,'windfallLgGiraffe_tibia-cleaned.tif',247,8,124,1248.5308882,126.417905,134.6351331,1.8,126.6372183,135.0765815,0.0271199,22.3195917,34.5664157,139146.416653,405459.8560146,0.1530093,11729.8785001,6234.2724938,15726.5202647,41.4257683,67.1116192,3.0005599,214.7698487),(26195,'windfallLgGiraffe_tibia-cleaned.tif',247,8,125,1248.0041306,126.292536,134.683292,1.8,126.5075416,135.1218792,0.0290877,23.7841362,34.4551439,138685.3447601,407191.7586298,0.1759379,11818.0251796,5831.0019689,13441.11001,41.4257683,67.1705006,2.9945143,214.049057),(26196,'windfallLgGiraffe_tibia-cleaned.tif',247,8,126,1245.9954367,126.1215351,134.7193084,1.8,126.3832092,135.157961,0.0303945,21.9349892,34.6713583,138582.1355849,409746.2020216,0.1917884,11818.0025899,6317.8574748,15815.0097779,41.0156122,67.4080075,3.0134641,238.5759788),(26197,'windfallLgGiraffe_tibia-cleaned.tif',247,8,127,1244.4582402,125.9812005,134.7756217,1.8,126.2012405,135.1677195,0.0321494,22.4847111,34.5591414,138364.1897584,411280.9036346,0.2143011,11900.7847604,6153.7010381,15900.4844279,41.0156122,67.461643,3.0074341,230.1738152),(26198,'windfallLgGiraffe_tibia-cleaned.tif',247,8,128,1241.6613215,125.8147206,134.8121074,1.8,126.1068015,135.2076839,0.033313,22.0377167,34.7774536,138559.8903207,414368.3297556,0.2295718,11914.8553538,6287.3977507,15899.0212223,41.0156122,67.7155211,3.0262532,221.3906444),(26199,'windfallLgGiraffe_tibia-cleaned.tif',247,8,129,1239.9832723,125.6684166,134.8641022,1.8,125.9797637,135.2785489,0.0333088,21.7678077,34.6602811,138508.5255751,416537.1313614,0.2292032,12017.7078199,6362.9984079,16009.4057772,41.4257683,67.7664309,2.977439,224.7301912),(26200,'windfallLgGiraffe_tibia-cleaned.tif',247,8,130,1234.8303453,125.4887652,134.8810552,1.8,125.8123696,135.2897394,0.0331059,21.6883285,34.5082744,138811.1518834,419191.8047797,0.2254783,12147.573639,6400.2696996,15760.0335838,41.0156122,67.8346644,2.9714738,215.4081948),(26201,'windfallLgGiraffe_tibia-cleaned.tif',247,8,131,1234.3800549,125.3663412,134.9231617,1.8,125.6371052,135.3483691,0.0332611,22.640699,44.1174997,139084.53854,421440.4525986,0.2275153,9552.6821732,6143.1203494,12093.5951505,41.0156122,67.9820626,2.9962826,215.3086743),(26202,'windfallLgGiraffe_tibia-cleaned.tif',247,8,132,1231.5612156,125.210317,134.9390751,1.8,125.4812348,135.3587325,0.0326492,22.5308713,34.6276513,139650.0822538,424560.5929562,0.2187223,12260.7389441,6198.1660753,16281.6585956,41.3492715,67.9820626,2.9962826,223.3710534),(26203,'windfallLgGiraffe_tibia-cleaned.tif',247,8,133,1230.0399243,125.0944333,134.9762683,1.8,125.3683842,135.4109686,0.0326969,22.080511,34.5399257,139897.767339,427162.2510739,0.2190914,12367.2023774,6335.802971,16384.6759711,41.4257683,68.053788,2.9536531,232.2949675),(26204,'windfallLgGiraffe_tibia-cleaned.tif',247,8,134,1228.6771242,124.9494478,134.9686344,1.8,125.2060783,135.3745761,0.0315905,22.5329538,34.763416,140659.3253155,430622.4203211,0.2042935,12387.229717,6242.382899,16426.8849066,41.0156122,68.1711062,2.9784222,245.8009706),(26205,'windfallLgGiraffe_tibia-cleaned.tif',247,8,135,1227.7375961,124.8493726,134.9657625,1.8,125.0835989,135.3275924,0.0314237,22.1696822,34.688909,140887.1263499,433295.8431438,0.2019885,12490.9043036,6354.945704,16448.0259439,41.0156122,68.2389351,2.9724914,263.00338),(26206,'windfallLgGiraffe_tibia-cleaned.tif',247,8,136,1231.1631779,124.6912606,134.9634553,1.8,124.9236105,135.3458328,0.0306401,21.8945853,34.56707,142142.3532378,436942.2490279,0.1925775,12640.4190351,6492.1235586,16686.9768699,41.3627969,68.3793117,2.9300804,246.8615468),(26207,'windfallLgGiraffe_tibia-cleaned.tif',247,8,137,1234.5086729,124.5636652,134.9780196,1.8,124.8235185,135.32987,0.0294489,21.8899029,34.7979527,143257.2798463,439987.8381784,0.1783843,12644.0725381,6544.4456474,16745.8944535,41.4257683,68.3879219,2.9971511,248.8419557),(26208,'windfallLgGiraffe_tibia-cleaned.tif',247,8,138,1230.8513443,124.4071889,134.9287008,1.8,124.6697605,135.3309162,0.0268699,21.8237125,34.6693501,144853.0341783,444215.4790237,0.1480751,12812.9162358,6637.4148904,16937.9106796,41.4257683,68.4567647,2.9547725,250.8052896),(26209,'windfallLgGiraffe_tibia-cleaned.tif',247,8,139,1234.8246358,124.290701,134.9385011,1.8,124.5571467,135.3314508,0.0252613,21.9417385,34.5694011,146643.5079278,447901.9921825,0.1313009,12956.6026048,6683.3130929,17104.2124156,41.4257683,68.5562185,2.9183812,268.8109362),(26210,'windfallLgGiraffe_tibia-cleaned.tif',247,8,140,1240.1059768,124.1396869,134.935008,1.8,124.4213848,135.3803639,0.022658,22.7418834,34.7630575,149421.2207986,452899.6239279,0.1060906,13028.1872981,6570.3098621,17315.1447994,41.4257683,68.4665937,2.9242233,281.7127433),(26211,'windfallLgGiraffe_tibia-cleaned.tif',247,8,141,1241.3070231,124.0103931,134.9175684,1.8,124.3038182,135.3516223,0.0196412,22.5356866,34.6617173,151588.5154766,457461.2971644,0.0798009,13197.8832347,6726.5984923,17506.3514605,41.950317,68.6138603,2.9430248,272.0097397),(26212,'windfallLgGiraffe_tibia-cleaned.tif',247,8,142,1235.4047167,123.8100359,134.8317564,1.8,124.1299622,135.2097159,0.015197,22.3543267,35.1918827,154163.3332272,462521.4535201,0.0475486,13142.8448182,6896.3532404,17498.6739238,40.0808457,68.6138603,2.9430248,185.7091334),(26213,'windfallLgGiraffe_tibia-cleaned.tif',247,8,143,1237.9028521,123.6784114,134.8137674,1.8,123.981696,135.1993258,0.0117669,22.3446564,35.0566281,156944.4167203,467692.0684069,0.0285666,13341.0454453,7023.8008464,17769.4591908,42.1431712,68.5562185,2.9183812,260.7897799),(26214,'windfallLgGiraffe_tibia-cleaned.tif',247,8,144,1238.6950533,123.5233864,134.7562907,1.8,123.8316946,135.1358059,0.0079274,22.3788488,34.5429677,160129.6938357,473633.8860899,0.0129741,13711.4416584,7155.4035408,18263.8923044,40.1952999,68.5782998,3.0216887,187.4905012),(26215,'windfallLgGiraffe_tibia-cleaned.tif',247,8,145,1245.5999479,123.4568842,134.7449653,1.8,123.7919367,135.0875221,0.004825,23.2020208,35.2897708,163229.3542388,479714.4761076,0.0048323,13593.584352,7035.1352342,18138.6625495,42.4292817,68.5758467,2.9793938,254.9480736),(26216,'windfallLgGiraffe_tibia-cleaned.tif',247,8,146,1255.0622146,123.3432498,134.7321054,1.8,123.6457448,135.096519,0.0008461,22.3679956,50.3293657,167503.9545143,486846.6674789,0.0001495,9673.2128665,7488.5545185,12869.4568937,41.0156122,68.5758467,2.9793938,189.1311257),(26217,'windfallLgGiraffe_tibia-cleaned.tif',247,8,147,1259.1850252,123.2665773,134.7366876,1.8,123.5876557,135.1180543,-0.0036394,24.8041235,49.0556083,171329.0165358,492398.0523694,0.0027804,10037.5485914,6907.2796233,13378.3696589,41.0156122,68.6432757,2.973497,190.0921813),(26218,'windfallLgGiraffe_tibia-cleaned.tif',247,8,148,1259.346677,123.1297093,134.6823941,1.8,123.3963339,135.1080839,-0.0080439,24.0531788,34.9833869,175584.6347588,499439.3546378,0.0135815,14276.4723141,7299.8515489,19138.6080351,41.590959,68.6285695,3.0157551,191.9318469),(26219,'windfallLgGiraffe_tibia-cleaned.tif',247,8,149,1257.520944,123.0650958,134.6533904,1.8,123.2979205,135.0879607,-0.0130308,24.9110229,35.7025632,179222.823039,505323.8341607,0.0355854,14153.7130415,7194.5188294,19173.3634475,41.8359244,68.6959467,2.9371714,192.0725902),(26220,'windfallLgGiraffe_tibia-cleaned.tif',247,8,150,1256.4245559,122.9874364,134.6111501,1.8,123.2681484,135.0512541,-0.0182418,24.3618326,35.6242788,183518.2761027,511818.198098,0.0696741,14367.1174655,7533.0242724,19505.4729098,42.108444,68.8598261,0.1857138,193.3734302),(26221,'windfallLgGiraffe_tibia-cleaned.tif',247,8,151,1258.0358747,122.9961609,134.6170562,1.8,123.2145966,135.0573777,-0.0220046,24.1627879,35.6494654,187530.404958,518246.8418207,0.1015082,14537.2962981,7761.1244933,19771.3831823,42.2460805,69.1414227,0.2334684,194.0942219),(26222,'windfallLgGiraffe_tibia-cleaned.tif',247,8,152,1255.6164496,122.9546241,134.5562392,1.8,123.1974812,135.0241609,-0.0278103,24.429128,36.4881473,192177.7035049,524960.5978902,0.1618098,14387.1540878,7866.7443175,19616.9949167,0.4101561,0.5800484,2.3561945,1.1600967),(26223,'windfallLgGiraffe_tibia-cleaned.tif',247,8,153,1246.249563,122.8803556,134.4881243,1.8,123.0586655,134.8731028,-0.0355893,24.5697934,36.491066,195803.9882986,530333.6601059,0.2629723,14533.2465656,7969.2973053,19799.2334657,42.8756521,69.7844211,0.3105986,196.3148948),(26224,'windfallLgGiraffe_tibia-cleaned.tif',247,8,154,1242.1647312,122.8065801,134.416018,1.8,122.9367841,134.8321113,-0.0440249,24.2833645,35.968222,200931.2534354,537780.4166322,0.401,14951.5429458,8274.4404543,20481.7098678,43.0663928,70.0875088,0.2847304,197.2759503),(26225,'windfallLgGiraffe_tibia-cleaned.tif',247,8,155,1239.3805571,122.7833363,134.3632246,1.8,122.9006121,134.7311234,-0.0520023,24.7575527,36.0463677,205745.3180086,544534.8247261,0.5580952,15106.5102774,8310.4061339,20731.7252319,0.4101561,2.0913941,1.7681919,4.4413457),(26226,'windfallLgGiraffe_tibia-cleaned.tif',247,8,156,1237.3151245,122.7071565,134.2861058,1.8,122.9295061,134.6187222,-0.0599138,24.5109413,36.7935744,211249.5717236,552532.4611245,0.7393745,15017.0911607,8618.5825926,20708.5734807,0.4101561,0.917137,2.0344439,1.9804089),(26227,'windfallLgGiraffe_tibia-cleaned.tif',247,8,157,1236.0751819,122.6797435,134.1978545,1.8,122.8988525,134.4538527,-0.0685617,25.7585955,36.5243219,216867.0094147,559949.596087,0.9668879,15330.8690444,8419.2094143,21115.5312159,44.1391203,71.4425564,0.376242,201.3775116),(26228,'windfallLgGiraffe_tibia-cleaned.tif',247,8,158,1236.675705,122.6339767,134.1185542,1.8,122.9310752,134.4399409,-0.0765398,25.0116951,36.6128131,223670.9044302,568608.6088716,1.2051209,15530.3174263,8942.6527658,21405.963687,44.5322888,71.9119606,0.3614409,202.4380877),(26229,'windfallLgGiraffe_tibia-cleaned.tif',247,8,159,1234.3600715,122.6502157,134.0245951,1.8,122.9148471,134.2614118,-0.0859544,25.2685742,37.1164394,229718.671197,575491.4559157,1.5162018,15505.0286364,9091.0816557,21691.2950791,0.4101561,0.917137,2.0344439,1.9804089),(26230,'windfallLgGiraffe_tibia-cleaned.tif',247,8,160,1230.5685172,122.6163509,133.8885064,1.8,123.0925082,134.076828,-0.0962298,25.2806516,36.691792,235832.5269302,583106.5584327,1.8933604,15892.0163604,9328.5778564,22212.4477147,0.4101561,0.5800484,2.3561945,1.1600967),(26231,'windfallLgGiraffe_tibia-cleaned.tif',247,8,161,1227.8408779,122.5946511,133.7325854,1.8,122.9980774,133.9048702,-0.1063407,26.1142536,37.359101,241688.7743302,590610.5357329,2.3054306,15809.013578,9255.0519794,22225.3511164,45.7428851,73.1367137,0.403419,206.7799128),(26232,'windfallLgGiraffe_tibia-cleaned.tif',247,8,162,1232.4818818,122.5826837,133.6390011,1.8,123.1459465,133.7044448,-0.1162115,26.2457226,37.1904626,249430.2046868,599705.9016298,2.7616691,16125.2606194,9503.6516582,22745.3260133,0.4101561,0.5800484,2.3561945,1.1600967),(26233,'windfallLgGiraffe_tibia-cleaned.tif',247,8,163,1239.7963353,122.6466388,133.5888423,1.8,123.2061425,133.6653752,-0.1221794,26.2242259,37.0063522,257045.9137432,610153.9789695,3.0692546,16487.8174174,9801.8494354,22988.3426445,0.4101561,0.917137,2.0344439,1.9804089),(26234,'windfallLgGiraffe_tibia-cleaned.tif',247,8,164,1250.9447058,122.7106679,133.5248501,1.8,123.358857,133.4692973,-0.1255164,26.2701532,37.4430377,266175.411267,622037.2479058,3.2674274,16612.8948426,10132.236731,23447.3135787,47.1677097,74.2144606,0.4092459,210.019939),(26235,'windfallLgGiraffe_tibia-cleaned.tif',247,8,165,1251.7955828,122.770667,133.4166036,1.8,123.4018237,133.279194,-0.1309393,26.4066671,38.1081248,273500.8305795,631359.9844543,3.5566305,16567.595164,10357.2643105,23490.4291224,47.6846333,74.5909251,0.4070578,212.5803963),(26236,'windfallLgGiraffe_tibia-cleaned.tif',247,8,166,1262.0311378,122.8469442,133.346156,1.8,123.4785483,133.2148469,-0.1338436,26.4581051,37.935619,282821.7429667,643758.8118078,3.745578,16969.7721974,10689.4179076,24240.5076833,48.2032985,75.1302573,0.4099097,213.9807569),(26237,'windfallLgGiraffe_tibia-cleaned.tif',247,8,167,1266.8180923,122.9556144,133.2766261,1.8,123.5111599,133.3845152,-0.1377309,28.6765333,38.4725418,292373.1977263,655235.3786827,3.9799526,17031.2474179,10195.555886,24535.8580714,51.4532979,75.7823791,0.4902757,307.3414639),(26238,'windfallLgGiraffe_tibia-cleaned.tif',247,8,168,1277.0486004,123.1437201,133.1738645,1.8,123.6626995,133.2263207,-0.1399589,28.1249166,38.6805953,302752.9236048,668433.7224704,4.1420926,17280.8540439,10764.5803022,25012.6998147,49.4507752,76.3165979,0.4804729,217.3615264),(26239,'windfallLgGiraffe_tibia-cleaned.tif',247,8,169,1279.9812741,123.2527078,133.0501384,1.8,123.712237,132.9910785,-0.1406987,29.7968335,39.6815443,311723.7976316,678860.5650225,4.1953188,17107.7153527,10461.6417641,24957.6730958,50.0871904,76.7287993,0.5019064,219.3419354),(26240,'windfallLgGiraffe_tibia-cleaned.tif',247,8,170,1288.7263795,123.4154125,132.9651026,1.8,123.8277817,132.894406,-0.1403421,29.2212792,39.0948563,323254.0517953,689685.7348401,4.2027347,17641.3421077,11062.2827097,25751.369279,50.755736,77.1758635,0.5231013,221.0820804),(26241,'windfallLgGiraffe_tibia-cleaned.tif',247,8,171,1292.3114721,123.6245977,132.8641206,1.8,123.9317898,132.7472845,-0.1384632,29.1185435,39.6107168,333856.3354078,697505.753027,4.103054,17609.0161607,11465.4201353,25931.2322153,56.0865804,77.6073479,0.4423742,426.48871),(26242,'windfallLgGiraffe_tibia-cleaned.tif',247,8,172,1301.2622746,123.8027037,132.7789516,1.8,124.0469412,132.6284669,-0.1342655,29.230636,39.9050645,346295.6663173,708836.6644449,3.8862544,17763.0752702,11847.0110199,26343.2872105,55.1411896,78.0051816,0.4283681,322.7454305),(26243,'windfallLgGiraffe_tibia-cleaned.tif',247,8,173,1305.0051447,124.0314002,132.6604216,1.8,124.2141857,132.5339859,-0.1302899,29.8467929,40.7934116,358051.2852952,715951.5012963,3.6713311,17550.6649833,11996.3068417,26324.2119156,55.3710764,78.5328487,0.4893429,317.5008476),(26244,'windfallLgGiraffe_tibia-cleaned.tif',247,8,174,1308.2604593,124.1854558,132.621754,1.8,124.4211689,132.592404,-0.1230942,30.4419922,39.9337355,369718.5626648,722877.5307412,3.2871819,18101.9261341,12145.0186426,27105.7720284,55.8903946,78.8951053,0.440396,277.868521),(26245,'windfallLgGiraffe_tibia-cleaned.tif',247,8,175,1311.8251096,124.4708326,132.5972842,1.8,124.6466411,132.561089,-0.1194544,30.6804742,40.4783741,381099.3003833,730262.9773338,3.1050038,18040.8179233,12421.5583457,26848.6685813,0.4101561,0.5800484,2.3561945,1.1600967),(26246,'windfallLgGiraffe_tibia-cleaned.tif',247,8,176,1319.3091165,124.7041361,132.535216,1.8,124.82932,132.6676898,-0.1182316,30.5670942,41.2996868,393781.0602449,739092.1388621,3.0594096,17895.8291661,12882.5153462,27343.4121615,57.4218571,79.9309994,0.350963,299.512276),(26247,'windfallLgGiraffe_tibia-cleaned.tif',247,8,177,1323.3070814,125.0576391,132.4657305,1.8,125.1325981,132.5465762,-0.1131872,30.9915199,41.1508191,404334.399616,745834.300018,2.8135104,18124.4095864,13046.6140791,27609.5937064,57.8320132,80.4543999,0.1483858,277.0482087),(26248,'windfallLgGiraffe_tibia-cleaned.tif',247,8,178,1332.6419536,125.2784499,132.4153485,1.8,125.3044115,132.5332601,-0.1105816,31.2527928,41.2233016,417208.6138366,754936.2390506,2.7049368,18313.3376089,13349.4825859,27932.3383549,0.4101561,0.917137,2.0344439,1.9804089),(26249,'windfallLgGiraffe_tibia-cleaned.tif',247,8,179,1342.0890289,125.5406871,132.38359,1.8,125.5421717,132.5214854,-0.1114381,31.2506385,42.3953152,428169.4203352,763695.7393433,2.7662983,18013.6822953,13701.1415215,28069.3265245,59.8164077,82.2646812,0.1602307,271.8036258),(26250,'windfallLgGiraffe_tibia-cleaned.tif',247,8,180,1350.9391494,125.7120086,132.3541674,1.8,125.7385992,132.6132045,-0.1082061,32.5286619,42.6938172,439918.1467667,769012.2447545,2.6259876,18012.2625466,13524.016088,28208.230328,60.2929499,82.8312294,0.1390959,286.188239),(26251,'windfallLgGiraffe_tibia-cleaned.tif',247,8,181,1360.2068324,125.9324833,132.3582534,1.8,125.9546652,132.6299713,-0.1037907,32.7644003,42.3348164,447708.9768412,775245.1199949,2.4333851,18312.2353,13664.4947927,28559.6413143,60.9810407,83.5883686,0.1328758,286.0304206),(26252,'windfallLgGiraffe_tibia-cleaned.tif',247,8,182,1370.3601086,126.0737109,132.3368769,1.8,126.0648691,132.6740198,-0.0987716,33.5852736,43.0991639,456625.2778,779591.7456229,2.2209325,18088.3264415,13595.9969549,28496.4331787,62.9037695,84.6334075,0.180287,291.1684102),(26253,'windfallLgGiraffe_tibia-cleaned.tif',247,8,183,1387.8388494,126.3418752,132.2867495,1.8,126.2640002,132.6259634,-0.0918416,33.7309778,43.2925493,465208.7858177,786753.775778,1.9455598,18172.9601988,13791.7373194,28740.7294256,64.3945111,85.3804769,0.1058827,339.4019416),(26254,'windfallLgGiraffe_tibia-cleaned.tif',247,8,184,1416.5025122,126.5537488,132.2088669,1.8,126.4094791,132.5730519,-0.0876799,33.7273602,58.4285102,476596.9230337,801621.4319711,1.8103125,13719.6965941,14130.8694257,21125.0839781,64.5677276,86.2401405,0.1096068,309.2735774),(26255,'windfallLgGiraffe_tibia-cleaned.tif',247,8,185,1454.5992312,126.85763,132.1656687,1.8,126.6791205,132.5759451,-0.0781205,33.8739292,44.4974047,491531.8753639,827811.5345231,1.4765153,18603.5913769,14510.6247449,29646.2374963,65.9821002,87.4719836,0.1458758,344.2413695),(26256,'windfallLgGiraffe_tibia-cleaned.tif',247,8,186,1498.2482913,126.9898359,132.0824055,1.8,126.8348805,132.5831704,-0.0776826,35.0863779,45.2040442,506128.5459207,861765.3637478,1.503855,19063.8996756,14425.2150291,30130.5769249,64.7703968,88.8260294,0.1203459,322.5563917),(26257,'windfallLgGiraffe_tibia-cleaned.tif',247,8,187,1557.3594458,127.2473267,132.0652564,1.8,127.1431873,132.5850197,-0.077424,35.2989757,45.9023766,523237.8274501,901943.3224314,1.5528174,19649.1639412,14823.0314844,31024.4574416,66.2525652,90.2017148,0.1322511,358.0800844),(26258,'windfallLgGiraffe_tibia-cleaned.tif',247,8,188,1624.2256074,127.5092824,131.8660879,1.8,127.4730521,132.4857766,-0.0721995,35.6897444,46.8678541,540369.3064061,959923.3647295,1.4086676,20481.4874303,15140.7446394,32009.1834173,66.8554479,92.6489933,0.1600541,352.039337),(26259,'windfallLgGiraffe_tibia-cleaned.tif',247,8,189,1716.7428242,127.7039121,131.6786632,1.8,127.671149,132.3935242,-0.0682209,37.0158681,47.806909,563640.2704111,1041111.1111945,1.3295814,21777.4194883,15226.9904753,33566.134636,68.0083325,94.5291967,0.113053,349.0737247),(26260,'windfallLgGiraffe_tibia-cleaned.tif',247,8,190,1816.6979127,127.8377545,131.5427555,1.8,127.8435647,132.3523282,-0.0709524,37.0908624,48.9725911,595080.6293361,1125329.4928457,1.5217277,22978.7615486,16043.8606956,35030.7636067,68.9062285,96.7012103,0.0806756,338.310145),(26261,'windfallLgGiraffe_tibia-cleaned.tif',247,8,191,1927.9677645,127.9446412,131.5171618,1.8,128.0566024,132.2854442,-0.0838008,37.9899868,50.8748502,632799.598402,1224151.5579054,2.2512719,24062.0179427,16657.0102111,36480.9541509,69.9944584,99.4212009,0.1074682,379.0030477),(26262,'windfallLgGiraffe_tibia-cleaned.tif',247,8,192,2041.4706652,127.6719459,131.6414773,1.8,127.8927016,132.3242957,-0.1134849,38.2465261,51.4260705,678966.9551336,1360730.8588181,4.3631755,26459.9422923,17752.3823602,39614.428701,71.3671652,100.2812845,0.1106572,343.5718029),(26263,'windfallLgGiraffe_tibia-cleaned.tif',247,8,193,2111.5967804,127.389124,131.8784805,1.8,127.961565,132.3519135,-0.0959377,38.2958002,52.6583311,709058.1304223,1441823.2782653,3.2292739,27380.7248984,18515.2974326,40840.1009303,72.7236133,101.4180992,0.1012783,376.9572683),(26264,'windfallLgGiraffe_tibia-cleaned.tif',247,8,194,2254.5699209,127.4452516,132.0106894,1.8,127.9484323,132.4700992,-0.0745924,38.6142791,53.2046552,747897.0787322,1537124.4180376,2.0868739,28890.788068,19368.4071433,42855.8251994,72.9490011,101.451269,0.1378948,424.3121895),(26265,'windfallLgGiraffe_tibia-cleaned.tif',247,8,195,2391.7778353,127.8685837,131.4685181,1.8,128.1718748,132.1913034,-0.081757,39.4890813,53.8954429,796683.4398848,1653562.3239368,2.6585898,30680.9302168,20174.7777912,45177.8538133,73.8281019,103.0235108,0.3494513,439.3934466),(26266,'windfallLgGiraffe_tibia-cleaned.tif',247,8,196,2403.4461325,128.529327,130.890324,1.8,128.5285123,131.5915718,-0.1176938,57.0745368,54.8727845,841794.7678728,1766065.9214753,5.523119,32184.7330426,14749.0424869,45595.0136314,75.4687264,104.7505331,0.4023211,475.7203766),(26267,'windfallLgGiraffe_tibia-cleaned.tif',247,8,197,2502.4871309,128.1999476,130.7049464,1.8,128.9605985,131.043626,-0.1463698,41.6778042,54.3275975,893318.8269941,1890075.8253857,8.8719639,34790.3443924,21433.9225451,51084.6886114,77.3291418,105.5154027,0.3574058,415.3641277),(26268,'windfallLgGiraffe_tibia-cleaned.tif',247,8,198,2630.1782829,128.4147245,130.2791524,1.8,129.145949,130.4551009,-0.162726,42.4347244,54.8745223,938965.9803408,1993924.5049405,11.505649,36336.0704111,22127.3024554,53341.878858,78.1498988,106.0434044,0.3596761,429.2682131),(26269,'windfallLgGiraffe_tibia-cleaned.tif',247,8,199,2674.7016191,129.2668532,130.1087958,1.8,129.1746972,130.0302476,-0.1576691,42.1366243,55.6657632,962101.8221036,1994360.6070991,10.9904456,35827.4187001,22832.9117026,52934.8627164,0.4101561,0.5800484,2.3561945,1.1600967),(26270,'windfallLgGiraffe_tibia-cleaned.tif',247,8,200,2545.2511076,132.8261163,129.1804216,1.8,130.5491714,129.1914088,-0.1449033,41.6291799,58.763924,964599.0081015,1721508.3630048,8.8449322,29295.3269137,23171.2229186,45664.2490264,77.862877,105.6165951,0.348771,492.0371032),(26271,'windfallLgGiraffe_tibia-cleaned.tif',247,8,201,2244.3065828,137.1546066,127.4679483,1.8,135.3492347,127.5998528,-0.1087333,41.4546747,58.1156923,920657.6205446,1166450.6682045,4.4049792,20071.1825293,22208.7768541,34470.945913,76.5209618,105.0392131,0.6161642,593.775826),(26272,'windfallLgGiraffe_tibia-cleaned.tif',247,8,202,1915.5875059,139.0788971,125.58281,1.8,138.1117903,126.0504373,0.8154814,59.3551561,48.0619428,807878.5478198,836926.6207491,169.2310199,17413.4995673,13610.9244955,26757.0950837,75.9601472,104.5182103,0.6293733,506.686128),(26273,'windfallLgGiraffe_tibia-cleaned.tif',247,8,203,1572.5646612,140.4471205,123.0804022,1.8,139.6484266,123.7146093,1.2424554,56.6799426,43.3659582,554668.3941077,713695.1386459,234.8392452,16457.4972629,9785.9731099,21560.4320076,0.4101561,0.5800484,2.3561945,1.1600967),(26274,'windfallLgGiraffe_tibia-cleaned.tif',247,8,204,1234.2030586,141.6812533,119.6057016,1.8,140.6942253,120.8439362,1.1694166,37.6705706,44.4607316,406481.4559064,574417.9251209,174.3028457,12919.6687496,10790.4247003,21095.0112248,72.5120443,88.18452,2.3759288,513.2586282),(26275,'windfallLgGiraffe_tibia-cleaned.tif',247,8,205,925.6510068,142.4082993,115.2494111,1.8,141.5934064,116.136937,0.9176826,40.1304077,46.5779535,293346.8297803,423529.8385508,97.3085386,9092.9250193,7309.8392617,14734.8153356,34.0427186,76.830683,2.9263979,270.0151853),(26276,'windfallLgGiraffe_tibia-cleaned.tif',247,8,206,709.1841826,142.2620167,112.8956539,1.8,141.6797651,113.4807345,0.6322752,33.7844911,42.357519,210613.5975516,310532.9118376,41.2815293,7331.2346666,6234.0319695,10509.1529571,28.8502752,75.3895515,2.9666053,279.5191478),(26277,'windfallLgGiraffe_tibia-cleaned.tif',247,8,207,547.0599105,143.1796324,110.5235148,1.8,142.0306568,111.2051573,0.3219957,42.2368721,39.5230111,136344.5153116,221132.1238282,9.1310826,5595.0221777,3228.0921539,7185.8434467,0.8203122,1.1600967,2.3561945,2.3201934),(26278,'windfallLgGiraffe_tibia-cleaned.tif',247,8,208,419.4585311,144.4956911,108.294497,1.8,143.5794572,109.4290952,0.0617648,53.2500681,57.2359368,68550.0718502,160975.4110556,0.2663591,2812.4884467,1287.3236468,2936.0010893,21.7816067,37.297154,0.1434523,132.1897964),(26279,'windfallLgGiraffe_tibia-cleaned.tif',247,8,209,320.5785728,145.0108977,106.114752,1.8,143.834592,106.9075488,-0.0492965,50.319772,31.5347637,15499.8322851,125550.1708851,0.1297371,3981.3258822,308.0266797,2744.707777,19.9728986,33.1212179,0.1366432,95.3823387),(26280,'windfallLgGiraffe_tibia-cleaned.tif',247,8,210,242.7492955,146.0173148,106.0137966,1.8,144.3764072,105.8485994,-0.0820233,10.3001051,30.2581144,4388.0468908,95705.0986432,0.2715856,3162.956463,426.0196232,3293.9892154,16.9931612,29.8147109,0.138006,83.8808923),(26281,'windfallLgGiraffe_tibia-cleaned.tif',247,8,211,166.5007501,147.1418914,106.4003928,1.8,146.1475143,106.1668328,-0.1018477,9.5816845,29.0583566,2126.021711,69188.210712,0.286857,2381.0090745,221.8839193,2452.9659864,12.7148398,26.9144935,0.1375867,71.4183903),(26282,'windfallLgGiraffe_tibia-cleaned.tif',247,8,212,78.1967281,154.138626,105.7073981,1.8,149.9369205,105.9210622,-0.1183611,8.3654509,35.2994828,770.9992117,34268.0555551,0.1817297,970.7806698,92.1646926,992.0562019,8.9064464,23.8772872,3.0555984,59.8344983),(26283,'windfallLgGiraffe_tibia-cleaned.tif',247,8,213,26.1575747,169.8801185,103.6396047,1.8,169.5048755,103.3233103,-1.5524003,5.016757,6.4376717,126.4893012,206.9964778,4.3581206,32.1539351,25.2133601,50.9953617,9.8437469,12.8791635,1.4108832,36.8074577),(26284,'windfallLgGiraffe_tibia-cleaned.tif',247,8,214,3.8486498,169.909879,103.573537,1.8,169.8098928,103.5407579,-1.0780586,2.944294,3.1667022,5.066311,8.787955,0.4979085,2.7751125,1.7207218,4.3578148,5.3320296,6.8263583,0.9994588,19.5638255),(26285,'windfallLgGiraffe_tibia-cleaned.tif',247,8,215,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26286,'windfallLgGiraffe_tibia-cleaned.tif',247,8,216,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26287,'windfallLgGiraffe_tibia-cleaned.tif',247,8,217,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26288,'windfallLgGiraffe_tibia-cleaned.tif',247,8,218,0.0127445,151.7577651,160.7811998,1.8,151.7577651,160.7811998,0.7853982,0.0000000000000201,0.0000000000000201,0.0001787,0.0001787,0.001062,8890095325.89354,8890095322.08326,12572493377.974,0.4101561,0.5800484,2.3561945,1.1600967),(26289,'windfallLgGiraffe_tibia-cleaned.tif',247,8,219,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26290,'windfallLgGiraffe_tibia-cleaned.tif',247,8,220,9.5208917,109.8233732,151.3126116,1.8,109.8524048,151.308854,-1.3956126,5.1640591,5.1497847,54.6045533,56.5106061,1.5386131,10.9733919,10.5739599,20.6838006,10.253903,11.1574528,0.942,34.0479593),(26291,'windfallLgGiraffe_tibia-cleaned.tif',247,8,221,56.5124391,109.9277472,151.2251661,1.8,110.0590611,151.2610622,0.1509824,9.289486,44.633845,1028.9358748,1216.5563612,0.2130802,27.2563648,110.7634887,50.2756364,18.4570255,19.2817006,0.6647745,61.4339),(26292,'windfallLgGiraffe_tibia-cleaned.tif',247,8,222,279.3285466,128.1199213,150.3239031,1.8,126.6752493,151.0403784,-0.0441427,13.0503047,29.7530104,10585.8651638,65641.0222328,0.0906565,2206.1976688,811.158468,2560.7055808,22.9687428,23.6756382,1.3258177,76.0175543),(26293,'windfallLgGiraffe_tibia-cleaned.tif',247,8,223,640.2716543,129.4952625,152.7526023,1.8,122.1612078,153.6826385,-0.0653964,21.2622015,108.2729699,40543.5682244,261145.8316217,0.4557238,2411.9208311,1906.8377373,2785.9387929,26.2499918,26.5969721,0.2973651,86.599168),(26294,'windfallLgGiraffe_tibia-cleaned.tif',247,8,224,666.798719,128.7925488,152.6422195,1.8,121.5771658,153.5622717,-0.062318,21.3488718,107.6094425,42898.1122185,272449.6017397,0.4310307,2531.8373124,2009.3854476,2930.3505803,29.1210846,56.9807095,3.026166,182.4208117),(26295,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26296,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26297,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,3,0.0385905,66.5620523,133.3135995,1.8,66.5600928,133.3145216,1.3078522,0.2793529,0.4001883,0.0017056,0.0031675,0.0059972,0.0079149,0.0061055,0.0121218,0.7773441,1.229089,1.8925469,2.9760054),(26298,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26299,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26300,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,6,192.3314398,130.9945856,136.0769,1.8,131.0668593,134.6557776,1.0263113,19.0556748,45.054062,10604.6060448,52683.7890743,23.454791,1169.3460418,556.5064563,1397.6480282,27.7058066,38.8749801,0.2013171,121.4341959),(26301,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,7,962.9993059,120.8201124,126.3462946,1.8,112.8738176,125.2312368,0.5516755,61.8471957,56.8496146,161538.0914762,542419.7362806,44.0887403,9541.308948,2611.8903147,9580.4070759,54.5125017,99.3032431,2.8681317,394.0302807),(26302,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,8,1874.3325354,104.1220571,126.7487176,1.8,103.7733456,129.2932067,0.0712017,37.6158817,50.9066682,504204.1841135,1386195.8561377,1.5810426,27230.1430036,13404.0240773,31609.1810364,65.4444245,101.7586247,0.2746271,375.8751445),(26303,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,9,1903.859297,102.8571178,127.1383847,1.8,103.4910497,128.7629536,0.0238359,36.5251498,52.0560167,551545.2507133,1399700.772961,0.1802499,26888.3572287,15100.424039,32603.0762165,0.3886721,0.5496653,2.3561945,1.0993306),(26304,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,10,1825.0723908,103.0626906,126.9312816,1.8,103.5830217,128.8218029,0.0329663,36.5665536,51.9802519,547725.5139223,1330302.5052299,0.3304576,25592.4597432,14978.8662194,31233.988978,66.475639,99.4636064,2.7059098,423.6703682),(26305,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,11,1777.6468738,103.2659862,127.0600462,1.8,103.7586725,129.0550874,0.0367421,36.1618075,52.961623,547597.4894518,1292809.4137739,0.3997892,24410.3058071,15142.9789445,30583.4172767,67.6161906,99.138049,2.7130184,376.8249233),(26306,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,12,1736.1737686,103.4982904,127.4723461,1.8,103.6900547,129.5861738,0.0411178,37.9318233,52.2275714,545578.533953,1238621.556708,0.4889401,23715.8559022,14383.1349563,29960.4821922,67.6094071,98.2694911,2.7133285,388.3288315),(26307,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,13,1675.3094219,103.9287359,128.2088677,1.8,103.6955566,130.3658872,0.0441931,37.3577091,53.4737276,532252.9780618,1146084.3299535,0.5449683,21432.6619952,14247.4737055,28114.1379276,68.305422,97.1291437,0.3470616,424.6067426),(26308,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,14,1599.6466059,104.337914,129.0600683,1.8,103.688581,130.9411538,0.0355997,39.3436662,54.7189677,509467.1043326,1048580.8403466,0.3377413,19163.0230658,12949.1517546,25908.6510229,67.0084641,95.7688307,0.3435699,450.3628856),(26309,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,15,1540.2097412,104.3618669,129.5061892,1.8,103.6740984,131.3290672,0.0320813,41.4350538,54.9208666,485526.2346291,957705.7012978,0.2641094,17437.9204266,11717.765287,23871.6156255,66.6543331,95.6243895,0.3268919,461.8182519),(26310,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,16,1485.2736357,104.1835552,129.5377571,1.8,103.5598741,131.2213364,0.02788,42.6779207,54.2018069,457944.1289666,891261.7344087,0.1923673,16443.3952439,10730.2352525,21631.4516533,65.08892,91.5856901,0.301619,463.8054149),(26311,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,17,1431.5646895,104.2036595,129.1010637,1.8,103.7149357,130.8350236,0.0232376,41.9264399,54.3407959,421823.0575836,827017.6834304,0.1288151,15219.0940406,10061.0273226,19664.7532221,0.3886721,0.8690972,2.0344439,1.8766748),(26312,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,18,1388.7260851,104.0291124,128.8137286,1.8,103.7455435,130.7378195,0.021721,40.8315125,54.531257,393038.2314078,776604.1460365,0.1091846,14241.4495564,9625.8553142,18950.0675244,62.875688,84.3024264,0.3728011,404.7339618),(26313,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,19,1376.5811584,103.9468374,128.5324917,1.8,103.6190328,130.3588434,0.0289608,40.9406887,52.9830769,373344.8019912,734080.342478,0.1923763,13854.9964626,9119.1627159,18296.7661674,0.5496653,1.0993306,2.3561945,2.1986613),(26314,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,20,1364.0044576,104.1498608,128.3571459,1.8,103.7622279,130.1632066,0.045088,36.2757484,51.9226825,357052.7696448,690882.9357184,0.4618394,13305.994644,9842.7402628,17437.4336538,0.5496653,1.0993306,2.3561945,2.1986613),(26315,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,21,1335.9337889,104.3955855,128.2718904,1.8,104.0172913,129.9879755,0.0553085,40.3775348,52.7134392,336840.109082,655131.6347994,0.6804151,12428.1709696,8342.2653419,16437.6967341,0.6966587,2.2663282,2.6011732,4.6250014),(26316,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,22,1323.0546815,104.5899692,128.2525605,1.8,104.1425926,129.964346,0.0557869,40.1093422,50.952046,320547.5033176,623879.2270919,0.6855511,12244.4391443,7991.8414531,16064.7983011,0.5496653,1.0993306,2.3561945,2.1986613),(26317,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,23,1307.8389497,104.7332839,128.2290241,1.8,104.4152375,129.8601775,0.0478227,34.1017399,52.1582025,306134.8833778,595506.2779405,0.4981284,11417.3082862,8977.104518,15252.4575548,56.5339823,73.1044543,2.9327273,330.844428),(26318,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,24,1289.53195,104.7177252,128.1100382,1.8,104.5896471,129.5964435,0.0371844,38.6195946,51.6544425,293154.7956331,567073.2264115,0.2970301,10978.2082346,7590.8304729,14717.2127397,1.9126046,2.4887156,0.6747409,7.9229933),(26319,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,25,1277.3806602,104.9318275,128.1243802,1.8,104.7941837,129.4473359,0.0246539,40.3299746,44.0287395,282140.049951,541223.232773,0.1293771,12292.4989149,6995.7904227,15897.8379842,0.5496653,1.0993306,2.3561945,2.1986613),(26320,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,26,1252.0309187,104.9844089,128.1155871,1.8,104.6694971,129.3378936,0.0093622,32.5149853,54.4896716,271755.9192184,518094.491644,0.0182898,9508.1228493,8357.8668942,14470.0067885,0.3886721,0.5496653,2.3561945,1.0993306),(26321,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,27,1226.779599,105.0350896,128.1356834,1.8,104.6976071,129.404219,-0.001661,29.6443232,50.6469629,263970.9565527,497087.6372791,0.0005644,9814.7570746,8904.603929,14361.8254779,54.6548301,69.0141966,0.227221,373.7640886),(26322,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,28,1210.9261856,105.1387318,128.0641425,1.8,104.966717,129.3026891,-0.0069453,30.045012,48.9515405,256226.2234024,479202.2507086,0.0097338,9789.3191047,8528.0785769,13451.9067665,1.8856343,6.1454451,1.2490458,17.0786884),(26323,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,29,1194.5284311,105.276694,128.059522,1.8,105.1084141,129.34057,-0.0135552,29.1821086,39.3122168,249241.2782598,461619.5387822,0.0365768,11742.3940058,8540.8933798,17733.9079564,54.3501175,68.6223635,0.0793783,360.1167633),(26324,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,30,1184.4335613,105.3548769,128.1364505,1.8,105.2317772,129.5424165,-0.0207809,28.2171314,45.0793405,244159.0680085,445716.6732713,0.0852369,9887.3823059,8652.8663988,13856.7483387,52.7386778,66.6988912,0.2053954,290.8684115),(26325,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,31,1173.09963,105.5154412,128.161226,1.8,105.4696382,129.5615267,-0.0280501,27.8070825,39.6029071,239254.8778457,431307.1688013,0.1537927,10890.7956701,8604.0985277,16787.4594894,2.1372576,11.0618012,1.2490458,30.7650772),(26326,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,32,1160.1079098,105.6204625,128.1582247,1.8,105.5869496,129.5650224,-0.030122,27.254314,37.8464381,233565.0530215,416660.7505903,0.175383,11009.2460961,8569.8378987,16851.3819243,51.3047139,65.3443186,0.2218947,238.4939521),(26327,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,33,1159.0279254,105.823618,128.1757056,1.8,105.6774631,129.7539373,-0.0305435,27.4282927,37.6873793,229712.3611391,401995.0378806,0.1801567,10666.5691768,8375.0149289,16372.4881621,1.7223981,3.0356259,0.8760581,9.1556951),(26328,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,34,1147.8002896,105.9206892,128.3099153,1.8,105.7724947,129.8154958,-0.0317958,26.8807731,33.153463,225893.7277972,388677.2067671,0.1933346,11723.5779252,8403.5428136,17888.6161478,2.1873411,13.8892497,1.2578951,35.7511286),(26329,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,35,1144.0408524,106.0295108,128.455156,1.8,105.8542779,129.9329646,-0.0425384,26.2569382,32.8799002,223256.6746956,376328.8266656,0.3448181,11445.5586563,8502.7687995,17881.4510645,2.1861516,18.2054597,1.2895641,46.0061544),(26330,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,36,1142.3559632,106.133593,128.6041881,1.8,105.9568036,130.0568434,-0.0529468,26.9463386,32.2252241,221074.1791731,366298.7407745,0.5332424,11366.8329918,8204.2381518,17660.906378,2.218839,16.2314224,1.2793395,41.5145242),(26331,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,37,1137.6130865,106.2378893,128.7792376,1.8,106.0146449,130.1670056,-0.0597317,27.3173574,32.1223815,219014.1271571,356553.6846747,0.6756737,11099.8521129,8017.3980266,17362.6012851,2.5098028,15.6485768,1.3197936,42.5195471),(26332,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,38,1136.0917147,106.2796488,128.9623084,1.8,106.0449346,130.357209,-0.0739737,26.4946124,31.6169893,217282.2632184,348139.8556386,1.0342487,11011.1640557,8200.9980064,17180.5602088,2.4538588,18.2054597,1.2895641,46.461512),(26333,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,39,1134.8919304,106.3674905,129.0709551,1.8,106.1582879,130.3300866,-0.0794065,26.201577,31.9307329,215868.4701212,341108.0433427,1.1901504,10682.7501904,8238.7586938,17142.7530748,2.3890726,15.749614,1.2958865,41.381153),(26334,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,40,1133.9813687,106.4717996,129.1981809,1.8,106.3357091,130.4976846,-0.0825934,28.0506231,31.0760799,214860.0371716,333999.814537,1.2863434,10747.810389,7659.72422,17026.7691134,1.6317428,10.2021792,1.2610934,24.6244511),(26335,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,41,1138.1632871,106.6591075,129.2906199,1.8,106.4656187,130.5862557,-0.087393,26.9343563,30.6125026,214089.4167891,326157.3771124,1.4451102,10654.38462,7948.5625763,16872.1709291,1.727877,12.5463442,1.2882414,30.8041408),(26336,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,42,1134.6720149,106.721051,129.4298133,1.8,106.5248854,130.7887914,-0.0892391,26.8913435,30.4827941,212765.066024,319045.6496775,1.502022,10466.4175127,7912.0281371,16685.6268069,1.6958894,9.4567997,1.4056476,23.9414146),(26337,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,43,1136.7051799,106.8041253,129.5679531,1.8,106.6017312,130.9652851,-0.0884457,26.9395118,30.5858042,211910.0359769,312985.7584313,1.4781445,10233.0400233,7866.1423968,16580.8958288,2.0094788,13.4920164,1.3677511,35.295771),(26338,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,44,1138.7784919,106.8967112,129.6963328,1.8,106.684886,131.0141631,-0.0852154,27.5013668,30.2712759,211351.4724762,308604.7269392,1.3749053,10194.6389096,7685.1261352,16486.8351647,1.8734712,12.7848892,1.2298174,31.4481137),(26339,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,45,1141.7189225,106.9807028,129.800745,1.8,106.8058802,131.1536238,-0.0799141,27.3772775,29.8368068,211063.1372523,304308.2655605,1.2126327,10199.0895801,7709.4275445,16472.3990322,1.9054076,11.9733711,1.3415644,30.1211043),(26340,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,46,1142.6677085,107.0445365,129.9156338,1.8,106.8872585,131.3153124,-0.0753885,27.0703954,29.5999591,210393.2787395,300425.6019983,1.0803306,10149.5275928,7772.0799898,16339.0158163,2.1286564,16.4026984,1.3315647,40.8314877),(26341,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,47,1144.802225,107.12318,129.9417978,1.8,107.0441519,131.2616245,-0.0745061,26.5319054,29.2749382,209901.0695522,297319.504415,1.0572044,10156.1104042,7911.2700999,16250.6575362,0.7773441,3.205072,1.3258177,7.1847127),(26342,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,48,1144.3069575,107.1910231,130.0063136,1.8,107.1579786,131.3327362,-0.0743961,26.3832945,29.5512007,209265.2193564,293329.8191041,1.0536339,9926.1557071,7931.7319391,16129.2137821,1.4066226,5.4135756,1.2036225,13.6863888),(26343,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,49,1155.6641895,107.3570301,130.1066764,1.8,107.266646,131.5340368,-0.0772371,27.1000594,29.1567433,209580.5460398,289761.1722481,1.1467509,9938.0499908,7733.5825425,16132.0738495,50.0604709,57.2074595,0.7469556,212.1261974),(26344,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,50,1155.7622451,107.4096194,130.2010246,1.8,107.2903327,131.6189555,-0.0810578,28.1156346,29.3383081,208102.3605498,285217.3607329,1.2628597,9721.6703894,7401.6597293,15653.7958064,1.2815105,4.7283999,1.735945,11.4877276),(26345,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,51,1155.0728806,107.4476891,130.2853734,1.8,107.3655065,131.7388016,-0.0948576,26.8583624,28.8530805,206549.404774,280751.825452,1.7270285,9730.3934394,7690.320123,15888.1312085,2.2405647,12.27244,1.3796119,31.9425349),(26346,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,52,1150.1109583,107.4727814,130.3475819,1.8,107.3947505,131.8929131,-0.1025828,27.470521,29.044378,205182.2743095,276543.6238774,2.0100795,9521.4166237,7469.180296,15720.8471176,1.9198178,11.4377944,1.4000611,27.8281353),(26347,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,53,1147.3602756,107.4911045,130.3875015,1.8,107.3925181,131.8953753,-0.1157148,28.0482567,28.5757188,203219.7103398,272466.5309113,2.5490971,9534.8968263,7245.3597459,15557.7973394,2.0304466,14.1265056,1.4327903,35.2405268),(26348,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,54,1144.5571319,107.522107,130.436774,1.8,107.468496,131.9589259,-0.1286763,27.3189975,28.7678676,201507.8016736,268452.963929,3.1411253,9331.6949162,7376.1052691,15378.3569521,1.8951822,13.3569804,1.4247841,33.0418655),(26349,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,55,1144.5385462,107.5416981,130.4323046,1.8,107.5600619,131.8487768,-0.1425296,27.0064207,27.7734273,200046.3492362,265940.3620565,3.8489887,9575.352716,7407.3625402,15326.5705461,1.6730752,6.327123,1.3854484,15.7907425),(26350,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,56,1139.4028064,107.5436388,130.4426945,1.8,107.5575457,131.7870055,-0.1590538,26.376713,27.9704912,198158.0412937,262587.7858637,4.7637458,9388.0291041,7512.6131568,15157.5802537,49.7480954,56.1627786,0.844154,205.0910366),(26351,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,57,1143.8005202,107.6336101,130.4517774,1.8,107.5928498,131.8719474,-0.1806133,26.3307485,28.5406284,196619.2556403,258880.0773985,6.1513584,9070.5808598,7467.2869745,15051.2445254,1.1071562,2.0930632,1.1902899,5.1746667),(26352,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,58,1139.4440977,107.6673377,130.4903732,1.8,107.6076586,131.9491349,-0.1925929,26.9611158,28.2167694,194303.1709743,254646.6986905,6.957383,9024.6581854,7206.7926533,14869.6448478,0.7773441,1.602536,1.815775,3.7533496),(26353,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,59,1133.9694208,107.6964171,130.5288343,1.8,107.656919,132.0271624,-0.2065081,27.032993,28.1719617,192236.621031,250423.2958802,7.9458769,8889.0968314,7111.1852594,14622.5728054,1.5310691,5.7780258,1.2277724,13.45871),(26354,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,60,1130.08437,107.7368428,130.5515298,1.8,107.7258847,132.0605042,-0.2155873,26.6054837,28.1558362,190506.609565,246925.2877494,8.6192058,8769.9504288,7160.4264521,14540.1740452,1.1360635,7.0925998,1.4056476,15.9241136),(26355,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,61,1125.708492,107.79526,130.5880082,1.8,107.7695111,132.1805793,-0.224995,26.7933893,27.8249443,189222.4950152,243629.4303995,9.3385515,8755.7922147,7062.2829089,13772.2541922,0.7773441,3.5833795,1.3521274,7.9620568),(26356,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,62,1121.5768374,107.8318517,130.5665407,1.8,107.7996059,132.1470746,-0.2320297,26.7878455,28.2166281,186919.3399826,240068.8576835,9.8845539,8508.0632859,6977.7668259,13891.4777265,1.2106579,4.1861264,1.1902899,10.0273469),(26357,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,63,1115.7925668,107.871238,130.5298017,1.8,107.8943429,132.0081795,-0.2413074,26.9529477,27.5125578,184964.8642544,237479.8342192,10.6200739,8631.6887058,6862.5096778,13976.0689929,1.1660162,3.5833795,1.3521274,8.8337086),(26358,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,64,1110.5172511,107.9096695,130.5109488,1.8,107.9367542,131.9608912,-0.2507716,26.5456166,27.3379333,183434.8030252,234865.4373723,11.3974592,8591.1921303,6910.1730093,13862.3208101,0.7773441,1.0993306,2.3561945,2.1986613),(26359,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,65,1113.2063172,108.0658103,130.5300209,1.8,108.0713138,132.1152113,-0.266558,26.9553579,27.3025979,182542.2123538,232174.5560478,12.8735265,8503.7532614,6772.0196157,13583.5453781,49.7312186,55.2693877,0.9301082,191.8990689),(26360,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,66,1107.5127777,108.1032097,130.5651267,1.8,108.105862,132.1231022,-0.2764083,27.0704831,27.0703818,180545.1539236,228844.376523,13.7471035,8453.6811421,6669.4470478,13591.6959131,49.4960526,55.037942,0.9357696,207.705992),(26361,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,67,1102.078385,108.1446084,130.6023211,1.8,108.1878682,132.1962047,-0.2881074,27.3075776,27.1121475,178912.6455322,225615.9272621,14.8292847,8321.5808539,6551.7582071,13429.376061,0.3886721,0.8690972,2.0344439,1.8766748),(26362,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,68,1099.9520626,108.180784,130.6230375,1.8,108.1945869,132.228164,-0.2963703,27.2123145,27.2605099,177638.4486988,223449.0784473,15.6364813,8196.8048024,6527.8699042,13314.0909986,1.2601365,5.9455395,1.3734008,13.2700947),(26363,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,69,1095.372154,108.2072569,130.6474759,1.8,108.1952007,132.189735,-0.3071552,27.2373653,27.0443854,176120.8094002,221144.8814132,16.6888033,8177.1087721,6466.1470475,13189.8481818,0.7773441,1.229089,1.8925469,2.9760054),(26364,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,70,1095.927436,108.2462298,130.6594258,1.8,108.2620466,132.2844018,-0.3170724,27.1357692,27.0376785,175231.8044901,219205.5242742,17.7559717,8107.4092345,6457.5948812,13103.4313208,0.7773441,1.7381944,1.1071487,3.7533496),(26365,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,71,1094.2979376,108.3004683,130.6335139,1.8,108.3280249,132.1509528,-0.3172862,26.4061227,27.7001383,174532.2587013,218096.7875703,17.7526852,7873.4909271,6609.537512,12912.0278149,0.3886721,2.7483266,1.7126934,5.7633955),(26366,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,72,1093.1315709,108.3507459,130.6324541,1.8,108.3886052,132.0707645,-0.3195857,26.7682548,26.3329361,173972.8995235,216894.5401405,17.9828924,8236.6257877,6499.2245836,13065.1399076,48.3810095,54.6481783,0.9216054,192.8097842),(26367,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,73,1099.0130273,108.5210028,130.669063,1.8,108.5586604,132.1670504,-0.3261391,26.6064884,26.6000786,174078.3724976,215224.3225514,18.8020049,8091.1160412,6542.7037947,12958.953541,48.8681696,54.58041,0.9472356,201.1881352),(26368,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,74,1095.9235449,108.5953818,130.6971286,1.8,108.614004,132.2229817,-0.3270475,26.805872,26.4699439,172835.6600712,212658.1322862,18.8499909,8033.9472369,6447.6790817,12903.8822084,0.3886721,0.8690972,2.0344439,1.8766748),(26369,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,75,1090.3254516,108.6642612,130.7115331,1.8,108.7147635,132.2813091,-0.3263805,27.2470237,26.4051077,171401.7309659,209863.0048251,18.6800158,7947.8185403,6290.6588474,12844.667087,0.3886721,1.229089,1.8925469,2.6540189),(26370,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,76,1086.0554572,108.7468301,130.7170184,1.8,108.8139631,132.2694645,-0.3211496,26.9442983,26.4286915,170269.7134572,207811.8829838,18.035707,7863.1166105,6319.3226194,12547.8839355,48.9726814,54.1148229,0.9847858,213.508451),(26371,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,77,1084.6797039,108.8398361,130.7068284,1.8,108.8956542,132.2537034,-0.3102815,26.7237579,26.4214134,169590.1932524,205669.2705414,16.8531067,7784.1888185,6346.0458728,12776.3406569,0.3886721,0.8690972,2.0344439,1.8766748),(26372,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,78,1083.5420397,108.93334,130.7073784,1.8,109.014357,132.2727157,-0.2971085,26.5968856,26.2649159,168884.8119654,203937.2168213,15.477754,7764.624765,6349.796541,12727.0746633,0.3886721,0.8690972,2.0344439,1.8766748),(26373,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,79,1084.7730901,109.0090867,130.6624001,1.8,109.0700171,132.1278795,-0.2857459,26.640179,25.575468,168544.8836875,203249.572128,14.364654,7947.0519172,6326.7173892,12690.5688243,48.3712939,53.6001198,1.0129657,205.9074442),(26374,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,80,1082.5933453,109.1001107,130.6269162,1.8,109.1527966,132.070725,-0.2736429,26.4436507,25.4955233,167706.4272644,202271.0734379,13.1769603,7933.5917407,6342.0300386,12246.8037541,48.1652547,53.4957377,0.9505468,182.1937085),(26375,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,81,1086.9808508,109.3115957,130.6230095,1.8,109.4053192,132.1408052,-0.2626417,26.3024755,25.9789234,167295.4318294,201000.1979294,12.2120625,7737.0487969,6360.4443558,12686.1857956,48.1953373,53.3260353,0.9302107,191.2160324),(26376,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,82,1081.7233426,109.4152718,130.6259018,1.8,109.527274,132.1082143,-0.2491279,26.2444519,25.7222581,165794.2595098,199094.8862109,10.9598925,7740.1791603,6317.3069845,12555.1784503,48.3089447,53.1799421,0.9462988,188.0123482),(26377,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,83,1078.0929066,109.508419,130.6498635,1.8,109.6358302,132.1830464,-0.2385952,26.72107,25.9101142,164699.0270634,197574.7137921,10.0362538,7625.3895404,6163.6389254,12294.2985018,48.1953373,53.094654,0.9360798,209.7160379),(26378,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,84,1076.4448225,109.6119715,130.6329742,1.8,109.7283936,132.1267197,-0.2299097,26.4596651,26.1020378,163738.2520601,196655.8916426,9.3172924,7534.1202504,6188.2208837,12470.8375244,48.1953373,52.9536283,0.9522533,190.5882401),(26379,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,85,1073.1747934,109.7105743,130.639265,1.8,109.8556637,132.1346646,-0.2206987,26.1685436,25.8735324,162772.5003885,195761.3806784,8.5714864,7566.086373,6220.158937,12442.4617911,48.1953373,52.9536283,0.9522533,188.5620135),(26380,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,86,1069.6336236,109.8203357,130.6477571,1.8,109.9663017,132.1509063,-0.2140152,27.0821098,25.6449676,161815.6134039,194927.1627818,8.0414154,7600.9908062,5975.0002609,12340.9030898,47.8066652,52.8722611,0.90524,189.7556518),(26381,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,87,1066.5605296,109.9099301,130.6108776,1.8,110.0439095,131.9915844,-0.2065131,25.8357919,25.0319671,160948.2034185,194711.1485599,7.473894,7778.4996987,6229.6601624,12348.2361984,47.660804,52.7048505,0.9213956,182.8376814),(26382,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,88,1063.9878301,109.9958837,130.5981458,1.8,110.1206831,131.9408674,-0.204573,25.2771737,25.1451261,160436.1249967,194239.2517686,7.3183863,7724.7276738,6347.0753008,12368.8658172,47.0875993,52.6331452,0.9110485,177.6239512),(26383,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,89,1065.4742278,110.2150753,130.6261881,1.8,110.333514,132.1376125,-0.2029691,26.7058961,25.917167,160102.050964,193572.2646123,7.2157203,7468.88211,5995.0076245,12383.6961926,47.7008322,52.5067059,0.8902751,177.3019647),(26384,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,90,1060.2169486,110.3246089,130.6353987,1.8,110.4530135,132.1113588,-0.2040521,25.7345204,25.3437318,158478.6229267,192125.8159503,7.2558718,7580.8021382,6158.2116261,12302.023591,47.3771644,52.4520129,0.8798531,173.9096652),(26385,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,91,1053.3583699,110.4367894,130.6762481,1.8,110.5475856,132.2010846,-0.2012727,25.3221741,25.9009169,156995.2455773,190763.6850782,7.0165284,7365.1325138,6199.9117927,12233.0524417,47.8066652,52.2630272,0.8960554,190.7054306),(26386,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,92,1050.5148046,110.5445264,130.698525,1.8,110.659862,132.1595327,-0.1950408,25.0039291,25.6669171,156084.3874237,190244.7377397,6.5763983,7412.0603233,6242.3944244,12214.6890504,47.5101614,52.2630272,0.8960554,185.2640216),(26387,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,93,1046.1141152,110.6564455,130.7342317,1.8,110.7504867,132.2133431,-0.1857227,25.950978,25.3616246,155178.9305827,189434.2544101,5.9450901,7469.326485,5979.6948812,11933.4280438,47.7283701,52.2630272,0.8960554,186.1356734),(26388,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,94,1040.7798838,110.7503315,130.7644695,1.8,110.8610123,132.2034819,-0.1767591,24.8839198,25.2432248,154018.5398665,188801.7157467,5.3634387,7479.3025689,6189.4806352,12157.8155681,47.4179931,52.021111,0.9018896,186.2138004),(26389,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,95,1038.641934,110.8449858,130.7556002,1.8,110.9571427,132.1245773,-0.1669728,24.7621508,25.6081405,153440.9550829,189117.1624501,4.7815218,7385.0408052,6196.5923735,11983.3822119,47.0351643,52.0878588,0.912371,181.510672),(26390,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,96,1031.8108676,110.9347966,130.7801205,1.8,111.0109321,132.1209215,-0.1579076,24.1627515,25.230414,152706.3759886,189097.0514149,4.2524801,7494.8057307,6319.9084046,11947.961244,46.6766513,52.0878588,0.912371,196.9794279),(26391,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,97,1036.4530794,111.1585839,130.8103163,1.8,111.2892872,132.2722052,-0.1490175,24.8872545,33.3316979,152462.8851626,189012.0970736,3.8076373,5670.6411357,6126.1432083,9319.7629239,0.3886721,0.5496653,2.3561945,1.0993306),(26392,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,98,1030.3152228,111.2608342,130.8693079,1.8,111.3903663,132.3698681,-0.139143,25.0249739,39.6378564,151406.1645399,188119.3139302,3.303215,4745.9507436,6050.2026916,7285.8931745,0.3886721,1.229089,1.8925469,2.6540189),(26393,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,99,1026.7455337,111.3767452,130.9247301,1.8,111.5250977,132.4896021,-0.1298009,26.085687,25.5997773,150207.3967951,187350.9922917,2.8669916,7318.461788,5758.2304386,11326.4586207,0.7773441,1.602536,1.815775,3.7533496),(26394,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,100,1024.2890635,111.4851568,130.9455313,1.8,111.6289329,132.4261376,-0.1206186,24.7619893,25.7578819,149392.5929315,187051.2702304,2.4716828,7261.9041847,6033.1418067,11865.9597767,46.8491898,51.8553225,0.8703,190.2891365),(26395,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,101,1018.6130568,111.5804886,130.9977357,1.8,111.7318762,132.4889276,-0.1108608,25.9499532,25.33616,148647.4413234,187012.4600796,2.0779432,7381.2472146,5728.235423,11973.9946604,0.3886721,2.3641999,1.735945,4.9860514),(26396,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,102,1016.5947237,111.6940851,131.0263314,1.8,111.8468608,132.5269872,-0.1041914,25.1841523,25.8003787,148024.7802805,186844.947319,1.832685,7241.9459223,5877.695563,11971.5302106,46.9705908,51.7167594,0.8972291,194.3644725),(26397,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,103,1014.0899582,111.791983,131.006211,1.8,111.9136356,132.3851047,-0.096009,24.2092548,25.3174792,147796.9166124,187580.5162227,1.5531533,7409.130838,6104.975884,11996.1927572,0.7773441,1.229089,1.8925469,2.9760054),(26398,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,104,1011.612705,111.8839201,131.0082459,1.8,112.0256407,132.3465797,-0.0880028,24.2339404,25.3151878,147726.4699531,188166.5798035,1.3023682,7432.9521599,6095.8501781,12006.310765,45.9204024,51.6158857,2.4950795,185.4917004),(26399,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,105,1016.9100854,112.1012052,131.058599,1.8,112.2331682,132.5488726,-0.070116,26.1619534,25.7918998,148045.4868837,189001.6016081,0.831867,7327.9441747,5658.8085889,12040.5771002,46.250416,51.7167594,2.4680254,195.1970608),(26400,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,106,1013.542962,112.1986135,131.091794,1.8,112.3477066,132.5768885,-0.059641,26.4143489,25.6479834,147599.820966,188758.1269426,0.6001575,7359.5699078,5587.8651884,11936.9245842,46.2051292,51.8698866,2.5265696,187.0854522),(26401,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,107,1011.5771816,112.3070803,131.1378212,1.8,112.4684061,132.7847445,-0.0473075,25.6922194,25.668511,147756.3372799,188686.1523189,0.3770372,7350.8803218,5751.0149213,11979.930226,0.3886721,1.229089,1.8925469,2.6540189),(26402,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,108,1011.1719585,112.4115152,131.162638,1.8,112.5630169,132.7737703,-0.0321168,25.5936217,25.5097482,147906.3511293,189129.8463458,0.1737755,7414.0224623,5779.0317053,11851.2233284,1.1660162,3.1335744,1.6951513,7.734378),(26403,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,109,1011.0723008,112.5123988,131.1852346,1.8,112.6525482,132.8450234,-0.020062,25.3705823,25.822536,148144.0747162,189488.3922392,0.067815,7338.1015697,5839.2067203,11907.3756502,0.3886721,0.8690972,2.0344439,1.8766748),(26404,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,110,1006.463003,112.6134374,131.1783306,1.8,112.7350907,132.8427813,-0.0107184,26.1417915,25.7461092,147773.6422121,189952.4844892,0.0192703,7377.9102984,5652.7741211,11951.0735658,46.4812951,52.1993976,2.5845719,191.3103401),(26405,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,111,1007.1639949,112.7326044,131.1339287,1.8,112.9048966,132.6976124,0.0024397,25.1179033,25.651277,147998.6039983,191562.1599391,0.0009995,7467.9385279,5892.1559681,11973.2054994,46.2309236,52.3222488,2.5144348,194.9303185),(26406,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,112,1005.9224615,112.845693,131.1136653,1.8,112.9983975,132.6456328,0.0131449,24.5131563,25.6351417,148286.8359588,192661.1248376,0.0289668,7515.5084751,6049.2755079,11950.4788759,46.339905,52.4707301,2.4980915,187.0073252),(26407,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,113,1007.1091076,113.071911,131.1314268,1.8,113.2258563,132.7537347,0.0306073,25.3874794,25.8458472,148796.6342229,193545.0791569,0.1571947,7488.4401078,5861.0243229,12026.1721395,46.6471102,52.5512817,2.5084462,191.1217247),(26408,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,114,1005.9907158,113.1799349,131.1385938,1.8,113.3544549,132.7173731,0.0457708,25.6123385,25.8799561,148141.2024011,193753.8944453,0.3510071,7486.63923,5783.9779907,11972.6731155,1.1660162,4.2930234,1.6614562,9.7444239),(26409,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,115,1004.4076359,113.274062,131.174353,1.8,113.4515889,132.8436928,0.0558227,25.6061015,25.8868661,147821.260281,193836.5476945,0.5211105,7487.8336834,5772.8920744,11790.2998568,46.8150232,52.8093655,2.4657023,190.8388018),(26410,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,116,1003.1265506,113.3853652,131.1922298,1.8,113.5321858,132.8533694,0.0667771,25.9493512,26.1287277,147588.2051843,194601.9165318,0.7444124,7447.8144943,5687.5489397,11880.041477,46.8224783,52.9536283,2.5230497,181.871722),(26411,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,117,997.9561114,113.462835,131.2077954,1.8,113.6218355,132.8723901,0.0673343,25.2979512,26.3406443,146871.434727,194860.8062844,0.7529664,7397.7236253,5805.6651959,11718.8494962,1.1660162,4.4315435,1.3045443,10.8046911),(26412,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,118,996.1646977,113.5632777,131.2303586,1.8,113.6984243,132.8279586,0.076959,25.1881873,26.2924241,146550.0496969,195550.9192562,0.9813882,7437.538603,5818.2055029,11827.9173171,0.3886721,2.3641999,1.735945,4.9860514),(26413,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,119,995.6150922,113.6325103,131.2038725,1.8,113.8044987,132.7041125,0.0773058,24.7163094,26.2565622,146349.0866939,196435.8862517,0.9896904,7481.4015795,5921.1545122,11796.6566149,0.3886721,0.8690972,2.0344439,1.8766748),(26414,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,120,995.0589863,113.7055235,131.1748279,1.8,113.8484796,132.6326287,0.0770013,24.6581659,25.6841923,146167.9101942,197025.8217977,0.9813734,7671.0927638,5927.768962,11784.8026061,46.0247283,53.1628954,2.4234504,194.6473955),(26415,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,121,1002.7899481,113.9133803,131.1843216,1.8,114.1245366,132.8198212,0.0828563,25.0402283,26.9654847,146880.1037643,197740.3042598,1.1447635,7333.0891899,5865.7653668,11875.0506444,0.3886721,0.5496653,2.3561945,1.0993306),(26416,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,122,1000.1528396,113.9644778,131.2137315,1.8,114.103814,132.8249992,0.0821794,25.0415334,26.5846981,146190.4878289,197053.4351251,1.1232168,7412.2878584,5837.9207734,11757.5954362,46.2036873,53.2991162,2.4543239,184.2980621),(26417,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,123,1000.2866475,114.0606462,131.2752446,1.8,114.2097153,132.9250482,0.0905101,25.3410187,27.1003676,146253.7371855,197201.5693279,1.3620126,7276.7119656,5771.4229542,11801.8612219,0.3886721,0.8690972,2.0344439,1.8766748),(26418,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,124,997.5952468,114.1315149,131.2909274,1.8,114.2819838,132.9095064,0.0885476,25.1708408,26.9863499,145871.9239856,197234.1971335,1.3002312,7308.6652332,5795.2741906,11643.6658675,46.5366128,53.2494927,2.4907924,186.0966099),(26419,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,125,998.4792117,114.2137601,131.3457758,1.8,114.3648724,132.9450715,0.0879234,25.6419114,26.726746,145666.4770264,197706.9955775,1.2831503,7397.3462933,5680.7963693,11755.5081277,46.7893718,53.2480742,2.4440506,189.4336653),(26420,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,126,1005.448984,114.2637463,131.3850487,1.8,114.4027949,132.9409234,0.0833823,25.0332304,33.559455,145249.4495349,197945.9091381,1.1623825,5898.3648369,5802.2655142,8968.0243071,46.2158325,53.2480742,2.4440506,188.884),(26421,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,127,1010.1746484,114.319989,131.3773169,1.8,114.4596577,132.8604349,0.0709716,24.9164073,27.1962588,144925.597437,198735.9542194,0.8466142,7307.4740028,5816.4724743,11810.4579221,46.0835138,53.1799421,2.5170951,184.8086639),(26422,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,128,1006.6079806,114.3762282,131.3591093,1.8,114.5166376,132.8456755,0.0748986,24.8062848,26.5315103,144759.1464603,199651.8778293,0.9393877,7525.0852777,5835.5834959,11846.7135649,45.7729536,53.1287857,2.4131277,192.4096707),(26423,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,129,1012.7150289,114.5056987,131.3398974,1.8,114.6319763,132.8400061,0.0720073,25.1103887,26.2436336,145018.5638229,200255.8157939,0.8736521,7630.6436418,5775.2416879,11905.3137848,0.3886721,0.5496653,2.3561945,1.0993306),(26424,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,130,1009.9593107,114.5233033,131.3494927,1.8,114.6650819,132.8179417,0.0608318,24.5391,26.1761459,143672.0336885,199633.7936536,0.6221244,7626.5541309,5854.8208275,11836.2290211,0.7773441,1.0993306,2.3561945,2.1986613),(26425,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,131,1004.2319873,114.5897614,131.4039593,1.8,114.7325231,132.9001963,0.0600665,24.8719723,26.705098,142870.5183294,199431.0790388,0.6031488,7467.9029082,5744.2376055,11836.6302205,0.7773441,2.7483266,1.7126934,6.4073685),(26426,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,132,1000.4806986,114.6496479,131.4285137,1.8,114.7244115,132.9111532,0.0607688,25.0443012,26.352145,142565.5991907,199708.5196178,0.6150106,7578.4540341,5692.5365092,11833.177619,0.3886721,1.229089,1.8925469,2.6540189),(26427,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,133,992.7112378,114.715795,131.4222423,1.8,114.8300422,132.9282102,0.062236,25.8925829,26.5113239,141904.539182,199793.1625715,0.6400194,7536.1443163,5480.5092209,11828.7246311,46.1567501,52.929374,2.5495168,193.1870149),(26428,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,134,986.4066593,114.7341963,131.3967245,1.8,114.8550391,132.9109432,0.0500333,24.9570542,26.4555781,141049.2514424,199037.4224547,0.4112053,7523.4576894,5651.6786935,11881.4049319,0.5496653,1.0993306,2.3561945,2.1986613),(26429,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,135,984.9626974,114.8006331,131.3736417,1.8,114.873719,132.8279483,0.0519772,24.4335177,26.3930507,140807.4716356,200377.0283883,0.4431008,7592.037422,5762.8816878,11962.0167335,46.1182519,52.7292081,2.5290551,185.586008),(26430,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,136,980.5529898,114.8130441,131.3251003,1.8,114.9015646,132.7351303,0.0443987,25.8609521,26.5562409,139825.5963781,200477.8032518,0.3219401,7549.1785183,5406.8232182,11931.3481755,0.3886721,0.5496653,2.3561945,1.0993306),(26431,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,137,985.043449,114.9476825,131.279178,1.8,115.0308529,132.7018099,0.0364333,25.0397518,26.3811183,139483.7408878,200499.1830203,0.2178244,7600.101735,5570.4921574,11939.1070121,45.6725926,52.5670899,2.4714706,198.3616816),(26432,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,138,979.3051848,114.9760447,131.2474279,1.8,115.0393829,132.6591614,0.0245236,24.8010801,42.0403481,137868.4626175,199070.8054459,0.0981402,4735.2320914,5558.9700899,7759.2748001,45.7138711,52.5067059,2.5351117,190.1167018),(26433,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,139,975.424666,115.0253496,131.2545816,1.8,115.0865034,132.6914848,0.0244262,26.5947916,26.2095715,136818.0621752,198245.7750302,0.0969759,7563.8693784,5144.5434923,11876.9518125,45.3795243,52.3265794,2.5948038,190.2110094),(26434,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,140,971.6568057,115.0280391,131.2275443,1.8,115.0941596,132.6705879,0.0174611,24.3186956,26.1738258,135728.0762198,197726.9304356,0.0493679,7554.3763381,5581.2235275,11828.385062,0.3886721,1.229089,1.8925469,2.6540189),(26435,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,141,963.4942072,115.0592696,131.1633596,1.8,115.1442186,132.5719029,0.0154511,24.1123051,26.1308854,134227.8047037,196968.0669541,0.0383336,7537.7494595,5566.7761447,11749.9728992,45.0859607,52.1993976,2.5845719,198.0396951),(26436,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,142,957.5261396,115.0640521,131.0943349,1.8,115.1610304,132.4979044,0.0050823,25.149626,40.3837509,132599.3869208,196278.8077979,0.0041218,4860.341185,5272.4198413,7858.7120144,0.7385693,1.7381944,1.1071487,3.7533496),(26437,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,143,953.4713455,115.0627941,131.0210887,1.8,115.1173613,132.3546373,0.0018639,22.9191226,26.0489468,131513.8348482,196464.1526164,0.0005519,7542.1150034,5738.1705811,11695.1643868,44.2252853,51.9266474,2.4995885,190.3443806),(26438,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,144,951.1788506,115.1036117,130.9981249,1.8,115.1756377,132.3741814,0.0016957,22.9365111,25.9935145,130929.8819347,196320.4339447,0.0004555,7552.6698741,5708.3608399,11742.7543327,44.1797694,51.8509525,2.5535901,192.4487342),(26439,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,145,954.1535229,115.2883054,130.9454499,1.8,115.3704275,132.3498016,0.0013773,23.3753394,26.1947798,130304.8963883,196288.7520085,0.0003014,7493.4301323,5574.4600727,11685.1479298,44.1662028,51.7503403,2.5702552,177.2467206),(26440,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,146,949.898864,115.3279907,130.925197,1.8,115.389321,132.2822143,-0.000218,22.9882048,26.1478687,128679.7426746,195268.0076726,0.0000082,7467.8364798,5597.6420825,11681.0042532,44.1188514,51.659768,2.7149652,187.674181),(26441,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,147,944.2015707,115.348668,130.8717402,1.8,115.4057474,132.2049354,-0.0042975,23.4379118,26.1406123,127221.5616557,193933.6979311,0.0029072,7418.8659217,5428.0245817,11672.8712072,0.3886721,0.8690972,2.0344439,1.8766748),(26442,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,148,936.3906354,115.36283,130.8182349,1.8,115.4317691,132.1788934,-0.0081011,24.2270813,26.490831,126099.7375091,193066.5427604,0.0102425,7288.051577,5204.9083439,11613.7285216,44.5699785,51.4693409,2.7049655,198.4007451),(26443,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,149,932.7941206,115.4000183,130.7691611,1.8,115.4859921,132.1661817,-0.0100491,24.765177,26.0614392,125282.4677404,192707.2545379,0.0156984,7394.3442921,5058.8157586,11569.6135559,44.2323876,51.3944422,2.7456381,197.3957221),(26444,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,150,929.6961693,115.4313739,130.7377908,1.8,115.5377164,132.1667271,-0.0139736,24.0980514,26.0756907,124498.325319,192498.7258996,0.0302533,7382.3059207,5166.3233318,11535.0674606,44.0917225,51.3429779,2.7287487,193.7757437),(26445,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,151,926.2596929,115.4351145,130.6199691,1.8,115.5174659,131.9735222,-0.0165479,23.348874,26.0319566,123488.0328455,192981.4122458,0.0422677,7413.2503817,5288.8217603,11501.4073065,44.1868685,51.3429779,2.7287487,214.874524),(26446,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,152,922.5152708,115.4498127,130.55126,1.8,115.4994879,131.8809616,-0.0189884,23.2477031,26.5063667,122825.7437472,193391.0647659,0.0554294,7296.0231412,5283.3496393,11516.9297618,43.8700541,51.3429779,2.7287487,206.4799924),(26447,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,153,923.6864899,115.6084424,130.4180812,1.8,115.7408022,131.8536909,-0.0218782,23.3276521,26.229731,122474.2905396,193832.6355771,0.0736757,7389.806452,5250.1764859,11564.3960983,0.3886721,0.5496653,2.3561945,1.0993306),(26448,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,154,919.9624846,115.6385523,130.3480384,1.8,115.7945157,131.7154006,-0.0263479,23.1646043,26.5280376,121286.3768428,193144.3438112,0.1064167,7280.762602,5235.8492769,10870.6560071,43.5312724,51.3179623,2.7695249,208.2785402),(26449,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,155,916.9416685,115.680312,130.2766117,1.8,115.8508627,131.7294462,-0.0304974,23.7468312,26.6108962,120292.8942834,192495.7672058,0.1420967,7233.7198294,5065.6398525,11078.72529,43.3666604,51.2457903,2.7526358,187.8237328),(26450,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,156,911.8594427,115.7532049,130.2019724,1.8,115.8916272,131.6044339,-0.0312854,23.0474029,26.439076,119336.128217,192063.3347027,0.1487015,7264.3739352,5177.8557832,10478.0226279,43.5312724,51.3179623,2.7695249,191.4437112),(26451,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,157,909.8244466,115.8150498,130.1150546,1.8,115.9555599,131.5256514,-0.0324403,23.4740356,26.4347033,118633.1287813,192072.9807789,0.1595231,7265.9404803,5053.8020199,11360.1622867,0.3886721,1.602536,1.815775,3.4313631),(26452,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,158,904.9157177,115.8035797,130.0555976,1.8,115.9668066,131.4361104,-0.0358851,22.8320509,26.44195,117853.6306649,191610.7663515,0.1941309,7246.4688374,5161.7627916,11212.009708,42.678232,51.3061861,2.8653742,183.1987314),(26453,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,159,907.2080753,115.8178111,129.9690722,1.8,115.957,131.2697922,-0.0382753,22.5246504,26.4226455,117618.3884315,192308.8217574,0.2214026,7278.181963,5221.7631094,11308.0850014,0.3886721,1.229089,1.8925469,2.6540189),(26454,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,160,904.7721135,115.8849877,129.9081898,1.8,115.973209,131.1437812,-0.0392938,22.3552062,26.7864178,117567.5077542,192317.7856182,0.2327084,7179.6754164,5259.0661405,11282.8684072,42.236705,51.3061861,2.7118304,176.7361188),(26455,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,161,909.9412709,116.0867802,129.7519132,1.8,116.2979856,131.031623,-0.0389457,22.7213326,26.8610646,117771.3902974,192262.1023493,0.2299105,7157.6501127,5183.2959033,10813.8414351,42.3652561,51.4047289,2.7863618,197.2071068),(26456,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,162,907.2989438,116.1210413,129.7401191,1.8,116.264484,131.0828758,-0.0398369,22.7443633,26.9250122,117099.8675287,191655.6957012,0.2398503,7118.1284742,5148.5225596,11052.4635468,0.3886721,0.5496653,2.3561945,1.0993306),(26457,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,163,907.6572906,116.178649,129.7134588,1.8,116.4041204,131.0494765,-0.0419194,23.1487581,27.0827931,116484.543721,191319.2007676,0.2656726,7064.2344794,5031.9996884,11203.5268584,42.4972879,51.4135444,2.8581009,189.7947153),(26458,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,164,909.1959205,116.2143991,129.6718179,1.8,116.414027,130.9453721,-0.0425537,23.1460555,26.753425,115958.6110751,191645.5436166,0.2742335,7163.4022033,5009.8649094,11236.2898368,42.4589314,51.523611,2.8508584,194.3644725),(26459,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,165,906.7167447,116.2772975,129.6285666,1.8,116.4575115,130.9304578,-0.0413801,24.8458581,26.9669814,115399.1000376,191780.905741,0.2586151,7111.6934868,4644.601107,10932.8389942,42.9181215,51.5763596,2.8746797,191.8990689),(26460,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,166,907.10915,116.3079694,129.5742118,1.8,116.5054838,130.856654,-0.0411714,22.6936318,27.3554387,114791.5341729,191920.9562156,0.2561272,7015.8244607,5058.3148165,11078.1301352,42.1915282,51.5763596,2.8746797,188.8287558),(26461,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,167,916.2268975,116.3709739,129.5687635,1.8,116.5687939,130.794847,-0.0383073,23.3214113,26.9601494,115145.6245687,193689.1402571,0.2239768,7184.2754872,4937.3351759,11257.6343743,42.8723293,51.6802337,2.8674252,215.3689452),(26462,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,168,916.2791755,116.4022103,129.5326407,1.8,116.6158147,130.6777003,-0.0376944,22.1953602,27.3030565,114938.2169853,195112.2079531,0.2168823,7146.1672401,5178.4794741,11271.9595388,0.3886721,0.5496653,2.3561945,1.0993306),(26463,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,169,923.7714073,116.5915652,129.470646,1.8,116.8371655,130.7298817,-0.03536,22.8373266,27.4938488,115259.4903314,196539.5072797,0.1924214,7148.4901393,5046.9782407,11241.9342993,42.2812715,51.8902694,2.9912212,210.9325591),(26464,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,170,925.5623174,116.6612845,129.5179977,1.8,116.8819144,130.8099282,-0.0329731,22.9423935,26.930586,115067.8704752,197085.0144144,0.1676547,7318.2594205,5015.5128937,11129.3703459,42.5152137,52.077707,2.9690821,219.7662677),(26465,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,171,925.9038639,116.7129408,129.5262232,1.8,116.9228523,130.8775902,-0.0297395,25.3472974,27.0288859,115069.5980193,197432.8713842,0.1364443,7304.5138365,4539.7186258,11122.0510896,42.4664625,52.0544956,2.8694468,190.2500729),(26466,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,172,924.9059128,116.7445761,129.5395558,1.8,116.9939824,130.8764115,-0.029734,24.9444984,27.0554509,115061.0468293,198736.2901519,0.1362465,7345.5175665,4612.6823194,11215.6685282,43.0342805,52.2268835,2.8857841,205.5854577),(26467,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,173,924.2355003,116.7719565,129.5523216,1.8,117.0341452,130.772398,-0.0321098,22.5902583,27.2405515,114695.2922281,200362.4967165,0.1587651,7355.3025074,5077.2014407,11277.8356746,0.3886721,1.229089,2.8198421,2.4263401),(26468,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,174,923.8485425,116.7879512,129.584574,1.8,117.082813,130.7527764,-0.030189,22.3117235,27.7314673,114740.3064525,201956.4161725,0.1402859,7282.5723196,5142.6016562,11281.6948382,42.3652561,52.534031,2.8643093,216.1462893),(26469,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,175,927.3161477,116.78854,129.6225702,1.8,117.1410013,130.6812811,-0.0282112,22.153834,27.4143509,115306.3984919,205034.8441462,0.1229708,7479.1062849,5204.8055547,11479.4139985,0.3886721,1.229089,1.8925469,2.6540189),(26470,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,176,930.7416833,116.8082776,129.6479037,1.8,117.217448,130.6182813,-0.0295629,22.0887312,27.7146595,115900.5633089,207915.5549139,0.1355337,7502.0064756,5247.0448464,11600.6236193,41.587912,52.9921271,2.9197415,234.5748701),(26471,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,177,935.08364,116.9614722,129.6691703,1.8,117.3833057,130.7236946,-0.0284058,22.4148622,27.9756489,116926.9825322,211514.2473634,0.125718,7560.6556351,5216.4934875,11470.7333745,42.5069124,53.4576016,0.2273438,224.053102),(26472,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,178,935.329374,117.0235444,129.7032675,1.8,117.4040317,130.7301127,-0.0290117,22.0828848,27.9586424,117331.5113483,214280.3716627,0.1311705,7664.1908647,5313.2329683,11604.5515449,0.3886721,0.8690972,2.0344439,1.8766748),(26473,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,179,933.0361466,117.0778973,129.7571194,1.8,117.4786318,130.7285869,-0.0296165,22.1338971,28.2712968,117990.1175736,217309.3823911,0.1363608,7686.5728389,5330.7430286,11529.0388696,0.7773441,2.0930632,1.1902899,4.5306937),(26474,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,180,932.4835198,117.1207185,129.8002185,1.8,117.6075231,130.7976291,-0.0298106,22.3753865,28.6528585,119115.0416871,221076.4597283,0.1380693,7715.6860054,5323.4853371,11569.9865695,42.3652561,54.9665319,0.1418971,276.9286848),(26475,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,181,929.4914978,117.1648834,129.851008,1.8,117.746986,130.8255607,-0.031626,22.2704474,28.7534875,120417.0692356,224450.8416812,0.1548943,7806.0388908,5407.0341349,11561.6137402,42.9320017,55.5270806,0.1616964,222.7260925),(26476,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,182,922.3122473,117.2069651,129.8778658,1.8,117.8908115,130.8359134,-0.0342539,22.920423,28.6635301,121498.7008387,227381.9779515,0.1802915,7932.7974264,5300.8926087,11918.1028435,0.3886721,1.229089,1.8925469,2.6540189),(26477,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,183,915.4411255,117.2468882,129.8405862,1.8,118.0542302,130.6624838,-0.0354421,22.3028183,29.209859,122678.3505892,231197.8537955,0.1915735,7915.0622921,5500.5761482,11948.8658511,40.4157393,56.9706294,0.0888069,189.5899193),(26478,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,184,910.8538926,117.2691405,129.8111928,1.8,118.1520675,130.6117595,-0.0397591,22.4515916,29.6098134,124384.4285601,235933.6509198,0.2398514,7968.0897604,5540.1163053,12008.7796579,40.4218958,57.6611758,0.1352241,178.5575494),(26479,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,185,911.0287171,117.434966,129.7466501,1.8,118.3644679,130.5722978,-0.0430964,22.7760342,30.1958269,126432.3953447,243095.1739056,0.2818336,8050.6215298,5551.1154535,11843.5366945,42.8447494,58.7190767,0.1194289,225.9297768),(26480,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,186,908.7779713,117.5022368,129.709759,1.8,118.4743125,130.519849,-0.0447617,22.8597676,30.5638084,127570.0438591,249740.6951117,0.3032702,8171.1248713,5580.5485982,12082.0068743,40.8105678,59.6393204,0.1372888,171.5062079),(26481,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,187,908.4202654,117.6121009,129.6410538,1.8,118.5303899,130.4129448,-0.0448779,22.9402549,31.1925338,129258.1288054,258946.4838781,0.3047248,8301.5533645,5634.5550393,12217.996431,41.1992399,60.9509198,0.1022067,186.0642486),(26482,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,188,912.1323228,117.6983935,129.5696135,1.8,118.5849907,130.3853736,-0.0461073,23.5215599,31.5246878,131591.2163078,269787.6257906,0.3229523,8557.9793151,5594.4935938,12431.3570819,41.587912,62.0050742,3.0600131,187.1635792),(26483,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,189,914.9387167,117.7960791,129.4670489,1.8,118.6261299,130.3333118,-0.0459496,24.3083593,32.1277123,134128.9910257,281364.6072501,0.3217336,8757.691958,5517.8134141,12713.6433064,41.9765841,63.167284,0.0800753,192.5268612),(26484,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,190,919.6891467,117.9047617,129.4085506,1.8,118.6327982,130.2435265,-0.0456369,25.1403085,32.4943344,137112.144101,295096.0782045,0.3190215,9081.4624793,5453.8767594,13055.9263553,42.3652561,64.4317021,0.0966675,193.8929342),(26485,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,191,925.1981111,117.9707926,129.3308829,1.8,118.6332882,130.1501595,-0.04604,25.3138217,33.1829794,140606.6532527,310617.4178258,0.3266226,9360.7452805,5554.5407082,13261.6022191,43.1184917,66.2398025,0.1294496,196.9632473),(26486,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,192,931.0890893,118.0804781,129.290646,1.8,118.6009585,130.0972717,-0.0433398,24.555128,34.6410705,144338.3186896,327246.635047,0.2912994,9446.781827,5878.1334217,13587.6493095,43.5312724,69.2109183,3.1135102,207.0849019),(26487,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,193,942.1146628,118.300568,129.1920485,1.8,118.718628,129.9465397,-0.0424673,24.2348484,35.5904114,148720.5070497,348735.7269249,0.2830094,9798.5865721,6136.6386397,13971.0853935,43.9199444,70.8066226,3.0976649,210.155215),(26488,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,194,944.3728703,118.41559,129.1469727,1.8,118.6703258,129.9406141,-0.0425564,24.2938408,36.0625901,151998.0408415,362247.6312689,0.2848794,10044.9698776,6256.6492612,14259.3111676,44.3086165,71.7223731,3.065652,216.8683893),(26489,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,195,945.839721,118.5936303,129.0782604,1.8,118.7371914,129.8302677,-0.0428865,24.6049893,36.0384962,155375.9236185,376058.6738216,0.2897617,10434.9158207,6314.813704,14544.7938195,45.0859607,72.055442,3.0768185,210.2724055),(26490,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,196,949.4571562,118.7536557,128.9770448,1.8,118.7998611,129.70543,-0.0428608,24.6668219,36.9292612,158698.902137,393126.4196188,0.2905205,10645.3908639,6433.6987749,14838.0125502,45.4746327,73.8732603,3.1152829,226.4794421),(26491,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,197,957.0741776,118.9929668,128.8747202,1.8,118.8423702,129.6193812,-0.0404502,24.9896906,37.909157,163096.3489776,411091.4265537,0.2608557,10844.1194492,6526.5453549,15102.0103544,46.2519769,75.0781258,0.0414271,227.6178363),(26492,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,198,967.3463897,119.1194815,128.8166119,1.8,118.9060545,129.572829,-0.0399514,25.0853394,38.5024171,167766.4393214,432266.5123229,0.2571947,11226.9967658,6687.8281537,15429.1571655,48.1553519,76.347108,3.0753631,255.7288946),(26493,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,199,986.4831536,119.2876005,128.7981633,1.8,119.0178671,129.5551924,-0.041549,25.0481858,39.1480062,174116.2892396,457910.826695,0.2836659,11696.9130887,6951.2535149,15907.5512577,48.7235438,77.7353866,3.0414265,247.3114801),(26494,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,200,1012.9500509,119.4267563,128.8328309,1.8,119.08347,129.4885742,-0.0400502,25.4616345,40.2382246,182795.305966,489099.8362052,0.2706539,12155.1047933,7179.2447433,16590.5637024,50.0735757,79.7923985,3.0879855,282.3633916),(26495,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,201,1052.0235417,119.56265,128.9065263,1.8,119.3156152,129.4043545,-0.0353028,25.9101689,41.1123035,193124.6139815,535045.2019768,0.2184321,13014.2355702,7453.6223442,17199.2470828,50.5361889,81.829088,3.0702852,277.9270055),(26496,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,202,1082.2433758,119.6001308,128.9930226,1.8,119.3887986,129.3797878,-0.0315223,25.8571733,41.9933683,202771.93271,574703.6784654,0.1791695,13685.581832,7841.9992198,18369.6776886,51.4276551,83.795572,3.067311,301.4911895),(26497,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,203,1125.7618687,119.5298301,129.0884551,1.8,119.3626158,129.3676991,-0.0284564,26.4963286,42.7531767,217217.4533588,625097.0481716,0.1518916,14621.0667069,8198.0208124,19370.7449002,52.6243812,85.7336947,3.0689932,309.2969922),(26498,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,204,1174.6567998,119.4173544,129.1376931,1.8,119.4627025,129.3038985,-0.0267507,27.2671939,43.6975175,234281.9886849,681980.0296275,0.1400623,15606.8369172,8592.0828377,20562.1712537,53.2722395,87.8682608,3.0441247,304.1452084),(26499,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,205,1227.4102766,119.2668668,129.235439,1.8,119.5032715,129.2937554,-0.0286452,27.7679054,45.0617318,252789.1062079,743790.8935684,0.1678117,16506.0432489,9103.6433128,21781.1622051,54.4634311,90.055412,0.0777649,321.2629603),(26500,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,206,1290.3684435,119.1062881,129.3585572,1.8,119.6370691,129.2306821,-0.0307058,28.5888037,46.4678507,273816.7270052,817441.2447839,0.2027067,17591.5440929,9577.7609185,23036.1850427,56.3428899,92.5659899,0.1347713,356.6139754),(26501,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,207,1367.6191919,119.0054348,129.3208897,1.8,119.616168,129.1586607,-0.0334849,29.5072441,47.7920366,299699.8121089,904675.3538669,0.2554782,18929.4162438,10156.8215338,24834.9383668,57.353305,96.3695146,0.1253555,348.0241263),(26502,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,208,1442.8877715,119.0920242,129.230085,1.8,119.6970991,129.0443615,-0.0361499,30.0857962,49.8316529,326066.5126491,994313.6394948,0.3141291,19953.4549331,10837.8887614,26183.6707412,58.7755103,99.8887232,0.1248376,357.5408714),(26503,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,209,1524.8331927,119.5976334,128.9571397,1.8,119.9784046,128.7489938,-0.0340134,31.3439184,50.2466443,359716.680715,1101087.9793524,0.2939071,21913.662001,11476.4426109,28209.0397326,60.642589,101.1339377,3.0453657,389.5548311),(26504,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,210,1580.4336682,119.832456,128.8734698,1.8,119.837062,128.8516948,-0.0343262,32.0409805,51.4958464,396909.9719847,1187337.7697214,0.3102456,23056.9619424,12387.5725952,29720.3912051,63.2113732,103.1241577,0.3300936,439.0542949),(26505,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,211,1640.7085828,119.9337876,128.9809301,1.8,119.8467082,128.9647126,-0.0371537,33.6243507,52.9624985,446034.4716218,1279629.1672401,0.3772981,24161.042296,13265.22186,31903.1175413,65.855875,105.8587479,0.0514252,430.6206998),(26506,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,212,1683.4570512,119.6702589,128.8041035,1.8,119.5729135,128.8006357,-0.0318541,34.9437266,53.1583351,486553.4620319,1347634.0830135,0.2846014,25351.3222544,13923.9145133,33797.7697098,67.3453434,106.7667403,2.7806916,433.4700363),(26507,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,213,1693.6100585,119.3993287,128.6312653,1.8,119.3704207,128.4954901,-0.0256343,35.1410819,52.7247182,508326.8527923,1299111.4950612,0.185445,24639.5151839,14465.3159525,33513.1684261,67.9382022,106.0398287,2.778103,424.9354313),(26508,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,214,1725.0344378,118.727516,128.3965828,1.8,119.0455181,128.2820429,-0.0124323,35.0133696,52.66481,517740.8067805,1292762.6268168,0.0444305,24546.991196,14786.9460519,33770.3690328,0.824498,1.648996,2.3561945,3.2979919),(26509,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,215,1832.7619697,118.4554271,128.5709687,1.8,119.0123061,128.5909785,0.0038232,34.9530942,54.1550031,543146.2406246,1416450.5972531,0.0044646,26155.4891885,15539.2892289,35351.5521569,68.5518816,107.1502014,2.8622965,378.8511499),(26510,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,216,1993.8099794,119.6574277,129.0704366,1.8,120.0239075,129.2200229,0.0169212,39.0654461,53.7544428,569380.2802248,1573564.0628338,0.0951383,29273.1908699,14575.0359064,39087.5644348,68.2791841,107.5238657,2.863293,372.4990256),(26511,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,217,2082.4504618,119.8194846,128.81915,1.8,120.4295791,129.1764467,-0.0016148,37.1014542,52.7417055,557384.9889368,1600293.8750128,0.0009046,30342.0956846,15023.2652673,39561.1206652,67.3620815,106.9378081,2.8083484,402.1580699),(26512,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,218,2082.1609645,119.7225768,128.7341729,1.8,120.6216694,129.2244246,-0.0253721,34.2107475,52.2274638,519433.8506017,1482787.1554036,0.2233508,28390.9469691,15183.3528661,37200.9398575,1.5546883,2.6072915,0.4636476,8.2840433),(26513,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,219,1932.8463412,119.6722874,129.0143346,1.8,120.7362325,129.0985412,-0.02273,33.0012575,51.5149946,461312.8826834,1327905.8024094,0.1664071,25777.0734879,13978.6456075,33864.7606482,2.5763018,5.2145831,2.0344439,18.6333767),(26514,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,220,1664.3252771,119.9706743,129.2290065,1.8,120.613794,128.7648911,-0.0048005,33.6807988,50.2232473,395261.9226412,1171467.4326796,0.0063942,23325.2028775,11735.5269801,29478.9248737,1.0993306,1.9433604,2.4980915,4.3973226),(26515,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,221,1449.5767442,119.5657262,128.4201708,1.8,120.4769587,128.1550129,-0.0062652,38.0892569,53.9977296,339178.8719002,1031778.4898916,0.0094869,19107.8124586,8904.843499,22577.2698334,0.3886721,1.229089,2.8198421,2.4263401),(26516,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,222,1353.5272536,119.4099867,127.4437271,1.8,120.3168012,127.5994788,-0.0003972,39.2247704,49.2762983,310551.8268118,947429.5482841,0.0000384,19226.8814911,7917.2376026,24719.8800775,48.8134602,64.5453146,0.870661,260.0090266),(26517,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,223,1331.0241445,119.5758679,126.7177538,1.8,120.5047991,127.167499,0.0056091,33.0196808,47.9998445,310826.6681026,913117.6602373,0.0069775,19023.3462247,9413.3759102,23995.5118918,0.3886721,1.229089,2.8198421,2.4263401),(26518,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,224,1338.2148852,119.7068125,126.2208858,1.8,120.6898177,127.0903875,0.0116845,38.0786988,65.4778607,331720.6953123,904633.2594744,0.0304481,13815.8646333,8711.4503801,18376.559282,62.1875319,98.4629956,2.8036138,533.3986361),(26519,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,225,1353.742225,119.8768277,125.7376448,1.8,120.7336512,127.1998756,0.0076818,37.0254862,50.6961983,364194.0056247,915983.464989,0.0133146,18068.0898222,9836.3058157,23109.970226,3.3014204,9.0736409,2.3259007,26.6897412),(26520,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,226,1370.5636968,119.9851061,125.5485949,1.8,120.7414042,127.305487,0.0044142,37.7391266,47.6058357,386027.9395385,939798.289446,0.004452,19741.2412894,10228.8519715,25792.6228685,3.1616056,7.4661467,2.2455373,28.6054795),(26521,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,227,1408.5328037,120.0314594,125.6184444,1.8,120.7943932,127.4455156,-0.0018371,34.1001407,47.0640356,407066.8407261,979550.6020762,0.0007932,20813.1450824,11937.394738,26720.226369,0.7773441,1.4013771,2.1587989,2.9760054),(26522,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,228,1447.4898821,119.9830931,125.8083263,1.8,120.7586863,127.589529,-0.0074846,33.4162501,47.5104504,415627.8028395,1020919.6782853,0.0135184,21488.3182565,12437.8947842,26108.8593658,47.4179931,67.7316154,1.0146301,361.6943345),(26523,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,229,1488.6297725,119.9501582,126.1161489,1.8,120.804893,127.6906033,-0.0093514,33.8349285,47.6253222,410472.8420536,1065681.2390585,0.0216975,22376.3575636,12131.6302408,27888.6562788,47.9848242,68.4736071,1.0079852,306.2266792),(26524,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,230,1510.604883,120.0860447,126.5849637,1.8,120.9326497,127.8492368,-0.0076565,34.5642414,47.8715202,393973.7152549,1107144.4626664,0.0147615,23127.413919,11398.303559,28464.004499,48.9726814,65.0105604,0.8997902,270.514614),(26525,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,231,1526.7702706,120.0538513,126.9629404,1.8,121.060794,127.8422351,-0.0067388,31.0899981,48.5335406,366881.5481626,1134450.7817288,0.0115569,23374.572889,11800.6294774,28631.7311621,59.1765735,100.3985937,2.7524596,504.8160395),(26526,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,232,1525.9239807,119.9982265,127.2849335,1.8,121.1549948,127.8519386,-0.0026232,29.3123541,49.0785315,328385.0872553,1149269.1992707,0.001749,23416.9434791,11202.958513,28375.669688,57.74615,100.352691,2.7855418,467.5883496),(26527,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,233,1489.7084294,120.2011529,127.6129837,1.8,121.4200869,127.8053408,0.0018166,28.6700417,49.6616431,269344.7432444,1138991.6998242,0.0008188,22935.0385692,9394.6407919,27325.50828,46.8198945,60.5530636,0.8398896,224.2969615),(26528,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,234,1377.4810538,120.4763655,127.8260859,1.8,121.5114985,127.7529737,0.0023365,27.3021006,49.3914689,204446.0460032,1050613.3011665,0.0012534,21271.1491267,7488.2899553,24770.88829,46.2519769,58.274894,0.7665325,214.3248587),(26529,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,235,1164.7847753,121.2989149,127.7837242,1.8,121.8807517,127.757814,0.0011843,27.3171678,48.6203192,131300.1242903,855344.4535804,0.0002713,17592.3249399,4806.5057595,20104.2991113,46.1725238,54.5097862,0.6691731,213.4141434),(26530,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,236,779.803238,124.2699395,127.4223751,1.8,123.6047377,127.6319823,0.0032105,21.5122034,50.8154476,62251.2863561,455441.2587944,0.0013393,8962.6536864,2893.7661709,10173.3627169,17.3847366,20.7785123,1.4394809,65.0396446),(26531,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,237,383.0245919,121.8180232,127.0423521,1.8,123.6491014,127.3524964,-0.0069722,17.7979705,45.6764787,19336.7556103,115735.9852606,0.0031032,2533.8202163,1086.4584611,2948.6098954,24.4863407,33.5701091,1.6635526,98.9369813),(26532,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,238,87.8774619,120.3208233,127.6633281,1.8,120.6677409,127.64807,-0.0193105,11.9026469,24.6827381,2002.5799761,31869.1509833,0.0054608,1291.1513649,168.246609,1338.7129233,16.3242271,22.3207439,1.4486012,62.3465621),(26533,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26534,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26535,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26536,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26537,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,243,52.9317804,112.0237158,159.8098882,1.8,109.4335404,156.564819,0.0517293,19.5152381,63.199461,4170.374148,50531.579601,0.0235858,799.5571292,213.6983486,864.5385639,15.6498123,167.3475902,3.0904744,358.7289574),(26538,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,244,100.9253512,108.0048614,153.1293249,1.8,106.9879939,152.1659704,0.1198856,16.7107728,67.5944181,9805.0998281,54048.1696824,0.2406032,799.5951614,586.7532261,944.4266637,19.4336037,20.0797187,0.7443254,64.1679928),(26539,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,245,373.6003178,121.7985029,146.160759,1.8,119.8899586,146.636795,-0.1152008,22.689088,72.7015148,30498.9395184,124632.7600532,0.8227063,1714.3076104,1344.2117863,2129.0446609,23.6356087,24.1759029,0.933726,78.0820605),(26540,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,246,636.7388094,124.5973181,144.9866656,1.8,118.7783978,146.5770295,-0.1322222,25.1953343,75.7030537,45021.7219957,172686.7577527,1.8445349,2281.1068961,1786.9071089,2870.9168549,26.4297011,26.9307961,1.2170932,87.3711267),(26541,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,247,663.66687,123.8326681,144.998092,1.8,118.0330216,146.4951817,-0.1271071,24.2986426,74.9687588,47280.9524991,185795.8432448,1.7774555,2478.3102477,1945.8269011,3101.2879841,27.5957173,28.5323426,0.4209906,92.1294993),(26542,'windfallLgGiraffe_metatarsus-cleaned.tif',247,10,248,674.7098848,123.474585,145.0237039,1.8,117.7103598,146.4716133,-0.1279833,23.6992258,74.6149375,48161.5923225,191284.6513385,1.8318925,2563.6240916,2032.2010832,3201.2084744,29.3782295,57.515588,0.1151348,181.149622),(26543,'cephalophus_sylvicultor_humerus.tif',240,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26544,'cephalophus_sylvicultor_humerus.tif',240,2,2,2.1089334,64.3636458,56.2009039,1.8,64.3261748,56.1536166,-0.1764872,1.9527525,2.7329742,1.3110694,2.6990182,0.0108349,0.9875754,0.6713956,1.4448935,3.6328206,5.3610609,0.3217506,14.3163887),(26545,'cephalophus_sylvicultor_humerus.tif',240,2,3,27.8782467,64.0922647,55.9293857,1.8,64.0029638,55.783393,-0.1349624,3.7459467,5.5328215,58.0734068,162.5962471,0.0841204,29.3875822,15.5029986,39.8837449,7.0225136,11.0693449,0.1759396,29.7434001),(26546,'cephalophus_sylvicultor_humerus.tif',240,2,4,43.5648284,64.1997077,55.5882364,1.8,63.9834915,55.4863469,-0.0642462,5.1725466,6.5916609,208.455123,478.7302547,0.0299282,72.6266508,40.3002892,102.2497667,9.1259087,13.6401544,0.2880554,37.6697115),(26547,'cephalophus_sylvicultor_humerus.tif',240,2,5,54.3370235,64.4671457,55.3074966,1.8,63.9753244,55.2778051,-0.0457629,6.4859542,7.6517874,432.8870066,834.0276004,0.0189526,108.9977481,66.7422238,160.2646747,11.135786,15.6843639,0.2337432,44.2016593),(26548,'cephalophus_sylvicultor_humerus.tif',240,2,6,63.6513918,64.7107066,55.0793106,1.8,64.1063179,55.1690402,-0.0520589,7.0752786,8.5061938,656.9276295,1269.1204534,0.0287246,149.199569,92.8483052,222.2022038,12.1094022,17.2106942,0.2415657,48.4779383),(26549,'cephalophus_sylvicultor_humerus.tif',240,2,7,69.0238743,65.044015,54.9089036,1.8,64.3317895,55.0567038,-0.0669497,7.7748764,9.3243736,841.7630769,1648.4725498,0.0514868,176.791773,108.2670686,264.6243004,13.0781543,18.5032299,0.2513278,52.1279707),(26550,'cephalophus_sylvicultor_humerus.tif',240,2,8,74.3630123,65.4410756,54.7958579,1.8,64.6534193,54.9943702,-0.1484226,8.1854687,9.9798335,1012.3546644,2026.92626,0.2710281,203.1022122,123.6770551,300.5608197,13.5625304,19.5333328,0.3021452,55.3767329),(26551,'cephalophus_sylvicultor_humerus.tif',240,2,9,78.9159415,65.9042003,54.5920639,1.8,65.1902185,54.8355301,-0.2434254,8.7205611,11.5628108,1162.8595312,2394.4426769,0.7640998,207.0813687,133.3468712,250.3866374,14.198525,20.6030722,0.3105986,57.9161426),(26552,'cephalophus_sylvicultor_humerus.tif',240,2,10,80.9768844,66.2559996,54.4494012,1.8,65.584824,54.6824968,-0.2882307,8.8170654,10.8869063,1272.1664059,2582.3852343,1.0905111,237.2010156,144.2845598,336.205648,14.5531806,21.3743812,0.3468349,58.8848948),(26553,'cephalophus_sylvicultor_humerus.tif',240,2,11,82.0764177,66.553462,54.4050853,1.8,65.9851046,54.6249533,-0.3098802,8.5853502,11.0985555,1348.9020782,2630.5862201,1.2720641,237.0205941,157.1167225,357.3358778,14.7747892,21.8305352,0.3392926,59.9124116),(26554,'cephalophus_sylvicultor_humerus.tif',240,2,12,81.6979505,66.8228033,54.3685881,1.8,66.4230676,54.5762201,-0.3177626,9.2448749,10.9737694,1407.1854513,2582.2777696,1.3292253,235.3136536,152.2124931,360.6845507,15.0603998,21.9123304,0.3497153,60.029941),(26555,'cephalophus_sylvicultor_humerus.tif',240,2,13,83.953326,67.3226908,54.2605085,1.8,66.9386064,54.4451871,-0.331375,8.6758925,11.045463,1504.8040824,2675.4098231,1.4810543,242.2179877,173.4466023,377.4145063,15.3319388,22.1347152,0.3113703,60.9155874),(26556,'cephalophus_sylvicultor_humerus.tif',240,2,14,89.3268927,68.2928996,53.8668421,1.8,68.0806381,54.0184259,-0.3608787,9.2313011,13.3058605,1647.6219947,3224.4408857,1.85617,242.3323833,178.4820992,366.0873507,15.6264355,24.4322006,0.3123464,66.8212886),(26557,'cephalophus_sylvicultor_humerus.tif',240,2,15,96.0267033,69.4283547,53.3082311,1.8,68.9075449,53.6332383,-0.3677123,8.7621387,12.9694837,1808.557634,4063.9942552,2.0682072,313.3505047,206.4059591,429.7047622,15.932086,24.7233545,0.5118558,69.2775926),(26558,'cephalophus_sylvicultor_humerus.tif',240,2,16,102.8550397,70.2480976,52.8231484,1.8,69.6764576,53.2090833,-0.3919007,9.9115153,13.2386976,2064.1759568,4697.3407882,2.5007926,354.8189508,208.2603824,493.8531444,16.3557508,25.4930958,0.6777083,71.4157321),(26559,'cephalophus_sylvicultor_humerus.tif',240,2,17,110.9999152,71.0895395,52.196069,1.8,70.4600163,52.5834605,-0.3995853,8.9968542,17.3589831,2465.4392017,5343.666288,2.7999597,307.8329112,274.0334734,410.5068934,17.0909526,26.4816872,0.6947383,74.3807533),(26560,'cephalophus_sylvicultor_humerus.tif',240,2,18,120.3060185,71.6513811,51.6619938,1.8,71.0110366,52.0802074,-0.4034594,10.1879069,13.764914,2983.1881739,6014.2165325,3.0905926,436.9236533,292.8165906,637.0765692,17.9274792,27.3200565,0.7038186,76.9445042),(26561,'cephalophus_sylvicultor_humerus.tif',240,2,19,132.1860831,71.0719953,50.7151967,1.8,70.077232,50.9127468,0.0426203,13.710476,26.4389546,4718.3280187,9276.8660101,0.0399948,350.8786999,344.1403502,499.2955078,18.7377285,27.9567258,0.7302394,79.4494904),(26562,'cephalophus_sylvicultor_humerus.tif',240,2,20,162.569789,68.2948796,48.9033545,1.8,68.0029885,49.3133454,0.2943469,15.3497563,26.6472544,6329.5987477,22650.8120345,2.2804919,850.0242362,412.3582566,1087.5078085,19.5949706,28.8030728,0.7378151,81.1519361),(26563,'cephalophus_sylvicultor_humerus.tif',240,2,21,197.0943104,66.0789037,47.3698846,1.8,65.5746489,47.6400658,0.3366863,15.8763251,25.0303255,8489.0021598,34459.4597683,3.5850991,1376.7084159,534.6956637,1711.9999916,11.1602486,26.1406066,1.3370531,65.5444544),(26564,'cephalophus_sylvicultor_humerus.tif',240,2,22,310.8614996,63.627394,43.5145945,1.8,63.4724437,43.5412419,0.5120043,18.8508591,23.4622537,17621.660273,48260.1694861,12.4358608,2056.9281215,934.7934874,2805.056233,33.8121745,44.6579253,2.8387078,162.3584605),(26565,'cephalophus_sylvicultor_humerus.tif',240,2,23,363.1130163,64.1345369,41.9067305,1.8,63.5360176,42.2627383,0.5918306,20.9518279,31.0343049,27480.9502498,54187.4229728,18.8353622,1746.0491913,1311.6254316,2523.3319727,36.7815187,45.3402926,2.8265988,158.4490283),(26566,'cephalophus_sylvicultor_humerus.tif',240,2,24,381.8451813,64.6584005,40.8978478,1.8,63.6861874,41.3892595,0.6598057,24.0758941,34.4700524,35455.5652049,58942.1620883,23.9114026,1709.9527858,1472.6582945,2696.6862841,39.241856,46.1207689,2.4044841,154.0896435),(26567,'cephalophus_sylvicultor_humerus.tif',240,2,25,393.5857357,65.0412832,40.0444086,1.8,63.9390036,40.6610261,0.7516184,24.2889426,30.0787774,42280.1483341,62391.3261729,30.5846274,2074.2640346,1740.7158866,3365.5692631,41.2966017,47.2967888,2.3924105,159.1340395),(26568,'cephalophus_sylvicultor_humerus.tif',240,2,26,404.7570162,65.2181938,39.4613086,1.8,64.065686,40.2085663,0.8547546,25.1003273,36.6754677,47599.0614442,64931.5782032,38.3935112,1770.43627,1896.3522238,3063.0349219,42.4148183,48.1467149,2.324177,166.492869),(26569,'cephalophus_sylvicultor_humerus.tif',240,2,27,416.3605311,65.3221048,38.8728964,1.8,64.0882299,39.6977061,0.9733499,25.2376673,35.1368678,51138.8092481,68818.3115884,47.4343262,1958.5784358,2026.2890599,3413.9424805,41.9663334,48.6659381,2.3209978,152.3913741),(26570,'cephalophus_sylvicultor_humerus.tif',240,2,28,424.2014846,65.3681799,38.3848001,1.8,64.2475447,39.2122167,1.1214553,24.4048123,35.0453913,53047.8572771,72591.4168585,57.3605882,2071.3541534,2173.6638084,3557.5415474,41.3006041,49.0082331,2.3212437,152.8413267),(26571,'cephalophus_sylvicultor_humerus.tif',240,2,29,428.7120223,65.3356747,37.8567324,1.8,64.4487295,38.8019406,1.2325151,23.2464829,32.9673373,53394.6339215,76778.7739963,63.582625,2328.9346439,2296.8908479,3618.7993624,40.7417991,49.6290518,2.0038858,157.7438522),(26572,'cephalophus_sylvicultor_humerus.tif',240,2,30,436.7559756,65.3380322,37.4544825,1.8,64.684992,38.4224625,1.2795923,22.3561902,37.3703346,52805.3315726,81450.280065,66.7923833,2179.5437743,2362.0004588,3289.3058772,39.8871622,50.1159572,1.9261733,155.6057127),(26573,'cephalophus_sylvicultor_humerus.tif',240,2,31,432.9652598,65.5365869,37.253101,1.8,64.954646,38.1820507,1.3242964,21.6145108,35.1022889,49937.980828,85206.8130931,67.8643118,2427.3862434,2310.3914444,3416.3889815,39.0589654,50.6335215,1.9122115,154.602537),(26574,'cephalophus_sylvicultor_humerus.tif',240,2,32,433.1081293,65.5437855,36.922032,1.8,65.1478529,37.9717203,1.3666361,30.0220104,34.841006,47521.4828037,88019.052099,69.2175022,2526.3062725,1582.8880931,3430.4875931,38.4928927,50.943033,1.8699943,156.6088884),(26575,'cephalophus_sylvicultor_humerus.tif',240,2,33,429.3687278,65.5951242,36.6688034,1.8,65.3435217,37.8267259,1.394805,19.97108,35.9219042,44415.0028462,88456.4871688,69.3677742,2462.4665433,2223.9659985,3232.8664768,37.4224078,51.2272082,1.7997213,162.6564602),(26576,'cephalophus_sylvicultor_humerus.tif',240,2,34,426.8476449,65.5777824,36.5025671,1.8,65.4262568,37.6880149,1.408416,21.1262393,36.1700759,41317.8961429,87698.1095244,69.2818937,2424.6039695,1955.7620071,3080.0337348,36.1884897,51.3558589,1.7894653,171.7865824),(26577,'cephalophus_sylvicultor_humerus.tif',240,2,35,421.7750675,65.9119784,36.6005633,1.8,65.7260947,37.6561556,1.4233065,18.2548886,27.8014354,37254.9048794,84738.5978413,68.7777384,3047.9936204,2040.8179759,4334.0375153,35.2810275,51.4043765,1.7460144,207.7740131),(26578,'cephalophus_sylvicultor_humerus.tif',240,2,36,389.6676318,66.5599562,37.2098767,1.8,66.282814,37.9977898,1.4435614,17.7234556,27.8103592,29265.5692694,80948.1371451,63.8988955,2910.7188643,1651.2338214,3943.348401,33.906326,51.2981489,1.7607846,224.0724122),(26579,'cephalophus_sylvicultor_humerus.tif',240,2,37,376.2384519,66.7982935,37.6804249,1.8,66.5131525,38.3483232,1.4456562,17.3579318,27.8016333,25395.9255187,78031.8151253,61.7295382,2806.734928,1463.0732428,3717.7491185,31.9554991,51.102251,1.708672,225.099929),(26580,'cephalophus_sylvicultor_humerus.tif',240,2,38,372.3904852,66.9729279,38.1011899,1.8,66.7774909,38.9240896,1.4478877,17.6200958,27.3054336,22296.2541943,75508.3875274,61.132204,2765.3246053,1265.3877968,3576.1113423,31.3525713,50.8046789,1.7335939,229.9294312),(26581,'cephalophus_sylvicultor_humerus.tif',240,2,39,353.9103414,66.9794185,39.2253641,1.8,66.8163981,39.7057505,1.4336338,16.0785935,25.7112319,19599.1329115,69442.9182745,57.8822807,2700.878691,1218.958173,3463.0238903,30.0313173,50.2865433,1.6963461,199.8577842),(26582,'cephalophus_sylvicultor_humerus.tif',240,2,40,301.1845365,67.3814518,42.3549437,1.8,67.1377804,42.6395097,1.4378622,18.1342764,28.1462827,17284.3459007,51913.7905709,49.3155722,1844.4279522,953.1312713,2315.8592125,1.792332,13.4081215,1.2776094,35.0228548),(26583,'cephalophus_sylvicultor_humerus.tif',240,2,41,264.1267392,67.7839993,45.0415597,1.8,67.5549034,45.2112804,1.4156456,17.561716,29.7957815,15475.3748829,35126.5458582,42.9699325,1178.9100364,881.199472,1693.5211194,27.5576103,36.3354714,1.7721134,103.4735657),(26584,'cephalophus_sylvicultor_humerus.tif',240,2,42,239.877498,68.0026953,47.2819171,1.8,67.83425,47.4613392,1.3068947,14.9541972,30.1496019,14033.9850847,22100.226103,37.259283,733.0188375,938.4646252,1180.2753042,0.6718868,3.0634634,1.2490458,6.6150536),(26585,'cephalophus_sylvicultor_humerus.tif',240,2,43,230.7546118,67.9620002,48.0309147,1.8,67.8320657,48.3975981,1.2746623,15.2195206,17.612987,13033.026922,19544.8446257,35.1838615,1109.6837037,856.3362297,1842.4386971,0.4843761,1.9971338,1.3258177,4.276279),(26586,'cephalophus_sylvicultor_humerus.tif',240,2,44,226.0014555,68.0064596,48.623505,1.8,67.851955,48.9037306,1.2492604,14.2170256,16.7805163,12225.6132024,18165.7057765,33.905068,1082.547488,859.9276362,1780.6687466,0.7404329,8.1700333,1.3617734,17.589492),(26587,'cephalophus_sylvicultor_humerus.tif',240,2,45,221.9322704,67.9987962,49.1244791,1.8,67.8972581,49.4092421,1.2350696,14.1373991,16.3234238,11620.0614894,16927.9313935,32.9739249,1037.0331341,821.9377142,1627.7603439,24.9503583,30.9773561,1.7436569,91.613481),(26588,'cephalophus_sylvicultor_humerus.tif',240,2,46,217.5153142,67.983762,49.4948748,1.8,67.8852538,49.700622,1.2188262,13.7786835,15.8839417,11061.6831573,15970.2946121,31.943897,1005.4364945,802.8113251,1537.4506914,0.5292103,1.4121868,1.0303768,3.0237859),(26589,'cephalophus_sylvicultor_humerus.tif',240,2,47,218.1878033,68.033833,49.867541,1.8,67.9044765,50.0642899,1.1997104,13.6329633,15.5452031,10743.3346506,15295.4090158,31.5827265,983.9311129,788.0410462,1539.9596598,0.617344,4.0598114,1.2679115,8.7531931),(26590,'cephalophus_sylvicultor_humerus.tif',240,2,48,214.9897701,68.0354779,50.1904844,1.8,67.9692958,50.4296918,1.1775992,19.0974768,16.5862613,10322.8200621,14679.8945564,30.5715822,885.0635066,540.5331895,1189.1296619,0.4843761,0.8732214,0.9827937,1.8543985),(26591,'cephalophus_sylvicultor_humerus.tif',240,2,49,213.4911336,68.1076818,50.4687182,1.8,68.1015326,50.6914545,1.1523656,19.6349253,16.1228615,9965.9334754,14067.67306,29.7072314,872.5295507,507.5615682,1104.7918786,0.5635118,3.7047647,1.3734008,7.8675467),(26592,'cephalophus_sylvicultor_humerus.tif',240,2,50,211.6792436,68.1267238,50.7542331,1.8,68.1302466,50.9284786,1.1217377,14.7173481,15.4293569,9671.0323466,13552.4559002,28.6310932,878.3552011,657.1178649,1361.7099484,23.0853977,27.8474127,1.7016237,85.932756),(26593,'cephalophus_sylvicultor_humerus.tif',240,2,51,209.0467695,68.1353255,50.9572065,1.8,68.1429085,51.1584053,1.0985497,14.1814847,15.6955295,9356.7716483,13139.6686411,27.63169,837.1599481,659.7878763,1364.0300935,0.6785647,4.7024412,1.3633001,10.2063214),(26594,'cephalophus_sylvicultor_humerus.tif',240,2,52,206.6526837,68.117964,51.1724866,1.8,68.1296858,51.4074391,1.0982806,15.1485637,15.1347225,9005.3862058,12787.9299686,27.3077299,844.9398398,594.4712892,1283.1213724,0.242188,2.193106,1.6814535,4.5600199),(26595,'cephalophus_sylvicultor_humerus.tif',240,2,53,205.9381941,68.0594165,51.3437818,1.8,68.1065848,51.5421293,1.0921574,13.5250658,14.9081371,8795.8461892,12570.0772361,27.0422209,843.1688761,650.3366631,1387.8660116,0.242188,1.9525824,1.6951513,4.0756438),(26596,'cephalophus_sylvicultor_humerus.tif',240,2,54,205.2537253,67.944753,51.454466,1.8,68.0611765,51.6687205,1.0925561,12.7514995,14.5727362,8605.1007122,12311.377632,26.9634907,844.8226541,674.8304935,1370.5113332,0.7265641,2.7077446,1.3909428,6.1306775),(26597,'cephalophus_sylvicultor_humerus.tif',240,2,55,204.8026324,67.8958677,51.5728876,1.8,67.9902045,51.8228691,1.0917733,15.2464349,16.0029473,8420.2666264,12161.6774094,26.8823852,759.9648458,552.2777426,1223.5781392,21.8805301,26.8686869,2.1637989,81.5632888),(26598,'cephalophus_sylvicultor_humerus.tif',240,2,56,202.4512226,67.8082592,51.7072498,1.8,67.9104894,51.9362655,1.1111095,13.2595724,14.8395378,8182.5896579,11874.7447783,27.1000929,800.2098824,617.1081101,1335.759696,0.4843761,1.7125281,1.7126934,3.992538),(26599,'cephalophus_sylvicultor_humerus.tif',240,2,57,200.5066656,67.781694,51.7748422,1.8,67.9279864,52.0228767,1.117443,14.2147592,14.6714606,7897.4756104,11594.3706316,27.0072889,790.266963,555.582793,1171.0761223,0.503641,3.4676051,1.7818897,7.3831706),(26600,'cephalophus_sylvicultor_humerus.tif',240,2,58,199.7745084,67.7058864,51.8943613,1.8,67.8246669,52.1399261,1.1298234,13.9990011,15.0050412,7691.248189,11367.0873561,27.2301014,757.5512279,549.4140727,1189.9336748,0.4843761,3.1854864,1.7234457,6.8987946),(26601,'cephalophus_sylvicultor_humerus.tif',240,2,59,198.0051166,67.6219037,52.0446934,1.8,67.7723229,52.2863358,1.1516903,13.6876225,14.7042451,7491.3127576,11095.3312886,27.535798,754.5665348,547.3056248,1173.0133035,21.1394487,26.2916288,2.1127956,78.2801031),(26602,'cephalophus_sylvicultor_humerus.tif',240,2,60,199.636278,67.5120916,52.0878151,1.8,67.6793077,52.2963919,1.1740766,12.554343,14.5080962,7385.9529919,10944.8169834,28.3050634,754.3937435,588.3185603,1218.8212763,0.4843761,1.0830979,2.0344439,2.3387746),(26603,'cephalophus_sylvicultor_humerus.tif',240,2,61,199.4468577,67.4597859,52.2550706,1.8,67.6070868,52.4470253,1.1905464,12.4208097,15.2944032,7267.1352763,10821.8570131,28.6620348,707.5697496,585.077419,1140.918778,0.4843761,1.0830979,2.0344439,2.5394098),(26604,'cephalophus_sylvicultor_humerus.tif',240,2,62,197.8909704,67.3789797,52.343367,1.8,67.5327056,52.5221155,1.2123094,12.6479519,14.4094876,7169.2715777,10674.3134263,28.9217269,740.7836907,566.8326102,1130.0475091,0.242188,1.4731724,1.735945,3.1068917),(26605,'cephalophus_sylvicultor_humerus.tif',240,2,63,195.798727,67.3191663,52.384575,1.8,67.4357808,52.5008237,1.2246025,11.8218307,14.7217386,7005.9584271,10510.8814033,28.8758093,713.9701132,592.6288931,1162.7847223,0.242188,0.9985669,1.815775,2.1381395),(26606,'cephalophus_sylvicultor_humerus.tif',240,2,64,189.0896915,67.262384,52.5094366,1.8,67.4070351,52.9004519,1.2304334,12.5805042,14.009659,6838.0693431,10179.9251732,28.0028623,726.6361851,543.5449352,1214.5442242,0.4843761,0.8732214,2.1587989,1.8543985),(26607,'cephalophus_sylvicultor_humerus.tif',240,2,65,185.11455,67.1602256,52.4999648,1.8,67.035219,52.853293,1.2633843,11.4838156,14.0558193,6637.4744292,9877.4390101,28.0274988,702.7295106,577.9851114,1147.8094266,0.242188,1.4731724,1.735945,3.1068917),(26608,'cephalophus_sylvicultor_humerus.tif',240,2,66,185.0982332,67.060805,52.4976821,1.8,66.9395107,52.689327,1.2971248,11.3635453,14.1955718,6517.5220402,9677.3023919,28.5962935,681.7127557,573.5465369,1103.9487444,20.4228499,25.5045973,1.9707006,74.8307058),(26609,'cephalophus_sylvicultor_humerus.tif',240,2,67,184.6078059,66.9788862,52.5235811,1.8,66.8586915,52.7349672,1.3098104,11.7018266,14.4414544,6410.7165859,9440.3697083,28.7194018,653.6993746,547.8389641,1046.7078501,20.3321246,25.2306012,1.9441727,74.4050944),(26610,'cephalophus_sylvicultor_humerus.tif',240,2,68,185.9046157,66.9368311,52.5718685,1.8,67.0614759,53.0108683,1.3187854,11.594815,14.6645744,6311.8293917,9284.3949116,29.0576239,633.1172436,544.3665468,1046.8236611,20.2207581,25.1432717,1.9352039,74.0625888),(26611,'cephalophus_sylvicultor_humerus.tif',240,2,69,185.4017109,66.834294,52.5974704,1.8,66.9635509,53.01316,1.3290131,11.6027481,13.5768578,6228.199642,9114.2941912,29.1288083,671.3110143,536.7865969,1089.6388432,20.1439107,24.9747429,1.9170818,73.5782127),(26612,'cephalophus_sylvicultor_humerus.tif',240,2,70,183.7888037,66.7321308,52.6585318,1.8,66.8426532,53.07778,1.3384461,11.7493448,13.8352417,6125.968545,8922.2711862,29.0073227,644.8944956,521.3880982,1007.6808197,0.3425056,0.6850112,2.3561945,1.3700225),(26613,'cephalophus_sylvicultor_humerus.tif',240,2,71,182.8629605,66.6263566,52.6753226,1.8,66.7306358,53.0951733,1.3408958,11.543388,13.3537281,6037.2902979,8731.4215428,28.894494,653.8564704,523.0085243,1040.0386942,19.9306418,24.5901381,1.8707435,72.751331),(26614,'cephalophus_sylvicultor_humerus.tif',240,2,72,181.6817189,66.5690451,52.7071871,1.8,66.6643598,53.1130348,1.3464944,11.2173045,13.6695333,5943.2285598,8563.8136131,28.7822224,626.4890998,529.8268007,976.5111365,0.242188,0.3425056,2.3561945,0.6850112),(26615,'cephalophus_sylvicultor_humerus.tif',240,2,73,180.5715743,66.5909841,52.6620605,1.8,66.7189091,53.0638365,1.3497279,11.322996,14.1338156,5829.832624,8351.7574543,28.6482741,590.9060732,514.8666151,993.0361438,19.7922937,24.2877298,1.8641633,71.983214),(26616,'cephalophus_sylvicultor_humerus.tif',240,2,74,177.7115186,66.5197701,52.6544275,1.8,66.6368956,53.1278404,1.3560741,10.8263168,13.9842888,5682.4243371,8101.8232665,28.2738616,579.3518291,524.8714256,970.669092,19.6836958,24.0876677,1.8352847,71.4988379),(26617,'cephalophus_sylvicultor_humerus.tif',240,2,75,175.6939272,66.4424967,52.6227958,1.8,66.5590291,53.1430411,1.3650799,11.1744372,13.9062081,5563.5755098,7914.4232007,28.0604974,569.128778,497.8841786,920.9623029,19.6050423,23.9386679,1.7642237,70.8138267),(26618,'cephalophus_sylvicultor_humerus.tif',240,2,76,175.5289465,66.375917,52.6086113,1.8,66.5331862,53.0680157,1.3765165,11.2059043,14.104585,5485.7498463,7771.0487784,28.1644338,550.9590522,489.5410215,874.2209561,19.4969785,23.7998277,1.786154,70.8138267),(26619,'cephalophus_sylvicultor_humerus.tif',240,2,77,174.4656905,66.274916,52.6075216,1.8,66.3747937,53.1052327,1.3866439,11.2225035,12.9653781,5393.1435172,7625.2764584,28.1026285,588.1260362,480.5651014,898.3356288,19.3020675,23.6552142,1.7561443,70.2706859),(26620,'cephalophus_sylvicultor_humerus.tif',240,2,78,175.4216611,66.1856794,52.5484314,1.8,66.2294534,52.9197627,1.3961572,11.2395662,15.2307085,5311.3216764,7574.6599516,28.354279,497.3281407,472.5557548,792.2473572,19.2252201,23.5321548,1.7257931,70.1288154),(26621,'cephalophus_sylvicultor_humerus.tif',240,2,79,175.3977192,66.0945227,52.539636,1.8,66.1738117,52.9844687,1.4052341,11.2078835,14.5490451,5238.2544799,7502.607866,28.438948,515.6769968,467.372317,816.6235435,19.1293585,23.4172169,1.7580502,69.4438042),(26622,'cephalophus_sylvicultor_humerus.tif',240,2,80,176.1281523,65.9871002,52.482204,1.8,66.0607468,52.8758417,1.4165969,10.9189489,13.4821589,5176.9413766,7415.7775287,28.6622268,550.0437696,474.1245185,854.5756086,18.9955474,23.2563583,1.7171116,69.3019337),(26623,'cephalophus_sylvicultor_humerus.tif',240,2,81,175.310181,65.9275821,52.3664107,1.8,66.0420122,52.8137206,1.4341539,11.2411186,13.444664,5073.5190067,7262.6268249,28.6762101,540.1865618,451.3357762,775.4967806,18.8444612,23.0537067,1.7290367,68.6169225),(26624,'cephalophus_sylvicultor_humerus.tif',240,2,82,174.8488857,65.819812,52.2569117,1.8,65.9294101,52.6758994,1.4521492,11.1966832,12.9222595,4978.6199948,7135.5548599,28.7331735,552.1909578,444.6513244,904.829203,18.8418526,22.8966989,1.7515959,68.2156522),(26625,'cephalophus_sylvicultor_humerus.tif',240,2,83,174.122043,65.7243858,52.122813,1.8,65.8370749,52.5469548,1.4664609,10.4876286,14.6705992,4893.4858092,7005.7433792,28.7055734,477.5362816,466.5960222,788.0177863,0.242188,0.5415489,2.0344439,1.1693873),(26626,'cephalophus_sylvicultor_humerus.tif',240,2,84,174.3918384,65.6410998,52.0060967,1.8,65.7295444,52.446757,1.4798892,11.03739,14.1168679,4842.1759087,6906.5496366,28.8257684,489.2409356,438.7066081,767.5767652,18.6484793,22.5755114,1.7324177,67.3887705),(26627,'cephalophus_sylvicultor_humerus.tif',240,2,85,173.6578327,65.5502098,51.8740487,1.8,65.5673194,52.1872533,1.4949422,11.0265196,13.7806775,4775.831024,6803.510824,28.7767576,493.6992985,433.122255,840.1363986,18.6130495,22.5872001,1.6459235,67.6481703),(26628,'cephalophus_sylvicultor_humerus.tif',240,2,86,178.6975278,65.5064112,51.7493228,1.8,65.6796167,51.8793735,1.506961,11.2701146,14.1514754,4757.5991641,6779.7182063,29.661722,479.0820747,422.1429285,815.2680736,18.5620012,22.4125374,1.4625257,67.2469),(26629,'cephalophus_sylvicultor_humerus.tif',240,2,87,175.8142767,65.4092207,51.6351796,1.8,65.456103,51.6753614,1.5227163,10.9953097,14.0945862,4697.0577738,6703.7197327,29.2346937,475.6237334,427.1874008,786.7797357,18.4062913,22.3286343,1.5056712,66.9043944),(26630,'cephalophus_sylvicultor_humerus.tif',240,2,88,177.1393831,65.3383188,51.5200296,1.8,65.418511,51.5477412,1.5365213,10.8841249,13.6901059,4673.5524333,6662.851495,29.4885609,486.6910124,429.3916591,768.26778,18.4062913,22.1995431,1.4505008,66.7037593),(26631,'cephalophus_sylvicultor_humerus.tif',240,2,89,177.0557907,65.3043215,51.3284481,1.8,65.3598332,51.3145551,1.5498498,10.9415984,16.9108695,4590.8619128,6608.3861771,29.4963529,390.7774339,419.5787249,652.5136138,0.4843761,1.5317317,1.2490458,3.3075268),(26632,'cephalophus_sylvicultor_humerus.tif',240,2,90,177.8537482,65.2329196,51.1826327,1.8,65.2809422,51.1407781,1.563564,11.0390945,14.4143077,4535.5912464,6578.7402766,29.6407409,456.4034861,410.8662388,727.9708513,0.4843761,1.7631556,1.2924967,3.992538),(26633,'cephalophus_sylvicultor_humerus.tif',240,2,91,178.6640411,65.1606376,51.0319015,1.8,65.2086562,50.9642366,-1.5699722,11.130446,14.1180844,4484.8597352,6566.2015463,29.7773199,465.0915354,402.936209,777.1733405,0.242188,0.7658658,1.8925469,1.6537634),(26634,'cephalophus_sylvicultor_humerus.tif',240,2,92,181.0549986,65.0877267,50.9124807,1.8,65.1269364,50.9745062,-1.5591447,10.949492,14.5245701,4447.9726891,6578.0397921,30.1717366,452.8904998,406.2263979,733.3180924,0.242188,0.9985669,1.815775,2.1381395),(26635,'cephalophus_sylvicultor_humerus.tif',240,2,93,181.9303274,65.0222127,50.7679246,1.8,65.0480777,50.8745729,-1.5490946,10.5767501,12.6901243,4414.8459067,6592.719117,30.307443,519.515724,417.410441,866.7144369,17.9219152,21.9898208,1.4382448,65.534372),(26636,'cephalophus_sylvicultor_humerus.tif',240,2,94,184.5785317,64.9490553,50.6083833,1.8,64.9905443,50.7568546,-1.5440339,10.6424559,14.510212,4393.7400481,6592.3044761,30.7410606,454.3217207,412.850201,754.0356142,0.4843761,2.7077446,1.3909428,5.7294072),(26637,'cephalophus_sylvicultor_humerus.tif',240,2,95,185.3919706,64.8770432,50.418468,1.8,64.9240584,50.5585839,-1.5288939,10.3325138,14.6753749,4361.5100985,6595.8306804,30.8444411,449.4488702,422.1150998,742.1715459,0.4843761,3.1577457,1.6475682,6.6981594),(26638,'cephalophus_sylvicultor_humerus.tif',240,2,96,186.2129458,64.8182481,50.2472504,1.8,64.8767518,50.3914462,-1.51126,9.8668302,13.6753024,4340.1339226,6605.8987743,30.9256134,483.0532133,439.8711464,799.4905568,17.6797271,21.9444286,1.3820586,65.250631),(26639,'cephalophus_sylvicultor_humerus.tif',240,2,97,185.5615193,64.8192656,50.0172855,1.8,64.8648114,50.1146068,-1.4819672,10.2454256,12.7804889,4294.4973352,6562.9164027,30.6835288,513.5105889,419.1624165,849.389088,0.4843761,1.7631556,1.2924967,3.7919029),(26640,'cephalophus_sylvicultor_humerus.tif',240,2,98,185.3868339,64.7686692,49.8234378,1.8,64.8101831,49.93161,-1.4606179,10.5218611,13.077232,4258.7889337,6514.4523792,30.5242437,498.1522379,404.7562398,819.5153783,0.4843761,2.6750544,1.6614562,5.7294072),(26641,'cephalophus_sylvicultor_humerus.tif',240,2,99,185.3988848,64.7092744,49.6126882,1.8,64.7438134,49.7741635,-1.4359974,9.7550888,12.8262109,4243.6700656,6475.8965207,30.3417335,504.8955278,435.0211601,832.0893577,0.5869692,4.386212,1.4601391,9.320675),(26642,'cephalophus_sylvicultor_humerus.tif',240,2,100,186.8183014,64.661569,49.4048513,1.8,64.7024979,49.5512076,-1.4070136,10.5539931,11.7884391,4228.8431906,6451.9116179,30.3085981,547.3083876,400.6865594,855.4114548,0.4843761,2.6750544,1.6614562,5.7294072),(26643,'cephalophus_sylvicultor_humerus.tif',240,2,101,187.9449227,64.6064793,49.1690122,1.8,64.6914119,49.3009902,-1.375156,9.8408833,11.9073392,4221.8191547,6456.423531,30.1404362,542.22219,429.0081512,882.0157651,17.6447586,22.1559044,1.2939982,66.2781479),(26644,'cephalophus_sylvicultor_humerus.tif',240,2,102,190.1900247,64.5724181,48.8945605,1.8,64.6137959,49.018775,-1.3355933,9.911526,12.5616661,4238.1703695,6511.6464934,29.976869,518.3744292,427.6001885,850.6593689,0.4843761,2.2328634,1.7894653,4.9612902),(26645,'cephalophus_sylvicultor_humerus.tif',240,2,103,191.2120978,64.5572713,48.6237013,1.8,64.5964633,48.7816269,-1.3033128,10.6547335,12.1785696,4253.8674428,6491.3383733,29.6424228,533.0131994,399.2467252,839.4302308,17.6797271,22.1559044,1.2939982,64.4237493),(26646,'cephalophus_sylvicultor_humerus.tif',240,2,104,191.9397225,64.5601518,48.3515259,1.8,64.6120257,48.4535321,-1.2628572,10.0071524,12.2191958,4272.1874243,6464.9858321,29.0511397,529.0843953,426.9133956,772.9237596,0.242188,1.2349216,1.7681919,2.6225156),(26647,'cephalophus_sylvicultor_humerus.tif',240,2,105,191.4650254,64.629965,47.9642158,1.8,64.6785917,48.0090114,-1.2200389,10.5407653,11.9159581,4261.9639456,6395.2155923,28.1432119,536.6933586,404.3315494,879.4350194,17.616642,22.0391119,1.1760052,64.1643495),(26648,'cephalophus_sylvicultor_humerus.tif',240,2,106,191.0991957,64.6472886,47.6807687,1.8,64.6637212,47.7578934,-1.1776492,10.067385,11.824848,4267.8360303,6340.180772,27.1754659,536.1743974,423.9269714,873.1830481,0.5976508,2.9957006,1.3258177,6.4144185),(26649,'cephalophus_sylvicultor_humerus.tif',240,2,107,192.4319983,64.6875439,47.4132113,1.8,64.690977,47.510983,-1.1398922,10.2734386,11.7531609,4287.9843407,6298.2889111,26.4764941,535.8804291,417.3855038,873.1176173,0.6512828,4.8679194,1.4711277,10.2894272),(26650,'cephalophus_sylvicultor_humerus.tif',240,2,108,195.8226689,64.7451368,47.1428778,1.8,64.7659557,47.2461907,-1.1041386,10.246654,12.2399267,4328.4725125,6311.454314,26.0309188,515.6447805,422.427899,868.0503783,0.6313249,4.6269961,1.4659194,9.8050511),(26651,'cephalophus_sylvicultor_humerus.tif',240,2,109,197.4269378,64.8283389,46.8533693,1.8,64.8572213,46.8882068,-1.0669936,9.9368966,12.288886,4365.793955,6366.9718594,25.2358844,518.108139,439.3518553,870.1657093,0.242188,0.5415489,2.0344439,1.1693873),(26652,'cephalophus_sylvicultor_humerus.tif',240,2,110,198.8992151,64.8970147,46.6085936,1.8,64.9179673,46.6253457,-1.0245679,10.1248855,11.8087745,4392.6111756,6453.2452233,24.2044701,546.4788248,433.8430488,910.211268,17.7648839,21.7659556,0.9673628,64.3893258),(26653,'cephalophus_sylvicultor_humerus.tif',240,2,111,198.905756,64.9702141,46.4323401,1.8,64.970969,46.5292247,-0.9847578,10.0576776,12.4490594,4407.476436,6564.6257007,23.0107182,527.3190103,438.2200946,877.847856,0.4843761,1.9971338,1.3258177,4.276279),(26654,'cephalophus_sylvicultor_humerus.tif',240,2,112,199.7696204,65.0601473,46.2237482,1.8,65.1105886,46.3325132,-0.9432375,10.1273387,11.6031403,4420.4222798,6702.6010602,21.8158694,577.6540563,436.4840959,913.4531496,0.242188,0.7658658,1.8925469,1.6537634),(26655,'cephalophus_sylvicultor_humerus.tif',240,2,113,200.69717,65.1946772,45.925857,1.8,65.2176863,46.0427684,-0.9051284,10.1518077,12.2464883,4431.3908739,6842.8409734,20.691518,558.7594425,436.5124917,919.402431,0.4843761,2.2328634,1.3521274,4.9612902),(26656,'cephalophus_sylvicultor_humerus.tif',240,2,114,201.6342822,65.2720137,45.7203919,1.8,65.294174,45.853298,-0.8710513,10.1511917,12.5223536,4448.6863087,7005.8500294,19.6672354,559.4675127,438.242762,914.5449105,1.2341924,4.0598114,1.2679115,9.9813451),(26657,'cephalophus_sylvicultor_humerus.tif',240,2,115,201.6406987,65.3318173,45.5512739,1.8,65.373417,45.6789119,-0.8334605,10.163634,12.8652493,4468.2491249,7163.5379347,18.4161244,556.812989,439.6310536,899.5801594,1.3267198,9.8823406,1.2722974,21.2982891),(26658,'cephalophus_sylvicultor_humerus.tif',240,2,116,203.0434964,65.4766592,45.2289674,1.8,65.577739,45.3077834,-0.76515,11.1625583,12.75295,4542.3039368,7637.3742961,16.2352705,598.8711865,406.9231988,937.2097114,0.469988,1.5317317,1.2490458,3.3075268),(26659,'cephalophus_sylvicultor_humerus.tif',240,2,117,203.0288504,65.4784389,45.2308689,1.8,65.5755659,45.3229651,-0.765626,11.1649104,12.7535173,4541.0714825,7637.5186412,16.2501931,598.8558649,406.7270858,937.1664443,0.469988,1.5317317,1.2490458,3.3075268),(26660,'cephalophus_sylvicultor_humerus.tif',240,2,118,204.3261223,65.5503549,45.0870634,1.8,65.662033,45.1193665,-0.7321721,10.1241238,12.6008761,4570.8836698,7954.265084,15.2180192,631.2469891,451.4843721,947.6857044,0.7049821,4.0598114,1.2679115,8.9538282),(26661,'cephalophus_sylvicultor_humerus.tif',240,2,119,206.183781,65.6361648,44.9743138,1.8,65.7355282,45.0308301,-0.6978294,10.1937038,12.7905328,4618.5563927,8315.2366011,14.1881329,650.1086978,453.07932,992.7375678,17.9810114,24.9641721,0.6823166,68.6311812),(26662,'cephalophus_sylvicultor_humerus.tif',240,2,120,206.601636,65.7404645,44.8559318,1.8,65.7766771,44.8910004,-0.6679815,10.9088265,13.1432601,4649.9129766,8706.4648127,13.2107828,662.4281003,426.2523534,1014.3324387,0.242188,0.3425056,2.3561945,0.6850112),(26663,'cephalophus_sylvicultor_humerus.tif',240,2,121,205.4458828,65.8908555,44.7003174,1.8,65.9621054,44.6538696,-0.6395121,10.5488711,13.6291108,4670.0517231,9117.3528518,12.1957825,668.9616772,442.7063045,994.3349177,0.6139096,3.6003841,1.2277724,7.7844409),(26664,'cephalophus_sylvicultor_humerus.tif',240,2,122,205.6390178,65.9839262,44.6251585,1.8,66.1142536,44.5746247,-0.6156452,10.7899355,13.9617948,4682.212667,9592.9270573,11.4297362,687.0840911,433.9425992,1016.7959853,0.4843761,1.3042225,1.1902899,2.8231507),(26665,'cephalophus_sylvicultor_humerus.tif',240,2,123,206.1899842,66.0843873,44.6016983,1.8,66.3295948,44.5539442,-0.5892323,10.6974126,14.1573891,4732.2808943,10080.9200194,10.6128737,712.0606713,442.3762156,1036.5881435,0.4843761,0.7658658,1.8925469,1.8543985),(26666,'cephalophus_sylvicultor_humerus.tif',240,2,124,211.5449591,66.1564857,44.5968212,1.8,66.3130663,44.5208323,-0.5625219,10.3052259,14.4465489,4794.0984562,10688.7173927,10.0283421,739.8803327,465.2104166,1060.6030146,0.469988,1.5317317,1.2490458,3.3075268),(26667,'cephalophus_sylvicultor_humerus.tif',240,2,125,209.9065458,66.1674138,44.6195064,1.8,66.2218404,44.5628104,-0.5408276,10.4330343,14.8151919,4868.8834268,11298.1848747,9.2731826,762.6080691,466.6795197,1079.5524706,0.6508421,1.6246468,1.1071487,3.7087971),(26668,'cephalophus_sylvicultor_humerus.tif',240,2,126,213.6028448,66.2046587,44.6631286,1.8,66.2823425,44.6134787,-0.5169138,10.2884497,15.0780807,4957.7047999,12091.4000108,8.6948168,801.9190409,481.8709261,1113.1756845,0.6677902,5.7567441,1.3156139,12.7457311),(26669,'cephalophus_sylvicultor_humerus.tif',240,2,127,216.8425942,66.153107,44.7627195,1.8,66.3277674,44.706452,-0.4960896,10.8002338,15.4222952,5075.3539565,12963.9709571,8.1882155,840.5993238,469.930006,1153.1630703,0.7640604,1.7464428,0.9827937,4.0513027),(26670,'cephalophus_sylvicultor_humerus.tif',240,2,128,219.4768635,66.0436557,44.9015605,1.8,66.1758518,44.8481019,-0.4824948,10.4923376,15.8735363,5215.5570605,13922.4179626,7.8750954,877.0835738,497.0824688,1184.622606,0.9991983,3.2941135,1.2722974,7.8432056),(26671,'cephalophus_sylvicultor_humerus.tif',240,2,129,225.0874854,66.0911931,44.9627429,1.8,66.3910889,44.8754984,-0.4745192,11.2908716,16.2655992,5397.1975228,15124.465943,7.8318247,929.8437638,478.0142521,1240.929002,0.242188,0.3425056,2.3561945,0.6850112),(26672,'cephalophus_sylvicultor_humerus.tif',240,2,130,236.9825337,66.1147917,45.0365597,1.8,66.3572816,45.0142996,-0.453815,10.9421267,16.5406274,5530.5774594,16388.0168795,7.5910409,990.7735935,505.4389915,1304.3002069,1.8315912,8.3510989,1.2765618,19.5614199),(26673,'cephalophus_sylvicultor_humerus.tif',240,2,131,240.1321854,66.1855726,45.1229778,1.8,66.4579409,45.0420729,-0.4274296,11.2029015,16.9275948,5642.6967886,17471.933483,6.8772895,1032.1568831,503.6817305,1358.766264,1.470866,7.8887899,1.2587542,19.5370788),(26674,'cephalophus_sylvicultor_humerus.tif',240,2,132,247.9307473,66.2876397,45.2058537,1.8,66.5558325,45.1275073,-0.3976633,11.3235897,16.7364546,5779.5272071,18789.0310629,6.1972034,1122.6410581,510.3970882,1432.0403463,1.7806586,10.1140696,1.2793395,25.6089916),(26675,'cephalophus_sylvicultor_humerus.tif',240,2,133,261.7945611,66.4750683,45.3282856,1.8,66.6612716,45.2523771,-0.3628433,11.4867684,16.7575431,5987.8494253,20231.9598551,5.4967267,1207.3344925,521.2823313,1515.9205211,1.4358602,8.1951223,1.2397003,19.762055),(26676,'cephalophus_sylvicultor_humerus.tif',240,2,134,271.2872408,66.6627446,45.624588,1.8,66.7108519,45.5486367,-0.3265257,11.9951281,16.8950439,6264.3822464,21980.3810243,4.6518195,1300.9957951,522.2438807,1622.8946263,1.037455,9.5809786,1.2890245,21.758324),(26677,'cephalophus_sylvicultor_humerus.tif',240,2,135,267.7435516,66.671902,46.1141972,1.8,66.5274197,46.2087841,-0.3078833,11.9795783,17.2188777,6794.8274317,24298.5269901,4.0980168,1411.1562587,567.2008869,1747.0635342,22.1374007,35.3270924,0.6736703,150.9684931),(26678,'cephalophus_sylvicultor_humerus.tif',240,2,136,278.6546526,66.3254543,47.1099017,1.8,66.1080513,47.3031056,-0.3427559,13.6279819,18.1565903,8381.2729059,27796.5131822,5.2457873,1530.9324483,615.004698,1933.5419045,1.2047557,6.7465782,1.2036225,15.9701521),(26679,'cephalophus_sylvicultor_humerus.tif',240,2,137,298.3460409,66.0153724,48.3650647,1.8,65.8252034,48.5690682,-0.3951063,16.1050722,19.7026091,10831.4107141,31824.3188525,7.3668028,1615.2337323,672.5465473,2050.5707952,1.6515904,11.1984148,1.194306,29.2934476),(26680,'cephalophus_sylvicultor_humerus.tif',240,2,138,316.1188583,65.8260481,49.5833585,1.8,65.847768,49.7634595,-0.4117607,16.2983133,20.9296993,13493.6174303,36018.7246565,8.4392567,1720.9384653,827.9149627,2350.0381094,2.0708229,5.6694767,1.2220253,17.8002096),(26681,'cephalophus_sylvicultor_humerus.tif',240,2,139,331.4131265,66.2750778,50.6317988,1.8,66.2063838,50.9388432,-0.3391898,16.8187056,21.0953733,16580.2428258,40960.7176691,6.1148307,1941.6920023,985.8215724,2675.4418302,1.5662472,4.3323914,1.1071487,11.953273),(26682,'cephalophus_sylvicultor_humerus.tif',240,2,140,363.9903003,67.1711053,52.0232423,1.8,67.23951,52.5732649,-0.2191499,18.0470105,20.7385755,21149.3461813,46085.1355017,2.8671963,2222.1938773,1171.9030259,3126.1045886,33.0291636,41.3999899,0.7067227,243.5507263),(26683,'cephalophus_sylvicultor_humerus.tif',240,2,141,394.7178137,67.774427,53.1583694,1.8,67.2906691,53.3912173,-0.1370773,19.2813828,20.1906084,25028.7940237,49301.7866628,1.2284149,2441.8177853,1298.0808615,3412.6378931,34.4107433,42.0222427,0.6792414,271.04854),(26684,'cephalophus_sylvicultor_humerus.tif',240,2,142,396.1640872,67.2818544,53.761248,1.8,66.9768082,53.9574395,-0.1274558,19.6198321,21.6221857,26690.1851047,48378.1915091,1.0668175,2237.4329886,1360.3676641,3391.1214951,1.6766947,3.7047647,1.7681919,11.1263913),(26685,'cephalophus_sylvicultor_humerus.tif',240,2,143,401.0369531,66.8412558,54.1298357,1.8,66.8799429,54.1912491,-0.134518,19.9899106,21.51611,27766.5825107,48078.0016075,1.2021887,2234.5117942,1389.0298473,3284.2517974,1.1565879,3.7597695,1.3101939,9.5557337),(26686,'cephalophus_sylvicultor_humerus.tif',240,2,144,422.7120552,66.7319953,54.3752225,1.8,67.0546357,54.3299678,-0.1260553,20.3328264,21.78449,28768.3380699,49772.6687957,1.1135612,2284.7754914,1414.8715717,3453.3962638,0.4843761,0.8732214,0.9827937,1.8543985),(26687,'cephalophus_sylvicultor_humerus.tif',240,2,145,434.1906704,66.8002011,54.4249983,1.8,67.1318297,54.2777819,-0.1088503,20.35429,21.7527076,29609.4650647,50197.1231392,0.8540289,2307.6264424,1454.703902,3585.3197469,33.5990662,43.0100327,0.6896915,242.8111266),(26688,'cephalophus_sylvicultor_humerus.tif',240,2,146,441.1613074,66.7146429,54.4575606,1.8,67.0990362,54.1819898,-0.1019153,20.3000116,22.0361014,29915.7087529,50621.5434782,0.7610638,2297.2095877,1473.6793953,3628.2275728,0.242188,0.3425056,2.3561945,0.6850112),(26689,'cephalophus_sylvicultor_humerus.tif',240,2,147,447.7250029,66.7513295,54.3490089,1.8,67.0481714,54.0337081,-0.1217178,20.0831662,21.3712338,29845.6775467,49821.0560368,1.1000763,2331.2203936,1486.1041927,3582.8728864,33.4032341,42.793332,0.7012599,261.7563824),(26690,'cephalophus_sylvicultor_humerus.tif',240,2,148,442.880167,66.7837186,54.252615,1.8,67.044578,54.0137164,-0.1195372,19.7714235,21.4421547,28675.7600603,48324.2931244,1.0497151,2253.7050838,1450.3639578,3514.215139,32.5487566,42.3358277,0.6515101,170.2402659),(26691,'cephalophus_sylvicultor_humerus.tif',240,2,149,436.6215845,66.855794,53.9974498,1.8,67.0894761,53.9128209,-0.0868819,19.6287961,21.0840056,27367.6971327,46855.1684634,0.5479229,2222.3086683,1394.2626419,3426.7943351,31.9295319,41.8992314,0.6377208,256.0412339),(26692,'cephalophus_sylvicultor_humerus.tif',240,2,150,422.3878883,67.0247631,53.6221057,1.8,67.2104023,53.6870253,-0.0464727,19.3033969,20.8321708,25718.705108,44672.6342738,0.1519296,2144.4061041,1332.3408936,3206.1583336,31.0703819,41.1897714,0.6140978,235.5354029),(26693,'cephalophus_sylvicultor_humerus.tif',240,2,151,403.8857044,67.4758694,53.4062611,1.8,67.4271533,53.5676662,0.0251941,17.7159363,19.7085253,22897.5742455,42321.983972,0.0427187,2147.3947597,1292.4845674,3161.6662064,32.4456881,40.119237,0.6181442,209.8533879),(26694,'cephalophus_sylvicultor_humerus.tif',240,2,152,362.6217713,67.6220939,53.3888055,1.8,67.599243,53.457959,0.1603693,16.8135264,18.649556,18053.8305183,37281.7923069,1.5410574,1999.071306,1073.76823,2747.8917119,0.242188,0.3425056,2.3561945,0.6850112),(26695,'cephalophus_sylvicultor_humerus.tif',240,2,153,283.8369683,66.7372138,53.3428708,1.8,67.2501478,53.5330234,0.3579765,15.6920491,19.2679345,10851.0920302,30674.4907358,5.8075855,1591.9968362,691.5025523,2116.0396665,2.082541,8.2379543,1.6001996,22.9621349),(26696,'cephalophus_sylvicultor_humerus.tif',240,2,154,178.1010593,65.7533525,52.2045956,1.8,66.5156897,53.1397197,0.4709455,12.7753517,20.9200666,5433.7626309,22459.1359192,6.1109465,1073.5690463,425.3317463,1302.8320471,12.8359663,25.1875565,1.1760052,92.0147512),(26697,'cephalophus_sylvicultor_humerus.tif',240,2,155,67.2484927,63.6725617,47.8318796,1.8,65.1996777,50.3937087,0.5579833,12.0525435,23.7796706,1099.451233,10356.3094972,3.1421331,435.5110583,91.221511,476.4317899,6.3856548,15.5170543,0.9741359,37.219759),(26698,'cephalophus_sylvicultor_humerus.tif',240,2,156,12.9386282,58.028806,42.8114841,1.8,59.3008242,43.8768658,0.5508592,5.9462682,30.6057816,77.1084071,420.29561,0.590795,13.732556,12.9675292,16.2489172,4.5549933,11.4239871,1.012197,26.6121673),(26699,'cephalophus_sylvicultor_humerus.tif',240,2,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26700,'cephalophus_sylvicultor_humerus.tif',240,2,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26701,'cephalophus_sylvicultor_humerus.tif',240,2,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26702,'cephalophus_sylvicultor_humerus.tif',240,2,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26703,'cephalophus_sylvicultor_humerus.tif',240,2,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26704,'cephalophus_sylvicultor_humerus.tif',240,2,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26705,'cephalophus_sylvicultor_humerus.tif',240,2,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26706,'cephalophus_sylvicultor_humerus.tif',240,2,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26707,'cephalophus_sylvicultor_humerus.tif',240,2,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26708,'cephalophus_sylvicultor_humerus.tif',240,2,166,5.3161025,85.8648924,52.562102,1.8,85.8567329,52.5802182,-1.3327772,3.8086969,3.960705,16.0309289,17.0014118,0.8367622,4.2925216,4.2090325,8.3383488,7.6915884,8.1232339,1.7506498,25.9271561),(26709,'cephalophus_sylvicultor_humerus.tif',240,2,167,28.9932614,85.7931448,52.6521851,1.8,85.7968104,52.6682787,-0.8440035,6.7298699,6.8245638,276.3458842,283.0964119,2.6986506,41.4819791,41.0625896,81.9500423,13.5625304,13.9231797,0.8716037,44.7448001),(26710,'cephalophus_sylvicultor_humerus.tif',240,2,168,51.7359743,85.551003,52.6698955,1.8,85.4333243,52.6768731,-1.475972,8.3813128,8.7080397,798.2715035,890.8347344,8.5453625,102.3002612,95.2442086,190.8479727,17.1953511,17.810292,1.1801893,57.2067903),(26711,'cephalophus_sylvicultor_humerus.tif',240,2,169,147.9268051,67.7751535,53.4383322,1.8,65.9972033,53.3686908,-0.0445419,14.4422253,25.3209475,5288.1506425,45288.8324925,0.0488817,1788.5915389,366.1589914,1924.662316,19.8594195,28.5083207,1.7415315,100.826709),(26712,'cephalophus_sylvicultor_humerus.tif',240,2,170,527.819662,61.8557587,53.3822787,1.8,66.5480961,53.2798825,-0.0323103,15.9397322,31.1945214,25508.2993863,80343.6992381,0.091805,2575.5708271,1600.2966129,3272.7776611,0.242188,0.7658658,1.8925469,1.6537634),(26713,'cephalophus_sylvicultor_humerus.tif',240,2,171,561.3857065,62.4033557,53.3467016,1.8,67.1511293,53.2492715,-0.0338933,15.9926936,30.6923455,27365.5388765,87848.7667595,0.1074416,2862.2369945,1711.1275667,3587.814059,0.7265641,0.8732214,2.5535901,2.5394098),(26714,'cephalophus_sylvicultor_humerus.tif',240,2,172,574.6050436,62.768162,53.3383213,1.8,67.5977505,53.2386491,-0.0342593,16.1163254,30.3641029,28476.6514506,93010.3453932,0.1123583,3063.1679005,1766.9444281,3784.9164097,28.8203771,29.2927414,2.1381597,95.6202777),(26715,'cephalophus_sylvicultor_humerus.tif',240,2,173,585.7957158,63.049008,53.3304592,1.8,67.9474354,53.2276423,-0.0343502,15.6728065,30.1007337,29489.3909715,97109.000191,0.1151556,3226.1339946,1881.5641578,3954.9954085,0.4843761,0.7658658,1.8925469,1.8543985),(26716,'cephalophus_sylvicultor_humerus.tif',240,2,174,594.0469881,63.2610851,53.3226873,1.8,68.1944007,53.2104703,-0.0350859,15.6640007,29.9135091,30319.2345606,100206.0500833,0.1218311,3349.8594152,1935.5996648,4079.6056957,0.242188,0.5415489,2.0344439,1.1693873),(26717,'cephalophus_sylvicultor_humerus.tif',240,2,175,599.6128545,63.3826768,53.3246784,1.8,68.377176,53.2143951,-0.0347829,15.7420448,29.8054636,30869.3653488,102305.2435263,0.1208587,3432.4325569,1960.9501709,4152.0138299,28.9005229,57.2717116,0.0634739,185.3692777),(26718,'cephalophus_sylvicultor_humerus.tif',240,2,176,600.7879995,63.3543085,53.3723977,1.8,68.3917864,53.2542957,-0.0261737,15.6230708,29.7382874,30956.477961,102565.564777,0.0685801,3448.9398594,1981.459237,4144.3183671,0.242188,0.5415489,2.0344439,1.1693873),(26719,'cephalophus_sylvicultor_radius.tif',240,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26720,'cephalophus_sylvicultor_radius.tif',240,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26721,'cephalophus_sylvicultor_radius.tif',240,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26722,'cephalophus_sylvicultor_radius.tif',240,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26723,'cephalophus_sylvicultor_radius.tif',240,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26724,'cephalophus_sylvicultor_radius.tif',240,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26725,'cephalophus_sylvicultor_radius.tif',240,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26726,'cephalophus_sylvicultor_radius.tif',240,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26727,'cephalophus_sylvicultor_radius.tif',240,3,9,3.5820102,63.6774923,30.4866748,1.8,63.6816247,30.3885575,-1.3212078,1.7179799,4.2390898,2.0619792,10.8781628,0.5605777,2.5661553,1.2002347,3.0296932,3.6382999,8.1863681,1.3397057,19.4559858),(26728,'cephalophus_sylvicultor_radius.tif',240,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26729,'cephalophus_sylvicultor_radius.tif',240,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26730,'cephalophus_sylvicultor_radius.tif',240,3,12,36.5933231,64.0942653,30.5872928,1.8,63.9730743,30.7708509,-1.1425229,4.6201755,8.3548816,162.2861522,511.6861132,5.0469833,61.2439697,35.1255381,77.4482429,9.7071817,26.9123375,1.2242575,63.8556647),(26731,'cephalophus_sylvicultor_radius.tif',240,3,13,45.8297318,64.1373249,30.7963057,1.8,64.0243766,30.8853946,-1.054887,5.4886438,8.7759479,265.345559,736.7307305,5.7793542,83.9488494,48.344467,111.5745775,10.9115821,27.7959308,1.2357132,66.8387719),(26732,'cephalophus_sylvicultor_radius.tif',240,3,14,54.2478086,64.2686832,31.1197769,1.8,64.2095113,31.0345626,-1.0067519,6.7102484,39.6355567,358.8585367,973.725753,6.457241,24.5669756,53.4791731,33.1492241,11.6529345,28.6225566,1.2801238,68.7706411),(26733,'cephalophus_sylvicultor_radius.tif',240,3,15,59.3399733,64.4877577,31.6947621,1.8,64.5404817,31.1974725,-1.0266402,7.1806701,9.4465673,365.1162497,1143.7184482,7.239383,121.0723869,50.8470998,150.8688177,11.9943598,29.5730777,1.2565644,70.839804),(26734,'cephalophus_sylvicultor_radius.tif',240,3,16,59.5424713,64.9173666,32.2205671,1.8,65.0353499,31.5792835,-1.0504494,6.8876689,42.2582644,305.2808546,1290.8935665,7.4707035,30.5477186,44.3228122,37.7632921,12.0521457,30.5533728,1.2830133,77.1374748),(26735,'cephalophus_sylvicultor_radius.tif',240,3,17,61.2991192,65.3221883,32.5928688,1.8,65.4778326,31.9297473,-1.0680406,21.9225279,41.2627105,295.1443497,1434.9536078,7.8445318,34.7760385,13.4630619,41.8742897,0.8794436,5.010366,1.3825748,11.20289),(26736,'cephalophus_sylvicultor_radius.tif',240,3,18,63.4770928,65.4888002,32.9143508,1.8,65.615735,32.2296593,-1.0958821,6.481459,10.852092,286.6212349,1575.0856816,8.3674587,145.1412019,44.2217154,171.5241044,1.3156083,12.5625894,1.4209839,28.2818124),(26737,'cephalophus_sylvicultor_radius.tif',240,3,19,66.2387403,65.6057655,33.2034929,1.8,65.7320634,32.5419699,-1.1231834,6.4826296,11.1674469,287.6348487,1750.9573908,8.9717206,156.7911985,44.3700884,181.5576375,1.5470978,18.7280174,1.4200499,41.3832586),(26738,'cephalophus_sylvicultor_radius.tif',240,3,20,69.954534,65.7912202,33.2946142,1.8,65.9026857,32.7528058,-1.1352445,6.2808414,11.4990281,297.2444036,1991.0664512,9.58367,173.1508466,47.3255709,198.951019,1.6190626,19.9590677,1.4056476,47.4867667),(26739,'cephalophus_sylvicultor_radius.tif',240,3,21,73.1401207,65.9621156,33.4226142,1.8,66.0540634,32.9053126,-1.1367472,7.0202337,11.6832902,305.7555352,2179.5659572,10.0340868,186.5541224,43.5534693,212.3935713,1.5293751,19.4968477,1.4016951,49.6461116),(26740,'cephalophus_sylvicultor_radius.tif',240,3,22,74.4700328,66.1064008,33.5535918,1.8,66.1953644,32.9824092,-1.1444881,6.6202717,11.8417973,320.592606,2304.1702133,10.289371,194.5794342,48.4258985,221.4755523,0.4687501,1.706276,1.2924967,3.6695758),(26741,'cephalophus_sylvicultor_radius.tif',240,3,23,77.4524057,66.1665525,33.8128427,1.8,66.2912518,33.1992629,-1.1548096,6.5029279,11.9423135,348.1010811,2505.8349879,10.8008557,209.8282698,53.5299002,238.9725193,1.6190626,20.1902905,1.407556,47.7613542),(26742,'cephalophus_sylvicultor_radius.tif',240,3,24,81.8623358,66.1842746,34.221687,1.8,66.272859,33.5886537,-1.1649179,6.4605899,12.3123341,387.8576277,2878.0869798,11.516836,233.7564067,60.0343985,265.2342785,1.7300413,17.1910535,1.3787483,43.0502976),(26743,'cephalophus_sylvicultor_radius.tif',240,3,25,87.8313762,66.2104687,34.7614674,1.8,66.2787778,34.0835362,-1.1778877,6.7568228,12.7763439,446.0641598,3416.8988902,12.4926257,267.4394899,66.0168502,291.996385,1.7448676,26.2039257,1.3909428,64.0165143),(26744,'cephalophus_sylvicultor_radius.tif',240,3,26,94.6155358,66.1583898,35.3651693,1.8,66.2697934,34.6450749,-1.187364,7.4243767,13.279293,507.611733,4053.5166349,13.5622681,305.2509368,68.3709561,343.4042748,1.8404124,21.7880561,1.3649621,55.4985882),(26745,'cephalophus_sylvicultor_radius.tif',240,3,27,102.0332406,66.0631409,36.0745654,1.8,66.1831662,35.3300831,-1.1978499,7.0433885,13.5862873,574.7323903,4788.1082306,14.7479043,352.4221249,81.5988482,391.6140938,2.1177224,24.9639672,1.3531457,60.688152),(26746,'cephalophus_sylvicultor_radius.tif',240,3,28,109.77401,65.9649978,36.7933169,1.8,66.1255684,35.9710262,-1.2111302,7.1003735,14.0580101,648.407445,5599.1384163,16.0292548,398.2881203,91.3201889,444.4036881,1.9051971,27.4579133,1.3382394,67.0329345),(26747,'cephalophus_sylvicultor_radius.tif',240,3,29,117.4189154,65.8970135,37.4849231,1.8,66.0478281,36.6613313,-1.2241596,26.9760414,21.6705402,733.0928239,6503.8794513,17.3110528,300.1253953,27.1757006,209.1471493,1.9497886,26.8305679,1.323699,68.6333474),(26748,'cephalophus_sylvicultor_radius.tif',240,3,30,124.3092097,65.8771054,38.0843732,1.8,65.9548637,37.4046309,-1.2312976,6.9473299,15.3938728,827.3899942,7545.6153672,18.4205812,490.1700482,119.0946751,543.8154626,0.7031251,0.8450512,2.1587989,2.1260319),(26749,'cephalophus_sylvicultor_radius.tif',240,3,31,133.9735526,65.8284531,38.8248442,1.8,65.8932006,38.2311646,-1.2409577,6.7444411,16.0103925,959.5638635,8901.6067438,19.9865103,555.989289,142.2747776,614.8928652,0.4687501,0.8450512,2.5535901,1.6572818),(26750,'cephalophus_sylvicultor_radius.tif',240,3,32,146.3714946,65.6491998,39.7416438,1.8,65.6681147,39.1978188,-1.2520951,6.5698577,16.6257632,1114.924805,10680.1829365,22.0001762,642.3875306,169.7030369,698.7593815,1.960039,24.276774,1.3070845,61.1569021),(26751,'cephalophus_sylvicultor_radius.tif',240,3,33,161.3026017,65.5005773,40.7886907,1.8,65.4980342,40.2880152,-1.2606793,7.2370523,16.9216403,1367.4702273,12788.0485093,24.3801143,755.7215668,188.9540336,830.2161832,13.6534542,37.8854759,1.2236109,206.8708554),(26752,'cephalophus_sylvicultor_radius.tif',240,3,34,179.5810276,65.443545,41.7454869,1.8,65.4814171,41.0524799,-1.2840481,7.7378483,17.7357194,1725.8984017,14923.3101136,27.5358935,841.4268299,223.0462957,932.5565768,14.0177117,37.7372923,1.2745805,194.6971522),(26753,'cephalophus_sylvicultor_radius.tif',240,3,35,179.7945952,65.5111061,41.3586502,1.8,65.5292212,40.8928513,-1.2788363,7.557268,17.2887671,1636.8268888,14535.6943542,27.4832215,840.7594504,216.5897636,930.5420704,13.6266222,36.9844996,1.2550577,151.3722672),(26754,'cephalophus_sylvicultor_radius.tif',240,3,36,161.2759515,65.8693744,39.6105347,1.8,65.7325774,39.8085159,-1.2524157,7.3033568,17.5696464,1433.8379548,10772.1664781,24.2454963,613.1123076,196.3258816,694.3190723,13.4052019,35.1320284,1.3144913,137.7549592),(26755,'cephalophus_sylvicultor_radius.tif',240,3,37,149.4266602,66.1375589,38.4123535,1.8,66.0832603,38.3972872,-1.2233803,7.0271685,14.6164229,1305.6922501,8464.1484876,22.0175365,579.0848121,185.8063091,662.8991526,2.0110053,20.3272214,1.2052781,51.9427502),(26756,'cephalophus_sylvicultor_radius.tif',240,3,38,142.2268844,66.3151266,37.7494718,1.8,66.2735352,37.7768591,-1.1942986,6.7480979,13.8972759,1207.8499235,7178.1144344,20.5001536,516.5123346,178.9911677,600.7036706,1.617709,19.0205126,1.1788488,49.2675435),(26757,'cephalophus_sylvicultor_radius.tif',240,3,39,135.3927869,66.4728025,37.3400947,1.8,66.4384753,37.399965,-1.1620908,7.0417574,12.7560335,1121.0649088,6139.7418623,19.0013826,481.3206143,159.202432,567.6055324,1.6995455,15.4509865,1.1818394,38.807991),(26758,'cephalophus_sylvicultor_radius.tif',240,3,40,129.1719265,66.6082864,37.1444935,1.8,66.5463161,37.2420167,-1.12542,6.9141517,11.8600856,1058.245771,5251.7372911,17.5332273,442.8077064,153.0550409,524.0644421,1.4299337,15.1112839,1.1557216,36.4073717),(26759,'cephalophus_sylvicultor_radius.tif',240,3,41,122.6876604,66.7167861,37.0690235,1.8,66.5349872,37.2097282,-1.0830206,6.652089,12.2496554,990.015276,4494.0547538,15.9566698,366.8719341,148.8277259,440.8535037,12.2338976,22.8536693,1.1254953,104.0894203),(26760,'cephalophus_sylvicultor_radius.tif',240,3,42,117.0094415,66.780484,37.0682092,1.8,66.5594391,37.2505945,-1.0395875,6.8122616,11.2006215,954.1213355,3850.581695,14.4970958,343.7828612,140.0594097,415.3292383,1.7643406,13.8420238,1.076855,33.8694587),(26761,'cephalophus_sylvicultor_radius.tif',240,3,43,112.7543354,66.8431559,37.2217568,1.8,66.5880284,37.4188734,-1.0133331,7.0187848,11.0397413,932.8151224,3459.7392694,13.5328093,313.3895228,132.9026539,386.0926112,0.4687501,0.6629127,2.3561945,1.3258254),(26762,'cephalophus_sylvicultor_radius.tif',240,3,44,111.3080015,66.8395146,37.5676163,1.8,66.5222697,37.8397409,-0.9911492,9.1872371,10.870226,950.9442586,3298.9692609,12.985808,303.4867227,103.5070989,360.8052806,1.7641364,14.8231788,0.9652517,33.5948713),(26763,'cephalophus_sylvicultor_radius.tif',240,3,45,115.5497243,66.934683,38.271844,1.8,66.6872851,38.6936863,-1.0204651,11.1420901,10.4191493,1301.0094745,3324.1623257,13.9911993,319.0435438,116.7652987,387.1276724,1.524625,11.0554484,1.012197,26.2557197),(26764,'cephalophus_sylvicultor_radius.tif',240,3,46,127.5998989,67.1822122,39.2907123,1.8,67.0968671,39.7006198,-1.1185559,10.9665616,10.9536112,1941.4666543,3485.1065363,17.2057172,318.1696418,177.0351291,437.1016324,1.441383,14.7674873,0.9431669,34.4852597),(26765,'cephalophus_sylvicultor_radius.tif',240,3,47,4.3623726,75.3889197,48.9097929,1.8,75.4937459,49.0236434,-0.127497,1.3359034,2.9822362,1.37215,5.7596452,0.0117548,1.9313176,1.0271327,2.3907516,2.8125004,5.6687759,3.0172377,13.9918346),(26766,'cephalophus_sylvicultor_radius.tif',240,3,48,14.6647052,75.6043301,50.0041825,1.8,75.5569028,50.8774118,1.4265306,5.8534451,11.5337002,39.3928282,91.8116236,2.393601,7.9602922,6.7298535,11.3754583,1.0121333,2.2110897,2.5829933,5.2464328),(26767,'cephalophus_sylvicultor_radius.tif',240,3,49,65.4797179,71.2624221,51.0132751,1.8,70.7195964,51.5184855,0.4695891,13.8185888,17.4623691,744.9160261,3190.4331624,2.2347603,182.7033401,53.906809,222.3033473,0.7031251,1.1718752,0.9272952,2.6516508),(26768,'cephalophus_sylvicultor_radius.tif',240,3,50,119.2555138,69.492836,52.2897191,1.8,68.593203,52.697084,0.4120418,13.2560578,17.6039357,2421.5168733,6831.8962809,3.1878004,388.0891408,182.6724743,525.1383737,14.7167956,29.5433429,2.5998126,110.6852343),(26769,'cephalophus_sylvicultor_radius.tif',240,3,51,187.5553065,67.4819883,53.4888928,1.8,66.7357654,54.0727664,0.2197227,13.3615515,17.0027023,4709.4882389,9986.9479975,1.4850043,587.3741598,352.4656738,858.3283636,21.2557531,30.2915568,2.7610863,157.9307267),(26770,'cephalophus_sylvicultor_radius.tif',240,3,52,260.5047478,66.2265606,54.0094407,1.8,65.3125922,54.1079454,0.019536,12.6814651,16.5974323,6618.9079037,16032.0078292,0.0165685,965.9330157,521.9355839,1296.6355753,19.9218781,32.3743113,3.0981418,119.4444348),(26771,'cephalophus_sylvicultor_radius.tif',240,3,53,293.6237101,64.3023836,54.0433914,1.8,64.5943655,53.8850246,-0.0762078,12.9990621,18.1892168,7137.7371048,23341.7698148,0.2836595,1283.2751449,549.0963173,1608.2028513,19.4554633,34.6407573,0.1562501,96.2286912),(26772,'cephalophus_sylvicultor_radius.tif',240,3,54,296.8984526,63.5024266,53.5566956,1.8,64.3768631,53.3756236,-0.1367935,13.8872428,19.1475235,7640.7454544,25806.0753636,0.9201888,1347.7500261,550.1988824,1731.1427491,19.7542431,35.1171713,0.1947778,95.2911911),(26773,'cephalophus_sylvicultor_radius.tif',240,3,55,286.0407943,63.5430782,53.4429371,1.8,64.2782137,53.2360492,-0.1767381,13.6355934,18.8604611,7449.4890997,25003.8391374,1.4737038,1325.7278808,546.3267246,1625.2033292,19.7164188,34.8423541,0.1894802,94.4674288),(26774,'cephalophus_sylvicultor_radius.tif',240,3,56,250.5488676,63.5105,53.3379756,1.8,64.0519292,53.2262187,-0.2126405,13.8805846,18.7438513,6470.6600154,20451.8083441,1.8598477,1091.1209258,466.1662455,1419.6546637,20.0456466,33.2325289,0.1987787,102.8009494),(26775,'cephalophus_sylvicultor_radius.tif',240,3,57,228.0803048,63.4172727,53.4460415,1.8,64.055422,53.2835338,-0.2295804,14.7892139,18.1213557,5611.9127128,17057.1147802,1.9686225,941.2714497,379.4598371,1250.9220427,20.1562531,31.323064,0.2340898,111.0638024),(26776,'cephalophus_sylvicultor_radius.tif',240,3,58,216.4544855,63.272845,53.7312388,1.8,63.8888905,53.5161773,-0.2371647,13.1650704,17.926643,5104.5054516,14990.6629327,1.991395,836.2225415,387.7309652,1118.1292468,0.234375,0.3314564,2.3561945,0.6629127),(26777,'cephalophus_sylvicultor_radius.tif',240,3,59,208.3653161,63.1595689,54.0642704,1.8,63.5658863,53.9184341,-0.2203299,13.3972365,16.4262142,4572.32002,13203.3726459,1.6587542,803.7988847,341.2882966,1074.1642872,17.780546,29.9459398,0.393587,95.438242),(26778,'cephalophus_sylvicultor_radius.tif',240,3,60,198.9841875,63.0250039,54.3986202,1.8,63.3170753,54.2989292,-0.207724,12.0879142,15.9122238,4116.4905848,11653.6208536,1.4105397,732.3690887,340.5459786,977.5199054,17.3437527,28.2030212,0.2691675,76.2235305),(26779,'cephalophus_sylvicultor_radius.tif',240,3,61,190.8253548,62.9208944,54.6954638,1.8,63.2880319,54.5228937,-0.2002327,12.1940614,15.507096,3756.7336741,10497.4899406,1.2581804,676.9475066,308.0789533,873.6645917,17.1093777,27.5128742,0.2408465,74.2112365),(26780,'cephalophus_sylvicultor_radius.tif',240,3,62,185.41715,62.7444307,54.9626774,1.8,63.0802899,54.8000585,-0.1880067,11.5714707,15.9412769,3520.3157309,9551.2110388,1.0794989,599.1496862,304.22371,772.4592842,0.234375,0.3314564,2.3561945,0.6629127),(26781,'cephalophus_sylvicultor_radius.tif',240,3,63,180.8964743,62.5295674,55.1936688,1.8,62.821961,55.0130802,-0.1663394,11.6434382,15.3307588,3303.7846157,8768.3845897,0.8265323,571.9472004,283.7464814,740.6859246,18.0775514,26.209166,0.2623305,82.7957887),(26782,'cephalophus_sylvicultor_radius.tif',240,3,64,176.4988289,62.3736847,55.3784036,1.8,62.5983967,55.3307562,-0.1487751,12.7133672,14.6402282,3120.6930128,8096.2548398,0.6463151,553.0142507,245.4654988,762.558122,16.4062526,25.6027239,0.2027815,69.2727042),(26783,'cephalophus_sylvicultor_radius.tif',240,3,65,168.9029126,62.291757,55.5382466,1.8,62.4947014,55.3931992,-0.1262248,11.1166033,13.8606648,2865.3395252,7470.2433998,0.4461363,538.9527479,257.7531503,744.3401432,15.9329593,25.0967406,0.1973956,67.0093787),(26784,'cephalophus_sylvicultor_radius.tif',240,3,66,164.3943884,62.1631322,55.7013528,1.8,62.3567525,55.6245869,-0.1086194,11.0540496,13.4980375,2664.9672018,7011.5553699,0.3219895,519.4499859,241.0851503,691.9764222,15.6481618,24.6851551,0.2104302,66.0150096),(26785,'cephalophus_sylvicultor_radius.tif',240,3,67,158.0856706,61.9549438,55.9010138,1.8,62.0666072,55.8329171,-0.0948472,12.4390267,13.0421697,2483.1503963,6617.8690037,0.236313,507.4208635,199.6257787,679.142042,15.2343774,24.2779053,0.2239045,64.4950215),(26786,'cephalophus_sylvicultor_radius.tif',240,3,68,154.080953,61.7739812,56.1352097,1.8,61.9130127,56.035902,-0.0808896,10.5413064,13.1671537,2322.1247723,6287.191925,0.1676624,477.4905853,220.2881398,648.8397768,15.0000023,23.9315161,0.1474372,64.0262715),(26787,'cephalophus_sylvicultor_radius.tif',240,3,69,151.7640189,61.5957575,56.3366905,1.8,61.7733691,56.1912598,-0.0743837,10.5586863,12.7943731,2206.6471733,6004.3741276,0.1396922,469.2980346,208.9887991,626.4744978,14.6231406,23.4901789,0.2110933,62.8377398),(26788,'cephalophus_sylvicultor_radius.tif',240,3,70,148.9957464,61.4841859,56.546021,1.8,61.7127347,56.413823,-0.0661891,10.4185836,12.6788737,2095.4263298,5710.9017314,0.1086329,450.4265824,201.1239158,601.0303003,14.2968772,23.1224961,0.18348,62.0375333),(26789,'cephalophus_sylvicultor_radius.tif',240,3,71,147.2813793,61.4177428,56.7299167,1.8,61.5805161,56.6222002,-0.0585659,11.3835254,12.4857992,2003.7435052,5494.1506916,0.0840987,440.0319615,176.0213498,581.0910171,14.0625022,22.8103631,0.1651487,61.1000332),(26790,'cephalophus_sylvicultor_radius.tif',240,3,72,145.9462071,61.3853988,56.914856,1.8,61.5679868,56.7756619,-0.044426,9.9252501,12.2362528,1898.1565092,5261.7183573,0.0479767,430.010597,191.2452061,563.6364669,13.8281272,22.5061062,0.1463153,60.1056641),(26791,'cephalophus_sylvicultor_radius.tif',240,3,73,142.4914719,61.4016016,57.0920037,1.8,61.519034,56.989981,-0.0235409,10.2838613,11.9908418,1758.746554,4979.3294945,0.0131583,415.2610443,171.0200571,528.340363,13.3593771,22.1171068,0.1703751,58.9171324),(26792,'cephalophus_sylvicultor_radius.tif',240,3,74,140.4419551,61.3814863,57.2569502,1.8,61.4768085,57.1885836,-0.0084772,9.5497365,11.7575995,1668.0874597,4763.2930976,0.001682,405.1246248,174.6736631,512.1411598,12.9628964,21.8107349,0.1510153,58.116926),(26793,'cephalophus_sylvicultor_radius.tif',240,3,75,139.5612674,61.3594573,57.4118625,1.8,61.4436339,57.3697224,0.0081739,10.1161644,12.0072731,1619.2276757,4574.1099491,0.001554,380.9449401,160.0634013,514.5130692,12.7829106,21.5127687,0.1311116,57.4540133),(26794,'cephalophus_sylvicultor_radius.tif',240,3,76,138.8016458,61.3347127,57.5745109,1.8,61.4007947,57.4970535,0.0215207,10.1509389,12.0236484,1556.0500409,4415.4363671,0.0107125,367.2293314,153.2912433,485.6886396,12.5808154,21.1535643,0.1669702,56.4596442),(26795,'cephalophus_sylvicultor_radius.tif',240,3,77,138.6604215,61.3080484,57.7350046,1.8,61.3585144,57.6679949,0.0367964,9.9625046,11.1120401,1507.6033162,4289.6372469,0.0312764,386.035075,151.3277412,488.3617988,12.409063,20.9224851,0.1688319,56.2654816),(26796,'cephalophus_sylvicultor_radius.tif',240,3,78,139.3010578,61.2735522,57.8866069,1.8,61.3030278,57.8567457,0.0519916,9.8333249,10.9359609,1473.3006742,4217.538309,0.0627015,385.6577719,149.8273155,479.769619,12.2533934,20.7855115,0.124355,55.6594378),(26797,'cephalophus_sylvicultor_radius.tif',240,3,79,138.4776156,61.1708463,58.0343484,1.8,61.2665623,57.9502239,0.0715971,9.4608709,11.0116922,1429.1595803,4135.9572257,0.1181074,375.5968784,151.0600449,470.9319977,12.1864705,20.6170116,0.1483278,55.3279814),(26798,'cephalophus_sylvicultor_radius.tif',240,3,80,138.6728561,61.067051,58.181057,1.8,61.0839181,58.1519264,0.0901221,9.4233046,10.9212377,1392.8648515,4083.4095429,0.187209,373.8962257,147.8106573,501.4116829,12.0618532,20.4994435,0.1030816,54.9965251),(26799,'cephalophus_sylvicultor_radius.tif',240,3,81,138.1390702,61.003277,58.2816393,1.8,61.0927778,58.2704406,0.1031027,9.947944,10.9962005,1367.3375537,4034.8749104,0.2438742,366.9335528,137.4492616,476.610901,11.9835496,20.4766536,3.0498965,55.1338188),(26800,'cephalophus_sylvicultor_radius.tif',240,3,82,137.601439,60.9041215,58.4217447,1.8,60.9345584,58.4112051,0.1164097,9.7929788,11.0214363,1338.8628786,4001.5520831,0.3093766,363.0699269,136.7166112,474.7728468,11.9211563,20.4766536,3.0498965,54.9965251),(26801,'cephalophus_sylvicultor_radius.tif',240,3,83,137.7146482,60.8430077,58.5412047,1.8,60.9379749,58.4468748,0.1228805,9.6293768,11.1189794,1324.88782,4014.3697842,0.3448324,361.0376131,137.5881173,448.0726873,11.8556781,20.5529669,3.0158232,54.6650687),(26802,'cephalophus_sylvicultor_radius.tif',240,3,84,137.9520362,60.760648,58.6657659,1.8,60.8283726,58.6195211,0.1342781,9.2788883,11.0067156,1305.9779618,4028.0842068,0.4120746,365.9660473,140.7472449,471.7091595,11.8004179,20.6170116,2.9932648,56.7106758),(26803,'cephalophus_sylvicultor_radius.tif',240,3,85,138.7000722,60.6863377,58.7800901,1.8,60.7308241,58.7792139,0.1425283,11.4050312,23.7153571,1276.3780286,4066.1989772,0.4664284,171.4584756,111.913594,203.0220125,11.81136,20.8488419,2.9949262,56.2419257),(26804,'cephalophus_sylvicultor_radius.tif',240,3,86,139.5792118,60.6103936,58.8774305,1.8,60.6710817,58.8503016,0.1534483,11.8427686,24.1128187,1261.6752594,4108.3364494,0.5434783,170.379768,106.5354984,199.8955567,11.9531269,21.0807284,2.996551,55.4417193),(26805,'cephalophus_sylvicultor_radius.tif',240,3,87,140.2667064,60.5665241,58.9841224,1.8,60.6889556,59.0274257,0.1597521,12.0695649,23.8326335,1245.6437382,4161.8485614,0.5915603,174.6281444,103.205356,202.4172638,11.9531269,21.1535643,2.9746225,56.2419257),(26806,'cephalophus_sylvicultor_radius.tif',240,3,88,140.9534853,60.5313135,59.0691317,1.8,60.6634109,59.0924371,0.1628758,11.2736882,22.694175,1247.0246024,4207.1331139,0.6177235,185.3838318,110.613721,218.1887551,11.7187518,21.3474362,2.9872739,56.2987946),(26807,'cephalophus_sylvicultor_radius.tif',240,3,89,140.8601348,60.5352118,59.0940273,1.8,60.6138849,59.0742572,0.1704916,9.2742913,11.8680505,1253.9917889,4202.6356176,0.6758192,354.1133928,135.2116029,457.7265682,11.9531269,21.3847154,2.976444,57.5677511),(26808,'cephalophus_sylvicultor_radius.tif',240,3,90,141.5855989,60.5010771,59.1641809,1.8,60.5813519,59.1366076,0.1730624,9.3938084,12.1175401,1263.0189418,4253.7132778,0.6997347,351.0376905,134.4522782,422.1122465,12.1875019,21.4667575,2.9549033,58.5621202),(26809,'cephalophus_sylvicultor_radius.tif',240,3,91,141.9257757,60.4419963,59.2325141,1.8,60.4638405,59.2479259,0.1830537,8.8840612,12.2778956,1267.2314946,4289.612251,0.7838096,349.3768299,142.6410144,450.0292621,11.9531269,21.6083107,2.9229237,57.4540133),(26810,'cephalophus_sylvicultor_radius.tif',240,3,92,141.2915647,60.3696765,59.3268683,1.8,60.3748808,59.3857327,0.1976499,9.1439246,11.7665634,1240.4393404,4290.553738,0.9080201,364.6394957,135.6572151,468.5054371,12.1875019,21.7716622,2.8913921,56.8479695),(26811,'cephalophus_sylvicultor_radius.tif',240,3,93,142.0958308,60.3882545,59.383737,1.8,60.4330546,59.3575536,0.1964506,9.3671386,11.2763496,1251.9246048,4375.8660358,0.9022834,388.0569675,133.6506972,479.3376111,11.8200544,21.7716622,2.8913921,57.5344381),(26812,'cephalophus_sylvicultor_radius.tif',240,3,94,142.2659691,60.3430939,59.4525742,1.8,60.3659914,59.4622942,0.2093899,15.5759202,22.9358516,1237.9147349,4391.9641342,1.0244829,191.4890369,79.4761864,203.0631794,11.8231518,21.8924351,2.8706458,57.4540133),(26813,'cephalophus_sylvicultor_radius.tif',240,3,95,142.847196,60.338363,59.4924124,1.8,60.3825878,59.4583085,0.2166209,16.5961274,22.9972035,1243.1873972,4455.2571705,1.0998099,193.7303888,74.9082823,202.4977696,12.0164862,21.998816,2.89403,57.7854696),(26814,'cephalophus_sylvicultor_radius.tif',240,3,96,142.9243,60.3205971,59.5443201,1.8,60.3842366,59.5025287,0.2261976,8.7385467,11.5253936,1225.7210978,4507.6990172,1.1981503,391.1102027,140.2660119,496.432642,11.8292939,22.0910128,2.8399736,57.3402754),(26815,'cephalophus_sylvicultor_radius.tif',240,3,97,141.0060699,60.2611419,59.5634548,1.8,60.2200961,59.5728894,0.2530194,8.605983,11.1313814,1196.5451137,4469.2788185,1.4726744,401.5026228,139.0364254,492.5695623,11.8297377,22.2347683,2.8198421,56.9283943),(26816,'cephalophus_sylvicultor_radius.tif',240,3,98,141.7403397,60.3091654,59.5680049,1.8,60.3042796,59.5219283,0.2492962,8.6924533,11.1739232,1215.3339748,4552.2207324,1.4379962,407.3968169,139.8148402,503.3461709,11.6596522,22.3849633,2.8330864,58.2777756),(26817,'cephalophus_sylvicultor_radius.tif',240,3,99,141.3970002,60.3025505,59.5949275,1.8,60.2566231,59.5705824,0.2608987,9.061037,11.2549299,1215.8002785,4569.4937545,1.5680379,405.9993084,134.1789328,504.8237961,0.234375,0.5240785,2.0344439,1.1316628),(26818,'cephalophus_sylvicultor_radius.tif',240,3,100,140.8747333,60.3138594,59.6031534,1.8,60.293653,59.5427022,0.2694954,8.9584304,11.4088499,1220.9784042,4635.5971496,1.6643514,406.3159046,136.2937876,502.8789971,0.4458078,1.4823179,1.8925469,3.2008257),(26819,'cephalophus_sylvicultor_radius.tif',240,3,101,141.0052542,60.3342503,59.6007974,1.8,60.3003873,59.529193,0.2775501,8.6691379,11.413001,1230.5889021,4679.6196367,1.7643561,410.0253426,141.9505506,501.7604222,0.234375,0.7411589,1.8925469,1.6004129),(26820,'cephalophus_sylvicultor_radius.tif',240,3,102,141.1047138,60.3530452,59.6113739,1.8,60.3510104,59.5437908,0.2821155,8.6602884,11.4471783,1229.3389593,4727.7408614,1.8226012,413.0049116,141.9512719,504.8154843,0.5121379,1.7849471,1.9756881,3.8637384),(26821,'cephalophus_sylvicultor_radius.tif',240,3,103,140.2144381,60.3760377,59.6063682,1.8,60.4149526,59.5252606,0.2883081,8.533374,11.4853272,1237.4265762,4732.5330213,1.889246,412.0503442,145.0102361,495.5444714,0.4687501,1.048157,2.0344439,2.2633256),(26822,'cephalophus_sylvicultor_radius.tif',240,3,104,139.488741,60.3904467,59.6025324,1.8,60.4088799,59.5105647,0.2946945,8.9717485,11.4398455,1236.8134267,4744.2662605,1.961206,414.7141886,137.8564538,503.7896372,0.4687501,0.8450512,2.1587989,1.7945755),(26823,'cephalophus_sylvicultor_radius.tif',240,3,105,138.8361695,60.5117853,59.5043729,1.8,60.6384691,59.4286318,0.2989208,10.8325317,11.4615744,1281.227183,4727.5827445,2.0067338,412.4723677,118.2758767,497.439116,11.6750228,22.8968937,2.7420772,59.5231762),(26824,'cephalophus_sylvicultor_radius.tif',240,3,106,137.8566049,60.5580998,59.482421,1.8,60.7194958,59.3970607,0.302914,10.1331404,11.3539803,1298.1782257,4709.8720881,2.0445188,414.8212323,128.1121324,494.6149554,0.5863261,1.3666296,2.1112158,2.9262383),(26825,'cephalophus_sylvicultor_radius.tif',240,3,107,137.0816191,60.5947014,59.4643117,1.8,60.7544549,59.4071476,0.3070932,10.0767322,11.2997736,1315.9493961,4696.54386,2.0877238,415.6316766,130.5928714,495.2732828,0.234375,0.7411589,1.8925469,1.6004129),(26826,'cephalophus_sylvicultor_radius.tif',240,3,108,136.0146466,60.627065,59.4334686,1.8,60.7801586,59.3859987,0.3117654,9.2930652,11.3093999,1328.0906511,4693.1104714,2.1329145,414.9743143,142.9120128,514.0506728,0.6292508,1.3666296,2.1112158,2.9262383),(26827,'cephalophus_sylvicultor_radius.tif',240,3,109,137.0743115,60.7078454,59.3515173,1.8,60.9017925,59.2722102,0.3104069,8.8091229,11.4241979,1390.506566,4716.9753138,2.1314447,412.8933481,157.8484689,498.5997935,0.4601378,1.706276,1.849096,3.6695758),(26828,'cephalophus_sylvicultor_radius.tif',240,3,110,136.1166863,60.7321125,59.3365664,1.8,60.8909649,59.2939347,0.3185314,9.9763132,11.2904205,1386.3297255,4726.5796367,2.2249823,418.6362801,138.96213,510.0315231,12.0125013,22.681159,2.7380577,59.8546326),(26829,'cephalophus_sylvicultor_radius.tif',240,3,111,137.3420284,60.795046,59.2775744,1.8,60.9654727,59.2148706,0.322178,9.0678535,11.495612,1424.2794716,4756.4760182,2.2949077,413.7644894,157.0690867,506.9682301,12.1843974,22.6557147,2.7149652,59.6604699),(26830,'cephalophus_sylvicultor_radius.tif',240,3,112,136.9055215,60.8279825,59.2279246,1.8,61.0031767,59.1344444,0.3327277,8.9519872,11.3734311,1440.5871109,4757.207324,2.4342288,418.2737173,160.9237236,517.4597407,0.4687501,0.6629127,2.3561945,1.3258254),(26831,'cephalophus_sylvicultor_radius.tif',240,3,113,135.2841554,60.9234483,59.1017306,1.8,61.0978804,58.9356205,0.346157,8.9039208,11.1573386,1458.0755872,4711.7245907,2.5955274,422.2982513,163.7565766,499.2906383,0.234375,0.966353,1.815775,2.0691629),(26832,'cephalophus_sylvicultor_radius.tif',240,3,114,134.99911,61.0197047,59.0153393,1.8,61.1605585,58.7662109,0.3464496,8.9451681,11.5915143,1506.1319454,4689.240385,2.5942625,404.540793,168.3737995,505.9116058,0.4687501,1.2621482,1.9513027,2.7320756),(26833,'cephalophus_sylvicultor_radius.tif',240,3,115,133.9261616,61.0966357,58.980405,1.8,61.2387423,58.8493106,0.3505043,9.0006745,11.518097,1512.3463617,4679.2316579,2.6317374,406.250413,168.0258928,475.0851756,0.4560488,3.638479,1.8313987,7.8079016),(26834,'cephalophus_sylvicultor_radius.tif',240,3,116,134.0961667,61.1742747,58.9122579,1.8,61.3238135,58.7914915,0.3516826,8.9448584,11.1737953,1533.3590716,4691.1595485,2.6520873,419.8358219,171.4235145,535.1593823,0.4687501,1.4823179,1.8925469,3.2008257),(26835,'cephalophus_sylvicultor_radius.tif',240,3,117,133.73986,61.2574546,58.84177,1.8,61.4624606,58.7875154,0.3567341,9.0474207,11.1614468,1557.5280944,4707.1666164,2.7182996,421.7344498,172.1516154,539.6727329,0.4601378,1.4823179,1.8925469,3.2008257),(26836,'cephalophus_sylvicultor_radius.tif',240,3,118,132.9958024,61.3137452,58.7843321,1.8,61.4931452,58.7417286,0.3645975,8.749872,11.0939139,1565.7553758,4718.9039819,2.8182816,425.3597077,178.9460898,542.865141,0.5100311,1.5722355,2.0344439,3.3949884),(26837,'cephalophus_sylvicultor_radius.tif',240,3,119,133.109977,61.3792273,58.733543,1.8,61.5370048,58.6992007,0.3707976,9.1559423,12.0009351,1571.3287305,4735.3542366,2.9129785,394.5821049,171.6184608,521.2052356,12.7714265,22.6411623,2.668686,59.1348509),(26838,'cephalophus_sylvicultor_radius.tif',240,3,120,134.197757,61.4858975,58.6134884,1.8,61.6362367,58.5539331,0.3680231,9.3134657,11.2742729,1642.0141132,4751.5422476,2.8949949,421.4499938,176.3053809,546.6447,13.0135877,22.5414692,2.6546934,59.603601),(26839,'cephalophus_sylvicultor_radius.tif',240,3,121,132.8338705,61.5800485,58.4805367,1.8,61.7225277,58.4799813,0.380458,9.3527142,11.5013022,1654.9951858,4737.785505,3.0529134,411.9347042,176.9534654,538.2516894,13.1106222,22.5414692,2.6546934,59.603601),(26840,'cephalophus_sylvicultor_radius.tif',240,3,122,133.1466813,61.6755336,58.3898882,1.8,61.8467491,58.3945434,0.3827464,8.9524635,11.7023649,1694.4780646,4733.1358673,3.095205,404.4597728,189.2750588,539.6527652,0.5949463,3.7057947,1.8925469,8.1962269),(26841,'cephalophus_sylvicultor_radius.tif',240,3,123,131.9186925,61.7285225,58.3031137,1.8,61.8249095,58.2397962,0.3903606,8.8817152,11.2470452,1710.5010108,4725.0244169,3.1835701,420.1125128,192.5867892,545.7573363,0.6676317,3.0468755,1.9655874,6.5958141),(26842,'cephalophus_sylvicultor_radius.tif',240,3,124,132.3835641,61.7812254,58.2221501,1.8,61.8509433,58.2034969,0.3980242,9.7070594,11.4561088,1729.8875052,4755.2385119,3.3147077,415.0832179,178.2092218,554.7474267,0.6318907,3.3557398,2.0032041,7.2587268),(26843,'cephalophus_sylvicultor_radius.tif',240,3,125,133.2089705,61.8660924,58.1042619,1.8,61.9150337,58.0272326,0.4026241,9.8388495,11.4919327,1791.2220945,4788.4201613,3.4086807,416.676664,182.0560522,562.536467,0.6412879,3.3557398,2.0032041,7.2587268),(26844,'cephalophus_sylvicultor_radius.tif',240,3,126,133.0811296,61.9249762,58.0167501,1.8,61.9885578,57.9201735,0.4087368,9.6027846,11.2725584,1806.9527839,4826.1771492,3.5037354,428.13503,188.169668,566.6770071,0.6318907,2.3083264,1.9890207,4.9954012),(26845,'cephalophus_sylvicultor_radius.tif',240,3,127,133.7408421,62.0022747,57.9056684,1.8,62.0806983,57.8348687,0.4108496,9.5402852,11.1314305,1855.7181492,4875.8574491,3.5555236,438.0261317,194.5139067,575.8347369,0.6261501,2.4469472,1.8622531,5.4641513),(26846,'cephalophus_sylvicultor_radius.tif',240,3,128,133.4601747,62.0471922,57.8164798,1.8,62.1374547,57.7914201,0.4193555,9.1802747,11.8400775,1875.2205526,4904.7154311,3.6877031,414.2469016,204.2662789,561.4476252,13.9301219,22.3554965,2.6263477,59.3858825),(26847,'cephalophus_sylvicultor_radius.tif',240,3,129,133.5457848,62.1797638,57.6271184,1.8,62.3097444,57.5735986,0.4220804,9.4678023,11.4061446,1941.1521649,4898.14876,3.7352903,429.43071,205.0266893,579.4554287,0.6224373,3.7057947,1.8925469,8.0020643),(26848,'cephalophus_sylvicultor_radius.tif',240,3,130,132.7806201,62.2430283,57.5436138,1.8,62.322316,57.5274762,0.4271214,9.7983279,11.4648028,1971.1710838,4871.1157401,3.7976399,424.8756675,201.1742312,580.0379096,0.5688384,1.7849471,1.9756881,3.8637384),(26849,'cephalophus_sylvicultor_radius.tif',240,3,131,132.2433718,62.3333076,57.4426129,1.8,62.4187954,57.4182005,0.4261153,10.1407004,11.7177589,2033.6180528,4838.4210905,3.7655678,412.9135197,200.5401961,578.1386152,0.6129108,2.7432895,1.9195673,5.9329014),(26850,'cephalophus_sylvicultor_radius.tif',240,3,132,131.684617,62.4051389,57.3475706,1.8,62.4519189,57.3008617,0.429233,10.1496316,11.834082,2064.7037528,4834.2567936,3.8013049,408.502898,203.4264717,566.0698187,0.5797965,2.3083264,1.9890207,4.9954012),(26851,'cephalophus_sylvicultor_radius.tif',240,3,133,132.1588936,62.4586162,57.2204412,1.8,62.4607656,57.1774556,0.4381433,10.2848326,11.4317205,2121.3822889,4859.7167014,3.9646691,425.1080764,206.263181,598.1850326,0.6684731,2.9646358,1.8925469,6.4016514),(26852,'cephalophus_sylvicultor_radius.tif',240,3,134,132.1879575,62.5000085,57.1067341,1.8,62.5128673,57.136446,0.4495738,10.4898262,11.8082597,2172.8028846,4895.8023395,4.1608638,414.6082875,207.1343077,583.3465609,0.6693146,2.4469472,1.8622531,5.4641513),(26853,'cephalophus_sylvicultor_radius.tif',240,3,135,131.9468075,62.5428024,56.9816407,1.8,62.5287959,56.9786433,0.4628367,10.6483002,11.4057658,2214.942561,4922.4314233,4.3839689,431.5739526,208.0090276,606.227984,0.234375,0.966353,1.815775,2.0691629),(26854,'cephalophus_sylvicultor_radius.tif',240,3,136,133.0143626,62.6129001,56.8288173,1.8,62.6069013,56.7809718,0.4679855,10.5069266,11.8809353,2308.2284101,4972.3730646,4.5109958,418.5169704,219.6863554,596.451985,0.5949463,2.6203926,2.0344439,5.6583139),(26855,'cephalophus_sylvicultor_radius.tif',240,3,137,131.8652423,62.6861446,56.6116217,1.8,62.6629452,56.5826465,0.482394,10.0614634,11.9559216,2339.8897351,4980.4842857,4.7296645,416.5705024,232.5595833,595.532128,0.5246732,1.7849471,1.9756881,3.8637384),(26856,'cephalophus_sylvicultor_radius.tif',240,3,138,132.0533416,62.7715799,56.4288238,1.8,62.7565828,56.3560169,0.489729,10.259954,11.753885,2443.6734332,5010.5536379,4.8697685,426.289148,238.1758658,625.616592,15.9892874,21.9124992,2.5773245,62.265009),(26857,'cephalophus_sylvicultor_radius.tif',240,3,139,132.0998504,62.8096436,56.2966255,1.8,62.7521191,56.2335118,0.5023294,10.7815323,11.5815694,2509.5287052,5036.8559544,5.1037202,434.9027137,232.7617859,615.0016473,0.7090016,3.1878451,1.8692953,7.0645641),(26858,'cephalophus_sylvicultor_radius.tif',240,3,140,132.508492,62.8505483,56.1503138,1.8,62.7700139,56.0792011,0.5125093,10.6895287,11.6591727,2582.9135089,5083.8166348,5.3104658,436.0357929,241.6302518,639.4310069,0.5688384,2.2234768,1.8925469,4.8012386),(26859,'cephalophus_sylvicultor_radius.tif',240,3,141,133.442247,62.9043881,55.9850851,1.8,62.8254785,55.8961576,0.5232604,10.9648026,11.6322675,2684.6534016,5134.9053878,5.5535784,441.4363217,244.8428389,656.9388634,0.889895,2.0963141,2.0344439,5.1895638),(26860,'cephalophus_sylvicultor_radius.tif',240,3,142,134.0004025,62.9510014,55.8114585,1.8,62.8480124,55.8018036,0.5372541,11.7062547,11.7152645,2777.4598047,5207.6293137,5.8495115,444.5165786,237.2628895,663.0734691,0.4687501,2.1608311,1.7894653,4.8012386),(26861,'cephalophus_sylvicultor_radius.tif',240,3,143,133.7726692,63.0111158,55.6538395,1.8,62.9384769,55.6002655,0.5461965,11.2508527,11.5586713,2842.6637649,5266.9764845,6.0157308,455.6731779,252.6620729,680.1186881,0.6684731,1.4256477,1.735945,3.3949884),(26862,'cephalophus_sylvicultor_radius.tif',240,3,144,134.0489921,63.0567361,55.4786166,1.8,63.0037074,55.4261179,0.5587311,10.9943114,11.7289487,2946.5940117,5323.7268192,6.2783488,453.8963344,268.0107835,682.9036332,17.0700023,22.4278664,2.5419964,64.2204341),(26863,'cephalophus_sylvicultor_radius.tif',240,3,145,135.00179,63.188173,55.2124715,1.8,63.3818765,55.2591677,0.5688036,10.9564406,12.0911676,3062.9639093,5362.9610625,6.5277028,443.5436859,279.5583011,696.8576726,0.5527935,2.0025012,1.929567,4.3324885),(26864,'cephalophus_sylvicultor_radius.tif',240,3,146,134.5612215,63.2159379,55.0409328,1.8,63.338909,55.0933556,0.5860149,11.5073905,11.8785979,3155.8868075,5378.8861614,6.8594608,452.8216374,274.2486938,687.5490735,0.5932634,2.5242964,1.9513027,5.6583139),(26865,'cephalophus_sylvicultor_radius.tif',240,3,147,134.8408236,63.2664639,54.840889,1.8,63.4258867,54.9180092,0.60192,12.0536955,12.095378,3252.6284047,5444.1414364,7.2052638,450.1009767,269.8449125,683.966755,0.6267614,3.4842354,1.9138203,7.7274769),(26866,'cephalophus_sylvicultor_radius.tif',240,3,148,134.2045153,63.3146174,54.6327446,1.8,63.4694734,54.7203949,0.6114824,12.1319303,11.6585986,3338.790965,5483.3002198,7.3716301,470.3224113,275.2069022,692.5304601,0.6292508,1.3666296,2.1112158,2.9262383),(26867,'cephalophus_sylvicultor_radius.tif',240,3,149,134.2063463,63.375581,54.3678977,1.8,63.4890524,54.4517479,0.6179309,12.3578135,11.773272,3438.7439497,5558.0602462,7.5076452,472.0913802,278.2647556,691.5330878,0.5188951,1.3666296,2.1112158,2.9262383),(26868,'cephalophus_sylvicultor_radius.tif',240,3,150,134.4782247,63.4152707,54.1175735,1.8,63.5111458,54.1815895,0.6242524,12.1246408,12.4661631,3558.9572425,5632.1290947,7.6569557,451.793311,293.5309424,725.7348676,18.4141685,22.7355866,2.4877826,66.9760656),(26869,'cephalophus_sylvicultor_radius.tif',240,3,151,135.8288277,63.4690315,53.8086727,1.8,63.5873492,53.8655512,0.6277394,12.0996217,11.9130411,3726.5391342,5742.2763369,7.8088173,482.0159934,307.9880689,757.9611751,0.234375,0.5240785,2.0344439,1.1316628),(26870,'cephalophus_sylvicultor_radius.tif',240,3,152,135.6519145,63.5135225,53.5502924,1.8,63.5683579,53.6395086,0.6245429,12.3362615,12.6253673,3818.1405868,5798.3439287,7.7300141,459.2614066,309.5054838,719.5976121,18.6490965,22.8788935,2.479651,68.0508595),(26871,'cephalophus_sylvicultor_radius.tif',240,3,153,135.782552,63.5459162,53.1344988,1.8,63.5952911,53.1583335,0.6294584,12.2027276,11.874669,3926.7486891,5850.9204652,7.8431622,492.7228261,321.7927027,753.0505993,0.58011,4.1531362,1.8568478,8.9395644),(26872,'cephalophus_sylvicultor_radius.tif',240,3,154,136.6110379,63.570305,52.8157344,1.8,63.6867966,52.7971268,0.6413241,11.969228,11.9964548,4066.4895891,5962.1459833,8.1491078,496.9923268,339.7453534,797.7071665,0.5688384,2.2234768,1.8925469,4.9954012),(26873,'cephalophus_sylvicultor_radius.tif',240,3,155,137.0919562,63.5954473,52.5177892,1.8,63.7142918,52.4703457,0.6321278,12.672295,12.1071333,4187.4407155,6064.2789836,7.9768957,500.8847941,330.4405971,793.6859612,0.3314564,0.6629127,2.3561945,1.3258254),(26874,'cephalophus_sylvicultor_radius.tif',240,3,156,137.7996591,63.5797372,52.1934905,1.8,63.6766017,52.1774616,0.6153341,12.9682425,12.0745735,4293.1145382,6213.2665103,7.6523841,514.5744066,331.0482935,787.9048465,0.9375495,10.9781627,1.8520285,24.2003555),(26875,'cephalophus_sylvicultor_radius.tif',240,3,157,138.3349431,63.6565731,51.9026954,1.8,63.7633999,51.910801,0.582548,13.5236241,12.2597214,4416.7003545,6331.3316339,6.9782791,516.4335649,326.5914767,775.2343921,19.4990772,23.5788742,2.4901394,71.6066974),(26876,'cephalophus_sylvicultor_radius.tif',240,3,158,139.1533416,63.6761581,51.5720772,1.8,63.7168177,51.5820176,0.567946,13.3781329,12.7303292,4553.2577085,6478.5362033,6.7103954,508.9056294,340.3507619,793.277099,0.6655329,5.7457747,1.7761917,12.2208149),(26877,'cephalophus_sylvicultor_radius.tif',240,3,159,140.3123496,63.7122492,51.1681849,1.8,63.7536745,51.2091394,0.5534158,13.8220509,14.8670912,4711.4769243,6662.8673844,6.4602466,448.1621378,340.8667025,706.8798169,0.234375,0.5240785,2.677945,0.9943691),(26878,'cephalophus_sylvicultor_radius.tif',240,3,160,144.4712088,63.8436315,50.6692922,1.8,63.8325553,50.7368066,0.5044095,14.4697893,15.0498446,5050.7446763,6869.2808592,5.6240171,456.4353341,349.0544724,630.2986951,0.6255388,2.6722866,1.8370484,5.9329014),(26879,'cephalophus_sylvicultor_radius.tif',240,3,161,145.8153199,63.994838,50.1649131,1.8,63.9951024,50.1448592,0.4658798,12.364249,12.4846268,5179.6011262,7024.4393693,4.9039815,562.6471226,418.9175693,905.4314945,0.234375,0.3314564,2.3561945,0.6629127),(26880,'cephalophus_sylvicultor_radius.tif',240,3,162,148.0065104,64.0561938,49.7706332,1.8,64.0758194,49.7111326,0.4212203,12.1881197,12.696247,5272.0841224,7211.8500874,4.1239111,568.0300714,432.5592671,863.2382192,0.4687501,1.048157,2.0344439,2.4574882),(26881,'cephalophus_sylvicultor_radius.tif',240,3,163,148.1063196,64.1563132,49.3773789,1.8,64.1530973,49.3078949,0.3711026,12.644181,12.7065915,5356.6201818,7378.4563685,3.2462466,580.6794368,423.643113,869.0513849,0.7171696,3.412552,1.849096,7.5333142),(26882,'cephalophus_sylvicultor_radius.tif',240,3,164,149.7719307,64.2499674,48.9797278,1.8,64.226904,48.9339525,0.3275902,12.5966237,12.9355183,5541.2993614,7579.2299033,2.5843387,585.9239458,439.9035411,877.7969103,0.4687501,1.048157,2.0344439,2.2633256),(26883,'cephalophus_sylvicultor_radius.tif',240,3,165,154.2632096,64.2516311,48.4796532,1.8,64.2726551,48.4369257,0.3367356,15.596002,13.2424847,5819.0671053,7910.4154827,2.8068017,597.3513011,373.1127448,822.9968693,21.0381102,25.8461581,0.5326436,80.0775118),(26884,'cephalophus_sylvicultor_radius.tif',240,3,166,162.5067036,64.3130821,47.9290391,1.8,64.3951482,47.88489,0.3234492,12.8840876,13.291384,6233.1546231,8372.2316069,2.7361124,629.899161,483.7870413,914.3240145,0.5527935,1.5722355,2.0344439,3.3949884),(26885,'cephalophus_sylvicultor_radius.tif',240,3,167,170.3772949,64.5221197,47.3577294,1.8,64.580378,47.3860563,0.2138423,18.5020087,14.2698815,6817.214198,9096.4448203,1.278844,637.4576282,368.458059,857.8937977,21.942613,27.4779118,0.4979853,84.5806071),(26886,'cephalophus_sylvicultor_radius.tif',240,3,168,177.1295775,64.6760731,46.7801783,1.8,64.7035559,46.8161039,0.1756483,12.9364618,14.8080555,7318.5874181,9857.0827123,0.9014813,665.6567898,565.7333133,1078.7012037,22.2626096,28.0016872,0.4973427,85.7926946),(26887,'cephalophus_sylvicultor_radius.tif',240,3,169,187.2684634,65.087198,45.9051164,1.8,65.0279958,45.961963,0.0080194,12.9558799,16.45437,8054.1248653,11212.6982143,0.0020071,681.4419661,621.6578805,1153.1335832,22.7343786,28.621597,0.4856221,89.4955835),(26888,'cephalophus_sylvicultor_radius.tif',240,3,170,193.097711,65.3499726,45.2693632,1.8,65.2022329,45.3818778,-0.0707815,13.2939079,16.2887173,8513.9781134,12650.5198053,0.1609683,776.6430934,640.442086,1265.1094423,23.3150144,30.1178762,0.5123895,92.2276591),(26889,'cephalophus_sylvicultor_radius.tif',240,3,171,193.854919,65.1940105,44.7758366,1.8,65.1510662,44.7572786,0.0076871,13.5744281,16.8024451,8807.7262654,13214.3309616,0.0019092,786.4528588,648.8469497,1259.820206,23.7388371,30.827223,0.4908518,93.6907782),(26890,'cephalophus_sylvicultor_radius.tif',240,3,172,196.7694263,64.8772804,44.4017145,1.8,64.9198551,44.2361428,0.1468436,13.5511784,16.5686101,8973.9464769,13396.5052305,0.7020893,808.5473145,662.2262801,1248.5028357,24.1111045,31.5771983,3.0374927,95.7363853),(26891,'cephalophus_sylvicultor_radius.tif',240,3,173,214.7930192,64.6310425,43.7648945,1.8,64.631019,43.7162966,0.2482796,14.2738053,15.9062928,9522.2857499,14317.405767,2.1617677,900.10953,667.1161315,1357.822885,0.234375,0.3314564,2.3561945,0.6629127),(26892,'cephalophus_sylvicultor_radius.tif',240,3,174,245.1020608,64.3619728,42.8815746,1.8,64.4948319,43.2533419,0.3188403,14.0641416,15.9648084,10894.051697,16712.4156286,4.01398,1046.8284529,774.5976968,1559.9000413,24.5443995,32.0211543,2.9872739,99.9315801),(26893,'cephalophus_sylvicultor_radius.tif',240,3,175,266.2424926,64.3207452,43.0159964,1.8,64.2771612,43.0371189,0.2938949,13.9035394,16.2950656,10972.500873,18337.5166018,3.7236594,1125.3416886,789.1875976,1725.1846421,24.2323229,31.765384,3.0529368,113.8998588),(26894,'cephalophus_sylvicultor_radius.tif',240,3,176,269.3485783,63.9604702,43.5657616,1.8,63.8805209,43.1555632,0.2836083,12.5734023,16.0287739,9744.9276581,18267.3082051,3.5150061,1139.657237,775.0430165,1688.2405173,23.1400954,31.3896344,2.8694468,109.0986202),(26895,'cephalophus_sylvicultor_radius.tif',240,3,177,248.4953724,63.4829389,43.8402014,1.8,63.5620747,43.1895724,0.2803054,12.0055278,15.6491483,7615.3747178,16902.0215533,3.1697562,1080.0601565,634.3223585,1458.6964603,21.7417048,31.4560638,3.0070717,106.4900396),(26896,'cephalophus_sylvicultor_radius.tif',240,3,178,220.2525602,63.0950351,43.4010165,1.8,63.1495246,43.0898451,0.3398305,12.4289469,16.5403793,6209.0405156,14809.0857038,4.078604,895.3292669,499.5628804,1228.0017403,21.4013718,30.9312897,3.0200572,106.6842022),(26897,'cephalophus_sylvicultor_radius.tif',240,3,179,209.2972567,62.7915538,42.8864346,1.8,62.9223606,42.681407,0.3559345,11.3623394,15.5060369,5363.84999,13525.5006789,4.2357882,872.2732152,472.0726769,1164.5577214,20.3907324,30.6709087,2.9726751,96.4090552),(26898,'cephalophus_sylvicultor_radius.tif',240,3,180,203.1557808,62.6971382,42.4999838,1.8,62.4895469,42.3109813,0.3502588,11.0908948,14.6574514,4447.8198253,12297.8406021,3.9867864,839.0162989,401.0334522,1106.2843489,19.5319441,28.4212953,3.075573,88.8992968),(26899,'cephalophus_sylvicultor_radius.tif',240,3,181,198.6956964,62.2994603,42.2146707,1.8,62.1293248,41.9223979,0.3958549,10.3446681,13.7703881,3567.4556407,10773.3405034,4.9238492,782.3556182,344.8593611,1003.7522754,18.2992884,27.3577016,3.0299894,82.4172206),(26900,'cephalophus_sylvicultor_radius.tif',240,3,182,181.6857923,61.0026155,41.8894413,1.8,61.4860787,41.6931088,0.5232761,9.3367647,14.2019189,2642.3256306,8108.2371514,7.5617819,570.9254636,283.0022736,704.2754238,17.0954964,26.9194805,3.0193975,83.8803397),(26901,'cephalophus_sylvicultor_radius.tif',240,3,183,148.5443746,59.487789,40.9422091,1.8,60.1318361,41.1240158,0.6127108,8.7373728,14.9309834,1838.6653503,5039.259488,8.1878984,337.5035217,210.436867,442.1518983,15.4459222,25.5253676,2.6121963,82.9192837),(26902,'cephalophus_sylvicultor_radius.tif',240,3,184,101.5908909,57.8505236,39.2728664,1.8,58.6204154,39.9744385,0.4855173,8.0517509,15.5079929,1202.1498306,2022.4651541,3.6873609,130.4143718,149.3029097,207.7341363,14.2527497,23.5404028,2.5259728,66.2091722),(26903,'cephalophus_sylvicultor_radius.tif',240,3,185,49.5174771,56.780669,38.3595955,1.8,57.2892118,38.3673917,-0.0050563,6.6720102,8.3656097,338.7844549,800.4367418,0.000211,95.6818172,50.7769688,122.0357521,12.5760216,15.4918176,2.9590328,60.6410403),(26904,'cephalophus_sylvicultor_radius.tif',240,3,186,10.7384566,53.8247733,38.5994481,1.8,54.7643502,38.5092142,-0.6071007,8.7266974,7.7576179,22.7186461,28.0220082,0.5824849,3.6121924,2.6033498,4.8432728,4.4531257,7.2201207,1.3415644,18.9872358),(26905,'cephalophus_sylvicultor_radius.tif',240,3,187,0.8148362,53.3866747,38.7247544,1.8,53.4099348,38.6966972,-1.5080495,0.9683768,1.610833,0.1192827,0.4426178,0.1352721,0.2747757,0.123178,0.3422401,1.8750003,3.3557398,1.7818897,8.5276833),(26906,'cephalophus_sylvicultor_radius.tif',240,3,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26907,'cephalophus_sylvicultor_radius.tif',240,3,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26908,'cephalophus_sylvicultor_radius.tif',240,3,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26909,'cephalophus_sylvicultor_radius.tif',240,3,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26910,'cephalophus_sylvicultor_radius.tif',240,3,192,1.2283385,78.5076143,51.1624583,1.8,78.5148178,51.1814437,1.4951924,2.1609717,2.4403588,1.3537177,1.5368629,0.2035551,0.6297692,0.6264394,1.176922,4.4531257,5.1188281,1.849096,15.4882667),(26911,'cephalophus_sylvicultor_radius.tif',240,3,193,22.6329749,78.5872774,51.1403629,1.8,78.5932633,51.1454018,1.51481,6.1531231,6.1872036,176.3317986,179.6600956,3.7603511,29.0373662,28.6572844,56.4142775,12.4218769,12.8222639,1.8867666,40.9007098),(26912,'cephalophus_sylvicultor_radius.tif',240,3,194,46.7268323,78.589583,51.1770172,1.8,78.5566894,51.1778114,-1.1292356,8.1921907,8.315149,691.2305766,708.6620188,6.3655269,85.2254146,84.3767678,168.1650303,16.4062526,16.8912708,1.0636978,54.2296317),(26913,'cephalophus_sylvicultor_radius.tif',240,3,195,68.2468087,78.2539872,51.1978833,1.8,78.1444179,51.1657645,-1.527569,9.3637504,9.7765043,1309.8983457,1516.4066257,11.3532269,155.1072423,139.8903533,281.4924336,19.453128,19.8873813,0.7853982,64.5518905),(26914,'cephalophus_sylvicultor_radius.tif',240,3,196,90.7321839,77.4500287,51.2509284,1.8,76.5609116,51.2886033,-0.7398818,15.4333257,19.1174304,2484.5126794,2623.9474036,6.8736651,137.2541887,160.9836221,257.5434987,3.3010795,15.611911,1.4352686,35.9288645),(26915,'cephalophus_sylvicultor_radius.tif',240,3,197,304.2410508,62.7927187,51.8031191,1.8,63.2091489,51.4975854,-0.0613384,15.3278646,24.0026171,13311.0163107,42036.0699667,0.1905402,1751.3119428,868.4194883,2183.1774238,23.339908,28.923247,1.4896739,100.2727936),(26916,'cephalophus_sylvicultor_radius.tif',240,3,198,472.3749701,58.5418444,51.4613466,1.8,63.4738593,51.5040275,-0.018366,16.6323115,27.8910274,24641.9984698,68480.3962933,0.0265531,2455.2841074,1481.5738868,3153.4967049,28.8281295,29.3203077,0.6834798,95.5422227),(26917,'cephalophus_sylvicultor_radius.tif',240,3,199,488.4583269,58.8449657,51.4430267,1.8,63.8460125,51.4502431,-0.0162144,16.8019732,27.5781119,25930.6571094,72119.931469,0.0214007,2615.1149064,1543.3102317,3324.6798727,28.8281295,29.2978171,2.7388017,95.5422227),(26918,'cephalophus_sylvicultor_radius.tif',240,3,200,500.1577879,59.1271499,51.4468003,1.8,64.1005855,51.463136,-0.0171428,16.7822061,27.3137593,27008.8478649,74647.9126989,0.0244953,2732.978343,1609.3741025,3456.6406314,28.8281295,29.3043786,0.5280744,95.7363853),(26919,'cephalophus_sylvicultor_ulna.tif',240,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26920,'cephalophus_sylvicultor_ulna.tif',240,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26921,'cephalophus_sylvicultor_ulna.tif',240,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26922,'cephalophus_sylvicultor_ulna.tif',240,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26923,'cephalophus_sylvicultor_ulna.tif',240,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26924,'cephalophus_sylvicultor_ulna.tif',240,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26925,'cephalophus_sylvicultor_ulna.tif',240,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(26926,'cephalophus_sylvicultor_ulna.tif',240,4,8,7.7182974,66.6335199,19.3400925,1.8,66.6843635,19.2703484,1.5474927,2.2913351,3.4026324,6.3701679,16.0710559,1.2856845,4.7231243,2.7801119,6.4843894,4.6875007,7.0468588,1.5042282,18.6322235),(26927,'cephalophus_sylvicultor_ulna.tif',240,4,9,30.8723907,66.4158641,20.6470369,1.8,65.8289589,22.7190732,-1.3127316,3.2503957,13.8751128,55.7584765,566.9146702,4.810268,40.8583828,17.1543659,44.8660108,6.5508039,10.3045085,1.2706252,27.5149191),(26928,'cephalophus_sylvicultor_ulna.tif',240,4,10,62.7971388,65.8799111,22.9582336,1.8,65.5938941,23.9675827,-1.2933705,4.8759407,13.4405289,169.6585336,2134.4498573,9.6811134,158.8069837,34.7950364,171.4257879,7.7350955,23.1260593,1.2618656,58.4483823),(26929,'cephalophus_sylvicultor_ulna.tif',240,4,11,78.7257215,66.0241084,23.2578839,1.8,65.7004404,24.3163708,-1.2806923,5.1981694,14.5187839,333.9034235,3097.5179772,12.0473227,213.345553,64.2348102,236.2118317,0.234375,0.5240785,2.0344439,1.1316628),(26930,'cephalophus_sylvicultor_ulna.tif',240,4,12,91.1778128,66.0376006,23.8176516,1.8,65.6993723,24.7324405,-1.2570857,5.824484,15.4078459,524.3022187,4197.7198213,13.7491893,272.4404075,90.016938,306.4598794,9.7071817,26.9123375,1.2242575,63.8556647),(26931,'cephalophus_sylvicultor_ulna.tif',240,4,13,102.2489222,66.0058964,24.4150466,1.8,65.7188766,25.0188082,-1.2460992,6.2326011,15.4257024,744.0242033,5118.6631421,15.3070922,331.8269098,119.3761939,379.9302489,0.234375,0.3314564,2.3561945,0.6629127),(26932,'cephalophus_sylvicultor_ulna.tif',240,4,14,110.2636508,65.9105811,25.0616923,1.8,65.7863902,25.2106529,-1.2574941,6.5505762,15.2999968,951.0665464,5891.7856993,16.6316481,385.0841136,145.1882267,446.8689786,0.3314564,0.6629127,0.7853982,1.3258254),(26933,'cephalophus_sylvicultor_ulna.tif',240,4,15,111.3055046,65.9344361,25.7213449,1.8,65.9838454,25.3481451,-1.2896234,6.1689223,15.4047364,956.6756229,6585.516109,17.1225591,427.4994345,155.0798619,489.019949,11.9943598,29.5730777,1.2565644,70.839804),(26934,'cephalophus_sylvicultor_ulna.tif',240,4,16,108.3787126,66.2702304,26.0656134,1.8,66.4205996,25.4111882,-1.3159034,6.3731259,15.9792959,856.9590285,7097.4287614,16.914747,444.1640483,134.4644742,496.6074146,12.0521457,30.5533728,1.2830133,77.1374748),(26935,'cephalophus_sylvicultor_ulna.tif',240,4,17,108.9781835,66.6304981,26.3273298,1.8,66.8119181,25.5740514,-1.328423,16.9504291,28.862042,832.6475717,7755.9018288,17.116777,268.7232535,49.1225069,256.9659732,11.4108452,31.6788014,1.2935129,74.921261),(26936,'cephalophus_sylvicultor_ulna.tif',240,4,18,111.3135446,66.776715,26.5678792,1.8,66.9389753,25.744936,-1.3368717,6.4182996,17.0580352,836.6282535,8360.9334007,17.5554471,490.1463334,130.3504517,534.84658,11.4394083,32.3556415,1.2994617,76.7962613),(26937,'cephalophus_sylvicultor_ulna.tif',240,4,19,114.8976189,66.8875228,26.8516625,1.8,67.0434644,26.027588,-1.3406546,7.1589005,17.3085019,857.3931655,8925.0713364,18.1531213,515.646667,119.7660409,559.2059385,1.5470978,18.7280174,1.4200499,41.3832586),(26938,'cephalophus_sylvicultor_ulna.tif',240,4,20,119.1977523,67.0370851,27.1082816,1.8,67.19568,26.2823766,-1.3399177,7.4752187,17.618352,886.3336272,9342.0231945,18.8260033,530.2438736,118.5695919,577.2618816,1.6190626,19.9590677,1.4056476,47.4867667),(26939,'cephalophus_sylvicultor_ulna.tif',240,4,21,122.5431569,67.1782371,27.4138299,1.8,67.3303238,26.4880742,-1.3368707,7.4146571,17.7068295,919.1453887,9583.095594,19.3264787,541.2090049,123.9633039,591.0755251,1.5293751,19.4968477,1.4016951,49.6461116),(26940,'cephalophus_sylvicultor_ulna.tif',240,4,22,124.2015436,67.3040696,27.6030921,1.8,67.4707317,26.7376795,-1.3373084,7.5980588,17.7791856,930.1370437,9735.0389599,19.5921086,547.5525796,122.4177212,597.4750132,1.6565321,19.6902931,1.4154321,50.0579928),(26941,'cephalophus_sylvicultor_ulna.tif',240,4,23,126.6805261,67.3510109,27.99243,1.8,67.5368025,27.0803422,-1.3339754,7.5531316,17.6997595,931.9457417,10091.0632449,19.9512651,570.1243145,123.3853438,619.4262235,1.6190626,20.1902905,1.407556,47.7613542),(26942,'cephalophus_sylvicultor_ulna.tif',240,4,24,130.3796739,67.3334972,28.5876772,1.8,67.4950972,27.7552767,-1.3294179,7.2320463,17.8645672,935.908884,10660.0295796,20.48828,596.7135639,129.4113512,645.2788797,1.7300413,17.1910535,1.3787483,43.0502976),(26943,'cephalophus_sylvicultor_ulna.tif',240,4,25,134.5675303,67.3214261,29.4000662,1.8,67.4215828,28.6709107,-1.3224962,7.1809205,18.0535275,936.4720436,11448.5516038,21.0733584,634.1448571,130.4111425,681.8093473,1.7448676,26.2039257,1.3909428,64.0165143),(26944,'cephalophus_sylvicultor_ulna.tif',240,4,26,138.2955588,67.2103465,30.3938319,1.8,67.3133539,29.7432131,-1.3135252,6.9918827,18.2148055,927.889559,12158.7603765,21.5570281,667.5207369,132.7095439,715.3752895,1.8404124,21.7880561,1.3649621,55.4985882),(26945,'cephalophus_sylvicultor_ulna.tif',240,4,27,141.6086036,67.0155335,31.5943663,1.8,67.1152506,30.9456958,-1.3066975,7.0097743,18.0862461,921.0583458,12736.0305577,21.9931946,704.1831932,131.396291,753.5534704,0.234375,0.3314564,2.3561945,0.6629127),(26946,'cephalophus_sylvicultor_ulna.tif',240,4,28,145.7373502,66.8325266,32.7728194,1.8,66.9453846,32.1148386,-1.3010084,7.0175307,18.0999193,933.0597334,13335.5124413,22.5641098,736.7719267,132.9612621,784.5997964,1.9051971,27.4579133,1.3382394,67.0329345),(26947,'cephalophus_sylvicultor_ulna.tif',240,4,29,149.6827916,66.6569869,33.9388455,1.8,66.7488592,33.3407511,-1.298595,6.5988062,18.221634,956.9639742,13804.2537555,23.143914,757.5749678,145.0207728,809.3050332,1.9497886,26.8305679,1.323699,68.6333474),(26948,'cephalophus_sylvicultor_ulna.tif',240,4,30,152.9605636,66.5180846,34.9960453,1.8,66.5235403,34.6557409,-1.2974085,6.5123046,18.4871834,1010.5401949,14219.8296033,23.635026,769.1723113,155.1739758,822.3829865,1.9126228,27.6284331,1.3134726,69.8218791),(26949,'cephalophus_sylvicultor_ulna.tif',240,4,31,158.8469901,66.3478709,36.2276915,1.8,66.3221494,36.0300863,-1.2973305,7.2101523,18.5736426,1110.4464715,14925.7912836,24.5435048,803.6006503,154.0115133,860.0952863,1.958603,30.2416463,1.3201786,71.857729),(26950,'cephalophus_sylvicultor_ulna.tif',240,4,32,167.6876745,66.0885659,37.5820459,1.8,66.0233353,37.4385397,-1.2950519,6.6591138,18.713986,1230.2379865,16274.2253189,25.8762389,869.6290187,184.7450023,921.244126,1.960039,24.276774,1.3070845,61.1569021),(26951,'cephalophus_sylvicultor_ulna.tif',240,4,33,178.7379265,65.8553612,39.0769297,1.8,65.7609689,38.9970769,-1.2926508,6.9441775,19.1598851,1451.4499143,17831.5999887,27.5438044,930.6736369,209.0168236,1001.9637267,13.6534542,37.8854759,1.2236109,206.8708554),(26952,'cephalophus_sylvicultor_ulna.tif',240,4,34,193.1139908,65.7033834,40.4767008,1.8,65.6699927,40.1288051,-1.3045618,7.6717903,19.727727,1777.7433784,19214.0847103,29.9577124,973.9634347,231.7247086,1061.6627833,14.0177117,37.7372923,1.2745805,194.6971522),(26953,'cephalophus_sylvicultor_ulna.tif',240,4,35,189.4584721,65.6978907,40.4719827,1.8,65.6704618,40.2249504,-1.294053,7.5545181,18.8718184,1669.8535378,17420.3303366,29.2191834,923.0870042,221.0403788,1010.0078773,13.6266222,36.9844996,1.2550577,151.3722672),(26954,'cephalophus_sylvicultor_ulna.tif',240,4,36,167.5593009,65.9945608,39.0361305,1.8,65.8327327,39.3573175,-1.2664352,7.2541848,18.1618233,1455.3976298,12247.6551621,25.4184574,674.3626444,200.6286947,754.3107309,13.4052019,35.1320284,1.3144913,137.7549592),(26955,'cephalophus_sylvicultor_ulna.tif',240,4,37,152.9377087,66.2088312,38.0950059,1.8,66.1458079,38.1193862,-1.2342876,6.9938481,14.8918002,1318.5691295,9143.5862778,22.7105396,614.0014065,188.5327087,697.6831584,2.0110053,20.3272214,1.2052781,51.9427502),(26956,'cephalophus_sylvicultor_ulna.tif',240,4,38,143.5766051,66.343157,37.6282644,1.8,66.3028566,37.6497455,-1.199828,6.7597492,13.7666167,1213.3874176,7407.4310935,20.7846441,538.0720079,179.5018406,622.9116032,1.617709,19.0205126,1.1788488,49.2675435),(26957,'cephalophus_sylvicultor_ulna.tif',240,4,39,135.5314311,66.4757078,37.3275257,1.8,66.4459059,37.3676875,-1.1628656,7.0435321,12.7425968,1121.8006189,6161.0575725,19.0335959,483.5009438,159.2667728,565.8315138,1.6995455,15.4509865,1.1818394,38.807991),(26958,'cephalophus_sylvicultor_ulna.tif',240,4,40,129.1719265,66.6082864,37.1444935,1.8,66.5463161,37.2420167,-1.12542,6.9141517,11.8600856,1058.245771,5251.7372911,17.5332273,442.8077064,153.0550409,524.0644421,1.4299337,15.1112839,1.1557216,36.4073717),(26959,'cephalophus_sylvicultor_ulna.tif',240,4,41,122.6876604,66.7167861,37.0690235,1.8,66.5349872,37.2097282,-1.0830206,6.652089,12.2496554,990.015276,4494.0547538,15.9566698,366.8719341,148.8277259,440.8535037,12.2338976,22.8536693,1.1254953,104.0894203),(26960,'cephalophus_sylvicultor_ulna.tif',240,4,42,117.0094415,66.780484,37.0682092,1.8,66.5594391,37.2505945,-1.0395875,6.8122616,11.2006215,954.1213355,3850.581695,14.4970958,343.7828612,140.0594097,415.3292383,1.7643406,13.8420238,1.076855,33.8694587),(26961,'cephalophus_sylvicultor_ulna.tif',240,4,43,112.7543354,66.8431559,37.2217568,1.8,66.5880284,37.4188734,-1.0133331,7.0187848,11.0397413,932.8151224,3459.7392694,13.5328093,313.3895228,132.9026539,386.0926112,0.4687501,0.6629127,2.3561945,1.3258254),(26962,'cephalophus_sylvicultor_ulna.tif',240,4,44,111.3080015,66.8395146,37.5676163,1.8,66.5222697,37.8397409,-0.9911492,9.1872371,10.870226,950.9442586,3298.9692609,12.985808,303.4867227,103.5070989,360.8052806,1.7641364,14.8231788,0.9652517,33.5948713),(26963,'cephalophus_sylvicultor_ulna.tif',240,4,45,115.5497243,66.934683,38.271844,1.8,66.6872851,38.6936863,-1.0204651,11.1420901,10.4191493,1301.0094745,3324.1623257,13.9911993,319.0435438,116.7652987,387.1276724,1.524625,11.0554484,1.012197,26.2557197),(26964,'cephalophus_sylvicultor_ulna.tif',240,4,46,127.5998989,67.1822122,39.2907123,1.8,67.0968671,39.7006198,-1.1185559,10.9665616,10.9536112,1941.4666543,3485.1065363,17.2057172,318.1696418,177.0351291,437.1016324,1.441383,14.7674873,0.9431669,34.4852597),(26965,'cephalophus_sylvicultor_ulna.tif',240,4,47,135.4380972,67.240482,40.0019068,1.8,67.2252241,40.3368412,-1.0999958,11.2824819,10.8387841,2328.8330631,3584.7566876,17.9285545,330.7342091,206.4114163,484.9644234,1.5080473,15.3367975,0.8936688,36.4739978),(26966,'cephalophus_sylvicultor_ulna.tif',240,4,48,134.0698828,67.2142254,40.2440458,1.8,67.1626551,40.4043583,-0.9287346,12.1780008,11.1729265,2450.512881,3510.5928263,14.3316505,314.205308,201.2245621,466.3030759,1.67348,14.6779413,0.8985491,37.5487917),(26967,'cephalophus_sylvicultor_ulna.tif',240,4,49,132.0101121,67.4907981,40.4295819,1.8,67.7071155,40.3811066,-0.643817,10.7416169,13.7962922,2610.6319424,3237.0016964,7.9272796,234.6283805,243.03901,411.0707315,1.7200972,12.9649864,0.8621701,32.6671283),(26968,'cephalophus_sylvicultor_ulna.tif',240,4,50,123.7005502,67.9872569,40.3938707,1.8,68.1802451,40.2516829,0.8169609,12.264356,10.7002163,2390.6813935,2477.822217,10.9586685,231.5674883,194.9292237,350.9644947,1.8760577,14.5991381,0.8308214,37.7998232),(26969,'cephalophus_sylvicultor_ulna.tif',240,4,51,114.367029,68.180127,40.3796152,1.8,68.1777614,40.3088902,0.8648161,12.0555731,9.9642386,1974.5156296,2152.9730217,11.0380276,216.0699979,163.7844683,305.9557514,16.7315043,23.7656749,3.0527185,135.3640971),(26970,'cephalophus_sylvicultor_ulna.tif',240,4,52,100.7713771,67.9431417,39.9882385,1.8,68.2767351,40.2776878,-0.4016492,8.9200292,13.9303485,1409.6381035,1783.3664984,2.566842,128.0202354,158.0306598,225.583039,15.6708929,24.5646954,0.124355,142.2913675),(26971,'cephalophus_sylvicultor_ulna.tif',240,4,53,86.9450289,67.8007899,39.5499342,1.8,68.1246729,40.1093282,-0.4303001,9.290162,13.5779723,859.4799874,1508.6053526,2.5215325,111.1068218,92.5150702,172.469684,14.2968772,24.8835216,3.0850492,131.4199338),(26972,'cephalophus_sylvicultor_ulna.tif',240,4,54,75.2638286,67.8505539,39.2405937,1.8,68.1354455,39.5151956,-0.4601604,9.9970318,10.5485089,528.6274655,1177.0520155,2.4738914,111.5846824,52.8784421,131.5550404,11.6736905,17.5013978,3.0072712,86.7927793),(26973,'cephalophus_sylvicultor_ulna.tif',240,4,55,70.4404628,67.8386179,39.358794,1.8,67.326031,39.5393427,-0.5135181,8.6406167,12.8757796,391.3854558,1033.87758,2.8331304,80.296309,45.2960096,108.38953,3.1214859,15.1258175,0.7086263,38.898173),(26974,'cephalophus_sylvicultor_ulna.tif',240,4,56,67.4166914,67.9997379,39.5896334,1.8,67.4557783,39.7941489,-0.5355739,6.6881432,12.0283171,334.5607646,897.4734235,2.9263503,74.6133826,50.0229664,99.8434703,10.8142759,18.5630356,0.4297623,84.2548663),(26975,'cephalophus_sylvicultor_ulna.tif',240,4,57,64.3875601,68.0858629,39.9539054,1.8,67.5060836,40.1561813,-0.5753377,6.5395208,11.7726627,301.509059,835.5346402,3.1771461,70.9724439,46.1056807,94.0728808,10.2196123,18.3502333,0.4922113,76.654926),(26976,'cephalophus_sylvicultor_ulna.tif',240,4,58,61.3845129,68.1410149,40.3726646,1.8,67.449134,40.5944423,-0.620501,6.8813057,13.5359641,278.3163824,783.4955484,3.4587698,57.8825079,40.4452869,73.3373857,10.6007186,18.7763516,0.4245614,73.2030687),(26977,'cephalophus_sylvicultor_ulna.tif',240,4,59,59.5853347,68.2751297,40.8576053,1.8,67.9763029,41.2264789,-0.6714536,8.0478047,10.4910517,282.9949231,722.592183,3.8436428,68.8770016,35.1642383,88.8598537,3.0044253,13.0935749,0.7727406,35.0108787),(26978,'cephalophus_sylvicultor_ulna.tif',240,4,60,57.1869852,68.3507806,41.2523423,1.8,68.3157469,41.7521228,-0.7277457,9.0699092,10.3414381,266.903833,659.9368996,4.2173037,63.8148094,29.4273986,81.2293272,3.3024893,12.099292,0.7990959,29.4565454),(26979,'cephalophus_sylvicultor_ulna.tif',240,4,61,55.6681748,68.2614942,41.6494057,1.8,67.9474213,42.1698629,-0.7547948,10.2098733,9.8701732,232.9674845,652.6530724,4.3552527,66.1237711,22.8178625,78.959346,3.9628625,12.6345319,0.7066142,38.6471414),(26980,'cephalophus_sylvicultor_ulna.tif',240,4,62,53.2363836,68.2567135,41.9727799,1.8,68.0030562,42.3724442,-0.7874404,9.5671558,10.1207608,197.2223805,600.5853306,4.4544856,59.3419153,20.6145259,67.205544,2.7922139,10.275147,0.7853982,28.0738511),(26981,'cephalophus_sylvicultor_ulna.tif',240,4,63,50.6909172,68.2447679,42.2794323,1.8,67.9382328,42.6230559,-0.8027349,6.8829666,9.1387588,169.8672339,549.9200704,4.3706833,60.1744815,24.6793632,65.1116574,3.2182132,9.6350663,0.7165417,27.2736447),(26982,'cephalophus_sylvicultor_ulna.tif',240,4,64,49.363452,68.2251998,42.6536245,1.8,68.0527978,43.1105079,-0.8384694,12.96214,28.0547794,162.163687,531.2459498,4.5494312,18.9360231,12.5105643,22.4371784,3.4140109,9.1526378,0.6947383,26.5303072),(26983,'cephalophus_sylvicultor_ulna.tif',240,4,65,48.3536251,68.2114948,43.038364,1.8,68.1519845,43.6844215,-0.835127,8.0135418,7.4532509,158.287403,506.1800413,4.4295698,67.9139943,19.7524899,73.1759783,3.6206635,10.6117811,0.7541583,26.9755013),(26984,'cephalophus_sylvicultor_ulna.tif',240,4,66,47.4480018,68.1595925,43.4051086,1.8,68.0960005,44.0776191,-0.8386595,12.4526792,27.9451051,152.7719761,492.5078097,4.3743948,17.6241173,12.2682014,21.0916508,3.2089869,10.7736063,0.7700148,27.0559261),(26985,'cephalophus_sylvicultor_ulna.tif',240,4,67,46.0403864,68.1206968,43.7514898,1.8,67.987224,44.3863054,-0.8279839,7.2112438,9.0049476,139.4958732,471.0925389,4.1630811,52.3148564,19.3442181,54.7633257,3.7250224,11.3133003,0.6973908,29.8448707),(26986,'cephalophus_sylvicultor_ulna.tif',240,4,68,44.712039,68.1313881,44.0935716,1.8,67.9283898,44.7647909,-0.8458464,7.4872651,7.8800656,128.0644657,444.5273251,4.1753675,56.4116277,17.1043049,58.6585277,3.4228195,11.4364451,0.7709064,27.7188389),(26987,'cephalophus_sylvicultor_ulna.tif',240,4,69,42.9341176,68.2058923,44.3885801,1.8,68.0245572,45.0946698,-0.870377,7.2993136,8.0964413,115.299211,405.2220939,4.1830015,50.0494083,15.7958976,52.4269007,3.6206635,10.4527062,0.7378151,29.6507081),(26988,'cephalophus_sylvicultor_ulna.tif',240,4,70,40.6510414,68.3202489,44.6442567,1.8,68.1373213,45.2799944,-0.8945165,6.8316238,7.6447574,99.0806274,360.7355076,4.1210278,47.1873064,14.5032323,46.3092248,3.3607645,7.9618549,0.8270407,22.1409497),(26989,'cephalophus_sylvicultor_ulna.tif',240,4,71,38.4376452,68.4144431,44.9072776,1.8,68.199694,45.5274369,-0.9168297,7.1988963,8.2923871,85.4675334,322.9542959,4.0354606,38.945878,11.8723107,37.1926631,3.4038528,7.299569,0.8308214,21.9467871),(26990,'cephalophus_sylvicultor_ulna.tif',240,4,72,36.3780243,68.5005533,45.1481647,1.8,68.2468455,45.6842917,-0.9307658,6.5867517,7.3496101,73.6120324,287.0011592,3.9005025,39.0498485,11.1757715,36.5390729,3.0184937,7.7909872,0.8066715,22.9411562),(26991,'cephalophus_sylvicultor_ulna.tif',240,4,73,34.2322772,68.6074445,45.3707709,1.8,68.3023017,45.8925011,-0.92873,5.7802746,6.5943064,70.2823638,251.8518825,3.6592979,38.1923234,12.1590009,37.4471403,3.241893,8.7851568,0.8042638,25.9811323),(26992,'cephalophus_sylvicultor_ulna.tif',240,4,74,32.739035,68.6505191,45.6932876,1.8,68.4291332,46.2496176,-0.9503403,5.8813445,6.3448849,66.1344094,230.9340309,3.6120254,36.3968824,11.2447774,36.1173726,2.9037538,7.4743224,0.8519663,18.6086677),(26993,'cephalophus_sylvicultor_ulna.tif',240,4,75,31.4876253,68.6489185,46.0316503,1.8,68.3095473,46.698745,-0.9542348,6.2735645,7.1075238,65.900966,215.8473076,3.4932705,30.3688476,10.5045491,30.0016802,2.7755353,6.4014855,1.1562895,16.0138857),(26994,'cephalophus_sylvicultor_ulna.tif',240,4,76,30.1316622,68.6741484,46.3351383,1.8,68.4163921,46.8909498,-0.9863603,15.7867334,28.5327862,58.9169108,199.8270469,3.4932391,7.0034186,3.732052,7.9347632,2.5797154,6.6374083,0.8353566,16.9513859),(26995,'cephalophus_sylvicultor_ulna.tif',240,4,77,29.2408539,68.663993,46.7056037,1.8,68.3223059,47.39489,-0.9901171,6.5142461,6.7194501,56.4440636,189.000978,3.4067881,28.1274474,8.6647116,26.2262319,2.2660256,6.4357183,0.9928944,15.6255605),(26996,'cephalophus_sylvicultor_ulna.tif',240,4,78,28.3058505,68.6426166,47.0375966,1.8,68.2522263,47.6852195,-0.9925079,7.2227034,7.3191225,53.4481242,177.80618,3.3081887,24.2933741,7.4000164,22.4893206,3.2577206,7.6773478,1.0251413,22.8607314),(26997,'cephalophus_sylvicultor_ulna.tif',240,4,79,27.3555661,68.6241722,47.3632858,1.8,68.2251808,47.9675199,-1.0004233,7.6529102,7.9491021,48.8336503,167.3975518,3.2300459,21.0586743,6.3810562,19.5963189,2.817379,6.9684708,0.7378151,20.2895053),(26998,'cephalophus_sylvicultor_ulna.tif',240,4,80,26.4751781,68.5963148,47.6822341,1.8,68.285303,48.1545416,-1.0182708,7.6612483,7.079629,44.2431971,154.4992172,3.1970738,21.8230668,5.7749332,19.0521695,2.3972659,5.878096,1.160669,18.4949298),(26999,'cephalophus_sylvicultor_ulna.tif',240,4,81,26.0440311,68.5620425,48.0109061,1.8,68.06306,48.6046676,-1.0002397,8.1609349,9.9235979,49.0571135,152.1968892,3.0744604,15.3368658,6.0112125,16.6894977,3.0915375,7.9618549,0.8270407,21.6957555),(27000,'cephalophus_sylvicultor_ulna.tif',240,4,82,26.1515807,68.4334835,48.4140116,1.8,67.6824442,49.0001354,-0.9316572,9.5934855,11.0527656,57.8519034,162.3654774,2.8077302,14.6900317,6.0303321,15.0467702,0.4687501,0.6629127,0.7853982,1.3258254),(27001,'cephalophus_sylvicultor_ulna.tif',240,4,83,26.6993159,68.228505,48.8947188,1.8,67.0157757,49.6083632,-0.8142939,9.1342511,13.5785436,73.1670764,188.1716092,2.3534542,13.8580112,8.0101888,15.9694214,6.7452644,14.0703125,0.5232783,58.4345836),(27002,'cephalophus_sylvicultor_ulna.tif',240,4,84,26.7205561,68.1941618,49.266942,1.8,67.1009125,49.7833794,-0.8676173,9.6746995,12.132817,72.6065757,182.093478,2.591222,15.0083429,7.5047887,16.4133123,2.8307362,6.0802143,1.089909,15.9570168),(27003,'cephalophus_sylvicultor_ulna.tif',240,4,85,26.6202309,68.2642502,49.6497381,1.8,67.7896106,49.9430892,-1.1414671,9.2392979,30.1444135,54.7763305,178.5083843,3.6679429,5.9217733,5.9286248,7.5834645,3.4045487,8.1358864,0.72425,29.5938391),(27004,'cephalophus_sylvicultor_ulna.tif',240,4,86,26.2347272,68.2192194,49.9543097,1.8,67.7221352,50.2464021,-1.1325396,8.331707,4.9366428,51.5590771,157.631887,3.585051,31.9309889,6.188297,21.6376432,3.1358465,6.6621903,0.6857295,18.0261797),(27005,'cephalophus_sylvicultor_ulna.tif',240,4,87,26.0274185,68.2208458,50.2815992,1.8,68.0221808,50.6153827,-1.1719573,15.6907048,5.6839378,52.0822207,154.6056434,3.6836832,27.2004459,3.3193041,12.5581649,3.6460199,7.0857276,0.5971767,21.2838744),(27006,'cephalophus_sylvicultor_ulna.tif',240,4,88,25.7385112,68.1879659,50.5618426,1.8,68.0884152,50.8514882,-1.1466879,15.764154,6.2177467,56.5975673,147.9394195,3.5633291,23.7930919,3.5902699,12.3696392,3.5769418,7.0857276,0.5971767,24.106132),(27007,'cephalophus_sylvicultor_ulna.tif',240,4,89,25.2630195,68.1504101,50.7706067,1.8,67.8849851,50.9839407,-1.1428062,14.1583141,6.8064659,54.1743585,138.4202564,3.4851988,20.3365828,3.8263283,12.4077193,3.7250607,6.633269,0.5585993,18.6086677),(27008,'cephalophus_sylvicultor_ulna.tif',240,4,90,24.7881103,68.0502203,50.999179,1.8,67.5637992,51.1691446,-1.1121238,13.3303257,9.9814654,55.4134037,131.4491689,3.3214628,13.1693257,4.156943,11.2638365,4.1322094,7.8611777,0.4636476,22.9980251),(27009,'cephalophus_sylvicultor_ulna.tif',240,4,91,24.2171374,67.9719614,51.1915598,1.8,67.4763014,51.3318376,-1.0844186,7.3122807,4.8123633,53.2889937,121.560974,3.1543316,25.2601406,7.2876023,21.8779638,3.7388035,7.6773478,0.5456551,22.003656),(27010,'cephalophus_sylvicultor_ulna.tif',240,4,92,23.5479033,67.9215586,51.3580273,1.8,67.4598393,51.4512055,-1.0492132,7.5534507,4.6717985,50.9206719,111.6932688,2.9503309,23.907981,6.7413787,19.7993463,3.3957514,7.5583678,0.5191461,21.5113501),(27011,'cephalophus_sylvicultor_ulna.tif',240,4,93,23.2742771,67.7641637,51.5107807,1.8,66.7419538,51.5844807,-0.8302026,8.1173587,7.4908031,58.7299084,111.8377146,2.1130889,14.9300032,7.2351008,15.4422364,0.234375,0.3314564,2.3561945,0.6629127),(27012,'cephalophus_sylvicultor_ulna.tif',240,4,94,22.9608337,67.7566132,51.7287805,1.8,67.090183,51.7403279,-0.904836,7.2287072,5.0563056,51.0713926,104.2929255,2.3661336,20.6263099,7.0650797,17.8226003,3.6720686,9.5434107,0.4306925,25.0436321),(27013,'cephalophus_sylvicultor_ulna.tif',240,4,95,23.0916376,67.6649049,51.9846076,1.8,67.0611691,52.0641576,-0.8700506,7.4502197,5.0169111,50.1876471,107.3488773,2.248543,21.3974049,6.7363983,17.7374811,3.8655431,9.5750163,0.375961,28.5759142),(27014,'cephalophus_sylvicultor_ulna.tif',240,4,96,22.7708867,67.6404876,52.1506364,1.8,67.1212489,52.143816,-0.8831086,7.2991951,4.6282237,44.3484168,103.4112076,2.2660436,22.3436061,6.0757955,17.0961864,3.3907004,8.1863681,0.4124104,23.8551004),(27015,'cephalophus_sylvicultor_ulna.tif',240,4,97,22.5865494,67.5700495,52.2347273,1.8,66.8909617,52.21071,-0.7671375,9.0037173,7.6948342,45.9389285,105.1734466,1.8134869,13.6680589,5.102218,12.7586928,3.8578948,8.8939073,0.3217506,24.1296879),(27016,'cephalophus_sylvicultor_ulna.tif',240,4,98,21.8568572,67.5560961,52.3365938,1.8,66.8683615,52.250396,-0.7442986,6.6682162,5.4056037,43.9016283,96.5319887,1.6718555,17.8577629,6.5837139,16.3598605,3.8578948,9.4130104,0.3296244,24.3238505),(27017,'cephalophus_sylvicultor_ulna.tif',240,4,99,21.2602994,67.4976389,52.4451219,1.8,66.7580081,52.3128414,-0.6832179,7.4087863,6.9610996,42.3000588,92.6072723,1.4121426,13.3035408,5.7094451,13.270478,4.0327623,10.012506,0.3587707,28.3817516),(27018,'cephalophus_sylvicultor_ulna.tif',240,4,100,20.6664882,67.4720362,52.5707016,1.8,66.8748144,52.4794232,-0.6982402,6.4734248,5.4631484,36.6708153,87.6403969,1.4235173,16.0421045,5.6648244,14.9637423,3.9230509,9.1915662,0.3378782,25.3750885),(27019,'cephalophus_sylvicultor_ulna.tif',240,4,101,19.9098296,67.4912559,52.6996856,1.8,67.2723608,52.6536802,-0.7718402,4.9089609,4.1181568,28.5151896,81.1395182,1.6141684,19.7028725,5.8088035,20.0591281,2.9616719,5.8217551,0.8709035,20.3796873),(27020,'cephalophus_sylvicultor_ulna.tif',240,4,102,20.2225072,67.3119817,52.8855367,1.8,66.8662253,52.7905454,-0.7135644,4.7192539,4.3052925,29.5155853,88.5982311,1.443931,20.5789111,6.2542907,21.7492732,2.817379,7.1282385,0.8086498,22.9176003),(27021,'cephalophus_sylvicultor_ulna.tif',240,4,103,19.6820463,67.2956363,52.9673471,1.8,66.9559964,52.8908533,-0.7024357,4.6476801,4.2488988,26.2838781,85.4530687,1.3692724,20.1118154,5.6552683,21.2022399,2.3201945,6.9605835,0.7853982,19.1911556),(27022,'cephalophus_sylvicultor_ulna.tif',240,4,104,19.0262788,67.2777835,53.0341175,1.8,66.9077194,52.9369906,-0.699353,4.6325352,4.194797,23.9868207,80.8282139,1.3140147,19.268683,5.1779036,19.2579942,2.3201945,7.1282385,0.7621465,20.8484374),(27023,'cephalophus_sylvicultor_ulna.tif',240,4,105,18.1470061,67.3194078,52.9796062,1.8,66.8578023,52.8782434,-0.6452757,9.5631894,4.3010571,23.8587279,73.6626265,1.0939756,17.126633,2.4948505,9.5029625,2.7681145,6.7968761,0.7610128,18.9969929),(27024,'cephalophus_sylvicultor_ulna.tif',240,4,106,17.0904705,67.4051279,52.9470542,1.8,66.9206326,52.8134538,-0.609769,10.0606074,5.4357601,23.266962,61.9365748,0.9341659,11.3942804,2.3126797,7.4510019,2.9831072,6.9684708,0.7378151,20.9857311),(27025,'cephalophus_sylvicultor_ulna.tif',240,4,107,16.6655825,67.3916714,52.9902984,1.8,66.8794371,52.8653892,-0.5836912,9.9441184,5.66118,22.7111261,58.9462037,0.8436112,10.4123528,2.2838753,7.1362197,2.9260237,7.1436342,0.7157436,19.7971994),(27026,'cephalophus_sylvicultor_ulna.tif',240,4,108,16.5139045,67.3759804,53.0309126,1.8,66.8219193,52.8555617,-0.5738349,4.7762584,4.1924457,22.1272943,57.5431568,0.8110897,13.7254389,4.6327674,13.98533,3.2599209,6.3063873,0.7328151,23.5236441),(27027,'cephalophus_sylvicultor_ulna.tif',240,4,109,16.4129967,67.3915732,53.0796466,1.8,66.9435588,52.9370042,-0.5835318,4.5676201,4.1514143,20.7395763,57.1489876,0.8304243,13.7661491,4.5405651,13.8022929,2.674636,6.4357183,0.5779019,19.6599056),(27028,'cephalophus_sylvicultor_ulna.tif',240,4,110,16.4871711,67.3768692,53.0844963,1.8,66.8501525,52.7957322,-0.5739256,9.8202833,6.3425906,22.7249475,57.6559219,0.8100039,9.0902796,2.3140827,6.8757771,2.991544,7.6773478,0.5456551,23.9355252),(27029,'cephalophus_sylvicultor_ulna.tif',240,4,111,15.8504133,67.4649777,53.0104098,1.8,66.8596645,52.7107935,-0.5111302,9.9394776,9.9710721,22.4187488,51.6196151,0.6321165,5.1769373,2.2555259,5.2588165,2.5441371,6.9566364,0.5693132,20.0717868),(27030,'cephalophus_sylvicultor_ulna.tif',240,4,112,15.6030877,67.4481892,53.0023612,1.8,66.8126903,52.7521156,-0.487858,8.7010413,8.3253144,21.7876986,51.2585109,0.5713652,6.1569459,2.5040335,6.0657605,3.3145537,6.633269,0.5585993,23.5236441),(27031,'cephalophus_sylvicultor_ulna.tif',240,4,113,14.610972,67.5728673,52.8024604,1.8,66.9020902,52.45817,-0.4798725,4.8696284,4.4988679,18.6724992,44.4483784,0.5190196,9.879903,3.8344813,10.3978207,2.4148057,6.3971935,0.4964228,18.5517987),(27032,'cephalophus_sylvicultor_ulna.tif',240,4,114,14.5160734,67.5845013,52.8108517,1.8,67.0212337,52.574791,-0.4988815,4.9505823,4.4532696,17.1119096,44.9393132,0.5538085,10.0913075,3.4565448,10.1978829,2.7966635,6.3971935,0.4964228,18.414505),(27033,'cephalophus_sylvicultor_ulna.tif',240,4,115,14.4869264,67.5678565,52.7912857,1.8,66.9707102,52.5201916,-0.4975024,4.2849315,4.4518103,17.6078028,45.0205639,0.549901,10.1128667,4.1092379,10.9560303,2.7635318,6.3971935,0.4964228,20.4032432),(27034,'cephalophus_sylvicultor_ulna.tif',240,4,116,13.8450916,67.6597749,52.7070429,1.8,67.0836253,52.4835386,-0.489385,4.5434841,4.4845332,17.1496573,40.0031014,0.5099106,8.9202376,3.7745609,9.8560084,3.1119505,6.0802143,0.4808873,21.1465807),(27035,'cephalophus_sylvicultor_ulna.tif',240,4,117,13.3752428,67.7043219,52.6054706,1.8,67.0910456,52.378705,-0.4167418,4.504328,4.7642054,16.3167843,37.8372264,0.3652544,7.9419805,3.622468,8.8667562,2.7901556,6.2889422,0.4636476,16.5630606),(27036,'cephalophus_sylvicultor_ulna.tif',240,4,118,13.3209104,67.6988171,52.5643698,1.8,67.0547415,52.3895606,-0.4205691,4.480315,4.7664318,15.8719206,38.1367322,0.3700829,8.0011073,3.5425903,8.8740816,2.8242226,6.0802143,0.4808873,17.363267),(27037,'cephalophus_sylvicultor_ulna.tif',240,4,119,13.1265522,67.7568362,52.5032755,1.8,67.2100289,52.3405413,-0.4851566,4.7098477,4.4477226,14.6500406,36.6228173,0.4757924,8.2340605,3.1105126,8.3837621,3.976786,7.3370992,0.4636476,19.1578425),(27038,'cephalophus_sylvicultor_ulna.tif',240,4,120,12.8739664,67.8347503,52.3994802,1.8,67.3386376,52.2483432,-0.5071802,4.3319896,4.2565956,13.6430515,35.177591,0.506201,8.264255,3.1493731,8.1448589,4.0457622,7.3557925,0.3923401,19.4892989),(27039,'cephalophus_sylvicultor_ulna.tif',240,4,121,12.2614285,68.0136383,52.1421423,1.8,67.5156989,51.9271443,-0.4890299,4.5134554,4.1958014,13.7074718,31.0242942,0.4509826,7.3941284,3.0370239,7.6184852,2.3598394,6.1520657,0.3097029,17.4770049),(27040,'cephalophus_sylvicultor_ulna.tif',240,4,122,11.822974,68.0936086,51.9872874,1.8,67.5202835,51.7439756,-0.4714854,4.3452418,4.1925967,12.8530496,29.4259462,0.4065267,7.0185492,2.9579596,7.178693,2.6749962,6.310741,0.2629947,18.3340802),(27041,'cephalophus_sylvicultor_ulna.tif',240,4,123,12.1411115,68.1041071,51.9170068,1.8,67.5206907,51.6934823,-0.4604671,4.6644739,4.2721451,14.3612973,31.5693594,0.3995674,7.3895804,3.0788675,7.8178409,3.7542485,7.0351563,0.5232783,18.2203424),(27042,'cephalophus_sylvicultor_ulna.tif',240,4,124,11.2408982,68.2894531,51.7070689,1.8,67.8169195,51.5212411,-0.5245395,4.5764589,3.8784392,11.5670581,26.1130804,0.4698979,6.7328838,2.5275127,6.6029592,2.5303332,5.9292715,0.3217506,16.402211),(27043,'cephalophus_sylvicultor_ulna.tif',240,4,125,11.394274,68.3054991,51.5915319,1.8,67.8046468,51.4122413,-0.5380348,4.8524219,3.9002635,11.7402799,27.7809473,0.4986978,7.1228386,2.4194681,6.6049689,2.8445398,6.2274995,0.3455556,18.1967865),(27044,'cephalophus_sylvicultor_ulna.tif',240,4,126,11.6136178,68.3615737,51.4781647,1.8,67.8629939,51.3519678,-0.5643258,8.7703185,6.563461,12.2949479,30.3166174,0.5536997,4.6189986,1.4018816,3.8899263,3.9414287,7.0351563,0.5232783,18.414505),(27045,'cephalophus_sylvicultor_ulna.tif',240,4,127,10.7931885,68.5859343,51.180797,1.8,68.2180713,51.0799712,-0.60694,4.25214,3.6392143,9.1464508,26.3295087,0.5851828,7.2349431,2.151023,6.4374734,2.2738617,4.7803315,0.1973956,13.0307785),(27046,'cephalophus_sylvicultor_ulna.tif',240,4,128,11.1225621,68.6407081,51.0341537,1.8,68.2584742,50.977113,-0.6220558,4.9792735,3.7074001,9.655018,29.0756457,0.6294399,7.8425971,1.9390415,6.6480239,2.2072965,5.7074051,0.3347368,15.6020046),(27047,'cephalophus_sylvicultor_ulna.tif',240,4,129,10.7883778,68.8340997,50.7318365,1.8,68.4466074,50.7020627,-0.6058425,4.331606,3.5845389,9.914699,27.5408279,0.5830736,7.6832275,2.2889199,6.9671512,2.4460676,5.1881126,0.3217506,14.0820165),(27048,'cephalophus_sylvicultor_ulna.tif',240,4,130,11.0718751,68.8977577,50.5736771,1.8,68.5154659,50.5653951,-0.6294835,4.4182364,3.6393757,10.3898459,30.4470395,0.639585,8.3660062,2.3515822,7.6716739,2.5547855,5.2669239,0.363979,17.0651237),(27049,'cephalophus_sylvicultor_ulna.tif',240,4,131,10.671157,69.0823797,50.2939531,1.8,68.7073645,50.2299032,-0.663298,4.3958784,3.4609425,9.3331067,28.1511993,0.6742566,8.1339691,2.1231495,7.2384003,2.4408439,5.2669239,0.363979,14.2193102),(27050,'cephalophus_sylvicultor_ulna.tif',240,4,132,9.9317769,69.3728024,49.9605021,1.8,69.1652752,49.981979,-0.7062077,4.1922745,3.357139,7.5731741,23.9147435,0.6971118,7.1235487,1.8064595,6.8001692,2.5242934,4.7167066,0.4636476,14.8017982),(27051,'cephalophus_sylvicultor_ulna.tif',240,4,133,10.2616498,69.4158518,49.804213,1.8,69.1749635,49.814165,-0.7176392,4.2791713,3.3978197,7.3194575,26.969108,0.7396054,7.9371805,1.7104848,7.1059315,2.607275,5.0322454,0.4844779,17.3161553),(27052,'cephalophus_sylvicultor_ulna.tif',240,4,134,10.5385553,69.4763948,49.6507126,1.8,69.2611715,49.7438694,-0.712346,4.3438958,3.4065173,7.8878578,29.406416,0.7503582,8.6323989,1.8158487,7.3845432,2.5444818,5.5907167,0.5763752,16.92783),(27053,'cephalophus_sylvicultor_ulna.tif',240,4,135,10.7266047,69.5700449,49.4663155,1.8,69.3566394,49.6468679,-0.7329662,4.3542778,3.5396236,7.5269521,33.0603852,0.8003193,9.3400851,1.7286339,8.4612513,2.2815651,4.8260774,0.5070985,14.8017982),(27054,'cephalophus_sylvicultor_ulna.tif',240,4,136,9.7470234,69.883033,49.0318681,1.8,69.802243,49.1229987,-0.7370182,4.1329042,3.3455786,5.083325,27.2987632,0.7337811,8.1596538,1.2299644,7.6338153,1.6080534,3.900778,0.5713375,11.6813972),(27055,'cephalophus_sylvicultor_ulna.tif',240,4,137,10.1674836,69.9913262,48.7558447,1.8,69.8540255,48.9809611,-0.7200839,3.9754631,3.5744296,6.2644235,32.9407864,0.7369244,9.2156763,1.575772,8.7765184,2.1544663,5.3445731,0.6610432,16.6532426),(27056,'cephalophus_sylvicultor_ulna.tif',240,4,138,10.1560978,70.1547499,48.4439852,1.8,69.9334452,48.5891737,-0.6957975,4.5367414,3.7362157,5.6824706,35.1552369,0.6954864,9.4093168,1.2525445,8.9408258,0.6629127,1.6901024,2.1587989,3.7833136),(27057,'cephalophus_sylvicultor_ulna.tif',240,4,139,10.4294411,70.2744814,48.1546865,1.8,69.9863732,48.1427366,-0.663202,8.0726024,6.7315489,5.2781992,39.432818,0.658822,5.8579116,0.6538411,4.2537447,1.7819848,5.0703073,0.5880026,12.81306),(27058,'cephalophus_sylvicultor_ulna.tif',240,4,140,10.4211347,70.4613716,47.8523977,1.8,70.281639,47.820698,-0.667575,9.8383286,8.2513478,4.6202701,41.0201433,0.6656747,4.9713264,0.4696194,3.5544216,0.7338285,1.3258254,0.7853982,2.7889446),(27059,'cephalophus_sylvicultor_ulna.tif',240,4,141,10.6248147,70.5950681,47.5899962,1.8,70.4114828,47.7117141,-0.6618157,4.2156395,4.1412926,4.67695,43.469068,0.6687825,10.4964977,1.1094283,10.6829623,0.6629127,4.4777288,0.748378,8.9493216),(27060,'cephalophus_sylvicultor_ulna.tif',240,4,142,10.6758512,70.7896377,47.2449099,1.8,70.5175891,47.3389742,-0.6405218,3.5709532,4.2408581,4.709158,43.029952,0.6354664,10.1465201,1.3187398,9.1808479,0.9412231,5.2039703,0.625485,11.0184845),(27061,'cephalophus_sylvicultor_ulna.tif',240,4,143,11.0231191,70.9641717,46.9455598,1.8,70.7496872,46.9697288,-0.6444022,3.021175,4.4155436,4.6029726,46.1227645,0.6629768,10.4455461,1.5235704,10.4091959,1.5464244,6.3756903,0.6287963,16.402211),(27062,'cephalophus_sylvicultor_ulna.tif',240,4,144,11.1678557,71.2087556,46.6005628,1.8,71.0653709,46.6673647,-0.6436904,3.1974893,4.1159066,4.6208238,45.9264927,0.6704097,11.1582932,1.4451413,10.8331637,0.4687501,0.8450512,2.1587989,1.7945755),(27063,'cephalophus_sylvicultor_ulna.tif',240,4,145,11.1508768,71.5153629,46.1450763,1.8,71.4591104,46.391896,-0.6458115,6.0465916,4.0230704,5.799933,44.2615302,0.6731775,11.0019278,0.959207,8.0753869,1.0439157,4.9828816,0.71883,11.0184845),(27064,'cephalophus_sylvicultor_ulna.tif',240,4,146,11.342555,71.7515448,45.7775089,1.8,71.5402673,46.0324508,-0.6289569,5.4343614,4.5659627,6.8531571,44.1655317,0.6542741,9.6727753,1.2610787,8.8285886,0.4687501,0.7411589,1.8925469,1.7945755),(27065,'cephalophus_sylvicultor_ulna.tif',240,4,147,11.5220151,72.0044628,45.4253766,1.8,71.8131548,45.7042048,-0.6409988,4.930042,4.3847277,7.5034131,43.4969181,0.6867113,9.9200956,1.5219775,9.5883249,1.5950234,2.0025012,2.782822,6.8468456),(27066,'cephalophus_sylvicultor_ulna.tif',240,4,148,11.9922301,72.223673,45.113809,1.8,72.0566856,45.5132075,-0.6498273,5.7319443,4.7743242,9.3924855,47.1268272,0.7316943,9.8708897,1.6386212,9.1286021,0.7031251,1.4823179,0.3217506,3.2576946),(27067,'cephalophus_sylvicultor_ulna.tif',240,4,149,12.4372431,72.4214741,44.7878429,1.8,72.2498727,45.0826359,-0.663243,5.4657323,4.4820219,9.0415591,49.9412734,0.785736,11.1425769,1.6542265,9.8234897,1.2768471,5.3957185,0.6000502,12.7561911),(27068,'cephalophus_sylvicultor_ulna.tif',240,4,150,12.8885816,72.6043214,44.4933875,1.8,72.5603335,44.7521502,-0.6751586,5.1489257,4.4482291,9.280085,53.3415722,0.8391571,11.9916423,1.8023342,11.1407954,0.7537828,3.9912631,0.7022569,8.0922462),(27069,'cephalophus_sylvicultor_ulna.tif',240,4,151,13.0844712,72.7975128,44.1385656,1.8,72.6504678,44.3089957,-0.65927,3.6371962,4.7150228,8.6832545,56.1471617,0.8182271,11.9081421,2.3873484,12.079258,0.7922161,4.9441468,0.5485494,10.6301593),(27070,'cephalophus_sylvicultor_ulna.tif',240,4,152,13.3442813,73.0461972,43.7686312,1.8,72.8853218,43.9365502,-0.6621294,3.9581544,4.9245636,9.3414752,57.5588124,0.8406367,11.6881041,2.3600583,11.1091081,0.9477438,4.7457328,0.5743048,10.2987029),(27071,'cephalophus_sylvicultor_ulna.tif',240,4,153,13.6050069,73.3113017,43.3371302,1.8,73.1255112,43.4888128,-0.6680601,3.7458105,4.7785333,10.445684,59.4207209,0.8701218,12.4349288,2.7886312,12.5276852,1.3017603,4.8317652,0.3985224,11.293072),(27072,'cephalophus_sylvicultor_ulna.tif',240,4,154,14.0801491,73.5336233,42.9829087,1.8,73.295039,43.1160826,-0.6642639,3.8483657,4.9427257,12.2924593,62.6681706,0.8918537,12.6788688,3.1942025,12.8548304,1.4176021,4.7167066,0.4636476,11.236203),(27073,'cephalophus_sylvicultor_ulna.tif',240,4,155,14.5493986,73.7111694,42.6654276,1.8,73.4112639,42.8239321,-0.6428383,4.0596121,5.1063991,14.3027312,67.1517776,0.8714213,13.150515,3.5231768,13.105609,1.4721108,5.0485928,0.3805064,12.0932784),(27074,'cephalophus_sylvicultor_ulna.tif',240,4,156,15.0250236,73.9265939,42.3414312,1.8,73.7517972,42.5718817,-0.6275329,4.5232072,5.2494176,16.9594509,69.5944904,0.8632991,13.2575642,3.7494304,13.4670564,0.4195005,0.8450512,2.5535901,1.6572818),(27075,'cephalophus_sylvicultor_ulna.tif',240,4,157,15.1946126,74.2142499,41.9642139,1.8,73.9891304,42.2088538,-0.6188062,4.4270476,5.9256197,19.1065167,66.6192548,0.8520966,11.2425802,4.3158598,12.3104297,0.5863261,1.3666296,0.5404195,2.7889446),(27076,'cephalophus_sylvicultor_ulna.tif',240,4,158,15.6347983,74.4150854,41.5635391,1.8,74.1631447,41.7597068,-0.5866689,4.3556466,6.1696604,20.6425513,71.3563682,0.7985782,11.5656881,4.7392622,12.8489089,0.8286409,1.3258254,0.7853982,3.1204009),(27077,'cephalophus_sylvicultor_ulna.tif',240,4,159,16.4788814,74.5206658,41.1996333,1.8,74.3147479,41.2970557,-0.5387263,6.7682652,9.594712,22.9885358,88.2595123,0.7229098,9.1987662,3.3965182,9.4745982,0.234375,0.3314564,2.3561945,0.6629127),(27078,'cephalophus_sylvicultor_ulna.tif',240,4,160,17.5117131,74.7459808,40.8211022,1.8,74.4150896,40.8811806,-0.5084246,6.4582288,10.0623564,28.6481813,97.0613062,0.6916424,9.6459818,4.4359193,10.5138358,0.7031251,1.048157,2.677945,2.7889446),(27079,'cephalophus_sylvicultor_ulna.tif',240,4,161,18.5695304,75.0071905,40.4202544,1.8,74.3779487,40.405199,-0.4452845,8.2532197,12.6898046,40.3932349,107.9269479,0.5741548,8.5050126,4.8942396,9.798134,1.260207,3.7791839,3.0172377,9.4416275),(27080,'cephalophus_sylvicultor_ulna.tif',240,4,162,19.9765299,75.2588476,40.1236996,1.8,74.2251989,40.0854463,-0.3924618,6.7664721,12.1171957,56.7807988,123.9897623,0.4870241,10.232546,8.3914923,13.1735775,1.3725683,4.6166528,2.7233683,17.1122355),(27081,'cephalophus_sylvicultor_ulna.tif',240,4,163,22.0757182,75.5815317,39.8184465,1.8,74.6794118,39.7912374,-0.4484911,8.4150645,13.7625281,77.2537614,136.4410911,0.691759,9.9139555,9.1804123,13.2471763,0.234375,0.5240785,2.677945,0.9943691),(27082,'cephalophus_sylvicultor_ulna.tif',240,4,164,23.138779,75.9455569,39.3895674,1.8,75.3715696,39.3453929,-0.6674251,9.4289184,9.4354988,85.6948826,131.6352383,1.4774823,13.9510631,9.0885167,16.4184569,0.5882406,4.4035071,2.7017501,9.3847586),(27083,'cephalophus_sylvicultor_ulna.tif',240,4,165,24.8785978,76.2672588,39.0069506,1.8,75.8807454,38.9903095,-0.8685548,12.4420713,7.9395446,100.0571971,137.0910624,2.4164325,17.2668673,8.0418441,16.0675488,0.234375,0.3314564,2.3561945,0.6629127),(27084,'cephalophus_sylvicultor_ulna.tif',240,4,166,30.2281922,76.5285359,38.6885513,1.8,75.8514237,38.5423184,-1.2564361,12.8821677,5.2384868,145.0115769,156.0677566,4.5563474,29.7925264,11.2567683,23.169389,0.7031251,0.8450512,2.5535901,2.3201945),(27085,'cephalophus_sylvicultor_ulna.tif',240,4,167,31.2489888,76.8064817,38.2744186,1.8,76.1947142,37.9945214,1.1583104,10.0135991,6.7621564,135.2480631,146.933566,4.3711545,21.7288034,13.5064388,23.3536037,0.9375001,1.4823179,2.8198421,4.7776827),(27086,'cephalophus_sylvicultor_ulna.tif',240,4,168,27.7163672,77.2486604,37.5578733,1.8,76.8216858,37.2859208,0.7960573,6.1238437,9.3554355,95.9913338,135.6221914,2.3589322,14.4966198,15.6750138,20.7140196,8.1443971,10.4946641,2.6279866,31.7669828),(27087,'cephalophus_sylvicultor_ulna.tif',240,4,169,24.4966063,77.4309338,36.712837,1.8,77.0034565,36.3956723,0.5546694,4.4563912,11.9947999,71.1469227,122.4423675,1.1324503,10.2079542,15.9651429,15.3311431,7.3035096,10.8041553,2.7167605,31.2982327),(27088,'cephalophus_sylvicultor_ulna.tif',240,4,170,20.4010517,77.7518312,36.1135873,1.8,77.4309149,35.7770889,0.5434395,4.1064489,6.7455322,47.0220621,101.2533642,0.9091214,15.0104337,11.4507848,21.1894024,6.4874466,11.0181198,2.6303619,30.3607325),(27089,'cephalophus_sylvicultor_ulna.tif',240,4,171,17.5183382,78.3483951,35.7848297,1.8,78.1650902,35.5482345,0.7304549,3.4748293,7.3069448,32.0701651,101.3694996,1.299765,13.8730348,9.2292779,16.7416229,6.1032112,11.3907232,2.5022067,30.4744704),(27090,'cephalophus_sylvicultor_ulna.tif',240,4,172,19.1580981,78.3935825,35.7530307,1.8,78.2467622,35.5376306,0.6946141,3.9276917,7.7608002,38.2412037,126.5170628,1.3082232,16.3020642,9.7363047,19.8498322,6.4921885,11.2524429,2.5189219,30.8059267),(27091,'cephalophus_sylvicultor_ulna.tif',240,4,173,18.3494542,78.27561,35.5318141,1.8,77.9685169,35.2320502,0.4953039,4.5402272,8.4100112,45.3708865,111.4561996,0.6908852,13.2528003,9.9930873,18.4649216,7.2395925,13.1959598,2.5585161,38.5334036),(27092,'cephalophus_sylvicultor_ulna.tif',240,4,174,19.0988052,78.3672979,35.4610678,1.8,77.7657736,35.0501556,0.4422686,4.8427767,9.873703,55.7186399,112.5827059,0.5830745,11.4022779,11.505515,17.0017718,7.6693212,14.6310858,2.5269297,40.9908918),(27093,'cephalophus_sylvicultor_ulna.tif',240,4,175,21.7099566,78.6568773,35.5473331,1.8,78.0102285,35.1078781,0.816062,4.9638154,9.6865215,75.0135494,102.2471903,1.9200452,10.5556149,15.1120749,16.5323531,8.3042857,12.4240878,2.5169572,37.4017408),(27094,'cephalophus_sylvicultor_ulna.tif',240,4,176,24.7726129,78.7406658,35.5591161,1.8,78.4381511,35.2427771,1.4937819,7.2571316,5.3516396,77.5005775,126.8598946,4.1043285,23.7048649,10.6792301,25.6144361,8.1945774,10.3788719,1.4576453,31.3315457),(27095,'cephalophus_sylvicultor_ulna.tif',240,4,177,29.6786092,78.4949519,35.5535304,1.8,78.2673434,35.1515411,1.5687463,6.0703165,6.1705409,103.0859473,189.0648242,4.9464141,30.6399113,16.9819724,43.6660007,8.1574849,11.5225786,1.6522484,32.7377959),(27096,'cephalophus_sylvicultor_ulna.tif',240,4,178,31.7438731,78.339059,35.4975032,1.8,78.1774334,35.0315741,1.5360846,5.8529618,5.8202375,111.4859664,219.7099196,5.2842734,37.7493049,19.0477865,50.8592146,8.1602685,11.756192,1.6506263,32.6573711),(27097,'cephalophus_sylvicultor_ulna.tif',240,4,179,32.6866002,78.1560558,35.8307307,1.8,77.9006106,35.7421931,-1.4608834,5.9550946,6.2479083,87.9265859,238.8607647,5.3822177,38.2305172,14.7649352,51.1691498,1.3258254,2.1608311,2.2794226,5.2464328),(27098,'cephalophus_sylvicultor_ulna.tif',240,4,180,17.013483,78.6948444,34.2571571,1.8,78.4030688,34.891771,-1.382622,3.5273024,5.1925598,22.3279356,66.6685104,2.7363534,12.8392378,6.3300316,17.1366147,5.333178,9.9492134,1.3086765,25.4457561),(27099,'cephalophus_sylvicultor_ulna.tif',240,4,181,9.182326,79.1363401,33.4212641,1.8,79.0750418,33.4972045,-1.460383,2.2399825,3.2540371,6.1642727,18.089914,1.5118063,5.5592218,2.7519289,7.3216658,3.7500006,6.600061,1.4640607,16.6434854),(27100,'cephalophus_sylvicultor_ulna.tif',240,4,182,3.5717063,79.2375752,32.9208936,1.8,79.2287056,33.0610847,-1.3568001,1.23632,2.4671711,0.9577891,4.0636822,0.5684373,1.6471019,0.7747098,2.0002776,2.5781254,5.0594617,1.3370531,12.5855843),(27101,'cephalophus_sylvicultor_ulna.tif',240,4,183,0.0474743,79.1560597,32.4408909,1.8,79.1601686,32.4414113,-1.1520375,0.3272137,0.4236662,0.0019597,0.003238,0.0066041,0.0076427,0.0059892,0.0116764,0.9375001,1.1718752,0.6435011,2.7889446),(27102,'cephalophus_sylvicultor_ulna.tif',240,4,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27103,'cephalophus_sylvicultor_ulna.tif',240,4,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27104,'cephalophus_sylvicultor_ulna.tif',240,4,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27105,'cephalophus_sylvicultor_ulna.tif',240,4,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27106,'cephalophus_sylvicultor_ulna.tif',240,4,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27107,'cephalophus_sylvicultor_ulna.tif',240,4,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27108,'cephalophus_sylvicultor_ulna.tif',240,4,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27109,'cephalophus_sylvicultor_ulna.tif',240,4,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27110,'cephalophus_sylvicultor_ulna.tif',240,4,192,1.2283385,78.5076143,51.1624583,1.8,78.5148178,51.1814437,1.4951924,2.1609717,2.4403588,1.3537177,1.5368629,0.2035551,0.6297692,0.6264394,1.176922,4.4531257,5.1188281,1.849096,15.4882667),(27111,'cephalophus_sylvicultor_ulna.tif',240,4,193,22.6329749,78.5872774,51.1403629,1.8,78.5932633,51.1454018,1.51481,6.1531231,6.1872036,176.3317986,179.6600956,3.7603511,29.0373662,28.6572844,56.4142775,12.4218769,12.8222639,1.8867666,40.9007098),(27112,'cephalophus_sylvicultor_ulna.tif',240,4,194,44.2520113,78.2093274,51.1785492,1.8,78.0562936,51.1803748,-1.5193401,7.7289891,8.1521089,572.8882154,692.1581512,7.3558244,84.90541,74.1220109,147.7100102,16.4062526,16.8912708,1.0636978,54.2296317),(27113,'cephalophus_sylvicultor_ulna.tif',240,4,195,63.1643319,77.6705148,51.2003449,1.8,77.5096992,51.1633365,-1.5527103,8.7732256,9.7550906,1020.2877668,1448.0020231,10.5239454,148.4355277,116.295626,238.5365757,19.453128,19.8873813,0.7853982,64.5518905),(27114,'cephalophus_sylvicultor_ulna.tif',240,4,196,83.6764954,76.7940894,51.2223722,1.8,75.8173293,51.2212278,-1.3506967,16.3751186,12.5123729,2066.3547861,2389.6675644,13.28132,190.984363,126.188691,231.2876045,3.3010795,15.611911,1.4352686,35.9288645),(27115,'cephalophus_sylvicultor_ulna.tif',240,4,197,250.9684789,64.2187094,50.9029381,1.8,66.5966384,50.5748346,0.0211282,13.3520266,20.6030757,8963.6300378,28026.2692129,0.0186693,1360.2954082,671.3310517,1620.1976983,23.339908,28.923247,1.4896739,100.2727936),(27116,'cephalophus_sylvicultor_ulna.tif',240,4,198,321.8024188,62.2447356,50.3673878,1.8,66.7444784,50.3213161,0.0529286,13.6885118,22.9173328,12667.2947106,36578.357042,0.1501115,1596.1000913,925.3960452,1974.516178,28.8281295,29.3203077,0.6834798,95.5422227),(27117,'cephalophus_sylvicultor_ulna.tif',240,4,199,332.3966382,62.4450315,50.2921312,1.8,66.8768707,50.1959474,0.0389532,14.6732102,22.5803644,13374.6079027,37707.3579586,0.0840178,1669.9180435,911.4984168,2060.1879095,28.8281295,29.2978171,2.7388017,95.5422227),(27118,'cephalophus_sylvicultor_ulna.tif',240,4,200,340.7020552,62.6108203,50.2261886,1.8,66.9580497,50.0908948,0.0253328,14.5450068,22.2747014,13948.2698753,38479.2236303,0.036433,1727.4854937,958.9730739,2124.5896453,28.8281295,29.3043786,0.5280744,95.7363853),(27119,'cephalophus_sylvicultor_metacarpus.tif',240,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27120,'cephalophus_sylvicultor_metacarpus.tif',240,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27121,'cephalophus_sylvicultor_metacarpus.tif',240,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27122,'cephalophus_sylvicultor_metacarpus.tif',240,5,4,4.7734416,51.0805006,37.3002698,1.8,51.7484573,37.6974405,0.566562,6.1715177,12.5079535,49.8770027,127.7344868,0.2291919,10.2122611,8.081805,13.5431562,3.1875002,11.8777965,1.3641131,27.4361083),(27123,'cephalophus_sylvicultor_metacarpus.tif',240,5,5,93.5620749,52.2723208,38.2718496,1.8,51.5910502,38.3972862,0.1219817,9.8374287,13.5101151,1620.5932057,3673.2091121,0.2308783,271.8858496,164.7374785,358.8341325,17.0625011,26.1170758,0.0646579,86.8207034),(27124,'cephalophus_sylvicultor_metacarpus.tif',240,5,6,222.1193033,51.6366033,37.8793993,1.8,51.8028548,38.4219063,-0.2208322,13.0993822,14.5764131,4593.6479877,11701.1376756,1.7761863,802.7446509,350.6766888,1044.0635778,18.5658833,27.6872196,0.5485494,105.6318112),(27125,'cephalophus_sylvicultor_metacarpus.tif',240,5,7,220.9086498,51.6551268,37.672478,1.8,51.8396999,38.3508027,-0.2880022,13.9101465,15.120841,5091.4930365,12279.9456624,2.9703807,812.1205466,366.0272763,1002.5252066,18.9227434,27.871358,0.4154921,84.4264121),(27126,'cephalophus_sylvicultor_metacarpus.tif',240,5,8,207.8687476,51.7528459,37.6683998,1.8,51.8037032,38.3083203,-0.2902392,14.4294809,15.2393675,5204.4097338,11406.7180594,2.8374024,748.5033771,360.6789309,943.7150604,19.718622,27.5191002,0.4971716,82.8354218),(27127,'cephalophus_sylvicultor_metacarpus.tif',240,5,9,191.4740332,51.9255931,37.8941725,1.8,51.9917893,38.49149,-0.2506844,15.6474651,15.4627459,4839.3120358,10331.2988585,1.963797,668.1412811,309.2713097,900.5053308,0.2651651,0.5303301,0.7853982,1.0606602),(27128,'cephalophus_sylvicultor_metacarpus.tif',240,5,10,175.7547769,52.0250689,38.0240453,1.8,52.0337595,38.587802,-0.1993205,17.4298687,14.6942928,4308.7675412,8935.385662,1.1484206,608.0854529,247.2059667,683.8806427,0.2651651,0.5303301,0.7853982,1.0606602),(27129,'cephalophus_sylvicultor_metacarpus.tif',240,5,11,162.5892923,52.011687,38.2686902,1.8,52.0977781,38.8259279,-0.1522061,15.723528,13.6691841,3859.1502432,7639.3835524,0.6229434,558.8763363,245.4379354,649.3833546,17.9046856,25.0956,0.5070985,78.9300915),(27130,'cephalophus_sylvicultor_metacarpus.tif',240,5,12,153.1231512,51.9469663,38.5060121,1.8,52.0420092,39.0646282,-0.0934412,13.7628728,12.8023774,3541.8879412,6663.295826,0.2221784,520.4733148,257.3509182,733.2333543,0.6025276,2.1866071,1.0303768,4.992641),(27131,'cephalophus_sylvicultor_metacarpus.tif',240,5,13,146.9267336,51.8992315,38.7423127,1.8,52.0150148,39.2425207,-0.059368,15.2533761,12.1653644,3324.2100307,5934.6632266,0.0862075,487.8327545,217.9327394,590.0241561,0.6060096,1.8750001,0.9272952,4.0873109),(27132,'cephalophus_sylvicultor_metacarpus.tif',240,5,14,142.9064987,51.9034482,38.9376312,1.8,51.9731841,39.4355898,-0.0478481,12.4696067,11.7858846,3164.4861462,5361.4042212,0.0544878,454.9004511,253.7759383,611.5547192,0.3977476,0.7954952,0.7853982,1.5909904),(27133,'cephalophus_sylvicultor_metacarpus.tif',240,5,15,142.3304581,51.8983221,39.0881529,1.8,51.9277365,39.5370411,-0.0498059,11.3553239,11.4078007,3053.8242306,5039.6572715,0.0587961,441.7729074,268.9332552,590.6863378,0.5584102,2.0281227,0.9827937,4.4623109),(27134,'cephalophus_sylvicultor_metacarpus.tif',240,5,16,141.0671554,51.9140162,39.1909225,1.8,51.953126,39.6324957,-0.0651751,10.8988751,11.0275652,2927.6065242,4769.7882084,0.0997294,432.5332142,268.6154763,630.6521358,17.8912965,20.8732235,2.896614,100.5293352),(27135,'cephalophus_sylvicultor_metacarpus.tif',240,5,17,138.1402694,52.0195309,39.2566597,1.8,52.0444522,39.7637603,-0.0596882,12.0411759,11.4643113,2798.6791015,4490.4875147,0.0819277,391.6927419,232.4257294,505.3825362,0.1875,0.2651651,2.3561945,0.5303301),(27136,'cephalophus_sylvicultor_metacarpus.tif',240,5,18,137.1424923,52.0347614,39.3521152,1.8,52.0670747,39.8797625,-0.0439765,11.5109758,11.0997391,2722.8668643,4283.6677029,0.0441757,385.9250818,236.5452692,547.9997741,16.1994398,20.0773906,2.9441971,62.9448091),(27137,'cephalophus_sylvicultor_metacarpus.tif',240,5,19,136.4114553,52.0357972,39.4600102,1.8,52.0601663,40.0287253,-0.0291553,10.5443473,11.0098798,2663.1906919,4113.1056396,0.0193202,373.5831558,252.5704651,541.0819427,0.5870627,1.3520818,0.9827937,3.0266506),(27138,'cephalophus_sylvicultor_metacarpus.tif',240,5,20,136.3229254,52.0232754,39.5631855,1.8,52.0376884,40.1386704,-0.0110356,11.5605893,10.7891624,2617.9727564,3978.8063905,0.0027668,368.7780614,226.4566877,509.3503666,0.5303301,0.8385255,1.1071487,1.9659904),(27139,'cephalophus_sylvicultor_metacarpus.tif',240,5,21,135.9217393,52.0165822,39.6609369,1.8,52.0475821,40.2635442,0.0067213,11.3557248,10.56816,2564.1178313,3821.4649697,0.0010234,361.6017315,225.7995741,494.6195251,15.7704151,19.2404615,2.8753406,60.2021682),(27140,'cephalophus_sylvicultor_metacarpus.tif',240,5,22,135.9683693,51.9912875,39.7988229,1.8,51.987299,40.3880409,0.0207844,10.789475,10.4936038,2543.4732087,3679.5856875,0.0097881,350.6503347,235.736512,480.9163565,15.5947114,18.9820034,2.7354039,58.9861779),(27141,'cephalophus_sylvicultor_metacarpus.tif',240,5,23,136.5571939,51.9970886,39.9528992,1.8,52.0100021,40.4850189,0.0470215,11.1610804,10.4076254,2556.1584236,3553.3284649,0.0502848,341.4158679,229.0242823,532.054176,15.7670343,18.7949473,2.6422459,59.0771682),(27142,'cephalophus_sylvicultor_metacarpus.tif',240,5,24,137.5782274,51.9862681,40.1187658,1.8,52.0001403,40.6295934,0.0730216,11.289173,9.8497629,2582.3434846,3462.5956748,0.1220477,351.541017,228.7451419,482.0884438,15.7291262,18.6522463,2.6149654,58.3915079),(27143,'cephalophus_sylvicultor_metacarpus.tif',240,5,25,137.3630605,52.0566459,40.2634836,1.8,52.0547232,40.858261,0.1093667,10.7606658,10.1356162,2590.1621817,3344.8808417,0.2727449,330.0125789,240.706498,503.9568726,15.7438373,18.5131932,2.5507811,57.8611778),(27144,'cephalophus_sylvicultor_metacarpus.tif',240,5,26,137.437645,52.0489972,40.4059521,1.8,52.0291135,40.9858706,0.131222,10.7770485,9.9151905,2592.0171855,3253.0929437,0.3921695,328.0918263,240.5127143,461.8789207,0.375,0.6760409,0.9827937,1.4356603),(27145,'cephalophus_sylvicultor_metacarpus.tif',240,5,27,137.0828651,52.0365078,40.5290795,1.8,52.0265141,41.1215846,0.1462625,10.375164,9.893169,2568.9353212,3159.7660015,0.4852872,319.38866,247.6043089,497.117361,15.7933083,18.2029585,2.5393053,57.1111778),(27146,'cephalophus_sylvicultor_metacarpus.tif',240,5,28,136.9646975,52.029548,40.6515063,1.8,52.0014171,41.2285907,0.1741883,11.5845335,9.8414334,2548.9237989,3085.6314052,0.6856437,313.5347534,220.0281774,460.2788977,15.9112116,18.156547,2.5249446,57.0013428),(27147,'cephalophus_sylvicultor_metacarpus.tif',240,5,29,136.974765,52.0219124,40.7610395,1.8,51.9699903,41.3552983,0.2042539,11.6274679,9.8877743,2525.4292295,3024.7828515,0.9392516,305.9113964,217.1951155,453.6627394,15.9226582,18.0487632,2.5334199,56.6263428),(27148,'cephalophus_sylvicultor_metacarpus.tif',240,5,30,137.1155924,52.0020168,40.8694504,1.8,51.9787467,41.4174165,0.2020087,11.471078,9.9742955,2513.1918041,2972.8933867,0.9199415,298.0554744,219.0894189,455.7424307,15.9312977,17.8922568,2.4750348,56.4066729),(27149,'cephalophus_sylvicultor_metacarpus.tif',240,5,31,137.2377125,51.9837932,40.9760243,1.8,51.9358383,41.4718907,0.2147659,10.4595189,9.5656362,2501.3163454,2919.4656557,1.0388799,305.2035005,239.1425813,496.668318,15.8257625,17.7769393,2.4833247,55.9861777),(27150,'cephalophus_sylvicultor_metacarpus.tif',240,5,32,137.1024355,51.9697776,41.0830113,1.8,51.9549036,41.5819935,0.2284291,11.1358813,9.5665157,2473.2410458,2862.297497,1.1717361,299.199581,222.0965702,467.9460911,0.5245893,2.5015622,1.3439975,5.962311),(27151,'cephalophus_sylvicultor_metacarpus.tif',240,5,33,135.772517,52.0279599,41.1544665,1.8,52.0202836,41.712365,0.2489469,10.7161645,9.5361639,2445.7356288,2782.9337363,1.3736742,291.8294774,228.228637,472.9469627,0.375,1.0097185,1.1902899,2.1856603),(27152,'cephalophus_sylvicultor_metacarpus.tif',240,5,34,134.5930992,52.0198816,41.2486615,1.8,52.0259535,41.8101573,0.2684857,10.3373031,9.543523,2404.846035,2717.7407596,1.5785317,284.7733218,232.6376632,469.8415828,0.6370011,1.5461647,1.3258177,3.6213206),(27153,'cephalophus_sylvicultor_metacarpus.tif',240,5,35,133.9010856,52.0115403,41.3541589,1.8,52.0115943,41.913192,0.2745892,10.8577346,9.5293025,2388.7530237,2664.0799017,1.6408056,279.5671456,220.0047357,442.4889997,0.1875,0.2651651,2.3561945,0.5303301),(27154,'cephalophus_sylvicultor_metacarpus.tif',240,5,36,133.2157624,51.9906533,41.4318396,1.8,51.9824338,41.9450634,0.2311941,12.8690912,9.4834511,2363.4464369,2609.9207397,1.1657521,275.2079075,183.6529409,384.0098587,0.375,0.8385255,1.1071487,1.8106603),(27155,'cephalophus_sylvicultor_metacarpus.tif',240,5,37,132.8289158,51.9819357,41.5190906,1.8,51.9652845,42.046201,0.2021587,10.8266289,9.6557868,2350.134088,2568.324503,0.8924875,265.9881115,217.0697916,439.7955045,15.6220837,17.1897737,2.4566306,54.5505174),(27156,'cephalophus_sylvicultor_metacarpus.tif',240,5,38,132.5855279,51.9737796,41.6101734,1.8,51.9559268,42.1486154,0.2049143,10.7888156,9.3515032,2346.9407033,2531.4542868,0.9149606,270.7002538,217.5346013,424.9503002,0.4080248,1.6020008,1.2120257,3.4659905),(27157,'cephalophus_sylvicultor_metacarpus.tif',240,5,39,132.7850344,51.953216,41.6956935,1.8,51.9376618,42.1981254,0.1733783,10.2349381,9.3361579,2345.3663202,2515.7514093,0.6586146,269.4632461,229.1529564,434.7045988,0.1875,0.2651651,2.3561945,0.5303301),(27158,'cephalophus_sylvicultor_metacarpus.tif',240,5,40,132.3305279,51.9385656,41.7618793,1.8,51.9302804,42.2381606,0.1551663,10.4654231,9.6282517,2330.6030237,2495.2825765,0.5267634,259.1625837,222.6955377,435.9498452,0.1875,0.4192628,2.0344439,0.9053301),(27159,'cephalophus_sylvicultor_metacarpus.tif',240,5,41,130.9415682,51.9920568,41.7911558,1.8,52.0095859,42.3041955,0.1277707,10.3437277,9.5546683,2306.8324295,2461.4661349,0.3543434,257.6192124,223.0175141,417.8957496,0.4796163,1.4279575,1.1659045,3.4016506),(27160,'cephalophus_sylvicultor_metacarpus.tif',240,5,42,129.7616604,51.9646184,41.8517955,1.8,51.9827437,42.3720129,0.0082691,10.6604714,9.7662534,2276.7775648,2429.983085,0.0014788,248.814258,213.5719412,428.6142395,0.1875,0.4192628,2.0344439,0.9053301),(27161,'cephalophus_sylvicultor_metacarpus.tif',240,5,43,128.8135282,51.9473399,41.9002559,1.8,51.9655304,42.388867,-0.0299921,9.7550599,9.7977979,2253.3781108,2413.6580295,0.0193061,246.3469921,230.9958261,406.5738737,15.3766586,17.1190694,1.0679531,53.8005174),(27162,'cephalophus_sylvicultor_metacarpus.tif',240,5,44,128.4854351,51.9315807,41.9546585,1.8,51.9409196,42.4411069,-0.0895898,9.636945,9.3392442,2231.4366752,2407.0145532,0.1714183,257.7311936,231.550214,411.6692557,0.375,1.3650207,1.2924967,2.9356604),(27163,'cephalophus_sylvicultor_metacarpus.tif',240,5,45,128.4865963,51.9002808,42.0215352,1.8,51.8982038,42.4663111,-0.1901699,9.6664475,9.307137,2219.6973582,2406.3230658,0.7651531,258.5460014,229.6290709,413.2463184,0.7712331,4.5311425,1.1441688,10.6442918),(27164,'cephalophus_sylvicultor_metacarpus.tif',240,5,46,128.7437483,51.8731692,42.1128772,1.8,51.9090728,42.5858982,-0.2992661,9.8530604,9.2791264,2220.2453715,2410.4641533,1.8650301,259.7727478,225.3356087,411.2514467,0.375,1.3650207,1.2924967,3.0909905),(27165,'cephalophus_sylvicultor_metacarpus.tif',240,5,47,128.7637874,51.8511633,42.1862015,1.8,51.8577059,42.6137864,-0.328127,9.7083165,9.3789273,2206.1556555,2415.9126987,2.2288639,257.5894471,227.2438942,422.984328,0.5625,0.9560662,1.7681919,2.3409904),(27166,'cephalophus_sylvicultor_metacarpus.tif',240,5,48,128.6749486,51.8373479,42.2784397,1.8,51.8342448,42.7382143,-0.3414126,10.2023358,9.4023159,2198.8733849,2409.6298823,2.40415,256.2804646,215.5264669,428.7363723,0.5625,1.1858542,1.2490458,2.8713205),(27167,'cephalophus_sylvicultor_metacarpus.tif',240,5,49,127.4477183,51.8503534,42.3218209,1.8,51.8295174,42.7935104,-0.3753882,10.0306594,9.9090982,2171.2719635,2391.2372562,2.8552599,241.3173448,216.4635316,409.9694559,0.6126091,2.611573,1.2036225,5.962311),(27168,'cephalophus_sylvicultor_metacarpus.tif',240,5,50,126.2806585,51.8349753,42.3914071,1.8,51.8311068,42.8717412,-0.3888044,10.2480867,9.8641299,2149.414462,2381.3969891,3.0244929,241.4198737,209.7381218,401.4968823,0.375,1.0097185,1.1902899,2.1856603),(27169,'cephalophus_sylvicultor_metacarpus.tif',240,5,51,125.4650654,51.8213714,42.4597714,1.8,51.815678,42.9467283,-0.3979484,10.6361044,9.9887438,2137.9530844,2377.3574689,3.1403457,238.0036487,201.0090354,393.0312103,0.7132623,2.5155766,1.1071487,5.962311),(27170,'cephalophus_sylvicultor_metacarpus.tif',240,5,52,125.1360774,51.8111246,42.5197561,1.8,51.8016511,42.9997682,-0.3919931,10.9190299,9.6358597,2126.333544,2379.9739841,3.0438876,246.9913499,194.7364888,412.5572849,0.5921298,2.3717084,1.2490458,5.4319809),(27171,'cephalophus_sylvicultor_metacarpus.tif',240,5,53,124.8540604,51.7985657,42.5698663,1.8,51.7637128,42.9825921,-0.4115734,9.7197104,9.8338348,2116.2888011,2386.8670408,3.3303042,242.7198632,217.731672,425.6719073,0.375,0.9560662,1.7681919,2.1856603),(27172,'cephalophus_sylvicultor_metacarpus.tif',240,5,54,124.3543089,51.7866337,42.6264326,1.8,51.772002,43.0431375,-0.4170239,10.1277578,9.7942689,2104.0745868,2395.0047823,3.4002282,244.5312458,207.7532495,429.7549576,0.5625,1.1858542,1.2490458,2.7159904),(27173,'cephalophus_sylvicultor_metacarpus.tif',240,5,55,123.937068,51.7725735,42.6801936,1.8,51.7356307,43.0886221,-0.4129206,10.2564004,9.6384789,2088.639944,2398.4109056,3.3262758,248.8370767,203.642591,387.9893032,0.5625,1.1858542,1.2490458,2.8713205),(27174,'cephalophus_sylvicultor_metacarpus.tif',240,5,56,123.3043514,51.7608485,42.7267455,1.8,51.7207152,43.1016709,-0.4078274,9.8489699,9.5854147,2068.0438859,2412.5420692,3.2327145,251.6888564,209.975654,400.4339108,0.375,1.1858542,1.2490458,2.7159904),(27175,'cephalophus_sylvicultor_metacarpus.tif',240,5,57,122.0658924,51.7785524,42.7254305,1.8,51.7167561,43.1096259,-0.404143,9.637343,9.5361527,2039.8074577,2404.9144482,3.1458538,252.1891714,211.6566204,408.7722104,0.5625,1.0097185,1.1902899,2.3409904),(27176,'cephalophus_sylvicultor_metacarpus.tif',240,5,58,120.6894931,51.7697843,42.7691979,1.8,51.7122881,43.1905791,-0.38626,9.7418412,9.5546389,2010.7895506,2397.7129886,2.8547676,250.947526,206.4075474,395.146273,0.5625,1.1858542,1.2490458,2.7159904),(27177,'cephalophus_sylvicultor_metacarpus.tif',240,5,59,119.5963147,51.7605616,42.8019144,1.8,51.7215099,43.192796,-0.3700871,9.712938,9.3750492,1989.6284143,2394.5540426,2.6076867,255.4177578,204.843108,394.133743,0.4752838,1.1858542,1.2490458,2.7159904),(27178,'cephalophus_sylvicultor_metacarpus.tif',240,5,60,119.0367549,51.7405289,42.8467952,1.8,51.6797691,43.2405615,-0.3607307,9.6970599,9.3567325,1977.4500045,2405.4869375,2.4715866,257.0862136,203.9226341,395.7629883,0.5936926,2.9646355,1.2490458,6.712311),(27179,'cephalophus_sylvicultor_metacarpus.tif',240,5,61,118.6300397,51.7227737,42.8994476,1.8,51.6444752,43.3518563,-0.3545331,9.6764938,9.3916744,1967.6850161,2418.0552561,2.3827809,257.4679601,203.3468992,393.2233751,0.5163886,1.5461647,1.3258177,3.7766507),(27180,'cephalophus_sylvicultor_metacarpus.tif',240,5,62,118.2257854,51.7104456,42.9382293,1.8,51.6547366,43.3574378,-0.3410073,9.4521256,9.4305135,1956.9541192,2426.1809213,2.2038822,257.2692277,207.0385233,408.6837392,14.609322,16.8176118,1.0322889,52.5656824),(27181,'cephalophus_sylvicultor_metacarpus.tif',240,5,63,117.9540169,51.6933553,42.9831221,1.8,51.6211949,43.3694503,-0.3330528,9.9587307,9.3698815,1953.4926811,2446.8652987,2.1012126,261.1415417,196.1588021,401.5244077,0.5233599,1.2577883,1.1071487,2.8713205),(27182,'cephalophus_sylvicultor_metacarpus.tif',240,5,64,117.3167086,51.6933654,43.022096,1.8,51.6169643,43.388093,-0.3220169,9.8984439,9.5854604,1940.6908685,2453.8293684,1.9584045,255.9949418,196.0601978,412.0115069,0.4796163,1.6020008,1.2120257,3.4659905),(27183,'cephalophus_sylvicultor_metacarpus.tif',240,5,65,115.8384626,51.7263489,43.0077473,1.8,51.6394852,43.3711369,-0.3012291,9.7515908,9.3614417,1910.81419,2438.1660101,1.6994937,260.4477055,195.9489722,410.9978913,0.5341053,1.3650207,1.2924967,3.2463205),(27184,'cephalophus_sylvicultor_metacarpus.tif',240,5,66,114.8693112,51.7210072,43.0501669,1.8,51.6613771,43.4791183,-0.2914741,9.6343953,9.9072308,1891.7523283,2431.888917,1.580953,245.4660615,196.3540292,391.7433844,14.4826114,16.7925077,2.8586918,52.6755173),(27185,'cephalophus_sylvicultor_metacarpus.tif',240,5,67,114.1979227,51.7121569,43.0803195,1.8,51.6473488,43.5232697,-0.2810182,9.7088254,10.1755753,1879.7025917,2443.9386993,1.4639065,240.176955,193.6076204,406.7669688,14.4679324,16.8458091,2.8480037,52.9861775),(27186,'cephalophus_sylvicultor_metacarpus.tif',240,5,68,113.6501349,51.7106983,43.1146511,1.8,51.6504532,43.5322721,-0.2809023,9.2747371,10.1646295,1869.1549455,2458.3580831,1.4557149,241.8541751,201.5318529,391.2438772,14.4078988,16.9207723,2.9181161,52.9861775),(27187,'cephalophus_sylvicultor_metacarpus.tif',240,5,69,112.9499715,51.7002134,43.1450334,1.8,51.6226474,43.5458694,-0.2693196,9.8169605,9.5823975,1852.0713257,2470.930645,1.3327391,257.8614207,188.6603632,381.0177188,0.4746106,1.0933035,1.0303768,2.3409904),(27188,'cephalophus_sylvicultor_metacarpus.tif',240,5,70,112.7651561,51.701521,43.170359,1.8,51.6350723,43.5782176,-0.2467977,9.6930538,9.7615227,1835.6936842,2483.0502427,1.1216835,254.3711987,189.3823886,381.210391,0.4752838,1.4279575,1.1659045,3.0909905),(27189,'cephalophus_sylvicultor_metacarpus.tif',240,5,71,112.4993642,51.6912622,43.1892425,1.8,51.6194216,43.5613525,-0.2370334,8.9700152,9.3427406,1821.6504062,2502.4776423,1.0338772,267.8526289,203.0821984,391.5060833,0.5034006,0.9375001,0.9272952,1.9659904),(27190,'cephalophus_sylvicultor_metacarpus.tif',240,5,72,111.8727199,51.7007387,43.2000995,1.8,51.6526411,43.560877,-0.2174712,9.0894145,9.5540761,1801.7608477,2517.3360949,0.8679987,263.4829443,198.2262826,391.1938745,0.375,0.8385255,1.1071487,1.8106603),(27191,'cephalophus_sylvicultor_metacarpus.tif',240,5,73,110.0092467,51.7459589,43.1710789,1.8,51.6582995,43.5571908,-0.2032777,9.4783332,9.9845942,1774.6245819,2505.9687863,0.7472523,250.9835381,187.2296054,385.9989869,0.5341053,1.2577883,1.1071487,2.7159904),(27192,'cephalophus_sylvicultor_metacarpus.tif',240,5,74,108.4099248,51.7453556,43.1891705,1.8,51.6007052,43.5409017,-0.1908243,9.165704,9.6504103,1751.6467002,2497.4796579,0.6499907,258.7951787,191.1088016,387.2089222,0.4746106,1.0933035,1.0303768,2.3409904),(27193,'cephalophus_sylvicultor_metacarpus.tif',240,5,75,107.7186463,51.7526368,43.2060427,1.8,51.6239624,43.5977202,-0.1841069,9.5050744,10.4349023,1733.870777,2506.1896534,0.6016827,240.1737539,182.415277,386.75112,0.4097103,1.4279575,1.1659045,3.0909905),(27194,'cephalophus_sylvicultor_metacarpus.tif',240,5,76,107.3573678,51.7633057,43.2162907,1.8,51.633005,43.545502,-0.17354,9.4716336,9.6619791,1713.6953041,2522.0931767,0.5334767,261.032771,180.9292229,389.9726589,0.3977476,0.9375001,0.9272952,1.9659904),(27195,'cephalophus_sylvicultor_metacarpus.tif',240,5,77,107.3755106,51.7801769,43.2270747,1.8,51.6547133,43.5265475,-0.1669991,9.7268603,10.3730434,1691.1479056,2542.6393198,0.4944715,245.1198968,173.8636993,386.2905242,0.6736497,3.941962,1.1284221,8.6783014),(27196,'cephalophus_sylvicultor_metacarpus.tif',240,5,78,107.3056136,51.795474,43.2612045,1.8,51.7054962,43.5840431,-0.1616828,9.4994188,10.4726074,1691.0221683,2562.327251,0.4634591,244.6694642,178.0132242,392.3686513,0.5920789,3.5228054,1.1309537,7.6176412),(27197,'cephalophus_sylvicultor_metacarpus.tif',240,5,79,107.0022044,51.8133675,43.2592288,1.8,51.7157979,43.5349114,-0.1534883,9.3077462,9.8935064,1677.4224971,2580.1694281,0.416849,260.7942355,180.2179033,388.7965399,0.4705924,1.6770511,1.1071487,3.6213206),(27198,'cephalophus_sylvicultor_metacarpus.tif',240,5,80,107.0807307,51.842605,43.2733139,1.8,51.780617,43.5318025,-0.1456051,9.4420747,10.4367075,1671.9221519,2603.1992924,0.3757007,249.4272534,177.0714817,393.8527132,0.1875,0.2651651,2.3561945,0.5303301),(27199,'cephalophus_sylvicultor_metacarpus.tif',240,5,81,106.4622789,51.9166065,43.2393278,1.8,51.8477538,43.5402977,-0.1323559,9.1576926,10.3844581,1651.1188046,2599.1927456,0.309025,250.2964269,180.2985617,382.9573111,0.5038766,1.7688716,1.012197,3.7766507),(27200,'cephalophus_sylvicultor_metacarpus.tif',240,5,82,106.146352,51.9445403,43.2479807,1.8,51.8312508,43.5185559,-0.1266841,9.7148139,10.7591257,1635.6072516,2601.5395115,0.2824058,241.7984131,168.3621803,387.6587937,0.4746106,1.0933035,1.0303768,2.3409904),(27201,'cephalophus_sylvicultor_metacarpus.tif',240,5,83,105.5297433,51.9566814,43.2552872,1.8,51.8179126,43.5888551,-0.1223979,9.8658998,10.4216167,1621.3519673,2609.1127765,0.2621815,250.3558566,164.3389866,394.6604262,0.5233599,1.6770511,1.1071487,3.6213206),(27202,'cephalophus_sylvicultor_metacarpus.tif',240,5,84,105.1256275,51.9577697,43.2528736,1.8,51.7910467,43.5125943,-0.1265956,9.3126105,10.0073622,1608.3414473,2626.5765052,0.2793017,262.4644196,172.705758,376.5634273,0.4916563,2.9348394,1.1071487,6.337311),(27203,'cephalophus_sylvicultor_metacarpus.tif',240,5,85,105.3001943,51.9833276,43.2649461,1.8,51.8129985,43.5090286,-0.1209339,8.7148538,10.2328263,1593.8248622,2647.6875374,0.2554206,258.744502,182.8860118,376.9169086,0.6220399,3.2745469,1.1583859,7.2426411),(27204,'cephalophus_sylvicultor_metacarpus.tif',240,5,86,104.7373853,52.0022196,43.2753409,1.8,51.8263643,43.5641069,-0.1173845,9.5154846,10.2451646,1578.3477766,2637.7923314,0.2394288,257.4670517,165.8715078,388.6081096,0.5043526,1.7688716,1.012197,3.7766507),(27205,'cephalophus_sylvicultor_metacarpus.tif',240,5,87,104.0168418,52.0248051,43.2797485,1.8,51.8466751,43.5192365,-0.121921,8.9742097,10.1331196,1566.0761562,2637.3494013,0.2564226,260.2702332,174.5085307,380.7007592,0.5034006,1.7688716,1.012197,3.7766507),(27206,'cephalophus_sylvicultor_metacarpus.tif',240,5,88,104.6724847,52.058414,43.2846817,1.8,51.9552505,43.4978458,-0.1203777,9.1506177,10.304192,1560.6647872,2640.2776384,0.251579,256.2333514,170.5529436,392.1725789,0.5043526,2.0281227,0.9827937,4.3069808),(27207,'cephalophus_sylvicultor_metacarpus.tif',240,5,89,103.0313801,52.1171244,43.2124958,1.8,51.9236503,43.4206489,-0.1193698,8.8723519,10.34731,1532.8587949,2603.1774745,0.2435251,251.5801172,172.7680336,382.8076719,0.5870627,1.7688716,1.012197,3.7766507),(27208,'cephalophus_sylvicultor_metacarpus.tif',240,5,90,102.6469198,52.1767039,43.2170826,1.8,52.015964,43.4513532,-0.1069067,8.4186683,10.6153155,1510.1585583,2583.4649809,0.1947822,243.3714745,179.3821186,376.404381,0.5604374,2.1378291,0.9097532,4.4623109),(27209,'cephalophus_sylvicultor_metacarpus.tif',240,5,91,101.9387769,52.1972117,43.2232583,1.8,52.066137,43.4602613,-0.1063044,9.5225252,10.4077444,1494.6186722,2559.3142059,0.1912734,245.9047903,156.9561275,351.1558479,13.6875009,18.4332634,0.1634764,53.3611775),(27210,'cephalophus_sylvicultor_metacarpus.tif',240,5,92,104.8214833,52.2840186,43.2713008,1.8,52.2087768,43.5248178,-0.0949345,8.5677063,10.4726692,1493.6061389,2569.162467,0.1569792,245.3206939,174.3297541,368.7106302,13.6875009,18.4647057,0.1734957,53.2058474),(27211,'cephalophus_sylvicultor_metacarpus.tif',240,5,93,105.7429287,52.329224,43.2984107,1.8,52.2928211,43.5452465,-0.0891986,10.1003211,10.5065456,1491.2923221,2584.318247,0.1398504,245.9722095,147.6480114,373.9834637,13.6254769,18.535967,0.1318831,53.9370028),(27212,'cephalophus_sylvicultor_metacarpus.tif',240,5,94,105.7154109,52.3569729,43.3130209,1.8,52.3044985,43.5316614,-0.0814206,9.1911994,10.3187324,1480.9417942,2595.2697736,0.1165456,251.5105212,161.1260648,373.7281393,13.5000008,18.6182885,0.1618374,53.3156824),(27213,'cephalophus_sylvicultor_metacarpus.tif',240,5,95,105.0403469,52.3840519,43.3305798,1.8,52.2782211,43.5649137,-0.0722712,8.7502246,10.5316449,1459.0614393,2613.6982889,0.0912807,248.175694,166.7455996,373.1504885,13.3125008,18.6494189,0.1717602,53.4255174),(27214,'cephalophus_sylvicultor_metacarpus.tif',240,5,96,104.7798178,52.4416823,43.3302285,1.8,52.3580911,43.5305199,-0.055563,9.3668986,10.5599467,1435.6250109,2634.7050843,0.0538582,249.4998476,153.2657792,341.2272764,13.2533305,18.7471885,0.1404826,53.4255174),(27215,'cephalophus_sylvicultor_metacarpus.tif',240,5,97,104.795947,52.5527079,43.2641691,1.8,52.4711963,43.5094959,-0.0374024,10.3235719,10.6382794,1420.1508443,2671.026021,0.0244225,251.0768819,137.5639029,339.5063374,13.1125087,18.9077749,0.129275,53.8460125),(27216,'cephalophus_sylvicultor_metacarpus.tif',240,5,98,104.5329676,52.5589408,43.2575534,1.8,52.496159,43.5361971,-0.0218332,9.1047193,10.6108354,1401.9297398,2717.4887101,0.0083036,256.1050675,153.9783595,358.8159032,12.9375008,19.0513299,0.1780929,53.5996922),(27217,'cephalophus_sylvicultor_metacarpus.tif',240,5,99,105.0717532,52.5963695,43.2656929,1.8,52.5395532,43.5327666,-0.0115964,9.0733503,10.7771617,1406.9889573,2781.6148052,0.0023549,258.1027246,155.0682951,364.0381664,12.9375008,19.3043077,0.1364026,54.2853524),(27218,'cephalophus_sylvicultor_metacarpus.tif',240,5,100,106.2608869,52.5995762,43.3034837,1.8,52.5569047,43.5418689,-0.0066196,8.6065226,11.1668534,1425.1511792,2878.2971719,0.000776,257.7536446,165.5896626,379.6537619,0.5043526,1.6129361,0.9505468,3.4016506),(27219,'cephalophus_sylvicultor_metacarpus.tif',240,5,101,106.8156632,52.581025,43.3537098,1.8,52.5841642,43.5390203,-0.00501,10.6410572,10.7794532,1453.2395227,2987.1013889,0.0004468,277.11066,136.5690927,382.5487982,13.1250008,19.8617303,0.1325515,55.3005175),(27220,'cephalophus_sylvicultor_metacarpus.tif',240,5,102,108.0527905,52.592672,43.4019778,1.8,52.5826241,43.5736659,0.0018815,9.0981837,10.7746742,1481.5259404,3130.7596738,0.0000638,290.5665276,162.8375499,398.1171911,0.5341053,1.9304308,1.0636978,4.3069808),(27221,'cephalophus_sylvicultor_metacarpus.tif',240,5,103,109.0688595,52.6169319,43.4573186,1.8,52.6888402,43.6379038,0.0072572,9.0432952,11.3676809,1514.1951057,3286.7012788,0.0009573,289.126807,167.4384256,422.3222209,0.375,0.8385255,1.1071487,1.8106603),(27222,'cephalophus_sylvicultor_metacarpus.tif',240,5,104,111.4165409,52.6393114,43.5334597,1.8,52.7218107,43.603987,0.0126225,8.9912542,11.5763089,1568.492161,3491.9530627,0.0029585,301.6465009,174.4464261,437.117359,0.2651651,0.5303301,0.7853982,1.0606602),(27223,'cephalophus_sylvicultor_metacarpus.tif',240,5,105,112.3391156,52.7312266,43.5709033,1.8,52.8150672,43.6946516,0.0128012,9.1308136,11.4595896,1628.3604246,3697.0670275,0.003068,322.6177521,178.3368374,458.2154705,13.6875009,21.4742774,0.0961934,60.1378284),(27224,'cephalophus_sylvicultor_metacarpus.tif',240,5,106,112.6126845,52.787923,43.6684185,1.8,52.8571325,43.7528088,0.0154402,9.1983531,11.7063586,1680.6607301,3920.8488334,0.0044741,334.9332579,182.7132217,474.672496,13.8720144,21.8861592,0.1116033,61.4824984),(27225,'cephalophus_sylvicultor_metacarpus.tif',240,5,107,114.6660122,52.8102535,43.7808981,1.8,52.8679153,43.8994258,0.0230793,11.2819493,11.877977,1769.0116576,4181.6727928,0.0101777,352.05261,156.8001781,477.3760848,14.0625009,22.3911443,0.0838366,64.5734888),(27226,'cephalophus_sylvicultor_metacarpus.tif',240,5,108,117.7304657,52.7751693,43.9340387,1.8,52.8574641,44.0258797,0.0218715,9.2834136,11.5442042,1887.4690662,4479.9396477,0.0093848,388.0682943,203.3162748,530.0290188,14.4375009,22.9853908,3.0435474,64.1718384),(27227,'cephalophus_sylvicultor_metacarpus.tif',240,5,109,118.1310233,52.8064039,44.0176586,1.8,52.8651096,44.1144207,0.0180363,9.3569292,12.1161215,1948.8404592,4726.3993847,0.0064042,390.0917792,208.277783,539.5801374,0.375,0.6760409,0.9827937,1.4356603),(27228,'cephalophus_sylvicultor_metacarpus.tif',240,5,110,120.0797984,52.8516417,44.1210794,1.8,52.9226767,44.2029311,0.0242239,9.4268339,12.6925334,2004.3055265,5055.9881203,0.0117414,398.3434955,212.6170411,552.0916868,0.1875,0.4192628,2.0344439,0.9053301),(27229,'cephalophus_sylvicultor_metacarpus.tif',240,5,111,122.8712689,52.9045458,44.2151841,1.8,52.9632809,44.3065472,0.0273243,9.5864075,12.2721927,2058.412417,5447.8757184,0.0152859,443.9203216,214.7219828,580.1627593,15.4577239,24.7023705,3.0351265,69.7591493),(27230,'cephalophus_sylvicultor_metacarpus.tif',240,5,112,128.9205523,52.9513349,44.3155716,1.8,52.9838602,44.4210979,0.0258249,9.8393752,12.8334319,2149.956561,5928.6335554,0.0143267,461.9678975,218.5053948,609.6943161,15.6286882,25.3263867,3.0154011,71.1304698),(27231,'cephalophus_sylvicultor_metacarpus.tif',240,5,113,141.9922869,53.0762601,44.4058178,1.8,53.0707453,44.5532453,0.0288585,10.6521325,13.0220713,2340.7128816,6770.3308926,0.0197034,519.911981,219.7412462,669.1935064,15.4933618,26.1170758,3.0769347,73.2062951),(27232,'cephalophus_sylvicultor_metacarpus.tif',240,5,114,176.4517657,53.1596094,44.7522729,1.8,53.1719122,44.9298426,0.0271169,10.8480881,13.4199355,2754.5433487,8412.0148424,0.0216199,626.8297522,253.919707,805.3172075,15.4835454,26.6520566,3.0146199,74.3501399),(27233,'cephalophus_sylvicultor_metacarpus.tif',240,5,115,180.008705,53.0757756,44.8753455,1.8,53.143587,45.0104453,0.0226803,10.2512199,13.6862953,2754.8265737,8781.3039853,0.01543,641.6129261,268.7315859,805.6226059,15.375001,27.2804463,3.0590222,75.9222855),(27234,'cephalophus_sylvicultor_metacarpus.tif',240,5,116,176.3945888,53.0781822,45.0063394,1.8,53.1485894,45.1860182,0.0266481,11.4924704,14.0683544,2672.0431866,8425.8963844,0.0208719,598.9255147,232.5038136,764.6955809,16.5399806,27.8265431,3.0674047,82.3505868),(27235,'cephalophus_sylvicultor_metacarpus.tif',240,5,117,183.02215,53.1099301,45.0582778,1.8,53.1321917,45.2867834,0.0228555,10.3284179,13.9169017,2735.4426487,8731.2010973,0.0159316,627.3811001,264.8462409,795.5659605,16.9094088,28.0003505,3.0745791,86.9870725),(27236,'cephalophus_sylvicultor_metacarpus.tif',240,5,118,188.0231911,53.1165991,45.1367756,1.8,53.1295003,45.3890463,0.022986,11.2774385,13.8940846,2780.4915649,9052.9233825,0.0165544,651.5667395,246.5534675,822.3299471,17.8123573,27.9544848,3.0205654,139.9134827),(27237,'cephalophus_sylvicultor_metacarpus.tif',240,5,119,184.2141175,53.1650015,45.2343741,1.8,53.1489718,45.551353,0.0156184,10.3538917,14.5844229,2895.8725098,9405.3951522,0.0074887,644.8931981,279.6892784,815.5047693,16.8449064,28.318089,3.1217277,107.635491),(27238,'cephalophus_sylvicultor_metacarpus.tif',240,5,120,186.8027471,53.2773542,45.2867778,1.8,53.1874415,45.7019868,0.0156483,10.8305792,14.8014471,3338.4783157,9908.5845602,0.007623,669.4334994,308.2455932,881.7894222,17.2198922,27.6548216,2.9574942,141.7228037),(27239,'cephalophus_sylvicultor_metacarpus.tif',240,5,121,189.850496,53.411795,45.2525849,1.8,53.3463486,45.6767877,0.0049474,11.7221017,14.7655981,3726.5820036,10123.8756618,0.0007744,685.6393887,317.9107373,900.2732729,17.9406812,28.0436341,0.0870279,175.3298539),(27240,'cephalophus_sylvicultor_metacarpus.tif',240,5,122,192.1964516,53.4609691,45.3260872,1.8,53.362839,45.7986601,0.0053794,11.6436146,14.4483907,3766.917308,10275.9576859,0.000927,711.2181502,323.5178625,916.0486703,1.6432529,3.3802045,1.2315037,10.1139617),(27241,'cephalophus_sylvicultor_metacarpus.tif',240,5,123,193.3080497,53.4728141,45.4326175,1.8,53.434512,45.883255,-0.0006617,10.4447176,14.4743832,3436.1234375,10552.8857682,0.0000141,729.0732627,328.9819395,922.9215694,12.6532272,19.0153116,0.8621701,54.9177117),(27242,'cephalophus_sylvicultor_metacarpus.tif',240,5,124,185.1146929,53.3967568,45.4642728,1.8,53.3835154,45.7778089,-0.0062391,9.6958915,14.0349623,2717.6352045,9968.241027,0.001201,710.2435189,280.287294,859.1570772,12.6323304,18.3040734,0.8143756,53.3910612),(27243,'cephalophus_sylvicultor_metacarpus.tif',240,5,125,157.2676368,53.1558757,45.4769404,1.8,53.309816,45.7157277,-0.0098159,10.438976,13.788411,1757.9937226,7794.2163717,0.0025254,565.272994,168.4067211,678.6597656,12.3363263,17.4294347,0.8691711,66.4029938),(27244,'cephalophus_sylvicultor_metacarpus.tif',240,5,126,93.7124265,52.6824839,45.389164,1.8,52.6984576,45.4918375,-0.0269348,6.9052196,13.5005031,810.4238786,2671.7568481,0.0113284,197.9005392,117.3639544,254.9278543,11.5745256,15.4001329,0.7337201,51.5427115),(27245,'cephalophus_sylvicultor_metacarpus.tif',240,5,127,45.4032798,53.3387011,45.3642854,1.8,53.3323907,45.3338427,-0.0281445,5.4249829,6.9259901,190.9152845,814.2133448,0.0059925,117.5591255,35.1918685,122.3250184,6.1292574,10.7334545,1.0993364,28.7619336),(27246,'cephalophus_sylvicultor_metacarpus.tif',240,5,128,1.3337005,53.0289573,45.6882907,1.8,53.0931023,45.6940133,-0.0057129,2.2818738,6.2216635,1.3031852,37.1463337,0.0000073,5.9704826,0.5711031,6.1693103,1.6292207,4.5966193,1.3654009,10.5078064),(27247,'cephalophus_sylvicultor_metacarpus.tif',240,5,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27248,'cephalophus_sylvicultor_metacarpus.tif',240,5,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27249,'cephalophus_sylvicultor_metacarpus.tif',240,5,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27250,'cephalophus_sylvicultor_metacarpus.tif',240,5,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27251,'cephalophus_sylvicultor_metacarpus.tif',240,5,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27252,'cephalophus_sylvicultor_metacarpus.tif',240,5,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27253,'cephalophus_sylvicultor_metacarpus.tif',240,5,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27254,'cephalophus_sylvicultor_metacarpus.tif',240,5,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27255,'cephalophus_sylvicultor_metacarpus.tif',240,5,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27256,'cephalophus_sylvicultor_metacarpus.tif',240,5,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27257,'cephalophus_sylvicultor_metacarpus.tif',240,5,139,2.8593647,67.3042162,38.4509621,1.8,67.1324013,38.4609801,-1.5704924,1.8668301,4.7012472,1.5030611,12.2815539,0.4765607,2.6124033,0.8051408,2.8746947,11.0625007,11.3866705,1.8717166,36.3418854),(27258,'cephalophus_sylvicultor_metacarpus.tif',240,5,140,11.4682791,66.3666816,38.533174,1.8,66.1694347,38.5206923,-1.5691259,3.1808991,7.2238079,19.0141257,119.913329,1.9113745,16.5997394,5.9775948,18.6173958,15.562501,15.9650507,0.8685394,51.4861774),(27259,'cephalophus_sylvicultor_metacarpus.tif',240,5,141,20.871107,65.6717282,38.5320594,1.8,65.4877914,38.5150886,-1.5706082,4.1718479,8.9075424,62.1090859,351.2849696,3.4785177,39.4368003,14.8876677,44.5817871,18.8267192,19.1185663,1.1027628,62.2403042),(27260,'cephalophus_sylvicultor_metacarpus.tif',240,5,142,30.8344215,65.1668124,38.5405138,1.8,64.9738001,38.5314649,-1.5707879,4.7918221,10.228038,130.1423092,688.5272889,5.1390703,67.3176314,27.159253,76.6356793,21.1875013,21.5853154,1.0020684,70.4526153),(27261,'cephalophus_sylvicultor_metacarpus.tif',240,5,143,137.1753048,51.134506,39.9716889,1.8,49.5297977,39.1650736,-0.1760031,16.426102,19.0567147,6349.5482197,13481.5329783,0.7009324,707.4426639,386.5523426,933.171236,28.5000018,28.9194076,1.0025753,94.4948787),(27262,'cephalophus_sylvicultor_metacarpus.tif',240,5,144,400.47869,47.3530954,39.2077515,1.8,50.0174496,39.2559377,-0.1235579,16.7609743,22.3114538,21402.2034698,26799.0903651,1.0138143,1201.1359979,1276.9068877,1968.2031267,28.8750018,29.2962393,1.0183028,95.6198787),(27263,'cephalophus_sylvicultor_metacarpus.tif',240,5,145,414.341664,47.572859,39.1229065,1.8,50.3716646,39.2235979,-0.1102134,17.0701626,22.0294558,22137.0399813,28639.2135246,0.8354438,1300.0418091,1296.8265452,2059.1568143,29.035574,29.2127184,0.9311463,95.9305389),(27264,'cephalophus_sylvicultor_metacarpus.tif',240,5,146,420.1486569,47.7739424,39.1230335,1.8,50.6304606,39.2246792,-0.1089375,17.0849531,21.8561938,22563.1103709,29832.0029926,0.8277279,1364.9221501,1320.6422154,2121.4163047,29.0625018,29.2361764,1.0094778,96.0403739),(27265,'cephalophus_sylvicultor_metacarpus.tif',240,5,147,424.2141794,47.920815,39.1262648,1.8,50.8071626,39.236854,-0.1075004,16.4888912,21.7341986,22905.6689388,30681.4147513,0.8139175,1411.6653355,1389.1576266,2161.5482122,29.035574,29.25541,0.9080668,95.9305389),(27266,'cephalophus_sylvicultor_metacarpus.tif',240,5,148,427.0360122,48.0084142,39.1288537,1.8,50.9357786,39.207599,-0.1042791,16.7822375,21.6088161,23112.1319453,31175.5166015,0.77114,1442.7221024,1377.1782203,2196.0339314,29.094071,57.2762667,0.0556801,183.0995919),(27267,'cephalophus_sylvicultor_metacarpus.tif',240,5,149,427.9227381,48.0224581,39.1605195,1.8,50.9396464,39.2693612,-0.0843688,17.2266675,21.3541538,23156.3316532,31147.495261,0.5064619,1458.615291,1344.2142374,2196.0929679,28.973087,57.3900139,0.0228718,181.1147569),(27268,'cephalophus_sylvicultor_metacarpus.tif',240,5,150,427.8645918,48.0074037,39.1871486,1.8,50.925514,39.2634632,-0.0671811,16.8116166,21.1535244,23123.2636592,30945.378981,0.3213632,1462.8947128,1375.433675,2184.1409439,28.9681788,57.3498755,0.0752674,180.6942617),(27269,'cephalophus_sylvicultor_metacarpus.tif',240,5,151,428.4052311,47.9818504,39.208581,1.8,50.8831362,39.2917031,-0.0551383,17.4450558,21.0238361,23162.8956842,30793.2307939,0.2168552,1464.6818334,1327.7627769,2176.6737007,28.9681788,57.3498755,0.0752674,180.3192617),(27270,'cephalophus_sylvicultor_metacarpus.tif',240,5,152,428.5632105,47.9682548,39.227603,1.8,50.8676943,39.3017065,-0.0451093,16.7938415,20.9055151,23179.9948496,30694.3638045,0.1452445,1468.242407,1380.2675761,2171.4418357,28.9718788,57.3360811,0.0720064,180.3192617),(27271,'cephalophus_sylvicultor_femur.tif',240,7,1,22.134298,95.0914175,92.4536858,1.8,95.7700811,92.4611843,0.0104696,2.3505635,41.6271157,13.2320306,13502.2719769,0.0004044,324.3624197,5.6293016,324.6491514,12.5995651,161.7531265,3.1122469,350.6142044),(27272,'cephalophus_sylvicultor_femur.tif',240,7,2,21.4942436,95.2942744,92.4842832,1.8,96.4056592,92.4875047,0.0132703,2.4824831,41.8318122,13.3314332,13186.8798177,0.0006308,315.2356811,5.3702009,315.5329132,12.5995651,161.7531265,3.1122469,351.1066426),(27273,'cephalophus_sylvicultor_femur.tif',240,7,3,21.2878293,95.5286057,92.5431229,1.8,96.688984,92.5655774,0.0159744,2.6374369,42.0732741,13.7081313,13122.5429032,0.0009053,311.897355,5.1975202,312.1740746,12.6529873,161.7729308,3.1083368,351.1066426),(27274,'cephalophus_sylvicultor_femur.tif',240,7,4,20.9006962,95.6461319,92.5958006,1.8,96.5394097,92.6101845,0.0179085,2.4426045,42.1987553,13.9383335,13029.5939441,0.0011171,308.7672577,5.7063406,309.0052112,12.9527198,161.7837603,3.1063822,350.1349382),(27275,'cephalophus_sylvicultor_femur.tif',240,7,5,20.6079119,95.8360063,92.654799,1.8,96.6461389,92.6404218,0.0193237,12.5779413,42.397266,16.0014875,13015.3176993,0.0012824,306.9848348,1.2721865,307.208003,13.067149,161.8072732,3.1024737,351.1066426),(27276,'cephalophus_sylvicultor_femur.tif',240,7,6,20.4381752,96.090625,92.7426979,1.8,97.1095798,92.7522288,0.0203612,2.3537785,42.6549927,13.9337382,12900.3173095,0.001412,302.4339355,5.9197322,302.6017188,13.3060654,161.8199564,3.1005199,350.5824039),(27277,'cephalophus_sylvicultor_femur.tif',240,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27278,'cephalophus_sylvicultor_femur.tif',240,7,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27279,'cephalophus_sylvicultor_femur.tif',240,7,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27280,'cephalophus_sylvicultor_femur.tif',240,7,10,10.4392144,112.6055936,71.2278385,1.8,112.5276724,71.1371417,-1.3076541,2.3612469,5.6495755,8.7033655,50.4872679,1.6221491,8.9364711,3.6859193,10.4731809,4.8810299,11.6082642,1.2662854,28.1321945),(27281,'cephalophus_sylvicultor_femur.tif',240,7,11,50.4137913,111.3746614,71.8296501,1.8,111.1479305,71.5672798,-1.0784614,4.5244725,9.6068331,167.9723774,957.4530424,6.5249654,99.6637533,37.1252951,116.6988028,8.3387401,18.5630865,1.0537644,46.1262238),(27282,'cephalophus_sylvicultor_femur.tif',240,7,12,72.2460521,111.1908766,71.4674665,1.8,111.2748153,71.0838114,-1.0909615,5.7123031,13.3142745,408.3174224,2143.3217888,9.475013,160.9792401,71.4803491,185.1277979,0.316406,0.4474657,2.3561945,0.8949314),(27283,'cephalophus_sylvicultor_femur.tif',240,7,13,80.8713443,110.8246081,70.4646155,1.8,108.8669812,69.2219227,1.0858951,20.6905925,32.7517364,2676.3126618,3112.7209608,10.5500877,95.0398759,129.3492522,152.7463858,10.8276721,22.6512248,1.0759089,57.0825475),(27284,'cephalophus_sylvicultor_femur.tif',240,7,14,133.3412093,100.3062395,63.9518532,1.8,99.9826322,63.7651161,0.5378022,12.8139001,29.595617,3627.0489542,41550.9102396,5.8314493,1403.9548574,283.0558173,1525.933533,11.9103237,23.7135714,1.0235119,59.7991421),(27285,'cephalophus_sylvicultor_femur.tif',240,7,15,185.2820542,95.7666637,61.248092,1.8,96.5341196,61.6143251,0.5286776,13.3752811,26.1022513,5136.256458,62290.1655346,7.8563058,2386.390539,384.0111035,2582.9284895,13.5238932,24.3159631,1.0080591,62.5925097),(27286,'cephalophus_sylvicultor_femur.tif',240,7,16,239.9823713,93.7667447,59.9186041,1.8,94.9266061,60.4767719,0.5254505,40.590604,27.9809561,7125.784747,75048.2083737,10.0634756,2682.1173669,175.5525676,1893.402929,18.6679559,24.8030848,2.7350258,71.9125165),(27287,'cephalophus_sylvicultor_femur.tif',240,7,17,301.1813424,93.0723548,59.0432735,1.8,94.3814874,59.5966262,0.5187663,21.8837424,38.1607252,9661.5535163,84404.2506009,12.3397342,2211.8093998,441.4945741,2327.034396,24.8441245,53.7648243,2.749065,168.1789833),(27288,'cephalophus_sylvicultor_femur.tif',240,7,18,358.0572011,93.0856739,58.6851662,1.8,94.2147667,59.2574477,0.508526,19.0136136,29.4719095,12359.0102712,92964.1157957,14.1469668,3154.3295755,650.0084903,3555.7780363,25.0703425,55.1763496,2.7472426,200.9393808),(27289,'cephalophus_sylvicultor_femur.tif',240,7,19,379.4455679,92.6602944,58.312526,1.8,93.897596,59.0291723,0.5073501,20.2038345,30.2668961,14635.2742357,98122.496131,14.9288225,3241.9081153,724.3810202,3679.2338099,25.4880307,56.1288606,2.7359607,172.5768673),(27290,'cephalophus_sylvicultor_femur.tif',240,7,20,380.1716889,92.3443558,58.0582207,1.8,93.6119801,58.7624084,0.5069771,17.4844164,30.8499996,16444.0286041,100999.4318069,14.9373249,3273.8876249,940.4962833,3785.0936059,25.8890086,56.8800899,2.7476573,161.5437707),(27291,'cephalophus_sylvicultor_femur.tif',240,7,21,378.2737024,92.2136926,57.8096996,1.8,93.4656415,58.6044022,0.5085408,20.6176207,31.8782359,17714.584594,103608.2854439,14.9465237,3250.1260703,859.1963577,3772.2688279,26.6976199,57.5058715,2.722251,162.8543674),(27292,'cephalophus_sylvicultor_femur.tif',240,7,22,374.0455757,92.2647081,57.6292966,1.8,93.4042173,58.3570754,0.511479,30.4079392,31.0282679,18557.7521762,104367.0271504,14.9355429,3363.6111319,610.292991,3443.0290605,27.2960852,57.6388976,2.7590475,164.5356569),(27293,'cephalophus_sylvicultor_femur.tif',240,7,23,363.30575,92.4164052,57.6355933,1.8,93.301219,58.1784441,0.5170297,27.6469861,31.4649125,18993.0749209,102607.7739565,14.7945815,3261.0220693,686.9853681,3425.7727113,27.9869897,57.6354237,2.7172369,167.0351047),(27294,'cephalophus_sylvicultor_femur.tif',240,7,24,351.5434088,92.6696248,57.7445524,1.8,93.1937631,58.0517943,0.5257122,42.5053989,31.1274978,18833.3679538,99442.6882988,14.7550103,3194.6894349,443.0817833,2560.2654247,28.4836873,57.499778,2.6360976,168.8567679),(27295,'cephalophus_sylvicultor_femur.tif',240,7,25,339.7972373,93.1421133,57.8762298,1.8,93.2498045,57.886175,0.537657,40.6158506,31.6633027,18416.8247374,94751.1519094,14.853216,2992.4595269,453.4393461,2487.540503,28.7195337,57.3254038,2.6532587,170.8319771),(27296,'cephalophus_sylvicultor_femur.tif',240,7,26,326.4976795,93.675484,58.218894,1.8,93.2790183,57.9379541,0.5440212,42.5533302,29.5156643,17449.3809809,90173.2920136,14.5775711,3055.0995269,410.0591162,2379.4558786,28.8067785,56.9469332,2.6307165,176.156593),(27297,'cephalophus_sylvicultor_femur.tif',240,7,27,312.6324846,94.3855116,58.6395686,1.8,93.3799264,57.9948108,0.5580899,29.5346668,29.107463,16327.4528684,83979.8943751,14.612497,2885.1670942,552.8233306,2890.0648933,28.505804,56.3815663,2.5925112,191.8365208),(27298,'cephalophus_sylvicultor_femur.tif',240,7,28,306.7784354,95.0742315,59.092587,1.8,93.6580913,58.2839873,0.5653951,28.359984,28.1060852,15615.176577,78704.6133052,14.6756424,2800.2695073,550.6059728,2959.9770593,28.1206826,55.6451983,2.5709385,179.0135614),(27299,'cephalophus_sylvicultor_femur.tif',240,7,29,309.8924889,94.8318935,59.1515811,1.8,93.8759638,58.5802926,0.5529463,33.8334537,26.9853453,15348.2688154,76407.7073134,14.2463599,2831.4519083,453.6418,2525.9988671,0.5663253,1.1408182,2.1587989,2.4226749),(27300,'cephalophus_sylvicultor_femur.tif',240,7,30,295.139506,95.6028015,59.5474666,1.8,94.9031054,59.1482904,0.5580292,33.8375363,29.3685145,13872.1628189,65722.625175,13.7921909,2237.8600485,409.9637361,2138.8590597,0.6328121,1.0005637,2.8198421,2.2373285),(27301,'cephalophus_sylvicultor_femur.tif',240,7,31,266.3567791,97.5947116,60.8760833,1.8,96.8397264,60.6735948,0.548921,36.7062978,26.8065965,13016.2612467,48439.9177769,12.0855313,1807.0148463,354.6056675,1459.8388586,0.6328121,0.8949314,2.3561945,1.7898628),(27302,'cephalophus_sylvicultor_femur.tif',240,7,32,263.7320041,97.8318579,61.1237049,1.8,97.0237906,60.9334755,0.5606069,33.7275699,32.9949771,12760.6166282,44903.0380847,12.4264017,1360.9052674,378.3437899,1322.7381229,0.6328121,0.8949314,2.3561945,1.7898628),(27303,'cephalophus_sylvicultor_femur.tif',240,7,33,259.1307602,98.158646,61.3249193,1.8,97.4734476,61.2348998,0.5814432,37.350366,30.3149434,12380.2458272,41223.809371,13.0279818,1359.8511077,331.4625038,1233.9052899,24.8859037,43.278285,2.4234504,139.4457771),(27304,'cephalophus_sylvicultor_femur.tif',240,7,34,254.1644687,98.2537,61.5084843,1.8,97.5476091,61.299387,0.6057616,35.4970683,33.141906,11971.0767457,38625.9335229,13.7334832,1165.4710954,337.2412799,1156.2372324,24.6755607,42.3570665,2.41433,136.3135172),(27305,'cephalophus_sylvicultor_femur.tif',240,7,35,247.3594998,98.0952997,61.6217015,1.8,97.2440848,61.6193206,0.6205002,37.0379792,30.8150803,11943.4191713,36017.8555462,13.9376776,1168.8386057,322.4641149,1132.7215795,0.4474657,1.3423971,2.3561945,2.6847942),(27306,'cephalophus_sylvicultor_femur.tif',240,7,36,247.1330932,98.0200488,61.8768403,1.8,97.1965562,61.9391725,0.6533885,36.7292844,29.9840342,11916.9864627,34270.3665239,15.2200471,1142.9538229,324.4546324,1099.6432889,0.6328121,0.8949314,2.3561945,1.7898628),(27307,'cephalophus_sylvicultor_femur.tif',240,7,37,246.0265133,97.9492741,62.0640877,1.8,97.0638786,62.1712445,0.6766624,37.7701983,29.724968,12055.0876977,32470.7534221,16.0786255,1092.3730337,319.1692983,1020.528038,0.6328121,1.1408182,2.1587989,2.4226749),(27308,'cephalophus_sylvicultor_femur.tif',240,7,38,248.1243311,97.6844133,62.2628901,1.8,96.6150342,62.4497854,0.6987282,36.7568943,29.8728913,12628.3410816,30795.0417582,17.1107957,1030.8691398,343.5638763,970.2375261,24.5706837,39.7829473,2.260443,133.7822689),(27309,'cephalophus_sylvicultor_femur.tif',240,7,39,256.0945823,97.4089435,62.4773674,1.8,96.296216,62.6697757,0.7253842,39.0367248,29.7327988,13258.6361833,29122.1042579,18.7858177,979.4605775,339.6451992,932.6313565,24.6528866,39.0553233,2.2759077,113.2569914),(27310,'cephalophus_sylvicultor_femur.tif',240,7,40,259.1065814,96.9990412,62.6919098,1.8,95.7814168,62.8986181,0.7329972,39.6476947,28.8253724,14154.3848701,27206.0097276,19.3334499,943.8216226,357.0039816,923.5943307,26.1910361,37.7571973,2.2612428,141.3573855),(27311,'cephalophus_sylvicultor_femur.tif',240,7,41,252.3027957,96.6909226,62.4149969,1.8,95.2359829,62.9498353,0.7161467,41.2780474,28.4086384,14933.3974597,24928.9262583,18.1224777,877.5121829,361.7757715,894.249158,26.8615582,36.1340676,2.2195513,135.431758),(27312,'cephalophus_sylvicultor_femur.tif',240,7,42,244.3174062,96.5819018,62.2319661,1.8,95.5650561,62.644966,0.7713177,41.1061853,25.0354426,14267.8152129,23038.0593393,19.7865089,920.2177761,347.0965528,839.6424211,25.7299028,35.4600689,2.1785983,101.6678557),(27313,'cephalophus_sylvicultor_femur.tif',240,7,43,238.9405613,96.4780495,62.1641785,1.8,95.6584107,62.5280115,0.8161708,39.9225985,22.7900146,13796.4942497,21698.411377,21.1364117,952.1016887,345.5810689,839.9474269,0.316406,0.4474657,2.3561945,0.8949314),(27314,'cephalophus_sylvicultor_femur.tif',240,7,44,239.2336794,96.1186433,62.118147,1.8,95.2940339,62.4301727,0.8360989,39.9095723,26.4299555,14271.9619919,20747.699173,21.9542309,785.0069665,357.60749,840.9593544,28.3074271,34.1440082,2.1382363,115.4625195),(27315,'cephalophus_sylvicultor_femur.tif',240,7,45,241.1484424,95.7186515,62.093716,1.8,94.9770229,62.3815133,0.9316756,42.195752,23.3747137,14922.2406783,19824.2140547,25.8912956,848.1051077,353.6431979,813.5056941,0.316406,0.4474657,2.3561945,0.8949314),(27316,'cephalophus_sylvicultor_femur.tif',240,7,46,244.2514228,95.334528,62.2205542,1.8,94.7285867,62.4314944,1.1236818,39.4213801,17.055774,15424.8311924,19101.8230117,33.0985126,1119.9622498,391.2808524,865.9437557,0.6328121,2.0011275,1.2490458,4.5832304),(27317,'cephalophus_sylvicultor_femur.tif',240,7,47,244.8707265,94.9632216,62.282779,1.8,94.3280838,62.4386785,1.3680987,42.3242913,16.7770664,15665.8785321,19107.2700945,39.1578203,1138.8922025,370.1391815,819.5589242,26.7444246,32.3988035,2.1262901,96.9628797),(27318,'cephalophus_sylvicultor_femur.tif',240,7,48,245.987166,94.8286411,62.0594993,1.8,94.2107844,62.2798108,1.4786041,41.6477693,19.038006,15296.3068203,19035.0647893,40.6503896,999.845507,367.2779376,819.1606412,0.6328121,4.1254299,1.6475682,8.7507955),(27319,'cephalophus_sylvicultor_femur.tif',240,7,49,240.3499065,94.816292,61.7306458,1.8,94.23241,61.9498867,1.5128911,37.0745946,19.1561359,14243.2976002,18580.8763699,39.9241519,969.96996,384.1794569,795.576121,0.316406,0.4474657,2.3561945,0.8949314),(27320,'cephalophus_sylvicultor_femur.tif',240,7,50,235.67916,94.8697798,61.359825,1.8,94.2381398,61.6727588,1.4814271,37.3630529,20.2339307,13449.4179704,17996.5259307,38.9669714,889.4231286,359.9657126,827.3901855,24.9960766,31.2025121,2.1025204,94.2780855),(27321,'cephalophus_sylvicultor_femur.tif',240,7,51,231.5402248,94.8444085,60.9198305,1.8,94.3180771,61.2903314,1.4647691,34.9836982,22.498889,12791.0442579,17365.6977551,38.1578404,771.8469026,365.6287042,775.3687729,1.0860187,2.2816363,2.1587989,5.0306961),(27322,'cephalophus_sylvicultor_femur.tif',240,7,52,227.4297762,94.7786702,60.6383684,1.8,94.3263671,61.0102514,1.471233,23.1958595,22.8261343,12227.6829148,16718.7271027,37.5304562,732.4379552,527.1493775,937.6403618,1.5820302,4.9119425,1.3101939,11.8062825),(27323,'cephalophus_sylvicultor_femur.tif',240,7,53,222.4032956,94.6840984,60.3329707,1.8,94.3250083,60.6587438,1.5019747,35.764746,21.5053727,11821.2996394,16106.1059111,36.8919269,748.9340513,330.5293891,675.1074811,0.316406,1.0005637,1.8925469,2.1605555),(27324,'cephalophus_sylvicultor_femur.tif',240,7,54,219.9047538,94.5925127,60.0007993,1.8,94.2917048,60.2715196,1.5067152,38.8495131,23.5352762,11436.5931799,15665.5475212,36.5004957,665.6198721,294.3818925,625.1641976,23.8050745,29.5953829,2.0727028,88.6913503),(27325,'cephalophus_sylvicultor_femur.tif',240,7,55,219.9548708,94.542023,59.5980047,1.8,94.2945105,59.8682546,1.5311144,34.6396139,23.3441552,11211.6003837,15250.2848558,36.6014501,653.2806482,323.6641268,655.9475287,0.9492181,2.7033743,1.2120257,6.0342009),(27326,'cephalophus_sylvicultor_femur.tif',240,7,56,217.3983242,94.4747382,59.2292979,1.8,94.2280394,59.6491019,1.536152,36.0287421,24.3105404,11003.2495818,14800.0389927,36.1895835,608.7910324,305.4019909,624.563659,23.3666936,28.6115742,2.0789689,87.4706987),(27327,'cephalophus_sylvicultor_femur.tif',240,7,57,217.2207909,94.4631819,58.7731604,1.8,94.2984569,59.0165811,1.528206,34.1045471,24.2494497,10749.0405079,14167.4506049,36.1378342,584.2380245,315.1791014,603.0249699,23.4140464,28.2612763,1.9492237,88.8130958),(27328,'cephalophus_sylvicultor_femur.tif',240,7,58,215.3419471,94.4260062,58.3282566,1.8,94.2671921,58.5513574,1.5133445,33.7859394,23.7111805,10425.6949324,13738.3695483,35.7719913,579.404705,308.5808808,591.3451183,23.0976404,27.9675013,1.9534035,90.3726397),(27329,'cephalophus_sylvicultor_femur.tif',240,7,59,215.8439368,94.4241566,57.8186614,1.8,94.2928051,58.0276387,1.5094255,34.5809128,20.467028,10075.5305968,13482.3579158,35.8386679,658.7355003,291.3610363,597.9209702,0.6328121,5.101894,1.4464413,11.1734704),(27330,'cephalophus_sylvicultor_femur.tif',240,7,60,215.3294481,94.4525604,57.3431436,1.8,94.3319402,57.7433538,1.5026418,29.5964359,25.5838733,9645.1710477,13133.7928207,35.7217972,513.3621732,325.8896127,614.438435,0.9492181,7.3389832,1.4410938,15.6031549),(27331,'cephalophus_sylvicultor_femur.tif',240,7,61,213.5194395,94.4489759,56.9209433,1.8,94.3556911,57.3116957,1.4842898,28.7458328,21.9940485,9305.3012923,12735.076428,35.320929,579.0237502,323.7095739,608.9382601,0.6328121,5.0723746,1.6332151,10.6492317),(27332,'cephalophus_sylvicultor_femur.tif',240,7,62,212.3461481,94.4234061,56.5420794,1.8,94.2915613,56.9831882,1.4660513,16.0901926,19.8551349,8946.2004276,12395.2573426,35.0041493,624.2847216,556.0033159,952.7584537,0.316406,5.3882006,1.6295521,11.0199244),(27333,'cephalophus_sylvicultor_femur.tif',240,7,63,210.219965,94.3566862,56.1866329,1.8,94.2271838,56.6982407,1.464695,13.3497465,20.2413771,8656.3657811,12059.1050763,34.6437136,595.7650509,648.4292258,988.7680447,1.5820302,5.7040909,1.6262948,13.966838),(27334,'cephalophus_sylvicultor_femur.tif',240,7,64,208.0076547,94.3588122,55.8730681,1.8,94.2942485,56.3395569,1.4608295,12.4879433,16.8987038,8367.6143452,11694.1401051,34.2504007,692.0140277,670.0554406,1103.3545655,0.316406,0.7075054,2.0344439,1.5277435),(27335,'cephalophus_sylvicultor_femur.tif',240,7,65,202.9143109,94.3191843,55.529351,1.8,94.0657062,56.0145094,1.4574736,12.4950916,14.7428474,8028.1372251,11217.7152306,33.3866019,760.892041,642.5032695,1204.32998,21.1992042,26.2636067,1.9535398,78.0421186),(27336,'cephalophus_sylvicultor_femur.tif',240,7,66,201.2349646,94.2908638,55.2357578,1.8,94.01027,55.5925307,1.4542302,12.4746082,15.3687214,7787.9447088,10887.2145503,33.085502,708.400799,624.3037504,1133.3575533,0.9375316,4.221383,1.7975952,9.1982612),(27337,'cephalophus_sylvicultor_femur.tif',240,7,67,200.9887782,94.2742859,54.9355354,1.8,94.1212186,55.1731806,1.4485684,12.5508876,14.6155408,7596.2557978,10593.3091711,33.0001663,724.7976213,605.2365407,1135.3452154,0.6328121,5.7040909,1.6262948,11.9148558),(27338,'cephalophus_sylvicultor_femur.tif',240,7,68,199.1735818,94.2146145,54.6593779,1.8,93.9947006,54.8778696,1.4409106,41.078835,13.2790598,7410.9155556,10297.6535943,32.6387197,775.4806252,180.4071503,430.3705313,0.6328121,3.8100332,1.6539376,8.3801028),(27339,'cephalophus_sylvicultor_femur.tif',240,7,69,198.7037495,94.1900968,54.3797435,1.8,94.02905,54.5024793,1.4373551,13.1901223,13.579095,7254.4321212,10049.1508394,32.5310786,740.0456979,549.9897543,1141.0797466,0.316406,3.4948189,1.6614562,7.2230521),(27340,'cephalophus_sylvicultor_femur.tif',240,7,70,198.3640032,94.1639403,54.1007937,1.8,94.015152,54.2408852,1.4333314,14.1677546,15.062257,7142.3684509,9824.9481786,32.4398581,652.2892399,504.1284714,903.3695553,20.5663921,25.385546,1.967505,75.325524),(27341,'cephalophus_sylvicultor_femur.tif',240,7,71,198.6334886,94.137267,53.8471156,1.8,94.0064206,54.0102517,1.4325215,14.851823,13.3355452,7003.7751516,9640.4410597,32.4766293,722.9131547,471.5767985,1018.4586036,0.316406,2.2373285,1.7126934,4.6918038),(27342,'cephalophus_sylvicultor_femur.tif',240,7,72,198.4420608,94.1222687,53.5897401,1.8,93.974304,53.801012,1.4385296,13.3866328,15.1519106,6880.0549744,9458.850417,32.4984359,624.2678348,513.9496312,820.7753634,20.5663921,24.9720342,1.9607142,74.5073655),(27343,'cephalophus_sylvicultor_femur.tif',240,7,73,196.0273406,94.1455417,53.2567882,1.8,94.0863933,53.3900666,1.437147,13.1941254,12.8422686,6688.7595505,9174.3487293,32.0911118,714.3869203,506.9498257,993.9510935,0.6266536,3.2267211,1.7681919,6.8523593),(27344,'cephalophus_sylvicultor_femur.tif',240,7,74,194.67779,94.097212,52.9870814,1.8,94.0848802,53.02846,1.4364214,10.9933683,13.0015149,6564.3103585,8971.372471,31.863946,690.0251658,597.1154778,1183.2657735,20.498347,24.6411038,1.9942357,73.4270878),(27345,'cephalophus_sylvicultor_femur.tif',240,7,75,194.1771655,94.0463075,52.7177235,1.8,94.0253576,52.7516427,1.436352,11.1393282,13.16859,6446.6024538,8794.8208889,31.7814088,667.8635207,578.7245295,1150.1072048,20.2499861,24.3879071,1.9705774,72.9796221),(27346,'cephalophus_sylvicultor_femur.tif',240,7,76,193.6100114,94.0126632,52.4904109,1.8,94.01565,52.5331742,1.4310335,11.0053315,13.0495502,6351.8253271,8632.6877083,31.6421104,661.5314356,577.1589251,1147.0735809,20.2499861,24.3529894,1.9995744,72.423583),(27347,'cephalophus_sylvicultor_femur.tif',240,7,77,192.0591128,93.9935798,52.2608558,1.8,94.034677,52.3029635,1.4226842,11.0007518,12.9282298,6274.7358791,8465.5592291,31.3127655,654.8119417,570.391553,1134.8802701,20.2499861,24.2231498,1.9876944,72.1614636),(27348,'cephalophus_sylvicultor_femur.tif',240,7,78,190.5591807,93.9849685,51.9924821,1.8,94.004598,52.0431023,1.4165658,24.6250606,12.7646839,6224.4093251,8303.3249311,31.0103609,650.492011,252.7672698,529.6687359,20.2499861,23.9738911,1.963557,71.9761173),(27349,'cephalophus_sylvicultor_femur.tif',240,7,79,189.9818637,93.9848683,51.7372449,1.8,93.9956466,51.7672817,1.4126156,11.0357886,12.6707502,6182.0058459,8175.7015783,30.8779693,645.2421092,560.1779856,1117.4344178,0.316406,0.7075054,2.0344439,1.5277435),(27350,'cephalophus_sylvicultor_femur.tif',240,7,80,189.8588767,93.9808068,51.4922513,1.8,93.9977555,51.5729092,1.4111597,11.0022521,12.5536859,6139.593719,8093.0262366,30.8435832,644.6733079,558.0306335,1122.0580867,20.2499861,23.7388884,1.9389271,70.9726125),(27351,'cephalophus_sylvicultor_femur.tif',240,7,81,190.6845947,94.0026375,51.1326138,1.8,94.0463299,51.1837396,1.4163082,11.0112651,12.7014168,6074.6688087,8021.0560852,31.0282824,631.5087696,551.6776463,1099.8160701,20.2499861,23.6818871,1.9686707,70.7872661),(27352,'cephalophus_sylvicultor_femur.tif',240,7,82,191.4333776,93.9937113,50.8777322,1.8,94.0421207,50.9328515,1.4152382,10.9403315,12.6610609,6042.7909317,7958.2262803,31.1397089,628.5591981,552.3407534,1097.1728827,20.2326529,23.5610982,1.9562902,70.7872661),(27353,'cephalophus_sylvicultor_femur.tif',240,7,83,191.9567854,93.9784784,50.6546086,1.8,93.9717189,50.7590717,1.4156422,10.9207141,12.7481485,6030.7373938,7873.8515462,31.2288009,617.646675,552.2292163,1079.4902853,20.2499861,23.5164407,1.9862884,70.3398004),(27354,'cephalophus_sylvicultor_femur.tif',240,7,84,192.9493581,93.9760575,50.4336752,1.8,93.9810486,50.4619505,1.4116279,10.9178182,12.5612636,6053.7608771,7831.2959072,31.3503674,623.4480975,554.4844908,1100.5037078,0.316406,1.0005637,1.8925469,2.1605555),(27355,'cephalophus_sylvicultor_femur.tif',240,7,85,193.9961737,93.9527797,50.2288733,1.8,93.939469,50.3380015,1.4114547,10.87946,12.5553788,6065.9316619,7819.3654195,31.5187005,622.7900823,557.5581555,1094.1364207,20.2499861,23.2273063,1.9917869,70.231227),(27356,'cephalophus_sylvicultor_femur.tif',240,7,86,194.9577418,93.9495798,50.0131017,1.8,93.9702828,50.1112069,1.4024452,10.8969922,12.5665478,6071.6481295,7821.0994644,31.580706,622.3745448,557.1856891,1098.0411608,20.2499861,23.2682165,1.9614034,69.9691077),(27357,'cephalophus_sylvicultor_femur.tif',240,7,87,195.6669043,93.9518877,49.8014243,1.8,93.9692202,49.8860034,1.3929477,10.8230995,12.871897,6087.3198781,7826.6939463,31.5904851,608.0451048,562.4377636,1077.6694371,20.2499861,23.2682165,1.9614034,70.4165734),(27358,'cephalophus_sylvicultor_femur.tif',240,7,88,196.0806431,93.9395563,49.6144164,1.8,93.9329371,49.7400041,1.3867247,11.6187478,12.5816102,6099.9151677,7846.9585628,31.5852774,623.6847606,525.0062467,1100.1602208,0.316406,1.9246228,1.735945,4.0589917),(27359,'cephalophus_sylvicultor_femur.tif',240,7,89,195.8603343,93.9854826,49.3404795,1.8,94.0100981,49.4022336,1.3720436,10.997508,12.5523564,6065.8957434,7792.661678,31.3707796,620.8126544,551.5700256,1097.8981382,20.2499861,23.3905179,1.9739119,69.9691077),(27360,'cephalophus_sylvicultor_femur.tif',240,7,90,195.145347,93.9722887,49.1711192,1.8,94.0357562,49.3232887,1.3676612,10.9550219,12.7904441,6032.5833905,7793.158615,31.2005074,609.2953886,550.6683101,1072.9371308,0.316406,1.0005637,1.8925469,2.1605555),(27361,'cephalophus_sylvicultor_femur.tif',240,7,91,194.6837968,93.9793767,48.9846239,1.8,94.0200189,49.0928635,1.3653715,11.1310261,12.6008284,6014.7112991,7816.1046086,31.0971971,620.2849836,540.3555113,1092.2852111,0.316406,0.7075054,2.0344439,1.5277435),(27362,'cephalophus_sylvicultor_femur.tif',240,7,92,195.1376414,93.9994075,48.7980452,1.8,93.9845077,48.9136988,1.3679597,11.1777367,13.0136815,6057.650022,7818.9250985,31.2031095,600.8234584,541.9388718,1064.4658696,0.316406,1.6133605,1.7681919,3.4261797),(27363,'cephalophus_sylvicultor_femur.tif',240,7,93,195.406247,94.0043651,48.6325042,1.8,93.9979792,48.7659439,1.3689884,11.1379535,12.7459425,6091.4468628,7842.7183829,31.2592497,615.3109806,546.9089884,1089.7666957,0.316406,1.9246228,1.735945,4.0589917),(27364,'cephalophus_sylvicultor_femur.tif',240,7,94,194.4154339,93.9860241,48.4773793,1.8,93.9844518,48.6343612,1.3626285,11.1613295,12.8201759,6099.9816719,7830.1712316,31.0186102,610.7694064,546.5282322,1076.5791709,0.316406,0.7075054,2.0344439,1.5277435),(27365,'cephalophus_sylvicultor_femur.tif',240,7,95,193.7990122,93.9807861,48.345609,1.8,94.0281793,48.502219,1.3563991,11.0717805,13.2081562,6123.0841116,7849.3017551,30.8377454,594.2768736,553.0351774,1056.7057247,20.2499861,23.5610982,1.9562902,70.1544541),(27366,'cephalophus_sylvicultor_femur.tif',240,7,96,192.8557375,93.9755075,48.1898109,1.8,94.0179432,48.3056035,1.3488055,11.1024808,12.9082532,6125.3199641,7848.2607855,30.5844861,608.0033179,551.7073212,1077.1263382,20.2499861,23.5610982,1.9562902,70.4933464),(27367,'cephalophus_sylvicultor_femur.tif',240,7,97,191.6952484,94.0366599,47.9637358,1.8,94.0476322,48.1039814,1.3404016,11.215898,12.6314728,6101.629299,7795.1309532,30.2830848,617.1197214,544.0161175,1098.2162363,20.2499861,23.5610982,1.9562902,70.231227),(27368,'cephalophus_sylvicultor_femur.tif',240,7,98,191.138955,94.0366442,47.8484466,1.8,94.0646032,48.0008235,1.3309537,11.2535098,13.6511279,6113.7435921,7792.6742428,30.0588349,570.8447154,543.2743816,1018.613732,20.2499861,23.5164407,1.9862884,70.4165734),(27369,'cephalophus_sylvicultor_femur.tif',240,7,99,189.757156,94.0131639,47.7236525,1.8,94.0389492,47.8578668,1.3185341,11.3197085,12.6324055,6098.4807193,7768.4938105,29.6559513,614.96552,538.7489203,1080.2657661,20.2499861,23.5610982,1.9562902,70.4165734),(27370,'cephalophus_sylvicultor_femur.tif',240,7,100,188.8886322,94.0157887,47.6215678,1.8,94.06824,47.7268492,1.3111042,11.2721097,12.6534258,6102.34703,7823.7710162,29.4056314,618.312474,541.3668967,1100.4506973,20.2499861,23.645927,1.9985312,70.6019198),(27371,'cephalophus_sylvicultor_femur.tif',240,7,101,188.0380983,94.027948,47.5390823,1.8,94.0435945,47.6708575,1.2999931,11.467336,12.6463935,6115.0103731,7875.6350284,29.0970414,622.7573912,533.2546609,1106.0151452,20.2499861,23.7789185,2.0106389,70.6019198),(27372,'cephalophus_sylvicultor_femur.tif',240,7,102,187.4222834,94.0555118,47.4467373,1.8,94.054642,47.5653044,1.2919284,11.3396793,12.6377804,6143.2371007,7927.9102397,28.8701475,627.3182452,541.7469892,1111.5013015,20.2499861,23.8062688,1.9809237,71.0493855),(27373,'cephalophus_sylvicultor_femur.tif',240,7,103,187.9970217,94.0837968,47.3768911,1.8,94.0795756,47.4486419,1.2843984,11.2898479,12.9236278,6192.6269682,8023.7090975,28.8323038,620.855785,548.5128776,1096.5780832,20.2499861,23.9341871,1.9930475,71.2347318),(27374,'cephalophus_sylvicultor_femur.tif',240,7,104,187.9803362,94.1003023,47.3374759,1.8,94.1061208,47.4609049,1.2860787,11.3188581,13.1846555,6230.9566361,8131.5827469,28.8582017,616.7459381,550.4933941,1063.3712169,20.2499861,23.9341871,1.9930475,71.2347318),(27375,'cephalophus_sylvicultor_femur.tif',240,7,105,187.7419768,94.1733117,47.20357,1.8,94.1544796,47.299058,1.2784495,11.3884154,12.8578775,6228.8518473,8187.428029,28.6913743,636.7635752,546.9463174,1116.2916085,20.2499861,24.0655857,2.0050406,71.4200782),(27376,'cephalophus_sylvicultor_femur.tif',240,7,106,186.9389813,94.2138389,47.1236381,1.8,94.1986964,47.1911059,1.2722189,11.4724727,12.9296243,6245.4679534,8235.5976702,28.4605061,636.9556821,544.3872598,1116.2112136,20.2499861,24.200408,2.0169019,71.6821975),(27377,'cephalophus_sylvicultor_femur.tif',240,7,107,186.5606461,94.2321291,47.0573026,1.8,94.2245022,47.1464894,1.2736825,11.4184825,13.0787577,6265.3961537,8324.2988262,28.4284406,636.4747318,548.7065508,1109.6344419,20.5663921,24.2665069,1.9585665,71.8675439),(27378,'cephalophus_sylvicultor_femur.tif',240,7,108,185.3441545,94.2493331,46.983435,1.8,94.2780386,47.0777389,1.2740771,11.4570916,13.1438337,6285.757245,8400.7394649,28.249889,639.1392106,548.6346351,1111.8035727,20.5663921,24.3879071,1.9705774,72.0528903),(27379,'cephalophus_sylvicultor_femur.tif',240,7,109,184.8165601,94.2765663,46.9548132,1.8,94.2721599,47.0027721,1.2756914,11.4936352,13.1611551,6314.6986055,8533.7212971,28.1972149,648.4021528,549.4083013,1122.7075115,20.5663921,24.4862293,2.0113267,72.5771289),(27380,'cephalophus_sylvicultor_femur.tif',240,7,110,184.5878783,94.2871226,46.949101,1.8,94.2553039,46.9909814,1.2775587,11.5078207,13.1611152,6364.4660629,8660.2797076,28.1942069,658.0202023,553.0557177,1135.9341162,20.5663921,24.5127903,1.9824677,72.500356),(27381,'cephalophus_sylvicultor_femur.tif',240,7,111,184.416291,94.2838254,46.9070666,1.8,94.260932,46.9119698,1.2735012,11.4189764,12.9976645,6443.890215,8759.7815512,28.0985586,673.9504288,564.3141735,1160.4224138,20.8032157,24.6248471,2.0516836,73.3952874),(27382,'cephalophus_sylvicultor_femur.tif',240,7,112,184.0820357,94.2771577,46.8536278,1.8,94.2321316,46.8786525,1.2731679,11.5891817,13.0512579,6506.0653145,8879.8477273,28.0418997,680.3825184,561.3912611,1169.7369498,20.8032157,24.6796705,1.9655874,73.3952874),(27383,'cephalophus_sylvicultor_femur.tif',240,7,113,182.8707014,94.3546496,46.7391752,1.8,94.3478855,46.7810651,1.2749331,11.8622191,13.2274899,6502.6316437,8942.0132538,27.88746,676.017395,548.1800326,1156.3201494,20.8827981,24.8030848,1.9773632,73.3952874),(27384,'cephalophus_sylvicultor_femur.tif',240,7,114,180.9202618,94.4131431,46.6924321,1.8,94.3901566,46.7514479,1.2757706,11.6087064,13.3456483,6490.6121302,8998.489422,27.6040899,674.2639394,559.1158839,1146.5329401,20.8827981,25.0600769,2.0005586,73.8427531),(27385,'cephalophus_sylvicultor_femur.tif',240,7,115,179.9139161,94.4649504,46.6530468,1.8,94.4266455,46.7149884,1.2746197,11.7604802,13.3706034,6508.3994826,9083.2177,27.4313117,679.3423911,553.4127324,1153.0100521,20.8827981,25.0940106,1.9723769,74.2134458),(27386,'cephalophus_sylvicultor_femur.tif',240,7,116,180.0314727,94.4648704,46.6375596,1.8,94.4008406,46.745606,1.2721401,11.7622216,13.4834976,6571.6262364,9193.7233884,27.4075442,681.8500396,558.7062105,1152.7808935,20.8827981,25.3480533,1.9953577,74.6609115),(27387,'cephalophus_sylvicultor_femur.tif',240,7,117,181.2650745,94.4283014,46.6328734,1.8,94.3768135,46.7057298,1.2775755,11.7343969,13.5144705,6672.7299076,9345.6480421,27.6869585,691.5289818,568.6470269,1179.0305295,20.8827981,25.385546,1.967505,74.9230308),(27388,'cephalophus_sylvicultor_femur.tif',240,7,118,182.0903982,94.4023886,46.6361266,1.8,94.387927,46.6888783,1.2787712,11.6485091,13.4874023,6784.7591124,9465.4906693,27.833066,701.8023544,582.4572938,1185.6798661,20.9443954,25.3480533,1.9953577,75.3704965),(27389,'cephalophus_sylvicultor_femur.tif',240,7,119,183.1485296,94.413491,46.6144643,1.8,94.3992524,46.6416449,1.2787642,11.6356311,14.1090868,6871.0689597,9605.6294034,27.9946865,680.8115591,590.5196628,1163.6470643,20.9443954,25.5094699,1.9789454,75.3704965),(27390,'cephalophus_sylvicultor_femur.tif',240,7,120,183.3503023,94.4460686,46.607541,1.8,94.4100574,46.6202595,1.2722934,11.7532486,13.7267298,6927.1463055,9726.7791404,27.9154277,708.6013413,589.3814186,1201.7678121,20.9443954,25.6776703,1.9627439,75.7411893),(27391,'cephalophus_sylvicultor_femur.tif',240,7,121,184.1709541,94.5514894,46.5108053,1.8,94.537708,46.4917821,1.2674288,11.5386753,13.7572999,6941.5363506,9823.523256,27.9558319,714.0589623,601.5886735,1210.4954596,20.9148356,25.6776703,1.9627439,76.0033086),(27392,'cephalophus_sylvicultor_femur.tif',240,7,122,183.097381,94.569453,46.5492275,1.8,94.5209894,46.5616663,1.258107,11.7658514,14.0799882,6956.1844914,9937.045192,27.628503,705.7566398,591.2181163,1193.6284079,0.316406,0.7075054,2.0344439,1.5277435),(27393,'cephalophus_sylvicultor_femur.tif',240,7,123,183.2429996,94.5800944,46.5951682,1.8,94.5537595,46.617611,1.2570645,11.7612492,14.1311383,7009.8889652,10077.053505,27.6318112,713.109819,596.0156841,1207.4058238,0.316406,1.3045755,1.815775,2.7933676),(27394,'cephalophus_sylvicultor_femur.tif',240,7,124,183.9251924,94.6062716,46.6291101,1.8,94.6063863,46.627342,1.2657658,11.7471445,13.9438569,7091.4707832,10213.2080335,27.88939,732.4521574,603.6761348,1217.8591834,0.316406,1.0005637,1.8925469,2.1605555),(27395,'cephalophus_sylvicultor_femur.tif',240,7,125,186.2909786,94.5856887,46.6608427,1.8,94.5453722,46.6281499,1.2548544,11.8315436,13.7620733,7192.0390939,10426.7276467,28.0510166,757.6422138,607.8698915,1268.8666767,21.0140967,26.1872588,2.0074235,77.5310521),(27396,'cephalophus_sylvicultor_femur.tif',240,7,126,187.6862474,94.5961213,46.7431299,1.8,94.497028,46.6709187,1.2498652,11.8251331,49.2035908,7287.2782834,10652.7934165,28.1682993,216.50439,616.2533858,358.2290375,0.316406,0.7075054,2.0344439,1.5277435),(27397,'cephalophus_sylvicultor_femur.tif',240,7,127,188.7712575,94.6045554,46.7439722,1.8,94.5783374,46.6830734,1.2548951,11.7943209,14.0995794,7384.8936528,10780.7378421,28.4252442,764.614147,626.1397957,1271.0058862,0.316406,0.7075054,2.0344439,1.5277435),(27398,'cephalophus_sylvicultor_femur.tif',240,7,128,187.4396059,94.5777775,46.7642361,1.8,94.5210153,46.772441,1.2537675,11.8969261,14.0864715,7439.9934582,10838.476663,28.2038862,769.4245251,625.3710733,1285.5969648,0.316406,2.2373285,1.7126934,4.6918038),(27399,'cephalophus_sylvicultor_femur.tif',240,7,129,187.52634,94.627206,46.7220522,1.8,94.6815951,46.8060627,1.2428394,14.93621,51.3161986,7486.1957861,10996.1547054,28.0116048,214.2823319,501.2112017,345.815496,21.213755,26.7676511,2.0767467,78.6113298),(27400,'cephalophus_sylvicultor_femur.tif',240,7,130,188.4572371,94.6413751,46.7887246,1.8,94.7057483,46.8457286,1.2351964,14.5521482,51.3612365,7540.232314,11174.9484724,28.0027984,217.5755344,518.1525227,350.5833474,21.3130161,27.0281878,2.0449148,79.0587955),(27401,'cephalophus_sylvicultor_femur.tif',240,7,131,190.0820675,94.6713054,46.9066594,1.8,94.7548796,46.9358825,1.2331488,14.4577799,51.2697345,7620.4092733,11415.9435027,28.2037846,222.6643772,527.0801838,357.3610011,0.316406,1.3045755,1.815775,2.7933676),(27402,'cephalophus_sylvicultor_femur.tif',240,7,132,189.7556088,94.6897135,46.9781072,1.8,94.7376387,47.0321742,1.2183459,13.7046684,51.4047167,7691.1089159,11513.2308223,27.8573221,223.9722648,561.2035777,360.9823734,0.316406,1.3045755,1.815775,2.7933676),(27403,'cephalophus_sylvicultor_femur.tif',240,7,133,190.266093,94.7444484,47.0867788,1.8,94.7794699,47.0560843,1.1872743,12.0909879,51.6844041,7794.5800736,11636.5526533,27.2709226,225.1463059,644.6603174,366.073674,0.316406,1.3045755,1.815775,2.7933676);
INSERT INTO `slices_w` VALUES (27404,'cephalophus_sylvicultor_femur.tif',240,7,134,193.3186529,94.8287583,47.2585918,1.8,94.8408378,47.2584277,1.1604595,12.2075035,51.7988197,7939.8266781,11972.4634996,27.0924568,231.1339056,650.4054408,376.4791041,0.316406,1.3045755,1.815775,2.7933676),(27405,'cephalophus_sylvicultor_femur.tif',240,7,135,193.7795357,94.8435826,47.3220069,1.8,94.899982,47.2869534,1.1544107,12.2213164,14.6100441,8033.1298805,12145.3720217,27.0133221,831.3028982,657.3047964,1353.5392346,21.7146045,27.5127736,2.1013542,80.4011926),(27406,'cephalophus_sylvicultor_femur.tif',240,7,136,195.3632592,94.914745,47.4287088,1.8,94.8770182,47.3051372,1.1229407,12.5928963,14.4321078,8158.3173164,12411.8396434,26.4548499,860.0157273,647.8507482,1409.0119478,0.316406,1.0005637,1.8925469,2.1605555),(27407,'cephalophus_sylvicultor_femur.tif',240,7,137,197.610609,95.111445,47.5230025,1.8,95.0725567,47.4546689,1.0907085,12.4461217,14.7013123,8293.6133986,12680.0508707,25.9096494,862.5114942,666.3612662,1422.7389009,0.316406,1.6133605,1.7681919,3.4261797),(27408,'cephalophus_sylvicultor_femur.tif',240,7,138,199.2598002,95.1841544,47.6738065,1.8,95.1749521,47.5580848,1.0615468,12.6676193,14.7793942,8420.6613079,12912.0797036,25.3166945,873.6541924,664.7390545,1435.088491,0.316406,3.1798413,1.670465,6.59024),(27409,'cephalophus_sylvicultor_femur.tif',240,7,139,200.8535956,95.24974,47.821378,1.8,95.2795124,47.7812768,1.0362129,12.6905347,14.9770394,8569.1416662,13153.9138138,24.7862518,878.2719643,675.238819,1440.2606142,0.316406,1.9246228,1.735945,4.0589917),(27410,'cephalophus_sylvicultor_femur.tif',240,7,140,201.7194194,95.2739307,47.9771686,1.8,95.2842842,47.9202879,1.0257737,12.5623722,14.7915595,8705.6864479,13430.5789327,24.5836345,907.9893801,692.9970183,1488.1662245,0.316406,1.3045755,1.815775,2.7933676),(27411,'cephalophus_sylvicultor_femur.tif',240,7,141,204.171242,95.3207221,48.1396631,1.8,95.3316759,48.0594969,1.0143473,13.060325,15.4091319,8929.868499,13769.3493981,24.535663,893.5837191,683.7401437,1466.2008512,0.316406,3.1798413,1.670465,6.59024),(27412,'cephalophus_sylvicultor_femur.tif',240,7,142,206.843161,95.3869137,48.3628578,1.8,95.2889235,48.2203138,0.9957802,12.9195101,14.8215891,9250.8929874,14007.7403867,24.2774915,945.0903186,716.0405403,1544.8975304,0.316406,2.550947,1.6951513,5.3246159),(27413,'cephalophus_sylvicultor_femur.tif',240,7,143,210.8759464,95.430568,48.6081188,1.8,95.3510067,48.4705316,0.9762182,13.4908514,15.0977657,9662.8406782,14362.924945,24.1179366,951.3278475,716.2513605,1580.3857669,0.6328121,1.9246228,1.735945,4.3211111),(27414,'cephalophus_sylvicultor_femur.tif',240,7,144,213.4884652,95.4514526,48.8597547,1.8,95.3667767,48.7067116,0.9598477,13.2661142,15.083495,10123.4662736,14615.6734475,23.8726967,968.9845397,763.107125,1609.3732175,0.316406,3.1798413,1.670465,6.59024),(27415,'cephalophus_sylvicultor_femur.tif',240,7,145,218.3879845,95.4160429,49.08748,1.8,95.2735966,48.9550661,0.9352192,14.0998622,15.0345934,10847.3707043,14909.6593996,23.5709466,991.6902306,769.3245914,1687.8804778,1.2656241,4.7566257,1.6373645,12.3305211),(27416,'cephalophus_sylvicultor_femur.tif',240,7,146,224.4364041,95.2333442,49.433584,1.8,95.0970037,49.3264601,0.9114397,14.7435657,15.2674274,11909.882226,15140.9205057,23.3679771,991.7139342,807.8020253,1720.3864959,1.3004889,10.612581,1.3909428,24.0282302),(27417,'cephalophus_sylvicultor_femur.tif',240,7,147,229.5159748,95.0224346,49.7975329,1.8,94.8591847,49.6814532,0.8817955,14.8703276,15.2294517,12945.4385586,15301.0532909,22.7909832,1004.7015216,870.5550374,1813.0536446,1.3731953,7.0039461,1.2490458,16.0188201),(27418,'cephalophus_sylvicultor_femur.tif',240,7,148,232.2242681,94.8705918,50.0307415,1.8,94.7496899,49.8010335,0.730018,14.6312829,15.5130195,13747.0105661,15266.3150817,17.2129644,984.0969436,939.5629014,1854.277817,1.2335829,13.1260843,1.3024301,28.4579147),(27419,'cephalophus_sylvicultor_femur.tif',240,7,149,235.5067537,94.7624029,50.1989072,1.8,94.6162281,49.9845205,0.3942121,14.9547887,15.4738563,14255.9245355,15359.5136122,5.7902502,992.6105918,953.2682049,1858.5870723,1.42946,7.9101508,1.2870022,18.441495),(27420,'cephalophus_sylvicultor_femur.tif',240,7,150,241.9463109,94.7350614,50.2857113,1.8,94.5854914,50.0710057,0.1080203,15.0888324,15.2454249,14456.4869368,15974.6787949,0.4686931,1047.8342762,958.0918252,1905.3728799,1.0765891,7.0039461,1.2490458,15.3860081),(27421,'cephalophus_sylvicultor_femur.tif',240,7,151,244.8935704,94.5709799,50.4333219,1.8,94.5773293,50.2629067,-0.1190026,15.1486523,15.2428165,14441.0392327,16275.5519031,0.5752911,1067.7522656,953.2887133,1947.157734,1.2024933,6.7045236,1.2341215,15.0153154),(27422,'cephalophus_sylvicultor_femur.tif',240,7,152,244.4200066,94.4048161,50.4123245,1.8,94.5440295,50.2316755,-0.2754091,15.2694049,16.1147613,14224.0808729,16394.4129867,3.012547,1017.353762,931.541271,1886.7627879,0.9999932,9.0050736,1.2490458,19.7071192),(27423,'cephalophus_sylvicultor_femur.tif',240,7,153,243.2922817,94.4335315,50.3227392,1.8,94.5571562,50.0627181,-0.3511721,15.1738378,15.5181929,14135.1939329,16521.9118359,4.7983327,1064.6801414,931.55035,1933.6026702,1.3426158,15.3350877,1.1902899,33.194691),(27424,'cephalophus_sylvicultor_femur.tif',240,7,154,241.1106726,94.353115,50.2930065,1.8,94.5419379,50.0816977,-0.4387077,14.9014347,15.8760863,14052.0686001,16629.2214726,7.2505793,1047.4383386,943.0010516,1922.1296853,0.9146955,7.0039461,1.2490458,15.3860081),(27425,'cephalophus_sylvicultor_femur.tif',240,7,155,238.5379562,94.2621261,50.2450137,1.8,94.5091162,50.0833549,-0.5312701,14.8846288,15.9069781,13967.7720611,16718.7161278,10.2043644,1051.0303127,938.4024421,1924.4142177,26.9393483,29.7573103,0.1494157,94.3044298),(27426,'cephalophus_sylvicultor_femur.tif',240,7,156,239.9534296,94.2698868,50.2857096,1.8,94.5778586,50.1082003,-0.5377316,40.6881516,15.8942,14263.0436519,17100.0960259,10.4914699,1075.8701918,350.5453825,726.4296929,0.9585707,9.6387062,1.1659045,20.8641699),(27427,'cephalophus_sylvicultor_femur.tif',240,7,157,240.6511549,94.234582,50.2677172,1.8,94.5017151,50.0910578,-0.5931799,14.8339175,16.3086,14530.3290464,17486.1099999,12.5331768,1072.2017848,979.5341663,1953.2265621,0.9146423,4.1132784,1.1760052,9.1664608),(27428,'cephalophus_sylvicultor_femur.tif',240,7,158,242.5640674,94.2224465,50.3491942,1.8,94.5310929,50.1861233,-0.687763,14.8032755,16.0593046,15033.3654689,17873.482557,16.291579,1112.967406,1015.5431779,1999.1850665,27.6920045,30.5098116,0.7120008,98.4401945),(27429,'cephalophus_sylvicultor_femur.tif',240,7,159,243.9462305,94.2542418,50.3502148,1.8,94.5898704,50.2064078,-0.7506781,15.5208458,16.1523286,15661.406674,18426.2900475,18.9183467,1140.7822675,1009.0562644,2025.0633936,0.6328121,0.8949314,0.7853982,1.7898628),(27430,'cephalophus_sylvicultor_femur.tif',240,7,160,247.1149516,94.2814164,50.3732639,1.8,94.6260906,50.2424645,-0.8402208,15.9189861,16.5516636,16522.7708256,19255.4985541,22.8463082,1163.35729,1037.9285935,2092.5406237,0.6328121,1.1408182,0.9827937,2.4226749),(27431,'cephalophus_sylvicultor_femur.tif',240,7,161,251.9105357,94.3609678,50.3483291,1.8,94.7874212,50.2479667,-0.9749438,16.9097292,17.0259562,17276.1122354,20436.413319,28.7613905,1200.3092833,1021.6669969,2162.940382,0.8009049,3.0016912,1.2490458,6.7437859),(27432,'cephalophus_sylvicultor_femur.tif',240,7,162,255.0168531,94.3830753,50.4011001,1.8,94.8429886,50.2114227,-1.0827521,17.3730041,17.1721104,18035.6447047,21760.4538261,33.1578605,1267.1974133,1038.1419687,2270.0648965,0.316406,0.7075054,2.0344439,1.5277435),(27433,'cephalophus_sylvicultor_femur.tif',240,7,163,260.1557937,94.4210009,50.4044041,1.8,94.8678744,50.2486555,-1.1665987,17.5814001,17.5698307,18736.5400559,23453.3271686,36.6529112,1334.8635854,1065.7023875,2347.9903204,0.6328121,1.1408182,2.1587989,2.4226749),(27434,'cephalophus_sylvicultor_femur.tif',240,7,164,261.9656507,94.3560688,50.5120924,1.8,94.8595271,50.2737808,-1.2281679,17.5975429,18.4942944,19460.1387919,25025.0240239,38.7328559,1353.1213176,1105.8440873,2344.5859259,30.4777481,35.5784479,0.8988332,111.8827938),(27435,'cephalophus_sylvicultor_femur.tif',240,7,165,264.9920902,94.4151914,50.7754121,1.8,94.9023918,50.3906742,-1.3091415,17.9587602,18.8166084,20582.544554,27081.5983478,41.2100234,1439.2390931,1146.1005272,2372.0643531,30.6200704,37.1113389,0.8880662,115.6346937),(27436,'cephalophus_sylvicultor_femur.tif',240,7,166,272.8800367,94.525483,50.9870599,1.8,94.9437029,50.5315519,-1.3950632,18.2560423,20.544444,22094.2669438,29402.9157893,44.0898854,1431.1857636,1210.2440715,2387.7108297,0.6012466,1.4150108,1.1071487,3.0554869),(27437,'cephalophus_sylvicultor_femur.tif',240,7,167,281.2092984,94.7314427,51.3174086,1.8,95.044097,50.682944,-1.475399,17.7044145,22.5441745,23871.7465935,32514.4741243,46.4429777,1442.25614,1348.3499603,2420.9689691,31.2751786,40.9094769,1.7970155,124.8647553),(27438,'cephalophus_sylvicultor_femur.tif',240,7,168,290.7322685,94.857291,51.7386338,1.8,95.1578006,50.9059438,-1.5627677,17.5233935,24.5020399,25810.0649169,36011.3072791,48.4522548,1469.7269076,1472.8919364,2469.7181884,32.5898213,43.3660988,2.0899424,135.2968402),(27439,'cephalophus_sylvicultor_femur.tif',240,7,169,301.39974,95.0259187,52.3353033,1.8,95.3349981,51.3282519,1.5142297,17.5518394,26.3240003,28205.6666153,40430.1241674,50.0727258,1535.8655106,1606.992062,2582.1792962,0.9210223,2.4096766,1.1659045,5.4781618),(27440,'cephalophus_sylvicultor_femur.tif',240,7,170,311.6976739,95.2163442,53.0246187,1.8,95.5079954,51.8710401,1.4856525,18.0727823,27.49061,30430.8524845,45442.0698509,51.5739144,1653.0033288,1683.7945569,2735.7487247,0.998205,8.9100748,1.2827409,19.1828805),(27441,'cephalophus_sylvicultor_femur.tif',240,7,171,328.1239358,95.357462,53.8758094,1.8,95.7491262,52.9508644,1.442437,19.006485,28.8398492,33034.5984935,53165.2250893,53.7912259,1843.4640441,1738.0698509,2913.69632,0.6328121,1.1408182,2.1587989,2.4226749),(27442,'cephalophus_sylvicultor_femur.tif',240,7,172,364.7299604,95.9397879,55.7587662,1.8,96.3268634,54.9765845,1.3420511,21.1658916,31.0108143,37598.1803099,74306.8068523,57.6627062,2396.1578756,1776.3570293,3608.3841768,36.7103191,61.5529695,1.9169323,181.7619564),(27443,'cephalophus_sylvicultor_femur.tif',240,7,173,423.1237412,95.3539052,57.5686323,1.8,95.8481554,56.96631,1.4628792,22.8704969,32.4820652,47732.5934861,97847.8028703,69.7025163,3012.3639734,2087.0816062,4459.1831601,0.6328121,1.1408182,0.9827937,2.4226749),(27444,'cephalophus_sylvicultor_femur.tif',240,7,174,500.4309493,94.356893,59.4934405,1.8,95.3812882,58.4982255,-1.5571831,21.8739665,33.4924272,60618.604982,126234.2065978,83.3897025,3769.0372808,2771.2671525,5461.4440737,42.8072179,63.9930712,1.9347753,247.2246067),(27445,'cephalophus_sylvicultor_femur.tif',240,7,175,557.8430181,94.1302599,60.2573052,1.8,95.3315676,59.4249742,-1.5318042,23.8992845,34.107105,70069.729817,146615.1543651,92.8325524,4298.6689832,2931.8756304,6215.4618303,0.316406,1.6133605,1.7681919,3.4261797),(27446,'cephalophus_sylvicultor_femur.tif',240,7,176,596.2966696,94.1850556,61.0748342,1.8,95.3101075,60.1637309,-1.5321481,25.9472646,34.6077706,78230.2956396,159897.3937924,99.2344053,4620.2743162,3014.9727423,6366.6274454,0.316406,1.0005637,1.8925469,2.1605555),(27447,'cephalophus_sylvicultor_femur.tif',240,7,177,613.6224902,94.2287791,61.6827569,1.8,95.3126749,60.827526,-1.5378455,25.5748562,34.931219,83108.5032282,170249.6492914,102.1594144,4873.8536585,3249.6176121,6852.961072,1.4584916,3.0016912,1.2490458,8.7189951),(27448,'cephalophus_sylvicultor_femur.tif',240,7,178,629.1590225,93.9940359,62.0334855,1.8,95.2156919,61.2902113,-1.5276604,26.2514196,34.8870537,87210.7153098,178500.2118203,104.6648441,5116.5172502,3322.133308,7064.4122015,46.9376358,65.9249262,1.9441727,237.7006253),(27449,'cephalophus_sylvicultor_femur.tif',240,7,179,638.8964766,93.7659148,62.1106645,1.8,94.9510485,61.6174687,-1.5094597,26.4932836,34.2594428,91402.7619606,185292.4494781,106.0826408,5408.5073863,3450.0352382,7865.6974155,1.4804312,5.3789026,1.080839,15.9870197),(27450,'cephalophus_sylvicultor_femur.tif',240,7,180,650.3478312,93.5860564,62.1900039,1.8,94.7550138,61.7952475,-1.4904154,26.8977234,33.5699429,95341.436662,187585.6211124,107.6924849,5587.9040855,3544.5913076,8176.9654456,2.4821489,32.9199152,1.2581641,79.8133531),(27451,'cephalophus_sylvicultor_femur.tif',240,7,181,660.187188,93.4388975,62.2437561,1.8,94.5908045,61.977985,-1.4807724,26.970388,32.6499672,98533.0021682,186620.7960858,109.1418769,5715.8034782,3653.3772647,8425.1675954,1.6221666,9.7676751,1.1361261,24.3353221),(27452,'cephalophus_sylvicultor_femur.tif',240,7,182,663.4611488,93.4271706,62.2640884,1.8,94.4694281,62.167786,-1.4698488,27.10828,32.0171346,99844.0860749,181680.3182548,109.4538573,5674.4715118,3683.1582811,8416.7868555,2.4889964,32.0336693,1.2178059,80.7082845),(27453,'cephalophus_sylvicultor_femur.tif',240,7,183,653.7761781,93.5481265,62.4483182,1.8,94.4272069,62.3342466,-1.4798172,26.5708074,31.3524078,99491.607792,172118.4416477,108.0632771,5489.7997785,3744.3953609,8194.6221225,2.1064002,9.2247418,1.1839206,28.1003941),(27454,'cephalophus_sylvicultor_femur.tif',240,7,184,644.3326611,93.5625832,62.4540017,1.8,94.3386419,62.5032713,-1.4823372,26.4343309,30.9296874,98150.9180464,161187.435475,106.5506473,5211.4149554,3713.009356,7869.6685217,2.3855611,6.7119855,1.4288993,21.8040739),(27455,'cephalophus_sylvicultor_femur.tif',240,7,185,629.3940752,93.6169653,62.4022306,1.8,94.4157938,62.5097891,-1.4950948,26.9816133,30.0801052,94619.1588241,146301.2154359,104.2990128,4863.720201,3506.8013796,6160.3695965,1.2754367,9.6231138,1.0924439,21.7273009),(27456,'cephalophus_sylvicultor_femur.tif',240,7,186,609.694884,93.6182578,62.2991653,1.8,94.3980767,62.4727905,-1.5050912,25.7177098,29.2158161,88879.8559123,131391.5930916,101.1777518,4497.2761516,3455.9786474,6258.8220607,2.0960201,23.9237277,1.2197654,65.8465151),(27457,'cephalophus_sylvicultor_femur.tif',240,7,187,578.9486725,93.563506,62.2455587,1.8,94.3326994,62.4121148,-1.5080127,25.2469695,28.4628059,82571.488175,115158.6487703,96.1115965,4045.934513,3270.5504776,6301.8011715,1.5643071,11.0515876,1.1583859,26.4958777),(27458,'cephalophus_sylvicultor_femur.tif',240,7,188,548.2228476,93.5723181,62.1878912,1.8,94.2271752,62.357451,-1.5120156,24.5251702,27.3968931,76706.7644186,97975.7636611,91.0551373,3576.1633006,3127.675109,5902.7800092,1.7056355,12.4086039,1.2329181,30.4780964),(27459,'cephalophus_sylvicultor_femur.tif',240,7,189,511.2771373,93.7262665,62.2682471,1.8,94.2060327,62.3585939,-1.4257043,24.1743766,27.2006212,70788.0312797,80249.3795277,83.4315336,2950.2774514,2928.2257149,5250.9213219,1.3928272,8.7054795,1.237552,19.9692385),(27460,'cephalophus_sylvicultor_femur.tif',240,7,190,467.8813426,93.8741372,62.6580598,1.8,94.3073615,62.5535877,-0.3936196,26.5016118,26.7198593,62453.7789536,64326.7587612,11.4707432,2407.4512513,2356.6030386,4562.0279296,1.1020962,2.0259871,0.8960554,5.0306961),(27461,'cephalophus_sylvicultor_femur.tif',240,7,191,373.5640636,93.9882186,63.687583,1.8,94.3470267,63.2949049,-0.1575198,23.0260331,23.9105396,43700.7119558,51880.5771276,1.5321064,2169.7786028,1897.8827893,3604.0446813,1.0143647,4.3035873,0.942,9.3200068),(27462,'cephalophus_sylvicultor_femur.tif',240,7,192,248.5178046,95.7896599,65.0711733,1.8,95.3513552,64.7348249,-0.4005668,21.2149353,25.5102849,25550.1535797,34442.4070422,6.2979981,1350.1380769,1204.3474657,2338.9410436,0.316406,0.4474657,2.3561945,0.8949314),(27463,'cephalophus_sylvicultor_femur.tif',240,7,193,136.3825142,99.1179435,64.8018391,1.8,98.6080249,65.6324599,-1.2439329,21.2018781,22.2116712,11350.0502835,14051.6459503,20.3871721,632.6244352,535.3323054,950.19026,12.0451432,39.1692266,1.741257,98.0431575),(27464,'cephalophus_sylvicultor_femur.tif',240,7,194,39.4955828,101.7126316,58.9425599,1.8,102.3060753,62.8855774,1.3860975,4.6524112,19.8439743,129.6657772,3587.2448282,6.3605826,180.7724993,27.8706614,186.688957,8.9701606,33.9676281,1.7298195,84.8944779),(27465,'cephalophus_sylvicultor_femur.tif',240,7,195,3.4698785,101.0373618,52.5463537,1.8,100.9552208,52.7367495,-1.3757034,1.2252565,4.5320523,0.9208095,13.2402213,0.5565796,2.9214626,0.7515239,3.1245527,2.7953349,9.4392993,1.3339476,20.8959703),(27466,'cephalophus_sylvicultor_femur.tif',240,7,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27467,'cephalophus_sylvicultor_femur.tif',240,7,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27468,'cephalophus_sylvicultor_femur.tif',240,7,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27469,'cephalophus_sylvicultor_femur.tif',240,7,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27470,'cephalophus_sylvicultor_femur.tif',240,7,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27471,'cephalophus_sylvicultor_femur.tif',240,7,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27472,'cephalophus_sylvicultor_femur.tif',240,7,202,10.204374,109.3160534,71.4976973,1.8,109.3006565,71.5028544,1.527048,4.6267996,4.7862979,44.9366226,47.9326095,1.697476,10.0145479,9.7122474,19.0920677,9.492181,10.0056373,1.2490458,31.3730278),(27473,'cephalophus_sylvicultor_femur.tif',240,7,203,34.7036089,109.2666494,71.5854641,1.8,109.2734884,71.5890385,-0.8021206,7.2890712,7.3676622,392.2994685,401.4790056,2.9886711,54.4920481,53.8202273,107.6478892,14.5546775,15.0716917,0.8894981,48.7342451),(27474,'cephalophus_sylvicultor_femur.tif',240,7,204,58.7771217,109.2477677,71.5937673,1.8,109.2493904,71.5826399,-0.8197405,8.8969964,8.9931571,1071.5355776,1093.1292212,5.2342528,121.5512204,120.4379021,237.8081687,18.0351439,18.5415015,0.9307082,59.3516764),(27475,'cephalophus_sylvicultor_femur.tif',240,7,205,203.4455761,90.029473,72.8952737,1.8,90.2907822,72.4361787,-0.0605104,14.9755934,29.6017923,7991.3094294,58482.9818247,0.1240015,1975.6567861,533.6222209,2245.4086728,26.2829449,28.862405,1.7918434,102.3906129),(27476,'cephalophus_sylvicultor_femur.tif',240,7,206,555.8349985,86.0645838,72.4629665,1.8,91.3794202,72.35632,-0.037534,17.4389864,34.5451624,26507.0993671,96157.34677,0.1304494,2783.5256823,1519.990824,3549.5702278,29.109355,29.3780914,2.424789,96.0493201),(27477,'cephalophus_sylvicultor_femur.tif',240,7,207,583.3966832,86.7553634,72.4240736,1.8,92.3343408,72.3076178,-0.037372,17.7931063,34.5210977,28109.0743056,107904.2462577,0.1357386,3125.7478282,1579.7733038,3934.404979,28.792949,29.3780914,2.2876,95.7872007),(27478,'cephalophus_sylvicultor_femur.tif',240,7,208,601.0919503,87.3194935,72.4110084,1.8,93.0707188,72.2773535,-0.0370821,17.2137515,34.6004428,29380.0340908,117373.671815,0.1376961,3392.2592417,1706.7769427,4233.1933703,28.792949,29.4138509,0.5551786,95.6018544),(27479,'cephalophus_sylvicultor_tibia.tif',240,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27480,'cephalophus_sylvicultor_tibia.tif',240,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27481,'cephalophus_sylvicultor_tibia.tif',240,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27482,'cephalophus_sylvicultor_tibia.tif',240,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27483,'cephalophus_sylvicultor_tibia.tif',240,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27484,'cephalophus_sylvicultor_tibia.tif',240,8,6,0.3727996,64.0334917,50.4470289,1.8,63.9908489,50.3640966,1.0931703,0.5566328,1.7639882,0.0250871,0.2113536,0.0490046,0.1198157,0.0450693,0.134014,1.428686,3.4459791,2.0988708,7.5368527),(27485,'cephalophus_sylvicultor_tibia.tif',240,8,7,8.9150656,63.9129019,50.2468628,1.8,63.8843522,50.14607,1.0336696,1.5494628,4.204787,3.5491124,26.817788,1.096842,6.3779183,2.2905438,7.2219816,3.3608248,8.5531268,2.0863453,19.5738077),(27486,'cephalophus_sylvicultor_tibia.tif',240,8,8,35.7902341,66.9793245,50.24669,1.8,67.7267306,50.1681248,0.2865561,5.9692519,10.1445283,129.4696521,915.7219796,0.4765547,90.2675758,21.6894268,102.8010081,6.3243908,11.2308057,2.1036402,28.9497338),(27487,'cephalophus_sylvicultor_tibia.tif',240,8,9,91.2965795,68.2169958,49.8284212,1.8,68.420046,49.4464164,0.387464,8.5719994,10.3646464,648.9287686,2696.4196806,2.1723152,260.1554928,75.7033151,320.9723905,13.4845954,20.9684094,2.6620734,73.6394995),(27488,'cephalophus_sylvicultor_tibia.tif',240,8,10,156.5742642,67.7487903,48.637677,1.8,66.9192325,48.0549343,0.2944941,12.2173334,20.4502013,2331.2807222,6450.4042603,2.1985228,315.4200869,190.817476,395.106135,2.7087703,9.2045159,1.3258177,20.6760419),(27489,'cephalophus_sylvicultor_tibia.tif',240,8,11,299.179348,63.9532795,47.4324601,1.8,63.7342809,47.6338648,-0.0017419,12.9585852,18.6451443,7948.9831691,26484.5909211,0.0001514,1420.4551344,613.4144322,1673.5154988,24.7236658,37.9649692,0.2307166,157.4373469),(27490,'cephalophus_sylvicultor_tibia.tif',240,8,12,415.6882551,64.3687395,46.8415089,1.8,65.8093633,46.3931911,-0.1023289,21.5961872,28.1468991,19468.2890384,49535.069691,0.7229301,1759.8766231,901.4688016,2428.0228723,33.3387111,48.4479674,0.1542064,205.7906559),(27491,'cephalophus_sylvicultor_tibia.tif',240,8,13,517.6517134,68.4015381,46.7483973,1.8,68.8319549,45.6805267,-0.1199028,24.0992909,27.3371627,32685.6370597,94864.6989183,1.2344201,3470.1735439,1356.2904045,4468.1109899,37.6092287,51.609277,0.1011034,209.8445242),(27492,'cephalophus_sylvicultor_tibia.tif',240,8,14,537.8153519,69.41929,46.8440411,1.8,69.5929912,45.4634475,-0.1133448,29.07326,27.5983966,45284.8470114,103913.1901811,1.1466335,3765.1893901,1557.6116021,4699.8009663,41.0608259,53.4413222,1.0510745,259.8460213),(27493,'cephalophus_sylvicultor_tibia.tif',240,8,15,570.9588673,69.3638311,46.764099,1.8,69.873019,45.1420899,-0.0629246,29.5961356,29.1822305,60518.1668199,110108.7339863,0.376289,3773.1431812,2044.7996198,5314.3880911,43.5151115,53.4597399,2.428437,258.2769004),(27494,'cephalophus_sylvicultor_tibia.tif',240,8,16,590.8278646,69.0077908,46.6927774,1.8,69.9332931,45.2877906,-0.0035587,29.5492805,28.4491151,74786.5938778,110847.6724387,0.0012474,3896.3486928,2530.9108248,5266.4958567,0.496094,0.7015829,0.7853982,1.4031657),(27495,'cephalophus_sylvicultor_tibia.tif',240,8,17,560.6091899,69.6978257,46.4093155,1.8,70.1771048,45.5544904,0.1856229,29.2969112,29.8206789,77792.1533248,103828.3939045,3.1825717,3481.7582251,2655.3022169,5304.958561,47.309877,56.4223787,2.290867,259.0386695),(27496,'cephalophus_sylvicultor_tibia.tif',240,8,18,562.003548,70.888193,46.3211613,1.8,70.2897409,45.563484,0.3876555,30.9556951,32.6954351,75716.2094698,106492.6779823,13.3848928,3257.1115098,2445.9541056,4905.6743849,48.3117941,57.0108933,2.2761192,226.0393447),(27497,'cephalophus_sylvicultor_tibia.tif',240,8,19,541.3210291,71.026634,46.3745383,1.8,70.5258679,45.5391926,0.5764686,26.197857,34.4481041,73146.8814503,104141.6110052,26.8042012,3023.1449205,2792.0940816,5010.2296558,47.0612567,57.6819957,2.2495668,224.2458539),(27498,'cephalophus_sylvicultor_tibia.tif',240,8,20,492.3665225,70.7392964,45.6220498,1.8,70.7466642,45.1250341,0.6988465,25.3434205,31.4363212,67162.3902158,97475.8272995,33.9634348,3100.7390073,2650.0917697,5138.6215168,45.4418361,58.15155,2.2322136,227.5233494),(27499,'cephalophus_sylvicultor_tibia.tif',240,8,21,459.6569983,70.7784104,44.9368766,1.8,70.9464309,44.6132481,0.7876879,25.4500278,31.8140717,59409.4618882,95137.1049332,38.4801683,2990.4095828,2334.3574424,4694.6419146,43.3151604,58.4223098,2.1811745,215.3264882),(27500,'cephalophus_sylvicultor_tibia.tif',240,8,22,427.9881807,70.8660318,44.3416926,1.8,70.9777586,44.1016176,0.8356583,24.8151905,31.6254944,52296.7051235,91946.2456825,39.2447701,2907.3457204,2107.4472522,4356.7036141,41.1254254,58.5485511,2.1693743,237.6816974),(27501,'cephalophus_sylvicultor_tibia.tif',240,8,23,408.4346508,70.8763853,43.8577586,1.8,70.9236386,43.6311918,0.8613866,37.620379,32.3124388,47351.9808056,89559.1737603,39.1890524,2771.6624616,1258.678994,3639.2602664,0.496094,0.7015829,0.7853982,1.4031657),(27502,'cephalophus_sylvicultor_tibia.tif',240,8,24,391.4975979,70.8561051,43.4926902,1.8,70.7319921,43.2555034,0.8832624,37.9134378,33.3881764,43304.3479118,87028.9217969,38.9697102,2606.5790683,1142.1899567,3432.2072634,0.6020208,1.4463501,1.0303768,3.3024255),(27503,'cephalophus_sylvicultor_tibia.tif',240,8,25,377.968543,70.8215957,43.0099247,1.8,70.6203636,42.7937113,0.9014941,42.4437081,33.8299309,40120.9317006,83719.4420514,38.7452746,2474.7151392,945.2739532,2912.000086,38.8504418,57.8183675,2.1266671,232.239267),(27504,'cephalophus_sylvicultor_tibia.tif',240,8,26,368.3508169,70.5916415,42.2081071,1.8,70.1483166,42.1556275,0.9356272,38.298906,37.1503367,38298.7870465,79054.1651708,39.7805896,2127.9528604,999.9968929,3035.109385,38.4819882,57.4125671,2.2367656,176.859803),(27505,'cephalophus_sylvicultor_tibia.tif',240,8,27,350.3603045,69.7232943,41.0599188,1.8,69.1557155,41.2406401,1.0598841,21.3320084,32.4726586,35715.0804602,69283.5099405,44.4318333,2133.595243,1674.2483811,2982.5374444,1.2046886,4.4717309,1.2315037,10.2228116),(27506,'cephalophus_sylvicultor_tibia.tif',240,8,28,334.7842731,68.8054537,40.0314202,1.8,68.2894118,40.5805325,1.2350369,22.077919,31.937176,31859.8644384,61212.5901077,49.7399464,1916.6563155,1443.0646469,2557.2752885,1.4036084,6.8246742,1.237552,16.8525925),(27507,'cephalophus_sylvicultor_tibia.tif',240,8,29,322.4584874,68.1216524,39.2851333,1.8,67.805488,40.2083617,1.3813861,26.0449217,33.4323461,27359.1155488,56139.3143693,51.8379298,1679.1915876,1050.4587358,2271.2396101,0.9423239,5.7266097,1.2627435,12.557979),(27508,'cephalophus_sylvicultor_tibia.tif',240,8,30,312.2970089,67.524123,38.8102971,1.8,67.2369101,39.7713706,1.486218,26.8021358,33.0007637,23118.3280405,52308.0923857,51.6780524,1585.0570242,862.5554411,2095.0232731,1.0217786,7.462052,1.1964627,16.9978951),(27509,'cephalophus_sylvicultor_tibia.tif',240,8,31,300.222814,67.2955585,38.659155,1.8,66.9645939,39.6061612,1.5051084,23.5318567,27.8210763,21058.2338708,49577.1204266,49.8215403,1781.9986483,894.8819517,1938.484105,31.2989427,43.6992366,1.2292997,134.3143196),(27510,'cephalophus_sylvicultor_tibia.tif',240,8,32,289.9323892,66.980069,38.7884575,1.8,66.6666774,39.6139112,1.5241524,18.1060697,32.7435748,19510.0024191,46513.8144731,48.2170087,1420.5478388,1077.5393399,1839.5878794,0.9231423,7.2952812,1.259798,15.7400319),(27511,'cephalophus_sylvicultor_tibia.tif',240,8,33,279.8766631,66.7466369,38.9432304,1.8,66.5406926,39.6447256,1.5327126,17.866861,22.8044658,17976.4617737,42871.3742281,46.5784893,1879.9552036,1006.1343031,2627.3996354,1.0034173,8.7099472,1.2220253,19.0424574),(27512,'cephalophus_sylvicultor_tibia.tif',240,8,34,273.8372537,66.4986645,39.1171099,1.8,66.3707061,39.7419637,1.5387659,17.0439745,22.6714979,17007.2107975,40346.4763866,45.5927346,1779.6122942,997.8430099,2500.4783529,1.244846,6.126309,1.1978086,14.6627276),(27513,'cephalophus_sylvicultor_tibia.tif',240,8,35,269.8911341,66.2510804,39.286295,1.8,66.157838,39.8281477,1.5481293,17.1023309,22.3857404,16240.748331,38570.3861075,44.9587482,1722.9890744,949.6219198,2420.2790121,0.9847924,3.454895,1.2036225,7.8274578),(27514,'cephalophus_sylvicultor_tibia.tif',240,8,36,265.7181279,66.0380308,39.628891,1.8,65.9625598,40.0305485,1.5568472,18.3634581,22.2434775,15653.0493175,36953.0641912,44.277738,1661.2988774,852.4020513,2325.2476411,1.4756333,18.7550436,1.2197654,43.782694),(27515,'cephalophus_sylvicultor_tibia.tif',240,8,37,264.0577853,65.8438797,39.9337575,1.8,65.7813019,40.2893959,1.5612232,17.1489525,22.0578066,15234.2979406,35693.0324271,44.0055976,1618.1587322,888.3515143,2272.642784,1.6305172,24.0439317,1.1902899,53.9805755),(27516,'cephalophus_sylvicultor_tibia.tif',240,8,38,262.9838726,65.6719447,40.2249893,1.8,65.6261815,40.4480873,1.564087,20.9727334,29.336167,14944.2184925,34374.4990198,43.8286725,1171.7447279,712.5546409,1367.6098925,1.0384615,8.8917152,1.1695675,19.4534351),(27517,'cephalophus_sylvicultor_tibia.tif',240,8,39,260.943832,65.4547283,40.3832837,1.8,65.4490243,40.5616503,1.5688289,17.1252742,21.7747778,14624.4330914,33056.913162,43.4904702,1518.1286082,853.967819,2165.2138228,0.850582,4.7905833,1.199905,10.7790919),(27518,'cephalophus_sylvicultor_tibia.tif',240,8,40,260.1925089,65.2554814,40.558062,1.8,65.2574118,40.6750186,-1.5680955,16.1310025,21.468362,14354.6889063,31958.6272951,43.3651018,1488.6383665,889.8820076,2126.8675498,0.8163942,5.4400955,1.1479424,11.7712799),(27519,'cephalophus_sylvicultor_tibia.tif',240,8,41,259.4738512,65.1527068,40.7745606,1.8,65.2602927,40.8672296,1.5703652,16.6988866,21.1782747,14074.606986,30526.0585919,43.2456338,1441.3855229,842.8470302,2072.731259,1.4627975,12.5747843,1.186627,29.2403389),(27520,'cephalophus_sylvicultor_tibia.tif',240,8,42,255.4716858,64.9861102,40.9678683,1.8,65.113176,41.0507051,1.5694243,16.6094812,21.1206819,13719.556468,29104.8981965,42.5785342,1378.0283372,826.0075279,2007.418597,0.8087178,5.6672091,1.1659045,12.4728627),(27521,'cephalophus_sylvicultor_tibia.tif',240,8,43,252.730271,64.7914057,41.1541293,1.8,64.9733528,41.1584838,-1.5659866,16.1088193,20.8292978,13396.456905,27744.8380379,42.1207375,1332.0102405,831.6225226,1954.0094184,1.4575822,22.8970359,1.1701719,51.4399192),(27522,'cephalophus_sylvicultor_tibia.tif',240,8,44,252.2500223,64.6269646,41.3494475,1.8,64.7804278,41.3320622,-1.5655342,16.0263335,20.5320851,13179.7430468,26760.1110815,42.0405064,1303.3313936,822.3804316,1917.9196292,1.8007518,19.5438372,1.152572,47.2656783),(27523,'cephalophus_sylvicultor_tibia.tif',240,8,45,251.4348786,64.4329003,41.5052644,1.8,64.6576039,41.4862116,-1.5607936,16.0071503,20.2125042,13019.9066697,26002.9733875,41.9016205,1286.4795544,813.3806734,1896.9442408,0.7832714,3.7781394,1.1659045,8.3837381),(27524,'cephalophus_sylvicultor_tibia.tif',240,8,46,250.4540213,64.2590268,41.6089155,1.8,64.436858,41.5953305,-1.5559916,15.4551131,20.0851658,12824.9590868,25308.424403,41.7331885,1260.0555382,829.819815,1867.8764873,1.4030469,11.1068568,1.1571071,26.6996826),(27525,'cephalophus_sylvicultor_tibia.tif',240,8,47,250.9763696,64.0902789,41.7600062,1.8,64.2327667,41.7199868,-1.5563084,15.6233346,19.978724,12709.0099077,24776.7518775,41.8206156,1240.1568719,813.4633375,1848.7247743,0.9296321,8.437245,1.1466019,18.2557582),(27526,'cephalophus_sylvicultor_tibia.tif',240,8,48,253.2467835,63.8924197,41.8907388,1.8,64.055531,41.8200372,-1.5534099,15.5972243,19.8694255,12645.1842654,24388.5655757,42.1950396,1227.4419098,810.7329907,1843.1368856,1.7342294,20.6356621,1.1232764,45.8625126),(27527,'cephalophus_sylvicultor_tibia.tif',240,8,49,253.9875164,63.7932192,41.9343294,1.8,64.0412596,41.8828402,-1.5517442,15.6685045,19.6765632,12504.5132827,23853.11794,42.3158891,1212.2603761,798.0668027,1822.2928121,1.9311605,19.3030936,1.1186425,45.9828852),(27528,'cephalophus_sylvicultor_tibia.tif',240,8,50,255.6272007,63.6150858,42.0678936,1.8,63.9076618,42.0227223,-1.5433497,15.692607,19.6008387,12406.7375094,23542.6991078,42.5724468,1201.1067185,790.6103496,1804.470102,2.0056926,18.3118505,1.1374425,46.9750732),(27529,'cephalophus_sylvicultor_tibia.tif',240,8,51,256.4928528,63.4813087,42.1801765,1.8,63.8081736,42.1130004,-1.5430535,15.5702716,19.4767736,12292.0813047,23161.0559549,42.7159149,1189.1628677,789.4583744,1784.0525847,2.0120245,18.0870322,1.1316837,44.9906972),(27530,'cephalophus_sylvicultor_tibia.tif',240,8,52,256.5774435,63.3498326,42.3699501,1.8,63.7096937,42.2632674,-1.5483163,15.6711929,19.4004398,12163.6400527,22580.8787324,42.7413006,1163.9364353,776.1783137,1750.7377548,1.9670952,18.1938714,1.1193432,43.9383229),(27531,'cephalophus_sylvicultor_tibia.tif',240,8,53,256.2391924,63.2112992,42.5718811,1.8,63.541858,42.4674606,-1.5598486,15.2313947,19.0610323,12022.7644108,22038.0927724,42.7014137,1156.1856885,789.3410071,1732.9828852,25.188955,36.0906257,1.2273101,104.042259),(27532,'cephalophus_sylvicultor_tibia.tif',240,8,54,257.7038968,63.0671306,42.7597701,1.8,63.4153103,42.6655696,-1.5640873,15.3530104,18.9663772,11892.6388349,21674.0176336,42.9487163,1142.7600245,774.6128294,1736.5068739,0.7077202,4.4717309,1.2315037,9.6665313),(27533,'cephalophus_sylvicultor_tibia.tif',240,8,55,255.5793772,62.9385919,42.9316092,1.8,63.2918485,42.8258704,1.5693928,15.1889149,18.6208041,11695.293212,21265.3156657,42.596479,1142.0191932,769.9887236,1719.7359592,0.6287612,4.007322,1.1902899,8.6743432),(27534,'cephalophus_sylvicultor_tibia.tif',240,8,56,253.5139985,62.8166024,43.1239304,1.8,63.2203094,42.9936076,1.5583372,15.0098181,18.5418697,11524.2424828,20763.5084359,42.2457746,1119.8174069,767.7802872,1710.3224009,0.6923619,2.4429797,1.152572,5.2868015),(27535,'cephalophus_sylvicultor_tibia.tif',240,8,57,252.3078394,62.7177232,43.2750248,1.8,63.1121899,43.0951262,1.5435711,15.0179894,18.1874765,11308.3561651,20150.2356908,42.0201452,1107.9181733,752.9873583,1686.0987943,24.6683482,34.4499693,1.2786499,101.1508112),(27536,'cephalophus_sylvicultor_tibia.tif',240,8,58,252.8777315,62.6300131,43.457729,1.8,63.043359,43.2839499,1.5316075,14.8047508,18.0894714,11135.5203538,19779.6601004,42.081595,1093.4349384,752.1585833,1670.1791449,0.4439716,1.1092999,1.1071487,2.3953537),(27537,'cephalophus_sylvicultor_tibia.tif',240,8,59,252.4786616,62.4836634,43.6600815,1.8,62.8995026,43.4708869,1.5205679,14.7264931,18.0000084,11009.1267497,19299.5985847,41.9737034,1072.1994228,747.572875,1647.1849296,0.5420128,1.8890697,1.1659045,4.0891246),(27538,'cephalophus_sylvicultor_tibia.tif',240,8,60,251.9918127,62.3743157,43.905973,1.8,62.8357165,43.7377544,1.5019221,14.9551908,17.9203964,10908.2526523,18803.2650941,41.7997231,1049.2661381,729.395754,1626.8706964,24.2061649,33.4596926,1.3006431,98.8758301),(27539,'cephalophus_sylvicultor_tibia.tif',240,8,61,250.4662336,62.2947564,44.1430634,1.8,62.7740847,43.9513184,1.4801335,14.4042546,17.6227301,10770.7395037,18330.6358379,41.4021833,1040.1700394,747.7470942,1604.9004033,2.0858663,14.4315613,1.1455913,36.631889),(27540,'cephalophus_sylvicultor_tibia.tif',240,8,62,247.844275,62.1714867,44.3683074,1.8,62.6626764,44.1615711,1.4505989,14.3238923,17.322836,10593.2674348,17723.8229913,40.7134623,1023.1478853,739.5522966,1586.8889297,23.7657048,32.7271677,1.3258177,97.0616866),(27541,'cephalophus_sylvicultor_tibia.tif',240,8,63,247.1297005,62.045889,44.6762822,1.8,62.5178044,44.5111335,1.4158288,14.0853927,17.0731188,10479.8580709,17142.4482145,40.207042,1004.0607334,744.02314,1569.5747576,23.5772772,32.3128231,1.346299,96.1296849),(27542,'cephalophus_sylvicultor_tibia.tif',240,8,64,248.4608533,61.9295089,44.9761661,1.8,62.3540034,44.8077131,1.3843834,13.8011247,16.7898207,10395.386149,16671.9709752,39.9877407,992.9808806,753.2274617,1567.6248607,1.6232647,13.9105502,1.1869787,31.4302038),(27543,'cephalophus_sylvicultor_tibia.tif',240,8,65,248.1276922,61.8834305,45.2734786,1.8,62.28926,45.1840633,1.3476374,13.9640694,21.8790913,10215.3684496,16033.6629425,39.3291197,732.8303875,731.5466668,1168.5712514,0.5579313,4.3319547,1.3397057,9.2555535),(27544,'cephalophus_sylvicultor_tibia.tif',240,8,66,247.0578627,61.7743312,45.5526834,1.8,62.2199214,45.4813448,1.3218325,13.7196761,16.1463551,10048.4795179,15518.8590393,38.6763778,961.136982,732.4137547,1542.1024143,0.248047,0.7843935,1.8925469,1.6937709),(27545,'cephalophus_sylvicultor_tibia.tif',240,8,67,245.8866809,61.6610346,45.8095334,1.8,62.0711391,45.7547398,1.297143,13.191468,16.004117,9906.2576177,14980.793375,37.9880426,936.0587252,750.9594539,1535.3632189,0.9243337,3.017622,1.4056476,6.7750835),(27546,'cephalophus_sylvicultor_tibia.tif',240,8,68,246.7241236,61.5699776,46.0534366,1.8,62.0174936,46.0124112,1.2726272,13.2198196,15.5459561,9788.7915743,14627.6450047,37.5719243,940.9292614,740.4633229,1545.2177587,2.0991547,15.3007004,1.2234104,35.2536533),(27547,'cephalophus_sylvicultor_tibia.tif',240,8,69,246.2155724,61.4671987,46.2978787,1.8,61.8716827,46.2269763,1.2554331,13.008937,15.1383077,9666.3796564,14302.2153266,37.0882595,944.7697569,743.0568437,1540.8324063,1.95362,12.7158871,1.2120257,31.2849013),(27548,'cephalophus_sylvicultor_tibia.tif',240,8,70,244.7660634,61.3851312,46.5463369,1.8,61.8029917,46.4989908,1.2313936,12.8344898,14.803333,9562.1125348,13944.5621213,36.272765,941.9880037,745.032542,1533.114785,0.727473,5.7534073,1.4410938,12.4376064),(27549,'cephalophus_sylvicultor_tibia.tif',240,8,71,243.8634204,61.2916366,46.7773892,1.8,61.6947239,46.7293931,1.2063261,12.8304374,15.1768374,9454.2470355,13660.8689452,35.4797016,900.1130198,736.8608503,1519.8499167,1.1380151,12.2726879,1.3258177,27.5113117),(27550,'cephalophus_sylvicultor_tibia.tif',240,8,72,241.8572011,61.1891691,47.012625,1.8,61.5738824,46.9895364,1.1871467,12.6357146,14.8305686,9315.7976099,13389.1135079,34.66193,902.8051334,737.2592626,1524.9445582,0.496094,3.017622,1.4056476,6.7750835),(27551,'cephalophus_sylvicultor_tibia.tif',240,8,73,242.3599725,61.1596608,47.2498355,1.8,61.5651742,47.2690542,1.1636221,12.6742195,14.7878667,9166.4195525,13085.5533729,34.0584929,884.8844579,723.2334554,1373.6142588,1.3576583,9.9867802,1.3197936,23.131582),(27552,'cephalophus_sylvicultor_tibia.tif',240,8,74,242.7472777,61.126335,47.4692342,1.8,61.5560963,47.5004949,1.143196,12.5210988,14.7225776,9020.3992382,12880.7141451,33.5004808,874.8953117,720.4159489,1480.7843185,1.1505988,11.8700275,1.3815973,25.7822846),(27553,'cephalophus_sylvicultor_tibia.tif',240,8,75,242.9077148,61.0702321,47.682894,1.8,61.4932939,47.7024736,1.1238252,12.6827768,14.5022287,8897.2155508,12657.088599,32.920953,872.7685154,701.5195221,1466.4366733,1.2909814,9.3898159,1.357858,21.3174385),(27554,'cephalophus_sylvicultor_tibia.tif',240,8,76,243.4470297,61.0258369,47.873915,1.8,61.4099327,47.8852594,1.0959387,12.7136479,19.6160773,8806.6226175,12396.3673976,32.0927026,631.9493553,692.6904589,1077.975965,1.5665727,13.6222752,1.3876855,30.1620143),(27555,'cephalophus_sylvicultor_tibia.tif',240,8,77,240.9457206,60.9446704,48.0770681,1.8,61.306927,48.0679241,1.071499,12.1800501,14.1986685,8701.1017999,12140.6393845,30.9511703,855.0547819,714.3732348,1317.526942,1.6105138,10.2452721,1.4494443,24.1487),(27556,'cephalophus_sylvicultor_tibia.tif',240,8,78,239.5151546,60.8695354,48.3515664,1.8,61.2580183,48.354797,1.0514332,12.0627238,14.062556,8616.1106808,11921.1126555,30.0854637,847.7201925,714.2757167,1442.2486898,1.1793098,10.8971427,1.3644724,24.0033974),(27557,'cephalophus_sylvicultor_tibia.tif',240,8,79,239.649974,60.7899802,48.5803414,1.8,61.0922587,48.5903148,1.0303608,12.3287683,13.2927592,8564.2588278,11716.6370211,29.3683036,881.430021,694.6564841,1427.1697905,0.8587386,9.0969357,1.3787483,19.5032951),(27558,'cephalophus_sylvicultor_tibia.tif',240,8,80,239.6075947,60.7780993,48.7843163,1.8,61.1242103,48.7697885,1.0184957,11.9298816,13.989431,8488.7445656,11588.4248819,28.9424161,828.3699933,711.5531285,1200.7649627,1.4289159,7.8321602,1.3796119,17.8697105),(27559,'cephalophus_sylvicultor_tibia.tif',240,8,81,239.8948713,60.8143565,48.9583065,1.8,61.1761376,48.9652056,0.9921002,12.0733149,13.9562273,8371.0667723,11351.7133242,28.0222994,813.379794,693.3528074,1384.7212438,0.83044,7.9992755,1.4464413,17.1079413),(27560,'cephalophus_sylvicultor_tibia.tif',240,8,82,238.5463604,60.8079977,49.1287887,1.8,61.1431665,49.1503985,0.9692268,11.9760366,13.6491721,8201.2195244,11176.3293488,27.0239295,818.8283729,684.8024742,1393.294066,1.5234998,11.8700275,1.3815973,27.7417306),(27561,'cephalophus_sylvicultor_tibia.tif',240,8,83,235.4337494,60.7933469,49.3239431,1.8,61.1957166,49.3728768,0.9529926,12.6399172,18.2050661,8015.9914292,10942.5499266,26.073258,601.0716928,634.1806913,939.544797,1.240235,7.2104495,1.5019398,15.8251482),(27562,'cephalophus_sylvicultor_tibia.tif',240,8,84,232.9732162,60.7910987,49.5050565,1.8,61.171804,49.5195474,0.9328245,11.8616905,13.8416894,7855.6448613,10796.6824427,25.0562477,780.0119013,662.2702604,1281.7541612,1.3039719,11.2963557,1.4164776,24.7900965),(27563,'cephalophus_sylvicultor_tibia.tif',240,8,85,232.7512517,60.7978366,49.7278146,1.8,61.1476734,49.7683685,0.9051743,11.9696472,13.5680246,7735.7513027,10675.2834794,23.9979679,786.7971768,646.2806466,1161.2220327,0.818487,6.2456639,1.4513674,13.4297944),(27564,'cephalophus_sylvicultor_tibia.tif',240,8,86,233.9309914,60.8231331,49.949208,1.8,61.1381583,49.9632492,0.8819948,11.9651604,13.5860776,7648.3161742,10570.0183772,23.2370237,778.0036782,639.2155146,1302.9654201,0.8391548,6.4920113,1.4559197,13.9258884),(27565,'cephalophus_sylvicultor_tibia.tif',240,8,87,235.0194469,60.8699631,50.1597139,1.8,61.1671292,50.1663855,0.8579797,12.0554469,13.5179882,7569.7448098,10466.7618089,22.4179918,774.2839903,627.9107592,1301.944002,0.6821814,6.4920113,1.4559197,13.9258884),(27566,'cephalophus_sylvicultor_tibia.tif',240,8,88,234.2898075,60.9140614,50.3597533,1.8,61.18588,50.3479451,0.8394474,12.0633959,13.4342782,7457.4406895,10315.6159688,21.6305738,767.8578474,618.1875128,1292.9732187,0.6511954,5.9994566,1.4464413,13.3446781),(27567,'cephalophus_sylvicultor_tibia.tif',240,8,89,231.6487195,60.9601575,50.4780189,1.8,61.2641103,50.5076223,0.8247586,12.0572551,13.8703562,7318.9788854,10130.3821383,20.8221245,730.3620773,607.0186642,1252.9185298,1.9428846,11.9706774,1.467004,27.9721494),(27568,'cephalophus_sylvicultor_tibia.tif',240,8,90,229.9450282,60.9802004,50.6505235,1.8,61.292977,50.693795,0.8186657,12.1037207,13.8749386,7212.3209127,9998.9894677,20.4360955,720.6510787,595.8763519,1160.1551069,1.4423202,9.7024117,1.4940244,21.8986488),(27569,'cephalophus_sylvicultor_tibia.tif',240,8,91,229.3893806,61.0217284,50.8382931,1.8,61.3353902,50.8533901,0.7981096,12.4771646,13.5043003,7132.4293462,9862.74196,19.6017058,730.3408351,571.6386377,1226.4617108,1.4675375,10.4915379,1.4523064,23.3869308),(27570,'cephalophus_sylvicultor_tibia.tif',240,8,92,228.4893292,61.059285,51.0241161,1.8,61.388183,51.0544684,0.7802951,12.197591,13.1807147,7053.5589122,9751.1045366,18.84645,739.8008967,578.2747511,1234.1712299,1.5558226,9.9990943,1.6951513,23.3018145),(27571,'cephalophus_sylvicultor_tibia.tif',240,8,93,228.2379062,61.1105428,51.211911,1.8,61.419403,51.2364124,0.7627089,13.5456721,13.2297002,6986.0732901,9645.5753965,18.1570302,729.0849539,515.7420952,985.2273855,0.248047,0.3507914,2.3561945,0.7015829),(27572,'cephalophus_sylvicultor_tibia.tif',240,8,94,228.5347848,61.1833957,51.3998516,1.8,61.4810594,51.4617814,0.7426992,13.6883305,13.0469169,6933.178615,9561.2320785,17.4201738,732.8345972,506.5028658,947.7016419,0.9204238,9.9342747,1.6207547,21.8986488),(27573,'cephalophus_sylvicultor_tibia.tif',240,8,95,228.1774603,61.2504189,51.587009,1.8,61.5090686,51.6407256,0.722872,12.0945789,12.7088597,6862.163098,9439.8629985,16.6431377,742.7781266,567.3751144,1025.9255219,1.240235,9.6865451,1.5195592,22.3947428),(27574,'cephalophus_sylvicultor_tibia.tif',240,8,96,227.8009131,61.3200643,51.7703815,1.8,61.5763992,51.8146668,0.7036961,18.6460845,12.7692596,6785.9082499,9308.8856017,15.8952267,729.0074668,363.9320758,767.8744425,1.1200383,10.9394071,1.6388728,23.8830248),(27575,'cephalophus_sylvicultor_tibia.tif',240,8,97,227.0898624,61.4478639,51.9106127,1.8,61.7315682,51.964559,0.692058,12.3465145,15.0697507,6696.1975369,9142.8488763,15.4118708,606.7020651,542.3552972,1031.9311231,1.4682927,10.1971154,1.6438369,23.3869308),(27576,'cephalophus_sylvicultor_tibia.tif',240,8,98,225.4812028,61.5396945,52.0967867,1.8,61.8465634,52.1367916,0.6789885,12.2044767,13.2181348,6592.1073207,8957.3763484,14.8213202,677.6581174,540.1384656,1071.4311186,1.8752334,12.4642076,1.670465,28.092522),(27577,'cephalophus_sylvicultor_tibia.tif',240,8,99,223.1264779,61.646712,52.2736258,1.8,61.9556792,52.3202494,0.6681661,12.0997957,13.0017163,6480.0645527,8793.4587009,14.2741102,676.3306084,535.5515674,1071.3889462,0.248047,0.55465,2.0344439,1.1976769),(27578,'cephalophus_sylvicultor_tibia.tif',240,8,100,221.28325,61.7670534,52.4476609,1.8,62.0474174,52.5313833,0.6514268,12.4572882,12.6040606,6385.3126982,8616.2080239,13.5582421,683.6057262,512.5764598,1135.4217111,1.6507874,11.2061256,1.6594522,26.5440537),(27579,'cephalophus_sylvicultor_tibia.tif',240,8,101,220.0886506,61.8879542,52.6107991,1.8,62.1447685,52.7099457,0.6299315,12.0741162,13.8223698,6311.419698,8479.6791349,12.7294251,613.4750592,522.72312,1026.7899481,1.5340526,10.2182119,1.6680495,24.5596777),(27580,'cephalophus_sylvicultor_tibia.tif',240,8,102,219.1348467,62.01715,52.7846432,1.8,62.2459454,52.8908394,0.5974108,12.6700182,12.5351839,6225.6273379,8346.3365285,11.556088,665.832795,491.3668823,1095.4520398,1.6171134,9.9342747,1.6207547,24.5596777),(27581,'cephalophus_sylvicultor_tibia.tif',240,8,103,219.1666172,62.1553352,52.9528339,1.8,62.3776799,53.0535603,0.5688001,12.6980563,13.0941387,6162.4435982,8260.1638266,10.5971836,630.8291055,485.3060525,1088.3686037,1.3492199,9.2078575,1.6517004,20.1446916),(27582,'cephalophus_sylvicultor_tibia.tif',240,8,104,219.1930553,62.2789474,53.0974016,1.8,62.4643778,53.1971017,0.5430492,15.0055067,12.7728135,6103.4940194,8158.73925,9.7551668,638.7581912,406.7502779,918.8296163,0.8391466,9.0154081,1.7088024,19.0923173),(27583,'cephalophus_sylvicultor_tibia.tif',240,8,105,217.8043278,62.4556971,53.2024542,1.8,62.6823336,53.3308406,0.5220155,12.755162,12.6499452,6001.9499219,8008.2426409,9.0254533,633.0654012,470.5506607,1053.6204366,1.7732213,9.7024117,1.6475682,24.4745614),(27584,'cephalophus_sylvicultor_tibia.tif',240,8,106,216.7699977,62.5771353,53.3569908,1.8,62.7710358,53.4621757,0.503114,12.7131017,12.7491763,5932.2809451,7898.7376307,8.3989122,619.548857,466.6273504,997.9911098,2.2849653,13.786148,1.7152379,35.9199798),(27585,'cephalophus_sylvicultor_tibia.tif',240,8,107,216.2969832,62.7063927,53.5135928,1.8,62.9181677,53.6337454,0.4848721,13.1349633,12.6555894,5861.1352336,7786.5777598,7.8315641,615.2678881,446.2239505,977.8677445,1.8534635,10.9843099,1.6839473,26.60424),(27586,'cephalophus_sylvicultor_tibia.tif',240,8,108,216.5816123,62.8304869,53.6750804,1.8,62.999034,53.8084477,0.4618315,16.8140414,12.7594988,5810.5735797,7705.6616338,7.1670139,603.9156982,345.5786409,788.8326457,1.7145007,6.8606411,1.7894653,19.4534351),(27587,'cephalophus_sylvicultor_tibia.tif',240,8,109,216.0116829,62.9629366,53.8411128,1.8,63.1656543,54.0148162,0.4326695,16.1666552,12.694973,5737.6320697,7604.0547846,6.3294661,598.9815618,354.905328,807.4572163,2.3226916,11.5068146,1.7004989,30.5480621),(27588,'cephalophus_sylvicultor_tibia.tif',240,8,110,214.7498882,63.0982418,53.9791538,1.8,63.3144347,54.1441877,0.4137399,15.4473517,12.3880185,5656.0484563,7527.3804871,5.785122,607.6339383,366.1500415,845.8505595,1.6312323,12.7690009,1.7071989,27.7666606),(27589,'cephalophus_sylvicultor_tibia.tif',240,8,111,214.0693774,63.2312647,54.1166802,1.8,63.4134462,54.2622299,0.3946868,16.4767089,12.0996695,5609.6560197,7462.9420982,5.2752022,616.7889221,340.4597386,792.0154494,1.4440918,7.4785246,1.670465,21.3174385),(27590,'cephalophus_sylvicultor_tibia.tif',240,8,112,213.8641931,63.3754163,54.2478908,1.8,63.5479221,54.4270376,0.3815334,16.6488347,12.7153559,5566.6916887,7431.4040174,4.9416918,584.4432592,334.359239,775.1321552,1.240235,4.2240882,1.6295521,10.102439),(27591,'cephalophus_sylvicultor_tibia.tif',240,8,113,212.2767138,63.5935927,54.3118321,1.8,63.7310752,54.5521665,0.3669212,14.503951,12.7925821,5484.919901,7343.9277501,4.553221,574.0770471,378.1672937,884.2160476,1.926265,11.0150745,1.706324,28.5034998),(27592,'cephalophus_sylvicultor_tibia.tif',240,8,114,211.0318298,63.7583895,54.427281,1.8,63.8994667,54.6481441,0.3490405,14.1249293,12.668909,5404.3504299,7269.5739398,4.1137666,573.8121539,382.6107957,896.2430348,2.0386004,11.8258863,1.7393933,33.4644398),(27593,'cephalophus_sylvicultor_tibia.tif',240,8,115,210.4535849,63.9093593,54.5382704,1.8,64.0636412,54.7558489,0.3406438,13.8395512,12.8507504,5334.2569407,7210.4217873,3.9150943,561.0895516,385.4356869,890.5102974,1.9345454,12.8050886,1.7263912,29.9066655),(27594,'cephalophus_sylvicultor_tibia.tif',240,8,116,209.7778099,64.0575507,54.6609671,1.8,64.226674,54.8959961,0.3195302,13.4324532,12.6140906,5249.7037925,7139.6647512,3.4498567,566.0070926,390.8224149,895.174725,1.6111964,9.0154081,1.7088024,22.5753017),(27595,'cephalophus_sylvicultor_tibia.tif',240,8,117,209.121388,64.2035796,54.7703841,1.8,64.3416632,55.0295079,0.3015178,13.7181857,12.7220159,5176.1519097,7092.8144844,3.0737741,557.5228448,377.3204434,872.6308615,1.6959856,8.3197494,1.7506498,20.3252505),(27596,'cephalophus_sylvicultor_tibia.tif',240,8,118,208.5491653,64.3562285,54.875699,1.8,64.5209876,55.1402546,0.2875802,13.1462627,12.2417156,5118.2580188,7060.0053621,2.7962087,576.7169889,389.331792,913.0709081,1.3936456,9.8752617,1.773118,22.164324),(27597,'cephalophus_sylvicultor_tibia.tif',240,8,119,207.6178842,64.5146268,54.9703626,1.8,64.6577268,55.2081891,0.2738596,14.0297268,12.7871388,5028.8521579,7026.6334783,2.5309582,549.5078766,358.4426289,857.203933,1.2689853,8.6104828,1.7738415,19.0673873),(27598,'cephalophus_sylvicultor_tibia.tif',240,8,120,206.7169378,64.6684217,55.0676585,1.8,64.7859931,55.2924796,0.2601904,14.93495,12.6283355,4963.2939256,6990.012744,2.2802615,553.5181372,332.3274549,792.4875698,0.8757378,8.2789751,1.7211678,18.015013),(27599,'cephalophus_sylvicultor_tibia.tif',240,8,121,204.6018338,64.873791,55.1164102,1.8,65.0092676,55.4063455,0.25394,12.8621787,11.7931728,4877.7037847,6907.8176901,2.152114,585.7471802,379.2284274,891.208597,1.7085475,11.337132,1.746736,25.636982),(27600,'cephalophus_sylvicultor_tibia.tif',240,8,122,202.0694814,65.0149348,55.2117649,1.8,65.1249406,55.5027427,0.2454547,13.1599308,12.6324989,4785.3742313,6821.5343468,1.9886248,539.9988091,363.632173,872.0680351,1.7654407,10.118372,1.7681919,27.2207066),(27601,'cephalophus_sylvicultor_tibia.tif',240,8,123,200.410388,65.1651863,55.3049835,1.8,65.2930834,55.6167169,0.2355231,13.4032088,11.6971915,4710.5583682,6767.3934938,1.818825,578.5485774,351.4500485,855.6728232,0.496094,0.7015829,2.3561945,1.4031657),(27602,'cephalophus_sylvicultor_tibia.tif',240,8,124,199.5686011,65.3176677,55.4076527,1.8,65.4199277,55.7032657,0.2318374,13.7083231,11.6447149,4640.7764005,6733.074906,1.755954,578.2086505,338.5371326,788.4316537,1.7145007,8.8535755,1.7681919,21.8737188),(27603,'cephalophus_sylvicultor_tibia.tif',240,8,125,198.7425317,65.4728775,55.5087079,1.8,65.5684955,55.7884396,0.228508,13.3265738,12.4967007,4583.42113,6703.298448,1.699692,536.4054557,343.930947,843.4172229,1.1111827,6.6187195,1.7975952,15.038449),(27604,'cephalophus_sylvicultor_tibia.tif',240,8,126,197.8112505,65.6347753,55.6110555,1.8,65.7105704,55.8861252,0.2235952,13.9271431,12.4862405,4520.4220966,6676.3329076,1.620971,534.6952055,324.5764098,801.6453805,1.1647577,10.0328803,1.7196863,22.3096265),(27605,'cephalophus_sylvicultor_tibia.tif',240,8,127,197.1345619,65.7898834,55.7166564,1.8,65.8569747,56.0075656,0.216086,12.9625372,11.5638652,4461.6437755,6653.6169036,1.5104096,575.3800139,344.195254,855.987385,0.9440286,6.2751479,1.8925469,14.4572387),(27606,'cephalophus_sylvicultor_tibia.tif',240,8,128,195.9479983,65.9297742,55.8102322,1.8,66.0136328,56.063377,0.2047449,13.8201341,11.5746011,4389.3151845,6594.7982712,1.3500158,569.7646255,317.6029363,787.4472195,1.0292094,8.8535755,1.7681919,19.2126899),(27607,'cephalophus_sylvicultor_tibia.tif',240,8,129,194.3361691,66.1338261,55.8255669,1.8,66.2520648,56.0444935,0.2014022,12.5301885,11.5174396,4326.966625,6510.1292161,1.2961361,565.2410111,345.3233451,838.4976619,0.9916126,6.6187195,1.7975952,14.542355),(27608,'cephalophus_sylvicultor_tibia.tif',240,8,130,192.1595191,66.2767062,55.8872292,1.8,66.4209895,56.1309116,0.1933544,13.8364535,11.5455007,4235.2938599,6438.9829732,1.1824963,557.7049585,306.0967796,757.7115874,0.248047,0.3507914,2.3561945,0.7015829),(27609,'cephalophus_sylvicultor_tibia.tif',240,8,131,189.6724545,66.4186234,55.9669469,1.8,66.5163119,56.246947,0.187598,13.1553508,11.515328,4146.7331782,6376.8817679,1.0995346,553.7733502,315.2126635,789.290704,1.8037348,10.7693542,1.8269477,24.7651666),(27610,'cephalophus_sylvicultor_tibia.tif',240,8,132,187.1536754,66.5887695,56.0566338,1.8,66.6847752,56.3287627,0.1740549,12.1612252,12.1746563,4078.7834891,6307.25122,0.9354692,518.0640063,335.3924819,815.963547,1.253826,9.4453484,1.8094056,20.6158557),(27611,'cephalophus_sylvicultor_tibia.tif',240,8,133,185.9986958,66.7396259,56.1536208,1.8,66.8570879,56.4666916,0.1661426,13.6141447,11.3866451,4036.2321168,6251.8907053,0.8478539,549.0546741,296.4734252,728.306209,1.0349426,8.0758253,1.7561443,17.9298968),(27612,'cephalophus_sylvicultor_tibia.tif',240,8,134,185.6211978,66.8628089,56.2312004,1.8,66.9606643,56.5430996,0.1667801,12.9403624,11.4603762,4007.2294534,6220.4029838,0.8525781,542.7747638,309.6690295,786.5062335,1.4555916,5.4907545,1.8925469,14.5776113),(27613,'cephalophus_sylvicultor_tibia.tif',240,8,135,184.418954,66.9855858,56.2884634,1.8,67.0949437,56.5682538,0.1622828,13.3859349,11.2905372,3955.867073,6165.6431231,0.8023861,546.0894376,295.5241536,733.493549,0.9033547,4.8733504,1.82812,10.8642081),(27614,'cephalophus_sylvicultor_tibia.tif',240,8,136,183.6341638,67.0981029,56.3603932,1.8,67.1892462,56.6543341,0.1632239,12.8872007,11.327567,3922.5069184,6119.515857,0.8081829,540.2321507,304.3723004,747.6192245,0.914982,3.068172,1.815775,6.9805724),(27615,'cephalophus_sylvicultor_tibia.tif',240,8,137,182.1639593,67.2890262,56.3719748,1.8,67.3804107,56.6353291,0.1577745,12.0832156,11.3076598,3873.8968678,6028.960196,0.749511,533.1748838,320.601484,742.5044503,1.594175,9.1475214,1.7894653,22.635488),(27616,'cephalophus_sylvicultor_tibia.tif',240,8,138,181.04942,67.4336728,56.4703947,1.8,67.5780855,56.7749115,0.1511659,12.2383449,12.1540711,3842.2007231,5952.7248258,0.6842942,489.7720904,313.947741,785.8010578,1.112853,7.8439349,1.8925469,17.7596642),(27617,'cephalophus_sylvicultor_tibia.tif',240,8,139,179.1068907,67.5646981,56.5480378,1.8,67.7405191,56.8130039,0.14615,12.1685908,12.1836707,3795.1958509,5873.5148776,0.6330882,482.0808948,311.8845805,777.4398404,0.9722695,7.6412971,1.8000283,17.6392916),(27618,'cephalophus_sylvicultor_tibia.tif',240,8,140,177.7527864,67.6933095,56.6344117,1.8,67.86325,56.920684,0.1413829,12.0180141,12.1149914,3758.2772581,5828.690337,0.5882519,481.113865,312.7203245,756.3589157,1.0258558,8.2454644,1.94013,17.8447805),(27619,'cephalophus_sylvicultor_tibia.tif',240,8,141,177.1948642,67.8112372,56.7152182,1.8,67.9531902,56.9593134,0.1292026,11.9031196,11.9803515,3736.9781574,5806.4039935,0.4902578,484.6605695,313.9494768,754.0256188,0.496094,3.5079143,1.7126934,7.3562938),(27620,'cephalophus_sylvicultor_tibia.tif',240,8,142,176.3654573,67.9455339,56.8075074,1.8,68.0783745,57.08295,0.1262122,11.9367325,11.8963062,3708.8616076,5793.7496654,0.4657554,487.0208939,310.7099553,764.4949231,0.744141,3.017622,1.735945,6.7750835),(27621,'cephalophus_sylvicultor_tibia.tif',240,8,143,175.7227765,68.0816569,56.8767116,1.8,68.2093705,57.094387,0.123135,11.7802091,11.259725,3680.2391806,5800.3999753,0.4418182,515.1457921,312.4086464,742.8909939,0.496094,1.335774,1.9513027,2.8914477),(27622,'cephalophus_sylvicultor_tibia.tif',240,8,144,174.5075002,68.2071078,56.9440606,1.8,68.3009404,57.1713123,0.117872,11.7020856,11.2196743,3651.8051921,5815.0041777,0.402228,518.2863637,312.0644741,741.5525891,0.496094,1.022724,1.815775,2.3953537),(27623,'cephalophus_sylvicultor_tibia.tif',240,8,145,172.7155638,68.3811557,56.9447983,1.8,68.5266632,57.1808154,0.1134871,11.629683,11.2378001,3621.6432155,5782.5926363,0.3691544,514.5662498,311.413751,766.4933616,0.496094,1.1092999,2.0344439,2.3953537),(27624,'cephalophus_sylvicultor_tibia.tif',240,8,146,170.6127093,68.4900382,56.9990281,1.8,68.6413606,57.2315724,0.1118744,11.3186612,11.6480366,3567.7950456,5724.1770555,0.3544125,491.4284902,315.2135194,757.0278661,0.496094,1.1092999,2.0344439,2.3953537),(27625,'cephalophus_sylvicultor_tibia.tif',240,8,147,168.3657317,68.5752521,57.0538855,1.8,68.7193415,57.2946859,0.0985666,11.552748,11.5336675,3526.885042,5651.7318669,0.2717412,490.0203566,305.2853769,706.2822428,0.496094,1.2647965,1.7681919,2.8914477),(27626,'cephalophus_sylvicultor_tibia.tif',240,8,148,165.8033801,68.6576377,57.1124007,1.8,68.7856669,57.3511121,0.0907693,12.0838408,11.4540453,3486.6438432,5583.7374796,0.2270527,487.4904322,288.5377176,697.0781175,16.8671961,21.4183954,2.9078495,62.764965),(27627,'cephalophus_sylvicultor_tibia.tif',240,8,149,164.3763379,68.7502597,57.1735924,1.8,68.8891639,57.406944,0.0861624,12.1152139,11.1510146,3471.3122788,5562.9212389,0.2028841,498.8713074,286.5250518,663.4832015,16.8671961,21.4542733,2.9555345,63.1157565),(27628,'cephalophus_sylvicultor_tibia.tif',240,8,150,163.7963031,68.8396433,57.2488836,1.8,68.935423,57.4856637,0.081744,12.170017,11.6957109,3461.9690105,5578.4809954,0.1820107,476.9680973,284.4670637,664.7111243,0.248047,0.3507914,2.3561945,0.7015829),(27629,'cephalophus_sylvicultor_tibia.tif',240,8,151,163.4560757,68.9252747,57.3055801,1.8,69.0238354,57.5305782,0.07837,11.8708575,11.6005037,3441.118748,5603.9827975,0.1669784,483.0809898,289.8795423,691.247964,16.8541233,21.5387083,2.8854413,63.1759428),(27630,'cephalophus_sylvicultor_tibia.tif',240,8,152,163.3491114,69.0121535,57.3613836,1.8,69.1133436,57.5791865,0.0785474,12.9231867,11.1457298,3433.9096208,5650.9134161,0.1676238,507.0025506,265.7169405,674.9189198,16.8541233,21.6043101,2.9216784,63.261059),(27631,'cephalophus_sylvicultor_tibia.tif',240,8,153,162.7031865,69.1384128,57.3481544,1.8,69.22651,57.5261068,0.071518,11.8056238,12.2039651,3434.0300682,5667.3827054,0.1384633,464.388636,290.8808662,691.9002254,0.4813579,1.335774,1.9513027,2.8914477),(27632,'cephalophus_sylvicultor_tibia.tif',240,8,154,161.2560081,69.2356795,57.4086464,1.8,69.3763582,57.5947227,0.0664602,13.4880743,12.122627,3428.2867942,5683.829499,0.1185354,468.8612048,254.1717007,663.2351924,16.6191491,21.6980878,2.9576492,63.4063616),(27633,'cephalophus_sylvicultor_tibia.tif',240,8,155,159.0124052,69.3191939,57.4739129,1.8,69.4405205,57.6620151,0.0615235,11.8192169,12.2695086,3424.1004705,5684.9256975,0.1001874,463.3376847,289.7062045,675.9292867,16.6191491,21.7787528,2.8883269,63.4063616),(27634,'cephalophus_sylvicultor_tibia.tif',240,8,156,157.6058908,69.3962157,57.5303304,1.8,69.5046358,57.6991351,0.0596167,11.7577386,12.2053206,3421.2150847,5714.1953768,0.0932485,468.1724943,290.9756044,670.6468197,0.5654403,2.828171,1.8370484,6.0735006),(27635,'cephalophus_sylvicultor_tibia.tif',240,8,157,157.1812964,69.4526258,57.569185,1.8,69.5180043,57.7368599,0.0597266,11.7228926,12.1910593,3423.6368159,5770.7130567,0.0933402,473.3561629,292.0471013,708.9853827,16.6191491,21.9419972,2.9597169,63.6118505),(27636,'cephalophus_sylvicultor_tibia.tif',240,8,158,157.0948785,69.5035456,57.6052267,1.8,69.5907077,57.8034601,0.0554376,11.6670503,12.1508121,3439.4141674,5824.3009553,0.0803849,479.3342972,294.7972342,698.7432596,16.6191491,22.0189746,2.8911496,64.253247),(27637,'cephalophus_sylvicultor_tibia.tif',240,8,159,156.6939068,69.5667379,57.6510871,1.8,69.6582166,57.7775709,0.0512465,12.148165,12.2800091,3454.1054673,5879.9097238,0.0685251,478.8196536,284.3314582,678.739801,16.7030457,22.0817566,2.8802667,64.749341),(27638,'cephalophus_sylvicultor_tibia.tif',240,8,160,155.9182898,69.6098407,57.6978382,1.8,69.6598078,57.86399,0.0478785,12.2820309,12.260028,3468.7254631,5937.1637142,0.0595245,484.2699968,282.4227923,698.3425251,0.8959549,4.007322,1.9513027,8.8798321),(27639,'cephalophus_sylvicultor_tibia.tif',240,8,161,155.2119375,69.7105916,57.6715412,1.8,69.7460286,57.8216214,0.0444815,12.7674749,12.193543,3463.1644078,5947.4530743,0.0511502,487.7543033,271.2489689,683.5282605,0.4439716,0.8943462,2.1587989,1.8992597),(27640,'cephalophus_sylvicultor_tibia.tif',240,8,162,155.0095686,69.7704318,57.7026217,1.8,69.7821353,57.8626654,0.0476158,12.7553622,11.9811254,3479.7300007,5983.7209137,0.0585302,499.4289519,272.8052684,687.5292767,0.496094,0.8943462,2.1587989,1.8992597),(27641,'cephalophus_sylvicultor_tibia.tif',240,8,163,154.5947253,69.8386454,57.7544822,1.8,69.8983899,57.9669198,0.0542688,13.471003,12.2086873,3516.7285298,6031.8701312,0.0758084,494.0637738,261.0591463,651.5140471,0.496094,0.7015829,2.3561945,1.4031657),(27642,'cephalophus_sylvicultor_tibia.tif',240,8,164,154.1608645,69.8709662,57.7971611,1.8,69.923487,57.972589,0.0584101,12.7219485,12.197121,3547.5306766,6083.8802124,0.08756,498.7964155,278.8512062,701.9254968,0.496094,0.7015829,2.3561945,1.4031657),(27643,'cephalophus_sylvicultor_tibia.tif',240,8,165,154.1482981,69.8978122,57.8458536,1.8,69.8955223,57.9314224,0.0634538,11.8050065,12.2094113,3589.6236666,6144.4191254,0.1033048,503.2526945,304.0763833,718.2975662,0.6620288,1.4463501,2.1112158,3.3024255),(27644,'cephalophus_sylvicultor_tibia.tif',240,8,166,154.0932964,69.9252102,57.8932888,1.8,69.9281151,57.9928776,0.0681771,11.6218683,12.1771521,3642.4150492,6213.3760426,0.1191893,510.2486999,313.4104573,764.240201,0.6121091,1.8058094,1.849096,4.0891246),(27645,'cephalophus_sylvicultor_tibia.tif',240,8,167,155.2190971,69.9272552,57.9621225,1.8,69.9241789,58.0823124,0.0662736,11.4315011,12.1220741,3722.5317753,6304.6871035,0.1134591,520.0997013,325.6380552,780.4549009,0.496094,1.8058094,1.849096,4.2946135),(27646,'cephalophus_sylvicultor_tibia.tif',240,8,168,155.8869481,69.901193,57.9879604,1.8,69.9272799,58.1591977,0.0618749,11.0371719,12.4299893,3784.0106884,6379.8184311,0.0993422,513.2601714,342.8424182,792.6358411,0.496094,1.568787,1.8925469,3.3875418),(27647,'cephalophus_sylvicultor_tibia.tif',240,8,169,157.775296,69.9601015,57.9693387,1.8,70.0058989,58.1324725,0.0617162,12.9730857,12.3724548,3837.8531916,6467.5778874,0.1000309,522.7400682,295.831947,684.0565513,0.248047,1.022724,1.815775,2.1898649),(27648,'cephalophus_sylvicultor_tibia.tif',240,8,170,157.2561733,69.9292858,58.026391,1.8,69.9713577,58.2041164,0.0551269,12.6023368,12.4453646,3902.8129603,6537.5140499,0.0795688,525.2971114,309.689626,712.3428685,17.3632901,22.9306004,2.8677506,67.3149273),(27649,'cephalophus_sylvicultor_tibia.tif',240,8,171,156.0507972,69.9062784,58.0639536,1.8,69.991453,58.2389272,0.0412837,12.6966679,12.4543321,3961.7699935,6640.3526798,0.044302,533.1761354,312.0322609,722.0142581,0.58504,2.3531805,1.8925469,5.4922904),(27650,'cephalophus_sylvicultor_tibia.tif',240,8,172,156.6059228,69.8719908,58.1230354,1.8,69.9341738,58.2769072,0.0281065,13.0342389,12.741297,4056.7676285,6835.9264455,0.0206136,536.5173128,311.2393193,724.4190889,0.248047,0.55465,2.0344439,1.1976769),(27651,'cephalophus_sylvicultor_tibia.tif',240,8,173,158.2062296,69.8798067,58.1650487,1.8,69.9487327,58.2945942,0.0089086,12.5957325,12.7270918,4184.7728882,7104.0014405,0.0020926,558.1794759,332.2373588,769.8450266,0.3507914,0.7015829,2.3561945,1.4031657),(27652,'cephalophus_sylvicultor_tibia.tif',240,8,174,161.2531368,69.912072,58.2171858,1.8,70.0125189,58.3800711,-0.0131835,11.9239741,12.6822333,4361.4024269,7436.2267859,0.0046708,586.3499423,365.7675208,798.5786793,0.4713482,1.1092999,2.0344439,2.3953537),(27653,'cephalophus_sylvicultor_tibia.tif',240,8,175,164.6660756,69.9398695,58.2399407,1.8,70.0915369,58.3592319,-0.0335404,11.6614527,12.9417499,4554.5034107,7826.2688117,0.0308622,604.7303387,390.560554,880.2833408,18.0263202,24.0311336,2.9441971,71.9603323),(27654,'cephalophus_sylvicultor_tibia.tif',240,8,176,167.2032757,69.9203037,58.2384129,1.8,70.0738297,58.3471645,-0.0555283,11.6393323,12.9045489,4789.3769519,8226.906819,0.0858372,637.5199064,411.4821043,938.2115343,0.496094,0.8943462,0.9827937,1.8992597),(27655,'cephalophus_sylvicultor_tibia.tif',240,8,177,171.4086677,69.9779279,58.1795972,1.8,70.0614784,58.2804696,-0.0839464,11.9105859,13.4060854,5054.31808,8771.8658473,0.2008471,654.3197037,424.3551169,1016.2535832,0.496094,1.022724,1.815775,2.6008426),(27656,'cephalophus_sylvicultor_tibia.tif',240,8,178,174.8699707,69.9465161,58.2164649,1.8,69.9478863,58.3252071,-0.104378,11.6151683,13.5334354,5314.6073955,9424.0740177,0.3163766,696.3548971,457.5575028,987.7899889,20.1917004,25.3275302,2.8942387,113.8085102),(27657,'cephalophus_sylvicultor_tibia.tif',240,8,179,178.1267793,69.8268345,58.2378113,1.8,69.8674268,58.3042063,-0.1094241,11.9041011,14.1792674,5612.9665715,10213.4870038,0.3540543,720.3113342,471.5153645,1081.7779345,20.7024857,25.8968673,0.3520443,111.533529),(27658,'cephalophus_sylvicultor_tibia.tif',240,8,180,187.7746911,69.8031126,58.3134916,1.8,69.7738706,58.4801873,-0.1086128,11.793553,14.9162894,6041.5382268,11425.4308479,0.3677385,765.9700436,512.2746498,1169.1203136,19.6793362,26.945943,0.3770876,83.6112395),(27659,'cephalophus_sylvicultor_tibia.tif',240,8,181,195.6241968,69.7617004,58.3449674,1.8,69.7137367,58.5784365,-0.0891667,13.27814,14.6279932,6492.9568007,12751.9813314,0.2585388,871.7519299,488.9959599,1309.8294357,20.0954384,27.9314582,0.3442187,87.9660393),(27660,'cephalophus_sylvicultor_tibia.tif',240,8,182,202.3526189,69.623098,58.3263888,1.8,69.5318588,58.585034,-0.0714637,13.6483884,15.4009167,7016.7510915,14298.1654213,0.171945,928.3970363,514.1083972,1381.8924075,20.4062251,29.434098,0.2122705,95.7934971),(27661,'cephalophus_sylvicultor_tibia.tif',240,8,183,211.8617401,69.497749,58.2474337,1.8,69.3659451,58.5092921,-0.044875,13.8180694,15.1064977,7584.3176445,16120.652247,0.0710592,1067.1336628,548.869559,1546.231432,20.858267,30.4381062,0.3062879,100.1732269),(27662,'cephalophus_sylvicultor_tibia.tif',240,8,184,224.4366554,69.4228444,58.1575228,1.8,69.368178,58.4193585,-0.0199457,13.9378683,16.4589303,8275.3640154,17912.5816446,0.0148795,1088.3199175,593.7324004,1501.8122484,21.7314208,31.2046678,2.7241754,97.6325706),(27663,'cephalophus_sylvicultor_tibia.tif',240,8,185,251.388528,69.5444764,57.9419096,1.8,69.432986,58.2285991,0.0084308,14.3090413,16.7341132,9364.3696985,20085.7986461,0.0029778,1200.2905909,654.4372557,1736.8520173,0.248047,0.3507914,2.3561945,0.7015829),(27664,'cephalophus_sylvicultor_tibia.tif',240,8,186,285.4066264,69.6678328,57.7931773,1.8,69.533788,58.1142814,0.0164495,14.5002466,17.5633148,10636.9452286,23037.4922146,0.0128701,1311.6824713,733.569954,1907.2316328,0.248047,0.3507914,2.3561945,0.7015829),(27665,'cephalophus_sylvicultor_tibia.tif',240,8,187,323.5881289,69.8216154,57.7471622,1.8,69.5266534,58.0460461,0.055735,14.6951639,17.7015491,11858.5547281,26476.2848899,0.1673584,1495.7044025,806.9698869,2161.9248682,0.744141,1.1092999,2.677945,2.6008426),(27666,'cephalophus_sylvicultor_tibia.tif',240,8,188,347.6825984,69.6369874,57.7449533,1.8,69.2167382,57.9697331,0.1182679,15.2063289,17.3528556,12736.3332247,28041.8681907,0.8067516,1615.9800318,837.5679188,2300.0754501,0.496094,1.335774,1.9513027,2.8914477),(27667,'cephalophus_sylvicultor_tibia.tif',240,8,189,350.3594655,68.3792598,57.596098,1.8,68.7252857,57.8254681,0.1042308,15.0140672,17.5774748,13397.2037354,25075.7905754,0.6320935,1426.5866356,892.3100941,2161.6577753,1.2033947,2.3531805,1.2490458,6.1336869),(27668,'cephalophus_sylvicultor_tibia.tif',240,8,190,306.5318249,66.4437591,57.0876596,1.8,67.3966587,57.2797708,-0.0604989,14.9934018,17.5017776,13194.8901149,16039.844938,0.1867624,916.469475,880.0464577,1538.1375102,25.4163278,33.8745395,2.6288043,155.0256178),(27669,'cephalophus_sylvicultor_tibia.tif',240,8,191,250.2515219,65.5737548,56.3871303,1.8,65.7839253,56.5599385,-1.4571139,17.5045599,15.9064908,9454.6735538,12010.1678692,41.1718762,755.0482414,540.1263215,1171.5614381,25.3099889,28.7648976,1.0067126,117.7480549),(27670,'cephalophus_sylvicultor_tibia.tif',240,8,192,206.9968312,65.1107082,55.5910888,1.8,65.4214998,55.8466941,-1.5101805,16.7280327,16.4029304,6221.6170339,10554.7007166,34.3728664,643.4643347,371.9275994,904.0861814,22.6349934,28.7145878,1.0259324,135.2876266),(27671,'cephalophus_sylvicultor_tibia.tif',240,8,193,155.1540086,64.660222,53.9262976,1.8,64.9508653,54.0784971,-1.4959431,36.8968203,17.5675167,4598.7131379,8084.5365048,25.7143838,460.1980246,124.6371125,323.3786928,0.248047,0.3507914,2.3561945,0.7015829),(27672,'cephalophus_sylvicultor_tibia.tif',240,8,194,118.363937,64.3425528,52.5264556,1.8,64.4696641,52.488491,-1.5030077,11.583165,18.1318785,3683.6857699,5289.886357,19.6368086,291.7450801,318.0206605,492.3931084,12.1319152,22.03713,0.204018,90.2616731),(27673,'cephalophus_sylvicultor_tibia.tif',240,8,195,85.6818391,64.3625928,51.0640195,1.8,64.5090549,51.2896149,-0.0336593,18.8204679,11.1281301,2062.5516669,2962.7964844,0.0161727,266.2438752,109.5908814,263.1262939,6.1621041,11.2308057,1.4601391,30.4027595),(27674,'cephalophus_sylvicultor_tibia.tif',240,8,196,66.3051349,64.3870235,50.1146307,1.8,64.5601707,50.1625035,0.0422916,19.4321495,9.7384383,318.2489507,2349.3869264,0.0197535,241.2488383,16.3774446,136.6921444,5.208987,10.1971154,1.4977558,25.2363306),(27675,'cephalophus_sylvicultor_tibia.tif',240,8,197,55.9345754,64.3114675,50.1306815,1.8,64.4371769,50.0667535,0.0599164,4.6932745,9.1011752,182.5859694,1863.3061794,0.0334273,204.732481,38.9037482,220.8484873,4.96094,8.7381576,1.6845883,22.3448828),(27676,'cephalophus_sylvicultor_tibia.tif',240,8,198,44.3301696,64.0796003,50.1735758,1.8,64.1933478,50.1691352,0.0867177,3.8286756,8.7595624,107.118122,1418.3152782,0.0554211,161.9162248,27.9778524,173.0752864,4.96094,7.72538,1.6672701,20.3605068),(27677,'cephalophus_sylvicultor_tibia.tif',240,8,199,19.4393128,61.2346546,49.9132523,1.8,63.5199534,50.2157018,0.1337128,3.3201825,11.2199737,33.1608407,503.057564,0.0575819,44.8358953,9.9876561,47.7310534,4.464846,6.8606411,1.7894653,18.3159445),(27678,'cephalophus_sylvicultor_tibia.tif',240,8,200,6.1361191,58.5560347,49.6597501,1.8,58.4072194,49.6083538,1.4796412,1.9658466,2.8899438,3.4090251,8.0699199,1.0142123,2.7924142,1.7341257,3.9068107,3.720705,5.7907156,1.3986055,15.0737053),(27679,'cephalophus_sylvicultor_tibia.tif',240,8,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27680,'cephalophus_sylvicultor_tibia.tif',240,8,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27681,'cephalophus_sylvicultor_tibia.tif',240,8,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27682,'cephalophus_sylvicultor_tibia.tif',240,8,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27683,'cephalophus_sylvicultor_tibia.tif',240,8,205,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27684,'cephalophus_sylvicultor_tibia.tif',240,8,206,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27685,'cephalophus_sylvicultor_tibia.tif',240,8,207,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27686,'cephalophus_sylvicultor_tibia.tif',240,8,208,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27687,'cephalophus_sylvicultor_tibia.tif',240,8,209,5.1614519,89.7797044,54.1416296,1.8,89.7711677,54.1488622,1.3818243,3.7733907,3.881012,15.0721746,16.3401864,0.8298863,4.2102901,3.9943319,7.7215263,7.6894571,8.2789751,1.4204249,25.7074946),(27688,'cephalophus_sylvicultor_tibia.tif',240,8,210,28.3077855,89.7479062,54.239047,1.8,89.7414004,54.2519104,-0.9833607,6.6880467,6.7665371,267.506053,273.5548625,3.2687514,40.4276011,39.9976351,79.4014748,13.3945381,13.9017012,1.2998495,44.3389743),(27689,'cephalophus_sylvicultor_tibia.tif',240,8,211,52.4779522,89.7445193,54.2573558,1.8,89.7437959,54.2525668,-0.790413,8.51853,8.6089493,867.0219789,885.5137516,4.4170231,102.8596775,101.7807042,200.5998193,17.3632901,17.6967238,1.0255692,57.307931),(27690,'cephalophus_sylvicultor_tibia.tif',240,8,212,78.317989,89.2358483,54.4079787,1.8,88.0498722,54.7037555,-0.2545386,9.9820292,41.0702608,1770.6179808,3261.6621923,0.827595,79.4166419,177.3805646,120.6936182,20.0918072,20.4619984,1.0366138,66.2728794),(27691,'cephalophus_sylvicultor_tibia.tif',240,8,213,521.0496619,66.5920905,55.2012064,1.8,71.7057213,54.9960022,-0.0377122,16.8144081,34.1986912,24630.9413478,89806.5829779,0.1234483,2626.0239751,1464.8711513,3342.7113965,28.7734522,29.2285267,1.0463871,95.3928457),(27692,'cephalophus_sylvicultor_tibia.tif',240,8,214,577.20829,67.2188687,55.017812,1.8,72.704823,54.9241801,-0.0337866,16.9949308,34.5177347,27700.7864385,104059.8376094,0.1097753,3014.6774835,1629.9440548,3816.7499068,28.7734522,29.2705973,0.9357696,95.5381483),(27693,'cephalophus_sylvicultor_tibia.tif',240,8,215,596.0394892,67.8323558,55.0002842,1.8,73.4996441,54.8855047,-0.0333131,17.0027794,34.6226963,28981.0264178,113741.8764646,0.1102024,3285.1825183,1704.4875864,4122.1465617,28.7734522,29.2958106,0.8033603,95.6834509),(27694,'cephalophus_sylvicultor_tibia.tif',240,8,216,612.0059394,68.3194634,54.9911994,1.8,74.0479101,54.8787288,-0.0333943,16.7306643,34.2514837,30239.1183845,121630.9487476,0.113707,3551.1147384,1807.406916,4414.1700671,0.496094,0.8943462,0.9827937,1.8992597),(27695,'cephalophus_sylvicultor_metatarsus.tif',240,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27696,'cephalophus_sylvicultor_metatarsus.tif',240,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27697,'cephalophus_sylvicultor_metatarsus.tif',240,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27698,'cephalophus_sylvicultor_metatarsus.tif',240,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27699,'cephalophus_sylvicultor_metatarsus.tif',240,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27700,'cephalophus_sylvicultor_metatarsus.tif',240,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27701,'cephalophus_sylvicultor_metatarsus.tif',240,10,7,3.0562184,52.5678643,44.0503231,1.8,52.3314177,44.1307593,0.0807406,1.4014495,2.5415842,0.6327991,2.8889582,0.0033134,1.1366762,0.4515318,1.3729566,2.4375002,5.0031243,2.9147938,11.8791268),(27702,'cephalophus_sylvicultor_metatarsus.tif',240,10,8,10.2401327,51.618998,44.3131749,1.8,51.4282519,44.3435914,-0.0007886,2.3149905,4.2556104,5.8010297,30.2753776,0.0000011,7.1142268,2.5058547,8.303189,3.5625002,8.8264523,2.927532,20.9512729),(27703,'cephalophus_sylvicultor_metatarsus.tif',240,10,9,19.3242638,51.2249355,44.2748879,1.8,51.51926,44.2986514,0.0554642,4.0478811,7.9696553,22.5460895,134.248267,0.0098976,16.8449277,5.5698497,18.9878686,4.6875003,12.0613673,2.9380996,28.9439141),(27704,'cephalophus_sylvicultor_metatarsus.tif',240,10,10,36.6218441,51.4926929,43.3703071,1.8,50.9727876,42.8441452,0.3418517,5.5803342,9.8455901,123.4928357,568.6391682,0.6859311,57.7557222,22.1300072,70.1620654,9.7805159,19.4575873,2.5829933,61.7632749),(27705,'cephalophus_sylvicultor_metatarsus.tif',240,10,11,113.7709872,50.2016784,40.9801268,1.8,50.4579904,40.2584862,0.3776082,15.0333714,13.7156692,1389.3180193,4152.5203089,2.5776402,302.757397,92.4155989,330.7970003,15.6343409,24.8407443,2.6374267,83.3280625),(27706,'cephalophus_sylvicultor_metatarsus.tif',240,10,12,223.6507417,51.0481786,37.5948886,1.8,51.4535921,37.203787,0.2788509,13.8549682,13.6316397,6645.7995106,11727.7471884,2.8240817,860.332833,479.6690542,1140.7376398,23.9449736,28.904816,2.2597207,145.3298521),(27707,'cephalophus_sylvicultor_metatarsus.tif',240,10,13,284.8127593,51.5305188,35.6541855,1.8,51.7168588,36.3137266,0.2480966,16.9764061,14.7316153,10465.3883909,14167.9008591,2.862337,961.7343787,616.4666608,1329.3518722,0.375,1.1858542,1.2490458,2.5606603),(27708,'cephalophus_sylvicultor_metatarsus.tif',240,10,14,290.5945889,51.6791106,35.0535818,1.8,51.7625288,36.1098949,-0.0511435,19.957399,14.6313864,11429.0281064,14008.554156,0.1265722,957.4317665,572.6712246,1273.2217347,25.5480879,28.2584352,2.252791,157.4709107),(27709,'cephalophus_sylvicultor_metatarsus.tif',240,10,15,273.8113233,51.699033,35.0487863,1.8,51.7891517,35.9566171,-0.0973362,22.09858,14.1138248,11144.3528159,12765.8749855,0.4309995,904.494361,504.3017602,1062.072502,25.0088914,27.8492752,2.2560521,94.1465291),(27710,'cephalophus_sylvicultor_metatarsus.tif',240,10,16,252.160621,51.6931921,35.2318409,1.8,51.8742444,36.0633778,-0.24072,21.9803168,15.1180232,10540.6474788,11418.0689785,2.3886112,755.2620344,479.5493892,984.885137,24.3750015,27.4160668,2.2690372,94.3850437),(27711,'cephalophus_sylvicultor_metatarsus.tif',240,10,17,229.4989101,51.7910976,35.4386267,1.8,51.9459512,36.3151929,-0.361729,22.1232015,14.1287076,9552.036468,9884.2903332,4.7903872,699.5891363,431.7655594,876.7998367,23.0625014,26.8446066,1.9500057,99.0670245),(27712,'cephalophus_sylvicultor_metatarsus.tif',240,10,18,215.390311,51.86054,35.7952981,1.8,51.9922208,36.5635687,0.8053352,17.8783405,19.7497237,8747.0905783,8835.7768527,18.6647098,447.3873642,489.2562925,802.1400649,22.3125014,26.2526801,1.9513027,85.9797131),(27713,'cephalophus_sylvicultor_metatarsus.tif',240,10,19,198.7699787,51.9217326,36.102854,1.8,52.0558251,36.8359863,0.9854795,13.178217,19.2700381,7775.9073883,8183.2157377,23.017037,424.6600704,590.057622,827.7738922,21.5625013,25.5674675,2.2627177,81.691577),(27714,'cephalophus_sylvicultor_metatarsus.tif',240,10,20,186.8216249,51.9827885,36.4133241,1.8,52.0491253,37.1053043,0.9934238,13.3727893,16.6053506,7001.9634554,7688.2306144,21.8604934,462.9971868,523.5978315,871.8298706,0.7142613,3.9774759,1.7126934,9.4283014),(27715,'cephalophus_sylvicultor_metatarsus.tif',240,10,21,178.4552673,52.0114497,36.7017776,1.8,52.0623963,37.3310719,0.9850637,12.2585188,17.2081732,6431.5904196,7266.9470695,20.6532552,422.2962529,524.6629341,791.8662214,0.5778594,5.7025902,1.735945,12.6479716),(27716,'cephalophus_sylvicultor_metatarsus.tif',240,10,22,174.8019572,52.0746179,36.9696423,1.8,52.1104788,37.5354974,0.9992789,12.7609806,15.1068124,6026.0420812,7046.1299428,20.6096611,466.4206942,472.2240597,828.8818486,0.375,2.0963139,1.7506498,4.4356604),(27717,'cephalophus_sylvicultor_metatarsus.tif',240,10,23,172.6075251,52.1199065,37.1949629,1.8,52.1387869,37.7713669,0.9872483,12.6925157,16.5564296,5709.2269373,6823.3350823,20.0343232,412.1259983,449.8105077,723.6184625,19.8750012,23.8383241,1.9074711,73.7366252),(27718,'cephalophus_sylvicultor_metatarsus.tif',240,10,24,169.9723188,52.1525174,37.3871774,1.8,52.1454533,37.8732105,0.9725972,13.3023041,13.8090367,5456.0312297,6617.9902507,19.3444403,479.2506808,410.156857,801.6491987,0.2651651,0.5303301,0.7853982,1.0606602),(27719,'cephalophus_sylvicultor_metatarsus.tif',240,10,25,169.1190233,52.2394819,37.5551863,1.8,52.2233335,38.0596411,0.9893077,12.3913662,17.1314596,5222.2401721,6368.3784739,19.6827513,371.7358947,421.4418408,656.955051,0.703679,5.6747801,1.7033479,12.6479716),(27720,'cephalophus_sylvicultor_metatarsus.tif',240,10,26,168.8980396,52.2481376,37.7052715,1.8,52.2377519,38.1737722,1.0302631,12.0915657,13.2984221,5036.6849321,6155.2782263,20.6954649,462.8577885,416.5453061,764.6334358,0.375,1.140518,1.735945,2.5606603),(27721,'cephalophus_sylvicultor_metatarsus.tif',240,10,27,167.1364875,52.227823,37.859085,1.8,52.1533217,38.386494,1.0860548,11.5231481,20.0353706,4876.8060337,5985.6843355,21.8074938,298.7558577,423.2182026,525.9479061,18.7938828,22.702992,2.4087776,69.7591493),(27722,'cephalophus_sylvicultor_metatarsus.tif',240,10,28,167.0714804,52.2213665,38.0229432,1.8,52.1595965,38.5402489,1.1303236,10.963075,13.1385252,4755.2704406,5844.0160404,22.7832898,444.8000009,433.7533433,780.508661,0.2651651,0.5303301,0.7853982,1.0606602),(27723,'cephalophus_sylvicultor_metatarsus.tif',240,10,29,167.1646658,52.2097865,38.1580465,1.8,52.1460412,38.6133096,1.1530615,10.7942807,12.9185497,4647.3325721,5717.4774402,23.275304,442.5788936,430.5365682,794.6395241,0.7010015,5.4665177,1.6738779,12.1176414),(27724,'cephalophus_sylvicultor_metatarsus.tif',240,10,30,168.3708236,52.181433,38.3016036,1.8,52.091711,38.7249716,1.1634983,10.6955158,13.8959625,4574.9735513,5641.6107305,23.6583776,405.9892012,427.7468848,723.4191513,0.591221,4.1631759,1.706324,9.4926413),(27725,'cephalophus_sylvicultor_metatarsus.tif',240,10,31,169.6316973,52.147077,38.439384,1.8,52.0479793,38.8134395,1.1796889,10.6684429,12.9742185,4493.0794364,5543.7777892,24.1633862,427.2918482,421.1560663,754.4515846,0.375,1.140518,1.735945,2.5606603),(27726,'cephalophus_sylvicultor_metatarsus.tif',240,10,32,170.4940376,52.1294888,38.5729439,1.8,52.0745781,38.9216265,1.1944759,10.5619511,12.503588,4420.7818449,5479.5498363,24.5779409,438.2381945,418.5573086,752.8831223,0.375,3.0233468,1.6951513,6.4659907),(27727,'cephalophus_sylvicultor_metatarsus.tif',240,10,33,170.2776243,52.1633156,38.6684421,1.8,52.0827212,39.0000936,1.2014396,10.3478908,12.6707409,4306.6702815,5338.7911306,24.6808262,421.3479853,416.1882229,754.5666641,0.5625,3.7919531,1.7196863,8.1213209),(27728,'cephalophus_sylvicultor_metatarsus.tif',240,10,34,168.636786,52.1419887,38.7847258,1.8,52.0235756,39.1321409,1.2090222,10.5768725,12.423638,4202.5287035,5239.647616,24.5852948,421.748253,397.3318875,738.6797724,0.5625,4.7024764,1.6506263,10.6176414),(27729,'cephalophus_sylvicultor_metatarsus.tif',240,10,35,168.3679259,52.1232884,38.8982764,1.8,52.0547152,39.213729,1.2107721,13.4961305,12.5815263,4119.4085687,5155.8876331,24.5785436,409.7982626,305.2288624,597.8855238,0.6435384,3.9553171,1.665748,9.2729714),(27730,'cephalophus_sylvicultor_metatarsus.tif',240,10,36,167.7125813,52.0983843,39.0330316,1.8,52.0321081,39.4394799,1.2222025,10.8083766,12.5845638,4049.632037,5065.887231,24.6907994,402.547702,374.6753268,641.8353822,17.2814376,20.9371282,2.4640545,64.7476636),(27731,'cephalophus_sylvicultor_metatarsus.tif',240,10,37,167.6263952,52.0763475,39.1298401,1.8,52.0203958,39.4875712,1.2202226,10.2000366,12.5302938,3980.1184064,4995.8628716,24.6425112,398.7027711,390.2062858,628.5986298,0.7442406,6.3997685,1.6588037,13.8373115),(27732,'cephalophus_sylvicultor_metatarsus.tif',240,10,38,167.2117325,52.0525135,39.2378341,1.8,52.0288383,39.6068675,1.2183255,10.7016078,11.8206418,3911.1284011,4922.1929567,24.5473705,416.4065756,365.4711024,631.1976449,0.5625,5.2633761,1.6421038,11.5873113),(27733,'cephalophus_sylvicultor_metatarsus.tif',240,10,39,167.7567291,52.022713,39.3293389,1.8,52.0021897,39.6652817,1.222266,9.914634,11.9157373,3849.3674711,4878.2781474,24.6984375,409.3979282,388.2510899,702.0464047,1.2373677,7.5374072,1.670465,17.7692922),(27734,'cephalophus_sylvicultor_metatarsus.tif',240,10,40,167.2302801,52.0005604,39.4167582,1.8,51.9960169,39.7443714,1.2353248,10.503109,11.8216442,3782.5808644,4831.7318413,24.8509165,408.7191055,360.1391628,608.3683312,0.6347853,5.4665177,1.6738779,11.8069813),(27735,'cephalophus_sylvicultor_metatarsus.tif',240,10,41,165.9360399,52.0177873,39.4673037,1.8,52.0079558,39.784081,1.2377895,10.3766623,12.1399845,3698.4683665,4740.2734305,24.7008366,390.4678319,356.4217737,644.106577,1.1250001,5.8606877,1.4424731,14.0836318),(27736,'cephalophus_sylvicultor_metatarsus.tif',240,10,42,163.8988095,51.980405,39.5763093,1.8,51.9522862,39.9366997,1.24081,10.5869278,11.8702418,3613.6321039,4660.2024785,24.4483616,392.5954144,341.3296273,590.8537986,0.6799215,6.9602671,1.6517004,14.6516513),(27737,'cephalophus_sylvicultor_metatarsus.tif',240,10,43,163.7616256,51.9400736,39.6523818,1.8,51.9528788,39.980935,1.2370022,10.283452,12.5891056,3549.7802122,4615.3889772,24.3638686,366.6177028,345.1934453,635.6657472,1.1523508,6.0263099,1.6642731,13.6631367),(27738,'cephalophus_sylvicultor_metatarsus.tif',240,10,44,163.117318,51.8916447,39.728924,1.8,51.9173953,40.0693888,1.2332467,9.9613826,12.4263713,3504.009803,4563.2176408,24.2045025,367.2204473,351.759383,623.080876,1.1083591,5.0763702,1.6447354,11.8524764),(27739,'cephalophus_sylvicultor_metatarsus.tif',240,10,45,163.1103293,51.8333092,39.8085399,1.8,51.8200103,40.1269186,1.2349457,10.4638122,11.3304424,3471.1157989,4520.3985646,24.2322699,398.9604637,331.7257358,581.869605,0.5294391,5.450416,1.5019398,11.4963211),(27740,'cephalophus_sylvicultor_metatarsus.tif',240,10,46,162.7905885,51.7871244,39.8957738,1.8,51.7978678,40.2537737,1.2305873,10.461678,11.864682,3435.4496455,4468.3027845,24.1107751,376.6053572,328.3841884,657.544061,0.375,4.5039048,1.6124389,9.6213209),(27741,'cephalophus_sylvicultor_metatarsus.tif',240,10,47,162.4407838,51.7403394,39.9738496,1.8,51.7266969,40.3041667,1.2285276,10.3323853,12.2391235,3406.4269986,4418.7542195,24.0237957,361.0351859,329.6844727,625.23386,0.7993843,6.8431083,1.735945,15.0533018),(27742,'cephalophus_sylvicultor_metatarsus.tif',240,10,48,161.7659968,51.6958933,40.0472352,1.8,51.6996112,40.3539578,1.2177731,10.2825015,11.611088,3371.326497,4365.6000547,23.7382566,375.9854437,327.8702656,615.0301714,1.195586,3.5821827,1.6756733,9.1631364),(27743,'cephalophus_sylvicultor_metatarsus.tif',240,10,49,160.3443737,51.713347,40.0760082,1.8,51.7397266,40.4281219,1.2215277,10.2833896,11.8800044,3320.1365283,4290.8128566,23.5944571,361.1793988,322.8640227,566.2179097,0.9375001,5.3033012,1.4288993,12.0721463),(27744,'cephalophus_sylvicultor_metatarsus.tif',240,10,50,159.3202507,51.6705856,40.1459573,1.8,51.7032179,40.4447208,1.2193187,10.2341211,11.5734504,3265.1490674,4220.6225717,23.405937,364.6814413,319.0453813,552.7966455,0.75,6.5651784,1.59936,14.8336319),(27745,'cephalophus_sylvicultor_metatarsus.tif',240,10,51,158.1644622,51.6320781,40.2328552,1.8,51.7053088,40.5684748,1.2208711,9.8236625,11.9240403,3223.3317136,4154.6245322,23.2625468,348.4242283,328.1191418,548.6860155,0.7750086,5.7025902,1.735945,12.7123114),(27746,'cephalophus_sylvicultor_metatarsus.tif',240,10,52,157.5604458,51.5835075,40.309037,1.8,51.6310123,40.6580897,1.2250846,9.5760756,12.1038745,3195.2571253,4102.8240977,23.2446185,338.9678317,333.6708338,473.1012281,0.6355724,5.0763702,1.4968573,11.0569812),(27747,'cephalophus_sylvicultor_metatarsus.tif',240,10,53,157.1114578,51.5369772,40.3879742,1.8,51.5746382,40.7386389,1.2193915,10.1426658,11.4919122,3174.2428142,4045.3677755,23.0826727,352.0186818,312.9594201,544.2129782,0.5625,3.1930101,1.6295521,7.306981),(27748,'cephalophus_sylvicultor_metatarsus.tif',240,10,54,156.6707476,51.4855698,40.4538978,1.8,51.5454058,40.8052118,1.2128207,10.0816679,11.2399181,3145.3432717,4000.4193631,22.906167,355.9117907,311.9864011,556.3805332,0.5625,1.5461647,1.3258177,3.6213206),(27749,'cephalophus_sylvicultor_metatarsus.tif',240,10,55,156.4733931,51.440881,40.5109267,1.8,51.4910346,40.8663915,1.21874,9.7202113,11.5220255,3120.7121332,3965.8900317,22.9779387,344.2007689,321.0539391,554.8182315,0.5625,4.1420106,1.6614562,9.026651),(27750,'cephalophus_sylvicultor_metatarsus.tif',240,10,56,158.4423991,51.3954994,40.5572772,1.8,51.4079957,40.8971132,1.2292557,10.1759166,13.3184824,3100.133636,3937.1641387,23.4446105,295.6165731,304.6539933,523.5692687,0.5625,4.5039048,1.6124389,9.6213209),(27751,'cephalophus_sylvicultor_metatarsus.tif',240,10,57,157.4585033,51.3994836,40.5488423,1.8,51.4035626,40.9422275,1.2479137,10.1489804,11.7476416,3067.5120073,3890.9965666,23.6009232,331.215124,302.2482941,547.0031217,0.6919232,6.0263099,1.4773195,13.2426415),(27752,'cephalophus_sylvicultor_metatarsus.tif',240,10,58,156.7934429,51.3614715,40.5931795,1.8,51.3972127,40.9747883,1.2687557,10.1487173,11.5482031,3042.5978433,3861.0344852,23.8198542,334.3407146,299.801221,545.0930542,0.6775762,5.8876198,1.4108832,12.8676415),(27753,'cephalophus_sylvicultor_metatarsus.tif',240,10,59,156.5311346,51.3179859,40.6186674,1.8,51.345681,41.0058948,1.2974478,9.7650364,12.0056301,3025.571591,3853.7210453,24.1872727,320.9928176,309.8372064,571.9881493,0.8212854,6.6052185,1.4570043,14.2123115),(27754,'cephalophus_sylvicultor_metatarsus.tif',240,10,60,156.23269,51.2766972,40.6293762,1.8,51.2914537,40.9951477,1.3266014,9.8303094,12.0837914,3013.1973898,3841.9673591,24.516678,317.9438653,306.5211141,491.0904742,0.6601083,5.0763702,1.4968573,11.0569812),(27755,'cephalophus_sylvicultor_metatarsus.tif',240,10,61,155.5977893,51.2276419,40.667797,1.8,51.2437983,41.0130753,1.3363873,9.7474199,11.2787613,3001.3870947,3806.1286433,24.5339194,337.4598108,307.9160547,548.6912142,0.5865006,4.8894021,1.4940244,10.6819812),(27756,'cephalophus_sylvicultor_metatarsus.tif',240,10,62,155.1458291,51.1741677,40.7140034,1.8,51.1860051,41.0926246,1.3505974,9.7189966,11.7143901,2998.331266,3771.0770896,24.6239978,321.918347,308.5021408,533.9061724,0.5625,3.3957696,1.6814535,7.8373111),(27757,'cephalophus_sylvicultor_metatarsus.tif',240,10,63,154.6042416,51.1269774,40.7494039,1.8,51.1585989,41.0770628,1.3633288,9.4294179,10.9993717,2989.9334196,3741.873431,24.6740962,340.1897423,317.0856851,543.3402259,0.4813246,3.9553171,1.4758446,8.4963209),(27758,'cephalophus_sylvicultor_metatarsus.tif',240,10,64,153.0850653,51.0822432,40.8069707,1.8,51.1092457,41.1455312,1.3615037,9.437823,10.8981392,2966.6297987,3674.6284852,24.4127935,337.1794422,314.3341215,556.3426494,15.9061063,18.9189277,1.2271057,59.3156828),(27759,'cephalophus_sylvicultor_metatarsus.tif',240,10,65,150.5270323,51.0764349,40.8487823,1.8,51.0900422,41.1945002,1.3472365,10.0865389,11.6106527,2925.4287097,3576.8764192,23.8547238,308.068504,290.0329572,496.601855,15.9257261,18.8565733,2.412473,58.7853527),(27760,'cephalophus_sylvicultor_metatarsus.tif',240,10,66,148.0928665,51.0243418,40.9271247,1.8,51.0549454,41.2406262,1.3292923,9.7921178,10.8958143,2885.2261503,3468.1482498,23.2703482,318.3009696,294.6478183,499.8475401,0.5625,2.8187432,1.6373645,6.2463207),(27761,'cephalophus_sylvicultor_metatarsus.tif',240,10,67,146.2115169,50.9738482,41.0037839,1.8,51.008033,41.32137,1.3061319,10.0044094,11.476533,2863.7362632,3383.9970889,22.7011193,294.8623158,286.2474083,483.7967779,0.2651651,0.5303301,0.7853982,1.0606602),(27762,'cephalophus_sylvicultor_metatarsus.tif',240,10,68,144.4632496,50.9215193,41.0758332,1.8,50.959361,41.4113456,1.2763869,9.5784724,11.5376803,2834.39088,3295.9025209,22.0498738,285.6642271,295.9126229,527.2584281,0.7894154,5.3033012,1.7126934,12.7389618),(27763,'cephalophus_sylvicultor_metatarsus.tif',240,10,69,142.9438495,50.8769534,41.1429014,1.8,50.9183404,41.4462753,1.2411162,9.9743883,10.7947154,2819.2885224,3209.8178265,21.327036,297.350852,282.6527734,498.0602447,0.1875,0.2651651,2.3561945,0.5303301),(27764,'cephalophus_sylvicultor_metatarsus.tif',240,10,70,141.3290695,50.8310501,41.20501,1.8,50.8860135,41.5150236,1.2079745,9.796182,10.6147666,2798.8089609,3132.464891,20.5877877,295.1044534,285.7040578,485.8849127,0.5625,2.4661776,1.418147,5.6516508),(27765,'cephalophus_sylvicultor_metatarsus.tif',240,10,71,140.1564486,50.7857097,41.2535616,1.8,50.8406768,41.5209929,1.1904267,9.7229251,10.6257097,2782.9767645,3067.3258645,20.1396243,288.6702117,286.2283469,516.0061092,0.375,2.2810361,1.4056476,5.4319809),(27766,'cephalophus_sylvicultor_metatarsus.tif',240,10,72,139.3032703,50.7435352,41.2958349,1.8,50.7801258,41.5580834,1.1718841,9.4586173,10.6711918,2769.7071165,3014.638289,19.7144972,282.5024939,292.8236786,481.8381197,0.375,1.140518,1.735945,2.5606603),(27767,'cephalophus_sylvicultor_metatarsus.tif',240,10,73,137.3844632,50.767301,41.3353138,1.8,50.846409,41.6648692,1.143569,10.0581952,12.1540677,2741.932886,2952.6587924,18.9662679,242.9358515,272.6068487,466.5960222,0.375,0.5303301,0.7853982,1.0606602),(27768,'cephalophus_sylvicultor_metatarsus.tif',240,10,74,135.5465262,50.7171731,41.3813312,1.8,50.7765761,41.7296558,1.1393116,9.5553291,11.2593041,2713.5472733,2889.8658373,18.6397287,256.6646936,283.9826087,463.6446862,0.5625,2.6516506,1.7126934,6.337311),(27769,'cephalophus_sylvicultor_metatarsus.tif',240,10,75,134.035553,50.6684232,41.4144574,1.8,50.721786,41.7417367,1.1049706,11.5458668,11.4071992,2695.2941217,2842.7143065,17.8324171,249.2035295,233.4423358,444.4075226,0.5271111,3.7687036,1.670465,8.2766509),(27770,'cephalophus_sylvicultor_metatarsus.tif',240,10,76,132.8017176,50.6186668,41.447778,1.8,50.6793902,41.7987105,1.0505122,10.0881931,12.8842102,2679.7746516,2803.9236343,16.6636288,217.6247966,265.6347512,395.1174969,16.0382278,17.9814369,2.4521948,56.0050224),(27771,'cephalophus_sylvicultor_metatarsus.tif',240,10,77,131.8815186,50.5600151,41.4759809,1.8,50.5858912,41.8153311,0.9932503,10.1792787,11.7759758,2672.5068808,2768.8429145,15.4283167,235.1264095,262.5438365,434.3399696,16.0910349,17.8922568,2.4750348,56.0505175),(27772,'cephalophus_sylvicultor_metatarsus.tif',240,10,78,131.0395902,50.5079022,41.5063064,1.8,50.5717685,41.8394108,0.9024582,10.4460349,11.536133,2665.1495488,2746.222825,13.4532583,238.0540194,255.1350416,458.3087261,16.0986451,17.8627592,2.4602944,55.7853525),(27773,'cephalophus_sylvicultor_metatarsus.tif',240,10,79,130.3849808,50.4535619,41.5308154,1.8,50.4918474,41.822389,0.6944798,11.2702632,11.1621915,2654.9583987,2716.4868721,8.9005524,243.3650116,235.5719953,456.0572272,0.5625,1.1858542,1.8925469,2.7159904),(27774,'cephalophus_sylvicultor_metatarsus.tif',240,10,80,128.8924486,50.4067312,41.558335,1.8,50.4264737,41.8257758,0.3982088,11.4729242,9.6587465,2625.4946798,2694.583203,3.2301295,278.9785609,228.8426769,463.7063671,0.375,1.5461647,1.3258177,3.3106604),(27775,'cephalophus_sylvicultor_metatarsus.tif',240,10,81,126.8507865,50.3587636,41.5158386,1.8,50.3954378,41.8088528,0.2909398,11.6111822,9.6601139,2587.4717073,2662.4142935,1.739641,275.6089954,222.8430896,449.9829485,16.0537738,17.6936838,2.4387134,55.8308476),(27776,'cephalophus_sylvicultor_metatarsus.tif',240,10,82,125.5396606,50.3127239,41.5351128,1.8,50.3668551,41.8153765,0.1675989,11.1713607,9.5436438,2550.6087994,2641.0418657,0.5822399,276.7330711,228.3167536,435.4537436,15.9603275,17.6936838,2.4387134,55.8308476),(27777,'cephalophus_sylvicultor_metatarsus.tif',240,10,83,124.2448451,50.2667564,41.5644414,1.8,50.2840281,41.8418291,0.0516725,11.3802407,9.8377485,2520.2246267,2623.7074485,0.0552407,266.6979589,221.45618,417.9694411,0.6112419,3.9774759,1.7126934,8.8069811),(27778,'cephalophus_sylvicultor_metatarsus.tif',240,10,84,123.0814287,50.2232701,41.5924496,1.8,50.2730577,41.8402004,0.0093417,10.7666279,9.7783627,2479.9698823,2615.1985614,0.0017901,267.447489,230.3385899,430.1926513,0.5062438,3.2094832,1.6879051,6.9963208),(27779,'cephalophus_sylvicultor_metatarsus.tif',240,10,85,122.387359,50.1819457,41.6334277,1.8,50.2461163,41.8755594,-0.018141,11.8781956,9.6325274,2465.4108516,2614.9959252,0.0067122,271.4755749,207.5576904,405.566612,15.7360385,17.5730629,2.4468544,55.7210126),(27780,'cephalophus_sylvicultor_metatarsus.tif',240,10,86,121.6698412,50.1396318,41.6643744,1.8,50.17297,41.9043808,-0.0439988,10.8441261,9.6734895,2439.1319347,2613.0696875,0.0392314,270.1268965,224.9265565,424.0692545,15.6343409,17.5510427,2.4318076,55.8763427),(27781,'cephalophus_sylvicultor_metatarsus.tif',240,10,87,119.7565207,50.1001403,41.6850262,1.8,50.1269737,41.9237743,-0.0499463,10.4250788,9.4410484,2406.554729,2607.0909854,0.04975,276.1442245,230.8428333,451.4429436,0.375,0.9560662,1.7681919,2.3409904),(27782,'cephalophus_sylvicultor_metatarsus.tif',240,10,88,118.4922911,50.0610301,41.7174328,1.8,50.0914816,41.9350287,-0.0597284,11.6321046,9.309631,2383.4402024,2604.3581147,0.0703696,279.7488004,204.9018894,423.6353851,15.5617443,17.5510427,2.4318076,55.8763427),(27783,'cephalophus_sylvicultor_metatarsus.tif',240,10,89,117.0896844,50.0560672,41.7081762,1.8,50.1091697,41.9603077,-0.0629096,11.5326633,9.5213486,2349.7118638,2588.5977768,0.077131,271.8730164,203.7440784,403.4882731,15.5212008,17.5139464,2.4852443,55.7665078),(27784,'cephalophus_sylvicultor_metatarsus.tif',240,10,90,116.1677063,50.0161259,41.7621883,1.8,50.0698966,42.0582175,-0.0728965,11.7296217,9.9810104,2327.5701674,2582.442208,0.1027018,258.7355486,198.4352282,392.1829785,0.375,1.5116734,1.6951513,3.3106604),(27785,'cephalophus_sylvicultor_metatarsus.tif',240,10,91,115.4542154,49.9740992,41.8066725,1.8,50.0186959,42.1025273,-0.0681153,11.5121436,10.0872293,2311.723689,2593.2759851,0.0891408,257.0850627,200.807406,399.5570382,0.1875,0.2651651,2.3561945,0.5303301),(27786,'cephalophus_sylvicultor_metatarsus.tif',240,10,92,115.2213638,49.9200643,41.8419216,1.8,49.9825345,42.091746,-0.0698804,11.3303053,10.1396991,2298.1461178,2613.6949014,0.0936236,257.7684864,202.8317903,410.3456172,0.5341053,1.0933035,1.0303768,2.4963205),(27787,'cephalophus_sylvicultor_metatarsus.tif',240,10,93,115.2060336,49.8654951,41.889188,1.8,49.8940466,42.1439794,-0.0852816,11.2501472,9.6395788,2296.0301411,2638.7518554,0.1393096,273.7414052,204.0888979,411.1370945,0.375,1.0097185,1.1902899,2.1856603),(27788,'cephalophus_sylvicultor_metatarsus.tif',240,10,94,115.208665,49.8397458,41.9219314,1.8,49.9089686,42.1950767,-0.0701318,10.6302789,9.8902161,2291.2271766,2664.9730661,0.0942869,269.4554938,215.5378228,408.5536005,0.375,1.0097185,1.1902899,2.1856603),(27789,'cephalophus_sylvicultor_metatarsus.tif',240,10,95,115.7081075,49.8058213,41.9514408,1.8,49.872631,42.1648657,-0.0675972,10.548673,9.9298896,2289.8629367,2689.8357366,0.0879849,270.8827433,217.0759242,411.8899775,0.1875,0.4192628,2.0344439,0.9053301),(27790,'cephalophus_sylvicultor_metatarsus.tif',240,10,96,115.4305755,49.7751755,41.9941162,1.8,49.8898651,42.2055342,-0.0835658,10.4462576,9.9401679,2279.4852091,2708.1800376,0.1340341,272.4481174,218.2107016,426.283809,0.375,0.8385255,1.1071487,1.8106603),(27791,'cephalophus_sylvicultor_metatarsus.tif',240,10,97,114.8695243,49.7752419,41.9943281,1.8,49.8683886,42.2521625,-0.0835379,10.8814502,10.1150178,2264.6875693,2703.3135693,0.133294,267.2574203,208.1236903,443.1901641,0.5625,1.3650207,1.2924967,3.0909905),(27792,'cephalophus_sylvicultor_metatarsus.tif',240,10,98,113.8270668,49.7460834,42.0386505,1.8,49.8653421,42.2540338,-0.0831822,10.4047353,9.5054276,2235.4791678,2684.9375315,0.1309642,282.4636253,214.8520941,446.071124,15.2846295,17.717511,2.4536293,55.9406826),(27793,'cephalophus_sylvicultor_metatarsus.tif',240,10,99,114.366939,49.6919188,42.0938446,1.8,49.7490713,42.3726018,-0.0821516,11.7710913,9.8765135,2229.0899408,2698.8925257,0.1283526,273.2636898,189.3698618,418.6149054,0.6823615,1.9575576,1.2793395,4.5266507),(27794,'cephalophus_sylvicultor_metatarsus.tif',240,10,100,113.4844744,49.6682094,42.1217289,1.8,49.7469117,42.4066223,-0.0678657,11.7414611,10.1631944,2211.5861241,2703.602758,0.08698,266.018996,188.3569778,418.4335043,0.6383213,2.6845916,1.359703,6.337311),(27795,'cephalophus_sylvicultor_metatarsus.tif',240,10,101,113.3020135,49.6337307,42.1536139,1.8,49.6936959,42.4253527,-0.0569588,11.5305653,9.8770748,2193.1424034,2721.9687462,0.0611981,275.5845014,190.2025049,411.1677587,0.5625,1.3650207,1.2924967,3.0909905),(27796,'cephalophus_sylvicultor_metatarsus.tif',240,10,102,112.7708131,49.60666,42.1853931,1.8,49.669167,42.4169772,-0.0476203,10.119478,10.4528646,2166.9378827,2735.8896399,0.0425895,261.7358734,214.1353411,415.4892659,0.375,1.0097185,1.1902899,2.1856603),(27797,'cephalophus_sylvicultor_metatarsus.tif',240,10,103,112.8059587,49.5684435,42.2063001,1.8,49.6504929,42.4354676,-0.0363791,11.2826591,9.6962968,2149.7105863,2746.9290856,0.024871,283.2967196,190.5322647,418.2721622,0.375,1.0097185,1.1902899,2.1856603),(27798,'cephalophus_sylvicultor_metatarsus.tif',240,10,104,112.846708,49.5319741,42.2354681,1.8,49.6265394,42.4397373,-0.0278624,10.8892286,9.9082447,2127.748178,2760.2750315,0.0145969,278.5836554,195.3993491,387.4081542,0.4746106,0.8385255,1.1071487,1.9659904),(27799,'cephalophus_sylvicultor_metatarsus.tif',240,10,105,111.9510864,49.5495177,42.1983217,1.8,49.6403657,42.4275921,-0.0203018,10.7733923,10.2953476,2079.9402909,2751.7089902,0.0076893,267.2769388,193.0627084,412.7088829,0.4626964,1.5461647,1.3258177,3.4659905),(27800,'cephalophus_sylvicultor_metatarsus.tif',240,10,106,110.8968143,49.5392959,42.2278645,1.8,49.678905,42.4414858,-0.0132945,10.4357583,10.1102796,2039.6965814,2747.5301102,0.0032665,271.7560957,195.4526463,433.6440083,0.5625,2.0710053,1.6614562,5.1213207),(27801,'cephalophus_sylvicultor_metatarsus.tif',240,10,107,110.6570486,49.5076142,42.2537668,1.8,49.6144105,42.4825692,-0.0072714,10.9658961,9.7467039,2024.7684135,2761.1050138,0.0009751,283.286025,184.6423128,407.4069553,0.5457914,1.5116734,1.6951513,3.4659905),(27802,'cephalophus_sylvicultor_metatarsus.tif',240,10,108,110.2033838,49.4893346,42.2711431,1.8,49.6118823,42.4750459,-0.0020777,11.1581772,9.7619905,1998.7641383,2775.1101152,0.0000793,284.2770753,179.1299872,403.3110432,14.7503925,18.2116475,2.6364941,55.9406826),(27803,'cephalophus_sylvicultor_metatarsus.tif',240,10,109,109.828224,49.4555996,42.2989451,1.8,49.5730515,42.4418663,-0.0004586,11.1367717,10.3559223,1971.6916801,2788.1027045,0.0000039,269.2278517,177.0433782,403.3960433,0.375,0.7730824,1.815775,1.9659904),(27804,'cephalophus_sylvicultor_metatarsus.tif',240,10,110,109.3659938,49.4510222,42.3216581,1.8,49.6088461,42.4931443,0.0048691,11.8755087,10.371661,1937.412537,2811.9281665,0.0004321,271.1164753,163.143541,394.6119766,0.5625,2.2577991,1.6539376,5.2766508),(27805,'cephalophus_sylvicultor_metatarsus.tif',240,10,111,107.8802159,49.3831916,42.3311276,1.8,49.4529107,42.5009566,0.0061353,11.8680899,10.4420389,1903.959368,2825.7676663,0.0006768,270.6145497,160.4267735,393.6530456,0.375,0.8385255,1.1071487,1.8106603),(27806,'cephalophus_sylvicultor_metatarsus.tif',240,10,112,107.9919382,49.3805435,42.33209,1.8,49.4406644,42.5312527,0.0026247,11.6729731,10.4374503,1882.1064555,2888.4598286,0.000124,276.7399834,161.2362544,403.3080129,0.375,0.8385255,1.1071487,1.8106603),(27807,'cephalophus_sylvicultor_metatarsus.tif',240,10,113,109.2006422,49.4163159,42.3227729,1.8,49.4471211,42.5421273,-0.0026866,11.1290197,10.2090144,1860.2295619,2970.4620266,0.0001314,290.9646226,167.151251,391.8395739,0.1875,0.5929271,1.8925469,1.2803302),(27808,'cephalophus_sylvicultor_metatarsus.tif',240,10,114,111.1061218,49.3437154,42.3969501,1.8,49.4008293,42.6042194,0.0042728,11.6086887,10.4702013,1865.9731633,3044.9909947,0.0003381,290.8244938,160.7393577,419.5344398,14.3186495,18.8789329,2.8701142,57.7324982),(27809,'cephalophus_sylvicultor_metatarsus.tif',240,10,115,110.8022014,49.3399851,42.4583907,1.8,49.3947201,42.6879765,0.0023672,12.1063631,10.6615667,1878.1996247,3123.0683224,0.0001035,292.9277097,155.1415241,411.8806391,14.3420174,19.162648,2.8538847,58.4181584),(27810,'cephalophus_sylvicultor_metatarsus.tif',240,10,116,111.098771,49.313527,42.5488925,1.8,49.3377887,42.6646436,-0.0008139,11.6393693,10.6860044,1875.157014,3230.1623538,0.0000123,302.2797152,161.1046933,420.7085837,0.1875,0.4192628,2.0344439,0.9053301),(27811,'cephalophus_sylvicultor_metatarsus.tif',240,10,117,112.3570453,49.2750477,42.624267,1.8,49.2567381,42.736409,-0.0022539,10.4429429,10.9104545,1902.6552241,3403.3924156,0.0000952,311.9386478,182.19531,388.9281523,14.5106831,19.8829596,2.8645883,59.6529934),(27812,'cephalophus_sylvicultor_metatarsus.tif',240,10,118,113.9429865,49.2465929,42.7223007,1.8,49.2044357,42.7905464,-0.0010618,11.8406642,11.1267825,1941.7326572,3630.715708,0.0000214,326.3041859,163.9884918,470.3119433,0.375,0.6760409,0.9827937,1.4356603),(27813,'cephalophus_sylvicultor_metatarsus.tif',240,10,119,114.5312039,49.2519335,42.8016659,1.8,49.1594988,42.9010342,-0.003049,12.6973199,11.3101036,1995.5740602,3823.9105861,0.0001774,338.0968679,157.1649829,458.1466949,14.8281478,20.7439763,2.9229237,65.0849743),(27814,'cephalophus_sylvicultor_metatarsus.tif',240,10,120,115.491822,49.2282439,42.8982948,1.8,49.1788527,42.9889046,-0.0056458,12.0373753,11.7099105,2086.4437341,4044.5952918,0.0006136,345.3993344,173.3304546,509.1075485,0.1875,0.5929271,1.8925469,1.2803302),(27815,'cephalophus_sylvicultor_metatarsus.tif',240,10,121,116.4121168,49.2528062,42.9568149,1.8,49.1980649,43.0712743,-0.0102544,11.791258,11.3885436,2165.2733881,4287.3959783,0.0020401,376.4656947,183.6337894,547.1200997,15.5069281,21.8306707,3.0555984,68.3312948),(27816,'cephalophus_sylvicultor_metatarsus.tif',240,10,122,116.7868292,49.1920833,43.0252064,1.8,49.1794962,43.1053685,-0.0208336,11.5880801,11.5962996,2233.9406727,4501.3544012,0.0084471,388.171621,192.7791879,569.9447692,0.1875,0.4192628,2.0344439,0.9053301),(27817,'cephalophus_sylvicultor_metatarsus.tif',240,10,123,118.114926,49.1587211,43.0941388,1.8,49.1522295,43.1602987,-0.0274545,11.1654645,12.5232141,2319.9847656,4748.8904907,0.0148345,379.2070043,207.7821993,564.1251801,0.1875,0.2651651,2.3561945,0.5303301),(27818,'cephalophus_sylvicultor_metatarsus.tif',240,10,124,118.9301569,49.0872958,43.187277,1.8,49.0752472,43.238192,-0.0337955,11.4270242,12.229448,2375.428441,5036.3283642,0.0226305,411.8197619,207.8781321,596.897877,0.3562946,1.2577883,1.1071487,2.7159904),(27819,'cephalophus_sylvicultor_metatarsus.tif',240,10,125,119.809532,49.0754454,43.3357595,1.8,49.0524643,43.3019756,-0.0406808,10.3971299,12.5550235,2361.9314487,5364.6750227,0.0330278,427.2931083,227.1714867,604.9149,16.5076077,24.3295264,0.108104,73.6534407),(27820,'cephalophus_sylvicultor_metatarsus.tif',240,10,126,123.2553883,49.0689511,43.5345541,1.8,49.0735659,43.4267444,-0.0468185,10.913185,12.7661746,2408.9886358,5753.8500715,0.044996,450.7105881,220.7411154,628.0905744,16.6109589,24.9092901,0.113151,74.7784408),(27821,'cephalophus_sylvicultor_metatarsus.tif',240,10,127,131.9326124,49.0980792,43.7259986,1.8,49.0648998,43.5496061,-0.0616324,12.6197357,13.0484833,2519.0667643,6407.437716,0.0834197,491.0484666,199.6132743,670.8250648,16.6378862,25.5990738,0.0880074,75.9034408),(27822,'cephalophus_sylvicultor_metatarsus.tif',240,10,128,152.2016952,49.091616,43.835499,1.8,49.0908219,43.7284247,-0.0758714,10.8047653,13.6051579,2780.0623757,7620.4359944,0.1457439,560.1137477,257.2996537,757.7398666,16.7921587,26.2801183,0.1287797,78.3997613),(27823,'cephalophus_sylvicultor_metatarsus.tif',240,10,129,187.767488,49.262982,44.0339685,1.8,49.1813749,44.0072402,-0.0810521,11.8365324,13.5985303,3155.9666528,9417.49767,0.2051382,692.5379031,266.6293254,880.6801402,16.6542787,26.8380577,0.1260881,79.2595964),(27824,'cephalophus_sylvicultor_metatarsus.tif',240,10,130,177.0219895,49.4176558,44.1668011,1.8,49.2833658,44.1808706,-0.0539966,10.8859249,13.6946914,2956.0254112,8823.4628697,0.0859384,644.2980445,271.5456362,846.9340838,16.7119905,27.2101216,0.124355,80.4755867),(27825,'cephalophus_sylvicultor_metatarsus.tif',240,10,131,179.2205551,49.2408544,44.3774422,1.8,49.3060528,44.5002915,-0.0720134,11.0100262,14.0803291,2886.3281503,8941.8643267,0.1546367,635.0607468,262.1545205,832.9339028,0.3356004,0.8385255,1.1071487,1.8106603),(27826,'cephalophus_sylvicultor_metatarsus.tif',240,10,132,182.598645,49.1858775,44.648364,1.8,49.2904311,44.8961785,-0.0882499,10.6684028,13.7293771,2856.7551895,8950.4520387,0.2363994,651.9197469,267.7772149,852.4590469,0.1875,0.2651651,2.3561945,0.5303301),(27827,'cephalophus_sylvicultor_metatarsus.tif',240,10,133,182.5271499,49.1794212,44.8500814,1.8,49.2861837,45.1465886,-0.1043423,10.4350789,13.5441792,2990.5573792,8843.1048925,0.3300046,652.9081451,286.5869439,842.2620131,17.3806118,26.7600027,0.2840744,117.9424721),(27828,'cephalophus_sylvicultor_metatarsus.tif',240,10,134,179.2191914,49.1667005,44.8847603,1.8,49.2030035,45.2426543,-0.124582,11.1102592,13.6881291,3431.7261415,9093.8592262,0.4612071,664.3610062,308.8790339,862.0712064,18.1270775,27.0526847,3.0791738,110.0973553),(27829,'cephalophus_sylvicultor_metatarsus.tif',240,10,135,181.9876932,49.2178871,44.8902569,1.8,49.2820435,45.2852922,-0.1250474,11.3509101,13.7756481,3869.9432674,9369.4722814,0.4718191,680.1474747,340.9368276,892.6054989,18.4602508,27.2101216,0.5191461,133.7646187),(27830,'cephalophus_sylvicultor_metatarsus.tif',240,10,136,184.5017383,49.2832416,44.9122669,1.8,49.3200038,45.3251294,-0.1191598,11.3433934,13.6964308,4009.8151519,9583.9453425,0.4345627,699.7403557,353.4934406,913.6174758,18.4738757,27.4660319,0.5216863,128.9461525),(27831,'cephalophus_sylvicultor_metatarsus.tif',240,10,137,186.2506447,49.236617,44.9163856,1.8,49.2695936,45.275078,-0.12525,12.1651076,13.6821006,3811.4462742,9836.0594596,0.4844289,718.8998058,313.3097042,925.6316504,0.375,0.6760409,2.1587989,1.4356603),(27832,'cephalophus_sylvicultor_metatarsus.tif',240,10,138,184.1237979,49.1289498,44.9929011,1.8,49.1489823,45.2669732,-0.1321594,11.3549663,13.8103711,3323.7400131,9678.7553374,0.5328741,700.8323888,292.7124502,900.8646541,12.1875008,18.2531045,0.9827937,55.2927118),(27833,'cephalophus_sylvicultor_metatarsus.tif',240,10,139,169.046676,48.9854901,44.9562969,1.8,49.1061645,45.1872146,-0.1354438,10.1785757,13.8463864,2472.9827283,8519.3299182,0.5137078,615.2746035,242.9596039,773.4753413,0.1875,0.5929271,1.8925469,1.2803302),(27834,'cephalophus_sylvicultor_metatarsus.tif',240,10,140,125.6167273,48.4240569,44.9671901,1.8,48.8308071,45.0219524,-0.131277,8.7627829,13.6045117,1471.0472686,4993.1823034,0.3587381,367.0239996,167.8744396,466.7957406,12.0000008,15.7254282,0.8867447,65.0960132),(27835,'cephalophus_sylvicultor_metatarsus.tif',240,10,141,73.9899276,48.8645781,44.846446,1.8,48.6224675,44.9721114,-0.1382586,7.6584487,11.9329646,677.9930505,1310.2550149,0.234227,109.801299,88.528771,166.4236889,0.4936428,2.6516506,1.4288993,5.8713207),(27836,'cephalophus_sylvicultor_metatarsus.tif',240,10,142,31.8654372,48.5570131,44.8006231,1.8,48.8993131,44.7522493,-0.1467093,4.7338164,6.8940779,110.710078,561.1632627,0.1134921,81.3978705,23.3870663,86.9735705,5.4985175,9.787788,1.218752,26.9057782),(27837,'cephalophus_sylvicultor_metatarsus.tif',240,10,143,0.118924,43.9619081,45.4204543,1.8,43.9642885,45.4196457,1.4948782,0.333375,1.0840687,0.0047384,0.0376755,0.0197067,0.0347538,0.0142133,0.0391191,0.75,2.3192471,1.815775,5.2311556),(27838,'cephalophus_sylvicultor_metatarsus.tif',240,10,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27839,'cephalophus_sylvicultor_metatarsus.tif',240,10,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27840,'cephalophus_sylvicultor_metatarsus.tif',240,10,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27841,'cephalophus_sylvicultor_metatarsus.tif',240,10,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27842,'cephalophus_sylvicultor_metatarsus.tif',240,10,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27843,'cephalophus_sylvicultor_metatarsus.tif',240,10,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27844,'cephalophus_sylvicultor_metatarsus.tif',240,10,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27845,'cephalophus_sylvicultor_metatarsus.tif',240,10,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27846,'cephalophus_sylvicultor_metatarsus.tif',240,10,152,2.485675,66.7133346,38.6251615,1.8,66.5558316,38.6099891,-1.5702978,1.8385174,4.5006445,1.3454278,9.6402065,0.4142791,2.1419614,0.7318005,2.3859025,9.5625006,10.2011035,1.8692953,32.1258948),(27847,'cephalophus_sylvicultor_metatarsus.tif',240,10,153,79.2452123,47.987432,40.8015454,1.8,45.8624224,39.645749,-0.258354,17.148152,21.3748055,3266.2152778,6656.7097671,0.8621207,311.427852,190.4703942,457.1472737,25.0197005,28.5745343,1.3592447,106.9387918),(27848,'cephalophus_sylvicultor_metatarsus.tif',240,10,154,382.7877645,44.6055998,39.2903712,1.8,46.6460776,39.3646715,-0.3460649,17.4504371,24.9283688,20548.2105368,21536.2375841,7.3403186,863.9248625,1177.5183842,1686.6134996,28.8750018,29.2656227,2.2745581,95.6198787),(27849,'cephalophus_sylvicultor_metatarsus.tif',240,10,155,402.7079694,45.0539094,39.2303365,1.8,47.4754902,39.3115626,-0.0975367,16.475218,23.5709619,21496.3411745,25540.8355849,0.6364987,1083.5720547,1304.7682425,1877.855507,28.8750018,29.2127184,0.63965,95.7297137),(27850,'cephalophus_sylvicultor_metatarsus.tif',240,10,156,413.4249167,45.4709781,39.2297877,1.8,48.1127426,39.3011657,-0.0771593,17.0614545,23.0642247,22048.8857449,28510.6314195,0.4094113,1236.1408949,1292.3215736,2007.8008015,28.8750018,29.2271564,2.4197452,95.7297137),(27851,'cephalophus_sylvicultor_metatarsus.tif',240,10,157,422.9660259,45.8094225,39.2287205,1.8,48.639987,39.2926242,-0.0691846,16.3949642,22.6970305,22607.3681634,30838.258096,0.3368833,1358.6913071,1378.9214731,2116.7552655,28.8750018,29.2451937,2.4287939,95.8850438),(27852,'cephalophus_sylvicultor_metatarsus.tif',240,10,158,430.9658955,46.0820042,39.2304587,1.8,49.0224867,39.2720438,-0.0665325,16.9599174,22.4456154,23123.2320243,32671.711347,0.3174812,1455.5943681,1363.4047531,2196.641328,28.8750018,29.25541,2.2335258,95.8850438),(27853,'cephalophus_sylvicultor_metatarsus.tif',240,10,159,437.5442486,46.2986912,39.2286931,1.8,49.3247101,39.2518462,-0.0666938,17.072568,22.2562013,23523.9601553,34116.208635,0.3238902,1532.8855197,1377.8805935,2267.8953207,28.8750018,29.2241491,2.2425313,95.7752088),(27854,'cephalophus_sylvicultor_metatarsus.tif',240,10,160,442.8669694,46.4617589,39.2357565,1.8,49.5421158,39.2488773,-0.0671707,16.3246896,22.1375803,23926.8634121,35174.5479266,0.3325277,1588.9066231,1465.6856594,2309.3319569,28.8750018,29.2241491,2.2425313,95.7752088),(27855,'zebu_humerus.tif',238,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27856,'zebu_humerus.tif',238,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27857,'zebu_humerus.tif',238,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27858,'zebu_humerus.tif',238,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27859,'zebu_humerus.tif',238,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27860,'zebu_humerus.tif',238,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27861,'zebu_humerus.tif',238,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27862,'zebu_humerus.tif',238,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27863,'zebu_humerus.tif',238,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27864,'zebu_humerus.tif',238,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(27865,'zebu_humerus.tif',238,2,11,2.1641765,46.0265364,31.9962294,1.8,46.0362548,32.0154888,1.0419946,2.2675759,2.6057202,2.0776033,3.2483122,0.2688919,1.2466082,0.9162222,2.0365018,4.3949961,5.3450531,1.927016,18.2616461),(27866,'zebu_humerus.tif',238,2,12,36.7811008,45.850216,32.3651788,1.8,45.7940554,32.4773942,-0.789432,2.7467409,7.397669,47.2167144,433.6807303,3.0898194,58.6239704,17.1900867,64.4090301,5.4520796,14.0284593,0.844154,33.3695124),(27867,'zebu_humerus.tif',238,2,13,65.1329716,45.3958843,32.7847893,1.8,45.3936698,32.9699941,-0.7919611,3.7154506,9.0889369,169.2930675,1170.7382203,5.4989897,128.8091486,45.564613,146.5426349,7.3044721,16.9598573,0.8778171,41.6424338),(27868,'zebu_humerus.tif',238,2,14,109.3141767,44.0168072,36.0637807,1.8,43.9776178,36.2788005,-1.1192042,6.1922211,13.692899,693.2385631,4836.133575,14.7493286,353.1855132,111.9531347,379.6980596,10.9113551,25.1221683,1.3415644,67.8260808),(27869,'zebu_humerus.tif',238,2,15,133.9193032,43.2837985,37.7669048,1.8,43.5142802,37.9771411,-1.2816909,7.2796012,18.2804625,1342.7493726,7277.9372404,20.5057436,398.1265383,184.4536984,442.5302005,13.316598,31.5035079,1.5152978,83.3551207),(27870,'zebu_humerus.tif',238,2,16,143.6845506,42.8253589,39.4302837,1.8,43.2212094,40.2834563,-1.4431696,8.6905573,22.9330898,1914.6601955,10546.3378351,23.5594691,459.874265,220.3150061,534.8277994,14.9236402,37.0653173,1.5393601,97.3282634),(27871,'zebu_humerus.tif',238,2,17,143.6026064,42.7718212,40.8061589,1.8,42.8744253,41.5717703,-1.5186907,8.9303909,23.8815613,2043.2703376,13181.4749787,23.8688463,551.9519779,228.7996532,634.1624934,15.9268713,38.9404671,1.6096988,99.2487989),(27872,'zebu_humerus.tif',238,2,18,143.1224934,42.6105354,41.9852071,1.8,42.5263635,42.7424937,-1.5661555,9.0919143,24.0634213,2112.9067323,15366.9339426,23.8532352,638.6013758,232.394044,724.2308848,16.6250297,39.8699063,1.6556362,101.3740668),(27873,'zebu_humerus.tif',238,2,19,143.6501885,42.3680706,43.0593723,1.8,42.1920743,43.8774048,1.5356965,9.0851835,24.2293507,2108.082697,16912.9027289,23.9122138,698.0336745,232.0352371,783.5016088,16.9124371,40.7067118,1.6884067,101.8800434),(27874,'zebu_humerus.tif',238,2,20,144.7273223,42.1488602,44.0682755,1.8,41.9179534,45.0099819,1.4971566,8.9621098,24.2264468,2039.8693412,18061.9383682,23.990652,745.5463259,227.6103938,828.9821368,16.8925019,41.2225712,1.7182888,102.5790434),(27875,'zebu_humerus.tif',238,2,21,145.4188417,41.967035,45.0471115,1.8,41.7745353,46.0653359,1.4617566,9.0948778,24.040421,2020.2905936,18702.2988846,23.9494505,777.9522185,222.1349893,861.4424102,16.9140379,41.4651682,1.7373307,102.3908699),(27876,'zebu_humerus.tif',238,2,22,153.9236761,42.6793829,44.7058318,1.8,42.4269695,45.8411945,-1.5346281,18.7938292,27.045347,4656.4772696,23320.1046779,25.620402,862.2594009,247.7662867,872.9307172,16.8942018,41.4302942,1.7488893,102.2777993),(27877,'zebu_humerus.tif',238,2,23,193.330691,45.4050449,40.7829936,1.8,45.0438096,41.8488898,-1.2676962,13.1786928,27.7670539,7891.5948583,44032.2809963,29.3511253,1585.7743191,598.8146917,1790.3731184,17.1866243,41.1561753,1.7876231,102.5673346),(27878,'zebu_humerus.tif',238,2,24,246.3297381,46.7025653,38.1035055,1.8,46.5388547,39.2720222,-1.2638077,13.9085846,30.9394277,9060.6289636,57249.1494889,37.3058806,1850.3622655,651.4414814,2075.1671785,18.1391298,41.0586113,1.8026993,104.1983348),(27879,'zebu_humerus.tif',238,2,25,265.883422,46.7456497,37.9665342,1.8,47.1346805,38.1526017,-1.2929214,14.3157542,31.5635697,10043.6116482,60507.6763396,40.9793937,1917.0099233,701.57754,2182.1004343,25.1194685,56.8109302,1.3009472,162.0591087),(27880,'zebu_humerus.tif',238,2,26,279.0012628,46.3232629,38.1922709,1.8,46.9517681,37.8960649,-1.3223432,14.499481,31.7463424,11022.0370989,61951.7867269,43.6883804,1951.4621833,760.1676999,2249.8466186,25.8180579,57.4393507,1.3686275,160.0020849),(27881,'zebu_humerus.tif',238,2,27,292.1229815,46.3248337,38.7233863,1.8,47.2947765,38.1546454,-1.3551342,15.926976,31.2745481,14139.1640583,64389.0975699,46.4576044,2058.8338247,887.7494428,2478.1279919,26.7184915,57.3930195,1.3726046,162.0708175),(27882,'zebu_humerus.tif',238,2,28,328.5124852,47.7499837,40.0608759,1.8,48.4996781,38.8431329,-1.4340306,17.3817261,30.3335436,22832.4839597,67276.7264029,53.7343218,2217.8986819,1313.5912893,2968.9521749,33.3190038,57.2560529,1.345065,201.5597158),(27883,'zebu_humerus.tif',238,2,29,356.6430826,49.0965526,41.4056736,1.8,49.8405817,39.8804744,-1.5368294,19.2455451,28.8548936,31079.3450567,71096.4203079,59.3719594,2463.9293892,1614.8851521,3518.5533585,36.5574737,57.0927331,1.4418856,172.9846833),(27884,'zebu_humerus.tif',238,2,30,400.6525765,51.299125,42.5342826,1.8,51.542733,40.9268542,1.4746176,21.7684463,29.0577306,48878.6653287,75822.7844231,66.1596369,2609.3842461,2245.3906314,4288.9246371,40.0272396,56.7756812,1.4535677,172.0244156),(27885,'zebu_humerus.tif',238,2,31,426.9731802,52.4651002,43.3757082,1.8,52.8990475,41.4510344,1.3153115,22.2676271,29.9725323,60951.7433671,81056.3041951,66.6174499,2704.3528835,2737.2356791,4718.1095193,42.2044262,56.4664641,1.4653794,174.3992423),(27886,'zebu_humerus.tif',238,2,32,441.1174797,52.8920427,44.1322521,1.8,53.2669406,41.9044943,1.1546803,22.175126,30.1696327,67783.5035322,86095.8765345,61.5074716,2853.7263764,3056.7358861,4984.8795682,42.8773133,56.0279076,1.481266,177.2352191),(27887,'zebu_humerus.tif',238,2,33,458.5568884,53.3664205,44.7833696,1.8,53.5771217,42.685478,0.8907073,23.8050229,28.5409419,74463.9799961,91542.7962864,46.2020703,3207.4202957,3128.0784849,5271.9615162,43.4406694,55.574414,1.4784283,178.1720692),(27888,'zebu_humerus.tif',238,2,34,474.3982954,54.0583873,45.3490847,1.8,54.2002291,43.1764992,0.6504362,24.6727344,28.3162079,77980.2531698,97735.3869365,28.9913457,3451.5704686,3160.5841428,5488.4067641,44.2882507,54.8817702,1.5028161,182.9665491),(27889,'zebu_humerus.tif',238,2,35,491.2715157,54.5837361,45.7864823,1.8,54.7247853,43.7774791,0.4963538,25.2670554,30.4538708,78076.0161576,106499.0533915,18.5690752,3497.0613118,3090.0322588,5740.5080028,44.8594082,55.0916972,2.796435,186.2733759),(27890,'zebu_humerus.tif',238,2,36,507.3709959,54.9103646,46.1560764,1.8,55.0199787,44.3504291,0.4387663,25.4617109,31.497791,77937.6885344,115959.7377476,15.2612602,3681.5196922,3060.9761046,6069.4093075,44.9510774,56.376859,2.8002368,182.1145019),(27891,'zebu_humerus.tif',238,2,37,518.3628169,55.0531174,46.3555559,1.8,55.2641137,44.8018148,0.4198539,24.9666558,32.0108399,76445.363661,124385.7565957,14.3551786,3885.738611,3061.8984072,6239.3647649,45.0117649,57.3659363,2.8063554,182.3240843),(27892,'zebu_humerus.tif',238,2,38,524.1008025,55.1957568,46.4665398,1.8,55.4341854,45.1492382,0.4051285,24.3285674,32.3535466,74452.1925239,131081.9177206,13.5693037,4051.5470927,3060.2785273,6322.1271648,44.4788592,58.0775644,2.7957351,179.2219898),(27893,'zebu_humerus.tif',238,2,39,528.6130505,55.4561372,46.5909927,1.8,55.6638526,45.5533422,0.3856723,23.8470064,32.6726343,71210.0433463,137933.1358724,12.4676062,4221.6717145,2986.1208641,6372.2821316,43.7242976,58.5949902,2.844994,178.346525),(27894,'zebu_humerus.tif',238,2,40,528.1390058,55.6874972,46.636162,1.8,55.7776461,45.7844895,0.3784246,23.3439316,32.9031625,68709.9231503,143539.7156203,12.0150292,4362.4899508,2943.3740719,6420.974555,42.9316364,59.0595321,2.8079899,175.13621),(27895,'zebu_humerus.tif',238,2,41,525.6554693,55.806371,46.6655417,1.8,55.944668,45.9633018,0.3814154,22.8445564,32.7764761,67094.8496341,148508.1708511,12.1390147,4530.9376946,2937.0169579,6528.6435598,42.0655248,59.2302613,2.8503243,172.782792),(27896,'zebu_humerus.tif',238,2,42,517.2804773,55.741027,46.5834866,1.8,55.9767864,46.1286511,0.3880788,22.1407456,32.2062981,64352.7625843,149559.1450048,12.3453067,4643.7856448,2906.5309561,6594.4758279,41.0196511,58.9850279,2.8304601,170.9987448),(27897,'zebu_humerus.tif',238,2,43,507.1890835,55.795038,46.5457651,1.8,56.1233452,46.2446948,0.3983017,21.6239615,31.5899387,61434.8664408,145250.0786832,12.7161058,4597.9854621,2841.0551156,6477.2394772,39.7553162,58.4710538,2.8066104,167.4706267),(27898,'zebu_humerus.tif',238,2,44,495.2792792,55.9254923,46.5429298,1.8,56.2378651,46.3174908,0.4196145,21.0551603,31.2626449,57703.8892555,137066.912849,13.7012084,4384.3671311,2740.6055532,6160.8404309,38.2509072,58.0775644,2.7957351,165.5783589),(27899,'zebu_humerus.tif',238,2,45,488.3000606,55.9835839,46.7212626,1.8,56.3323095,46.436666,0.4478931,20.7064172,31.0827734,54362.9292231,129722.5037736,15.263235,4173.4533126,2625.4145652,5848.5277806,36.8256058,57.7193788,2.7892004,163.533044),(27900,'zebu_humerus.tif',238,2,46,481.1404185,55.9071781,46.7876772,1.8,56.2355229,46.3397875,0.4624884,20.2791623,30.8685765,50241.1648708,122073.3404954,15.9637163,3954.6151531,2477.4773241,5523.4158862,35.6358927,57.2574751,2.7380367,164.8862177),(27901,'zebu_humerus.tif',238,2,47,462.4684147,55.6108761,45.9845894,1.8,55.8271201,45.6830183,0.4117331,18.6006872,30.3378932,43133.6924602,112124.0724139,12.3447134,3695.842408,2318.9300516,5085.2590164,34.3349878,56.6838115,2.7202381,167.6422415),(27902,'zebu_humerus.tif',238,2,48,448.4165659,55.3315037,45.296278,1.8,55.4418097,45.1814302,0.359022,16.8909737,29.82016,38114.162411,102259.7735106,9.2263954,3429.2161196,2256.4810696,4679.7361126,32.8571016,55.9881659,2.7328757,166.2276826),(27903,'zebu_humerus.tif',238,2,49,437.9188463,55.131478,44.8904275,1.8,54.5308514,44.7700556,0.3049288,16.4255601,29.5137764,32288.0637769,97774.4654992,6.5786486,3312.8415782,1965.7207225,4395.0239203,30.8196175,55.1942098,2.7450155,161.4263438),(27904,'zebu_humerus.tif',238,2,50,398.3729149,52.9652851,44.2301416,1.8,52.0367046,43.9193397,0.2782438,15.3519148,27.2007732,26330.06274,79614.6449221,5.009021,2926.9258057,1715.0995845,3847.5018759,30.0303807,54.0470922,2.7454751,159.9786672),(27905,'zebu_humerus.tif',238,2,51,347.6861569,49.7503123,43.1203993,1.8,48.9712312,42.8482692,0.178519,14.8134358,23.8172513,22390.1757321,52663.639833,1.8272023,2211.1552364,1511.4775575,3151.210742,29.2018595,45.8344278,2.8343105,128.169902),(27906,'zebu_humerus.tif',238,2,52,324.4819092,48.3771205,42.8232727,1.8,47.8593069,42.5721506,0.1666634,14.4441095,22.3336518,20203.8378906,45423.978075,1.4883148,2033.8804666,1398.7596716,2938.4411788,28.32288,43.0337867,2.8335399,120.334713),(27907,'zebu_humerus.tif',238,2,53,307.820647,47.4144666,42.5246391,1.8,46.983809,42.342644,0.155021,14.274226,21.2898116,18400.0210074,40711.4584774,1.2230543,1912.2507649,1289.0380892,2772.9193326,27.3233944,41.2090701,2.8520313,115.5850595),(27908,'zebu_humerus.tif',238,2,54,295.1372453,46.6965948,42.1407788,1.8,46.2307013,42.0372087,0.154151,14.072364,20.5403368,16486.3335967,37816.1799195,1.159639,1841.0691267,1171.5397313,2639.050443,26.2529666,39.7988668,2.8689222,110.9319179),(27909,'zebu_humerus.tif',238,2,55,282.1836528,46.1405243,41.7519746,1.8,45.625479,41.7211569,0.161634,13.1625032,19.9592272,14664.5755073,35609.975425,1.2180368,1784.1359812,1114.1175258,2504.4205372,25.5135029,38.6263872,2.8885673,107.3686734),(27910,'zebu_humerus.tif',238,2,56,270.1151257,45.6041825,41.4440752,1.8,44.9671138,41.4886345,0.1623258,12.8909071,19.4539975,13368.3133832,33630.5874339,1.1758582,1728.7237475,1037.0343421,2391.2796878,24.7167754,37.7224453,2.9363232,105.0786496),(27911,'zebu_humerus.tif',238,2,57,262.0428909,45.0676013,41.2019556,1.8,44.314673,41.2384358,0.1619198,12.621353,19.0057316,12485.8362478,32096.5634974,1.1350688,1688.7833706,989.2628971,2303.7997017,23.9484263,37.0237336,2.9867902,106.8909645),(27912,'zebu_humerus.tif',238,2,58,256.7901405,44.6761971,41.035711,1.8,43.8029268,40.9574747,0.1600918,12.5065433,18.7327762,11908.1693841,30767.9053408,1.0875563,1642.4637261,952.1551281,2222.2877247,23.3984622,36.4870156,3.0231782,105.2316966),(27913,'zebu_humerus.tif',238,2,59,254.4054468,44.3293735,40.8541788,1.8,43.4011415,40.7210654,0.1551383,12.3635618,18.5552187,11524.6043213,29864.0274997,1.0123403,1609.467822,932.1427352,2172.3697085,22.9098458,36.0678096,3.0120294,102.612161),(27914,'zebu_humerus.tif',238,2,60,255.0824357,43.9707255,40.7085614,1.8,43.0554185,40.5397409,0.1535415,12.0536206,18.3793207,11254.9216867,29329.228249,0.9944094,1595.7732466,933.7378443,2140.6507304,22.6665097,35.7656939,3.0273383,101.6401845),(27915,'zebu_humerus.tif',238,2,61,255.5658446,43.6136861,40.590615,1.8,42.6638376,40.3819075,0.1509089,12.1499658,18.2324603,11032.2478928,28810.8351049,0.96268,1580.1945911,908.0064968,2113.5655759,22.5967455,35.5767847,3.0464857,102.0944757),(27916,'zebu_humerus.tif',238,2,62,255.817997,43.253489,40.5362926,1.8,42.3412127,40.3396977,0.1457123,11.9867381,18.1042869,10825.0946514,28502.5183342,0.8988696,1574.3518897,903.0892749,2097.6101352,22.4420199,35.4010552,3.0658304,102.9747904),(27917,'zebu_humerus.tif',238,2,63,257.4284043,42.9673271,40.4861921,1.8,42.0468333,40.2647296,0.1435538,11.9099265,18.070689,10669.9158891,28278.7505098,0.8781104,1564.8960851,895.8842761,2084.2945334,22.296047,35.3033487,3.0589995,101.9696963),(27918,'zebu_humerus.tif',238,2,64,258.2903987,42.7056403,40.4251628,1.8,41.8063518,40.1967099,0.1406224,11.8018612,18.0626355,10509.6704742,28008.1800457,0.845671,1550.6142525,890.5095785,2059.572168,22.1534231,35.2387025,3.0853606,102.1909874),(27919,'zebu_humerus.tif',238,2,65,260.2772584,42.4117883,40.3597238,1.8,41.5978852,40.1766252,0.1297542,11.6469742,18.1790531,10385.786715,28158.5934809,0.7262549,1548.9582039,891.7154359,2037.1973978,22.0305733,35.3617363,3.0822564,101.4237432),(27920,'zebu_humerus.tif',238,2,66,263.6396832,42.1433848,40.3229791,1.8,41.3780046,40.1493343,0.1154912,11.8799339,18.6018658,10346.8687816,28592.7474799,0.5834792,1537.0902998,870.9533956,2010.6826274,21.9381124,35.7928162,0.0390681,102.1792786),(27921,'zebu_humerus.tif',238,2,67,269.0309108,41.8802494,40.2352562,1.8,41.2162386,40.0547581,0.1109307,11.9109426,18.7401693,10300.8296902,29029.7149515,0.5495055,1549.0636474,864.8206962,2003.3658985,21.8635469,36.0096246,0.0842159,102.4688139),(27922,'zebu_humerus.tif',238,2,68,272.0366472,41.8194952,40.1246549,1.8,41.1806022,39.9389555,0.1176753,11.721364,18.7083225,10214.8390443,28894.2730354,0.6249434,1544.4609196,871.4718763,2000.8128128,21.7440509,35.8657358,0.0747789,104.2245935),(27923,'zebu_humerus.tif',238,2,69,272.2792206,41.8466156,40.0015101,1.8,41.2598825,39.8460697,0.1310814,11.6559088,18.5352233,9983.8813737,28228.7596932,0.7752768,1522.9792038,856.5510906,1970.8278864,21.4532778,35.5172221,0.075514,99.7362078),(27924,'zebu_humerus.tif',238,2,70,270.4255594,42.0061254,39.8955654,1.8,41.4660165,39.7688264,0.150099,11.5049237,18.5356495,9783.9789849,27024.7101554,1.0078315,1457.9856089,850.4166786,1911.9314693,21.2238642,35.2063349,3.1051849,100.2304755),(27925,'zebu_humerus.tif',238,2,71,269.1869744,42.1494646,39.7934224,1.8,41.6462931,39.6820527,0.1680207,11.2912414,18.4373141,9623.6614126,25916.9946662,1.2546933,1405.6816831,852.3120788,1862.0296853,20.8423769,34.820254,3.0645642,98.0486723),(27926,'zebu_humerus.tif',238,2,72,268.9792451,42.3300699,39.6884089,1.8,41.8464083,39.6153657,0.1888145,11.163962,18.13952,9503.7208941,24739.4446813,1.5793243,1363.8422999,851.2856698,1837.18315,20.5864292,34.2345553,3.0290564,98.0769399),(27927,'zebu_humerus.tif',238,2,73,267.6680092,42.538603,39.6376632,1.8,42.0638104,39.5946742,0.2034739,11.0984343,18.021478,9345.9342283,23811.2236698,1.8216328,1321.2691918,842.0948375,1786.3266219,20.3913094,33.8652534,3.0727362,96.5424515),(27928,'zebu_humerus.tif',238,2,74,264.3858034,42.7985069,39.6083038,1.8,42.4268907,39.5783623,0.224375,10.9343757,17.6204859,9192.4848732,22637.1659591,2.1814004,1284.7072469,840.6959031,1757.5800714,20.2250167,33.1345782,3.0111322,90.9738685),(27929,'zebu_humerus.tif',238,2,75,262.4932059,42.9656639,39.5698564,1.8,42.7613411,39.5137385,0.2452191,10.8727011,16.8074188,9072.3756885,21620.2384432,2.5784147,1286.3509103,834.4178345,1781.9237647,20.1132811,32.0815316,2.984802,88.8603095),(27930,'zebu_humerus.tif',238,2,76,261.1715378,43.1174916,39.5345495,1.8,42.9771473,39.4585805,0.2568096,10.7467554,16.4850638,8983.3413966,20805.2656229,2.8082041,1262.0676432,835.9119612,1771.3744101,20.0607075,31.5104002,2.9594243,88.03653),(27931,'zebu_humerus.tif',238,2,77,260.7406496,43.2296544,39.5167607,1.8,43.1386093,39.433075,0.267576,10.6775028,16.1639864,8905.5118845,20190.8633008,3.0378212,1249.1264685,834.0444458,1765.8190593,20.0607075,31.0270836,2.9412516,86.8997975),(27932,'zebu_humerus.tif',238,2,78,259.4944941,43.4031835,39.5064434,1.8,43.2924615,39.420738,0.2724851,10.665714,16.020395,8883.9638886,19550.8792111,3.1324709,1220.3743526,832.9460091,1743.3857032,20.1637843,30.6386176,2.9464342,85.7065297),(27933,'zebu_humerus.tif',238,2,79,259.5359994,43.5604033,39.4848633,1.8,43.4516729,39.4220934,0.2753575,10.6034772,15.7901413,8892.8176656,18981.0229898,3.1976864,1202.0806295,838.6699494,1738.616327,20.2854175,30.151905,2.9116082,84.5932149),(27934,'zebu_humerus.tif',238,2,80,258.3568746,43.7418769,39.4864053,1.8,43.5854714,39.3978716,0.2782653,10.5878637,15.6368506,8899.6144902,18391.0338842,3.2489917,1176.1341442,840.548649,1720.1577849,20.3578366,29.7257723,2.8880591,84.746262),(27935,'zebu_humerus.tif',238,2,81,258.5701402,43.8653367,39.4862339,1.8,43.7362776,39.4368656,0.2872536,10.6606448,15.4647904,8882.5715382,17990.9591625,3.4592334,1163.3496948,833.2114711,1721.2196777,20.4025795,29.3658615,2.872557,84.1272149),(27936,'zebu_humerus.tif',238,2,82,257.841524,44.0159841,39.4613127,1.8,43.9168663,39.3998711,0.2943473,10.4996541,15.3192399,8909.3835427,17507.1643841,3.6169522,1142.821997,848.5406755,1706.4869257,20.4387093,29.0461426,2.8528251,83.2751677),(27937,'zebu_humerus.tif',238,2,83,258.4919826,44.1689176,39.4576089,1.8,44.0886521,39.381707,0.3069664,10.4513618,15.1746966,8905.4952988,17224.7243624,3.9336291,1135.0951396,852.0894653,1704.1811314,20.4549392,28.7450651,2.7942067,83.1503883),(27938,'zebu_humerus.tif',238,2,84,259.7603316,44.3098664,39.4488507,1.8,44.2770455,39.3915921,0.3198326,10.2977449,15.0220409,8911.8794651,16963.9713651,4.2796468,1129.2720797,865.4204908,1704.3492184,20.3834423,28.4718024,2.7732437,82.5878765),(27939,'zebu_humerus.tif',238,2,85,261.0873835,44.4347722,39.4567452,1.8,44.4210696,39.4254535,0.338961,10.249033,14.9229762,8881.6505674,16684.9251129,4.8110195,1118.0695413,866.5842489,1695.7126442,20.3583597,28.2797634,2.7794469,82.2300971),(27940,'zebu_humerus.tif',238,2,86,262.9583885,44.5317896,39.4881877,1.8,44.4736258,39.4707432,0.3605174,10.2423127,14.7341853,8851.7806984,16460.9799657,5.4536905,1117.19648,864.236519,1698.6964976,20.2535848,28.0593372,2.7541473,81.5028293),(27941,'zebu_humerus.tif',238,2,87,261.7365137,44.6529902,39.5211233,1.8,44.6002582,39.4922963,0.3770394,10.2184554,14.6284993,8748.762793,16120.4473551,5.913009,1101.9891391,856.1727218,1683.1983153,20.2317837,27.9041245,2.72464,80.7755616),(27942,'zebu_humerus.tif',238,2,88,262.445737,44.7676319,39.5155341,1.8,44.7420775,39.5212211,0.3975958,10.2162855,14.4780798,8684.5823057,15898.6013132,6.5579062,1098.1153219,850.0724,1678.6175872,20.2088756,27.72994,2.7080112,80.7073175),(27943,'zebu_humerus.tif',238,2,89,262.8949513,44.8925061,39.5398963,1.8,44.8410433,39.5146864,0.4217055,10.2581096,14.3734266,8650.6202539,15653.9292434,7.3409273,1089.0881929,843.2957493,1673.9618931,20.2111053,27.6144354,2.6685114,80.349538),(27944,'zebu_humerus.tif',238,2,90,262.8508975,45.0027084,39.5983559,1.8,44.9856366,39.5668795,0.4438775,10.2760704,14.2413497,8613.9378391,15405.4859722,8.0792708,1081.7433974,838.2521269,1666.1562356,20.1610207,27.4747443,2.6419075,79.6339792),(27945,'zebu_humerus.tif',238,2,91,261.856604,45.1056778,39.654409,1.8,45.126137,39.6728752,0.4737428,10.3403747,14.0888189,8507.6544293,15112.1766358,9.0836638,1072.6361604,822.7607482,1652.4841762,20.1123938,27.3395524,2.6245607,79.5540262),(27946,'zebu_humerus.tif',238,2,92,259.948987,45.1948534,39.7407137,1.8,45.2072222,39.7443517,0.5056163,10.4105345,13.9788356,8353.4463081,14820.0035437,10.1636468,1060.174393,802.4032143,1632.9134654,20.1112107,27.2383409,2.6224465,78.9632467),(27947,'zebu_humerus.tif',238,2,93,260.5874417,45.3087097,39.8216387,1.8,45.2909008,39.8158127,0.5290608,10.4215409,13.8908675,8291.2373616,14635.8631338,11.0638931,1053.6320442,795.5865095,1622.48781,20.060116,27.1555009,2.5857218,78.7302467),(27948,'zebu_humerus.tif',238,2,94,258.8785142,45.4226269,39.8844626,1.8,45.4403295,39.8556549,0.5486154,10.4577206,13.8174742,8246.4031735,14385.4367703,11.7344811,1041.104658,788.5469001,1612.1318611,20.0096127,27.0942065,2.5893743,78.6737114),(27949,'zebu_humerus.tif',238,2,95,259.7545588,45.5552725,39.9631482,1.8,45.5901351,39.9456784,0.5670956,10.4472362,13.7285907,8254.6562506,14275.0740087,12.4927758,1039.806222,790.1282314,1614.0365175,20.0096127,26.9950919,2.5871104,78.7019791),(27950,'zebu_humerus.tif',238,2,96,262.2574892,45.6896746,40.0878015,1.8,45.7070966,40.1090772,0.5911243,10.4748979,13.6860229,8250.4750493,14292.4657371,13.5752188,1044.3111061,787.6425267,1620.052921,20.0516066,26.949553,2.5655799,78.5654908),(27951,'zebu_humerus.tif',238,2,97,262.7714143,45.8297434,40.2222047,1.8,45.830154,40.2208236,0.6187104,10.463755,13.6274589,8192.8829927,14289.8428048,14.7319613,1048.6065596,782.9773331,1620.9724412,20.0034726,26.8961167,2.5223502,78.0994907),(27952,'zebu_humerus.tif',238,2,98,263.8808098,45.9438311,40.3668723,1.8,45.8998531,40.3857222,0.647924,10.5103446,13.5741816,8111.5002366,14296.3660499,16.0198234,1053.2027958,771.7634936,1625.6185346,20.004866,26.8650648,2.4946223,77.7134437),(27953,'zebu_humerus.tif',238,2,99,265.0609622,46.0630928,40.5149473,1.8,46.0080289,40.5216452,0.6775837,10.5774437,13.5125265,8036.8069209,14362.3832728,17.3623347,1062.8939926,759.8061646,1630.9663769,20.037713,26.8650648,2.4946223,78.1677349),(27954,'zebu_humerus.tif',238,2,100,266.4698417,46.2198105,40.6638827,1.8,46.1851776,40.653894,0.7023839,10.5593237,13.4772798,8011.4185597,14431.8272238,18.5359354,1070.8264125,758.7056501,1639.3725482,20.0301491,26.8547061,2.4668517,78.786782),(27955,'zebu_humerus.tif',238,2,101,269.477383,46.3778194,40.8221041,1.8,46.351906,40.8016268,0.7259476,10.6027399,13.4598707,8031.5264674,14540.2729103,19.7926389,1080.2683958,757.4953781,1647.275482,20.0624675,26.8650648,2.4390811,78.9349791),(27956,'zebu_humerus.tif',238,2,102,274.510705,46.510298,40.9822394,1.8,46.4317108,40.9724169,0.7502596,10.6149146,13.437419,8104.1768579,14789.4868222,21.2695643,1100.6196069,763.4707574,1673.4672688,20.0637229,26.8943504,2.4512914,77.6451995),(27957,'zebu_humerus.tif',238,2,103,277.8296501,46.6602802,41.1414657,1.8,46.5754488,41.1241121,0.7748198,10.6126694,13.4238154,8188.865597,14985.913233,22.6626785,1116.3676513,771.6122354,1698.2163326,20.1002197,26.9278888,2.4296816,78.6902702),(27958,'zebu_humerus.tif',238,2,104,279.4589666,46.7940803,41.3133477,1.8,46.7134569,41.2748029,0.7961237,10.6204244,13.4292176,8234.324863,15180.4596095,23.7877667,1130.4053601,775.3291703,1716.2253049,20.1002197,27.0520958,2.4049363,78.4972467),(27959,'zebu_humerus.tif',238,2,105,279.869585,46.9260273,41.5174479,1.8,46.8236973,41.4267716,0.8162298,10.6507917,13.4691409,8280.8348917,15383.2917475,24.7596939,1142.1138044,777.485383,1737.8554941,20.1627238,27.0606235,2.4110175,78.3441996),(27960,'zebu_humerus.tif',238,2,106,280.965233,47.0283744,41.7204056,1.8,46.9077591,41.6281518,0.8343161,10.6848644,13.6058466,8330.7742922,15640.470257,25.7008253,1149.5403958,779.6799255,1754.122428,20.1825976,27.1385025,2.3045687,78.8950026),(27961,'zebu_humerus.tif',238,2,107,282.1452397,47.1818657,41.9378887,1.8,47.0833452,41.8526475,0.8550692,10.6669348,13.7047705,8428.2081689,15893.8523203,26.7777365,1159.7313754,790.1246551,1768.9313746,20.2155549,27.3119864,2.2988556,80.4460498),(27962,'zebu_humerus.tif',238,2,108,283.8309963,47.337381,42.1889184,1.8,47.2388387,42.1001648,0.8793595,10.6210138,13.747727,8532.5631578,16204.5881231,28.0713228,1178.7103478,803.3661704,1793.0871932,20.2155549,27.4527529,2.3171753,80.0200262),(27963,'zebu_humerus.tif',238,2,109,286.6285817,47.4603039,42.444213,1.8,47.3833155,42.3746853,0.9041625,10.5904982,13.7414634,8627.6596254,16512.9061546,29.5060584,1201.6846837,814.6604142,1820.6292075,20.195386,27.4863506,2.2932148,80.900341),(27964,'zebu_humerus.tif',238,2,110,289.7391066,47.5923867,42.6667733,1.8,47.5748714,42.5846776,0.9260124,10.5502703,13.7345383,8762.6703945,16790.957851,30.8460117,1222.5352965,830.5635943,1849.1404383,20.2190036,27.4925222,2.2541406,80.5708292),(27965,'zebu_humerus.tif',238,2,111,292.4668366,47.7164924,42.8748782,1.8,47.6801452,42.8159679,0.948253,10.474958,13.7166534,8911.6749897,17061.0717482,32.1708948,1243.8217428,850.7599762,1870.8555578,20.2277015,27.4962245,2.2270086,80.2413174),(27966,'zebu_humerus.tif',238,2,112,294.0578826,47.814247,43.063365,1.8,47.7863557,43.0181101,0.9698132,10.4331756,13.7296727,9076.0890881,17326.0833377,33.339409,1261.9443818,869.9258401,1898.0778655,20.2728362,27.5139885,2.0988708,80.036585),(27967,'zebu_humerus.tif',238,2,113,296.8082713,47.9159804,43.3050686,1.8,47.8641673,43.2635488,1.0013036,10.398155,13.7462602,9274.0297751,17631.5965853,35.0856105,1282.6467907,891.8918548,1931.7099853,20.299459,27.5996867,2.0873246,80.9168998),(27968,'zebu_humerus.tif',238,2,114,301.184833,48.039074,43.5635909,1.8,47.994052,43.5075389,1.0298023,10.3913311,13.7501404,9496.6963636,17974.4803015,36.8844515,1307.2215842,913.905668,1976.0262592,20.3388876,27.6917371,1.8259787,80.8486557),(27969,'zebu_humerus.tif',238,2,115,305.657472,48.1325293,43.779083,1.8,48.0850303,43.7092248,1.0551942,10.4119762,13.7905695,9726.3543493,18201.2661304,38.558337,1319.8342613,934.150654,1987.8290109,20.3934568,28.003899,1.8016488,81.6324587),(27970,'zebu_humerus.tif',238,2,116,311.1415958,48.2259267,43.9952017,1.8,48.2003449,43.9536525,1.0787763,10.4301727,13.8390083,9965.8878584,18290.1437922,40.2840899,1321.636883,955.4863669,2014.5594898,20.4798946,28.003899,1.8016488,81.4677028),(27971,'zebu_humerus.tif',238,2,117,315.5456021,48.3034157,44.2223173,1.8,48.2642462,44.1624533,1.1056244,10.4919268,13.9013634,10222.6038829,18393.2010002,42.0085422,1323.1220865,974.330465,2040.9638823,20.616419,28.148197,1.7665685,81.9619705),(27972,'zebu_humerus.tif',238,2,118,315.8947411,48.3775472,44.3918582,1.8,48.3303319,44.3475888,1.1375354,10.5448953,13.9960904,10485.0104917,18545.8909845,43.3692173,1325.0765351,994.320966,2038.4095518,20.7464138,28.5367966,1.7721951,82.3879941),(27973,'zebu_humerus.tif',238,2,119,318.7872799,48.4140317,44.5415637,1.8,48.3733449,44.5025841,1.1701717,10.616941,14.0791725,10759.7318405,18660.9641324,45.0502204,1325.4304592,1013.4493405,2056.9481149,20.894508,28.37463,1.8366883,81.8937264),(27974,'zebu_humerus.tif',238,2,120,321.7623014,48.4460909,44.7039504,1.8,48.4007143,44.6804541,1.2064202,10.7107646,14.2298122,11011.8459877,18805.2313164,46.8165746,1321.5375612,1028.1101628,2060.6622602,21.0914406,28.6336557,1.7881414,82.1832617),(27975,'zebu_humerus.tif',238,2,121,323.2695858,48.450358,44.8873701,1.8,48.4157857,44.866525,1.2536005,10.8595457,14.3669053,11241.6654881,19038.294844,48.6367825,1325.1493276,1035.187454,2059.6794444,21.27731,29.3640127,1.6621746,85.9843562),(27976,'zebu_humerus.tif',238,2,122,322.0922703,48.439865,45.0501969,1.8,48.3871348,45.0260843,1.2977533,10.9988642,14.5435453,11434.1394856,19233.8882664,49.7783876,1322.5034096,1039.5745691,2077.4584511,21.4789243,29.2820878,1.6744238,83.9838677),(27977,'zebu_humerus.tif',238,2,123,317.1682068,48.4083449,45.1592913,1.8,48.3923985,45.1798666,1.3494776,11.174936,14.9459922,11637.3978211,19564.1817114,50.3141149,1308.9918319,1041.3838423,2064.7424516,21.7162434,30.0310281,1.6484608,85.3701591),(27978,'zebu_humerus.tif',238,2,124,319.7698082,48.3208211,45.3283149,1.8,48.312164,45.4175771,1.4138809,11.3956504,15.1777144,11889.1551967,20069.7098826,51.9934508,1322.3143756,1043.3064174,2093.062872,21.9899587,30.1221818,1.6365927,84.9724031),(27979,'zebu_humerus.tif',238,2,125,329.8598024,48.2427574,45.586861,1.8,48.2121314,45.6760982,1.4784397,11.5919097,15.540414,12142.3201178,20973.6186082,54.5090288,1349.6177545,1047.4822876,2125.6361191,22.2576604,30.555002,1.6165659,86.0574503),(27980,'zebu_humerus.tif',238,2,126,342.0794738,48.1942953,45.8142583,1.8,48.1343414,45.9214815,1.5296816,11.6899243,15.7784505,12455.4016234,21959.1781631,56.9169233,1391.7195554,1065.4818019,2174.8805626,22.6011395,31.0382361,1.6271276,86.5916945),(27981,'zebu_humerus.tif',238,2,127,351.1460252,48.0147705,45.9075765,1.8,47.9653592,45.985464,-1.5574602,11.8604327,16.1919292,12846.3874199,23551.8756148,58.5139303,1454.5441286,1083.1297388,2247.621038,22.9710211,31.9346066,1.5416075,88.199277),(27982,'zebu_humerus.tif',238,2,128,360.0719895,47.9475156,45.9116584,1.8,47.9230892,46.0908222,-1.5296918,11.913914,16.4477813,12971.9612088,24949.5586293,59.91066,1516.895088,1088.8076921,2304.7497726,23.0370885,32.6368503,1.5386645,91.4378597),(27983,'zebu_humerus.tif',238,2,129,359.1121735,47.8062231,46.0073209,1.8,47.7689839,46.1474489,-1.4863168,12.028287,16.8281017,13346.6352722,26301.9442679,59.4258932,1562.9774924,1109.6039907,2355.9020505,22.9833033,33.3483196,1.5288629,90.8753479),(27984,'zebu_humerus.tif',238,2,130,367.4049794,47.611015,46.1088055,1.8,47.5624104,46.3104267,-1.4443602,12.1605349,17.1726216,13576.5085496,27845.6977692,60.260474,1621.5169922,1116.4400803,2412.1068567,23.0011072,34.0471165,1.4782777,92.8641275),(27985,'zebu_humerus.tif',238,2,131,379.1460183,47.3808796,46.1962578,1.8,47.2724669,46.3313962,-1.4085867,12.3238996,17.4775294,13894.0060432,29660.5579122,61.5428548,1697.0681174,1127.4033791,2491.6695613,22.9498059,34.8134322,1.4601391,99.5294665),(27986,'zebu_humerus.tif',238,2,132,387.7149434,47.1600293,46.1354209,1.8,47.02002,46.2243524,-1.378445,12.5276453,17.9547813,14177.9500978,31552.5352903,62.2576513,1757.3333165,1131.7330383,2546.2377081,23.0033794,35.7791627,1.4533071,102.2055373),(27987,'zebu_humerus.tif',238,2,133,395.7856825,46.9928994,46.1617456,1.8,46.8417682,46.1940797,-1.3378435,12.6622773,18.2520265,14491.8698055,33488.4461622,62.4488821,1834.7796139,1144.4915843,2623.3564643,23.1121723,36.3444567,1.4583692,104.6203405),(27988,'zebu_humerus.tif',238,2,134,411.271412,46.7509254,46.1662014,1.8,46.5662275,46.1768806,-1.300438,12.8934514,18.581008,14884.9479629,35737.1523221,63.6559054,1923.3161248,1154.457992,2721.3311367,23.2412869,37.0537812,1.4320118,110.4053647),(27989,'zebu_humerus.tif',238,2,135,425.4411452,46.4624986,46.244795,1.8,46.3336811,46.1622506,-1.2486488,13.0991736,18.7501159,15050.008373,37749.6113646,63.799273,2013.3001613,1148.9280757,2773.5623752,23.448931,37.8655512,1.4132348,113.985168),(27990,'zebu_humerus.tif',238,2,136,436.4014924,46.1516403,46.3077531,1.8,46.1096598,46.1819277,-1.1939822,13.342898,18.8862984,15243.207681,39659.3548458,62.885851,2099.9008869,1142.4210619,2787.5771795,23.7338154,38.4813494,1.3912136,119.9115304),(27991,'zebu_humerus.tif',238,2,137,438.0801976,45.7622745,46.1882515,1.8,45.7836711,46.0784135,-1.1438133,13.6971015,19.1659824,15342.3317038,41714.0825983,60.4915157,2176.4646144,1120.1152076,2812.5879862,24.1294294,39.1176444,1.3850825,123.7760191),(27992,'zebu_humerus.tif',238,2,138,426.2351461,45.4252363,46.0051112,1.8,45.4879622,45.755767,-1.0987862,13.995303,19.3169952,15999.3681677,44988.6311317,56.3531393,2328.966312,1143.1955529,2918.5364824,24.7110692,39.8477733,1.3825748,144.8247977),(27993,'zebu_humerus.tif',238,2,139,415.3778508,45.0908611,45.7792842,1.8,45.1812125,45.4736459,-1.0719055,14.3460387,19.5498969,16614.8802737,48607.9854841,53.38186,2486.3550849,1158.1510865,3021.6701294,25.5003436,40.6491569,1.3863287,149.0801834),(27994,'zebu_humerus.tif',238,2,140,414.5014631,44.606172,45.3143534,1.8,44.6779714,45.0082812,-1.0543302,14.8516169,19.839943,17692.5513235,52764.1100999,52.2376472,2659.4889925,1191.2878907,3179.1368855,26.5807801,41.5044276,1.3987257,158.7676639),(27995,'zebu_humerus.tif',238,2,141,433.2872028,43.6625115,44.453329,1.8,43.3776572,43.7300386,-1.0513096,16.0269185,20.1672965,21505.6253772,60875.2523313,54.4174536,3018.5132867,1341.8440608,3538.8549559,0.233,0.4200468,2.5535901,0.8920236),(27996,'zebu_humerus.tif',238,2,142,509.9731055,41.7028314,42.3924807,1.8,41.6016888,42.2183351,-1.1447264,18.9946033,22.2385935,34138.1598223,83949.692769,70.4771763,3774.9551288,1797.2557418,4781.3089752,33.6465679,46.2258489,1.5077487,197.4659003),(27997,'zebu_humerus.tif',238,2,143,564.4995064,40.4145029,41.1097309,1.8,40.2601974,41.2085156,-1.1735148,20.7440162,23.2398441,41992.7571667,99966.0767936,79.9988309,4301.4951561,2024.3310998,5616.5500558,2.6795003,5.3247006,1.3948567,13.9097486),(27998,'zebu_humerus.tif',238,2,144,612.7156735,38.9328306,40.3333456,1.8,38.520953,40.287515,-1.134728,22.4005011,24.0665286,51985.7921877,107133.7454761,83.900789,4451.5662111,2320.7423824,6210.2655732,38.2009416,48.8490822,1.5326287,241.0728639),(27999,'zebu_humerus.tif',238,2,145,648.7062731,37.6951335,39.9058158,1.8,37.4048848,39.6871924,-1.0913158,23.6113774,24.7000492,59103.6563005,110994.6730981,85.1086816,4493.7025039,2503.1854448,6482.9646012,39.2751434,49.701287,1.5168581,199.9949509),(28000,'zebu_humerus.tif',238,2,146,669.4238925,36.8985384,39.5194588,1.8,36.6089656,39.3226821,-1.0661346,24.4043306,25.1448443,62979.1818186,113474.1143661,85.487298,4512.8183394,2580.6559871,6615.3225605,39.9594547,50.4134206,1.2241971,196.7846358),(28001,'zebu_humerus.tif',238,2,147,679.0628814,36.4479919,39.0783512,1.8,36.0433707,39.0005511,-1.0294387,24.8606323,25.0378223,66494.2506626,114273.1030087,83.1247613,4564.0192509,2674.6805891,6752.3395065,40.4382558,51.1423117,1.2317564,209.2543988),(28002,'zebu_humerus.tif',238,2,148,682.6033806,36.2432902,38.5536786,1.8,35.7218106,38.6986055,-0.9992292,25.2070846,25.281839,70942.9567238,114558.5974541,80.4757905,4531.2604682,2814.4054686,6965.0147479,40.8580009,51.5064465,1.2604902,211.5492725),(28003,'zebu_humerus.tif',238,2,149,687.0867565,36.254259,38.1431738,1.8,35.6881159,38.491514,-0.9714135,25.328758,25.3640454,73796.9037758,112842.2915307,78.0706897,4448.9074814,2913.5618755,7065.1526276,41.1724917,51.6580029,1.2661625,210.9116577),(28004,'zebu_humerus.tif',238,2,150,697.4130293,36.312561,37.9667108,1.8,35.9103102,38.4312699,-0.9681262,25.313756,25.4648716,74816.7105286,109861.5632936,78.8875997,4314.2398217,2955.5752456,7019.4806018,41.2815505,51.763907,1.2597215,200.8946655),(28005,'zebu_humerus.tif',238,2,151,700.2639169,36.314247,37.8327278,1.8,36.0630291,38.2713667,-0.9716895,25.3281394,25.200009,74928.0514953,107455.0143794,79.597952,4264.086343,2958.2927661,6967.3315836,0.4521579,0.8400935,2.5535901,1.9205355),(28006,'zebu_humerus.tif',238,2,152,703.4379808,36.3193646,37.8068448,1.8,36.1555149,38.2050213,-0.9730492,25.2484215,24.9446857,75320.2360564,107449.6093666,80.107146,4307.5150667,2983.1661437,7011.8435624,41.2299583,51.2750957,1.4179743,201.007736),(28007,'zebu_humerus.tif',238,2,153,700.1931059,36.3309596,37.8544141,1.8,36.2520864,38.1900708,-0.9705144,25.1485753,24.6811845,74050.3791001,106353.9868724,79.4621261,4309.111935,2944.5158718,6938.3304052,40.9612967,51.2050361,1.3854484,197.8091298),(28008,'zebu_humerus.tif',238,2,154,696.9832724,36.3722624,37.9785276,1.8,36.3239805,38.1850595,-0.9422441,24.9829859,24.2100011,72347.360726,105215.4876264,76.0044275,4345.9513755,2895.8652536,6845.926677,40.6827976,50.9275648,1.3774384,195.5308149),(28009,'zebu_humerus.tif',238,2,155,694.7389384,36.5281619,38.171341,1.8,36.5272543,38.1713518,-0.8932273,24.6238546,23.8291533,70537.4048595,105039.6231436,70.2838675,4408.0300235,2864.5963867,6790.613319,40.3651952,50.4190739,1.3471149,192.4404293),(28010,'zebu_humerus.tif',238,2,156,681.9223427,36.7376525,38.2675536,1.8,36.7220671,38.1666488,-0.8173266,24.2814937,22.9149664,67352.2639124,102031.8756419,60.4531778,4452.6303937,2773.8105684,6628.8472635,39.9185885,49.5278539,1.2944353,187.2530435),(28011,'zebu_humerus.tif',238,2,157,651.0486758,36.8120666,38.4018248,1.8,36.7560751,38.2823184,-0.721275,23.71888,22.5038618,60946.8123836,96045.9628435,47.3152268,4267.976924,2569.5484981,6219.1241396,39.2416871,48.4841648,1.2581641,184.5135784),(28012,'zebu_humerus.tif',238,2,158,605.3509912,36.9533654,38.589043,1.8,36.8659816,38.4653527,-0.6119287,22.6974463,23.3094592,53079.8066062,87856.7084926,33.2932544,3769.1440094,2338.5805534,5651.4528836,38.2466077,47.4782937,1.2148976,180.9903104),(28013,'zebu_humerus.tif',238,2,159,537.5966941,37.4049952,38.7455677,1.8,37.1763438,38.6282561,-0.4829188,20.8600841,24.265247,43343.4456761,77934.4817207,19.320862,3211.773682,2077.8173995,4884.2289142,36.7391513,46.1888395,1.1827959,180.9172163),(28014,'zebu_humerus.tif',238,2,160,444.5904713,38.4003984,38.944028,1.8,38.1688977,38.6898583,-0.3737318,18.5596275,24.9067205,31990.9813446,65611.4430314,9.8767491,2634.2867173,1723.686607,3900.3538091,34.7221311,44.9985732,0.0362535,200.3155948),(28015,'zebu_humerus.tif',238,2,161,329.2860404,40.4478045,39.6264353,1.8,40.5359439,39.1266888,-0.306256,15.9172496,25.3981053,19116.3006452,48452.3291292,4.988507,1907.7143166,1200.98014,2659.5264675,7.331092,15.5744441,2.2502101,40.4491661),(28016,'zebu_humerus.tif',238,2,162,198.2327553,44.9604502,40.0323918,1.8,44.0720705,38.3081421,-0.2499496,15.1221059,27.9075133,7661.0416719,23451.5028876,2.0214631,840.3293637,506.6120891,1105.9504822,4.276849,10.8294893,2.2724215,26.3863704),(28017,'zebu_humerus.tif',238,2,163,112.1587972,50.8786428,38.751182,1.8,50.8592096,38.699978,1.1057157,5.0953656,10.418559,448.8854654,3174.9156578,14.9330532,304.7365445,88.0968123,347.0486479,9.5457903,20.4808216,2.0115472,53.4551822),(28018,'zebu_humerus.tif',238,2,164,66.4069928,50.4188581,37.8104133,1.8,50.5934659,38.0277308,1.1339611,3.2673825,8.9965417,132.1542636,1312.751287,9.0867828,145.9173232,40.4465237,158.0004168,6.5130692,17.2832786,2.1008116,43.5581194),(28019,'zebu_humerus.tif',238,2,165,17.1755881,49.2895923,34.9111765,1.8,49.3456924,35.1217778,1.150267,1.9446432,3.7925429,11.9897938,49.9329254,2.3855091,13.1660804,6.1655495,16.310005,3.9316678,7.3358015,1.9277083,19.0688668),(28020,'zebu_humerus.tif',238,2,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28021,'zebu_humerus.tif',238,2,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28022,'zebu_humerus.tif',238,2,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28023,'zebu_humerus.tif',238,2,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28024,'zebu_humerus.tif',238,2,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28025,'zebu_humerus.tif',238,2,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28026,'zebu_humerus.tif',238,2,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28027,'zebu_humerus.tif',238,2,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28028,'zebu_humerus.tif',238,2,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28029,'zebu_humerus.tif',238,2,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28030,'zebu_humerus.tif',238,2,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28031,'zebu-radius.tif',238,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28032,'zebu-radius.tif',238,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28033,'zebu-radius.tif',238,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28034,'zebu-radius.tif',238,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28035,'zebu-radius.tif',238,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28036,'zebu-radius.tif',238,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28037,'zebu-radius.tif',238,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28038,'zebu-radius.tif',238,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28039,'zebu-radius.tif',238,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28040,'zebu-radius.tif',238,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28041,'zebu-radius.tif',238,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28042,'zebu-radius.tif',238,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28043,'zebu-radius.tif',238,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28044,'zebu-radius.tif',238,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28045,'zebu-radius.tif',238,3,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28046,'zebu-radius.tif',238,3,16,1.0479484,56.2819552,66.2499136,1.8,56.2916772,66.3906374,0.0335519,0.7882706,2.0542765,0.0699835,0.6693086,0.0001965,0.3258123,0.0887811,0.3587179,13.087568,33.3552094,1.9252905,81.0304027),(28047,'zebu-radius.tif',238,3,17,6.4172963,56.4726924,66.8481947,1.8,56.4777884,67.0786584,0.1078916,1.8198513,3.8867495,2.5240959,9.3898026,0.0124019,2.4158497,1.3869792,3.065254,13.0987733,35.211595,1.9180888,85.2815929),(28048,'zebu-radius.tif',238,3,18,13.6666398,56.4487889,67.5447904,1.8,56.3379406,67.7252421,0.3133096,2.5971024,5.476452,14.2828811,32.0933997,0.2163718,5.860254,5.4995448,8.4643797,0.4062501,0.7323777,2.1587989,1.5552988),(28049,'zebu-radius.tif',238,3,19,21.0792846,56.3111042,68.1966622,1.8,56.2063069,68.3193971,0.5660143,3.7772454,6.008508,34.6637286,71.6067441,1.0103578,11.9175583,9.1769862,17.3253182,1.827118,17.1709754,2.0503156,47.9882462),(28050,'zebu-radius.tif',238,3,20,27.9660797,56.1874236,68.9048098,1.8,56.0480539,68.938076,0.8051141,5.1337951,6.6740901,57.2421794,142.2073218,2.422379,21.3073721,11.150071,27.5959051,0.203125,0.4542014,2.0344439,0.9807744),(28051,'zebu-radius.tif',238,3,21,33.15616,56.1123825,69.5616606,1.8,55.9909517,69.4632123,0.9472334,5.3743848,6.7756728,73.3884545,237.6718508,3.641786,35.0772327,13.6552289,40.3048863,1.6202043,8.8189958,2.0756577,21.1010862),(28052,'zebu-radius.tif',238,3,22,37.5401493,56.0559249,70.2113373,1.8,55.9700007,70.071266,1.0386822,5.3980077,7.3222897,85.9714486,349.8499272,4.6461539,47.7787605,15.9265147,51.7296574,1.5722421,11.5424362,2.0659296,29.8583547),(28053,'zebu-radius.tif',238,3,23,42.5877334,56.0699326,70.8757625,1.8,56.0408698,70.7459088,1.0877491,5.2912677,8.0806547,101.7820495,505.8569861,5.5666313,62.6009901,19.2358533,73.3361653,1.9455336,18.7150817,2.0198819,48.9486056),(28054,'zebu-radius.tif',238,3,24,48.8554692,56.1943564,71.5396254,1.8,56.1860998,71.3801118,1.0995189,5.4603207,8.9920737,121.1614824,744.6638121,6.4640791,82.8133569,22.1894444,95.0654588,2.0109643,17.5406439,2.065522,44.9762214),(28055,'zebu-radius.tif',238,3,25,56.5892276,56.5518542,72.1301518,1.8,56.6633523,72.0633724,1.0644471,6.2097349,9.8053951,159.881371,1074.7730262,7.2131158,109.6103742,25.7468914,116.8757837,2.171605,21.3522969,2.0131705,53.9221793),(28056,'zebu-radius.tif',238,3,26,67.8823048,56.8966577,72.720453,1.8,57.165058,72.566584,1.0139802,6.2840859,10.426784,237.1338855,1514.8328831,8.1538259,145.2828489,37.7356214,156.5623957,2.1398554,15.1705985,2.028456,41.5086601),(28057,'zebu-radius.tif',238,3,27,80.8586935,57.1952265,73.2199643,1.8,57.3998938,72.9639126,0.9737897,6.6948359,11.3371262,362.0866541,1981.8205373,9.2174272,174.8080155,54.0844702,193.7336056,1.3550115,4.7245679,2.0152155,11.3630432),(28058,'zebu-radius.tif',238,3,28,97.1240994,57.3030404,73.7454872,1.8,57.2791808,73.4826688,0.969956,7.2530601,11.8476726,569.7865502,2444.2084185,11.0137979,206.3028319,78.5580899,241.1965261,14.3059437,48.2861157,1.93646,245.4963346),(28059,'zebu-radius.tif',238,3,29,106.0346492,57.2291775,73.8538932,1.8,57.2142514,73.5083803,0.9784209,7.3785353,11.8623144,723.5253709,2528.0773368,12.1633046,213.1183885,98.0581295,259.2347266,13.0921751,47.4813195,1.9155469,153.2134204),(28060,'zebu-radius.tif',238,3,30,95.6982363,56.9207606,72.8420645,1.8,56.9571635,72.7472011,0.8450054,7.3833812,11.6077021,660.9906976,1834.9396669,8.9233208,158.0794935,89.5241189,208.1057447,12.8960914,43.4222233,1.8895883,148.7650846),(28061,'zebu-radius.tif',238,3,31,84.3107493,56.6120105,71.7830198,1.8,56.6494543,71.6854419,0.5997233,7.2023007,10.4159219,549.4986945,1316.1302681,4.476385,126.3575401,76.2948839,179.0981256,1.3520444,9.1248144,1.8643853,21.5481665),(28062,'zebu-radius.tif',238,3,32,76.0633192,56.4932211,70.960934,1.8,56.4894151,70.8858508,0.4036651,6.2935104,10.0245662,437.1823553,1086.7808436,1.9559068,108.4117577,69.4655803,151.7003158,13.6122227,36.0224946,1.9460671,88.2936177),(28063,'zebu-radius.tif',238,3,33,69.0046958,56.4991656,70.2944282,1.8,56.4390276,70.2526679,0.2811514,5.5677013,9.6078485,335.7077617,954.3708396,0.8853896,99.3324194,60.2955774,132.2691859,0.9211147,3.5064818,1.7454685,8.0841713),(28064,'zebu-radius.tif',238,3,34,63.4952398,56.4508456,69.8552471,1.8,56.3983395,69.8164673,0.2122011,5.1262382,9.3570637,269.41793,872.3217962,0.4694145,93.2260183,52.5566545,119.8718615,0.203125,0.2872622,2.3561945,0.5745244),(28065,'zebu-radius.tif',238,3,35,59.7814719,56.414595,69.50238,1.8,56.3822411,69.5296471,0.1732222,4.9946896,9.7515283,227.1754598,823.6958363,0.2959882,84.4683837,45.4833988,105.9091099,13.2623691,29.8455594,1.9765818,75.5928363),(28066,'zebu-radius.tif',238,3,36,56.689789,56.4022494,69.2520866,1.8,56.4124876,69.3273327,0.1505592,5.4381967,9.2560746,199.6777278,789.9649218,0.2125614,85.3455658,36.7176364,104.8024104,13.1008425,28.5446695,1.996246,72.8187873),(28067,'zebu-radius.tif',238,3,37,54.7363884,56.4164572,69.0775202,1.8,56.4401611,69.155437,0.1437139,4.8314922,9.4040616,182.8295964,772.334077,0.1871245,82.1277133,37.8412278,100.2550706,0.203125,0.2872622,2.3561945,0.5745244),(28068,'zebu-radius.tif',238,3,38,53.0763198,56.4045714,68.9190984,1.8,56.4152067,68.9944716,0.1287913,4.7599002,9.7248813,159.9855762,793.5645812,0.1459218,81.6014667,33.6111201,97.2416065,12.5021137,26.1810761,2.0726198,68.2310486),(28069,'zebu-radius.tif',238,3,39,52.9020535,56.3473264,68.8454549,1.8,56.3432249,68.9399615,0.1325186,4.8433927,9.5153655,149.3227954,857.4924457,0.1539328,90.1166064,30.8302058,104.368771,12.6583935,25.3719354,2.0810052,66.844024),(28070,'zebu-radius.tif',238,3,40,54.6415784,56.2079074,68.9191702,1.8,56.169082,69.0270209,0.1392428,4.7964186,9.8002976,151.7305689,964.0092308,0.1754321,98.3653013,31.6341381,112.434904,13.1892563,24.7412634,2.0858691,66.3392012),(28071,'zebu-radius.tif',238,3,41,57.8919614,56.1957791,69.0095386,1.8,56.1257109,69.1642523,0.1344503,4.3791736,10.3966867,167.0436011,1098.8106199,0.1733692,105.6885381,38.1450052,120.3129017,0.203125,0.2872622,2.3561945,0.5745244),(28072,'zebu-radius.tif',238,3,42,62.1491081,56.1780722,69.2148519,1.8,56.0215528,69.4567213,0.127642,5.2257996,9.8876512,203.6891868,1293.2934494,0.167846,130.7988538,38.9776115,149.9131042,1.6949,15.4588697,1.6233794,38.6684123),(28073,'zebu-radius.tif',238,3,43,0.7365121,44.4409218,76.0780215,1.8,44.428235,76.0744553,0.3979857,0.8186854,1.9978607,0.0890493,0.6372947,0.0184379,0.3189885,0.1087711,0.3632906,1.8173201,4.1875299,2.7430702,9.9267323),(28074,'zebu-radius.tif',238,3,44,9.4583422,46.7604794,77.9102072,1.8,48.5491127,79.2706604,0.7846956,11.9659261,19.7120982,19.1026586,521.4066015,0.7870877,26.451096,1.5964212,27.3917345,4.670401,7.0948526,2.910502,20.6166784),(28075,'zebu-radius.tif',238,3,45,33.2899042,54.5206931,80.6956339,1.8,54.4307079,80.2943828,0.5330391,16.4607933,13.8450307,1520.5321311,2075.6369,1.4326845,149.9192705,92.3729557,203.107236,0,0,0,0),(28076,'zebu-radius.tif',238,3,46,110.9166065,54.0285457,81.1363765,1.8,53.6398405,81.6208078,-0.4170844,16.6762576,19.3625115,4685.7988781,9734.4450592,3.0336278,502.7470241,280.9862378,743.2556191,12.4106228,20.910043,0.8748143,69.1301626),(28077,'zebu-radius.tif',238,3,47,222.0976508,54.611794,82.1748593,1.8,56.2697817,82.3246796,-0.2724893,14.7073382,22.5039697,8493.679658,22100.8597014,2.6811195,982.0871618,577.5130445,1349.9342979,23.3478545,39.8855034,0.4818688,193.335056),(28078,'zebu-radius.tif',238,3,48,306.5858296,56.9295053,82.5183163,1.8,58.2424984,82.6919512,-0.1994849,14.3820763,22.1518047,11565.6205415,33611.0020725,2.0065608,1517.303103,804.1690422,2017.9433923,0.7067899,1.6376464,1.0516502,3.5168477),(28079,'zebu-radius.tif',238,3,49,430.9360708,59.0536575,82.6945947,1.8,59.6861801,82.8163237,-0.100542,15.2063008,22.2733482,13763.3046432,57094.7707354,0.7235908,2563.3672179,905.1053812,3052.0233617,23.1245195,44.5256385,2.9996956,128.4969137),(28080,'zebu-radius.tif',238,3,50,461.7926232,59.7274112,82.6688313,1.8,59.3216734,82.8188489,-0.0625273,15.3783768,24.1965767,13585.1416416,69909.7988458,0.3005168,2889.2433706,883.3924272,3273.2696574,22.5468792,45.7604241,3.034857,125.911554),(28081,'zebu-radius.tif',238,3,51,431.5399264,59.2715541,82.4784356,1.8,58.8603696,82.6326932,-0.0464827,13.814738,24.2789991,12736.3622626,68090.415627,0.1552879,2804.4984633,921.9401929,3245.7158303,21.7343791,45.9606028,3.0929585,130.5774505),(28082,'zebu-radius.tif',238,3,52,405.6969876,58.5424834,82.2872484,1.8,58.3468327,82.466858,-0.0362642,14.2746453,23.8063944,11631.2322042,63026.3386577,0.0888825,2647.4541926,814.8176013,3131.558257,21.125004,45.8491503,0.07983,137.1267381),(28083,'zebu-radius.tif',238,3,53,382.4215574,58.4109538,82.1604803,1.8,58.0644996,82.2325957,-0.0374044,12.8321977,23.491345,10503.1970563,55336.3142063,0.0891322,2355.6043414,818.5033723,2802.7096623,20.5156288,44.6195945,0.1232257,115.3321396),(28084,'zebu-radius.tif',238,3,54,357.51319,58.5655553,82.2149767,1.8,58.2244218,82.1510035,-0.0344656,14.22497,22.6497363,9329.8085683,46884.1480926,0.0707517,2069.9644084,655.875447,2480.7221808,20.3125038,42.9492991,0.1806995,110.9823767),(28085,'zebu-radius.tif',238,3,55,330.6094997,59.1072229,82.3036751,1.8,58.6799404,82.2141908,-0.0333975,12.1025356,22.3210797,8065.6499748,38560.5127302,0.0614369,1727.5379741,666.4429847,2085.4563121,21.1925921,41.3622633,0.0786551,129.4776881),(28086,'zebu-radius.tif',238,3,56,307.7340143,59.5680948,82.4278283,1.8,59.2374227,82.3244669,-0.0364945,13.9183048,20.998922,7145.798855,32350.4049528,0.0682789,1540.5745564,513.4101444,1820.090742,19.0937536,39.127809,0.1301502,100.0340397),(28087,'zebu-radius.tif',238,3,57,290.8460984,59.7428701,82.5454365,1.8,59.2981527,82.412882,-0.0298422,13.9109801,20.1404181,6442.2071307,27226.1043023,0.0431565,1351.8142582,463.1023187,1671.6692718,18.8906285,37.371695,0.1034545,133.5571013),(28088,'zebu-radius.tif',238,3,58,277.5400065,59.8711138,82.670818,1.8,59.4530625,82.554573,-0.029038,13.6095156,19.2498187,5919.0682286,23488.7926514,0.0389924,1220.208513,434.9212996,1527.6480757,18.2812534,35.8629321,0.0793783,91.9583246),(28089,'zebu-radius.tif',238,3,59,260.8335085,59.9895719,82.7956252,1.8,59.5083356,82.6051329,-0.0274286,13.4041982,18.3664976,5542.6528417,20616.1997447,0.0326971,1122.4894495,413.5012594,1423.951807,18.5908281,34.2607576,0.0890496,88.8765983),(28090,'zebu-radius.tif',238,3,60,244.4697293,60.1201865,82.9701564,1.8,59.5991567,82.835263,-0.0260221,13.3592828,17.8563678,5033.8663256,18353.1709353,0.0275843,1027.8221808,376.8066285,1285.2037118,20.7455146,32.9463552,0.0493426,124.9646044),(28091,'zebu-radius.tif',238,3,61,232.646714,60.2549616,83.0814827,1.8,59.7786684,82.9777896,-0.0281576,11.8379383,17.3256826,4694.6087217,16534.2280027,0.0307342,954.3189959,396.5731699,1210.3848436,17.8322624,31.4496339,0.1035247,82.655403),(28092,'zebu-radius.tif',238,3,62,224.8076807,60.3712456,83.2356633,1.8,59.86616,83.1292926,-0.029828,11.0014529,16.8054601,4424.1461726,15178.853049,0.0333256,903.209607,402.1419893,1141.9081864,17.6196178,30.550573,0.0732023,81.0796891),(28093,'zebu-radius.tif',238,3,63,217.857308,60.4779703,83.399754,1.8,59.9895426,83.3158619,-0.0325198,10.5745441,16.7207002,4169.5882912,14115.0472173,0.038385,844.1660352,394.3043086,1077.4688953,17.3902923,29.7403081,0.0752004,79.2864145),(28094,'zebu-radius.tif',238,3,64,213.0828887,60.5948488,83.5294023,1.8,60.0501905,83.3928548,-0.0359475,11.0440212,15.9743351,3965.5280007,13240.8758895,0.045872,828.8843221,359.0655926,1002.9798485,16.8593782,29.1326912,0.0767719,77.5628414),(28095,'zebu-radius.tif',238,3,65,208.6435238,60.7225463,83.6429263,1.8,60.1637153,83.6079021,-0.0448438,10.5822469,15.6606042,3797.983707,12407.8339378,0.0698825,792.2959939,358.9014445,989.0672093,16.4531281,28.5251493,0.0784103,76.0075426),(28096,'zebu-radius.tif',238,3,66,203.2271273,60.7686629,83.8035303,1.8,60.2730277,83.7544104,-0.0524681,10.7086741,16.2557859,3566.7229558,11641.873818,0.0931586,716.1680071,333.0685878,933.9197802,16.046878,27.9346781,0.0873683,74.4726589),(28097,'zebu-radius.tif',238,3,67,197.8006909,60.8090952,83.9931362,1.8,60.3510434,83.9286916,-0.0561595,10.7183651,14.9623796,3349.6456659,10901.131531,0.1038641,728.5693754,312.5146077,932.2978627,15.6406279,27.366906,0.1040999,73.1349208),(28098,'zebu-radius.tif',238,3,68,191.634079,60.8617052,84.1915343,1.8,60.4947137,84.203107,-0.0635565,10.0994902,14.7808326,3139.3216774,10265.6705594,0.1288416,694.5258679,310.8396193,879.4784762,15.4375029,27.0431067,3.0965104,71.8668841),(28099,'zebu-radius.tif',238,3,69,188.8734871,60.9413684,84.3735966,1.8,60.6237768,84.3077305,-0.0681583,10.462594,14.6263151,2992.863811,9773.0424394,0.1460109,668.1821329,286.0537072,848.5955189,15.19411,26.720788,3.0502445,70.4798596),(28100,'zebu-radius.tif',238,3,70,186.6234537,61.0732821,84.5780687,1.8,60.8995772,84.5804762,-0.0714719,10.5936052,14.3558181,2848.102826,9344.0318171,0.1586158,650.8881447,268.8511399,830.5020659,14.9664025,26.4842647,3.0648208,69.9546217),(28101,'zebu-radius.tif',238,3,71,185.3272714,61.2061916,84.7720875,1.8,61.0117387,84.7550259,-0.0728491,10.0550055,14.0979542,2753.1172053,9032.5872212,0.163632,640.7019836,273.8056396,814.8549013,14.7604951,26.1337551,3.0403772,69.2611094),(28102,'zebu-radius.tif',238,3,72,183.625468,61.3051286,84.9433768,1.8,61.1313662,84.877057,-0.0747133,10.0104219,13.9503944,2634.9872498,8766.8651172,0.1705178,628.4313433,263.2243939,786.1836711,14.3856415,25.9531487,3.0317997,68.7358714),(28103,'zebu-radius.tif',238,3,73,182.1804004,61.438911,85.0694191,1.8,61.2036386,84.9750277,-0.0767863,10.1716415,13.713957,2560.9416519,8513.4886784,0.1786752,620.7900976,251.7727015,748.4498514,13.987547,25.7296169,3.0387818,67.8740849),(28104,'zebu-radius.tif',238,3,74,180.4374497,61.4863555,85.2307239,1.8,61.3390411,85.2286847,-0.0822111,10.2401773,13.5810741,2460.1462969,8290.8345475,0.2027953,610.4697238,240.2445031,737.061897,13.695995,25.5073614,3.0458859,67.3488469),(28105,'zebu-radius.tif',238,3,75,177.9014235,61.5294433,85.3881121,1.8,61.4817065,85.5000397,-0.0942339,9.5892337,26.4717851,2356.120616,8076.3033061,0.2625164,305.0909966,245.7047852,389.7782437,13.4497633,25.2864159,3.0531146,66.7250361),(28106,'zebu-radius.tif',238,3,76,176.3239871,61.5582037,85.5227888,1.8,61.5171351,85.5897395,-0.0987369,9.3283968,13.1894254,2288.4846402,7865.7303925,0.2855664,596.3664182,245.3245397,717.8950648,13.2035315,25.051173,3.0685521,66.1997982),(28107,'zebu-radius.tif',238,3,77,174.4952286,61.5690126,85.6581791,1.8,61.4779031,85.6566114,-0.1025168,9.2724506,13.1919643,2210.976251,7668.3270171,0.3045792,581.287733,238.4457295,676.802385,13.0067359,24.8344762,3.0761126,65.2190237),(28108,'zebu-radius.tif',238,3,78,172.0158533,61.5789448,85.7930152,1.8,61.4601231,85.7996937,-0.1053362,9.219672,12.7713786,2151.7505923,7477.8016049,0.3169313,585.5124833,233.3868908,687.1566008,12.8673851,24.4771992,3.0501815,64.6444994),(28109,'zebu-radius.tif',238,3,79,171.9473246,61.5880669,85.9227499,1.8,61.4434514,85.9204907,-0.1087536,9.0989515,12.9605428,2090.9402214,7352.8681741,0.3376127,567.327178,229.8001275,672.4235442,12.8233402,24.2749293,3.0494176,64.069975),(28110,'zebu-radius.tif',238,3,80,171.5439539,61.5924972,86.0406759,1.8,61.6298268,86.1477637,-0.112526,8.6848119,13.2884619,2045.9452285,7217.5908694,0.3604922,543.1471995,235.5773793,682.1038777,12.6900515,24.2025848,3.0912151,63.9017007),(28111,'zebu-radius.tif',238,3,81,171.4025829,61.6145557,86.0822826,1.8,61.6575348,86.163756,-0.114374,8.9697928,12.9708248,2058.9725489,7091.7609703,0.372071,546.7471097,229.5451631,682.2426255,12.753453,24.0546704,0.0845438,64.4065236),(28112,'zebu-radius.tif',238,3,82,171.7281351,61.6118885,86.1321108,1.8,61.5278215,85.8539989,-0.1178062,11.6212089,12.7611736,2110.7307034,7011.477596,0.3953812,549.4383033,181.6274638,623.7225224,13.1511472,23.8903025,0.1022067,64.1685478),(28113,'zebu-radius.tif',238,3,83,171.5575822,61.6433226,86.2250108,1.8,61.5484685,85.9693488,-0.1271158,11.502163,12.7508583,2090.4791247,6922.5687849,0.4595333,542.9100225,181.7466094,657.599795,12.8141982,23.7334897,0.1201087,63.4954506),(28114,'zebu-radius.tif',238,3,84,171.97018,61.70043,86.3068613,1.8,61.6663826,86.0507133,-0.1389809,11.6313333,12.7961686,2064.5574,6858.9089151,0.5500649,536.0127011,177.4996335,651.6893129,0.203125,0.2872622,2.3561945,0.5745244),(28115,'zebu-radius.tif',238,3,85,172.9668287,61.7311144,86.3640915,1.8,61.685172,86.0921645,-0.1453045,10.8075517,12.549885,2034.8507432,6866.7999863,0.6043815,547.1603922,188.280454,647.8402315,13.0873592,23.7100088,0.1116033,63.0892006),(28116,'zebu-radius.tif',238,3,86,173.0686029,61.7618281,86.4352369,1.8,61.677914,86.1997163,-0.153167,11.1191235,12.317692,2002.6830051,6876.1104414,0.6714264,558.2304237,180.1115894,659.139975,13.2031275,23.7334897,0.1201087,63.8319992),(28117,'zebu-radius.tif',238,3,87,174.1628623,61.7779156,86.4837853,1.8,61.6903717,86.242674,-0.1573602,10.8032913,12.8395848,1981.1022146,6925.4211351,0.7128637,539.3804588,183.3795058,626.512197,0.203125,0.2872622,2.3561945,0.5745244),(28118,'zebu-radius.tif',238,3,88,174.0122391,61.8351755,86.5397388,1.8,61.7279712,86.2798036,-0.1686125,10.678246,12.6169195,1943.2717695,6917.6909059,0.8167487,548.2868375,181.9841731,628.7832616,13.8125026,23.758684,0.1285968,65.2887252),(28119,'zebu-radius.tif',238,3,89,174.1887559,61.911691,86.5396879,1.8,61.8003769,86.2577507,-0.1768655,11.0062851,12.6400148,1973.3075694,6890.3834866,0.8987148,545.1246383,179.2891571,623.0979016,0.4062501,1.0357385,1.7681919,2.367799),(28120,'zebu-radius.tif',238,3,90,175.1774653,61.9277198,86.5226785,1.8,61.835997,86.2393667,-0.1791504,10.9957995,12.4946013,2025.0754056,6907.1307914,0.9270675,552.8092175,184.1680917,644.5897799,0.203125,0.2872622,2.3561945,0.5745244),(28121,'zebu-radius.tif',238,3,91,170.7901627,62.0493877,86.6815797,1.8,62.0284459,86.7458084,-0.1991472,9.4329142,12.5701965,1836.2561168,6842.6712276,1.114066,544.3567425,194.664775,618.7161019,0.6093751,1.0357385,1.7681919,2.5360733),(28122,'zebu-radius.tif',238,3,92,170.2287421,62.0663644,86.7093914,1.8,62.0295527,86.719108,-0.2042106,9.6183554,12.6398623,1808.8598602,6811.4734951,1.1667901,538.8882656,188.0633212,616.8275925,13.0555806,24.0211998,0.1957372,63.4461642),(28123,'zebu-radius.tif',238,3,93,169.791376,62.0967143,86.7534497,1.8,62.0392588,86.7226878,-0.2096204,8.3086456,12.4249372,1767.8573853,6807.6164672,1.2253526,547.8994686,212.7732335,614.4829618,3.4309285,6.1476792,1.7033479,18.3474522),(28124,'zebu-radius.tif',238,3,94,168.8208709,62.1727878,86.805796,1.8,62.1571311,86.7774442,-0.2205066,8.5179619,12.4704796,1723.9537436,6793.816873,1.3460705,544.7919465,202.3904036,603.8378508,3.3622226,5.5442346,1.7178747,16.5048913),(28125,'zebu-radius.tif',238,3,95,168.6742861,62.1767395,86.8267758,1.8,62.1172206,86.7448088,-0.2229915,8.5030134,12.4517589,1701.848111,6780.3550902,1.3748775,544.5299035,200.1464699,603.4719096,0.6093751,1.4787726,1.2924967,3.3485734),(28126,'zebu-radius.tif',238,3,96,168.6414284,62.1828473,86.8604669,1.8,62.1096888,86.7737686,-0.2253759,8.4628832,12.4098422,1689.094107,6771.8560429,1.4036606,545.6842997,199.5884927,604.1413385,12.8903908,24.0615305,0.204018,63.9017007),(28127,'zebu-radius.tif',238,3,97,167.492681,62.2248286,86.8666241,1.8,62.1963113,86.8224423,-0.2297068,8.5918306,12.5785978,1686.2068667,6733.6430115,1.4472388,535.3254093,196.2569955,596.5416717,0.4062501,2.0413814,1.670465,4.3990493),(28128,'zebu-radius.tif',238,3,98,167.0682429,62.1896268,86.8946649,1.8,62.1083358,86.9032196,-0.2285988,9.1534441,12.4689821,1690.2242524,6712.8964461,1.4299214,538.3676372,184.6544564,588.3750787,3.0468756,5.2734327,1.843805,16.9111413),(28129,'zebu-radius.tif',238,3,99,166.90833,62.1831815,86.9127677,1.8,62.165132,86.9074592,-0.2311659,8.8925391,12.3551981,1685.5221266,6685.8266649,1.4602407,541.1347203,189.5434042,588.9391201,0.5601272,2.9083079,1.7818897,6.3605982),(28130,'zebu-radius.tif',238,3,100,167.1799319,62.1510225,86.9285986,1.8,62.1676091,86.8954793,-0.2289527,8.6931426,12.473281,1684.7669475,6689.6631443,1.4352333,536.3194458,193.8041314,574.6384298,2.6609982,5.7810399,1.8925469,15.8810805),(28131,'zebu-radius.tif',238,3,101,168.5194494,62.0833468,86.9338408,1.8,62.1261113,86.940018,-0.221878,8.7307121,12.4769001,1706.4093103,6712.1494455,1.3601567,537.9661147,195.4490405,624.0662091,1.9972369,4.3848669,1.8045395,11.5024462),(28132,'zebu-radius.tif',238,3,102,169.0212434,62.0652676,86.9554641,1.8,62.0889117,86.9326614,-0.2210295,8.5889145,12.8944178,1709.5356984,6732.1506769,1.353962,522.0980722,199.0397847,617.3805035,2.1680049,4.2413753,1.8622531,11.5517326),(28133,'zebu-radius.tif',238,3,103,168.1787312,62.1028179,87.005545,1.8,62.0892022,86.9949767,-0.2290343,8.1281142,12.4146189,1669.8853901,6675.7934679,1.4448195,537.736479,205.445611,608.123657,1.9499758,4.4363178,1.849096,11.8389948),(28134,'zebu-radius.tif',238,3,104,169.0672293,62.0941665,87.0180141,1.8,62.1069409,86.9916046,-0.2279242,8.7021505,12.4045727,1686.9238855,6721.4065864,1.4386514,541.8491036,193.8513804,595.9736852,2.2514625,4.3754472,1.9513027,12.2452449),(28135,'zebu-radius.tif',238,3,105,168.8619931,62.1425083,87.0212039,1.8,62.1752422,87.0629845,-0.2308055,9.0759931,12.5287949,1717.0649471,6699.70893,1.4728124,534.7448803,189.1875557,608.7766372,2.1374475,4.828227,1.8259787,12.5325071),(28136,'zebu-radius.tif',238,3,106,168.909792,62.1405269,87.0480486,1.8,62.1698829,87.1434818,-0.23137,9.1087247,12.5321618,1738.2757116,6698.0343794,1.4803149,534.4675962,190.8363421,612.5705007,2.173457,5.2223285,1.8063413,14.0385195),(28137,'zebu-radius.tif',238,3,107,169.6749859,62.0852716,87.0530942,1.8,62.1052411,87.1657847,-0.2258919,9.0686512,12.4812127,1778.7951092,6725.2144448,1.4186278,538.827005,196.1477047,628.7038466,2.0150612,5.1786927,1.7681919,15.0685803),(28138,'zebu-radius.tif',238,3,108,170.1045002,62.0727101,87.068442,1.8,62.0690753,87.1390066,-0.2273291,8.9030683,12.5102841,1792.9246907,6736.0510053,1.44006,538.4410897,201.3827862,604.799916,2.4903043,4.6408626,1.9756881,15.0685803),(28139,'zebu-radius.tif',238,3,109,170.9966742,62.0219058,87.070019,1.8,61.9920748,87.1353742,-0.2223868,8.9712118,12.2647096,1830.1039178,6776.3784041,1.3863831,552.5103033,203.997405,648.2326157,1.82562,5.5442346,1.7178747,15.6431047),(28140,'zebu-radius.tif',238,3,110,172.6589933,61.9670962,87.0470321,1.8,61.8940609,87.1176746,-0.216763,8.682142,12.3256695,1903.3536442,6816.6443269,1.331054,553.0445468,219.2262746,650.1857493,2.2177207,5.1786927,1.7681919,14.2067938),(28141,'zebu-radius.tif',238,3,111,173.1011856,61.9734805,87.0670015,1.8,61.9268552,87.1431583,-0.2162708,8.7202466,11.9588091,1918.3091278,6834.3548903,1.3285039,571.4912618,219.9833582,671.4108247,1.8224898,5.316291,1.6856729,14.7320317),(28142,'zebu-radius.tif',238,3,112,173.4229494,61.9876248,87.0843457,1.8,61.9012486,87.1386557,-0.2187328,8.7280632,12.3177069,1940.5779307,6863.4775522,1.3609618,557.2041629,222.33775,688.8960468,1.7557794,5.8625419,1.3258177,14.3257817),(28143,'zebu-radius.tif',238,3,113,172.6101567,62.0621619,87.059876,1.8,61.9831405,87.1720831,-0.2225566,8.857232,12.4218683,1973.561152,6823.6515505,1.4015664,549.3257021,222.8191782,690.6745528,1.5809164,4.6895057,1.2627435,12.8197693),(28144,'zebu-radius.tif',238,3,114,172.372938,62.0815684,87.0835465,1.8,62.0144131,87.2505209,-0.2236317,9.1475623,12.4545088,2004.6687339,6816.7456753,1.4129692,547.3315536,219.1478625,694.8419667,1.5138689,5.6656959,1.3171222,13.7512573),(28145,'zebu-radius.tif',238,3,115,172.1219284,62.0922977,87.1005536,1.8,61.9948386,87.2722907,-0.2263436,9.7814215,12.2347991,2037.7760626,6827.1834771,1.4447487,558.0135317,208.3312798,657.244444,2.2343754,5.7452437,1.7126934,18.3678673),(28146,'zebu-radius.tif',238,3,116,172.0378335,62.0990995,87.1057491,1.8,62.0253596,87.232739,-0.2286144,9.2034532,12.4210728,2059.5654537,6833.2494828,1.4726539,550.1336009,223.7818135,658.9190625,1.7402346,5.6656959,1.3171222,15.5938183),(28147,'zebu-radius.tif',238,3,117,172.3765763,62.100761,87.1061957,1.8,62.0346788,87.2455221,-0.2305204,9.0136557,12.2709518,2085.1917619,6846.4694992,1.4998205,557.9411927,231.3369655,691.5971181,1.6250003,5.2734327,1.2977876,14.900306),(28148,'zebu-radius.tif',238,3,118,172.6189338,62.1067722,87.1027159,1.8,62.0910515,87.1936166,-0.23493,8.7488133,12.3335239,2108.1852489,6856.3493978,1.5588692,555.9116301,240.9681388,708.3184746,1.1334077,4.8834571,1.2753555,11.6707205),(28149,'zebu-radius.tif',238,3,119,173.8608407,62.1090155,87.0894412,1.8,62.1020328,87.1901448,-0.2370558,8.6185795,12.3851879,2151.3720307,6901.8636945,1.5980907,557.2675817,249.6202581,728.0912865,1.1683496,4.4363178,1.2924967,10.9772083),(28150,'zebu-radius.tif',238,3,120,174.1663131,62.1165134,87.0833794,1.8,62.0924808,87.2121798,-0.2395133,8.6327409,12.3882337,2183.0515046,6919.2090943,1.633622,558.5307223,252.8804626,721.3619124,1.4465267,3.8540266,1.2490458,10.5709582),(28151,'zebu-radius.tif',238,3,121,177.2582086,62.0399836,86.935162,1.8,62.0745798,87.0846239,-0.2109794,9.0493424,12.158426,2401.9205203,7025.9139781,1.2956322,577.8637788,265.4248694,775.3900127,0.4062501,0.7323777,0.9827937,1.5552988),(28152,'zebu-radius.tif',238,3,122,175.7586406,62.0529602,86.9298246,1.8,62.0935611,87.1073355,-0.2125036,9.2683088,12.3554369,2427.1869658,6995.6473107,1.3030193,566.1999145,261.8802434,760.1048816,0.9898494,5.469309,1.3078016,12.2452449),(28153,'zebu-radius.tif',238,3,123,175.2266895,62.067954,86.9233683,1.8,62.1000445,87.1169775,-0.2141911,9.3703221,12.5938717,2460.4668905,6985.3867052,1.3194719,554.6655442,262.580823,741.6990295,13.9272377,23.393797,0.3547057,64.0615188),(28154,'zebu-radius.tif',238,3,124,174.9224298,62.0961638,86.9147406,1.8,62.1652839,87.1054297,-0.2151133,9.7521498,12.2206105,2492.6355988,7014.0418731,1.3283714,573.9518374,255.5985759,768.8084566,0.6093751,0.8617866,2.3561945,1.842561),(28155,'zebu-radius.tif',238,3,125,174.8320834,62.1208257,86.8969151,1.8,62.1761447,87.0466344,-0.2146597,9.3778475,12.2712302,2512.1342911,7050.7349546,1.3221782,574.5744188,267.8796281,777.7908027,0.4062501,1.2355614,1.735945,2.774049),(28156,'zebu-radius.tif',238,3,126,174.3616094,62.157416,86.8771538,1.8,62.2191923,87.0453975,-0.2159121,9.3492597,12.0247966,2544.3296043,7066.1973727,1.3338114,587.6355027,272.1423611,795.7817773,0.203125,0.6423378,1.8925469,1.3870245),(28157,'zebu-radius.tif',238,3,127,175.5606811,62.1308949,86.808167,1.8,62.1722911,86.9468454,-0.203405,9.5166775,11.9499838,2631.311457,7145.3432625,1.1939923,597.9374868,276.494759,816.058603,0.4062501,0.7323777,0.9827937,1.5552988),(28158,'zebu-radius.tif',238,3,128,174.8224186,62.1932367,86.7786092,1.8,62.222486,86.8594416,-0.2072421,9.0919331,11.9414252,2644.5269731,7145.7806562,1.2336037,598.4026631,290.8652023,805.5847727,0.4062501,0.837506,1.815775,1.9615489),(28159,'zebu-radius.tif',238,3,129,173.3626101,62.318399,86.7396601,1.8,62.3692158,86.8564661,-0.2112187,9.4376374,12.0175407,2673.1851747,7079.414931,1.2699918,589.090156,283.2472848,800.3322829,14.3479791,23.203424,0.3577461,64.9233053),(28160,'zebu-radius.tif',238,3,130,172.765406,62.3856063,86.7241718,1.8,62.4644712,86.8975797,-0.213497,9.764935,11.9719385,2702.5809372,7059.1915563,1.2926491,589.6448223,276.7638425,807.2327141,14.3944196,23.204313,0.4048918,64.6360432),(28161,'zebu-radius.tif',238,3,131,173.8175804,62.3802244,86.6372254,1.8,62.4413816,86.7261359,-0.1990207,9.8511532,12.0277713,2833.5057708,7113.6640409,1.1323935,591.4365886,287.631885,794.9907609,14.7794266,23.1598177,0.3772491,65.9040798),(28162,'zebu-radius.tif',238,3,132,173.5785238,62.4377066,86.6254651,1.8,62.4475177,86.7530895,-0.1997194,9.9295088,12.0081309,2853.6581041,7130.4710243,1.1386845,593.8035709,287.3916699,824.2605131,0.4062501,1.4787726,1.849096,3.5168477),(28163,'zebu-radius.tif',238,3,133,173.8680674,62.4969083,86.588738,1.8,62.5171671,86.6495702,-0.2003882,9.7666251,12.1002173,2896.0484335,7176.4961876,1.1481323,593.0882091,296.5249925,821.4520733,14.9592244,23.1598177,0.3772491,65.8343783),(28164,'zebu-radius.tif',238,3,134,173.6465274,62.5731866,86.5910956,1.8,62.6082485,86.6820566,-0.2058986,9.7060601,12.0289614,2902.1018262,7190.8827513,1.2096947,597.797476,298.998956,795.6536269,14.8508479,23.085766,0.369069,65.6168176),(28165,'zebu-radius.tif',238,3,135,174.0364448,62.6357147,86.5641904,1.8,62.6658708,86.6304495,-0.2061925,9.50537,12.0540617,2944.4797214,7237.9540412,1.2158257,600.4576896,309.7701333,831.8388551,0.4062501,0.5745244,2.3561945,1.1490487),(28166,'zebu-radius.tif',238,3,136,174.5522546,62.6766047,86.5236053,1.8,62.7007469,86.5713081,-0.1982286,9.5449722,11.9447837,3023.864052,7297.3602336,1.1282643,610.9244332,316.8017652,836.3049053,0.4062501,1.0938618,1.1902899,2.367799),(28167,'zebu-radius.tif',238,3,137,173.9773183,62.7933613,86.4986978,1.8,62.8495829,86.5836734,-0.2013544,10.2740979,12.0294683,3077.5793156,7267.1188076,1.1598091,604.1097291,299.5474006,826.2183767,15.177438,23.204313,0.4048918,66.1420556),(28168,'zebu-radius.tif',238,3,138,173.2776024,62.8613399,86.4848207,1.8,62.9545764,86.5980415,-0.1988738,10.2666672,11.9730769,3122.8542764,7273.7940435,1.1272323,607.5125115,304.1741023,846.6576717,15.3305822,23.2567081,0.4519294,66.3596163),(28169,'zebu-radius.tif',238,3,139,174.7173937,62.8813771,86.4068081,1.8,62.9564726,86.36743,-0.1850978,10.1959474,12.7398578,3266.1631338,7356.2995544,0.9863297,577.4239915,320.3393482,818.8219732,15.7870572,23.3673264,0.4208722,67.9642015),(28170,'zebu-radius.tif',238,3,140,175.3478807,62.9534486,86.3895229,1.8,63.0240123,86.323374,-0.1831027,10.1804254,12.1579445,3345.3376236,7421.3036983,0.9689015,610.4077614,328.6048941,864.3294671,15.8154131,23.3911513,0.401471,67.2911043),(28171,'zebu-radius.tif',238,3,141,175.3213869,63.0426025,86.3463241,1.8,63.1666076,86.1694812,-0.1812369,9.7390376,11.9781668,3390.9498169,7482.8425254,0.9493292,624.7068225,348.1812002,859.8112112,15.8889892,23.4712717,0.4094372,67.5783665),(28172,'zebu-radius.tif',238,3,142,180.9844794,63.0738009,86.270878,1.8,63.0579413,86.0857987,-0.1651722,9.9904135,12.7100484,3559.3783746,7635.7103093,0.8154751,600.7617035,356.2793851,868.1667414,16.250003,23.5362236,0.4366272,68.7274152),(28173,'zebu-radius.tif',238,3,143,181.4594045,63.2001214,86.2776591,1.8,63.2189283,86.1829321,-0.1719152,10.259937,12.4842588,3585.0429665,7719.2004107,0.8850631,618.3146755,349.4215396,883.5179277,16.0467702,23.5528715,0.4173487,68.1528909),(28174,'zebu-radius.tif',238,3,144,182.0079845,63.3032285,86.2424296,1.8,63.285651,86.1529601,-0.1699238,10.0319945,12.1605284,3650.5644951,7826.6170934,0.8674885,643.608306,363.8921955,906.0155168,0.4062501,0.837506,1.815775,1.9615489),(28175,'zebu-radius.tif',238,3,145,182.904322,63.4222587,86.1433549,1.8,63.4339096,86.0051835,-0.1601226,10.3631504,12.2283371,3777.6103344,7902.6391944,0.7749318,646.2562435,364.5233524,888.9222463,0.203125,0.2872622,2.3561945,0.5745244),(28176,'zebu-radius.tif',238,3,146,182.5776071,63.5232931,86.0783268,1.8,63.5254966,85.9530373,-0.1523071,10.6796043,12.8957212,3860.2241077,7969.2669764,0.7004482,617.9776106,361.4575983,899.7731519,0.4062501,1.8727203,1.7894653,3.9927993),(28177,'zebu-radius.tif',238,3,147,182.2421276,63.6377114,86.0006354,1.8,63.6456852,85.8618229,-0.1516478,10.7113385,12.3548588,3943.2966621,8048.3071645,0.6931669,651.4285006,368.1422893,901.9522467,0.6089031,3.9907738,1.82812,8.7283972),(28178,'zebu-radius.tif',238,3,148,184.1410152,63.7378077,85.8858236,1.8,63.6928367,85.7172526,-0.1410395,10.8172249,12.9349608,4116.9080877,8223.6106639,0.6064563,635.7661854,380.5881951,934.2675253,17.2656282,23.992842,0.4939414,72.0062871),(28179,'zebu-radius.tif',238,3,149,184.6160653,63.8774053,85.8121251,1.8,63.8413555,85.6790667,-0.1441886,10.9822178,12.6148293,4208.4969336,8345.0000563,0.6352843,661.5230267,383.2101136,943.8970255,0.4062501,1.4787726,1.849096,3.1802991),(28180,'zebu-radius.tif',238,3,150,185.9359157,63.9938482,85.7125454,1.8,63.9643478,85.574454,-0.1369601,10.8986403,12.742929,4331.7944857,8499.049462,0.5776738,666.9620043,397.4619201,959.9766771,0.6906144,3.5993848,1.8568478,8.0841713),(28181,'zebu-radius.tif',238,3,151,188.5799675,64.1037091,85.625045,1.8,64.0711629,85.5161756,-0.1291692,10.8320055,12.9261739,4466.120573,8678.7342315,0.5214892,671.4078216,412.3078193,969.7872513,0.6409442,4.0472377,1.8766752,8.8966715),(28182,'zebu-radius.tif',238,3,152,191.0250972,64.215216,85.5397963,1.8,64.1988432,85.4563315,-0.1218744,10.8478601,13.0725067,4598.1057428,8861.4765161,0.470557,677.8712553,423.8721465,984.118053,0.5795502,3.0196708,1.9138203,6.5288725),(28183,'zebu-radius.tif',238,3,153,192.7624215,64.36753,85.4224679,1.8,64.3164741,85.2825216,-0.1148709,11.3331487,12.8477373,4729.5027824,9007.8622887,0.4220662,701.1244162,417.3158678,1020.0154582,0.6977467,2.5693511,1.8925469,5.7163724),(28184,'zebu-radius.tif',238,3,154,192.7592708,64.474802,85.3320277,1.8,64.4181768,85.2224641,-0.1073874,11.5265537,12.8760779,4817.8214053,9156.1016083,0.3690627,711.0939876,417.9758789,986.100153,0.7537355,2.5693511,1.8925469,5.8846467),(28185,'zebu-radius.tif',238,3,155,191.9468157,64.5992293,85.2451418,1.8,64.5766201,85.1496558,-0.1017321,11.4858047,13.2624932,4901.5114124,9320.3688542,0.3299491,702.7614429,426.7451469,998.7375448,0.6437959,3.0196708,1.9138203,6.5288725),(28186,'zebu-radius.tif',238,3,156,191.8787245,64.7109619,85.1510559,1.8,64.6703823,85.0810269,-0.0964801,11.5693566,13.4043541,4979.714671,9507.236888,0.2967589,709.2648242,430.4227846,1000.7273786,0.7609124,4.1875299,1.9693188,9.352208),(28187,'zebu-radius.tif',238,3,157,190.8185107,64.8394671,85.0486482,1.8,64.8041033,85.005762,-0.0887177,11.5309746,13.590009,5050.3122815,9670.5566532,0.2496602,711.5931001,437.9779213,1005.7570474,0.9992977,2.9991052,2.0647377,7.370244),(28188,'zebu-radius.tif',238,3,158,190.2535017,64.9697165,84.9452424,1.8,64.9135012,84.9115312,-0.0806323,11.919254,14.0083334,5122.5762664,9861.334195,0.2057111,703.9619869,429.7732284,941.4270055,0.6900846,1.7355011,1.929567,4.0913721),(28189,'zebu-radius.tif',238,3,159,191.8831756,65.124014,84.852059,1.8,65.0772061,84.830982,-0.0710392,11.8392943,14.0941607,5216.692468,10124.7580293,0.1611206,718.3654445,440.625289,1010.9367119,0.6093751,1.3626042,2.0344439,3.1105976),(28190,'zebu-radius.tif',238,3,160,194.1524385,65.2342917,84.7172935,1.8,65.1982268,84.7343176,-0.0573699,11.7808946,14.0625956,5343.4529303,10426.7847635,0.1063857,741.4552107,453.5693697,972.6977699,18.2867561,26.8747552,3.0735162,79.1589704),(28191,'zebu-radius.tif',238,3,161,197.0235066,65.3774008,84.5329689,1.8,65.343363,84.5644069,-0.0485271,12.0175804,15.2706655,5489.8646713,10800.5809159,0.077267,707.2763755,456.8194658,1002.3419398,1.3482103,3.4946953,2.1910458,8.82697),(28192,'zebu-radius.tif',238,3,162,198.2796294,65.4701279,84.4085824,1.8,65.4696251,84.4544082,-0.0417684,11.8935908,14.747115,5628.2165996,11167.2810794,0.0576196,757.251917,473.2142463,1031.8260499,0.9779496,3.0196708,2.3086114,6.9147075),(28193,'zebu-radius.tif',238,3,163,199.1265677,65.54525,84.26969,1.8,65.5807982,84.3451045,-0.0392962,12.0402131,14.8768296,5765.8229873,11643.9799095,0.0512219,782.6922977,478.8804754,1069.2852411,1.3003047,4.1826005,2.0778948,10.4315552),(28194,'zebu-radius.tif',238,3,164,200.9568141,65.5913172,84.1427704,1.8,65.617888,84.1707844,-0.0345304,12.1669485,15.345436,5951.0001026,12184.6096732,0.0399195,794.0217322,489.1119641,1146.9420241,0.72765,2.9083079,2.0032041,6.2908967),(28195,'zebu-radius.tif',238,3,165,204.107561,65.6762056,84.0224352,1.8,65.7137944,84.0582221,-0.0387587,12.0755481,16.3843694,6185.2814556,12843.9611708,0.0510774,783.9155036,512.2153796,1131.1459377,0.9071033,3.3623177,2.0074235,7.4399455),(28196,'zebu-radius.tif',238,3,166,206.6157056,65.7844652,83.8868087,1.8,65.8018414,83.9470004,-0.0353589,12.3015343,15.8725189,6445.5064422,13531.4378107,0.0430356,852.5072726,523.9595557,1202.3470824,0.990111,7.086124,2.0472637,15.8606654),(28197,'zebu-radius.tif',238,3,167,209.0010336,65.9174191,83.7475357,1.8,65.9124432,83.8102198,-0.0293665,12.089352,16.23874,6695.1522774,14235.699227,0.0300314,876.6504829,553.8057201,1232.6519877,0.5669733,1.6376464,2.0899424,3.5168477),(28198,'zebu-radius.tif',238,3,168,211.7739534,66.013597,83.5600266,1.8,66.013072,83.6473593,-0.0238609,12.3842287,16.3670598,6964.4967771,15014.9341306,0.0200914,917.3873841,562.3682301,1267.5561049,0.7281657,4.1826005,2.0778948,9.1635186),(28199,'zebu-radius.tif',238,3,169,214.1312747,66.1510261,83.3639395,1.8,66.2192526,83.4312729,-0.0214279,12.6387486,17.2951501,7254.742987,15762.7545737,0.0163841,911.3973876,574.0080153,1272.1433732,0.6314485,2.8219032,2.0988708,6.052921),(28200,'zebu-radius.tif',238,3,170,218.707222,66.2713258,83.1765871,1.8,66.3719376,83.2785861,-0.0192783,13.1286422,17.4417656,7577.95824,16713.4544134,0.0135456,958.2432659,577.2080726,1322.926195,0.729197,3.8325556,2.1293956,8.1827441),(28201,'zebu-radius.tif',238,3,171,225.5028955,66.3876565,82.9213855,1.8,66.4228073,82.9706748,-0.0102764,12.9240774,18.3902509,7992.9644133,17971.131883,0.0039689,977.2097177,618.4553207,1343.8562473,0.7106286,4.006252,2.1025204,8.5889942),(28202,'zebu-radius.tif',238,3,172,231.144883,66.4174321,82.6388995,1.8,66.5245021,82.7317382,0.0041352,13.4357503,18.703751,8422.4302666,19503.4797849,0.0006585,1042.7576695,626.8671331,1417.4205446,0.7323199,3.2116889,2.176341,6.7957196),(28203,'zebu-radius.tif',238,3,173,236.3058565,66.502848,82.3654413,1.8,66.6356864,82.4242839,0.01188,13.536129,19.0221105,8886.1624155,20922.2182128,0.0055583,1099.8894255,656.4773738,1473.8951096,0.6620757,3.9439748,2.1730837,8.3510184),(28204,'zebu-radius.tif',238,3,174,243.494048,66.684535,82.083031,1.8,66.8119014,82.1014874,0.0075478,13.6073218,19.7975053,9384.4453893,22524.5542863,0.0023124,1137.7471024,689.6614577,1527.2048052,0.6775324,2.4794571,2.1815223,5.2404208),(28205,'zebu-radius.tif',238,3,175,267.517418,67.0783805,81.7481353,1.8,67.0624795,81.6541421,0.0162938,13.5164809,20.8539697,10467.4818088,25579.9912633,0.0118358,1226.6245546,774.4235994,1652.1643714,0.5745244,1.8727203,2.2794226,3.8533963),(28206,'zebu-radius.tif',238,3,176,300.5564128,67.6385673,81.3030202,1.8,67.3522604,81.260277,0.0011734,13.7644909,21.7387911,11771.4543216,30229.4173294,0.0000691,1390.574903,855.2044824,1835.8742869,0.5745244,1.0156252,2.4980915,2.0108353),(28207,'zebu-radius.tif',238,3,177,333.9206347,67.1601633,80.7140509,1.8,67.5169139,80.7013327,0.0475659,14.8600559,21.4167881,13879.3084485,38209.6298823,0.1258223,1784.0971133,934.0010906,2305.7475104,24.7402485,41.5458985,3.0190569,116.9043509),(28208,'zebu-radius.tif',238,3,178,346.2982314,67.3638951,80.36098,1.8,67.5365962,80.3877032,0.0191857,15.3261671,21.6041968,15816.0339527,41937.4393259,0.021243,1941.1709564,1031.9627751,2516.4673713,1.5896731,9.1406267,2.2142974,21.0109696),(28209,'zebu-radius.tif',238,3,179,335.9966393,67.5175737,80.3864632,1.8,67.6796643,80.3191924,-0.0261571,15.0272384,22.0869228,15381.1340128,39888.5377148,0.0383063,1805.9798618,1023.5502732,2312.7056928,1.5937805,8.9789539,2.2278713,20.8631104),(28210,'zebu-radius.tif',238,3,180,327.0353649,67.5181797,80.4184638,1.8,67.7632202,80.337362,-0.0098912,14.2142093,21.9228543,13968.1916353,38611.4557295,0.0053324,1761.2421843,982.6921285,2191.6191076,0.7181555,1.5864573,2.4468544,3.2788719),(28211,'zebu-radius.tif',238,3,181,318.7879348,67.2432266,80.4934178,1.8,67.7106433,80.3161752,0.045512,14.02,22.1941627,11558.7653737,38347.2316594,0.1099772,1727.8070878,824.448313,2194.856485,1.3651817,7.4936348,2.1437625,17.9207871),(28212,'zebu-radius.tif',238,3,182,316.4344019,67.1963968,80.4562604,1.8,67.8154765,80.3458564,0.0591809,12.6228298,22.0199366,9915.320532,38509.0218012,0.1844961,1748.8252782,785.5069467,2140.9352498,1.2963358,8.0561551,2.1587989,18.7128721),(28213,'zebu-radius.tif',238,3,183,315.8611285,66.9875604,80.2109494,1.8,67.8505357,80.1483133,0.0760092,12.7451999,21.1842835,8936.6370893,39468.5786557,0.3035572,1863.1066093,701.1766911,2167.8704661,0.8883229,4.2267582,2.1854593,9.619055),(28214,'zebu-radius.tif',238,3,184,283.3251404,69.1417247,80.9553954,1.8,69.6807369,80.6468785,-0.069095,12.7240143,20.5723475,6529.6199312,29346.1977224,0.2250791,1426.4875595,513.1729467,1710.0593412,0.5745244,0.8617866,2.3561945,1.7235731),(28215,'zebu-radius.tif',238,3,185,269.9204252,70.4510754,81.1041411,1.8,70.4630824,80.7090315,-0.1341308,11.5807409,19.7090942,5354.9680848,24603.6919032,0.8045173,1248.342094,462.4028911,1460.3018206,18.5771698,36.6583015,3.0138012,104.5281592),(28216,'zebu-radius.tif',238,3,186,238.1824513,72.0674447,80.9166764,1.8,71.5696727,80.7207475,-0.1932083,10.3341486,19.7147108,4372.2041895,18264.4864394,1.4635225,926.439481,423.0831548,1137.6747631,19.5233415,35.1881519,3.0896164,106.9332857),(28217,'zebu-radius.tif',238,3,187,169.2532234,74.3342834,79.7467461,1.8,73.3429463,80.0304729,-0.1995845,9.8530758,21.435126,2950.6680312,10006.7677933,1.1088307,466.8396996,299.4666926,602.9035353,18.388549,34.163675,0.0475831,127.8372263),(28218,'zebu-radius.tif',238,3,188,108.212353,77.6262943,78.5313327,1.8,76.5301997,78.6549988,-0.0933507,8.9096093,13.4383117,1409.55873,3786.9803041,0.1567107,281.8047665,158.2065699,376.2533635,16.7292348,23.7274043,0.5595068,107.1628052),(28219,'zebu-radius.tif',238,3,189,81.3300052,79.1780727,77.7739712,1.8,78.6943717,78.0227262,-0.0055402,8.5700191,11.3522687,731.4817155,1812.568326,0.0004161,159.6657354,85.3535689,209.3793049,14.8036175,20.2820122,0.512935,82.9102912),(28220,'zebu-radius.tif',238,3,190,57.5315385,79.8332234,77.3428,1.8,79.3971546,77.4724507,0.1355544,6.6530425,10.107326,281.7700152,923.0963269,0.1751138,91.3294301,42.352054,108.8385889,11.3310177,18.2190817,0.3887878,63.1962296),(28221,'zebu-radius.tif',238,3,191,14.3436878,82.3575783,78.0850503,1.8,80.8693048,77.4652152,0.3396532,4.0055604,8.8126131,32.344804,162.7893584,0.2653479,18.4723142,8.0749759,21.5049038,7.6947244,12.8756282,0.1106572,38.6275821),(28222,'zebu-radius.tif',238,3,192,1.4296139,84.7310776,78.7417438,1.8,84.6956639,78.8212379,-1.2719279,0.8568476,2.3906094,0.190284,1.7000798,0.2176124,0.7111491,0.2220746,0.7904101,1.8654767,4.9464179,1.2360595,11.5517326),(28223,'zebu-radius.tif',238,3,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28224,'zebu-radius.tif',238,3,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28225,'zebu-radius.tif',238,3,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28226,'zebu-radius.tif',238,3,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28227,'zebu-radius.tif',238,3,197,9.0031843,86.5711359,79.5084596,1.8,86.4535535,79.548776,-1.5619886,4.311458,4.5908466,33.6326983,40.1473839,1.5004143,8.7450937,7.8007714,15.7381482,8.9375017,9.5209106,1.7640078,30.1371607),(28228,'zebu-radius.tif',238,3,198,28.2676137,85.6783305,79.5949902,1.8,85.4467281,79.6314815,-1.5451032,6.0818564,7.151661,207.2784027,338.5187616,4.7081595,47.3342854,34.0814363,70.2268006,14.4218777,14.8781291,0.891791,47.8608021),(28229,'zebu-radius.tif',238,3,199,44.5048004,84.915104,79.6058731,1.8,84.6946463,79.6376254,-1.5559066,7.1413352,8.9686538,456.9275042,874.7513586,7.4158224,97.5342986,63.9834833,135.324857,16.7789151,18.5456608,1.0679531,58.5796195),(28230,'zebu-radius.tif',238,3,200,60.7388363,84.3499693,79.5587493,1.8,84.0750872,79.5713882,-1.5327426,8.0052994,10.4072849,758.869904,1551.9496297,10.1084874,149.121471,94.7959432,204.3679375,18.0390251,21.2515779,1.0172628,66.6229607),(28231,'zebu-radius.tif',238,3,201,303.4726791,62.6051336,80.9145488,1.8,65.8878263,80.7707599,-0.0708956,16.2075005,28.3814262,14082.150153,54732.9964847,0.2537929,1928.4794262,868.8662501,2279.8806497,28.6406304,29.264108,1.8090411,95.0977935),(28232,'zebu-radius.tif',238,3,202,536.7528183,62.3147393,80.9749984,1.8,66.2512833,80.7340218,-0.0845319,16.3497331,28.881939,26356.9528023,69233.5184627,0.6377191,2397.1215535,1612.072362,3102.473204,0.203125,0.6423378,1.8925469,1.3870245),(28233,'zebu-radius.tif',238,3,203,549.9445831,62.5680183,80.9347853,1.8,66.5603093,80.6706888,-0.0914918,16.3358872,28.7557074,27181.8831664,72496.0638353,0.7651033,2521.1017342,1663.9367546,3233.0649874,28.8437554,29.2366018,2.4299521,95.7913058),(28234,'zebu-radius.tif',238,3,204,558.5028369,62.7491324,80.896382,1.8,66.7834053,80.6200959,-0.0978052,16.442753,28.7008436,27872.8159729,75091.205209,0.887593,2616.3413986,1695.1428949,3329.1596596,29.0468804,29.261993,0.4915906,95.9595801),(28235,'zebu-radius.tif',238,3,205,564.5851663,62.8718679,80.8575097,1.8,66.954244,80.5462338,-0.1024745,16.7463959,28.6698276,28367.9404984,76923.7692464,0.9846676,2683.0914463,1693.9728827,3397.5010531,29.0468804,29.262698,0.5475622,95.9595801),(28236,'zebu-radius.tif',238,3,206,566.414675,62.868782,80.8798046,1.8,67.0204819,80.559625,-0.095798,16.2232742,28.6152562,28495.6743812,76942.1063728,0.8637107,2688.8491193,1756.4687624,3390.2004218,29.1452724,56.3682045,0.1995157,176.0838634),(28237,'zebu-radius.tif',238,3,207,564.8184216,62.7208544,80.9488262,1.8,66.8304994,80.6738246,-0.0764559,16.476068,28.5270419,28223.9563554,75221.7761307,0.5492045,2636.8586142,1713.0274239,3308.8149878,29.1452724,56.6077813,0.2023216,174.7954117),(28238,'zebu-radius.tif',238,3,208,563.5983449,62.591671,80.9932318,1.8,66.6279996,80.7672498,-0.0633732,16.4686963,28.4889922,28085.538445,74136.0814091,0.3767465,2602.2711156,1705.3892995,3255.6322807,29.1452724,56.6489475,0.2058342,174.7461253),(28239,'zebu-ulna.tif',238,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28240,'zebu-ulna.tif',238,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28241,'zebu-ulna.tif',238,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28242,'zebu-ulna.tif',238,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28243,'zebu-ulna.tif',238,4,5,4.6470141,53.3938296,53.6214282,1.8,53.1224425,52.7681657,1.2140259,1.334887,11.041775,1.4257457,71.0259847,0.6800321,6.4324789,1.0680647,6.5615826,2.8089492,7.1441129,1.8295672,16.336617),(28244,'zebu-ulna.tif',238,4,6,24.537842,52.6903754,51.1428365,1.8,52.7923969,51.2608141,1.1893245,2.9214147,10.2104894,20.763444,871.0748833,3.5228261,85.3117659,7.107325,87.3433151,4.1655673,10.7426071,1.8387067,25.4015627),(28245,'zebu-ulna.tif',238,4,7,40.8443701,52.4110038,49.9338213,1.8,52.8144881,50.7980218,1.172498,3.0904265,12.1693815,60.7680209,1676.1934678,5.7833726,137.7385914,19.6633124,142.6127464,0.4062501,0.9084028,2.0344439,1.9615489),(28246,'zebu-ulna.tif',238,4,8,58.1368945,52.1830346,49.0068754,1.8,52.7271959,50.2159825,1.1602897,4.1392905,14.091488,121.2139605,2347.2707572,8.1463359,166.5736614,29.2837529,175.0309866,0.2872622,0.5745244,2.3561945,1.1490487),(28247,'zebu-ulna.tif',238,4,9,76.733428,52.1084524,48.6723039,1.8,52.697637,49.8231784,1.1625891,5.311664,15.1248595,241.1916936,3275.0117147,10.7736191,216.5317109,45.4079353,232.4782058,8.3817561,26.1408587,1.9614034,70.6157599),(28248,'zebu-ulna.tif',238,4,10,91.6382864,51.8780511,48.7174765,1.8,52.3968747,49.6755279,1.1738393,5.9306624,15.7032708,421.414365,4249.3455348,12.9901821,270.6025763,71.05688,297.2237295,0.203125,0.6423378,1.8925469,1.3870245),(28249,'zebu-ulna.tif',238,4,11,104.4172283,51.6940995,48.8519027,1.8,52.0633085,49.5595097,1.1837924,6.763713,16.2057978,636.7461472,5360.5712706,14.9239626,330.7810787,94.1415088,369.6822591,10.0462064,28.6291032,1.9486677,68.1902184),(28250,'zebu-ulna.tif',238,4,12,117.4044946,51.5594779,49.0470941,1.8,51.7667583,49.3859994,1.1918769,7.1762813,16.106139,861.5356951,6593.3635968,16.8898416,409.3695939,120.0532226,462.5177755,0.4308933,1.0156252,2.2142974,2.1298232),(28251,'zebu-ulna.tif',238,4,13,126.956609,51.4078882,49.0343893,1.8,51.5096656,49.1868653,1.2008178,7.9176585,16.0197099,1073.9644855,7579.206923,18.3928125,473.1176152,135.6416788,539.8709353,11.9235222,29.8752671,1.9614034,71.4895054),(28252,'zebu-ulna.tif',238,4,14,137.1684548,51.3350612,49.2580881,1.8,51.3271786,49.2926496,1.2179611,7.9982154,16.134682,1280.872713,8931.5536034,20.1314925,553.5624187,160.1448136,632.4946313,12.6548481,30.5661002,1.9809237,74.4811151),(28253,'zebu-ulna.tif',238,4,15,145.6739462,51.3784001,49.7090808,1.8,51.3097505,49.5788358,1.2413075,7.9838746,16.823475,1444.848087,10539.105694,21.7372071,626.4523637,180.970789,712.3312393,12.9239161,31.8362454,1.9430091,77.4438535),(28254,'zebu-ulna.tif',238,4,16,154.377647,51.2954178,50.1847226,1.8,51.159646,49.8817542,1.2595551,8.8489543,17.7458314,1592.1729444,12555.2459389,23.3166024,707.5039572,179.9278076,797.1955058,0.4308933,1.0156252,2.2142974,2.1298232),(28255,'zebu-ulna.tif',238,4,17,162.107967,51.4042375,50.8867682,1.8,51.2609742,50.4749078,1.2724108,7.6783171,18.771729,1688.5684469,15013.7738485,24.6830259,799.807723,219.9138726,889.3247959,0.4547168,1.3626042,2.0344439,2.9423233),(28256,'zebu-ulna.tif',238,4,18,169.4817151,51.369745,51.6880585,1.8,51.2514555,51.1690768,1.276094,8.4041899,19.8210213,1719.4432063,17599.2764725,25.8639232,887.9096685,204.5935701,974.2325882,0.203125,0.4542014,2.0344439,0.9807744),(28257,'zebu-ulna.tif',238,4,19,174.4108711,51.293201,52.4652901,1.8,51.120624,51.7483261,1.2753567,8.2793507,20.6378744,1750.5149005,19862.6553207,26.6042156,962.4370679,211.4314239,1045.9308814,0.5141616,1.0938618,1.9513027,2.5360733),(28258,'zebu-ulna.tif',238,4,20,180.309957,51.2721126,53.2064655,1.8,51.035835,52.3441862,1.2770008,8.3579653,21.8770413,1801.3781489,22358.9280037,27.5315055,1022.0270527,215.5283125,1103.769929,1.5517515,20.3500472,2.047836,45.5014594),(28259,'zebu-ulna.tif',238,4,21,186.3178062,51.2451469,53.7509332,1.8,51.0193343,52.8435237,1.278035,8.6105304,22.6469017,1824.328091,24619.5945906,28.4666186,1087.1065241,211.8717436,1166.6072998,0.203125,0.2872622,2.3561945,0.5745244),(28260,'zebu-ulna.tif',238,4,22,193.4177644,51.1965311,54.1930559,1.8,50.9631975,53.3459429,1.2841586,8.8207962,23.6515321,1852.1885294,26775.7579443,29.6594692,1132.0940132,209.9797439,1209.1774259,0.5453507,2.1877236,1.9513027,4.9038722),(28261,'zebu-ulna.tif',238,4,23,200.7946381,51.2530563,54.8500953,1.8,51.0850083,54.0715057,1.2891503,9.1457789,24.8116049,1822.0471851,29069.9933906,30.8805724,1171.6289005,199.2227458,1244.0548863,0.3859858,1.1844123,2.1112158,2.5360733),(28262,'zebu-ulna.tif',238,4,24,207.20367,51.3979688,55.6935397,1.8,51.2227376,54.9857502,1.2870025,9.510981,25.4177876,1731.6464497,31715.1459685,31.8264894,1247.753993,182.0681222,1313.0261008,0.4504384,2.0005496,1.9890207,4.3293479),(28263,'zebu-ulna.tif',238,4,25,211.7040743,51.847207,56.8004381,1.8,51.8717729,56.3195227,1.2812064,8.5680938,25.4806915,1639.1701513,34040.5417533,32.4068096,1335.934771,191.3109489,1392.2344943,0.4062501,0.9084028,2.0344439,1.9615489),(28264,'zebu-ulna.tif',238,4,26,216.6045611,52.3573537,58.3274928,1.8,52.4237638,57.6496103,1.2704016,7.7293972,24.4538463,1596.81708,36254.3306019,32.9399502,1482.5614811,206.5901172,1531.9474059,0.203125,0.4542014,2.0344439,0.9807744),(28265,'zebu-ulna.tif',238,4,27,222.3043498,52.8877324,59.9332191,1.8,52.8850833,59.1047405,1.2590934,7.4772221,24.6541577,1609.0688411,37827.8853781,33.5660074,1534.3410171,215.196075,1595.9239249,2.2483637,14.3631092,2.0724004,40.310325),(28266,'zebu-ulna.tif',238,4,28,231.0417961,53.4160104,61.7459576,1.8,53.3327941,60.8441007,1.2553407,7.5654042,25.9515335,1701.169721,38742.0127615,34.8004852,1492.8602489,224.8617104,1557.2629118,14.3059437,48.2861157,1.93646,245.4963346),(28267,'zebu-ulna.tif',238,4,29,229.0332324,53.8304215,63.2827906,1.8,53.6397591,62.0379672,1.2558364,7.5542082,26.6388928,1720.6766352,34222.4622192,34.5091004,1284.6803523,227.7772312,1348.9764602,13.0921751,47.4813195,1.9155469,153.2134204),(28268,'zebu-ulna.tif',238,4,30,210.143967,53.7455743,63.1222349,1.8,53.7453991,62.4491748,1.2513331,7.4509261,23.5034576,1627.783958,25799.3838598,31.569516,1097.6846196,218.4673348,1165.3489407,12.8960914,43.4222233,1.8895883,148.6460967),(28269,'zebu-ulna.tif',238,4,31,194.7856136,53.5219731,62.5102546,1.8,53.5307698,61.9556203,1.2470558,7.3685089,21.5632695,1558.1380765,20196.6195677,29.1789784,936.6213939,211.4590738,1008.3457207,1.4401121,8.6846347,1.7590178,23.8955503),(28270,'zebu-ulna.tif',238,4,32,182.5885347,53.4276501,62.2107243,1.8,53.4225591,61.730075,1.2349431,7.3691141,19.8299207,1482.3454012,16158.3088035,27.1259733,814.8448503,201.1565283,888.0398325,1.2718408,11.9723214,1.82812,29.1563862),(28271,'zebu-ulna.tif',238,4,33,171.0262187,53.4645081,62.0821548,1.8,53.4989699,61.6568798,1.2176676,7.6195936,18.4233366,1408.36243,12997.4550564,25.0951909,705.4886615,184.834323,781.001856,1.8477073,11.1940143,1.7717506,27.6010874),(28272,'zebu-ulna.tif',238,4,34,161.4887077,53.4361667,62.074103,1.8,53.5336659,61.6736988,1.2009849,7.695473,17.2207918,1324.1884117,10824.2872905,23.3986743,628.5592103,172.0736875,703.0282046,1.5607878,14.1343504,1.7004989,36.3991861),(28273,'zebu-ulna.tif',238,4,35,154.3226214,53.4255057,62.1394978,1.8,53.5498587,61.7880899,1.1815606,7.4260252,16.5568789,1259.2677705,9215.3220021,22.0165361,556.5856986,169.5749386,630.5926637,0.203125,0.2872622,2.3561945,0.5745244),(28274,'zebu-ulna.tif',238,4,36,147.6793466,53.4091694,62.264294,1.8,53.5863149,62.0693191,1.1587858,7.5827554,15.3659106,1198.4259248,7967.0718371,20.6661948,518.490054,158.0462332,593.1521217,1.903039,14.4732826,1.6551031,38.9556744),(28275,'zebu-ulna.tif',238,4,37,142.5875395,53.4312314,62.4553313,1.8,53.6482827,62.2971563,1.133711,7.4038325,15.3321886,1152.198255,7008.0074948,19.5063691,457.0780899,155.6218698,531.2755762,1.1846673,4.6319635,1.8370484,11.4820311),(28276,'zebu-ulna.tif',238,4,38,137.6220624,53.4286814,62.6701744,1.8,53.6449215,62.5930951,1.1027969,7.4995424,15.4482463,1132.727013,6158.5456778,18.2694942,398.6566223,151.0394833,471.4324482,12.5021137,26.1810761,2.0726198,68.2310486),(28277,'zebu-ulna.tif',238,4,39,133.1019408,53.4618744,62.9721882,1.8,53.6912522,62.9547455,1.0719646,7.5065292,15.6990225,1128.0401665,5554.5852954,17.1065603,353.8172699,150.2745321,424.1374627,12.6583935,25.3719354,2.0810052,66.844024),(28278,'zebu-ulna.tif',238,4,40,131.9977541,53.4938497,63.3699941,1.8,53.7207282,63.430105,1.0467409,7.5769116,18.7603613,1155.420401,5206.5241457,16.4910167,277.527925,152.4922643,334.133199,1.1232992,11.0156714,1.6631257,25.4712642),(28279,'zebu-ulna.tif',238,4,41,131.6265036,53.6676952,63.837232,1.8,53.9680252,63.9660596,1.0118579,7.9734802,12.4713856,1218.6766274,4995.3717988,15.7687729,400.5466557,152.8412433,490.5392939,1.4382423,14.4447469,1.6270749,34.9424601),(28280,'zebu-ulna.tif',238,4,42,132.6164507,53.8084269,64.3656419,1.8,54.0361118,64.5718755,0.9758316,8.9202503,12.3639993,1313.264821,4946.0989489,15.159446,400.0403776,147.2228667,497.9626344,1.6949,15.4588697,1.6233794,38.5494244),(28281,'zebu-ulna.tif',238,4,43,141.6018808,53.9888586,65.1784408,1.8,54.1651623,65.3685104,0.9544068,10.6434729,12.7322302,1561.3476384,5166.5133066,15.713291,405.7822735,146.6953175,527.5714737,1.8281253,15.645903,1.5967645,41.4917477),(28282,'zebu-ulna.tif',238,4,44,156.904571,54.0311799,66.2163854,1.8,53.873485,66.390279,0.9423255,11.6352581,13.2598252,2230.8493193,5525.56007,17.1121087,416.7143967,191.7318294,582.9550651,2.9189701,15.5453703,1.4529242,45.7598503),(28283,'zebu-ulna.tif',238,4,45,165.744204,52.933241,67.1257274,1.8,52.7435044,67.1176958,1.4478273,12.92499,13.1598886,4342.1040388,4952.0384925,27.2084219,376.2979023,335.9464149,617.9482506,4.6673079,19.9124709,1.2490458,58.509918),(28284,'zebu-ulna.tif',238,4,46,155.253017,52.2483028,67.1778481,1.8,52.1428747,67.0803797,-1.1229459,14.4265807,13.2354059,3468.8276321,4758.0078567,21.0234828,359.4908918,240.4469715,532.6510586,4.8985823,19.7324239,1.2132305,61.7803337),(28285,'zebu-ulna.tif',238,4,47,152.7118646,51.934733,67.5119578,1.8,51.9150146,67.3238186,-1.0629657,14.0827466,12.9479481,3062.2642311,4813.3604527,19.4333246,371.7469682,217.4479397,482.5052796,5.3203732,17.3133564,1.1859327,66.9425968),(28286,'zebu-ulna.tif',238,4,48,153.6099275,51.8803649,67.7965276,1.8,52.0687954,67.6315425,-0.917806,16.4283259,14.535147,3067.0482117,4841.8973548,16.151206,333.1165037,186.6926816,394.5724168,0.4062501,0.9084028,2.677945,1.842561),(28287,'zebu-ulna.tif',238,4,49,145.107962,52.0500545,67.8510596,1.8,52.6617344,67.6592381,-0.6944193,14.3132113,16.5635752,2970.7542067,4571.961652,9.9041581,276.0250492,207.5532975,344.556353,0.4062501,0.7323777,2.5535901,1.5552988),(28288,'zebu-ulna.tif',238,4,50,125.429522,52.3776085,67.3736642,1.8,52.9116982,67.4993615,-0.4461934,10.8609208,18.3538378,2480.3042255,3306.8427504,3.8929608,180.1717325,228.3696072,272.7089485,19.0791343,34.2703906,0.1427353,226.2596754),(28289,'zebu-ulna.tif',238,4,51,112.5903408,52.4874544,67.1223655,1.8,52.9702388,67.191273,-0.2051855,10.2720103,19.7679605,2042.9793572,2419.0027658,0.7790042,122.3698706,198.8879774,214.8228579,17.0946583,24.9810766,0.1798535,134.813179),(28290,'zebu-ulna.tif',238,4,52,105.7058213,52.5897346,67.1600972,1.8,52.8603083,67.2802217,0.1754712,9.3592689,19.4229406,1773.0695257,2021.9541953,0.5369048,104.1013429,189.4453013,195.0767535,4.6112796,12.9777666,1.2688452,47.434137),(28291,'zebu-ulna.tif',238,4,53,99.7387942,52.8263329,67.2450111,1.8,53.1498014,67.3336255,0.5714574,11.8256534,16.3847517,1434.0274708,1871.4893123,4.8627294,114.2214024,121.2641216,184.8320894,3.4531256,11.2363219,1.3521274,36.0915088),(28292,'zebu-ulna.tif',238,4,54,94.6924854,52.9412797,67.3813972,1.8,53.208913,67.4681897,0.6600195,11.9475291,14.1925282,1188.7034296,1759.677223,5.9329758,123.9861702,99.4936623,184.5009821,2.7541639,11.1552454,1.3876855,28.2248982),(28293,'zebu-ulna.tif',238,4,55,91.0758281,53.0306571,67.5735563,1.8,53.367054,67.4675965,0.7181864,11.2548405,12.9552923,983.7903166,1672.0774303,6.5724941,129.0652032,87.4104186,174.4564771,2.1804378,10.0849076,1.4089589,26.6491843),(28294,'zebu-ulna.tif',238,4,56,88.8623158,53.0871244,67.8565048,1.8,53.4114671,67.7529144,0.7251198,9.8315205,11.9268195,880.6243004,1631.8391805,6.5146084,136.8209842,89.5715266,175.8130983,0.4062501,0.5745244,2.3561945,1.1490487),(28295,'zebu-ulna.tif',238,4,57,85.9064901,53.1601358,68.1544303,1.8,53.4799346,68.1271557,0.7193215,10.4301395,12.0656448,806.7965347,1589.5289795,6.215556,131.7400775,77.3524203,172.5336975,2.2343754,8.350391,1.4977558,22.409953),(28296,'zebu-ulna.tif',238,4,58,83.3336927,53.15738,68.4715103,1.8,53.5175828,68.3710824,0.7498291,9.6033051,11.0277642,718.5458178,1518.4543149,6.4508736,137.69376,74.8227623,166.0331117,2.0842448,8.5914928,1.4523064,21.5974529),(28297,'zebu-ulna.tif',238,4,59,81.0995506,53.0656796,68.8303231,1.8,53.289464,68.9715014,0.7944097,10.127959,10.2671496,673.2760507,1441.7244527,6.8800947,140.4211005,66.4769725,168.3925031,2.1929426,7.7613968,1.4659194,20.2597147),(28298,'zebu-ulna.tif',238,4,60,78.9620814,53.0003726,69.1679509,1.8,53.128156,69.3868651,0.8344472,11.7237187,9.2410257,619.9849141,1390.5104968,7.2246411,150.471445,52.8829572,159.4036938,9.8583327,14.3875058,2.103952,67.3080167),(28299,'zebu-ulna.tif',238,4,61,76.9228354,52.9404141,69.4834123,1.8,53.0898923,69.7756688,0.8667288,11.4557005,8.9400525,559.5713385,1325.0586404,7.4483417,148.2159791,48.8465405,161.1310076,7.5257936,14.146022,2.1309177,52.0014606),(28300,'zebu-ulna.tif',238,4,62,74.0180718,52.8642862,69.7303068,1.8,53.0687556,69.8448867,0.8929971,9.9997295,8.8271195,479.1369377,1237.9825926,7.485329,140.2476297,47.91499,140.8505879,7.7555494,14.2853378,2.0917061,51.1805042),(28301,'zebu-ulna.tif',238,4,63,71.7504968,52.8011267,70.0231,1.8,53.232588,70.279086,0.9224859,9.5375314,8.7954402,431.7492383,1174.55858,7.5980989,133.5417619,45.2684475,136.8058981,8.6709855,15.3571126,2.2248791,57.9269375),(28302,'zebu-ulna.tif',238,4,64,68.9516208,52.6815364,70.2606621,1.8,53.11084,70.5210923,0.9522073,9.2085185,8.9327423,384.7719406,1076.8268751,7.6275655,120.5482979,41.784348,115.1899158,7.3429056,13.7466286,2.1669955,51.1108028),(28303,'zebu-ulna.tif',238,4,65,65.6558895,52.6080482,70.474665,1.8,53.1488553,70.719077,0.9883326,8.3995274,8.5641847,357.0719402,972.0560602,7.6314974,113.5024637,42.5109561,120.8480541,6.6812507,12.6476943,2.0919345,44.0771074),(28304,'zebu-ulna.tif',238,4,66,63.2065088,52.5275743,70.7155086,1.8,53.0934083,70.9508354,1.0166324,8.4084,8.4931388,329.0198178,891.2574184,7.6172202,104.9385197,39.1298962,106.4077302,6.767646,12.9904775,2.0414368,48.0699066),(28305,'zebu-ulna.tif',238,4,67,61.7254202,52.4928206,71.0052068,1.8,53.0587201,71.3190818,1.0402016,8.9122761,8.4143577,314.1942692,837.7169776,7.6530989,99.5580426,35.2540995,99.9491804,1.291014,6.1476792,1.4382448,14.6827454),(28306,'zebu-ulna.tif',238,4,68,59.5498795,52.3650896,71.2232989,1.8,52.8279141,71.4860796,1.0938803,8.7339793,8.2530089,276.1597245,756.5422884,7.8335973,91.6686625,31.6190037,95.1629083,1.0904065,5.9220616,1.4677147,13.4147087),(28307,'zebu-ulna.tif',238,4,69,58.1824928,52.2840049,71.5038948,1.8,52.7161419,71.9671652,1.1287316,9.9984073,8.1543344,257.1039479,709.695122,7.9223368,87.0328694,25.7144903,76.7972216,6.5593636,13.378525,2.0955921,48.8619917),(28308,'zebu-ulna.tif',238,4,70,56.7188959,52.236355,71.7694454,1.8,52.6790256,72.2578118,1.1504584,10.2944327,7.949824,238.2490428,656.376201,7.8790081,82.5648721,23.1434845,72.2437844,1.7434925,5.316291,1.4559197,14.3257817),(28309,'zebu-ulna.tif',238,4,71,55.3963948,52.1915483,72.0494071,1.8,52.5509463,72.5544932,1.1682107,10.7263461,7.7304593,217.345864,610.6923515,7.8154514,78.9981974,20.2628054,63.2569571,0.8813908,6.1241441,1.4711277,14.0385195),(28310,'zebu-ulna.tif',238,4,72,54.2814805,52.1466722,72.3287833,1.8,52.339557,72.7417241,1.1820502,9.8487602,7.5304358,198.1563002,566.2617053,7.7472111,75.1964057,20.1199234,64.0919322,0.6872303,6.0153826,1.3667783,13.1274465),(28311,'zebu-ulna.tif',238,4,73,52.952603,52.193393,72.6105525,1.8,52.5628738,73.0936588,1.1788898,9.6268283,7.3526128,205.8948657,526.4156127,7.5379212,71.5957205,21.3876116,63.0038955,0.5251379,4.1875299,1.3258177,8.966373),(28312,'zebu-ulna.tif',238,4,74,51.4196646,52.1903496,72.9073982,1.8,52.7151415,73.3791256,1.1498659,10.0116146,7.3255077,197.3318292,492.4076353,7.1390888,67.2182267,19.7102902,56.1336318,0.520663,3.3500239,1.3258177,7.1730984),(28313,'zebu-ulna.tif',238,4,75,50.2966859,52.1689902,73.2437735,1.8,52.7309835,73.8553372,1.1395063,11.524423,8.0794258,199.1697796,466.1749175,6.9178064,57.6990157,17.282408,47.2733121,0.5800727,2.3159818,1.3045443,5.141848),(28314,'zebu-ulna.tif',238,4,76,48.7118977,52.129178,73.5292452,1.8,52.5836476,74.0848315,1.1326782,9.5166315,7.3362851,182.6472802,423.8455055,6.6574854,57.7738592,19.1924297,50.7610436,0.5141616,1.3626042,1.1071487,2.9423233),(28315,'zebu-ulna.tif',238,4,77,47.3818324,52.1047705,73.8231229,1.8,52.3456116,74.2850751,1.1263358,8.9819647,6.8878186,164.1599894,392.5468768,6.4370198,56.9914655,18.2766237,49.2068292,0.5141616,1.0156252,0.9272952,2.1298232),(28316,'zebu-ulna.tif',238,4,78,46.7465693,52.1293995,74.1545539,1.8,52.4266375,74.6598499,1.0965118,9.6202778,7.6630348,159.133629,384.2287772,6.1660531,50.14055,16.5414797,44.1784561,7.4455674,12.3972854,1.8873656,32.8703795),(28317,'zebu-ulna.tif',238,4,79,46.1719081,52.1644421,74.505942,1.8,52.4078727,75.1064553,1.0814653,10.8093294,7.8738574,151.0887916,377.4418177,5.9951656,47.936075,13.9776286,39.5219847,7.1976418,12.2044176,1.8925469,32.3451415),(28318,'zebu-ulna.tif',238,4,80,46.0448404,52.2394782,74.8708231,1.8,52.5341534,75.3525499,1.0402066,9.5861252,8.0747567,142.823928,381.7174396,5.7089574,47.272934,14.8990259,41.8502332,7.0148186,12.4851693,1.9543238,32.2261537),(28319,'zebu-ulna.tif',238,4,81,46.3725181,52.4355447,75.3179077,1.8,53.0222754,75.7390774,0.9852693,9.2119505,8.1079826,151.440422,413.3207208,5.3683179,50.9770115,16.4395611,46.0206946,0.4062501,0.5745244,2.3561945,1.1490487),(28320,'zebu-ulna.tif',238,4,82,46.4232802,52.5096502,75.713184,1.8,53.0178299,76.0390029,0.9849415,7.8966267,6.2394227,143.6475969,426.3996752,5.371858,68.3396033,18.1910078,59.0263122,6.6258022,12.5297034,1.9181823,32.6816901),(28321,'zebu-ulna.tif',238,4,83,46.4359332,52.5945231,76.0909889,1.8,53.2600661,76.440947,0.9653121,7.8672747,6.3827442,148.4892121,437.5480518,5.2322199,68.551714,18.8742885,58.6514655,6.4209022,12.7208829,1.9127462,33.4737752),(28322,'zebu-ulna.tif',238,4,84,46.4043882,52.7510488,76.422293,1.8,53.9982826,76.7360977,0.8561661,9.8652161,10.2838475,166.139272,457.709242,4.4125303,44.5075875,16.8409155,44.163926,3.3947828,7.4908813,2.2794226,23.8751352),(28323,'zebu-ulna.tif',238,4,85,45.3479252,52.7745479,76.6543747,1.8,54.0535712,76.9260707,0.8228317,9.8015621,10.5449771,155.2592028,439.3258,4.0616515,41.6620916,15.8402508,42.1157859,3.271535,7.0744692,2.2545056,26.1443614),(28324,'zebu-ulna.tif',238,4,86,44.1131825,52.7576023,76.8749229,1.8,53.9106289,77.0669747,0.8113352,10.4530967,11.19576,139.8221407,414.1392683,3.8667073,36.9907241,13.3761453,36.1663056,2.8116175,6.7643993,2.2924512,21.5073363),(28325,'zebu-ulna.tif',238,4,87,43.7702137,52.7008064,77.2007139,1.8,53.3254588,77.4285316,0.8745157,8.0933565,7.4337826,119.1632939,400.2233911,4.2941969,53.8384576,14.7235938,47.6779034,3.2402965,7.3603052,2.2584676,22.4184092),(28326,'zebu-ulna.tif',238,4,88,42.8682999,52.7058286,77.4000708,1.8,53.3964571,77.5184742,0.8419252,7.9809397,7.5372599,114.0957277,385.0731356,3.9753679,51.0892741,14.2960268,45.8813994,3.668544,7.3378481,2.2974387,20.7934089),(28327,'zebu-ulna.tif',238,4,89,42.0380156,52.796698,77.5954474,1.8,53.5774891,77.6445458,0.796304,7.99787,7.8229447,115.707927,375.4579469,3.5795715,47.9944526,14.4673428,43.9023527,2.6295916,7.2044989,2.2763645,19.8126345),(28328,'zebu-ulna.tif',238,4,90,42.9728372,52.9099963,77.9164631,1.8,53.351365,77.9618612,0.7742579,6.9892112,5.8136111,119.3447537,396.7789482,3.5012881,68.2499978,17.0755685,56.7727419,3.3365731,7.2044989,2.2763645,22.131147),(28329,'zebu-ulna.tif',238,4,91,42.7524725,52.9344111,78.1024897,1.8,53.2622006,78.0793541,0.7416135,6.7917871,5.7867853,118.1215198,393.7633942,3.2511209,68.0452741,17.3918172,58.748012,3.4471462,6.7521891,2.3774679,22.9436472),(28330,'zebu-ulna.tif',238,4,92,42.1521426,52.8669853,78.2523615,1.8,53.2034897,78.1981179,0.7239687,6.7168252,5.8254571,113.9910206,381.6003492,3.0821997,65.5056497,16.9709673,57.6035969,3.3035151,6.8942924,2.3561945,21.2489454),(28331,'zebu-ulna.tif',238,4,93,42.4385105,52.8649473,78.4898531,1.8,53.2582225,78.4040214,0.7354585,7.2281895,5.8617259,114.2454532,386.5316929,3.1839019,65.9416186,15.805542,54.3611805,3.0162529,7.039389,2.3357892,21.3186469),(28332,'zebu-ulna.tif',238,4,94,43.3087668,53.0464836,78.7756139,1.8,53.8079631,78.5787805,0.695466,7.3693557,7.4328213,118.1538101,420.0285096,2.9634164,56.50997,16.0331262,51.8740134,2.5361042,6.3262934,2.3107712,17.4652506),(28333,'zebu-ulna.tif',238,4,95,42.5504746,53.0120906,78.9369311,1.8,53.730416,78.6933144,0.6967892,7.0033706,6.8533648,111.6905423,397.3349619,2.9207648,57.9766248,15.9481125,52.9230229,2.199991,5.1786927,2.411693,16.1479276),(28334,'zebu-ulna.tif',238,4,96,42.7354934,53.0571172,79.1678328,1.8,53.8199322,79.0255859,0.6706082,7.2942034,7.9284788,116.6745353,398.9297348,2.7508537,50.3160501,15.9955145,47.9580491,6.3143121,12.2634376,2.677945,32.3247264),(28335,'zebu-ulna.tif',238,4,97,41.5254566,53.032679,79.2970737,1.8,53.947156,79.0750491,0.6569215,7.9632097,8.2020037,124.88061,362.6989976,2.5810315,44.2207796,15.6821954,42.6512448,6.6528836,12.0032977,2.7233683,32.4437143),(28336,'zebu-ulna.tif',238,4,98,40.5303707,53.0156239,79.4507072,1.8,53.955899,79.1842758,0.6392673,7.8712908,8.1003157,122.1169699,340.0535988,2.4044009,41.9802894,15.5142241,41.0246414,6.6215083,11.7356359,2.7321554,31.7502021),(28337,'zebu-ulna.tif',238,4,99,41.0004071,53.2113323,79.684593,1.8,54.1318456,79.3368345,0.6065315,6.8949323,7.3394318,117.008708,363.0368173,2.220336,49.4638861,16.9702476,47.6702806,6.4196708,12.1739531,2.6928693,31.9388915),(28338,'zebu-ulna.tif',238,4,100,40.0234505,53.1616526,79.8187575,1.8,54.3287306,79.4477251,0.5803222,9.0671064,10.8829992,124.7776276,338.2716671,2.0053461,31.0825777,13.7615709,32.6892821,0.2872622,0.5745244,2.3561945,1.1490487),(28339,'zebu-ulna.tif',238,4,101,40.814363,53.2615691,80.0709181,1.8,54.5836159,79.6573827,0.5671297,8.8482263,11.451943,139.3495085,351.3872839,1.9631581,30.683639,15.7488635,33.998601,6.8281301,11.3550348,2.677945,31.4136535),(28340,'zebu-ulna.tif',238,4,102,39.5993125,53.2677474,80.1657573,1.8,54.6208483,79.7615652,0.5432806,9.9173547,13.4115484,133.082058,330.8558058,1.7637155,24.6694711,13.4191084,27.8139629,6.687892,11.0884691,2.6451699,30.6708548),(28341,'zebu-ulna.tif',238,4,103,38.3933516,53.2795317,80.2831365,1.8,54.4230486,79.8856553,0.5680688,9.2938441,11.8280386,118.5010003,303.2387872,1.8521563,25.6372843,12.750483,28.0364729,6.6031448,10.9102919,2.6363025,30.3835927),(28342,'zebu-ulna.tif',238,4,104,37.3503668,53.3151713,80.3972647,1.8,54.4108522,79.9782907,0.5609399,8.9627901,11.2871083,112.3146094,283.4676124,1.7617244,25.1142813,12.5312106,27.4603605,0.203125,0.2872622,2.3561945,0.5745244),(28343,'zebu-ulna.tif',238,4,105,35.9315055,53.4609051,80.4603708,1.8,54.7822277,79.9906175,0.4845871,8.6314104,12.8579725,115.124823,271.4691731,1.2995812,21.1129066,13.3378924,24.9634454,2.1534888,4.2849274,2.1193457,11.5806039),(28344,'zebu-ulna.tif',238,4,106,32.2227513,53.2873445,80.3524509,1.8,54.1871765,79.9593036,0.5132263,7.7229453,9.3253295,85.801346,204.879607,1.2946653,21.9702272,11.1099254,24.0071837,0.203125,0.2872622,2.3561945,0.5745244),(28345,'zebu-ulna.tif',238,4,107,31.2108864,53.3441326,80.4209858,1.8,54.2354222,80.0017101,0.489367,6.7798899,8.5398419,82.1592927,191.4351709,1.1494098,22.4167113,12.1180866,25.2642392,0.5453507,0.8617866,2.3561945,1.7235731),(28346,'zebu-ulna.tif',238,4,108,30.2918935,53.406511,80.4923352,1.8,54.2894677,80.0830132,0.4588218,7.2770679,9.5626926,78.541567,180.8478946,0.9903097,18.9118173,10.7930237,21.5857686,2.562297,4.5827097,1.7942729,15.3354274),(28347,'zebu-ulna.tif',238,4,109,29.1069501,53.5170921,80.5167142,1.8,54.3068591,80.1283687,0.4299596,6.4814227,8.2656071,67.5158725,172.4799779,0.842892,20.867188,10.4168292,23.1409705,0.6093751,1.0156252,2.4980915,2.1298232),(28348,'zebu-ulna.tif',238,4,110,28.2957078,53.5801463,80.5788057,1.8,54.2863816,80.2226061,0.4168551,6.0955519,8.9016321,62.9621366,162.8031204,0.7731019,18.2891316,10.3291937,20.9261969,0.4062501,0.5745244,2.3561945,1.1490487),(28349,'zebu-ulna.tif',238,4,111,27.4979937,53.6490676,80.6485622,1.8,54.3618423,80.2819926,0.4148294,5.867971,8.3469469,58.4601083,152.3542996,0.7444452,18.2526978,9.9625762,20.797958,0.203125,0.4542014,2.0344439,0.9807744),(28350,'zebu-ulna.tif',238,4,112,26.8805723,53.8413012,80.6684379,1.8,54.8632567,80.2998314,0.2968225,5.708027,11.6224516,56.8582882,162.4947626,0.3832559,13.981109,9.9611107,16.940457,0.4062501,0.5745244,2.3561945,1.1490487),(28351,'zebu-ulna.tif',238,4,113,26.3045858,54.0227869,80.6885733,1.8,55.1555685,80.2855086,0.2351965,5.4484244,12.118478,57.4045549,163.7993225,0.2380779,13.5164929,10.5359918,16.7024676,5.8461006,10.3514082,2.863293,27.3631116),(28352,'zebu-ulna.tif',238,4,114,23.5889045,53.8127069,80.6056916,1.8,54.8757107,80.1544313,0.202889,5.3385579,13.0601855,50.3402876,122.2502407,0.159627,9.3605287,9.4295667,12.2654369,5.8018873,9.4229002,3.0118901,25.5001355),(28353,'zebu-ulna.tif',238,4,115,22.9341868,53.8901982,80.6472569,1.8,55.0420609,80.158031,0.1563316,4.55625,11.7976802,48.518198,117.9812667,0.0926584,10.0003784,10.6487129,13.2473612,5.7259248,9.1225533,2.9398303,24.638349),(28354,'zebu-ulna.tif',238,4,116,22.3793553,53.944712,80.6960273,1.8,55.0816871,80.2154386,0.1292729,4.1691933,12.4545587,45.8512273,113.7475551,0.0619856,9.1330057,10.9976258,12.162325,5.7254091,9.0840279,2.9617392,24.5193611),(28355,'zebu-ulna.tif',238,4,117,21.8754233,53.9882465,80.7472104,1.8,55.0129413,80.2924001,0.130145,3.9211094,11.8232804,43.4864601,104.9872848,0.0614054,8.8797086,11.0903462,11.9231774,5.7049252,8.8842536,2.9576492,24.0638246),(28356,'zebu-ulna.tif',238,4,118,17.986889,53.6684907,80.5232078,1.8,54.498579,80.1382996,0.0972668,3.4489984,11.4569807,30.1768477,64.6017456,0.0282725,5.6386362,8.7494526,7.9214093,5.6954304,8.5698547,3.0466409,23.3703124),(28357,'zebu-ulna.tif',238,4,119,17.3926356,53.7245862,80.5555081,1.8,54.6014926,80.179266,0.0877961,3.2686223,9.6449567,28.4331578,61.0380131,0.0222868,6.3284901,8.6988201,8.9080148,5.6808132,8.1882321,3.0172377,22.6768001),(28358,'zebu-ulna.tif',238,4,120,16.822513,53.7561779,80.5860028,1.8,54.5576148,80.1961097,0.0931085,3.5037701,11.5803234,27.1934667,55.1260927,0.0242361,4.7603241,7.7612018,6.8086984,5.6337438,7.9867153,3.0140831,22.1515621),(28359,'zebu-ulna.tif',238,4,121,16.2028786,53.9511901,80.5472544,1.8,55.173244,80.0421346,-0.047496,3.2364215,12.5775721,27.1268001,61.7038936,0.0060873,4.9058668,8.3817265,6.9790536,5.5425942,7.8143762,2.9849908,21.8642999),(28360,'zebu-ulna.tif',238,4,122,12.2319872,53.602664,80.2305434,1.8,54.4454519,79.8596014,-0.0554001,2.8343096,9.8808635,14.8049485,31.0218693,0.0062506,3.1395909,5.2234762,4.5718583,4.7253416,6.5788685,2.9865959,18.5157265),(28361,'zebu-ulna.tif',238,4,123,11.7748539,53.691714,80.2278246,1.8,54.6387942,79.8223101,-0.1050186,2.9027958,11.9261254,13.9464685,31.4632447,0.0215645,2.6381783,4.8044952,3.7819253,4.6347077,6.5505856,3.0172377,18.2284644),(28362,'zebu-ulna.tif',238,4,124,11.4254085,53.7493018,80.2535325,1.8,54.6425636,79.8535306,-0.1119032,2.8588663,11.2528196,13.1907831,28.2961363,0.0237461,2.5145819,4.6139909,3.6657542,4.543558,6.5788685,2.9865959,18.5157265),(28363,'zebu-ulna.tif',238,4,125,9.6374972,53.6218054,80.1058604,1.8,54.2841785,79.781113,-0.1337788,2.66344,8.7390785,9.1557451,18.5426393,0.0285756,2.1218072,3.4375639,3.150973,4.0893569,6.1241441,3.041924,17.2969763),(28364,'zebu-ulna.tif',238,4,126,9.3519295,53.7131766,80.08347,1.8,54.4090727,79.7257649,-0.136888,2.6796716,6.9831776,8.6376159,17.6331178,0.0290246,2.5250851,3.223386,3.7415525,4.0893569,5.9463966,3.0045265,16.8414398),(28365,'zebu-ulna.tif',238,4,127,9.6240815,54.1603769,79.9906399,1.8,55.7381021,79.5760414,-0.1000503,2.3911907,11.5905861,7.6976766,36.236293,0.0160028,3.1263555,3.2191814,3.78064,4.0568512,13.9329563,0.1315881,44.3728257),(28366,'zebu-ulna.tif',238,4,128,9.2984043,54.1971817,79.9662758,1.8,55.7060565,79.5956388,-0.0718456,2.49717,10.0911221,7.1876681,31.2606116,0.0079857,3.0978331,2.8783255,3.7899793,4.0038344,12.068431,0.118092,39.2309777),(28367,'zebu-ulna.tif',238,4,129,9.1858276,54.4579178,79.8510718,1.8,56.3110248,79.4280062,-0.1053473,2.5655002,11.9116463,7.254709,40.8432491,0.0169281,3.4288501,2.8277951,4.0286787,4.0577185,14.1343504,0.1297025,43.1744906),(28368,'zebu-ulna.tif',238,4,130,8.2372402,54.459555,79.6674678,1.8,56.2022023,79.2548143,-0.0788395,2.6124895,10.2660483,5.4061955,32.7589817,0.0085157,3.1910021,2.0693654,3.6895256,4.1256683,12.8996394,0.1263081,39.9941915),(28369,'zebu-ulna.tif',238,4,131,7.0834292,54.3202413,79.4847972,1.8,55.9315428,79.10031,-0.0807436,2.1984236,10.8138825,3.7661797,24.5535788,0.0076801,2.2705609,1.7131274,2.6021651,3.4574964,12.323849,0.1488899,36.239368),(28370,'zebu-ulna.tif',238,4,132,6.5535411,54.2156251,79.35158,1.8,55.7382474,78.9645131,-0.0704755,2.057248,8.8265816,3.1156133,19.3065859,0.005416,2.1873231,1.5144568,2.5316168,3.2888012,10.2553002,0.1390959,34.1588312),(28371,'zebu-ulna.tif',238,4,133,6.6897359,54.23073,79.2960253,1.8,55.6760215,78.9545185,-0.0428339,2.2571713,8.9971499,3.2779126,19.1580883,0.0020444,2.1293508,1.4522215,2.4747509,3.4040453,11.0605267,0.1289108,36.2886544),(28372,'zebu-ulna.tif',238,4,134,6.6955623,54.2798351,79.2322829,1.8,55.6398416,78.9161883,-0.005186,2.2386183,8.0847801,3.3871752,17.3497488,0.00003,2.1459766,1.5130651,2.5460223,3.487324,10.2553002,0.1390959,34.3271055),(28373,'zebu-ulna.tif',238,4,135,6.6519519,54.3405658,79.1614089,1.8,55.6682939,78.8827903,0.0293661,2.1564289,7.9872269,3.3911049,17.0446377,0.0009558,2.1339869,1.5725559,2.5304677,3.2147523,5.3780207,2.9516044,13.7801286),(28374,'zebu-ulna.tif',238,4,136,5.7282204,54.1590237,78.9651278,1.8,55.2991242,78.7300521,0.055573,1.8129023,7.322851,2.49993,11.460906,0.0029454,1.565088,1.3789656,1.873778,2.8083411,5.2223285,2.9060477,13.3245921),(28375,'zebu-ulna.tif',238,4,137,5.8648653,54.315012,78.8428455,1.8,55.5182887,78.6061047,0.05055,2.1369826,7.9812484,2.7660963,13.3952985,0.0024956,1.6783463,1.2943935,1.9852411,2.796967,5.2223285,2.9060477,13.3245921),(28376,'zebu-ulna.tif',238,4,138,5.7943611,54.3374877,78.7235207,1.8,55.5316276,78.505971,0.0513345,2.4506723,6.9599197,2.7699448,13.328481,0.0025427,1.9150337,1.1302796,2.2684141,3.3788221,9.6521804,0.1478494,31.2657943),(28377,'zebu-ulna.tif',238,4,139,6.3284627,55.0535816,78.5808583,1.8,57.8806824,78.3491243,-0.0135436,1.8050215,17.4628201,2.8481718,52.5375333,0.0001935,3.0085366,1.5779157,3.1716158,3.2321968,17.5441719,0.0927563,49.1492539),(28378,'zebu-ulna.tif',238,4,140,6.6602164,55.1592721,78.5075182,1.8,58.2125109,78.2503619,-0.013135,1.7542608,17.3561992,3.2652119,60.177309,0.0001915,3.467194,1.8613036,3.655226,3.2500006,14.6475548,0.0554985,45.591576),(28379,'zebu-ulna.tif',238,4,141,6.8745047,55.1247628,78.4316554,1.8,58.1644888,78.2027912,0.0018314,2.2607357,17.5935528,3.627244,63.4068044,0.0000038,3.6039795,1.6044529,3.8097301,3.7195951,16.4844447,0.0616502,49.9906253),(28380,'zebu-ulna.tif',238,4,142,5.6380991,54.5367757,78.1347618,1.8,56.8509191,77.9934013,0.0422936,1.5961775,9.8393524,2.1372803,27.2000894,0.0016799,2.7644187,1.3389991,2.9769677,2.726238,5.3433855,2.9889433,13.2753057),(28381,'zebu-ulna.tif',238,4,143,5.9682398,54.5091363,78.0470685,1.8,56.745047,77.9154928,0.0651109,1.9987084,11.2234979,2.4825671,27.6201433,0.004211,2.4609212,1.2420857,2.6554941,2.7267536,5.3780207,2.9516044,13.6815558),(28382,'zebu-ulna.tif',238,4,144,6.1390178,54.4627463,77.9540766,1.8,56.6285891,77.8650585,0.0827162,1.7907914,10.0833905,2.6271813,27.7294093,0.0069845,2.7500085,1.4670504,2.9960409,2.7272693,5.3433855,2.9889433,13.8498301),(28383,'zebu-ulna.tif',238,4,145,6.4511793,54.6503196,77.8217604,1.8,56.9623006,77.7522104,0.0814438,1.7773883,10.296838,2.9576284,34.3269135,0.0071161,3.3337335,1.6640305,3.5993568,2.7272693,5.469309,2.5948038,14.0878059),(28384,'zebu-ulna.tif',238,4,146,6.0190269,54.5141057,77.587349,1.8,56.8130041,77.4718895,0.0659594,2.095713,10.0581607,2.6185094,29.8861261,0.0043581,2.9713311,1.24946,3.2241622,3.4531256,13.0142768,0.0468407,39.538655),(28385,'zebu-ulna.tif',238,4,147,6.3897398,54.5720337,77.4809507,1.8,56.9084065,77.3796385,0.0735421,2.0526146,11.7514888,3.0790544,34.8595489,0.0057494,2.9663943,1.5000646,3.1923577,3.3633473,13.2171825,0.0461211,41.0939538),(28386,'zebu-ulna.tif',238,4,148,6.255608,54.4128817,77.3016726,1.8,56.6785729,77.2426842,0.0904812,2.1021499,10.9013877,2.9593573,31.4714563,0.0085124,2.886922,1.4077765,3.1284553,2.9019134,5.3665005,2.6271413,13.8005437),(28387,'zebu-ulna.tif',238,4,149,6.2996309,54.2905779,77.145566,1.8,56.533624,77.1597768,0.1131204,2.1491429,11.1824168,2.976883,30.566731,0.013378,2.7334638,1.3851489,2.956685,2.9981398,5.4504167,2.677945,14.2560802),(28388,'zebu-ulna.tif',238,4,150,6.5492901,54.2225735,76.9863795,1.8,56.5080618,76.9558444,0.1111368,2.0388414,10.890072,3.3490845,32.389862,0.0134267,2.974256,1.642641,3.2541783,3.6562507,13.836379,0.0587558,46.8103262),(28389,'zebu-ulna.tif',238,4,151,6.3733234,53.941426,76.7631015,1.8,55.90473,76.7581294,0.1331255,2.2085271,11.7145377,3.2621751,25.9865169,0.0187142,2.2183135,1.4770817,2.4625442,3.3890703,10.7732894,3.1038747,34.9713314),(28390,'zebu-ulna.tif',238,4,152,6.5523908,53.8855269,76.5821343,1.8,55.9273981,76.6169385,0.1678162,1.9018758,10.8252647,3.4673522,26.7341474,0.0304674,2.4696068,1.8231223,2.766016,3.4671982,13.5592619,2.9912212,42.3331192),(28391,'zebu-ulna.tif',238,4,153,6.8372083,54.0310878,76.3457933,1.8,56.433055,76.4111166,0.1572594,2.209782,11.2711953,4.2292233,38.0006705,0.0279497,3.3714854,1.9138644,3.711687,3.8593757,14.1926126,2.9835027,46.4737776),(28392,'zebu-ulna.tif',238,4,154,7.0532971,53.8328088,76.1200586,1.8,55.8834449,76.1584791,0.2127086,2.2880352,10.0194935,4.8315814,32.4597888,0.0523904,3.2396636,2.1116727,3.6697212,3.7884127,13.1906216,2.9713807,43.8187165),(28393,'zebu-ulna.tif',238,4,155,7.4059182,53.7627543,75.9271529,1.8,55.7785885,76.0027443,0.2544458,2.839377,11.0825102,5.5025855,35.9321567,0.0782034,3.2422399,1.9379552,3.6217728,4.1081744,13.6638395,2.9471125,48.5134842),(28394,'zebu-ulna.tif',238,4,156,7.8273931,53.6565672,75.7161891,1.8,55.6932595,75.8529571,0.292453,2.8528025,10.468237,6.4741781,40.7705167,0.1084329,3.894688,2.2694099,4.3931107,4.5750911,14.1022035,2.9385474,49.5146738),(28395,'zebu-ulna.tif',238,4,157,7.8428092,53.5003889,75.5227532,1.8,55.2842537,75.6691354,0.3519615,4.0477009,10.5476859,6.5890767,37.1658274,0.155347,3.5236001,1.6278566,3.8729107,4.2079378,13.3074032,2.926235,47.0278869),(28396,'zebu-ulna.tif',238,4,158,7.8804181,53.3877764,75.3401329,1.8,55.0472891,75.5657448,0.3995795,3.414335,9.336943,6.6650989,36.2982463,0.1987771,3.8875943,1.9520928,4.3753529,3.4206651,7.3854878,2.5917395,17.7729279),(28397,'zebu-ulna.tif',238,4,159,7.9857181,53.3363389,75.1577849,1.8,55.2379641,75.4125589,0.3739317,3.7281383,11.721194,7.3751527,42.3536597,0.1775867,3.6134254,1.9782401,4.0430543,4.295639,13.4262423,2.8341952,37.835497),(28398,'zebu-ulna.tif',238,4,160,8.1480566,52.9861768,74.9530237,1.8,53.8456777,75.0874786,0.6449806,4.9841408,6.9646483,5.7645117,26.5584052,0.490813,3.8133161,1.1565708,3.774665,3.5459479,7.6651111,2.5829933,18.8029887),(28399,'zebu-ulna.tif',238,4,161,8.4059677,52.9843724,74.7256016,1.8,54.198632,74.9016702,0.5798508,5.1101698,8.5883448,8.2579161,30.1956007,0.4205694,3.5158813,1.6159769,3.8477861,3.7678417,7.5566882,2.5088438,19.0409645),(28400,'zebu-ulna.tif',238,4,162,8.6447243,52.7942043,74.5040253,1.8,53.6743751,74.680822,0.7420897,5.5842987,6.7547581,7.3783335,28.1306812,0.6580733,4.1645727,1.3212641,4.0515993,3.8398482,7.6785563,2.4875099,19.6154889),(28401,'zebu-ulna.tif',238,4,163,8.8086382,52.7300685,74.2776357,1.8,53.7766919,74.5075501,0.6983913,5.0710595,6.7451982,8.758646,31.9018283,0.6069615,4.7295613,1.7271827,4.8268433,0.4062501,0.9084028,2.0344439,1.9615489),(28402,'zebu-ulna.tif',238,4,164,8.845922,52.5557655,74.0200744,1.8,53.4127603,74.2088762,0.7800051,5.8059306,6.6179738,8.2027641,31.6565175,0.7292092,4.7834154,1.412825,4.527523,0.2872622,0.5745244,2.3561945,1.1490487),(28403,'zebu-ulna.tif',238,4,165,9.0928556,52.3946704,73.7473937,1.8,53.1243552,74.0218591,0.8309958,6.8079034,7.021166,8.0031116,32.9146643,0.8267443,4.68792,1.1755619,4.1839109,4.0216706,7.9322863,2.4468544,20.5962633),(28404,'zebu-ulna.tif',238,4,166,9.0898048,52.1378076,73.4059045,1.8,52.466274,73.5203521,0.9353608,5.0112558,4.8149862,6.2520279,31.712461,0.9812815,6.5861998,1.247597,5.5762761,4.0047097,7.911453,2.301703,19.9724525),(28405,'zebu-ulna.tif',238,4,167,9.5433249,51.9678146,73.1170158,1.8,52.2364473,73.2663887,0.9450907,5.9666324,5.3235111,6.867723,34.3846092,1.0449803,6.4590096,1.1510216,5.1589413,4.0589575,8.0638338,2.284887,19.9231662),(28406,'zebu-ulna.tif',238,4,168,9.784382,51.7467885,72.785103,1.8,51.9908492,72.9784451,0.9833829,6.5042386,5.7151081,7.6442393,37.6400551,1.1298538,6.5860618,1.1752704,5.2301104,4.1945604,8.2484774,2.2339993,20.5469769),(28407,'zebu-ulna.tif',238,4,169,10.0115358,51.6877385,72.3905249,1.8,52.4494327,72.6540043,0.8760482,7.3117845,7.578197,11.5944851,43.7862524,0.9847251,5.7779248,1.5857258,5.2590836,4.5870198,8.6608477,2.2565258,21.7657271),(28408,'zebu-ulna.tif',238,4,170,10.6487369,51.3922387,71.895039,1.8,51.8792595,72.0260212,0.9807069,6.8533805,5.9942242,12.096706,47.932202,1.2252786,7.9963979,1.7650714,6.654979,5.0496647,9.2639271,2.2318395,23.8462639),(28409,'zebu-ulna.tif',238,4,171,12.1670843,51.1284245,71.2797473,1.8,51.7818384,71.4771546,0.981953,8.7091711,7.5471489,18.3655918,66.4492571,1.4023201,8.8045509,2.1087646,7.3596633,0.203125,0.4542014,2.0344439,0.9807744),(28410,'zebu-ulna.tif',238,4,172,12.7726654,50.8570401,70.7262503,1.8,51.0928823,70.6875133,1.0883234,6.3858738,5.5939199,16.8962234,73.3575,1.670517,13.1137916,2.6458749,10.6312389,5.7880329,10.2794114,2.2301064,27.937636),(28411,'zebu-ulna.tif',238,4,173,13.5247312,50.6316642,70.055193,1.8,51.0370031,70.1642679,1.1044277,6.010596,6.4626224,18.8460577,86.6202939,1.7983806,13.4032733,3.1354723,11.949931,5.8906844,10.2008415,2.1864162,28.3931725),(28412,'zebu-ulna.tif',238,4,174,13.8622737,50.4161641,69.6026272,1.8,50.5830364,69.5983586,1.1491962,4.7652449,5.0858449,19.5316075,83.8780503,1.9234787,16.4924514,4.0987625,15.5120862,5.990057,9.8048605,2.2681871,28.2248982),(28413,'zebu-ulna.tif',238,4,175,13.8864919,50.3046318,69.3124396,1.8,50.4901136,69.2367081,1.123544,4.6995641,4.9269013,21.721943,79.9562379,1.8815099,16.2285041,4.6221187,15.7015283,6.5986519,9.4970459,2.2956625,29.2260877),(28414,'zebu-ulna.tif',238,4,176,11.5539515,50.038789,68.6104335,1.8,50.2399668,68.4856827,1.1074727,7.0947834,4.7310687,16.7420577,58.942703,1.5410259,12.4586444,2.3597701,8.875332,6.4481735,9.0772123,2.4353936,28.1263254),(28415,'zebu-ulna.tif',238,4,177,11.541336,50.0752583,68.3031413,1.8,50.747734,68.2726918,1.0151457,21.4846568,12.5601507,22.2298947,60.6427791,1.3883224,4.8281888,1.034687,3.3299984,0.6383375,2.0312504,0.9272952,4.4976221),(28416,'zebu-ulna.tif',238,4,178,13.0902032,50.1718109,68.2621786,1.8,50.8087816,68.2072339,1.0352293,6.2295969,5.015161,21.8526624,72.6595638,1.6135085,14.4879823,3.5078774,12.1790876,7.1096425,9.0772123,2.4353936,29.394362),(28417,'zebu-ulna.tif',238,4,179,14.7085243,50.1089201,68.0897965,1.8,50.7537038,68.1232565,1.0594379,8.5009553,5.3865933,27.1898323,80.4676022,1.8643656,14.9384961,3.1984443,11.1991621,7.1092307,9.2103263,2.2937757,28.7008497),(28418,'zebu-ulna.tif',238,4,180,15.2955635,49.9795845,67.8343206,1.8,50.3414812,67.7750299,1.1570919,6.0876213,4.4957492,25.6695755,77.5653639,2.1372816,17.2530452,4.216684,14.3937984,6.4517488,8.9097598,2.3239476,26.5217402),(28419,'zebu-ulna.tif',238,4,181,18.003593,50.1611383,67.8627278,1.8,50.6827462,67.8144433,1.0621972,6.030321,5.3236711,38.3636926,93.126338,2.2890838,17.4928797,6.3617994,17.3134269,7.6110332,9.104444,2.2455373,28.7705512),(28420,'zebu-ulna.tif',238,4,182,20.7542075,50.5562897,68.0679442,1.8,50.931334,67.9399798,0.9047727,4.8640652,5.0511029,51.0605577,115.2071208,2.1385264,22.8083101,10.4975069,25.2025926,7.4730556,9.9365314,2.4285318,29.2465028),(28421,'zebu-ulna.tif',238,4,183,26.8155569,51.0962231,68.4774493,1.8,51.475741,68.2506777,0.6466566,4.5634887,6.0199271,77.7085736,173.7829374,1.6224844,28.8679473,17.0283261,36.6266719,0.4062501,0.5745244,0.7853982,1.1490487),(28422,'zebu-ulna.tif',238,4,184,55.3240652,51.2732382,70.8466256,1.8,51.7259469,70.7122265,1.218142,11.3510523,7.6026736,318.6716811,503.7450096,8.1207035,66.2589289,28.0741971,71.5157427,12.7844825,13.7601285,1.4226363,65.2155211),(28423,'zebu-ulna.tif',238,4,185,34.6231078,50.6320549,69.5198495,1.8,51.0618408,70.1258991,1.3972002,5.6032539,6.6726485,110.8576551,226.6758533,5.5983597,33.9708968,19.7845139,48.4106365,8.2363875,12.5757203,2.1139859,38.3403199),(28424,'zebu-ulna.tif',238,4,186,22.1598157,50.1076985,68.4881206,1.8,50.1743615,68.6352072,1.541891,3.4863128,4.5058678,40.2703341,92.6031653,3.6902177,20.5516826,11.5509814,27.5489813,5.8906261,8.9950226,1.4576453,24.6587641),(28425,'zebu-ulna.tif',238,4,187,12.6083515,49.9002731,67.8660307,1.8,49.8871651,68.0651346,1.4826009,2.2600896,3.6760805,11.8664134,33.0295248,2.0850887,8.984984,5.2504173,12.1967291,4.587543,7.5594178,1.4631065,19.7344768),(28426,'zebu-ulna.tif',238,4,188,4.3795632,49.859921,67.4384138,1.8,49.8255489,67.5427285,1.403152,1.3961589,2.6547712,1.4090072,5.7889117,0.7096043,2.180569,1.0092026,2.7079245,2.8437505,5.420052,1.7975952,13.6322694),(28427,'zebu-ulna.tif',238,4,189,0.0212925,49.8688071,67.3296882,1.8,49.8671969,67.3359501,1.4877122,0.1286221,0.3181718,0.0002989,0.0011484,0.0035243,0.0036095,0.0023237,0.0044177,0.4062501,0.9084028,2.0344439,1.9615489),(28428,'zebu-ulna.tif',238,4,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28429,'zebu-ulna.tif',238,4,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28430,'zebu-ulna.tif',238,4,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28431,'zebu-ulna.tif',238,4,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28432,'zebu-ulna.tif',238,4,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28433,'zebu-ulna.tif',238,4,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28434,'zebu-ulna.tif',238,4,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28435,'zebu-ulna.tif',238,4,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28436,'zebu-ulna.tif',238,4,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28437,'zebu-ulna.tif',238,4,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28438,'zebu-ulna.tif',238,4,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28439,'zebu-ulna.tif',238,4,201,185.2467023,55.6995378,78.88233,1.8,58.3492121,78.7908941,-0.1500354,12.5581328,16.5768972,5862.262255,9122.0875353,0.6898039,550.2892028,466.8100209,836.8870034,28.6406304,29.264108,1.8090411,95.0977935),(28440,'zebu-ulna.tif',238,4,202,364.6750753,58.4130173,78.8161981,1.8,58.5652664,78.6270447,-0.0019355,14.0226546,16.5448156,11770.7070687,20431.5911717,0.0002275,1234.9240767,839.4064728,1856.7735829,0.203125,0.2872622,2.3561945,0.5745244),(28441,'zebu-ulna.tif',238,4,203,369.7226969,58.4863478,78.8239726,1.8,58.7433954,78.6303649,0.0024226,13.8273975,16.4814779,11883.4866493,21056.8964243,0.0003619,1277.6097246,859.4159983,1876.4971381,0.203125,0.4542014,2.0344439,0.9807744),(28442,'zebu-ulna.tif',238,4,204,372.1994591,58.5159272,78.8209557,1.8,58.8642626,78.6397127,0.0044588,13.8107725,16.4696158,11943.4417634,21570.6733416,0.0012331,1309.7253476,864.7917224,1863.2436542,29.0468804,29.261993,0.4915906,95.9595801),(28443,'zebu-ulna.tif',238,4,205,374.2145993,58.5396899,78.8159122,1.8,58.9755441,78.6432042,0.0063286,13.8205142,16.4645186,11990.8220324,21969.5907077,0.0024986,1334.3597381,867.6104108,1854.4545153,29.0468804,29.262698,0.5475622,95.9595801),(28444,'zebu-ulna.tif',238,4,206,375.4154715,58.5526579,78.8181879,1.8,59.0521024,78.6593777,0.0073724,13.6142925,16.4628886,12010.6398265,22234.7371075,0.0034009,1350.5975539,882.2081499,1852.6956244,29.1452724,56.3682045,0.1995157,176.0838634),(28445,'zebu-ulna.tif',238,4,207,376.6917365,58.5430849,78.8234734,1.8,59.0983743,78.6920961,0.0077028,13.2290085,16.4767617,12022.7013734,22430.6863424,0.003725,1361.3528396,908.8134896,1853.8661359,29.1452724,56.6077813,0.2023216,174.7954117),(28446,'zebu-ulna.tif',238,4,208,377.4999281,58.5080889,78.8179929,1.8,59.0631031,78.6793091,0.0084635,13.2235362,16.5200562,12049.8454949,22549.7522443,0.0045066,1364.9924692,911.2422938,1848.8434152,29.1452724,56.6489475,0.2058342,174.7461253),(28447,'zebu-femur.tif',238,7,1,0.0036888,54.878962,92.531344,1.8,54.878962,92.531344,0.7853982,0,0,0.0000186,0.0000186,0.0003074,0,0,0,0.246094,0.3480295,2.3561945,0.6960589),(28448,'zebu-femur.tif',238,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28449,'zebu-femur.tif',238,7,3,0.0036704,27.808622,80.718832,1.8,27.808622,80.718832,0.7853982,0.000000000000002512,0.000000000000002512,0.0000185,0.0000185,0.0003059,7373839846.34069,7373839844.71338,10428184316.3115,0.246094,0.3480295,2.3561945,0.6960589),(28450,'zebu-femur.tif',238,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28451,'zebu-femur.tif',238,7,5,8.4136207,95.3688931,87.0254797,1.8,95.2319261,87.3117548,-1.2110392,2.3657435,5.3451164,8.902144,29.2717761,1.2284769,5.4763589,3.762937,7.141715,4.9807659,9.7354985,1.2090671,24.2571269),(28452,'zebu-femur.tif',238,7,6,42.56398,94.8357112,87.9640723,1.8,94.3042113,88.7654739,-1.0983586,35.1088302,27.2164961,121.7411154,491.5077972,5.6249857,18.0591871,3.4675355,13.8048848,7.374536,18.8659583,1.0370881,46.4610557),(28453,'zebu-femur.tif',238,7,7,90.8270151,93.1255784,90.3564394,1.8,92.6497332,90.8820349,-0.9972845,30.5593904,24.0863415,380.1459793,2985.2647868,10.6812753,123.9401504,12.4395799,86.491036,9.1153344,24.452631,1.0666304,58.8357131),(28454,'zebu-femur.tif',238,7,8,152.2425758,83.5847771,87.851531,1.8,79.1024164,86.1989966,0.344529,14.4095346,40.9375039,5168.2725514,52236.0104945,2.8945724,1275.9940271,358.6703316,1402.2407349,0.7718203,5.957305,0.9025069,12.4096362),(28455,'zebu-femur.tif',238,7,9,243.4588594,73.9855461,84.2378718,1.8,73.7978086,84.134553,0.3521122,15.0102519,33.1826846,8539.5034055,122932.5048944,4.8262903,3704.7184832,568.9113971,3962.0615482,0.5220442,1.23047,2.4980915,2.4362063),(28456,'zebu-femur.tif',238,7,10,306.5474616,71.360841,83.0328333,1.8,71.7966548,83.1508531,0.3444452,21.3649215,31.6467246,12394.7633302,156273.8712719,5.8256328,4938.0740981,580.1455125,5095.3943563,18.949238,21.7525381,2.7589854,65.7510788),(28457,'zebu-femur.tif',238,7,11,366.8431894,69.8893226,82.0891101,1.8,70.8741909,82.4857228,0.3292375,17.0572995,33.395208,16562.962065,182241.9926537,6.3914386,5457.1300332,971.019011,5581.3062596,21.8790606,25.7753362,2.3967128,92.6977504),(28458,'zebu-femur.tif',238,7,12,427.9056171,68.5935151,81.3667154,1.8,69.9292159,81.9624109,0.3174522,17.7536326,35.3849999,20869.5312569,204999.8126134,6.9488877,5793.4100036,1175.5076689,5996.0070456,24.1539314,29.1483773,2.4338821,122.5088602),(28459,'zebu-femur.tif',238,7,13,482.7239843,67.3990371,80.8381766,1.8,69.1632679,81.5524112,0.3111265,23.6402141,37.0087689,24653.1446421,223285.3062169,7.5398529,6033.3081321,1042.8477738,6308.8618639,25.5103048,32.2983726,2.8318897,128.2956913),(28460,'zebu-femur.tif',238,7,14,530.2429112,66.7553065,80.5538184,1.8,68.8606496,81.3773086,0.3092983,33.0514936,38.0759051,28256.1259538,238106.8982877,8.188141,6253.4796725,854.912225,5521.8540889,27.5596527,34.6503498,2.8535372,147.3426212),(28461,'zebu-femur.tif',238,7,15,564.1841104,66.6543426,80.4136928,1.8,68.8011028,81.1276693,0.3085787,24.4183273,38.326166,31078.3657428,249199.8229297,8.6730705,6502.080661,1272.7475283,6944.1535735,0.246094,0.3480295,2.3561945,0.6960589),(28462,'zebu-femur.tif',238,7,16,590.2960046,67.0171278,80.3741178,1.8,68.9260209,80.979863,0.3055729,20.3867628,42.130401,33479.1362607,259213.7074069,8.9040696,6152.6522754,1642.1997282,6632.4190099,28.30081,40.5995436,2.9216088,130.5877391),(28463,'zebu-femur.tif',238,7,17,616.9384976,67.8237801,80.2954568,1.8,69.3364865,80.8287156,0.2969245,24.8200836,37.5957997,35220.687779,264266.5068234,8.8020105,7029.1497782,1419.0398508,7626.6133854,0.3480295,0.6960589,2.3561945,1.3921179),(28464,'zebu-femur.tif',238,7,18,615.4978867,68.3302836,80.2346443,1.8,69.4377923,80.7124499,0.2916077,20.5476105,37.2489776,36113.6614515,260968.6429704,8.4786753,7006.0619144,1757.5601542,7670.6801449,0.440476,0.8873045,2.1587989,1.8843059),(28465,'zebu-femur.tif',238,7,19,599.4089359,69.020589,80.2657803,1.8,69.6793986,80.6015601,0.2891789,19.9626321,36.6700828,36125.9438167,258029.2617837,8.1239152,7036.506109,1809.6783807,7714.67168,0.4792492,1.23047,2.2142974,2.5803648),(28466,'zebu-femur.tif',238,7,20,582.9910219,69.4931234,80.3933726,1.8,69.7526789,80.545341,0.2930975,25.4437413,36.2899069,35304.6564322,250690.6858459,8.1107821,6908.0002511,1387.5575922,7596.2436329,0.4411007,1.4349623,2.1112158,3.0725528),(28467,'zebu-femur.tif',238,7,21,566.8061625,69.97739,80.3664328,1.8,70.0141389,80.4498036,0.303573,26.3447537,36.2079855,33884.6564949,244535.5168883,8.4416484,6753.6349638,1286.2013022,7507.8456314,32.6481038,70.059033,3.0041665,239.39378),(28468,'zebu-femur.tif',238,7,22,549.0956848,70.7906597,80.6657176,1.8,70.4843913,80.5234916,0.3173616,26.7084752,34.839779,31796.8674935,235880.3864693,8.9120143,6770.4329128,1190.5160165,7471.7709309,32.1667132,69.5715181,3.0031973,209.1357059),(28469,'zebu-femur.tif',238,7,23,522.0560319,71.8905539,81.3980951,1.8,70.8954445,80.9314984,0.3279133,26.4260923,35.401881,28666.1655356,219832.2127555,9.0253003,6209.6195588,1084.7674777,6994.1567515,31.5641992,68.4981772,2.986485,236.5498318),(28470,'zebu-femur.tif',238,7,24,504.1691712,72.5674274,82.1751681,1.8,71.4145431,81.4791211,0.3332217,19.463669,34.9911608,26004.326336,207093.2577857,8.9899522,5918.4449103,1336.0444165,6661.1651172,30.4564118,67.585854,2.9213439,266.1220919),(28471,'zebu-femur.tif',238,7,25,456.998202,75.7201041,83.8014466,1.8,73.7154334,82.80439,0.3340237,24.9083844,37.6421981,23989.1295519,153276.037253,8.1866392,4071.920476,963.0945603,3927.2561541,29.704922,65.5982472,2.8875151,256.8097422),(28472,'zebu-femur.tif',238,7,26,429.9874722,76.8958896,84.7669953,1.8,75.7230322,84.0704318,0.3693622,26.1022087,41.6484483,23112.6880675,123461.9411586,9.3404726,2964.3827383,885.4686706,3018.1864728,29.3877126,59.579149,2.9166514,187.329274),(28473,'zebu-femur.tif',238,7,27,412.1450422,76.8077482,85.4253728,1.8,75.8216122,84.763207,0.4132053,30.28891,34.0468686,22223.9900919,106902.7598219,11.0757037,3139.8705479,733.7335715,3001.6347985,29.7604262,56.7624227,2.9008201,184.6047506),(28474,'zebu-femur.tif',238,7,28,393.6657542,75.9877457,85.7814571,1.8,75.3059812,85.1679997,0.4621663,28.4192096,30.4309031,20985.8674102,92066.3717608,13.0445252,3025.4235745,738.4395167,2720.3817804,2.5361865,14.3073557,0.0688565,40.7381806),(28475,'zebu-femur.tif',238,7,29,380.6610556,75.232826,85.8779358,1.8,74.6013074,85.4140158,0.4916421,29.5002266,40.2857207,20333.5795619,80860.7895419,14.1386398,2007.1824015,689.2685891,2029.0610894,1.3921179,2.9633642,2.2974387,7.2489065),(28476,'zebu-femur.tif',238,7,30,371.7947779,74.5449595,85.8966012,1.8,74.0744029,85.6622046,0.5077043,33.3644313,39.9341628,19869.7428307,72295.7666249,14.6464594,1810.3739122,595.5366848,1879.7108334,1.1842455,2.3346527,1.8925469,5.6529177),(28477,'zebu-femur.tif',238,7,31,357.6459482,74.0072841,85.874533,1.8,73.6648944,85.6507281,0.5259592,29.5685495,38.8437016,18973.5732346,63874.0759751,15.0239302,1644.3869507,641.6808931,1718.8131853,0.492188,0.8873045,2.5535901,1.8843059),(28478,'zebu-femur.tif',238,7,32,345.9615985,73.7164689,86.0196976,1.8,73.4097625,85.9711887,0.5534184,27.068582,24.5698282,18042.5912733,58071.9095783,15.928861,2363.5456083,666.5510325,2106.5998344,4.183598,13.126295,0.1127276,44.8898005),(28479,'zebu-femur.tif',238,7,33,336.6568868,73.4674717,86.0927195,1.8,73.114892,86.1825127,0.5794215,19.8238951,23.3782254,17065.3935217,52676.0169359,16.8216206,2253.2085366,860.8496665,2440.3899335,4.429692,12.3587221,2.9207639,37.4967355),(28480,'zebu-femur.tif',238,7,34,323.6394335,73.0993608,86.0975989,1.8,72.7830118,86.3853141,0.5976378,24.5941131,22.6721308,16215.8898726,47116.6914564,17.0785313,2078.1765894,659.3402979,2002.3796854,0.6960589,1.7401474,2.3561945,3.6244533),(28481,'zebu-femur.tif',238,7,35,314.3612774,72.699815,86.1150207,1.8,72.2817291,86.6152468,0.6165417,32.6033878,22.5650546,15896.8415252,41957.6950068,17.5169949,1859.4103021,487.5825064,1459.1122069,27.2161079,40.8404838,2.699505,266.3856753),(28482,'zebu-femur.tif',238,7,36,309.8435716,72.5569096,86.3236456,1.8,72.2765629,86.8957469,0.6560766,32.3769332,24.9809413,15510.0135546,37975.9438753,19.2162671,1520.1966765,479.0451722,1380.7872225,6.3754814,16.0320372,2.8295505,56.6033778),(28483,'zebu-femur.tif',238,7,37,318.155723,72.4884375,86.5741935,1.8,72.2404903,87.0509273,0.6973234,30.058068,28.2823248,15072.8241264,35272.5715874,21.866844,1247.1595521,501.4568514,1432.3493244,26.5297876,38.0897549,2.7010623,189.1248901),(28484,'zebu-femur.tif',238,7,38,315.7418399,72.4717437,86.6539119,1.8,71.9813396,87.15523,0.7047949,27.4821942,25.2299041,14830.6033749,32859.3562906,22.088532,1302.3971958,539.6440789,1440.927231,0.246094,0.3480295,2.3561945,0.6960589),(28485,'zebu-femur.tif',238,7,39,306.8780948,72.308136,86.6296698,1.8,71.8541565,87.1414979,0.7167247,25.4906181,23.1707432,14479.216909,30704.9990517,22.0718096,1325.1624621,568.0214134,1477.3603101,25.6598684,35.4409538,2.6655233,178.2370417),(28486,'zebu-femur.tif',238,7,40,297.540606,72.0092421,86.5221409,1.8,71.6500408,86.9573071,0.730706,34.587027,30.2063052,13995.1520022,28789.7456468,22.0882637,953.1038467,404.635877,931.7187111,0.3480295,1.0440884,2.3561945,2.0881768),(28487,'zebu-femur.tif',238,7,41,291.6819601,71.7116473,86.3758265,1.8,71.1406461,86.7343828,0.7412499,25.0968232,21.9273873,13756.8257904,26927.8697373,22.1634073,1228.0473432,548.1500854,1442.4398709,0.246094,0.3480295,2.3561945,0.6960589),(28488,'zebu-femur.tif',238,7,42,288.6105544,71.453295,86.2297656,1.8,70.9501223,86.5410024,0.7470108,21.7239508,18.0459329,13759.6194956,25372.6124394,22.2061919,1406.0017068,633.3847661,1496.7585452,24.4911057,32.9380065,2.239703,100.7024282),(28489,'zebu-femur.tif',238,7,43,287.353282,71.1952362,86.107874,1.8,70.7957218,86.3372948,0.7601698,20.1140078,19.5115936,13882.3148351,23827.8585826,22.7383793,1221.2153969,690.1814388,1351.5727476,24.7861711,32.2983726,2.1883886,99.2258642),(28490,'zebu-femur.tif',238,7,44,289.8966031,70.9241051,85.9905994,1.8,70.4292518,86.207168,0.7675185,21.7108292,20.6569541,14411.2758588,22744.6084758,23.2943604,1101.0630291,663.7828402,1288.2390986,26.3426168,31.7804461,2.1072318,106.9669587),(28491,'zebu-femur.tif',238,7,45,297.0858752,70.6278782,85.8950353,1.8,70.2696031,86.0987587,0.7576586,20.5094523,16.8633126,15245.6624082,21769.6683569,23.3843552,1290.9485154,743.348101,1802.9717039,26.9521377,31.3187853,2.0977396,110.4472535),(28492,'zebu-femur.tif',238,7,46,302.1021736,70.3362283,85.7778616,1.8,69.9733318,86.0245234,0.6903685,21.4194602,18.3247503,16376.9863343,20912.2053446,20.4191587,1141.200014,764.5844567,1337.120824,27.1489673,31.0205367,2.1125764,109.114848),(28493,'zebu-femur.tif',238,7,47,305.5009825,69.9558144,85.6823734,1.8,69.6595168,85.9026255,0.5612134,18.9654156,26.0254371,17523.1267412,20211.2154504,14.4222725,776.594658,923.9516339,1300.5969544,0.492188,0.6960589,0.7853982,1.3921179),(28494,'zebu-femur.tif',238,7,48,316.7113498,69.6576499,85.6150817,1.8,69.399266,85.8175608,0.1410367,17.4572816,30.9544242,18440.3842946,19975.9923848,1.0430255,645.3356148,1056.3147627,1216.6272735,0.492188,0.8873045,2.1587989,1.8843059),(28495,'zebu-femur.tif',238,7,49,318.9101635,69.4911865,85.3766045,1.8,69.1769799,85.5024776,-0.3386326,16.2722852,29.5694913,18180.9990838,20023.5460401,5.8655718,677.1691073,1117.2984551,1266.5563201,0.492188,1.1005658,0.4636476,2.2323354),(28496,'zebu-femur.tif',238,7,50,313.2021341,69.4851328,85.1272889,1.8,69.1968279,85.1659751,-0.5907812,15.3166509,25.3147776,17558.9712446,19530.7408256,16.1956879,771.5154011,1146.3975631,1391.247444,26.9287841,30.1050523,2.1406603,125.9686648),(28497,'zebu-femur.tif',238,7,51,304.8782189,69.623877,84.8633575,1.8,69.3486311,84.9929918,-0.8326235,14.7249232,23.063105,16833.8378009,19069.4463412,27.8026138,826.8377721,1143.2207532,1341.1941532,2.4682101,4.0958204,0.9994588,12.6629745),(28498,'zebu-femur.tif',238,7,52,295.146213,69.7879528,84.5138323,1.8,69.5499803,84.664505,-0.9893896,18.9562645,22.7149091,16061.747894,18540.8988324,34.3539982,816.2435857,847.3055386,1269.0936641,1.476564,4.0586862,1.3258177,12.9265579),(28499,'zebu-femur.tif',238,7,53,289.5196306,69.9560096,84.176919,1.8,69.7080343,84.3871335,-1.073949,19.7109405,22.6421355,15405.0092282,18218.2101225,37.2900612,804.6153643,781.5461277,1243.4344565,0.3480295,0.6960589,0.7853982,1.3921179),(28500,'zebu-femur.tif',238,7,54,282.6837852,70.1538379,83.7605393,1.8,69.8938138,83.9476122,-1.1447901,19.7199482,22.4402069,14757.8158545,17799.5113295,39.0685466,793.1972917,748.3699087,1095.6659942,1.722658,5.1385936,1.2793395,14.8108638),(28501,'zebu-femur.tif',238,7,55,279.6441471,70.3542186,83.3684423,1.8,70.0410903,83.5404812,-1.1908767,23.7661237,21.9660197,14213.4563575,17421.8797065,40.1976055,793.1286577,598.0553057,1040.4176228,0.492188,1.7915914,1.2924967,3.8530579),(28502,'zebu-femur.tif',238,7,56,275.6337696,70.6181206,82.9521654,1.8,70.3585163,83.0884433,-1.2822725,25.5002468,18.0622665,13471.3803165,17004.1905029,42.2196722,941.4206387,528.2843105,1041.8584354,0.4861283,2.0293431,1.815775,4.3452459),(28503,'zebu-femur.tif',238,7,57,272.9357394,70.8623627,82.4515449,1.8,70.6317549,82.6344711,-1.3090511,25.2553921,18.6057663,12866.9670768,16588.9751295,42.4433174,891.6039715,509.4740572,968.501868,0.492188,2.2688746,1.3521274,4.8374339),(28504,'zebu-femur.tif',238,7,58,271.4290238,71.04026,82.020696,1.8,70.7890027,82.2148228,-1.3043978,24.372149,18.8184093,12404.6349997,16149.1859787,42.1029322,858.1589292,508.9676332,1077.5199424,0.246094,0.3480295,2.3561945,0.6960589),(28505,'zebu-femur.tif',238,7,59,269.2822019,71.2180008,81.631173,1.8,70.9634223,81.8623711,-1.3227584,25.8378363,22.6765647,11956.3802721,15554.7223197,42.1753636,685.9382155,462.7469627,894.1986498,1.8246532,10.5131403,1.2120257,23.4416431),(28506,'zebu-femur.tif',238,7,60,268.3436154,71.464081,81.1711419,1.8,71.1733825,81.4120518,-1.3267593,23.1292211,14.5657501,11510.9997223,15249.5343686,42.1128999,1046.944664,497.6821172,1116.2387696,1.6639818,8.4177099,1.3045443,19.9366147),(28507,'zebu-femur.tif',238,7,61,266.3008505,71.6980507,80.7422584,1.8,71.4124514,80.9791812,-1.3658496,12.6736168,14.7222157,11007.1774226,14890.3431395,42.5451843,1011.4199812,868.5111424,1757.4528866,1.7210668,7.2878734,1.3667783,18.7483678),(28508,'zebu-femur.tif',238,7,62,263.4371734,71.9115679,80.3278391,1.8,71.669035,80.5744688,-1.4057417,12.5695638,14.5544384,10533.0599835,14462.1767669,42.72088,993.6609269,837.9813451,1716.7901804,1.3354465,6.75751,1.3876855,16.0238444),(28509,'zebu-femur.tif',238,7,63,261.8592329,72.0852193,79.9288762,1.8,71.8745113,80.1451374,-1.4295767,38.471919,14.5618555,10194.9017694,14126.0241129,42.7786005,970.0703378,264.9959255,608.384751,1.1173414,10.1973229,1.4254863,22.8300303),(28510,'zebu-femur.tif',238,7,64,261.0966807,72.2425521,79.5371504,1.8,72.0337463,79.7623481,-1.4411527,36.7258362,14.8740577,9931.9207624,13802.0447985,42.7888062,927.92734,270.4341631,600.6345652,0.492188,5.6815212,1.484058,11.9319368),(28511,'zebu-femur.tif',238,7,65,259.0428494,72.4541631,79.0573781,1.8,72.2422955,79.3137213,-1.4556933,37.9628729,14.1865074,9595.8510856,13263.5325031,42.6043332,934.9399513,252.7693601,592.7045921,0.492188,1.5564351,1.8925469,3.3608699),(28512,'zebu-femur.tif',238,7,66,256.7378866,72.5966846,78.7106671,1.8,72.4256853,78.9383305,-1.4611791,35.6571979,14.6060731,9337.5388725,12902.3377132,42.2775461,883.354318,261.8696764,613.0254434,0.492188,3.699604,1.6373645,7.9944328),(28513,'zebu-femur.tif',238,7,67,254.8851404,72.7205877,78.3941737,1.8,72.4981518,78.7081887,-1.4584746,22.8666634,27.1737842,9155.5274918,12652.4763797,41.9471616,465.6133383,400.3875562,617.2448589,0.492188,1.5564351,1.2490458,3.3608699),(28514,'zebu-femur.tif',238,7,68,252.8404485,72.8566971,78.0680308,1.8,72.6557487,78.3095544,-1.4627439,32.6497079,14.1356928,8983.7443778,12376.704452,41.6499874,875.5640512,275.1554288,638.8883755,0.492188,1.9840733,1.6951513,4.3452459),(28515,'zebu-femur.tif',238,7,69,251.0681215,72.9873929,77.7609829,1.8,72.8005193,77.9923743,-1.4646404,32.8650282,14.0104206,8833.7410321,12173.5645229,41.3749046,868.8935799,268.7884815,626.7145892,21.556569,25.8586132,1.7140393,77.6335483),(28516,'zebu-femur.tif',238,7,70,250.0727717,73.1115212,77.4402503,1.8,72.924657,77.6484758,-1.4694089,12.2529598,13.9119214,8724.1162583,11953.8277517,41.2518278,859.2506685,712.0007228,1458.0876051,0.246094,0.7782176,1.8925469,1.6804349),(28517,'zebu-femur.tif',238,7,71,249.2286623,73.2429623,77.1214053,1.8,73.0683729,77.3113532,-1.4784914,12.2727299,14.3328919,8642.3650332,11758.7849019,41.1852016,820.4056098,704.1925571,1413.8453145,21.164084,25.6906106,1.7343702,76.5894599),(28518,'zebu-femur.tif',238,7,72,248.1768794,73.3673277,76.8289,1.8,73.1826558,77.0368048,-1.4852157,35.0696524,13.8261239,8578.4653388,11566.4800806,41.0606092,836.5670768,244.6122144,565.7326001,0.246094,1.2548381,1.7681919,2.6648109),(28519,'zebu-femur.tif',238,7,73,247.6161647,73.5561858,76.498995,1.8,73.4028337,76.7340774,-1.4993847,12.1265479,13.7628775,8451.214031,11348.1677049,41.0592602,824.5490592,696.9183713,1427.0333172,21.410178,25.6516846,1.7249044,76.2166967),(28520,'zebu-femur.tif',238,7,74,246.702372,73.6851511,76.2257064,1.8,73.5138094,76.4576756,-1.5059254,13.1464546,13.6946317,8398.5333615,11154.4160855,40.9442744,814.5101203,638.8439785,1399.6542047,21.410178,25.4478332,1.735945,75.8686672),(28521,'zebu-femur.tif',238,7,75,245.6068741,73.7938113,75.9717367,1.8,73.6379734,76.2318129,-1.503562,13.0526148,13.6866966,8363.3577831,10982.2063762,40.749715,802.4000735,640.7419461,1382.1562229,21.4803812,25.1461831,1.7777885,75.5803502),(28522,'zebu-femur.tif',238,7,76,245.2897849,73.8985063,75.7242521,1.8,73.7468698,75.9908308,-1.5087353,12.1163162,13.6623481,8363.1385297,10920.3563327,40.724374,799.3030344,690.2377234,1399.8075691,0.492188,0.7782176,1.8925469,1.8843059),(28523,'zebu-femur.tif',238,7,77,245.6046168,73.9998602,75.4892926,1.8,73.8656206,75.7532136,-1.5172829,12.1716165,13.467986,8400.3305513,10898.3320456,40.8169924,809.2028034,690.157346,1399.6596089,0.246094,0.5502829,2.0344439,1.1882469),(28524,'zebu-femur.tif',238,7,78,245.6672896,74.0937026,75.2442569,1.8,73.9559562,75.4924487,-1.5295072,12.0956976,13.5036261,8453.4000953,10853.5368174,40.8747859,803.7498034,698.8766072,1401.9185323,21.6356712,25.1461831,1.7777885,75.3764792),(28525,'zebu-femur.tif',238,7,79,246.8253317,74.1879053,75.0164087,1.8,74.0616698,75.2524584,-1.5302382,12.1505153,13.4710885,8539.6229553,10893.2846683,41.0699225,808.6417588,702.8198158,1410.3436468,21.656272,25.1979106,1.7873466,75.8686672),(28526,'zebu-femur.tif',238,7,80,247.5741748,74.2871776,74.7876877,1.8,74.196033,75.0384843,-1.5309716,12.1616039,13.4696001,8634.604509,10913.1087835,41.1969545,810.202881,709.9889581,1422.1542948,21.656272,25.1979106,1.7873466,75.5206377),(28527,'zebu-femur.tif',238,7,81,247.5999597,74.4203224,74.5458556,1.8,74.3020575,74.8015999,-1.5382027,12.4208598,13.4636368,8658.5261692,10838.9337179,41.2228358,805.052447,697.095557,1412.4271482,21.656272,25.1979106,1.7873466,75.8686672),(28528,'zebu-femur.tif',238,7,82,247.3001765,74.5247307,74.35193,1.8,74.443908,74.5900581,-1.5499918,12.3482428,13.3203499,8705.8035558,10843.7008402,41.1988592,814.0702687,705.0236791,1434.4736767,21.8690479,25.1894971,1.8276228,76.0128257),(28529,'zebu-femur.tif',238,7,83,247.4590515,74.6163083,74.146426,1.8,74.5423162,74.3915147,-1.5586413,12.1054234,13.6116736,8774.0830628,10863.4683341,41.237082,798.099385,724.8059651,1442.4007559,21.656272,25.3082285,1.8063413,76.0128257),(28530,'zebu-femur.tif',238,7,84,247.634994,74.706818,73.9558711,1.8,74.6197951,74.2056599,-1.5694667,12.1984465,13.8982251,8860.7055187,10922.6699023,41.272426,785.9039418,726.3798302,1418.9391792,21.902366,25.4275963,1.8251644,76.5050137),(28531,'zebu-femur.tif',238,7,85,248.2564545,74.8177534,73.775417,1.8,74.7524076,74.0155807,1.5515324,12.2991293,13.5711108,8965.4015067,11056.1036386,41.3607229,814.6793455,728.9460346,1453.125559,21.902366,25.4906346,1.8345082,76.6491723),(28532,'zebu-femur.tif',238,7,86,248.716691,74.9273337,73.6016959,1.8,74.8785032,73.8360125,1.5382249,12.4282608,13.7586519,9069.4465058,11153.8173879,41.4088204,810.6766163,729.7438179,1469.4682399,21.902366,25.5558873,1.843805,76.7933308),(28533,'zebu-femur.tif',238,7,87,249.5053767,75.0484272,73.429211,1.8,74.9747888,73.6365144,1.5241364,12.3570791,13.3197355,9183.9391017,11279.7137595,41.49376,846.8421712,743.2127774,1494.6250104,21.902366,25.3870742,1.8557537,76.4453013),(28534,'zebu-femur.tif',238,7,88,249.4994857,75.1785771,73.2713011,1.8,75.1380601,73.476291,1.5042315,12.5159794,13.5617743,9280.1014032,11432.1919871,41.3992691,842.9717015,741.4602648,1498.3781018,22.14846,25.4573508,1.8650309,76.7933308),(28535,'zebu-femur.tif',238,7,89,250.1702586,75.3380454,73.0821474,1.8,75.2737519,73.286507,1.4781489,12.3996232,13.6465539,9325.6063593,11509.3801832,41.3381749,843.3909578,752.0878801,1487.7027485,21.902366,25.548777,1.9352039,77.0219354),(28536,'zebu-femur.tif',238,7,90,250.3359789,75.446951,72.9493174,1.8,75.3997396,73.1541012,1.4567715,12.5500571,13.69029,9411.2557013,11578.6889382,41.1825465,845.7592132,749.8974427,1505.5924728,0.246094,0.3480295,2.3561945,0.6960589),(28537,'zebu-femur.tif',238,7,91,252.3633647,75.5415068,72.8319278,1.8,75.4460932,73.0613834,1.4354711,12.6275947,13.7347203,9558.4705916,11765.6141622,41.2949998,856.6329625,756.9510099,1536.9591809,22.394554,25.637515,1.9441727,77.9218653),(28538,'zebu-femur.tif',238,7,92,253.69634,75.6355244,72.7109575,1.8,75.5350525,72.9368198,1.4231344,12.6723655,13.8427342,9726.6418512,11974.7604331,41.3674694,865.0574553,767.5474528,1546.1545361,0.246094,0.7782176,1.8925469,1.6804349),(28539,'zebu-femur.tif',238,7,93,254.818999,75.7553495,72.5858628,1.8,75.6772656,72.798981,1.4096673,12.7498934,14.1738815,9906.8467913,12161.4899901,41.3767167,858.0211428,777.014085,1549.1255803,22.394554,25.9241078,1.9195673,78.3543409),(28540,'zebu-femur.tif',238,7,94,255.3370816,75.8616832,72.4407699,1.8,75.7982007,72.6423965,1.3978013,12.7507664,13.9966914,10092.4795959,12314.2459782,41.2952439,879.7969167,791.5194463,1576.8221524,0.246094,1.0146716,1.815775,2.1726229),(28541,'zebu-femur.tif',238,7,95,255.9797206,75.9542043,72.3042751,1.8,75.8899176,72.4853677,1.3872129,12.9799925,13.982131,10295.7453961,12477.1402844,41.241492,892.3632811,793.2011814,1608.0275822,0.246094,0.5502829,2.0344439,1.1882469),(28542,'zebu-femur.tif',238,7,96,257.7664356,76.0242333,72.1867658,1.8,75.9788507,72.3594317,1.3726109,13.0943925,13.9230818,10522.1878989,12664.5478002,41.2956472,909.608088,803.5644191,1615.1419747,0.492188,2.4732141,1.670465,5.3296219),(28543,'zebu-femur.tif',238,7,97,258.6444232,76.1694298,72.0308108,1.8,76.1222983,72.2526812,1.3616344,13.3712877,14.0535197,10648.7809613,12777.9772615,41.2488527,909.2367957,796.3915811,1634.2783239,0.246094,1.9840733,1.6951513,4.1413749),(28544,'zebu-femur.tif',238,7,98,258.8109694,76.2652184,71.9119605,1.8,76.1734433,72.120812,1.3509803,13.1798899,14.5304978,10786.0837977,12922.5732685,41.0842644,889.3414021,818.3743469,1615.2860086,0.4894917,2.5096762,1.3734008,5.3296219),(28545,'zebu-femur.tif',238,7,99,259.0176518,76.3294121,71.7729663,1.8,76.2403097,71.9652743,1.3373992,13.6664241,14.0045967,10944.3928652,13003.4524331,40.8603691,928.5131645,800.8234466,1666.8773251,0.4831451,1.7915914,1.2924967,3.8530579),(28546,'zebu-femur.tif',238,7,100,258.4404018,76.3931747,71.632129,1.8,76.3087297,71.7923071,1.3108679,13.4418058,14.3790159,11121.5619523,13095.0238955,40.2281937,910.7037663,827.3860031,1660.5292073,23.4941752,26.3699798,1.9634338,81.2230228),(28547,'zebu-femur.tif',238,7,101,258.4622959,76.4703805,71.5196408,1.8,76.3913831,71.690284,1.2892026,13.4563207,14.1359097,11319.301352,13218.6051264,39.7505904,935.1082056,841.188434,1671.5271804,0.492188,2.9938627,1.4056476,6.3139979),(28548,'zebu-femur.tif',238,7,102,257.9831384,76.5396391,71.4011408,1.8,76.4448151,71.5563114,1.2636139,13.5943111,14.5050268,11493.6569753,13297.25524,39.0659512,916.7342753,845.4754978,1704.4597511,0.492188,0.8873045,0.9827937,1.8843059),(28549,'zebu-femur.tif',238,7,103,257.7995613,76.6069488,71.3010175,1.8,76.5329017,71.5038061,1.2419052,13.7899922,14.4445217,11681.3992761,13439.8765207,38.4841039,930.4480166,847.0925208,1735.20563,0.246094,0.5502829,2.0344439,1.1882469),(28550,'zebu-femur.tif',238,7,104,256.6196434,76.6596482,71.1708712,1.8,76.5710546,71.3201774,1.2051189,13.7895188,14.519488,11833.7863793,13564.8602326,37.3011673,934.2519679,858.1725424,1745.96427,23.9703223,26.505135,1.9513027,83.0228826),(28551,'zebu-femur.tif',238,7,105,256.9237393,76.7843713,71.0377774,1.8,76.7334848,71.1750444,1.169212,14.0948889,14.58189,11959.9691693,13660.2025954,36.2782786,936.7923239,848.532346,1754.1032178,23.9940689,26.4651186,1.9720251,83.1670411),(28552,'zebu-femur.tif',238,7,106,256.6519249,76.8678129,70.9723737,1.8,76.8262971,71.0989821,1.1351437,14.1467936,14.3539377,12101.8008002,13793.0704041,35.1576435,960.9258945,855.4447822,1788.2717895,24.1038755,26.505135,1.9513027,83.5150706),(28553,'zebu-femur.tif',238,7,107,257.904334,76.9551851,70.9235227,1.8,76.9070521,70.9972049,1.0939509,14.2124309,14.4309579,12302.566281,14032.8028131,33.9289687,972.4096555,865.6201318,1811.3942161,0.246094,0.5502829,2.0344439,1.1882469),(28554,'zebu-femur.tif',238,7,108,258.3652312,77.0560705,70.8829335,1.8,76.9878342,70.9278557,1.0524283,14.3069305,14.9332197,12505.7021182,14300.5684379,32.4901267,957.6346349,874.1009877,1751.5865883,24.2174307,27.0143516,1.9732958,84.7630299),(28555,'zebu-femur.tif',238,7,109,259.804484,77.1869089,70.8524166,1.8,77.0990215,70.8593575,1.0047147,14.2665807,14.295853,12729.5823587,14661.706817,30.8453397,1025.5916025,892.2658222,1863.014265,0.246094,0.3480295,2.3561945,0.6960589),(28556,'zebu-femur.tif',238,7,110,261.3773959,77.3103414,70.8033678,1.8,77.2267855,70.8070609,0.9652951,14.3592827,14.8397233,12966.7431731,14939.1176165,29.4502916,1006.697852,903.0216494,1868.5396969,0.246094,0.3480295,2.3561945,0.6960589),(28557,'zebu-femur.tif',238,7,111,263.2196447,77.4336312,70.7476829,1.8,77.3388561,70.6978463,0.9315033,14.4892162,14.2758861,13226.0556876,15213.8756144,28.2537658,1065.7044656,912.8206464,1918.0424936,24.5843107,27.3740169,1.9579804,86.0707017),(28558,'zebu-femur.tif',238,7,112,264.8740588,77.5179394,70.6669107,1.8,77.4373514,70.6484773,0.913826,14.6786646,14.1838243,13500.8098773,15398.1707701,27.6802358,1085.614885,919.7573652,1951.7466545,24.7589223,27.1116969,1.7165445,86.2745727),(28559,'zebu-femur.tif',238,7,113,267.9102099,77.6311495,70.5582931,1.8,77.5281492,70.4850083,0.906047,14.3179638,15.1471201,13754.3578895,15623.611434,27.6609021,1031.4575503,960.6364456,1934.5085064,24.9613991,27.3552051,1.7152379,86.8264731),(28560,'zebu-femur.tif',238,7,114,270.0099584,77.6950054,70.4921985,1.8,77.6002508,70.4458262,0.8802028,14.451365,14.9702422,14015.4393827,15842.0831455,26.7416781,1058.2382657,969.8349889,1975.6613097,25.1268226,27.5559354,2.8424371,88.218591),(28561,'zebu-femur.tif',238,7,115,272.1794819,77.7633171,70.4100009,1.8,77.6957691,70.376996,0.8430276,14.4495393,15.8377346,14306.2362304,16133.3046034,25.2900986,1018.6623892,990.0825175,1919.9881325,0.492188,0.7782176,1.8925469,1.8843059),(28562,'zebu-femur.tif',238,7,116,274.4660191,77.8126035,70.3425519,1.8,77.7604834,70.3397308,0.8322678,14.7934658,14.966,14650.8456183,16437.085774,25.0130525,1098.2951889,990.3592418,2008.455875,25.5794511,28.1925355,2.8584969,90.0184508),(28563,'zebu-femur.tif',238,7,117,274.4790125,77.7510043,70.2111518,1.8,77.7206541,70.1889936,0.8508108,14.5941409,14.7247803,15001.5336403,16357.9302884,25.8571212,1110.9116728,1027.9148137,2024.1658446,0.492188,1.5564351,1.2490458,3.5647408),(28564,'zebu-femur.tif',238,7,118,275.0282204,77.702871,70.0709218,1.8,77.7197427,70.0403119,0.8816868,14.6432939,14.7967976,15399.5317337,16270.6789547,27.3054679,1099.608133,1051.6439696,2050.895094,0.3480295,0.6960589,0.7853982,1.3921179),(28565,'zebu-femur.tif',238,7,119,275.026844,77.6218841,69.9309052,1.8,77.7260145,69.9112065,1.1732319,15.430415,14.6071641,15795.2357996,16113.6327329,38.9665558,1103.1321784,1023.6429675,2067.2793619,26.1022104,28.2847558,2.9578481,92.5391032),(28566,'zebu-femur.tif',238,7,120,275.6210882,77.5390631,69.7922381,1.8,77.6739827,69.8653325,-1.0252128,15.0600331,14.8486469,15874.0741786,16345.1264526,33.567211,1100.7822171,1054.0530734,2072.1117057,26.626908,28.3531902,1.6315909,110.5419446),(28567,'zebu-femur.tif',238,7,121,278.3327357,77.4850888,69.6279142,1.8,77.6649505,69.6890995,-0.845373,15.1690336,15.1919052,15782.5815732,16908.1127017,25.969887,1112.9685483,1040.4474013,2101.2526264,0.5972808,1.8741961,1.1659045,4.4646707),(28568,'zebu-femur.tif',238,7,122,278.2707603,77.3857704,69.505395,1.8,77.6034029,69.5904919,-0.7927984,14.6603343,15.4933992,15596.5928573,17403.5659378,23.532428,1123.2890655,1063.8633843,2074.8344669,0.440476,0.8873045,0.9827937,1.8843059),(28569,'zebu-femur.tif',238,7,123,277.9401088,77.2163687,69.4041465,1.8,77.4358867,69.5188296,-0.7682146,14.5495253,15.6259588,15385.0816256,18020.5600301,22.3658304,1153.245077,1057.4284224,2137.1602509,0.5260552,3.5235299,1.359703,7.5022448),(28570,'zebu-femur.tif',238,7,124,276.8056125,76.9558643,69.3029001,1.8,77.1609709,69.4454164,-0.7753568,15.8692121,15.8800654,15027.875098,18770.5674425,22.6039133,1182.0207894,946.9830633,2090.1658266,26.1022104,30.039601,0.9600704,110.0744903),(28571,'zebu-femur.tif',238,7,125,276.3297583,76.7458458,69.1991306,1.8,76.9722105,69.3750804,-0.7725204,16.0122383,16.8267362,14735.5783357,19553.5123845,22.4344611,1162.0502146,920.2697367,2037.4211148,25.3714706,30.5652315,0.9224643,95.6961021),(28572,'zebu-femur.tif',238,7,126,278.185129,76.5660311,69.1700942,1.8,76.8289062,69.3036201,-0.7706734,14.4988558,16.3551418,14658.8243215,20480.0488232,22.4994917,1252.2085775,1011.0331805,2125.2962357,3.4734568,21.1153815,0.9342881,62.1820944),(28573,'zebu-femur.tif',238,7,127,280.9994754,76.4212014,69.1974085,1.8,76.7249965,69.3366544,-0.7737668,14.056854,16.2608773,14639.7210504,21401.6902266,22.8719366,1316.1460952,1041.4649697,2149.3464851,0.246094,0.3480295,2.3561945,0.6960589),(28574,'zebu-femur.tif',238,7,128,281.6172655,76.3089606,69.1763579,1.8,76.5910097,69.3052472,-0.7784436,14.5399316,17.218291,14572.8414031,22137.9173726,23.1416955,1285.7209453,1002.2634102,2128.7805451,2.8671099,20.4850159,0.8960554,57.2602144),(28575,'zebu-femur.tif',238,7,129,281.1406038,76.3625174,69.148625,1.8,76.7578319,69.1506682,-0.7720079,15.3465807,16.8157073,14662.4060449,22645.0049237,22.8010355,1346.6578934,955.4184317,2141.7671613,25.823444,32.2195227,0.9976231,99.8374771),(28576,'zebu-femur.tif',238,7,130,281.5750921,76.3357555,69.1521284,1.8,76.7593383,69.1049566,-0.785991,14.2413782,16.6743304,14751.0045694,22984.728528,23.4924144,1378.4498649,1035.7849074,2198.6412696,0.6832704,1.23047,0.6435011,2.7842358),(28577,'zebu-femur.tif',238,7,131,280.5125365,76.3014447,69.0910112,1.8,76.6887528,68.9050346,-0.8121038,14.1725666,17.2658677,14735.5123386,23258.4928483,24.623997,1347.0792956,1039.7208021,2139.2450455,0.6229271,1.1005658,1.1071487,2.7842358),(28578,'zebu-femur.tif',238,7,132,280.9569533,76.2557921,69.0231286,1.8,76.6316353,68.9136966,-0.8299799,14.3294205,17.8140775,14821.2373653,23655.2837911,25.4979042,1327.8983341,1034.3221737,2125.0065485,2.7879718,21.562385,0.9067502,62.3612316),(28579,'zebu-femur.tif',238,7,133,284.9281306,76.2327684,68.9956105,1.8,76.5990422,68.7920836,-0.8303141,14.2479263,17.3433334,15182.6133494,24145.3490212,25.8741121,1392.1977099,1065.6016183,2154.4940955,1.3892539,3.9757702,1.1902899,9.8292713),(28580,'zebu-femur.tif',238,7,134,286.4067857,76.292978,68.9363477,1.8,76.6080763,68.6841764,-0.8320869,14.4586619,17.6457745,15587.0492913,24418.1484557,26.092657,1383.7957859,1078.042312,2172.1213854,2.551633,21.0665664,0.9179497,61.1132722),(28581,'zebu-femur.tif',238,7,135,289.6450312,76.3500425,68.9338185,1.8,76.675962,68.6293646,-0.8315647,14.7076836,18.2181558,16012.5416953,24851.7052261,26.362574,1364.1175019,1088.7194862,2199.9863675,1.9502478,17.3387151,0.967047,52.7008525),(28582,'zebu-femur.tif',238,7,136,293.2472192,76.4085898,68.9374699,1.8,76.7767811,68.6024531,-0.8367087,17.3096262,18.1018566,16466.5222001,25401.6841936,26.9406495,1403.26403,951.2927647,2227.0883544,0.246094,0.3480295,2.3561945,0.6960589),(28583,'zebu-femur.tif',238,7,137,296.8475536,76.5017358,68.871443,1.8,76.9007737,68.5238757,-0.8421341,14.6676542,18.6489894,16902.7285372,26151.6869803,27.5382646,1402.3112128,1152.3811708,2263.1380209,1.935165,21.0277207,0.9600704,66.1545771),(28584,'zebu-femur.tif',238,7,138,298.6497028,76.5611037,68.8380104,1.8,76.9926372,68.4707629,-0.851668,15.0048259,19.0526546,17425.439833,27004.6950963,28.1764061,1417.3717835,1161.322364,2275.1055098,1.8950147,20.3426129,0.9660168,54.5007123),(28585,'zebu-femur.tif',238,7,139,301.4309419,76.5804704,68.8150555,1.8,76.9897851,68.4364547,-0.8607749,15.0527935,19.8597822,18099.7033062,28084.3326354,28.8917317,1414.1309497,1202.414907,2242.6537365,1.949806,22.1826134,0.9827937,64.101379),(28586,'zebu-femur.tif',238,7,140,305.685367,76.6208717,68.7853223,1.8,77.0794525,68.4172896,-0.8742856,15.5394215,20.1368175,19006.8788074,29453.457866,29.978564,1462.6669706,1223.1394038,2357.7065593,2.0044617,21.0277207,0.9600704,56.996631),(28587,'zebu-femur.tif',238,7,141,311.7496126,76.6878048,68.717735,1.8,77.1459597,68.3775353,-0.8994396,16.1687431,19.5561293,20069.0056764,31224.087003,31.8532893,1596.6394208,1241.2223759,2539.723209,1.7697834,21.9782747,0.9765826,57.0810771),(28588,'zebu-femur.tif',238,7,142,319.4807334,76.7570876,68.6460223,1.8,77.1828508,68.3159284,-0.9292318,16.470591,19.9400399,21290.5173948,33246.9466468,34.1768812,1667.3460406,1292.6383355,2641.2388549,1.6465685,19.1131246,0.968509,48.3556066),(28589,'zebu-femur.tif',238,7,143,326.3388401,76.8265753,68.575288,1.8,77.2840052,68.2363518,-0.9695297,16.613153,20.3791705,22684.0350769,35491.7329736,36.9849445,1741.5690703,1365.426246,2702.0418839,0.930694,9.0118803,0.9600704,19.5391178),(28590,'zebu-femur.tif',238,7,144,337.3048112,76.9561733,68.3118409,1.8,77.4002175,67.7927105,-1.0442053,17.3802925,24.3001604,24423.5060315,39186.7273907,42.0171722,1612.6118844,1405.2413727,2425.9682659,0.6607139,1.0440884,0.7853982,2.0881768),(28591,'zebu-femur.tif',238,7,145,358.2624352,77.2058798,67.3642758,1.8,77.5709782,66.79563,-1.2084031,17.5104588,27.7341063,26686.8755291,49927.2088152,52.2060328,1800.2097579,1524.0534695,2689.6803752,2.0538807,33.3418774,1.0278452,86.9066756),(28592,'zebu-femur.tif',238,7,146,367.3861209,77.2527736,67.1415226,1.8,77.5475263,66.3794717,-1.2633649,17.7584629,29.2298524,28533.65746,56262.1138663,55.6238672,1924.8169013,1606.7639204,2852.9757593,32.7648615,49.7682146,1.1801893,227.6862041),(28593,'zebu-femur.tif',238,7,147,375.5300927,77.2529588,67.1361837,1.8,77.5468493,66.31274,-1.2978452,17.9386703,30.4072239,30631.1554858,61860.5210988,58.0400268,2034.4021281,1707.5488344,3010.3857652,2.5622182,35.1096023,1.0977446,89.8845373),(28594,'zebu-femur.tif',238,7,148,383.0227817,77.3168033,67.224053,1.8,77.6071465,66.3826754,-1.3238975,18.1676503,31.3572122,32814.9175477,67860.3058183,60.0241129,2164.1051972,1806.2279362,3189.2526021,2.5645279,33.1533467,1.0673027,90.5805962),(28595,'zebu-femur.tif',238,7,149,389.848038,77.3441295,67.4506302,1.8,77.642032,66.5971888,-1.3415321,18.6759716,32.2220119,35193.1560045,73452.8961015,61.6188886,2279.5875155,1884.4083044,3359.221162,2.7138861,30.3105499,1.0526573,102.0058564),(28596,'zebu-femur.tif',238,7,150,396.694858,77.3496071,67.8497221,1.8,77.6898863,66.9391094,-1.3538792,19.4613279,33.0702615,37914.8073758,78903.9543172,63.0533486,2385.9489071,1948.2127631,3519.5768222,2.471895,30.5245855,1.0566502,91.5999509),(28597,'zebu-femur.tif',238,7,151,406.0313558,77.4329481,68.4247535,1.8,77.8209807,67.4466241,-1.3587374,20.3233319,33.9206073,41413.8550416,84301.9328873,64.6740984,2485.271919,2037.7492833,3694.637038,1.9018966,25.5795743,1.046877,71.6283575),(28598,'zebu-femur.tif',238,7,152,419.4455837,77.5235275,69.1274762,1.8,77.9788669,68.2759753,-1.3632608,22.2326531,34.7534992,46056.5306858,90601.7004233,66.9395898,2606.9806668,2071.5715063,3925.4537614,1.6669485,26.556496,1.0033564,71.3153068),(28599,'zebu-femur.tif',238,7,153,441.6903759,77.9760542,69.8643598,1.8,78.2618911,69.2521813,-1.3736604,22.8181419,35.40682,53364.6364516,99330.107543,70.7910595,2805.3947701,2338.6933426,4303.7657281,1.9133711,22.320061,0.9736197,61.8093312),(28600,'zebu-femur.tif',238,7,154,460.6488031,78.2665623,70.760542,1.8,78.4824542,70.332574,-1.403865,22.8919975,36.1719239,60168.3453362,107928.4657791,74.6551863,2983.7634898,2628.3571464,4637.3006359,2.2249793,25.6693855,1.0040671,71.0269897),(28601,'zebu-femur.tif',238,7,155,479.9424149,78.4969825,72.1335427,1.8,78.7009796,71.6522175,-1.456793,24.0185004,37.227538,67774.2716982,117700.2368965,78.9552823,3161.6443943,2821.7528403,4976.5100801,0.492188,0.8873045,0.9827937,1.8843059),(28602,'zebu-femur.tif',238,7,156,527.2577608,78.8351375,74.1850098,1.8,78.9172866,73.1117103,-1.5584033,25.5928402,38.7769916,79385.6101463,138629.5876888,87.8627973,3575.0475172,3101.8679302,5613.7275094,0.5220442,1.23047,0.9272952,2.5803648),(28603,'zebu-femur.tif',238,7,157,584.6268819,78.7964421,75.9804352,1.8,78.9846264,74.3347952,1.5550455,26.4962906,40.0309694,93761.8559256,157638.1518873,97.4136423,3937.9049324,3538.6785746,6265.6658812,0.6607139,1.0440884,0.7853982,2.0881768),(28604,'zebu-femur.tif',238,7,158,641.0724652,78.1026564,77.4925391,1.8,78.7654384,75.6314931,-1.4681529,25.9606277,41.1225257,109523.5826484,181011.8595739,105.7236712,4401.7690201,4218.8341424,7059.7361013,0.246094,0.5502829,2.0344439,1.1882469),(28605,'zebu-femur.tif',238,7,159,686.601977,77.9538836,78.742328,1.8,78.744542,76.5751059,-1.4153346,38.1562147,41.5994826,122171.2117125,201221.8381296,111.6901975,4837.12358,3201.8692822,7266.5298137,50.2968464,71.1428769,1.7586942,235.0835128),(28606,'zebu-femur.tif',238,7,160,714.2560615,78.006276,79.5962922,1.8,78.8527494,77.3832498,-1.4043473,37.1425946,41.6913172,131076.6341242,214635.5912645,115.7749121,5148.2084476,3529.0112467,7859.3705553,50.8147527,71.3392507,1.7546609,258.321285),(28607,'zebu-femur.tif',238,7,161,721.7673229,78.0881837,80.2395687,1.8,78.9120279,78.1244465,-1.3964534,35.6372485,41.4146942,137095.7381786,224372.8836414,116.675041,5417.7119495,3846.9787667,8197.1989764,0.3480295,0.6960589,0.7853982,1.3921179),(28608,'zebu-femur.tif',238,7,162,735.5732418,78.1437568,80.8223792,1.8,78.8671768,78.8093083,-1.3846475,28.9761879,40.9801604,142729.3652302,231707.7268931,118.396279,5654.143975,4925.7468123,9029.2940246,0.5515321,1.7746091,0.9827937,3.7686118),(28609,'zebu-femur.tif',238,7,163,751.7027877,78.2008927,81.2857244,1.8,78.8475101,79.3585798,-1.3724882,28.960073,40.3767065,146841.7015053,237721.3222478,120.4211225,5887.5857636,5070.4879652,9339.7888139,52.484489,70.6834064,1.7955075,295.191919),(28610,'zebu-femur.tif',238,7,164,760.0300429,78.2836208,81.5975638,1.8,78.8103259,79.7520129,-1.3632092,28.6671521,39.5743541,148130.9637496,238633.9540038,121.2910456,6030.0151355,5167.2717015,9546.8138702,52.6843024,70.0763198,1.8047022,233.5122577),(28611,'zebu-femur.tif',238,7,165,760.3846441,78.2678653,81.8812913,1.8,78.7984373,80.1181706,-1.3471602,28.4547705,39.0025629,145791.9712909,234924.4316417,120.4975367,6023.3075489,5123.6389797,9613.6631985,52.3009884,69.2364378,1.8149129,246.1257648),(28612,'zebu-femur.tif',238,7,166,747.8247845,78.0659059,82.2250658,1.8,78.6962204,80.4798735,-1.321807,28.3874495,37.5294808,142375.8968718,225974.7575217,117.068848,6021.2598968,5015.4522279,9510.0097267,0.246094,0.5502829,2.0344439,1.1882469),(28613,'zebu-femur.tif',238,7,167,735.7337502,77.7534486,82.6878265,1.8,78.5587237,80.9302008,-1.2842662,28.4990989,36.344406,140307.7331369,212220.6738243,112.8275716,5839.1564796,4923.2340245,9289.4852511,52.3251938,67.1042881,1.8380133,250.0138014),(28614,'zebu-femur.tif',238,7,168,730.6042371,77.469025,83.080458,1.8,78.4011791,81.3490097,-1.2140446,28.6151632,35.2267539,140020.1078432,198888.7503293,106.9162345,5645.9573539,4893.2136809,9193.3107511,0.246094,0.3480295,2.3561945,0.6960589),(28615,'zebu-femur.tif',238,7,169,721.2443403,77.4292868,83.2717017,1.8,78.2907246,81.6488351,-1.1098175,29.1887386,35.0062123,136717.5123136,182776.5152434,96.422042,5221.2594085,4683.9129993,9025.4279823,51.4536037,65.5303547,0.9025069,301.4564495),(28616,'zebu-femur.tif',238,7,170,695.2720513,77.4950317,83.4373625,1.8,78.2696679,81.9040343,-0.9969826,28.9976982,34.1883016,130146.3516637,166724.8297297,81.7322378,4876.6631264,4488.1614679,8661.4548295,50.6835703,64.5357761,0.9097532,277.9303603),(28617,'zebu-femur.tif',238,7,171,663.8621892,77.4979268,83.470647,1.8,78.1934459,82.1588283,-0.8523991,29.4330781,32.4620051,120552.6573804,152244.2627361,62.7129181,4689.9217137,4095.8222915,8191.717575,49.2175314,63.3767307,0.895449,299.9551518),(28618,'zebu-femur.tif',238,7,172,637.5019164,77.3658601,83.4110176,1.8,77.9567435,82.4209427,-0.6765368,29.5417228,30.8640791,109171.307399,140278.876025,41.6497759,4545.0530288,3695.4956219,7744.0163245,0.492188,1.1005658,1.1071487,2.3764939),(28619,'zebu-femur.tif',238,7,173,612.5016883,77.1228922,83.3254457,1.8,77.4358895,82.5444265,-0.4877271,28.8319588,30.7209075,95974.7321472,129424.9236667,22.4179643,4212.9264472,3328.7621116,7262.6244066,47.7380988,60.5341219,0.8890714,306.6624029),(28620,'zebu-femur.tif',238,7,174,592.0753604,76.9376234,83.5588586,1.8,76.9927585,83.0018094,-0.2898114,26.0707521,29.5944027,80042.2639527,118994.8157472,8.058671,4020.8554568,3070.193892,6610.0041986,0.8212636,2.7842358,0.7853982,5.7126301),(28621,'zebu-femur.tif',238,7,175,542.1728866,76.652047,84.3404751,1.8,76.5586093,83.7657421,-0.1745428,23.1413445,27.996863,59717.7142429,107617.0011084,2.7250588,3843.8949767,2580.5637254,5691.1676523,0.246094,0.3480295,2.3561945,0.6960589),(28622,'zebu-femur.tif',238,7,176,425.9811137,75.8445404,85.9228788,1.8,75.7469313,85.3643394,-0.1011698,24.3068577,25.8831442,38358.6192768,91560.0096859,0.7242003,3537.4376873,1578.0986482,4399.7522804,18.884586,38.2088179,1.1388384,97.3168246),(28623,'zebu-femur.tif',238,7,177,288.8551342,75.3177692,88.1325651,1.8,74.9435099,87.2340491,-0.0912474,24.2859357,24.0510361,17860.6642949,68426.1713218,0.3997277,2845.0404787,735.432414,2954.3586113,17.1225424,31.2578133,1.0965857,82.0137729),(28624,'zebu-femur.tif',238,7,178,169.0666973,72.4188531,90.3771987,1.8,74.043517,89.5613396,-0.0040511,24.6063667,24.3210588,4139.9008871,39546.4774044,0.0004623,1626.0179174,168.2451109,1480.8992252,14.749072,20.526364,0.9129077,58.7904894),(28625,'zebu-femur.tif',238,7,179,65.8625371,63.1664239,90.215942,1.8,67.91372,90.5666146,0.0505597,6.3311812,30.7354951,485.3212448,5677.6845296,0.0280367,184.7272842,76.6557189,200.096419,11.4473767,15.5351406,0.7069081,43.1743869),(28626,'zebu-femur.tif',238,7,180,7.3678573,59.9002818,89.9598441,1.8,60.0547984,89.8498629,-0.3883328,2.9998922,4.2558849,12.1760437,24.8319852,0.1760583,5.8347408,4.0588271,8.6787234,5.9169236,8.6693576,0.6037493,23.5858016),(28627,'zebu-femur.tif',238,7,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28628,'zebu-femur.tif',238,7,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28629,'zebu-femur.tif',238,7,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28630,'zebu-femur.tif',238,7,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28631,'zebu-femur.tif',238,7,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28632,'zebu-femur.tif',238,7,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28633,'zebu-femur.tif',238,7,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28634,'zebu-femur.tif',238,7,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28635,'zebu-femur.tif',238,7,189,0.014957,90.3198195,91.2401809,1.8,90.316498,91.2393505,0.2330991,0.0598189,0.7643735,0.0001,0.0033634,0.000133,0.0044003,0.0016712,0.0045307,0.246094,0.7782176,2.8198421,1.5362764),(28636,'zebu-femur.tif',238,7,190,17.2003233,90.0437561,91.352895,1.8,90.033505,91.3883774,-1.1786009,5.5328147,5.6579401,107.0157557,109.7611396,2.4479194,19.3994876,19.3420098,38.0972182,11.3109579,11.6914077,0.859887,37.2084185),(28637,'zebu-femur.tif',238,7,191,41.8679912,90.034205,91.393406,1.8,90.0081162,91.4193354,-0.8078089,7.8104105,7.9341683,554.7414815,571.4888739,3.6453288,72.028832,71.0259063,140.9984347,15.750016,16.2589745,0.8818719,52.2478868),(28638,'zebu-femur.tif',238,7,192,186.4900365,71.6564869,91.8785561,1.8,70.1326423,92.0654034,-0.0252015,14.4759562,27.7960345,7754.6673038,40682.1321729,0.0197364,1463.5948245,535.6929235,1741.7423413,28.546904,29.1390261,2.2244322,94.6417687),(28639,'zebu-femur.tif',238,7,193,544.5250513,66.3613487,92.1524321,1.8,71.5737085,92.0619149,-0.0322539,16.4961392,34.3721484,25832.4931962,86899.3504289,0.0943801,2528.1908301,1565.972066,3274.4301516,28.792998,29.3089585,2.284887,95.6261447),(28640,'zebu-femur.tif',238,7,194,569.1814509,67.1878947,92.1341975,1.8,72.6677166,92.0329949,-0.0328379,16.5332839,34.5142733,27155.2176162,99476.9175955,0.1022575,2882.1964972,1642.4575891,3665.8618291,29.039092,29.2810497,2.1587989,95.6858571),(28641,'zebu-femur.tif',238,7,195,586.9852863,67.8821111,92.1095369,1.8,73.4910557,91.9866822,-0.0325588,16.8303395,34.5651254,28365.7931832,109604.717418,0.1036706,3170.962532,1685.3963774,3987.0531886,29.039092,29.2893217,0.9104901,95.6858571),(28642,'zebu-femur.tif',238,7,196,603.2294416,68.4565758,92.0944177,1.8,74.1711851,91.9872339,-0.032099,16.7571831,34.6881191,29567.353396,118211.9227442,0.1035531,3407.8504606,1764.4584507,4259.9169874,29.039092,29.2944906,0.5577088,95.6858571),(28643,'zebu-femur.tif',238,7,197,616.4036778,68.9178692,92.0697971,1.8,74.7300872,91.9413218,-0.0319554,16.3545335,34.7181509,30598.690934,125221.3983832,0.1048698,3606.7991902,1870.9607901,4487.8497056,28.792998,29.2944906,0.5577088,95.4819861),(28644,'zebu-femur.tif',238,7,198,625.7372025,69.2523078,92.0552536,1.8,75.093336,91.9223547,-0.0315675,16.3676334,34.6603033,31403.1146536,130330.7036003,0.1038886,3760.2297463,1918.6105884,4662.5407924,28.8702164,57.0200382,0.0777649,185.6343504),(28645,'zebu-femur.tif',238,7,199,629.8881763,69.3627694,92.1000333,1.8,75.3091217,91.9486769,-0.0240799,16.5569598,34.785642,31632.2687804,132457.2900694,0.0608595,3807.815024,1910.5119056,4711.6406527,28.9055292,57.2653917,0.0774311,181.2046584),(28646,'zebu-femur.tif',238,7,200,631.0661672,69.3587002,92.1570071,1.8,75.2688236,92.0698374,-0.0163066,16.5146612,34.9984773,31673.956397,132982.7101403,0.0279647,3799.671309,1917.9295307,4704.1382105,28.9119712,57.4158979,0.0514567,179.7280944),(28647,'zebu-tibia.tif',238,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28648,'zebu-tibia.tif',238,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28649,'zebu-tibia.tif',238,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28650,'zebu-tibia.tif',238,8,4,1.7362215,71.6090387,72.8183261,1.8,71.5983127,72.7934717,0.2186307,0.7233853,2.2705011,0.1732093,1.8740808,0.0136127,0.825404,0.2394427,0.8910642,1.7041757,4.8421674,2.8049178,10.7889729),(28651,'zebu-tibia.tif',238,8,5,8.198203,71.9455212,72.7353881,1.8,72.0370238,72.7248419,0.2171793,1.2879127,4.0613656,2.2164146,26.3350907,0.0634403,6.4842945,1.7209354,7.0210899,2.7432147,8.3181083,2.863293,18.7248591),(28652,'zebu-tibia.tif',238,8,6,19.7844906,72.6261053,72.9306719,1.8,72.8550589,73.1251233,0.279499,2.9627934,5.6818884,16.8289564,118.7111743,0.2509548,20.8929083,5.6800979,23.8530162,5.0592347,11.2739712,2.8326619,26.6932255),(28653,'zebu-tibia.tif',238,8,7,38.6377797,73.1999267,73.3409263,1.8,73.3158247,73.4954893,0.3395828,3.8649508,7.5069252,86.8186404,344.8708817,0.7144864,45.9403647,22.4630648,57.4756781,7.3713245,13.9469669,2.8250234,35.0631767),(28654,'zebu-tibia.tif',238,8,8,66.1830316,73.0563294,73.8996636,1.8,72.4393838,74.3764111,0.0701175,6.3737418,12.3150087,381.5030361,1127.9498223,0.0541423,91.591476,59.8554273,116.6698974,9.7689196,16.0482679,2.7928217,43.3776806),(28655,'zebu-tibia.tif',238,8,9,139.8860448,71.6711238,75.4126323,1.8,71.6101851,76.0872432,-0.1354583,9.250583,12.0722409,1574.4421068,4623.6617141,0.4251838,382.9994559,170.1992303,510.7791972,16.0708458,23.1354827,0.2905107,83.8793076),(28656,'zebu-tibia.tif',238,8,10,199.476546,72.2296696,76.3051321,1.8,72.1591713,76.5701389,-0.11526,10.8626692,15.4750814,3800.8910042,8849.0147343,0.439717,571.823468,349.9039639,771.579704,20.4498548,27.4390546,2.9147938,91.6124311),(28657,'zebu-tibia.tif',238,8,11,295.3668304,74.276546,75.6387405,1.8,75.6007355,74.7208974,-0.5106525,18.1785188,19.9871134,11739.5548322,21174.4952889,11.7592059,1059.4073745,645.7927052,1548.1785786,29.5966122,38.5644041,1.4758446,164.6013845),(28658,'zebu-tibia.tif',238,8,12,478.6187411,76.4465674,73.4265335,1.8,75.8441199,74.2355712,-0.949077,18.0298177,21.8546762,27588.7294464,56167.3809601,52.7095711,2570.0394889,1530.1724056,3689.3909295,33.2565362,44.569996,1.5913063,219.9363714),(28659,'zebu-tibia.tif',238,8,13,564.2783895,75.0395236,73.442208,1.8,73.9393502,75.5985025,-1.02913,20.1046779,33.6768017,39215.9848606,92158.0564358,69.0482306,2736.5442023,1950.5900616,3875.9118834,36.1462557,57.1568747,1.0749595,239.5198473),(28660,'zebu-tibia.tif',238,8,14,662.5599502,72.4174968,75.8535832,1.8,72.2236496,76.9041753,-1.0175814,21.8812949,31.7419513,51880.2986301,153573.3457382,79.9409765,4838.1822668,2370.9885066,6449.9440879,38.0117805,58.1886305,0.9980431,255.7108496),(28661,'zebu-tibia.tif',238,8,15,671.6847973,71.5622468,75.7170718,1.8,71.4168134,76.8751055,-1.0233152,23.3930854,31.5780793,62795.5205305,161277.2908694,81.614184,5107.2546091,2684.3624755,6909.0000666,39.7566483,58.6859191,0.9374195,235.5174537),(28662,'zebu-tibia.tif',238,8,16,689.0283871,70.8461019,75.3878614,1.8,70.7706835,76.5538546,-1.0230215,30.7668579,31.4448135,75003.1040932,169418.2494168,83.6915552,5387.7962803,2437.7888807,6946.3808396,1.3209562,4.3116315,1.012197,10.0412507),(28663,'zebu-tibia.tif',238,8,17,694.3527258,70.1152834,75.2678963,1.8,70.1409473,76.2002508,-0.997336,26.1130158,30.9484551,85698.7165251,169911.5383432,81.6614524,5490.1460439,3281.8391058,8032.1468057,45.4100793,59.0053827,0.9365901,249.1365462),(28664,'zebu-tibia.tif',238,8,18,691.6625636,69.4535792,75.4848923,1.8,69.6462339,76.1257225,-0.9307153,26.831804,31.0807357,91632.865664,164358.6049312,74.1554494,5288.1182287,3415.0840412,8088.049258,46.5339085,58.2316907,0.941423,237.7241995),(28665,'zebu-tibia.tif',238,8,19,695.0341595,68.7862647,75.9725889,1.8,69.2286905,76.3981394,-0.8420347,27.5601982,30.9346317,94062.7688158,158971.3258897,64.4662171,5138.9435397,3412.993193,8127.9757005,47.2717227,57.8633042,0.917027,274.6020505),(28666,'zebu-tibia.tif',238,8,20,714.6359766,67.921951,77.0426956,1.8,68.9174199,76.8075387,-0.7174502,27.9004693,29.4532596,95489.4230965,154785.8345179,51.4848705,5255.3040494,3422.5024013,8289.5620714,0.228516,0.7226311,2.8198421,1.4265433),(28667,'zebu-tibia.tif',238,8,21,699.5392365,67.8980085,77.6823083,1.8,68.8587494,77.3981652,-0.516916,26.6309484,29.9336201,91940.7847271,146811.0057225,28.4753303,4904.5523117,3452.4036963,7890.1747353,48.20613,55.8047139,3.100632,246.5282157),(28668,'zebu-tibia.tif',238,8,22,640.7543883,68.4772742,78.208178,1.8,69.1746519,77.9413444,-0.3905628,25.9679133,30.5960198,83131.3280925,139701.0597377,15.478412,4565.9880206,3201.3095213,7225.8063486,1.8827777,5.6021389,0.2053954,16.5505935),(28669,'zebu-tibia.tif',238,8,23,606.8402798,68.9429205,78.6544811,1.8,69.5769933,78.2775368,-0.3154117,24.7670075,31.1164985,75896.8510848,136051.4981315,9.7326019,4372.3267364,3064.4336514,6768.7487927,44.6307665,56.3193458,3.0806924,190.2506249),(28670,'zebu-tibia.tif',238,8,24,571.7541901,69.3497495,79.3080214,1.8,69.9484715,78.744231,-0.281119,24.1834819,30.6664809,67172.4036551,131288.6478041,7.3344549,4281.1774918,2777.6150598,6442.4039992,43.607648,56.2933781,3.0887962,204.1469539),(28671,'zebu-tibia.tif',238,8,25,541.4228661,69.8091426,79.5945389,1.8,70.4479092,79.0432481,-0.2593592,23.1895877,30.6201054,61101.0585624,123213.5096888,5.9351093,4023.9413987,2634.8488522,6016.9748487,0.228516,0.3231704,2.3561945,0.6463409),(28672,'zebu-tibia.tif',238,8,26,513.5018707,70.8264897,79.7504672,1.8,71.1229375,79.2432587,-0.2467021,23.8614779,30.7416611,57328.6365679,106550.6868493,5.1039661,3466.0029135,2402.5601809,5301.0820234,41.2348966,55.3376892,2.9798384,333.0293075),(28673,'zebu-tibia.tif',238,8,27,477.7678629,72.3381693,79.4699238,1.8,72.3433726,79.1404965,-0.1703254,22.0391862,31.1546113,53535.7072684,85207.3735042,2.2878138,2734.9843249,2429.1145271,4391.8581989,40.3553656,53.1750422,0.0774311,273.3917235),(28674,'zebu-tibia.tif',238,8,28,441.2596445,73.9691226,78.9244468,1.8,73.8476533,78.708282,0.105673,21.50222,29.5323807,48360.3703823,65573.9551162,0.8181891,2220.4087005,2249.0873199,3498.0006756,38.699417,52.427868,0.0610594,223.6520154),(28675,'zebu-tibia.tif',238,8,29,415.6722624,75.0567164,78.555765,1.8,74.9704645,78.3888327,0.4756502,23.332795,24.1128047,41724.3051878,55488.210552,14.526885,2301.1927151,1788.225767,3147.9782926,2.5768958,15.5994609,1.0153026,39.0291496),(28676,'zebu-tibia.tif',238,8,30,397.6993636,75.5035521,78.3181862,1.8,75.5557453,78.2624683,0.5978792,20.8350442,24.4224379,37186.9052566,50868.1571024,21.0015836,2082.8451812,1784.8248793,3488.0418894,2.0322136,16.3592567,1.0759089,41.6145131),(28677,'zebu-tibia.tif',238,8,31,382.0496657,75.8406931,78.1921168,1.8,75.9130473,78.164994,0.6530512,20.3700826,24.1934628,33657.6122172,47061.6904134,23.5083476,1945.223416,1652.3061271,3278.7847776,2.0793727,21.5654229,1.1213658,57.1726283),(28678,'zebu-tibia.tif',238,8,32,365.7608162,76.0097635,77.9809571,1.8,76.1278014,78.0477715,0.6764491,20.2159736,23.9448127,31016.7665084,43228.4148419,23.890953,1805.3352689,1534.2702313,3095.7359013,1.5142017,9.7085693,1.1071487,22.8246935),(28679,'zebu-tibia.tif',238,8,33,350.0567784,76.183134,77.7136032,1.8,76.3334785,77.922673,0.6703821,19.7958431,23.3622587,28506.2101793,38677.9051456,22.5200619,1655.5721646,1440.0099076,2849.716563,1.5821598,6.3657194,1.2036225,18.0325842),(28680,'zebu-tibia.tif',238,8,34,339.2993102,76.2765574,77.5598494,1.8,76.449713,77.8473054,0.6699361,19.7191521,22.6744549,26758.7388242,35622.4555044,21.803455,1571.0391115,1356.9923646,2740.509133,2.2536361,24.2205412,1.1113681,71.3366804),(28681,'zebu-tibia.tif',238,8,35,331.5168225,76.3563869,77.4502564,1.8,76.5699891,77.7836055,0.6626776,19.2596011,22.2128271,25264.4068127,33329.6960132,20.9136189,1500.4706915,1311.7824523,2627.7399616,2.2553006,22.5861229,1.0980992,58.5437243),(28682,'zebu-tibia.tif',238,8,36,323.7199348,76.4943112,77.3914892,1.8,76.7132533,77.695044,0.6517564,19.21759,21.7669626,23980.8334148,31108.7574562,19.8517892,1429.1731034,1247.8585226,2526.3233303,2.1833266,20.8501294,1.0924439,56.5817347),(28683,'zebu-tibia.tif',238,8,37,312.5946985,76.6655478,77.3485013,1.8,76.7401174,77.6127426,0.6421226,18.7571473,21.1852489,22804.5948075,29150.5725596,18.6867627,1375.9844259,1215.7816131,2446.888513,1.9184392,16.8699923,1.1374425,46.6513786),(28684,'zebu-tibia.tif',238,8,38,301.585532,76.7721789,77.2748835,1.8,76.7038448,77.4994272,0.6282378,18.5442485,20.5326149,21787.2739183,27461.2138269,17.3620117,1337.4435745,1174.8803933,2392.8222699,1.2777743,4.049314,1.2847449,11.2230379),(28685,'zebu-tibia.tif',238,8,39,295.0310269,76.8177394,77.1971568,1.8,76.6510312,77.442896,0.6137452,18.1918807,20.067348,21034.7311187,26075.2820997,16.310252,1299.3885438,1156.270284,2340.474123,1.3710961,3.8306264,1.2679115,9.3394625),(28686,'zebu-tibia.tif',238,8,40,290.8338238,76.7994447,77.1057572,1.8,76.5740463,77.3336582,0.595972,17.8460298,19.7245396,20513.960512,24836.9506448,15.2723023,1259.1903887,1149.4971534,2284.4643546,1.4968137,3.5768413,1.1071487,8.8269832),(28687,'zebu-tibia.tif',238,8,41,285.8029908,76.891774,76.9611831,1.8,76.6861467,77.2488257,0.5900012,17.8583503,19.3347334,19934.7712111,23545.3712286,14.744513,1217.7758436,1116.271712,2225.7821818,1.9033217,22.1766517,1.111757,62.3663223),(28688,'zebu-tibia.tif',238,8,42,282.8682986,76.9138869,76.8935362,1.8,76.7211795,77.1641983,0.6052274,17.4260974,19.1210309,19407.5161675,22518.4305332,15.2608879,1177.6786826,1113.704104,2187.1177074,2.2072701,22.8926969,1.1160771,61.7754287),(28689,'zebu-tibia.tif',238,8,43,280.8952534,76.9649836,76.8180223,1.8,76.7256092,77.1041313,0.6124519,17.4937004,18.8136261,18970.0834585,21705.460034,15.471795,1153.7095485,1084.3951293,2157.1959272,2.0934915,20.7660584,1.1514547,64.6514824),(28690,'zebu-tibia.tif',238,8,44,278.2392871,76.9738382,76.7010565,1.8,76.7319722,77.0146028,0.6315637,17.5448556,18.7117374,18596.3677181,20942.2502766,16.1648248,1119.2039434,1059.9327894,2109.1656519,1.8618636,16.9672176,1.125219,42.4176826),(28691,'zebu-tibia.tif',238,8,45,276.6653103,76.9569719,76.5846545,1.8,76.716969,76.8766051,0.6401808,17.5263866,18.4841073,18297.7102939,20261.0330442,16.4530851,1096.1326244,1044.0092847,2082.9433278,2.1236423,17.5258521,1.1830262,50.9214953),(28692,'zebu-tibia.tif',238,8,46,276.4096876,76.9755438,76.4724189,1.8,76.7366702,76.780109,0.6150598,17.2891023,18.1069403,18085.8899651,19643.8413642,15.3378569,1084.8791163,1046.0861192,2057.0879789,1.7857664,20.3494758,1.1423101,54.6102318),(28693,'zebu-tibia.tif',238,8,47,276.926598,76.9210656,76.3464473,1.8,76.7063402,76.6940186,0.5802047,17.0709243,17.8587624,17976.0675627,19040.9532702,13.8702349,1066.1966832,1053.0225076,2063.9097103,2.0889064,20.5842067,1.1717354,55.5797431),(28694,'zebu-tibia.tif',238,8,48,276.0585506,76.8745989,76.2639036,1.8,76.7100941,76.6185102,0.6044874,16.9957861,17.6609577,17717.3107974,18466.3780517,14.8616507,1045.6045695,1042.4531544,2038.3418854,1.9688829,18.0802237,1.2090671,50.0628786),(28695,'zebu-tibia.tif',238,8,49,274.7845988,76.8441515,76.1213702,1.8,76.6701255,76.5498251,0.685364,16.9177259,17.3804776,17322.5461976,17808.380413,18.3479116,1024.6197373,1023.9287643,2019.8085756,2.0808377,18.1623513,1.1972992,50.409016),(28696,'zebu-tibia.tif',238,8,50,272.6067581,76.7579768,76.0087898,1.8,76.613106,76.4214519,0.9558763,17.1406238,16.6458536,16916.1649452,17211.2474229,30.3136112,1033.9660442,986.9048614,1990.8146326,2.2097016,17.9497835,1.192654,56.2815312),(28697,'zebu-tibia.tif',238,8,51,271.0496814,76.6608232,75.9073182,1.8,76.5765304,76.3459702,1.35816,21.4097434,16.5125251,16469.7911016,16785.7824815,43.1629963,1016.5484919,769.2661618,1504.9302109,2.2821018,19.3686698,1.2341215,51.4014944),(28698,'zebu-tibia.tif',238,8,52,270.832717,76.5536655,75.7998602,1.8,76.5406768,76.234532,1.5331598,17.3343811,15.9948023,16046.2652333,16550.8066084,45.0748768,1034.7615632,925.6901169,1876.1624901,2.4394513,18.8022995,1.2106032,57.163115),(28699,'zebu-tibia.tif',238,8,53,271.1503069,76.4469311,75.7251816,1.8,76.4888095,76.1855164,-1.4509889,16.0877316,15.6437515,15683.5721669,16333.6127834,44.5461413,1044.0982025,974.8777836,1873.6934307,2.5805925,19.1531318,1.2301801,58.2989682),(28700,'zebu-tibia.tif',238,8,54,271.6854941,76.3880593,75.6325587,1.8,76.455335,76.0468115,-1.3836605,16.5482099,15.5168495,15356.3243685,16165.0769444,43.713611,1041.7757108,927.9749595,1862.0432907,2.5978388,18.215464,1.2252407,52.3710057),(28701,'zebu-tibia.tif',238,8,55,271.4217695,76.3368642,75.5487232,1.8,76.359225,75.9640465,-1.3242536,16.4190147,15.1728874,14996.1168074,15970.2442009,42.5425703,1052.5514221,913.3384096,1840.9533823,2.4186254,19.511039,1.2490458,59.4482751),(28702,'zebu-tibia.tif',238,8,56,269.8531095,76.2978821,75.4474574,1.8,76.3424101,75.8707509,-1.2636636,16.5425148,15.0668181,14608.2075491,15754.7201077,40.864689,1045.6567545,883.0705442,1828.6589215,2.2840833,19.0780078,1.2414702,47.5004821),(28703,'zebu-tibia.tif',238,8,57,268.9924994,76.288898,75.2886276,1.8,76.3979262,75.6946378,-1.205832,16.5808475,15.2480108,14192.7997395,15469.1132381,39.1209695,1014.5004146,855.9755299,1788.4059942,2.5887999,18.49992,1.2568581,52.1816968),(28704,'zebu-tibia.tif',238,8,58,267.4097085,76.243533,75.1869368,1.8,76.3433683,75.5719249,-1.1686317,16.5449595,15.5228055,13779.1254783,15226.7484985,37.7403035,980.9276069,832.829207,1753.0742235,2.7537085,18.7174003,1.2606283,50.2197072),(28705,'zebu-tibia.tif',238,8,59,266.3133825,76.2094006,75.0826349,1.8,76.3021179,75.4910416,-1.1558215,15.9491482,15.6670267,13431.0473956,15003.63441,37.1709782,957.6567847,842.1169124,1738.1386229,2.6943539,18.6489226,1.2722974,45.9860112),(28706,'zebu-tibia.tif',238,8,60,265.6663029,76.1560427,74.9806399,1.8,76.2291344,75.3796166,-1.143471,15.87889,15.6238372,13110.8784303,14825.5804789,36.6726212,948.9077668,825.6797827,1728.0889162,2.8339518,19.3713657,1.2714301,50.9999096),(28707,'zebu-tibia.tif',238,8,61,264.1512392,76.0804012,74.8920384,1.8,76.1299147,75.2539909,-1.1375348,15.2660087,15.5970415,12709.4834587,14639.3536474,36.2653268,938.5981055,832.5347959,1720.0078306,2.829151,19.0862175,1.2793395,54.3329954),(28708,'zebu-tibia.tif',238,8,62,262.2642139,76.0012836,74.8077695,1.8,76.0370834,75.1508066,-1.1414632,15.0687988,36.1449925,12295.5657236,14445.2986007,36.1366787,399.6486819,815.9619015,722.6145629,2.2468189,17.2782888,1.2197654,47.5234491),(28709,'zebu-tibia.tif',238,8,63,261.0484317,75.9115239,74.7380488,1.8,75.968783,75.049961,-1.1440859,14.9893757,15.3818793,11968.765589,14260.5978785,36.0553415,927.1037407,798.4832609,1680.4171878,2.0288875,16.5496716,1.2621455,44.2917447),(28710,'zebu-tibia.tif',238,8,64,260.7082133,75.8210423,74.6678862,1.8,75.8727115,74.9462746,-1.1554599,14.9156833,15.4304852,11692.492357,14133.8447652,36.3770319,915.968913,783.905912,1640.217801,1.9557154,17.2722432,1.2615974,41.5170723),(28711,'zebu-tibia.tif',238,8,65,260.544861,75.7750594,74.5848203,1.8,75.8329269,74.8782197,-1.1648362,14.6924403,15.3683302,11343.7856903,13928.5219012,36.6522848,906.3132878,772.0831591,1614.0906112,2.3887012,16.3321018,1.2578951,45.0489801),(28712,'zebu-tibia.tif',238,8,66,259.6081685,75.6935445,74.5411347,1.8,75.7119518,74.8544664,-1.169716,14.5749298,35.6478705,10984.7059504,13757.8895776,36.6730109,385.9386091,753.6712752,687.5426959,2.7273558,19.4614624,1.2973353,55.5931969),(28713,'zebu-tibia.tif',238,8,67,259.0746903,75.627137,74.4875603,1.8,75.6767845,74.7439926,-1.1741233,14.3577848,36.5875108,10697.346376,13572.0474817,36.7338649,370.9475494,745.0554882,655.2925443,2.1243547,12.026978,1.3212094,31.2405787),(28714,'zebu-tibia.tif',238,8,68,258.9317827,75.5365073,74.4547276,1.8,75.5394323,74.7353205,-1.1812773,14.3986919,34.7982992,10411.4783784,13405.0467155,36.9320812,385.2213191,723.0850178,677.873089,2.7746852,19.5244165,1.2860659,49.8640565),(28715,'zebu-tibia.tif',238,8,69,257.4300746,75.4580022,74.4344257,1.8,75.4628394,74.6831175,-1.1824097,13.9767892,34.8231229,10110.5657281,13232.0432812,36.7519857,379.9786518,723.3825728,655.5728542,2.5519593,15.3531471,1.3149878,41.1709348),(28716,'zebu-tibia.tif',238,8,70,256.23537,75.3768968,74.4237087,1.8,75.3338765,74.6837412,-1.1828229,13.758232,14.964695,9807.5882108,13095.7636607,36.593787,875.1106286,712.8523636,1517.0767855,2.6761781,20.4032935,1.2986504,50.4549501),(28717,'zebu-tibia.tif',238,8,71,256.3189213,75.2826277,74.3861034,1.8,75.2300497,74.6464187,-1.186329,19.4434348,33.0604864,9563.5309093,13039.0812751,36.7102497,394.4007695,491.8642721,590.6467508,1.4133151,5.3786281,1.3567356,14.8008797),(28718,'zebu-tibia.tif',238,8,72,255.7745244,75.2023604,74.3385779,1.8,75.1595244,74.5537892,-1.2058504,13.3776278,33.6433359,9324.6739293,12930.675868,37.1991326,384.3458307,697.0349375,646.9257844,2.2077351,20.2465701,1.2847449,48.16979),(28719,'zebu-tibia.tif',238,8,73,255.5306116,75.1635641,74.3194913,1.8,75.0971972,74.6685424,-1.2180698,13.2147587,14.8302746,9062.0530568,12769.8812351,37.5058864,861.0684281,685.7524425,1457.9853314,2.220996,14.1753622,1.2082521,38.5626043),(28720,'zebu-tibia.tif',238,8,74,253.4286474,75.0939105,74.3514227,1.8,75.0547329,74.7702979,-1.2178232,13.4495768,14.6977477,8830.6387449,12606.9357196,37.1906128,857.7460955,656.5737261,1430.9067594,2.1379717,17.4930461,1.2242575,42.8976816),(28721,'zebu-tibia.tif',238,8,75,253.1998466,75.0221971,74.3424995,1.8,74.9683162,74.6435326,-1.2167484,13.6181147,14.9251836,8682.2047443,12437.0908435,37.127573,833.2956668,637.5482173,1361.5094562,2.7480866,20.6854328,1.2909792,51.8260461),(28722,'zebu-tibia.tif',238,8,76,253.7251121,74.949666,74.3433408,1.8,74.8967546,74.6283323,-1.2156821,13.6824458,19.719665,8565.074474,12316.9809849,37.1752306,624.603968,625.9900149,939.8091383,2.5606082,19.34304,1.3200871,50.7781205),(28723,'zebu-tibia.tif',238,8,77,253.5965412,74.8762525,74.3791565,1.8,74.8382529,74.7591665,-1.216638,12.8521835,15.3332295,8418.2220471,12214.970953,37.182707,796.6339345,655.0032542,1225.0348457,2.390002,19.1217522,1.3171222,51.4799087),(28724,'zebu-tibia.tif',238,8,78,253.1651443,74.7863679,74.4042957,1.8,74.7663178,74.726409,-1.2133128,12.816075,14.7084847,8241.9729469,12095.283096,37.0278263,822.3337317,643.0964967,1371.4150804,2.5769318,17.1280334,1.3419975,45.8521496),(28725,'zebu-tibia.tif',238,8,79,253.1424525,74.677506,74.4441525,1.8,74.6259729,74.8196095,-1.2140231,13.556189,19.8779056,8036.9467415,11950.1952743,37.0441365,601.1797984,592.8618081,830.7080164,2.4715523,17.5734606,1.3478961,46.3875959),(28726,'zebu-tibia.tif',238,8,80,252.8558779,74.5661262,74.4825025,1.8,74.5654225,74.8472367,-1.2174771,13.4631074,22.730448,7828.8230929,11785.4601151,37.0970919,518.4878055,581.5019428,742.4495812,2.2853896,17.2964129,1.3033855,47.2002786),(28727,'zebu-tibia.tif',238,8,81,250.1189712,74.4737622,74.5132016,1.8,74.4711591,74.9079235,-1.2173369,12.5081328,16.4509942,7570.3175149,11532.9061848,36.6917589,701.0461542,605.2316227,1042.6804968,2.65864,18.6796988,1.310982,50.8335678),(28728,'zebu-tibia.tif',238,8,82,247.9509889,74.37714,74.6045498,1.8,74.423365,75.0485869,-1.2144619,23.6541614,15.7798116,7378.2121245,11335.076981,36.2962947,718.3277759,311.9202582,671.5347688,2.7100603,19.6217957,1.3116943,55.380921),(28729,'zebu-tibia.tif',238,8,83,245.775585,74.2672995,74.673445,1.8,74.3109548,75.1581756,-1.2177166,14.0134098,15.8355879,7199.6130119,11126.6224523,36.0646923,702.633999,513.7659667,953.0031542,2.6887994,19.4614624,1.2973353,51.558323),(28730,'zebu-tibia.tif',238,8,84,245.022294,74.1756058,74.7523549,1.8,74.2091834,75.2778052,-1.2135188,14.6945363,17.1031914,7028.6850933,10943.7740229,35.8423701,639.8673643,478.3196249,869.5451554,3.0067285,20.6234908,1.3016288,50.1317796),(28731,'zebu-tibia.tif',238,8,85,242.5872482,74.0721625,74.8090429,1.8,74.1030236,75.2165762,-1.2063061,12.0549793,15.7296402,6852.3464268,10738.9250177,35.2934908,682.7190506,568.4245683,908.1060636,2.3030049,15.3922115,1.2537406,42.0620319),(28732,'zebu-tibia.tif',238,8,86,240.8030005,73.9728951,74.8811859,1.8,74.0703163,75.2651894,-1.2083135,16.1922807,18.5889719,6675.9592084,10572.4470531,35.0874481,568.7483476,412.2927058,770.8450095,2.0586368,16.4785238,1.2315037,40.8247974),(28733,'zebu-tibia.tif',238,8,87,240.3096522,73.8717068,74.9695075,1.8,73.9785053,75.3500065,-1.2040313,22.9339044,15.4657596,6504.8213499,10443.8830682,34.9012871,675.2906625,283.6334028,640.3923022,1.7780543,11.9725816,1.3397057,29.7585881),(28734,'zebu-tibia.tif',238,8,88,237.8689413,73.7780103,75.0575199,1.8,73.9412381,75.4995409,-1.2083946,15.3598441,21.2370014,6352.1480788,10351.4085404,34.6620582,487.4232648,413.5555036,657.3580038,2.038355,15.1924483,1.2966289,37.593093),(28735,'zebu-tibia.tif',238,8,89,238.0015473,73.7055416,75.1284161,1.8,73.8251977,75.653692,-1.2106406,23.4266637,18.3130471,6205.5122351,10240.8720792,34.7402999,559.2118011,264.8909937,645.3035515,2.4024627,16.5496716,1.2621455,47.8236525),(28736,'zebu-tibia.tif',238,8,90,236.0184539,73.6140236,75.201661,1.8,73.710151,75.7351465,-1.2044672,22.5571303,32.3111656,6059.8894616,10104.9833024,34.2895303,312.7396707,268.646294,411.188562,2.1602944,14.4110103,1.3142797,35.7324846),(28737,'zebu-tibia.tif',238,8,91,234.3108741,73.553331,75.2813531,1.8,73.7632194,75.8772126,-1.2173112,23.7528607,18.1550524,5948.4028283,9961.0242401,34.3721015,548.6640319,250.4289018,633.2907073,2.6234942,16.4086589,1.3460852,47.1218643),(28738,'zebu-tibia.tif',238,8,92,232.8508466,73.4721976,75.3360734,1.8,73.6057522,75.8242966,-1.2108435,21.9094869,15.1603803,5802.6141037,9851.7675857,33.9936605,649.8364433,264.844819,654.7528688,2.951394,19.96346,1.2924967,52.929419),(28739,'zebu-tibia.tif',238,8,93,231.5958205,73.3881472,75.3810864,1.8,73.5141318,75.7863576,-1.2106303,23.234794,15.2535998,5664.3620439,9783.8323835,33.8050142,641.4113726,243.7879172,605.1767246,2.4131905,16.3321018,1.2578951,41.7943087),(28740,'zebu-tibia.tif',238,8,94,230.4149779,73.2925295,75.4509557,1.8,73.3744252,75.8529847,-1.2141722,27.2932168,15.4298806,5518.0817171,9703.9646339,33.7220108,628.9073042,202.1777701,556.5959515,2.3896079,16.3321018,1.2578951,44.5689811),(28741,'zebu-tibia.tif',238,8,95,230.450503,73.2292369,75.5144205,1.8,73.3106783,75.910407,-1.2139462,23.8607186,14.8436105,5399.4086801,9666.8505413,33.7215278,651.246577,226.2886035,564.4167205,2.4141028,17.4930461,1.2242575,42.1404462),(28742,'zebu-tibia.tif',238,8,96,230.4530349,73.1685768,75.5722608,1.8,73.2486758,75.9298841,-1.2126086,18.2962502,18.9381517,5327.8915581,9625.3872262,33.6882159,508.2537811,291.2012845,673.109455,2.0405272,15.4885987,1.1930297,37.3808171),(28743,'zebu-tibia.tif',238,8,97,229.7178625,73.1431096,75.6183545,1.8,73.1840191,75.89552,-1.2070866,14.4386252,17.9940889,5239.5389464,9522.3482117,33.4410394,529.1931278,362.8835074,819.2047654,2.6144332,18.7884079,1.2490458,44.1578831),(28744,'zebu-tibia.tif',238,8,98,228.983956,73.0713854,75.7128423,1.8,73.0733813,75.9062208,-1.2051097,14.69806,19.3498356,5109.0103169,9411.0136964,33.283924,486.3614299,347.5975951,684.5287391,2.8507577,17.7081478,1.2286404,47.3666205),(28745,'zebu-tibia.tif',238,8,99,227.7109538,73.0086442,75.831902,1.8,73.0207986,75.9700864,-1.2069702,18.2032102,14.0355416,4995.31377,9341.4363604,33.1459484,665.5558189,274.4193855,684.0290319,2.5537286,16.9101848,1.240499,43.6224368),(28746,'zebu-tibia.tif',238,8,100,226.1830092,72.9371572,75.9460218,1.8,72.9477063,76.0030861,-1.2090384,19.6608684,13.6539105,4882.9437243,9277.0821204,32.9752724,679.4450678,248.3584966,698.5292077,2.4970834,17.786122,1.2165369,43.5669895),(28747,'zebu-tibia.tif',238,8,101,225.2161244,72.866265,76.0809419,1.8,72.8978728,76.1907813,-1.2085311,18.4036944,17.3837993,4782.8943228,9241.3106388,32.8216974,531.6047711,259.8877276,684.2944845,2.2504049,12.9933006,1.1543577,35.3404131),(28748,'zebu-tibia.tif',238,8,102,224.079795,72.8185751,76.2101457,1.8,72.8669591,76.2678599,-1.2088881,18.1920172,16.92289,4701.5614605,9195.9567083,32.6649293,543.4034425,258.4409085,683.6119851,2.073495,16.341691,1.2136623,40.8247974),(28749,'zebu-tibia.tif',238,8,103,223.1187809,72.7857681,76.3559791,1.8,72.8311149,76.3756945,-1.2069245,23.5102596,14.0145045,4623.0790163,9151.4464564,32.4763733,652.9982189,196.6409174,553.7243978,1.9018363,16.0482679,1.2220253,37.2144752),(28750,'zebu-tibia.tif',238,8,104,222.6336928,72.7366219,76.5001157,1.8,72.8051151,76.4867977,-1.2057871,18.1080217,13.5583497,4557.2838065,9123.9861018,32.3776559,672.9422316,251.6720977,634.1357153,2.0486659,15.5407689,1.2257941,36.2449639),(28751,'zebu-tibia.tif',238,8,105,221.9694282,72.7266515,76.6306391,1.8,72.7445092,76.6163167,-1.2067244,12.8215752,13.5943734,4498.2226191,9052.56768,32.304154,665.9054776,350.8322931,958.2407898,2.1775363,15.0647349,1.1818394,39.6430102),(28752,'zebu-tibia.tif',238,8,106,221.5662932,72.6947016,76.7821791,1.8,72.7670196,76.7678667,-1.2038283,21.0756979,13.7087529,4458.4217742,8971.2283746,32.1740812,654.4160821,211.5432571,574.5856845,2.0357252,14.6838207,1.2047398,34.8509008),(28753,'zebu-tibia.tif',238,8,107,220.6570081,72.635666,76.9379909,1.8,72.6323017,76.9243256,-1.2115082,19.5749995,13.6416436,4364.4051547,8862.0696317,32.2295999,649.6335683,222.9581234,603.8158637,2.6237385,17.5600838,1.253161,50.0303983),(28754,'zebu-tibia.tif',238,8,108,220.1817309,72.568019,77.1044954,1.8,72.5281623,77.0477489,-1.2156303,13.2501595,13.7517032,4282.5329041,8806.7226562,32.2592915,640.4095935,323.2061397,685.4271697,1.8835347,16.6362167,1.2055949,43.2992663),(28755,'zebu-tibia.tif',238,8,109,220.0544101,72.5148036,77.272343,1.8,72.4942361,77.2151098,-1.21922,10.4731457,14.1114145,4232.4265829,8782.0857457,32.3261288,622.3391526,404.1218073,920.9839358,2.0551461,16.2101468,1.1955255,40.2568708),(28756,'zebu-tibia.tif',238,8,110,220.4020816,72.4760399,77.4281118,1.8,72.4524936,77.3943439,-1.221537,10.4989781,13.5007041,4209.7295756,8768.0241141,32.4320869,649.449393,400.9656496,961.1264906,1.5951256,14.2231713,1.1574659,33.9922841),(28757,'zebu-tibia.tif',238,8,111,221.1934296,72.4425707,77.5848041,1.8,72.4638073,77.4949779,-1.2229842,10.7200334,14.383272,4198.4876019,8805.6517911,32.5827837,612.2147879,391.6487416,802.8860318,1.5144218,13.5037301,1.152572,31.6746437),(28758,'zebu-tibia.tif',238,8,112,221.7715477,72.3943859,77.7402484,1.8,72.3492872,77.6615575,-1.2279008,10.0805163,14.2082179,4159.2351412,8836.4447147,32.7837176,621.9249144,412.601401,850.3219073,0.9855219,7.8895959,1.3961241,17.0535596),(28759,'zebu-tibia.tif',238,8,113,220.6179067,72.398932,77.8630318,1.8,72.3442409,77.7886119,-1.233636,9.9672785,13.3411123,4119.8472553,8803.8901515,32.7457889,659.9067558,413.3372289,968.676672,2.1807592,14.3438173,1.1784562,36.2219969),(28760,'zebu-tibia.tif',238,8,114,219.5188905,72.3675244,78.032485,1.8,72.2871702,78.0046079,-1.2381849,10.199974,13.8544415,4084.5715368,8794.2512875,32.6859838,634.7604354,400.4492104,898.8549861,2.2620975,13.7489939,1.1964627,35.4972417),(28761,'zebu-tibia.tif',238,8,115,218.9505992,72.3381842,78.2097832,1.8,72.2777339,78.2388949,-1.2425355,9.9825122,13.4076312,4058.4664357,8806.3785817,32.6988137,656.8183768,406.5576218,936.6054888,2.177738,12.6924136,1.1635405,31.9978142),(28762,'zebu-tibia.tif',238,8,116,218.2754635,72.3182167,78.3808071,1.8,72.2441506,78.4300656,-1.2455933,10.004213,13.618298,4032.5850556,8845.2716069,32.665614,649.513736,403.088683,945.2629506,2.1137869,13.8341864,1.1810878,35.8204122),(28763,'zebu-tibia.tif',238,8,117,218.3079979,72.2959863,78.5610861,1.8,72.2515947,78.579564,-1.2482133,10.1210711,12.7209921,4020.2999433,8882.8574505,32.7280055,698.2833848,397.220798,994.0219366,2.1480852,14.8974212,1.2102303,36.6235816),(28764,'zebu-tibia.tif',238,8,118,218.1322711,72.2883979,78.7442791,1.8,72.2771726,78.7589829,-1.2525636,10.0802748,12.9698883,3997.6535198,8935.7836027,32.7962161,688.9638046,396.5817999,987.4757525,1.8810867,12.6036472,1.1801893,31.1391974),(28765,'zebu-tibia.tif',238,8,119,217.7050993,72.2792042,78.920086,1.8,72.2509606,78.9263231,-1.2549873,9.9230236,13.0682625,3984.7964791,8987.0610539,32.7840866,687.7012971,401.5707934,991.054166,1.6449953,12.9025571,1.1705557,29.9803772),(28766,'zebu-tibia.tif',238,8,120,217.8561246,72.2650961,79.1061562,1.8,72.2236498,79.0798087,-1.2562812,10.1340781,13.1693609,3965.7319218,9036.591401,32.8345215,686.1829861,391.3263612,986.7010828,1.5179014,11.9725816,1.1583859,27.3950137),(28767,'zebu-tibia.tif',238,8,121,216.3875205,72.2968811,79.2669244,1.8,72.2283182,79.1529812,-1.2582195,10.056655,13.3951681,3949.3417932,9030.8757148,32.6541974,674.1890529,392.7092851,967.2257171,2.1413065,13.1133151,1.1773457,31.9423669),(28768,'zebu-tibia.tif',238,8,122,215.326498,72.2830917,79.4652437,1.8,72.2509107,79.3998894,-1.2584968,10.1291376,13.3789199,3925.4456068,9041.3687668,32.4999049,675.7921292,387.5399641,968.7606407,1.9961165,11.6722256,1.1684752,31.7855383),(28769,'zebu-tibia.tif',238,8,123,214.4536875,72.2635343,79.6649841,1.8,72.1927955,79.5797143,-1.2557998,10.0888163,13.3844464,3901.7503548,9026.292733,32.3115861,674.3867074,386.7401509,958.180326,1.9405663,12.1822826,1.1659045,31.8409856),(28770,'zebu-tibia.tif',238,8,124,213.7974616,72.2510089,79.8536381,1.8,72.1755057,79.7191157,-1.2540608,9.9795648,13.2336019,3880.0386656,9035.7857689,32.1761213,682.7911134,388.7983843,975.4724101,1.8404342,11.8586379,1.133005,31.4069206),(28771,'zebu-tibia.tif',238,8,125,213.9437239,72.2367136,80.051628,1.8,72.1588787,79.9089615,-1.2517331,9.9326253,13.2385246,3873.4406643,9061.2470454,32.148845,684.4604899,389.971486,969.7570942,2.0462818,12.9933006,1.1543577,34.5831777),(28772,'zebu-tibia.tif',238,8,126,213.7026119,72.2228859,80.2428526,1.8,72.1474406,80.1203572,-1.2500573,10.1677461,13.5421362,3872.5843581,9083.5547621,32.0769793,670.7623234,380.8694994,955.5985879,1.8072867,12.0659916,1.141034,29.1447275),(28773,'zebu-tibia.tif',238,8,127,213.8806173,72.2069203,80.4330929,1.8,72.1507704,80.3046795,-1.246861,10.5522847,13.3708426,3882.6288743,9104.6960975,32.0352281,680.9366014,367.9420131,963.467884,1.9265375,13.4125467,1.1681417,33.4243575),(28774,'zebu-tibia.tif',238,8,128,213.6278746,72.1996266,80.6157633,1.8,72.1407668,80.4875871,-1.2427166,11.5660569,13.4647973,3876.7469022,9105.4198549,31.9078362,676.2389105,335.1831094,962.8229375,1.3713194,10.7426832,1.1547318,24.541927),(28775,'zebu-tibia.tif',238,8,129,212.086353,72.2432511,80.7673059,1.8,72.1891437,80.6600598,-1.2386964,10.3954807,13.2865665,3855.0471218,9040.4176666,31.5904448,680.4178996,370.8387551,970.3387928,1.8312791,13.2952335,1.1455913,32.644155),(28776,'zebu-tibia.tif',238,8,130,210.9363041,72.2413042,80.955115,1.8,72.1777611,80.8547173,-1.2327975,9.8086803,13.2382658,3838.2953122,9005.0960501,31.2903469,680.2323046,391.3161787,968.6371157,2.9425284,18.212597,1.2649175,41.461625),(28777,'zebu-tibia.tif',238,8,131,210.3783617,72.2377014,81.1528407,1.8,72.1758801,81.0597872,-1.2252874,9.769297,13.354604,3820.1137709,8989.9701687,31.0412879,673.1738463,391.0326188,959.2093674,2.0405407,10.8394661,1.2490458,25.2112349),(28778,'zebu-tibia.tif',238,8,132,210.6841943,72.2297709,81.3485083,1.8,72.1458853,81.2533833,-1.2172477,9.6767025,13.3037575,3824.9351976,8988.2970696,30.904751,675.6209318,395.2725848,962.9423474,2.0760045,12.6512044,1.2204821,30.7051324),(28779,'zebu-tibia.tif',238,8,133,210.9009846,72.2201876,81.5332927,1.8,72.122545,81.4239682,-1.2085245,10.1751719,13.3160262,3830.4749528,9000.9961423,30.7353369,675.952119,376.4530959,961.7533518,1.9864853,14.7335243,1.1557216,32.7225693),(28780,'zebu-tibia.tif',238,8,134,210.2654725,72.2042681,81.7210404,1.8,72.1088165,81.6205795,-1.198455,9.659765,13.1530626,3839.7900263,8975.0142686,30.4061927,682.351673,397.5034631,973.4549817,1.6268991,15.4531576,1.1600794,33.6366334),(28781,'zebu-tibia.tif',238,8,135,210.4564062,72.184725,81.9187554,1.8,72.0980647,81.8341516,-1.1890896,9.263969,13.0004959,3866.4956917,8956.9185107,30.2089165,688.9674525,417.3692403,986.2939926,1.3984292,13.5365601,1.1902899,29.3015561),(28782,'zebu-tibia.tif',238,8,136,210.6082861,72.166483,82.1131589,1.8,72.0717617,82.014574,-1.1777483,9.8679389,13.1496862,3885.6204043,8945.6983754,29.9522378,680.2974787,393.762106,975.5258452,0.9537999,9.3048397,1.1401038,20.1284354),(28783,'zebu-tibia.tif',238,8,137,208.5388404,72.1865235,82.2665874,1.8,72.1181055,82.162382,-1.1642321,9.7441182,13.1017282,3888.3998938,8851.8529987,29.3210669,675.6248378,399.0509757,972.3033347,1.8595295,13.027417,1.1935473,29.7910684),(28784,'zebu-tibia.tif',238,8,138,207.617529,72.1684391,82.4376614,1.8,72.0841553,82.3232079,-1.1545066,10.0367742,13.0960642,3906.1447239,8810.6910767,28.9448251,672.7739689,389.183283,969.8137627,1.6693524,14.2360156,1.2439697,31.4528546),(28785,'zebu-tibia.tif',238,8,139,207.0313723,72.1427046,82.5931917,1.8,72.0710141,82.4438886,-1.1449177,9.9890193,13.0632157,3932.6905384,8760.0132071,28.6162536,670.5862781,393.7013648,971.4261866,1.8331425,12.3059638,1.1902899,28.364525),(28786,'zebu-tibia.tif',238,8,140,205.8213975,72.1380779,82.7506012,1.8,72.0425812,82.61614,-1.1350576,9.7895918,13.0313215,3940.6852526,8722.0833342,28.1923267,669.3168712,402.5382623,971.6904294,1.4231227,12.6924136,1.1635405,27.473428),(28787,'zebu-tibia.tif',238,8,141,204.7978465,72.1291305,82.9112124,1.8,72.060702,82.7651926,-1.1240072,9.8328577,13.086816,3968.1480185,8696.0698619,27.7608179,664.4908768,403.5599967,967.4875981,1.6556071,14.0458365,1.1872688,30.7835467),(28788,'zebu-tibia.tif',238,8,142,203.8646987,72.1229689,83.0593369,1.8,72.0617696,82.9258582,-1.1134616,9.8470686,13.048422,4004.3667074,8680.1764482,27.3527405,665.2280594,406.6557141,972.0468061,0.6293497,3.5475225,1.3101939,7.6127158),(28789,'zebu-tibia.tif',238,8,143,203.4981964,72.1277187,83.1982953,1.8,72.0601979,83.0817792,-1.1032994,9.6755253,13.0272725,4049.5911552,8689.350569,27.0283481,667.0122681,418.5396705,971.476953,1.4760924,13.2401316,1.199905,28.7890768),(28790,'zebu-tibia.tif',238,8,144,202.1572612,72.1451553,83.3418132,1.8,72.0664009,83.2223653,-1.0944855,9.9201036,12.9924567,4070.211312,8666.1329308,26.6097695,667.0126491,410.2992741,974.8241199,0.8357586,7.7324902,1.2397003,16.7074221),(28791,'zebu-tibia.tif',238,8,145,200.3280889,72.219903,83.4930913,1.8,72.1234434,83.3637725,-1.0842505,9.8470633,12.9140036,4075.6204593,8568.1356467,26.0885016,663.476325,413.8919726,976.205094,1.01895,8.2392619,1.2315037,17.810795),(28792,'zebu-tibia.tif',238,8,146,197.9550577,72.2597619,83.6604586,1.8,72.1711608,83.5540194,-1.0755169,10.1967278,12.8790356,4067.302987,8462.7258316,25.539874,657.0931297,398.8831594,960.0115862,1.1442032,9.4689491,1.226149,20.8531906),(28793,'zebu-tibia.tif',238,8,147,196.3864927,72.3033747,83.8062916,1.8,72.2261384,83.7007614,-1.0648946,10.1030065,12.9701881,4071.6152576,8381.5098504,25.0447226,646.2134378,403.0102593,959.8985486,1.0813549,8.7465231,1.2242575,19.1034768),(28794,'zebu-tibia.tif',238,8,148,194.4345411,72.3397931,83.956301,1.8,72.2271571,83.833624,-1.0535302,10.1561678,12.795474,4084.725722,8319.4763056,24.4813827,650.1889867,402.1916334,967.2019966,1.18011,10.1426105,1.1777383,22.1458723),(28795,'zebu-tibia.tif',238,8,149,192.6812929,72.3895634,84.1000142,1.8,72.2999909,83.9932969,-1.042344,10.0427751,12.6840249,4096.7425656,8261.1870792,23.9498023,651.3064376,407.9293367,968.5975696,1.3878796,8.8267544,1.199905,19.9391265),(28796,'zebu-tibia.tif',238,8,150,190.864052,72.4267755,84.2454667,1.8,72.324295,84.168398,-1.0303233,9.8480071,12.7177783,4124.2619623,8203.9496495,23.3886994,645.0772658,418.7915304,967.829421,1.010182,7.1719086,1.1784562,15.9042526),(28797,'zebu-tibia.tif',238,8,151,190.0684315,72.4749407,84.3911538,1.8,72.3842761,84.3165061,-1.0168635,9.8353543,12.8948911,4179.0136861,8188.9806281,22.9123098,635.0562072,424.897117,955.4355812,0.7537626,6.8744969,1.1964627,14.879294),(28798,'zebu-tibia.tif',238,8,152,189.0654835,72.5279663,84.5393288,1.8,72.4230711,84.4542063,-1.0022849,10.2155956,12.638592,4232.6734684,8172.3668557,22.3774399,646.6200409,414.3344791,975.0237909,0.6961224,4.9223855,1.1902899,10.6551113),(28799,'zebu-tibia.tif',238,8,153,188.6735044,72.6385309,84.6697498,1.8,72.5205126,84.5703949,-0.9856221,10.0472941,12.8149444,4289.2675405,8153.2773715,21.852021,636.2319736,426.9077307,970.6694434,0.457032,1.0219547,1.1071487,2.2067458),(28800,'zebu-tibia.tif',238,8,154,187.6469785,72.6960182,84.8350042,1.8,72.5779393,84.7628123,-0.969061,10.4103782,12.8225303,4352.5967357,8176.0522309,21.2529083,637.6317316,418.1016901,967.1741706,0.6378459,3.6917891,1.1902899,7.9913335),(28801,'zebu-tibia.tif',238,8,155,187.6564413,72.7548991,84.9891735,1.8,72.6324357,84.9556027,-0.9562506,10.1080083,12.8813744,4443.8297132,8289.8106342,20.8782471,643.5501655,439.6345531,976.9191832,1.0002677,9.5129653,1.150133,20.7747763),(28802,'zebu-tibia.tif',238,8,156,188.9988482,72.836896,85.1176054,1.8,72.710285,85.0271778,-0.943625,10.2927998,13.2525682,4557.9318458,8504.5794892,20.6512469,641.730671,442.8272125,976.9181939,0.228516,0.5109773,2.0344439,1.1033729),(28803,'zebu-tibia.tif',238,8,157,189.9157763,72.9210817,85.256065,1.8,72.8027919,85.1932659,-0.9303378,10.364658,13.5767356,4693.0430288,8776.17819,20.3500546,646.4129872,452.7928501,987.884404,17.6125562,24.2323963,0.8990009,71.2851736),(28804,'zebu-tibia.tif',238,8,158,192.7979324,72.9962763,85.4432208,1.8,72.9357249,85.325622,-0.920878,10.5094633,13.3661477,4871.584134,9187.8547116,20.3667906,687.3973658,463.542616,1043.3637572,0.228516,0.5109773,2.0344439,1.1033729),(28805,'zebu-tibia.tif',238,8,159,195.3975649,73.0896813,85.6139528,1.8,73.0097126,85.5324266,-0.9109147,10.5878993,13.4513583,5096.0973183,9696.0600114,20.3279383,720.823858,481.3133518,1089.9102818,17.950854,25.1087003,0.8562471,73.9489514),(28806,'zebu-tibia.tif',238,8,160,198.5122247,73.1884323,85.8141552,1.8,73.1042539,85.7600114,-0.9055525,11.0715932,13.3652524,5396.8552768,10296.239773,20.4798851,770.3737638,487.4506472,1174.0640981,0.457032,0.8239262,0.9827937,1.7497138),(28807,'zebu-tibia.tif',238,8,161,202.8710552,73.3879171,86.0614748,1.8,73.3309575,86.1487706,-0.9139001,11.3714243,13.6616434,5827.4302158,10981.8164505,21.2031361,803.8430028,512.4626478,1229.8913003,0.5115571,1.532932,1.1071487,3.3101187),(28808,'zebu-tibia.tif',238,8,162,208.2829329,73.5298825,86.311021,1.8,73.5001776,86.3992925,-0.9178992,11.4705321,13.732639,6353.5774063,11712.9447378,21.9028817,852.9274504,553.9043307,1292.9874606,0.6817165,3.1081538,1.2722974,6.8879606),(28809,'zebu-tibia.tif',238,8,163,215.0960831,73.6536121,86.5282079,1.8,73.6135238,86.617712,-0.9106042,11.4701219,13.9635421,6937.8067892,12535.9061962,22.3664635,897.7597616,604.85903,1386.735104,0.6421338,3.1828597,1.2036225,6.8879606),(28810,'zebu-tibia.tif',238,8,164,222.0333102,73.7903232,86.6812195,1.8,73.7709613,86.7533767,-0.8996669,11.6933894,14.5301731,7561.4278151,13458.6268586,22.6946384,926.2537212,646.6412376,1442.8184983,0.457032,1.0219547,1.1071487,2.2067458),(28811,'zebu-tibia.tif',238,8,165,229.400415,73.9020456,86.8364114,1.8,73.9352827,86.8536576,-0.8891218,12.3627017,14.4974263,8196.5199247,14479.918698,23.0540277,998.7923617,663.0039392,1539.6337434,0.5075644,2.0439093,1.1071487,4.4134916),(28812,'zebu-tibia.tif',238,8,166,238.6268687,74.0243052,86.9511734,1.8,74.0544721,86.9816136,-0.8689137,12.4751195,14.9321997,8928.7577558,15659.1928272,23.1916587,1048.6862685,715.7252266,1640.6851577,0.5059235,1.532932,1.1071487,3.3101187),(28813,'zebu-tibia.tif',238,8,167,250.7622372,74.1440032,87.0423084,1.8,74.1573006,87.0824012,-0.8508653,12.5165792,15.155172,9781.0322405,17235.4459087,23.6251543,1137.264948,781.4461202,1748.1615786,21.8794391,30.2953975,0.5921867,93.4635262),(28814,'zebu-tibia.tif',238,8,168,265.1502945,74.3012613,87.197616,1.8,74.3484342,87.2847341,-0.8416857,12.881333,15.5380376,10906.6384247,19388.2734398,24.5780484,1247.7942125,846.7010692,1847.0649528,22.4755783,31.5070463,0.6101318,96.8290922),(28815,'zebu-tibia.tif',238,8,169,289.4247184,74.6151705,87.3104221,1.8,74.6980208,87.4097097,-0.8148271,13.9697152,16.8665941,12515.5328868,22906.6365606,25.537482,1358.1068258,895.9046565,2098.8413116,0.6817609,3.5768413,1.1071487,7.7236103),(28816,'zebu-tibia.tif',238,8,170,316.5558691,74.9156961,87.4592765,1.8,74.8987494,87.5706697,-0.7934287,14.3062238,17.5928204,14238.8754435,26938.1482619,26.803321,1531.2012299,995.2923763,2340.0310481,0.5546183,1.9524416,1.2120257,4.2241827),(28817,'zebu-tibia.tif',238,8,171,354.049708,75.074156,87.6749808,1.8,75.07959,87.7589866,-0.7854274,14.5101163,19.5288881,16220.1440572,31784.2406309,29.5058698,1627.549939,1117.850726,2456.9099743,26.1303861,36.0251703,0.5175726,169.8830061),(28818,'zebu-tibia.tif',238,8,172,390.5605373,75.1604588,87.9670464,1.8,75.2075295,87.926943,-0.7789348,15.1884321,18.7463195,18212.8716062,37247.327714,32.1260038,1986.9141593,1199.1278277,2944.5714759,26.0768372,37.6490096,0.5779019,126.1631285),(28819,'zebu-tibia.tif',238,8,173,425.7106197,75.1273384,88.0529935,1.8,75.3220948,87.9587035,-0.7598314,15.8298718,20.0141492,20115.9985287,43253.8198252,33.6626711,2161.1620597,1270.761938,3108.0263739,2.5983287,17.0547057,0.9567773,45.3262165),(28820,'zebu-tibia.tif',238,8,174,434.3769157,75.6768787,87.4093889,1.8,75.6294792,87.6509747,-0.7164962,16.1745745,20.4971881,21310.2157065,44428.8192221,31.2256115,2167.5567891,1317.5132224,3181.70991,2.0158706,17.0087154,1.0349851,39.8647993),(28821,'zebu-tibia.tif',238,8,175,406.8442282,76.9713654,85.9336452,1.8,76.2936028,86.8214213,-0.6536245,16.9552357,22.129573,21866.4315892,36178.2015269,25.0715404,1634.835045,1289.6565952,2622.9432062,1.8092448,14.5175126,1.0789872,35.6635836),(28822,'zebu-tibia.tif',238,8,176,364.6323672,78.0463366,85.2088145,1.8,77.637792,85.8257937,-0.5399985,17.441566,22.9270039,21919.9367236,25517.2586034,16.0641508,1112.9783337,1256.7642571,2061.1609464,1.4873998,8.8267544,1.199905,21.2318083),(28823,'zebu-tibia.tif',238,8,177,320.1511071,79.0616068,84.8154849,1.8,78.8587723,85.236937,0.7658067,22.3348354,16.18318,16317.1819443,20947.166946,25.6341578,1294.3789127,730.5709526,1620.9879068,0.228516,0.5109773,2.0344439,1.1033729),(28824,'zebu-tibia.tif',238,8,178,270.3458724,79.7590621,84.8181533,1.8,79.6821805,85.0387089,0.7148442,20.6233045,16.6308059,11254.7333211,19760.7936571,19.3603659,1188.2042133,545.7289029,1399.0843661,26.2660149,32.6785885,1.8615833,127.9128423),(28825,'zebu-tibia.tif',238,8,179,199.8144383,80.7404814,85.2026306,1.8,80.8402131,85.397565,0.6555368,13.6720929,17.5380519,7871.5068265,17380.0367074,12.3749662,990.9901492,575.735325,1439.0889965,24.7170468,32.2410096,1.8656475,228.9431503),(28826,'zebu-tibia.tif',238,8,180,154.2910181,81.7146591,85.7724632,1.8,81.9443241,86.0486475,0.6423579,12.8225693,18.5744259,5954.3275931,14211.1762807,9.2292487,765.0937031,464.3630642,1084.2243937,0.228516,0.3231704,2.3561945,0.6463409),(28827,'zebu-tibia.tif',238,8,181,119.3521085,82.1298472,86.3290511,1.8,82.3126328,86.5119248,0.6631268,12.7787463,18.7419681,4730.5365526,10654.0459807,7.537955,568.4592955,370.1878437,820.8542395,0.3231704,0.6463409,0.7853982,1.2926818),(28828,'zebu-tibia.tif',238,8,182,94.3433983,83.2453955,87.3064876,1.8,82.9432871,87.2030052,0.6863769,12.7683881,20.1573525,4038.8855838,7096.2732126,6.3151069,352.0439104,316.3191422,552.3324357,0,0,0,0),(28829,'zebu-tibia.tif',238,8,183,67.2837093,85.2471248,89.1444398,1.8,84.2918182,88.3847134,-0.9445216,22.3465209,12.0551488,2286.4181809,3239.7184105,7.361409,268.7414708,102.3165168,246.6366164,7.4845245,13.3128964,0.8826514,36.0651683),(28830,'zebu-tibia.tif',238,8,184,44.6112077,86.1475665,90.5964815,1.8,86.23863,90.5207306,-0.8809651,4.5231397,12.0378812,115.4589308,2191.8866445,4.4238413,182.0824293,25.5262801,188.005244,6.6762558,12.3059638,1.0240075,34.2600072),(28831,'zebu-tibia.tif',238,8,185,12.7162716,88.4074255,88.1410358,1.8,86.4009249,90.3046921,-0.8391151,3.3422231,12.8205248,20.5233017,805.6062802,1.173317,62.8372311,6.1406139,64.4312223,0,0,0,0),(28832,'zebu-tibia.tif',238,8,186,1.2397558,92.8070177,83.52126,1.8,92.7562428,83.4490869,0.4767925,1.0399633,2.3248091,0.2303186,1.1508165,0.0435192,0.4950155,0.221468,0.5939743,2.248995,4.598796,2.677945,10.7105586),(28833,'zebu-tibia.tif',238,8,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28834,'zebu-tibia.tif',238,8,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28835,'zebu-tibia.tif',238,8,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28836,'zebu-tibia.tif',238,8,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28837,'zebu-tibia.tif',238,8,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28838,'zebu-tibia.tif',238,8,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28839,'zebu-tibia.tif',238,8,193,1.5074048,93.8994163,85.4500333,1.8,93.9038468,85.4450083,-1.4430361,2.5581359,2.5974528,1.9503448,2.3568281,0.2471556,0.9073613,0.7624086,1.6144845,5.0983844,5.4938975,1.8662372,17.764861),(28840,'zebu-tibia.tif',238,8,194,20.2254453,93.6035679,85.6375556,1.8,93.4450973,85.6516551,-1.457608,5.711642,6.2138505,131.736151,160.3947248,3.3279049,25.812453,23.0644973,46.1504627,12.1113485,12.7314389,1.2036225,40.3907324),(28841,'zebu-tibia.tif',238,8,195,39.0967106,92.8516775,85.6839383,1.8,92.6523897,85.6786926,-1.5463243,7.1669796,8.2518773,402.8741117,614.3600117,6.5122168,74.4509391,56.2125375,116.0018281,16.3201073,16.7379203,1.0093027,54.0327919),(28842,'zebu-tibia.tif',238,8,196,56.3765293,92.2377875,85.7089449,1.8,92.0531961,85.6904116,-1.5646328,7.9237753,9.630342,737.388296,1290.1551705,9.3957313,133.9677419,93.0602227,193.970268,19.3902264,19.7173699,1.0085115,63.9077008),(28843,'zebu-tibia.tif',238,8,197,73.1453241,91.7816675,85.7132823,1.8,91.5712283,85.702864,-1.5685836,8.6059076,10.7682758,1132.8355884,2123.3239063,12.1908276,197.1832773,131.6346451,276.2471732,21.709021,22.0562346,0.9770467,71.5758638),(28844,'zebu-tibia.tif',238,8,198,86.6387019,91.3784631,85.7120412,1.8,91.1717249,85.7256481,-1.5659885,9.3422953,11.6937277,1528.5161772,3015.5830011,14.4394498,257.8803844,163.6124879,353.7483643,23.537149,23.9506147,1.0516502,77.8729308),(28845,'zebu-tibia.tif',238,8,199,145.4993476,81.8567368,86.7523882,1.8,74.6581337,87.1627812,-0.1169356,15.0451226,30.6560956,6270.2602859,28731.3825771,0.3300831,937.2159766,416.763655,1139.5503395,28.2508544,28.5654153,1.9735873,93.8326307),(28846,'zebu-tibia.tif',238,8,200,547.9333644,70.2798677,87.262902,1.8,74.683494,86.9935302,-0.0792966,16.1139064,28.9958898,27527.5452678,81199.8099979,0.5730272,2800.3903459,1708.3098692,3479.4564666,28.7930173,29.2866247,1.929567,95.6837258),(28847,'zebu-tibia.tif',238,8,201,573.4186967,70.4501256,87.222817,1.8,74.9198023,86.9587994,-0.0811678,16.5300474,28.9002724,29148.4485553,84490.7675021,0.6282522,2923.528413,1763.3614645,3620.2328212,29.0215333,29.2375497,2.7654404,95.7391731),(28848,'zebu-tibia.tif',238,8,202,578.3571803,70.5934375,87.224507,1.8,75.0793907,86.9444065,-0.0809381,16.4812552,28.7732267,29693.3169331,86100.2345396,0.63009,2992.3732771,1801.6417172,3691.1063547,29.1252755,57.1865596,0.1000663,187.1203018),(28849,'zebu-tibia.tif',238,8,203,578.0291465,70.5442141,87.2980153,1.8,75.0133592,87.0423106,-0.0654328,16.3167588,28.6448329,29717.1164064,85108.1873106,0.4118798,2971.1532123,1821.2634488,3638.5881517,0.228516,0.5109773,2.0344439,1.1033729),(28850,'zebu-tibia.tif',238,8,204,576.5397337,70.4507473,87.3637693,1.8,74.8675029,87.1465442,-0.0499837,16.5754638,28.5448942,29522.4285197,83751.6356471,0.2398693,2934.0320926,1781.0921565,3564.1902897,29.1421239,57.5393149,0.0795133,181.502056),(28851,'zebu-tibia.tif',238,8,205,574.4623285,70.3733478,87.4054403,1.8,74.7837431,87.2337945,-0.0400164,16.9491356,28.483215,29284.3101548,82635.2706173,0.1532338,2901.1918273,1727.7760286,3511.8582919,29.0576288,57.5978219,0.0913783,181.4466087),(28852,'zebu-tibia.tif',238,8,206,573.4683844,70.3271937,87.4308035,1.8,74.7276726,87.2854791,-0.0350558,16.9806215,28.4589687,29159.5763518,82167.4941182,0.1174086,2887.2266908,1717.2266793,3487.5031434,29.0416884,57.5393149,0.0795133,181.3127471),(28853,'zebu-tibia.tif',238,8,207,574.7853936,70.2988472,87.4376648,1.8,74.7077622,87.2969071,-0.0336355,16.4976969,28.4669641,29235.2186384,82282.3435228,0.1083396,2890.4502485,1772.0787807,3490.3950844,29.1261835,57.5579166,0.0834709,182.0145353),(28854,'zebu-tibia.tif',238,8,208,575.9928999,70.2981343,87.4306764,1.8,74.7371881,87.2740383,-0.0348695,16.2802504,28.4853117,29328.2151207,82655.1595069,0.1166763,2901.6765004,1801.4597115,3505.276933,29.1261835,57.5579166,0.0834709,181.3681944),(28855,'full set',251,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28856,'full set',251,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28857,'full set',251,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28858,'full set',251,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28859,'full set',251,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28860,'full set',251,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28861,'full set',251,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28862,'full set',251,7,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28863,'full set',251,7,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28864,'full set',251,7,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28865,'full set',251,7,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28866,'full set',251,7,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28867,'full set',251,7,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28868,'full set',251,7,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28869,'full set',251,7,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28870,'full set',251,7,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(28871,'full set',251,7,17,3.716246,86.3924268,120.1119503,1.8,85.9233954,119.5455937,0.848531,2.7533762,7.6350037,3.0568358,18.5168514,0.3486862,2.4252577,1.1102136,2.688515,3.8443347,8.7005189,2.1451012,20.4954665),(28872,'full set',251,7,18,20.0953226,85.2907399,118.9499694,1.8,85.1079022,118.7009874,0.7027766,3.6908113,7.5322068,45.8635241,240.4265266,1.39915,31.919799,12.4264072,37.3216125,6.0894985,11.2048922,2.1375255,28.7943353),(28873,'full set',251,7,19,38.9904268,85.2317469,118.7134584,1.8,85.1575117,118.432755,0.7006273,4.9906897,8.5486192,137.5392542,574.3927172,2.7009622,67.191286,27.5591675,82.135635,9.115059,15.9853176,2.5088438,42.2494601),(28874,'full set',251,7,20,46.9570083,85.312828,118.6101165,1.8,85.119596,118.2026687,0.7228713,5.3912597,9.1135711,204.1903466,763.4150647,3.4250126,83.7668418,37.8743294,104.3402492,9.9197337,16.8457425,2.4827866,44.4716229),(28875,'full set',251,7,21,49.1634699,85.2676054,118.4844312,1.8,85.1070445,118.0495729,0.7432418,5.6486344,9.5655301,248.7998412,919.8573916,3.7519394,96.1637657,44.0460164,119.744018,10.4472247,17.6381559,2.5468334,47.0065651),(28876,'full set',251,7,22,47.8140354,85.2705403,118.5309975,1.8,85.1075351,118.030741,0.7534775,5.9543464,10.1671725,257.8558952,948.1872561,3.7303001,93.2596799,43.305491,117.5498763,10.9607983,18.3210418,2.4558631,48.7253171),(28877,'full set',251,7,23,42.5533166,85.291487,118.6399458,1.8,85.059703,117.9512081,0.7497901,6.3189512,10.5762123,235.4886044,880.5576649,3.2937829,83.2583199,37.2670398,104.3865121,11.2028318,18.6555863,2.4704488,49.2287279),(28878,'full set',251,7,24,38.2290166,85.1967021,118.5133866,1.8,84.9881281,117.8504396,0.732617,6.6000981,10.7338119,209.3597261,793.1523679,2.8500802,73.8928884,31.7206989,92.9152496,11.2729137,18.9257932,2.4526683,49.8363985),(28879,'full set',251,7,25,33.9984312,84.6551135,117.5261154,1.8,84.4684884,116.8623667,0.701464,6.2710574,9.7628181,183.1974577,698.2484934,2.3598281,71.5212028,29.2131688,88.837061,10.6547435,18.7345939,2.5026787,47.5099759),(28880,'full set',251,7,26,32.5351404,84.1767226,116.830881,1.8,83.9666398,116.2439483,0.678181,6.0337785,9.057713,185.7076343,633.2857665,2.1343193,69.9167405,30.778,87.4316081,10.4585722,17.6381559,2.5468334,51.9111157),(28881,'full set',251,7,27,30.4790138,83.8374305,116.4502287,1.8,83.6468745,115.8777218,0.5896548,6.0585418,8.7397118,183.5575587,551.0656583,1.5707791,63.05307,30.2973166,82.4992984,10.4470949,16.5806127,2.5967287,58.7861237),(28882,'full set',251,7,28,29.6345752,83.7461264,116.3007747,1.8,83.5007292,115.7044026,0.5269412,5.8322368,8.8914385,187.3639985,507.8192177,1.2490981,57.1132798,32.1255816,77.0940038,10.3350959,16.3337968,2.5244013,60.8608409),(28883,'full set',251,7,29,29.5813117,83.6292782,116.0906069,1.8,83.3617616,115.5654653,0.4451662,5.4592049,8.9393239,195.051391,487.2158211,0.9141767,54.5025356,35.728901,75.9797373,10.3578716,15.9910916,2.6057814,61.4685115),(28884,'full set',251,7,30,29.5060603,83.4550713,115.9667712,1.8,83.2232484,115.4903263,0.4017531,5.3947471,8.92703,196.1606938,488.6760888,0.751944,54.7411725,36.361425,76.7090246,10.1854688,15.9910916,2.6057814,60.9651007),(28885,'full set',251,7,31,30.3543034,83.2899407,115.8189051,1.8,83.0711804,115.376334,0.3363712,5.3936758,8.9743157,200.1642753,525.1726968,0.5511437,58.5195255,37.1109207,80.8107926,10.171064,16.9549897,2.9889433,61.6770311),(28886,'full set',251,7,32,31.1229311,83.1573482,115.7440122,1.8,83.0346807,115.3335429,0.3164703,5.380646,8.8264091,203.3185662,566.4179327,0.5023977,64.1730888,37.7870175,87.2082691,10.1854688,17.0256245,2.9639965,60.8176551),(28887,'full set',251,7,33,32.952688,82.8824027,115.5309013,1.8,82.9375541,115.216991,0.3167897,5.2635835,8.6326082,208.7570762,630.5403624,0.5329724,73.0416981,39.6606376,97.1739891,10.1854688,17.1982588,2.9147938,59.6023139),(28888,'full set',251,7,34,34.0943278,82.7357735,115.4263078,1.8,82.844001,115.1888424,0.3284067,5.2078104,8.4627182,215.2091645,631.9425257,0.5911333,74.6737051,41.324309,100.0930134,10.3628798,17.1982588,2.9147938,58.3869727),(28889,'full set',251,7,35,35.7888559,82.6558626,115.3904406,1.8,82.7982158,115.1510604,0.3466362,5.1965732,8.3762514,226.2508086,614.9419602,0.6884616,73.4149358,43.5384623,99.3840897,10.3628798,17.1982588,2.9147938,46.5031543),(28890,'full set',251,7,36,37.8000554,82.5475196,115.2881767,1.8,82.6897987,115.135052,0.3510835,4.989023,8.2391057,235.7866434,610.9221612,0.7451513,74.1490864,47.2610854,99.0125902,10.1865597,17.1067638,2.939271,45.0361077),(28891,'full set',251,7,37,37.4343167,82.6771579,115.2409024,1.8,82.6464732,115.1374966,0.3424185,4.9051533,8.2019018,237.2078132,557.0732056,0.7033841,67.9200046,48.3588992,96.6216551,10.3280525,16.7798528,2.9090357,43.3173557),(28892,'full set',251,7,38,35.2415625,82.8213127,115.4408107,1.8,82.7085027,115.2199521,0.3075738,4.9387595,8.4141021,230.2388116,531.5301903,0.5383493,63.17135,46.6187538,90.5255702,10.185768,16.8840595,2.8842689,43.3173557),(28893,'full set',251,7,39,33.9846118,82.8488358,115.5895779,1.8,82.6798134,115.3124114,0.2731185,4.9903468,8.1820176,223.8302798,504.1873286,0.412105,61.6213938,44.8526501,88.5176767,10.3052371,16.5861794,2.8526172,42.7096851),(28894,'full set',251,7,40,33.2554841,82.8939307,115.6425607,1.8,82.7625869,115.3616986,0.2502623,4.8557633,7.8012999,224.8427999,476.2496117,0.3399516,61.0474686,46.3043167,88.8769605,10.1854688,15.898456,2.8112953,41.4943439),(28895,'full set',251,7,41,31.3049892,82.8640576,115.7172192,1.8,82.8323386,115.4700655,0.2333185,4.9399834,7.438436,215.8579814,412.3070455,0.278911,55.4292657,43.6960941,84.1951249,10.1705519,14.9467204,2.8198421,39.6713321),(28896,'full set',251,7,42,30.7168531,82.6598025,115.8236783,1.8,82.5933038,115.5804795,0.2618049,5.0873223,6.9810439,209.2599893,372.6739162,0.3429539,53.3836948,41.1336214,83.3492463,10.2544431,14.283491,2.772259,38.4559909),(28897,'full set',251,7,43,28.7941649,82.5163317,115.9164012,1.8,82.453258,115.6481833,0.2914291,5.0859215,6.5569206,195.2205357,332.9088023,0.3961768,50.7721264,38.3844965,80.2957957,10.1865597,13.4582233,2.8501359,36.8414987),(28898,'full set',251,7,44,27.9115691,82.3600395,116.0065508,1.8,82.2719242,115.76733,0.2823916,4.9287417,6.2736407,187.7808453,305.4567087,0.3612114,48.6889073,38.099145,78.4023595,9.882824,13.047241,2.8406724,35.6261575),(28899,'full set',251,7,45,26.397029,82.1635668,116.131066,1.8,82.1306338,115.9254213,0.2617043,5.0975954,5.8490805,180.1306597,257.205421,0.2945018,43.9736503,35.3363977,74.1237562,9.7227296,12.1306029,2.741352,34.1591109),(28900,'full set',251,7,46,25.5664658,82.0168202,116.1973205,1.8,82.0253096,116.0145073,0.2139721,5.0813023,5.7184687,177.7333554,239.9667156,0.1921301,41.963457,34.9779141,72.003232,9.882824,11.7360686,2.7270858,34.0548511),(28901,'full set',251,7,47,25.3749522,81.8679794,116.2805314,1.8,81.9150991,116.0947087,0.1523793,5.094675,5.3216248,174.2444627,217.8165268,0.097441,40.9304556,34.2012914,71.1498805,9.7227296,11.3440887,2.7118304,33.1954751),(28902,'full set',251,7,48,25.0941441,81.7734638,116.3440754,1.8,81.8214949,116.2062689,0.061726,4.7407288,5.0997167,171.901794,206.9894075,0.0159149,40.5884129,36.2606264,69.4690346,9.453136,11.171888,2.7468015,32.2318393),(28903,'full set',251,7,49,25.891026,81.7198244,116.5065621,1.8,81.7426332,116.3490436,-0.0591916,4.809396,5.0972944,169.99313,201.5931894,0.0151012,39.5490577,35.3460456,70.2525554,9.453136,10.7765202,2.7314653,32.2318393),(28904,'full set',251,7,50,26.6946219,81.6482119,116.603705,1.8,81.6393814,116.4427708,-0.1764366,4.810305,4.8998519,169.2438429,196.7978663,0.1370689,40.1640438,35.183599,69.5086115,9.3782866,10.6125107,2.5872852,31.6241687),(28905,'full set',251,7,51,27.4126716,81.5971257,116.6205793,1.8,81.611271,116.452141,-0.2901904,4.5184573,4.8667274,167.7698772,192.5663113,0.3740597,39.5679263,37.1299019,71.333373,9.3134825,10.3838797,2.7149652,31.3724633),(28906,'full set',251,7,52,27.2753727,81.5493801,116.7777223,1.8,81.5181533,116.6257761,-0.2902061,4.6553592,4.7151907,164.1916821,187.7137347,0.3722255,39.8104223,35.2693907,69.4267099,9.3767439,10.2135672,2.7532739,31.1207579),(28907,'full set',251,7,53,26.7709923,81.458908,116.8981304,1.8,81.4000357,116.7245237,-0.3672227,4.5836594,4.7129163,156.0152448,179.6642477,0.5751244,38.121672,34.037268,68.9531479,9.2257488,10.0219602,0.5404195,30.5130873),(28908,'full set',251,7,54,26.5475878,81.3829096,116.9691837,1.8,81.3660266,116.8398402,-0.4769486,4.3998764,4.6941115,150.3027971,174.8645237,0.932465,37.25189,34.1606865,67.4278078,9.023448,9.9942879,1.1263771,29.6537113),(28909,'full set',251,7,55,26.5549171,81.3164109,117.0779651,1.8,81.2589468,116.9323247,-0.5519358,4.4221267,4.6613831,143.7071589,172.0408385,1.2167854,36.9076806,32.4972957,66.0532413,8.9389886,9.8172189,0.4048918,29.9054167),(28910,'full set',251,7,56,26.7098959,81.2481372,117.1274321,1.8,81.1863904,117.0707287,-0.5581678,4.3780055,4.5435672,141.2031239,172.7280394,1.248737,38.0159534,32.2528429,67.8179174,8.9389886,9.807811,1.0679531,29.6537113),(28911,'full set',251,7,57,26.7489484,81.2117977,117.2079441,1.8,81.1836051,117.1372152,-0.5709672,4.3337899,4.5971985,137.0930086,172.8377659,1.3021475,37.5963242,31.6335149,65.3995644,8.7947143,9.8172189,0.4048918,29.4020059),(28912,'full set',251,7,58,27.0860972,81.1903784,117.290291,1.8,81.1283997,117.2236941,-0.5810739,4.265025,4.6569611,134.4028593,176.6379879,1.3602424,37.9298824,31.5127953,65.803205,8.7278627,9.8921606,0.6000502,29.6537113),(28913,'full set',251,7,59,27.6476575,81.1988742,117.3964157,1.8,81.079281,117.3003325,-0.5968681,4.3611309,4.6999551,132.1000992,177.7825385,1.4556752,37.8264333,30.2903314,64.8762179,8.7512133,10.0219602,1.0303768,29.6537113),(28914,'full set',251,7,60,27.2647424,81.1326614,117.4959675,1.8,81.0212405,117.4232539,-0.575002,4.2978187,4.6045852,130.1391175,175.039932,1.3439614,38.0142668,30.2802714,64.0651525,8.7677591,9.8921606,0.9707461,29.6537113),(28915,'full set',251,7,61,26.9679888,81.0659378,117.5756752,1.8,80.9724863,117.5418405,-0.5742735,4.2017549,4.6828835,125.1382711,176.138809,1.3263458,37.6133232,29.7823826,63.6795742,8.5073884,10.0219602,1.0303768,29.0460407),(28916,'full set',251,7,62,26.8636998,80.9781761,117.6427541,1.8,80.9453239,117.5841971,-0.5896915,4.2030748,4.6721146,124.8454763,175.1789992,1.3846106,37.4945851,29.7033674,62.083982,8.5073884,10.0219602,1.0303768,29.0460407),(28917,'full set',251,7,63,26.9395107,80.9015895,117.7009928,1.8,80.9119206,117.6540404,-0.6183312,4.1050987,4.5752168,124.7982719,172.1583879,1.5087225,37.6284654,30.400797,61.8725357,8.5073884,9.8921606,0.9707461,29.0460407),(28918,'full set',251,7,64,26.9254116,80.7878538,117.7727737,1.8,80.7404934,117.7647717,-0.6530434,4.0814524,4.6198813,123.4024637,170.3245036,1.6567452,36.8677225,30.2349391,62.8146938,8.5073884,9.8921606,0.9707461,29.0460407),(28919,'full set',251,7,65,26.4621537,80.6815308,117.8796525,1.8,80.6652969,117.8364453,-0.6616715,4.0853368,4.6531221,120.0503089,163.870959,1.6650522,35.2174209,29.3856574,58.8569897,8.5073884,10.0219602,1.0303768,28.3341103),(28920,'full set',251,7,66,26.104024,80.5853096,117.9356273,1.8,80.6062859,117.9191187,-0.7020081,4.0356995,4.56908,118.239745,161.342864,1.8142121,35.3118928,29.2984511,59.5427183,8.5073884,9.807811,1.0679531,28.4383701),(28921,'full set',251,7,67,26.0770006,80.5244015,117.9925774,1.8,80.5225903,118.010516,-0.7522505,4.0053136,4.6152967,115.1845871,161.5306767,2.0291236,34.9989799,28.7579446,57.9470429,8.4670327,9.8921606,0.9707461,29.0460407),(28922,'full set',251,7,68,26.2156423,80.4757912,118.0600195,1.8,80.442945,118.0933723,-0.7574226,3.9833986,6.7755452,114.6668188,160.5888732,2.0624677,23.7012473,28.7861776,37.9149153,8.4670327,9.8921606,0.9707461,29.0460407),(28923,'full set',251,7,69,25.7885834,80.4244512,118.2007505,1.8,80.3890909,118.2244214,-0.7189821,3.9665264,4.5369422,111.9862158,152.0838222,1.8644246,33.5212165,28.2328174,56.929765,8.2035531,9.6560368,1.0074801,28.1866647),(28924,'full set',251,7,70,25.1543452,80.3083617,118.3263998,1.8,80.3200123,118.3324112,-0.7383019,3.9261737,4.4187729,111.4775286,143.6940747,1.8990415,32.519,28.3934274,55.6304526,8.2035531,9.6081158,1.1071487,27.5789941),(28925,'full set',251,7,71,25.1141738,80.2772028,118.438119,1.8,80.2334085,118.3990295,-0.6992814,3.9564442,4.3334811,110.5052651,138.7240496,1.7341686,32.0121507,27.9304494,55.2285286,8.2035531,9.4335845,1.0460006,27.5789941),(28926,'full set',251,7,72,24.7434556,80.2035441,118.5323433,1.8,80.1701211,118.5006224,-0.6920957,3.9419117,4.3099507,110.3290665,135.0748229,1.6794131,31.3402248,27.9887206,54.8691229,8.2035531,9.4335845,1.0460006,27.9349593),(28927,'full set',251,7,73,24.3175157,80.136685,118.6425841,1.8,80.1334551,118.6006019,-0.7140686,3.9440975,4.1991232,109.9259571,128.6202199,1.7383464,30.6302562,27.8710039,53.2896083,8.2035531,9.3845276,1.2924967,27.6832539),(28928,'full set',251,7,74,24.2187097,80.0813732,118.7073704,1.8,80.0685674,118.6646601,-0.6990937,3.9790356,4.2412577,110.2897733,125.7246683,1.6715892,29.6432514,27.7177143,53.0375854,8.2035531,9.2557628,1.1902899,27.3272887),(28929,'full set',251,7,75,23.9375659,80.0659683,118.787041,1.8,80.0371244,118.7468569,-0.6942881,3.9820547,4.0846183,109.3871446,121.7943938,1.6333131,29.8178155,27.4700256,53.0838577,8.2035531,9.2557628,1.1902899,27.0755833),(28930,'full set',251,7,76,23.903437,80.0160418,118.8372487,1.8,79.9596299,118.8010284,-0.7044892,3.9786742,4.1538464,109.5238269,120.605681,1.6710243,29.034699,27.5277193,52.0657355,8.164072,9.2557628,1.1902899,26.9713235),(28931,'full set',251,7,77,23.7089582,79.9755188,118.9116052,1.8,79.8998892,118.891103,-0.7636718,4.0125709,4.1365739,108.7050187,118.4080525,1.8899219,28.6246674,27.0911145,51.2063193,8.164072,9.2756891,1.3370531,27.5789941),(28932,'full set',251,7,78,23.6425467,79.9226147,118.9539155,1.8,79.8569156,118.970507,-0.8088513,3.9750177,4.0352443,108.2896649,117.9515078,2.0625937,29.2303266,27.2425616,50.8358167,8.164072,9.2756891,1.3370531,27.3272887),(28933,'full set',251,7,79,23.131844,79.8900619,119.0122166,1.8,79.8923943,118.9766061,-0.9023698,3.9262472,4.1110226,105.1454934,115.7505031,2.3745129,28.1561341,26.7801508,50.3525817,8.164072,9.2756891,1.3370531,27.3272887),(28934,'full set',251,7,80,22.9425684,79.8442722,119.0480593,1.8,79.8767377,119.0427119,-0.9960709,4.0012374,4.2445053,104.8406291,114.5564499,2.693818,26.9893528,26.202052,49.4047518,8.164072,9.2756891,1.3370531,27.3272887),(28935,'full set',251,7,81,22.5236222,79.8026605,119.1096227,1.8,79.7852491,119.1620705,-1.0907544,3.9593306,4.275119,103.4054489,112.0316576,2.9533186,26.2055065,26.116902,49.135509,8.164072,9.1856803,1.3825748,27.3272887),(28936,'full set',251,7,82,22.3458721,79.7580388,119.1490342,1.8,79.7698973,119.184488,-1.1287874,3.9524282,4.2518071,103.4735329,111.422099,3.0428548,26.2058215,26.1797376,49.7386456,8.164072,9.1049255,1.9074711,26.9713235),(28937,'full set',251,7,83,22.2129932,79.7196243,119.185646,1.8,79.7500928,119.1919435,-1.2839917,3.9790123,4.3948892,103.3137675,110.8790247,3.4058956,25.2290831,25.9646767,48.634797,8.164072,9.2557628,1.1902899,26.9713235),(28938,'full set',251,7,84,22.2138884,79.6676365,119.2303822,1.8,79.720496,119.2339627,-1.4237699,4.1097082,4.2604799,103.882836,111.1507493,3.6228576,26.0887862,25.2774238,49.1889068,8.2649378,9.1049255,1.9074711,27.3272887),(28939,'full set',251,7,85,22.0294244,79.641625,119.2766596,1.8,79.6498323,119.2634851,-1.5643844,4.1458271,4.4743501,102.4269599,110.772546,3.6714198,24.7572372,24.7060378,47.6319522,8.2638469,9.2557628,1.9513027,27.6832539),(28940,'full set',251,7,86,22.0493982,79.6100681,119.3220815,1.8,79.6390901,119.3386805,1.4955143,3.9835596,4.438979,102.4067978,111.9345282,3.654112,25.2162781,25.7073593,48.0394362,8.164072,9.2756891,1.3370531,27.3272887),(28941,'full set',251,7,87,22.030991,79.5981326,119.3868808,1.8,79.6204642,119.3539664,1.4089144,3.9784845,4.4276664,101.6053347,112.620335,3.5764463,25.4355964,25.538703,48.3814105,8.164072,9.2756891,1.8045395,27.3272887),(28942,'full set',251,7,88,22.2190357,79.5792195,119.43777,1.8,79.5650784,119.3840168,1.3348134,4.0737024,4.3839748,102.3295092,113.9519592,3.5007503,25.9928407,25.1195345,49.3261631,8.164072,9.2756891,1.8045395,27.0755833),(28943,'full set',251,7,89,22.2825938,79.5601933,119.5111695,1.8,79.5879595,119.4550036,1.4021712,4.0435627,4.4486434,102.1861131,115.4125472,3.6091639,25.9433126,25.2713066,48.8720246,8.164072,9.3845276,1.849096,27.0755833),(28944,'full set',251,7,90,21.8946992,79.5370382,119.5104638,1.8,79.564187,119.4620331,1.3889287,4.0806033,4.4457984,102.4526006,114.8540569,3.5297439,25.8342925,25.1072192,48.8663194,8.164072,9.3845276,1.849096,27.3272887),(28945,'full set',251,7,91,21.6155136,79.572329,119.5560073,1.8,79.5831084,119.4969315,1.3314613,4.1109912,4.4969126,101.6013816,115.1588805,3.4001352,25.608432,24.7145702,48.1817922,8.164072,9.3845276,1.849096,27.5789941),(28946,'full set',251,7,92,21.8568217,79.5797881,119.5865373,1.8,79.5792614,119.5611209,1.3108391,4.1287334,4.5246908,103.067146,116.4923004,3.4021266,25.7459142,24.9633813,48.4655692,8.164072,9.3845276,1.849096,27.5789941),(28947,'full set',251,7,93,22.1411546,79.6049849,119.5938161,1.8,79.594918,119.5524228,1.320206,4.0982828,4.5398869,103.8712802,118.723084,3.463275,26.1511104,25.3450739,49.0009032,8.164072,9.3845276,1.849096,27.5789941),(28948,'full set',251,7,94,22.4671696,79.6069234,119.6435331,1.8,79.5945042,119.5762795,1.3002017,4.1262912,4.584231,105.3467865,121.8714052,3.4769753,26.5849182,25.5306232,49.4851194,8.164072,9.5115493,1.8925469,27.5789941),(28949,'full set',251,7,95,22.4409855,79.6367713,119.6640109,1.8,79.6125926,119.5615454,1.2778537,4.12129,4.6054817,105.6218219,124.0584093,3.4282775,26.937119,25.62834,49.7352535,8.164072,9.5115493,1.8925469,27.5789941),(28950,'full set',251,7,96,22.2825938,79.6136872,119.6720266,1.8,79.5979694,119.5641512,1.2387,4.1727979,4.5886726,105.9244787,125.2865309,3.3190197,27.3034367,25.3845215,50.035637,8.164072,9.5115493,1.8925469,27.5789941),(28951,'full set',251,7,97,22.0976263,79.6279033,119.6663064,1.8,79.5931784,119.5715587,1.2146387,4.170958,4.5738273,105.2937739,126.7661642,3.2351859,27.7155553,25.2445061,50.2470551,8.164072,9.6081158,1.7506498,27.9349593),(28952,'full set',251,7,98,22.0621546,79.6190367,119.6802895,1.8,79.6039989,119.5856079,1.1928236,4.1944795,4.5685037,106.3770343,127.98201,3.1762578,28.0139883,25.3612003,50.6159946,8.164072,9.6081158,1.7506498,28.1866647),(28953,'full set',251,7,99,21.8732148,79.6560444,119.700524,1.8,79.6952822,119.5598402,1.1865971,4.170338,4.5963574,106.7162576,129.3011793,3.133383,28.1312285,25.5893544,50.6703621,8.59376,9.6081158,1.7506498,28.7943353),(28954,'full set',251,7,100,21.8973847,79.6427637,119.7066759,1.8,79.7204477,119.5781733,1.190549,4.2632424,4.6000872,108.2887468,131.1743322,3.1468278,28.5156189,25.4005603,51.3758409,8.59376,9.6942031,1.7942729,28.7943353),(28955,'full set',251,7,101,22.0169478,79.6482218,119.6669495,1.8,79.7263513,119.5636119,1.1963384,4.2464878,4.7265475,109.123736,135.296952,3.1785637,28.6249007,25.6974094,51.6050182,8.59376,9.8172189,1.9756881,28.7943353),(28956,'full set',251,7,102,22.2611093,79.6293393,119.631916,1.8,79.7560653,119.574373,1.2009238,4.4090806,4.6884058,111.4729521,138.7748438,3.2253386,29.59958,25.2825841,53.2753148,8.59376,9.8172189,1.9756881,28.7943353),(28957,'full set',251,7,103,22.4532942,79.6578918,119.6089516,1.8,79.7573366,119.542165,1.2128527,4.3755925,4.6800047,113.9211721,141.4080238,3.2828799,30.2153596,26.0355993,54.5089624,8.59376,9.8172189,1.9756881,28.7943353),(28958,'full set',251,7,104,22.2047687,79.6811576,119.6241377,1.8,79.7434822,119.5739072,1.2336799,4.3596723,4.7051291,115.7436301,141.4960759,3.2959021,30.0727297,26.5486998,54.6636771,8.59376,9.9201178,1.8788491,28.7943353),(28959,'full set',251,7,105,22.0844223,79.7079295,119.5805351,1.8,79.7678051,119.5155852,1.2283061,4.4641547,4.6926644,117.3526016,142.6352302,3.2656077,30.3953615,26.2877544,55.0483879,8.59376,9.9201178,1.8788491,29.2977461),(28960,'full set',251,7,106,21.9932254,79.7097332,119.5681786,1.8,79.8019797,119.5002865,1.2075473,4.4647591,4.6914881,119.9996664,143.5100557,3.2027729,30.5894532,26.877075,55.6570933,9.023448,9.9201178,1.8788491,29.6537113),(28961,'full set',251,7,107,21.8368479,79.7592201,119.5578503,1.8,79.8660606,119.4995872,1.155862,4.4697983,4.6552418,120.2722071,144.9029126,3.0480103,31.1268281,26.9077481,56.0191527,8.8112237,9.9201178,1.8788491,29.6537113),(28962,'full set',251,7,108,21.8376871,79.7762129,119.5211849,1.8,79.8676753,119.439303,1.1723924,4.5584908,4.6837266,121.8296931,147.0137124,3.0918398,31.3881926,26.7258832,56.4104343,8.8112237,9.9201178,1.8788491,29.6537113),(28963,'full set',251,7,109,21.7713875,79.8605783,119.4803464,1.8,79.9189313,119.4426357,1.1758908,4.5291755,4.7913316,123.8199472,148.1308832,3.0914998,30.9164329,27.3382976,56.5650216,8.8112237,10.0219602,2.1112158,29.6537113),(28964,'full set',251,7,110,21.762156,79.867049,119.4499035,1.8,79.9129536,119.3691293,1.1646899,4.6754897,4.8208891,126.1973953,151.2820172,3.0610178,31.3805221,26.991268,57.4270536,9.023448,10.1864154,2.0533096,30.2613819),(28965,'full set',251,7,111,21.8859711,79.9044884,119.404595,1.8,79.9790594,119.3601149,1.138479,4.6171516,4.8833127,130.3323465,154.4985613,3.0073479,31.6380643,28.2278681,57.5328583,9.115059,10.2135672,1.8259787,30.6173471),(28966,'full set',251,7,112,21.8894959,79.934049,119.3752164,1.8,79.9802308,119.3221727,1.1327264,4.7584391,4.8926122,133.5696511,156.639504,2.9917861,32.0155157,28.0700558,58.3755054,9.115059,10.3304002,1.8662372,30.8690525),(28967,'full set',251,7,113,22.0466567,80.0001244,119.3191308,1.8,80.0541797,119.2750656,1.1544933,4.7184248,4.9352188,137.8904505,159.815036,3.0735803,32.3825632,29.2238313,59.4309981,9.4188943,10.3304002,1.8662372,31.1207579),(28968,'full set',251,7,114,22.14619,80.0243759,119.2749235,1.8,80.0969734,119.2469568,1.1422117,4.8460975,4.9544385,141.3298787,162.8731024,3.0535537,32.8741802,29.1636475,60.2810366,9.4188943,10.3304002,1.8662372,31.1207579),(28969,'full set',251,7,115,22.5368821,80.0503791,119.2229722,1.8,80.0932905,119.2418741,1.0947084,4.9659154,4.9614692,146.0812402,166.7639922,2.9671906,33.6118166,29.4167798,61.4514832,9.4188943,10.3304002,1.8662372,31.1207579),(28970,'full set',251,7,116,22.8624494,80.0837285,119.1813049,1.8,80.1388325,119.1650094,1.0071103,4.9571646,5.0194521,152.2710069,170.7129268,2.7226035,34.0102709,30.7173597,63.0327022,9.7227296,10.4635866,1.9055332,31.9801339),(28971,'full set',251,7,117,23.4884071,80.1868054,119.1653721,1.8,80.2507052,119.1801792,0.8408628,4.8521407,5.2120443,158.4236194,179.447274,2.1740517,34.4293457,32.6502523,64.6288913,9.7227296,10.7422,2.2142974,32.2318393),(28972,'full set',251,7,118,23.3540176,80.209256,119.1487521,1.8,80.2823929,119.2082777,0.7122515,5.0361742,5.2439763,160.4401211,184.2397099,1.6624711,35.1335891,31.8575401,65.1188096,9.882824,10.7422,2.2142974,32.4835447),(28973,'full set',251,7,119,24.3429166,80.3291391,119.1393947,1.8,80.4581702,119.2450771,0.6583942,5.0045664,5.3719338,166.9238447,195.8554966,1.5188248,36.4590305,33.3543068,67.1322979,9.882824,10.9549375,2.300696,33.0912153),(28974,'full set',251,7,120,24.4334421,80.3642827,119.127923,1.8,80.5373092,119.2325818,0.5865575,5.0855642,5.4130379,168.1448148,203.2265365,1.2475683,37.5438968,33.0631581,68.4158817,10.0148917,11.0889478,2.1910458,33.4471805),(28975,'full set',251,7,121,25.2474444,80.5123665,119.1201348,1.8,80.6069942,119.1878023,0.5012091,5.0506727,5.4030864,175.6901756,215.362609,0.9714672,39.8591826,34.7855001,71.9448565,10.0265649,11.0889478,2.1910458,33.8031457),(28976,'full set',251,7,122,25.5649551,80.5906239,119.1257044,1.8,80.6686752,119.1749057,0.5058769,5.1897458,5.501204,178.7724593,225.9661003,1.0004956,41.0757538,34.4472476,73.1161836,10.0265649,11.3522236,2.6271413,34.0548511),(28977,'full set',251,7,123,25.9918462,80.6545981,119.1318427,1.8,80.716785,119.2056113,0.4986281,5.1623015,5.6489975,179.3391375,234.1934706,0.990703,41.4575277,34.7401517,73.1463238,10.0265649,11.5697035,2.5948038,34.0548511),(28978,'full set',251,7,124,26.034815,80.6555848,119.1659195,1.8,80.7477254,119.176961,0.5189141,5.35582,5.6346534,180.0352004,237.7542618,1.0672277,42.1950106,33.6148716,74.1386212,10.312512,11.5697035,2.5948038,34.3065565),(28979,'full set',251,7,125,26.4719447,80.7489792,119.1504016,1.8,80.8643755,119.1325548,0.5390641,5.5051836,5.7835467,185.3047804,245.4888524,1.1626073,42.4460742,33.6600546,74.3100801,10.3304002,11.7988288,2.5636907,34.9142271),(28980,'full set',251,7,126,27.0887827,80.7719536,119.1663637,1.8,80.8646405,119.0946828,0.5469727,5.5846767,5.7585911,187.9376572,253.4282185,1.2212893,44.0087192,33.6523789,76.5029199,10.6077394,11.7988288,2.5636907,35.5218977),(28981,'full set',251,7,127,27.9708191,80.8616813,119.1619315,1.8,80.9932977,119.0861987,0.5257009,5.6770902,5.6744381,196.7739984,257.2921176,1.1739477,45.3423075,34.661066,79.6829937,10.62025,11.7988288,2.1486983,35.8778629),(28982,'full set',251,7,128,28.756735,80.8973448,119.079435,1.8,80.996188,118.9902381,0.5498301,5.8131871,5.6980838,207.7633075,266.3812753,1.3086737,46.7492731,35.74,81.430177,10.7422,12.0389346,2.1785983,36.7372389),(28983,'full set',251,7,129,30.0736072,81.0506242,119.011976,1.8,81.1322559,118.9949301,0.4233341,5.8155055,5.8244128,218.4059266,277.0829336,0.8458639,47.5726815,37.5557937,83.5432437,10.7422,12.1001239,3.034857,37.3449095),(28984,'full set',251,7,130,31.4192931,81.1460474,119.0087014,1.8,81.2388353,118.9629142,0.3657745,5.9003205,5.9188495,227.3155583,285.2248914,0.6699104,48.1892453,38.5259678,85.2773926,10.7422,12.1534119,2.9996956,37.3449095),(28985,'full set',251,7,131,34.0628844,81.3687529,118.9996094,1.8,81.4502901,118.8982503,0.2656129,5.889494,6.0999207,240.4919133,308.1610868,0.391193,50.5188676,40.8340535,88.6830755,11.0794094,12.2291349,2.8198421,37.9525801),(28986,'full set',251,7,132,37.1315205,81.5307689,118.9728862,1.8,81.5538258,118.8577595,0.2334447,6.0069458,6.2511977,254.6904885,336.7219225,0.3311737,53.865185,42.3993316,93.1843108,11.171888,12.5789281,3.0045265,38.6645105),(28987,'full set',251,7,133,43.0474024,81.8094267,118.9263332,1.8,81.7592283,118.8079674,0.1750711,5.8993126,6.4470796,278.2083759,396.788426,0.2176623,61.5454516,47.1594562,103.5965269,11.171888,12.9263977,2.8724252,38.8119561),(28988,'full set',251,7,134,49.8584127,81.9473581,118.8555385,1.8,81.8997202,118.771997,0.1315455,6.0950165,6.4710497,315.8037012,453.4031611,0.1429659,70.0664011,51.8134282,118.1637101,11.601576,13.145925,2.9441971,39.7755919),(28989,'full set',251,7,135,61.4706885,82.1996753,118.705828,1.8,82.303016,118.7876163,0.2245674,6.4233507,6.7214849,402.1840684,568.8213386,0.5080394,84.6273321,62.6128152,139.0685605,12.1368787,14.0488921,2.7326848,42.1020145),(28990,'full set',251,7,136,71.0254949,82.5136697,118.6471084,1.8,82.5710986,118.6049056,0.3529039,6.5388953,7.2050675,488.2555746,718.8016034,1.4140711,99.763341,74.6694288,166.0831668,12.1534119,14.6850235,2.782822,43.0656503),(28991,'full set',251,7,137,80.1892735,82.8148772,118.1772017,1.8,83.0629194,118.1344403,0.6797897,7.177872,7.8589489,647.6895735,985.9659194,5.2814665,125.4577336,90.2342045,193.2662846,13.497242,16.1061369,2.9808299,48.5346857),(28992,'full set',251,7,138,90.8848246,83.7542987,117.5849276,1.8,84.0836463,117.4222805,0.4213193,8.6392846,9.2466301,1039.1050026,1387.1422021,2.5334473,150.0159718,120.2767412,252.8276473,15.4380614,18.2958305,0.1651487,57.3369652),(28993,'full set',251,7,139,94.6333532,84.150775,117.1193415,1.8,84.4265556,116.9821824,0.4258683,9.4281179,10.0262572,1359.6259234,1611.2555322,2.6917078,160.7035905,144.209686,290.6662643,16.4071061,18.7936316,0.1839435,60.878729),(28994,'full set',251,7,140,92.3575147,84.4868309,117.0486158,1.8,84.4891124,116.8765755,0.3695696,9.7461603,10.2349446,1401.1119406,1714.6202545,2.0084008,167.5260908,143.7604038,301.6678323,16.7109414,19.4549516,0.1106572,62.0940702),(28995,'full set',251,7,141,88.5311051,84.6528246,117.1052486,1.8,84.6555858,116.8197947,0.2497627,10.1167064,10.568739,1420.9921871,1737.0139855,0.9014681,164.3539479,140.459961,298.7068678,17.0147767,19.8820682,3.0333221,64.316233),(28996,'full set',251,7,142,84.9528293,84.5156667,117.0719334,1.8,84.7784165,116.8188544,0.2278232,10.1403218,10.7133177,1367.4583833,1740.8627699,0.7222636,162.4952061,134.8535485,290.134228,16.7109414,19.6391391,2.965653,64.0645276),(28997,'full set',251,7,143,69.213306,84.9876031,116.9530102,1.8,84.8856317,116.7957205,0.3425336,9.7011284,10.3781478,1204.2568385,1493.7159001,1.3013456,143.9289491,124.1357493,259.5474735,16.2537074,19.5685029,2.9872739,64.4204928),(28998,'full set',251,7,144,63.8479625,85.1591552,116.8163764,1.8,84.9747806,116.8074999,0.4776892,9.0822281,10.1144569,1085.1054241,1353.3403402,2.2490454,133.8025717,119.4756853,237.4247582,16.1032708,19.2977277,2.9398303,64.4204928),(28999,'full set',251,7,145,60.4883356,85.2242527,116.7699509,1.8,85.0307634,116.7730109,0.6345105,8.2060566,9.5956375,926.3044393,1218.9388803,3.5425202,127.0305262,112.880581,214.648854,15.4956002,19.0279509,3.0284417,63.3094114),(29000,'full set',251,7,146,57.0244756,85.1516733,116.7183985,1.8,85.0156914,116.8050102,0.7048845,7.5901782,9.4243807,802.6452764,1079.5536905,3.9901342,114.5490329,105.7478832,190.1376741,14.8879296,18.4565877,2.9304993,61.9898104),(29001,'full set',251,7,147,52.9079702,85.2029015,116.777459,1.8,85.0836946,116.8408206,0.7774571,6.8719367,8.8171461,615.0593546,937.9144076,4.3389758,106.3739221,89.5030589,164.7702886,14.0154874,17.7164901,2.896614,59.2031628),(29002,'full set',251,7,148,48.7445796,85.2264432,116.820628,1.8,85.0619988,116.8863258,0.8215736,6.4024829,8.3528747,465.9727879,824.9898097,4.3556848,98.7671723,72.7800125,143.7022176,13.2386494,16.8840595,2.8842689,55.5571393),(29003,'full set',251,7,149,40.4054336,85.2272445,116.7598708,1.8,85.1270522,116.9204765,0.8930744,5.7481315,7.7197092,272.4293535,637.1425813,4.0866451,82.5345317,47.3944194,108.590678,11.751219,15.6408793,2.7763912,51.0517397),(29004,'full set',251,7,150,30.3228041,85.3058729,116.6774891,1.8,85.1641616,116.9353809,0.8926694,5.1904382,7.4006746,153.6413901,490.7711757,3.0648783,66.3143837,29.6008513,82.7052002,10.4007946,14.6850235,2.782822,48.6210573),(29005,'full set',251,7,151,15.4017031,85.5463197,116.9112445,1.8,85.3731079,117.0486963,0.900661,3.7819509,6.3209929,35.0317681,243.4878749,1.5767357,38.5205106,9.2628828,43.566812,4.2536942,7.9230552,0.8621701,19.3843851),(29006,'full set',251,7,152,3.1580426,86.988324,118.6247948,1.8,86.2882649,117.7987183,0.9292658,2.0218762,7.015957,2.2179521,34.3336461,0.337853,4.8936512,1.0969772,5.1832319,3.3977511,4.4239087,0.5070985,11.3372218),(29007,'full set',251,7,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29008,'full set',251,7,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29009,'full set',251,7,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29010,'full set',251,7,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29011,'full set',251,7,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29012,'full set',251,7,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29013,'full set',251,7,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29014,'full set',251,7,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29015,'full set',251,7,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29016,'full set',251,7,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29017,'full set',251,7,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29018,'full set',251,7,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29019,'full set',251,7,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29020,'full set',251,7,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29021,'full set',251,7,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29022,'full set',251,7,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29023,'full set',251,7,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29024,'full set',251,7,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29025,'full set',251,7,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29026,'full set',251,7,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29027,'full set',251,7,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29028,'full set',251,7,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29029,'full set',251,7,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29030,'full set',251,7,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29031,'full set',251,7,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29032,'full set',251,7,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29033,'full set',251,7,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29034,'full set',251,7,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29035,'full set',251,7,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29036,'full set',251,7,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29037,'full set',251,7,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29038,'full set',251,7,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29039,'full set',251,7,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29040,'full set',251,7,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29041,'full set',251,7,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29042,'full set',251,7,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29043,'full set',251,7,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29044,'full set',251,7,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29045,'full set',251,7,191,0.3276375,85.805964,124.2095492,1.8,85.7792939,124.2024472,-0.0097173,0.466455,1.5867523,0.0367334,0.2016347,0.0000052,0.1270738,0.0787501,0.1501631,1.289064,3.4642554,3.0172377,7.6911982),(29046,'full set',251,7,192,1.5802802,85.5062234,124.2727827,1.8,85.3420675,124.3381381,-0.0119988,0.7973241,3.4396084,0.2562751,5.0396342,0.0000379,1.4651767,0.321419,1.5340335,1.718752,6.9948139,0.1853479,15.7815474),(29047,'full set',251,7,193,2.9986998,84.9289472,124.299983,1.8,84.648536,124.3481634,-0.0115605,0.7955415,5.8745088,0.5060882,30.4378916,0.0000668,5.1813509,0.6361556,5.2334355,1.718752,11.7282,0.1470784,25.4863888),(29048,'full set',251,7,194,3.9189493,84.7919535,124.2966136,1.8,84.5323089,124.3136692,-0.0026886,0.9615211,7.4489278,0.6901878,70.2054029,0.0000047,9.4249004,0.7178083,9.5102081,2.14844,14.6346459,3.0828368,31.3545752),(29049,'full set',251,7,195,4.4223227,84.0360232,124.1910523,1.8,83.7772242,124.1738641,0.012444,0.9637015,8.4157705,0.7924702,109.741999,0.0001141,13.0400418,0.8223191,13.123738,2.14844,16.8073383,3.0648208,36.5108312),(29050,'full set',251,7,196,4.6122137,83.370736,124.1110077,1.8,83.3453375,124.1119865,0.0251544,1.0061665,8.6221855,0.8430371,122.8042249,0.0004863,14.2428187,0.8378703,14.3089356,2.14844,17.6643059,3.0685521,37.873618),(29051,'full set',251,7,197,4.9728052,83.1747682,123.9804606,1.8,83.1551082,123.9571279,0.053127,1.1252275,8.8841384,0.9775171,134.8856617,0.0023371,15.182751,0.8687284,15.255819,2.3720697,18.1285566,3.0466409,39.0889592),(29052,'full set',251,7,198,5.0169489,82.984536,123.9235286,1.8,83.1473135,123.940818,0.0659111,1.1641713,8.9661028,0.9703001,132.2842553,0.0036272,14.7538187,0.8334685,14.851677,2.3816108,18.1285566,3.0466409,38.8372538),(29053,'full set',251,7,199,5.0963406,82.9611206,123.8307474,1.8,82.916522,123.8297159,0.0895535,1.2355881,9.1025659,1.0219279,124.6790246,0.0067938,13.6971296,0.8270781,13.8080663,2.5808598,18.1743294,3.0231027,39.2974787),(29054,'full set',251,7,200,5.1833973,82.9480021,123.7794794,1.8,82.9403936,123.7846251,0.1020262,1.2862861,9.128926,1.0645018,119.8800141,0.0089615,13.1318858,0.8275778,13.2363793,2.6108334,18.2301179,2.9996956,39.2974787),(29055,'full set',251,7,201,5.3553846,83.0437432,123.6965267,1.8,82.8695229,123.6872628,0.1218043,1.1690745,9.2720278,1.1806337,116.2667603,0.013177,12.5395181,1.0098875,12.6452193,2.5990404,18.2958305,2.976444,39.6534439),(29056,'full set',251,7,202,5.6152118,82.8623957,123.6179277,1.8,82.6831583,123.6179323,0.1377982,1.108569,9.5737323,1.2921374,119.5280335,0.0176584,12.4849985,1.1655904,12.5856107,2.6086553,18.7936316,2.9576492,40.2611145),(29057,'full set',251,7,203,5.4563166,82.957868,123.5367165,1.8,82.622492,123.4923312,0.1573397,1.368083,9.667304,1.35515,109.8292556,0.0223274,11.3608981,0.9905466,11.4899534,2.8335669,18.3713606,2.9533711,40.0094091),(29058,'full set',251,7,204,5.3975142,82.9623696,123.499797,1.8,82.606867,123.4610812,0.1674338,1.2932499,10.0930714,1.3894251,108.1856368,0.0249843,10.7188023,1.0743671,10.853906,2.8335669,18.7936316,2.9576492,41.2247503),(29059,'full set',251,7,205,5.3335645,82.866315,123.3922457,1.8,82.4558251,123.3491019,0.1832217,1.5683239,10.0595188,1.5380684,106.5509867,0.029509,10.592056,0.9807084,10.7367208,3.1333015,18.8769524,2.9352688,41.3290101),(29060,'full set',251,7,206,5.2569143,82.7871705,123.3250063,1.8,82.3836143,123.2609209,0.1986012,1.7970592,10.3947752,1.6685609,105.5195115,0.0341056,10.1512067,0.9284952,10.3112081,3.4151613,19.2977277,2.9398303,43.2562817),(29061,'full set',251,7,207,4.942257,82.7236009,123.2377386,1.8,82.3040508,123.1539519,0.2112578,1.8524582,10.4049068,1.7213205,99.6864616,0.0362184,9.5807164,0.9292088,9.7415228,3.4933998,19.0715653,2.8911496,43.1520219),(29062,'full set',251,7,208,4.8464723,82.4921742,123.13125,1.8,81.9055591,123.02589,0.2197905,2.0967508,10.251871,1.9308209,100.6299125,0.0383961,9.8157607,0.9208633,9.9871328,3.8109068,19.0715653,2.8911496,43.0045763),(29063,'full set',251,7,209,4.8025523,82.36981,122.998623,1.8,81.9437051,122.9596283,0.2326921,2.0491262,10.428103,2.2183962,99.0181114,0.0425629,9.4953139,1.082606,9.7070082,3.8109068,19.3884063,2.9181161,43.8639523),(29064,'full set',251,7,210,4.6621202,82.2580819,122.927947,1.8,81.708281,122.8583387,0.2389415,2.4055855,10.4033615,2.4622128,96.6835252,0.0435246,9.293489,1.0235399,9.5290707,4.2287225,16.7798528,2.9090357,38.1432115),(29065,'full set',251,7,211,4.4386039,82.2876433,122.8709066,1.8,81.7690684,122.8265938,0.2475471,2.4225024,10.419016,2.6088173,91.4370516,0.0444142,8.7759776,1.0769101,9.0263664,4.2754366,16.2658334,2.9286543,37.2838355),(29066,'full set',251,7,212,4.3503163,82.289007,122.8203921,1.8,81.8956682,122.8048304,0.2568349,2.7645553,10.407105,2.8734879,86.0296968,0.0467851,8.2664388,1.0394033,8.541769,4.692361,16.2658334,2.9286543,37.6398007),(29067,'full set',251,7,213,4.3314615,82.1628249,122.7153473,1.8,81.671214,122.6495883,0.2556462,2.6980745,10.3672762,3.1579696,89.2405284,0.0461615,8.607905,1.1704531,8.9105465,4.6465382,15.8461105,2.9229237,37.9957659),(29068,'full set',251,7,214,4.4168397,82.1065492,122.6669649,1.8,81.6084934,122.5819297,0.2554094,3.0818383,10.3005507,3.5191275,92.9077169,0.0469862,9.0196844,1.1418923,9.3597742,5.0643539,16.2658334,2.9286543,39.7145179),(29069,'full set',251,7,215,4.4543256,82.0059068,122.6111097,1.8,81.4456469,122.4848051,0.2524092,3.1680382,10.1885385,3.6296101,95.2779921,0.0463019,9.3514876,1.1456964,9.7060497,5.1646626,16.3620316,2.9029833,40.2179287),(29070,'full set',251,7,216,4.4346874,81.8448005,122.586073,1.8,81.1949187,122.4261678,0.2462028,3.5078863,10.0248148,3.6141795,95.1779164,0.0439041,9.4942319,1.0303012,9.8512376,5.4433152,18.3562794,2.8568622,45.3309989),(29071,'full set',251,7,217,4.6342017,81.7243605,122.536939,1.8,81.0593774,122.3675597,0.2423327,3.6015448,9.8949914,3.8403154,102.8808613,0.0444764,10.3972664,1.0662967,10.7808104,5.539974,18.3562794,2.8568622,44.3673631),(29072,'full set',251,7,218,4.697536,81.6302543,122.4901742,1.8,80.9271775,122.2631631,0.2392425,3.5841477,9.4759191,3.9343604,100.9943804,0.0439636,10.6580036,1.0977116,11.0325056,5.4748167,17.9442977,2.8501359,43.7596925),(29073,'full set',251,7,219,4.9099744,81.5904205,122.4304586,1.8,80.9186408,122.1814014,0.238057,3.9551494,9.3208277,4.6596396,102.8810162,0.0455062,11.0377554,1.1781197,11.5290925,5.9094027,17.533166,2.8430937,44.8275881),(29074,'full set',251,7,220,5.0870531,81.4994787,122.3819363,1.8,80.8491895,122.1494934,0.239092,3.9276871,9.221349,4.9343949,105.9865371,0.0475503,11.4936044,1.2563106,12.0212732,5.9094027,17.4116449,2.8666828,44.3241773),(29075,'full set',251,7,221,5.325284,81.4208221,122.3341478,1.8,80.8657914,122.1406768,0.2378912,3.9018145,8.7156632,5.3525828,104.8461553,0.0492879,12.0296245,1.3718189,12.629871,5.867566,16.7137033,2.827972,42.7528709),(29076,'full set',251,7,222,5.2980928,81.4482214,122.329594,1.8,80.9319817,122.1128846,0.2366559,3.993684,8.7407195,5.4825661,104.3916812,0.0485378,11.9431452,1.3728092,12.5566673,5.9458704,16.5861794,2.8526172,43.0045763),(29077,'full set',251,7,223,5.5353166,81.5261568,122.3083407,1.8,81.0830912,122.0869135,0.2353669,4.0565981,8.3931746,6.0419667,100.6844002,0.0501704,11.9959854,1.4894171,12.6949899,6.0241748,16.0544686,2.8706458,41.5375297),(29078,'full set',251,7,224,5.5405758,81.5494489,122.3135493,1.8,80.9815395,122.0826616,0.2318824,4.3787102,8.3165655,6.0847585,98.8373499,0.0487687,11.8843951,1.3896235,12.615264,6.3683633,15.9448411,2.896614,41.6417895),(29079,'full set',251,7,225,5.5382819,81.7482939,122.3314417,1.8,81.252536,122.072896,0.2290673,4.3548558,8.0955229,6.5315716,93.0657449,0.0475927,11.4959522,1.4998365,12.29954,6.3537555,15.2281815,2.8555412,40.6781537),(29080,'full set',251,7,226,5.5607175,81.585464,122.2894063,1.8,81.0974363,122.0338615,0.2308754,4.446681,7.5094296,7.1075151,85.1995083,0.0485294,11.3456698,1.5983866,12.2844772,6.4671745,14.4057668,2.8387078,39.1068473),(29081,'full set',251,7,227,5.6610341,81.6972051,122.2763577,1.8,81.2401634,122.0241092,0.2376984,4.7172692,7.5154155,8.053708,80.2150643,0.0523121,10.6734038,1.7072818,11.7389237,6.8069796,14.283491,2.8674252,39.2111071),(29082,'full set',251,7,228,5.8715703,81.6614336,122.2141706,1.8,81.2979352,121.9686286,0.2494635,4.6461809,7.0456392,8.9738143,73.5375851,0.0596471,10.4373191,1.9314388,11.7020028,6.8069796,13.7567282,2.8890384,37.8483203),(29083,'full set',251,7,229,5.4907812,81.7044252,122.142147,1.8,81.3172193,121.905449,0.2689498,4.646496,6.6469876,10.1502238,64.4755605,0.0646143,9.699967,2.18449,11.2086993,6.9228585,12.9263977,2.8724252,35.9210487),(29084,'full set',251,7,230,5.4691289,81.5090689,122.0546408,1.8,81.2666387,121.8620444,0.2916435,4.8750944,6.0128408,11.280814,55.487557,0.0753569,9.2281766,2.3139683,11.0753644,7.287183,12.2291349,2.8198421,35.3133781),(29085,'full set',251,7,231,5.2709015,81.4504302,121.9126918,1.8,81.3724905,121.8438918,0.3390812,4.814015,5.5103687,12.4813444,45.6727349,0.0971924,8.288508,2.5927099,10.5184385,7.4125419,11.4655059,2.9147938,33.5946261),(29086,'full set',251,7,232,6.0665526,81.1618059,121.8063873,1.8,81.1510197,121.7721389,0.3735884,4.7658959,5.5558181,14.1772509,42.5001768,0.1346722,7.6496702,2.9747295,10.2001135,7.4720721,11.1553493,2.868584,32.7352501),(29087,'full set',251,7,233,6.2794946,81.3191929,121.7012241,1.8,81.2345122,121.6110961,0.5046182,4.7561413,5.0333628,16.816683,41.868387,0.2446349,8.3181739,3.5357829,11.1449882,7.9226849,10.3304002,2.8461518,31.6241687),(29088,'full set',251,7,234,7.021043,80.9960339,121.5550851,1.8,81.0585621,121.5439502,0.5986845,4.8264275,5.0770033,19.1490691,37.6635767,0.3716421,7.418466,3.9675451,10.826739,8.1305867,10.1136544,2.927532,31.1207579),(29089,'full set',251,7,235,7.5272138,80.9445614,121.3106696,1.8,81.0180171,121.4477516,0.8676123,4.0048753,4.5837341,20.8652288,37.1982924,0.7299443,8.1152815,5.2099572,10.8723454,7.9672317,9.3845276,2.863293,30.5130873),(29090,'full set',251,7,236,7.9908633,80.9054933,121.2209284,1.8,80.9486962,121.4117367,0.9705701,3.9941601,4.5558901,20.8372226,38.9888921,0.9069204,8.5579088,5.2169223,11.2161426,7.9701856,9.2557628,1.9513027,29.9054167),(29091,'full set',251,7,237,7.0215465,80.862643,121.2550166,1.8,80.871331,121.35199,1.1804233,4.1103822,4.5490082,19.5413287,36.7328448,1.0007978,8.0749129,4.754139,10.4663752,7.9920562,9.1856803,1.7590178,31.1207579),(29092,'full set',251,7,238,6.1561829,80.81139,121.2823083,1.8,80.8601201,121.4155059,1.3119588,4.0691287,4.8788371,19.4838727,34.804903,0.9588112,7.1338522,4.7882173,9.8159575,4.3257278,8.7005189,2.7886023,21.2505827),(29093,'full set',251,7,239,6.0033862,80.7749608,121.4270072,1.8,80.7270428,121.5025452,1.360553,4.4118296,5.1114104,21.6235131,33.4603612,0.956985,6.5462091,4.9012576,9.6985735,4.29688,8.8582451,2.896614,21.2505827),(29094,'full set',251,7,240,7.2364467,80.4989373,121.6390384,1.8,80.5136326,121.5724582,1.3498588,4.5162803,5.2363749,28.8356413,34.1995515,1.1481536,6.5311503,6.384821,10.5608819,4.29688,8.9721488,2.8501359,21.7539936),(29095,'full set',251,7,241,9.7279127,80.2121806,121.8712886,1.8,80.2806983,121.6509801,0.3661659,6.2865088,4.4137552,37.0954719,41.7504724,0.207839,9.4591727,5.9008065,12.541837,5.1070441,9.3845276,2.863293,23.3252999),(29096,'full set',251,7,242,12.5369453,80.3378667,122.0401707,1.8,80.2015467,121.7030278,0.5635727,6.2478313,4.2181897,41.6054816,47.5927253,0.5962992,11.282737,6.6591877,13.9357297,5.156256,9.1856803,2.9533711,23.5770053),(29097,'full set',251,7,243,5.9427374,78.7322464,120.9929635,1.8,79.1121714,120.8414868,-0.8682718,4.7578203,5.9556099,8.4454019,33.2357038,0.5769355,5.580571,1.7750569,6.9549817,4.726568,8.76395,0.1973956,25.0008661),(29098,'full set',251,7,244,3.7907142,78.1195399,120.5947629,1.8,78.3602174,120.3043768,-0.8970145,1.8337601,5.9757848,2.0328822,32.1062975,0.3858262,5.3727333,1.1085868,5.658041,3.6460236,5.5026913,0.6747409,13.3076792),(29099,'full set',251,7,245,3.0038471,78.0535307,120.1116217,1.8,78.3358358,119.7609418,-0.8823591,1.667653,5.3832125,1.1890951,29.0481508,0.2985595,5.3960624,0.7130351,5.4979735,4.7458112,11.2048922,2.5748634,27.3704745),(29100,'full set',251,7,246,1.5593552,79.2405816,118.2454323,1.8,78.9419778,118.6692719,-0.8763739,1.6740458,5.88329,0.8339332,9.8429848,0.1534599,1.6730409,0.4981544,1.8137959,2.14844,4.899197,0.266252,11.232962),(29101,'full set',251,7,247,0.9734011,79.0931182,117.3603194,1.8,79.2221904,117.3293776,-0.2523667,0.7862228,2.1719757,0.1541936,1.1370385,0.010115,0.5235042,0.1961194,0.5942772,2.0405019,4.6278814,0.3805064,10.6252914),(29102,'full set',251,7,248,0.3891814,77.7856354,117.7640392,1.8,77.773528,117.788223,-0.5123857,0.7173417,0.9635941,0.0554235,0.1098453,0.0155901,0.1139954,0.0772623,0.1682808,1.8230118,2.5054901,0.5404195,6.076706),(29103,'full set',251,7,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29104,'full set',251,7,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29105,'full set',251,7,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29106,'full set',251,7,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29107,'full set',251,7,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29108,'full set',251,7,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29109,'full set',251,7,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29110,'full set',251,7,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29111,'full set',251,7,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29112,'full set',251,7,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29113,'full set',251,7,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29114,'full set',251,7,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29115,'full set',251,7,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29116,'full set',251,7,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29117,'full set',251,7,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29118,'full set',251,7,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29119,'full set',251,7,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29120,'full set',251,7,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29121,'full set',251,7,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29122,'full set',251,7,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29123,'full set',251,7,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29124,'full set',251,7,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29125,'full set',251,7,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29126,'full set',251,7,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29127,'full set',251,7,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29128,'full set',251,7,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29129,'full set',251,7,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29130,'full set',251,7,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29131,'full set',251,7,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29132,'full set',251,7,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29133,'full set',251,7,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29134,'full set',251,7,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29135,'full set',251,7,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29136,'full set',251,7,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29137,'full set',251,7,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29138,'full set',251,7,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29139,'full set',251,7,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29140,'full set',251,7,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29141,'full set',251,7,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29142,'full set',251,7,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29143,'full set',251,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29144,'full set',251,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29145,'full set',251,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29146,'full set',251,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29147,'full set',251,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29148,'full set',251,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29149,'full set',251,8,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29150,'full set',251,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29151,'full set',251,8,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29152,'full set',251,8,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29153,'full set',251,8,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29154,'full set',251,8,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29155,'full set',251,8,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29156,'full set',251,8,14,0.4033925,106.9594149,116.3620134,1.8,106.9708276,116.338026,-0.7280976,0.8432399,1.1823807,0.0812782,0.1293453,0.029772,0.109394,0.0963879,0.1781216,2.1268471,2.7513456,0.6747409,6.5801168),(29157,'full set',251,8,15,15.1935168,107.8349821,117.8659248,1.8,108.0164651,118.55713,-1.1616342,6.4031497,6.6408133,61.4119374,101.7803075,2.1314548,15.3264824,9.5908952,24.4884063,9.485311,12.3043918,1.1383886,45.0361077),(29158,'full set',251,8,16,34.7897742,108.6053799,118.7920437,1.8,108.9453685,119.0601618,-1.2799443,7.0396054,6.968883,228.6181967,314.1336581,5.3214658,45.0766156,32.4759958,71.7674073,11.8004998,14.5397175,0.9745972,51.8679299),(29159,'full set',251,8,17,55.6261416,109.6231351,119.1031814,1.8,109.4928414,119.3026995,-0.938225,7.4640403,8.6057427,497.1327508,616.985742,6.0304147,71.6946534,66.6037069,118.0237264,13.3687531,17.1121594,0.6786625,54.5503177),(29160,'full set',251,8,18,58.928197,109.7059846,119.2238238,1.8,109.3655374,119.3897497,-0.6225067,7.401435,9.8830264,505.0973432,816.6047167,3.3390159,82.6269897,68.243164,133.5875003,13.0649178,17.9905393,0.7008544,50.6525887),(29161,'full set',251,8,19,53.3290985,109.3076197,119.4899467,1.8,108.9878423,119.4828977,-0.526678,6.7177759,9.6199029,412.3615129,855.7822412,2.2457894,88.9595506,61.3836362,131.3422459,12.4572472,17.6643059,0.7165417,48.8295769),(29162,'full set',251,8,20,48.2631942,109.0697412,119.5941917,1.8,108.7285006,119.5155376,-0.4915491,6.4831373,9.5020606,356.6479073,811.0312121,1.7919847,85.3531931,55.0116232,122.6413258,12.1534119,17.3851149,0.6979028,47.9702009),(29163,'full set',251,8,21,41.0164529,108.7684412,119.6028158,1.8,108.4252778,119.5527849,-0.4849408,6.2258691,9.2272961,291.3022892,701.7521887,1.4854887,76.0517689,46.7890162,107.2219061,11.8495766,16.7798528,0.6947383,46.8591195),(29164,'full set',251,8,22,37.5821899,108.5968336,119.5953519,1.8,108.2899555,119.5361988,-0.4989234,6.1362539,9.2621355,262.9314523,646.8453945,1.4340335,69.8376085,42.8488547,98.2080725,11.5095215,16.7798528,0.6947383,45.8954837),(29165,'full set',251,8,23,33.9318518,108.318502,119.6399977,1.8,108.0536648,119.5756978,-0.5068723,5.8698328,9.0397341,221.929925,583.1623512,1.3327131,64.5110073,37.8085602,88.3417196,11.2032467,16.7137033,0.7672183,44.5758827),(29166,'full set',251,8,24,31.7051926,108.172188,119.6496915,1.8,108.0185571,119.5825876,-0.5109015,5.9413511,8.9119495,200.8742767,554.5438308,1.2633759,62.2247502,33.809528,84.0276065,11.1820393,16.4183554,0.748378,44.3241773),(29167,'full set',251,8,25,29.5383988,108.0072956,119.641504,1.8,107.8661313,119.6238754,-0.5092543,5.6500712,8.9356915,178.4575925,514.9842547,1.1701238,57.632278,31.5850167,77.3662232,10.6342355,16.1747714,0.6913369,42.8571307),(29168,'full set',251,8,26,28.704087,107.9086386,119.6467643,1.8,107.7402524,119.6204174,-0.5044682,5.473088,8.8433264,167.0393834,500.1835811,1.1176388,56.5605701,30.5201349,75.1527885,10.3304002,15.9042615,0.6705216,41.9977547),(29169,'full set',251,8,27,28.0146831,107.759574,119.675361,1.8,107.6040206,119.6362793,-0.5027249,5.3087816,8.6975425,154.086486,483.8169241,1.0839152,55.6268536,29.0248305,72.9963775,10.0265649,15.8461105,0.7086263,41.3900841),(29170,'full set',251,8,28,27.4652637,107.7329609,119.7073718,1.8,107.549163,119.6850289,-0.4970729,5.1086502,8.6539507,148.020094,470.4824958,1.0408896,54.3662091,28.9744041,71.1020189,10.0265649,15.5698916,0.6876713,41.1383787),(29171,'full set',251,8,29,26.9768287,107.6079607,119.7010924,1.8,107.4697431,119.6590899,-0.4941717,4.9616906,8.5442876,138.8041685,452.9898375,1.0114644,53.0166889,27.9751762,68.8179371,9.7227296,15.5223861,0.7266423,40.5307081),(29172,'full set',251,8,30,26.4396622,107.5869577,119.7217432,1.8,107.4481076,119.6697397,-0.483937,4.9274956,8.5056912,132.9068976,435.9894799,0.9539166,51.2585594,26.9725045,66.3793347,9.6088866,15.3007547,0.6659692,39.5670723),(29173,'full set',251,8,31,26.1417896,107.4761622,119.7002456,1.8,107.3650803,119.6329517,-0.4786972,4.7861885,8.2137036,127.786065,425.2599799,0.9244336,51.774449,26.6989203,67.0272219,9.4188943,14.9652379,0.6837093,39.0636615),(29174,'full set',251,8,32,25.9502761,107.4147916,119.6695143,1.8,107.2829168,119.6466236,-0.4822851,4.6687008,8.1763477,124.526009,415.7558201,0.9303819,50.8485986,26.6725186,65.7563161,9.4188943,14.9158068,0.72425,39.0636615),(29175,'full set',251,8,33,25.7123808,107.338694,119.6448915,1.8,107.1399057,119.6663226,-0.4794144,4.5191092,8.1178259,118.8592297,402.6546603,0.9117631,49.6012926,26.3014731,63.8595822,9.115059,14.6975909,0.6610432,38.2042855),(29176,'full set',251,8,34,25.4901513,107.3151703,119.625335,1.8,107.1311157,119.6463822,-0.4767293,4.5403159,8.1034775,116.0870969,390.3293453,0.8945634,48.1681283,25.568066,62.0766519,9.115059,14.6346459,0.7022569,37.8483203),(29177,'full set',251,8,35,24.9085612,107.2427031,119.6056166,1.8,107.0944407,119.6575215,-0.4689234,4.3810146,8.0401525,110.5379581,372.5628662,0.847876,46.3377859,25.2311324,59.5758305,9.032932,14.4377726,0.6375488,37.5966149),(29178,'full set',251,8,36,24.8822092,107.2275163,119.5948737,1.8,107.0975417,119.6574598,-0.4628075,4.3780728,7.8329208,108.3500414,365.1736034,0.8266217,46.6203623,24.7483414,60.1882223,8.9480626,14.0948144,0.6556956,37.3449095),(29179,'full set',251,8,37,24.7581702,107.1541593,119.6124672,1.8,107.0447442,119.6885693,-0.4551626,4.1874949,7.7534461,104.9929099,358.0220134,0.7974423,46.1758566,25.0729644,59.3926088,8.6855039,14.0948144,0.6556956,36.3812737),(29180,'full set',251,8,38,24.7688565,107.1540604,119.6134827,1.8,107.0513139,119.7008156,-0.449983,4.1758153,7.7486062,103.8287825,352.3597112,0.780969,45.4739477,24.8643141,58.5216329,8.6855039,14.0948144,0.6556956,36.3812737),(29181,'full set',251,8,39,24.1354016,107.1468756,119.5755399,1.8,107.0080804,119.7200122,-0.4483306,4.1949341,7.570908,100.35261,331.7661685,0.7557965,43.8211861,23.922333,56.1284014,8.6110275,13.7567282,0.6747409,36.3812737),(29182,'full set',251,8,40,23.9939065,107.1869953,119.5329909,1.8,107.1047537,119.6125564,-0.4377422,4.071354,7.4372714,98.8471881,316.0665853,0.7185677,42.4976539,24.2787017,55.2715517,8.5485395,13.4924769,0.6498704,35.7736031),(29183,'full set',251,8,41,23.7044823,107.1969391,119.4850758,1.8,107.1027647,119.5542878,-0.4238414,4.0680633,7.2472222,96.1105618,297.123421,0.6682249,40.9982488,23.6256308,53.8112692,8.4141472,13.2369013,0.6240231,35.1659325),(29184,'full set',251,8,42,23.4137152,107.2576348,119.4507381,1.8,107.131857,119.520964,-0.408926,3.9709192,7.1309189,93.9792525,281.8913293,0.6169707,39.5308562,23.6668761,52.4863711,8.2313064,12.9905136,0.5971767,34.9142271),(29185,'full set',251,8,43,23.0333178,107.2896631,119.3833318,1.8,107.1721814,119.4446988,-0.3961419,3.986251,6.7810584,91.4737541,261.2984161,0.5715694,38.5335742,22.947314,51.5035554,8.1956634,12.5495381,0.6640462,33.6988859),(29186,'full set',251,8,44,22.8635125,107.3481311,119.3458317,1.8,107.2498354,119.3794792,-0.3879846,3.9227425,6.5161429,90.068676,248.4713403,0.5454044,38.131659,22.9606394,51.6571838,8.1247444,12.2140278,0.6857295,33.4471805),(29187,'full set',251,8,45,22.6633828,107.3919855,119.3136392,1.8,107.3190539,119.3518099,-0.3701391,3.9545692,6.3182368,88.3471339,232.7500695,0.4942866,36.8378197,22.3405206,50.2852878,8.091519,11.7988288,0.5779019,32.2318393),(29188,'full set',251,8,46,22.4604557,107.4699593,119.272203,1.8,107.3961884,119.3196508,-0.3604409,3.9672433,6.093461,88.0131162,221.6577976,0.4656351,36.3763382,22.1849556,50.7365571,8.091519,11.4655059,0.2267988,31.9801339),(29189,'full set',251,8,47,22.3419557,107.4985434,119.2348331,1.8,107.4112578,119.2875272,-0.3498154,3.8576752,5.8743291,86.9571288,210.6756798,0.437381,35.8637857,22.5413299,50.1639107,8.0305001,11.2048922,0.5667292,31.3724633),(29190,'full set',251,8,48,22.2991547,107.5318461,119.2247476,1.8,107.456375,119.2751388,-0.3434894,3.8677046,5.7589829,86.36037,204.4903424,0.4215179,35.5080656,22.3285849,49.9799944,8.0305001,11.0889478,0.6202495,31.3724633),(29191,'full set',251,8,49,22.2981476,107.5728798,119.205722,1.8,107.5155483,119.2661674,-0.3359488,3.8727116,5.6586745,85.6766111,195.9745684,0.4038903,34.6325925,22.1231583,49.7644865,7.7856148,10.8788312,0.1586553,30.7647927),(29192,'full set',251,8,50,22.3088898,107.6065476,119.1917125,1.8,107.5833327,119.2551922,-0.3309405,3.8763256,5.4277095,85.7965706,190.6062402,0.3925667,35.1172517,22.1334786,49.8270175,7.7856148,10.7422,0.6435011,30.4088275),(29193,'full set',251,8,51,22.239513,107.6449546,119.1522307,1.8,107.5941971,119.2263501,-0.3256988,3.8571136,5.4730734,85.3301803,182.2758397,0.3794854,33.3041102,22.1228074,48.4576535,7.7856148,10.6125107,0.3729877,29.8011569),(29194,'full set',251,8,52,22.1164252,107.7114863,119.1374657,1.8,107.6752382,119.1853217,-0.3208114,3.869252,5.4017029,85.0088327,175.9421571,0.3665327,32.5716094,21.9703533,48.1187839,7.7290989,10.4900209,0.610726,29.4451917),(29195,'full set',251,8,53,21.8906149,107.7648059,119.1288653,1.8,107.7781227,119.1773943,-0.3100769,3.8876351,5.1729617,83.624858,167.3297883,0.3396893,32.3469991,21.5104701,47.7324272,7.734384,10.2496576,0.5763752,28.5858157),(29196,'full set',251,8,54,22.1129004,107.8159471,119.1332199,1.8,107.8217098,119.1834599,-0.2989876,3.9164426,5.0832526,83.7594968,165.5318785,0.3197577,32.5641651,21.3866272,48.3749063,7.734384,10.1410009,0.6350267,28.5858157),(29197,'full set',251,8,55,22.294455,107.8379814,119.1421937,1.8,107.8055912,119.1865611,-0.2870366,3.9405076,5.0947101,83.6757907,161.4379569,0.2978242,31.6873689,21.2347748,47.7674438,7.734384,10.0219602,0.5404195,28.3341103),(29198,'full set',251,8,56,22.4351668,107.8925691,119.1293443,1.8,107.825347,119.1997316,-0.2941695,3.9387341,5.1549178,85.0532263,158.1778038,0.3143473,30.6848355,21.5940511,46.89582,7.734384,10.0219602,0.5404195,28.3341103),(29199,'full set',251,8,57,22.3034068,107.9526346,119.0759895,1.8,107.8682783,119.1496621,-0.2952132,3.9044288,5.1034879,84.7167479,151.623001,0.3146576,29.709682,21.6976037,46.2774918,7.734384,9.8921606,0.6000502,28.3341103),(29200,'full set',251,8,58,22.1340491,108.0205813,119.0573353,1.8,107.970106,119.1521441,-0.2895544,3.7867827,5.0500903,84.4986193,146.5662252,0.3007451,29.0224962,22.3140926,45.7206198,7.734384,9.6942031,0.2234766,28.0824049),(29201,'full set',251,8,59,22.1721504,108.0729921,119.0507608,1.8,108.0123981,119.1606025,-0.2772008,3.8062731,4.9262155,83.5050677,142.7501669,0.2767534,28.9776539,21.9388011,45.3293431,7.734384,9.6560368,2.7776137,27.9781451),(29202,'full set',251,8,60,22.1844032,108.1159003,119.0564633,1.8,108.0454689,119.1718605,-0.2737836,3.8262567,4.9632082,83.1534595,140.3040494,0.2702918,28.2688218,21.7323261,44.4440801,7.734384,9.6560368,0.5633163,27.9781451),(29203,'full set',251,8,61,22.2689422,108.1510679,119.0823882,1.8,108.0957909,119.1807381,-0.2694732,3.8640217,4.8723021,83.8336287,136.7202112,0.2630521,28.060701,21.6959518,45.1323888,7.734384,9.5406219,0.625485,27.9781451),(29204,'full set',251,8,62,22.2435414,108.1874444,119.0982727,1.8,108.1556965,119.2070001,-0.2643612,3.8926767,4.9012765,83.4148784,133.9045107,0.2531088,27.3203339,21.4286685,44.2091253,7.734384,9.5115493,2.8198421,27.4747343),(29205,'full set',251,8,63,22.3483339,108.2149727,119.0970856,1.8,108.1984834,119.2282699,-0.2603999,3.9013829,4.8160221,84.7958933,129.2849951,0.2469091,26.8447677,21.7348301,44.4511959,7.734384,9.3845276,2.863293,27.4747343),(29206,'full set',251,8,64,22.5399033,108.2658274,119.118267,1.8,108.2479372,119.2476157,-0.2495508,3.879821,4.860061,85.8570105,126.7109156,0.2291313,26.0718774,22.1291161,43.7376727,7.734384,9.4237936,2.7187387,27.7264397),(29207,'full set',251,8,65,22.4988367,108.3035073,119.1508975,1.8,108.279736,119.3204215,-0.2407037,3.9264972,4.6763028,85.7465175,122.3946012,0.2130937,26.1733695,21.8379162,43.3235074,8.1444208,9.4237936,2.7187387,27.7264397),(29208,'full set',251,8,66,22.4946965,108.351822,119.1792688,1.8,108.3413325,119.355002,-0.2200104,3.9375296,4.6031741,85.7841614,119.5922869,0.1785651,25.9803963,21.7862898,43.2492375,8.1444208,9.2557628,2.7610863,27.4747343),(29209,'full set',251,8,67,22.375637,108.3738,119.2125702,1.8,108.3521481,119.3909171,-0.2048351,3.9027884,4.6087051,84.6759922,115.890551,0.1542944,25.1460117,21.6962806,42.573028,8.1444208,9.2557628,2.7610863,27.4747343),(29210,'full set',251,8,68,22.2924967,108.4249555,119.252042,1.8,108.4009263,119.4567292,-0.1961039,3.7911303,4.5620068,84.616069,112.99981,0.1410606,24.7697591,22.3194832,42.5299378,7.734384,9.2557628,2.7610863,26.8670637),(29211,'full set',251,8,69,22.2325194,108.4682693,119.3032958,1.8,108.4546373,119.4567292,-0.1671302,3.8394792,4.5177251,84.6055331,109.4661111,0.1025415,24.2303611,22.0356798,40.0201323,7.734384,9.2557628,2.7610863,27.1187691),(29212,'full set',251,8,70,22.2104195,108.518038,119.3514575,1.8,108.5381408,119.5213853,-0.1092451,3.8203447,4.2310334,84.8243936,107.2826381,0.0440029,25.3561314,22.2033349,40.1879087,7.734384,9.2257926,2.6571147,26.7628039),(29213,'full set',251,8,71,22.239513,108.5564958,119.3957447,1.8,108.5747373,119.5222902,-0.065608,3.8476843,4.2216832,84.3769174,104.5897237,0.0159318,24.7744128,21.9292724,40.0165725,7.734384,9.0642783,2.5930433,26.7628039),(29214,'full set',251,8,72,22.1635902,108.5960088,119.4466875,1.8,108.5940352,119.5423457,-0.0176197,3.8655597,4.2040032,84.0341649,103.3094985,0.0011467,24.5740768,21.7391972,40.2102445,7.734384,9.0642783,2.5930433,26.5110985),(29215,'full set',251,8,73,22.0613713,108.640883,119.5132093,1.8,108.6633209,119.6000299,0.0462393,3.9857679,4.2448136,83.2324558,101.3258692,0.0078559,23.870511,20.882414,37.9010964,7.734384,9.2257926,2.6571147,26.5110985),(29216,'full set',251,8,74,22.2268685,108.6890545,119.567466,1.8,108.7198331,119.6619696,0.141332,4.1263769,4.2580233,83.8607347,100.9457726,0.0735046,23.7071912,20.3230914,38.1235718,8.0441187,9.2557628,2.7610863,26.9713235),(29217,'full set',251,8,75,22.223064,108.7501998,119.6493206,1.8,108.7729532,119.7238083,0.2344561,4.1426348,4.3765349,82.765956,99.5180733,0.1998957,22.7390105,19.9790616,36.4377601,8.0251607,9.2955727,2.1587989,27.2230289),(29218,'full set',251,8,76,22.2848877,108.8038288,119.7141598,1.8,108.8263461,119.8777119,0.3165626,4.0208031,4.575764,82.8975611,100.0784763,0.3599338,21.8714243,20.617165,37.0902228,7.734384,9.4335845,2.6167969,26.8670637),(29219,'full set',251,8,77,22.2387297,108.8621297,119.7841279,1.8,108.9168809,119.9226711,0.3936335,4.0814497,4.6234638,81.4489585,98.9999411,0.5452491,21.4125047,19.9558896,37.2548451,7.734384,9.2257926,2.6571147,26.2593931),(29220,'full set',251,8,78,22.2908183,108.9178133,119.8326433,1.8,108.9142219,119.9476749,0.4553771,4.092905,4.6323925,81.384118,98.2426304,0.7186,21.2077517,19.8841942,37.6591986,7.734384,9.2257926,2.6571147,26.2593931),(29221,'full set',251,8,79,22.3893445,108.9649507,119.9091172,1.8,108.9525416,119.9965885,0.5325546,4.0979417,4.6267997,80.2640511,97.9645977,0.9619794,21.1732955,19.5864306,37.7102256,7.9984867,9.0642783,2.1193457,26.6153583),(29222,'full set',251,8,80,22.3803927,109.0003778,119.9545011,1.8,108.9365614,119.9788328,0.5755372,4.0822325,4.5996497,79.6076129,97.1182808,1.1050199,21.1142777,19.5009991,37.8529947,7.9765186,9.0642783,2.1193457,26.6153583),(29223,'full set',251,8,81,22.3020081,109.0298539,120.0254472,1.8,108.9728487,120.0129416,0.6463866,3.9597985,4.4741647,78.2926341,94.5848102,1.3484253,21.1402166,19.7718731,37.6316797,7.734384,8.9412281,2.1854593,26.2593931),(29224,'full set',251,8,82,22.0927028,109.0739917,120.0765756,1.8,109.0719275,120.0931457,0.6985606,3.9288955,4.7169453,77.1680388,93.0077641,1.5229174,19.7177959,19.6411531,35.524192,7.304696,9.1957248,2.223643,26.1551333),(29225,'full set',251,8,83,21.9623975,109.0846535,120.1515996,1.8,109.0740763,120.2255911,0.7564244,3.9135892,4.6981409,76.0410013,91.7827627,1.7242036,19.5359751,19.4299906,35.5091375,7.304696,9.0642783,2.1193457,25.9034279),(29226,'full set',251,8,84,21.9587049,109.1055254,120.2001865,1.8,109.0828375,120.2341752,0.7755994,3.6080833,4.3573755,75.4069722,90.6723851,1.7940329,20.8089446,20.8994541,36.5863461,7.304696,8.8582451,1.9693188,25.1483117),(29227,'full set',251,8,85,22.1218522,109.1294749,120.2847065,1.8,109.0777805,120.27745,0.8335262,3.6814668,4.3354987,75.081645,89.472844,2.0206608,20.637267,20.394492,36.9469439,7.304696,8.8582451,1.9693188,25.4000171),(29228,'full set',251,8,86,22.099081,109.1604748,120.3408351,1.8,109.1145971,120.3462678,0.8760942,3.6831787,4.587068,74.6526976,88.7362574,2.1738112,19.344875,20.2685517,35.4162733,7.304696,8.9412281,2.1854593,25.6517225),(29229,'full set',251,8,87,22.1526242,109.1595709,120.4084655,1.8,109.1254742,120.423404,0.9242824,3.6536213,4.2931618,74.2504578,86.8619162,2.3522586,20.2326211,20.3224287,37.1988872,7.304696,8.6473042,2.0344439,25.1483117),(29230,'full set',251,8,88,22.3164429,109.1875116,120.4460275,1.8,109.1350733,120.4451429,0.9819297,3.6592938,4.5108923,73.9163022,87.1399832,2.5720065,19.3176819,20.1996083,35.7030105,7.304696,8.8478174,2.0778948,25.4000171),(29231,'full set',251,8,89,22.3987999,109.2047872,120.4942047,1.8,109.1808562,120.5055222,1.0296419,3.6461167,4.379684,73.288019,85.8863581,2.7425291,19.6101723,20.1002946,35.8862309,7.6720481,8.76395,1.7681919,25.8602421),(29232,'full set',251,8,90,22.3375917,109.2252229,120.5478524,1.8,109.2309097,120.5907862,1.0926676,3.6258216,4.3581451,72.8592272,85.6789402,2.9347535,19.6594971,20.0945429,36.2113924,7.304696,8.7005189,1.9237867,25.1483117),(29233,'full set',251,8,91,22.1651008,109.2299248,120.6063161,1.8,109.2476879,120.6315035,1.1465149,3.6237506,4.3191014,72.113048,84.1391628,3.0681343,19.4807103,19.9001133,36.1513178,7.304696,8.7005189,1.9237867,25.1483117),(29234,'full set',251,8,92,21.951991,109.2427736,120.6436466,1.8,109.2643609,120.6658082,1.1993428,3.6458788,4.2822287,71.2550212,82.9630504,3.1766457,19.3738017,19.5439904,36.0091021,7.304696,8.5614727,1.8766752,24.8966063),(29235,'full set',251,8,93,21.7594145,109.2303157,120.6899675,1.8,109.2581205,120.6965742,1.244743,3.6332755,4.2348865,69.8212538,81.4315788,3.2544961,19.2287513,19.2171647,35.6336669,7.304696,8.5614727,1.8766752,24.6449009),(29236,'full set',251,8,94,21.7442523,109.2423231,120.7433418,1.8,109.2595597,120.7482684,1.2978729,3.639453,4.1589869,69.1571323,81.5235802,3.3607335,19.6017881,19.0020677,35.9553207,7.304696,8.463872,1.9890207,24.6449009),(29237,'full set',251,8,95,21.6323542,109.2495943,120.7942681,1.8,109.2649279,120.7640095,1.3460071,3.6371023,4.0781147,67.8022169,80.8317692,3.4262591,19.8208668,18.6418227,35.8931802,7.304696,8.4420297,1.82812,24.6449009),(29238,'full set',251,8,96,21.6879675,109.2745874,120.8431507,1.8,109.2996777,120.826696,1.3911185,3.6494085,3.9889803,67.297714,81.1890617,3.4992155,20.3533372,18.4407181,36.3380877,7.304696,8.3430318,1.7782926,24.6449009),(29239,'full set',251,8,97,21.6906531,109.2871416,120.9276059,1.8,109.3240593,120.9276063,1.4139028,3.5780634,4.2396447,66.0323048,81.7141463,3.5268487,19.2738195,18.4547609,34.6218636,7.304696,8.5614727,1.8766752,24.6449009),(29240,'full set',251,8,98,21.7735136,109.3212363,120.9875205,1.8,109.3616197,120.9591799,1.427538,3.607266,4.1684529,65.4837545,82.6201408,3.5549509,19.8203368,18.1532922,35.2577149,7.304696,8.5614727,1.8766752,24.3931955),(29241,'full set',251,8,99,21.8469187,109.3525759,121.0577371,1.8,109.3848471,121.0449252,1.4448167,3.3704498,4.0852696,64.3495708,83.3707565,3.58367,20.407651,19.0922801,35.8142172,6.875008,8.4420297,1.82812,24.0372303),(29242,'full set',251,8,100,21.9556277,109.3814974,121.0999115,1.8,109.3937459,121.0615822,1.4543357,3.3847205,4.0344242,64.0957549,83.9310288,3.6098642,20.8037191,18.9367941,36.3131244,6.875008,8.4420297,1.82812,24.2889357),(29243,'full set',251,8,101,21.9738111,109.3927912,121.1556336,1.8,109.409809,121.0796532,1.4795136,3.3652825,3.9619367,63.1200721,83.9973926,3.6318702,21.2010941,18.7562475,36.5995883,6.875008,8.4420297,1.82812,24.2889357),(29244,'full set',251,8,102,21.9698947,109.4144477,121.1900909,1.8,109.4125546,121.0880769,1.4978977,3.3653676,3.9128476,62.7023304,83.8716085,3.6422248,21.4349286,18.6316441,36.4997404,6.875008,8.3430318,1.7782926,24.2889357),(29245,'full set',251,8,103,21.9114279,109.4299701,121.2296878,1.8,109.4345387,121.1480334,1.5251654,3.3497722,3.9339711,61.6774952,83.5521584,3.644306,21.2386306,18.4124444,35.6925389,6.875008,8.4420297,1.82812,24.2889357),(29246,'full set',251,8,104,21.8837891,109.455857,121.2594437,1.8,109.4729645,121.1958876,1.5354245,3.348142,3.9632895,61.3885637,83.2572613,3.6427367,21.0071106,18.3351133,35.8746602,6.875008,8.4420297,1.82812,24.5406411),(29247,'full set',251,8,105,21.7454272,109.4610648,121.2882412,1.8,109.475179,121.2591697,1.5674318,3.3306102,3.9830267,60.3639607,82.0601423,3.6241968,20.6024586,18.1239942,35.4312912,6.875008,8.3430318,1.7782926,24.2889357),(29248,'full set',251,8,106,21.7474414,109.4790063,121.3158589,1.8,109.4599488,121.3213837,-1.5596643,3.3570306,4.151762,59.9325565,81.7667846,3.6241244,19.6944778,17.8528477,34.1111835,6.875008,8.3430318,1.7782926,24.0372303),(29249,'full set',251,8,107,21.7599739,109.486227,121.3467328,1.8,109.478364,121.3459373,-1.5359118,3.372331,4.1167182,59.1980455,81.7353904,3.6222507,19.8545024,17.5540438,33.9265656,6.875008,8.4420297,1.82812,24.0372303),(29250,'full set',251,8,108,21.6458939,109.5065942,121.3614909,1.8,109.478364,121.3459373,-1.5219997,3.3998436,4.0994017,58.6932946,81.4763321,3.5990656,19.8751764,17.2635281,33.8823628,6.875008,8.4420297,1.82812,24.0372303),(29251,'full set',251,8,109,21.4326162,109.5286584,121.3983617,1.8,109.5187948,121.4054523,-1.4946043,3.4030998,4.0882516,57.4607898,80.7502798,3.5514059,19.7517884,16.8848385,33.728549,6.875008,8.4420297,1.3134726,24.0372303),(29252,'full set',251,8,110,21.3750447,109.5395623,121.4145632,1.8,109.5149301,121.4022794,-1.4845361,3.4148564,4.0736172,57.1025705,80.6009649,3.5360651,19.786092,16.7218074,33.7474858,6.875008,8.4420297,1.3134726,24.0372303),(29253,'full set',251,8,111,21.1999802,109.5153087,121.4309927,1.8,109.4947331,121.4093675,-1.463599,3.3906659,4.0547998,56.1294469,79.8131919,3.4928829,19.6836332,16.5541073,33.4265624,6.875008,8.4420297,1.3134726,23.7855249),(29254,'full set',251,8,112,21.0764447,109.5316788,121.4472397,1.8,109.5206211,121.4273379,-1.4603382,3.1397698,4.0402404,55.4327817,79.0763486,3.4700558,19.5721892,17.6550465,33.2215872,6.44532,8.3430318,1.7782926,23.4295597),(29255,'full set',251,8,113,20.9695261,109.5282562,121.4641878,1.8,109.524551,121.4264914,-1.4507102,3.1474601,4.0222897,54.8408692,78.1773777,3.4447637,19.4360387,17.4238488,32.9872619,6.44532,8.3430318,1.7782926,23.4295597),(29256,'full set',251,8,114,20.8932117,109.5387421,121.4787935,1.8,109.5328944,121.4390066,-1.4398315,3.1590338,4.0079065,54.4617971,77.5302371,3.4228167,19.3443226,17.2400172,32.8609,6.44532,8.3430318,1.7782926,23.4295597),(29257,'full set',251,8,115,20.9219695,109.5307043,121.4805378,1.8,109.5187948,121.430242,-1.4364016,3.1553773,4.0046436,54.1325727,76.6159214,3.4243913,19.1317705,17.1556576,32.5578005,6.44532,8.3430318,1.7782926,23.4295597),(29258,'full set',251,8,116,20.8810148,109.5442982,121.4836654,1.8,109.5346327,121.4184547,-1.4231044,3.1847677,4.0012289,53.8804234,76.0082973,3.4048069,18.9962383,16.9181644,32.426701,6.44532,8.3430318,1.3633001,23.4295597),(29259,'full set',251,8,117,20.7693405,109.5405903,121.4894167,1.8,109.5409516,121.4310926,-1.4100757,3.1966687,3.9921786,53.3121074,74.57409,3.3729082,18.6800486,16.6773952,31.9754206,6.44532,8.3430318,1.3633001,23.4295597),(29260,'full set',251,8,118,20.7221196,109.5532096,121.4873754,1.8,109.536573,121.4493023,-1.406968,3.2122178,3.9954789,53.1249856,73.8691145,3.3618169,18.4881752,16.5384132,31.7260989,6.44532,8.2652137,1.4141944,23.4295597),(29261,'full set',251,8,119,20.5464956,109.5432127,121.4692673,1.8,109.536573,121.4493023,-1.3973502,3.2096304,4.0090736,52.5084897,72.8144209,3.3224262,18.1624055,16.3596684,31.1761996,6.44532,8.2652137,1.4141944,23.4295597),(29262,'full set',251,8,120,20.4728107,109.5506676,121.4587248,1.8,109.536573,121.4493023,-1.3935878,3.2190309,4.0196313,52.3938237,72.2388669,3.3061013,17.9715155,16.2762725,30.9180373,6.44532,8.2652137,1.4141944,23.4295597),(29263,'full set',251,8,121,20.3953773,109.5362887,121.4516282,1.8,109.516729,121.4319772,-1.4019196,3.1950174,3.7474632,52.1551814,70.6013343,3.3032038,18.8397673,16.3239117,32.2981572,6.44532,8.0272343,1.2998495,23.0735945),(29264,'full set',251,8,122,20.3865373,109.5405168,121.4478474,1.8,109.516729,121.4319772,-1.4069022,3.1933177,3.7486774,52.1561748,70.1005538,3.3073024,18.7000765,16.3329113,32.1246871,6.44532,8.0272343,1.2998495,23.0735945),(29265,'full set',251,8,123,20.3300847,109.5132359,121.4270016,1.8,109.4827922,121.4242706,-1.4137024,3.3113433,3.7604487,51.9429907,68.797131,3.3054138,18.294926,15.6863805,31.6365203,6.875008,7.9230552,1.3521274,23.4295597),(29266,'full set',251,8,124,20.1897086,109.5166723,121.4177888,1.8,109.4853749,121.4184868,-1.4197358,3.1837199,3.7660743,51.6177457,67.8996384,3.2887479,18.0292882,16.2130296,31.2356923,6.44532,7.9230552,1.3521274,22.8218891),(29267,'full set',251,8,125,20.0250507,109.4852013,121.3888325,1.8,109.4090344,121.4053998,-1.4145465,3.3451673,3.793239,51.0556257,66.6726645,3.2566875,17.5767106,15.262503,30.6284745,6.875008,7.9230552,1.3521274,23.1778543),(29268,'full set',251,8,126,20.051067,109.4794538,121.3732199,1.8,109.401169,121.3933704,-1.4176733,3.3380507,3.8058316,50.9868163,66.1942731,3.2640999,17.3928537,15.2744282,30.3830314,6.875008,7.9230552,1.3521274,22.9261489),(29269,'full set',251,8,127,19.7786512,109.4358228,121.3341396,1.8,109.3881481,121.3933704,-1.4161717,3.2884499,3.8386602,50.697455,64.5945839,3.2182541,16.8273775,15.4168244,29.7086427,6.875008,7.9230552,1.3521274,22.9261489),(29270,'full set',251,8,128,19.6810761,109.4211532,121.3207751,1.8,109.3674718,121.3382772,-1.422073,3.3376305,3.7826033,50.7088098,63.7848034,3.2081597,16.8626734,15.1930566,30.2442953,6.875008,7.8410702,1.735945,22.9261489),(29271,'full set',251,8,129,19.5292864,109.3865859,121.3009279,1.8,109.3663382,121.3417428,-1.4415585,3.3145714,3.7941645,50.3132112,62.325761,3.2008187,16.4267419,15.1794018,29.651007,6.875008,7.8410702,1.735945,22.9261489),(29272,'full set',251,8,130,19.357355,109.3627086,121.2801353,1.8,109.3501979,121.3361179,-1.4363879,3.2872172,3.8124918,50.0084296,61.3558714,3.1682922,16.093378,15.2129985,29.190121,6.875008,7.8410702,1.735945,22.9261489),(29273,'full set',251,8,131,19.2938529,109.3113278,121.2708333,1.8,109.3282139,121.3110327,-1.438413,3.3387344,3.8146349,49.7290472,60.0976369,3.1596154,15.7544924,14.8945803,28.7814583,6.875008,7.8410702,1.4056476,22.9261489),(29274,'full set',251,8,132,19.1277962,109.2805493,121.2578307,1.8,109.2854429,121.2816303,-1.4516315,3.3662835,3.7711803,49.5717522,59.3028719,3.14291,15.7252814,14.7259587,28.7726633,6.875008,7.7819807,1.6814535,22.9261489),(29275,'full set',251,8,133,18.9319187,109.2179091,121.2443325,1.8,109.2729637,121.2711748,-1.4576715,3.4277145,3.5271814,49.1607868,57.905064,3.1151124,16.4168091,14.3421477,29.4789041,6.875008,7.6864926,1.1071487,22.5701837),(29276,'full set',251,8,134,18.6795886,109.1792925,121.2214136,1.8,109.1961242,121.2096691,-1.4855403,3.4190009,3.5075442,48.5720438,57.3076476,3.0906905,16.3383966,14.2065021,29.0963947,6.875008,7.6864926,1.1071487,22.8218891),(29277,'full set',251,8,135,18.3622457,109.0943315,121.1961427,1.8,109.0973261,121.1765871,-1.5002546,3.1357974,3.4924737,47.5245489,56.0525305,3.0451707,16.0495212,15.1554908,28.5137216,6.44532,7.6864926,1.1071487,22.2142185),(29278,'full set',251,8,136,18.2740141,109.0701339,121.1863675,1.8,109.0977832,121.1516624,-1.5344729,3.1226952,3.4677474,47.3546943,55.4960224,3.0416524,16.003479,15.1646866,28.994632,6.44532,7.6140908,1.8568478,22.2142185),(29279,'full set',251,8,137,17.8645791,109.0036721,121.1659495,1.8,109.0344851,121.1928074,1.5442747,3.2994243,3.468784,46.7340635,54.2763923,2.975336,15.6470947,14.1643084,28.1770905,6.875008,7.6140908,1.8568478,22.3184783),(29280,'full set',251,8,138,17.7387498,108.9664587,121.1526534,1.8,108.9975227,121.1561016,1.5047969,3.2573832,3.4891739,46.5598418,54.1363984,2.9435989,15.5155346,14.2936337,28.0075027,6.875008,7.6140908,1.8568478,22.3184783),(29281,'full set',251,8,139,17.5254162,108.8919275,121.1562833,1.8,108.9562786,121.1540186,1.433955,3.3412822,3.5316879,46.1495239,53.6359837,2.8665477,15.1870677,13.8119205,27.9011254,6.875008,7.6140908,1.8568478,22.3184783),(29282,'full set',251,8,140,17.3861031,108.8607784,121.1516564,1.8,108.9123389,121.1313087,1.3689621,3.3031059,3.5500671,45.9384645,53.8975709,2.781235,15.1821272,13.9076573,28.0200297,6.875008,7.6140908,1.8568478,22.5701837),(29283,'full set',251,8,141,17.0537099,108.77998,121.1343107,1.8,108.8354474,121.1200011,1.2962941,3.3487228,3.5593666,45.2832973,53.6641517,2.6334402,15.0768826,13.5225578,27.7632401,6.875008,7.6140908,1.8568478,22.5701837),(29284,'full set',251,8,142,16.898899,108.7317744,121.1246002,1.8,108.7860889,121.106085,1.2843328,3.2641584,3.6220313,44.9469859,54.185174,2.5916121,14.9598858,13.7698543,27.2767504,6.875008,7.7463106,1.9100889,22.5701837),(29285,'full set',251,8,143,16.643212,108.6511329,121.0967851,1.8,108.711064,121.0525306,1.2582813,3.292352,3.5773162,44.6487005,53.978308,2.5116626,15.0890516,13.5613386,27.2239849,6.875008,7.6140908,1.8568478,22.5701837),(29286,'full set',251,8,144,16.5600717,108.6134894,121.0662522,1.8,108.6565004,121.0265132,1.2422488,3.3211033,3.5379883,44.9936298,54.3721531,2.4726532,15.3680984,13.5477959,27.5344883,6.875008,7.6503773,2.2367656,22.8218891),(29287,'full set',251,8,145,16.4758684,108.5132555,121.0145878,1.8,108.5351813,120.9916806,1.181946,3.2324362,3.6118309,45.3659272,55.1951636,2.3512832,15.2817685,14.0345933,27.5563728,6.875008,7.7463106,1.9100889,22.5701837),(29288,'full set',251,8,146,16.4026312,108.4643207,120.9655284,1.8,108.5155446,120.931027,1.1703116,3.2515711,3.619367,45.8428505,55.8811618,2.3182536,15.4394848,14.0986768,27.446669,6.875008,7.8410702,1.735945,22.9261489),(29289,'full set',251,8,147,16.2294689,108.3633494,120.9081826,1.8,108.4858799,120.85492,1.1062661,3.2684531,3.6582411,45.8047809,56.4178327,2.162018,15.4221197,14.014208,27.9430983,6.875008,7.7463106,1.9100889,22.8218891),(29290,'full set',251,8,148,16.3119378,108.3089995,120.8632375,1.8,108.3943352,120.7888406,1.0765093,3.3218162,3.7219002,46.5228353,57.7518025,2.1067974,15.5167519,14.0052407,28.0092545,6.9882119,7.8997178,1.9614034,23.1778543),(29291,'full set',251,8,149,16.2049073,108.1935727,120.798661,1.8,108.243916,120.821655,1.0790127,3.3640587,3.8335287,47.145294,57.8372751,2.0986118,15.0872157,14.0144087,27.3853453,6.875008,7.8997178,1.9614034,23.0735945),(29292,'full set',251,8,150,16.0974852,108.1291885,120.7693025,1.8,108.1927805,120.782196,1.0793452,3.2577088,3.7137353,47.8587818,57.8738752,2.0854426,15.5837375,14.6909332,28.0799948,6.875008,7.8997178,1.9614034,23.0735945),(29293,'full set',251,8,151,15.9739497,108.0386573,120.720763,1.8,108.0994163,120.7313666,1.0605951,3.3351405,3.8113071,48.7887668,58.8438602,2.0273911,15.4392858,14.6286992,27.8886032,6.875008,7.9926588,2.2035452,23.3252999),(29294,'full set',251,8,152,15.8301048,107.9843798,120.6698968,1.8,108.0314554,120.7006746,1.0534044,3.3647138,3.8350166,49.4817845,59.2596647,1.9928938,15.4522578,14.7060904,28.2324095,7.1113101,8.0731046,2.0106389,23.4295597),(29295,'full set',251,8,153,15.8705559,107.8848968,120.5981923,1.8,107.928647,120.6760577,0.9823422,3.4679134,3.9148113,51.1610291,60.8611837,1.8301154,15.5463902,14.7526835,28.2996298,7.2920472,8.107337,2.1293956,23.6812651),(29296,'full set',251,8,154,16.1530426,107.8434577,120.5476877,1.8,107.90981,120.5907955,1.0068942,3.4598739,3.9928526,52.5526204,63.2043526,1.9230799,15.8293728,15.1891722,28.7823216,7.2920472,8.2652137,2.0576956,24.0372303),(29297,'full set',251,8,155,16.1387756,107.7318616,120.4552323,1.8,107.8394112,120.5131611,1.0506633,3.4797912,3.9864882,53.8424673,64.5473942,2.0254039,16.1915429,15.4729019,29.5961004,7.2920472,8.2540369,2.2455373,24.2889357),(29298,'full set',251,8,156,16.0803648,107.6560693,120.374014,1.8,107.7209995,120.4651099,1.0372475,3.5121109,4.0990433,55.7720898,66.0737584,1.9868203,16.119312,15.8799343,29.6455205,7.4958527,8.3430318,2.1730837,24.8966063),(29299,'full set',251,8,157,16.6209442,107.5366059,120.3028956,1.8,107.5758621,120.4102111,1.0985299,3.5669433,4.1823006,58.7273125,69.3406503,2.1969031,16.5795471,16.4643246,30.5236032,7.304696,8.4747721,2.1025204,24.5406411),(29300,'full set',251,8,158,16.5898366,107.4623666,120.2416245,1.8,107.4812673,120.3089358,1.1286343,3.7253697,4.0937756,60.2712811,71.6294237,2.2587235,17.4971545,16.1786038,31.9261536,7.5958825,8.4747721,2.1025204,25.2525715),(29301,'full set',251,8,159,16.9997191,107.3134152,120.1025483,1.8,107.3433985,120.2095847,1.0523196,3.7946153,4.2866965,63.9119702,75.5826479,2.1374953,17.6319103,16.8428063,32.363978,7.5958825,8.7005189,1.9237867,25.5042769),(29302,'full set',251,8,160,17.5451102,107.2117305,120.0364781,1.8,107.2497904,120.1805569,1.0464713,3.734142,4.3956176,67.2809698,79.9169482,2.1912987,18.1810509,18.0177856,33.4063239,7.8997178,8.8582451,1.9693188,26.3636529),(29303,'full set',251,8,161,18.8549887,107.0498961,119.9104123,1.8,107.1181492,120.044085,0.9763574,3.8427485,4.4773543,74.7033162,87.5596743,2.1568559,19.5561192,19.4400744,35.4192947,8.164072,9.1352922,2.2896263,27.2230289),(29304,'full set',251,8,162,19.9415747,106.9343948,119.8206213,1.8,106.9952055,119.9610771,0.973218,3.9499369,4.6033909,80.3054941,95.9632289,2.2714577,20.8462048,20.3308295,37.4453178,8.2035531,9.2557628,1.9513027,27.3272887),(29305,'full set',251,8,163,21.5104972,106.8068335,119.7303294,1.8,106.8992585,119.8555833,0.9247913,4.1842291,4.6148242,89.989523,106.2696066,2.285829,23.0278773,21.5068347,41.8689073,8.5073884,9.4335845,2.6167969,28.1866647),(29306,'full set',251,8,164,23.0277788,106.6945919,119.6345799,1.8,106.7547504,119.7479443,0.9214145,4.218941,4.7570517,100.029146,117.029121,2.4345926,24.6011876,23.7095388,45.0864297,8.8112237,9.6560368,2.1341126,29.0460407),(29307,'full set',251,8,165,25.6513404,106.5436418,119.5832059,1.8,106.6334108,119.6743174,0.9513021,4.2861909,4.9005483,112.0157913,133.6232729,2.8339447,27.2670045,26.1341119,49.9862587,8.8112237,9.8921606,2.1708465,29.6537113),(29308,'full set',251,8,166,28.1123701,106.433693,119.5064474,1.8,106.5531803,119.5335354,0.9896272,4.5381527,5.0331518,121.9027209,148.6154599,3.2732047,29.5273154,26.8617492,53.7424859,9.115059,10.2496576,2.1471715,30.5130873),(29309,'full set',251,8,167,32.2088457,106.2986282,119.3538953,1.8,106.410228,119.348993,1.0219686,4.532766,5.1515583,134.4124414,176.8657224,3.9071594,34.3324704,29.6535143,59.6618867,9.115059,10.4635866,1.9055332,30.8690525),(29310,'full set',251,8,168,35.3935201,106.3410973,119.2559943,1.8,106.3956468,119.2450991,1.0545087,4.407981,5.2398823,142.4977356,197.7919353,4.4613811,37.7474004,32.3272118,64.2985316,9.115059,10.7765202,1.9809237,31.1207579),(29311,'full set',251,8,169,36.9299922,106.3850924,119.1310362,1.8,106.3364155,119.0831046,1.0865353,4.4694678,5.3511046,140.8434181,215.5012881,4.8209583,40.2722996,31.5123466,66.0733909,9.2419446,10.9549375,2.0169019,32.3360991),(29312,'full set',251,8,170,34.8501432,106.4144537,119.0967751,1.8,106.3389659,119.0213725,1.0922821,4.4180473,5.1959867,129.7610862,209.3315881,4.5768451,40.2871677,29.3706876,61.8924455,9.1795109,10.980189,2.1045045,33.1954751),(29313,'full set',251,8,171,25.8586316,106.2704852,119.1227511,1.8,106.32576,118.9914387,1.2162987,4.3224165,5.2915025,95.2577675,160.7700646,3.7904797,30.3826869,22.0380817,47.2849892,9.0038898,10.980189,2.1045045,34.7667815),(29314,'full set',251,8,172,17.0803417,106.1967029,119.368058,1.8,106.2092917,119.216711,1.4224,4.1347278,4.9400529,58.7482276,109.0118822,2.7844934,22.0669461,14.2084873,31.7808127,8.5485395,10.6125107,1.1978086,37.5534291),(29315,'full set',251,8,173,3.1715823,106.306541,120.0998161,1.8,106.3540376,119.7411132,-1.381835,3.7305112,4.8850615,6.4022874,22.4231354,0.5099463,4.5901439,1.7161957,5.6362884,3.3557953,4.4239087,2.0778948,11.5889272),(29316,'full set',251,8,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29317,'full set',251,8,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29318,'full set',251,8,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29319,'full set',251,8,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29320,'full set',251,8,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29321,'full set',251,8,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29322,'full set',251,8,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29323,'full set',251,8,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29324,'full set',251,8,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29325,'full set',251,8,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29326,'full set',251,8,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29327,'full set',251,8,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29328,'full set',251,8,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29329,'full set',251,8,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29330,'full set',251,8,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29331,'full set',251,8,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29332,'full set',251,8,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29333,'full set',251,8,191,2.3537195,116.1306764,123.4263025,1.8,116.2749369,123.38184,-0.4555226,1.6812953,2.2507997,1.3179386,2.1426808,0.0759231,0.9519642,0.7838828,1.5373892,3.7523199,4.6477863,0.5880026,12.8042684),(29334,'full set',251,8,192,3.4746022,116.4910093,123.3212586,1.8,116.4326215,123.4102416,-0.9110018,1.7721597,2.1754477,2.1490034,3.0811734,0.3615247,1.4163399,1.2126465,2.3941265,3.867192,4.6477863,0.5880026,12.4483032),(29335,'full set',251,8,193,2.7759667,116.4018176,123.3343384,1.8,116.3850231,123.3943086,-0.6199822,1.6625821,2.1042695,1.7114585,2.5399326,0.1561875,1.2070376,1.0293979,2.0136146,3.6460236,4.6477863,0.5880026,12.1965978),(29336,'full set',251,8,194,3.0066446,116.288074,123.2543864,1.8,116.230604,123.320456,-0.3589481,1.7263531,2.1892685,1.9585289,3.1946622,0.0618388,1.4592373,1.1344892,2.3470211,3.8443347,4.8040579,0.4636476,12.8042684),(29337,'full set',251,8,195,3.7478572,115.0619433,122.9140077,1.8,113.6409252,122.6320311,0.222637,1.9570185,13.6635939,2.7585069,56.2274739,0.0304536,4.1151306,1.4095456,4.3146262,3.867192,5.0293691,0.348771,13.411939),(29338,'full set',251,8,196,7.3903625,109.079902,121.4180576,1.8,109.1328919,121.4759417,0.236739,1.9942323,9.3778716,5.751136,363.3698926,0.0677525,38.7475868,2.8838847,39.3566867,3.867192,5.1919399,2.7149652,14.1670552),(29339,'full set',251,8,197,12.0208155,106.7838487,120.8175049,1.8,107.2192468,121.0046051,0.2308954,2.8305904,12.0694214,15.7538939,515.4749193,0.1049257,42.7091656,5.5655858,44.003738,5.585944,6.7939638,0.3217506,19.2801253),(29340,'full set',251,8,198,15.5745856,106.0105903,120.9439057,1.8,106.0880209,121.1869877,0.185586,4.5315393,12.805748,38.3058725,634.9105296,0.088382,49.5801206,8.4531701,52.5713929,6.4501819,8.7005189,0.9964915,24.2889357),(29341,'full set',251,8,199,18.1140558,105.9354595,121.2701929,1.8,105.3741253,121.3522499,0.15907,4.4388395,12.8914404,59.001573,717.6041048,0.0757486,55.6651608,13.2921169,60.2063376,7.304696,9.1049255,1.2341215,26.0076877),(29342,'full set',251,8,200,16.6833274,106.120565,121.4407144,1.8,105.3376129,121.5109624,0.1543602,4.3465697,13.0386019,60.7709277,657.0153105,0.065728,50.3900125,13.9813535,55.048272,7.734384,9.4335845,1.0460006,26.8670637),(29343,'full set',251,8,201,13.4380043,106.5922731,121.713005,1.8,105.4172937,121.7620805,0.1351419,4.1103616,12.5924226,46.8900869,607.3265848,0.0406554,48.2295269,11.4077765,51.9338624,7.734384,9.2257926,1.0863184,26.3636529),(29344,'full set',251,8,202,11.5040144,107.0338209,122.1328895,1.8,105.7423105,122.1432529,0.1060303,3.5782116,12.1390527,31.9462571,584.9030906,0.0214748,48.1835859,8.9279954,50.7142651,7.1920283,8.107337,1.012197,23.9329705),(29345,'full set',251,8,203,10.8258003,106.9728966,122.2921685,1.8,105.595826,122.3363937,0.0913239,3.3608018,12.1726119,27.4137062,586.2440889,0.0150062,48.1609118,8.1568946,50.3095977,6.875008,7.7463106,2.5535901,22.7176293),(29346,'full set',251,8,204,10.4899384,106.9944938,122.3413872,1.8,105.4740811,122.4324341,0.0889266,3.6495897,12.1448222,25.3946284,581.488661,0.0137892,47.8795532,6.9582145,49.8722412,6.875008,7.5164702,2.1112158,22.5701837),(29347,'full set',251,8,205,10.3747393,106.9015972,122.4050077,1.8,105.4778724,122.494781,0.0843121,3.5519556,12.2645666,24.0043889,585.3024795,0.0122624,47.7230464,6.7580768,49.4534936,6.8533591,7.3425118,1.2120257,22.2142185),(29348,'full set',251,8,206,10.5175772,106.6753827,122.4688996,1.8,105.3518775,122.5669145,0.0783146,3.4702536,12.4778164,24.0174533,600.548558,0.0107291,48.1292991,6.9209505,49.836251,6.8533591,7.3425118,1.2120257,21.9625131),(29349,'full set',251,8,207,10.8609923,106.1676855,122.5123841,1.8,104.9708734,122.5605644,0.0708432,3.3165358,12.9720873,24.0989162,618.2325597,0.0090696,47.6586803,7.2662915,49.3121845,6.6843766,7.2028834,2.8387078,21.7108077),(29350,'full set',251,8,208,10.8995412,105.9728319,122.5055063,1.8,104.9198269,122.5283544,0.0722782,3.2051308,13.1686114,23.9250537,610.6615667,0.0094736,46.3725102,7.4646108,48.0047063,6.44532,7.4175649,2.9669205,21.7108077),(29351,'full set',251,8,209,11.0531212,105.6831575,122.5086344,1.8,104.7659493,122.5790772,0.0698399,3.2380845,13.4545035,23.893758,614.183132,0.0089709,45.6488887,7.3789791,47.2480435,6.3805413,7.304696,1.080839,21.1031371),(29352,'full set',251,8,210,11.0129498,105.4896188,122.5464221,1.8,104.4653903,122.6057936,0.0663217,3.2729684,13.6409309,23.8703591,606.4075222,0.0080617,44.4549955,7.2931834,46.0382743,6.3805413,7.3926319,0.6202495,21.3548425),(29353,'full set',251,8,211,10.9711,105.3669299,122.5966932,1.8,104.4011632,122.6173302,0.062021,3.3473992,13.7817788,23.6672654,620.0216778,0.0070246,44.988509,7.0703444,46.3975111,6.076706,7.6503773,0.6659692,21.7108077),(29354,'full set',251,8,212,11.0573733,105.1675017,122.6256104,1.8,104.2759181,122.6440165,0.0587775,3.4001126,13.9739298,24.0344555,613.0596454,0.0063595,43.8716706,7.0687234,45.2973301,6.076706,7.8880231,0.5123895,21.7108077),(29355,'full set',251,8,213,11.5846929,104.9753363,122.6717777,1.8,104.233041,122.7075187,0.0539345,3.4736633,14.1554363,25.3126363,638.6415584,0.0056111,45.1163458,7.2870148,46.6052974,6.076706,7.9926588,0.6327488,21.9625131),(29356,'full set',251,8,214,11.6852333,104.9749252,122.6831443,1.8,104.2730924,122.7411254,0.0539419,3.485011,14.1552457,25.3850611,643.4238146,0.0056613,45.4547965,7.2840692,46.9509391,5.7728707,7.9926588,0.6327488,21.7108077),(29357,'full set',251,8,215,12.0650153,105.029125,122.7181978,1.8,104.4330484,122.7461413,0.0536003,3.5182481,14.0987001,25.6263506,673.8607769,0.0057716,47.7959507,7.2838385,49.3096,5.7376138,7.9926588,0.6327488,22.0667729),(29358,'full set',251,8,216,12.0789466,105.0488561,122.7259142,1.8,104.4394598,122.7412197,0.0542501,3.5226821,14.0795955,25.6624733,674.7655709,0.0059191,47.9250679,7.2849246,49.448179,5.7376138,7.9926588,0.6327488,22.0667729),(29359,'full set',251,8,217,12.3148836,105.1424764,122.6771802,1.8,104.6429234,122.6663041,0.0605202,3.472921,13.9985495,25.7307543,688.965138,0.0075084,49.2168949,7.4089661,50.7573853,5.7376138,8.2091777,0.748378,21.6065479),(29360,'full set',251,8,218,12.2264841,105.2390165,122.6509887,1.8,104.797834,122.6167323,0.0645772,3.4279796,13.9099445,25.3230121,680.4816491,0.008486,48.9205149,7.3871537,50.4509677,5.4690354,7.9926588,0.6327488,21.1031371),(29361,'full set',251,8,219,12.4563787,105.4217713,122.5934171,1.8,105.1230601,122.5766813,0.0728384,3.361969,13.7437289,24.9731262,691.235995,0.0109949,50.294647,7.4281251,51.8242963,5.4690354,7.9926588,0.9380475,20.7471719),(29362,'full set',251,8,220,12.6091195,105.5101565,122.555028,1.8,105.5112597,122.5273617,0.0800947,3.2949272,13.6688542,24.3178553,691.1370375,0.0134528,50.5629093,7.3803922,52.0714966,5.4399592,7.6503773,0.9048271,20.1395013),(29363,'full set',251,8,221,12.4118433,105.8294532,122.423808,1.8,105.873722,122.4494037,0.0979087,3.0775897,13.3865946,22.7935816,681.157679,0.0197669,50.8835667,7.4063094,52.3351011,5.3825049,7.1514336,0.9994588,18.9241602),(29364,'full set',251,8,222,12.5615069,105.9386915,122.3440951,1.8,106.1872372,122.3760868,0.1082124,2.95082,13.2994235,22.0801295,680.3374526,0.0244202,51.1554092,7.4827097,52.5778991,5.3814141,6.7939638,0.9652517,18.6724547),(29365,'full set',251,8,223,12.1558205,106.2427045,122.2612962,1.8,106.3191341,122.2319131,0.1191923,3.1684864,13.0205135,21.4458751,672.6322611,0.0286465,51.6594265,6.7684922,53.0670138,5.156256,6.7939638,0.9652517,18.3164896),(29366,'full set',251,8,224,12.0376002,106.3579624,122.2192898,1.8,106.6150859,122.1987705,0.126258,3.1353477,12.9198879,21.2027705,665.7503494,0.0318125,51.5291119,6.7624941,52.9413633,4.726568,6.725681,1.1071487,17.708819),(29367,'full set',251,8,225,12.0388871,106.6041239,122.1532417,1.8,106.7989524,122.1483626,0.136614,2.9938681,12.6967759,21.1814581,672.4313148,0.0372153,52.9607926,7.074947,54.3994804,5.156256,6.5448126,1.1659045,18.0647842),(29368,'full set',251,8,226,12.1862568,106.6511834,122.1034512,1.8,106.8023947,122.1310986,0.14365,2.9071236,12.6652304,21.1877738,674.9665122,0.0416237,53.292873,7.288226,54.7466462,5.156256,6.3877713,1.2277724,18.3164896),(29369,'full set',251,8,227,13.252869,106.5231261,121.9876058,1.8,106.7707541,122.0246781,0.1546102,3.1221832,12.8874412,22.6884655,705.4482662,0.0523808,54.7392037,7.266859,56.1134377,5.156256,6.5729625,1.7681919,18.6724547),(29370,'full set',251,8,228,12.7624198,106.7269734,121.9753405,1.8,107.0039883,122.0057041,0.1604573,3.049415,12.6968085,23.8813526,695.8482478,0.0542963,54.8049732,7.8314538,56.3025721,5.1435094,6.725681,2.0344439,18.4207493),(29371,'full set',251,8,229,13.7174137,106.5220487,121.8662515,1.8,106.8973056,121.9277487,0.1689015,3.2130012,12.9292339,25.8562719,727.4410434,0.0646032,56.2632752,8.0473895,57.9001879,5.1070441,7.086596,1.815775,19.0284199),(29372,'full set',251,8,230,13.9394194,106.3930167,121.7772648,1.8,106.5403289,121.7456089,0.1786159,3.1739682,13.0854975,28.1475884,729.3261185,0.0733348,55.7354523,8.8682641,57.563185,5.210995,8.2540369,2.2455373,20.9988773),(29373,'full set',251,8,231,13.9614634,106.2254138,121.5660549,1.8,106.445086,121.5381179,0.1978015,3.425382,13.2311344,33.0942353,752.9853798,0.0898602,56.910115,9.661473,59.2772778,5.1652001,8.9412281,2.1854593,21.9625131),(29374,'full set',251,8,232,13.6935794,106.2674195,121.5548467,1.8,106.3062865,121.4763015,0.2004146,3.3690801,13.1944824,32.7560338,746.3475258,0.0904486,56.5651234,9.7225454,58.9182142,5.1652001,9.2955727,2.1587989,22.9261489),(29375,'full set',251,8,233,14.0255809,106.3698579,121.5981782,1.8,106.1844275,121.3975134,0.1951857,3.4206845,13.0808285,32.9592138,738.0870324,0.0879313,56.4250983,9.6352685,58.7990296,5.1652001,9.5406219,2.1962814,23.1778543),(29376,'full set',251,8,234,13.9971588,106.4830883,121.6842488,1.8,106.1504743,121.4561362,0.1887813,3.529057,12.9472875,33.8001871,730.7504268,0.0821563,56.4404265,9.5776824,58.8953565,4.8613648,9.798394,2.2318395,23.8897847),(29377,'full set',251,8,235,13.5148783,106.6418938,121.775659,1.8,106.1125555,121.5065952,0.1843237,3.621672,12.7700907,35.306292,707.5893967,0.0756657,55.409896,9.7486166,58.0180482,5.1652001,10.1410009,2.2058231,24.3931955),(29378,'full set',251,8,236,12.9686479,106.7661119,121.8449827,1.8,106.4696711,121.612227,0.1772265,3.7198151,12.6286112,35.050104,674.2968154,0.0671814,53.3943761,9.4225393,56.0003647,5.1652001,10.1410009,2.2058231,24.7491607),(29379,'full set',251,8,237,13.3678442,106.7461787,121.9547985,1.8,106.5659809,121.6772351,0.165174,3.84993,12.6174499,37.1947335,660.9696511,0.0602338,52.3853598,9.6611455,55.1520031,5.1190639,10.4900209,2.1815223,25.3568313),(29380,'full set',251,8,238,13.3113917,106.6981567,121.9801769,1.8,106.5406321,121.7336554,0.1604061,3.8511585,12.6557775,36.0407333,643.4232545,0.056596,50.8402788,9.3584133,53.5038162,5.066102,10.7422,2.2142974,26.3204671),(29381,'full set',251,8,239,12.8197116,106.6784904,121.7963605,1.8,106.5203062,121.709126,0.1673565,3.646296,12.7127887,30.1638377,641.1239976,0.0592862,50.4314209,8.2724599,52.5926811,5.0774252,11.2460112,2.329174,26.9713235),(29382,'full set',251,8,240,12.9706062,106.5946186,121.7815906,1.8,106.3920363,121.7256215,0.165121,3.854297,12.7953647,27.8715185,622.2444957,0.0584067,48.6304621,7.2312846,50.5975042,4.8900608,11.3440887,2.4905159,28.0392191),(29383,'full set',251,8,241,14.5669996,106.2909321,121.8373193,1.8,106.6544776,121.8040933,0.1599532,3.7472576,13.0800796,30.4681976,637.2508598,0.0615882,48.7191882,8.1307988,50.8580867,4.7740502,11.6887773,2.5127964,28.2909245),(29384,'full set',251,8,242,15.2594248,105.9576408,121.8246868,1.8,106.7126989,121.840244,0.1570259,3.706351,13.407873,30.3632062,653.8064688,0.0621952,48.7628775,8.19221,50.8466548,4.8900608,11.9388329,2.6135182,28.6468897),(29385,'full set',251,8,243,13.6102713,106.0644737,121.8131513,1.8,106.9957772,121.9360983,0.1491418,3.6049893,13.2307539,27.4643511,638.506178,0.0500832,48.2592437,7.6184278,50.2339636,4.5715375,12.1610055,2.5829933,29.8622309),(29386,'full set',251,8,244,13.1424816,106.1431724,121.9215504,1.8,106.9779291,122.0098177,0.1343119,3.2060275,13.1243407,26.0387591,617.1696164,0.0392773,47.024809,8.121814,48.883867,4.5962892,12.1610055,2.5829933,29.0460407),(29387,'full set',251,8,245,14.6176335,105.2438744,121.9294084,1.8,106.3820547,121.9829058,0.0887118,2.8682133,13.9629613,22.2096571,680.0284209,0.0191227,48.7023066,7.7433771,50.0243711,4.7458112,11.2048922,2.5748634,27.3704745),(29388,'full set',251,8,246,12.5818723,106.0920214,121.9733248,1.8,106.8309524,121.9498057,0.0690023,2.9298263,13.0825405,16.8506859,624.2009026,0.0099686,47.7125146,5.7514283,48.573627,4.5312139,10.0587382,2.7928217,25.7127965),(29389,'full set',251,8,247,7.0321768,109.259694,121.9798352,1.8,109.3800719,121.9770011,0.0539267,2.4128603,10.981537,8.6296881,464.1193891,0.0034051,42.2636093,3.5765386,42.3946782,3.007816,4.29688,2.2142974,10.9812566),(29390,'full set',251,8,248,3.5274181,117.5194261,122.1557791,1.8,116.9838522,122.1194004,0.116611,2.4323947,18.778691,4.7618758,17.4769663,0.0079582,0.9306808,1.9576904,1.1840607,4.8613648,5.4351711,1.2490458,15.8426213),(29391,'full set',251,8,249,4.2368517,117.7098918,121.962326,1.8,117.5912827,121.92397,1.5094181,2.1504139,2.4764702,3.9552778,5.9549118,0.703485,2.4045966,1.83931,3.7253084,5.156256,5.4351711,0.3217506,16.0943267),(29392,'full set',251,8,250,4.8034475,117.6796336,121.9251687,1.8,117.59961,121.8715081,-1.5529799,2.1066471,2.4954553,4.5928881,6.4969188,0.8003205,2.6035004,2.1801887,3.9414638,5.156256,5.585944,0.3947911,16.0943267),(29393,'full set',251,8,251,5.736845,117.5823274,121.9478237,1.8,117.4480533,121.9574672,-1.1993274,2.3861185,2.8475696,5.6405116,7.4623794,0.8301619,2.6206135,2.3638858,4.5480728,5.156256,6.1521959,0.4324078,17.2054082),(29394,'full set',251,8,252,3.6672906,118.0426691,122.0720159,1.8,117.8403772,122.1497119,-1.2485938,1.9354687,2.7946022,1.7507865,4.9893638,0.5499277,1.7853574,0.9045801,2.4102667,3.9498589,5.9694165,1.0427219,15.2349507),(29395,'full set',251,8,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29396,'full set',251,8,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29397,'full set',251,8,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29398,'full set',251,8,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29399,'full set',251,8,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29400,'full set',251,8,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29401,'full set',251,8,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29402,'full set',251,8,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29403,'full set',251,8,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29404,'full set',251,8,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29405,'full set',251,8,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29406,'full set',251,8,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29407,'full set',251,8,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29408,'full set',251,8,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29409,'full set',251,8,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29410,'full set',251,8,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29411,'full set',251,8,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29412,'full set',251,8,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29413,'full set',251,8,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29414,'full set',251,8,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29415,'full set',251,8,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29416,'full set',251,8,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29417,'full set',251,8,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29418,'full set',251,8,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29419,'full set',251,8,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29420,'full set',251,8,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29421,'full set',251,8,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29422,'full set',251,8,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29423,'full set',251,8,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29424,'full set',251,8,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29425,'full set',251,8,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29426,'full set',251,8,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29427,'full set',251,8,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29428,'full set',251,8,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29429,'full set',251,8,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29430,'full set',251,8,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29431,'full set',251,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29432,'full set',251,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29433,'full set',251,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29434,'full set',251,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29435,'full set',251,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29436,'full set',251,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29437,'full set',251,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29438,'full set',251,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29439,'full set',251,10,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29440,'full set',251,10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29441,'full set',251,10,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29442,'full set',251,10,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29443,'full set',251,10,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29444,'full set',251,10,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29445,'full set',251,10,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29446,'full set',251,10,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29447,'full set',251,10,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29448,'full set',251,10,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29449,'full set',251,10,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29450,'full set',251,10,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29451,'full set',251,10,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29452,'full set',251,10,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29453,'full set',251,10,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29454,'full set',251,10,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29455,'full set',251,10,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29456,'full set',251,10,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29457,'full set',251,10,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29458,'full set',251,10,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29459,'full set',251,10,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29460,'full set',251,10,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29461,'full set',251,10,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29462,'full set',251,10,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29463,'full set',251,10,33,2.7496707,47.5092975,117.2293711,1.8,47.8091089,117.2037209,-0.3254793,1.6399883,3.0071392,1.2827132,4.1797913,0.0468582,1.389956,0.7821477,1.8094465,3.437504,7.8997178,0.390607,18.4639352),(29464,'full set',251,10,34,5.0255651,48.8293456,116.8595652,1.8,49.3645406,116.6669026,-0.2493346,1.93805,5.461345,2.8454473,23.8203562,0.0510012,4.3616281,1.4682012,4.8821649,4.3631705,13.6556983,0.2220819,30.5562731),(29465,'full set',251,10,35,10.2319574,51.0476651,116.3305544,1.8,51.0354761,116.2430172,-0.1959649,2.3095627,6.2963625,8.4520184,106.4532152,0.0646543,16.9070976,3.6595752,18.2153982,4.7550276,18.1336482,0.2392316,41.3290101),(29466,'full set',251,10,36,12.794087,51.9944953,116.1476312,1.8,51.7267105,116.1284123,-0.1931375,2.5495812,6.6784824,11.711731,170.5521585,0.0785569,25.5375618,4.5935902,26.5458272,5.2804001,20.0116547,0.2606024,45.8775955),(29467,'full set',251,10,37,15.3010508,53.2310517,115.9502436,1.8,52.8992116,115.9751706,-0.2285761,2.835512,7.8595005,13.8669177,279.8616893,0.1309347,35.6080759,4.8904458,36.4611721,5.7040858,22.9310118,0.2267988,52.4577123),(29468,'full set',251,10,38,16.0852883,54.1989106,115.7235442,1.8,53.6019553,115.8171429,-0.2489155,2.5752678,8.8877126,14.3663118,356.8374911,0.1627022,40.149531,5.57857,41.1138825,5.9666081,24.9107889,0.2617135,57.2148173),(29469,'full set',251,10,39,17.4470875,55.2960859,115.5427517,1.8,54.546916,115.7330055,-0.2714164,2.4567809,10.0266977,14.6915048,474.1377715,0.2090034,47.2875304,5.9799817,48.3670332,6.1597065,26.9917949,0.2411177,61.1557321),(29470,'full set',251,10,40,17.4708659,55.7124871,115.4178895,1.8,54.8890613,115.670816,-0.2794419,2.5236822,10.5897622,15.1685053,528.1345531,0.2215197,49.8721826,6.0104657,50.7241839,6.3910059,28.1503035,0.2153577,63.9423797),(29471,'full set',251,10,41,16.3888117,55.8537822,115.4872357,1.8,55.2757805,115.701849,-0.2868565,2.2877038,10.7172835,13.5985754,543.0060988,0.2186657,50.6663932,5.9442028,51.4843678,6.4137543,28.7634315,0.2413555,65.9128371),(29472,'full set',251,10,42,15.2861124,55.508798,115.6754475,1.8,55.4178822,115.732071,-0.2816289,2.3222852,10.3260049,12.4297489,546.1439058,0.196783,52.8901458,5.3523783,53.6085864,6.5022018,29.8099437,0.2624594,67.8832945),(29473,'full set',251,10,43,14.1259535,55.0286181,115.9913125,1.8,55.4080871,115.9086389,-0.2688771,2.3810871,10.9352748,11.0997811,529.5133171,0.1661434,48.4224977,4.6616443,49.2430942,6.659878,30.868829,0.2821237,70.2097171),(29474,'full set',251,10,44,13.7282678,54.5550515,116.2261184,1.8,55.3366115,116.0083088,-0.2646803,2.4471574,11.7519145,10.1755298,520.5560608,0.1565821,44.2954262,4.1581018,45.1036612,6.6678012,31.5813372,0.2614788,71.4250583),(29475,'full set',251,10,45,13.5807862,54.2155938,116.4621887,1.8,55.2474215,116.1713147,-0.2563494,2.5208409,12.5504236,10.1727382,534.4550007,0.1455138,42.5846185,4.0354543,43.3228503,6.8615361,32.1089371,0.2709469,73.2480701),(29476,'full set',251,10,46,12.3779941,54.0234603,116.5681353,1.8,55.14139,116.2841366,-0.2573281,2.5820896,12.7638979,9.218573,523.0456381,0.1336184,40.9785194,3.5701988,41.6257204,6.9737071,32.1089371,0.2709469,73.8557407),(29477,'full set',251,10,47,10.8050433,53.4557944,116.7492931,1.8,54.7460784,116.3949988,-0.2633874,2.6554596,13.6665628,8.3663232,526.0173563,0.1220672,38.4893675,3.1506121,39.0977731,6.837346,19.8076381,0.2186689,46.9886769),(29478,'full set',251,10,48,10.131417,53.1593935,116.8375045,1.8,54.6953073,116.4473409,-0.2662174,2.6824706,14.0892557,8.1971876,531.1485639,0.1168713,37.6988377,3.055835,38.2490487,6.875008,18.6555863,0.1386397,44.6622543),(29479,'full set',251,10,49,9.6881329,52.6186207,117.0170973,1.8,54.2818415,116.5637679,-0.2661323,2.7129451,14.6581751,8.6618438,518.582544,0.111688,35.3783837,3.1927826,35.9387063,6.875008,17.0256245,0.1775962,41.7281611),(29480,'full set',251,10,50,9.0522722,52.3545303,117.0962436,1.8,54.1627233,116.6239338,-0.2645568,2.7105989,14.9328015,8.70698,501.1816652,0.1031546,33.5624676,3.2121979,34.1146716,6.44532,16.1804778,0.1869793,40.1136689),(29481,'full set',251,10,51,9.066819,52.4082039,117.1488498,1.8,54.2423346,116.6233296,-0.265575,2.7814267,15.1973022,9.5180182,544.4165645,0.1040983,35.8232374,3.4219913,36.447572,6.44532,14.3415411,2.9912212,35.4608237),(29482,'full set',251,10,52,8.6818897,52.2471394,117.2179532,1.8,54.2878739,116.6448612,-0.2711281,2.8376386,15.3716314,9.7765849,531.1220048,0.1037873,34.5520909,3.4453242,35.1874089,6.44532,13.4924769,2.9816795,33.4903663),(29483,'full set',251,10,53,8.9959875,52.0342096,117.3301768,1.8,54.2433357,116.7199709,-0.2732815,2.900539,15.7230901,11.2125881,552.8847559,0.1092143,35.1638738,3.8656913,35.856793,6.44532,12.3043918,2.9304993,30.9122383),(29484,'full set',251,10,54,8.5278621,52.1089546,117.3509073,1.8,54.2232269,116.7270514,-0.2798607,2.9770872,15.954394,11.2945605,545.6469895,0.1084438,34.2004209,3.7938293,34.9080449,6.44532,11.7988288,2.9584818,29.8011569),(29485,'full set',251,10,55,9.0724139,51.9004913,117.5035847,1.8,54.2943195,116.7527109,-0.2842962,3.5020824,16.3173801,13.2854378,576.8287567,0.1189546,35.3505742,3.7935823,36.1558093,6.7955022,10.7422,2.8577985,28.3341103),(29486,'full set',251,10,56,9.2269451,51.7436122,117.572485,1.8,54.2855,116.7991691,-0.2813698,3.5096319,16.3667769,14.8640995,581.9117143,0.1185688,35.5544478,4.2352303,36.4626058,6.7955022,10.4635866,2.8068558,27.2230289),(29487,'full set',251,10,57,9.8637569,52.0557267,117.6067918,1.8,54.5591862,116.7945695,-0.2848996,3.647866,16.6099933,17.3937417,664.6959764,0.1298652,40.0178354,4.7681965,41.0545458,6.7278584,9.9201178,2.8335399,26.3636529),(29488,'full set',251,10,58,10.4864136,52.001205,117.6380117,1.8,54.4640391,116.8317332,-0.2869683,3.673263,16.6718627,19.9189066,699.5332917,0.1400197,41.9589163,5.4226737,43.1438771,6.875008,9.6560368,2.7776137,25.7559823),(29489,'full set',251,10,59,11.861137,51.8759115,117.7152368,1.8,54.649797,116.8160794,-0.2859364,4.1188897,17.104521,25.6710905,786.9109004,0.1572699,46.006018,6.2325268,47.5056443,6.875008,9.2557628,2.7610863,24.8966063),(29490,'full set',251,10,60,12.2554098,51.9365396,117.7303749,1.8,54.6413337,116.8022073,-0.2908845,4.175163,17.1732023,29.0700144,818.4101321,0.1680095,47.6562332,6.9626058,49.3442969,6.875008,9.0642783,2.5930433,24.5406411),(29491,'full set',251,10,61,13.5062062,52.006356,117.7118121,1.8,54.5591178,116.8432378,-0.2893784,4.1698025,17.1006155,36.2975947,907.2967567,0.183298,53.0563801,8.7048714,55.1723561,6.9165695,8.8582451,2.7430702,24.6449009),(29492,'full set',251,10,62,14.2777432,51.9317985,117.7644564,1.8,54.416916,116.9419362,-0.2905476,4.2047832,17.1874275,41.3902705,942.0885644,0.1952935,54.8126569,9.8436159,57.213565,6.6843766,8.8582451,2.2531129,25.0008661),(29493,'full set',251,10,63,15.3603568,51.8281448,117.839609,1.8,54.2442887,117.0262911,-0.2875267,4.6445066,17.4290835,50.1594038,968.0106122,0.2058758,55.5399605,10.7997272,58.3593844,6.6843766,8.8582451,2.2531129,24.6449009),(29494,'full set',251,10,64,16.3464583,51.6450026,117.9064757,1.8,54.2189645,117.0616672,-0.2805026,4.6247311,17.6176668,57.0426134,977.4550756,0.2087978,55.4815281,12.3342552,58.640046,6.3805413,9.0642783,2.1193457,24.0372303),(29495,'full set',251,10,65,17.834031,51.8180677,117.8240663,1.8,54.2922507,117.0407612,-0.268991,4.5384048,17.5314004,69.6586477,1080.2815711,0.2099296,61.6198106,15.3487076,65.3543925,6.3805413,9.0642783,2.1193457,24.0372303),(29496,'full set',251,10,66,18.2428505,51.8689668,117.7973821,1.8,54.140688,117.1248825,-0.2572443,4.7749851,17.4565581,77.6284239,1099.0641701,0.1968032,62.9599582,16.2573123,67.0921275,6.3805413,9.2955727,2.1587989,24.6449009),(29497,'full set',251,10,67,19.835943,51.8342892,117.8396676,1.8,54.1151471,117.2116749,-0.2399221,4.8331265,17.4683471,92.0840262,1139.5971478,0.1866779,65.237835,19.052683,70.0389292,6.5347533,9.6560368,2.1341126,25.5042769),(29498,'full set',251,10,68,20.6435112,51.6302629,117.927213,1.8,53.8881011,117.3425669,-0.2271598,4.8102097,17.6595454,99.6332956,1101.2863022,0.1745068,62.3620982,20.7128798,67.4393232,6.6242032,9.8921606,2.1708465,26.0076877),(29499,'full set',251,10,69,22.0511886,51.4196454,118.0407905,1.8,53.6858884,117.4778153,-0.2020918,4.9223154,17.8257247,111.6245635,1048.4032454,0.1480668,58.8140603,22.6772474,64.2872739,6.6816145,10.0219602,2.1112158,26.3636529),(29500,'full set',251,10,70,22.8441541,51.5149905,118.0630057,1.8,53.449685,117.5742209,-0.1828706,4.9766159,17.6007421,117.143132,1063.6531197,0.1259114,60.4322884,23.5387128,66.2781036,6.8018442,10.2496576,2.1471715,26.6153583),(29501,'full set',251,10,71,24.5646985,51.3660077,118.1680207,1.8,53.1484993,117.765762,-0.1518157,4.8713403,17.6047349,127.1920912,1014.5738109,0.0936385,57.6307349,26.1102866,63.9570382,6.9688372,10.4900209,2.1815223,27.8306995),(29502,'full set',251,10,72,25.9834538,51.5879177,118.2145148,1.8,53.1601179,117.9132426,-0.1355964,4.891577,17.2827158,136.3115412,1069.2117654,0.0791368,61.8659577,27.8665838,68.79343,7.186367,10.7422,2.2142974,29.2977461),(29503,'full set',251,10,73,26.0015254,52.206761,118.1895928,1.8,53.3922754,118.0437929,-0.1047257,4.8151051,16.4771749,146.5548625,1100.1266895,0.047355,66.7667057,30.4364826,74.7264978,7.5487621,10.980189,2.1045045,29.9054167),(29504,'full set',251,10,74,27.7741023,52.2660845,118.2205127,1.8,53.3336315,118.0896168,-0.0815527,5.1043224,16.3205677,159.6051532,1147.7980454,0.0307187,70.3283163,31.2686269,79.1081307,7.8118101,11.2048922,2.1375255,31.5809829),(29505,'full set',251,10,75,30.6844586,52.2344135,118.4007323,1.8,53.1591258,118.3525703,-0.0544492,5.1793855,16.238704,178.5537539,1176.7194419,0.0151468,72.4638764,34.4739262,82.5888027,8.5044237,11.6887773,2.1995926,33.9074055),(29506,'full set',251,10,76,31.9055461,51.9931756,118.6469588,1.8,52.8111601,118.6333885,-0.0475177,5.4075918,16.0045655,207.3651265,1121.8634546,0.0119977,70.0964643,38.3470377,82.4900649,9.5724986,12.1610055,2.1293956,37.9525801),(29507,'full set',251,10,77,32.9040683,52.1818474,118.7870009,1.8,52.7164513,118.832902,-0.0132032,5.8207682,14.8847746,222.1170825,1097.3438546,0.0009559,73.7225713,38.1594107,87.3476508,10.9762039,12.3940969,2.1587989,41.5986037),(29508,'full set',251,10,78,33.0529486,52.2349188,118.8539843,1.8,52.790118,118.8270984,0.020196,5.7965605,14.7534295,227.1358052,1050.214443,0.0022466,71.184428,39.184583,85.5665656,11.171888,12.7538463,2.1401095,43.0656503),(29509,'full set',251,10,79,32.2231687,52.7168091,118.7689958,1.8,53.0398273,118.7262319,0.11873,5.4310799,13.2378812,210.5940051,998.6325507,0.0753522,75.4374914,38.7757149,88.9937263,10.9014583,13.8103087,3.0481159,45.3920729),(29510,'full set',251,10,80,33.082154,53.0127547,118.7294863,1.8,53.2481938,118.6660688,0.1826175,5.2069752,12.415181,201.9949273,1027.0362843,0.181842,82.7242298,38.7931419,95.5413646,11.1378629,14.7101476,3.0244839,47.3193445),(29511,'full set',251,10,81,34.3319433,53.6753465,118.7839837,1.8,53.8656226,118.6825925,0.2628946,4.9967822,11.3795865,187.8944277,1074.8710873,0.38644,94.4560763,37.6030852,104.2533599,11.2610361,16.3507435,3.0890096,48.9949106),(29512,'full set',251,10,82,36.4473199,54.1284755,118.9377048,1.8,54.1494086,118.7500661,0.3182294,4.9798882,10.3805386,188.3824723,1108.2433861,0.594682,106.7616462,37.8286552,115.2696238,11.2684686,23.5232106,0.1651487,65.236683),(29513,'full set',251,10,83,36.6376585,54.217056,118.908253,1.8,54.4118654,118.7531756,0.3589158,5.0967969,9.8757624,179.5860198,1094.9395269,0.7534115,110.8713926,35.2350747,118.7790594,10.9473482,22.6759675,0.1713791,63.057706),(29514,'full set',251,10,84,34.5839937,54.2833844,118.8153393,1.8,54.496022,118.6893742,0.3879459,5.0828368,9.4928503,165.6786125,1039.4970838,0.8248375,109.5031577,32.5956981,117.8415253,10.9881884,22.1820578,0.1555948,61.5906594),(29515,'full set',251,10,85,34.5778393,54.3266898,118.7000523,1.8,54.4810502,118.5499951,0.4033894,4.7608756,9.4407094,157.6885071,1012.1592253,0.8879938,107.2122006,33.1217449,115.3618874,10.7450704,21.2684709,0.1418971,58.9082716),(29516,'full set',251,10,86,34.2847223,54.2322366,118.5770177,1.8,54.4781912,118.449135,0.4205885,4.955112,9.3370823,152.8535568,984.5600233,0.9525841,105.4462183,30.8476489,111.2822726,10.5345529,21.1640424,0.1016889,58.5523064),(29517,'full set',251,10,87,34.4526253,54.0616635,118.361907,1.8,54.56963,118.3641243,0.4402369,5.2102058,9.6826837,149.4561594,949.1387921,1.0428068,98.0243515,28.6852696,105.5065009,10.2432416,20.6965148,0.0831412,56.8335544),(29518,'full set',251,10,88,36.4423964,53.8690343,118.1738268,1.8,54.5286516,118.3208495,0.4563005,5.0118995,9.8757117,148.8874888,967.0720585,1.1792449,97.9242903,29.7067984,105.0985326,10.1670281,20.2364345,3.0778493,56.2258838),(29519,'full set',251,10,89,39.1760098,53.7216537,118.0472695,1.8,54.5597402,118.3386278,0.4579769,5.0708609,10.437266,150.2416377,1002.6436328,1.2763729,96.0638188,29.6284281,105.8915471,9.8230912,19.9330777,3.0118901,54.0469068),(29520,'full set',251,10,90,41.5642498,53.7099329,118.1222391,1.8,54.5683035,118.3673001,0.4524342,4.5777716,10.4320466,144.9546949,1054.6777799,1.3238594,101.099796,31.6649031,110.1935671,9.5124893,19.9330777,3.0118901,53.5866819),(29521,'full set',251,10,91,39.5866756,54.7129211,118.5286874,1.8,54.6961549,118.3647664,0.4349518,4.4332399,9.7936868,142.0202946,1038.3962679,1.171435,106.0271057,32.0353279,115.0532661,9.2007666,20.0623347,2.9694018,53.0832711),(29522,'full set',251,10,92,38.6111484,55.0435245,118.5621231,1.8,54.8147353,118.4620987,0.4685885,4.4543558,9.5740741,140.3769573,982.0185425,1.3125687,102.5706014,31.5145362,114.9416744,9.041659,19.4881391,2.896614,50.6525887),(29523,'full set',251,10,93,39.2340848,54.4882383,118.398526,1.8,54.6981946,118.4885057,0.4185375,4.466358,10.2320438,152.3151879,1015.9125719,1.0801207,99.2873554,34.1027721,112.9406886,9.3377195,19.163314,2.7985687,49.8363985),(29524,'full set',251,10,94,37.8377651,54.1347525,118.4430731,1.8,54.3596504,118.5334846,0.3747016,4.6737523,10.4440369,157.3213962,932.4150445,0.844742,89.2772643,33.660619,103.0823325,9.6802672,19.2162315,2.9617392,49.6889529),(29525,'full set',251,10,95,37.5663563,53.8961621,118.6156195,1.8,53.9620059,118.5754525,0.3318987,4.9612879,10.2676176,181.2845597,783.9885736,0.6647419,76.3554512,36.5398188,93.2789519,10.0287077,18.4565877,2.9304993,49.1855421),(29526,'full set',251,10,96,37.0828449,53.2597938,118.7677387,1.8,53.2167136,118.7376012,0.3116282,5.3572293,8.4105168,212.4774687,612.4633825,0.5810199,72.8211357,39.6618208,95.4515455,10.7370785,16.0429641,0.1343214,44.4284371),(29527,'full set',251,10,97,38.2773006,52.9541499,119.1900307,1.8,52.90342,119.1118481,0.1470235,6.1003718,8.0760832,285.4284619,539.9223501,0.1369091,66.8544813,46.7886993,102.0050893,11.601576,15.1125613,0.2587709,42.6054253),(29528,'full set',251,10,98,35.0618543,53.055809,119.0739167,1.8,52.8054779,119.1657967,0.1286514,5.9896461,7.5717647,274.7384766,478.1204986,0.0961868,63.1451874,45.8689,99.4065466,11.5098581,14.5904229,0.2378359,42.1020145),(29529,'full set',251,10,99,31.8201678,53.4480527,118.745767,1.8,53.0381552,119.023576,0.2143229,6.0763091,7.0337293,227.5327731,401.1316872,0.2398991,57.0297303,37.4458855,88.0068362,11.1461045,13.9896277,0.1853479,40.3832625),(29530,'full set',251,10,100,29.768685,53.5295301,118.5856281,1.8,53.169776,118.8800419,0.2377245,5.887228,6.7459295,203.0828543,358.4933637,0.2751438,53.1421749,34.4954969,83.1646372,10.8749632,13.2369013,0.2292319,39.1679213),(29531,'full set',251,10,101,28.3983256,53.5795468,118.4430428,1.8,53.3474178,118.6860355,0.1994853,5.7718486,6.5613886,187.4955482,320.1444931,0.1858638,48.7921862,32.4844886,76.8878343,10.603822,12.7248603,0.204018,37.4491693),(29532,'full set',251,10,102,28.4042562,53.5356601,118.4446215,1.8,53.4063312,118.5781293,0.1000446,5.4270051,6.3036726,185.7477186,307.2218284,0.0472248,48.7369584,34.2265607,77.5614504,10.3984456,12.4015431,0.2449787,36.4855335),(29533,'full set',251,10,103,28.6282761,53.6615084,118.3891189,1.8,53.6367188,118.4567535,0.003938,5.3830202,6.0709593,186.9014489,284.1799341,0.000074,46.8097248,34.7205549,75.4167045,10.2728169,11.8845829,0.2186689,35.9821227),(29534,'full set',251,10,104,29.2147337,53.8019034,118.1720537,1.8,53.7075348,118.2658466,0.0315975,5.230153,5.9758223,185.9748996,264.8327919,0.0048597,44.3173811,35.5582137,73.1022162,10.0584539,11.7988288,2.9584818,35.4787119),(29535,'full set',251,10,105,30.5934296,54.0702912,117.7719063,1.8,54.0103816,117.8777413,0.1182179,5.4295812,5.8658442,191.7970372,242.2871333,0.0709282,41.3047337,35.3244625,71.8986909,10.2135898,11.5697035,1.1902899,34.7667815),(29536,'full set',251,10,106,31.5276664,54.2408403,117.3067341,1.8,54.24811,117.0757922,-1.5089118,5.6080428,8.2238788,229.9473337,256.412883,5.2345132,31.1790689,41.0031347,58.9379153,10.6496494,14.8164498,1.2765618,41.5986037),(29537,'full set',251,10,107,34.7175999,54.6436406,116.5483763,1.8,54.5846672,116.3739921,-1.502246,5.2994606,7.8433189,219.420513,365.5531842,5.7591187,46.6069513,41.4043108,74.4863585,10.6873373,14.6975909,1.3045443,41.1383787),(29538,'full set',251,10,108,36.0397313,54.8025138,116.3585276,1.8,54.7148243,116.1547229,-1.5087413,5.1332083,7.6716421,216.4666448,387.7778993,5.9835211,50.5469228,42.1698541,78.2197017,10.312512,14.8164498,1.2765618,41.3900841),(29539,'full set',251,10,109,34.2091352,55.0399903,116.3188559,1.8,54.9508189,115.9848611,-1.5508749,5.1691927,8.0265303,199.5124041,356.3058703,5.6992601,44.3910202,38.5964338,69.0355642,10.0630821,14.4952048,1.3617734,40.5307081),(29540,'full set',251,10,110,32.3867077,55.1863818,116.2254365,1.8,55.0868181,115.9024693,1.4643605,5.1366964,7.5829383,180.438773,328.6035452,5.3368659,43.334593,35.1273966,67.0959415,9.8746646,13.5879276,1.2490458,38.9594017),(29541,'full set',251,10,111,30.4907071,55.411869,116.2508748,1.8,55.26152,115.8389557,1.3411902,5.2161609,7.5334557,159.8879035,296.3348928,4.8185531,39.3358512,30.6524102,60.1351561,9.6883703,13.3272566,1.9333406,38.2474713),(29542,'full set',251,10,112,29.3149944,55.5108415,116.286656,1.8,55.3475894,115.8270082,1.2819145,5.2657282,7.407193,148.5506449,278.1867624,4.4893133,37.5563,28.2108457,56.2029641,9.5343839,13.1809902,1.9028558,37.3880953),(29543,'full set',251,10,113,27.1482006,55.6633751,116.370106,1.8,55.5532117,115.9201393,1.2086571,5.0244911,6.9954609,135.5257188,248.7976857,3.9567999,35.565589,26.9730241,52.9391468,9.2907979,12.7755427,1.9138203,37.2406497),(29544,'full set',251,10,114,26.8264937,55.7225814,116.4622625,1.8,55.6165729,115.9522409,1.1377611,5.0605514,6.919488,132.2891239,231.3377046,3.6837807,33.4327777,26.1412469,49.6258712,9.2031788,12.695808,1.9890207,36.0253085),(29545,'full set',251,10,115,25.6471442,55.8721628,116.5618579,1.8,55.7370289,116.04324,1.0674778,4.9625282,6.752287,124.8519648,212.7059608,3.2800679,31.5013212,25.1589433,47.4659522,9.12933,12.6885346,2.0647377,35.6693433),(29546,'full set',251,10,116,24.4658925,55.8696523,116.6491152,1.8,55.7482266,116.0536736,1.0232592,4.6898568,6.7202235,116.3855715,194.6519428,2.9725663,28.9650995,24.8164448,43.218099,8.7593591,12.6885346,2.0647377,35.4176379),(29547,'full set',251,10,117,24.0859427,55.9861521,116.5788326,1.8,55.8671589,116.0749386,1.0535499,4.8413379,6.7916686,107.0993882,183.6376142,3.0327453,27.0386596,22.1218575,40.6627213,8.6516621,12.5274503,2.1112158,34.8099673),(29548,'full set',251,10,118,23.184492,56.0091028,116.517559,1.8,55.8968042,116.0184289,1.1032754,4.7151975,6.8500094,100.6495971,180.0122302,3.0792575,26.2791216,21.3457861,39.5602967,8.4599362,12.4905505,2.0344439,34.2022967),(29549,'full set',251,10,119,21.9390108,56.0326466,116.4898419,1.8,55.9439688,116.1242386,1.1198244,4.7529379,6.4782145,93.2023568,164.829148,2.9619239,25.4436078,19.6094201,38.7876457,8.4373442,12.1077509,2.0503156,33.0912153),(29550,'full set',251,10,120,21.512959,55.9955129,116.4099821,1.8,55.8889284,116.0635031,1.1654069,4.7654797,6.6218279,89.1577799,160.5976551,3.0278309,24.2527679,18.7090881,37.4287358,8.4373442,12.1610055,2.1293956,33.3429207),(29551,'full set',251,10,121,21.5248202,56.0529628,116.3111198,1.8,55.9530899,116.0116284,1.2140452,4.7047645,6.4313953,83.1591546,153.0933383,3.1499321,23.8040628,17.675519,36.4429774,8.2284072,11.9388329,2.0988708,33.0912153),(29552,'full set',251,10,122,21.0506522,55.9984693,116.314405,1.8,55.925991,115.9723572,1.2559863,4.5151461,6.4461521,78.9748651,146.6390178,3.1720724,22.7483027,17.4910985,34.8505272,8.1530202,11.7360686,1.9853032,32.1275795),(29553,'full set',251,10,123,20.5597555,56.0228305,116.3221577,1.8,55.974509,116.046348,1.2279733,4.4152381,6.4423859,72.6848362,138.9865709,3.0394346,21.5737731,16.4622688,32.6314437,7.882577,11.7360686,1.9853032,31.9801339),(29554,'full set',251,10,124,20.19038,56.0278188,116.3406726,1.8,55.952786,116.0083516,1.211916,4.4189378,6.4484847,70.286383,136.1044623,2.9499498,21.1064254,15.9057192,31.7236758,7.882577,11.7360686,1.9853032,31.6241687),(29555,'full set',251,10,125,19.1604704,56.0883485,116.3852275,1.8,56.0250652,116.0845101,1.2000469,4.3066602,6.3455716,65.4925054,127.1235151,2.7742079,20.0334224,15.2072611,29.7376367,7.6908511,11.5297389,2.0344439,31.3724633),(29556,'full set',251,10,126,18.6898272,56.0274892,116.493549,1.8,55.9872283,116.1946636,1.1741062,4.201352,6.1558344,61.9298269,122.0645289,2.6499685,19.8290794,14.7404519,29.503542,7.6267195,11.3522236,2.0852476,31.3724633),(29557,'full set',251,10,127,18.5149306,56.0805055,116.5346759,1.8,56.0251998,116.1895664,1.1704287,4.1718338,6.2106574,58.9879386,119.0946195,2.6170532,19.1758476,14.1395704,28.3171285,7.6267195,11.3522236,2.0852476,31.0164981),(29558,'full set',251,10,128,18.078696,56.0061822,116.5328675,1.8,56.0108074,116.1817758,1.1739956,4.1022797,6.1837529,57.2939622,117.7368765,2.5630808,19.0397122,13.9663715,27.9170682,7.6267195,11.3522236,2.0852476,31.0164981),(29559,'full set',251,10,129,17.2541193,56.0859057,116.6085425,1.8,56.0370669,116.3067298,1.1250183,4.1619117,6.2283493,54.7711126,113.1823297,2.3410995,18.1721231,13.1600854,26.3999787,7.5484069,11.3522236,2.0852476,30.7647927),(29560,'full set',251,10,130,16.8051844,56.0410052,116.6619429,1.8,56.0133833,116.2965797,1.1064967,4.1010565,6.2309081,53.2032939,111.6906107,2.2392295,17.9252541,12.9730701,25.7514246,7.5484069,11.3522236,2.0852476,30.7647927),(29561,'full set',251,10,131,16.6970909,56.0888174,116.7540768,1.8,56.0384767,116.3618976,1.0834031,3.9231053,6.2989659,50.9991213,109.7644463,2.1724931,17.4257883,12.9996819,24.717668,7.386014,11.5297389,2.0344439,30.7647927),(29562,'full set',251,10,132,16.1605397,55.9916412,116.818214,1.8,55.9530011,116.4749024,1.0736522,3.9844355,6.1201488,49.3941979,107.1395814,2.0808037,17.506042,12.396787,24.212892,7.386014,11.3522236,2.0852476,30.7647927),(29563,'full set',251,10,133,15.7240814,56.0062867,116.9133066,1.8,55.9607486,116.590424,1.0661392,3.7817341,5.9934109,46.3209189,103.7721208,2.0080194,17.3143678,12.2485921,24.1238664,7.2040377,11.3522236,2.0852476,30.1571221),(29564,'full set',251,10,134,15.5376592,55.9397128,116.9885803,1.8,55.8681735,116.695226,1.0655482,3.8952132,6.0260679,44.3827189,102.2010747,1.9829167,16.9598279,11.3941694,23.3406999,7.2220986,11.3522236,2.0852476,30.0528623),(29565,'full set',251,10,135,14.9492434,55.8978893,117.0887192,1.8,55.8116969,116.741088,1.0572924,3.651731,6.0779421,40.9414445,96.8170424,1.890309,15.9292473,11.2115171,21.6291977,6.8792519,11.3522236,2.0852476,29.8011569),(29566,'full set',251,10,136,14.4186228,55.7946942,117.1299893,1.8,55.7419185,116.8237203,1.0630174,3.7013966,6.0746266,38.7577894,94.3446245,1.8349452,15.5309338,10.4711257,20.8334112,7.0120326,11.3522236,2.0852476,29.8011569),(29567,'full set',251,10,137,13.8714414,55.7597173,117.2048881,1.8,55.761441,116.9373277,1.0705986,3.4591672,5.9674358,35.0878218,90.499251,1.780133,15.1655174,10.1434304,20.476442,6.6787883,11.3522236,2.0852476,29.4451917),(29568,'full set',251,10,138,13.4234016,55.6309042,117.2661843,1.8,55.5618206,116.9960439,1.0914013,3.4747575,5.9905816,33.080051,87.4614649,1.7612741,14.5998287,9.5201035,19.5685359,6.6379681,11.1470707,2.0516836,29.2977461),(29569,'full set',251,10,139,13.2048088,55.5345055,117.3936527,1.8,55.4774951,117.0794765,1.1026771,3.3235674,6.0766361,30.9097261,82.5351064,1.752742,13.5823678,9.3001651,18.1176549,6.4264627,11.3522236,2.0852476,28.5858157),(29570,'full set',251,10,140,13.0371855,55.4136207,117.4064858,1.8,55.3617019,117.096785,1.1324589,3.3951956,6.0792328,29.0511304,82.7878901,1.7814341,13.6181477,8.5565409,17.8990229,6.4644829,11.3440887,2.0005586,28.6900755),(29571,'full set',251,10,141,12.5155727,55.3348367,117.5211874,1.8,55.2917788,117.2890556,1.1407569,3.2740349,5.9509916,26.4643535,77.9478795,1.7233711,13.098301,8.0831007,17.3291171,6.3108778,11.1470707,2.0516836,28.9417809),(29572,'full set',251,10,142,12.3098482,55.2222033,117.6238808,1.8,55.1921365,117.427592,1.1499829,3.3032721,5.8316328,25.0654996,75.1102094,1.7092742,12.8797907,7.5880821,16.6869824,6.2868172,10.9549375,2.0169019,27.7264397),(29573,'full set',251,10,143,12.1647724,55.1102478,117.7523437,1.8,55.0568152,117.5135875,1.1566229,3.1930362,5.9135132,23.7826455,72.5045878,1.6991092,12.2608313,7.4482856,15.7567148,6.0624078,10.9549375,2.0169019,28.0824049),(29574,'full set',251,10,144,12.2613963,54.9462219,117.8362593,1.8,54.8744931,117.6521061,1.174804,3.1833548,5.7239997,23.2197964,72.614922,1.7395182,12.6860458,7.2941276,16.4656673,6.0492793,10.9549375,2.0169019,27.7264397),(29575,'full set',251,10,145,12.1582263,54.8281623,117.915535,1.8,54.7881902,117.7424325,1.1907957,3.2039887,5.769956,21.8887163,72.2903626,1.747578,12.5287545,6.8317083,16.0327263,6.0492793,10.9549375,2.0169019,27.7264397),(29576,'full set',251,10,146,11.8775301,54.6551004,118.0327445,1.8,54.6314691,117.8485524,1.1910262,2.9997203,5.8149128,20.8597609,69.5688067,1.7075461,11.9638606,6.9539019,15.1740184,5.8414437,10.9549375,2.0169019,27.7264397),(29577,'full set',251,10,147,11.9230166,54.5205568,118.1842684,1.8,54.4699816,118.02164,1.1980472,2.9733108,5.6723504,19.9160494,70.7441981,1.723621,12.4717608,6.6982737,15.7907536,5.7188642,10.9549375,2.0169019,27.4747343),(29578,'full set',251,10,148,11.7984741,54.3473133,118.267315,1.8,54.3156741,118.1680886,1.2167747,3.0231962,5.705812,19.6897285,71.1197655,1.7300849,12.4644424,6.5128847,15.6890808,5.761864,10.9549375,2.0169019,27.7264397),(29579,'full set',251,10,149,11.7512531,54.1805994,118.4185124,1.8,54.1640195,118.2964117,1.2265481,2.9586699,5.801105,19.0040764,71.3103287,1.7354664,12.2925423,6.4231824,15.2839855,5.7053109,11.171888,1.9655874,27.7264397),(29580,'full set',251,10,150,11.7358672,54.0273398,118.5189958,1.8,54.0080452,118.3809122,1.2407866,2.9130127,5.8619246,18.6529113,74.0427682,1.7505809,12.6311362,6.4033059,15.4817943,5.7385608,11.171888,1.9655874,28.3341103),(29581,'full set',251,10,151,11.9330875,53.879406,118.6595706,1.8,53.8482113,118.5559744,1.2578089,2.9897838,5.8258176,18.6762471,78.0920062,1.8002976,13.4044716,6.2466882,16.5797529,5.7700627,11.3440887,2.0005586,27.9781451),(29582,'full set',251,10,152,12.0636725,53.7191127,118.7402181,1.8,53.6877252,118.6314857,1.2652612,2.939452,5.8569857,18.5170284,82.5884535,1.8286863,14.100846,6.2994832,17.2029633,5.6914391,11.5697035,1.9513027,28.6900755),(29583,'full set',251,10,153,12.5889779,53.5985594,118.8943476,1.8,53.5672,118.7702142,1.2804717,2.9342041,5.8538837,19.3709922,89.0486152,1.9262255,15.2118868,6.6017877,18.272133,5.7064272,11.8222779,1.9040406,28.9417809),(29584,'full set',251,10,154,12.9717251,53.4620078,119.0488477,1.8,53.4911206,119.0034344,1.2817133,3.0046219,5.7240144,19.5223604,92.3485803,1.986259,16.1335339,6.4974432,19.0961638,5.7515901,11.9697226,1.9379702,29.1934863),(29585,'full set',251,10,155,13.1391246,53.3742826,119.361565,1.8,53.4057851,119.2776376,1.3029953,2.9008236,5.6047929,18.9615255,90.1040879,2.0365222,16.0762564,6.5366006,19.3511455,5.7352325,11.6887773,1.8692953,29.2977461),(29586,'full set',251,10,156,11.8181682,53.4500822,119.6480822,1.8,53.4393139,119.5804362,1.3769601,2.8234659,5.4489084,13.8163383,73.7509755,1.8966106,13.5350002,4.8933965,16.0704867,5.4748167,11.0137676,1.929567,27.1187691),(29587,'full set',251,10,157,8.4883061,53.6442987,119.5436142,1.8,53.6751927,119.5734743,1.3490262,2.1053958,4.8208848,6.2834717,42.2567174,1.3462723,8.7653447,2.984461,10.0489285,4.3505664,9.798394,1.8370484,23.8287107),(29588,'full set',251,10,158,6.1160115,53.6641688,119.47109,1.8,53.6805497,119.5310815,1.330273,2.0368644,4.1591372,3.8713269,21.1612978,0.9614936,5.0879057,1.9006307,5.9109445,4.135461,8.463872,1.9890207,20.286947),(29589,'full set',251,10,159,2.215973,54.0511204,119.4206851,1.8,54.0314453,119.4022841,1.4032551,1.2597877,2.6607415,0.7334208,2.9352418,0.3590584,1.1031668,0.5821781,1.3782407,2.578128,5.4351711,1.8925469,12.951714),(29590,'full set',251,10,160,0.2150121,54.2190672,119.4418593,1.8,54.2067938,119.453264,1.4789291,0.5463898,0.8993371,0.0251504,0.0597715,0.0355338,0.0664617,0.0460301,0.0904409,1.289064,2.3139407,1.9513027,5.3647756),(29591,'full set',251,10,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29592,'full set',251,10,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29593,'full set',251,10,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29594,'full set',251,10,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29595,'full set',251,10,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29596,'full set',251,10,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29597,'full set',251,10,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29598,'full set',251,10,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29599,'full set',251,10,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29600,'full set',251,10,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29601,'full set',251,10,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29602,'full set',251,10,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29603,'full set',251,10,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29604,'full set',251,10,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29605,'full set',251,10,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29606,'full set',251,10,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29607,'full set',251,10,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29608,'full set',251,10,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29609,'full set',251,10,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29610,'full set',251,10,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29611,'full set',251,10,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29612,'full set',251,10,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29613,'full set',251,10,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29614,'full set',251,10,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29615,'full set',251,10,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29616,'full set',251,10,186,0.2718563,61.0496536,121.1201068,1.8,60.7882141,121.0456372,0.3321341,0.5839432,4.0913348,0.0352906,2.6811559,0.0048171,0.6553255,0.060435,0.663743,3.867192,6.2563517,2.863293,16.2417724),(29617,'full set',251,10,187,9.2310294,59.5135121,120.1404184,1.8,60.0889808,120.3992189,0.409078,2.2814259,5.6784981,7.1805527,51.9757762,0.2434158,9.153085,3.1473969,10.3917488,4.29688,5.4351711,0.3217506,15.130691),(29618,'full set',251,10,188,19.7383119,60.5517076,120.4624025,1.8,60.8889931,120.6303153,0.5330428,2.8992905,4.8125562,26.8859325,101.9311489,0.8494806,21.1802509,9.2732799,26.6352819,6.3181644,9.6560368,2.5782764,26.6153583),(29619,'full set',251,10,189,28.3763376,61.5338917,120.4408436,1.8,61.4819532,120.5411974,0.6688153,4.3412065,4.608749,74.120237,123.5508059,1.8183116,26.8078833,17.0736493,40.2153809,8.3922875,9.798394,2.4805495,28.9417809),(29620,'full set',251,10,190,24.6370965,61.6730172,120.3008769,1.8,61.5896588,120.4929835,0.8677965,4.1080088,5.1345187,73.9665293,112.8540926,2.3899045,21.9794882,18.0054457,35.320536,8.1075676,10.0311674,2.3259007,28.5858157),(29621,'full set',251,10,191,19.6927694,61.7537566,120.2935982,1.8,61.7185055,120.3474326,0.7818731,4.0250155,4.9565523,58.4589343,94.8228243,1.6294946,19.1308027,14.5239028,30.1107639,7.6927216,9.7417008,2.2937757,27.4747343),(29622,'full set',251,10,192,18.1414708,61.6701138,120.1441639,1.8,61.74216,120.2907915,0.5303749,4.010403,4.4422089,53.358556,82.546953,0.7737068,18.5824113,13.3050358,27.7230127,7.6302573,9.4628966,2.4526683,26.5110985),(29623,'full set',251,10,193,15.8038088,61.4805676,119.9436156,1.8,61.6148384,120.1573068,0.0992077,3.4062795,3.9743128,41.7271323,69.0669771,0.025839,17.3783443,12.250061,24.6272416,6.44532,8.7005189,2.5672878,24.3321216),(29624,'full set',251,10,194,15.4087527,61.501072,120.0096724,1.8,61.604226,120.1721259,0.0966076,3.3421639,3.9997043,41.2641365,67.5960398,0.0238939,16.9002592,12.346533,26.0627428,6.44532,8.6473042,2.677945,24.1846759),(29625,'full set',251,10,195,15.7626862,61.5512576,120.1315303,1.8,61.598291,120.2487675,0.1261881,3.2309724,4.0268373,40.5523637,68.7763973,0.0416112,17.0795075,12.5511329,26.8932415,6.44532,8.4747721,2.6098686,24.4363813),(29626,'full set',251,10,196,15.6528583,61.5805444,120.2024926,1.8,61.5214532,120.2900248,0.1694655,3.1685635,4.0713805,39.8612313,67.1992396,0.0742068,16.5052713,12.5802215,25.9974998,6.44532,8.4420297,0.2573237,24.1846759),(29627,'full set',251,10,197,15.5103561,61.5791156,120.257943,1.8,61.522343,120.3105022,0.1681614,3.18553,4.0791663,38.8399313,63.2621903,0.0724145,15.5086077,12.1926118,25.0186445,6.44532,8.2652137,2.6546934,23.9329705),(29628,'full set',251,10,198,15.302002,61.4650743,120.2642006,1.8,61.4019812,120.3365116,0.1711715,3.1613284,3.9682114,37.9441364,60.5009727,0.073997,15.2464088,12.0025925,24.6637567,6.44532,8.1527566,0.3217506,23.0735945),(29629,'full set',251,10,199,14.73563,61.4633121,120.2557101,1.8,61.4340166,120.3558361,0.1617474,3.1660266,3.8944393,35.9066005,55.549481,0.0636944,14.2637944,11.3412187,23.3575872,6.44532,8.0272343,0.2709469,23.0735945),(29630,'full set',251,10,200,14.7140337,61.3946691,120.2615085,1.8,61.3722456,120.3674938,0.1548794,3.1470772,3.8291909,35.4199314,54.2134569,0.0583569,14.1579406,11.2548658,22.8447663,6.44532,8.0272343,0.2709469,23.0735945),(29631,'full set',251,10,201,14.8170358,61.3819767,120.2750435,1.8,61.3506678,120.3542227,0.1368026,3.1255109,3.8217184,34.8114645,52.6082846,0.0459291,13.76561,11.1378479,22.8108274,6.44532,7.9230552,2.9229237,22.8218891),(29632,'full set',251,10,202,15.0186761,61.3204498,120.2992164,1.8,61.2651923,120.3842547,0.12632,3.0896952,3.7648831,34.8675019,51.9737572,0.0397295,13.8048793,11.2850943,22.5990755,6.44532,7.8410702,2.976444,22.5701837),(29633,'full set',251,10,203,15.2524311,61.299751,120.3138678,1.8,61.1974871,120.4165206,0.1053111,3.0649576,3.7462376,34.6061705,51.0168316,0.0280886,13.6181516,11.2909134,22.418993,6.44532,7.7463106,0.3392926,22.2142185),(29634,'full set',251,10,204,15.705898,61.2439349,120.3377997,1.8,61.1719462,120.4275298,0.0963771,3.0734737,3.6925005,35.1521432,50.4748344,0.024239,13.669554,11.4372683,22.7763642,6.44532,7.6140908,2.8555412,22.2142185),(29635,'full set',251,10,205,15.6178342,61.2297365,120.3463385,1.8,61.15576,120.4242164,0.0802495,3.0505947,3.6769395,34.8957693,48.8561594,0.0167271,13.2871807,11.4390053,22.3712475,6.44532,7.6140908,2.8555412,21.9625131),(29636,'full set',251,10,206,15.7384603,61.148522,120.375778,1.8,61.0679233,120.452704,0.0886996,3.0851784,3.5999504,35.0794925,47.8964864,0.0205833,13.304763,11.3703286,22.6831844,6.44532,7.5041783,2.910502,21.7108077),(29637,'full set',251,10,207,15.8190269,61.1152747,120.4098555,1.8,61.0767312,120.5055113,0.0710142,3.001795,3.5655538,34.5766986,46.0035424,0.0132736,12.902215,11.5186742,22.2704081,6.015632,7.5041783,0.2310907,21.3548425),(29638,'full set',251,10,208,15.5661373,61.0483543,120.4204419,1.8,60.9752548,120.4845152,0.0682674,2.9834195,3.4987437,34.2543396,44.0138608,0.0120721,12.5799043,11.48157,22.0435416,6.015632,7.3425118,0.3587707,20.9988773),(29639,'full set',251,10,209,15.3227031,61.0435496,120.4356476,1.8,61.00035,120.5070227,0.0535497,2.9511601,3.4669741,33.6235957,41.5869362,0.0073162,11.9951677,11.3933487,21.2295358,6.015632,7.2028834,0.3028849,20.9988773),(29640,'full set',251,10,210,15.2034198,60.9682802,120.452166,1.8,60.875918,120.522307,0.0173798,2.8894354,3.3994686,33.1878203,40.3497495,0.0007653,11.8694286,11.4859189,21.218849,6.015632,7.2028834,0.3028849,20.7471719),(29641,'full set',251,10,211,14.9318432,60.9597863,120.4908052,1.8,60.8989906,120.5619651,-0.0209975,2.857266,3.3951516,32.2057661,38.4610276,0.0010971,11.3282211,11.2715322,20.4859444,6.015632,7.086596,0.2449787,20.4954665),(29642,'full set',251,10,212,14.8611237,60.8772318,120.5191068,1.8,60.8175764,120.60596,-0.0567412,3.2336897,3.3307575,32.0001402,37.7416396,0.0079658,11.3312482,9.8958598,20.7377963,6.44532,7.086596,0.2449787,21.1031371),(29643,'full set',251,10,213,14.6183608,60.851741,120.5375141,1.8,60.798232,120.6139456,-0.0945392,3.213761,3.3188269,31.2254895,36.0054472,0.0217108,10.8488476,9.7161829,20.1623828,6.44532,6.9948139,0.1853479,21.1031371),(29644,'full set',251,10,214,14.4894543,60.7808041,120.5531648,1.8,60.7065302,120.6218058,-0.1107361,3.2033556,3.2513854,30.7662048,35.2565422,0.029492,10.8435445,9.6043675,20.1781713,6.44532,6.7939638,2.536048,20.7471719),(29645,'full set',251,10,215,14.3978098,60.7593021,120.5780605,1.8,60.7019974,120.6316108,-0.1820007,3.1660986,3.236074,29.8300336,34.1699746,0.0786124,10.5590832,9.4217008,19.6550011,6.3433159,6.7939638,2.8198421,20.7471719),(29646,'full set',251,10,216,14.3696674,60.6831447,120.5923559,1.8,60.6151843,120.641537,-0.2361126,3.1479663,3.1544017,29.3337206,33.4300473,0.1310534,10.5979041,9.3183084,19.6049011,6.3433159,6.7939638,0.3217506,20.2437611),(29647,'full set',251,10,217,14.1211419,60.6734274,120.5987241,1.8,60.5995202,120.650445,-0.2887792,3.1183986,3.130332,28.5783274,32.3835231,0.1908729,10.3450762,9.164424,19.0889744,6.3433159,6.6705516,2.8809903,20.2437611),(29648,'full set',251,10,218,14.0429811,60.6135615,120.6087785,1.8,60.5996923,120.6328534,-0.3112993,2.9819406,3.061996,28.0494803,31.9096425,0.2195786,10.4211901,9.4064517,18.887928,6.342225,6.6705516,2.8809903,20.2437611),(29649,'full set',251,10,219,14.0530519,60.6010177,120.6282958,1.8,60.5806031,120.6288255,-0.3287632,2.9593319,3.0731699,27.3479174,31.1943668,0.2441642,10.1505506,9.2412472,18.5650375,6.342225,6.6705516,0.2606024,20.2437611),(29650,'full set',251,10,220,13.9514485,60.5350127,120.6385436,1.8,60.4716105,120.6335109,-0.3549983,2.9353084,3.107238,26.7565345,30.5411042,0.280931,9.8290198,9.1154083,18.2793254,6.015632,6.725681,0.4636476,19.8877959),(29651,'full set',251,10,221,13.8653429,60.528409,120.6479572,1.8,60.4494184,120.6768788,-0.3582753,2.9254049,3.0973275,25.9954414,29.8044468,0.284152,9.6226332,8.8861004,17.8592673,6.015632,6.5729625,1.3734008,19.8877959),(29652,'full set',251,10,222,13.8374803,60.4630779,120.6580124,1.8,60.3994329,120.7055784,-0.3659752,2.9313477,3.0315446,25.641446,29.5906237,0.2953468,9.7609068,8.7473234,17.7748798,6.015632,6.5729625,1.3734008,19.8877959),(29653,'full set',251,10,223,13.6839562,60.4585628,120.6838039,1.8,60.3896605,120.7650929,-0.3618597,2.9128816,3.0187878,25.0467478,29.123521,0.2858259,9.6474224,8.5986152,17.1833527,6.015632,6.5589027,1.0191413,19.5318307),(29654,'full set',251,10,224,13.6421623,60.3993773,120.6878469,1.8,60.3400682,120.7564625,-0.36542,2.9267961,3.0233799,24.8741176,28.999634,0.2903348,9.5917929,8.4987532,17.1828399,6.015632,6.5589027,0.551655,19.2801253),(29655,'full set',251,10,225,13.5829123,60.394965,120.6953898,1.8,60.3570295,120.7677701,-0.3900907,2.8979129,3.0334819,24.4475509,28.6640764,0.327364,9.4492327,8.4362614,16.9847956,6.015632,6.5589027,0.551655,19.2801253),(29656,'full set',251,10,226,13.5049753,60.3308868,120.6974687,1.8,60.3005106,120.7394442,-0.3839481,2.8494883,2.9320737,24.3605625,28.3081747,0.315821,9.6546599,8.5491009,16.9249202,6.015632,6.5589027,1.0191413,19.2801253),(29657,'full set',251,10,227,13.3751176,60.3191729,120.7026555,1.8,60.3005106,120.7394442,-0.3965819,2.8496434,2.9407811,24.0746289,28.0376213,0.3326009,9.5340728,8.4482952,16.7857136,6.015632,6.5589027,1.0191413,19.2801253),(29658,'full set',251,10,228,13.3515071,60.2454961,120.7111759,1.8,60.2222055,120.7451926,-0.3476195,2.8268174,3.0262086,23.9578476,28.1610853,0.2582397,9.3057318,8.4752017,16.6912533,5.9587733,6.5729625,2.9441971,19.6360905),(29659,'full set',251,10,229,13.2180687,60.2366187,120.7083225,1.8,60.2222055,120.7451926,-0.3207077,2.8614136,3.0384391,23.7497016,28.0441988,0.2189246,9.2298046,8.2999889,16.6360084,5.9587733,6.5729625,2.9441971,19.6360905),(29660,'full set',251,10,230,13.14858,60.1754376,120.723077,1.8,60.1679332,120.7655544,-0.2949985,2.8907473,3.0267016,23.7595852,28.0746677,0.1852391,9.2756641,8.2191845,16.9384289,5.9587733,6.5729625,2.9441971,19.6360905),(29661,'full set',251,10,231,12.9669695,60.1781952,120.7404796,1.8,60.1649714,120.7653985,-0.2992606,2.86945,3.0222587,23.5713891,28.0911587,0.1878377,9.2947566,8.2146019,16.8816959,5.9587733,6.5729625,2.9441971,19.6360905),(29662,'full set',251,10,232,12.9405056,60.1127105,120.765253,1.8,60.1022533,120.8220052,-0.3053026,2.8599661,3.0463628,23.7581658,28.4185392,0.1948611,9.3286785,8.3071495,16.8618859,5.9587733,6.6705516,2.8809903,19.6360905),(29663,'full set',251,10,233,12.7452435,60.1186366,120.7892672,1.8,60.1136358,120.8561526,-0.3179919,2.9585621,3.041836,23.9815824,28.4432651,0.2076542,9.35069,8.1058236,16.8821965,6.015632,6.6705516,2.8809903,19.6360905),(29664,'full set',251,10,234,12.5937895,60.0522052,120.8100472,1.8,60.0274136,120.8569115,-0.3490989,2.9453419,2.9993409,23.9705534,28.5322438,0.2455769,9.5128378,8.138462,16.8674608,6.015632,6.5729625,2.9441971,19.6360905),(29665,'full set',251,10,235,12.4613022,60.0577232,120.84318,1.8,60.0417365,120.874099,-0.3524464,2.9106371,2.9922311,24.0875597,28.6380126,0.2474803,9.570789,8.2757,16.9641999,6.015632,6.5729625,2.9441971,19.6360905),(29666,'full set',251,10,236,12.2895946,59.9986345,120.8653755,1.8,59.9966386,120.8991061,-0.3447543,2.9135364,3.0764979,24.0363565,28.6277809,0.2339542,9.3053146,8.2498905,17.1019565,6.015632,6.725681,0.4636476,19.2801253),(29667,'full set',251,10,237,12.0775478,60.0018197,120.8976106,1.8,59.9908321,120.9136225,-0.3380361,2.8848395,3.0678418,24.0971684,28.7460313,0.2213849,9.3701154,8.3530361,17.0966195,6.015632,6.725681,0.4636476,19.2801253),(29668,'full set',251,10,238,11.9561385,59.9426935,120.927199,1.8,59.9429179,120.9528463,-0.3249896,2.8805849,3.0004926,24.2743731,28.9176378,0.2031583,9.63763,8.4268904,17.284002,6.015632,6.7119411,0.6947383,19.5318307),(29669,'full set',251,10,239,11.7731852,59.9325331,120.9569076,1.8,59.9300177,120.9772241,-0.283971,2.9848381,3.0939537,24.3943304,29.0013698,0.1540229,9.3735629,8.1727483,16.8739409,6.015632,6.7939638,0.6055447,19.5318307),(29670,'full set',251,10,240,11.6644203,59.8691929,120.973014,1.8,59.8764574,120.9599989,-0.2250771,2.9629604,3.1153282,24.5342861,29.3293619,0.0968341,9.4145336,8.2803286,17.0518712,6.015632,6.7939638,0.6055447,20.1395013),(29671,'full set',251,10,241,11.4366518,59.8761605,120.9574495,1.8,59.8680132,120.9446972,-0.145407,2.9283365,3.1551148,24.4629213,29.3188717,0.040018,9.2924898,8.3538629,16.9944688,6.015632,6.7939638,2.536048,20.3912067),(29672,'full set',251,10,242,11.4444287,59.8107668,120.9531881,1.8,59.8005274,120.9174874,-0.1078482,2.9104033,3.1437924,24.45164,30.0361051,0.0220996,9.5540994,8.4014611,17.2471612,6.015632,6.7939638,2.8198421,20.1395013),(29673,'full set',251,10,243,11.5137495,59.8233102,120.9659144,1.8,59.8286829,120.9544864,-0.0754599,2.8661983,3.1435907,24.3932394,30.9169285,0.0109062,9.8349089,8.51066,17.4343434,6.015632,6.7939638,2.536048,20.3912067),(29674,'full set',251,10,244,11.7180194,59.7462678,121.0007222,1.8,59.7526737,121.002745,-0.0682045,2.8605494,3.0906547,24.553773,32.0378105,0.009071,10.3660271,8.5835865,17.5357692,6.015632,6.9418221,2.7610863,20.1395013),(29675,'full set',251,10,245,11.7795633,59.7270728,121.0266138,1.8,59.7447514,121.0374149,-0.1010992,2.8912095,3.1074454,24.9660867,33.3909616,0.0199983,10.7454699,8.6351705,17.8765349,6.015632,7.0474072,0.6556956,20.6429122),(29676,'full set',251,10,246,11.9107638,59.6556693,121.0494611,1.8,59.6745486,121.0444117,-0.1042179,2.9516244,3.3610245,25.6205083,34.7991161,0.0214832,10.3537228,8.6801383,17.8728668,6.015632,7.112602,0.4366272,20.7471719),(29677,'full set',251,10,247,12.1954324,59.6136224,121.0975095,1.8,59.6485069,121.0626409,-0.1127019,2.9503149,3.3601068,26.0698764,37.1515896,0.025708,11.0566692,8.836303,18.8018657,6.015632,7.2028834,0.3028849,20.7471719),(29678,'full set',251,10,248,12.6368143,59.5260971,121.1318539,1.8,59.5370638,121.0835508,-0.1165199,2.9741714,3.3317887,27.1175848,39.9006101,0.0284656,11.9757325,9.117694,19.4658608,6.015632,7.3425118,0.3587707,21.2505827),(29679,'full set',251,10,249,13.415233,59.5249057,121.162572,1.8,59.5304701,121.108964,-0.1217055,3.0560352,3.3694884,29.1454811,43.9602099,0.032955,13.0465532,9.537024,20.8423917,6.44532,7.5164702,0.5404195,21.8582533),(29680,'full set',251,10,250,13.6979994,59.4385991,121.2050898,1.8,59.4560877,121.1197259,-0.1213637,3.0876927,3.6008489,29.454693,46.8557927,0.0334619,13.0124296,9.5393862,21.1447824,6.44532,7.6503773,0.6659692,22.4659239),(29681,'full set',251,10,251,14.487552,59.4261663,121.2350698,1.8,59.460736,121.1528715,-0.1180955,3.1153322,3.7193631,30.4045644,51.8338047,0.0335189,13.9362043,9.7596541,21.885875,6.44532,7.8997178,0.390607,22.8218891),(29682,'full set',251,10,252,14.9814141,59.3619791,121.2957895,1.8,59.4131881,121.1886223,-0.1410588,3.1096289,3.6315808,30.8391626,55.3800557,0.0493537,15.249573,9.9173127,22.4355478,6.44532,8.107337,0.5585993,23.2210402),(29683,'full set',251,10,253,16.0952472,59.3791185,121.3529505,1.8,59.4382113,121.2446117,-0.170077,3.1566511,3.9344876,32.7777981,61.8607006,0.0768504,15.7226829,10.3837255,23.9155649,6.44532,8.3430318,0.2074962,23.9329705),(29684,'full set',251,10,254,17.1466972,59.3207649,121.4282865,1.8,59.3478281,121.3020532,-0.1724307,3.2197693,4.0105158,34.324609,68.392326,0.0841298,17.0532496,10.6605802,25.5149961,6.44532,8.5614727,0.3058789,24.1846759),(29685,'full set',251,10,255,18.6090928,59.3052159,121.5489852,1.8,59.3149226,121.4398968,-0.1725183,3.2621981,4.1220324,36.9099949,75.766086,0.0913969,18.3807596,11.3144554,26.442697,6.6707909,8.8582451,0.3985224,25.0440519),(29686,'full set',251,10,256,20.1740429,59.2087694,121.6490797,1.8,59.2546796,121.5559176,-0.1847651,3.2238127,4.286248,39.6896941,82.2042582,0.1134838,19.1786051,12.3114143,28.1912458,6.7115212,9.0642783,0.5485494,25.6517225),(29687,'full set',251,10,257,23.6329234,59.1442637,121.7514037,1.8,59.1756203,121.7078622,-0.2173241,3.2356203,4.4776828,45.7721469,96.2041362,0.1831192,21.4852506,14.1463282,30.8575896,6.44532,9.4335845,0.5247958,25.7991682),(29688,'full set',251,10,258,22.4106051,59.3055355,121.6039267,1.8,59.3543517,121.6973835,-0.1077538,3.3107143,4.4651054,41.0947856,91.422183,0.0432003,20.4748096,12.4126646,28.4755738,6.44532,9.2955727,0.5880026,26.4068387),(29689,'full set',251,10,259,9.0586504,60.3452793,121.5855445,1.8,59.8521902,121.6714585,-0.0610347,2.708979,4.5833106,12.8070459,30.0107375,0.0056173,6.5478297,4.7276284,8.9024855,5.585944,8.2652137,0.4868992,25.3568313),(29690,'full set',251,10,260,1.2400542,61.1946939,121.3093518,1.8,61.23054,121.4649851,1.428041,1.2405773,2.1485769,0.3491614,1.498504,0.2024924,0.6974402,0.2814507,0.8043379,2.578128,4.6278814,1.9513027,11.9448924),(29691,'full set',251,10,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29692,'full set',251,10,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29693,'full set',251,10,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29694,'full set',251,10,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29695,'full set',251,10,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29696,'full set',251,10,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29697,'full set',251,10,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29698,'full set',251,10,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29699,'full set',251,10,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29700,'full set',251,10,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29701,'full set',251,10,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29702,'full set',251,10,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29703,'full set',251,10,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29704,'full set',251,10,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29705,'full set',251,10,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29706,'full set',251,10,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29707,'full set',251,10,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29708,'full set',251,10,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29709,'full set',251,10,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29710,'full set',251,10,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29711,'full set',251,10,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29712,'full set',251,10,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29713,'full set',251,10,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29714,'full set',251,10,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29715,'full set',251,10,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29716,'full set',251,10,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29717,'full set',251,10,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29718,'full set',251,10,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29719,'full set',251,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29720,'full set',251,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29721,'full set',251,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29722,'full set',251,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29723,'full set',251,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29724,'full set',251,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29725,'full set',251,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29726,'full set',251,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29727,'full set',251,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29728,'full set',251,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29729,'full set',251,2,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29730,'full set',251,2,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29731,'full set',251,2,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29732,'full set',251,2,14,0.4033925,106.9594149,116.3620134,1.8,106.9708276,116.338026,-0.7280976,0.8432399,1.1823807,0.0812782,0.1293453,0.029772,0.109394,0.0963879,0.1781216,2.1268471,2.7513456,0.6747409,6.5801168),(29733,'full set',251,2,15,12.0296555,107.0478169,117.9154414,1.8,106.8991267,118.6663655,-1.2555663,3.1105488,6.372577,24.4110434,81.3807249,1.8122238,12.7704578,7.8478253,16.5117417,9.485311,12.3043918,1.1383886,45.0361077),(29734,'full set',251,2,16,22.1074733,106.9574127,118.8930241,1.8,106.8714622,119.1900801,-1.3032136,3.6613942,6.3665337,46.6833239,182.0283002,3.4269979,28.5914295,12.7501495,35.519161,11.8004998,14.5397175,0.9745972,51.8679299),(29735,'full set',251,2,17,26.5442868,106.9045326,119.3864538,1.8,106.4260656,119.6792917,-1.1687019,4.3291559,7.3084926,79.6133942,219.4379123,3.7464953,30.0250577,18.3900503,40.9012738,13.3687531,17.1121594,0.6786625,54.5503177),(29736,'full set',251,2,18,26.0759376,106.4533023,119.8212148,1.8,106.0761638,120.0621742,-0.9756279,5.0248096,7.3893744,87.2047039,257.7950681,2.9799302,34.8872657,17.3548276,46.0461594,13.0649178,17.9905393,0.7008544,50.6525887),(29737,'full set',251,2,19,24.2596085,105.8545518,120.2310522,1.8,105.9338397,120.0752992,-0.8739294,5.1081715,7.9240144,77.5496815,273.2029662,2.377722,34.4778482,15.1814954,43.180844,12.4572472,17.6643059,0.7165417,48.8295769),(29738,'full set',251,2,20,22.6189593,105.5898427,120.3333359,1.8,105.8898231,120.0740501,-0.8642562,5.2459049,8.1560131,67.6159382,268.1050586,2.1809635,32.8720729,12.8892801,40.2685255,12.1534119,17.3851149,0.6979028,47.9702009),(29739,'full set',251,2,21,20.0787617,105.4050528,120.2985811,1.8,105.8468634,120.024251,-0.8605524,5.1285275,7.9179017,55.6487765,250.3319463,1.9237849,31.6159453,10.8508294,38.1217956,11.8495766,16.7798528,0.6947383,46.8591195),(29740,'full set',251,2,22,18.8021729,105.3215002,120.2752624,1.8,105.8064217,120.0261813,-0.8603498,5.206988,7.9544485,50.5704349,242.5759354,1.8008446,30.4956321,9.7120323,36.4145239,11.5095215,16.7798528,0.6947383,45.8954837),(29741,'full set',251,2,23,17.8133298,105.2490934,120.3032914,1.8,105.7983117,119.9868883,-0.8486163,5.237006,8.0082661,48.0327862,231.3648358,1.6716321,28.8907529,9.1718028,34.4407355,11.2032467,16.7137033,0.7672183,44.5758827),(29742,'full set',251,2,24,16.8345017,105.1149415,120.3355532,1.8,105.6604174,120.0100623,-0.8550301,5.0387988,8.1287863,44.4919977,221.5187212,1.597614,27.2511433,8.8298817,32.3939265,11.1820393,16.4183554,0.748378,44.3241773),(29743,'full set',251,2,25,16.075721,105.0554499,120.2839929,1.8,105.5476713,120.0963143,-0.8518019,5.1142833,7.8020441,41.0216482,215.6184259,1.5170355,27.6361454,8.0209964,32.7099066,10.6342355,16.1747714,0.6913369,42.8571307),(29744,'full set',251,2,26,15.8553938,105.0080993,120.2679427,1.8,105.4846082,120.0530052,-0.8496783,5.1582827,7.8194737,38.7772061,212.6289515,1.4906798,27.1922331,7.5174643,31.9846559,10.3304002,15.9042615,0.6705216,41.9977547),(29745,'full set',251,2,27,15.8317273,104.9626999,120.2982643,1.8,105.4062578,120.0851581,-0.842176,5.1640012,7.8661092,39.9987717,207.0024893,1.4688041,26.3157405,7.7456938,31.2214125,10.0265649,15.8461105,0.7086263,41.3900841),(29746,'full set',251,2,28,15.6011054,104.9726775,120.3151009,1.8,105.3817897,120.1220265,-0.8363413,5.1386092,7.8668591,40.9845694,203.702296,1.4323247,25.8937262,7.9758098,30.8980331,10.0265649,15.5698916,0.6876713,41.1383787),(29747,'full set',251,2,29,15.8263562,105.0062998,120.262933,1.8,105.3916422,120.0781156,-0.8284711,5.1397338,7.7982922,42.0141465,204.1784757,1.4323371,26.1824604,8.1743818,31.3334676,9.7227296,15.5223861,0.7266423,40.5307081),(29748,'full set',251,2,30,15.5826423,105.0268722,120.2765003,1.8,105.407315,120.0585055,-0.8157638,5.1004399,7.468324,43.6390602,195.7849533,1.377368,26.2153802,8.5559406,31.8811926,9.6088866,15.3007547,0.6659692,39.5670723),(29749,'full set',251,2,31,15.706961,104.9953909,120.1947646,1.8,105.3383542,119.9971944,-0.8210464,5.1854993,7.4340216,41.2232462,197.86738,1.4021552,26.6164656,7.9497159,32.0315544,9.4188943,14.9652379,0.6837093,39.0636615),(29750,'full set',251,2,32,15.9326034,105.0400917,120.1333199,1.8,105.333003,119.9763624,-0.8220675,5.1957454,7.3592629,41.2992331,199.7017969,1.4250026,27.1361142,7.9486637,32.6193954,9.4188943,14.9158068,0.72425,39.0636615),(29751,'full set',251,2,33,16.0595517,105.0604907,120.0837282,1.8,105.2805468,120.0366615,-0.8179635,4.9165742,7.3063798,42.2295772,198.0763439,1.4253984,27.1100531,8.5892281,32.7543759,9.115059,14.6975909,0.6610432,38.2042855),(29752,'full set',251,2,34,16.1702189,105.1247361,120.0487186,1.8,105.3261749,120.0004585,-0.8108063,4.8843469,7.231795,44.1165591,194.4929332,1.4159645,26.8941435,9.0322331,32.8231137,9.115059,14.6346459,0.7022569,37.8483203),(29753,'full set',251,2,35,16.1111927,105.1421223,119.987941,1.8,105.3433843,119.9581474,-0.8075028,4.9094322,7.1733763,43.4333444,189.6140171,1.4019354,26.4330226,8.846918,32.3188747,9.032932,14.4377726,0.6375488,37.5966149),(29754,'full set',251,2,36,16.2120128,105.1708017,119.9545548,1.8,105.3688465,119.9512706,-0.8034114,4.9067146,7.1263715,43.3101606,187.4199117,1.3996623,26.2994865,8.8267128,32.1937837,8.9480626,14.0948144,0.6556956,37.3449095),(29755,'full set',251,2,37,16.3526687,105.1523724,119.9509487,1.8,105.3265853,120.0109442,-0.7992564,4.9172017,6.8253951,43.0953151,184.7330269,1.4004873,27.0655434,8.7641951,33.2987948,8.6855039,14.0948144,0.6556956,36.3812737),(29756,'full set',251,2,38,16.4025193,105.1709252,119.9392277,1.8,105.3085989,120.0304844,-0.8009175,4.9141605,6.8048463,43.0500627,181.7443762,1.4092959,26.7080794,8.7604103,32.9561667,8.6855039,14.0948144,0.6556956,36.3812737),(29757,'full set',251,2,39,16.2276786,105.2577736,119.8622768,1.8,105.3513483,119.9977824,-0.8000046,4.9043264,6.688706,42.7788845,176.4621344,1.3918057,26.3821035,8.7226829,32.6922283,8.6110275,13.7567282,0.6747409,36.3812737),(29758,'full set',251,2,40,16.2171042,105.3470571,119.7920305,1.8,105.4921732,119.8584522,-0.800248,4.8894689,6.5762314,42.9896432,168.4004262,1.3915564,25.6074362,8.792293,32.0528778,8.5485395,13.4924769,0.6498704,35.7736031),(29759,'full set',251,2,41,16.1614349,105.4186329,119.7124528,1.8,105.5279805,119.8019144,-0.8019267,4.8950763,6.4700971,43.006149,158.5821848,1.391299,24.5100161,8.7855932,31.0705349,8.4141472,13.2369013,0.6240231,35.1659325),(29760,'full set',251,2,42,15.8934391,105.4886687,119.6610895,1.8,105.5638897,119.7474648,-0.8033132,4.5832525,6.3851685,42.6955595,148.5892454,1.3718983,23.2709984,9.3155591,29.8703544,8.2313064,12.9905136,0.5971767,34.9142271),(29761,'full set',251,2,43,15.7249766,105.5800849,119.5584925,1.8,105.6352973,119.6331334,-0.8114436,4.5966048,6.2515825,42.0272285,138.5541022,1.3786446,22.1630448,9.1431024,28.8168741,8.1956634,12.5495381,0.6640462,33.6988859),(29762,'full set',251,2,44,15.5767117,105.6543124,119.5121482,1.8,105.7417578,119.5566323,-0.8262948,4.5870741,6.1729337,41.3984063,130.2949326,1.4041134,21.1074571,9.0250136,27.7660286,8.1247444,12.2140278,0.6857295,33.4471805),(29763,'full set',251,2,45,15.4724786,105.7385822,119.4540129,1.8,105.8492585,119.4720368,-0.8362095,4.5712186,5.788587,41.329875,121.4108226,1.4201774,20.9741727,9.0413255,27.9417516,8.091519,11.7988288,0.5779019,32.2318393),(29764,'full set',251,2,46,15.2579701,105.8273463,119.3926439,1.8,105.9212986,119.4297487,-0.8514483,4.5543441,5.693076,40.9133637,115.7665532,1.4389746,20.334623,8.9833712,27.3784896,8.091519,11.4655059,0.2267988,31.9801339),(29765,'full set',251,2,47,15.220708,105.8968387,119.339348,1.8,105.9868421,119.3931077,-0.8615372,4.5409447,5.6129551,41.3033992,110.2891979,1.460795,19.6490433,9.0957724,26.8823745,8.0305001,11.2048922,0.5667292,31.3724633),(29766,'full set',251,2,48,15.1744382,105.9403504,119.3261917,1.8,106.0139455,119.378344,-0.8757454,4.520462,5.5272988,41.033859,106.1287205,1.49179,19.2008293,9.0773595,26.6186655,8.0305001,11.0889478,0.6202495,31.3724633),(29767,'full set',251,2,49,15.1823829,106.0091826,119.2972382,1.8,106.0676954,119.3677763,-0.893636,4.488657,5.4586174,40.7648244,101.5720626,1.5369491,18.6076538,9.0817419,26.0613229,7.7856148,10.8788312,0.1586553,30.7647927),(29768,'full set',251,2,50,15.1931252,106.0573162,119.2740376,1.8,106.1488504,119.3532308,-0.9130011,4.4658565,5.4063038,40.3129821,98.8275787,1.5857122,18.2800638,9.0269318,25.7064058,7.7856148,10.7422,0.6435011,30.4088275),(29769,'full set',251,2,51,15.1347703,106.1232894,119.2200815,1.8,106.1765941,119.317694,-0.9317007,4.4436673,5.3177892,39.9801667,95.4817652,1.6250298,17.9551618,8.9971107,25.420552,7.7856148,10.6125107,0.3729877,29.8011569),(29770,'full set',251,2,52,14.9475089,106.1905048,119.1977154,1.8,106.2620772,119.2607262,-0.9497384,4.397682,5.2534369,39.3612396,92.2775338,1.6477067,17.5651742,8.9504516,24.986353,7.7290989,10.4900209,0.610726,29.4451917),(29771,'full set',251,2,53,14.702676,106.252509,119.1783089,1.8,106.3960596,119.2456619,-0.9699118,4.3498025,5.1932941,38.5220018,87.7654654,1.6671712,16.8997679,8.8560346,24.2213981,7.734384,10.2496576,0.5763752,28.5858157),(29772,'full set',251,2,54,14.7374204,106.2943659,119.1822132,1.8,106.4346832,119.2601458,-0.9810806,4.3072402,5.1677678,38.6912532,85.586437,1.6965847,16.5615872,8.9828408,23.9438886,7.734384,10.1410009,0.6350267,28.5858157),(29773,'full set',251,2,55,14.8643128,106.3398583,119.1824407,1.8,106.4658262,119.2573074,-0.9937759,4.2617102,5.1365818,38.9662155,83.4611502,1.7401103,16.2483833,9.1433282,23.7172427,7.734384,10.0219602,0.5404195,28.3341103),(29774,'full set',251,2,56,14.8898815,106.4036156,119.1631919,1.8,106.4941572,119.2761948,-1.0162698,4.2024998,5.0738495,38.5371472,83.2820414,1.793622,16.4139754,9.1700534,23.8525351,7.734384,10.0219602,0.5404195,28.3341103),(29775,'full set',251,2,57,14.7105648,106.4798398,119.094105,1.8,106.5411396,119.2049998,-1.0281758,4.1634233,4.9680304,37.6548488,81.5651578,1.7979983,16.4180068,9.0442039,23.8166489,7.734384,9.8921606,0.6000502,28.3341103),(29776,'full set',251,2,58,14.456892,106.5402977,119.071947,1.8,106.6243608,119.1939695,-1.051662,4.0991836,4.9030242,36.9679938,78.9097565,1.8164033,16.0940991,9.0183796,23.4044433,7.734384,9.6942031,0.2234766,28.0824049),(29777,'full set',251,2,59,14.3611072,106.5908578,119.0544849,1.8,106.6545226,119.1924707,-1.0554283,4.0597523,4.8602843,35.9632332,76.6800427,1.8121176,15.7768636,8.8584797,22.9582752,7.734384,9.6560368,2.7776137,27.9781451),(29778,'full set',251,2,60,14.3061653,106.6349601,119.0607708,1.8,106.7107923,119.2087863,-1.0638527,4.0085509,4.8385394,35.4911042,75.071284,1.8223251,15.515278,8.853849,22.6339607,7.734384,9.6560368,0.5633163,27.9781451),(29779,'full set',251,2,61,14.3590931,106.6915492,119.0796263,1.8,106.7713296,119.2052726,-1.08082,3.9292877,4.8164697,35.3381102,73.9720729,1.8631664,15.3581517,8.9935156,22.4631787,7.734384,9.5406219,0.625485,27.9781451),(29780,'full set',251,2,62,14.3006823,106.7311475,119.0938486,1.8,106.8474172,119.2209327,-1.0959119,4.0647305,4.7999925,34.6673939,72.3134291,1.885153,15.0653212,8.5288296,22.0379037,7.734384,9.5115493,2.8198421,27.4747343),(29781,'full set',251,2,63,14.4307078,106.7961015,119.0739822,1.8,106.8792362,119.2145484,-1.1209552,3.971123,4.7342053,34.2984442,71.743939,1.9503809,15.1543783,8.6369635,22.0899917,7.734384,9.3845276,2.863293,27.4747343),(29782,'full set',251,2,64,14.4933707,106.8535541,119.0853008,1.8,106.9223628,119.2084418,-1.1403637,3.8776572,4.7042005,33.7705848,70.7663737,1.9949902,15.0432306,8.7090176,21.884289,7.734384,9.4237936,2.7187387,27.7264397),(29783,'full set',251,2,65,14.4128601,106.89793,119.11418,1.8,106.9825464,119.2994552,-1.1718411,3.7627534,4.6851318,32.6122415,68.7647901,2.039665,14.677237,8.6671216,21.2280764,8.1444208,9.4237936,2.7187387,27.7264397),(29784,'full set',251,2,66,14.3007942,106.9379412,119.1388049,1.8,107.01744,119.3326498,-1.1964703,3.6649839,4.5121027,31.7524474,66.763736,2.0648046,14.7965905,8.6637345,21.6469154,8.1444208,9.2557628,2.7610863,27.4747343),(29785,'full set',251,2,67,14.2042821,106.9718109,119.1635213,1.8,107.0355351,119.3693604,-1.2075647,3.60069,4.5163037,30.8335356,64.9374557,2.068532,14.3784519,8.5632296,21.0186629,8.1444208,9.2557628,2.7610863,27.4747343),(29786,'full set',251,2,68,14.018979,107.0108308,119.2039555,1.8,107.0533171,119.4691784,-1.2351784,3.4895436,4.2590451,29.6698825,63.3466883,2.0830492,14.8734486,8.5025108,20.9885317,7.734384,9.2557628,2.7610863,26.8670637),(29787,'full set',251,2,69,13.8929818,107.0544166,119.2455727,1.8,107.1044045,119.4505951,-1.2618141,3.5053382,4.2512954,28.6021688,61.782656,2.1013823,14.5326661,8.1596033,20.3524423,7.734384,9.2557628,2.7610863,27.1187691),(29788,'full set',251,2,70,13.7301701,107.0855633,119.274322,1.8,107.1493134,119.4394919,-1.2809115,3.4149314,4.2446463,27.4593261,59.9758624,2.1013898,14.1297669,8.0409597,19.6606219,7.734384,9.2257926,2.6571147,26.7628039),(29789,'full set',251,2,71,13.6829491,107.1307495,119.3035327,1.8,107.2044365,119.4206295,-1.2876518,3.3447348,4.2510294,26.6203936,58.5076712,2.1024966,13.7631771,7.9588952,19.1448431,7.734384,9.0642783,2.5930433,26.7628039),(29790,'full set',251,2,72,13.5002196,107.1477188,119.3478182,1.8,107.2085421,119.4504918,-1.3059149,3.2657513,4.2648058,25.5867753,56.8513602,2.0958269,13.3303516,7.8348817,18.4243736,7.734384,9.0642783,2.5930433,26.5110985),(29791,'full set',251,2,73,13.28683,107.1768683,119.3962692,1.8,107.2597999,119.5187132,-1.3096181,3.214743,4.2990454,24.4935001,55.100618,2.0668173,12.8169425,7.619116,17.6889844,7.734384,9.2257926,2.6571147,26.5110985),(29792,'full set',251,2,74,13.2556664,107.2097966,119.4334702,1.8,107.3024841,119.52725,-1.3290002,3.1198102,4.3007241,23.7479714,54.1974256,2.0826092,12.6019305,7.6119925,17.2679383,8.0441187,9.2557628,2.7610863,26.9713235),(29793,'full set',251,2,75,13.036682,107.2456437,119.4974978,1.8,107.3319978,119.5490728,-1.3486687,3.0152342,4.3274911,22.4736353,52.1918846,2.0673255,12.0605413,7.4533632,16.4094377,8.0251607,9.2955727,2.1587989,27.2230289),(29794,'full set',251,2,76,12.9156642,107.2724979,119.5576413,1.8,107.3581275,119.7435937,-1.3766541,2.9807128,3.9186722,21.8126299,51.183945,2.0724904,13.061553,7.317924,16.5562522,7.734384,9.4335845,2.6167969,26.8670637),(29795,'full set',251,2,77,12.6252328,107.3018905,119.6054341,1.8,107.4096349,119.7871223,-1.3820295,2.9253676,3.9515968,20.7305816,49.2538726,2.0301128,12.4642961,7.0864878,16.0776761,7.734384,9.2257926,2.6571147,26.2593931),(29796,'full set',251,2,78,12.4751216,107.3426754,119.6522028,1.8,107.4158616,119.8307756,-1.3994977,2.8204579,3.9629702,20.162537,48.6463878,2.0187713,12.2752344,7.1486751,16.0328803,7.734384,9.2257926,2.6571147,26.2593931),(29797,'full set',251,2,79,12.3420748,107.3780836,119.7087822,1.8,107.4616166,119.8159085,-1.4121183,2.7355054,3.9930477,19.6475868,47.5417211,2.0056528,11.9061239,7.182434,15.6445373,7.9984867,9.0642783,2.1193457,26.6153583),(29798,'full set',251,2,80,12.2554657,107.4098458,119.7529355,1.8,107.4704155,119.8012508,-1.4248755,2.6563624,4.0116164,19.0000269,46.598525,1.9993931,11.6158974,7.1526487,15.1961528,7.9765186,9.0642783,2.1193457,26.6153583),(29799,'full set',251,2,81,12.1738361,107.4587348,119.8233275,1.8,107.5631832,119.8399832,-1.4371175,2.5835869,4.0550478,18.2507018,45.7782565,1.9929303,11.2892028,7.0640943,14.7059515,7.734384,8.9412281,2.1854593,26.2593931),(29800,'full set',251,2,82,11.9414798,107.4946605,119.8717284,1.8,107.6270784,119.882952,-1.4436091,2.4964651,4.0881236,17.3668809,44.6530537,1.9582245,10.922628,6.9565888,14.1624039,7.304696,9.1957248,2.223643,26.1551333),(29801,'full set',251,2,83,11.8762992,107.5213685,119.9557218,1.8,107.6173127,120.0294365,-1.4707595,2.4177762,3.697365,17.1088362,43.9344341,1.9596408,11.8826337,7.0762697,14.1554646,7.304696,9.0642783,2.1193457,25.9034279),(29802,'full set',251,2,84,11.863319,107.5484576,120.0130897,1.8,107.6483242,120.0108744,-1.4843775,2.3518144,3.7288479,16.6096956,43.1810525,1.9624903,11.5802665,7.0625028,14.0717275,7.304696,8.8582451,1.9693188,25.1483117),(29803,'full set',251,2,85,11.8834047,107.5847072,120.110789,1.8,107.6610745,120.0897192,-1.5024981,2.3506318,3.7923122,16.2770347,42.9859976,1.9713432,11.3350367,6.924536,14.2162722,7.304696,8.8582451,1.9693188,25.4000171),(29804,'full set',251,2,86,11.7948374,107.612854,120.1716126,1.8,107.6732022,120.153986,-1.5072192,2.3802076,3.8430103,15.720295,42.2267735,1.9578711,10.9879418,6.6045899,13.7671223,7.304696,8.9412281,2.1854593,25.6517225),(29805,'full set',251,2,87,11.8742291,107.6360534,120.2497902,1.8,107.6709462,120.2785378,-1.5057347,2.3813452,3.9220587,15.3014631,42.2585843,1.9706727,10.7745926,6.4255545,13.4867744,7.304696,8.6473042,2.0344439,25.1483117),(29806,'full set',251,2,88,11.9409763,107.6745005,120.2865699,1.8,107.7284442,120.2759999,-1.5082312,2.4214789,3.952149,14.9821461,42.5503783,1.9823826,10.7663903,6.1871884,13.2858319,7.304696,8.8478174,2.0778948,25.4000171),(29807,'full set',251,2,89,11.9890924,107.7097393,120.3413345,1.8,107.7357404,120.3365116,-1.5098806,2.4334076,4.0019363,14.6573519,42.5294629,1.9907765,10.6272214,6.0233854,13.2455909,7.6720481,8.76395,1.7681919,25.8602421),(29808,'full set',251,2,90,11.9543481,107.7340846,120.4071708,1.8,107.7719878,120.4477838,-1.5216845,2.0752172,3.6990561,14.0181332,42.6492924,1.9875896,11.529777,6.7550197,13.5055826,7.304696,8.7005189,1.9237867,25.1483117),(29809,'full set',251,2,91,11.940137,107.7572501,120.4771674,1.8,107.7882914,120.4887416,-1.5251527,2.0985813,3.6810117,13.6252405,42.5616866,1.9858798,11.5624969,6.4925959,13.6283806,7.304696,8.7005189,1.9237867,25.1483117),(29810,'full set',251,2,92,11.8780896,107.7825054,120.5240413,1.8,107.8126255,120.5470153,-1.5259469,2.1251743,3.7253971,13.2138163,42.242863,1.9757022,11.3391573,6.2177565,13.6271118,7.304696,8.5614727,1.8766752,24.8966063),(29811,'full set',251,2,93,11.935773,107.8051588,120.579813,1.8,107.8302036,120.5561299,-1.5330323,2.1267222,3.7686839,13.0251217,42.4131105,1.9864599,11.2540907,6.1245056,13.5091297,7.304696,8.5614727,1.8766752,24.6449009),(29812,'full set',251,2,94,12.0075556,107.837547,120.648074,1.8,107.8445857,120.6499983,-1.5476327,2.1514478,3.9202469,12.8362835,42.8398697,2.0001857,10.9278499,5.9663466,12.8764216,7.304696,8.463872,1.9890207,24.6449009),(29813,'full set',251,2,95,12.0243403,107.8688383,120.7046906,1.8,107.848166,120.6542772,-1.5521972,2.1804984,3.8725075,12.5352693,42.9341884,2.0033635,11.0869219,5.7488091,13.0225994,7.304696,8.4420297,1.82812,24.6449009),(29814,'full set',251,2,96,12.0415726,107.9004358,120.7648921,1.8,107.8833863,120.7564161,-1.5583646,2.2026401,3.910216,12.2081233,43.2417183,2.0066186,11.058652,5.5424956,13.0991167,7.304696,8.3430318,1.7782926,24.6449009),(29815,'full set',251,2,97,12.0617143,107.9308115,120.8503141,1.8,107.8946568,120.8354271,1.5701775,2.2277621,3.7602198,12.0014011,43.9639643,2.0102849,11.6918601,5.3872005,13.6460263,7.304696,8.5614727,1.8766752,24.6449009),(29816,'full set',251,2,98,12.0308864,107.9633977,120.9092552,1.8,107.932484,120.8818848,1.5650521,2.2616218,3.709435,11.7046923,44.3255185,2.0050816,11.949399,5.1753535,13.8888994,7.304696,8.5614727,1.8766752,24.3931955),(29817,'full set',251,2,99,12.0233332,108.0042776,120.9894139,1.8,107.9875722,121.0067514,1.5492799,1.9025711,4.0825524,11.396561,45.2080303,2.0029613,11.0734722,5.9900841,13.0362716,6.875008,8.4420297,1.82812,24.0372303),(29818,'full set',251,2,100,12.020312,108.031072,121.03721,1.8,107.9875722,121.0067514,1.5424357,1.9377492,4.0440403,11.1474239,45.3497291,2.0017744,11.2139657,5.7527693,13.1761086,6.875008,8.4420297,1.82812,24.2889357),(29819,'full set',251,2,101,12.0469437,108.0578812,121.1089617,1.8,108.0169526,121.0398043,1.5332848,1.9742992,3.9842066,10.9818893,46.0117621,2.005,11.5485382,5.562424,13.5336495,6.875008,8.4420297,1.82812,24.2889357),(29820,'full set',251,2,102,12.0057652,108.0791873,121.1538981,1.8,108.0169526,121.0655121,1.5302067,1.9976917,3.9426226,10.7274833,45.8798752,1.9976661,11.6368926,5.3699393,13.6020892,6.875008,8.3430318,1.7782926,24.2889357),(29821,'full set',251,2,103,11.9663771,108.1039439,121.2093455,1.8,108.0331941,121.1423823,1.5268596,2.0240851,3.8905787,10.4634965,45.86652,1.9905486,11.7891254,5.1694944,13.5056795,6.875008,8.4420297,1.82812,24.2889357),(29822,'full set',251,2,104,11.8980074,108.1229319,121.2464675,1.8,108.0628278,121.1683118,1.5264589,2.0228303,3.8926572,10.070217,45.7044007,1.9791056,11.741183,4.9782807,13.2827459,6.875008,8.4420297,1.82812,24.5406411),(29823,'full set',251,2,105,11.8357362,108.1368,121.2985571,1.8,108.0740704,121.2850918,1.5243943,2.0356999,3.9229344,9.8358872,45.6235672,1.9683784,11.6299593,4.8316981,13.070021,6.875008,8.3430318,1.7782926,24.2889357),(29824,'full set',251,2,106,11.8309245,108.1583984,121.339832,1.8,108.0870823,121.3438912,1.5205881,2.0576174,4.1947269,9.6300965,45.6380814,1.9668542,10.8798694,4.6802173,12.665056,6.875008,8.3430318,1.7782926,24.0372303),(29825,'full set',251,2,107,11.8478771,108.1754342,121.3874545,1.8,108.1042239,121.3529373,1.5198225,2.072655,4.1472181,9.4507611,45.802623,1.9695198,11.0441799,4.5597367,12.8101235,6.875008,8.4420297,1.82812,24.0372303),(29826,'full set',251,2,108,11.7443155,108.1919159,121.4120617,1.8,108.1042239,121.3529373,1.5213767,2.0870608,4.1199798,9.2174176,45.620114,1.9526093,11.0728974,4.4164587,12.7985996,6.875008,8.4420297,1.82812,24.0372303),(29827,'full set',251,2,109,11.6226823,108.2187628,121.4698193,1.8,108.1547715,121.46359,1.5230808,2.0897433,4.0589967,8.8540773,45.3422173,1.9327067,11.1707944,4.236921,12.8386707,6.875008,8.4420297,1.3134726,24.0372303),(29828,'full set',251,2,110,11.6041072,108.2329119,121.4925651,1.8,108.1596944,121.4572072,1.5237107,2.1027855,4.034879,8.715046,45.2708888,1.9297332,11.2198876,4.1445246,12.8683231,6.875008,8.4420297,1.3134726,24.0372303),(29829,'full set',251,2,111,11.6480272,108.2317965,121.5248126,1.8,108.1580742,121.5008207,1.5249535,2.1001791,4.0012855,8.7790846,45.9136819,1.9372609,11.4747327,4.18016,13.1313138,6.875008,8.4420297,1.3134726,23.7855249),(29830,'full set',251,2,112,11.5522425,108.2480649,121.5418805,1.8,108.1939174,121.5028377,1.5261255,1.7439954,3.9821499,8.5203371,45.4870658,1.9215343,11.4227406,4.8855274,13.0336646,6.44532,8.3430318,1.7782926,23.4295597),(29831,'full set',251,2,113,11.5100569,108.2498769,121.567168,1.8,108.1893,121.501955,1.5256661,1.7452491,3.9573324,8.477325,45.2858262,1.9144383,11.4435233,4.8573726,13.0520121,6.44532,8.3430318,1.7782926,23.4295597),(29832,'full set',251,2,114,11.4564018,108.2598837,121.587934,1.8,108.204646,121.524974,1.5258108,1.7541316,3.9359719,8.3493838,44.8419843,1.9055389,11.3928619,4.759839,12.9853195,6.44532,8.3430318,1.7782926,23.4295597),(29833,'full set',251,2,115,11.4848239,108.2591645,121.5919285,1.8,108.2022229,121.5074742,1.5226629,1.757069,3.935569,8.4012248,44.7787545,1.909706,11.377962,4.7813858,12.9938128,6.44532,8.3430318,1.7782926,23.4295597),(29834,'full set',251,2,116,11.4039775,108.2657361,121.6036013,1.8,108.2000837,121.5242827,1.5234011,1.7621823,3.9227678,8.2777374,44.3890275,1.8963966,11.3157418,4.6974353,12.8985661,6.44532,8.3430318,1.3633001,23.4295597),(29835,'full set',251,2,117,11.305843,108.2598102,121.620144,1.8,108.1954384,121.5587352,1.5215537,1.7576724,3.9085993,8.2393065,43.7466877,1.8797417,11.1924206,4.6876235,12.6772911,6.44532,8.3430318,1.3633001,23.4295597),(29836,'full set',251,2,118,11.2192339,108.2657828,121.6178757,1.8,108.1954384,121.5587352,1.5227124,1.7623723,3.9092781,8.1671706,43.4174946,1.8655524,11.1062692,4.6341913,12.5918755,6.44532,8.2652137,1.4141944,23.4295597),(29837,'full set',251,2,119,11.155396,108.2622843,121.6061197,1.8,108.1954384,121.5587352,1.525952,1.7555415,3.9175366,8.2243293,43.2845478,1.8554962,11.0489198,4.6847821,12.6042153,6.44532,8.2652137,1.4141944,23.4295597),(29838,'full set',251,2,120,11.0922296,108.2652358,121.5955314,1.8,108.1954384,121.5587352,1.5288475,1.7554318,3.9246929,8.1523316,43.0061,1.8454537,10.9578256,4.6440607,12.5162532,6.44532,8.2652137,1.4141944,23.4295597),(29839,'full set',251,2,121,11.0828302,108.2566908,121.5744526,1.8,108.1867658,121.4755571,1.5338857,1.741488,3.8047013,8.173368,42.4219782,1.844623,11.1498841,4.6933244,12.4666429,6.44532,8.0272343,1.2998495,23.0735945),(29840,'full set',251,2,122,11.0640313,108.2598473,121.5659452,1.8,108.1867658,121.4755571,1.5343707,1.7443443,3.7968112,8.1471162,42.1980025,1.8415596,11.1140639,4.6705895,12.4327759,6.44532,8.0272343,1.2998495,23.0735945),(29841,'full set',251,2,123,11.1095178,108.2463284,121.5373325,1.8,108.157502,121.4546036,1.5354979,2.1143477,3.7688864,8.3590265,42.254672,1.8492802,11.2114475,3.9534778,12.5693671,6.875008,7.9230552,1.3521274,23.4295597),(29842,'full set',251,2,124,11.0212303,108.2485627,121.5227038,1.8,108.1709974,121.4479624,1.53767,1.7303244,3.756564,8.260849,41.9805779,1.8348568,11.1752597,4.7741621,12.522161,6.44532,7.9230552,1.3521274,22.8218891),(29843,'full set',251,2,125,11.0770674,108.2405591,121.4936553,1.8,108.1394255,121.4520805,1.5389298,2.1099956,3.7285537,8.4860299,41.737489,1.8443038,11.1940158,4.0218235,12.595404,6.875008,7.9230552,1.3521274,23.1778543),(29844,'full set',251,2,126,11.1219945,108.242116,121.472766,1.8,108.1520893,121.4572072,1.5422461,2.1120011,3.7110778,8.5569574,41.623816,1.8521552,11.2160991,4.0515875,12.648789,6.875008,7.9230552,1.3521274,22.9261489),(29845,'full set',251,2,127,11.0986637,108.210283,121.4260542,1.8,108.1292741,121.4572072,1.5469927,2.0911664,3.6683499,8.747046,41.2641366,1.8487294,11.2486915,4.1828551,12.7120785,6.875008,7.9230552,1.3521274,22.9261489),(29846,'full set',251,2,128,11.1039789,108.2015378,121.4072677,1.8,108.1207101,121.3924646,1.5476617,2.0824858,3.6626347,8.8633325,40.9835827,1.8496728,11.1896453,4.256131,12.7174453,6.875008,7.8410702,1.735945,22.9261489),(29847,'full set',251,2,129,11.1596482,108.1877934,121.3739054,1.8,108.1295035,121.3979726,1.5496881,2.068277,3.6936691,9.0333003,40.5074204,1.8591128,10.9667162,4.3675486,12.6462726,6.875008,7.8410702,1.735945,22.9261489),(29848,'full set',251,2,130,11.1681524,108.1744776,121.3494553,1.8,108.1295035,121.3979726,1.5551454,2.0519641,3.711148,9.0462695,40.1550871,1.8609028,10.8201254,4.4085906,12.4718423,6.875008,7.8410702,1.735945,22.9261489),(29849,'full set',251,2,131,11.346462,108.1530629,121.3366068,1.8,108.1428815,121.3531242,1.553626,2.0317582,3.7190135,9.2732729,39.7460569,1.8905195,10.6872581,4.5641617,12.6634731,6.875008,7.8410702,1.4056476,22.9261489),(29850,'full set',251,2,132,11.3333139,108.1299644,121.3200634,1.8,108.0813488,121.3090717,1.5528985,2.0094391,3.7366389,9.3542768,39.5856565,1.8882806,10.5939207,4.6551681,12.6653374,6.875008,7.7819807,1.6814535,22.9261489),(29851,'full set',251,2,133,11.3885916,108.0903128,121.3000972,1.8,108.0497181,121.2915814,1.553546,1.9771119,3.5543471,9.7000385,39.3844069,1.8975338,11.0806305,4.9061656,12.7142259,6.875008,7.6864926,1.1071487,22.5701837),(29852,'full set',251,2,134,11.3641418,108.0683471,121.2719555,1.8,108.0242977,121.2050689,1.5511245,1.9584273,3.5325687,9.7909567,39.4333039,1.8932908,11.1627847,4.9993975,12.8083162,6.875008,7.6864926,1.1071487,22.8218891),(29853,'full set',251,2,135,11.4354209,108.0260544,121.2464814,1.8,107.9985899,121.2013964,1.5460687,1.9225708,3.5045829,10.2945685,39.6969508,1.9047383,11.3271543,5.3545849,13.0303584,6.44532,7.6864926,1.1071487,22.2142185),(29854,'full set',251,2,136,11.4507509,108.0138183,121.2323299,1.8,108.0009864,121.1610917,1.5412663,1.916342,3.488393,10.5302208,39.613446,1.9067948,11.3557863,5.494959,13.097297,6.44532,7.6140908,1.8568478,22.2142185),(29855,'full set',251,2,137,11.3612325,107.9698086,121.199319,1.8,107.9508468,121.1683435,1.5384819,2.2644952,3.460135,10.9492881,39.444258,1.8915622,11.3996297,4.8352004,13.2035654,6.875008,7.6140908,1.8568478,22.3184783),(29856,'full set',251,2,138,11.4038657,107.9500778,121.1792974,1.8,107.9369154,121.1400557,1.535577,2.2451801,3.4851516,11.2610041,39.8159293,1.8982877,11.424447,5.0156352,13.417106,6.875008,7.6140908,1.8568478,22.3184783),(29857,'full set',251,2,139,11.6231858,107.7198545,121.1383497,1.8,107.265447,121.015463,0.7612588,8.1743277,12.5036251,34.582313,48.7558282,0.9218543,3.8993354,4.2306003,5.8906759,6.875008,7.6140908,1.8568478,22.3184783),(29858,'full set',251,2,140,11.9316328,107.2881687,121.047723,1.8,106.4748046,120.8458295,0.2845072,3.8206184,13.8275812,38.6348143,110.8706956,0.1566699,8.0180831,10.1121887,10.8095179,6.875008,7.6140908,1.8568478,22.5701837),(29859,'full set',251,2,141,12.4449651,106.7066421,120.9099773,1.8,105.732281,120.6842621,0.2396434,3.7644593,13.3044377,39.7507325,196.1098712,0.116854,14.7401849,10.55948,17.6380531,6.875008,7.6140908,1.8568478,22.5701837),(29860,'full set',251,2,142,12.6631103,106.527094,120.8673522,1.8,105.5081923,120.6292522,0.2332549,3.7514561,13.2103552,40.7651622,221.5299585,0.1127613,16.7694172,10.8664907,19.6637693,16.7109414,19.6391391,2.965653,64.0645276),(29861,'full set',251,2,143,12.7888837,106.3727034,120.8261128,1.8,105.4686157,120.634906,0.2217256,3.7191414,12.9339959,41.2576823,236.5013378,0.1030824,18.2852492,11.0933351,21.3176681,16.2537074,19.5685029,2.9872739,64.4204928),(29862,'full set',251,2,144,12.7265006,106.4096398,120.8139124,1.8,105.549788,120.6446716,0.2142472,3.6810189,12.9553548,41.9062659,225.5445806,0.095881,17.4093712,11.3844201,20.478268,16.1032708,19.2977277,2.9398303,64.4204928),(29863,'full set',251,2,145,12.5423164,106.6906962,120.8227687,1.8,105.9373729,120.695503,0.2143152,3.6300636,13.1405919,42.6844734,172.4953887,0.0945525,13.1269117,11.7586022,16.3095878,15.4956002,19.0279509,3.0284417,63.3094114),(29864,'full set',251,2,146,12.2165252,107.0081022,120.8289244,1.8,106.3433954,120.7189436,0.2305535,3.8200077,13.3702417,43.1640232,115.4576037,0.106324,8.6354164,11.2994598,11.8560952,14.8879296,18.4565877,2.9304993,61.9898104),(29865,'full set',251,2,147,11.8797121,107.4028621,120.8303799,1.8,107.0989499,120.7203731,1.0209147,10.8453005,9.224169,37.3462359,48.4284541,1.4392341,5.2501699,3.4435409,6.3228756,6.875008,7.7463106,1.9100889,22.8218891),(29866,'full set',251,2,148,11.9191562,107.5031025,120.7932526,1.8,107.5386296,120.7054976,1.4906875,2.6466272,3.5411535,19.1312445,46.2630308,1.9738049,13.0643957,7.2285376,16.4815738,6.9882119,7.8997178,1.9614034,23.1778543),(29867,'full set',251,2,149,12.1176073,107.4354154,120.7275357,1.8,107.4779183,120.7599864,1.500551,2.6163492,3.5936344,20.9592335,47.3469273,2.0096521,13.1752211,8.0108702,16.8277104,6.875008,7.8997178,1.9614034,23.0735945),(29868,'full set',251,2,150,12.1592894,107.3850156,120.7026705,1.8,107.4483074,120.7218667,1.5073676,2.5657836,3.6086949,21.6837465,47.9359384,2.0184059,13.2834557,8.4511206,16.9518298,6.875008,7.8997178,1.9614034,23.0735945),(29869,'full set',251,2,151,12.2706839,107.3279157,120.6574088,1.8,107.3589791,120.6735779,1.4964708,2.5473062,3.6792216,23.6176585,49.3804855,2.033837,13.4214491,9.2716214,17.4816994,6.875008,7.9926588,2.2035452,23.3252999),(29870,'full set',251,2,152,12.2685578,107.290392,120.6079943,1.8,107.3174049,120.6660018,1.4957913,2.8459891,3.7326501,24.8313154,50.1190101,2.0332779,13.4271921,8.7250214,17.6872756,7.1113101,8.0731046,2.0106389,23.4295597),(29871,'full set',251,2,153,12.4873185,107.2166059,120.5314682,1.8,107.2085244,120.6355902,1.4905168,2.8447638,3.8253754,27.2719888,51.4684877,2.0678355,13.4544933,9.5867321,18.1355096,7.2920472,8.107337,2.1293956,23.6812651),(29872,'full set',251,2,154,12.8559107,107.2062911,120.4784347,1.8,107.2605415,120.5339944,1.4849176,2.841308,3.8905371,29.3257646,53.9629974,2.1268882,13.8703206,10.3212198,18.9638036,7.2920472,8.2652137,2.0576956,24.0372303),(29873,'full set',251,2,155,13.1945141,107.159708,120.392253,1.8,107.2299042,120.4592394,1.4843651,2.8396795,3.9444514,32.1835594,56.5951208,2.1826986,14.3480335,11.3335182,20.7699745,7.2920472,8.2540369,2.2455373,24.2889357),(29874,'full set',251,2,156,13.2603661,107.0962821,120.3065684,1.8,107.1088376,120.4024618,1.4977694,3.1352862,4.0121091,34.1909431,58.2471516,2.1982958,14.5178385,10.9052062,21.1058925,7.4958527,8.3430318,2.1730837,24.8966063),(29875,'full set',251,2,157,14.0951256,107.0490794,120.2469045,1.8,107.0720479,120.3790866,1.4947723,3.1259945,4.0804317,38.379118,62.8061247,2.3356362,15.3920294,12.2774104,22.7150331,7.304696,8.4747721,2.1025204,24.5406411),(29876,'full set',251,2,158,14.1800562,106.9888059,120.1859254,1.8,106.9879717,120.2714073,1.4959712,3.4338619,4.1114793,39.9727543,65.4593793,2.3501355,15.9211259,11.6407577,23.9565971,7.5958825,8.4747721,2.1025204,25.2525715),(29877,'full set',251,2,159,14.8757823,106.8972066,120.0443882,1.8,106.8793424,120.1532722,1.4740652,3.4356802,4.2912944,45.6541368,69.1838835,2.4561708,16.1219152,13.288238,25.1323387,7.5958825,8.7005189,1.9237867,25.5042769),(29878,'full set',251,2,160,15.5336309,106.8218059,119.9828497,1.8,106.8127979,120.1312162,1.4552584,3.7100583,4.3867962,49.2695207,73.5478661,2.5545322,16.7657356,13.2799855,26.3363281,7.8997178,8.8582451,1.9693188,26.3636529),(29879,'full set',251,2,161,16.9843891,106.7019033,119.8600684,1.8,106.7196586,119.9933939,1.4338456,3.6637422,4.553614,57.3658176,80.6718121,2.7779708,17.7159972,15.6577111,28.9742667,8.164072,9.1352922,2.2896263,27.2230289),(29880,'full set',251,2,162,18.1801316,106.61804,119.7769862,1.8,106.6237781,119.9328409,1.3821192,3.8728692,4.7172763,63.6178942,88.7055489,2.9234299,18.8043999,16.4265537,31.2457194,8.2035531,9.2557628,1.9513027,27.3272887),(29881,'full set',251,2,163,19.8840591,106.5305337,119.6913687,1.8,106.5399292,119.8178936,1.3463864,3.9728099,4.7655346,74.5237426,98.4818524,3.1498998,20.6654364,18.7584468,35.8512532,8.5073884,9.4335845,2.6167969,28.1866647),(29882,'full set',251,2,164,21.4501842,106.4382908,119.5983235,1.8,106.414652,119.7107922,1.3412889,4.127889,4.8806728,84.3013301,109.1365758,3.3900039,22.3609695,20.4223831,39.0477714,8.8112237,9.6560368,2.1341126,29.0460407),(29883,'full set',251,2,165,24.2210596,106.3296277,119.5549647,1.8,106.3126483,119.6370299,1.2866059,4.2337906,4.9865911,97.0611669,126.0523139,3.7194941,25.2782535,22.9253586,44.1813645,8.8112237,9.8921606,2.1708465,29.6537113),(29884,'full set',251,2,166,26.7455355,106.2427054,119.4786776,1.8,106.2429157,119.4865137,1.2732881,4.3315733,5.0922457,106.8879488,140.9461969,4.074547,27.6785934,24.6764723,48.0131965,9.115059,10.2496576,2.1471715,30.5130873),(29885,'full set',251,2,167,31.0208241,106.1505297,119.3294186,1.8,106.1341637,119.303487,1.2057887,4.3774419,5.2914925,121.3510049,169.3182055,4.5113693,31.9981942,27.7218995,54.8656975,9.115059,10.4635866,1.9055332,30.8690525),(29886,'full set',251,2,168,34.1960991,106.2071681,119.2345643,1.8,106.1042103,119.2031114,1.1924309,4.3144193,5.361704,129.4413268,190.4861003,4.9216289,35.5271574,30.0020273,59.6584615,9.115059,10.7765202,1.9809237,31.1207579),(29887,'full set',251,2,169,35.8495046,106.2715615,119.1093744,1.8,106.0728721,119.0293514,1.1804798,4.3962369,5.4537983,129.7107631,208.8309892,5.1099532,38.2909261,29.5049528,62.0692959,9.2419446,10.9549375,2.0169019,32.3360991),(29888,'full set',251,2,170,33.8864772,106.3083799,119.0767617,1.8,106.0942992,118.9755727,1.1697952,4.3658398,5.3006624,120.0711684,203.5300617,4.7872245,38.3970993,27.502422,60.2192107,9.1795109,10.980189,2.1045045,33.1954751),(29889,'full set',251,2,171,25.5383793,106.2229331,119.1177122,1.8,106.1737997,118.9628996,1.2414881,4.3097247,5.3168339,91.3413958,159.5051859,3.8112621,30.0000319,21.1942528,46.688388,9.0038898,10.980189,2.1045045,34.7667815),(29890,'full set',251,2,172,17.067921,106.1939351,119.3689341,1.8,106.196037,119.2203911,1.4217956,4.1307507,4.939899,58.5554051,109.0064996,2.7819647,22.0665443,14.1754877,31.7307066,8.5485395,10.6125107,1.1978086,37.5534291),(29891,'full set',251,2,173,3.1715823,106.306541,120.0998161,1.8,106.3540376,119.7411132,-1.381835,3.7305112,4.8850615,6.4022874,22.4231354,0.5099463,4.5901439,1.7161957,5.6362884,3.3557953,4.4239087,2.0778948,11.5889272),(29892,'full set',251,2,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29893,'full set',251,2,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29894,'full set',251,2,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29895,'full set',251,2,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29896,'full set',251,2,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29897,'full set',251,2,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29898,'full set',251,2,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29899,'full set',251,2,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29900,'full set',251,2,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29901,'full set',251,2,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29902,'full set',251,2,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29903,'full set',251,2,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29904,'full set',251,2,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29905,'full set',251,2,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29906,'full set',251,2,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29907,'full set',251,2,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29908,'full set',251,2,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29909,'full set',251,2,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29910,'full set',251,2,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29911,'full set',251,2,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29912,'full set',251,2,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29913,'full set',251,2,195,0.2979845,102.7389978,119.9689541,1.8,102.7207078,119.9840551,0.2153751,0.7648167,0.9922906,0.0522563,0.0893836,0.0022683,0.0900781,0.0683253,0.1362149,1.718752,2.5054901,2.6011732,6.2241516),(29914,'full set',251,2,196,3.8972411,102.7127905,119.8648224,1.8,102.7358732,119.8930623,-0.0271949,1.7708191,2.1771746,2.877401,4.5505773,0.0004803,2.0901297,1.6248984,3.1969729,3.867192,5.1919399,2.7149652,14.1670552),(29915,'full set',251,2,197,8.4014732,102.6974293,119.8275652,1.8,102.5993176,119.9197016,-0.2495148,2.7636768,3.2485968,11.4140778,18.6749996,0.0853818,5.7486357,4.1300335,9.1277461,5.585944,6.7939638,0.3217506,19.2801253),(29916,'full set',251,2,198,11.5995753,102.4508677,120.2106895,1.8,102.2821914,120.4791698,-0.7373547,3.0546596,4.3960016,21.378669,43.5084316,0.8738935,9.8972739,6.9987076,13.9864527,6.4501819,8.7005189,0.9964915,24.2889357),(29917,'full set',251,2,199,13.8067084,102.589534,120.6895601,1.8,102.433668,120.8954352,-0.9496937,3.8131421,4.3764786,39.4490847,60.7868414,1.5218556,13.8894411,10.3455584,22.2366231,7.304696,9.1049255,1.2341215,26.0076877),(29918,'full set',251,2,200,12.8604425,102.8642583,120.9223442,1.8,102.6445911,121.1359353,-1.2900268,4.0469239,4.4786964,43.6114448,59.0178736,1.9788326,13.1774668,10.776443,22.3207325,7.734384,9.4335845,1.0460006,26.8670637),(29919,'full set',251,2,201,9.8874793,102.7186569,121.1735989,1.8,102.547199,121.412191,-1.3091723,3.8695788,4.2957674,32.3135973,45.363257,1.5376684,10.559989,8.3506756,17.5190368,7.734384,9.2257926,1.0863184,26.3636529),(29920,'full set',251,2,202,8.0385319,102.4938307,121.6590711,1.8,102.3617381,121.8394037,1.3525141,3.7522868,3.4613337,26.3694671,30.6190385,1.2769272,8.8460233,7.0275723,14.609793,7.1920283,8.107337,1.012197,23.9329705),(29921,'full set',251,2,203,7.4953228,102.1998893,121.8705625,1.8,102.1323926,122.0881898,0.9914164,3.6018694,3.7395601,23.4650448,27.3159177,0.8747518,7.3045805,6.514685,13.2087314,6.875008,7.7463106,2.5535901,22.7176293),(29922,'full set',251,2,204,7.2483079,102.145148,121.9229518,1.8,102.0273196,122.191215,0.8591229,3.6156182,3.5611292,22.369632,25.5915296,0.6927666,7.1863525,6.1869454,12.846159,6.875008,7.5164702,2.1112158,22.5701837),(29923,'full set',251,2,205,7.1992406,102.0359916,122.0025335,1.8,101.9792853,122.2475872,0.7896543,3.5057464,3.5257104,21.7224035,23.830577,0.6050435,6.7590851,6.1962279,12.5676858,6.8533591,7.3425118,1.2120257,22.2142185),(29924,'full set',251,2,206,7.3832569,101.8694636,122.0978685,1.8,101.7952628,122.3387005,0.6809291,3.6588922,3.5583404,22.1636871,23.7627268,0.487651,6.6780364,6.0574857,12.5405559,6.8533591,7.3425118,1.2120257,21.9625131),(29925,'full set',251,2,207,7.8489766,101.6049878,122.1859459,1.8,101.5958577,122.3543252,-0.0750925,3.2265615,3.2825128,22.7457625,24.576144,0.0073627,7.486991,7.0495363,13.7369002,6.6843766,7.2028834,2.8387078,21.7108077),(29926,'full set',251,2,208,7.996738,101.5721867,122.1824798,1.8,101.5185795,122.3105524,-0.1605647,3.2134784,3.6015151,22.5069809,24.8358049,0.0340664,6.8959324,7.003931,13.0995509,6.44532,7.4175649,2.9669205,21.7108077),(29927,'full set',251,2,209,8.2335142,101.428299,122.1944014,1.8,101.3136902,122.3684022,-0.4400855,3.0909233,3.6095218,21.3339422,26.7131254,0.2490506,7.4007381,6.9021261,13.2066784,6.3805413,7.304696,1.080839,21.1031371),(29928,'full set',251,2,210,8.29959,101.3516512,122.2493701,1.8,101.2411034,122.414255,-0.5034128,3.1301947,3.7253196,20.6333768,27.5530691,0.321923,7.3961624,6.5917232,12.7465318,6.3805413,7.3926319,0.6202495,21.3548425),(29929,'full set',251,2,211,8.2585235,101.1627487,122.3020779,1.8,101.0415386,122.4016263,-0.5599256,2.9973442,3.7958422,18.9363855,29.1097852,0.3882769,7.6688607,6.3177214,12.3509702,6.076706,7.6503773,0.6659692,21.7108077),(29930,'full set',251,2,212,8.4270419,101.1102792,122.3472906,1.8,100.9687716,122.439991,-0.5850101,2.9986462,3.9891957,18.4079351,30.5216894,0.4282811,7.6510885,6.1387486,12.1901996,6.076706,7.8880231,0.5123895,21.7108077),(29931,'full set',251,2,213,8.8928175,100.9870907,122.4073477,1.8,100.8509177,122.5056208,-0.6603927,2.9749292,4.0738675,17.3358738,32.8151176,0.5577171,8.0550282,5.8273232,12.258347,6.076706,7.9926588,0.6327488,21.9625131),(29932,'full set',251,2,214,8.9677333,100.9852022,122.4139168,1.8,100.8485743,122.5331395,-0.6823427,2.7824951,4.0590281,16.415445,33.3676846,0.5943704,8.2206094,5.8995413,12.1836935,5.7728707,7.9926588,0.6327488,21.7108077),(29933,'full set',251,2,215,9.1887319,100.9410196,122.4428547,1.8,100.8440602,122.5167803,-0.6969632,2.7338622,3.9992819,15.8628149,33.8296566,0.6309985,8.4589327,5.8023462,12.2745589,5.7376138,7.9926588,0.6327488,22.0667729),(29934,'full set',251,2,216,9.1877248,100.9478241,122.4461863,1.8,100.8298922,122.5091197,-0.7142013,2.7361311,3.9926453,15.4429129,33.667235,0.656989,8.432313,5.6440691,12.1146564,5.7376138,7.9926588,0.6327488,22.0667729),(29935,'full set',251,2,217,9.3135542,100.988355,122.3669211,1.8,100.9137321,122.3926583,-0.7215468,2.7337651,4.0709329,14.8793731,33.7026789,0.6772849,8.2788588,5.4428132,11.8085776,5.7376138,8.2091777,0.748378,21.6065479),(29936,'full set',251,2,218,9.213909,101.0631974,122.3229716,1.8,100.9908145,122.3197353,-0.7467699,2.4714563,3.8475457,14.1713802,32.4995233,0.7085651,8.4468193,5.7340202,11.7166509,5.4690354,7.9926588,0.6327488,21.1031371),(29937,'full set',251,2,219,9.292853,101.1616454,122.2301849,1.8,101.1370969,122.2405068,-0.8013039,2.487166,3.9400995,13.5819712,30.276108,0.7990352,7.6840973,5.4608221,11.0145123,5.4690354,7.9926588,0.9380475,20.7471719),(29938,'full set',251,2,220,9.3875747,101.2554722,122.1689609,1.8,101.2866692,122.1326756,-0.8508837,2.527754,3.7185887,13.3338453,27.9102414,0.8844636,7.5056006,5.2749774,10.9766585,5.4399592,7.6503773,0.9048271,20.1395013),(29939,'full set',251,2,221,9.0929472,101.4377085,121.9606577,1.8,101.4384343,121.9897059,-0.9499483,2.6125884,3.4225791,13.0113701,23.8413288,1.0026427,6.9658957,4.9802602,10.742851,5.3825049,7.1514336,0.9994588,18.9241602),(29940,'full set',251,2,222,9.1873332,101.5619866,121.8453619,1.8,101.5617167,121.8562115,-1.0410842,2.6187386,3.178743,12.8142233,21.8280939,1.1402815,6.8668948,4.8932807,10.5616642,5.3814141,6.7939638,0.9652517,18.6724547),(29941,'full set',251,2,223,8.7094726,101.6524915,121.6940742,1.8,101.674923,121.6453442,-1.1492199,2.6175122,3.0796919,12.302907,20.2805275,1.2085204,6.5852457,4.7002291,10.2833801,5.156256,6.7939638,0.9652517,18.3164896),(29942,'full set',251,2,224,8.5703274,101.7185896,121.6195472,1.8,101.7895065,121.5587352,-1.2781819,2.5362814,3.1788241,11.9116392,19.4544102,1.3095358,6.1200022,4.6964975,9.8652767,4.726568,6.725681,1.1071487,17.708819),(29943,'full set',251,2,225,8.4244123,101.8080984,121.4905216,1.8,101.8845692,121.463095,-1.4200517,2.6577562,2.9970391,11.9665556,18.9381338,1.3724037,6.3189478,4.5025031,10.2012639,5.156256,6.5448126,1.1659045,18.0647842),(29944,'full set',251,2,226,8.5273026,101.8798334,121.4174771,1.8,101.9288686,121.4435788,-1.5704137,2.5345854,2.823901,12.2021623,18.9363388,1.4212169,6.7057376,4.8142637,10.5037468,5.156256,6.3877713,1.2277724,18.3164896),(29945,'full set',251,2,227,9.446601,101.9980438,121.2961841,1.8,102.0316602,121.2874546,1.4128953,2.4731737,3.1860591,12.576247,20.7718234,1.5355037,6.5195976,5.0850641,10.4625269,5.156256,6.5729625,1.7681919,18.6724547),(29946,'full set',251,2,228,8.9351709,102.0083703,121.2366164,1.8,102.0713613,121.2129387,1.340353,2.4551166,3.2268453,11.7265891,22.6567105,1.4115027,7.0213192,4.7763879,10.6088318,5.1435094,6.725681,2.0344439,18.4207493),(29947,'full set',251,2,229,9.7749098,102.016339,121.1347631,1.8,102.0461954,121.1281063,1.2242082,2.388569,3.4052641,12.2563493,26.1702808,1.4411641,7.6852426,5.1312519,11.1235503,5.1070441,7.086596,1.815775,19.0284199),(29948,'full set',251,2,230,10.0520813,102.0231179,121.042929,1.8,101.9449103,120.9313907,1.1377034,2.4767917,4.1634531,12.3441014,31.1347237,1.3802656,7.4781013,4.9839078,10.0836074,5.210995,8.2540369,2.2455373,20.9988773),(29949,'full set',251,2,231,10.0932038,101.838476,120.7824886,1.8,101.8469342,120.7096935,1.0281637,2.4483393,4.5325681,12.4247737,43.6416219,1.2336234,9.6284536,5.074776,12.1895937,5.1652001,8.9412281,2.1854593,21.9625131),(29950,'full set',251,2,232,9.8652675,101.8398259,120.763568,1.8,101.83091,120.6445547,0.9742782,2.3830735,4.6673074,12.1882668,46.4099854,1.1253306,9.9436316,5.1145157,12.5543698,5.1652001,9.2955727,2.1587989,22.9261489),(29951,'full set',251,2,233,10.1454043,102.0544201,120.8572397,1.8,101.8262346,120.6048278,0.9359814,2.3285337,5.1195329,12.4066824,48.5534985,1.09624,9.4839705,5.3281093,11.8947231,5.1652001,9.5406219,2.1962814,23.1778543),(29952,'full set',251,2,234,10.0994701,102.1644324,120.9813996,1.8,101.9296752,120.7135221,0.92176,2.2791195,5.2877811,12.1206523,51.0090178,1.0683181,9.6465827,5.3181294,11.9321804,4.8613648,9.798394,2.2318395,23.8897847),(29953,'full set',251,2,235,9.673754,102.2643324,121.1059859,1.8,101.9908361,120.8093224,0.8947058,2.5085403,5.4502978,11.8302839,56.2315206,0.9809816,10.3171464,4.7160032,12.4874961,5.1652001,10.1410009,2.2058231,24.3931955),(29954,'full set',251,2,236,9.247926,102.3785627,121.2173395,1.8,102.1119352,120.9303165,0.8709525,2.5204614,5.3315325,11.6134931,57.2233122,0.9018847,10.732995,4.6076855,12.8733075,5.1652001,10.1410009,2.2058231,24.7491607),(29955,'full set',251,2,237,9.6811393,102.5943938,121.4361437,1.8,102.2517324,121.0529177,0.8325049,2.477134,5.618936,12.0683792,64.0416869,0.8826571,11.3974757,4.8719121,13.4682147,5.1190639,10.4900209,2.1815223,25.3568313),(29956,'full set',251,2,238,9.7431867,102.6863963,121.5129678,1.8,102.3381371,121.1650102,0.7838885,2.3733012,5.7042728,11.7166771,67.3901031,0.8094807,11.8139692,4.936869,13.7159933,5.066102,10.7422,2.2142974,26.3204671),(29957,'full set',251,2,239,9.3374444,102.5896063,121.2865698,1.8,102.4527585,121.1697896,0.6818334,2.3848311,5.7633786,10.6260878,69.5445902,0.6180986,12.0666358,4.4556982,13.8681108,5.0774252,11.2460112,2.329174,26.9713235),(29958,'full set',251,2,240,9.6305054,102.760543,121.3212148,1.8,102.5658778,121.2303154,0.6165009,2.2098627,5.7348971,10.3032098,74.8878676,0.536574,13.0582758,4.6623755,14.8463088,4.8900608,11.3440887,2.4905159,28.0392191),(29959,'full set',251,2,241,11.282736,102.9882261,121.507099,1.8,102.7271823,121.3794516,0.5744014,2.117198,6.0301484,9.681844,99.3212468,0.5551295,16.4707798,4.5729516,18.0747924,4.7740502,11.6887773,2.5127964,28.5426299),(29960,'full set',251,2,242,12.0664699,102.8627256,121.5430791,1.8,102.8007056,121.4384226,0.5525248,2.257697,6.0792643,8.4624976,111.5520511,0.5539614,18.349597,3.7482876,19.7201707,4.8900608,11.9388329,2.6135182,28.6468897),(29961,'full set',251,2,243,10.5568534,102.7067727,121.5484049,1.8,102.9114762,121.6233084,0.5138257,2.2229851,5.9524896,6.5701595,118.7029717,0.4250621,19.9417352,2.9555572,21.0451771,4.5715375,12.1610055,2.5829933,29.8622309),(29962,'full set',251,2,244,10.1765119,102.7776706,121.7066544,1.8,102.8503195,121.7241151,0.4862797,2.2415223,6.0859564,6.3404857,117.2652538,0.3704365,19.2681719,2.8286517,20.2847423,4.5962892,12.1610055,2.5829933,29.0460407),(29963,'full set',251,2,245,11.5918544,101.9938484,121.7819591,1.8,102.0947929,121.7795856,0.4076571,2.2009404,5.3153879,8.5578289,93.8893872,0.3036683,17.6636942,3.8882602,19.0671469,4.7458112,11.2048922,2.5748634,27.3704745),(29964,'full set',251,2,246,9.4615953,102.2563326,121.8252466,1.8,102.0990771,121.7188916,0.3762861,2.0613556,4.9429605,6.6160861,64.9876184,0.2129386,13.1475092,3.2095801,14.454472,4.5312139,10.0587382,2.7928217,25.7127965),(29965,'full set',251,2,247,3.7523891,101.8971316,121.7111121,1.8,101.7626946,121.6226644,0.3657766,1.6443309,4.1299491,1.6128325,26.7958884,0.0800079,6.4881885,0.9808442,6.8226481,3.007816,4.29688,2.2142974,10.9812566),(29966,'full set',251,2,248,0.0410666,99.1226992,120.452552,1.8,99.1146987,120.4558693,0.7906724,0.1945338,0.3065662,0.0015049,0.0030591,0.0034583,0.0099784,0.0077357,0.0139994,0.859376,1.2153412,2.3561945,2.4306824),(29967,'full set',251,2,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29968,'full set',251,2,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29969,'full set',251,2,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29970,'full set',251,2,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29971,'full set',251,2,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29972,'full set',251,2,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29973,'full set',251,2,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29974,'full set',251,2,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29975,'full set',251,2,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29976,'full set',251,2,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29977,'full set',251,2,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29978,'full set',251,2,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29979,'full set',251,2,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29980,'full set',251,2,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29981,'full set',251,2,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29982,'full set',251,2,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29983,'full set',251,2,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29984,'full set',251,2,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29985,'full set',251,2,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29986,'full set',251,2,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29987,'full set',251,2,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29988,'full set',251,2,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29989,'full set',251,2,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29990,'full set',251,2,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29991,'full set',251,2,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29992,'full set',251,2,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29993,'full set',251,2,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29994,'full set',251,2,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29995,'full set',251,2,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29996,'full set',251,2,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29997,'full set',251,2,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29998,'full set',251,2,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(29999,'full set',251,2,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30000,'full set',251,2,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30001,'full set',251,2,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30002,'full set',251,2,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30003,'full set',251,2,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30004,'full set',251,2,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30005,'full set',251,2,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30006,'full set',251,2,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30007,'full set',251,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30008,'full set',251,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30009,'full set',251,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30010,'full set',251,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30011,'full set',251,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30012,'full set',251,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30013,'full set',251,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30014,'full set',251,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30015,'full set',251,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30016,'full set',251,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30017,'full set',251,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30018,'full set',251,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30019,'full set',251,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30020,'full set',251,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30021,'full set',251,3,15,0.4266673,112.4118688,121.2926509,1.8,112.4771529,121.2478433,1.4573753,0.6058985,1.4304411,0.04199,0.2398986,0.0702003,0.1677095,0.069302,0.1965644,9.485311,12.3043918,1.1383886,45.0361077),(30022,'full set',251,3,16,3.3966093,112.8139831,121.6934822,1.8,113.0520146,121.6788275,1.4112988,1.9030116,4.8628706,1.3603629,10.9409485,0.5518219,2.249895,0.7148474,2.5290129,11.8004998,14.5397175,0.9745972,51.8679299),(30023,'full set',251,3,17,10.166553,113.4691201,121.4271458,1.8,113.7085818,121.2158059,1.5052463,2.6423202,4.628734,11.3171736,44.0793628,1.6871553,9.5229845,4.283044,11.6878,13.3687531,17.1121594,0.6786625,54.5503177),(30024,'full set',251,3,18,12.4938645,113.5136165,120.9917998,1.8,113.7579449,120.9246199,1.5548922,2.9422617,4.1378522,13.2653124,59.836487,2.0817841,14.46076,4.5085427,16.855066,13.0649178,17.9905393,0.7008544,50.6525887),(30025,'full set',251,3,19,11.7010669,113.3076991,120.7404933,1.8,113.5458052,120.7363184,1.562639,2.2817872,4.2961265,8.5060694,52.8852087,1.950048,12.3099746,3.7278102,14.0800367,12.4572472,17.6643059,0.7165417,48.8295769),(30026,'full set',251,3,20,10.9222005,113.1681583,120.6649161,1.8,113.3717927,120.6903496,1.5281371,2.0014401,3.9525073,6.2691073,44.9522928,1.817056,11.373108,3.1322982,12.5720009,12.1534119,17.3851149,0.6979028,47.9702009),(30027,'full set',251,3,21,8.7057799,112.994805,120.6730735,1.8,113.1866261,120.691276,1.4995693,1.7531506,3.8485315,3.8179038,30.8072293,1.4436146,8.004931,2.1777387,8.8853658,11.8495766,16.7798528,0.6947383,46.8591195),(30028,'full set',251,3,22,7.4145324,112.8691448,120.7180816,1.8,113.0225925,120.6251404,1.5041402,1.4516975,3.8824069,2.5546789,25.7758691,1.230273,6.6391468,1.7597873,7.2458157,11.5095215,16.7798528,0.6947383,45.8954837),(30029,'full set',251,3,23,5.8853337,112.6965161,120.6611868,1.8,112.8460326,120.5804166,1.4979467,1.1930676,3.8158914,1.3896881,19.0915778,0.9756925,5.0031764,1.1648025,5.3538836,11.2032467,16.7137033,0.7672183,44.5758827),(30030,'full set',251,3,24,5.1742216,112.5995683,120.5657991,1.8,112.7897947,120.5704528,1.5115517,1.2296335,3.7108918,0.9835036,17.148419,0.859347,4.6211046,0.7998348,4.8766409,11.1820393,16.4183554,0.748378,44.3241773),(30031,'full set',251,3,25,4.3232929,112.4925931,120.4309054,1.8,112.6641936,120.3048275,1.5305214,0.9490344,3.5667378,0.6194104,13.8164798,0.7193807,3.8737021,0.6526744,4.01787,10.6342355,16.1747714,0.6913369,42.8571307),(30032,'full set',251,3,26,3.9135223,112.4507711,120.3214674,1.8,112.6298186,120.2009211,1.5339547,0.9706896,3.455124,0.493752,11.8591459,0.6513688,3.4323359,0.5086611,3.57066,10.3304002,15.9042615,0.6705216,41.9977547),(30033,'full set',251,3,27,3.184003,112.3846778,120.2227898,1.8,112.5030606,120.1622492,1.5359901,0.6646204,3.3538426,0.3082762,8.8763701,0.5300245,2.6466269,0.463838,2.7368083,10.0265649,15.8461105,0.7086263,41.3900841),(30034,'full set',251,3,28,2.9023556,112.3651225,120.1792897,1.8,112.4991029,120.1091036,1.5345255,0.6687265,3.3098334,0.2635715,7.6486111,0.4830898,2.3108749,0.3941394,2.3894905,10.0265649,15.5698916,0.6876713,41.1383787),(30035,'full set',251,3,29,2.4061997,112.3332138,120.0994895,1.8,112.4677648,119.9811664,1.5364458,0.6817688,3.2287928,0.1956264,5.7389013,0.4005603,1.7774139,0.2869394,1.8352404,9.7227296,15.5223861,0.7266423,40.5307081),(30036,'full set',251,3,30,2.147883,112.3155296,120.0843983,1.8,112.4350267,119.9220145,1.5374564,0.6844215,3.2130443,0.1598862,4.759299,0.3575827,1.4812429,0.2336078,1.527698,9.6088866,15.3007547,0.6659692,39.5670723),(30037,'full set',251,3,31,1.8079367,112.2980958,120.1013331,1.8,112.4300877,119.9274025,1.5295315,0.7005269,3.2296192,0.1253608,3.4168452,0.30081,1.0579715,0.1789521,1.0967735,9.4188943,14.9652379,0.6837093,39.0636615),(30038,'full set',251,3,32,1.6654905,112.2873274,120.0766205,1.8,112.4031979,119.9466095,1.5289298,0.7101067,3.2044868,0.1081519,2.9053445,0.2770955,0.9066489,0.1523037,0.9403981,9.4188943,14.9158068,0.72425,39.0636615),(30039,'full set',251,3,33,1.3483155,112.2598101,120.0279822,1.8,112.3438807,119.7462331,1.5316542,0.719607,3.1547844,0.0716578,2.0395692,0.2243751,0.6465004,0.099579,0.6692093,9.115059,14.6975909,0.6610432,38.2042855),(30040,'full set',251,3,34,1.2491179,112.251804,120.003394,1.8,112.3122587,119.6988,1.53411,0.3779304,3.1299396,0.0604131,1.7761739,0.2079062,0.5674787,0.1598524,0.5867763,9.115059,14.6346459,0.7022569,37.8483203),(30041,'full set',251,3,35,1.0554783,112.2433659,120.035854,1.8,112.3068741,119.9055672,1.5283637,0.3775294,2.732593,0.0489707,1.2429794,0.1755965,0.4548718,0.1297136,0.4727786,9.032932,14.4377726,0.6375488,37.5966149),(30042,'full set',251,3,36,0.9984103,112.2438482,119.9961951,1.8,112.3156689,119.7874658,1.5243023,0.3792511,2.692891,0.0463844,1.0690793,0.1660423,0.3970006,0.1223052,0.4141998,8.9480626,14.0948144,0.6556956,37.3449095),(30043,'full set',251,3,37,0.8787354,112.2375369,120.0051885,1.8,112.309701,119.829241,1.5282048,0.3822059,2.2724054,0.039953,0.7850114,0.1461904,0.3454539,0.1045328,0.3630336,8.6855039,14.0948144,0.6556956,36.3812737),(30044,'full set',251,3,38,0.8523274,112.23626,119.9770749,1.8,112.309701,119.829241,1.5282969,0.3821981,2.2442637,0.0385234,0.737273,0.1417981,0.3285144,0.1007944,0.3456777,8.6855039,14.0948144,0.6556956,36.3812737),(30045,'full set',251,3,39,0.7577736,112.2324181,119.9702601,1.8,112.309701,119.829241,1.5282842,0.3857589,2.2372917,0.0335722,0.6136767,0.1260675,0.2742945,0.0870289,0.2892965,8.6110275,13.7567282,0.6747409,36.3812737),(30046,'full set',251,3,40,0.7548083,112.2328749,119.957895,1.8,112.309701,119.829241,1.526856,0.3860888,2.2249402,0.0335178,0.5982089,0.1255586,0.2688651,0.0868136,0.2839245,8.5485395,13.4924769,0.6498704,35.7736031),(30047,'full set',251,3,41,0.6774867,112.2230865,119.9580383,1.8,112.2917973,119.882952,1.5188911,0.3808798,2.2243979,0.0281242,0.5128584,0.1126105,0.2305605,0.0738401,0.2431629,8.4141472,13.2369013,0.6240231,35.1659325),(30048,'full set',251,3,42,0.6520859,112.2164038,119.9271927,1.8,112.271336,119.790876,1.5278573,0.3818625,2.1935716,0.0260634,0.478333,0.1084807,0.2180613,0.0682535,0.2299264,8.2313064,12.9905136,0.5971767,34.9142271),(30049,'full set',251,3,43,0.5485242,112.2116801,119.910432,1.8,112.2917973,119.8113373,1.5201385,0.3892549,1.7471877,0.0211838,0.3313718,0.0911863,0.1896601,0.0544214,0.2017633,8.1956634,12.5495381,0.6640462,33.6988859),(30050,'full set',251,3,44,0.5391248,112.2108184,119.9024387,1.8,112.2917973,119.8113373,1.5200048,0.3897682,1.7391575,0.0206838,0.3231073,0.0896225,0.1857838,0.0530668,0.1976545,8.1247444,12.2140278,0.6857295,33.4471805),(30051,'full set',251,3,45,0.4802105,112.2033866,119.8868569,1.8,112.2917973,119.8113373,1.5231636,0.3950896,1.7233132,0.0173488,0.2853305,0.0798536,0.1655709,0.0439111,0.1756161,8.091519,11.7988288,0.5779019,32.2318393),(30052,'full set',251,3,46,0.4792034,112.2032008,119.8830523,1.8,112.2917973,119.8113373,1.5228858,0.3952083,1.7194965,0.0172801,0.2850372,0.079684,0.1657678,0.043724,0.1757944,8.091519,11.4655059,0.2267988,31.9801339),(30053,'full set',251,3,47,0.3998677,112.1792901,119.8738737,1.8,112.2345056,119.7540456,1.5310512,0.3982901,1.7095442,0.0111866,0.2353633,0.0665394,0.137676,0.0280866,0.1441855,8.0305001,11.2048922,0.5667292,31.3724633),(30054,'full set',251,3,48,0.3948882,112.1775467,119.8665754,1.8,112.2345056,119.7540456,1.5321325,0.3997768,1.7022233,0.0107916,0.2367246,0.0657164,0.1390679,0.026994,0.1453735,8.0305001,11.0889478,0.6202495,31.3724633),(30055,'full set',251,3,49,0.3648995,112.1760412,119.8729378,1.8,112.2345056,119.7540456,1.5326402,0.4015401,1.7085421,0.0097724,0.2165551,0.0607281,0.1267485,0.0243373,0.1324359,7.7856148,10.8788312,0.1586553,30.7647927),(30056,'full set',251,3,50,0.3692076,112.1762415,119.8808032,1.8,112.2345056,119.7540456,1.5337827,0.4016596,1.7164515,0.0099133,0.2244561,0.0614503,0.1307675,0.0246809,0.1365132,7.7856148,10.7422,0.6435011,30.4088275),(30057,'full set',251,3,51,0.3073839,112.148568,119.8623827,1.8,112.148568,119.668108,1.546104,0.0419279,1.697665,0.0048461,0.19599,0.0511994,0.1154468,0.1155809,0.1182653,7.7856148,10.6125107,0.3729877,29.8011569),(30058,'full set',251,3,52,0.3014533,112.148568,119.8626957,1.8,112.148568,119.668108,1.5463312,0.0415497,1.6979875,0.0047515,0.193956,0.0502122,0.114227,0.1143573,0.1169903,7.7290989,10.4900209,0.610726,29.4451917),(30059,'full set',251,3,53,0.2519944,112.148568,119.9482066,1.8,112.148568,119.882952,1.5419922,0.0390046,1.3537568,0.0039887,0.1382218,0.0419642,0.1021024,0.1022625,0.1050052,7.734384,10.2496576,0.5763752,28.5858157),(30060,'full set',251,3,54,0.2641913,112.148568,119.8587468,1.8,112.148568,119.668108,1.5476481,0.0392222,1.6940928,0.0041589,0.1794462,0.0440083,0.1059246,0.1060331,0.1083505,7.734384,10.1410009,0.6350267,28.5858157),(30061,'full set',251,3,55,0.2258662,112.148568,119.9562874,1.8,112.148568,119.882952,1.5439077,0.0366287,1.3619069,0.0035685,0.1325003,0.0376172,0.0972903,0.0974238,0.0998744,7.734384,10.0219602,0.5404195,28.3341103),(30062,'full set',251,3,56,0.2236842,112.148568,120.0037547,1.8,112.148568,119.882952,1.5446073,0.0369188,1.4093833,0.0035316,0.1346454,0.0372551,0.095535,0.0956595,0.0980072,7.734384,10.0219602,0.5404195,28.3341103),(30063,'full set',251,3,57,0.1792607,112.148568,120.0796912,1.8,112.148568,119.882952,1.5443626,0.0392708,1.4852841,0.0028309,0.1069282,0.0298559,0.0719918,0.0720873,0.0738719,7.734384,9.8921606,0.6000502,28.3341103),(30064,'full set',251,3,58,0.1744491,112.148568,120.0503898,1.8,112.148568,119.882952,1.5466749,0.0351294,1.456078,0.0027488,0.1138065,0.0290579,0.0781596,0.0782464,0.0800241,7.734384,9.6942031,0.2234766,28.0824049),(30065,'full set',251,3,59,0.1782536,112.148568,120.136503,1.8,112.148568,120.097796,1.5508065,0.0308346,1.5423068,0.0027974,0.1398145,0.0296971,0.0906528,0.0907225,0.0924481,7.734384,9.6560368,2.7776137,27.9781451),(30066,'full set',251,3,60,0.1869257,112.148568,120.1661525,1.8,112.148568,120.097796,1.5512637,0.0307085,1.5719646,0.0029322,0.1499878,0.0311424,0.0954142,0.0954843,0.097261,7.734384,9.6560368,0.5633163,27.9781451),(30067,'full set',251,3,61,0.1818903,112.148568,120.2829015,1.8,112.148568,120.097796,1.5520116,0.0317257,1.6887155,0.0028511,0.1516569,0.0303044,0.0898061,0.0898672,0.0914783,7.734384,9.5406219,0.625485,27.9781451),(30068,'full set',251,3,62,0.1889399,112.148568,120.2698875,1.8,112.148568,120.097796,1.5518784,0.0317045,1.6756996,0.002962,0.1564439,0.0314787,0.0933603,0.0934247,0.0951109,7.734384,9.5115493,2.8198421,27.4747343),(30069,'full set',251,3,63,0.1729384,112.148568,120.3059674,1.8,112.148568,120.097796,1.5530654,0.0303552,1.7118103,0.002708,0.1526178,0.028814,0.0891558,0.0892099,0.0907234,7.734384,9.3845276,2.863293,27.4747343),(30070,'full set',251,3,64,0.196493,112.148568,120.4380472,1.8,112.148568,120.31264,1.5555547,0.0281069,1.843945,0.0030693,0.2012697,0.0327412,0.1091517,0.1092009,0.1108033,7.734384,9.4237936,2.7187387,27.7264397),(30071,'full set',251,3,65,0.1892196,112.148568,120.4853029,1.8,112.148568,120.31264,1.5561163,0.027765,1.8912111,0.0029541,0.2011307,0.0315298,0.1063502,0.1063948,0.1079006,8.1444208,9.4237936,2.7187387,27.7264397),(30072,'full set',251,3,66,0.1999059,112.148568,120.5190057,1.8,112.148568,120.31264,1.5562929,0.0279198,1.9249152,0.0031203,0.215042,0.0333106,0.111715,0.1117607,0.1133241,8.1444208,9.2557628,2.7610863,27.4747343),(30073,'full set',251,3,67,0.1840163,112.148568,120.5518491,1.8,112.148568,120.31264,1.556823,0.0273583,1.95777,0.0028708,0.205359,0.0306634,0.1048944,0.1049342,0.1063504,8.1444208,9.2557628,2.7610863,27.4747343),(30074,'full set',251,3,68,0.1995702,112.148568,120.5687422,1.8,112.148568,120.31264,1.5570857,0.0270756,1.9746686,0.0031127,0.2269291,0.0332554,0.1149201,0.1149622,0.1164855,7.734384,9.2557628,2.7610863,26.8670637),(30075,'full set',251,3,69,0.2096969,112.148568,120.7187112,1.8,112.148568,120.527484,1.5589348,0.0252031,2.1246737,0.0032647,0.2751419,0.0349446,0.1294984,0.129534,0.1310257,7.734384,9.2557628,2.7610863,27.1187691),(30076,'full set',251,3,70,0.2314611,112.148568,120.7714101,1.8,112.148568,120.527484,1.5595065,0.0245834,2.1773833,0.0036015,0.3189058,0.0385719,0.1464629,0.1464994,0.1481075,7.734384,9.2257926,2.6571147,26.7628039),(30077,'full set',251,3,71,0.2296707,112.148568,120.8610287,1.8,112.148568,120.527484,1.5596658,0.0252339,2.2670002,0.003573,0.3209212,0.0382737,0.1415621,0.1415964,0.1431293,7.734384,9.0642783,2.5930433,26.7628039),(30078,'full set',251,3,72,0.2552394,112.148568,120.929669,1.8,112.148568,120.527484,1.5597518,0.025797,2.3356385,0.0039705,0.3593979,0.0425347,0.1538757,0.1539124,0.1555661,7.734384,9.0642783,2.5930433,26.5110985),(30079,'full set',251,3,73,0.2801368,112.148568,121.166352,1.8,112.148568,120.742328,1.560736,0.0258794,2.5723339,0.0043535,0.4326416,0.0466847,0.1681903,0.1682237,0.1698741,7.734384,9.2257926,2.6571147,26.5110985),(30080,'full set',251,3,74,0.3280291,112.165351,121.2957996,1.8,112.1843753,120.8855573,1.5472433,0.3853471,2.7015574,0.0072879,0.4936501,0.0546412,0.182728,0.0189124,0.1853977,8.0441187,9.2557628,2.7610863,26.9713235),(30081,'full set',251,3,75,0.3658507,112.164733,121.4047007,1.8,112.1816209,121.0728572,1.5500318,0.3915002,2.8105424,0.0080616,0.5797141,0.0609488,0.2062642,0.0205916,0.2091089,8.0251607,9.2955727,2.1587989,27.2230289),(30082,'full set',251,3,76,0.45218,112.1942908,121.5368946,1.8,112.2345056,121.2579536,1.5327369,0.3648714,2.9426151,0.0144323,0.6988791,0.0752542,0.2375027,0.0395544,0.2423458,7.734384,9.4335845,2.6167969,26.8670637),(30083,'full set',251,3,77,0.4771333,112.1944189,121.6053318,1.8,112.2345056,121.2579536,1.5343398,0.3680529,3.011114,0.0152921,0.7527165,0.0794166,0.2499794,0.0415486,0.2550005,7.734384,9.2257926,2.6571147,26.2593931),(30084,'full set',251,3,78,0.5109824,112.1914756,121.5967169,1.8,112.2345056,121.2579536,1.5361559,0.371494,3.0025135,0.0159389,0.8047343,0.0850616,0.2680202,0.042905,0.2732721,7.734384,9.2257926,2.6571147,26.2593931),(30085,'full set',251,3,79,0.512605,112.1840236,121.5411106,1.8,112.2345056,121.2579536,1.5402083,0.3790536,2.9469283,0.0147705,0.8302665,0.0853542,0.2817396,0.0389668,0.2867024,7.9984867,9.0642783,2.1193457,26.6153583),(30086,'full set',251,3,80,0.5188712,112.1714563,121.4749845,1.8,112.209952,121.202708,1.5451402,0.3813693,2.8807355,0.0126552,0.8760708,0.0864216,0.3041136,0.0331837,0.3084583,7.9765186,9.0642783,2.1193457,26.6153583),(30087,'full set',251,3,81,0.4750072,112.148568,121.3568982,1.8,112.148568,120.957172,1.5616493,0.0252729,2.7628947,0.0073753,0.8061533,0.0791612,0.2917785,0.2918264,0.2944356,7.734384,8.9412281,2.1854593,26.2593931),(30088,'full set',251,3,82,0.5016949,112.148568,121.3546825,1.8,112.148568,121.172016,1.5620492,0.0241487,2.7606889,0.0077866,0.8900319,0.0836094,0.3223948,0.3224433,0.3252029,7.304696,9.1957248,2.223643,26.1551333),(30089,'full set',251,3,83,0.4701956,112.148568,121.2950835,1.8,112.148568,121.172016,1.5618101,0.0242733,2.7010864,0.0072994,0.8121384,0.0783596,0.300671,0.3007187,0.3033612,7.304696,9.0642783,2.1193457,25.9034279),(30090,'full set',251,3,84,0.4853578,112.148568,121.1754832,1.8,112.148568,120.957172,1.5609899,0.0253157,2.5814711,0.0075409,0.7688106,0.0808852,0.2978188,0.297875,0.3007255,7.304696,8.8582451,1.9693188,25.1483117),(30091,'full set',251,3,85,0.478532,112.148568,121.1258973,1.8,112.148568,120.957172,1.560654,0.0256799,2.531879,0.0074373,0.7331281,0.0797471,0.2895589,0.2896173,0.2924813,7.304696,8.8582451,1.9693188,25.4000171),(30092,'full set',251,3,86,0.5066744,112.148568,121.098282,1.8,112.148568,120.957172,1.5605192,0.0257375,2.5042617,0.0078758,0.7661556,0.0844368,0.3059407,0.306004,0.3090693,7.304696,8.9412281,2.1854593,25.6517225),(30093,'full set',251,3,87,0.4837912,112.148568,121.0466924,1.8,112.148568,120.957172,1.5598076,0.0269526,2.4526563,0.0075254,0.6846403,0.0806221,0.2791424,0.2792083,0.2821936,7.304696,8.6473042,2.0344439,25.1483117),(30094,'full set',251,3,88,0.5139477,112.148568,121.0291141,1.8,112.148568,120.957172,1.5595477,0.0273925,2.435072,0.0079965,0.7106799,0.0856471,0.2918517,0.2919239,0.2951169,7.304696,8.8478174,2.0778948,25.4000171),(30095,'full set',251,3,89,0.5391807,112.1672501,120.9902335,1.8,112.209952,120.957172,1.5589107,0.4139233,2.3963983,0.0125379,0.686069,0.0898508,0.2862917,0.0302903,0.2915213,7.6720481,8.76395,1.7681919,25.8602421),(30096,'full set',251,3,90,0.5923323,112.1775873,120.999118,1.8,112.2345056,121.0001408,1.553959,0.4049354,2.4053777,0.0161056,0.7278904,0.0986941,0.3026096,0.0397733,0.3093018,7.304696,8.7005189,1.9237867,25.1483117),(30097,'full set',251,3,91,0.6181248,112.1903778,120.9193682,1.8,112.2631515,120.7996197,1.5523349,0.3990125,2.3258557,0.0196691,0.6546114,0.1029857,0.2814497,0.0492945,0.2899064,7.304696,8.7005189,1.9237867,25.1483117),(30098,'full set',251,3,92,0.6580724,112.1945982,120.9138817,1.8,112.2631515,120.7996197,1.5519244,0.3949354,2.3204492,0.0218946,0.6781928,0.1096397,0.2922679,0.0554385,0.3017033,7.304696,8.5614727,1.8766752,24.8966063),(30099,'full set',251,3,93,0.6426305,112.1973503,120.930237,1.8,112.271336,120.957172,1.5495497,0.3939407,1.9590521,0.021995,0.5828314,0.1070567,0.2975068,0.0558333,0.3084059,7.304696,8.5614727,1.8766752,24.6449009),(30100,'full set',251,3,94,0.6897396,112.2020699,120.9316235,1.8,112.271336,120.957172,1.5496125,0.3892132,1.9575716,0.0246804,0.6111183,0.114905,0.3121818,0.0634111,0.3244078,7.304696,8.463872,1.9890207,24.6449009),(30101,'full set',251,3,95,0.7115597,112.210869,120.8889247,1.8,112.2917973,120.8855573,1.5553612,0.3828698,2.0006433,0.027434,0.6082408,0.118565,0.3040226,0.0716537,0.3173911,7.304696,8.4420297,1.82812,24.6449009),(30102,'full set',251,3,96,0.7773557,112.2208734,120.9039172,1.8,112.309701,120.957172,1.5471661,0.3814063,1.9845877,0.0322589,0.6650585,0.129487,0.3351117,0.0845789,0.350734,7.304696,8.3430318,1.7782926,24.6449009),(30103,'full set',251,3,97,0.7860838,112.2209268,120.9269868,1.8,112.309701,120.957172,1.54817,0.3808584,1.9616415,0.0326378,0.6741427,0.1309469,0.3436626,0.0856954,0.3596639,7.304696,8.5614727,1.8766752,24.6449009),(30104,'full set',251,3,98,0.8481872,112.225464,120.9480737,1.8,112.309701,120.957172,1.5482316,0.3767344,1.9404647,0.0362932,0.7336133,0.1412926,0.3780606,0.0963364,0.3959985,7.304696,8.5614727,1.8766752,24.3931955),(30105,'full set',251,3,99,0.8809174,112.2281469,120.9643903,1.8,112.309701,120.957172,1.5486224,0.3740008,1.9421016,0.0383414,0.7627674,0.1467474,0.3927536,0.102517,0.4124229,6.875008,8.4420297,1.82812,24.0372303),(30106,'full set',251,3,100,0.941734,112.2308959,120.9750927,1.8,112.309701,120.957172,1.5498168,0.3701945,1.9528143,0.041685,0.8209618,0.1568866,0.4203993,0.1126029,0.4416463,6.875008,8.4420297,1.82812,24.2889357),(30107,'full set',251,3,101,0.9430208,112.2320583,120.9869353,1.8,112.309701,120.957172,1.5496566,0.3694565,1.9646855,0.0420355,0.8112684,0.1570999,0.4129253,0.1137766,0.4342218,6.875008,8.4420297,1.82812,24.2889357),(30108,'full set',251,3,102,0.9990258,112.2351746,120.995097,1.8,112.309701,120.957172,1.5499847,0.366151,1.9728963,0.0453411,0.8607262,0.1664322,0.4362754,0.1238317,0.459135,6.875008,8.3430318,1.7782926,24.2889357),(30109,'full set',251,3,103,1.0135725,112.2358765,121.0010516,1.8,112.309701,120.957172,1.5501079,0.3654363,1.9788586,0.0461847,0.8711213,0.1688565,0.440214,0.1263823,0.4634258,6.875008,8.4420297,1.82812,24.2889357),(30110,'full set',251,3,104,1.1010208,112.2418246,121.0602652,1.8,112.3156689,121.172016,1.5486853,0.3623786,2.2575765,0.0517578,1.02265,0.1834138,0.4529858,0.142828,0.4749574,6.875008,8.4420297,1.82812,24.5406411),(30111,'full set',251,3,105,1.0954819,112.2423839,121.0744035,1.8,112.3156689,121.172016,1.5483878,0.3624842,2.2433865,0.0516482,1.0078397,0.1824886,0.4492493,0.142484,0.4713002,6.875008,8.3430318,1.7782926,24.2889357),(30112,'full set',251,3,106,1.1555711,112.2450782,121.0909632,1.8,112.3156689,121.172016,1.5480861,0.3605237,2.2267263,0.0552201,1.0702142,0.1924959,0.4806222,0.1531664,0.5043216,6.875008,8.3430318,1.7782926,24.0372303),(30113,'full set',251,3,107,1.166649,112.2461607,121.1099284,1.8,112.3156689,121.172016,1.5484297,0.3594534,2.207792,0.0560567,1.0685391,0.1943442,0.4839854,0.1559498,0.5082503,6.875008,8.4420297,1.82812,24.0372303),(30114,'full set',251,3,108,1.2290322,112.2487966,121.1277503,1.8,112.3156689,121.172016,1.5485068,0.3571212,2.1899271,0.059801,1.1366553,0.2047369,0.5190379,0.1674529,0.5450838,6.875008,8.4420297,1.82812,24.0372303),(30115,'full set',251,3,109,1.2820719,112.2513256,121.1595838,1.8,112.3156689,121.172016,1.5499367,0.3534875,2.1582587,0.0631264,1.1944281,0.2135857,0.5534221,0.1785818,0.5813093,6.875008,8.4420297,1.3134726,24.0372303),(30116,'full set',251,3,110,1.3320903,112.2530438,121.1643639,1.8,112.3156689,121.172016,1.5505844,0.3510438,2.1535402,0.0660976,1.2551679,0.2219244,0.5828393,0.1882887,0.6120875,6.875008,8.4420297,1.3134726,24.0372303),(30117,'full set',251,3,111,1.2477751,112.2504123,121.1749446,1.8,112.3156689,121.172016,1.5499014,0.3547663,2.1530268,0.061187,1.1482568,0.2078717,0.5333221,0.1724714,0.5615453,6.875008,8.4420297,1.3134726,23.7855249),(30118,'full set',251,3,112,1.2872192,112.2519419,121.1836327,1.8,112.3156689,121.172016,1.5504634,0.3526915,2.161712,0.0635641,1.1919513,0.2144478,0.5513923,0.1802259,0.5805774,6.44532,8.3430318,1.7782926,23.4295597),(30119,'full set',251,3,113,1.2500131,112.2500761,121.1993451,1.8,112.3156689,121.172016,1.5511865,0.3539294,2.1773412,0.0612092,1.149953,0.2082554,0.5281455,0.1729417,0.5560545,6.44532,8.3430318,1.7782926,23.4295597),(30120,'full set',251,3,114,1.2814005,112.2519798,121.2097448,1.8,112.3156689,121.172016,1.5517544,0.3514803,2.1877415,0.0632974,1.1771978,0.2134893,0.5380882,0.180088,0.5667951,6.44532,8.3430318,1.7782926,23.4295597),(30121,'full set',251,3,115,1.2287525,112.2500911,121.2061375,1.8,112.3156689,121.172016,1.5505927,0.3548292,2.184167,0.060181,1.1020316,0.2047085,0.5045546,0.1696054,0.5319242,6.44532,8.3430318,1.7782926,23.4295597),(30122,'full set',251,3,116,1.2605315,112.2516702,121.2159956,1.8,112.3156689,121.172016,1.5510909,0.3527889,2.1940255,0.0621874,1.1309634,0.210007,0.5154741,0.1762737,0.5436156,6.44532,8.3430318,1.3633001,23.4295597),(30123,'full set',251,3,117,1.1987078,112.2497076,121.2269078,1.8,112.3156689,121.172016,1.5507792,0.3553829,2.2049147,0.0586151,1.0519408,0.1997046,0.4770891,0.164935,0.5035046,6.44532,8.3430318,1.3633001,23.4295597),(30124,'full set',251,3,118,1.2236051,112.2505968,121.2321173,1.8,112.3156689,121.172016,1.5510161,0.3542802,2.2101273,0.0600784,1.077293,0.2038544,0.4874348,0.1695787,0.5144389,6.44532,8.2652137,1.4141944,23.4295597),(30125,'full set',251,3,119,1.171125,112.2492569,121.2394909,1.8,112.3156689,121.172016,1.550161,0.3569197,2.2175207,0.0571537,1.0046132,0.1951044,0.4530344,0.1601303,0.4786612,6.44532,8.2652137,1.4141944,23.4295597),(30126,'full set',251,3,120,1.1960782,112.2508345,121.2465049,1.8,112.3156689,121.172016,1.5506376,0.3548406,2.2245387,0.0588027,1.0211912,0.1992654,0.4590575,0.1657159,0.4853294,6.44532,8.2652137,1.4141944,23.4295597),(30127,'full set',251,3,121,1.1395697,112.2503784,121.2878976,1.8,112.3254984,121.2983948,1.5516889,0.354661,2.0302422,0.0559302,0.9132149,0.189859,0.4498059,0.1577005,0.4762134,6.44532,8.0272343,1.2998495,23.0735945),(30128,'full set',251,3,122,1.1588162,112.2515089,121.2935867,1.8,112.3254984,121.2983948,1.55084,0.3548313,2.0244116,0.0571719,0.9261717,0.1930591,0.4575017,0.1611241,0.4845294,6.44532,8.0272343,1.2998495,23.0735945),(30129,'full set',251,3,123,1.0724868,112.2478475,121.3011757,1.8,112.3254984,121.2983948,1.5487004,0.3616623,2.0165939,0.0520293,0.8320766,0.1786605,0.4126149,0.1438616,0.437304,6.875008,7.9230552,1.3521274,23.4295597),(30130,'full set',251,3,124,1.0882085,112.2496828,121.3038606,1.8,112.3254984,121.2983948,1.5489631,0.3595155,2.0139073,0.0532521,0.8409552,0.1812816,0.417574,0.1481219,0.4428679,6.44532,7.9230552,1.3521274,22.8218891),(30131,'full set',251,3,125,1.0135166,112.2444443,121.2879831,1.8,112.3204432,121.2579536,1.5366529,0.3669122,1.8369227,0.0483071,0.7225027,0.1687226,0.3933223,0.1316584,0.4195517,6.875008,7.9230552,1.3521274,23.1778543),(30132,'full set',251,3,126,1.0076419,112.244717,121.2931923,1.8,112.3204432,121.2579536,1.5370225,0.3664595,1.8421257,0.0481049,0.7121659,0.1677488,0.3866,0.1312694,0.4126437,6.875008,7.9230552,1.3521274,22.9261489),(30133,'full set',251,3,127,0.9039124,112.2392344,121.2819646,1.8,112.3204432,121.2579536,1.5372597,0.3713327,1.8307124,0.0419683,0.6233285,0.1504827,0.3404841,0.1130209,0.3633622,6.875008,7.9230552,1.3521274,22.9261489),(30134,'full set',251,3,128,0.8827077,112.2377629,121.2827539,1.8,112.3204432,121.2579536,1.5373124,0.3727794,1.8314504,0.0406686,0.6006654,0.1469531,0.3279725,0.1090955,0.3501375,6.875008,7.8410702,1.735945,22.9261489),(30135,'full set',251,3,129,0.8054421,112.2334251,121.2850494,1.8,112.3204432,121.2579536,1.5380131,0.3765186,1.8335825,0.0362366,0.5337057,0.1340961,0.2910726,0.0962412,0.310807,6.875008,7.8410702,1.735945,22.9261489),(30136,'full set',251,3,130,0.7622495,112.2262487,121.26493,1.8,112.302028,121.172016,1.5473754,0.3742123,1.8129884,0.0328671,0.4931696,0.1269719,0.2720203,0.0878302,0.2900942,6.875008,7.8410702,1.735945,22.9261489),(30137,'full set',251,3,131,0.6779903,112.2216837,121.2700237,1.8,112.302028,121.172016,1.5460113,0.380189,1.8180137,0.0283797,0.42575,0.112929,0.2341842,0.0746462,0.2497647,6.875008,7.8410702,1.4056476,22.9261489),(30138,'full set',251,3,132,0.6162785,112.2130505,121.322241,1.8,112.2917973,121.38686,1.5361578,0.3850698,1.565353,0.0242594,0.3497619,0.1025899,0.2234397,0.063,0.2382526,6.875008,7.7819807,1.6814535,22.9261489),(30139,'full set',251,3,133,0.4888266,112.2019778,121.3129666,1.8,112.2917973,121.38686,1.535783,0.3960235,1.5749646,0.0175619,0.2689195,0.0813713,0.1707464,0.0443457,0.1814661,6.875008,7.6864926,1.1071487,22.5701837),(30140,'full set',251,3,134,0.4139109,112.1801063,121.2661083,1.8,112.2440542,121.2197591,1.5304471,0.4016211,1.3833027,0.0117616,0.2059259,0.0688729,0.1488654,0.0292854,0.1573437,6.875008,7.6864926,1.1071487,22.8218891),(30141,'full set',251,3,135,0.2935645,112.148568,121.2607871,1.8,112.148568,121.172016,1.5397596,0.0427566,1.3771715,0.0046567,0.14972,0.0488803,0.1087156,0.1089127,0.112043,6.44532,7.6864926,1.1071487,22.2142185),(30142,'full set',251,3,136,0.2628485,112.148568,121.2693315,1.8,112.148568,121.172016,1.5390229,0.0440426,1.3856797,0.0041725,0.1310264,0.0437639,0.0945575,0.094737,0.0975194,6.44532,7.6140908,1.8568478,22.2142185),(30143,'full set',251,3,137,0.1963811,112.148568,121.3244267,1.8,112.148568,121.38686,1.5313694,0.0448032,1.13577,0.0031403,0.0793796,0.0326793,0.0698905,0.0700918,0.072599,6.875008,7.6140908,1.8568478,22.3184783),(30144,'full set',251,3,138,0.1698612,112.148568,121.3224634,1.8,112.148568,121.38686,1.5300592,0.0463711,1.1376719,0.0027197,0.0665202,0.0282633,0.0584704,0.0586498,0.0608105,6.875008,7.6140908,1.8568478,22.3184783),(30145,'full set',251,3,139,0.1095482,112.148568,121.2510189,1.8,112.148568,121.172016,1.5174985,0.0499899,0.9370464,0.0017749,0.0331005,0.0182062,0.0353243,0.0355055,0.0371656,6.875008,7.6140908,1.8568478,22.3184783),(30146,'full set',251,3,140,0.0825248,112.148568,121.3634092,1.8,112.148568,121.38686,1.4943982,0.050983,0.6660343,0.0013658,0.017664,0.013674,0.0265211,0.0267891,0.0284884,6.875008,7.6140908,1.8568478,22.5701837),(30147,'full set',251,3,141,0.0436402,112.148568,121.2100269,1.8,112.148568,121.172016,1.4387873,0.0615613,0.4636296,0.0007575,0.005553,0.0071474,0.0119773,0.012305,0.0134927,6.875008,7.6140908,1.8568478,22.5701837),(30148,'full set',251,3,142,0.026296,112.148568,121.3850315,1.8,112.148568,121.38686,1.2767783,0.0627917,0.2073744,0.0005065,0.0015163,0.0040146,0.0073121,0.0080667,0.009336,6.875008,7.7463106,1.9100889,22.5701837),(30149,'full set',251,3,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30150,'full set',251,3,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30151,'full set',251,3,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30152,'full set',251,3,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30153,'full set',251,3,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30154,'full set',251,3,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30155,'full set',251,3,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30156,'full set',251,3,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30157,'full set',251,3,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30158,'full set',251,3,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30159,'full set',251,3,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30160,'full set',251,3,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30161,'full set',251,3,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30162,'full set',251,3,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30163,'full set',251,3,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30164,'full set',251,3,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30165,'full set',251,3,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30166,'full set',251,3,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30167,'full set',251,3,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30168,'full set',251,3,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30169,'full set',251,3,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30170,'full set',251,3,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30171,'full set',251,3,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30172,'full set',251,3,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30173,'full set',251,3,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30174,'full set',251,3,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30175,'full set',251,3,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30176,'full set',251,3,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30177,'full set',251,3,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30178,'full set',251,3,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30179,'full set',251,3,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30180,'full set',251,3,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30181,'full set',251,3,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30182,'full set',251,3,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30183,'full set',251,3,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30184,'full set',251,3,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30185,'full set',251,3,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30186,'full set',251,3,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30187,'full set',251,3,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30188,'full set',251,3,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30189,'full set',251,3,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30190,'full set',251,3,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30191,'full set',251,3,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30192,'full set',251,3,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30193,'full set',251,3,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30194,'full set',251,3,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30195,'full set',251,3,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30196,'full set',251,3,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30197,'full set',251,3,191,2.3537195,116.1306764,123.4263025,1.8,116.2749369,123.38184,-0.4555226,1.6812953,2.2507997,1.3179386,2.1426808,0.0759231,0.9519642,0.7838828,1.5373892,3.7523199,4.6477863,0.5880026,12.8042684),(30198,'full set',251,3,192,3.4746022,116.4910093,123.3212586,1.8,116.4326215,123.4102416,-0.9110018,1.7721597,2.1754477,2.1490034,3.0811734,0.3615247,1.4163399,1.2126465,2.3941265,3.867192,4.6477863,0.5880026,12.4483032),(30199,'full set',251,3,193,2.7759667,116.4018176,123.3343384,1.8,116.3850231,123.3943086,-0.6199822,1.6625821,2.1042695,1.7114585,2.5399326,0.1561875,1.2070376,1.0293979,2.0136146,3.6460236,4.6477863,0.5880026,12.1965978),(30200,'full set',251,3,194,3.0066446,116.288074,123.2543864,1.8,116.230604,123.320456,-0.3589481,1.7263531,2.1892685,1.9585289,3.1946622,0.0618388,1.4592373,1.1344892,2.3470211,3.8443347,4.8040579,0.4636476,12.8042684),(30201,'full set',251,3,195,3.4498727,116.126344,123.1683882,1.8,116.0836055,123.2243416,-0.1188761,1.8954611,2.3120751,2.4427584,4.4348612,0.0080871,1.9181302,1.2887409,2.9483136,3.867192,5.0293691,0.348771,13.411939),(30202,'full set',251,3,196,3.4931213,116.1836256,123.1509868,1.8,116.01576,123.1790397,0.0256468,1.9029238,2.3332358,2.6032903,4.9299435,0.0003829,2.1129212,1.3680475,3.1169426,3.867192,5.0293691,2.7928217,13.6636444),(30203,'full set',251,3,197,3.6193423,116.2695343,123.1154226,1.8,116.1082245,123.0920143,0.0719918,1.601203,2.4430585,2.5895719,5.2484763,0.003121,2.148322,1.6172664,3.1481411,3.437504,5.314947,2.896614,13.9153498),(30204,'full set',251,3,198,3.9750103,116.3983043,123.0835219,1.8,116.2856922,123.0835767,0.165341,1.709593,2.5281926,2.6520011,5.3365028,0.0179468,2.1107976,1.551247,3.1425437,3.437504,5.314947,0.2449787,13.9153498),(30205,'full set',251,3,199,4.3073475,116.6604399,123.1313446,1.8,116.660292,123.105612,0.0683342,1.5994093,1.9749971,2.3720579,4.4001919,0.003347,2.2279485,1.4830837,3.3090054,3.437504,4.6278814,2.7610863,12.4483032),(30206,'full set',251,3,200,3.8228849,117.0750005,123.1845466,1.8,117.0971415,123.1485808,-0.080922,1.628552,1.9659462,1.9479048,3.0171026,0.0041632,1.5346822,1.1960962,2.5195449,3.437504,4.381975,2.9441971,12.1965978),(30207,'full set',251,3,201,3.550525,117.3794946,123.2151398,1.8,117.3673241,123.2188934,-0.1742292,1.6019532,1.8590135,1.6551047,2.4819436,0.0177821,1.3350864,1.0331792,2.2105262,3.437504,4.231936,0.4182243,11.3372218),(30208,'full set',251,3,202,3.4899322,117.5780107,123.231132,1.8,117.581052,123.197688,-0.1872989,1.6517995,1.9058343,1.6030635,2.343623,0.0201675,1.2297097,0.9704952,2.0707823,3.437504,4.231936,0.4182243,11.5889272),(30209,'full set',251,3,203,3.4066801,117.7535586,123.2389205,1.8,117.7822551,123.193141,-0.1894943,1.6114974,1.8157958,1.4653081,2.2774158,0.020145,1.2542246,0.9092836,2.0022772,3.437504,4.231936,0.4182243,11.3372218),(30210,'full set',251,3,204,3.3708727,117.8996076,123.272701,1.8,117.8977934,123.2774872,-0.1658195,1.4330808,1.6663122,1.4020278,2.1817887,0.0153066,1.3093517,0.9783313,2.0445343,3.007816,4.0536685,0.5585993,10.6252914),(30211,'full set',251,3,205,3.4200519,118.0449477,123.3126183,1.8,118.0733045,123.3535089,-0.1540087,1.4316738,1.880962,1.3853154,2.355696,0.0134133,1.252389,0.9676194,1.9837862,3.007816,4.231936,0.4182243,10.9812566),(30212,'full set',251,3,206,3.5046468,118.1600499,123.3379618,1.8,118.1074488,123.3609926,-0.1097171,1.3923583,1.7964746,1.4042476,2.4965464,0.0070032,1.389692,1.0085389,2.0421591,3.007816,4.231936,0.4182243,10.9812566),(30213,'full set',251,3,207,3.5793388,118.2993628,123.3557109,1.8,118.291515,123.3443276,-0.0755552,1.3631775,1.8783988,1.4468976,2.6801168,0.003399,1.4268092,1.0614154,2.15924,3.007816,4.231936,2.7233683,11.232962),(30214,'full set',251,3,208,3.6620874,118.419102,123.385414,1.8,118.432755,123.351148,-0.066652,1.3966111,1.9935636,1.4756632,2.9484632,0.0027075,1.4789912,1.0566029,2.2042689,3.007816,4.4860744,0.2914568,11.5889272),(30215,'full set',251,3,209,3.7787411,118.5145021,123.4229935,1.8,118.5185041,123.4033782,-0.0288433,1.4135171,2.0776283,1.5396311,3.2803744,0.0005238,1.5789034,1.08922,2.3009841,3.007816,4.4860744,2.8501359,11.5889272),(30216,'full set',251,3,210,3.8217659,118.6180119,123.4475797,1.8,118.7145022,123.4109166,-0.0317905,1.4298966,2.1272834,1.556245,3.4181768,0.0006435,1.6068272,1.0883619,2.3182619,3.007816,4.4860744,2.8501359,11.8406326),(30217,'full set',251,3,211,4.0241895,118.707514,123.4974247,1.8,118.8189627,123.5114284,0.0198801,1.5437374,2.0479773,1.7342613,3.8288053,0.000265,1.8695546,1.1234173,2.5920617,3.437504,4.6278814,2.7610863,12.4483032),(30218,'full set',251,3,212,4.0058941,118.7486439,123.5295657,1.8,118.8355875,123.5353,0.0402931,1.5253414,2.0182601,1.7769017,3.9672808,0.0010834,1.9656935,1.1649207,2.7391717,3.437504,4.6278814,2.7610863,12.4483032),(30219,'full set',251,3,213,4.1372624,118.7528587,123.5576453,1.8,118.8252585,123.558437,0.043801,1.5554581,2.0148049,1.8645828,4.2341029,0.0013221,2.1014953,1.1987355,2.9065383,3.437504,4.6278814,2.7610863,12.4483032),(30220,'full set',251,3,214,4.2370755,118.7664645,123.5802456,1.8,118.7988161,123.5848794,0.0296621,1.5685412,2.3149567,1.8723136,4.4785087,0.0006211,1.9345972,1.1936655,2.7289232,3.437504,4.899197,0.266252,12.8042684),(30221,'full set',251,3,215,4.4497377,118.7226345,123.6083284,1.8,118.70131,123.6048084,0.0221268,1.5927155,2.2829982,1.9652175,5.0033879,0.000363,2.1915864,1.2338786,2.9681347,3.437504,5.0293691,0.348771,13.0559738),(30222,'full set',251,3,216,4.576798,118.7547682,123.636533,1.8,118.7534864,123.6396528,0.042418,1.6333171,2.3206463,2.0431024,5.3673744,0.0013717,2.3128791,1.2508914,3.1236614,3.437504,5.0293691,2.7928217,13.3076792),(30223,'full set',251,3,217,4.6482449,118.7004773,123.6664769,1.8,118.7289328,123.6826216,0.0450789,1.6479838,2.2683314,2.0821985,5.7167043,0.0015732,2.5202244,1.2634824,3.3721724,3.437504,5.0293691,2.7928217,13.3076792),(30224,'full set',251,3,218,4.707327,118.7053139,123.6838952,1.8,118.7633424,123.6835726,0.046031,1.6653975,2.4671377,2.1325001,6.069317,0.0016612,2.4600642,1.2804752,3.3238148,3.437504,5.2273801,2.976444,13.6636444),(30225,'full set',251,3,219,4.8740551,118.6309498,123.6847162,1.8,118.6403408,123.6630451,0.0335909,1.6800086,2.6115171,2.2531707,6.6790117,0.0009163,2.5575217,1.3411662,3.4144322,3.437504,5.314947,2.896614,14.1670552),(30226,'full set',251,3,220,4.9241295,118.6032667,123.6999403,1.8,118.6225339,123.6813939,0.0237365,1.6882523,2.5855863,2.3215947,6.9024996,0.0004623,2.6696071,1.3751468,3.5641873,3.437504,5.314947,2.896614,14.1670552),(30227,'full set',251,3,221,4.8955396,118.5110491,123.7157886,1.8,118.4893693,123.7327242,0.0224153,1.6954609,2.503523,2.3241682,6.9296732,0.0004099,2.7679687,1.3708179,3.6460138,3.437504,5.4351711,2.8198421,13.9153498),(30228,'full set',251,3,222,4.9502017,118.4949321,123.7178726,1.8,118.4767004,123.7055011,0.005891,1.6920969,2.4814702,2.4836226,6.9476954,0.0000286,2.7998302,1.467778,3.7398488,3.437504,5.4351711,2.8198421,13.9153498),(30229,'full set',251,3,223,4.9574192,118.4453356,123.7008399,1.8,118.4220128,123.6756647,-0.022496,1.6753494,2.4397354,2.5407791,6.838445,0.0004181,2.8029454,1.5165667,3.7875314,3.437504,5.314947,2.896614,13.6636444),(30230,'full set',251,3,224,4.9866246,118.4321861,123.7044696,1.8,118.4220128,123.6756647,-0.0342792,1.6812793,2.4312984,2.6097995,6.9818061,0.0009762,2.8716369,1.5522701,3.8946899,3.437504,5.314947,2.896614,13.6636444),(30231,'full set',251,3,225,5.0882839,118.3656282,123.6986542,1.8,118.3382508,123.6685577,-0.0517088,1.6976534,2.3938061,2.8310534,7.2951781,0.0022655,3.0475225,1.6676274,4.0179798,3.437504,5.4351711,0.3217506,13.9153498),(30232,'full set',251,3,226,5.1367917,118.3550258,123.7000952,1.8,118.3382508,123.6685577,-0.0616311,1.7037537,2.4061524,2.9359583,7.440541,0.0032478,3.0922982,1.7232293,4.1343529,3.437504,5.4351711,0.3217506,13.9153498),(30233,'full set',251,3,227,5.2222259,118.3014816,123.6978388,1.8,118.3199619,123.7179174,-0.0662417,1.8149708,2.4320309,3.172104,7.5074387,0.0038136,3.086901,1.7477439,4.2924538,3.867192,5.314947,2.896614,14.271315),(30234,'full set',251,3,228,5.260551,118.2991699,123.6906794,1.8,118.3498677,123.7130105,-0.0782424,1.8293978,2.4646212,3.272796,7.6943547,0.0053565,3.1219218,1.7890018,4.4015713,3.867192,5.4351711,0.3217506,14.271315),(30235,'full set',251,3,229,5.282427,118.2165326,123.6705415,1.8,118.1849079,123.6880204,-0.0804078,1.8573668,2.6628685,3.4449074,7.8933789,0.0056799,2.9642391,1.8547265,4.2317941,3.867192,5.6516632,0.1526493,14.8789856),(30236,'full set',251,3,230,5.2317372,118.2242081,123.6649637,1.8,118.2159696,123.7035513,-0.080775,1.8625493,2.6364073,3.5571145,7.8420497,0.0056768,2.9745213,1.9098096,4.3186654,3.867192,5.6024461,3.0648208,14.8789856),(30237,'full set',251,3,231,5.2002379,118.2065558,123.6017184,1.8,118.2130282,123.5499485,-0.105867,1.9932927,2.6669014,3.7721614,8.0397807,0.0096777,3.0146524,1.8924272,4.4016992,4.29688,5.6516632,0.1526493,15.4866562),(30238,'full set',251,3,232,5.1905588,118.227125,123.5818129,1.8,118.240589,123.5687202,-0.1171501,1.9738916,2.6928485,3.9239902,8.1180741,0.0118185,3.0146791,1.9879461,4.4469923,4.29688,5.7327529,0.2267988,15.4866562),(30239,'full set',251,3,233,5.200182,118.1848002,123.5286914,1.8,118.1304043,123.4846065,-0.1239395,1.9678718,2.6592898,4.0839383,8.1644435,0.0132453,3.0701593,2.0753071,4.571892,3.867192,5.585944,0.3947911,14.7747258),(30240,'full set',251,3,234,5.2681041,118.2171267,123.4952399,1.8,118.2303058,123.4668332,-0.1307938,1.9403058,2.6978673,4.2741032,8.2495148,0.0149348,3.0577912,2.2027987,4.6065399,3.867192,5.7327529,0.2267988,15.130691),(30241,'full set',251,3,235,5.1440651,118.1900536,123.4401669,1.8,118.0909577,123.4132295,-0.1636377,1.9581146,2.6896932,4.3552399,8.0646815,0.0227532,2.9983648,2.2242007,4.5880835,3.867192,5.585944,0.3947911,14.5230204),(30242,'full set',251,3,236,5.0374822,118.2143574,123.3872164,1.8,118.1311471,123.3440652,-0.161179,2.194538,2.6524629,4.5356812,7.9265867,0.021623,2.9883874,2.0668046,4.6970272,4.29688,5.6516632,0.1526493,15.4866562),(30243,'full set',251,3,237,4.9351515,118.1762078,123.3063,1.8,118.0902752,123.2834936,-0.1601476,2.1774077,2.6277689,4.717526,7.7800171,0.0209158,2.9606931,2.1665791,4.7557347,4.29688,5.4351711,0.3217506,15.130691),(30244,'full set',251,3,238,4.8285126,118.1968067,123.2508711,1.8,118.1174948,123.2317161,-0.125915,2.1204533,2.652766,4.8268374,7.6194347,0.0126917,2.8722604,2.2763234,4.6824891,4.29688,5.5026913,0.6747409,15.3823964),(30245,'full set',251,3,239,4.6483568,118.1657257,123.1611681,1.8,118.0894717,123.1709993,-0.0982814,2.0640274,2.6249972,4.8143474,7.3062641,0.0074592,2.7833417,2.3325017,4.5806679,4.29688,5.4351711,2.8198421,15.130691),(30246,'full set',251,3,240,4.4942172,118.1840938,123.1003457,1.8,118.1547563,123.136304,-0.1202925,2.0255913,2.6056612,4.8392442,7.0385899,0.0107866,2.7012682,2.3890526,4.5555559,4.29688,5.4351711,2.8198421,15.130691),(30247,'full set',251,3,241,4.3213907,118.134565,122.9731863,1.8,118.0918315,122.9812286,-0.0929683,2.2583632,2.5697261,4.9651521,6.6567633,0.0062071,2.5904564,2.1985623,4.5185515,4.726568,5.4351711,0.3217506,15.7383616),(30248,'full set',251,3,242,4.1886236,118.1411042,122.8927768,1.8,118.0810346,122.9415913,-0.0732488,2.2052578,2.5794799,4.8742462,6.3501889,0.0037389,2.4618098,2.2102841,4.3327902,4.726568,5.4351711,0.3217506,15.4866562),(30249,'full set',251,3,243,3.9626455,118.135049,122.7377145,1.8,118.102134,122.752313,-0.0733585,2.0508693,2.5848321,4.6887877,5.8098188,0.0035478,2.2476581,2.2862441,4.015161,4.29688,5.4351711,0.3217506,15.130691),(30250,'full set',251,3,244,3.8456561,118.1452583,122.6609926,1.8,118.1159204,122.7266175,-0.082401,2.0495751,2.5694152,4.7090411,5.5378634,0.0043421,2.1553011,2.2975695,3.9879281,4.29688,5.314947,2.896614,15.130691),(30251,'full set',251,3,245,3.7730902,118.0820764,122.4898223,1.8,118.0639395,122.5040488,0.1364332,2.2265623,2.4767194,4.816291,5.1675456,0.0116329,2.0864478,2.1631063,3.9492988,4.726568,5.314947,0.2449787,15.2349507),(30252,'full set',251,3,246,3.8693785,118.0948127,122.4176384,1.8,118.1075378,122.4752455,0.4946135,2.3041904,2.2172,5.050464,5.1327991,0.1453158,2.3149915,2.1918605,4.058505,4.726568,5.2273801,2.976444,15.2349507),(30253,'full set',251,3,247,3.9798778,118.0236366,122.2660067,1.8,118.019463,122.320866,0.1973632,2.3547116,2.4362485,5.1583511,5.2752496,0.0255038,2.1653168,2.190651,4.2606484,4.726568,5.2450105,0.610726,15.7383616),(30254,'full set',251,3,248,4.244181,118.0727147,122.1483783,1.8,118.0470124,122.1702811,-0.3163528,2.5011492,2.4605288,5.4454509,5.5622382,0.068462,2.2605865,2.1771795,4.3234799,4.8613648,5.4351711,1.2490458,15.8426213),(30255,'full set',251,3,249,5.0101232,118.0069513,121.941393,1.8,118.0209707,121.8963472,-1.393093,2.5187584,2.5526992,6.4037555,6.7098317,0.8089282,2.6285242,2.5424255,5.1296695,5.156256,5.4351711,0.3217506,16.0943267),(30256,'full set',251,3,250,5.7016531,117.9925744,121.8887797,1.8,118.0617056,121.8500558,-0.5942452,2.4755411,2.5642192,7.0279132,8.0020858,0.2978824,3.1206715,2.8389403,5.6829571,5.156256,5.585944,0.3947911,16.0943267),(30257,'full set',251,3,251,6.6803134,117.8780544,121.8565622,1.8,117.9254844,121.8514372,-0.620727,2.5561433,2.8784142,7.1124478,10.8737285,0.3766468,3.7776802,2.7824918,6.2389965,5.156256,6.1521959,0.4324078,17.2054082),(30258,'full set',251,3,252,4.4350231,118.3205852,121.9128482,1.8,118.2883321,121.9359058,-1.0240501,1.9071972,2.6899194,2.5908823,6.9859195,0.5393676,2.5970739,1.3584763,3.5366656,3.9498589,5.9694165,1.0427219,15.2349507),(30259,'full set',251,3,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30260,'full set',251,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30261,'full set',251,3,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30262,'full set',251,3,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30263,'full set',251,3,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30264,'full set',251,3,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30265,'full set',251,3,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30266,'full set',251,3,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30267,'full set',251,3,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30268,'full set',251,3,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30269,'full set',251,3,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30270,'full set',251,3,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30271,'full set',251,3,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30272,'full set',251,3,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30273,'full set',251,3,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30274,'full set',251,3,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30275,'full set',251,3,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30276,'full set',251,3,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30277,'full set',251,3,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30278,'full set',251,3,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30279,'full set',251,3,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30280,'full set',251,3,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30281,'full set',251,3,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30282,'full set',251,3,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30283,'full set',251,3,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30284,'full set',251,3,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30285,'full set',251,3,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30286,'full set',251,3,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30287,'full set',251,3,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30288,'full set',251,3,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30289,'full set',251,3,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30290,'full set',251,3,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30291,'full set',251,3,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30292,'full set',251,3,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30293,'full set',251,3,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30294,'full set',251,3,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30295,'full set',251,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30296,'full set',251,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30297,'full set',251,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30298,'full set',251,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30299,'full set',251,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30300,'full set',251,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30301,'full set',251,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30302,'full set',251,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30303,'full set',251,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30304,'full set',251,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30305,'full set',251,4,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30306,'full set',251,4,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30307,'full set',251,4,13,2.8358322,128.7195655,122.9614954,1.8,128.7193593,122.9969262,-0.1419818,1.6234285,3.3295576,1.340416,10.665398,0.009464,3.2032478,0.8256699,3.5892151,3.5613334,6.9948139,2.9562447,19.7403503),(30308,'full set',251,4,14,8.5547176,128.8166866,123.1560217,1.8,128.8458806,123.1752094,-0.0206192,2.3936126,3.5230774,6.8781484,27.0454592,0.0006061,7.6766577,2.8735429,9.2364462,4.726568,7.7463106,2.8023,20.6429122),(30309,'full set',251,4,15,9.0618955,128.7796772,123.1590594,1.8,128.7863401,123.2161935,-0.0303095,1.9822904,3.544677,6.9118462,25.3876275,0.0013871,7.1621836,3.486798,8.9400247,4.29688,7.5041783,2.910502,19.7835362),(30310,'full set',251,4,16,7.8454518,128.84695,123.1737446,1.8,128.852689,123.2237762,-0.0607367,1.9960411,3.4068123,5.3881298,20.9731446,0.0048176,6.1562373,2.6994082,7.692507,4.29688,7.086596,2.896614,19.1758656),(30311,'full set',251,4,17,6.5838573,128.8179728,123.1610483,1.8,128.8715604,123.2043241,-0.0534593,1.9585059,3.106262,4.112382,17.1298974,0.003133,5.5146339,2.0997547,6.5169437,4.1123629,6.7939638,2.8198421,17.708819),(30312,'full set',251,4,18,6.0997863,128.872738,123.1853548,1.8,128.9105717,123.2703953,-0.0548596,1.7586673,3.0530552,3.5422618,15.7681424,0.0030566,5.1647093,2.0141739,6.034627,3.7670207,6.6705516,2.8809903,17.4571136),(30313,'full set',251,4,19,5.8372176,128.8591401,123.1764936,1.8,128.8846986,123.2293101,-0.0542755,1.7459849,3.0427673,3.2015127,14.4436742,0.0028631,4.7468875,1.8336428,5.4873452,3.7401268,6.6705516,2.8809903,17.4571136),(30314,'full set',251,4,20,5.6787699,128.9116452,123.2138542,1.8,128.8571649,123.2891246,-0.0595983,1.7194264,3.0652483,3.0424754,13.3800266,0.0033578,4.3650711,1.7694711,5.1902284,3.7670207,6.5729625,2.9441971,17.4571136),(30315,'full set',251,4,21,5.33625,128.9340166,123.2229104,1.8,128.982789,123.2774872,-0.059821,1.7086414,2.9690368,2.7137078,11.2753705,0.0031789,3.7976527,1.5882254,4.4692657,3.7670207,6.2563517,2.863293,16.5977376),(30316,'full set',251,4,22,5.1359525,128.9821502,123.252153,1.8,129.012615,123.2818324,-0.0716376,1.6823933,2.9196565,2.6012011,10.4486888,0.0043854,3.578739,1.5461314,4.2434239,3.7670207,6.2563517,0.2782997,16.5977376),(30317,'full set',251,4,23,5.0123611,128.9314365,123.2816686,1.8,128.8861794,123.3507869,-0.1031712,1.67361,2.9186713,2.4538016,9.5901988,0.0088607,3.2858098,1.4661729,3.9889451,3.7336349,6.1521959,0.2110933,16.3460322),(30318,'full set',251,4,24,4.913723,129.0106651,123.3126622,1.8,129.0035913,123.3767247,-0.096362,1.7130523,2.8479893,2.4506836,9.0578241,0.007581,3.1804278,1.4305948,3.919359,3.7559017,6.076706,0.1418971,16.3460322),(30319,'full set',251,4,25,4.8263306,129.009938,123.364823,1.8,128.9859719,123.4424662,-0.0780146,1.7323376,2.7370276,2.324488,8.3868814,0.0048858,3.0642298,1.3418216,3.8216956,3.7072596,5.8443887,0.2984989,15.7383616),(30320,'full set',251,4,26,4.6516018,129.091723,123.3945997,1.8,129.0641336,123.505385,-0.0832816,1.5520046,2.426738,2.2347357,7.7744224,0.0053647,3.2036513,1.4399028,3.7297922,3.437504,5.585944,2.7468015,14.670466),(30321,'full set',251,4,27,4.4410097,129.1226839,123.4182531,1.8,129.0364372,123.5353,-0.0786823,1.5313918,2.4510427,2.1226571,7.0311467,0.0045729,2.8686349,1.3860967,3.4570885,3.437504,5.4351711,2.8198421,14.4187606),(30322,'full set',251,4,28,4.3439381,129.1829984,123.4375229,1.8,129.0610877,123.5496229,-0.0757342,1.511144,2.5067626,2.0390937,6.6602748,0.0041446,2.6569229,1.3493709,3.229887,3.437504,5.4351711,2.8198421,14.1670552),(30323,'full set',251,4,29,4.1293177,129.2271479,123.4358759,1.8,129.1510834,123.5173963,-0.0574658,1.532906,2.5078405,1.880058,6.0171657,0.0022702,2.3993414,1.2264666,3.0623292,3.437504,5.314947,2.896614,13.9153498),(30324,'full set',251,4,30,3.9826193,129.2950345,123.4453186,1.8,129.2364502,123.525959,-0.0470482,1.5334306,2.192943,1.7580854,5.5524659,0.0014682,2.53197,1.1465047,2.9480794,3.4118814,5.1919399,2.7149652,13.5593846),(30325,'full set',251,4,31,3.8090095,129.3013873,123.4353635,1.8,129.2527157,123.4872006,-0.0468878,1.5432891,2.1861272,1.5932832,5.0861978,0.0013946,2.3265791,1.0323945,2.6945777,3.4118814,5.1919399,2.7149652,13.9153498),(30326,'full set',251,4,32,3.7192673,129.3644964,123.4551229,1.8,129.3428019,123.4950168,-0.048213,1.5187496,2.2092458,1.4971803,4.7512338,0.0014398,2.1506135,0.985798,2.5884578,3.4118814,5.0293691,2.7928217,13.411939),(30327,'full set',251,4,33,3.6464217,129.3433336,123.472944,1.8,129.3565493,123.5182489,-0.061133,1.4841402,2.194846,1.3989359,4.5308556,0.0022684,2.0643159,0.9425901,2.4461291,3.3595156,5.0293691,2.7928217,13.411939),(30328,'full set',251,4,34,3.6003197,129.3645068,123.4826424,1.8,129.3430185,123.5006477,-0.0709586,1.4800776,2.2208108,1.3596617,4.4087017,0.0030163,1.9851766,0.9186422,2.4025792,3.3595156,5.0293691,2.7928217,13.411939),(30329,'full set',251,4,35,3.4848409,129.3637101,123.4710186,1.8,129.3879469,123.4834411,-0.0552152,1.4626703,2.2118632,1.2403358,4.0889888,0.0017689,1.8486626,0.8479941,2.2140168,3.007816,4.899197,2.8753406,13.0559738),(30330,'full set',251,4,36,3.3739499,129.4250268,123.4787959,1.8,129.435837,123.496935,-0.046531,1.4499741,2.2475787,1.1486631,3.8529242,0.0012166,1.7142556,0.7921956,2.1288011,3.007816,4.899197,2.8753406,13.0559738),(30331,'full set',251,4,37,3.2384973,129.4432446,123.4990405,1.8,129.5031889,123.5114284,-0.0417379,1.4708415,2.0469572,1.0577688,3.6167161,0.0009397,1.7668743,0.7191589,2.0115775,3.007816,4.8040579,2.677945,12.7000086),(30332,'full set',251,4,38,3.1484753,129.4844408,123.5087051,1.8,129.5063417,123.5393537,-0.0436758,1.4636206,2.0063991,0.9870952,3.5035372,0.0010004,1.7461816,0.6744201,1.9669775,3.007816,4.8040579,2.677945,12.7000086),(30333,'full set',251,4,39,3.0107288,129.5020719,123.5082549,1.8,129.5382941,123.5816389,-0.0421321,1.1837883,1.9886069,0.9038904,3.31627,0.0008902,1.6676348,0.7635575,1.860905,2.578128,4.6278814,2.7610863,12.092338),(30334,'full set',251,4,40,2.9750893,129.5435827,123.5142782,1.8,129.5839849,123.5848794,-0.0376051,1.1674398,2.3600897,0.8817587,3.3111253,0.0007009,1.4029659,0.7552926,1.7599869,2.578128,4.899197,0.266252,12.4483032),(30335,'full set',251,4,41,2.9668089,129.4958262,123.5012301,1.8,129.4993694,123.5610813,-0.0527816,1.1889955,1.9954694,0.8541414,3.1755978,0.0013763,1.5914039,0.7183723,1.847604,2.578128,4.6278814,0.3805064,11.8406326),(30336,'full set',251,4,42,3.0200723,129.5347766,123.5044659,1.8,129.5839849,123.5518265,-0.053198,1.1843171,2.3630098,0.8551607,3.2942606,0.0014231,1.3940952,0.7220708,1.7346434,2.578128,4.899197,0.266252,12.4483032),(30337,'full set',251,4,43,2.9443174,129.4850764,123.4852929,1.8,129.4763943,123.5396846,-0.0565846,1.2112048,2.0055737,0.8147464,3.1230829,0.0015695,1.5572017,0.6726744,1.8063549,2.578128,4.6278814,0.3805064,11.8406326),(30338,'full set',251,4,44,2.9040341,129.5295697,123.484831,1.8,129.5553166,123.504608,-0.0536791,1.2049049,1.9840159,0.7891443,3.0968963,0.0013933,1.5609231,0.6549432,1.8729509,2.578128,4.6278814,0.3805064,11.8406326),(30339,'full set',251,4,45,2.8838365,129.5227302,123.4808804,1.8,129.5553166,123.504608,-0.0521217,1.2069268,1.9898774,0.7816039,3.0434991,0.0013046,1.5294908,0.6475984,1.8367042,2.578128,4.6278814,0.3805064,11.8406326),(30340,'full set',251,4,46,2.9307217,129.5668786,123.478962,1.8,129.6024946,123.5095187,-0.0461632,1.1980183,2.3323225,0.7898746,3.0943037,0.0010402,1.3267049,0.6593177,1.6437836,2.578128,4.8040579,2.9617392,12.1965978),(30341,'full set',251,4,47,2.8870256,129.542684,123.4559217,1.8,129.5240765,123.481589,-0.0575225,1.1151098,1.9711234,0.7643837,3.0280229,0.0015904,1.5361914,0.6854784,1.8299668,2.578128,4.6278814,0.3805064,11.4846674),(30342,'full set',251,4,48,2.888704,129.5925809,123.4561426,1.8,129.5728549,123.4870697,-0.0529525,1.1154428,2.3028201,0.7632855,3.0843524,0.0013487,1.3393805,0.6842893,1.6441656,2.578128,4.8040579,2.9617392,11.8406326),(30343,'full set',251,4,49,2.8515539,129.5903919,123.4586522,1.8,129.5728549,123.4870697,-0.0428941,1.120479,2.3091871,0.7463953,3.0460295,0.0008739,1.3190917,0.6661394,1.6192865,2.578128,4.8040579,2.9617392,11.8406326),(30344,'full set',251,4,50,2.8631913,129.6217266,123.456512,1.8,129.5728549,123.4870697,-0.0390147,1.1242294,2.2792918,0.7477858,3.0319177,0.000726,1.3302017,0.6651541,1.6353732,2.578128,4.8040579,2.9617392,11.8406326),(30345,'full set',251,4,51,2.8402522,129.6216466,123.4255144,1.8,129.6024946,123.4665499,-0.0412709,1.153487,2.2772232,0.7545183,3.0385677,0.0008058,1.3343302,0.6541195,1.6381713,2.578128,4.8040579,2.9617392,11.8406326),(30346,'full set',251,4,52,2.7849745,129.662232,123.4233266,1.8,129.6024946,123.4665499,-0.0384741,1.1562427,2.2377465,0.7408824,2.9365515,0.0006867,1.3122807,0.6407671,1.616046,2.578128,4.8040579,2.9617392,11.8406326),(30347,'full set',251,4,53,2.740551,129.6651152,123.4075989,1.8,129.6024946,123.4665499,-0.0350546,1.1745917,2.2357138,0.7375191,2.8394179,0.000561,1.2700275,0.6278941,1.5722547,2.578128,4.8040579,2.9617392,11.8406326),(30348,'full set',251,4,54,2.7218081,129.7136019,123.392265,1.8,129.6454634,123.4235811,-0.0141822,1.3599962,2.1953175,0.7590849,2.7435084,0.0000912,1.2497092,0.5581522,1.5710045,2.8973654,4.8040579,2.9617392,12.1965978),(30349,'full set',251,4,55,2.6342479,129.7109915,123.3518501,1.8,129.6868537,123.3467634,0.0107901,1.3209723,2.2073938,0.7247188,2.6734217,0.0000511,1.2111214,0.5486253,1.5177477,2.9187431,4.8040579,2.9617392,11.9448924),(30350,'full set',251,4,56,2.6179667,129.7454082,123.3593549,1.8,129.6941613,123.374167,0.0106484,1.3281045,2.172846,0.7004232,2.6954302,0.0000495,1.2405068,0.5273856,1.5409544,2.8589421,4.8040579,2.9617392,11.9448924),(30351,'full set',251,4,57,2.5887054,129.7306164,123.3458552,1.8,129.7200645,123.3478829,0.0280623,1.3149322,2.1940836,0.6715067,2.6571708,0.0003397,1.2110618,0.5106778,1.4989244,2.578128,4.8040579,2.9617392,11.5889272),(30352,'full set',251,4,58,2.5766204,129.7685378,123.3509474,1.8,129.7478723,123.374167,0.050072,1.3177633,2.1629692,0.6902171,2.6391903,0.0010758,1.2201701,0.5237793,1.5217174,2.8589421,4.8040579,2.9617392,11.9448924),(30353,'full set',251,4,59,2.593517,129.7310524,123.3319873,1.8,129.712065,123.320456,0.0484871,1.3007497,2.200865,0.6900088,2.6467539,0.0010154,1.2025971,0.5304701,1.5011197,2.578128,4.8040579,2.9617392,11.5889272),(30354,'full set',251,4,60,2.51558,129.7666361,123.3526907,1.8,129.7190708,123.3765023,0.051725,0.9570209,2.1652568,0.6292169,2.5994914,0.0011207,1.2005465,0.6574745,1.4771693,2.14844,4.8040579,2.9617392,11.232962),(30355,'full set',251,4,61,2.4531409,129.7413742,123.3651339,1.8,129.7190708,123.4232075,0.0821849,1.1323603,2.1971143,0.6120919,2.529078,0.0027554,1.1510908,0.5405452,1.4234768,2.5530378,4.8040579,2.9617392,11.5889272),(30356,'full set',251,4,62,2.3440403,129.7874163,123.3687518,1.8,129.8146042,123.4181124,0.1018755,1.1054388,2.15456,0.5798674,2.324115,0.0040406,1.0786959,0.5245586,1.3439846,2.5530378,4.4860744,2.8501359,11.232962),(30357,'full set',251,4,63,2.2358908,129.7390569,123.3214344,1.8,129.685834,123.3304487,0.1217271,1.2837411,1.8367877,0.5909844,2.0870986,0.0054945,1.1362765,0.4603611,1.3768172,2.578128,4.231936,2.7233683,10.6252914),(30358,'full set',251,4,64,2.2167563,129.7659929,123.29073,1.8,129.765776,123.3004705,0.1419478,1.2466413,1.8270333,0.571814,2.042813,0.0073944,1.1181039,0.4586837,1.3512934,2.578128,4.231936,2.7233683,10.6252914),(30359,'full set',251,4,65,2.2558646,129.7210914,123.2401133,1.8,129.7474914,123.2107484,0.1526452,1.2667965,1.8858191,0.6112495,2.112539,0.0086927,1.1202236,0.4825159,1.3631251,2.578128,4.4239087,2.6344941,10.8769968),(30360,'full set',251,4,66,2.3236189,129.7394242,123.2361034,1.8,129.7474914,123.2107484,0.1524975,1.2600062,1.8682105,0.62666,2.1990107,0.0089365,1.177068,0.4973468,1.4242736,2.578128,4.4239087,2.6344941,10.8769968),(30361,'full set',251,4,67,2.4195155,129.6768874,123.2261919,1.8,129.6605463,123.2064571,0.1540431,1.2602197,2.0866295,0.6441582,2.3802768,0.0094934,1.1407281,0.5111475,1.4493959,2.578128,4.6278814,2.7610863,11.232962),(30362,'full set',251,4,68,2.4886126,129.7002988,123.2324125,1.8,129.6605463,123.2064571,0.1605107,1.2647208,2.1107904,0.6700347,2.4267348,0.0105945,1.1496806,0.5297887,1.4671106,2.578128,4.6278814,2.7610863,11.232962),(30363,'full set',251,4,69,2.5107124,129.6668161,123.2494653,1.8,129.6494022,123.2309377,0.171691,1.2170715,2.0806301,0.6576428,2.4754678,0.0122143,1.1897683,0.5403486,1.5058452,2.578128,4.6278814,2.7610863,11.232962),(30364,'full set',251,4,70,2.485927,129.6887103,123.2652944,1.8,129.6194992,123.2473176,0.1897838,1.2262859,2.104836,0.640005,2.4496967,0.0147447,1.1638421,0.5219052,1.4678189,2.578128,4.6278814,2.7610863,11.232962),(30365,'full set',251,4,71,2.5677804,129.6700266,123.2861615,1.8,129.6314985,123.3115042,0.236317,1.2423127,2.0882108,0.6884204,2.5010591,0.0234583,1.1977044,0.5541443,1.5257569,2.8690354,4.6278814,2.7610863,11.3372218),(30366,'full set',251,4,72,2.5855163,129.6975831,123.2970432,1.8,129.6314985,123.3115042,0.2536799,1.2422588,2.1156317,0.6981031,2.4970682,0.0271414,1.1802944,0.5619627,1.5074771,2.8690354,4.6278814,2.7610863,11.3372218),(30367,'full set',251,4,73,2.5831664,129.674273,123.3118473,1.8,129.643008,123.3379943,0.2699682,1.2584804,2.0947357,0.7066955,2.4634241,0.0306231,1.1760071,0.5615467,1.5098722,2.918471,4.6278814,2.7610863,11.3372218),(30368,'full set',251,4,74,2.5973775,129.7032535,123.326574,1.8,129.6798384,123.3634248,0.29538,1.2572903,2.1224444,0.7201695,2.5044644,0.0366841,1.1799906,0.5727949,1.4689498,2.918471,4.8040579,2.677945,11.5889272),(30369,'full set',251,4,75,2.6005666,129.675782,123.3227948,1.8,129.643008,123.3379943,0.2799071,1.2660052,2.097688,0.7078191,2.4103286,0.0330806,1.1490406,0.5590965,1.4825066,2.918471,4.6278814,2.7610863,11.3372218),(30370,'full set',251,4,76,2.6181905,129.7263019,123.3422544,1.8,129.7219303,123.3643017,0.3140454,1.2589442,2.1452881,0.7219993,2.4159036,0.04164,1.1261441,0.5734959,1.4478194,2.918471,4.8040579,2.677945,11.5889272),(30371,'full set',251,4,77,2.6354228,129.6764158,123.3361369,1.8,129.6196821,123.3118622,0.3115601,1.2693227,2.0964736,0.7321852,2.4312611,0.0412748,1.1596908,0.5768314,1.5016158,2.918471,4.6278814,2.7610863,11.3372218),(30372,'full set',251,4,78,2.6279816,129.740793,123.3592616,1.8,129.765776,123.374167,0.335653,1.2619974,2.058244,0.7325773,2.3591574,0.0475205,1.1461991,0.5804903,1.4409402,2.918471,4.6477863,2.5535901,11.232962),(30373,'full set',251,4,79,2.6767132,129.6888863,123.327201,1.8,129.6605463,123.3116869,0.3495883,1.2437661,2.0957332,0.7587633,2.4250355,0.0523359,1.1571299,0.6100531,1.5039024,2.918471,4.6278814,2.7610863,11.3372218),(30374,'full set',251,4,80,2.7251091,129.7508582,123.3673355,1.8,129.765776,123.3993783,0.3555083,1.257599,2.0576262,0.787539,2.4058709,0.0550248,1.1692458,0.6262243,1.4973186,2.9902678,4.6477863,2.5535901,11.232962),(30375,'full set',251,4,81,2.7476565,129.7282231,123.3789377,1.8,129.765776,123.3993783,0.3590564,1.2748068,2.0767187,0.7946775,2.3700959,0.0565448,1.1412696,0.623371,1.4757533,2.9902678,4.6477863,2.5535901,11.232962),(30376,'full set',251,4,82,2.7876601,129.7568847,123.3770722,1.8,129.765776,123.3993783,0.3688867,1.2583614,2.0558162,0.8106321,2.3894041,0.0604067,1.1622654,0.6441966,1.5078953,2.9902678,4.6477863,2.5535901,11.232962),(30377,'full set',251,4,83,2.8199986,129.7277458,123.3441301,1.8,129.7142134,123.320456,0.3873459,1.3921559,1.9423024,0.8573177,2.3522515,0.0670604,1.2110635,0.6158202,1.6498029,3.007816,4.4239087,2.6344941,10.9812566),(30378,'full set',251,4,84,2.7918003,129.7686435,123.3523948,1.8,129.7389205,123.320456,0.3810857,1.3849826,1.9296183,0.8312916,2.2861747,0.0643653,1.1847808,0.6002181,1.6080493,3.007816,4.4239087,2.6344941,10.9812566),(30379,'full set',251,4,85,2.8260971,129.744688,123.3571537,1.8,129.6780846,123.320456,0.4229484,1.3939606,1.924199,0.8691321,2.2417125,0.0793521,1.1650107,0.6234984,1.6164119,3.007816,4.4239087,2.6344941,10.9812566),(30380,'full set',251,4,86,2.7926955,129.8013975,123.3592282,1.8,129.765776,123.3294078,0.4133954,1.3742869,1.9673938,0.8428942,2.1534959,0.0751141,1.0945932,0.6133321,1.5203059,3.007816,4.4239087,2.6344941,10.9812566),(30381,'full set',251,4,87,2.7651686,129.7587946,123.3310628,1.8,129.7031132,123.3025523,0.4637419,1.3577274,1.9231228,0.8601463,2.1090893,0.092207,1.0967003,0.6335192,1.5439316,3.007816,4.4239087,2.6344941,10.9812566),(30382,'full set',251,4,88,2.8608974,129.8072877,123.326313,1.8,129.8023452,123.320456,0.4572171,1.333274,1.9614168,0.8933501,2.076315,0.0929222,1.0585792,0.6700424,1.5140407,3.007816,4.4239087,2.6344941,10.7295512),(30383,'full set',251,4,89,2.8388534,129.7962115,123.3182457,1.8,129.765776,123.320456,0.5092556,1.3182084,1.7356362,0.9191724,1.929355,0.1124579,1.1116126,0.6972891,1.5797057,3.007816,4.0763783,2.8198421,10.4778458),(30384,'full set',251,4,90,2.9116431,129.8534128,123.3191927,1.8,129.8642462,123.3294078,0.5426696,1.5013309,1.8412326,1.0218804,1.9911158,0.1294195,1.0814037,0.6806497,1.5982245,3.2680663,4.231936,2.7233683,11.0855164),(30385,'full set',251,4,91,2.9171821,129.8811012,123.3201758,1.8,129.9432558,123.3391381,0.612885,1.4822149,1.80609,1.0606373,1.8862555,0.1608774,1.0443862,0.7155759,1.5732301,3.2680663,4.0536685,2.1293956,10.7295512),(30386,'full set',251,4,92,2.9821389,129.92953,123.3379012,1.8,129.9627163,123.3652152,0.6105321,1.4692818,1.7567587,1.134525,1.9233661,0.16336,1.0948379,0.772163,1.6636833,3.3421883,4.0536685,2.1293956,10.7295512),(30387,'full set',251,4,93,3.0340036,129.930756,123.3276111,1.8,129.9627163,123.3652152,0.5812645,1.4646196,1.766533,1.1799531,1.8977439,0.1524537,1.0742759,0.8056379,1.6662389,3.3421883,4.0536685,2.1293956,10.7295512),(30388,'full set',251,4,94,3.1443911,129.985043,123.3138579,1.8,129.98062,123.320456,0.5220178,1.4466877,1.7326644,1.2594482,1.9436773,0.1302994,1.1217852,0.8705737,1.8486192,3.007816,4.0536685,2.5829933,10.373586),(30389,'full set',251,4,95,3.2534917,129.994375,123.272286,1.8,129.98062,123.320456,0.5116343,1.4882944,1.7436695,1.3581593,1.958382,0.129983,1.1231383,0.9125609,1.9008555,3.007816,4.0536685,2.5829933,10.373586),(30390,'full set',251,4,96,3.3404924,130.0445198,123.2256319,1.8,130.0016831,123.2277782,0.5762327,1.5518876,1.7312207,1.4940671,1.9969391,0.1652887,1.1534862,0.9627419,2.0013866,3.437504,4.0536685,2.5829933,10.9812566),(30391,'full set',251,4,97,3.460559,130.0517924,123.190998,1.8,130.0301994,123.213034,0.5675337,1.5808691,1.7396764,1.6250104,2.0583802,0.166663,1.1831972,1.0279222,2.1158696,3.437504,4.0536685,2.5829933,10.9812566),(30392,'full set',251,4,98,3.5897453,130.1033799,123.1553207,1.8,130.0283631,123.1533551,0.6210871,1.6291244,1.7268739,1.7738456,2.1391501,0.2025995,1.2387414,1.0888337,2.2124564,3.437504,4.0536685,2.1293956,10.9812566),(30393,'full set',251,4,99,3.6863693,130.1125758,123.1094401,1.8,130.0283631,123.1533551,0.6425568,1.6662192,1.7397648,1.8823967,2.1699288,0.2206253,1.2472541,1.1297414,2.2875513,3.437504,4.0536685,2.1293956,10.9812566),(30394,'full set',251,4,100,3.7613969,130.1951956,123.0793082,1.8,130.195464,123.105612,0.6856667,1.7283571,1.6947793,1.9992788,2.1931398,0.2513419,1.2940563,1.156751,2.3886441,3.437504,4.0536685,2.1293956,11.5889272),(30395,'full set',251,4,101,3.8467192,130.2019261,123.0430906,1.8,130.195464,123.105612,0.7839551,1.720586,1.7108811,2.0894078,2.2343688,0.3196347,1.3059755,1.2143582,2.4157903,3.437504,4.0536685,2.1293956,11.5889272),(30396,'full set',251,4,102,3.860091,130.2598988,123.0168662,1.8,130.211089,123.0782682,0.8208047,1.7830632,1.707194,2.0881301,2.2509376,0.344434,1.3185014,1.1710915,2.3988051,3.437504,4.0536685,2.1293956,11.5889272),(30397,'full set',251,4,103,3.8993112,130.2971245,122.946361,1.8,130.3307361,123.0101258,0.9254152,1.5944867,1.7844169,2.0790813,2.2793789,0.414753,1.2773802,1.3039188,2.3847609,3.437504,4.0763783,1.8925469,11.3372218),(30398,'full set',251,4,104,3.9842419,130.3617228,122.9154649,1.8,130.3839236,122.9661519,0.9679021,1.6720336,1.7884072,2.1874559,2.3717886,0.450537,1.3262017,1.3082608,2.4908943,3.437504,4.0763783,1.8925469,11.5889272),(30399,'full set',251,4,105,4.026931,130.3717928,122.8640644,1.8,130.3732659,122.9352185,1.0239261,1.7124504,1.8460876,2.2026166,2.4502314,0.4896633,1.3272563,1.2862367,2.4823862,3.437504,4.231936,1.9890207,11.5889272),(30400,'full set',251,4,106,4.0593254,130.4420576,122.8185275,1.8,130.4212323,122.8616366,1.0010646,1.7956135,1.8386361,2.2410649,2.4729326,0.4797047,1.3449821,1.2480775,2.4903276,3.437504,4.231936,1.9890207,11.5889272),(30401,'full set',251,4,107,4.0747674,130.4717434,122.7688117,1.8,130.4473501,122.8463175,1.0202818,1.7060097,1.8737866,2.1994489,2.5197871,0.4932773,1.3447567,1.2892359,2.4441147,3.437504,4.231936,1.9890207,11.5889272),(30402,'full set',251,4,108,4.0790755,130.5308301,122.7288578,1.8,130.456346,122.791019,0.9878858,1.6818272,1.7363351,2.1783932,2.4995987,0.4738513,1.4395831,1.2952538,2.4487873,3.437504,4.0763783,1.8925469,11.3372218),(30403,'full set',251,4,109,4.100392,130.5756682,122.6733501,1.8,130.533076,122.698943,1.0162436,1.702237,1.7592866,2.1908421,2.5096451,0.4939136,1.426513,1.287037,2.4269321,3.437504,4.0763783,1.8925469,11.5889272),(30404,'full set',251,4,110,4.0948531,130.6480252,122.6388344,1.8,130.625152,122.675924,0.9527194,1.7131908,1.7406317,2.2392974,2.4859884,0.453311,1.4282104,1.3070917,2.6611143,3.437504,4.0536685,2.1293956,11.5889272),(30405,'full set',251,4,111,4.1020146,130.6371547,122.5922129,1.8,130.5949985,122.6646164,0.9091076,1.7379749,1.7732298,2.263964,2.5477644,0.4255506,1.4367931,1.3026449,2.6447524,3.437504,4.0763783,2.8198421,11.5889272),(30406,'full set',251,4,112,4.1159459,130.7190028,122.5537685,1.8,130.755593,122.591521,0.934949,1.617563,1.7628944,2.2261969,2.6072298,0.4440632,1.4789484,1.376266,2.6630874,3.6460236,4.0763783,1.8925469,11.693187),(30407,'full set',251,4,113,4.1551661,130.739229,122.498664,1.8,130.7708089,122.5047771,0.988095,1.7111195,1.8138645,2.2902656,2.7083439,0.4828236,1.4931346,1.3384603,2.7181629,3.8443347,4.231936,1.9890207,11.9448924),(30408,'full set',251,4,114,4.1633906,130.8043744,122.4640133,1.8,130.8029539,122.5055305,0.9870843,1.6971784,1.8065676,2.2655683,2.7587725,0.4831345,1.5270796,1.3349028,2.7221735,3.437504,4.231936,1.9890207,11.5889272),(30409,'full set',251,4,115,4.1790564,130.8242165,122.3873369,1.8,130.839996,122.4252727,0.992159,1.7019453,1.861806,2.2929719,2.8630327,0.4881962,1.5377718,1.3472654,2.6835521,3.437504,4.29688,2.2142974,11.8406326),(30410,'full set',251,4,116,4.2037299,130.883794,122.3638991,1.8,130.8770381,122.4166295,0.9834268,1.6988596,1.8444957,2.3164461,2.8718357,0.4854551,1.5569761,1.3635301,2.7125166,3.437504,4.231936,1.9890207,11.5889272),(30411,'full set',251,4,117,4.267232,130.900283,122.3294131,1.8,130.8696297,122.372179,0.9667079,1.6062205,1.8547904,2.3390661,2.9850749,0.4817437,1.6093866,1.4562546,2.7361728,3.437504,4.29688,2.2142974,11.5889272),(30412,'full set',251,4,118,4.3283843,130.9718439,122.3029414,1.8,130.9689024,122.3464965,0.997256,1.7661608,1.8547475,2.4411802,3.0274421,0.5090001,1.6322664,1.3821959,2.8106882,3.867192,4.231936,1.9890207,11.9448924),(30413,'full set',251,4,119,4.408839,130.9922361,122.2431088,1.8,130.978605,122.2878187,0.9355776,1.7235509,1.9357659,2.4747422,3.1863056,0.4761043,1.646018,1.4358393,2.8329159,3.8443347,4.4239087,2.0778948,12.1965978),(30414,'full set',251,4,120,4.418686,131.0679085,122.2201289,1.8,131.0617705,122.3086101,0.8803223,1.7046728,1.9922412,2.4700177,3.2163658,0.4377113,1.614446,1.4489689,2.8382264,3.8443347,4.5676461,2.2896263,12.4483032),(30415,'full set',251,4,121,4.3837738,131.0918515,122.1872473,1.8,131.0900603,122.2568021,0.8365344,1.7126138,1.9611234,2.445145,3.1802876,0.402611,1.6216663,1.427727,2.7699097,3.867192,4.4239087,2.0778948,12.1965978),(30416,'full set',251,4,122,4.393453,131.1596273,122.1639,1.8,131.1241445,122.2254446,0.8508781,1.5841439,1.9878211,2.4264931,3.2646766,0.4139314,1.6423393,1.5317379,2.7871308,3.6460236,4.5676461,2.2896263,12.552563),(30417,'full set',251,4,123,4.3933411,131.18067,122.1062334,1.8,131.1707876,122.1064169,0.890333,1.7622655,2.0096334,2.4341136,3.3028742,0.4423847,1.6435208,1.3812411,2.7374475,3.8443347,4.5676461,2.2896263,12.8042684),(30418,'full set',251,4,124,4.374766,131.2589022,122.0866911,1.8,131.2558231,122.1006965,0.9357275,1.7619874,1.9827897,2.435885,3.2599424,0.4725292,1.6441191,1.3824645,2.7055142,3.437504,4.5676461,2.2896263,12.4483032),(30419,'full set',251,4,125,4.334147,131.2880661,122.0530966,1.8,131.3013823,122.0736564,0.905868,1.7126801,1.986965,2.377997,3.2649861,0.4473617,1.6432026,1.3884654,2.8090604,3.437504,4.5676461,2.2896263,12.092338),(30420,'full set',251,4,126,4.3151244,131.362618,122.0310299,1.8,131.3859111,122.0454801,0.9024366,1.6441263,1.9573306,2.3826648,3.2330875,0.4429997,1.6517841,1.4491982,2.8370073,3.8151286,4.4239087,2.0778948,12.1965978),(30421,'full set',251,4,127,4.2928007,131.3722268,121.976297,1.8,131.371823,121.9961717,0.8872058,1.594461,1.988974,2.3312598,3.2530427,0.4300711,1.635538,1.462099,2.7567597,3.6460236,4.5676461,2.2896263,12.1965978),(30422,'full set',251,4,128,4.3433786,131.4520929,121.9575329,1.8,131.4777076,121.9972898,0.8659388,1.793953,1.9432658,2.4148972,3.2658666,0.4199995,1.6806072,1.3461318,2.8372691,3.867192,4.4239087,2.0778948,12.1965978),(30423,'full set',251,4,129,4.3169707,131.4925694,121.9148301,1.8,131.5186302,121.9631876,0.8929099,1.733121,1.9634388,2.3833621,3.2395681,0.436507,1.649946,1.3751851,2.7792908,3.8443347,4.4239087,2.0778948,12.1965978),(30424,'full set',251,4,130,4.318817,131.5675298,121.894707,1.8,131.59195,121.9508255,0.8899932,1.7259624,1.9304631,2.3702019,3.2565108,0.4346413,1.6869066,1.3732639,2.797524,3.867192,4.4239087,2.0778948,12.1965978),(30425,'full set',251,4,131,4.3035989,131.6096861,121.8708623,1.8,131.6369979,121.9274352,0.901808,1.6835133,1.9295582,2.3040869,3.2340972,0.4413778,1.6760817,1.3686182,2.7449144,3.8151286,4.4239087,2.0778948,12.1965978),(30426,'full set',251,4,132,4.2592313,131.6866016,121.8501065,1.8,131.7102963,121.9148664,0.9155717,1.6157769,1.9070796,2.215894,3.1611408,0.4463021,1.657582,1.3714108,2.6744504,3.437504,4.4239087,2.0778948,11.5889272),(30427,'full set',251,4,133,4.2132412,131.6984847,121.8288187,1.8,131.7102963,121.9148664,0.9164838,1.5937439,1.9173184,2.1628878,3.1119201,0.4421018,1.6230586,1.3571112,2.6024861,3.437504,4.4239087,2.0778948,11.5889272),(30428,'full set',251,4,134,4.1701045,131.7700508,121.8117631,1.8,131.7612762,121.8857351,0.9368255,1.788205,1.9016393,2.1217599,3.0926369,0.4511518,1.6263005,1.1865306,2.5794167,3.437504,4.4239087,2.0778948,11.8406326),(30429,'full set',251,4,135,4.1124211,131.7818015,121.7581976,1.8,131.8030898,121.8091396,0.9149896,1.7460777,1.921499,2.0550516,3.0200776,0.4305331,1.57173,1.1769531,2.4520652,3.437504,4.4239087,2.0778948,11.8406326),(30430,'full set',251,4,136,4.0720259,131.8596172,121.7410348,1.8,131.8778018,121.7837752,0.868976,1.6708866,1.8878015,2.0334321,2.9876192,0.3957936,1.5825919,1.216978,2.4295574,3.6460236,4.4239087,2.0778948,11.9448924),(30431,'full set',251,4,137,3.9922985,131.8916164,121.7079939,1.8,131.8697655,121.7498723,0.8454045,1.622089,1.8842677,1.9715274,2.8900346,0.372523,1.5337707,1.2154249,2.3804638,3.6460236,4.29688,2.2142974,11.9448924),(30432,'full set',251,4,138,3.9363495,131.9734694,121.6954761,1.8,131.960254,121.739818,0.8582822,1.5537326,1.9278675,1.9071366,2.8140238,0.3756761,1.4596563,1.2274549,2.4444602,3.437504,4.29688,2.2142974,11.5889272),(30433,'full set',251,4,139,3.878666,132.0069096,121.6520455,1.8,132.0348302,121.6544727,0.9200131,1.5845142,1.902726,1.8642198,2.7846734,0.4091958,1.4635178,1.1765245,2.41578,3.6460236,4.29688,2.2142974,11.9448924),(30434,'full set',251,4,140,3.8668049,132.0654987,121.6357617,1.8,132.0875989,121.6393959,0.9288897,1.7034967,1.9221315,1.881962,2.7679136,0.4134452,1.4400231,1.1047641,2.3774503,3.437504,4.29688,2.2142974,11.8406326),(30435,'full set',251,4,141,3.857909,132.0842367,121.6076987,1.8,132.110214,121.5866272,0.9538332,1.6620059,1.90047,1.8838327,2.7838775,0.4277568,1.4648363,1.1334693,2.3925636,3.437504,4.29688,2.2142974,11.8406326),(30436,'full set',251,4,142,3.8290393,132.1529057,121.6002223,1.8,132.1629827,121.5941656,0.9757504,1.7065631,1.7967676,1.9032223,2.7163211,0.4376511,1.5117821,1.115237,2.5031162,3.437504,4.231936,1.9890207,11.5889272),(30437,'full set',251,4,143,3.7789649,132.1808601,121.5759837,1.8,132.175098,121.563339,0.9707851,1.6691923,1.7904937,1.8640045,2.6736436,0.4290186,1.4932438,1.1167105,2.4628726,3.437504,4.231936,1.9890207,11.3372218),(30438,'full set',251,4,144,3.8081143,132.2478328,121.5667552,1.8,132.2273784,121.5871383,0.9840703,1.609916,1.9893794,1.8974934,2.7555706,0.4401453,1.3851408,1.1786289,2.3299287,3.437504,4.4239087,2.0778948,11.5889272),(30439,'full set',251,4,145,3.7575364,132.2571091,121.5451651,1.8,132.255003,121.5794788,0.9845567,1.5902831,2.0023176,1.8408531,2.7324847,0.4345803,1.364661,1.1575632,2.2733808,3.437504,4.4239087,2.0778948,11.5889272),(30440,'full set',251,4,146,3.73387,132.3184525,121.5379433,1.8,132.2856412,121.5798555,0.9834636,1.5634079,1.974123,1.8594476,2.7270497,0.4312158,1.3813981,1.1893554,2.3047227,3.6460236,4.4239087,2.0778948,11.9448924),(30441,'full set',251,4,147,3.7144557,132.3353348,121.5159865,1.8,132.3152581,121.5873811,0.9722816,1.5903915,1.9798188,1.90143,2.7592094,0.422558,1.3936676,1.1955735,2.3275751,3.6460236,4.4239087,2.0778948,11.9448924),(30442,'full set',251,4,148,3.706455,132.4121967,121.5142383,1.8,132.4155187,121.5587352,1.0170882,1.6702186,1.9523207,1.9553553,2.7636299,0.4469288,1.4155615,1.1707182,2.3931633,3.8151286,4.4239087,2.0778948,12.1965978),(30443,'full set',251,4,149,3.6969436,132.420683,121.494043,1.8,132.4284328,121.5312633,1.0653857,1.6327161,1.9769745,2.020136,2.8143497,0.4717192,1.423564,1.2372855,2.4330351,3.8151286,4.4239087,2.0778948,12.1965978),(30444,'full set',251,4,150,3.7185959,132.4963093,121.482477,1.8,132.5102348,121.5323995,1.0831324,1.7305642,1.9549862,2.0942225,2.8895814,0.4836953,1.4780572,1.2101386,2.5308037,3.8443347,4.4239087,2.0778948,12.1965978),(30445,'full set',251,4,151,3.761229,132.5221044,121.4541326,1.8,132.5102348,121.5323995,1.0997878,1.695809,1.9722089,2.2024887,2.9881198,0.4977855,1.5151132,1.2987835,2.6126169,3.8443347,4.4239087,2.0778948,12.1965978),(30446,'full set',251,4,152,3.7518296,132.5960409,121.440217,1.8,132.6003307,121.4700254,1.1699142,1.7903528,1.9681316,2.2813491,3.0766832,0.5300835,1.5632507,1.2742455,2.6789546,3.437504,4.4239087,2.0778948,12.092338),(30447,'full set',251,4,153,3.8796172,132.5973035,121.4625583,1.8,132.5686639,121.5157664,1.1923212,1.7865476,2.1090949,2.4768155,3.3815737,0.5583201,1.6033294,1.3863697,2.7542189,3.867192,4.6477863,2.1587989,12.7000086),(30448,'full set',251,4,154,3.966562,132.6560424,121.4728691,1.8,132.6490448,121.5518851,1.1567435,1.7545385,2.3050064,2.6096657,3.791449,0.5540865,1.6448757,1.4873801,2.733062,4.0360605,4.8040579,1.7506498,13.7679042),(30449,'full set',251,4,155,4.3333638,132.7149351,121.5083068,1.8,132.7682872,121.5910944,0.9473131,1.8060785,2.7598427,3.2222995,4.8677601,0.4760199,1.7637817,1.7841415,2.8329274,4.1734394,5.6024461,2.5748634,14.8789856),(30450,'full set',251,4,156,4.6734779,132.8653053,121.5648571,1.8,132.9510718,121.6624208,0.8467829,2.0483658,2.9994837,3.8923086,6.1157787,0.4371499,2.0389438,1.9002019,3.2880831,4.5317501,5.9694165,2.6135182,16.0943267),(30451,'full set',251,4,157,4.7934885,132.8326969,121.5113991,1.8,132.8396978,121.54032,0.8529092,2.038579,2.2126306,4.725127,5.5559908,0.4532292,2.5110341,2.3178532,4.3243756,4.5575295,5.1919399,1.9974238,14.6272802),(30452,'full set',251,4,158,4.9148979,132.8140388,121.4950622,1.8,132.8467304,121.4874253,1.1418676,2.2300936,2.3913881,5.1922672,5.892188,0.6774612,2.4639196,2.3282732,4.6201118,4.726568,5.1919399,1.9974238,14.8789856),(30453,'full set',251,4,159,5.673231,132.8236036,121.5264154,1.8,132.8343969,121.4517186,1.3627698,2.4982841,2.6746243,6.5987043,7.6710125,0.9052071,2.868071,2.6412946,5.3236415,5.156256,5.7327529,1.3439975,16.9537027),(30454,'full set',251,4,160,6.60937,132.8898164,121.5981285,1.8,132.8513803,121.5239157,1.3689299,2.640358,2.7644318,8.6841437,10.1617425,1.0572794,3.6758882,3.2890024,6.6461234,5.156256,5.9848613,1.2036225,17.2054082),(30455,'full set',251,4,161,8.7859549,132.974778,121.6733501,1.8,132.9560622,121.5987609,1.5510452,3.1984748,3.3697142,13.2932192,17.8226543,1.4637546,5.28907,4.1561119,9.2233297,6.015632,6.9948139,1.3854484,19.9920557),(30456,'full set',251,4,162,9.8656032,133.0142394,121.6953921,1.8,132.975174,121.6441423,-1.4756545,3.3243115,3.5740002,16.7071206,21.4063682,1.6294282,5.9894703,5.0257386,10.6314116,6.015632,7.4175649,1.3961241,21.1031371),(30457,'full set',251,4,163,11.2011623,132.9628365,121.5638203,1.8,132.9046833,121.5774278,-0.8501126,3.2670762,3.2407925,22.218574,23.9765671,1.053906,7.3983655,6.8007518,12.4226484,6.5361326,7.2028834,1.2679115,21.4591023),(30458,'full set',251,4,164,10.7530107,132.9201876,121.3280552,1.8,132.8661767,121.4046648,-0.0592948,3.3179373,3.5940172,18.7573063,26.4891755,0.0062937,7.3703529,5.6533035,12.1461757,6.44532,7.6140908,0.2860514,21.9625131),(30459,'full set',251,4,165,4.6079056,132.4257784,120.6846565,1.8,132.525844,120.7655544,-0.0428881,2.0923562,3.3684941,3.106746,12.1258827,0.0014118,3.5997934,1.4848074,4.378851,4.2284266,7.086596,0.2449787,18.0647842),(30460,'full set',251,4,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30461,'full set',251,4,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30462,'full set',251,4,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30463,'full set',251,4,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30464,'full set',251,4,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30465,'full set',251,4,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30466,'full set',251,4,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30467,'full set',251,4,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30468,'full set',251,4,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30469,'full set',251,4,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30470,'full set',251,4,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30471,'full set',251,4,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30472,'full set',251,4,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30473,'full set',251,4,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30474,'full set',251,4,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30475,'full set',251,4,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30476,'full set',251,4,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30477,'full set',251,4,183,2.378337,130.7782301,121.8151076,1.8,130.640498,121.762837,0.0155343,1.5142193,2.3112299,1.1514071,1.6813231,0.0000956,0.7274582,0.7603965,1.1854034,3.437504,4.6278814,2.7610863,11.9448924),(30478,'full set',251,4,184,5.230898,130.2883469,121.6156387,1.8,130.2087533,121.6149933,0.1825185,1.9273325,2.7851564,3.862545,7.7764707,0.0287217,2.7921127,2.0040886,4.14177,3.867192,5.9848613,2.7744188,15.3823964),(30479,'full set',251,4,185,5.4320907,129.9515655,121.8101618,1.8,129.9117078,121.8530309,0.1056986,2.0394224,2.8749502,3.9847351,10.4223396,0.0100771,3.6252244,1.9538548,4.9746074,4.29688,6.2563517,2.863293,16.849443),(30480,'full set',251,4,186,4.9965835,129.8011158,121.9633538,1.8,129.7955564,121.9463053,0.0313189,1.827386,2.973149,3.4637855,9.8132507,0.0008166,3.3006252,1.8954865,4.4339619,3.867192,6.2563517,2.863293,16.2417724),(30481,'full set',251,4,187,5.0217605,129.5724796,122.071926,1.8,129.5885851,122.0535409,-0.0516094,1.7081211,2.8141576,3.0623259,10.8517986,0.0022273,3.8561446,1.7928037,4.7088513,3.8010925,6.2563517,2.863293,16.2417724),(30482,'full set',251,4,188,5.1562061,129.5197005,122.1463171,1.8,129.5551446,122.0903688,-0.0865079,1.6941839,2.9349472,3.1756861,12.2994013,0.0064152,4.190672,1.8744636,4.9065956,3.8460071,6.3877713,0.3430239,16.7451832),(30483,'full set',251,4,189,6.0708047,129.5203407,122.197975,1.8,129.612316,122.1196315,-0.1225455,1.7281044,3.3542664,3.86696,16.8772942,0.0151187,5.0315903,2.2376888,6.0812319,3.867192,7.086596,0.2449787,18.568195),(30484,'full set',251,4,190,6.7695521,129.7166688,122.2289501,1.8,129.786401,122.1826422,-0.2006072,2.1784083,3.4523218,5.7354092,21.0812738,0.044799,6.1064046,2.632844,7.4327446,4.6539647,7.5041783,0.4124104,19.1758656),(30485,'full set',251,4,191,8.5419612,129.8146455,122.473728,1.8,129.8296485,122.4697899,-0.1638111,2.6633128,3.8615743,10.2242801,26.7030871,0.0378621,6.9150779,3.8389333,9.3701352,5.3559133,7.9230552,0.2186689,21.3548425),(30486,'full set',251,4,192,8.4504286,129.7219845,122.5495507,1.8,129.7056798,122.5782676,-0.0669556,2.5157572,3.8376627,8.2786382,27.0645227,0.0063045,7.0523453,3.2907144,9.1601704,5.0340321,7.9230552,0.2186689,20.4954665),(30487,'full set',251,4,193,6.6161958,129.034797,122.5442895,1.8,128.9437642,122.5993274,-0.0747189,2.1461113,3.1854028,5.2413969,16.860328,0.0061448,5.2929972,2.4422764,6.7490354,4.29688,6.6705516,2.8809903,17.708819),(30488,'full set',251,4,194,6.2535342,128.7688116,122.5509065,1.8,128.7508939,122.6329552,-0.1563271,2.1887288,2.9550394,4.7598768,14.0067804,0.025264,4.7399639,2.174722,6.2077329,4.29688,6.3877713,0.3430239,17.1011484),(30489,'full set',251,4,195,6.4194231,128.5762012,122.5572399,1.8,128.5076805,122.6352778,-0.2350163,2.4906299,3.1996087,5.3029715,15.0900016,0.0580136,4.7162022,2.1291688,6.373475,4.7580857,6.725681,0.4636476,18.0647842),(30490,'full set',251,4,196,7.4109517,128.6794967,122.5520918,1.8,128.6296518,122.650434,-0.2964336,2.5704368,3.2950161,6.4908721,18.3975569,0.1053948,5.5834498,2.525202,7.5390618,4.8944277,6.9285108,0.5191461,18.6724547),(30491,'full set',251,4,197,8.9072524,128.934232,122.3566046,1.8,128.9959183,122.4014011,-0.400045,2.627301,3.7344527,8.2047886,30.8409096,0.2251738,8.2584819,3.1228963,10.453897,5.1918699,7.7463106,0.3392926,21.1031371),(30492,'full set',251,4,198,10.1640912,129.1998117,122.1874938,1.8,129.1870126,122.2915432,-0.424426,2.4401954,4.043387,8.0719848,41.8597147,0.2872667,10.3526361,3.3079256,12.3442117,4.8073274,8.2986537,0.3708913,21.3548425),(30493,'full set',251,4,199,9.976662,128.7982027,122.3697674,1.8,128.8999867,122.3584679,-0.4340933,2.2582476,4.0820468,6.8748064,34.9495324,0.2941356,8.5617668,3.0443102,10.2029488,4.538475,8.2652137,0.4868992,20.1395013),(30494,'full set',251,4,200,8.4854527,128.3046883,122.6463997,1.8,128.3664381,122.6397998,-0.392729,2.2083923,3.2694867,5.8979424,20.8204271,0.2071409,6.3681028,2.6706951,7.9876265,4.5187213,6.9285108,0.5191461,17.708819),(30495,'full set',251,4,201,7.8314646,127.9915659,122.7340635,1.8,128.0682957,122.7461206,-0.4046395,2.0841615,3.0358676,4.9391624,16.2625443,0.2022995,5.3568029,2.3698559,6.9241648,4.2767649,6.5589027,0.551655,16.849443),(30496,'full set',251,4,202,7.6976904,127.8979305,122.7843641,1.8,127.9453774,122.7706402,-0.4250741,1.9014146,2.9722362,4.4703521,14.5234666,0.2181835,4.8863769,2.3510664,6.1791567,4.0779184,6.44532,0.6435011,16.2417724),(30497,'full set',251,4,203,7.3446521,127.6942205,122.8295785,1.8,127.7731569,122.7916092,-0.455152,1.9427155,2.975265,3.8908759,12.299747,0.2365555,4.1340005,2.0028027,5.3957556,4.0779184,6.1970485,0.5880026,15.7383616),(30498,'full set',251,4,204,6.8960528,127.6126367,122.8814042,1.8,127.7156983,122.8338214,-0.481874,1.7501557,2.8817806,3.4388807,10.7029007,0.2468525,3.7139887,1.9648999,4.9061342,3.831054,5.9694165,0.5280744,15.130691),(30499,'full set',251,4,205,6.4564054,127.4937483,122.9531855,1.8,127.5438367,122.9190369,-0.4937693,1.7207138,2.6411725,3.1620439,9.0850986,0.2417138,3.4397976,1.837635,4.6327546,3.8052344,5.6024461,0.5667292,13.9153498),(30500,'full set',251,4,206,6.2590732,127.4987936,123.0036259,1.8,127.6010187,122.9560371,-0.4886618,1.8770219,2.6597839,3.1768738,8.602442,0.229894,3.2342636,1.6925076,4.4192689,3.867192,5.6024461,0.5667292,14.1670552),(30501,'full set',251,4,207,5.9406114,127.4424969,123.059634,1.8,127.5212216,122.99819,-0.4843872,1.8531868,2.5348276,3.0873576,7.7159903,0.2146986,3.0439901,1.6659721,4.2521968,3.867192,5.3839752,0.4993467,13.9153498),(30502,'full set',251,4,208,5.8413578,127.4819661,123.1131867,1.8,127.6063184,123.0780679,-0.4928123,1.788898,2.5238528,3.1013295,7.4680999,0.2179106,2.9590077,1.7336536,4.1824888,3.9415764,5.3839752,0.4993467,14.0196096),(30503,'full set',251,4,209,5.6647827,127.4606055,123.1746407,1.8,127.5268754,123.1904188,-0.504219,1.7472167,2.4020057,3.070487,6.9071287,0.2203682,2.8755671,1.757359,4.0762109,3.8454256,5.2450105,0.610726,14.0196096),(30504,'full set',251,4,210,5.6130858,127.5088957,123.2104781,1.8,127.555952,123.1865273,-0.5080606,1.6931552,2.3790414,3.0600369,6.7666118,0.2214048,2.8442598,1.8072985,4.036415,3.8454256,5.2450105,0.610726,14.0196096),(30505,'full set',251,4,211,5.4957607,127.4971626,123.2588033,1.8,127.4502351,123.2786808,-0.50993,1.6570106,2.2197969,2.9693197,6.2537902,0.2182342,2.8172804,1.7919739,4.1403974,3.8443347,5.0109801,0.5404195,13.0559738),(30506,'full set',251,4,212,5.4733251,127.5582768,123.299307,1.8,127.5525885,123.3381144,-0.5273875,1.8106677,2.2486343,2.9775944,6.1326561,0.2310548,2.7272803,1.6444731,4.0180323,3.867192,5.0293691,0.348771,13.6636444),(30507,'full set',251,4,213,5.4205652,127.5632458,123.3321735,1.8,127.5447127,123.3567677,-0.5568722,1.7942574,2.2259355,2.9223765,5.8989409,0.2523704,2.6500951,1.6287388,3.9042982,3.867192,5.0109801,0.5404195,13.0559738),(30508,'full set',251,4,214,5.3491183,127.6345043,123.3573813,1.8,127.6664432,123.3757016,-0.5652945,1.738654,2.1471553,2.8727538,5.7127491,0.2558095,2.660613,1.6522861,3.9008407,3.8443347,4.899197,0.266252,13.411939),(30509,'full set',251,4,215,5.2493052,127.6601294,123.3647287,1.8,127.6982917,123.3702749,-0.5815513,1.7247644,2.1557575,2.81474,5.460985,0.2639993,2.5332094,1.6319562,3.8330607,3.8443347,4.899197,0.6610432,13.0559738),(30510,'full set',251,4,216,5.244046,127.7257883,123.385554,1.8,127.7665332,123.3801349,-0.5799103,1.7947689,2.2130383,2.8369395,5.4604026,0.2624191,2.4673783,1.5806712,3.7046868,3.867192,5.0109801,0.5404195,13.0559738),(30511,'full set',251,4,217,5.1284553,127.7470398,123.407033,1.8,127.7928424,123.3870274,-0.6090195,1.756144,2.2040196,2.719829,5.2501939,0.2797202,2.3820995,1.5487505,3.5749996,3.867192,5.0109801,0.5404195,13.0559738),(30512,'full set',251,4,218,5.0507981,127.8147474,123.4180455,1.8,127.8290663,123.4200938,-0.6252419,1.7019171,2.2510288,2.6018514,5.1353399,0.2883739,2.2813302,1.5287768,3.4290141,3.6460236,5.0109801,0.5404195,12.8042684),(30513,'full set',251,4,219,4.9738682,127.8450851,123.4029667,1.8,127.8802794,123.3781753,-0.6480275,1.6857953,2.0998576,2.535812,4.8533835,0.302039,2.3112917,1.504223,3.4541761,3.6460236,4.8040579,0.4636476,12.552563),(30514,'full set',251,4,220,4.918087,127.9136933,123.4085317,1.8,127.9379987,123.3845885,-0.6637044,1.6313507,2.0624841,2.4898409,4.7296866,0.3110724,2.293199,1.5262451,3.3459725,3.6460236,4.8040579,0.4636476,12.552563),(30515,'full set',251,4,221,4.8214071,127.9445222,123.4093654,1.8,128.0007499,123.3667301,-0.6925103,1.6001577,2.0102042,2.41476,4.4854013,0.3275708,2.2313163,1.5090763,3.360455,3.6460236,4.6477863,0.5880026,12.1965978),(30516,'full set',251,4,222,4.7904113,128.0052501,123.4133231,1.8,128.0067408,123.3943086,-0.6863906,1.5871317,2.0552961,2.33693,4.4241835,0.3206687,2.1525772,1.4724235,3.2822708,3.6460236,4.6477863,0.5880026,12.1965978),(30517,'full set',251,4,223,4.634929,128.0328328,123.3805663,1.8,128.0333831,123.4023013,-0.6952759,1.577423,2.0961575,2.2161934,4.2408671,0.3170021,2.0231624,1.4049456,3.0727517,3.6460236,4.6477863,0.5880026,12.1965978),(30518,'full set',251,4,224,4.5861974,128.0990818,123.3748308,1.8,128.0604518,123.3808809,-0.6952287,1.6154654,2.1507115,2.1657626,4.1758667,0.3136336,1.941621,1.3406432,2.9376321,3.6460236,4.899197,0.6610432,12.4483032),(30519,'full set',251,4,225,4.5013227,128.1277821,123.3528105,1.8,128.1093981,123.3343169,-0.6975585,1.6166456,2.1041905,2.1170127,3.9078987,0.3095496,1.8571982,1.3095094,2.8627897,3.6460236,4.6477863,0.5880026,12.1965978),(30520,'full set',251,4,226,4.4319459,128.2006103,123.3466775,1.8,128.2272157,123.3412474,-0.6943525,1.6589375,2.0444155,2.0524585,3.8310869,0.3024483,1.8739278,1.2372127,2.8709455,3.6460236,4.6477863,0.5880026,12.552563),(30521,'full set',251,4,227,4.2857511,128.1927234,123.339702,1.8,128.1616075,123.3491019,-0.732358,1.6448775,2.0444903,1.9472323,3.5657356,0.3193308,1.7440707,1.183816,2.694493,3.6460236,4.6477863,0.5880026,12.1965978),(30522,'full set',251,4,228,4.2152554,128.2602796,123.3430123,1.8,128.3334827,123.3562633,-0.7229912,1.6235548,1.9966744,1.9258688,3.433075,0.3075415,1.7193965,1.186205,2.6702692,3.6460236,4.5676461,0.71883,12.1965978),(30523,'full set',251,4,229,4.0555769,128.2396654,123.3229042,1.8,128.2248259,123.3278644,-0.7749981,1.6587973,1.9939776,1.8316526,3.1700561,0.3309355,1.5898153,1.1042052,2.4846208,3.437504,4.5676461,0.71883,11.8406326),(30524,'full set',251,4,230,3.9872072,128.2996635,123.3269497,1.8,128.3334827,123.3562633,-0.7530186,1.6248794,2.0019484,1.8325979,3.086482,0.310765,1.541739,1.1278362,2.409344,3.6460236,4.5676461,0.71883,12.1965978),(30525,'full set',251,4,231,3.8519224,128.2895321,123.3155691,1.8,128.261868,123.358821,-0.8096524,1.6649961,1.993284,1.7636251,2.7626462,0.3365583,1.3859772,1.0592368,2.2574928,3.437504,4.29688,0.6435011,11.5889272),(30526,'full set',251,4,232,3.778797,128.3397259,123.3144312,1.8,128.323252,123.335802,-0.8090957,1.6292393,1.7467174,1.7616244,2.5960302,0.3298189,1.4862336,1.0812558,2.3303625,3.6460236,4.231936,1.152572,11.693187),(30527,'full set',251,4,233,3.7169174,128.3325362,123.3083934,1.8,128.2892118,123.336081,-0.8859655,1.6613031,1.7929552,1.7269566,2.4383605,0.371624,1.3599673,1.0395193,2.2241594,3.437504,4.231936,1.152572,11.3372218),(30528,'full set',251,4,234,3.6487715,128.3710228,123.3238294,1.8,128.3360868,123.3673311,-0.9683748,1.6342738,1.8404821,1.7047559,2.3169356,0.4128705,1.2588743,1.0431274,2.1464466,3.437504,4.231936,1.152572,11.3372218),(30529,'full set',251,4,235,3.5478954,128.3648127,123.299369,1.8,128.3794242,123.320456,-1.0260678,1.6544426,1.7326015,1.66158,2.123336,0.4325377,1.225519,1.0043141,2.1240179,3.437504,4.0763783,1.2490458,11.3372218),(30530,'full set',251,4,236,3.5092346,128.3936681,123.3086865,1.8,128.36929,123.3535089,-1.0891215,1.6195602,1.7115308,1.6485948,2.0246574,0.4593508,1.1829512,1.0179275,2.0707438,3.437504,3.9615276,1.7894653,11.3372218),(30531,'full set',251,4,237,3.4406411,128.3836348,123.3129796,1.8,128.4008847,123.3457318,-1.2601703,1.5809528,1.7465019,1.6005563,1.9304558,0.5198666,1.105327,1.0123998,2.0018023,3.437504,3.9615276,1.7894653,11.3372218),(30532,'full set',251,4,238,3.3907346,128.4193106,123.3259154,1.8,128.4337432,123.3462373,-1.3898164,1.4781742,1.75232,1.5676668,1.8728668,0.5468138,1.0687927,1.0605427,1.9340339,3.007816,3.9615276,1.7894653,10.9812566),(30533,'full set',251,4,239,3.2821376,128.3991436,123.3159806,1.8,128.4591737,123.320456,1.5658059,1.3708817,1.723593,1.5156029,1.7656501,0.5470093,1.0244008,1.1055679,1.8655831,3.007816,3.9615276,1.7894653,10.7295512),(30534,'full set',251,4,240,3.2012353,128.4224312,123.3243686,1.8,128.4677602,123.3562633,1.4929937,1.4063794,1.7138708,1.4832578,1.6802053,0.5303161,0.9803571,1.054664,1.802081,3.007816,3.9615276,1.3521274,10.7295512),(30535,'full set',251,4,241,3.1168641,128.4028361,123.3335374,1.8,128.4675697,123.3935944,1.3407058,1.5259982,1.6775675,1.4435326,1.5862724,0.4924573,0.9455789,0.9459595,1.7388812,3.007816,3.8432463,1.1071487,10.373586),(30536,'full set',251,4,242,3.0376403,128.4306511,123.3307841,1.8,128.476712,123.3578202,1.1842121,1.5644976,1.5997124,1.411679,1.5225337,0.434307,0.9517546,0.902321,1.716873,3.007816,3.6963159,2.1910458,10.373586),(30537,'full set',251,4,243,2.8837246,128.4253165,123.3001729,1.8,128.476712,123.320456,1.0540035,1.5799977,1.5883643,1.3430421,1.4159485,0.3632872,0.8914508,0.8500279,1.7207996,3.007816,3.6963159,2.1910458,10.0176208),(30538,'full set',251,4,244,2.7797153,128.4496765,123.2999848,1.8,128.476712,123.320456,1.0607482,1.5581572,1.5756221,1.3060996,1.3701476,0.352858,0.8695915,0.8382336,1.6904959,3.007816,3.6963159,2.1910458,10.0176208),(30539,'full set',251,4,245,2.6869519,128.4390444,123.2904919,1.8,128.476712,123.320456,1.012519,1.5646534,1.5939458,1.2762919,1.3188704,0.3221613,0.8274249,0.8157026,1.6247897,3.007816,3.6963159,2.1910458,10.0176208),(30540,'full set',251,4,246,2.6584738,128.4753103,123.2924226,1.8,128.476712,123.320456,0.9335106,1.5629348,1.5707459,1.2740882,1.3060854,0.2862094,0.8315065,0.8151896,1.6398396,3.007816,3.6963159,2.1910458,10.0176208),(30541,'full set',251,4,247,2.5829986,128.4560871,123.2725143,1.8,128.476712,123.320456,0.8300379,1.5483548,1.5805193,1.2639107,1.2747245,0.2344417,0.8065226,0.8162927,1.586032,3.007816,3.6963159,2.1910458,10.0176208),(30542,'full set',251,4,248,2.5065722,128.4974766,123.2681465,1.8,128.5140762,123.320456,0.5880934,1.6043033,1.561006,1.2388801,1.2715629,0.1285772,0.8145791,0.7722231,1.4777804,3.007816,3.6963159,2.1910458,10.373586),(30543,'full set',251,4,249,2.3735254,128.4794265,123.2678275,1.8,128.476712,123.320456,0.8059896,1.5635088,1.5612032,1.1878663,1.1909848,0.2059372,0.7628634,0.7597439,1.4916438,3.007816,3.6963159,2.1910458,10.0176208),(30544,'full set',251,4,250,2.2764539,128.5306553,123.2633023,1.8,128.5498504,123.3113137,0.2485315,1.5295139,1.6277156,1.1570571,1.2079705,0.0229567,0.7421262,0.7564869,1.3863157,3.007816,3.8432463,0.4636476,10.373586),(30545,'full set',251,4,251,2.1196288,128.5338412,123.2365599,1.8,128.5498504,123.3113137,0.0850965,1.4458893,1.6627409,1.0776456,1.1642489,0.002552,0.7001986,0.7453168,1.32092,3.007816,3.8432463,0.4636476,10.373586),(30546,'full set',251,4,252,2.0145565,128.6093046,123.2067898,1.8,128.659558,123.2473176,0.1512877,1.47145,1.6499315,1.0122107,1.1484764,0.0076264,0.6960752,0.6879002,1.2886976,3.007816,3.8432463,2.677945,10.373586),(30547,'full set',251,4,253,1.9308008,128.5824095,123.1686894,1.8,128.6261687,123.2363866,0.1640514,1.508923,1.6161832,0.9797468,1.0881299,0.0085831,0.6732714,0.6493021,1.2599168,3.007816,3.6963159,2.1910458,10.373586),(30548,'full set',251,4,254,2.0649106,128.6075848,123.1545976,1.8,128.6419766,123.213034,-0.1836894,1.5635125,1.6878421,1.0980566,1.2731618,0.0114823,0.7543133,0.7023011,1.3473284,3.437504,4.0536685,0.5585993,10.9812566),(30549,'full set',251,4,255,2.2278901,128.5652718,123.0954255,1.8,128.6438129,123.1533551,-0.3783508,1.6917409,1.7492169,1.201647,1.4477088,0.0506651,0.8276325,0.710302,1.4831071,3.437504,4.0536685,0.5585993,10.9812566),(30550,'full set',251,4,256,2.4494482,128.5722582,123.1155052,1.8,128.5520959,123.1319964,-0.1958537,1.6140963,1.8194965,1.3449147,1.7244365,0.0154604,0.9477548,0.8332307,1.6789252,3.437504,4.0763783,2.8198421,11.5889272),(30551,'full set',251,4,257,3.0038471,128.4895973,123.1252801,1.8,128.5031543,123.1684126,-0.0744666,1.584248,1.8052946,1.8054434,2.440087,0.0027711,1.3516281,1.1396217,2.0940008,3.437504,4.6477863,0.5880026,12.3440434),(30552,'full set',251,4,258,3.2799556,128.4341712,123.0936722,1.8,128.4574722,123.0831656,-0.1403063,1.6516287,1.892541,2.0519648,2.7154267,0.010691,1.4348047,1.2423887,2.3038956,3.437504,4.6477863,2.5535901,12.5957488),(30553,'full set',251,4,259,1.4584791,128.3809602,123.0552883,1.8,128.3761467,123.0553294,-0.0269378,1.4620514,1.8182768,0.5993175,1.0208825,0.0001763,0.5614561,0.4099155,0.8835316,3.007816,4.0763783,0.3217506,10.7295512),(30554,'full set',251,4,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30555,'full set',251,4,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30556,'full set',251,4,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30557,'full set',251,4,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30558,'full set',251,4,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30559,'full set',251,4,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30560,'full set',251,4,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30561,'full set',251,4,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30562,'full set',251,4,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30563,'full set',251,4,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30564,'full set',251,4,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30565,'full set',251,4,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30566,'full set',251,4,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30567,'full set',251,4,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30568,'full set',251,4,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30569,'full set',251,4,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30570,'full set',251,4,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30571,'full set',251,4,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30572,'full set',251,4,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30573,'full set',251,4,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30574,'full set',251,4,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30575,'full set',251,4,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30576,'full set',251,4,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30577,'full set',251,4,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30578,'full set',251,4,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30579,'full set',251,4,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30580,'full set',251,4,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30581,'full set',251,4,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30582,'full set',251,4,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30583,'humerus.tif',227,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30584,'humerus.tif',227,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30585,'humerus.tif',227,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30586,'humerus.tif',227,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30587,'humerus.tif',227,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30588,'humerus.tif',227,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30589,'humerus.tif',227,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30590,'humerus.tif',227,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30591,'humerus.tif',227,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30592,'humerus.tif',227,2,10,0.0103135,10.8430637,7.2225867,1.8,10.8424434,7.2235229,-0.9199733,0.1113683,0.1664999,0.0000293,0.0000654,0.001088,0.0003927,0.0002631,0.0005146,0.241342,0.3521807,1.1071487,0.9202159),(30593,'humerus.tif',227,2,11,0.8225782,11.0349737,7.2663359,1.8,11.0014626,7.2813718,-0.9205987,0.7284918,0.846806,0.1042562,0.1313658,0.0868586,0.155131,0.1431124,0.2475424,1.4478012,1.696327,0.2629947,5.2342456),(30594,'humerus.tif',227,2,12,1.5569139,11.0066825,7.5084783,1.8,10.9514677,7.5832026,-1.476568,1.3088658,4.0293591,0.4078702,1.4825132,0.2571885,0.3679278,0.3116211,0.4664932,2.080812,2.3683728,0.2417529,7.5264865),(30595,'humerus.tif',227,2,13,3.4302262,10.7980394,8.0779225,1.8,10.7943826,8.3197857,1.5446936,1.3871692,4.0201662,1.2268991,10.0084702,0.5713149,2.4895663,0.8844625,2.7946868,2.5866937,3.1782236,1.8109673,9.5743707),(30596,'humerus.tif',227,2,14,5.4727005,10.7329923,8.8238567,1.8,10.7630462,8.9372613,1.5250255,1.555365,4.32193,2.3862659,23.8266826,0.9102072,5.5129728,1.534216,6.0573707,3.0124205,7.6581289,1.7028042,23.0204596),(30597,'humerus.tif',227,2,15,6.5318362,10.7471404,9.1942962,1.8,10.7595989,9.2120664,1.508393,1.6112368,4.3713739,3.2565017,32.5269034,1.0844055,7.440888,2.0211192,7.8362118,3.1468231,7.9595958,1.7418005,21.2633346),(30598,'humerus.tif',227,2,16,6.3693223,10.7554897,9.2368588,1.8,10.7576886,9.2861144,1.4788579,1.8349847,4.6414852,3.4087742,37.3452261,1.052606,8.0459646,1.8576582,8.5166044,3.208862,8.2607513,1.7509909,25.8554597),(30599,'humerus.tif',227,2,17,6.0899386,10.6871993,9.2724727,1.8,10.7022341,9.3789227,1.4496814,1.6689421,4.7269089,3.3121588,40.9439974,1.0001737,8.6618968,1.9845858,9.0039269,3.1052639,8.3913069,1.7902796,23.0038619),(30600,'humerus.tif',227,2,18,4.9880047,10.5038055,9.6578283,1.8,10.5614749,9.7373263,1.3645755,2.0589862,4.323458,2.5535896,35.5240509,0.7964783,8.2165829,1.2402169,8.4029689,2.6588677,8.3298296,1.7919263,29.5115393),(30601,'humerus.tif',227,2,19,4.1923851,10.3052872,9.8463809,1.8,10.3895106,9.996914,1.2688226,1.4422521,4.3783561,1.6032868,29.0127033,0.6369282,6.6263918,1.111655,6.9833768,2.7023726,8.1609323,1.967072,29.0750166),(30602,'humerus.tif',227,2,20,3.7896863,10.1686646,9.8748259,1.8,10.2041959,10.0043394,1.2410406,1.3913786,4.297373,1.368706,24.7930418,0.565387,5.7693483,0.9837049,6.0839188,2.5346032,8.1014426,1.9491366,46.5839033),(30603,'humerus.tif',227,2,21,3.4955858,10.0990154,9.782311,1.8,10.1116436,9.8590456,1.2251973,1.351743,4.1341172,1.370285,20.0162814,0.5157396,4.8417306,1.0137171,5.1619733,2.4746923,7.8095865,1.9640361,21.6758414),(30604,'humerus.tif',227,2,22,3.486215,9.9915391,9.8277608,1.8,10.002434,9.883289,1.2091525,1.2349982,4.0842915,1.4630687,18.2045287,0.5083,4.4572061,1.1846727,4.7945956,2.401381,7.539629,2.062474,19.4777164),(30605,'humerus.tif',227,2,23,3.351968,9.9122686,9.7756616,1.8,9.9204218,9.8344136,1.1717739,2.0694338,3.954277,1.4794393,17.2634551,0.4743336,4.3657678,0.7149005,4.3040795,2.3533216,7.3200065,2.1134298,18.5269277),(30606,'humerus.tif',227,2,24,3.0565302,9.8826011,9.7645651,1.8,9.8625456,9.7867057,1.132987,1.2369646,3.9051642,1.3349834,14.9027666,0.4178587,3.8161691,1.0792414,4.1332816,2.3161239,7.1732218,2.1466193,18.1444504),(30607,'humerus.tif',227,2,25,3.0486352,9.7977333,9.7619342,1.8,9.7680961,9.7624522,1.1041555,1.1768174,3.8449199,1.2745445,13.2511768,0.4052653,3.4464117,1.0830435,3.7547438,2.2814905,7.0166561,2.1774767,18.468405),(30608,'humerus.tif',227,2,26,2.675729,9.6495249,9.5574619,1.8,9.5813525,9.4846134,1.080639,1.1671064,3.6074785,1.2178208,10.6093492,0.3471226,2.9409321,1.0434531,3.2540198,2.2393545,6.1295634,2.0114595,15.0453299),(30609,'humerus.tif',227,2,27,2.6866394,9.5308964,9.4552389,1.8,9.4683399,9.4041009,1.0415971,1.2983555,3.4626213,1.2210066,9.9933481,0.3336512,2.8860644,0.9404255,3.2270292,2.2298771,5.8478969,2.0103522,15.1389026),(30610,'humerus.tif',227,2,28,2.6541431,9.5005163,9.4375252,1.8,9.4202869,9.353794,0.99091,1.2336915,3.4407153,1.1797149,9.1974746,0.30955,2.6731286,0.9562479,3.0100355,2.2525956,5.6237868,2.0670139,13.9374253),(30611,'humerus.tif',227,2,29,2.5860342,9.3940826,9.3489173,1.8,9.3026623,9.2581715,0.964609,1.2417015,3.315894,1.1926866,8.2062631,0.2911005,2.4748267,0.960526,2.8217113,2.2754936,5.4429413,2.0784569,13.6593299),(30612,'humerus.tif',227,2,30,2.674598,9.3301905,9.2874547,1.8,9.2438603,9.202591,0.9140329,1.3038149,3.303367,1.2462778,7.8309019,0.2795937,2.3705819,0.9558702,2.7444029,2.2980237,5.3536102,2.1081886,13.4257821),(30613,'humerus.tif',227,2,31,2.8347783,9.2843232,9.3155963,1.8,9.1885903,9.214336,0.8842464,1.292093,3.3194978,1.28082,7.3853319,0.2826301,2.2248341,0.9912754,2.6105071,2.3318195,5.2522886,2.1338457,13.3551389),(30614,'humerus.tif',227,2,32,2.9659133,9.2923907,9.381513,1.8,9.207672,9.2884047,0.8406839,1.2936593,3.3700536,1.3381293,7.5847636,0.2744326,2.2506359,1.0343754,2.646543,2.3585129,5.9735497,2.3188984,14.9575458),(30615,'humerus.tif',227,2,33,3.0619598,9.1591752,9.3318904,1.8,9.0768053,9.2453734,0.8277437,1.2479347,3.290093,1.4418876,7.1397061,0.2767475,2.1700621,1.1554191,2.5978951,2.3931232,5.8206853,2.3064272,14.4859731),(30616,'humerus.tif',227,2,34,3.268997,9.0586926,9.2561196,1.8,8.9837989,9.188274,0.8038139,1.2513056,3.1124462,1.4680836,6.9954193,0.2824476,2.2475632,1.1732415,2.7022485,2.4595406,5.5748772,2.3082313,14.0697571),(30617,'humerus.tif',227,2,35,3.1776179,9.0096083,9.1993874,1.8,8.9358312,9.1387254,0.7773083,1.2760338,2.8737399,1.501588,6.0746374,0.2605172,2.1138439,1.1767619,2.6258849,2.505772,5.2381954,2.3944737,13.5090889),(30618,'humerus.tif',227,2,36,3.2180183,9.0913035,9.3085606,1.8,9.0515643,9.2779807,0.7127605,1.2930144,2.8730766,1.5886955,4.82591,0.2293469,1.6797012,1.2286758,2.2024126,2.5376677,4.4526563,2.4513833,11.3829184),(30619,'humerus.tif',227,2,37,2.9638184,9.1111838,9.3283256,1.8,9.1028875,9.3259433,0.5833131,1.3298707,2.1135792,1.5991175,3.6600465,0.1498566,1.7316818,1.202461,2.4813704,2.5614944,4.050905,2.4996468,10.6408934),(30620,'humerus.tif',227,2,38,3.205805,9.1302799,9.3214334,1.8,9.1356251,9.3239635,0.5110713,1.3266948,1.9779784,1.6682968,3.2520265,0.127821,1.6441163,1.2574835,2.4763907,2.5689309,3.7936255,2.5213432,10.2215116),(30621,'humerus.tif',227,2,39,2.8410156,9.0896354,9.3171037,1.8,9.099027,9.3109895,0.4338871,1.3046826,1.8526813,1.5168481,3.0506333,0.0836854,1.6466044,1.1626185,2.4496177,2.5602578,3.6196229,2.5922182,9.9618684),(30622,'humerus.tif',227,2,40,2.7458874,9.1428237,9.3131508,1.8,9.1548002,9.3079622,0.3471536,1.3073989,1.803689,1.5020806,2.759545,0.0529734,1.529945,1.1489076,2.3388327,2.5306118,3.4421589,2.6247167,9.7098684),(30623,'humerus.tif',227,2,41,2.6527679,9.1324842,9.313838,1.8,9.1413866,9.3047001,0.2122897,1.2658137,1.7184863,1.4678234,2.5333438,0.0196278,1.4741716,1.1595888,2.2787511,2.4942092,3.3182825,2.7928217,9.5577729),(30624,'humerus.tif',227,2,42,2.8783864,9.1300527,9.2806776,1.8,9.1257502,9.2765692,0.0620431,1.2296273,1.6250815,1.4585896,2.525142,0.0018443,1.5538556,1.1862047,2.3676031,2.4570001,3.2105285,2.863293,9.4056775),(30625,'humerus.tif',227,2,43,2.8943246,9.187602,9.2096445,1.8,9.1917648,9.2026136,0.1127144,1.2853236,1.6368853,1.4465385,2.4714021,0.0061026,1.50982,1.1254275,2.3615649,2.4255001,3.1413256,3.020969,9.2612252),(30626,'humerus.tif',227,2,44,2.6517291,9.2248075,9.210859,1.8,9.220222,9.1981339,-0.011508,1.1848418,1.6011908,1.3591402,2.3161952,0.0000585,1.4465454,1.1471068,2.2186622,2.3625001,3.1278724,0.1618374,9.1644866),(30627,'humerus.tif',227,2,45,2.6169898,9.2339459,9.1809911,1.8,9.2385126,9.1650989,-0.170477,1.1913812,1.5647797,1.344091,2.2680425,0.0125537,1.4494324,1.1281788,2.2126755,2.3625001,3.1570796,0.2110933,9.1460343),(30628,'humerus.tif',227,2,46,2.6997321,9.2344983,9.1282615,1.8,9.2311606,9.1229141,-0.2884084,1.2086749,1.630991,1.3328065,2.3113654,0.0364008,1.417154,1.1027006,2.2178681,2.3822158,3.1982973,0.2999472,9.2351298),(30629,'humerus.tif',227,2,47,2.9833674,9.2532046,9.063576,1.8,9.2532824,9.0581611,-0.3585852,1.2346508,1.703931,1.3725873,2.4939598,0.0612414,1.4636507,1.111721,2.2630035,2.3822158,3.2779682,0.3430239,9.3503207),(30630,'humerus.tif',227,2,48,2.7630551,9.3282462,9.0144439,1.8,9.337882,9.0034352,-0.3841139,1.2093756,1.7652447,1.306796,2.6833155,0.0646686,1.5200813,1.0805543,2.2457293,2.3663785,3.4165523,0.397628,9.5208684),(30631,'humerus.tif',227,2,49,2.7970459,9.3824663,8.9723459,1.8,9.407337,8.9559748,-0.4446971,1.1955909,1.9290769,1.289947,2.9814651,0.0862696,1.5455398,1.07892,2.2069539,2.353288,3.6274272,0.401471,9.8435116),(30632,'humerus.tif',227,2,50,2.9298449,9.4266321,8.9045829,1.8,9.4666205,8.8717076,-0.464677,1.2023454,2.1438629,1.2967582,3.5355899,0.0980639,1.6491679,1.0785239,2.2424788,2.3709164,3.9113311,0.5321324,10.3335366),(30633,'humerus.tif',227,2,51,3.1260824,9.5519822,8.7895134,1.8,9.6334118,8.7379336,-0.5250211,1.1942863,2.3629084,1.3382873,4.2930108,0.1308957,1.8168334,1.1205749,2.3749007,2.3907935,4.2900179,0.5227891,11.2136821),(30634,'humerus.tif',227,2,52,3.0736663,9.5779945,8.737145,1.8,9.6924465,8.6623057,-0.5665128,1.2307338,2.4494791,1.3757049,4.8421545,0.1475561,1.9768099,1.1177924,2.5363958,2.4094592,4.4308757,0.5623672,11.5961594),(30635,'humerus.tif',227,2,53,3.0601418,9.5706398,8.7161125,1.8,9.7141294,8.6236368,-0.5845296,1.2442616,2.5237979,1.4245678,5.1567125,0.1552976,2.0432351,1.1449102,2.605879,2.4232577,4.5111037,0.5511975,11.7959685),(30636,'humerus.tif',227,2,54,3.0335404,9.6188144,8.6476229,1.8,9.7701267,8.5470638,-0.5724356,1.2286516,2.5225485,1.4070207,5.4637942,0.1483494,2.1659818,1.1451747,2.7185992,2.4491778,4.6065453,0.6202495,12.021873),(30637,'humerus.tif',227,2,55,2.9768353,9.619748,8.6065264,1.8,9.7716863,8.5020333,-0.5722823,1.230367,2.5259649,1.3792764,5.564436,0.1455071,2.2028952,1.1210285,2.7465727,2.4512882,4.6579544,0.5636172,12.0371594),(30638,'humerus.tif',227,2,56,2.9538937,9.5905166,8.6056584,1.8,9.7354641,8.4996371,-0.5809823,1.2560293,2.5424941,1.3924149,5.6782238,0.1483008,2.2333283,1.1085848,2.780982,2.4927625,4.6783599,0.5450384,12.6423753),(30639,'humerus.tif',227,2,57,2.8833031,9.5300154,8.5999016,1.8,9.6801115,8.4952026,-0.592658,1.385064,2.5716478,1.4505571,5.4961841,0.1499308,2.1372227,1.0472853,2.6993088,2.6640124,4.7003659,0.5266273,12.5348276),(30640,'humerus.tif',227,2,58,2.9042166,9.5001931,8.6158594,1.8,9.646292,8.5245851,-0.5958163,1.5327974,2.5528189,1.5743891,5.6329065,0.1524366,2.2065437,1.0271345,2.8220648,2.8510546,4.6891642,0.5358112,14.3523299),(30641,'humerus.tif',227,2,59,3.1767676,9.3875215,8.6832662,1.8,9.5301397,8.6043837,-0.5793244,1.5710949,2.6302,1.7936729,5.8129752,0.1586854,2.2100887,1.1416706,2.8816227,2.9149485,4.6874711,0.6327488,17.0085958),(30642,'humerus.tif',227,2,60,3.1387943,9.311015,8.7481001,1.8,9.4420855,8.6740415,-0.6051753,1.756238,2.6233035,1.9187312,5.6122892,0.1693141,2.1393976,1.0925235,2.8544733,3.0507944,4.6306073,0.6503037,15.4583799),(30643,'humerus.tif',227,2,61,2.9329432,9.2798206,8.7191938,1.8,9.3865112,8.6514947,-0.6075339,1.6708784,2.5037538,1.9553099,5.3072725,0.1592898,2.1197261,1.1702287,2.8767949,3.0728253,4.5702148,0.6779702,14.9759981),(30644,'humerus.tif',227,2,62,2.7732962,9.1953334,8.7312728,1.8,9.3064103,8.6821362,-0.6176917,1.7754567,2.8132007,1.9870343,5.062157,0.1550367,1.7994298,1.119168,2.4848659,3.0536332,4.2947568,0.5391616,13.8928776),(30645,'humerus.tif',227,2,63,2.6663611,9.0548783,8.7808738,1.8,9.1229316,8.7309223,-0.626369,1.7055158,2.1472699,2.0431717,4.7628092,0.1527108,2.2180767,1.1979788,3.1642825,3.1504437,4.1611012,0.5144513,13.8406867),(30646,'humerus.tif',227,2,64,2.7476283,8.8739641,8.8255603,1.8,8.95892,8.7675863,-0.6418846,1.7089876,2.1278933,2.3202248,4.6918224,0.1641474,2.2049143,1.3576604,3.2574937,3.1130789,4.0950001,0.3947911,12.5946616),(30647,'humerus.tif',227,2,65,3.0650213,8.7414516,8.8817173,1.8,8.8073002,8.8242688,-0.6499235,1.7649381,2.0981947,2.7539769,4.6224143,0.1870566,2.2030436,1.5603816,3.4916065,3.1703349,4.0665513,1.2147455,12.7836617),(30648,'humerus.tif',227,2,66,2.857732,8.602264,9.0082842,1.8,8.6558264,8.9636684,-0.6864218,1.7493606,2.1587139,2.8328287,4.7066415,0.1913103,2.1802989,1.6193509,3.3766512,3.2454386,4.1639617,1.2394767,12.8804003),(30649,'humerus.tif',227,2,67,3.0035372,8.5798599,9.1147441,1.8,8.6244927,9.0637353,-0.759262,1.7495953,2.1672608,3.2799872,4.7098342,0.2372172,2.1731737,1.874712,3.4595527,3.3886939,4.2663608,1.2864116,13.0954958),(30650,'humerus.tif',227,2,68,3.0206937,8.388604,9.150052,1.8,8.3371633,9.1231428,-0.7818474,2.2183546,2.20707,3.6993474,4.9060913,0.2499369,2.222898,1.6676087,3.2850067,3.5588942,4.3703342,1.3380548,13.4595208),(30651,'humerus.tif',227,2,69,2.8740009,8.3890775,9.1628205,1.8,8.3957904,9.1428735,-1.0320281,2.5200596,2.2616291,3.9423358,5.0338106,0.3529033,2.2257454,1.564382,3.4038779,3.7084356,4.5312945,1.410219,14.146189),(30652,'humerus.tif',227,2,70,3.1917009,8.1923873,9.2315281,1.8,8.1417669,9.213714,-1.0380392,2.5021434,2.4921277,4.6933012,5.8333045,0.3947214,2.3406925,1.8757123,3.8471453,3.845764,4.6613616,1.4556615,16.0910026),(30653,'humerus.tif',227,2,71,3.4306726,8.0188173,9.2773828,1.8,7.9731594,9.2586877,-0.8810212,2.7225118,2.4376327,5.5165096,6.5791619,0.3402319,2.6989964,2.0262574,4.2110317,4.0706782,4.7669192,1.5046677,18.0128868),(30654,'humerus.tif',227,2,72,4.2061834,7.7282224,9.3184709,1.8,7.6162814,9.333925,-0.4632398,2.5781122,2.7593309,6.9264949,8.9913774,0.1399774,3.2585354,2.6866537,5.5763488,4.3879512,5.1875634,0.2390877,41.4648487),(30655,'humerus.tif',227,2,73,5.7458546,7.39149,9.3395135,1.8,7.3303643,9.3241555,-0.3515372,2.8826194,2.9514384,9.459363,15.1900491,0.1135487,5.1466597,3.2815165,8.169644,5.0991096,5.7486423,0.3408124,32.4008098),(30656,'humerus.tif',227,2,74,6.3129892,7.12456,9.4723312,1.8,7.0851041,9.4523256,-0.4733653,3.0479132,3.1712863,13.1842056,15.7251441,0.2186717,4.9586012,4.3256499,9.0348484,5.2305666,5.9204082,1.7149507,20.3763141),(30657,'humerus.tif',227,2,75,6.8914911,7.0356658,9.4289662,1.8,7.0046601,9.4282702,-1.2728441,2.8122847,3.0520871,15.2217569,18.7592483,1.0495977,6.1463672,5.4125946,10.5504249,5.2712116,6.1030388,1.6586525,20.8816255),(30658,'humerus.tif',227,2,76,7.1484839,6.8191299,9.4568241,1.8,6.8138223,9.4595576,-1.4391633,3.1596301,3.1041316,15.7379288,19.5067655,1.170889,6.2841296,4.9809403,10.4063799,5.297666,6.1702222,1.8554073,21.597555),(30659,'humerus.tif',227,2,77,7.5823924,6.8297366,9.471636,1.8,6.8260908,9.4887673,-1.3330123,2.9747027,3.1226634,16.4541095,20.739642,1.1936157,6.6416515,5.5313459,11.2557171,5.3239921,6.1968596,1.8330359,20.4959823),(30660,'humerus.tif',227,2,78,8.3917538,6.9295139,9.3885199,1.8,6.9220106,9.4166742,-1.2820626,2.7454826,3.0080486,17.81072,22.6691471,1.2852306,7.5361639,6.4872821,12.5791784,5.2243096,6.3177726,1.6957698,20.1287914),(30661,'humerus.tif',227,2,79,8.5373803,7.0219448,9.3334258,1.8,7.005922,9.3565292,-1.2782104,2.5890759,3.0005574,15.8700827,20.7819975,1.304524,6.9260456,6.1296321,11.4407471,5.0060773,6.1850795,1.6882026,20.0352186),(30662,'humerus.tif',227,2,80,7.9195447,6.8952643,9.3851333,1.8,6.9522205,9.3843405,-1.4681293,2.582494,2.8994582,11.4423001,16.1880683,1.3060602,5.5831357,4.4307169,8.9961039,4.8190396,5.865855,1.6191457,20.1459323),(30663,'humerus.tif',227,2,81,7.0089196,6.842796,9.3617061,1.8,6.8747458,9.3911375,-1.2866099,2.2790519,2.8223184,7.611046,11.3244903,1.0763235,4.0124779,3.3395668,6.7015631,4.3708344,5.5286764,1.2580545,19.37148),(30664,'humerus.tif',227,2,82,5.0076692,6.9155999,9.2050787,1.8,6.877944,9.2552967,-1.0509176,1.8775708,3.7188071,3.8776417,7.072311,0.6286417,1.9017687,2.065244,2.8191082,3.6591399,4.822073,1.6034644,15.3845708),(30665,'humerus.tif',227,2,83,2.3897435,7.1128488,8.7841129,1.8,6.9823012,8.9129169,-0.7016371,1.2628306,4.6612758,0.7011225,2.5710868,0.1659399,0.5515844,0.5551992,0.7018094,2.4791842,3.6499245,0.4366272,11.5223503),(30666,'humerus.tif',227,2,84,0.4055617,7.359702,8.5963257,1.8,7.3546481,8.593965,-0.1825506,0.6772621,1.1365497,0.0386682,0.0993237,0.0022276,0.0873905,0.0570948,0.1194537,1.3360619,2.0715891,0.1526493,6.7628433),(30667,'humerus.tif',227,2,85,0.0748644,6.931285,8.800003,1.8,6.9283907,8.801606,-0.9389647,0.3139621,0.3945022,0.0015093,0.0018372,0.0081248,0.004657,0.0048072,0.0084656,0.5877881,0.7380686,0.8760581,2.1923364),(30668,'humerus.tif',227,2,86,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30669,'humerus.tif',227,2,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30670,'humerus.tif',227,2,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30671,'humerus.tif',227,2,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30672,'humerus.tif',227,2,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30673,'humerus.tif',227,2,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30674,'humerus.tif',227,2,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30675,'humerus.tif',227,2,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30676,'humerus.tif',227,2,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30677,'humerus.tif',227,2,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30678,'humerus.tif',227,2,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30679,'Bettongia_lesuer-radius.tif',227,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30680,'Bettongia_lesuer-radius.tif',227,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30681,'Bettongia_lesuer-radius.tif',227,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30682,'Bettongia_lesuer-radius.tif',227,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30683,'Bettongia_lesuer-radius.tif',227,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30684,'Bettongia_lesuer-radius.tif',227,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30685,'Bettongia_lesuer-radius.tif',227,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30686,'Bettongia_lesuer-radius.tif',227,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30687,'Bettongia_lesuer-radius.tif',227,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30688,'Bettongia_lesuer-radius.tif',227,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30689,'Bettongia_lesuer-radius.tif',227,3,11,0.0039581,8.138579,7.4448013,1.8,8.1392262,7.4452784,0.6393104,0.0441705,0.1498754,0.0000017,0.0000231,0.0002348,0.0001545,0.0000377,0.0001655,0.1133428,0.3203893,2.4805495,0.6687516),(30690,'Bettongia_lesuer-radius.tif',227,3,12,0.0553296,7.9907808,7.587537,1.8,7.9911138,7.5823011,0.3088132,0.2310977,0.5207635,0.0006768,0.0029126,0.0008518,0.005593,0.0029285,0.006486,0.4275296,0.8168356,3.0727362,2.3065397),(30691,'Bettongia_lesuer-radius.tif',227,3,13,0.082125,8.0059413,7.7371329,1.8,8.0018515,7.7358423,-0.1708471,0.4244418,0.4825115,0.002435,0.0038701,0.0003956,0.0080207,0.0057369,0.0102624,0.7668965,1.0182131,2.6532587,3.3425883),(30692,'Bettongia_lesuer-radius.tif',227,3,14,0.1193501,8.1962991,7.8865866,1.8,8.1901371,7.8821823,0.9818957,0.7697994,0.8545989,0.0047323,0.0129869,0.0137547,0.0151965,0.0061474,0.020038,0.7652848,1.146604,1.8692953,4.3292552),(30693,'Bettongia_lesuer-radius.tif',227,3,15,0.6766848,8.258649,8.1369373,1.8,8.1767688,8.1322085,-1.2350825,0.9695524,1.150758,0.119722,0.1468056,0.1005404,0.127573,0.1234817,0.2255229,1.7849129,2.1784298,1.6871515,7.032019),(30694,'Bettongia_lesuer-radius.tif',227,3,16,1.6436649,8.1689204,8.0496492,1.8,8.1067928,8.1659258,-0.8066588,1.1329955,1.3754839,0.5184557,0.6192794,0.1427945,0.4502266,0.4575973,0.779073,2.2676339,2.6789486,1.6548086,8.3928011),(30695,'Bettongia_lesuer-radius.tif',227,3,17,2.3596,7.9804768,8.0977287,1.8,8.0411553,8.1443765,-0.9456099,1.4689794,1.4071524,0.9460197,1.2138703,0.2585666,0.8626431,0.643998,1.4462357,2.7276289,2.9698391,2.7839294,9.8278981),(30696,'Bettongia_lesuer-radius.tif',227,3,18,2.6658722,7.9353296,8.1167245,1.8,7.9960839,8.1192539,-1.084298,1.6282302,1.6172997,1.1945926,1.9535405,0.347191,1.2079026,0.7336755,1.8655451,2.8740612,3.4033497,0.3191396,10.4761951),(30697,'Bettongia_lesuer-radius.tif',227,3,19,2.4030539,8.0634398,7.9663395,1.8,8.0712463,7.9894508,-1.1561731,1.481133,1.7325471,1.2279536,1.7827786,0.3355127,1.0289928,0.8290637,1.7283319,3.0072889,3.5093514,0.4206633,10.8996921),(30698,'Bettongia_lesuer-radius.tif',227,3,20,2.1751482,8.0837912,7.8102644,1.8,8.0786914,7.8641021,-1.248707,1.5110578,1.7759555,1.1329117,1.7500814,0.3261985,0.9854309,0.7497474,1.5768069,3.0217614,3.4940178,0.5500744,10.6572617),(30699,'Bettongia_lesuer-radius.tif',227,3,21,1.9738845,8.024409,7.7919082,1.8,8.0637913,7.8001606,-1.2148021,1.5726859,1.6852014,0.9046316,1.7022593,0.2890202,1.0101221,0.5752144,1.5414132,3.0557956,3.4462334,0.6174059,11.2437104),(30700,'Bettongia_lesuer-radius.tif',227,3,22,1.9989673,8.0171505,7.7527522,1.8,8.0595478,7.7519915,-1.2079119,1.4470596,1.7252357,0.8735521,1.9364833,0.2911811,1.1224456,0.6036739,1.5925032,2.9208428,3.4362521,0.8896698,10.6050557),(30701,'Bettongia_lesuer-radius.tif',227,3,23,2.0178705,8.0072157,7.6597216,1.8,8.0474614,7.6865555,-1.2305065,1.4094809,1.9104453,0.8954611,2.1960243,0.298848,1.1494829,0.6353127,1.6107585,2.7362338,3.625009,1.0064452,10.6981709),(30702,'Bettongia_lesuer-radius.tif',227,3,24,2.0632717,7.9744542,7.592772,1.8,8.007404,7.6325156,-1.1991316,1.668353,2.0816268,0.9079161,2.555242,0.2985244,1.2275217,0.544199,1.6037964,2.5715458,3.860351,1.0191413,11.4424074),(30703,'Bettongia_lesuer-radius.tif',227,3,25,2.1701311,7.9258554,7.5962039,1.8,7.9489047,7.6891681,-1.227835,1.6776001,2.2677272,1.0142709,3.0242529,0.3207879,1.3336053,0.6045963,1.7411962,2.4710046,4.1262054,1.2878194,12.331965),(30704,'Bettongia_lesuer-radius.tif',227,3,26,2.3826817,7.8875566,7.5804183,1.8,7.908122,7.6575229,-1.2378071,1.6687094,2.3004622,1.156909,3.513956,0.3546845,1.5275,0.6932956,1.9976677,2.4914132,4.2549006,1.357858,12.5675772),(30705,'Bettongia_lesuer-radius.tif',227,3,27,2.6853303,7.7922667,7.5676906,1.8,7.8078298,7.6599961,-1.224154,1.786211,2.255042,1.4536101,4.3804862,0.3958963,1.9425298,0.8137953,2.4415415,2.6095181,4.3568595,1.4544412,14.1218924),(30706,'Bettongia_lesuer-radius.tif',227,3,28,2.8064709,7.6727098,7.4650302,1.8,7.6752606,7.5715473,-1.1590003,1.9492371,2.2443285,1.7965357,4.5127701,0.3928101,2.010744,0.9216609,2.6848126,3.024698,4.3888207,1.0699166,13.0035408),(30707,'Bettongia_lesuer-radius.tif',227,3,29,2.938641,7.5480759,7.3204111,1.8,7.5279271,7.4150627,-0.9841324,1.9014166,2.168622,2.2244917,4.5504526,0.3396788,2.0983153,1.1699129,2.8851556,3.4083837,4.3758477,1.023769,13.6421954),(30708,'Bettongia_lesuer-radius.tif',227,3,30,2.7614483,7.5769127,7.2137439,1.8,7.5311257,7.3011986,-0.9518559,1.8641697,2.1353918,1.8886325,4.0554431,0.3053241,1.8991564,1.0131226,2.7627763,3.2352535,4.2635211,0.9681695,20.3619476),(30709,'Bettongia_lesuer-radius.tif',227,3,31,2.5274721,7.6804076,7.0841706,1.8,7.6357882,7.1737837,-0.9999171,1.6584093,2.0049468,1.4991281,3.4644028,0.2982409,1.7279275,0.9039554,2.4494312,2.980172,4.0262506,0.8644411,11.8101889),(30710,'Bettongia_lesuer-radius.tif',227,3,32,2.2950546,7.7849881,6.948374,1.8,7.7331265,7.0328835,-1.0688857,1.5697018,1.8795208,1.1974077,2.8766995,0.2939741,1.5305494,0.7628249,2.1381265,2.8108869,3.6755187,0.9318823,20.1848751),(30711,'Bettongia_lesuer-radius.tif',227,3,33,2.2164403,7.8470457,6.8348673,1.8,7.7917142,6.9100077,-1.1579438,1.4652479,1.779576,1.086768,2.5552268,0.3099394,1.4358627,0.7416957,1.991654,2.6684476,3.4506984,0.9240379,10.5777829),(30712,'Bettongia_lesuer-radius.tif',227,3,34,2.1255715,7.8897176,6.768169,1.8,7.8494574,6.8443783,-1.201256,1.428819,1.7501931,0.9608999,2.4429512,0.3080464,1.3958181,0.6725134,1.7575275,2.5858578,3.534015,1.7385594,10.5846011),(30713,'Bettongia_lesuer-radius.tif',227,3,35,2.1945544,7.8895339,6.7213497,1.8,7.8452375,6.8063613,-1.2386301,1.4447422,1.7432083,0.9605996,2.5276844,0.3268658,1.4500186,0.6648934,1.7116098,2.5903366,3.6218492,1.7423225,10.9218011),(30714,'Bettongia_lesuer-radius.tif',227,3,36,2.2934491,7.8805619,6.7274718,1.8,7.8261155,6.8292184,-1.2964265,1.5005077,1.7863457,1.0002672,2.6806194,0.3541817,1.5006163,0.6666192,1.7050561,2.6329708,3.7584735,1.7740569,11.2822799),(30715,'Bettongia_lesuer-radius.tif',227,3,37,2.379158,7.8505614,6.7663818,1.8,7.7994093,6.8798279,-1.3446985,1.5569181,2.319487,1.1232046,2.9809509,0.3765989,1.2851768,0.7214282,1.4882061,2.701746,3.9196227,1.7949085,11.8579164),(30716,'Bettongia_lesuer-radius.tif',227,3,38,2.6150719,7.7789085,6.8461547,1.8,7.7212838,6.9547248,-1.3734339,1.7016383,1.991328,1.3386663,3.5049727,0.4190876,1.7601183,0.7866927,2.024951,2.8474572,4.0340876,1.7599953,12.5720558),(30717,'Bettongia_lesuer-radius.tif',227,3,39,2.7520083,7.7460367,6.9473104,1.8,7.6789147,7.0855078,-1.3980911,1.7952551,2.156484,1.4937139,4.2920058,0.4451228,1.9902795,0.8320344,2.1832343,2.8342349,4.3098476,1.7809789,13.5274558),(30718,'Bettongia_lesuer-radius.tif',227,3,40,2.9422509,7.7306083,7.1007116,1.8,7.6688772,7.2552387,-1.4211824,1.6713146,2.2992341,1.4600835,5.1759895,0.4794801,2.2511799,0.8736138,2.6202747,2.7142329,4.5567944,1.1650948,13.702874),(30719,'Bettongia_lesuer-radius.tif',227,3,41,3.3949967,7.7017136,7.2651175,1.8,7.6467607,7.3989106,-1.4327884,1.8112141,2.4973882,1.3959449,6.0799238,0.5551241,2.434513,0.7707233,2.9553683,0.313964,1.2993022,1.9472867,2.9412003),(30720,'Bettongia_lesuer-radius.tif',227,3,42,0.4086263,5.961441,7.1608359,1.8,5.9299303,7.1846273,1.1455398,1.2605165,1.4760104,0.0545182,0.183946,0.0565129,0.1246238,0.0432507,0.1296544,1.7643055,2.7297527,1.9283622,9.6484859),(30721,'Bettongia_lesuer-radius.tif',227,3,43,2.3115691,5.5204183,7.6292076,1.8,5.4696142,7.6745993,1.4701588,1.5568516,1.9092141,0.9067501,1.1795096,0.3813728,0.6177985,0.5824255,0.9948393,2.5137669,2.8692288,1.7182335,8.8877889),(30722,'Bettongia_lesuer-radius.tif',227,3,44,2.3335008,5.2137993,7.7681395,1.8,5.3161242,7.7663177,1.1005438,1.657651,2.1707721,1.0852721,1.2460753,0.3090683,0.574024,0.6547048,1.061812,2.6020028,2.7949261,1.7425565,9.0796677),(30723,'Bettongia_lesuer-radius.tif',227,3,45,1.2971441,5.3786779,7.7791563,1.8,5.4432962,7.8150849,-1.3024077,1.699676,1.5220037,0.6218545,0.6826181,0.2009883,0.4484997,0.3658665,0.7520443,2.3885,2.9417896,1.6856729,10.4830133),(30724,'Bettongia_lesuer-radius.tif',227,3,46,1.1650455,5.5047866,7.7569522,1.8,5.5792151,7.7822279,-0.8061177,1.5166306,2.0058499,0.5389983,0.5874542,0.1011092,0.2928705,0.3553919,0.4992999,2.2199,2.4651245,1.1479424,7.5968432),(30725,'Bettongia_lesuer-radius.tif',227,3,47,1.0467209,5.6464071,7.7390067,1.8,5.7595972,7.7230081,-0.5263642,1.2641241,1.3021607,0.4360946,0.5859108,0.0440318,0.4499527,0.3449777,0.704559,2.2514567,2.6197882,2.5238369,9.6087465),(30726,'Bettongia_lesuer-radius.tif',227,3,48,0.9988718,5.7590165,7.7068838,1.8,5.8995591,7.6879074,-0.5539767,1.3708881,1.3375523,0.4118601,0.6070922,0.0460735,0.453883,0.300433,0.685513,2.2102371,2.6770321,2.4602944,9.9402981),(30727,'Bettongia_lesuer-radius.tif',227,3,49,1.0101868,5.789271,7.6849542,1.8,5.9140684,7.6399237,-0.6447032,1.360584,1.3174257,0.3868177,0.6202571,0.0608056,0.4708099,0.2843027,0.6856795,2.0936776,2.5577176,0.9492697,8.2724131),(30728,'Bettongia_lesuer-radius.tif',227,3,50,1.0698263,5.8916469,7.6758542,1.8,6.0413377,7.6123621,-0.6757388,1.1878566,1.3225471,0.3872046,0.7001826,0.0697558,0.5294198,0.3259691,0.7267116,2.0541752,2.6419979,1.0595656,9.0768435),(30729,'Bettongia_lesuer-radius.tif',227,3,51,1.1091897,5.9215468,7.6990446,1.8,6.0906806,7.6235916,-0.724574,1.3507983,1.3419831,0.3964403,0.7313837,0.0812159,0.5450021,0.2934859,0.7765639,2.1943078,2.6659482,1.0032587,9.6388435),(30730,'Bettongia_lesuer-radius.tif',227,3,52,1.1476926,5.9016936,7.7388932,1.8,6.0828456,7.6493913,-0.6941194,1.3216891,1.3270496,0.3694165,0.744996,0.0782779,0.5613928,0.2795034,0.7482892,2.0038245,2.6731949,0.9798783,8.9315223),(30731,'Bettongia_lesuer-radius.tif',227,3,53,1.1187303,5.7936802,7.7664652,1.8,5.9138935,7.6922724,-0.8621848,1.4398665,1.3795379,0.3042471,0.6774912,0.1074886,0.4911001,0.2113023,0.6405188,1.7523768,2.6457311,1.0358413,7.4322372),(30732,'Bettongia_lesuer-radius.tif',227,3,54,1.132962,5.7359027,7.8094251,1.8,5.8678375,7.7588049,-0.8831613,1.421066,1.3445083,0.2986508,0.6278784,0.1127564,0.4669948,0.2101597,0.5505966,1.6491852,2.5645003,0.9645587,6.829328),(30733,'Bettongia_lesuer-radius.tif',227,3,55,1.1036373,5.5858644,7.9223177,1.8,5.6433632,7.9030984,-1.0450983,1.5044024,1.099613,0.2256228,0.4813983,0.1376199,0.4377889,0.149975,0.435455,1.569464,2.2255839,0.9197196,6.207134),(30734,'Bettongia_lesuer-radius.tif',227,3,56,1.0841385,5.4988242,7.9791895,1.8,5.5258778,7.9700141,-1.1173555,0.7494314,1.0647166,0.1877694,0.4395551,0.1460158,0.4128376,0.2505491,0.5850323,1.4750585,2.1746205,0.9971297,6.008437),(30735,'Bettongia_lesuer-radius.tif',227,3,57,1.0578381,5.4340716,8.0174039,1.8,5.4542472,8.0220682,-1.1731687,0.73069,1.0509234,0.1686933,0.3968851,0.1498694,0.3776537,0.2308685,0.5367512,1.4091507,2.0915161,1.0349851,5.8029218),(30736,'Bettongia_lesuer-radius.tif',227,3,58,0.9730126,5.3784247,8.0995902,1.8,5.3975684,8.098801,-1.2235391,0.6780655,1.0128633,0.1497499,0.3552119,0.1433868,0.3507007,0.2208487,0.4962208,1.3451482,2.0497597,1.0703555,5.7302612),(30737,'Bettongia_lesuer-radius.tif',227,3,59,0.9256339,5.323085,8.1948799,1.8,5.3428471,8.1876042,-1.2752746,0.6599275,0.9987679,0.1428815,0.3303442,0.1411869,0.3307517,0.216511,0.4701496,1.3288201,2.0037882,1.1824776,5.6275036),(30738,'Bettongia_lesuer-radius.tif',227,3,60,0.9054311,5.2739971,8.2562814,1.8,5.2920196,8.2498885,-1.2988212,0.6460109,0.9963295,0.1368667,0.31897,0.1400152,0.3201451,0.2118643,0.4525139,1.3077131,1.9831913,1.2087089,5.611043),(30739,'Bettongia_lesuer-radius.tif',227,3,61,0.9065102,5.2340576,8.2828515,1.8,5.2484308,8.2787136,-1.3193167,0.6540227,0.9807371,0.1339973,0.3199167,0.1417298,0.3262002,0.2048817,0.4557089,1.2985822,1.9778089,1.1770981,5.5713036),(30740,'Bettongia_lesuer-radius.tif',227,3,62,0.9165,5.1894432,8.2968533,1.8,5.2006537,8.2943031,-1.321751,0.6614229,0.9650479,0.1369082,0.3254532,0.1434702,0.3372404,0.2069904,0.4692386,1.30764,1.9672007,1.1902899,5.5644854),(30741,'Bettongia_lesuer-radius.tif',227,3,63,0.9278333,5.1512628,8.3173672,1.8,5.1653587,8.3112222,-1.3100087,0.6711047,0.960449,0.1409099,0.3243106,0.1443581,0.3376656,0.209967,0.4724736,1.3227172,1.966197,1.0303768,5.5644854),(30742,'Bettongia_lesuer-radius.tif',227,3,64,0.9557202,5.1166863,8.341161,1.8,5.1275935,8.3335049,-1.3152559,0.696375,0.9715218,0.1478327,0.3306123,0.1491096,0.3403036,0.2122889,0.4819721,1.343755,1.9887576,1.1640493,5.6275036),(30743,'Bettongia_lesuer-radius.tif',227,3,65,0.9672777,5.0808914,8.3542942,1.8,5.0889574,8.3496678,-1.3119737,0.7122254,0.9714725,0.152159,0.3322514,0.1506524,0.342008,0.2136389,0.4877526,1.359532,1.9887576,1.1640493,5.6042248),(30744,'Bettongia_lesuer-radius.tif',227,3,66,1.0101641,5.0503075,8.3579413,1.8,5.0546683,8.3579169,-1.2923917,0.7177531,0.9819536,0.1570946,0.3309442,0.1556449,0.3370264,0.2188699,0.489236,1.3687201,2.0116539,1.0759089,5.6439642),(30745,'Bettongia_lesuer-radius.tif',227,3,67,1.0039419,5.0358532,8.3831924,1.8,5.0391801,8.3836458,-1.2510723,0.7375061,0.9931551,0.1563435,0.3322325,0.1507942,0.3345223,0.2119895,0.4872863,1.3815219,2.0251505,1.0636978,5.6740612),(30746,'Bettongia_lesuer-radius.tif',227,3,68,1.0112533,4.9942866,8.404237,1.8,5.002272,8.4040465,-1.2023242,0.7402721,1.0056726,0.1612897,0.3389072,0.146676,0.3369956,0.2178789,0.4907335,1.3957258,2.0433937,1.0209431,5.6905218),(30747,'Bettongia_lesuer-radius.tif',227,3,69,1.0536866,4.9485102,8.4334714,1.8,4.9478469,8.4418033,-1.1977583,0.7435131,1.0500332,0.1636607,0.3529459,0.1522891,0.3361283,0.2201182,0.4865434,1.4132731,2.0674039,1.0280458,5.7864612),(30748,'Bettongia_lesuer-radius.tif',227,3,70,1.0314565,4.9283082,8.4221386,1.8,4.9252144,8.4276949,-1.1925426,0.7480182,1.0372438,0.1654541,0.3577998,0.1484642,0.3449525,0.2211899,0.4992897,1.4246674,2.0915161,1.0349851,5.7631824),(30749,'Bettongia_lesuer-radius.tif',227,3,71,1.0555041,4.8966315,8.4234119,1.8,4.8932041,8.4359466,-1.1663214,0.7530218,1.0383117,0.1726296,0.3730023,0.1486729,0.3592393,0.2292491,0.5233133,1.4485079,2.1157266,1.0417659,5.8330188),(30750,'Bettongia_lesuer-radius.tif',227,3,72,1.167311,4.8715084,8.4266826,1.8,4.8700549,8.4354934,-1.1247081,0.7594574,1.0621755,0.1819133,0.4057129,0.1583379,0.3819641,0.2395306,0.5461486,1.4536212,2.1746205,0.9971297,5.8892188),(30751,'Bettongia_lesuer-radius.tif',227,3,73,1.1530012,4.8256128,8.4465752,1.8,4.824253,8.4629324,-1.0796566,0.7600257,1.0911419,0.1879899,0.4242874,0.149422,0.3888471,0.2473467,0.5553468,1.4663404,2.1833176,1.0149255,5.9289582),(30752,'Bettongia_lesuer-radius.tif',227,3,74,1.186694,4.8008719,8.4588279,1.8,4.795716,8.471303,-1.0545,0.7595593,1.1176387,0.1885216,0.435083,0.1495822,0.3892877,0.2481986,0.5532711,1.4688728,2.2086672,0.9298397,5.9851582),(30753,'Bettongia_lesuer-radius.tif',227,3,75,1.2039454,4.7887826,8.4564314,1.8,4.7875605,8.4610539,-1.0250213,0.776129,1.1402669,0.1910645,0.4567877,0.1465914,0.4005971,0.2461763,0.5634006,1.4821674,2.2523864,0.8648764,6.0714552),(30754,'Bettongia_lesuer-radius.tif',227,3,76,1.2441923,4.761673,8.4580714,1.8,4.7536983,8.4685108,-0.9693274,0.7746323,1.179358,0.196537,0.4795097,0.1409689,0.4065854,0.2537165,0.5698137,1.4946422,2.2776606,0.8902751,6.150934),(30755,'Bettongia_lesuer-radius.tif',227,3,77,1.2427553,4.7575999,8.451195,1.8,4.7534087,8.454665,-0.9642945,0.7834419,1.1908087,0.1945998,0.4941459,0.1398315,0.4149666,0.2483909,0.5778234,1.4955365,2.2997408,0.9590694,6.1742128),(30756,'Bettongia_lesuer-radius.tif',227,3,78,1.2634214,4.7425823,8.4399727,1.8,4.7357057,8.4444842,-0.9314129,0.7877899,1.2028321,0.1966087,0.5054006,0.1355963,0.4201755,0.24957,0.5818584,1.5082173,2.3171854,0.8884798,6.237231),(30757,'Bettongia_lesuer-radius.tif',227,3,79,1.2938341,4.7213575,8.437844,1.8,4.7128939,8.4417688,-0.8981766,0.7779363,1.2213206,0.1958424,0.5260984,0.1319332,0.4307619,0.2517461,0.5909075,1.4902276,2.3267072,0.9224643,6.2207704),(30758,'Bettongia_lesuer-radius.tif',227,3,80,1.2761905,4.7283857,8.4104848,1.8,4.7202336,8.4141031,-0.8718643,0.7807175,1.2143627,0.2014868,0.5291478,0.1246489,0.4357412,0.258079,0.6014259,1.4902276,2.3437826,0.9129077,6.2837886),(30759,'Bettongia_lesuer-radius.tif',227,3,81,1.2925273,4.7172837,8.3979899,1.8,4.7084638,8.4031763,-0.8362469,0.7650008,1.2338238,0.2084719,0.5394448,0.1186456,0.4372138,0.272512,0.6061514,1.4902276,2.361069,0.9034902,6.323528),(30760,'Bettongia_lesuer-radius.tif',227,3,82,1.3233786,4.6965848,8.4080097,1.8,4.6877814,8.4097135,-0.825324,0.772549,1.2756739,0.2107314,0.5578572,0.1190784,0.4373039,0.2727742,0.6022609,1.4902276,2.3832048,0.9107873,6.3399886),(30761,'Bettongia_lesuer-radius.tif',227,3,83,1.3188677,4.6973428,8.3914905,1.8,4.6924527,8.3901535,-0.8129312,0.7619192,1.3034334,0.2080374,0.5698359,0.1159546,0.4371807,0.2730439,0.5956869,1.4862886,2.4172534,0.9505468,6.4427462),(30762,'Bettongia_lesuer-radius.tif',227,3,84,1.331415,4.6842479,8.3923714,1.8,4.684635,8.3868972,-0.7958256,0.7665213,1.3514155,0.2102915,0.5895505,0.1132649,0.4362467,0.2743453,0.5904759,1.4950821,2.4479278,0.7285489,6.5386856),(30763,'Bettongia_lesuer-radius.tif',227,3,85,1.3225187,4.6965193,8.3734563,1.8,4.7101787,8.3564894,-0.8022769,0.7648258,1.369589,0.2103622,0.6043265,0.1139296,0.4412466,0.2750458,0.593862,1.4902276,2.4856988,0.8253769,6.578425),(30764,'Bettongia_lesuer-radius.tif',227,3,86,1.3259223,4.7049368,8.3564865,1.8,4.7254037,8.3355841,-0.8035487,0.7762687,1.3913625,0.2092452,0.6178597,0.1145037,0.4440681,0.2695526,0.5936948,1.4812564,2.493311,0.8731721,6.6181644),(30765,'Bettongia_lesuer-radius.tif',227,3,87,1.3361515,4.7142927,8.3375315,1.8,4.7384205,8.310388,-0.7969486,0.7688638,1.4105077,0.2080758,0.6289695,0.1139179,0.4459171,0.2706277,0.5926492,1.4797873,2.5114547,0.8645972,6.6579038),(30766,'Bettongia_lesuer-radius.tif',227,3,88,1.3404017,4.7239863,8.3234871,1.8,4.7498707,8.2916662,-0.7933383,0.7645805,1.4334806,0.2077025,0.6396985,0.1134739,0.4462555,0.2716556,0.5892805,1.4826695,2.5328998,0.8717967,6.6976432),(30767,'Bettongia_lesuer-radius.tif',227,3,89,1.3620808,4.7339284,8.3167234,1.8,4.7643278,8.2810597,-0.8027253,0.7518202,1.4617628,0.2090892,0.6574361,0.1174394,0.4497556,0.2781106,0.592248,1.4703579,2.5724933,0.8704637,6.720922),(30768,'Bettongia_lesuer-radius.tif',227,3,90,1.3806745,4.7542401,8.2923872,1.8,4.7897749,8.2513231,-0.8081532,0.7688463,1.7844,0.2120351,0.6817042,0.1202906,0.3820355,0.2757835,0.4998384,1.4966026,2.576174,0.8858343,6.8236796),(30769,'Bettongia_lesuer-radius.tif',227,3,91,1.3937597,4.7775404,8.263007,1.8,4.8172433,8.2148344,-0.82458,0.7684101,1.7670808,0.2118741,0.7102962,0.125239,0.4019602,0.2757305,0.5212202,1.4966026,2.6120912,0.8691711,6.9031584),(30770,'Bettongia_lesuer-radius.tif',227,3,92,1.4317877,4.7998329,8.2350137,1.8,4.8398921,8.1838904,-0.8419145,0.7690134,1.6270109,0.2147329,0.7394806,0.1327735,0.4545025,0.2792317,0.5831506,1.5059002,2.627613,0.7248661,6.9428978),(30771,'Bettongia_lesuer-radius.tif',227,3,93,1.4609673,4.8252412,8.1963278,1.8,4.855985,8.1485277,-0.8491912,0.7619437,1.6431606,0.2186876,0.7573025,0.1372384,0.4608816,0.2870129,0.5919234,1.5100973,2.6419979,0.9060218,6.9826372),(30772,'Bettongia_lesuer-radius.tif',227,3,94,1.4360593,4.8564394,8.1646273,1.8,4.8941488,8.1086254,-0.8619624,0.7683844,1.5084878,0.2202413,0.7505675,0.1379252,0.4975628,0.2866291,0.6435541,1.5100973,2.6594242,0.6730908,7.062116),(30773,'Bettongia_lesuer-radius.tif',227,3,95,1.415767,4.885591,8.1379744,1.8,4.9221834,8.0782653,-0.8808364,0.7681651,1.5122935,0.223849,0.7435219,0.1403638,0.4916518,0.2914074,0.6396687,1.529967,2.6463279,0.8379812,7.0785766),(30774,'Bettongia_lesuer-radius.tif',227,3,96,1.4095392,4.9123327,8.1020001,1.8,4.9440617,8.0426872,-0.8925526,0.769467,1.493581,0.2296414,0.7470502,0.1424424,0.5001739,0.2984421,0.6536671,1.5498367,2.627613,0.8459302,6.9990978),(30775,'Bettongia_lesuer-radius.tif',227,3,97,1.4021875,4.9419675,8.0683209,1.8,4.9762658,8.0064834,-0.8960657,0.7630216,1.4927931,0.2363483,0.7534387,0.1425011,0.5047175,0.309753,0.6622302,1.5568764,2.6303162,0.8610113,6.9690008),(30776,'Bettongia_lesuer-radius.tif',227,3,98,1.4061307,4.9696777,8.0367567,1.8,4.9996053,7.9754341,-0.9113185,0.7759322,1.4912493,0.2471464,0.7610319,0.1463767,0.5103318,0.3185154,0.6757011,1.5697064,2.6303162,0.8610113,7.118316),(30777,'Bettongia_lesuer-radius.tif',227,3,99,1.3918608,5.0012184,8.0010328,1.8,5.0284789,7.9463802,-0.9268942,0.7861888,1.4780615,0.2541426,0.7717249,0.1483758,0.5221196,0.3232589,0.6940242,1.5895761,2.644537,0.7478219,7.088219),(30778,'Bettongia_lesuer-radius.tif',227,3,100,1.3497413,5.0250196,7.9794772,1.8,5.0611427,7.9125243,-0.9304398,0.7966514,1.4973006,0.2577156,0.7632888,0.1446509,0.5097766,0.3234986,0.6813809,1.6063498,2.6552642,0.882833,7.1279584),(30779,'Bettongia_lesuer-radius.tif',227,3,101,1.3307982,5.0587145,7.9440441,1.8,5.0905333,7.8774966,-0.9515516,0.810935,1.4889783,0.2634526,0.7773035,0.1470781,0.5220382,0.3248752,0.6988589,1.6293155,2.6770321,0.8894981,7.144419),(30780,'Bettongia_lesuer-radius.tif',227,3,102,1.3183861,5.0857898,7.9195441,1.8,5.1216267,7.846151,-0.9690306,0.8161315,1.5014204,0.2730321,0.7855445,0.1493143,0.5232009,0.3345443,0.7044856,1.6411124,2.7069505,0.844154,7.6144737),(30781,'Bettongia_lesuer-radius.tif',227,3,103,1.3350259,5.1077926,7.8964675,1.8,5.1450254,7.8179034,-0.9916959,0.8301339,1.6863191,0.2880276,0.8094204,0.155863,0.4799924,0.3469652,0.6493216,1.6678251,2.7280166,0.8509973,7.4651584),(30782,'Bettongia_lesuer-radius.tif',227,3,104,1.3930305,5.1326681,7.864067,1.8,5.1729268,7.7781326,-1.0158764,0.8466025,1.5297184,0.3121146,0.8336817,0.1677215,0.5449903,0.3686672,0.7482395,1.6914681,2.752366,0.8721365,7.5145402),(30783,'Bettongia_lesuer-radius.tif',227,3,105,1.5120957,5.1681956,7.8057849,1.8,5.2005629,7.7314206,-1.0445377,0.8641181,1.4986353,0.3320511,0.8966582,0.1884305,0.5983165,0.3842659,0.8176838,1.7087564,2.7705232,0.8643703,7.4748008),(30784,'Bettongia_lesuer-radius.tif',227,3,106,1.3922499,5.1792598,7.8378406,1.8,5.2123904,7.7550494,-1.0680774,0.882044,1.5709286,0.3439208,0.8712089,0.1781753,0.5545821,0.3899135,0.7712551,1.7536397,2.7998658,0.8991902,7.477625),(30785,'Bettongia_lesuer-radius.tif',227,3,107,1.3789431,5.2153146,7.8307599,1.8,5.2501025,7.7502083,-1.0749643,0.8882073,1.9575288,0.3555689,0.9123554,0.177803,0.4660751,0.400322,0.6476694,1.7848415,2.8158949,0.9412664,7.8420978),(30786,'Bettongia_lesuer-radius.tif',227,3,108,1.3771019,5.2603233,7.8069751,1.8,5.2875373,7.7304985,-1.0911765,0.8937754,2.0274664,0.3671388,0.9526146,0.1806462,0.4698547,0.410773,0.6499697,1.815434,2.8440754,0.9114863,7.7421644),(30787,'Bettongia_lesuer-radius.tif',227,3,109,1.3839271,5.2920975,7.7971801,1.8,5.3191097,7.7177588,-1.1048896,0.9062267,1.7046509,0.3899416,0.9628591,0.1841061,0.5648424,0.4302914,0.7920215,1.8437254,2.8615129,0.9528299,7.6791462),(30788,'Bettongia_lesuer-radius.tif',227,3,110,1.4796057,5.3430831,7.7454874,1.8,5.3674382,7.6725397,-1.1326522,0.9360906,2.1192424,0.4203465,1.0178376,0.2022137,0.4802837,0.4490447,0.6749504,1.8775126,2.8778846,0.9448715,7.7915462),(30789,'Bettongia_lesuer-radius.tif',227,3,111,1.4965825,5.3712952,7.7206163,1.8,5.394823,7.6511297,-1.1630955,0.9485757,2.0763327,0.4515468,1.0826373,0.210217,0.521418,0.4760261,0.7373086,1.916581,2.8915706,0.9720125,7.9175826),(30790,'Bettongia_lesuer-radius.tif',227,3,112,1.521596,5.4108596,7.7064022,1.8,5.4307542,7.6474045,-1.188084,0.9765447,1.5924105,0.4819357,1.1359471,0.2182334,0.7133507,0.4935112,1.0140239,1.9481229,2.9160436,1.012197,7.9669644),(30791,'Bettongia_lesuer-radius.tif',227,3,113,1.5147469,5.4396278,7.7254584,1.8,5.4633547,7.6590621,-1.2026013,1.0088701,1.9491558,0.5121411,1.1369867,0.2197517,0.5833227,0.5076383,0.8460425,1.9877032,2.9349371,1.0385868,8.1861161),(30792,'Bettongia_lesuer-radius.tif',227,3,114,1.5241005,5.4692067,7.7177871,1.8,5.4948446,7.6571652,-1.2150104,1.024023,1.6419745,0.5364225,1.1819161,0.2231964,0.7198139,0.5238383,1.0449284,2.0144731,2.9492955,1.0303768,8.1889403),(30793,'Bettongia_lesuer-radius.tif',227,3,115,1.5301144,5.5003292,7.7187674,1.8,5.527314,7.6496617,-1.2342602,1.0432361,1.6491384,0.5598268,1.2401298,0.2272105,0.7519865,0.5366252,1.0872442,2.0579998,2.9695732,1.056345,8.3081585),(30794,'Bettongia_lesuer-radius.tif',227,3,116,1.5444923,5.5355281,7.6970437,1.8,5.5656133,7.6314489,-1.2373078,1.0529854,1.6431911,0.5868044,1.3061536,0.2298327,0.7948885,0.5572769,1.1491942,2.0971754,2.9835003,1.0481456,8.4602979),(30795,'Bettongia_lesuer-radius.tif',227,3,117,1.5755729,5.5887263,7.6690359,1.8,5.6152846,7.6079353,-1.2580969,1.08387,1.6328139,0.6197088,1.3937401,0.2377447,0.8535817,0.5717557,1.2295101,2.1364807,3.0218934,1.1695675,8.7452919),(30796,'Bettongia_lesuer-radius.tif',227,3,118,1.589849,5.6235658,7.6704918,1.8,5.658613,7.6029569,-1.2874945,1.1093723,1.6583396,0.6621668,1.4215512,0.2442709,0.8572136,0.5968842,1.2551358,2.1868473,3.0394798,0.9827937,8.8275949),(30797,'Bettongia_lesuer-radius.tif',227,3,119,1.6314301,5.6696564,7.6919278,1.8,5.7106125,7.6157386,-1.3042257,1.152441,1.699991,0.7125933,1.4910574,0.2530368,0.8770972,0.6183338,1.2945762,2.248,3.0711385,1.0005584,9.0262919),(30798,'Bettongia_lesuer-radius.tif',227,3,120,1.6836341,5.711095,7.6904177,1.8,5.7502881,7.6114077,-1.3304673,1.1847232,1.7203016,0.7654618,1.5656594,0.2647081,0.9101075,0.6461102,1.3516159,2.3015077,3.1043824,1.0909558,9.2908313),(30799,'Bettongia_lesuer-radius.tif',227,3,121,1.8524952,5.7712148,7.6784099,1.8,5.8122786,7.5925251,-1.3645385,1.2336469,1.7151165,0.8659041,1.7128223,0.2957995,0.9986623,0.701906,1.4817701,2.3604,3.1407958,0.9827937,9.4730677),(30800,'Bettongia_lesuer-radius.tif',227,3,122,1.8854823,5.811334,7.6959,1.8,5.8502087,7.6218937,-1.380622,1.2633652,1.7657623,0.954089,1.7345691,0.3030183,0.9823344,0.7551965,1.4952211,2.4166,3.212876,1.368255,9.5922859),(30801,'Bettongia_lesuer-radius.tif',227,3,123,1.9877956,5.851053,7.7007289,1.8,5.8857223,7.6285329,-1.3874439,1.2978173,1.7623855,1.0553057,1.8544389,0.3202859,1.0522323,0.8131389,1.5948347,2.4769793,3.2436944,0.8405569,9.9664011),(30802,'Bettongia_lesuer-radius.tif',227,3,124,2.04561,5.8866106,7.7091233,1.8,5.9301425,7.6276782,-1.3808276,1.3281589,1.7751201,1.1364861,1.865443,0.3287786,1.0508827,0.8556854,1.6084026,2.529,3.26069,0.9014389,9.8500071),(30803,'Bettongia_lesuer-radius.tif',227,3,125,2.1848823,5.9366601,7.7010226,1.8,5.9717686,7.611316,-1.4160947,1.3707204,1.7669157,1.235971,1.9489056,0.3555014,1.1029987,0.9016945,1.7049665,2.6133,3.3144901,1.2517267,10.2377587),(30804,'Bettongia_lesuer-radius.tif',227,3,126,2.301645,6.0084308,7.7051053,1.8,6.0428006,7.6312159,-1.3747905,1.4345326,1.791224,1.3549842,2.0558972,0.3690577,1.1477611,0.9445475,1.7934219,2.7106669,3.3762124,1.5208379,10.9474196),(30805,'Bettongia_lesuer-radius.tif',227,3,127,2.3452051,6.0904026,7.7106712,1.8,6.1231764,7.6336716,-1.3378304,1.5015636,1.833358,1.451546,2.140589,0.3700349,1.1675783,0.9666897,1.8557165,2.81,3.5102513,1.2363882,11.260171),(30806,'Bettongia_lesuer-radius.tif',227,3,128,2.5030344,6.1412595,7.7347641,1.8,6.1725734,7.6693662,-1.3050454,1.5521901,1.9939504,1.5755821,2.5093979,0.3883973,1.2585057,1.0150703,1.9436327,2.8855347,3.6820652,0.9043985,11.9522014),(30807,'Bettongia_lesuer-radius.tif',227,3,129,2.7106727,6.2285895,7.7334948,1.8,6.2628551,7.6658459,-1.2199456,1.7508511,1.9952682,1.8936284,2.7677786,0.3984113,1.3871712,1.0815474,2.2723597,3.1768115,3.8620893,0.8471751,12.3853408),(30808,'Bettongia_lesuer-radius.tif',227,3,130,2.8459833,6.3485306,7.7093215,1.8,6.3873882,7.6526009,-0.9621516,1.7972326,2.0512775,2.1647684,2.7022441,0.3192695,1.3173469,1.204501,2.370756,3.2596001,3.8220133,1.2257941,12.2223892),(30809,'Bettongia_lesuer-radius.tif',227,3,131,2.9978475,6.4638603,7.7278429,1.8,6.4894282,7.6678141,-1.1861259,1.8645537,2.0775821,2.4651924,2.9497339,0.4292841,1.4197917,1.3221354,2.5935919,3.3390198,3.990299,1.2334568,12.1701832),(30810,'Bettongia_lesuer-radius.tif',227,3,132,3.5542446,6.5607984,7.7265263,1.8,6.5767916,7.7006509,-1.4396871,1.8660192,2.072601,2.9073815,4.0726381,0.5822496,1.964989,1.5580662,3.1287549,3.3439001,4.2668535,1.6763627,12.9938984),(30811,'Bettongia_lesuer-radius.tif',227,3,133,4.2732043,6.577863,7.6816469,1.8,6.5843168,7.624694,-1.4474681,1.8366194,2.1474385,3.3122491,5.2005248,0.7014231,2.421734,1.8034488,3.8049335,3.4810113,4.2632433,1.0688194,14.2944865),(30812,'Bettongia_lesuer-radius.tif',227,3,134,4.52602,6.587946,7.7089151,1.8,6.6352626,7.6172314,-1.5000914,1.8625864,2.2061265,3.3597081,5.123897,0.7505719,2.3225762,1.8037864,3.3887478,3.5184926,4.2926832,1.2304144,13.5394378),(30813,'Bettongia_lesuer-radius.tif',227,3,135,5.0337603,6.685124,7.6481512,1.8,6.7149808,7.5748708,-1.3586791,1.8613082,2.5034453,3.7621775,5.9458765,0.8017749,2.3750774,2.0212545,3.273051,3.4541227,4.5254961,1.2156594,13.5065166),(30814,'Bettongia_lesuer-radius.tif',227,3,136,4.989761,6.775788,7.6007259,1.8,6.7918071,7.5198563,-1.3064701,1.8966371,2.8017439,3.6041343,6.3606659,0.7748631,2.2702524,1.9002762,3.1451086,3.6448354,4.9060058,1.0225184,16.2036321),(30815,'Bettongia_lesuer-radius.tif',227,3,137,4.4819243,6.863653,7.4427599,1.8,6.8198111,7.4662736,-1.4340251,1.8840632,2.5461789,3.0922057,5.9410963,0.7331009,2.3333382,1.6412431,2.9891408,3.5828855,5.209728,0.8808923,19.580796),(30816,'Bettongia_lesuer-radius.tif',227,3,138,4.7267407,6.7916785,7.5475632,1.8,6.8637911,7.4550344,-1.3348373,1.8392257,3.2050389,3.6267581,7.0113318,0.7447366,2.1875965,1.971894,2.8788391,3.5502756,5.3455774,0.90837,16.3642441),(30817,'Bettongia_lesuer-radius.tif',227,3,139,4.3841672,6.9278398,7.4512621,1.8,6.9525787,7.3973195,-1.4790063,1.704852,2.2609483,2.7369004,6.2356775,0.7245554,2.7579921,1.6053596,3.8454339,3.0626632,4.5272406,1.7328838,13.478074),(30818,'Bettongia_lesuer-radius.tif',227,3,140,3.518246,7.0020025,7.7479021,1.8,7.0324804,7.5463962,1.4965332,1.5582678,2.6333226,1.6388716,3.6452697,0.5831464,1.3842853,1.0517265,1.9318578,2.8895804,4.60034,1.8113306,17.8129775),(30819,'Bettongia_lesuer-radius.tif',227,3,141,1.5301905,6.9343407,8.6026067,1.8,6.8601359,8.4970445,0.965249,1.0489576,3.4190044,0.3149502,0.7639997,0.1724008,0.2234568,0.3002507,0.3018701,1.8213731,3.9116573,1.9926676,12.3785226),(30820,'Bettongia_lesuer-radius.tif',227,3,142,1.1486173,6.9831113,8.7997323,1.8,6.9335307,8.6934886,0.9030738,0.781648,2.3097409,0.1748045,0.4343815,0.1180381,0.1880651,0.2236358,0.2608059,1.5100973,1.8929475,3.0374927,5.596922),(30821,'Bettongia_lesuer-radius.tif',227,3,143,0.8359931,7.1352629,8.9288631,1.8,7.1073218,8.9108493,0.7185545,0.6672587,1.8520144,0.0755983,0.1489016,0.0603803,0.0803998,0.1132968,0.117046,1.2791755,1.6416269,3.0214839,4.862328),(30822,'Bettongia_lesuer-radius.tif',227,3,144,0.148378,7.0655511,9.1044598,1.8,7.0731658,9.1096891,0.8163856,0.3243321,1.0052724,0.0018701,0.0366383,0.0131307,0.0364461,0.0057659,0.0381876,0.5694443,1.8960734,2.2617396,4.6278856),(30823,'Bettongia_lesuer-radius.tif',227,3,145,3.8937657,7.7045953,7.2945803,1.8,7.7232624,7.316381,1.3077677,1.8061322,2.6155817,1.8086127,6.9223127,0.6050891,2.6465672,1.0013734,3.2359019,2.9635145,5.0844697,1.8050515,24.4607544),(30824,'Bettongia_lesuer-radius.tif',227,3,146,4.0773286,7.8365282,7.3109926,1.8,7.8598272,7.3299643,1.4445474,1.8929058,2.6772857,1.9616923,8.3908949,0.6687809,3.1341052,1.0363391,3.6323823,2.580861,4.4822804,2.0961632,15.1029109),(30825,'Bettongia_lesuer-radius.tif',227,3,147,3.14141,7.9870145,6.984075,1.8,7.9782399,6.9569809,1.2761025,2.1827216,2.9906273,1.332171,6.6445709,0.4794004,2.2217984,0.6103257,2.646913,4.6586156,6.8455661,1.6859866,33.0278039),(30826,'Bettongia_lesuer-radius.tif',227,3,148,4.0084916,7.6817345,7.1688109,1.8,7.7068532,7.130695,1.3081023,2.2047632,2.9754057,2.3431468,7.1620274,0.6230296,2.4070759,1.0627657,3.0560799,4.8415187,6.9802347,1.7366068,37.2940408),(30827,'Bettongia_lesuer-radius.tif',227,3,149,4.4178772,7.7262924,7.257459,1.8,7.7603912,7.2355808,1.357058,2.0627727,2.91381,2.7369966,8.3630248,0.7031842,2.8701339,1.3268532,3.6002037,4.8814122,7.0737251,1.7183113,33.8225919),(30828,'Bettongia_lesuer-radius.tif',227,3,150,4.2326574,7.8176658,7.1452501,1.8,7.8254298,7.1464137,1.3622233,2.0257961,2.9444406,2.2117982,8.6062849,0.6751967,2.922893,1.0918168,3.5062545,4.7862469,7.1421003,1.72883,52.4393146),(30829,'Bettongia_lesuer-radius.tif',227,3,151,3.8346473,7.8295946,7.1159714,1.8,7.8439554,7.0333117,1.3542894,2.0402033,2.920068,2.0624337,7.9313387,0.6096147,2.7161486,1.0108962,3.2965315,4.666554,7.0588633,1.7307094,51.2654482),(30830,'Bettongia_lesuer-radius.tif',227,3,152,3.4473956,7.8757525,7.1127333,1.8,7.8844207,7.0589114,1.3379974,2.1912881,3.1755393,1.9253644,7.398488,0.5439856,2.3298367,0.8786451,2.8593675,4.5836169,7.1944782,1.5864201,36.7995376),(30831,'Bettongia_lesuer-radius.tif',227,3,153,3.2263168,7.9332558,7.166397,1.8,7.9420202,7.1097545,1.2583749,2.1734315,3.1824023,1.6061631,6.939168,0.4869198,2.1804811,0.7389988,2.6599884,0.20483,0.5689816,2.5672878,1.274485),(30832,'Bettongia_lesuer-radius.tif',227,3,154,3.1138878,7.9996071,7.1680268,1.8,7.9948938,7.0426911,1.305407,2.2363973,3.1663823,1.4738833,6.8271787,0.4832788,2.1561448,0.6590436,2.5873345,0.2452009,0.5847231,2.1854593,1.4663639),(30833,'Bettongia_lesuer-ulna.tif',227,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30834,'Bettongia_lesuer-ulna.tif',227,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30835,'Bettongia_lesuer-ulna.tif',227,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30836,'Bettongia_lesuer-ulna.tif',227,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30837,'Bettongia_lesuer-ulna.tif',227,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30838,'Bettongia_lesuer-ulna.tif',227,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30839,'Bettongia_lesuer-ulna.tif',227,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30840,'Bettongia_lesuer-ulna.tif',227,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30841,'Bettongia_lesuer-ulna.tif',227,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30842,'Bettongia_lesuer-ulna.tif',227,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(30843,'Bettongia_lesuer-ulna.tif',227,4,11,0.0039581,8.138579,7.4448013,1.8,8.1392262,7.4452784,0.6393104,0.0441705,0.1498754,0.0000017,0.0000231,0.0002348,0.0001545,0.0000377,0.0001655,0.1133428,0.3203893,2.4805495,0.6687516),(30844,'Bettongia_lesuer-ulna.tif',227,4,12,0.0553296,7.9907808,7.587537,1.8,7.9911138,7.5823011,0.3088132,0.2310977,0.5207635,0.0006768,0.0029126,0.0008518,0.005593,0.0029285,0.006486,0.4275296,0.8168356,3.0727362,2.3065397),(30845,'Bettongia_lesuer-ulna.tif',227,4,13,0.082125,8.0059413,7.7371329,1.8,8.0018515,7.7358423,-0.1708471,0.4244418,0.4825115,0.002435,0.0038701,0.0003956,0.0080207,0.0057369,0.0102624,0.7668965,1.0182131,2.6532587,3.3425883),(30846,'Bettongia_lesuer-ulna.tif',227,4,14,0.1193501,8.1962991,7.8865866,1.8,8.1901371,7.8821823,0.9818957,0.7697994,0.8545989,0.0047323,0.0129869,0.0137547,0.0151965,0.0061474,0.020038,0.7652848,1.146604,1.8692953,4.3292552),(30847,'Bettongia_lesuer-ulna.tif',227,4,15,0.6766848,8.258649,8.1369373,1.8,8.1767688,8.1322085,-1.2350825,0.9695524,1.150758,0.119722,0.1468056,0.1005404,0.127573,0.1234817,0.2255229,1.7849129,2.1784298,1.6871515,7.032019),(30848,'Bettongia_lesuer-ulna.tif',227,4,16,1.6487763,8.1726606,8.0501212,1.8,8.113813,8.1661482,-0.7703389,1.146537,1.3781194,0.5232112,0.6221137,0.1332604,0.4514222,0.4563404,0.7842597,2.2676339,2.6789486,1.6548086,8.3928011),(30849,'Bettongia_lesuer-ulna.tif',227,4,17,2.4696786,8.0457583,8.0988444,1.8,8.1032876,8.1459344,-0.5366954,1.384066,1.4475388,1.0573334,1.3371291,0.1076066,0.9237259,0.7639328,1.4195039,2.7276289,2.9698391,2.7839294,9.8278981),(30850,'Bettongia_lesuer-ulna.tif',227,4,18,2.9103453,8.0722608,8.1040131,1.8,8.1267606,8.1106061,-0.6943899,1.4974635,1.6716171,1.5183304,2.2665105,0.1986279,1.3558789,1.0139348,2.1028717,2.8740612,3.4033497,0.3191396,10.4761951),(30851,'Bettongia_lesuer-ulna.tif',227,4,19,2.6996124,8.2383742,7.9572383,1.8,8.2602142,7.9795364,-0.534458,1.6068078,1.8031896,1.5943339,2.1386872,0.1167414,1.1860579,0.9922369,2.0113888,3.0072889,3.5093514,0.4206633,10.8996921),(30852,'Bettongia_lesuer-ulna.tif',227,4,20,2.5164044,8.2862581,7.8089902,1.8,8.2977942,7.8564734,-0.6532532,1.7126807,1.8808921,1.6153356,2.0058835,0.1549216,1.0664533,0.9431621,1.8619401,3.0217614,3.4940178,0.5500744,10.6572617),(30853,'Bettongia_lesuer-ulna.tif',227,4,21,2.3985739,8.301952,7.7737703,1.8,8.3094835,7.7831574,-0.654861,1.6565436,1.7957512,1.4561986,2.11458,0.1482881,1.1775462,0.8790585,1.9521735,3.0557956,3.4462334,0.6174059,11.2437104),(30854,'Bettongia_lesuer-ulna.tif',227,4,22,2.3215776,8.2363303,7.7178929,1.8,8.2721213,7.721806,-0.8767998,1.6337472,1.7940844,1.3223203,2.2608791,0.2286341,1.2601855,0.8093788,1.9434995,2.9208428,3.4362521,0.8896698,10.6050557),(30855,'Bettongia_lesuer-ulna.tif',227,4,23,2.2333906,8.1511788,7.6225385,1.8,8.1805066,7.652998,-1.0608859,1.682067,1.9698495,1.1840133,2.4081536,0.283551,1.2225063,0.7039038,1.8018666,2.7362338,3.625009,1.0064452,10.6981709),(30856,'Bettongia_lesuer-ulna.tif',227,4,24,2.2238187,8.0818248,7.554547,1.8,8.100505,7.5980867,-1.0899871,1.6906331,2.1445696,1.1034169,2.7499045,0.2913561,1.282264,0.6526649,1.748337,2.5715458,3.860351,1.0191413,11.4424074),(30857,'Bettongia_lesuer-ulna.tif',227,4,25,2.2839306,8.0009187,7.5592033,1.8,8.0088665,7.6564636,-1.1543277,1.6722805,2.2971458,1.1521843,3.2001758,0.3183619,1.3931096,0.6889899,1.8509872,2.4710046,4.1262054,1.2878194,12.331965),(30858,'Bettongia_lesuer-ulna.tif',227,4,26,2.4538561,7.9316384,7.5537961,1.8,7.9445692,7.6338396,-1.1936273,1.6579945,2.320735,1.2418602,3.6499571,0.3535035,1.5727591,0.7490135,2.0627309,2.4914132,4.2549006,1.357858,12.5675772),(30859,'Bettongia_lesuer-ulna.tif',227,4,27,2.7224895,7.813978,7.5538296,1.8,7.8272655,7.6470883,-1.2031821,1.8055902,2.2627784,1.5012145,4.4664553,0.3951416,1.973881,0.831426,2.4850155,2.6095181,4.3568595,1.4544412,14.1218924),(30860,'Bettongia_lesuer-ulna.tif',227,4,28,2.8186166,7.680007,7.4605159,1.8,7.6833537,7.56625,-1.1509084,1.9611782,2.2501317,1.8120039,4.5461143,0.3917007,2.020377,0.9239364,2.7010958,3.024698,4.3888207,1.0699166,13.0035408),(30861,'Bettongia_lesuer-ulna.tif',227,4,29,2.9406397,7.5493056,7.3196956,1.8,7.5301365,7.4136753,-0.9826473,1.9021429,2.167791,2.2261942,4.5575106,0.3392383,2.1023755,1.1703612,2.8882594,3.4083837,4.3758477,1.023769,13.6421954),(30862,'Bettongia_lesuer-ulna.tif',227,4,30,2.7614483,7.5769127,7.2137439,1.8,7.5311257,7.3011986,-0.9518559,1.8641697,2.1353918,1.8886325,4.0554431,0.3053241,1.8991564,1.0131226,2.7627763,3.2352535,4.2635211,0.9681695,20.3619476),(30863,'Bettongia_lesuer-ulna.tif',227,4,31,2.5274721,7.6804076,7.0841706,1.8,7.6357882,7.1737837,-0.9999171,1.6584093,2.0049468,1.4991281,3.4644028,0.2982409,1.7279275,0.9039554,2.4494312,2.980172,4.0262506,0.8644411,11.8101889),(30864,'Bettongia_lesuer-ulna.tif',227,4,32,2.2950546,7.7849881,6.948374,1.8,7.7331265,7.0328835,-1.0688857,1.5697018,1.8795208,1.1974077,2.8766995,0.2939741,1.5305494,0.7628249,2.1381265,2.8108869,3.6755187,0.9318823,20.1848751),(30865,'Bettongia_lesuer-ulna.tif',227,4,33,2.2164403,7.8470457,6.8348673,1.8,7.7917142,6.9100077,-1.1579438,1.4652479,1.779576,1.086768,2.5552268,0.3099394,1.4358627,0.7416957,1.991654,2.6684476,3.4506984,0.9240379,10.5777829),(30866,'Bettongia_lesuer-ulna.tif',227,4,34,2.1255715,7.8897176,6.768169,1.8,7.8494574,6.8443783,-1.201256,1.428819,1.7501931,0.9608999,2.4429512,0.3080464,1.3958181,0.6725134,1.7575275,2.5858578,3.534015,1.7385594,10.5846011),(30867,'Bettongia_lesuer-ulna.tif',227,4,35,2.1945544,7.8895339,6.7213497,1.8,7.8452375,6.8063613,-1.2386301,1.4447422,1.7432083,0.9605996,2.5276844,0.3268658,1.4500186,0.6648934,1.7116098,2.5903366,3.6218492,1.7423225,10.9218011),(30868,'Bettongia_lesuer-ulna.tif',227,4,36,2.2934491,7.8805619,6.7274718,1.8,7.8261155,6.8292184,-1.2964265,1.5005077,1.7863457,1.0002672,2.6806194,0.3541817,1.5006163,0.6666192,1.7050561,2.6329708,3.7584735,1.7740569,11.2822799),(30869,'Bettongia_lesuer-ulna.tif',227,4,37,2.379158,7.8505614,6.7663818,1.8,7.7994093,6.8798279,-1.3446985,1.5569181,2.319487,1.1232046,2.9809509,0.3765989,1.2851768,0.7214282,1.4882061,2.701746,3.9196227,1.7949085,11.8579164),(30870,'Bettongia_lesuer-ulna.tif',227,4,38,2.6150719,7.7789085,6.8461547,1.8,7.7212838,6.9547248,-1.3734339,1.7016383,1.991328,1.3386663,3.5049727,0.4190876,1.7601183,0.7866927,2.024951,2.8474572,4.0340876,1.7599953,12.5720558),(30871,'Bettongia_lesuer-ulna.tif',227,4,39,2.7520083,7.7460367,6.9473104,1.8,7.6789147,7.0855078,-1.3980911,1.7952551,2.156484,1.4937139,4.2920058,0.4451228,1.9902795,0.8320344,2.1832343,2.8342349,4.3098476,1.7809789,13.5274558),(30872,'Bettongia_lesuer-ulna.tif',227,4,40,2.9422509,7.7306083,7.1007116,1.8,7.6688772,7.2552387,-1.4211824,1.6713146,2.2992341,1.4600835,5.1759895,0.4794801,2.2511799,0.8736138,2.6202747,2.7142329,4.5567944,1.1650948,13.702874),(30873,'Bettongia_lesuer-ulna.tif',227,4,41,3.3949967,7.7017136,7.2651175,1.8,7.6467607,7.3989106,-1.4327884,1.8112141,2.4973882,1.3959449,6.0799238,0.5551241,2.434513,0.7707233,2.9553683,0.313964,1.2993022,1.9472867,2.9412003),(30874,'Bettongia_lesuer-ulna.tif',227,4,42,3.4280225,7.7482561,7.293984,1.8,7.7153621,7.413322,-1.4449196,1.6550061,2.5441977,1.0008165,6.2226628,0.562332,2.4458252,0.6047207,2.8130067,2.4661247,4.9635292,1.4345037,16.2382077),(30875,'Bettongia_lesuer-ulna.tif',227,4,43,2.8431631,7.7989233,7.0166239,1.8,7.7324668,7.2198085,-1.4093234,1.6423527,2.5991749,0.6988557,5.019818,0.4616123,1.9313121,0.4255211,2.0856352,2.1574762,4.9444823,1.2885935,14.1752683),(30876,'Bettongia_lesuer-ulna.tif',227,4,44,2.5040923,7.8147036,6.6497546,1.8,7.7284047,6.8720939,-1.3350263,1.3973161,3.1396458,0.5958721,3.277595,0.394576,1.0439378,0.4264404,1.2091753,2.0841962,5.0094507,1.1975815,14.8548321),(30877,'Bettongia_lesuer-ulna.tif',227,4,45,2.4411249,7.8230998,6.5028448,1.8,7.7359951,6.7008439,-1.3032262,1.3370953,3.1068214,0.5305062,2.8960351,0.3784145,0.9321537,0.3967602,1.1029076,0.1131288,0.1799278,2.2455373,0.4138546),(30878,'Bettongia_lesuer-ulna.tif',227,4,46,2.3255111,7.8335252,6.3540351,1.8,7.7452027,6.5556629,-1.2938316,0.9988625,3.0712001,0.4646607,2.5556138,0.3586062,0.8321222,0.4651899,0.9833833,1.7767616,4.7129322,1.2113278,13.2845408),(30879,'Bettongia_lesuer-ulna.tif',227,4,47,2.1231297,7.8813835,6.1587171,1.8,7.8672022,6.2150171,-1.3327915,0.9102924,3.0918576,0.3988783,1.8614636,0.334186,0.6020535,0.438187,0.7304062,1.6255579,3.1522139,1.3734008,8.3149767),(30880,'Bettongia_lesuer-ulna.tif',227,4,48,2.053772,7.8746044,6.0793075,1.8,7.8574459,6.1511332,-1.3258594,0.8402328,2.9363789,0.3598601,1.7376584,0.322167,0.5917692,0.4282862,0.7134175,1.5406277,3.0364908,1.3752156,7.9806008),(30881,'Bettongia_lesuer-ulna.tif',227,4,49,2.0134236,7.8628083,6.0257397,1.8,7.8341081,6.1269494,-1.32758,0.8025875,3.237595,0.3316186,1.7802717,0.3161085,0.5498747,0.4131869,0.6522724,1.4888768,2.9483583,1.3790082,8.0930008),(30882,'Bettongia_lesuer-ulna.tif',227,4,50,1.9239402,7.8643434,5.9206386,1.8,7.8449049,5.9748592,-1.3228965,0.7774724,2.9106699,0.3056892,1.4352023,0.3013513,0.4930832,0.3931833,0.5981007,1.4457917,2.8712921,1.3638041,7.7257038),(30883,'Bettongia_lesuer-ulna.tif',227,4,51,1.9328073,7.8439969,5.8786467,1.8,7.814267,5.959667,-1.3269871,0.7553269,2.5988524,0.2941857,1.3965975,0.3033623,0.5373901,0.3894813,0.6505871,1.4421959,2.7990196,1.4601391,7.4378856),(30884,'Bettongia_lesuer-ulna.tif',227,4,52,1.9215104,7.8202325,5.8559403,1.8,7.7840643,5.9885385,-1.3390102,0.7442499,2.6700646,0.2848315,1.4642393,0.3033522,0.5483909,0.3827094,0.6550562,1.4329205,2.7464786,1.4477104,7.3186674),(30885,'Bettongia_lesuer-ulna.tif',227,4,53,1.8847622,7.8064955,5.7627039,1.8,7.7851081,5.8399231,-1.3432802,0.7365003,2.648337,0.2792056,1.2545311,0.2981453,0.4737053,0.3790977,0.5791251,1.4449149,2.6943783,1.4347989,7.1829886),(30886,'Bettongia_lesuer-ulna.tif',227,4,54,1.8753828,7.7818183,5.6978699,1.8,7.7637934,5.746996,-1.3407038,0.7267827,2.5963545,0.2781381,1.1319279,0.2963058,0.4359682,0.3826978,0.543051,1.4312456,2.6427449,1.4213806,7.0637704),(30887,'Bettongia_lesuer-ulna.tif',227,4,55,1.8754535,7.7527293,5.6430578,1.8,7.7449962,5.6575959,-1.3377446,0.7273226,1.3346668,0.2809787,1.021741,0.2959038,0.7655401,0.3863192,0.9722973,1.4380436,2.5916062,1.4074302,6.9842916),(30888,'Bettongia_lesuer-ulna.tif',227,4,56,1.8543304,7.7197747,5.6038834,1.8,7.7112269,5.6188449,-1.3400387,0.7240875,1.3108215,0.2808387,0.9729773,0.2928882,0.7422653,0.3878519,0.9508926,1.4313922,2.5461144,1.3820586,6.8650734),(30889,'Bettongia_lesuer-ulna.tif',227,4,57,1.8472258,7.688836,5.5659967,1.8,7.6807443,5.5798347,-1.3392798,0.730239,1.2857891,0.2831845,0.9372459,0.2916618,0.7289266,0.3877971,0.9410158,1.4448416,2.5038977,1.4130276,6.8389704),(30890,'Bettongia_lesuer-ulna.tif',227,4,58,1.8451733,7.6583533,5.5349998,1.8,7.6491607,5.5501852,-1.3335818,0.7322077,1.266348,0.2889472,0.9140653,0.2905462,0.7218121,0.3946247,0.9437324,1.451523,2.4718419,1.4224685,6.8156916),(30891,'Bettongia_lesuer-ulna.tif',227,4,59,1.8250861,7.6296123,5.5013807,1.8,7.6231137,5.515042,-1.3341545,0.7370297,1.2575049,0.2938368,0.8737707,0.2874627,0.6948447,0.398677,0.9263478,1.458747,2.4358017,1.3734008,6.6800128),(30892,'Bettongia_lesuer-ulna.tif',227,4,60,1.8198511,7.5966644,5.4808824,1.8,7.5917568,5.4924016,-1.3355887,0.7421137,1.2294592,0.2993749,0.8495879,0.2868359,0.6910257,0.4034084,0.92581,1.4724733,2.4162733,1.4190312,6.6635522),(30893,'Bettongia_lesuer-ulna.tif',227,4,61,1.8184086,7.5646179,5.4641245,1.8,7.5581003,5.4733906,-1.3298039,0.7462879,1.2093357,0.3029461,0.8285071,0.2858048,0.6850927,0.4059373,0.9330881,1.4840764,2.3752397,1.3803612,6.6073522),(30894,'Bettongia_lesuer-ulna.tif',227,4,62,1.8183305,7.5345686,5.4422259,1.8,7.53015,5.4488482,-1.3209888,0.7521055,1.1817344,0.3100693,0.8049535,0.2845334,0.6811628,0.4122684,0.9330469,1.5064634,2.3424346,1.3898699,6.5908916),(30895,'Bettongia_lesuer-ulna.tif',227,4,63,1.8205457,7.5025462,5.4256797,1.8,7.4971482,5.4318954,-1.3133484,0.7541717,1.1690269,0.3126097,0.7809543,0.2837539,0.6680379,0.4145073,0.9335037,1.5171277,2.310531,1.3376165,6.5278734),(30896,'Bettongia_lesuer-ulna.tif',227,4,64,1.7994642,7.4704191,5.4087801,1.8,7.4642439,5.4139432,-1.3090055,0.7527141,1.1515022,0.3140324,0.7564151,0.2798218,0.6568942,0.4172001,0.9270493,1.5201327,2.2871743,1.3854484,6.5114128),(30897,'Bettongia_lesuer-ulna.tif',227,4,65,1.8030095,7.4393561,5.3964032,1.8,7.4327486,5.4035489,-1.3072819,0.7543264,1.1407326,0.3164672,0.7431905,0.2801133,0.6515029,0.4195362,0.9265182,1.5268574,2.269847,1.3078016,6.4716734),(30898,'Bettongia_lesuer-ulna.tif',227,4,66,1.7901139,7.4085044,5.3854585,1.8,7.4023064,5.3904724,-1.3002698,0.7624335,1.1228605,0.3194079,0.7260659,0.277045,0.6466216,0.4189321,0.9282098,1.539988,2.2427251,1.3045443,6.4154734),(30899,'Bettongia_lesuer-ulna.tif',227,4,67,1.795355,7.3864052,5.3832666,1.8,7.390368,5.411073,-1.3405919,1.4932578,1.8044516,0.3374861,0.7295935,0.2836468,0.4043298,0.2260066,0.4565523,1.5406,2.2232766,1.2090671,6.3921946),(30900,'Bettongia_lesuer-ulna.tif',227,4,68,1.8081409,7.3603328,5.3921623,1.8,7.3738589,5.461295,-1.400319,1.0876209,1.8085911,0.3469155,0.7723599,0.2926831,0.4270506,0.3189673,0.5392842,1.5665789,2.2177648,1.1808785,6.3853764),(30901,'Bettongia_lesuer-ulna.tif',227,4,69,1.7927461,7.317171,5.376704,1.8,7.3109974,5.424386,-1.3106169,0.7716393,1.6046845,0.3224186,0.7251137,0.2790172,0.4518731,0.4178359,0.6437321,1.5665789,2.2000703,1.0785851,6.3689158),(30902,'Bettongia_lesuer-ulna.tif',227,4,70,1.7733607,7.2895166,5.3561816,1.8,7.2799662,5.3787513,-1.2718141,0.7730711,1.4806773,0.317248,0.677947,0.2699178,0.4578628,0.4103736,0.6721199,1.5606272,2.1918,1.1760052,6.3291764),(30903,'Bettongia_lesuer-ulna.tif',227,4,71,1.7602528,7.2654731,5.3452938,1.8,7.2596619,5.3534795,-1.2660834,0.7812708,1.0901553,0.3139623,0.6470956,0.2669683,0.5935811,0.4018611,0.8766788,1.5608474,2.1811466,1.1878976,6.3058976),(30904,'Bettongia_lesuer-ulna.tif',227,4,72,1.7728847,7.240055,5.3409421,1.8,7.234019,5.351007,-1.2696682,0.787967,1.0881839,0.3129562,0.6358691,0.2694873,0.5843397,0.3971692,0.8627372,1.5743701,2.1769794,1.159125,6.2496976),(30905,'Bettongia_lesuer-ulna.tif',227,4,73,1.7604715,7.2133305,5.3446045,1.8,7.2088741,5.3542943,-1.263432,0.7863793,1.0851188,0.3086069,0.6267732,0.2665544,0.5776079,0.3924403,0.852562,1.5675721,2.1753466,1.0724805,6.2099582),(30906,'Bettongia_lesuer-ulna.tif',227,4,74,1.7622707,7.1940087,5.3416667,1.8,7.1887365,5.3529338,-1.2621973,0.7887685,1.0894153,0.3064825,0.6135912,0.2666174,0.5632298,0.3885583,0.8335829,1.5707952,2.1746205,1.130266,6.2099582),(30907,'Bettongia_lesuer-ulna.tif',227,4,75,1.7568221,7.1726326,5.3402937,1.8,7.165247,5.3571562,-1.263671,0.7924647,1.2494268,0.3038754,0.6027021,0.2660422,0.4823829,0.3834561,0.7030797,1.570704,2.1746205,1.130266,6.233237),(30908,'Bettongia_lesuer-ulna.tif',227,4,76,1.7479996,7.1563918,5.3411318,1.8,7.1507058,5.3590555,-1.265453,0.7963153,1.26007,0.300177,0.593662,0.2650047,0.4711341,0.3769574,0.682165,1.5778397,2.1658885,1.1710152,6.177037),(30909,'Bettongia_lesuer-ulna.tif',227,4,77,1.7256377,7.1363013,5.3456482,1.8,7.1301525,5.3618197,-1.2669099,0.7886758,1.2308199,0.2954203,0.5771284,0.2618543,0.4688975,0.3745776,0.6775934,1.5610297,2.1627875,1.1420183,6.120837),(30910,'Bettongia_lesuer-ulna.tif',227,4,78,1.71933,7.1187736,5.3487932,1.8,7.1133322,5.3640552,-1.2697934,0.7941044,1.2298542,0.2929426,0.5655828,0.261367,0.4598779,0.3688969,0.664927,1.5794565,2.1510729,1.2242575,6.1372976),(30911,'Bettongia_lesuer-ulna.tif',227,4,79,1.712377,7.1001191,5.354448,1.8,7.0944218,5.3678503,-1.2623421,0.7928335,1.2302289,0.2919127,0.5532207,0.2590927,0.4496893,0.3681892,0.654136,1.5611889,2.1446395,1.1951561,6.0413582),(30912,'Bettongia_lesuer-ulna.tif',227,4,80,1.6973728,7.0828266,5.3558859,1.8,7.0777219,5.3703148,-1.2652393,0.7915655,1.2761038,0.2867075,0.5413048,0.2572947,0.4241856,0.3622032,0.6238087,1.5455,2.1291198,1.1780357,6.008437),(30913,'Bettongia_lesuer-ulna.tif',227,4,81,1.6680033,7.0659732,5.3598877,1.8,7.0619395,5.3754799,-1.2641005,0.7980382,1.2760994,0.2813009,0.5235767,0.2526608,0.4102946,0.3524905,0.6050498,1.5575118,2.1082492,1.2026656,6.008437),(30914,'Bettongia_lesuer-ulna.tif',227,4,82,1.6634518,7.0532325,5.3574585,1.8,7.0466139,5.373908,-1.2569806,0.7931859,1.0841722,0.2796465,0.5066001,0.2508237,0.467269,0.3525611,0.7211786,1.5455,2.0924597,1.1853025,5.952237),(30915,'Bettongia_lesuer-ulna.tif',227,4,83,1.6511578,7.0393759,5.3652523,1.8,7.0329205,5.3816965,-1.2323676,0.7960113,1.0834989,0.2776191,0.497485,0.2448591,0.4591468,0.3487627,0.7114621,1.5587375,2.0773105,1.1676807,5.9124976),(30916,'Bettongia_lesuer-ulna.tif',227,4,84,1.6703346,7.0249389,5.3715375,1.8,7.018739,5.3879205,-1.2190874,0.7935528,1.0739969,0.277159,0.4904863,0.2453493,0.4566925,0.3492634,0.7125416,1.5455,2.0628157,1.1498058,5.8795764),(30917,'Bettongia_lesuer-ulna.tif',227,4,85,1.6571247,7.0132686,5.378458,1.8,7.0066379,5.3955243,-1.2001494,0.7895915,1.0705663,0.272642,0.4814415,0.239951,0.4497073,0.3452949,0.6989822,1.5587375,2.0497597,1.0703555,5.8631158),(30918,'Bettongia_lesuer-ulna.tif',227,4,86,1.6317002,7.0037101,5.3822122,1.8,6.9977384,5.4018849,-1.1968329,0.7914278,1.0681897,0.2659561,0.4665799,0.2356584,0.436795,0.3360459,0.6840128,1.5736,2.0358446,1.2184876,5.8631158),(30919,'Bettongia_lesuer-ulna.tif',227,4,87,1.607495,6.991337,5.3862042,1.8,6.9823497,5.4065061,-1.1940145,0.7863344,1.0601214,0.2604687,0.4578136,0.2316474,0.4318501,0.3312441,0.6743789,1.5455,2.019489,1.2006255,5.8000976),(30920,'Bettongia_lesuer-ulna.tif',227,4,88,1.5855392,6.9870713,5.3863757,1.8,6.9801694,5.4042955,-1.1882297,0.7795164,1.0481982,0.2549832,0.4410894,0.2274311,0.4208073,0.3271043,0.6639201,1.5455,1.9998437,1.2268272,5.7438976),(30921,'Bettongia_lesuer-ulna.tif',227,4,89,1.5845767,6.9785599,5.3929158,1.8,6.9741776,5.4089077,-1.1870204,0.7794863,1.0389727,0.2516692,0.4321097,0.2270715,0.4159009,0.3228655,0.658059,1.5736,1.9762113,1.0498865,5.727437),(30922,'Bettongia_lesuer-ulna.tif',227,4,90,1.5784603,6.9717147,5.3968382,1.8,6.9633581,5.4160329,-1.1739338,0.7724411,1.0436814,0.2491265,0.4239806,0.2237723,0.4062357,0.3225185,0.6447819,1.5455,1.9778089,1.1770981,5.7109764),(30923,'Bettongia_lesuer-ulna.tif',227,4,91,1.571402,6.9685948,5.3938864,1.8,6.9615903,5.4097107,-1.1615798,0.7638517,1.0341691,0.2455316,0.4155538,0.2204371,0.4018238,0.3214388,0.6391243,1.5455,1.9672007,1.1902899,5.6547764),(30924,'Bettongia_lesuer-ulna.tif',227,4,92,1.5669829,6.9670776,5.3912905,1.8,6.9596341,5.4065809,-1.1459707,0.7642737,1.033033,0.2419446,0.4102223,0.216798,0.3971047,0.316568,0.6311387,1.5584413,1.9629816,1.1583859,5.6945158),(30925,'Bettongia_lesuer-ulna.tif',227,4,93,1.5441941,6.9660134,5.3883376,1.8,6.9570322,5.4056079,-1.130216,0.7632366,1.0235203,0.2389456,0.3997262,0.2105581,0.3905406,0.3130688,0.6238802,1.5459745,1.948852,1.0749018,5.6479582),(30926,'Bettongia_lesuer-ulna.tif',227,4,94,1.5213887,6.9628742,5.3865641,1.8,6.9567991,5.4012884,-1.1169991,0.7584099,1.0110705,0.2332288,0.3914012,0.2048351,0.3871156,0.3075234,0.616631,1.5334363,1.9372704,1.152572,5.615037),(30927,'Bettongia_lesuer-ulna.tif',227,4,95,1.4949781,6.9578158,5.3835859,1.8,6.9523827,5.3973534,-1.0952346,0.7532282,0.9984445,0.2287251,0.3818542,0.1969346,0.3824491,0.3036598,0.6084234,1.5208981,1.9276682,1.0353768,5.5985764),(30928,'Bettongia_lesuer-ulna.tif',227,4,96,1.4706102,6.9567138,5.3854933,1.8,6.9512133,5.3979226,-1.0898058,0.7646842,0.9832869,0.2250548,0.3761639,0.1926372,0.3825576,0.2943108,0.60997,1.5165891,1.9151341,1.1793912,5.5259158),(30929,'Bettongia_lesuer-ulna.tif',227,4,97,1.4500832,6.9561301,5.3809607,1.8,6.9492362,5.3932511,-1.0807582,0.7623098,0.9735679,0.2222371,0.3674884,0.1881434,0.3774656,0.2915312,0.6047376,1.5082173,1.9002333,1.1600794,5.5122794),(30930,'Bettongia_lesuer-ulna.tif',227,4,98,1.4313226,6.9566339,5.3770394,1.8,6.9512643,5.3856408,-1.0884892,0.7607361,0.9658182,0.2178134,0.3635453,0.187233,0.3764118,0.2863193,0.6008659,1.508146,1.8891896,1.0405806,5.5122794),(30931,'Bettongia_lesuer-ulna.tif',227,4,99,1.4270423,6.9556576,5.3728623,1.8,6.950848,5.3801746,-1.0804616,0.7580861,0.9590371,0.2180489,0.36169,0.1850953,0.3771387,0.2876308,0.6024933,1.4958218,1.8946153,0.9539951,5.5122794),(30932,'Bettongia_lesuer-ulna.tif',227,4,100,1.4077845,6.9555128,5.3638129,1.8,6.9506163,5.3714831,-1.0693481,0.7537394,0.9542068,0.2150519,0.3568422,0.1804149,0.3739674,0.2853133,0.5988506,1.4957505,1.8946153,0.9539951,5.4958188),(30933,'Bettongia_lesuer-ulna.tif',227,4,101,1.3975986,6.9612828,5.3537944,1.8,6.9598691,5.3621797,-1.0557598,0.7537519,0.9629764,0.2123146,0.3584043,0.1764184,0.3721839,0.281677,0.592223,1.4957505,1.8996099,1.0608243,5.4958188),(30934,'Bettongia_lesuer-ulna.tif',227,4,102,1.3707103,6.9710321,5.3400351,1.8,6.9710887,5.3504039,-1.0464258,0.7550628,0.958869,0.208745,0.3522698,0.171186,0.3673805,0.2764605,0.5847481,1.4890488,1.8883535,0.9332475,5.4958188),(30935,'Bettongia_lesuer-ulna.tif',227,4,103,1.3370427,6.9711449,5.3264486,1.8,6.9691213,5.3363774,-1.0425864,0.7481307,0.9667237,0.205121,0.3515425,0.1662381,0.3636432,0.2741781,0.5749338,1.4848393,1.9035547,1.0278452,5.4793582),(30936,'Bettongia_lesuer-ulna.tif',227,4,104,1.3043486,6.974851,5.3133665,1.8,6.9731452,5.3252838,-1.0391886,0.7444833,0.9697572,0.1986201,0.3493817,0.1615289,0.3602776,0.2667891,0.5650669,1.4765873,1.9095599,0.995038,5.4560794),(30937,'Bettongia_lesuer-ulna.tif',227,4,105,1.2669337,6.9764906,5.2954947,1.8,6.9735687,5.3108724,-1.0321002,0.7408733,0.9858503,0.1932474,0.3472115,0.1555823,0.352195,0.2608373,0.5480573,1.4744066,1.9331902,1.0029523,5.5190976),(30938,'Bettongia_lesuer-ulna.tif',227,4,106,1.2456455,6.9791313,5.2808518,1.8,6.9763704,5.2937333,-1.0235575,0.7351817,0.990115,0.1884573,0.350313,0.1513989,0.3538104,0.2563411,0.5441488,1.4704053,1.9421553,1.0229328,5.4958188),(30939,'Bettongia_lesuer-ulna.tif',227,4,107,1.2330577,6.9865612,5.2664022,1.8,6.9823837,5.2815421,-1.007721,0.7302572,1.2099489,0.1858761,0.3544467,0.1469536,0.2929435,0.2545351,0.4370195,1.4618952,1.9484468,0.9907936,5.4958188),(30940,'Bettongia_lesuer-ulna.tif',227,4,108,1.2172929,6.9947268,5.2471237,1.8,6.9870318,5.2668687,-0.9971574,0.728259,1.1623837,0.1812568,0.3618054,0.1431304,0.3112616,0.2488905,0.4532305,1.4449871,1.963987,0.9788255,5.5190976),(30941,'Bettongia_lesuer-ulna.tif',227,4,109,1.2100415,7.0052359,5.2198724,1.8,7.0001534,5.2370133,-0.9834949,0.7280646,1.0621281,0.1817419,0.3716911,0.1397507,0.3499494,0.2496234,0.4994654,1.449771,1.9873674,0.9867153,5.5190976),(30942,'Bettongia_lesuer-ulna.tif',227,4,110,1.1865207,7.018562,5.1893342,1.8,7.0102757,5.2103705,-0.9680101,0.7289987,1.0605216,0.1793617,0.3808765,0.1341914,0.3591408,0.2460385,0.4950151,1.4467004,2.0145956,1.0447299,5.5752976),(30943,'Bettongia_lesuer-ulna.tif',227,4,111,1.1508783,7.0215513,5.158265,1.8,7.0124234,5.1776587,-0.9583279,0.7265531,1.0903779,0.1755166,0.3850168,0.1284194,0.353104,0.2415744,0.4909536,1.4206732,2.0350687,0.952152,5.6615946),(30944,'Bettongia_lesuer-ulna.tif',227,4,112,1.1176242,7.0273614,5.123324,1.8,7.018844,5.1460261,-0.9796983,0.7239266,1.0781463,0.1723233,0.3923706,0.1284237,0.3639308,0.2380397,0.4964962,1.4200388,2.0811081,0.9678136,5.787631),(30945,'Bettongia_lesuer-ulna.tif',227,4,113,1.1202899,7.0409245,5.0831575,1.8,7.0316383,5.1060723,-0.9736008,0.7281304,1.2141213,0.1731932,0.4095706,0.1276738,0.3373391,0.2378601,0.467624,1.4125451,2.1202004,0.9644134,5.8370128),(30946,'Bettongia_lesuer-ulna.tif',227,4,114,1.1680517,7.0470425,5.0468654,1.8,7.0368928,5.0747672,-0.9703755,0.7197953,1.1274637,0.181082,0.440412,0.1325323,0.3906219,0.2515743,0.5503407,1.4175027,2.1541908,1.0370881,5.9397704),(30947,'Bettongia_lesuer-ulna.tif',227,4,115,1.1889942,7.0591855,5.0004031,1.8,7.0474696,5.0296501,-0.9607774,0.734029,1.1557365,0.1878608,0.4664428,0.1331287,0.4035892,0.2559311,0.5633678,1.4261642,2.1984547,0.9579761,6.0822674),(30948,'Bettongia_lesuer-ulna.tif',227,4,116,1.2166516,7.0678742,4.96182,1.8,7.0585585,4.9893913,-0.9546219,0.7342003,1.1752778,0.1996401,0.4814817,0.1350507,0.4096748,0.271915,0.574247,1.4332258,2.2312533,1.028217,6.1452856),(30949,'Bettongia_lesuer-ulna.tif',227,4,117,1.2446414,7.0736588,4.9389162,1.8,7.0648963,4.9650673,-0.9660385,0.7419458,1.1760417,0.2100584,0.5131192,0.1403823,0.4363104,0.2831183,0.6105913,1.4738158,2.2795665,1.0409473,6.327522),(30950,'Bettongia_lesuer-ulna.tif',227,4,118,1.273561,7.0797649,4.9037123,1.8,7.0655853,4.9315054,-0.9739158,0.7672729,1.2022003,0.2197147,0.552114,0.1452035,0.459253,0.286358,0.6395672,1.4967219,2.3422661,1.0427219,6.5494978),(30951,'Bettongia_lesuer-ulna.tif',227,4,119,1.3250313,7.0930291,4.8499858,1.8,7.0788708,4.8838033,-0.9684373,0.7804843,1.2302372,0.2363527,0.5883572,0.1499446,0.4782469,0.3028283,0.6670487,1.5184808,2.3772335,0.9959077,6.7180978),(30952,'Bettongia_lesuer-ulna.tif',227,4,120,1.3799227,7.105786,4.8184014,1.8,7.0854253,4.8548177,-0.9546262,0.7959328,1.2454349,0.2576614,0.6300323,0.153175,0.5058734,0.3237226,0.7066202,1.569661,2.4139847,1.1383886,7.0263706),(30953,'Bettongia_lesuer-ulna.tif',227,4,121,1.4222461,7.1095114,4.7714729,1.8,7.0784331,4.8169293,-0.9764485,0.8364903,1.2903088,0.2802846,0.6547122,0.1627133,0.5074074,0.3350721,0.7239033,1.6247849,2.4907762,1.152572,7.5486313),(30954,'Bettongia_lesuer-ulna.tif',227,4,122,1.5055671,7.1120921,4.7556726,1.8,7.088186,4.7918121,-0.9411073,0.8695934,1.3922509,0.321637,0.7029122,0.1639072,0.5048747,0.3698706,0.6829036,1.6736704,2.5510715,0.8633648,7.7513223),(30955,'Bettongia_lesuer-ulna.tif',227,4,123,1.5252972,7.1142482,4.7058616,1.8,7.0817888,4.7476996,-0.9478309,0.9123595,1.347717,0.3396146,0.7536914,0.1676786,0.5592356,0.3722377,0.810136,1.7502879,2.6090665,1.18429,8.0226799),(30956,'Bettongia_lesuer-ulna.tif',227,4,124,1.5994021,7.114386,4.6558694,1.8,7.095934,4.6938411,-0.9715076,0.9308337,1.3893583,0.3736991,0.8400298,0.1817565,0.6046171,0.401467,0.8304994,1.8179984,2.7284507,1.0056469,8.3133223),(30957,'Bettongia_lesuer-ulna.tif',227,4,125,1.7632104,7.1417862,4.563353,1.8,7.1274625,4.5913391,-0.97447,0.966731,1.5054536,0.4424204,1.0169869,0.2011817,0.6755352,0.4576459,0.9449098,1.9215999,2.985749,0.9592994,8.7833769),(30958,'Bettongia_lesuer-ulna.tif',227,4,126,1.9742811,7.1643256,4.490345,1.8,7.1439964,4.5337214,-0.940958,1.0804409,1.6173587,0.5869471,1.3239625,0.2148881,0.8185954,0.5432478,1.1802855,2.0863186,3.172439,0.999991,9.1234011),(30959,'Bettongia_lesuer-ulna.tif',227,4,127,2.1580507,7.1819044,4.4391851,1.8,7.1367685,4.5147411,-0.8611292,1.1764521,1.772717,0.7505342,1.5545308,0.2069721,0.8769199,0.6379641,1.2984989,2.2173621,3.2993278,0.9426262,9.6672861),(30960,'Bettongia_lesuer-ulna.tif',227,4,128,2.2872341,7.1809714,4.468106,1.8,7.1380624,4.5409032,-0.8059151,1.2041609,1.6841597,0.8349251,1.7530555,0.1984218,1.0409081,0.6933667,1.5266843,2.2722696,3.2666175,0.9565468,9.7194921),(30961,'Bettongia_lesuer-ulna.tif',227,4,129,2.5110359,7.1746604,4.4549591,1.8,7.1380193,4.5354398,-0.8188994,1.2168478,1.6726205,0.890102,1.8070497,0.223263,1.0803704,0.7314818,1.6005459,2.2758977,3.2675842,1.018578,9.3453769),(30962,'Bettongia_lesuer-ulna.tif',227,4,130,2.6976128,7.1724429,4.4467013,1.8,7.1404519,4.5063902,-0.8635633,1.2187593,1.6635846,0.9356844,1.8603436,0.2598013,1.1182741,0.7677352,1.6764429,2.3184493,3.2586309,1.0067126,9.3714799),(30963,'Bettongia_lesuer-ulna.tif',227,4,131,2.7520232,7.1411097,4.4877493,1.8,7.1438876,4.5012946,-0.8206945,1.2452838,1.6849948,0.9749142,1.8557582,0.2455112,1.1013436,0.7828851,1.6701831,2.4140246,3.3518012,0.9641912,10.1883769),(30964,'Bettongia_lesuer-ulna.tif',227,4,132,2.2170175,7.1012795,4.5672698,1.8,7.1290089,4.5369391,-0.6586031,1.2414369,1.5680367,0.7445673,1.2553864,0.1384009,0.8006103,0.5997625,1.2318193,2.4042338,3.1772888,0.8919118,9.4634253),(30965,'Bettongia_lesuer-ulna.tif',227,4,133,2.158695,7.3820179,4.1724336,1.8,7.2780982,4.3329762,-0.9968131,1.1527732,1.8380785,0.6812102,1.2483444,0.2537083,0.6791573,0.5909317,1.0489356,2.2600127,3.1754244,0.9361445,9.1988859),(30966,'Bettongia_lesuer-ulna.tif',227,4,134,2.4294326,7.1596241,4.399956,1.8,7.1678237,4.4269818,-0.6941747,1.4088654,1.55725,0.8023183,1.3203785,0.1657204,0.8478912,0.5694784,1.3537898,2.2850156,3.1598447,0.7665325,9.1824253),(30967,'Bettongia_lesuer-ulna.tif',227,4,135,1.618958,7.2469754,4.3421785,1.8,7.2143417,4.3938493,-0.65377,1.9426788,1.5081097,0.4869388,0.9812395,0.0998053,0.650642,0.2506533,0.7460387,2.0904832,2.8530843,0.6947383,8.4149101),(30968,'Bettongia_lesuer-ulna.tif',227,4,136,1.3195502,7.2616299,4.4383061,1.8,7.2574356,4.4824686,-0.3744955,1.6243831,1.2650923,0.3289715,0.5120381,0.0294286,0.4047437,0.2025208,0.4361316,2.0363894,2.4089093,0.295926,8.4779283),(30969,'Bettongia_lesuer-ulna.tif',227,4,137,0.9957877,7.1799883,4.4943822,1.8,7.1781468,4.5029459,-0.4639799,1.7419979,1.0568462,0.1896018,0.2455933,0.0332371,0.2323832,0.1088416,0.2281364,1.7833489,2.0145956,1.0447299,8.1327403),(30970,'Bettongia_lesuer-ulna.tif',227,4,138,0.8570011,7.1665848,4.532147,1.8,7.1797674,4.5674111,0.7572981,1.2059125,2.139881,0.1699786,0.1752377,0.0674052,0.0818913,0.1409543,0.1613208,1.4743019,2.1510729,0.99004,6.5647886),(30971,'Bettongia_lesuer-ulna.tif',227,4,139,0.8043208,7.1511683,4.5060568,1.8,7.1367391,4.5355122,-0.9355563,0.7651714,1.1728969,0.0865796,0.172703,0.0868547,0.1472448,0.1131506,0.216765,1.3910273,2.2289518,0.9827937,7.084225),(30972,'Bettongia_lesuer-ulna.tif',227,4,140,0.944492,7.0962563,4.5098325,1.8,7.0640154,4.5257239,-0.9209657,0.7671389,1.2366061,0.1124747,0.2111271,0.0997876,0.1707311,0.1466159,0.2518091,1.4737007,2.3491668,0.9296876,7.9147584),(30973,'Bettongia_lesuer-ulna.tif',227,4,141,0.5009099,7.1477403,4.4820766,1.8,7.1609587,4.4598343,1.4431966,0.5840021,0.8908578,0.0338215,0.036219,0.0821331,0.0406563,0.0579134,0.0765667,1.0682403,1.1534699,0.5947593,3.6003095),(30974,'Bettongia_lesuer-ulna.tif',227,4,142,6.169132,7.8697984,5.9897846,1.8,7.8686076,6.0524202,-1.2828119,2.5486428,3.8160318,6.3367359,24.8267404,0.9452473,6.5059051,2.4863177,8.1591688,2.8632567,3.7691728,1.6155426,16.6692082),(30975,'Bettongia_lesuer-ulna.tif',227,4,143,5.7759935,7.9820654,6.2129222,1.8,7.9903024,6.2597914,-1.2895032,2.4127637,3.6098097,5.5516316,21.9795294,0.8884818,6.0888333,2.3009429,7.2117078,2.9505001,6.7538864,1.4035957,26.5942155),(30976,'Bettongia_lesuer-ulna.tif',227,4,144,5.3210249,8.0908922,6.3070727,1.8,8.0891094,6.3846826,-1.3260129,2.3707839,3.4767086,5.6302722,19.0023085,0.834752,5.4656029,2.3748568,6.4728519,3.113962,6.6848478,1.4146315,28.5816702),(30977,'Bettongia_lesuer-ulna.tif',227,4,145,5.3787806,8.1068873,6.5376207,1.8,8.1372863,6.5654849,-1.3388518,2.3281549,3.4595512,5.9610846,18.1935145,0.8490939,5.2589233,2.560433,6.1283278,2.9635145,5.0844697,1.8050515,24.4607544),(30978,'Bettongia_lesuer-ulna.tif',227,4,146,5.3449965,8.2133288,6.8302207,1.8,8.2845459,6.7786992,-1.3881707,2.2459654,3.6539036,5.7551361,17.6866866,0.8614504,4.8404908,2.5624331,5.7241045,2.580861,4.4822804,2.0961632,15.1029109),(30979,'Bettongia_lesuer-ulna.tif',227,4,147,5.6511757,8.3886401,6.1545576,1.8,8.4986094,6.1583432,1.4592925,2.6185144,3.6936719,5.7895522,20.7227655,0.9302008,5.6103427,2.2110065,7.1574144,4.6586156,6.8455661,1.6859866,33.0278039),(30980,'Bettongia_lesuer-ulna.tif',227,4,148,7.0417322,8.3063589,6.2023676,1.8,8.4084927,6.2863418,-1.4620821,2.683141,3.4753233,9.0830876,26.4149701,1.1598058,7.6007231,3.3852442,9.3029805,4.8415187,6.9802347,1.7366068,37.2940408),(30981,'Bettongia_lesuer-ulna.tif',227,4,149,7.5928397,8.2898653,6.3611943,1.8,8.4069461,6.4567781,-1.5206061,2.560424,3.4986631,9.6172789,29.58566,1.2622882,8.4562757,3.7561275,10.4187283,4.8814122,7.0737251,1.7183113,33.8225919),(30982,'Bettongia_lesuer-ulna.tif',227,4,150,7.05735,8.3538848,6.4685503,1.8,8.4786069,6.4881987,1.5446305,2.5626374,3.5630327,8.8101534,26.0836912,1.1754199,7.3206432,3.4379244,9.2221113,4.7862469,7.1421003,1.72883,52.4393146),(30983,'Bettongia_lesuer-ulna.tif',227,4,151,6.7410714,8.4533572,6.2868857,1.8,8.5813233,6.3682943,-1.5141464,2.6027805,3.709317,8.7430682,26.801422,1.1199102,7.2254331,3.3591262,8.8748601,4.666554,7.0588633,1.7307094,51.2654482),(30984,'Bettongia_lesuer-ulna.tif',227,4,152,6.4645214,8.5668064,6.3603888,1.8,8.6424849,6.4768421,1.5661277,2.8951207,3.7324732,7.8616133,28.4580901,1.0773967,7.6244594,2.7154699,9.2189961,4.5836169,7.1944782,1.5864201,36.7995376),(30985,'Bettongia_lesuer-ulna.tif',227,4,153,6.34613,8.6265354,6.3686513,1.8,8.6906069,6.5047908,1.5371891,2.9782767,3.7577543,7.3299703,29.4425798,1.0564942,7.835153,2.4611448,9.4031761,4.6448528,7.3137775,1.6169174,37.3241378),(30986,'Bettongia_lesuer-ulna.tif',227,4,154,6.1028869,8.67006,6.3249882,1.8,8.7344509,6.4084052,-1.5643265,2.9600781,3.8127677,6.6164117,30.1845783,1.0171052,7.9167106,2.2352153,9.3239371,2.7018829,6.0238956,1.0319768,16.7736201),(30987,'metacarpal.tif',227,5,1,5.8999661,2.5998743,3.5210293,1.8,2.5998743,3.5210293,1.4198348,1.6183915,1.9805535,2.4690629,7.2636103,0.961088,3.6674648,1.5256277,4.2107782,4.4827531,7.1601536,0.8298134,32.1892824),(30988,'metacarpal.tif',227,5,2,5.9291817,2.6281191,3.5440878,1.8,2.6281191,3.5440878,1.4048121,1.6360819,2.0117099,2.3565542,6.9513645,0.9612205,3.4554508,1.4403644,3.9919132,2.9562729,6.2521712,1.2078174,23.180621),(30989,'metacarpal.tif',227,5,3,5.8794363,2.6376036,3.5898977,1.8,2.6376036,3.5898977,1.3648084,1.6131533,2.0722408,2.2420659,6.4043632,0.9389124,3.0905497,1.3898654,3.7060994,2.9418136,6.2521712,1.2078174,23.5972998),(30990,'metacarpal.tif',227,5,4,5.8336389,2.6273957,3.600904,1.8,2.6273957,3.600904,1.361838,1.5812876,1.9213241,2.2541857,6.1198339,0.9304345,3.1852168,1.425538,3.558211,3.1935943,6.2131509,1.2247301,27.8720093),(30991,'metacarpal.tif',227,5,5,5.823374,2.5992862,3.6041423,1.8,2.5992862,3.6041423,1.3842451,1.6292801,1.9080573,2.2832223,6.1731387,0.9371755,3.2353004,1.4013688,3.472767,3.1191001,6.0909627,1.8560667,25.7380636),(30992,'metacarpal.tif',227,5,6,5.8138986,2.5856885,3.5858585,1.8,2.5856885,3.5858585,1.3973276,1.7016481,1.9181589,2.4732317,6.3017504,0.9401163,3.285312,1.4534331,3.5100201,3.031013,5.9921563,1.7930258,24.1854028),(30993,'metacarpal.tif',227,5,7,6.0326206,2.5660707,3.6174153,1.8,2.5660707,3.6174153,1.3947536,1.7858656,1.9117806,2.6419403,6.3474573,0.9745978,3.3201808,1.4793613,3.5655172,2.9630207,5.9403428,1.8536444,19.277687),(30994,'metacarpal.tif',227,5,8,6.2418673,2.5736152,3.6331008,1.8,2.5736152,3.6331008,1.4106815,1.7538434,1.9499877,2.8538674,6.6705643,1.0138681,3.4208237,1.6272076,3.7677854,3.0055955,4.9154925,2.1112158,21.0965417),(30995,'metacarpal.tif',227,5,9,6.2639763,2.6176357,3.5979477,1.8,2.6176357,3.5979477,1.4958855,1.8955189,1.9034434,2.9120735,7.1528013,1.0381485,3.7578219,1.5362936,3.9066405,2.5531271,4.1084661,2.4871481,13.5751832),(30996,'metacarpal.tif',227,5,10,6.0713115,2.7118273,3.652218,1.8,2.7118273,3.652218,1.4751979,2.2028069,1.9858038,2.9073147,7.0845697,1.0026657,3.5676081,1.3198228,3.6458833,2.5343152,4.2568487,2.24863,14.4494501),(30997,'metacarpal.tif',227,5,11,5.7862623,2.8113537,3.6515583,1.8,2.8113537,3.6515583,1.3832781,2.5355999,2.064723,2.902635,7.235958,0.9308622,3.5045659,1.1447527,3.463763,2.9532443,4.4326804,2.2574179,17.4303897),(30998,'metacarpal.tif',227,5,12,5.4104079,2.8954975,3.4861758,1.8,2.8954975,3.4861758,1.3194819,2.5010405,2.1893115,3.0105059,6.783588,0.845971,3.0985028,1.2037014,3.5533632,4.5535058,6.3684794,1.9791643,29.6306699),(30999,'metacarpal.tif',227,5,13,5.6291299,2.8613518,3.404834,1.8,2.8613518,3.404834,1.1778721,2.6398987,2.4872953,3.2679438,6.3965485,0.8006444,2.5716884,1.237905,3.4341626,4.6726869,6.4491185,2.0071603,32.0183428),(31000,'metacarpal.tif',227,5,14,6.5371814,2.6888636,3.5124559,1.8,2.6888636,3.5124559,1.2912588,2.7385982,2.2665154,4.7338075,7.0142412,1.0065876,3.0947247,1.7285513,4.0027346,4.116918,6.4059373,0.7357496,27.8327545),(31001,'metacarpal.tif',227,5,15,7.0993838,2.6458849,3.5717191,1.8,2.6458849,3.5717191,1.3157135,2.7685086,2.1756902,5.2878058,8.1140741,1.1078965,3.7294254,1.9099835,4.4597013,4.9879401,6.4216955,2.0285732,33.6697672),(31002,'metacarpal.tif',227,5,16,7.5739394,2.6614028,3.5483574,1.8,2.6614028,3.5483574,1.3175657,2.7454631,2.1909028,5.6245243,8.5877766,1.1830914,3.9197433,2.0486614,4.7714901,4.8804188,6.4730716,2.0150289,33.3626642),(31003,'metacarpal.tif',227,5,17,7.6829056,2.6757063,3.5713426,1.8,2.6757063,3.5713426,1.3163937,2.7387566,2.1672592,5.7573931,8.0424668,1.1993829,3.710893,2.1021923,4.6288476,4.9010614,6.4851976,2.0189413,31.1440759),(31004,'metacarpal.tif',227,5,18,0.5653608,3.0547762,3.8790952,1.8,3.0547762,3.8790952,0.9729955,1.4435327,2.437362,0.0613759,0.2772931,0.0643783,0.1137677,0.0425178,0.1387447,0.6851755,1.3314182,0.8003224,3.8977701),(31005,'metacarpal.tif',227,5,19,2.8252247,2.6930371,3.3651203,1.8,2.6930371,3.3651203,1.1438661,0.9664432,1.6315439,0.5254508,1.7782843,0.3901348,1.0899396,0.5436954,1.3381756,1.832512,3.020456,2.3693516,10.866771),(31006,'metacarpal.tif',227,5,20,4.1699306,2.588946,3.4086668,1.8,2.588946,3.4086668,1.1623541,1.1885157,1.6197305,1.0899217,2.3285609,0.5853525,1.4376225,0.9170444,2.0280515,2.1227136,3.0192793,2.4683052,9.7251405),(31007,'metacarpal.tif',227,5,21,4.8150419,2.4363134,3.5228037,1.8,2.4363134,3.5228037,1.2441845,1.4920655,1.6177047,1.8187076,2.8551287,0.7199004,1.7649257,1.2189194,2.648397,2.4766343,3.2655296,1.6310681,15.8709107),(31008,'metacarpal.tif',227,5,22,4.4233954,2.4445044,3.5088133,1.8,2.4445044,3.5088133,1.2238297,1.5201714,1.7005464,1.658531,2.7078589,0.6519851,1.5923464,1.0910158,2.4867498,2.3506592,3.1468237,1.7594355,11.0177405),(31009,'metacarpal.tif',227,5,23,4.0183254,2.3911173,3.5252387,1.8,2.3911173,3.5252387,1.1611261,1.4593877,1.7840853,1.5162161,2.6370173,0.5634708,1.478078,1.0389399,2.3268177,2.3309275,3.3146092,1.6983059,10.0856193),(31010,'metacarpal.tif',227,5,24,3.5469282,2.3541632,3.5212891,1.8,2.3541632,3.5212891,1.1541976,1.4330451,1.6887703,1.4403876,2.3873153,0.4943569,1.4136412,1.0051237,2.2657638,2.3265953,3.2110322,1.720119,9.7143283),(31011,'metacarpal.tif',227,5,25,3.2863569,2.3877304,3.533808,1.8,2.3877304,3.533808,1.145159,1.4438426,1.7027658,1.4049892,2.1994387,0.4543457,1.291686,0.9730903,2.1164928,2.3041886,3.1875856,1.730148,9.6047525),(31012,'metacarpal.tif',227,5,26,3.0952713,2.4009085,3.5512953,1.8,2.4009085,3.5512953,1.0686828,1.3981518,1.6970729,1.2064517,2.1023093,0.3963858,1.2387855,0.8628904,1.9472949,2.2544461,3.1416756,1.7506498,9.3634919),(31013,'metacarpal.tif',227,5,27,2.9239259,2.4563407,3.5725019,1.8,2.4563407,3.5725019,0.8362692,1.460502,2.5562455,1.1432723,2.0615956,0.2684082,0.8064936,0.7827941,1.1418281,2.26608,3.084991,2.2981951,9.3373889),(31014,'metacarpal.tif',227,5,28,2.8512818,2.4655396,3.5117919,1.8,2.4655396,3.5117919,0.8970082,1.4871317,2.5228714,1.0242504,1.8268836,0.2902061,0.7241287,0.6887422,1.0098925,2.2449219,3.0192793,2.2440838,9.5059889),(31015,'metacarpal.tif',227,5,29,2.6412455,2.4992535,3.5112064,1.8,2.4992535,3.5112064,0.8399176,1.3394603,2.3179189,0.9216444,1.5653254,0.2440561,0.675315,0.6880714,0.9322275,2.2027463,2.9229404,2.2335258,8.7617525),(31016,'metacarpal.tif',227,5,30,2.5630741,2.5957787,3.49497,1.8,2.5957787,3.49497,0.8034795,1.1850787,2.7136857,0.8835693,1.5002499,0.2213118,0.5528458,0.7455786,0.8455312,2.1511775,2.8534994,2.1314833,8.6413645),(31017,'metacarpal.tif',227,5,31,2.3783054,2.6281617,3.4811534,1.8,2.6281617,3.4811534,0.8016401,1.6497818,2.7024911,0.793529,1.228936,0.204629,0.4547419,0.4809903,0.7227036,2.1415657,2.8837775,2.1479885,8.7685707),(31018,'metacarpal.tif',227,5,32,2.1935367,2.6704408,3.4950008,1.8,2.6704408,3.4950008,0.7001946,1.6760014,1.3957785,0.7587217,0.9622995,0.1517957,0.6894357,0.4526976,0.9649358,2.0568158,2.4459917,2.3968225,7.7779098),(31019,'metacarpal.tif',227,5,33,2.0403523,2.6833543,3.5229506,1.8,2.6833543,3.5229506,0.1890707,1.2211846,1.41206,0.6913411,0.813298,0.0120122,0.5759656,0.5661233,0.825217,1.9389,2.3103601,2.425051,7.7682674),(31020,'metacarpal.tif',227,5,34,1.765568,2.6419279,3.5582191,1.8,2.6419279,3.5582191,0.0789901,1.0810205,1.4591522,0.5428515,0.7020507,0.0018322,0.481136,0.5021658,0.7034778,1.8265,2.2285976,2.4097148,6.7061158),(31021,'metacarpal.tif',227,5,35,1.6597603,2.6209734,3.5797288,1.8,2.6209734,3.5797288,-0.1507869,0.8725838,1.604963,0.4667084,0.671441,0.0062421,0.4183529,0.534858,0.6630567,1.7556343,2.11554,2.4502557,6.4182976),(31022,'metacarpal.tif',227,5,36,1.6494953,2.5575843,3.6196137,1.8,2.5575843,3.6196137,-0.3199896,0.9364542,1.5922916,0.4173292,0.7401393,0.0272018,0.4648264,0.4456483,0.7182885,1.6298,2.0350687,2.5229483,6.1702188),(31023,'metacarpal.tif',227,5,37,1.7197706,2.5016096,3.6576447,1.8,2.5016096,3.6576447,-0.3893123,0.9611306,1.4660707,0.3966418,0.7744339,0.0412917,0.5282378,0.4126825,0.7972139,1.5736,2.0077249,3.0293898,6.1043764),(31024,'metacarpal.tif',227,5,38,1.8437394,2.4648334,3.6748904,1.8,2.4648334,3.6748904,-0.3891042,0.926438,1.3214839,0.3778732,0.7721427,0.0442233,0.5842997,0.4078775,0.8658692,1.6337409,2.4880801,0.3217506,8.8946071),(31025,'metacarpal.tif',227,5,39,1.650285,2.5976232,3.5896608,1.8,2.5976232,3.5896608,-0.0391005,0.836921,1.0273111,0.3295527,0.4781608,0.0004203,0.4654489,0.393768,0.786103,1.5985098,2.066831,0.1226687,6.9951038),(31026,'metacarpal.tif',227,5,40,1.8311057,2.5583724,3.6124798,1.8,2.5583724,3.6124798,-0.182351,0.7901901,1.0618796,0.3419583,0.5215263,0.010036,0.4911351,0.4327545,0.8077898,1.5942607,2.0744577,0.1495597,6.6771886),(31027,'metacarpal.tif',227,5,41,1.8326849,2.5905634,3.6013401,1.8,2.5905634,3.6013401,-0.1601732,1.3438947,1.0585245,0.3336433,0.5029361,0.0077696,0.4751294,0.2482659,0.4931866,1.593156,2.0466756,0.1516055,6.2275886),(31028,'metacarpal.tif',227,5,42,1.8011005,2.6234387,3.582362,1.8,2.6234387,3.582362,-0.131913,1.3579959,1.0335016,0.3168139,0.4740619,0.0051933,0.4586948,0.2332952,0.4715772,1.5736,2.0233952,0.1674318,6.2508674),(31029,'metacarpal.tif',227,5,43,1.7624096,2.6550346,3.556186,1.8,2.6550346,3.556186,0.0087785,1.423746,1.0258891,0.2911111,0.4385115,0.0000226,0.4274454,0.2044685,0.4594191,1.4612,1.9633839,0.15809,5.6848734),(31030,'metacarpal.tif',227,5,44,1.6952927,2.6908335,3.5402598,1.8,2.6908335,3.5402598,0.066337,1.4203301,0.9656609,0.2817334,0.3953354,0.0012416,0.4093936,0.1983577,0.4388014,1.4331,1.8810217,2.9002372,5.4066976),(31031,'metacarpal.tif',227,5,45,1.6566018,2.7177576,3.532738,1.8,2.7177576,3.532738,0.0494516,1.4160132,0.9625535,0.286043,0.376163,0.0006746,0.390797,0.2020059,0.4309013,1.4331,1.8650019,3.0359271,5.364134),(31032,'metacarpal.tif',227,5,46,1.5997499,2.7517473,3.5143309,1.8,2.7517473,3.5143309,0.0521301,1.4067707,0.9560567,0.2796601,0.353488,0.0007239,0.3697354,0.1987958,0.4169538,1.4612,1.8573654,2.9590328,5.3408552),(31033,'metacarpal.tif',227,5,47,1.5500045,2.7776629,3.4965247,1.8,2.7776629,3.4965247,0.143254,1.4146472,0.9282876,0.2647077,0.3368783,0.0052653,0.3629029,0.1871193,0.4056864,1.3929176,1.8351258,2.9411941,5.2942976),(31034,'metacarpal.tif',227,5,48,1.5342123,2.8014384,3.4884639,1.8,2.8014384,3.4884639,0.1286705,1.4118459,0.9276037,0.2651295,0.3310719,0.0042101,0.3569109,0.1877893,0.403801,1.3769,1.8297395,2.9562447,5.2846552),(31035,'metacarpal.tif',227,5,49,1.5350019,2.8232984,3.4693093,1.8,2.8232984,3.4693093,0.1308211,1.3994233,0.919157,0.2611029,0.3378021,0.0043535,0.3675129,0.1865789,0.4117858,1.3945516,1.8265,2.8928827,5.1818976),(31036,'metacarpal.tif',227,5,50,1.5539525,2.8409272,3.4598554,1.8,2.8409272,3.4598554,0.1119367,1.3999186,0.9587696,0.2674007,0.3507248,0.0032316,0.3658072,0.1910116,0.4236606,1.3767882,1.8745038,2.9147938,5.334037),(31037,'metacarpal.tif',227,5,51,1.561059,2.8570608,3.4554473,1.8,2.8570608,3.4554473,0.0857071,1.3920249,0.9378858,0.2722266,0.3560355,0.0019065,0.379615,0.1955616,0.4307595,1.405,1.8402819,3.0191316,5.3504976),(31038,'metacarpal.tif',227,5,52,1.5350019,2.8903539,3.43284,1.8,2.8903539,3.43284,0.1446035,1.267464,0.9527142,0.2498627,0.3708023,0.0053123,0.3892062,0.197136,0.4719308,1.405,1.8717638,3.0060649,5.390237),(31039,'metacarpal.tif',227,5,53,1.5049967,2.9154119,3.4302493,1.8,2.9154119,3.4302493,0.137716,1.2710228,0.9568527,0.2545874,0.3724634,0.0047272,0.3892589,0.2003012,0.4722444,1.4331,1.8757671,2.9912212,5.4299764),(31040,'metacarpal.tif',227,5,54,1.4978902,2.9412568,3.4244968,1.8,2.9412568,3.4244968,0.0862348,1.2879433,0.9917934,0.2759919,0.3811402,0.0018519,0.3842939,0.2142889,0.475648,1.4331,1.8996099,3.0080636,5.5259158),(31041,'metacarpal.tif',227,5,55,1.5065759,2.969793,3.4195992,1.8,2.969793,3.4195992,0.0128236,1.2815312,1.0211541,0.3070238,0.3970229,0.0000413,0.3887982,0.2395758,0.4900808,1.4854311,1.9239781,3.0244839,5.869934),(31042,'metacarpal.tif',227,5,56,1.5373707,2.9967705,3.411011,1.8,2.9967705,3.411011,-0.1272421,1.183441,1.0003923,0.3411159,0.4159445,0.0041261,0.4157814,0.2882407,0.5100179,1.5208586,1.9282826,2.8152338,5.9755158),(31043,'metacarpal.tif',227,5,57,1.5863265,3.0561583,3.4089539,1.8,3.0561583,3.4089539,0.3435617,1.4809475,2.0206508,0.3872727,0.5048124,0.0299982,0.2498267,0.2615033,0.4111932,1.5455,1.9356393,2.907177,5.8727582),(31044,'metacarpal.tif',227,5,58,1.7260875,3.1089064,3.4514153,1.8,3.1089064,3.4514153,0.4097062,1.8589697,2.1028454,0.5229702,0.678179,0.0456477,0.3225054,0.2813226,0.5453948,1.5638863,1.9696076,0.2449787,6.0674612),(31045,'metacarpal.tif',227,5,59,1.876903,3.1589744,3.4705333,1.8,3.1589744,3.4705333,0.4214861,1.8309804,2.1196794,0.6287085,0.8096971,0.0523583,0.3819904,0.3433726,0.6500214,1.6185611,1.9617745,0.6635557,6.3058976),(31046,'metacarpal.tif',227,5,60,1.8311057,3.2359592,3.3484925,1.8,3.2359592,3.3484925,0.086271,0.8709925,1.8110855,0.4151852,0.6692562,0.0022658,0.3695332,0.4766806,0.5974521,1.6659772,2.0497597,2.6411518,6.289437),(31047,'metacarpal.tif',227,5,61,2.379095,3.4235649,3.3755813,1.8,3.4235649,3.3755813,0.1932335,1.1274746,1.6405046,0.5522738,1.2296985,0.0146222,0.7495855,0.4898326,1.0861618,1.7927604,3.0323273,3.0114906,9.1358677),(31048,'metacarpal.tif',227,5,62,2.7810065,3.4966948,3.3547268,1.8,3.4966948,3.3547268,0.048757,1.0337279,1.5541376,0.7045986,1.5017978,0.001101,0.9663223,0.6816093,1.26701,1.8403718,3.2388222,2.9935607,10.2309405),(31049,'metacarpal.tif',227,5,63,2.6830949,3.3487626,3.3306357,1.8,3.3487626,3.3306357,-0.164401,1.1069543,1.7896669,0.7907599,0.9871093,0.0119778,0.5515604,0.7143564,0.9545694,2.0574136,2.4141482,0.8760581,7.953328),(31050,'metacarpal.tif',227,5,64,3.0455259,3.4144743,3.2974844,1.8,3.4144743,3.2974844,-0.3087956,1.1556287,1.7725678,0.9710345,1.118006,0.0468819,0.6307268,0.8402651,1.1677783,2.0794,2.5149108,2.2612428,7.8562188),(31051,'metacarpal.tif',227,5,65,3.3621595,3.4598967,3.2811337,1.8,3.4598967,3.2811337,-0.5540803,1.3074948,1.4684768,1.1115163,1.2260159,0.1551333,0.8348895,0.8501114,1.586209,0.1686,0.4634371,1.815775,1.0882546),(31052,'metacarpal.tif',227,5,66,3.6432607,3.493785,3.2766099,1.8,3.493785,3.2766099,-0.8401799,1.3913797,1.3649799,1.2660815,1.3437861,0.3368026,0.9844732,0.9099468,1.8304785,2.1688195,2.7280166,0.6022873,9.5337463),(31053,'metacarpal.tif',227,5,67,3.6724762,3.4954141,3.2581259,1.8,3.4954141,3.2581259,-1.4525822,1.1131308,1.138514,1.199942,1.404083,0.6035656,1.2332593,1.0779884,1.7816984,2.2199,2.7374074,0.6250227,8.6413645),(31054,'metacarpal.tif',227,5,68,4.2180968,3.5870582,3.2578484,1.8,3.5870582,3.2578484,1.4967161,1.2131321,1.2378739,1.497821,1.5869899,0.6991651,1.2820287,1.2346726,2.1628988,2.2996576,2.6896853,0.5619216,8.5755221),(31055,'metacarpal.tif',227,5,69,4.5228862,3.6297567,3.2517067,1.8,3.6297567,3.2517067,1.3457707,1.2463674,1.3388856,1.6012022,1.7548878,0.7162838,1.3107078,1.2846951,2.3011391,2.2701711,2.7739412,2.2629406,8.4182188),(31056,'metacarpal.tif',227,5,70,4.4052343,3.6522194,3.2386875,1.8,3.6522194,3.2386875,1.470757,1.1506674,1.2346948,1.506717,1.7083197,0.7268824,1.3835968,1.3094288,2.1344634,2.2125192,2.8393518,2.2439917,8.6032794),(31057,'metacarpal.tif',227,5,71,4.4004967,3.6843674,3.2311572,1.8,3.6843674,3.2311572,1.457238,1.1278904,1.2363109,1.493603,1.7347115,0.7239989,1.4031354,1.3242448,2.1126834,2.1637,2.914283,2.2605964,8.5731824),(31058,'metacarpal.tif',227,5,72,4.363385,3.7114782,3.2280117,1.8,3.7114782,3.2280117,-1.4791262,1.133706,1.1975992,1.4344573,1.7403478,0.7211367,1.4531972,1.2652816,2.1003108,2.1075,2.8788447,2.2455373,8.7156794),(31059,'metacarpal.tif',227,5,73,4.144663,3.7192109,3.221516,1.8,3.7192109,3.221516,-1.4858447,1.0989638,1.1943703,1.2648809,1.6861144,0.685804,1.4117183,1.1509759,1.8970817,2.0513,2.9007041,2.1910458,8.7224976),(31060,'metacarpal.tif',227,5,74,4.0349072,3.743107,3.2222947,1.8,3.743107,3.2222947,-1.4923721,1.039857,1.2131713,1.1188053,1.6731143,0.668357,1.3791245,1.0759223,1.834404,1.967,2.8453245,2.1807132,8.5771764),(31061,'metacarpal.tif',227,5,75,3.7466996,3.7535146,3.2179327,1.8,3.7535146,3.2179327,-1.5282945,0.874373,1.2132618,0.8760786,1.6075698,0.6233226,1.3249983,1.0019506,1.7661076,1.7660155,2.6965754,2.1559088,8.0140066),(31062,'metacarpal.tif',227,5,76,3.4426997,3.7627254,3.2273044,1.8,3.7627254,3.2273044,-1.5200101,0.7853219,1.2478691,0.6322045,1.5175633,0.5723046,1.2161237,0.805026,1.6158202,1.5797357,2.6122423,1.0156178,7.5206732),(31063,'metacarpal.tif',227,5,77,3.0076246,3.7747397,3.241843,1.8,3.7747397,3.241843,-1.5629384,0.7079244,1.2503848,0.4232618,1.3323207,0.5012398,1.0655286,0.5978913,1.3181887,1.4331,2.5422349,1.1615504,7.1738308),(31064,'metacarpal.tif',227,5,78,2.4091002,3.7706038,3.2568739,1.8,3.7706038,3.2568739,1.5662793,0.598737,1.233177,0.2307179,1.0470491,0.4015085,0.8490663,0.385341,0.974447,1.2077636,2.4535661,1.2200684,6.873546),(31065,'metacarpal.tif',227,5,79,1.1780982,3.7638557,3.3221659,1.8,3.7638557,3.3221659,-1.5590263,0.5925585,1.3590589,0.0702234,0.6565305,0.1963225,0.4830773,0.1185088,0.5202762,0.8856182,1.4328245,2.300696,3.7552731),(31066,'metacarpal.tif',227,5,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31067,'metacarpal.tif',227,5,81,3.5121854,4.2086005,3.1880487,1.8,4.2086005,3.1880487,1.4838428,1.0002956,1.1782384,0.8058154,1.2965851,0.5809495,1.1004438,0.8055773,1.5466565,2.3042,2.8293226,2.8701142,9.2579101),(31068,'metacarpal.tif',227,5,82,3.0842168,4.184821,3.1975441,1.8,4.184821,3.1975441,1.5117897,0.923956,1.1050525,0.6352752,1.1188427,0.5122484,1.0124792,0.68756,1.3442912,2.1918,2.8351773,2.9014216,8.6658131),(31069,'metacarpal.tif',227,5,83,2.8291727,4.1231947,3.4672248,1.8,4.1231947,3.4672248,-1.4936882,0.9551199,1.7969844,0.5324897,2.0292951,0.4687308,1.1292781,0.5575109,1.3067377,2.1356,2.7949261,2.9185617,8.3615343),(31070,'metacarpal.tif',227,5,84,2.3743574,4.1579684,3.5147802,1.8,4.1579684,3.5147802,-1.4701866,0.9265631,1.7654376,0.4321137,1.8426451,0.3917341,1.0437327,0.4663618,1.1919737,2.067985,2.8497612,2.9229237,8.8685041),(31071,'metacarpal.tif',227,5,85,1.9598121,4.1836168,3.5441211,1.8,4.1836168,3.5441211,-1.4499456,0.9040516,1.7469339,0.3385402,1.6918789,0.3218881,0.9684848,0.37447,1.0868466,1.9951,2.8419924,2.8918179,8.7191889),(31072,'metacarpal.tif',227,5,86,1.8050485,4.2277594,3.559063,1.8,4.2277594,3.559063,-1.4466906,0.8597758,1.7362384,0.2877461,1.6480737,0.2962315,0.9492208,0.3346757,1.0393581,1.9951,2.8564034,2.8727522,8.4149101),(31073,'metacarpal.tif',227,5,87,1.7860979,4.2770636,3.5468238,1.8,4.2770636,3.5468238,-1.4556904,0.805232,1.7414675,0.2613904,1.7053902,0.2937563,0.9792834,0.3246151,1.0517243,1.9951,2.8564034,2.8727522,8.6465283),(31074,'metacarpal.tif',227,5,88,1.8224199,4.3270835,3.5655467,1.8,4.3270835,3.5655467,-1.4822153,0.7450857,1.703585,0.2461703,1.7974982,0.3013596,1.0551268,0.3303919,1.1043146,2.0755215,2.8692288,2.9941555,8.6300677),(31075,'metacarpal.tif',227,5,89,1.8397914,4.3801509,3.5898293,1.8,4.3801509,3.5898293,-1.4927861,0.7462162,1.6713954,0.2287157,1.8472926,0.3047696,1.1052397,0.3065006,1.1358325,2.1075,2.9666468,3.0372115,8.7163647),(31076,'metacarpal.tif',227,5,90,1.8571628,4.416933,3.6122121,1.8,4.416933,3.6122121,-1.4866306,0.7726025,1.6543429,0.2189206,1.8823956,0.3073397,1.1378509,0.2833548,1.1595034,2.1908068,3.0477815,3.0492633,8.9684375),(31077,'metacarpal.tif',227,5,91,1.8658485,4.453749,3.622819,1.8,4.453749,3.622819,-1.4835544,0.7492887,1.6468039,0.2050363,1.9034086,0.3086139,1.1558198,0.2736412,1.1666718,2.1637,3.1013287,3.0599563,9.0933041),(31078,'metacarpal.tif',227,5,92,1.7600408,4.4784139,3.6238915,1.8,4.4784139,3.6238915,-1.4811582,0.7446647,1.6472073,0.1824993,1.8265186,0.2909894,1.1088578,0.2450758,1.1132668,2.1637,3.1093384,3.0329314,9.2221647),(31079,'metacarpal.tif',227,5,93,1.6613395,4.5083673,3.6260887,1.8,4.5083673,3.6260887,-1.4872104,0.7561424,1.6406811,0.1622782,1.7062013,0.2749599,1.0399347,0.2146133,1.0359692,2.1637,3.0917663,3.0048369,9.3839465),(31080,'metacarpal.tif',227,5,94,1.5981707,4.5357344,3.6117664,1.8,4.5357344,3.6117664,-1.4871005,0.774998,1.6573235,0.1414347,1.6391746,0.2645003,0.9890493,0.1824969,0.9732368,2.1918,3.0863984,2.9584818,9.3305707),(31081,'metacarpal.tif',227,5,95,1.5807993,4.5712609,3.5504533,1.8,4.5712609,3.5504533,-1.4872225,0.7518263,1.7166023,0.1213339,1.5731324,0.2616306,0.9164222,0.1613856,0.9046397,2.2199,3.1367707,2.970553,9.5525465),(31082,'metacarpal.tif',227,5,96,1.6179109,4.6209347,3.5186714,1.8,4.6209347,3.5186714,-1.4791424,0.7541603,1.7562252,0.1110146,1.5118437,0.267393,0.8608485,0.147203,0.8490842,2.3042,3.1895667,2.8923405,9.7018617),(31083,'metacarpal.tif',227,5,97,1.6005395,4.6616334,3.4980134,1.8,4.6616334,3.4980134,-1.4731242,0.7261357,1.7797798,0.1000297,1.4616353,0.2642199,0.821245,0.1377561,0.8124323,2.327202,3.2986097,2.9007462,9.9033829),(31084,'femur.tif',227,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31085,'femur.tif',227,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31086,'femur.tif',227,7,3,0.0002389,9.8042003,17.3054004,1.8,9.8042003,17.3054004,0.7853982,0,0,0.00000002155,0.00000002155,0.0000199,0,0,0,0.0329,0.0465276,2.3561945,0.0930553),(31087,'femur.tif',227,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31088,'femur.tif',227,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31089,'femur.tif',227,7,6,0.0002376,11.8769003,18.2924005,1.8,11.8769003,18.2924005,0.7853982,0,0,0.00000002143,0.00000002143,0.0000198,0,0,0,0.0329,0.0465276,2.3561945,0.0930553),(31090,'femur.tif',227,7,7,0.0017768,7.824403,10.9498356,1.8,7.8255002,10.9510003,-1.3687761,0.5368968,5.9057084,0.0000955,0.0461211,0.0002842,0.0078096,0.0001778,0.0078257,0,0,0,0),(31091,'femur.tif',227,7,8,0.0009823,11.5676683,13.489543,1.8,11.5561253,13.5383503,-1.350327,0.0280817,7.9615814,0.0000005,0.0390392,0.0001559,0.0049034,0.0000194,0.0049035,0,0,0,0),(31092,'femur.tif',227,7,9,0.0324653,6.5740487,18.5016988,1.8,6.675237,17.8742241,1.5138322,4.1220725,13.8150237,0.0318021,0.5408789,0.0053933,0.0391515,0.0077151,0.039723,0.0987,0.1186226,2.1587989,0.2984381),(31093,'femur.tif',227,7,10,0.0042811,7.0555014,16.600317,1.8,7.0456617,16.7486312,-1.5032937,0.0433134,4.2673438,0.0000025,0.0606669,0.0007103,0.0142165,0.0000569,0.0142171,0,0,0,0),(31094,'femur.tif',227,7,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31095,'femur.tif',227,7,12,0.0065666,8.0083437,7.7066552,1.8,8.0091762,7.7038642,-1.1560396,0.0480838,0.2053044,0.000004,0.0001032,0.0009167,0.0005025,0.0000836,0.000522,0.1298704,0.4277,1.1760052,0.9531315),(31096,'femur.tif',227,7,13,0.9875233,8.0558953,7.7754343,1.8,8.0530354,7.8413492,-1.5551473,0.7353507,1.5051989,0.0804467,0.3261334,0.1645469,0.2166713,0.1093991,0.2684254,1.2790894,2.8670232,1.6282044,9.1351457),(31097,'femur.tif',227,7,14,2.1085485,8.1235679,7.8027084,1.8,8.135955,7.8844391,1.4384357,1.0902443,2.0103024,0.4838589,1.5803589,0.3453039,0.7861299,0.4438078,1.003891,1.9552213,3.7662958,1.8178936,11.0447154),(31098,'femur.tif',227,7,15,2.562768,8.084773,7.7467187,1.8,8.0969683,7.833725,1.4684056,1.3476117,2.2549421,0.9503322,3.1770459,0.4226657,1.4089257,0.7051973,1.8227113,2.483256,4.3974147,1.7285651,12.4983614),(31099,'femur.tif',227,7,16,2.7393148,7.969663,7.6457628,1.8,7.9718714,7.702938,1.528263,1.5068207,2.4939418,1.2666254,4.5258305,0.455727,1.8147298,0.8405946,2.30971,2.7147072,4.9877964,1.7164247,13.8735482),(31100,'femur.tif',227,7,17,3.0023723,7.8904706,7.5155377,1.8,7.887016,7.5241458,-1.5693196,1.6847184,2.81544,1.6725168,5.6521714,0.5003943,2.0075624,0.9927575,2.5911309,2.855074,5.4572365,1.6734644,40.5738904),(31101,'femur.tif',227,7,18,3.3032359,7.899747,7.4880888,1.8,7.904381,7.5073383,1.540815,1.9374152,3.2278543,2.3839043,6.8244437,0.5500446,2.1142353,1.2304561,2.8295357,3.1961937,6.0358726,1.6417154,18.4178572),(31102,'femur.tif',227,7,19,3.7526458,7.9725085,7.487099,1.8,7.9524898,7.4863772,1.4877166,1.8843165,3.1716397,4.0361938,8.4448243,0.6211339,2.6626052,2.1419936,3.7667917,3.5912195,6.076444,1.6575347,18.1978782),(31103,'femur.tif',227,7,20,4.1259401,8.0628413,7.4755449,1.8,8.039443,7.4400412,1.5227127,2.2971129,3.2080345,6.2496837,9.7035624,0.686068,3.0247687,2.7206689,4.7092025,4.2365222,6.0148544,1.746736,48.7426781),(31104,'femur.tif',227,7,21,4.4571265,8.2047562,7.4760269,1.8,8.2168603,7.4984354,-1.3223996,4.019715,3.5553235,8.4227445,10.9855189,0.6979546,3.0898789,2.0953586,4.6565227,4.6565245,5.8936015,1.5317101,20.3626651),(31105,'femur.tif',227,7,22,4.8978463,8.3062925,7.5306363,1.8,8.3420706,7.5468382,-1.1319883,5.0942289,3.5927239,10.8980208,13.3548031,0.6689587,3.7171805,2.1392876,4.7313318,5.0666001,6.3306646,1.0303768,21.0366308),(31106,'femur.tif',227,7,23,5.2712234,8.3827391,7.5603367,1.8,8.4177376,7.5812296,-1.0556619,2.9523158,3.7094061,12.5113672,15.3163122,0.6653111,4.129047,4.2378147,7.4572891,5.3627001,6.4843056,1.0503916,21.5357756),(31107,'femur.tif',227,7,24,6.6882179,9.2509031,7.7998302,1.8,9.64622,7.8979679,0.1864536,3.7128202,6.3540117,17.2673791,44.4735256,0.0383056,6.9992829,4.6507448,9.7133023,5.5272001,6.9916179,1.3041316,23.3649492),(31108,'femur.tif',227,7,25,11.2248599,10.903473,8.239616,1.8,11.2728563,8.3484996,0.2250749,3.808365,5.7152133,23.4424256,111.3745625,0.0931832,19.487385,6.1555092,23.400789,6.6135053,11.2768322,2.9150125,42.5052368),(31109,'femur.tif',227,7,26,14.7709202,11.4823632,8.429722,1.8,11.6669019,8.4485739,0.2381042,3.8860115,6.1293756,31.0534397,159.6447809,0.1369518,26.0458472,7.9910827,30.8281333,6.7377206,12.1495476,2.9426039,78.3913613),(31110,'femur.tif',227,7,27,17.6671637,11.7240109,8.4926835,1.8,11.822003,8.4730321,0.2472731,3.9968005,6.5053331,42.3084813,198.8353696,0.1764005,30.5649792,10.5855874,36.8777295,6.9562689,12.9437986,2.9342273,43.3760352),(31111,'femur.tif',227,7,28,19.6279365,11.8157088,8.5150843,1.8,11.8333462,8.4795256,0.2479329,4.0400306,6.5937934,53.0914024,228.2968662,0.1970038,34.6229933,13.1413367,42.4037381,7.3616214,13.0026198,2.9789398,52.8880782),(31112,'femur.tif',227,7,29,20.9550434,11.8212919,8.5543461,1.8,11.786371,8.5028624,0.2278168,3.9736398,6.7631796,62.0927551,261.2599386,0.1781486,38.62975,15.6261659,47.4866053,7.2613108,13.2624143,2.9821535,52.8514705),(31113,'femur.tif',227,7,30,20.6614157,12.0411116,8.6287235,1.8,11.9011276,8.570353,0.2137025,5.5617721,6.4914378,69.0983965,263.2873285,0.1548841,40.55917,12.4238094,50.7433663,7.2079654,12.8419623,2.9924493,60.0963189),(31114,'femur.tif',227,7,31,19.5951081,12.304011,8.7169235,1.8,12.1694931,8.6867813,0.1965976,3.8756572,6.6759507,74.2510544,251.1742426,0.1246093,37.6237413,19.1583134,46.5579031,7.2572713,13.0269463,2.7775013,65.2375042),(31115,'femur.tif',227,7,32,18.8154992,12.4202899,8.7831223,1.8,12.2488304,8.7822351,0.1785851,3.9900301,6.9090275,76.1306752,251.1410042,0.0989539,36.3496896,19.0802258,45.1450535,7.4965411,13.0619633,2.7568768,101.7510669),(31116,'femur.tif',227,7,33,18.0710849,12.4551552,8.8569296,1.8,12.2263628,8.9149549,0.1523772,4.3029998,7.0129254,77.2483812,247.4373772,0.069392,35.2830471,17.9522158,43.6960958,7.9378546,13.203111,2.7504435,153.2283878),(31117,'femur.tif',227,7,34,17.2814756,12.3431896,8.8451897,1.8,12.1101144,8.9143673,0.1418002,4.3744415,7.0120025,74.1671749,248.6736736,0.0575268,35.4640026,16.9546617,43.644315,8.0111153,13.233532,2.7513913,153.6936641),(31118,'femur.tif',227,7,35,16.3487547,12.2267102,8.8733383,1.8,12.0570171,8.9537171,0.1345568,4.5209324,7.1446388,70.9607165,240.6790089,0.0490368,33.6866587,15.6960358,42.0566348,8.1541144,13.2471027,2.7057157,145.1931371),(31119,'femur.tif',227,7,36,15.600893,12.1257055,8.9187241,1.8,11.9479325,8.9997656,0.1220687,4.9708122,7.20322,67.6564329,232.2326271,0.0385521,32.2401131,13.6107402,40.7548421,8.465469,13.3126348,2.9601919,180.1454024),(31120,'femur.tif',227,7,37,14.9214805,12.0450761,8.9376561,1.8,11.8782929,8.999247,0.1285633,4.9206823,7.2251427,62.4557592,222.137526,0.040879,30.7450709,12.6924997,38.6335429,7.9312619,13.3303885,2.9403249,75.0242717),(31121,'femur.tif',227,7,38,13.9240113,11.8935471,9.0386744,1.8,11.7487017,9.0890447,0.1618434,4.5572015,7.2213859,57.313853,205.1230531,0.060257,28.4049426,12.5765457,35.2834625,7.8986452,13.3017352,2.8942145,59.5927328),(31122,'femur.tif',227,7,39,12.5054317,11.2395394,9.0898132,1.8,11.1760316,9.1354947,0.2619821,4.9892142,6.7627059,51.3347484,165.0264038,0.139808,24.402422,10.289145,31.0913495,7.7695935,13.2002823,2.9153542,115.7578197),(31123,'femur.tif',227,7,40,10.8518956,10.4227938,9.1097542,1.8,10.2908913,9.1601821,0.4729312,4.1482752,6.2291746,41.3107662,118.9007617,0.3752552,19.0877234,9.9585405,22.8389035,6.4894756,11.2663169,2.8604851,67.817968),(31124,'femur.tif',227,7,41,10.5560028,10.1560112,9.0784373,1.8,9.9655127,9.1450073,0.5560552,3.7031873,6.4053298,38.9321434,111.0550081,0.4901766,17.3379064,10.5131446,22.9147941,6.4163971,11.3403874,2.2555052,42.9740547),(31125,'femur.tif',227,7,42,10.4911441,9.9167466,8.9620368,1.8,9.7260434,9.0347516,0.5925958,3.6243398,6.4319948,36.9184948,111.2286559,0.545435,17.2930263,10.1862675,21.78401,6.3436596,11.3612235,2.2577483,38.800597),(31126,'femur.tif',227,7,43,10.6395302,9.7091017,8.8462189,1.8,9.5133015,8.9035573,0.6183721,3.6029728,6.2011026,34.8608819,117.0143897,0.5959256,18.8699329,9.6755885,21.5459489,6.2896784,11.4299925,2.2828569,68.4839509),(31127,'femur.tif',227,7,44,10.5416474,9.5832643,8.7651676,1.8,9.4521963,8.8366211,0.6348591,3.5324431,5.759034,32.33722,118.3856326,0.6179601,20.5565088,9.1543497,25.7824719,6.2021854,11.5378197,2.2673601,56.8409896),(31128,'femur.tif',227,7,45,10.8135509,9.5416997,8.7616239,1.8,9.3887212,8.8131054,0.6507315,3.4627609,5.7441696,32.0394902,114.9825011,0.6613488,20.017254,9.2525852,25.1169826,6.1134201,11.4917117,2.2933968,37.3276787),(31129,'femur.tif',227,7,46,10.936559,9.4787159,8.8157145,1.8,9.3303919,8.8892778,0.6501841,3.3352669,5.6744361,31.7624475,106.9477012,0.6679101,18.8472826,9.5232101,23.9760702,6.0570781,11.3642718,2.311143,37.96173),(31130,'femur.tif',227,7,47,11.2001767,9.4303161,8.8780394,1.8,9.2510903,8.9194005,0.659783,3.1933433,5.5335881,31.7156847,100.3638966,0.7013216,18.1372186,9.9318118,23.113667,5.9801892,11.1841132,2.2708076,37.4658919),(31131,'femur.tif',227,7,48,11.4737248,9.397932,9.0407161,1.8,9.2048019,9.1184339,0.6678841,3.0071167,5.4420779,32.6091939,90.1296087,0.7334862,16.5616169,10.8440069,21.918131,5.94292,11.0373987,2.2781294,34.3259619),(31132,'femur.tif',227,7,49,11.7955054,9.4151177,9.1742151,1.8,9.2757548,9.2391321,0.6696246,3.058997,5.3582282,33.2821155,82.7037769,0.7573858,15.4349113,10.8800746,21.3339181,5.9075299,10.8386904,2.2939096,33.9297922),(31133,'femur.tif',227,7,50,11.2895545,9.5421919,9.2620399,1.8,9.4179886,9.3319968,0.6817355,3.0568732,5.2492794,33.0267454,75.4544226,0.7471397,14.3742438,10.8040939,20.6418813,5.9154905,10.5033478,2.3096649,33.2750988),(31134,'femur.tif',227,7,51,10.4033448,9.718207,9.3465845,1.8,9.5703026,9.4677325,0.7134653,3.0679138,4.9972061,32.4622139,67.7758414,0.7426514,13.5627469,10.5812015,19.7653222,5.906843,10.0792738,2.3215663,31.9271673),(31135,'femur.tif',227,7,52,9.7649754,9.831686,9.3053125,1.8,9.7265449,9.4899704,0.7558541,3.0289033,4.8771601,31.539559,61.5974854,0.7656931,12.6297853,10.4128643,18.8438914,6.0319034,9.7377333,2.3036114,33.0936646),(31136,'femur.tif',227,7,53,9.1810029,9.9462863,9.2878396,1.8,9.8711395,9.4729668,0.7935783,3.0347616,4.7606915,29.2252935,58.4036957,0.7776,12.2679016,9.6301778,18.1946351,5.8399936,9.4615964,2.2971499,29.7623804),(31137,'femur.tif',227,7,54,8.898214,10.0590981,9.2225937,1.8,10.0318069,9.4277314,0.8088715,3.0081808,4.6831796,27.5597461,55.5533894,0.7763168,11.8623232,9.1615989,17.6332814,5.7060324,9.2359977,2.348638,28.5559687),(31138,'femur.tif',227,7,55,8.4364179,10.1067961,9.1360757,1.8,10.0522699,9.3006272,0.8298868,3.0500399,4.5934594,26.013951,48.9099113,0.7655064,10.6477291,8.5290527,16.1740375,5.6215545,8.953758,2.2885893,27.6254162),(31139,'femur.tif',227,7,56,8.0606788,10.1205492,9.0238541,1.8,10.0965252,9.1846592,0.8309422,3.0817132,4.4711911,25.0269923,42.6278439,0.7328247,9.5338901,8.1211295,15.0531719,5.569047,8.6201769,2.302193,24.4210558),(31140,'femur.tif',227,7,57,8.0910235,10.1913608,8.9857941,1.8,10.1947972,9.133291,0.8474767,3.0968831,4.1478322,24.1150319,40.3976267,0.7577502,9.7394554,7.7868718,15.5082376,5.5468921,8.1995621,2.3051026,22.7267889),(31141,'femur.tif',227,7,58,8.0427816,10.1526847,8.8794571,1.8,10.1526524,8.9873771,0.8278698,3.0580705,3.9866724,23.5723428,38.9885458,0.727095,9.7797215,7.7082406,15.6208028,5.5371053,7.8457363,2.3176379,21.7689811),(31142,'femur.tif',227,7,59,7.9684037,10.1836336,8.7671657,1.8,10.1972097,8.8528762,0.880551,3.0913576,3.8188917,23.1430656,36.5718375,0.7896416,9.5765579,7.486376,15.6308965,5.5068207,7.5145359,2.3469068,21.2811258),(31143,'femur.tif',227,7,60,7.7669878,10.1798284,8.7351246,1.8,10.1833487,8.8064617,0.8997242,3.0216628,3.5763835,22.3359257,34.8849811,0.7939576,9.7542619,7.3919319,15.9292572,5.4774045,7.1465739,2.3203792,20.584581),(31144,'femur.tif',227,7,61,7.4826258,10.1632486,8.6464899,1.8,10.1569199,8.6805379,0.9011783,2.9809505,3.5072566,21.6159976,32.372749,0.7666552,9.2302197,7.2513777,15.3008028,5.4441783,6.9168291,2.2618805,20.2442915),(31145,'femur.tif',227,7,62,7.4368576,10.1961607,8.6136106,1.8,10.1987325,8.6625334,0.9420464,2.9402457,3.4196952,21.2393346,31.1849973,0.8107391,9.1192329,7.2236599,15.256752,5.4204686,6.746506,2.2386828,19.8960191),(31146,'femur.tif',227,7,63,7.3193941,10.2158974,8.5461064,1.8,10.2381018,8.5959348,0.933555,2.9194653,3.3676154,20.8736507,29.7338013,0.7880527,8.8293341,7.1498197,14.9302272,5.3856257,6.6598736,2.4506494,20.2217125),(31147,'femur.tif',227,7,64,7.3800754,10.2673662,8.5405816,1.8,10.283954,8.5864236,0.9817465,2.8840099,3.2580505,20.4086532,29.2795559,0.8503576,8.986833,7.0764853,15.166005,5.3664994,6.5414766,2.4809906,19.6873296),(31148,'femur.tif',227,7,65,7.423902,10.3074175,8.5381318,1.8,10.3292999,8.5936493,1.0226661,2.8393707,3.1729787,20.1482349,28.5737328,0.9013394,9.0053339,7.0960213,14.5459318,5.3274133,6.5674863,2.4840644,20.3034783),(31149,'femur.tif',227,7,66,7.2536505,10.315191,8.4871893,1.8,10.3270153,8.5236319,1.0516021,2.7946807,3.1506857,19.7371781,27.4566402,0.911306,8.7144967,7.0624089,14.505642,5.2822817,6.3908199,2.5207447,19.7883678),(31150,'femur.tif',227,7,67,7.2085753,10.3496038,8.4398679,1.8,10.3492356,8.4563038,1.0663637,2.7746961,3.0984571,19.7048535,26.3057391,0.9207882,8.4899477,7.1016257,14.7476246,5.2542583,6.172938,2.5151475,19.0246534),(31151,'femur.tif',227,7,68,7.3145611,10.384455,8.4102051,1.8,10.3879161,8.423832,1.1111251,2.7452566,3.0630922,19.8873699,25.9359841,0.9791412,8.4672554,7.2442664,14.8544803,5.2440552,6.0967173,2.532635,18.9940915),(31152,'femur.tif',227,7,69,7.5288674,10.4303863,8.405818,1.8,10.4269412,8.4424307,1.1403127,2.7259364,3.0066093,20.1291485,26.0151248,1.0362885,8.6526455,7.3843059,14.5549689,5.2438189,5.9823746,2.0885782,18.5288152),(31153,'femur.tif',227,7,70,7.7103893,10.4503356,8.3792816,1.8,10.4468894,8.40837,1.1202645,2.6992446,2.9635318,20.3640645,25.8316962,1.0414014,8.716524,7.5443569,13.1902809,5.2409069,5.9146845,2.1341126,18.4051981),(31154,'femur.tif',227,7,71,7.7104405,10.4748674,8.3353044,1.8,10.4862903,8.3550915,1.1216921,2.6819896,2.962458,20.2295554,25.947706,1.042845,8.7588434,7.5427419,13.8180161,5.2230584,5.8736408,2.1121764,18.3939086),(31155,'femur.tif',227,7,72,7.7323511,10.5230872,8.3392744,1.8,10.538329,8.3627732,1.2164527,2.6534384,2.934132,20.0377267,25.9630868,1.1335736,8.8486431,7.551608,14.2108808,5.2107636,5.8354623,2.0899424,18.3746362),(31156,'femur.tif',227,7,73,7.7533535,10.5273704,8.3484655,1.8,10.5313585,8.3649561,1.3057678,2.5955937,2.9200585,19.8368631,25.9827977,1.2035648,8.8980402,7.6425148,15.1645023,5.1948451,5.9221829,2.545886,18.5142191),(31157,'femur.tif',227,7,74,7.8797506,10.60335,8.3480571,1.8,10.6037158,8.3815459,1.277022,2.6210968,2.8755488,19.3139301,26.8341507,1.2031736,9.3318362,7.3686444,15.6508369,5.1868859,5.780297,1.9682144,18.1419981),(31158,'femur.tif',227,7,75,7.7620055,10.6512728,8.2941771,1.8,10.6471402,8.3181748,1.2511249,2.6337896,2.8825597,19.0122315,26.4136143,1.1659102,9.1632496,7.2185841,15.2867129,5.1868001,5.7747702,1.7715438,18.0296704),(31159,'femur.tif',227,7,76,7.8330155,10.6692226,8.2700362,1.8,10.6635612,8.2948998,1.2853787,2.6143362,2.9380152,19.1873784,26.7982644,1.2020088,9.1212135,7.3392927,15.3802301,5.1743691,5.7890915,1.8529992,18.0376533),(31160,'femur.tif',227,7,77,7.9258962,10.7164774,8.2559681,1.8,10.7102121,8.2718034,1.2392965,2.6271932,2.923319,19.4763253,27.242919,1.1810573,9.3191742,7.4133585,15.591937,5.1628366,5.8077588,1.8638809,18.0921638),(31161,'femur.tif',227,7,78,7.8353746,10.7276709,8.2298269,1.8,10.7186576,8.2467684,1.3051085,2.5978106,2.9756015,19.4521078,26.8935048,1.2158613,9.0380063,7.4878853,15.4306353,5.1548774,5.8206973,1.8514252,18.0921638),(31162,'femur.tif',227,7,79,7.8999934,10.7447979,8.2196108,1.8,10.7463489,8.2481964,1.3384902,2.5779788,2.9772689,19.2745446,26.9623426,1.2468793,9.0560657,7.4766109,15.5297873,5.1545867,5.829895,1.928246,17.9366152),(31163,'femur.tif',227,7,80,7.9772155,10.763772,8.1890238,1.8,10.7608294,8.2089351,1.3609824,2.572817,2.9706236,19.6103804,27.0018557,1.2718611,9.0896255,7.6221436,15.6772131,5.1562166,5.8057083,1.8817946,17.9366152),(31164,'femur.tif',227,7,81,7.8938655,10.790519,8.1426327,1.8,10.7765733,8.1686268,1.3690848,2.5827364,2.9268218,19.2852415,26.2607994,1.262836,8.9724627,7.4669801,15.2130929,5.1600167,5.7330081,1.8798434,18.0263638),(31165,'femur.tif',227,7,82,7.8890024,10.8342287,8.0969394,1.8,10.8278657,8.1386814,1.3751066,2.6035203,2.9365694,19.391876,25.7878561,1.2651223,8.7816267,7.4483292,14.8132689,5.1547916,5.7457381,1.3397057,18.0456362),(31166,'femur.tif',227,7,83,7.6525048,10.8194424,8.0452469,1.8,10.805285,8.1026956,1.4411928,2.5831586,2.9234466,19.0633536,25.1872214,1.2541139,8.6155914,7.3798619,14.3991686,5.1469181,5.753833,1.3105623,17.9366152),(31167,'femur.tif',227,7,84,7.6624851,10.8061711,8.0239244,1.8,10.7935132,8.0766132,1.4856593,2.5856475,2.8774941,19.3330412,24.8370551,1.2678465,8.6314879,7.4770599,14.3981155,5.1600167,5.7711141,1.2995443,17.9718533),(31168,'femur.tif',227,7,85,7.7456118,10.8343449,8.050977,1.8,10.834997,8.0881065,1.5317392,2.5890786,2.8776996,19.2915295,25.6251439,1.288967,8.9047321,7.4511178,14.9084463,5.1687785,5.7711141,1.2995443,17.9173428),(31169,'femur.tif',227,7,86,7.8224352,10.8492038,8.076994,1.8,10.8490306,8.115187,1.563748,2.5763677,2.8772984,19.2082214,26.0459389,1.3036744,9.0522202,7.4555434,15.5406382,5.1653001,5.7175999,1.3914575,17.9366152),(31170,'femur.tif',227,7,87,8.0342965,10.8368132,8.1144671,1.8,10.8394877,8.1519057,-1.5308001,2.6150345,2.851309,19.2786514,27.0021096,1.3369085,9.470075,7.3722361,16.1478637,5.1653001,5.7425347,1.3689064,17.9831428),(31171,'femur.tif',227,7,88,7.8458556,10.8868594,8.0653988,1.8,10.8876366,8.1142909,1.5643053,2.5717812,2.8904739,18.9705142,26.3768844,1.3075875,9.1254532,7.3764105,15.4826011,5.1653001,5.7667986,1.2815253,18.0409599),(31172,'femur.tif',227,7,89,7.881951,10.9015777,8.0685488,1.8,10.8950729,8.1292683,-1.5469281,2.5875428,2.9273504,18.9945047,26.4416753,1.3129103,9.0326308,7.3407499,15.4552323,5.1632182,5.8060812,1.1629284,18.1340152),(31173,'femur.tif',227,7,90,8.0325023,10.901029,8.1154307,1.8,10.8981544,8.1659539,-1.4888164,2.5909463,2.8786604,19.2050434,27.1360853,1.3297732,9.4266364,7.4123666,15.7726968,5.162452,5.8784301,1.2401964,18.0296704),(31174,'femur.tif',227,7,91,7.943075,10.9193617,8.0872457,1.8,10.917402,8.1350417,-1.4926584,2.5981197,2.9159326,19.3305758,26.8387715,1.3157795,9.2041811,7.4402177,15.6108072,5.1501625,5.8839515,1.2932647,18.0921638),(31175,'femur.tif',227,7,92,7.8597489,10.944495,8.0483321,1.8,10.9426429,8.0782545,-1.477554,2.6214687,2.8474992,19.3784845,26.4469158,1.2986022,9.2877695,7.3922242,15.8876613,5.1502411,5.7575001,1.2870022,17.9831428),(31176,'femur.tif',227,7,93,7.7574127,10.9769288,8.025646,1.8,10.9796893,8.0489197,-1.4963373,2.6300549,2.8243826,19.1702075,26.2399533,1.2857473,9.2905095,7.2889002,15.7842033,5.1481405,5.7167479,1.2909156,17.9366152),(31177,'femur.tif',227,7,94,7.6550156,11.0080481,7.9991966,1.8,11.0140887,7.9972012,-1.4989682,2.6451741,2.8018228,19.08236,26.0170625,1.2692649,9.2857631,7.2140279,15.7636219,5.1362408,5.6894176,1.1666638,17.9366152),(31178,'femur.tif',227,7,95,7.5363199,11.0323212,7.9442291,1.8,11.0333835,7.9424981,-1.4924196,2.6616676,2.8545342,19.0246395,25.6631937,1.2483533,8.9903262,7.1476392,15.5310027,5.136951,5.7156118,1.1560787,17.9366152),(31179,'femur.tif',227,7,96,7.4853967,11.0506128,7.9154009,1.8,11.0492027,7.9138866,-1.4732932,2.6695784,2.8937993,19.0761294,25.4271175,1.2357432,8.786759,7.145746,15.3514704,5.1290421,5.7259236,1.2126982,17.9253257),(31180,'femur.tif',227,7,97,7.3755318,11.068207,7.8875057,1.8,11.0713051,7.8894186,-1.440959,2.6692933,2.9278979,18.9666198,25.0101229,1.208649,8.5420066,7.1054835,15.0198932,5.1204686,5.7306475,1.1945543,17.9718533),(31181,'femur.tif',227,7,98,7.2983666,11.0862364,7.8524314,1.8,11.0900506,7.8540948,-1.4191364,2.6763825,2.9469112,18.8774127,24.6518865,1.1886303,8.3653306,7.0533314,14.7535095,5.1057887,5.7259236,1.2126982,17.9445981),(31182,'femur.tif',227,7,99,7.2513985,11.1054819,7.8311741,1.8,11.1120971,7.8359272,-1.3838414,2.6670846,2.9467652,18.8136671,24.4619888,1.1668143,8.3013023,7.0540195,14.6612678,5.1176647,5.7144754,1.2180903,17.9253257),(31183,'femur.tif',227,7,100,7.2318854,11.1177665,7.8117959,1.8,11.1206928,7.8173454,-1.3431818,2.6615264,2.946911,18.9794119,24.1375466,1.1439399,8.190796,7.1310253,14.6111727,5.1196912,5.7068937,1.1742314,17.952581),(31184,'femur.tif',227,7,101,7.273271,11.1285493,7.8042972,1.8,11.1271309,7.8109374,-1.3461044,2.6809132,2.9420774,19.356063,23.9757404,1.1520346,8.1492556,7.2199513,14.7163134,5.1401768,5.7049968,1.0452125,17.9911257),(31185,'femur.tif',227,7,102,7.214529,11.1366696,7.8035247,1.8,11.1423039,7.8053438,-1.3190251,2.6648734,2.9176628,19.3614376,23.5993431,1.1277985,8.088441,7.2654249,14.7115211,5.1325639,5.6722693,1.0552473,17.9173428),(31186,'femur.tif',227,7,103,7.2693387,11.1565931,7.8114908,1.8,11.1603496,7.8151291,-1.3014017,2.6701127,2.8930377,19.5641392,23.544199,1.1257362,8.1382276,7.3270836,14.880422,5.1346095,5.6681651,0.9586438,17.9173428),(31187,'femur.tif',227,7,104,7.4467907,11.1974211,7.8170179,1.8,11.2060378,7.8148873,-1.2581378,2.6943113,2.8793735,20.0017461,23.4247989,1.1237068,8.1353805,7.4236954,15.035184,5.1439189,5.6622421,0.8924256,17.8708152),(31188,'femur.tif',227,7,105,7.3062671,11.1694397,7.7924353,1.8,11.1745273,7.7898416,-1.212019,2.6512874,2.8867314,19.5890743,23.4987039,1.067577,8.1402462,7.388514,14.8950501,5.1604222,5.6703607,0.8634287,17.9173428),(31189,'femur.tif',227,7,106,7.2685311,11.1739269,7.8216583,1.8,11.1781208,7.8216819,-1.1987032,2.656584,2.8516703,19.8867605,23.110573,1.0512957,8.1042234,7.4858392,15.051858,5.1652848,5.6703607,0.8634287,17.9093599),(31190,'femur.tif',227,7,107,7.2122504,11.1839453,7.818778,1.8,11.1855102,7.8144084,-1.1659651,2.650405,2.8565599,19.813755,22.7860237,1.0155707,7.9767359,7.475746,14.8834189,5.1854437,5.6741772,0.8716037,17.9093599),(31191,'femur.tif',227,7,108,7.2649435,11.1865605,7.8322389,1.8,11.1901294,7.8383051,-1.1383146,2.641564,2.8430958,20.1677112,22.6822694,0.9981233,7.9780181,7.6347617,15.0345987,5.1822861,5.6703607,0.8634287,17.8821047),(31192,'femur.tif',227,7,109,7.3685244,11.1449082,7.8456281,1.8,11.1333556,7.8433082,-0.9986761,2.5850574,2.8030172,20.6714296,22.4589035,0.8680968,8.012403,7.9965069,14.9254934,5.1968211,5.6669237,0.8552432,17.8821047),(31193,'femur.tif',227,7,110,7.2738529,11.1853626,7.8882282,1.8,11.1773199,7.8955448,-0.9823933,2.6140078,2.8136549,20.3188025,22.3970681,0.8388425,7.9601333,7.773046,14.8291723,5.2079558,5.6741772,0.8716037,17.9013771),(31194,'femur.tif',227,7,111,7.3104253,11.1964014,7.9296042,1.8,11.1905634,7.9426175,-0.954933,2.628737,2.8424679,20.3537578,22.5798815,0.8118287,7.9437596,7.7427899,14.7688428,5.2192119,5.6783724,0.6910291,17.9093599),(31195,'femur.tif',227,7,112,7.3331198,11.188954,7.9517396,1.8,11.1970214,7.9540054,-0.8321247,2.611153,2.8942888,20.5366051,22.594834,0.6681188,7.8066964,7.8649567,14.7391815,5.2294306,5.6878954,0.6747409,17.9093599),(31196,'femur.tif',227,7,113,7.3988857,11.2416397,7.9845124,1.8,11.2377289,8.0057257,-0.8851585,2.6570112,2.8689181,20.7324796,22.6238493,0.7387784,7.885847,7.8029327,14.952564,5.2236456,5.6917952,0.7117611,17.9013771),(31197,'femur.tif',227,7,114,7.5356015,11.31291,7.9876564,1.8,11.3140639,8.0024364,-0.6920758,2.6574489,2.8429787,20.8526564,23.3340976,0.5114395,8.207623,7.8468703,15.5091895,5.2193332,5.7034787,0.6008019,17.9638704),(31198,'femur.tif',227,7,115,7.2146725,11.2805064,7.9530143,1.8,11.2856179,7.9538137,-0.7250266,2.602376,2.8365819,20.3657281,22.5637781,0.5288054,7.954566,7.8258208,15.034565,5.2060471,5.713623,0.6711438,17.9286323),(31199,'femur.tif',227,7,116,7.4305783,11.2864117,7.9597956,1.8,11.2863303,7.9656273,-0.6569291,2.6166311,2.8457737,20.968636,22.9077421,0.4618597,8.0497413,8.0136004,15.2740159,5.1941187,5.7228982,0.5640837,17.9944323),(31200,'femur.tif',227,7,117,7.7717061,11.3085299,8.0898196,1.8,11.3080679,8.1098798,-0.6450643,2.6569936,2.9070052,21.9200888,23.1300344,0.468247,7.9566539,8.2499593,15.4922482,5.1940352,5.7341408,0.675637,18.0409599),(31201,'femur.tif',227,7,118,7.2447943,11.2418862,8.0595914,1.8,11.2525368,8.0665248,-0.6816361,2.628853,2.9293343,20.1725827,23.590154,0.4793411,8.0530767,7.6735302,14.8982309,5.1796059,5.7457381,0.6962046,18.0602323),(31202,'femur.tif',227,7,119,7.0324067,11.2903325,8.0583197,1.8,11.3044809,8.0658192,-0.6255205,2.6300445,2.8850317,20.1522776,22.7725716,0.4018233,7.8933524,7.6623334,14.8368554,5.1941187,5.7521397,0.6229091,18.1067599),(31203,'femur.tif',227,7,120,7.1376019,11.3318951,8.0456225,1.8,11.3469046,8.0514273,-0.620114,2.6542,2.8810271,20.1180807,23.4941958,0.4017395,8.1547986,7.5797155,14.7825582,5.1941187,5.7743954,0.5120791,18.1340152),(31204,'femur.tif',227,7,121,6.9365071,11.307186,8.1161905,1.8,11.3121071,8.1253087,-0.5942171,2.6518527,2.8955374,20.1759421,22.9551488,0.3623672,7.9277681,7.6082438,14.7781412,5.2056312,5.7905871,0.517032,18.2270705),(31205,'femur.tif',227,7,122,6.9310683,11.3169744,8.1759526,1.8,11.3226229,8.1931663,-0.6003375,2.6361281,2.9110016,20.3220768,23.0356002,0.3686586,7.9132902,7.7090626,14.8402649,5.2229403,5.8061744,0.7172309,18.2928705),(31206,'femur.tif',227,7,123,6.7997453,11.3272343,8.1987867,1.8,11.3342612,8.227978,-0.5328319,2.6582934,2.912556,20.0847841,22.87307,0.2924324,7.8532637,7.5555181,14.5005967,5.2336159,5.8239507,0.5597969,18.3393981),(31207,'femur.tif',227,7,124,6.7429434,11.3115804,8.2176301,1.8,11.3172594,8.2365591,-0.4766745,2.7037294,2.9312043,20.1854677,22.6615456,0.2365899,7.7311383,7.4657869,14.4362194,5.2542583,5.8493574,0.3502126,18.4051981),(31208,'femur.tif',227,7,125,6.660242,11.3082166,8.2666963,1.8,11.3205353,8.2946992,-0.4843873,2.7225426,2.9544329,20.2853695,22.681489,0.2407067,7.677104,7.4508914,14.4237227,5.2957793,5.8784301,0.3129012,18.5175257),(31209,'femur.tif',227,7,126,6.7497366,11.3009892,8.3303903,1.8,11.3154551,8.3485292,-0.496349,2.7345646,2.9769576,20.9943026,22.8292283,0.2551219,7.668644,7.6773841,14.5942307,5.3272154,5.8980077,0.2652736,18.6571086),(31210,'femur.tif',227,7,127,6.9694542,11.3100235,8.3897938,1.8,11.3219177,8.3920882,-0.6506433,2.7632792,2.9597054,21.7712877,23.8368402,0.4261479,8.053788,7.8787867,15.1049182,5.3584153,5.9294893,0.1167846,18.742181),(31211,'femur.tif',227,7,128,7.1352468,11.3288284,8.4872984,1.8,11.3444104,8.5021959,-0.4846392,2.718477,3.0174518,22.5991072,24.7684936,0.2581207,8.2084139,8.3131501,15.6477715,5.4000544,5.961531,0.2623799,18.8817639),(31212,'femur.tif',227,7,129,7.4065731,11.3031765,8.6093482,1.8,11.317167,8.6225454,-0.4606175,2.7354272,3.0841039,23.2630409,26.4949675,0.2439002,8.5908156,8.5043537,16.078155,5.4492086,6.0114343,0.1372531,18.9940915),(31213,'femur.tif',227,7,130,7.9618631,11.2677145,8.6839223,1.8,11.2548502,8.6878385,-0.328462,2.7311197,3.1578606,24.489832,28.7655727,0.138089,9.1091965,8.9669566,16.8634011,5.4934177,6.0722565,0.1304033,19.1722191),(31214,'femur.tif',227,7,131,8.0414965,11.3772169,8.6744901,1.8,11.4166841,8.6499252,-0.4540623,2.7662189,3.0333233,25.4649808,29.0126006,0.2578471,9.5646252,9.2056998,17.7336058,5.5378643,6.1219644,0.1076899,19.3503467),(31215,'femur.tif',227,7,132,7.9499293,11.2999155,8.7597271,1.8,11.3041249,8.7380954,-0.3388168,2.8122753,3.1510957,26.130777,29.697698,0.1463725,9.4245625,9.2916854,17.6414819,5.5936647,6.1671488,0.069407,19.509202),(31216,'femur.tif',227,7,133,7.9222385,11.2338407,8.9105216,1.8,11.2389704,8.9228336,-0.2786029,2.8234703,3.2741123,26.1021975,31.1143097,0.0998624,9.5031285,9.2447217,17.4595501,5.6529279,6.2376528,0.0791991,19.7225678),(31217,'femur.tif',227,7,134,7.7111938,11.2877322,9.0084541,1.8,11.3104057,9.0214861,-0.3069128,2.8947998,3.2614072,26.3551365,30.8089531,0.1173063,9.4465214,9.1043038,17.4830539,5.7117779,6.2908725,0.0470856,19.8927125),(31218,'femur.tif',227,7,135,7.6890425,11.3043698,9.0876373,1.8,11.3194388,9.1113725,-0.2897165,2.930217,3.2792267,26.6838699,31.0815461,0.1045881,9.4783157,9.1064484,17.6008539,5.7758832,6.3582178,3.0898255,20.078823),(31219,'femur.tif',227,7,136,7.7695649,11.3084211,9.1545317,1.8,11.3170801,9.165487,-0.2564662,2.9475556,3.2914185,27.909423,31.447045,0.0833226,9.554253,9.4686672,17.9909675,5.8562001,6.4259522,2.9873863,20.3034783),(31220,'femur.tif',227,7,137,7.7919802,11.320269,9.1821094,1.8,11.3343561,9.1723313,-0.2602416,2.9698258,3.297819,28.191978,32.296916,0.0859851,9.7934167,9.4928052,18.0664114,5.9220002,6.5195152,3.1012106,20.6484441),(31221,'femur.tif',227,7,138,7.5955648,11.3457142,9.2487147,1.8,11.3437403,9.2381993,-0.3328289,3.0256516,3.3037169,29.1051067,31.9483309,0.135131,9.6704204,9.6194508,18.2601344,6.0134552,6.5984805,3.0667328,20.9468822),(31222,'femur.tif',227,7,139,7.551417,11.3849274,9.2911375,1.8,11.3887243,9.2722002,-0.410673,3.0843125,3.2820615,29.8898823,32.3623118,0.200593,9.8603611,9.6909385,18.382124,6.0865002,6.6887409,3.0282195,21.2453203),(31223,'femur.tif',227,7,140,7.5064053,11.3815014,9.3989641,1.8,11.3651647,9.4088447,-0.4242935,3.1255018,3.3275971,30.9560303,33.4827452,0.2120284,10.0621393,9.9043392,18.5127008,6.1852002,6.8041783,2.976444,21.7331756),(31224,'femur.tif',227,7,141,7.638698,11.311671,9.5118569,1.8,11.2630735,9.5316468,-0.0500918,3.2330862,3.5154051,32.5470802,34.8938863,0.0031918,9.9259931,10.0668766,19.005283,6.2510002,6.8915097,3.0747069,22.0974137),(31225,'femur.tif',227,7,142,7.8350475,11.2699199,9.6648931,1.8,11.2002159,9.6963219,-0.0098488,3.2605822,3.6306122,34.3345513,36.7816119,0.0001267,10.1309669,10.5301903,19.317649,6.3497002,6.9998956,3.0568901,22.6783243),(31226,'femur.tif',227,7,143,8.0187771,11.3217632,9.8036253,1.8,11.2673394,9.8330051,0.2944244,3.4185289,3.6924504,35.6690078,38.8084323,0.1125431,10.5102108,10.4340226,20.1680904,6.4155002,7.0602513,3.0669651,23.1741624),(31227,'femur.tif',227,7,144,8.4903932,11.2995414,9.9093252,1.8,11.2321752,9.9355631,0.3736695,3.4935419,3.6881637,37.7212918,41.5006189,0.1885574,11.25238,10.7974351,21.0513724,6.5295556,7.1943508,3.0178049,23.7517663),(31228,'femur.tif',227,7,145,8.7584774,11.2152891,9.9866408,1.8,11.1107969,10.0615065,0.2773291,3.5245983,3.9483734,40.3865985,43.9664118,0.1094222,11.1353226,11.4584967,21.359362,6.6286678,7.3758397,0.5595449,27.6493648),(31229,'femur.tif',227,7,146,9.1316254,11.2347861,10.0669508,1.8,11.1427309,10.1536677,0.2319772,3.595243,3.9461479,42.2591776,47.7926234,0.080442,12.1112093,11.7541922,22.7724492,6.7069621,7.600185,0.5411619,26.4137609),(31230,'femur.tif',227,7,147,9.7873609,11.1843014,10.1965873,1.8,11.0624697,10.2976348,0.3184944,3.6506952,4.0911114,45.2338755,53.0580345,0.1599496,12.9691003,12.3904826,23.9926938,6.7905526,7.6305309,0.5640837,26.6722847),(31231,'femur.tif',227,7,148,10.1239215,11.2136236,10.3083828,1.8,11.0931556,10.4429355,0.4013377,3.9154559,4.1582308,48.4697807,56.1965362,0.2574978,13.5145304,12.37909,24.9981956,0.0329,0.0465276,2.3561945,0.0930553),(31232,'femur.tif',227,7,149,10.7427091,11.2400407,10.4425625,1.8,11.1459053,10.5814414,0.5096856,4.1352948,3.9957635,52.6227504,59.9174844,0.4262156,14.9952528,12.7252718,26.8126686,7.122226,7.9207051,3.0625908,28.0315057),(31233,'femur.tif',227,7,150,11.4878525,11.2134462,10.6197767,1.8,11.0699913,10.8522138,0.3912189,4.7086208,4.1626278,58.594656,64.228362,0.2783919,15.4297632,12.444123,25.6176651,7.3523916,8.6438765,0.6937636,31.5210778),(31234,'femur.tif',227,7,151,11.6695916,11.2138324,10.722833,1.8,11.0975945,10.973918,0.5403885,4.8237346,4.2769174,61.3785729,68.3811575,0.5147818,15.9884215,12.7242849,26.4069434,7.5573802,8.7773971,0.7456313,34.0933237),(31235,'femur.tif',227,7,152,11.8149569,11.1998131,10.8376733,1.8,11.0703282,11.0644701,0.7481279,5.1468728,4.2995057,62.9630096,72.7515409,0.9112566,16.920908,12.2332553,26.1455526,7.8636027,8.817814,0.7114591,38.2959736),(31236,'femur.tif',227,7,153,12.1861361,11.2595383,10.933734,1.8,11.1199968,11.1490238,0.6772937,4.6888048,4.4104844,66.0881255,79.1340663,0.7976554,17.942262,14.0948768,30.764576,7.6926626,8.8213731,2.2769954,38.0826079),(31237,'femur.tif',227,7,154,12.7240379,11.3233574,11.0983437,1.8,11.2199276,11.3064518,0.7581649,4.7638868,4.6658697,70.515241,87.8739321,1.0026122,18.8333446,14.8020395,33.2368179,7.8553838,9.1497499,2.2747424,30.6084279),(31238,'femur.tif',227,7,155,13.8963652,11.6169651,11.3886956,1.8,11.6729163,11.6832435,0.7493475,4.7741629,6.2952384,71.9663978,116.370764,1.0746073,18.4855213,15.0741395,29.9004282,8.0878452,10.4737813,2.3872956,41.9463379),(31239,'femur.tif',227,7,156,16.3325859,11.8766867,11.9117252,1.8,12.0491444,12.3247359,0.7032123,5.3642799,6.8126443,88.0082301,169.4024084,1.1383369,24.8658819,16.4063457,36.6260319,8.454014,12.6869928,2.2034058,46.994468),(31240,'femur.tif',227,7,157,17.6782746,11.94874,12.141887,1.8,12.0372491,12.5110836,0.6672526,5.3344933,6.7437357,98.5434752,191.8013967,1.1283182,28.4414167,18.4728839,42.0435165,8.8972499,12.8001723,2.2322904,41.9323091),(31241,'femur.tif',227,7,158,20.1274331,11.8520992,12.3633795,1.8,11.8940132,12.7172197,0.560117,5.8469498,6.8350888,123.1699492,219.2436594,0.9468752,32.0761978,21.0656757,48.2013978,9.6291867,13.0927123,2.2565258,43.8663948),(31242,'femur.tif',227,7,159,21.6949985,11.6573676,12.5082184,1.8,11.5728331,12.7493288,0.3920246,5.7033675,6.5630069,143.2911455,231.9188891,0.5278032,35.3372917,25.1239544,53.4926402,9.8372086,12.9560855,2.298704,42.0226251),(31243,'femur.tif',227,7,160,26.2351789,11.8485995,13.2935254,1.8,11.8421095,13.5757418,0.672087,6.0451904,8.1691649,198.9348351,346.4123352,1.6950386,42.4048651,32.9079517,64.3748916,10.6457136,13.4123906,2.2623939,49.1744182),(31244,'femur.tif',227,7,161,30.9012118,11.6736723,13.7287552,1.8,11.6461255,13.9981266,0.5965055,6.723614,8.3999201,278.5340314,432.3942718,1.6252418,51.4759982,41.4262379,80.4190455,11.3747379,15.7785948,2.1738354,59.2819679),(31245,'femur.tif',227,7,162,34.8716897,11.5094364,14.0261475,1.8,11.4961809,14.238459,0.4407004,7.6551958,8.0253457,354.7314244,495.9388084,1.0575687,61.7965661,46.3386479,96.4417684,11.8347449,15.85664,2.1881515,60.571515),(31246,'femur.tif',227,7,163,37.9877922,11.3943018,14.1174571,1.8,11.368762,14.3108452,0.3678704,7.2875974,8.0413004,393.8681245,557.5296716,0.8188465,69.3332726,54.0463616,104.0453127,12.1744627,16.1475001,2.1853614,63.9061057),(31247,'femur.tif',227,7,164,40.2469814,11.3138496,14.1076579,1.8,11.300659,14.2825608,0.3558434,6.8020298,8.2077176,424.6071471,592.5906861,0.8141253,72.1992053,62.4235937,109.7576732,12.4457382,16.1628433,2.1971981,62.019115),(31248,'femur.tif',227,7,165,42.0858089,11.2787715,14.1149724,1.8,11.2635586,14.2811101,0.3767628,7.8118349,8.391575,458.4996438,616.1495972,0.9494517,73.4247856,58.6929507,113.9415824,12.5956819,16.3091779,2.1783823,60.1646232),(31249,'femur.tif',227,7,166,42.2692894,11.2843543,14.1115838,1.8,11.2464899,14.2951477,0.4091753,7.9041159,8.5614489,470.2634501,619.2934329,1.1151124,72.3351195,59.4960216,114.7181666,12.7003138,16.3119319,2.1856531,58.7156535),(31250,'femur.tif',227,7,167,41.666646,11.2503346,14.175695,1.8,11.1930719,14.3685147,0.385281,8.3093112,8.5619522,491.6184401,617.386853,0.9808354,72.1081876,59.1647644,115.2241417,12.7759213,16.4254057,2.1493548,70.7972032),(31251,'femur.tif',227,7,168,40.1518281,11.2448234,14.2091027,1.8,11.1881991,14.3708588,0.372437,8.3196715,8.5311141,482.9937158,596.3734588,0.8861063,69.9056948,58.0544218,113.9807405,12.7922301,16.2352087,2.1424991,68.0501362),(31252,'femur.tif',227,7,169,37.903809,11.2220362,14.2400245,1.8,11.1737763,14.3639899,0.3298674,8.1661141,8.2348873,462.5877559,561.3295986,0.6628277,68.1648188,56.6472314,109.0137242,12.7110893,16.0889414,2.1434853,60.5016061),(31253,'femur.tif',227,7,170,35.319767,11.2257307,14.2988481,1.8,11.1961036,14.4016533,0.2390973,7.8123962,7.3511521,433.2150698,518.4370887,0.3301598,70.5246033,55.4522657,102.6503497,12.611209,15.889338,2.1392724,177.8780702),(31254,'femur.tif',227,7,171,31.9475249,11.1966513,14.374007,1.8,11.1644899,14.4821708,0.1375655,7.3231365,7.2715333,394.9268965,474.6937102,0.10013,65.2811027,53.9286545,95.1726253,12.9696044,15.5853662,2.1242491,164.8918536),(31255,'femur.tif',227,7,172,29.4493211,11.1248996,14.4979236,1.8,11.0853748,14.7137545,0.1358456,7.1830476,7.0506741,368.8162217,439.3157818,0.0900206,62.308338,51.3453682,89.7740926,12.6037485,15.0302602,2.258528,62.5554349),(31256,'femur.tif',227,7,173,27.3866152,11.0713123,14.4684532,1.8,11.0461293,14.7262479,0.3583494,7.2427974,7.6557993,335.9302076,408.6392503,0.561475,53.376432,46.3812792,83.0503371,11.9172712,14.8378639,2.2808656,198.4716714),(31257,'femur.tif',227,7,174,26.0106562,11.0248867,14.6051938,1.8,10.9800975,14.855999,0.3560433,7.0853602,7.5049342,309.5464735,380.6351689,0.5267155,50.7179887,43.6881776,78.5614784,11.6220016,14.5560104,2.2826096,57.0288021),(31258,'femur.tif',227,7,175,25.0310644,11.0284682,14.7113171,1.8,10.9997849,14.9324343,0.2995918,6.7546416,7.1144398,284.9333678,348.9997028,0.3633753,49.0551209,42.1833435,78.1217947,11.3464874,14.2018676,2.249517,50.7549879),(31259,'femur.tif',227,7,176,24.7991201,10.9901734,14.7882791,1.8,10.9830045,14.9516267,0.2755718,7.4473892,6.8944026,263.5463853,328.5948957,0.3060082,47.6611121,35.3877549,71.2896678,11.4756833,13.7805454,2.2496387,53.9560417),(31260,'femur.tif',227,7,177,24.2326366,11.0088759,14.8416496,1.8,11.0334444,14.9844694,0.2570521,6.5817493,6.6600282,234.4734847,303.5100131,0.2610388,45.571881,35.6247975,71.076986,10.608771,13.3777245,2.223643,118.1335653),(31261,'femur.tif',227,7,178,23.9071648,10.9998028,14.8828582,1.8,11.0319826,14.9797742,0.2201264,5.4578375,6.3826261,201.0821803,279.2839117,0.1899745,43.7568968,36.8428299,65.8223343,10.1482894,12.86491,2.271101,85.3821272),(31262,'femur.tif',227,7,179,23.0537884,11.0346916,14.9496288,1.8,11.0812387,15.0239064,0.2031516,5.1346701,6.0865103,165.8445301,248.8568859,0.1564043,40.8866285,32.2989651,59.9576036,9.57268,12.2686569,2.2840764,40.8701566),(31263,'femur.tif',227,7,180,21.8067927,11.1026424,15.0883125,1.8,11.1392724,15.1418123,0.1844905,4.681903,5.7671753,128.3270039,216.2386676,0.1223082,37.4947275,27.4091548,53.2829812,8.9080014,11.6310228,2.29415,38.3876592),(31264,'femur.tif',227,7,181,20.175264,11.1621919,15.2631065,1.8,11.2350264,15.2901465,0.1923526,4.2122362,5.4787535,91.6201749,182.9611986,0.1228856,33.3946764,21.7509587,45.7986234,8.0834661,10.9178939,2.319963,35.8200895),(31265,'femur.tif',227,7,182,17.7624232,11.16505,15.4432642,1.8,11.2422279,15.4625201,0.1841027,3.5859136,5.1959179,56.1516544,152.8579647,0.0992108,29.4188567,15.6589534,37.7803354,7.0141876,10.1140082,2.4460214,34.8696973),(31266,'femur.tif',227,7,183,14.1489968,11.1865608,15.6487672,1.8,11.2314588,15.6687079,0.1592669,2.8170116,4.835974,26.0370586,119.5955699,0.0593131,24.7303999,9.2427942,29.073657,3.7145539,5.6802783,1.4838071,15.9386665),(31267,'femur.tif',227,7,184,7.1138029,11.342107,15.8558713,1.8,11.4328184,15.8970993,0.1635386,1.867408,4.2155605,4.9972452,58.0932665,0.0314279,13.7806743,2.6760329,14.6457142,2.253688,3.7194466,1.3022169,10.1381115),(31268,'femur.tif',227,7,185,0.2024442,14.5483774,16.7031939,1.8,14.5495767,16.6806267,1.4072071,0.754865,0.7866427,0.011212,0.0248711,0.0328458,0.0316167,0.014853,0.0438937,0.7874134,1.4524521,1.3422997,4.7078406),(31269,'femur.tif',227,7,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31270,'femur.tif',227,7,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31271,'femur.tif',227,7,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31272,'femur.tif',227,7,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31273,'femur.tif',227,7,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31274,'femur.tif',227,7,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31275,'femur.tif',227,7,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31276,'femur.tif',227,7,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31277,'femur.tif',227,7,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31278,'femur.tif',227,7,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31279,'femur.tif',227,7,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31280,'femur.tif',227,7,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31281,'femur.tif',227,7,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31282,'femur.tif',227,7,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31283,'femur.tif',227,7,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31284,'Bettongia-lesuer-tibia.tif',227,8,1,11.5108019,10.3654618,11.6644361,1.8,10.3772171,11.6384909,-1.3728683,2.8426166,3.9632191,19.4809045,31.8958355,1.8442864,8.0479616,6.8531594,12.9425812,5.6088001,7.3431722,1.0050949,23.4425792),(31285,'Bettongia-lesuer-tibia.tif',227,8,2,12.1497413,10.4129213,11.6852518,1.8,10.4522265,11.5881543,-1.377623,7.1262367,7.6207419,21.4345478,39.3321668,1.950329,5.1611992,3.0078355,5.8472903,5.691097,7.4644687,1.0688194,24.3302274),(31286,'Bettongia-lesuer-tibia.tif',227,8,3,11.7394435,10.4266572,11.6185855,1.8,10.4770336,11.5259938,-1.4312274,2.7254181,4.6750218,18.4095121,46.1791374,1.9187077,9.8778442,6.7547478,13.668273,5.2757179,8.0125037,1.1868692,23.1692068),(31287,'Bettongia-lesuer-tibia.tif',227,8,4,10.795366,10.4841993,11.3656996,1.8,10.5318974,11.3407638,-1.4092974,2.6153942,4.9722156,14.6302373,50.5088472,1.7527069,10.1582175,5.5938937,13.0264903,4.9691661,8.4492317,1.3116943,23.1354412),(31288,'Bettongia-lesuer-tibia.tif',227,8,5,9.6204185,10.6146288,10.918976,1.8,10.6336108,10.9986154,-1.4380267,2.4154224,5.2133256,11.0990491,50.5230458,1.5753043,9.6911357,4.5950758,11.7840051,4.7232001,8.9378948,1.3993129,23.6105585),(31289,'Bettongia-lesuer-tibia.tif',227,8,6,8.8541838,10.73618,10.3988088,1.8,10.7661756,10.500742,-1.4446597,2.3039131,5.039408,8.8455477,49.6735218,1.4523426,9.8570153,3.8393583,11.5575728,4.3665783,8.8652886,1.4147715,23.8580068),(31290,'Bettongia-lesuer-tibia.tif',227,8,7,7.9447081,10.8731502,9.8945905,1.8,10.8777147,9.9911393,-1.4671343,2.3211685,5.0935572,6.7838472,46.634076,1.3099402,9.1555026,2.9226001,10.4535423,3.9648206,9.0913561,1.4786666,24.8321171),(31291,'Bettongia-lesuer-tibia.tif',227,8,8,6.8799759,11.0739341,8.9916915,1.8,11.1163968,8.84264,-1.4660888,1.7123926,4.8111409,5.2896204,36.2640028,1.1341369,7.5375058,3.0890231,8.626891,3.1788819,8.3964958,1.482789,21.7199792),(31292,'Bettongia-lesuer-tibia.tif',227,8,9,6.577848,11.1755315,8.4145897,1.8,11.2502797,8.1345498,-1.4700174,1.8143773,4.8181495,4.9497628,33.5049908,1.0852111,6.9539126,2.7280779,7.974503,3.2681989,8.2099161,1.4687425,22.5211654),(31293,'Bettongia-lesuer-tibia.tif',227,8,10,6.4574371,11.2200561,8.1754812,1.8,11.2888444,7.8662637,-1.4854509,1.9550724,4.5976509,5.2969544,31.1796068,1.0684194,6.7816386,2.7093392,7.8790976,3.3456,8.5138749,1.4607773,44.491841),(31294,'Bettongia-lesuer-tibia.tif',227,8,11,7.2318296,10.9294918,7.7148383,1.8,10.8499447,7.3802832,1.3717603,3.1983704,4.0144653,12.0861386,35.0524724,1.1581836,8.7315419,3.7788427,10.3406267,3.5424,9.7481827,1.4239029,25.9960343),(31295,'Bettongia-lesuer-tibia.tif',227,8,12,10.8310792,10.2111311,6.9090027,1.8,10.1449462,6.7007284,1.0008444,3.7441586,4.1199547,18.2403845,55.9778337,1.2795854,13.5870021,4.8716911,17.9415079,6.2225469,10.7202952,1.3815014,38.4474824),(31296,'Bettongia-lesuer-tibia.tif',227,8,13,9.6776371,10.3282632,7.1958494,1.8,10.2492566,6.9380887,0.9008459,4.2544006,4.6173497,19.486078,48.9179112,0.9910299,10.5943701,4.5802171,14.8108361,6.5285402,10.6455205,1.3090031,31.4887032),(31297,'Bettongia-lesuer-tibia.tif',227,8,14,8.5684807,10.739572,7.5021328,1.8,10.6316256,7.2255982,0.6095862,4.6507742,4.8441696,18.8178102,38.8571945,0.4681084,8.0214355,4.0461673,11.4830647,0.1942134,0.5944859,1.9974238,1.3269517),(31298,'Bettongia-lesuer-tibia.tif',227,8,15,9.8604854,11.2206059,7.4996828,1.8,11.1351875,7.3513742,0.3747205,4.4363818,4.6937813,21.1346208,55.2856515,0.2201602,11.778489,4.7639319,14.6760213,0.7097751,2.3061106,2.1587989,5.4519103),(31299,'Bettongia-lesuer-tibia.tif',227,8,16,13.0493805,11.1295416,7.6349795,1.8,11.0429873,7.5402708,0.113257,4.2732398,6.1800396,32.2689387,94.0107372,0.0277786,15.2119959,7.551399,18.5310136,8.6293624,12.5421407,2.2645301,55.6896617),(31300,'Bettongia-lesuer-tibia.tif',227,8,17,18.1160111,10.767481,7.4763023,1.8,10.771848,7.3678643,0.0701326,4.0644775,5.8048605,52.5671726,158.7790776,0.0148265,27.3527808,12.9333161,32.8774616,2.6703339,6.2770023,2.5514161,17.8416206),(31301,'Bettongia-lesuer-tibia.tif',227,8,18,23.6820044,10.6813394,7.2238966,1.8,10.6257831,7.1737191,0.0870814,4.1941151,6.1277676,83.2857426,238.3532029,0.0298552,38.8972331,19.8577627,47.1163082,11.2684968,13.536797,2.3330624,90.0471509),(31302,'Bettongia-lesuer-tibia.tif',227,8,19,25.0725432,10.6070983,7.1025628,1.8,10.6494898,7.0323984,0.0793778,5.1376775,7.1563621,103.0450729,252.7873994,0.0262744,35.3234501,20.0567423,47.6139969,11.6604001,13.7923319,0.8966125,90.6078818),(31303,'Bettongia-lesuer-tibia.tif',227,8,20,25.6858104,10.4412309,7.1472625,1.8,10.4618978,7.1176977,0.0625547,5.0053594,8.0381967,111.8205739,227.7493232,0.01673,28.3333852,22.3401689,41.3628084,11.5128001,14.0516614,0.8522957,86.8147854),(31304,'Bettongia-lesuer-tibia.tif',227,8,21,26.383607,10.4097087,7.1016545,1.8,10.4648908,7.1490902,0.0470564,4.9852337,8.4705941,119.6091636,249.4505803,0.0097297,29.4490065,23.9926892,43.3942952,11.4144001,14.0797989,0.8447344,86.8197303),(31305,'Bettongia-lesuer-tibia.tif',227,8,22,23.9122387,9.8612097,6.9401197,1.8,9.9018774,6.9646584,-0.0207452,4.866393,6.8631313,101.3594351,203.4906345,0.0017149,29.6498239,20.8284524,42.4325383,1.414232,5.3900391,1.6713732,14.6619516),(31306,'Bettongia-lesuer-tibia.tif',227,8,23,19.5372944,9.7720819,6.9942067,1.8,9.7485345,6.9627425,0.0295732,4.7619566,6.5443858,83.3331042,152.2667183,0.002847,23.2667697,17.4997613,33.6778446,10.8732001,14.3576359,0.7272115,76.1283927),(31307,'Bettongia-lesuer-tibia.tif',227,8,24,3.8457949,7.6396214,8.3919385,1.8,7.5901868,8.5779885,-0.1602011,3.5511009,4.9706206,5.3624302,25.9775231,0.0163097,5.2262132,1.5100754,6.2564646,1.2612502,2.460492,1.3694792,9.3422069),(31308,'Bettongia-lesuer-tibia.tif',227,8,25,11.2655894,8.8669146,8.6205487,1.8,8.6091394,8.6915144,-0.1971047,3.1714071,5.2304729,21.0836867,79.6434378,0.0720054,15.226814,6.6480543,18.9951275,5.539907,10.1505933,0.387707,49.2092478),(31309,'Bettongia-lesuer-tibia.tif',227,8,26,16.4707592,9.3334326,8.7685987,1.8,9.1242427,8.7937841,-0.1617844,3.3082766,5.6844194,33.6546799,120.1469,0.0712268,21.1361779,10.1728736,26.9402577,6.1637015,11.2408812,0.2386093,48.1803927),(31310,'Bettongia-lesuer-tibia.tif',227,8,27,17.7299953,9.3417664,8.9149876,1.8,9.287995,8.9258509,-0.1043139,3.4912706,5.4894334,42.4044903,134.8272069,0.032038,24.5612247,12.1458617,31.8882201,6.4543857,10.9760118,0.1666225,32.7361859),(31311,'Bettongia-lesuer-tibia.tif',227,8,28,16.0406917,9.2481132,9.123934,1.8,9.2091657,9.1066329,-0.0532362,3.6728092,5.1842158,47.6661282,122.4462173,0.0075697,23.6190434,12.9781119,32.089859,6.6976885,10.4008848,0.0615336,30.2860756),(31312,'Bettongia-lesuer-tibia.tif',227,8,29,16.4062432,9.7909794,9.4186521,1.8,9.6252208,9.3713814,-0.0168558,3.5964407,5.4093904,50.9052351,116.9424148,0.0007768,21.6184092,14.1543375,31.0053491,6.7398422,10.152024,0.150807,29.6787928),(31313,'Bettongia-lesuer-tibia.tif',227,8,30,17.8066208,9.9507365,9.6569645,1.8,9.9357848,9.5789928,0.0235655,3.4713093,5.2038873,55.4591032,95.4324047,0.0016478,18.3386764,15.9764222,28.2395557,6.7308315,9.5326191,0.1345979,29.3934825),(31314,'Bettongia-lesuer-tibia.tif',227,8,31,19.5462697,9.752714,9.5602336,1.8,9.8341479,9.5598308,0.1293487,3.7869009,4.7959098,56.5337453,106.6084103,0.0542018,22.2290276,14.9287627,33.2029077,6.7404001,9.3666258,2.9833523,29.4342411),(31315,'Bettongia-lesuer-tibia.tif',227,8,32,21.0426123,9.8179077,9.5856466,1.8,9.8435896,9.5747205,0.1193075,3.7552716,4.6841123,62.0647392,118.019397,0.0496847,25.1956807,16.5273635,37.3459138,6.8721048,9.3516247,2.9937433,28.2970964),(31316,'Bettongia-lesuer-tibia.tif',227,8,33,20.9816131,9.9044866,9.6497393,1.8,9.9441742,9.6032348,0.1387145,3.8198139,4.564333,65.473688,105.0567074,0.0668565,23.0168806,17.1405439,35.9830522,7.4072667,9.0828318,0.0813419,31.5652756),(31317,'Bettongia-lesuer-tibia.tif',227,8,34,19.7538135,9.8532767,9.5948336,1.8,10.0118755,9.5761835,0.1779082,3.8500426,4.6131322,63.9803458,95.7240254,0.103111,20.7503321,16.6180876,33.5957366,7.5996574,8.9464218,2.9646904,34.3682273),(31318,'Bettongia-lesuer-tibia.tif',227,8,35,17.8528407,9.9174125,9.5988622,1.8,10.0631906,9.6035197,0.180896,3.7498665,4.5738196,55.5946,87.9077344,0.0963101,19.2197642,14.8257544,30.7659007,7.3631526,8.8866969,2.9409398,35.707117),(31319,'Bettongia-lesuer-tibia.tif',227,8,36,16.1944114,10.0779594,9.6521501,1.8,10.1310325,9.6492091,0.1652876,3.516517,4.4227223,49.7057342,78.4038412,0.0730694,17.727507,14.1349338,28.9499628,6.6185161,8.7361525,2.9143717,28.2324619),(31320,'Bettongia-lesuer-tibia.tif',227,8,37,14.6763245,10.2974528,9.726923,1.8,10.314247,9.7048536,0.1318594,3.3872445,4.2789044,45.172339,67.5582154,0.0422834,15.7886716,13.3360135,26.3192419,6.5556634,8.4642592,2.6181207,27.5724826),(31321,'Bettongia-lesuer-tibia.tif',227,8,38,13.5305142,10.3945072,9.7611772,1.8,10.4247942,9.7334872,0.1588817,3.2768589,4.1812719,40.1035304,62.1005342,0.0564486,14.852068,12.2384063,24.4409757,6.437187,8.1740141,2.5619371,27.0010136),(31322,'Bettongia-lesuer-tibia.tif',227,8,39,12.5828193,10.4855616,9.7835155,1.8,10.5186983,9.7520445,0.1704098,3.1494789,4.0881344,35.9738183,56.4546298,0.0603126,13.8093869,11.4221493,22.6089498,6.1872924,7.9140155,2.9222494,24.4236825),(31323,'Bettongia-lesuer-tibia.tif',227,8,40,11.6420393,10.6244571,9.8221781,1.8,10.6571065,9.7668295,0.195816,3.094414,3.9718417,32.3798388,52.3156398,0.0734541,13.1716327,10.4639646,20.7441161,6.0018988,7.7891542,2.6835947,23.4565653),(31324,'Bettongia-lesuer-tibia.tif',227,8,41,10.5346264,10.7590865,9.9111582,1.8,10.7679468,9.8523443,0.1829565,2.991026,3.8225194,28.2955778,46.0655189,0.0581182,12.0510883,9.4601579,18.9591834,5.7358987,7.5084424,2.7160498,22.2975929),(31325,'Bettongia-lesuer-tibia.tif',227,8,42,9.8422159,10.8957868,9.9744706,1.8,10.92815,9.9053696,0.1542262,2.8674251,3.6788058,25.7814543,41.899328,0.038709,11.389383,8.9911517,17.9440371,5.5065836,7.264293,2.7082388,21.6713791),(31326,'Bettongia-lesuer-tibia.tif',227,8,43,9.3955759,11.0367662,9.9976269,1.8,11.1021178,9.907033,0.1261046,2.8120137,3.6140471,23.8708074,40.1485624,0.0247703,11.1090313,8.4888661,16.9445661,5.3339447,7.2210115,2.644421,23.1951308),(31327,'Bettongia-lesuer-tibia.tif',227,8,44,8.8290482,11.1498946,10.0700792,1.8,11.1724413,9.9859221,0.1140944,2.9099493,3.5619712,21.851388,36.1458193,0.0190724,10.1477011,7.5091988,16.0889074,5.1936712,6.954625,2.817605,24.2367722),(31328,'Bettongia-lesuer-tibia.tif',227,8,45,8.3492944,11.2347894,10.105493,1.8,11.266172,10.0139747,0.0763338,3.292546,3.5359707,20.8896001,33.6586613,0.0080926,9.5189311,6.3445128,13.5801185,4.9522651,6.7447082,2.868303,19.6317516),(31329,'Bettongia-lesuer-tibia.tif',227,8,46,7.7445377,11.2603612,10.2345761,1.8,11.2655623,10.193193,0.1035365,3.3439675,3.4960518,17.6089587,30.9686333,0.0137873,8.8581734,5.2658881,12.1664655,4.841472,6.603256,3.0070717,19.499586),(31330,'Bettongia-lesuer-tibia.tif',227,8,47,7.4123826,11.3890032,10.2578053,1.8,11.428064,10.2070971,0.0648894,3.2292973,3.4241906,16.6630502,29.4281615,0.0051945,8.5941949,5.1599616,11.3077702,4.7223791,6.4768582,3.0426799,19.4468895),(31331,'Bettongia-lesuer-tibia.tif',227,8,48,7.0247645,11.4799526,10.3116719,1.8,11.5043527,10.26871,0.046884,3.0353358,3.3311536,15.1536167,26.7594956,0.0025717,8.0331016,4.9924021,9.5177138,4.6248001,6.3179391,2.9930878,18.5592413),(31332,'Bettongia-lesuer-tibia.tif',227,8,49,6.6882224,11.557743,10.322437,1.8,11.5661528,10.3051865,0.0501782,2.3435044,3.2527798,14.0161707,24.5176653,0.0028043,7.53745,5.9808597,11.8447234,4.5644541,6.173767,3.0538188,18.3047999),(31333,'Bettongia-lesuer-tibia.tif',227,8,50,6.5842763,11.7042615,10.384601,1.8,11.6919325,10.3833031,0.0516765,2.2870029,3.2065109,13.4630566,24.5559947,0.0029279,7.6581667,5.8867684,11.8565636,4.4772001,6.2062247,0.0475831,18.2352206),(31334,'Bettongia-lesuer-tibia.tif',227,8,51,6.5069257,11.7924002,10.4032638,1.8,11.7901724,10.4154148,0.0212817,2.2560016,3.117166,12.9912197,23.7558705,0.0004911,7.6209834,5.7585152,11.7864949,4.4280001,6.1134837,0.0644268,17.8296826),(31335,'Bettongia-lesuer-tibia.tif',227,8,52,6.6003661,11.8834077,10.4277125,1.8,11.8848857,10.4332183,0.0227865,2.2324033,3.0704139,12.7653853,23.9653843,0.0005711,7.8052618,5.7182254,11.8780214,4.3788001,6.0853062,0.1053001,17.690524),(31336,'Bettongia-lesuer-tibia.tif',227,8,53,6.5304587,11.9339628,10.4427344,1.8,11.904938,10.4437088,0.01114,2.2095092,3.0214163,12.5397679,22.8985358,0.0001351,7.5787424,5.6753635,11.6427287,4.3296001,5.9874602,0.1070275,17.4529654),(31337,'Bettongia-lesuer-tibia.tif',227,8,54,6.5462547,12.0011316,10.4728519,1.8,11.9768367,10.4666606,-0.0193398,2.1750189,3.0127393,12.3535395,22.5071664,0.000408,7.4706651,5.6797389,11.4811503,4.2804001,5.9562489,0.1325515,17.3257447),(31338,'Bettongia-lesuer-tibia.tif',227,8,55,6.6100099,12.0865247,10.5137156,1.8,12.0632995,10.5159054,-0.0121258,2.133713,2.923254,12.2744838,22.0682101,0.000162,7.5491935,5.7526405,11.6891795,4.2312001,5.8587265,0.1347713,17.1050689),(31339,'Bettongia-lesuer-tibia.tif',227,8,56,6.5906098,12.1385065,10.5358322,1.8,12.1198512,10.5324015,-0.0224289,2.1149696,2.8746541,12.1121966,21.2431702,0.0005525,7.3898179,5.7268891,11.5458493,4.2312001,5.7755017,0.1539447,16.9082689),(31340,'Bettongia-lesuer-tibia.tif',227,8,57,6.8017176,12.2501969,10.573289,1.8,12.2291785,10.5613805,-0.0267888,2.1090237,2.8613243,12.0653815,22.0436922,0.0008133,7.7040173,5.7208373,11.8670091,4.2312001,5.7681624,0.1455159,16.8794482),(31341,'Bettongia-lesuer-tibia.tif',227,8,58,6.6624553,12.2315765,10.6096172,1.8,12.2147792,10.5944601,-0.0454977,2.0838637,2.7953677,11.8795308,20.5234552,0.002297,7.3419518,5.7007235,11.4424952,4.1820001,5.6682586,0.2365578,16.5434895),(31342,'Bettongia-lesuer-tibia.tif',227,8,59,6.7006077,12.2713641,10.637582,1.8,12.2467175,10.6250273,-0.0497564,2.0948105,2.7537911,11.8529837,20.032199,0.0027625,7.2744076,5.6582607,11.4903072,4.1820001,5.5980002,0.2215288,16.4858482),(31343,'Bettongia-lesuer-tibia.tif',227,8,60,6.8498908,12.3305445,10.661393,1.8,12.309302,10.6473746,-0.0567437,2.083307,2.7581036,11.8478733,20.2283024,0.003672,7.3341343,5.6870512,11.5607558,4.1328001,5.5811107,0.1593516,16.3466895),(31344,'Bettongia-lesuer-tibia.tif',227,8,61,7.0154475,12.3532755,10.6777525,1.8,12.3404092,10.6568245,-0.0520738,2.0570022,2.7319402,11.9030853,20.1331829,0.0031677,7.3695548,5.7866175,11.6320737,4.0836001,5.5406279,0.1695282,16.2771102),(31345,'Bettongia-lesuer-tibia.tif',227,8,62,7.095233,12.4292958,10.7080051,1.8,12.4147252,10.6847875,-0.0767754,2.0941967,2.7641456,11.8053623,20.0162071,0.0069568,7.2413721,5.6371792,11.4657908,4.1328001,5.4839796,0.1621988,16.1618275),(31346,'Bettongia-lesuer-tibia.tif',227,8,63,7.1578331,12.4563821,10.7220176,1.8,12.4430974,10.6994024,-0.0928044,2.0878359,2.739907,11.8156615,19.4969931,0.0102452,7.1159325,5.6592865,11.4126369,4.1328001,5.4363218,0.3704227,16.0395516),(31347,'Bettongia-lesuer-tibia.tif',227,8,64,6.9905862,12.4048109,10.7555734,1.8,12.3850032,10.7397398,-0.065098,2.0816608,2.6353292,11.8074343,18.2291943,0.0049304,6.917236,5.6721221,11.3428115,4.0836001,5.3267948,0.3685001,15.801993),(31348,'Bettongia-lesuer-tibia.tif',227,8,65,7.256245,12.5123926,10.7785875,1.8,12.5175645,10.7514613,-0.0886741,2.1070051,2.7094849,11.8812135,19.2220863,0.0094845,7.0943692,5.6389108,11.4103146,4.1328001,5.4014789,0.3534402,15.8835102),(31349,'Bettongia-lesuer-tibia.tif',227,8,66,7.2787119,12.508217,10.8103247,1.8,12.505146,10.775636,-0.0743952,2.1027482,2.6566714,11.9606665,18.7687175,0.0067018,7.0647494,5.6881115,11.4330021,4.0836001,5.3727212,0.2782997,15.801993),(31350,'Bettongia-lesuer-tibia.tif',227,8,67,7.243561,12.4888551,10.840819,1.8,12.4714539,10.8220012,-0.0794874,2.1228903,2.6252712,11.9012273,18.195379,0.0076117,6.9308569,5.6061435,11.4247903,4.1328001,5.2809274,0.3718561,15.7155309),(31351,'Bettongia-lesuer-tibia.tif',227,8,68,7.183638,12.5189609,10.8686374,1.8,12.5051232,10.850446,-0.0865411,2.1518301,2.6138229,11.8186523,17.7858222,0.0089444,6.8045246,5.4923724,11.2654412,4.1328001,5.253353,0.3839846,15.6459516),(31352,'Bettongia-lesuer-tibia.tif',227,8,69,7.1585015,12.539965,10.8835585,1.8,12.5194118,10.8658439,-0.0926843,2.1310358,2.6167612,11.773351,17.4505164,0.0102197,6.6687463,5.5247083,11.1650391,4.0836001,5.2351205,0.3752708,15.5763723),(31353,'Bettongia-lesuer-tibia.tif',227,8,70,7.1934044,12.545712,10.9021826,1.8,12.5231268,10.8880292,-0.0909004,2.140299,2.5940471,11.7480411,17.4108893,0.0098791,6.7118631,5.4889718,11.1767606,4.1328001,5.2351205,0.3752708,15.6459516),(31354,'Bettongia-lesuer-tibia.tif',227,8,71,7.3196104,12.5745679,10.917678,1.8,12.5638087,10.9017524,-0.0896906,2.1446138,2.5990268,11.7445707,17.8724369,0.0097874,6.8765882,5.4763104,11.2389445,4.1328001,5.2818441,0.4428173,15.6867102),(31355,'Bettongia-lesuer-tibia.tif',227,8,72,7.3883485,12.5740251,10.9290515,1.8,12.5600857,10.9127403,-0.0938398,2.1310986,2.5807604,11.7581593,17.9139928,0.0108117,6.9413622,5.5174169,11.2351973,4.0836001,5.2719815,0.3926375,15.7155309),(31356,'Bettongia-lesuer-tibia.tif',227,8,73,7.2837091,12.5484087,10.9422958,1.8,12.5234183,10.9178945,-0.1076148,2.1273297,2.5477866,11.7026628,17.1788714,0.0140045,6.742665,5.5011043,10.9963669,4.0836001,5.2265594,0.3962393,15.6747723),(31357,'Bettongia-lesuer-tibia.tif',227,8,74,7.2686476,12.5311727,10.9635811,1.8,12.5195162,10.9453727,-0.1097832,2.141783,2.5560789,11.7424104,16.845523,0.0145421,6.5903767,5.4825398,10.6106467,4.1328001,5.2719815,0.3926375,15.7851102),(31358,'Bettongia-lesuer-tibia.tif',227,8,75,7.3277734,12.5452765,10.9861603,1.8,12.5377284,10.9715194,-0.1209819,2.1369159,2.5513749,11.7881001,16.8250791,0.0177886,6.5945146,5.5164081,10.6308242,4.0836001,5.2719815,0.3926375,15.506793),(31359,'Bettongia-lesuer-tibia.tif',227,8,76,7.3652624,12.547606,11.0124385,1.8,12.5362836,10.9963478,-0.1189723,2.1509296,2.5509768,11.7899038,16.7901646,0.0172933,6.581857,5.4813063,10.6668572,4.1328001,5.253353,0.3839846,15.4372137),(31360,'Bettongia-lesuer-tibia.tif',227,8,77,7.3777188,12.557458,11.0421841,1.8,12.5418218,11.028203,-0.1298554,2.1587013,2.5644859,11.7799,16.746109,0.0206181,6.5300062,5.4569384,10.6999656,4.1328001,5.2459753,0.3543799,15.3795723),(31361,'Bettongia-lesuer-tibia.tif',227,8,78,7.4298393,12.5599329,11.0639395,1.8,12.5399904,11.0453467,-0.1343838,2.1648965,2.5682213,11.8720082,16.7446047,0.0222283,6.5199228,5.4838687,10.7081849,4.0836001,5.2459753,0.3543799,15.3964551),(31362,'Bettongia-lesuer-tibia.tif',227,8,79,7.5341512,12.5696663,11.0821388,1.8,12.5532676,11.0631935,-0.1284693,2.1699662,2.5863692,12.0061485,17.1085682,0.0206106,6.6148978,5.5328735,10.8175151,4.1328001,5.2653196,0.4134805,15.4491516),(31363,'Bettongia-lesuer-tibia.tif',227,8,80,7.5540983,12.5506334,11.1069127,1.8,12.5353159,11.0797274,-0.1182083,2.178654,2.6190929,12.0789839,17.0171817,0.0175107,6.497357,5.5442415,10.6062499,4.1328001,5.2990022,0.3805064,15.506793),(31364,'Bettongia-lesuer-tibia.tif',227,8,81,7.5611021,12.5475829,11.138396,1.8,12.5412861,11.1236501,-0.1158768,2.1832347,2.623853,12.1092295,17.0478372,0.0168454,6.4972531,5.5464625,10.5677097,4.1328001,5.3174709,0.3890972,15.506793),(31365,'Bettongia-lesuer-tibia.tif',227,8,82,7.6310927,12.5389246,11.1649482,1.8,12.5308263,11.1486545,-0.106659,2.1954517,2.6220755,12.1816533,17.346263,0.014414,6.6154704,5.5485864,10.7078294,4.1328001,5.2990022,0.3805064,15.5356137),(31366,'Bettongia-lesuer-tibia.tif',227,8,83,7.7086737,12.5480093,11.1868684,1.8,12.5394584,11.1643814,-0.1072669,2.2025393,2.7521253,12.287243,17.6162532,0.0147263,6.4009634,5.5786713,10.4722191,4.1820001,5.418705,0.3619588,15.7682275),(31367,'Bettongia-lesuer-tibia.tif',227,8,84,7.738425,12.5448019,11.211176,1.8,12.5363783,11.1905914,-0.1077869,2.2039425,2.6988244,12.3966239,17.6105485,0.0149262,6.5252665,5.6247493,10.7709178,4.1328001,5.3521822,0.3275644,15.6459516),(31368,'Bettongia-lesuer-tibia.tif',227,8,85,7.7720405,12.539512,11.2350578,1.8,12.531641,11.2111664,-0.0915552,2.2085104,2.6991985,12.4807899,17.7148388,0.0108277,6.5629995,5.6512253,10.7178242,4.1328001,5.3846473,0.3448678,15.6747723),(31369,'Bettongia-lesuer-tibia.tif',227,8,86,7.8893768,12.55828,11.263025,1.8,12.5493704,11.2421363,-0.0828327,2.2199456,2.7165549,12.567727,18.29983,0.0090012,6.736411,5.661277,10.9446159,4.1820001,5.4151301,0.3045109,15.7274688),(31370,'Bettongia-lesuer-tibia.tif',227,8,87,7.8843177,12.5531997,11.2946821,1.8,12.5457577,11.268293,-0.0769116,2.2245563,2.727077,12.6240614,18.2999866,0.0077578,6.7104767,5.6748673,10.7643438,4.1328001,5.4647449,0.3587707,15.801993),(31371,'Bettongia-lesuer-tibia.tif',227,8,88,7.9170431,12.5573531,11.320701,1.8,12.5397291,11.296728,-0.0766168,2.2431879,2.656776,12.6564994,18.4581313,0.0077306,6.9475678,5.6421932,11.3127755,4.1820001,5.3553472,0.3566201,15.7851102),(31372,'Bettongia-lesuer-tibia.tif',227,8,89,7.8701247,12.5455111,11.3585431,1.8,12.5288481,11.3337547,-0.0673803,2.2613273,2.6646621,12.6975272,18.3000797,0.0059462,6.8676925,5.6150771,11.1972758,4.1820001,5.3682138,0.3072588,15.7851102),(31373,'Bettongia-lesuer-tibia.tif',227,8,90,7.886737,12.5385815,11.3846269,1.8,12.5243153,11.3603287,-0.0557923,2.2569735,2.6641606,12.7584217,18.3863302,0.0040874,6.9013594,5.6528895,11.1883397,4.1820001,5.3864452,0.2870824,15.7851102),(31374,'Bettongia-lesuer-tibia.tif',227,8,91,8.0335219,12.5553953,11.4148178,1.8,12.5495198,11.3882846,-0.0404969,2.2760855,2.7282732,12.8254062,19.204873,0.0021946,7.0392045,5.6348526,11.3443252,4.1820001,5.4543255,0.2646698,15.8954482),(31375,'Bettongia-lesuer-tibia.tif',227,8,92,8.0074836,12.5289767,11.4435693,1.8,12.5136265,11.4120806,-0.0210973,2.2558036,2.6433371,12.8657648,19.128635,0.0005939,7.2365477,5.7034063,11.5109732,4.1820001,5.4005826,0.2958198,15.8546895),(31376,'Bettongia-lesuer-tibia.tif',227,8,93,8.0060227,12.5225782,11.465559,1.8,12.5121948,11.4352489,-0.0090596,2.2702024,2.6389548,12.9297752,19.1180533,0.0001095,7.244555,5.6954284,11.5417155,4.1820001,5.406854,0.2670501,15.8546895),(31377,'Bettongia-lesuer-tibia.tif',227,8,94,8.0125351,12.5032193,11.4911952,1.8,12.4917399,11.4629989,0.0100911,2.2896207,2.6435133,13.0077284,19.1387542,0.000136,7.2398932,5.6811717,11.5317396,4.1820001,5.4151301,0.3045109,15.9819102),(31378,'Bettongia-lesuer-tibia.tif',227,8,95,8.0695116,12.4923484,11.5185291,1.8,12.4800483,11.4924098,0.0141547,2.2701575,2.6525475,13.0728347,19.345734,0.0002694,7.2932659,5.7585584,11.6745072,4.1820001,5.420045,0.2758059,15.9242688),(31379,'Bettongia-lesuer-tibia.tif',227,8,96,8.1038278,12.4720953,11.542831,1.8,12.4663259,11.5160347,0.0309873,2.2928954,2.6609952,13.1860746,19.381687,0.0012965,7.2836235,5.7508399,11.6758533,4.1820001,5.420045,0.2758059,15.9242688),(31380,'Bettongia-lesuer-tibia.tif',227,8,97,8.099051,12.4451737,11.5697689,1.8,12.444945,11.5394254,0.0531894,2.3117852,2.6701792,13.26701,19.3581633,0.0038153,7.2497618,5.7388594,11.6661549,4.2312001,5.4175881,0.2383708,16.0226688),(31381,'Bettongia-lesuer-tibia.tif',227,8,98,8.1355128,12.4383832,11.5935345,1.8,12.4384727,11.5660786,0.0631967,2.29695,2.6736259,13.3752852,19.4320536,0.0054081,7.2680526,5.8230633,11.678771,4.1820001,5.4416624,0.2559431,16.0226688),(31382,'Bettongia-lesuer-tibia.tif',227,8,99,8.1842905,12.4155991,11.6161256,1.8,12.415268,11.5890229,0.0808682,2.3163118,2.6809628,13.4810079,19.5529651,0.008901,7.2932624,5.8200317,11.6954348,4.2312001,5.4654093,0.2362453,16.0346068),(31383,'Bettongia-lesuer-tibia.tif',227,8,100,8.2290536,12.3903496,11.6371652,1.8,12.3914098,11.6075165,0.0966048,2.3187476,2.6909154,13.5441223,19.7079985,0.0127598,7.3239013,5.841137,11.699119,4.2312001,5.467402,0.2733553,16.0753654),(31384,'Bettongia-lesuer-tibia.tif',227,8,101,8.2067052,12.3550806,11.6569702,1.8,12.3507543,11.6286484,0.1151126,2.3249348,2.6693567,13.613455,19.6622123,0.0180445,7.3658991,5.8554135,11.7438319,4.2804001,5.4416624,0.2559431,16.1041861),(31385,'Bettongia-lesuer-tibia.tif',227,8,102,8.1525517,12.327683,11.6699204,1.8,12.333007,11.643477,0.1387598,2.3093839,2.8132316,13.6196338,19.652403,0.0259945,6.985704,5.8975184,11.1455914,4.2804001,5.5191788,0.1973956,16.1857033),(31386,'Bettongia-lesuer-tibia.tif',227,8,103,8.1837748,12.3000581,11.688288,1.8,12.3091858,11.6598306,0.1596877,2.3183264,2.7423923,13.7683503,19.7007689,0.0344866,7.1837894,5.938918,11.5390276,4.2804001,5.4912579,0.2167253,16.1449447),(31387,'Bettongia-lesuer-tibia.tif',227,8,104,8.2251398,12.2798041,11.704802,1.8,12.2940089,11.6752584,0.1767285,2.3236434,2.7433793,13.8685976,19.9095337,0.042372,7.2573025,5.9684708,11.5884828,4.2804001,5.5020473,0.2254584,16.1857033),(31388,'Bettongia-lesuer-tibia.tif',227,8,105,8.309971,12.2557858,11.7175641,1.8,12.2711392,11.6881233,0.1886559,2.3173593,2.9459445,14.0568522,20.4210418,0.0487114,6.9319166,6.0658924,10.9986416,4.3296001,5.7161,0.2345406,16.7135171),(31389,'Bettongia-lesuer-tibia.tif',227,8,106,8.3332656,12.221117,11.7276117,1.8,12.247557,11.6980728,0.1951263,2.33067,2.8548322,14.2426392,20.4261059,0.0522128,7.1549235,6.1109635,11.5422928,4.369153,5.558076,0.1869793,16.3367998),(31390,'Bettongia-lesuer-tibia.tif',227,8,107,8.3648786,12.1930149,11.7391851,1.8,12.2045266,11.7078677,0.2130487,2.3324615,2.7872915,14.4118112,20.5356186,0.0623283,7.3675893,6.1787993,11.8788786,4.3788001,5.4912579,0.2167253,16.2960412),(31391,'Bettongia-lesuer-tibia.tif',227,8,108,8.381833,12.1609409,11.7513266,1.8,12.1713458,11.7236305,0.2358684,2.3329387,2.794722,14.5404916,20.64137,0.0762884,7.3858402,6.2326933,11.875013,4.4189783,5.4921395,0.1710396,16.3079792),(31392,'Bettongia-lesuer-tibia.tif',227,8,109,8.3161383,12.1348565,11.7682249,1.8,12.1448822,11.7370789,0.254668,2.3361558,2.8818217,14.5687559,20.7134195,0.087965,7.187613,6.2362091,11.6719218,4.4280001,5.5176435,0.1431581,16.3199171),(31393,'Bettongia-lesuer-tibia.tif',227,8,110,8.3647115,12.1060879,11.7835776,1.8,12.1167266,11.759319,0.2600611,2.3559963,2.9386662,14.7309208,21.1057787,0.0921802,7.1820947,6.2525229,11.7589405,4.4747122,5.5369131,3.0436923,16.430255),(31394,'Bettongia-lesuer-tibia.tif',227,8,111,8.29863,12.0877884,11.7925004,1.8,12.09955,11.7715343,0.2937507,2.3497856,2.8918819,14.7843007,21.0344044,0.1159539,7.2736042,6.2917659,11.8736633,4.5059089,5.5191788,2.9441971,16.4590757),(31395,'Bettongia-lesuer-tibia.tif',227,8,112,8.3105721,12.0572185,11.7996905,1.8,12.0663654,11.7755799,0.3163931,2.3579457,2.8823751,14.9060652,21.1161296,0.1340891,7.3259478,6.321632,12.0078779,4.5264001,5.523782,2.8339257,16.3894964),(31396,'Bettongia-lesuer-tibia.tif',227,8,113,8.260749,12.0227512,11.8093197,1.8,12.0354608,11.7859006,0.3587589,2.3501319,2.8734691,15.0341528,21.0411334,0.1697308,7.3225542,6.3971526,11.8903283,4.5756001,5.5419384,2.8535372,16.4710136),(31397,'Bettongia-lesuer-tibia.tif',227,8,114,8.2608577,11.9972262,11.8181342,1.8,12.0128914,11.7955429,0.3855159,2.348516,3.0418201,15.1664237,21.2642125,0.1946864,6.9906214,6.4578755,11.6126419,4.6414177,5.7376567,2.7547169,16.7085722),(31398,'Bettongia-lesuer-tibia.tif',227,8,115,8.2582548,11.9821903,11.8197156,1.8,11.9978509,11.8027882,0.4298799,2.3877251,3.0177976,15.3086301,21.3373373,0.2390631,7.0704999,6.4113871,11.6268882,4.6618136,5.7650141,2.7658406,16.6797515),(31399,'Bettongia-lesuer-tibia.tif',227,8,116,8.3099777,11.9730709,11.8309826,1.8,11.9959129,11.8222453,0.4776362,2.4153983,2.8669397,15.5322328,21.5355002,0.2926592,7.5116683,6.4305059,12.2725915,4.6778822,5.6802035,2.7128146,16.6966343),(31400,'Bettongia-lesuer-tibia.tif',227,8,117,8.4129994,11.9595411,11.8284745,1.8,11.9889699,11.8252987,0.5203957,2.4620258,2.8973407,15.7608583,22.0074221,0.3466593,7.5957314,6.4015813,12.5783433,4.6765475,5.8089347,2.4642062,18.1100481),(31401,'Bettongia-lesuer-tibia.tif',227,8,118,8.4429007,11.9206714,11.8174953,1.8,11.9359933,11.805635,0.5679447,2.4826762,2.8419281,15.9388649,22.0848241,0.4071407,7.7710707,6.4200337,12.4959035,4.6685557,5.730269,2.6203166,16.8646136),(31402,'Bettongia-lesuer-tibia.tif',227,8,119,8.481845,11.892689,11.8113005,1.8,11.9130374,11.8024312,0.6318369,2.4994157,2.8575424,16.0491639,22.4043534,0.4931365,7.8404273,6.4211663,12.6775286,4.6665063,5.7549281,2.6129028,16.8526757),(31403,'Bettongia-lesuer-tibia.tif',227,8,120,8.4875725,11.8732845,11.8027504,1.8,11.8874133,11.7890587,0.6873285,2.5099295,2.9037653,16.0457654,22.8390595,0.5694566,7.8653257,6.3929148,12.889269,4.6578859,5.7734057,2.5748634,16.922255),(31404,'Bettongia-lesuer-tibia.tif',227,8,121,8.5391258,11.8511965,11.7977956,1.8,11.8598389,11.7789177,0.7207411,2.5123172,2.9284574,16.1683841,23.3400769,0.6198309,7.9700927,6.435646,13.0990919,4.65164,5.7999685,2.5677068,16.9918343),(31405,'Bettongia-lesuer-tibia.tif',227,8,122,8.6099637,11.8284878,11.792617,1.8,11.8338878,11.7652609,0.7549846,2.5015716,2.9527267,16.2872578,23.8408167,0.6738806,8.0741697,6.5108103,13.2514872,4.6383022,5.8131003,2.5488952,17.0614136),(31406,'Bettongia-lesuer-tibia.tif',227,8,123,8.5557475,11.8022847,11.7844959,1.8,11.8004421,11.7526684,0.8026961,2.482517,3.0143975,16.2483453,24.2544648,0.7376401,8.0462064,6.5451093,13.2140623,4.6270138,5.8454901,2.5115587,17.1309929),(31407,'Bettongia-lesuer-tibia.tif',227,8,124,8.5358459,11.7639736,11.7790072,1.8,11.758923,11.7435843,0.8458271,2.4539288,3.0470256,16.3672923,24.6595464,0.7970801,8.0929895,6.6698319,13.2234057,4.6039162,5.8746119,2.5047916,17.2005722),(31408,'Bettongia-lesuer-tibia.tif',227,8,125,8.4958478,11.7411727,11.7716704,1.8,11.733904,11.7302724,0.8844347,2.4501501,3.1140691,16.3656847,25.121267,0.8473054,8.0670229,6.6794622,13.1702757,4.6098409,5.9164919,2.4681504,17.2989722),(31409,'Bettongia-lesuer-tibia.tif',227,8,126,8.4200346,11.720355,11.7512735,1.8,11.7195684,11.7091276,0.9272425,2.4337874,3.159048,16.3728508,25.7397365,0.898066,8.147941,6.7273136,13.1798933,4.6037767,5.9728882,2.4964441,17.4500688),(31410,'Bettongia-lesuer-tibia.tif',227,8,127,8.4251234,11.7078483,11.7135604,1.8,11.7050674,11.6684696,0.9670099,2.4348352,3.2172782,16.4898529,26.5012935,0.9515399,8.237178,6.7724719,13.2424193,4.5960593,6.0241378,2.4719537,17.629986),(31411,'Bettongia-lesuer-tibia.tif',227,8,128,8.5231556,11.6893716,11.6627901,1.8,11.6791682,11.5850155,1.0103268,2.4339889,3.2656144,16.5152417,27.5591877,1.0191115,8.4392045,6.7852576,13.3718539,4.5960593,6.0729624,2.4364813,17.728386),(31412,'Bettongia-lesuer-tibia.tif',227,8,129,8.4895649,11.6628868,11.6357168,1.8,11.6460031,11.5692802,1.0202339,2.4187561,3.3263629,16.4557474,28.5869174,1.0276572,8.5940466,6.8033926,13.3662519,4.6021659,6.1328546,2.4129516,17.8844274),(31413,'Bettongia-lesuer-tibia.tif',227,8,130,8.2903438,11.6626482,11.6084545,1.8,11.6496443,11.5417486,1.0601404,2.4193839,3.4139242,16.3796323,29.0719624,1.051663,8.5157023,6.7701668,13.1613408,4.6131552,6.2066147,2.2888806,18.0931653),(31414,'Bettongia-lesuer-tibia.tif',227,8,131,8.1991869,11.6723173,11.5640415,1.8,11.6558811,11.4956866,1.0939008,2.4202909,3.5004842,16.1847465,30.2872752,1.0785998,8.6523101,6.6871079,13.1786848,4.6233913,6.3131481,2.2844944,18.3714826),(31415,'Bettongia-lesuer-tibia.tif',227,8,132,8.1391115,11.6692565,11.5203667,1.8,11.6508677,11.44423,1.1185564,2.4362817,3.5599418,16.072129,31.5087292,1.0974877,8.8509114,6.5969911,13.1969651,4.6432066,6.387858,2.2744101,18.5563446),(31416,'Bettongia-lesuer-tibia.tif',227,8,133,8.1947365,11.6797252,11.4748598,1.8,11.6564224,11.4014446,1.1353072,2.4374001,3.6836442,16.2008846,33.20189,1.1227325,9.013327,6.6467893,13.3367481,4.650143,6.514682,2.2007031,18.7939033),(31417,'Bettongia-lesuer-tibia.tif',227,8,134,8.187892,11.6766707,11.4177783,1.8,11.641671,11.3204558,1.154338,2.4597093,3.7520471,16.1654207,34.7995258,1.141338,9.2748105,6.5720859,13.5049845,4.65651,6.6232046,2.1979542,19.0195239),(31418,'Bettongia-lesuer-tibia.tif',227,8,135,8.2394873,11.6779715,11.3749832,1.8,11.6379677,11.2485947,1.1715827,2.4687606,3.95328,16.324349,36.3502206,1.1657735,9.1949522,6.612366,13.2072985,4.6721825,6.8430462,2.1149149,19.6049791),(31419,'Bettongia-lesuer-tibia.tif',227,8,136,8.1610386,11.6841096,11.377652,1.8,11.6434086,11.2620237,1.197319,2.458334,4.0897389,16.6098058,37.2608718,1.1791077,9.1108192,6.7565294,13.066827,4.7037028,6.9934993,1.6977691,19.8017791),(31420,'Bettongia-lesuer-tibia.tif',227,8,137,8.1057459,11.6942619,11.3720462,1.8,11.65782,11.2403697,1.2131593,2.4644427,4.291759,16.8673392,38.836196,1.1854069,9.0490161,6.8442814,12.8448611,4.7477961,7.2317307,1.6867127,20.2768963),(31421,'Bettongia-lesuer-tibia.tif',227,8,138,8.0826794,11.672605,11.3163466,1.8,11.6422273,11.1687059,1.2390042,2.4506013,4.4007047,17.2424444,40.5938841,1.2041775,9.2244053,7.0360057,12.992509,4.8011691,7.4488866,1.6435156,20.7520136),(31422,'Bettongia-lesuer-tibia.tif',227,8,139,8.1802111,11.6652793,11.259808,1.8,11.618412,11.080818,1.2601693,2.4705519,4.4683002,17.7116869,43.1158921,1.2359953,9.6492827,7.1691216,13.446393,4.8433417,7.5997679,1.6485613,21.1456136),(31423,'Bettongia-lesuer-tibia.tif',227,8,140,8.2613676,11.6721476,11.2269666,1.8,11.6160891,11.0351562,1.2780845,2.4884505,4.5966046,18.418453,44.9924135,1.262253,9.7881843,7.4015749,13.5869596,4.8844404,7.8326957,1.5205243,21.6783722),(31424,'Bettongia-lesuer-tibia.tif',227,8,141,8.2937066,11.6708344,11.1795799,1.8,11.6300845,10.9875444,1.2943094,2.5380762,4.6782926,19.0298872,47.0121565,1.279281,10.0489987,7.4977605,13.8859749,4.9478317,7.9922369,1.4968573,22.0958481),(31425,'Bettongia-lesuer-tibia.tif',227,8,142,8.3611391,11.6975802,11.1409528,1.8,11.6557221,10.9336314,1.3175135,2.6356048,4.7015114,19.550887,49.7617654,1.306021,10.584206,7.4179887,14.5478286,5.038187,8.1227696,1.4554569,22.8781032),(31426,'Bettongia-lesuer-tibia.tif',227,8,143,8.4201582,11.7222159,11.1266597,1.8,11.69625,10.9235077,1.3348414,2.7901543,4.8017171,20.4634767,52.4210955,1.3266673,10.9171562,7.3341739,14.9402714,5.1560567,8.3239655,1.4523064,23.5380825),(31427,'Bettongia-lesuer-tibia.tif',227,8,144,8.4621515,11.7300615,11.0649434,1.8,11.7053632,10.8650491,1.3467325,2.8540352,4.8361139,21.2586681,55.1308323,1.3407291,11.3998208,7.4486356,15.38321,5.2524063,8.5036334,1.4722791,24.3372205),(31428,'Bettongia-lesuer-tibia.tif',227,8,145,8.5245742,11.7147422,10.988089,1.8,11.6972304,10.7745597,1.3642183,2.9700719,4.8931356,22.2072566,57.7202433,1.3609896,11.7961666,7.4770097,16.0127105,5.4099749,8.6487108,1.4280948,24.9107377),(31429,'Bettongia-lesuer-tibia.tif',227,8,146,8.5571166,11.7229305,10.9099383,1.8,11.7142461,10.6953159,1.385339,3.0883019,4.9679161,22.9227892,60.5429727,1.3776931,12.1867946,7.4224573,16.6510219,5.3568134,8.7816144,1.4415769,24.3083998),(31430,'Bettongia-lesuer-tibia.tif',227,8,147,8.7572817,11.738248,10.8380176,1.8,11.7160312,10.5809648,1.3870175,3.7148231,5.0946062,24.088518,64.9473196,1.4108037,12.7482513,6.484432,17.32834,5.4802969,8.9808533,1.4940244,25.8560273),(31431,'Bettongia-lesuer-tibia.tif',227,8,148,8.9878983,11.7822667,10.8056478,1.8,11.7849581,10.5758606,1.3831281,3.8207783,5.2225697,25.9151332,69.8867401,1.4458415,13.3816769,6.7826844,18.2169903,5.5987733,9.1939519,1.4743226,27.5069997),(31432,'Bettongia-lesuer-tibia.tif',227,8,149,9.1657636,11.7726429,10.7728463,1.8,11.7395007,10.4824913,1.397789,3.3306245,5.2709645,27.0647639,73.4001509,1.4823574,13.9253737,8.1260327,18.9028722,5.8908328,9.3932066,1.4288993,28.8339514),(31433,'Bettongia-lesuer-tibia.tif',227,8,150,9.5470402,11.8021338,10.7311996,1.8,11.7843919,10.4523593,1.4091846,3.4290558,5.3302266,29.603342,79.6852107,1.5499751,14.9496855,8.6330883,20.1647851,5.8823227,9.6020706,1.3904845,28.2415032),(31434,'Bettongia-lesuer-tibia.tif',227,8,151,9.7648614,11.8431319,10.7367823,1.8,11.807228,10.5084907,1.4265952,3.4676638,5.4968013,31.8809623,84.2849257,1.5938691,15.3334496,9.1937871,20.8300203,6.2600418,9.838524,1.4303137,32.0663169),(31435,'Bettongia-lesuer-tibia.tif',227,8,152,10.1789048,11.8900104,10.7423799,1.8,11.8985175,10.5347789,1.4360738,3.5925261,5.5815072,35.0501102,89.500799,1.6658785,16.0352383,9.7563969,21.8605978,6.349977,10.046563,1.3935709,30.8855169),(31436,'Bettongia-lesuer-tibia.tif',227,8,153,10.5022271,11.9574103,10.7790314,1.8,11.9461624,10.6335005,1.4460484,3.518945,5.7220569,37.7721849,94.2012015,1.7232728,16.4628215,10.7339515,22.6761381,6.5717807,10.2158443,1.41119,29.582441),(31437,'Bettongia-lesuer-tibia.tif',227,8,154,10.950492,11.9825,10.8475094,1.8,11.9862811,10.7961532,1.4560101,3.6681394,5.8690428,41.5636702,99.6171604,1.8011404,16.9733233,11.3309954,23.7838066,6.7297331,10.354584,1.3892429,29.9422755),(31438,'Bettongia-lesuer-tibia.tif',227,8,155,11.1213912,12.0315773,10.9079294,1.8,12.0413326,10.8920545,1.4661067,3.8350707,5.9914506,44.8745564,102.517093,1.8333244,17.1105631,11.7011027,24.398114,6.923155,10.482718,1.4010181,29.3329445),(31439,'Bettongia-lesuer-tibia.tif',227,8,156,11.6507176,12.0651553,10.9503209,1.8,12.0912242,10.9747679,1.4826444,4.01417,6.0439026,50.0512699,108.0446287,1.9267362,17.8766331,12.4686473,25.9852842,7.1183115,10.6538168,1.3897037,30.3646962),(31440,'Bettongia-lesuer-tibia.tif',227,8,157,12.3895906,12.1210177,11.0480198,1.8,12.1286225,11.1032325,1.4957622,4.2327294,6.1501097,56.2790835,116.1139371,2.0533278,18.8799782,13.2961685,27.8888449,7.4244089,10.799148,1.4198789,31.1708272),(31441,'Bettongia-lesuer-tibia.tif',227,8,158,13.2897633,12.2130857,11.1620084,1.8,12.2225284,11.2008286,1.4989697,4.3411132,6.3248844,65.5504347,125.6116359,2.2035531,19.8599102,15.0999138,30.1428591,7.8793846,10.9524992,1.4174639,32.5792961),(31442,'Bettongia-lesuer-tibia.tif',227,8,159,14.6029185,12.2893589,11.2027305,1.8,12.2781248,11.2896935,1.5071252,4.8048632,6.4688542,76.3570438,140.2043434,2.4239663,21.6737522,15.8916165,33.420964,8.2908697,11.2350655,1.3991683,35.4299995),(31443,'Bettongia-lesuer-tibia.tif',227,8,160,16.3471704,12.3489719,11.2882324,1.8,12.3356574,11.378917,1.5053681,4.8330563,6.6000652,92.4237895,157.5173798,2.7128817,23.8660339,19.1232594,37.7873315,8.747159,11.4468007,1.3497964,39.8839237),(31444,'Bettongia-lesuer-tibia.tif',227,8,161,18.5862339,12.4469094,11.393745,1.8,12.4251565,11.4589197,1.5154731,5.0294688,6.7121465,112.9803815,176.7955404,3.0882343,26.3396427,22.4636806,43.1218649,9.0098924,11.7427323,1.3725791,37.6376064),(31445,'Bettongia-lesuer-tibia.tif',227,8,162,21.386192,12.5843204,11.6144999,1.8,12.5699422,11.6534079,1.4960381,5.4019221,6.9803884,140.7635331,196.7553194,3.5444819,28.1868727,26.0580459,48.2787974,9.5523098,12.055205,1.348586,42.2039167),(31446,'Bettongia-lesuer-tibia.tif',227,8,163,25.5304948,12.8619244,11.9216426,1.8,12.8379,11.8877312,1.4052618,5.7000881,7.2572628,182.3405839,222.5619014,4.1395472,30.6674718,31.9890819,55.4207552,10.0957533,12.3706453,1.3624808,50.8305511),(31447,'Bettongia-lesuer-tibia.tif',227,8,164,31.0003858,12.8423443,12.1205258,1.8,12.7288639,12.0311127,-1.074231,6.1567901,6.4366643,230.6959312,252.0583589,3.9940633,39.1597799,37.4701636,65.1679296,10.4786346,12.8518463,1.3193182,45.9422683),(31448,'Bettongia-lesuer-tibia.tif',227,8,165,35.505585,12.681506,12.2063284,1.8,12.6377448,12.0891842,-0.6808513,6.1389698,5.991527,253.0050962,290.865807,2.3446304,48.5461899,41.212957,73.1557028,10.5504569,13.0957981,1.3549799,39.4944201),(31449,'Bettongia-lesuer-tibia.tif',227,8,166,37.8086902,12.5661132,12.1491897,1.8,12.5871604,12.0789523,-0.8763557,5.6195584,6.2644586,270.8922503,324.225161,3.7207324,51.7562938,48.2052557,81.7066473,10.689076,13.185692,1.3258177,40.4755235),(31450,'Bettongia-lesuer-tibia.tif',227,8,167,40.7480264,12.8760799,12.1378587,1.8,12.9024801,12.1457289,-0.7530863,7.0911688,6.4624993,353.3304166,361.0949314,3.1763806,55.8754308,49.8268233,92.3926831,11.7493977,13.3745295,1.2874437,52.8393097),(31451,'Bettongia-lesuer-tibia.tif',227,8,168,41.5665891,13.2882896,12.1211811,1.8,13.194038,12.1476452,0.5387377,6.4481859,7.1868083,355.0866796,402.3799355,1.8235492,55.9886834,55.0676861,102.1110842,11.6597049,13.2106354,1.2643567,46.9868064),(31452,'Bettongia-lesuer-tibia.tif',227,8,169,41.0388316,13.2107221,12.1198072,1.8,13.1796016,12.0920062,0.0895655,7.2491037,7.36673,362.7396714,424.9878355,0.0547223,57.6901606,50.0392444,105.9857279,11.7765981,13.3000261,1.2935129,45.1361373),(31453,'Bettongia-lesuer-tibia.tif',227,8,170,37.7924751,13.1498161,11.9664592,1.8,13.1836296,12.0723071,-0.0721928,7.0752069,7.2352289,372.4876261,408.7132132,0.0327708,56.4893271,52.6468883,103.4734602,12.0044547,13.5485939,0.1567907,58.7474062),(31454,'Bettongia-lesuer-tibia.tif',227,8,171,35.4535255,13.151578,11.9392713,1.8,13.236899,12.1445463,-0.6248218,6.2238847,6.9060006,372.9464442,400.7417068,2.0218535,58.0280443,59.9218108,102.5748091,12.2396405,13.8798076,1.2647396,48.4380821),(31455,'Bettongia-lesuer-tibia.tif',227,8,172,33.8844507,13.1778936,11.9280069,1.8,13.2588911,12.2009269,-0.8302743,6.7306905,7.6302751,340.0425941,401.8554642,3.0767978,52.665921,50.5212051,95.809672,12.1490262,14.5083286,1.1921791,49.3067994),(31456,'Bettongia-lesuer-tibia.tif',227,8,173,25.3976759,13.0294435,10.904747,1.8,13.1257226,10.8658016,-0.3139737,5.4738556,6.4539277,176.0936115,245.7198545,0.4037488,38.0729172,32.1699412,60.5878366,10.1440755,12.2009058,0.9660168,40.6583374),(31457,'Bettongia-lesuer-tibia.tif',227,8,174,20.6448923,12.9958149,10.8560645,1.8,13.2049339,10.7377909,-0.1882441,5.3733809,6.8252385,110.1703901,167.0377535,0.1204947,24.4735411,20.5029929,38.0136426,8.6915294,11.333741,0.2860514,37.5433029),(31458,'Bettongia-lesuer-tibia.tif',227,8,175,12.19082,13.2463511,11.3033258,1.8,13.2152447,11.159095,0.0721737,5.9632537,5.0744613,40.1311354,52.1321381,0.0105654,10.273433,6.729738,15.0977467,6.5658982,10.4694318,0.1891008,42.7992615),(31459,'Bettongia-lesuer-tibia.tif',227,8,176,8.1451501,13.4043596,11.5883392,1.8,13.4552177,11.5119541,-0.0442176,3.1771578,4.8374346,14.8386002,22.8157813,0.0026525,4.7165043,4.6704008,7.6925273,1.772095,3.1763545,1.2882414,12.7009446),(31460,'Bettongia-lesuer-tibia.tif',227,8,177,4.1977715,13.5352299,12.0146159,1.8,13.793152,11.9272595,-0.2964122,2.7312155,4.6678309,4.4939346,7.5707491,0.0596902,1.6218988,1.6453973,2.5846034,2.8049286,4.7855695,1.8307365,13.8191584),(31461,'Bettongia-lesuer-tibia.tif',227,8,178,1.5502402,14.2264963,12.4851335,1.8,14.2328819,12.4051619,-0.5510986,2.5715717,3.6070044,0.8579488,3.3471224,0.0708412,0.9279507,0.3336282,1.1657486,1.812615,3.1136254,2.1193457,9.1614412),(31462,'Bettongia-lesuer-tibia.tif',227,8,179,17.6369772,14.8207762,15.8052132,1.8,14.9596564,15.799432,-0.1148177,4.3088677,6.873388,52.4264722,276.3466062,0.0385817,40.2052972,12.167111,47.1193511,0.0492,0.2028568,1.815775,0.4343586),(31463,'Bettongia-lesuer-tibia.tif',227,8,180,16.0360468,14.8797348,15.7781271,1.8,14.9952846,15.8099904,-0.1104774,3.8401874,6.8194936,47.0789931,250.3129452,0.0324882,36.7055036,12.2595561,41.9581338,13.4316002,16.4538514,2.4196684,67.1093581),(31464,'Bettongia-lesuer-tibia.tif',227,8,181,14.4376349,14.8529633,15.6988343,1.8,14.9350716,15.7462026,-0.1088882,3.3289492,6.6516933,40.6058658,217.4214924,0.0284178,32.6866383,12.1978029,37.0856789,13.1856002,16.2412175,2.4162082,73.1755442),(31465,'Bettongia-lesuer-tibia.tif',227,8,182,13.3272964,14.714149,15.6020415,1.8,14.7947639,15.6604629,-0.1266634,3.5518974,6.1592779,34.7136475,195.3785657,0.0354462,31.7210179,9.7732685,35.5655488,13.0872002,15.9488463,2.3998349,57.9787858),(31466,'Bettongia-lesuer-tibia.tif',227,8,183,12.3513606,14.661222,15.5266059,1.8,14.8016936,15.5994202,-0.1419401,3.7083714,6.0021975,28.0939913,172.4008738,0.041196,28.7229592,7.5758299,31.0530553,12.9888002,15.5098661,2.4167944,54.4034686),(31467,'metatarsal.tif',227,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31468,'metatarsal.tif',227,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31469,'metatarsal.tif',227,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31470,'metatarsal.tif',227,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31471,'metatarsal.tif',227,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31472,'metatarsal.tif',227,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31473,'metatarsal.tif',227,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31474,'metatarsal.tif',227,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31475,'metatarsal.tif',227,10,9,0.0004972,17.2200002,12.6444002,1.8,17.2200002,12.6444002,0.7853982,0.000000000000001256,0.000000000000001256,0.0000001,0.0000001,0.0000414,79848500.0561749,79848500.0501841,112922831.710355,0.0492,0.0695793,2.3561945,0.1391586),(31476,'metatarsal.tif',227,10,10,1.3956209,10.6690799,14.9617393,1.8,10.6724026,14.9726535,0.3019752,0.8678996,1.3847174,0.2129915,0.57322,0.0205739,0.4139617,0.2454103,0.5561264,1.798157,2.8331683,2.786887,9.5142826),(31477,'metatarsal.tif',227,10,11,4.9888491,10.1931139,14.5663121,1.8,10.1656805,14.5823129,0.1463309,1.61523,2.5578523,2.7755589,7.7381393,0.0176774,3.0252486,1.7183676,3.9922769,3.7944616,5.0828625,3.0640784,15.0407171),(31478,'metatarsal.tif',227,10,12,6.0474812,9.8617234,14.2877427,1.8,9.8791163,14.2898233,0.0481722,1.8979505,2.9946323,5.0595041,12.8061914,0.0023371,4.2763819,2.6657724,5.4572255,4.7470864,6.0116683,2.6376738,17.6756895),(31479,'metatarsal.tif',227,10,13,6.7360097,9.9056195,14.144051,1.8,9.9071881,14.1434743,0.0446555,1.9309962,2.9101677,5.2200172,13.1654248,0.0022372,4.5239402,2.7032768,5.5601289,5.2110316,5.9939252,2.5194348,18.5732274),(31480,'metatarsal.tif',227,10,14,7.4332272,9.9793104,14.1382259,1.8,9.9674745,14.1208969,0.1768265,2.1552098,2.968246,7.6412537,13.5880376,0.0383345,4.5778003,3.5454802,6.7998295,5.4891895,6.3789466,2.1138613,19.6984343),(31481,'metatarsal.tif',227,10,15,7.2800881,9.9650789,14.1875737,1.8,9.9367726,14.1327539,0.1574962,2.2741958,2.8948589,7.580978,13.436441,0.0298491,4.6414839,3.3334763,7.1338781,5.3806628,6.6514689,1.9416876,20.219255),(31482,'metatarsal.tif',227,10,16,6.7009886,9.9203889,14.2496697,1.8,9.8878535,14.1805692,0.0592096,2.253267,2.5151331,7.1200352,10.6177077,0.0039108,4.2215292,3.159872,6.4144754,4.9514905,6.7860339,1.8650309,19.9985791),(31483,'metatarsal.tif',227,10,17,5.976059,9.9310652,14.1516482,1.8,9.9456614,14.1613719,-0.2314581,2.265754,2.6597486,6.5757327,8.8776902,0.052413,3.337793,2.9022271,5.4608742,4.7689714,6.8004653,1.8719548,22.1604825),(31484,'metatarsal.tif',227,10,18,5.1941753,9.8842639,14.0675274,1.8,9.8322275,14.1529262,-0.162138,2.1964252,2.4666058,5.7879183,6.277151,0.0225593,2.5448537,2.6351539,4.2576343,4.3851985,6.4344874,1.9797042,20.2410826),(31485,'metatarsal.tif',227,10,19,4.667094,9.8349498,13.998969,1.8,9.7855537,14.1336679,1.3511112,2.7976726,2.1647675,4.7373638,5.4885784,0.7409088,2.5354125,1.6933232,3.3309052,3.7471592,5.822462,1.6469201,16.9202068),(31486,'metatarsal.tif',227,10,20,4.3785083,9.8526573,13.8359135,1.8,9.7890652,14.0015256,1.4316878,2.3859183,2.2036558,4.1436049,5.6279864,0.7157207,2.5539317,1.7366918,3.3407458,3.5247886,5.9629508,1.4300661,16.7641654),(31487,'metatarsal.tif',227,10,21,4.3120619,9.8400022,13.6142845,1.8,9.7900235,13.8064607,1.4811402,1.8975073,2.3425113,3.7259019,6.1585928,0.7129156,2.6290558,1.9635771,3.5853455,3.374469,6.1160568,1.4254863,16.9778482),(31488,'metatarsal.tif',227,10,22,4.5370762,9.8539366,13.4205732,1.8,9.7903362,13.630966,1.4738281,1.8908035,2.5281847,3.7455064,7.1148422,0.7490914,2.8142098,1.9809073,3.784717,3.198,6.0475988,1.4484595,16.275062),(31489,'metatarsal.tif',227,10,23,4.9699069,9.8350784,13.0878639,1.8,9.8245822,13.2289075,-1.4430343,5.6470489,6.0345315,4.8532009,9.2677566,0.8148705,1.5357873,0.8594225,1.974557,3.198,5.8473533,1.3156139,15.9848069),(31490,'metatarsal.tif',227,10,24,5.9063056,10.0091658,12.3931209,1.8,10.1820563,12.1986017,-1.2235338,4.2429399,6.7558795,7.0710455,25.4871964,0.8703718,3.7725949,1.6665439,4.5526425,3.3456,7.0012828,1.2490458,18.8692758),(31491,'metatarsal.tif',227,10,25,10.5205644,10.9534467,10.872629,1.8,11.1013495,10.5782778,-0.9248984,3.708301,6.1035831,26.0780903,71.2380077,1.1181562,11.6715062,7.0323554,15.7690843,3.8651282,6.6454614,1.0939045,18.4468551),(31492,'metatarsal.tif',227,10,26,13.8036331,11.1610451,10.3745877,1.8,11.285493,10.1803112,-0.7477837,4.0234543,6.5733568,45.6555351,98.0128283,1.0638483,14.9106204,11.3473478,21.719957,7.242981,11.0122307,0.9121043,49.2022547),(31493,'metatarsal.tif',227,10,27,16.3118064,10.9334418,10.1061,1.8,10.9626232,9.9651216,-0.5179693,5.6777546,7.3595268,66.4005814,119.2642465,0.6664478,16.2054232,11.6948664,25.1876053,7.8442606,11.2507826,0.8782977,77.1427646),(31494,'metatarsal.tif',227,10,28,18.0389263,11.2116783,9.9097079,1.8,11.2150392,9.7894478,-0.5401584,5.6925866,7.2804956,79.7193918,138.8402866,0.7951426,19.0701697,14.004072,30.0182761,7.4949983,8.8909179,2.0542433,31.7810066),(31495,'metatarsal.tif',227,10,29,19.9131696,11.4104098,9.8516513,1.8,11.4302905,9.7572676,-0.4167528,5.4197772,7.146292,96.8728814,154.1839512,0.5438209,21.5753781,17.8739601,34.8352597,7.4748993,9.4045386,2.6334779,31.9082273),(31496,'metatarsal.tif',227,10,30,21.4070222,11.5176158,9.7157281,1.8,11.5995242,9.6552537,-0.3065656,5.4535218,7.0434166,109.6182418,169.1858527,0.3249404,24.0204241,20.10045,38.644578,13.1900885,17.0845187,1.236296,116.8476195),(31497,'metatarsal.tif',227,10,31,22.6272505,11.5718788,9.5823541,1.8,11.6726776,9.5578503,-0.2163182,5.83747,6.7923386,119.0891103,185.9602199,0.1737328,27.3779371,20.4008091,42.9566344,13.2653159,17.1038479,1.2244829,85.2511235),(31498,'metatarsal.tif',227,10,32,23.2035501,11.5980869,9.5094786,1.8,11.7312112,9.5153011,-0.1718241,6.0147788,6.6066983,126.5587361,198.828338,0.1130559,30.0949624,21.0412952,46.4843303,13.2308316,17.0281764,1.2198037,109.270468),(31499,'metatarsal.tif',227,10,33,23.5907041,11.6176025,9.5076709,1.8,11.7600883,9.5296746,-0.0614143,6.2318033,6.277701,129.9463237,205.2864004,0.0148109,32.7008885,20.8521223,48.3106546,12.9714115,16.970078,1.212365,118.2013436),(31500,'metatarsal.tif',227,10,34,22.839025,11.7027279,9.6258534,1.8,11.7964282,9.6854023,-0.0142699,6.1324162,5.812986,130.9235269,193.4984693,0.0007751,33.2872758,21.3494198,48.0210053,9.1291985,12.380914,0.0715906,71.6789164),(31501,'metatarsal.tif',227,10,35,21.1988388,11.8700723,9.8195429,1.8,11.8857809,9.8821928,0.1109293,6.1237908,5.7543037,127.105069,178.953088,0.0432984,31.0989997,20.7559456,46.8223563,12.0540001,16.9025455,1.1983979,137.8269505),(31502,'metatarsal.tif',227,10,36,19.1997572,11.9965632,10.1058984,1.8,11.9781018,10.1839954,0.1660593,5.9742175,6.0885056,116.7616983,144.5813641,0.087433,23.7466094,19.5442663,38.4018338,6.2980179,12.5661463,2.8842689,40.0358686),(31503,'metatarsal.tif',227,10,37,17.281178,12.0621049,10.7870959,1.8,12.0570406,10.8765875,-0.0614138,4.9275097,5.5655127,87.6472759,120.62203,0.0108495,21.6731209,17.7873371,33.3606963,7.2096678,12.5499548,2.8595235,44.7462823),(31504,'metatarsal.tif',227,10,38,16.339776,11.9577488,11.5127184,1.8,11.9158486,11.6050106,-0.0430658,4.2472021,5.4328684,41.2847565,116.0681398,0.0050477,21.3640623,9.7204597,25.3393205,7.9651487,13.116853,2.83289,77.3453579),(31505,'metatarsal.tif',227,10,39,17.8075873,11.9148319,11.5192802,1.8,11.773179,11.6298153,0.0537368,4.4811724,5.5741529,45.4737079,126.3401918,0.0085621,22.6653616,10.1477256,27.7165267,0.0492,0.1100145,2.0344439,0.2375586),(31506,'metatarsal.tif',227,10,40,19.1640821,11.7883999,11.6047057,1.8,11.6033771,11.6431931,-0.0241771,4.1953009,5.2783368,62.8356706,157.5648028,0.0018666,29.8512217,14.9776314,35.2129285,3.8493634,7.1949849,2.1910458,19.5691653),(31507,'metatarsal.tif',227,10,41,19.3821919,11.7821219,11.8664766,1.8,11.7241188,11.8323201,-0.0098384,3.9590444,5.2810821,68.4107021,148.5380007,0.0003127,28.1264326,17.2795998,35.2245854,0.2193311,0.9901309,2.0344439,2.1787862),(31508,'metatarsal.tif',227,10,42,20.4437427,11.4836491,11.9337911,1.8,11.4942739,11.9174449,-0.0037564,3.9155291,5.2462651,71.3095571,170.1533946,0.0000481,32.4332437,18.2119849,41.9743481,7.8852515,10.8106856,2.7145885,38.6673099),(31509,'metatarsal.tif',227,10,43,19.337508,11.6492024,12.0088162,1.8,11.5560633,12.0148559,0.0166841,3.8862167,5.1878054,72.1947173,154.6891997,0.000897,29.8178494,18.5771207,40.7317078,8.2280816,10.6317547,3.0023134,50.3006891),(31510,'metatarsal.tif',227,10,44,18.3711747,11.8503893,12.0137892,1.8,11.7775256,12.0271751,0.0147926,3.9596477,5.3795526,71.1077798,138.7194142,0.0006699,25.786422,17.9581077,37.473941,8.6217542,10.3092494,3.0699452,55.4742821),(31511,'metatarsal.tif',227,10,45,18.3221395,11.7868635,11.9324932,1.8,11.7556058,11.9893564,-0.0109001,3.9404727,5.2319421,67.798502,135.2641888,0.0003628,25.8535332,17.2056772,37.4108694,8.5737725,10.2033969,0.7410586,44.7244547),(31512,'metatarsal.tif',227,10,46,0.5428747,12.6831554,13.7173991,1.8,12.5784739,13.8374779,-0.8407075,0.6569735,1.9086207,0.0231912,0.2993805,0.0502337,0.156857,0.0353001,0.168638,0.8908399,1.7909071,0.6489956,4.2641172),(31513,'metatarsal.tif',227,10,47,1.1091443,12.9354816,13.5137611,1.8,12.8414449,13.6401494,-0.9886465,0.943767,2.2102044,0.1654775,0.6973604,0.1289744,0.3155185,0.1753372,0.3741688,1.5556991,3.273187,0.8279257,9.159393),(31514,'metatarsal.tif',227,10,48,7.3278036,10.9417627,11.5700488,1.8,11.1273274,11.728896,0.381474,3.6285467,3.7021511,9.4611328,33.6110634,0.1692711,9.078793,2.6074165,10.9308647,5.1917807,7.3648966,2.7437183,32.8127583),(31515,'metatarsal.tif',227,10,49,11.9421687,11.0400852,11.3121428,1.8,11.0834118,11.4586383,0.3679609,3.6322227,4.0956543,20.7513857,48.8731498,0.2575406,11.9329285,5.7131369,14.4371761,6.1796325,7.9802644,2.2118313,36.0739445),(31516,'metatarsal.tif',227,10,50,11.9016588,11.297375,11.4181459,1.8,11.3223032,11.4807507,0.5343923,3.6211448,4.9336473,28.3822731,48.1393378,0.5145584,9.7573529,7.8379281,14.0717798,6.6251727,8.0791435,2.5687916,30.7879653),(31517,'metatarsal.tif',227,10,51,10.4628902,11.5679159,11.713819,1.8,11.6072206,11.7610549,0.7580073,4.0650012,3.9721043,25.882083,42.2788865,0.8241668,10.6439518,6.3670543,15.5510069,6.786399,7.8604604,2.5657422,29.4103653),(31518,'metatarsal.tif',227,10,52,8.6357379,11.7512499,11.7669118,1.8,11.7891255,11.8116235,0.8366704,3.8177414,4.0204654,22.1832532,36.7203703,0.7933112,9.1333632,5.8105699,14.119142,6.336683,7.7375507,2.4688378,26.0030274),(31519,'metatarsal.tif',227,10,53,7.5151442,11.874359,11.710513,1.8,11.9366537,11.7682214,0.7971694,3.5440328,4.033325,17.94508,33.2823649,0.6410044,8.2518431,5.0634633,12.4163828,5.8756953,7.6556213,2.4929502,23.4615101),(31520,'metatarsal.tif',227,10,54,6.7995504,11.8536493,11.4592521,1.8,11.955208,11.5498515,0.6267985,3.1906696,4.104474,15.6556937,29.1154237,0.3898936,7.0935821,4.906711,10.2399351,5.2941434,7.4488866,2.4967705,23.0460825),(31521,'metatarsal.tif',227,10,55,6.4862565,11.785926,11.2422073,1.8,11.862707,11.3294625,0.3229491,2.5685781,3.6406352,13.3389438,25.2756058,0.108883,6.9426361,5.1931237,9.2144733,4.9062458,7.0979421,2.5785848,21.6017998),(31522,'metatarsal.tif',227,10,56,6.1694098,11.7977884,11.0571451,1.8,11.8783943,11.1571177,0.1503294,2.6027453,3.1561457,11.4872069,22.7505339,0.0230625,7.2083281,4.4134964,8.6457028,4.5839429,6.6580163,2.6151139,20.1068688),(31523,'metatarsal.tif',227,10,57,5.8082154,11.8325071,11.0007422,1.8,11.9446093,11.093594,0.1183793,2.4318013,2.9862125,10.363458,20.4875359,0.0135025,6.8607093,4.2616385,8.6817889,4.4241665,6.2437495,0.2143955,18.3505033),(31524,'metatarsal.tif',227,10,58,5.9144646,11.9723845,11.0413579,1.8,12.0945051,11.152393,0.1825488,2.4600293,2.8837367,10.5888029,20.2604664,0.0324857,7.0257686,4.3043402,9.0148241,4.3961842,6.0307642,0.2053954,19.302786),(31525,'metatarsal.tif',227,10,59,5.8272456,11.9810096,11.0222798,1.8,12.0729935,11.1571608,0.1658769,2.3237969,2.9184529,10.466951,18.3305904,0.0264787,6.2809274,4.5042451,9.0059131,4.3367692,5.840726,0.109727,17.2870343),(31526,'metatarsal.tif',227,10,60,5.7600417,12.0892541,11.0249426,1.8,12.1824774,11.182387,0.2246975,2.3718478,2.7431539,10.0823641,17.332561,0.0476595,6.3184793,4.2508479,8.837501,4.3326266,5.7048668,0.2261524,17.826786),(31527,'metatarsal.tif',227,10,61,5.5315107,12.1219129,10.9603491,1.8,12.1907413,11.0902432,0.1967347,2.312,2.7051339,9.250477,15.8412653,0.0352244,5.8560003,4.0010714,8.4463692,4.2708126,5.5183015,0.0535203,16.3726136),(31528,'metatarsal.tif',227,10,62,5.5982135,12.1833714,10.9951459,1.8,12.2221189,11.1228379,0.2003013,2.3667233,2.6485076,9.1457462,15.0993838,0.036936,5.7010913,3.8643073,8.9748097,4.2722404,5.3772247,0.0732631,15.8517929),(31529,'metatarsal.tif',227,10,63,5.6445499,12.2089462,10.9845424,1.8,12.2206068,11.1006373,0.2098634,2.2607862,2.5910177,9.0118178,14.3449752,0.0408288,5.5364249,3.9861432,8.8804526,4.2482177,5.243206,3.0381892,16.1708688),(31530,'metatarsal.tif',227,10,64,5.5837268,12.2285864,10.914408,1.8,12.2478392,10.9912705,0.1956245,2.3096257,2.5245125,8.5024279,13.3436658,0.0351619,5.2856405,3.6813013,8.50776,4.1820001,5.1078037,3.0160429,15.1629929),(31531,'metatarsal.tif',227,10,65,5.5769677,12.2238196,10.8929268,1.8,12.2324429,10.9770686,0.1660675,2.2976119,2.474179,8.4359225,12.3000956,0.0253992,4.9713848,3.6716047,8.0108073,4.1660424,5.0041504,3.0233351,14.8340274),(31532,'metatarsal.tif',227,10,66,5.6656635,12.2591921,10.8865858,1.8,12.2687716,10.9708882,0.1896435,2.3521247,2.44521,8.3495266,11.8699293,0.0335554,4.8543598,3.5497805,8.1829603,4.1399688,4.9445389,3.041924,14.6491653),(31533,'metatarsal.tif',227,10,67,5.6520117,12.2890897,10.8395503,1.8,12.3001295,10.8960534,0.1765762,2.3058516,2.4137399,7.9902447,11.3789381,0.0290668,4.7142354,3.4652034,7.9085685,4.1289479,4.8518785,3.0298156,14.3062136),(31534,'metatarsal.tif',227,10,68,5.7116868,12.2661513,10.8206343,1.8,12.2617887,10.8859854,0.0723466,2.2937536,2.3356442,7.9921987,10.8795282,0.0049738,4.6580418,3.4843319,7.9940652,4.0488325,4.739827,2.9747375,14.1262964),(31535,'metatarsal.tif',227,10,69,5.7060441,12.3235097,10.7962377,1.8,12.3393794,10.8656297,0.1722685,2.3285526,2.3303105,7.6752709,10.3566128,0.0279444,4.4443058,3.2961552,7.699294,4.004653,4.6833129,2.9833523,13.9414343),(31536,'metatarsal.tif',227,10,70,5.6907979,12.3218621,10.7716679,1.8,12.3318544,10.842571,0.1372959,2.3086014,2.2615295,7.589837,10.0081864,0.0177667,4.4254061,3.2876343,7.6067445,3.9742022,4.5737481,2.9357585,13.970255),(31537,'metatarsal.tif',227,10,71,5.478534,12.347798,10.701788,1.8,12.3478321,10.7483105,0.1432362,2.3823189,2.2216558,6.9736763,9.3946556,0.0186057,4.2286729,2.927264,6.8567979,3.8510062,4.4966217,2.8302223,14.265455),(31538,'metatarsal.tif',227,10,72,5.4790654,12.3827057,10.6761437,1.8,12.3913546,10.707774,0.2003941,2.3031784,2.2032302,6.926167,9.0810654,0.0361829,4.1217053,3.0072213,6.9493914,3.8512561,4.4293665,2.9289477,13.5239584),(31539,'metatarsal.tif',227,10,73,5.2936659,12.4008871,10.6379981,1.8,12.4008067,10.6666493,0.1921141,2.24769,2.1764465,6.6267322,8.6177346,0.0321643,3.9595435,2.9482412,6.7821007,3.7848385,4.3765883,2.9949262,13.459324),(31540,'metatarsal.tif',227,10,74,5.2620146,12.4106516,10.612257,1.8,12.4062622,10.6507685,0.1965224,2.2556791,2.1416165,6.5899446,8.284108,0.033437,3.8681566,2.9214902,6.5893214,3.7776801,4.3279225,2.9932648,13.4016826),(31541,'metatarsal.tif',227,10,75,5.2593831,12.4582732,10.5812747,1.8,12.4608215,10.6122791,0.3273255,2.1776065,2.1260287,6.4082908,8.1765122,0.0906102,3.8459087,2.942814,6.6803859,3.7759588,4.2868986,2.9802175,13.1929447),(31542,'metatarsal.tif',227,10,76,5.325452,12.4738208,10.5790723,1.8,12.4662333,10.6310733,0.3614554,2.1499321,2.0969723,6.5506361,8.0536913,0.1109988,3.8406283,3.0469038,6.7756552,3.8031889,4.2599928,2.896614,13.360924),(31543,'metatarsal.tif',227,10,77,5.2398858,12.5111473,10.5193102,1.8,12.5081817,10.5514552,0.4268596,2.0992561,2.0634081,6.1737438,7.8625312,0.1496929,3.8104586,2.9409198,6.5689789,3.6770237,4.2165864,2.9419088,12.9842067),(31544,'metatarsal.tif',227,10,78,5.3562664,12.4897107,10.515219,1.8,12.4723318,10.5530754,0.2934738,2.3054789,2.0839946,6.4888627,7.6979758,0.0747043,3.6938559,2.8145401,6.1200351,3.763944,4.2004816,1.3343402,13.2048826),(31545,'metatarsal.tif',227,10,79,5.3363852,12.5359809,10.4755426,1.8,12.525685,10.5103657,0.4037643,2.2356464,2.0780075,6.296639,7.6600724,0.1372846,3.6862584,2.8164735,6.0695176,3.6853849,4.1785257,2.9280322,13.2168205),(31546,'metatarsal.tif',227,10,80,5.4270276,12.5538517,10.4734108,1.8,12.5333067,10.5150172,0.4589801,2.2123751,2.0631325,6.4848646,7.6537542,0.1775353,3.7097736,2.9311777,6.1348921,3.7264121,4.2071035,1.3825748,13.2168205),(31547,'metatarsal.tif',227,10,81,5.2827804,12.5817638,10.4045486,1.8,12.5743848,10.4235518,0.4315476,2.0559158,2.0504795,6.0937657,7.3677494,0.1540421,3.5931837,2.9640152,6.4152784,3.6683324,4.1216565,2.7367009,12.8162274),(31548,'metatarsal.tif',227,10,82,5.2411179,12.6112298,10.3701374,1.8,12.612782,10.390491,0.4961589,2.021962,2.0478024,6.0056023,7.2594384,0.1979611,3.5449897,2.9701856,6.2645926,3.6172775,4.1010495,2.6135182,12.7874067),(31549,'metatarsal.tif',227,10,83,5.1754343,12.6468628,10.3186502,1.8,12.6480902,10.3511477,0.5878889,2.1003528,2.0521923,5.8895504,7.1776753,0.2653164,3.4975647,2.8040768,5.7528896,3.5582082,4.1304565,1.3547114,12.9842067),(31550,'metatarsal.tif',227,10,84,5.2244614,12.6540519,10.2835809,1.8,12.640603,10.3159256,0.5241274,2.0393881,2.0304386,5.9761338,7.1119386,0.2180846,3.5026612,2.9303564,6.1571757,3.6210884,4.0678613,2.5804292,12.8450481),(31551,'metatarsal.tif',227,10,85,5.2365571,12.6902461,10.2370621,1.8,12.6836189,10.2635802,0.5709402,2.0146256,2.031758,5.9364707,7.1213864,0.2548959,3.5050367,2.9466869,6.0526774,3.54288,4.0773712,2.7969453,12.7754688),(31552,'metatarsal.tif',227,10,86,5.2753298,12.7054851,10.2083567,1.8,12.6973378,10.2282812,0.5466552,1.9993974,2.0202318,6.0163063,7.1455178,0.2375887,3.5369792,3.0090597,6.4194568,3.5767637,4.0773712,2.7969453,12.8331102),(31553,'metatarsal.tif',227,10,87,5.273972,12.7319384,10.1773275,1.8,12.7211285,10.2005016,0.6112501,1.9662203,2.008166,6.0524233,7.1503691,0.2894986,3.5606464,3.0782019,6.4588343,3.5767637,4.0622042,2.8466556,12.8042895),(31554,'metatarsal.tif',227,10,88,5.1577163,12.7368404,10.1082281,1.8,12.7284073,10.1199445,0.5042428,2.0528189,2.0340449,5.9062753,6.9736239,0.2006598,3.4284512,2.8771536,6.1532609,3.5767637,4.094256,2.5702552,12.751593),(31555,'metatarsal.tif',227,10,89,5.1424405,12.7583728,10.0849815,1.8,12.7512949,10.1043385,0.5411523,1.9915199,2.0292187,5.9442304,7.0347904,0.2274268,3.4667483,2.9847708,6.2712206,3.586307,4.0838964,2.7588491,12.7923516),(31556,'metatarsal.tif',227,10,90,5.0059302,12.780363,10.0351833,1.8,12.7860984,10.055619,0.530733,2.0414256,2.0263151,5.7777883,6.9565366,0.2137563,3.4330971,2.8302713,6.1141228,3.5692927,4.1025249,2.747724,12.849993),(31557,'metatarsal.tif',227,10,91,4.9768563,12.7849613,10.0184197,1.8,12.7854056,10.0361147,0.5024384,1.9829583,2.0260184,5.8179234,6.9945586,0.1923587,3.4523668,2.9339615,6.2095628,3.6199725,4.0838964,2.5970409,12.8738688),(31558,'metatarsal.tif',227,10,92,4.7527954,12.8044852,9.9301915,1.8,12.8160091,9.9230724,0.3621944,2.1076218,2.0470381,5.507089,6.7445322,0.0994504,3.2947761,2.6129399,5.7975744,3.5946326,4.0963248,2.7209293,12.7923516),(31559,'metatarsal.tif',227,10,93,4.9142277,12.8229444,9.9238335,1.8,12.8171811,9.9025259,0.4325229,2.0638623,2.0534995,5.9709185,7.0191546,0.1439028,3.4181428,2.8930799,6.1916864,3.6621451,4.1295774,2.7632987,12.9315102),(31560,'metatarsal.tif',227,10,94,5.0078934,12.8281335,9.9042886,1.8,12.8065867,9.9231016,0.4486164,2.1184163,2.0558989,6.2992776,7.2364815,0.1570078,3.5198625,2.9735788,6.3568632,3.7157555,4.1541236,2.8160968,13.3370481),(31561,'metatarsal.tif',227,10,95,5.0402114,12.8452467,9.8624258,1.8,12.8361212,9.8858933,0.6030691,1.9853928,2.0566141,6.5088405,7.2760581,0.2702268,3.537882,3.2783641,6.4699287,3.740742,4.1576184,2.7786669,13.2098274),(31562,'metatarsal.tif',227,10,96,4.9788984,12.8503577,9.8221617,1.8,12.8409046,9.8317786,0.5124156,2.0381321,2.0885558,6.5107735,7.2490487,0.19947,3.4708428,3.1944806,6.4518985,3.7628198,4.1935605,2.756729,13.1283102),(31563,'metatarsal.tif',227,10,97,4.9139313,12.8855139,9.8081117,1.8,12.8839746,9.8217322,0.6789152,1.9846222,2.0523834,6.4642025,7.3815767,0.3229437,3.5965877,3.2571451,6.4594323,3.7312014,4.1935605,2.756729,13.2674688),(31564,'metatarsal.tif',227,10,98,4.9765856,12.8628459,9.7788882,1.8,12.8251069,9.7783332,0.5216713,2.1004913,3.1478458,6.6524441,7.8943147,0.2059748,2.5078467,3.1670896,4.5145757,3.7763208,4.2508914,1.289317,13.4354481),(31565,'metatarsal.tif',227,10,99,5.1333637,12.9067249,9.7877591,1.8,12.882781,9.8387872,0.686177,2.0850941,2.5892373,7.0426404,8.1178601,0.3434467,3.1352322,3.3776128,5.4763206,3.8121862,4.2852043,1.3508821,14.0666067),(31566,'metatarsal.tif',227,10,100,5.1985543,12.9302165,9.7593762,1.8,12.9121926,9.8210989,0.7820532,2.1072903,2.1288417,7.2676589,8.2365188,0.4303148,3.8690142,3.4488171,6.6970452,3.8722206,4.3455049,1.2956071,14.1361861),(31567,'metatarsal.tif',227,10,101,5.2736814,12.940686,9.729079,1.8,12.9016875,9.7879983,0.737773,2.1577671,2.3421762,7.4701304,8.6720419,0.3976767,3.7025574,3.4619725,6.7418145,3.9558014,4.5742773,2.8130395,14.3329861),(31568,'metatarsal.tif',227,10,102,5.181832,12.9619949,9.6927968,1.8,12.9023716,9.7399014,0.6633006,2.1916154,2.3731832,7.5875133,8.7545162,0.327416,3.6889339,3.4620643,6.8101903,3.9870484,4.6011866,2.7114254,14.8846757),(31569,'metatarsal.tif',227,10,103,5.1556698,12.9928592,9.5767873,1.8,12.9083943,9.5678326,0.5805705,2.1531784,2.6972331,7.4138824,9.4710981,0.2585168,3.5114126,3.4432272,6.2427642,4.0218806,4.9369449,2.6199744,15.8229722),(31570,'metatarsal.tif',227,10,104,5.1079594,13.0566685,9.5205563,1.8,12.9861351,9.5181016,0.5666261,2.1505753,2.557386,7.5382654,9.4612052,0.2453028,3.6995609,3.505232,6.5521186,4.0526636,4.8256147,2.852089,14.7166964),(31571,'metatarsal.tif',227,10,105,5.2336381,13.1101609,9.4551867,1.8,13.0504013,9.4328608,0.5049006,2.2074858,2.6624488,7.9316995,9.8806281,0.2040992,3.7111054,3.5930919,6.6783228,4.0466047,4.8973158,2.7498927,14.7862757),(31572,'metatarsal.tif',227,10,106,5.4834833,13.1243064,9.3804728,1.8,13.0654336,9.3772907,0.4825949,2.3004313,2.6649809,8.4099372,10.7014456,0.1968293,4.0155806,3.6558089,7.1679046,4.2270685,4.9523656,2.7758454,16.3676688),(31573,'metatarsal.tif',227,10,107,5.6611976,13.1399442,9.3413801,1.8,13.0993468,9.3327981,0.3886719,2.3754594,2.6441066,8.9190286,11.2803,0.1355012,4.2662048,3.7546542,7.5749674,4.1852309,4.9808774,2.7354039,15.5397101),(31574,'metatarsal.tif',227,10,108,5.9227284,13.170988,9.2966437,1.8,13.1424568,9.2983133,0.2847182,2.4499049,2.5812668,9.3719944,12.0074631,0.0778814,4.6517713,3.8254523,8.0316275,4.43254,5.0388584,2.5156679,17.5385791),(31575,'metatarsal.tif',227,10,109,6.2095601,13.1976314,9.2385778,1.8,13.1729201,9.2265774,0.1891282,2.4271482,2.6633444,9.6688377,13.1288614,0.0365795,4.9294643,3.9836207,8.5327419,4.4767153,5.1697473,2.9983497,16.3726136),(31576,'metatarsal.tif',227,10,110,6.5264195,13.2293182,9.2145777,1.8,13.2035487,9.2042226,0.1349573,2.8532639,2.8481926,10.3941106,14.4665318,0.0196915,5.0791971,3.6428844,8.7107958,4.5840363,5.4689513,2.9971511,16.6579239),(31577,'metatarsal.tif',227,10,111,7.1814202,13.2562056,9.1652411,1.8,13.246998,9.1122944,0.069058,2.9525459,2.8083006,12.1388646,16.2281003,0.005699,5.7786193,4.1113212,9.5139072,4.6571186,5.4921395,2.970553,16.7493308),(31578,'metatarsal.tif',227,10,112,8.0073959,13.2913908,9.1894535,1.8,13.2954908,9.1661802,0.0617207,2.8762363,2.9894972,13.9058675,19.1318343,0.0050775,6.399683,4.8347444,10.9556489,4.8939432,5.8355432,3.0402462,17.6707446),(31579,'metatarsal.tif',227,10,113,8.3395078,13.3313579,9.2129239,1.8,13.332248,9.1791966,0.0378466,2.782566,3.1183527,14.5058409,21.3302632,0.0019899,6.8402344,5.2131165,11.3253232,5.0831889,6.0747558,2.987096,20.4975722),(31580,'metatarsal.tif',227,10,114,9.3237914,13.3016657,9.271745,1.8,13.3346761,9.2460337,0.0553562,2.771987,3.1982283,16.7058743,24.4218659,0.004757,7.6360609,6.0266784,12.7138611,5.246245,6.3500411,2.9624322,21.4358687),(31581,'metatarsal.tif',227,10,115,10.3557011,13.3321935,9.3052337,1.8,13.3679507,9.2748988,-0.0014357,2.7613467,3.2983308,18.2473736,28.6220847,0.0000036,8.6777482,6.6081428,13.9488418,5.2151802,6.597388,3.1042965,20.7133032),(31582,'metatarsal.tif',227,10,116,11.4772189,13.367464,9.3655493,1.8,13.3933609,9.3522401,0.0025579,2.8224816,3.3817855,20.0567469,33.78309,0.0000125,9.9897201,7.1060684,15.5458923,5.0130941,6.8474665,2.8425655,20.0422343),(31583,'metatarsal.tif',227,10,117,13.2965855,13.4519207,9.3973958,1.8,13.420322,9.3557803,-0.0273608,2.7522284,3.4468668,23.5919319,40.9959309,0.0016586,11.8936802,8.5719383,18.2343585,5.2644001,7.0030113,2.8420607,20.9924688),(31584,'metatarsal.tif',227,10,118,15.205725,13.4588148,9.3582527,1.8,13.4750299,9.3474084,-0.0458318,2.6587364,3.6456602,25.0919578,49.5736916,0.0053197,13.5980013,9.4375499,20.129657,5.2575845,7.3190686,2.8623696,21.9665791),(31585,'metatarsal.tif',227,10,119,16.1977792,13.5049291,9.4485667,1.8,13.4767198,9.4475323,0.0265458,2.9533523,3.8229964,31.1984696,57.659706,0.0019019,15.0823334,10.5637479,21.3640791,5.768322,8.0159772,2.7907241,25.6790067),(31586,'metatarsal.tif',227,10,120,16.5225582,13.3992735,9.4356222,1.8,13.3994682,9.4822981,-0.0070927,2.6963209,3.8564925,30.7540003,61.785448,0.0001385,16.0211507,11.4059124,21.3998489,5.4120001,7.9213529,2.7530126,23.4187033),(31587,'metatarsal.tif',227,10,121,12.3043678,13.4257045,9.5104394,1.8,13.4420828,9.5412181,-0.0291703,2.5975696,3.6617518,24.3963623,49.1305233,0.0017445,13.4172183,9.3919958,18.0465452,5.2145641,7.5332254,2.7246946,23.4376343),(31588,'metatarsal.tif',227,10,122,12.5402763,13.5261273,9.4827813,1.8,13.5100959,9.520725,-0.0478566,2.516963,3.7484222,19.3592272,45.3882427,0.0047831,12.1086261,7.6915025,16.0430657,4.9749977,7.4189294,2.7105744,23.8649998),(31589,'metatarsal.tif',227,10,123,11.5282632,13.5172993,9.4083654,1.8,13.4838524,9.4317093,-0.0654932,2.2195635,3.7226289,12.8200961,38.1225107,0.0082297,10.2407496,5.7759538,12.4147682,4.4527277,7.4526228,3.0622891,21.676324),(31590,'metatarsal.tif',227,10,124,8.3106868,13.3735929,9.2970062,1.8,13.3852337,9.2703121,-0.0997922,1.8478329,3.3129708,5.2501986,21.3064042,0.0137479,6.431208,2.8412735,7.6244624,3.5201548,6.6640125,0.0813019,17.7143999),(31591,'metatarsal.tif',227,10,125,2.0620031,12.6197281,9.4302517,1.8,12.5842548,9.4218001,0.0751842,0.893059,1.8274163,0.2769353,1.5614756,0.001939,0.8544717,0.3100974,0.9898954,1.6016469,3.5946316,3.1005199,9.2915586),(31592,'metatarsal.tif',227,10,126,17.1065432,13.8278641,11.0062353,1.8,13.7928718,11.0727306,0.4417673,3.2778474,5.1816371,34.1083353,64.4522566,0.5211467,12.4385895,10.4057117,18.0145444,5.7226722,6.9164072,2.9916475,24.6204825),(31593,'metatarsal.tif',227,10,127,16.8668987,13.8930839,11.1569554,1.8,13.8297816,11.2419913,0.6374728,3.3777651,5.4870966,34.2657004,61.4081786,0.9957742,11.1913791,10.144489,17.2014422,5.7072001,6.5191393,0.3145908,23.5788411),(31594,'metatarsal.tif',227,10,128,15.0308189,13.9077232,11.3363132,1.8,13.9492699,11.4743404,0.7548148,3.2260029,5.6245527,27.5802474,58.8852971,1.1760006,10.4693298,8.5493559,15.3422937,5.3940026,6.0677784,3.0685521,21.1217377),(31595,'metatarsal.tif',227,10,129,12.6017276,14.1398212,11.6749975,1.8,14.135883,11.7348926,0.8346294,3.1501916,5.3774137,22.6929975,60.1706845,1.1533768,11.1895213,7.203688,15.4088602,5.3261889,5.9017446,1.066127,18.8157309),(31596,'metatarsal.tif',227,10,130,11.193874,14.3656722,12.0367934,1.8,14.2943236,12.0189091,0.8460012,3.036302,4.9160214,18.8178874,56.9055831,1.0456099,11.575536,6.1976336,15.3928536,4.8216001,5.5772058,2.4186133,17.6785861),(31597,'metatarsal.tif',227,10,131,9.863429,14.3434217,12.1889417,1.8,14.2892403,12.1462629,0.8630131,2.8626738,4.7844838,15.9481431,47.6139911,0.9490322,9.9517509,5.5710655,13.2632081,4.6707122,5.3254313,2.8607549,17.0305447),(31598,'metatarsal.tif',227,10,132,8.4460562,14.3215341,12.3140251,1.8,14.290389,12.2744108,0.8671902,2.6885295,4.7339083,12.8507627,38.2480579,0.818462,8.0795942,4.7798482,10.74746,4.5264001,5.0486968,2.8753406,16.1498895),(31599,'metatarsal.tif',227,10,133,7.459604,14.278253,12.4483797,1.8,14.2919712,12.4377691,0.8310617,2.5078878,4.7821283,10.5087904,30.5399335,0.6783267,6.3862639,4.1902953,8.5607329,4.3788001,4.6957013,0.9566369,15.0386688),(31600,'metatarsal.tif',227,10,134,6.7574571,14.3666302,12.7176867,1.8,14.4850765,12.7938341,0.8042362,2.3788797,4.5030328,8.7325727,27.9267667,0.5843326,6.2017685,3.6708762,8.1264644,4.1820001,4.5586396,2.1797539,14.5874274),(31601,'metatarsal.tif',227,10,135,6.5713131,14.5552883,13.064263,1.8,14.7009262,13.2205673,0.7669232,2.5264571,4.2362276,7.9770592,27.4428693,0.5273799,6.4781385,3.1574093,8.3495041,0.4840905,1.2151504,1.943784,2.7811241),(31602,'metatarsal.tif',227,10,136,6.0546198,14.4471258,13.1861293,1.8,14.6627294,13.3664479,0.8066898,2.0974806,4.0065655,6.6572149,20.9493666,0.5260306,5.2287594,3.1739101,6.846222,3.8529418,4.3279225,2.4366655,13.4692137),(31603,'metatarsal.tif',227,10,137,5.2760698,14.3156452,13.2112971,1.8,14.5089319,13.3788581,0.7807742,1.996821,4.0201837,5.6396407,14.8576131,0.4356065,3.6957548,2.8243096,5.0795276,3.7572826,4.3721613,2.459822,13.3131723),(31604,'metatarsal.tif',227,10,138,4.7916994,14.2315972,13.305033,1.8,14.3951268,13.419817,0.7538778,1.9340999,3.9871574,5.0039819,11.3058603,0.3741523,2.8355691,2.5872406,4.081725,3.6293897,4.1799737,2.4061529,12.7157792),(31605,'metatarsal.tif',227,10,139,4.6275636,14.1897461,13.444182,1.8,14.322113,13.5355428,0.7483173,1.8818369,3.8550187,4.6939744,9.1551102,0.3570575,2.3748549,2.4943577,3.5757081,3.575534,4.011837,2.5569914,12.2933585),(31606,'metatarsal.tif',227,10,140,4.5412009,14.1438792,13.591558,1.8,14.2524604,13.6518135,0.7294587,1.8532376,3.7934669,4.4812336,7.5138269,0.3361829,1.9807282,2.4180567,3.1469323,3.4866394,3.9168887,2.5710099,12.0846206),(31607,'metatarsal.tif',227,10,141,4.5303418,14.1133098,13.7590157,1.8,14.1797602,13.7848685,0.720512,1.8223635,3.5982154,4.3515552,6.3050096,0.3286731,1.7522602,2.3878635,2.9446669,3.4194679,3.8743243,2.4370986,11.933524),(31608,'metatarsal.tif',227,10,142,4.4573056,14.0566831,13.9332383,1.8,14.0931091,13.9346847,0.9404454,1.7699527,3.1168103,4.2486532,4.6609314,0.4847872,1.4954171,2.4004332,2.7135091,3.3948,3.9812499,2.2686991,12.4086413),(31609,'metatarsal.tif',227,10,143,4.4737806,14.0759897,14.1564803,1.8,14.0938067,14.1352958,1.0653239,1.7353895,1.9814426,4.1708251,4.4254676,0.5708023,2.2334573,2.4033942,4.0159357,3.364554,3.7239558,2.3281645,11.5975654),(31610,'metatarsal.tif',227,10,144,4.2259702,14.1208059,14.3056837,1.8,14.1437834,14.2832575,0.3235564,1.7856024,2.0429138,3.6866918,4.1931985,0.0711978,2.0525577,2.0646768,3.5253137,3.3904579,3.9387666,2.2943266,12.0150413),(31611,'metatarsal.tif',227,10,145,3.7051856,14.1300597,14.3591295,1.8,14.1299025,14.3543655,0.0506645,1.546639,1.7186821,2.5140251,3.9306032,0.0015838,2.2869868,1.6254764,3.0898752,3.3456,4.057136,2.2531129,12.4325171),(31612,'metatarsal.tif',227,10,146,3.355344,14.1438165,14.4414246,1.8,14.1413175,14.4300629,0.0081752,1.4123823,1.7091756,1.6693781,3.7043353,0.0000374,2.1673228,1.1819591,2.5104535,3.3897448,3.6117626,2.2306448,11.6621999),(31613,'metatarsal.tif',227,10,147,3.1339256,14.169608,14.575866,1.8,14.1707854,14.5599915,-0.0031131,1.2720419,1.7672408,1.2009035,3.4671494,0.0000051,1.9618998,0.9440754,2.1438294,3.4305183,3.8945771,1.6340032,12.6004964),(31614,'metatarsal.tif',227,10,148,2.950961,14.1987412,14.7236725,1.8,14.1932273,14.694709,-0.0009495,1.1445462,1.7904763,0.8662766,3.2978726,0.0000004,1.8418968,0.7568734,2.0113327,3.5266931,3.9464412,2.1968428,12.4971516),(31615,'metatarsal.tif',227,10,149,2.7693829,14.2465385,14.8788404,1.8,14.255187,14.8447924,0.0083073,1.0533734,1.8498027,0.6093007,3.106123,0.0000319,1.6791645,0.5784281,1.7873975,3.6092355,3.9879324,1.6078164,12.6074895),(31616,'metatarsal.tif',227,10,150,2.5507856,14.2654212,15.0234128,1.8,14.2571976,14.9889584,0.0078509,0.9522035,1.9277495,0.412307,2.7976921,0.0000262,1.4512737,0.433003,1.5368812,3.7789339,4.6781414,1.5287159,14.2246964),(31617,'metatarsal.tif',227,10,151,2.2473175,14.2949081,15.1657157,1.8,14.2873674,15.1343532,0.0006198,0.8977291,1.9415112,0.2586883,2.3697832,0.0000001,1.220587,0.2881585,1.2786505,3.7474011,4.3198049,2.8883269,15.7076894),(31618,'metatarsal.tif',227,10,152,1.9735478,14.3257302,15.2980866,1.8,14.3210599,15.2662855,-0.0037839,0.8336851,1.9573964,0.1570931,1.8854682,0.0000047,0.9632531,0.1884322,1.0043737,3.9584145,4.5742773,2.8130395,17.0684067),(31619,'metatarsal.tif',227,10,153,1.7249204,14.3392998,15.4397568,1.8,14.3390613,15.4005463,-0.0155113,0.8268367,1.890227,0.0946734,1.3938186,0.0000692,0.7373816,0.1145007,0.7676726,4.5865069,4.919262,2.6063189,16.2165722),(31620,'metatarsal.tif',227,10,154,1.4598885,14.415231,15.5781736,1.8,14.4090167,15.5215715,-0.0033533,0.7689678,1.8209067,0.057194,0.9248707,0.0000027,0.5079177,0.0743776,0.5339889,4.7488673,5.3925086,2.5839605,18.6617377),(31621,'metatarsal.tif',227,10,155,0.8989401,14.4874355,15.6624089,1.8,14.4519947,15.5916824,0.0018708,0.7058413,1.6458958,0.0263084,0.4676557,0.0000005,0.2841344,0.0372724,0.2982792,4.7545,5.5604708,0.5389021,18.4291239),(31622,'metatarsal.tif',227,10,156,0.3167705,14.683954,15.6904923,1.8,14.6238701,15.6563155,0.0558338,0.5756946,1.4875417,0.0084746,0.1033339,0.0001644,0.0694662,0.0147206,0.0742403,4.6518217,5.5543728,0.6027436,17.6855792),(31623,'metatarsal.tif',227,10,157,0.2017686,14.5524868,15.6681674,1.8,14.5584852,15.6591302,0.0697418,0.4159021,1.3970799,0.0052448,0.0339601,0.0001633,0.0243079,0.0126107,0.0280194,4.5075311,5.5139132,0.607802,17.7263378),(31624,'metatarsal.tif',227,10,158,0.3127394,14.5052779,15.6052632,1.8,14.5213936,15.5989543,-0.0489326,0.4063677,1.2256405,0.0097901,0.0582654,0.0001247,0.0475387,0.0240917,0.0539602,4.5333205,5.5147912,0.2709469,18.318786),(31625,'metatarsal.tif',227,10,159,0.6816076,14.516485,15.6306533,1.8,14.5284194,15.5868748,-0.0159337,0.5238742,1.4816709,0.0198295,0.2709259,0.0000288,0.1828516,0.0378516,0.1946713,4.7033412,5.3763243,0.516876,17.2293929),(31626,'metatarsal.tif',227,10,160,0.8169188,14.5480958,15.6061668,1.8,14.5692578,15.5794092,-0.0010752,0.5015914,1.7071486,0.026144,0.4113676,0.0000002,0.2409676,0.0521221,0.2538999,4.7666833,5.7249861,2.6395025,18.103055),(31627,'metatarsal.tif',227,10,161,0.8457072,14.5186055,15.573129,1.8,14.552308,15.5514978,0.0072042,0.5193,1.6208926,0.0306189,0.3731729,0.0000073,0.2302268,0.0589619,0.2460293,4.6880068,5.6656957,2.7401216,18.1866205),(31628,'metatarsal.tif',227,10,162,0.8792448,14.5038913,15.5347417,1.8,14.5193768,15.5225265,0.0061604,0.5312185,1.4387769,0.0344125,0.35459,0.0000056,0.2464524,0.0647803,0.2647218,4.3977752,5.5813275,3.053327,16.842786),(31629,'metatarsal.tif',227,10,163,1.0403684,14.4581265,15.4993644,1.8,14.487733,15.4831653,-0.0184285,0.5414425,1.426909,0.0494919,0.4044069,0.0000589,0.2834147,0.0914075,0.3079478,4.1979008,4.9750422,0.1488899,15.4511998),(31630,'metatarsal.tif',227,10,164,1.1514858,14.4636086,15.4395483,1.8,14.4818747,15.4214177,0.010962,0.6351771,1.4323218,0.0688846,0.4798351,0.0000231,0.3350051,0.1084494,0.3698249,4.0814581,4.6664845,0.4353533,14.7146481),(31631,'metatarsal.tif',227,10,165,1.276614,14.4396524,15.3796045,1.8,14.4418402,15.3569602,-0.0015028,0.7178918,1.4021247,0.0931271,0.5521773,0.0000005,0.3938147,0.129723,0.4368668,3.9055637,4.3821157,1.0669693,13.833993),(31632,'metatarsal.tif',227,10,166,1.3780727,14.4457748,15.299968,1.8,14.4620477,15.2603722,0.0016671,0.7373727,1.4467277,0.112284,0.659299,0.0000006,0.4557174,0.1522758,0.4996557,3.579878,4.0963248,1.150133,12.7853585),(31633,'metatarsal.tif',227,10,167,1.5337348,14.4387551,15.2346903,1.8,14.4453696,15.1845125,-0.0166413,0.8669178,1.4449874,0.1584809,0.8345597,0.0000708,0.577555,0.1828096,0.6305725,3.444,3.8765105,1.152572,12.0846206),(31634,'metatarsal.tif',227,10,168,1.6467064,14.4521537,15.1694698,1.8,14.4549892,15.1005338,-0.0045033,0.9998025,1.4860442,0.2080304,1.0007599,0.0000056,0.6734389,0.2080715,0.7399196,3.3407125,3.7855236,1.4141944,11.9166413),(31635,'metatarsal.tif',227,10,169,1.7702963,14.4881749,15.1174935,1.8,14.4884306,15.0313894,0.0206139,1.1459966,1.5343178,0.2724263,1.2612784,0.0001254,0.8220451,0.23772,0.8969841,3.3609721,3.7832849,1.2120257,12.1830206),(31636,'metatarsal.tif',227,10,170,1.976099,14.4947077,15.0458346,1.8,14.5002396,14.957223,0.0100612,1.2699642,1.6459046,0.3961304,1.5316841,0.0000333,0.9306032,0.3119224,1.050365,3.444,3.7807247,1.8884317,11.748662),(31637,'metatarsal.tif',227,10,171,2.1352635,14.4685957,15.002586,1.8,14.4836557,14.9234821,0.0085176,1.3261626,1.7252953,0.4769618,1.8099445,0.0000258,1.0490635,0.3596556,1.1915402,3.4823641,3.8520804,2.0058803,12.2167861),(31638,'metatarsal.tif',227,10,172,2.3099553,14.4558585,14.965721,1.8,14.4770784,14.8807506,-0.0241167,1.3906478,1.8320722,0.7014251,2.1087035,0.0002239,1.1509937,0.5043873,1.3963732,3.5567881,4.1339713,0.6673061,13.3926413),(31639,'metatarsal.tif',227,10,173,2.8701706,14.471637,14.7736345,1.8,14.4846456,14.6088533,0.0203953,1.8315067,1.8542503,1.5135478,2.4503178,0.000199,1.3214601,0.8263949,1.8355803,4.0397669,4.7612282,1.9743313,15.0913654),(31640,'metatarsal.tif',227,10,174,3.7900047,14.4426442,14.4585927,1.8,14.4526529,14.424558,0.0870523,1.8135267,2.0049041,2.6779959,3.3532965,0.0047748,1.6725471,1.4766785,2.5689084,4.2212552,4.9796623,2.0874915,15.9242688),(31641,'metatarsal.tif',227,10,175,5.0534841,14.412157,14.3868228,1.8,14.4190102,14.419891,0.0901259,1.846946,2.1924503,3.5615487,4.7245228,0.0068228,2.1549053,1.9283448,3.2746011,4.1820001,5.0174353,2.300696,15.9530895),(31642,'metatarsal.tif',227,10,176,5.8436509,14.4271754,14.4744712,1.8,14.4171113,14.477645,0.0549826,1.9303282,2.1760197,4.4012661,6.5325757,0.0029413,3.0020756,2.280061,4.3567865,4.2312001,4.8090327,2.2982883,15.6072412),(31643,'metatarsal.tif',227,10,177,5.4523642,14.4347045,14.4822055,1.8,14.4355574,14.5016157,0.0845151,2.0381902,2.2803018,3.987231,6.7913351,0.0064754,2.9782615,1.9562605,4.5352495,4.2591403,4.5956593,1.9433506,14.8797308),(31644,'metatarsal.tif',227,10,178,4.2841699,14.4188696,14.451499,1.8,14.4124179,14.5593619,0.0495982,2.1560087,2.137224,4.2312392,5.6167399,0.0017551,2.6280539,1.9625335,4.0819402,4.1486322,4.5903891,1.2320982,14.5030136),(31645,'metatarsal.tif',227,10,179,3.8917385,14.4100157,14.317106,1.8,14.4301916,14.4381458,-1.5642898,1.8278671,2.2138954,3.400099,4.3516975,0.6485956,1.9656293,1.8601456,3.5007326,3.5441703,4.6074953,1.6885289,16.0724688),(31646,'metatarsal.tif',227,10,180,3.5871873,14.4106892,14.1005826,1.8,14.4185846,14.2218279,1.5552219,1.6226413,2.1469445,2.0004106,4.7837033,0.5977195,2.2281448,1.2328114,3.0506918,3.1056556,4.8348858,1.786154,23.977386),(31647,'metatarsal.tif',227,10,181,3.9395405,14.3979599,14.0612065,1.8,14.4111605,14.2520212,1.5657768,1.5407951,2.3030297,1.8607011,5.332637,0.6565735,2.3154877,1.207624,3.1162544,3.0012,4.8291248,1.7242202,16.8695585),(31648,'metatarsal.tif',227,10,182,3.990271,14.4345631,13.9640368,1.8,14.4602589,14.1886109,1.5316979,1.462309,2.4067117,1.6351856,5.5069928,0.664029,2.2881814,1.1182217,2.9662615,2.9262195,4.9896175,1.7894653,15.3359171),(31649,'metatarsal.tif',227,10,183,3.6474562,14.4543054,13.592433,1.8,14.4686934,13.8610663,1.5395016,1.2816936,2.2861407,1.0287183,4.6509573,0.6073142,2.0344143,0.8026242,2.230923,2.4761492,4.4413732,1.4931748,12.8907516),(31650,'metatarsal.tif',227,10,184,2.1982337,14.4485624,12.7930711,1.8,14.4535494,13.0393051,1.5390459,0.9102559,2.5198753,0.4587323,2.1636403,0.3660031,0.8586299,0.5039596,1.0318642,1.8204,2.6731497,1.6814535,7.1675171),(31651,'metatarsal.tif',227,10,185,1.4498565,14.4527142,12.1242175,1.8,14.4480577,12.1108763,-1.5672437,0.8247331,1.2020275,0.2600041,0.4951336,0.2416397,0.4119154,0.3152584,0.6275144,1.6725448,2.282371,1.4410938,6.2003999),(31652,'metatarsal.tif',227,10,186,1.1440574,14.4441458,11.7871106,1.8,14.4469642,11.7798859,-1.5431272,0.7630254,1.0152167,0.1599011,0.2853299,0.1905303,0.2810531,0.209562,0.4368062,1.4746247,1.9900169,1.4219064,5.499662),(31653,'metatarsal.tif',227,10,187,0.9027937,14.4599931,11.5040657,1.8,14.4621333,11.4900854,-1.5047443,0.6991659,0.9243634,0.0929773,0.1537018,0.1498101,0.1662785,0.1329832,0.2663696,1.307896,1.7773394,1.6539376,4.8685033),(31654,'metatarsal.tif',227,10,188,0.6783275,14.4644092,11.2210412,1.8,14.4596945,11.2221256,-1.477864,0.6460414,0.6914967,0.0552788,0.0753369,0.112081,0.1089476,0.0855653,0.186822,1.1557367,1.4403085,1.7078625,4.1558275),(31655,'metatarsal.tif',227,10,189,0.4073955,14.4538744,11.0066777,1.8,14.452076,10.9939946,-0.23859,0.5059948,0.5447752,0.0208723,0.0285963,0.0037924,0.052492,0.0412501,0.0894165,0.904531,1.1485856,0.1721908,3.303993),(31656,'metatarsal.tif',227,10,190,0.1333355,14.4752291,10.8565797,1.8,14.480902,10.8445747,-0.1179772,0.2711494,0.3528574,0.0025333,0.0039971,0.0003079,0.0113277,0.0093429,0.017209,0.5782507,0.7163628,0.2782997,2.1499655),(31657,'metatarsal.tif',227,10,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31658,'metatarsal.tif',227,10,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31659,'metatarsal.tif',227,10,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31660,'metatarsal.tif',227,10,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31661,'metatarsal.tif',227,10,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31662,'metatarsal.tif',227,10,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31663,'metatarsal.tif',228,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31664,'metatarsal.tif',228,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31665,'metatarsal.tif',228,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31666,'metatarsal.tif',228,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31667,'metatarsal.tif',228,10,5,0.0661937,3.6211842,3.176888,1.8,3.6231608,3.1744715,-0.5426645,0.2023369,0.9510923,0.0008935,0.0179449,0.0029422,0.0188677,0.0044161,0.0195378,0.3937016,1.5773991,0.390607,4.3392338),(31668,'metatarsal.tif',228,10,6,0.8744063,3.9865651,3.5525979,1.8,3.8937326,3.5163777,-0.4779034,0.7902602,1.3330173,0.0434924,0.3187523,0.0308265,0.2391209,0.0550356,0.2687314,1.1240059,2.6289986,0.5366882,11.0052086),(31669,'metatarsal.tif',228,10,7,1.4729447,4.0936584,3.7505799,1.8,4.0778644,3.6782717,-0.5060818,1.0496969,2.5325703,0.2263614,1.1098561,0.057687,0.4382331,0.2156446,0.5127468,1.6173144,3.7035275,0.525851,14.3766097),(31670,'metatarsal.tif',228,10,8,2.0669145,4.3199773,4.0940838,1.8,4.3740556,3.9868677,-0.4975099,1.4214142,3.1103077,0.636003,2.5803169,0.078459,0.8296018,0.4474438,1.026356,2.1407996,5.0375328,0.6037493,27.2423404),(31671,'metatarsal.tif',228,10,9,3.3075218,4.3747684,4.6589085,1.8,4.2845523,4.5920333,-0.5954479,1.9784124,3.9879156,1.9796861,7.5871171,0.1734166,1.902527,1.0006438,2.3641106,2.3282011,5.6615917,0.517893,27.9847428),(31672,'metatarsal.tif',228,10,10,5.4970345,4.4039523,5.1785516,1.8,4.3125856,5.012497,-0.5647987,2.4545869,4.8712913,4.2445849,25.5897377,0.2624725,5.2531734,1.7292461,5.920481,3.6401586,6.4931475,3.1239733,30.0058588),(31673,'metatarsal.tif',228,10,11,7.2217639,4.7472455,5.4533219,1.8,4.5810603,5.3131022,-0.5138999,2.9828656,5.0852849,6.158069,43.5725147,0.2908543,8.5683528,2.0644809,9.5077704,2.8817891,6.7825402,0.393818,21.5793887),(31674,'metatarsal.tif',228,10,12,8.7361517,5.3098952,5.6985132,1.8,5.0774337,5.536086,-0.486715,3.5939187,4.903348,9.8150731,64.0832664,0.3185297,13.0692879,2.7310226,14.628371,3.1473265,9.9550083,0.2854029,47.00116),(31675,'metatarsal.tif',228,10,13,11.4775221,5.4599526,6.0354795,1.8,5.293226,5.8471324,-0.516361,4.1345226,4.9772264,15.9998289,90.4629667,0.4662902,18.1753771,3.8698129,20.9238395,3.3036262,4.669558,2.7849725,26.9194688),(31676,'metatarsal.tif',228,10,14,16.2002934,5.8596235,6.1905675,1.8,5.7070119,6.0254344,-0.564568,4.7497311,5.1382547,28.3575482,122.045895,0.7729685,23.7524026,5.9703481,28.0780584,2.9726401,5.361287,2.7065768,31.8139439),(31677,'metatarsal.tif',228,10,15,0.0876996,4.1623957,7.5221987,1.8,4.0196245,7.3629335,0.8181749,0.3061552,2.8276785,0.0013562,0.122022,0.007787,0.0431527,0.0044299,0.0435936,0,0,0,0),(31678,'metatarsal.tif',228,10,16,0.6216904,4.1813866,7.3571756,1.8,3.9912848,7.0726984,0.9611749,0.8002858,4.6535569,0.0592811,0.6371646,0.0696478,0.1369199,0.0740749,0.1484639,0.6445254,1.4345554,1.160669,3.7117234),(31679,'metatarsal.tif',228,10,17,2.3929971,4.0791715,7.0214075,1.8,4.0433173,7.000843,1.1261436,1.3043008,2.3179275,0.2655838,2.0771806,0.3250391,0.896137,0.2036215,0.9214494,0.2308401,0.954563,1.7211678,2.3238666),(31680,'metatarsal.tif',228,10,18,5.2909082,5.8958323,6.4801564,1.8,5.9187307,6.4682229,-0.3446927,2.0844966,3.3152678,3.9934779,22.834774,0.1006872,6.8877614,1.9157997,7.9837952,1.8470422,4.0552164,2.0155188,11.6858534),(31681,'metatarsal.tif',228,10,19,11.8230759,6.8937051,6.069741,1.8,6.6722838,6.1415913,-0.524558,5.5159935,4.879459,14.776261,55.0599076,0.494266,11.2840189,2.6788032,11.2896032,0.9762781,2.6144913,1.0435093,7.4425814),(31682,'metatarsal.tif',228,10,20,15.773306,6.8382041,6.6567314,1.8,6.8016842,6.6631774,-0.8160806,3.574004,3.8191348,26.1156374,62.9559599,1.395052,16.4843513,7.3071091,21.9811545,5.9011198,7.4549364,0.6657538,31.8618227),(31683,'metatarsal.tif',228,10,21,17.8430515,6.6618625,6.9025811,1.8,6.674889,6.876946,-0.7266061,4.6565981,3.9649228,40.4148766,65.7661319,1.3124851,16.5869893,8.6790563,21.11152,6.6701535,7.5332481,0.2532658,31.9623427),(31684,'metatarsal.tif',228,10,22,16.9455889,6.5784643,6.9447445,1.8,6.5628726,6.9307586,-0.5878887,3.7082717,3.7882262,45.2670922,65.6694238,0.8687077,17.3351378,12.2070593,24.1949941,6.8493863,7.7510028,0.1220667,30.8662321),(31685,'metatarsal.tif',228,10,23,15.81011,6.4181391,6.8191943,1.8,6.3986667,6.8428728,-0.4228429,4.0276156,4.1877095,40.7537294,63.3302658,0.4437131,15.122889,10.1185746,22.8267079,6.9310339,7.8165747,0.347208,29.4680683),(31686,'metatarsal.tif',228,10,24,13.8464873,6.4386416,6.8724036,1.8,6.4000186,6.8864807,-0.2690699,4.059783,4.5105428,37.3134813,58.1598566,0.1630845,12.8942034,9.1910039,20.462756,6.8151509,7.8579038,0.1130688,32.4431381),(31687,'metatarsal.tif',228,10,25,12.3038239,6.3291219,6.9726794,1.8,6.2674372,6.9528959,-0.1621218,3.8719117,4.4873501,34.8991696,56.5550964,0.0534273,12.6032281,9.0134209,20.1933488,6.6205877,7.8507703,0.1351996,33.4461613),(31688,'metatarsal.tif',228,10,26,11.506319,6.3213144,7.1006333,1.8,6.2505614,7.0904841,-0.0995051,3.7683008,4.465091,32.5085781,53.4909776,0.0189253,11.9798181,8.6268532,19.1489709,6.3449398,7.7581754,0.1293847,28.4037805),(31689,'metatarsal.tif',228,10,27,11.0974728,6.3387557,7.2092834,1.8,6.2340464,7.229785,-0.0856993,3.7716105,4.3988149,31.7146589,49.9448115,0.0135508,11.3541517,8.4087842,18.4605928,6.4192437,7.4251982,0.1119333,28.4205339),(31690,'metatarsal.tif',228,10,28,10.8955793,6.3752721,7.2841082,1.8,6.2628275,7.3197425,-0.0771695,3.5758168,4.2906974,31.2252964,45.9241057,0.0107927,10.7031798,8.7323535,17.851661,6.2310504,7.2688912,0.0354183,25.2068523),(31691,'metatarsal.tif',228,10,29,10.7230558,6.4049168,7.3599954,1.8,6.3275952,7.4163603,-0.2213852,3.5600461,4.007299,30.0071705,41.5949365,0.0861703,10.3797937,8.4288714,17.110821,5.8785452,7.0655815,0.0202402,25.1860339),(31692,'metatarsal.tif',228,10,30,10.4054589,6.511209,7.4092,1.8,6.4428679,7.4745243,-0.5326261,3.112534,3.294932,27.8392375,37.2129107,0.4471888,11.2939843,8.9442355,16.2252759,5.6886521,6.7452338,0.0849018,24.1246206),(31693,'metatarsal.tif',228,10,31,9.5385722,6.8060549,7.3868228,1.8,6.7618537,7.4631332,-1.0011337,4.0663116,3.1770247,21.7979258,32.5293669,1.1273062,10.2389404,5.3606137,11.7661375,5.130095,6.569042,1.3913322,22.3658092),(31694,'metatarsal.tif',228,10,32,9.6457856,6.8291962,7.3713849,1.8,6.7788578,7.455054,-1.0091657,2.8529786,3.0995692,21.7543013,31.9558,1.1516624,10.3097552,7.625119,14.6687806,5.1827824,6.4802858,1.3482978,23.1342857),(31695,'metatarsal.tif',228,10,33,9.8518804,6.8159004,7.3658769,1.8,6.7574213,7.4506133,-0.9920055,2.8240938,3.0475424,22.4226692,31.7353794,1.1506631,10.4134331,7.939775,14.2483947,5.1454002,6.4679043,1.3569235,22.1745831),(31696,'metatarsal.tif',228,10,34,10.0626663,6.7442133,7.3757216,1.8,6.6664512,7.4405209,-0.9522861,2.946909,3.0344008,22.8732737,32.0769514,1.1132771,10.5710991,7.7617849,14.5248143,5.1860549,6.4165465,1.3734008,22.3126748),(31697,'metatarsal.tif',228,10,35,10.2612643,6.6534922,7.3946501,1.8,6.5592765,7.4536682,-0.9170944,3.0573632,3.1275748,23.0648488,32.8007828,1.0777384,10.4876095,7.5440329,14.4456366,5.0773778,6.3902968,0.062698,23.4786731),(31698,'metatarsal.tif',228,10,36,10.3938049,6.6057098,7.3812379,1.8,6.5177497,7.4114356,-0.8824573,2.6033739,2.9507706,23.1886191,32.39446,1.033232,10.978305,8.9071412,16.2997548,5.0355434,6.4000173,1.3637604,21.7631823),(31699,'metatarsal.tif',228,10,37,10.5570738,6.5633355,7.3853348,1.8,6.4773433,7.4007676,-0.8586526,2.6442389,2.8973815,23.3390527,32.0969083,1.0081876,11.0779019,8.8263783,16.3483318,4.9876162,6.3213177,1.3796119,20.9877663),(31700,'metatarsal.tif',228,10,38,10.6527458,6.5304523,7.3698776,1.8,6.4588744,7.3666228,-0.8651886,2.4802789,2.8680072,23.1964456,31.4884819,1.0287928,10.9792201,9.3523537,16.4552669,4.9290374,6.3060955,1.3093175,21.8273212),(31701,'metatarsal.tif',228,10,39,10.7689792,6.4929056,7.3877121,1.8,6.4239728,7.3857743,-0.8380249,2.4848462,2.833523,23.0626949,30.9101484,0.9916967,10.9087338,9.281337,16.54316,4.9261207,6.1638233,1.2886726,20.2666754),(31702,'metatarsal.tif',228,10,40,10.7417025,6.474102,7.3702172,1.8,6.4099399,7.3612707,-0.808572,2.502415,2.766205,22.7059033,29.5723135,0.9366148,10.6905717,9.0735964,16.6093268,4.9051667,6.0415204,1.2430578,20.802289),(31703,'metatarsal.tif',228,10,41,10.8301774,6.4414356,7.3659391,1.8,6.3789862,7.3450516,-0.785893,2.4917925,2.7370362,22.5306284,28.9699642,0.903408,10.5844286,9.0419359,16.4099526,4.8594789,5.9527308,1.2733571,19.5594634),(31704,'metatarsal.tif',228,10,42,11.0570013,6.3845264,7.3737802,1.8,6.322381,7.3488332,-0.7190363,2.6224678,2.6983038,22.6050216,29.0362702,0.7994817,10.7609343,8.6197519,16.5624495,4.6766796,5.8707529,1.2690739,19.1284349),(31705,'metatarsal.tif',228,10,43,11.0716641,6.3954194,7.3798769,1.8,6.3345661,7.3594809,-0.7790039,2.7952561,2.6770278,21.906601,28.172925,0.9108399,10.523957,7.8370639,16.0700823,4.6073564,5.8428914,1.2366625,19.0475426),(31706,'metatarsal.tif',228,10,44,11.1663307,6.3936154,7.3793807,1.8,6.3456397,7.3534121,-0.8252882,2.4061607,2.7034202,21.4691391,27.5002263,1.0046865,10.1723832,8.9225708,15.7663278,4.6147028,5.8065208,1.2397003,19.6207279),(31707,'metatarsal.tif',228,10,45,11.2515287,6.3814821,7.3964859,1.8,6.3374943,7.3720639,-0.8266892,2.3937154,2.6993869,21.0019874,26.9583289,1.0149707,9.9868341,8.7738029,16.0134545,4.5571166,5.6672233,1.2043471,18.7072202),(31708,'metatarsal.tif',228,10,46,11.335888,6.3727975,7.3974316,1.8,6.3343315,7.3733743,-0.8323418,2.5089465,2.6875791,20.5461038,26.4850206,1.0332183,9.8546013,8.189136,15.9552334,4.5220575,5.5880104,1.1712808,17.8705397),(31709,'metatarsal.tif',228,10,47,11.4660012,6.3688646,7.3993602,1.8,6.3332568,7.3696692,-0.8317659,2.5797895,2.6758621,20.2428787,26.1103573,1.043982,9.7577367,7.8467171,15.7107025,4.5223989,5.5445141,1.1902899,18.3767117),(31710,'metatarsal.tif',228,10,48,11.499577,6.3696328,7.4020196,1.8,6.3375715,7.3718234,-0.8433551,2.5591861,2.651549,19.7267805,25.6606506,1.0691296,9.6776074,7.7082244,15.257288,4.4979896,5.5175996,1.2326538,18.7840474),(31711,'metatarsal.tif',228,10,49,11.5423184,6.3703875,7.4029509,1.8,6.3389744,7.375195,-0.8516935,3.0932363,2.6405144,19.2120558,25.2826023,1.0890201,9.5748777,6.2109887,12.8842963,4.447331,5.5030526,1.2095926,17.8636003),(31712,'metatarsal.tif',228,10,50,11.6207311,6.3641967,7.3942208,1.8,6.3275644,7.3610115,-0.8493752,3.1788695,2.6356503,18.951013,24.8610951,1.0919664,9.4326229,5.9615575,12.4362235,0.051335,0.2062356,2.1587989,0.437968),(31713,'metatarsal.tif',228,10,51,11.7295727,6.3615659,7.3888952,1.8,6.3324303,7.3501933,-0.8587354,2.8419704,2.6848945,18.8218274,24.6134157,1.1203199,9.167368,6.6228092,14.5280314,0.0285997,0.0404461,2.3561945,0.0808923),(31714,'metatarsal.tif',228,10,52,11.6678745,6.379323,7.403293,1.8,6.3422282,7.3677001,-0.8777543,3.2746545,2.7330414,18.0092431,24.3098562,1.1509033,8.8948,5.4995858,11.9006131,4.3987592,5.4104922,1.1166047,18.0005014),(31715,'metatarsal.tif',228,10,53,11.806534,6.3656512,7.4058301,1.8,6.3326759,7.3707483,-0.8763056,3.3186721,2.7605276,17.9024197,24.1955076,1.1617775,8.7648127,5.3944527,11.7937005,4.3696886,5.4237795,1.1236567,18.1050864),(31716,'metatarsal.tif',228,10,54,11.8547597,6.3619812,7.4157481,1.8,6.3273177,7.3789028,-0.8723843,3.4054933,2.781346,17.6985026,24.1220794,1.1588977,8.6728078,5.1970451,11.5996023,4.3505048,5.4273977,1.1472216,18.4997339),(31717,'metatarsal.tif',228,10,55,11.8385771,6.3621448,7.4199574,1.8,6.3210027,7.3830339,-0.8775446,3.4728405,2.8077251,17.4404279,23.9062927,1.1673344,8.5144705,5.021949,11.3199361,4.3584127,5.3198581,1.2762499,17.7046902),(31718,'metatarsal.tif',228,10,56,11.8086924,6.3581272,7.4258889,1.8,6.3189684,7.3849505,-0.8809772,3.4889245,2.8323968,17.1474248,23.7299814,1.1710246,8.3780569,4.9148168,11.0566752,4.3199032,5.3002183,1.3088036,17.6041701),(31719,'metatarsal.tif',228,10,57,11.8278659,6.3552665,7.4308077,1.8,6.3157872,7.3907264,-0.8756508,3.5309777,2.8627022,16.9729593,23.5906304,1.1626069,8.2406862,4.8068724,10.9772198,4.2970319,5.2801182,1.302169,17.609919),(31720,'metatarsal.tif',228,10,58,11.8128851,6.3495004,7.4380489,1.8,6.3095618,7.4021204,-0.8693965,3.5661537,2.8603781,16.6886254,23.434234,1.1490075,8.1927052,4.679727,10.8978065,4.2821965,5.2924965,1.2746812,17.5371568),(31721,'metatarsal.tif',228,10,59,11.8515631,6.3457436,7.4439151,1.8,6.308842,7.4064348,-0.8746159,3.5640248,2.8856111,16.444136,23.4044825,1.1629248,8.1107542,4.613923,10.749726,4.260949,5.2998325,1.2524587,17.0015432),(31722,'metatarsal.tif',228,10,60,11.838059,6.3420247,7.4477578,1.8,6.3101205,7.4145575,-0.8751328,3.5716014,2.5575027,16.1463012,23.3031238,1.1626034,9.1116712,4.5207455,10.7019015,4.2718826,5.2558966,1.2266743,18.0588915),(31723,'metatarsal.tif',228,10,61,11.7950052,6.33751,7.458274,1.8,6.3087231,7.4265398,-0.8682731,3.5875645,2.5552341,15.8078245,23.1784954,1.1450905,9.0709871,4.406283,10.5420286,4.2240003,5.2294518,1.2767204,17.1997088),(31724,'metatarsal.tif',228,10,62,11.8214923,6.3247396,7.4641046,1.8,6.2985258,7.4345984,-0.8591931,3.5896702,2.5536442,15.7381259,23.1387446,1.1299915,9.0610682,4.3842818,10.5042305,4.2341619,5.2421838,1.2024474,17.0685566),(31725,'metatarsal.tif',228,10,63,11.8329445,6.3182827,7.468664,1.8,6.2904627,7.439606,-0.8586369,3.5745509,2.5451133,15.5720176,23.0598239,1.1300011,9.0604312,4.3563563,10.4879657,4.2253829,5.2218604,1.2126667,17.7757686),(31726,'metatarsal.tif',228,10,64,11.8506511,6.3082521,7.4740136,1.8,6.2798355,7.4422091,-0.8563839,3.6002041,2.5565396,15.4986394,23.0235169,1.1272883,9.0057346,4.3049335,10.4677621,4.2400273,5.2319538,1.2075471,17.4285067),(31727,'metatarsal.tif',228,10,65,11.8429593,6.3016369,7.4761397,1.8,6.2772984,7.4438153,-0.8551946,3.55817,2.5716519,15.3913707,22.9562426,1.1242323,8.9266523,4.3256423,10.5122797,4.2543765,5.2421838,1.2024474,17.2164622),(31728,'metatarsal.tif',228,10,66,11.8455683,6.2965066,7.4783757,1.8,6.2683434,7.4457615,-0.8553863,3.5906086,2.5637572,15.2757255,22.9114757,1.1248547,8.9366791,4.2543556,10.4306215,4.2438924,5.2193535,1.229984,17.3811211),(31729,'metatarsal.tif',228,10,67,11.8325315,6.2912888,7.4835778,1.8,6.2619996,7.451799,-0.8515809,3.563173,2.5621685,15.1659363,22.8572342,1.1161817,8.9210505,4.2563008,10.4916657,4.2412173,5.2425739,1.1730677,17.7590152),(31730,'metatarsal.tif',228,10,68,11.8273314,6.2895979,7.4876742,1.8,6.2624029,7.4540991,-0.8533575,3.5873121,2.5812756,15.077245,22.8283156,1.1191618,8.8438117,4.2029365,10.386858,4.2486501,5.2421838,1.2024474,17.4926456),(31731,'metatarsal.tif',228,10,69,11.8496737,6.2871968,7.4918438,1.8,6.2617249,7.4565173,-0.8542826,3.0719531,2.592944,15.0142275,22.8399021,1.1230859,8.8084826,4.8875185,12.1526646,4.2596396,5.2579971,1.1801893,17.9306136),(31732,'metatarsal.tif',228,10,70,11.8656869,6.2833648,7.4939138,1.8,6.255447,7.4577856,-0.8538401,3.086223,2.5937629,14.944492,22.8430974,1.1237367,8.8069333,4.8423241,12.1154306,4.2691423,5.2502133,1.1558906,18.1426582),(31733,'metatarsal.tif',228,10,71,11.8925427,6.2812775,7.4954315,1.8,6.2551173,7.4586032,-0.8571637,3.0842193,2.618551,14.8630932,22.8640387,1.1328032,8.7315612,4.8190779,12.1319075,4.2546622,5.2630505,1.1923081,17.4354462),(31734,'metatarsal.tif',228,10,72,11.9167928,6.2758614,7.4970194,1.8,6.246322,7.4605296,-0.8608881,3.0795557,2.60851,14.8421421,22.8263601,1.1424301,8.7507274,4.8195725,12.1574638,4.2774564,5.2502133,1.1558906,17.6168584),(31735,'metatarsal.tif',228,10,73,11.9154606,6.2710316,7.4981883,1.8,6.2416059,7.4611122,-0.8654187,3.1152336,2.6252543,14.7825324,22.7861454,1.1511912,8.6795955,4.7452405,12.0114058,4.2662948,5.2502133,1.1558906,17.0338593),(31736,'metatarsal.tif',228,10,74,11.8529857,6.2697877,7.5091393,1.8,6.2402829,7.477099,-0.8681233,3.5924315,2.6443641,14.6068893,22.6201545,1.1504275,8.5540998,4.0660175,10.3611567,4.2905122,5.2568303,1.1022826,17.3643678),(31737,'metatarsal.tif',228,10,75,11.836226,6.2637878,7.5128005,1.8,6.2326839,7.4821545,-0.8705893,3.5281712,2.6315526,14.5368458,22.5109764,1.1535972,8.5542568,4.1202212,10.5001917,4.29641,5.2218604,1.2126667,17.3643678),(31738,'metatarsal.tif',228,10,76,11.8348392,6.2633481,7.5142691,1.8,6.2369205,7.4843166,-0.8744849,3.1515495,2.6661188,14.4695604,22.4153735,1.1610296,8.4074925,4.5912527,11.6966795,4.2852915,5.2334388,1.1364802,17.1286304),(31739,'metatarsal.tif',228,10,77,11.8598109,6.2573928,7.51544,1.8,6.2260857,7.4846641,-0.8776368,3.5179649,2.6588229,14.5017512,22.2846304,1.1696073,8.3813894,4.1221989,10.448221,4.3202477,5.2312502,1.1120387,18.1831043),(31740,'metatarsal.tif',228,10,78,11.8227586,6.2563865,7.521682,1.8,6.2331365,7.4943359,-0.8777247,3.4917319,2.678887,14.3053656,22.1946667,1.1661234,8.2850327,4.0969255,10.452676,4.2490485,5.2253053,1.0557235,17.1551977),(31741,'metatarsal.tif',228,10,79,11.8350201,6.2538085,7.5251198,1.8,6.232221,7.4966401,-0.8788185,3.4334611,2.6582614,14.2862993,22.1467061,1.1694533,8.3312747,4.1609032,10.6097964,4.2443927,5.2061729,1.1218897,16.9627809),(31742,'metatarsal.tif',228,10,80,11.8610152,6.2522995,7.5232439,1.8,6.2295216,7.498911,-0.8824882,3.4533711,2.6904053,14.2613945,22.1354558,1.1791451,8.2275542,4.1297022,10.5378634,4.2476213,5.2575304,1.0901187,16.7703641),(31743,'metatarsal.tif',228,10,81,11.8774468,6.2506137,7.5195546,1.8,6.2324528,7.4948187,-0.8864656,3.3875484,2.6878052,14.2176494,22.0537847,1.1884981,8.2051275,4.1970321,10.7067045,4.3001657,5.2362513,1.0631673,17.6532395),(31744,'metatarsal.tif',228,10,82,11.8823737,6.250182,7.5190608,1.8,6.2325402,7.4970008,-0.8895364,3.2440974,2.7080684,14.1726342,22.0032232,1.1949448,8.1250619,4.368745,11.151085,4.2920145,5.2569081,1.1144479,17.5012689),(31745,'metatarsal.tif',228,10,83,11.9051847,6.2477944,7.5212991,1.8,6.2302919,7.5034385,-0.889676,2.6096199,2.7114143,14.1649549,21.8831789,1.1975098,8.0707618,5.4279763,12.8236033,4.3467206,5.2590082,1.0779599,17.5752217),(31746,'metatarsal.tif',228,10,84,11.910547,6.247713,7.5240728,1.8,6.2292269,7.5031511,-0.894135,2.588882,2.7260393,14.1491862,21.7770723,1.2067008,7.9885394,5.4653654,12.8417798,4.3378101,5.2439779,1.1071487,17.9392369),(31747,'metatarsal.tif',228,10,85,11.8692665,6.2505031,7.5208578,1.8,6.2307892,7.5018311,-0.8973926,2.5620005,2.7059835,14.0680371,21.6840218,1.2088063,8.0133606,5.4910361,12.8549537,4.3282432,5.2313284,1.0998139,17.4175022),(31748,'metatarsal.tif',228,10,86,11.8760203,6.2485876,7.5231511,1.8,6.2294536,7.5028896,-0.9014636,2.51658,2.7115632,14.0829188,21.6084262,1.2173432,7.9689924,5.5960544,12.8197973,4.300149,5.2321883,1.0875913,17.272471),(31749,'metatarsal.tif',228,10,87,11.8032428,6.2527431,7.5254864,1.8,6.2358594,7.5079283,-0.9117045,2.4691862,2.7120922,13.9248386,21.5433042,1.22944,7.9434261,5.6394446,12.7999971,4.2596955,5.2112765,1.0604995,17.2140809),(31750,'metatarsal.tif',228,10,88,11.8556246,6.2471293,7.5261836,1.8,6.2258944,7.5111511,-0.913881,2.5325318,2.7347677,14.0139127,21.5455358,1.239058,7.8783786,5.5335585,12.760392,4.2149051,5.2321883,1.0875913,17.5613428),(31751,'metatarsal.tif',228,10,89,11.7648855,6.2434587,7.5367599,1.8,6.2214217,7.5223525,-0.9062717,2.600427,2.7314492,13.9625533,21.3377112,1.2151159,7.8118647,5.3693311,12.7288866,4.2102682,5.2112765,1.0604995,17.2475876),(31752,'metatarsal.tif',228,10,90,11.7633321,6.240841,7.5299554,1.8,6.2158875,7.5141658,-0.9173021,2.6372824,2.7153748,14.1084141,21.250539,1.2358934,7.8260058,5.349603,12.8341598,4.3445944,5.2004352,1.0530145,18.6423838),(31753,'metatarsal.tif',228,10,91,11.7163513,6.2383331,7.5318737,1.8,6.2118146,7.5193666,-0.919453,2.63604,2.714011,14.1294533,21.1538077,1.23501,7.7942969,5.3601057,12.8480475,4.265493,5.1844463,1.0256465,17.8652841),(31754,'metatarsal.tif',228,10,92,11.6621749,6.232604,7.5310751,1.8,6.2038437,7.5172474,-0.9223053,2.6532131,2.6952256,14.1493724,21.0547243,1.234641,7.8118597,5.3329197,12.9275974,4.2616427,5.1696739,1.0303768,17.1666953),(31755,'metatarsal.tif',228,10,93,11.5752147,6.227511,7.5350133,1.8,6.1960941,7.523552,-0.9269335,2.6734696,2.6803311,14.1326745,20.9300854,1.2340196,7.8087685,5.286267,12.9664883,4.3486552,5.1506525,1.0151399,18.7677873),(31756,'metatarsal.tif',228,10,94,11.4816311,6.2270529,7.5399228,1.8,6.195232,7.5288103,-0.9317362,2.6980363,2.7203486,14.0808047,20.8356775,1.232855,7.6591939,5.2189086,12.7571515,4.3541846,5.1879161,0.9934967,17.9351718),(31757,'metatarsal.tif',228,10,95,11.4069437,6.2235726,7.5460432,1.8,6.1900288,7.5339651,-0.9325312,2.7217041,2.7046072,14.0953437,20.7767729,1.2262822,7.6819928,5.1788672,12.7836129,4.2749961,5.1642124,0.9705056,17.1205004),(31758,'metatarsal.tif',228,10,96,11.340891,6.2203861,7.5530555,1.8,6.1858175,7.5434485,-0.9354898,2.722746,2.7069205,14.1059167,20.6440785,1.2245283,7.6264074,5.1807684,12.7288991,4.3554861,5.1569215,1.0027911,18.467911),(31759,'metatarsal.tif',228,10,97,11.3081415,6.2139702,7.5603004,1.8,6.1772551,7.5483272,-0.939938,2.7440212,2.7175819,14.1763528,20.5703293,1.2289896,7.5693503,5.1662694,12.6278842,4.3556594,5.1639748,0.9904741,17.6855556),(31760,'metatarsal.tif',228,10,98,11.2429323,6.2136535,7.5676227,1.8,6.176193,7.553663,-0.9413007,2.7709136,2.7345472,14.1970438,20.5269695,1.2243339,7.5065332,5.1235968,12.500101,4.358966,5.1733117,0.9582588,18.5990633),(31761,'metatarsal.tif',228,10,99,11.1612467,6.2142485,7.5729273,1.8,6.1722607,7.5576608,-0.9380588,2.775154,2.7317857,14.1978151,20.4400041,1.2096928,7.4822867,5.1160458,12.4516965,4.3539947,5.1639748,0.9904741,18.4372788),(31762,'metatarsal.tif',228,10,100,11.1049705,6.2121049,7.5797476,1.8,6.1712122,7.566613,-0.9346378,2.7781217,2.7260447,14.2157639,20.3838857,1.1975481,7.4774585,5.1170415,12.4255866,4.3102384,5.1499379,0.9550659,17.6197329),(31763,'metatarsal.tif',228,10,101,11.0519136,6.2076439,7.5854185,1.8,6.1648324,7.5722673,-0.9362957,2.8066866,2.7394408,14.2662948,20.3549184,1.1947437,7.4303188,5.0829667,12.3190681,4.3398098,5.1665085,0.9505468,18.4245905),(31764,'metatarsal.tif',228,10,102,11.0407805,6.2000338,7.5958827,1.8,6.1533732,7.5825991,-0.9359124,2.8759009,2.746276,14.4063168,20.3404055,1.1928667,7.4065409,5.009323,12.0739959,4.355578,5.1733117,0.9582588,18.0842681),(31765,'metatarsal.tif',228,10,103,10.94901,6.1968692,7.5980464,1.8,6.1508799,7.5861658,-0.9361465,2.6977044,2.7438348,14.4352964,20.296359,1.1833596,7.3970775,5.3509555,12.657741,4.3441847,5.1708604,0.9306138,17.8514052),(31766,'metatarsal.tif',228,10,104,10.9180374,6.1949325,7.5891446,1.8,6.1481974,7.5709737,-0.948163,3.0390808,2.744327,14.5735684,20.4456179,1.200812,7.4501392,4.795387,11.5185492,4.3756429,5.1878373,0.5971767,18.6880856),(31767,'metatarsal.tif',228,10,105,10.8926103,6.1896051,7.5922795,1.8,6.1405034,7.5704146,-0.9535385,3.1391289,2.7665882,14.7590591,20.5469382,1.2072448,7.4268148,4.7016416,11.2410178,4.4040847,5.2365637,0.610726,18.3772049),(31768,'metatarsal.tif',228,10,106,10.8650681,6.1897771,7.5942796,1.8,6.1393374,7.5672166,-0.9604651,3.165366,2.7843111,14.8939684,20.6858638,1.2160036,7.429437,4.7052911,11.2149932,4.3986948,5.2630505,0.6271982,19.0035246),(31769,'metatarsal.tif',228,10,107,10.84736,6.1937798,7.5983511,1.8,6.1388202,7.5676159,-0.9722821,3.1607141,2.8167204,15.1146255,20.8015756,1.2340009,7.3850338,4.7820287,11.3153865,4.3916485,5.3327577,0.6177557,18.7579734),(31770,'metatarsal.tif',228,10,108,10.8224294,6.1984145,7.5992335,1.8,6.1401077,7.5613912,-0.983638,3.1694291,2.8131559,15.3300363,20.9036389,1.2501471,7.430672,4.8368448,11.347209,4.3936257,5.3598374,0.6338963,19.5489521),(31771,'metatarsal.tif',228,10,109,10.8087781,6.1992327,7.5948926,1.8,6.1427534,7.5525338,-1.002978,3.1551055,2.8361178,15.4822778,21.0784085,1.2804395,7.4321342,4.9070556,11.4131846,0.0285997,0.0904403,1.8925469,0.1952912),(31772,'metatarsal.tif',228,10,110,10.7545864,6.1994433,7.5960093,1.8,6.1483206,7.5509716,-1.0173146,3.1651981,2.847852,15.6145093,21.1503643,1.2971638,7.426778,4.9331855,11.399179,4.3956957,5.525895,0.6310794,19.1808718),(31773,'metatarsal.tif',228,10,111,10.7429626,6.1989838,7.5937686,1.8,6.1489292,7.5410137,-1.0334563,3.179871,2.8404234,15.8032698,21.3173142,1.3213967,7.5049776,4.9697833,11.3101979,4.2071122,5.354188,0.8610113,17.8334612),(31774,'metatarsal.tif',228,10,112,10.7248574,6.1947951,7.5886111,1.8,6.1485009,7.5376311,-1.0438121,3.1632853,2.8339847,15.9269511,21.4531391,1.3353563,7.569956,5.0349399,11.4775455,4.2062388,5.3655571,0.9177006,17.8583446),(31775,'metatarsal.tif',228,10,113,10.6802578,6.1867843,7.589095,1.8,6.1382513,7.5372732,-1.0535686,3.1772923,2.8483182,16.0326467,21.54972,1.3448172,7.5657698,5.0460094,11.4201915,4.2389852,5.4005053,0.7666738,17.519706),(31776,'metatarsal.tif',228,10,114,10.6425256,6.184036,7.591098,1.8,6.1453558,7.540557,-1.0585959,3.1928888,2.8489881,16.0525766,21.6623156,1.3477081,7.6035122,5.0276028,11.3691704,4.2249039,5.4409444,0.7668129,17.8918513),(31777,'metatarsal.tif',228,10,115,10.6014086,6.1786712,7.592479,1.8,6.1400281,7.5439447,-1.0632064,3.2076517,2.8644121,16.196391,21.7312623,1.3494419,7.5866395,5.0492985,11.294067,4.2557119,5.4615758,0.7631796,17.9923713),(31778,'metatarsal.tif',228,10,116,10.5372686,6.174096,7.5902105,1.8,6.1458165,7.5450421,-1.0791307,3.2255834,2.8674366,16.1958879,21.7869384,1.3647984,7.598054,5.0210724,11.5648978,4.2665863,5.5008226,0.792751,18.4008977),(31779,'metatarsal.tif',228,10,117,10.4932168,6.1702751,7.5905709,1.8,6.1463239,7.5460691,-1.0887026,3.2080419,2.8895231,16.2467548,21.8698661,1.3729366,7.5686767,5.0643836,11.4365081,4.2786471,5.5253769,0.8256694,18.4875388),(31780,'metatarsal.tif',228,10,118,10.4422984,6.1660959,7.5894054,1.8,6.1499887,7.5461645,-1.0962676,3.2435382,2.9115013,16.3199785,21.9039874,1.3770342,7.523262,5.0315359,11.1973235,4.3019716,5.5839104,0.8143756,18.5279849),(31781,'metatarsal.tif',228,10,119,10.399374,6.1580963,7.5878075,1.8,6.1489185,7.5462659,-1.0985851,3.2475513,2.9248376,16.3858545,21.9473692,1.3746333,7.5037907,5.045603,11.8005745,4.3172357,5.6233216,0.8069775,18.9503902),(31782,'metatarsal.tif',228,10,120,10.3417544,6.150139,7.585312,1.8,6.1457597,7.5398014,-1.1058736,2.4608521,2.9604667,16.4605936,21.9913808,1.3771406,7.4283494,6.6889812,12.7351411,4.3294307,5.6695321,0.8353566,19.2808987),(31783,'metatarsal.tif',228,10,121,10.2497802,6.1378574,7.5911363,1.8,6.131041,7.5487895,-1.1155379,3.1149484,2.9526495,16.5491682,21.9440174,1.3780297,7.4319751,5.3128227,10.8402615,4.3441973,5.6741469,0.8495955,19.0647891),(31784,'metatarsal.tif',228,10,122,10.1135293,6.1278199,7.5944018,1.8,6.1188462,7.5501968,-1.126798,2.4525571,2.9787395,16.5990141,21.8656109,1.3745698,7.3405583,6.7680439,12.6306662,4.3548709,5.7202328,0.8632547,19.5501427),(31785,'metatarsal.tif',228,10,123,10.0031804,6.117289,7.599545,1.8,6.1097501,7.5539842,-1.1290393,2.4677176,3.0123183,16.6672041,21.7645979,1.3624655,7.2251987,6.7540969,12.4837227,4.3921887,5.7491157,0.8805166,19.4553715),(31786,'metatarsal.tif',228,10,124,9.9637614,6.1100514,7.5968653,1.8,6.1024746,7.5467485,-1.1350335,2.482034,3.0090827,16.8187869,21.8948494,1.3647527,7.2762537,6.7762114,12.566076,4.4132402,5.761906,0.9014817,19.3299681),(31787,'metatarsal.tif',228,10,125,9.9015903,6.101032,7.6017367,1.8,6.0937334,7.5518889,-1.1383704,2.470929,3.0789832,16.9240361,21.9273871,1.3604396,7.1216327,6.8492604,12.3221275,4.4259185,5.8517041,0.8823158,19.5865238),(31788,'metatarsal.tif',228,10,126,9.8697346,6.0913938,7.6074041,1.8,6.0814403,7.5626196,-1.1374072,3.1458119,3.0768164,17.057833,21.9778009,1.3548561,7.1430329,5.4223944,10.2170322,4.4478029,5.8470196,0.9067502,19.4235486),(31789,'metatarsal.tif',228,10,127,9.8477764,6.0779869,7.6103422,1.8,6.0652862,7.5654697,-1.1347187,3.2632832,3.1128197,17.1970937,22.0718747,1.3484706,7.0906372,5.2698748,9.7460466,4.4738633,5.8871703,0.9059185,20.2001552),(31790,'metatarsal.tif',228,10,128,9.7365625,6.072042,7.6233435,1.8,6.0612541,7.5793535,-1.1271914,3.2824728,3.1835597,17.1752004,21.9985673,1.3238298,6.9100532,5.2323968,9.7889566,4.485722,5.6210666,0.8682406,18.7273411),(31791,'metatarsal.tif',228,10,129,9.6832933,6.0594811,7.6301856,1.8,6.0467487,7.5870783,-1.1167742,2.519548,3.2269857,17.2383919,22.0500874,1.3034428,6.8330291,6.841859,11.9948035,4.4994976,5.7171577,0.8952741,19.0329662),(31792,'metatarsal.tif',228,10,130,9.603681,6.0516797,7.6334789,1.8,6.0393826,7.595404,-1.1101513,2.493422,3.2243378,17.2664138,21.9982113,1.2843269,6.8225518,6.9247861,12.0222731,4.5135442,5.6546528,0.8928958,18.5014177),(31793,'metatarsal.tif',228,10,131,9.5088626,6.0404806,7.6421907,1.8,6.0281655,7.6092551,-1.1128572,2.4976705,3.2613373,17.212742,21.892505,1.2750548,6.7127386,6.8915183,11.8397361,4.5235568,5.7371523,0.9233072,18.73309),(31794,'metatarsal.tif',228,10,132,9.4829373,6.0329684,7.6468453,1.8,6.0198623,7.612583,-1.1077377,2.5099,3.3098511,17.2072807,21.9583012,1.265136,6.6342263,6.8557635,11.6880395,4.5283057,5.5075841,0.8847015,18.148407),(31795,'metatarsal.tif',228,10,133,9.4344666,6.0300479,7.6582048,1.8,6.0195648,7.6274119,-1.108071,2.4994453,3.3339118,17.1416391,21.9898437,1.2590882,6.5958085,6.8581773,11.5824332,4.5282771,5.5713721,0.9201085,18.1079609),(31796,'metatarsal.tif',228,10,134,9.4019346,6.0291008,7.6598442,1.8,6.0200245,7.631922,-1.100356,2.4908732,3.352454,17.1391201,22.0252518,1.2450329,6.5698893,6.8807679,11.5628558,4.5371457,5.4858584,0.9147828,18.2501176),(31797,'metatarsal.tif',228,10,135,9.3856431,6.0298112,7.6537717,1.8,6.0260699,7.6280624,-1.0824311,2.5250669,2.7889793,17.1595332,22.1057028,1.2199262,7.9260905,6.7956748,13.5030998,4.53076,5.4211398,0.8077825,18.0033758),(31798,'metatarsal.tif',228,10,136,9.4377765,6.0341253,7.6522691,1.8,6.0286379,7.6296403,-1.0781876,2.5132682,2.6820683,17.3098405,22.2670717,1.2211554,8.3022017,6.887383,14.0059201,4.5549751,5.404139,0.8265734,17.828903),(31799,'metatarsal.tif',228,10,137,9.4641369,6.0365717,7.6459529,1.8,6.0339137,7.6268336,-1.0747412,2.5116694,2.6865935,17.4190442,22.5006753,1.2200254,8.3751694,6.9352457,14.0518516,4.5692989,5.4292059,0.9462603,17.9866225),(31800,'metatarsal.tif',228,10,138,9.4359142,6.0374612,7.6428881,1.8,6.0340121,7.6256627,-1.0765386,2.5375708,2.6566428,17.4635726,22.6555326,1.2187509,8.5278806,6.882004,14.2420567,4.5607167,5.4235533,0.8226943,17.5850356),(31801,'metatarsal.tif',228,10,139,9.4672104,6.0322525,7.6513525,1.8,6.0299704,7.6304037,-1.0816483,2.548505,2.7161518,17.599553,23.0294349,1.2295042,8.4786995,6.9058343,14.2766916,4.5756808,5.4626241,0.8150191,17.6046633),(31802,'metatarsal.tif',228,10,140,9.4776894,6.0235296,7.6634644,1.8,6.0253108,7.6453734,-1.0829443,2.5309898,2.6634362,17.6952761,23.4167126,1.2325618,8.791918,6.9914451,14.4595651,4.5976159,5.4675631,0.8372036,17.6826812),(31803,'metatarsal.tif',228,10,141,9.4578715,6.0113899,7.6683715,1.8,6.0097179,7.6508896,-1.083083,2.5611852,2.7357156,17.711099,23.7780556,1.2301655,8.6917134,6.9151966,14.3373532,4.5972699,5.5505593,0.8437261,18.1778486),(31804,'metatarsal.tif',228,10,142,9.3924714,6.0023851,7.6809428,1.8,6.0042811,7.6644694,-1.083103,2.5307731,2.7138926,17.643162,24.0805502,1.221685,8.8730669,6.9714516,14.3941733,4.6169204,5.5448092,0.8218783,18.1079609),(31805,'metatarsal.tif',228,10,143,9.345278,5.9974124,7.6962928,1.8,5.998256,7.6817574,-1.0785305,2.5852262,2.7594842,17.5252516,24.6071282,1.209632,8.9172927,6.7790011,14.4044838,4.6537496,5.6062045,0.8250885,18.4315299),(31806,'metatarsal.tif',228,10,144,9.268481,5.9819983,7.6929551,1.8,5.9830312,7.6776156,-1.0674233,2.5649959,2.788326,17.4309579,25.0551147,1.1852947,8.9857193,6.795706,14.3860484,4.6835173,5.6553036,0.8533935,18.3535121),(31807,'metatarsal.tif',228,10,145,9.2056474,5.9767968,7.7004392,1.8,5.9803877,7.6847254,-1.0593898,2.5769581,2.8051264,17.3942604,25.6288266,1.1667904,9.1364248,6.7499198,14.497871,4.6846973,5.6930714,0.8458227,18.1720998),(31808,'metatarsal.tif',228,10,146,9.1263134,5.9670851,7.6956881,1.8,5.9740263,7.684274,-1.049575,2.5561601,2.889453,17.3161515,26.3728231,1.1439166,9.1272719,6.7742829,14.4391046,4.599444,5.7979216,0.8552146,18.1079609),(31809,'metatarsal.tif',228,10,147,9.1088221,5.957734,7.6730397,1.8,5.9631819,7.6641214,-1.0423582,2.6221579,2.9797661,17.4263749,27.3499916,1.1322226,9.1785699,6.6458145,14.4718657,4.6193706,5.9331181,0.836548,18.6950251),(31810,'metatarsal.tif',228,10,148,9.2643171,5.9405812,7.6556068,1.8,5.9352466,7.6410736,-1.0513019,2.7019426,2.926554,17.9339002,28.8828838,1.1635149,9.8692469,6.6374097,15.3152385,4.6383589,5.9567143,0.8465463,19.3670466),(31811,'metatarsal.tif',228,10,149,9.3859415,5.9221861,7.6837302,1.8,5.9307402,7.667623,-1.0726023,2.4540511,2.9910462,18.4180327,30.6265642,1.2071402,10.2394152,7.5051545,15.6840237,4.6662959,6.06456,0.8621701,18.905879),(31812,'metatarsal.tif',228,10,150,9.5909014,5.8852503,7.7123615,1.8,5.8977751,7.6986275,-1.0961238,2.3525447,3.1122069,19.2046558,32.822465,1.264573,10.5463635,8.1633542,16.0813203,4.7153242,6.2105559,0.8701619,19.3409726),(31813,'metatarsal.tif',228,10,151,9.70929,5.8369563,7.7242413,1.8,5.8449027,7.7140965,-1.074606,2.4103076,3.2393923,19.9187547,34.7680901,1.251445,10.732905,8.2639888,16.3745492,4.8213807,6.366509,0.9192091,20.0354963),(31814,'metatarsal.tif',228,10,152,9.8853179,5.7903874,7.6760155,1.8,5.805567,7.6706442,-1.0711859,2.6687585,3.258638,20.8564588,36.9626791,1.2694047,11.3429843,7.8150417,16.9522465,4.7847944,6.4468774,0.9397169,19.8124472),(31815,'metatarsal.tif',228,10,153,10.0370157,5.7182612,7.6426387,1.8,5.7246008,7.6374086,-1.0524086,2.7879449,3.8061339,21.7585744,39.536984,1.2621534,10.3877017,7.804521,15.9353979,4.8379923,6.6948429,0.9768696,20.7774056),(31816,'metatarsal.tif',228,10,154,10.7468492,5.6214906,7.6798168,1.8,5.6479303,7.6428526,-1.0671069,3.110817,4.2065348,24.0325878,44.5661844,1.3738759,10.5945123,7.7254907,16.2718771,4.930901,6.8773293,0.989714,21.6729693),(31817,'metatarsal.tif',228,10,155,11.2732207,5.5912002,7.6794664,1.8,5.6323308,7.6432288,-1.0993622,2.6038694,4.35519,24.7905525,51.1815094,1.4913244,11.751843,9.5206588,17.4427254,4.9617243,7.039312,1.0143503,21.8555722),(31818,'metatarsal.tif',228,10,156,11.6004476,5.5633069,7.6509009,1.8,5.5814999,7.6258294,-1.092102,3.0205547,4.2538156,25.5314535,56.7252031,1.523194,13.3351344,8.4525713,19.336629,5.0887622,7.3034672,1.0229895,23.124965),(31819,'metatarsal.tif',228,10,157,12.0695287,5.551961,7.6412098,1.8,5.5651222,7.5947444,-1.074255,3.338943,4.3480531,27.6627134,62.6527281,1.5550683,14.4093752,8.2848715,20.7473434,5.2567113,7.636611,1.0920745,24.1222394),(31820,'metatarsal.tif',228,10,158,12.5300058,5.4986664,7.6384442,1.8,5.4943685,7.5861146,-1.0607559,3.163874,4.3800252,30.7159513,65.5216018,1.5905767,14.9591837,9.7083357,21.9110696,5.4244456,7.7137677,1.0889086,25.4512129),(31821,'metatarsal.tif',228,10,159,13.9418533,5.4262611,7.6262043,1.8,5.4106098,7.5650654,-1.0554785,3.0916091,3.9869665,36.9599924,69.501617,1.7593153,17.4322049,11.9549372,24.4950849,5.5452524,7.598923,1.127348,25.0288076),(31822,'metatarsal.tif',228,10,160,15.2453457,5.3592659,7.6231638,1.8,5.3635321,7.5768575,-1.0775068,2.8065047,3.882336,41.1982224,72.1291908,1.9711555,18.5788121,14.6795485,28.3872177,5.5652779,7.5215126,0.5658543,25.3720044),(31823,'metatarsal.tif',228,10,161,18.5723652,5.3549571,7.6692854,1.8,5.3440962,7.6353302,-1.0629606,2.852724,3.8848322,43.7678233,75.8165521,2.3634099,19.5160431,15.3424667,29.8612591,5.5437523,7.6004836,0.5681722,25.0623143),(31824,'metatarsal.tif',228,10,162,19.6919987,5.3376331,7.6839479,1.8,5.3241003,7.6533456,-1.070707,2.855431,4.6807707,43.8205125,77.9795866,2.5273893,16.6595613,15.3463739,25.9468988,5.497224,7.5918693,0.5733746,24.8935903),(31825,'metatarsal.tif',228,10,163,18.452432,5.3691745,7.6254857,1.8,5.3565113,7.6086036,-1.1107691,2.9027324,4.5193014,42.1627302,70.5345759,2.4692072,15.6074067,14.525187,24.6891438,5.4542027,7.5678593,0.5754247,26.0052636),(31826,'metatarsal.tif',228,10,164,18.6002076,5.363695,7.6327892,1.8,5.3358682,7.6298176,-1.0835119,2.8029794,4.7506241,41.5219352,65.7198006,2.4203905,13.83393,14.8135002,22.5727624,5.3750768,7.5283062,0.6017004,26.4934916),(31827,'metatarsal.tif',228,10,165,19.3270096,5.393337,7.6719684,1.8,5.3674565,7.6637382,-1.0794956,2.7839091,4.9226667,40.1862632,65.8668538,2.5042331,13.3803196,14.4351926,21.5402134,0.0857992,0.1667637,0.5404195,0.3807685),(31828,'metatarsal.tif',228,10,166,20.2342611,5.4136973,7.6623878,1.8,5.3917929,7.6488285,-1.0720797,2.6972262,4.7873237,36.7625259,66.4606477,2.6008788,13.8826308,13.6297525,21.5474803,0.1793094,0.381568,1.3439975,1.1353661),(31829,'metatarsal.tif',228,10,167,19.1809409,5.443953,7.713928,1.8,5.4133482,7.6784594,-1.0557197,2.9285239,4.5940037,30.0448287,62.880786,2.4210941,13.6875783,10.2593765,20.1710162,4.7990433,7.3127009,0.691233,26.5547561),(31830,'metatarsal.tif',228,10,168,18.0110008,5.4808348,7.7533201,1.8,5.4650915,7.7106459,-1.0569806,2.4150326,4.4101288,22.2233045,58.4884548,2.2766626,13.2623008,9.2020722,18.300414,4.3935271,7.1241473,0.7456464,26.4525523),(31831,'metatarsal.tif',228,10,169,16.1357885,5.5205107,7.7548935,1.8,5.5196877,7.7000709,-1.0660818,2.1416648,4.30626,14.0816486,50.7226408,2.060465,11.7788153,6.5750946,15.0482697,3.8987612,7.0799218,0.762545,26.435799),(31832,'metatarsal.tif',228,10,170,12.9442335,5.5423084,7.7380647,1.8,5.5767168,7.6405476,-1.0918318,1.8921869,4.1651454,6.1398007,38.3075954,1.6991629,9.1971809,3.2448172,10.6552363,3.3026591,7.0315807,1.1872688,27.1777083),(31833,'metatarsal.tif',228,10,171,4.8131801,5.7141584,7.4437224,1.8,5.8318903,7.2622603,-1.0213139,1.9200974,3.7365508,1.0591927,9.9492213,0.5834049,2.6626753,0.5516349,2.9450552,2.8828007,5.951013,1.0081216,26.27114),(31834,'metatarsal.tif',228,10,172,15.4154728,4.7772597,8.8047465,1.8,5.0684335,8.7556354,-0.2235638,3.7635503,4.3855478,31.3873241,60.764976,0.1262877,13.8557322,8.339818,17.704742,5.3840358,7.7924173,2.9233218,40.9737),(31835,'metatarsal.tif',228,10,173,18.1960865,5.3910452,8.7815446,1.8,5.5293868,8.7851429,-0.5316329,3.4165895,4.313935,35.2279582,72.9739635,0.7793678,16.9158701,10.3108548,25.0770041,5.7262886,9.0318123,0.285694,45.8224734),(31836,'metatarsal.tif',228,10,174,17.9016236,5.8005211,8.9989361,1.8,5.8962025,9.0434552,-0.5592435,3.2063882,4.2501478,31.9479942,75.3895463,0.8398192,17.7381,9.9638573,23.8131696,5.2508364,9.12587,0.2761473,37.4970165),(31837,'metatarsal.tif',228,10,175,18.8446237,6.5320658,9.2965431,1.8,6.5331389,9.336113,-0.4302627,2.8030555,4.948671,27.4594642,85.6810557,0.5464324,17.3139528,9.7962614,21.857948,4.8936148,8.7815622,0.2433989,41.4636118),(31838,'metatarsal.tif',228,10,176,18.0213788,7.0909617,9.6132519,1.8,6.9407274,9.6117736,-0.4017068,2.3470211,4.8981361,23.6225687,70.5242907,0.4591638,14.3981892,10.0649155,18.5405953,4.3972262,8.2071271,0.2897879,31.655527),(31839,'metatarsal.tif',228,10,177,13.7101556,7.2297125,9.8740411,1.8,7.1310892,9.859702,-0.4538159,2.1027353,4.2891721,14.1666733,46.6330679,0.4391663,10.8722771,6.7372595,13.5617617,3.8084018,7.6055937,0.3693337,21.8740093),(31840,'metatarsal.tif',228,10,178,9.9119455,7.5469195,10.1712605,1.8,7.5148362,10.1280663,-0.5209191,1.7140997,3.7775893,6.7696547,31.1064556,0.4091699,8.2344725,3.9493937,9.4038136,3.1930311,7.0592695,0.5216587,24.5001335),(31841,'metatarsal.tif',228,10,179,7.6304406,7.7647446,10.3650618,1.8,7.7477355,10.3532383,-0.5307215,1.4731038,3.5483535,3.4978656,20.1736657,0.3258117,5.6853596,2.3744868,6.3712091,2.6154265,6.6906265,0.5286898,22.1848901),(31842,'metatarsal.tif',228,10,180,4.7553755,7.9805974,10.6480943,1.8,7.9609049,10.6323077,-0.5187286,1.0876389,3.2960239,1.2996818,10.83722,0.1948073,3.2879677,1.1949571,3.5770877,1.9707044,6.1617661,0.5197218,18.0825843),(31843,'metatarsal.tif',228,10,181,2.5824054,8.1413726,10.9632731,1.8,8.1590603,10.9284891,-0.5089949,0.6746147,2.4222114,0.3003922,3.7277458,0.1022035,1.5389845,0.4452797,1.6229034,1.2999124,4.8707791,0.5293424,17.0142315),(31844,'metatarsal.tif',228,10,182,1.1124039,8.3271743,11.1700859,1.8,8.3263079,11.1704903,-0.515855,0.3378313,1.6390748,0.0232409,0.6135941,0.0451124,0.374354,0.0687943,0.3858978,0.6161224,3.2568555,0.5343955,7.4650836),(31845,'metatarsal.tif',228,10,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31846,'femur.tif',228,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31847,'femur.tif',228,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31848,'femur.tif',228,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31849,'femur.tif',228,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31850,'femur.tif',228,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31851,'femur.tif',228,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31852,'femur.tif',228,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31853,'femur.tif',228,7,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31854,'femur.tif',228,7,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31855,'femur.tif',228,7,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31856,'femur.tif',228,7,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31857,'femur.tif',228,7,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31858,'femur.tif',228,7,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31859,'femur.tif',228,7,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31860,'femur.tif',228,7,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31861,'femur.tif',228,7,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31862,'femur.tif',228,7,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31863,'femur.tif',228,7,18,2.9577054,12.7074865,16.3534453,1.8,12.7085384,16.3436421,0.5383211,0.8390572,1.2424368,0.4972443,1.0417863,0.1295753,0.8385024,0.5926227,1.2351142,1.6990302,2.4773011,2.7392716,6.8764149),(31864,'femur.tif',228,7,19,3.1549424,12.3294124,16.4056206,1.8,12.3516224,16.4108705,0.5811855,1.0794579,1.7179189,0.9809363,2.3891182,0.1584925,1.3907049,0.9087305,1.9414014,2.0228457,3.3310005,2.3046937,9.2064341),(31865,'femur.tif',228,7,20,3.5925683,11.9970871,16.2662307,1.8,12.0389018,16.2931084,0.4245197,1.2645811,2.2065216,1.9611337,4.5502784,0.1015785,2.0621953,1.5508169,2.7815657,2.5318725,4.3189517,2.5317867,16.8706171),(31866,'femur.tif',228,7,21,4.7992682,11.7725481,16.2925587,1.8,11.8078258,16.3308936,0.4542412,1.4882312,2.4343492,3.8900353,7.7202188,0.1539993,3.1713687,2.6138648,4.4905566,2.9394451,4.7619,2.5592397,19.5034043),(31867,'femur.tif',228,7,22,5.3781678,11.6101848,16.450533,1.8,11.607462,16.4585169,0.4962872,1.9286794,2.7333859,6.3139595,10.4572636,0.2032339,3.8257545,3.2737216,5.932183,3.5244287,5.3031597,2.4468544,14.6806321),(31868,'femur.tif',228,7,23,6.0897874,11.6154614,16.4705386,1.8,11.6147568,16.4839613,0.4394193,2.2849711,2.8695883,10.2119993,12.9069427,0.1836853,4.4978378,4.4692029,7.5750874,4.1655409,5.8323143,2.4681504,16.6108831),(31869,'femur.tif',228,7,24,7.311311,11.8934168,16.2323782,1.8,11.8832982,16.2638946,-0.3915335,3.2392072,2.8060002,15.8123272,18.6621495,0.1774497,6.6508012,4.8815424,10.4827004,4.8328736,6.1732329,2.4619438,19.2927618),(31870,'femur.tif',228,7,25,13.7891836,14.5092076,14.711564,1.8,14.4577979,14.7597334,-0.4915321,3.5954754,8.3831224,30.5428313,253.3393526,0.5119521,30.2201663,8.4947963,33.8470919,5.7716163,7.2790408,3.1082717,25.2109447),(31871,'femur.tif',228,7,26,22.7139199,16.5029199,13.7099867,1.8,16.5563184,13.7416753,-0.4935794,3.7276955,8.3033984,63.5410896,464.7569476,0.8497599,55.9718954,17.0456762,63.2117249,7.204242,15.6904064,0.4304648,46.8081704),(31872,'femur.tif',228,7,27,24.5518453,17.1568364,13.4398606,1.8,17.2203491,13.4316883,-0.5145455,3.9149513,9.0809983,93.9147087,532.0774609,0.9910804,58.5923972,23.98873,68.5019335,7.6325751,16.3125197,0.449021,47.5342427),(31873,'femur.tif',228,7,28,25.9266144,17.6192149,13.2931354,1.8,17.6268827,13.2903116,-0.5523945,4.2039056,9.4708125,119.7112461,596.7145043,1.1897658,63.0056298,28.4761972,74.5912615,8.1248664,16.6154097,0.5158876,49.7976916),(31874,'femur.tif',228,7,29,25.7773031,17.8269453,13.1761269,1.8,17.8411274,13.1784187,-0.5829891,4.4492818,9.7373288,132.8802371,636.4359552,1.3020726,65.3604256,29.8655478,78.0375018,8.5099757,17.0116132,0.5555773,53.4122469),(31875,'femur.tif',228,7,30,26.9233161,17.8102139,13.2761672,1.8,17.9031959,13.2571461,-0.5927862,4.634749,9.8010921,140.0436416,706.7177221,1.4005359,72.1060178,30.2160142,85.1597177,8.8331925,17.4090687,0.5447195,54.7771406),(31876,'femur.tif',228,7,31,26.9113839,17.7539016,13.3278722,1.8,17.8490746,13.3188009,-0.6054048,4.8561118,9.8391543,145.4954657,723.2771705,1.4526278,73.5100954,29.9613087,86.8898085,9.1083578,17.8018792,0.5063046,56.2820683),(31877,'femur.tif',228,7,32,26.265826,17.7632173,13.2651457,1.8,17.8945302,13.2420836,-0.6127289,5.1108058,9.9418412,144.1632298,722.2775065,1.4478701,72.6502756,28.2075343,85.8182077,9.3327768,17.9628843,0.5168018,58.3308365),(31878,'femur.tif',228,7,33,25.5499543,17.7337594,13.3181352,1.8,17.8505402,13.2908364,-0.6164694,5.2579429,9.9603912,144.285395,719.8469781,1.4234166,72.2709546,27.4414156,85.4956899,9.4803911,18.0595277,0.5261413,60.457943),(31879,'femur.tif',228,7,34,24.2925244,17.7402025,13.3723001,1.8,17.8706991,13.335218,-0.6198778,5.3740036,10.0128964,135.7001617,693.0298332,1.366399,69.2137225,25.2512228,81.4469342,9.5885449,18.1034986,0.5031953,77.1865068),(31880,'femur.tif',228,7,35,24.1977294,17.5433845,13.4984109,1.8,17.6905445,13.4745922,-0.6255412,5.4977429,9.8486448,132.5310315,675.4322602,1.3827087,68.5812388,24.1064442,80.7322785,9.5604582,18.1014845,0.5247958,62.8350344),(31881,'femur.tif',228,7,36,23.1276831,17.2004185,13.7836467,1.8,17.3492831,13.7744618,-0.6113863,5.615854,9.4953911,122.1920347,627.9972206,1.2700167,66.1370571,21.7584066,77.8026842,9.537436,18.0530792,0.5201458,63.4121599),(31882,'femur.tif',228,7,37,23.2603703,17.4161556,13.9606641,1.8,17.6730154,13.8692242,-0.5543495,5.5001988,9.7614937,111.038855,648.5691529,1.0741902,66.4415892,20.1881532,76.8297324,8.9922429,17.929264,0.5023692,69.6968258),(31883,'femur.tif',228,7,38,19.9608177,16.3803145,14.8076595,1.8,16.3287173,14.9696924,-0.4738608,5.3027362,8.6484251,100.7133312,416.4879241,0.6927487,48.1576608,18.9927102,59.2681638,8.2033969,15.2778085,0.4963064,57.4704408),(31884,'femur.tif',228,7,39,19.4591379,16.0508304,15.1602943,1.8,15.9680412,15.3264135,-0.4166888,5.0877593,8.3689573,106.4778376,370.4470683,0.5312679,44.2644233,20.928238,56.6028892,8.1245859,14.7734858,0.4445604,60.18846),(31885,'femur.tif',228,7,40,19.949128,15.7200804,15.4151659,1.8,15.6213419,15.5710168,-0.3410184,4.8166047,8.1133456,114.4040789,367.467809,0.3719009,45.291773,23.7520174,59.2201546,8.0631761,14.399274,0.4124104,61.5553727),(31886,'femur.tif',228,7,41,20.1167738,15.4998264,15.5041423,1.8,15.4587295,15.6574858,-0.2799334,5.381138,7.9923319,112.7888197,369.5174972,0.2559425,46.2340033,20.9600309,60.3248914,7.9178134,14.428078,3.084416,65.6520727),(31887,'femur.tif',228,7,42,20.273214,15.274442,15.4572887,1.8,15.2553975,15.5738736,-0.2466319,4.5744179,7.8700615,109.6551986,379.1400542,0.2013938,48.17498,23.9713995,62.1046618,7.7984586,14.5249205,3.0847976,76.5955942),(31888,'femur.tif',228,7,43,20.4905111,15.1441588,15.4471214,1.8,15.1230692,15.5314617,-0.2406586,4.5299697,7.827096,107.4321418,382.2195947,0.194001,48.8328745,23.7158634,62.5121722,7.6356588,14.5562233,3.0548543,81.2057048),(31889,'femur.tif',228,7,44,21.4973665,14.9402074,15.5843702,1.8,14.9024562,15.6865138,-0.248203,4.363781,7.6566583,109.4566822,400.9367861,0.2162278,52.3644613,25.0829917,66.6385532,7.4655793,14.5122022,3.0512353,59.1969429),(31890,'femur.tif',228,7,45,22.4051382,14.8362953,15.5915223,1.8,14.7972548,15.679283,-0.2218791,4.1285923,7.5872006,110.5287608,413.4894873,0.1808384,54.498294,26.771537,69.0329619,7.299774,14.4855143,3.0745791,78.8659366),(31891,'femur.tif',228,7,46,23.1391559,14.7792115,15.5984995,1.8,14.755837,15.6582428,-0.2205753,3.9861132,7.5191545,111.8118536,409.1906133,0.18461,54.4197637,28.0503458,69.2808632,7.1528198,14.3769582,3.0875912,52.4763684),(31892,'femur.tif',228,7,47,23.0578589,14.7899075,15.5941567,1.8,14.7192103,15.6554894,-0.2224772,3.8276603,7.4834595,110.6298192,384.4195413,0.1870947,51.3692282,28.9027267,66.1438825,7.2021044,14.2058649,0.0786048,51.1260982),(31893,'femur.tif',228,7,48,23.1533705,14.7845049,15.6053879,1.8,14.7159328,15.6589224,-0.2213802,3.6931126,7.4649364,111.9632151,362.4191779,0.1860519,48.5495333,30.3167617,63.5451481,7.2631653,14.130407,0.0962534,50.4588663),(31894,'femur.tif',228,7,49,23.0929149,14.7381798,15.6721585,1.8,14.6612709,15.7162093,-0.2396136,3.6494745,7.3455308,115.7273001,336.2550393,0.2167818,45.7768198,31.7106748,61.5181189,7.3384665,14.0338591,0.0969176,49.7445621),(31895,'femur.tif',228,7,50,24.7073726,14.6920563,15.7951179,1.8,14.6240101,15.8386376,-0.2459163,3.8308004,7.2815526,122.6343819,329.4755289,0.2440494,45.2479775,32.0127308,62.0498795,7.3922507,13.9323378,0.1256503,49.8013833),(31896,'femur.tif',228,7,51,27.2143457,14.4602689,15.8855091,1.8,14.3880045,15.928139,-0.2647628,3.9359702,7.0747841,128.3781459,329.4177295,0.3105909,46.5622309,32.6166459,64.5846845,7.4253545,13.9458379,0.1571443,36.4336981),(31897,'femur.tif',228,7,52,23.753952,14.4231444,15.6211984,1.8,14.3592762,15.6666819,-0.2620237,3.7397531,7.0023123,114.8072157,314.3267328,0.2656463,44.8889909,30.6991433,61.2654715,7.4165956,13.5550347,0.15809,35.4186449),(31898,'femur.tif',228,7,53,22.4847693,14.3935069,15.5364944,1.8,14.3424794,15.5779266,-0.2708947,3.7800337,6.8959493,111.4671136,294.3641126,0.268342,42.6865251,29.4883915,58.7868021,7.4205003,13.2240571,0.1398224,34.5574129),(31899,'femur.tif',228,7,54,21.6828679,14.4877725,15.438199,1.8,14.453894,15.4595977,-0.269414,3.7904488,6.6394423,108.4883755,252.8158295,0.2560193,38.0778716,28.6215122,54.4060379,7.4205003,12.3460848,0.1418971,32.7761086),(31900,'femur.tif',228,7,55,20.5448398,14.5614267,15.2886992,1.8,14.5434763,15.3061468,-0.2674185,3.8436123,5.6487631,104.9839957,206.4864927,0.2390878,36.5542844,27.3138877,55.1047881,7.4205003,10.7966712,0.1533324,29.6749639),(31901,'femur.tif',228,7,56,19.9851507,14.5723389,15.2799358,1.8,14.5589305,15.3031859,-0.2817352,3.7736286,5.3709659,104.2813953,183.8193707,0.2574643,34.2246392,27.6342495,53.6167327,7.3720003,10.1923881,0.1432429,28.6696597),(31902,'femur.tif',228,7,57,20.0531792,14.5558241,15.2813848,1.8,14.5520606,15.2952189,-0.3046637,3.7268318,5.1454818,104.5921249,168.4402925,0.3007422,32.7355727,28.0646218,53.0407128,7.3483769,9.8735331,0.1877619,27.9504809),(31903,'femur.tif',228,7,58,19.8496834,14.5219553,15.2459918,1.8,14.5137996,15.2536199,-0.2975415,3.7304917,4.9710731,101.4536879,157.3218691,0.2843433,31.6474662,27.1957954,52.0509701,7.2930685,9.5524075,0.1734957,27.4135341),(31904,'femur.tif',228,7,59,19.9776336,14.4799158,15.1945636,1.8,14.4690876,15.1996789,-0.2951134,3.7108902,4.8208628,99.9340158,148.0297878,0.2816605,30.7060776,26.9299305,51.4263553,7.2522934,9.2044008,0.3834418,26.807998),(31905,'femur.tif',228,7,60,20.7455045,14.322504,15.1628718,1.8,14.3002881,15.1779764,-0.2547909,3.6715886,4.5608693,98.9445148,141.0628817,0.2196454,30.9289466,26.9486931,52.6006746,7.2132678,8.9432215,0.3835275,26.2710512),(31906,'femur.tif',228,7,61,19.784325,14.2281237,15.0525058,1.8,14.219152,15.0542822,-0.2421742,3.6031808,4.4000557,95.2746451,131.0473562,0.1896351,29.7831129,26.4418164,51.2862113,7.1531617,8.7452107,0.3866855,25.7507469),(31907,'femur.tif',228,7,62,19.3119882,14.1956842,14.9906968,1.8,14.1955893,14.9907759,-0.2642957,3.5813659,4.2933658,93.7812652,121.0139091,0.2196444,28.1862563,26.1858935,49.9641474,7.1361318,8.5399951,0.4026547,25.3392108),(31908,'femur.tif',228,7,63,19.478786,14.1392227,14.9606799,1.8,14.1380885,14.9625995,-0.2598806,3.5837077,4.1645731,93.5042637,116.3356159,0.2143675,27.934584,26.0914873,50.277882,7.1146143,8.3577761,0.3805064,25.0364427),(31909,'femur.tif',228,7,64,19.7000175,14.1042017,14.9241919,1.8,14.1058939,14.920428,-0.2451538,3.5721175,4.0643705,92.8912023,112.7579642,0.193408,27.7430327,26.0045204,50.4632558,7.0958885,8.1867371,0.376106,24.705264),(31910,'femur.tif',228,7,65,19.752819,14.0685695,14.8828336,1.8,14.0695613,14.8813574,-0.2523402,3.5618982,3.9710418,91.2209713,108.7370605,0.2052168,27.382502,25.6102129,50.1421832,7.0581427,8.0177706,0.4040975,24.4426746),(31911,'femur.tif',228,7,66,19.7342668,14.0272803,14.8209899,1.8,14.0279292,14.8183555,-0.2992574,3.5427314,3.9028817,89.1547655,104.1642234,0.2858619,26.6890546,25.1655445,49.1709005,7.0099141,7.8719552,0.3919475,24.1399065),(31912,'femur.tif',228,7,67,19.7545262,14.006927,14.7612071,1.8,14.0022322,14.7558816,-0.3187114,3.5251816,3.8349583,87.0325236,100.7090932,0.3232629,26.2608051,24.6888054,48.8499594,6.9355002,7.7372325,0.3653737,23.8087278),(31913,'femur.tif',228,7,68,19.6799176,13.9660336,14.6917154,1.8,13.9639529,14.6912719,-0.3564569,3.5086017,3.8092701,85.1575597,97.0871015,0.399405,25.4870614,24.2710818,47.8322867,6.8870002,7.6293139,0.363979,23.5343703),(31914,'femur.tif',228,7,69,19.5292837,13.8974194,14.6080578,1.8,13.8935266,14.6076668,-0.4246485,3.4631215,3.7654075,82.9472828,94.0533298,0.552498,24.9782607,23.9515945,46.9397267,6.8385002,7.5112396,0.3769093,23.3001916),(31915,'femur.tif',228,7,70,19.1727691,13.8680533,14.5252822,1.8,13.8667126,14.5247517,-0.4498695,3.4303183,3.7269885,80.2036772,90.4311398,0.6042388,24.2638635,23.3808264,45.6166243,6.7900002,7.4319033,0.4023211,23.1061916),(31916,'femur.tif',228,7,71,19.2492663,13.8412629,14.487933,1.8,13.8379468,14.4900785,-0.4664509,3.424885,3.7286202,79.4625874,87.9104043,0.6488522,23.5771949,23.2015342,44.7264982,6.7415002,7.3855487,0.3695312,22.9004235),(31917,'femur.tif',228,7,72,19.6967579,13.8106388,14.4614481,1.8,13.8078264,14.4605296,-0.4372762,3.4250044,3.7528325,79.8228527,87.2094675,0.5887027,23.2383052,23.3059123,44.4130817,6.7030736,7.3496308,0.3927607,22.8436022),(31918,'femur.tif',228,7,73,19.6597532,13.8239235,14.4235126,1.8,13.8172511,14.4200337,-0.4301632,3.4385936,3.7302232,78.3010361,85.776326,0.5698214,22.9949583,22.771239,43.7863756,6.6596693,7.3228578,0.3657473,22.6780129),(31919,'femur.tif',228,7,74,19.4865278,13.8129859,14.3782052,1.8,13.8061744,14.3778149,-0.5078183,3.4633326,3.688425,76.6818371,84.5667994,0.7679657,22.9276178,22.1410548,43.2390251,6.6380287,7.288729,0.2901821,22.6094235),(31920,'femur.tif',228,7,75,19.3358359,13.7934848,14.3378573,1.8,13.7873479,14.3379033,-0.5509182,3.473785,3.6187875,75.9840213,82.7414114,0.8830698,22.864402,21.8735531,43.0356362,6.616265,7.2265002,0.3493444,22.5124235),(31921,'femur.tif',228,7,76,19.3946185,13.7783385,14.3091419,1.8,13.7724311,14.3089638,-0.5142787,3.4675902,3.5602941,75.9944437,81.3444866,0.7821608,22.8476873,21.9156357,43.4558871,6.616265,7.1494333,0.2960052,22.4673703),(31922,'femur.tif',228,7,77,19.6547544,13.7741497,14.2778564,1.8,13.7655026,14.2801596,-0.4152135,3.4339922,3.5744749,76.8507127,80.9820571,0.5330359,22.6556513,22.379408,43.6453785,6.5959788,7.1420267,0.2680388,22.3987809),(31923,'femur.tif',228,7,78,19.7256898,13.7153459,14.2695176,1.8,13.7060135,14.2690549,1.4358391,3.3969493,3.4594837,77.3741237,78.2670467,3.2280987,22.6239096,22.7775326,43.747688,6.6160187,6.9619045,1.9564773,22.2498341),(31924,'femur.tif',228,7,79,19.7193224,13.6636168,14.2594158,1.8,13.6555997,14.2577782,1.2056806,3.3476601,3.5112781,74.2831234,79.2589035,2.8675511,22.5726649,22.1895657,43.4245097,6.5728607,7.0179352,1.9756881,22.1126554),(31925,'femur.tif',228,7,80,19.7757124,13.6205299,14.2670653,1.8,13.6126152,14.2713283,1.221072,3.3003967,3.5668593,71.3938258,81.2619915,2.9090027,22.7825053,21.6318921,42.737698,6.4020002,7.1071949,1.9703118,22.0087618),(31926,'femur.tif',228,7,81,19.9646246,13.5722696,14.267816,1.8,13.5709599,14.2777703,1.2356475,3.2560921,3.631032,69.2940183,83.2080946,2.9674699,22.9158253,21.2813448,41.9726892,6.3080444,7.204985,2.0013235,22.0773512),(31927,'femur.tif',228,7,82,20.3425734,13.5372868,14.2713599,1.8,13.5368367,14.2792336,1.2166938,3.2202363,3.6703271,67.7390656,85.7425859,2.9827818,23.3610204,21.0354332,41.8151878,6.2080002,7.2601117,1.9686707,22.0538151),(31928,'femur.tif',228,7,83,21.0982588,13.5272638,14.285315,1.8,13.5276287,14.2922752,1.1980045,3.2030556,3.6511187,66.7999914,88.8187967,3.0499153,24.326461,20.8550835,42.6101518,6.1110002,7.297115,2.0849961,22.0018683),(31929,'femur.tif',228,7,84,21.8284929,13.5184943,14.2946569,1.8,13.5264719,14.3060028,1.1953533,3.1814102,3.6280765,66.4844981,91.3254482,3.1489141,25.1718636,20.8978075,43.3597992,6.0625002,7.3210909,2.0907641,22.0704576),(31930,'femur.tif',228,7,85,21.6969209,13.4508515,14.262137,1.8,13.4573495,14.2716412,1.2359078,3.1425084,3.6484166,65.7760558,91.9031465,3.2255368,25.1898717,20.9310673,42.866349,6.0625002,7.339382,2.0817459,22.0822257),(31931,'femur.tif',228,7,86,22.4156707,13.4514815,14.2412284,1.8,13.4508957,14.2438941,1.2047727,3.1356903,3.617591,66.25567,92.3839896,3.2573847,25.5374334,21.1295323,43.6895588,6.0140002,7.297115,2.0849961,21.9332789),(31932,'femur.tif',228,7,87,21.9631301,13.3891751,14.1659022,1.8,13.3860154,14.1636201,1.2169223,3.1441774,3.6217824,65.2911997,88.6964407,3.2209441,24.4897212,20.765749,42.4766643,5.9655002,7.2154246,1.9712751,21.7275108),(31933,'femur.tif',228,7,88,21.208189,13.3163636,14.064153,1.8,13.3148111,14.0639703,1.2556518,3.1272083,3.5327748,64.7338804,83.199893,3.1951147,23.5508626,20.7002141,41.6708132,6.0140002,7.0371814,1.9820229,21.4649215),(31934,'femur.tif',228,7,89,20.6880186,13.2657311,13.9823497,1.8,13.263601,13.9819686,1.2979828,3.086138,3.4017659,64.3897571,78.7952183,3.1976817,23.1630334,20.8641856,41.4776226,6.0001809,6.8639069,2.0881896,21.3395108),(31935,'femur.tif',228,7,90,20.3481671,13.2269698,13.9174348,1.8,13.2278,13.9205307,1.3566101,3.0533644,3.3121523,63.9983051,75.6568914,3.2381447,22.8422143,20.95993,41.0465281,5.9655002,6.7402789,2.1408368,21.1219747),(31936,'femur.tif',228,7,91,20.1673803,13.2021618,13.8781952,1.8,13.2025439,13.8804435,1.4312486,3.0130096,3.2391365,63.5972963,73.4284756,3.2961987,22.6691517,21.1075648,40.9711768,5.9655002,6.6359984,2.1952939,20.996564),(31937,'femur.tif',228,7,92,20.1032202,13.1873778,13.8480512,1.8,13.1904643,13.8516385,1.5101693,3.004129,3.2291586,63.1958619,72.3576532,3.3382364,22.4075871,21.0363344,40.6026264,5.9601009,6.6296149,1.1726287,20.9681534),(31938,'femur.tif',228,7,93,19.9796045,13.1730071,13.8253076,1.8,13.177763,13.8286973,-1.5595143,2.9976973,3.2092893,62.8347115,71.2706062,3.3295102,22.207598,20.960993,39.9929527,5.9562983,6.6558191,1.182171,20.9279747),(31939,'femur.tif',228,7,94,19.8691453,13.1559869,13.8113376,1.8,13.1587691,13.8161225,-1.4797124,3.0370621,3.2399138,62.3630971,70.6868009,3.2841267,21.8174945,20.5340213,39.3703828,5.9492447,6.6931759,1.168759,20.899564),(31940,'femur.tif',228,7,95,19.787619,13.147564,13.8039611,1.8,13.1509985,13.8069642,-1.4293841,3.0535863,3.2696699,62.2441208,70.3725358,3.2324247,21.5228257,20.3839403,38.9792419,5.9514125,6.7273541,1.1393956,21.0083321),(31941,'femur.tif',228,7,96,19.6970706,13.1386176,13.803161,1.8,13.1430848,13.8055709,-1.3761308,3.0793494,3.3073285,62.1304497,70.1770485,3.1600061,21.2186506,20.1764857,38.8960577,5.9497098,6.7378356,1.1715756,20.996564),(31942,'femur.tif',228,7,97,19.4992937,13.1302688,13.806591,1.8,13.1369488,13.8082065,-1.3254565,3.1341308,3.3531088,61.7135966,70.0892323,3.0581599,20.9027613,19.690817,38.5594945,5.9533375,6.7714409,1.1423905,21.0249747),(31943,'femur.tif',228,7,98,19.4008227,13.1325094,13.817674,1.8,13.1388822,13.8224611,-1.2658367,3.1782715,3.3843906,61.664163,69.8822882,2.9419637,20.6484112,19.4017924,38.3083534,5.9645013,6.7977904,1.056075,20.9847959),(31944,'femur.tif',228,7,99,19.1832565,13.1349668,13.822977,1.8,13.13994,13.8270717,-1.2224544,3.2023019,3.4149402,61.1606307,69.711328,2.8246933,20.4136305,19.0989586,37.9509769,5.972389,6.8217972,1.0498865,21.0533853),(31945,'femur.tif',228,7,100,18.9576122,13.1398149,13.830579,1.8,13.1426388,13.832714,-1.1709517,3.2521596,3.4475256,60.8677737,69.2104238,2.6808109,20.0753905,18.7161089,37.5047533,5.9839819,6.8460634,1.0437418,21.0249747),(31946,'femur.tif',228,7,101,18.9578187,13.1469755,13.8493423,1.8,13.1493047,13.8521991,-1.1019755,3.3056324,3.4709917,61.4301375,69.7316432,2.5145821,20.0898329,18.5834752,37.6844766,6.0281496,6.8705863,1.0376406,21.1503853),(31947,'femur.tif',228,7,102,18.6205475,13.1564852,13.8662343,1.8,13.157828,13.8700605,-1.0480848,3.3421868,3.4941434,61.033991,69.2095677,2.3299518,19.8073062,18.2616933,37.2495208,6.0449295,6.8743513,0.9964915,21.1102066),(31948,'femur.tif',228,7,103,18.2253968,13.1647977,13.8792162,1.8,13.1638753,13.8829689,-0.9655191,3.3550236,3.5022248,60.5469227,68.7325492,2.054155,19.6253962,18.0466458,36.8770928,6.0810748,6.8789691,1.0219127,21.2189747),(31949,'femur.tif',228,7,104,17.9945434,13.1671331,13.8992229,1.8,13.1678591,13.901936,-0.903822,3.3442426,3.5170362,60.05664,68.9915939,1.8513977,19.6164013,17.9582184,36.5847695,6.122356,6.9016712,0.9652517,21.2591534),(31950,'femur.tif',228,7,105,17.6648805,13.1650666,13.9107638,1.8,13.1657764,13.9159884,-0.8519433,3.3429515,3.5247627,59.2721483,68.9277945,1.6674141,19.5553009,17.7304839,36.0416103,6.1206446,6.9461756,0.9440534,21.2473853),(31951,'femur.tif',228,7,106,17.391404,13.1681073,13.9309947,1.8,13.1715578,13.9342384,-0.7962022,3.3078035,3.5142592,58.580569,69.068441,1.4805973,19.6537698,17.7098091,35.76649,6.1202963,6.9573417,0.9537883,21.3561534),(31952,'femur.tif',228,7,107,17.1699451,13.1676122,13.9557769,1.8,13.1726155,13.9591823,-0.7521345,3.3046505,3.4843832,58.1803098,69.0588639,1.3357095,19.8195375,17.6055865,35.7281861,6.1197739,6.964607,0.928688,21.3561534),(31953,'femur.tif',228,7,108,16.9329681,13.1755422,13.981283,1.8,13.1769494,13.9854549,-0.7124228,3.2742313,3.4893107,57.9274357,69.138876,1.2058627,19.8144796,17.6919195,35.6951689,6.1292797,6.9762494,0.9036557,21.3963321),(31954,'femur.tif',228,7,109,16.728908,13.1907108,14.0126266,1.8,13.1938235,14.0198888,-0.6791485,3.2716427,3.4884036,57.7956821,69.1800398,1.1000599,19.8314324,17.6656463,35.5480196,6.1353373,6.998972,0.8884798,21.4933321),(31955,'femur.tif',228,7,110,16.5164138,13.2059131,14.0506651,1.8,13.2097825,14.0577574,-0.6623278,3.2662816,3.491386,57.7357879,69.0004917,1.0409981,19.7630658,17.6763043,35.3989105,6.1507266,7.0232959,0.8734055,21.5619215),(31956,'femur.tif',228,7,111,16.4372128,13.2333198,14.112396,1.8,13.2370619,14.1190677,-0.6496067,3.2393493,3.4994276,58.2218429,69.0887735,1.0023183,19.7428786,17.9733144,35.5677245,6.1661159,7.0492045,0.8584387,21.5903321),(31957,'femur.tif',228,7,112,16.2910133,13.2554144,14.158285,1.8,13.2564315,14.166155,-0.6346413,3.2284944,3.5013492,58.2652486,69.188439,0.9544279,19.760508,18.047189,35.5864711,6.1967203,7.0545416,0.8681357,21.5903321),(31958,'femur.tif',228,7,113,16.2868544,13.284244,14.2023213,1.8,13.2869348,14.2099065,-0.6054517,3.2209589,3.50675,58.8751085,69.7948476,0.8792538,19.9030007,18.2787516,35.8772684,6.2230607,7.0766804,0.8435848,21.6991002),(31959,'femur.tif',228,7,114,16.4435178,13.3163237,14.2644477,1.8,13.3193293,14.2709163,-0.5696432,3.1998447,3.4957617,60.0318701,70.9362727,0.7971778,20.2920788,18.76087,36.416859,6.2539802,7.0859814,0.8629124,21.7676895),(31960,'femur.tif',228,7,115,16.5739267,13.3417894,14.3283273,1.8,13.3456151,14.3331731,-0.5029404,3.1754855,3.4636021,61.1353645,72.1586026,0.6417638,20.8333985,19.2522887,37.0156565,6.2689073,7.1176128,0.8577355,21.9048683),(31961,'femur.tif',228,7,116,16.5521309,13.3657333,14.3979194,1.8,13.3679815,14.4001822,-0.4634056,3.1599497,3.433484,61.5817497,73.2199671,0.5512038,21.3252684,19.4882055,37.4833345,6.3055365,7.1362606,0.8142363,22.0018683),(31962,'femur.tif',228,7,117,16.4713748,13.3910056,14.448752,1.8,13.3945811,14.4478469,-0.4533292,3.1889718,3.451955,61.7948344,74.1548275,0.5265616,21.4819795,19.3776672,37.6432074,6.3345272,7.1494333,0.8526045,22.0704576),(31963,'femur.tif',228,7,118,16.5975723,13.4295863,14.5186606,1.8,13.4304426,14.5222881,-0.4287259,3.1812315,3.4490858,63.0257711,75.1210023,0.4780565,21.7799752,19.8117524,38.3969155,6.3557159,7.1494333,0.8526045,22.1508151),(31964,'femur.tif',228,7,119,16.7031968,13.4602143,14.5757971,1.8,13.4652103,14.5765024,-0.4211051,3.1920437,3.461711,63.8331791,76.0148003,0.4651626,21.9587367,19.9975897,38.6643382,6.3772334,7.1775087,0.8379812,22.2076363),(31965,'femur.tif',228,7,120,16.7319638,13.4812641,14.631698,1.8,13.4879248,14.6341574,-0.46922,3.2056945,3.4811336,64.1489349,76.9480887,0.5702155,22.1043195,20.0109321,38.9260123,6.3759719,7.1860245,0.8570456,22.2879938),(31966,'femur.tif',228,7,121,16.7698813,13.5144891,14.6697409,1.8,13.5239834,14.6669076,-0.4861998,3.2300607,3.5289358,64.3412654,77.9473576,0.610258,22.0880633,19.9195221,38.9932018,6.3806951,7.2100436,0.8329813,22.3849938),(31967,'femur.tif',228,7,122,16.7971029,13.5579252,14.7272387,1.8,13.5629249,14.730865,-0.4710427,3.2179282,3.5298624,65.0361324,78.3800929,0.5765568,22.2048578,20.2105605,39.0983361,6.3959102,7.2100436,0.7378151,22.4251725),(31968,'femur.tif',228,7,123,16.8504354,13.5929179,14.7890577,1.8,13.5938685,14.7923602,-0.4597946,3.2288674,3.5256649,65.8165047,78.8396697,0.5530497,22.3616455,20.3837741,39.5601462,6.3959102,7.2100436,0.8329813,22.4653512),(31969,'femur.tif',228,7,124,16.8861253,13.6205121,14.8637926,1.8,13.6203429,14.8663641,-0.4486152,3.2344091,3.5321531,66.4319331,79.2554065,0.5294123,22.4382707,20.5391248,39.8599107,6.3959102,7.2178693,0.8519663,22.4937619),(31970,'femur.tif',228,7,125,16.9334473,13.6461723,14.9277772,1.8,13.6512004,14.9259166,-0.4536579,3.2536778,3.5309134,66.9559393,79.951443,0.5420641,22.643275,20.5785404,40.1634768,6.4112995,7.2401585,0.752235,22.5623512),(31971,'femur.tif',228,7,126,17.0492654,13.6825112,14.9848133,1.8,13.6864869,14.9843708,-0.472923,3.2573605,3.5492179,68.0470333,80.304205,0.5895396,22.6258875,20.8902374,40.3551966,6.4112995,7.2460041,0.7333126,22.6025299),(31972,'femur.tif',228,7,127,17.0979902,13.7189847,15.0556044,1.8,13.722081,15.058096,-0.4858388,3.2697735,3.5770015,68.6691196,80.7728461,0.6213482,22.5811607,21.0011852,40.843338,6.4205146,7.2498986,0.7238646,22.6427087),(31973,'femur.tif',228,7,128,17.0790888,13.740393,15.1489894,1.8,13.741797,15.1525707,-0.4865271,3.2632476,3.5551255,69.0328863,81.192432,0.6222801,22.8381337,21.154658,41.3017549,6.4114736,7.2498986,0.7238646,22.7397087),(31974,'femur.tif',228,7,129,17.1612663,13.7610115,15.2390074,1.8,13.7639753,15.2362677,-0.4655225,3.2509719,3.5203995,69.3994784,82.0645229,0.5763384,23.3111392,21.3473017,41.8447448,6.4266888,7.2756469,0.7476802,22.808298),(31975,'femur.tif',228,7,130,17.3623404,13.7885781,15.3321412,1.8,13.7968986,15.3302386,-0.4471111,3.2429876,3.5187357,70.0968843,83.3921713,0.5409449,23.6994701,21.6149096,42.5238234,6.4266888,7.2596257,0.8657932,22.7798874),(31976,'femur.tif',228,7,131,17.4622641,13.81938,15.436981,1.8,13.825225,15.4342245,-0.4107538,3.2237249,3.5205984,70.8771413,83.9233182,0.4640332,23.8377994,21.9861013,42.3158277,6.4419039,7.2863081,0.8513402,22.8768874),(31977,'femur.tif',228,7,132,17.5505671,13.8546616,15.5120742,1.8,13.8652996,15.5041614,-0.4128009,3.2351992,3.5250264,71.1845797,84.9774799,0.4707723,24.106906,22.0031523,42.717062,6.4422522,7.2863081,0.8513402,22.8768874),(31978,'femur.tif',228,7,133,17.6266773,13.901925,15.5936227,1.8,13.9122935,15.5856953,-0.4071608,3.2444268,3.5301801,71.7283826,85.84002,0.4606998,24.3160452,22.1081834,42.955268,6.4424263,7.3087105,0.7525461,22.9738874),(31979,'femur.tif',228,7,134,17.6114619,13.9356558,15.68216,1.8,13.9478783,15.6763094,-0.397587,3.2507052,3.541099,72.2844687,85.9347982,0.440051,24.267833,22.2365503,42.9376485,6.4574673,7.291149,0.7100693,23.0140661),(31980,'femur.tif',228,7,135,17.6811124,13.9775048,15.7730802,1.8,13.9864006,15.7637232,-0.3896377,3.2656366,3.5690264,72.8865139,86.6887646,0.4251969,24.289191,22.3192362,42.9993312,6.4726825,7.3145013,0.7338008,23.0826555),(31981,'femur.tif',228,7,136,17.7964147,14.0372514,15.8708486,1.8,14.0480999,15.8590026,-0.3859862,3.2604339,3.5742092,73.3963842,87.8875739,0.4203866,24.5893758,22.5112319,43.3257418,6.4728566,7.3228578,0.8557046,23.0826555),(31982,'femur.tif',228,7,137,17.9208143,14.0750947,15.9519619,1.8,14.0810175,15.9436498,-0.3859539,3.2791615,3.6047486,74.2077072,89.1859262,0.4232579,24.7412333,22.6300862,43.6781467,6.4880718,7.3505909,0.8414143,23.1914235),(31983,'femur.tif',228,7,138,17.9531187,14.123109,16.0366734,1.8,14.1320223,16.0265905,-0.3885992,3.2725156,3.6025966,74.5022551,90.3932938,0.4295567,25.0911504,22.7660503,44.1133379,6.4726825,7.3401832,0.8836721,23.2316023),(31984,'femur.tif',228,7,139,18.0105255,14.1756457,16.1278093,1.8,14.179812,16.1199369,-0.3907755,3.2685233,3.6246467,74.8181104,92.4331177,0.4355217,25.5012768,22.8904929,44.5256323,6.4713465,7.4008206,2.9969153,23.4373703),(31985,'femur.tif',228,7,140,18.1680724,14.2276042,16.2248773,1.8,14.2316832,16.2158914,-0.3844252,3.2749976,3.6534186,75.7942199,94.9109679,0.425874,25.9786735,23.1432899,45.1751553,6.4680397,7.4609651,3.0373962,23.5745491),(31986,'femur.tif',228,7,141,18.2789914,14.2813134,16.3224566,1.8,14.2922543,16.3098719,-0.3705007,3.2921926,3.6750199,76.971334,97.3037261,0.3994067,26.4770611,23.3799611,45.9326542,6.4813786,7.5317239,3.0124454,23.6950852),(31987,'femur.tif',228,7,142,18.2946276,14.3148904,16.4289348,1.8,14.3211086,16.4168469,-0.3673346,3.3135966,3.7354377,78.3921628,99.2314948,0.3932544,26.5648906,23.6577268,46.2253722,6.510907,7.5998125,2.9942805,23.8204959),(31988,'femur.tif',228,7,143,18.4015776,14.3551221,16.5394196,1.8,14.364917,16.5248469,-0.3642031,3.3425216,3.7911388,80.5580784,101.482467,0.3891378,26.768333,24.1009895,46.8110675,6.5442144,7.6760351,3.0148866,23.9978533),(31989,'femur.tif',228,7,144,18.5506825,14.3950777,16.6412976,1.8,14.4032272,16.6267086,-0.337944,3.3899265,3.8273116,82.7553093,104.8782467,0.3398613,27.4025887,24.4121248,47.6765605,6.5924322,7.7663633,3.0226598,24.2604427),(31990,'femur.tif',228,7,145,18.6509773,14.4374155,16.7524379,1.8,14.4456819,16.7404214,-0.3230415,3.4371712,3.8869514,85.5263584,108.51486,0.3132615,27.9177301,24.8827755,48.6733149,6.6683574,7.8626865,3.0241235,24.5348001),(31991,'femur.tif',228,7,146,18.7373402,14.5106685,16.8558428,1.8,14.519156,16.8469681,-0.2786756,3.4896637,3.9422081,88.8284982,112.0646248,0.2363104,28.4268669,25.4547445,49.9622126,6.7323847,7.9647872,3.0195035,24.8375682),(31992,'femur.tif',228,7,147,18.8730043,14.5815,16.957264,1.8,14.5911956,16.9470051,-0.2426816,3.5396393,4.0004466,91.8598811,117.2272404,0.181644,29.303538,25.9517635,50.9430449,6.809157,8.0938351,2.9912212,25.2089256),(31993,'femur.tif',228,7,148,19.192845,14.6819669,17.0774215,1.8,14.6844672,17.065057,-0.1832401,3.5914137,4.1045513,95.0834579,125.0692622,0.1062094,30.4708729,26.4752175,52.1008653,6.9011444,8.2428603,3.0354838,25.5969256),(31994,'femur.tif',228,7,149,19.340089,14.7610834,17.1771604,1.8,14.7708763,17.1639894,-0.179089,3.6636995,4.219208,98.4398393,131.8652039,0.1022815,31.2535444,26.8689717,53.0976785,6.9780908,8.4045059,0.0577392,26.0368724),(31995,'femur.tif',228,7,150,18.689262,14.7678956,17.2706429,1.8,14.7847511,17.2473108,-0.1749068,3.7474328,4.2593641,99.8736908,132.9289109,0.0943237,31.2086279,26.6512292,53.142663,7.0659511,8.5909371,0.113151,26.5454086),(31996,'femur.tif',228,7,151,18.4660572,14.828569,17.3804422,1.8,14.8262696,17.3613505,-0.160406,3.8395968,4.3754486,102.898516,137.7269469,0.078512,31.4772177,26.7993023,53.588505,7.132984,8.8085937,0.082684,27.0421767),(31997,'femur.tif',228,7,152,18.8743069,14.9186395,17.5326086,1.8,14.8941177,17.5236375,-0.1632842,4.7281784,4.4995396,109.7404613,145.8805797,0.0831275,32.4212236,23.2098816,47.7401357,7.2526599,9.0543151,0.0858103,27.6477129),(31998,'femur.tif',228,7,153,19.1495092,14.9366585,17.7611912,1.8,14.8907924,17.8242536,-0.2320215,4.4676677,4.6720928,115.6918756,159.4552071,0.1687546,34.1292894,25.8953627,54.3734447,7.3765498,9.4007467,2.8753406,29.5329107),(31999,'femur.tif',228,7,154,19.2734486,14.9802074,17.9771659,1.8,14.8854204,18.0540648,-0.2387983,3.8632003,6.2106641,118.4404138,173.8516611,0.1797212,27.9924433,30.658626,47.009164,7.5394701,9.759232,2.9364,30.5617511),(32000,'femur.tif',228,7,155,19.5481596,15.2180836,18.1426331,1.8,15.1883333,18.1958634,-0.1848854,4.0929281,4.8663948,124.845155,179.9636112,0.1101047,36.9808903,30.5026508,58.4594923,7.7071106,10.2163616,2.9311625,30.1571085),(32001,'femur.tif',228,7,156,20.1604117,15.4247695,18.2993112,1.8,15.4089156,18.3265798,-0.1432714,4.2723931,5.1557979,129.6555973,194.5716726,0.0685005,37.7384213,30.3473004,58.9299043,7.9175838,10.4770107,2.9741609,31.0771809),(32002,'femur.tif',228,7,157,20.5420498,15.5318226,18.3927285,1.8,15.4886439,18.4180803,-0.1653253,4.2944536,5.2799995,133.9684119,209.4123157,0.092728,39.6614272,31.1956829,60.7685916,8.1256695,10.8243051,2.947712,37.4803638),(32003,'femur.tif',228,7,158,20.8924807,15.7040245,18.5419411,1.8,15.716675,18.569615,-0.1933361,4.402939,5.6399827,144.5030031,223.9013329,0.1285426,39.6989397,32.8196694,59.5578466,8.4167084,11.0836034,2.965653,36.8748277),(32004,'femur.tif',228,7,159,22.3661604,15.7602618,18.6927182,1.8,15.8173526,18.7298424,-0.1580241,4.6304731,5.6102404,159.8276242,258.9086984,0.0923142,46.1493055,34.516478,66.9305586,8.725719,11.5478901,2.9557287,38.1475958),(32005,'femur.tif',228,7,160,23.4001392,16.0132402,18.9492711,1.8,16.0519635,18.9549672,-0.1928305,4.7499801,5.8905924,171.5556847,300.0638928,0.1432283,50.9395107,36.1171373,72.0388696,9.0910677,12.1277161,3.0132694,41.8425086),(32006,'femur.tif',228,7,161,26.173773,16.264481,19.2721028,1.8,16.2091844,19.2355548,-0.2443291,4.9744313,6.0457535,200.9966583,360.5798892,0.2552736,59.6418439,40.4059571,85.6677418,9.4910215,12.31222,2.9913392,43.5483299),(32007,'femur.tif',228,7,162,28.8313613,16.4891613,19.8087022,1.8,16.4539797,19.7695999,-0.2967675,5.3854379,6.41992,239.7111857,436.4516891,0.4109218,67.9839768,44.5109923,95.0903842,10.0055611,13.1008371,2.966706,43.1984895),(32008,'femur.tif',228,7,163,41.0713832,17.6814419,21.3714659,1.8,17.7308102,21.4430082,0.1892482,7.0461986,8.2707153,480.6180629,764.4126998,0.2422483,92.4240133,68.209554,143.8184636,12.4306135,16.2087267,2.7060501,58.3024258),(32009,'femur.tif',228,7,164,43.4844203,17.3978679,22.1007684,1.8,17.3927333,22.0817044,0.1038244,7.8361386,8.2439478,640.5330647,849.8910946,0.0778432,103.0927316,81.7409057,169.9755216,13.0937685,16.9421273,2.6945888,57.17373),(32010,'femur.tif',228,7,165,46.7504794,17.1982264,22.6388145,1.8,17.2312098,22.5534016,-0.1417352,8.2724526,8.3858729,750.8600498,978.7517654,0.1554819,116.7143569,90.7663159,195.3705222,14.2185887,17.2519626,2.7093812,59.4919811),(32011,'femur.tif',228,7,166,47.9554915,17.2790994,22.8574663,1.8,17.2423765,22.8089361,-0.0429695,8.4540595,8.7964864,763.248138,1059.3923745,0.0147483,120.4335834,90.2818503,202.2467564,14.4578171,17.4524545,2.717725,60.1827492),(32012,'femur.tif',228,7,167,48.2673968,17.2960859,23.012987,1.8,17.2316838,22.9602194,0.1019874,8.572828,9.1047023,795.4220303,1022.1222746,0.0833852,112.2631187,92.784088,199.1156048,14.482576,17.5096425,2.7039615,61.3370002),(32013,'femur.tif',228,7,168,49.3718434,17.4518076,23.0573898,1.8,17.4065704,22.9391353,0.1860238,8.5089993,9.061458,792.2714557,1033.9964643,0.2814814,114.1092812,93.1098276,201.5161081,14.4262879,17.5127992,2.710152,59.8113917),(32014,'femur.tif',228,7,169,45.7869148,17.5438598,23.2085996,1.8,17.4852122,23.1035497,0.0393238,8.5802842,8.8971288,777.9996223,980.2565915,0.0117944,110.1767338,90.6729435,195.6233793,14.3160507,17.4374875,2.7264748,61.476198),(32015,'femur.tif',228,7,170,42.7472744,17.6995395,23.2009142,1.8,17.652947,23.11971,-0.0210621,8.4115936,8.7058658,700.7173668,898.1841674,0.0031599,103.1699996,83.3037594,180.3269439,14.1768197,17.2775087,2.7407554,135.6775683),(32016,'femur.tif',228,7,171,41.8984171,17.7201237,23.3001028,1.8,17.7123351,23.2560052,-0.0340245,8.3611618,8.6215996,658.8295812,856.7166291,0.0080809,99.3686407,78.796416,172.7294932,13.9041565,17.0313058,2.7531541,61.5163768),(32017,'femur.tif',228,7,172,39.7665511,17.7047357,23.2670021,1.8,17.6484392,23.2340981,-0.0012241,8.1832607,8.580996,591.500583,766.3172102,0.0000099,89.303993,72.2817715,156.2311497,13.5715322,16.7336252,2.7583952,60.4846809),(32018,'femur.tif',228,7,173,38.1343253,17.6782668,23.1788165,1.8,17.6591678,23.1498392,0.0685953,7.9442319,8.536697,527.1576383,701.7256774,0.0298587,82.2010761,66.3572821,143.3575354,13.126758,16.3313268,2.7803889,60.668932),(32019,'femur.tif',228,7,174,37.8622233,17.7679328,23.0163717,1.8,17.7588257,22.9496651,0.0719475,7.5420026,8.2610325,469.9605205,635.187608,0.0326089,76.8896154,62.3124319,133.0987437,12.6181671,15.8660993,2.7889042,59.3040383),(32020,'femur.tif',228,7,175,36.6039937,17.5828233,22.9460066,1.8,17.5338005,22.8904277,0.0178366,7.1983383,8.1450082,419.9385811,546.3569908,0.0019406,67.078753,58.3382668,117.354113,11.9374653,15.3107984,2.7957986,55.7296617),(32021,'femur.tif',228,7,176,33.6304472,17.6510378,22.8660353,1.8,17.5529001,22.8338716,-0.0027133,6.7622911,7.7608901,324.7731587,445.7484292,0.0000414,57.4352198,48.0270897,97.919632,11.1407275,14.6518979,2.8460141,51.3821405),(32022,'femur.tif',228,7,177,32.2126817,17.7174691,22.72418,1.8,17.5655131,22.7130354,-0.0359514,6.159558,7.3270697,255.3969049,383.9381008,0.0069362,52.3999517,41.4635118,85.792999,10.2802339,13.8971759,2.8695249,47.0512618),(32023,'femur.tif',228,7,178,28.4299979,17.8665832,22.6107511,1.8,17.7550817,22.5781295,-0.0538982,5.5461716,6.7307561,175.3696362,320.5556853,0.0137516,47.6255087,31.619944,72.3613377,9.2864812,12.9653849,2.8766529,43.9667597),(32024,'femur.tif',228,7,179,23.1310979,17.8990788,22.6767985,1.8,17.8220232,22.6382186,-0.1701149,4.8111478,6.0958376,103.3633093,249.7672863,0.1104933,40.9734151,21.4841269,56.4970501,3.9696484,7.5401516,1.9739989,19.8159214),(32025,'femur.tif',228,7,180,17.0023606,18.2989096,22.5503418,1.8,18.2710075,22.5153485,-0.2192006,3.8877793,4.9877499,43.4757901,173.0476388,0.1339907,34.6945298,11.1826796,41.9173794,2.4969518,5.4948597,1.9316331,13.9517043),(32026,'femur.tif',228,7,181,7.1484161,20.7657506,21.6964855,1.8,20.7393271,21.674026,0.8715183,1.4241374,2.6990375,3.1482473,11.4074693,0.6977985,4.2264953,2.2106345,5.345921,2.7183415,4.9688246,2.2455373,12.7994724),(32027,'femur.tif',228,7,182,1.8417274,20.6771635,21.8468006,1.8,20.6829924,21.8538211,0.8674257,0.6078355,1.1690489,0.144103,0.5414272,0.1785432,0.4631347,0.2370756,0.5850337,1.2630914,2.3481215,2.2390857,5.9230574),(32028,'femur.tif',228,7,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32029,'femur.tif',228,7,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32030,'femur.tif',228,7,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32031,'femur.tif',228,7,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32032,'femur.tif',228,7,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32033,'femur.tif',228,7,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32034,'femur.tif',228,7,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32035,'femur.tif',228,7,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32036,'femur.tif',228,7,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32037,'femur.tif',228,7,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32038,'femur.tif',228,7,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32039,'femur.tif',228,7,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32040,'femur.tif',228,7,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32041,'femur.tif',228,7,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32042,'femur.tif',228,7,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32043,'femur.tif',228,7,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32044,'femur.tif',228,7,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32045,'femur.tif',228,7,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32046,'Bettongia_penicillata_tibia.tif',228,8,1,0.9958762,6.4879329,13.6532376,1.8,6.5421173,13.5943789,-0.8630243,5.4092403,9.2646905,0.5976371,7.0363214,0.0958223,0.7594772,0.1104845,0.8224391,1.876086,2.6136788,2.2419402,8.6435612),(32047,'Bettongia_penicillata_tibia.tif',228,8,2,1.0517372,7.6109339,13.2809963,1.8,7.6993273,13.1832944,-0.8542158,1.6324992,9.0755315,0.3699654,14.386231,0.0996697,1.5851668,0.2266252,1.617598,2.0264012,2.8908542,2.1183586,10.8984032),(32048,'Bettongia_penicillata_tibia.tif',228,8,3,0.9188825,8.4355948,11.9847223,1.8,8.3493751,12.0778372,-0.9486745,5.5146528,6.4243763,0.9601939,14.5968222,0.1011368,2.2720995,0.1741168,2.4193794,0,0,0,0),(32049,'Bettongia_penicillata_tibia.tif',228,8,4,2.7579087,10.8724158,8.3629098,1.8,9.9890688,8.772063,-0.6559764,5.2381354,8.580604,3.7608685,17.5113602,0.1709989,2.0408074,0.7179785,2.4648998,1.5522337,3.5415823,0.5549957,10.5518101),(32050,'Bettongia_penicillata_tibia.tif',228,8,5,15.7474235,9.4559509,10.1630921,1.8,8.9926111,10.4666768,-0.8904669,5.6401819,6.2632466,24.8955321,137.4175003,1.5860206,21.9402984,4.4139591,25.1009477,4.6712476,10.2659987,0.8227252,30.5048459),(32051,'Bettongia_penicillata_tibia.tif',228,8,6,27.496791,9.6320651,10.1519059,1.8,9.4067535,10.4115302,-0.740162,6.5865154,6.4575062,171.6821677,252.2045853,2.0843739,39.0560343,26.065705,61.5637899,10.1687704,12.3662301,0.9409263,67.5455187),(32052,'Bettongia_penicillata_tibia.tif',228,8,7,36.5338693,9.7993463,10.417503,1.8,9.758328,10.3680808,-0.7477507,7.2765102,6.8000226,395.5049126,426.1001339,2.8154711,62.6615766,54.3536532,106.6998821,11.7022669,13.4251413,1.561828,51.4573842),(32053,'Bettongia_penicillata_tibia.tif',228,8,8,35.9334147,9.8584454,10.0589615,1.8,9.9778468,9.8929218,-1.0459428,7.5309085,7.5971448,428.347261,560.6818545,4.4851646,73.8016547,56.8785637,124.5421,12.9460867,14.5141953,1.4752548,54.2376472),(32054,'Bettongia_penicillata_tibia.tif',228,8,9,31.4909158,10.4655159,9.3752339,1.8,10.5718052,9.2184894,-0.865879,7.5569989,8.6796806,437.5879707,590.925077,3.044824,68.0814309,57.9049931,117.8978988,13.8381704,15.6550113,1.3734008,58.5795661),(32055,'Bettongia_penicillata_tibia.tif',228,8,10,31.4296521,10.6889976,8.8908929,1.8,10.846252,8.7790147,-0.8209866,7.7878939,9.2860008,441.7340486,661.0189101,2.8054026,71.1844552,56.7206045,117.2135769,14.1677411,16.2980885,1.3473197,59.810274),(32056,'Bettongia_penicillata_tibia.tif',228,8,11,30.0263678,10.6762813,9.1511033,1.8,10.9172969,8.880086,-0.7348072,7.3736523,9.1015801,403.313725,691.8890481,2.2494521,76.0185642,54.6966023,116.9931443,13.7623755,16.6213078,1.2994617,59.9634322),(32057,'Bettongia_penicillata_tibia.tif',228,8,12,29.3247265,10.443951,9.3655969,1.8,10.8357785,8.9926239,-0.7286739,7.3038059,8.9459791,373.6136989,747.501616,2.1670844,83.557273,51.1532897,120.9791724,13.3472611,16.7871687,0.505357,60.6153036),(32058,'Bettongia_penicillata_tibia.tif',228,8,13,28.1110144,10.8730401,9.563202,1.8,11.1547792,9.2211742,-0.5092949,7.5382093,8.7423219,368.8426933,758.8207968,1.1137418,86.7985426,48.9297493,122.0445069,12.9497779,17.0649763,0.5997437,62.2802464),(32059,'Bettongia_penicillata_tibia.tif',228,8,14,24.233468,10.1878047,9.1644888,1.8,10.3919625,9.0207797,-0.6712972,6.915062,8.7198666,262.0695256,590.1369092,1.5626013,67.6772863,37.8983622,92.3793772,12.1149285,16.4363657,0.5046083,74.117648),(32060,'Bettongia_penicillata_tibia.tif',228,8,15,21.1872971,9.0769707,9.3954499,1.8,9.2762289,9.2911775,-0.913189,8.3383283,8.2473007,179.7069354,451.3980635,2.2119684,54.7328247,21.5519141,71.8196294,11.1774883,14.8332864,1.2272264,49.1647716),(32061,'Bettongia_penicillata_tibia.tif',228,8,16,19.4315454,8.6760843,9.4985358,1.8,8.7966983,9.504324,-0.9824643,8.8328087,8.0290324,138.2162265,387.9906686,2.2411166,48.3234653,15.6480494,57.3633793,10.0415314,14.2592709,1.2397003,46.7895295),(32062,'Bettongia_penicillata_tibia.tif',228,8,17,18.7373416,8.5592745,9.6033266,1.8,8.5865023,9.6802539,-0.9588935,6.0245645,7.8353856,117.2632555,357.2160903,2.0924448,45.5901097,19.4641878,59.6653267,9.4389983,13.8216382,1.2380269,44.8193084),(32063,'Bettongia_penicillata_tibia.tif',228,8,18,18.3747876,8.3847665,9.6638637,1.8,8.4195309,9.7508223,-0.9586957,5.7177473,7.6853424,103.4990275,334.6131901,2.0513878,43.5391388,18.1013645,56.2003641,8.937698,13.4506268,1.2094065,42.7322316),(32064,'Bettongia_penicillata_tibia.tif',228,8,19,18.5889368,8.2974916,9.7053191,1.8,8.2803805,9.7889687,-0.9339946,5.3874485,7.5647405,92.1716574,319.2188085,2.0027058,42.1982494,17.1085919,53.3148705,8.5391017,13.1936935,1.2360595,41.8189028),(32065,'Bettongia_penicillata_tibia.tif',228,8,20,18.6121555,8.184035,9.7032355,1.8,8.142742,9.8117193,-0.9334865,5.2608592,7.4982989,80.7469965,306.2181413,2.0037,40.838348,15.3486328,50.6407365,8.2746499,12.9465008,1.234341,40.6209531),(32066,'Bettongia_penicillata_tibia.tif',228,8,21,18.781047,8.090287,9.6772089,1.8,8.0377298,9.783952,-0.9252675,5.0144003,7.476214,72.5245845,291.6776351,1.9972149,39.0140834,14.4632619,47.7880187,7.9904429,12.7561526,1.2341215,39.8219739),(32067,'Bettongia_penicillata_tibia.tif',228,8,22,18.897975,7.9862047,9.7037053,1.8,7.9298467,9.8041294,-0.925182,4.7683699,7.3923136,64.5213316,283.2299205,2.0093903,38.3141105,13.5311088,46.0324859,7.6945663,12.5910151,1.214264,38.650732),(32068,'Bettongia_penicillata_tibia.tif',228,8,23,18.5282928,7.9537997,9.6650408,1.8,7.8812379,9.7839562,-0.926259,4.5572054,7.4536607,58.6214857,270.4061146,1.9732785,36.2782966,12.8634723,43.3160745,7.4124624,12.4660535,1.1741479,37.990304),(32069,'Bettongia_penicillata_tibia.tif',228,8,24,18.4994267,7.8784168,9.6980127,1.8,7.81895,9.796352,-0.9334271,4.4109673,7.4601564,54.5442627,271.5686102,1.9913891,36.4025356,12.3656012,43.2824866,7.2007964,12.3892139,0.6405857,37.0185474),(32070,'Bettongia_penicillata_tibia.tif',228,8,25,18.108666,7.8650233,9.6615719,1.8,7.794334,9.76545,-0.9370406,4.2772087,7.5584445,51.4851084,263.5242363,1.9597451,34.8648766,12.037081,41.2412322,7.0584064,12.3657905,0.6542115,36.9067039),(32071,'Bettongia_penicillata_tibia.tif',228,8,26,18.1220311,7.8117866,9.6606527,1.8,7.733418,9.7794358,-0.9355308,4.169078,7.6103308,49.5647279,258.2836959,1.9568374,33.9385636,11.8886544,39.864464,6.9496404,12.4105492,1.1722739,36.6659039),(32072,'Bettongia_penicillata_tibia.tif',228,8,27,18.1377649,7.7730532,9.6479986,1.8,7.6967182,9.7618936,-0.926892,4.0524605,7.624371,48.2137851,249.837225,1.9335245,32.7682407,11.8974103,38.4946923,6.7928727,12.4105492,1.1722739,36.3606256),(32073,'Bettongia_penicillata_tibia.tif',228,8,28,18.3268042,7.6845502,9.704083,1.8,7.6202155,9.8054564,-0.9302745,4.0072676,7.579297,46.9347615,251.6213286,1.9635876,33.1985051,11.71241,38.7395415,6.7294532,12.4429204,1.1786103,36.5601108),(32074,'Bettongia_penicillata_tibia.tif',228,8,29,17.9729363,7.6703612,9.7141295,1.8,7.5774752,9.8553158,-0.9405777,3.9223793,7.7135435,46.1328081,252.6500987,1.9551569,32.7540899,11.7614347,37.8814662,6.6661791,12.6266553,1.220396,36.4956326),(32075,'Bettongia_penicillata_tibia.tif',228,8,30,18.0000694,7.62273,9.7639259,1.8,7.5184058,9.9267404,-0.9532415,3.9140209,7.8192519,46.2626619,258.6463591,1.994134,33.0781464,11.8197279,38.1300132,6.6334118,12.8329131,1.2312435,36.9772326),(32076,'Bettongia_penicillata_tibia.tif',228,8,31,18.3406656,7.5811588,9.7950402,1.8,7.4789876,9.9537533,-0.9623632,3.8890952,7.8277895,47.0064909,264.7460987,2.0581083,33.8213102,12.0867422,38.9312959,6.6133718,12.9072519,1.2431461,36.6135264),(32077,'Bettongia_penicillata_tibia.tif',228,8,32,18.5454958,7.5479926,9.7946998,1.8,7.4534906,9.941234,-0.9620756,3.846499,7.7442808,47.7379129,266.1864271,2.0802597,34.3720008,12.4107436,39.7439371,6.6271918,12.813554,1.265389,36.9626256),(32078,'Bettongia_penicillata_tibia.tif',228,8,33,18.7693717,7.5227375,9.779102,1.8,7.4308856,9.9253617,-0.9606667,3.8358235,7.6072269,48.4677885,266.1566699,2.1012348,34.9873448,12.6355629,40.3949374,6.6160511,12.7675116,1.293792,36.7364326),(32079,'Bettongia_penicillata_tibia.tif',228,8,34,18.6520266,7.4867246,9.7915183,1.8,7.3858183,9.9529166,-0.9573475,3.7949922,7.5273717,48.2252247,262.7588948,2.0783955,34.9071236,12.7075954,40.5240782,6.6197646,12.6352628,1.2957689,36.7218256),(32080,'Bettongia_penicillata_tibia.tif',228,8,35,19.0647874,7.4308842,9.8202862,1.8,7.3513897,9.9556635,-0.9538672,3.7744546,7.4382348,48.4185431,267.0169513,2.1139654,35.8978921,12.8279574,41.7218646,6.5865212,12.5194304,1.2931572,36.4019403),(32081,'Bettongia_penicillata_tibia.tif',228,8,36,18.7189159,7.4727103,9.7129163,1.8,7.3824064,9.8606826,-0.9396807,3.751868,7.3851944,47.8429636,254.061388,2.0336416,34.4014488,12.7517717,40.07643,6.6302962,12.3392392,1.3092511,36.4251039),(32082,'Bettongia_penicillata_tibia.tif',228,8,37,18.703533,7.5007622,9.5951264,1.8,7.439695,9.6961168,-0.909641,3.6632991,7.2633566,47.1657368,236.827846,1.9419511,32.6058404,12.8752077,38.3828848,6.5128784,12.0648082,1.2979798,35.1772828),(32083,'Bettongia_penicillata_tibia.tif',228,8,38,18.2334006,7.5649449,9.4133695,1.8,7.5160529,9.4927503,-0.873943,3.5766312,7.0347134,45.8747078,211.3060099,1.7871249,30.0376147,12.8262337,35.6523673,6.4109013,11.6397922,1.2114203,34.052368),(32084,'Bettongia_penicillata_tibia.tif',228,8,39,17.8853883,7.6337905,9.2504918,1.8,7.6090316,9.3068268,-0.8381387,3.4817607,6.7284411,45.295888,190.5741055,1.6473718,28.3236643,13.0094777,34.3483416,6.3323421,11.3307223,0.6573153,32.264519),(32085,'Bettongia_penicillata_tibia.tif',228,8,40,18.0070331,7.6965247,9.1204849,1.8,7.6796981,9.1694441,-0.8040277,3.4215466,6.5531635,45.7422619,178.7178675,1.5564836,27.271999,13.3688845,33.5871931,6.3072664,11.0920043,0.6196186,31.7123903),(32086,'Bettongia_penicillata_tibia.tif',228,8,41,18.1783815,7.7440984,9.0274308,1.8,7.7307634,9.0774921,-0.7776038,3.3509487,6.276896,46.1150373,170.5801772,1.4912514,27.1758809,13.7617855,33.849518,6.2587048,10.8026726,0.5910938,30.7844545),(32087,'Bettongia_penicillata_tibia.tif',228,8,42,18.3727069,7.7782665,8.9457629,1.8,7.791584,8.9765397,-0.7529875,3.3241547,5.9543119,46.505054,162.179189,1.4318832,27.2372682,13.990039,34.439753,6.2174863,10.5226098,0.561025,29.8625692),(32088,'Bettongia_penicillata_tibia.tif',228,8,43,18.2630193,7.8031978,8.8773365,1.8,7.8373783,8.9079055,-0.7348545,3.331776,5.6671097,46.6464338,153.1388085,1.3683336,27.0223831,14.0004714,34.6915531,6.1591735,10.2223085,0.5242593,29.2046474),(32089,'Bettongia_penicillata_tibia.tif',228,8,44,18.250268,7.8433844,8.8170214,1.8,7.8910819,8.8415813,-0.716722,3.2836593,5.4234781,47.0622069,145.8131964,1.3126187,26.8855507,14.3322444,34.8237407,6.1455706,9.988304,0.4690384,28.552776),(32090,'Bettongia_penicillata_tibia.tif',228,8,45,18.3758677,7.892398,8.7642634,1.8,7.9485483,8.7806009,-0.6978116,3.264335,5.2030326,47.9810132,140.4325682,1.2644456,26.9905223,14.6985568,35.6283602,6.1035037,9.7464535,0.4746969,28.1709186),(32091,'Bettongia_penicillata_tibia.tif',228,8,46,18.5469105,7.9419266,8.7251996,1.8,8.0077993,8.7289026,-0.6800999,3.2415969,5.0230048,49.5360121,137.3625543,1.2224835,27.34669,15.2813607,36.0600146,6.1290372,9.5414636,0.4156619,27.4460124),(32092,'Bettongia_penicillata_tibia.tif',228,8,47,18.7638315,7.9999384,8.6820142,1.8,8.0611473,8.6898866,-0.6619478,3.2569328,4.9294673,50.8863461,133.9674856,1.1814963,27.1768688,15.6240088,36.07475,6.1283445,9.3792305,0.374547,27.3548263),(32093,'Bettongia_penicillata_tibia.tif',228,8,48,18.6627125,8.0541297,8.6226102,1.8,8.1198711,8.6301865,-0.6490271,3.2565125,4.7891173,51.5512945,128.2153592,1.1362897,26.7722319,15.8302153,35.4528224,6.1353772,9.2339824,0.3877702,27.3840402),(32094,'Bettongia_penicillata_tibia.tif',228,8,49,18.7747687,8.1053303,8.5954153,1.8,8.1720034,8.5986626,-0.6388964,3.2709183,4.6710944,52.4236271,124.7968472,1.1126725,26.7168324,16.0271895,35.7165647,6.1257639,9.0772347,0.3805064,26.8233549),(32095,'Bettongia_penicillata_tibia.tif',228,8,50,18.7918257,8.1699927,8.5593077,1.8,8.2398512,8.5675849,-0.625255,3.2717007,4.6022106,53.1855119,120.3205065,1.0729532,26.1440679,16.2562279,35.3949462,6.1326062,8.913261,0.3516562,26.6178192),(32096,'Bettongia_penicillata_tibia.tif',228,8,51,18.8603872,8.2084317,8.5433693,1.8,8.2914211,8.5517409,-0.6172253,3.2815563,4.4481668,53.6468764,116.5379844,1.0529757,26.1991037,16.3479983,34.4948346,6.1312801,8.7819822,0.2848909,26.0923983),(32097,'Bettongia_penicillata_tibia.tif',228,8,52,18.7103194,8.247369,8.5374589,1.8,8.3340694,8.5503205,-0.6118959,3.2640722,4.3521497,54.0036046,112.4874897,1.0289392,25.8464202,16.5448558,33.9705313,6.1298914,8.6665013,0.2887955,26.1714835),(32098,'Bettongia_penicillata_tibia.tif',228,8,53,18.5750995,8.3036769,8.5207604,1.8,8.3976064,8.5285671,-0.6086073,3.2782337,4.2179897,54.5199657,107.6719052,1.0119401,25.5268296,16.6308967,33.4178819,6.1466645,8.5273898,0.2569644,25.7105409),(32099,'Bettongia_penicillata_tibia.tif',228,8,54,18.6240696,8.3779232,8.5134319,1.8,8.4595764,8.5306739,-0.5908835,3.2957212,4.1879383,55.5288154,104.8530769,0.9633448,25.0369204,16.8487598,33.0827136,6.1471605,8.4691803,0.2587709,25.5755339),(32100,'Bettongia_penicillata_tibia.tif',228,8,55,18.6047942,8.4419899,8.5043858,1.8,8.5256168,8.5203513,-0.5786608,3.3239888,4.105179,56.1227458,101.7387897,0.9274589,24.7830335,16.8841563,32.9866763,6.1569212,8.3469865,0.1959811,25.3639478),(32101,'Bettongia_penicillata_tibia.tif',228,8,56,18.6083101,8.5050785,8.5040163,1.8,8.5842666,8.5246272,-0.5646538,3.3399372,4.0677101,56.6962982,99.1759938,0.8881034,24.3812838,16.9752588,32.5901565,6.1402996,8.2936297,0.2344157,25.2349912),(32102,'Bettongia_penicillata_tibia.tif',228,8,57,18.6795648,8.5732078,8.5014953,1.8,8.6540132,8.5197646,-0.549097,3.3597111,4.0270336,57.364545,97.1172579,0.8480446,24.116327,17.0742495,32.3502569,6.1946679,8.265178,0.1831108,25.0148486),(32103,'Bettongia_penicillata_tibia.tif',228,8,58,18.3852482,8.6198033,8.4965794,1.8,8.7018105,8.5170742,-0.5439817,3.3528428,3.9720031,57.2059091,93.9510594,0.8207634,23.65332,17.061912,31.7681156,6.2221928,8.1652604,0.155452,25.2435478),(32104,'Bettongia_penicillata_tibia.tif',228,8,59,18.2726581,8.6815226,8.5003243,1.8,8.7642203,8.5191312,-0.5326419,3.3397902,3.9429134,57.3505167,91.1210567,0.7853346,23.1100832,17.1718919,31.1465782,6.1828619,8.1171845,0.1114762,24.9151059),(32105,'Bettongia_penicillata_tibia.tif',228,8,60,18.2126817,8.750752,8.5074022,1.8,8.8319767,8.5318792,-0.5079737,3.3768617,3.9046784,57.4918223,89.1855469,0.7181641,22.8406892,17.0252226,30.8361055,6.2044724,8.1171845,0.1114762,24.7594416),(32106,'Bettongia_penicillata_tibia.tif',228,8,61,18.0802546,8.7983945,8.5211314,1.8,8.8764563,8.5434798,-0.4999509,3.367058,3.8699204,57.1971963,86.8782537,0.6924964,22.4496228,16.9872916,30.4531753,6.2105099,8.0045637,0.1206237,24.8093129),(32107,'Bettongia_penicillata_tibia.tif',228,8,62,18.0982326,8.8521511,8.5427508,1.8,8.9343224,8.567914,-0.4821804,3.4018376,3.8189035,57.460319,84.9354177,0.6486071,22.2407868,16.8909649,30.006062,6.2516523,8.0120305,0.1280828,24.6244346),(32108,'Bettongia_penicillata_tibia.tif',228,8,63,18.0506678,8.9154884,8.5664126,1.8,8.9953877,8.5877086,-0.4547065,3.4199837,3.78797,57.584827,82.976363,0.5803154,21.9052326,16.8377491,29.5883091,6.2350956,7.9848449,0.0981683,24.3544206),(32109,'Bettongia_penicillata_tibia.tif',228,8,64,17.9332974,8.9729291,8.5834108,1.8,9.0473685,8.6045366,-0.4350242,3.4277916,3.8057998,57.3119467,80.763934,0.5308412,21.2212777,16.7197871,28.9885054,6.2449787,7.9791696,0.0906599,24.5952207),(32110,'Bettongia_penicillata_tibia.tif',228,8,65,18.0236129,9.029757,8.6178275,1.8,9.1106501,8.6367707,-0.4006511,3.4582826,3.8729892,57.4309826,79.8115254,0.4569406,20.6072163,16.6067928,28.6690149,6.2406433,7.9609814,0.060532,24.4188989),(32111,'Bettongia_penicillata_tibia.tif',228,8,66,18.1201384,9.0983638,8.6490359,1.8,9.1737993,8.6688426,-0.3630381,3.4700852,3.9473425,57.4869253,78.4944562,0.3808471,19.885393,16.5664307,28.0689348,6.2859518,7.9691712,0.0756131,24.4249493),(32112,'Bettongia_penicillata_tibia.tif',228,8,67,18.1428829,9.1561262,8.6791131,1.8,9.2311812,8.6916608,-0.3453217,3.4805197,3.9930624,57.1815186,77.1782531,0.3464742,19.3280859,16.4290172,27.6767818,6.2680585,7.9575664,3.088612,24.510085),(32113,'Bettongia_penicillata_tibia.tif',228,8,68,18.2102174,9.215687,8.7082535,1.8,9.2861217,8.7234287,-0.3066768,3.4768803,4.0627057,57.0325639,75.9478859,0.2766099,18.6939176,16.4033729,27.5793153,6.2910143,7.9008925,3.0805997,24.7156207),(32114,'Bettongia_penicillata_tibia.tif',228,8,69,18.2462171,9.285188,8.7399308,1.8,9.3555353,8.7538984,-0.256086,3.5139402,4.1403766,56.6897409,74.247101,0.1951096,17.9324511,16.1328134,27.1604484,6.2973159,7.8974516,3.0882083,24.3252067),(32115,'Bettongia_penicillata_tibia.tif',228,8,70,18.4070049,9.3625007,8.7846327,1.8,9.4334655,8.800444,-0.1838483,3.5220688,4.2681951,56.643484,73.932567,0.1025303,17.3217403,16.0824467,27.0531307,6.2834545,7.8882685,3.1186959,24.3957354),(32116,'Bettongia_penicillata_tibia.tif',228,8,71,18.6810796,9.4319283,8.8260065,1.8,9.5097558,8.8386849,-0.1370633,3.5234982,4.3077913,56.7295496,73.8715135,0.0581262,17.1483501,16.1003485,27.3888621,6.322725,7.8051345,3.0411565,24.3957354),(32117,'Bettongia_penicillata_tibia.tif',228,8,72,18.9141162,9.4919793,8.8656932,1.8,9.5686399,8.8788637,-0.0892327,3.501968,4.3346843,56.6107283,73.5239052,0.025034,16.9617672,16.1654041,27.4490949,6.2944144,7.7393892,3.0481159,24.495478),(32118,'Bettongia_penicillata_tibia.tif',228,8,73,19.2018069,9.5481381,8.9105613,1.8,9.6209331,8.9261928,-0.0474386,3.5103474,4.3391152,56.812436,73.5927813,0.0071966,16.9603198,16.1842774,27.6453012,6.3147731,7.7105375,2.9610408,25.0561633),(32119,'Bettongia_penicillata_tibia.tif',228,8,74,19.3784069,9.6020296,8.9571104,1.8,9.6764355,8.9667324,-0.0149489,3.4879719,4.2819038,56.6846648,73.4515816,0.0007217,17.1539544,16.2514682,27.8507113,6.3259396,7.6304547,2.975147,24.360471),(32120,'Bettongia_penicillata_tibia.tif',228,8,75,19.6583688,9.6519625,9.0077424,1.8,9.7219079,9.0223922,0.0286301,3.4552856,4.2979383,56.9148232,73.5379969,0.0026849,17.1100633,16.4718144,28.3618298,6.285273,7.5732469,2.502861,24.1755927),(32121,'Bettongia_penicillata_tibia.tif',228,8,76,19.8151733,9.7121519,9.0528384,1.8,9.7775711,9.0699027,0.0881147,3.4231882,4.3188049,56.7692816,73.099971,0.0255752,16.9259719,16.5837453,28.5359657,6.2836125,7.5310184,2.4581129,24.0345353),(32122,'Bettongia_penicillata_tibia.tif',228,8,77,19.8775064,9.765399,9.0949986,1.8,9.8330817,9.1191358,0.1334405,3.3558652,4.2999852,56.1553727,72.9487802,0.0586417,16.9648911,16.7335006,28.6235441,6.2876099,7.4890356,2.5045223,24.0491423),(32123,'Bettongia_penicillata_tibia.tif',228,8,78,20.0382802,9.8271848,9.1469313,1.8,9.8918376,9.1751314,0.1719118,3.2846995,4.2897129,55.7664546,72.743825,0.0977322,16.9577373,16.977643,28.8257884,6.2574714,7.4640725,2.418969,23.7499144),(32124,'Bettongia_penicillata_tibia.tif',228,8,79,20.1578951,9.8941182,9.1946262,1.8,9.9642354,9.221567,0.2212335,3.2482462,4.2817877,55.3699672,72.8291189,0.1617703,17.0090449,17.0461116,29.1134563,6.2149036,7.4463295,2.4592761,23.7353074),(32125,'Bettongia_penicillata_tibia.tif',228,8,80,20.1502993,9.9558527,9.2479796,1.8,10.0162913,9.2830442,0.2813195,3.1769839,4.2372559,55.1453899,72.7865585,0.2588468,17.1777584,17.3577805,29.5791218,6.1780859,7.4112051,2.3906636,24.1257214),(32126,'Bettongia_penicillata_tibia.tif',228,8,81,20.2299015,10.0120244,9.3078656,1.8,10.075669,9.3564244,0.3384209,3.1325682,4.6003495,54.6709808,73.0580868,0.3716322,15.8809863,17.4524473,26.6555237,6.1297679,7.3532773,2.4489508,23.6501718),(32127,'Bettongia_penicillata_tibia.tif',228,8,82,20.2487501,10.0706753,9.3614838,1.8,10.1428888,9.420592,0.3915603,3.1328298,4.4791254,54.0277886,72.9425521,0.4915123,16.2849988,17.2456825,27.5096208,6.0931576,7.2851957,2.3971073,24.2753354),(32128,'Bettongia_penicillata_tibia.tif',228,8,83,20.360273,10.1473759,9.4202344,1.8,10.228296,9.4990852,0.4538907,3.1585615,4.2827869,53.3282999,73.5351811,0.6523842,17.1699368,16.8837301,28.9987651,6.0446322,7.2851957,2.3971073,22.8693438),(32129,'Bettongia_penicillata_tibia.tif',228,8,84,20.5245172,10.223061,9.4754124,1.8,10.3224541,9.5713255,0.4988778,3.1826746,4.2545324,52.8860632,73.875449,0.7830283,17.3639409,16.6168617,29.3542393,6.0018932,7.6247532,2.2443042,26.1458138),(32130,'Bettongia_penicillata_tibia.tif',228,8,85,20.6382798,10.292417,9.5235484,1.8,10.3947868,9.6196672,0.5269919,3.1553173,4.2717949,52.1273111,74.0121894,0.8700557,17.3257825,16.5204656,29.2077884,5.9594966,7.6076232,2.2665478,24.3871788),(32131,'Bettongia_penicillata_tibia.tif',228,8,86,20.7794657,10.3568078,9.5666109,1.8,10.4465264,9.6611427,0.5531067,3.1539441,4.2727504,51.8683147,74.1720087,0.9557688,17.3593125,16.44554,29.1903686,5.9594966,7.6157172,2.2554135,23.3302865),(32132,'Bettongia_penicillata_tibia.tif',228,8,87,20.9224921,10.4177171,9.6092292,1.8,10.4931963,9.6852594,0.5727726,3.1651606,4.007513,51.4125286,73.5404483,1.024244,18.350645,16.2432607,30.757632,5.9084912,7.3830344,2.1882022,22.4376151),(32133,'Bettongia_penicillata_tibia.tif',228,8,88,20.9237901,10.4775377,9.6435965,1.8,10.5401852,9.7174334,0.5948876,3.1348169,3.9524599,50.7107216,72.8340126,1.0952408,18.4275146,16.1766137,30.9237237,5.8317931,7.3340311,2.1929542,22.1469437),(32134,'Bettongia_penicillata_tibia.tif',228,8,89,20.89475,10.541236,9.6805653,1.8,10.6120924,9.7507827,0.6164226,3.1244221,4.0237816,50.0287926,72.7441073,1.1639161,18.0785426,16.0121746,30.2940179,5.8317931,7.3709985,2.2404353,22.8985578),(32135,'Bettongia_penicillata_tibia.tif',228,8,90,20.7887879,10.5792297,9.7092359,1.8,10.6320921,9.7734136,0.6504042,3.1002111,3.8715492,49.2163279,70.6694552,1.2703337,18.2535343,15.8751537,30.6145329,5.7892252,7.2302688,2.1726549,21.6713941),(32136,'Bettongia_penicillata_tibia.tif',228,8,91,20.6916365,10.6317743,9.7381269,1.8,10.6740907,9.792848,0.6789576,3.110374,3.8277291,48.4327757,69.5042888,1.3599977,18.1581004,15.5713674,30.5639063,5.7581799,7.1648124,2.2311026,21.7565298),(32137,'Bettongia_penicillata_tibia.tif',228,8,92,20.5208108,10.6833427,9.7640911,1.8,10.7175113,9.8149983,0.7021425,3.0563094,3.8596337,47.6230742,68.50549,1.4266359,17.7492208,15.581889,29.8342121,5.7040896,7.2124532,2.225983,21.6507367),(32138,'Bettongia_penicillata_tibia.tif',228,8,93,20.2994662,10.7343559,9.794918,1.8,10.7606325,9.8443998,0.7341608,3.0418625,3.8152802,46.6517092,67.4692206,1.5185768,17.683949,15.336561,29.754944,5.6615217,7.1313508,2.1822139,21.2104514),(32139,'Bettongia_penicillata_tibia.tif',228,8,94,20.3364959,10.8005308,9.8295214,1.8,10.8286186,9.8756032,0.7496508,3.0552209,3.8339615,46.1179797,67.8047844,1.5736486,17.6853064,15.0948102,29.5871131,5.7040896,7.1473406,2.1401095,21.3807228),(32140,'Bettongia_penicillata_tibia.tif',228,8,95,20.2820063,10.8540581,9.8599864,1.8,10.8755286,9.9007239,0.7726289,3.0001987,3.7815251,45.4938336,67.1493459,1.6470074,17.7572126,15.1636069,29.6560742,5.651108,7.1127778,2.1634937,21.1399227),(32141,'Bettongia_penicillata_tibia.tif',228,8,96,20.2446624,10.9015738,9.8847875,1.8,10.9134652,9.9156491,0.7958893,2.9786093,3.7800247,44.9846965,66.3663021,1.722451,17.5571082,15.1025838,29.3401322,5.5954655,7.0831645,2.1257921,20.8200374),(32142,'Bettongia_penicillata_tibia.tif',228,8,97,20.2911747,10.9463727,9.914858,1.8,10.9584377,9.9480949,0.8181825,2.958823,3.7752164,44.805383,66.0891688,1.8017241,17.506061,15.1429749,29.3234015,5.5763861,7.0642084,2.1375255,20.8845157),(32143,'Bettongia_penicillata_tibia.tif',228,8,98,20.2846092,10.9830774,9.9421087,1.8,10.9920987,9.9713385,0.8366983,2.9579343,3.7785653,44.5663863,65.4072686,1.8635137,17.3100804,15.0667263,29.0630884,5.5969293,7.0821412,2.1870933,20.7701661),(32144,'Bettongia_penicillata_tibia.tif',228,8,99,20.4644456,11.057002,9.9846696,1.8,11.0658327,10.0088188,0.8289292,2.9052681,3.780612,44.5438112,66.7675156,1.8536562,17.6605047,15.3320831,29.3767456,5.5338182,7.1171074,2.1939957,20.6351591),(32145,'Bettongia_penicillata_tibia.tif',228,8,100,20.3352609,11.1036077,10.0088685,1.8,11.1116131,10.0334582,0.8502292,2.9093685,3.7814534,44.0730094,65.9663936,1.9137158,17.4447193,15.1486513,29.0453271,5.5763861,7.0967101,2.1446822,20.5852878),(32146,'Bettongia_penicillata_tibia.tif',228,8,101,20.3057524,11.1475477,10.030864,1.8,11.1466366,10.0539488,0.8733299,2.8660401,3.7407142,43.6963737,65.5263677,1.9882013,17.5170743,15.2462535,29.1704242,5.5244202,7.0196924,2.2040062,20.5147591),(32147,'Bettongia_penicillata_tibia.tif',228,8,102,20.1719185,11.1756357,10.0457184,1.8,11.1752341,10.0637593,0.9010062,2.8454213,3.7147307,43.1752596,64.7608761,2.0662121,17.4335318,15.1735912,29.0506406,5.5148121,6.9959038,2.1540257,20.3797521),(32148,'Bettongia_penicillata_tibia.tif',228,8,103,20.0829293,11.2119064,10.0705819,1.8,11.2124657,10.0898901,0.9158786,2.820024,3.6735939,42.7495617,64.3388237,2.1053755,17.5138638,15.15929,29.1497881,5.4912504,6.9457347,2.1587989,20.3092235),(32149,'Bettongia_penicillata_tibia.tif',228,8,104,19.9783059,11.2407873,10.0864418,1.8,11.2389918,10.097772,0.9334525,2.7941091,3.7404085,42.2671645,63.6936978,2.1506653,17.0285408,15.1272417,28.3259277,5.510034,7.0132361,2.1730837,20.6291087),(32150,'Bettongia_penicillata_tibia.tif',228,8,105,20.0286353,11.2986737,10.1116896,1.8,11.2866981,10.1242193,0.9115488,2.8054954,3.487873,42.4467105,64.0350268,2.0857036,18.3593342,15.1298448,30.4031225,5.4912504,6.7964714,2.1416016,20.1182947),(32151,'Bettongia_penicillata_tibia.tif',228,8,106,19.8594515,11.3144963,10.1250629,1.8,11.3106719,10.1349594,0.9441076,2.7834463,3.5956321,41.8830541,63.0166556,2.1714912,17.5258908,15.0471931,29.1498776,5.4912504,6.8622726,2.1563658,20.2885661),(32152,'Bettongia_penicillata_tibia.tif',228,8,107,19.8408322,11.3385113,10.1370665,1.8,11.3282159,10.145855,0.9543762,2.7811083,3.5732734,41.6202706,62.3570374,2.201604,17.450956,14.9653543,29.0814866,5.4912504,6.8554037,2.1051918,20.3530444),(32153,'Bettongia_penicillata_tibia.tif',228,8,108,19.7680871,11.3656829,10.1430541,1.8,11.3534643,10.1466654,0.9669368,2.7604678,3.6037284,41.3484427,61.8141926,2.232398,17.1528443,14.9787813,28.6077687,5.4912504,6.8862597,2.1127151,20.1036878),(32154,'Bettongia_penicillata_tibia.tif',228,8,109,19.9073955,11.4160467,10.1589989,1.8,11.4031307,10.164101,0.9487478,2.7619289,3.558446,41.4929024,62.3563637,2.1913375,17.5234816,15.0231608,29.1241192,5.458745,6.8662323,2.1247488,20.1389521),(32155,'Bettongia_penicillata_tibia.tif',228,8,110,19.8239221,11.4355925,10.1639199,1.8,11.4214412,10.161101,0.9559788,2.7694266,3.5447082,41.5196338,61.5350799,2.2047203,17.3597027,14.992141,29.0192714,5.4814846,6.8291859,2.1490193,20.2034304),(32156,'Bettongia_penicillata_tibia.tif',228,8,111,19.6425694,11.4433047,10.1633659,1.8,11.4273515,10.1623454,0.97328,2.7343584,3.4942551,40.9470581,60.2183773,2.2375882,17.2335379,14.975015,28.9328487,5.4486826,6.7729689,2.1020697,19.9480234),(32157,'Bettongia_penicillata_tibia.tif',228,8,112,19.5080722,11.4540843,10.1513229,1.8,11.4341892,10.1501793,0.9783003,2.7476927,3.414287,40.7474863,58.6807496,2.2374204,17.1868241,14.8297099,28.962077,5.4486826,6.6604717,2.0910635,19.9772374),(32158,'Bettongia_penicillata_tibia.tif',228,8,113,19.4203508,11.4660144,10.1480406,1.8,11.4475446,10.1463548,0.9788627,2.7094302,3.3941871,40.4503086,58.0454746,2.2290458,17.1014366,14.929452,28.9174184,5.458745,6.625557,2.0628915,19.7424877),(32159,'Bettongia_penicillata_tibia.tif',228,8,114,19.3497907,11.4805339,10.1467512,1.8,11.4604486,10.1401604,0.9792164,2.7393416,3.4544045,40.371798,57.7577051,2.2220032,16.7200178,14.7377743,28.3613012,5.4853234,6.6626477,2.1437625,19.9832878),(32160,'Bettongia_penicillata_tibia.tif',228,8,115,19.2440809,11.4925209,10.1335212,1.8,11.4744545,10.1269662,0.9678602,2.706245,3.3877778,40.1225666,57.1618668,2.1759899,16.8729681,14.8259179,28.5624586,5.4486826,6.6083047,2.0955921,19.7072234),(32161,'Bettongia_penicillata_tibia.tif',228,8,116,19.1234297,11.4941678,10.1304186,1.8,11.4695074,10.1243754,0.9648067,2.7245851,3.3731067,39.6110746,56.7388993,2.1532455,16.8209618,14.538388,28.4650154,5.4486826,6.5783486,2.0876723,19.5722164),(32162,'Bettongia_penicillata_tibia.tif',228,8,117,19.0441143,11.5017172,10.1207801,1.8,11.4769007,10.1138721,0.9588252,2.7036982,3.3749132,39.4295367,56.5457136,2.1264991,16.7547164,14.5835572,28.3158091,5.4061147,6.5868821,2.108081,19.6220877),(32163,'Bettongia_penicillata_tibia.tif',228,8,118,18.8923423,11.4962256,10.0999184,1.8,11.4675529,10.0908785,0.9538955,2.7223518,3.3238667,39.375249,55.2015205,2.0949282,16.6076218,14.4636889,28.2120551,5.4423673,6.5152428,2.1254779,19.5868234),(32164,'Bettongia_penicillata_tibia.tif',228,8,119,18.7964349,11.4997365,10.0925491,1.8,11.472695,10.0793608,0.941413,2.7001557,3.3088262,39.1654241,55.0525125,2.0472307,16.6380792,14.5048762,28.2682783,5.4348611,6.4963031,2.1382363,19.6366947),(32165,'Bettongia_penicillata_tibia.tif',228,8,120,18.6518677,11.4795989,10.0594611,1.8,11.4535459,10.0443853,0.941797,2.7184268,3.2634864,39.1265999,53.7945934,2.032621,16.4837805,14.3931039,28.2446535,5.4231558,6.4456189,2.1432561,19.3666807),(32166,'Bettongia_penicillata_tibia.tif',228,8,121,18.6336281,11.4767485,10.0473819,1.8,11.4470988,10.0326384,0.9259821,2.7070046,3.2559405,39.0973224,53.7992261,1.9836707,16.5234056,14.4430204,28.3309051,5.4061147,6.4459,2.1769317,19.4165521),(32167,'Bettongia_penicillata_tibia.tif',228,8,122,18.309629,11.4402403,10.0100339,1.8,11.4150051,9.9960836,0.963503,2.7300745,3.3004387,38.4635867,51.7370609,2.0578869,15.6758135,14.0888412,27.1408811,5.4193535,6.4526432,2.1096158,19.3520738),(32168,'Bettongia_penicillata_tibia.tif',228,8,123,18.28177,11.4327578,9.9962781,1.8,11.4026053,9.983636,0.9358641,2.715616,3.2554403,38.4871913,51.5803184,1.9750563,15.8443449,14.1725457,27.4088162,5.4061147,6.4132081,2.1353657,19.4019451),(32169,'Bettongia_penicillata_tibia.tif',228,8,124,17.8695383,11.3957471,9.946727,1.8,11.3757934,9.9331113,0.9302164,2.7159695,3.1944838,38.4554259,48.9063845,1.9144288,15.3096363,14.1590053,26.975504,5.3964585,6.2798735,2.0816192,19.2608877),(32170,'Bettongia_penicillata_tibia.tif',228,8,125,17.884237,11.3851576,9.9246676,1.8,11.3628992,9.9131536,0.8833155,2.7423233,3.1817298,38.5872514,48.8297074,1.7803538,15.3469057,14.0710072,27.003692,5.3599249,6.2876594,2.1030058,19.310759),(32171,'Bettongia_penicillata_tibia.tif',228,8,126,17.6788571,11.3607623,9.8950635,1.8,11.3371116,9.8824005,0.8328154,2.7219429,3.0643546,38.3816626,48.3177319,1.6127425,15.7676698,14.100833,27.1649921,5.3234441,6.2218971,2.0647377,19.460373),(32172,'Bettongia_penicillata_tibia.tif',228,8,127,17.4501085,11.3160265,9.8672312,1.8,11.2961388,9.8597575,0.8496734,2.703817,3.1239298,37.7842138,47.3098756,1.6405962,15.1443465,13.9743976,26.5055604,5.3236404,6.2285918,2.1427145,19.2754947),(32173,'Bettongia_penicillata_tibia.tif',228,8,128,17.2848187,11.2725678,9.837654,1.8,11.2507951,9.8305899,0.8426005,2.7291339,3.1295504,37.428915,46.4982304,1.6048309,14.8577987,13.7145765,25.9931866,5.3273656,6.2358606,2.1079046,19.1404877),(32174,'Bettongia_penicillata_tibia.tif',228,8,129,17.0525364,11.2311983,9.788483,1.8,11.2115721,9.7797563,0.7473059,2.7060358,2.8969361,37.2214957,44.9972869,1.3128878,15.5327164,13.7549902,26.6592023,5.3041711,6.0109638,2.0837313,18.9142946),(32175,'Bettongia_penicillata_tibia.tif',228,8,130,17.131642,11.2142771,9.772676,1.8,11.1927469,9.761138,0.6989218,2.6802142,2.9258236,37.1535728,45.7715517,1.1819522,15.643989,13.8621654,26.9805366,5.27731,6.0109638,2.0837313,19.0991729),(32176,'Bettongia_penicillata_tibia.tif',228,8,131,16.9415116,11.1521715,9.7454671,1.8,11.1353398,9.7408525,0.7185941,2.6824733,2.9548809,36.788999,44.8983183,1.2237262,15.1946288,13.7145818,26.1489815,5.2235878,6.0344313,2.070143,19.0200877),(32177,'Bettongia_penicillata_tibia.tif',228,8,132,16.5346674,11.0667883,9.6909143,1.8,11.0519906,9.6884776,0.6811797,2.6511139,2.8786388,36.2380321,42.4926374,1.0927612,14.7613649,13.6689834,25.8178911,5.2237406,5.929013,2.0798672,18.799945),(32178,'Bettongia_penicillata_tibia.tif',228,8,133,16.6157554,11.042957,9.6811838,1.8,11.0298456,9.6792506,0.6112903,2.6285073,2.8945824,36.266114,43.4338763,0.9121758,15.0052305,13.7972277,25.9752055,5.2152331,5.9816515,2.0749623,18.9289016),(32179,'Bettongia_penicillata_tibia.tif',228,8,134,16.6500929,11.0184692,9.6768769,1.8,11.0046858,9.6726283,0.5639191,2.5991431,2.9053275,36.2455269,44.5344793,0.7928025,15.3285573,13.9451831,26.4406736,5.1942267,5.9985915,2.1198215,19.0200877),(32180,'Bettongia_penicillata_tibia.tif',228,8,135,16.4973765,10.975965,9.6574846,1.8,10.9579002,9.6503915,0.4785543,2.5774604,2.8866074,35.9655063,44.6729707,0.5830638,15.4759428,13.953854,26.7650925,5.196421,5.9228975,2.0344439,18.8850807),(32181,'Bettongia_penicillata_tibia.tif',228,8,136,16.4966336,10.9503593,9.6555011,1.8,10.9392383,9.6443176,0.4515709,2.5368985,2.8973714,35.8842778,45.8679761,0.5235676,15.8308928,14.1449402,26.8171815,5.1430044,5.9485405,2.5142845,19.0906164),(32182,'Bettongia_penicillata_tibia.tif',228,8,137,15.7648599,10.8108345,9.6013777,1.8,10.8052306,9.5933071,0.4448002,2.5428825,2.8439377,35.154477,41.8037656,0.4864478,14.6992551,13.8246562,24.752788,5.1521355,5.9816515,2.0749623,19.0200877),(32183,'Bettongia_penicillata_tibia.tif',228,8,138,15.8012145,10.7803344,9.5940737,1.8,10.7668189,9.5867589,0.4177513,2.5551922,2.8842319,35.1783181,43.1092329,0.4334734,14.9465209,13.7673866,25.1961905,5.1403956,6.0115667,2.1421338,18.9556094),(32184,'Bettongia_penicillata_tibia.tif',228,8,139,15.8073106,10.748084,9.5825209,1.8,10.7402708,9.5711744,0.3953555,2.5905924,2.9248118,35.3113166,44.5182678,0.3907829,15.2208997,13.6305952,25.904428,5.1858563,6.0200006,2.2142974,19.1052233),(32185,'Bettongia_penicillata_tibia.tif',228,8,140,15.5189461,10.6623295,9.5543658,1.8,10.6548908,9.5405871,0.4012645,2.5809096,2.9174858,34.980499,43.694233,0.3945818,14.9766738,13.5535546,25.4519283,5.1638382,6.0115667,2.1421338,19.0054807),(32186,'Bettongia_penicillata_tibia.tif',228,8,141,15.4817226,10.6317005,9.5417287,1.8,10.6260905,9.5309617,0.388586,2.5416571,2.9509147,35.0759807,45.1233815,0.3704007,15.2913202,13.8004375,25.7491846,5.1429811,6.0775178,2.1587989,19.0614024),(32187,'Bettongia_penicillata_tibia.tif',228,8,142,15.3727184,10.5760558,9.5259875,1.8,10.5649123,9.51296,0.4104906,2.5748337,2.9716462,34.9205909,45.8144894,0.408013,15.4172088,13.5622706,26.2627265,5.1910182,6.0613963,2.1725722,19.0760094),(32188,'Bettongia_penicillata_tibia.tif',228,8,143,15.4198391,10.5562818,9.5141347,1.8,10.5422105,9.4992419,0.4108065,2.5549792,2.9946962,35.1736617,47.5121965,0.409858,15.8654478,13.7667117,26.7202708,5.1819506,6.1167472,2.202487,19.2669381),(32189,'Bettongia_penicillata_tibia.tif',228,8,144,15.1252986,10.4717692,9.4821768,1.8,10.4619879,9.4663134,0.4187606,2.5659494,3.034239,34.7642607,46.4239709,0.4168196,15.3000374,13.5483035,26.6035056,5.1886249,6.0775178,2.1587989,19.3812877),(32190,'Bettongia_penicillata_tibia.tif',228,8,145,15.3053354,10.4546763,9.4656114,1.8,10.4371808,9.4539732,0.3986598,2.5780449,3.0324488,35.3664708,48.3300828,0.3843845,15.9376418,13.7183301,27.5992937,5.194511,6.1114126,2.6823503,19.296152),(32191,'Bettongia_penicillata_tibia.tif',228,8,146,15.0243569,10.3616411,9.4476109,1.8,10.3443377,9.4354952,0.4541043,2.6117561,3.0633835,34.9091124,47.3542394,0.4818323,15.4581494,13.3661456,26.354713,5.2165864,6.1886075,2.2181885,19.3520738),(32192,'Bettongia_penicillata_tibia.tif',228,8,147,15.1936171,10.3331172,9.4279578,1.8,10.3177465,9.4179155,0.4235165,2.5960585,3.0924641,35.3933022,49.0735059,0.4276886,15.8687392,13.6334762,27.2470886,5.235472,6.2358606,2.6044844,19.4664234),(32193,'Bettongia_penicillata_tibia.tif',228,8,148,15.0185524,10.2638884,9.400099,1.8,10.2461159,9.3889302,0.4294063,2.6310494,3.0818001,35.3232002,48.8277328,0.4338649,15.8438999,13.4255177,27.0464475,5.251396,6.2154866,2.7646834,19.6160373),(32194,'Bettongia_penicillata_tibia.tif',228,8,149,14.6841729,10.1463762,9.3553911,1.8,10.1269291,9.3485615,0.4258309,2.6166254,3.0290559,35.2694759,46.828005,0.4176011,15.4596041,13.4789931,26.4701722,5.2647928,6.1406957,2.224101,19.551559),(32195,'Bettongia_penicillata_tibia.tif',228,8,150,14.9823832,10.1226452,9.336954,1.8,10.103312,9.3277518,0.3953689,2.6563907,3.0671153,35.9758699,49.3606238,0.3704132,16.0935012,13.5431398,27.6978225,5.3089296,6.2192754,2.6692873,19.6427451),(32196,'Bettongia_penicillata_tibia.tif',228,8,151,14.8360037,10.017354,9.3030207,1.8,10.0001186,9.2941462,0.4027352,2.6284306,3.0554694,36.2164295,48.4769602,0.3798362,15.8656342,13.7787279,27.3248559,5.3057812,6.2052746,2.4592761,19.5576094),(32197,'Bettongia_penicillata_tibia.tif',228,8,152,15.0618266,9.9781279,9.2656761,1.8,9.9591621,9.2581887,0.3455437,2.6369368,3.0904103,37.0568857,50.3160009,0.2879904,16.2813335,14.0530051,28.077614,5.3307646,6.2738112,2.6951107,19.7570947),(32198,'Bettongia_penicillata_tibia.tif',228,8,153,14.67721,9.8288551,9.2140047,1.8,9.8092061,9.2037059,0.350241,2.6675021,3.0597368,37.1193383,47.504938,0.2880016,15.5258251,13.9153921,27.4753915,5.3691842,6.1680775,2.7085032,19.5868234),(32199,'Bettongia_penicillata_tibia.tif',228,8,154,14.9070333,9.7956648,9.2037153,1.8,9.7678097,9.1977129,0.3319057,2.6817219,3.0874869,38.1320361,50.1934111,0.2637928,16.2570444,14.2192358,28.3613625,5.4005354,6.2738112,2.6951107,19.8422304),(32200,'Bettongia_penicillata_tibia.tif',228,8,155,15.0316916,9.7251059,9.1811526,1.8,9.6980317,9.1718954,0.3065291,2.7169016,3.158919,39.0404087,52.0433191,0.2281156,16.4750406,14.36946,28.7605639,5.4625561,6.3874448,2.7243253,19.9772374),(32201,'Bettongia_penicillata_tibia.tif',228,8,156,15.3495459,9.6735262,9.1635947,1.8,9.6428448,9.1498983,0.2864536,2.7557682,3.2144261,40.2589428,55.6410659,0.2042403,17.3097978,14.6089731,29.7704668,5.5026803,6.4976976,2.7318347,20.1681661),(32202,'Bettongia_penicillata_tibia.tif',228,8,157,15.3202419,9.5411639,9.1143514,1.8,9.5104213,9.099864,0.2658118,2.8301102,3.2176314,41.3946099,56.482066,0.1762017,17.5539269,14.6265012,30.1000082,5.6148628,6.5294115,2.7439647,20.4734444),(32203,'Bettongia_penicillata_tibia.tif',228,8,158,15.6765232,9.4807872,9.0806136,1.8,9.4510455,9.0659346,0.2653759,2.8826108,3.2848363,43.4842684,60.6944728,0.1797225,18.4771684,15.0850294,31.3739122,5.6924009,6.6563896,2.7224501,21.1338723),(32204,'Bettongia_penicillata_tibia.tif',228,8,159,15.6132815,9.3330934,9.0508235,1.8,9.3047278,9.037667,0.3235691,2.9108133,3.3807913,45.2225491,62.1231693,0.2630675,18.3753337,15.5360526,31.4877009,5.7961812,6.760919,2.7098068,21.3162445),(32205,'Bettongia_penicillata_tibia.tif',228,8,160,15.6973277,9.2449838,9.015565,1.8,9.219742,9.0027719,0.3322479,2.9343425,3.4792014,47.4112159,66.3463776,0.2783295,19.0694272,16.1573556,32.4698667,5.9148397,6.925356,2.7207205,21.6713941),(32206,'Bettongia_penicillata_tibia.tif',228,8,161,15.4172148,9.070177,8.9440691,1.8,9.0482161,8.9318187,0.3478574,3.0026565,3.5606485,50.0271719,66.6381557,0.2985855,18.715174,16.6609704,32.5405979,6.0578105,6.9816436,2.6277941,21.8124515),(32207,'Bettongia_penicillata_tibia.tif',228,8,162,15.4766956,8.9723646,8.9088423,1.8,8.96243,8.9005825,0.3786532,3.0739073,3.6752193,52.6395844,71.7699897,0.3524959,19.5280838,17.1246492,33.7334108,6.1660191,7.1645595,2.7080112,22.7927647),(32208,'Bettongia_penicillata_tibia.tif',228,8,163,15.4962655,8.7969182,8.8243904,1.8,8.762652,8.818697,0.3811121,3.1343915,3.7695227,56.0988467,75.0294035,0.3573155,19.9042182,17.8978431,34.7362644,6.3004775,7.3142388,0.0906599,23.0250082),(32209,'Bettongia_penicillata_tibia.tif',228,8,164,15.7546169,8.6018238,8.7499786,1.8,8.5873378,8.7355516,0.4702556,3.2423334,3.9283457,60.0571194,80.3375532,0.5391032,20.4507339,18.5228084,35.7159753,6.3812095,7.4475461,2.7866063,23.5358222),(32210,'Bettongia_penicillata_tibia.tif',228,8,165,16.3637986,8.4639843,8.6795554,1.8,8.4493614,8.6363898,0.4931192,3.3176231,3.9752675,65.4065534,89.1776438,0.611146,22.4331175,19.7148835,38.885388,6.5298554,7.599759,2.852412,24.2667788),(32211,'Bettongia_penicillata_tibia.tif',228,8,166,17.0951262,8.2940443,8.6451717,1.8,8.3113335,8.5787497,0.531544,3.3739281,4.171635,70.8328818,100.7491145,0.7319907,24.1509898,20.9941885,40.939361,6.6878117,7.9793967,2.2867874,25.0597076),(32212,'Bettongia_penicillata_tibia.tif',228,8,167,18.4202618,8.1268679,8.5345853,1.8,8.1665288,8.4775915,0.5479346,3.4356928,4.37627,79.1464253,117.5625008,0.8330967,26.8636306,23.0365259,44.7972269,6.8265277,8.2796349,2.2841544,26.0521216),(32213,'Bettongia_penicillata_tibia.tif',228,8,168,19.5027612,7.9433044,8.4394023,1.8,8.0134951,8.3639707,0.5848762,3.5301881,4.6032395,84.6672419,136.0565764,0.9907732,29.5567013,23.9837761,47.7661483,6.9906064,8.8614736,2.2115801,27.5346923),(32214,'Bettongia_penicillata_tibia.tif',228,8,169,21.1293843,7.9077468,8.4238023,1.8,8.0079386,8.3919393,0.5412656,3.579332,4.6612203,96.688445,149.5076736,0.9348089,32.0747925,27.0129862,52.0843958,7.1722919,9.0358184,2.1329267,29.725056),(32215,'Bettongia_penicillata_tibia.tif',228,8,170,22.5791816,7.8668409,8.3855199,1.8,7.9440772,8.3418953,0.5486999,3.6582094,4.9045683,101.315755,164.7748272,1.0237555,33.596194,27.6954496,51.4602741,7.2700621,9.4883307,2.446042,29.604656),(32216,'Bettongia_penicillata_tibia.tif',228,8,171,29.3764726,7.7528832,8.4725322,1.8,7.781108,8.4417215,0.5212412,3.7082039,4.950975,115.8266804,186.9594702,1.2140371,37.7621518,31.2352509,57.377963,7.1357701,9.7063993,2.5191802,28.973442),(32217,'Bettongia_penicillata_tibia.tif',228,8,172,29.9354909,7.7382052,8.5621692,1.8,7.8079807,8.6035807,0.574788,3.5973069,5.2343046,108.0099356,216.1302883,1.4746361,41.291118,30.025221,58.459655,6.8924918,10.3991046,2.4053352,31.6247484),(32218,'Bettongia_penicillata_tibia.tif',228,8,173,33.9733683,7.578633,8.7665104,1.8,7.5487153,8.7255555,0.57384,3.5938973,5.3487649,100.5352014,246.2223277,1.6686472,46.0334919,27.9738659,64.5765758,6.7035951,10.3886444,2.5793079,32.4055764),(32219,'Bettongia_penicillata_tibia.tif',228,8,174,38.1046687,7.0997852,8.7821217,1.8,7.1174646,8.7295427,0.6046948,3.5488553,5.6373,96.7828403,268.6873226,2.0526019,47.662413,27.2715654,63.4956537,6.5430179,10.9466391,2.3911996,32.129512),(32220,'Bettongia_penicillata_tibia.tif',228,8,175,30.2224462,6.5983866,8.6489345,1.8,6.5873692,8.5607729,0.6736507,3.534453,6.3386426,68.8882219,202.8169644,1.9603312,31.996908,19.4904904,42.6303668,6.2321595,11.1954209,2.3599968,33.4468237),(32221,'Bettongia_penicillata_tibia.tif',228,8,176,11.8414025,5.3870169,8.4217051,1.8,5.5377031,8.461899,0.784061,3.8051016,6.4973716,14.8556239,78.5495169,0.9841447,12.0894297,3.9041333,14.3300879,3.6896215,7.2991111,2.0049322,22.5932794),(32222,'Bettongia_penicillata_tibia.tif',228,8,177,5.0406326,4.1361233,7.4256795,1.8,4.0770524,7.3612903,-1.5329093,1.3393774,2.6777536,0.9856072,8.0569283,0.8389001,3.0088386,0.7358697,3.3711097,2.2936614,5.0743285,1.6539376,16.7677518),(32223,'Bettongia_penicillata_tibia.tif',228,8,178,44.7869316,8.0858573,9.9603149,1.8,8.1470504,9.8811718,0.6947597,4.8724904,5.9979633,158.8786066,371.0871352,3.059374,61.8688577,32.6072691,85.090464,6.7091267,11.2535374,2.5580411,37.6512294),(32224,'Bettongia_penicillata_tibia.tif',228,8,179,31.1617704,9.0368698,9.2295284,1.8,8.917112,9.0708404,0.7934975,3.2870286,5.8419813,61.3365851,255.9466795,2.6388774,43.8116222,18.6601919,50.5119957,5.8724834,10.873561,2.4149503,42.7508128),(32225,'Bettongia_penicillata_tibia.tif',228,8,180,19.9629326,9.5991638,8.4733215,1.8,9.6870494,8.5256877,0.7943395,2.4381269,5.4923591,17.2693238,130.3502211,1.6933253,23.7330116,7.0830292,26.3237953,3.9560039,10.9093308,2.3093538,29.9965381),(32226,'Bettongia_penicillata_tibia.tif',228,8,181,6.2516209,11.0520307,8.1698679,1.8,11.0198637,8.1159807,0.8715112,1.0927717,3.8345201,1.2881096,18.4386614,0.6102498,4.8085969,1.1787545,5.0333506,1.9326162,7.7548264,2.3122667,17.6362216),(32227,'humerus.tif',228,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32228,'humerus.tif',228,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32229,'humerus.tif',228,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32230,'humerus.tif',228,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32231,'humerus.tif',228,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32232,'humerus.tif',228,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32233,'humerus.tif',228,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32234,'humerus.tif',228,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32235,'humerus.tif',228,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32236,'humerus.tif',228,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32237,'humerus.tif',228,2,11,2.6042307,7.473756,10.594337,1.8,7.4555799,10.6035199,1.0592855,0.9321283,1.303061,0.5310036,1.0724472,0.3300404,0.8230215,0.569668,1.1764901,1.8270606,2.5520928,2.1634937,7.3660177),(32238,'humerus.tif',228,2,12,3.9648284,7.7176454,10.3871478,1.8,7.7490925,10.3760347,-1.2556898,1.9709713,4.6469031,3.1681268,6.8189281,0.5973351,1.4674135,1.6073937,2.0883919,2.7459637,3.8566738,2.4196014,11.3082266),(32239,'humerus.tif',228,2,13,8.2180534,8.468438,9.1767605,1.8,8.3592961,9.3530469,-1.0457416,2.4065166,3.7960092,7.696382,42.5380251,1.0255282,11.2059859,3.1981421,13.0004108,3.8457807,4.3273378,2.5840515,14.5697175),(32240,'humerus.tif',228,2,14,10.1664568,8.4212874,9.1717583,1.8,8.3920945,9.2102139,-1.0272682,2.5404056,4.0220744,11.2805759,51.0856751,1.2412341,12.7013254,4.4404625,15.1162259,4.6122157,7.9848747,1.3415644,24.7739098),(32241,'humerus.tif',228,2,15,10.7095275,8.4229962,9.1304414,1.8,8.4292256,9.1181685,-1.0338655,2.6062829,5.2883934,14.5278517,64.9425434,1.3179263,12.2802029,5.5741654,15.0259788,4.73029,8.560252,1.1771698,25.0837217),(32242,'humerus.tif',228,2,16,10.7679282,8.4477679,9.0391637,1.8,8.4896128,8.9700593,-1.0407647,2.602787,5.1810699,16.2681049,79.5791726,1.3359561,15.3596022,6.2502636,18.4869423,4.7093093,9.1974414,1.1239539,25.9983337),(32243,'humerus.tif',228,2,17,10.6358188,8.6120804,8.7829545,1.8,8.625644,8.757661,-1.0087298,2.4202876,5.2416717,14.7479442,98.8488624,1.269171,18.8582704,6.0934676,21.6708018,4.4662972,10.2748819,0.9466368,28.0990381),(32244,'humerus.tif',228,2,18,10.7921851,8.6521387,8.6830353,1.8,8.6531316,8.6810912,-0.9651266,2.1440874,5.3289801,12.011945,104.8050393,1.215709,19.6669977,5.6023579,21.9081019,4.2027683,10.5320325,0.887087,28.1688157),(32245,'humerus.tif',228,2,19,9.1640908,8.6564995,8.2700738,1.8,8.7014332,8.2668208,-0.8820976,1.8583221,5.4217152,7.0706126,99.3455596,0.9104489,18.3236403,3.8048371,19.5741813,3.6966884,10.6192068,0.8458432,29.7214724),(32246,'humerus.tif',228,2,20,7.8799741,8.7026134,8.1100497,1.8,8.7704394,8.1048349,-0.8521771,1.7702256,5.5970802,5.4808942,97.9731103,0.7441067,17.504325,3.0961557,18.4340519,3.3510024,10.6609514,0.7825328,30.2792573),(32247,'humerus.tif',228,2,21,7.5724324,8.5967952,8.1819008,1.8,8.6912869,8.1377435,-0.8294123,1.7454216,5.4778335,5.1569894,91.7084267,0.6865134,16.7417331,2.954581,17.6444739,3.3371141,10.5126116,0.7563366,28.7790111),(32248,'humerus.tif',228,2,22,7.909982,8.5559125,8.2612229,1.8,8.6203891,8.252949,-0.8157916,1.6922022,5.3921116,5.2959032,82.2490769,0.6992091,15.2535933,3.1295923,16.162367,3.2685304,10.3364521,0.7380962,27.3713051),(32249,'humerus.tif',228,2,23,7.915424,8.5915437,8.1854494,1.8,8.5666889,8.2575749,-0.7779516,1.5904847,5.4837129,5.194581,75.0329264,0.6497952,13.6828692,3.2660364,14.5792022,3.1463424,10.0508493,0.7062953,26.0124126),(32250,'humerus.tif',228,2,24,8.0501235,8.4856472,8.2876116,1.8,8.4442083,8.3315928,-0.7417346,1.528617,5.3814867,4.9472519,67.2519846,0.6123352,12.4969155,3.2364235,13.3963944,3.0801707,9.8237978,0.6857295,24.6997903),(32251,'humerus.tif',228,2,25,8.3787627,8.5603098,8.3209601,1.8,8.4774115,8.3723919,-0.7032194,1.5346401,5.434189,5.271796,63.0711648,0.5839868,11.606362,3.4352002,12.5597001,3.0537609,9.5732604,0.638086,24.1604261),(32252,'humerus.tif',228,2,26,8.8296047,8.6148135,8.3243699,1.8,8.4687193,8.416857,-0.6734673,1.5930208,5.4874435,5.6908595,59.5211239,0.5724552,10.8467857,3.5723699,11.8746103,3.0678433,9.3007504,0.6137701,24.0425799),(32253,'humerus.tif',228,2,27,8.5232964,8.3994698,8.5942719,1.8,8.2767655,8.6496531,-0.6244504,1.6342532,5.1532847,5.9889985,50.2064724,0.4855685,9.7426157,3.66467,10.8968945,3.122812,8.9757293,0.5693132,24.3314277),(32254,'humerus.tif',228,2,28,8.2124167,8.2014741,8.8606752,1.8,8.0665041,8.9200085,-0.5688466,1.641617,4.8691756,6.2433421,41.1737626,0.397146,8.4560027,3.8031662,9.7382031,2.9773124,7.5674021,0.7086263,18.1157144),(32255,'humerus.tif',228,2,29,8.5151874,8.1626983,9.0155405,1.8,8.0481506,9.0768928,-0.4999307,1.7450542,4.7452174,6.8478297,37.0840823,0.3261183,7.8150438,3.9241359,9.2546436,3.2150328,8.3214684,0.5217218,22.4096635),(32256,'humerus.tif',228,2,30,9.0161455,8.0222463,9.1448167,1.8,7.9165538,9.1925476,-0.4577402,1.747336,4.5529362,7.1683204,35.2419043,0.2934682,7.7404785,4.1024281,9.298927,3.2504562,7.9998189,0.4829689,20.9094173),(32257,'humerus.tif',228,2,31,9.6787212,7.8631673,9.3072737,1.8,7.7691294,9.3384437,-0.4369111,1.750362,4.3718794,7.4451378,33.6332406,0.2888288,7.6930851,4.2534847,9.3681002,3.2812031,7.7100806,0.483695,20.4878993),(32258,'humerus.tif',228,2,32,9.5769956,7.7377552,9.4451998,1.8,7.6525514,9.4704396,-0.4103167,1.7685238,4.2051293,7.5310239,32.7214377,0.2539835,7.7813155,4.2583672,9.5181145,3.3255112,7.4199695,0.4454205,18.0712427),(32259,'humerus.tif',228,2,33,9.6811163,7.620052,9.5668599,1.8,7.5686837,9.5809667,-0.39296,1.7776377,4.0413838,7.6927497,32.1441182,0.2365922,7.9537406,4.3275127,9.7830891,3.394495,7.1147659,0.4256225,17.8225248),(32260,'humerus.tif',228,2,34,9.9674143,7.5498676,9.6547058,1.8,7.4953677,9.6787515,-0.3765575,1.8199911,3.9432968,8.152305,29.79641,0.2246306,7.556218,4.4793104,9.4960614,3.4734041,6.8611883,0.435486,17.7108188),(32261,'humerus.tif',228,2,35,10.5014147,7.4923007,9.7822234,1.8,7.4385145,9.8068948,-0.3729364,1.8417587,3.8794916,8.7135473,28.6224632,0.2323474,7.3778902,4.7311013,9.4558323,3.5599847,6.6659714,0.4491559,17.9848427),(32262,'humerus.tif',228,2,36,9.8078384,7.4688192,9.8715701,1.8,7.4290217,9.8937071,-0.373757,1.9038847,3.8413839,8.9510737,25.0510963,0.2179129,6.5213727,4.701479,8.6873743,3.6548948,5.2714622,0.2231134,14.3567876),(32263,'humerus.tif',228,2,37,9.4548409,7.5610919,9.9297098,1.8,7.5284963,9.9508821,-0.3180977,1.9441904,3.8520983,9.2800951,19.70078,0.1541438,5.1142983,4.7732438,7.2990156,3.7392484,4.8299069,0.1798535,13.7668115),(32264,'humerus.tif',228,2,38,9.0903307,7.6163798,10.0102279,1.8,7.5877912,10.0309754,-0.2676263,1.9865421,3.772263,9.4915378,16.5328579,0.105948,4.3827426,4.7779193,6.5922685,3.7096074,4.5456583,0.1526493,13.4107294),(32265,'humerus.tif',228,2,39,8.8225774,7.7041091,10.1034053,1.8,7.6823212,10.1192288,-0.0438611,1.9475541,3.3762243,9.5421828,13.1748268,0.002827,3.9022369,4.8995726,5.9881277,3.6896169,4.3683297,2.9927027,13.2021414),(32266,'humerus.tif',228,2,40,8.7150093,7.7853853,10.1999083,1.8,7.7906794,10.2032492,0.4512619,1.9167082,2.1791563,8.8126698,11.4628704,0.2762432,5.2602333,4.5978149,9.0509947,3.6505374,4.2547066,2.9163159,13.1052593),(32267,'humerus.tif',228,2,41,8.5561305,7.8086913,10.3444111,1.8,7.8141486,10.3463365,0.6573381,1.8865723,2.0968857,8.5192914,11.2687841,0.5323845,5.3740574,4.5157513,9.0441291,3.6045476,4.2338204,2.5082953,13.0083772),(32268,'humerus.tif',228,2,42,8.4412696,7.8226081,10.4848536,1.8,7.8293577,10.4879323,0.8162293,1.8578598,2.1851176,8.17647,11.3014443,0.7467873,5.1720073,4.4010155,8.7852564,3.5434535,4.2835583,2.4132753,12.9621071),(32269,'humerus.tif',228,2,43,8.3838043,7.8678993,10.6536654,1.8,7.8704339,10.6546252,0.9400197,1.8342798,2.2426187,7.9261898,11.6211836,0.9112761,5.1819704,4.3211454,8.6610435,3.5434535,4.3531369,2.2718878,13.012719),(32270,'humerus.tif',228,2,44,8.4652492,7.8962637,10.8058703,1.8,7.90422,10.8144909,1.0007399,1.8071072,2.3286533,7.7068663,12.1321773,0.9999519,5.2099542,4.2647532,8.4886477,3.5169596,4.4529541,2.2531129,13.088637),(32271,'humerus.tif',228,2,45,8.3982047,7.9355998,10.9877632,1.8,7.9426849,10.9913596,1.0557475,1.7964599,2.4052441,7.4806402,12.7639479,1.060088,5.3067162,4.1641009,8.4088118,3.4780791,4.571246,2.1063536,13.2003429),(32272,'humerus.tif',228,2,46,8.3866551,7.9895661,11.1801184,1.8,7.9962842,11.1899351,1.0921841,1.7454069,2.4817516,7.2631544,13.5929511,1.1013016,5.4771602,4.1612958,8.3994832,3.4264465,4.7121676,2.1206495,13.3120489),(32273,'humerus.tif',228,2,47,8.4841516,8.0450882,11.3712521,1.8,8.0517851,11.3842618,1.1153068,1.7119186,2.5958332,7.1970193,14.8148122,1.140392,5.707151,4.2040663,8.4756594,3.4018603,4.8976303,2.0976009,13.607037),(32274,'humerus.tif',228,2,48,8.5422196,8.1147139,11.6053118,1.8,8.1245414,11.6188364,1.1254261,1.6902051,2.7230055,7.1144402,16.4204656,1.1594899,6.0302727,4.2092172,8.6416681,3.3746003,5.1278964,2.0909874,13.963119),(32275,'humerus.tif',228,2,49,8.7554812,8.1948234,11.8616519,1.8,8.2073365,11.8810953,1.1302345,1.6854833,2.8663494,7.0738775,18.6877124,1.1938717,6.519691,4.196943,8.9764619,3.3607377,5.4103581,2.0165887,14.4160832),(32276,'humerus.tif',228,2,50,9.0147176,8.2889775,12.1546971,1.8,8.3147889,12.2052492,1.1395608,1.6669115,3.3163058,7.0632298,22.9995862,1.2399465,6.9353031,4.2373155,9.0615653,3.3607377,6.0314689,1.9992021,15.4337175),(32277,'humerus.tif',228,2,51,9.7302458,8.4418614,12.5780353,1.8,8.4822596,12.6870304,1.1531737,1.6655946,3.9036063,7.2082498,32.4734381,1.3549333,8.3188303,4.3277337,10.1463475,3.3607377,6.9396199,2.0010302,17.4017518),(32278,'humerus.tif',228,2,52,9.8251267,8.5259549,12.8129048,1.8,8.5903427,12.9611335,1.1434399,1.6741558,4.1351645,7.4976889,36.9293405,1.3562237,8.9305613,4.4784893,10.7258256,3.3812616,7.2947905,1.9787985,18.3582921),(32279,'humerus.tif',228,2,53,10.0345404,8.6127585,13.0377314,1.8,8.6903006,13.1796509,1.1331427,1.70321,4.1218086,7.8935959,39.8138679,1.3720236,9.6593199,4.6345405,11.5631885,3.415723,7.4058712,2.0761951,18.9439263),(32280,'humerus.tif',228,2,54,9.4068255,8.6259444,13.0797743,1.8,8.7250589,13.2487048,1.1105714,1.7238306,4.188921,8.217226,36.5493085,1.2585253,8.7252322,4.7668408,10.6710052,3.4586936,7.4236156,2.1152078,19.3253144),(32281,'humerus.tif',228,2,55,8.9603129,8.6105931,13.1186313,1.8,8.7039788,13.2777343,1.110028,1.75574,4.2382067,8.4412203,34.341919,1.1981409,8.1029364,4.807785,10.0787127,3.4974645,7.3805023,2.0449148,19.4894308),(32282,'humerus.tif',228,2,56,9.0213208,8.6441046,13.2711061,1.8,8.7305348,13.4291571,1.1263077,1.8110077,4.1488844,8.6685943,35.1996878,1.2255513,8.4841331,4.7866138,10.5599778,3.5795933,7.3264449,2.0687313,24.17525),(32283,'humerus.tif',228,2,57,8.4099343,8.5887041,13.2413983,1.8,8.6779855,13.4106332,1.1373377,1.8372703,4.2040947,8.8228755,31.6811819,1.1543894,7.5357917,4.8021651,9.620892,3.6205609,7.2271935,2.055831,21.8598173),(32284,'humerus.tif',228,2,58,8.3732938,8.638038,13.3595568,1.8,8.7249623,13.529072,1.1412002,1.8730725,4.0655398,9.045758,32.2022019,1.1534556,7.9207691,4.8293689,10.0882058,3.6616836,7.1147659,1.9964188,27.9699648),(32285,'humerus.tif',228,2,59,8.1008479,8.6308581,13.3801363,1.8,8.7253179,13.5550223,1.142251,1.8900863,3.9930144,9.2748025,30.6399951,1.1169986,7.6733995,4.9070789,9.9368652,3.7160485,6.9611006,1.9928014,19.9825248),(32286,'humerus.tif',228,2,60,7.9854916,8.6025129,13.3739155,1.8,8.6916178,13.5438346,1.1458142,1.912406,3.9762769,9.6295894,28.9850669,1.1046663,7.2894992,5.035327,9.6418195,3.7570161,6.8430764,2.0005586,18.4298682),(32287,'humerus.tif',228,2,61,7.9854486,8.5892439,13.4627724,1.8,8.6559627,13.6144201,1.1655629,1.9354276,3.8120796,9.8240329,27.5498348,1.1240585,7.2269832,5.075898,9.7514191,3.8009431,6.6680708,2.0054665,17.9664219),(32288,'humerus.tif',228,2,62,7.8514346,8.5734106,13.4594467,1.8,8.6316599,13.6012575,1.1917763,1.9465472,3.7008769,10.2108015,26.1023888,1.129419,7.0530282,5.2455968,9.7544224,3.8526588,6.4611085,1.9835896,17.6967398),(32289,'humerus.tif',228,2,63,7.7997153,8.5545866,13.4743837,1.8,8.5979116,13.5988674,1.2235665,1.9815754,3.5618984,10.7544992,25.2538132,1.1494178,7.0899869,5.4272471,10.0674074,3.9123496,6.2411667,1.9538734,17.4165757),(32290,'humerus.tif',228,2,64,7.6017151,8.5005163,13.4464297,1.8,8.5372013,13.5408754,1.2577946,2.0245784,3.4521751,11.2151745,23.1049155,1.14683,6.6928574,5.5395111,9.8817796,3.9793864,6.0203196,1.4989776,17.1678578),(32291,'humerus.tif',228,2,65,7.9884776,8.5108506,13.4832686,1.8,8.5366626,13.5498263,1.3030792,2.0210132,3.2683285,12.1945121,22.7140302,1.2382454,6.9497389,6.0338606,10.6317047,4.0314757,5.8351992,1.4446048,16.8012936),(32292,'humerus.tif',228,2,66,8.0798451,8.4568688,13.5165466,1.8,8.4797563,13.5982505,1.2726512,2.0630092,3.095253,12.466,20.9568019,1.2304423,6.7706265,6.0426294,10.6410984,4.0767548,5.5779883,1.8533513,16.4705175),(32293,'humerus.tif',228,2,67,7.6183837,8.4303411,13.5465658,1.8,8.4646051,13.6206672,1.3066764,2.0936205,2.9497692,12.6071706,20.5354874,1.1831956,6.9617269,6.0217076,11.0242039,4.1690999,5.431015,1.3624808,16.4199055),(32294,'humerus.tif',228,2,68,7.353696,8.3676743,13.4824469,1.8,8.397376,13.5306144,1.3693159,2.1267299,2.9364548,13.158369,19.311445,1.1765325,6.576449,6.1871368,10.9017034,4.261445,5.3423224,1.2669467,16.3483294),(32295,'humerus.tif',228,2,69,7.4597498,8.3723254,13.4930772,1.8,8.4052489,13.5379329,1.392388,2.180982,2.8355181,14.4906181,18.6126561,1.2041363,6.5641111,6.6440797,11.4655652,4.3862538,5.3106138,1.1872688,16.4495533),(32296,'humerus.tif',228,2,70,7.5033909,8.3504914,13.5141723,1.8,8.4044047,13.5601225,1.4552053,2.3177102,2.7802058,15.6590053,18.265476,1.2339303,6.5698287,6.7562396,11.993615,4.5184425,5.3381288,1.1542154,16.6223533),(32297,'humerus.tif',228,2,71,7.2999647,8.2768885,13.5209992,1.8,8.3334143,13.5506964,-1.4907804,2.6410205,2.7896832,16.4265016,17.7709386,1.2088877,6.3702355,6.2197554,12.2053918,4.6718779,5.4337633,1.06447,16.9426474),(32298,'humerus.tif',228,2,72,6.9826767,8.1912131,13.5132614,1.8,8.2507405,13.5314522,-0.8018058,2.7797539,2.8186356,16.6872515,17.6755686,0.6009812,6.2709663,6.0031398,11.917882,4.8227937,5.5499812,1.0130221,17.2376354),(32299,'humerus.tif',228,2,73,7.1378892,8.194331,13.4477263,1.8,8.2543842,13.4417639,-0.5472578,2.6023446,2.8068512,16.9522819,19.7079828,0.3221109,7.0213849,6.514234,12.6118926,4.8296031,5.7158025,0.9681197,17.6085414),(32300,'humerus.tif',228,2,74,7.1515332,8.0563081,13.438083,1.8,8.141624,13.439969,-0.6034003,2.7211819,3.0192802,17.5850526,20.8861107,0.3837924,6.9175795,6.4622848,12.572549,4.8977577,5.9672322,0.9707461,18.3460115),(32301,'humerus.tif',228,2,75,7.1957081,7.8954588,13.4147577,1.8,7.9791085,13.4265672,-0.667368,2.8943936,3.2467395,17.5949896,23.6555826,0.4594016,7.2859503,6.0789899,12.7033664,5.008435,6.290015,0.9218008,19.5111399),(32302,'humerus.tif',228,2,76,7.3866459,7.8216481,13.3944585,1.8,7.8875134,13.3926765,-0.6690232,3.092608,3.41901,19.2556681,26.7864073,0.4735737,7.8345507,6.2263527,11.1888872,5.2154346,6.6771606,0.8586613,20.33501),(32303,'humerus.tif',228,2,77,8.1820088,7.6544946,13.3049814,1.8,7.6235359,13.3473784,-0.6517553,3.1250703,3.6325023,24.3437133,32.4472602,0.5017518,8.9324816,7.7898131,14.5045702,0.5344671,1.4914953,1.3961241,3.5398566),(32304,'humerus.tif',228,2,78,8.496356,7.4659085,12.9679656,1.8,7.4053933,12.995161,-0.5610817,3.6350072,3.8378835,32.6408167,35.145984,0.4009331,9.1576475,8.9795741,17.2329907,6.2578568,7.684866,0.7177724,25.7687814),(32305,'humerus.tif',228,2,79,9.5365875,7.0593469,12.7131765,1.8,7.0021276,12.7650191,1.1165221,4.0662896,3.6958529,40.5897368,48.0158477,1.2833792,12.991818,9.9820084,20.4796538,6.6844333,8.0645272,0.8726287,29.0599202),(32306,'humerus.tif',228,2,80,10.0563159,6.8833798,12.550767,1.8,6.8561962,12.6026801,1.3292607,4.2332604,3.9477152,46.4217536,56.7327975,1.5801594,14.3710463,10.9659575,22.6473984,7.1026374,8.5820256,0.9031307,29.8201529),(32307,'humerus.tif',228,2,81,10.9992621,6.8168995,12.4278567,1.8,6.8131889,12.4465818,-1.4755968,4.1410065,4.4589576,53.039997,64.3997626,1.8166462,14.4427843,12.8084795,25.2460186,7.4304,8.7183766,0.9154028,29.1925903),(32308,'humerus.tif',228,2,82,12.1262692,6.8150143,12.305024,1.8,6.8302492,12.316247,-1.3554337,4.2610621,4.5821602,58.5799305,72.200388,1.928747,15.7568449,13.7477298,28.0984242,7.5615355,8.800191,0.8722869,28.6130963),(32309,'humerus.tif',228,2,83,12.7553037,6.9800631,12.3194585,1.8,7.0191016,12.3468103,-1.1312683,4.2829586,4.420936,62.2875661,75.4722278,1.7409698,17.0715494,14.5431164,30.0466847,7.5517972,8.6807281,0.7502014,28.3076261),(32310,'humerus.tif',228,2,84,13.0001195,7.0079648,12.3184074,1.8,7.0565273,12.331543,-1.1684476,4.0585157,4.3492735,63.4489656,75.7954452,1.8344569,17.4271508,15.6335394,30.5273309,7.429157,8.6196721,1.0802494,29.4055202),(32311,'humerus.tif',228,2,85,13.3715487,7.2046309,12.3388768,1.8,7.2132272,12.3270192,-1.0976057,3.7005241,4.2762022,59.961441,77.677765,1.7657385,18.165129,16.2034998,31.5505856,7.180654,8.5849607,1.0666304,29.6202485),(32312,'humerus.tif',228,2,86,14.0790652,7.3130104,12.5846803,1.8,7.2975838,12.5394807,-1.2073389,3.6321143,4.1235542,56.2464265,76.8525695,2.0499451,18.6374582,15.4858635,31.1228138,6.806388,8.0524847,0.9262223,30.8970828),(32313,'humerus.tif',228,2,87,15.9075334,7.1947668,12.5726722,1.8,7.2115311,12.4682647,-1.0307418,3.2437411,4.1899186,43.5489004,74.1778141,1.9503063,17.7038796,13.4255165,27.4038952,6.1356817,8.0774759,1.1286765,26.8894381),(32314,'humerus.tif',228,2,88,12.9663143,7.3348928,12.3970398,1.8,7.4006299,12.3127492,-0.9446827,2.8582688,3.9319842,24.9093765,51.0495916,1.4189556,12.983163,8.7148474,18.9733601,5.3659019,7.6611519,1.1955255,26.0464022),(32315,'humerus.tif',228,2,89,7.2299668,6.8900234,12.4982727,1.8,7.129565,12.5049429,-1.3083604,2.6728978,4.2362096,7.8049039,14.8380154,1.1238912,3.5026631,2.9200158,5.2289725,3.018745,4.1223757,1.4763414,11.9846027),(32316,'humerus.tif',228,2,90,1.4179741,6.1616989,12.6059395,1.8,6.181994,12.5548035,-1.1083933,2.2229012,4.983717,1.6212353,4.3562041,0.1892983,0.8740874,0.729333,1.1980431,1.2107435,4.2172583,2.3272171,10.7724593),(32317,'humerus.tif',228,2,91,0.6404784,6.0601603,12.0642448,1.8,6.0727232,12.0604637,-1.0122543,1.2528324,4.472548,0.1442363,2.8805753,0.076767,0.6440569,0.1151281,0.6762743,0,0,0,0),(32318,'humerus.tif',228,2,92,0.0322764,7.980717,8.692303,1.8,7.9760348,8.6982261,-0.8972639,0.1186175,0.2825878,0.0000856,0.0008903,0.0032865,0.0031504,0.0007217,0.0032848,0.2608276,0.6139874,0.6857295,1.4705984),(32319,'humerus.tif',228,2,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32320,'humerus.tif',228,2,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32321,'humerus.tif',228,2,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32322,'humerus.tif',228,2,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32323,'humerus.tif',228,2,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32324,'humerus.tif',228,2,98,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32325,'Bettongia_penicillata_radius.tif',228,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32326,'Bettongia_penicillata_radius.tif',228,3,2,0.3145861,7.4647313,7.5311617,1.8,7.5021429,7.4874858,-1.3336649,0.4975938,0.65466,0.0110542,0.0259271,0.0495376,0.039604,0.0222152,0.0561402,0.9072,1.2705501,1.259798,4.6203834),(32327,'Bettongia_penicillata_radius.tif',228,3,3,1.8806411,7.2207572,7.4481318,1.8,7.20323,7.3911654,-1.5177082,1.1239069,1.7543966,0.3667012,1.973479,0.3125576,1.1248762,0.3262736,1.3309526,1.8590045,3.6495692,1.677532,12.0597757),(32328,'Bettongia_penicillata_radius.tif',228,3,4,3.2068244,6.5501317,7.5120539,1.8,6.6011682,7.4687596,-1.1968422,1.5587906,2.2789988,1.4797265,4.2949045,0.4631491,1.8845575,0.9492786,2.5254293,2.5708898,4.4319495,1.3944302,13.3199876),(32329,'Bettongia_penicillata_radius.tif',228,3,5,3.2228721,6.3633298,7.4052347,1.8,6.4110082,7.3601769,-1.0354553,1.8795241,2.402547,1.6990951,5.3064538,0.3973602,2.2086784,0.9040028,2.9113517,2.8726781,4.9454095,1.323699,14.7041861),(32330,'Bettongia_penicillata_radius.tif',228,3,6,3.141973,6.2986586,7.5009913,1.8,6.3182903,7.4875495,-0.7278343,2.0407934,2.1095203,1.9016588,4.1983584,0.2317536,1.9901958,0.9318233,2.822032,3.092848,4.8037546,1.3716371,14.5147637),(32331,'Bettongia_penicillata_radius.tif',228,3,7,3.2911985,6.2546302,7.5688836,1.8,6.2421577,7.5845597,-0.540479,1.7160269,1.9803733,1.5182854,4.172494,0.1452287,2.106923,0.8847678,2.7953227,3.1525348,4.6585948,1.2402483,14.5357279),(32332,'Bettongia_penicillata_radius.tif',228,3,8,3.0751213,6.2273841,7.475045,1.8,6.1893752,7.5069568,-0.4582275,1.6012866,1.9913884,1.1130958,3.7754642,0.1002908,1.8958954,0.6951259,2.3097455,2.958752,4.5614373,1.0774964,14.3943741),(32333,'Bettongia_penicillata_radius.tif',228,3,9,3.1441204,6.1808093,7.442639,1.8,6.1451767,7.466895,-0.5054089,1.3404352,2.0390546,0.9508383,3.9734181,0.1228387,1.948657,0.7093505,2.2722815,2.6775792,4.4696867,0.9988781,13.1891159),(32334,'Bettongia_penicillata_radius.tif',228,3,10,3.1093859,6.1635666,7.3963263,1.8,6.1325709,7.4344087,-0.5423559,1.2194706,2.1109081,0.8878917,4.6703563,0.1380651,2.2124868,0.728096,2.5047757,2.4984843,4.5015147,0.9215371,12.9848697),(32335,'Bettongia_penicillata_radius.tif',228,3,11,3.3529475,6.2156256,7.2874935,1.8,6.1817178,7.3152304,-0.5464361,1.1906087,2.2580973,0.9528828,5.7628833,0.1509003,2.552097,0.8003325,2.841218,2.4013737,4.6353017,0.8844111,13.519892),(32336,'Bettongia_penicillata_radius.tif',228,3,12,4.0232965,6.3529948,7.1445241,1.8,6.3018646,7.1796516,-0.5286384,1.227291,2.519315,1.277176,8.2318366,0.1705724,3.2674901,1.0406464,3.630158,2.4175262,4.8647497,0.8419416,14.0932458),(32337,'Bettongia_penicillata_radius.tif',228,3,13,4.6302924,6.53675,6.9545952,1.8,6.5166713,6.9758765,-0.5212427,1.3045362,2.8268946,1.9494114,11.5230524,0.1913563,4.0762229,1.4943329,4.5778296,2.6329452,5.2753551,0.551655,15.7489248),(32338,'Bettongia_penicillata_radius.tif',228,3,14,5.7785702,6.7260867,6.6751758,1.8,6.7190841,6.6799093,-0.5041229,1.6731473,3.1888753,3.7418902,16.6790885,0.2247164,5.2303985,2.236438,6.1222722,3.3581052,6.1106244,0.5840811,18.6988053),(32339,'Bettongia_penicillata_radius.tif',228,3,15,7.4519331,6.7671012,6.2313166,1.8,6.7563631,6.2186865,-0.5653594,2.4492863,3.5516538,10.3629156,20.3820612,0.3564448,5.7387523,4.230994,8.2618469,4.7855001,6.5437663,0.6118076,22.1287544),(32340,'Bettongia_penicillata_radius.tif',228,3,16,7.7213475,6.7109691,5.9960987,1.8,6.7096578,5.9735488,-0.792763,2.7165301,3.8994445,10.5642633,22.203809,0.6529231,5.6940954,3.8888814,8.3537815,4.7016746,6.6445196,0.6330984,22.0676604),(32341,'Bettongia_penicillata_radius.tif',228,3,17,7.0646833,6.6328548,6.0931363,1.8,6.6326627,6.0698586,-0.7818657,2.3031517,3.8022959,6.0854075,21.9637795,0.5845643,5.776452,2.6422088,7.3332641,4.0920899,6.5644103,1.0394059,20.46005),(32342,'Bettongia_penicillata_radius.tif',228,3,18,5.75843,6.1853498,6.6423633,1.8,6.2193414,6.5918619,-0.7031079,1.8810391,3.1406114,3.8380907,14.0394054,0.4012481,4.4702777,2.0404098,5.6457166,3.4803822,6.3611175,0.8334381,19.5541217),(32343,'Bettongia_penicillata_radius.tif',228,3,19,4.9445937,5.8888057,6.9825756,1.8,5.8843894,6.9843538,-0.6361174,1.7230302,2.7224227,2.9756694,10.4773259,0.2908469,3.8485301,1.7269978,4.9029871,3.1785502,4.9949738,0.705812,15.2941622),(32344,'Bettongia_penicillata_radius.tif',228,3,20,4.5778771,5.7699642,7.148301,1.8,5.7710086,7.1394257,-0.5629228,1.6912135,2.5490146,2.7564727,9.2778674,0.2172915,3.639786,1.6298786,4.6283936,3.1631677,4.7688574,0.7469556,15.0244801),(32345,'Bettongia_penicillata_radius.tif',228,3,21,4.9836054,5.7400792,7.1970609,1.8,5.7676154,7.1670462,-0.4888783,1.7917174,2.5440573,3.0777161,10.1046833,0.1831956,3.9718772,1.7177464,5.1164214,3.2341942,4.8124878,0.6452964,15.2941622),(32346,'Bettongia_penicillata_radius.tif',228,3,22,5.4167636,5.7858415,7.2076417,1.8,5.8428604,7.171793,-0.4177528,2.0146156,2.6141041,3.6339497,11.7968122,0.1485986,4.5127553,1.8037931,5.7712114,3.4230041,5.0026272,0.6383198,17.0492666),(32347,'Bettongia_penicillata_radius.tif',228,3,23,6.2636689,5.938797,7.1137995,1.8,5.969817,7.0705567,-0.3502996,2.4305681,2.8261262,5.0705111,15.3198381,0.1229474,5.4207905,2.0861424,6.8795755,3.9020691,5.3908339,0.1124271,18.3007949),(32348,'Bettongia_penicillata_radius.tif',228,3,24,7.4381734,6.241128,6.8927217,1.8,6.26488,6.8353551,-0.3601282,2.6751508,3.2374209,6.9594867,21.6262643,0.1539475,6.6800905,2.6015306,8.5655233,4.2049811,6.2035261,0.6421084,20.6162276),(32349,'Bettongia_penicillata_radius.tif',228,3,25,0.5059782,5.5104136,4.7712438,1.8,5.5422112,4.7712298,0.4892718,0.4469187,1.3499213,0.0136742,0.1901301,0.0186271,0.1408453,0.0305965,0.1433244,0.8648334,2.6081497,2.677945,6.7210878),(32350,'Bettongia_penicillata_radius.tif',228,3,26,3.1154022,6.0822075,4.1907605,1.8,6.0910519,4.2057052,0.4695467,1.6966243,1.8978417,1.2631154,4.1474667,0.1063079,2.1853597,0.7444874,2.4600278,2.8728224,3.8469837,2.7131064,14.729492),(32351,'Bettongia_penicillata_radius.tif',228,3,27,5.5125393,6.5454833,3.2732093,1.8,6.5138198,3.3946075,0.8208062,2.0401165,1.9840022,3.9695376,4.6436842,0.4918824,2.3405641,1.9457406,4.0480289,3.5562783,3.7242309,1.6404509,12.7972458),(32352,'Bettongia_penicillata_radius.tif',228,3,28,3.3056955,6.5363417,3.3261679,1.8,6.4752946,3.3873372,-0.964463,1.4529403,1.8547205,2.1383704,2.5549301,0.3720349,1.3775284,1.4717538,2.5054392,2.8795912,3.3131894,1.1830262,11.0316593),(32353,'Bettongia_penicillata_radius.tif',228,3,29,2.3426978,6.425655,3.3544066,1.8,6.3887563,3.4024979,-1.0406033,1.2921408,1.6614279,1.1708469,1.5590747,0.290599,0.9383944,0.9061295,1.6329589,2.4743081,3.0243086,1.1902899,9.495625),(32354,'Bettongia_penicillata_radius.tif',228,3,30,2.2003803,6.5075553,3.4908872,1.8,6.4759596,3.5548813,-1.2076472,1.2706287,1.5593683,1.0419452,1.5135006,0.3204557,0.9705857,0.8200233,1.6377614,2.4437611,2.9235901,1.2397003,9.0723086),(32355,'Bettongia_penicillata_radius.tif',228,3,31,2.3592884,6.596511,3.6124459,1.8,6.5745859,3.6693066,-1.2157267,1.2932296,1.4871773,1.2276648,1.570323,0.3456891,1.0559084,0.9493015,1.881342,2.5282616,2.8567582,1.2155655,9.0155564),(32356,'Bettongia_penicillata_radius.tif',228,3,32,2.6820228,6.7342923,3.7516197,1.8,6.7044517,3.7980216,-1.5497687,1.5066165,1.4806009,1.489993,1.8991709,0.4468062,1.2827028,0.9889663,2.2301209,2.6563142,2.9483802,1.3791478,9.6579429),(32357,'Bettongia_penicillata_radius.tif',228,3,33,2.9898904,6.8028852,3.8776864,1.8,6.7779332,3.9472008,1.4636943,1.4726182,2.0914822,1.7545542,2.5899401,0.4926208,1.2383276,1.1914522,2.0466648,2.6548816,3.2385597,1.7315591,10.3657653),(32358,'Bettongia_penicillata_radius.tif',228,3,34,3.2985375,6.8331771,3.9600684,1.8,6.8142019,4.0486106,1.4146295,1.4045273,1.9914326,1.9665607,3.4529513,0.5364574,1.7339031,1.4001584,2.6837587,2.6451583,3.660037,1.7728215,11.2044593),(32359,'Bettongia_penicillata_radius.tif',228,3,35,3.5026156,6.8647056,3.930716,1.8,6.8491621,4.0170087,1.3166688,1.3341602,2.2843555,2.0485665,3.9727911,0.5468736,1.73913,1.5354727,2.6307771,2.5822126,4.0080661,1.7004989,11.4025653),(32360,'Bettongia_penicillata_radius.tif',228,3,36,3.7196046,6.8607226,3.8491286,1.8,6.8578294,3.9246825,1.2399306,1.303356,2.1969946,2.021679,4.1624755,0.5545092,1.8946226,1.5511334,2.8115155,2.4828991,3.9503796,1.8025132,11.4235294),(32361,'Bettongia_penicillata_radius.tif',228,3,37,4.7536317,6.8643151,3.8773458,1.8,6.8599689,3.934929,1.2272298,1.2864258,1.9557164,1.9711347,4.8091067,0.7023759,2.4590001,1.5322568,3.4527969,2.3940778,3.842858,1.9387773,11.0613071),(32362,'Bettongia_penicillata_radius.tif',228,3,38,4.4075675,6.6954677,3.5787234,1.8,6.6946242,3.6061911,1.2988608,1.2593118,1.95175,1.5680199,3.5817888,0.681598,1.8351678,1.2451403,2.6221436,2.3345746,3.6676775,1.8329162,11.0211772),(32363,'Bettongia_penicillata_radius.tif',228,3,39,3.4807475,6.4731057,3.1864584,1.8,6.4673992,3.1998226,-1.3876821,1.2043142,2.6504006,1.2367616,1.9979322,0.560889,0.7538227,1.0269426,1.2028424,2.2464,2.8645868,1.1678847,9.2660728),(32364,'Bettongia_penicillata_radius.tif',228,3,40,3.3705361,6.3571331,3.0079206,1.8,6.3552616,3.0026051,-1.2463236,1.1202844,1.4994663,1.1132979,1.9241407,0.5046596,1.283217,0.9937637,2.0115279,2.2032,2.8879451,1.1875122,8.7606982),(32365,'Bettongia_penicillata_radius.tif',228,3,41,3.3472383,6.2529343,2.8576226,1.8,6.2540738,2.8552946,-1.2155571,1.1187075,1.5463674,1.0473196,1.9762017,0.4903843,1.2779639,0.9361872,1.9385156,2.1781365,2.9490131,1.0153026,8.7606982),(32366,'Bettongia_penicillata_radius.tif',228,3,42,3.3940004,6.1430366,2.7211713,1.8,6.1449966,2.7209695,-1.228126,1.1105996,1.5454835,1.0646919,2.0092365,0.5018039,1.3000699,0.958664,1.9692628,2.1887927,2.958175,1.0679531,9.1080967),(32367,'Bettongia_penicillata_radius.tif',228,3,43,3.5060045,6.0379724,2.5895674,1.8,6.038563,2.5919009,-1.2620007,1.0960052,1.5540644,1.1155785,2.1469415,0.5303637,1.381501,1.0178587,2.0532938,2.173019,3.0007679,1.0427219,9.0766504),(32368,'Bettongia_penicillata_radius.tif',228,3,44,3.6132612,5.9310566,2.4865378,1.8,5.93334,2.4890594,-1.3022501,1.0967838,1.5850786,1.1813214,2.337529,0.5598146,1.4747086,1.0770777,2.1977851,2.2054785,3.0644608,1.1955255,9.6832489),(32369,'Bettongia_penicillata_radius.tif',228,3,45,3.7585767,5.827871,2.3869279,1.8,5.8271119,2.3889305,-1.3448175,1.1158102,1.5979019,1.2289517,2.5377407,0.5949808,1.5881705,1.1013985,2.3038511,2.1948196,3.1450075,1.2055949,9.3000624),(32370,'Bettongia_penicillata_radius.tif',228,3,46,3.8898563,5.7324448,2.2996945,1.8,5.7311702,2.3081834,-1.3838928,1.1453744,1.6023857,1.2533153,2.7198065,0.6259245,1.6973482,1.0942407,2.4240269,2.201338,3.1865674,1.296221,9.4685206),(32371,'Bettongia_penicillata_radius.tif',228,3,47,3.9422493,5.6421529,2.2365142,1.8,5.6403829,2.243785,-1.4257022,1.1536082,1.6367483,1.264363,2.8702726,0.6433061,1.7536432,1.0960073,2.4576626,2.2032,3.2698148,1.3033855,9.5487803),(32372,'Bettongia_penicillata_radius.tif',228,3,48,3.9410662,5.543503,2.1708817,1.8,5.5431366,2.1822298,-1.4693697,1.1709648,1.6368677,1.2771991,2.9705677,0.6501103,1.8147879,1.0907237,2.5486041,2.2032,3.3221896,1.3478961,9.7844728),(32373,'Bettongia_penicillata_radius.tif',228,3,49,4.0509111,5.4543652,2.1264903,1.8,5.4581526,2.1400405,-1.5176695,1.1718303,1.6733392,1.3155324,3.1254264,0.673248,1.8677782,1.1226305,2.6027419,2.1979197,3.3734747,1.4035424,9.8961788),(32374,'Bettongia_penicillata_radius.tif',228,3,50,4.2608544,5.3719518,2.0831861,1.8,5.3711837,2.0948983,-1.5538512,1.1830085,1.7601538,1.3424127,3.2819339,0.7099385,1.8645723,1.1347448,2.6146137,2.2032,3.473237,1.4711277,10.1553788),(32375,'Bettongia_penicillata_radius.tif',228,3,51,4.1930239,5.3039952,2.0657923,1.8,5.3022368,2.0738138,1.5474572,1.1998506,1.8249601,1.3638474,3.5548338,0.6984567,1.9478967,1.136681,2.6914555,2.1978331,3.5983292,1.4866581,10.1510369),(32376,'Bettongia_penicillata_radius.tif',228,3,52,4.2343871,5.2217635,2.0494729,1.8,5.2210355,2.0505836,1.4981013,1.2058731,1.8560298,1.4040546,3.8028421,0.7020083,2.0489122,1.1643469,2.793219,2.2032,3.6760637,1.6178205,10.1405549),(32377,'Bettongia_penicillata_radius.tif',228,3,53,4.3184483,5.1532142,2.0317049,1.8,5.1538053,2.0270589,1.4662863,1.197184,1.923889,1.4324526,4.0596419,0.7119087,2.1101227,1.1965184,2.847865,2.2159376,3.8260667,1.6839473,10.5429071),(32378,'Bettongia_penicillata_radius.tif',228,3,54,4.4583217,5.0802249,2.0123968,1.8,5.0820122,2.0119767,1.4222109,1.2052916,2.0005148,1.4679887,4.3124961,0.7267691,2.1556932,1.2179531,2.8850414,2.2497802,3.977451,1.7234457,10.7113653),(32379,'Bettongia_penicillata_radius.tif',228,3,55,4.6357064,5.0170188,2.0115958,1.8,5.0193262,2.0080134,1.3870626,1.177728,2.0579967,1.4820333,4.4887045,0.7468278,2.1811039,1.2583833,2.898153,2.2399023,4.0766245,1.7952123,10.766319),(32380,'Bettongia_penicillata_radius.tif',228,3,56,4.6256526,4.9685706,2.0439323,1.8,4.9696308,2.0563317,1.3545265,1.1841882,2.0624637,1.4706054,4.5068794,0.7354418,2.1851922,1.2418679,2.8981811,2.2630276,4.0766245,1.7952123,10.8736832),(32381,'Bettongia_penicillata_radius.tif',228,3,57,4.7164201,4.9167509,2.0524941,1.8,4.916328,2.0661247,1.3232704,1.1590625,2.1073782,1.4470025,4.6480929,0.7388838,2.2056283,1.2484249,2.8918859,2.2270427,4.0967178,1.815775,11.0421414),(32382,'Bettongia_penicillata_radius.tif',228,3,58,4.7700697,4.8837071,2.1004297,1.8,4.8857352,2.1269332,1.3017329,1.1494944,2.1635031,1.4452832,4.714691,0.7388322,2.1791931,1.2573209,2.8471424,2.2284559,4.1420218,1.8562592,11.1686712),(32383,'Bettongia_penicillata_radius.tif',228,3,59,4.7802784,4.8538466,2.1386202,1.8,4.8528983,2.1658667,1.2851611,1.1449184,2.1639852,1.4390757,4.7823484,0.7334599,2.2099728,1.2569243,2.8736373,2.2218654,4.1602296,1.8334054,11.111919),(32384,'Bettongia_penicillata_radius.tif',228,3,60,4.8420694,4.8255679,2.1698192,1.8,4.8305845,2.2126479,1.2711894,1.1435817,2.2366866,1.4420678,4.9545438,0.7367125,2.2151265,1.2610099,2.8592947,2.2029187,4.2371251,1.8603,11.2297653),(32385,'Bettongia_penicillata_radius.tif',228,3,61,4.9100559,4.8009055,2.2015754,1.8,4.8078851,2.2488499,1.2663881,1.1493389,2.2700742,1.4512286,5.1154951,0.744825,2.2534484,1.2626638,2.8879663,2.2030283,4.3037695,1.8766752,11.2865175),(32386,'Bettongia_penicillata_radius.tif',228,3,62,4.943248,4.7817202,2.2423603,1.8,4.7940038,2.2978932,1.2661906,1.1293123,2.3040192,1.4552484,5.3040803,0.749767,2.302099,1.2886146,2.9334472,2.2223041,4.3449838,1.8736812,11.4933071),(32387,'Bettongia_penicillata_radius.tif',228,3,63,4.9544914,4.7635971,2.2787093,1.8,4.7778828,2.3416976,1.2675273,1.142918,2.3597623,1.4611745,5.4462992,0.7521027,2.3079864,1.2784596,2.9203068,2.2414702,4.4150738,1.8585043,11.4531772),(32388,'Bettongia_penicillata_radius.tif',228,3,64,4.9574925,4.7402401,2.3097221,1.8,4.754178,2.3777264,1.2709065,1.1384349,2.4613838,1.4589956,5.5229084,0.754142,2.2438225,1.2815802,2.8305314,2.2415798,4.5164149,1.8320149,12.0030234),(32389,'Bettongia_penicillata_radius.tif',228,3,65,4.9378502,4.7218722,2.3570171,1.8,4.7345659,2.429711,1.2725876,1.1235159,2.4790416,1.467168,5.5337457,0.751933,2.2322117,1.3058721,2.8116137,2.2561438,4.558163,1.8295672,12.3591055),(32390,'Bettongia_penicillata_radius.tif',228,3,66,4.9232929,4.7026768,2.3924295,1.8,4.7175647,2.4697326,1.2689555,1.1318016,2.5454091,1.476936,5.6458103,0.7480333,2.2180365,1.3049425,2.7898508,2.2606362,4.6110815,1.8362267,12.2282338),(32391,'Bettongia_penicillata_radius.tif',228,3,67,4.8720467,4.6903222,2.4487088,1.8,4.7085068,2.5349643,1.2657512,1.1604236,2.5359969,1.488412,5.7455828,0.7387632,2.2656111,1.2826454,2.8445224,2.2801313,4.5891741,1.8180581,12.5991398),(32392,'Bettongia_penicillata_radius.tif',228,3,68,4.8126184,4.6793854,2.5083154,1.8,4.7018052,2.6085602,1.2681943,1.1628073,2.5652897,1.4982047,5.6848773,0.7308707,2.2160762,1.2884377,2.7931072,2.2746469,4.5930357,1.8568478,12.5065995),(32393,'Bettongia_penicillata_radius.tif',228,3,69,4.7063994,4.6732127,2.5669425,1.8,4.6921666,2.6604403,1.275307,1.1695751,2.5535562,1.4937988,5.4554708,0.7178811,2.1364209,1.277215,2.7165328,2.3142801,4.5516075,1.8595259,11.9567533);
INSERT INTO `slices_w` VALUES (32394,'Bettongia_penicillata_radius.tif',228,3,70,4.6821312,4.6778353,2.6479609,1.8,4.6999264,2.74594,1.2842404,1.1865678,2.5586772,1.5079445,5.4464321,0.7180117,2.1286124,1.2708457,2.7141153,2.3041033,4.5362057,1.9106172,12.0832832),(32395,'Bettongia_penicillata_radius.tif',228,3,71,4.6531209,4.6793821,2.7256853,1.8,4.699517,2.821848,1.2931331,1.204323,2.5261612,1.5425342,5.4005604,0.7172508,2.1378526,1.280831,2.7460843,2.3348719,4.4815706,1.8742562,12.0073653),(32396,'Bettongia_penicillata_radius.tif',228,3,72,4.6827009,4.6818421,2.797286,1.8,4.7056838,2.8971853,1.2971037,1.2212171,2.4985516,1.6034531,5.4297164,0.7234337,2.1731456,1.3129959,2.8130691,2.3939149,4.4671808,1.895605,12.3695876),(32397,'Bettongia_penicillata_radius.tif',228,3,73,4.6818319,4.6829657,2.8611658,1.8,4.7073981,2.9662168,1.3040659,1.2362815,2.7327821,1.6656337,5.4154399,0.7260945,1.9816582,1.3472932,2.5908621,2.4192,4.4602824,1.9477056,12.6078234),(32398,'Bettongia_penicillata_radius.tif',228,3,74,4.6722198,4.680351,2.9153633,1.8,4.7023353,3.0180902,1.3121544,1.251295,2.4914811,1.7249008,5.442807,0.7277627,2.1845668,1.3784926,2.8765052,2.4590254,4.4292116,1.929567,12.8164115),(32399,'Bettongia_penicillata_radius.tif',228,3,75,4.674878,4.6811628,2.9640747,1.8,4.7042292,3.0672836,1.3205262,1.2606295,2.4855134,1.7959807,5.4730278,0.7313548,2.2019707,1.4246697,2.9236409,2.5052559,4.4292116,1.929567,12.5170816),(32400,'Bettongia_penicillata_radius.tif',228,3,76,4.6606246,4.6832057,3.0143128,1.8,4.7009595,3.1088712,1.3330205,1.2999135,2.4772237,1.8843546,5.4679266,0.7336757,2.2072802,1.4496,2.9658757,2.5056,4.4262612,1.8987196,12.6183055),(32401,'Bettongia_penicillata_radius.tif',228,3,77,4.6556372,4.6864812,3.060912,1.8,4.7036929,3.1511166,1.3454431,1.3248549,2.4621825,1.9622851,5.4901505,0.7371967,2.2297902,1.481132,3.0252056,2.5488,4.4125369,1.8894509,12.2560832),(32402,'Bettongia_penicillata_radius.tif',228,3,78,4.7035949,4.6928495,3.1076637,1.8,4.7120293,3.2019142,1.3556805,1.3258205,2.4564162,2.0511878,5.5349219,0.7482123,2.2532509,1.5471082,3.0857947,2.592,4.3853852,1.9018924,12.3529653),(32403,'Bettongia_penicillata_radius.tif',228,3,79,4.7253932,4.6970605,3.1578036,1.8,4.7105701,3.2482003,1.3698243,1.3441991,2.4471341,2.1290506,5.5655317,0.7561819,2.274306,1.5838804,3.139851,2.6267249,4.3862362,1.8707435,12.8478577),(32404,'Bettongia_penicillata_radius.tif',228,3,80,4.7809808,4.7070978,3.197032,1.8,4.721826,3.2835435,1.382601,1.3637362,2.5422717,2.2154829,5.6297781,0.76894,2.2144675,1.6245686,3.0854907,2.6326919,4.3862362,1.8707435,12.6497518),(32405,'Bettongia_penicillata_radius.tif',228,3,81,4.8602363,4.7191289,3.2436957,1.8,4.7345278,3.3327339,1.3920432,1.3887398,2.440203,2.3323291,5.7350306,0.7844309,2.3502268,1.6794572,3.2986512,2.6784,4.3715327,1.8925469,12.2813892),(32406,'Bettongia_penicillata_radius.tif',228,3,82,4.8812439,4.7331928,3.2952012,1.8,4.751906,3.3898773,1.398736,1.4139737,2.583921,2.4292163,5.8982071,0.7896927,2.2826577,1.7180067,3.2221236,2.7090703,4.3614888,1.8518171,12.1845071),(32407,'Bettongia_penicillata_radius.tif',228,3,83,4.8751056,4.7461768,3.3429915,1.8,4.7635469,3.4318565,1.4098832,1.420285,2.5062374,2.5088098,5.9267346,0.79166,2.3647938,1.766413,3.3634277,2.7216,4.3614888,1.8518171,12.4201995),(32408,'Bettongia_penicillata_radius.tif',228,3,84,4.9378614,4.7566106,3.3970778,1.8,4.7773765,3.490941,1.418003,1.4284236,2.405935,2.5945979,6.0907782,0.8039129,2.5315639,1.8164065,3.5984136,2.7599859,4.3383212,1.8326816,12.5065995),(32409,'Bettongia_penicillata_radius.tif',228,3,85,4.9716465,4.7762436,3.4409253,1.8,4.8005737,3.5338654,1.4240013,1.4535866,2.4012215,2.6846153,6.2079332,0.8108801,2.5853231,1.8468905,3.6920263,2.7826509,4.3486331,1.8013182,14.149998),(32410,'Bettongia_penicillata_radius.tif',228,3,86,5.0279472,4.8020499,3.4960875,1.8,4.8256644,3.5978947,1.4326667,1.4452952,2.4149914,2.7783487,6.3427281,0.8221039,2.6263978,1.9223399,3.7740282,2.808,4.3548514,1.7604099,13.235386),(32411,'Bettongia_penicillata_radius.tif',228,3,87,5.0398527,4.8282187,3.5449976,1.8,4.8546953,3.6523578,1.4385893,1.4347585,2.4166747,2.8464926,6.4125868,0.8253791,2.6534754,1.9839524,3.8220758,2.808,4.3548514,1.7604099,14.1203502),(32412,'Bettongia_penicillata_radius.tif',228,3,88,5.0793537,4.8556181,3.5986875,1.8,4.8804771,3.7077397,1.4492769,1.446713,2.3905309,2.9025566,6.5004999,0.8341192,2.7192705,2.0063112,3.9311245,2.8246829,4.3124334,1.762298,13.3662577),(32413,'Bettongia_penicillata_radius.tif',228,3,89,5.2034553,4.898464,3.6684964,1.8,4.9201984,3.7765425,1.4531553,1.4317422,2.3688802,3.0246329,6.6920483,0.8552957,2.8249839,2.1125541,4.0948556,2.808,4.3297091,1.7818897,13.2798577),(32414,'Bettongia_penicillata_radius.tif',228,3,90,5.2189626,4.9359884,3.7276877,1.8,4.9537258,3.8324877,1.4671183,1.4295215,2.3129065,3.078009,6.7485648,0.8605107,2.9177854,2.1531744,4.2229611,2.8512,4.2547066,1.7960731,13.0249996),(32415,'Bettongia_penicillata_radius.tif',228,3,91,5.235632,4.9699081,3.7772681,1.8,4.9816202,3.8795017,1.4855839,1.4475371,2.2990977,3.158032,6.7319461,0.8662845,2.9280817,2.1816587,4.2793302,2.8512,4.2276448,1.7661879,12.8670234),(32416,'Bettongia_penicillata_radius.tif',228,3,92,5.2352189,5.0102636,3.8295306,1.8,5.0134096,3.9312,1.5033792,1.4602886,2.2769662,3.2171599,6.7153999,0.8685767,2.9492751,2.2030988,4.3527193,2.8944,4.1850523,1.7053942,13.1428458),(32417,'Bettongia_penicillata_radius.tif',228,3,93,5.2315626,5.0537993,3.8824204,1.8,5.0541832,3.977678,1.520983,1.447171,2.2642734,3.2802443,6.6870718,0.8697653,2.9532969,2.2666597,4.3864971,2.8512,4.1617993,1.7376515,13.5180936),(32418,'Bettongia_penicillata_radius.tif',228,3,94,5.2704533,5.0985183,3.9360159,1.8,5.0926777,4.0293301,1.5488011,1.4740074,2.2448222,3.3838219,6.660062,0.877984,2.966855,2.2956613,4.4675933,2.932357,4.1185259,1.6548086,13.6106338),(32419,'Bettongia_penicillata_radius.tif',228,3,95,5.2258171,5.14359,3.9927023,1.8,5.1346304,4.0848743,1.5705322,1.4717562,2.1849768,3.4284688,6.5415287,0.8709695,2.9938664,2.3295086,4.4569255,2.9376,4.0601106,1.929567,13.3452936),(32420,'Bettongia_penicillata_radius.tif',228,3,96,5.2029658,5.1929312,4.0526913,1.8,5.1835479,4.1417354,-1.5473539,1.4862486,2.1697476,3.4811354,6.4569592,0.8666845,2.9759034,2.3422295,4.5080965,2.9376,4.0201541,1.419781,13.2231055),(32421,'Bettongia_penicillata_radius.tif',228,3,97,5.150996,5.2426881,4.1214042,1.8,5.2309628,4.212612,-1.5141191,1.5024677,2.1856105,3.5142667,6.3672305,0.8557445,2.9132503,2.3389964,4.480472,2.9376,4.0582716,1.3671378,13.6464219),(32422,'Bettongia_penicillata_radius.tif',228,3,98,5.1171057,5.2944748,4.1803533,1.8,5.2786486,4.2623256,-1.4829757,1.5203413,2.1283399,3.5576786,6.2728474,0.8462903,2.9472959,2.3400527,4.5196668,2.9808,3.977451,1.418147,13.0441653),(32423,'Bettongia_penicillata_radius.tif',228,3,99,5.0534164,5.3491226,4.2430884,1.8,5.3301529,4.3244079,-1.4556163,1.5252343,2.1123256,3.5585521,6.1853599,0.8311119,2.9282227,2.3331183,4.5507296,3.024,3.977451,1.418147,13.3156458),(32424,'Bettongia_penicillata_radius.tif',228,3,100,5.0055616,5.4055468,4.3029671,1.8,5.386511,4.3788538,-1.4155266,1.5166986,2.0863823,3.5476912,6.1075755,0.8143085,2.9273521,2.3390878,4.5259188,2.9919779,3.9649976,1.3734008,13.0860936),(32425,'Bettongia_penicillata_radius.tif',228,3,101,4.9814366,5.4609673,4.3605942,1.8,5.439676,4.4357216,-1.3877246,1.539897,2.0872233,3.5406132,6.0358909,0.8027232,2.8918281,2.2992533,4.5183265,3.0062023,3.9640561,1.2835149,12.8478577),(32426,'Bettongia_penicillata_radius.tif',228,3,102,4.9633519,5.5105272,4.422121,1.8,5.4875772,4.4973993,-1.3605861,1.5112383,2.0626854,3.5474658,5.9465078,0.7912069,2.8828962,2.3473901,4.4858955,2.9901701,3.9312,1.1760052,12.5868593),(32427,'Bettongia_penicillata_radius.tif',228,3,103,4.9177741,5.5640041,4.486951,1.8,5.5404069,4.556605,-1.3334798,1.5003222,2.0292552,3.5101412,5.8223502,0.7743283,2.8692055,2.3395917,4.4794238,2.9523095,3.9147877,1.1861916,12.5109414),(32428,'Bettongia_penicillata_radius.tif',228,3,104,4.8656633,5.6209552,4.5561321,1.8,5.6004363,4.6254287,-1.3126636,1.5206325,1.9913839,3.4896072,5.7188006,0.7580982,2.8717721,2.2948392,4.4843071,2.9830461,3.8836776,1.122073,12.1845071),(32429,'Bettongia_penicillata_radius.tif',228,3,105,4.7917434,5.6790182,4.618209,1.8,5.6586972,4.6778546,-1.2992552,1.5187885,1.9979918,3.474723,5.6032747,0.7411708,2.8044532,2.2878255,4.4640018,2.9908076,3.8651328,1.1321435,12.4053757),(32430,'Bettongia_penicillata_radius.tif',228,3,106,4.7107777,5.7416645,4.6820359,1.8,5.7159236,4.7412073,-1.2759921,1.5157304,1.9776536,3.4845451,5.4782404,0.7188484,2.7700708,2.2989215,4.3847719,2.9967678,3.8448,1.1171986,12.1949892),(32431,'Bettongia_penicillata_radius.tif',228,3,107,4.6141942,5.8056093,4.7448875,1.8,5.7800171,4.8000083,-1.2630418,1.5445163,1.9523126,3.4993973,5.3701747,0.6984658,2.7506736,2.2656914,4.3109952,3.028427,3.8077314,1.1375962,12.5232219),(32432,'Bettongia_penicillata_radius.tif',228,3,108,4.6042787,5.869913,4.8182543,1.8,5.842609,4.8668854,-1.2606667,1.5589368,2.1340955,3.5693126,5.4519084,0.695909,2.5546694,2.2895814,4.1280857,3.0331521,3.7937373,1.0460006,12.0474951),(32433,'Bettongia_penicillata_radius.tif',228,3,109,4.5543083,5.9476159,4.8794391,1.8,5.920935,4.9164818,-1.2493431,1.5980764,1.937597,3.6668095,5.4599884,0.6832816,2.8179175,2.2945145,4.530862,3.0700376,3.8292359,1.152572,12.0221892),(32434,'Bettongia_penicillata_radius.tif',228,3,110,4.5347655,6.017569,4.9370196,1.8,5.9953357,4.9720911,-1.2369227,1.6144581,1.9300462,3.8299658,5.5434268,0.674629,2.8721732,2.3722919,4.5029142,3.1119544,3.8687524,1.0571903,12.4097175),(32435,'Bettongia_penicillata_radius.tif',228,3,111,4.5710969,6.0842018,5.0119053,1.8,6.064757,5.0351493,-1.2145519,1.6621693,1.9346599,4.0428533,5.7055341,0.6691847,2.9491147,2.4322753,4.7320115,3.1537585,3.8939954,1.2315037,12.1696832),(32436,'Bettongia_penicillata_radius.tif',228,3,112,4.544241,6.1560555,5.080334,1.8,6.1421072,5.1029675,-1.1936193,1.6899704,1.9643582,4.2379818,5.9172051,0.6546411,3.0122841,2.5077255,4.8984758,3.2222552,3.9793274,1.2044019,12.7151876),(32437,'Bettongia_penicillata_radius.tif',228,3,113,4.5338277,6.2379307,5.12242,1.8,6.2278248,5.1472305,-1.1572561,1.749723,1.9974619,4.5081434,6.1075786,0.6336127,3.0576697,2.5764898,4.9140091,3.3281746,4.0718149,1.2691773,12.7047055),(32438,'Bettongia_penicillata_radius.tif',228,3,114,4.5068782,6.3016191,5.1577454,1.8,6.292303,5.1868151,-1.1259697,1.7833442,2.0422635,4.8532854,6.379921,0.6120646,3.123946,2.7214518,4.9911461,3.4292755,4.1264481,1.2291808,13.2187637),(32439,'Bettongia_penicillata_radius.tif',228,3,115,4.3437382,6.3799924,5.2148105,1.8,6.3717268,5.2440772,-1.0985247,1.8338621,2.1022509,5.0927157,6.5230236,0.5741383,3.1028759,2.777044,5.0928637,3.5681507,4.2349223,1.2490458,13.4692801),(32440,'Bettongia_penicillata_radius.tif',228,3,116,4.2181798,6.4788078,5.2876552,1.8,6.477303,5.3161375,-1.1263323,1.9045063,2.1575812,5.3445797,6.8690752,0.5730554,3.1836926,2.8062809,5.2515843,3.6708604,4.3632,1.371459,13.7013757),(32441,'Bettongia_penicillata_radius.tif',228,3,117,4.2233466,6.5611403,5.4067104,1.8,6.5682928,5.4369491,-1.1100269,1.9889643,2.2490275,5.8581232,7.2071443,0.5647301,3.2045603,2.9453134,5.4803896,3.7825101,4.4815706,1.2673364,14.1203502),(32442,'Bettongia_penicillata_radius.tif',228,3,118,4.297495,6.6701171,5.4670559,1.8,6.672467,5.5052723,-1.0471407,2.061851,2.2903417,6.3014514,7.7214462,0.5371516,3.3713075,3.0562109,5.7116217,3.9170902,4.592223,1.3623311,14.6239263),(32443,'Bettongia_penicillata_radius.tif',228,3,119,4.1692532,6.7357226,5.5133959,1.8,6.7466546,5.5825378,-1.0521672,2.1324892,2.3491555,6.5644927,7.9130763,0.5241387,3.368477,3.078324,5.4576719,4.0576675,4.8539963,1.2912742,15.0664084),(32444,'Bettongia_penicillata_radius.tif',228,3,120,5.2994146,6.7786275,5.9468176,1.8,6.7850067,6.0140785,-1.2060767,2.3363856,2.7252855,7.3321243,10.1488985,0.7708653,3.7239763,3.1382338,6.3473845,4.0522576,5.2788916,1.2024474,16.0124666),(32445,'Bettongia_penicillata_radius.tif',228,3,121,6.2307329,6.7707742,5.9648083,1.8,6.7716797,6.0249575,-0.9133907,2.1543406,2.7645762,7.8409352,12.1318953,0.6506955,4.3883381,3.6395987,7.2198142,3.9327002,5.3908339,1.1932661,16.5221829),(32446,'Bettongia_penicillata_radius.tif',228,3,122,8.5043927,6.867439,5.8821034,1.8,6.8778672,5.9005708,-0.9838012,1.9321735,2.4745736,7.9807612,13.347775,0.9825937,5.3939696,4.1304579,8.5667361,3.6265271,4.8043373,0.9129077,14.8979502),(32447,'Bettongia_penicillata_radius.tif',228,3,123,4.702556,7.0240321,5.4061831,1.8,6.9582773,5.4872381,-0.4722291,1.3384742,2.0936041,1.7622732,5.4198694,0.1621669,2.5887747,1.3166285,3.1423462,2.5640478,4.1584348,0.6081728,13.174292),(32448,'Bettongia_penicillata_radius.tif',228,3,124,2.6086594,7.6696947,5.0384602,1.8,7.6655974,5.0741156,-0.0140973,1.2713303,1.5864793,0.7288433,1.114651,0.0000864,0.7025941,0.5732919,1.0967746,2.1427924,2.6954169,0.1124271,9.1482265),(32449,'Bettongia_penicillata_radius.tif',228,3,125,2.4076195,7.777181,4.9956204,1.8,7.7618868,5.0201519,0.1717596,0.9107055,1.8270301,0.457219,0.8096958,0.011722,0.4431759,0.5020493,0.6569846,1.7329946,2.3383933,2.9369508,7.174052),(32450,'Bettongia_penicillata_radius.tif',228,3,126,1.7299899,7.946724,4.9370242,1.8,7.9647502,4.9684997,0.5252579,1.0808131,1.1114494,0.1848089,0.4029848,0.0724976,0.3625759,0.1709906,0.3960536,1.3333167,2.1793533,2.4544684,5.9373476),(32451,'Bettongia_penicillata_radius.tif',228,3,127,0.473274,8.1373307,4.9643293,1.8,8.1691564,5.0157984,0.4070865,1.1596117,1.9335159,0.019218,0.0662765,0.0123655,0.0342777,0.0165728,0.0381682,0.69998,1.6330514,2.2248791,4.8184894),(32452,'Bettongia_penicillata_radius.tif',228,3,128,3.5957617,6.8075078,7.0281594,1.8,6.8388362,7.0349731,-1.4497606,2.7091195,2.1310234,1.9713305,3.9638633,0.590557,1.860075,0.7276647,1.8466394,1.7410367,3.0601948,0.72547,8.3793102),(32453,'Bettongia_penicillata_radius.tif',228,3,129,5.457911,6.7320618,6.974887,1.8,6.7870675,6.9716452,-1.3380853,2.9706708,2.1736148,2.8595615,6.7779661,0.861273,3.1182923,0.9625979,2.9150202,2.7002429,4.3715327,1.2490458,16.2062307),(32454,'Bettongia_penicillata_radius.tif',228,3,130,0.0505911,7.4555264,9.0132695,1.8,7.4814546,9.0052364,-0.3126728,0.1042194,0.247501,0.0001006,0.000682,0.0007978,0.0027556,0.0009653,0.0031535,0.2690129,1.0241225,0.4825133,2.3407387),(32455,'Bettongia_penicillata_radius.tif',228,3,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32456,'Bettongia_penicillata_radius.tif',228,3,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32457,'Bettongia_penicillata_radius.tif',228,3,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32458,'Bettongia_penicillata_ulna.tif',228,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32459,'Bettongia_penicillata_ulna.tif',228,4,2,0.3145861,7.4647313,7.5311617,1.8,7.5021429,7.4874858,-1.3336649,0.4975938,0.65466,0.0110542,0.0259271,0.0495376,0.039604,0.0222152,0.0561402,0.9072,1.2705501,1.259798,4.6203834),(32460,'Bettongia_penicillata_ulna.tif',228,4,3,1.9081657,7.2221727,7.472897,1.8,7.2066,7.4327455,-1.5229828,1.131502,1.7989469,0.3686569,2.0528313,0.3173011,1.1411295,0.325812,1.3168424,1.8590045,3.6495692,1.677532,12.0597757),(32461,'Bettongia_penicillata_ulna.tif',228,4,4,3.8332864,6.596746,7.8184362,1.8,6.6366518,7.7537352,-1.4009751,1.3205874,2.5172386,1.8935008,5.8937859,0.6206326,2.3413696,1.4338323,3.0571905,2.5708898,4.4319495,1.3944302,13.3452936),(32462,'Bettongia_penicillata_ulna.tif',228,4,5,4.3670136,6.3755129,7.9680846,1.8,6.418171,7.8929512,-1.3225737,1.556214,2.8948175,2.7403355,8.7132971,0.6839039,3.0099643,1.7608989,3.9324291,2.8726781,4.9454095,1.323699,14.7041861),(32463,'Bettongia_penicillata_ulna.tif',228,4,6,4.4618148,6.3211979,8.157533,1.8,6.3462756,8.0996616,-1.3601077,1.5682045,2.6328141,3.6431342,7.8549418,0.7111116,2.9834776,2.3231244,4.2405375,3.092848,4.8037546,1.3716371,14.5147637),(32464,'Bettongia_penicillata_ulna.tif',228,4,7,4.4053173,6.2472021,8.1151381,1.8,6.245307,8.112423,-1.1660666,1.8273064,2.4397714,3.6109093,6.7441818,0.6203751,2.7642679,1.9760831,4.2045933,3.1525348,4.6585948,1.2402483,14.5357279),(32465,'Bettongia_penicillata_ulna.tif',228,4,8,4.0346356,6.1396244,8.0039662,1.8,6.1170782,8.033553,-1.0385352,1.6753695,2.3011491,2.6450413,6.3277302,0.49926,2.7498132,1.5787808,3.7893766,2.958752,4.5614373,1.0774964,14.3943741),(32466,'Bettongia_penicillata_ulna.tif',228,4,9,3.7419357,6.066359,7.777367,1.8,6.0442773,7.7799446,-0.8255191,1.4600005,2.2423129,1.7120978,5.7686978,0.3368228,2.5726551,1.1726694,3.2186887,2.6775792,4.4696867,0.9988781,13.1891159),(32467,'Bettongia_penicillata_ulna.tif',228,4,10,3.5165235,6.0600971,7.6318152,1.8,6.0389755,7.6534326,-0.7235413,1.303389,2.2525403,1.3475581,6.0271384,0.2568825,2.6757072,1.0338878,3.2002409,2.4984843,4.5015147,0.9215371,12.9848697),(32468,'Bettongia_penicillata_ulna.tif',228,4,11,3.699412,6.1162217,7.4781231,1.8,6.0969634,7.4827713,-0.6739958,1.2371443,2.2772829,1.3132668,7.0808209,0.240164,3.1093286,1.0615308,3.4914418,2.4013737,4.6353017,0.8844111,13.519892),(32469,'Bettongia_penicillata_ulna.tif',228,4,12,4.2820711,6.2749914,7.2727436,1.8,6.2356074,7.2933676,-0.6080967,1.2604748,2.4506649,1.572549,9.4506664,0.2329382,3.8563683,1.2475847,4.2302621,2.4175262,4.8647497,0.8419416,14.1185518),(32470,'Bettongia_penicillata_ulna.tif',228,4,13,4.8180957,6.4756574,7.0430815,1.8,6.4644847,7.0522327,-0.5719235,1.3413929,2.7888433,2.1805775,12.6744393,0.2352451,4.5446939,1.6256068,5.1512992,2.6329452,5.2753551,0.551655,15.7236188),(32471,'Bettongia_penicillata_ulna.tif',228,4,14,6.1393306,6.7806536,6.7182568,1.8,6.775168,6.7172255,-0.504605,1.71924,3.2162844,4.1732262,19.2625084,0.239163,5.9890564,2.4273669,6.9934618,3.3581052,6.1106244,0.5840811,18.7241113),(32472,'Bettongia_penicillata_ulna.tif',228,4,15,7.8358521,6.8383765,6.2543468,1.8,6.8359424,6.2412639,-0.5456561,2.4909388,3.5780516,10.9099312,23.2625046,0.3517504,6.5014448,4.3798471,9.0722472,4.7855001,6.5437663,0.6118076,22.1287544),(32473,'Bettongia_penicillata_ulna.tif',228,4,16,7.851041,6.7095739,6.0218826,1.8,6.7136509,5.9960443,-0.7958891,2.7004095,3.8826376,10.7135495,23.5475703,0.6679799,6.0648386,3.9673796,8.7466836,4.7016746,6.6445196,0.6330984,22.0676604),(32474,'Bettongia_penicillata_ulna.tif',228,4,17,7.1168829,6.6180182,6.1155706,1.8,6.6186448,6.0912537,-0.7902307,2.2998918,3.7790506,6.1135962,22.6335097,0.5988056,5.9892053,2.6582104,7.5390466,4.0920899,6.5644103,1.0394059,20.46005),(32475,'Bettongia_penicillata_ulna.tif',228,4,18,5.7954598,6.1746673,6.6583179,1.8,6.2074337,6.6096681,-0.7114313,1.8841913,3.1593652,3.8626668,14.3478419,0.4117699,4.5413686,2.0500396,5.7638433,3.4803822,6.3611175,0.8334381,19.5541217),(32476,'Bettongia_penicillata_ulna.tif',228,4,19,4.9636731,5.8832044,6.9908333,1.8,5.8772749,6.9948839,-0.6413873,1.7265305,2.7146339,2.9896599,10.5916088,0.2961427,3.9016711,1.7315998,4.9676415,3.1785502,4.9949738,0.705812,15.2941622),(32477,'Bettongia_penicillata_ulna.tif',228,4,20,4.588017,5.7668062,7.1526542,1.8,5.7660546,7.1462587,-0.5660607,1.6923317,2.5456114,2.7646939,9.3296784,0.2199418,3.6650049,1.6336596,4.6609636,3.1631677,4.7688574,0.7469556,15.0244801),(32478,'Bettongia_penicillata_ulna.tif',228,4,21,4.9873744,5.738909,7.1985105,1.8,5.7654005,7.1697971,-0.4900491,1.7921232,2.5427845,3.0812267,10.1240809,0.1841418,3.9814938,1.7193163,5.1289808,3.2341942,4.8124878,0.6452964,15.2941622),(32479,'Bettongia_penicillata_ulna.tif',228,4,22,5.4167636,5.7858415,7.2076417,1.8,5.8428604,7.171793,-0.4177528,2.0146156,2.6141041,3.6339497,11.7968122,0.1485986,4.5127553,1.8037931,5.7712114,3.4230041,5.0026272,0.6383198,17.0492666),(32480,'Bettongia_penicillata_ulna.tif',228,4,23,6.2636689,5.938797,7.1137995,1.8,5.969817,7.0705567,-0.3502996,2.4305681,2.8261262,5.0705111,15.3198381,0.1229474,5.4207905,2.0861424,6.8795755,3.9020691,5.3908339,0.1124271,18.3007949),(32481,'Bettongia_penicillata_ulna.tif',228,4,24,7.4381734,6.241128,6.8927217,1.8,6.26488,6.8353551,-0.3601282,2.6751508,3.2374209,6.9594867,21.6262643,0.1539475,6.6800905,2.6015306,8.5655233,4.2049811,6.2035261,0.6421084,20.6162276),(32482,'Bettongia_penicillata_ulna.tif',228,4,25,8.2857303,6.5207947,6.8034141,1.8,6.5310497,6.7622517,-0.3134238,2.6844346,3.5795254,7.6744267,29.5046559,0.1312731,8.2426167,2.8588615,10.1934838,4.244402,6.7443212,0.4865662,22.2910723),(32483,'Bettongia_penicillata_ulna.tif',228,4,26,7.9070147,6.459091,6.9475898,1.8,6.4669241,6.9046114,-0.2302051,2.6356183,3.4710533,5.7321581,32.0144731,0.0686129,9.2232733,2.1748818,10.5881589,4.1542789,7.0034649,0.3724882,22.5397903),(32484,'Bettongia_penicillata_ulna.tif',228,4,27,6.7149847,6.0050328,7.0901315,1.8,6.0389847,7.021334,-0.2254282,2.5292971,3.5012279,4.7390259,21.3090724,0.0559166,6.0861712,1.8736533,7.4397037,3.9687854,6.6546232,0.344334,21.8634141),(32485,'Bettongia_penicillata_ulna.tif',228,4,28,6.0529023,5.5213244,7.148817,1.8,5.5736773,7.0619534,-0.3355263,2.3409694,2.8472386,4.0418926,13.5638543,0.1093721,4.7638629,1.7265892,6.0280946,3.5326353,5.602692,0.2973651,16.6783606),(32486,'Bettongia_penicillata_ulna.tif',228,4,29,6.1363368,5.3303525,7.1711239,1.8,5.3771542,7.1119965,-0.3849276,1.7882655,2.5986817,3.4182055,11.9568438,0.144198,4.601119,1.9114643,5.879476,2.9707278,5.2471553,0.3973244,15.2034203),(32487,'Bettongia_penicillata_ulna.tif',228,4,30,6.0048625,5.1741046,7.2283459,1.8,5.2320348,7.1871881,-0.3823223,1.8067345,2.5729875,2.894654,10.6421246,0.1392985,4.1360965,1.6021468,5.2405714,2.9383407,5.0943041,0.3915296,14.8307159),(32488,'Bettongia_penicillata_ulna.tif',228,4,31,5.725104,4.9555843,7.3123768,1.8,4.9722461,7.2861206,-0.3666181,1.8269612,2.8100372,2.4910702,8.8896504,0.1226067,3.1635348,1.3635047,4.0067287,2.9263879,4.6723951,0.3100552,13.2903398),(32489,'Bettongia_penicillata_ulna.tif',228,4,32,5.6064231,4.8052247,7.3458162,1.8,4.8156042,7.3209066,-0.3590982,1.6990311,2.9088379,2.2537184,7.9245525,0.1154018,2.7243019,1.3264727,3.4434387,2.7769035,4.4403633,0.3063672,12.5109414),(32490,'Bettongia_penicillata_ulna.tif',228,4,33,5.4018816,4.6680925,7.3829678,1.8,4.6659852,7.3677125,-0.3367408,1.5401482,3.1604,1.975433,6.8961788,0.0982895,2.1820588,1.2826252,2.7674679,2.5906,4.3182717,0.3470616,12.2011294),(32491,'Bettongia_penicillata_ulna.tif',228,4,34,5.2925166,4.5658492,7.3995247,1.8,4.5647588,7.3840074,-0.3238223,1.4417005,2.1608195,1.7622726,6.235624,0.0893081,2.8857682,1.2223569,3.6515966,2.4461007,4.2223442,0.3444004,11.4889653),(32492,'Bettongia_penicillata_ulna.tif',228,4,35,5.1665295,4.4863945,7.4069243,1.8,4.4911571,7.3886519,-0.3076727,1.3847499,2.1341371,1.6518464,5.8276107,0.078973,2.7306637,1.1928842,3.4717033,2.3771786,4.1393175,0.3184502,11.5858473),(32493,'Bettongia_penicillata_ulna.tif',228,4,36,5.0423883,4.4280782,7.3935365,1.8,4.4320724,7.3753934,-0.3037557,1.3396491,2.0761724,1.5993435,5.4871968,0.0751857,2.642939,1.1938525,3.391304,2.3370134,4.04376,0.3149939,11.3414712),(32494,'Bettongia_penicillata_ulna.tif',228,4,37,4.9261801,4.3677647,7.3758172,1.8,4.3724961,7.354571,-0.3079525,1.3322065,2.0168571,1.5834552,5.261285,0.0754317,2.6086554,1.1885959,3.353725,2.3326802,3.9482531,0.3113703,11.3920832),(32495,'Bettongia_penicillata_ulna.tif',228,4,38,4.9234377,4.3167279,7.3383986,1.8,4.3188411,7.3125891,-0.3171924,1.2936221,2.0106969,1.6109445,5.1227651,0.0798268,2.547756,1.2452976,3.3219706,2.3183776,3.9293007,0.2556449,11.000213),(32496,'Bettongia_penicillata_ulna.tif',228,4,39,5.0126872,4.2713462,7.3041034,1.8,4.2654691,7.2761332,-0.3247413,1.2977536,1.9726682,1.6608543,5.071891,0.0850499,2.5710816,1.2797917,3.3498412,2.3398069,3.88752,0.2584549,11.1032354),(32497,'Bettongia_penicillata_ulna.tif',228,4,40,4.9774133,4.2356463,7.2764883,1.8,4.2329673,7.2474631,-0.3293509,1.3105857,1.9554646,1.6351411,4.9564815,0.0867781,2.5346823,1.2476415,3.3360721,2.3455914,3.8389709,0.3324263,10.827413),(32498,'Bettongia_penicillata_ulna.tif',228,4,41,4.9663699,4.2073575,7.2443125,1.8,4.2068017,7.2120279,-0.3383216,1.2903389,1.9281003,1.6201186,4.8643397,0.0911829,2.5228665,1.2555761,3.3160346,2.3469093,3.8155653,0.2751892,11.0526234),(32499,'Bettongia_penicillata_ulna.tif',228,4,42,4.9261824,4.1836314,7.2154824,1.8,4.1849394,7.1884412,-0.3456658,1.2895558,1.8975629,1.5891272,4.7701468,0.0942552,2.513828,1.2323059,3.2923014,2.3380682,3.7986534,0.3001712,11.3327876),(32500,'Bettongia_penicillata_ulna.tif',228,4,43,4.9206019,4.1623087,7.1786535,1.8,4.1615676,7.1515662,-0.3545599,1.265209,1.8654576,1.5791662,4.6790394,0.0988486,2.5082529,1.2481465,3.295727,2.3258822,3.7574068,0.3399304,11.2254234),(32501,'Bettongia_penicillata_ulna.tif',228,4,44,4.9109108,4.148825,7.1400032,1.8,4.1475625,7.1137673,-0.3680414,1.2671024,1.8489446,1.5744346,4.583002,0.1059512,2.4787125,1.2425472,3.2827667,2.3364343,3.74472,0.2925618,11.198319),(32502,'Bettongia_penicillata_ulna.tif',228,4,45,4.8810516,4.1317996,7.1015828,1.8,4.1328845,7.073525,-0.379127,1.2226563,1.8565817,1.5465217,4.5151848,0.1114353,2.4319882,1.2648867,3.2644727,2.3097865,3.7162045,0.3070457,11.3624354),(32503,'Bettongia_penicillata_ulna.tif',228,4,46,4.8745001,4.1255063,7.0623846,1.8,4.1241128,7.0367277,-0.388204,1.2052192,1.8658155,1.5211874,4.4795138,0.116405,2.4008343,1.2621666,3.2147508,2.2671455,3.7033766,0.295926,11.5457175),(32504,'Bettongia_penicillata_ulna.tif',228,4,47,4.9110241,4.1247962,7.0179538,1.8,4.122448,6.9879589,-0.4032423,1.1737172,1.8832075,1.5251494,4.4332461,0.1260331,2.3540932,1.2994181,3.1619186,2.2895366,3.6615664,0.3366748,11.7080354),(32505,'Bettongia_penicillata_ulna.tif',228,4,48,4.8866176,4.1298085,6.9764223,1.8,4.1309395,6.9489066,-0.4175357,1.1492003,1.8703699,1.5184023,4.3810146,0.133924,2.3423252,1.3212686,3.1541422,2.2671455,3.6148876,0.2536741,11.4994473),(32506,'Bettongia_penicillata_ulna.tif',228,4,49,4.8994061,4.1313344,6.942478,1.8,4.131372,6.9221495,-0.4193862,1.1080658,1.8637131,1.4727265,4.3009151,0.1353965,2.3077131,1.3290966,3.0949518,2.2224138,3.5949565,0.3559577,11.3580936),(32507,'Bettongia_penicillata_ulna.tif',228,4,50,4.8257429,4.1376286,6.9084549,1.8,4.1360098,6.8892256,-0.4168057,1.0763698,1.8480471,1.4363768,4.1771879,0.1318207,2.2603255,1.334464,3.0291032,2.2045708,3.5772626,0.7426891,10.9792489),(32508,'Bettongia_penicillata_ulna.tif',228,4,51,4.8104809,4.15202,6.8690718,1.8,4.1497014,6.8503047,-0.4207545,1.0781069,1.8421072,1.4110887,4.0677408,0.133756,2.2081999,1.3088579,2.9740429,2.2013475,3.5518703,0.7165417,10.8989892),(32509,'Bettongia_penicillata_ulna.tif',228,4,52,4.7931908,4.1668147,6.833929,1.8,4.1712524,6.8105765,-0.4262781,1.0852954,1.8306362,1.4048007,4.0124558,0.1365818,2.1918368,1.2943947,2.9591397,2.1836429,3.6092043,0.7345945,10.446025),(32510,'Bettongia_penicillata_ulna.tif',228,4,53,4.7243544,4.1764899,6.8032007,1.8,4.1818318,6.7798131,-0.4149808,1.0813485,1.8120758,1.380761,3.8512661,0.127989,2.1253339,1.2768881,2.8847847,2.1832042,3.5352807,0.6728325,10.5158027),(32511,'Bettongia_penicillata_ulna.tif',228,4,54,4.7048787,4.1963648,6.7704926,1.8,4.2040946,6.7493425,-0.4105179,1.0956901,1.7740343,1.3518131,3.7010373,0.1248896,2.0862265,1.233755,2.8469824,2.1788322,3.4871794,0.7328151,10.7366712),(32512,'Bettongia_penicillata_ulna.tif',228,4,55,4.6557404,4.2104019,6.7402361,1.8,4.2137473,6.7199882,-0.4078962,1.0873047,1.7711513,1.3362597,3.5910616,0.1221001,2.0275295,1.2289652,2.7747895,2.1802685,3.4627434,0.7059199,10.2670847),(32513,'Bettongia_penicillata_ulna.tif',228,4,56,4.6489201,4.2315551,6.7085507,1.8,4.2415034,6.6845824,-0.4149784,1.0888127,1.7693095,1.3179999,3.501968,0.125944,1.9792851,1.2104928,2.7228198,2.1768376,3.4584292,0.7235303,10.8125892),(32514,'Bettongia_penicillata_ulna.tif',228,4,57,4.5884035,4.2542596,6.6844753,1.8,4.2679169,6.6609351,-0.4088189,1.0989833,1.7372252,1.2918679,3.3469697,0.1208484,1.9266181,1.1755119,2.6597641,2.1802685,3.4018457,0.7044941,10.3787907),(32515,'Bettongia_penicillata_ulna.tif',228,4,58,4.5398346,4.2825119,6.658359,1.8,4.2958917,6.6351237,-0.4117721,1.0956224,1.7048567,1.2702904,3.2218131,0.1212039,1.8897853,1.1594236,2.6348804,2.1621227,3.3465365,0.6848212,10.5638712),(32516,'Bettongia_penicillata_ulna.tif',228,4,59,4.5278018,4.317563,6.6276147,1.8,4.3345842,6.6025921,-0.4271408,1.093123,1.7100305,1.2460387,3.152833,0.12951,1.8437291,1.1398889,2.57236,2.1448721,3.3690461,0.7127987,10.557731),(32517,'Bettongia_penicillata_ulna.tif',228,4,60,4.49757,4.3546132,6.6031188,1.8,4.3696983,6.5778395,-0.4374214,1.1032558,1.6940031,1.2192507,3.0732558,0.1345083,1.8141973,1.1051386,2.531567,2.1413641,3.3709844,0.5382217,10.1405549),(32518,'Bettongia_penicillata_ulna.tif',228,4,61,4.4700896,4.3931776,6.5898375,1.8,4.4056776,6.567877,-0.4358612,1.1114088,1.6952915,1.2174758,3.0658858,0.1327955,1.8084711,1.0954347,2.523066,2.1415235,3.3339654,0.5448639,9.5086504),(32519,'Bettongia_penicillata_ulna.tif',228,4,62,4.4291782,4.4219945,6.5876189,1.8,4.4329759,6.5625065,-0.4273877,1.1256379,1.6857998,1.2396205,3.0288953,0.1268266,1.7967111,1.1012605,2.53193,2.1416828,3.3275219,0.5159255,9.6413206),(32520,'Bettongia_penicillata_ulna.tif',228,4,63,4.397383,4.4523305,6.5846123,1.8,4.4584051,6.5612368,-0.4205863,1.1278881,1.679296,1.2603256,2.973373,0.1221779,1.7706068,1.1174208,2.5194428,2.1884219,3.3041647,0.7298997,10.2461206),(32521,'Bettongia_penicillata_ulna.tif',228,4,64,4.3348801,4.4839264,6.5843179,1.8,4.4969881,6.5594749,-0.410006,1.1238979,1.6469251,1.2568358,2.8859928,0.1147976,1.7523521,1.1182829,2.5153374,2.1779157,3.2970969,0.551655,9.7128967),(32522,'Bettongia_penicillata_ulna.tif',228,4,65,4.3101179,4.5071171,6.5883001,1.8,4.5151437,6.5654911,-0.40333,1.1196616,1.6665331,1.2597006,2.8357868,0.1106573,1.7016084,1.1250726,2.4573682,2.1787124,3.290014,0.5224034,9.4728624),(32523,'Bettongia_penicillata_ulna.tif',228,4,66,4.2433617,4.5362068,6.5865464,1.8,4.5454264,6.5607543,-0.4065393,1.1161055,1.625659,1.2498599,2.7582957,0.1105872,1.6967247,1.1198402,2.454079,2.1412048,3.2477667,0.4993467,9.4222504),(32524,'Bettongia_penicillata_ulna.tif',228,4,67,4.1840009,4.5603567,6.5912321,1.8,4.5678271,6.5634465,-0.4092507,1.1369277,1.6058848,1.2574103,2.6743315,0.1104171,1.6653321,1.105972,2.4364886,2.1857041,3.2099083,0.5057913,9.2389684),(32525,'Bettongia_penicillata_ulna.tif',228,4,68,4.1364271,4.5819049,6.5971231,1.8,4.5907062,6.5705685,-0.4115761,1.1355939,1.6005937,1.2533317,2.5891577,0.1103347,1.6176234,1.1036795,2.3884872,2.211769,3.2008839,0.5543075,9.2599325),(32526,'Bettongia_penicillata_ulna.tif',228,4,69,4.1364073,4.603067,6.604634,1.8,4.6145893,6.577514,-0.3913284,1.1446553,1.5794467,1.2601959,2.5228848,0.1002932,1.5973219,1.1009393,2.3916898,2.1858634,3.168949,0.4819383,9.2852385),(32527,'Bettongia_penicillata_ulna.tif',228,4,70,4.0833304,4.6179649,6.6170073,1.8,4.6293448,6.588383,-0.3773003,1.141276,1.5579518,1.2541399,2.4529836,0.09237,1.5744926,1.0988927,2.3669307,2.2303627,3.1298393,0.4574748,9.0198982),(32528,'Bettongia_penicillata_ulna.tif',228,4,71,4.0145973,4.6348774,6.6291263,1.8,4.642624,6.601752,-0.3634233,1.1306743,1.5157964,1.2453691,2.3772056,0.0845496,1.5682882,1.1014393,2.3397166,2.2138034,3.0757065,0.5139197,9.2913788),(32529,'Bettongia_penicillata_ulna.tif',228,4,72,4.0146621,4.6542065,6.6439583,1.8,4.6627212,6.6176501,-0.3434647,1.1368491,1.5207387,1.2466856,2.3468338,0.0758781,1.5432197,1.0966148,2.3349541,2.2230524,3.0926494,0.4324078,9.1691907),(32530,'Bettongia_penicillata_ulna.tif',228,4,73,3.9838236,4.6743152,6.6582905,1.8,4.6852674,6.6337259,-0.326272,1.139645,1.4953484,1.2553296,2.2883506,0.0682092,1.5303127,1.1015093,2.3166464,2.2413605,3.0534792,0.4383366,9.0260385),(32531,'Bettongia_penicillata_ulna.tif',228,4,74,3.9941418,4.6856591,6.6779391,1.8,4.6925597,6.6542699,-0.3028656,1.1425985,1.4754405,1.2619966,2.2555292,0.0592178,1.5287158,1.104497,2.2976931,2.2514755,3.0341658,0.4891198,9.0871325),(32532,'Bettongia_penicillata_ulna.tif',228,4,75,3.9669104,4.6971107,6.7038882,1.8,4.7016061,6.679678,-0.2692576,1.1515106,1.4537078,1.272151,2.176888,0.046786,1.4974728,1.1047671,2.3169709,2.2675517,2.9782946,0.4182243,9.0827907),(32533,'Bettongia_penicillata_ulna.tif',228,4,76,3.9334797,4.7073131,6.7284448,1.8,4.7137523,6.7061787,-0.2420937,1.142156,1.4440038,1.2837825,2.1273282,0.0376783,1.4732151,1.1239993,2.2691324,2.2747027,2.9528077,0.3587707,8.8069684),(32534,'Bettongia_penicillata_ulna.tif',228,4,77,3.9362681,4.7145096,6.753976,1.8,4.7200991,6.7306663,-0.2150657,1.1554251,1.4359519,1.2940165,2.0732626,0.0298793,1.4438245,1.1199484,2.240348,2.2896,2.9442631,0.3914051,8.8279325),(32535,'Bettongia_penicillata_ulna.tif',228,4,78,3.9155195,4.7160347,6.7827933,1.8,4.7227397,6.7621259,-0.1780972,1.1496843,1.4135037,1.301795,2.0089057,0.0204812,1.4212242,1.1323065,2.2153704,2.3118916,2.8966559,0.3028849,8.8279325),(32536,'Bettongia_penicillata_ulna.tif',228,4,79,3.8669637,4.7131008,6.8133812,1.8,4.7183171,6.7936152,-0.1482361,1.1733747,1.3924387,1.2948938,1.9124318,0.0140586,1.3734405,1.1035638,2.1578655,2.3262008,2.8305067,0.2782997,8.7668385),(32537,'Bettongia_penicillata_ulna.tif',228,4,80,3.8220129,4.7115003,6.8479714,1.8,4.7156569,6.8266578,-0.1062371,1.1355634,1.3594475,1.2802078,1.8390486,0.0071624,1.3527912,1.1273768,2.1342654,2.2896,2.801346,0.2973651,9.2704146),(32538,'Bettongia_penicillata_ulna.tif',228,4,81,3.7738263,4.7119738,6.8830129,1.8,4.714597,6.8615873,-0.0688804,1.1379074,1.3411857,1.2687644,1.7687913,0.0029794,1.3188266,1.1149979,2.0548692,2.2896,2.760747,2.7901479,9.3777788),(32539,'Bettongia_penicillata_ulna.tif',228,4,82,3.7265997,4.7112848,6.9188792,1.8,4.7154894,6.8971476,-0.0389388,1.131001,1.3403999,1.2531887,1.7002688,0.0009413,1.2684787,1.108035,2.0562475,2.2896,2.7116389,0.3923401,9.1840146),(32540,'Bettongia_penicillata_ulna.tif',228,4,83,3.6862965,4.7054218,6.9540531,1.8,4.7095415,6.9286635,-0.0005973,1.124581,1.2995837,1.2328357,1.6343731,0.0000002,1.2576128,1.0962623,2.008813,2.2896,2.6954169,2.7640625,9.0155564),(32541,'Bettongia_penicillata_ulna.tif',228,4,84,3.6261115,4.6998072,6.9891717,1.8,4.7002633,6.9652655,0.0371838,1.1264934,1.2954103,1.2056649,1.554263,0.0008352,1.1998229,1.0702814,1.9456668,2.2896,2.6797932,2.7790484,8.8026265),(32542,'Bettongia_penicillata_ulna.tif',228,4,85,3.58454,4.6976406,7.0209203,1.8,4.6999354,6.9954117,0.0809481,1.2999917,1.2952861,1.1821764,1.4825872,0.0039061,1.1446021,0.9093722,1.860667,2.2633932,2.6493261,2.7217127,8.5625923),(32543,'Bettongia_penicillata_ulna.tif',228,4,86,3.531235,4.6949097,7.0580708,1.8,4.6961313,7.0323735,0.1461775,1.1119698,1.286035,1.1564624,1.4127431,0.0124865,1.0985261,1.0400124,1.8356962,2.2585451,2.6181481,2.484891,8.6193445),(32544,'Bettongia_penicillata_ulna.tif',228,4,87,3.4811858,4.6922284,7.0934534,1.8,4.6910325,7.0679828,0.2071126,1.1220958,1.3203297,1.1438751,1.3537101,0.0245341,1.0252818,1.0194095,1.7616177,2.2680103,2.6298832,2.4026726,8.9544624),(32545,'Bettongia_penicillata_ulna.tif',228,4,88,3.4530107,4.6900335,7.1289132,1.8,4.6910951,7.1007553,0.2729095,1.144093,1.3333099,1.1395138,1.3005408,0.0418095,0.9754228,0.9959975,1.7595172,2.2786346,2.6009844,2.4149503,8.6446504),(32546,'Bettongia_penicillata_ulna.tif',228,4,89,3.4097663,4.6875604,7.1612846,1.8,4.6881109,7.1314343,0.354637,1.2674175,1.3404785,1.1254383,1.2507468,0.0685264,0.93306,0.8879775,1.7235339,2.2464,2.5775598,2.4511462,8.4761923),(32547,'Bettongia_penicillata_ulna.tif',228,4,90,3.3882269,4.686425,7.195311,1.8,4.6888047,7.1641901,0.477195,1.1761585,1.3632896,1.1222009,1.2065156,0.1191226,0.8850031,0.9541238,1.7069306,2.2788605,2.5399984,2.4163627,8.3540042),(32548,'Bettongia_penicillata_ulna.tif',228,4,91,3.3742796,4.6823836,7.23271,1.8,4.6859906,7.2018177,0.7210234,1.2957884,1.3531807,1.1079855,1.1788937,0.2450868,0.871202,0.8550667,1.6740627,2.2804042,2.5666763,2.3799995,8.6699564),(32549,'Bettongia_penicillata_ulna.tif',228,4,92,3.3659288,4.6765483,7.262957,1.8,4.678863,7.2322818,0.9857252,1.3119337,1.2435151,1.0961364,1.1633643,0.3898926,0.9355449,0.8355121,1.6976332,2.2868026,2.5370577,2.3200656,8.3644863),(32550,'Bettongia_penicillata_ulna.tif',228,4,93,3.3436164,4.6708222,7.2909077,1.8,4.673672,7.2576,1.3584808,1.2455454,1.2125019,1.082036,1.1464895,0.5325241,0.9455569,0.8687246,1.6450027,2.3152093,2.544403,2.2720562,8.2676042),(32551,'Bettongia_penicillata_ulna.tif',228,4,94,3.2954959,4.6592397,7.3155,1.8,4.6603428,7.2805682,1.5144835,1.2057686,1.1721153,1.0519673,1.1355336,0.5475094,0.96879,0.8724454,1.6079513,2.2896,2.5724866,2.284887,8.3540042),(32552,'Bettongia_penicillata_ulna.tif',228,4,95,3.259236,4.6526846,7.3461571,1.8,4.6571384,7.3149825,-1.5031736,1.1487598,1.1636284,1.0250777,1.124358,0.5407258,0.9662517,0.8923342,1.5961253,2.2896,2.5115516,2.2831539,8.3286982),(32553,'Bettongia_penicillata_ulna.tif',228,4,96,3.205813,4.6450228,7.3776741,1.8,4.6513105,7.34707,-1.3880817,1.1545645,1.1447632,0.9916236,1.1091529,0.5166623,0.9688928,0.8588724,1.5513843,2.2412547,2.550264,2.2481828,8.3182162),(32554,'Bettongia_penicillata_ulna.tif',228,4,97,3.1942447,4.6391322,7.3952221,1.8,4.6479692,7.3552934,-1.2930541,1.2048739,1.2430996,0.9642568,1.1255918,0.4923516,0.905472,0.8002969,1.5008346,2.2366562,2.4808989,0.6121525,8.3391803),(32555,'Bettongia_penicillata_ulna.tif',228,4,98,3.127866,4.6258143,7.4298695,1.8,4.631522,7.3955112,-1.2386563,1.2099868,1.148973,0.9222704,1.066754,0.4658854,0.9284413,0.7622153,1.4463814,2.2134902,2.5059724,2.1970578,8.5434265),(32556,'Bettongia_penicillata_ulna.tif',228,4,99,3.0892925,4.6177308,7.4610768,1.8,4.6238803,7.426893,-1.2253034,1.1895948,1.1522807,0.8866455,1.0446803,0.4558298,0.9066196,0.745334,1.4039012,2.1831492,2.4536687,0.4557738,8.3959325),(32557,'Bettongia_penicillata_ulna.tif',228,4,100,3.0257515,4.6070067,7.4856798,1.8,4.6131528,7.4513048,-1.1911199,1.2012144,1.1398031,0.8537086,1.006343,0.4350228,0.8829095,0.7107046,1.3741113,2.1859403,2.4456695,2.1930992,8.2676042),(32558,'Bettongia_penicillata_ulna.tif',228,4,101,2.972001,4.5991319,7.507669,1.8,4.6077328,7.4757931,-1.1231534,1.2058045,1.1593233,0.8185989,0.978406,0.4025317,0.8439458,0.6788819,1.3307629,2.1679593,2.4452879,2.1293956,8.2842265),(32559,'Bettongia_penicillata_ulna.tif',228,4,102,2.9024891,4.5935542,7.5300447,1.8,4.6033706,7.4995249,-1.0368548,1.1805647,1.1775013,0.7697862,0.9407512,0.3584526,0.7989386,0.6520492,1.2522567,2.1193005,2.4391747,0.4002407,8.1558982),(32560,'Bettongia_penicillata_ulna.tif',228,4,103,2.8296407,4.593003,7.5508171,1.8,4.6003173,7.5223207,-0.9420718,1.1777384,1.1849867,0.7315234,0.9208972,0.3084885,0.7771372,0.6211255,1.2180885,2.0872642,2.4349629,0.4398426,7.9830982),(32561,'Bettongia_penicillata_ulna.tif',228,4,104,2.7602733,4.5888771,7.5766025,1.8,4.5989799,7.5497665,-0.8402505,1.1518498,1.2025049,0.6896763,0.8918303,0.2552068,0.7416438,0.5987554,1.1829911,2.0721372,2.4068255,0.3671738,7.9071803),(32562,'Bettongia_penicillata_ulna.tif',228,4,105,2.7019248,4.5855444,7.5939272,1.8,4.5950721,7.5675854,-0.7828252,1.1894662,1.2427219,0.6678386,0.8643168,0.2240017,0.695503,0.5614607,1.1379428,2.0671455,2.4322789,0.3442187,7.8417445),(32563,'Bettongia_penicillata_ulna.tif',228,4,106,2.6365471,4.5849011,7.6175754,1.8,4.5915163,7.5914158,-0.7239538,1.2130102,1.2299751,0.6396242,0.8300885,0.19278,0.6748823,0.5273032,1.1095706,2.0736,2.399448,0.4072558,7.9787564),(32564,'Bettongia_penicillata_ulna.tif',228,4,107,2.6019276,4.5896102,7.6417835,1.8,4.595805,7.61724,-0.6721838,1.2038317,1.2651555,0.6207891,0.8113136,0.1681498,0.6412758,0.5156776,1.0779636,2.0736,2.4068255,0.3671738,8.0145445),(32565,'Bettongia_penicillata_ulna.tif',228,4,108,2.5543862,4.5979809,7.6696991,1.8,4.6029435,7.6443665,-0.6040746,1.1690965,1.2251673,0.6048717,0.793853,0.1373514,0.6479548,0.5173839,1.0859842,2.0304,2.3633993,0.3159703,7.9133206),(32566,'Bettongia_penicillata_ulna.tif',228,4,109,2.5225284,4.6024329,7.7101651,1.8,4.6095373,7.6859607,-0.5999074,1.1447213,1.1728157,0.6022674,0.7937729,0.1340029,0.6768096,0.5261258,1.1070958,2.0441781,2.3503341,0.2984989,8.0398504),(32567,'Bettongia_penicillata_ulna.tif',228,4,110,2.4929847,4.6061635,7.7606993,1.8,4.6157517,7.7391959,-0.5608957,1.1874466,1.2273145,0.6069675,0.8166534,0.1175714,0.6653986,0.5111535,1.0941612,2.0304,2.399448,0.2362453,8.1009445),(32568,'Bettongia_penicillata_ulna.tif',228,4,111,2.4605212,4.611618,7.8209197,1.8,4.6308307,7.8011505,-0.5561356,0.9933071,1.1652925,0.6386555,0.8591392,0.1142858,0.7372734,0.6429587,1.1742095,1.9518953,2.399448,0.2362453,7.4646982),(32569,'Bettongia_penicillata_ulna.tif',228,4,112,2.4270297,4.6095,7.8764849,1.8,4.6283929,7.8606391,-0.5479881,0.9860311,1.2146051,0.7032656,0.9412667,0.109787,0.774957,0.7132286,1.2438089,1.9832673,2.4865344,0.1394401,7.9429684),(32570,'Bettongia_penicillata_ulna.tif',228,4,113,2.383955,4.5861461,7.9267779,1.8,4.604078,7.911068,-0.5393297,1.0076901,1.1832358,0.7828306,1.0571877,0.1047926,0.8934716,0.7768565,1.3795221,2.0469423,2.5579362,0.0845438,8.1219086),(32571,'Bettongia_penicillata_ulna.tif',228,4,114,2.3764657,4.5454389,7.9986564,1.8,4.5592725,7.978989,-0.4328536,1.0839741,1.2734734,0.8842278,1.227052,0.0696895,0.9635475,0.8157278,1.490351,2.1412048,2.7270802,3.0781857,8.7773206),(32572,'Bettongia_penicillata_ulna.tif',228,4,115,2.3795758,4.479167,8.0726435,1.8,4.4906102,8.0504153,-0.3306937,1.1482164,1.3862147,0.9963864,1.416044,0.0418129,1.0215185,0.8677688,1.6264586,2.2109197,2.7137028,0.2411177,8.7162265),(32573,'Bettongia_penicillata_ulna.tif',228,4,116,2.5093856,4.4325412,8.1248728,1.8,4.4486707,8.0979157,-0.2950675,1.1806202,1.50689,1.2239253,1.7376331,0.0353686,1.1531254,1.03668,1.9653407,2.335385,2.9337858,0.2378359,9.2049788),(32574,'Bettongia_penicillata_ulna.tif',228,4,117,2.4822685,4.4365217,8.1839597,1.8,4.4360836,8.1508637,-0.2567489,1.2577584,1.5457732,1.4064122,1.9916975,0.0266778,1.2884798,1.1181894,2.1455298,2.4723988,3.086609,0.1122028,9.9720967),(32575,'Bettongia_penicillata_ulna.tif',228,4,118,2.5819349,4.399267,8.2444167,1.8,4.388396,8.2389158,-0.2061585,1.4049986,1.9968592,1.7730013,2.2360344,0.0180316,1.1197757,1.2619239,2.0075996,2.7420838,3.2110709,2.9521125,10.8588593),(32576,'Bettongia_penicillata_ulna.tif',228,4,119,4.0539806,4.4305835,8.320788,1.8,4.4265263,8.2870016,-0.1812983,1.5522376,2.3066942,2.1779392,2.859677,0.0219662,1.2397295,1.4030966,2.1740161,2.8144712,3.2110709,2.8411155,10.6336489),(32577,'Bettongia_penicillata_ulna.tif',228,4,120,3.3932661,4.4737516,8.175215,1.8,4.5354957,8.1477292,-0.3541515,1.263679,1.5118322,1.3513359,1.8579721,0.0680161,1.2289539,1.0693664,1.8481424,2.4288948,3.2110709,2.9521125,10.3657653),(32578,'Bettongia_penicillata_ulna.tif',228,4,121,1.813559,4.6443156,8.2102176,1.8,4.6543481,8.2029828,1.3830956,1.1328576,0.983867,0.3126952,0.4152782,0.2917352,0.4220878,0.2760234,0.6355707,1.7106327,2.0848197,3.0378003,6.853758),(32579,'Bettongia_penicillata_ulna.tif',228,4,122,1.3820724,4.6805058,8.3691286,1.8,4.691009,8.3528358,1.0654076,0.7221605,1.1768479,0.1576893,0.2015922,0.1763527,0.1712984,0.2183577,0.2786338,1.3799657,1.7204234,2.4629302,5.0567252),(32580,'Bettongia_penicillata_ulna.tif',228,4,123,1.5708583,4.7018353,8.3398186,1.8,4.7206129,8.334956,0.6758382,0.7752043,0.8269067,0.2213147,0.2585376,0.10245,0.3126563,0.285492,0.5536305,1.5220824,1.7263793,2.5882983,5.4084655),(32581,'Bettongia_penicillata_ulna.tif',228,4,124,0.9263398,4.7167238,8.3318854,1.8,4.7229274,8.3265956,1.1054411,0.5506274,0.6936904,0.0596976,0.0838315,0.1233008,0.1208485,0.1084175,0.1953402,1.1232,1.4210108,1.9117753,4.2747834),(32582,'Bettongia_penicillata_ulna.tif',228,4,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32583,'Bettongia_penicillata_ulna.tif',228,4,126,9.8122281,7.3331836,7.9774778,1.8,7.3554253,7.9787847,1.2998402,2.4831437,3.6159515,17.3228514,29.2553139,1.5182165,8.0906268,6.9761777,12.2848055,3.0544448,3.839943,1.2739517,18.1149695),(32584,'Bettongia_penicillata_ulna.tif',228,4,127,7.7824003,7.4155504,8.3330995,1.8,7.4626576,8.312408,1.1089464,2.6924405,3.4476311,10.1486378,20.6924246,1.0395162,6.0019254,3.7693081,7.985393,2.1547096,2.9442631,2.8894967,9.9171429),(32585,'Bettongia_penicillata_ulna.tif',228,4,128,6.6217035,7.460304,8.2051458,1.8,7.4957067,8.1858343,0.957266,2.5861002,3.3743764,6.9715882,19.6622789,0.7377718,5.8269371,2.695792,7.5648046,1.7135966,2.2814345,1.8985348,7.6436385),(32586,'Bettongia_penicillata_ulna.tif',228,4,129,6.7803549,7.2974734,7.4997624,1.8,7.3111848,7.4739919,0.866901,2.2755329,4.1277857,6.05547,20.9968261,0.6567253,5.0867045,2.6611217,6.5368307,2.7002429,4.3715327,1.2490458,16.2062307),(32587,'Bettongia_penicillata_ulna.tif',228,4,130,1.4882183,9.5281498,9.5501672,1.8,9.485388,9.5562324,0.1655036,1.0076261,2.8224073,0.3267557,0.9527404,0.0067323,0.3375631,0.3242827,0.4509081,1.5884447,1.9900154,1.0974403,6.2995699),(32588,'Bettongia_penicillata_ulna.tif',228,4,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32589,'Bettongia_penicillata_ulna.tif',228,4,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32590,'Bettongia_penicillata_ulna.tif',228,4,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32591,'humerus.tif',231,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32592,'humerus.tif',231,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32593,'humerus.tif',231,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32594,'humerus.tif',231,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32595,'humerus.tif',231,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32596,'humerus.tif',231,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32597,'humerus.tif',231,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32598,'humerus.tif',231,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32599,'humerus.tif',231,2,9,3.9900844,13.7736069,12.0441448,1.8,13.7251032,12.0655779,-0.2089891,1.1233383,2.4617374,0.7376502,4.3881511,0.028625,1.7825424,0.656659,2.0528652,2.0491702,4.8779736,0.2090229,11.7319066),(32600,'humerus.tif',231,2,10,14.477999,14.0728259,13.4393723,1.8,14.3131849,14.6853622,1.3707551,3.7013138,12.4500876,36.0763657,126.632356,2.3177212,10.1712021,9.7469081,13.0537171,4.0493724,7.2245758,0.2425515,18.7210791),(32601,'humerus.tif',231,2,11,33.1956959,14.9912093,17.1485763,1.8,14.9592999,17.0264358,1.3382289,4.2110171,10.0805766,90.9052319,943.7409734,5.2387263,93.6197417,21.5874765,101.4836538,0,0,0,0),(32602,'humerus.tif',231,2,12,45.5446456,15.2368767,17.549129,1.8,15.2097974,17.5538016,1.2895138,4.4285852,10.287227,165.0827973,1261.1420963,7.0058665,122.593007,37.276645,137.3531159,0,0,0,0),(32603,'humerus.tif',231,2,13,56.5050008,15.3330379,17.72525,1.8,15.291524,17.7352543,1.2748377,4.7585917,11.0796826,232.5120987,1517.9546274,8.6164123,137.0034392,48.8615356,157.9818861,9.2160831,21.8034563,1.9513027,58.0139713),(32604,'humerus.tif',231,2,14,61.8643617,15.3888965,17.7131314,1.8,15.3417947,17.7045476,1.2692893,5.2113404,12.5732287,282.574162,2000.5457119,9.4014754,159.1115344,54.2229332,181.5856674,9.3154438,23.6159968,1.9535767,62.2497238),(32605,'humerus.tif',231,2,15,63.1685206,15.3353578,17.6263861,1.8,15.2962198,17.5856593,1.2825201,5.2346958,13.3564968,319.6397479,2550.896377,9.6771384,190.9854372,61.0617612,214.3909162,9.2790954,24.6770831,1.7475052,65.6487056),(32606,'humerus.tif',231,2,16,61.4701821,15.3740022,17.4043118,1.8,15.2995067,17.3753164,1.2891233,5.1688251,13.6568977,308.0282705,2773.5026223,9.4534634,203.0843819,59.5934792,225.4275797,9.1480034,25.5440117,1.7443208,66.4812198),(32607,'humerus.tif',231,2,17,59.2649294,15.3927068,17.4366439,1.8,15.3322979,17.5137141,1.3013853,4.9634225,13.7954903,262.262671,2832.9384304,9.1777358,205.3524999,52.8390788,224.3606509,8.8528423,25.7701595,1.745631,66.5308386),(32608,'humerus.tif',231,2,18,56.8406228,15.3729263,17.5618155,1.8,15.2625223,17.593279,1.3247955,4.8383847,13.8746379,221.971656,2957.8965674,8.9116104,213.1872983,45.8772239,229.1588033,8.6066854,25.7701595,1.745631,68.6955821),(32609,'humerus.tif',231,2,19,54.130503,15.2529939,17.9982949,1.8,15.1115485,17.7488865,1.3584119,4.4744894,14.1495566,176.8422871,3075.9368449,8.6208872,217.3875078,39.5223388,229.8763517,8.161561,25.6028798,1.7410517,68.0530302),(32610,'humerus.tif',231,2,20,45.3936604,14.3454935,17.2208725,1.8,14.3294259,17.2245666,1.4573722,4.3136709,12.8580303,98.976348,2700.3621192,7.4686949,210.0136693,22.9448075,217.0983189,6.1787116,25.2007778,1.7496234,64.3618385),(32611,'humerus.tif',231,2,21,43.9486618,14.1110039,16.9670863,1.8,14.075005,16.8533279,1.4932081,3.2630445,12.3059576,84.2451436,2468.724237,7.2807707,200.6121192,25.8179573,206.3468395,5.9343441,24.6059123,1.7480217,62.0773045),(32612,'humerus.tif',231,2,22,46.1147064,14.0099636,17.2037805,1.8,14.0001314,17.1790721,1.5165563,3.2738976,11.8857339,85.145941,2302.2894136,7.6631952,193.7019152,26.0075149,199.34529,5.9162168,23.7603157,1.7389465,59.2639893),(32613,'humerus.tif',231,2,23,46.7615734,13.9571233,17.0943737,1.8,13.9546025,17.1699667,1.5295401,3.3216076,11.9532741,88.5447904,2144.5758277,7.7803378,179.4132557,26.6572095,186.041424,6.065372,23.0160562,1.7158031,57.8470553),(32614,'humerus.tif',231,2,24,47.1375701,13.889864,16.8282784,1.8,13.8864653,17.1262084,1.5430557,3.2933183,12.2012268,97.3210643,2142.1343642,7.8502175,175.5671295,29.5510649,182.7024368,6.1455003,22.6086399,1.6380027,56.8493883),(32615,'humerus.tif',231,2,25,48.8773443,13.8893648,16.7140957,1.8,13.8913152,17.1464318,1.5480364,3.1974867,12.3044662,104.3858764,2160.1168318,8.1420049,175.5555096,32.6462271,183.4174766,6.2042352,22.2301054,1.6261144,56.6098072),(32616,'humerus.tif',231,2,26,48.5519524,13.9083335,16.7076541,1.8,13.9054044,17.1502158,1.5508429,3.1626076,12.3033065,109.3790895,2061.1539028,8.0887707,167.5284527,34.5850969,176.0352748,6.258513,21.9374223,1.51804,55.8414449),(32617,'humerus.tif',231,2,27,46.3138273,13.9359869,17.027354,1.8,13.9144716,17.4545382,1.5609281,3.2019387,12.0418323,112.9488772,1844.2415824,7.7182195,153.1529038,35.275153,162.4406724,6.3311149,21.6568382,1.5106682,58.5845884),(32618,'humerus.tif',231,2,28,44.9926518,14.0034582,17.3638812,1.8,13.9574852,17.7888784,-1.559178,3.1969246,11.630731,115.588572,1645.9670209,7.4977631,141.5187933,36.1561774,151.3704779,5.8661207,20.2405148,1.6889485,47.5012535),(32619,'humerus.tif',231,2,29,44.4996478,14.0921541,17.506316,1.8,14.0398527,17.9087417,-1.5303472,3.3518449,11.4997231,119.0612288,1515.448007,7.40448,131.7812604,35.5211037,142.1284947,6.0159936,19.6492469,1.6851106,46.4539676),(32620,'humerus.tif',231,2,30,46.0237697,14.2333532,17.3857014,1.8,14.1811259,17.7868034,-1.492066,3.5736948,11.6381163,126.9206394,1437.33499,7.6231803,123.5023741,35.5152432,134.4063248,6.6298077,20.706726,1.4412443,56.500293),(32621,'humerus.tif',231,2,31,48.2467976,14.3365216,17.4011252,1.8,14.2698531,17.7889096,-1.4591102,3.7680298,11.6421843,132.0001001,1400.902794,7.9412459,120.3298932,35.0315967,131.6498633,6.7443008,20.4098696,1.4178777,53.6899877),(32622,'humerus.tif',231,2,32,47.4401945,14.4116334,17.3333986,1.8,14.3318333,17.7748613,-1.4375206,3.8415513,11.7412303,133.4152337,1296.2142354,7.7670865,110.3985019,34.7295198,121.7495924,6.8308781,20.099531,1.4009168,51.9372447),(32623,'humerus.tif',231,2,33,47.4394747,14.4152495,17.455276,1.8,14.3511855,17.8976673,-1.41885,3.8330772,11.687663,131.6913855,1244.6566341,7.725435,106.4932001,34.3565699,117.7011163,6.8572541,19.836702,1.372686,50.8330734),(32624,'humerus.tif',231,2,34,46.9472339,14.4541133,17.5448879,1.8,14.3927246,18.0076713,-1.4028207,3.8639503,11.6104317,131.6083972,1158.2435306,7.605832,99.7588685,34.0605821,111.0164005,6.9354523,19.4718017,1.3537383,49.6163781),(32625,'humerus.tif',231,2,35,48.7882629,14.5115973,17.5614448,1.8,14.4504887,17.9623201,-1.385817,3.8764838,11.6089563,131.424193,1090.9856704,7.8563019,93.9779289,33.9029386,105.2007232,7.0065621,19.080764,1.3414414,48.3676068),(32626,'humerus.tif',231,2,36,50.8036452,14.5428012,17.6852857,1.8,14.4754423,18.04816,-1.3690164,3.8908715,11.456454,128.5584429,1044.1281727,8.1271816,91.1388617,33.0410408,102.2935374,7.0427647,18.6578841,1.3201786,47.5847115),(32627,'humerus.tif',231,2,37,48.5067845,14.5700981,17.7979424,1.8,14.5090178,18.1676171,-1.3533858,3.8623814,11.2894622,127.5493171,995.1526331,7.7083159,88.1488081,33.0234908,99.3658723,7.0977738,18.2244776,1.3017607,46.2058732),(32628,'humerus.tif',231,2,38,47.3242345,14.601977,17.848524,1.8,14.5304833,18.2192362,-1.335375,3.8221417,11.2010909,125.7034087,946.8498698,7.4582457,84.5319336,32.8882122,95.6740756,7.1182454,17.8465349,1.2874884,46.4103685),(32629,'humerus.tif',231,2,39,47.9213283,14.6621908,17.8243211,1.8,14.5781181,18.2115452,-1.3170459,3.8112177,11.1075214,126.3237727,887.8063828,7.4835615,79.9283972,33.145252,91.2067377,7.1564321,17.4304497,1.2805314,44.3581491),(32630,'humerus.tif',231,2,40,50.0043524,14.7241669,17.7736007,1.8,14.635871,18.1251911,-1.2992616,3.8057962,11.0617379,127.6815892,822.1182793,7.7345336,74.3208964,33.5492448,85.7831572,7.2249959,17.0801011,1.2610934,43.5927967),(32631,'humerus.tif',231,2,41,48.931414,14.7635717,17.7932363,1.8,14.6879932,18.0999169,-1.2821585,3.8226974,10.8363947,129.863585,756.5820165,7.4944683,69.8186102,33.9717146,81.692466,7.3394419,16.647537,1.2298174,42.7251966),(32632,'humerus.tif',231,2,42,47.5287488,14.8071874,17.821544,1.8,14.7176435,18.1231384,-1.2602533,3.853057,10.5766577,132.0949489,703.2309647,7.1817797,66.4889597,34.2831548,78.8815218,7.4182248,16.2559286,1.2448264,42.0693584),(32633,'humerus.tif',231,2,43,47.7209276,14.8733513,17.7652506,1.8,14.7568944,18.0607743,-1.2359519,3.8785066,10.3388156,134.127593,643.3660973,7.0945702,62.2282205,34.5822776,75.0247022,7.4491214,15.7822809,1.2200684,40.7679583),(32634,'humerus.tif',231,2,44,47.0684644,14.9262992,17.7374995,1.8,14.8109039,18.0021486,-1.2122114,3.8886059,10.050482,137.8529172,587.0894491,6.8785419,58.4140589,35.4504724,71.9452898,7.5347756,15.3931105,1.2208215,40.5313871),(32635,'humerus.tif',231,2,45,47.8472293,14.9930666,17.7001354,1.8,14.8719654,17.9222054,-1.1867027,3.8832789,9.7804183,140.8433957,545.3074628,6.8547993,55.7550247,36.2691938,69.9627803,7.5408346,14.9550945,1.2306992,39.1598153),(32636,'humerus.tif',231,2,46,47.2007666,15.0672431,17.6632062,1.8,14.9525242,17.8377847,-1.1611768,3.8999328,9.4416511,144.9000073,507.9929238,6.6190319,53.8033992,37.1544885,68.7082382,7.5897396,14.5186256,1.2411719,37.9503865),(32637,'humerus.tif',231,2,47,47.4398492,15.1942185,17.5802781,1.8,15.093143,17.7242835,-1.1261976,3.9506769,9.1703852,148.9352089,471.9039135,6.444053,51.4595517,37.698656,67.0965698,7.634992,14.1532681,1.2377377,37.0301577),(32638,'humerus.tif',231,2,48,47.5895463,15.3179391,17.5105232,1.8,15.2329371,17.631916,-1.0907603,3.9785838,8.885914,152.6798571,437.5786851,6.2400245,49.2440827,38.3754285,65.642939,7.6629902,13.6983228,1.2707452,36.5013765),(32639,'humerus.tif',231,2,49,46.6313261,15.4626635,17.4169478,1.8,15.3962052,17.5183931,-1.0448581,4.0276873,8.6180173,157.0209332,392.5850733,5.8131484,45.5539899,38.9853831,62.5723948,7.7227583,13.3979534,1.2524587,36.0778529),(32640,'humerus.tif',231,2,50,45.3306293,15.6630453,17.2650907,1.8,15.6273054,17.3100102,-0.9678942,4.1229994,8.3890601,161.8729199,332.4118262,5.1259194,39.624442,39.2609612,56.9991944,7.6349133,10.5926291,0.7419473,30.1038904),(32641,'humerus.tif',231,2,51,44.6113326,15.8337736,17.1728775,1.8,15.794361,17.2311414,-0.8594772,4.2147356,8.0178672,165.52463,295.790546,4.2663922,36.8914249,39.2728385,54.4148487,7.6839495,10.2094159,0.6548321,29.8074239),(32642,'humerus.tif',231,2,52,43.3984364,16.0284754,17.0726657,1.8,16.0007919,17.1110443,-0.6919749,4.3374821,7.2795176,165.5312523,268.2573451,2.9447241,36.8509784,38.1629821,52.8143457,7.663816,10.032,0.5540157,29.4232427),(32643,'humerus.tif',231,2,53,42.5746881,16.2267629,17.0089764,1.8,16.2135982,17.0110377,-0.5018643,4.370795,5.0375606,162.5607786,255.4785122,1.6421021,50.7147274,37.1924966,78.0300622,7.628737,9.9999034,0.505694,29.3633475),(32644,'humerus.tif',231,2,54,41.8098499,16.4209826,16.9748842,1.8,16.4158904,16.9734673,-0.3753862,4.3367648,5.1227009,160.4230849,255.2931075,0.9366724,49.8356456,36.9914195,76.7377961,7.5685936,10.0291337,0.3764903,29.3034522),(32645,'humerus.tif',231,2,55,41.5270074,16.6149026,16.9376389,1.8,16.6173886,16.9359776,-0.2601867,4.2529486,5.4169469,158.3248124,260.6442328,0.4580651,48.1164458,37.2270691,75.0209967,7.5450226,10.1747967,0.3105151,29.4904045),(32646,'humerus.tif',231,2,56,41.9433751,16.8273142,16.9014389,1.8,16.8387119,16.8981763,-0.1675914,4.1664844,5.7064328,156.9931693,271.3229537,0.1945118,47.5468583,37.6800093,73.6583448,7.5228532,10.3830457,0.2247112,29.7197093),(32647,'humerus.tif',231,2,57,42.0669153,17.0619853,16.8723517,1.8,17.0874796,16.8742951,-0.0926792,4.1195187,5.9583332,155.5427504,284.9650619,0.0600496,47.8263052,37.7575058,73.0031511,7.5228532,10.6061912,0.192048,30.1111569),(32648,'humerus.tif',231,2,58,42.1182803,17.3116035,16.8517754,1.8,17.3547583,16.8583562,-0.0352773,4.0371227,6.244311,154.4879647,301.9591143,0.0087323,48.3574753,38.266849,72.4616801,7.5304764,10.9002896,0.1531536,30.5873093),(32649,'humerus.tif',231,2,59,42.2827107,17.5853333,16.8349915,1.8,17.6557806,16.8454171,0.0077339,3.9591946,6.5677883,154.5948948,322.6952651,0.0004215,49.1330184,39.0470568,72.3590944,7.533091,11.258854,0.0964738,31.3702046),(32650,'humerus.tif',231,2,60,42.7804155,17.8786139,16.8262083,1.8,17.9845979,16.845491,0.0390555,3.9772434,6.871764,155.6863851,349.1876279,0.0108702,50.8148456,39.1442942,73.2960936,7.5248314,11.6492784,0.1181965,32.1779094),(32651,'humerus.tif',231,2,61,43.155941,18.1436473,16.8329076,1.8,18.3020233,16.8599243,0.0578106,3.962438,7.264094,158.4696331,390.0750867,0.0240115,53.699069,39.992962,75.4428218,7.5611409,12.1293895,0.0955168,33.2923571),(32652,'humerus.tif',231,2,62,43.8819724,18.426707,16.8546122,1.8,18.651515,16.8871979,0.0686597,3.9692602,7.6522295,162.287437,446.8076894,0.0344236,58.389217,40.8860667,79.4411862,7.5640923,12.6053143,0.0631344,34.5586713),(32653,'humerus.tif',231,2,63,44.2616143,18.7079162,16.8702711,1.8,18.9929333,16.9009445,0.0711518,4.0334471,7.9744264,167.0587833,495.1691678,0.0372834,62.0946439,41.4183649,82.6451059,7.639134,13.0990767,0.1551672,36.670786),(32654,'humerus.tif',231,2,64,44.0250318,18.9277084,16.8786457,1.8,19.2888899,16.9174553,0.0702635,4.1000177,8.2485881,171.4072661,525.3082059,0.0361654,63.6846206,41.8064693,84.2281488,7.6952272,13.4784737,0.1236897,36.9321667),(32655,'humerus.tif',231,2,65,43.6915535,19.1217683,16.8703347,1.8,19.5571678,16.9319134,0.0704538,4.1082345,8.4884362,175.3491081,551.2616917,0.0360858,64.9426678,42.6823514,85.3808875,7.7287373,13.9071833,0.1566019,38.4586148),(32656,'humerus.tif',231,2,66,43.4985998,19.3308303,16.8749749,1.8,19.832821,16.950849,0.0746545,4.1675756,8.5704866,179.208802,586.0528247,0.04033,68.380344,43.0007324,89.0987357,7.7809346,14.1105455,0.1491433,40.4757484),(32657,'humerus.tif',231,2,67,43.2804364,19.4722946,16.8647066,1.8,20.0169484,16.9504703,0.0738383,4.2258535,8.5231411,183.9350296,587.9940928,0.0392567,68.9879573,43.5261257,90.0971156,7.8807004,14.1327552,0.1592614,42.912149),(32658,'humerus.tif',231,2,68,42.8498528,19.584195,16.8579064,1.8,20.1290825,16.9397601,0.0750818,4.2966403,8.4960881,189.5751761,585.0864246,0.0401838,68.8653908,44.1217236,90.5330118,7.9530004,14.0999837,0.1440725,41.4383296),(32659,'humerus.tif',231,2,69,42.3820378,19.7008842,16.8441492,1.8,20.2961824,16.9402945,0.0801463,4.3536612,8.5184728,195.7188882,592.264303,0.0452759,69.5270521,44.9550109,92.0450199,8.0253004,14.1244307,0.1180059,40.9373678),(32660,'humerus.tif',231,2,70,42.3183171,19.8474616,16.820955,1.8,20.475155,16.9187986,0.0857911,4.4520386,8.4324809,203.8289995,602.1723454,0.0517841,71.4110538,45.7832958,94.7114068,8.1699004,14.1081374,0.1078276,41.2586437),(32661,'humerus.tif',231,2,71,41.9844405,19.9266535,16.7923405,1.8,20.5539965,16.8979597,0.0989563,4.5265093,8.4066081,213.5586623,600.6094483,0.0682977,71.4449202,47.1795477,96.2194084,8.3145004,14.0144563,0.0929952,39.7775578),(32662,'humerus.tif',231,2,72,41.8344664,20.0120536,16.753488,1.8,20.6310536,16.8696688,0.1193791,4.5934017,8.2811797,225.8040506,605.2976614,0.0988953,73.0931679,49.1583506,99.7463705,8.5314004,13.904364,3.0843635,39.0370149),(32663,'humerus.tif',231,2,73,42.2091984,20.0744263,16.702743,1.8,20.6873321,16.8207986,0.1376973,4.6762399,8.1503653,240.9734365,600.0858833,0.1325441,73.6268699,51.5314528,102.8208849,8.6760004,13.7797434,3.0628087,38.6455672),(32664,'humerus.tif',231,2,74,42.786651,20.1816332,16.658123,1.8,20.7553348,16.76552,0.1603907,4.7922724,7.8994698,259.787507,608.1397508,0.1818813,76.9848825,54.20967,109.6935229,8.9652004,13.6248584,0.069039,38.4937007),(32665,'humerus.tif',231,2,75,42.6334561,20.2225771,16.6483607,1.8,20.7639517,16.7426613,0.1817346,4.9337106,7.7004221,273.4745468,599.4721113,0.232107,77.849253,55.4297912,113.3316557,9.1098004,13.5038524,0.0911446,38.408996),(32666,'humerus.tif',231,2,76,43.3622348,20.1781863,16.5504924,1.8,20.7209401,16.6223531,0.2278458,5.0676472,7.6302438,303.1045173,591.1513371,0.3687347,77.474764,59.8116854,117.0738347,9.5074142,13.4137454,0.0755317,38.9129677),(32667,'humerus.tif',231,2,77,42.998407,20.2188282,16.588016,1.8,20.7437454,16.6556304,0.2607596,5.1313438,7.4166181,313.4934854,586.1436571,0.4763387,79.0311226,61.0938378,120.9721143,9.5547209,13.215879,0.0931364,38.8530724),(32668,'humerus.tif',231,2,78,43.0914288,20.2769783,16.6420212,1.8,20.7759233,16.6976799,0.2996669,5.144765,7.2038355,325.2286985,586.5477544,0.6258613,81.4215925,63.2154624,126.1674638,9.5951416,13.0940875,0.1106572,38.7084724),(32669,'humerus.tif',231,2,79,42.7462666,20.2826653,16.6458832,1.8,20.7844248,16.6995234,0.3283869,5.1986204,7.068732,337.8554296,587.4970093,0.7410559,83.1120784,64.9894402,130.3698581,9.6948327,13.0144023,0.1057493,38.8355295),(32670,'humerus.tif',231,2,80,42.5325407,20.2661028,16.6780263,1.8,20.7606335,16.7242024,0.3782776,5.1988657,6.9558062,354.4089664,585.9422019,0.966889,84.2378562,68.1704406,134.7053221,9.7867715,12.9999347,2.3089855,39.2269771),(32671,'humerus.tif',231,2,81,42.5735015,20.2982029,16.7039295,1.8,20.7969805,16.7520524,0.4233977,5.1308852,6.8166594,371.0661047,588.0496667,1.1977797,86.2665464,72.320095,139.1720662,9.8250847,13.1094481,2.2507052,39.7309488),(32672,'humerus.tif',231,2,82,41.7053595,20.2373732,16.7023718,1.8,20.7417726,16.7849207,0.4888779,5.0684113,6.8217811,385.8800835,570.4266311,1.5330719,83.6184313,76.1343271,138.5188356,9.9093993,13.2626666,2.1935807,40.0128823),(32673,'humerus.tif',231,2,83,41.6014994,20.2448308,16.6855114,1.8,20.744659,16.7958804,0.5400511,5.0213721,6.7523412,407.1931064,565.521367,1.8331067,83.7518943,81.0919995,141.5339141,9.9800269,13.4660576,2.1185822,40.5767493),(32674,'humerus.tif',231,2,84,41.2055076,20.257607,16.7165615,1.8,20.7059949,16.82152,0.625002,5.255226,6.7167228,422.585166,562.4146532,2.3510539,83.7334914,80.4123678,143.1304414,10.0777546,13.7455598,2.057969,41.2749399),(32675,'humerus.tif',231,2,85,40.6131651,20.2040598,16.7310283,1.8,20.6065041,16.824303,0.8023729,5.8645881,6.8854944,432.610622,558.2592178,3.4993079,81.0775792,73.7665821,140.2955802,10.1853438,14.0219142,1.9790733,41.3699211),(32676,'humerus.tif',231,2,86,40.6267939,20.2107154,16.7854073,1.8,20.5594129,16.9435509,0.9425223,6.1846745,7.1122045,436.8635977,574.7845726,4.4320503,80.8166545,70.6364736,140.2083175,10.3021033,14.3267159,1.9372455,41.821264),(32677,'humerus.tif',231,2,87,40.4735176,20.2444053,16.7736753,1.8,20.6144864,16.9565624,1.0732983,6.3301415,7.3286856,443.2779042,579.618667,5.2092998,79.0890339,70.0265393,138.7761347,10.6201231,14.5703791,1.8627284,42.6289688),(32678,'humerus.tif',231,2,88,40.7191454,20.2662805,16.844699,1.8,20.6591337,17.0345273,1.1204165,6.3489956,7.3730783,446.0586659,590.3717017,5.5005281,80.0712642,70.2565724,139.9425932,10.9752488,14.7509726,1.7931867,42.9780641),(32679,'humerus.tif',231,2,89,41.2610442,20.1671593,16.7749927,1.8,20.5143732,16.9698354,1.2221345,6.4287493,7.5794873,453.5581624,602.039269,6.0741883,79.430078,70.5515396,138.9443455,10.9015867,14.8707943,1.8263878,43.4717594),(32680,'humerus.tif',231,2,90,39.5299342,20.1156365,16.6649806,1.8,20.4507521,16.861083,1.3199001,6.34825,7.7474946,443.8693804,597.8603332,6.1822241,77.1682151,69.9199587,134.4516466,10.7664945,14.9784948,1.7947008,43.3695117),(32681,'humerus.tif',231,2,91,39.1909677,20.0255309,16.5971998,1.8,20.2641328,16.8331088,1.3717136,6.3501047,7.8305092,438.314802,612.2531096,6.2763481,78.1881608,69.0248151,134.0503521,10.6740573,15.0585478,1.7738415,43.284807),(32682,'humerus.tif',231,2,92,38.2720452,19.8931768,16.4650921,1.8,20.0983863,16.6638991,1.4608951,6.2934467,7.8581168,437.0169969,609.8207035,6.3019405,77.6039248,69.4400094,132.0997456,10.5932095,15.0441349,1.7691344,43.541931),(32683,'humerus.tif',231,2,93,38.080914,19.8174616,16.3429485,1.8,20.0192893,16.4961515,1.5664119,6.1489721,7.7407712,440.8435723,607.8350882,6.346697,78.523841,71.6938647,132.0797788,10.5204922,15.0359673,1.7398976,43.4469499),(32684,'humerus.tif',231,2,94,37.8096187,19.7635848,16.2405291,1.8,19.9414702,16.4153144,-1.5201094,6.0756375,7.6921305,443.3922423,615.9790253,6.2854271,80.0791183,72.9787193,133.2698177,10.4777642,15.0483039,1.7446336,43.4820358),(32685,'humerus.tif',231,2,95,37.4367374,19.7268682,16.1841527,1.8,19.9272858,16.3263197,-1.5113557,6.0810479,7.6769757,441.4661247,627.5838019,6.217437,81.7488331,72.5970472,135.1350283,10.4847458,15.0483039,1.7446336,43.7113405),(32686,'humerus.tif',231,2,96,37.1123881,19.6801287,16.0808709,1.8,19.8758185,16.2044777,-1.4645603,6.0270945,7.636156,445.1434945,628.4218654,6.1158512,82.2955775,73.857062,135.2744383,10.467961,15.0836938,1.7296409,43.8910263),(32687,'humerus.tif',231,2,97,36.5495683,19.6452932,15.9862207,1.8,19.9055072,16.0505029,-1.4420982,6.0091963,7.6312914,443.50768,635.0403519,5.9912542,83.2153195,73.8048248,136.110506,10.4299625,15.1438739,1.7241716,44.0356263),(32688,'humerus.tif',231,2,98,36.469334,19.5786791,15.9446939,1.8,19.8481869,16.0053602,-1.443948,6.0753874,7.5956732,446.3506893,652.3602759,5.9809441,85.8857743,73.4686799,139.6319614,10.4666013,15.2271772,1.6945624,44.3423693),(32689,'humerus.tif',231,2,99,36.9617595,19.5186056,15.9315557,1.8,19.7193091,15.9722515,-1.4483545,6.1197538,7.5642224,453.5516963,668.4037072,6.0683988,88.3638362,74.1127356,143.6880774,10.5214615,15.3079785,1.6986662,44.5644075),(32690,'humerus.tif',231,2,100,37.024399,19.449985,15.8993459,1.8,19.658646,15.9177169,-1.4436679,6.1547931,7.5078848,459.4392207,700.0396432,6.0715402,93.2405943,74.6473862,149.4751027,10.5880226,15.3890349,1.7027269,44.7864457),(32691,'humerus.tif',231,2,101,38.2922239,19.3574706,15.7790662,1.8,19.5575455,15.7667351,-1.4145222,6.2034472,7.4479681,481.3537808,730.3753556,6.2274425,98.0637062,77.5945645,158.0952877,10.7445089,15.3270891,1.7080236,45.0157504),(32692,'humerus.tif',231,2,102,39.0718415,19.1674245,15.748942,1.8,19.3250072,15.7191268,-1.3896445,6.354849,7.5507653,507.9351896,739.3545533,6.300604,97.9178298,79.9287587,161.2263966,10.8995805,15.3620069,1.6887299,45.5517981),(32693,'humerus.tif',231,2,103,39.1699064,18.9948433,15.7833651,1.8,19.0988896,15.7260486,-1.3798744,6.5098771,7.7491572,518.308561,750.8329375,6.2932302,96.8922063,79.6187934,160.197317,11.1081862,15.4424413,1.6928284,46.0454934),(32694,'humerus.tif',231,2,104,39.6754491,18.9652879,15.7563509,1.8,19.1049561,15.6539557,-1.3381011,6.462403,7.7988604,543.3209369,763.0739507,6.2609395,97.8442887,84.0741348,161.892669,11.3553596,15.6040761,1.7008984,46.8459317),(32695,'humerus.tif',231,2,105,39.0586336,18.9420331,15.7469756,1.8,19.0707547,15.6731226,-1.3155521,6.4889341,7.8731404,563.4699753,769.0898365,6.0947938,97.6852691,86.8355209,161.5607708,11.6809475,15.7769806,1.6763929,47.4243317),(32696,'humerus.tif',231,2,106,38.4166404,18.7956961,15.7913203,1.8,18.965036,15.6244813,-1.255621,6.524592,7.9565171,568.5027726,777.213871,5.7875337,97.6826752,87.1323103,158.7474675,11.9432647,16.0435972,1.7018589,48.4468081),(32697,'humerus.tif',231,2,107,37.5330456,18.5245713,15.8000184,1.8,18.7670673,15.5894524,-1.2124357,6.7084073,8.0537868,569.3462928,780.2338144,5.4859666,96.8778827,84.8705615,156.0232918,12.2661376,16.2880531,1.7133211,49.494094),(32698,'humerus.tif',231,2,108,38.3141942,18.3023315,15.9153358,1.8,18.667352,15.7105179,-0.9836831,6.5866748,7.6450988,622.0437804,804.0326425,4.4261089,105.1696868,94.439728,159.2880192,12.6059746,16.5846185,1.7151595,51.8705993),(32699,'humerus.tif',231,2,109,39.8631063,17.9846272,15.9427406,1.8,18.3109433,15.7803612,-0.8591833,7.2299403,7.9766029,675.3619195,857.6515805,3.810366,107.5209077,93.4118247,167.7865315,13.0291218,16.9028996,1.7253969,53.0800281),(32700,'humerus.tif',231,2,110,43.5914688,17.3262418,15.7874131,1.8,17.6633474,15.682334,-0.4694935,8.4328757,9.1187993,765.0775364,1005.802778,1.4871748,110.2999137,90.7255802,188.4301541,13.896538,17.2389651,1.7138796,55.9925811),(32701,'humerus.tif',231,2,111,50.4188552,15.899617,15.8955198,1.8,16.3065078,15.828549,-0.2245183,8.9422037,10.4835155,861.5703455,1551.6633436,0.4165198,148.0098294,96.3487722,230.0145141,15.6607773,19.5553801,0.1821683,64.1778961),(32702,'humerus.tif',231,2,112,54.9106752,15.2052864,15.9585856,1.8,15.6770176,15.897187,-0.1668239,9.1912734,11.1374053,953.1402339,1851.4437188,0.2523421,166.2365394,103.7005637,250.8786475,16.4191329,20.1490134,0.2354054,66.945849),(32703,'humerus.tif',231,2,113,58.3392041,14.8036451,16.1194349,1.8,15.1718498,16.1168144,-0.1364208,9.5290971,11.5255392,1127.415715,2028.0315281,0.1798352,175.9597968,118.3129635,272.6732327,17.0388768,20.4219035,0.1779536,69.2975448),(32704,'humerus.tif',231,2,114,61.0244693,14.4237206,16.2266189,1.8,14.897108,16.2056962,-0.1181909,9.7507509,11.9008039,1268.7757482,2153.889204,0.1414157,180.9868657,130.1208248,286.6783467,17.7065229,20.5995385,0.1160835,71.3146784),(32705,'humerus.tif',231,2,115,66.9152144,14.1110794,16.2525525,1.8,14.5862962,16.2008519,-0.021707,10.1348562,12.1038654,1522.1949432,2262.0033795,0.0052542,186.8827283,150.1940345,308.9070044,18.1199093,20.7161905,0.1330128,70.8179732),(32706,'humerus.tif',231,2,116,69.8060298,14.278044,16.275872,1.8,14.7718115,16.2699731,0.0568616,10.5240123,11.7574768,1745.4951769,2335.3867609,0.0375761,198.6299273,165.8583364,338.7151051,18.4557,20.6818453,0.1685969,68.5189062),(32707,'humerus.tif',231,2,117,75.6890789,14.4327513,16.1047664,1.8,14.8629202,16.1858637,0.0526714,10.5285364,11.5723898,2089.8335925,2386.6766426,0.0349648,206.2388733,198.4923176,378.8791695,18.5525042,20.5540657,0.1269728,68.3289439),(32708,'humerus.tif',231,2,118,80.4994548,14.8733038,15.8379484,1.8,15.288926,16.0040119,0.1976766,10.4017447,10.8656358,2381.5276798,2512.625918,0.5174732,231.2451814,228.9546369,435.0908943,18.5087653,20.2730292,0.1000235,68.568525),(32709,'humerus.tif',231,2,119,84.4511552,15.1729529,15.8792706,1.8,15.5446786,15.9738184,0.5293734,10.1909023,9.6290112,2396.2138338,2564.1827162,3.5894203,266.2976156,235.1326462,458.6383702,18.3929465,19.8798717,0.0837453,68.0718198),(32710,'humerus.tif',231,2,120,81.823464,15.0800569,15.9542359,1.8,15.5030632,15.9192829,0.647026,9.9802646,9.7173263,2175.7900753,2459.9301924,4.9556016,253.1488729,218.0092579,428.963325,17.9937069,19.5945014,1.8435208,67.570858),(32711,'humerus.tif',231,2,121,83.9284485,15.1750991,15.7940471,1.8,15.6427805,15.764194,1.0121117,10.0940454,9.7249606,2052.3560337,2394.8567276,10.0577679,246.2587591,203.3234407,421.1929094,17.4494957,19.4605233,1.872573,67.151591),(32712,'humerus.tif',231,2,122,91.2858106,15.3947257,15.6397157,1.8,15.8499302,15.585551,0.9413497,9.3979457,9.6328917,1908.9129093,2304.9613694,9.941561,239.2803162,203.1202313,411.8231663,16.5386207,19.0840512,2.0988708,65.9276292),(32713,'humerus.tif',231,2,123,94.1599272,15.6690474,15.5874443,1.8,16.0127453,15.5378898,1.0236219,9.0364187,9.2921983,1557.8008898,2172.0337674,11.4453371,233.748108,172.3914031,378.9116011,15.4075772,18.5388544,2.1252617,66.2724678),(32714,'humerus.tif',231,2,124,81.7579563,16.0511954,15.3504758,1.8,16.2326733,15.3443281,0.9236052,7.7067863,8.8327452,1035.5615307,1671.2863783,8.6725267,189.2148294,134.3700844,292.3037142,13.7762091,17.7953501,2.1272423,65.7642395),(32715,'humerus.tif',231,2,125,37.0023887,17.927909,14.609348,1.8,17.6910415,14.780484,0.994849,6.4362744,8.8769789,299.9337796,1032.2161674,4.3377821,116.280119,46.6005272,149.4858542,3.863681,9.7121808,1.1571071,23.7705562),(32716,'humerus.tif',231,2,126,12.9022119,17.4343932,13.1560871,1.8,17.8105781,13.639366,1.0827787,2.5759245,9.0923549,17.5768277,493.9656735,1.6776217,54.3275842,6.8235027,55.7992682,0,0,0,0),(32717,'humerus.tif',231,2,127,3.2254921,16.0841244,10.1566799,1.8,16.448016,10.7964875,1.0618955,1.3806859,11.3921267,1.2575222,50.6203814,0.4099702,4.4434532,0.9107953,4.5505484,0,0,0,0),(32718,'humerus.tif',231,2,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32719,'humerus.tif',231,2,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32720,'humerus.tif',231,2,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32721,'humerus.tif',231,2,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32722,'humerus.tif',231,2,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32723,'humerus.tif',231,2,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32724,'humerus.tif',231,2,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32725,'Macropus_agilis_radius.tif',231,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32726,'Macropus_agilis_radius.tif',231,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32727,'Macropus_agilis_radius.tif',231,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32728,'Macropus_agilis_radius.tif',231,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32729,'Macropus_agilis_radius.tif',231,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32730,'Macropus_agilis_radius.tif',231,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32731,'Macropus_agilis_radius.tif',231,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32732,'Macropus_agilis_radius.tif',231,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32733,'Macropus_agilis_radius.tif',231,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32734,'Macropus_agilis_radius.tif',231,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32735,'Macropus_agilis_radius.tif',231,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32736,'Macropus_agilis_radius.tif',231,3,12,0.2955228,22.2942091,22.2548255,1.8,22.3223089,22.2569852,1.5696536,0.2636241,1.0256628,0.0025556,0.0590203,0.0492537,0.0575436,0.0096942,0.059756,3.2535002,3.3492933,1.8105394,10.6422684),(32737,'Macropus_agilis_radius.tif',231,3,13,2.0374324,31.1806753,14.5527293,1.8,31.175738,14.5449767,1.077972,0.7269278,1.4473476,0.1979845,0.8880557,0.2635627,0.6135746,0.2723579,0.7486258,1.520263,2.910019,2.0344439,7.1864012),(32738,'Macropus_agilis_radius.tif',231,3,14,4.7362139,30.9794846,15.0011172,1.8,31.0194221,14.9659495,1.2928289,1.3365214,2.0990215,1.6524154,3.8297737,0.7299324,1.8245519,1.2363554,2.6079268,2.6094283,3.8672055,1.9339433,10.7941349),(32739,'Macropus_agilis_radius.tif',231,3,15,11.9163403,30.1059045,17.0952434,1.8,30.1349784,17.0315056,-1.1616907,1.9193206,4.3227224,6.7898823,67.9463541,1.671791,15.7184172,3.5376488,16.9739885,3.7638448,8.3107274,1.1967519,24.4614803),(32740,'Macropus_agilis_radius.tif',231,3,16,21.4716807,29.3910893,17.8990171,1.8,29.3637456,17.8230294,-0.9621733,2.9049391,4.5921132,26.9124274,126.9902897,2.4088196,27.6539978,9.2643689,31.1799625,5.0623864,9.1464505,0.6846172,26.5487855),(32741,'Macropus_agilis_radius.tif',231,3,17,29.7923412,28.1216895,17.5847367,1.8,28.106628,17.6716956,-0.4918802,4.4508278,5.0585458,109.921341,193.828419,1.1075414,38.3170237,24.6968305,59.7161588,8.1034841,9.8948042,0.3818632,30.1317097),(32742,'Macropus_agilis_radius.tif',231,3,18,31.3535961,28.2245363,17.5841171,1.8,28.166796,17.7612077,-0.5401437,4.9948916,5.2292813,171.0236486,224.2663355,1.3819756,42.8866459,34.2397115,74.1495048,9.0381536,10.6622284,0.360358,32.106491),(32743,'Macropus_agilis_radius.tif',231,3,19,28.6937157,28.6189248,17.6842698,1.8,28.4770521,17.989702,-0.5248299,5.2673351,5.5237006,159.4345008,238.6132603,1.200674,43.1980802,30.2685319,69.7625747,9.1935004,11.0429824,0.3196802,33.5482344),(32744,'Macropus_agilis_radius.tif',231,3,20,26.0707244,28.4905456,17.6425991,1.8,28.6258085,18.0110804,-0.5154208,5.3477754,5.6058662,139.5341213,227.6098293,1.0556534,40.6020803,26.0919937,62.6974216,9.1373176,11.247241,0.1418971,33.8374344),(32745,'Macropus_agilis_radius.tif',231,3,21,22.8389365,28.4158933,17.6390109,1.8,28.6825871,18.012108,-0.3558714,5.7738192,5.9089522,142.7435737,186.191246,0.4620607,31.5100276,24.722557,53.4102062,9.2239428,11.0183402,0.0722425,33.8447009),(32746,'Macropus_agilis_radius.tif',231,3,22,18.4941219,28.5955394,18.0503852,1.8,28.7767858,18.2404811,-0.0669979,5.4953397,5.9105787,125.5697833,157.638417,0.0138151,26.6705556,22.8502311,47.9104091,9.3557381,10.7976612,0.1343214,33.682558),(32747,'Macropus_agilis_radius.tif',231,3,23,14.8879113,28.9833596,18.5611266,1.8,29.0780033,18.6663811,-0.4356942,4.901649,5.3427808,99.3532705,126.2918857,0.4419665,23.6378563,20.2693566,40.8679058,8.8355072,10.585718,0.0752004,31.7501291),(32748,'Macropus_agilis_radius.tif',231,3,24,13.7669802,29.0598043,18.8920845,1.8,29.1466215,18.9094219,-0.3460878,4.7096936,5.3503078,95.4455511,113.3976529,0.2640285,21.1946035,20.2657667,38.797258,8.5972372,10.4362745,0.0693331,31.2987862),(32749,'Macropus_agilis_radius.tif',231,3,25,13.0142246,29.2406294,18.9931968,1.8,29.2226094,19.0242282,-0.1850075,4.7279541,5.1259475,89.2127733,109.8878238,0.0733981,21.4375631,18.8692131,37.6970816,8.4119142,10.2790672,0.0492559,30.6925668),(32750,'Macropus_agilis_radius.tif',231,3,26,12.8838284,29.1636166,19.2758745,1.8,29.1062853,19.291697,-0.0469314,4.5317417,5.078296,90.747453,105.9958119,0.0047261,20.8723185,20.0248513,38.2478559,8.214737,10.0562002,0.0359557,30.2061381),(32751,'Macropus_agilis_radius.tif',231,3,27,13.0448537,29.2515759,19.5089715,1.8,29.1663728,19.6245365,-0.04767,4.3568497,4.9299298,86.3343672,108.5142272,0.0049368,22.0113128,19.8157783,38.4285426,7.9731477,9.8543075,0.0660801,29.5926522),(32752,'Macropus_agilis_radius.tif',231,3,28,12.6426732,29.3443564,19.7937749,1.8,29.2610093,19.8982891,-0.1433468,4.0868513,4.8751998,81.1359605,104.5178799,0.0430019,21.4386863,19.8529272,36.590685,7.7825637,9.5897717,3.0434244,29.0463281),(32753,'Macropus_agilis_radius.tif',231,3,29,12.4280817,29.5568496,19.9291723,1.8,29.4896549,19.9740565,-0.1195171,4.0010921,4.6781595,74.5723028,98.0454875,0.0294472,20.9581328,18.6379872,33.5010688,7.6457296,9.4059498,3.1031501,28.6373375),(32754,'Macropus_agilis_radius.tif',231,3,30,12.7634753,29.5322328,20.052278,1.8,29.4290905,20.0157558,-0.2058024,3.9348995,4.6407522,75.346835,97.3356954,0.0888339,20.9741202,19.1483503,34.614668,7.579436,9.2300802,3.0395857,28.372947),(32755,'Macropus_agilis_radius.tif',231,3,31,13.1184849,29.3762011,20.1516527,1.8,29.2254086,20.1111221,-0.0906564,4.0042907,4.7018947,74.2865175,97.3967747,0.01792,20.7143677,18.5517294,35.7298646,7.4469003,9.382301,0.4981167,28.6796899),(32756,'Macropus_agilis_radius.tif',231,3,32,12.6318391,29.4541105,20.3480264,1.8,29.3128396,20.2931057,-0.1193716,3.8846318,4.670656,69.6501569,94.555201,0.0298575,20.2445226,17.9296676,33.6407764,7.3023003,9.7054508,0.4969686,28.9688899),(32757,'Macropus_agilis_radius.tif',231,3,33,12.7796124,29.4835537,20.5320534,1.8,29.3582686,20.517236,-0.1860077,3.7788478,4.7138172,67.9899689,96.6124568,0.0728474,20.4955885,17.9922484,34.4383346,7.3023003,9.506282,0.456845,28.4080328),(32758,'Macropus_agilis_radius.tif',231,3,34,12.7705671,29.5784819,20.7006369,1.8,29.5016407,20.6756917,-0.279539,3.6699649,4.6967416,65.6956368,96.826724,0.1620324,20.6157229,17.9008897,34.3614997,7.2171151,9.4746113,0.4499966,28.2882422),(32759,'Macropus_agilis_radius.tif',231,3,35,12.8349695,29.624879,20.8721121,1.8,29.5767788,20.8381946,-0.3582327,3.703897,4.6884012,64.3466893,94.5401783,0.262976,20.1646945,17.3726995,33.8178519,7.1577003,8.9943064,0.6370703,26.634737),(32760,'Macropus_agilis_radius.tif',231,3,36,13.2527201,29.6260224,20.9735724,1.8,29.6078581,20.935717,-0.3749128,3.6055164,4.6903021,64.7390787,93.7418693,0.2961897,19.9863181,17.9555637,33.6728569,7.1271301,8.9514879,0.6305778,26.4054323),(32761,'Macropus_agilis_radius.tif',231,3,37,13.6436064,29.6670677,21.0626842,1.8,29.6432395,21.0275806,-0.3470265,3.5096111,4.6548719,65.5987183,92.7235402,0.2630263,19.9196758,18.6911643,33.9848758,7.0321637,8.9643258,0.7226236,26.1410417),(32762,'Macropus_agilis_radius.tif',231,3,38,13.6571222,29.7561568,21.1596238,1.8,29.7376033,21.1446168,-0.3549851,3.4963547,4.5812389,64.1163682,90.997214,0.2749847,19.8630141,18.3380616,33.8250525,6.9616342,8.9242926,0.7051113,25.9540893),(32763,'Macropus_agilis_radius.tif',231,3,39,13.6681422,29.8726143,21.2857002,1.8,29.8423764,21.2524536,-0.4006682,3.4352445,4.499497,62.3409725,90.5220582,0.3465472,20.1182618,18.147463,33.9667009,6.8918589,8.9584927,0.7340149,25.8693846),(32764,'Macropus_agilis_radius.tif',231,3,40,13.8692811,29.9697048,21.3684296,1.8,29.9267458,21.3594096,-0.4440533,3.4275328,4.4469939,61.8244245,90.5563396,0.4266165,20.3634954,18.0375878,34.1938578,6.839386,8.8870204,0.6874467,25.5626417),(32765,'Macropus_agilis_radius.tif',231,3,41,14.1079008,30.0467913,21.4533877,1.8,30.0009056,21.4467255,-0.4961497,3.4327999,4.3849839,61.3582588,90.882372,0.5328483,20.7258165,17.8741148,33.8462607,6.8044041,8.8870204,0.6874467,25.4180416),(32766,'Macropus_agilis_radius.tif',231,3,42,14.3002655,30.0878913,21.5535334,1.8,30.0518584,21.5407071,-0.5260119,3.4251769,4.3348858,60.6887067,90.4805068,0.6008322,20.8726392,17.7184153,33.9215123,6.7688565,8.8223781,0.7041819,25.3333369),(32767,'Macropus_agilis_radius.tif',231,3,43,14.395245,30.0972875,21.7088161,1.8,30.0638473,21.6938836,-0.5408856,3.4244453,4.3441408,59.7953056,89.6004024,0.6360714,20.6255752,17.4613112,33.90219,6.7395835,8.7602427,0.7211592,25.1288416),(32768,'Macropus_agilis_radius.tif',231,3,44,14.4184132,30.1322325,21.8203408,1.8,30.1117582,21.7980958,-0.5677947,3.417492,4.3037817,59.0331109,87.6370743,0.6949697,20.3628066,17.2738111,33.7388494,6.6994266,8.6738914,0.6968727,24.881994),(32769,'Macropus_agilis_radius.tif',231,3,45,14.5171544,30.1998157,21.9345608,1.8,30.1810086,21.9043572,-0.5849104,3.4390977,4.2644319,58.5962256,86.2109938,0.7375722,20.2162903,17.0382554,33.8432609,6.6764854,8.5635074,0.7077105,24.6774987),(32770,'Macropus_agilis_radius.tif',231,3,46,14.479131,30.2685332,22.040879,1.8,30.2483493,21.9989225,-0.5833318,3.4445218,4.20775,57.9277137,83.9215397,0.7321354,19.9445165,16.8173458,33.5049419,6.6469856,8.5086999,0.7132345,24.430651),(32771,'Macropus_agilis_radius.tif',231,3,47,14.353036,30.3268806,22.1498798,1.8,30.2966375,22.0862564,-0.5876562,3.4689501,4.1779243,56.7182121,81.859505,0.7352883,19.5933431,16.3502533,32.992162,6.6159303,8.4430184,0.7429993,24.2685081),(32772,'Macropus_agilis_radius.tif',231,3,48,14.4355258,30.3873047,22.2348888,1.8,30.3542164,22.1804607,-0.6131288,3.4623949,4.1328785,55.7800383,81.0958375,0.7966456,19.62212,16.1102473,32.7224995,6.5892083,8.3783819,0.6814794,24.1589939),(32773,'Macropus_agilis_radius.tif',231,3,49,14.4146307,30.4607095,22.3188494,1.8,30.422687,22.2630174,-0.612361,3.4786662,4.0796053,55.1311058,79.1762601,0.7937567,19.4078234,15.8483461,32.5494738,6.5319591,8.2766927,0.6801979,23.9544987),(32774,'Macropus_agilis_radius.tif',231,3,50,14.4530529,30.5117841,22.4087083,1.8,30.4706408,22.3542561,-0.5996504,3.4734297,4.0448116,54.6726679,77.3283777,0.767205,19.1179182,15.7402546,32.2032925,6.499699,8.2110653,0.6981205,23.852251),(32775,'Macropus_agilis_radius.tif',231,3,51,14.646211,30.5739888,22.4709691,1.8,30.5244763,22.4230483,-0.5910377,3.47388,3.9731968,54.6610148,76.2586635,0.7579353,19.1932761,15.7348597,32.3563744,6.490413,8.0937262,0.7221913,23.6054034),(32776,'Macropus_agilis_radius.tif',231,3,52,14.7827936,30.6359392,22.5445095,1.8,30.5748458,22.4876392,-0.5832462,3.4469203,3.9784652,54.2993455,74.895899,0.7472962,18.8253246,15.7530031,32.0065232,6.4355856,8.0282309,0.6705216,23.4432604),(32777,'Macropus_agilis_radius.tif',231,3,53,14.9407638,30.6882153,22.5992608,1.8,30.6223411,22.550113,-0.5800155,3.439607,3.9274036,54.1852024,73.4393096,0.7478959,18.699201,15.7533122,31.6378216,6.4156879,7.9520144,0.701723,23.2986604),(32778,'Macropus_agilis_radius.tif',231,3,54,15.0023007,30.7472358,22.6621053,1.8,30.692277,22.6106102,-0.5661886,3.4201302,3.891612,53.7479548,71.9643061,0.7194746,18.4921586,15.7151779,31.5909157,6.3792891,7.8836847,0.7334968,23.0766222),(32779,'Macropus_agilis_radius.tif',231,3,55,15.069721,30.8051609,22.7218684,1.8,30.7488798,22.6748448,-0.5438595,3.4066097,3.8288992,53.2988066,70.6582017,0.6724781,18.4539208,15.6457039,31.5511744,6.3517053,7.7876199,0.7197034,22.8896698),(32780,'Macropus_agilis_radius.tif',231,3,56,15.1993162,30.8603223,22.7685552,1.8,30.7986715,22.7231238,-0.522914,3.3897997,3.8077315,53.1731513,69.6592776,0.6318031,18.2941674,15.6862224,31.231828,6.3131489,7.7333971,0.7258659,22.7874222),(32781,'Macropus_agilis_radius.tif',231,3,57,15.3824775,30.9135618,22.8032469,1.8,30.848157,22.7626545,-0.5005495,3.3635577,3.6939576,53.0699782,68.895161,0.5904599,18.6507719,15.77793,31.2500487,6.3069088,7.5911561,0.7044941,22.7202604),(32782,'Macropus_agilis_radius.tif',231,3,58,15.4296033,30.9630449,22.8402503,1.8,30.9015903,22.7964287,-0.4741973,3.340018,3.6540361,52.9401932,67.171012,0.536194,18.3826898,15.8502717,31.158682,6.2657436,7.5362133,0.7107074,22.4982222),(32783,'Macropus_agilis_radius.tif',231,3,59,15.5399948,31.0065947,22.8880932,1.8,30.9428547,22.8413696,-0.4245394,3.3175857,3.6036035,52.6914595,66.0558546,0.4394259,18.3305002,15.8824714,29.3425085,6.225727,7.4426875,0.6959821,22.4734127),(32784,'Macropus_agilis_radius.tif',231,3,60,15.7800122,31.0501272,22.9208735,1.8,30.9798155,22.8838998,-0.4035208,3.299045,3.5583215,52.7626234,65.4425984,0.4054961,18.3914239,15.9933021,31.0548955,6.2153483,7.3965412,0.6884805,22.7378033),(32785,'Macropus_agilis_radius.tif',231,3,61,15.9125106,31.0969589,22.9541787,1.8,31.0317322,22.9126846,-0.3966101,3.239861,3.5098831,52.6108885,64.2687725,0.3957518,18.3108015,16.2386252,31.3579598,6.1661904,7.2775619,0.7150917,22.0644222),(32786,'Macropus_agilis_radius.tif',231,3,62,15.9201781,31.1567873,23.0045705,1.8,31.0917761,22.9587104,-0.3701203,3.2409224,3.4716589,51.6234013,63.4111773,0.3471842,18.2653825,15.9286138,30.9248769,6.1192521,7.2390322,0.6934595,22.2265651),(32787,'Macropus_agilis_radius.tif',231,3,63,15.8560105,31.204092,23.0580661,1.8,31.1512081,23.0095298,-0.3370651,3.1924075,3.4585747,50.5021809,62.4003439,0.2890417,18.0422137,15.8194655,31.2117984,6.0584063,7.1372226,0.6921442,21.6378887),(32788,'Macropus_agilis_radius.tif',231,3,64,15.7448051,31.2416226,23.1073675,1.8,31.1938545,23.0568506,-0.317889,3.1291797,3.4354939,49.4210138,61.2082588,0.2563649,17.8164365,15.7936004,30.2571607,6.0217809,7.1690111,0.7283174,21.986984),(32789,'Macropus_agilis_radius.tif',231,3,65,15.6294172,31.2824226,23.1442457,1.8,31.2417037,23.0914386,-0.2807447,3.1007091,3.4020142,48.6073543,59.7314297,0.1999744,17.5576662,15.6762059,29.6129036,5.9727229,7.1372226,0.6921442,21.6554316),(32790,'Macropus_agilis_radius.tif',231,3,66,15.5818671,31.3230415,23.1756026,1.8,31.2785477,23.1195742,-0.2403366,3.1095642,3.3764907,47.8702066,58.6608659,0.1471398,17.3733237,15.3945064,29.896523,5.9668056,7.026504,0.7052781,21.6905174),(32791,'Macropus_agilis_radius.tif',231,3,67,15.5954034,31.3667694,23.2024231,1.8,31.3259665,23.1453672,-0.1978776,3.0125065,3.3281629,47.2053226,57.6968599,0.100453,17.3359481,15.6697827,29.7383411,5.9115842,6.9648586,0.7266423,21.4684792),(32792,'Macropus_agilis_radius.tif',231,3,68,15.7248481,31.4095579,23.2229612,1.8,31.3663877,23.1652264,-0.1690498,3.0164717,3.3003205,46.5989093,57.343409,0.0741863,17.3751031,15.4481509,29.3594292,5.8563003,6.7130076,0.3865063,20.9324315),(32793,'Macropus_agilis_radius.tif',231,3,69,15.793865,31.4487178,23.2402363,1.8,31.417308,23.1808394,-0.1340079,2.928055,3.264971,45.9104501,56.7165381,0.0469891,17.3712228,15.6795042,29.2847652,5.8328318,6.6860892,0.3764903,20.6855839),(32794,'Macropus_agilis_radius.tif',231,3,70,15.9241231,31.4820504,23.2592908,1.8,31.4494761,23.2046672,-0.1158368,2.8919143,3.2563901,45.178558,56.2738839,0.0354531,17.2810636,15.6223709,28.8725349,5.7840003,6.6074451,0.4048918,20.7630221),(32795,'Macropus_agilis_radius.tif',231,3,71,15.9956251,31.5107846,23.281744,1.8,31.4844313,23.2237709,-0.0939211,2.8928042,3.2334947,44.3633896,55.5201987,0.0234476,17.1703386,15.3357732,29.2356727,5.7117003,6.5665759,0.3600593,20.4211933),(32796,'Macropus_agilis_radius.tif',231,3,72,16.0781762,31.5369281,23.3085418,1.8,31.5054818,23.25544,-0.0935171,2.8772314,3.2166069,43.6318892,54.7897031,0.0233669,17.0333847,15.1645396,29.1551477,5.6394003,6.5126212,0.3990609,20.2765933),(32797,'Macropus_agilis_radius.tif',231,3,73,16.0905264,31.564981,23.3352009,1.8,31.5313602,23.2902567,-0.0786365,2.8803564,3.190405,42.6577864,53.9438235,0.016549,16.9081429,14.8098985,28.6810032,5.6730692,6.457811,0.3784274,20.234241),(32798,'Macropus_agilis_radius.tif',231,3,74,16.1782264,31.5980516,23.3607412,1.8,31.565705,23.3178259,-0.0734833,2.87616,3.1618405,41.8922496,53.0954173,0.0145337,16.7925669,14.5653404,28.5347578,5.6394003,6.5725435,0.6919214,20.6607745),(32799,'Macropus_agilis_radius.tif',231,3,75,16.1594296,31.6289182,23.3853731,1.8,31.6058604,23.3416221,-0.0764722,2.8596345,3.1572364,40.8326107,51.9797197,0.0157194,16.463677,14.2789612,27.8004753,5.5671003,6.3512991,0.3974181,20.0472886),(32800,'Macropus_agilis_radius.tif',231,3,76,16.2533108,31.6639277,23.4089976,1.8,31.6463865,23.3633286,-0.0733149,2.8444277,3.1240098,39.9094918,51.1445887,0.0145344,16.3714558,14.0307635,27.5248398,5.5671003,6.3244942,2.9576492,19.8427933),(32801,'Macropus_agilis_radius.tif',231,3,77,16.3046973,31.689537,23.434015,1.8,31.6743397,23.3971635,-0.0756146,2.8284908,3.1059189,39.0107498,50.0636703,0.0155076,16.1187952,13.7920724,27.0439948,5.4948003,6.4707493,0.6904465,20.8652697),(32802,'Macropus_agilis_radius.tif',231,3,78,16.3248284,31.7089065,23.4519345,1.8,31.6903825,23.4163265,-0.0734112,2.8438995,3.0876085,38.029924,48.8651301,0.0146367,15.8262065,13.3724571,26.8369129,5.4948003,6.3906823,0.7773983,20.3116792),(32803,'Macropus_agilis_radius.tif',231,3,79,16.3542299,31.7195484,23.4728288,1.8,31.6996083,23.4394715,-0.0839534,2.8239191,3.0802946,37.1363428,47.7363255,0.0191661,15.4973246,13.1506399,25.7771033,5.491502,6.4004903,0.7294566,20.3715744),(32804,'Macropus_agilis_radius.tif',231,3,80,16.3032761,31.725652,23.4927081,1.8,31.7045138,23.4658176,-0.0981119,2.8052039,3.0709198,36.1358594,46.4972715,0.0260719,15.1411545,12.8817228,25.6188049,5.4225003,6.3050412,0.7123576,20.0648315),(32805,'Macropus_agilis_radius.tif',231,3,81,16.2402949,31.7390092,23.5123022,1.8,31.7168795,23.4893217,-0.1005069,2.7908134,3.0452129,35.2680352,45.3072704,0.0272503,14.8781946,12.6371887,25.3077153,5.4222081,6.2446447,0.7362574,19.8355268),(32806,'Macropus_agilis_radius.tif',231,3,82,16.1831186,31.7391684,23.5340229,1.8,31.7155831,23.5167591,-0.1178277,2.7724427,3.0165634,34.3475715,44.2519939,0.037273,14.6696715,12.3889203,24.81997,5.3502002,6.2114919,0.6947383,19.8004409),(32807,'Macropus_agilis_radius.tif',231,3,83,16.1405248,31.7402065,23.5568403,1.8,31.7237186,23.5362352,-0.1407322,2.7532827,3.0036655,33.4181609,43.2022446,0.0529279,14.3831744,12.1375697,24.3278579,5.3502002,6.0026422,2.9843646,18.9927362),(32808,'Macropus_agilis_radius.tif',231,3,84,16.1971171,31.7436358,23.5805155,1.8,31.7293755,23.558922,-0.1730751,2.7200236,2.9961742,32.6192245,42.2906208,0.0800599,14.1148736,11.9922579,23.5659637,5.2779002,5.962011,0.6823166,18.6684503),(32809,'Macropus_agilis_radius.tif',231,3,85,16.0942975,31.7452554,23.60107,1.8,31.726578,23.5807652,-0.2013802,2.6760617,2.9934471,31.755409,41.3425803,0.1073188,13.8110274,11.866471,23.4432919,5.2056002,6.1484766,0.71883,19.204498),(32810,'Macropus_agilis_radius.tif',231,3,86,16.0495884,31.7399106,23.6208068,1.8,31.7226151,23.5952814,-0.2393658,2.6366081,2.9757067,30.9885489,40.651097,0.150358,13.660989,11.7531875,23.0230866,5.2056002,6.1425225,0.8353566,18.9751933),(32811,'Macropus_agilis_radius.tif',231,3,87,15.9651501,31.7389349,23.6344124,1.8,31.7167226,23.6120012,-0.2660307,2.6138984,2.9726055,30.1093936,39.8065942,0.1839144,13.3911459,11.5189609,22.6397325,5.2024236,6.138266,0.7520772,18.9751933),(32812,'Macropus_agilis_radius.tif',231,3,88,15.8518756,31.7268008,23.642964,1.8,31.7123642,23.6279592,-0.3073803,2.5899773,2.9844751,29.2690752,38.9005922,0.241858,13.0343163,11.3009002,22.1768887,5.1467199,6.0942513,0.7266423,18.608555),(32813,'Macropus_agilis_radius.tif',231,3,89,15.9523582,31.7249275,23.6500894,1.8,31.7108911,23.6287822,-0.3252381,2.5575029,2.9895562,28.6564294,38.3319166,0.271462,12.8219422,11.2048475,22.0645422,5.1028788,6.0464593,0.7177051,18.3441645),(32814,'Macropus_agilis_radius.tif',231,3,90,16.0555952,31.7298758,23.6549998,1.8,31.7209264,23.6353353,-0.3338862,2.5476468,2.9673714,28.0956493,38.0691238,0.2873911,12.8292413,11.0280784,21.4935105,5.0611404,6.0891027,0.7434061,18.5238503),(32815,'Macropus_agilis_radius.tif',231,3,91,16.0971806,31.7289867,23.6601494,1.8,31.7180359,23.644774,-0.3465121,2.5197457,2.9686275,27.4484298,37.7659572,0.3094449,12.7216894,10.8933333,21.5206989,5.0154241,6.0404046,0.7345945,18.2770027),(32816,'Macropus_agilis_radius.tif',231,3,92,16.0701016,31.7255313,23.6604359,1.8,31.7155761,23.6424248,-0.3521705,2.5125053,2.9724897,26.8321418,37.576416,0.3186722,12.6413949,10.6794369,21.2707686,4.9628272,6.0360761,0.8192835,18.5413932),(32817,'Macropus_agilis_radius.tif',231,3,93,16.1369942,31.7293393,23.6633799,1.8,31.7183522,23.6473627,-0.3581169,2.4886872,2.9703937,26.2570617,37.5531619,0.3304268,12.6424863,10.5505672,21.0739572,4.9474097,6.0360761,0.7515128,18.6611838),(32818,'Macropus_agilis_radius.tif',231,3,94,16.2280545,31.7410185,23.6679473,1.8,31.7272664,23.6544235,-0.3668486,2.4618714,2.9719265,25.8362786,37.6084898,0.3479514,12.6545828,10.4945688,20.709168,4.9301487,6.0891027,0.7434061,18.5165838),(32819,'Macropus_agilis_radius.tif',231,3,95,16.3300085,31.7515484,23.6599031,1.8,31.7447234,23.6405776,-0.3661669,2.4555777,2.959023,25.4765774,37.7368002,0.3488961,12.7531284,10.374983,21.1678816,4.8743623,5.804299,0.6883588,17.8183932),(32820,'Macropus_agilis_radius.tif',231,3,96,16.4545132,31.7573946,23.6519552,1.8,31.7493477,23.6360886,-0.3612509,2.4373893,2.9493417,25.1403775,38.0066353,0.3425916,12.886481,10.3144694,20.6781382,4.840197,5.8168936,0.5638694,17.6737932),(32821,'Macropus_agilis_radius.tif',231,3,97,16.6277312,31.7629824,23.643482,1.8,31.7505363,23.6305984,-0.3566161,2.4282887,2.9650241,24.8322342,38.4350485,0.3377493,12.9628116,10.2262282,20.8038551,4.7961076,5.8290126,0.4081491,17.7935838),(32822,'Macropus_agilis_radius.tif',231,3,98,16.7200113,31.7664513,23.6286427,1.8,31.7546467,23.616785,-0.3532584,2.3992235,2.9732109,24.4023183,38.7770092,0.3335256,13.0421321,10.1709233,20.6157594,4.7698029,5.8580852,0.4194775,17.6314408),(32823,'Macropus_agilis_radius.tif',231,3,99,16.9391262,31.7713725,23.6130151,1.8,31.7604738,23.6084698,-0.352672,2.3873449,2.9630772,23.9957465,39.180203,0.3368225,13.2228086,10.0512275,20.5122343,4.6986031,5.8674471,0.3919475,17.6314408),(32824,'Macropus_agilis_radius.tif',231,3,100,17.0520429,31.7690216,23.591908,1.8,31.7565824,23.5875388,-0.3473554,2.3790669,2.9570606,23.524473,39.4646786,0.3293334,13.3459149,9.8881091,21.2600643,4.650418,5.8812398,0.364526,17.6314408),(32825,'Macropus_agilis_radius.tif',231,3,101,17.3070706,31.7770346,23.5802787,1.8,31.7661122,23.5729964,-0.3434797,2.3508064,2.969215,23.5560154,40.0511291,0.3271356,13.4887937,10.0203978,20.9001018,4.6499885,5.9074014,0.375961,17.5291932),(32826,'Macropus_agilis_radius.tif',231,3,102,17.4685759,31.7752321,23.5618309,1.8,31.7601776,23.5588758,-0.3408349,2.3453233,2.9882318,23.3590526,40.8238467,0.3253207,13.6615396,9.9598434,21.3525169,4.6422404,5.98389,0.2068739,17.8111267),(32827,'Macropus_agilis_radius.tif',231,3,103,17.6400977,31.7683947,23.5408451,1.8,31.760682,23.536931,-0.3348313,2.3218276,3.0066312,23.1290671,41.685888,0.3174761,13.8646497,9.9615782,21.1278243,4.5551112,6.0404046,0.1927008,17.8286696),(32828,'Macropus_agilis_radius.tif',231,3,104,17.8228375,31.7645966,23.5206196,1.8,31.7558114,23.5178775,-0.3310483,2.3203958,3.0244416,22.9605672,42.3877784,0.313823,14.0150757,9.895108,21.6062173,4.5217268,6.0697564,0.216085,17.7687743),(32829,'Macropus_agilis_radius.tif',231,3,105,17.8710496,31.7600819,23.496708,1.8,31.7511658,23.4977141,-0.328778,2.298965,3.021034,22.7611791,43.0137237,0.310527,14.2380798,9.90062,21.2981534,4.5301869,6.1254788,0.2020252,17.9732696),(32830,'Macropus_agilis_radius.tif',231,3,106,17.9724391,31.7587838,23.4665199,1.8,31.7520579,23.4660886,-0.3240432,2.2630487,3.0221429,22.6598354,43.6402726,0.3036737,14.4401751,10.0129686,21.7735618,4.4268494,6.1692708,0.1767089,17.871022),(32831,'Macropus_agilis_radius.tif',231,3,107,18.1397301,31.7544806,23.4324231,1.8,31.752587,23.4354212,-0.3231769,2.2514957,3.0292123,22.6127906,44.2654279,0.3049212,14.6128512,10.0434529,21.7711252,4.3989377,6.2064405,0.1402496,17.9732696),(32832,'Macropus_agilis_radius.tif',231,3,108,18.2956067,31.7442964,23.3979534,1.8,31.74675,23.3965313,-0.3239307,2.2406543,3.0527894,22.6198648,45.0180957,0.3089271,14.7465447,10.0952053,21.5285014,4.3664941,6.2404578,0.1746722,17.9309173),(32833,'Macropus_agilis_radius.tif',231,3,109,18.3739287,31.7352671,23.3621833,1.8,31.7349479,23.3615344,-0.3165544,2.2148997,3.1048726,22.659076,45.8316651,0.296751,14.7612064,10.2302942,21.3270064,4.3344175,6.2996499,0.1613751,18.0755173),(32834,'Macropus_agilis_radius.tif',231,3,110,18.4796753,31.7292035,23.3210675,1.8,31.7323581,23.3220973,-0.3093581,2.2142762,3.1150909,22.6137861,46.4546889,0.2854745,14.9127876,10.2127216,21.3440661,4.3338669,6.3401785,0.1257694,18.0755173),(32835,'Macropus_agilis_radius.tif',231,3,111,18.3542295,31.7174584,23.279274,1.8,31.7306706,23.2803205,-0.3089684,2.1960182,3.1167781,22.5108768,46.1875365,0.2828455,14.8190007,10.2507698,21.7597848,4.3331327,6.359935,0.1483278,18.1777649),(32836,'Macropus_agilis_radius.tif',231,3,112,18.3054124,31.7173099,23.2237371,1.8,31.7309862,23.2244165,-0.3089489,2.2119565,3.0895638,22.4223064,46.2200406,0.2820588,14.9600536,10.1368658,21.8184045,4.3240127,6.3496529,0.1370662,18.1777649),(32837,'Macropus_agilis_radius.tif',231,3,113,18.2781679,31.706996,23.1648405,1.8,31.7259376,23.1638277,-0.3113969,2.197611,3.1187808,22.328535,45.9251707,0.2859741,14.7253604,10.1603674,21.7477874,4.3302401,6.3244942,0.1839435,18.1178696),(32838,'Macropus_agilis_radius.tif',231,3,114,18.33264,31.6868219,23.1049157,1.8,31.7155489,23.1010613,-0.3209272,2.1949101,3.137864,22.1430373,45.8532061,0.3040363,14.6128725,10.0883575,21.4996046,4.3484372,6.3710212,0.1595517,18.1777649),(32839,'Macropus_agilis_radius.tif',231,3,115,18.2470595,31.6676957,23.0401027,1.8,31.702116,23.0358489,-0.33265,2.1856783,3.1378231,21.9925899,45.1778281,0.3242933,14.3978249,10.0621351,21.2969478,4.3511809,6.359935,0.1483278,18.1354125),(32840,'Macropus_agilis_radius.tif',231,3,116,18.3476176,31.6664605,22.9686591,1.8,31.7038561,22.9614922,-0.3377461,2.2256803,3.1794818,22.1924522,45.7912676,0.3357625,14.4021168,9.9710874,21.2703301,4.3805249,6.3677384,0.2174374,18.0755173),(32841,'Macropus_agilis_radius.tif',231,3,117,18.1118862,31.6526781,22.8993435,1.8,31.7195662,22.8827433,-0.3368198,2.2487733,3.1896825,22.5004309,45.8978474,0.3297022,14.3894721,10.0056468,21.225364,4.39802,6.4880945,0.2476814,18.1354125),(32842,'Macropus_agilis_radius.tif',231,3,118,18.1790006,31.6621373,22.8251924,1.8,31.7450274,22.8097067,-0.3300502,2.3014755,3.2671219,23.1071273,46.9161067,0.3182375,14.3600722,10.0401361,21.4274732,4.4946168,6.6141662,0.2767982,18.5867555),(32843,'Macropus_agilis_radius.tif',231,3,119,18.2101812,31.6772392,22.7510581,1.8,31.7784211,22.7301597,-0.3148077,2.3645098,3.3456351,23.831305,48.1568152,0.2909774,14.3939233,10.0787508,21.4780399,4.5595041,6.7343873,0.2606024,18.5444031),(32844,'Macropus_agilis_radius.tif',231,3,120,18.227264,31.6848153,22.675056,1.8,31.7907794,22.6555554,-0.3117882,2.4101803,3.3845176,24.4874707,49.0289182,0.2858715,14.4862351,10.1600161,21.6454337,4.6414741,6.786194,0.2475626,18.7065461),(32845,'Macropus_agilis_radius.tif',231,3,121,18.1522314,31.6696769,22.6039231,1.8,31.7956778,22.5749911,-0.3188236,2.4250136,3.3738472,25.0663832,49.1055256,0.2972449,14.5547567,10.336595,21.9623183,4.6863579,6.7730865,0.2812322,18.8511461),(32846,'Macropus_agilis_radius.tif',231,3,122,18.1025965,31.6583233,22.5266699,1.8,31.7669511,22.4966824,-0.325713,2.4568773,3.3365332,25.4393161,49.2140109,0.3089208,14.7500439,10.354329,22.3661727,4.7209881,6.7533776,0.2709469,18.8087937),(32847,'Macropus_agilis_radius.tif',231,3,123,17.5079851,31.5947323,22.4608901,1.8,31.7142767,22.4240235,-0.3443863,2.4756885,3.2952215,25.7313651,47.5518529,0.3326127,14.4305482,10.3936198,22.1832465,4.7676101,6.6535647,0.3320595,18.7488984),(32848,'Macropus_agilis_radius.tif',231,3,124,17.3547673,31.570528,22.3863934,1.8,31.670533,22.3527797,-0.3649027,2.4911433,3.2678952,26.1320897,46.9501069,0.368349,14.3670787,10.4899986,22.2754647,4.786059,6.5649836,0.1995554,18.6042984),(32849,'Macropus_agilis_radius.tif',231,3,125,17.221841,31.5368087,22.3160043,1.8,31.6197548,22.2852093,-0.3836991,2.5170576,3.2440175,26.4800422,45.9351549,0.4022456,14.1599592,10.5202368,22.2961224,4.8505792,6.5090083,0.2126449,18.5195937),(32850,'Macropus_agilis_radius.tif',231,3,126,17.2693829,31.4991524,22.2403198,1.8,31.5458946,22.2187376,-0.4107679,2.5328632,3.2151308,26.8092781,45.2074143,0.4589375,14.0608323,10.584574,22.2718004,4.8671433,6.4363248,0.261326,18.272746),(32851,'Macropus_agilis_radius.tif',231,3,127,17.3368139,31.4480988,22.164961,1.8,31.4776669,22.1499251,-0.4415513,2.5165101,3.1890506,27.1727762,44.550525,0.5276794,13.9698394,10.7978015,22.3536749,4.8265797,6.338117,0.3614409,18.2303937),(32852,'Macropus_agilis_radius.tif',231,3,128,17.342212,31.393804,22.090784,1.8,31.4228928,22.0724645,-0.4890569,2.5136362,3.1596972,27.5345618,44.0178355,0.6379215,13.9310297,10.954076,22.4826813,4.8567632,6.2705406,0.3655182,18.2303937),(32853,'Macropus_agilis_radius.tif',231,3,129,17.103488,31.3141672,22.0142954,1.8,31.3355461,21.9976283,-0.5397311,2.4900896,3.1138783,27.7908969,43.1767497,0.7528349,13.8659077,11.1606013,22.6268885,4.8567632,6.1811218,0.4217873,18.1106031),(32854,'Macropus_agilis_radius.tif',231,3,130,17.1143661,31.22444,21.9362566,1.8,31.2381271,21.9233967,-0.5933713,2.4600836,3.0622947,28.1714744,42.4087652,0.8918268,13.8486882,11.4514299,22.8785223,4.8567632,6.0891027,0.5220916,18.128146),(32855,'Macropus_agilis_radius.tif',231,3,131,16.9961667,31.1355006,21.8614233,1.8,31.1416496,21.8537475,-0.6451434,2.453111,3.013671,28.4527731,42.0831237,1.0242382,13.9640735,11.5986489,22.9691346,4.8945198,6.0494843,0.4315731,18.1704984),(32856,'Macropus_agilis_radius.tif',231,3,132,16.8942905,31.0293138,21.7880156,1.8,31.030001,21.782175,-0.7039879,2.4731631,2.9597375,28.7133003,41.7740697,1.179641,14.114113,11.6099502,23.1120442,4.9070339,6.0195995,0.4206633,18.0083555),(32857,'Macropus_agilis_radius.tif',231,3,133,16.7853564,30.9172373,21.720152,1.8,30.9167089,21.7148145,-0.7615852,2.5000634,2.891025,29.0360234,41.1381894,1.3321866,14.2296207,11.614115,23.3040543,4.9312744,5.9549928,0.5070985,18.0682507),(32858,'Macropus_agilis_radius.tif',231,3,134,16.6028095,30.7920027,21.6496426,1.8,30.7899094,21.6412281,-0.824692,2.5132875,2.8600913,29.4047668,40.0895888,1.4921869,14.0168914,11.6997228,23.4656098,4.9695297,5.8861262,0.4856221,18.0083555),(32859,'Macropus_agilis_radius.tif',231,3,135,16.4693095,30.651528,21.5795668,1.8,30.6484504,21.5677315,-0.9147455,2.5564733,2.9020242,30.0029324,39.410132,1.7235392,13.5802215,11.7360633,23.4693109,5.0074407,5.8006956,0.3967087,18.0930602),(32860,'Macropus_agilis_radius.tif',231,3,136,16.2786032,30.5027663,21.4981635,1.8,30.5035189,21.4858107,-1.010287,2.6134732,2.9094216,30.772514,38.8813651,1.9463313,13.3639501,11.7745665,23.1392043,5.0734192,5.821834,1.3197936,18.1106031),(32861,'Macropus_agilis_radius.tif',231,3,137,16.3170077,30.3366573,21.4169111,1.8,30.3337587,21.4101207,-1.1107271,2.6723248,2.9467402,32.0976694,39.1229674,2.1833651,13.276694,12.0111406,23.5007999,5.1799477,5.8794619,1.2840509,18.1953078),(32862,'Macropus_agilis_radius.tif',231,3,138,16.3983384,30.1620254,21.3264984,1.8,30.1617544,21.3193127,-1.2445926,2.7772831,2.9107647,33.8200097,39.7060938,2.452405,13.641121,12.1773721,23.9709331,5.2951383,5.9286003,1.3494819,18.3822602),(32863,'Macropus_agilis_radius.tif',231,3,139,16.5820562,29.9650082,21.2393877,1.8,29.9660572,21.2373754,-1.3923132,2.8354576,3.0015445,35.8609645,40.4245016,2.6765666,13.4679001,12.6473288,22.8086449,5.4330966,5.962011,1.3258177,18.4845078),(32864,'Macropus_agilis_radius.tif',231,3,140,16.7288615,29.769916,21.1618648,1.8,29.759427,21.1571734,1.5351331,2.8451072,3.0326397,37.3222084,41.0547744,2.784599,13.5376366,13.1180322,25.5610386,5.596588,5.9501629,1.4856369,18.7313555),(32865,'Macropus_agilis_radius.tif',231,3,141,16.9212545,29.5322752,21.0826286,1.8,29.5307696,21.068334,0.94902,2.78393,2.8689439,39.7982475,42.7501131,1.8633604,14.9009933,14.2957072,26.7571584,5.5724967,6.0078649,1.5226408,18.9533937),(32866,'Macropus_agilis_radius.tif',231,3,142,17.1531469,29.2726625,20.9930115,1.8,29.2803512,20.9742256,0.5678928,2.8338946,3.0484733,40.8594952,47.590046,0.8270387,15.6111079,14.4181421,28.4364719,5.5724967,6.1980124,2.8456666,19.3623843),(32867,'Macropus_agilis_radius.tif',231,3,143,17.7288615,28.9574718,20.9162509,1.8,28.9619343,20.8924748,0.4452311,2.8594945,3.2609138,42.3783573,56.4603777,0.5480394,17.3142812,14.820227,30.0593077,5.6200439,6.6460969,2.8886986,20.0781178),(32868,'Macropus_agilis_radius.tif',231,3,144,18.6939674,28.5000419,20.7941114,1.8,28.4640283,20.7336121,0.3901971,2.9494745,3.5928223,45.398561,75.7073795,0.4507798,21.0718408,15.3920846,32.892857,5.6462527,7.3483271,2.9133189,21.3547084),(32869,'Macropus_agilis_radius.tif',231,3,145,17.0149245,28.4095279,20.857498,1.8,28.1136455,20.7285462,0.2819841,3.0848652,4.1650871,48.7451615,76.4768279,0.2195768,18.3613994,15.801391,29.3344341,6.0730722,7.8117469,3.0023134,23.1746132),(32870,'Macropus_agilis_radius.tif',231,3,146,16.4347785,28.2569236,20.8699593,1.8,27.9418363,20.7854212,0.217673,3.0713091,4.41371,50.1682888,79.9130547,0.1277473,18.1056422,16.3344968,29.0571014,6.1210325,8.0334381,3.096578,23.6507656),(32871,'Macropus_agilis_radius.tif',231,3,147,16.326228,28.0943542,20.9481428,1.8,27.8831927,20.8811006,0.1538379,3.1296457,4.5950692,50.2688064,84.6829334,0.06389,18.4290879,16.0621397,29.2762021,6.1333438,8.2018291,3.053327,23.8552609),(32872,'Macropus_agilis_radius.tif',231,3,148,15.3372378,27.9062996,20.9474926,1.8,27.686478,20.9009322,0.1341341,3.166468,4.6918653,49.0695878,86.3403678,0.045716,18.4021413,15.4966318,28.7755281,6.2178003,8.3345944,3.0721393,24.0772991),(32873,'Macropus_agilis_radius.tif',231,3,149,15.037483,27.8122292,20.9492785,1.8,27.6054052,20.908687,0.1567904,3.2110097,4.6838374,49.1710774,86.0114233,0.0611084,18.363452,15.313276,28.7946905,6.2890477,8.2877377,3.0367157,23.9078897),(32874,'Macropus_agilis_radius.tif',231,3,150,15.0198457,27.7345951,20.9923999,1.8,27.5103464,20.9405891,0.1573672,3.246288,4.6624807,50.0041952,83.653198,0.061483,17.941779,15.4034993,28.550264,6.3624003,8.2472725,0.0350733,23.805642),(32875,'Macropus_agilis_radius.tif',231,3,151,14.7123538,27.6611941,21.079531,1.8,27.3975683,21.0338753,0.1324206,3.3022994,4.5911928,49.4628092,82.0391728,0.0427467,17.8688146,14.9782934,28.5583455,6.3624003,8.1365616,3.0436923,23.7033944),(32876,'Macropus_agilis_radius.tif',231,3,152,15.1989533,27.6342033,21.1804428,1.8,27.3442533,21.1265943,0.1340871,3.3467469,4.4960249,51.7730013,79.3705622,0.0452723,17.6534969,15.4696496,29.0960161,6.5670286,7.9926665,3.041924,23.6362326),(32877,'Macropus_agilis_radius.tif',231,3,153,16.2188969,27.6406789,21.3282768,1.8,27.3837725,21.2459918,0.0993996,3.343039,4.27357,54.8609646,75.2732117,0.02662,17.6136605,16.4105067,30.3357092,6.5070003,7.7127534,3.028865,22.9628514),(32878,'Macropus_agilis_radius.tif',231,3,154,15.394955,27.773061,21.2934703,1.8,27.5620691,21.3372422,0.1262008,3.418321,3.9422239,52.6288236,63.9961692,0.0406485,16.2335195,15.3961036,29.5829431,6.6218796,7.2476922,3.0717067,22.4691561),(32879,'Macropus_agilis_radius.tif',231,3,155,15.5017405,27.818979,21.4232633,1.8,27.7263582,21.4878006,0.2489562,3.5881516,3.5144431,52.5131409,59.1776477,0.1568498,16.838414,14.6351511,27.8427177,6.4927255,6.8837045,0.2984989,21.7358797),(32880,'Macropus_agilis_radius.tif',231,3,156,15.7617688,27.9465367,21.4401114,1.8,27.8955158,21.6341941,0.0214311,3.735759,3.3599572,50.5070006,55.7033573,0.0012064,16.5785911,13.5198764,27.4975346,6.3904778,6.9438122,0.5475622,21.8381273),(32881,'Macropus_agilis_radius.tif',231,3,157,15.3612727,28.1629442,21.6640013,1.8,28.1417915,21.8818395,-0.7224131,3.2826454,3.901526,50.8324368,55.2528097,1.119277,14.1618456,15.485205,26.9551955,6.2991971,7.2606628,1.3089111,22.229575),(32882,'Macropus_agilis_radius.tif',231,3,158,15.2052654,28.432893,21.7317936,1.8,28.4062205,22.0214813,-0.9369855,3.2097909,4.2297333,52.8322752,60.7108894,1.6454018,14.353361,16.4597248,26.8314933,6.3708422,7.7090249,1.2164164,23.2345085),(32883,'Macropus_agilis_radius.tif',231,3,159,15.5383608,28.4690172,21.8329296,1.8,28.4431936,22.1447704,-1.0336018,3.4119831,4.3933884,54.4823735,69.7972088,1.9115675,15.8868741,15.9679495,28.2071088,6.7223133,8.2094736,1.2295496,24.7754897),(32884,'Macropus_agilis_radius.tif',231,3,160,17.8988889,28.585911,21.9233167,1.8,28.4764114,22.1502582,-0.9718812,3.6070055,4.6995682,70.4481397,93.7360085,2.0350725,19.9456642,19.5309211,34.621451,7.2107062,8.8031007,1.2620321,26.4931469),(32885,'Macropus_agilis_radius.tif',231,3,161,27.6403073,28.7478688,21.9666923,1.8,28.5536784,22.1319854,-1.1140813,4.0466157,4.8148738,118.3989831,149.2292028,3.71079,30.9933776,29.2587665,53.4976635,7.8127724,9.3870355,0.8671825,28.3656804),(32886,'Macropus_agilis_radius.tif',231,3,162,38.0295649,28.7634187,21.8142817,1.8,28.5309682,21.9307422,-0.9364916,3.9974849,5.0392715,135.7488337,190.3676835,4.1122914,37.7768263,33.9585606,64.6494454,7.6553129,9.5908618,0.8654407,28.5629092),(32887,'Macropus_agilis_radius.tif',231,3,163,24.5821563,27.8092196,21.1736417,1.8,27.9871171,21.3030933,-0.8069462,3.9700677,4.7245755,59.200107,162.5844775,2.1367685,34.4125048,14.9116115,43.7508665,6.6534766,9.3247386,0.8512369,33.0557858),(32888,'Macropus_agilis_radius.tif',231,3,164,0.1798184,25.8849541,24.4227998,1.8,25.9029325,24.4062196,1.4214448,0.6366119,0.8399231,0.0129393,0.0237485,0.0293062,0.0282746,0.0203253,0.0348109,1.0845001,1.5251702,2.1193457,4.2490389),(32889,'Macropus_agilis_radius.tif',231,3,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32890,'Macropus_agilis_radius.tif',231,3,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32891,'Macropus_agilis_radius.tif',231,3,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32892,'Macropus_agilis_radius.tif',231,3,168,1.9949503,22.9414211,14.2004161,1.8,22.9329918,14.2059829,-1.1077126,0.9707255,1.6648366,0.2575967,0.8033988,0.2661433,0.4825692,0.2653651,0.6372967,8.4239402,14.5436269,0.3028849,41.3481215),(32893,'Macropus_agilis_radius.tif',231,3,169,3.977271,22.7629852,14.6545697,1.8,22.8068497,14.684876,-1.5531649,0.823655,2.2732737,0.5092391,4.4110335,0.6626725,1.9403882,0.6182674,2.1085064,8.9027397,14.4601814,0.3897912,42.7838452),(32894,'Macropus_agilis_radius.tif',231,3,170,3.2508157,22.5701127,15.2067442,1.8,22.6503791,15.1955383,1.5271686,0.7357799,2.4236628,0.2219156,5.6362009,0.540772,2.3254889,0.3016059,2.394788,9.2465626,14.0688078,0.4406632,42.3645782),(32895,'Macropus_agilis_radius.tif',231,3,171,0.7171375,22.3552817,16.754618,1.8,22.3613227,16.2597987,1.5283593,0.3965657,3.9607075,0.0141055,1.3240416,0.1193078,0.3342942,0.035569,0.3378547,9.3534374,13.4904909,0.5404195,41.3245588),(32896,'Macropus_agilis_radius.tif',231,3,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32897,'Macropus_agilis_radius.tif',231,3,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32898,'Macropus_agilis_radius.tif',231,3,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32899,'Macropus_agilis_radius.tif',231,3,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32900,'Macropus_agilis_radius.tif',231,3,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32901,'Macropus_agilis_radius.tif',231,3,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32902,'Macropus_agilis_radius.tif',231,3,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32903,'Macropus_agilis_radius.tif',231,3,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32904,'Macropus_agilis_radius.tif',231,3,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32905,'Macropus_agilis_radius.tif',231,3,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32906,'Macropus_agilis_radius.tif',231,3,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32907,'Macropus_agilis_radius.tif',231,3,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32908,'Macropus_agilis_radius.tif',231,3,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32909,'Macropus_agilis_radius.tif',231,3,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32910,'Macropus_agilis_radius.tif',231,3,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32911,'Macropus_agilis_radius.tif',231,3,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32912,'Macropus_agilis_radius.tif',231,3,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32913,'Macropus_agilis_radius.tif',231,3,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32914,'Macropus_agilis_radius.tif',231,3,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32915,'Macropus_agilis_radius.tif',231,3,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32916,'Macropus_agilis_radius.tif',231,3,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32917,'Macropus_agilis_radius.tif',231,3,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32918,'Macropus_agilis_radius.tif',231,3,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32919,'Macropus-agilis_ulna.tif',231,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32920,'Macropus-agilis_ulna.tif',231,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32921,'Macropus-agilis_ulna.tif',231,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32922,'Macropus-agilis_ulna.tif',231,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32923,'Macropus-agilis_ulna.tif',231,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32924,'Macropus-agilis_ulna.tif',231,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32925,'Macropus-agilis_ulna.tif',231,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32926,'Macropus-agilis_ulna.tif',231,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32927,'Macropus-agilis_ulna.tif',231,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32928,'Macropus-agilis_ulna.tif',231,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32929,'Macropus-agilis_ulna.tif',231,4,11,0.2896483,20.9090291,22.2608883,1.8,20.9081943,22.2595398,-0.5663282,0.8219998,0.8424237,0.0403783,0.0434226,0.0138969,0.0515449,0.049122,0.0949812,1.6335522,1.759135,1.4056476,5.7053153),(32930,'Macropus-agilis_ulna.tif',231,4,12,5.3393114,20.9553015,22.2905874,1.8,20.9539806,22.2709684,-1.3046062,1.6052044,1.6351382,2.9942395,3.5108078,0.8283058,2.1471015,1.8653322,3.9417721,3.2535002,3.3492933,1.8105394,10.6422684),(32931,'Macropus-agilis_ulna.tif',231,4,13,6.686912,20.8442467,22.2906097,1.8,20.8913464,22.2459091,-0.9101191,1.8824777,2.0459178,5.3240584,6.6081043,0.6948053,3.2298973,2.8282185,5.8100558,3.7831629,4.08223,1.1705557,12.7368402),(32932,'Macropus-agilis_ulna.tif',231,4,14,5.8114725,20.6582388,22.3981719,1.8,20.6048073,22.3853683,-0.7461198,1.8349454,1.7936923,4.0379645,4.9397024,0.4462843,2.7539296,2.2005911,4.7560439,3.5058146,3.7351892,1.8251644,11.8692401),(32933,'Macropus-agilis_ulna.tif',231,4,15,5.6935537,20.6844945,22.5401574,1.8,20.617737,22.5612075,0.7805103,1.6545466,1.8329177,3.414872,4.4345663,0.4698246,2.4194029,2.0639321,4.2301213,3.1505931,3.6901344,2.1751018,11.0936113),(32934,'Macropus-agilis_ulna.tif',231,4,16,6.1572329,20.7762387,22.4660474,1.8,20.7168095,22.4956074,0.5630135,1.8093297,1.8520647,4.5510395,5.1652514,0.2923405,2.7889152,2.515318,5.0881918,3.4923509,3.7491578,2.2605964,11.8589637),(32935,'Macropus-agilis_ulna.tif',231,4,17,7.6887115,21.1123528,22.2544154,1.8,21.0544488,22.2772714,-0.5491232,2.0861397,2.6403883,7.7862684,12.5520484,0.3490942,4.7538646,3.7323811,7.600313,3.920631,5.0738945,0.7148086,14.8634879),(32936,'Macropus-agilis_ulna.tif',231,4,18,10.1410524,21.2723246,22.1103021,1.8,21.3366208,22.0980971,-0.4947284,2.6054889,3.007916,17.5451512,25.9137997,0.3810129,8.6152005,6.733919,13.8036897,5.0519724,6.1233451,0.4002407,18.7809744),(32937,'Macropus-agilis_ulna.tif',231,4,19,13.4611788,21.1942889,22.0315414,1.8,21.2605869,22.0180989,-0.6164135,2.9666392,3.3387205,29.6207148,35.4780683,0.7498191,10.6262468,9.9846031,18.9520787,5.7523394,6.5808891,0.9492697,20.3292221),(32938,'Macropus-agilis_ulna.tif',231,4,20,11.3996244,20.9183179,22.3573776,1.8,21.0967381,22.2123305,-0.7071727,3.0560471,3.3736842,27.5460364,36.5534168,0.8019507,10.8348662,9.0136164,17.7484882,5.9061026,6.8073438,0.5349551,21.1822891),(32939,'Macropus-agilis_ulna.tif',231,4,21,9.1330152,21.1168808,22.2404926,1.8,21.1966465,22.2769573,-0.4710628,2.984704,3.3411498,22.558648,29.6132644,0.3135134,8.8631957,7.5580855,15.2324722,5.7505762,6.67396,0.4006244,20.6958603),(32940,'Macropus-agilis_ulna.tif',231,4,22,8.7198615,21.2739259,22.263394,1.8,21.3546621,22.2919843,-0.5046864,2.9051239,3.2051805,20.6358728,28.5275777,0.3397899,8.900459,7.1032678,14.5909063,5.5533268,6.5506357,0.6523309,20.0999174),(32941,'Macropus-agilis_ulna.tif',231,4,23,8.4163104,21.2737935,22.2858579,1.8,21.3224292,22.2718878,-0.5080408,2.8254477,3.2304651,19.6503452,27.0236646,0.3319528,8.3652552,6.9547723,14.1852902,5.4415582,6.4057966,0.6412438,19.2819362),(32942,'Macropus-agilis_ulna.tif',231,4,24,8.1227221,21.3720251,22.2720842,1.8,21.4112839,22.287609,-0.4996353,2.7302012,3.13136,18.3407908,25.705716,0.310751,8.2091219,6.7177433,13.9034457,5.3276313,6.2672052,0.6873529,18.9927362),(32943,'Macropus-agilis_ulna.tif',231,4,25,8.0276416,21.4762121,22.2339304,1.8,21.4938796,22.2392499,-0.4482347,2.6969414,3.0297214,18.006518,25.0877147,0.2512841,8.2805352,6.6766442,13.9170585,5.2756182,6.1891506,0.6528466,18.7634314),(32944,'Macropus-agilis_ulna.tif',231,4,26,7.8402078,21.4872432,22.1950327,1.8,21.5257849,22.2053954,-0.4963211,2.5805353,3.004089,16.8641085,24.8928396,0.2963082,8.2863189,6.5351202,13.4338386,5.1886733,6.0749215,0.6673061,18.5165838),(32945,'Macropus-agilis_ulna.tif',231,4,27,7.9787703,21.542662,22.1707704,1.8,21.5222539,22.1507681,-0.5019102,2.5511159,2.9800395,17.7716811,24.6682352,0.3077919,8.2778216,6.9662382,13.6290787,5.115998,6.0078649,0.6916566,18.3544409),(32946,'Macropus-agilis_ulna.tif',231,4,28,8.0915476,21.6649298,22.2463933,1.8,21.6475972,22.192468,-0.4912215,2.575201,2.9547425,17.7884808,24.8271041,0.300067,8.4024594,6.9076087,14.2255014,5.096437,5.885238,0.6459581,17.9629932),(32947,'Macropus-agilis_ulna.tif',231,4,29,8.3278404,21.7645382,22.2006571,1.8,21.74708,22.128384,-0.3832867,2.5412171,2.8721361,17.9165306,24.8389935,0.1941137,8.6482647,7.050374,14.678217,5.0094612,5.7993437,0.6260465,17.8183932),(32948,'Macropus-agilis_ulna.tif',231,4,30,8.5240779,21.8010146,22.2081774,1.8,21.8047048,22.1289594,-0.385774,2.4791022,2.8657736,17.7117842,24.7823432,0.2011454,8.6476976,7.1444348,14.4080048,4.9154665,5.7171888,0.5599398,17.6314408),(32949,'Macropus-agilis_ulna.tif',231,4,31,8.6558205,21.8341823,22.2316324,1.8,21.8657078,22.1554164,-0.3899642,2.4556772,2.833562,17.5987919,23.9840239,0.208487,8.4642664,7.1665737,14.3753233,4.8488109,5.6468108,0.6947383,17.5291932),(32950,'Macropus-agilis_ulna.tif',231,4,32,9.0297049,21.9191183,22.2039487,1.8,21.9600358,22.1523544,-0.4140998,2.3788948,2.9072315,17.8540055,24.3603214,0.2436491,8.3792162,7.5051682,11.9541425,4.8127676,5.6175753,0.5558708,17.3422408),(32951,'Macropus-agilis_ulna.tif',231,4,33,9.1901093,21.9879098,22.150314,1.8,22.0240471,22.127508,-0.3876984,2.3383203,2.7819898,17.6565767,24.2483284,0.2189211,8.7161816,7.5509657,14.9185038,4.6892787,5.6175753,0.5558708,17.2224503),(32952,'Macropus-agilis_ulna.tif',231,4,34,9.1946688,22.0335493,22.1231235,1.8,22.0865047,22.0995053,-0.3455484,2.3359348,3.2710444,17.1381057,24.1997888,0.1758118,7.3981841,7.3367225,11.2367458,4.6245749,5.5727312,0.3997811,17.2998885),(32953,'Macropus-agilis_ulna.tif',231,4,35,9.2765972,22.0749546,22.1240014,1.8,22.1375408,22.0975957,-0.3386307,2.3221973,3.2435442,16.8981222,24.5436837,0.1706184,7.5669337,7.2767815,11.3920257,4.5595041,5.5951982,0.5736667,17.2224503),(32954,'Macropus-agilis_ulna.tif',231,4,36,9.3825096,22.1181528,22.1273416,1.8,22.1799612,22.0893529,-0.3263784,2.2847596,2.74899,16.8700549,24.889058,0.160744,9.0538918,7.3837331,14.6117063,4.5595041,5.6119894,0.6666928,17.2648026),(32955,'Macropus-agilis_ulna.tif',231,4,37,9.4674712,22.1826992,22.1281307,1.8,22.2419001,22.0818888,-0.3078247,2.2860396,2.7762381,16.8283811,25.5519131,0.1448535,9.2037902,7.3613692,14.5478383,4.5270604,5.695203,0.1401017,17.2823455),(32956,'Macropus-agilis_ulna.tif',231,4,38,9.5944348,22.257699,22.1102835,1.8,22.3131301,22.0657951,-0.3022391,2.301982,2.8103602,16.9291146,26.2154156,0.1416788,9.3281338,7.3541472,13.5542019,4.5420151,5.6689842,0.658806,17.307155),(32957,'Macropus-agilis_ulna.tif',231,4,39,9.82036,22.3135064,22.1015073,1.8,22.3739596,22.0637211,-0.3118419,2.3180422,2.8620404,17.222209,26.9163402,0.1540712,9.4045981,7.4296356,15.4141037,4.552034,5.6984146,0.6231993,17.3495073),(32958,'Macropus-agilis_ulna.tif',231,4,40,10.0820793,22.3405113,22.0934098,1.8,22.4116819,22.0603546,-0.2946742,2.3418129,2.9218273,17.6688049,27.7748003,0.1417347,9.5059693,7.5449259,13.1908593,4.5643833,5.7349901,0.5880026,17.3319644),(32959,'Macropus-agilis_ulna.tif',231,4,41,10.3056121,22.3572997,22.1091096,1.8,22.4379573,22.0687513,-0.2859322,2.3432458,3.1748716,18.2400095,28.6990208,0.1366409,9.0394274,7.7840786,13.0297848,4.5946586,5.7663502,0.5253669,17.4765644),(32960,'Macropus-agilis_ulna.tif',231,4,42,10.4987654,22.3663942,22.1167565,1.8,22.4425952,22.060647,-0.2759933,2.372976,2.8670847,18.646992,29.8098142,0.1299358,10.3972561,7.8580618,14.9905515,4.626898,5.7952861,0.5810823,17.5189168),(32961,'Macropus-agilis_ulna.tif',231,4,43,10.6257172,22.3827748,22.1349599,1.8,22.4638104,22.0813614,-0.2478686,2.3813922,2.8611246,19.0925392,30.4577064,0.1065951,10.6453619,8.0173853,15.3725313,4.642772,5.802948,0.536146,17.6635168),(32962,'Macropus-agilis_ulna.tif',231,4,44,10.8935495,22.4096578,22.1561337,1.8,22.4865869,22.1091227,-0.2411263,2.4243961,2.8652776,19.7511766,31.167806,0.1035319,10.8777612,8.1468439,15.7954809,4.703134,5.8168936,0.5638694,17.7482215),(32963,'Macropus-agilis_ulna.tif',231,4,45,11.1549249,22.4133015,22.1727229,1.8,22.4944893,22.128166,-0.2266494,2.4233633,2.8665504,20.3937061,31.8212709,0.0938805,11.1008934,8.4154554,15.9771104,4.7190364,5.8402115,0.5467888,17.7657644),(32964,'Macropus-agilis_ulna.tif',231,4,46,11.6040163,22.423541,22.1836546,1.8,22.4943563,22.1549019,-0.2066706,2.4341626,2.8951873,21.2387136,32.72175,0.0814371,11.3021185,8.7252648,16.7354655,4.7478823,5.8402115,0.5467888,17.8680121),(32965,'Macropus-agilis_ulna.tif',231,4,47,12.0817148,22.4475161,22.1945822,1.8,22.5169121,22.167393,-0.2098464,2.4634032,2.9149702,22.1047484,33.7996653,0.0873768,11.5952011,8.9732563,17.1318737,4.7914654,5.8652194,0.5298491,17.8504692),(32966,'Macropus-agilis_ulna.tif',231,4,48,12.5963412,22.4820504,22.1990092,1.8,22.5455436,22.1725249,-0.2114622,2.4671685,3.4875543,22.8089038,34.9122218,0.0924859,10.0105172,9.244972,15.4534899,4.8163874,5.8674471,0.3919475,17.8680121),(32967,'Macropus-agilis_ulna.tif',231,4,49,12.8883901,22.5189656,22.1986622,1.8,22.5806195,22.1791989,-0.2021887,2.487736,2.9167747,23.4722431,35.3906766,0.0866234,12.1334968,9.4351826,18.3308112,4.8394497,5.8718999,0.663203,17.9527168),(32968,'Macropus-agilis_ulna.tif',231,4,50,13.2608131,22.5489657,22.1927339,1.8,22.6020368,22.183878,-0.1844905,2.5227258,2.8990886,24.2372147,35.8117485,0.0743762,12.352761,9.6075502,18.5681169,4.9094467,5.8718999,0.663203,18.0725074),(32969,'Macropus-agilis_ulna.tif',231,4,51,13.6222717,22.5725524,22.1972732,1.8,22.618097,22.1938129,-0.1675284,2.5055729,2.9213554,24.8625774,36.2575307,0.063126,12.4112016,9.9229111,18.9687901,4.9101012,5.8718999,0.663203,17.9527168),(32970,'Macropus-agilis_ulna.tif',231,4,52,13.9082769,22.5833752,22.2048238,1.8,22.6287261,22.2055634,-0.153032,2.6536938,2.933249,25.6206485,36.6114207,0.0538634,12.4815248,9.6547118,19.364834,4.9887002,5.8567466,0.5023024,18.1148597),(32971,'Macropus-agilis_ulna.tif',231,4,53,14.1174373,22.5895878,22.2114428,1.8,22.6421447,22.2045264,-0.1503187,2.540447,2.9491584,26.0945953,36.8795482,0.0527663,12.5051091,10.271655,19.5448906,4.9164002,5.8674471,0.3919475,18.0725074),(32972,'Macropus-agilis_ulna.tif',231,4,54,14.2799344,22.5917284,22.2163604,1.8,22.6622248,22.2091203,-0.1476955,2.5659703,2.9757301,26.4239003,37.2068163,0.0515406,12.5034244,10.2978198,19.4520748,4.9164002,5.8918958,0.5130579,17.9702597),(32973,'Macropus-agilis_ulna.tif',231,4,55,14.4935649,22.595085,22.2199588,1.8,22.6685133,22.2106133,-0.1294906,2.5491618,2.9894173,26.763484,37.5465669,0.0402784,12.5598281,10.4989351,19.6935546,4.9887002,5.8918958,0.2479548,18.0725074),(32974,'Macropus-agilis_ulna.tif',231,4,56,14.6579897,22.6041611,22.2286252,1.8,22.6731655,22.2186001,-0.1113412,2.5340163,2.9831728,27.0433496,37.7376936,0.0301606,12.6501869,10.6721292,19.8359989,4.9887002,5.8847939,0.1853479,18.0900503),(32975,'Macropus-agilis_ulna.tif',231,4,57,14.7146068,22.5986594,22.240314,1.8,22.664849,22.2365525,-0.1015854,2.5792857,3.0139103,27.2270247,37.7170384,0.0252212,12.51432,10.556033,19.8320018,4.9887002,5.8954435,0.4032815,18.030155),(32976,'Macropus-agilis_ulna.tif',231,4,58,14.8359105,22.6051764,22.2516295,1.8,22.661946,22.2442083,-0.0961683,2.5631014,3.0013723,27.449812,37.7778749,0.0227975,12.5868671,10.7096082,19.8964433,4.9887002,5.9074014,0.375961,17.9878026),(32977,'Macropus-agilis_ulna.tif',231,4,59,14.9860435,22.6036178,22.268087,1.8,22.6567277,22.2651881,-0.0966325,2.6122266,2.9813708,27.7868852,37.7338905,0.0232504,12.6565575,10.6372414,20.2229694,5.0610002,5.8794619,0.2867454,18.0476979),(32978,'Macropus-agilis_ulna.tif',231,4,60,15.0346562,22.600877,22.2856145,1.8,22.6533615,22.2831182,-0.0943352,2.5933801,2.9777612,27.7080079,37.6423873,0.0222332,12.6411704,10.6841291,20.4068034,4.9887002,5.8812398,0.364526,17.9279074),(32979,'Macropus-agilis_ulna.tif',231,4,61,15.0777265,22.5898016,22.3012122,1.8,22.6447916,22.2953778,-0.0945142,2.5790274,2.9766954,27.6588841,37.2307883,0.0223813,12.5074229,10.7245405,20.4670738,4.9887002,5.8312541,0.3021452,17.885555),(32980,'Macropus-agilis_ulna.tif',231,4,62,15.1689526,22.5744096,22.3118501,1.8,22.6305099,22.3084891,-0.0936344,2.620927,2.965682,27.6219521,36.9109683,0.0221007,12.4460302,10.5390011,20.2356397,5.0610002,5.821834,0.2510027,17.9454503),(32981,'Macropus-agilis_ulna.tif',231,4,63,15.2287747,22.5509103,22.3291924,1.8,22.6048476,22.3300089,-0.0974489,2.6150124,2.9541627,27.5945598,36.5262452,0.0240266,12.3643308,10.5523627,20.2431471,4.9887002,5.7885173,0.4804058,17.7833074),(32982,'Macropus-agilis_ulna.tif',231,4,64,15.2208236,22.5271355,22.3477961,1.8,22.5843949,22.3489408,-0.0983965,2.5994232,2.9587448,27.4965692,36.0198401,0.0244818,12.1740274,10.5779501,20.5138627,4.9887002,5.7568239,0.2023216,17.7833074),(32983,'Macropus-agilis_ulna.tif',231,4,65,15.2503727,22.5035177,22.3693327,1.8,22.5495941,22.3717602,-0.1057536,2.585181,2.9370682,27.3474015,35.5267946,0.0283204,12.0960059,10.5785248,21.1665455,4.9164002,5.7568239,0.2023216,17.6810597),(32984,'Macropus-agilis_ulna.tif',231,4,66,15.2702493,22.4786992,22.392517,1.8,22.5161334,22.394275,-0.108396,2.6071217,2.9419473,27.1148911,35.0900221,0.0297865,11.9274814,10.4003168,21.0735037,4.9887002,5.7427324,0.1899883,17.740955),(32985,'Macropus-agilis_ulna.tif',231,4,67,15.3372087,22.4599949,22.4202289,1.8,22.4946269,22.423858,-0.1098804,2.5901138,2.9079251,26.8760835,34.9604875,0.0307388,12.0224856,10.3764101,20.3439729,4.9164002,5.7011659,0.2172934,17.6387073),(32986,'Macropus-agilis_ulna.tif',231,4,68,15.3771871,22.4349396,22.4465897,1.8,22.4727021,22.4460162,-0.1154121,2.5693578,2.9214424,26.681688,34.7893374,0.0339859,11.9082741,10.3845745,20.9133386,4.9164002,5.6965796,0.4182243,17.6387073),(32987,'Macropus-agilis_ulna.tif',231,4,69,15.3966673,22.4085196,22.4746113,1.8,22.4441147,22.4768209,-0.1220602,2.5567034,2.8987015,26.5151978,34.579635,0.0380422,11.9293537,10.3708541,20.8433286,4.9148746,5.6915305,0.4466038,17.5189168),(32988,'Macropus-agilis_ulna.tif',231,4,70,15.3843631,22.3883752,22.491979,1.8,22.42703,22.4901304,-0.144629,2.573963,2.8690901,26.4664733,34.465492,0.0532609,12.0126908,10.2823828,20.0492742,4.9164002,5.6915305,0.4466038,17.5612691),(32989,'Macropus-agilis_ulna.tif',231,4,71,15.3635471,22.3579056,22.510776,1.8,22.3991132,22.5068579,-0.1612101,2.8080621,2.8862976,26.4611079,34.4708812,0.065972,11.9429408,9.4232632,19.9259122,4.9164002,5.7158171,0.6055447,17.6635168),(32990,'Macropus-agilis_ulna.tif',231,4,72,15.433835,22.3272171,22.5299743,1.8,22.3652651,22.5368359,-0.1621353,2.5837835,2.8719392,26.5496073,34.5579022,0.06703,12.0329506,10.2754767,20.8957518,4.8991062,5.7409116,0.6334259,17.5437262),(32991,'Macropus-agilis_ulna.tif',231,4,73,15.5501763,22.2992856,22.548166,1.8,22.3456777,22.5477464,-0.1797301,2.5645365,2.9102269,26.6701432,34.7404809,0.0828217,11.9373786,10.399596,20.7627624,4.8441002,5.7704281,0.6610432,17.5261833),(32992,'Macropus-agilis_ulna.tif',231,4,74,15.6730657,22.2638345,22.5692581,1.8,22.3080596,22.566609,-0.1935118,2.5839369,2.9267345,26.7792885,34.725133,0.0966028,11.8648044,10.3637549,19.9661407,4.9164002,5.8901211,0.7246036,18.0374215),(32993,'Macropus-agilis_ulna.tif',231,4,75,15.8105196,22.2300124,22.5909392,1.8,22.2744015,22.5871525,-0.2049068,2.5704229,2.9255405,26.9241335,34.5837863,0.1090991,11.8213324,10.4745931,20.7489026,4.9164002,5.7704281,0.6610432,17.5860786),(32994,'Macropus-agilis_ulna.tif',231,4,76,15.9844837,22.2050262,22.6165113,1.8,22.2538944,22.6111027,-0.2246507,2.5685552,2.9465406,26.9436507,34.677804,0.132204,11.7689889,10.4898079,20.7647646,4.8441002,5.7840003,0.6435011,17.5261833),(32995,'Macropus-agilis_ulna.tif',231,4,77,16.0781659,22.1679812,22.6415811,1.8,22.2132405,22.6387422,-0.251728,2.5565015,2.9610794,26.9296383,34.6594764,0.1662477,11.7050144,10.5337854,20.6387805,4.9164002,5.7993437,0.6260465,17.6459739),(32996,'Macropus-agilis_ulna.tif',231,4,78,16.2355561,22.1438664,22.6632093,1.8,22.1865788,22.6602148,-0.2693938,2.8948099,2.9576753,26.9650975,34.9748437,0.1916724,11.8251126,9.3149805,20.5681035,4.9164002,5.8276673,0.6534263,17.5860786),(32997,'Macropus-agilis_ulna.tif',231,4,79,16.2785228,22.1136594,22.6821187,1.8,22.1581113,22.6779855,-0.2985817,2.5417584,2.9699159,26.9182059,35.052149,0.2347716,11.8024047,10.5903874,20.7475975,4.9164002,5.8420013,0.6360755,17.5860786),(32998,'Macropus-agilis_ulna.tif',231,4,80,16.4159248,22.0818859,22.7021238,1.8,22.1291629,22.6982703,-0.3290936,2.5285112,2.9684106,26.8573299,35.128814,0.2857706,11.8342165,10.6217957,20.6442149,4.8441002,5.885238,0.6459581,17.5860786),(32999,'Macropus-agilis_ulna.tif',231,4,81,16.5055459,22.0462128,22.7229643,1.8,22.0878692,22.719503,-0.3510004,2.5210643,2.9964315,26.8120277,35.3879602,0.3252257,11.8100346,10.635202,20.5863082,4.9045825,5.9166853,0.6728325,17.6883262),(33000,'Macropus-agilis_ulna.tif',231,4,82,16.6896279,22.0136483,22.7460785,1.8,22.0541007,22.7413651,-0.3640622,2.5012585,2.9980848,26.8119819,35.8032732,0.3526743,11.9420482,10.7193968,20.6517405,4.9006957,5.962011,0.6823166,17.6532404),(33001,'Macropus-agilis_ulna.tif',231,4,83,16.8808736,21.9719729,22.7659376,1.8,22.0100376,22.7616183,-0.3830699,2.8851961,3.0111766,26.9117878,36.1814711,0.3930535,12.0157252,9.3275421,20.8274017,4.8441002,5.9991579,0.7086263,17.6532404),(33002,'Macropus-agilis_ulna.tif',231,4,84,17.0605977,21.9260734,22.7887333,1.8,21.9669597,22.7860017,-0.3946474,2.5398012,3.0243528,26.884535,36.7339028,0.420336,12.1460378,10.5852912,20.8977812,4.890436,6.0182968,0.6747409,17.6707833),(33003,'Macropus-agilis_ulna.tif',231,4,85,17.2168535,21.8739359,22.8078618,1.8,21.9130173,22.8041331,-0.4026066,2.5417279,3.0527097,26.9102735,37.3912805,0.4405254,12.2485542,10.5873936,21.023338,4.8441002,6.063725,0.6840517,17.6955927),(33004,'Macropus-agilis_ulna.tif',231,4,86,17.4248398,21.8235144,22.8260685,1.8,21.8636367,22.8239486,-0.4099514,2.562308,3.0691643,26.8962543,38.0923277,0.461334,12.4113031,10.4968859,21.1315007,4.8386261,6.0878148,0.6506269,17.7131357),(33005,'Macropus-agilis_ulna.tif',231,4,87,17.4835769,21.7716002,22.8419274,1.8,21.8113958,22.8357029,-0.4219396,2.5635735,3.0948859,26.724812,38.6839145,0.4887109,12.4993024,10.4248276,21.1333345,4.8244045,6.1318758,0.660009,17.8752786),(33006,'Macropus-agilis_ulna.tif',231,4,88,17.52547,21.7198544,22.8550721,1.8,21.7589215,22.8549622,-0.4361021,2.566364,3.1169417,26.5571044,39.4284362,0.521178,12.6497187,10.3481439,21.1616377,4.8441002,6.1891506,0.6528466,17.8577357),(33007,'Macropus-agilis_ulna.tif',231,4,89,17.6038197,21.6675001,22.8719394,1.8,21.7047416,22.8675445,-0.4410689,2.5882011,3.1364982,26.430732,40.1526832,0.534713,12.8017554,10.2120087,21.1747975,4.8441002,6.2780387,0.6711438,17.9424404),(33008,'Macropus-agilis_ulna.tif',231,4,90,17.7059799,21.6133754,22.8870045,1.8,21.6471514,22.8793773,-0.4447203,2.611473,3.1606643,26.3055634,40.9489566,0.5461608,12.9558069,10.0730749,21.2667603,4.8441002,6.3046266,0.638914,17.900088),(33009,'Macropus-agilis_ulna.tif',231,4,91,17.814583,21.5509131,22.9037461,1.8,21.5867904,22.8902056,-0.4482257,2.630112,3.1900155,26.2767168,41.9235089,0.5576175,13.1421018,9.9907214,21.3768624,4.9164002,6.3628111,0.632138,18.062231),(33010,'Macropus-agilis_ulna.tif',231,4,92,17.9020661,21.4827531,22.9177627,1.8,21.5241932,22.8986711,-0.4506097,2.6188425,3.2238081,26.2164325,42.752627,0.5659227,13.2615296,10.0106945,21.3915632,4.9164002,6.4363248,0.6659692,18.2667263),(33011,'Macropus-agilis_ulna.tif',231,4,93,18.0094611,21.4138798,22.9345527,1.8,21.4516386,22.9151534,-0.4521924,2.6358659,3.2299813,26.2152108,43.5035791,0.5730471,13.4686783,9.9455785,21.560367,4.9164002,6.5070003,0.6435011,18.3090786),(33012,'Macropus-agilis_ulna.tif',231,4,94,18.195102,21.3429879,22.9423013,1.8,21.3760829,22.9277601,-0.4638711,2.6463701,3.2631265,26.2544129,44.5427815,0.6070456,13.6503387,9.9209152,21.6418931,4.9789911,6.5390547,0.6125376,18.4712215),(33013,'Macropus-agilis_ulna.tif',231,4,95,18.2849069,21.2645208,22.9554387,1.8,21.297491,22.935081,-0.4725636,2.6585145,3.2752666,26.1780708,45.3194768,0.6313782,13.8368818,9.846879,21.7844556,4.9576763,6.5808891,0.6215266,18.5311168),(33014,'Macropus-agilis_ulna.tif',231,4,96,18.4552923,21.1862931,22.9638391,1.8,21.2237918,22.9391303,-0.4782759,2.636685,3.2847515,26.1855943,46.3292276,0.651562,14.1043326,9.9312561,22.0359086,4.8835735,6.6173267,0.5910329,18.6509074),(33015,'Macropus-agilis_ulna.tif',231,4,97,18.5741336,21.095531,22.9775931,1.8,21.1348343,22.9521344,-0.4870964,2.6715619,3.3078853,26.2783509,47.1699312,0.6782098,14.259845,9.8363249,22.0584209,4.9494472,6.6989767,0.6089576,18.9401074),(33016,'Macropus-agilis_ulna.tif',231,4,98,18.6024894,20.9975858,22.9874982,1.8,21.0392676,22.9623511,-0.4973963,2.6708232,3.3298508,26.363022,47.841922,0.7058454,14.3675873,9.8707478,22.1384168,4.909597,6.7211788,0.5551786,18.6932598),(33017,'Macropus-agilis_ulna.tif',231,4,99,18.7275655,20.9056646,22.9958639,1.8,20.9450448,22.967494,-0.5038833,2.6985176,3.321514,26.5156391,48.8538257,0.727643,14.7083003,9.826002,22.2615885,4.9181139,6.7584069,0.6028383,18.7955074),(33018,'Macropus-agilis_ulna.tif',231,4,100,18.8724581,20.8061347,23.0096516,1.8,20.8495809,22.9787923,-0.5132027,2.6979127,3.344778,26.6923184,49.948044,0.7582055,14.9331416,9.8936924,22.4713083,4.9517745,6.7996606,0.611597,19.3067456),(33019,'Macropus-agilis_ulna.tif',231,4,101,18.9940013,20.7057044,23.0182544,1.8,20.7435698,22.9872211,-0.5240947,2.6915341,3.4121925,26.7089455,51.0757886,0.7927766,14.9686129,9.9233167,22.5533864,4.8857815,6.8821856,0.5530314,19.0175456),(33020,'Macropus-agilis_ulna.tif',231,4,102,19.18242,20.5973137,23.0298401,1.8,20.6295578,22.9976015,-0.5364192,2.6943471,3.4550765,26.7771323,52.2510948,0.8350227,15.1229921,9.9382637,22.5438359,4.872973,6.9204361,0.5619216,19.1373362),(33021,'Macropus-agilis_ulna.tif',231,4,103,19.2862977,20.4853668,23.0413201,1.8,20.518609,23.015678,-0.5494222,2.6841268,3.5082477,26.8727573,53.3424565,0.8765209,15.2048719,10.0117318,22.7015577,4.8777205,7.0056428,0.5421894,19.2994791),(33022,'Macropus-agilis_ulna.tif',231,4,104,19.4178781,20.3717703,23.0516002,1.8,20.4067357,23.0271447,-0.5590773,2.6937172,3.5483879,26.9830624,54.8996934,0.9104675,15.4717284,10.0170361,22.8291285,4.8800722,7.067672,0.5369107,19.4192697),(33023,'Macropus-agilis_ulna.tif',231,4,105,19.5744442,20.2592468,23.0609689,1.8,20.2868231,23.0349205,-0.5615627,2.6797966,3.5945349,27.0829167,56.6221381,0.9251091,15.752285,10.106333,23.1510508,4.8343285,7.1049239,0.5456551,19.5638697),(33024,'Macropus-agilis_ulna.tif',231,4,106,19.7913104,20.1472633,23.0669986,1.8,20.1722327,23.0415247,-0.5637308,2.7018475,3.6583523,27.415349,58.6639612,0.9418122,16.0356239,10.1468898,23.3755765,4.8488109,7.1923061,0.5266273,19.6661173),(33025,'Macropus-agilis_ulna.tif',231,4,107,19.9194194,20.0329619,23.0723572,1.8,20.0557528,23.0471927,-0.5641784,2.7062632,3.681278,27.5994015,60.4741563,0.9492509,16.4274898,10.1983434,23.7859785,4.8587245,7.2473316,0.4993467,19.9305079),(33026,'Macropus-agilis_ulna.tif',231,4,108,20.1076314,19.9110776,23.0795676,1.8,19.9316569,23.0562228,-0.5676152,2.7066046,3.736772,27.6952494,62.2333986,0.9686458,16.6543205,10.2324697,23.9093916,4.8511003,7.3176748,0.5166951,20.1101938),(33027,'Macropus-agilis_ulna.tif',231,4,109,20.265098,19.7822014,23.0866642,1.8,19.8057453,23.0589699,-0.5661961,2.721723,3.7456238,27.8074685,64.0012417,0.9718887,17.086938,10.2168619,24.3589288,4.8472108,7.3777894,0.4241944,20.1948985),(33028,'Macropus-agilis_ulna.tif',231,4,110,20.3725267,19.649727,23.0890166,1.8,19.6721874,23.0633824,-0.566063,2.7302753,3.7767877,27.9647034,65.9130605,0.9766316,17.4521485,10.2424482,24.7725031,4.8472108,7.4735265,0.4290294,20.314689),(33029,'Macropus-agilis_ulna.tif',231,4,111,20.5843339,19.5176837,23.0884727,1.8,19.5374293,23.0561845,-0.5611898,2.7614827,3.8246237,28.2910139,68.1909489,0.9716846,17.8294529,10.2448637,25.0998782,4.8717042,7.569434,0.433742,20.5790796),(33030,'Macropus-agilis_ulna.tif',231,4,112,20.7218674,19.3799573,23.084138,1.8,19.3909952,23.0600301,-0.5568255,2.7637844,3.8542026,28.6761366,70.1439062,0.9646229,18.1993305,10.375678,25.5612917,4.8664127,7.6655054,0.4383366,20.6637843),(33031,'Macropus-agilis_ulna.tif',231,4,113,20.9043458,19.2339318,23.0798247,1.8,19.241015,23.0598594,-0.5514122,2.7716962,3.8914349,29.0814873,72.1376393,0.9562393,18.5375423,10.4923071,25.7528348,4.8743574,7.7617345,0.4428173,20.9281749),(33032,'Macropus-agilis_ulna.tif',231,4,114,20.998787,19.0856651,23.0722478,1.8,19.088308,23.0575309,-0.5501285,2.7782683,3.8917683,29.4619565,73.3379103,0.9565525,18.8443671,10.6044319,26.1425278,4.8817252,7.7617345,0.4428173,20.9705273),(33033,'Macropus-agilis_ulna.tif',231,4,115,21.1776507,18.9298849,23.0660839,1.8,18.9285765,23.0561959,-0.5488276,2.7919231,3.9088831,29.8217915,74.8842421,0.9606101,19.1574522,10.6814517,26.095816,4.9282101,7.8624384,0.4266275,21.3123561),(33034,'Macropus-agilis_ulna.tif',231,4,116,21.4324111,18.7626709,23.0602899,1.8,18.7633073,23.0440356,-0.5546016,2.8177495,3.8944855,30.4123551,76.791882,0.990579,19.7181068,10.7931364,26.302273,4.9613342,7.881032,0.3856171,21.7213466),(33035,'Macropus-agilis_ulna.tif',231,4,117,21.659338,18.596765,23.048883,1.8,18.5914725,23.0273215,-0.5627874,2.8115474,3.907558,31.206351,78.6143122,1.0276312,20.1185271,11.0993508,26.819286,4.9356353,7.9213885,0.3737268,21.4920419),(33036,'Macropus-agilis_ulna.tif',231,4,118,21.8963812,18.4143421,23.0430851,1.8,18.4138974,23.0131998,-0.5750582,2.8120772,3.9204852,31.9197134,79.9001595,1.079526,20.3801713,11.3509378,27.0677707,4.9523516,7.9628534,0.3619588,21.5942896),(33037,'Macropus-agilis_ulna.tif',231,4,119,22.1025603,18.2326111,23.0287012,1.8,18.2280945,22.9978651,-0.5849769,2.8095067,3.9200201,32.7422048,80.8698112,1.1231892,20.6299479,11.654076,27.6644879,4.9966125,7.9480693,0.3821956,21.6118325),(33038,'Macropus-agilis_ulna.tif',231,4,120,22.1191106,18.0516309,23.007975,1.8,18.046092,22.9781291,-0.592473,2.8023613,3.9230783,33.5203033,81.8051475,1.149554,20.8522854,11.9614494,27.9476687,5.0352983,7.9628534,0.3619588,21.7316231),(33039,'Macropus-agilis_ulna.tif',231,4,121,22.3045135,17.8693947,22.9839761,1.8,17.8676115,22.9521749,-0.6049533,2.763069,3.9275896,34.3686866,83.109154,1.2023864,21.1603457,12.4385914,28.312829,5.046321,7.9628534,0.3619588,21.6892707),(33040,'Macropus-agilis_ulna.tif',231,4,122,22.5187359,17.6825173,22.9544705,1.8,17.6783563,22.9230683,-0.6225325,2.721562,3.9298311,34.914608,83.8897631,1.2760586,21.3469129,12.8288857,29.3039332,5.0644399,7.8697483,0.3566201,21.7068136),(33041,'Macropus-agilis_ulna.tif',231,4,123,22.5617801,17.4930714,22.9242886,1.8,17.490801,22.8942369,-0.6454993,2.6593903,3.912799,35.1496132,83.9534726,1.3609242,21.4561169,13.2171698,30.2212626,5.052249,7.7344109,0.363147,21.604566),(33042,'Macropus-agilis_ulna.tif',231,4,124,22.6733403,17.3002619,22.8916929,1.8,17.289918,22.8618465,-0.6650863,2.5958012,3.8948865,35.4180816,84.647589,1.4391745,21.7330055,13.6443739,30.8263345,5.0574729,7.5918446,0.3398209,21.604566),(33043,'Macropus-agilis_ulna.tif',231,4,125,22.7567132,17.117058,22.8552141,1.8,17.1059493,22.8229598,-0.6824776,2.5199053,3.8875619,35.8626748,85.8401614,1.508788,22.080719,14.2317551,31.3056895,5.0380384,7.5448786,0.3217506,21.5622136),(33044,'Macropus-agilis_ulna.tif',231,4,126,22.9735274,16.9334835,22.8161159,1.8,16.9277875,22.7850233,-0.7029597,2.4945492,3.8439097,36.2832171,87.3300459,1.6002383,22.719068,14.5449996,32.1212543,5.0287543,7.4892474,1.0336881,21.5446707),(33045,'Macropus-agilis_ulna.tif',231,4,127,23.1981765,16.7482425,22.7721305,1.8,16.7421922,22.7382573,-0.7243303,2.5118306,3.8315589,36.651994,88.7331977,1.6976574,23.158511,14.5917461,32.5798053,4.9791844,7.5884011,1.0303768,21.7068136),(33046,'Macropus-agilis_ulna.tif',231,4,128,23.3007972,16.5764102,22.7126645,1.8,16.5674281,22.6810255,-0.7399541,2.5557137,3.8099823,37.0683961,90.3033956,1.7654955,23.7017889,14.5041272,32.5460236,4.9816464,7.6638004,1.014197,21.7140801),(33047,'Macropus-agilis_ulna.tif',231,4,129,23.4025909,16.4035741,22.6502099,1.8,16.4027396,22.6181233,-0.753575,2.5563529,3.7806528,37.5771768,92.0311835,1.8261756,24.34267,14.6995264,32.5427217,4.9500919,7.7411665,0.9983365,21.8762231),(33048,'Macropus-agilis_ulna.tif',231,4,130,23.5601712,16.241069,22.5823571,1.8,16.2481775,22.5552833,-0.763785,2.6250745,3.8049128,38.3093168,94.1584281,1.8785057,24.7465404,14.5936115,32.6217771,4.9496751,7.8204411,0.9827937,21.9258419),(33049,'Macropus-agilis_ulna.tif',231,4,131,23.7936424,16.0781388,22.5114697,1.8,16.1052914,22.4803604,-0.773021,2.6050876,3.8735507,39.1886229,96.6178283,1.9337256,24.9429623,15.0431111,32.931651,4.9196428,7.8836847,0.9548112,21.9010325),(33050,'Macropus-agilis_ulna.tif',231,4,132,24.0629807,15.9253259,22.4273793,1.8,15.9600535,22.3956896,-0.7815605,2.6338162,3.9809002,40.0368146,98.9369511,1.9898575,24.852909,15.2010665,33.0288682,4.948824,7.9844871,0.9526521,21.9258419),(33051,'Macropus-agilis_ulna.tif',231,4,133,24.2425975,15.7684331,22.3400931,1.8,15.799703,22.3163433,-0.7878975,2.6571964,4.0875685,40.5222595,101.2318763,2.0303149,24.765793,15.2500056,33.2278688,4.9993115,8.0691468,0.9380475,22.1127943),(33052,'Macropus-agilis_ulna.tif',231,4,134,24.3898146,15.6207821,22.2476639,1.8,15.6470301,22.22194,-0.7935395,2.7240917,4.1835967,40.9413459,103.5172929,2.0655773,24.743612,15.0293566,33.435914,5.0481152,8.1275624,0.9433081,22.197499),(33053,'Macropus-agilis_ulna.tif',231,4,135,24.634149,15.4765209,22.1619649,1.8,15.5003231,22.1378302,-0.797682,2.7382694,4.279187,41.7481881,105.9983812,2.1032742,24.7706822,15.2461948,33.7079817,5.1112491,8.1992794,0.9167136,22.2646608),(33054,'Macropus-agilis_ulna.tif',231,4,136,24.8970649,15.3330053,22.0754276,1.8,15.3634541,22.0541007,-0.8031358,2.7972106,4.3253238,42.5981345,108.4673934,2.1483425,25.0772886,15.2287905,34.0849934,5.1900204,8.2434687,0.9097532,22.3318226),(33055,'Macropus-agilis_ulna.tif',231,4,137,25.3425742,15.195814,21.9815716,1.8,15.2230138,21.9685621,-0.8066037,2.8535677,4.410186,43.4549479,111.3365455,2.2014216,25.2453172,15.2282872,34.3276842,5.2667758,8.3295754,0.9394474,22.4588797),(33056,'Macropus-agilis_ulna.tif',231,4,138,25.8543053,15.0613348,21.8833053,1.8,15.0860028,21.8728354,-0.8095601,2.911645,4.4869123,44.0717745,114.4930589,2.2585999,25.5171152,15.1363834,34.7751051,5.3469185,8.4020568,0.9135267,22.6881844),(33057,'Macropus-agilis_ulna.tif',231,4,139,26.363856,14.934904,21.7794,1.8,14.9595949,21.7761674,-0.8127822,2.9693707,4.5534709,44.6923045,118.3974773,2.3172527,26.0015886,15.051103,35.4196716,5.4434501,8.4594094,0.9187484,23.0124703),(33058,'Macropus-agilis_ulna.tif',231,4,140,26.892307,14.8140877,21.67253,1.8,14.8304962,21.6761662,-0.8160304,2.9780287,4.6163905,45.3405576,123.0998387,2.3782351,26.6658202,15.2250239,36.1209445,5.4549198,8.5747926,0.9289816,23.1395274),(33059,'Macropus-agilis_ulna.tif',231,4,141,27.2531853,14.7015745,21.555285,1.8,14.7226782,21.5567548,-0.8161441,3.0286608,4.6639413,46.0547718,127.5410164,2.410665,27.3461879,15.2063154,36.8664582,5.5333461,8.6182696,0.9222617,23.386375),(33060,'Macropus-agilis_ulna.tif',231,4,142,27.8125243,14.6115648,21.4238963,1.8,14.6367377,21.429047,-0.8092645,3.0333786,4.7286029,47.3776705,132.9420614,2.4282988,28.114448,15.618779,37.9035333,5.5558182,8.7204714,0.8675657,23.8129085),(33061,'Macropus-agilis_ulna.tif',231,4,143,28.5854771,14.5432865,21.2863335,1.8,14.5626298,21.2921776,-0.798398,3.0289694,4.7740106,48.9213007,139.2733038,2.4440504,29.1732289,16.1511371,39.2637872,5.6230502,8.8223781,0.8666145,23.9399656),(33062,'Macropus-agilis_ulna.tif',231,4,144,29.0057406,14.4895771,21.1481617,1.8,14.506408,21.1515696,-0.7854568,3.0206336,4.8106167,50.9002142,146.4280088,2.4174285,30.4385108,16.85084,40.6386684,5.6255645,8.9430165,0.8884798,24.3241468),(33063,'Macropus-agilis_ulna.tif',231,4,145,29.1303084,14.4578349,20.9982048,1.8,14.4667615,21.0047968,-0.7707559,3.059698,4.8254227,53.2012759,155.1819005,2.3564469,32.1592344,17.3877539,42.6574278,5.6864298,9.0348972,0.8760581,24.6732421),(33064,'Macropus-agilis_ulna.tif',231,4,146,29.7359845,14.4515095,20.8334124,1.8,14.4532968,20.8377637,-0.7526456,3.093686,4.9089347,56.0509662,165.6099829,2.315793,33.7364407,18.1178588,44.6898316,5.7447084,9.1832389,0.8690017,25.0223374),(33065,'Macropus-agilis_ulna.tif',231,4,147,30.7011349,14.4661402,20.6634249,1.8,14.4564831,20.6608588,-0.7363004,3.1204432,5.125517,59.2928799,179.2198672,2.3076051,34.9662028,19.0014293,46.2142639,5.8036782,9.4690926,0.8340085,25.5408421),(33066,'Macropus-agilis_ulna.tif',231,4,148,31.1761746,14.5393053,20.4545819,1.8,14.5136442,20.4507861,-0.7196402,3.148279,5.3234512,63.3620108,200.3532948,2.2573182,37.6359781,20.1259201,49.1039752,5.8781527,9.8242909,0.8270407,26.298928),(33067,'Macropus-agilis_ulna.tif',231,4,149,32.3175405,14.6362454,20.2430547,1.8,14.6035611,20.2350528,-0.6968065,3.1907743,5.3922585,68.3813351,225.650629,2.2184438,41.8471463,21.4309531,53.8479396,5.9278913,10.1225169,0.7853982,27.0993662),(33068,'Macropus-agilis_ulna.tif',231,4,150,33.2124461,14.7169585,20.067105,1.8,14.6894112,20.0444308,-0.6638546,3.2140728,5.3796021,73.7225852,245.9340524,2.1015174,45.7160299,22.9374344,58.0653436,5.9650498,10.2375375,0.7354398,27.5682521),(33069,'Macropus-agilis_ulna.tif',231,4,151,34.5987506,14.8669012,19.879097,1.8,14.8127144,19.8562899,-0.6215299,3.2115698,5.3417932,80.9618286,272.8818918,1.9551151,51.0843235,25.209425,64.1781254,6.0342685,10.4417827,0.7364178,28.1218427),(33070,'Macropus-agilis_ulna.tif',231,4,152,36.1774723,15.0156364,19.7077702,1.8,14.9410258,19.6825461,-0.5830239,3.2480291,5.2724406,90.4699232,300.2459618,1.8276028,56.9462962,27.8537908,70.8652095,6.1091639,10.5926291,0.7419473,28.8024903),(33071,'Macropus-agilis_ulna.tif',231,4,153,36.5969363,15.1229031,19.4992847,1.8,15.0275841,19.4854309,-0.5699583,3.3219794,5.3717407,96.4324276,324.8413719,1.7759568,60.4722731,29.0286053,75.2229192,6.2189762,10.8179748,0.6622155,29.5430333),(33072,'Macropus-agilis_ulna.tif',231,4,154,35.9129833,15.1531121,19.2586341,1.8,15.1012299,19.2233685,-0.5910327,3.5048661,5.9200829,100.605594,357.5192404,1.858454,60.3909184,28.7045475,74.3761138,6.3585525,11.4886503,0.7052133,30.9043286),(33073,'Macropus-agilis_ulna.tif',231,4,155,36.3070845,15.382935,18.899635,1.8,15.325977,18.8572218,-0.6072651,3.7451254,6.5353666,106.6875873,423.9788666,1.970333,64.8745344,28.4870531,79.3664352,6.70322,12.3869551,0.6820334,34.0359099),(33074,'Macropus-agilis_ulna.tif',231,4,156,42.3094141,16.3544569,17.9330044,1.8,16.4223725,17.8831175,-0.6895845,4.2427566,8.2119479,132.9901571,751.5584847,2.8542752,91.5201229,31.3452243,105.3639439,7.4754595,15.262666,0.7250688,40.3928069),(33075,'Macropus-agilis_ulna.tif',231,4,157,48.4089163,17.177039,17.3357066,1.8,17.298634,17.3071889,-0.6847852,4.6835313,7.8574431,198.2966371,972.4381526,3.2277825,123.7601263,42.3391296,146.3511865,0.0723,0.1616677,2.0344439,0.3490953),(33076,'Macropus-agilis_ulna.tif',231,4,158,47.8435425,17.2241785,17.2287114,1.8,17.4338665,17.2308093,-0.6500142,4.8446244,7.9048262,221.4566318,926.0890041,2.920563,117.1548855,45.711827,142.8988209,8.8116216,15.2472462,0.4148541,45.1706269),(33077,'Macropus-agilis_ulna.tif',231,4,159,46.1749121,17.1076342,17.4111841,1.8,17.2981563,17.4313254,-0.5760609,5.5464858,7.6982954,230.1644477,821.5863934,2.2835423,106.7231575,41.4973473,134.7202666,9.2356603,15.3057587,0.3875238,47.4769604),(33078,'Macropus-agilis_ulna.tif',231,4,160,44.7818929,17.0095059,17.6239872,1.8,17.1026355,17.7027897,-0.4752183,5.9940896,7.5177988,219.8263306,703.3914351,1.5624109,93.5634828,36.6738482,121.9232378,9.6230355,14.7074983,0.3512909,45.1603504),(33079,'Macropus-agilis_ulna.tif',231,4,161,40.263124,16.4965057,17.8285911,1.8,16.5815535,17.9353963,-0.4331221,5.8488994,6.8800723,192.4576615,523.2270766,1.1820826,76.0496478,32.9049363,102.7790892,10.1120622,12.9425084,0.2598827,41.517531),(33080,'Macropus-agilis_ulna.tif',231,4,162,35.9291248,15.947756,17.77011,1.8,15.9913508,17.9225535,-0.4573949,5.6189367,6.2915183,157.1213051,416.0504221,1.1678246,66.1287789,27.9628179,88.4461872,9.7140787,11.6510732,0.9931204,38.2528728),(33081,'Macropus-agilis_ulna.tif',231,4,163,33.4468087,15.6577739,17.602487,1.8,15.6246635,17.6918547,-0.4526085,5.1195755,5.9825912,130.8652781,363.6878995,1.0660755,60.791033,25.561744,80.4621847,8.9489028,11.221417,0.9363156,35.9114534),(33082,'Macropus-agilis_ulna.tif',231,4,164,32.7199933,15.5314332,17.3964138,1.8,15.471172,17.4633138,-0.4423775,4.7731248,5.8119682,118.2391183,341.5459224,0.99938,58.7659654,24.771847,77.8473234,8.4370882,10.9459913,0.4074937,34.4128245),(33083,'Macropus-agilis_ulna.tif',231,4,165,32.9731618,15.5110956,17.1685284,1.8,15.4545595,17.1817437,-0.4284546,4.2272418,5.7519031,110.6169395,341.2699261,0.9485919,59.3316548,26.1676396,77.2276837,7.8719475,10.9163429,0.3657473,33.971758),(33084,'Macropus-agilis_ulna.tif',231,4,166,31.9574339,15.6530321,16.8923731,1.8,15.5010326,16.9452779,-0.4239838,4.0350157,5.8444962,105.6118958,351.3898256,0.9014429,60.1232019,26.1738498,76.7556028,7.4641478,11.024743,0.2927131,33.2064056),(33085,'Macropus-agilis_ulna.tif',231,4,167,33.3856818,16.004604,16.5629499,1.8,15.8842382,16.5830688,-0.4126576,4.4201678,6.1359102,113.2196218,393.3402381,0.8949437,64.1046271,25.6143269,80.8518586,7.774809,11.5720667,0.2980396,34.7752061),(33086,'Macropus-agilis_ulna.tif',231,4,168,39.0147536,17.0140275,16.0417989,1.8,16.9382107,16.0764756,-0.3696916,5.2409868,7.3004251,134.2528916,583.6452977,0.8489469,79.9467548,25.6159569,98.1105445,8.4239402,14.5436269,0.3028849,41.3481215),(33087,'Macropus-agilis_ulna.tif',231,4,169,43.7261293,17.7063686,15.5647301,1.8,17.5519858,15.6222633,-0.3688012,5.7117586,7.7861417,179.0708963,706.6275508,0.9470968,90.7545195,31.3512718,112.3001082,8.9027397,14.4601814,0.3897912,42.7838452),(33088,'Macropus-agilis_ulna.tif',231,4,170,44.8718839,17.8532304,15.2840285,1.8,17.7751768,15.3256464,-0.4119269,5.3746964,7.7593929,229.2552062,702.1253075,1.1988331,90.4871443,42.6545411,117.4326638,9.2465626,14.0688078,0.4406632,42.3645782),(33089,'Macropus-agilis_ulna.tif',231,4,171,45.1409381,17.8186553,15.1416204,1.8,17.6543216,15.1826238,-0.4617728,4.9371593,7.4878861,262.5013878,662.33322,1.4934296,88.4539661,53.1685073,118.8952452,9.3534374,13.4904909,0.5404195,41.3245588),(33090,'Macropus-agilis_ulna.tif',231,4,172,36.7470533,16.8945788,14.9751288,1.8,16.7532913,15.0091735,-0.4648352,3.9494742,6.472224,136.4521911,480.0012636,1.2307259,74.1632647,34.5494573,91.9604112,7.6919373,12.3757671,0.5263924,36.1552911),(33091,'Macropus-agilis_ulna.tif',231,4,173,31.4248897,16.1870348,15.0447436,1.8,16.0040053,15.0409727,-0.4195819,3.374149,5.6114491,98.5130314,333.2298742,0.8691987,59.3839258,29.196408,74.1810311,6.6753117,10.8709973,0.4993467,32.5651004),(33092,'Macropus-agilis_ulna.tif',231,4,174,28.0457559,15.8179299,14.9308312,1.8,15.6621546,15.0011477,-0.3816842,3.3386872,5.1125,78.1604434,252.5643203,0.6485316,49.4013343,23.4105319,61.9289951,6.4599342,10.0624359,0.2990272,29.8425097),(33093,'Macropus-agilis_ulna.tif',231,4,175,25.6187448,15.5407748,14.7686031,1.8,15.4409827,14.8115583,-0.3646225,3.4600592,4.7273594,70.1454615,202.3381971,0.5429514,42.8015259,20.2729076,55.2994733,6.5419501,9.5244107,0.2689152,28.3190714),(33094,'Macropus-agilis_ulna.tif',231,4,176,24.0044196,15.3824949,14.5094322,1.8,15.2984159,14.5487582,-0.330932,3.6512643,4.4980193,65.5598096,168.23426,0.4223817,37.4018537,17.9553725,50.0194632,6.6786064,9.0131749,0.2430331,27.1271856),(33095,'Macropus-agilis_ulna.tif',231,4,177,23.1051112,15.2426886,14.2434496,1.8,15.1945495,14.2781178,-0.3058129,3.7228758,4.3229029,66.5587819,142.7631123,0.3490497,33.0248251,17.8783244,46.0968893,6.7949746,8.56076,0.2736593,26.3939091),(33096,'Macropus-agilis_ulna.tif',231,4,178,22.1090991,15.1327389,13.9303179,1.8,15.067162,13.9692272,-0.2695329,3.9029351,4.0895757,66.6250861,122.8706352,0.2612769,30.0448372,17.0705083,42.0086767,6.9537834,8.2132931,2.856038,25.8899374),(33097,'Macropus-agilis_ulna.tif',231,4,179,21.8413351,14.9693603,13.618311,1.8,14.9525877,13.6484077,-0.2070152,3.9880004,3.8930573,69.8163696,108.944081,0.153787,27.9841965,17.5066105,40.4542244,7.0724782,8.0824161,2.7660696,25.3859657),(33098,'Macropus-agilis_ulna.tif',231,4,180,22.4522218,14.7396989,13.2484573,1.8,14.8058515,13.2614436,0.0378527,3.9338593,3.819215,79.7012438,100.9264761,0.0053591,26.4259739,20.2603191,41.1921901,7.2808721,8.2627865,2.1757876,25.3333369),(33099,'Macropus-agilis_ulna.tif',231,4,181,23.9438215,14.5327488,12.7896863,1.8,14.650837,12.779437,0.8570426,4.0995964,4.3293077,88.9647909,107.2040176,2.2802481,24.762393,21.7008656,44.8811533,7.1199956,8.7006678,2.0084275,25.9220134),(33100,'Macropus-agilis_ulna.tif',231,4,182,24.0614432,14.3941106,12.4394714,1.8,14.579024,12.4473537,1.1799073,3.8535558,4.2607751,81.5619819,112.0723013,3.4280778,26.303266,21.1653823,45.3500497,6.9135018,8.404545,1.9497053,25.4283181),(33101,'Macropus-agilis_ulna.tif',231,4,183,23.3777492,14.3195374,12.3159369,1.8,14.5810223,12.261824,1.2973915,3.7236369,3.9572726,70.0400198,90.4342985,3.6122279,22.8526833,18.8095728,40.4664552,6.5793003,7.7872843,1.7955075,24.0815557),(33102,'Macropus-agilis_ulna.tif',231,4,184,22.6555102,14.3088076,12.2713084,1.8,14.5284454,12.1418818,1.4818132,3.34182,3.5084837,53.0546642,71.0685986,3.7460995,20.2562145,15.8759792,33.2515058,6.1455003,7.03654,1.735945,22.1418604),(33103,'Macropus-agilis_ulna.tif',231,4,185,18.5564133,14.3243176,12.1283177,1.8,14.4263564,12.0199857,-1.3014608,2.5922429,3.0684879,28.5680304,36.777272,2.8737563,11.9854708,11.020584,20.8589432,5.2056002,6.1079597,1.2827409,18.3719838),(33104,'Macropus-agilis_ulna.tif',231,4,186,5.6448009,13.8470219,12.2957371,1.8,13.8687438,12.2649226,-1.4047714,1.2386215,1.9360291,1.5119003,4.5889327,0.9151051,2.3702809,1.2206314,3.1417318,2.5529852,3.8934743,1.3078016,10.4976684),(33105,'Macropus-agilis_ulna.tif',231,4,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33106,'Macropus-agilis_ulna.tif',231,4,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33107,'Macropus-agilis_ulna.tif',231,4,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33108,'Macropus-agilis_ulna.tif',231,4,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33109,'Macropus-agilis_ulna.tif',231,4,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33110,'Macropus-agilis_ulna.tif',231,4,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33111,'Macropus-agilis_ulna.tif',231,4,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33112,'Macropus-agilis_ulna.tif',231,4,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33113,'metacarpal.tif',231,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33114,'metacarpal.tif',231,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33115,'metacarpal.tif',231,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33116,'metacarpal.tif',231,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33117,'metacarpal.tif',231,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33118,'metacarpal.tif',231,5,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33119,'metacarpal.tif',231,5,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33120,'metacarpal.tif',231,5,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33121,'metacarpal.tif',231,5,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33122,'metacarpal.tif',231,5,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33123,'metacarpal.tif',231,5,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33124,'metacarpal.tif',231,5,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33125,'metacarpal.tif',231,5,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33126,'metacarpal.tif',231,5,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33127,'metacarpal.tif',231,5,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33128,'metacarpal.tif',231,5,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33129,'metacarpal.tif',231,5,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33130,'metacarpal.tif',231,5,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33131,'metacarpal.tif',231,5,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33132,'metacarpal.tif',231,5,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33133,'metacarpal.tif',231,5,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33134,'metacarpal.tif',231,5,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33135,'metacarpal.tif',231,5,23,0.002576,6.8871836,16.8275912,1.8,6.8850001,16.8300002,-0.7965408,0.0322956,0.0668846,0.0000019,0.0000044,0.0002195,0.0000657,0.0000597,0.0000945,0.1272792,0.1909188,0.7853982,0.3818377),(33136,'metacarpal.tif',231,5,24,0.000595,14.7372271,14.4450001,1.8,14.7375001,14.4450001,0.2940353,0.0066,0.0217957,0.0000001,0.0000004,0.0000083,0.0000173,0.000019,0.000022,0.045,0.1006231,2.677945,0.1909188),(33137,'metacarpal.tif',231,5,25,0.8764164,9.4187163,16.5795116,1.8,9.4067577,16.6114287,-1.5078882,1.4350933,1.646278,0.1870724,0.2190906,0.1454921,0.1330824,0.1303556,0.2281972,2.3040005,2.5582807,0.8850668,12.1258345),(33138,'metacarpal.tif',231,5,26,2.1936779,9.3132429,16.5901575,1.8,9.2871245,16.6617766,-1.3612019,1.3128498,1.5724439,0.3824633,0.4984764,0.3497855,0.3170075,0.2913229,0.5429589,1.9108485,2.5079175,1.4085975,8.043854),(33139,'metacarpal.tif',231,5,27,4.374662,9.2282561,16.6638062,1.8,9.207515,16.6749879,1.2447141,1.4111675,1.8646236,1.4032965,2.1640887,0.6542934,1.1606035,0.9944224,1.9114965,2.5767343,3.6447222,2.1451012,9.982052),(33140,'metacarpal.tif',231,5,28,6.8790348,9.1477604,16.7134004,1.8,9.1350001,16.7052054,1.0682216,1.77592,2.3947686,3.088936,7.344947,0.8804947,3.0670801,1.7393441,4.3564547,3.1196556,4.7939259,2.1353657,12.8176008),(33141,'metacarpal.tif',231,5,29,9.1825157,9.1143015,16.7376427,1.8,9.1082742,16.7292538,1.0408686,1.9831295,2.7072721,5.3249442,15.0492291,1.1393958,5.5588165,2.6851218,7.5204163,3.4619026,5.4427682,2.1381597,14.5712761),(33142,'metacarpal.tif',231,5,30,10.9804072,9.1062384,16.7498385,1.8,9.0976618,16.7338695,1.030622,2.1597046,2.8721455,7.8145181,22.7524565,1.3460339,7.9217633,3.6183273,10.5431001,3.783973,5.7805299,2.1847111,15.8595099),(33143,'metacarpal.tif',231,5,31,12.3430945,9.1135344,16.743726,1.8,9.094006,16.712035,1.0275313,2.2895257,2.9489353,10.6284746,28.7604618,1.5074613,9.752829,4.6422167,13.1919879,4.0449205,5.9130069,2.2158195,16.6977437),(33144,'metacarpal.tif',231,5,32,13.2808801,9.1297906,16.7523207,1.8,9.1031983,16.7170237,1.0293885,2.4033552,2.994772,13.6101221,32.6994965,1.6256276,10.9188603,5.6629673,15.1245425,4.2897613,6.0140274,2.3614854,17.4286625),(33145,'metacarpal.tif',231,5,33,13.9348468,9.1394358,16.7572697,1.8,9.1026975,16.698913,1.0293275,2.4825976,3.0039988,16.5265082,35.0240726,1.7055502,11.65915,6.6569419,16.5197087,4.4776733,6.1016085,2.4449658,18.0759774),(33146,'metacarpal.tif',231,5,34,14.4894174,9.1447878,16.7481767,1.8,9.1188094,16.68938,1.0320669,2.5655527,2.9831574,19.6186723,36.3977045,1.7792618,12.2010673,7.6469575,17.8040415,4.6480694,6.1740263,2.501007,18.4532924),(33147,'metacarpal.tif',231,5,35,14.9837592,9.130256,16.743026,1.8,9.1222387,16.6856296,1.0355636,2.6596658,2.9666008,22.0189966,37.9171369,1.8476422,12.7813409,8.2788584,19.0502836,4.7934942,6.2588837,1.744219,18.786932),(33148,'metacarpal.tif',231,5,36,15.2856543,9.1313354,16.7310112,1.8,9.1461926,16.6831336,1.0406907,2.7134179,2.9783968,23.7215353,38.8222013,1.8962971,13.0345966,8.742308,19.7022213,4.9055306,6.3360576,1.677532,19.2433281),(33149,'metacarpal.tif',231,5,37,15.4087649,9.1268918,16.7229687,1.8,9.145905,16.6788821,1.0528534,2.7555536,3.0131229,25.3173093,38.9250526,1.9386332,12.918508,9.1877397,19.9817604,5.0027515,6.4209813,1.6690703,19.4342469),(33150,'metacarpal.tif',231,5,38,15.3723341,9.1176207,16.7177245,1.8,9.1375424,16.6474617,1.0541864,2.8166836,3.0274737,26.742212,38.561573,1.9369855,12.7372114,9.4942193,20.1140391,5.0849351,6.4657657,1.6683874,19.7415262),(33151,'metacarpal.tif',231,5,39,15.2069674,9.1208614,16.723686,1.8,9.1808737,16.682201,1.0319984,2.8590122,3.0367955,27.98184,38.1669762,1.8672221,12.5681747,9.7872403,20.093979,5.1574078,6.5473068,1.6533668,20.0751658),(33152,'metacarpal.tif',231,5,40,15.0092441,9.1051125,16.71878,1.8,9.1719101,16.6513105,1.0410333,2.9145208,3.0419939,28.6930036,37.9501953,1.862754,12.4754342,9.8448443,20.0418223,5.2057295,6.6273864,1.6319445,20.1278865),(33153,'metacarpal.tif',231,5,41,14.690842,9.0978735,16.7174194,1.8,9.18993,16.6388652,1.0693303,2.9529009,3.0986788,28.9946924,37.5278774,1.8826715,12.1109286,9.8190538,19.7954517,5.262674,6.67837,1.6449842,20.4042827),(33154,'metacarpal.tif',231,5,42,14.3177874,9.1010251,16.7041734,1.8,9.1843577,16.6515338,1.1021856,2.9341618,3.1269468,28.6544175,37.6608408,1.8995285,12.0439659,9.7657934,19.7898222,5.2496007,6.7267099,1.6511598,20.4833638),(33155,'metacarpal.tif',231,5,43,14.0504962,9.0982909,16.6968519,1.8,9.1695793,16.6699567,1.1026616,2.9534406,3.1084719,27.649081,38.7852158,1.8649651,12.4772613,9.3616513,19.6545218,5.2902481,6.7681257,1.6439986,20.610643),(33156,'metacarpal.tif',231,5,44,13.8659485,9.1059974,16.7192905,1.8,9.204355,16.6598301,1.1021014,2.9569105,3.1436014,26.6048781,40.0562065,1.8394266,12.742139,8.9975256,19.593894,5.2731776,6.8164233,1.6500999,20.790643),(33157,'metacarpal.tif',231,5,45,13.5587059,9.1032101,16.7615863,1.8,9.2141228,16.6947714,1.0842339,2.9624134,3.1673924,25.2465837,40.6010085,1.7657042,12.8184333,8.5223026,19.3551153,5.1778196,6.8201357,1.6566773,20.7160846),(33158,'metacarpal.tif',231,5,46,13.0616796,9.0982646,16.7995641,1.8,9.1974145,16.7217258,1.0718118,2.9086454,3.6891535,23.1769175,40.5654715,1.6784368,10.9958752,7.9682857,16.4789155,5.0693066,6.8379274,1.682907,20.7379223),(33159,'metacarpal.tif',231,5,47,12.4263676,9.1021779,16.8134187,1.8,9.1791359,16.7318269,1.0687506,2.7332716,5.1920085,20.8519723,40.6526203,1.5914603,7.8298447,7.6289425,11.84164,4.8563945,6.8732253,1.669162,20.5251658),(33160,'metacarpal.tif',231,5,48,11.8594311,9.09893,16.8073599,1.8,9.1612333,16.7311088,1.0806126,2.6100905,3.2213765,18.7391133,40.3745599,1.5384818,12.5333255,7.1794878,17.2814264,4.698375,6.8485802,1.6959663,20.3188054),(33161,'metacarpal.tif',231,5,49,11.1250252,9.0825277,16.8127552,1.8,9.1389264,16.7822342,1.0791439,2.561159,3.2092297,16.5208408,38.8963769,1.4409456,12.1201598,6.4505331,16.2170007,4.5779232,6.8158291,1.7098923,20.160643),(33162,'metacarpal.tif',231,5,50,10.2857462,9.0726182,16.8000643,1.8,9.1178662,16.723189,1.068541,2.4789673,3.2366095,14.8739464,36.2412946,1.3170051,11.1973021,6.0000574,14.8449606,4.4467754,6.8063152,1.7435536,19.8797242),(33163,'metacarpal.tif',231,5,51,9.6489094,9.0735034,16.818285,1.8,9.1149925,16.7724882,1.067809,2.3903796,3.2730368,13.757227,33.8270852,1.2344696,10.3350765,5.7552479,13.7626228,4.3539025,6.8288891,1.7229447,19.5788411),(33164,'metacarpal.tif',231,5,52,9.1032207,9.0752676,16.8350472,1.8,9.1076013,16.8095639,1.0829597,2.3436353,3.2912095,12.7985029,31.8904103,1.1838819,9.6895718,5.4609617,13.055853,4.3293456,6.7781414,1.7577756,19.3242826),(33165,'metacarpal.tif',231,5,53,8.7083995,9.0801949,16.8957838,1.8,9.1044145,16.8662101,1.0888559,2.3187696,3.2779141,11.8585923,30.9130658,1.1395932,9.4307126,5.1141746,12.8020222,4.292696,6.6954799,1.7260006,19.1333638),(33166,'metacarpal.tif',231,5,54,8.3313856,9.0755484,16.9082482,1.8,9.0939961,16.8737835,1.0837615,2.2508458,3.2665617,11.1277211,29.4929406,1.0844256,9.0287414,4.9437953,12.2444745,4.2316061,6.5598209,1.8274217,18.8087697),(33167,'metacarpal.tif',231,5,55,7.9952797,9.0820195,16.870121,1.8,9.0853255,16.8993841,1.0807262,2.148906,3.3140849,10.5684705,27.6305767,1.037325,8.3373172,4.9180703,10.673561,4.1868164,6.4209813,2.1160235,18.2514547),(33168,'metacarpal.tif',231,5,56,7.838768,9.0968056,16.8493014,1.8,9.0630217,16.8699473,1.0719564,2.043082,3.2410816,10.2110893,26.2028156,1.0074471,8.0845898,4.9978853,11.0505313,4.0968164,6.3464361,2.082027,18.1723735),(33169,'metacarpal.tif',231,5,57,7.7242339,9.0807893,16.8625719,1.8,9.049146,16.8790409,1.0625805,1.9894963,3.223114,10.0246334,24.8781777,0.9825247,7.7186775,5.0387795,10.7427035,4.0213552,6.2743945,2.1050658,17.8323378),(33170,'metacarpal.tif',231,5,58,7.6100856,9.0666179,16.8766389,1.8,9.0481045,16.9162067,1.056926,1.9673267,3.0761571,9.8104981,23.655039,0.9618859,7.689802,4.9867151,10.7988493,3.9815184,6.0783325,1.9183023,17.7005359),(33171,'metacarpal.tif',231,5,59,7.4610257,9.0860185,16.9020718,1.8,9.0374533,16.9601746,1.0775787,2.0234745,2.9864872,9.5582741,22.7091979,0.964752,7.6039831,4.7236939,10.676744,3.9809084,5.9937906,1.9234159,17.3668963),(33172,'metacarpal.tif',231,5,60,7.3641817,9.0877038,16.9206843,1.8,9.0351253,16.9745134,1.0850546,2.0249618,2.9531724,9.4209275,21.9643627,0.9598445,7.4375484,4.6523975,10.4246823,3.951164,5.9526003,1.854288,17.0377794),(33173,'metacarpal.tif',231,5,61,7.3976663,9.1023157,16.9403288,1.8,9.0521263,16.9884963,1.0825119,2.028144,2.9804524,9.3242988,21.6522979,0.9616158,7.2647689,4.5974541,9.3529939,3.9289408,5.9253228,1.9357891,16.9632209),(33174,'metacarpal.tif',231,5,62,7.4855977,9.1138396,16.9540094,1.8,9.0572841,16.9927874,1.0832238,2.0164313,2.9235064,9.2485482,21.6500192,0.9737815,7.4054975,4.5865922,10.3911175,3.8805225,5.9162594,1.9527151,16.8995813),(33175,'metacarpal.tif',231,5,63,7.6044721,9.1169148,16.9448537,1.8,9.0405724,16.975759,1.0892911,2.0291537,2.9402413,9.1937072,21.6040018,0.9955846,7.347697,4.5308086,9.5786085,3.8645884,5.9215624,1.9936503,16.7504644),(33176,'metacarpal.tif',231,5,64,7.7048359,9.098047,16.9232752,1.8,9.0038871,16.9441651,1.0903313,2.0233682,2.96666,9.0973865,21.5658958,1.0098201,7.2694195,4.4961598,10.2251416,3.8263488,5.9215624,1.9936503,16.5968248),(33177,'metacarpal.tif',231,5,65,7.830647,9.0744952,16.918223,1.8,9.005809,16.9683596,1.0888679,2.0035124,2.9815558,9.0847935,21.7203864,1.0247421,7.2849171,4.5344335,9.502166,3.8125386,5.9183127,2.0106389,16.6604644),(33178,'metacarpal.tif',231,5,66,7.9221029,9.0443096,16.9219658,1.8,8.9914656,16.982179,1.0898641,1.9759087,2.9751831,9.0880431,21.8852149,1.03779,7.355922,4.5994246,9.9805858,3.8046124,5.883137,2.0823525,16.3840683),(33179,'metacarpal.tif',231,5,67,7.9184916,9.0333349,16.9367961,1.8,8.9708902,16.9795482,1.0960871,1.9486964,2.9666501,8.9221243,21.7923189,1.0440241,7.3457666,4.5785091,10.2672533,3.7859895,5.8791773,2.0652561,16.2940683),(33180,'metacarpal.tif',231,5,68,7.8921954,9.0342815,16.9498457,1.8,8.9807044,17.0102858,1.0944916,1.9427312,2.9349436,8.8112998,21.3609521,1.0388487,7.2781474,4.5355217,9.5278089,3.7816017,5.8439392,2.086122,16.2567891),(33181,'metacarpal.tif',231,5,69,7.8804642,9.0350785,16.9535749,1.8,8.970713,17.0070016,1.0929312,1.9216311,2.9267598,8.7091468,20.9058168,1.0356326,7.1429903,4.5321638,9.5013879,3.7613646,5.8194588,2.1244776,16.3577079),(33182,'metacarpal.tif',231,5,70,7.906125,9.0514792,16.9551412,1.8,8.9783678,16.986294,1.100957,1.9207961,2.8800081,8.6160817,20.5548557,1.0475928,7.1370826,4.4856827,9.907783,3.7439294,5.7578903,2.0064792,15.9013118),(33183,'metacarpal.tif',231,5,71,7.9489614,9.0601472,16.9480059,1.8,8.9816866,16.975706,1.1043052,1.9318578,2.8645615,8.5598491,20.125724,1.0568414,7.025761,4.4308898,9.1855812,3.7329582,5.7204895,1.9922155,15.8222307),(33184,'metacarpal.tif',231,5,72,7.8944351,9.0490372,16.9305742,1.8,8.9862482,16.9730972,1.0946793,1.9079219,2.8796953,8.4655436,19.5941439,1.0393448,6.8042421,4.4370493,9.5533122,3.6836927,5.6965451,2.0556422,15.6576722),(33185,'metacarpal.tif',231,5,73,7.8230863,9.0231263,16.9194788,1.8,8.9652507,16.9707231,1.0876928,1.8734018,2.8804588,8.4829258,19.0227948,1.0224931,6.6040851,4.5280868,9.4200906,3.6634996,5.6429713,2.0879642,15.6158703),(33186,'metacarpal.tif',231,5,74,7.7054423,9.0139818,16.920225,1.8,8.9724459,16.9690747,1.0938836,1.8593487,2.8258977,8.4488339,18.3829745,1.0136299,6.5051804,4.543975,9.0344699,3.6832357,5.556179,2.0598008,15.3613118),(33187,'metacarpal.tif',231,5,75,7.6753976,9.0164577,16.9385455,1.8,8.9801877,16.9740788,1.0979398,1.8369117,2.7700462,8.3852904,17.8948382,1.0138975,6.4601226,4.5648849,9.2889898,3.6630426,5.4953458,2.0564184,15.2231138),(33188,'metacarpal.tif',231,5,76,7.7057817,9.0284896,16.9600357,1.8,9.0021742,16.9907361,1.0981858,1.8173824,2.7063612,8.3339435,17.4500513,1.0181673,6.447791,4.5856852,9.3365521,3.6430779,5.4099284,2.1126424,15.0694742),(33189,'metacarpal.tif',231,5,77,7.7099768,9.0486879,16.9739579,1.8,9.0251243,16.9949376,1.0965327,1.8081666,2.6442958,8.2206296,17.0016306,1.0169976,6.4295494,4.5463895,9.3421094,3.622999,5.3330222,2.1213457,14.9158346),(33190,'metacarpal.tif',231,5,78,7.6964017,9.0627861,16.9786985,1.8,9.0460964,17.0048257,1.0910048,1.7947889,2.5906239,8.0891759,16.5543655,1.0094225,6.3901076,4.5070346,9.2730681,3.6026917,5.2410997,2.0920724,14.7358346),(33191,'metacarpal.tif',231,5,79,7.6673006,9.0754146,16.9764226,1.8,9.0668837,16.9904111,1.0927293,1.7721186,2.5489365,7.9799332,16.0775686,1.0074083,6.3075594,4.5030469,9.2137128,3.5826128,5.1632476,2.1007528,14.5821949),(33192,'metacarpal.tif',231,5,80,7.6111608,9.0863591,16.9671501,1.8,9.0802468,16.9728065,1.0946273,1.7630779,2.5307249,7.906791,15.4858433,1.0019964,6.1191335,4.4846521,9.081444,3.5632193,5.096337,2.0778948,14.4021949),(33193,'metacarpal.tif',231,5,81,7.5758937,9.0943888,16.9486434,1.8,9.0892124,16.9470808,1.0882845,1.744367,2.5010074,7.8030756,14.9231057,0.990799,5.9668378,4.4732992,8.9182384,3.5431404,5.013614,2.0665614,14.2485553),(33194,'metacarpal.tif',231,5,82,7.5817096,9.1031833,16.9267917,1.8,9.0977001,16.9187531,1.0806745,1.7624437,2.475987,7.6841679,14.465064,0.9836132,5.8421406,4.3599508,8.774792,3.5447187,4.9397622,2.0955921,14.0576365),(33195,'metacarpal.tif',231,5,83,7.5949933,9.1128362,16.9028693,1.8,9.1091907,16.9024167,1.0731104,1.7784976,2.4503978,7.565623,14.0070004,0.9773433,5.7162149,4.2539406,8.624724,3.5379801,4.8620829,2.1048667,13.9412761),(33196,'metacarpal.tif',231,5,84,7.626377,9.1275976,16.8791677,1.8,9.1357428,16.8852075,1.0679763,1.7907119,2.4268205,7.4471955,13.5763471,0.9758889,5.5942938,4.1587904,8.4539597,3.5429119,4.7848355,2.1144416,13.8139969),(33197,'metacarpal.tif',231,5,85,7.6251017,9.1538399,16.8684483,1.8,9.1590712,16.8742314,1.0739961,1.8401008,2.4037363,7.359435,13.1022103,0.9821616,5.4507685,3.9994738,8.3596143,3.6025774,4.7230711,2.1112158,13.6712761),(33198,'metacarpal.tif',231,5,86,7.5577641,9.1925247,16.86659,1.8,9.1925923,16.8721555,1.0844572,1.7650957,2.3505317,7.2696953,12.5185588,0.9844543,5.3258412,4.1185842,8.221403,3.5227188,4.6461275,2.1211823,13.6185553),(33199,'metacarpal.tif',231,5,87,7.4863725,9.2349158,16.8688486,1.8,9.2301947,16.871586,1.0999657,1.7805734,2.3138093,7.2133349,11.9357337,0.9909746,5.1584777,4.0511303,8.1411303,3.5423856,4.5996957,2.1045045,13.4803573),(33200,'metacarpal.tif',231,5,88,7.45867,9.2684001,16.8630598,1.8,9.2606033,16.8618624,1.1056766,1.7673643,2.2650177,7.1435092,11.4616582,0.9930237,5.0602951,4.0418998,8.0339711,3.522833,4.5224441,2.1146288,13.3267177),(33201,'metacarpal.tif',231,5,89,7.4639436,9.2980999,16.85193,1.8,9.2882343,16.8463844,1.1052266,1.7761326,2.2413247,7.0783109,11.0952155,0.9932769,4.9502936,3.9852378,7.9495115,3.5229473,4.4713337,2.0749623,13.1621592),(33202,'metacarpal.tif',231,5,90,7.4563628,9.327371,16.8387787,1.8,9.3167679,16.8339033,1.1061919,1.7636655,2.2201896,7.0043935,10.7295406,0.9932298,4.8327137,3.9714977,7.8414572,3.4950285,4.4150482,2.0937351,13.1357988),(33203,'metacarpal.tif',231,5,91,7.4479769,9.3549502,16.8199715,1.8,9.3475151,16.8194791,1.0992985,1.7529427,2.1831975,6.9321114,10.3906771,0.9852222,4.7593849,3.9545568,7.7164791,3.5025256,4.3603584,2.1129857,12.9557988),(33204,'metacarpal.tif',231,5,92,7.4387301,9.3828835,16.8008897,1.8,9.379933,16.8032317,1.0863364,1.7539632,2.1654574,6.8720212,10.0624784,0.9708721,4.6468143,3.9179963,7.6205664,3.4938423,4.3073252,2.1327179,12.8657988),(33205,'metacarpal.tif',231,5,93,7.440868,9.4127691,16.7872795,1.8,9.408358,16.7899164,1.0780152,1.7804606,2.1402879,6.8202876,9.7492733,0.9625969,4.5551224,3.8306311,7.552282,3.5038131,4.2600529,2.114839,12.8394384),(33206,'metacarpal.tif',231,5,94,7.4351215,9.446583,16.7757077,1.8,9.4428916,16.7738686,1.0753744,1.8152828,2.115424,6.7762343,9.4470758,0.9591209,4.4658073,3.7328807,7.4996901,3.5423407,4.2216141,2.1203563,12.7121592),(33207,'metacarpal.tif',231,5,95,7.4122278,9.4795153,16.7641115,1.8,9.4746218,16.7615201,1.0720137,1.8172379,2.0874096,6.7136298,9.168161,0.9526872,4.3921236,3.6944144,7.4047342,3.5310798,4.1753114,2.1019739,12.7494384),(33208,'metacarpal.tif',231,5,96,7.3830108,9.5111714,16.7516223,1.8,9.5108519,16.7494889,1.0615159,1.9059853,2.061733,6.6469902,8.9017585,0.9380064,4.3176097,3.4874299,7.33903,3.608089,4.1365747,2.1074845,12.7385196),(33209,'metacarpal.tif',231,5,97,7.353036,9.5443064,16.7366648,1.8,9.5434247,16.7358293,1.0507965,1.8089227,2.0377386,6.5838018,8.649347,0.9229411,4.2445811,3.6396259,7.2413808,3.5224695,4.097966,2.1130991,12.4839612),(33210,'metacarpal.tif',231,5,98,7.3410649,9.5772732,16.7219083,1.8,9.5754652,16.7235945,1.0436006,1.7918052,2.0151417,6.5256322,8.4105522,0.9138139,4.1736778,3.6419318,7.1658279,3.5010858,4.0594889,2.1188202,12.3939612),(33211,'metacarpal.tif',231,5,99,7.3622663,9.6094358,16.7066263,1.8,9.607464,16.7074285,1.0381139,1.8990794,1.9872728,6.5125815,8.2145895,0.9105804,4.1335992,3.429336,7.104382,3.5911338,4.0133341,2.0996779,12.58488),(33212,'metacarpal.tif',231,5,100,7.3790777,9.6423804,16.6927109,1.8,9.6409538,16.6965459,1.0296698,1.832747,1.971041,6.495975,8.0488559,0.9035312,4.0835559,3.5443926,7.0713192,3.5324895,3.9829449,2.1305932,12.3785196),(33213,'metacarpal.tif',231,5,101,7.3995642,9.6775141,16.6786605,1.8,9.6810542,16.6813604,1.0200122,1.8818164,1.9528178,6.5004076,7.894845,0.8954693,4.0427966,3.4543262,7.0370602,3.5751853,3.9518098,2.0955921,12.40488),(33214,'metacarpal.tif',231,5,102,7.4213811,9.7136376,16.666065,1.8,9.7175857,16.6689967,1.0086602,1.8643532,1.9340647,6.5083982,7.76664,0.8855149,4.0157085,3.4909684,7.039476,3.5551952,3.9209438,2.1269626,12.4157988),(33215,'metacarpal.tif',231,5,103,7.460556,9.7511044,16.6542555,1.8,9.757621,16.6549059,0.9988086,1.8985394,1.9241291,6.5520203,7.6474504,0.8790891,3.9744996,3.4510847,7.0175811,3.5997823,3.8827986,2.1330811,12.4421592),(33216,'metacarpal.tif',231,5,104,7.5135151,9.7887298,16.6432702,1.8,9.7947255,16.6434917,0.9933981,1.9119106,1.9147767,6.5745721,7.5337649,0.8791469,3.9345396,3.4387445,7.0473491,3.6037374,3.8681682,2.0812846,12.22488),(33217,'metacarpal.tif',231,5,105,7.5519551,9.8252437,16.6304538,1.8,9.8300136,16.629804,0.9741664,1.9233329,1.9048946,6.6250051,7.419609,0.8613204,3.8950234,3.4445441,7.0113364,3.6265563,3.8289686,2.087027,12.2357988),(33218,'metacarpal.tif',231,5,106,7.5744688,9.8641124,16.6175391,1.8,9.874917,16.6155045,0.9626467,1.9687303,1.9059944,6.6872452,7.319173,0.8503091,3.8400811,3.39673,7.0691612,3.6723789,3.8069575,2.0767467,12.2885196),(33219,'metacarpal.tif',231,5,107,7.597693,9.905786,16.6050211,1.8,9.9164269,16.6033182,0.9567844,1.9374027,1.8954217,6.7604049,7.239184,0.8459395,3.8193,3.4894165,7.0396518,3.6452572,3.8026997,1.2078706,12.13488),(33220,'metacarpal.tif',231,5,108,7.6307123,9.9487985,16.5911576,1.8,9.9579261,16.5899767,0.9428066,1.9906015,1.886591,6.8734983,7.1563196,0.832792,3.7932544,3.4529756,6.9977936,3.6686989,3.829233,1.2230293,12.2512404),(33221,'metacarpal.tif',231,5,109,7.6768467,9.9922035,16.5751155,1.8,10.0012101,16.572231,0.8782553,1.9679276,1.885271,6.9771785,7.1009944,0.7578638,3.7665642,3.5454447,6.9787124,3.6274578,3.8471711,1.1490091,12.2357988),(33222,'metacarpal.tif',231,5,110,7.7348064,10.0360706,16.5598086,1.8,10.0393835,16.5602193,-0.1342609,1.9742749,1.8790922,7.0677892,7.1117756,0.0230986,3.784687,3.5799418,7.1144888,3.6492668,3.8421674,1.2490458,12.1985196),(33223,'metacarpal.tif',231,5,111,7.7966221,10.0838544,16.5424015,1.8,10.0887161,16.5434949,-0.523607,1.8196555,2.0192077,7.0340619,7.2418427,0.3248685,3.5864773,3.8656008,7.0622509,3.6274578,3.8608322,1.201112,12.273078),(33224,'metacarpal.tif',231,5,112,7.8648632,10.1311419,16.5261562,1.8,10.1343125,16.5264343,-0.5770111,1.8314881,2.0118647,7.0265505,7.3803903,0.3900888,3.6684328,3.8365253,7.1493242,3.6240053,3.8608322,1.201112,12.22488),(33225,'metacarpal.tif',231,5,113,7.940238,10.17984,16.5128221,1.8,10.1824546,16.515244,-0.6005652,1.8316111,2.0214042,7.0391041,7.5494296,0.4226165,3.7347452,3.8431215,7.1407001,3.595638,3.90075,0.2925618,12.3103573),(33226,'metacarpal.tif',231,5,114,8.0026151,10.2283695,16.4984197,1.8,10.2263251,16.5004906,-0.6265145,1.8430952,2.0079779,7.067809,7.7329713,0.4585189,3.8511236,3.8347499,7.3360637,3.595638,3.9028259,1.2052781,12.3257988),(33227,'metacarpal.tif',231,5,115,8.0752327,10.2778689,16.4855659,1.8,10.2752047,16.4900108,-0.6454849,1.8418228,2.0196401,7.1097575,7.9157294,0.4870785,3.9193763,3.8601745,7.4013466,3.5947591,3.9116365,1.1689257,12.4003573),(33228,'metacarpal.tif',231,5,116,8.1689264,10.326906,16.472397,1.8,10.3231251,16.4748108,-0.6520443,1.844361,2.0343532,7.1800309,8.1439178,0.5013291,4.0031976,3.892964,7.4584918,3.5638182,3.9663869,1.1375962,12.4376365),(33229,'metacarpal.tif',231,5,117,8.2601129,10.3781205,16.458035,1.8,10.3715378,16.4632591,-0.6666742,1.8405429,2.0529362,7.2476004,8.3704768,0.5264288,4.0773195,3.9377515,7.5490569,3.5638182,3.9908176,1.0516502,12.4639969),(33230,'metacarpal.tif',231,5,118,8.3019475,10.4314917,16.4397762,1.8,10.4267392,16.4429223,-0.6755311,1.8406318,2.0749577,7.3151627,8.6265449,0.5410309,4.1574559,3.9742673,7.6761973,3.5638182,4.0080326,1.0669693,12.5649157),(33231,'metacarpal.tif',231,5,119,8.3444905,10.4839394,16.4210769,1.8,10.480764,16.4251645,-0.6870595,1.848972,2.0972394,7.4136956,8.9145984,0.5594899,4.2506347,4.009631,7.6869088,3.595638,4.1137483,1.0435093,12.6812761),(33232,'metacarpal.tif',231,5,120,8.399109,10.5370495,16.4027263,1.8,10.5335367,16.4096416,-0.6876558,1.8463549,2.1425336,7.5261238,9.2047379,0.5639707,4.2961929,4.0762065,7.7693956,3.595638,4.1137483,1.0435093,12.7339969),(33233,'metacarpal.tif',231,5,121,8.4979272,10.5932934,16.3821076,1.8,10.5941289,16.3847081,-0.6860316,1.8433507,2.1559402,7.6658379,9.5389913,0.5683501,4.4245156,4.1586433,7.9269834,3.595638,4.1716724,0.4105574,12.9094741),(33234,'metacarpal.tif',231,5,122,8.6165599,10.6484987,16.3606425,1.8,10.6444757,16.36957,-0.6894579,1.8463501,2.1785997,7.8456834,9.9151411,0.5811114,4.5511531,4.2492935,8.1480107,3.5875853,4.2216141,0.9443511,12.9249157),(33235,'metacarpal.tif',231,5,123,8.765454,10.7037098,16.3380882,1.8,10.7010368,16.3480083,-0.69341,1.8531709,2.2023309,8.0321631,10.3693039,0.596825,4.7083315,4.3342808,8.3036082,3.6202272,4.2600529,1.0267537,13.0894741),(33236,'metacarpal.tif',231,5,124,8.9295909,10.7605603,16.31119,1.8,10.7585317,16.3237331,-0.6880098,1.8505158,2.2345449,8.2296721,10.8560871,0.6001076,4.8582989,4.4472315,8.5141637,3.6218931,4.369405,1.0056469,13.2167534),(33237,'metacarpal.tif',231,5,125,9.0880233,10.822004,16.2822765,1.8,10.8238285,16.2974725,-0.6847523,1.8505381,2.2865901,8.4536833,11.3640849,0.6059173,4.9698828,4.5682299,8.5576736,3.6274578,4.4431661,0.9799847,13.4076722),(33238,'metacarpal.tif',231,5,126,9.2212809,10.8838636,16.2511164,1.8,10.8868526,16.2695002,-0.6814033,1.8515953,2.3117726,8.7084045,11.8955107,0.6097622,5.1456232,4.70319,8.8372165,3.6585629,4.4894126,0.4905469,13.4713118),(33239,'metacarpal.tif',231,5,127,9.3616458,10.9434124,16.2214446,1.8,10.9490706,16.245534,-0.6895887,1.8589812,2.3467417,8.977372,12.4516383,0.6315613,5.3059261,4.8291892,9.1131535,3.6592776,4.5325076,0.5080628,13.6622306),(33240,'metacarpal.tif',231,5,128,9.4872622,11.0034156,16.1912612,1.8,11.0082144,16.2166306,-0.6988016,1.8759543,2.3677542,9.2473242,13.0618848,0.6543614,5.5165713,4.9293975,9.3252973,3.7161498,4.6148592,0.4112937,13.8795099),(33241,'metacarpal.tif',231,5,129,9.5561904,11.0653803,16.1576,1.8,11.0688907,16.1817567,-0.7051174,1.8867143,2.4208231,9.5347691,13.6797669,0.6690349,5.6508743,5.053637,9.5637585,3.7424894,4.6804327,0.9907936,13.9476722),(33242,'metacarpal.tif',231,5,130,9.6129084,11.1283295,16.118683,1.8,11.1282399,16.1430882,-0.7182669,2.7638024,2.4509564,9.8520086,14.3171192,0.6938441,5.8414418,3.5646574,6.9514473,3.754737,4.7335637,1.0646212,14.0858703),(33243,'metacarpal.tif',231,5,131,9.6848458,11.1937929,16.0805943,1.8,11.1925122,16.1085575,-0.7263834,1.9025721,2.4777324,10.1727458,14.9799462,0.7120334,6.0458289,5.3468385,10.1470176,3.7927535,4.8168922,1.052809,14.2658703),(33244,'metacarpal.tif',231,5,132,9.8015257,11.2663978,16.0277986,1.8,11.2689225,16.0500172,-0.7535789,1.9231045,2.6033061,10.5772162,15.8742439,0.7648493,6.0977247,5.5000737,10.1597302,3.8434947,5.0323603,1.0150406,14.7004287),(33245,'metacarpal.tif',231,5,133,9.9306738,11.3366042,15.9764373,1.8,11.3407789,15.999708,-0.7833648,1.9394319,2.6446528,11.0076298,17.0210756,0.8241908,6.4360341,5.6756982,10.5919223,3.8866826,5.1183421,1.0047414,15.055906),(33246,'metacarpal.tif',231,5,134,10.038345,11.3984713,15.9228639,1.8,11.4005559,15.9425166,-0.7979659,1.9736084,2.6275207,11.510211,17.9760846,0.8575532,6.8414627,5.8320642,11.1210141,3.9289825,5.1921889,1.1032728,15.1086268),(33247,'metacarpal.tif',231,5,135,10.1553733,11.4657888,15.8589165,1.8,11.4721392,15.8752372,-0.8173227,2.0187309,2.7264504,12.028555,19.1751319,0.9002786,7.0330022,5.9584736,11.3928929,3.9851305,5.3868591,1.0361074,15.4686268),(33248,'metacarpal.tif',231,5,136,10.2782845,11.5315294,15.8119018,1.8,11.5336981,15.8192832,-0.8173538,2.0953293,2.8647263,12.6450637,20.3746922,0.911228,7.1122649,6.0348814,11.5068117,4.0489123,5.5570901,1.0164888,15.7804287),(33249,'metacarpal.tif',231,5,137,10.4179446,11.604954,15.7705305,1.8,11.6045383,15.771104,-0.7991309,2.1615823,2.9436322,13.4049233,21.295944,0.8920035,7.2345805,6.2014403,11.7408609,4.1312071,5.6429713,1.0071252,16.1995456),(33250,'metacarpal.tif',231,5,138,10.5441864,11.6999052,15.7176534,1.8,11.6979363,15.7157168,-0.7577898,2.1776989,3.0419142,14.2028036,22.4853609,0.8301889,7.3918459,6.5219317,11.9943132,4.2158813,5.7915543,0.995724,16.7086625),(33251,'metacarpal.tif',231,5,139,10.5694738,11.8056608,15.6740039,1.8,11.8162062,15.6533906,-0.7203741,2.1811478,3.1340299,14.8176714,23.6976568,0.766567,7.561401,6.7935203,12.2738947,4.298458,5.9059822,0.9532041,17.2968605),(33252,'metacarpal.tif',231,5,140,10.5597003,11.8936986,15.6418488,1.8,11.9301385,15.5957543,-0.6826844,2.225545,3.1822815,15.4194955,24.3464381,0.7004726,7.6506236,6.9284131,12.4938975,4.4060961,5.9687374,0.9514233,17.6677794),(33253,'metacarpal.tif',231,5,141,10.6621155,11.9864401,15.6047353,1.8,12.0457057,15.5519466,-0.6373296,2.3064332,3.1400079,16.1472462,25.1722885,0.629218,8.0166322,7.0009597,13.157879,4.5677771,5.9675498,0.9137214,17.7841398),(33254,'metacarpal.tif',231,5,142,10.7293187,12.0685445,15.5694717,1.8,12.1293684,15.5157339,-0.6115708,2.3786874,3.1042516,16.6091245,25.6788605,0.5894922,8.2721582,6.9824748,13.6105119,4.6406406,5.9319833,0.9090878,17.7841398),(33255,'metacarpal.tif',231,5,143,10.7782914,12.1359293,15.5508925,1.8,12.1913919,15.5012788,-0.6107758,2.4425903,3.1083232,17.0816174,26.3500999,0.5908405,8.4772715,6.993239,13.9545854,4.7393733,5.9169439,0.9638087,18.516932),(33256,'metacarpal.tif',231,5,144,10.786709,12.2064925,15.5296152,1.8,12.2460593,15.5099316,-0.5866621,2.5165092,3.0759452,17.2736667,27.145895,0.5509412,8.8252206,6.8641381,13.9442586,4.8470251,5.9116369,1.0355987,18.8023736),(33257,'metacarpal.tif',231,5,145,10.6711096,12.2538227,15.5206195,1.8,12.2889824,15.5242857,-0.5523954,2.4981569,3.072503,17.201,27.3241526,0.489696,8.8931248,6.8854762,13.7903676,4.9274361,5.9052964,1.0081583,19.1732924),(33258,'metacarpal.tif',231,5,146,10.6994761,12.3019056,15.5341185,1.8,12.3287136,15.5438402,-0.5321405,2.563088,3.0611097,17.4501974,27.29992,0.4590672,8.9183083,6.808271,14.1067112,4.998657,5.8335346,0.8454352,18.8550943),(33259,'metacarpal.tif',231,5,147,10.7427095,12.3354487,15.5461775,1.8,12.3479885,15.5685263,-0.557204,2.6238366,3.0690585,17.7463938,27.1396171,0.5006917,8.842978,6.7635287,13.787002,5.042042,5.9160883,0.9912323,19.2478508),(33260,'metacarpal.tif',231,5,148,10.8956097,12.3596966,15.5790295,1.8,12.356582,15.5897177,-0.5728329,2.7057589,3.0891815,18.3267202,27.3697878,0.5334857,8.8598833,6.7732273,14.1312779,5.1229887,5.833361,0.9056936,20.6196885),(33261,'metacarpal.tif',231,5,149,11.1072447,12.4020207,15.6123207,1.8,12.397835,15.6100248,-0.5951019,2.7034889,3.082866,18.8885011,27.4314818,0.5817691,8.8980456,6.9867131,14.4234112,5.1324873,5.8672822,1.0040671,21.6887697),(33262,'metacarpal.tif',231,5,150,11.4750032,12.4254,15.639745,1.8,12.4137981,15.6499042,-0.6358532,2.7377152,3.0990499,19.5363563,27.6077121,0.6744904,8.908444,7.1360076,13.8055603,5.2515471,6.0816631,1.3922665,21.3506073),(33263,'metacarpal.tif',231,5,151,11.6160823,12.4318997,15.6844307,1.8,12.4128631,15.715276,-0.6263605,2.8567759,3.1479958,20.3334903,27.6525135,0.6652733,8.7841647,7.1176359,13.9005304,5.2439199,6.0841598,1.0608243,19.5705716),(33264,'metacarpal.tif',231,5,152,11.5281745,12.386226,15.7150612,1.8,12.4022284,15.7865188,-0.6263342,3.0477555,3.213037,21.5510841,27.366091,0.6601907,8.5172037,7.0711329,12.9755305,5.3717577,6.3464361,1.1547318,19.8759775),(33265,'metacarpal.tif',231,5,153,11.5604967,12.3212218,15.6963114,1.8,12.3561885,15.7872144,-0.5637237,3.2412586,3.2809155,22.7154154,27.2658635,0.5501187,8.3104437,7.0082082,13.3409752,5.5349502,6.3006429,1.1902899,20.023221),(33266,'metacarpal.tif',231,5,154,11.7540474,12.2579812,15.6947565,1.8,12.3104438,15.7786179,-0.4133764,3.5129411,3.2806156,23.7768804,27.0549587,0.3161169,8.2469151,6.7683687,13.5516848,5.491722,6.3520175,2.0978509,21.0523736),(33267,'metacarpal.tif',231,5,155,11.7149501,12.2265542,15.7051061,1.8,12.2750514,15.7635862,-0.1892676,3.6434633,3.1653793,24.0038214,26.8910144,0.0691114,8.4953529,6.588188,13.787617,5.4342525,6.5304288,2.0899424,21.4605716),(33268,'metacarpal.tif',231,5,156,11.7440961,12.2216015,15.7311803,1.8,12.2563339,15.7562018,0.1026857,3.6380219,3.2529231,25.2402775,26.7996012,0.0205665,8.2386211,6.9379125,14.1975093,5.390273,6.4690533,2.087354,21.258734),(33269,'metacarpal.tif',231,5,157,12.0082258,12.2415411,15.7044244,1.8,12.2727762,15.7267945,0.7231833,3.2220622,3.5118825,25.6454456,27.8770316,0.8764914,7.937917,7.9593267,14.3237562,5.3525323,6.5040181,2.0684865,21.6996885),(33270,'metacarpal.tif',231,5,158,12.1730795,12.3591826,15.6375996,1.8,12.3810801,15.6834406,0.5728847,3.1733156,3.681492,25.814502,29.660798,0.5961306,8.056733,8.1348676,14.7638308,5.323426,6.6298304,2.7295709,23.1833639),(33271,'metacarpal.tif',231,5,159,12.6377046,12.4498934,15.5875183,1.8,12.4551558,15.6398797,0.670053,3.0501911,3.7535004,26.8330443,33.3701358,0.8123416,8.8904043,8.7971681,15.9845475,5.3115712,6.7856062,2.7105744,21.9278866),(33272,'metacarpal.tif',231,5,160,13.12585,12.5015463,15.587861,1.8,12.5283205,15.6010754,0.7193587,3.0544493,3.7727072,27.4113182,37.447842,0.9497698,9.9259869,8.974226,17.0250792,5.3373317,6.8836764,2.6954871,21.0324093),(33273,'metacarpal.tif',231,5,161,13.3125273,12.5122728,15.5491275,1.8,12.5484086,15.5604586,0.7799646,3.0385646,3.7123927,27.8252241,39.5438052,1.0973217,10.651838,9.1573581,17.7838828,5.3167233,6.8720467,2.730682,21.2933638),(33274,'metacarpal.tif',231,5,162,13.7536177,12.5415778,15.535617,1.8,12.5677711,15.5377966,0.8546887,2.9890631,3.6536992,28.5294731,41.4117947,1.3044595,11.3342102,9.5446207,18.1895175,5.2819249,6.8850001,2.6516353,21.3942827),(33275,'metacarpal.tif',231,5,163,14.6319833,12.5662559,15.4587448,1.8,12.5748598,15.4557071,0.9022719,2.9077065,3.5523214,29.9696022,44.02016,1.5017593,12.3919416,10.3069557,19.3268459,5.2609439,6.8850001,2.6516353,21.192445),(33276,'metacarpal.tif',231,5,164,15.6184031,12.5204044,15.3751088,1.8,12.5078851,15.3578852,1.0080093,2.8085629,3.296142,29.3562656,47.2434352,1.8620502,14.3329488,10.4524152,20.3870465,5.1965275,6.7633369,2.6571147,22.0988411),(33277,'metacarpal.tif',231,5,165,15.9017396,12.4910148,15.3682719,1.8,12.4473342,15.3327653,1.0566821,2.6270409,3.2020617,25.7766747,45.788657,2.009366,14.2997425,9.8120569,19.2444582,4.9975686,6.6493497,1.4691075,20.3933638),(33278,'metacarpal.tif',231,5,166,15.635317,12.3955689,15.2799946,1.8,12.3545243,15.2742759,1.0675091,2.3619196,3.1474825,20.765009,42.2999779,1.999703,13.4393051,8.7915817,17.6558353,4.6086804,6.560747,2.6718102,19.7479223),(33279,'metacarpal.tif',231,5,167,14.2325064,12.2204198,15.1925015,1.8,12.2086153,15.1783605,0.9706526,2.2170252,3.0004758,14.624742,35.765177,1.6154961,11.919835,6.5965609,15.008046,4.2229205,6.3245415,2.6365674,18.6814904),(33280,'metacarpal.tif',231,5,168,11.3215219,11.9085467,14.9126592,1.8,11.9824399,15.000002,0.9223068,2.0411908,3.0979066,8.8541464,24.3006133,1.1985797,7.8442048,4.3377359,10.3371823,3.8619331,6.0160474,2.5639631,18.5896171),(33281,'metacarpal.tif',231,5,169,7.7675425,11.3545359,14.287737,1.8,11.4617124,14.4911132,0.287766,3.290705,3.5810012,5.3739707,6.9422471,0.1042774,1.938633,1.6330758,3.1119447,3.0545544,4.0699509,2.826835,12.0648443),(33282,'metacarpal.tif',231,5,170,6.2580044,11.1326968,14.1360827,1.8,11.115189,14.1283593,-0.35716,1.4102472,1.7078389,2.7872962,4.0884874,0.1274866,2.3939538,1.9764593,3.7563813,2.7608605,3.5332882,3.026716,10.7348085),(33283,'metacarpal.tif',231,5,171,4.8358599,10.9432032,14.0276484,1.8,10.9341992,14.032475,-0.5460066,1.264693,1.6076432,1.5600671,2.5590023,0.2173318,1.5917726,1.233554,2.5602865,2.4282029,3.2224525,0.6267429,9.4574936),(33284,'metacarpal.tif',231,5,172,3.5692336,10.7492861,13.8938491,1.8,10.7559567,13.9067708,-0.6173613,1.0636293,1.4732294,0.7496235,1.5473305,0.1993468,1.0502984,0.7047789,1.5584282,2.0453974,2.8982236,0.6310794,8.1865748),(33285,'metacarpal.tif',231,5,173,2.2988409,10.559674,13.7634185,1.8,10.5950727,13.7770956,-0.6342042,0.8247664,1.2858887,0.2740114,0.7211413,0.1345204,0.5608116,0.3322291,0.7732828,1.6100822,2.4668046,0.669043,6.676539),(33286,'metacarpal.tif',231,5,174,0.9440986,10.3807773,13.6411439,1.8,10.4287189,13.6610528,-0.6205802,0.5891502,0.9515165,0.0481401,0.1429704,0.0532079,0.1502553,0.0817111,0.2008397,1.1273888,1.8273547,0.663203,4.7955845),(33287,'metacarpal.tif',231,5,175,0.0331243,10.195346,13.5401634,1.8,10.2015001,13.5400001,-0.715253,0.1774787,0.3102104,0.0002471,0.0008031,0.0023744,0.0025889,0.0013923,0.0033748,0.3818377,0.675,0.6435011,1.6591526),(33288,'metacarpal.tif',231,5,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33289,'metacarpal.tif',231,5,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33290,'metacarpal.tif',231,5,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33291,'metacarpal.tif',231,5,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33292,'metacarpal.tif',231,5,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33293,'metacarpal.tif',231,5,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33294,'metacarpal.tif',231,5,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33295,'metacarpal.tif',231,5,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33296,'metacarpal.tif',231,5,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33297,'metacarpal.tif',231,5,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33298,'metacarpal.tif',231,5,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33299,'metacarpal.tif',231,5,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33300,'metacarpal.tif',231,5,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33301,'metacarpal.tif',231,5,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33302,'metacarpal.tif',231,5,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33303,'metacarpal.tif',231,5,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33304,'metacarpal.tif',231,5,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33305,'metacarpal.tif',231,5,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33306,'metacarpal.tif',231,5,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33307,'metacarpal.tif',231,5,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33308,'metacarpal.tif',231,5,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33309,'metacarpal.tif',231,5,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33310,'metacarpal.tif',231,5,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33311,'metacarpal.tif',231,5,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33312,'metacarpal.tif',231,5,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33313,'metacarpal.tif',231,5,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33314,'femur.tif',231,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33315,'femur.tif',231,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33316,'femur.tif',231,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33317,'femur.tif',231,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33318,'femur.tif',231,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33319,'femur.tif',231,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33320,'femur.tif',231,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33321,'femur.tif',231,7,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33322,'femur.tif',231,7,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33323,'femur.tif',231,7,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33324,'femur.tif',231,7,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33325,'femur.tif',231,7,12,8.3903628,30.8136719,42.2223956,1.8,30.878187,42.2345939,-0.6873216,1.4893625,3.7824487,2.5080812,26.5893695,0.562925,7.029671,1.6839965,7.6893626,2.9658182,7.0925905,0.6327488,17.337606),(33326,'femur.tif',231,7,13,28.4586786,31.0318864,42.5313619,1.8,30.6949555,42.6703225,-0.4576129,3.1105793,6.074647,61.4126568,290.0636074,0.925828,47.7498708,19.7431572,55.4612305,5.8330337,12.0985591,0.331717,30.9260826),(33327,'femur.tif',231,7,14,36.1165347,30.3606436,43.2445113,1.8,30.1739603,43.1681352,-0.4545195,3.6288051,7.6023637,123.3058522,657.3534525,1.160231,86.4669834,33.9797391,100.780746,7.1329488,15.2482937,0.3665754,39.3072003),(33328,'femur.tif',231,7,15,41.9487201,29.8106607,44.0415871,1.8,29.8299766,43.7991755,-0.5697438,3.9899962,8.8411792,191.7257685,989.4510455,2.0343028,111.9139226,48.0516173,132.3738271,7.7511078,17.0697727,0.5570208,43.4977592),(33329,'femur.tif',231,7,16,45.7567361,29.7949537,44.3147189,1.8,29.6667256,44.1274522,-0.6112598,4.6816985,9.5007083,294.2462151,1152.9092845,2.5117453,121.3498242,62.8503123,152.0340717,8.8921104,18.4365125,0.5841785,46.1014386),(33330,'femur.tif',231,7,17,48.6361522,29.8155409,44.1387995,1.8,29.8352605,43.8627307,-0.6600988,5.5237071,9.3277225,467.5462442,1300.4331438,3.0479302,139.4159336,84.6435614,188.6226054,10.5424336,18.7944775,0.5636172,48.8848646),(33331,'femur.tif',231,7,18,51.7852684,29.7890826,43.3586641,1.8,29.8198106,42.827137,-0.8067201,6.527478,9.3818709,744.4363357,1474.9116627,4.4994104,157.2086925,114.0465487,228.3190879,12.6721323,18.8112309,0.9340519,53.2243304),(33332,'femur.tif',231,7,19,56.1620777,29.1857775,42.5843207,1.8,29.3009369,41.8531686,-1.0476685,7.5796856,10.4492816,1133.7805963,1558.9759995,7.0240759,149.1945631,149.5814808,255.6074418,15.0631426,19.7835565,1.089909,59.5357171),(33333,'femur.tif',231,7,20,61.458637,29.0962928,41.5205785,1.8,29.1069714,41.0631832,-1.2745416,8.6649102,10.5214562,1368.9578349,2124.966148,9.3700961,201.965023,157.9886923,323.600105,16.3811746,20.9155801,1.2106032,62.9870326),(33334,'femur.tif',231,7,21,63.1892431,29.7774758,40.8208777,1.8,29.519858,40.6534736,-1.3002185,8.7220646,11.2010152,1400.0800919,2691.5014572,9.7791356,240.2908505,160.5216383,365.0158896,17.1942905,22.3511791,1.3120254,68.0146449),(33335,'femur.tif',231,7,22,70.2930221,29.8988393,39.7164997,1.8,29.8821741,39.7202364,-1.3543716,8.6510969,12.5212731,1576.2299081,3652.2053811,11.1752679,291.6800349,182.2000057,416.7770165,17.0545034,24.3598037,1.3498637,74.5727487),(33336,'femur.tif',231,7,23,79.1896452,30.1838057,38.2166126,1.8,30.2956879,38.3978944,-1.3459631,8.8214464,14.2878272,1701.550999,5223.3676997,12.5422681,365.5816679,192.8879817,483.5169213,16.9964703,28.1795369,1.3433213,82.8230249),(33337,'femur.tif',231,7,24,111.4087158,30.6016537,33.0109727,1.8,30.7478099,34.6508763,-1.442824,9.7565716,19.8011896,2016.3233419,12713.0251304,18.2656873,642.0334023,206.6631015,743.806417,16.8934807,36.9563906,1.4605189,105.295728),(33338,'femur.tif',231,7,25,127.7271163,30.5611853,30.9094632,1.8,30.8863283,32.0723105,-1.4644135,10.6191779,22.3098182,2525.8538318,16514.0006068,21.047839,740.2122459,237.8577558,852.7801782,17.7943835,39.1461841,1.4569122,114.7372596),(33339,'femur.tif',231,7,26,131.8636899,30.4942403,30.4465582,1.8,30.999862,30.8027803,-1.4790234,11.0976038,22.9226957,2984.3345436,18227.2617997,21.7927023,795.1622296,268.9170192,923.1574115,18.7499495,40.3730136,1.4191044,119.56706),(33340,'femur.tif',231,7,27,134.1612219,30.3747315,30.2875837,1.8,30.8670753,30.073405,-1.4853963,11.5697118,23.3461466,3136.5964699,19886.6520383,22.197523,851.8173188,271.1041135,982.734019,19.4069698,41.504138,1.4232692,122.6408169),(33341,'femur.tif',231,7,28,136.0776528,30.2840147,30.4365176,1.8,30.8016694,29.7442883,-1.4877571,11.9197484,23.3121862,3268.6402615,21476.2107814,22.5235802,921.2439617,274.2205752,1057.8729408,19.9016894,42.1715458,1.4408339,126.0251619),(33342,'femur.tif',231,7,29,139.1991452,30.1696674,30.7746835,1.8,30.7027874,29.601983,-1.4908118,12.2058568,22.9396802,3326.7009294,22493.5025228,23.0517521,980.5499589,272.5495625,1122.6652956,20.2623737,42.2654834,1.4471873,129.5584138),(33343,'femur.tif',231,7,30,141.8063282,30.1250616,31.0550692,1.8,30.7874853,29.6538804,-1.4890829,12.3439754,22.3208787,3412.0882816,22937.9388347,23.4769302,1027.6449736,276.4172951,1175.1833353,20.3653306,41.8450604,1.4306175,134.0956916),(33344,'femur.tif',231,7,31,151.4546885,30.1007607,30.6125958,1.8,30.8300442,29.5856806,-1.485432,12.4264508,22.2898468,3355.8886456,24487.8641804,25.0589511,1098.6106988,270.0601091,1248.2017505,20.2287472,41.0141314,1.4683525,133.8159432),(33345,'femur.tif',231,7,32,148.1885953,30.3613117,31.4940717,1.8,30.8666585,31.2698974,-1.4319499,12.0681353,21.3596393,2900.6371484,22902.9767511,24.2250132,1072.2548444,240.3550412,1207.9976361,19.8182227,40.33238,1.4792805,145.8100575),(33346,'femur.tif',231,7,33,121.4870843,30.2950232,35.0343644,1.8,30.7221841,34.7542366,-1.3170392,10.9807542,21.2247018,2563.5405084,13119.0492802,18.9717807,618.1028797,233.4575989,730.1932092,16.7240648,32.8894454,1.3999298,112.7375987),(33347,'femur.tif',231,7,34,113.5739195,30.1415683,36.2511797,1.8,30.4065988,36.4472655,-1.2351671,10.1179915,16.2844141,2529.8518714,9618.5415948,16.875566,590.6593574,250.0349878,740.5875111,16.2575425,31.0087559,1.3685777,109.979721),(33348,'femur.tif',231,7,35,116.088204,30.1786675,36.8572742,1.8,30.3839518,37.0518486,-1.1639898,9.495509,15.541579,2642.8737944,9188.0575044,16.3188772,591.192022,278.3288183,756.0972714,16.0878224,29.5331854,1.3362557,107.2835227),(33349,'femur.tif',231,7,36,118.8150264,30.5945797,37.1550279,1.8,30.9634558,37.2162479,-1.0700659,8.8934368,15.1685559,2890.8216992,9096.2425882,15.2387454,599.6775596,325.0511309,771.9098445,16.441881,29.6415644,0.9161465,107.2473918),(33350,'femur.tif',231,7,37,123.3190575,30.9295043,37.3382135,1.8,31.2671445,37.3694608,-0.9994098,8.5471859,15.1946701,3079.4192416,9354.0107494,14.5421255,615.6113093,360.2845772,767.9414538,16.3989758,30.3108875,0.9012944,105.1957262),(33351,'femur.tif',231,7,38,129.6098312,31.1561354,37.5291672,1.8,31.6427721,37.4226305,-0.954103,8.4167381,15.9754412,3158.9250417,9570.2405607,14.3763645,599.0595471,375.3146427,766.478361,16.2261207,30.6329482,0.8558695,103.8066588),(33352,'femur.tif',231,7,39,137.5095835,31.0391798,38.215744,1.8,31.6375223,37.9682088,-0.9758462,8.2240988,16.2351925,3257.6133543,8819.4584493,15.7190935,543.2309124,396.1058125,712.734233,16.0315302,30.2107927,0.8151513,88.3154235),(33353,'femur.tif',231,7,40,134.7248663,30.8752448,38.3060233,1.8,31.514432,38.0134861,-0.970161,8.0265637,16.5555777,3165.3307391,7886.3726957,15.2819895,476.3574438,394.3568932,649.6276027,15.9744284,29.8078655,0.8487574,82.0987474),(33354,'femur.tif',231,7,41,127.4148713,30.6273985,38.058146,1.8,31.4018167,37.742695,-0.9194567,8.4097174,16.7186828,2993.3600533,7516.3416706,13.4307608,449.5773842,355.9406229,620.2126718,15.9705769,29.5039068,0.8738518,79.6875887),(33355,'femur.tif',231,7,42,121.0203558,30.4241685,38.0900868,1.8,31.194175,37.7563373,-0.888222,8.5281687,15.9571601,2799.531247,6735.6808923,12.1444043,422.1102523,328.2687455,589.8975676,15.9034661,28.0407511,0.8656115,76.3776972),(33356,'femur.tif',231,7,43,116.7026467,30.1618631,38.1632277,1.8,30.9444945,37.8501784,-0.8665841,8.5814465,15.9978542,2643.8353534,6008.9642127,11.2973928,375.6106385,308.0873783,537.8402457,15.8981533,27.3395046,0.8742723,74.4493901),(33357,'femur.tif',231,7,44,115.4222741,30.03701,38.2547156,1.8,30.7024789,38.0365329,-0.8275759,8.5230774,15.2123556,2543.3943118,5632.2129014,10.4289354,370.239367,298.4126719,535.643256,15.8124126,26.1977139,0.8437511,71.7531918),(33358,'femur.tif',231,7,45,115.3207447,29.7975845,38.3815085,1.8,30.3851008,38.1738987,-0.8260937,8.4292491,14.2269919,2459.9896905,5155.7259091,10.3913726,362.3904436,291.8397191,533.3168905,15.710906,24.8466704,0.8433044,68.3996864),(33359,'femur.tif',231,7,46,113.3526656,29.4020076,38.4940847,1.8,29.8209715,38.3924502,-0.8371499,8.3520958,12.4966718,2379.9060324,4476.2478256,10.4220103,358.195197,284.9471654,545.8695435,15.5579247,22.7523218,0.8209563,63.8624087),(33360,'femur.tif',231,7,47,112.5229637,29.0626227,38.6176736,1.8,29.3391108,38.6042651,-0.8450943,8.161775,11.485781,2302.5888209,3959.4408652,10.4937866,344.7254353,282.1186355,542.8935601,15.3582838,21.3966364,0.8106029,60.4780637),(33361,'femur.tif',231,7,48,112.2565843,28.6808044,38.7748873,1.8,28.8964522,38.7953859,-0.8219506,8.0760407,10.6280854,2211.6269708,3582.3270032,10.0379819,337.0623083,273.8504006,543.0858301,15.1790913,20.1388351,0.7586189,58.3391704),(33362,'femur.tif',231,7,49,110.1268137,28.3828912,38.8235275,1.8,28.5384272,38.8291323,-0.7902415,7.9274924,10.077318,2123.7824679,3326.2340147,9.2661297,330.0713548,267.9009154,538.046405,14.9189643,19.358045,0.7250066,56.8139703),(33363,'femur.tif',231,7,50,110.1767679,28.0971793,38.8387022,1.8,28.2435508,38.8597086,-0.7610762,7.8697923,9.7830512,2045.6138332,3160.7034147,8.7349537,323.079514,259.9323784,528.5823131,14.7848686,18.8870786,0.6421552,55.8716237),(33364,'femur.tif',231,7,51,111.130459,27.8856361,38.7257519,1.8,27.9917757,38.7630195,-0.7395323,7.7738388,9.5626597,1972.7953354,3075.400204,8.4125469,321.6051092,253.7736372,527.9070304,14.5594712,18.5566014,0.7175413,54.7931444),(33365,'femur.tif',231,7,52,110.5557548,27.6604821,38.6930419,1.8,27.7470053,38.7220852,-0.710317,7.7082602,9.141376,1897.4819895,2940.0789422,7.8347304,321.6232387,246.1621605,527.4255411,14.4364801,18.0553606,0.6153395,53.8507977),(33366,'femur.tif',231,7,53,110.4591824,27.4110202,38.6789442,1.8,27.4699513,38.7367231,-0.6686313,7.6391191,8.8948862,1825.7516156,2826.3693223,7.074756,317.7521638,239.0002825,522.1755319,14.2729536,17.6710156,0.6219217,53.1626512),(33367,'femur.tif',231,7,54,109.5061731,27.182594,38.649901,1.8,27.2229521,38.7288142,-0.6563162,7.5489648,8.6839321,1766.170202,2713.2899036,6.7957185,312.4494604,233.9619069,515.0744212,14.1062494,17.3625313,0.6347166,52.3692115),(33368,'femur.tif',231,7,55,109.1133634,27.0310037,38.639925,1.8,27.0573807,38.7227742,-0.6268968,7.3958892,8.5005646,1723.7573861,2634.6347167,6.2583787,309.93644,233.0696609,512.5527711,13.9576741,17.1340053,0.6538865,51.8608114),(33369,'femur.tif',231,7,56,108.8661484,26.8634492,38.6310758,1.8,26.8900493,38.693988,-0.6022026,7.2856237,8.4007189,1692.3883203,2556.9105712,5.8220855,304.3680676,232.2914818,504.6043315,13.8590312,16.922926,0.5713375,51.3215717),(33370,'femur.tif',231,7,57,108.2135314,26.6737578,38.6518493,1.8,26.7098358,38.7073196,-0.5906005,7.1902957,8.2989095,1666.7513344,2477.3648631,5.5927094,298.5169136,231.805672,496.3921952,13.7489593,16.7198119,0.552153,50.8131717),(33371,'femur.tif',231,7,58,107.2007201,26.4728707,38.6609305,1.8,26.5180408,38.7113649,-0.5816805,7.0476014,8.2300108,1629.8806478,2410.1342402,5.393484,292.847034,231.2674294,489.5458232,13.6434257,16.5493779,0.6327488,50.5153579),(33372,'femur.tif',231,7,59,106.6947275,26.2697952,38.6949143,1.8,26.3306575,38.7388715,-0.5838015,6.9226764,8.1501957,1601.5872352,2366.144377,5.4026872,290.3174932,231.3537636,485.5424347,13.5046436,16.4214984,0.648145,50.2611578),(33373,'femur.tif',231,7,60,106.4119786,26.084329,38.7521439,1.8,26.16821,38.7728028,-0.5697994,6.8083183,8.0731963,1581.2388258,2315.544944,5.1613439,286.8188579,232.2510129,480.6589395,13.3986567,16.2767431,0.6747409,49.9016647),(33374,'femur.tif',231,7,61,106.5393824,25.8790777,38.7638353,1.8,25.9238815,38.7924352,-0.5572053,6.7372475,8.0288009,1550.4895823,2287.9225783,4.9655647,284.9644169,230.1369492,476.1478103,13.308672,16.2130997,0.71883,49.7219182),(33375,'femur.tif',231,7,62,106.2726889,25.7048781,38.7728467,1.8,25.7534113,38.8021536,-0.5403149,6.6480263,8.0208091,1526.8412433,2263.7706914,4.6868668,282.2371977,229.6683506,471.0396641,13.210065,16.1751929,0.5269432,49.4677181),(33376,'femur.tif',231,7,63,106.3132081,25.527283,38.7680604,1.8,25.5747547,38.7859267,-0.528414,6.5948559,7.9778343,1511.7072186,2228.2353655,4.5038107,279.3032898,229.225209,463.8388504,13.1584471,16.0870659,0.5485494,49.2879716),(33377,'femur.tif',231,7,64,106.6977542,25.3472986,38.7618303,1.8,25.3840429,38.7810438,-0.5259402,6.5636951,7.9287808,1504.0253652,2214.0366016,4.4818469,279.2404867,229.143087,463.7081758,13.132879,16.0392961,0.5880026,49.2879716),(33378,'femur.tif',231,7,65,107.3995996,25.1806116,38.766025,1.8,25.2260524,38.7947775,-0.5134717,6.5350114,7.9063953,1499.7245426,2203.1482901,4.3189247,278.653952,229.4907304,461.2022004,13.076937,15.9726841,0.6100741,49.108225),(33379,'femur.tif',231,7,66,107.1975959,24.9832437,38.7696552,1.8,25.0264272,38.7987423,-0.5025263,6.5046606,7.8730276,1493.3376359,2177.6211239,4.144582,276.5925928,229.5796381,457.8917621,13.076937,15.9123933,0.5458989,49.0773854),(33380,'femur.tif',231,7,67,107.1821063,24.8133436,38.7602656,1.8,24.8720181,38.7881817,-0.4894038,6.5255942,7.840345,1497.4391473,2157.2693438,3.9477624,275.1497965,229.4716939,455.217173,13.1326808,15.8707152,0.5569015,48.8976388),(33381,'femur.tif',231,7,68,107.2690556,24.6656883,38.7702815,1.8,24.7350572,38.7847805,-0.4612992,6.4894085,7.8491758,1502.6561672,2151.7760988,3.5421068,274.1403866,231.5551831,454.0900343,13.1330034,15.8707152,0.5569015,48.7923457),(33382,'femur.tif',231,7,69,107.6552479,24.5570326,38.7784405,1.8,24.6157293,38.7898308,-0.4339765,6.5736617,7.9111548,1510.4996467,2158.9806332,3.172333,272.9033482,229.7805578,457.6459451,13.1893925,15.8880096,0.4027909,48.9720923),(33383,'femur.tif',231,7,70,106.9004959,24.4238689,38.7660822,1.8,24.4945485,38.785989,-0.4190883,6.6035289,7.9167428,1520.2065795,2152.850701,2.9502798,271.9364224,230.2112388,451.3166051,13.2440089,15.9605429,0.2990844,49.0773854),(33384,'femur.tif',231,7,71,105.4245537,24.2836305,38.7549879,1.8,24.3609221,38.7685335,-0.3943096,6.6417645,7.9007599,1530.7374208,2142.6468225,2.5932203,271.1950291,230.4714991,447.5122904,13.2454589,16.0095568,0.2815712,49.2262923),(33385,'femur.tif',231,7,72,105.0917882,24.1876717,38.7577683,1.8,24.2686245,38.760246,-0.3522481,6.7356811,8.0028915,1542.0822003,2176.8380689,2.0848641,272.0064466,228.9422823,442.8330041,13.3015253,16.1316903,0.2793819,49.6602389),(33386,'femur.tif',231,7,73,105.7831164,24.1564585,38.7841403,1.8,24.2460333,38.7809983,-0.2977172,6.8700828,8.129763,1559.443834,2249.9195392,1.5170624,276.7509369,226.9905456,438.4360346,13.3024933,16.3954086,3.0172377,50.0941855),(33387,'femur.tif',231,7,74,106.823336,24.1327057,38.7804922,1.8,24.2062161,38.7764467,-0.2720102,6.9084581,8.3647367,1562.4775905,2336.2213345,1.2851317,279.2940678,226.1687879,442.1323017,13.3592051,16.8007753,0.0529807,50.5153579),(33388,'femur.tif',231,7,75,108.1408453,24.1580056,38.7498693,1.8,24.2389138,38.7509108,-0.2561619,6.9544956,8.599877,1569.8740675,2428.7364783,1.1570377,282.4152576,225.7351442,452.4698134,13.4159168,17.0261837,0.1197254,50.874851),(33389,'femur.tif',231,7,76,107.497219,24.0725539,38.7660701,1.8,24.1801815,38.7288239,-0.2280452,7.0137856,8.7611164,1568.3134751,2442.0695267,0.9156853,278.7395353,223.6044226,446.7381672,13.4723059,17.1965891,0.0665682,51.129051),(33390,'femur.tif',231,7,77,107.9570305,24.071268,38.7551648,1.8,24.1345637,38.7470959,-0.2248609,7.0316196,8.7359498,1563.2104177,2504.202223,0.8945309,286.6548308,222.3115731,458.9294143,13.5194367,17.237873,0.0960003,51.129051),(33391,'femur.tif',231,7,78,107.233093,23.9580151,38.7911872,1.8,23.9953321,38.7876156,-0.212777,7.0423168,8.6768024,1546.265704,2484.1431732,0.7970085,286.2970794,219.5677579,460.6469509,13.4719832,17.1340053,0.1639292,51.0237579),(33392,'femur.tif',231,7,79,106.1342686,23.8055098,38.8039041,1.8,23.8485069,38.7948375,-0.2051927,7.0495884,8.7121172,1526.9854786,2458.5800501,0.7343862,282.2023602,216.6063299,454.5190269,13.4726286,17.1137225,0.1566019,50.7695579),(33393,'femur.tif',231,7,80,105.0288635,23.650741,38.8219888,1.8,23.6990318,38.8133386,-0.194376,7.0615812,8.6283045,1512.8778945,2416.9733002,0.6530801,280.1214653,214.2406709,453.1951424,13.4723059,16.9505865,0.1885723,50.6642648),(33394,'femur.tif',231,7,81,103.0976244,23.4472219,38.8427422,1.8,23.4888002,38.8247967,-0.1975671,7.0171436,8.3306277,1494.2301877,2312.5340058,0.6620162,277.5942077,212.9399472,444.8487868,13.4726286,16.6185389,0.1072789,50.2303182),(33395,'femur.tif',231,7,82,101.2770268,23.2934391,38.8134583,1.8,23.3221936,38.8047146,-0.2106135,6.9337664,8.1087305,1474.1572503,2215.9281257,0.7377363,273.276824,212.6055556,443.6386289,13.4162395,16.3287654,3.0558658,49.8091458),(33396,'femur.tif',231,7,83,98.3994404,23.0928663,38.7969127,1.8,23.143495,38.7949681,-0.2320635,6.8987913,7.931466,1456.0013254,2109.6419525,0.867451,265.98386,211.0516563,433.0019945,13.4726286,16.0699856,2.9907473,49.4188131),(33397,'femur.tif',231,7,84,97.4519808,22.8798215,38.8029826,1.8,22.9387602,38.807282,-0.2451026,6.8185023,7.7918189,1448.1632768,2045.7107777,0.9563591,262.5459866,212.3872969,424.5662984,13.4723059,15.8813993,2.9237918,49.2082269),(33398,'femur.tif',231,7,85,96.2252844,22.7432344,38.8633813,1.8,22.7903124,38.8525478,-0.2367088,6.8461149,7.7064704,1441.0187541,1991.299189,0.8819426,258.393154,210.487083,421.6724681,13.4960739,15.721403,2.896614,49.0284803),(33399,'femur.tif',231,7,86,94.7060363,22.6383794,38.9248838,1.8,22.6965719,38.9133793,-0.2333523,6.8236263,7.6489684,1442.3587588,1934.3752727,0.8440211,252.8936144,211.3771625,416.998309,13.5066199,15.6436311,2.8532487,48.9976407),(33400,'femur.tif',231,7,87,95.6887806,22.5271424,38.9673104,1.8,22.5737469,38.9487469,-0.2143812,6.8348132,7.6224916,1460.3461257,1913.2866482,0.7218047,251.0054129,213.6629166,419.6351451,13.5458397,15.5311844,2.7732437,48.7870545),(33401,'femur.tif',231,7,88,96.8890706,22.4717648,39.0188817,1.8,22.4956003,38.9937495,-0.1942337,6.8759142,7.6259176,1476.1371517,1903.4904559,0.601595,249.6080545,214.6823123,423.2031787,13.5458397,15.5067221,2.7549981,48.6073079),(33402,'femur.tif',231,7,89,95.9154886,22.4171919,39.0691008,1.8,22.4309694,39.0407096,-0.1792626,6.9120704,7.5863022,1480.3391929,1863.3978068,0.5082292,245.6266236,214.1672619,423.3095983,13.5861691,15.4215843,2.7258788,48.6817614),(33403,'femur.tif',231,7,90,95.5634522,22.3253411,39.1137701,1.8,22.3329705,39.0932624,-0.154862,6.8753321,7.5469636,1484.4085114,1840.9552184,0.3789274,243.9332323,215.903536,421.0025156,13.6255447,15.4048148,2.6890147,48.5020148),(33404,'femur.tif',231,7,91,96.072178,22.2657885,39.1601008,1.8,22.2683609,39.1353024,-0.1309955,6.8872307,7.5458172,1499.0616225,1836.4856393,0.2731954,243.3779652,217.6581113,426.2879623,13.6372087,15.3706956,2.6224465,48.5020148),(33405,'femur.tif',231,7,92,96.6375411,22.1781578,39.2114808,1.8,22.1729551,39.1822966,-0.1179954,6.9386965,7.5248717,1520.6727749,1831.3726355,0.2232072,243.3759286,219.1582778,430.754605,13.7132277,15.3243824,2.6111302,48.3967217),(33406,'femur.tif',231,7,93,97.5984908,22.0588116,39.2498353,1.8,22.0706845,39.2207412,-0.0843031,7.0207667,7.4196847,1541.5050449,1836.1582384,0.1153321,247.4711965,219.5636318,435.5198435,13.8690822,15.2376957,2.5882983,48.5456287),(33407,'femur.tif',231,7,94,96.6313896,21.9857788,39.2959645,1.8,22.0011543,39.2567199,-0.0714728,7.0667948,7.4305759,1542.956382,1822.9759756,0.0821313,245.3344118,218.3389241,436.5163703,13.8713911,15.2286817,2.5582196,48.5020148),(33408,'femur.tif',231,7,95,95.2369619,21.9200804,39.3835642,1.8,21.9228195,39.3434613,-0.0671682,7.1381406,7.3735872,1531.6135268,1804.4606958,0.0715036,244.7195166,214.5675765,438.0425568,13.932969,15.1505131,2.493058,48.5020148),(33409,'femur.tif',231,7,96,94.8746255,21.8673283,39.4381003,1.8,21.8844154,39.3916538,-0.0843178,7.1601071,7.3503926,1544.7018808,1788.8862005,0.1121524,243.3728775,215.737258,437.4289642,13.9790749,15.1350444,0.5087298,48.6073079),(33410,'femur.tif',231,7,97,94.5679688,21.7839817,39.4844405,1.8,21.7899626,39.4255585,-0.1327249,7.1525488,7.4044012,1567.1794838,1779.5641087,0.2760233,240.3386939,219.1078337,435.6831578,14.0772823,15.1606392,0.6066051,48.6073079),(33411,'femur.tif',231,7,98,94.5899305,21.7027569,39.5153283,1.8,21.7109507,39.4535803,-0.1874629,7.1274456,7.4446687,1598.8314823,1783.6929702,0.5475593,239.5933317,224.3204041,437.7475933,14.2297887,15.2037327,0.6251085,48.8923476),(33412,'femur.tif',231,7,99,94.3045686,21.645657,39.5284498,1.8,21.6525393,39.4664201,-0.2482097,7.1658747,7.4989,1621.9374489,1794.2589561,0.9485972,239.2696198,226.341867,439.6972282,14.268969,15.2800433,0.541846,49.1029338),(33413,'femur.tif',231,7,100,94.6342719,21.5767459,39.5394577,1.8,21.5766468,39.4774406,-0.3461609,7.2623501,7.5353694,1654.7264488,1808.8286319,1.8156684,240.0451186,227.8499959,442.3958793,14.3954278,15.3459775,0.548942,49.2826803),(33414,'femur.tif',231,7,101,95.0623896,21.5135305,39.5393617,1.8,21.5203787,39.4741867,-0.5510212,7.3792356,7.7454882,1691.9630973,1821.4848385,4.3429645,235.1672082,229.2870426,445.4350139,14.5107062,15.3727974,0.5673633,49.0720942),(33415,'femur.tif',231,7,102,95.1575073,21.4472112,39.5562536,1.8,21.4348311,39.4800126,-0.7592136,7.3932361,7.8711504,1711.0245479,1848.0818689,7.5147059,234.7918375,231.431071,447.4243386,14.6517313,15.4440895,0.6863085,49.4315873),(33416,'femur.tif',231,7,103,95.146416,21.3484051,39.5669873,1.8,21.3363586,39.4915981,-0.9205759,7.5245773,7.9871596,1718.276506,1885.6479909,10.046463,236.084927,228.3552203,449.7202457,14.6165011,15.5426216,0.6811266,49.5060407),(33417,'femur.tif',231,7,104,94.9296696,21.2923647,39.578341,1.8,21.2844536,39.5041216,-1.006553,7.6194959,8.0778848,1721.9855083,1926.4587608,11.2968527,238.4855446,225.9972997,451.639752,14.7436012,15.6802474,1.2746812,49.7910804),(33418,'femur.tif',231,7,105,95.210237,21.2191062,39.5850542,1.8,21.2068636,39.515474,-1.0530987,7.6398563,8.1553568,1728.8496935,1990.7763547,11.9820981,244.1065918,226.2934847,455.709195,14.6165011,15.8630793,0.9160777,50.0144408),(33419,'femur.tif',231,7,106,95.8733761,21.1223864,39.5696029,1.8,21.124291,39.5006825,-1.087887,7.6427038,8.2235061,1743.6153586,2055.9995946,12.5333967,250.014965,228.1411669,461.0472717,14.7354661,16.0211567,1.0290163,50.479227),(33420,'femur.tif',231,7,107,97.1325013,21.03221,39.5763251,1.8,21.0435474,39.5150698,-1.1076246,7.7113658,8.257805,1778.411092,2123.3591132,12.9571616,257.1335976,230.6220625,470.4127007,14.7436012,16.1956536,1.0263392,50.8078805),(33421,'femur.tif',231,7,108,97.7076213,20.9312454,39.5743879,1.8,20.9469171,39.5205531,-1.1175822,7.8032919,8.3007136,1800.3077008,2187.8354136,13.162534,263.5719677,230.7113096,475.861285,14.8565732,16.4003344,0.9505468,51.2726667),(33422,'femur.tif',231,7,109,98.3580358,20.8228346,39.5882597,1.8,20.8227629,39.5302619,-1.1390894,7.841715,8.4077441,1815.5273811,2263.5835701,13.5229716,269.226032,231.5217232,482.4000395,14.8699411,16.6170808,1.2030733,51.7066132),(33423,'femur.tif',231,7,110,98.2293674,20.7271695,39.6296416,1.8,20.7181059,39.581775,-1.1594636,7.9480078,8.5230456,1835.827823,2330.3441264,13.7543211,273.416833,230.9796206,485.3954766,14.8707012,16.8808719,1.2490458,51.9299736),(33424,'femur.tif',231,7,111,98.7560055,20.6487541,39.6832983,1.8,20.6365661,39.6344013,-1.168029,8.0448454,8.6626851,1868.3528109,2412.8378365,13.9305697,278.5323277,232.2422272,491.3212716,14.9913141,17.128819,1.2772073,52.5436668),(33425,'femur.tif',231,7,112,99.2002339,20.5956889,39.689539,1.8,20.5908298,39.6631716,-1.1689852,8.1404226,8.7732414,1909.9022091,2503.4580152,14.0046233,285.3515468,234.6195411,500.8860762,15.0743601,17.407134,1.2282635,53.0520668),(33426,'femur.tif',231,7,113,99.1621822,20.5633125,39.7210026,1.8,20.5614351,39.7064387,-1.1592583,8.229059,8.9350804,1959.2587847,2586.6136229,13.8824487,289.4896851,238.090258,507.1462552,15.2097645,17.7326151,1.2195758,53.7402134),(33427,'femur.tif',231,7,114,99.3534786,20.557698,39.7422228,1.8,20.5610879,39.7208739,-1.1474303,8.2927831,9.1161876,2006.4788405,2689.033283,13.764056,294.973448,241.9548203,513.6817696,15.3465226,18.0593863,1.2112019,54.3539065),(33428,'femur.tif',231,7,115,98.2938014,20.5844781,39.7514744,1.8,20.571895,39.7432644,-1.1241094,8.3786669,9.242251,2029.3232234,2799.5245103,13.3252546,302.9050518,242.2012063,521.3347491,15.5037325,18.4334455,1.1966919,55.2217997),(33429,'femur.tif',231,7,116,98.5202112,20.5590697,39.7450426,1.8,20.5495006,39.7517773,-1.1264463,8.5140297,9.4113716,2060.2360929,2932.651214,13.3857908,311.6072055,241.9813149,529.6614227,15.6356685,18.7918987,1.1676807,56.1205325),(33430,'femur.tif',231,7,117,98.0195298,20.5647003,39.7501772,1.8,20.5330394,39.7922778,-1.134209,8.621134,9.579644,2096.1317563,3040.8646402,13.415581,317.4298154,243.1387512,535.0266983,15.7995116,19.1857875,1.0508285,56.9139722),(33431,'femur.tif',231,7,118,97.8957385,20.5118622,39.8430428,1.8,20.4932604,39.8269433,-1.1281865,8.7987213,9.8096614,2136.9337642,3165.3837285,13.3229529,322.6802229,242.8686721,539.0778433,16.0327787,19.5329188,1.0460006,57.7818653),(33432,'femur.tif',231,7,119,98.8113871,20.563059,39.9180722,1.8,20.5025762,39.8927409,-1.1040956,8.8886858,10.0251128,2225.49828,3320.3197287,13.1345352,331.2002376,250.3742774,552.7794123,16.2499456,19.9125602,1.0643178,58.829505),(33433,'femur.tif',231,7,120,99.3944986,20.5646343,39.9708246,1.8,20.4866946,39.983086,-1.0796445,9.0846727,10.1972594,2307.4616574,3471.053153,12.8807644,340.3907881,253.9950235,566.357954,16.536328,20.2504262,1.022842,60.1621844),(33434,'femur.tif',231,7,121,101.7150762,20.5583109,39.9947048,1.8,20.3826525,40.0722222,-1.0641001,9.2576399,10.385846,2420.6811335,3691.0114352,12.9600676,355.3886156,261.4792937,588.4542078,16.8250581,20.6427007,1.076855,61.3895707),(33435,'femur.tif',231,7,122,103.1680286,20.5602118,40.0054837,1.8,20.3543955,40.0231894,-1.0493946,9.4842718,10.4860652,2532.7010245,3893.3471848,12.9286784,371.2877142,267.0422242,611.1620041,17.1583396,20.9872869,1.0719329,62.9019966),(33436,'femur.tif',231,7,123,105.0398274,20.4941184,39.9572711,1.8,20.2523082,39.9715409,-1.0211763,9.8657761,10.6097172,2640.9088309,4160.3548447,12.729717,392.1268361,267.6838391,638.0944654,17.5675181,21.392106,1.2189796,64.5324898),(33437,'femur.tif',231,7,124,106.5878246,20.5605863,39.9687088,1.8,20.1998612,39.9806812,-1.0163738,10.1008884,10.8077225,2764.3657954,4461.9931005,12.8411299,412.8523014,273.6755106,666.7264407,18.0354268,21.8275534,1.2324727,66.360795),(33438,'femur.tif',231,7,125,109.9877297,20.7025147,40.0184279,1.8,20.2430084,40.0570009,-1.0223642,10.3310418,11.0637436,2956.0335942,4800.8515574,13.3487384,433.9265006,286.1312196,700.0268982,18.4961938,22.3077717,1.240037,68.1582606),(33439,'femur.tif',231,7,126,112.4320512,20.8558953,40.0464477,1.8,20.325001,40.0834713,-1.0330145,10.5578643,11.3323375,3166.6359927,5225.2617535,13.8219873,461.0930245,299.9314934,737.3978184,19.0402871,22.8755303,1.2718889,70.2227004),(33440,'femur.tif',231,7,127,117.158457,20.9775431,40.1067599,1.8,20.4358158,40.1250602,-1.0553396,10.8080343,11.6948898,3510.8518404,5724.6686902,14.7818389,489.5017206,324.8372235,784.5883278,19.6085974,23.4890997,1.2113923,73.0061264),(33441,'femur.tif',231,7,128,122.028148,21.3414429,40.3135357,1.8,20.7695509,40.223087,-1.0543995,10.9716113,12.6057826,3829.4272808,6419.1304097,15.3798356,509.2210923,349.0305274,813.0036971,20.3339806,24.4828405,1.0490746,76.3160179),(33442,'femur.tif',231,7,129,133.5353473,21.8009835,40.8019669,1.8,21.267558,40.5417869,-1.1532872,11.074518,13.7565013,4494.7003329,7695.0927153,18.5966242,559.3786203,405.8596818,872.5362649,21.2064601,25.9075218,0.8791987,82.4965631),(33443,'femur.tif',231,7,130,142.786216,22.56825,41.0187396,1.8,21.9830471,40.7876398,-1.1993976,11.1672199,14.2499469,5394.1261599,8961.5856029,20.6633004,628.8855447,483.0321446,994.8741271,22.2839932,26.7722829,0.7081113,82.9560581),(33444,'femur.tif',231,7,131,152.906051,23.5640861,40.4739213,1.8,22.8953526,40.5885161,-1.0866782,12.0214389,15.1429883,6473.7034556,10529.0932654,19.9638407,695.3114566,538.5131934,1061.7263961,23.6407137,29.9786329,0.6197566,93.7791741),(33445,'femur.tif',231,7,132,174.3880901,25.9611757,40.0288243,1.8,25.1162813,40.2549317,-0.7507521,14.2609579,17.0805192,8340.9248979,14518.159422,13.5261695,849.9834972,584.8783069,1314.6246656,26.1963063,34.1056956,0.4553145,113.1217323),(33446,'femur.tif',231,7,133,203.0002056,28.4178793,40.0430717,1.8,27.2146417,40.3836877,-0.5507052,15.0601212,18.6818914,11366.6816011,18783.3390167,9.2646121,1005.4302651,754.7536617,1572.7235391,26.9254409,36.3881357,0.4870808,117.8281742),(33447,'femur.tif',231,7,134,221.5641934,29.4144262,40.7262447,1.8,27.9940561,40.9842268,-0.4570804,18.9723596,19.6007841,14432.9109316,20229.4851094,7.1924256,1032.0752985,760.7335732,1739.6161637,27.9148921,37.4123364,0.4879589,119.9106794),(33448,'femur.tif',231,7,135,244.7975295,29.9730061,41.7766401,1.8,28.6302175,41.9367025,-0.5676244,19.2279351,19.0637807,19832.2129042,21711.9029408,11.7929789,1138.9085561,1031.427075,2053.9700291,31.4807822,37.876656,0.4966686,128.843811),(33449,'femur.tif',231,7,136,252.262503,29.8993243,41.9616373,1.8,28.769984,42.2615761,-0.5047236,19.5973501,19.2754184,19298.4281885,21576.2078759,9.8313265,1119.3639204,984.7468197,2041.9039249,31.9913812,38.1615531,2.2689461,131.0007697),(33450,'femur.tif',231,7,137,241.5162086,29.4871907,41.9972284,1.8,28.455392,42.255846,-0.4632083,19.7886251,19.0191923,19355.9823077,21257.9548386,8.0363992,1117.7107074,978.1367931,2047.7222971,32.0629251,38.3572584,2.2952372,131.2060646),(33451,'femur.tif',231,7,138,227.6912295,29.3768434,41.9233684,1.8,28.4427915,42.1529282,-0.186675,18.6762885,19.2353451,18171.4542767,19283.063423,1.3071248,1002.4807636,972.9692405,1902.0083154,31.7242968,38.1056344,2.2877437,130.8157319),(33452,'femur.tif',231,7,139,216.3075684,28.9226137,42.0570609,1.8,28.1223164,41.9457225,0.542562,18.7504674,17.8486288,16481.9409515,17557.7351713,9.61121,983.7021876,879.0149375,1751.797477,31.0242326,37.5597196,2.2603353,129.5936368),(33453,'femur.tif',231,7,140,202.7621111,28.6086711,42.0244716,1.8,27.7656403,41.6920361,0.3995913,17.7466646,16.4169232,14266.3647532,15416.6032953,5.1147937,939.0677591,803.8899199,1568.3112262,29.9111945,36.5858212,2.2330583,127.529197),(33454,'femur.tif',231,7,141,191.7162674,28.2604631,41.7925066,1.8,27.3580058,41.5289685,0.4859179,17.2733459,16.1792039,12106.4294852,13058.9398139,6.9691378,807.143536,700.8734471,1389.2572058,28.4216789,35.0586434,2.2302497,120.7838638),(33455,'femur.tif',231,7,142,178.1632077,27.6581719,41.2757672,1.8,26.9942326,41.0434569,-1.1233662,14.4106747,15.9012806,9740.9064937,10137.59264,24.1355904,637.5330966,675.9507602,1205.7969677,25.6329486,32.0496228,2.1785983,111.2498133),(33456,'femur.tif',231,7,143,158.3508193,27.0462904,40.3960668,1.8,26.5986106,40.1976627,-1.0631424,13.0921356,14.562281,6335.3751298,8253.9135679,20.154871,566.8008717,483.9069283,968.7497252,22.7809871,29.4469082,0.6167372,101.0509729),(33457,'femur.tif',231,7,144,131.5007337,26.6029449,39.9579005,1.8,26.4083129,39.8210226,-1.2163921,10.6892139,12.6114619,3578.9649599,6035.0676956,19.2773285,478.5383142,334.8202201,706.439455,19.5459645,26.5988468,0.6702634,91.9636431),(33458,'femur.tif',231,7,145,82.4491671,26.5982503,39.3800125,1.8,26.4798953,39.202081,-1.3320066,8.2473406,11.5240214,1415.0642353,4099.040628,12.9727584,355.6953321,171.5782454,472.2404383,0,0,0,0),(33459,'femur.tif',231,7,146,22.3411794,26.7784424,34.6917318,1.8,26.7345619,35.6062031,-1.397017,5.4977428,13.9591941,119.0862673,520.2275926,3.6122094,37.2677382,21.6609381,45.7978123,4.4647016,10.3950404,2.9322073,25.441167),(33460,'femur.tif',231,7,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33461,'femur.tif',231,7,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33462,'femur.tif',231,7,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33463,'femur.tif',231,7,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33464,'femur.tif',231,7,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33465,'femur.tif',231,7,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33466,'femur.tif',231,7,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33467,'femur.tif',231,7,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33468,'femur.tif',231,7,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33469,'femur.tif',231,7,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33470,'femur.tif',231,7,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33471,'tibia.tif',231,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33472,'tibia.tif',231,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33473,'tibia.tif',231,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33474,'tibia.tif',231,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33475,'tibia.tif',231,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33476,'tibia.tif',231,8,6,22.518133,28.3624256,44.9897485,1.8,28.7098619,44.5410644,-0.1626304,4.2863945,4.0741543,58.7940091,71.8802514,0.0983903,17.6429871,13.7164252,27.1126654,7.5208052,8.3548319,2.9113731,26.0601513),(33477,'tibia.tif',231,8,7,69.7715704,28.5565743,45.6406657,1.8,28.8232755,45.0088352,-1.1073627,6.625354,7.9300239,650.0502229,876.6263596,9.3048667,110.545235,98.1155452,188.4977397,12.5865972,14.5255906,1.2961024,44.2422938),(33478,'tibia.tif',231,8,8,109.0727568,29.2672583,41.8470853,1.8,29.473568,41.7486629,-1.2659175,8.1165685,16.1637181,1057.8796373,6341.1986468,16.5407644,392.3106423,130.3358232,457.0914057,14.7420438,27.462133,1.2212345,73.0114177),(33479,'tibia.tif',231,8,9,119.5039524,29.4898579,40.0411458,1.8,29.6169302,40.1344764,-1.279072,13.3853026,15.6110251,1570.0468734,8222.1932934,18.2698408,526.6914389,117.2963297,612.549289,16.5845348,29.265588,1.2298174,79.4461629),(33480,'tibia.tif',231,8,10,145.4132381,28.7848367,37.6319252,1.8,29.1129942,38.001942,-1.4357625,12.50517,16.2321901,4682.9888645,10758.7832927,23.796305,662.8054012,374.484221,951.0859978,21.9421404,30.305291,1.8951994,103.6185214),(33481,'tibia.tif',231,8,11,170.5889471,29.6889075,36.3721428,1.8,29.8214635,36.722711,-1.3636195,15.2936445,18.1397908,8274.7954301,13943.3259937,27.2285083,768.6596897,541.0610553,1224.8092428,25.9927941,32.5289129,1.7674256,103.99608),(33482,'tibia.tif',231,8,12,187.5237052,30.3258772,35.1100954,1.8,30.4784189,35.3603346,-1.2980866,17.1431099,19.9314783,11291.1128282,18298.0082628,28.9866293,918.0457141,658.6385363,1484.2030522,28.8342774,35.7313824,1.7423777,113.8226531),(33483,'tibia.tif',231,8,13,193.1237071,30.9996146,33.1587014,1.8,30.9257834,33.8370479,-1.3044755,18.0412478,22.4836892,11623.7765569,20109.0394821,29.95781,894.3834497,644.2889464,1411.303272,30.1646729,38.2199261,1.6774139,125.989031),(33484,'tibia.tif',231,8,14,190.3607346,30.9608389,33.0651359,1.8,31.1581849,32.9350731,-1.2853878,18.3510056,23.0633045,10740.1824552,21276.2273643,29.2118024,922.5142631,585.2639741,1388.0544781,30.6535548,39.066251,1.6196174,128.4023814),(33485,'tibia.tif',231,8,15,179.2215326,31.6034317,34.1386779,1.8,31.5120736,33.1192937,-1.1755604,15.9057916,22.3109995,10583.6679297,21826.3714753,25.4421411,978.2785151,665.3971222,1447.6443716,29.2677831,39.3086448,1.5287499,128.7980054),(33486,'tibia.tif',231,8,16,153.9392851,31.1982431,34.2424533,1.8,30.7329462,33.3940772,-1.1900762,14.274624,22.3000586,8242.2500401,19524.3616535,22.1139297,875.5296122,577.4057562,1240.5396595,28.0109133,39.4471011,1.5224469,127.8939814),(33487,'tibia.tif',231,8,17,121.9451309,29.556584,35.3486828,1.8,29.1632328,34.5524087,-1.3385686,14.8660711,21.1998244,5518.7881859,14603.0071895,19.2476738,688.8267993,371.2338082,947.0390398,25.6384849,39.6018014,1.5097789,121.1816795),(33488,'tibia.tif',231,8,18,114.6383723,28.6503415,35.4272651,1.8,28.0712062,35.2195875,-1.4210981,13.9908535,21.2639371,4151.5063159,13781.5219326,18.6814182,648.1171332,296.7300259,842.8823531,22.9674619,38.8188067,1.5183854,111.1700686),(33489,'tibia.tif',231,8,19,106.9085202,28.0091707,36.134271,1.8,27.4074913,36.3447468,-1.4256882,13.2024588,20.5820762,3271.5626775,12207.0325142,17.4455283,593.0904339,247.7994987,750.5691181,21.5120214,36.6420754,1.5256881,103.3154164),(33490,'tibia.tif',231,8,20,101.4029154,27.5469457,36.5398475,1.8,27.0746109,37.0215956,-1.4269418,12.6890421,20.0813437,2697.1126998,11386.282708,16.553151,567.0080092,212.5544763,700.420446,20.4161643,35.6390332,1.5172761,99.3226695),(33491,'tibia.tif',231,8,21,97.9529307,27.2729285,36.9028539,1.8,26.7751253,37.4306383,-1.4195709,12.1409947,19.4027145,2250.287044,10559.6918001,15.9549761,544.2378588,185.3461851,658.3338629,19.5460202,34.7318074,1.5268686,95.9255503),(33492,'tibia.tif',231,8,22,95.1705498,26.9657028,37.0985782,1.8,26.5399631,37.8612978,-1.4184837,11.850018,19.1318272,1946.614912,9942.4095883,15.4966163,519.6790409,164.2710509,620.3723654,18.9150533,34.1312635,1.5074484,93.2474174),(33493,'tibia.tif',231,8,23,93.6412927,26.7103863,37.5049455,1.8,26.3279314,38.2854205,-1.4135718,11.4929951,18.7307123,1738.4645471,9537.0810477,15.2242556,509.1680935,151.2629678,598.8427583,18.1753014,33.8374984,1.5294665,91.3191103),(33494,'tibia.tif',231,8,24,92.6235255,26.5477438,37.765073,1.8,26.2041149,38.6041177,-1.4133651,11.1096329,18.5475398,1567.0801377,9274.3393312,15.0577989,500.0307018,141.0559785,582.8236762,17.7689227,33.4816263,1.5138238,89.7630706),(33495,'tibia.tif',231,8,25,91.1423755,26.3815463,37.8951162,1.8,26.0341026,38.8007232,-1.4137772,10.8592364,18.5192257,1456.2611109,8958.4194838,14.8189445,483.7361792,134.1034544,560.3549804,17.2549963,33.2433957,1.5057541,87.8603119),(33496,'tibia.tif',231,8,26,91.1572735,26.291783,38.0100644,1.8,25.9744994,39.0064773,-1.4126754,10.5469189,18.5299281,1340.3866786,8692.1597613,14.8161783,469.0876148,127.0879862,539.6245284,16.7772013,33.0938748,1.5170021,86.7818326),(33497,'tibia.tif',231,8,27,90.3644513,26.1983014,38.1762468,1.8,25.8612806,39.2188394,-1.4099734,10.2001207,18.5148978,1251.9312924,8500.6472177,14.6745575,459.1247163,122.7369099,525.3413062,16.5090624,32.9542164,1.5244974,85.9139394),(33498,'tibia.tif',231,8,28,89.5713922,26.1171365,38.4007003,1.8,25.8139099,39.3034365,-1.4089877,9.9667117,18.5305105,1168.7463774,8388.4676902,14.5411045,452.6841129,117.2649927,515.3073078,16.0146012,32.7634638,1.4931318,84.9535274),(33499,'tibia.tif',231,8,29,89.3613737,26.0235164,38.7479952,1.8,25.7679789,39.6036421,-1.4076797,9.7434735,18.2763677,1099.1730048,8315.2760379,14.5007908,454.9742135,112.8112064,514.3779917,15.6304877,32.6367484,1.4928297,84.0547946),(33500,'tibia.tif',231,8,30,90.5783735,25.9549224,39.0458153,1.8,25.7625245,39.8172836,-1.4095129,9.6298274,18.2882826,1048.5821218,8451.1271676,14.7070963,462.1061109,108.8889843,517.919881,15.3791012,32.8400454,1.5165859,83.6953015),(33501,'tibia.tif',231,8,31,92.9145651,25.8739952,39.3836576,1.8,25.717242,40.1410248,-1.4152738,9.5727983,18.2205827,1015.8114449,8731.1873088,15.1142129,479.193638,106.1143682,531.6516681,15.1249012,32.9434301,1.5322055,84.278155),(33502,'tibia.tif',231,8,32,94.3220743,25.8437705,39.6685759,1.8,25.721119,40.3718026,-1.4215042,9.4616456,18.2242418,1001.3010373,8811.0429664,15.372564,483.4792616,105.827367,535.8197901,15.0549493,33.0704359,1.5323537,84.4579015),(33503,'tibia.tif',231,8,33,95.6780453,25.8604614,39.8231481,1.8,25.7593651,40.5076527,-1.4272723,9.3416806,18.333841,995.4720476,8921.3918435,15.6201093,486.6078998,106.5624155,535.0525278,14.8822474,33.3157226,1.6013212,84.8790739),(33504,'tibia.tif',231,8,34,96.8098511,25.868896,39.8907878,1.8,25.7651827,40.6075903,-1.4339854,9.2504216,18.3935339,993.8101917,8944.3562187,15.8348529,486.2772029,107.4340426,533.9036333,14.6596588,33.3295391,1.6127564,85.0896601),(33505,'tibia.tif',231,8,35,97.4920974,25.8639311,40.0039214,1.8,25.7623748,40.7293808,-1.4386893,9.0417762,18.3182631,980.5077314,8903.2695374,15.9667526,486.0324092,108.441938,530.7978982,14.3127333,33.3295391,1.6127564,84.5812601),(33506,'tibia.tif',231,8,36,96.6910841,25.8770785,39.9992541,1.8,25.7953863,40.6653463,-1.4385086,8.8852116,18.198043,956.9961404,8737.9194729,15.8348055,480.1570943,107.7066237,523.3833955,14.0404173,33.0872843,1.6207547,84.3578997),(33507,'tibia.tif',231,8,37,96.8008438,25.8834256,39.95212,1.8,25.7946503,40.6379184,-1.4376304,8.643241,18.0830225,934.2103892,8619.8173066,15.8490636,476.6801196,108.0856582,518.0208337,13.718121,32.8471773,1.6288705,83.4283272),(33508,'tibia.tif',231,8,38,96.4803884,25.8830276,39.8417911,1.8,25.8145917,40.4778803,-1.4308526,8.4991005,17.7905506,903.1714438,8334.2677213,15.7671994,468.4659811,106.2667094,508.2992301,13.5328239,32.3473895,1.6337053,82.5295945),(33509,'tibia.tif',231,8,39,95.2974409,25.8702861,39.7498795,1.8,25.8156318,40.343007,-1.4194743,8.3341072,17.4499885,870.3803226,8030.3339063,15.5219819,460.1913584,104.4359407,501.4724422,13.3481472,31.8179333,1.6227495,81.0480082),(33510,'tibia.tif',231,8,40,93.2050407,25.8333123,39.4730955,1.8,25.7848823,40.0313593,-1.4050803,8.3105729,17.4844079,834.6403661,7503.1591743,15.1114679,429.1343009,100.4311463,470.3098691,13.2863192,31.5272081,1.5909549,79.1324753),(33511,'tibia.tif',231,8,41,91.5790689,25.8339983,39.1138959,1.8,25.8144187,39.4802886,-1.3872437,8.246915,16.9602398,803.334029,6957.1108689,14.7546869,410.2012097,97.4102474,455.9384239,13.2248226,30.4536504,1.4997862,76.1820769),(33512,'tibia.tif',231,8,42,91.1642785,25.8625818,38.9404528,1.8,25.8679474,39.2648969,-1.3759568,8.1737453,16.967702,792.6473024,6665.5806525,14.6245053,392.8393283,96.974798,438.6607398,13.1633261,30.1503085,1.4694498,74.8057837),(33513,'tibia.tif',231,8,43,90.8569185,25.8911395,38.7785798,1.8,25.9128764,39.0547444,-1.3668604,8.0902305,17.0699633,783.1449231,6369.9018668,14.5217147,373.1643553,96.8013113,417.4520322,13.0918056,30.1031215,1.4862526,74.1484768),(33514,'tibia.tif',231,8,44,90.1393574,25.9208279,38.5552594,1.8,25.9457282,38.8301917,-1.3584415,8.0768725,16.7672881,783.6783989,6009.8769211,14.3558827,358.4286793,97.0274575,404.4160059,13.0707497,29.5052756,1.4715563,72.846637),(33515,'tibia.tif',231,8,45,89.420057,25.961854,38.294121,1.8,26.0001059,38.4785469,-1.3501223,8.06666,16.333522,778.985538,5696.8726884,14.189299,348.7840954,96.5685352,396.0434347,13.0707497,28.6919651,1.4464413,71.2033696),(33516,'tibia.tif',231,8,46,88.1042783,26.002016,38.0557729,1.8,26.0452698,38.2488978,-1.3445913,8.1031526,15.7603073,777.7667106,5316.6041203,13.945411,337.3414002,95.9832235,386.5529266,13.0883356,27.8259051,1.437943,69.1389298),(33517,'tibia.tif',231,8,47,87.8727714,26.0338256,37.9312885,1.8,26.0726795,38.1665776,-1.3381616,8.0632345,15.1729806,782.3411634,5043.1453837,13.8670606,332.3767098,97.0257237,383.8974433,13.0523419,27.0878122,1.4295628,67.6137297),(33518,'tibia.tif',231,8,48,87.6343332,26.0711591,37.8056839,1.8,26.123075,38.0196191,-1.3336244,8.1538036,14.655109,791.0500096,4803.4262246,13.7994324,327.7646198,97.0160738,381.6835464,13.1382932,26.4233554,1.4357019,66.2991158),(33519,'tibia.tif',231,8,49,87.2677263,26.1210829,37.6400225,1.8,26.1857395,37.8438319,-1.3305536,8.1574587,14.1795415,801.5350159,4548.639306,13.7211818,320.7888852,98.2579311,377.2503287,13.1353184,25.6858397,1.4267999,65.0717295),(33520,'tibia.tif',231,8,50,87.768709,26.1832352,37.4918797,1.8,26.2763545,37.6163555,-1.3271077,8.2375084,13.6585703,818.2018969,4324.6263848,13.7764998,316.6236504,99.3263806,376.507536,13.2059558,24.9702195,1.4123421,63.8007294),(33521,'tibia.tif',231,8,51,88.2365293,26.2542212,37.3771551,1.8,26.3614161,37.497904,-1.3250097,8.308672,13.1709839,835.4277531,4119.7381939,13.8354245,312.7889488,100.5488904,376.1156589,13.3040681,24.3030375,1.4185446,62.8892224),(33522,'tibia.tif',231,8,52,88.1744941,26.3389374,37.2395826,1.8,26.4571698,37.3374372,-1.3224294,8.3700267,12.7411545,854.3605359,3931.0917771,13.8077123,308.5349739,102.0738129,375.1722573,13.3942454,23.6573376,1.3870985,61.9777154),(33523,'tibia.tif',231,8,53,88.5468243,26.4150874,37.1339996,1.8,26.5428544,37.2133134,-1.3228962,8.3556954,12.3378679,867.2666487,3763.8971868,13.869298,305.0686892,103.7934734,374.8307924,13.3873437,23.1342968,1.3884858,60.7503292),(33524,'tibia.tif',231,8,54,88.7660463,26.4933522,37.0476876,1.8,26.6431951,37.0793188,-1.3219521,8.4196635,12.0092509,882.630722,3607.407745,13.8969787,300.3857419,104.8296906,373.4938076,13.4619809,22.6922466,1.4019644,60.0930222),(33525,'tibia.tif',231,8,55,89.1062534,26.5524355,36.9869478,1.8,26.6897766,37.0236426,-1.3233825,8.4464015,11.6511493,895.3980229,3471.7848518,13.960355,297.9778866,106.0094082,373.5149866,13.464084,22.2134313,1.3924781,59.1942894),(33526,'tibia.tif',231,8,56,88.8184911,26.6200679,36.8774377,1.8,26.7562457,36.9146927,-1.3261471,8.5122298,11.3395147,902.0757447,3337.1551549,13.9346061,294.2943533,105.974083,372.4325309,13.5329684,21.7727177,1.4066073,58.6114359),(33527,'tibia.tif',231,8,57,88.897064,26.6986151,36.8022567,1.8,26.8372732,36.8330123,-1.3265032,8.5172847,11.1230064,916.6373664,3229.1813288,13.9494111,290.3155153,107.6208434,371.6983746,13.5360646,21.4633497,1.3861759,57.8488358),(33528,'tibia.tif',231,8,58,89.6079309,26.7867265,36.7553699,1.8,26.929427,36.7617579,-1.3291287,8.5772553,10.879904,935.5266669,3125.6032023,14.0792714,287.28224,109.0706336,372.4991966,13.6118691,21.1460194,1.4016951,57.551022),(33529,'tibia.tif',231,8,59,89.9199105,26.863933,36.731531,1.8,27.0163126,36.7586956,-1.331807,8.6423294,10.6123065,951.4498659,3020.1421951,14.1468489,284.5886689,110.0918304,372.2668366,13.6224391,20.8339365,1.4176832,57.042622),(33530,'tibia.tif',231,8,60,90.1859791,26.9486515,36.6621542,1.8,27.1072772,36.6998148,-1.3363812,8.7477035,10.4198333,961.6597037,2918.1541929,14.2200551,280.0576655,109.9328186,371.2349145,13.7408081,20.4982016,1.4025896,56.5778357),(33531,'tibia.tif',231,8,61,90.0688846,27.0406279,36.5785586,1.8,27.2052833,36.6085375,-1.3398906,8.8435603,10.2433682,973.6765907,2814.1891756,14.2252307,274.7327945,110.1000676,368.4875065,13.8188305,20.2061036,1.4128864,56.2183426),(33532,'tibia.tif',231,8,62,90.3905344,27.1354099,36.5090507,1.8,27.3159351,36.523169,-1.3426179,8.9293509,10.0829757,989.7495889,2718.5776337,14.2942377,269.6205677,110.842277,366.3082057,13.8065521,19.8942983,1.3909428,55.679103),(33533,'tibia.tif',231,8,63,90.2813874,27.2274001,36.4454406,1.8,27.4123051,36.4863878,-1.3470113,9.0208062,9.9530117,1004.083501,2635.6039664,14.3058488,264.8046693,111.3075129,364.7873278,13.9303582,19.7041912,1.408829,55.7099426),(33534,'tibia.tif',231,8,64,90.0074068,27.346398,36.3760204,1.8,27.5400976,36.4121068,-1.3487763,9.1456104,9.8258287,1024.3451094,2556.2692004,14.2738506,260.1581267,112.0040178,362.5683175,14.0071491,19.4533613,1.4067218,55.4557426),(33535,'tibia.tif',231,8,65,89.5729361,27.4560773,36.3369361,1.8,27.6583921,36.3977242,-1.3528246,9.2116921,9.6773145,1033.8156089,2469.9924594,14.2306917,255.2353193,112.2286329,358.4567489,14.0781542,19.1819982,1.4110942,55.2143167),(33536,'tibia.tif',231,8,66,88.9430869,27.545363,36.3129362,1.8,27.7572439,36.3720067,-1.3582351,9.2969951,9.5207047,1033.3484995,2392.4075895,14.1640995,251.2847171,111.1486544,349.2677469,14.0652753,18.9651785,1.4431163,55.1270891),(33537,'tibia.tif',231,8,67,87.990893,27.6395879,36.2838603,1.8,27.8354841,36.3559313,-1.3639415,9.3775176,9.3590372,1034.5633604,2311.9438448,14.0465423,247.0279579,110.3237978,340.8369882,14.1285972,18.6970984,1.4481277,55.1270891),(33538,'tibia.tif',231,8,68,87.8454999,27.7569505,36.2710501,1.8,27.9565426,36.3432687,-1.366949,9.4233911,9.2637821,1046.5217414,2235.1318481,14.0409123,241.2763845,111.0557477,333.962339,14.1782277,18.5413606,1.4608961,55.0834753),(33539,'tibia.tif',231,8,69,87.8704018,27.8868512,36.2521795,1.8,28.1075425,36.3165955,-1.3641466,9.4174348,9.1597146,1063.2065744,2166.094389,14.0285142,236.4805545,112.897683,329.3485256,14.1808991,18.303284,1.4524705,53.8688632),(33540,'tibia.tif',231,8,70,87.3204214,27.9968194,36.2579718,1.8,28.2258271,36.3133658,-1.3603558,9.5210928,9.0809926,1070.186833,2106.8839124,13.9183607,232.010311,112.4016813,320.2008977,14.2321976,18.0830755,1.4368514,53.7635701),(33541,'tibia.tif',231,8,71,87.388708,28.131564,36.2640707,1.8,28.3584816,36.3216373,-1.3560592,9.6247355,9.0253983,1087.6804499,2056.7378669,13.9034326,227.8833343,113.0088662,313.7744367,14.2650811,17.9971101,1.4788577,53.7944097),(33542,'tibia.tif',231,8,72,87.5683946,28.2548774,36.266896,1.8,28.5110786,36.3138482,-1.3580911,9.6603231,8.923568,1099.5006532,2003.7750147,13.9443137,224.5486344,113.8161365,309.5463093,14.2599877,17.783558,1.4561928,53.4349166),(33543,'tibia.tif',231,8,73,87.2717072,28.368629,36.2638271,1.8,28.6064811,36.3250616,-1.3601777,9.6083814,8.8428262,1103.3521089,1946.6656182,13.9095371,220.1406617,114.8322555,307.7238499,14.2500443,17.6174552,1.4768706,53.1062631),(33544,'tibia.tif',231,8,74,86.9671233,28.4672862,36.26458,1.8,28.7054865,36.3327591,-1.3659916,9.5768626,8.7363107,1101.3129179,1894.4583492,13.8950014,216.8487837,114.997256,305.2807428,14.251251,17.3769468,1.4682165,52.7159304),(33545,'tibia.tif',231,8,75,86.8379307,28.5804657,36.2781898,1.8,28.8146337,36.3392841,-1.3702295,9.4717625,8.6445644,1099.358145,1843.9891136,13.8985478,213.3119757,116.0669034,303.6567906,14.2167952,17.2153667,1.4894945,52.1330769),(33546,'tibia.tif',231,8,76,86.8086146,28.7055698,36.2856727,1.8,28.9343043,36.3551434,-1.3734696,9.403825,8.5847205,1100.6228436,1794.0848658,13.91202,208.9858214,117.0399107,303.0008711,14.1742627,16.997696,1.4659194,51.5193837),(33547,'tibia.tif',231,8,77,86.9222212,28.842815,36.2934016,1.8,29.0725427,36.3585721,-1.3751615,9.2952385,8.5288938,1109.6043107,1755.3008447,13.9396124,205.8063893,119.3734091,304.1482435,14.1720937,16.9429605,1.5032302,51.1162768),(33548,'tibia.tif',231,8,78,87.0978494,28.9740848,36.3163634,1.8,29.2064659,36.3602642,-1.3782203,9.1909459,8.454593,1113.760467,1719.0341842,13.9845853,203.3254816,121.180179,304.8535223,14.1425845,16.7318848,1.4718835,50.5025837),(33549,'tibia.tif',231,8,79,87.263235,29.0976948,36.3421958,1.8,29.3278586,36.3927034,-1.3860062,8.9734899,8.3996746,1114.0514317,1684.1897233,14.0528642,200.5065439,124.1491823,309.2976664,14.0970672,16.5932458,1.4787495,50.0377975),(33550,'tibia.tif',231,8,80,87.4332472,29.2154824,36.3632603,1.8,29.4251756,36.4098245,-1.3952557,8.8862982,8.3126601,1112.2083835,1652.426942,14.1277658,198.7843761,125.1599216,309.3730053,14.0046892,16.466688,1.47804,49.560237),(33551,'tibia.tif',231,8,81,87.7053047,29.3461926,36.367133,1.8,29.5445921,36.4248589,-1.4065157,8.8505916,8.255063,1115.8260852,1619.1519944,14.2265867,196.1404778,126.0736158,306.6678214,13.943728,16.3401386,1.4773195,49.306037),(33552,'tibia.tif',231,8,82,87.5350801,29.4722592,36.3777247,1.8,29.6863009,36.4377757,-1.4226275,8.9041094,8.1532224,1121.2262314,1584.8571872,14.271226,194.3841468,125.9223336,302.9417633,13.9627,16.1821824,1.5000485,48.9773835),(33553,'tibia.tif',231,8,83,87.1997432,29.5773913,36.394026,1.8,29.7824668,36.4608808,-1.4360089,8.8064963,8.0681711,1117.3708128,1552.0692956,14.2708497,192.3694079,126.8802915,302.4281563,13.9377255,16.0649586,1.4915973,48.39453),(33554,'tibia.tif',231,8,84,87.2155833,29.6954511,36.4235271,1.8,29.8859662,36.4912692,-1.4582635,8.7112418,7.9953709,1117.0241847,1530.5472592,14.3526287,191.4291755,128.2278931,303.757106,13.8037906,15.948899,1.4830224,47.9605835),(33555,'tibia.tif',231,8,85,87.4731213,29.811933,36.4545043,1.8,30.0153209,36.5392791,-1.4803554,8.5967273,7.911599,1113.5369049,1506.2610648,14.4599297,190.3864281,129.5303278,304.7148286,13.6461436,15.8115682,1.4903253,47.6755438),(33556,'tibia.tif',231,8,86,87.0729587,29.8923401,36.4859866,1.8,30.0633373,36.5639953,-1.4972606,8.406914,7.8093863,1092.6164825,1484.4907225,14.4338265,190.090574,129.9664156,306.3945749,13.4763722,15.734242,1.4574629,47.0618507),(33557,'tibia.tif',231,8,87,85.9348281,29.9430869,36.5191658,1.8,30.0934266,36.5940323,-1.523168,8.2240682,7.7579683,1061.2356221,1466.9802611,14.290006,189.0933571,129.040227,306.6433482,13.3012453,15.607964,1.456542,46.522611),(33558,'tibia.tif',231,8,88,85.9165923,30.0448633,36.549473,1.8,30.2014974,36.6173815,-1.5480599,8.1074243,7.8072807,1056.08608,1454.3946256,14.312031,186.2869652,130.2616023,307.8110501,13.211372,15.5810305,1.472751,46.3737041),(33559,'tibia.tif',231,8,89,86.3536288,30.1687154,36.5790808,1.8,30.3164759,36.6505758,1.5540578,7.9533597,7.7589767,1064.8313764,1444.1636389,14.3882395,186.1281068,133.8844734,311.0504201,13.0657163,15.4545459,1.471946,46.1631179),(33560,'tibia.tif',231,8,90,86.6639373,30.2850334,36.6110754,1.8,30.4177897,36.671006,1.5171738,7.9268864,7.8318544,1069.4609065,1433.9489346,14.4024974,183.0918774,134.9156344,310.1439496,12.9680142,15.4425204,1.4801364,46.0886644),(33561,'tibia.tif',231,8,91,87.0547749,30.39054,36.6459276,1.8,30.5065261,36.6926294,1.4857047,7.8818193,7.8025754,1068.3447831,1427.2725062,14.4043278,182.923257,135.5454552,306.9541805,12.9129991,15.2445852,1.4454072,45.8780782),(33562,'tibia.tif',231,8,92,87.6268208,30.4942295,36.6649158,1.8,30.6003764,36.7014089,1.4547721,7.7408908,7.8245834,1059.3314617,1421.0546574,14.4087509,181.6140971,136.8487808,308.1599679,12.9298162,15.2148852,1.4619841,46.776811),(33563,'tibia.tif',231,8,93,87.9417728,30.5789302,36.679642,1.8,30.6693486,36.7069285,1.4304472,7.4709052,7.7764484,1040.314577,1415.0210928,14.3701418,181.9623836,139.248799,312.1809418,12.7291083,15.1893818,1.4786213,45.5930386),(33564,'tibia.tif',231,8,94,88.4022485,30.6533598,36.6876955,1.8,30.7249776,36.7034688,1.417055,7.2931876,7.7293385,1020.5444504,1411.5386174,14.3881913,182.6208824,139.9311935,312.1776251,12.6169395,15.0515608,1.4862526,45.3824524),(33565,'tibia.tif',231,8,95,88.9440483,30.7323481,36.696401,1.8,30.8058455,36.7131479,1.4013943,7.0929241,7.6736295,1004.0355092,1406.9662627,14.4026564,183.3508213,141.5545266,313.2514756,12.5112842,14.8505906,1.4506876,44.8868265),(33566,'tibia.tif',231,8,96,89.5510144,30.8175515,36.7085861,1.8,30.8950912,36.7168818,1.3852978,7.0263186,7.6161428,991.1658415,1400.3564404,14.417462,183.8668834,141.0647458,313.9992193,12.4174856,14.8222809,1.4677147,44.8123731),(33567,'tibia.tif',231,8,97,89.7668145,30.8817908,36.7204708,1.8,30.9419593,36.7280831,1.3792674,6.646193,7.5638376,970.1261871,1390.0527863,14.4189899,183.7761281,145.9672017,311.7155676,12.2651407,14.6832145,1.4754343,44.4220403),(33568,'tibia.tif',231,8,98,90.1809597,30.9598985,36.7335151,1.8,31.0226246,36.7395695,1.3631761,6.5972637,7.525259,958.3880821,1383.9200802,14.3915238,183.9033149,145.2705436,310.3728078,12.2000055,14.5694537,1.4659194,44.1678403),(33569,'tibia.tif',231,8,99,90.5488697,31.022227,36.7469103,1.8,31.0767281,36.7562214,1.3567139,6.3547159,7.5011064,943.2476504,1380.6320456,14.4103185,184.0571196,148.4327007,309.5051066,12.1120061,14.4570325,1.4562556,44.0625472),(33570,'tibia.tif',231,8,100,90.7658648,31.0850117,36.7581954,1.8,31.143026,36.7672934,1.3449714,6.388201,7.4726058,930.4539773,1376.1325199,14.3692065,184.1569805,145.6519573,308.6645288,11.9711544,14.4184304,1.4825307,44.2731334),(33571,'tibia.tif',231,8,101,91.2859425,31.1581346,36.7619734,1.8,31.2068018,36.7691881,1.3336684,6.2464047,7.4637206,920.5951703,1373.6138224,14.3747426,184.0387516,147.3800067,307.3615969,11.8806903,14.4184304,1.4825307,43.8828007),(33572,'tibia.tif',231,8,102,91.1668122,31.2245019,36.7743423,1.8,31.2866211,36.7791214,1.3215891,6.1697394,7.4278129,906.8335397,1365.9138954,14.2702017,183.8918021,146.9808495,305.6193052,11.8107624,14.3166751,1.4640607,43.5233075),(33573,'tibia.tif',231,8,103,90.9719533,31.2861168,36.7802864,1.8,31.3582097,36.7751796,1.3127718,6.078324,7.3877917,893.3640495,1360.1477974,14.1747612,184.1074905,146.9753925,304.2661945,11.7352143,14.303693,1.472896,43.7775076),(33574,'tibia.tif',231,8,104,90.8686969,31.3511937,36.7898134,1.8,31.4186575,36.781406,1.3063062,5.9933771,7.4132686,883.797259,1352.399714,14.1098046,182.4296121,147.4623154,301.6317955,11.7312093,14.2714692,1.4994889,43.6722145),(33575,'tibia.tif',231,8,105,90.5583083,31.3909012,36.791401,1.8,31.447462,36.7960391,1.3014399,5.8527568,7.3910821,865.8369397,1347.1841104,14.0242347,182.2715651,147.9366008,298.5132261,11.6197605,14.1903049,1.6784862,43.2074283),(33576,'tibia.tif',231,8,106,90.6320675,31.4452567,36.7876997,1.8,31.496592,36.789649,1.3007451,5.7978446,7.4018771,856.4688141,1345.407083,14.0302668,181.7656608,147.7219338,297.414981,11.5524263,14.1772071,1.6695729,43.1329748),(33577,'tibia.tif',231,8,107,90.4959138,31.4928362,36.788113,1.8,31.5418258,36.7917008,1.2962123,5.7420989,7.3799612,844.9919631,1339.4287699,13.973769,181.4953669,147.1573329,294.9539303,11.485092,14.1543995,1.6517004,42.9840679),(33578,'tibia.tif',231,8,108,90.183803,31.5339898,36.7778155,1.8,31.573161,36.7829204,1.2919141,5.6901082,7.3802075,834.8879491,1331.1609058,13.8916161,180.369035,146.7261984,292.5966429,11.4177578,14.110391,1.706324,42.6990282),(33579,'tibia.tif',231,8,109,89.5720867,31.542477,36.7589772,1.8,31.5656718,36.7691247,1.3029172,5.545962,7.3545769,811.8539344,1319.7220368,13.8827913,179.4422789,146.3864931,288.6054707,11.1874301,14.0782984,1.6884325,42.7734817),(33580,'tibia.tif',231,8,110,88.9811996,31.5746417,36.7503548,1.8,31.59597,36.7613232,1.2978891,5.5347444,7.3318165,799.2902427,1305.649777,13.7528217,178.0799855,144.4132168,285.948821,11.1280883,14.0386549,1.6614562,42.6990282),(33581,'tibia.tif',231,8,111,88.5080879,31.6100776,36.7284916,1.8,31.6317294,36.7361887,1.2905689,5.5199634,7.3183578,789.0331899,1294.3466754,13.6229691,176.8629949,142.9417436,283.6250593,11.0638419,14.0023607,1.7165445,42.4139886),(33582,'tibia.tif',231,8,112,88.5961139,31.6799014,36.7103578,1.8,31.7105761,36.7159474,1.2749865,5.5727771,7.3158973,796.3435726,1285.9119709,13.5111913,175.7695484,142.8988737,283.6960957,11.1577592,13.967707,1.6985373,42.4139886),(33583,'tibia.tif',231,8,113,87.737212,31.7036368,36.6905997,1.8,31.7301831,36.6968807,1.2681869,5.539341,7.2714731,783.1190421,1272.3950246,13.3241945,174.9844928,141.3740442,280.6331673,11.0975562,13.9161452,1.735945,42.2650816),(33584,'tibia.tif',231,8,114,87.1798853,31.7279689,36.6633085,1.8,31.7553303,36.6695426,1.2593046,5.5433442,7.2448471,769.729259,1260.3288404,13.1651896,173.9621044,138.8564803,278.0070035,11.0317736,13.8859306,1.9853032,42.0544954),(33585,'tibia.tif',231,8,115,86.1679449,31.7232898,36.6316318,1.8,31.7394486,36.6359281,1.2612136,5.4672156,7.214981,747.9966322,1241.6440231,13.0283284,172.0924862,136.8149145,273.6711445,10.8865988,13.8859306,1.9853032,41.5897092),(33586,'tibia.tif',231,8,116,85.1930143,31.7416857,36.6074849,1.8,31.7537105,36.6091537,1.2486388,5.4747615,7.2264907,733.7850946,1223.872544,12.7754831,169.3591803,134.0305133,270.0254484,10.8440227,13.8859306,1.9853032,41.5897092),(33587,'tibia.tif',231,8,117,84.3115297,31.7552416,36.5748216,1.8,31.7647103,36.5826874,1.2414627,5.4335988,7.1966427,719.9799708,1206.9910102,12.5821518,167.7158444,132.5051774,266.8787261,10.795519,13.8766205,2.0672191,41.3355092),(33588,'tibia.tif',231,8,118,83.3688106,31.7644108,36.5518458,1.8,31.7703619,36.5586979,1.2292953,5.433783,7.1372363,706.6136126,1184.1106476,12.3363714,165.9060459,130.0408217,263.4715854,10.7704447,13.8217974,1.9974238,41.1557627),(33589,'tibia.tif',231,8,119,82.5524385,31.7684412,36.5197691,1.8,31.7808439,36.5276699,1.2220844,5.4196474,7.1390372,694.2255306,1167.7327436,12.152402,163.5700602,128.0942239,259.9748948,10.7402643,13.8217974,1.9974238,41.1557627),(33590,'tibia.tif',231,8,120,81.9985758,31.7755753,36.4781161,1.8,31.7876928,36.4845176,1.2151932,5.4095974,7.0983493,684.9360848,1155.650916,12.0098879,162.8055847,126.6149824,257.2276967,10.6965756,13.7696892,1.9890207,40.9015626),(33591,'tibia.tif',231,8,121,81.3959206,31.7752067,36.426906,1.8,31.7842638,36.4379676,1.2100104,5.3916507,7.0762733,674.9203653,1144.4491566,11.8754499,161.7304904,125.1788,255.0372325,10.6712359,13.7368007,1.9598936,40.5420695),(33592,'tibia.tif',231,8,122,81.7638031,31.8270995,36.3684483,1.8,31.8418199,36.3763035,1.1919752,5.444041,7.0466294,686.2568961,1135.3037694,11.763483,161.1130234,126.0565251,256.9493064,10.7704447,13.7185606,1.9805543,40.362323),(33593,'tibia.tif',231,8,123,80.6112008,31.7867507,36.3136987,1.8,31.7863909,36.3130055,1.2021902,5.3376812,6.986372,665.2095387,1112.1758723,11.6909446,159.1921914,124.6251901,252.9586656,10.5973668,13.6536413,1.9928014,40.0772833),(33594,'tibia.tif',231,8,124,80.2767633,31.7936609,36.2732207,1.8,31.7857509,36.2743787,1.1874598,5.3603218,6.9432061,659.6290298,1097.9183245,11.507826,158.1284367,123.0577292,251.4835919,10.5952169,13.6234374,2.1096158,39.9719902),(33595,'tibia.tif',231,8,125,79.6093769,31.794969,36.2348335,1.8,31.7873788,36.2338954,1.1724393,5.3467554,6.9294885,652.9328879,1082.7824455,11.2717601,156.2571962,122.117591,248.5478006,10.5698773,13.5925721,2.0679042,40.0028298),(33596,'tibia.tif',231,8,126,78.8461833,31.7880129,36.1973065,1.8,31.7724537,36.196467,1.1576998,5.3579726,6.9018862,646.3908341,1066.9581195,11.023223,154.5893535,120.6409375,246.689191,10.5698773,13.5324211,2.0596487,39.8230833),(33597,'tibia.tif',231,8,127,78.1003673,31.7792074,36.1526614,1.8,31.7678341,36.1494071,1.1443612,5.3344068,6.8482883,639.8864031,1052.5028134,10.7897226,153.6884505,119.9545569,245.2748498,10.5329973,13.4809918,2.0724004,39.8230833),(33598,'tibia.tif',231,8,128,76.5101301,31.6880605,36.1021067,1.8,31.6714994,36.0968012,1.1617001,5.2478278,6.7773354,611.6807504,1029.016589,10.7339989,151.8320288,116.5588459,240.2901319,10.3271918,13.4203407,2.0640963,39.4327505),(33599,'tibia.tif',231,8,129,75.6757441,31.6663405,36.0575364,1.8,31.6553093,36.0513937,1.1518553,5.2212232,6.7334816,606.2453891,1012.6855145,10.5254769,150.3955269,116.111756,237.6633681,10.3275233,13.3648546,2.1324198,39.253004),(33600,'tibia.tif',231,8,130,75.0411844,31.6418639,36.0091471,1.8,31.6300947,36.000692,1.1393706,5.2228533,6.7190511,601.6976191,1002.8308779,10.3198756,149.2518596,115.2047714,236.1963936,10.3275233,13.3648546,2.1324198,39.4635902),(33601,'tibia.tif',231,8,131,74.4253929,31.6234602,35.9373461,1.8,31.6175111,35.9293694,1.1380963,5.2467285,6.6981656,602.4844392,988.3413936,10.2231685,147.5540405,114.8304965,235.4749539,10.4706685,13.3400528,2.1112158,39.253004),(33602,'tibia.tif',231,8,132,73.7000305,31.6053858,35.8875057,1.8,31.5953102,35.881449,1.122094,5.2663474,6.681356,600.3098427,976.1666646,9.9718648,146.1030757,113.989791,234.4908928,10.5106952,13.3085303,2.0686187,39.2838436),(33603,'tibia.tif',231,8,133,72.3041925,31.5466445,35.8293055,1.8,31.5412249,35.8247429,1.121228,5.2359897,6.6621393,584.8873085,959.0187274,9.7748403,143.9505673,111.705207,229.8724412,10.4453288,13.2751078,2.1030058,39.1040971),(33604,'tibia.tif',231,8,134,71.6895594,31.515873,35.7796793,1.8,31.5230925,35.787533,1.1025435,5.2691294,6.5920293,581.6461603,948.9362051,9.5144366,143.9520622,110.3875274,228.6057557,10.4812647,13.231227,2.1161581,39.0296436),(33605,'tibia.tif',231,8,135,70.8531775,31.4753242,35.7281761,1.8,31.4743791,35.7385599,1.087724,5.3067361,6.5849557,578.6911553,939.7268892,9.2609563,142.7081576,109.0484133,226.9352123,10.4908426,13.2196231,2.1507991,39.2093902),(33606,'tibia.tif',231,8,136,70.2014313,31.4369589,35.6751056,1.8,31.4456384,35.6943926,1.0711406,5.3397409,6.5789751,577.072565,929.0877602,9.0143407,141.2207442,108.0712665,226.0992129,10.5274384,13.2196231,2.1507991,39.1349367),(33607,'tibia.tif',231,8,137,68.8174844,31.3360055,35.6341742,1.8,31.3339291,35.6596204,1.0739119,5.2422463,6.5461724,558.8881145,913.8557537,8.8633203,139.6015411,106.612334,221.0393564,10.3991529,13.1657452,2.1079046,38.8807367),(33608,'tibia.tif',231,8,138,68.3400959,31.2937656,35.5868899,1.8,31.293576,35.6126385,1.0579254,5.2799164,6.5411394,560.5608491,902.9674115,8.647668,138.044362,106.1685081,221.5546354,10.4345842,13.1657452,2.1079046,38.8807367),(33609,'tibia.tif',231,8,139,67.6758016,31.2139716,35.5311329,1.8,31.207677,35.5549192,1.0606425,5.4782642,6.5031535,557.5381565,891.3907992,8.5897723,137.0705465,101.7727766,220.6947124,10.4129217,13.1227298,2.1211823,38.849897),(33610,'tibia.tif',231,8,140,66.6040715,31.0937967,35.4825184,1.8,31.0745022,35.5070503,1.0705518,5.4481681,6.4549467,542.4289194,879.4228055,8.5469156,136.240135,99.5617081,217.9899625,10.3327192,13.0764849,2.0561796,38.7446039),(33611,'tibia.tif',231,8,141,66.5221709,31.0488281,35.427398,1.8,31.0329493,35.4436028,1.0527887,5.4838101,6.4419651,548.1541013,874.6851192,8.3687814,135.7792388,99.9586224,218.4180815,10.3730486,13.0468021,2.1831185,38.6701505),(33612,'tibia.tif',231,8,142,66.6880896,31.0114261,35.3762212,1.8,30.9962516,35.384778,1.0304669,5.5155306,6.4225973,553.6869367,873.0917257,8.1734436,135.9406003,100.3868844,220.042101,10.4532511,13.0170516,2.1967211,38.6701505),(33613,'tibia.tif',231,8,143,67.339094,30.9820917,35.3291142,1.8,30.9724848,35.3365967,1.0100939,5.5353453,6.4182568,562.8302,876.0313054,8.0493644,136.4905358,101.6793295,222.6100464,10.5334537,12.9915858,2.1045045,38.6701505),(33614,'tibia.tif',231,8,144,66.7036998,30.8668264,35.2762658,1.8,30.8471148,35.276011,1.0275932,5.547505,6.4044536,551.5560039,865.2044556,8.1471274,135.0941874,99.4241571,219.0354613,10.4812647,12.9741658,2.1751018,38.4595643),(33615,'tibia.tif',231,8,145,66.6284294,30.8318577,35.2232805,1.8,30.8166443,35.2294665,1.011691,5.5648389,6.3870059,559.7061078,862.0427427,7.9803772,134.9682083,100.5790325,218.7894948,10.5434243,12.9866111,2.2730533,38.8190574),(33616,'tibia.tif',231,8,146,66.9381764,30.8049407,35.1641799,1.8,30.7993031,35.1641713,0.9902594,5.6423418,6.3854739,570.660103,860.198232,7.8002764,134.711729,101.1388753,221.1887638,10.6356691,12.9529814,2.3145519,38.7882178),(33617,'tibia.tif',231,8,147,66.9250783,30.7075009,35.1144715,1.8,30.7047934,35.1047211,0.9832443,5.6660865,6.3792645,572.7156454,854.8297012,7.7267632,134.0012944,101.0778147,221.2889667,10.6356691,12.9142617,2.202487,38.6084712),(33618,'tibia.tif',231,8,148,67.8626096,30.6488437,35.0594206,1.8,30.6591538,35.0552046,0.9600218,5.7007642,6.3683909,586.3409153,860.55951,7.5903801,135.1298188,102.8530372,223.4799421,10.7282454,12.9048765,2.2655346,38.8935109),(33619,'tibia.tif',231,8,149,68.3585706,30.5826936,34.9918196,1.8,30.5940156,34.9793613,0.9410802,5.7254942,6.3981104,598.1094733,864.8791873,7.4417276,135.1772832,104.4642528,226.942075,10.8208217,12.92239,2.2516816,38.8935109),(33620,'tibia.tif',231,8,150,68.0179789,30.4444097,34.9415308,1.8,30.4348742,34.9096551,0.9460999,5.7484607,6.4144413,594.6251436,861.0325913,7.4587294,134.2334519,103.4407603,223.5430334,10.7500352,12.9430003,2.1887627,38.7573781),(33621,'tibia.tif',231,8,151,68.3113387,30.3870644,34.8908193,1.8,30.3943144,34.8572097,0.9207133,5.7793118,6.4304281,605.444836,866.9998607,7.2144673,134.827704,104.7607141,225.6408448,10.8688451,13.0027721,2.2592769,39.0115782),(33622,'tibia.tif',231,8,152,67.6109482,30.2598503,34.8309538,1.8,30.2639017,34.7843678,0.9359578,5.784359,6.4626208,603.2068681,861.6802106,7.3053024,133.3329358,104.2824058,222.6420943,10.7818585,13.0027721,2.2592769,39.0115782),(33623,'tibia.tif',231,8,153,67.3848365,30.1854175,34.7749654,1.8,30.1835332,34.7363706,0.9167147,5.87744,6.4708294,613.7602813,864.9105133,7.0732974,133.6630058,104.4264654,224.8916532,10.8730868,13.0468021,2.3079561,39.4455247),(33624,'tibia.tif',231,8,154,66.9332798,30.0966011,34.709554,1.8,30.1086119,34.6672101,0.8985354,5.9211431,6.4572507,621.6303061,867.0741972,6.8291388,134.2791598,104.9848472,226.3236558,10.9961383,13.0027721,2.2592769,39.3710713),(33625,'tibia.tif',231,8,155,65.5199035,29.9706971,34.6510123,1.8,29.9734439,34.6041094,0.9103303,5.9540359,6.4954652,615.8081301,860.3144609,6.8100972,132.4484757,103.4270105,222.3341685,10.964315,13.0424677,2.4805495,39.5508178),(33626,'tibia.tif',231,8,156,65.0729545,29.8878935,34.5868297,1.8,29.8923601,34.5395605,0.8887772,5.9934334,6.4920932,621.0034289,862.5855782,6.535972,132.8670963,103.6139694,223.2518823,11.0873666,13.0659799,2.4942005,39.5508178),(33627,'tibia.tif',231,8,157,64.8281479,29.7959366,34.5224566,1.8,29.813483,34.4715066,0.8586469,5.9519608,6.5246878,628.9356208,864.1954357,6.1909474,132.4500815,105.6686433,223.096644,11.2061766,13.083895,2.4456106,39.7305644),(33628,'tibia.tif',231,8,158,64.0009679,29.684836,34.4457688,1.8,29.7165262,34.3915243,0.834368,5.9851504,6.567646,633.2226026,861.4356245,5.8549326,131.1635291,105.798945,220.9603259,11.3016465,13.1510129,2.5348255,39.9103109),(33629,'tibia.tif',231,8,159,63.2644549,29.5638413,34.3754674,1.8,29.6072486,34.3181291,0.8140813,5.9393858,6.5527621,636.7676142,860.1100789,5.5743095,131.2591642,107.2110202,218.742864,11.3309802,13.2196231,2.5615899,40.164511),(33630,'tibia.tif',231,8,160,62.4533776,29.4107367,34.313333,1.8,29.4438931,34.2537109,0.8187486,5.9936604,6.6030271,635.0284136,857.358423,5.5513322,129.8432379,105.9500166,216.4262759,11.3610514,13.257451,2.5748634,40.015604),(33631,'tibia.tif',231,8,161,61.8280707,29.3131353,34.2549027,1.8,29.3553439,34.208551,0.7818153,5.9199775,6.6451964,641.4829148,859.3268296,5.1154196,129.3154902,108.359013,215.9716741,11.4258429,13.3261193,2.5668168,40.1208971),(33632,'tibia.tif',231,8,162,61.3043999,29.2032807,34.1872166,1.8,29.2403467,34.1443673,0.7525871,5.9291089,6.6308699,652.2586354,860.1521793,4.7736967,129.7193578,110.0095557,223.6312181,11.4725714,13.1841374,2.5482425,40.0900575),(33633,'tibia.tif',231,8,163,60.5144496,29.101572,34.1242957,1.8,29.1588816,34.0778837,0.7365062,5.9378735,6.6836402,657.4143294,864.871387,4.5505442,129.4012492,110.715448,223.3239555,11.5392664,13.231227,2.5962309,40.2698041),(33634,'tibia.tif',231,8,164,59.8963991,28.9704479,34.0583955,1.8,29.0171206,34.0283077,0.7296766,6.0048745,6.7595822,662.5515815,872.392801,4.4362634,129.0601657,110.3356248,220.926662,11.6140747,13.3696886,2.6354175,40.7345903),(33635,'tibia.tif',231,8,165,59.4641635,28.8289721,34.000122,1.8,28.8822209,33.9537274,0.7011842,6.0409589,6.8360507,676.7197462,879.9811741,4.1246681,128.7265425,112.0219087,222.9286882,11.7369478,13.3847837,2.6142017,41.0196299),(33636,'tibia.tif',231,8,166,58.9578834,28.682394,33.9241414,1.8,28.7517356,33.8784023,0.6785869,6.0782234,6.9434028,689.879261,890.5387686,3.8715604,128.2568202,113.5001496,224.4210088,11.8237932,13.4726011,2.5849933,41.2738299),(33637,'tibia.tif',231,8,167,58.6014729,28.5220667,33.8458808,1.8,28.5808545,33.7902453,0.6547386,6.1619991,6.9894931,704.7243975,903.8596674,3.6217903,129.3169122,114.3661955,226.5175272,11.9375393,13.5145029,2.5979474,41.6641627),(33638,'tibia.tif',231,8,168,57.4742149,28.3157247,33.7996494,1.8,28.3990703,33.7351936,0.6171049,6.1501502,7.0927253,717.8504759,908.5880271,3.2076981,128.1013974,116.7208041,226.1221487,12.0985436,13.5925721,2.6444847,42.0236558),(33639,'tibia.tif',231,8,169,56.8295051,28.1071099,33.7117174,1.8,28.2134655,33.6641891,0.5920342,6.1934011,7.1912222,736.2138178,922.9236319,2.9496406,128.3403031,118.870682,226.8211531,12.2190756,13.6684228,2.6155262,43.2074283),(33640,'tibia.tif',231,8,170,56.5505515,27.900318,33.6344963,1.8,28.0116524,33.5670154,0.5550813,6.2404639,7.368657,757.4764405,940.4881537,2.6177444,127.6335916,121.3814307,227.3179558,12.3803933,13.8229661,2.5790947,43.1021352),(33641,'tibia.tif',231,8,171,56.6010952,27.7078333,33.5753512,1.8,27.7949338,33.4816324,0.555526,6.2977614,7.4289808,784.8371019,959.2963293,2.6238431,129.128928,124.6215991,230.9847218,12.5065928,13.9068554,2.6043079,43.3563352),(33642,'tibia.tif',231,8,172,56.7801184,27.4814831,33.4753259,1.8,27.5891774,33.3764514,0.602484,6.4372451,7.4774655,810.8503006,986.8084822,3.0390473,131.9709845,125.9623157,232.980797,12.6767281,14.0202315,2.7509856,43.8211214),(33643,'tibia.tif',231,8,173,56.1196348,27.2239861,33.3986242,1.8,27.3564804,33.2699727,0.6416099,6.4932997,7.5755482,830.9247555,1005.3621322,3.3502061,132.7114698,127.9664878,233.5168024,12.8475087,14.1863199,2.7461124,44.255068),(33644,'tibia.tif',231,8,174,56.2769488,26.9857113,33.2759585,1.8,27.0505213,33.0963266,0.6249377,6.6085493,7.7444848,859.1186411,1042.3775353,3.21041,134.5961114,130.0010939,237.2092888,13.0637119,14.3645505,2.6026906,44.8379215),(33645,'tibia.tif',231,8,175,57.0191536,26.7606171,33.1503562,1.8,26.7974506,32.9190063,0.6599519,6.759423,7.8313005,893.5956243,1092.5143459,3.5719238,139.5061193,132.1999866,242.7373105,13.2451362,14.5993602,2.4301335,45.8111077),(33646,'tibia.tif',231,8,176,57.3211273,26.4619072,33.1154925,1.8,26.4657223,32.8218399,0.6832651,6.7933872,7.9370297,925.2911618,1138.9704787,3.8078014,143.5008461,136.204684,246.4909354,13.4651808,14.8902422,2.4468544,46.4248009),(33647,'tibia.tif',231,8,177,58.4744035,26.2542278,33.1001213,1.8,26.1893349,32.7589388,0.6374084,6.8343543,8.1340593,972.8197603,1206.7678089,3.451564,148.3598482,142.3425998,257.1411699,13.6607384,15.1270372,2.4812864,47.038494),(33648,'tibia.tif',231,8,178,61.3035393,26.0220286,33.0198292,1.8,25.9330131,32.6377766,0.6535098,6.9733024,8.2308587,1055.8061684,1292.0051585,3.7766635,156.9708834,151.4069094,272.6309801,13.9477649,15.4629059,2.2455373,48.2658803),(33649,'tibia.tif',231,8,179,63.4008749,25.7779968,32.9139805,1.8,25.6647972,32.5746437,0.6604528,7.1458036,8.4501662,1121.932768,1388.609547,3.9768303,164.3292585,157.0058227,284.4260668,14.1897415,15.8544208,2.288118,49.3879734),(33650,'tibia.tif',231,8,180,66.2508282,25.5772589,32.8704407,1.8,25.5071251,32.6036917,0.67833,7.2629727,8.6784787,1188.0358647,1525.3765657,4.3476905,175.7654324,163.5743262,301.0010432,14.452112,16.2871608,2.3065117,50.4356132),(33651,'tibia.tif',231,8,181,68.1019213,25.360984,32.8686818,1.8,25.394963,32.59889,0.6575494,7.3795994,8.9416837,1255.1377254,1634.5331298,4.2397966,182.7992553,170.0820953,312.7955587,14.7392177,16.7781642,2.2703842,51.7682925),(33652,'tibia.tif',231,8,182,71.9793456,25.1757875,32.8540479,1.8,25.1929218,32.5858772,0.6324852,7.5265694,9.2139094,1337.3823594,1808.6231618,4.1923122,196.2927014,177.6881729,330.9614118,15.0334651,17.3014816,2.2834066,52.9339995),(33653,'tibia.tif',231,8,183,77.075958,24.851078,32.8090333,1.8,24.9516873,32.5030699,0.6089993,7.6825178,9.7681715,1435.9727262,2004.9146718,4.2036933,205.2497402,186.9143366,342.937064,15.3653912,18.244497,2.5999784,54.5953324),(33654,'tibia.tif',231,8,184,83.8817415,24.7755562,32.884044,1.8,24.9559369,32.598865,0.5470074,7.8339764,10.0657157,1498.2865411,2205.5172497,3.782213,219.1118153,191.2549213,363.268915,15.6159888,18.8262532,2.5386099,56.5108652),(33655,'tibia.tif',231,8,185,88.634438,24.5644892,32.9490414,1.8,24.7637982,32.5965715,0.5456374,7.9778252,10.5634223,1660.7743971,2380.5028789,3.978543,225.3533768,208.1738262,379.2888989,15.7669247,19.4467169,2.5046274,58.5880792),(33656,'tibia.tif',231,8,186,96.4210783,24.242983,33.0713029,1.8,24.5109391,32.6836972,0.4904987,8.366095,10.9481705,1884.7173369,2702.3829348,3.566022,246.8342022,225.2804139,418.6065755,16.3893259,20.1444494,2.3204954,61.2662122),(33657,'tibia.tif',231,8,187,112.915684,23.9911233,33.0994976,1.8,24.3395298,32.7700377,0.3885483,8.7930114,11.1145982,2135.2183144,3116.1784737,2.7010143,280.3680725,242.8312915,466.8966316,16.5983205,20.2468361,2.2494588,61.7182242),(33658,'tibia.tif',231,8,188,126.9509039,23.9096457,33.1476487,1.8,24.1841096,32.9857377,0.3865427,8.6727821,10.8853757,2141.427724,3215.9995237,3.0070496,295.4422171,246.9135844,485.4337732,15.953274,19.6922998,3.0316482,59.684624),(33659,'tibia.tif',231,8,189,133.0318959,23.619767,33.3153362,1.8,23.8634046,33.2120166,0.3831749,8.2315974,10.61125,1952.8367009,3354.6583444,3.0991237,316.1416748,237.2366638,500.1576361,14.9397999,19.5209231,2.9250423,57.8435446),(33660,'tibia.tif',231,8,190,131.8387457,23.3294463,33.4473168,1.8,23.6800929,33.4131548,0.3077692,7.9754017,10.8221391,1672.6921565,3429.6261577,2.0164436,316.9083413,209.7313992,471.4380146,14.2878395,20.184506,3.0406709,57.9796773),(33661,'tibia.tif',231,8,191,111.8271801,23.0716283,34.3006815,1.8,23.2557919,34.1669025,0.2493633,8.7487108,10.6980978,1188.3150486,3274.460921,1.1351176,306.0787985,135.8274459,417.1520496,14.1498453,20.1159608,3.0148866,77.8050872),(33662,'tibia.tif',231,8,192,74.5849615,21.9961706,35.2055095,1.8,21.8350581,35.0656167,0.4387161,5.4487546,11.0553401,391.3563972,2584.501708,2.2429675,233.7785797,71.8249257,266.0642121,10.2407875,20.7344491,2.5790947,61.2789863),(33663,'tibia.tif',231,8,193,33.7217768,18.3743347,33.1892073,1.8,19.2366275,33.4673409,0.8652917,5.1989703,12.3217649,132.9350135,490.6220338,3.2572649,39.8175128,25.5694891,47.6819044,4.6011251,11.5605127,1.8264413,29.192488),(33664,'tibia.tif',231,8,194,20.8404465,17.7852954,33.1175624,1.8,17.7487949,32.959811,1.32133,1.859814,5.3389894,14.3346644,123.5839113,3.2616927,23.1474352,7.7075796,25.8298869,3.7809267,9.6545823,1.8509043,23.9415152),(33665,'tibia.tif',231,8,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33666,'tibia.tif',231,8,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33667,'tibia.tif',231,8,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33668,'tibia.tif',231,8,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33669,'tibia.tif',231,8,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33670,'tibia.tif',231,8,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33671,'metatarsal.tif',231,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33672,'metatarsal.tif',231,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33673,'metatarsal.tif',231,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33674,'metatarsal.tif',231,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33675,'metatarsal.tif',231,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33676,'metatarsal.tif',231,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33677,'metatarsal.tif',231,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33678,'metatarsal.tif',231,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33679,'metatarsal.tif',231,10,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33680,'metatarsal.tif',231,10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33681,'metatarsal.tif',231,10,11,2.8127555,15.2867547,20.070176,1.8,15.2509542,20.10873,-0.9687665,0.7912378,2.0489127,0.3441446,1.6965146,0.318444,0.8280073,0.4349445,0.9942224,1.6170433,3.589606,0.971621,8.5827824),(33682,'metatarsal.tif',231,10,12,6.3948812,15.1248171,20.3692755,1.8,14.9400811,20.4744782,-0.9647352,1.3896837,2.9186054,2.4808673,10.7040564,0.7199746,3.6675243,1.7852029,4.4817715,2.5706101,5.3075294,0.9109479,13.3255166),(33683,'metatarsal.tif',231,10,13,10.6732511,14.6775971,20.4804054,1.8,14.4818649,20.5638252,-0.6625477,1.8471291,3.8992017,10.1078825,31.4164603,0.6730941,8.0571518,5.4722124,10.1539907,3.6758197,7.0432228,0.6250227,18.9388607),(33684,'metatarsal.tif',231,10,14,16.0246973,14.4073703,20.1371796,1.8,14.2997988,20.2289569,-0.5457475,2.6545733,4.3850567,26.9139968,54.4166079,0.7195632,12.4095563,10.1387281,18.492149,4.9478765,8.0282309,0.6705216,22.0178132),(33685,'metatarsal.tif',231,10,15,29.6246957,13.4714959,18.4055957,1.8,13.4594373,18.5278332,1.1778945,4.7898519,6.6151736,99.6438486,238.0543985,4.2136686,35.986115,20.8031169,51.0302057,7.4911532,11.802851,1.7994317,37.7240917),(33686,'metatarsal.tif',231,10,16,40.2527307,12.6791757,17.8344361,1.8,12.6558234,17.9462649,0.9653731,5.412547,6.6217237,171.4127071,379.7767488,4.5359036,57.3531552,31.6695092,80.247982,8.9923846,13.0492994,1.7942729,37.7095586),(33687,'metatarsal.tif',231,10,17,46.6651543,12.2669788,17.5909678,1.8,12.2722186,17.7095287,0.7833676,6.1566012,6.4859693,260.3753976,524.8377804,3.87297,80.9189425,42.2920685,108.1412247,10.4477692,13.8802826,1.9106668,41.4721687),(33688,'metatarsal.tif',231,10,18,63.1599691,10.5603218,16.8358687,1.8,10.8536314,17.016709,0.4870147,6.4870966,9.0203239,400.5801612,1232.8264144,2.3054911,136.672078,61.7503004,179.323337,11.6334664,17.4967502,2.4939593,57.7187515),(33689,'metatarsal.tif',231,10,19,78.2755347,9.8032243,15.9842546,1.8,10.18402,16.1770242,0.5527347,7.6308046,9.4490819,614.3983399,1682.3965437,3.596011,178.0486792,80.5155386,240.3887865,12.3581236,18.1232329,2.4749512,57.6733892),(33690,'metatarsal.tif',231,10,20,85.6056268,9.5860627,15.7898574,1.8,9.9919399,16.0551071,0.591496,8.1534517,9.8780605,817.01229,1846.3008803,4.4361065,186.909251,100.2044677,268.3412022,12.9559635,18.0317136,2.5012992,57.6631128),(33691,'metatarsal.tif',231,10,21,90.3282926,9.6382752,15.8685629,1.8,10.0093003,16.0677123,0.449059,9.7771491,9.5436376,1245.4032725,1779.2378599,2.8371886,186.4318334,127.3789793,296.685625,15.1340635,18.5495659,0.9936041,70.3618572),(33692,'metatarsal.tif',231,10,22,94.1576673,9.5725159,15.8600098,1.8,9.9634774,16.0045931,-0.299885,8.2546614,9.4013779,1492.178228,1904.112333,1.3694803,202.5354541,180.7679501,312.6573025,15.3378263,19.5409402,0.9509769,72.3293719),(33693,'metatarsal.tif',231,10,23,94.0192909,9.8723355,15.5768312,1.8,10.2139095,15.7090059,-0.4501519,8.7044128,10.0809711,1498.5238701,1999.5411398,2.966528,198.3480673,172.1568017,322.0982399,15.6301541,19.7950227,0.9645587,71.0981436),(33694,'metatarsal.tif',231,10,24,94.8526368,9.9713414,14.9724159,1.8,10.2859292,15.0674062,-0.5767935,9.176766,10.3905719,1494.4529481,2042.602399,4.701444,196.5822884,162.8518097,332.1064032,15.9305298,19.8435522,0.9484291,68.9146104),(33695,'metatarsal.tif',231,10,25,98.2532024,9.7212911,14.3126063,1.8,9.9996655,14.4349184,-0.6579068,9.481457,10.5221444,1585.7080746,2076.6151927,6.1225776,197.3566527,167.2430801,347.5914637,16.1478391,19.813499,0.9696366,73.0220592),(33696,'metatarsal.tif',231,10,26,105.1584389,9.1061545,13.6939117,1.8,9.3628049,13.8576271,-0.7513486,9.9538337,10.7093698,1924.6329412,2095.886594,8.1668983,195.705876,193.3559464,372.4455753,14.2825878,19.8014913,0.9513957,63.4313333),(33697,'metatarsal.tif',231,10,27,107.006825,8.7759282,13.8267634,1.8,9.0414995,14.0725206,-1.4708599,9.7426102,9.4388615,1890.9192615,2180.927096,17.6569449,231.0582793,194.087541,318.041109,14.5180591,19.9507402,1.0260263,70.5826487),(33698,'metatarsal.tif',231,10,28,115.2765639,8.7825315,14.1255405,1.8,9.0610728,14.3679026,1.3423338,10.7683278,10.8104702,1929.2025568,2483.3093387,18.2272745,229.7133519,179.1552591,342.2293149,14.7767567,19.9784939,0.9576986,76.9129731),(33699,'metatarsal.tif',231,10,29,123.9376615,8.6956239,14.3416912,1.8,8.9750325,14.610359,1.2179608,11.2127905,11.6257148,1799.174979,2727.1971036,18.1896744,234.5831756,160.4573799,341.9361808,13.0396904,22.485766,2.2947684,79.3844595),(33700,'metatarsal.tif',231,10,30,126.9970648,8.687712,14.5268386,1.8,8.9697986,14.7601659,1.1329132,11.2054297,12.110389,1572.4907851,2957.5584966,17.3605889,244.2166384,140.3329302,338.0927052,13.0594024,18.484638,1.30969,61.3397714),(33701,'metatarsal.tif',231,10,31,10.9837542,11.1783178,16.7159622,1.8,11.1319323,16.7619524,-0.9876955,1.9620446,7.3305806,9.0074091,213.8449291,1.2756222,29.1716223,4.5908279,30.2504151,0,0,0,0),(33702,'metatarsal.tif',231,10,32,48.0338467,9.3924371,15.0734409,1.8,9.4427739,15.1379716,-1.2621514,7.7442755,7.050638,473.3919124,592.9484972,7.2669212,84.0985587,61.1279795,126.8091573,6.1590415,14.7492007,2.0607537,42.0372824),(33703,'metatarsal.tif',231,10,33,79.5614458,8.7348171,14.4200723,1.8,8.9891636,14.5744751,0.3284817,7.3356733,7.1689575,748.7247871,877.7073075,1.3800575,122.4316512,102.0662665,205.3955877,13.0105451,14.6932748,2.1137475,48.2786454),(33704,'metatarsal.tif',231,10,34,82.9477412,8.3811401,14.3777739,1.8,8.6655926,14.5128819,0.1282962,7.7232981,7.2931236,795.460084,997.8621279,0.2263063,136.8223248,102.9948699,208.2936535,13.2285101,14.8243219,2.0802634,48.0493407),(33705,'metatarsal.tif',231,10,35,73.8967953,8.0874668,14.2546809,1.8,8.453542,14.4106727,0.3822665,7.0152057,6.6592932,713.844989,854.8221348,1.7137552,128.3652958,101.7568157,179.8438708,12.8774936,14.6676377,1.9815133,46.4587406),(33706,'metatarsal.tif',231,10,36,62.6308589,7.7537068,14.0281913,1.8,8.0546962,14.2349957,0.4933175,6.9928259,6.3466977,586.1434738,720.7364839,2.3408286,113.5608656,83.8206871,153.9369673,12.2795838,14.1460643,1.986426,45.1718736),(33707,'metatarsal.tif',231,10,37,54.5363012,7.5276674,13.9310341,1.8,7.7340115,14.1371135,0.6233626,6.6956059,6.0376621,460.1924523,615.9067141,3.0975326,102.0107948,68.7305163,138.0038838,11.6441112,13.471297,1.9792117,42.5690735),(33708,'metatarsal.tif',231,10,38,51.0961487,7.56321,13.8187434,1.8,7.7403003,13.9623741,0.5522441,6.0738873,6.1178201,408.2803495,556.6730793,2.3436458,90.9920637,67.2189541,129.445527,10.933687,12.4746318,1.9695999,40.0509781),(33709,'metatarsal.tif',231,10,39,48.2805661,7.7572154,13.6489157,1.8,7.9229644,13.7257338,0.3138796,5.6248315,6.675774,361.4682025,537.9327072,0.7670749,80.5798258,64.2629385,126.0687248,10.5278679,12.3387534,0.0880074,37.4759973),(33710,'metatarsal.tif',231,10,40,46.7512904,8.0063753,13.5252737,1.8,8.1711457,13.5902108,0.190487,5.648433,7.0620722,333.8863757,545.5367534,0.2793276,77.2488218,59.1113282,121.0170904,10.2401088,12.6731409,0.0570808,37.2642355),(33711,'metatarsal.tif',231,10,41,46.3176243,8.181325,13.456422,1.8,8.359055,13.500948,0.1211039,5.4492727,7.1646645,322.017717,547.923833,0.1126644,76.4758532,59.0937054,120.3561902,9.9468574,12.804451,0.0338853,36.9296732),(33712,'metatarsal.tif',231,10,42,44.7604839,8.2563496,13.3777893,1.8,8.4228948,13.4149289,0.087992,5.2903433,7.2004405,298.8344667,533.3026014,0.0576115,74.0652743,56.4867818,115.2675432,9.6876139,12.8175081,3.0851555,36.5031397),(33713,'metatarsal.tif',231,10,43,43.7118176,8.3151499,13.3205981,1.8,8.4740659,13.3494256,0.0677516,5.1469755,6.9951846,278.0438072,522.1021569,0.0333904,74.6373666,54.0208139,113.9374151,9.421486,12.6100823,0.0688565,35.6924251),(33714,'metatarsal.tif',231,10,44,43.4609125,8.4470549,13.258879,1.8,8.6121238,13.2926465,0.0492827,5.0191943,7.1266289,263.6241558,536.0268819,0.0175786,75.214648,52.5232024,112.0147099,9.1608786,12.849279,3.0514422,36.1189586),(33715,'metatarsal.tif',231,10,45,44.2132156,8.6085703,13.2102947,1.8,8.7661769,13.2601579,0.0384629,4.869636,7.2289196,256.3322253,560.6575795,0.0108961,77.5575897,52.6388887,113.0150879,8.9403164,13.0340685,3.0860941,35.6676156),(33716,'metatarsal.tif',231,10,46,44.7536725,8.7492661,13.166417,1.8,8.9146232,13.2207062,0.0261933,4.8804156,7.1749041,246.8579803,584.4327341,0.0051163,81.4551282,50.581344,115.4581783,8.7409266,13.1150293,3.0753912,36.288368),(33717,'metatarsal.tif',231,10,47,46.0675872,8.9312635,13.1153037,1.8,9.0889728,13.1624348,0.0166524,4.6813236,7.2058081,245.4248075,615.0171167,0.0021289,85.3501933,52.4263704,118.6964592,8.5639009,13.3020218,3.0381382,37.028911),(33718,'metatarsal.tif',231,10,48,46.8447625,9.0366915,13.0638678,1.8,9.1877499,13.1126052,0.0089628,4.655271,7.0241966,240.7321814,630.6457434,0.0006272,89.781904,51.7117436,122.4441083,8.4360326,13.2008402,3.009765,36.8915775),(33719,'metatarsal.tif',231,10,49,47.0942053,9.0664888,13.0220884,1.8,9.2032311,13.0708491,0.005135,4.6221705,6.9776669,234.0206835,626.2902293,0.000207,89.7563954,50.6300419,119.7999899,8.3336762,13.2419583,0.1534795,36.7717869),(33720,'metatarsal.tif',231,10,50,47.8533247,9.1204512,12.9962278,1.8,9.2651837,13.0525274,0.006142,4.5717641,6.9957656,229.8828152,629.28147,0.0003009,89.951766,50.2831756,120.8992457,8.2715932,13.1915314,0.1263944,36.8740345),(33721,'metatarsal.tif',231,10,51,48.3975397,9.1751098,12.970733,1.8,9.3155886,13.0252306,0.0064009,4.4599108,6.8696109,225.5135786,636.2321156,0.0003305,92.6154517,50.5645937,121.0904405,8.1755327,13.1343458,0.1714834,36.4723105),(33722,'metatarsal.tif',231,10,52,48.80282,9.2153656,12.9465914,1.8,9.3572107,13.0021975,0.0117205,4.4165125,6.8228452,222.3759619,640.699334,0.0011173,93.9050082,50.3510324,122.3655929,8.1051876,13.088098,0.1497094,36.4372246),(33723,'metatarsal.tif',231,10,53,49.2053279,9.251962,12.9331157,1.8,9.3904566,12.9875121,0.022969,4.3686298,6.7704744,218.8632342,639.9012783,0.0043258,94.5135067,50.0988287,123.0272899,8.0352702,13.0059648,0.1450417,36.2151864),(33724,'metatarsal.tif',231,10,54,49.4623461,9.242212,12.9112097,1.8,9.3768656,12.965091,0.0285475,4.2589688,6.7693384,217.9354321,628.9056489,0.0067165,92.9050397,51.170939,121.7779172,7.9674237,12.9503818,0.1118903,36.0705864),(33725,'metatarsal.tif',231,10,55,49.5179639,9.235374,12.8969226,1.8,9.3579829,12.9475005,0.0365885,4.2126444,6.6201946,216.0276145,619.551652,0.0110435,93.5851123,51.2807613,121.7321761,7.8775051,12.7913807,0.1474925,35.8134624),(33726,'metatarsal.tif',231,10,56,49.8280965,9.2354278,12.8915314,1.8,9.3524765,12.9469269,0.0464872,4.2196383,6.5262798,216.3460202,611.9961997,0.017934,93.7741287,51.2712236,121.9494682,7.8637386,12.6483685,0.1491726,35.5666147),(33727,'metatarsal.tif',231,10,57,50.0378331,9.2392598,12.8696056,1.8,9.3527961,12.9172892,0.0571973,4.1876867,6.4370674,215.1003371,606.3397956,0.0272536,94.1950362,51.3649543,122.0412065,7.8305599,12.5462902,0.1329323,35.1648906),(33728,'metatarsal.tif',231,10,58,50.1618951,9.239232,12.8455887,1.8,9.3483419,12.8863642,0.0631593,4.1502387,6.3472437,215.3727096,598.04772,0.0333058,94.2216419,51.8940537,122.2291814,7.8318078,12.4231941,0.1460123,36.5788148),(33729,'metatarsal.tif',231,10,59,50.0347964,9.2100406,12.8246277,1.8,9.3175977,12.86857,0.071567,4.1264511,6.290164,214.5188999,584.946318,0.0426388,92.9938109,51.9862935,120.9854884,7.751069,12.3039652,0.1177953,34.7982524),(33730,'metatarsal.tif',231,10,60,50.2073348,9.2039721,12.8026598,1.8,9.3085175,12.8429141,0.0790039,4.0801079,6.2004858,215.6838047,576.5893361,0.0521205,92.9909931,52.8622797,120.8401105,7.7399923,12.1981484,0.1427353,34.8406048),(33731,'metatarsal.tif',231,10,61,50.5324132,9.1983381,12.7812961,1.8,9.2991732,12.8231493,0.0891257,4.1078347,6.1152275,218.5433,567.5131458,0.0667229,92.8032766,53.2015814,120.4742209,7.7613426,12.106743,0.1317623,34.8333383),(33732,'metatarsal.tif',231,10,62,50.3807899,9.1752133,12.7430621,1.8,9.276392,12.7768292,0.0947525,4.0903198,6.0445498,217.4528823,556.106549,0.0751615,92.0013174,53.1628076,119.2490983,7.7730562,12.0052844,0.1572281,34.2271189),(33733,'metatarsal.tif',231,10,63,50.4723181,9.1571893,12.7071273,1.8,9.2535242,12.7426411,0.0990848,4.1223126,5.977396,219.6066817,545.7939807,0.0823178,91.3096573,53.2726899,119.1330791,7.7986803,11.8917572,0.1341586,34.1000618),(33734,'metatarsal.tif',231,10,64,50.6891808,9.1605216,12.6782476,1.8,9.2576967,12.7116496,0.1066049,4.1183526,5.8805023,222.4115707,538.5148703,0.0956472,91.5763394,54.0049855,119.1606013,7.8084004,11.7911087,0.1601084,34.1424142),(33735,'metatarsal.tif',231,10,65,50.5486717,9.1531448,12.6501593,1.8,9.2441864,12.6874133,0.1133791,4.1381536,5.8032716,223.661485,529.2538798,0.1078357,91.1992268,54.0486179,118.8079241,7.8786003,11.6974166,0.1488899,33.920376),(33736,'metatarsal.tif',231,10,66,50.536648,9.148273,12.6071959,1.8,9.2406897,12.6499118,0.1181057,4.1553091,5.7850456,225.8264344,520.2255592,0.1169437,89.9259224,54.3464824,118.2819921,7.8822733,11.6492784,0.1181965,34.1599571),(33737,'metatarsal.tif',231,10,67,50.318362,9.1488182,12.5580478,1.8,9.2382497,12.5945492,0.1191585,4.172617,5.7159655,226.1466079,510.3081444,0.1185138,89.2776802,54.1977877,117.099798,7.9098789,11.5544363,0.1507464,33.8780236),(33738,'metatarsal.tif',231,10,68,50.3691275,9.1514041,12.5102704,1.8,9.2405751,12.5388138,0.1189472,4.2115273,5.710997,228.8952592,501.4848015,0.1182149,87.8103776,54.3497034,117.272311,7.9531218,11.5057,0.1196785,33.775776),(33739,'metatarsal.tif',231,10,69,50.2406049,9.144652,12.474789,1.8,9.2311518,12.5042381,0.126368,4.235998,5.6231235,231.5147044,490.9248106,0.133004,87.3046467,54.6541113,116.1281681,7.9951418,11.4114969,0.1526493,33.6910712),(33740,'metatarsal.tif',231,10,70,50.1759506,9.1459122,12.4405619,1.8,9.2315808,12.4742056,0.1336035,4.2533824,5.5365202,234.8022349,481.1348074,0.1483865,86.9020226,55.203651,116.594263,8.051576,11.2903811,0.1219722,33.5464712),(33741,'metatarsal.tif',231,10,71,50.3276956,9.1608401,12.3983452,1.8,9.252616,12.4286817,0.1395255,4.2947659,5.4600072,238.6438568,473.6703479,0.1622344,86.752697,55.5662087,117.8490694,8.1163846,11.1656114,0.1364026,33.4018712),(33742,'metatarsal.tif',231,10,72,50.1961045,9.1567231,12.356425,1.8,9.2424088,12.3870711,0.1411878,4.3173314,5.456768,240.5798742,463.3888889,0.165663,84.9200276,55.7242081,116.6465931,8.1656675,11.1041131,0.1437387,33.4793094),(33743,'metatarsal.tif',231,10,73,49.9744046,9.1631414,12.3112268,1.8,9.2469734,12.3435962,0.1438416,4.3356309,5.3907396,242.0530109,453.0952497,0.1711465,84.0506651,55.8287858,116.0078207,8.2098569,11.0126458,0.1316839,33.1302141),(33744,'metatarsal.tif',231,10,74,49.7691162,9.1620606,12.2752378,1.8,9.2427501,12.3129775,0.1493824,4.3599213,5.3766199,243.0654257,443.1312448,0.1837278,82.4181835,55.7499569,114.7193147,8.233883,10.9610239,0.1456284,32.9432618),(33745,'metatarsal.tif',231,10,75,49.6791637,9.1793233,12.2213938,1.8,9.2561359,12.2595259,0.1477595,4.404744,5.3597697,245.6984419,433.7154512,0.1794614,80.9205394,55.7804134,114.2268255,8.2680545,10.8894942,0.1465919,32.9432618),(33746,'metatarsal.tif',231,10,76,49.4346423,9.1901728,12.1717099,1.8,9.264663,12.208067,0.1484279,4.4194921,5.3444747,245.8928711,424.1863739,0.1801854,79.369143,55.6382642,113.1492856,8.3237046,10.8271518,0.1003331,32.7986618),(33747,'metatarsal.tif',231,10,77,49.3765544,9.2088344,12.120931,1.8,9.2844962,12.1593498,0.1519225,4.4478674,5.3162797,247.8035679,415.5567518,0.188482,78.1668335,55.7128949,113.0895645,8.3562326,10.7165093,0.1285391,32.5941665),(33748,'metatarsal.tif',231,10,78,49.2984712,9.2182092,12.0823085,1.8,9.2901883,12.1194876,0.1592774,4.4845397,5.3131885,248.8324809,407.013813,0.2066879,76.6044371,55.4867381,111.7618376,8.4147366,10.7074816,0.1218424,32.6891476),(33749,'metatarsal.tif',231,10,79,49.0510006,9.2319461,12.0354043,1.8,9.2996128,12.0749798,0.1652177,4.50369,5.2701234,249.2974972,398.01103,0.2211336,75.5221457,55.3540529,110.4104722,8.4298159,10.6357212,0.1226687,32.4320235),(33750,'metatarsal.tif',231,10,80,48.923055,9.2503668,11.9914134,1.8,9.3212536,12.0257183,0.1753069,4.5250912,5.2398271,250.0392673,389.4256559,0.2480314,74.3203253,55.2561826,110.5375168,8.463608,10.5136238,0.075717,32.3473188),(33751,'metatarsal.tif',231,10,81,48.8330832,9.2798376,11.9508662,1.8,9.3440596,11.9877964,0.181609,4.5505794,5.1927412,250.7732277,380.9278619,0.2654959,73.3577604,55.1079781,109.926982,8.4841233,10.4362745,0.0693331,32.2874235),(33752,'metatarsal.tif',231,10,82,48.4687947,9.3048094,11.9052699,1.8,9.3631449,11.9405833,0.1904031,4.5802823,5.1316562,250.3664862,370.7269772,0.2893374,72.2431438,54.6618019,108.819764,8.5202673,10.3641494,0.0698164,32.3721283),(33753,'metatarsal.tif',231,10,83,48.3903692,9.3353154,11.8642302,1.8,9.3958291,11.8989597,0.196582,4.6022762,5.0681747,252.301212,362.5951916,0.3076758,71.5435465,54.8209631,108.8831234,8.5378735,10.2973583,0.0773104,32.1851759),(33754,'metatarsal.tif',231,10,84,47.9695345,9.3557549,11.8238768,1.8,9.412089,11.8621015,0.2193326,4.6347322,4.9649534,252.1808067,351.2896147,0.378482,70.7538592,54.4110853,108.019538,8.5401959,10.2150464,0.0637433,31.8112712),(33755,'metatarsal.tif',231,10,85,47.8323746,9.3959686,11.7731318,1.8,9.4553074,11.8082234,0.2277665,4.6663374,4.9023171,254.3662748,343.0779438,0.4064688,69.9828135,54.510905,107.7765407,8.5419729,10.0619164,0.1297025,31.8112712),(33756,'metatarsal.tif',231,10,86,47.503787,9.4178999,11.7355203,1.8,9.4726286,11.7746202,0.272456,4.6975668,4.8976472,255.0565017,335.8070216,0.5733195,68.5649682,54.2954496,106.7266234,8.5496207,10.0207909,2.4995345,31.7513759),(33757,'metatarsal.tif',231,10,87,47.3628746,9.4517752,11.6820095,1.8,9.5090244,11.7198137,0.2908045,4.7463574,4.8544313,257.5929727,329.0549789,0.6489512,67.7844545,54.2717186,106.738046,8.6148438,10.0278306,2.535592,32.280157),(33758,'metatarsal.tif',231,10,88,46.9951139,9.4834849,11.6282343,1.8,9.5409591,11.6647828,0.3186589,4.7705305,4.8309985,257.7658508,320.6143683,0.7687827,66.3660672,54.0329534,105.6156791,8.6583259,9.9936286,2.4792804,31.8112712),(33759,'metatarsal.tif',231,10,89,46.733793,9.5160823,11.576384,1.8,9.5677004,11.6150547,0.369222,4.7998269,4.8836123,257.9801318,313.5927166,1.0144473,64.21327,53.7477994,104.4738263,8.6822913,9.9870882,2.5676453,31.5396141),(33760,'metatarsal.tif',231,10,90,46.5764091,9.5611411,11.5331924,1.8,9.6126551,11.5725888,0.4316113,4.8009384,4.9265526,258.6666237,308.8102049,1.3585102,62.6828196,53.8783467,104.8129138,8.710718,9.9776624,2.5053378,31.7441094),(33761,'metatarsal.tif',231,10,91,46.2197614,9.6021953,11.4898073,1.8,9.6521856,11.5311523,0.4950063,4.7776322,4.9221962,257.7537523,302.5967306,1.7383275,61.4759584,53.9501039,104.518379,8.7336439,9.9493316,2.4850109,31.4373664),(33762,'metatarsal.tif',231,10,92,45.7553247,9.6471728,11.4443859,1.8,9.691682,11.4854684,0.5684754,4.7498033,4.953273,256.9931452,297.3579201,2.2101229,60.0326132,54.1060605,104.4105677,8.7912314,9.9145952,2.4543239,31.3351188),(33763,'metatarsal.tif',231,10,93,45.2569638,9.6926185,11.3967593,1.8,9.7329492,11.4387204,0.6620808,4.6645381,4.9715489,255.2685067,294.4941637,2.8506535,59.2358981,54.7253561,104.7180931,8.8266853,9.9367142,2.4748061,31.3950141),(33764,'metatarsal.tif',231,10,94,44.8299188,9.7418291,11.3486263,1.8,9.7844535,11.3903365,0.7554186,4.780766,4.9362948,253.5091335,291.4891418,3.5119641,59.0501896,53.0268861,104.5545937,8.8773253,9.8921624,2.4805495,31.3526617),(33765,'metatarsal.tif',231,10,95,44.4860941,9.7929113,11.2947372,1.8,9.8347152,11.3334089,0.8483121,5.1371123,4.8583617,252.0014184,289.2506266,4.1724102,59.5366593,49.0550726,102.4645203,8.8929004,9.8234927,2.4657023,30.9860235),(33766,'metatarsal.tif',231,10,96,44.1397217,9.8330652,11.2439676,1.8,9.8717704,11.2825369,0.9517234,5.0066692,4.7675355,249.0896437,287.6351479,4.8794598,60.3320411,49.7515682,104.3740368,8.9381178,9.8032513,2.4449658,30.8837758),(33767,'metatarsal.tif',231,10,97,43.8078872,9.8827871,11.1906883,1.8,9.9248029,11.2294026,1.0554083,5.0711614,4.6835519,246.1763497,286.7688804,5.5276551,61.2289322,48.5443731,104.6236918,8.954229,9.7479068,2.4402068,30.8414235),(33768,'metatarsal.tif',231,10,98,43.5059569,9.9394362,11.1460576,1.8,9.978885,11.1862244,1.130811,5.0535202,4.6355145,242.7462854,287.0102952,5.9355675,61.9155204,48.0350878,104.8243954,8.8677798,9.7269706,2.4087776,30.7815282),(33769,'metatarsal.tif',231,10,99,43.2220885,9.9966249,11.1045942,1.8,10.035847,11.1434096,1.1923097,5.0189514,4.6002407,239.0938209,287.660204,6.2200831,62.5315544,47.6382024,104.9056011,8.7829068,9.6852325,2.4248694,30.6369282),(33770,'metatarsal.tif',231,10,100,42.9059183,10.0610405,11.0566141,1.8,10.0993084,11.097641,1.2388714,4.9770736,4.6586547,236.2704242,288.5009644,6.3916445,61.9279561,47.471756,104.9166193,8.6991504,9.6733514,2.4037776,30.5346805),(33771,'metatarsal.tif',231,10,101,42.5543636,10.1173522,11.0095461,1.8,10.1515013,11.0524849,1.2877578,4.899832,4.7344636,231.7839324,289.4697556,6.5392276,61.1409824,47.3044651,104.5649805,8.6028393,9.6248658,2.4093359,30.4499758),(33772,'metatarsal.tif',231,10,102,42.2586576,10.1758248,10.9665884,1.8,10.2133221,11.0131658,1.328129,4.7973069,4.7991295,227.4454335,290.6130082,6.6364365,60.5553582,47.4110655,103.6090975,8.5215047,9.5766806,2.2974387,30.2031282),(33773,'metatarsal.tif',231,10,103,41.7595111,10.2326406,10.9211528,1.8,10.2670049,10.9758652,1.3604135,4.6737219,4.8717183,222.2927133,291.0184418,6.6563841,59.7363036,47.5622465,102.1950861,8.4115059,9.5638449,2.2490792,30.0585282),(33774,'metatarsal.tif',231,10,104,41.2640236,10.2925391,10.8722809,1.8,10.3222461,10.926409,1.3836447,4.5878222,4.9237671,217.4814925,290.647736,6.6392527,59.0295456,47.4040808,101.0412561,8.3267385,9.5441482,2.2703842,29.8963852),(33775,'metatarsal.tif',231,10,105,40.8657675,10.3529429,10.8284862,1.8,10.3827159,10.8885628,1.4070974,4.4978382,4.9713604,212.663564,291.0633169,6.6300701,58.5480219,47.2812835,99.7644171,8.244546,9.5578307,1.7533562,29.8116805),(33776,'metatarsal.tif',231,10,106,40.4747092,10.4157724,10.7814046,1.8,10.4463431,10.8467007,1.4257919,4.4193391,5.0299544,207.3490583,292.1494228,6.6049374,58.0819229,46.9185675,98.4955712,8.1335942,9.6039336,1.7371826,29.7094329),(33777,'metatarsal.tif',231,10,107,40.0289985,10.4774136,10.7319737,1.8,10.5024223,10.7940208,1.44995,4.3798037,5.0739697,202.9430172,292.7484016,6.5745436,57.696127,46.3360991,97.0786471,8.0481012,9.6319236,1.706324,29.7693281),(33778,'metatarsal.tif',231,10,108,39.8088752,10.543732,10.6863998,1.8,10.5713008,10.7521717,1.4628454,4.3005715,5.0934976,199.4395767,294.6427106,6.5577943,57.8468342,46.3751329,96.9825308,7.9785462,9.6752425,1.735945,29.7094329),(33779,'metatarsal.tif',231,10,109,39.4830947,10.609891,10.6419711,1.8,10.6385312,10.7082497,1.4783819,4.2124657,5.1392969,195.6925864,295.5725101,6.5244751,57.5122459,46.4555919,95.5890375,7.8756023,9.7350283,1.7273982,29.6495376),(33780,'metatarsal.tif',231,10,110,39.2172859,10.6818997,10.5893778,1.8,10.7081472,10.6437436,1.4934135,4.1756741,5.1859215,192.5408457,296.6342285,6.4971529,57.1999067,46.1101232,94.3267408,7.7951046,9.7712057,1.7493262,29.6071852),(33781,'metatarsal.tif',231,10,111,38.8939519,10.7644624,10.5356019,1.8,10.7868315,10.5847916,1.5030534,4.0831778,5.1813886,189.687259,296.6775246,6.4526227,57.2583039,46.4557925,93.7700673,7.7132873,9.8032513,1.8014647,29.5472899),(33782,'metatarsal.tif',231,10,112,38.6858865,10.8538266,10.4931291,1.8,10.8788162,10.5403639,1.5097953,4.0517983,5.2166226,186.7001294,297.8700585,6.423685,57.1001741,46.0783375,92.8346442,7.661974,9.8423649,1.7480217,29.5049376),(33783,'metatarsal.tif',231,10,113,38.3627883,10.9272183,10.4394319,1.8,10.9451986,10.4906898,1.5194015,4.0243023,5.2607986,184.323175,298.5474845,6.3769241,56.7494614,45.8025176,91.7755772,7.611663,9.8778846,1.7251151,29.5472899),(33784,'metatarsal.tif',231,10,114,37.9475484,11.0221824,10.3803954,1.8,11.0371104,10.4366017,1.5238044,3.9261316,5.2596607,182.2577034,298.5687774,6.3106354,56.765787,46.4217,91.1906417,7.5408418,9.9135407,1.746736,29.5049376),(33785,'metatarsal.tif',231,10,115,37.7879602,11.1155456,10.3242417,1.8,11.1326733,10.3864634,1.5305257,3.8946283,5.3123054,180.3462206,300.329141,6.2877853,56.5346156,46.3064011,90.2485303,7.5133021,9.972422,1.7383288,29.5049376),(33786,'metatarsal.tif',231,10,116,37.532636,11.2110405,10.2749445,1.8,11.2265568,10.3363141,1.5329048,3.8634981,5.3570221,178.3494806,301.1677661,6.2464623,56.21925,46.1626935,89.3729522,7.4661169,10.0207909,1.7228971,29.5472899),(33787,'metatarsal.tif',231,10,117,37.2522993,11.3099867,10.2236009,1.8,11.32253,10.2779023,1.5386011,3.8764325,5.3404117,176.9047771,302.2658307,6.2022832,56.5997246,45.6359755,89.3027746,7.4304525,10.0559403,1.744219,29.5472899),(33788,'metatarsal.tif',231,10,118,37.2296572,11.413133,10.1714301,1.8,11.4228339,10.2270603,1.5448337,3.8913372,5.3865415,175.8399939,305.4504662,6.2007613,56.7062308,45.1875496,89.0417674,7.4039272,10.0922621,1.7218117,29.6495376),(33789,'metatarsal.tif',231,10,119,37.0333795,11.5146289,10.1118272,1.8,11.5222504,10.1622221,1.5499871,3.8607373,5.3753675,175.0949029,306.9307223,6.1695576,57.0994866,45.3527108,88.9952929,7.3899658,10.0956283,1.7653829,29.6319947),(33790,'metatarsal.tif',231,10,120,37.0928209,11.602352,10.0535878,1.8,11.592801,10.1077893,1.5585094,3.865912,5.4266651,175.4225686,309.2698092,6.1812036,56.9907672,45.3767616,88.7357815,7.3826614,10.1398016,1.7500121,29.6495376),(33791,'metatarsal.tif',231,10,121,36.7882575,11.7149206,9.9888784,1.8,11.7044896,10.0357042,-1.5694034,3.835441,5.4109196,174.0146621,311.1490929,6.1313643,57.5039212,45.3701836,88.8772976,7.4002034,10.1271634,1.7429871,29.5896423),(33792,'metatarsal.tif',231,10,122,36.706941,11.8267209,9.9262376,1.8,11.8176004,9.9705468,-1.5585314,3.8146949,5.4693306,173.5211877,313.6926409,6.1169033,57.3548506,45.4875667,88.7832014,7.4127383,10.1531963,1.6492067,29.7094329),(33793,'metatarsal.tif',231,10,123,36.3933465,11.93334,9.8808822,1.8,11.916999,9.9225499,-1.5453419,3.8541224,5.4432116,172.9479581,314.0984552,6.0616286,57.7046198,44.8734994,88.9267536,7.4140102,10.147789,1.6421038,29.6670805),(33794,'metatarsal.tif',231,10,124,36.0591706,12.0539169,9.8376029,1.8,12.0375141,9.8679447,-1.5370251,3.843882,5.4188096,171.6939268,314.0525343,6.0030102,57.9560008,44.6668051,89.1169118,7.4209393,10.1336135,1.6995761,29.5648329),(33795,'metatarsal.tif',231,10,125,35.5988211,12.1837663,9.7868054,1.8,12.1612458,9.8178018,-1.5286527,3.8882612,5.465214,170.2479431,313.4895901,5.9226054,57.3608991,43.78511,88.2274512,7.4247541,10.165545,1.663388,29.6247281),(33796,'metatarsal.tif',231,10,126,35.1842671,12.3185591,9.7624398,1.8,12.2987353,9.7794118,-1.5218157,3.8974035,5.4224891,169.4020661,313.0830868,5.8499873,57.7378916,43.4653647,88.4277959,7.4303763,10.1799329,1.677532,29.6071852),(33797,'metatarsal.tif',231,10,127,34.9818919,12.4448428,9.6971019,1.8,12.4255373,9.7063241,-1.5089581,3.8969034,5.4804524,168.401577,315.5286488,5.8080488,57.5734674,43.214204,87.8538866,7.4499642,10.2252758,1.6486528,29.7094329),(33798,'metatarsal.tif',231,10,128,34.3120701,12.5872923,9.6703404,1.8,12.564596,9.6741702,-1.5024062,3.907849,5.5002581,166.6604449,314.0053361,5.6919725,57.0892006,42.6476159,87.0791214,7.43588,10.2790672,1.5215404,29.8715758),(33799,'metatarsal.tif',231,10,129,33.7975731,12.7138238,9.6250539,1.8,12.6905532,9.6189346,-1.5019398,3.9343714,5.4868156,165.0167704,314.6113921,5.6062641,57.3395233,41.9423466,86.6610169,7.4815623,10.2770329,1.4438235,29.8116805),(33800,'metatarsal.tif',231,10,130,33.3461659,12.8622918,9.6079014,1.8,12.8418316,9.6003967,-1.4992962,3.9537084,5.5037267,163.4453023,317.3868897,5.5293302,57.6676322,41.3397463,86.8890932,7.4550794,10.3315668,1.4585935,29.8963852),(33801,'metatarsal.tif',231,10,131,33.0519068,13.0020808,9.586474,1.8,12.9908089,9.5777734,-1.4957551,3.9658466,5.5132068,162.830046,320.0991644,5.477689,58.0604317,41.0580802,87.1370666,7.4605368,10.3815353,1.4801364,30.0409852),(33802,'metatarsal.tif',231,10,132,32.8459437,13.1398603,9.5368373,1.8,13.1341052,9.5268817,-1.4886015,3.9726989,5.5111309,162.1332369,323.2307847,5.4374226,58.6505364,40.8118614,87.5769564,7.4524607,10.3883306,1.4732052,30.12569),(33803,'metatarsal.tif',231,10,133,32.3642607,13.2704563,9.514416,1.8,13.2683066,9.5115322,-1.4842324,4.0014751,5.5254732,161.3899795,324.1150454,5.3537251,58.6583323,40.3326208,87.4751738,7.4920152,10.4362745,1.5014632,30.2031282),(33804,'metatarsal.tif',231,10,134,32.2085894,13.4130991,9.4823338,1.8,13.4131302,9.4792125,-1.4782332,4.0195027,5.5290744,161.9055666,326.4405671,5.3222359,59.0407258,40.2799994,87.8484813,7.494179,10.4535404,1.4807626,30.3301852),(33805,'metatarsal.tif',231,10,135,32.3932042,13.5753744,9.4484104,1.8,13.5989846,9.4560236,-1.4792133,4.0465824,5.5392951,163.978717,330.168772,5.3537111,59.6048356,40.5227673,89.2071987,7.4878776,10.5014355,1.4396097,30.3301852),(33806,'metatarsal.tif',231,10,136,32.1918362,13.7120131,9.4039061,1.8,13.7320479,9.4078535,-1.476252,4.0540831,5.5759472,165.5745307,332.8956863,5.3174902,59.7020868,40.8414246,89.3764624,7.5067817,10.5553053,1.4540877,30.5770329),(33807,'metatarsal.tif',231,10,137,32.03504,13.8323727,9.366874,1.8,13.8569943,9.3668395,-1.4768629,4.0603037,5.6106136,168.0448491,338.1117614,5.2922016,60.2628849,41.3872611,90.1851238,7.5501304,10.6271168,1.45488,30.7815282),(33808,'metatarsal.tif',231,10,138,32.0209616,13.9914409,9.3029208,1.8,14.011677,9.2905248,-1.4598579,4.0987936,5.6885532,170.7582591,346.4215767,5.2714139,60.8980108,41.6606138,90.9053298,7.5851839,10.7416006,1.4831834,31.0882711),(33809,'metatarsal.tif',231,10,139,32.0118695,14.1311001,9.2560366,1.8,14.1573052,9.255537,-1.4577157,4.1223704,5.7506984,177.0099884,353.0184131,5.267378,61.3870507,42.9388852,92.1659885,7.6813616,10.8425902,1.4571936,31.4198235),(33810,'metatarsal.tif',231,10,140,32.5651888,14.2759659,9.1915373,1.8,14.292936,9.1724472,-1.4689033,4.1497048,5.8288513,185.708512,367.3382467,5.3713765,63.0206925,44.7522223,94.8029147,7.779238,10.9710342,1.4717834,31.8112712),(33811,'metatarsal.tif',231,10,141,32.8802247,14.4486501,9.1688625,1.8,14.4651796,9.145848,-1.4646172,4.1848121,5.9195654,192.4725704,386.3000812,5.4184873,65.2581831,45.9931208,97.7036631,7.8756023,11.1738012,1.4865804,32.3896712),(33812,'metatarsal.tif',231,10,142,33.6503451,14.659644,9.1272199,1.8,14.6658139,9.1232197,-1.4736704,4.2703292,6.0167077,200.9873478,413.2516541,5.5556506,68.6840176,47.0660081,101.2533777,7.9839649,11.3741027,1.507188,33.0279665),(33813,'metatarsal.tif',231,10,143,34.8052011,14.864473,9.0998985,1.8,14.8450992,9.1151918,-1.4634161,4.3503872,6.1766497,212.5451239,449.7203734,5.7342366,72.8097588,48.8565993,106.6405623,8.1259968,11.6492784,1.4525998,33.8108618),(33814,'metatarsal.tif',231,10,144,35.640879,15.1027683,9.005294,1.8,15.0783196,9.0132252,-1.4848086,4.4392199,6.3380003,227.5630704,477.3525747,5.8963339,75.3159595,51.2619503,110.2198173,8.306509,11.8823026,1.4426678,34.6185666),(33815,'metatarsal.tif',231,10,145,36.9209747,15.4228944,9.0377924,1.8,15.3555847,9.0573425,-1.4832361,4.6274541,6.459874,249.4512529,517.6286417,6.1064387,80.1298351,53.9068019,117.4535486,8.6266164,12.1885026,1.4876551,35.6906619),(33816,'metatarsal.tif',231,10,146,38.2619614,15.7330136,9.028972,1.8,15.6748445,9.0884793,-1.4611038,4.8162324,6.6553037,274.929387,567.416157,6.3005699,85.257741,57.0839119,125.2693562,9.0665776,12.4892893,1.47804,37.1469384),(33817,'metatarsal.tif',231,10,147,39.1599031,16.0234383,8.9389325,1.8,15.9844328,9.0057015,-1.4694166,4.9432079,6.8956904,304.2520082,598.4017837,6.4598002,86.779097,61.5495074,129.3014872,9.4731005,12.8631033,1.4694498,38.6806531),(33818,'metatarsal.tif',231,10,148,43.2774401,16.409998,8.905286,1.8,16.3573575,8.926852,-1.4735597,5.1695665,7.1148427,357.6502804,697.6956068,7.1449236,98.0619858,69.1838053,147.0179372,9.9804976,13.6116158,1.5176549,40.9549107),(33819,'metatarsal.tif',231,10,149,48.0072929,16.9478572,8.828664,1.8,16.9259603,8.8298387,-1.4729346,6.1917556,7.5249193,462.0038091,801.0562931,7.9248328,106.4538057,74.6159635,165.572349,11.6114183,14.1401507,1.4940244,46.804826),(33820,'metatarsal.tif',231,10,150,51.7243324,17.3637969,8.8678054,1.8,17.333587,8.888782,-1.4479673,6.1428274,7.6917516,524.5851662,903.1375869,8.4913143,117.416375,85.3979988,182.9404382,11.7849005,14.7585896,0.9841524,48.4976737),(33821,'metatarsal.tif',231,10,151,55.3792605,17.8138235,9.0465365,1.8,17.7473249,9.0434044,-1.4607796,6.0156031,7.5384414,584.7092599,971.9911442,9.1186112,128.9379445,97.1987769,202.3004173,11.8572006,14.9206258,0.9680099,50.0181021),(33822,'metatarsal.tif',231,10,152,61.3516252,18.0224343,9.0818483,1.8,17.899598,9.0495719,-1.4534286,6.0104464,7.3755823,663.2410977,1005.4315516,10.0850614,136.3189382,110.3480596,221.3805782,11.9547744,14.9856474,0.9533511,46.7988062),(33823,'metatarsal.tif',231,10,153,68.318591,18.0552629,9.0210742,1.8,17.9695502,8.9958594,-1.4453509,5.9941109,7.2160596,668.8808293,1054.069935,11.2081864,146.0727869,111.5896653,230.0478998,11.6726277,14.9856474,0.9533511,46.6965586),(33824,'metatarsal.tif',231,10,154,74.7572729,18.0174243,9.1332101,1.8,17.9840633,9.157736,-1.4751163,6.0187246,6.8900563,650.8490057,1077.1713375,12.3458301,156.3370872,108.1373631,228.7837911,11.4484469,14.8518005,0.9409263,46.8587015),(33825,'metatarsal.tif',231,10,155,77.2768144,17.9097518,9.169641,1.8,17.9708372,9.2191312,-1.5619977,6.0258788,6.8690614,643.0489403,1015.3425055,12.878472,147.8138629,106.7145501,219.9376893,10.93961,14.4897937,0.9163176,45.1876534),(33826,'metatarsal.tif',231,10,156,75.2204825,17.9322686,9.083519,1.8,18.0267213,9.1323546,-1.5694072,5.7828664,6.8196657,599.0619761,854.5893398,12.5367229,125.312498,103.5925666,199.0131849,10.7212905,13.9434076,0.9511496,43.9812344),(33827,'metatarsal.tif',231,10,157,72.0933934,17.8182415,8.9729742,1.8,17.9358249,9.0112531,-1.5641964,5.6106035,6.4830753,506.8993023,759.3942464,12.0150422,117.1348798,90.3466625,177.8735225,10.2666005,13.5038524,1.0184398,42.4081773),(33828,'metatarsal.tif',231,10,158,67.796295,17.6851727,8.8919514,1.8,17.803886,8.9322461,-1.5620529,5.3117231,6.1238418,384.6633995,705.2442371,11.2985187,115.1636929,72.4178179,160.1364158,9.5436004,13.0406841,1.0674673,39.7497385),(33829,'metatarsal.tif',231,10,159,59.5379321,17.5643305,8.9819722,1.8,17.6382317,9.0248251,1.5640583,4.4862074,5.7583596,219.3886578,580.9228136,9.9225382,100.8833865,48.9029241,128.4912304,8.1699004,12.1640324,1.2377681,35.4087284),(33830,'metatarsal.tif',231,10,160,40.6987533,17.466761,9.4190249,1.8,17.4820291,9.3886425,1.5342236,2.9955136,5.445725,72.4043085,297.2145719,6.7740567,54.5775947,24.1709167,67.1458223,5.7840003,10.6034801,1.4202206,28.67668),(33831,'metatarsal.tif',231,10,161,9.3326537,17.5054678,9.8026222,1.8,17.4940713,9.8339852,1.5152636,1.4773851,2.9252075,3.6824666,15.9551039,1.5506504,5.4543495,2.492557,6.7129442,2.8197001,5.8847939,1.6692425,14.4296879),(33832,'metatarsal.tif',231,10,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33833,'metatarsal.tif',231,10,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33834,'metatarsal.tif',231,10,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33835,'metatarsal.tif',231,10,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33836,'metatarsal.tif',231,10,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33837,'metatarsal.tif',231,10,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33838,'metatarsal.tif',231,10,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33839,'metatarsal.tif',231,10,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33840,'metatarsal.tif',231,10,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33841,'metacarpal.tif',228,5,1,7.354269,12.676561,7.549994,1.8,12.624216,7.54128,-0.026549,2.719457,3.206111,11.596813,20.27225,0.000864,6.323003,4.264385,8.223433,1.920162,2.266662,1.704607,6.786524),(33842,'metacarpal.tif',228,5,2,7.02189,12.662887,7.605977,1.8,12.62555,7.595114,-0.021904,2.650935,3.187401,10.645053,20.047202,0.000561,6.289514,4.015584,7.977183,1.922814,2.211654,1.787347,6.714948),(33843,'metacarpal.tif',228,5,3,6.701709,12.617584,7.652395,1.8,12.599817,7.638432,-0.042837,2.664286,3.169671,9.927331,19.796874,0.002048,6.24572,3.726076,7.719924,1.9008,2.179353,1.810967,6.59276),(33844,'metacarpal.tif',228,5,4,6.379715,12.572796,7.658675,1.8,12.5706,7.65675,-0.068413,2.688196,3.158231,9.225296,19.105803,0.004969,6.049526,3.431779,7.355182,1.91898,2.144827,1.898916,6.567454),(33845,'metacarpal.tif',228,5,5,5.92389,12.539286,7.680089,1.8,12.562038,7.697835,-0.128394,2.761285,3.194056,7.940536,18.338135,0.016187,5.741331,2.875667,6.948132,1.896467,2.118563,1.924794,6.445265),(33846,'metacarpal.tif',228,5,6,5.486109,12.531578,7.713643,1.8,12.565841,7.72515,-0.204398,2.821164,3.257808,6.221875,17.785743,0.037671,5.459421,2.205429,6.506972,1.893739,2.106637,1.840645,6.394654),(33847,'metacarpal.tif',228,5,7,5.309199,12.624436,7.779427,1.8,12.639826,7.768551,-0.236179,2.32912,3.366583,5.016779,18.078693,0.048447,5.370042,2.153938,6.734863,1.8576,2.097314,2.135946,6.348383),(33848,'metacarpal.tif',228,5,8,5.091846,12.796248,7.913405,1.8,12.796173,7.880484,-0.258455,1.943057,3.523187,3.882745,18.789284,0.055437,5.333036,1.998266,6.384206,1.8144,2.07405,2.193467,6.226195),(33849,'metacarpal.tif',228,5,9,5.294283,12.901959,7.945564,1.8,12.909061,7.934219,-0.283012,1.765136,3.637658,3.621734,19.703774,0.068808,5.41661,2.051816,6.384381,1.8144,2.091523,2.239086,6.215713),(33850,'metacarpal.tif',228,5,10,5.695687,12.933801,7.910829,1.8,12.960752,7.900448,-0.290756,1.86756,3.680646,4.180708,20.70928,0.078015,5.626534,2.238594,6.734374,2.461515,3.906436,2.238629,12.873909),(33851,'metacarpal.tif',228,5,11,5.904389,12.949406,7.904151,1.8,12.977042,7.891096,-0.290581,1.939609,3.685074,4.679975,21.512033,0.080779,5.837612,2.412844,7.084573,0.1296,0.232639,1.951303,0.539364),(33852,'metacarpal.tif',228,5,12,6.158763,13.015156,7.898939,1.8,13.044239,7.878413,-0.285763,1.996783,3.711619,5.197501,22.343961,0.081564,6.020004,2.602937,7.403709,2.568965,4.176348,2.253615,13.708261),(33853,'metacarpal.tif',228,5,13,6.431936,13.089238,7.875829,1.8,13.11288,7.852649,-0.279618,2.060033,3.752275,5.700507,22.936504,0.081653,6.112693,2.767191,7.630293,2.613591,4.315894,2.292451,15.280083),(33854,'metacarpal.tif',228,5,14,6.544114,13.173741,7.85564,1.8,13.1979,7.828955,-0.26572,2.450637,3.78465,6.166959,22.616077,0.075214,5.975738,2.516472,7.602744,1.99617,3.489587,1.833791,9.171734),(33855,'metacarpal.tif',228,5,15,6.588686,13.300902,7.810823,1.8,13.327227,7.788166,-0.226137,2.472989,3.869747,6.609216,21.101668,0.055204,5.452984,2.672562,7.143431,2.022028,3.573087,1.827505,9.28344),(33856,'metacarpal.tif',228,5,16,6.660495,13.4502,7.763142,1.8,13.447801,7.748761,-0.145065,2.498985,3.940737,7.294616,18.465189,0.023197,4.685719,2.919032,6.468911,2.035098,2.231814,0.744325,7.096336),(33857,'metacarpal.tif',228,5,17,6.626018,13.592942,7.733493,1.8,13.574955,7.744293,0.06225,2.372573,3.803672,7.670274,15.388575,0.004274,4.045716,3.232892,5.683394,2.103573,2.296112,0.71883,7.15743),(33858,'metacarpal.tif',228,5,18,6.630706,13.658997,7.723542,1.8,13.623794,7.761781,0.388772,2.996684,3.217711,7.608775,13.879858,0.158784,4.313581,2.539065,5.334832,2.093573,2.418043,0.722191,7.319748),(33859,'metacarpal.tif',228,5,19,6.825865,13.53091,7.659633,1.8,13.487546,7.689882,0.554951,3.450759,3.885478,7.387721,16.597908,0.315839,4.27178,2.140897,6.149756,2.099804,2.523413,0.664046,7.492548),(33860,'metacarpal.tif',228,5,20,7.3885,13.25679,7.538016,1.8,13.253082,7.552871,0.567393,3.495115,3.624442,7.846623,21.494123,0.355679,5.930325,2.245026,7.951568,2.170335,2.671772,0.682317,7.949854),(33861,'metacarpal.tif',228,5,21,8.487338,12.875788,7.37321,1.8,12.87009,7.380905,0.535416,3.469761,3.263699,9.421818,27.733268,0.368213,8.497495,2.715409,10.521521,2.259009,4.673793,2.99316,16.932165),(33862,'metacarpal.tif',228,5,22,9.407278,12.615816,7.325324,1.8,12.622848,7.349327,0.498629,3.436876,3.479326,11.290325,31.43366,0.358569,9.03441,3.285055,11.983433,2.469472,4.790333,3.015001,17.374647),(33863,'metacarpal.tif',228,5,23,10.186251,12.418323,7.367001,1.8,12.438661,7.398355,0.432871,3.315706,3.629367,13.271124,33.987728,0.298732,9.364645,4.002503,12.905742,4.05645,5.391699,0.985016,24.114901),(33864,'metacarpal.tif',228,5,24,10.648756,12.206218,7.423685,1.8,12.189572,7.441801,0.352431,3.176037,3.75803,14.457572,34.99582,0.211465,9.312278,4.55208,12.966696,4.097377,5.415702,0.978369,21.41808),(33865,'metacarpal.tif',228,5,25,10.928551,12.032714,7.501052,1.8,12.000505,7.502428,0.298951,3.026771,3.86092,15.150401,34.764521,0.157992,9.004207,5.005467,12.70605,4.160571,5.404318,0.967274,22.28822),(33866,'metacarpal.tif',228,5,26,10.552415,11.999892,7.5776,1.8,11.991777,7.568893,0.294912,2.966355,3.854558,15.100099,32.840021,0.148579,8.51979,5.090456,12.281079,4.226348,5.371586,1.020722,21.932138),(33867,'metacarpal.tif',228,5,27,9.94539,12.034471,7.597791,1.8,12.016162,7.592182,0.30464,2.977669,3.782458,14.678794,30.40915,0.14913,8.03952,4.929626,11.838035,4.328343,5.376448,2.873226,21.348302),(33868,'metacarpal.tif',228,5,28,9.493401,12.057987,7.564876,1.8,12.031299,7.558876,0.297467,3.035463,3.699695,14.344295,27.580883,0.135925,7.454908,4.72557,11.083455,4.406289,5.507449,2.847131,20.712056),(33869,'metacarpal.tif',228,5,29,9.752702,12.067065,7.545317,1.8,12.037712,7.54027,0.270201,3.041855,3.483558,14.714315,27.995077,0.115812,8.036346,4.837284,11.170047,4.503605,5.64401,2.84647,21.169362),(33870,'metacarpal.tif',228,5,30,10.443457,12.13166,7.544144,1.8,12.126054,7.550686,0.316176,3.121759,3.506374,14.933016,32.00096,0.168279,9.12651,4.783526,12.433499,4.694951,5.895653,2.71072,23.057137),(33871,'metacarpal.tif',228,5,31,11.374828,12.173979,7.537297,1.8,12.173746,7.548819,0.342181,3.196766,3.685434,14.853755,36.774879,0.213446,9.978439,4.646494,13.882058,4.74653,6.058174,2.738574,22.273396),(33872,'metacarpal.tif',228,5,32,11.957688,12.175985,7.531225,1.8,12.175206,7.538914,0.332532,3.206948,3.709615,15.30054,38.666406,0.212372,10.423294,4.771059,14.400662,4.762363,6.163688,2.791025,22.823243),(33873,'metacarpal.tif',228,5,33,11.837066,12.29645,7.51497,1.8,12.281258,7.513876,0.298172,3.230021,3.604166,15.748648,38.217824,0.170262,10.603793,4.875711,14.624101,4.740724,6.272932,2.848157,23.288487),(33874,'metacarpal.tif',228,5,34,11.182543,12.644301,7.528931,1.8,12.609246,7.528778,0.245678,3.234399,3.406189,16.003674,34.831298,0.110247,10.225884,4.947959,13.482898,4.707307,6.350253,0.591776,24.194416),(33875,'metacarpal.tif',228,5,35,10.449126,13.085284,7.546069,1.8,13.056026,7.5652,0.238484,3.318108,3.433293,15.917507,28.710456,0.097185,8.362368,4.797164,10.82934,0.444439,0.970799,2.578276,2.269163),(33876,'metacarpal.tif',228,5,36,0.221901,12.509752,6.444382,1.8,12.512448,6.448649,-1.112721,0.244415,1.018506,0.002567,0.018393,0.029751,0.018059,0.010504,0.020222,0.4752,0.970799,1.206817,2.258681),(33877,'metacarpal.tif',228,5,37,0.617923,12.495551,6.606659,1.8,12.497822,6.625723,-1.308512,0.357763,0.748516,0.016666,0.072427,0.096063,0.096761,0.046583,0.118698,0.751434,1.508911,1.339706,3.607091),(33878,'metacarpal.tif',228,5,38,1.278208,12.542827,6.887524,1.8,12.55349,6.921776,-1.499388,0.49781,1.278161,0.057426,0.41571,0.21195,0.325241,0.115358,0.36894,0.9504,2.385798,1.480136,5.726961),(33879,'metacarpal.tif',228,5,39,1.768143,12.61389,7.005474,1.8,12.625533,7.005087,1.555546,0.557623,1.437111,0.112224,0.74802,0.294622,0.520502,0.201254,0.587544,1.1232,2.604928,1.670465,6.367549),(33880,'metacarpal.tif',228,5,40,2.10137,12.710522,7.109997,1.8,12.722883,7.10598,1.466513,0.624433,1.443927,0.186257,1.052388,0.346433,0.728837,0.298282,0.852579,1.274089,2.816295,1.647568,7.380842),(33881,'metacarpal.tif',228,5,41,2.73871,12.97549,7.291615,1.8,13.007947,7.302731,1.141773,1.185298,1.685247,0.528551,1.836915,0.377466,1.089997,0.445923,1.399063,1.977025,3.092649,2.003204,9.14463),(33882,'metacarpal.tif',228,5,42,3.259586,13.177787,7.367504,1.8,13.18797,7.362274,0.997766,1.113098,1.845114,0.823661,2.550702,0.383566,1.382408,0.739971,1.816901,2.209712,3.284337,2.034444,9.643864),(33883,'metacarpal.tif',228,5,43,3.404614,13.283112,7.380922,1.8,13.272112,7.372725,0.947395,1.212169,1.954943,0.974314,2.87829,0.374041,1.472314,0.803777,1.964422,2.291026,3.421538,2.490516,9.766052),(33884,'metacarpal.tif',228,5,44,3.311811,13.3658,7.359707,1.8,13.343661,7.341023,0.895689,1.32601,2.006364,1.073688,2.910426,0.336369,1.450598,0.809714,1.980524,2.400393,3.522589,2.556991,9.959816),(33885,'metacarpal.tif',228,5,45,3.115349,13.413055,7.333865,1.8,13.385345,7.319456,0.842874,1.404248,2.065505,1.144523,3.000679,0.28939,1.452758,0.815043,2.002633,2.455016,3.623138,2.457541,10.265286),(33886,'metacarpal.tif',228,5,46,2.90621,13.373709,7.274558,1.8,13.351605,7.267992,0.85147,1.405855,2.04894,1.124295,3.040561,0.274094,1.483968,0.799723,2.032603,2.457681,3.741479,2.511947,10.520144),(33887,'metacarpal.tif',228,5,47,2.76448,13.357624,7.202229,1.8,13.346668,7.200023,0.81424,1.43667,2.157214,1.18181,2.967108,0.243655,1.375435,0.822603,1.898155,2.510105,3.751193,2.636731,10.699085),(33888,'metacarpal.tif',228,5,48,2.640124,13.338648,7.187266,1.8,13.325267,7.187601,0.796125,1.442436,2.109054,1.153137,2.856275,0.22473,1.354292,0.799437,1.884626,2.502938,4.038218,2.663592,11.084815),(33889,'metacarpal.tif',228,5,49,2.679068,13.377138,7.22556,1.8,13.362275,7.245454,0.79927,2.156162,2.041972,1.277579,2.906325,0.229449,1.423294,0.592524,1.467763,2.540916,3.787091,2.69325,10.612685),(33890,'metacarpal.tif',228,5,50,2.786556,13.441939,7.197422,1.8,13.441857,7.207882,0.665888,1.565555,2.052357,1.313478,2.791843,0.177236,1.360311,0.838985,2.000248,2.587093,3.88632,2.717725,10.699085),(33891,'metacarpal.tif',228,5,51,2.707513,13.424228,7.230463,1.8,13.427315,7.252908,0.657775,1.52353,1.997761,1.230447,2.642645,0.168659,1.322803,0.807629,1.937841,2.528892,3.7898,2.718739,10.480015),(33892,'metacarpal.tif',228,5,52,2.671322,13.428244,7.247319,1.8,13.433168,7.273462,0.642341,1.490435,1.98403,1.182325,2.473156,0.159784,1.246531,0.793275,1.841391,2.502448,3.755171,2.739722,10.418921),(33893,'metacarpal.tif',228,5,53,2.708544,13.449749,7.262976,1.8,13.449354,7.283943,0.592731,1.477153,1.944867,1.173409,2.402788,0.140874,1.235451,0.794372,1.832979,2.447397,3.658762,2.741352,10.235638),(33894,'metacarpal.tif',228,5,54,2.695822,13.457569,7.28242,1.8,13.451856,7.298173,0.590272,1.465445,1.937755,1.132111,2.235276,0.139189,1.153539,0.772537,1.733536,2.43303,3.619015,2.736701,9.970298),(33895,'metacarpal.tif',228,5,55,2.696403,13.467027,7.303636,1.8,13.470319,7.315579,0.583046,1.45304,1.896453,1.128936,2.01084,0.136225,1.060316,0.776948,1.650459,2.410271,3.50586,2.749645,11.120603),(33896,'metacarpal.tif',228,5,56,2.681854,13.461446,7.340319,1.8,13.464337,7.359427,0.595722,1.41957,1.626435,1.124687,1.77987,0.140726,1.094338,0.792273,1.545564,2.401072,3.120583,2.758516,9.095816),(33897,'metacarpal.tif',228,5,57,2.693768,13.440445,7.361765,1.8,13.432162,7.379821,0.622941,1.379733,1.566831,1.095563,1.671866,0.15282,1.067036,0.79404,1.7556,2.37651,3.053479,2.703256,8.826134),(33898,'metacarpal.tif',228,5,58,2.71791,13.432507,7.385304,1.8,13.418722,7.406207,0.605553,1.379792,1.54587,1.079567,1.595511,0.146771,1.032112,0.782413,1.717746,2.363653,2.9961,2.710192,8.668158),(33899,'metacarpal.tif',228,5,59,2.757259,13.427311,7.410256,1.8,13.42069,7.432679,0.593459,1.354984,1.528965,1.093423,1.527579,0.143718,0.999093,0.806964,1.700467,2.356771,2.978295,2.723368,8.63237),(33900,'metacarpal.tif',228,5,60,2.767535,13.405581,7.435942,1.8,13.402281,7.459166,0.595808,1.346046,1.490091,1.108875,1.424543,0.145259,0.95601,0.823802,1.578463,2.344014,3.033243,2.684314,8.790346),(33901,'metacarpal.tif',228,5,61,2.690775,13.339804,7.455711,1.8,13.324718,7.478432,0.928619,1.264629,1.379782,1.067702,1.238386,0.287586,0.897523,0.844281,1.662363,2.340968,2.609938,1.997424,8.347864),(33902,'metacarpal.tif',228,5,62,2.641677,13.2933,7.475718,1.8,13.283973,7.498008,1.209022,1.281166,1.273115,1.000893,1.157329,0.385126,0.909053,0.781236,1.606528,2.24386,2.589479,2.056828,8.617546),(33903,'metacarpal.tif',228,5,63,2.63113,13.288274,7.479469,1.8,13.279669,7.501121,-1.420277,1.190106,1.24319,0.996606,1.088459,0.428661,0.875537,0.83741,1.551984,2.236908,2.588037,0.583373,8.45957),(33904,'metacarpal.tif',228,5,64,2.557274,13.254187,7.494884,1.8,13.250425,7.515045,-1.378461,1.370274,1.215495,0.916267,1.040548,0.410639,0.856069,0.668674,1.352429,2.240906,2.59236,0.411456,9.828944),(33905,'metacarpal.tif',228,5,65,2.572543,13.247526,7.492067,1.8,13.244933,7.509525,-1.114615,1.208915,1.210694,0.884791,1.038306,0.345552,0.857612,0.731889,1.317703,2.199385,2.632011,0.404892,9.900521),(33906,'metacarpal.tif',228,5,66,2.529359,13.221118,7.494771,1.8,13.219606,7.50856,-1.112587,1.11406,1.197299,0.822723,0.997601,0.339075,0.83321,0.738491,1.283821,2.109522,2.609938,0.500668,9.706756),(33907,'metacarpal.tif',228,5,67,2.510124,13.201257,7.497033,1.8,13.201256,7.509223,-1.111237,1.129692,1.22562,0.773191,0.962225,0.336047,0.785092,0.684426,1.214783,2.096626,2.402169,0.912908,7.610394),(33908,'metacarpal.tif',228,5,68,2.518094,13.180727,7.492987,1.8,13.180686,7.503738,-1.108002,1.146952,1.240291,0.727088,0.954522,0.336032,0.769596,0.633931,1.196401,2.04665,2.428824,0.898833,7.599912),(33909,'metacarpal.tif',228,5,69,2.516868,13.152198,7.497922,1.8,13.153048,7.508131,-1.138135,1.193975,1.23524,0.686159,0.933584,0.345733,0.755791,0.574684,1.135394,2.033004,2.48353,0.871604,7.966476),(33910,'metacarpal.tif',228,5,70,2.596978,13.157787,7.492515,1.8,13.166507,7.498639,-1.003629,1.108262,1.289696,0.704321,0.941001,0.307901,0.72963,0.635518,1.204911,2.02205,2.541467,0.554996,8.45957),(33911,'metacarpal.tif',228,5,71,2.652859,13.145182,7.478765,1.8,13.14866,7.486428,-1.0127,1.122759,1.293452,0.65693,0.967302,0.318146,0.747845,0.585103,1.224146,1.949541,2.537058,0.749269,8.301594),(33912,'metacarpal.tif',228,5,72,2.637599,13.120258,7.481245,1.8,13.120729,7.488142,-1.061335,1.037718,1.250515,0.626239,0.919859,0.335037,0.735584,0.603477,1.186774,1.853413,2.446814,0.73544,7.172254),(33913,'metacarpal.tif',228,5,73,2.677271,13.121006,7.475995,1.8,13.13216,7.479108,-0.987969,1.030728,1.261348,0.632821,0.917387,0.311043,0.727307,0.613955,1.179369,1.924462,2.459746,0.534395,7.427112),(33914,'metacarpal.tif',228,5,74,2.650702,13.091318,7.479874,1.8,13.097016,7.485302,-1.059899,1.067136,1.237743,0.604256,0.872774,0.336161,0.705133,0.566241,1.154888,1.918205,2.408763,0.568105,7.477724),(33915,'metacarpal.tif',228,5,75,2.629408,13.069807,7.480667,1.8,13.074858,7.484493,-1.10233,1.132295,1.221944,0.584244,0.837425,0.348892,0.685322,0.515982,1.106149,1.912457,2.363399,0.537285,7.538818),(33916,'metacarpal.tif',228,5,76,2.601461,13.044423,7.481684,1.8,13.044398,7.48712,-1.188685,1.112942,1.179306,0.558576,0.804375,0.373292,0.682075,0.501892,1.079729,1.808767,2.290008,0.946161,6.658195),(33917,'metacarpal.tif',228,5,77,2.596312,13.025286,7.482315,1.8,13.022871,7.488135,-1.210296,1.143238,1.167891,0.546877,0.78779,0.378877,0.674541,0.478358,1.041569,1.802755,2.276521,0.988057,6.632889),(33918,'metacarpal.tif',228,5,78,2.59682,13.016996,7.481588,1.8,13.020411,7.486335,-1.177789,1.324898,1.147373,0.557162,0.776586,0.369326,0.676838,0.420532,1.002968,1.7712,2.240577,0.977446,6.510701),(33919,'metacarpal.tif',228,5,79,2.583021,12.99749,7.482221,1.8,12.997124,7.487409,-1.195213,1.304794,1.144571,0.55384,0.763638,0.372578,0.667182,0.424465,1.003551,1.7712,2.223856,1.063698,6.521183),(33920,'metacarpal.tif',228,5,80,2.555074,12.977303,7.483462,1.8,12.977274,7.48905,-1.258453,1.065204,1.114032,0.529349,0.740873,0.385634,0.665037,0.496947,1.046742,1.7712,2.221757,1.107149,6.398995),(33921,'metacarpal.tif',228,5,81,2.532953,12.961136,7.481585,1.8,12.960535,7.487455,-1.286308,1.162738,1.091815,0.519347,0.73034,0.388904,0.668923,0.446659,0.988166,1.728,2.206586,1.168475,6.337901),(33922,'metacarpal.tif',228,5,82,2.5317,12.94573,7.483932,1.8,12.945501,7.491413,-1.293726,1.192285,1.119504,0.522942,0.730801,0.390378,0.65279,0.438605,0.979306,1.7712,2.243074,1.297788,6.445265),(33923,'metacarpal.tif',228,5,83,2.512656,12.928557,7.479754,1.8,12.926785,7.486695,-1.336011,0.887728,1.117468,0.510685,0.722087,0.396112,0.646181,0.575272,1.101814,1.728,2.243074,1.297788,6.409477),(33924,'metacarpal.tif',228,5,84,2.522236,12.911402,7.476911,1.8,12.90873,7.48532,-1.319172,0.885402,1.20041,0.515684,0.730242,0.394314,0.608327,0.58243,1.037916,1.7712,2.326391,1.307802,6.55263),(33925,'metacarpal.tif',228,5,85,2.510387,12.89636,7.471702,1.8,12.89384,7.480177,-1.312781,0.891039,1.170824,0.514589,0.73245,0.391157,0.625585,0.577516,1.064806,1.787051,2.315536,1.325818,6.55263),(33926,'metacarpal.tif',228,5,86,2.519435,12.884256,7.466663,1.8,12.882715,7.475381,-1.276331,0.890127,1.172351,0.523651,0.744123,0.384536,0.634727,0.588288,1.081077,1.7712,2.326391,1.307802,6.567454),(33927,'metacarpal.tif',228,5,87,2.523925,12.869827,7.467935,1.8,12.867669,7.478498,-1.240027,0.893956,1.219546,0.531507,0.757922,0.376285,0.621479,0.594556,1.056136,1.808767,2.379532,1.29499,6.72543),(33928,'metacarpal.tif',228,5,88,2.498673,12.857465,7.458814,1.8,12.856338,7.466624,-1.203945,0.901173,1.236258,0.539723,0.74811,0.36287,0.605141,0.598912,1.039766,1.813492,2.231814,1.316428,6.481054),(33929,'metacarpal.tif',228,5,89,2.493165,12.844994,7.455184,1.8,12.843718,7.464305,-1.132852,0.902812,1.080967,0.552119,0.753337,0.340798,0.69691,0.611555,1.203231,1.82534,2.190031,1.311465,6.50636),(33930,'metacarpal.tif',228,5,90,2.498917,12.836065,7.453869,1.8,12.835082,7.462667,-1.082427,0.91391,1.100591,0.564686,0.777815,0.324803,0.706725,0.61788,1.219792,1.836012,2.190031,1.186627,6.59276),(33931,'metacarpal.tif',228,5,91,2.502808,12.827028,7.453564,1.8,12.8258,7.463014,-1.034504,0.913162,1.110496,0.576986,0.802776,0.308232,0.722898,0.631855,1.241342,1.850281,2.21292,0.896055,6.618065),(33932,'metacarpal.tif',228,5,92,2.490557,12.815742,7.459553,1.8,12.814093,7.470101,-0.985823,0.914578,1.11055,0.585669,0.814388,0.288531,0.733319,0.640371,1.258895,1.853413,2.220497,0.647392,6.618065),(33933,'metacarpal.tif',228,5,93,2.477779,12.80108,7.469053,1.8,12.800538,7.479227,-0.949543,0.922716,1.108262,0.597468,0.811648,0.273056,0.732361,0.647511,1.257644,1.858024,2.240161,0.6898,6.668677),(33934,'metacarpal.tif',228,5,94,2.455527,12.780669,7.480339,1.8,12.780336,7.49079,-0.894562,0.932213,1.10249,0.608193,0.797243,0.248949,0.72313,0.652418,1.259611,1.869596,2.229723,0.620249,6.67916),(33935,'metacarpal.tif',228,5,95,2.423844,12.756216,7.490952,1.8,12.7548,7.500234,-0.895079,0.944664,1.085608,0.613422,0.778284,0.245941,0.71691,0.649355,1.256094,1.885439,2.216712,0.577192,6.643371),(33936,'metacarpal.tif',228,5,96,2.400892,12.731587,7.505299,1.8,12.729528,7.515479,-0.872986,0.939786,1.066883,0.621279,0.76978,0.234943,0.721523,0.661086,1.27108,1.899302,2.207854,0.533708,6.653854),(33937,'metacarpal.tif',228,5,97,2.367187,12.709379,7.517667,1.8,12.706683,7.528627,-0.865856,0.958355,1.058333,0.626807,0.745971,0.228872,0.704855,0.654044,1.278582,1.923578,2.180637,0.588003,6.618065),(33938,'metacarpal.tif',228,5,98,2.341553,12.687448,7.526388,1.8,12.682662,7.537914,-0.833721,0.952739,1.05346,0.634215,0.731449,0.213958,0.69433,0.665676,1.292331,1.93851,2.15221,0.671606,6.582277),(33939,'metacarpal.tif',228,5,99,2.302635,12.669971,7.534871,1.8,12.668018,7.547129,-0.849946,0.958189,1.041847,0.636366,0.714939,0.216589,0.686223,0.664135,1.289162,1.944,2.13436,0.627308,6.556971),(33940,'metacarpal.tif',228,5,100,2.293899,12.629031,7.562021,1.8,12.615287,7.584957,-0.764114,0.972202,3.524527,0.63912,0.905224,0.183024,0.256836,0.657395,0.438029,1.944,2.13436,0.627308,6.618065),(33941,'metacarpal.tif',228,5,101,2.24282,12.631015,7.552327,1.8,12.62748,7.568439,-0.687909,0.997974,1.035839,0.643032,0.687568,0.15069,0.663779,0.644337,1.251348,1.944,2.118563,0.684295,6.582277),(33942,'metacarpal.tif',228,5,102,2.220582,12.609417,7.560682,1.8,12.603527,7.578547,-0.549916,1.029751,1.039769,0.649892,0.677227,0.101084,0.651324,0.631116,1.252683,1.944,2.109293,0.610726,6.582277),(33943,'metacarpal.tif',228,5,103,2.210182,12.59303,7.569941,1.8,12.586954,7.586267,-0.220126,1.063344,1.031495,0.657511,0.67218,0.017563,0.651656,0.618343,1.249125,1.944,2.099538,0.639386,6.582277),(33944,'metacarpal.tif',228,5,104,2.22492,12.576565,7.584911,1.8,12.56997,7.601356,0.342894,0.992241,0.998536,0.664843,0.683277,0.041917,0.684279,0.670042,1.242286,1.9872,2.118122,1.776192,6.653854),(33945,'metacarpal.tif',228,5,105,2.22028,12.561898,7.595182,1.8,12.554135,7.610741,0.649089,0.992579,1.02341,0.661284,0.692336,0.135205,0.676499,0.666229,1.254785,1.944,2.127353,1.796073,6.618065),(33946,'metacarpal.tif',228,5,106,2.224654,12.542105,7.599813,1.8,12.532091,7.615732,0.565115,0.993303,1.017379,0.659243,0.704062,0.106329,0.692035,0.663688,1.237076,1.971061,2.15221,1.752445,6.740254),(33947,'metacarpal.tif',228,5,107,2.220866,12.525962,7.610317,1.8,12.519296,7.630152,0.609315,0.990797,1.021621,0.649246,0.716506,0.121235,0.701342,0.655276,1.224626,1.967028,2.172492,1.873681,6.704465),(33948,'metacarpal.tif',228,5,108,2.24246,12.505698,7.62368,1.8,12.496853,7.644148,0.613722,0.988716,1.071516,0.649814,0.747712,0.123962,0.697807,0.65723,1.246036,1.951519,2.199809,1.911178,6.740254),(33949,'metacarpal.tif',228,5,109,2.233879,12.490776,7.630916,1.8,12.483107,7.649468,0.642688,0.977658,1.049915,0.639585,0.754082,0.133742,0.718231,0.654201,1.227627,1.9324,2.223856,1.990993,6.740254),(33950,'metacarpal.tif',228,5,110,2.235445,12.465685,7.636936,1.8,12.454544,7.653797,0.620395,0.977675,1.055582,0.636343,0.769655,0.125921,0.729128,0.650873,1.234008,1.928938,2.223856,1.990993,6.801348),(33951,'metacarpal.tif',228,5,111,2.246779,12.443426,7.649043,1.8,12.430355,7.666253,0.580268,0.983109,1.057134,0.636893,0.790135,0.112555,0.747431,0.647835,1.253834,1.9209,2.245154,2.094716,6.816171),(33952,'metacarpal.tif',228,5,112,2.265308,12.423019,7.664672,1.8,12.412684,7.680732,0.601604,0.984502,1.071956,0.641793,0.815992,0.120936,0.761217,0.651896,1.266085,1.926407,2.282661,2.085248,6.816171),(33953,'metacarpal.tif',228,5,113,2.295196,12.391103,7.681677,1.8,12.379117,7.69633,0.587512,0.991911,1.079854,0.653837,0.84859,0.117529,0.785838,0.659169,1.28464,1.936519,2.304225,2.10157,6.902571),(33954,'metacarpal.tif',228,5,114,2.31234,12.363084,7.701577,1.8,12.352339,7.718027,0.550287,0.99352,1.102526,0.662944,0.878032,0.105388,0.796382,0.667268,1.321834,1.927468,2.312714,2.143256,6.953183),(33955,'metacarpal.tif',228,5,115,2.332826,12.337219,7.72445,1.8,12.330228,7.741114,0.560956,1.00566,1.129814,0.68207,0.91802,0.110039,0.812541,0.678231,1.35632,1.951457,2.360634,2.174026,7.003795),(33956,'metacarpal.tif',228,5,116,2.35337,12.308712,7.749674,1.8,12.299484,7.766096,0.552193,1.018033,1.140993,0.70027,0.960928,0.107925,0.842186,0.687866,1.415043,1.970952,2.376,2.214297,7.136465),(33957,'metacarpal.tif',228,5,117,2.373604,12.281476,7.776144,1.8,12.270243,7.793076,0.554984,1.023688,1.168864,0.719078,1.007943,0.109841,0.862327,0.702438,1.454541,2.008342,2.402169,2.228685,7.319748),(33958,'metacarpal.tif',228,5,118,2.400047,12.254457,7.80553,1.8,12.240573,7.820831,0.558197,1.035432,1.198595,0.749986,1.052175,0.112217,0.87784,0.724322,1.491586,2.028779,2.436495,2.217844,7.309265),(33959,'metacarpal.tif',228,5,119,2.47939,12.210795,7.832641,1.8,12.201017,7.84897,0.524011,1.053941,1.300587,0.789577,1.151595,0.103456,0.885443,0.749166,1.484282,2.063017,2.502992,2.770701,7.492548),(33960,'metacarpal.tif',228,5,120,2.531291,12.18759,7.87116,1.8,12.178934,7.89027,0.532017,1.069496,1.237727,0.841037,1.207276,0.108561,0.975397,0.786387,1.645315,2.103985,2.49702,2.221218,7.492548),(33961,'metacarpal.tif',228,5,121,2.590908,12.161842,7.912365,1.8,12.152124,7.931614,0.521284,1.093612,1.26631,0.9073,1.288444,0.10709,1.01748,0.829636,1.718957,2.158545,2.541467,2.125792,7.578948),(33962,'metacarpal.tif',228,5,122,2.667948,12.12568,7.952647,1.8,12.11231,7.9698,0.495294,1.10156,1.289201,0.983242,1.40839,0.100449,1.092452,0.892591,1.829328,2.199628,2.601343,2.191046,7.76223),(33963,'metacarpal.tif',228,5,123,2.777144,12.082668,8.003599,1.8,12.074592,8.025148,0.440974,1.133802,1.291794,1.084315,1.563403,0.084322,1.210257,0.956353,2.007014,2.263281,2.647917,2.158799,7.970818),(33964,'metacarpal.tif',228,5,124,2.873907,12.037278,8.046824,1.8,12.030918,8.069089,0.412098,1.169528,1.333662,1.192249,1.716217,0.076842,1.286845,1.019427,2.152328,2.326099,2.732208,2.176341,8.2405),(33965,'metacarpal.tif',228,5,125,2.884687,12.013344,8.104372,1.8,12.004926,8.135502,0.424004,1.208287,1.38701,1.26995,1.833286,0.081377,1.321754,1.051033,2.216992,2.378467,2.816295,2.137526,8.449088),(33966,'metacarpal.tif',228,5,126,2.899134,12.001979,8.17344,1.8,11.981228,8.210242,0.483581,1.254335,1.431644,1.3925,1.980768,0.104456,1.383562,1.11015,2.296659,2.519025,2.959437,2.158799,8.97797),(33967,'metacarpal.tif',228,5,127,2.986751,11.954087,8.273705,1.8,11.9252,8.3172,0.36405,1.379836,1.45368,1.67305,2.112107,0.06311,1.452938,1.212499,2.444376,2.664545,3.05989,2.103952,9.740746),(33968,'metacarpal.tif',228,5,128,2.981609,11.917168,8.327634,1.8,11.888244,8.379517,0.219804,1.433356,1.416886,1.81274,2.18522,0.023625,1.542269,1.264682,2.521157,2.730316,3.104695,2.127921,9.985122),(33969,'metacarpal.tif',228,5,129,2.909153,11.896927,8.353676,1.8,11.87019,8.407338,0.149982,1.473689,1.416277,1.889296,2.204736,0.010825,1.556712,1.282018,2.536234,2.808,3.151232,2.151195,11.175556),(33970,'metacarpal.tif',228,5,130,2.838671,11.87666,8.35044,1.8,11.856807,8.399661,0.167105,1.421781,1.435641,1.834804,2.212036,0.013089,1.5408,1.290497,2.441537,2.724436,3.189202,0.433354,9.989464),(33971,'metacarpal.tif',228,5,131,2.885379,11.840971,8.371207,1.8,11.821101,8.417408,0.094581,1.422884,1.471228,1.866264,2.27215,0.004289,1.54439,1.311606,2.469909,2.7216,3.23106,0.517488,9.989464),(33972,'metacarpal.tif',228,5,132,3.047249,11.819527,8.410707,1.8,11.804926,8.450769,0.11309,1.390655,1.48783,1.934742,2.351318,0.006468,1.580367,1.391245,2.560202,2.711087,3.252647,0.52903,10.269628),(33973,'metacarpal.tif',228,5,133,3.296644,11.802281,8.438423,1.8,11.791254,8.484676,0.146731,1.405075,1.504004,1.963789,2.436868,0.011745,1.620254,1.39764,2.639841,2.710904,3.267817,0.422251,10.305416),(33974,'metacarpal.tif',228,5,134,3.47791,11.794267,8.436237,1.8,11.774756,8.48388,0.166664,1.408621,1.509861,1.990606,2.47283,0.015952,1.637786,1.413159,2.661191,2.692418,3.267817,0.422251,10.269628),(33975,'metacarpal.tif',228,5,135,3.72793,11.807292,8.400226,1.8,11.783952,8.433916,0.025824,1.517768,1.512299,2.043302,2.43842,0.000414,1.612393,1.346254,2.593615,2.668965,3.284337,0.463648,10.341204),(33976,'metacarpal.tif',228,5,136,3.740866,11.83347,8.378722,1.8,11.821711,8.414943,-0.121204,1.624604,1.6452,1.948076,2.312931,0.009114,1.405866,1.199108,2.397614,2.642641,3.290014,0.404892,10.244322),(33977,'metacarpal.tif',228,5,137,3.69584,11.827661,8.394067,1.8,11.807436,8.434692,-0.162921,1.549854,1.692191,1.850462,2.323963,0.016206,1.373346,1.193959,2.36556,2.578408,3.273238,0.392761,9.978982),(33978,'metacarpal.tif',228,5,138,3.55711,11.785276,8.404715,1.8,11.765463,8.443684,-0.037992,1.472053,1.574387,1.769563,2.325897,0.000855,1.477335,1.202105,2.38009,2.55768,3.241152,0.368131,10.32024),(33979,'metacarpal.tif',228,5,139,3.358618,11.726617,8.41118,1.8,11.719035,8.457397,0.063173,1.412753,1.497553,1.65047,2.235532,0.002231,1.492789,1.168265,2.360027,2.523635,3.183052,0.317459,9.816664),(33980,'metacarpal.tif',228,5,140,3.223971,11.695575,8.412905,1.8,11.68964,8.462197,0.127149,1.381745,1.469881,1.481429,2.178281,0.00864,1.481943,1.072144,2.254634,2.448123,3.122377,0.25169,9.633382),(33981,'metacarpal.tif',228,5,141,3.156881,11.689332,8.41725,1.8,11.682537,8.460154,0.168311,1.339242,1.464651,1.305503,2.156,0.014765,1.472023,0.974808,2.151175,2.357675,3.069937,0.241566,9.546982),(33982,'metacarpal.tif',228,5,142,3.191052,11.687019,8.437757,1.8,11.676243,8.47415,0.201034,1.27907,1.473148,1.177147,2.194505,0.021206,1.48967,0.920315,2.130639,2.267353,3.057144,2.316216,9.485888),(33983,'metacarpal.tif',228,5,143,3.236171,11.677781,8.45984,1.8,11.666338,8.490148,0.244375,1.204934,1.468107,1.003949,2.205847,0.031574,1.502511,0.833199,2.090176,2.161548,3.031704,2.426784,9.338394),(33984,'metacarpal.tif',228,5,144,3.134099,11.688519,8.458791,1.8,11.684387,8.489792,0.279161,1.112548,1.468902,0.7033,2.078501,0.039661,1.415003,0.632152,1.842147,1.994023,2.982052,2.469114,9.114982),(33985,'metacarpal.tif',228,5,145,2.810405,11.727589,8.459677,1.8,11.717761,8.479851,0.307228,0.997622,1.482505,0.428959,1.849706,0.042838,1.247689,0.429981,1.486599,1.783447,2.955335,2.480549,9.053888),(33986,'metacarpal.tif',228,5,146,2.020092,11.821562,8.491875,1.8,11.805552,8.497399,0.323179,0.846107,1.550783,0.215481,1.441463,0.033957,0.929507,0.254673,1.06306,0.9936,1.133949,0.309703,3.362715),(33987,'metacarpal.tif',228,5,147,1.107371,12.033112,8.546575,1.8,11.977186,8.53464,0.332336,0.606908,1.728191,0.072205,0.804389,0.019645,0.465452,0.118972,0.507123,1.231368,1.474507,0.555494,4.588937),(33988,'metacarpal.tif',228,5,148,0.327483,12.632501,8.739224,1.8,12.625342,8.739228,1.316238,0.306943,0.517361,0.006604,0.016294,0.051119,0.031495,0.021515,0.044229,0.6048,0.974636,1.794273,2.553669),(33989,'metacarpal.tif',228,5,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33990,'metacarpal.tif',228,5,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33991,'metacarpal.tif',228,5,151,4.50995,12.815207,9.250907,1.8,12.745546,9.248412,-0.089469,1.33459,3.382335,1.226717,14.997434,0.006001,4.434047,0.919171,4.673444,1.370917,1.654058,0.711459,4.827173),(33992,'metacarpal.tif',228,5,152,4.34546,12.702253,9.275942,1.8,12.61235,9.27264,-0.080652,1.236017,3.261916,1.181501,14.200368,0.004701,4.353382,0.955894,4.597804,1.440897,1.714991,0.856706,5.269655),(33993,'metacarpal.tif',228,5,153,4.370713,12.606275,9.288502,1.8,12.496767,9.29133,-0.068959,1.119306,3.157378,1.160237,13.829607,0.003459,4.380093,1.036568,4.637457,1.673502,3.214556,2.289626,9.797498),(33994,'metacarpal.tif',228,5,154,4.386775,12.537605,9.289871,1.8,12.437534,9.293741,-0.054965,1.516029,3.076387,1.155977,13.421051,0.002207,4.362602,0.762503,4.622152,1.727606,3.219197,2.270689,9.76171),(33995,'metacarpal.tif',228,5,155,4.532518,12.444777,9.271635,1.8,12.364474,9.27315,-0.024883,1.536094,2.960696,1.241804,13.30852,0.000468,4.495065,0.808417,4.758715,1.790907,3.247192,2.280866,9.883898),(33996,'metacarpal.tif',228,5,156,4.648231,12.378391,9.255135,1.8,12.307052,9.258509,0.005499,1.427946,2.873454,1.236386,12.967334,0.000023,4.512803,0.865849,4.75603,1.855698,3.258666,2.243467,9.787016),(33997,'metacarpal.tif',228,5,157,4.72258,12.343256,9.213477,1.8,12.28759,9.215831,0.046274,1.042491,2.824776,1.284238,12.504953,0.001684,4.426883,1.231893,4.689087,2.056404,3.266103,2.224879,9.852452),(33998,'metacarpal.tif',228,5,158,5.122659,12.241935,9.093573,1.8,12.169382,9.071716,0.119342,1.364674,2.719458,1.74131,12.550865,0.012102,4.615208,1.27599,5.051655,2.544232,3.249203,2.195683,10.747898),(33999,'metacarpal.tif',228,5,159,5.613189,12.174913,8.978594,1.8,12.1313,8.972638,0.180446,1.311805,2.771317,2.152042,12.633795,0.030132,4.558769,1.64052,5.316272,2.637766,3.285757,2.005041,9.833286),(34000,'metacarpal.tif',228,5,160,5.903587,12.173093,8.9221,1.8,12.151209,8.929242,0.202167,1.384091,2.757433,2.31691,12.364487,0.03967,4.484057,1.673957,5.31669,2.634122,3.227303,2.058391,9.532158),(34001,'metacarpal.tif',228,5,161,6.026206,12.191858,8.894341,1.8,12.170957,8.905477,0.208112,1.408629,2.719465,2.420986,11.974939,0.042876,4.403417,1.718682,5.293102,2.630921,3.156262,2.101826,9.471064),(34002,'metacarpal.tif',228,5,162,5.769555,12.217911,8.907338,1.8,12.199741,8.914861,0.208639,1.401508,2.666897,2.395251,11.483989,0.041254,4.306123,1.709053,5.197901,2.600005,3.075707,2.084716,9.298264),(34003,'metacarpal.tif',228,5,163,5.401922,12.247896,8.935786,1.8,12.232346,8.938952,0.207574,1.379421,2.62274,2.299758,11.052817,0.038238,4.214224,1.667191,5.090985,2.554833,2.963533,2.106216,9.089676),(34004,'metacarpal.tif',228,5,164,5.127032,12.27249,8.958641,1.8,12.26155,8.962353,0.20646,1.361603,2.578284,2.147822,10.701431,0.035909,4.150601,1.577421,4.979481,2.531703,2.879208,2.054575,8.902052),(34005,'metacarpal.tif',228,5,165,4.92967,12.277854,8.968955,1.8,12.267447,8.974789,0.206212,1.379026,2.562051,1.956295,10.414707,0.034445,4.064988,1.418606,4.821629,2.511879,2.773225,1.887621,9.161252),(34006,'metacarpal.tif',228,5,166,4.767034,12.289777,8.990892,1.8,12.282525,8.998546,0.206439,1.377845,2.539033,1.758467,10.227055,0.033381,4.027932,1.276244,4.703952,2.412812,2.686054,0.485227,8.398476),(34007,'metacarpal.tif',228,5,167,4.631417,12.29519,9.022766,1.8,12.283585,9.032372,0.20347,1.354357,2.526648,1.566186,10.047114,0.031518,3.97646,1.156406,4.583304,2.340891,2.6242,0.574305,8.215194),(34008,'metacarpal.tif',228,5,168,4.565173,12.299393,9.055223,1.8,12.288629,9.066129,0.198881,1.336929,2.515214,1.407601,10.043091,0.0297,3.992938,1.052861,4.542061,2.248419,2.59344,0.523278,8.010948),(34009,'metacarpal.tif',228,5,169,4.569182,12.301123,9.092556,1.8,12.291227,9.106355,0.198084,1.291477,2.497532,1.310076,10.058822,0.029492,4.027505,1.014401,4.540193,2.234101,2.556112,2.10252,8.204712),(34010,'metacarpal.tif',228,5,170,4.624564,12.301641,9.137558,1.8,12.291343,9.154044,0.200712,1.154922,2.489023,1.255189,10.085859,0.030636,4.052136,1.086817,4.53095,2.163398,2.541467,2.125792,8.0677),(34011,'metacarpal.tif',228,5,171,4.675023,12.278619,9.166312,1.8,12.258795,9.175516,0.200994,1.071301,2.505916,1.196498,10.153923,0.031056,4.051981,1.116865,4.510353,2.062978,2.505972,2.197058,7.833806),(34012,'metacarpal.tif',228,5,172,4.697979,12.2477,9.189778,1.8,12.222332,9.197801,0.199146,1.442879,2.539697,1.144103,10.379535,0.030645,4.086919,0.792931,4.515806,1.988756,2.542569,2.970857,7.833806),(34013,'metacarpal.tif',228,5,173,4.748138,12.185945,9.219001,1.8,12.149328,9.229831,0.184129,1.403278,2.591036,1.168877,10.788411,0.026528,4.163745,0.832962,4.57779,1.913023,2.59919,2.872425,7.736924),(34014,'metacarpal.tif',228,5,174,4.81129,12.115788,9.247233,1.8,12.067761,9.258634,0.170237,1.354786,2.651718,1.197228,11.217933,0.023015,4.23044,0.883703,4.66239,1.909431,2.652494,2.861056,8.168924),(34015,'metacarpal.tif',228,5,175,4.874936,12.043877,9.27515,1.8,11.988888,9.289584,0.15699,1.305834,2.714928,1.226839,11.463884,0.01986,4.222537,0.939506,4.656367,1.913057,2.703713,2.915991,8.036254),(34016,'metacarpal.tif',228,5,176,4.916191,11.97856,9.297197,1.8,11.921949,9.313238,0.145248,1.24671,2.767117,1.246962,11.459679,0.017165,4.141379,1.000202,4.580402,1.891551,2.735621,2.769884,8.255324),(34017,'metacarpal.tif',228,5,177,4.967711,11.912199,9.325566,1.8,11.856282,9.345868,0.133232,1.181829,2.789473,1.29399,11.232921,0.01461,4.026897,1.094905,4.473972,2.754551,3.340955,0.703016,14.498141),(34018,'metacarpal.tif',228,5,178,4.978041,11.855646,9.352624,1.8,11.802776,9.371762,0.120897,1.120042,2.833942,1.32641,10.960803,0.012068,3.867687,1.184251,4.32499,2.799506,3.336483,0.84953,10.865744),(34019,'metacarpal.tif',228,5,179,4.944671,11.813381,9.376127,1.8,11.767977,9.394947,0.112796,1.073803,2.861857,1.312395,10.657985,0.010441,3.724151,1.222193,4.179711,2.816177,3.308116,0.711459,10.682462),(34020,'metacarpal.tif',228,5,180,4.923354,11.787244,9.395573,1.8,11.75023,9.413181,0.109253,1.043815,2.847081,1.264331,10.556883,0.009755,3.707967,1.21126,4.146713,2.813751,3.311781,0.533708,10.707768),(34021,'metacarpal.tif',228,5,181,4.830598,11.777415,9.409698,1.8,11.74496,9.425586,0.106324,1.022329,2.850336,1.198766,10.427264,0.009067,3.658258,1.172584,4.076577,2.784341,3.324997,0.428778,10.657156),(34022,'metacarpal.tif',228,5,182,4.748707,11.78594,9.428021,1.8,11.752683,9.445486,0.107301,1.007152,2.797038,1.12878,10.354443,0.009077,3.701932,1.120764,4.103846,2.745479,3.324997,0.428778,10.564616),(34023,'metacarpal.tif',228,5,183,4.760987,11.80812,9.447027,1.8,11.781593,9.46464,0.106667,0.989229,2.729955,1.073507,10.525749,0.008994,3.85565,1.085195,4.247521,2.721485,3.343189,0.44053,10.528828),(34024,'metacarpal.tif',228,5,184,4.741211,11.787746,9.464359,1.8,11.759019,9.479179,0.102772,0.961277,2.705182,1.017684,10.516959,0.008317,3.887709,1.058679,4.262682,2.757791,3.329765,0.399781,10.431946),(34025,'metacarpal.tif',228,5,185,4.682911,11.720542,9.478951,1.8,11.706135,9.49212,0.100941,0.935964,2.72747,0.963816,10.201459,0.007925,3.740265,1.029758,4.092869,2.73146,3.346815,0.411671,10.518346),(34026,'metacarpal.tif',228,5,186,4.611506,11.637456,9.49216,1.8,11.636419,9.502241,0.105805,0.924418,2.765962,0.906037,9.657577,0.008572,3.49158,0.980116,3.819023,2.696097,3.346815,0.411671,10.40664),(34027,'metacarpal.tif',228,5,187,4.535126,11.541719,9.506336,1.8,11.540235,9.514737,0.116044,0.920165,2.793686,0.835001,8.925021,0.010133,3.194712,0.907447,3.488548,2.645369,3.329765,0.399781,10.259146),(34028,'metacarpal.tif',228,5,188,4.398998,11.453286,9.520788,1.8,11.445202,9.529268,0.126733,0.915382,2.821797,0.763227,8.082429,0.011713,2.864285,0.833779,3.124806,2.597457,3.324997,0.428778,10.294934),(34029,'metacarpal.tif',228,5,189,4.258386,11.392638,9.535115,1.8,11.369277,9.542611,0.129398,0.898271,2.838921,0.712272,7.394175,0.011818,2.604572,0.792936,2.840048,2.559622,3.304165,0.446106,10.208534),(34030,'metacarpal.tif',228,5,190,4.06909,11.345962,9.55287,1.8,11.31364,9.560831,0.131503,0.878311,2.840656,0.649962,6.826356,0.01166,2.403091,0.740014,2.619897,2.523996,3.273238,0.392761,9.999946),(34031,'metacarpal.tif',228,5,191,3.761939,11.268929,9.573348,1.8,11.234436,9.578938,0.135474,0.854525,2.829668,0.567344,5.933231,0.011437,2.096794,0.663929,2.288944,2.475321,3.228459,0.427735,9.618558),(34032,'metacarpal.tif',228,5,192,3.414506,11.162598,9.605554,1.8,11.137187,9.599464,0.132243,0.803197,2.801559,0.473395,4.899541,0.009894,1.748862,0.589389,1.911835,2.417957,3.171304,0.420991,9.471064),(34033,'metacarpal.tif',228,5,193,2.996351,11.04538,9.642655,1.8,11.027162,9.636782,0.129407,0.746834,2.82669,0.349278,3.834902,0.008316,1.356676,0.467678,1.47693,2.369109,3.131926,0.426627,9.477204),(34034,'metacarpal.tif',228,5,194,2.597594,10.927873,9.654162,1.8,10.933824,9.654939,0.13707,0.730523,2.814507,0.257986,2.844994,0.008083,1.010832,0.353153,1.100763,2.307327,3.297097,0.551655,9.787016),(34035,'metacarpal.tif',228,5,195,2.308631,10.774181,9.65046,1.8,10.814256,9.661248,0.147231,0.725181,2.840341,0.214795,1.934602,0.008281,0.681116,0.296194,0.755954,2.256319,3.379555,0.566729,9.84197),(34036,'metacarpal.tif',228,5,196,2.078066,10.627405,9.657955,1.8,10.670537,9.668531,0.139666,0.688405,2.769686,0.188721,1.151547,0.006712,0.415768,0.274143,0.483168,2.240026,3.356559,0.555871,9.557464),(34037,'metacarpal.tif',228,5,197,1.886268,10.556436,9.702743,1.8,10.572583,9.709161,0.102135,0.630266,2.355299,0.161351,0.755307,0.003268,0.320684,0.256004,0.386952,2.2032,3.290014,0.522403,9.313088),(34038,'metacarpal.tif',228,5,198,1.718541,10.566034,9.765105,1.8,10.568889,9.765595,0.027215,0.572014,2.145678,0.120367,0.619052,0.000212,0.288511,0.210426,0.339547,2.111929,3.224121,0.614019,9.1045),(34039,'metacarpal.tif',228,5,199,1.486638,10.560849,9.837,1.8,10.566448,9.830188,-0.009007,0.502847,2.050241,0.074038,0.518665,0.00002,0.252977,0.147237,0.28433,1.985898,3.300491,0.646119,9.083536),(34040,'metacarpal.tif',228,5,200,1.185908,10.502322,9.914178,1.8,10.521725,9.904208,0.015882,0.365485,2.029885,0.036905,0.409078,0.00005,0.201527,0.100975,0.218076,2.111954,3.284337,0.617191,9.479748),(34041,'metacarpal.tif',228,5,201,0.881214,10.377404,9.972115,1.8,10.407101,9.964445,0.067213,0.334217,2.117621,0.018568,0.265374,0.000662,0.125317,0.055558,0.133988,2.103479,3.200884,0.554307,9.368042),(34042,'metacarpal.tif',228,5,202,0.669193,10.249418,10.005011,1.8,10.265644,9.998086,0.089484,0.286746,1.081701,0.010656,0.154822,0.000891,0.143128,0.037163,0.152406,1.995596,2.912398,0.363979,8.605266),(34043,'metacarpal.tif',228,5,203,0.552651,10.174319,10.025544,1.8,10.189849,10.019659,0.111487,0.272001,1.06999,0.007055,0.117499,0.00114,0.109813,0.025938,0.116275,2.322033,4.771596,0.09066,15.650989),(34044,'metacarpal.tif',228,5,204,0.491381,10.099958,10.014951,1.8,10.106541,9.998965,0.192306,0.642053,1.060817,0.010248,0.101027,0.002992,0.095235,0.015961,0.104871,1.922484,2.842678,0.292912,8.62623),(34045,'metacarpal.tif',228,5,205,0.466807,10.023626,9.964905,1.8,10.034248,9.946981,0.353944,0.550861,1.091724,0.018429,0.098473,0.009346,0.090199,0.033455,0.105977,1.90041,2.830507,0.2783,8.53983),(34046,'metacarpal.tif',228,5,206,0.493187,9.945429,9.869714,1.8,9.962762,9.859653,0.580913,0.514345,1.109693,0.027954,0.105636,0.024755,0.095194,0.054349,0.115129,1.893527,2.801346,0.297365,8.392336),(34047,'metacarpal.tif',228,5,207,0.618292,10.050764,9.794403,1.8,10.102277,9.802444,0.305956,0.591384,2.524108,0.058453,0.317381,0.009349,0.12574,0.098841,0.147264,1.898682,2.773561,2.223643,8.377512),(34048,'metacarpal.tif',228,5,208,0.792617,10.143952,9.744342,1.8,10.165096,9.755121,0.264445,0.610265,2.544111,0.077616,0.546046,0.009025,0.214631,0.127183,0.244213,1.882282,2.757027,2.189224,8.337382),(34049,'metacarpal.tif',228,5,209,1.023128,10.205495,9.715055,1.8,10.238006,9.730981,0.254971,0.641552,2.535734,0.088455,0.64445,0.010847,0.254147,0.137876,0.288422,2.451189,3.273238,1.963557,14.451871),(34050,'metacarpal.tif',228,5,210,1.267572,10.273118,9.693088,1.8,10.303254,9.708386,0.245753,0.674142,2.476898,0.09942,0.675807,0.012504,0.272844,0.147476,0.31271,2.546134,3.41526,0.605545,14.462353),(34051,'metacarpal.tif',228,5,211,1.466247,10.312523,9.672317,1.8,10.332729,9.690303,0.234241,0.696266,2.444419,0.114536,0.651812,0.013165,0.266653,0.164501,0.313455,2.672347,3.522589,0.584601,15.041847),(34052,'metacarpal.tif',228,5,212,1.574309,10.342154,9.655091,1.8,10.354827,9.674347,0.220463,0.710325,2.41967,0.125842,0.610965,0.012548,0.252499,0.177161,0.304504,2.759931,3.606618,0.597969,15.412753),(34053,'metacarpal.tif',228,5,213,1.631095,10.359345,9.651839,1.8,10.364014,9.675717,0.200049,0.702497,2.402734,0.134299,0.542548,0.010735,0.225804,0.191174,0.281588,2.794021,3.62082,0.62441,13.769355),(34054,'metacarpal.tif',228,5,214,1.61527,10.365214,9.658295,1.8,10.357037,9.680193,0.198625,0.696285,1.099517,0.138211,0.459215,0.010482,0.417651,0.198497,0.535074,2.767975,3.595995,0.674741,11.868555),(34055,'metacarpal.tif',228,5,215,1.560888,10.361018,9.687307,1.8,10.350594,9.702368,0.206291,0.672668,1.090289,0.143317,0.421268,0.010915,0.386382,0.213057,0.503148,2.602975,3.523648,0.707296,11.364979),(34056,'metacarpal.tif',228,5,216,1.440834,10.340804,9.718915,1.8,10.331332,9.723266,0.224678,0.650747,1.101252,0.130305,0.368309,0.01192,0.334446,0.20024,0.442645,2.587166,3.468129,0.882438,10.865744),(34057,'metacarpal.tif',228,5,217,1.304739,10.313207,9.737808,1.8,10.304108,9.741683,0.249623,0.643122,1.087031,0.108946,0.306706,0.013271,0.28215,0.169403,0.376373,2.594294,3.426171,0.838918,10.534968),(34058,'metacarpal.tif',228,5,218,1.169244,10.283507,9.74404,1.8,10.271538,9.754705,0.284952,0.652095,0.995613,0.08538,0.249181,0.0154,0.250279,0.130932,0.330763,2.608754,3.369046,0.857998,10.692944),(34059,'metacarpal.tif',228,5,219,0.987481,10.272526,9.727278,1.8,10.262304,9.739728,0.374344,0.605962,0.943505,0.052579,0.196498,0.022006,0.208263,0.086769,0.261442,2.621185,3.309526,0.94296,10.810791),(34060,'metacarpal.tif',228,5,220,0.864549,10.253257,9.714589,1.8,10.250021,9.72,0.407457,0.460533,0.890752,0.031629,0.161996,0.022627,0.181864,0.068679,0.214772,2.612568,3.259525,0.964413,9.955474),(34061,'metacarpal.tif',228,5,221,0.783521,10.221992,9.722698,1.8,10.223589,9.727596,0.41494,0.405581,0.838043,0.023295,0.135784,0.021223,0.162026,0.057436,0.186962,2.595751,3.224989,0.889779,9.818462),(34062,'metacarpal.tif',228,5,222,0.711273,10.19103,9.73068,1.8,10.193942,9.732792,0.423194,0.390575,0.824793,0.018613,0.113656,0.019993,0.137799,0.047656,0.158168,2.417956,3.188909,0.948972,9.63518),(34063,'metacarpal.tif',228,5,223,0.644062,10.156344,9.745328,1.8,10.159065,9.747333,0.422435,0.401958,0.771514,0.015337,0.094686,0.018043,0.122728,0.038155,0.140105,2.322685,3.139365,0.971344,9.624698),(34064,'metacarpal.tif',228,5,224,0.592983,10.12169,9.769449,1.8,10.124544,9.773276,0.422461,0.365763,0.753833,0.01316,0.078837,0.016614,0.104581,0.035979,0.120318,2.254303,3.115196,0.982794,9.833286),(34065,'metacarpal.tif',228,5,225,0.551242,10.087952,9.794962,1.8,10.090112,9.797462,0.417928,0.365906,0.694762,0.011434,0.065864,0.015134,0.0948,0.031248,0.109377,2.183424,3.158331,0.698241,10.789827),(34066,'metacarpal.tif',228,5,226,0.509255,10.053116,9.823212,1.8,10.05649,9.825649,0.419503,0.326667,0.67582,0.009681,0.054707,0.014081,0.080949,0.029635,0.094125,2.144653,3.1536,0.717541,10.998415),(34067,'metacarpal.tif',228,5,227,0.47193,10.017275,9.851502,1.8,10.021134,9.853556,0.41271,0.322848,0.656996,0.008432,0.044965,0.012654,0.068441,0.026119,0.080564,2.088073,3.130734,0.687671,11.023721),(34068,'metacarpal.tif',228,5,228,0.433469,9.982393,9.880364,1.8,9.985966,9.882043,0.400912,0.31747,0.597221,0.007147,0.036499,0.011003,0.061114,0.022512,0.072286,2.014648,3.103492,0.676915,11.329191),(34069,'metacarpal.tif',228,5,229,0.399044,9.947858,9.910142,1.8,9.951726,9.911558,0.393684,0.273931,0.577139,0.006114,0.029689,0.009786,0.051442,0.02232,0.061598,1.984418,3.103492,0.676915,11.893861),(34070,'metacarpal.tif',228,5,230,0.366547,9.910621,9.938644,1.8,9.911931,9.939703,0.380908,0.269023,0.56008,0.005331,0.023866,0.008443,0.042611,0.019816,0.051906,1.932181,2.300983,0.692334,10.566415),(34071,'metacarpal.tif',228,5,231,0.334551,9.877457,9.966218,1.8,9.881039,9.966534,0.352995,0.262898,0.539458,0.004605,0.019195,0.006664,0.035582,0.017516,0.043963,2.121757,3.147677,0.814516,15.138729),(34072,'metacarpal.tif',228,5,232,0.307768,9.842836,9.992304,1.8,9.847636,9.990736,0.319711,0.258097,0.52131,0.004197,0.015176,0.005067,0.029112,0.016261,0.037047,2.126496,3.158331,0.872555,10.056698),(34073,'metacarpal.tif',228,5,233,0.275322,9.81022,10.019394,1.8,9.815262,10.016308,0.279206,0.25339,0.501577,0.003572,0.011813,0.003485,0.023551,0.014097,0.03058,2.102552,3.153896,0.940993,9.690134),(34074,'metacarpal.tif',228,5,234,0.231665,9.779337,10.037808,1.8,9.782474,10.032369,0.282678,0.227945,0.443259,0.002557,0.008418,0.003004,0.018991,0.011219,0.024683,2.07618,3.163939,0.96007,9.685792),(34075,'metacarpal.tif',228,5,235,0.191876,9.757536,10.057019,1.8,9.7632,10.0532,0.267065,0.200191,0.416946,0.001686,0.006047,0.002227,0.014503,0.008423,0.018502,2.013625,3.163939,0.96007,9.477204),(34076,'metacarpal.tif',228,5,236,0.155518,9.733316,10.07502,1.8,9.738655,10.071,0.265926,0.176221,0.39387,0.001087,0.004119,0.00179,0.010458,0.006168,0.013205,1.964275,3.151232,0.990398,9.426592),(34077,'metacarpal.tif',228,5,237,0.120522,9.704397,10.092699,1.8,9.708565,10.089106,0.267278,0.151787,0.333783,0.000646,0.002527,0.001401,0.00757,0.004258,0.009497,1.921557,3.119088,0.932835,9.451898),(34078,'metacarpal.tif',228,5,238,0.092895,9.68264,10.110325,1.8,9.6904,10.1064,0.248033,0.126133,0.308321,0.000373,0.001582,0.000933,0.005131,0.002957,0.006337,1.872973,3.097172,1.04473,9.279098),(34079,'metacarpal.tif',228,5,239,0.064357,9.651209,10.129534,1.8,9.655784,10.126314,0.252086,0.100308,0.250334,0.000174,0.000799,0.000667,0.003193,0.001739,0.003889,1.79914,3.038161,1.049887,9.019898),(34080,'metacarpal.tif',228,5,240,0.041376,9.620066,10.147538,1.8,9.6246,10.1448,0.241298,0.074017,0.192326,0.000072,0.000342,0.000394,0.001776,0.000966,0.002147,1.691815,2.9961,1.074902,8.836616),(34081,'metacarpal.tif',228,5,241,0.023521,9.586545,10.163993,1.8,9.5904,10.161257,0.255242,0.054379,0.137011,0.000024,0.000112,0.00025,0.000817,0.000449,0.000995,1.655769,2.944263,1.179391,8.566934),(34082,'metacarpal.tif',228,5,242,0.010979,9.555312,10.179533,1.8,9.559543,10.176686,0.244107,0.035197,0.079754,0.000006,0.000024,0.000107,0.000296,0.000174,0.000372,1.63439,2.89182,1.329441,8.225676),(34083,'metacarpal.tif',228,5,243,0.00281,9.522286,10.1952,1.8,9.5256,10.1952,0.299524,0.007351,0.023805,0.0000005484,0.000002,0.000041,0.000067,0.000075,0.000086,1.598552,2.827868,1.244215,7.920206),(34084,'metacarpal.tif',228,5,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34085,'metacarpal.tif',228,5,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34086,'metacarpal.tif',228,5,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34087,'metacarpal.tif',228,5,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34088,'metacarpal.tif',228,5,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34089,'metacarpal.tif',228,5,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34090,'metacarpal.tif',228,5,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34091,'metacarpal.tif',228,5,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34092,'metacarpal.tif',228,5,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34093,'metacarpal.tif',228,5,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34094,'metacarpal.tif',228,5,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34095,'metacarpal.tif',228,5,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34096,'metacarpal.tif',228,5,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34097,'metacarpal.tif',228,5,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34098,'metacarpal.tif',228,5,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34099,'metacarpal.tif',228,5,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34100,'metacarpal.tif',228,5,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34101,'metacarpal.tif',228,5,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34102,'metacarpal.tif',228,5,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34103,'metacarpal.tif',228,5,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34104,'metacarpal.tif',228,5,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34105,'metacarpal.tif',228,5,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34106,'metacarpal.tif',228,5,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34107,'metacarpal.tif',228,5,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34108,'metacarpal.tif',228,5,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34109,'metacarpal.tif',228,5,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34110,'metacarpal.tif',228,5,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34111,'metacarpal.tif',228,5,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34112,'metacarpal.tif',228,5,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34113,'metacarpal.tif',228,5,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34114,'metacarpal.tif',228,5,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34115,'metacarpal.tif',228,5,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34116,'metacarpal.tif',228,5,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34117,'metacarpal.tif',228,5,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34118,'metacarpal.tif',228,5,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34119,'metacarpal.tif',228,5,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34120,'metacarpal.tif',228,5,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34121,'metacarpal.tif',228,5,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34122,'metacarpal.tif',228,5,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34123,'metacarpal.tif',228,5,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34124,'metacarpal.tif',228,5,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34125,'metacarpal.tif',228,5,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34126,'metacarpal.tif',228,5,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34127,'metacarpal.tif',228,5,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34128,'metacarpal.tif',228,5,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34129,'metacarpal.tif',228,5,289,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34130,'metacarpal.tif',228,5,290,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34131,'metacarpal.tif',228,5,291,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34132,'metacarpal.tif',228,5,292,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34133,'metacarpal.tif',228,5,293,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34134,'metacarpal.tif',228,5,294,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34135,'metacarpal.tif',228,5,295,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34136,'metacarpal.tif',228,5,296,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34137,'metacarpal.tif',228,5,297,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34138,'metacarpal.tif',228,5,298,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34139,'metacarpal.tif',228,5,299,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34140,'metacarpal.tif',228,5,300,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34141,'metacarpal.tif',228,5,301,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34142,'metacarpal.tif',228,5,302,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34143,'metacarpal.tif',228,5,303,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34144,'forelimb',252,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34145,'forelimb',252,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34146,'forelimb',252,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34147,'forelimb',252,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34148,'forelimb',252,2,5,0.3567869,110.7714372,119.1676364,1.8,110.8953113,119.2563237,0.8017504,1.000331,5.4260322,0.0674222,6.0929692,0.0307044,1.1229143,0.0673999,1.1341089,0,0,0,0),(34149,'forelimb',252,2,6,17.0545492,112.1449636,120.0749466,1.8,112.2244903,119.5986472,0.8657864,8.2941537,7.8860299,45.4895179,339.5704711,1.6487267,43.0597492,5.4845279,43.8959907,5.585944,6.725681,0.4636476,18.6724547),(34150,'forelimb',252,2,7,58.87885,112.3423087,118.9269678,1.8,112.70331,119.054395,0.9718939,9.1763237,8.1132916,540.4680989,1127.5019753,6.6945391,138.9697342,58.8981072,176.680131,10.1705519,16.998492,1.9325256,48.4304259),(34151,'forelimb',252,2,8,76.8549915,112.8553171,118.9379741,1.8,113.1769941,119.0914694,0.9596583,9.3331279,8.5010931,924.7388535,1561.9364264,8.5917951,183.7335989,99.081344,260.9617469,15.7045819,18.0366624,1.7868813,66.6426556),(34152,'forelimb',252,2,9,84.7319985,113.7020119,119.4134627,1.8,113.4767291,119.1344142,0.8948386,9.430068,9.5267409,1331.5794327,1755.7602293,8.5942072,184.2980979,141.205709,313.9727895,16.9165999,18.8916179,1.8709675,63.3525972),(34153,'forelimb',252,2,10,87.9043082,114.0935563,119.6323447,1.8,113.6806352,119.1459467,0.8948501,9.3943323,9.9424788,1550.2788988,1842.7323833,8.916132,185.3393318,165.0227863,328.1973117,17.5630929,19.3884063,1.7942729,63.456857),(34154,'forelimb',252,2,11,88.3386964,114.4413325,119.7369682,1.8,113.851321,119.2273186,0.8790522,9.4290723,10.274812,1766.06578,1930.9647858,8.732389,187.9318853,187.3000564,343.629897,18.1201506,19.9931938,1.7218117,65.2798688),(34155,'forelimb',252,2,12,84.2405983,114.6019137,119.8350637,1.8,113.9700167,119.2677169,0.9240444,9.5182233,10.5377669,1809.9213148,1959.7380837,8.9418062,185.972806,190.1532735,343.5673937,18.4039624,20.3092932,1.6767807,66.2435046),(34156,'forelimb',252,2,13,83.9907299,114.5472464,119.8476983,1.8,113.9783355,119.3064667,0.9902668,9.6732757,10.7282093,1838.4423777,2029.5781934,9.7874986,189.1814495,190.0537563,352.5245101,18.5855564,20.4858007,1.7393933,66.1392448),(34157,'forelimb',252,2,14,84.6660906,114.5303258,119.8104,1.8,114.028453,119.2882083,0.9891477,9.6655189,10.6859522,1849.9963406,2101.6183948,9.8517069,196.6711393,191.4016569,358.1359593,18.5855564,20.6473915,1.7804362,66.6426556),(34158,'forelimb',252,2,15,84.4119142,114.4667601,119.7396522,1.8,114.0001762,119.1833625,1.1350745,9.8063646,10.9497384,1823.1519153,2138.5717536,11.5624793,195.3080218,185.9151676,356.1211029,18.6454051,20.8431901,1.7156088,66.2866904),(34159,'forelimb',252,2,16,81.4879623,114.3975301,119.5569776,1.8,113.9789429,119.1715063,1.2658576,9.7263164,10.8917504,1739.8391917,2055.4293161,12.357094,188.7143242,178.8795602,345.1048489,18.3459375,20.8431901,1.7156088,66.034985),(34160,'forelimb',252,2,17,80.4943076,114.2205403,119.1920957,1.8,113.8788268,119.0305406,1.278899,9.6695976,10.633931,1630.7107282,2035.1039125,12.3047427,191.3783263,168.6430814,343.116716,18.0690816,20.9095205,1.735945,65.635834),(34161,'forelimb',252,2,18,73.8590332,113.9792956,119.2150012,1.8,113.8166389,118.8740509,1.194177,9.5470222,10.4410538,1391.6094277,1862.5851315,10.6447947,178.3905313,145.7637156,305.206194,17.7179506,20.7855324,1.6951513,65.4273144),(34162,'forelimb',252,2,19,62.8262214,113.6126329,119.2694587,1.8,113.6800377,118.6979718,1.2664919,9.7217186,10.2070693,1016.9250195,1545.2532814,9.5309693,151.3904956,104.6034208,242.5968425,16.6346335,20.3092932,1.6767807,63.1008918),(34163,'forelimb',252,2,20,54.8097894,113.4111438,118.8988946,1.8,113.5317853,118.2830731,1.2638693,9.3884039,9.9432172,866.4309016,1226.7480488,8.301098,123.3753642,92.287348,209.6073262,16.5905974,19.8076381,1.7894653,60.418504),(34164,'forelimb',252,2,21,46.6184607,113.1493021,118.0579273,1.8,113.2616152,117.5573005,1.3352729,9.3139571,9.1050533,757.7246377,852.8345353,7.3466564,93.6660672,81.3536752,172.3627877,15.9029378,18.4565877,1.7818897,56.2258838),(34165,'forelimb',252,2,22,43.8888198,113.0760527,117.6741629,1.8,113.1538518,117.1419993,-0.859179,7.9351874,8.2596802,715.1869186,738.0943703,4.1951375,89.3611314,90.1285478,156.2240819,14.995501,17.617208,0.2213144,53.7952014),(34166,'forelimb',252,2,23,40.5844705,112.9179609,117.3547629,1.8,113.06467,116.8201967,-0.404209,8.1926561,9.1865425,584.6738223,696.0250366,1.046256,75.7657236,71.3656007,137.9546957,14.4437819,17.5279,0.1973956,51.9721897),(34167,'forelimb',252,2,24,38.9328553,112.8331618,117.1522393,1.8,112.9751399,116.7000266,-0.3976121,7.9843499,9.1900895,530.7034757,674.9359152,0.9729167,73.4417133,66.4679633,130.0838295,14.0689089,17.4487192,0.1732457,51.1128137),(34168,'forelimb',252,2,25,38.7745196,112.7105291,116.9891244,1.8,112.904143,116.6009082,-0.4416718,7.5191112,9.005041,507.337115,659.1817852,1.1807793,73.2014197,67.4730169,127.147861,13.7373511,17.1982588,0.2267988,50.2534377),(34169,'forelimb',252,2,26,38.2913997,112.7127015,117.022363,1.8,112.9203233,116.6008881,-0.4961029,7.4356764,8.7367697,488.4224992,647.7867237,1.4459967,74.1448782,65.6863575,125.0953672,13.6131121,16.998492,0.2817719,49.6457671),(34170,'forelimb',252,2,27,38.5437298,112.5779529,116.9999131,1.8,112.8067042,116.5794367,-0.528903,7.2814244,8.6294683,476.2683026,644.9791985,1.6355877,74.7414757,65.4086728,126.1298952,13.2321872,16.5861794,0.2889754,48.5346857),(34171,'forelimb',252,2,28,38.5902794,112.5851205,116.9885379,1.8,112.7891843,116.5597878,-0.5013057,7.3346254,8.4469818,471.3895427,630.1667183,1.4853944,74.6025896,64.2690684,125.4594158,13.013999,16.4688822,0.2639637,47.6753097),(34172,'forelimb',252,2,29,37.2127585,112.4874388,117.0294446,1.8,112.6828617,116.5800943,-0.4972001,7.1596343,8.3859648,451.5825031,593.2503886,1.4109657,70.7432479,63.0734031,121.9167045,12.7610825,16.1747714,0.2965458,46.9633793),(34173,'forelimb',252,2,30,37.0050757,112.3907967,116.9615606,1.8,112.6263636,116.5547834,-0.5718876,6.915058,8.1034364,454.6740607,575.1053503,1.8065836,70.9705515,65.7513008,120.5210018,12.7610825,16.0544686,0.2709469,46.7116739),(34174,'forelimb',252,2,31,36.3027477,112.3337039,116.8740129,1.8,112.5569399,116.5492238,-0.550805,6.7700694,8.0063635,433.1546753,567.779354,1.6573396,70.9160104,63.9808321,121.1369224,12.4572472,15.7643386,0.3045109,45.6005925),(34175,'forelimb',252,2,32,36.1110104,112.3463687,116.8142153,1.8,112.5445438,116.5694404,-0.514337,6.7126311,7.9625591,429.2311341,559.4834196,1.4566123,70.2642721,63.9437992,120.0589513,12.3288644,15.6408793,0.2782997,45.0971817),(34176,'forelimb',252,2,33,35.7006802,112.2102724,116.791724,1.8,112.4453267,116.5579715,-0.5833201,6.4125284,7.7779988,417.5458417,535.5089212,1.8051366,68.8491905,65.1140729,118.1268559,12.1534119,15.4269362,0.2247112,44.8454762),(34177,'forelimb',252,2,34,36.1864856,112.1823437,116.7148706,1.8,112.360485,116.5572605,-0.5435072,6.4312445,7.619119,411.705288,545.4540049,1.6129208,71.5901674,64.0164265,120.3500796,12.1534119,15.4269362,0.2247112,44.5937708),(34178,'forelimb',252,2,35,35.1103621,112.0634982,116.7127775,1.8,112.271336,116.5146555,-0.5990129,6.2227725,7.46523,406.5059029,514.0291493,1.8602725,68.8564383,65.325529,118.4027107,12.1534119,15.1125613,0.2587709,44.2378057),(34179,'forelimb',252,2,36,34.8388974,112.0706095,116.6358994,1.8,112.1904444,116.5049246,-0.6408173,6.1698996,7.2287469,411.1969495,504.4109851,2.0753853,69.778482,66.6456467,120.0714474,12.4242735,15.2584623,0.1697783,44.5937708),(34180,'forelimb',252,2,37,33.9061153,112.033454,116.6133482,1.8,112.0889581,116.4634552,-0.5269369,6.3481267,7.2067825,405.0637563,490.4785187,1.4291226,68.0579049,63.8083915,119.5557054,12.3950071,15.2584623,0.1697783,44.5937708),(34181,'forelimb',252,2,38,33.7351351,112.0407786,116.6554618,1.8,112.0491673,116.4360112,-0.4693567,6.4699278,7.1055643,405.7312531,478.2954427,1.1502934,67.3128021,62.7103214,120.2532612,12.4572472,15.0083566,0.2310907,44.4895111),(34182,'forelimb',252,2,39,33.3323581,111.8748481,116.5728738,1.8,111.9270597,116.4137133,-0.4063997,6.5909355,7.296267,412.3949152,459.9610944,0.8681185,63.0406065,62.5700125,116.3687009,12.6603466,15.3369125,0.1973956,44.8454762),(34183,'forelimb',252,2,40,32.7099811,111.8934153,116.4838755,1.8,111.8890599,116.3183021,-0.3824453,6.5203122,7.2452632,405.3361705,453.3997595,0.7592581,62.5787841,62.1651481,113.9976809,12.6368926,15.2584623,0.1697783,45.0971817),(34184,'forelimb',252,2,41,33.537691,111.7734317,116.4951246,1.8,111.772017,116.3739427,-0.2585112,6.7085345,7.3217048,417.0403676,447.0649881,0.3652958,61.0602308,62.1656443,115.5217411,12.4572472,14.9158068,0.2030452,44.2378057),(34185,'forelimb',252,2,42,33.3364983,111.7602509,116.4502501,1.8,111.7669996,116.2821123,-0.1377544,6.8584468,7.393826,419.7177146,446.9597656,0.1047685,60.450404,61.1971963,116.18998,12.4572472,14.9158068,0.2030452,44.7412165),(34186,'forelimb',252,2,43,32.5522608,111.6767029,116.491588,1.8,111.5474579,116.2249403,0.0488321,6.9778791,7.3190365,419.5250954,439.5060628,0.0129269,60.0497157,60.1221499,116.3331028,12.4572472,14.8351299,0.1746722,44.7412165),(34187,'forelimb',252,2,44,33.1188566,111.7707462,116.4700346,1.8,111.6667515,116.1944864,0.3276247,6.9307249,7.3879883,420.8520011,443.4301119,0.5715873,60.0204136,60.7226528,115.6550494,12.4572472,14.8351299,0.1746722,44.9929219),(34188,'forelimb',252,2,45,33.937167,111.7358409,116.4279041,1.8,111.5470048,116.2339668,0.4621306,6.7053227,7.1220215,414.4461851,455.5939367,1.1243822,63.9697506,61.8085367,112.0854357,12.230838,15.0942245,0.0855053,44.8454762),(34189,'forelimb',252,2,46,33.3402469,111.7470478,116.4926362,1.8,111.5387386,116.2255351,0.5180069,6.6905934,7.2452536,402.3155073,460.1749522,1.3623548,63.5139879,60.1315135,110.9000684,12.1534119,15.0636136,3.0845119,44.8454762),(34190,'forelimb',252,2,47,33.0003565,111.6639252,116.4506043,1.8,111.5015475,116.2057186,0.6355325,6.4990064,6.8575933,393.5136364,448.8194441,1.938046,65.4485363,60.549815,113.0362253,11.9310702,14.5904229,2.9037567,43.8818405),(34191,'forelimb',252,2,48,34.4022153,111.6843518,116.4251434,1.8,111.5897344,116.2517297,0.7444396,6.2044828,6.4977733,392.0830411,467.2083895,2.6322697,71.9028459,63.1935094,115.0950784,11.9310702,14.5904229,2.9037567,43.8818405),(34192,'forelimb',252,2,49,34.5099171,111.6886567,116.4262775,1.8,111.5135205,116.1452437,0.8450363,5.6502901,6.4569997,382.6842471,467.113023,3.2180317,72.342116,67.7282482,113.7556089,11.557827,14.5904229,2.9037567,43.2741699),(34193,'forelimb',252,2,50,33.9168015,111.7232087,116.5051073,1.8,111.519382,116.1905339,0.8879561,5.5767263,6.4535316,373.3938359,466.0024774,3.4020833,72.2089097,66.9557398,116.17903,11.5179504,14.283491,2.8674252,43.1699101),(34194,'forelimb',252,2,51,34.8714597,111.7497316,116.478543,1.8,111.558977,116.2183038,0.9407197,5.6146218,6.5878316,365.9208038,468.2058831,3.794221,71.071319,65.1728322,117.077054,11.3536479,14.1731921,2.896614,42.9182047),(34195,'forelimb',252,2,52,36.7839093,111.7791569,116.4924935,1.8,111.68763,116.2931041,0.8814355,5.5257363,6.4804409,365.8304495,478.476002,3.6504838,73.8338657,66.2048333,120.3522838,11.2934392,14.1731921,1.3258177,42.8139449),(34196,'forelimb',252,2,53,36.0519282,111.7323247,116.5269264,1.8,111.7092732,116.3100788,0.9538368,5.5866981,6.572558,361.0318097,475.8389278,3.9973821,72.3978282,64.6234685,120.98287,11.1779822,14.1731921,1.3258177,42.2062743),(34197,'forelimb',252,2,54,35.074219,111.8566011,116.5627695,1.8,111.8370671,116.3318418,1.0567371,5.5984822,6.7101276,344.78711,481.0124318,4.4323027,71.6845433,61.585819,118.9883423,11.0482227,14.1731921,1.3258177,41.5986037),(34198,'forelimb',252,2,55,36.2019275,111.9810689,116.6885303,1.8,111.9355682,116.3993441,1.1289491,5.6723236,6.6178585,339.4310984,495.3090825,4.9303987,74.8443147,59.8398682,120.6018026,10.9578265,14.283491,1.2966289,41.2426385),(34199,'forelimb',252,2,56,36.7279602,112.076933,116.8025185,1.8,112.056626,116.5026772,1.1829984,5.6077907,6.7109779,339.6226032,502.8842039,5.2459893,74.9345646,60.5626387,121.4485893,10.7650098,14.283491,1.2966289,41.2426385),(34200,'forelimb',252,2,57,38.6103092,112.1886236,116.9876815,1.8,112.1145969,116.633666,1.2712247,5.6158499,7.0685865,337.9337068,533.4935403,5.8746198,75.4738651,60.1749894,122.5147075,10.8491968,14.4121737,1.3909428,41.2426385),(34201,'forelimb',252,2,58,39.8591473,112.258042,117.1825604,1.8,112.2363148,116.70507,1.3175576,5.6871553,7.3967676,329.7768381,560.850041,6.2261937,75.8236669,57.9862551,116.8977711,10.8218779,14.7665205,1.4247841,40.9909331),(34202,'forelimb',252,2,59,40.0223506,112.3042558,117.2187802,1.8,112.2004583,116.7094512,1.3446279,5.4653786,7.5848258,317.2060889,559.3119141,6.3349652,73.740904,58.0391798,114.2681898,10.6471081,14.8351299,1.3961241,40.6349679),(34203,'forelimb',252,2,60,38.9049927,112.3131627,117.2338311,1.8,112.3144779,116.7949773,1.347042,5.4611377,7.604219,305.9532003,540.3149569,6.1649109,71.0546287,56.0237106,110.0994263,10.312512,14.8351299,1.3961241,40.5307081),(34204,'forelimb',252,2,61,38.0269847,112.4153054,117.3015492,1.8,112.3414502,116.8340769,1.3704026,5.3831715,7.8005552,298.1163162,529.9597343,6.0867072,67.9387201,55.3793086,105.9911081,10.312512,14.9158068,1.7738415,40.7824135),(34205,'forelimb',252,2,62,38.4536519,112.4552253,117.3805826,1.8,112.439463,116.9312236,1.4094673,5.3609442,7.9650463,289.318014,548.5850946,6.2435782,68.8740626,53.9677348,105.1124822,10.2880099,15.1917649,1.7126934,41.3900841),(34206,'forelimb',252,2,63,40.0156367,112.4622645,117.5928485,1.8,112.4494436,117.078227,1.433443,5.3208633,8.1663052,280.0204386,586.4757148,6.5442399,71.8165314,52.6268812,105.9163747,9.882824,15.2584623,1.7405746,41.6417895),(34207,'forelimb',252,2,64,42.356432,112.4828448,117.8112493,1.8,112.4572041,117.2087217,1.4478294,5.3268334,8.3776982,274.1799695,634.8965885,6.953198,75.7841324,51.4714745,108.2340054,9.882824,15.3369125,1.7681919,41.6417895),(34208,'forelimb',252,2,65,43.8625238,112.5395208,117.9177627,1.8,112.5143584,117.3159366,1.4406129,5.2306009,8.4390012,265.722239,660.7150744,7.187224,78.293042,50.8014742,109.7616618,9.882824,15.3369125,1.7681919,41.2858243),(34209,'forelimb',252,2,66,43.4668523,112.6647648,118.0018667,1.8,112.6242611,117.4676822,1.4287445,5.1173662,8.5412481,259.497319,664.9235784,7.0992717,77.8485262,50.7091561,108.2092485,9.453136,15.6172526,1.7088024,41.5375297),(34210,'forelimb',252,2,67,43.0550674,112.727282,117.9945512,1.8,112.6415001,117.5624508,1.4182015,4.9885728,8.4795034,253.0687376,649.7615093,7.0100465,76.6273072,50.7296876,106.4124796,9.453136,15.6172526,1.7088024,41.5375297),(34211,'forelimb',252,2,68,43.3795718,112.7305951,118.064948,1.8,112.667157,117.6326463,1.4297369,5.0006727,8.6127871,250.4335603,656.5893446,7.0870209,76.2342475,50.0799745,105.2727375,9.453136,15.7584815,1.7628443,41.5375297),(34212,'forelimb',252,2,69,43.6307829,112.7346363,118.441881,1.8,112.6683216,117.9305923,1.4352861,4.9915531,8.5596371,242.8857831,652.2886286,7.1390803,76.2051735,48.6593609,104.5201898,9.453136,15.5639613,1.6814535,41.2858243),(34213,'forelimb',252,2,70,44.326565,112.789294,118.5203363,1.8,112.7196007,118.0841046,1.4296108,4.9461268,8.5860565,238.368972,655.8813178,7.2414738,76.3891219,48.1930573,104.1377764,9.453136,15.5639613,1.6814535,41.0341189),(34214,'forelimb',252,2,71,44.1429962,112.8503416,118.7863606,1.8,112.8002456,118.3757094,1.406308,4.8497621,8.4993847,236.7529515,626.001133,7.1598963,73.6525238,48.8174357,101.4871191,9.453136,15.3369125,1.7681919,40.4264483),(34215,'forelimb',252,2,72,45.6826574,112.9007684,119.151738,1.8,112.8666244,118.6683673,1.4150521,4.8617688,8.7330329,240.4276186,620.1402331,7.4305829,71.0108666,49.4527049,98.3023283,9.023448,15.4926212,1.6262948,40.5307081),(34216,'forelimb',252,2,73,46.207739,112.9810532,119.3898667,1.8,112.9441101,118.9988046,1.4069714,4.8196319,8.6219987,237.6056836,610.2428457,7.4964404,70.7774226,49.2995501,98.3214076,9.023448,15.1917649,1.7126934,39.8187777),(34217,'forelimb',252,2,74,47.0412116,113.0154667,119.5484152,1.8,112.9572236,119.2063609,1.4197801,4.8089382,8.4249282,237.5781988,605.4610789,7.6627542,71.8654285,49.4034623,99.9133902,9.023448,15.1369758,1.6845883,39.3153669),(34218,'forelimb',252,2,75,44.8773271,113.0793213,119.6759177,1.8,113.0089364,119.5128051,1.4111645,4.6996968,7.8527974,232.4232974,563.2010839,7.2905714,71.719803,49.4549554,99.7019348,9.023448,14.4952048,1.7798193,38.6034365),(34219,'forelimb',252,2,76,44.6641614,113.1159859,119.8465747,1.8,113.0893477,119.7860919,1.430763,4.6881879,7.5121226,236.4406345,547.4125587,7.2990061,72.8705568,50.4332678,102.995874,9.023448,14.0751518,1.786154,37.4923551),(34220,'forelimb',252,2,77,45.9041596,113.1136262,120.3353315,1.8,113.1204813,120.2625097,1.4926683,4.7091707,7.0525894,246.7427662,522.7455973,7.6040884,74.1210872,52.396225,106.0387046,9.023448,13.5675304,1.7619808,37.1363899),(34221,'forelimb',252,2,78,48.5532899,113.1855375,120.6191533,1.8,113.1925283,120.5506831,1.5394622,4.958898,6.8079296,253.4780158,523.7939806,8.0842724,76.9388071,51.1157953,110.8316608,9.4350396,13.145925,1.7681919,36.6329791),(34222,'forelimb',252,2,79,49.9091026,113.274319,120.9606671,1.8,113.2782003,120.9221748,-1.552903,4.9159442,6.6578263,259.8981691,506.1089967,8.3155208,76.0171524,52.8684128,111.9437282,9.4507994,13.145925,1.3734008,36.6329791),(34223,'forelimb',252,2,80,49.3404926,113.2701177,121.1999918,1.8,113.3572516,121.1601078,-1.4863457,5.019258,6.4643559,259.6052358,507.7324476,8.1649061,78.5433928,51.7218348,115.2752721,9.453136,13.145925,1.3734008,36.6329791),(34224,'forelimb',252,2,81,46.6091732,113.3181329,121.4574345,1.8,113.3892165,121.5048729,-1.397235,5.0949874,6.3012233,257.2965985,486.2237302,7.5365302,77.1633862,50.499948,114.5358915,9.332761,13.047241,1.2698761,36.2770139),(34225,'forelimb',252,2,82,46.5148432,113.3464556,121.6420328,1.8,113.4027647,121.6981018,-1.3147262,5.1945953,6.4103624,260.5740846,491.1857191,7.2551436,76.6237056,50.162538,116.0657356,9.417164,13.047241,1.2698761,36.2770139),(34226,'forelimb',252,2,83,50.1652372,113.3287388,122.0342214,1.8,113.3977934,121.9763768,-1.2166255,5.1304492,6.3909999,270.2805144,512.6990505,7.3552344,80.2220396,52.681647,120.4572276,9.5837339,13.1809902,1.2387369,36.6329791),(34227,'forelimb',252,2,84,49.7853433,113.2742491,122.2328156,1.8,113.3814572,122.1969599,-1.1471172,5.2580456,6.4695259,264.22921,529.0838497,6.8951271,81.7809306,50.2523619,121.3873428,9.6553937,13.3272566,1.2082521,36.8846845),(34228,'forelimb',252,2,85,50.5592302,113.2967131,122.3749566,1.8,113.3274077,122.3919563,-1.065171,5.340748,6.7671692,265.1858134,550.8445531,6.4496775,81.3995536,49.6533098,120.2420379,9.9022354,13.4856331,1.0358413,37.2406497),(34229,'forelimb',252,2,86,49.9929701,113.2966827,122.4617378,1.8,113.3316051,122.5113033,-0.9951516,5.252276,6.9475576,264.076885,570.1795037,5.8629679,82.0690573,50.2785618,119.8327869,9.9205692,13.7096736,1.0088748,37.2406497),(34230,'forelimb',252,2,87,50.9367742,113.2418806,122.6315428,1.8,113.2772026,122.7031313,-0.9188508,5.3735883,7.0537932,260.4529185,615.8518996,5.3642689,87.3079036,48.4690872,124.1073876,10.0265649,13.943359,0.9827937,37.8483203),(34231,'forelimb',252,2,88,52.6276656,113.2659954,122.7749773,1.8,113.2777273,122.8586084,-0.8703988,5.2044446,7.2436286,265.6454682,648.4296193,5.1276171,89.5172378,51.0420399,124.8252635,9.9991973,14.1862129,0.957589,38.4559909),(34232,'forelimb',252,2,89,50.2421671,113.1785504,122.8390245,1.8,113.1570194,122.9907362,-0.8085456,5.4080345,7.7420529,249.8298352,673.7419534,4.3806079,87.0236828,46.1960503,118.9739876,10.0265649,14.6346459,0.8685394,39.3153669),(34233,'forelimb',252,2,90,48.0671488,113.1361586,122.8458763,1.8,113.1387955,123.0428387,-0.7705489,5.4023151,7.7408689,242.0693385,685.5057825,3.8866527,88.5566975,44.8084448,117.7429803,10.0265649,14.9652379,0.6837093,40.2790027),(34234,'forelimb',252,2,91,48.3360398,112.8795668,123.03051,1.8,112.3993587,123.3881695,-0.6315261,5.2742853,9.4731925,250.5499143,802.0913803,2.8078828,84.6695959,47.5040502,104.69252,10.0505348,17.1552631,0.3851575,48.6821313),(34235,'forelimb',252,2,92,51.4885994,112.7406343,123.1107174,1.8,112.1213726,123.5100471,-0.5565507,5.3700373,9.7262171,257.0111376,955.025243,2.3947282,98.1908216,47.8602142,118.4943321,10.1778192,17.5542142,0.375961,49.4372475),(34236,'forelimb',252,2,93,50.872265,112.9454672,123.0172698,1.8,112.044172,123.5224396,-0.506503,5.3858538,10.3608953,253.6782432,995.9743298,1.9954104,96.1282108,47.1008405,117.3679243,10.1761077,18.1132733,0.3893167,49.6889529),(34237,'forelimb',252,2,94,50.8888259,113.0871594,123.0803541,1.8,112.1081444,123.522574,-0.472676,5.2032206,10.7309888,256.190221,1016.7902245,1.7579646,94.752706,49.2368552,116.9216196,10.0274973,18.5115256,0.3805064,51.2602593),(34238,'forelimb',252,2,95,50.9414739,113.1454284,123.1451901,1.8,112.0615806,123.5274261,-0.4311408,5.1999762,10.8239467,251.1777916,1075.3023172,1.482793,99.3447532,48.3036429,120.1161012,9.8072783,18.6753695,0.4018706,50.8000343),(34239,'forelimb',252,2,96,50.1386055,113.2485502,123.1088471,1.8,112.2290422,123.5234873,-0.4135559,5.192357,11.0053575,241.5059259,1096.6016363,1.3495464,99.6425274,46.5118104,119.1174399,9.7659785,19.163314,0.3430239,50.8000343),(34240,'forelimb',252,2,97,52.2508489,113.3180902,123.1094541,1.8,112.4232285,123.516541,-0.388822,5.2133213,11.1218191,237.1349197,1149.0646251,1.2515449,103.3162483,45.4863425,122.6574833,9.6478852,19.4312116,0.3147577,51.4077049),(34241,'forelimb',252,2,98,52.8015552,113.5280758,123.1103471,1.8,112.4396236,123.5142511,-0.3716923,5.1705658,11.3498805,233.8661703,1168.6786533,1.1608328,102.9683664,45.2302858,121.8899922,9.6068891,19.7142053,0.2872815,51.7636701),(34242,'forelimb',252,2,99,53.3259094,113.6424393,123.1889275,1.8,112.6471821,123.4979039,-0.3374834,5.128097,11.4898749,232.234177,1191.4415805,0.974408,103.6949136,45.2866198,122.6999191,9.5146286,20.126652,0.2812322,52.7704917),(34243,'forelimb',252,2,100,51.4533516,113.8064538,123.1503431,1.8,112.7562377,123.4939695,-0.3278793,5.0872036,11.6725638,224.4321913,1189.1384813,0.8893474,101.8746611,44.1170059,120.0861271,9.3534511,20.2501155,0.301619,52.4145265),(34244,'forelimb',252,2,101,50.8625858,113.9879618,123.1154121,1.8,112.8943995,123.4481008,-0.3013477,5.1282686,11.8925152,221.6544384,1216.5457989,0.7467868,102.2950807,43.2220803,120.2896817,9.3802393,20.6608003,0.2954408,53.6298677),(34245,'forelimb',252,2,102,52.0168142,114.0468024,123.1894529,1.8,112.9834962,123.5115931,-0.2766386,4.9707379,11.9556999,223.3738184,1270.7479403,0.646712,106.2880423,44.9377584,124.5148166,9.0710879,20.9536242,0.2698492,54.8452089),(34246,'forelimb',252,2,103,49.9082074,113.9087604,123.3588463,1.8,112.9225851,123.5533845,-0.2332665,4.8081036,14.820365,213.0372671,1343.3185483,0.4444615,90.6400447,44.3079612,104.840011,9.023448,21.2597881,0.2449787,57.5275967),(34247,'forelimb',252,2,104,48.2309116,113.9156147,123.4483703,1.8,113.0711555,123.5906101,-0.1964491,4.5804984,13.5037972,201.0514266,1332.2433262,0.3062529,98.6569414,43.8929151,112.7921844,8.164072,18.5214968,3.0719381,46.0429293),(34248,'forelimb',252,2,105,47.1434304,114.1933038,123.4908097,1.8,113.3113411,123.6014346,-0.1588615,4.3464343,12.0223158,187.8074308,1366.2058314,0.1966303,113.6391567,43.2095413,129.2034639,7.734384,18.9842363,3.0509328,46.0429293),(34249,'forelimb',252,2,106,46.181331,114.369879,123.5037696,1.8,113.4806763,123.6338488,-0.138076,4.2302006,12.1411285,178.5220407,1450.9707797,0.1458109,119.5087242,42.2017911,134.0645746,7.734384,19.3788812,3.0750245,46.9023053),(34250,'forelimb',252,2,107,47.8362472,114.8514537,123.4683109,1.8,113.7345345,123.5927409,-0.1077872,4.100358,12.6354393,167.233196,1635.2896868,0.0922694,129.4208814,40.785023,142.634637,8.4412339,22.1820578,0.1555948,57.8835619),(34251,'forelimb',252,2,108,50.1370948,115.1250733,123.460197,1.8,113.9702735,123.575695,-0.0898311,3.7527495,12.8720379,160.748159,1813.6204171,0.0672501,140.8961375,42.834769,153.2960356,7.7746601,22.4920224,0.1148766,57.1716315),(34252,'forelimb',252,2,109,50.5530199,115.1778167,123.452642,1.8,114.121258,123.5820052,-0.0679635,3.6755797,12.9316478,153.3261746,1929.5937279,0.0388578,149.2148374,41.7148279,161.0604667,7.734384,22.8382305,0.0753289,55.9562903),(34253,'forelimb',252,2,110,49.6299169,115.0237491,123.4996987,1.8,114.2166925,123.5513631,-0.0536546,3.7569746,12.393138,152.6444085,1988.0115539,0.0237897,160.4122828,40.6296089,172.2991041,7.734384,22.606653,0.1526493,55.7477707),(34254,'forelimb',252,2,111,48.4349577,114.8602242,123.5548864,1.8,114.3795653,123.5486262,-0.0287874,3.5134737,12.190108,147.1709482,2055.8028034,0.006688,168.6451678,41.8875909,180.4174855,7.304696,22.9189312,0.1127276,55.6435109),(34255,'forelimb',252,2,112,47.2133667,114.6610409,123.5679544,1.8,114.5245666,123.5232374,-0.0144968,3.7074694,11.9794504,140.9055708,2125.5080545,0.0016536,177.4295127,38.0058622,188.6970984,7.734384,23.3024045,0.0923293,56.7114065),(34256,'forelimb',252,2,113,46.0225477,114.6765577,123.5114963,1.8,114.6975756,123.4576455,-0.000867,3.6825271,11.9817007,134.6804368,2179.5640966,0.0000058,181.9077403,36.5728295,192.8576981,7.734384,23.345942,3.0309354,57.5707825),(34257,'forelimb',252,2,114,47.2270183,114.8303333,123.4641677,1.8,114.8821961,123.3674234,0.0142538,3.6834912,12.1479659,134.0378274,2299.2001843,0.0015991,189.2662691,36.3888011,199.8341214,7.734384,23.8234776,3.0150005,58.5344183),(34258,'forelimb',252,2,115,48.5339315,114.7179746,123.3483925,1.8,115.1791938,123.2612737,0.0386809,3.7290505,12.0963652,135.599997,2579.232781,0.0120968,213.223785,36.3631431,223.2936282,7.734384,24.732268,3.0021526,60.6091355),(34259,'forelimb',252,2,116,48.7001001,114.9179834,123.2388148,1.8,115.2923917,123.1736158,0.0466609,3.6728649,12.6747451,135.3917024,2742.3148447,0.0176591,216.3605519,36.8626956,227.0179205,7.734384,25.4823461,3.0402462,62.2847017),(34260,'forelimb',252,2,117,48.5875307,115.6163185,123.1844719,1.8,115.4751848,123.0946388,0.0724346,3.9369144,13.399016,144.753024,2765.3230452,0.0424137,206.3825469,36.7681412,217.1653611,8.0963807,25.6448512,2.9902172,63.1440777),(34261,'forelimb',252,2,118,50.5674547,115.706662,123.1185759,1.8,115.7365183,123.0834059,0.0888372,4.0976243,13.0944986,161.8716905,2812.2479795,0.0663387,214.7656102,39.5037903,227.0432779,8.59376,25.5835817,3.0068214,64.3594188),(34262,'forelimb',252,2,119,58.944702,114.9277394,122.6136732,1.8,115.190244,122.6795008,0.1463761,4.7069457,12.9076696,229.754703,3246.2780312,0.2089923,251.4999315,48.8118446,269.0567384,9.5295133,25.6448512,2.9902172,66.5383958),(34263,'forelimb',252,2,120,67.3256419,114.4014181,122.2162875,1.8,114.9129974,122.5398488,0.1883319,5.2655202,13.4302951,304.4341931,3552.9134751,0.3933112,264.5447074,57.8165468,287.200311,10.3856191,25.5835817,3.0068214,66.894361),(34264,'forelimb',252,2,121,69.0591665,114.1615117,122.0240199,1.8,114.4814636,122.3726773,0.206032,5.416162,13.3674779,361.4007127,3147.9221078,0.48171,235.4911018,66.7263484,262.4666178,10.7189297,25.2201601,2.987648,66.034985),(34265,'forelimb',252,2,122,70.2766732,114.1542239,121.9745891,1.8,114.259737,122.300429,0.219112,5.5261298,13.0619243,384.5330052,2942.5134062,0.5533898,225.2741122,69.5845049,254.3777442,10.8727889,24.6087836,2.9304993,64.8628297),(34266,'forelimb',252,2,123,67.5195053,113.676024,121.9046259,1.8,113.7194704,122.1468995,0.2540843,5.6376145,12.618047,376.3042448,2234.371814,0.7109968,177.0774683,66.7488434,206.8992159,10.8727889,23.5389032,2.7678658,62.0329962),(34267,'forelimb',252,2,124,66.4477458,113.3572442,121.9073136,1.8,113.2187439,122.0298755,0.2913477,5.8573882,10.3608341,344.7045916,1893.2804955,0.9137537,182.73437,58.849538,213.3744498,10.7654715,20.8254663,2.7610863,58.3437868),(34268,'forelimb',252,2,125,64.2281921,113.2129497,121.8973955,1.8,112.9389178,121.9658171,0.3242243,5.6342014,9.5329924,272.5818491,1591.9431336,1.0864105,166.9930149,48.3798554,191.0304246,10.2870188,19.4549516,2.6087488,55.0537285),(34269,'forelimb',252,2,126,54.0985654,113.1959116,121.7487645,1.8,112.8011286,121.8521948,0.3401174,5.669965,9.3560859,205.166479,1223.7030545,1.0034156,130.7921996,36.1847878,151.0318388,10.1230421,18.9501664,2.566168,52.9790113),(34270,'forelimb',252,2,127,39.6205807,112.8697143,121.5793985,1.8,112.4139132,121.726673,0.3327734,5.3003586,8.5859003,127.9654923,949.2762778,0.7046547,110.5622297,24.1427992,122.0135516,7.8997178,10.6125107,1.943784,29.7579711),(34271,'forelimb',252,2,128,30.64121,112.288097,121.4353014,1.8,112.0459391,121.6750104,0.3153864,5.0861115,8.879901,82.6064852,729.0601706,0.4913522,82.1022855,16.2415797,89.8403575,6.9882119,10.0587382,1.9195673,27.0755833),(34272,'forelimb',252,2,129,18.2977924,110.0742333,121.0901169,1.8,110.8050894,121.5022566,0.3625563,4.272807,10.4192967,36.0646998,197.8250718,0.383606,18.9864132,8.440517,22.4440896,5.722693,8.8582451,1.9693188,23.1778543),(34273,'forelimb',252,2,130,12.0941088,109.1631028,121.1587335,1.8,109.140752,121.3480687,0.9607152,2.1213116,3.660003,9.7728179,32.4073503,1.3540295,8.8544601,4.6069695,10.6254714,4.7740502,7.8997178,1.9614034,20.2437611),(34274,'forelimb',252,2,131,3.267367,109.0515314,121.733725,1.8,109.0752064,121.7837752,1.0356416,1.3215599,2.4373925,1.0351191,3.6423043,0.4029352,1.4943446,0.7832555,1.8705645,3.0763404,5.2450105,2.1815223,12.8042684),(34275,'forelimb',252,2,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34276,'forelimb',252,2,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34277,'forelimb',252,2,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34278,'forelimb',252,2,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34279,'forelimb',252,2,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34280,'forelimb',252,2,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34281,'forelimb',252,2,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34282,'forelimb',252,2,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34283,'forelimb',252,2,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34284,'forelimb',252,2,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34285,'forelimb',252,2,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34286,'forelimb',252,2,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34287,'forelimb',252,2,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34288,'forelimb',252,2,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34289,'forelimb',252,2,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34290,'forelimb',252,2,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34291,'forelimb',252,2,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34292,'forelimb',252,2,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34293,'forelimb',252,2,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34294,'forelimb',252,2,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34295,'forelimb',252,2,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34296,'forelimb',252,2,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34297,'forelimb',252,2,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34298,'forelimb',252,2,155,2.0988157,111.0810774,126.1235479,1.8,111.0448596,126.1260659,1.2718764,1.6304753,1.6386774,1.0322169,1.1566894,0.3194666,0.7058677,0.6330773,1.3280932,3.437504,3.8432463,2.0344439,10.7295512),(34299,'forelimb',252,2,156,16.7425774,111.7196224,125.204329,1.8,112.3594334,125.0571117,0.0439953,6.2881286,6.4877739,30.4564351,93.7898867,0.0053976,14.456405,4.8434816,18.5536066,5.471781,7.3926319,0.9505468,20.286947),(34300,'forelimb',252,2,157,47.2992485,112.9439939,123.7429398,1.8,113.1133767,124.0037793,-0.3955098,5.4863953,5.8608043,223.1955134,277.7924893,1.1701809,47.3983563,40.6816317,80.5934244,9.882824,12.2893773,0.9342881,36.2770139),(34301,'forelimb',252,2,158,42.5995864,113.1046035,123.7171866,1.8,113.3554566,124.010531,0.024008,5.1813915,5.9799477,219.4725473,275.1075026,0.0040915,46.0050017,42.3578392,76.1556472,9.882824,12.2893773,0.9342881,36.6329791),(34302,'forelimb',252,2,159,36.0196456,113.1131578,123.5756889,1.8,113.4313439,123.8287455,0.1102712,5.2236818,6.5572278,169.8865363,255.887454,0.0727028,39.0237248,32.5223747,63.0566729,9.7837702,12.1534119,2.9996956,36.3812737),(34303,'forelimb',252,2,160,32.3086588,113.1521387,123.3389616,1.8,113.5211206,123.5486582,0.1166507,4.9961028,6.5562081,145.1101542,246.9026404,0.072941,37.6593658,29.0446695,57.6390642,9.3923699,12.1534119,2.9996956,35.5218977),(34304,'forelimb',252,2,161,30.061746,113.0372053,123.0812529,1.8,113.4339278,123.2266161,-0.0418221,4.448734,5.8813089,131.8056969,205.2441334,0.0087583,34.8976964,29.6276864,52.2966746,9.023448,11.3765933,2.9516044,34.3065565),(34305,'forelimb',252,2,162,29.6688719,113.0449608,122.9846621,1.8,113.4984613,123.0913753,-0.1393152,4.3282856,5.2695294,128.635833,184.1821072,0.0953532,34.9522873,29.7198116,51.4533738,8.59376,10.6732285,0.6998929,32.4835447),(34306,'forelimb',252,2,163,29.1600715,113.1441153,122.7690713,1.8,113.4916808,122.9231973,-0.1353528,4.4558691,4.7838019,124.1364105,171.3687578,0.0884949,35.8227118,27.8590793,53.1897293,8.59376,10.3482574,0.7266423,30.9122383),(34307,'forelimb',252,2,164,29.493192,113.2314536,122.7219092,1.8,113.5491856,122.8632239,-0.0534279,4.2248733,4.847851,124.3716696,167.3645637,0.0140182,34.5234543,29.4379646,53.5301602,8.59376,10.0679117,2.2655346,30.9122383),(34308,'forelimb',252,2,165,32.0809462,113.272213,122.7313342,1.8,113.6302986,122.8173052,0.137669,4.3568734,5.1624219,121.9444738,167.4866578,0.1006984,32.4434271,27.9889871,53.5086841,8.5178568,9.9201178,2.8335399,30.0528623),(34309,'forelimb',252,2,166,29.5530575,113.3805612,122.7146884,1.8,113.6446246,122.8151087,0.2400768,4.2118405,5.1991605,113.4611155,168.3358041,0.2784784,32.3774971,26.9386069,52.9841449,8.164072,9.9201178,2.8335399,29.4451917),(34310,'forelimb',252,2,167,28.116902,113.4923176,122.6532612,1.8,113.7041284,122.759017,0.3176088,4.1020169,5.183339,102.6232164,167.7796976,0.4570341,32.3690383,25.0177461,51.5457959,8.0255151,9.9201178,2.8335399,29.1934863),(34311,'forelimb',252,2,168,28.5514021,113.5552358,122.630492,1.8,113.7016042,122.7543824,0.36244,3.9402888,5.163567,97.7374048,167.1292618,0.5982018,32.367017,24.80463,50.9316938,7.885888,9.9201178,2.8335399,28.9417809),(34312,'forelimb',252,2,169,28.4091797,113.6229304,122.5296862,1.8,113.6845073,122.6501427,0.3709814,7.1460953,12.6337771,92.0341905,164.5190691,0.6222946,13.0221602,12.8789481,17.6753047,7.537918,9.798394,2.4805495,28.3341103),(34313,'forelimb',252,2,170,28.5966649,113.6276558,122.4835387,1.8,113.6674285,122.5901438,0.3584783,7.0324505,12.8611262,89.9886091,163.417066,0.5866867,12.7062797,12.7961952,17.4447993,7.41588,9.798394,2.4805495,28.3341103),(34314,'forelimb',252,2,171,28.345174,113.5848705,122.4126259,1.8,113.5044724,122.4960916,0.3278919,7.1006093,13.1329061,88.5529322,162.7687974,0.4899694,12.3939665,12.4711738,17.2543287,7.3408702,9.6560368,2.5782764,27.4747343),(34315,'forelimb',252,2,172,28.3685047,113.5567796,122.3676141,1.8,113.4552684,122.4594767,0.3195236,7.027845,13.1408455,87.5816981,161.9416791,0.4665095,12.3235358,12.4620987,17.1537462,7.3283745,9.6560368,2.5782764,27.4747343),(34316,'forelimb',252,2,173,28.361623,113.5025659,122.2829268,1.8,113.3407099,122.4110036,0.2701978,6.8725842,13.4508763,87.5403215,166.8493939,0.3367819,12.4043512,12.7376136,17.4280371,7.303036,9.5406219,2.5161076,27.1187691),(34317,'forelimb',252,2,174,28.4513093,113.4989315,122.2235949,1.8,113.3461395,122.341813,0.2643755,6.8538131,13.4595953,86.5265045,167.1029477,0.3237811,12.4151539,12.6245789,17.3646251,7.1113101,9.5406219,2.5161076,26.8670637),(34318,'forelimb',252,2,175,28.4708915,113.4604939,122.1498021,1.8,113.2775201,122.2650246,0.2538818,6.779862,13.4532738,86.263896,164.7764204,0.2993381,12.2480537,12.7235475,17.2119413,7.303036,9.4237936,2.3239476,26.6153583),(34319,'forelimb',252,2,176,28.4534913,113.4630325,122.0971834,1.8,113.316523,122.2188621,0.2704128,6.6297128,13.3621291,85.5240758,161.1573211,0.3383976,12.0607517,12.9001178,17.004808,7.112401,9.4628966,2.4526683,26.2593931),(34320,'forelimb',252,2,177,28.0535677,113.4341082,122.0212174,1.8,113.2875822,122.15416,0.2476436,6.4007875,13.4252337,83.7492135,156.5855509,0.2809279,11.6635251,13.0842046,16.5818181,7.1113101,9.1957248,2.488746,25.7559823),(34321,'forelimb',252,2,178,27.8975259,113.4363514,121.9787556,1.8,113.2760693,122.0606108,0.2477735,6.444192,13.4163797,83.2816753,153.6121897,0.2796525,11.4496007,12.9235248,16.3319137,7.222451,9.1957248,2.488746,25.7559823),(34322,'forelimb',252,2,179,27.6562737,113.3898094,121.8956702,1.8,113.19986,121.9872343,0.2272386,6.2464674,13.5443985,82.8568238,148.4339273,0.2339475,10.9590638,13.2645891,15.9761091,7.222451,9.1352922,2.2896263,26.0076877),(34323,'forelimb',252,2,180,27.4437793,113.3909423,121.8485534,1.8,113.1938011,121.8983933,0.2267998,6.286901,13.5367288,82.1851699,143.5209766,0.2312697,10.6023382,13.0724454,15.5780834,7.2719466,8.9412281,2.1854593,25.7559823),(34324,'forelimb',252,2,181,26.9909279,113.3721456,121.7723509,1.8,113.187854,121.8270282,0.238371,6.0895942,13.4510419,80.5322195,132.9314396,0.2508027,9.8826128,13.2245625,14.8274171,7.2967479,8.8582451,2.2531129,25.4000171),(34325,'forelimb',252,2,182,26.8057366,113.3703829,121.7246518,1.8,113.1428873,121.7615053,0.2314788,6.0455623,13.4685233,79.6316457,127.4811221,0.2351409,9.465115,13.1719172,14.3785379,7.2719466,8.6473042,2.677945,25.1483117),(34326,'forelimb',252,2,183,26.5729887,113.3584028,121.6646224,1.8,113.1748476,121.7348718,0.2144257,5.8778435,13.5166495,79.4094433,122.7768448,0.2005286,9.0833786,13.5099623,14.0361187,7.2920472,8.6473042,2.677945,24.8966063),(34327,'forelimb',252,2,184,26.2599539,113.3641212,121.6073992,1.8,113.1768812,121.6567922,0.2380106,5.8257265,13.4059453,77.8068482,113.5324794,0.2432869,8.4688157,13.355733,13.3441364,7.2740207,8.5290633,2.284887,24.5406411),(34328,'forelimb',252,2,185,25.9642633,113.3336845,121.5171923,1.8,113.1407231,121.5334703,0.2370541,5.893729,13.3595432,78.1667741,104.8141574,0.2386544,7.8456393,13.2627025,12.7731973,7.3052177,8.4747721,2.1025204,24.8966063),(34329,'forelimb',252,2,186,25.8395529,113.3489062,121.464564,1.8,113.1679144,121.4696354,0.2994641,6.3408138,13.0431134,78.06959,97.2524141,0.374802,7.456227,12.312235,12.2816335,7.304696,8.4747721,2.1025204,24.5406411),(34330,'forelimb',252,2,187,25.6096024,113.3339732,121.4027795,1.8,113.1857459,121.3998247,0.3330882,6.4146219,12.8158681,77.915939,90.7369185,0.4562983,7.0800447,12.1466145,11.8718839,7.4969435,8.2986537,1.9416876,24.6449009),(34331,'forelimb',252,2,188,25.5278609,113.3478012,121.36465,1.8,113.3156682,121.3558999,0.4989158,3.8473958,3.8614457,77.6668348,85.2095004,0.9740461,22.0667355,20.1868585,38.6537871,7.5958825,8.2986537,1.9416876,24.6449009),(34332,'forelimb',252,2,189,25.3692454,113.3239109,121.313604,1.8,113.2925181,121.3340913,0.3310883,3.8407152,3.8623145,78.5707591,83.0855399,0.4468034,21.5118523,20.4573251,38.5532256,7.5958825,8.1527566,1.8925469,24.6449009),(34333,'forelimb',252,2,190,25.3190032,113.328824,121.2863236,1.8,113.3132486,121.2832072,0.1262509,3.6995566,4.1150275,79.5656409,82.9971946,0.0669045,20.1692929,21.5068046,38.7060827,7.6650624,8.2986537,1.9416876,24.8966063),(34334,'forelimb',252,2,191,25.1180903,113.2923005,121.242567,1.8,113.2627148,121.2328568,-0.3033162,3.9234217,4.197647,78.4491221,83.1826775,0.3734797,19.8165014,19.9950776,38.2485751,7.6650624,8.2986537,0.3708913,24.8966063),(34335,'forelimb',252,2,192,25.1001306,113.3054428,121.2143225,1.8,113.3020416,121.172016,-0.4789889,3.8661723,3.8892789,77.9860211,84.4603526,0.888596,21.7161983,20.1713774,38.8379771,7.304696,8.3430318,0.2074962,24.6449009),(34336,'forelimb',252,2,193,24.8959167,113.2838115,121.1747275,1.8,113.2924929,121.1338215,-0.6177514,3.8845849,3.8232668,77.0987587,85.3617143,1.3920003,22.3269049,19.8473609,39.0060871,7.5958825,8.3430318,0.2074962,25.0008661),(34337,'forelimb',252,2,194,24.7205725,113.3006114,121.1546832,1.8,113.3216543,121.1244841,-0.6162419,3.8919267,3.7990912,76.5785331,86.5051983,1.3763265,22.7699715,19.6762527,38.9797267,7.5958825,8.4420297,0.2573237,25.0008661),(34338,'forelimb',252,2,195,24.4211892,113.2720039,121.1199384,1.8,113.2962873,121.0759016,-0.6248311,3.9325543,3.8001485,75.2386574,87.5872594,1.3927345,23.0483784,19.1322614,39.1479261,7.5958825,8.4420297,0.2573237,25.0008661),(34339,'forelimb',252,2,196,24.1652784,113.281613,121.0978904,1.8,113.3032362,121.0319415,-0.6059898,3.8457316,3.9182607,73.90799,88.5603181,1.3066034,22.6019463,19.2181875,38.9481713,7.5958825,8.4420297,0.2573237,25.2525715),(34340,'forelimb',252,2,197,23.7717889,113.271748,121.0597354,1.8,113.3089149,120.9940835,-0.5896417,3.759411,4.0089561,71.6610099,89.73781,1.2250646,22.3843336,19.0617652,38.7382307,7.2920472,8.5614727,0.3058789,25.0008661),(34341,'forelimb',252,2,198,23.4538866,113.2957687,121.0442682,1.8,113.3115902,120.9925019,-0.5739042,3.7709265,3.9754099,70.3836485,90.6544853,1.1521977,22.8038083,18.6648158,38.413362,7.2920472,8.5614727,0.3058789,25.0008661),(34342,'forelimb',252,2,199,23.0621315,113.2885501,121.007109,1.8,113.3215001,120.9610431,-0.5618422,3.6800778,3.9572382,68.4802003,91.8403296,1.0909095,23.2081882,18.6083568,38.2608339,7.2920472,8.5614727,0.3058789,25.0008661),(34343,'forelimb',252,2,200,22.8282086,113.3196236,120.986142,1.8,113.3520833,120.9600884,-0.5572255,3.6819069,3.9620248,67.8190984,92.5634706,1.0640411,23.3626684,18.4195584,39.8082934,7.2920472,8.4747721,0.5317241,24.6449009),(34344,'forelimb',252,2,201,22.4540216,113.3326827,120.9466656,1.8,113.3692725,120.9337345,-0.5531532,3.7091343,4.0245138,66.5382991,93.3262578,1.0329472,23.1894488,17.9390374,39.4181904,7.2920472,8.6473042,0.4636476,24.6449009),(34345,'forelimb',252,2,202,22.1353359,113.3587776,120.9351681,1.8,113.3768086,120.9404946,-0.5357494,3.7076942,4.0364956,65.9459194,93.9198835,0.961395,23.2676788,17.7862347,39.1434176,7.2920472,8.6473042,0.4636476,24.6449009),(34346,'forelimb',252,2,203,21.7960051,113.350557,120.9156629,1.8,113.3272534,120.8862143,-0.5118005,3.566121,4.0526131,65.2509256,94.3941784,0.8713059,23.2921761,18.2974513,39.092086,7.4969435,8.6473042,0.4636476,24.8966063),(34347,'forelimb',252,2,204,21.5691878,113.3791009,120.9139669,1.8,113.3634132,120.8438906,-0.4971516,3.5453998,4.085457,65.0151612,95.401264,0.8176751,23.35143,18.3378926,38.9482999,7.4958527,8.7005189,0.5743048,25.1483117),(34348,'forelimb',252,2,205,21.2808825,113.4016064,120.8906722,1.8,113.4162448,120.7948238,-0.4772171,3.5433465,4.1403885,64.6223404,97.0213257,0.7482525,23.432904,18.2376579,38.8173889,7.304696,8.8478174,0.5070985,25.1483117),(34349,'forelimb',252,2,206,21.2690772,113.4319477,120.8762255,1.8,113.4357051,120.780865,-0.4601825,3.5349499,4.163653,65.297428,98.7811508,0.6991682,23.7246357,18.4719527,39.3088511,7.304696,8.8582451,0.3985224,25.1483117),(34350,'forelimb',252,2,207,21.1389398,113.4367483,120.850995,1.8,113.4261225,120.788366,-0.4390587,3.5614449,4.1840247,66.0069905,99.8543027,0.6366327,23.8656102,18.5337671,38.5009978,7.304696,8.8582451,0.2449787,25.5042769),(34351,'forelimb',252,2,208,21.2350043,113.4525545,120.8405634,1.8,113.4696701,120.7837891,-0.4072221,3.7410174,4.206475,67.6290284,101.2671783,0.5551666,24.0741188,18.07771,39.0554508,7.304696,8.8582451,0.2449787,25.5042769),(34352,'forelimb',252,2,209,21.1245049,113.4166783,120.8153654,1.8,113.4245545,120.7722193,-0.3844692,3.6101972,4.2763432,68.2792121,102.4330391,0.495283,23.9534185,18.9128761,39.2656014,7.304696,9.1049255,0.3366748,25.5042769),(34353,'forelimb',252,2,210,20.9276203,113.4229257,120.810249,1.8,113.4242042,120.7691835,-0.3607808,3.7645734,4.2858812,68.7209998,102.9613382,0.4346403,24.0233768,18.2546579,39.4246071,7.304696,9.1049255,0.3366748,25.5042769),(34354,'forelimb',252,2,211,20.9760162,113.44197,120.8020077,1.8,113.4806008,120.7610101,-0.3478469,3.7599223,4.3162091,69.4847249,105.5795915,0.4062193,24.4611858,18.4803618,40.0153643,7.304696,9.1049255,0.3366748,25.7559823),(34355,'forelimb',252,2,212,21.3153471,113.4408983,120.8159217,1.8,113.4859952,120.7590691,-0.3425203,3.7446713,4.3857717,70.2806166,108.8959739,0.4007404,24.8293759,18.7681669,40.1986283,7.304696,9.2557628,0.3805064,25.7559823),(34356,'forelimb',252,2,213,21.539255,113.4339387,120.840427,1.8,113.4339906,120.767818,-0.3493835,3.7272764,4.4414988,72.3475853,112.0877879,0.420669,25.2364785,19.4103086,41.2093973,7.5958825,9.4237936,0.4228539,26.1119475),(34357,'forelimb',252,2,214,21.6511531,113.4673608,120.8632098,1.8,113.5104304,120.7831661,-0.3553788,3.8008931,4.4627234,74.210551,115.8613937,0.4368701,25.962038,19.5245037,42.4122017,7.5958825,9.4237936,0.4228539,26.4679127),(34358,'forelimb',252,2,215,22.0930385,113.4577988,120.9012137,1.8,113.4800913,120.8034694,-0.368101,3.7618803,4.589167,76.9017635,123.2968376,0.476797,26.8669319,20.4423739,43.6142081,7.5958825,9.6560368,0.363979,27.0755833),(34359,'forelimb',252,2,216,22.6360237,113.4947969,120.9227801,1.8,113.5571693,120.8085581,-0.3895418,3.8783726,4.6433395,80.2074938,130.7749737,0.5440988,28.1639914,20.6807084,44.8532814,7.8705267,9.8172189,0.4048918,27.5789941),(34360,'forelimb',252,2,217,23.0252611,113.5022617,120.9563513,1.8,113.5167442,120.8447085,-0.4191255,3.8352673,4.8139968,83.2189649,142.2421348,0.635566,29.5476169,21.6983481,45.9157224,7.8997178,10.0587382,0.348771,27.9349593),(34361,'forelimb',252,2,218,23.2731153,113.5297262,121.0029123,1.8,113.4968993,120.8875329,-0.4451731,3.7705259,4.8323311,85.4111606,151.0971986,0.71925,31.2679733,22.6523203,48.0005841,7.8997178,10.2135672,0.3883187,28.1866647),(34362,'forelimb',252,2,219,23.5197945,113.5399118,121.0506302,1.8,113.5161327,120.9378911,-0.4869919,3.9016093,4.9499431,88.055191,162.2099306,0.858455,32.7700599,22.5689412,49.7483629,7.8997178,10.4900209,0.610726,29.0460407),(34363,'forelimb',252,2,220,23.7545007,113.583411,121.0947322,1.8,113.5826027,120.9774157,-0.5059367,3.8773833,5.1323512,90.1576605,172.1214377,0.9298436,33.5365663,23.2521918,50.5079059,8.1660023,10.7679504,0.4993467,29.6537113),(34364,'forelimb',252,2,221,23.961624,113.6160674,121.119975,1.8,113.5346187,121.0136453,-0.5418153,4.0056672,5.3372499,91.9523313,185.5753406,1.0620525,34.7698427,22.9555593,50.4533271,8.2554522,11.0889478,0.6202495,30.7647927),(34365,'forelimb',252,2,222,24.225032,113.6524889,121.1525622,1.8,113.5489011,121.1033606,-0.5667953,3.9545807,5.5634374,94.1069618,197.1646719,1.1639932,35.4393621,23.7969509,51.5947732,8.1660023,11.4413255,0.5984189,31.1207579),(34366,'forelimb',252,2,223,25.0122347,113.6961672,121.2103449,1.8,113.5831169,121.1257766,-0.5968413,4.1151957,5.6646065,98.0324646,212.8896982,1.316814,37.5824337,23.822066,53.5019813,8.424595,11.7988288,0.5779019,31.9801339),(34367,'forelimb',252,2,224,25.1859564,113.7703259,121.2931414,1.8,113.6878301,121.1709282,-0.605852,4.1133308,5.8026629,99.89828,221.4468584,1.3612492,38.1629716,24.2864688,54.9178956,8.4670327,12.0389346,0.607802,32.9437697),(34368,'forelimb',252,2,225,25.6378008,113.8125122,121.4234552,1.8,113.7342215,121.277866,-0.6178193,4.2236087,5.7854606,104.7193945,228.2457207,1.4337553,39.4516078,24.7938204,56.9424271,8.6831877,12.1610055,0.5585993,33.1954751),(34369,'forelimb',252,2,226,25.748356,113.8469313,121.5276598,1.8,113.8264945,121.3557306,-0.6163977,4.1191037,5.963965,106.3464683,232.6901861,1.4341795,39.0160217,25.8178661,56.139937,8.6426664,12.2893773,0.6365082,34.1591109),(34370,'forelimb',252,2,227,27.1668876,113.9307841,121.6588196,1.8,113.9420483,121.4935445,-0.5927566,4.3248628,6.0599088,113.4588359,253.180451,1.413082,41.7795813,26.2340893,59.9904629,8.8112237,12.5274503,0.5404195,34.1591109),(34371,'forelimb',252,2,228,29.1876544,113.9747043,121.8493333,1.8,113.9917034,121.6817994,-0.5478579,4.9673297,6.3101825,131.6997154,281.2374096,1.3197438,44.5688236,26.5131817,63.7256068,9.71268,12.9905136,0.5971767,35.7736031),(34372,'forelimb',252,2,229,32.8652956,114.1736898,121.9693983,1.8,114.1880356,121.8223067,-0.5344614,5.127055,6.3306924,158.7794292,312.609958,1.4212355,49.3800578,30.9689343,72.8448524,10.0162721,12.9905136,0.5971767,36.3812737),(34373,'forelimb',252,2,230,35.9117759,114.3354597,121.9608516,1.8,114.3287714,121.9140439,-0.5403521,5.0516895,6.0469572,173.0691654,331.7713404,1.5839873,54.8658326,34.2596604,79.3047779,9.805485,12.6375032,0.6162969,37.0932041),(34374,'forelimb',252,2,231,42.5577366,114.4085645,121.9887939,1.8,114.4644073,122.0134883,-0.619357,4.9653019,5.8775681,207.1428483,377.4244196,2.3902829,64.2143843,41.718077,95.828866,9.6424592,12.5495381,0.9067502,36.5897933),(34375,'forelimb',252,2,232,45.7760363,114.4545397,121.9593568,1.8,114.4924884,122.0479894,-0.624565,5.2108286,5.7310539,220.4236601,378.8562143,2.6086703,66.1058548,42.3010767,99.0477331,9.8834668,12.5274503,1.0303768,36.2338281),(34376,'forelimb',252,2,233,41.9750275,114.4724469,122.014935,1.8,114.5749815,122.0629568,-0.5719955,4.9273527,5.1401054,199.7175771,281.5092822,2.0499033,54.7672201,40.5324299,87.358842,9.4188943,11.5697035,1.0240075,34.6193359),(34377,'forelimb',252,2,234,42.2031317,114.4502687,121.9964969,1.8,114.5140004,122.0722124,-0.5593702,4.8221448,5.0421981,184.8998118,264.9511936,1.9806779,52.5467642,38.3438943,81.5187208,9.399056,11.3765933,0.1899883,33.6557001),(34378,'forelimb',252,2,235,41.3299353,114.4049065,121.8897045,1.8,114.4892673,121.9259968,-0.5877056,4.4676341,4.956376,142.241113,263.529521,2.1175958,53.1697996,31.8381295,75.7247619,8.5073884,11.0472442,0.235545,32.5446187),(34379,'forelimb',252,2,236,38.2074203,114.4345006,121.7863863,1.8,114.4737865,121.8739688,-0.6101195,4.1703129,5.0399447,95.5753203,245.8819632,2.0905149,48.7866386,22.9180213,65.9543703,7.8997178,10.7422,0.2837941,31.0775721),(34380,'forelimb',252,2,237,24.1073152,114.3075956,121.7540673,1.8,114.3851491,121.7779863,-0.620121,3.0667563,4.8252938,26.3021589,122.7450006,1.3569056,25.4378292,8.5765404,30.6380619,6.076706,10.2496576,0.5763752,26.2162073),(34381,'forelimb',252,2,238,3.5862765,114.0907612,121.932817,1.8,114.1967475,121.8117737,-0.6441533,1.7494975,3.457398,1.5364234,7.2998906,0.2155509,2.1113828,0.8782084,2.5556536,3.7590268,7.1514336,0.5713375,17.3096679),(34382,'forelimb',252,2,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34383,'forelimb',252,2,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34384,'forelimb',252,2,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34385,'forelimb',252,2,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34386,'forelimb',252,2,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34387,'forelimb',252,2,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34388,'forelimb',252,2,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34389,'forelimb',252,2,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34390,'forelimb',252,2,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34391,'forelimb',252,2,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34392,'forelimb',252,2,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34393,'forelimb',252,2,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34394,'forelimb',252,2,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34395,'forelimb',252,2,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34396,'forelimb',252,2,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34397,'forelimb',252,2,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34398,'forelimb',252,2,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34399,'forelimb',252,2,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34400,'forelimb',252,2,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34401,'forelimb',252,2,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34402,'forelimb',252,2,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34403,'forelimb',252,2,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34404,'forelimb',252,2,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34405,'forelimb',252,2,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34406,'forelimb',252,2,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34407,'forelimb',252,2,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34408,'forelimb',252,2,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34409,'forelimb',252,2,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34410,'forelimb',252,2,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34411,'forelimb',252,2,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34412,'forelimb',252,2,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34413,'forelimb',252,2,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34414,'forelimb',252,2,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34415,'forelimb',252,2,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34416,'forelimb',252,2,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34417,'forelimb',252,2,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34418,'forelimb',252,2,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34419,'forelimb',252,2,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34420,'forelimb',252,2,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34421,'forelimb',252,2,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34422,'forelimb',252,2,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34423,'forelimb',252,2,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34424,'forelimb',252,2,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34425,'forelimb',252,2,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34426,'forelimb',252,2,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34427,'forelimb',252,2,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34428,'forelimb',252,2,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34429,'forelimb',252,2,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34430,'forelimb',252,2,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34431,'forelimb',252,2,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34432,'forelimb',252,2,289,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34433,'forelimb',252,2,290,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34434,'forelimb',252,2,291,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34435,'forelimb',252,2,292,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34436,'forelimb',252,2,293,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34437,'forelimb',252,2,294,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34438,'forelimb',252,2,295,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34439,'forelimb',252,2,296,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34440,'forelimb',252,2,297,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34441,'forelimb',252,2,298,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34442,'forelimb',252,2,299,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34443,'forelimb',252,2,300,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34444,'forelimb',252,2,301,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34445,'forelimb',252,2,302,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34446,'forelimb',252,2,303,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34447,'forelimb',252,2,304,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34448,'forelimb',252,2,305,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34449,'forelimb',252,2,306,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34450,'forelimb',252,2,307,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34451,'forelimb',252,2,308,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34452,'forelimb',252,2,309,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34453,'forelimb',252,2,310,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34454,'forelimb',252,2,311,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34455,'forelimb',252,2,312,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34456,'forelimb',252,2,313,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34457,'forelimb',252,2,314,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34458,'forelimb',252,2,315,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34459,'forelimb',252,2,316,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34460,'forelimb',252,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34461,'forelimb',252,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34462,'forelimb',252,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34463,'forelimb',252,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34464,'forelimb',252,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34465,'forelimb',252,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34466,'forelimb',252,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34467,'forelimb',252,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34468,'forelimb',252,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34469,'forelimb',252,3,10,1.9787491,63.8019676,126.2998545,1.8,63.6797616,126.3098568,0.1319825,0.9659804,3.7232951,0.4279637,6.1973672,0.0057115,1.6644846,0.4430356,1.7718818,2.14844,7.9230552,2.9229237,17.5002994),(34470,'forelimb',252,3,11,7.5052258,63.4437996,126.1140526,1.8,63.3893339,126.0875432,0.1467818,1.3846078,7.1693545,2.3712656,93.6513245,0.0267569,13.0627276,1.7125901,13.366033,3.1830496,14.5904229,2.9037567,31.8148002),(34471,'forelimb',252,3,12,9.5999572,62.7886398,125.9709767,1.8,62.7707328,126.0017091,0.1466111,1.9647943,10.0920717,3.6871715,213.2675996,0.0341458,21.1321922,1.8766197,21.4867288,3.7169161,17.1982588,2.9147938,38.1863973),(34472,'forelimb',252,3,13,14.7770323,60.8796895,125.7265663,1.8,61.677905,125.7979609,0.1169758,2.1373032,13.9616489,8.8368718,548.0965011,0.0335464,39.2572901,4.1345897,39.8872887,4.384593,23.3972909,3.0126819,51.6415221),(34473,'forelimb',252,3,14,14.1349053,61.2287533,125.6251569,1.8,62.2993889,125.737451,0.1279732,2.0281485,14.9590346,7.9312686,666.3378196,0.0383714,44.5441726,3.9105956,45.0736658,4.3163865,25.7884405,2.9572682,56.5460727),(34474,'forelimb',252,3,15,13.5405029,62.0974289,125.5319763,1.8,63.0920681,125.6524652,0.1311743,1.8863864,15.4443932,6.5593142,811.0745114,0.038609,52.51579,3.4771849,52.9128585,4.1861706,27.8337015,2.9865959,60.5912473),(34475,'forelimb',252,3,16,12.6562845,61.926066,125.4015264,1.8,63.0705406,125.5653276,0.1312789,1.9378939,15.6314099,5.8624163,799.2968711,0.036145,51.1340229,3.0251482,51.4705882,4.1998693,29.2472054,2.9643673,64.3847165),(34476,'forelimb',252,3,17,11.3666036,61.415871,125.1503228,1.8,62.9363862,125.3671677,0.1286308,1.7337913,16.1679578,4.9755653,702.1616262,0.0311726,43.4292095,2.8697603,43.6794904,4.07566,30.8718194,2.9878851,67.5705151),(34477,'forelimb',252,3,18,11.0169222,61.1408098,125.0218773,1.8,62.8828295,125.2772366,0.1271231,1.7616039,16.4013384,4.688865,655.27201,0.0295133,39.9523498,2.6617022,40.2180029,4.0553885,31.2965106,2.9899872,69.0375617),(34478,'forelimb',252,3,19,11.1644598,60.9373346,124.8474271,1.8,62.7891356,125.0892081,0.1254207,1.7824564,16.5703776,4.6230043,614.4270625,0.029117,37.0798467,2.5936143,37.3538983,3.8460071,32.0312158,3.0205654,69.2892671),(34479,'forelimb',252,3,20,11.4443727,61.0617738,124.7798533,1.8,62.7159668,125.0053258,0.1262687,1.8008718,16.4015495,4.7315532,615.8973137,0.0302498,37.5511664,2.6273682,37.8391026,3.8909217,32.5713708,2.9959643,71.0080191),(34480,'forelimb',252,3,21,11.5877701,61.1873903,124.6521251,1.8,62.9743833,124.8510235,0.1236485,1.8376186,16.2928197,4.7223468,607.1224861,0.0293773,37.263193,2.5698189,37.552368,3.8216143,33.3638275,3.0124454,72.1191005),(34481,'forelimb',252,3,22,12.0046463,61.3261546,124.593373,1.8,62.9790879,124.7961363,0.1217049,1.7750133,16.109829,4.9029033,623.47303,0.0294896,38.7014059,2.7621784,39.0020267,3.9326148,34.1649249,3.0281577,74.1938177),(34482,'forelimb',252,3,23,12.7346691,61.4577812,124.4702563,1.8,62.9177415,124.6275489,0.1177607,1.9890094,15.9438478,5.4546232,649.5349666,0.0292974,40.7389092,2.7423818,41.0648162,4.1573134,34.6425541,3.0172377,75.3048991),(34483,'forelimb',252,3,24,12.8996628,61.6715917,124.4130657,1.8,62.9751323,124.5681755,0.1160876,1.9699266,15.7388278,5.5953816,657.3384705,0.0288434,41.765402,2.8404011,42.1111059,4.268389,35.401702,3.0443395,76.8762055),(34484,'forelimb',252,3,25,13.3268895,61.8323029,124.2764968,1.8,63.2662996,124.4127049,0.1110994,1.8531651,15.548108,5.7454548,673.3328132,0.0273032,43.3064148,3.100347,43.650135,4.3566311,35.4460046,3.0322741,77.6313217),(34485,'forelimb',252,3,26,13.5773174,61.8632388,124.1924992,1.8,63.2461945,124.3215694,0.1067868,2.1343793,15.5284626,5.9940783,688.859227,0.0257067,44.3610708,2.8083472,44.733624,4.5365361,36.2189008,3.0584514,79.2026281),(34486,'forelimb',252,3,27,13.9967112,62.0583836,124.0544152,1.8,63.424553,124.1624709,0.099292,2.2455747,15.3077908,6.5818251,717.6593561,0.0229232,46.8819677,2.9310203,47.2830337,4.6691598,36.6143597,3.0711213,80.3137095),(34487,'forelimb',252,3,28,14.2550838,62.1550142,123.9685439,1.8,63.2439767,124.0695067,0.093648,2.4933779,15.2223909,6.9269621,738.3800638,0.0207752,48.5061819,2.7781437,48.9463598,4.6541639,37.0429935,3.0719381,81.8850159),(34488,'forelimb',252,3,29,14.7836902,62.4515582,123.8393681,1.8,63.4205165,123.9220192,0.0844761,2.6299195,14.9041582,7.5865522,789.8856698,0.0175415,52.9976707,2.8847089,53.3214861,4.8170515,37.4223467,3.095648,83.7080277),(34489,'forelimb',252,3,30,15.1489814,62.6689214,123.7463956,1.8,63.6220003,123.8121318,0.077173,3.2696922,14.6977846,8.4465668,834.8261782,0.0150072,56.7994566,2.5832911,56.8595188,4.9208245,37.8345103,3.1075149,84.3156983),(34490,'forelimb',252,3,31,15.8237826,62.7528221,123.5868664,1.8,63.6095269,123.6502166,0.0663414,3.3768174,14.5982302,9.5714132,905.2909659,0.0115902,62.013748,2.834448,61.8589125,4.726568,37.8345103,3.1075149,84.8191091),(34491,'forelimb',252,3,32,16.2328259,62.9954648,123.4841304,1.8,63.9772797,123.5285011,0.0541909,3.944006,14.3649945,11.1717241,970.6008716,0.0079373,67.5670896,2.8325829,66.8113376,5.156256,38.2639516,0.0336951,85.6784851),(34492,'forelimb',252,3,33,16.4116389,63.1422394,123.3228349,1.8,63.9602037,123.3783763,0.0378269,3.9744972,14.2076014,13.3910132,1020.1065054,0.003912,71.8000511,3.3692345,70.7280905,6.015632,38.2639516,0.0336951,87.6057567),(34493,'forelimb',252,3,34,16.5939209,63.3933459,123.2017547,1.8,63.947605,123.2648812,0.0225074,4.0615043,13.9593025,15.8798783,1082.9964674,0.0014008,77.58242,3.9098514,76.0714076,5.7650714,37.87353,0.0567572,87.5446827),(34494,'forelimb',252,3,35,17.5246329,63.6578564,123.0122426,1.8,64.3495694,123.0816,0.0029346,4.4572373,13.6880901,20.858478,1215.2798666,0.0000252,88.7837424,4.6796876,86.7138657,6.6168174,38.2808362,0.0449136,88.2566131),(34495,'forelimb',252,3,36,18.07215,63.9754045,122.8726206,1.8,64.5122507,122.9711775,-0.0100017,4.1534092,13.4105606,24.5797083,1313.4412296,0.0003013,97.9408149,5.9179596,95.3245723,6.44532,38.2808362,0.0449136,88.9685435),(34496,'forelimb',252,3,37,18.5910213,64.2375601,122.6852042,1.8,64.8091163,122.7432245,-0.0224048,4.2551289,13.1946481,28.9740931,1403.3494197,0.0015551,106.3574723,6.8092162,104.3205722,6.875008,38.3025339,0.0561208,90.4355901),(34497,'forelimb',252,3,38,18.9418216,64.4842835,122.5821092,1.8,65.0735853,122.5811945,-0.0296571,4.5151096,12.9721635,31.2008295,1450.2157318,0.0027759,111.7944386,6.9103149,110.0295447,7.0764363,38.3025339,0.0561208,91.2949661),(34498,'forelimb',252,3,39,20.0732787,64.5724014,122.4252369,1.8,65.3639517,122.4342245,-0.0407166,4.6837558,12.8993194,36.2487,1578.2298015,0.0055433,122.3498502,7.7392378,122.1545099,7.5060589,38.7100956,0.0444152,91.5466715),(34499,'forelimb',252,3,40,20.0031187,64.6482833,122.3307581,1.8,65.3254199,122.3524904,-0.0467938,4.9361908,12.8162596,38.5909253,1579.9780434,0.0072947,123.2791853,7.8179566,124.3372573,7.734384,38.3290367,0.0673139,92.3017877),(34500,'forelimb',252,3,41,20.7301762,64.7182221,122.1391077,1.8,65.2852219,122.1784205,-0.0619588,5.0606026,12.7410906,45.0864642,1677.3497031,0.0132465,131.6488321,8.9093074,134.2965486,8.164072,38.7100956,0.0444152,94.3333191),(34501,'forelimb',252,3,42,20.8011196,64.7686388,122.0319051,1.8,65.4413684,122.0473486,-0.0675544,4.956893,12.6915789,48.3619178,1708.1018336,0.0157972,134.5854486,9.7564982,137.6809252,8.164072,38.7315529,0.0554985,94.8367299),(34502,'forelimb',252,3,43,20.6643242,64.6814358,121.8509866,1.8,65.45771,121.8828297,-0.078028,5.0984021,12.7437894,52.9667965,1712.7080931,0.0209261,134.395511,10.3889015,138.4245026,8.59376,39.1228505,0.0329551,95.1926951),(34503,'forelimb',252,3,44,20.8908618,64.8260767,121.7626614,1.8,65.5826656,121.7959007,-0.0814095,5.3827875,12.5942206,55.3612945,1749.9678743,0.0230248,138.9500729,10.2848747,143.2634173,9.023448,38.7577623,0.0665682,96.4080362),(34504,'forelimb',252,3,45,21.0893689,64.8972592,121.580378,1.8,65.6838705,121.6270446,-0.0910868,5.2281527,12.6209702,61.6774998,1769.6126346,0.0290818,140.2120925,11.797188,144.6219071,8.8474202,39.1605866,0.0548899,97.7708231),(34505,'forelimb',252,3,46,20.9772471,64.7842501,121.4961417,1.8,65.6428503,121.544265,-0.095409,5.4828491,12.5742806,64.2271127,1757.4722079,0.0317291,139.7672169,11.7141857,144.1584726,9.2620446,39.1393645,0.0439278,99.090424),(34506,'forelimb',252,3,47,20.8689298,64.6264511,121.3643889,1.8,65.5679773,121.4285134,-0.1012948,5.7087222,12.7151042,67.0019916,1734.5488367,0.0355662,136.4164071,11.7367756,140.6509813,9.6916671,39.5686425,0.0434509,100.6617304),(34507,'forelimb',252,3,48,20.7867966,64.4607498,121.2851562,1.8,65.4928722,121.3339587,-0.1050327,5.6671898,12.8690031,70.5708166,1716.0267285,0.0380792,133.3457391,12.4525239,137.6130994,9.6991662,39.1605866,0.0548899,99.6980946),(34508,'forelimb',252,3,49,20.4601103,64.2532656,121.1877598,1.8,65.4595745,121.1629699,-0.1127782,5.9056972,13.0575422,72.0002202,1665.4783485,0.0431882,127.5491456,12.1916545,132.1039739,10.1212897,39.5896345,0.0542944,100.3057652),(34509,'forelimb',252,3,50,20.2197533,64.1218824,121.1021368,1.8,65.4636999,121.0750261,-0.1194416,6.1709787,13.1706295,74.7211043,1620.6875451,0.0478487,123.0531577,12.108469,127.554802,10.312512,39.5896345,0.0542944,100.6617304),(34510,'forelimb',252,3,51,20.5120869,64.2617771,120.9767383,1.8,65.5252165,120.9736985,-0.1256411,6.1140341,12.9544736,81.4176553,1604.5971295,0.0536828,123.8643248,13.3165196,128.0582088,10.312512,39.5896345,0.0542944,101.6253662),(34511,'forelimb',252,3,52,20.1389069,64.0109252,120.9306525,1.8,65.4224962,120.8722337,-0.1305546,6.4766601,13.1880279,82.5073621,1544.4513806,0.0568853,117.1101085,12.7391836,121.2297035,10.7422,39.9817699,0.0322469,103.0924128),(34512,'forelimb',252,3,53,20.0563262,63.9572563,120.873051,1.8,65.398291,120.791308,-0.133521,6.4451856,13.2276342,84.0388588,1487.8923078,0.0592402,112.4836296,13.0390131,116.6082352,10.5959068,39.5896345,0.0542944,103.0924128),(34513,'forelimb',252,3,54,20.1822674,63.8381174,120.8111089,1.8,65.3446093,120.7224453,-0.1415102,6.7293781,13.3198195,87.1740803,1460.3754078,0.0669103,109.6392795,12.9542551,113.7390841,11.0180302,39.6152762,0.0651252,103.5958236),(34514,'forelimb',252,3,55,19.5471341,63.8801818,120.7290256,1.8,65.3661475,120.6697833,-0.1496322,6.6526066,13.2471764,87.3645718,1352.7902644,0.0724,102.1191404,13.132382,106.0917826,11.0180302,39.9979293,0.0429843,104.6637192),(34515,'forelimb',252,3,56,19.6819153,63.7994356,120.6765537,1.8,65.4975336,120.5709039,-0.1546516,6.97432,13.3064363,90.4140438,1330.2465506,0.0778323,99.9701587,12.9638507,103.9904112,11.4476528,39.6152762,0.0651252,105.2713898),(34516,'forelimb',252,3,57,19.6059925,63.7902973,120.6404784,1.8,65.5195461,120.5229846,-0.1592047,6.9014963,13.2978739,90.3813725,1268.9856983,0.0821254,95.4277135,13.0959097,99.4032807,11.4326546,39.6152762,0.0651252,105.7316148),(34517,'forelimb',252,3,58,19.3844344,63.8175342,120.5865796,1.8,65.5399241,120.3899384,-0.1641327,7.2378082,13.2488599,92.5672388,1213.7916698,0.0862559,91.6148017,12.7894019,95.6648848,11.8622772,39.2171226,0.0767719,105.5230952),(34518,'forelimb',252,3,59,19.4378657,63.9409907,120.5179242,1.8,65.6776407,120.3239774,-0.1729954,7.1947332,13.0902014,97.4231632,1153.7668634,0.0959908,88.1397337,13.5409,92.3866319,11.8547781,39.6152762,0.0651252,105.9833202),(34519,'forelimb',252,3,60,19.8950251,63.8992924,120.505065,1.8,65.6217695,120.2808113,-0.1741326,7.2408153,13.1256765,100.7718833,1147.4077536,0.0995312,87.4170377,13.9172013,91.8718772,11.8494534,39.5896345,0.0542944,106.2350256),(34520,'forelimb',252,3,61,19.9785011,64.2310049,120.4215156,1.8,65.7331701,120.2012394,-0.1772564,7.6178954,12.775037,106.6462384,1114.059814,0.103529,87.2059952,13.999436,91.9864146,12.1793485,39.2171226,0.0767719,105.5230952),(34521,'forelimb',252,3,62,19.5831093,64.4236966,120.3512916,1.8,65.8133057,120.1568065,-0.182191,7.5499566,12.5576003,109.1755093,1057.7016828,0.1071455,84.22801,14.4604155,89.1340046,12.1643526,39.1865091,0.0658388,105.0196844),(34522,'forelimb',252,3,63,20.2860529,64.5925703,120.3162758,1.8,65.8941854,120.1323751,-0.1806132,7.6335371,12.3901351,113.7702966,1051.1084107,0.1090982,84.8342978,14.9040079,90.0884224,12.1643526,38.7887143,0.0776215,104.9154246),(34523,'forelimb',252,3,64,20.6204602,64.6913531,120.2679886,1.8,66.0516394,120.0582647,-0.1879107,7.9020049,12.2608826,119.4596081,1035.1019338,0.1199313,84.4231179,15.1176328,89.9110864,12.5637871,38.3603345,0.0784901,104.4120138),(34524,'forelimb',252,3,65,20.6511762,64.9895827,120.2064319,1.8,66.1410967,120.022372,-0.1944647,7.9394438,11.9348041,124.0588749,981.4520222,0.1285268,82.2344473,15.6256379,88.0302392,12.5678736,38.3290367,0.0673139,103.8043432),(34525,'forelimb',252,3,66,20.4550189,65.1034657,120.1700007,1.8,66.1891395,119.9883688,-0.1953839,7.9204493,11.812945,126.8218723,941.6520631,0.1284969,79.713574,16.0119542,85.8009123,12.5828695,37.9319844,0.0793783,103.0924128),(34526,'forelimb',252,3,67,20.797371,65.2501966,120.0865741,1.8,66.3507022,119.9207645,-0.197891,8.1899501,11.6442165,133.9431667,919.8059198,0.1339778,78.9925126,16.3545767,85.5000171,12.9972998,37.5036649,0.0802868,102.8407074),(34527,'forelimb',252,3,68,20.9538045,65.3534273,120.0481895,1.8,66.3833676,119.8703813,-0.1958863,8.2682134,11.5423655,137.5826747,905.7934297,0.1322994,78.4755454,16.6399521,85.3073887,13.0122957,37.5036649,0.0802868,102.2330368),(34528,'forelimb',252,3,69,21.3949066,65.4588868,120.0150777,1.8,66.5824676,119.7656618,-0.1897705,8.2893259,11.5344055,142.0929593,895.3123877,0.1268811,77.6210261,17.1416785,85.4954283,12.7836894,37.075377,0.0812163,101.6253662),(34529,'forelimb',252,3,70,21.4925936,65.4954495,120.0070746,1.8,66.5892343,119.7961122,-0.1806417,8.3367991,11.5235045,142.9968953,884.0182857,0.1156231,76.7143613,17.1524939,84.8783021,12.7828716,37.01557,0.0580742,101.0176956),(34530,'forelimb',252,3,71,21.7690377,65.8079905,119.944345,1.8,66.6730657,119.7128908,-0.1685289,8.4626491,11.238569,144.7587813,858.663938,0.1020754,76.4033161,17.1056107,84.9840276,12.7603758,36.6143597,0.0704713,100.3057652),(34531,'forelimb',252,3,72,21.8030547,65.8274419,119.9004264,1.8,66.7562367,119.6396895,-0.1669108,8.7820495,11.2164804,149.3493144,838.9100252,0.1002994,74.7926265,17.0062028,83.7675262,13.0863447,36.5866148,0.0587558,100.410025),(34532,'forelimb',252,3,73,22.7968212,66.0433536,119.8739039,1.8,66.8962832,119.6195588,-0.158824,8.8291779,11.0209105,154.4897255,833.1277978,0.0950387,75.5951876,17.4976342,85.1918567,13.0639945,36.1857509,0.0713075,98.231048),(34533,'forelimb',252,3,74,23.2157675,66.2287301,119.8472749,1.8,66.8362203,119.6111546,-0.1549967,8.9153248,10.843687,161.4632085,818.4815349,0.0922138,75.4800038,18.1107488,85.8222747,13.0827373,36.1576771,0.0594537,99.090424),(34534,'forelimb',252,3,75,24.4160419,66.4548601,119.8210113,1.8,66.8559451,119.5420516,-0.1456524,8.9586323,10.6399631,170.5349802,815.7749388,0.0857208,76.670843,19.0358275,88.0283588,13.0827373,35.7054957,0.0481555,98.5870132),(34535,'forelimb',252,3,76,24.9563416,66.4520133,119.8339476,1.8,66.923634,119.5087427,-0.1363598,9.0044432,10.6672392,174.8349458,819.8886884,0.0768615,76.8604392,19.4165194,88.7814534,13.0735424,35.3286118,0.0730406,97.6233774),(34536,'forelimb',252,3,77,25.5891811,66.5142821,119.8634089,1.8,66.8805603,119.5383401,-0.1245625,9.1361102,10.6364543,181.6914349,823.5467864,0.0658313,77.4268157,19.8871763,90.2631506,13.0771916,35.2998564,0.0609002,97.1199666),(34537,'forelimb',252,3,78,25.9532413,66.608654,119.8814375,1.8,66.9790545,119.4929918,-0.111549,9.5815168,10.5726328,183.5239158,825.9925816,0.0536006,78.1255337,19.1539523,91.4352699,13.4838026,34.9000836,0.073939,96.4080362),(34538,'forelimb',252,3,79,27.1506064,66.6891521,119.9231932,1.8,66.954598,119.5248787,-0.0898422,9.6981351,10.5767747,184.0564332,860.3770926,0.0364268,81.3458841,18.9785387,95.3579059,13.4838026,34.4421133,0.0624188,94.8367299),(34539,'forelimb',252,3,80,27.1018748,66.7315205,119.950175,1.8,66.9160705,119.4815729,-0.076997,9.7983496,10.5529962,186.0291083,862.7831071,0.0267262,81.7571703,18.9857595,96.1743781,13.5062908,34.417982,0.0499584,94.0816137),(34540,'forelimb',252,3,81,27.6470421,66.771938,119.9772309,1.8,66.9132382,119.5008968,-0.0666567,9.8518079,10.5260839,186.2648264,874.2025914,0.0204429,83.0510761,18.9066645,97.6509959,13.4961602,33.9698191,0.0379564,93.3264974),(34541,'forelimb',252,3,82,27.7851243,66.8991783,120.003582,1.8,66.9096812,119.5219356,-0.0546261,9.9343963,10.4122079,185.7977198,870.6807765,0.0138048,83.6211481,18.7024671,98.4613823,13.522392,33.1305888,0.0519014,91.7551911),(34542,'forelimb',252,3,83,28.5418908,67.0657474,119.9631804,1.8,67.0284247,119.5055234,-0.049598,9.9099011,10.2694308,187.36812,854.5494771,0.0116924,83.2129348,18.9071635,98.5053205,13.5145148,32.2724008,3.0883098,89.9321793),(34543,'forelimb',252,3,84,29.7389201,67.1084144,119.9793443,1.8,67.1018311,119.5209089,-0.0481078,9.9300511,10.2282191,190.0083433,861.0775864,0.0114622,84.1864627,19.1346793,99.7993052,13.5145148,31.8085231,3.1145722,88.6736522),(34544,'forelimb',252,3,85,29.590879,67.1580197,119.9738974,1.8,67.2085859,119.5312204,-0.0467263,9.9286602,10.1789507,190.4657593,831.385256,0.01076,81.6769113,19.1834302,97.4575784,13.5737552,30.1272272,3.0845119,84.7759233),(34545,'forelimb',252,3,86,30.1913799,67.1919326,119.9425539,1.8,67.3044348,119.4887679,-0.0454273,10.3296812,10.1441409,201.1319295,820.1308693,0.0103769,80.8477402,19.471262,97.6383696,14.035009,29.2472054,3.0975036,83.1614311),(34546,'forelimb',252,3,87,31.8509958,67.6092194,119.9228854,1.8,67.5954583,119.4857762,-0.0176369,10.353449,9.7338109,217.9745509,864.1581443,0.0016511,88.779015,21.0533273,104.2834117,14.1015413,25.8706435,3.0584514,76.6855741),(34547,'forelimb',252,3,88,32.4396914,67.8339375,119.9488405,1.8,67.6488437,119.4566946,0.0035629,10.3800678,9.5203239,228.0207217,883.3349507,0.0000686,92.784128,21.9671706,106.966085,14.1165372,24.1238339,3.0702852,72.7446593),(34548,'forelimb',252,3,89,34.2849461,68.0757207,119.9336853,1.8,67.7906397,119.4347647,0.0212603,10.3661047,9.3288887,251.6941236,887.3981777,0.0025824,95.1236756,24.2804922,109.3626056,14.1260784,21.5915548,3.041924,67.9875543),(34549,'forelimb',252,3,90,36.1952696,68.1669848,119.9620919,1.8,67.8990152,119.4142015,0.033293,10.7918436,9.2829066,260.8315789,887.9939404,0.0066842,95.6590407,24.1693254,105.9377645,14.609392,20.2683424,3.0566909,65.6179459),(34550,'forelimb',252,3,91,35.9229657,68.1262525,119.836353,1.8,67.9131877,119.3508384,0.0325702,10.6682655,9.284179,288.9191117,775.7326436,0.006349,83.5542534,27.0821075,99.02356,14.609392,18.6010739,3.0258334,61.7202169),(34551,'forelimb',252,3,92,36.9888505,67.9095751,119.7316298,1.8,67.7170003,119.2862093,0.0037087,10.5891414,9.0114505,305.0494874,685.1089929,0.0000848,76.0264947,28.8077641,92.7867504,14.7885287,17.747727,3.0202407,60.7565811),(34552,'forelimb',252,3,93,38.78722,67.801536,119.5855961,1.8,67.5807382,119.0981974,-0.0774641,10.5396296,8.1734563,347.2619685,585.3805262,0.0387141,71.6197049,32.9482136,88.2248296,14.3136122,16.9331967,2.1939957,59.0378291),(34553,'forelimb',252,3,94,41.1717674,67.6723723,119.5258966,1.8,67.4831142,119.057951,-0.2016309,10.8101706,7.8655558,375.4083945,537.4663389,0.2752132,68.3316413,34.7273331,83.9988296,14.118404,16.8073383,2.1375255,58.2827129),(34554,'forelimb',252,3,95,42.1972011,67.478703,119.3749217,1.8,67.3778245,118.9848072,-0.6688574,9.1764266,7.5876718,386.9753587,517.8621359,2.7042191,68.2504659,42.1705936,84.2208817,14.0392768,16.7357822,2.0803886,56.2079957),(34555,'forelimb',252,3,96,43.3964684,67.4287635,119.3158695,1.8,67.3164481,118.9609299,-0.8262137,8.1355232,7.3155626,373.786279,526.2912482,3.9112527,71.9413225,45.9449588,84.2846534,14.0984453,16.5806127,2.1156602,55.6003251),(34556,'forelimb',252,3,97,42.0201784,67.2662981,119.1842893,1.8,67.1654593,119.0602282,-0.9661079,7.4347113,7.9939635,345.003637,560.9933349,4.7398846,70.1771196,46.4044429,85.604414,14.1648138,16.7357822,2.0803886,55.6003251),(34557,'forelimb',252,3,98,41.0319508,67.1243877,119.2487105,1.8,67.0890818,119.1860566,-1.0243615,7.6075016,8.5082537,338.0952657,588.1074803,4.9920128,69.1219965,44.4423521,87.1482367,14.1849245,16.998492,1.2090671,56.7114065),(34558,'forelimb',252,3,99,37.1819306,66.8133488,119.6774393,1.8,66.7885303,119.5171581,-1.0198575,7.500663,8.7830191,346.872182,589.1892868,4.4987718,67.0827741,46.2455359,84.5691628,6.6479347,15.2584623,0.1697783,37.7872463),(34559,'forelimb',252,3,100,34.4992309,66.5904926,119.8933942,1.8,66.604086,119.6677003,-1.009012,7.5592407,9.0118237,351.2359491,577.5156432,4.1182523,64.0842149,46.4644485,82.5181898,6.015632,15.5639613,0.1106572,37.4312811),(34560,'forelimb',252,3,101,33.6762207,66.5481793,120.0934067,1.8,66.4584107,119.9266101,-1.0332778,7.6818773,9.3645922,374.4957303,565.0686583,4.1413321,60.340979,48.7505481,81.6762669,6.875008,15.6821404,0.1651487,38.3949169),(34561,'forelimb',252,3,102,34.2693363,66.3924271,120.2198647,1.8,66.3164034,120.1219934,-1.0575974,7.8572795,9.4960481,393.553105,572.80574,4.334796,60.3204339,50.0877059,83.2538516,7.304696,16.0429641,0.1343214,39.8619635),(34562,'forelimb',252,3,103,35.1244612,66.3219521,120.4035803,1.8,66.1596557,120.3618253,-1.0621928,8.0016099,9.7210169,432.2112297,564.9734282,4.4659109,58.1187577,54.0155341,84.6453303,8.164072,16.1061369,0.1607627,40.8255993),(34563,'forelimb',252,3,104,39.8560142,66.1608353,120.564222,1.8,66.110568,120.4449993,-0.9476852,8.4019799,9.2936862,486.3214481,609.4891387,4.3805252,65.58099,57.8817676,91.5041239,9.0023367,16.2658334,0.2129383,42.2926459),(34564,'forelimb',252,3,105,51.2583692,65.831015,120.8193139,1.8,66.1299048,120.5989067,-0.7935806,9.4786572,9.1421988,579.9331712,712.8923175,4.3414303,77.9782119,61.1830516,106.0876549,9.882824,16.6028685,0.1821683,43.8639523),(34565,'forelimb',252,3,106,62.2572199,65.54992,121.0362507,1.8,66.0637141,120.6966397,-0.6995225,10.4133947,9.1051642,667.8545734,799.847403,4.3014124,87.8454674,64.1341841,118.1786874,10.7422,16.6028685,2.9594243,44.8275881),(34566,'forelimb',252,3,107,62.8834014,65.7733266,121.0189033,1.8,66.2562681,120.6655787,-0.6073086,10.9979353,8.2121193,767.5882091,865.5942826,3.4130194,105.4044938,69.7938467,131.9377243,11.171888,17.1067638,2.939271,45.7912239),(34567,'forelimb',252,3,108,50.2740021,66.9734921,120.5137379,1.8,66.7852725,120.3980928,1.1743417,8.3308626,11.7959099,540.4024968,756.4716715,7.1295895,64.1299975,64.8675322,109.3068721,11.601576,16.9549897,2.9889433,46.1471891),(34568,'forelimb',252,3,109,29.8446078,69.3664641,120.2806968,1.8,69.1645241,119.5904593,1.1822216,5.9682362,12.333745,111.8367997,527.5264071,4.2601072,42.7709838,18.7386687,51.7494366,9.7749823,15.4029813,2.7403639,43.2130959),(34569,'forelimb',252,3,110,22.6182879,69.9954701,120.3251916,1.8,69.9765323,119.7344027,1.1376175,4.2791084,12.4485427,64.0747129,437.9394975,3.1055027,35.1799811,14.9738466,40.1103726,8.164072,10.4016451,2.4733032,29.1934863),(34570,'forelimb',252,3,111,18.9668868,70.6308698,120.4675709,1.8,70.2372271,119.6970586,1.0741468,3.8318653,12.7288731,43.1627486,379.4624161,2.4434548,29.8111557,11.2641612,33.1631775,6.875008,8.59376,2.2142974,24.1846759),(34571,'forelimb',252,3,112,15.7556926,70.930088,120.6154424,1.8,70.2796958,119.5928208,1.0456853,3.5167639,12.8038131,28.0551148,301.6052394,1.9660194,23.5558921,7.9775373,25.7466897,6.015632,7.9230552,2.2794226,21.7539936),(34572,'forelimb',252,3,113,10.7917274,70.7641079,120.6284886,1.8,70.0631638,119.3785357,1.0817185,2.6877518,12.3473009,11.7158958,182.253249,1.4016236,14.7605741,4.3589947,15.692269,4.29688,6.3877713,1.9138203,17.6045592),(34573,'forelimb',252,3,114,7.294298,70.9883539,121.4518666,1.8,70.3531468,120.3456929,1.1181588,2.1616066,12.5822523,5.4973936,58.0943101,0.9831919,4.617163,2.543198,5.0469239,3.8158746,5.7327529,1.7975952,15.3823964),(34574,'forelimb',252,3,115,0.563015,71.0451511,122.3795234,1.8,71.082672,122.2973893,-1.5613261,0.7175545,1.2101338,0.1015032,0.1886944,0.0938274,0.1559285,0.1414572,0.233985,1.718752,2.8824347,1.1071487,6.8318222),(34575,'forelimb',252,3,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34576,'forelimb',252,3,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34577,'forelimb',252,3,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34578,'forelimb',252,3,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34579,'forelimb',252,3,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34580,'forelimb',252,3,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34581,'forelimb',252,3,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34582,'forelimb',252,3,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34583,'forelimb',252,3,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34584,'forelimb',252,3,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34585,'forelimb',252,3,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34586,'forelimb',252,3,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34587,'forelimb',252,3,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34588,'forelimb',252,3,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34589,'forelimb',252,3,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34590,'forelimb',252,3,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34591,'forelimb',252,3,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34592,'forelimb',252,3,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34593,'forelimb',252,3,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34594,'forelimb',252,3,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34595,'forelimb',252,3,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34596,'forelimb',252,3,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34597,'forelimb',252,3,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34598,'forelimb',252,3,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34599,'forelimb',252,3,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34600,'forelimb',252,3,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34601,'forelimb',252,3,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34602,'forelimb',252,3,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34603,'forelimb',252,3,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34604,'forelimb',252,3,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34605,'forelimb',252,3,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34606,'forelimb',252,3,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34607,'forelimb',252,3,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34608,'forelimb',252,3,149,6.9404204,65.0108844,123.022398,1.8,65.291951,122.7463928,1.4549166,2.51892,4.3142476,4.6953973,28.56329,1.1412734,6.6206887,1.8640517,6.8326141,4.2626336,8.76395,1.7681919,23.0735945),(34609,'forelimb',252,3,150,24.5461234,66.41664,122.1116122,1.8,67.0955804,122.2107633,-1.3824886,5.0510351,4.9173197,85.7585825,141.0271829,3.9476603,28.6796853,16.9784173,43.6178981,8.59376,10.2135672,1.1824776,29.9054167),(34610,'forelimb',252,3,151,39.9567784,67.5665319,122.2889308,1.8,67.2849325,122.1476735,1.1642208,4.7913025,4.959387,153.235355,178.7766968,5.6179653,36.048144,31.9819833,64.8118623,9.023448,10.5339308,1.3654009,31.3724633),(34611,'forelimb',252,3,152,29.3093435,67.4015307,122.2099028,1.8,67.1348539,122.0336184,0.736624,4.7983686,4.7020355,120.8083768,144.7453698,2.2045666,30.7835554,25.176969,52.2016063,9.023448,10.3304002,1.2753555,30.7647927),(34612,'forelimb',252,3,153,29.3862175,67.2789685,121.9339196,1.8,67.1497825,121.9663581,0.343052,4.6551946,4.6805296,123.3395804,145.4713952,0.554126,31.0801142,26.495043,54.9265236,9.023448,10.0219602,0.5404195,30.5130873),(34613,'forelimb',252,3,154,25.2633339,67.1297911,122.2087372,1.8,67.1219847,122.0264245,0.1524049,4.6683489,4.5017865,103.1946889,107.0315169,0.0970448,23.7753429,22.1051793,44.1784037,8.8112237,9.6560368,0.363979,29.0460407),(34614,'forelimb',252,3,155,16.7877842,67.4331687,122.0768991,1.8,67.3219993,121.997691,-1.2592545,4.0774796,4.537022,65.1798185,73.0603886,2.5350714,16.1031595,15.9853206,30.4649225,8.2035531,9.5115493,1.2490458,27.9349593),(34615,'forelimb',252,3,156,15.546667,67.472875,122.0421577,1.8,67.3408236,121.9878222,-1.2371618,3.9501071,4.3476593,58.0490857,67.4707737,2.3132335,15.5188732,14.6955725,28.5907421,7.734384,9.1957248,0.9179497,26.9713235),(34616,'forelimb',252,3,157,15.9691941,67.5830663,121.9303711,1.8,67.3539875,121.9070501,-1.2981368,3.8637024,4.317336,57.2917304,69.443802,2.4685205,16.0848733,14.8281945,28.9721773,7.5958825,9.1049255,1.2341215,26.1119475),(34617,'forelimb',252,3,158,16.3169732,67.554727,121.913328,1.8,67.3885967,121.8785068,-1.3832958,3.7676985,4.2482977,57.6634297,70.9385141,2.6250029,16.6981035,15.3046825,30.2708082,7.304696,8.9721488,1.2793395,25.5042769),(34618,'forelimb',252,3,159,16.0753853,67.5842147,121.7945463,1.8,67.4039481,121.6604504,-1.4064869,3.7551426,4.1960538,57.4411153,71.5538026,2.6075467,17.0526418,15.2966535,30.5377613,7.304696,8.8582451,1.1722739,25.7559823),(34619,'forelimb',252,3,160,16.6786277,67.5258734,121.702742,1.8,67.3223517,121.5794492,-1.4578063,3.6852092,4.0809553,60.3475099,75.1521473,2.7444334,18.4153321,16.3755995,32.3168741,7.304696,8.8582451,1.1722739,25.4000171),(34620,'forelimb',252,3,161,17.1694125,67.5188737,121.5522111,1.8,67.2564027,121.3118351,1.4524024,3.8019115,4.3767488,64.4322211,81.4096164,2.8216449,18.600477,16.9473228,32.7305047,7.734384,8.8582451,1.815775,26.1119475),(34621,'forelimb',252,3,162,18.2390459,67.3102402,121.3442002,1.8,67.1123077,121.0992996,1.0994544,4.0556535,4.5134182,72.4788252,93.8166569,2.413054,20.7861654,17.8710596,35.9681063,8.0605079,9.0642783,2.1193457,26.9713235),(34622,'forelimb',252,3,163,19.0273677,67.1885486,121.0954456,1.8,67.0763889,120.8115287,0.9808809,4.1174685,5.0286746,74.6480255,114.8421848,2.1898618,22.8374659,18.1295923,37.6777848,7.882577,9.6560368,2.1341126,27.8306995),(34623,'forelimb',252,3,164,19.1782063,67.16223,120.9121675,1.8,67.0266743,120.6259865,0.9710408,4.1502067,5.2162459,77.0754321,124.2938778,2.1780265,23.8282244,18.5714682,38.5467814,8.0753937,10.0219602,2.1112158,28.7943353),(34624,'forelimb',252,3,165,19.3736921,67.2907746,120.8168025,1.8,67.0920448,120.5119156,0.9848458,3.9975652,5.2113099,78.5694167,129.1165917,2.2415372,24.776226,19.6543178,39.8508696,7.9450949,10.0219602,2.1112158,28.7943353),(34625,'forelimb',252,3,166,19.5457354,67.3586027,120.7201947,1.8,67.0682904,120.3573029,0.9911132,3.8909611,5.4032336,78.4706946,134.4939248,2.2802063,24.891377,20.1674324,39.2790702,7.8120712,10.2496576,2.1471715,29.1503005),(34626,'forelimb',252,3,167,19.0403479,67.5850767,120.6397406,1.8,67.2844533,120.2251399,0.9979527,3.8933963,5.4551818,75.2409485,133.592497,2.2410808,24.4891007,19.3252734,37.952888,7.7898144,10.2496576,2.1471715,29.4020059),(34627,'forelimb',252,3,168,19.2665498,67.6042873,120.6461633,1.8,67.3373648,120.1843519,1.0162664,3.8811981,5.4566646,73.1771882,135.0030906,2.320822,24.7409543,18.8542779,37.7153283,7.6908511,10.4016451,2.2390857,29.6537113),(34628,'forelimb',252,3,169,19.9053198,67.7745693,120.5273089,1.8,67.6053024,120.1667681,1.028286,3.8197491,5.3566985,71.2111013,137.1675539,2.4332502,25.6067339,18.6428739,38.8858915,7.6787912,10.3927662,2.0899424,28.4383701),(34629,'forelimb',252,3,170,19.527496,67.913865,120.620413,1.8,67.7371273,120.2391192,1.0506151,3.7564126,5.1292476,67.7419505,128.3410233,2.4505505,25.0214131,18.0336823,38.0066047,7.61073,10.0219602,2.1112158,28.1866647),(34630,'forelimb',252,3,171,20.2943333,68.2264273,120.7863026,1.8,68.1170417,120.4965394,1.1278588,3.5778417,4.8024858,63.0794083,115.9536563,2.7610645,24.1445079,17.6305756,36.7076452,7.293842,9.5406219,2.1962814,26.6153583),(34631,'forelimb',252,3,172,21.2464738,68.409279,121.0256482,1.8,68.3904699,120.6980683,1.2619632,3.6856635,4.7823302,59.5970542,106.3512033,3.2139403,22.2383649,16.169966,34.6955136,7.2509862,9.2557628,1.9513027,25.7559823),(34632,'forelimb',252,3,173,19.0490759,68.731576,121.1207887,1.8,68.7097337,120.9158171,1.3778546,3.5468397,4.410498,52.4990672,88.6355792,3.0581169,20.0965013,14.8016464,31.8466767,6.875008,8.7005189,1.9237867,24.5406411),(34633,'forelimb',252,3,174,19.8488112,68.8061349,121.295964,1.8,68.856978,121.0483497,1.4936963,3.4471429,4.4451086,50.5842781,81.6759705,3.2885092,18.3743475,14.6742622,29.7385541,6.44532,8.463872,1.9890207,23.9329705),(34634,'forelimb',252,3,175,18.4159008,69.0276831,121.2396554,1.8,68.9947044,121.1230911,1.5681397,3.163494,3.937838,47.6914391,74.0044409,3.0692951,18.7931653,15.0755587,29.7123217,6.44532,8.1527566,1.8925469,23.8287107),(34635,'forelimb',252,3,176,18.5546544,69.0907014,121.2642907,1.8,69.1056086,121.1938276,-1.5345373,3.5209076,3.960093,46.9899152,70.4724937,3.0883785,17.7956665,13.3459666,29.1202484,6.8299244,8.0272343,1.8417432,23.6812651),(34636,'forelimb',252,3,177,18.9474165,69.2887649,121.3278306,1.8,69.3171809,121.2897985,-1.4474726,3.389774,3.6583335,46.8595415,66.1253769,3.110118,18.0752731,13.8237952,29.3032586,6.7442583,7.8997178,1.9614034,23.0735945),(34637,'forelimb',252,3,178,19.5464068,69.3419078,121.4137456,1.8,69.3595354,121.3364374,-1.352869,3.3314333,3.7429581,46.3011071,65.0006535,3.1054509,17.3661186,13.8982543,29.1487199,6.6707909,7.8997178,1.1801893,22.8218891),(34638,'forelimb',252,3,179,19.5726469,69.5057563,121.5148083,1.8,69.5512691,121.4338571,-1.2639998,3.2520064,3.7648654,44.8535161,61.7017909,2.9645781,16.388844,13.7925671,27.910568,6.44532,7.7463106,0.9827937,22.4659239),(34639,'forelimb',252,3,180,18.6421027,69.5536878,121.5737225,1.8,69.5744271,121.5269757,-1.1996942,3.1768344,3.665124,42.9403339,57.5106509,2.698414,15.6913249,13.5167052,27.3886427,6.44532,7.7463106,0.9827937,22.1099587),(34640,'forelimb',252,3,181,18.5345127,69.6876981,121.6644681,1.8,69.7425659,121.5993687,-1.0866561,3.1636723,3.4812664,41.112396,54.8582026,2.4198615,15.7581167,12.99515,26.2334654,6.5339509,7.6503773,0.9048271,22.2142185),(34641,'forelimb',252,3,182,18.0085919,69.7426256,121.7082907,1.8,69.8123642,121.6828673,-0.9858755,3.1658737,3.4721042,40.052651,52.1296949,2.0864416,15.0138623,12.6513738,25.9195951,6.3444067,7.5164702,1.0303768,21.9625131),(34642,'forelimb',252,3,183,17.9805615,69.878125,121.781876,1.8,69.9268392,121.762837,-0.8519537,3.0745721,3.4367402,38.9256236,50.3808932,1.6972427,14.6595,12.6605013,25.803878,6.3444067,7.3926319,0.9505468,21.6065479),(34643,'forelimb',252,3,184,18.3406494,69.9137531,121.8409364,1.8,69.9691387,121.816548,-0.7519021,2.9882626,3.409342,38.4507529,50.266757,1.4260741,14.7438294,12.8672604,25.5337981,6.3805413,7.3926319,0.9505468,21.3548425),(34644,'forelimb',252,3,185,18.8362458,70.033961,121.9357706,1.8,70.043945,121.9329718,-0.6556483,3.091768,3.4862205,37.7148873,49.653889,1.16691,14.2428998,12.1984857,24.903869,6.44532,7.3926319,0.6202495,21.6065479),(34645,'forelimb',252,3,186,18.324648,70.1191756,121.9677058,1.8,70.1496352,122.0019277,-0.5378809,3.0096824,3.4161279,36.5838625,49.0994307,0.8016085,14.3728313,12.1553899,24.7766737,6.3805413,7.317323,0.7022569,21.7108077),(34646,'forelimb',252,3,187,17.9538178,70.2593334,122.0348748,1.8,70.2429389,122.0510349,-0.4694387,3.1739236,3.4659501,35.5767595,48.5532956,0.6123835,14.0086538,11.2090787,23.8611173,6.3805413,7.3926319,0.6202495,21.3548425),(34647,'forelimb',252,3,188,18.163291,70.2706413,122.1184507,1.8,70.302421,122.1158394,-0.4378218,3.083279,3.443384,34.7728246,49.4473129,0.5441378,14.3600926,11.2778717,24.1683949,6.4444538,7.3926319,0.6202495,21.6065479),(34648,'forelimb',252,3,189,18.0915084,70.3499544,122.194262,1.8,70.3893521,122.177933,-0.4070108,3.0347064,3.4933441,33.7756233,50.2409487,0.4725199,14.3819067,11.1297828,23.9738387,6.3805413,7.5041783,0.4124104,21.1031371),(34649,'forelimb',252,3,190,17.6358595,70.3487097,122.2539563,1.8,70.4120342,122.2561139,-0.3812422,3.034544,3.4760208,32.7552358,50.5788902,0.4069148,14.5508021,10.7941212,23.3783773,6.3805413,7.5164702,0.5404195,21.7108077),(34650,'forelimb',252,3,191,17.8538369,70.3994995,122.3364861,1.8,70.5154838,122.3284906,-0.3450633,2.980505,3.694012,32.0791263,51.8440751,0.3404646,14.0346256,10.7629837,22.711917,6.015632,7.7463106,0.3392926,21.1031371),(34651,'forelimb',252,3,192,17.9222066,70.4254542,122.3969362,1.8,70.5072399,122.3938662,-0.3116272,3.0520844,3.7910565,32.1902064,53.5642111,0.2808062,14.1290987,10.5469581,22.2416927,6.015632,8.0272343,0.2709469,21.7108077),(34652,'forelimb',252,3,193,17.9335643,70.498171,122.4798274,1.8,70.5476081,122.4348213,-0.2605503,3.042663,3.8708801,31.6289992,54.5902904,0.1983574,14.1028111,10.3951701,22.0051544,6.015632,8.0272343,0.2709469,21.7108077),(34653,'forelimb',252,3,194,17.926179,70.5191685,122.5397296,1.8,70.5977384,122.506436,-0.2334015,3.113801,3.8924969,31.2093563,55.2263263,0.1598244,14.1878922,10.0229131,21.9757799,6.3578174,8.0272343,0.2709469,22.3184783),(34654,'forelimb',252,3,195,17.7170975,70.5744245,122.622184,1.8,70.646048,122.6528616,-0.2049593,2.8782953,3.6985076,30.2081306,54.4649338,0.122317,14.7261922,10.4951463,22.7719238,6.015632,7.8997178,0.390607,21.3548425),(34655,'forelimb',252,3,196,17.6884516,70.5698332,122.6722768,1.8,70.6219392,122.7030882,-0.1863278,2.9189561,3.6769342,29.7532634,54.6511007,0.1011724,14.8632249,10.1931177,22.8179775,6.015632,7.7463106,0.3392926,21.1031371),(34656,'forelimb',252,3,197,17.4845174,70.6471239,122.7353212,1.8,70.6983245,122.7564905,-0.1568288,2.912322,3.729923,28.7803846,55.914232,0.071087,14.99072,9.8822811,22.5521026,6.015632,7.9230552,0.2186689,21.7108077),(34657,'forelimb',252,3,198,17.4001463,70.6470986,122.7951175,1.8,70.709166,122.8179395,-0.1354604,2.9675901,3.7696484,28.0391244,56.6979597,0.0528894,15.0406494,9.4484493,21.8854187,6.015632,8.0272343,0.2709469,21.9625131),(34658,'forelimb',252,3,199,17.3283077,70.701702,122.8626184,1.8,70.7102298,122.9076658,-0.1170585,2.9864722,3.7990949,27.3241112,57.8939074,0.0393937,15.2388686,9.1492937,21.8531471,6.015632,8.0272343,0.2709469,21.9625131),(34659,'forelimb',252,3,200,17.3087256,70.7049558,122.9160007,1.8,70.7285869,122.9708793,-0.1066059,2.705147,3.7872493,27.093271,59.1268154,0.0326611,15.6120737,10.0154525,22.1933769,5.585944,8.0272343,0.2709469,21.6065479),(34660,'forelimb',252,3,201,17.0973502,70.7539432,122.9760453,1.8,70.7935394,123.0421354,-0.1047611,2.7235496,3.8280857,26.7082396,60.0273318,0.0311593,15.6807703,9.8064083,22.169336,5.585944,8.0272343,0.2709469,21.8582533),(34661,'forelimb',252,3,202,17.0038594,70.7221782,123.0307177,1.8,70.7892773,123.067984,-0.1042873,2.7744132,3.7904188,26.6317816,60.7690426,0.0307103,16.0322766,9.5990683,22.6099171,5.585944,8.0272343,0.2709469,21.8582533),(34662,'forelimb',252,3,203,17.2067865,70.7499153,123.0930222,1.8,70.7886566,123.117819,-0.105438,2.7945235,3.8123152,26.611081,62.8982822,0.0317638,16.4987096,9.5225826,23.1042516,5.585944,8.0272343,2.8706458,21.8582533),(34663,'forelimb',252,3,204,17.4220783,70.7378686,123.1517833,1.8,70.7916915,123.178018,-0.1080353,2.8515996,3.7957805,26.9580895,64.801651,0.033759,17.0720225,9.4536728,23.855575,5.9570883,8.0272343,2.8706458,22.2142185),(34664,'forelimb',252,3,205,17.4261626,70.7804329,123.2207075,1.8,70.8867799,123.2664515,-0.1112448,2.8292803,3.9972732,26.788588,66.814402,0.0357946,16.7149951,9.4683402,23.407105,5.9021346,8.3430318,0.2074962,22.8218891),(34665,'forelimb',252,3,206,17.4569345,70.769438,123.2670203,1.8,70.8915521,123.346005,-0.1094566,2.7237928,4.0134598,27.0020478,68.2208666,0.0347189,16.9980191,9.9134003,23.7230116,5.585944,8.3430318,0.2074962,22.4659239),(34666,'forelimb',252,3,207,17.6231591,70.8547854,123.2976351,1.8,70.9242079,123.4045254,-0.1091168,2.7306224,3.931975,26.8336887,72.5586882,0.034833,18.4534966,9.8269495,25.2455983,5.585944,8.3430318,2.9340964,22.4659239),(34667,'forelimb',252,3,208,17.4790344,70.8303759,123.3231903,1.8,70.9008302,123.3943808,-0.1057497,2.7042638,4.2048244,26.7346136,74.2877734,0.0324567,17.6672715,9.8860968,23.7655684,5.585944,8.689902,2.9927027,22.8218891),(34668,'forelimb',252,3,209,17.0894054,70.8667132,123.3485081,1.8,70.9569015,123.4395543,-0.108716,2.7249599,4.2368496,26.305775,75.1375355,0.0335313,17.734294,9.6536377,23.784144,5.585944,8.689902,2.9927027,22.8218891),(34669,'forelimb',252,3,210,17.1789239,70.8714411,123.3760916,1.8,70.8939244,123.4514304,-0.1101978,2.6991895,4.2377835,26.6179251,77.5257234,0.0346284,18.2939319,9.8614509,24.2347009,5.585944,8.76395,2.9441971,23.0735945),(34670,'forelimb',252,3,211,17.6709955,70.9301465,123.4110638,1.8,71.0126559,123.4502576,-0.1141688,2.7124753,4.2900051,27.6208127,81.5942478,0.0382223,19.0196157,10.1828807,25.0512522,5.585944,8.76395,2.9441971,23.5770053),(34671,'forelimb',252,3,212,17.851599,70.8848053,123.4427452,1.8,71.0048346,123.4777129,-0.1204589,2.6978642,4.2940536,27.8352209,84.246069,0.0429637,19.6192401,10.3175026,25.9532389,5.585944,9.0642783,3.0466409,23.9329705),(34672,'forelimb',252,3,213,17.8071754,70.945865,123.4520672,1.8,71.0547702,123.4940673,-0.1265838,2.6921969,4.3470977,28.09768,88.2753071,0.0473019,20.3067226,10.4367106,26.5671342,5.585944,9.115059,2.9996956,23.9329705),(34673,'forelimb',252,3,214,18.3628052,70.968654,123.4744666,1.8,71.0139586,123.5427821,-0.1362561,2.8178282,4.4223515,28.7582207,94.5465362,0.056469,21.3792451,10.2058105,27.8742194,5.9021346,9.1856803,0.1882215,24.2889357),(34674,'forelimb',252,3,215,18.3521749,70.9620426,123.5055665,1.8,71.0691616,123.563055,-0.1422923,2.9070399,4.4119536,29.6037403,97.332244,0.0615129,22.0610305,10.1834653,28.3101934,5.940893,9.2756891,0.2337432,24.7923465),(34675,'forelimb',252,3,216,18.4356508,70.910637,123.529647,1.8,71.0506583,123.5527753,-0.148415,2.8931437,4.3956691,30.1059043,100.0537739,0.0671849,22.7618987,10.4059487,29.3184473,5.940893,9.2756891,0.2337432,24.7923465),(34676,'forelimb',252,3,217,19.1478819,70.9868147,123.5535679,1.8,71.039732,123.6008627,-0.1619835,2.9320368,4.4287713,31.246774,107.8187501,0.083006,24.3450708,10.6570199,30.7720661,6.015632,9.3845276,0.2782997,25.0440519),(34677,'forelimb',252,3,218,19.2003061,71.025773,123.5627491,1.8,71.0109617,123.5854972,-0.1645326,2.9184691,4.7485847,31.8230952,111.6862138,0.0858497,23.5198949,10.904037,29.5294869,6.015632,9.6081158,0.1798535,25.4000171),(34678,'forelimb',252,3,219,18.5354079,70.9501203,123.5886739,1.8,70.9564779,123.6162412,-0.1759517,2.9891267,4.7326598,32.1775903,110.4360906,0.0946567,23.3348889,10.7648801,29.5335646,6.015632,9.6942031,0.2234766,25.4000171),(34679,'forelimb',252,3,220,18.7605468,70.9116125,123.6056841,1.8,70.9542203,123.6307862,-0.1916934,2.9976833,4.7622318,32.7598007,115.0401297,0.1134965,24.1567683,10.9283729,30.834852,6.015632,9.798394,0.266252,26.0076877),(34680,'forelimb',252,3,221,19.0820858,70.9408511,123.598406,1.8,71.0074271,123.6154952,-0.2049001,3.013861,4.7874423,33.378467,121.217562,0.1316657,25.3199002,11.0749854,32.0664471,6.015632,9.9201178,0.3080528,26.0076877),(34681,'forelimb',252,3,222,19.0896949,70.9006067,123.6078361,1.8,70.9770018,123.6343833,-0.2106325,3.0192289,4.7437381,33.8852958,124.3988935,0.1390805,26.2238112,11.2231621,33.0950497,6.015632,9.9201178,0.3080528,26.2593931),(34682,'forelimb',252,3,223,19.2088104,70.9472463,123.5861057,1.8,70.9374058,123.6315423,-0.2151201,3.0354531,4.8836903,34.6841087,128.0895001,0.1458819,26.2280147,11.4263367,33.3297769,6.015632,10.0587382,0.348771,26.2593931),(34683,'forelimb',252,3,224,19.6508636,70.8779964,123.6068792,1.8,70.867828,123.642722,-0.2163077,3.0312667,5.0468004,35.5281491,133.0852583,0.1508656,26.3702241,11.7205618,32.7804835,6.015632,10.2135672,0.2551824,26.8670637),(34684,'forelimb',252,3,225,19.2885377,70.8723712,123.6111004,1.8,70.8813325,123.6279216,-0.2201915,3.0326824,5.1304644,35.8119261,133.3957672,0.1533624,26.0007197,11.8086636,32.7824292,6.1340206,10.3304002,0.2954408,27.4747343),(34685,'forelimb',252,3,226,19.1739541,70.8546665,123.6031716,1.8,70.860662,123.6043908,-0.2245315,3.0491398,5.1124669,36.3060102,134.4540082,0.1584179,26.2992426,11.9069681,33.0814873,6.1636902,10.3304002,0.2954408,27.4747343),(34686,'forelimb',252,3,227,19.0884081,70.8725202,123.5885055,1.8,70.8499466,123.5913463,-0.2226253,3.0573776,5.2290782,36.7797788,135.3353129,0.1550889,25.8812946,12.0298452,32.9037228,6.1636902,10.6125107,0.3729877,27.7264397),(34687,'forelimb',252,3,228,19.1989074,70.8070803,123.5979294,1.8,70.8118447,123.5878584,-0.2236475,3.0638217,5.1630353,37.1279138,136.7607411,0.1573984,26.4884382,12.1181707,33.6677041,6.256305,10.4635866,0.3347368,27.7264397),(34688,'forelimb',252,3,229,19.1886128,70.7922901,123.5954347,1.8,70.7980735,123.5790128,-0.2177845,3.0626021,5.1498475,37.5968478,137.9505492,0.1493033,26.7873078,12.2761125,34.0813273,6.2893188,10.4635866,0.3347368,27.7264397),(34689,'forelimb',252,3,230,19.3198132,70.7546743,123.5984751,1.8,70.7225702,123.5630816,-0.2179301,3.0679399,5.3461689,38.1170779,139.4674758,0.1505219,26.0873678,12.4243235,32.6189675,6.2893188,10.6298941,0.2449787,27.7264397),(34690,'forelimb',252,3,231,19.6857758,70.7209842,123.6132723,1.8,70.7277466,123.5665166,-0.2192278,3.062415,5.3087279,38.9892069,140.6077905,0.1551757,26.486155,12.731523,33.1963687,6.2893188,10.6298941,0.2449787,27.7264397),(34691,'forelimb',252,3,232,19.6551157,70.6430524,123.6080734,1.8,70.6410698,123.5724671,-0.2174756,3.0820932,5.328284,39.536588,141.3555026,0.1525063,26.5292731,12.8278366,33.7418971,6.3911043,10.6298941,0.2449787,27.4747343),(34692,'forelimb',252,3,233,19.6411844,70.5901833,123.5788196,1.8,70.6568205,123.5370904,-0.2217938,3.1280216,5.2805399,40.14327,141.9310229,0.1584098,26.8781272,12.8334377,34.2778496,6.3911043,10.7422,0.2837941,27.7264397),(34693,'forelimb',252,3,234,19.4248855,70.5380595,123.5639453,1.8,70.5821965,123.5179296,-0.2336383,3.0711168,5.2260989,40.328918,139.2258064,0.1735317,26.6404846,13.1316785,34.1251539,6.2547623,10.6298941,0.2449787,27.7264397),(34694,'forelimb',252,3,235,19.463882,70.525667,123.5182736,1.8,70.5753662,123.4696039,-0.2426858,3.1270306,5.2193063,41.4881382,141.5236512,0.1873371,27.1154139,13.2675832,34.8268814,6.3911043,10.6298941,0.2449787,28.0824049),(34695,'forelimb',252,3,236,19.4721624,70.4550599,123.4876414,1.8,70.5292014,123.4411948,-0.2461754,3.1772,5.1561304,42.0261508,143.7918494,0.1927353,27.8875511,13.2274175,35.8109488,6.4806678,10.6298941,0.2449787,28.3341103),(34696,'forelimb',252,3,237,19.4540349,70.4251279,123.4419317,1.8,70.4986471,123.4134089,-0.2578583,3.2403575,5.2412695,42.8973787,145.3005877,0.2108501,27.7224035,13.2384712,35.8869983,6.4989884,10.7765202,0.4101273,28.3341103),(34697,'forelimb',252,3,238,19.4530838,70.348486,123.4041844,1.8,70.396925,123.371317,-0.2654381,3.1914126,5.1757389,43.737775,146.6440526,0.2231207,28.3329697,13.7048325,36.7663888,6.4791838,10.7765202,0.4101273,27.9781451),(34698,'forelimb',252,3,239,19.5486447,70.3332741,123.3378341,1.8,70.3508439,123.3574373,-0.2715363,3.2629686,5.1778207,44.559782,147.801559,0.2343803,28.5451288,13.6562093,37.1407968,6.4183729,10.7765202,0.4101273,27.9781451),(34699,'forelimb',252,3,240,19.4969478,70.2630811,123.3020244,1.8,70.323877,123.3014738,-0.2778322,3.2023319,5.1192734,45.0785611,150.5627981,0.2444428,29.4109706,14.0767923,37.7732966,6.4791838,10.7765202,0.4101273,27.9781451),(34700,'forelimb',252,3,241,19.4647212,70.2612201,123.2685342,1.8,70.3414541,123.2746,-0.2868063,3.236595,5.125855,45.9729479,151.4666921,0.2596172,29.5495465,14.2041087,38.2300805,6.5541094,10.7765202,0.4101273,28.3341103),(34701,'forelimb',252,3,242,19.4476008,70.1952407,123.2371193,1.8,70.3193006,123.2293621,-0.2962877,3.2872562,5.0997304,46.7527428,152.7312855,0.2763098,29.9488939,14.2224216,38.3104988,6.5723593,10.7765202,0.4101273,28.3341103),(34702,'forelimb',252,3,243,19.720632,70.1557665,123.1689147,1.8,70.2548372,123.1523172,-0.3100494,3.2353327,5.1305017,47.839097,157.1132207,0.3059639,30.6233639,14.7864537,39.3412859,6.5161137,10.7765202,0.4101273,28.3341103),(34703,'forelimb',252,3,244,19.8080804,70.0568285,123.1538253,1.8,70.1093654,123.1632939,-0.3153407,3.2702501,5.2370236,48.7231902,161.13229,0.3175468,30.7679138,14.8989188,39.666819,6.5723593,11.0137676,0.3587707,28.9417809),(34704,'forelimb',252,3,245,19.7831271,70.0313229,123.1006382,1.8,70.1142986,123.1096965,-0.3255526,3.3406235,5.2399752,50.074613,164.6525181,0.3372785,31.422385,14.9896009,39.9538457,6.6805481,11.0137676,0.3587707,29.1934863),(34705,'forelimb',252,3,246,19.844727,69.9475025,123.0826014,1.8,70.0621044,123.0383707,-0.3332066,3.2532334,5.3186451,50.8064792,166.9958988,0.3538249,31.3982032,15.6172252,40.1027908,6.5842246,11.171888,0.3947911,29.5494515),(34706,'forelimb',252,3,247,19.6642354,69.9696099,123.0088119,1.8,70.0278788,122.9808898,-0.345738,3.3248059,5.328184,52.3627018,168.5344967,0.376397,31.6307578,15.7491006,41.1356528,6.7486591,11.171888,0.3947911,29.5494515),(34707,'forelimb',252,3,248,19.8871363,69.9142236,122.9657205,1.8,69.9583756,122.952152,-0.3532765,3.2837738,5.3211163,53.7649095,171.4629135,0.3967414,32.2231093,16.3729027,41.7835911,6.6805481,11.171888,0.3947911,29.5494515),(34708,'forelimb',252,3,249,19.8298445,69.8930794,122.8841074,1.8,69.9273293,122.8795865,-0.365148,3.3282015,5.3161872,55.2068739,171.7544326,0.4214222,32.3078228,16.5875996,42.3309385,6.7486591,11.171888,0.3947911,29.5494515),(34709,'forelimb',252,3,250,19.6325683,69.7987472,122.8438735,1.8,69.8323768,122.8697682,-0.3733563,3.4021261,5.3046707,56.0393373,171.2448906,0.4353102,32.2819077,16.4718577,41.9504013,6.7888367,11.1470707,0.4808873,29.5494515),(34710,'forelimb',252,3,251,19.5240272,69.7699002,122.7680063,1.8,69.7975458,122.7918587,-0.386748,3.4871152,5.3170531,57.4686852,170.5213808,0.4629267,32.0706561,16.4802942,42.2109565,6.9516455,11.1470707,0.4808873,29.5494515),(34711,'forelimb',252,3,252,19.5888161,69.6958528,122.7021304,1.8,69.7017593,122.7204842,-0.3886593,3.5046513,5.3624198,58.6774465,172.5544552,0.4688311,32.178468,16.7427346,42.5884377,7.0084465,11.171888,0.3947911,29.9054167),(34712,'forelimb',252,3,253,19.7749026,69.691637,122.6134953,1.8,69.6760497,122.6592756,-0.3923157,3.4969346,5.3355016,60.6284059,173.6246436,0.4817681,32.5413912,17.3375865,43.4800651,6.9184934,11.171888,0.3947911,29.9054167),(34713,'forelimb',252,3,254,20.0801605,69.5710548,122.5834647,1.8,69.5768804,122.6084459,-0.3910998,3.5708328,5.4346182,62.3571049,176.4051899,0.4863333,32.459537,17.4629026,43.5935021,7.068482,11.3522236,0.5144513,30.1571221),(34714,'forelimb',252,3,255,19.8674982,69.558317,122.5207051,1.8,69.5601215,122.537469,-0.3950232,3.6334903,5.42485,63.211423,174.9832821,0.4903756,32.2558746,17.396888,43.6454468,7.1101095,11.3440887,0.4297623,29.8011569),(34715,'forelimb',252,3,256,19.7983452,69.4736673,122.4676432,1.8,69.4225657,122.4818456,-0.3886428,3.5521762,5.3163439,63.949712,177.3337421,0.4738076,33.3563341,18.0029673,45.0113139,7.068482,11.2048922,0.5667292,29.8011569),(34716,'forelimb',252,3,257,19.8934586,69.4341688,122.4334097,1.8,69.4287016,122.4261976,-0.392347,3.5974822,5.3402774,66.2398265,178.1536633,0.4847297,33.3603764,18.4128295,45.4757009,7.1786985,11.171888,0.3947911,29.9054167),(34717,'forelimb',252,3,258,19.9691016,69.3443098,122.3813595,1.8,69.3173905,122.3570986,-0.3935893,3.6795529,5.403406,68.0846276,181.0225928,0.4894981,33.5015715,18.5035056,45.9533696,7.2862516,11.2787985,0.3097029,30.7647927),(34718,'forelimb',252,3,259,19.8175917,69.2717898,122.2869329,1.8,69.2382918,122.2855086,-0.3947299,3.79425,5.4340289,69.5254962,182.113329,0.4884557,33.5135005,18.32391,46.2957143,7.434068,11.2787985,0.3097029,30.2613819),(34719,'forelimb',252,3,260,19.5306851,69.1534486,122.2382597,1.8,69.0812016,122.2685675,-0.3870768,3.8860557,5.4525408,70.5862729,183.0073671,0.4638325,33.5636858,18.1639892,46.0348391,7.6122567,11.3440887,0.4297623,30.4088275),(34720,'forelimb',252,3,261,19.06435,69.0911142,122.1386081,1.8,69.1084119,122.1399774,-0.3882799,3.9293435,5.4734477,71.0657843,181.778218,0.4554333,33.2109173,18.0859178,44.8387099,7.6122567,11.3522236,0.5144513,31.0164981),(34721,'forelimb',252,3,262,18.8307069,68.9819593,122.0444932,1.8,69.0085045,122.075737,-0.385709,3.9686682,5.5374545,71.5399112,182.8579701,0.4442118,33.0220266,18.0261761,44.8952873,7.6311421,11.4413255,0.5984189,31.6241687),(34722,'forelimb',252,3,263,18.7247954,68.8823748,121.9065142,1.8,68.9344497,121.961301,-0.3890416,4.0609032,5.5790579,71.8202758,184.1817297,0.448989,33.0130523,17.6857885,45.198135,7.7853668,11.4413255,0.5984189,31.3724633),(34723,'forelimb',252,3,264,18.7678202,68.824133,121.7914036,1.8,68.9171809,121.8896546,-0.3916614,4.1908629,5.5898843,73.1342008,185.0949072,0.4557879,33.1124757,17.4508692,45.7418945,7.8814861,11.4413255,0.5984189,31.6241687),(34724,'forelimb',252,3,265,18.5877203,68.7724732,121.7187208,1.8,68.8869327,121.7812312,-0.3972252,4.2806638,5.610547,73.6885754,182.7739924,0.4636443,32.5768577,17.214287,45.4119948,7.9943301,11.4413255,0.5984189,31.9801339),(34725,'forelimb',252,3,266,18.4263633,68.7054389,121.6592902,1.8,68.8231562,121.6879339,-0.4017984,4.1958231,5.6494132,73.9415437,182.3054335,0.469685,32.2697997,17.6226552,45.1848783,7.882577,11.5697035,0.2629947,31.9801339),(34726,'forelimb',252,3,267,18.439791,68.7281785,121.5913654,1.8,68.8414422,121.6473851,-0.4181587,4.2502775,5.6002351,74.2132338,181.0758458,0.506786,32.3336151,17.4607971,45.4622309,8.0153529,11.5697035,0.3805064,31.6241687),(34727,'forelimb',252,3,268,18.1156783,68.6130887,121.5226483,1.8,68.6895199,121.5829592,-0.4227559,4.1839021,5.6762561,73.2020908,179.7196106,0.5082228,31.6616458,17.496129,44.5019801,7.882577,11.6887773,0.2984989,31.7284285),(34728,'forelimb',252,3,269,18.4546735,68.5984488,121.4778343,1.8,68.6708928,121.5653558,-0.4282947,4.2289201,5.6692988,73.8456653,176.802283,0.5305436,31.1859172,17.4620623,44.1212189,8.0153529,11.6887773,0.2984989,31.7284285),(34729,'forelimb',252,3,270,18.2199673,68.512307,121.3999102,1.8,68.643317,121.5107578,-0.4308334,4.3032814,5.6825636,72.4533474,173.8905384,0.5296341,30.6007199,16.8367673,43.1993211,8.0153529,11.5697035,0.3805064,31.7284285),(34730,'forelimb',252,3,271,17.877895,68.5327611,121.2619006,1.8,68.6678788,121.3625733,-0.451831,4.2435662,5.8002617,69.9549621,169.1782213,0.5680145,29.1673426,16.4849465,40.9882441,7.9737258,11.7360686,0.4145069,31.7284285),(34731,'forelimb',252,3,272,17.5397951,68.4551458,121.2118055,1.8,68.5942867,121.3077069,-0.4556519,4.3230275,5.661189,69.2447589,163.0754872,0.5660737,28.8058722,16.0176541,40.3341495,8.0842594,11.5697035,0.3805064,31.7284285),(34732,'forelimb',252,3,273,17.8378914,68.4529073,121.1014328,1.8,68.62541,121.1187589,-0.4947586,4.2187461,5.8159651,69.290568,159.8134669,0.6702685,27.4784088,16.4244462,39.3690769,8.000919,11.7360686,0.4145069,31.3724633),(34733,'forelimb',252,3,274,17.4351144,68.3856108,121.0098135,1.8,68.5664424,121.0675946,-0.5021634,4.3278223,5.8321738,68.4812095,154.9002548,0.673204,26.5596088,15.8234798,38.3004952,8.0333769,11.7360686,0.4145069,31.7284285),(34734,'forelimb',252,3,275,17.533249,68.3494863,120.897654,1.8,68.5676098,120.9165577,-0.5386117,4.2734533,5.8033774,68.924595,152.9932555,0.7688688,26.3627964,16.1285478,38.1938873,8.1148574,11.7360686,0.4145069,31.7284285),(34735,'forelimb',252,3,276,17.1038962,68.2733703,120.8072524,1.8,68.5157047,120.8180857,-0.5501308,4.1644107,5.8173506,67.5950697,147.0985728,0.7791352,25.2861799,16.2316052,36.7873052,7.9937074,11.7360686,0.4145069,31.2250177),(34736,'forelimb',252,3,277,17.4493255,68.263067,120.6747995,1.8,68.4612924,120.7015717,-0.5797193,4.2647676,5.7370467,68.9597897,149.9823247,0.8726783,26.1427757,16.1696479,37.8361695,8.1148574,11.7360686,0.4145069,31.8326883),(34737,'forelimb',252,3,278,17.2065627,68.1305281,120.6025725,1.8,68.3761353,120.5948405,-0.5939828,4.1483361,5.7951013,68.0140194,143.4790482,0.8982575,24.7586783,16.3954939,35.9930678,8.0433297,11.7360686,0.4145069,31.5809829),(34738,'forelimb',252,3,279,17.6046959,68.0703857,120.4266796,1.8,68.3238295,120.4329526,-0.6054746,4.2064857,5.8687105,68.8368969,145.1238381,0.9504613,24.7284029,16.364467,36.4206163,8.1240983,11.7282,0.4964228,32.1886535),(34739,'forelimb',252,3,280,18.0983342,67.9682162,120.2945534,1.8,68.2024829,120.3137737,-0.613527,4.2255701,5.8738458,71.2556119,148.9455463,0.9999136,25.3574152,16.8629581,37.3640506,8.1436243,11.7360686,0.4145069,32.1886535),(34740,'forelimb',252,3,281,18.4865085,67.8608107,120.1374055,1.8,68.0357935,120.1396487,-0.5974503,4.3258439,5.881196,74.0777472,149.6516651,0.9750002,25.4457879,17.1244616,37.86065,8.3400236,11.7360686,0.4145069,32.0843937),(34741,'forelimb',252,3,282,18.9208407,67.6972275,120.0495365,1.8,67.8578197,120.0616233,-0.5918777,4.2548491,5.8541805,76.2190903,151.6231507,0.9815976,25.8999788,17.9134648,38.9126384,8.3379927,11.8222779,0.3332443,32.4403589),(34742,'forelimb',252,3,283,19.6769358,67.4212304,119.9332668,1.8,67.6753269,119.8882831,-0.5716124,4.393913,6.0244403,81.4563701,152.3592478,0.9598044,25.2901912,18.5384576,38.7102632,8.5829817,11.9851376,0.2536741,33.4039947),(34743,'forelimb',252,3,284,20.4389056,67.1424854,119.8337461,1.8,67.3967734,119.8102842,-0.5395138,4.5546134,6.0691183,85.3515839,156.9315607,0.8989953,25.8573903,18.7395892,39.8669008,8.742961,11.9697226,0.3671738,33.2997349),(34744,'forelimb',252,3,285,23.2622052,66.613715,119.781931,1.8,67.0028853,119.7092483,-0.4603214,4.7014858,6.2849869,94.4129855,191.5238673,0.765116,30.4732325,20.081521,45.4857699,8.973012,12.3717316,0.3547057,34.5150761),(34745,'forelimb',252,3,286,25.7081287,66.3352176,119.5857916,1.8,66.8194542,119.5691015,-0.4808396,4.9912982,6.442491,107.1645718,206.8699761,0.9166157,32.1102468,21.4702805,48.69025,9.115059,12.3717316,0.3547057,34.2633707),(34746,'forelimb',252,3,287,30.3564854,66.1584882,119.3331103,1.8,66.5996824,119.3867064,-0.5166259,5.1206847,6.2949919,129.3940847,226.9279618,1.2344255,36.0489682,25.2689029,56.5576573,9.4188943,12.1306029,0.4002407,34.4108163),(34747,'forelimb',252,3,288,31.5337088,66.027389,119.2707269,1.8,66.4665672,119.2780609,-0.4627763,5.0327683,6.1972258,132.8774613,239.4193953,1.0474626,38.6333182,26.4024597,59.8508618,9.4188943,12.2291349,0.3217506,34.8710413),(34748,'forelimb',252,3,289,35.0440065,66.3098055,119.0325415,1.8,66.6132532,119.1319658,-0.425215,5.1638181,6.0670749,168.8361296,269.6835687,0.9939063,44.4503443,32.6959871,71.5782049,9.4188943,12.2291349,0.3217506,34.2633707),(34749,'forelimb',252,3,290,33.2164317,66.4333064,118.8874742,1.8,66.7295868,118.9937217,-0.6128877,4.8159585,5.655884,138.3305294,225.6288631,1.8318409,39.8927672,28.7233638,63.9403984,9.0228992,11.417094,0.3455556,32.6920643),(34750,'forelimb',252,3,291,23.3762293,67.2273041,118.9448441,1.8,67.3827514,118.9069464,-1.1401053,3.7592694,4.6797469,48.4601502,128.1602291,3.2169381,27.3861457,12.8908426,36.9913217,7.20601,9.9201178,1.2627435,27.9349593),(34751,'forelimb',252,3,292,17.2113743,67.6551917,118.6764409,1.8,67.7482054,118.6136186,-1.2833824,3.0868859,4.5837198,19.6691225,78.6046621,2.6380532,17.1486621,6.3718333,21.2338877,5.8441936,9.5115493,1.2490458,25.0008661),(34752,'forelimb',252,3,293,7.7968881,68.0647443,117.0857943,1.8,68.1458312,117.1213114,1.3850038,2.0594267,2.5326992,5.5385338,10.95992,1.2551385,4.3273675,2.6893571,6.304568,4.29688,5.7648695,2.0344439,15.3823964),(34753,'forelimb',252,3,294,5.7507763,68.0835381,116.8798055,1.8,68.0823216,116.8925558,1.3197436,1.692732,2.348896,2.6186465,6.9110035,0.8993118,2.9422348,1.5469941,3.9578345,3.437504,5.3839752,2.070143,13.5593846),(34754,'forelimb',252,3,295,2.2909447,68.2148667,116.7161345,1.8,68.2051099,116.770334,1.256443,1.1341747,1.9512258,0.5439586,1.6492181,0.3453196,0.8452215,0.4796074,1.1232431,2.578128,4.231936,1.9890207,10.1218806),(34755,'forelimb',252,3,296,0.0810142,68.2453153,116.7816611,1.8,68.2487773,116.8035213,0.823565,0.3236599,0.4876344,0.0059822,0.0096842,0.007266,0.0198596,0.0184831,0.029642,1.2153412,1.5492621,2.1587989,3.6460236),(34756,'forelimb',252,3,297,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34757,'forelimb',252,3,298,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34758,'forelimb',252,3,299,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34759,'forelimb',252,3,300,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34760,'forelimb',252,3,301,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34761,'forelimb',252,3,302,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34762,'forelimb',252,3,303,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34763,'forelimb',252,3,304,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34764,'forelimb',252,3,305,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34765,'forelimb',252,3,306,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34766,'forelimb',252,3,307,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34767,'forelimb',252,3,308,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34768,'forelimb',252,3,309,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34769,'forelimb',252,3,310,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34770,'forelimb',252,3,311,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34771,'forelimb',252,3,312,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34772,'forelimb',252,3,313,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34773,'forelimb',252,3,314,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34774,'forelimb',252,3,315,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34775,'forelimb',252,3,316,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34776,'forelimb',252,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34777,'forelimb',252,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34778,'forelimb',252,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34779,'forelimb',252,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34780,'forelimb',252,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34781,'forelimb',252,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34782,'forelimb',252,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34783,'forelimb',252,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34784,'forelimb',252,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34785,'forelimb',252,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34786,'forelimb',252,4,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34787,'forelimb',252,4,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34788,'forelimb',252,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34789,'forelimb',252,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34790,'forelimb',252,4,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34791,'forelimb',252,4,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34792,'forelimb',252,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34793,'forelimb',252,4,18,0.0135397,80.781344,126.75796,1.8,80.781344,126.75796,0.7853982,0,0,0.0002083,0.0002083,0.0011283,0,0,0,4.0553885,31.2965106,2.9899872,69.2892671),(34794,'forelimb',252,4,19,0.3569548,80.9907327,126.6621894,1.8,81.0938444,126.6407724,1.5664851,0.6514208,0.954235,0.0325821,0.0842743,0.0594914,0.0883161,0.0500169,0.119506,3.8460071,32.0312158,3.0205654,69.5409725),(34795,'forelimb',252,4,20,0.7357297,81.1787482,126.5827519,1.8,81.3014926,126.5770387,1.3132286,0.9270695,1.1783429,0.1284415,0.2136978,0.1146651,0.1813545,0.1385457,0.2893047,3.8909217,32.5713708,2.9959643,71.2597245),(34796,'forelimb',252,4,21,1.1345343,81.5015238,126.3062981,1.8,81.6725487,126.328272,0.5510677,1.1279642,1.453318,0.2714338,0.4893128,0.0518395,0.3366867,0.2406404,0.5078504,3.8216143,33.3638275,3.0124454,72.3708059),(34797,'forelimb',252,4,22,1.4602695,81.7268881,126.0798103,1.8,81.9566671,126.0881522,0.4089629,1.0388756,1.7676225,0.351993,0.9440009,0.0384859,0.5340512,0.3388212,0.7330994,3.9326148,34.1649249,3.0281577,74.4455231),(34798,'forelimb',252,4,23,1.8406669,82.0275424,125.7923211,1.8,82.2637676,125.8233886,0.3165816,1.1443904,2.2492612,0.4187561,1.8686262,0.0297329,0.8307733,0.3659206,1.0139577,4.1573134,34.6425541,3.0172377,75.5566045),(34799,'forelimb',252,4,24,2.1371408,82.2801337,125.6365056,1.8,82.5187781,125.68374,0.2776174,1.0760454,2.4673079,0.4919402,2.8266686,0.026754,1.1456489,0.4571742,1.3450034,4.268389,35.401702,3.0443395,77.1279109),(34800,'forelimb',252,4,25,2.5531777,82.6295749,125.3671848,1.8,82.7865547,125.3593677,0.2408981,1.1294059,2.6072334,0.581681,4.5314888,0.0242203,1.7380449,0.5150327,1.9437958,4.3566311,35.4460046,3.0322741,77.8830271),(34801,'forelimb',252,4,26,2.8580999,82.7994998,125.164765,1.8,83.027783,125.1824373,0.2214203,1.064756,2.8034484,0.6677579,6.1090716,0.0229748,2.1791275,0.6271464,2.4150672,4.5365361,36.2189008,3.0584514,79.4543335),(34802,'forelimb',252,4,27,2.7166048,83.0362879,124.9369342,1.8,83.1936275,124.9713625,0.1934506,1.152821,3.0320667,0.597148,7.3546409,0.0167337,2.4256197,0.5179885,2.601573,4.6691598,36.6143597,3.0711213,80.5654149),(34803,'forelimb',252,4,28,2.8648697,83.274491,124.7825281,1.8,83.518126,124.801227,0.1714067,1.0886852,3.1645473,0.6520377,8.4899027,0.0138916,2.6828174,0.5989222,2.8856747,4.6541639,37.0429935,3.0719381,81.8850159),(34804,'forelimb',252,4,29,2.7502861,83.6229386,124.5661989,1.8,83.727776,124.5617769,0.1380512,1.2684504,3.2089321,0.6063434,9.7462363,0.0086805,3.0372211,0.478019,3.1383375,4.8170515,37.4223467,3.095648,83.9597331),(34805,'forelimb',252,4,30,2.7201296,83.8571953,124.4477838,1.8,83.9281767,124.4452275,0.1133472,1.1991314,3.3661402,0.6084123,10.1019454,0.0057996,3.0010471,0.5073775,3.1067154,4.9208245,37.8345103,3.1075149,84.5674037),(34806,'forelimb',252,4,31,2.7112337,84.0771349,124.2531624,1.8,83.9844727,124.225405,0.0759074,1.1362784,3.3896169,0.5827934,10.4241405,0.0025987,3.0753152,0.5128967,3.0863904,4.726568,37.8345103,3.1075149,84.8191091),(34807,'forelimb',252,4,32,2.7247174,84.1279253,124.1418924,1.8,84.1746154,124.1482373,0.0548377,1.0658169,3.5252022,0.599872,10.8988844,0.0013642,3.0917047,0.5628284,3.2184135,5.156256,38.2639516,0.0336951,85.9301905),(34808,'forelimb',252,4,33,2.7530836,84.1234743,123.9581463,1.8,84.2925088,123.9465728,0.0415187,1.1952617,3.5390346,0.6199265,11.6307767,0.0007905,3.2864264,0.5186533,3.4124821,6.015632,38.2639516,0.0336951,87.8574621),(34809,'forelimb',252,4,34,2.7181714,84.1596966,123.8527303,1.8,84.2562122,123.8248723,0.0265398,1.0544133,3.5041042,0.5966218,11.7811614,0.000319,3.3621036,0.565833,3.4130878,5.7650714,37.87353,0.0567572,87.5446827),(34810,'forelimb',252,4,35,2.6537181,84.2059477,123.734544,1.8,84.2551597,123.750144,0.0212679,1.2003473,3.8704087,0.6120657,12.0902192,0.0002,3.1237578,0.5099072,3.2552218,6.6168174,38.2808362,0.0449136,88.5083185),(34811,'forelimb',252,4,36,2.6063293,84.3035238,123.6533664,1.8,84.4488219,123.6654168,0.0009858,1.1955912,3.7826098,0.6141522,12.4818282,0.0000004,3.2997927,0.5136808,3.3939502,6.44532,38.2808362,0.0449136,89.2202489),(34812,'forelimb',252,4,37,2.4822344,84.4817203,123.5200363,1.8,84.587152,123.5168848,-0.0251199,1.1515654,4.0485405,0.5561786,12.7381495,0.000261,3.1463559,0.4829761,3.2561849,6.875008,38.3025339,0.0561208,90.6872955),(34813,'forelimb',252,4,38,2.4834653,84.6027773,123.4408012,1.8,84.6425681,123.4219101,-0.0369518,1.1202291,3.9464737,0.5346903,13.2324058,0.0005649,3.3529694,0.4773044,3.4129878,7.0764363,38.3025339,0.0561208,91.5466715),(34814,'forelimb',252,4,39,2.615393,84.7487561,123.3211454,1.8,84.8103665,123.2981345,-0.0621667,1.1066228,4.2419861,0.609241,14.6734696,0.0016824,3.4591037,0.5505408,3.5674889,7.5060589,38.7100956,0.0444152,91.7983769),(34815,'forelimb',252,4,40,2.7158215,84.7802724,123.2620855,1.8,84.8688888,123.259859,-0.0732639,1.0915718,4.2440549,0.6283409,15.7243263,0.0024252,3.7050242,0.5756295,3.7651553,7.734384,38.3290367,0.0673139,92.5534931),(34816,'forelimb',252,4,41,3.0265065,84.8042973,123.1619542,1.8,84.9746847,123.1289083,-0.0833046,1.2460177,4.6490281,0.7384696,18.200657,0.0034924,3.914938,0.5926638,4.0222841,8.164072,38.7100956,0.0444152,94.5850245),(34817,'forelimb',252,4,42,3.2625554,84.8052156,123.1158802,1.8,84.9821761,123.0727535,-0.0894756,1.1765617,4.6869087,0.814404,19.2532061,0.0043417,4.1078688,0.6921898,4.1684126,8.164072,38.7315529,0.0554985,94.8367299),(34818,'forelimb',252,4,43,3.833683,84.8589433,123.0359079,1.8,85.1155882,122.988849,-0.0945873,1.2001034,5.0591958,0.9845322,22.2188498,0.0056995,4.3917751,0.8203728,4.5058628,8.59376,39.1228505,0.0329551,95.4444005),(34819,'forelimb',252,4,44,4.2291307,84.9723155,122.9680435,1.8,85.2093919,122.9224292,-0.1033979,1.3642148,4.9920419,1.1248008,25.9380439,0.0075089,5.1958786,0.8245042,5.2493781,9.023448,38.7577623,0.0665682,96.4080362),(34820,'forelimb',252,4,45,4.7410083,85.1777685,122.8553283,1.8,85.5167715,122.7490153,-0.1128399,1.3137364,5.2140944,1.2657976,30.905551,0.0100185,5.9273094,0.9635096,6.0364346,8.8474202,39.1605866,0.0548899,97.7708231),(34821,'forelimb',252,4,46,4.9601047,85.2880079,122.7963378,1.8,85.5473731,122.7110006,-0.1245489,1.4769918,5.1099406,1.3645344,33.2421195,0.0127577,6.5053827,0.9238605,6.6470177,9.2620446,39.1393645,0.0439278,99.090424),(34822,'forelimb',252,4,47,5.3949405,85.327153,122.6860573,1.8,85.6203537,122.5695059,-0.1427866,1.3479174,5.5592981,1.6342368,38.7820881,0.0182078,6.9760763,1.2124161,7.115615,9.6916671,39.5686425,0.0434509,100.6617304),(34823,'forelimb',252,4,48,5.6639434,85.3673638,122.6148796,1.8,85.623007,122.4956085,-0.1496809,1.5507004,5.5168189,1.7582612,41.7543265,0.020992,7.5685512,1.1338497,7.7451286,9.6991662,39.1605866,0.0548899,99.6980946),(34824,'forelimb',252,4,49,6.0455158,85.464054,122.504258,1.8,85.7820233,122.4055169,-0.1686736,1.4318144,5.8456893,1.9289568,47.9314747,0.0283958,8.1994564,1.3472115,8.452248,10.1212897,39.5896345,0.0542944,100.3057652),(34825,'forelimb',252,4,50,6.1425873,85.4923822,122.445288,1.8,85.811657,122.3462496,-0.1793995,1.3289201,5.8921229,1.9233291,50.0921843,0.0325971,8.5015511,1.4472872,8.6783335,10.312512,39.5896345,0.0542944,100.6617304),(34826,'forelimb',252,4,51,6.2633253,85.6143293,122.3338014,1.8,85.9559627,122.2333821,-0.1990477,1.4888887,5.8559561,2.024197,53.6353631,0.0408155,9.1591129,1.3595355,9.2724892,10.312512,39.5896345,0.0542944,101.6253662),(34827,'forelimb',252,4,52,6.1598196,85.6858178,122.2595622,1.8,86.0477764,122.1525861,-0.2121679,1.3654628,6.1168073,1.9598287,54.9656943,0.045525,8.9860104,1.4352852,9.2504304,10.7422,39.9817699,0.0322469,103.0924128),(34828,'forelimb',252,4,53,5.909224,85.7939109,122.136851,1.8,86.2655198,121.9786233,-0.2252355,1.5281007,6.0882879,1.9323022,55.1198935,0.0491243,9.0534308,1.2645124,9.2662198,10.5959068,39.5896345,0.0542944,103.0924128),(34829,'forelimb',252,4,54,5.6826304,85.8403186,122.0757366,1.8,86.3032117,121.9107778,-0.2366049,1.5194021,6.139604,1.8831845,54.0433963,0.0520387,8.8024238,1.2394247,8.9352341,11.0180302,39.6152762,0.0651252,103.5958236),(34830,'forelimb',252,4,55,5.2849448,86.0259667,121.9647781,1.8,86.3598796,121.8498859,-0.2523775,1.5825425,6.2593445,1.7891458,51.7240541,0.0549225,8.2634937,1.1305515,8.5181789,11.0180302,39.9979293,0.0429843,104.6637192),(34831,'forelimb',252,4,56,4.9811416,86.1086451,121.88833,1.8,86.4517566,121.7706412,-0.2668104,1.5622986,6.2798064,1.7246603,50.9890579,0.0577103,8.1195271,1.1039249,8.3255404,11.4476528,39.6152762,0.0651252,105.0196844),(34832,'forelimb',252,4,57,4.4786074,86.213246,121.7894134,1.8,86.4471415,121.7119779,-0.2792357,1.4319388,6.2799785,1.5341858,48.5178886,0.0567044,7.7258049,1.0714045,7.8554945,11.4326546,39.6152762,0.0651252,105.4799094),(34833,'forelimb',252,4,58,4.1603694,86.2559251,121.7319279,1.8,86.4965747,121.677755,-0.2880115,1.3446521,6.2319353,1.4350501,45.7675581,0.0559446,7.3440362,1.0672278,7.4826357,11.8622772,39.2171226,0.0767719,105.2713898),(34834,'forelimb',252,4,59,3.7991065,86.2495688,121.6255225,1.8,86.5918097,121.5087985,-0.2985033,1.6309154,6.6273269,1.3598093,44.9047994,0.0547634,6.7757031,0.8337706,6.9440927,11.8547781,39.6152762,0.0651252,105.7316148),(34835,'forelimb',252,4,60,3.5979139,86.2775912,121.5447014,1.8,86.6403607,121.441073,-0.2984272,1.5615086,6.5767283,1.2793848,45.0442071,0.0518376,6.8490296,0.8193261,7.0130039,11.8494534,39.5896345,0.0542944,105.9833202),(34836,'forelimb',252,4,61,3.5228303,86.2763278,121.4263348,1.8,86.5706225,121.3293125,-0.2968776,1.4397821,6.6680489,1.2324096,46.8826727,0.0502457,7.0309432,0.8559695,7.1477401,12.1793485,39.2171226,0.0767719,105.2713898),(34837,'forelimb',252,4,62,3.4620696,86.2105202,121.3904188,1.8,86.5289138,121.2981629,-0.2989312,1.3969718,6.7222404,1.1648543,46.9175711,0.050044,6.9794545,0.8338424,7.0956088,12.1643526,39.1865091,0.0658388,104.767979),(34838,'forelimb',252,4,63,3.6616398,86.2397197,121.3170027,1.8,86.5235382,121.2696724,-0.2971555,1.325997,6.6712959,1.1959047,50.3172768,0.0523204,7.5423542,0.9018909,7.6660031,12.1643526,38.7887143,0.0776215,104.6637192),(34839,'forelimb',252,4,64,3.8521462,86.4053384,121.208138,1.8,86.6857175,121.1374875,-0.3030124,1.378006,6.4853382,1.2355588,53.950472,0.0571663,8.3188371,0.896628,8.4586068,12.5637871,38.3603345,0.0784901,104.1603084),(34840,'forelimb',252,4,65,4.1287022,86.4538382,121.149045,1.8,86.5936415,121.1528335,-0.2954775,1.2299725,6.4161877,1.2096287,56.4342054,0.0583492,8.7955976,0.98346,8.9284118,12.5678736,38.3290367,0.0673139,103.5526378),(34841,'forelimb',252,4,66,4.323237,86.4289349,121.1093181,1.8,86.6235931,121.0815554,-0.2921046,1.1892634,6.426138,1.2069583,58.045011,0.0597513,9.0326431,1.0148789,9.1671105,12.5828695,37.9319844,0.0793783,102.8407074),(34842,'forelimb',252,4,67,4.6637987,86.364355,121.0649986,1.8,86.5347935,121.0336419,-0.2842724,1.4630843,6.4700613,1.2819739,59.6203793,0.0611403,9.214809,0.8762133,9.3607886,12.9972998,37.5036649,0.0802868,102.589002),(34843,'forelimb',252,4,68,4.9699518,86.2980581,121.0250765,1.8,86.4063505,120.994459,-0.2763636,1.3639218,6.5173377,1.3562387,62.2832019,0.0616705,9.5565405,0.9943669,9.7121289,13.0122957,37.5036649,0.0802868,101.9813314),(34844,'forelimb',252,4,69,5.3336764,86.3190731,120.9523334,1.8,86.5314777,120.8855573,-0.2695467,1.2629166,6.4729328,1.3759969,64.0017264,0.0630376,9.8875932,1.089539,10.0483052,12.7836894,37.075377,0.0812163,101.3736608),(34845,'forelimb',252,4,70,5.4670029,86.2584698,120.9211968,1.8,86.5000371,120.8680903,-0.2635733,1.2121529,6.4073346,1.3509066,64.2311481,0.0618473,10.0246284,1.1144688,10.2285023,12.7828716,37.01557,0.0580742,100.7659902),(34846,'forelimb',252,4,71,5.7309704,86.0745328,120.8802928,1.8,86.5128848,120.7742883,-0.2517207,1.1877394,6.572034,1.3281649,66.3239222,0.0592547,10.091841,1.1182292,10.2878011,12.7603758,36.6143597,0.0704713,100.0540598),(34847,'forelimb',252,4,72,5.8716262,85.9287603,120.8475616,1.8,86.3533144,120.7213676,-0.2435312,1.1510302,6.7035336,1.3296716,66.8507281,0.0569002,9.9724611,1.1552014,10.1656428,13.0863447,36.5866148,0.0587558,100.1583196),(34848,'forelimb',252,4,73,5.8867884,85.7730994,120.7838605,1.8,86.279953,120.654993,-0.2264307,1.161125,6.836283,1.2986513,65.8574506,0.0494496,9.6335173,1.1184422,9.8178571,13.0639945,36.1857509,0.0713075,97.9793426),(34849,'forelimb',252,4,74,5.8870681,85.7597496,120.710835,1.8,86.2475389,120.5838365,-0.2132568,1.0902108,6.7392919,1.2795982,65.7041611,0.0439501,9.7494161,1.1737164,9.9360266,13.0827373,36.1576771,0.0594537,98.8387186),(34850,'forelimb',252,4,75,5.7463564,85.7582102,120.6366412,1.8,86.3003694,120.523962,-0.1882817,1.1424346,6.3874585,1.2625366,62.384132,0.0335521,9.7666595,1.1051281,9.9423316,13.0827373,35.7054957,0.0481555,98.3353078),(34851,'forelimb',252,4,76,5.6237161,85.7663489,120.576942,1.8,86.2898033,120.4605654,-0.1709512,1.1209321,6.3609576,1.2387379,60.57372,0.0271257,9.522736,1.1050963,9.6901315,13.0735424,35.3286118,0.0730406,97.371672),(34852,'forelimb',252,4,77,5.4363988,85.7016026,120.5334605,1.8,86.1723035,120.4534621,-0.1479435,1.1235435,6.3425642,1.1802663,56.2592885,0.0196871,8.8701172,1.0504857,9.0537765,13.0771916,35.2998564,0.0609002,96.8682612),(34853,'forelimb',252,4,78,5.2633484,85.5418352,120.5155398,1.8,86.0153883,120.4496957,-0.1299589,1.0726086,6.124615,1.1284582,51.2853788,0.0147325,8.3736494,1.052069,8.5018869,13.4838026,34.9000836,0.073939,96.4080362),(34854,'forelimb',252,4,79,5.2838258,85.3694646,120.4817989,1.8,85.8457863,120.4375066,-0.0984077,1.057618,5.7977486,1.1723344,48.7023511,0.0085007,8.4002179,1.1084668,8.5753405,13.4838026,34.4421133,0.0624188,94.8367299),(34855,'forelimb',252,4,80,5.2914908,85.1586624,120.481931,1.8,85.6295936,120.4571368,-0.0795214,1.0415777,5.9640189,1.1462097,45.1069923,0.0055652,7.5631874,1.1004552,7.7536554,13.5062908,34.417982,0.0499584,94.0816137),(34856,'forelimb',252,4,81,5.9023422,85.0474113,120.4747358,1.8,85.5270945,120.4622635,-0.0519594,1.082415,5.6175951,1.3537014,42.7836985,0.0026534,7.6160168,1.2506307,7.8548944,13.4961602,33.9698191,0.0379564,93.074792),(34857,'forelimb',252,4,82,6.2804457,84.7910317,120.5111142,1.8,85.1694852,120.4989649,-0.0361446,1.1088912,5.0331854,1.562924,39.9355317,0.0013669,7.9344448,1.4094475,8.2059269,13.522392,33.1305888,0.0519014,91.7551911),(34858,'forelimb',252,4,83,6.5544281,84.4663835,120.5962011,1.8,84.7917653,120.5329928,-0.0036539,1.1563941,4.9097238,1.8960985,35.4059489,0.0000146,7.2113932,1.6396646,7.5473887,13.5145148,32.2724008,3.0883098,89.9321793),(34859,'forelimb',252,4,84,6.2706546,84.0700149,120.7307613,1.8,84.3620773,120.7074884,0.0114911,1.3235221,4.8752121,1.9770109,28.2807022,0.000138,5.8009172,1.4937499,6.2061823,13.5145148,31.8085231,3.1145722,88.4219468),(34860,'forelimb',252,4,85,5.3716098,83.399738,120.9430675,1.8,83.7706788,120.9086588,0.0185098,1.4569911,4.2601223,1.8038066,17.6243646,0.0003067,4.137056,1.2380355,4.5576436,13.5737552,30.1272272,3.0845119,84.7759233),(34861,'forelimb',252,4,86,4.5000919,82.8812764,121.0858295,1.8,83.2590255,121.0604087,-0.002115,1.3726237,3.9164174,1.4812267,11.0529013,0.0000034,2.822197,1.0791207,3.1887472,14.035009,29.2472054,3.0975036,82.9097257),(34862,'forelimb',252,4,87,2.3383335,81.848213,121.235841,1.8,82.0599278,121.1929764,0.0387255,1.3272057,1.9536565,0.6845817,1.7179808,0.0005842,0.8793669,0.5158068,1.1996583,14.1015413,25.8706435,3.0584514,76.6855741),(34863,'forelimb',252,4,88,0.7571581,81.119303,121.3025766,1.8,81.2915985,121.2525825,1.2775518,0.9482432,1.0453676,0.1181965,0.1681123,0.1156489,0.1608164,0.1246479,0.2737084,14.1165372,24.1238339,3.0702852,72.7446593),(34864,'forelimb',252,4,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34865,'forelimb',252,4,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34866,'forelimb',252,4,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34867,'forelimb',252,4,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34868,'forelimb',252,4,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34869,'forelimb',252,4,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34870,'forelimb',252,4,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34871,'forelimb',252,4,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34872,'forelimb',252,4,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34873,'forelimb',252,4,98,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34874,'forelimb',252,4,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34875,'forelimb',252,4,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34876,'forelimb',252,4,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34877,'forelimb',252,4,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34878,'forelimb',252,4,103,0.0970716,100.0521697,127.6074296,1.8,100.009882,127.617336,1.3720705,0.3593346,0.4438015,0.0040884,0.0103258,0.015548,0.0232666,0.0113778,0.0324357,1.718752,1.9216232,2.0344439,5.1130702),(34879,'forelimb',252,4,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34880,'forelimb',252,4,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34881,'forelimb',252,4,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34882,'forelimb',252,4,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34883,'forelimb',252,4,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34884,'forelimb',252,4,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34885,'forelimb',252,4,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34886,'forelimb',252,4,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34887,'forelimb',252,4,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34888,'forelimb',252,4,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34889,'forelimb',252,4,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34890,'forelimb',252,4,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34891,'forelimb',252,4,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34892,'forelimb',252,4,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34893,'forelimb',252,4,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34894,'forelimb',252,4,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34895,'forelimb',252,4,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34896,'forelimb',252,4,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34897,'forelimb',252,4,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34898,'forelimb',252,4,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34899,'forelimb',252,4,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34900,'forelimb',252,4,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34901,'forelimb',252,4,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34902,'forelimb',252,4,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34903,'forelimb',252,4,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34904,'forelimb',252,4,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34905,'forelimb',252,4,130,2.0589241,88.2316552,124.1482359,1.8,88.270192,124.1552784,-0.9182949,1.3011413,1.4325215,0.5950569,0.835841,0.216646,0.5834754,0.4573346,0.9896118,2.578128,3.4642554,1.0516502,8.9065394),(34906,'forelimb',252,4,131,11.2806659,88.4470692,124.0182579,1.8,88.3474335,123.9900531,-0.2893885,2.6453743,2.6964665,11.9672248,14.8499733,0.1531047,5.5071974,4.5238304,9.6748429,5.156256,5.9694165,0.5280744,17.2054082),(34907,'forelimb',252,4,132,17.8451089,88.5034323,123.7408323,1.8,88.2940995,123.8406046,1.4684468,3.4960383,3.5178376,37.4523654,38.4735462,2.9431376,10.9367034,10.7128018,21.3555352,6.7267676,7.3425118,1.929567,21.9625131),(34908,'forelimb',252,4,133,18.0240338,88.5862158,123.6979881,1.8,88.321509,123.9392067,1.1922046,3.9957507,4.1738284,55.6022886,61.836678,2.5936187,14.8153377,13.9153549,26.8266139,7.6875785,8.4420297,1.82812,25.2525715),(34909,'forelimb',252,4,134,20.402259,88.5174849,123.6250512,1.8,88.3658009,123.887706,0.7372992,3.8524609,4.1951935,65.5018645,81.2453473,1.5368857,19.366293,17.0026032,31.8631898,7.734384,9.0642783,2.1193457,26.6153583),(34910,'forelimb',252,4,135,19.2554719,88.7561758,123.5828051,1.8,88.4990852,123.6517999,0.4884041,4.0788811,4.7347859,55.7898194,89.6201977,0.7065626,18.9280361,13.6777264,30.3238909,7.8997178,9.4628966,2.2597207,27.2230289),(34911,'forelimb',252,4,136,18.3084227,88.9759375,123.6077393,1.8,88.7273891,123.6053232,0.5479425,3.6300971,4.5959273,50.5591261,84.9233998,0.8280602,18.4779683,13.9277614,28.1620692,7.569124,9.2955727,2.1587989,26.6153583),(34912,'forelimb',252,4,137,17.94923,89.1212938,123.5091649,1.8,88.9518054,123.4977622,0.5747512,3.6282082,4.6639948,46.13111,93.0671135,0.8840871,19.9543775,12.7145708,29.55025,7.4631406,9.5406219,2.5161076,27.2230289),(34913,'forelimb',252,4,138,17.1460818,89.1918684,123.4000171,1.8,89.0358766,123.4335318,0.5127926,3.4598007,4.6776238,41.2318973,95.7814279,0.6878456,20.4765136,11.9174198,28.8753192,7.2770859,9.5406219,2.1962814,27.2230289),(34914,'forelimb',252,4,139,16.560855,89.2193154,123.2719795,1.8,89.1811031,123.3140427,0.4677403,3.4209115,4.8329071,38.8822314,105.6732108,0.5610933,21.865351,11.3660443,29.7048032,7.2089761,9.807811,2.6387494,28.0824049),(34915,'forelimb',252,4,140,16.851734,89.2933714,123.2541992,1.8,89.2632893,123.2214201,0.4664902,3.2804243,4.8917624,38.6253345,118.8593028,0.568125,24.2978489,11.7744936,31.9439244,7.0416448,10.0219602,2.6011732,28.0824049),(34916,'forelimb',252,4,141,17.6108503,89.4182699,123.1897146,1.8,89.2963031,123.0795928,0.4725804,3.32444,5.1653822,40.8846446,143.9513691,0.608143,27.8684835,12.2982049,34.698708,7.1134919,10.6125107,2.7686049,30.1571221),(34917,'forelimb',252,4,142,19.5102078,89.3329884,123.1479457,1.8,89.2917106,122.99819,0.441483,3.3371329,5.2844708,45.8143373,173.4746746,0.5936592,32.8272555,13.7286523,41.0439926,7.217568,10.9549375,2.6954871,31.0164981),(34918,'forelimb',252,4,143,21.4617097,89.2048828,123.0146122,1.8,89.1922864,122.9107845,0.39938,3.5143511,5.6006297,52.7800208,224.5797932,0.5408427,40.0990258,15.0184256,47.2378343,7.462822,11.6887773,2.8430937,33.1954751),(34919,'forelimb',252,4,144,23.0154141,89.1529179,122.9614126,1.8,89.0745708,122.8895261,0.3703088,3.567104,5.9823748,59.8703238,257.5485317,0.5024035,43.0512197,16.7840141,50.8422146,7.5352107,12.4015431,2.896614,35.0184869),(34920,'forelimb',252,4,145,25.2902454,89.0092604,122.891769,1.8,88.946568,122.8400809,0.3298881,3.9173168,6.4368891,75.5144427,317.0873757,0.4423066,49.2609658,19.2770834,59.795151,8.0889766,13.1809902,2.8095332,36.7372389),(34921,'forelimb',252,4,146,27.4796426,89.0297456,122.832166,1.8,89.0294152,122.7109236,0.3342465,4.257982,6.5719465,89.1116949,357.5054859,0.4929009,54.3987212,20.928152,66.8047903,8.6500132,13.4856331,2.7492525,37.9525801),(34922,'forelimb',252,4,147,29.4705327,89.3236309,122.5313725,1.8,89.3802072,122.3345211,0.4138666,5.1515854,6.5735004,117.0089511,369.872161,0.7943616,56.2671542,22.7131927,72.5924666,9.8921946,13.6556983,2.7201734,40.0272973),(34923,'forelimb',252,4,148,31.0075642,89.5229992,122.2802619,1.8,89.6339046,122.1370854,0.5073876,4.9451179,6.9286402,136.2568788,386.3938938,1.2201197,55.767637,27.5538181,74.1948538,9.897912,13.8570216,2.6224465,40.0272973),(34924,'forelimb',252,4,149,30.7424778,89.7774509,122.2687971,1.8,89.9550326,122.1505828,0.5844029,4.7874672,7.0370731,116.1763656,379.9073617,1.5595377,53.9865586,24.2667702,69.3253947,9.3784944,13.7096736,2.5796711,39.2721811),(34925,'forelimb',252,4,150,31.5639773,89.8840315,122.3375408,1.8,90.1682149,122.2540014,0.5975378,4.5673148,7.0394873,100.3975829,399.5541677,1.6651495,56.7589872,21.9817525,70.8002792,8.9723461,13.7096736,2.5796711,38.8119561),(34926,'forelimb',252,4,151,29.0663569,90.4332713,122.6400806,1.8,90.6803826,122.5919553,0.5742265,4.3502923,6.7598943,76.0467456,352.0644173,1.4293406,52.0813497,17.4808357,63.1364105,8.4285208,14.0291651,2.4429328,37.1363899),(34927,'forelimb',252,4,152,25.6141343,91.0155193,123.0629494,1.8,91.2644291,123.0118619,0.5325973,3.9560292,6.015608,63.1352233,271.6444369,1.1006949,45.1566055,15.959241,55.2316771,8.0685281,12.2140278,2.4558631,33.6988859),(34928,'forelimb',252,4,153,22.4779118,91.5087514,123.4160766,1.8,91.7333243,123.3219028,0.4770361,3.6053278,5.7464533,52.6508319,226.9470305,0.789788,39.4934087,14.6036185,48.2003067,7.5262392,11.4413255,2.5431738,32.2318393),(34929,'forelimb',252,4,154,20.9139128,91.776244,123.6390916,1.8,91.9429313,123.4823248,0.4354391,3.4531907,5.426153,46.6306636,212.8482931,0.6201757,39.2263716,13.5036457,47.0585008,7.1956195,11.2048922,2.5748634,32.0843937),(34930,'forelimb',252,4,155,20.9240955,91.9611241,123.7452713,1.8,92.1023677,123.547851,0.4065852,3.6594635,5.5254373,47.8917508,219.3872427,0.5454236,39.7049556,13.0870963,47.7419464,7.4170346,11.3522236,2.6271413,32.8395099),(34931,'forelimb',252,4,156,20.4654814,91.9688589,123.7271635,1.8,92.1213072,123.5236078,0.3969556,3.8714982,5.5804037,51.9420691,227.0041479,0.5098266,40.6788043,13.4165291,49.4605819,7.6786435,11.4655059,2.9147938,32.9437697),(34932,'forelimb',252,4,157,21.5906162,91.8841219,123.572205,1.8,92.2126922,123.3588945,0.3801515,4.7278609,5.9551192,66.1838502,249.0655489,0.4954557,41.8237719,13.9986881,52.4905907,8.7124185,11.6887773,2.8430937,35.5218977),(34933,'forelimb',252,4,158,24.7239854,91.7407897,123.4149247,1.8,92.1019702,123.2696053,0.3737782,4.8795243,6.3049053,81.5025211,287.3433766,0.5493827,45.5745748,16.7029645,58.3205275,9.0640737,11.9697226,2.7744188,36.4855335),(34934,'forelimb',252,4,159,28.5605777,91.5183227,123.2074042,1.8,91.9206117,123.0729917,0.353189,5.1795922,6.8346093,107.7400276,350.5851348,0.569503,51.2955634,20.8008707,67.0508814,9.5903826,12.7248603,0.204018,39.0636615),(34935,'forelimb',252,4,160,30.8246669,91.1797925,122.9798327,1.8,91.5704933,122.8397362,0.3650527,5.2346171,7.3836952,128.5169767,423.1991867,0.6547567,57.3153655,24.5513616,74.6581512,9.6946852,14.2316921,2.6374267,40.8255993),(34936,'forelimb',252,4,161,34.4836771,90.7658104,122.6466576,1.8,91.023721,122.5072448,0.3912788,5.1576146,7.8988521,147.1870097,556.2044398,0.8359057,70.4158569,28.5378071,88.7732192,9.8609438,15.2584623,2.5770233,43.4648013),(34937,'forelimb',252,4,162,35.1576949,90.7260767,122.7419901,1.8,90.984673,122.5508918,0.3373757,5.1526229,8.1425899,143.7819884,605.7592001,0.6420314,74.3939218,27.9046206,92.0511593,9.3695571,15.6408793,2.7763912,42.5011655),(34938,'forelimb',252,4,163,35.524217,90.7703754,122.7853652,1.8,91.081138,122.6500337,0.2925594,5.137718,8.0779873,133.7289124,628.4066268,0.4924649,77.7924756,26.0288541,94.248656,9.2452769,15.6408793,2.863293,42.6054253),(34939,'forelimb',252,4,164,33.4490118,91.3823513,122.9398763,1.8,91.7159565,122.8738197,0.3106723,4.9692314,7.5847965,118.1748648,509.4516612,0.5209782,67.1674795,23.7813164,82.4248852,8.9945006,14.8164498,2.8473581,39.9230375),(34940,'forelimb',252,4,165,28.9046642,92.323946,123.2765968,1.8,92.616011,123.2321639,0.3136807,4.4614447,6.7307869,91.7137396,373.0997531,0.4586706,55.4318177,20.5569597,68.9747852,8.3507819,13.4924769,2.9816795,36.5897933),(34941,'forelimb',252,4,166,28.7595884,92.4973921,123.3714954,1.8,92.8052419,123.3425542,0.3079293,4.3691772,6.6687579,82.531173,360.6935565,0.4403147,54.0870675,18.8894087,66.4580851,8.2359528,13.2369013,2.9123607,35.4787119),(34942,'forelimb',252,4,167,28.0860741,92.771776,123.4393423,1.8,93.0537463,123.4281987,0.3066224,3.9421836,6.3865825,74.6223362,337.6989715,0.4264756,52.8763186,18.9291885,64.5515281,7.7070632,12.8188253,2.9047439,34.1591109),(34943,'forelimb',252,4,168,27.7804246,92.9533223,123.5075148,1.8,93.2955081,123.4987167,0.2988968,3.6754782,6.318524,68.778385,319.8197109,0.4014748,50.6162054,18.7127719,61.2654399,7.3544005,12.5127034,2.863293,33.8031457),(34944,'forelimb',252,4,169,27.1924003,93.2269782,123.5532537,1.8,93.5045018,123.5153943,0.2802307,3.5313659,6.0878318,62.4292668,294.3549297,0.3466806,48.3513573,17.6785042,58.2718976,7.0109558,12.5789281,3.0045265,32.6920643),(34945,'forelimb',252,4,170,26.5380205,93.4557445,123.6314384,1.8,93.671984,123.6006242,0.2651192,3.4846812,5.8557438,57.1328598,276.9722703,0.3036691,47.299247,16.3954335,56.7815457,6.8557539,12.2215837,2.9648838,31.3724633),(34946,'forelimb',252,4,171,24.9293183,93.8955158,123.7449143,1.8,94.0196135,123.6815133,0.237667,3.4854932,5.8472675,51.0642495,240.1736708,0.2303056,41.074514,14.6505089,49.5853952,6.8557539,11.8845829,2.9229237,31.0164981),(34947,'forelimb',252,4,172,24.5946872,94.079543,123.7805962,1.8,94.1468204,123.7625987,0.2271152,3.2554838,5.9431987,47.8931546,224.4264063,0.2078272,37.7618886,14.711532,45.3024799,6.5746028,11.7988288,2.9584818,30.1571221),(34948,'forelimb',252,4,173,25.1744309,94.299246,123.7599209,1.8,94.3442634,123.786612,0.2154827,3.1811872,5.7437302,45.4161003,207.8841748,0.1918232,36.1932345,14.2764625,43.3318728,6.5746028,11.4655059,2.9147938,29.5494515),(34949,'forelimb',252,4,174,25.0154798,94.3746583,123.7678116,1.8,94.3908229,123.7969897,0.2112361,3.0811822,5.8224973,42.5328486,197.7403015,0.1832841,33.9614241,13.8040681,40.8907067,6.3167435,11.4655059,2.9147938,29.2977461),(34950,'forelimb',252,4,175,24.5815951,94.5460534,123.7862671,1.8,94.5516602,123.7873611,0.1929964,3.0670213,5.5859983,39.270897,182.2174025,0.1507157,32.6203825,12.8042464,39.1265392,6.2016017,11.0472442,2.9060477,28.3341103),(34951,'forelimb',252,4,176,24.237117,94.6280775,123.7885154,1.8,94.6166017,123.7918951,0.1823469,3.0560643,5.6733246,37.254662,172.0736261,0.1328335,30.3302981,12.1904051,36.7119912,6.1636902,10.9549375,2.9441971,28.0824049),(34952,'forelimb',252,4,177,23.4928271,94.7394087,123.7760483,1.8,94.6882585,123.7661904,0.1652818,3.0288432,5.7192944,35.3612104,160.0801244,0.1059926,27.9894885,11.6748236,33.6501041,6.0380616,10.8788312,2.9829374,28.0824049),(34953,'forelimb',252,4,178,22.8133822,94.7813412,123.7655241,1.8,94.7826182,123.7701718,0.1539698,3.0149921,5.4764362,34.1366194,152.9641865,0.0894283,27.9313374,11.3222915,34.1639917,6.0380616,10.6298941,2.896614,27.9781451),(34954,'forelimb',252,4,179,22.8927179,94.8446575,123.7081939,1.8,94.8128797,123.6982851,0.1440185,3.0135349,5.5302465,33.6118033,145.9310876,0.078592,26.3878088,11.1536135,32.4653168,6.0380616,10.6298941,2.896614,27.4747343),(34955,'forelimb',252,4,180,22.6643899,94.8571577,123.6672167,1.8,94.8047978,123.6534177,0.1380526,2.9704891,5.477616,33.1276004,142.2683598,0.0715355,25.9726787,11.1522378,31.8556066,5.9647255,10.5339308,2.9361973,27.2230289),(34956,'forelimb',252,4,181,22.1441199,94.8538624,123.5861271,1.8,94.8140495,123.5353,0.1349317,2.9479749,5.4646981,32.6415392,136.8352234,0.0667879,25.0398503,11.0725297,30.8971209,5.9218657,10.4547603,2.976444,26.8670637),(34957,'forelimb',252,4,182,21.7991383,94.8437372,123.5341194,1.8,94.8668182,123.5145694,0.1331832,2.896762,5.079752,32.5088539,134.1182606,0.0640646,26.4025215,11.22248,32.3395686,5.9218657,10.1136544,2.927532,26.5110985),(34958,'forelimb',252,4,183,21.1748031,94.8740502,123.4558749,1.8,94.8541121,123.394339,0.1334699,3.0696762,5.0993738,31.8618628,129.6009608,0.0624963,25.4150736,10.3795516,31.5314424,5.8462875,10.1136544,2.927532,26.3636529),(34959,'forelimb',252,4,184,20.6688001,94.8540523,123.4002622,1.8,94.7977277,123.3165674,0.1377517,3.014063,5.0713917,31.4476633,126.0758396,0.0649545,24.8602052,10.4336451,30.8320327,5.7888399,10.0311674,2.9694018,26.3636529),(34960,'forelimb',252,4,185,20.0964416,94.8363747,123.2924694,1.8,94.7735478,123.2110809,0.1366212,2.969043,5.0394079,31.1836588,121.0277799,0.0621299,24.0162698,10.5029329,30.1268301,5.836942,10.0311674,2.9694018,26.0076877),(34961,'forelimb',252,4,186,19.8272709,94.7910709,123.218105,1.8,94.7273928,123.1264034,0.1406807,2.900595,4.9829166,31.0649141,117.4723443,0.0649701,23.5750173,10.7098421,29.6210591,5.7329911,9.9665388,3.0118901,25.5042769),(34962,'forelimb',252,4,187,19.8987178,94.7549824,123.1057763,1.8,94.702841,123.0563359,0.1454633,2.8557906,4.9290764,31.1248245,114.4329607,0.0696812,23.2159034,10.8988468,29.3767848,5.836942,9.9201178,3.0548543,25.5042769),(34963,'forelimb',252,4,188,19.5974882,94.7011552,123.0248337,1.8,94.6016361,122.9469889,0.1513961,3.0155302,4.5654123,30.7110245,110.6496531,0.0742947,24.2365081,10.184287,30.640064,5.8940304,9.3845276,2.863293,25.4000171),(34964,'forelimb',252,4,189,19.3653557,94.6398741,122.8992283,1.8,94.5516283,122.8279363,0.1602004,2.891802,4.4874184,30.371363,108.2993662,0.0821264,24.1340025,10.5025734,30.8839379,5.7380707,9.3845276,2.863293,24.5406411),(34965,'forelimb',252,4,190,19.3364301,94.5788757,122.815547,1.8,94.507038,122.7813192,0.1659584,2.8844531,4.4142464,30.4993314,106.8744835,0.0879494,24.2112638,10.5736966,30.913679,5.8231196,9.2756891,2.9078495,24.5406411),(34966,'forelimb',252,4,191,19.2677806,94.4937977,122.6834733,1.8,94.4097502,122.6414679,0.1704913,2.7662911,4.3811041,30.3845322,104.5488631,0.0924428,23.8635878,10.9838522,30.7047588,5.7380707,9.2756891,2.9078495,24.5406411),(34967,'forelimb',252,4,192,19.1851439,94.4268314,122.6116119,1.8,94.3793477,122.5847166,0.1729704,2.9073492,4.4577289,30.3600994,103.2705883,0.0947157,23.1666375,10.4425364,29.9746546,5.8839289,9.2756891,2.9078495,24.8966063),(34968,'forelimb',252,4,193,19.0298294,94.341613,122.4721479,1.8,94.2718866,122.392579,0.1878872,2.8406789,4.4055998,30.4031108,99.9069416,0.1106526,22.6772619,10.7027621,29.0440135,5.7380707,9.115059,2.9996956,24.5406411),(34969,'forelimb',252,4,194,18.941374,94.2684617,122.3862181,1.8,94.2229206,122.3355771,0.1976224,2.758756,4.2331298,30.1876072,98.4845951,0.1216946,23.2651961,10.9424709,30.3870951,5.6524047,8.9721488,2.8501359,23.9329705),(34970,'forelimb',252,4,195,19.1020596,94.1656899,122.2552817,1.8,94.0699217,122.1986105,0.2098814,2.8788817,4.3618971,30.3984058,98.0404149,0.1381944,22.4765536,10.5591022,29.4136404,5.8839289,9.1856803,2.9533711,24.6449009),(34971,'forelimb',252,4,196,19.1054166,94.0815327,122.1673743,1.8,93.9900374,122.1114319,0.2112371,2.8078638,4.3727355,30.376863,97.1909581,0.1399834,22.2265804,10.8184958,29.1436473,5.8374863,9.115059,2.9996956,24.5406411),(34972,'forelimb',252,4,197,19.1792693,93.9712911,122.04468,1.8,93.8690117,122.0167197,0.2199643,2.7892483,4.4114434,30.6189281,96.1892197,0.1521842,21.8044779,10.9774837,28.5167213,5.8660608,9.115059,2.9996956,24.2889357),(34973,'forelimb',252,4,198,19.2585491,93.8917214,121.979184,1.8,93.7390572,121.9140138,0.2246137,2.8684987,4.1777626,30.4126978,95.9404098,0.1592315,22.9645431,10.6023047,30.243878,5.935635,8.8582451,2.896614,24.5406411),(34974,'forelimb',252,4,199,19.0250738,93.7944902,121.8841262,1.8,93.6294406,121.8080393,0.2188786,2.8119365,4.293357,29.5182372,93.5492717,0.1494979,21.7893066,10.4974765,28.6601183,5.935635,8.8582451,2.7430702,24.1846759),(34975,'forelimb',252,4,200,18.8525829,93.7200064,121.8184493,1.8,93.5779229,121.7663108,0.2188968,2.7820026,4.2870188,29.1446022,92.0436816,0.1481668,21.4703237,10.4761233,28.2018098,5.9805356,8.8582451,2.7430702,24.1846759),(34976,'forelimb',252,4,201,18.6334306,93.61178,121.7064195,1.8,93.4396017,121.6082809,0.2216187,2.6718442,4.0916739,28.3591196,89.6107805,0.1500488,21.9007631,10.6140617,27.3508186,5.7776852,8.8478174,2.6344941,23.8287107),(34977,'forelimb',252,4,202,18.3949199,93.5357275,121.6505631,1.8,93.4079049,121.5547069,0.2180839,2.6418864,4.0839849,27.6598921,87.3830142,0.1435152,21.3965075,10.4697507,27.268323,5.7108911,8.7005189,2.5672878,23.8287107),(34978,'forelimb',252,4,203,18.263104,93.4029999,121.5413494,1.8,93.2698696,121.431667,0.2174571,2.6549674,4.1444914,26.825705,85.1186011,0.1416818,20.5377677,10.1039678,25.4904642,5.585944,8.8582451,2.7430702,23.2210402),(34979,'forelimb',252,4,204,18.3157521,93.3099325,121.4871288,1.8,93.1851566,121.4165725,0.2122514,2.6790727,4.1584721,26.4622196,84.2029578,0.13547,20.2485328,9.8773803,25.830486,5.585944,8.8478174,2.6344941,23.5770053),(34980,'forelimb',252,4,205,18.3833944,93.2130197,121.4126381,1.8,93.0831523,121.3857233,0.2079044,2.7245856,4.028969,26.0903588,82.4536867,0.1305376,20.4652074,9.5759,26.0787341,5.585944,8.6473042,2.677945,22.7176293),(34981,'forelimb',252,4,206,18.4117606,93.1344095,121.3641189,1.8,92.9938826,121.3488147,0.2029679,2.7483753,4.114603,25.853489,81.8200971,0.1246887,19.8852959,9.4068261,24.8591688,5.585944,8.8478174,2.6344941,22.9693347),(34982,'forelimb',252,4,207,18.1014673,93.0355328,121.2921934,1.8,92.9154589,121.2542967,0.1901779,2.6994519,4.1402376,25.1119309,79.2808178,0.1078054,19.1488569,9.3026035,24.8002685,5.585944,8.7005189,2.7886023,22.7176293),(34983,'forelimb',252,4,208,17.9242767,92.9580955,121.2543502,1.8,92.8314954,121.1814597,0.1786501,2.7109935,3.876909,24.4609767,77.2282817,0.0943347,19.9200655,9.0228827,24.6477718,5.585944,8.4747721,2.6098686,22.3616642),(34984,'forelimb',252,4,209,17.7978879,92.8480451,121.1713676,1.8,92.7836403,121.1068386,0.1713896,2.6936059,3.9222934,24.0143623,75.4101795,0.0862838,19.2260424,8.9153214,24.3483433,5.5653028,8.4747721,2.6098686,22.3616642),(34985,'forelimb',252,4,210,17.617788,92.7831661,121.1310859,1.8,92.7508712,121.0806456,0.1623371,2.503068,3.9909139,23.8243241,73.6566789,0.0767039,18.4560933,9.5180491,24.3273468,5.156256,8.463872,2.7233683,22.005699),(34986,'forelimb',252,4,211,17.443227,92.7058317,121.0804594,1.8,92.6378197,121.0724838,0.1468718,2.5775484,4.0074646,23.9665835,71.4815703,0.0622626,17.8371058,9.298209,23.8143681,5.156256,8.3430318,2.9340964,22.3616642),(34987,'forelimb',252,4,212,17.2247461,92.6208538,121.0572292,1.8,92.4989851,121.0386646,0.1283245,2.5500083,3.7954926,23.8585455,69.9087475,0.0470149,18.4188866,9.3562619,24.3016942,5.156256,8.1527566,2.8198421,21.7539936),(34988,'forelimb',252,4,213,17.1673424,92.5156554,121.020265,1.8,92.4241895,120.9948,0.1149123,2.5465795,3.8257626,23.8660651,69.0886815,0.037616,18.0587998,9.3718122,23.4221206,5.156256,8.2986537,2.7707014,22.005699),(34989,'forelimb',252,4,214,16.9309578,92.4470791,120.995561,1.8,92.3605663,120.9683489,0.1077967,2.5494496,3.8461721,23.639514,67.1107795,0.0326632,17.4487197,9.2723992,23.2730824,5.156256,8.1527566,2.8198421,22.005699),(34990,'forelimb',252,4,215,16.691496,92.3642005,120.9551887,1.8,92.3208264,120.9484789,0.1013647,2.5686353,3.9313867,23.3032101,65.3420463,0.0284859,16.6206102,9.0722144,22.502645,5.156256,8.2986537,2.7707014,21.7539936),(34991,'forelimb',252,4,216,16.4478939,92.3028508,120.9384822,1.8,92.2575943,120.9213647,0.092413,2.5626821,3.9519689,23.0262617,63.7314016,0.0233447,16.1264937,8.9852196,21.9408387,5.156256,8.1527566,2.8198421,21.7539936),(34992,'forelimb',252,4,217,16.2517366,92.2463646,120.9034569,1.8,92.237133,120.9060187,0.0853116,2.5796379,3.6571704,22.8089887,62.053527,0.0196658,16.9676333,8.8419343,22.339812,5.156256,8.0731046,2.7017501,21.3980284),(34993,'forelimb',252,4,218,16.0360531,92.1793175,120.8864603,1.8,92.1407322,120.8907657,0.0755104,2.5737758,3.684688,22.6033321,60.703405,0.0152102,16.4745032,8.7821681,22.3217699,5.156256,7.8997178,2.7509856,21.146323),(34994,'forelimb',252,4,219,15.8480644,92.1125885,120.8688184,1.8,92.0778161,120.8796248,0.0695738,2.5762682,3.7498138,22.3678173,59.7546961,0.0127649,15.9353771,8.6822549,21.7279919,5.156256,8.0272343,2.8706458,21.5022882),(34995,'forelimb',252,4,220,15.6182818,92.0524851,120.8571046,1.8,92.0339613,120.8673281,0.0666856,2.5790212,3.7805485,22.1401231,58.2828913,0.0115585,15.4165172,8.5846999,21.1246314,5.156256,7.9230552,2.9229237,21.2505827),(34996,'forelimb',252,4,221,15.3760785,91.9641234,120.8333648,1.8,91.9057818,120.8451368,0.0605853,2.5872549,3.8437132,21.943385,56.8671929,0.009395,14.7948584,8.4813386,20.4311423,5.156256,7.9230552,2.9229237,20.9988773),(34997,'forelimb',252,4,222,15.2157845,91.9141686,120.8361235,1.8,91.86624,120.8583174,0.0531986,2.5701329,3.5123577,21.8264615,56.1044777,0.0071702,15.9734523,8.4923475,21.2402672,5.156256,7.7463106,2.8023,20.8946176),(34998,'forelimb',252,4,223,15.1036627,91.8751173,120.825342,1.8,91.852441,120.8457714,0.0456289,2.5673516,3.5473718,21.8250872,55.1225802,0.0052373,15.5389914,8.5010121,21.1410061,5.156256,7.7463106,2.8023,20.8946176),(34999,'forelimb',252,4,224,14.9250174,91.8245468,120.8247393,1.8,91.8196095,120.8654703,0.0395702,2.5736643,3.5941343,21.8883083,54.4215928,0.0038929,15.1417807,8.5047255,20.6888762,5.156256,7.7463106,2.8023,20.8946176),(35000,'forelimb',252,4,225,14.8551371,91.7773139,120.8256206,1.8,91.7855489,120.8576101,0.0308069,2.5544094,3.6223773,22.1508937,53.6136159,0.002349,14.8006715,8.6716302,20.2884865,5.156256,7.6140908,2.8555412,20.8946176),(35001,'forelimb',252,4,226,14.6899196,91.7149421,120.8327435,1.8,91.7169036,120.8604922,0.0247777,2.5342731,3.6830711,22.1094811,52.4817949,0.0015028,14.2494656,8.7241903,20.0924277,5.156256,7.6140908,2.8555412,20.6429122),(35002,'forelimb',252,4,227,14.5435011,91.6706623,120.822929,1.8,91.7092117,120.8325094,0.0154316,2.5260218,3.7250175,22.2289234,51.4909017,0.0005772,13.8229959,8.7999728,19.6329182,5.156256,7.6140908,2.8555412,20.8946176),(35003,'forelimb',252,4,228,14.4364146,91.6079802,120.8362879,1.8,91.6329677,120.8277318,0.0107125,2.5033418,3.7815322,22.3076428,50.784378,0.0002761,13.4295769,8.9111452,19.1399082,5.156256,7.7819807,3.0309354,21.2505827),(35004,'forelimb',252,4,229,14.4357432,91.5409037,120.8456233,1.8,91.5074307,120.8363222,0.0040857,2.4819054,3.458768,22.3398363,49.683784,0.0000402,14.3645898,9.0010831,20.0819958,5.156256,7.6140908,2.8555412,20.6429122),(35005,'forelimb',252,4,230,14.4869366,91.4961445,120.8638758,1.8,91.4731485,120.8643382,-0.0019994,2.8854581,3.4668578,22.709224,49.2512021,0.0000097,14.2062942,7.8702318,19.9830196,5.585944,7.6140908,2.8555412,20.9988773),(35006,'forelimb',252,4,231,14.3476235,91.4526803,120.8677219,1.8,91.4755043,120.8891158,-0.001814,2.8817665,3.5101483,22.6082231,48.00777,0.0000079,13.6768494,7.8452655,19.3789365,5.585944,7.5041783,2.910502,20.9988773),(35007,'forelimb',252,4,232,14.2182694,91.4231072,120.8726552,1.8,91.4725185,120.8900332,-0.0025061,2.8777315,3.54041,22.4891521,47.2344073,0.0000149,13.3415077,7.814889,18.9787834,5.585944,7.5041783,2.910502,20.9988773),(35008,'forelimb',252,4,233,14.2004776,91.3995087,120.8760148,1.8,91.4397684,120.9152842,-0.0112936,2.8753467,3.5676745,22.4622379,46.3153579,0.0003019,12.9819459,7.8120102,19.0740401,5.585944,7.5041783,2.910502,20.7471719),(35009,'forelimb',252,4,234,14.133059,91.3652947,120.8937171,1.8,91.36853,120.957172,-0.0223273,2.8592479,3.6078299,22.5144182,45.7630824,0.001174,12.6843791,7.8742449,18.7451851,5.585944,7.5041783,2.910502,20.7471719),(35010,'forelimb',252,4,235,13.9022693,91.3372198,120.9241527,1.8,91.3389985,120.9819617,-0.0181165,2.8289029,3.6343114,22.3338803,44.702073,0.0007604,12.3000118,7.894891,18.2407695,5.585944,7.5041783,2.910502,20.4954665),(35011,'forelimb',252,4,236,13.7273167,91.3115389,120.9451458,1.8,91.2919589,120.9850738,-0.0216241,2.8089264,3.6530413,22.2867716,43.8567181,0.0010697,12.0055357,7.9342667,18.0960184,5.585944,7.4175649,2.9669205,20.4954665),(35012,'forelimb',252,4,237,13.6471417,91.2978724,120.9708604,1.8,91.2740477,120.9945964,-0.0272681,2.7844033,3.6680447,22.4410829,43.1161309,0.0016908,11.7545272,8.0595664,17.861554,5.585944,7.4175649,2.9669205,20.4954665),(35013,'forelimb',252,4,238,13.6524569,91.2660175,120.9956547,1.8,91.2174264,121.0091277,-0.0307468,2.7611042,3.2980058,22.5594574,42.7533987,0.0021504,12.9634091,8.1704475,18.9327986,5.585944,7.2028834,2.8387078,20.1395013),(35014,'forelimb',252,4,239,13.5871084,91.2444577,121.0168865,1.8,91.2095412,121.0480675,-0.0350007,2.756386,3.3245696,22.8982443,41.7608673,0.002773,12.5612855,8.3073431,18.5962318,5.585944,7.2028834,2.8387078,20.1395013),(35015,'forelimb',252,4,240,13.488806,91.2305058,121.0414205,1.8,91.2296929,121.0583566,-0.0446547,2.7382857,3.3492776,22.8346875,41.1965775,0.0044799,12.3001381,8.3390451,18.3038479,5.585944,7.2028834,2.8387078,20.1395013),(35016,'forelimb',252,4,241,13.3004816,91.2322346,121.0713274,1.8,91.2361553,121.0576185,-0.0613503,2.7179825,3.3657801,22.8808641,40.0715515,0.0083331,11.9055763,8.4183265,17.9523898,5.585944,7.2028834,2.8387078,20.1395013),(35017,'forelimb',252,4,242,13.1692252,91.2153404,121.0959322,1.8,91.2019894,121.0781107,-0.063506,2.6956905,3.3590454,22.9281435,39.0990056,0.0088401,11.6399157,8.5054808,18.2043196,5.585944,7.2028834,2.8387078,19.8877959),(35018,'forelimb',252,4,243,12.9578498,91.1936783,121.1278823,1.8,91.1668749,121.0989971,-0.0860645,2.677846,3.395405,22.7947033,38.2154232,0.0159572,11.2550413,8.5123278,17.7571688,5.585944,7.2028834,2.8387078,20.1395013),(35019,'forelimb',252,4,244,12.8361607,91.1652503,121.1591942,1.8,91.127557,121.1074224,-0.1013208,2.6897569,3.4344733,22.7739025,37.5692604,0.0218874,10.9388712,8.4669,17.3853057,5.585944,7.2028834,0.3028849,20.1395013),(35020,'forelimb',252,4,245,12.6551096,91.1459508,121.2061304,1.8,91.0795331,121.1777452,-0.1196621,2.7023708,3.4165674,22.6244524,36.5507347,0.0300576,10.6980868,8.3720756,17.3177152,5.585944,7.086596,2.896614,20.1395013),(35021,'forelimb',252,4,246,12.4986761,91.1235157,121.2304197,1.8,91.0795331,121.1777452,-0.1293843,2.7292009,3.4423353,22.5747146,35.9249545,0.0346778,10.4362159,8.2715473,16.9927726,5.585944,7.086596,2.896614,20.1395013),(35022,'forelimb',252,4,247,12.4184452,91.1404236,121.2637361,1.8,91.1140427,121.2008541,-0.1533424,2.776896,3.4307884,22.690678,35.3137737,0.0482874,10.2931949,8.1712379,16.9070277,5.585944,7.086596,0.2449787,20.1395013),(35023,'forelimb',252,4,248,12.3580203,91.1318642,121.2903008,1.8,91.064823,121.2242754,-0.1734903,2.8108426,3.1681643,22.8788753,34.616288,0.0613743,10.9262921,8.1395078,17.4949058,6.015632,6.9418221,0.3805064,20.1395013),(35024,'forelimb',252,4,249,12.249647,91.1167531,121.3171235,1.8,91.0680747,121.2751411,-0.2012359,2.8446306,3.2113469,22.8720138,34.0051868,0.0815667,10.5890729,8.0404162,17.1752252,6.015632,6.9418221,0.3805064,20.1395013),(35025,'forelimb',252,4,250,12.2534516,91.0908974,121.3337099,1.8,91.035395,121.3152453,-0.197104,2.7915944,3.1524358,22.9201053,33.6308816,0.0783189,10.668221,8.2103996,17.7350132,5.9805356,6.7939638,2.8198421,19.8877959),(35026,'forelimb',252,4,251,12.4238163,91.0638357,121.3664279,1.8,91.0147029,121.3614179,-0.1992793,2.8487307,3.1863269,23.1572993,33.6858821,0.0811469,10.5720106,8.1289887,17.6783135,6.015632,6.9418221,0.3805064,19.8877959),(35027,'forelimb',252,4,252,12.5044389,91.0485315,121.3942628,1.8,90.9829688,121.3937905,-0.2146341,2.8228255,3.2134592,23.3859259,33.6011346,0.0945434,10.4563752,8.2845809,17.5936485,6.015632,6.9418221,0.3805064,20.1395013),(35028,'forelimb',252,4,253,12.3315005,91.0501164,121.430044,1.8,90.9843277,121.3854558,-0.2479565,2.8441357,3.2324639,23.3028381,33.0254816,0.1237932,10.2168136,8.1932933,17.3333632,6.015632,6.9418221,0.3805064,20.1395013),(35029,'forelimb',252,4,254,12.0694912,91.0223964,121.465551,1.8,90.9448975,121.4498809,-0.2730948,2.7957733,3.1602227,23.0136234,32.2850812,0.1463326,10.2160779,8.231577,17.2031649,6.015632,6.7939638,2.8198421,20.1395013),(35030,'forelimb',252,4,255,11.8531363,91.0071035,121.4865282,1.8,90.9381301,121.4546296,-0.2959387,2.8318375,3.1770809,22.8252822,31.2857341,0.1680234,9.8473206,8.0602372,17.0010965,6.015632,6.7939638,0.3217506,19.8877959),(35031,'forelimb',252,4,256,11.5313175,91.0047637,121.520905,1.8,90.939761,121.4950228,-0.2926025,2.861251,3.1898554,22.2617344,30.6137792,0.1599021,9.597231,7.7804199,16.5583817,5.585944,6.7939638,0.3217506,19.5318307),(35032,'forelimb',252,4,257,11.3440561,91.0038058,121.5461781,1.8,90.8879638,121.5390412,-0.285582,2.8792626,3.0778034,22.1610228,29.4407495,0.1500514,9.5655069,7.6967703,16.2894529,5.585944,6.6705516,2.8809903,19.2801253),(35033,'forelimb',252,4,258,11.2336128,90.9713888,121.5732305,1.8,90.8427003,121.5411846,-0.285994,2.8964217,3.0186232,22.1383581,28.7750458,0.1490078,9.5325067,7.6433477,16.1696467,5.585944,6.5589027,0.551655,18.9241602),(35034,'forelimb',252,4,259,11.0572055,90.9419683,121.6192477,1.8,90.8372368,121.5838003,-0.3121728,2.9514455,2.9993646,22.2552732,27.9888719,0.1738323,9.3316003,7.5404657,15.998116,6.015632,6.5589027,0.551655,19.2801253),(35035,'forelimb',252,4,260,10.8632862,90.8999493,121.6516186,1.8,90.8154666,121.6138079,-0.3291979,2.9798801,3.0560523,22.1501437,27.2725903,0.1892251,8.9241242,7.4332332,15.6692014,6.015632,6.5589027,0.551655,19.2801253),(35036,'forelimb',252,4,261,10.9125773,90.8774247,121.6899988,1.8,90.7805418,121.6852544,-0.3454707,2.8721163,3.033087,22.3230231,26.8349316,0.2085699,8.8473993,7.7723257,15.5982921,6.015632,6.7119411,0.8760581,19.5318307),(35037,'forelimb',252,4,262,10.8115893,90.8511147,121.7265968,1.8,90.7873653,121.6858387,-0.3147653,2.8941534,2.9896436,22.1574229,26.4336878,0.1727115,8.841752,7.6559256,15.6419909,6.015632,6.7119411,0.8760581,19.5318307),(35038,'forelimb',252,4,263,10.7253159,90.8039178,121.7729377,1.8,90.7242642,121.7309109,-0.2656819,2.8131854,3.0380407,21.8255991,26.0538738,0.1232368,8.5758804,7.7583225,14.941719,6.015632,6.6705516,2.8809903,19.6360905),(35039,'forelimb',252,4,264,10.576995,90.7628762,121.8114533,1.8,90.6581584,121.7729782,-0.2711502,2.8275434,3.0519309,21.4809537,25.6878757,0.1264623,8.4169256,7.5970376,14.8720093,6.015632,6.6705516,2.8809903,19.6360905),(35040,'forelimb',252,4,265,10.2673731,90.754169,121.8624277,1.8,90.6611841,121.8344517,-0.308124,2.8510453,3.0031648,20.8388094,25.0337306,0.1573879,8.3357831,7.3091822,14.4534123,6.015632,6.5729625,2.9441971,19.8877959),(35041,'forelimb',252,4,266,10.0418426,90.7268992,121.8950703,1.8,90.6308823,121.8256259,-0.3574818,2.9108077,3.0119079,20.2966004,24.7936872,0.204923,8.2318876,6.9728414,14.2938155,6.015632,6.5729625,2.9441971,19.6360905),(35042,'forelimb',252,4,267,9.9068936,90.720396,121.9266381,1.8,90.6006226,121.8831194,-0.3828888,2.9574107,3.0418427,19.9332025,24.2265477,0.2304643,7.9644315,6.7400861,13.9940835,6.015632,6.5729625,2.9441971,19.8877959),(35043,'forelimb',252,4,268,9.6543956,90.6578008,121.9594947,1.8,90.5543937,121.9498454,-0.4017049,2.8082432,2.9586345,19.3490109,23.4792875,0.2459806,7.9358526,6.8900766,13.8020738,5.585944,6.5729625,0.1973956,19.5318307),(35044,'forelimb',252,4,269,9.5063545,90.6355156,121.9751442,1.8,90.5125134,121.9618836,-0.4086446,2.8150738,2.9269543,19.0044196,22.8234315,0.250175,7.7976726,6.750949,13.556178,5.585944,6.44532,2.4980915,18.9241602),(35045,'forelimb',252,4,270,9.4942695,90.5926356,122.0062354,1.8,90.4972388,121.9942966,-0.4368155,2.8283405,2.9355702,18.9681925,22.6534259,0.2832085,7.7168741,6.7064742,13.6283525,6.015632,6.44532,2.4980915,19.5318307),(35046,'forelimb',252,4,271,9.630953,90.5508488,122.0439952,1.8,90.4715492,122.0521356,-0.4274955,2.845039,2.9888978,19.0694719,22.584483,0.2759064,7.5561242,6.7027103,13.7633562,6.015632,6.5589027,1.0191413,19.5318307),(35047,'forelimb',252,4,272,9.4018977,90.4975106,122.0901007,1.8,90.4027494,122.094493,-0.4852426,2.8767083,2.9073772,18.6148699,22.1816633,0.3408977,7.6294413,6.4708923,13.4669946,6.015632,6.44532,0.6435011,19.5318307),(35048,'forelimb',252,4,273,9.6905387,90.4751904,122.1022397,1.8,90.4449394,122.1366217,-0.5553969,2.7712208,2.9297044,18.4093352,22.0775637,0.4490351,7.535765,6.6430418,13.4395895,5.9587733,6.44532,0.6435011,19.2801253),(35049,'forelimb',252,4,274,9.3788467,90.4391068,122.1478547,1.8,90.4152453,122.1647434,-0.5758031,2.7627547,2.8825423,17.9507492,21.3138315,0.4634551,7.3941089,6.4974098,13.228475,5.9587733,6.3877713,2.7985687,19.0284199),(35050,'forelimb',252,4,275,9.1981314,90.3687036,122.1825781,1.8,90.3630941,122.1775444,-0.7086056,2.6722782,2.8394819,17.2865637,20.9807552,0.6492486,7.3889379,6.4688488,12.562696,5.7728707,6.5448126,0.4048918,18.7767145),(35051,'forelimb',252,4,276,9.0781766,90.31164,122.2293803,1.8,90.312869,122.2520426,-0.8184337,2.6611294,2.9649481,17.1256459,20.5454799,0.8064622,6.9294568,6.4354803,12.5691124,5.7728707,6.44532,0.6435011,19.0284199),(35052,'forelimb',252,4,277,8.7401886,90.2727654,122.2723679,1.8,90.2903983,122.2491791,-0.903582,2.7362175,2.9232012,16.0459,20.1233603,0.8989087,6.8840148,5.8642633,11.8808881,5.7728707,6.44532,0.6435011,19.0284199),(35053,'forelimb',252,4,278,8.5410101,90.2187457,122.2861109,1.8,90.2580245,122.2727236,-0.9214178,2.7145272,2.9628485,15.3514423,19.5500449,0.9029957,6.598395,5.6552914,11.502468,5.7728707,6.5589027,1.0191413,19.0284199),(35054,'forelimb',252,4,279,8.2313882,90.1878818,122.3455672,1.8,90.1803934,122.3438924,-0.968729,2.75104,2.923676,14.6700322,18.9062028,0.9318624,6.4665861,5.3325406,11.2226795,5.585944,6.44532,0.6435011,18.6724547),(35055,'forelimb',252,4,280,8.0426721,90.1278128,122.3969063,1.8,90.157198,122.3992544,-0.9518236,2.7236226,2.8573543,14.1804172,18.3995092,0.8892104,6.4393518,5.2064545,11.0402492,5.585944,6.3442673,0.4939414,18.0647842),(35056,'forelimb',252,4,281,7.7953215,90.1119658,122.4407473,1.8,90.1240741,122.4968873,-1.005451,2.7531981,3.0492662,13.6681418,18.2023878,0.9263668,5.9694323,4.9644601,10.2263444,5.585944,6.5589027,1.0191413,18.6724547),(35057,'forelimb',252,4,282,7.5049461,90.0859172,122.4693637,1.8,90.1091543,122.5058392,-1.0691321,2.7540781,3.008278,13.0401079,17.5886557,0.9615703,5.8467522,4.7348358,9.9360024,5.585944,6.5589027,1.0191413,18.6724547),(35058,'forelimb',252,4,283,7.2998369,90.0717609,122.5118826,1.8,90.0843835,122.5375998,-1.0737912,2.7620212,3.1362933,12.4473322,17.2100452,0.9400564,5.4873839,4.5066028,9.3725922,5.585944,6.725681,1.1071487,18.6724547),(35059,'forelimb',252,4,284,7.0992597,90.0456094,122.5682988,1.8,90.0703631,122.6072933,-1.1097157,2.7609813,3.0871881,12.142693,16.6875427,0.9489931,5.4054182,4.3979627,9.2933625,5.585944,6.5589027,1.0191413,18.6724547),(35060,'forelimb',252,4,285,7.0793418,90.0338342,122.6097858,1.8,90.0490667,122.6052904,-1.1230839,2.7655741,3.0484968,12.1064433,16.7256196,0.9587714,5.4865137,4.3775517,9.2593294,5.585944,6.7119411,0.8760581,18.9241602),(35061,'forelimb',252,4,286,6.9981598,89.9893695,122.6677188,1.8,89.9864722,122.6629468,-1.1523758,2.739483,3.1582915,12.3235475,16.5947746,0.9738008,5.2543519,4.498494,8.9360727,5.7728707,6.725681,1.1071487,19.3843851),(35062,'forelimb',252,4,287,7.1173312,89.9967838,122.7600927,1.8,90.0182676,122.7812934,-1.2437833,2.8573903,3.1718636,13.2155944,16.7162761,1.063828,5.270175,4.6250575,9.3552566,6.015632,6.7939638,1.2490458,19.6360905),(35063,'forelimb',252,4,288,6.998999,89.9804854,122.8545096,1.8,90.0005992,122.830938,-1.2420068,2.8720926,3.0764914,13.3728129,16.1360832,1.0448772,5.2449628,4.6561217,9.4582656,6.015632,6.6705516,1.8313987,19.6360905),(35064,'forelimb',252,4,289,6.8813382,89.9938934,122.9146712,1.8,90.0156818,122.890768,-1.3016039,2.9393979,3.1552959,13.8356038,15.7491862,1.065769,4.99135,4.7069517,9.3541101,6.015632,6.7939638,1.2490458,19.8877959),(35065,'forelimb',252,4,290,6.8728899,89.9795082,122.9707858,1.8,89.9998651,122.9197653,1.5310936,2.8681539,3.0923353,14.2599917,15.2606054,1.143677,4.9349776,4.9718363,9.3336102,6.015632,6.7939638,1.2490458,19.8877959),(35066,'forelimb',252,4,291,7.1596287,90.0237342,123.0981325,1.8,90.0636402,123.0538424,0.4230647,2.9962606,3.1648355,15.2212687,15.9797056,0.2011342,5.0491426,5.0800883,9.5095863,6.015632,6.7939638,2.176341,20.1395013),(35067,'forelimb',252,4,292,7.6397273,90.0439166,123.1883978,1.8,90.1091543,123.15165,0.5957782,2.9862643,3.1077148,16.3627602,17.3356123,0.4009492,5.5782506,5.4793409,10.2737882,6.44532,6.7939638,2.176341,20.7471719),(35068,'forelimb',252,4,293,8.5682013,90.1563414,123.2591886,1.8,90.1795754,123.289423,0.6236607,3.1006543,3.2482874,18.0483269,20.3868898,0.4870571,6.2761964,5.8208124,11.5725684,6.44532,7.0474072,2.226492,20.9988773),(35069,'forelimb',252,4,294,9.6620047,90.2225692,123.3354895,1.8,90.2532642,123.325152,0.6006682,3.0791418,3.3398036,20.3608465,22.7373598,0.5144116,6.8079931,6.6125069,12.3917888,6.44532,7.1514336,2.5702552,21.3548425),(35070,'forelimb',252,4,295,12.4972215,90.1531277,123.48111,1.8,90.317364,123.3662603,0.4080898,3.2816114,3.5071824,26.3193896,31.1735806,0.3280422,8.8884972,8.0202639,15.106714,6.44532,7.5041783,2.910502,22.2142185),(35071,'forelimb',252,4,296,11.8089366,90.3528556,123.3606223,1.8,90.4724255,123.290424,0.3322761,3.1229758,3.5449646,22.6576436,31.2418891,0.2094186,8.8130328,7.2551454,15.0751167,6.44532,7.5164702,2.6011732,21.6065479),(35072,'forelimb',252,4,297,9.3124352,90.6812424,123.3211969,1.8,90.7460133,123.3029177,0.4560838,2.6999574,3.2524639,13.5144125,21.7605522,0.3010765,6.6904824,5.005417,10.8324166,5.585944,6.9418221,2.7610863,19.2801253),(35073,'forelimb',252,4,298,8.9400945,90.7390239,123.4308024,1.8,90.7169985,123.4437271,0.2778052,2.6293751,2.9350499,10.3438992,16.0796845,0.1120651,5.4785047,3.9339762,8.8094897,5.156256,6.3877713,2.7985687,17.8130787),(35074,'forelimb',252,4,299,7.7876565,90.2182793,123.5716157,1.8,90.2468748,123.589011,-0.6564607,2.33733,2.7328951,7.2445419,10.6416994,0.4834666,3.893929,3.0994947,6.3380853,4.8613648,5.9694165,0.5280744,16.3460322),(35075,'forelimb',252,4,300,7.0592002,89.7813344,123.5839861,1.8,89.7362248,123.7044325,-0.7233398,1.9972676,2.5560849,5.4855684,9.1974044,0.5154403,3.5982389,2.7465365,5.5972723,4.2536942,5.6024461,0.5667292,15.2349507),(35076,'forelimb',252,4,301,6.6385754,89.4879236,123.658904,1.8,89.4132985,123.7119495,-0.828114,1.8946542,2.3109057,4.8288843,8.0750727,0.6004192,3.4943324,2.548689,5.2605861,4.2536942,5.3839752,0.4993467,14.6272802),(35077,'forelimb',252,4,302,4.4912519,89.3523976,123.908618,1.8,89.3818179,123.750144,-0.7908368,1.6194154,2.2571022,2.0876274,3.4501008,0.378342,1.5285532,1.2891241,2.4180792,3.6460236,4.899197,0.9097532,12.4483032),(35078,'forelimb',252,4,303,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35079,'forelimb',252,4,304,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35080,'forelimb',252,4,305,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35081,'forelimb',252,4,306,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35082,'forelimb',252,4,307,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35083,'forelimb',252,4,308,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35084,'forelimb',252,4,309,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35085,'forelimb',252,4,310,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35086,'forelimb',252,4,311,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35087,'forelimb',252,4,312,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35088,'forelimb',252,4,313,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35089,'forelimb',252,4,314,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35090,'forelimb',252,4,315,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35091,'forelimb',252,4,316,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35092,'forelimb',252,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35093,'forelimb',252,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35094,'forelimb',252,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35095,'forelimb',252,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35096,'forelimb',252,10,5,0.3567869,110.7714372,119.1676364,1.8,110.8953113,119.2563237,0.8017504,1.000331,5.4260322,0.0674222,6.0929692,0.0307044,1.1229143,0.0673999,1.1341089,0,0,0,0),(35097,'forelimb',252,10,6,17.0545492,112.1449636,120.0749466,1.8,112.2244903,119.5986472,0.8657864,8.2941537,7.8860299,45.4895179,339.5704711,1.6487267,43.0597492,5.4845279,43.8959907,5.585944,6.725681,0.4636476,18.6724547),(35098,'forelimb',252,10,7,58.87885,112.3423087,118.9269678,1.8,112.70331,119.054395,0.9718939,9.1763237,8.1132916,540.4680989,1127.5019753,6.6945391,138.9697342,58.8981072,176.680131,10.1705519,16.998492,1.9325256,48.4304259),(35099,'forelimb',252,10,8,76.605235,112.8596925,118.9657905,1.8,113.189276,119.1567058,0.9479757,9.3227147,8.5029351,920.9848956,1546.8998154,8.423101,181.9253934,98.7893471,258.7979919,15.7045819,18.0366624,1.7868813,66.6426556),(35100,'forelimb',252,10,9,83.9214091,113.7186319,119.5012642,1.8,113.498851,119.2615215,0.8211818,9.3377217,9.444519,1313.639207,1702.9971561,7.4935262,180.3159233,140.6809116,308.4679027,16.9165999,18.8916179,1.8709675,63.3525972),(35101,'forelimb',252,10,10,86.7414077,114.1193855,119.7583369,1.8,113.7107478,119.3172375,0.7151139,9.072261,9.850003,1519.1251007,1764.3268279,6.2157004,179.1194205,167.4472443,322.0060795,17.5630929,19.3884063,1.7942729,63.456857),(35102,'forelimb',252,10,11,86.9608957,114.4762761,119.8888114,1.8,113.8893211,119.4195957,0.4339663,8.9227425,10.5487147,1711.9655967,1848.2644369,2.5624092,175.2122887,191.8654039,337.4712424,18.1201506,19.9931938,1.7218117,65.2798688),(35103,'forelimb',252,10,12,82.8242487,114.6425425,120.0013894,1.8,114.0109788,119.4761335,0.3769497,9.1146064,10.7359395,1754.2253053,1869.4069402,1.8702726,174.1260692,192.4630896,337.1601662,18.4039624,20.3092932,1.6767807,66.2435046),(35104,'forelimb',252,10,13,82.4609717,114.5900795,120.0293281,1.8,114.0238268,119.5454744,0.5216674,9.2385522,10.7197662,1793.2338534,1915.1156776,3.4129116,178.6527477,194.1033424,345.9325798,18.5855564,20.4858007,1.7393933,66.1392448),(35105,'forelimb',252,10,14,82.9835916,114.5756035,120.0090573,1.8,114.0764328,119.5384581,0.6217509,9.28279,10.6380184,1805.5192417,1970.3147842,4.6921523,185.2144561,194.5017874,352.9720982,18.5855564,20.6473915,1.7804362,66.6426556),(35106,'forelimb',252,10,15,82.6599265,114.512597,119.9470939,1.8,114.0516481,119.4643607,0.9124617,9.5581936,10.4748912,1804.239545,1974.8130467,8.6200565,188.5282625,188.7636537,356.1147056,18.6454051,20.8431901,1.7156088,66.2866904),(35107,'forelimb',252,10,16,79.6189851,114.4441514,119.7832567,1.8,114.0276791,119.4687427,1.1364955,9.6657339,10.1460532,1733.265007,1873.6469987,10.9203725,184.6675703,179.3205795,344.2472863,18.3459375,20.8431901,1.7156088,66.034985),(35108,'forelimb',252,10,17,78.298756,114.2609723,119.4526846,1.8,113.9180558,119.3477211,1.157766,9.5533375,9.9257571,1621.3520632,1841.5831306,10.9473238,185.5357849,169.7157743,345.4409376,18.0690816,20.9095205,1.735945,65.635834),(35109,'forelimb',252,10,18,72.0214435,114.0091608,119.4534743,1.8,113.8572059,119.2053043,1.0755744,9.5089581,9.8751177,1373.817478,1709.6519782,9.2926794,173.12725,144.4761308,311.8939799,17.7179506,20.7855324,1.6951513,65.4273144),(35110,'forelimb',252,10,19,61.2300518,113.6396434,119.5120015,1.8,113.7197145,119.019673,1.2003246,9.6675834,9.6943301,1006.9897956,1408.2758104,8.8672959,145.2679858,104.1614806,245.3879348,16.6346335,20.3092932,1.6767807,63.1008918),(35111,'forelimb',252,10,20,53.3160624,113.4443821,119.1475175,1.8,113.5753283,118.6006785,1.182295,9.4589358,9.3005955,858.7132724,1108.4820475,7.6109491,119.1839861,90.7832859,205.957097,16.5905974,19.8076381,1.7894653,60.418504),(35112,'forelimb',252,10,21,44.985029,113.1827636,118.3504213,1.8,113.2979938,117.8666918,0.3623975,7.7040609,8.360219,734.772442,761.5775417,0.942304,91.0954052,95.3746923,159.0601198,15.9029378,18.4565877,1.7818897,56.2258838),(35113,'forelimb',252,10,22,42.1787938,113.1073113,117.9855904,1.8,113.1879365,117.4534943,-0.2035331,7.7807572,9.3117443,618.2800077,725.8346893,0.2872154,77.9483057,79.4627038,143.5741207,14.995501,17.617208,0.2213144,53.7952014),(35114,'forelimb',252,10,23,38.9475139,112.9424611,117.6645157,1.8,113.0980851,117.1366852,-0.2583917,7.5505357,9.3182947,496.472734,688.1403821,0.4238369,73.8483173,65.7533125,127.0560091,14.4437819,17.5279,0.1973956,51.9721897),(35115,'forelimb',252,10,24,37.3493301,112.8542293,117.4552199,1.8,113.0035988,117.005008,-0.2795473,7.3642979,9.2793172,451.3692599,666.9249747,0.4739142,71.8722033,61.2915535,120.2448731,14.0689089,17.4487192,0.1732457,51.1128137),(35116,'forelimb',252,10,25,37.2260184,112.7256157,117.2791637,1.8,112.9307817,116.8983351,-0.3135871,7.2124262,9.2305964,436.1241248,649.2942612,0.5903766,70.3415283,60.4684351,117.5229184,13.7373511,17.1982588,0.2267988,50.2534377),(35117,'forelimb',252,10,26,36.7911267,112.7279254,117.3070868,1.8,112.9464862,116.8890802,-0.3593584,7.1461329,9.0632907,421.6165343,636.0286169,0.7583535,70.1763451,58.9992574,115.8341091,13.6131121,16.998492,0.2817719,49.6457671),(35118,'forelimb',252,10,27,37.1319681,112.5863412,117.2629367,1.8,112.8240974,116.8505519,-0.3922774,7.0699936,8.9031032,417.5869516,631.4648511,0.9044639,70.926377,59.0646858,117.180438,13.2321872,16.5861794,0.2889754,48.5346857),(35119,'forelimb',252,10,28,37.1669363,112.5922094,117.2524658,1.8,112.8061538,116.8348867,-0.363863,7.0498166,8.7640463,411.5126175,617.8538729,0.7845665,70.4986999,58.3721021,116.5478425,13.013999,16.4688822,0.2639637,47.6753097),(35120,'forelimb',252,10,29,35.9620181,112.491232,117.2688774,1.8,112.6929137,116.8244862,-0.3601115,7.0274849,8.6176607,399.6524013,582.1808194,0.744238,67.5567116,56.869905,113.7191215,12.7610825,16.1747714,0.2965458,46.9633793),(35121,'forelimb',252,10,30,35.758028,112.3928903,117.1984525,1.8,112.6360768,116.7935066,-0.3974044,6.9373083,8.4890892,407.0625769,561.5999822,0.8926953,66.1555049,58.6773079,112.6937421,12.7610825,16.0544686,0.2709469,46.7116739),(35122,'forelimb',252,10,31,35.1581425,112.3352681,117.0913079,1.8,112.5666585,116.7672791,-0.4097857,6.8173922,8.2589868,391.042124,555.9631218,0.9301247,67.3161413,57.3594879,113.8166195,12.4572472,15.7643386,0.3045109,45.6005925),(35123,'forelimb',252,10,32,34.982015,112.3480105,117.0268746,1.8,112.5535003,116.7725767,-0.3822354,6.7583122,8.2478036,387.5027325,549.4242666,0.811149,66.6146158,57.3372052,113.0172576,12.3288644,15.6408793,0.2782997,45.0971817),(35124,'forelimb',252,10,33,34.5871827,112.2077625,117.0030892,1.8,112.4478472,116.7561455,-0.4216654,6.5090018,8.1104552,379.6363018,522.8610427,0.9656199,64.4675335,58.3248113,110.8955029,12.1534119,15.4269362,0.2247112,44.8454762),(35125,'forelimb',252,10,34,35.0828351,112.1780805,116.9188764,1.8,112.3603945,116.7562476,-0.4076817,6.4262803,7.9425594,374.3892989,533.9033058,0.919159,67.2205618,58.2590992,113.3854662,12.1534119,15.4269362,0.2247112,44.5937708),(35126,'forelimb',252,10,35,34.0098448,112.056647,116.9222589,1.8,112.270716,116.7083451,-0.4214869,6.3735108,7.8233137,371.2261443,500.7359432,0.9487457,64.0056069,58.2451579,111.096557,12.1534119,15.1125613,0.2587709,44.2378057),(35127,'forelimb',252,10,36,33.6521627,112.0639076,116.8616084,1.8,112.1904126,116.6908948,-0.4221129,6.3207791,7.6154079,374.6691385,489.6724026,0.9413909,64.3002199,59.275784,112.3749965,12.4242735,15.2584623,0.1697783,44.5937708),(35128,'forelimb',252,10,37,32.7942403,112.0259048,116.8297352,1.8,112.0859052,116.652619,-0.3370687,6.3289641,7.4415284,367.3494405,480.4469449,0.5978236,64.562939,58.0425852,112.5777828,12.3950071,15.2584623,0.1697783,44.5937708),(35129,'forelimb',252,10,38,32.6601305,112.0325331,116.8670818,1.8,112.0421196,116.6369253,-0.2775732,6.3559006,7.3099626,366.8300873,470.3663436,0.4087325,64.3459302,57.7148876,113.2968367,12.4572472,15.0083566,0.2310907,44.4895111),(35130,'forelimb',252,10,39,32.2419116,111.8782724,116.7734638,1.8,111.96498,116.6053472,-0.1950957,6.4751897,7.4065382,374.5791873,450.5747106,0.2019519,60.8347248,57.8483731,111.0171193,12.6603466,15.3369125,0.1973956,44.8454762),(35131,'forelimb',252,10,40,31.5857974,111.9044262,116.6861678,1.8,111.935421,116.5235114,-0.1899872,6.5610204,7.2799466,367.9776656,442.5870876,0.1877404,60.7953759,56.0854323,110.6208907,12.6368926,15.2584623,0.1697783,45.0971817),(35132,'forelimb',252,10,41,32.4210044,111.7872765,116.6871437,1.8,111.8288637,116.5745593,-0.0760872,6.6415837,7.0029301,378.5275673,437.4853259,0.031222,62.4717543,56.9935702,113.1016769,12.4572472,14.9158068,0.2030452,44.2378057),(35133,'forelimb',252,10,42,32.2167905,111.7723179,116.6427396,1.8,111.8222316,116.4964159,-0.0081096,6.6805481,6.9370718,380.4492021,438.5252371,0.0003531,63.2147466,56.9488009,111.9617917,12.4572472,14.9158068,0.2030452,44.7412165),(35134,'forelimb',252,10,43,31.5142945,111.6894768,116.6718934,1.8,111.6011897,116.4383392,0.0871377,6.6955678,7.0263123,382.685231,431.7970464,0.0397804,61.4542921,57.1550079,112.40668,12.4572472,14.8351299,0.1746722,44.7412165),(35135,'forelimb',252,10,44,32.0859817,111.7846872,116.6460486,1.8,111.7212195,116.4150345,0.2030183,6.723873,7.2718969,384.9598811,435.1828491,0.2173999,59.8444744,57.2526992,111.925999,12.4572472,14.8351299,0.1746722,44.9929219),(35136,'forelimb',252,10,45,32.9319868,111.7557965,116.5883573,1.8,111.610871,116.4470133,0.3358516,6.6513703,7.2809228,382.6176261,444.5135388,0.5961708,61.0518132,57.5246313,113.5884356,12.230838,15.0942245,0.0855053,44.8454762),(35137,'forelimb',252,10,46,32.3810568,111.7666122,116.6502833,1.8,111.6020637,116.4397297,0.4054062,6.48726,7.2897118,372.4497511,448.3255757,0.8394523,61.5011389,57.4124903,112.2537168,12.1534119,15.0636136,3.0845119,44.8454762),(35138,'forelimb',252,10,47,32.124027,111.6766383,116.597328,1.8,111.5374562,116.4332952,0.4988035,6.2948492,7.1006478,367.7361403,437.2054444,1.2252252,61.5726139,58.4185785,111.6487544,11.9310702,14.5904229,2.9037567,43.8818405),(35139,'forelimb',252,10,48,33.6053893,111.6916605,116.5546901,1.8,111.6281126,116.4720953,0.6257198,5.9713139,6.8726997,370.7188141,455.0815226,1.9212316,66.2158311,62.0832902,114.5296466,11.9310702,14.5904229,2.9037567,43.8818405),(35140,'forelimb',252,10,49,33.859286,111.6855277,116.537116,1.8,111.5321703,116.315007,0.7310453,5.9704012,6.8759393,367.2203427,456.236738,2.515486,66.3526422,61.5068118,112.124713,11.557827,14.5904229,2.9037567,43.2741699),(35141,'forelimb',252,10,50,33.330232,111.7110779,116.6141661,1.8,111.4952669,116.3603873,0.7686731,5.9343374,6.8357744,360.0066845,455.7916894,2.6846284,66.6774033,60.6650175,112.5611407,11.5179504,14.283491,2.8674252,43.1699101),(35142,'forelimb',252,10,51,34.3591345,111.7396306,116.5703413,1.8,111.5364098,116.3697691,0.8454821,5.7020641,6.4215156,355.7215803,458.1155165,3.2065059,71.3407157,62.3847039,114.0153156,11.3536479,14.1731921,2.896614,42.9182047),(35143,'forelimb',252,10,52,36.2898234,111.7699704,116.5764644,1.8,111.6692698,116.4390467,0.7991245,5.7978775,6.4969615,354.9671718,469.7251455,3.1071624,72.2992037,61.2236416,117.1660059,11.2934392,14.1731921,1.3258177,42.8139449),(35144,'forelimb',252,10,53,35.5678572,111.7229145,116.6113336,1.8,111.6892773,116.4741537,0.8723381,5.4867121,6.4114826,351.6077414,465.8185765,3.4767731,72.6538008,64.0835052,119.6361965,11.1779822,14.1731921,1.3258177,42.2062743),(35145,'forelimb',252,10,54,34.5401296,111.8487803,116.6593364,1.8,111.8239359,116.5325213,0.9821775,5.4911021,6.5420209,337.095529,466.9867917,3.9821242,71.3826504,61.3894118,117.4187379,11.0482227,14.1731921,1.3258177,41.5986037),(35146,'forelimb',252,10,55,35.6690131,111.9761663,116.7837481,1.8,111.9256257,116.6036037,1.0668362,5.6208058,6.4685052,333.6337107,478.6532535,4.5585616,73.9975057,59.3569181,118.9491968,10.9578265,14.283491,1.2966289,41.2426385),(35147,'forelimb',252,10,56,36.1677427,112.0734844,116.9030752,1.8,112.050603,116.7141242,1.1238009,5.5043794,6.5622726,334.7298009,483.3037932,4.9016511,73.6488438,60.8115422,121.2979206,10.7650098,14.283491,1.2966289,41.2426385),(35148,'forelimb',252,10,57,38.0293345,112.1875735,117.0899433,1.8,112.1133944,116.8599258,1.2282165,5.5854502,6.6031985,334.7616434,509.7343366,5.6230113,77.1950646,59.9345861,125.6593583,10.8491968,14.4121737,1.3909428,41.2426385),(35149,'forelimb',252,10,58,39.2228391,112.2584904,117.2948548,1.8,112.2388307,116.962578,1.2820372,5.6583623,6.8120121,327.1850371,531.9001596,6.0070435,78.0826793,57.8232748,125.9634853,10.8218779,14.7665205,1.4247841,40.9909331),(35150,'forelimb',252,10,59,39.3741812,112.3065837,117.3336373,1.8,112.2026347,116.9851665,1.3151247,5.4761051,6.8469747,315.2156533,528.6435203,6.1426609,77.2083358,57.5620165,122.7840543,10.6471081,14.8351299,1.3961241,40.6349679),(35151,'forelimb',252,10,60,38.2393112,112.3161261,117.3556717,1.8,112.3216098,117.0812307,1.3161623,5.4729504,6.870082,303.9640124,508.5027861,5.968843,74.0169895,55.5393327,117.8056838,10.312512,14.8351299,1.3961241,40.5307081),(35152,'forelimb',252,10,61,37.3130192,112.4234562,117.4372822,1.8,112.3569016,117.1635979,1.3452489,5.3983502,6.9531281,296.7460502,493.9382211,5.9078026,71.0382744,54.9697662,112.7942375,10.312512,14.9158068,1.7738415,40.7824135),(35153,'forelimb',252,10,62,37.6625887,112.4640537,117.531714,1.8,112.4633394,117.2818407,1.3904818,5.37982,7.0059136,288.2054263,507.0212732,6.0752112,72.3704719,53.5715739,111.8050837,10.2880099,15.1917649,1.7126934,41.3900841),(35154,'forelimb',252,10,63,39.1908922,112.4733973,117.7485514,1.8,112.4792495,117.4483834,1.4222531,5.3324412,7.1792212,279.1056046,540.2593689,6.3887472,75.2532002,52.3410565,111.9417538,9.882824,15.2584623,1.7405746,41.6417895),(35155,'forelimb',252,10,64,41.544276,112.4935293,117.9601384,1.8,112.4868744,117.5789688,1.4402909,5.3376117,7.3647319,273.3667516,586.6559839,6.806786,79.6574802,51.215181,114.2782067,9.882824,15.3369125,1.7681919,41.6417895),(35156,'forelimb',252,10,65,43.0870703,112.5500375,118.0563122,1.8,112.5432588,117.674239,1.4335692,5.2385372,7.4779715,264.9379517,613.7250303,7.0467943,82.0710574,50.5747966,115.080735,9.882824,15.3369125,1.7681919,41.2858243),(35157,'forelimb',252,10,66,42.6939724,112.6769778,118.1424556,1.8,112.6584001,117.8310711,1.4216544,5.1258536,7.5998553,258.7073184,617.1823683,6.9585563,81.2097528,50.4710705,112.8824027,9.453136,15.6172526,1.7088024,41.5375297),(35158,'forelimb',252,10,67,42.3484872,112.7383229,118.1240419,1.8,112.6653549,117.8641926,1.4100974,4.9941446,7.6090729,252.4300437,606.3216506,6.8773759,79.6840378,50.5452007,110.6146391,9.453136,15.6172526,1.7088024,41.5375297),(35159,'forelimb',252,10,68,42.6160355,112.7435273,118.2056127,1.8,112.6967574,117.9368315,1.423274,5.0060203,7.6695637,249.9367113,608.3203866,6.9492164,79.3161657,49.9272273,109.4484646,9.453136,15.7584815,1.7628443,41.5375297),(35160,'forelimb',252,10,69,43.210326,112.7409916,118.5210935,1.8,112.682306,118.1372241,1.4312516,4.9946216,7.9085811,242.6217429,624.0351504,7.0623917,78.9060823,48.5766012,108.2970173,9.453136,15.5639613,1.6814535,41.2858243),(35161,'forelimb',252,10,70,44.0725564,112.7934603,118.5674748,1.8,112.7339819,118.2411017,1.427366,4.9479582,7.9666785,238.2404718,638.6930675,7.1953475,80.1705585,48.1492489,108.7705293,9.453136,15.5639613,1.6814535,41.0341189),(35162,'forelimb',252,10,71,44.0600798,112.851988,118.8020867,1.8,112.8079997,118.4468136,1.4054004,4.8501719,8.1622406,236.7165898,620.1551271,7.1442885,75.9785408,48.8058149,104.6409029,9.453136,15.3369125,1.7681919,40.4264483),(35163,'forelimb',252,10,72,45.6711878,112.9009573,119.1539284,1.8,112.8682236,118.6867159,1.4148915,4.8618903,8.4440902,240.423381,619.2648967,7.4283424,73.3370772,49.4505973,101.7434138,9.023448,15.4926212,1.6262948,40.5307081),(35164,'forelimb',252,10,73,46.207739,112.9810532,119.3898667,1.8,112.9441101,118.9988046,1.4069714,4.8196319,8.6219987,237.6056836,610.2428457,7.4964404,70.7774226,49.2995501,98.3214076,9.023448,15.1917649,1.7126934,39.8187777),(35165,'forelimb',252,10,74,47.0412116,113.0154667,119.5484152,1.8,112.9572236,119.2063609,1.4197801,4.8089382,8.4249282,237.5781988,605.4610789,7.6627542,71.8654285,49.4034623,99.9133902,9.023448,15.1369758,1.6845883,39.3153669),(35166,'forelimb',252,10,75,44.8773271,113.0793213,119.6759177,1.8,113.0089364,119.5128051,1.4111645,4.6996968,7.8527974,232.4232974,563.2010839,7.2905714,71.719803,49.4549554,99.7019348,9.023448,14.4952048,1.7798193,38.6034365),(35167,'forelimb',252,10,76,44.6641614,113.1159859,119.8465747,1.8,113.0893477,119.7860919,1.430763,4.6881879,7.5121226,236.4406345,547.4125587,7.2990061,72.8705568,50.4332678,102.995874,9.023448,14.0751518,1.786154,37.4923551),(35168,'forelimb',252,10,77,45.9041596,113.1136262,120.3353315,1.8,113.1204813,120.2625097,1.4926683,4.7091707,7.0525894,246.7427662,522.7455973,7.6040884,74.1210872,52.396225,106.0387046,9.023448,13.5675304,1.7619808,37.1363899),(35169,'forelimb',252,10,78,48.5532899,113.1855375,120.6191533,1.8,113.1925283,120.5506831,1.5394622,4.958898,6.8079296,253.4780158,523.7939806,8.0842724,76.9388071,51.1157953,110.8316608,9.4350396,13.145925,1.7681919,36.6329791),(35170,'forelimb',252,10,79,49.9091026,113.274319,120.9606671,1.8,113.2782003,120.9221748,-1.552903,4.9159442,6.6578263,259.8981691,506.1089967,8.3155208,76.0171524,52.8684128,111.9437282,9.4507994,13.145925,1.3734008,36.6329791),(35171,'forelimb',252,10,80,49.3404926,113.2701177,121.1999918,1.8,113.3572516,121.1601078,-1.4863457,5.019258,6.4643559,259.6052358,507.7324476,8.1649061,78.5433928,51.7218348,115.2752721,9.453136,13.145925,1.3734008,36.6329791),(35172,'forelimb',252,10,81,46.6091732,113.3181329,121.4574345,1.8,113.3892165,121.5048729,-1.397235,5.0949874,6.3012233,257.2965985,486.2237302,7.5365302,77.1633862,50.499948,114.5358915,9.332761,13.047241,1.2698761,36.2770139),(35173,'forelimb',252,10,82,46.5148432,113.3464556,121.6420328,1.8,113.4027647,121.6981018,-1.3147262,5.1945953,6.4103624,260.5740846,491.1857191,7.2551436,76.6237056,50.162538,116.0657356,9.417164,13.047241,1.2698761,36.2770139),(35174,'forelimb',252,10,83,50.1652372,113.3287388,122.0342214,1.8,113.3977934,121.9763768,-1.2166255,5.1304492,6.3909999,270.2805144,512.6990505,7.3552344,80.2220396,52.681647,120.4572276,9.5837339,13.1809902,1.2387369,36.6329791),(35175,'forelimb',252,10,84,49.7853433,113.2742491,122.2328156,1.8,113.3814572,122.1969599,-1.1471172,5.2580456,6.4695259,264.22921,529.0838497,6.8951271,81.7809306,50.2523619,121.3873428,9.6553937,13.3272566,1.2082521,36.8846845),(35176,'forelimb',252,10,85,50.5592302,113.2967131,122.3749566,1.8,113.3274077,122.3919563,-1.065171,5.340748,6.7671692,265.1858134,550.8445531,6.4496775,81.3995536,49.6533098,120.2420379,9.9022354,13.4856331,1.0358413,37.2406497),(35177,'forelimb',252,10,86,49.9929701,113.2966827,122.4617378,1.8,113.3316051,122.5113033,-0.9951516,5.252276,6.9475576,264.076885,570.1795037,5.8629679,82.0690573,50.2785618,119.8327869,9.9205692,13.7096736,1.0088748,37.2406497),(35178,'forelimb',252,10,87,50.9367742,113.2418806,122.6315428,1.8,113.2772026,122.7031313,-0.9188508,5.3735883,7.0537932,260.4529185,615.8518996,5.3642689,87.3079036,48.4690872,124.1073876,10.0265649,13.943359,0.9827937,37.8483203),(35179,'forelimb',252,10,88,52.6276656,113.2659954,122.7749773,1.8,113.2777273,122.8586084,-0.8703988,5.2044446,7.2436286,265.6454682,648.4296193,5.1276171,89.5172378,51.0420399,124.8252635,9.9991973,14.1862129,0.957589,38.4559909),(35180,'forelimb',252,10,89,50.2421671,113.1785504,122.8390245,1.8,113.1570194,122.9907362,-0.8085456,5.4080345,7.7420529,249.8298352,673.7419534,4.3806079,87.0236828,46.1960503,118.9739876,10.0265649,14.6346459,0.8685394,39.3153669),(35181,'forelimb',252,10,90,48.0671488,113.1361586,122.8458763,1.8,113.1387955,123.0428387,-0.7705489,5.4023151,7.7408689,242.0693385,685.5057825,3.8866527,88.5566975,44.8084448,117.7429803,10.0265649,14.9652379,0.6837093,40.2790027),(35182,'forelimb',252,10,91,47.4508703,113.0458505,122.9896423,1.8,112.7996635,123.3012032,-0.6850348,5.2800773,8.4639387,237.7421357,738.3916609,3.1658368,87.2397223,45.0262606,110.2297897,10.0505348,17.1552631,0.3851575,48.6821313),(35183,'forelimb',252,10,92,50.2549235,112.9586404,123.0597372,1.8,112.6709825,123.4007638,-0.6081163,5.4111332,9.018367,243.5985304,862.0533581,2.7339465,95.5886315,45.0180247,121.44221,10.1778192,17.5542142,0.375961,49.4372475),(35184,'forelimb',252,10,93,49.2776619,113.2432811,122.9477721,1.8,112.7313068,123.3875692,-0.5683443,5.3972751,9.5922994,238.6309448,861.8454632,2.3792858,89.8476399,44.2132263,114.5119381,10.1761077,18.1132733,0.3893167,49.6889529),(35185,'forelimb',252,10,94,49.163358,113.4182458,123.0091571,1.8,112.903182,123.3720186,-0.5386861,5.2837887,9.7241362,240.2483618,863.6583828,2.1564507,88.8159492,45.4689575,113.4046499,10.0274973,18.5115256,0.3805064,51.2602593),(35186,'forelimb',252,10,95,48.8763395,113.5471509,123.0571924,1.8,112.9524737,123.3610238,-0.4965986,5.2487621,9.8246188,236.19669,882.7499307,1.8490973,89.8508072,45.0004564,113.8810027,9.8072783,18.6753695,0.4018706,50.8000343),(35187,'forelimb',252,10,96,48.0225015,113.672943,123.0151154,1.8,113.0882065,123.3618033,-0.4752971,5.1865604,9.9564168,228.1413428,891.6232812,1.6759865,89.5526267,43.9870216,112.4651,9.7659785,19.163314,0.3430239,50.8000343),(35188,'forelimb',252,10,97,50.0076847,113.7535873,123.0112127,1.8,113.2451998,123.3614155,-0.4432361,5.2762514,10.0241621,225.9099565,924.6246315,1.5329459,92.2395931,42.816375,114.7101865,9.6478852,19.4312116,0.3147577,51.1559995),(35189,'forelimb',252,10,98,50.702124,113.9394389,123.0210115,1.8,113.2859307,123.3546087,-0.4200779,5.1768877,10.1792988,224.0369718,949.2941752,1.4055185,93.2573246,43.2763828,115.1345786,9.6068891,19.7142053,0.2872815,51.5119647),(35190,'forelimb',252,10,99,51.1159789,114.0758136,123.1000747,1.8,113.4687804,123.350007,-0.3817526,5.1563606,10.2502573,224.0657713,955.1054343,1.1824117,93.1786787,43.4542479,114.7292599,9.5146286,20.126652,0.2812322,52.5187863),(35191,'forelimb',252,10,100,49.3942596,114.2301308,123.0623056,1.8,113.5410156,123.3487249,-0.365832,5.1059633,10.2408805,217.8975172,961.8502249,1.0534819,93.92261,42.6751041,115.0656913,9.3534511,20.2501155,0.301619,52.4145265),(35192,'forelimb',252,10,101,48.7680222,114.4310558,123.0249317,1.8,113.6468644,123.3068278,-0.3330865,5.1545181,10.4212977,216.6319192,976.8008846,0.8689145,93.7312139,42.0275798,114.1832899,9.3802393,20.6608003,0.2954408,53.6298677),(35193,'forelimb',252,10,102,49.8280324,114.5014444,123.1010442,1.8,113.7235582,123.3827528,-0.3034798,4.9944439,10.4374962,219.2363175,1018.3688445,0.7416657,97.5683082,43.8960421,118.0176346,9.0710879,20.9536242,0.2698492,54.8452089),(35194,'forelimb',252,10,103,47.3226352,114.4833429,123.2455537,1.8,113.885554,123.345825,-0.2462406,4.825169,10.3096264,210.0238852,1026.425845,0.4686424,99.5599453,43.5267422,118.725129,9.023448,21.2597881,0.2449787,57.7793021),(35195,'forelimb',252,10,104,45.9156291,114.4319384,123.3614017,1.8,113.9016297,123.4487089,-0.2050163,4.5934184,10.166229,198.9310553,1069.0559276,0.3171705,105.157569,43.307846,122.8273023,8.164072,18.5214968,3.0719381,46.2946347),(35196,'forelimb',252,10,105,44.8628363,114.7263391,123.4173734,1.8,114.0596335,123.5063323,-0.1654604,4.3557929,10.2977148,185.9308142,1097.1262236,0.2028415,106.5407466,42.685871,122.9946621,7.734384,18.9842363,3.0509328,46.0429293),(35197,'forelimb',252,10,106,43.817205,114.9448229,123.4308722,1.8,114.2279655,123.5430165,-0.1417128,4.2345064,10.4696087,176.7257475,1162.7714021,0.1456809,111.0615911,41.7346747,125.9542842,7.734384,19.3788812,3.0750245,46.9023053),(35198,'forelimb',252,10,107,45.4433075,115.4368839,123.4030161,1.8,114.4934139,123.5064404,-0.1070029,4.1001505,10.8907308,165.5450339,1319.298149,0.0863876,121.1395429,40.3753551,133.6300634,8.4412339,22.1820578,0.1555948,57.8835619),(35199,'forelimb',252,10,108,47.5736225,115.7384356,123.4008513,1.8,114.7090796,123.5081094,-0.0881386,3.7467195,11.1477821,158.9048355,1459.5134328,0.0614359,130.9241086,42.4117246,141.965589,7.7746601,22.4920224,0.1148766,57.1716315),(35200,'forelimb',252,10,109,48.0851084,115.7603625,123.4051617,1.8,114.8498881,123.5275077,-0.0649807,3.6692263,11.1111652,151.3395282,1586.7751493,0.0337923,142.8090678,41.2456244,152.2023222,7.734384,22.8382305,0.0753289,55.9562903),(35201,'forelimb',252,10,110,46.8652519,115.5910827,123.4613051,1.8,114.8393537,123.5111075,-0.0511139,3.7615745,10.8796525,150.4609166,1627.8718059,0.0203891,149.625349,39.9994513,159.8782877,7.734384,22.606653,0.1526493,55.7477707),(35202,'forelimb',252,10,111,45.2768591,115.3174705,123.5294009,1.8,114.8642529,123.5140283,-0.025112,3.5198737,10.5405742,144.5793166,1675.7448377,0.0047577,158.9804125,41.0751437,167.9091891,7.304696,22.9189312,0.1127276,55.6435109),(35203,'forelimb',252,10,112,43.5857999,115.0022483,123.5477707,1.8,114.8670464,123.4975134,-0.0110047,3.7028232,10.1883591,137.6897736,1710.5737033,0.0008797,167.8949176,37.1850786,175.4896548,7.734384,23.3024045,0.0923293,56.7114065),(35204,'forelimb',252,10,113,41.7723242,114.8716126,123.4927539,1.8,114.9354016,123.425892,0.0002771,3.6933862,10.0282642,130.2617818,1702.6278769,0.0000005,169.7829097,35.2689306,175.8854519,7.734384,23.345942,3.0309354,57.5707825),(35205,'forelimb',252,10,114,42.0911777,114.867406,123.441288,1.8,114.9786069,123.3334114,0.0120918,3.6750495,10.0450445,127.8639432,1722.8122274,0.0010257,171.5086701,34.7924413,179.3230783,7.734384,23.8234776,3.0150005,58.5344183),(35206,'forelimb',252,10,115,41.249033,114.474953,123.313964,1.8,115.0107271,123.1988324,0.0326212,3.6672102,9.8120431,125.5444734,1735.0308917,0.0073132,176.8266688,34.2343274,180.6760391,7.734384,24.732268,3.0021526,60.6091355),(35207,'forelimb',252,10,116,39.8579164,114.3724221,123.1788049,1.8,114.9783086,123.0984025,0.0347286,3.7852523,9.9257704,122.594151,1692.8323885,0.0080087,170.5492191,32.3873128,173.8898031,7.734384,25.4823461,3.0402462,62.2847017),(35208,'forelimb',252,10,117,38.8738291,114.7432006,123.1136107,1.8,115.0529794,123.0305039,0.0676256,3.9121868,10.0950101,131.0440743,1634.1244481,0.0295846,161.8744741,33.4963745,169.5132736,8.0963807,25.6448512,2.9902172,63.1440777),(35209,'forelimb',252,10,118,40.4673132,114.8186897,123.0469349,1.8,115.1976873,123.0246708,0.0892854,4.1075484,10.2555214,147.0799043,1630.7377067,0.0536241,159.0107072,35.8072236,167.6802495,8.59376,25.5835817,3.0068214,64.3594188),(35210,'forelimb',252,10,119,47.8128046,114.0299817,122.4536007,1.8,114.6393979,122.5563143,0.1728247,4.8794042,10.8127409,206.0928703,1873.0084639,0.2356548,173.2223568,42.2373022,185.6409551,9.5295133,25.6448512,2.9902172,66.5383958),(35211,'forelimb',252,10,120,56.0813429,113.6825713,122.0389401,1.8,114.5283785,122.4471358,0.2260717,5.4871852,11.3842397,274.1787809,2142.9739969,0.4696217,188.240415,49.9671086,206.7365108,10.3856191,25.5835817,3.0068214,66.894361),(35212,'forelimb',252,10,121,59.2553869,113.8233153,121.8861962,1.8,114.2839137,122.2995833,0.2479709,5.6664029,11.2354493,333.6780159,1952.5548363,0.5949195,173.7852022,58.8870963,199.7555558,10.7189297,25.2201601,2.987648,65.7832796),(35213,'forelimb',252,10,122,61.8853827,113.9196364,121.8636114,1.8,114.1425889,122.2515112,0.2627946,5.7760873,11.0677706,359.4647455,1947.3886574,0.6960635,175.9513029,62.233261,206.1624155,10.8727889,24.6087836,2.9304993,64.6111242),(35214,'forelimb',252,10,123,64.5351284,113.8673289,121.9140892,1.8,113.8392003,122.1606437,0.2777598,5.776676,10.7741605,364.7668305,1934.2831871,0.8086976,179.5298287,63.1447616,213.3565421,10.8727889,23.5389032,2.7678658,62.0329962),(35215,'forelimb',252,10,124,65.4434608,113.4957658,121.9230511,1.8,113.4563141,122.0646046,0.3009497,5.908551,10.2077284,339.9439824,1811.7014743,0.9584103,177.4833148,57.5342382,207.9054203,10.7654715,20.8254663,2.7610863,58.3437868),(35216,'forelimb',252,10,125,64.1507027,113.223578,121.8989373,1.8,112.9963621,121.9757989,0.3250301,5.6384339,9.5452412,272.322808,1585.9987885,1.090309,166.155968,48.2975973,190.2017861,10.2870188,19.4549516,2.6087488,55.0537285),(35217,'forelimb',252,10,126,54.0985654,113.1959116,121.7487645,1.8,112.8011286,121.8521948,0.3401174,5.669965,9.3560859,205.166479,1223.7030545,1.0034156,130.7921996,36.1847878,151.0318388,10.1230421,18.9501664,2.566168,52.9790113),(35218,'forelimb',252,10,127,39.6205807,112.8697143,121.5793985,1.8,112.4139132,121.726673,0.3327734,5.3003586,8.5859003,127.9654923,949.2762778,0.7046547,110.5622297,24.1427992,122.0135516,7.8997178,10.6125107,1.943784,29.7579711),(35219,'forelimb',252,10,128,30.64121,112.288097,121.4353014,1.8,112.0459391,121.6750104,0.3153864,5.0861115,8.879901,82.6064852,729.0601706,0.4913522,82.1022855,16.2415797,89.8403575,6.9882119,10.0587382,1.9195673,27.0755833),(35220,'forelimb',252,10,129,18.2977924,110.0742333,121.0901169,1.8,110.8050894,121.5022566,0.3625563,4.272807,10.4192967,36.0646998,197.8250718,0.383606,18.9864132,8.440517,22.4440896,5.722693,8.8582451,1.9693188,23.1778543),(35221,'forelimb',252,10,130,12.0941088,109.1631028,121.1587335,1.8,109.140752,121.3480687,0.9607152,2.1213116,3.660003,9.7728179,32.4073503,1.3540295,8.8544601,4.6069695,10.6254714,4.7740502,7.8997178,1.9614034,20.2437611),(35222,'forelimb',252,10,131,3.267367,109.0515314,121.733725,1.8,109.0752064,121.7837752,1.0356416,1.3215599,2.4373925,1.0351191,3.6423043,0.4029352,1.4943446,0.7832555,1.8705645,3.0763404,5.2450105,2.1815223,12.8042684),(35223,'forelimb',252,10,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35224,'forelimb',252,10,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35225,'forelimb',252,10,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35226,'forelimb',252,10,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35227,'forelimb',252,10,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35228,'forelimb',252,10,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35229,'forelimb',252,10,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35230,'forelimb',252,10,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35231,'forelimb',252,10,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35232,'forelimb',252,10,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35233,'forelimb',252,10,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35234,'forelimb',252,10,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35235,'forelimb',252,10,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35236,'forelimb',252,10,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35237,'forelimb',252,10,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35238,'forelimb',252,10,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35239,'forelimb',252,10,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35240,'forelimb',252,10,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35241,'forelimb',252,10,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35242,'forelimb',252,10,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35243,'forelimb',252,10,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35244,'forelimb',252,10,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35245,'forelimb',252,10,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35246,'forelimb',252,10,155,2.0988157,111.0810774,126.1235479,1.8,111.0448596,126.1260659,1.2718764,1.6304753,1.6386774,1.0322169,1.1566894,0.3194666,0.7058677,0.6330773,1.3280932,3.437504,3.8432463,2.0344439,10.7295512),(35247,'forelimb',252,10,156,16.7425774,111.7196224,125.204329,1.8,112.3594334,125.0571117,0.0439953,6.2881286,6.4877739,30.4564351,93.7898867,0.0053976,14.456405,4.8434816,18.5536066,5.471781,7.3926319,0.9505468,20.286947),(35248,'forelimb',252,10,157,47.2992485,112.9439939,123.7429398,1.8,113.1133767,124.0037793,-0.3955098,5.4863953,5.8608043,223.1955134,277.7924893,1.1701809,47.3983563,40.6816317,80.5934244,9.882824,12.2893773,0.9342881,36.2770139),(35249,'forelimb',252,10,158,42.5995864,113.1046035,123.7171866,1.8,113.3554566,124.010531,0.024008,5.1813915,5.9799477,219.4725473,275.1075026,0.0040915,46.0050017,42.3578392,76.1556472,9.882824,12.2893773,0.9342881,36.6329791),(35250,'forelimb',252,10,159,36.0196456,113.1131578,123.5756889,1.8,113.4313439,123.8287455,0.1102712,5.2236818,6.5572278,169.8865363,255.887454,0.0727028,39.0237248,32.5223747,63.0566729,9.7837702,12.1534119,2.9996956,36.3812737),(35251,'forelimb',252,10,160,32.3086588,113.1521387,123.3389616,1.8,113.5211206,123.5486582,0.1166507,4.9961028,6.5562081,145.1101542,246.9026404,0.072941,37.6593658,29.0446695,57.6390642,9.3923699,12.1534119,2.9996956,35.5218977),(35252,'forelimb',252,10,161,30.061746,113.0372053,123.0812529,1.8,113.4339278,123.2266161,-0.0418221,4.448734,5.8813089,131.8056969,205.2441334,0.0087583,34.8976964,29.6276864,52.2966746,9.023448,11.3765933,2.9516044,34.3065565),(35253,'forelimb',252,10,162,29.6688719,113.0449608,122.9846621,1.8,113.4984613,123.0913753,-0.1393152,4.3282856,5.2695294,128.635833,184.1821072,0.0953532,34.9522873,29.7198116,51.4533738,8.59376,10.6732285,0.6998929,32.4835447),(35254,'forelimb',252,10,163,29.1600715,113.1441153,122.7690713,1.8,113.4916808,122.9231973,-0.1353528,4.4558691,4.7838019,124.1364105,171.3687578,0.0884949,35.8227118,27.8590793,53.1897293,8.59376,10.3482574,0.7266423,30.9122383),(35255,'forelimb',252,10,164,29.493192,113.2314536,122.7219092,1.8,113.5491856,122.8632239,-0.0534279,4.2248733,4.847851,124.3716696,167.3645637,0.0140182,34.5234543,29.4379646,53.5301602,8.59376,10.0679117,2.2655346,30.9122383),(35256,'forelimb',252,10,165,32.0809462,113.272213,122.7313342,1.8,113.6302986,122.8173052,0.137669,4.3568734,5.1624219,121.9444738,167.4866578,0.1006984,32.4434271,27.9889871,53.5086841,8.5178568,9.9201178,2.8335399,30.0528623),(35257,'forelimb',252,10,166,29.5530575,113.3805612,122.7146884,1.8,113.6446246,122.8151087,0.2400768,4.2118405,5.1991605,113.4611155,168.3358041,0.2784784,32.3774971,26.9386069,52.9841449,8.164072,9.9201178,2.8335399,29.4451917),(35258,'forelimb',252,10,167,28.116902,113.4923176,122.6532612,1.8,113.7041284,122.759017,0.3176088,4.1020169,5.183339,102.6232164,167.7796976,0.4570341,32.3690383,25.0177461,51.5457959,8.0255151,9.9201178,2.8335399,29.1934863),(35259,'forelimb',252,10,168,28.5514021,113.5552358,122.630492,1.8,113.7016042,122.7543824,0.36244,3.9402888,5.163567,97.7374048,167.1292618,0.5982018,32.367017,24.80463,50.9316938,7.885888,9.9201178,2.8335399,28.9417809),(35260,'forelimb',252,10,169,28.3977101,113.6287323,122.5288462,1.8,113.737159,122.6429917,0.3853974,3.7473347,4.9849695,91.4422949,162.6932425,0.6688675,32.636758,24.4019559,50.3250329,7.537918,9.798394,2.4805495,28.3341103),(35261,'forelimb',252,10,170,28.5660048,113.6430789,122.4814707,1.8,113.7737717,122.5768262,0.3965207,3.7096054,4.9922055,88.4705849,158.4810237,0.710147,31.7456928,23.8490553,48.7466933,7.41588,9.798394,2.4805495,28.3341103),(35262,'forelimb',252,10,171,28.2636563,113.6261921,122.4067881,1.8,113.7187061,122.4675415,0.4329085,3.683514,4.8336588,84.3912865,149.7964196,0.8290246,30.9902756,22.9105376,47.9958071,7.3408702,9.6560368,2.5782764,27.4747343),(35263,'forelimb',252,10,172,28.2692512,113.606983,122.3603882,1.8,113.6703797,122.4301555,0.4494498,3.4919027,4.8814757,82.4222625,146.2923049,0.8893704,29.9688688,23.6038254,46.4807761,7.3283745,9.6560368,2.5782764,27.4747343),(35264,'forelimb',252,10,173,28.1951187,113.5866867,122.270323,1.8,113.6656972,122.3652265,0.484121,3.4435797,4.779579,79.0674606,140.5117725,1.017964,29.3983579,22.9608338,44.7697676,7.303036,9.5406219,2.5161076,27.1187691),(35265,'forelimb',252,10,174,28.2688595,113.5908442,122.2096621,1.8,113.6750472,122.2938862,0.4990213,3.4090885,4.8208249,77.0680754,138.3957242,1.0790499,28.7078927,22.6066516,43.6048522,7.1113101,9.5406219,2.5161076,26.8670637),(35266,'forelimb',252,10,175,28.2675727,113.562648,122.1341675,1.8,113.6048258,122.2153052,0.5291114,3.489701,4.6968226,75.4515794,133.2367658,1.2003784,28.3674254,21.6212158,44.0510609,7.303036,9.4237936,2.3239476,26.6153583),(35267,'forelimb',252,10,176,28.2566626,113.5619816,122.0823674,1.8,113.593267,122.1802603,0.5488039,3.4413524,4.7356892,74.5240581,131.2054782,1.2816123,27.7056774,21.6554565,43.1309476,7.112401,9.4628966,2.4526683,26.2593931),(35268,'forelimb',252,10,177,27.8454373,113.5400679,122.0051605,1.8,113.5715833,122.1131545,0.5574275,3.3852678,4.5725616,72.4700771,124.691898,1.2987399,27.2695938,21.4074875,43.0693353,7.1113101,9.1957248,2.488746,25.7559823),(35269,'forelimb',252,10,178,27.6920251,113.5415686,121.962741,1.8,113.5621538,122.0173614,0.5668445,3.4783441,4.5959289,71.9574766,122.2900753,1.3307852,26.6083481,20.6872793,42.2202171,7.222451,9.1957248,2.488746,25.7559823),(35270,'forelimb',252,10,179,27.4471362,113.4974893,121.8795498,1.8,113.5385304,121.9391917,0.579112,3.4226526,4.5561387,71.8038726,116.381802,1.3701449,25.5439553,20.9790129,40.6875465,7.222451,9.1352922,2.2896263,26.0076877),(35271,'forelimb',252,10,180,27.2457197,113.4936806,121.8332044,1.8,113.5337005,121.8479886,0.5842106,3.5035597,4.3518855,71.6737489,113.2225628,1.381347,26.0168985,20.4574077,41.7860638,7.2719466,8.9412281,2.1854593,25.7559823),(35272,'forelimb',252,10,181,26.8202834,113.4619476,121.7593943,1.8,113.4768566,121.7871295,0.5975923,3.5702819,4.4252917,71.3086351,107.182135,1.4151239,24.2203547,19.9728306,40.1401223,7.2967479,8.8582451,2.2531129,25.4000171),(35273,'forelimb',252,10,182,26.6497507,113.4529857,121.7126816,1.8,113.435819,121.7195509,0.5901384,3.5391926,4.2162504,71.4226732,103.7401847,1.3754182,24.6048443,20.1804989,41.5199771,7.2719466,8.6473042,2.677945,25.1483117),(35274,'forelimb',252,10,183,26.4228775,113.4385091,121.6529326,1.8,113.4684535,121.6923555,0.6009286,3.6058968,4.2632982,71.686852,99.8015332,1.4078413,23.4094659,19.8804502,40.2023298,7.2920472,8.6473042,2.677945,24.8966063),(35275,'forelimb',252,10,184,26.1455941,113.4258211,121.598769,1.8,113.4189499,121.6241225,0.585384,3.5814719,4.1803575,71.928252,96.0838919,1.3302782,22.9846111,20.0834334,39.4013112,7.2740207,8.5290633,2.284887,24.5406411),(35276,'forelimb',252,10,185,25.8759198,113.3817408,121.5103733,1.8,113.3832174,121.4985038,0.597292,3.6512576,4.0345799,73.5852032,91.4603407,1.3640917,22.6691111,20.1533859,39.6673616,7.3052177,8.4747721,2.1025204,24.8966063),(35277,'forelimb',252,10,186,25.7843872,113.3790539,121.4605318,1.8,113.3509406,121.4452825,0.6001251,3.7240867,3.9543588,74.9296709,89.2113597,1.3706022,22.5602594,20.1202808,39.0393345,7.304696,8.4747721,2.1025204,24.5406411),(35278,'forelimb',252,10,187,25.5810684,113.3496741,121.4008472,1.8,113.3068574,121.3849918,0.5501936,3.703636,3.867245,76.4093056,86.4957653,1.1655351,22.3662491,20.6308898,38.6607042,7.4969435,8.2986537,1.9416876,24.6449009),(35279,'forelimb',252,10,188,25.5278609,113.3478012,121.36465,1.8,113.3156682,121.3558999,0.4989158,3.8473958,3.8614457,77.6668348,85.2095004,0.9740461,22.0667355,20.1868585,38.6537871,7.5958825,8.2986537,1.9416876,24.6449009),(35280,'forelimb',252,10,189,25.3692454,113.3239109,121.313604,1.8,113.2925181,121.3340913,0.3310883,3.8407152,3.8623145,78.5707591,83.0855399,0.4468034,21.5118523,20.4573251,38.5532256,7.5958825,8.1527566,1.8925469,24.6449009),(35281,'forelimb',252,10,190,25.3190032,113.328824,121.2863236,1.8,113.3132486,121.2832072,0.1262509,3.6995566,4.1150275,79.5656409,82.9971946,0.0669045,20.1692929,21.5068046,38.7060827,7.6650624,8.2986537,1.9416876,24.8966063),(35282,'forelimb',252,10,191,25.1180903,113.2923005,121.242567,1.8,113.2627148,121.2328568,-0.3033162,3.9234217,4.197647,78.4491221,83.1826775,0.3734797,19.8165014,19.9950776,38.2485751,7.6650624,8.2986537,0.3708913,24.8966063),(35283,'forelimb',252,10,192,25.1001306,113.3054428,121.2143225,1.8,113.3020416,121.172016,-0.4789889,3.8661723,3.8892789,77.9860211,84.4603526,0.888596,21.7161983,20.1713774,38.8379771,7.304696,8.3430318,0.2074962,24.6449009),(35284,'forelimb',252,10,193,24.8959167,113.2838115,121.1747275,1.8,113.2924929,121.1338215,-0.6177514,3.8845849,3.8232668,77.0987587,85.3617143,1.3920003,22.3269049,19.8473609,39.0060871,7.5958825,8.3430318,0.2074962,25.0008661),(35285,'forelimb',252,10,194,24.7205725,113.3006114,121.1546832,1.8,113.3216543,121.1244841,-0.6162419,3.8919267,3.7990912,76.5785331,86.5051983,1.3763265,22.7699715,19.6762527,38.9797267,7.5958825,8.4420297,0.2573237,25.0008661),(35286,'forelimb',252,10,195,24.4211892,113.2720039,121.1199384,1.8,113.2962873,121.0759016,-0.6248311,3.9325543,3.8001485,75.2386574,87.5872594,1.3927345,23.0483784,19.1322614,39.1479261,7.5958825,8.4420297,0.2573237,25.0008661),(35287,'forelimb',252,10,196,24.1652784,113.281613,121.0978904,1.8,113.3032362,121.0319415,-0.6059898,3.8457316,3.9182607,73.90799,88.5603181,1.3066034,22.6019463,19.2181875,38.9481713,7.5958825,8.4420297,0.2573237,25.2525715),(35288,'forelimb',252,10,197,23.7717889,113.271748,121.0597354,1.8,113.3089149,120.9940835,-0.5896417,3.759411,4.0089561,71.6610099,89.73781,1.2250646,22.3843336,19.0617652,38.7382307,7.2920472,8.5614727,0.3058789,25.0008661),(35289,'forelimb',252,10,198,23.4538866,113.2957687,121.0442682,1.8,113.3115902,120.9925019,-0.5739042,3.7709265,3.9754099,70.3836485,90.6544853,1.1521977,22.8038083,18.6648158,38.413362,7.2920472,8.5614727,0.3058789,25.0008661),(35290,'forelimb',252,10,199,23.0621315,113.2885501,121.007109,1.8,113.3215001,120.9610431,-0.5618422,3.6800778,3.9572382,68.4802003,91.8403296,1.0909095,23.2081882,18.6083568,38.2608339,7.2920472,8.5614727,0.3058789,25.0008661),(35291,'forelimb',252,10,200,22.8282086,113.3196236,120.986142,1.8,113.3520833,120.9600884,-0.5572255,3.6819069,3.9620248,67.8190984,92.5634706,1.0640411,23.3626684,18.4195584,39.8082934,7.2920472,8.4747721,0.5317241,24.6449009),(35292,'forelimb',252,10,201,22.4540216,113.3326827,120.9466656,1.8,113.3692725,120.9337345,-0.5531532,3.7091343,4.0245138,66.5382991,93.3262578,1.0329472,23.1894488,17.9390374,39.4181904,7.2920472,8.6473042,0.4636476,24.6449009),(35293,'forelimb',252,10,202,22.1353359,113.3587776,120.9351681,1.8,113.3768086,120.9404946,-0.5357494,3.7076942,4.0364956,65.9459194,93.9198835,0.961395,23.2676788,17.7862347,39.1434176,7.2920472,8.6473042,0.4636476,24.6449009),(35294,'forelimb',252,10,203,21.7960051,113.350557,120.9156629,1.8,113.3272534,120.8862143,-0.5118005,3.566121,4.0526131,65.2509256,94.3941784,0.8713059,23.2921761,18.2974513,39.092086,7.4969435,8.6473042,0.4636476,24.8966063),(35295,'forelimb',252,10,204,21.5691878,113.3791009,120.9139669,1.8,113.3634132,120.8438906,-0.4971516,3.5453998,4.085457,65.0151612,95.401264,0.8176751,23.35143,18.3378926,38.9482999,7.4958527,8.7005189,0.5743048,25.1483117),(35296,'forelimb',252,10,205,21.2808825,113.4016064,120.8906722,1.8,113.4162448,120.7948238,-0.4772171,3.5433465,4.1403885,64.6223404,97.0213257,0.7482525,23.432904,18.2376579,38.8173889,7.304696,8.8478174,0.5070985,25.1483117),(35297,'forelimb',252,10,206,21.2690772,113.4319477,120.8762255,1.8,113.4357051,120.780865,-0.4601825,3.5349499,4.163653,65.297428,98.7811508,0.6991682,23.7246357,18.4719527,39.3088511,7.304696,8.8582451,0.3985224,25.1483117),(35298,'forelimb',252,10,207,21.1389398,113.4367483,120.850995,1.8,113.4261225,120.788366,-0.4390587,3.5614449,4.1840247,66.0069905,99.8543027,0.6366327,23.8656102,18.5337671,38.5009978,7.304696,8.8582451,0.2449787,25.5042769),(35299,'forelimb',252,10,208,21.2350043,113.4525545,120.8405634,1.8,113.4696701,120.7837891,-0.4072221,3.7410174,4.206475,67.6290284,101.2671783,0.5551666,24.0741188,18.07771,39.0554508,7.304696,8.8582451,0.2449787,25.5042769),(35300,'forelimb',252,10,209,21.1245049,113.4166783,120.8153654,1.8,113.4245545,120.7722193,-0.3844692,3.6101972,4.2763432,68.2792121,102.4330391,0.495283,23.9534185,18.9128761,39.2656014,7.304696,9.1049255,0.3366748,25.5042769),(35301,'forelimb',252,10,210,20.9276203,113.4229257,120.810249,1.8,113.4242042,120.7691835,-0.3607808,3.7645734,4.2858812,68.7209998,102.9613382,0.4346403,24.0233768,18.2546579,39.4246071,7.304696,9.1049255,0.3366748,25.5042769),(35302,'forelimb',252,10,211,20.9760162,113.44197,120.8020077,1.8,113.4806008,120.7610101,-0.3478469,3.7599223,4.3162091,69.4847249,105.5795915,0.4062193,24.4611858,18.4803618,40.0153643,7.304696,9.1049255,0.3366748,25.7559823),(35303,'forelimb',252,10,212,21.3153471,113.4408983,120.8159217,1.8,113.4859952,120.7590691,-0.3425203,3.7446713,4.3857717,70.2806166,108.8959739,0.4007404,24.8293759,18.7681669,40.1986283,7.304696,9.2557628,0.3805064,25.7559823),(35304,'forelimb',252,10,213,21.539255,113.4339387,120.840427,1.8,113.4339906,120.767818,-0.3493835,3.7272764,4.4414988,72.3475853,112.0877879,0.420669,25.2364785,19.4103086,41.2093973,7.5958825,9.4237936,0.4228539,26.1119475),(35305,'forelimb',252,10,214,21.6511531,113.4673608,120.8632098,1.8,113.5104304,120.7831661,-0.3553788,3.8008931,4.4627234,74.210551,115.8613937,0.4368701,25.962038,19.5245037,42.4122017,7.5958825,9.4237936,0.4228539,26.4679127),(35306,'forelimb',252,10,215,22.0930385,113.4577988,120.9012137,1.8,113.4800913,120.8034694,-0.368101,3.7618803,4.589167,76.9017635,123.2968376,0.476797,26.8669319,20.4423739,43.6142081,7.5958825,9.6560368,0.363979,27.0755833),(35307,'forelimb',252,10,216,22.6360237,113.4947969,120.9227801,1.8,113.5571693,120.8085581,-0.3895418,3.8783726,4.6433395,80.2074938,130.7749737,0.5440988,28.1639914,20.6807084,44.8532814,7.8705267,9.8172189,0.4048918,27.5789941),(35308,'forelimb',252,10,217,23.0252611,113.5022617,120.9563513,1.8,113.5167442,120.8447085,-0.4191255,3.8352673,4.8139968,83.2189649,142.2421348,0.635566,29.5476169,21.6983481,45.9157224,7.8997178,10.0587382,0.348771,27.9349593),(35309,'forelimb',252,10,218,23.2731153,113.5297262,121.0029123,1.8,113.4968993,120.8875329,-0.4451731,3.7705259,4.8323311,85.4111606,151.0971986,0.71925,31.2679733,22.6523203,48.0005841,7.8997178,10.2135672,0.3883187,28.1866647),(35310,'forelimb',252,10,219,23.5197945,113.5399118,121.0506302,1.8,113.5161327,120.9378911,-0.4869919,3.9016093,4.9499431,88.055191,162.2099306,0.858455,32.7700599,22.5689412,49.7483629,7.8997178,10.4900209,0.610726,29.0460407),(35311,'forelimb',252,10,220,23.7545007,113.583411,121.0947322,1.8,113.5826027,120.9774157,-0.5059367,3.8773833,5.1323512,90.1576605,172.1214377,0.9298436,33.5365663,23.2521918,50.5079059,8.1660023,10.7679504,0.4993467,29.6537113),(35312,'forelimb',252,10,221,23.961624,113.6160674,121.119975,1.8,113.5346187,121.0136453,-0.5418153,4.0056672,5.3372499,91.9523313,185.5753406,1.0620525,34.7698427,22.9555593,50.4533271,8.2554522,11.0889478,0.6202495,30.7647927),(35313,'forelimb',252,10,222,24.225032,113.6524889,121.1525622,1.8,113.5489011,121.1033606,-0.5667953,3.9545807,5.5634374,94.1069618,197.1646719,1.1639932,35.4393621,23.7969509,51.5947732,8.1660023,11.4413255,0.5984189,31.1207579),(35314,'forelimb',252,10,223,25.0122347,113.6961672,121.2103449,1.8,113.5831169,121.1257766,-0.5968413,4.1151957,5.6646065,98.0324646,212.8896982,1.316814,37.5824337,23.822066,53.5019813,8.424595,11.7988288,0.5779019,31.9801339),(35315,'forelimb',252,10,224,25.1859564,113.7703259,121.2931414,1.8,113.6878301,121.1709282,-0.605852,4.1133308,5.8026629,99.89828,221.4468584,1.3612492,38.1629716,24.2864688,54.9178956,8.4670327,12.0389346,0.607802,32.9437697),(35316,'forelimb',252,10,225,25.6378008,113.8125122,121.4234552,1.8,113.7342215,121.277866,-0.6178193,4.2236087,5.7854606,104.7193945,228.2457207,1.4337553,39.4516078,24.7938204,56.9424271,8.6831877,12.1610055,0.5585993,33.1954751),(35317,'forelimb',252,10,226,25.748356,113.8469313,121.5276598,1.8,113.8264945,121.3557306,-0.6163977,4.1191037,5.963965,106.3464683,232.6901861,1.4341795,39.0160217,25.8178661,56.139937,8.6426664,12.2893773,0.6365082,34.1591109),(35318,'forelimb',252,10,227,27.1668876,113.9307841,121.6588196,1.8,113.9420483,121.4935445,-0.5927566,4.3248628,6.0599088,113.4588359,253.180451,1.413082,41.7795813,26.2340893,59.9904629,8.8112237,12.5274503,0.5404195,34.1591109),(35319,'forelimb',252,10,228,29.1876544,113.9747043,121.8493333,1.8,113.9917034,121.6817994,-0.5478579,4.9673297,6.3101825,131.6997154,281.2374096,1.3197438,44.5688236,26.5131817,63.7256068,9.71268,12.9905136,0.5971767,35.7736031),(35320,'forelimb',252,10,229,32.8652956,114.1736898,121.9693983,1.8,114.1880356,121.8223067,-0.5344614,5.127055,6.3306924,158.7794292,312.609958,1.4212355,49.3800578,30.9689343,72.8448524,10.0162721,12.9905136,0.5971767,36.3812737),(35321,'forelimb',252,10,230,35.9117759,114.3354597,121.9608516,1.8,114.3287714,121.9140439,-0.5403521,5.0516895,6.0469572,173.0691654,331.7713404,1.5839873,54.8658326,34.2596604,79.3047779,9.805485,12.6375032,0.6162969,37.0932041),(35322,'forelimb',252,10,231,42.5577366,114.4085645,121.9887939,1.8,114.4644073,122.0134883,-0.619357,4.9653019,5.8775681,207.1428483,377.4244196,2.3902829,64.2143843,41.718077,95.828866,9.6424592,12.5495381,0.9067502,36.5897933),(35323,'forelimb',252,10,232,45.7760363,114.4545397,121.9593568,1.8,114.4924884,122.0479894,-0.624565,5.2108286,5.7310539,220.4236601,378.8562143,2.6086703,66.1058548,42.3010767,99.0477331,9.8834668,12.5274503,1.0303768,36.2338281),(35324,'forelimb',252,10,233,41.9750275,114.4724469,122.014935,1.8,114.5749815,122.0629568,-0.5719955,4.9273527,5.1401054,199.7175771,281.5092822,2.0499033,54.7672201,40.5324299,87.358842,9.4188943,11.5697035,1.0240075,34.6193359),(35325,'forelimb',252,10,234,42.2031317,114.4502687,121.9964969,1.8,114.5140004,122.0722124,-0.5593702,4.8221448,5.0421981,184.8998118,264.9511936,1.9806779,52.5467642,38.3438943,81.5187208,9.399056,11.3765933,0.1899883,33.6557001),(35326,'forelimb',252,10,235,41.3299353,114.4049065,121.8897045,1.8,114.4892673,121.9259968,-0.5877056,4.4676341,4.956376,142.241113,263.529521,2.1175958,53.1697996,31.8381295,75.7247619,8.5073884,11.0472442,0.235545,32.5446187),(35327,'forelimb',252,10,236,38.2074203,114.4345006,121.7863863,1.8,114.4737865,121.8739688,-0.6101195,4.1703129,5.0399447,95.5753203,245.8819632,2.0905149,48.7866386,22.9180213,65.9543703,7.8997178,10.7422,0.2837941,31.0775721),(35328,'forelimb',252,10,237,24.1073152,114.3075956,121.7540673,1.8,114.3851491,121.7779863,-0.620121,3.0667563,4.8252938,26.3021589,122.7450006,1.3569056,25.4378292,8.5765404,30.6380619,6.076706,10.2496576,0.5763752,26.2162073),(35329,'forelimb',252,10,238,3.5862765,114.0907612,121.932817,1.8,114.1967475,121.8117737,-0.6441533,1.7494975,3.457398,1.5364234,7.2998906,0.2155509,2.1113828,0.8782084,2.5556536,3.7590268,7.1514336,0.5713375,17.3096679),(35330,'forelimb',252,10,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35331,'forelimb',252,10,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35332,'forelimb',252,10,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35333,'forelimb',252,10,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35334,'forelimb',252,10,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35335,'forelimb',252,10,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35336,'forelimb',252,10,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35337,'forelimb',252,10,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35338,'forelimb',252,10,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35339,'forelimb',252,10,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35340,'forelimb',252,10,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35341,'forelimb',252,10,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35342,'forelimb',252,10,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35343,'forelimb',252,10,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35344,'forelimb',252,10,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35345,'forelimb',252,10,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35346,'forelimb',252,10,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35347,'forelimb',252,10,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35348,'forelimb',252,10,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35349,'forelimb',252,10,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35350,'forelimb',252,10,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35351,'forelimb',252,10,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35352,'forelimb',252,10,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35353,'forelimb',252,10,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35354,'forelimb',252,10,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35355,'forelimb',252,10,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35356,'forelimb',252,10,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35357,'forelimb',252,10,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35358,'forelimb',252,10,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35359,'forelimb',252,10,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35360,'forelimb',252,10,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35361,'forelimb',252,10,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35362,'forelimb',252,10,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35363,'forelimb',252,10,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35364,'forelimb',252,10,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35365,'forelimb',252,10,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35366,'forelimb',252,10,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35367,'forelimb',252,10,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35368,'forelimb',252,10,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35369,'forelimb',252,10,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35370,'forelimb',252,10,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35371,'forelimb',252,10,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35372,'forelimb',252,10,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35373,'forelimb',252,10,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35374,'forelimb',252,10,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35375,'forelimb',252,10,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35376,'forelimb',252,10,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35377,'forelimb',252,10,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35378,'forelimb',252,10,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35379,'forelimb',252,10,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35380,'forelimb',252,10,289,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35381,'forelimb',252,10,290,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35382,'forelimb',252,10,291,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35383,'forelimb',252,10,292,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35384,'forelimb',252,10,293,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35385,'forelimb',252,10,294,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35386,'forelimb',252,10,295,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35387,'forelimb',252,10,296,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35388,'forelimb',252,10,297,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35389,'forelimb',252,10,298,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35390,'forelimb',252,10,299,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35391,'forelimb',252,10,300,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35392,'forelimb',252,10,301,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35393,'forelimb',252,10,302,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35394,'forelimb',252,10,303,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35395,'forelimb',252,10,304,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35396,'forelimb',252,10,305,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35397,'forelimb',252,10,306,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35398,'forelimb',252,10,307,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35399,'forelimb',252,10,308,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35400,'forelimb',252,10,309,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35401,'forelimb',252,10,310,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35402,'forelimb',252,10,311,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35403,'forelimb',252,10,312,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35404,'forelimb',252,10,313,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35405,'forelimb',252,10,314,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35406,'forelimb',252,10,315,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35407,'forelimb',252,10,316,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35408,'hindlimb',252,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35409,'hindlimb',252,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35410,'hindlimb',252,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35411,'hindlimb',252,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35412,'hindlimb',252,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35413,'hindlimb',252,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35414,'hindlimb',252,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35415,'hindlimb',252,7,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35416,'hindlimb',252,7,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35417,'hindlimb',252,7,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35418,'hindlimb',252,7,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35419,'hindlimb',252,7,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35420,'hindlimb',252,7,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35421,'hindlimb',252,7,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35422,'hindlimb',252,7,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35423,'hindlimb',252,7,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35424,'hindlimb',252,7,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35425,'hindlimb',252,7,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35426,'hindlimb',252,7,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35427,'hindlimb',252,7,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35428,'hindlimb',252,7,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35429,'hindlimb',252,7,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35430,'hindlimb',252,7,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35431,'hindlimb',252,7,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35432,'hindlimb',252,7,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35433,'hindlimb',252,7,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35434,'hindlimb',252,7,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35435,'hindlimb',252,7,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35436,'hindlimb',252,7,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35437,'hindlimb',252,7,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35438,'hindlimb',252,7,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35439,'hindlimb',252,7,32,1.0732701,120.2432914,121.6632128,1.8,120.1097318,121.6494471,0.1480426,0.984421,1.7038144,0.2777961,0.7532422,0.0038919,0.4420917,0.2821924,0.5990961,2.14844,3.8432463,2.677945,9.4099502),(35440,'hindlimb',252,7,33,9.0858417,119.5402917,122.2143828,1.8,119.7350266,122.1757953,0.3547329,2.574738,3.1231213,9.3651572,13.0173984,0.1826936,4.1680733,3.6373243,7.166537,5.156256,6.3442673,2.6476513,17.4571136),(35441,'hindlimb',252,7,34,13.0762939,119.700436,122.3095995,1.8,119.8392549,122.240167,0.9171546,2.8794032,3.8456634,22.3774445,31.7957022,1.373527,8.2679368,7.7715564,13.7742846,5.9576825,7.9926588,2.2035452,22.2142185),(35442,'hindlimb',252,7,35,18.43,119.6436415,122.2623881,1.8,119.7277869,122.1746213,1.1986795,3.1772883,4.9121242,35.1016101,99.361897,2.6656035,20.2278878,11.0476629,27.3638943,6.5350417,10.3838797,1.9974238,26.6153583),(35443,'hindlimb',252,7,36,21.7133684,119.5099815,122.1848716,1.8,119.5409261,121.9652862,1.2521705,3.3890589,5.4640616,45.8971,156.5674663,3.2637618,28.6540448,13.5427271,36.9620804,7.1113101,11.2787985,1.8804993,29.0460407),(35444,'hindlimb',252,7,37,21.7245582,119.303087,122.2263458,1.8,119.3705835,121.8835693,1.286914,3.9800849,5.9888529,62.3959338,182.9167566,3.3367203,30.5428702,15.6770361,40.9542144,7.734384,11.9851376,1.8244704,31.3724633),(35445,'hindlimb',252,7,38,22.7829459,119.2706939,122.0233503,1.8,119.2654915,121.7860206,1.3240198,4.1382227,6.0958834,83.8209301,202.8416581,3.570572,33.2751869,20.2552969,46.9274072,8.164072,12.4015431,1.815775,32.5878045),(35446,'hindlimb',252,7,39,24.4248259,119.2763582,121.7258638,1.8,119.1776921,121.5863945,1.3861852,4.5502982,6.2462228,122.6048732,226.5236027,3.9336351,36.2656936,26.9443599,55.2100909,8.59376,12.7248603,1.7748143,34.3065565),(35447,'hindlimb',252,7,40,25.65397,119.3028829,121.5948237,1.8,119.2129463,121.5132671,1.5168759,4.6256888,6.0681796,151.1001041,241.8355249,4.2632426,39.8530598,32.6654279,64.3463156,9.453136,12.3717316,1.925502,35.5650835),(35448,'hindlimb',252,7,41,28.3553008,119.6337071,121.2554193,1.8,119.3744455,121.253377,-1.3242111,5.7228981,6.7350988,192.4217527,304.8737827,4.4443066,45.2664156,33.6231309,72.9284024,10.312512,13.0896253,1.1659045,38.2474713),(35449,'hindlimb',252,7,42,31.1150983,120.0743338,120.9845909,1.8,119.5959619,121.0914993,-1.1467666,6.3880331,7.0460821,221.6024467,379.1668064,4.3079885,53.8124307,34.6902469,83.255942,11.1430191,13.8570216,1.0516502,39.8187777),(35450,'hindlimb',252,7,43,46.2268735,122.9581664,120.7469373,1.8,122.5941191,120.9523599,-0.0860768,7.0086815,15.4186261,437.6505984,1759.8848534,0.0569433,114.1401864,62.4440698,142.4604335,11.9906436,14.2316921,1.0666304,43.0656503),(35451,'hindlimb',252,7,44,74.3470765,126.7787163,120.7661629,1.8,124.757908,120.9812964,-0.0448919,6.964066,12.9166018,546.1080462,4320.3993963,0.0249549,334.4842138,78.4179886,376.0368887,12.4732098,15.3369125,2.9441971,46.8591195),(35452,'hindlimb',252,7,45,94.1501215,128.9073616,120.9907785,1.8,126.3227007,121.0999371,-0.0474526,7.0290536,15.1132372,683.8886659,5844.2420204,0.0353073,386.6969026,97.2945588,430.6274613,13.4104956,27.4092448,0.1574169,78.4832882),(35453,'hindlimb',252,7,46,100.4946288,129.1857687,121.0963692,1.8,126.8582618,121.1782075,-0.0495248,6.8894906,15.7751157,827.7619326,6528.0220401,0.041047,413.8176959,120.1484953,465.7087689,13.3607551,28.1961776,0.1375867,80.4537456),(35454,'hindlimb',252,7,47,104.9408977,129.4816727,121.1731115,1.8,127.3327521,121.1824207,-0.0497602,6.4093392,16.4319108,991.9177864,6859.9153956,0.0432713,417.4752101,154.7613198,476.4646858,13.0115518,28.9457943,0.1040999,82.6759084),(35455,'hindlimb',252,7,48,107.2974146,129.4954615,121.2259088,1.8,127.6763075,121.1993573,-0.0468691,6.6670466,16.4870183,1108.4463633,7328.8500927,0.0392548,444.5224684,166.2574802,508.806158,13.0194671,29.4202952,3.0244839,84.8548854),(35456,'hindlimb',252,7,49,112.5128147,129.4819033,121.1512558,1.8,127.8964431,121.1821561,-0.037648,7.0578395,16.8924507,1254.3407306,7954.3110485,0.0265662,470.8796361,177.7230446,542.0451918,13.7196066,30.2281767,0.0996687,88.040684),(35457,'hindlimb',252,7,50,112.7396321,129.7235877,121.0821048,1.8,128.1119338,121.1621438,-0.036614,7.0353851,17.152861,1317.0592756,8100.4820145,0.0251782,472.2525318,187.2050008,543.5828408,13.9223676,30.655762,0.098274,90.1154012),(35458,'hindlimb',252,7,51,113.2066945,129.7033938,120.9741277,1.8,128.1600872,121.1400895,-0.0338216,7.3266567,17.5514779,1375.0326322,8492.6947681,0.0215746,483.8734834,187.6753197,557.0122664,14.4844456,31.1782987,3.0172377,92.9020488),(35459,'hindlimb',252,7,52,112.6521278,129.6138716,120.9134464,1.8,128.0808038,121.1148503,-0.0322704,7.4533185,17.8662897,1381.2978474,8674.8332153,0.0195455,485.5419532,185.3265547,558.8444442,14.5485917,31.6047135,3.018924,94.7250606),(35460,'hindlimb',252,7,53,109.72812,129.3621254,120.8746538,1.8,128.0035113,121.1072199,-0.0340128,7.9239307,17.628541,1343.4879958,8548.7868894,0.0211488,484.9401263,169.5481763,552.0086264,14.9604035,31.7213365,2.9920329,98.1625646),(35461,'hindlimb',252,7,54,106.3232862,129.3574381,120.8263292,1.8,127.9521485,121.1194402,-0.0285316,8.0271412,17.6289829,1286.9208702,8231.1853523,0.0144215,466.912096,160.321196,529.1760268,14.9926744,31.7882009,2.9786662,99.4821655),(35462,'hindlimb',252,7,55,103.1057697,128.9569445,120.8885957,1.8,127.6875827,121.1807063,-0.0175482,8.4226851,17.6323061,1240.3760574,7879.3794771,0.0052912,446.8717485,147.2661083,508.1470043,15.1894187,32.0859282,3.0072712,101.5568827),(35463,'hindlimb',252,7,56,99.133445,128.5293447,120.9814406,1.8,127.4262822,121.2674209,-0.0040227,8.3543681,17.2321372,1176.941781,7488.9655881,0.0002673,434.5929635,140.8774152,488.9795767,14.8868077,32.1462915,2.9940246,101.4526229),(35464,'hindlimb',252,7,57,94.0526583,127.497569,121.1303146,1.8,126.8472657,121.3677231,0.0404103,8.6235731,16.7790291,1098.4954264,6680.5013546,0.025584,398.1458818,127.3828629,455.6531953,14.8610525,32.2122739,2.9808299,101.9128479),(35465,'hindlimb',252,7,58,89.9265297,126.8995071,121.1768674,1.8,126.3080138,121.4127159,0.0730654,8.5135909,16.3426024,1063.6572536,6073.4215208,0.0798706,371.631235,124.9363832,426.7751075,14.4141893,32.0225685,2.938934,101.3051773),(35466,'hindlimb',252,7,59,81.6160296,125.3739085,121.0785546,1.8,124.9292055,121.3701974,0.1288792,8.642518,15.18624,1039.4354622,4553.5471147,0.2246902,299.8469092,120.2699798,363.8411062,14.4985826,28.8691504,2.8857841,93.3190879),(35467,'hindlimb',252,7,60,79.6271537,125.1422784,121.045373,1.8,124.6543992,121.3397065,0.1635942,8.4848575,14.9812065,1044.9894456,4255.1279556,0.3520206,284.0310588,123.1593396,346.6264815,14.4237851,28.1535827,2.863293,93.6750531),(35468,'hindlimb',252,7,61,78.1371753,124.8092558,120.9522388,1.8,124.4069484,121.2938075,0.2044097,8.3063362,15.0821258,1053.6449785,3987.1695649,0.5366022,264.363898,126.8483431,331.5628618,14.4670377,27.5134565,2.8890384,94.2827237),(35469,'hindlimb',252,7,62,77.4629895,124.6837091,120.9029303,1.8,124.358605,121.2742172,0.2265729,8.1064522,15.0839674,1059.2903293,3894.8631256,0.6515006,258.2121147,130.6724951,325.647647,14.4670377,27.2098039,2.8698005,96.3574409),(35470,'hindlimb',252,7,63,79.740954,124.4485691,120.9083417,1.8,124.219303,121.214696,0.2840018,7.7373647,15.0688825,1100.677137,4041.3586713,1.0434331,268.1923277,142.2547829,339.3432895,14.5106044,26.8099144,2.7640625,96.9651115),(35471,'hindlimb',252,7,64,80.2125483,124.106361,120.8586436,1.8,124.0868398,121.1575862,0.3158325,7.7201362,14.9047088,1116.4107315,4193.1528548,1.289781,281.3307458,144.6102386,354.2475902,14.5546685,27.2911083,2.5579568,92.8588629),(35472,'hindlimb',252,7,65,84.2091549,123.7203314,120.828305,1.8,123.9357354,121.0914089,0.3420039,7.5937341,14.827815,1147.6944948,4499.018358,1.5785965,303.4174873,151.1370407,380.343024,14.5564838,28.0122304,2.5748634,92.6071575),(35473,'hindlimb',252,7,66,85.352697,123.7060366,120.8073736,1.8,123.8156673,121.0077138,0.3434543,7.6139157,14.808367,1157.6469374,4578.6711735,1.6130938,309.1948736,152.0435719,386.9310634,14.5564838,28.4828375,2.549406,91.0358511),(35474,'hindlimb',252,7,67,86.568805,123.3149697,120.7021324,1.8,123.7394851,120.9601698,0.3480055,7.4493434,14.5544447,1163.4667293,4657.8304235,1.6779499,320.0280401,156.1837961,398.877278,14.5564838,28.6057343,2.5702552,89.7773241),(35475,'hindlimb',252,7,68,85.2223358,123.3746528,120.6813629,1.8,123.655839,120.8541223,0.3497303,7.3848673,14.4580034,1164.0120918,4482.8651938,1.6675908,310.0611522,157.6212598,390.2263417,14.5106044,28.4828375,2.549406,88.8136883),(35476,'hindlimb',252,7,69,84.0192639,123.4821911,120.5802097,1.8,123.6807356,120.7931321,0.3509447,7.3736746,14.2691621,1145.5089959,4240.1427891,1.6550137,297.1542942,155.3511719,376.4918796,14.3739084,28.1503035,2.5959376,88.3102775),(35477,'hindlimb',252,7,70,82.9709471,123.3985024,120.4540261,1.8,123.6902815,120.72066,0.3430471,7.4371074,13.8504308,1132.7704322,4012.4270678,1.5645115,289.6969151,152.3133093,371.4350569,14.453208,27.7140433,2.6224465,86.4872657),(35478,'hindlimb',252,7,71,84.1192448,123.3116147,120.4653142,1.8,123.6563041,120.6853402,0.3364287,7.2335332,13.5066149,1135.8906254,3871.8391531,1.5278576,286.6624382,157.0312322,369.9397337,14.3866946,27.5033887,2.6360116,84.9159594),(35479,'hindlimb',252,7,72,80.9068757,123.4672818,120.5407694,1.8,123.6679148,120.7149183,0.3350057,7.2092845,13.0068091,1126.918059,3597.0269298,1.4575736,276.549529,156.3148266,354.1782745,14.4560937,26.9712662,2.6066376,82.7369824),(35480,'hindlimb',252,7,73,81.1163489,123.5101934,120.5851263,1.8,123.7254829,120.7465078,0.3225288,7.128454,12.9161836,1141.5780159,3349.9019933,1.3582583,259.3569516,160.143843,338.2818149,14.372366,26.1686695,2.6265198,80.8707848),(35481,'hindlimb',252,7,74,82.2408123,123.4991143,120.6338823,1.8,123.7288934,120.8005548,0.3250036,7.3157144,12.9176204,1154.6463204,3321.3700501,1.3975491,257.1193422,157.830972,339.8782921,14.3310744,25.7562027,2.6555607,79.5511838),(35482,'hindlimb',252,7,75,84.8688499,123.4606895,120.6391179,1.8,123.6029557,120.7995915,0.3356062,7.3384192,12.8371131,1179.7843428,3204.589695,1.5342292,249.6347641,160.7681859,335.8781971,14.2591074,25.2091765,2.6245607,78.8392534),(35483,'hindlimb',252,7,76,88.6775796,123.3291215,120.7558448,1.8,123.5418232,120.8879422,0.3351156,7.614843,12.9219893,1226.7508808,3078.3279817,1.5985758,238.2240005,161.0999579,329.7764262,14.2159018,24.7956411,2.6546934,64.0034537),(35484,'hindlimb',252,7,77,88.6661101,123.2708109,120.7581711,1.8,123.6162373,120.860132,0.3366735,7.7776378,12.9791328,1226.4521361,2864.8471629,1.612697,220.7271638,157.6895405,312.1870439,14.1935397,24.4053706,2.6858189,62.7881125),(35485,'hindlimb',252,7,78,84.4099,123.4907032,120.6431259,1.8,123.7558208,120.868527,0.3559453,7.5929255,12.6959246,1207.1990225,2749.937086,1.7083988,216.599985,158.9899725,309.9504675,14.1935397,23.8660645,2.7343368,62.0329962),(35486,'hindlimb',252,7,79,80.4131815,123.6224348,120.5373331,1.8,123.8006955,120.8673281,0.3704794,7.4421218,12.4740705,1176.3569394,2594.9978021,1.7568827,208.0313558,158.0674125,301.1296812,14.1305134,23.4721372,2.7270858,61.0693605),(35487,'hindlimb',252,7,80,77.9385562,123.6316299,120.4162634,1.8,123.9069474,120.8008367,0.3734031,7.4814408,12.3555259,1149.8021949,2466.2357453,1.7285335,199.6058901,153.6872669,292.3371665,13.9898427,23.0794861,2.7195876,60.2099845),(35488,'hindlimb',252,7,81,75.7388644,123.6230356,120.2380355,1.8,123.8766074,120.6474805,0.3717087,7.406766,12.1829789,1124.2726344,2285.5341754,1.6652454,187.6006021,151.7899497,278.2392614,13.9590001,22.5125349,2.7291822,58.6386781),(35489,'hindlimb',252,7,82,73.4423808,123.764162,120.1270268,1.8,123.9364559,120.5540652,0.3731692,7.2506156,11.9373088,1097.9242594,2161.7012675,1.6268724,181.0878228,151.424972,271.9856262,13.940825,22.1195436,2.7213959,58.3869727),(35490,'hindlimb',252,7,83,73.4815451,123.7738161,119.9741425,1.8,123.9607851,120.4416947,0.3831587,7.1781657,11.597004,1062.0538894,2093.952503,1.7116953,180.5597808,147.9561684,270.5730528,13.9768379,21.5530404,2.7314653,57.5275967),(35491,'hindlimb',252,7,84,72.986676,123.6851675,119.8330915,1.8,123.9378524,120.3031799,0.3741874,7.1619209,11.40528,1046.5889594,1956.2967723,1.6251959,171.5255364,146.132438,262.6431509,13.9156919,21.1596801,2.7233683,56.6682207),(35492,'hindlimb',252,7,85,71.9024399,123.7371434,119.6647003,1.8,123.8606207,120.0585946,0.375022,7.0708704,11.0193133,1011.2960967,1853.6427006,1.6078654,168.2176239,143.0228581,258.9778578,13.6475255,20.5936687,2.7339611,55.3486197),(35493,'hindlimb',252,7,86,71.3799879,123.7387161,119.574391,1.8,123.7626289,119.9380936,0.3682009,7.0584184,10.7341138,997.602936,1776.3147396,1.5412724,165.4831293,141.3351933,258.2953107,13.537408,20.1174764,2.7928217,54.4892437),(35494,'hindlimb',252,7,87,69.3610114,123.5414137,119.3674483,1.8,123.5643478,119.6576946,0.3579782,7.0341597,10.1825388,962.8195212,1571.0726591,1.419208,154.2908589,136.8776881,247.9432751,13.6501081,19.2402368,2.7279034,52.5187863),(35495,'hindlimb',252,7,88,66.1263746,123.362182,119.1638689,1.8,123.3104633,119.3803757,0.346777,6.9095966,9.3096123,937.6580267,1375.5391111,1.2730491,147.7547141,135.7037286,247.9622023,13.320328,17.9545839,2.7744188,50.4440691),(35496,'hindlimb',252,7,89,64.5266801,123.0909551,118.9282308,1.8,123.0673017,119.1455559,0.3146972,6.9167538,8.6662974,905.5715187,1207.4261942,1.0303613,139.324344,130.9243541,242.2885883,13.320328,16.927744,2.7233683,48.3693519),(35497,'hindlimb',252,7,90,63.5897578,123.0728873,118.8278939,1.8,123.0131791,119.0067132,0.3128139,6.8280665,8.3038304,890.6087258,1125.426021,1.0036816,135.5309501,130.4335158,240.5557979,12.89064,16.5360111,2.7128146,46.7980455),(35498,'hindlimb',252,7,91,62.6231824,122.9770192,118.6677303,1.8,122.9107685,118.8919599,0.318278,6.8370657,7.9084992,856.4879889,1065.5179962,1.0220745,134.7307465,125.2712823,240.3986651,13.320328,15.7994355,2.7509856,46.9023053),(35499,'hindlimb',252,7,92,62.1576306,122.956656,118.551637,1.8,122.8659154,118.7331932,0.305074,6.7555876,7.691621,838.3806082,1030.5754372,0.9346271,133.9867679,124.1018043,242.2415389,13.2554576,15.4926212,2.8023,46.0429293),(35500,'hindlimb',252,7,93,60.4412824,122.8882017,118.3936538,1.8,122.7862128,118.5621842,0.2902323,6.7652497,7.5079995,819.9302633,950.5615887,0.8249832,126.6065061,121.1973398,233.2977426,12.89064,15.185687,2.7032561,44.8275881),(35501,'hindlimb',252,7,94,60.6654142,122.9031395,118.3445659,1.8,122.8601246,118.5046818,0.3132326,6.8290928,7.3999554,815.4318325,918.322084,0.9600052,124.098327,119.4055869,233.5877533,12.89064,15.0083566,2.7291822,44.4716229),(35502,'hindlimb',252,7,95,58.2748803,122.9022089,118.1718068,1.8,122.890768,118.2410915,0.2844892,6.6727386,7.309148,784.4457597,875.1625884,0.7650916,119.7352399,117.559792,226.4400508,12.460952,14.6850235,2.782822,44.1156577),(35503,'hindlimb',252,7,96,57.8149793,122.924943,118.0643637,1.8,122.8733072,118.0966342,0.2899684,6.7282711,7.1980797,776.341266,851.9265494,0.7877421,118.3546986,115.3849561,226.1226992,12.89064,14.5397175,2.8104966,43.9682121),(35504,'hindlimb',252,7,97,57.1892454,122.825638,117.9201859,1.8,122.7145051,118.0348397,0.2148059,6.767256,7.1074258,768.8398287,799.1821024,0.4330776,112.4432568,113.6117548,220.6166715,12.89064,14.283491,2.8674252,43.7165067),(35505,'hindlimb',252,7,98,56.8624472,122.8237776,117.828682,1.8,122.7408409,117.8998955,-0.1987735,6.6520436,6.4886895,762.2405989,778.7215881,0.3695422,120.0121523,114.5874329,221.0864781,12.89064,14.0488921,2.7326848,43.1088361),(35506,'hindlimb',252,7,99,56.2819201,122.8486496,117.7162562,1.8,122.7964662,117.7246718,-0.9530588,6.5434346,6.5540995,738.0119977,763.6385835,6.2335632,116.5131206,112.7866395,219.5493499,12.89064,13.8836442,2.7610863,42.6054253),(35507,'hindlimb',252,7,100,56.6490576,122.9018557,117.623434,1.8,122.8671677,117.639297,-1.1800135,6.8098412,6.6009073,729.0538093,763.1622755,8.0716009,115.6147545,107.0588559,218.8179689,12.89064,13.8836442,2.7610863,42.2494601),(35508,'hindlimb',252,7,101,56.4061829,122.8917478,117.4445448,1.8,122.8882985,117.4241818,-1.2836948,6.749381,6.5585814,705.133743,751.4677746,8.6471873,114.5777911,104.4738392,215.7881458,12.89064,13.7298596,2.7901479,42.5011655),(35509,'hindlimb',252,7,102,55.3645799,122.8912339,117.3193992,1.8,122.8991603,117.3367149,-1.3413534,6.663545,6.5836747,689.5145922,737.7070914,8.7501255,112.0509634,103.475642,214.0930836,12.89064,13.5879276,2.8198421,42.2494601),(35510,'hindlimb',252,7,103,54.2020711,122.8424792,117.1659743,1.8,122.8185735,117.1856595,-1.3723708,6.6476711,6.4463528,665.4015972,717.7155877,8.6826418,111.3366914,100.0954445,208.0266124,12.7610825,13.4924769,0.9209259,41.9977547),(35511,'hindlimb',252,7,104,53.9514755,122.84517,117.0610685,1.8,122.8380455,117.0587859,-1.3999298,6.6570309,6.4112597,656.3769986,712.479322,8.7319353,111.1293817,98.599062,205.2427867,12.7156348,13.4924769,0.9209259,41.9977547),(35512,'hindlimb',252,7,105,53.8030986,122.7638949,116.9036448,1.8,122.7195987,116.8883707,-1.4229682,6.387756,6.4851968,637.9165787,706.0918519,8.7726451,108.8774748,99.8655202,206.2901009,12.460952,13.348021,0.9917221,41.3900841),(35513,'hindlimb',252,7,106,54.0008784,122.7829738,116.8044519,1.8,122.7721425,116.803082,-1.5212754,6.2257676,6.4146968,631.8000193,705.4980319,8.9780931,109.9815086,101.4814647,205.3234147,12.460952,13.348021,0.9917221,41.3900841),(35514,'hindlimb',252,7,107,53.8953026,122.7631819,116.6880979,1.8,122.7630943,116.7254496,-1.5686644,6.1481832,6.2612879,618.7340935,697.1504316,8.9825096,111.342977,100.6368997,200.2203178,12.3893949,13.3411032,1.3101939,41.3900841),(35515,'hindlimb',252,7,108,53.496498,122.8063183,116.6087058,1.8,122.7947834,116.6311378,-1.5491713,6.1415816,6.3066412,610.3669624,690.5853087,8.9119141,109.5012845,99.3827,202.7991732,12.2975897,13.2717262,1.0636978,41.3900841),(35516,'hindlimb',252,7,109,53.3848237,122.8056976,116.5094025,1.8,122.8123972,116.5526448,-1.5253958,6.1890202,6.4099317,602.8566896,682.8813673,8.8791437,106.5348891,97.4074516,199.2547144,12.2975897,13.3272566,1.2082521,41.1383787),(35517,'hindlimb',252,7,110,53.3522614,122.8624774,116.4318691,1.8,122.8916632,116.4373914,-1.5287579,6.147502,6.4700617,603.2921219,679.7191769,8.8763386,105.0560581,98.1361413,195.1002322,12.2110825,13.3825567,1.4743226,41.7460493),(35518,'hindlimb',252,7,111,52.6635849,122.875186,116.3112072,1.8,122.8662921,116.2994991,-1.5200395,6.1392586,6.3473425,590.6621431,669.123765,8.7546711,105.417939,96.210663,193.5385206,12.031264,13.3411032,1.3101939,40.7824135),(35519,'hindlimb',252,7,112,52.3281705,122.9112209,116.2483222,1.8,122.9054896,116.2448656,-1.4912162,6.1626687,6.3313555,583.9171805,668.0066871,8.666246,105.5076889,94.7507007,194.0484703,12.031264,13.3411032,1.3101939,40.7824135),(35520,'hindlimb',252,7,113,52.4493001,122.8830249,116.1940457,1.8,122.8779688,116.1931206,-1.4426032,6.2258194,6.4343495,569.6948151,674.2830252,8.5986812,104.7942804,91.5051951,191.4871308,12.031264,13.4582233,1.2793395,40.7824135),(35521,'hindlimb',252,7,114,52.6406458,122.8995863,116.1495378,1.8,122.8648386,116.1630022,-1.4174046,5.8851167,6.4357401,560.7015868,679.2512035,8.5686243,105.5436033,95.2745068,192.4314906,11.601576,13.3411032,1.3101939,40.1747429),(35522,'hindlimb',252,7,115,53.1220312,122.8380884,116.091543,1.8,122.799345,116.0239881,-1.3810669,5.8534449,6.495055,548.1079999,688.6462116,8.5387699,106.0262324,93.6385342,189.1374086,11.601576,13.4307575,1.4424731,40.2790027),(35523,'hindlimb',252,7,116,53.6785002,122.8751385,116.0498661,1.8,122.8223463,115.9582858,-1.3945353,5.8667181,6.5324672,547.0801611,695.7051681,8.6713365,106.4996034,93.2514833,190.0794567,11.601576,13.4924769,1.4108832,40.2790027),(35524,'hindlimb',252,7,117,53.4726637,122.8973122,115.9393068,1.8,122.862487,115.8287408,-1.4217773,5.8381317,6.4886952,537.9656764,693.0118513,8.715663,106.8029598,92.1468895,189.4011866,11.601576,13.3411032,1.3101939,40.1747429),(35525,'hindlimb',252,7,118,53.279136,122.9198708,115.8632561,1.8,122.8587017,115.780302,-1.4249359,5.7830662,6.471574,532.1712199,694.3798669,8.6922708,107.2969053,92.0223286,188.245254,11.601576,13.4582233,1.2793395,40.1747429),(35526,'hindlimb',252,7,119,53.0768803,122.8922985,115.7684323,1.8,122.7947739,115.7625183,-1.4364384,5.7917793,6.4369538,524.56463,691.0076213,8.6874143,107.3500976,90.5705494,187.1572749,11.171888,13.4582233,1.2793395,39.8187777),(35527,'hindlimb',252,7,120,52.8908498,122.9313437,115.6972657,1.8,122.85037,115.6696224,-1.4417763,5.7599151,6.5520831,521.4894668,693.3237492,8.6692157,105.8173016,90.5376999,184.9579739,11.171888,13.4924769,1.4108832,40.1747429),(35528,'hindlimb',252,7,121,53.3806835,122.910003,115.6374015,1.8,122.8179395,115.586072,-1.4462331,5.7816675,6.5506939,519.3516713,702.3282201,8.7594506,107.2143236,89.8273151,186.3512201,11.171888,13.5675304,1.3796119,40.1747429),(35529,'hindlimb',252,7,122,53.8249747,122.9433184,115.6021985,1.8,122.8844491,115.5653098,-1.4457532,5.7572508,6.5652124,519.6664153,713.6897297,8.8312926,108.7077903,90.2629452,187.477262,11.171888,13.6556983,1.3487144,40.4264483),(35530,'hindlimb',252,7,123,54.7214459,122.933663,115.590858,1.8,122.8792268,115.5345805,-1.4663661,5.7778362,6.5896588,519.5559639,732.213456,9.0211398,111.1155346,89.922238,187.8332144,11.171888,13.7567282,1.3182421,40.1747429),(35531,'hindlimb',252,7,124,55.2385827,122.9726188,115.559443,1.8,122.9013776,115.4729031,-1.4819715,5.7955555,6.5680457,519.8781013,744.0450191,9.1339839,113.2825582,89.7028948,189.5941851,11.171888,13.7567282,1.3182421,40.1747429),(35532,'hindlimb',252,7,125,56.725484,122.9986517,115.53765,1.8,122.9080593,115.4719496,-1.5021486,5.7949912,6.5742691,522.7383417,757.1160641,9.409764,115.1635341,90.2051996,190.6112414,11.171888,13.8703393,1.2882414,40.4264483),(35533,'hindlimb',252,7,126,57.5327724,123.0638559,115.495307,1.8,122.9861587,115.3995874,-1.5190753,5.8132804,6.7884366,526.2465623,760.7041848,9.5631676,112.0588182,90.5248892,188.9526785,11.5860241,13.8570216,1.4464413,41.3900841),(35534,'hindlimb',252,7,127,58.1023335,123.0543184,115.4209154,1.8,122.9602385,115.3159089,-1.5328351,5.8043145,6.747733,528.5392303,767.1115849,9.6697741,113.6843417,91.0597166,190.4362426,11.171888,13.9896277,1.3854484,40.7824135),(35535,'hindlimb',252,7,128,58.6628868,123.0840122,115.3756044,1.8,123.0034869,115.2538477,-1.5214177,5.8465908,6.7105052,532.9669478,774.2279163,9.7533281,115.3755038,91.1585861,193.5429502,11.601576,13.9896277,1.3854484,41.1383787),(35536,'hindlimb',252,7,129,57.6554127,123.027484,115.2617233,1.8,122.9592442,115.1666554,-1.4888551,5.81759,6.7933143,528.8038576,764.0441606,9.5448598,112.4700152,90.8974086,190.3115985,11.5860241,13.9896277,1.3854484,41.1383787),(35537,'hindlimb',252,7,130,56.5837651,123.0363957,115.1417647,1.8,123.0051768,115.0445953,-1.4661007,5.8333732,6.6194033,529.0550958,752.2099542,9.327634,113.6371239,90.6945401,190.2294333,11.601576,13.9962251,1.2587542,40.5307081),(35538,'hindlimb',252,7,131,55.4243894,123.0215608,115.0042916,1.8,122.9604471,114.9723596,-1.4563513,5.8091766,6.7163952,522.6302565,734.2985468,9.1169373,109.3292638,89.9663225,186.2538993,11.601576,13.8703393,1.2882414,40.7824135),(35539,'hindlimb',252,7,132,54.9128475,123.0570626,114.9191621,1.8,123.0310009,114.9001893,-1.4527923,5.836069,6.7568214,519.225029,727.6130994,9.0252885,107.6857077,88.9682814,184.4217852,11.601576,13.7567282,1.3182421,40.7824135),(35540,'hindlimb',252,7,133,54.519414,123.0601905,114.8252217,1.8,123.0456347,114.7687696,-1.4532625,5.8279862,6.8503707,513.2269249,722.3231823,8.9616222,105.4429332,88.0624811,180.2635166,11.601576,13.9168507,1.4157996,41.1383787),(35541,'hindlimb',252,7,134,54.318501,123.101243,114.77099,1.8,123.067803,114.7275856,-1.4507421,5.8629262,6.8582172,511.7617256,722.1073403,8.9232269,105.2908233,87.2877651,179.8473623,11.601576,13.9168507,1.4157996,41.1383787),(35542,'hindlimb',252,7,135,54.3910669,123.0996353,114.6990651,1.8,123.0345892,114.6334786,-1.4429585,5.853564,6.9277219,509.1328798,722.1605681,8.9178355,104.2421424,86.9782716,177.6216894,11.601576,13.9896277,1.3854484,40.8866733),(35543,'hindlimb',252,7,136,54.4470719,123.1525926,114.6404069,1.8,123.1450001,114.5664582,-1.438267,5.7566242,6.99163,508.3029344,727.7493774,8.9160579,104.0886577,88.2987865,176.6909979,11.171888,14.0751518,1.3554386,40.7824135),(35544,'hindlimb',252,7,137,54.1770619,123.1277904,114.6051254,1.8,123.095765,114.5145376,-1.4477121,5.9222514,7.0255018,502.9640085,743.6058365,8.8934051,105.8438036,84.9278385,177.3650408,11.601576,14.0751518,1.3554386,40.8866733),(35545,'hindlimb',252,7,138,54.3098289,123.1645133,114.5961091,1.8,123.1361756,114.5280327,-1.4547891,5.7265358,7.0399287,502.0197354,759.8942776,8.9303697,107.9406218,87.66552,179.2282157,11.171888,14.1731921,1.3258177,40.5307081),(35546,'hindlimb',252,7,139,53.7590108,123.1362378,114.4986766,1.8,123.0783013,114.4517685,-1.4518295,5.9161276,6.8082991,496.5880137,754.5159424,8.8336228,110.822972,83.9380154,182.7096026,11.601576,13.9962251,1.2587542,40.2790027),(35547,'hindlimb',252,7,140,53.4600192,123.164952,114.4154078,1.8,123.1292813,114.3962368,-1.45025,5.7153016,6.8955638,494.736681,755.5040136,8.7811542,109.5637767,86.56353,180.2774537,11.171888,13.9962251,1.2587542,40.1747429),(35548,'hindlimb',252,7,141,52.7394518,123.1594441,114.2552551,1.8,123.112039,114.2309022,-1.4441759,5.9110014,7.0038407,492.1065487,738.6436095,8.6497338,105.4626507,83.252653,175.617132,11.5319132,13.9962251,1.2587542,41.1383787),(35549,'hindlimb',252,7,142,52.2756903,123.1792048,114.1310483,1.8,123.1533551,114.1363341,-1.4345906,5.721802,7.0732672,493.7142772,727.1395998,8.5519757,102.8010933,86.286501,172.4980299,11.171888,13.9896277,1.3854484,40.7824135),(35550,'hindlimb',252,7,143,51.6948275,123.132453,113.9734967,1.8,123.0870108,113.9612561,-1.407155,5.8370742,6.9277812,493.0514789,707.999517,8.3871384,102.1971538,84.4689418,173.0680872,11.601576,13.7567282,1.3182421,40.2790027),(35551,'hindlimb',252,7,144,51.5084613,123.1473345,113.885727,1.8,123.1196236,113.8841339,-1.3897453,5.7918911,6.9454703,493.7463994,702.7070329,8.3064016,101.1748664,85.2478741,172.2303822,11.171888,13.7567282,1.3182421,39.9230375),(35552,'hindlimb',252,7,145,51.3713303,123.1216835,113.7998203,1.8,123.119186,113.8570225,-1.3711701,5.7780515,6.9356345,492.6118974,696.1820966,8.2252002,100.3775646,85.2557128,170.4641244,11.171888,13.6556983,1.1493771,40.1747429),(35553,'hindlimb',252,7,146,51.4558693,123.1604693,113.7381901,1.8,123.1620027,113.8095312,-1.3570595,5.8219549,6.9931092,495.0959044,695.128476,8.190128,99.4019187,85.0394604,169.0907114,11.171888,13.7567282,1.3182421,40.1747429),(35554,'hindlimb',252,7,147,51.3483352,123.1386304,113.6466859,1.8,123.1311661,113.7102094,-1.3391435,5.8010138,6.8407524,494.564494,688.5401364,8.106961,100.6526908,85.254838,172.9472841,11.171888,13.5879276,1.2490458,40.0704831),(35555,'hindlimb',252,7,148,51.2642998,123.174507,113.5813759,1.8,123.1623003,113.6481886,-1.3350024,5.8249545,6.8120533,495.9110376,686.4734253,8.0777502,100.7733493,85.1356077,173.1762323,11.171888,13.4856331,1.1784562,39.8187777),(35556,'hindlimb',252,7,149,50.9888628,123.1654652,113.509589,1.8,123.1537256,113.6043624,-1.330388,5.8034384,6.8774228,496.1842275,678.7141187,8.0163734,98.6872749,85.4983191,170.3509505,11.5319132,13.5879276,1.2490458,40.1747429),(35557,'hindlimb',252,7,150,50.7929852,123.1968521,113.4454316,1.8,123.1990431,113.5685303,-1.3287205,5.9229663,6.8433556,498.6383563,674.6636943,7.9790282,98.5866784,84.1872693,169.1318342,11.601576,13.4582233,1.2793395,40.1747429),(35558,'hindlimb',252,7,151,50.5457465,123.1751733,113.3744866,1.8,123.1661848,113.4575074,-1.3282835,5.8854091,6.9066107,497.8514283,667.8725683,7.9384749,96.7004803,84.590794,167.1335671,11.601576,13.4924769,1.4108832,40.7824135),(35559,'hindlimb',252,7,152,50.5160935,123.2091191,113.3229681,1.8,123.2034386,113.4086117,-1.3168696,5.9178941,6.8455093,500.968929,666.1772618,7.8880476,97.3159532,84.6532429,166.8086151,11.601576,13.4924769,1.4108832,40.7824135),(35560,'hindlimb',252,7,153,50.2995708,123.2183795,113.2602762,1.8,123.2235199,113.3323072,-1.3140641,5.9137402,6.8161252,500.7212449,660.0439194,7.8427428,96.8356505,84.6708223,170.2714336,11.601576,13.4856331,1.1784562,40.4264483),(35561,'hindlimb',252,7,154,50.2042337,123.2609715,113.2110615,1.8,123.2746849,113.2722955,-1.3128821,5.9434653,6.7648334,502.7755279,658.4008726,7.8230092,97.3269893,84.5929951,170.5903145,11.601576,13.3411032,1.3101939,40.4264483),(35562,'hindlimb',252,7,155,50.1985828,123.2460822,113.1666525,1.8,123.240123,113.2424042,-1.3055728,5.9236135,6.7998575,503.9201271,656.7651208,7.7915771,96.5851295,85.0697172,169.3616549,11.601576,13.3411032,1.3101939,40.6781537),(35563,'hindlimb',252,7,156,50.1195268,123.2950927,113.1287699,1.8,123.2988306,113.2241984,-1.2976036,5.9666273,6.8446546,506.1004158,657.4909104,7.7451719,96.0590348,84.8218587,169.3387184,11.601576,13.4582233,1.2793395,40.4264483),(35564,'hindlimb',252,7,157,50.0748795,123.2989435,113.0779162,1.8,123.284805,113.1627443,-1.3059323,5.9511208,6.7870656,508.1285048,655.8037674,7.7738935,96.6255241,85.3836647,169.6245993,11.601576,13.3411032,1.3101939,40.4264483),(35565,'hindlimb',252,7,158,50.1887358,123.3379957,113.0527276,1.8,123.301527,113.1754655,-1.3073509,5.9812895,6.8229278,511.3688601,659.663816,7.7975505,96.6833941,85.494752,170.0528449,11.601576,13.4582233,1.2793395,40.4264483),(35566,'hindlimb',252,7,159,50.2835134,123.3170017,113.0269739,1.8,123.2616466,113.1359967,-1.3209516,5.9450726,6.7484934,513.7461083,658.1279056,7.8682443,97.5221971,86.4154479,170.5872273,11.601576,13.3411032,1.3101939,40.4264483),(35567,'hindlimb',252,7,160,50.0936784,123.3653284,112.9979181,1.8,123.2899682,113.1156042,-1.3339589,5.9753665,6.8041831,515.8129255,655.2495621,7.8893284,96.3009891,86.3232285,169.6855258,11.601576,13.3411032,1.3101939,40.4264483),(35568,'hindlimb',252,7,161,49.9676812,123.3651028,112.964206,1.8,123.2903025,113.0277323,-1.3504508,5.9544723,6.8551383,517.7769697,651.1056241,7.9301087,94.9806697,86.9559788,168.5486446,11.601576,13.4924769,1.4108832,40.7824135),(35569,'hindlimb',252,7,162,49.7432137,123.4130272,112.9279447,1.8,123.316645,112.9469683,-1.3540458,5.9904794,6.6697669,519.1360559,646.9516136,7.9071012,96.9976351,86.6601857,173.3985615,11.601576,13.3272566,1.9333406,40.4264483),(35570,'hindlimb',252,7,163,49.3905111,123.4018837,112.9000057,1.8,123.3166535,112.8881637,-1.3399392,5.8855934,6.6929895,517.8578894,640.2202908,7.800779,95.6553563,87.9873707,171.4476592,11.601576,13.4582233,1.8622531,40.1747429),(35571,'hindlimb',252,7,164,49.148028,123.4243186,112.8554655,1.8,123.3781894,112.8148683,-1.328314,5.8994336,6.7392393,519.9822067,636.6876775,7.7190724,94.4747103,88.1410384,170.2849331,11.601576,13.5879276,1.8925469,40.4264483),(35572,'hindlimb',252,7,165,49.4653149,123.382221,112.8814605,1.8,123.3185714,112.7714271,-1.3488842,5.9542411,6.7079634,524.9285228,642.3150981,7.8448533,95.7541154,88.160441,173.9766185,11.601576,13.7567282,1.8233506,40.7824135),(35573,'hindlimb',252,7,166,49.6263362,123.4179738,112.8985058,1.8,123.3649391,112.7921536,-1.36786,5.8911826,6.6997084,528.1215143,648.8586535,7.9350784,96.8487907,89.6460948,174.3086113,11.601576,13.8703393,1.8533513,40.7824135),(35574,'hindlimb',252,7,167,49.9224184,123.3902451,112.9136363,1.8,123.3379755,112.7737364,-1.3740218,5.8641807,6.6790932,533.3779432,652.5517857,8.0023721,97.7006552,90.9552359,175.841344,11.601576,13.8703393,1.8533513,40.7824135),(35575,'hindlimb',252,7,168,50.4469405,123.4351141,112.9121941,1.8,123.3751933,112.7652752,-1.3673438,5.8241375,6.6897839,541.7636246,657.273768,8.0645745,98.2503743,93.0204042,178.0337607,11.9153649,13.8703393,1.8533513,41.1383787),(35576,'hindlimb',252,7,169,50.5793719,123.4252859,112.9155048,1.8,123.3749619,112.7753856,-1.351121,5.8147745,6.6843927,545.4707421,660.402128,8.0295936,98.7976258,93.8077208,180.392924,11.8817859,13.8703393,1.2882414,41.1383787),(35577,'hindlimb',252,7,170,50.5140794,123.4604386,112.9207013,1.8,123.4308429,112.7406434,-1.3490211,5.8500448,6.686906,548.1531926,663.9654034,8.0116749,99.293366,93.7006829,174.7433514,11.9857368,14.0751518,1.786154,41.2426385),(35578,'hindlimb',252,7,171,50.3794101,123.4481877,112.9434769,1.8,123.4269676,112.805845,-1.3292393,5.8407304,6.6597049,549.0963115,664.4629249,7.9160858,99.7736291,94.0115825,182.1564842,11.9857368,13.7567282,1.3182421,41.1383787),(35579,'hindlimb',252,7,172,50.3916069,123.4927696,112.9529825,1.8,123.4551887,112.8258728,-1.3158948,5.9009563,6.6587318,552.5510414,667.4845007,7.8646206,100.2419858,93.6375424,183.1190007,12.031264,13.6556983,1.7928782,40.8866733),(35580,'hindlimb',252,7,173,50.3490297,123.509418,112.9619981,1.8,123.4649121,112.9490574,-1.3135943,5.9228172,6.6537128,553.8087301,667.8774925,7.8485164,100.3766644,93.5042757,183.1862845,12.031264,13.5879276,1.2490458,40.7824135),(35581,'hindlimb',252,7,174,50.5654406,123.538886,112.9280228,1.8,123.5225008,112.8671526,-1.3219358,5.9302516,6.6955181,560.1262944,674.6718135,7.9163267,100.764691,94.4523665,184.3776955,12.031264,13.7298596,1.2193515,41.1383787),(35582,'hindlimb',252,7,175,50.993003,123.5058903,112.9096845,1.8,123.4705341,112.8480393,-1.3286924,5.8834575,6.8092612,569.521909,680.7083878,8.0103376,99.9680239,96.8005478,183.4524588,12.031264,13.8836442,1.1902899,41.1383787),(35583,'hindlimb',252,7,176,51.4997333,123.5475598,112.8973332,1.8,123.5304272,112.792657,-1.334012,5.826492,6.7286622,578.1432699,689.3005633,8.1109779,102.4424378,99.2266477,188.3563825,12.031264,13.8703393,1.2882414,41.3900841),(35584,'hindlimb',252,7,177,51.6212546,123.5280107,112.8920102,1.8,123.5020767,112.852016,-1.3386128,5.8766467,7.0488528,584.3778739,691.0263326,8.1480074,98.0338718,99.4407017,180.3484581,12.031264,14.1731921,1.3258177,41.4943439),(35585,'hindlimb',252,7,178,51.8845507,123.559668,112.858225,1.8,123.5378989,112.7411216,-1.3522882,5.857813,6.9792446,592.3245263,699.243422,8.2410763,100.1889833,101.1170089,184.7461372,12.031264,14.4057668,1.2679115,41.7460493),(35586,'hindlimb',252,7,179,52.5443016,123.5749107,112.8859494,1.8,123.5743625,112.7328078,-1.3587745,5.8647895,7.0003606,601.5918925,707.2006782,8.3695743,101.0234645,102.5768943,186.6082216,12.031264,14.4057668,1.2679115,41.9977547),(35587,'hindlimb',252,7,180,52.4459991,123.606773,112.8999505,1.8,123.6057619,112.8073653,-1.3338896,5.8971723,6.8408538,606.4578511,707.5729465,8.2595226,103.4334267,102.8387547,191.7400084,12.031264,14.1340576,1.2298174,41.9977547),(35588,'hindlimb',252,7,181,52.6353866,123.5878026,112.8832169,1.8,123.5658707,112.816028,-1.3089842,5.9551921,6.9416162,614.8491373,711.8793993,8.184858,102.5523991,103.2458947,188.6069936,12.031264,14.283491,1.4501727,42.3537199),(35589,'hindlimb',252,7,182,52.7279822,123.6421636,112.8586448,1.8,123.6144974,112.7476036,-1.2724566,5.9817012,6.9655443,622.0983962,719.2142258,8.0287403,103.2531269,104.0002469,192.4582475,12.3670117,14.4057668,1.2679115,42.3537199),(35590,'hindlimb',252,7,183,52.7796232,123.6547447,112.8507647,1.8,123.627376,112.7598854,-1.2559444,5.9829916,6.9137121,632.9631705,715.8100028,7.953018,103.5348301,105.7937597,195.0692218,12.460952,14.283491,1.2966289,42.3537199),(35591,'hindlimb',252,7,184,52.8451954,123.6987201,112.8496709,1.8,123.6643746,112.7901569,-1.1964746,6.0360858,6.9130886,644.7742797,715.2951458,7.6300224,103.4696917,106.8199322,196.2990549,12.460952,14.283491,1.2014627,42.3537199),(35592,'hindlimb',252,7,185,53.0691594,123.6798008,112.8347129,1.8,123.635393,112.7692284,-1.1813531,6.0429934,6.9119561,655.9976317,720.4599352,7.5698569,104.2338707,108.5550792,194.0786513,12.460952,14.4121737,1.3909428,42.7096851),(35593,'hindlimb',252,7,186,52.8821218,123.7058225,112.8261986,1.8,123.6645421,112.7998139,-1.1195177,6.0828531,6.881272,665.0709697,719.1929353,7.1373445,104.5145337,109.3353655,199.0864581,12.460952,14.283491,1.2966289,42.6054253),(35594,'hindlimb',252,7,187,52.6910559,123.7210709,112.8193605,1.8,123.7254965,112.7902245,-1.1323111,6.2584716,6.9061249,673.2865033,720.6326539,7.1988416,104.3468899,107.5800213,192.8819407,12.460952,14.6661522,1.6588037,43.3173557),(35595,'hindlimb',252,7,188,52.5357973,123.7556348,112.7987089,1.8,123.7460044,112.8142118,-1.0529955,6.2805785,6.6919747,683.8937084,719.5451072,6.6107921,107.5235841,108.8902416,194.5818427,12.460952,14.7101476,1.6879051,44.1767317),(35596,'hindlimb',252,7,189,53.0821395,123.7691411,112.8014421,1.8,123.7485133,112.698112,-0.9555118,6.2984202,7.1706829,701.77154,728.9711877,5.8996436,101.6599398,111.4202486,195.7864978,12.460952,14.8413514,1.1849137,44.1767317),(35597,'hindlimb',252,7,190,53.2535114,123.8274034,112.8112428,1.8,123.8280455,112.7824398,-0.659675,6.4416151,6.7022742,711.4120808,736.5005682,3.3336473,109.8881582,110.4400174,201.9561583,12.89064,14.6346459,1.6295521,43.9250263),(35598,'hindlimb',252,7,191,53.5578181,123.7816131,112.8504643,1.8,123.8243406,112.8946107,-0.4361392,6.6974888,6.6366672,723.6205585,747.3058677,1.5929728,112.602583,108.0435642,205.5688384,12.89064,14.4121737,1.3909428,43.5690611),(35599,'hindlimb',252,7,192,54.2233877,123.8286684,112.8533714,1.8,123.9025379,112.9160363,-0.0953189,7.0310923,6.4049735,742.0986335,762.4047474,0.0818612,119.0332395,105.5452835,210.0858057,12.89064,14.4121737,1.3909428,43.8207665),(35600,'hindlimb',252,7,193,54.3682397,123.8460691,112.8782862,1.8,123.9077219,112.9579803,0.1613553,7.1361852,6.5638774,745.2836488,783.3108679,0.2338775,119.3366084,104.4372628,214.0806016,13.320328,14.4952048,1.3617734,44.1767317),(35601,'hindlimb',252,7,194,54.9014899,123.9024987,112.8591931,1.8,123.907218,112.8637078,0.2501971,7.0555641,6.5594095,755.9403182,803.447904,0.5609399,122.487841,107.1410183,219.7481544,13.320328,14.4121737,1.3909428,44.4284371),(35602,'hindlimb',252,7,195,55.2587803,123.8899077,112.8280817,1.8,123.9506172,112.8002854,0.1273909,7.1792306,6.5634626,765.6697685,823.0284432,0.1486538,125.3954646,106.650672,220.71056,13.320328,14.5904229,1.3329604,44.4284371),(35603,'hindlimb',252,7,196,54.755407,123.9466658,112.8658891,1.8,123.9502221,112.8337063,0.1264462,7.0941997,6.7514573,763.9370568,840.6565084,0.1451348,124.5148227,107.6847412,223.8031429,13.6725884,14.4121737,1.3909428,44.7844023),(35604,'hindlimb',252,7,197,54.7613935,123.8769968,112.9100227,1.8,123.9878129,112.9014278,0.1625289,7.0406206,6.8836569,774.0750034,859.4817049,0.2389774,124.8583015,109.9441436,230.4917736,13.6725884,14.4952048,1.7798193,44.7844023),(35605,'hindlimb',252,7,198,54.8259027,123.8968984,112.9760618,1.8,124.0089661,113.0281307,0.1436752,7.0413073,6.9711104,782.4439446,881.9359998,0.1873301,126.5129876,111.1219716,231.6963296,13.750016,14.4952048,1.7798193,45.2878131),(35606,'hindlimb',252,7,199,55.2233646,123.9448538,113.043099,1.8,124.1298369,112.9984855,0.1183002,7.2445947,6.8830268,790.7918231,906.4516146,0.1282081,131.6937497,109.156116,222.3495665,13.750016,14.5904229,1.3329604,45.2878131),(35607,'hindlimb',252,7,200,56.0232678,124.014941,113.0850875,1.8,124.1581241,113.0258211,0.1289821,6.941262,7.0820353,795.4925902,933.7364459,0.154478,131.8457763,114.6034533,239.7148541,14.0308944,14.5397175,1.9018924,46.1471891),(35608,'hindlimb',252,7,201,56.2412452,123.9835706,113.120172,1.8,124.0822879,113.0462208,0.1810472,7.0037557,7.2449646,803.7782293,969.6106809,0.3039043,133.8323556,114.7638874,243.248607,13.750016,14.8164498,2.6260436,46.3988945),(35609,'hindlimb',252,7,202,56.8392283,123.9804482,113.1398076,1.8,124.0535243,113.1112867,0.1674177,6.9736485,7.3831177,812.7207746,1010.9345732,0.2630501,136.92516,116.5416886,243.6282748,13.750016,15.0329403,2.6011732,46.3988945),(35610,'hindlimb',252,7,203,57.4749212,123.9922873,113.2133987,1.8,124.0369978,113.1632244,0.1552763,6.8925693,7.4109758,822.5697315,1052.6127417,0.22911,142.0342984,119.3415246,246.7924805,13.750016,15.240301,2.7663218,46.9023053),(35611,'hindlimb',252,7,204,57.9852881,123.9988058,113.2677863,1.8,124.0488576,113.2831052,0.146241,6.8312465,7.6810254,828.0680119,1099.1840335,0.205214,143.1038146,121.2177037,249.6347517,13.750016,15.4269362,2.9168815,47.2582705),(35612,'hindlimb',252,7,205,60.835779,124.0293009,113.3255816,1.8,124.056158,113.3583538,0.1792378,6.8851115,7.7387927,855.1132653,1173.4134027,0.3222636,151.6274498,124.1974465,260.3882241,13.750016,15.7350314,2.5308667,47.7616813),(35613,'hindlimb',252,7,206,60.9533279,124.091176,113.3934261,1.8,124.0697771,113.4023512,0.1872326,6.9417499,7.752262,872.0047107,1222.7321271,0.3519883,157.7258524,125.6174191,267.0279763,13.9309733,15.9853176,2.5088438,48.6210573),(35614,'hindlimb',252,7,207,63.0689843,124.022136,113.4275788,1.8,124.0128396,113.437632,0.1843765,6.8684823,8.1540395,898.8713557,1305.7267031,0.3533041,160.1324958,130.8689922,268.190257,13.750016,16.3620316,2.6191892,49.2287279),(35615,'hindlimb',252,7,208,63.2480211,124.1151833,113.4590583,1.8,124.0549737,113.4225124,0.1712286,6.8887721,8.1206253,915.4577816,1357.7796884,0.3060553,167.2013715,132.8912853,273.4731687,13.9820947,16.6860637,2.5393053,50.0881039),(35616,'hindlimb',252,7,209,64.3931857,124.0974009,113.5245357,1.8,124.0526746,113.4603218,0.1763648,6.9699028,8.4048943,941.6239689,1424.378803,0.3303732,169.4701632,135.098579,278.2009808,14.1225929,17.0418833,2.5535901,50.6957745),(35617,'hindlimb',252,7,210,66.1753859,124.1760836,113.5526547,1.8,124.1047366,113.5091726,0.1718963,7.0272095,8.4687612,971.7091147,1470.8517119,0.3226983,173.679678,138.2780903,284.0235635,14.179704,17.1713991,2.5882983,50.9474799),(35618,'hindlimb',252,7,211,68.7285637,124.1529166,113.5906589,1.8,124.0846317,113.5478414,0.1527284,7.0972353,8.5953265,1006.3102649,1553.3921405,0.2651222,180.7252038,141.7890514,290.0523088,14.179704,17.5384304,2.6011732,52.0585613),(35619,'hindlimb',252,7,212,68.8507004,124.2235562,113.5526348,1.8,124.1137262,113.5384643,0.1186612,7.1245871,8.7815042,1019.8640342,1582.2756736,0.1608183,180.1827619,143.1471076,292.4489163,14.179704,17.7164901,2.896614,52.4145265),(35620,'hindlimb',252,7,213,70.0818587,124.1778767,113.624535,1.8,124.1233049,113.5576497,0.1276878,7.3331827,8.8302387,1045.0042636,1646.5720117,0.189405,186.4697063,142.5035095,300.498478,14.609392,17.8876178,2.7209293,53.0221971),(35621,'hindlimb',252,7,214,70.787208,124.2844775,113.6531388,1.8,124.1641264,113.5713306,0.1210081,7.4130638,8.7641054,1069.0843166,1682.7940393,0.1719142,192.0097894,144.2162577,307.9349556,14.609392,17.9545839,2.7744188,53.0221971),(35622,'hindlimb',252,7,215,73.2835975,124.2414183,113.8175559,1.8,124.1470826,113.6226859,0.1096851,7.3132234,9.0075257,1128.3535779,1734.396348,0.1463553,192.5496969,154.2895003,317.8058554,14.609392,18.1132733,2.7522759,53.8815731),(35623,'hindlimb',252,7,216,74.9374506,124.2488509,113.8766058,1.8,124.2540227,113.6547945,0.1181007,7.6071241,9.0934746,1166.043365,1784.9888974,0.1733933,196.2933833,153.2830747,323.7149799,15.03908,18.280687,2.7305281,54.4892437),(35624,'hindlimb',252,7,217,76.1946811,124.2722425,113.9873504,1.8,124.2308953,113.6865182,0.1093453,7.5738587,9.0990546,1223.0658067,1780.1798224,0.1512315,195.6444828,161.4851625,327.9194215,15.468768,18.4815797,2.8345469,55.4528795),(35625,'hindlimb',252,7,218,77.4414491,124.3523202,114.1357392,1.8,124.2760969,113.7500318,0.108431,7.7662863,9.0489327,1270.4490101,1844.5077821,0.1511564,203.8370541,163.5851368,339.4897661,15.8807663,18.7592155,2.7908647,56.5639609),(35626,'hindlimb',252,7,219,79.303041,124.3279454,114.2799231,1.8,124.2997866,113.8812849,0.107429,7.8537782,9.3914282,1336.0486995,1915.5953712,0.1519533,203.9727435,170.1154112,346.0577211,15.898456,18.9696424,2.913096,57.7793021),(35627,'hindlimb',252,7,220,81.0222426,124.5390564,114.4235848,1.8,124.4289065,114.0066504,0.1260334,8.0247132,9.8102331,1382.5986889,2052.0541806,0.2133654,209.1748644,172.2925978,345.1947497,16.328144,19.8681338,2.7651023,59.4980541),(35628,'hindlimb',252,7,221,84.0956344,124.6755308,114.547996,1.8,124.4483457,114.1364943,0.1579631,8.2117248,10.0606668,1459.5634165,2231.4373295,0.3468311,221.7981547,177.7413945,365.8485896,16.328144,20.2683424,2.7728968,60.9651007),(35629,'hindlimb',252,7,222,87.8894257,124.7287961,114.8067007,1.8,124.3920042,114.3507583,0.1004916,8.4025021,10.0080161,1516.0322076,2553.840791,0.147429,255.1795258,180.4262807,398.7799411,16.757832,20.5936687,2.7339611,62.1804419),(35630,'hindlimb',252,7,223,96.0578713,124.6077984,115.1244017,1.8,124.3110186,114.6277878,0.0579547,8.852027,10.0440225,1669.0248592,3071.1653494,0.0537123,305.770456,188.547195,456.8641194,17.18752,20.9800419,2.5308667,63.7949341),(35631,'hindlimb',252,7,224,102.2377766,124.4459255,115.2765067,1.8,124.2017869,114.8167965,0.039456,9.07511,10.1694562,1804.4858808,3440.024572,0.0265131,338.2702581,198.8390086,495.7023159,17.5571195,21.1596801,2.6325218,64.2983449),(35632,'hindlimb',252,7,225,106.3529951,124.3171183,115.5322915,1.8,124.1222367,115.1652242,0.0685927,9.2500415,10.4200372,1986.37128,3789.4152263,0.083267,363.6661882,214.7418768,529.6674968,18.0263628,21.5915548,2.5977602,66.6247675),(35633,'hindlimb',252,7,226,112.9265018,124.2242705,116.0273336,1.8,124.0094809,115.7645351,0.0231379,10.8480765,10.3744103,2459.8593462,4125.1424559,0.0100743,397.6266927,226.7553472,552.2248235,20.5952915,23.0033622,0.9983365,72.9531788),(35634,'hindlimb',252,7,227,142.2458602,124.5331747,117.4014056,1.8,124.1287718,117.0433464,0.2542114,11.8063501,12.4833314,4073.488501,5650.5563006,1.4993496,452.6481037,345.0252175,670.7781888,22.2893477,26.0413617,0.6567017,88.040684),(35635,'hindlimb',252,7,228,158.8669164,124.3448572,118.0325274,1.8,123.9062224,117.6717783,0.1765009,12.3189925,12.5645955,5161.4698335,6543.3677457,0.8163225,520.7782239,418.9847371,793.5367321,22.759591,27.4058766,0.8519663,89.6551762),(35636,'hindlimb',252,7,229,162.5245278,124.2390293,118.5203274,1.8,123.7547912,118.1452537,0.1116724,12.8782503,12.7676151,5706.6392804,6820.9876186,0.3363981,534.2413264,443.1222509,817.0328433,23.1030977,28.7216779,0.8913825,93.8046106),(35637,'hindlimb',252,7,230,166.6774,124.2818391,118.8113832,1.8,123.7174961,118.3051475,0.1446341,13.3364698,13.0119744,5955.7829625,7115.7893814,0.5770809,546.8646933,446.5786728,838.3261618,23.385434,29.2219433,0.942,93.9520562),(35638,'hindlimb',252,7,231,165.8778325,124.1735234,118.9883078,1.8,123.7226245,118.4674375,0.0891339,13.3021381,13.1093909,5973.9466445,7110.0254376,0.2190648,542.3612341,449.0967237,835.652027,23.7959704,29.6609241,0.8983178,96.634444),(35639,'hindlimb',252,7,232,159.4722848,124.1887114,119.0601865,1.8,123.7515391,118.5502914,0.026344,13.06967,13.2236813,5936.3362802,6995.622304,0.0184415,529.0222998,454.2070506,813.9191178,23.7959704,29.9304758,0.887087,97.7455254),(35640,'hindlimb',252,7,233,141.0407742,124.2458498,119.2599155,1.8,123.8336598,118.5928196,0.0348647,12.9119423,13.2366701,5654.0887473,6768.8666695,0.028562,511.3723181,437.8960665,785.7286906,23.4265269,29.9982547,0.9072406,97.7455254),(35641,'hindlimb',252,7,234,135.9872346,124.1819036,119.3863739,1.8,123.9887181,118.5622478,0.0286577,13.0031077,13.1068122,5441.7154751,6597.7426725,0.0186084,503.3827112,418.4934543,767.6735789,23.4452696,29.9982547,0.9072406,98.6049014),(35642,'hindlimb',252,7,235,128.7392065,124.1327977,119.4103956,1.8,124.1289802,118.5730936,0.0645353,12.8386389,13.3845901,5002.7432946,6294.179223,0.0892381,470.2556578,389.6630567,722.7975676,23.109629,29.8749061,0.8668502,98.4574558),(35643,'hindlimb',252,7,236,129.3129637,124.2240592,119.3513245,1.8,124.3203662,118.5417171,-0.0068529,12.3943605,12.8071329,4802.2934971,6093.0300076,0.0010122,475.752853,387.4579483,707.5527541,22.6800064,29.5486662,0.8574382,96.5301842),(35644,'hindlimb',252,7,237,124.4531756,124.1652419,119.166603,1.8,124.4400375,118.4806338,0.0150943,12.1277252,13.0053705,4336.5874331,5566.8138525,0.0047254,428.039619,357.576326,662.7910752,22.2353857,28.6637647,0.8703,95.2716572),(35645,'hindlimb',252,7,238,117.0271176,124.2699109,118.9980896,1.8,124.5957265,118.4720455,0.0739017,11.616939,13.2433905,3890.1082916,4951.4040171,0.1063293,373.8773707,334.8651723,605.449424,21.2837034,27.6907163,0.840288,92.2333042),(35646,'hindlimb',252,7,239,109.9760301,124.6861284,118.8138899,1.8,124.8022163,118.3746594,0.1200335,11.5430427,12.7684505,3295.7464244,4171.0589269,0.2628239,326.6691534,285.5179957,528.8035105,20.6067084,25.9134285,2.274027,87.6847188),(35647,'hindlimb',252,7,240,103.8877133,124.8210646,118.6743718,1.8,124.919039,118.3193186,0.1377019,11.0913267,12.6404994,2859.4260337,3670.1352262,0.3262464,290.3473288,257.8073952,475.8187358,19.765648,25.2640467,2.2960262,85.861707),(35648,'hindlimb',252,7,241,92.5818144,125.0876916,118.5363067,1.8,125.140231,118.2431667,0.0772063,10.223076,11.6249764,2214.2036256,3057.6274754,0.0917944,263.0222528,216.5887859,398.4329586,18.8885454,24.375091,0.7105383,84.142955),(35649,'hindlimb',252,7,242,82.4240454,125.2207466,118.4673557,1.8,125.4369078,118.1445149,0.0732142,9.696944,11.0445241,1726.9742654,2611.2064541,0.0735051,236.4254375,178.094694,342.376269,18.0294639,23.1234432,2.4087776,80.705451),(35650,'hindlimb',252,7,243,69.6682835,125.3819453,118.5558361,1.8,125.7994542,118.1800306,0.0125782,8.626384,10.0451283,1109.2515727,2063.453181,0.001837,205.4183007,128.5882436,272.013693,16.3239205,21.1422216,2.485897,74.689819),(35651,'hindlimb',252,7,244,54.3721562,125.6257145,118.8653926,1.8,126.2084462,118.3687465,0.0109415,8.489772,9.7741675,667.7713937,1690.0200543,0.0010848,172.9068032,78.655987,220.1863321,6.7126658,13.5879276,1.2490458,34.4108163),(35652,'hindlimb',252,7,245,34.7340489,126.5518445,119.0428845,1.8,127.1586974,118.5687467,0.0567925,7.5190152,9.2332079,241.7647828,1007.1796092,0.0186517,109.082306,32.1537829,131.6206217,5.1640263,9.4237936,1.1479424,23.0735945),(35653,'hindlimb',252,7,246,16.2186148,130.145926,119.0061577,1.8,129.5873588,118.6652549,0.6173041,7.5034098,9.4099333,73.5088529,117.009399,0.9056867,12.4346683,9.7967264,16.4448774,2.4306824,2.8824347,0.4636476,7.5437526),(35654,'hindlimb',252,7,247,4.3724721,130.5711599,118.7050007,1.8,130.5437374,118.5034274,1.3080756,1.7407728,3.2210741,2.2483651,8.3895018,0.6795924,2.6045666,1.2915902,3.3024181,3.8562708,6.3877713,1.9138203,15.990067),(35655,'hindlimb',252,7,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35656,'hindlimb',252,7,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35657,'hindlimb',252,7,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35658,'hindlimb',252,7,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35659,'hindlimb',252,7,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35660,'hindlimb',252,7,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35661,'hindlimb',252,7,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35662,'hindlimb',252,7,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35663,'hindlimb',252,7,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35664,'hindlimb',252,7,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35665,'hindlimb',252,7,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35666,'hindlimb',252,7,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35667,'hindlimb',252,7,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35668,'hindlimb',252,7,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35669,'hindlimb',252,7,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35670,'hindlimb',252,7,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35671,'hindlimb',252,7,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35672,'hindlimb',252,7,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35673,'hindlimb',252,7,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35674,'hindlimb',252,7,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35675,'hindlimb',252,7,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35676,'hindlimb',252,7,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35677,'hindlimb',252,7,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35678,'hindlimb',252,7,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35679,'hindlimb',252,7,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35680,'hindlimb',252,7,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35681,'hindlimb',252,7,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35682,'hindlimb',252,7,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35683,'hindlimb',252,7,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35684,'hindlimb',252,7,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35685,'hindlimb',252,7,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35686,'hindlimb',252,7,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35687,'hindlimb',252,7,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35688,'hindlimb',252,7,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35689,'hindlimb',252,7,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35690,'hindlimb',252,7,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35691,'hindlimb',252,7,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35692,'hindlimb',252,7,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35693,'hindlimb',252,7,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35694,'hindlimb',252,7,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35695,'hindlimb',252,7,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35696,'hindlimb',252,7,289,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35697,'hindlimb',252,7,290,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35698,'hindlimb',252,7,291,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35699,'hindlimb',252,7,292,0.012029,108.281376,126.328272,1.8,108.281376,126.328272,0.7853982,0.00000000000001005,0.00000000000001005,0.0001851,0.0001851,0.0010024,18418360673.4846,18418360673.4846,26047495461.1211,7.0632059,27.8337015,2.9865959,64.8449415),(35700,'hindlimb',252,7,293,2.0001216,108.9212624,124.346159,1.8,109.0984876,124.3136692,-1.4157427,2.0484036,3.7552863,0.8643218,6.8272762,0.3254033,1.8180441,0.421949,2.0479382,7.9509954,31.8694118,0.067465,75.7651241),(35701,'hindlimb',252,7,294,4.8658306,109.5666702,124.5348956,1.8,109.8632362,124.2520804,-1.2294062,2.8094028,4.1446479,4.7730617,20.2488885,0.7200705,4.885551,1.6989595,5.4277836,8.1766167,35.3286118,0.0730406,83.3088767),(35702,'hindlimb',252,7,295,7.169196,110.3515428,124.1019142,1.8,110.6296072,123.974567,-0.9467105,2.8898569,5.2829419,9.6225303,38.4872359,0.7868533,7.2851901,3.3297602,8.5487715,8.5462915,39.5896345,0.0542944,91.5034857),(35703,'hindlimb',252,7,296,8.4079633,110.870069,123.9131852,1.8,111.1242847,123.7989194,-0.8053287,3.170445,5.8638005,12.2218589,54.3827165,0.7285855,9.2743122,3.8549348,11.0195672,8.8685253,41.7881245,0.0720401,96.8682612),(35704,'hindlimb',252,7,297,10.5277039,111.5831248,123.6831033,1.8,111.7051457,123.5990665,-0.7379927,3.1543046,6.4718966,15.5316207,81.4236297,0.7942548,12.5811079,4.9239444,14.8816204,9.0787153,44.3911586,0.0775143,103.7000834),(35705,'hindlimb',252,7,298,11.0181531,112.1426812,123.3766926,1.8,112.1077299,123.4198879,-0.6768704,3.1981269,6.5473647,17.1115568,96.4077818,0.7204448,14.7246696,5.3504934,17.2167464,9.3295364,45.8378624,0.1127276,106.6341766),(35706,'hindlimb',252,7,299,13.4546771,112.9846854,122.902509,1.8,112.9651281,123.0650898,-0.5485886,3.7704542,6.7274012,26.3068923,116.7180798,0.6098219,17.3496534,6.977115,21.1834402,8.9368616,47.5946139,0.1176362,112.1895836),(35707,'hindlimb',252,7,300,13.850964,113.6789206,122.5583848,1.8,113.4942463,122.7514097,-0.4423005,3.8145592,6.7521517,27.9153319,137.2925893,0.4229181,20.3331612,7.3181016,24.4523297,9.1292354,48.8750032,0.1145407,114.8719714),(35708,'hindlimb',252,7,301,15.1364488,114.6686213,122.163189,1.8,114.4376332,122.4233195,-0.2988587,3.7777363,7.0774171,28.9294264,164.7808765,0.2186936,23.282629,7.6578733,26.9342042,9.1217363,50.5828743,0.1106572,119.6290764),(35709,'hindlimb',252,7,302,15.2345274,115.1605532,122.0261293,1.8,114.9522507,122.2783681,-0.2352728,3.8305734,7.3920348,29.8375595,172.8607707,0.1379727,23.3847343,7.7893194,26.9900686,9.2117254,51.4855167,0.1171087,120.4884524),(35710,'hindlimb',252,7,303,16.2289094,115.6886463,122.0742577,1.8,115.616764,122.3155772,-0.0799174,3.3589343,7.5860245,35.648509,212.4413941,0.0172384,28.0043117,10.6130413,31.6880728,9.2117254,51.9638311,0.124355,124.0302162),(35711,'hindlimb',252,7,304,16.3648656,115.6493964,122.1400656,1.8,115.8769193,122.3461774,-0.008294,2.9412829,7.3846846,32.6177065,222.4672418,0.0001876,30.1254901,11.0896191,33.3655759,9.2042263,52.4852943,0.0491407,125.393003),(35712,'hindlimb',252,7,305,16.6158529,115.7474014,122.219572,1.8,116.0203803,122.3490377,0.0447557,3.0254638,8.0439833,28.0454623,268.3113711,0.0055434,33.3555357,9.269806,36.6864148,9.2192245,53.3436496,0.0483494,126.1049334),(35713,'hindlimb',252,7,306,16.4737983,116.030435,122.2097434,1.8,116.3457604,122.3476424,0.0591371,2.7281879,8.2007972,24.5076189,304.7736669,0.0095908,37.1639072,8.9831126,40.0354625,9.0899632,53.7951529,0.0559416,125.7489682),(35714,'hindlimb',252,7,307,16.1526509,116.2338002,122.2036881,1.8,116.534515,122.3407192,0.0726235,2.8288241,8.0372969,20.1543489,324.3509596,0.0141737,40.3557268,7.1246384,42.5242038,9.112459,53.8208877,0.0639128,125.5404486),(35715,'hindlimb',252,7,308,15.5551153,116.2147061,122.274821,1.8,116.5403791,122.3986253,0.0779312,2.9378085,8.4507399,17.8304204,327.9759033,0.0157132,38.8103179,6.0692929,40.8769789,9.123707,54.183299,0.0396617,125.393003),(35716,'hindlimb',252,7,309,14.5024345,116.0821822,122.3723419,1.8,116.4635674,122.4804936,0.0770655,2.643939,8.5750226,15.0356952,340.0721096,0.0143268,39.6584506,5.6868541,41.3884154,9.2174223,53.850039,0.071876,124.533627),(35717,'hindlimb',252,7,310,14.4134755,116.1830381,122.4515828,1.8,116.5663782,122.5794372,0.0715207,2.7049231,8.8956184,14.7391443,370.4919804,0.012267,41.6488165,5.4490068,43.2907672,8.9005996,54.2497054,0.063407,124.8895922),(35718,'hindlimb',252,7,311,13.9518401,116.1688433,122.5790531,1.8,116.5273573,122.6933801,0.064977,2.3812027,9.3285674,13.6584499,380.4158361,0.0098037,40.779663,5.7359459,42.2393291,8.8295716,54.1679629,0.0317354,124.2819216),(35719,'hindlimb',252,7,312,14.3820881,116.0992915,122.6963246,1.8,116.5628868,122.8009618,0.0538749,2.4094278,9.3896188,13.5068511,406.4424992,0.0069506,43.2863683,5.6058335,44.5176229,8.8295716,52.0561293,3.0920465,120.3841926),(35720,'hindlimb',252,7,313,14.6558467,115.7577569,122.8985924,1.8,116.5129075,122.9406294,0.0438223,2.5419746,9.7202971,12.7942529,394.625148,0.0046878,40.5980542,5.0331946,41.5846369,8.8558034,51.2482881,3.0744668,118.05777),(35721,'hindlimb',252,7,314,16.0431587,115.712725,123.0335058,1.8,116.6761226,123.0279666,0.0290936,2.5490113,10.1773963,12.6184697,426.7499886,0.0022626,41.9311555,4.9503389,42.9278871,8.8820352,51.2482881,3.0744668,117.5543592),(35722,'hindlimb',252,7,315,15.3972831,115.5742354,123.1913788,1.8,116.9095766,123.1876135,0.0119068,2.5615718,10.3251536,10.6946856,431.3397868,0.0003638,41.7756289,4.1750481,42.5470517,8.9082671,50.8504478,3.0654689,117.4069136),(35723,'hindlimb',252,7,316,12.4939764,116.5059691,123.2745644,1.8,117.540582,123.2805292,0.0110636,2.6264876,9.3925477,8.1846807,392.4958186,0.0002549,41.7880036,3.1162076,42.2902836,9.2085949,50.4220148,3.0648208,117.259468),(35724,'hindlimb',252,7,317,8.3192841,119.4126544,123.296604,1.8,120.1802204,123.185334,-0.0245804,2.4152156,11.1390629,5.8115623,203.4650186,0.0008376,18.2659009,2.4062291,18.5865424,8.3197601,33.7380335,3.026716,78.6128457),(35725,'hindlimb',252,7,318,6.7720698,121.109636,123.3720193,1.8,121.4043658,123.1963239,-0.1653829,3.4342511,12.6447346,3.4586961,59.1057682,0.0305906,4.6743384,1.007118,4.8506649,8.3627234,32.0312158,3.0205654,75.6787525),(35726,'hindlimb',252,7,319,6.3611242,121.727347,123.3654033,1.8,122.2101422,123.2070184,-0.2693513,1.4616805,4.7900214,2.2235437,35.6428957,0.0750745,7.4410723,1.5212242,7.9046224,3.2691226,9.5115493,0.3217506,22.6133696),(35727,'hindlimb',252,7,320,6.4161221,121.9882726,123.3347317,1.8,122.4892563,123.1549205,-0.2833134,1.6362024,4.5313167,2.3529993,32.8536128,0.0835612,7.2503457,1.4380857,7.7693448,3.5171593,9.1049255,0.3366748,22.1099587),(35728,'hindlimb',252,7,321,6.8373064,122.2502901,123.2210243,1.8,122.8068446,123.0183316,-0.30232,1.9461236,4.5295021,2.8692357,35.2782337,0.1010173,7.7885455,1.4743337,8.3450296,4.0571652,9.1049255,0.3366748,22.4659239),(35729,'hindlimb',252,7,322,6.4097439,122.3238479,123.1941158,1.8,122.8095671,123.0261028,-0.3054691,1.9314619,4.4492928,2.8565821,32.269626,0.0966214,7.2527539,1.4789741,7.8157319,4.0571652,8.9721488,0.2914568,22.2142185),(35730,'hindlimb',252,7,323,6.394302,122.4592941,123.1215456,1.8,122.913905,122.9667897,-0.3027489,1.9119689,4.4281888,3.0317114,33.523419,0.0947322,7.5704583,1.5856489,8.2428935,3.9415764,8.9721488,0.2914568,22.4659239),(35731,'hindlimb',252,7,324,6.5200754,122.5368808,123.061307,1.8,123.0580511,122.9006082,-0.3170294,1.9655533,4.1978425,3.4893341,32.7788216,0.1056091,7.8084924,1.7752427,8.3521478,4.170365,8.7005189,0.5743048,22.1099587),(35732,'hindlimb',252,7,325,6.9279997,122.5857456,122.9696461,1.8,123.1040883,122.8023925,-0.3511361,2.0544471,4.2403628,4.1721381,35.4914343,0.1366107,8.3699051,2.0307839,8.7596668,4.4206031,8.9412281,0.614663,22.7176293),(35733,'hindlimb',252,7,326,7.0346386,122.6294038,122.9570292,1.8,123.0744752,122.8347217,-0.3237697,1.8770348,4.2085329,4.1784336,35.616507,0.1186682,8.4629271,2.2260821,9.4054536,4.170365,8.7005189,0.3529904,22.1099587),(35734,'hindlimb',252,7,327,7.1080996,122.5202337,122.9069617,1.8,123.0289893,122.7255034,-0.3512176,2.1206067,4.2802643,4.4855172,34.7807982,0.1402244,8.1258528,2.1152047,9.0742316,4.4206031,8.7005189,0.3529904,22.2142185),(35735,'hindlimb',252,7,328,7.0609906,122.5816646,122.830457,1.8,123.0548849,122.6848758,-0.3682119,2.020019,4.2470988,4.6298853,36.4954459,0.1524731,8.5930296,2.2920009,9.2680725,4.3490597,8.9412281,0.614663,22.4659239),(35736,'hindlimb',252,7,329,7.7760191,122.5558974,122.7444316,1.8,123.0725591,122.507905,-0.3889852,2.1035043,4.5757721,5.1169328,45.6946953,0.1864045,9.9862261,2.4325754,10.7313954,4.4206031,9.4335845,0.5247958,24.0372303),(35737,'hindlimb',252,7,330,7.6303278,122.3694712,122.7606833,1.8,122.8762515,122.5481789,-0.3799017,2.0012174,4.5053776,4.6769164,40.4924106,0.1748799,8.987573,2.3370356,9.9193085,4.2589308,9.1049255,0.3366748,23.0735945),(35738,'hindlimb',252,7,331,7.8578165,122.2643663,122.6708178,1.8,122.8334763,122.4467571,-0.3858552,1.8620047,4.8019557,4.556189,43.0877992,0.1854976,8.9729689,2.4469267,9.5966813,4.1119689,9.3845276,0.2782997,23.1778543),(35739,'hindlimb',252,7,332,7.9445375,122.2161751,122.6306481,1.8,122.7418095,122.3722778,-0.3956119,1.8440456,4.7530989,4.5561836,43.1529009,0.1966435,9.0788982,2.4707543,10.0013513,4.0360605,9.2557628,0.3805064,23.4295597),(35740,'hindlimb',252,7,333,8.3969413,122.0626963,122.5739145,1.8,122.6523605,122.261483,-0.4107472,1.8441505,5.0360669,4.6649313,49.9580875,0.2231293,9.9200604,2.5295827,10.8304809,4.0037015,9.6560368,0.363979,24.0372303),(35741,'hindlimb',252,7,334,8.4780115,122.111119,122.4688241,1.8,122.7144857,122.1553405,-0.4463153,1.8438701,5.1057069,4.7292215,54.1926467,0.2632665,10.6141318,2.5648344,11.3652285,4.2214331,9.8921606,0.6000502,24.6449009),(35742,'hindlimb',252,7,335,8.3774711,122.2165808,122.3450102,1.8,122.8734651,121.9794834,-0.4589163,1.9177591,4.9717895,4.3224833,51.157967,0.273983,10.2896485,2.2539241,11.0370451,4.1804238,9.6560368,0.5633163,23.6812651),(35743,'hindlimb',252,7,336,8.1197699,122.1536296,122.3178832,1.8,122.7751967,121.9721247,-0.4574189,1.8710331,5.0165672,3.9615407,47.0326954,0.2639472,9.3754739,2.1173012,10.1540934,4.0189391,9.6081158,0.4636476,23.1778543),(35744,'hindlimb',252,7,337,8.2302132,122.2055608,122.1284663,1.8,122.8176918,121.7595486,-0.4832117,2.0129537,4.8748618,4.2240673,49.1159333,0.2961189,10.0753489,2.0984424,10.883094,4.2277864,9.6081158,0.4636476,23.7855249),(35745,'hindlimb',252,7,338,8.0719894,122.2297125,122.065124,1.8,122.8348497,121.7400282,-0.4831893,1.9681687,4.8240572,4.245222,48.9555543,0.2904012,10.1482118,2.1569401,10.9567268,4.2277864,9.6081158,0.4636476,23.7855249),(35746,'hindlimb',252,7,339,7.9046459,122.2317,121.9507481,1.8,122.8340731,121.5748485,-0.4830986,2.0677437,4.7692168,4.2408485,48.6709162,0.2842825,10.2052221,2.0509547,10.9922151,4.4031358,9.6081158,0.4636476,23.7855249),(35747,'hindlimb',252,7,340,8.0368534,122.2729064,121.8764517,1.8,122.9136847,121.5014435,-0.4827089,2.2034827,4.8796248,4.54636,51.2052473,0.2886079,10.4936854,2.063261,11.0532749,4.5744735,9.8172189,0.4048918,24.1414901),(35748,'hindlimb',252,7,341,8.8376518,122.3496939,121.7163979,1.8,122.9421144,121.3882112,-0.4754703,2.1237289,4.9552549,4.9757024,61.0573109,0.308642,12.3217296,2.3429085,13.1083086,4.5513817,10.2135672,0.3883187,24.7491607),(35749,'hindlimb',252,7,342,9.4237738,122.4037347,121.6466027,1.8,122.9610314,121.3719966,-0.4711963,2.101589,5.0632042,5.2947915,67.2237966,0.3236641,13.2769278,2.5194229,14.22308,4.5513817,10.3838797,0.4266275,24.7491607),(35750,'hindlimb',252,7,343,9.2701937,122.2895367,121.6015277,1.8,122.8853969,121.2767524,-0.4666956,2.2192245,4.9542261,5.7324229,67.8831088,0.3127824,13.7020611,2.5830749,14.5345871,4.6828328,10.2135672,0.3883187,25.0008661),(35751,'hindlimb',252,7,344,9.3534458,122.1860075,121.6150616,1.8,122.8360804,121.294412,-0.4648137,2.2300761,5.0548106,6.0913019,68.9881671,0.313237,13.6480222,2.7314323,14.5265413,4.9110142,10.4635866,0.3347368,26.2162073),(35752,'hindlimb',252,7,345,9.8795905,122.2833983,121.526956,1.8,122.8399173,121.3093128,-0.4364333,2.2459074,5.1656316,6.7332324,80.4670173,0.29422,15.5773823,2.9980009,16.174137,4.892885,10.8703421,0.3217506,26.2162073),(35753,'hindlimb',252,7,346,10.1790856,122.1801384,121.5814707,1.8,122.84473,121.3126877,-0.4196349,2.2760134,5.3073436,6.7371146,83.1492927,0.2816159,15.6668381,2.9600505,16.3383178,4.8521613,10.8703421,0.3217506,26.4679127),(35754,'hindlimb',252,7,347,10.8254646,122.1580523,121.5659833,1.8,122.6965587,121.3759357,-0.395903,2.3690297,5.3546366,7.2720141,93.6687363,0.2683261,17.4930145,3.0696171,18.2828322,4.9477863,11.2787985,0.3097029,27.3272887),(35755,'hindlimb',252,7,348,11.0724236,122.1221749,121.6197316,1.8,122.6674273,121.4390537,-0.3740575,2.3911016,5.5056556,6.988449,99.2054615,0.2463869,18.0188279,2.9226901,19.0832624,4.6934817,11.5697035,0.2629947,27.8306995),(35756,'hindlimb',252,7,349,11.5962184,121.9862141,121.6816838,1.8,122.6251007,121.5046777,-0.3417377,2.4774564,5.652715,7.27349,108.8896702,0.2170593,19.2632514,2.9358701,20.3476108,4.828343,11.8222779,0.3332443,28.6900755),(35757,'hindlimb',252,7,350,12.0602036,121.8589523,121.7987222,1.8,122.5854634,121.606227,-0.3174688,2.4268126,5.8003962,7.4160719,116.4467725,0.1958691,20.0756582,3.0558898,21.1569287,4.8102809,12.1001239,0.2880554,29.1934863),(35758,'hindlimb',252,7,351,12.4294113,121.6209277,121.963108,1.8,122.4632835,121.7757827,-0.2810508,2.4352783,5.9805578,7.507403,125.3000118,0.159369,20.951225,3.08277,21.957567,4.7145044,12.4015431,0.2449787,29.8011569),(35759,'hindlimb',252,7,352,12.9945523,121.5369762,122.0667983,1.8,122.3725513,121.9039971,-0.2636652,2.2681771,6.103429,7.4574714,136.3680638,0.1471053,22.3428605,3.2878699,23.4020764,4.6046734,12.5274503,0.3868757,30.3045677),(35760,'hindlimb',252,7,353,12.8641352,121.2004761,122.2369555,1.8,122.0356675,122.0848358,-0.2456202,2.2978453,6.3798718,7.0399418,140.340553,0.126767,21.997394,3.0637144,22.9089456,4.5037302,12.9263977,0.3743336,30.5562731),(35761,'hindlimb',252,7,354,13.618328,121.1710857,122.3559202,1.8,121.9203019,122.2242276,-0.2259266,2.2252885,6.5138858,7.4393083,159.1448556,0.1138952,24.4316313,3.3430759,24.9371803,4.4245678,13.3272566,0.3625442,31.6673545),(35762,'hindlimb',252,7,355,14.0676546,121.0098198,122.5876689,1.8,121.8881627,122.4748143,-0.17512,2.0713102,6.6782394,7.8037145,172.4008224,0.0711702,25.8153101,3.7675258,26.7208616,4.4006493,13.7298596,0.3514448,32.1707653),(35763,'hindlimb',252,7,356,15.1149644,121.1555685,122.7553243,1.8,122.1826127,122.6584045,-0.1263202,2.0648382,7.3540144,8.5192754,196.5713182,0.0399844,26.7297977,4.1258803,27.8775065,4.3584557,14.4952048,0.2090229,33.8895173),(35764,'hindlimb',252,7,357,16.8134089,121.3662623,122.9206547,1.8,122.0624538,122.9011219,-0.1054805,2.1114245,7.5918563,9.5650186,257.4640393,0.0310626,33.9131866,4.5301257,35.1705953,4.29688,15.3369125,0.1973956,34.7488933),(35765,'hindlimb',252,7,358,17.5419211,121.2258342,123.1351182,1.8,121.9074109,123.1166514,-0.0752049,2.1206535,7.7417836,9.3697417,276.5221552,0.0165044,35.7181458,4.4183275,36.844278,4.277098,15.7584815,0.192048,35.6082693),(35766,'hindlimb',252,7,359,16.5872629,120.2338393,123.483194,1.8,120.7673771,123.5054338,-0.0190925,2.0360643,7.3934612,7.931491,212.8374265,0.0010076,28.7872513,3.8955012,29.8045349,3.867192,14.7665205,0.1460123,33.177587),(35767,'hindlimb',252,7,360,15.8539391,119.5025919,123.713954,1.8,119.9861614,123.7754198,0.0198287,1.7300162,6.8335755,7.299386,173.0170874,0.0010388,25.3186767,4.2192588,26.3560443,3.867192,13.8570216,0.124355,31.2071296),(35768,'hindlimb',252,7,361,15.240458,118.504923,123.9250974,1.8,118.6951234,123.9863599,0.0626872,1.8294456,6.1354828,6.9696064,134.008872,0.0099686,21.8416182,3.8096823,22.9500321,3.867192,12.5274503,3.038511,28.6290016),(35769,'hindlimb',252,7,362,15.1928454,117.8338291,124.0595976,1.8,118.0364549,124.1403472,0.0846785,1.7681134,5.9416272,6.9475371,115.7148367,0.0181132,19.4752772,3.9293503,20.6439144,3.867192,12.1001239,3.034857,27.7696256),(35770,'hindlimb',252,7,363,15.1665494,116.9226988,124.1807228,1.8,116.8923235,124.2289392,0.1047762,1.7501767,5.6476445,7.0770716,100.8141215,0.0276485,17.8506494,4.0436325,19.0959968,3.867192,11.3765933,2.9516044,26.302579),(35771,'hindlimb',252,7,364,15.012186,116.3255939,124.2715878,1.8,116.2381867,124.2834626,0.1128872,1.8124852,5.4900376,7.2331509,93.5848997,0.0317495,17.046313,3.9907364,18.3609156,3.867192,10.9549375,2.9441971,25.443203),(35772,'hindlimb',252,7,365,15.3727215,115.5458842,124.3792557,1.8,115.3588806,124.4317181,0.12588,1.9285494,5.5808594,8.1136405,94.3362436,0.0403848,16.9035335,4.2071209,18.3558343,4.217887,10.9549375,2.9441971,25.5474627),(35773,'hindlimb',252,7,366,15.7879752,114.8610758,124.4323869,1.8,114.8007801,124.5107411,0.130651,1.9532136,5.3344276,8.9603769,95.8962781,0.044661,17.9768637,4.5875049,19.6565329,4.29688,10.8788312,2.9829374,25.5474627),(35774,'hindlimb',252,7,367,15.7989971,114.083707,124.4978214,1.8,113.9988092,124.5766477,0.1370715,2.092366,5.4244144,10.3269673,96.9341837,0.0491644,17.8699814,4.9355454,19.773761,4.5216268,10.9549375,2.9441971,26.2593931),(35775,'hindlimb',252,7,368,16.0151282,113.5353849,124.5522478,1.8,113.4806008,124.6728424,0.139205,2.257561,5.3144815,11.6624017,99.6299067,0.0513903,18.7468725,5.1659298,20.939748,4.721716,10.6298941,2.896614,25.2957573),(35776,'hindlimb',252,7,369,16.2309795,112.9029966,124.6142034,1.8,112.832968,124.726909,0.1455939,2.3552064,4.9043964,13.6890096,97.3970384,0.0569389,19.8591286,5.8122336,22.6404486,4.726568,10.9549375,2.9441971,25.9034279),(35777,'hindlimb',252,7,370,15.9218612,112.5462655,124.6606336,1.8,112.4545239,124.7445005,0.1500267,2.3901015,4.8259126,14.84507,88.706166,0.0592815,18.3812209,6.2110626,21.4537753,4.726568,10.9549375,2.9441971,25.9034279),(35778,'hindlimb',252,7,371,15.4448958,112.0935318,124.7350084,1.8,111.9831266,124.8415975,0.1606194,2.4691501,4.4819904,16.5853525,77.7023293,0.0658403,17.3365676,6.7170289,20.9305646,5.0089663,10.9549375,2.9441971,26.2593931),(35779,'hindlimb',252,7,372,15.1607866,111.8264388,124.7909777,1.8,111.71888,124.9247802,0.1789101,2.7598865,4.3195588,17.4519735,67.8107865,0.0800206,15.6985447,6.3234388,19.676322,5.156256,11.0472442,2.9060477,26.8670637),(35780,'hindlimb',252,7,373,13.6353365,111.4999791,124.8185563,1.8,111.3852399,124.9785462,0.2234831,2.9282759,3.9000697,16.5730514,52.4003397,0.1116251,13.4357443,5.6596619,17.288193,5.156256,11.5697035,2.8785979,27.9781451),(35781,'hindlimb',252,7,374,13.0057421,111.3136934,124.8622566,1.8,111.1858493,124.9902562,0.2744747,3.0602301,3.6825969,15.046978,43.6586464,0.159241,11.8553964,4.9169433,15.1776748,14.9304929,33.7899824,3.0140831,95.8793278),(35782,'hindlimb',252,7,375,11.8834047,111.0603455,124.892849,1.8,110.9018676,125.0059223,0.345617,3.1005515,3.4384677,13.3914601,32.4754652,0.2273098,9.4447493,4.3190575,12.4209093,14.7718989,32.9965694,2.997854,93.19694),(35783,'hindlimb',252,7,376,11.2221432,110.8528887,124.9216392,1.8,110.6979672,124.9875162,0.4157536,2.7184698,3.3462206,12.0140914,26.3437322,0.30509,7.8726826,4.4194317,10.7774636,15.0378111,32.6364937,2.9829374,92.2333042),(35784,'hindlimb',252,7,377,10.4601735,110.4816955,124.946752,1.8,110.3331362,125.0356273,0.5326325,3.0478007,3.1577479,10.9143907,18.8500636,0.44955,5.9694643,3.581071,8.966185,15.2793798,31.7882009,2.9786662,90.5145522),(35785,'hindlimb',252,7,378,9.9513731,110.2266222,124.9724229,1.8,110.10755,125.019315,0.6507292,2.9408922,3.0690082,10.1805089,15.3132303,0.608615,4.9896348,3.4617076,8.0254644,15.2760002,31.3642808,2.976444,89.6551762),(35786,'hindlimb',252,7,379,8.9837347,109.9656395,124.9831776,1.8,109.9016578,124.9989247,0.9149413,2.6791918,3.0259562,8.3973712,11.3873158,0.9404453,3.7632123,3.1342926,6.5236267,15.2721488,30.5924579,2.9579703,88.2923894),(35787,'hindlimb',252,7,380,8.3695823,109.7641332,125.0052823,1.8,109.7511043,124.9513173,1.2130102,2.1531283,2.9023529,7.3686049,9.663946,1.2238547,3.3296936,3.4222787,5.7840458,15.2245133,30.1700955,2.9553698,88.2923894),(35788,'hindlimb',252,7,381,7.1937576,109.5715094,124.9845751,1.8,109.5591324,124.9148246,1.4114175,1.8236295,2.6962629,5.1837254,8.3139695,1.1687611,3.0835159,2.8425321,4.7625002,15.350724,29.7479429,2.9526955,87.4330134),(35789,'hindlimb',252,7,382,6.5839692,109.451821,125.0016425,1.8,109.5056925,124.9391437,1.5101033,1.8577724,2.606879,4.4224961,7.6408146,1.093291,2.9310201,2.3805371,4.3126182,15.1793863,29.6702598,2.9669205,87.4330134),(35790,'hindlimb',252,7,383,5.9582913,109.3417788,124.9467703,1.8,109.4521201,124.8523871,1.5672098,1.9486103,2.4894775,3.5856723,7.0085795,0.9930358,2.8152813,1.8401177,3.9202735,15.1898913,29.5330411,2.9955804,87.2855678),(35791,'hindlimb',252,7,384,5.1791452,109.2794819,124.9081325,1.8,109.3589013,124.8937751,-1.5621793,1.5884981,2.4420636,2.9966414,6.4400097,0.8631268,2.6371179,1.8864621,3.5707302,15.1898913,28.9904096,2.9325697,85.6100016),(35792,'hindlimb',252,7,385,4.4599764,109.263403,124.800493,1.8,109.3044427,124.7868516,-1.5547154,1.6066428,2.4026376,2.420111,5.6909137,0.7431372,2.368611,1.5063156,3.1422775,15.2402368,28.904304,2.9471125,83.0318736),(35793,'hindlimb',252,7,386,4.4238893,109.2673271,124.7108094,1.8,109.3295543,124.7071764,1.5309438,1.6291875,2.7165722,2.5542725,5.773586,0.7361445,2.1253203,1.5678198,2.9168751,15.1898913,28.904304,2.9471125,78.7781794),(35794,'hindlimb',252,7,387,5.0710516,109.4498683,124.7303477,1.8,109.5246066,124.7642077,1.3849552,1.9093732,2.8683889,3.7713046,6.4113441,0.81632,2.2351725,1.9751532,3.4622573,15.2263005,29.3260093,2.9499442,79.0298848),(35795,'hindlimb',252,7,388,5.2753215,109.6255273,124.6778186,1.8,109.7153348,124.7594112,1.1561416,2.2413867,2.9636799,4.6060557,7.4311434,0.7365163,2.5074042,2.0550027,4.0553627,15.5012206,29.6702598,2.9669205,80.1409662),(35796,'hindlimb',252,7,389,6.1086822,109.7110745,124.5223254,1.8,109.7587302,124.6481436,1.09136,2.2997588,2.8695834,4.9249914,9.2976415,0.8014811,3.2400667,2.1415252,4.9520492,15.5097621,29.501766,2.9213439,79.2815902),(35797,'hindlimb',252,7,390,6.0690703,109.7108279,124.3514973,1.8,109.785284,124.4998124,1.1167422,2.3401191,3.0981495,5.1761487,9.5940341,0.8169162,3.0966983,2.2119168,4.7658906,15.565056,29.4108802,2.9356013,79.38585),(35798,'hindlimb',252,7,391,5.946542,109.7548479,124.260328,1.8,109.8185073,124.2728572,1.1846181,2.1438514,3.0178149,5.4317123,9.6397838,0.8504884,3.1942926,2.5336236,4.958319,15.7223453,29.4202952,3.0244839,79.2384044),(35799,'hindlimb',252,7,392,5.6247791,109.7115693,124.0189693,1.8,109.7479198,124.0350458,1.1502018,2.2484425,3.1827835,5.2150527,8.6499454,0.7811773,2.7177297,2.3194068,4.3518512,15.9156394,28.7505907,2.976444,78.2747686),(35800,'hindlimb',252,7,393,5.5035935,109.6844186,123.6041904,1.8,109.731573,123.5938938,1.3699202,2.0501657,2.6632147,5.1227687,7.6079428,0.880748,2.8566765,2.4987097,4.5339774,16.328144,28.4763545,3.0509328,78.6307338),(35801,'hindlimb',252,7,394,5.5062231,109.5898341,123.2719532,1.8,109.5979841,123.2763854,-1.4687404,2.1666856,2.7462682,4.438512,6.8684334,0.9081787,2.5010061,2.0485261,3.8531165,16.328144,28.0484581,3.0495458,77.8756176),(35802,'hindlimb',252,7,395,5.4497706,109.4483041,122.9370118,1.8,109.4599488,122.952152,-1.4044238,1.8789696,2.6901743,3.4249717,5.9378454,0.8833848,2.2072345,1.8227925,3.3584254,16.1937821,27.2369323,0.1106572,73.9778886),(35803,'hindlimb',252,7,396,3.9221384,109.0937083,122.7344972,1.8,109.2423146,122.6798303,-1.3814453,1.7636484,2.4164162,1.6426827,4.3300968,0.6305312,1.7919499,0.9314117,2.4441734,16.2359399,26.696042,0.0644268,73.3270322),(35804,'hindlimb',252,7,397,2.2282258,108.8466079,122.2728744,1.8,108.9736511,122.1984929,-1.501659,1.163766,1.9414494,0.5795944,1.5530599,0.3695987,0.7999487,0.4980334,1.0453678,15.7120484,25.5835817,0.1347713,73.5787376),(35805,'hindlimb',252,7,398,1.2916392,108.7778828,122.0097271,1.8,108.8763286,122.031392,1.4619635,0.8788586,1.3423882,0.2621893,0.5439481,0.2127334,0.4052092,0.2983293,0.5751482,3.007816,4.0536685,2.5829933,10.6252914),(35806,'hindlimb',252,7,399,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35807,'hindlimb',252,7,400,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35808,'hindlimb',252,7,401,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35809,'hindlimb',252,7,402,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35810,'hindlimb',252,7,403,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35811,'hindlimb',252,7,404,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35812,'hindlimb',252,7,405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35813,'hindlimb',252,7,406,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35814,'hindlimb',252,7,407,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35815,'hindlimb',252,7,408,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35816,'hindlimb',252,7,409,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35817,'hindlimb',252,7,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35818,'hindlimb',252,7,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35819,'hindlimb',252,7,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35820,'hindlimb',252,7,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35821,'hindlimb',252,7,414,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35822,'hindlimb',252,7,415,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35823,'hindlimb',252,7,416,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35824,'hindlimb',252,7,417,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35825,'hindlimb',252,7,418,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35826,'hindlimb',252,7,419,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35827,'hindlimb',252,7,420,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35828,'hindlimb',252,7,421,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35829,'hindlimb',252,7,422,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35830,'hindlimb',252,7,423,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35831,'hindlimb',252,7,424,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35832,'hindlimb',252,7,425,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35833,'hindlimb',252,7,426,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35834,'hindlimb',252,7,427,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35835,'hindlimb',252,7,428,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35836,'hindlimb',252,7,429,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35837,'hindlimb',252,7,430,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35838,'hindlimb',252,7,431,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35839,'hindlimb',252,7,432,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35840,'hindlimb',252,7,433,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35841,'hindlimb',252,7,434,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35842,'hindlimb',252,7,435,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35843,'hindlimb',252,7,436,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35844,'hindlimb',252,7,437,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35845,'hindlimb',252,7,438,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35846,'hindlimb',252,7,439,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35847,'hindlimb',252,7,440,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35848,'hindlimb',252,7,441,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35849,'hindlimb',252,7,442,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35850,'hindlimb',252,7,443,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35851,'hindlimb',252,7,444,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35852,'hindlimb',252,7,445,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35853,'hindlimb',252,7,446,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35854,'hindlimb',252,7,447,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35855,'hindlimb',252,7,448,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35856,'hindlimb',252,7,449,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35857,'hindlimb',252,7,450,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35858,'hindlimb',252,7,451,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35859,'hindlimb',252,7,452,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35860,'hindlimb',252,7,453,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35861,'hindlimb',252,7,454,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35862,'hindlimb',252,7,455,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35863,'hindlimb',252,7,456,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35864,'hindlimb',252,7,457,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35865,'hindlimb',252,7,458,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35866,'hindlimb',252,7,459,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35867,'hindlimb',252,7,460,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35868,'hindlimb',252,7,461,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35869,'hindlimb',252,7,462,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35870,'hindlimb',252,7,463,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35871,'hindlimb',252,7,464,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35872,'hindlimb',252,7,465,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35873,'hindlimb',252,7,466,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35874,'hindlimb',252,7,467,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35875,'hindlimb',252,7,468,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35876,'hindlimb',252,7,469,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35877,'hindlimb',252,7,470,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35878,'hindlimb',252,7,471,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35879,'hindlimb',252,7,472,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35880,'hindlimb',252,7,473,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35881,'hindlimb',252,7,474,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35882,'hindlimb',252,7,475,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35883,'hindlimb',252,7,476,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35884,'hindlimb',252,7,477,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35885,'hindlimb',252,7,478,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35886,'hindlimb',252,7,479,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35887,'hindlimb',252,7,480,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35888,'hindlimb',252,7,481,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35889,'hindlimb',252,7,482,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35890,'hindlimb',252,7,483,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35891,'hindlimb',252,7,484,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35892,'hindlimb',252,7,485,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35893,'hindlimb',252,7,486,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35894,'hindlimb',252,7,487,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35895,'hindlimb',252,7,488,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35896,'hindlimb',252,7,489,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35897,'hindlimb',252,7,490,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35898,'hindlimb',252,7,491,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35899,'hindlimb',252,7,492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35900,'hindlimb',252,7,493,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35901,'hindlimb',252,7,494,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35902,'hindlimb',252,7,495,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35903,'hindlimb',252,7,496,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35904,'hindlimb',252,7,497,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35905,'hindlimb',252,7,498,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35906,'hindlimb',252,7,499,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35907,'hindlimb',252,7,500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35908,'hindlimb',252,7,501,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35909,'hindlimb',252,7,502,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35910,'hindlimb',252,7,503,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35911,'hindlimb',252,7,504,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35912,'hindlimb',252,7,505,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35913,'hindlimb',252,7,506,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35914,'hindlimb',252,7,507,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35915,'hindlimb',252,7,508,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35916,'hindlimb',252,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35917,'hindlimb',252,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35918,'hindlimb',252,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35919,'hindlimb',252,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35920,'hindlimb',252,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35921,'hindlimb',252,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35922,'hindlimb',252,8,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35923,'hindlimb',252,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35924,'hindlimb',252,8,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35925,'hindlimb',252,8,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35926,'hindlimb',252,8,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35927,'hindlimb',252,8,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35928,'hindlimb',252,8,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35929,'hindlimb',252,8,14,1.6683999,72.6992614,118.4870856,1.8,72.7077326,118.5486577,-1.08286,1.3177205,1.4728483,0.5673986,0.7835336,0.2169539,0.5319853,0.430591,0.9086825,3.007816,3.4642554,0.5191461,9.2625046),(35930,'hindlimb',252,8,15,15.1440019,70.0847964,121.0064478,1.8,69.181281,121.6122949,-0.602112,2.3009115,9.4260467,13.0214075,251.3598813,0.809677,26.6665219,5.6592387,28.0478835,5.0955778,16.3337968,0.6171914,39.6281463),(35931,'hindlimb',252,8,16,32.1957536,68.8091478,121.9857155,1.8,68.2151042,122.3150051,-0.5705312,3.4178567,8.9044041,48.5725651,624.7981218,1.5651727,70.167314,14.2114107,75.4018236,7.2719466,17.99567,0.5813802,43.6733209),(35932,'hindlimb',252,8,17,50.3879143,68.466304,122.2165454,1.8,67.8522715,122.338222,-0.5422671,8.0941152,9.2564267,180.085159,1165.1240202,2.2367001,125.8719009,22.2489001,144.9602743,10.9184156,18.9501664,0.5754247,55.0537285),(35933,'hindlimb',252,8,18,77.5763422,68.4725213,122.0812249,1.8,67.9458639,122.1644954,-0.6479488,9.9253422,9.2772784,1047.0782403,1539.8488967,4.7098573,165.9806707,105.4954301,260.4480922,15.9505019,19.4121987,0.483447,65.0713492),(35934,'hindlimb',252,8,19,111.7665667,68.2311413,122.0743586,1.8,67.9679712,121.9647417,-0.0993577,10.8509897,10.5948049,2448.5973621,2752.4414446,0.1832879,259.7916127,225.6565917,452.6112826,18.9672519,21.3723891,2.0974236,68.3614076),(35935,'hindlimb',252,8,20,115.0485923,67.9863102,122.0446936,1.8,67.9744699,121.766909,-0.0233518,11.6440425,10.9732417,2967.8134266,3659.1565234,0.0104542,333.4617638,254.8782707,526.0295401,19.9948746,22.9832877,2.7784456,72.5540278),(35936,'hindlimb',252,8,21,128.6937199,68.6358417,121.7155607,1.8,68.5048998,121.4851132,0.0114157,12.5703883,12.202272,3807.6328567,5119.4859875,0.0027951,419.5518655,302.9049502,678.8359326,21.363106,25.1211348,2.9173579,77.0594274),(35937,'hindlimb',252,8,22,133.673183,69.7293471,121.4473139,1.8,69.0542672,121.2338204,-0.0408218,13.2300053,13.575609,4195.595168,5914.8956553,0.0371053,435.7002087,317.1272482,726.7508237,22.2748976,26.1369007,2.976444,80.1409662),(35938,'hindlimb',252,8,23,127.1692209,70.181004,120.9106342,1.8,69.6182825,120.8797399,-0.3439178,13.3261095,14.6153261,4204.5900327,5741.0198962,2.4096241,392.8081983,315.5151954,680.2463189,23.203152,26.861515,3.0132694,83.1793192),(35939,'hindlimb',252,8,24,127.6934073,70.2535295,120.86244,1.8,69.8085652,120.7241192,-0.462399,13.274721,14.552852,4155.649399,5764.3410009,4.2352086,396.0969997,313.0498487,671.5663899,23.203152,27.5302279,0.0468407,85.462556),(35940,'hindlimb',252,8,25,148.3500106,70.6889775,121.0449705,1.8,70.0489414,120.6817438,-0.4038073,13.7956359,15.1487867,4640.4303328,6211.5470258,3.8172416,410.0359413,336.3694404,711.5152903,23.4599798,27.6640329,0.108942,87.2855678),(35941,'hindlimb',252,8,26,158.7331982,70.7559474,121.0626967,1.8,70.150635,120.6969585,-0.351711,13.9407956,15.3952426,4947.4933032,6435.3633038,3.1398322,418.0098663,354.8931825,738.277624,23.4352191,27.4092448,0.1574169,88.1449438),(35942,'hindlimb',252,8,27,157.9871739,70.3209674,120.6549956,1.8,70.3939653,120.7641729,-0.596512,12.3128835,14.7955629,4874.8444261,6314.9176252,8.3094572,426.8115842,395.9141208,734.1544719,22.9488034,27.479883,0.1728606,87.7889786),(35943,'hindlimb',252,8,28,136.6390407,70.243859,120.6799703,1.8,70.5167501,121.0512084,-0.60149,11.0643577,14.7017967,3773.7816675,5328.8595725,7.292214,362.4631517,341.0755293,600.412319,22.0690943,27.479883,0.1728606,87.641533),(35944,'hindlimb',252,8,29,105.7749298,70.6151477,121.0554088,1.8,70.6869058,121.4900833,-0.4947463,10.6749334,15.1117749,2617.4873163,3509.573338,3.9743697,232.2409757,245.1994055,397.8193327,19.9320961,26.9849538,0.1599131,88.8568742),(35945,'hindlimb',252,8,30,87.3582457,70.7771143,121.6302203,1.8,70.5485979,121.9571573,-0.1162747,11.0328501,15.2622817,2060.0109786,2493.9502185,0.195959,163.4061187,186.7161207,295.6416919,19.33596,22.9712346,0.1313154,78.127323),(35946,'hindlimb',252,8,31,75.4632036,70.9665509,122.3267918,1.8,70.6542476,122.672692,0.1250868,10.2485017,10.9209127,1535.6882381,1907.5298572,0.1957675,174.667622,149.8451466,300.2096707,18.3062969,22.0191518,0.0977269,67.293512),(35947,'hindlimb',252,8,32,75.0278083,70.4721378,122.7674674,1.8,70.0690503,123.0719245,-0.1439535,10.9410296,12.2359879,1434.1102145,2184.524952,0.2573438,178.5327817,131.0763486,291.39811,18.046896,22.9712346,0.1313154,68.4045934),(35948,'hindlimb',252,8,33,78.2030832,69.5865123,123.2087305,1.8,69.6675507,123.3948455,-0.2283385,10.8356744,12.5972959,1340.1097532,2786.7574771,0.6678362,221.2187035,123.675713,326.2253498,17.617208,23.9471564,0.1621988,69.7673802),(35949,'hindlimb',252,8,34,76.7026982,69.333942,123.3396186,1.8,69.4495468,123.551436,-0.2404865,10.7954178,12.6489321,1261.3585284,2821.1156046,0.7251908,223.0319198,116.8420293,322.5766391,17.617208,24.0202894,0.1798535,69.7673802),(35950,'hindlimb',252,8,35,73.7467435,69.2528055,123.5342458,1.8,69.2872843,123.7388265,-0.2396869,10.6507477,12.9409771,1137.3491703,2796.2045007,0.6927035,216.0736765,106.7858524,303.9390181,17.18752,24.1008625,0.1973956,69.7673802),(35951,'hindlimb',252,8,36,72.9842702,69.1201808,123.6462098,1.8,69.0896345,123.8935028,-0.2455135,10.305717,13.0981707,1066.2004133,2772.316013,0.7185965,211.6567327,103.4571797,292.829414,16.757832,24.3068239,0.1418971,70.1233454),(35952,'hindlimb',252,8,37,71.1726408,69.1685233,123.7472847,1.8,69.0411459,124.0196645,-0.2506029,10.3044949,13.1171368,1001.8633811,2637.5215426,0.729497,201.0744859,97.2258604,277.065654,16.757832,23.9471564,0.1621988,68.6562988),(35953,'hindlimb',252,8,38,70.3941102,69.0544106,123.8134209,1.8,68.9355987,124.0978876,-0.2582704,9.9134411,13.0939596,963.2304626,2606.8394792,0.7653438,199.0871784,97.1640884,272.5142996,16.328144,23.9471564,0.1621988,67.5452174),(35954,'hindlimb',252,8,39,69.5180044,68.904995,123.9267014,1.8,68.9099739,124.1414747,-0.2695007,9.8519283,12.9143073,902.7012923,2563.4450006,0.8213453,198.4965158,91.6268641,268.077127,16.0989557,23.5976575,0.1831108,67.293512),(35955,'hindlimb',252,8,40,68.4487626,68.8359366,123.9724186,1.8,68.8319879,124.1623116,-0.2738019,9.8680822,12.8326308,861.7532257,2548.6017647,0.8340792,198.6032171,87.3273258,265.3497554,16.0299954,23.5232106,0.1651487,67.293512),(35956,'hindlimb',252,8,41,67.8560387,68.8427569,124.0259992,1.8,68.7850546,124.2275246,-0.280968,9.4923372,12.8189035,818.7053354,2494.3368598,0.8695461,194.5827009,86.249078,257.8752829,15.468768,23.3972909,0.1289108,66.0781708),(35957,'hindlimb',252,8,42,67.1505215,68.7603012,124.1193539,1.8,68.7514691,124.2650288,-0.2888075,9.4184567,12.7061691,780.3618844,2467.4496815,0.907834,194.1930457,82.8545385,254.7852563,15.4594782,23.099477,0.1682068,65.1145351),(35958,'hindlimb',252,8,43,66.4154073,68.5968729,124.1805085,1.8,68.6595692,124.2984488,-0.2913986,9.1346991,12.5293689,718.6991316,2452.1472683,0.9136188,195.7119535,78.6779211,252.1601934,15.03908,23.0314371,0.1498125,64.0034537),(35959,'hindlimb',252,8,44,65.7890579,68.5350341,124.2172817,1.8,68.5716462,124.3259549,-0.2944727,9.0196526,12.6179505,696.8087046,2416.2997355,0.9236401,191.4970057,77.2544949,243.4662347,14.9441443,23.0314371,0.1498125,63.5000428),(35960,'hindlimb',252,8,45,66.0862591,68.5261563,124.2497731,1.8,68.5513493,124.344383,-0.3033725,8.7396043,12.5808497,673.6022434,2375.6550868,0.9829871,188.8310516,77.0746843,238.7160021,14.5912344,22.9712346,0.1313154,62.6406668),(35961,'hindlimb',252,8,46,65.565038,68.4060795,124.2703598,1.8,68.4768199,124.3743893,-0.3101128,8.5742541,12.576159,650.1183223,2372.1401264,1.0176386,188.6219886,75.8221429,237.705645,14.4288104,22.9712346,0.1313154,62.3889614),(35962,'hindlimb',252,8,47,65.7074283,68.4651459,124.2701633,1.8,68.4742432,124.4138452,-0.3098416,8.1836926,12.6329793,625.5325426,2364.2288217,1.0181229,187.147368,76.4364661,234.0759445,13.9134765,22.9189312,0.1127276,61.8855506),(35963,'hindlimb',252,8,48,65.4659523,68.4715224,124.2389046,1.8,68.4741751,124.4130194,-0.316003,8.1378217,12.6369098,613.9696208,2319.5714363,1.0537613,183.5552742,75.4464328,229.470138,13.8890932,22.6759675,0.1713791,61.5295854),(35964,'hindlimb',252,8,49,64.0532395,68.4795813,124.2478832,1.8,68.4547336,124.4433876,-0.3255828,7.8453554,12.6225707,586.9483335,2232.0269786,1.0922261,176.8282408,74.8147536,220.396632,13.6598487,22.606653,0.1526493,61.27788),(35965,'hindlimb',252,8,50,63.0976302,68.4193421,124.24851,1.8,68.4425633,124.4184315,-0.3274321,7.6889854,12.699682,568.9088686,2208.1666785,1.0877474,173.8757457,73.9901093,216.8211223,13.4035494,22.606653,0.1526493,60.6702094),(35966,'hindlimb',252,8,51,61.8104669,68.4081565,124.2408673,1.8,68.4402803,124.4100599,-0.3331609,7.5204948,12.6818739,549.8951012,2138.6794824,1.1017691,168.6406521,73.1195372,210.06666,13.2835876,22.5453162,0.133811,60.418504),(35967,'hindlimb',252,8,52,61.5344144,68.3854564,124.2562294,1.8,68.4279478,124.4072509,-0.3367855,7.5150504,12.6490363,546.1637086,2111.0085314,1.1199309,166.8908591,72.6759874,208.0238836,13.2387868,22.3313777,0.193622,59.8108334),(35968,'hindlimb',252,8,53,59.0512289,68.4797986,124.2070118,1.8,68.4038806,124.372969,-0.3385789,7.4937222,12.7511607,528.4708254,2043.640789,1.0857714,160.2709614,70.5218059,199.7665234,13.2387868,22.2526948,0.1746722,59.8108334),(35969,'hindlimb',252,8,54,58.3483414,68.4594999,124.2130547,1.8,68.4073527,124.3338604,-0.3379504,7.4948166,12.7311264,514.6642793,2022.5237519,1.0690209,158.864478,68.6693625,197.3774892,13.1531208,22.2526948,0.1746722,59.8108334),(35970,'hindlimb',252,8,55,57.7602052,68.4492386,124.2133169,1.8,68.4373178,124.3036697,-0.3418451,7.3342927,12.714355,498.1398857,1983.0777468,1.0818146,155.9715566,67.9192806,193.17527,13.0353364,22.2526948,0.1746722,59.2031628),(35971,'hindlimb',252,8,56,57.5745664,68.4475425,124.2051413,1.8,68.3840924,124.2944927,-0.3468065,7.3068799,12.7063375,491.2120074,1953.5878367,1.1085927,153.749091,67.2259592,190.3405567,13.0062483,22.1820578,0.1555948,59.4548682),(35972,'hindlimb',252,8,57,56.412673,68.4974251,124.2033511,1.8,68.3828048,124.2848535,-0.3490613,7.3134994,12.7495577,478.4679349,1904.2064137,1.0998108,149.3547038,65.4225709,184.7952461,12.9283283,22.1820578,0.1555948,59.4548682),(35973,'hindlimb',252,8,58,56.3175037,68.4708007,124.2033401,1.8,68.3756033,124.3040574,-0.3526708,7.2903658,12.5691393,473.808578,1918.5061517,1.1198261,152.6362395,64.9910569,187.0584945,12.9283283,22.1195436,0.1364026,59.4548682),(35974,'hindlimb',252,8,59,55.8854653,68.5213546,124.1969922,1.8,68.3216393,124.3020655,-0.3615845,7.115285,12.5971179,461.1136575,1869.4292749,1.1656198,148.4013482,64.8060698,181.5059989,12.6544715,21.8296729,0.1780929,58.8471977),(35975,'hindlimb',252,8,60,54.7716881,68.50463,124.1764334,1.8,68.2469355,124.327395,-0.3666799,7.068024,12.5760463,455.7865468,1843.0263924,1.1733478,146.5505416,64.4857103,179.2171007,12.6458817,21.8296729,0.1780929,58.8471977),(35976,'hindlimb',252,8,61,54.273518,68.5546402,124.1779096,1.8,68.27544,124.3087384,-0.3789705,7.0337991,12.3497514,444.2077523,1799.4904636,1.2381013,145.7106625,63.1533178,179.0099247,12.5381986,21.4886965,0.2013171,58.1352673),(35977,'hindlimb',252,8,62,54.3710931,68.5198863,124.1853528,1.8,68.320392,124.285944,-0.3847699,7.0020246,12.3021218,442.0230402,1791.6102107,1.276674,145.6342444,63.1278902,178.7136768,12.5014842,21.4886965,0.2013171,57.6318565),(35978,'hindlimb',252,8,63,55.2954829,68.5890151,124.1212911,1.8,68.3236179,124.2688665,-0.3926397,6.9338576,12.3727582,440.7471309,1785.6278657,1.3492525,144.3193049,63.5644909,176.9869375,12.3855352,21.4886965,0.2013171,57.6318565),(35979,'hindlimb',252,8,64,54.3825627,68.5388362,124.1330633,1.8,68.1720154,124.3141095,-0.3916142,6.9301373,12.3242067,437.031739,1791.4502933,1.3204112,145.3602926,63.0624934,177.8831434,12.3855352,21.4886965,0.2013171,57.6318565),(35980,'hindlimb',252,8,65,55.8252082,68.3340786,124.1880926,1.8,68.0251463,124.3228417,-0.378243,6.9650098,12.3832107,435.2699217,1920.2724824,1.2688495,155.0706463,62.4937992,186.1074542,12.4236003,21.8296729,0.1780929,58.8471977),(35981,'hindlimb',252,8,66,56.5584202,68.2750714,124.2054469,1.8,67.992642,124.3398359,-0.3747283,6.9756956,12.488345,436.4742863,1953.277532,1.262859,156.408038,62.5707187,188.5361166,12.3327036,21.8296729,0.1780929,59.0989031),(35982,'hindlimb',252,8,67,56.7294004,68.2891274,124.1622143,1.8,67.9758674,124.2740279,-0.3732998,6.9471864,12.606974,434.7301646,1959.0345353,1.2574902,155.3929223,62.5764363,184.4752552,12.3433939,22.1195436,0.1364026,59.4548682),(35983,'hindlimb',252,8,68,57.5230373,68.2546942,124.1397801,1.8,67.9871775,124.1995075,-0.3773179,6.8951031,12.7290887,435.9589958,1969.9042639,1.3013578,154.7561111,63.2273354,184.9194908,12.2066977,22.1820578,0.1555948,59.4548682),(35984,'hindlimb',252,8,69,57.7186351,68.3510837,124.0792976,1.8,68.1262786,124.1521913,-0.3861961,6.908151,12.580581,431.8611595,1946.8879546,1.3648374,154.7534217,62.514725,186.194458,12.2066977,21.8296729,0.1780929,59.7065737),(35985,'hindlimb',252,8,70,57.6636932,68.4042741,124.0508539,1.8,68.1042767,124.122625,-0.3897948,6.8820038,12.6325057,431.1812209,1927.350945,1.3877626,152.5707557,62.6534409,183.7779107,12.2066977,21.5787243,0.2208288,59.3506085),(35986,'hindlimb',252,8,71,57.5811124,68.4566928,124.0422132,1.8,68.1327271,124.1164142,-0.3950408,6.7992629,12.5068035,427.292964,1892.815534,1.4213545,151.34287,62.844013,181.2159854,12.2066977,21.5787243,0.2208288,58.7429379),(35987,'hindlimb',252,8,72,57.3158581,68.4628929,124.0288307,1.8,68.0888197,124.1371912,-0.3962115,6.7839791,12.5144739,426.735017,1876.6575918,1.4227609,149.9589676,62.9033506,179.7910587,12.2066977,21.4886965,0.2013171,58.9946433),(35988,'hindlimb',252,8,73,56.5577488,68.5008488,124.0268551,1.8,67.9976153,124.1730224,-0.4028005,6.5984998,12.5318235,417.5283204,1842.1185029,1.4484537,146.9952483,63.2762498,175.8590591,11.9362427,21.5787243,0.2208288,58.4912325),(35989,'hindlimb',252,8,74,56.755137,68.5268575,124.0165425,1.8,68.0063634,124.1462101,-0.408373,6.5716731,12.5437786,413.7526035,1833.6422151,1.4917294,146.1794146,62.9600098,174.5328628,11.8635307,21.5787243,0.2208288,58.7429379),(35990,'hindlimb',252,8,75,56.5484613,68.7095542,123.941076,1.8,68.1650588,124.0655175,-0.421743,6.510712,12.7013484,406.9863166,1748.4527607,1.5792902,137.6588303,62.5102628,164.9153692,11.8423016,21.5787243,0.2208288,58.2395271),(35991,'hindlimb',252,8,76,56.4185476,68.7467746,123.9404022,1.8,68.2542347,124.0628874,-0.4302252,6.4842564,12.5296454,400.7062922,1718.4288377,1.635686,137.14904,61.7967993,162.5695198,11.7394373,21.4886965,0.2013171,57.8835619),(35992,'hindlimb',252,8,77,56.1710851,68.8406224,123.9173825,1.8,68.4162614,124.040511,-0.4521269,6.3963355,12.1447973,389.1234629,1637.6255504,1.7868382,134.8417354,60.8353741,162.788685,11.6730802,20.8431901,0.2499786,55.7045849),(35993,'hindlimb',252,8,78,56.7300718,68.8188459,123.9223904,1.8,68.4534072,124.0071211,-0.4627083,6.3396164,11.9015951,386.8183543,1638.2020367,1.8839023,137.645586,61.0160502,164.143434,11.6182555,20.7410714,0.2299044,55.5571393),(35994,'hindlimb',252,8,79,57.1594806,68.8366119,123.8933725,1.8,68.6021776,123.9120656,-0.4733516,6.4539086,11.7088316,382.6344462,1647.0677283,1.9798061,140.6688374,59.2872426,168.6636337,11.536481,20.4271343,0.2551824,54.5935035),(35995,'hindlimb',252,8,80,57.4892441,68.8542928,123.8879853,1.8,68.659505,123.8856443,-0.4842723,6.3955899,11.5157125,381.0614097,1623.1601448,2.0768013,140.951777,59.5819023,170.5870455,11.4790295,20.126652,0.2812322,53.9858329),(35996,'hindlimb',252,8,81,56.5005689,69.1054751,123.7681151,1.8,68.9395605,123.7411922,-0.513316,6.2470409,10.9722622,371.2809598,1477.6682361,2.2708366,134.6730706,59.4330928,165.0469608,11.2857706,19.3025109,0.293589,52.0153755),(35997,'hindlimb',252,8,82,56.491673,69.1975803,123.7073939,1.8,69.0802061,123.6895086,-0.5302786,6.1456991,10.6718425,367.8055564,1409.1418577,2.4084948,132.0429777,59.8476345,163.0105099,11.2144483,18.8916179,0.3001712,51.1559995),(35998,'hindlimb',252,8,83,55.4091154,69.382936,123.6106519,1.8,69.2619488,123.6147414,-0.5543891,6.024836,10.3192186,362.4061217,1318.1185917,2.559183,127.7343419,60.1520306,160.7456925,11.0615782,18.209851,0.3366748,49.4372475),(35999,'hindlimb',252,8,84,54.8463241,69.4460205,123.5641768,1.8,69.3597296,123.5598763,-0.5684439,5.9415542,10.0107013,359.4412035,1271.025848,2.6489843,126.9667142,60.4961583,160.8683082,11.0456713,17.8048522,0.3446473,48.8295769),(36000,'hindlimb',252,8,85,54.0418331,69.5880773,123.4932099,1.8,69.4769354,123.4746618,-0.5874699,5.8551502,9.7786587,353.4339944,1207.0749642,2.7669478,123.4397273,60.3629249,157.5984934,10.9380707,17.4010378,0.3529904,48.2219063),(36001,'hindlimb',252,8,86,53.9627212,69.603811,123.4621357,1.8,69.4994041,123.4313171,-0.599154,6.0163324,9.5479994,350.93276,1180.289924,2.86032,123.6164636,58.3300155,156.9348492,11.1144791,17.257203,0.3296244,47.9702009),(36002,'hindlimb',252,8,87,53.7016071,69.7147557,123.4018622,1.8,69.6292497,123.3369507,-0.6177211,5.9346905,9.2841247,345.5295976,1133.2029481,3.0023516,122.058135,58.2220077,155.8670621,11.0169019,16.8512217,0.3378782,47.1108249),(36003,'hindlimb',252,8,88,53.5259831,69.7571631,123.3548978,1.8,69.690545,123.2820014,-0.6297864,5.8592495,9.2276494,343.9619558,1102.9104527,3.0945883,119.5223619,58.7040979,154.8950127,10.7692794,16.7798528,0.8760581,46.8591195),(36004,'hindlimb',252,8,89,52.9520021,69.8910698,123.2535489,1.8,69.8729756,123.1274321,-0.6477033,5.8494076,9.0254499,340.8766752,1052.7467061,3.2127658,116.6420198,58.2754182,152.6953804,10.6846002,16.5861794,0.9324765,45.9997435),(36005,'hindlimb',252,8,90,52.7388923,69.9291752,123.2007914,1.8,69.8846589,123.1035015,-0.6581143,5.7714321,8.8104449,340.9053673,1028.6862197,3.2881508,116.7575798,59.0677252,152.3993922,10.7263357,16.3337968,0.9536049,45.7480381),(36006,'hindlimb',252,8,91,52.4205983,70.0430592,123.109161,1.8,70.0116989,122.9971179,-0.6697284,5.7038529,8.5985664,338.234619,991.9416873,3.3667934,115.3612869,59.2993234,152.0670002,10.6547435,16.3337968,0.9536049,45.1403675),(36007,'hindlimb',252,8,92,52.3990579,70.0849362,123.0508645,1.8,70.0511753,122.9552212,-0.6772264,5.642458,8.5898426,338.9450064,971.3809313,3.429257,113.0848352,60.0704523,151.422229,10.6875942,16.2431158,0.9167136,45.3920729),(36008,'hindlimb',252,8,93,52.1383914,70.202001,122.9606816,1.8,70.1658803,122.8786152,-0.6888045,5.5822504,8.451721,337.035178,933.5368143,3.5107041,110.4552329,60.3762195,148.0700361,10.6343708,15.9853176,0.9380475,43.9250263),(36009,'hindlimb',252,8,94,51.9256732,70.2216092,122.9024912,1.8,70.1567246,122.8008534,-0.6995392,5.7676702,8.2111208,336.5025009,913.4498005,3.5877384,111.2454459,58.342882,148.4233648,10.7519293,15.8519352,0.9978302,44.2809915),(36010,'hindlimb',252,8,95,51.7985011,70.3021625,122.8121478,1.8,70.2809522,122.6646164,-0.7127732,5.6829872,8.2174799,332.3774818,884.4631797,3.6917665,107.6319253,58.4864032,147.464274,10.6244165,15.8519352,0.9978302,43.9250263),(36011,'hindlimb',252,8,96,51.6236044,70.3244023,122.7466223,1.8,70.2995875,122.5961248,-0.7232514,5.6322346,8.0225556,331.3659472,865.0497459,3.7686364,107.8272045,58.8338323,145.7740698,10.5862505,15.6231626,1.0209431,43.6733209),(36012,'hindlimb',252,8,97,51.4126766,70.4215893,122.6409998,1.8,70.4395955,122.4575362,-0.7397853,5.5240974,7.8184421,328.9165189,833.7321928,3.8940848,106.6366142,59.5421292,143.3785933,10.3941755,15.6231626,1.0209431,43.0656503),(36013,'hindlimb',252,8,98,51.6657341,70.4406449,122.5757535,1.8,70.430736,122.4070368,-0.7502753,5.4293975,7.860054,330.0974522,819.2998977,4.0032847,104.2359116,60.7981736,142.9400796,10.3941755,15.6231626,1.0209431,42.7096851),(36014,'hindlimb',252,8,99,51.8607723,70.5296044,122.480245,1.8,70.5434431,122.3361289,-0.7654002,5.3355297,7.6552873,329.630232,792.7768267,4.1489257,103.5593829,61.7802261,141.560155,10.3498133,15.4029813,1.0447299,42.1020145),(36015,'hindlimb',252,8,100,52.0741619,70.5425228,122.4087456,1.8,70.5346641,122.2760384,-0.7756105,5.2356832,7.6936968,332.445203,780.0960317,4.2545713,101.3941734,63.4960502,141.6128822,10.4226942,15.2584623,1.0062269,42.1020145),(36016,'hindlimb',252,8,101,51.9275195,70.6200905,122.3034214,1.8,70.5744784,122.1547941,-0.7918544,5.4304973,7.506434,332.3255842,761.4492897,4.3831674,101.4395501,61.1961599,135.2533949,10.4506337,15.1917649,1.0691923,42.4579797),(36017,'hindlimb',252,8,102,51.9772582,70.6286093,122.2383905,1.8,70.5987994,122.1074273,-0.8017449,5.3388486,7.5522758,333.9987428,753.5280518,4.473023,99.7749645,62.5600702,135.5802995,10.3858718,15.1917649,1.0691923,42.4579797),(36018,'hindlimb',252,8,103,51.9642221,70.6965031,122.1209809,1.8,70.696261,121.9657702,-0.8139955,5.2918886,7.38025,332.3504105,736.7231868,4.57789,99.8236088,62.8037429,134.2249627,10.3056331,15.1917649,1.0691923,42.1020145),(36019,'hindlimb',252,8,104,51.8955726,70.7080608,122.0512974,1.8,70.7268265,121.8833177,-0.8237831,5.1522302,7.1426632,332.0952813,726.0719032,4.6563064,101.6528269,64.4566079,134.044056,10.19795,14.9898924,1.0943289,41.2426385),(36020,'hindlimb',252,8,105,51.6202475,70.7792955,121.9533726,1.8,70.7710702,121.8047134,-0.8391859,5.3459942,7.2272359,331.9568452,708.2822406,4.7635513,98.0018161,62.0945021,128.3507004,10.3386441,14.8413514,1.1849137,41.8503091),(36021,'hindlimb',252,8,106,51.6330598,70.7875658,121.8736882,1.8,70.7858745,121.7079905,-0.8535731,5.2203193,7.0385974,334.8115281,697.9018607,4.8876186,99.153542,64.1362162,128.0495174,10.3386441,15.0083566,1.1583859,41.5986037),(36022,'hindlimb',252,8,107,51.6791618,70.8657143,121.7269852,1.8,70.8656077,121.5815909,-0.8756629,5.2808433,7.0903602,337.1475459,682.5055501,5.0798482,96.2582343,63.8435048,128.9045464,10.3386441,14.6850235,1.2120257,41.2426385),(36023,'hindlimb',252,8,108,51.7413212,70.8785934,121.6315607,1.8,70.8744944,121.5083739,-0.8895947,5.3550734,6.9461708,339.2525946,675.0960824,5.2038314,97.1896755,63.351624,128.8256413,10.3386441,14.797746,1.120135,41.2426385),(36024,'hindlimb',252,8,109,51.3102899,70.9527303,121.500391,1.8,70.9252602,121.3711847,-0.9133396,5.3358217,7.0056501,339.1172626,659.8354491,5.3580753,94.1861837,63.554834,123.7630016,10.1958889,14.6850235,1.2120257,41.4943439),(36025,'hindlimb',252,8,110,51.0286985,70.9604506,121.4093802,1.8,70.9319299,121.2202747,-0.9262576,5.3933738,6.8515611,341.0428598,650.3573358,5.4345869,94.9210442,63.2336779,123.7466012,10.2199614,14.6850235,1.2120257,41.2426385),(36026,'hindlimb',252,8,111,50.7833061,71.0327273,121.2808829,1.8,70.9874532,121.1326981,-0.9486947,5.4213535,6.8355879,342.5838208,634.417706,5.5896259,92.8109936,63.1915664,124.036858,10.2199614,14.4441652,1.1737169,40.8866733),(36027,'hindlimb',252,8,112,50.945838,71.0379005,121.1934557,1.8,71.0171513,121.0281639,-0.9685933,5.3392146,7.0427434,345.5448412,629.3001971,5.7664222,89.3544126,64.7182901,124.3334044,10.2605468,14.6157096,1.1466019,40.5307081),(36028,'hindlimb',252,8,113,51.0462105,71.090807,121.0737393,1.8,71.0604721,120.9520232,-0.9894461,5.3822886,6.9839604,345.9681803,624.0196716,5.9420435,89.3504024,64.2790095,125.7361548,10.2605468,14.4441652,1.1737169,40.5307081),(36029,'hindlimb',252,8,114,51.130134,71.0903075,120.984423,1.8,71.0746828,120.8485849,-1.0068227,5.4443828,7.0980815,347.9039451,624.4441086,6.0866821,87.9736455,63.9014486,121.4771951,10.428492,14.5397175,1.2397003,40.6349679),(36030,'hindlimb',252,8,115,50.507925,71.1446093,120.8763094,1.8,71.1217709,120.7227118,-1.013236,5.4597556,7.0011907,345.6362219,609.6546441,6.0612423,87.0787091,63.3061708,121.0419441,10.428492,14.283491,1.2014627,40.2790027),(36031,'hindlimb',252,8,116,50.3671572,71.1349323,120.8074103,1.8,71.0964026,120.6480982,-1.0248112,5.3654042,6.9890304,346.4688266,601.8779565,6.1311002,86.117519,64.5745988,121.1502247,10.2605468,14.283491,1.2014627,40.2790027),(36032,'hindlimb',252,8,117,50.2935843,71.1991617,120.6941226,1.8,71.1340946,120.5557529,-1.0512822,5.4651831,7.1627786,347.6972389,592.7737429,6.3162795,82.7575125,63.6204194,121.3593595,10.382649,14.283491,1.2014627,40.5307081),(36033,'hindlimb',252,8,118,50.408056,71.1875447,120.6044298,1.8,71.1494882,120.46189,-1.0731855,5.3682923,7.1525721,348.7064925,592.217356,6.4871682,82.7978175,64.9566893,117.155994,10.1909232,14.283491,1.2966289,41.1383787),(36034,'hindlimb',252,8,119,50.3550722,71.2311825,120.4730849,1.8,71.2136245,120.2964073,-1.0983802,5.3954127,7.269795,347.3059113,586.0913689,6.6547536,80.6200682,64.3705919,117.9666972,10.274961,14.283491,1.2014627,40.2790027),(36035,'hindlimb',252,8,120,50.4905248,71.2138236,120.4010447,1.8,71.189415,120.2432435,-1.1159231,5.450995,7.2663793,349.7066163,584.3289227,6.7907479,80.4154175,64.1546393,118.86152,10.3815581,14.1340576,1.2298174,39.9230375),(36036,'hindlimb',252,8,121,50.301529,71.2546646,120.2883473,1.8,71.2319808,120.1516261,-1.1460691,5.4833982,7.2324263,349.6187942,574.9203178,6.9600249,79.4920396,63.7595119,119.2948326,10.2928202,13.9962251,1.2587542,39.9230375),(36037,'hindlimb',252,8,122,50.479391,71.244341,120.1897865,1.8,71.2032767,120.0741348,-1.17314,5.3780193,7.279849,351.2743256,574.4476151,7.1515056,78.9092756,65.3166729,115.015784,10.2928202,14.1731921,1.3258177,40.2790027),(36038,'hindlimb',252,8,123,50.1597542,71.2922293,120.0565419,1.8,71.2136245,119.9431083,-1.2073602,5.4023689,7.4042217,347.6268041,572.064913,7.3034967,77.261991,64.3471061,115.6739384,10.2837771,14.1731921,1.3258177,40.2790027),(36039,'hindlimb',252,8,124,49.4796938,71.2788535,119.9896487,1.8,71.1962948,119.8208752,-1.2249383,5.4438531,7.5391679,346.6753094,568.1369788,7.2988839,75.3580482,63.6819733,115.237749,10.2837771,14.1340576,1.2298174,40.1747429),(36040,'hindlimb',252,8,125,48.9673686,71.3244183,119.8837164,1.8,71.2572414,119.7118545,-1.2616791,5.4381148,7.6482776,344.9484077,565.5432674,7.4059187,73.9438728,63.4316154,111.3623667,10.3583942,14.1731921,1.3258177,40.5307081),(36041,'hindlimb',252,8,126,49.2517575,71.3024144,119.7710438,1.8,71.2484225,119.6128349,-1.2924875,5.4855889,7.7494144,346.9057453,572.1806905,7.5890676,73.8353459,63.2394723,113.5347938,10.3583942,14.283491,1.2966289,40.5307081),(36042,'hindlimb',252,8,127,50.0336451,71.3294111,119.5719612,1.8,71.2966975,119.5067363,-1.3330496,5.4880785,7.6318994,346.6629604,577.6679522,7.8764087,75.6912433,63.1665455,116.1457393,10.4184846,14.1731921,1.3258177,40.5307081),(36043,'hindlimb',252,8,128,50.8862523,71.3103116,119.4395798,1.8,71.2515456,119.3680836,-1.3547286,5.4252611,7.5450152,347.5681646,586.1520422,8.0912255,77.6873246,64.0647815,119.3306766,10.2610034,14.0751518,1.3554386,40.2790027),(36044,'hindlimb',252,8,129,51.4967121,71.3705194,119.274683,1.8,71.2988681,119.1825795,-1.3699085,5.4677831,7.3954117,344.8319113,589.9900061,8.2410536,79.7778449,63.0661289,121.8452834,10.241328,13.8703393,1.2882414,39.9230375),(36045,'hindlimb',252,8,130,51.3209202,71.372242,119.1871866,1.8,71.3073861,119.1153816,-1.3789081,5.4909375,7.3228345,344.8873749,589.4071474,8.2423847,80.4889346,62.8102902,121.7555519,10.2968424,13.8703393,1.2882414,40.1747429),(36046,'hindlimb',252,8,131,50.7015086,71.4312529,119.0935777,1.8,71.380493,119.0330824,-1.3948301,5.5364188,7.3179984,343.9516653,580.8462807,8.1912864,79.372288,62.1252971,121.7418009,10.2968424,13.8703393,1.2882414,39.9230375),(36047,'hindlimb',252,8,132,50.92385,71.4054367,119.0126424,1.8,71.3659828,118.9669138,-1.4164044,5.5109488,7.2612056,344.8227273,580.7256455,8.2865998,79.9764769,62.5704824,123.2154587,10.3342234,13.7567282,1.3182421,39.9230375),(36048,'hindlimb',252,8,133,50.5273393,71.440987,118.9350416,1.8,71.3991833,118.8739525,-1.4384087,5.5503977,7.1948493,340.0697202,567.1075903,8.274489,78.8213297,61.2694327,121.851129,10.3342234,13.5879276,1.2490458,39.5670723),(36049,'hindlimb',252,8,134,49.9466444,71.4225946,118.8854859,1.8,71.3656139,118.8442196,-1.4513252,5.5200844,7.1042713,337.3148156,556.946316,8.2061873,78.3959803,61.1068226,120.9701897,10.3342234,13.4582233,1.2793395,39.5670723),(36050,'hindlimb',252,8,135,50.2790375,71.4493735,118.747847,1.8,71.3904123,118.7307374,-1.4938981,5.5028207,6.9988868,333.1495644,551.9935734,8.3303844,78.8687677,60.5415986,121.8234204,10.2450182,13.3411032,1.3101939,39.3153669),(36051,'hindlimb',252,8,136,49.6545905,71.4521435,118.6816279,1.8,71.374349,118.629455,-1.5062358,5.5004121,6.9402466,328.0275017,546.7670719,8.2413191,78.7820813,59.6368957,121.4578351,10.2366819,13.2369013,1.3415644,38.7076963),(36052,'hindlimb',252,8,137,48.4418954,71.5081667,118.6113664,1.8,71.4297169,118.5436263,-1.5276764,5.4372517,6.8783223,322.2793469,529.2104704,8.058647,76.9388881,59.272472,119.1023331,10.184865,13.0684503,1.4056476,38.4559909),(36053,'hindlimb',252,8,138,47.8853145,71.4962463,118.5492029,1.8,71.4619788,118.498627,-1.5436017,5.4288013,6.8115444,319.1676538,519.8011476,7.9749849,76.3117901,58.7915522,118.3958497,10.0916194,12.9263977,1.9451299,38.1000257),(36054,'hindlimb',252,8,139,47.4571366,71.5330312,118.4419964,1.8,71.494017,118.3643841,-1.5651323,5.3843286,6.7194147,315.2744315,508.0347614,7.909269,75.6069961,58.5540849,117.7352746,10.1112579,12.7755427,1.9138203,38.1000257),(36055,'hindlimb',252,8,140,47.2037435,71.5148009,118.3979057,1.8,71.4236942,118.3328246,1.5663511,4.9725629,6.6874293,313.4749299,499.0279777,7.8671351,74.6217945,63.040918,116.9829359,10.1101373,12.7248603,1.7748143,37.7440605),(36056,'hindlimb',252,8,141,46.8394034,71.5738592,118.3069346,1.8,71.5144061,118.1959151,1.5429134,5.330217,6.6402599,310.2758368,482.0910568,7.8004995,72.6012326,58.2107331,115.2585877,10.0871589,12.6375032,1.8817946,37.7440605),(36057,'hindlimb',252,8,142,46.5071781,71.5695474,118.266573,1.8,71.5017358,118.1166864,1.5314442,5.3106848,6.6197377,308.9840253,471.0626313,7.7391991,71.1603167,58.1815787,114.1289784,10.1230421,12.5274503,1.957672,37.1363899),(36058,'hindlimb',252,8,143,46.4275067,71.5948154,118.1558519,1.8,71.5594994,118.082991,1.5092067,5.2822895,6.1709892,306.0461091,462.1488515,7.7086028,74.890563,57.9381549,115.5736161,10.139828,12.5274503,2.1112158,36.7804247),(36059,'hindlimb',252,8,144,46.5783453,71.5721103,118.0572397,1.8,71.5315238,118.0101411,1.4777367,4.9610168,6.1453435,303.786627,458.6644378,7.6960226,74.6360942,61.2347503,116.4403622,9.882824,12.3940969,2.1587989,36.1727541),(36060,'hindlimb',252,8,145,45.913615,71.6215151,117.9811307,1.8,71.5144408,117.9145024,1.4720327,4.905937,6.0872723,299.3655671,443.9972868,7.5778693,72.9386276,61.0210792,114.3446709,9.882824,12.3118922,2.0812846,36.1727541),(36061,'hindlimb',252,8,146,45.1875085,71.6231999,117.9477682,1.8,71.4911931,117.8308214,1.4690713,4.9014244,6.0609855,297.3131789,431.7577955,7.4535866,71.2355762,60.6585256,112.6516987,9.882824,12.1610055,2.1293956,35.9210487),(36062,'hindlimb',252,8,147,44.5006783,71.6598404,117.8910902,1.8,71.557087,117.7982095,1.4465499,4.9461782,6.0588531,293.0451701,416.7035991,7.3028735,68.7759869,59.2467878,110.2497605,9.8543606,12.1610055,2.1293956,35.3133781),(36063,'hindlimb',252,8,148,44.689786,71.6330665,117.8119529,1.8,71.5478739,117.7495136,1.421276,4.9869153,6.0296573,293.0477994,415.9969722,7.2830182,68.9918106,58.7633403,111.573412,9.8615247,12.1077509,2.0503156,35.3133781),(36064,'hindlimb',252,8,149,45.5311474,71.6412108,117.6462926,1.8,71.5940503,117.6368556,1.371932,4.900147,5.9605338,289.3600912,419.0487287,7.2923563,70.3038932,59.0513084,114.0466448,9.453136,12.0389346,2.1785983,34.9574129),(36065,'hindlimb',252,8,150,44.7152428,71.658656,117.6354925,1.8,71.6073961,117.5796498,1.3865741,4.8834342,5.9268791,287.8052485,406.7713286,7.2024657,68.6316229,58.9350115,111.8451003,9.453136,11.9388329,2.0988708,34.7057075),(36066,'hindlimb',252,8,151,44.156368,71.6995584,117.5689104,1.8,71.6419134,117.4970238,1.3670055,4.8800395,5.9051008,285.8415009,390.6987396,7.0579618,66.162925,58.5736036,109.6346456,9.453136,11.7988288,2.1486983,34.3497423),(36067,'hindlimb',252,8,152,44.1260996,71.682701,117.5156952,1.8,71.6161319,117.4443902,1.3393867,4.8491797,5.8966575,285.0078731,386.6628894,6.9675013,65.5732321,58.7744512,109.820635,9.453136,11.7988288,2.1486983,34.7057075),(36068,'hindlimb',252,8,153,44.1736563,71.7328255,117.420991,1.8,71.6600898,117.3707608,1.3253708,4.846382,5.8391448,282.6682613,380.3959583,6.9276514,65.1458345,58.3256249,109.458849,9.453136,11.7988288,2.1486983,34.4540021),(36069,'hindlimb',252,8,154,44.5492421,71.6993352,117.3302886,1.8,71.5956669,117.3059201,1.2995006,4.8825109,5.7825378,282.6110517,379.5642294,6.8916693,65.6397319,57.8823191,111.061449,9.453136,11.6887773,2.1995926,34.0980369),(36070,'hindlimb',252,8,155,43.9295507,71.7490628,117.2680868,1.8,71.6444143,117.2199882,1.304862,4.8245257,5.7277196,278.5339126,366.687514,6.8158926,64.0198089,57.7329113,108.7468425,9.453136,11.5697035,2.1175852,33.8463315),(36071,'hindlimb',252,8,156,43.6260272,71.7433667,117.2186832,1.8,71.6588229,117.1790345,1.2978237,4.8420653,5.6893635,277.3762162,360.3138068,6.7425366,63.3311282,57.2846909,108.3075672,9.453136,11.5697035,2.1175852,33.8463315),(36072,'hindlimb',252,8,157,43.271814,71.7859107,117.1530889,1.8,71.6750915,117.0944559,1.2863609,4.8289187,5.6553418,274.2634811,348.9299152,6.6440617,61.6991733,56.7960442,106.4681417,9.453136,11.4413255,2.1692152,33.4903663),(36073,'hindlimb',252,8,158,43.2054584,71.7766748,117.0989131,1.8,71.681407,117.0731074,1.2712439,4.8182283,5.6230254,273.1977112,344.450416,6.573857,61.2571333,56.7008651,106.4496221,9.453136,11.4413255,2.1692152,33.4903663),(36074,'hindlimb',252,8,159,43.1121914,71.8036478,117.0353747,1.8,71.6889198,116.9859503,1.2531897,4.7651272,5.5960061,270.3688444,336.0735376,6.4845953,60.0559636,56.7390613,105.2414399,9.453136,11.3522236,2.0852476,33.2386609),(36075,'hindlimb',252,8,160,43.3303366,71.7738854,116.9636456,1.8,71.6708276,116.9508968,1.2211391,4.7954952,5.5596007,269.0396298,333.3699414,6.3741947,59.9629285,56.102575,105.9497525,9.453136,11.3522236,2.0852476,32.9869555),(36076,'hindlimb',252,8,161,42.7113726,71.8272997,116.9216543,1.8,71.7417683,116.8958716,1.210632,4.8290522,5.3999043,265.0834908,320.5024822,6.2343975,59.3533632,54.8934819,104.8980646,9.453136,11.0889478,2.1910458,32.9869555),(36077,'hindlimb',252,8,162,42.4224518,71.832272,116.879656,1.8,71.7799016,116.8044865,1.2130409,4.810617,5.3603743,264.2349073,313.2494945,6.2034289,58.437989,54.9274463,103.9958164,9.453136,11.0889478,2.1910458,32.6309903),(36078,'hindlimb',252,8,163,41.906378,71.9027081,116.826785,1.8,71.8629571,116.7771577,1.240983,4.7366374,5.3079431,260.4420525,303.4833197,6.2518068,57.1753148,54.9845868,101.4756833,9.453136,11.0889478,2.1910458,32.6309903),(36079,'hindlimb',252,8,164,41.4600167,71.9036601,116.7849698,1.8,71.8221707,116.7394451,1.2331987,4.7193323,5.2769023,259.0891608,295.9316884,6.1519235,56.0805701,54.899538,100.4387828,9.453136,11.0053826,2.2455373,32.6309903),(36080,'hindlimb',252,8,165,40.9827156,71.9550747,116.7206955,1.8,71.8971245,116.660292,1.1658338,4.7793536,5.2957481,255.6652768,285.8388855,5.7702051,53.9751661,53.4936932,98.2594279,9.453136,11.0053826,2.2455373,32.3792849),(36081,'hindlimb',252,8,166,40.8233728,71.9483407,116.6789467,1.8,71.8810089,116.6180474,1.1177497,4.7449451,5.285167,254.9180162,281.2157063,5.5003558,53.2084802,53.7241233,97.9206184,9.453136,10.8448348,2.1587989,32.3792849),(36082,'hindlimb',252,8,167,40.4957913,71.9907421,116.630992,1.8,71.930745,116.5829968,1.0873581,4.7613312,5.2943752,251.0141321,273.5524927,5.2910225,51.6685132,52.7193177,95.9385396,9.453136,10.8448348,2.1587989,32.3792849),(36083,'hindlimb',252,8,168,40.2986269,71.9828965,116.5848908,1.8,71.9011253,116.5461941,1.0394976,4.7636512,5.3099399,248.185882,271.0109656,4.9923433,51.0384239,52.0999273,95.5261961,9.453136,10.7422,2.2142974,32.3792849),(36084,'hindlimb',252,8,169,40.1823648,72.0333878,116.5336727,1.8,71.9837891,116.472457,1.0086949,4.7292764,5.3257229,244.3724065,265.8344612,4.7947463,49.9151879,51.6722611,94.0456957,9.453136,10.7422,2.2142974,31.7716143),(36085,'hindlimb',252,8,170,40.2555462,72.0359501,116.4959019,1.8,71.9616909,116.4479034,1.003722,4.8017703,5.3003146,244.3363825,264.0362904,4.7733149,49.8152106,50.8846463,93.8396052,9.453136,10.7422,2.2142974,31.7716143),(36086,'hindlimb',252,8,171,40.3102643,72.0966161,116.4543861,1.8,71.9952591,116.4271893,1.0055878,4.7951089,5.2958176,243.0688054,259.4833839,4.7911525,48.9977952,50.6909873,92.8675728,9.453136,10.7422,2.2142974,32.1275795),(36087,'hindlimb',252,8,172,40.3250348,72.1037289,116.4181428,1.8,72.0093611,116.4100476,0.9825543,4.7125796,5.2938402,242.6994556,257.5874401,4.6514032,48.6579553,51.5003403,92.8075935,9.453136,10.7422,2.2142974,32.1275795),(36088,'hindlimb',252,8,173,40.2510143,72.1725006,116.3672943,1.8,72.103594,116.3164199,0.9739134,4.7437864,5.1713898,239.5475041,253.1784135,4.5891564,48.9575187,50.4971097,94.9717565,9.453136,10.6125107,2.1251038,31.8758741),(36089,'hindlimb',252,8,174,40.2633231,72.1612991,116.3294493,1.8,72.0792491,116.287206,0.9069824,4.7747104,5.3211006,238.1669569,251.2234832,4.1631574,47.2126918,49.8809218,91.1545213,9.453136,10.6732285,2.2706892,32.1275795),(36090,'hindlimb',252,8,175,40.2153188,72.1842979,116.2829026,1.8,72.1291562,116.2348644,0.8401723,4.7813172,5.0841057,235.3354763,247.2967325,3.7176691,48.6411465,49.2197996,93.7008376,9.5276277,10.4900209,2.1815223,32.2318393),(36091,'hindlimb',252,8,176,40.2237112,72.1723015,116.2479583,1.8,72.1246438,116.1634274,0.8178748,4.7546462,5.0375169,233.381508,245.7651167,3.5695445,48.7869559,49.0849362,93.5554721,9.5881412,10.3927662,2.0899424,31.9801339),(36092,'hindlimb',252,8,177,40.058158,72.2147267,116.2139944,1.8,72.2072269,116.1336173,0.8013174,4.6898898,5.0316934,229.5572819,241.7311868,3.4444444,48.0417167,48.9472655,91.7150831,9.453136,10.4900209,2.1815223,31.6241687),(36093,'hindlimb',252,8,178,39.99667,72.2088299,116.1847075,1.8,72.1801542,116.1073938,0.7710704,4.6851843,5.0112552,228.3919334,240.2073861,3.2375584,47.9335767,48.7476945,91.5613228,9.453136,10.3927662,2.0899424,31.3724633),(36094,'hindlimb',252,8,179,40.0064611,72.2745832,116.1475078,1.8,72.2774614,116.0662391,0.7964935,4.8909895,5.0228267,227.6673793,237.6270086,3.4078466,47.3094178,46.5483274,92.0168882,9.453136,10.3927662,2.0899424,31.2682035),(36095,'hindlimb',252,8,180,39.9361891,72.2768239,116.1245009,1.8,72.2855186,116.0439162,0.7884116,4.8747101,5.0032084,227.2524543,236.0963455,3.3480734,47.1889887,46.6186606,91.5700871,9.453136,10.3927662,2.0899424,31.2682035),(36096,'hindlimb',252,8,181,39.5485743,72.3201939,116.0961321,1.8,72.3230157,116.01576,0.7200028,4.9033774,5.043377,223.1383713,232.4608545,2.8658937,46.0923014,45.5070769,90.1596697,9.453136,10.3927662,2.0899424,31.2682035),(36097,'hindlimb',252,8,182,39.3523051,72.3182419,116.0731352,1.8,72.3085881,115.9898306,0.7062973,4.901048,5.0308196,221.4512502,230.8484977,2.7627196,45.8868567,45.1844685,89.7833758,9.453136,10.3838797,1.1441688,31.2682035),(36098,'hindlimb',252,8,183,38.9809715,72.3849003,116.0582507,1.8,72.352945,115.9669033,0.6618538,4.8863311,5.0809631,217.7786971,226.7070828,2.4539099,44.6189193,44.5689606,87.466366,9.453136,10.2135672,1.1824776,31.0164981),(36099,'hindlimb',252,8,184,38.7770373,72.3863001,116.034356,1.8,72.3779997,115.9581342,0.6235341,4.8927468,5.067931,216.3721839,224.9516452,2.2034944,44.3872746,44.2230493,87.0700407,9.453136,10.2135672,1.1824776,31.0164981),(36100,'hindlimb',252,8,185,38.4726186,72.4362229,116.015337,1.8,72.3854169,115.9514958,0.6013764,4.8606501,5.0952564,213.2806558,221.0912209,2.0525439,43.3915788,43.8790396,85.2127765,9.4174746,10.2135672,1.1824776,31.0164981),(36101,'hindlimb',252,8,186,38.455778,72.4370907,115.991046,1.8,72.381514,115.9092886,0.5686142,4.9544807,5.0752233,212.8941805,219.6998897,1.8583391,43.2887138,42.9700292,85.0908785,9.4174746,10.2496576,0.9944211,31.2682035),(36102,'hindlimb',252,8,187,38.2004266,72.528621,115.9708832,1.8,72.5229191,115.8857061,0.5362189,5.0176486,4.9118003,209.6932384,215.6310729,1.6617683,43.9006189,41.7911369,84.7413584,9.453136,10.2135672,1.1824776,30.7647927),(36103,'hindlimb',252,8,188,38.2038395,72.5291814,115.9599177,1.8,72.5136865,115.8674153,0.5140256,5.0039219,4.9050711,208.7099521,214.7481952,1.5393326,43.7808531,41.7092748,84.530966,9.453136,10.1864154,1.088283,30.7647927),(36104,'hindlimb',252,8,189,38.0451681,72.5946937,115.9483682,1.8,72.6029923,115.8470004,0.5113442,4.9611393,4.9561937,207.054623,211.4410983,1.5184038,42.661992,41.735297,84.2874269,9.023448,10.1864154,1.088283,30.4088275),(36105,'hindlimb',252,8,190,37.9279549,72.5955468,115.9298195,1.8,72.6211665,115.8418078,0.5547462,4.9488568,4.9467315,207.0592186,210.4794451,1.7538006,42.5491957,41.8398085,84.2444119,9.023448,10.2135672,1.1824776,30.7647927),(36106,'hindlimb',252,8,191,37.6572735,72.634855,115.9075208,1.8,72.6120637,115.830864,0.606158,4.9011835,4.9529415,203.529983,208.5980562,2.0370969,42.1159947,41.5267009,82.8995872,9.023448,10.1864154,1.088283,30.4088275),(36107,'hindlimb',252,8,192,37.4821531,72.6357985,115.8911478,1.8,72.617272,115.8127062,0.6189218,4.8833022,4.9383429,202.2797954,207.5993998,2.1026395,42.0382713,41.4227477,82.5683732,9.023448,10.0219602,1.0303768,30.4088275),(36108,'hindlimb',252,8,193,37.2858839,72.6832514,115.9049198,1.8,72.6358388,115.8327447,0.7470962,4.7781845,4.8774275,199.3008028,205.9406907,2.8693696,42.2232196,41.710571,80.8511791,9.023448,10.0219602,1.0303768,30.0528623),(36109,'hindlimb',252,8,194,37.1693421,72.6805872,115.8905435,1.8,72.6595797,115.7685241,0.7852308,4.7282487,4.8178196,197.7975405,205.7370297,3.0964082,42.7033485,41.8331504,80.6616322,9.023448,9.9942879,1.1263771,30.4088275),(36110,'hindlimb',252,8,195,36.8979334,72.717643,115.8824118,1.8,72.6946692,115.7635518,0.869809,4.6813459,4.806887,194.4815526,204.3573751,3.5914633,42.5134551,41.5439396,81.4056664,9.023448,9.9942879,1.1263771,30.1571221),(36111,'hindlimb',252,8,196,36.7632081,72.7116193,115.8779505,1.8,72.6944296,115.7496993,0.9100202,4.664597,4.7727644,193.1420418,204.2781063,3.8193034,42.8007939,41.4059439,81.2403718,9.023448,9.9942879,1.1263771,30.1571221),(36112,'hindlimb',252,8,197,36.5236903,72.7657059,115.8898675,1.8,72.7360367,115.822267,0.9150997,4.6261217,4.7326535,191.1006574,202.380089,3.8243456,42.7624985,41.3090423,79.6077273,9.023448,10.0311674,2.3259007,30.0528623),(36113,'hindlimb',252,8,198,36.3570182,72.7614912,115.8817318,1.8,72.7293645,115.7622174,0.9596126,4.5927569,4.6735443,190.3971523,202.2599159,4.0641738,43.2776293,41.4559617,79.5725468,9.023448,10.0311674,2.3259007,30.4088275),(36114,'hindlimb',252,8,199,36.0354232,72.8232978,115.8863311,1.8,72.8461712,115.8096168,0.9806271,4.6436943,4.6406573,188.3713213,201.157028,4.1459109,43.3466672,40.5649699,78.9344714,9.1723375,9.8172189,2.7367009,30.5130873),(36115,'hindlimb',252,8,200,35.8884451,72.8225626,115.8817269,1.8,72.843494,115.8002467,1.00613,4.631313,4.6498897,188.0870044,201.5987489,4.2685217,43.3555985,40.6120259,79.0072416,9.1723375,9.8172189,1.9756881,30.5130873),(36116,'hindlimb',252,8,201,35.5869358,72.8965969,115.8834522,1.8,72.9127672,115.819215,1.0019019,4.5718065,4.6079342,186.5308298,200.5153117,4.2099421,43.515229,40.8002462,79.9121886,9.1056026,9.8172189,1.1659045,30.5130873),(36117,'hindlimb',252,8,202,35.4094655,72.8926061,115.880791,1.8,72.9028242,115.8090746,0.9905862,4.5789351,4.6095881,185.7862954,200.1140968,4.1280185,43.4125764,40.5741274,79.7520675,9.1056026,9.8172189,1.1659045,30.5130873),(36118,'hindlimb',252,8,203,35.181809,72.9480849,115.8902864,1.8,72.9558553,115.8240321,1.0033849,4.5313285,4.5873679,184.8958983,199.9090569,4.1699036,43.5781608,40.8039049,79.1458821,9.023448,9.8172189,1.1659045,30.1571221),(36119,'hindlimb',252,8,204,35.1216638,72.9454514,115.8867654,1.8,72.9569301,115.8193312,1.0287285,4.5168813,4.5840756,185.0334923,200.8275462,4.2956043,43.8098237,40.964878,79.4292552,9.023448,9.8172189,1.1659045,30.1571221),(36120,'hindlimb',252,8,205,34.8350929,72.9957367,115.8995572,1.8,73.0249247,115.7954072,1.039198,4.6256448,4.7012896,183.1206304,200.7623764,4.3139805,42.703682,39.588131,78.2186735,9.023448,9.8921606,2.1708465,30.1571221),(36121,'hindlimb',252,8,206,34.702158,72.9852141,115.9083404,1.8,73.0056438,115.8160653,1.0637619,4.4673983,4.714774,182.5740558,201.3758207,4.4199289,42.711659,40.8680948,78.3069716,9.023448,9.8921606,2.1708465,30.1571221),(36122,'hindlimb',252,8,207,34.4130694,73.0170834,115.9354529,1.8,73.0524512,115.8372953,1.0683025,4.6183115,4.6782593,181.3239997,201.0343362,4.4051555,42.9720383,39.2619687,77.3326449,9.023448,9.8921606,2.5415424,30.1571221),(36123,'hindlimb',252,8,208,34.3857103,73.0122796,115.9485588,1.8,73.0414863,115.8460743,1.0925092,4.6196993,4.6813974,181.6622311,202.1754476,4.5169155,43.1869865,39.3233883,77.5927011,9.023448,9.8921606,2.5415424,30.1571221),(36124,'hindlimb',252,8,209,34.1592287,73.0595774,115.9746965,1.8,73.0636469,115.8627966,1.1170475,4.5861336,4.6468515,180.3404416,202.0230995,4.5993108,43.4752645,39.3229807,78.2872326,9.023448,9.8172189,1.9756881,30.1571221),(36125,'hindlimb',252,8,210,34.1015452,73.0621014,115.9874758,1.8,73.0745927,115.8706885,1.1391322,4.5962408,4.6411817,180.2660084,203.6818894,4.6887113,43.8857826,39.2203144,78.4546023,9.023448,10.0311674,2.3259007,30.4088275),(36126,'hindlimb',252,8,211,33.9717435,73.1282219,116.0100789,1.8,73.1268379,115.9248645,1.1797317,4.550331,4.653346,179.7087976,204.8123961,4.839316,44.014005,39.493566,78.8862385,9.023448,9.9665388,1.4410938,30.5130873),(36127,'hindlimb',252,8,212,33.8181634,73.1312198,116.0260877,1.8,73.1326213,115.9508232,1.1928207,4.5533657,4.6693867,180.0324976,206.187967,4.8687428,44.157398,39.5383349,79.0767176,9.023448,9.9665388,1.7004989,30.5130873),(36128,'hindlimb',252,8,213,33.5412158,73.1953299,116.062563,1.8,73.2116966,115.9855583,1.2115312,4.5043954,4.7228171,179.2529704,207.4114223,4.8991811,43.9168866,39.795123,80.1205349,9.2246579,10.0311674,1.3986055,30.8690525),(36129,'hindlimb',252,8,214,33.421261,73.1914112,116.0856622,1.8,73.2204878,115.9992335,1.2264324,4.5124874,4.7696937,179.1845387,209.2484403,4.9353599,43.8704143,39.7085962,80.0982236,9.2246579,10.0587382,1.9195673,30.8690525),(36130,'hindlimb',252,8,215,33.3617313,73.2372883,116.1139395,1.8,73.2494092,116.0033652,1.2434135,4.4727045,4.7755208,179.1969007,210.8317432,4.9853286,44.1484297,40.0645517,80.0729718,9.2246579,10.0587382,1.9195673,30.8690525),(36131,'hindlimb',252,8,216,33.2855847,73.2355057,116.1414718,1.8,73.2293356,116.0226682,1.2498014,4.4814638,4.7984676,179.6448375,213.0889656,4.9953504,44.4077116,40.0861962,80.1754176,9.2246579,10.0587382,1.9195673,30.8690525),(36132,'hindlimb',252,8,217,33.2652752,73.2869249,116.1968694,1.8,73.3136153,116.098658,1.2987818,4.6011877,4.7917019,179.1326654,215.898014,5.1440042,45.056646,38.931832,79.8373737,9.023448,10.1136544,1.784857,30.7647927),(36133,'hindlimb',252,8,218,33.3359388,73.2871337,116.2109988,1.8,73.307545,116.0892228,1.3194246,4.5008363,4.8381903,179.9090714,219.8057324,5.2122516,45.4313946,39.9723653,80.5778465,9.023448,10.2135672,1.959115,30.7647927),(36134,'hindlimb',252,8,219,33.6939006,73.3116224,116.2417714,1.8,73.3334187,116.107154,1.3352505,4.5920004,4.8775895,182.0896108,224.4148137,5.3098031,46.0093683,39.6536574,81.4060997,9.023448,10.2135672,1.959115,30.7647927),(36135,'hindlimb',252,8,220,34.1691876,73.2973001,116.2612476,1.8,73.2986153,116.1389105,1.3674339,4.6071286,4.9201562,184.8730093,229.5282167,5.4625752,46.6505958,40.1275991,82.7277347,9.023448,10.2135672,1.959115,31.0164981),(36136,'hindlimb',252,8,221,34.3299851,73.3404826,116.2823092,1.8,73.2967485,116.2086019,1.3860222,4.5644451,4.9620506,186.3522635,235.03653,5.5285312,47.3668147,40.8269261,83.8571635,9.023448,10.3927662,1.6951513,31.3724633),(36137,'hindlimb',252,8,222,34.2622868,73.339025,116.3124826,1.8,73.3134431,116.2274164,1.3982824,4.5671341,4.9988623,187.7317143,238.7832251,5.5421134,47.7675138,41.1049272,84.3711245,9.023448,10.4547603,1.735945,31.3724633),(36138,'hindlimb',252,8,223,34.4841246,73.3910491,116.340591,1.8,73.3413527,116.2262194,1.4149119,4.5131923,5.04357,189.3130349,243.9960998,5.6088213,48.3776574,41.9465914,84.317332,9.023448,10.5339308,1.3654009,31.3724633),(36139,'hindlimb',252,8,224,34.4129575,73.3743385,116.3851888,1.8,73.3489693,116.2784835,1.4399402,4.521917,5.0951462,190.4183242,248.3189414,5.6378415,48.7363724,42.1100882,84.6012228,9.023448,10.6298941,1.3258177,31.3724633),(36140,'hindlimb',252,8,225,34.5392344,73.4203657,116.4339571,1.8,73.4081302,116.2398946,1.4795268,4.4514854,5.157385,192.0894674,253.0187354,5.7087193,49.0595015,43.1517681,85.1781688,9.023448,10.6298941,1.3258177,31.6241687),(36141,'hindlimb',252,8,226,34.0879496,73.3861725,116.4747865,1.8,73.3761082,116.3149856,1.506052,4.4634626,5.1966765,192.7807202,256.67053,5.657543,49.391285,43.1908443,85.2546232,9.023448,10.7422,1.2870022,31.6241687),(36142,'hindlimb',252,8,227,33.9776181,73.4216061,116.5220876,1.8,73.427575,116.3724369,1.528897,4.4233062,5.2439958,194.8677184,262.7891866,5.6530006,50.1123943,44.0547662,86.1522182,9.023448,10.8788312,1.4121411,32.2318393),(36143,'hindlimb',252,8,228,33.349926,73.4048886,116.5554656,1.8,73.3963902,116.3923544,1.5457054,4.4131451,5.284376,194.2660995,266.8948061,5.5548225,50.5063998,44.019876,86.2312184,9.023448,10.9549375,1.7681919,32.2318393),(36144,'hindlimb',252,8,229,33.0230718,73.4487199,116.6232214,1.8,73.4203356,116.458914,1.5675949,4.3308575,5.3352883,195.8471434,270.5745887,5.5037889,50.714146,45.2213321,86.2573667,9.023448,11.0472442,1.3352513,32.4835447),(36145,'hindlimb',252,8,230,32.9510095,73.4291191,116.6443385,1.8,73.4054225,116.3975752,-1.5610678,4.3548089,5.3637157,197.5955037,274.3820384,5.4913152,51.1552162,45.3740928,86.8980053,9.023448,11.0472442,1.3352513,32.4835447),(36146,'hindlimb',252,8,231,33.2886059,73.4657249,116.6880973,1.8,73.4146195,116.4285311,-1.5350882,4.3685879,5.4111937,200.9473274,281.0708395,5.5410298,51.9424832,45.9982341,88.9641824,9.023448,11.171888,1.1760052,32.7352501),(36147,'hindlimb',252,8,232,32.7926178,73.4607718,116.7459069,1.8,73.4452074,116.5292896,-1.5275657,4.7250284,5.4708727,204.2647845,282.8482686,5.4552284,51.7007584,43.2303824,88.9724393,9.453136,11.2460112,1.4559197,33.4471805),(36148,'hindlimb',252,8,233,32.7370604,73.495836,116.8356057,1.8,73.4743064,116.6351195,-1.5056243,4.699961,5.2419732,210.4426226,285.3155856,5.433035,54.4290431,44.7753977,91.7421037,9.453136,11.171888,1.1760052,33.0912153),(36149,'hindlimb',252,8,234,32.5230554,73.4862855,116.887731,1.8,73.5099756,116.6608871,-1.4948737,4.7349786,5.2835968,212.3204833,290.1812069,5.3893241,54.9211494,44.8408537,92.199272,9.453136,11.2787985,1.2610934,33.0912153),(36150,'hindlimb',252,8,235,32.4384046,73.5188946,116.959223,1.8,73.5496139,116.7442607,-1.4838513,4.7339498,5.3661287,217.1576991,296.1751974,5.3656343,55.1934572,45.8724129,92.855151,9.453136,11.417094,1.2252407,33.5946261),(36151,'hindlimb',252,8,236,32.5352523,73.5118009,117.0069154,1.8,73.552883,116.7515429,-1.4734727,4.7399149,5.4266067,220.9489415,302.2223199,5.3713423,55.6926887,46.6145372,93.9045235,9.453136,11.417094,1.2252407,33.5946261),(36152,'hindlimb',252,8,237,32.3510681,73.5477985,117.0634708,1.8,73.5764972,116.8369914,-1.4728963,4.740715,5.4800416,224.2618516,309.0705723,5.3403319,56.3993116,47.3054912,94.6237827,9.453136,11.5697035,1.1902899,33.9505913),(36153,'hindlimb',252,8,238,32.3207438,73.5374771,117.1183565,1.8,73.5734948,116.9185501,-1.4566581,4.754492,5.5531655,227.8844897,314.5124243,5.3169182,56.6366019,47.9303547,95.4054312,9.453136,11.6887773,1.2722974,34.2022967),(36154,'hindlimb',252,8,239,32.5836482,73.5940856,117.2202235,1.8,73.6070508,116.9788169,-1.4506778,4.961159,5.6535885,235.7582392,320.1466027,5.3526288,56.6271493,47.5207984,95.8508308,9.882824,11.8222779,1.237552,34.8099673),(36155,'hindlimb',252,8,240,32.6463671,73.5528185,117.3028247,1.8,73.5605148,116.9828168,-1.4461519,5.0409224,5.744833,240.9131992,326.3839916,5.3569644,56.8134863,47.7914912,96.7202965,10.312512,11.9697226,1.2036225,35.1659325),(36156,'hindlimb',252,8,241,33.207312,73.5978766,117.3565883,1.8,73.6485232,117.0825716,-1.4197907,5.0345823,5.7492331,249.813561,339.0658788,5.4093057,58.9758446,49.6195207,99.2989448,10.312512,11.9851376,1.3171222,36.0253085),(36157,'hindlimb',252,8,242,33.7076641,73.5749796,117.4251125,1.8,73.5927021,117.1676691,-1.4059603,5.1106429,5.824274,257.71517,352.449407,5.4666768,60.5138776,50.4271526,101.8883192,10.312512,12.1001239,1.2827409,36.0253085),(36158,'hindlimb',252,8,243,33.5876534,73.6088971,117.5660498,1.8,73.6134089,117.2835706,-1.4249853,5.1200337,5.9532012,262.5487208,359.6909207,5.4797663,60.4197483,51.2787093,101.4550521,10.312512,12.3043918,1.359703,36.3812737),(36159,'hindlimb',252,8,244,33.8806585,73.5688819,117.6391071,1.8,73.599807,117.4042635,-1.4333049,5.205986,6.0283934,270.8927001,372.0133182,5.5407014,61.7101927,52.0348496,105.2998804,10.312512,12.4015431,1.3258177,36.8846845),(36160,'hindlimb',252,8,245,34.387165,73.5911506,117.7766533,1.8,73.6311226,117.4814932,-1.4289492,5.2281424,6.1022366,281.1631232,382.1713676,5.6166505,62.628081,53.7787805,106.3199829,10.312512,12.4015431,1.3258177,36.8846845),(36161,'hindlimb',252,8,246,35.1797948,73.5904337,117.8441011,1.8,73.6069077,117.5831062,-1.423677,5.2238847,6.1683486,288.1980253,400.6737647,5.7373063,64.956407,55.1692929,109.3509324,10.312512,12.644806,1.4000611,37.7440605),(36162,'hindlimb',252,8,247,36.0795111,73.5903721,117.9498431,1.8,73.6406816,117.7177086,-1.4763022,5.5491175,6.2329775,304.0642161,411.1794457,5.9597182,65.9683826,54.7950578,111.8375892,10.7422,12.7755427,1.2277724,38.1000257),(36163,'hindlimb',252,8,248,36.3270295,73.5533778,118.0141333,1.8,73.6136159,117.806518,-1.4605016,5.5868492,6.2485558,310.4608084,420.4729313,5.9811505,67.2912186,55.5699285,113.5270524,10.7422,12.9263977,1.1964627,38.6034365),(36164,'hindlimb',252,8,249,36.8473554,73.5518415,118.1814152,1.8,73.6071676,118.0168155,-1.4359449,5.68948,6.199042,321.0147448,430.479423,6.0302236,69.442895,56.4225106,116.8803416,11.171888,13.047241,1.2698761,38.9594017),(36165,'hindlimb',252,8,250,36.7049652,73.5289368,118.2737285,1.8,73.560577,118.0888791,-1.4157827,5.7157572,6.3090075,327.5940951,434.6024215,5.9716693,68.8860205,57.3142076,117.107548,11.171888,13.1809902,1.2387369,39.2111071),(36166,'hindlimb',252,8,251,37.3056898,73.5571737,118.4361095,1.8,73.6230552,118.2275296,-1.4351103,6.0181459,6.4513543,338.3199308,447.7617526,6.103845,69.4058539,56.2166385,117.8366842,11.601576,13.3411032,1.3101939,40.1747429),(36167,'hindlimb',252,8,252,37.7711298,73.5285652,118.6004527,1.8,73.5915879,118.3399511,-1.4319434,6.0838236,6.5610179,347.093266,461.8361112,6.1745943,70.3909236,57.0518291,118.6675038,11.601576,13.4856331,1.0358413,40.4264483),(36168,'hindlimb',252,8,253,38.7999764,73.5899476,118.6373799,1.8,73.628802,118.440428,-1.4497139,6.0614676,6.5833207,365.4087454,478.3421418,6.3723177,72.6597057,60.2838732,122.7864895,11.601576,13.6556983,1.7928782,41.0341189),(36169,'hindlimb',252,8,254,39.4120587,73.5567599,118.7498731,1.8,73.5293276,118.5913492,-1.4612504,6.1177707,6.6469304,374.8456131,494.1466202,6.4901651,74.3420786,61.2716025,124.7238712,12.031264,13.8703393,1.8533513,41.3900841),(36170,'hindlimb',252,8,255,40.5678536,73.5875044,118.860996,1.8,73.5737142,118.6804439,-1.4667556,6.4063442,6.7538676,392.1066653,510.7124141,6.688385,75.6177708,61.205994,127.4726923,12.460952,13.9962251,1.8828384,41.9977547),(36171,'hindlimb',252,8,256,41.5634105,73.5228837,118.9561955,1.8,73.5659652,118.7942481,-1.4858386,6.4911064,6.8156122,407.2502863,531.3894067,6.8773558,77.9664967,62.7397335,131.2296527,12.460952,14.1731921,1.815775,42.8571307),(36172,'hindlimb',252,8,257,42.3412139,73.5173331,119.1671485,1.8,73.5802229,118.9288789,-1.4909952,6.5440737,7.0272543,420.0307384,541.5334761,7.0120246,77.0618867,64.1849035,132.447788,12.460952,14.283491,1.8449638,42.8571307),(36173,'hindlimb',252,8,258,43.5280045,73.4749944,119.2827699,1.8,73.5670783,119.0961506,-1.5361224,6.523489,7.129971,441.1086204,559.5202078,7.2459487,78.4744019,67.6185124,136.1840753,12.460952,14.4441652,1.9678758,43.7165067),(36174,'hindlimb',252,8,259,45.7879534,73.4458186,119.4425762,1.8,73.6416527,119.2296911,-1.5359165,6.9619474,7.2756624,469.6867129,583.0973372,7.6220451,80.1435391,67.4648469,140.7076297,12.89064,14.6157096,1.9949907,44.3241773),(36175,'hindlimb',252,8,260,47.2535941,73.4251465,119.5716188,1.8,73.5979976,119.3666645,1.5670119,6.9269078,7.426055,488.8837872,604.4525879,7.8754862,81.3961903,70.5774927,146.4247326,13.2090365,14.7101476,1.6879051,45.2878131),(36176,'hindlimb',252,8,261,49.1683375,73.5626544,119.6824551,1.8,73.7337032,119.5219924,1.4236205,7.048236,7.4180791,500.4763831,641.6759384,8.0184972,86.5016312,71.0073243,150.5345736,13.1341153,14.9158068,1.7738415,45.7912239),(36177,'hindlimb',252,8,262,52.3482562,73.5517316,119.7158625,1.8,73.7209804,119.6549435,1.4133439,7.0466054,7.4653446,538.3663108,687.3903273,8.5101943,92.077508,76.4008027,160.2190255,13.2201149,15.240301,2.2763645,46.2946347),(36178,'hindlimb',252,8,263,56.8492992,73.5206596,119.9107887,1.8,73.7102402,119.8297477,1.3313496,7.0601341,7.7452109,606.816885,753.9408576,8.9419463,97.3428435,85.9497671,174.5923444,13.645261,15.5283322,1.8224863,47.3625303),(36179,'hindlimb',252,8,264,57.9339829,73.5382161,120.0050619,1.8,73.6934952,119.8183486,1.2099666,6.8198119,7.9335843,619.82596,765.4413716,8.4521356,96.4811539,90.8860789,172.6267693,13.6100887,15.6408793,1.849096,47.8659411),(36180,'hindlimb',252,8,265,65.9144397,73.6722721,120.2055802,1.8,73.8230441,120.0510056,1.2466916,6.9753308,8.1167454,691.7378032,942.6564122,9.8716001,116.1372408,99.1691757,197.7456388,13.4535351,16.3337968,2.0344439,48.4736117),(36181,'hindlimb',252,8,266,73.6543716,73.5783297,120.3919511,1.8,73.7926385,120.1590745,1.2047038,7.1552988,8.1616137,726.9596973,1110.4485532,10.7026894,136.0574743,101.5973919,223.2952986,13.4436922,16.3620316,1.9756881,48.2219063),(36182,'hindlimb',252,8,267,74.308136,73.5051849,120.3124562,1.8,73.7679096,120.3538077,1.1536936,6.7816416,7.9083377,670.0083845,1090.9131878,10.3521541,137.9446889,98.7973742,222.4202139,12.910837,16.3055132,1.8925469,47.3625303),(36183,'hindlimb',252,8,268,67.5529628,73.3813228,120.2546037,1.8,73.6708033,120.4903505,1.1117528,6.4134169,7.9799151,591.9548825,1037.617753,9.0483872,130.0286704,92.2994552,200.9578862,12.5033537,16.3620316,1.9756881,46.7548597),(36184,'hindlimb',252,8,269,61.6086029,73.3623348,120.5646711,1.8,73.5273291,120.6189304,1.1154175,6.1909923,8.0592249,484.2940249,980.165002,8.2819802,121.6202561,78.2255895,180.9816537,11.9595284,16.5861794,1.8597717,46.2514489),(36185,'hindlimb',252,8,270,68.2653617,73.3085899,120.6569345,1.8,73.3419864,120.6635426,1.1153936,5.893889,8.299495,469.6761099,1073.2964751,9.1766259,129.3206971,79.6886586,185.5297045,11.5520451,16.5973074,1.9416876,46.6074141),(36186,'hindlimb',252,8,271,70.8266521,73.1080834,120.9091065,1.8,73.1500851,120.9260567,1.0757445,5.5531709,8.4407331,430.046466,1119.8713896,9.1401981,132.6746597,77.4416052,183.6125033,10.9189774,16.5973074,1.9416876,45.5395185),(36187,'hindlimb',252,8,272,59.079651,72.6635004,121.3995544,1.8,72.9455059,121.3437586,1.0622321,5.7496714,8.5276678,323.1249697,995.5362562,7.5120303,116.7419128,56.1988588,154.099531,10.3957596,16.5861794,2.2091161,46.7548597),(36188,'hindlimb',252,8,273,31.1689212,72.7516974,123.2448662,1.8,72.7272721,123.0626432,0.8757235,4.4135838,8.7199993,95.7563939,496.88203,3.0640859,56.9818885,21.6958366,66.9771533,8.3972651,15.5698916,2.2584676,43.3605415),(36189,'hindlimb',252,8,274,18.5975113,74.2173069,125.0728306,1.8,74.2271697,124.8100411,0.061719,7.0136318,5.8829404,31.5710906,92.1355328,0.0117921,15.6614765,4.5013898,13.8980663,5.156256,9.5115493,2.8198421,24.3321216),(36190,'hindlimb',252,8,275,13.3254349,74.3268898,124.891902,1.8,74.6764872,124.8748465,0.0645626,2.1916116,4.3897143,12.4579294,59.7725637,0.0092446,13.6165043,5.6843692,15.9123799,4.726568,8.9721488,2.8501359,22.865075),(36191,'hindlimb',252,8,276,10.686823,74.3190398,124.7944426,1.8,74.6395099,124.7928135,0.0575854,1.8520365,4.3455308,6.6740182,41.1892966,0.0058999,9.4785421,3.6036105,10.9620609,3.867192,8.3430318,2.9340964,20.7903578),(36192,'hindlimb',252,8,277,4.8254354,73.6873693,124.8603071,1.8,73.9651974,124.8508516,-0.0207974,1.5528359,3.2313002,1.8217558,5.7990597,0.0003478,1.7946521,1.1731798,2.3546373,3.437504,5.8443887,0.2984989,14.7747258),(36193,'hindlimb',252,8,278,0.6571213,73.4827211,124.9325634,1.8,73.4971093,124.9573627,-0.2202595,0.9413554,0.9971467,0.1382522,0.1848142,0.0052279,0.185343,0.1468651,0.283924,2.14844,2.7513456,0.6747409,6.8318222),(36194,'hindlimb',252,8,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36195,'hindlimb',252,8,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36196,'hindlimb',252,8,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36197,'hindlimb',252,8,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36198,'hindlimb',252,8,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36199,'hindlimb',252,8,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36200,'hindlimb',252,8,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36201,'hindlimb',252,8,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36202,'hindlimb',252,8,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36203,'hindlimb',252,8,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36204,'hindlimb',252,8,289,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36205,'hindlimb',252,8,290,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36206,'hindlimb',252,8,291,1.4829848,83.3050356,123.3733524,1.8,83.1381176,123.320456,1.5014429,1.2577704,1.7636171,0.3509079,1.0908618,0.2459772,0.6185367,0.278992,0.7850193,6.3620826,24.8662788,2.9679215,57.8656737),(36207,'hindlimb',252,8,292,3.0696991,82.8022701,123.4159622,1.8,82.7082261,123.2801728,1.4769891,1.6557934,2.5694374,1.6757784,3.7540134,0.5071276,1.4610254,1.0120698,1.9052169,7.0632059,27.8337015,2.9865959,64.8449415),(36208,'hindlimb',252,8,293,4.8734397,82.0427339,123.2632481,1.8,82.0623764,123.0955726,-1.2588807,2.2646048,3.3441811,5.1499603,9.4179094,0.7357458,2.8162079,2.2741099,4.248783,7.9509954,31.8694118,0.067465,75.7651241),(36209,'hindlimb',252,8,294,6.7768814,81.4497503,123.2137595,1.8,81.4888969,123.0082161,-0.9826561,2.7611403,4.0690839,10.4532707,16.3653889,0.7818043,4.0218853,3.7858527,6.5889105,8.1766167,35.3286118,0.0730406,83.3088767),(36210,'hindlimb',252,8,295,10.0976238,80.5638609,122.93263,1.8,80.5665,122.7764473,-0.5604714,3.160317,4.5814239,24.2590181,37.6243964,0.4755698,8.2123806,7.6761344,13.0436935,8.5462915,39.5896345,0.0542944,91.5034857),(36211,'hindlimb',252,8,296,12.517475,79.7277835,122.8457346,1.8,79.8906039,122.6743558,-0.3218797,3.5010451,5.061935,34.979104,69.2848559,0.2087862,13.687425,9.9910465,18.6951245,8.8685253,41.7881245,0.0720401,96.8682612),(36212,'hindlimb',252,8,297,14.6319005,78.9562092,122.5909844,1.8,79.1167988,122.5575945,-0.3118464,3.5762159,5.694391,42.0404734,112.2097413,0.2295657,19.7053101,11.7555749,25.6784939,9.0787153,44.3911586,0.0775143,103.7000834),(36213,'hindlimb',252,8,298,17.2006321,78.374801,122.5183938,1.8,78.5181644,122.5594282,-0.2914458,3.4764452,6.1155895,49.5557229,158.8552252,0.2366887,25.9754557,14.2547113,33.4971023,9.3295364,45.8378624,0.1127276,106.6341766),(36214,'hindlimb',252,8,299,18.4272025,77.5820257,122.4083131,1.8,77.9976185,122.4469384,-0.2697857,3.4856387,6.8847268,55.109851,196.8080954,0.2181644,28.5861883,15.8105459,35.6319368,8.9368616,47.5946139,0.1176362,112.1895836),(36215,'hindlimb',252,8,300,19.5979358,77.1747872,122.3209109,1.8,77.7235885,122.3570393,-0.2601884,3.5007451,7.2400241,60.4340153,229.2870321,0.2161784,31.6693742,17.2631863,39.2007951,9.1292354,48.8750032,0.1145407,114.8719714),(36216,'hindlimb',252,8,301,21.3275999,76.8748733,122.2655918,1.8,77.3829025,122.3048298,-0.2213027,3.8255306,7.4572882,71.6306013,274.614349,0.1712626,36.8249614,18.7243573,45.3400545,9.1217363,50.5828743,0.1106572,119.6290764),(36217,'hindlimb',252,8,302,22.3128062,76.6934683,122.2384537,1.8,77.3229722,122.2173056,-0.2291138,3.865993,7.6404129,77.5290164,299.6332477,0.1918195,39.216892,20.0541016,48.416137,9.2117254,51.4855167,0.1171087,120.4884524),(36218,'hindlimb',252,8,303,23.9445595,76.6761158,122.2844432,1.8,77.2229321,122.2164741,-0.2181355,3.92354,7.650167,83.1073961,338.8540502,0.1868998,44.29368,21.181738,53.9256542,9.2117254,51.9638311,0.124355,124.0302162),(36219,'hindlimb',252,8,304,25.1832709,76.4767544,122.3281225,1.8,77.1525595,122.2014191,-0.2275368,4.0239589,7.8693629,86.3317849,359.4532207,0.2135779,45.6775504,21.4544399,55.5535545,9.2042263,52.4852943,0.0491407,125.393003),(36220,'hindlimb',252,8,305,27.1172048,76.4698555,122.3918568,1.8,77.2957947,122.2063494,-0.2379626,4.1939364,7.90703,90.0177626,397.9449947,0.2511297,50.3279984,21.463788,60.5627616,9.2192245,53.3436496,0.0483494,126.1049334),(36221,'hindlimb',252,8,306,28.295827,76.4019899,122.4461386,1.8,77.2879896,122.2367775,-0.2375366,4.1291128,7.9851029,94.4701321,409.7942941,0.2611252,51.3198516,22.8790387,61.9374425,9.0899632,53.7951529,0.0559416,125.7489682),(36222,'hindlimb',252,8,307,29.6295398,76.508337,122.4873807,1.8,77.3601229,122.2095994,-0.2412018,3.9850726,7.8974532,94.7128602,424.7621918,0.281771,53.7847049,23.7669093,64.428824,9.112459,53.8208877,0.0639128,125.5404486),(36223,'hindlimb',252,8,308,30.4595435,76.7047965,122.5134564,1.8,77.4886061,122.2056646,-0.2331289,4.0629748,7.6989618,95.1640892,428.6678381,0.2709457,55.6786553,23.422269,66.3304433,9.123707,54.183299,0.0396617,125.393003),(36224,'hindlimb',252,8,309,30.7832086,77.0856684,122.46159,1.8,77.8068741,122.1390522,-0.2524764,4.1099402,7.3497941,96.5407092,399.1921483,0.3201522,54.3133783,23.4895657,65.8019837,9.2174223,53.850039,0.071876,124.533627),(36225,'hindlimb',252,8,310,29.5456722,77.5202337,122.3965595,1.8,78.0030873,122.0922154,-0.2538213,4.0488169,6.9150413,94.6717515,357.2029098,0.3104931,51.6559329,23.3825716,63.4767785,8.9005996,54.2497054,0.063407,124.8895922),(36226,'hindlimb',252,8,311,27.3598557,78.272979,122.1629369,1.8,78.4875684,121.9682026,-0.2195079,4.0115412,6.7043651,98.0526418,268.5209139,0.2162102,40.0516545,24.4426359,54.6664989,8.8295716,54.1679629,0.0317354,124.2819216),(36227,'hindlimb',252,8,312,25.5316095,78.9497381,121.9955264,1.8,79.1108457,121.7958678,-0.0966593,3.9684257,5.1477276,101.1266688,201.0335563,0.0396334,39.0528735,25.482818,53.2053924,8.8295716,52.0561293,3.0920465,120.3841926),(36228,'hindlimb',252,8,313,24.8182595,79.3004539,121.8623509,1.8,79.545991,121.7141224,0.0539872,3.8190459,4.6535924,99.280145,162.9746501,0.0120442,35.0212555,25.9960598,47.6898614,8.8558034,51.2482881,3.0744668,118.05777),(36229,'hindlimb',252,8,314,24.2617905,79.5665715,121.7392457,1.8,79.8188429,121.6281463,0.237352,4.063542,4.8801232,98.6651422,141.6943726,0.2235561,29.0349993,24.2805763,44.8506834,8.8820352,51.2482881,3.0744668,117.5543592),(36230,'hindlimb',252,8,315,23.5888356,79.9521145,121.6655539,1.8,80.1511349,121.567329,0.5048183,4.5442945,4.9900839,92.607718,122.7177715,0.9196334,24.5923263,20.3788991,42.1442266,8.9082671,50.8504478,3.0654689,117.4069136),(36231,'hindlimb',252,8,316,23.1955699,80.1255159,121.5542831,1.8,80.3531532,121.4924105,0.7440607,4.6593516,5.0557059,86.2304792,113.8177046,1.7733385,22.5127226,18.5069698,39.5635102,9.2085949,50.4220148,3.0648208,117.5111734),(36232,'hindlimb',252,8,317,22.1413225,80.5752519,121.4994604,1.8,80.6375822,121.4036322,1.0207722,4.2586602,4.6976118,73.4283872,105.8531518,2.6819657,22.5333969,17.2421333,37.4978859,8.3197601,33.7380335,3.026716,78.6128457),(36233,'hindlimb',252,8,318,21.4182933,80.8051665,121.4283149,1.8,80.8891873,121.4096082,1.1323431,4.0874814,4.9252033,64.1932869,102.5957717,2.9263322,20.830769,15.704851,33.205079,8.3627234,32.0312158,3.0205654,75.6787525),(36234,'hindlimb',252,8,319,19.6747538,81.0879877,121.2847817,1.8,81.1723048,121.2955744,1.2058672,3.6369805,4.8725892,50.6768608,94.6823719,2.8614779,19.4316344,13.9337731,29.186986,8.4641236,30.0228636,2.9835027,71.2776127),(36235,'hindlimb',252,8,320,19.1867665,81.2577907,121.2126,1.8,81.3430921,121.2212921,1.2692365,3.3225451,4.81607,43.5671444,89.7180658,2.9157011,18.6288957,13.1125819,26.9145619,8.5236464,29.1079925,2.9934326,69.0554499),(36236,'hindlimb',252,8,321,17.6916967,81.5321195,121.1352071,1.8,81.6125082,121.1655056,1.3397708,2.975753,4.7353598,32.7820016,82.24752,2.7940202,17.3688005,11.0163718,23.5416442,8.6143022,27.4092448,2.9841758,65.5136861),(36237,'hindlimb',252,8,322,16.5741149,81.7555584,121.0857016,1.8,81.7777556,121.1743386,1.3581434,2.6950751,4.71366,26.2125209,77.7469365,2.639307,16.4939637,9.7260819,21.5149242,8.6103644,26.210968,2.9602729,63.4389689),(36238,'hindlimb',252,8,323,14.4763622,82.0705575,120.9871556,1.8,82.0250372,121.070599,1.4037385,2.501673,4.7051193,18.1113438,67.7943742,2.3460159,14.408641,7.2396928,17.8971832,8.7467114,24.8662788,2.9679215,60.2531703),(36239,'hindlimb',252,8,324,13.8470476,82.1972654,120.9687278,1.8,82.153481,121.0574325,1.4246042,2.2806401,4.6840591,14.6137914,62.5350918,2.2588681,13.3506199,6.4077588,16.1621454,8.7055369,24.0202894,2.9617392,58.5344183),(36240,'hindlimb',252,8,325,12.4772477,82.3796949,120.9375586,1.8,82.3256362,121.0072484,1.4456008,2.0414424,4.67187,10.5271939,52.843003,2.0471167,11.310889,5.1567431,13.3537923,8.6212022,22.8382305,2.9331274,55.8520305),(36241,'hindlimb',252,8,326,11.7222156,82.5078995,120.8714173,1.8,82.4683977,120.8585551,1.4582095,2.0315387,4.285352,8.5351369,47.2902109,1.9290423,11.0353153,4.2013165,12.8031345,8.664556,22.1820578,2.9859978,54.8452089),(36242,'hindlimb',252,8,327,10.2762131,82.7138253,120.8008328,1.8,82.6286008,120.8065804,1.4768245,1.878146,4.3205776,5.9036062,38.142646,1.6976223,8.8281359,3.1433158,10.0730989,8.6537035,20.9844416,2.9562447,52.1628211),(36243,'hindlimb',252,8,328,9.4739041,82.8227623,120.7411658,1.8,82.745632,120.7554817,1.4868001,1.6421952,4.3639673,4.5876438,32.7408423,1.5678699,7.5025406,2.7936044,8.4734477,8.8292755,20.1404075,2.9483812,50.6957745),(36244,'hindlimb',252,8,329,8.4169151,82.9858003,120.6457047,1.8,82.8935453,120.6336118,1.4980745,1.4109859,4.011709,3.1153952,25.2961929,1.3954135,6.3055902,2.2079563,7.0249103,8.8500614,19.0715653,2.8911496,48.1176465),(36245,'hindlimb',252,8,330,7.6154454,83.1001578,120.5670169,1.8,82.9412423,120.4386818,1.5015582,1.4680695,3.6518259,2.3884181,21.164286,1.263166,5.7955353,1.6269108,6.4037964,8.9144503,18.5513782,2.9078495,46.6505999),(36246,'hindlimb',252,8,331,6.4635669,83.2567829,120.3961592,1.8,83.0976309,120.4334898,1.5122563,1.2297355,3.808339,1.5244612,15.6306149,1.0735737,4.1043129,1.239666,4.4897494,8.8437176,17.8255796,2.8732264,45.1835533),(36247,'hindlimb',252,8,332,5.7720929,83.3437076,120.3209033,1.8,83.159974,120.366351,1.5227875,1.2714359,3.4466669,1.1281691,12.5323917,0.9597999,3.6360901,0.8873189,3.9503637,8.8116232,17.1982588,2.9147938,43.3605415),(36248,'hindlimb',252,8,333,4.3930054,83.4716797,120.2155364,1.8,83.3021803,120.31264,1.5401718,1.0004153,3.5426715,0.6225712,8.2259971,0.7314811,2.3219757,0.6223128,2.4933712,8.9768087,16.4688822,2.8776289,41.8934949),(36249,'hindlimb',252,8,334,3.4382353,83.5530914,120.1344803,1.8,83.4310867,120.1336033,1.5436421,0.662914,3.1912107,0.3491418,5.8848161,0.5726168,1.8440701,0.5266774,1.9513379,8.925759,16.0429641,2.7859568,41.0341189),(36250,'hindlimb',252,8,335,1.8340649,83.6540182,120.0204925,1.8,83.5247366,120.1804283,1.5496727,0.7302434,2.8724896,0.1170905,2.5106171,0.3055411,0.8740213,0.1603445,0.9144766,8.9854092,15.240301,2.7663218,40.1747429),(36251,'hindlimb',252,8,336,1.1448849,83.7000223,119.9090529,1.8,83.6308539,120.0186429,1.5494469,0.3674342,2.5533484,0.052556,1.2911082,0.1907272,0.505653,0.143035,0.5261877,8.9443445,14.9467204,2.8198421,39.3153669),(36252,'hindlimb',252,8,337,0.464265,83.7642528,119.8093696,1.8,83.7110349,119.8438895,1.5471077,0.4064101,1.7924215,0.0119546,0.3812637,0.0773341,0.2127087,0.0294151,0.2193677,8.8433879,14.4441652,2.7445132,38.2042855),(36253,'hindlimb',252,8,338,0.2564703,83.78916,119.8380522,1.8,83.78916,119.882952,1.5520198,0.0331134,1.7633409,0.0040201,0.2139313,0.04273,0.1213216,0.121404,0.1235796,8.7981975,14.225204,2.7049655,37.5966149),(36254,'hindlimb',252,8,339,0.0240581,83.78916,119.6651102,1.8,83.78916,119.668108,1.2767501,0.0631365,0.2084918,0.0004634,0.0013872,0.0036729,0.0066533,0.0073399,0.008495,8.8458876,13.7096736,2.5796711,37.3449095),(36255,'hindlimb',252,8,340,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36256,'hindlimb',252,8,341,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36257,'hindlimb',252,8,342,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36258,'hindlimb',252,8,343,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36259,'hindlimb',252,8,344,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36260,'hindlimb',252,8,345,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36261,'hindlimb',252,8,346,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36262,'hindlimb',252,8,347,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36263,'hindlimb',252,8,348,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36264,'hindlimb',252,8,349,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36265,'hindlimb',252,8,350,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36266,'hindlimb',252,8,351,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36267,'hindlimb',252,8,352,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36268,'hindlimb',252,8,353,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36269,'hindlimb',252,8,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36270,'hindlimb',252,8,355,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36271,'hindlimb',252,8,356,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36272,'hindlimb',252,8,357,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36273,'hindlimb',252,8,358,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36274,'hindlimb',252,8,359,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36275,'hindlimb',252,8,360,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36276,'hindlimb',252,8,361,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36277,'hindlimb',252,8,362,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36278,'hindlimb',252,8,363,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36279,'hindlimb',252,8,364,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36280,'hindlimb',252,8,365,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36281,'hindlimb',252,8,366,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36282,'hindlimb',252,8,367,0.4322062,83.7156263,125.6022244,1.8,83.6569483,125.5350018,1.5587021,0.364909,1.8510557,0.0180871,0.3107209,0.0720238,0.1678614,0.049566,0.1773946,14.2222883,17.4909935,1.0851742,55.6613991),(36283,'hindlimb',252,8,368,1.3652121,83.5554123,125.3803733,1.8,83.466894,125.200341,-1.5632046,0.6314623,2.4913081,0.1389935,1.250317,0.2275222,0.5018717,0.2201137,0.555601,14.8101228,17.6956349,1.0636978,57.1284457),(36284,'hindlimb',252,8,369,2.0812477,83.3466388,124.5792447,1.8,83.2463962,124.4964442,-1.4735441,1.2255383,3.0064393,0.4082275,2.5766371,0.3436042,0.8570394,0.3331006,0.9915687,15.3393777,17.4010378,0.9964915,59.559128),(36285,'hindlimb',252,8,370,2.3500828,83.2485105,124.0419051,1.8,83.1207564,123.9411164,-1.4015444,1.2104144,3.3434993,0.5857925,3.1239842,0.380567,0.9343457,0.4839603,1.1095231,15.0680827,17.4487192,0.9075933,60.9219148),(36286,'hindlimb',252,8,371,2.5248116,83.1558494,123.3489165,1.8,83.0157216,123.320456,-1.3195272,1.3677922,3.0983925,0.6926389,3.1688803,0.3947886,1.0227498,0.5063919,1.245,14.9853919,18.1285566,0.0949517,63.3525972),(36287,'hindlimb',252,8,372,2.6731884,83.1381034,122.833499,1.8,83.021207,122.799345,-1.3043304,1.3163097,3.0178536,0.7158643,3.3639582,0.4146385,1.1146857,0.5438418,1.3502536,15.0580256,18.6010739,3.0258334,65.635834),(36288,'hindlimb',252,8,373,2.9112515,83.1328854,122.2977484,1.8,83.0252702,122.2892048,-1.2905777,1.2699545,2.9150383,0.7197175,3.411677,0.4480956,1.1703712,0.566727,1.415244,15.0115209,21.1247487,3.0601406,69.7852684),(36289,'hindlimb',252,8,374,3.0229817,83.1437174,121.9871754,1.8,83.0176747,121.9142044,-1.2848212,1.308271,3.0253138,0.7407028,3.2344601,0.4637372,1.0691321,0.5661692,1.3106068,14.9304929,33.7899824,3.0140831,95.8793278),(36290,'hindlimb',252,8,375,3.3007126,83.1758194,121.726579,1.8,83.0869869,121.654105,-1.2806839,1.0949399,2.7655013,0.7411245,3.1447897,0.5051024,1.1371499,0.6768632,1.4019884,14.7718989,32.9965694,2.997854,93.19694),(36291,'hindlimb',252,8,376,3.3845802,83.1888654,121.5611317,1.8,83.0660265,121.5178624,-1.2851388,1.182782,2.6038814,0.7359258,3.1029103,0.5193048,1.1916481,0.622199,1.4721759,15.0378111,32.6364937,2.9829374,92.2333042),(36292,'hindlimb',252,8,377,3.1866885,83.2294725,121.3958337,1.8,83.0660265,121.5178624,-1.2984944,1.1765536,2.4353778,0.6439383,2.7707751,0.4926972,1.1377188,0.5473089,1.4009729,15.2793798,31.7882009,2.9786662,90.5145522),(36293,'hindlimb',252,8,378,2.9332954,83.2752276,121.2691523,1.8,83.1039818,121.3346006,-1.3184345,1.1909116,2.3027732,0.5578888,2.3470883,0.4584027,1.0192442,0.4684553,1.2610399,15.2760002,31.3642808,2.976444,89.6551762),(36294,'hindlimb',252,8,379,2.6284851,83.3783406,121.1317545,1.8,83.2683261,121.1459743,-1.4111152,0.9289917,2.5709015,0.425183,1.9509569,0.4270053,0.758861,0.4576822,0.9242435,15.2721488,30.5924579,2.9579703,88.2923894),(36295,'hindlimb',252,8,380,2.4506232,83.4164976,121.004775,1.8,83.2853879,120.9201299,-1.4290679,0.9442849,2.4393541,0.3723635,1.707352,0.4002877,0.6999197,0.3943339,0.8525104,15.2245133,30.1700955,2.9553698,88.2923894),(36296,'hindlimb',252,8,381,2.2166444,83.4564742,120.8769749,1.8,83.2853879,120.9201299,-1.4456114,0.9657059,2.3067594,0.3077553,1.5213379,0.3636813,0.659513,0.3186843,0.7927766,15.350724,29.7479429,2.9526955,87.4330134),(36297,'hindlimb',252,8,382,2.008458,83.4820057,120.7874896,1.8,83.3276433,120.8218999,-1.4608639,0.9809372,2.2140582,0.2628204,1.2960871,0.3307139,0.5853898,0.2679279,0.7037952,15.1793863,29.6702598,2.9669205,87.4330134),(36298,'hindlimb',252,8,383,1.6507759,83.5207597,120.6874246,1.8,83.3781541,120.6489176,-1.4662638,0.964529,2.1101144,0.1827924,0.9684998,0.2721339,0.4589798,0.1895146,0.5454625,15.1898913,29.5330411,2.9955804,87.2855678),(36299,'hindlimb',252,8,384,1.5385981,83.5438941,120.658156,1.8,83.4413173,120.6604827,-1.4737382,0.6447023,2.0783204,0.1508196,0.9063722,0.2540249,0.436108,0.2339369,0.5085617,15.1898913,28.9904096,2.9325697,85.6100016),(36300,'hindlimb',252,8,385,1.3890464,83.5723343,120.6382074,1.8,83.466894,120.5919372,-1.4994549,0.6641226,2.0545747,0.1260205,0.8303308,0.2303314,0.4041376,0.1897548,0.4651999,15.2402368,28.904304,2.9471125,83.0318736),(36301,'hindlimb',252,8,386,1.3522319,83.5857564,120.6429108,1.8,83.466894,120.5919372,-1.506912,0.6757191,2.0578284,0.1171926,0.8414228,0.2244535,0.4088887,0.1734339,0.4655521,15.1898913,28.904304,2.9471125,78.7781794),(36302,'hindlimb',252,8,387,1.2567829,83.6182259,120.7107083,1.8,83.5098628,120.6993592,-1.5285918,0.6864948,2.1221473,0.0946748,0.8651069,0.2090909,0.4076564,0.1379105,0.4519362,15.2263005,29.3260093,2.9499442,79.0298848),(36303,'hindlimb',252,8,388,1.2267383,83.640143,120.8003357,1.8,83.5313472,120.7852968,-1.5364268,0.6971675,2.2102653,0.080625,0.9547027,0.204215,0.4319403,0.1156465,0.4681618,15.5012206,29.6702598,2.9669205,80.1409662),(36304,'hindlimb',252,8,389,1.0116702,83.6786369,121.1047421,1.8,83.6122296,121.0456372,-1.5583695,0.3343229,2.0823788,0.0507504,0.7967007,0.1685857,0.3825916,0.1518006,0.4066271,15.5097621,29.501766,2.9213439,79.2815902),(36305,'hindlimb',252,8,390,0.829724,83.6958629,121.4120096,1.8,83.6172848,121.2579536,-1.5707643,0.3364261,1.9587486,0.0388056,0.5874302,0.1382873,0.2999008,0.1153466,0.3193506,15.565056,29.4108802,2.9356013,79.38585),(36306,'hindlimb',252,8,391,0.5161297,83.7330793,121.9902165,1.8,83.6459307,121.9597773,1.5657054,0.3781871,1.6772692,0.0188282,0.3217679,0.0860194,0.1918403,0.0497854,0.2029153,15.7223453,29.4202952,3.0244839,79.2384044),(36307,'hindlimb',252,8,392,0.3178464,83.78916,122.4578277,1.8,83.78916,122.246236,1.5475044,0.0399536,1.7150343,0.0050042,0.2145852,0.0529457,0.1251201,0.1252497,0.1280032,15.9156394,28.7505907,2.976444,78.2747686),(36308,'hindlimb',252,8,393,0.1069745,83.78916,123.3231528,1.8,83.78916,123.320456,1.5200002,0.0437711,0.8609608,0.0017292,0.0338534,0.0177831,0.0393204,0.0395045,0.0412755,16.328144,28.4763545,3.0509328,78.6307338),(36309,'hindlimb',252,8,394,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36310,'hindlimb',252,8,395,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36311,'hindlimb',252,8,396,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36312,'hindlimb',252,8,397,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36313,'hindlimb',252,8,398,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36314,'hindlimb',252,8,399,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36315,'hindlimb',252,8,400,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36316,'hindlimb',252,8,401,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36317,'hindlimb',252,8,402,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36318,'hindlimb',252,8,403,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36319,'hindlimb',252,8,404,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36320,'hindlimb',252,8,405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36321,'hindlimb',252,8,406,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36322,'hindlimb',252,8,407,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36323,'hindlimb',252,8,408,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36324,'hindlimb',252,8,409,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36325,'hindlimb',252,8,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36326,'hindlimb',252,8,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36327,'hindlimb',252,8,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36328,'hindlimb',252,8,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36329,'hindlimb',252,8,414,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36330,'hindlimb',252,8,415,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36331,'hindlimb',252,8,416,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36332,'hindlimb',252,8,417,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36333,'hindlimb',252,8,418,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36334,'hindlimb',252,8,419,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36335,'hindlimb',252,8,420,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36336,'hindlimb',252,8,421,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36337,'hindlimb',252,8,422,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36338,'hindlimb',252,8,423,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36339,'hindlimb',252,8,424,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36340,'hindlimb',252,8,425,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36341,'hindlimb',252,8,426,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36342,'hindlimb',252,8,427,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36343,'hindlimb',252,8,428,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36344,'hindlimb',252,8,429,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36345,'hindlimb',252,8,430,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36346,'hindlimb',252,8,431,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36347,'hindlimb',252,8,432,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36348,'hindlimb',252,8,433,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36349,'hindlimb',252,8,434,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36350,'hindlimb',252,8,435,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36351,'hindlimb',252,8,436,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36352,'hindlimb',252,8,437,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36353,'hindlimb',252,8,438,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36354,'hindlimb',252,8,439,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36355,'hindlimb',252,8,440,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36356,'hindlimb',252,8,441,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36357,'hindlimb',252,8,442,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36358,'hindlimb',252,8,443,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36359,'hindlimb',252,8,444,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36360,'hindlimb',252,8,445,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36361,'hindlimb',252,8,446,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36362,'hindlimb',252,8,447,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36363,'hindlimb',252,8,448,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36364,'hindlimb',252,8,449,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36365,'hindlimb',252,8,450,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36366,'hindlimb',252,8,451,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36367,'hindlimb',252,8,452,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36368,'hindlimb',252,8,453,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36369,'hindlimb',252,8,454,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36370,'hindlimb',252,8,455,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36371,'hindlimb',252,8,456,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36372,'hindlimb',252,8,457,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36373,'hindlimb',252,8,458,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36374,'hindlimb',252,8,459,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36375,'hindlimb',252,8,460,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36376,'hindlimb',252,8,461,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36377,'hindlimb',252,8,462,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36378,'hindlimb',252,8,463,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36379,'hindlimb',252,8,464,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36380,'hindlimb',252,8,465,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36381,'hindlimb',252,8,466,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36382,'hindlimb',252,8,467,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36383,'hindlimb',252,8,468,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36384,'hindlimb',252,8,469,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36385,'hindlimb',252,8,470,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36386,'hindlimb',252,8,471,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36387,'hindlimb',252,8,472,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36388,'hindlimb',252,8,473,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36389,'hindlimb',252,8,474,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36390,'hindlimb',252,8,475,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36391,'hindlimb',252,8,476,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36392,'hindlimb',252,8,477,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36393,'hindlimb',252,8,478,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36394,'hindlimb',252,8,479,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36395,'hindlimb',252,8,480,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36396,'hindlimb',252,8,481,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36397,'hindlimb',252,8,482,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36398,'hindlimb',252,8,483,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36399,'hindlimb',252,8,484,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36400,'hindlimb',252,8,485,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36401,'hindlimb',252,8,486,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36402,'hindlimb',252,8,487,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36403,'hindlimb',252,8,488,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36404,'hindlimb',252,8,489,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36405,'hindlimb',252,8,490,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36406,'hindlimb',252,8,491,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36407,'hindlimb',252,8,492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36408,'hindlimb',252,8,493,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36409,'hindlimb',252,8,494,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36410,'hindlimb',252,8,495,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36411,'hindlimb',252,8,496,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36412,'hindlimb',252,8,497,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36413,'hindlimb',252,8,498,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36414,'hindlimb',252,8,499,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36415,'hindlimb',252,8,500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36416,'hindlimb',252,8,501,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36417,'hindlimb',252,8,502,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36418,'hindlimb',252,8,503,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36419,'hindlimb',252,8,504,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36420,'hindlimb',252,8,505,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36421,'hindlimb',252,8,506,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36422,'hindlimb',252,8,507,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36423,'hindlimb',252,8,508,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36424,'humerus.tif',234,2,1,8.2029408,11.0431169,17.4215935,1.8,11.062114,17.4399879,1.2526238,2.4667854,3.9220444,11.1650282,40.8856076,1.2333621,10.4245653,4.526145,13.1084486,4.4266403,7.8247396,1.8827019,20.5528826),(36425,'humerus.tif',234,2,2,8.7292667,11.084856,17.1774275,1.8,11.1047153,17.1800496,1.2659929,3.1365622,4.053867,12.279624,46.7173846,1.3238465,11.5241534,3.9149945,14.3774891,4.521449,7.8598711,1.8673421,20.851668),(36426,'humerus.tif',234,2,3,9.1625589,11.0833375,16.8736617,1.8,11.1031995,16.8861558,1.3084067,3.2687494,4.1350633,14.1598687,53.0391322,1.4243462,12.8266797,4.3318918,15.1873017,4.6034586,7.9302779,1.8509043,21.2826582),(36427,'humerus.tif',234,2,4,9.7262299,11.0752364,16.5935746,1.8,11.0932105,16.6473702,1.3551122,3.2799643,4.2549518,16.3412459,62.006426,1.5467903,14.5727682,4.9821413,16.6235513,4.7223692,8.0402311,1.8514741,21.6679314),(36428,'humerus.tif',234,2,5,10.5787967,11.1382586,16.2368133,1.8,11.1397868,16.3904112,1.3692142,3.5355653,4.3043659,18.2865182,72.3692638,1.6924524,16.8129908,5.1721625,17.6333084,4.8605987,8.1620654,1.8250819,22.1804631),(36429,'humerus.tif',234,2,6,12.4927574,11.1755312,15.9229009,1.8,11.1665616,16.2352666,1.395024,3.7352384,4.5875252,23.6740992,91.6014862,2.0184568,19.9675169,6.3380423,20.8158712,5.0186024,8.3305851,1.8198277,22.6198972),(36430,'humerus.tif',234,2,7,14.4097432,11.2272031,15.7422987,1.8,11.2185454,16.036731,1.3863985,3.9911148,4.7793406,30.1450416,105.3445837,2.3208839,22.0416564,7.553038,23.3887959,5.0674379,8.4993257,1.8147819,23.0508874),(36431,'humerus.tif',234,2,8,16.0257126,11.3091053,15.6656675,1.8,11.2912438,15.8388949,1.3942753,4.257561,4.8716103,37.0436016,115.3555105,2.5885869,23.6791333,8.7006626,25.3202642,5.2157331,8.6859295,1.8011988,24.0133459),(36432,'humerus.tif',234,2,9,17.1437558,11.3582789,15.7056204,1.8,11.3460546,15.8477565,1.4377377,4.3190854,5.2395986,44.4024561,131.2313133,2.8070032,25.0460622,10.2805228,28.6132419,5.4112217,8.9555757,1.8261422,25.1368386),(36433,'humerus.tif',234,2,10,18.5966645,11.3483782,15.7220387,1.8,11.3337535,15.8792735,1.5004568,4.3039025,5.6158954,58.1061915,150.2524341,3.0841344,26.7548492,13.5008151,33.1198956,6.0878766,9.2351228,1.7526721,29.2475848),(36434,'humerus.tif',234,2,11,21.1358255,11.4207278,15.6342013,1.8,11.3814015,15.8371436,1.549822,4.3638308,5.9303994,82.9864304,172.9283531,3.5210881,29.159647,19.0168764,39.1387812,7.7036844,9.816438,1.825233,39.01017),(36435,'humerus.tif',234,2,12,24.4106274,11.4979271,15.5638154,1.8,11.4166423,15.7502072,-1.5132795,4.7218661,6.1915579,114.4527594,194.6164651,4.0549936,31.4325519,24.238883,45.5836184,8.123842,9.7029615,1.145653,35.4175018),(36436,'humerus.tif',234,2,13,27.6579703,11.6065925,15.4628882,1.8,11.5006478,15.6314741,-1.4005018,4.8829652,6.4160052,153.0045938,220.9365295,4.4772677,34.4352169,31.334361,53.0722843,8.4992923,14.4313046,1.2948153,66.8591112),(36437,'humerus.tif',234,2,14,31.1341159,11.6522207,15.3919327,1.8,11.5035147,15.5392138,-1.1853957,4.8754066,6.7222995,186.4313502,269.8813151,4.4556883,40.1471724,38.239139,62.9504824,8.7544321,14.7816457,1.3064026,67.3189307),(36438,'humerus.tif',234,2,15,33.4539499,11.6445302,15.2561304,1.8,11.535213,15.4180402,-1.1529651,4.7525865,6.9700645,203.0111874,308.9672623,4.6575885,44.3277477,42.7159375,69.0589589,8.5676393,10.8310773,1.9423531,35.9032531),(36439,'humerus.tif',234,2,16,35.1407157,11.4215371,15.1725959,1.8,11.2998263,15.3785105,-1.2417875,5.3774365,6.8733383,195.2618035,347.0205172,5.2453555,50.4879143,36.3113172,73.5845484,0.2570595,0.4537365,1.0040671,1.3322926),(36440,'humerus.tif',234,2,17,0.7534358,16.8454891,14.6617143,1.8,16.8962897,14.7451657,1.2474281,1.705871,2.2109146,0.0746828,0.3070662,0.1128932,0.1388865,0.0437798,0.1667039,0.6630827,2.1350304,1.9028558,4.9002292),(36441,'humerus.tif',234,2,18,4.9111221,13.9639752,15.1614021,1.8,13.1651371,15.2648589,-0.1332473,2.3747569,7.5287308,2.6701794,77.5169413,0.0144469,10.29615,1.1244012,10.5869627,1.9279049,2.8325148,0.7419473,10.1921266),(36442,'humerus.tif',234,2,19,11.3856151,12.7499175,15.4319347,1.8,12.5028307,15.4560251,-0.1603454,2.7784624,6.9208228,10.3586844,194.3593105,0.0483719,28.0832664,3.7282075,29.4736393,3.1251292,4.2487366,0.342473,14.3823655),(36443,'humerus.tif',234,2,20,17.4758178,12.9669369,15.4904735,1.8,12.8531803,15.464397,-0.1901216,3.1661031,7.1414787,22.6535719,308.7997857,0.1040184,43.2403143,7.1550329,46.2828418,4.0765903,5.1607356,1.3945616,17.7394533),(36444,'humerus.tif',234,2,21,23.0116168,13.2512851,15.5078371,1.8,13.1373491,15.4798803,-0.2123757,4.042951,7.6840238,37.9626816,410.1575049,0.1703987,53.3779587,9.3898445,58.0977545,4.6584899,5.8003364,0.3046744,17.6887899),(36445,'humerus.tif',234,2,22,28.631573,13.5521327,15.5223447,1.8,13.5172152,15.5098814,-0.2322643,3.9200934,8.1232653,49.7783799,526.301044,0.2528338,64.7893455,12.6982637,70.5173684,6.4951024,16.0396293,0.2949896,46.9273307),(36446,'humerus.tif',234,2,23,32.4382178,13.4719246,15.557204,1.8,13.3697576,15.5698494,-0.2357669,3.80715,8.0781188,65.6498012,615.2742079,0.2949914,76.1655313,17.243818,83.2556251,6.6303471,16.2320646,0.3251404,52.4335746),(36447,'humerus.tif',234,2,24,33.6310823,13.3823762,15.5473722,1.8,13.283858,15.5611575,-0.2481531,4.0963112,8.1332104,81.2573546,661.254086,0.3381398,81.3029609,19.8367141,91.2768659,6.8338655,16.2432146,0.3271706,47.3335894),(36448,'humerus.tif',234,2,25,34.278929,13.4261141,15.5319699,1.8,13.3619958,15.5392031,-0.2560758,4.3322477,8.4438556,95.0218317,710.0514364,0.3665215,84.0909019,21.9336099,95.3145362,6.9268778,16.7072623,0.3375595,49.2296772),(36449,'humerus.tif',234,2,26,34.6665721,13.3597227,15.5394999,1.8,13.3147994,15.5280891,-0.253733,4.6225312,8.731592,103.5465266,778.583253,0.3640604,89.1685336,22.4003952,100.846452,7.0086888,16.9924521,0.3100931,51.1764283),(36450,'humerus.tif',234,2,27,34.2961905,13.2157925,15.5926478,1.8,13.193733,15.5867291,-0.2362048,4.5118342,8.8477604,105.4374968,817.0591521,0.3130259,92.346437,23.3690984,103.8995179,7.0183635,17.0045279,0.3055707,52.2422625),(36451,'humerus.tif',234,2,28,34.4753789,13.0818418,15.6702962,1.8,13.0479826,15.6703527,-0.2119205,4.5069777,8.8823948,105.4468132,850.9479507,0.2542098,95.8016357,23.3963466,106.6521498,7.3238709,17.0285472,0.1476773,50.7215552),(36452,'humerus.tif',234,2,29,33.6363718,12.8112584,15.7655451,1.8,12.7775822,15.7542435,-0.1866741,4.4192458,9.0036045,100.8385829,829.0138006,0.193097,92.0757682,22.8180524,102.0804619,7.0882298,16.9139457,0.1820618,47.7060724),(36453,'humerus.tif',234,2,30,32.7534668,12.5828503,15.8319821,1.8,12.563803,15.8110936,-0.181046,4.0739787,9.0611666,88.6527126,791.1709378,0.176984,87.3144675,21.7607205,95.3267923,6.8960103,16.7428512,0.1839435,48.859843),(36454,'humerus.tif',234,2,31,31.9751746,12.2611941,15.722452,1.8,12.2588134,15.7041463,-0.1738148,3.9131684,9.2619462,76.3693999,761.1337104,0.1593886,82.1785937,19.5160013,89.8296582,6.7051187,16.6247144,0.1407129,52.0180234),(36455,'humerus.tif',234,2,32,29.827542,12.1332793,15.3987607,1.8,12.0960925,15.4013308,-0.1612581,3.5205102,9.2396233,61.7757446,703.521646,0.1281567,76.1418108,17.5473842,82.514334,6.3677912,16.4767252,0.1654959,47.0866675),(36456,'humerus.tif',234,2,33,25.5820496,12.5657935,14.8871567,1.8,12.5369973,14.9013188,-0.0993921,3.3046615,8.580172,46.6707277,598.4728594,0.0419814,69.7506832,14.1226956,74.8231408,6.172725,16.3280251,0.162696,59.7535161),(36457,'humerus.tif',234,2,34,24.2365523,12.873607,14.5807507,1.8,12.8902385,14.5748958,-0.0308915,3.0730759,8.0814118,34.1519256,536.7188812,0.0038535,66.4139993,11.113271,69.9021184,5.1857375,16.1922872,0.1510153,52.5789211),(36458,'humerus.tif',234,2,35,23.5978915,13.1462259,14.4266497,1.8,13.1392455,14.4153508,-0.0191545,2.6733369,8.216079,33.530569,506.7534967,0.0014428,61.6782649,12.5425902,65.5826174,5.0521852,15.9806284,0.1508281,46.9474675),(36459,'humerus.tif',234,2,36,22.2403838,13.0650365,14.3202414,1.8,13.0145121,14.2990356,-0.0043533,2.5722307,8.1609616,32.8911334,476.5070106,0.0000703,58.3885865,12.7870078,62.2462461,5.0369832,15.772733,0.0994491,43.1439506),(36460,'humerus.tif',234,2,37,21.9047357,12.8212229,14.2499518,1.8,12.7377518,14.2360678,0.004873,2.5323748,7.8782543,33.6558511,474.9913668,0.0000867,60.2914489,13.2902327,64.4199337,5.0808,15.4818939,0.0629797,43.0067994),(36461,'humerus.tif',234,2,38,21.3854986,12.8237174,14.1431683,1.8,12.7376052,14.1279822,0.0193324,2.7387998,7.8775586,34.76057,441.8043955,0.0013319,56.0839238,12.691899,60.3188774,5.1055662,15.2652651,0.0547398,42.7965506),(36462,'humerus.tif',234,2,39,21.254396,12.9100256,14.0608073,1.8,12.8206487,14.0376045,0.0352275,2.6663465,7.9897371,37.2829295,428.5506894,0.0043942,53.6376457,13.9827775,58.1398232,5.1039976,15.077439,0.0346282,41.0417117),(36463,'humerus.tif',234,2,40,21.7578392,13.0994782,13.9866987,1.8,12.9654307,13.9559623,0.0516954,2.6765977,8.1833818,40.0057064,421.5722661,0.0096823,51.5156542,14.946477,56.288696,5.0863322,14.9048039,3.1042269,40.4496873),(36464,'humerus.tif',234,2,41,23.1146549,13.2510356,13.920295,1.8,13.0615222,13.8845062,0.057434,2.7106722,8.3424794,42.3562517,440.9445216,0.0126939,52.8553321,15.625737,57.8796364,5.0766193,14.7226623,3.070622,40.4651264),(36465,'humerus.tif',234,2,42,22.5481288,13.2872944,13.8768974,1.8,13.0774969,13.8415259,0.0585636,2.7286476,8.4126027,44.073955,410.7451106,0.0128741,48.8249744,16.1523073,54.0313876,5.0771781,14.5863486,3.0675655,40.4770679),(36466,'humerus.tif',234,2,43,22.3506338,13.1811915,13.8414545,1.8,12.9511499,13.8036425,0.0764338,2.6600532,8.3402054,44.8881259,380.8778787,0.0217202,45.6676856,16.8748977,51.0000726,5.0972973,14.455704,3.0596509,41.0999703),(36467,'humerus.tif',234,2,44,21.6923283,12.9689892,13.8363464,1.8,12.7192193,13.7938529,0.100968,2.598034,8.138066,45.7584284,353.8231158,0.0367321,43.4775433,17.6127133,49.0552403,4.7943777,13.161073,0.0794083,31.8991314),(36468,'humerus.tif',234,2,45,21.2949751,12.8279708,13.9034906,1.8,12.5792908,13.8628672,0.1348922,2.8000491,8.0346854,46.934445,334.3967822,0.0641895,41.6191507,16.7620075,47.3779235,5.1285136,14.1885879,3.0260601,40.3343703),(36469,'humerus.tif',234,2,46,21.2542132,12.7442775,13.90663,1.8,12.5104618,13.8523981,0.1594578,2.8990673,7.9795505,46.7263538,322.7973486,0.0893103,40.4530745,16.1177196,46.055188,5.1533677,14.050325,3.024918,38.5437069),(36470,'humerus.tif',234,2,47,21.497888,12.7093461,13.843696,1.8,12.5087363,13.8036923,0.1720846,2.8852885,7.9812555,46.7588384,311.2239641,0.1050599,38.9943616,16.2059491,44.5923288,5.163773,13.9336089,3.0113517,37.2486874),(36471,'humerus.tif',234,2,48,20.9136189,12.6033619,13.7374749,1.8,12.4061357,13.7033338,0.1761562,2.8401938,7.8791064,44.3625953,299.3106539,0.1070475,37.9878936,15.6195663,43.2510733,5.1801077,13.7910781,3.0125429,36.1709118),(36472,'humerus.tif',234,2,49,20.5814186,12.5711915,13.673087,1.8,12.3705693,13.6347757,0.1838989,2.8204676,7.8607392,43.3095981,281.5037601,0.1147046,35.8113597,15.3554672,41.1123347,5.1914992,13.6219221,2.974764,35.2203948),(36473,'humerus.tif',234,2,50,20.7317676,12.4871976,13.6089073,1.8,12.2973356,13.565562,0.196192,2.8264523,7.7622882,42.8107699,261.2825702,0.1313012,33.6605089,15.1464684,38.9139186,5.176763,13.3844348,2.9559253,34.2002777),(36474,'humerus.tif',234,2,51,20.860381,12.3414045,13.4977389,1.8,12.1679828,13.4573719,0.2009132,2.7751047,7.6067875,42.9953454,249.7397346,0.1384639,32.8311703,15.4932334,38.1866204,5.1682757,13.1583582,2.9473091,33.2209314),(36475,'humerus.tif',234,2,52,21.2306148,12.2701042,13.4808352,1.8,12.1110557,13.4405698,0.2134175,2.8225113,7.5091499,42.4723402,242.1276899,0.1587332,32.2443544,15.0477133,37.6086039,5.1729077,12.848884,2.9176359,32.4961021),(36476,'humerus.tif',234,2,53,21.0904589,12.1623928,13.4460982,1.8,11.9890944,13.4012564,0.2201692,2.8540676,7.3904342,41.0986372,231.6519925,0.167656,31.3448418,14.4000223,36.5903092,5.1727178,12.669351,2.9059408,31.8612582),(36477,'humerus.tif',234,2,54,20.4861708,12.0864796,13.3967737,1.8,11.8829446,13.3431533,0.2322565,2.8697026,7.3124976,39.9310202,225.2185,0.1808932,30.7991212,13.9146891,36.066017,5.1651913,12.56786,2.9040014,31.3332875),(36478,'humerus.tif',234,2,55,20.2547783,12.0762446,13.3627682,1.8,11.881681,13.3137412,0.2442161,2.8679022,7.2766814,39.4561844,215.1793756,0.1973666,29.5710867,13.7578554,34.7395335,5.1524985,12.3884579,2.9293222,30.9241314),(36479,'humerus.tif',234,2,56,20.3131999,12.0991998,13.2674234,1.8,11.9109196,13.2139055,0.2432996,2.7513781,7.2933222,38.7469852,206.1575715,0.1964824,28.2666208,14.0827553,33.3588694,5.1240789,12.2228777,2.9118062,30.6218484),(36480,'humerus.tif',234,2,57,19.7554299,12.0719157,13.2555452,1.8,11.8696492,13.208726,0.2519392,2.7532325,7.2580848,37.6917912,195.0222762,0.2046061,26.8696606,13.6900141,31.8215747,5.1194581,12.0455263,2.9113291,29.944785),(36481,'humerus.tif',234,2,58,20.1869253,11.9952058,13.2012473,1.8,11.7957537,13.1546632,0.2604027,2.7310099,7.1639168,37.9045395,191.8530809,0.2230341,26.7804732,13.8793124,31.8180276,5.1064646,11.8925405,2.8902266,29.6087265),(36482,'humerus.tif',234,2,59,20.8278808,11.9962304,13.1545763,1.8,11.8032729,13.1072791,0.2761127,2.7143436,7.1245352,37.7855756,184.1200697,0.2579893,25.8430992,13.9207047,30.9216417,5.0989794,11.732917,2.8836651,29.2318972),(36483,'humerus.tif',234,2,60,21.0418405,11.9242229,13.0833144,1.8,11.7431082,13.0289235,0.2790256,2.6752074,6.9949928,37.2840406,182.5230413,0.2660238,26.0933853,13.9368787,31.1563738,5.0931953,11.5718766,2.8893202,28.9127265),(36484,'humerus.tif',234,2,61,19.9799945,11.8540743,13.0423863,1.8,11.6589783,12.9791257,0.2915742,2.6864863,6.8786645,36.6450178,174.3856292,0.2751693,25.3516697,13.6405006,30.4684211,5.1090226,11.4152488,2.8699931,28.5970533),(36485,'humerus.tif',234,2,62,19.6301173,11.846498,12.9977495,1.8,11.6605305,12.936092,0.3003686,2.6657649,6.8385828,36.6541139,165.4712864,0.2864048,24.196722,13.7499423,29.3620882,5.1257175,11.3003055,2.8607549,28.2117802),(36486,'humerus.tif',234,2,63,19.9429208,11.8071789,12.9574949,1.8,11.626541,12.8894485,0.3147651,2.671619,6.7097238,37.4059786,161.2866945,0.3185812,24.0377548,14.00124,29.4138663,5.1497009,11.1297452,2.846542,27.8876631),(36487,'humerus.tif',234,2,64,19.8899072,11.8507838,12.9234039,1.8,11.6499966,12.8498193,0.341137,2.6644547,6.6995879,37.7930421,148.87006,0.3710449,22.2207786,14.1841564,27.69334,5.1518554,11.0160004,2.826835,27.6380924),(36488,'humerus.tif',234,2,65,20.5629535,11.8799222,12.9179752,1.8,11.6762857,12.8378553,0.3566261,2.662781,6.6877925,38.2897101,145.1946479,0.4177057,21.7103997,14.3795943,27.3158948,5.1828224,10.896902,2.7996428,27.4377363),(36489,'humerus.tif',234,2,66,21.0687187,11.8899098,12.908593,1.8,11.7276202,12.8398257,0.3671099,2.6654414,6.6393234,38.7170331,141.5542802,0.4523564,21.3205882,14.5255614,27.0421883,5.2132708,10.7691242,2.7850913,27.3154241),(36490,'humerus.tif',234,2,67,20.9500917,11.9348285,12.8923081,1.8,11.768309,12.8168307,0.386996,2.6561966,6.6054038,38.7110736,134.340734,0.4973448,20.3380047,14.5738736,26.1015261,5.2450215,10.6436812,2.7701935,27.0489655),(36491,'humerus.tif',234,2,68,20.7374157,11.9548577,12.9074314,1.8,11.8025013,12.8386889,0.4207436,2.710527,6.5257892,38.5302823,128.5987793,0.5765785,19.7062418,14.2150519,25.4366471,5.274025,10.5013578,2.7684708,26.7213509),(36492,'humerus.tif',234,2,69,20.8018049,11.9766763,12.9379079,1.8,11.8301102,12.8623868,0.4567106,2.768516,6.4358102,39.0081728,122.9389427,0.6742538,19.1023256,14.0899213,24.8876597,5.2993259,10.3463742,2.7698306,26.4176192),(36493,'humerus.tif',234,2,70,20.7344658,12.0076716,12.9478533,1.8,11.8718107,12.8795922,0.4860733,2.8170044,6.3608307,39.766992,118.6636476,0.7541687,18.6553695,14.1167662,24.558701,5.3239122,10.2103462,2.7572888,26.0134094),(36494,'humerus.tif',234,2,71,20.1182358,12.0989882,12.9481003,1.8,11.9934643,12.8958555,0.5202162,2.8147069,6.1236053,40.158621,104.8140101,0.8284567,17.1163891,14.2674253,23.1892685,5.3451491,9.8751707,2.7473437,25.3870094),(36495,'humerus.tif',234,2,72,19.8212606,12.1779303,12.9372601,1.8,12.1323815,12.9163673,0.5619018,2.7894915,4.9750464,40.1529497,91.9143363,0.9377841,18.4750711,14.394362,26.2540102,5.3151803,8.5855205,2.6289824,22.6149509),(36496,'humerus.tif',234,2,73,20.7638597,12.1994831,12.9209343,1.8,12.1818721,12.9077736,0.6009168,2.7991895,4.5697079,41.2152419,86.7214416,1.1062844,18.9774584,14.7239914,27.7336244,5.3397876,8.1301023,2.5820859,21.8444045),(36497,'humerus.tif',234,2,74,21.870684,12.2607326,13.0018119,1.8,12.2456534,12.9986346,0.6414015,2.855858,4.4077636,42.9794614,85.5713984,1.3048983,19.4137904,15.0495794,28.9222164,5.3643949,7.8664937,2.5450013,21.6524923),(36498,'humerus.tif',234,2,75,20.5012674,12.2651425,13.117991,1.8,12.2646708,13.106384,0.6936455,2.9602536,4.2354869,42.2332544,82.3158729,1.3966877,19.4348075,14.2667689,29.1727449,5.3947763,7.6151593,2.4825535,21.3283753),(36499,'humerus.tif',234,2,76,19.2851183,12.2997807,13.1827919,1.8,12.2918814,13.1634127,0.7568862,3.0039363,4.1095776,42.2543729,78.9808322,1.5155002,19.2187228,14.0663344,29.2037424,5.4149409,7.4445977,2.4157267,21.2180045),(36500,'humerus.tif',234,2,77,19.0805624,12.2637999,13.1809601,1.8,12.2562166,13.169653,0.8133742,3.0479007,3.9467883,42.5952315,77.7978628,1.678967,19.711689,13.9752687,29.9194277,5.4247527,7.3435422,2.3025547,21.1772338),(36501,'humerus.tif',234,2,78,19.0270427,12.2409827,13.2162386,1.8,12.2311504,13.2081541,0.8696817,3.1042,3.8070721,43.1266634,76.0428832,1.8516007,19.9741117,13.8930042,30.5524627,5.4474999,7.258616,2.2747424,21.0499753),(36502,'humerus.tif',234,2,79,18.9700003,12.2831498,13.3146419,1.8,12.2766888,13.3114641,0.9376142,3.1414205,3.7807294,43.7093177,74.8314028,2.0546905,19.7928481,13.9138705,30.3206089,5.4630275,7.2183791,2.2297253,21.0295899),(36503,'humerus.tif',234,2,80,19.3924387,12.3265304,13.3846238,1.8,12.3111625,13.3749779,0.9853281,3.1428666,3.7649517,44.4704404,75.8976172,2.2451424,20.1589883,14.1496432,30.780391,5.4784669,7.222656,2.1293956,21.0788045),(36504,'humerus.tif',234,2,81,19.0657269,12.3169963,13.395727,1.8,12.3053446,13.3901111,1.0339094,3.1455686,3.6764416,44.989662,74.7904763,2.346372,20.3431701,14.3025533,31.2839376,5.4874705,7.2394875,2.1054451,21.2756631),(36505,'humerus.tif',234,2,82,18.8093905,12.3032252,13.4430467,1.8,12.2966106,13.4519186,1.0939228,3.1513203,3.6242228,45.5592259,74.0783466,2.474424,20.4397884,14.4571869,31.7095181,5.5128936,7.2877549,2.0686187,21.1976192),(36506,'humerus.tif',234,2,83,18.7058432,12.2987209,13.5162085,1.8,12.2973135,13.5285308,1.1566997,3.161095,3.7086756,45.9399065,74.3719251,2.6129068,20.0534997,14.5329093,31.7086875,5.5246939,7.3672513,1.9942964,21.2960484),(36507,'humerus.tif',234,2,84,18.6795601,12.3098328,13.5647495,1.8,12.3099037,13.5816873,1.2034376,3.141822,3.8776701,46.1358577,76.8166234,2.711681,19.8099943,14.6844274,31.2046662,5.5416926,7.5284715,1.949586,21.492907),(36508,'humerus.tif',234,2,85,18.8343938,12.3316941,13.6503226,1.8,12.3285617,13.6659756,1.2170344,3.1333578,3.9416061,46.183372,79.288283,2.7623362,20.1157299,14.739259,31.4048224,5.5622023,7.6532314,1.9285026,21.632107),(36509,'humerus.tif',234,2,86,18.6239744,12.322172,13.6800439,1.8,12.3233204,13.7122397,1.2605869,3.1180822,4.0190657,46.6925224,80.2698431,2.8147577,19.9722643,14.9747567,31.2871434,5.5789648,7.7184643,1.9253454,21.7916923),(36510,'humerus.tif',234,2,87,17.9138732,12.2872215,13.6787491,1.8,12.2889106,13.7175118,1.2883945,3.1361074,4.1152534,46.5398634,79.2687526,2.7538007,19.2621803,14.8400096,30.3068971,5.6015611,7.7553266,1.9379702,21.8901216),(36511,'humerus.tif',234,2,88,17.7374626,12.2628517,13.7429811,1.8,12.2638436,13.7855593,1.301387,3.1596559,4.1336445,46.2179781,80.4809026,2.7468167,19.4697204,14.6275355,30.4550876,5.6297644,7.7965981,1.8558402,22.0089362),(36512,'humerus.tif',234,2,89,17.4281206,12.2446066,13.7937366,1.8,12.2539152,13.8443183,1.3137828,3.1802919,4.2045091,45.9781204,81.0280134,2.7170027,19.2716943,14.4572013,30.0843413,5.6451384,7.8872494,1.8478839,22.1277509),(36513,'humerus.tif',234,2,90,17.3810225,12.2369632,13.860989,1.8,12.2545786,13.9196637,1.3258675,3.1376943,4.3057666,45.728872,83.4390735,2.7265029,19.3784479,14.5740369,29.9530406,5.6311675,8.0342039,1.8788491,22.2957801),(36514,'humerus.tif',234,2,91,17.3957161,12.2399661,13.9161547,1.8,12.2620728,13.9764,1.3320262,3.1952895,4.3872008,46.4391597,84.9540459,2.7371116,19.3640658,14.5336313,29.9427774,5.6724,8.1566479,1.8696089,22.4638094),(36515,'humerus.tif',234,2,92,17.8038909,12.258277,13.9631016,1.8,12.2841476,14.0319022,1.3331882,3.1971167,4.4552149,47.635506,87.6846177,2.8029168,19.6813443,14.8995205,30.3715457,5.7319811,8.2666666,1.8699143,22.7098826),(36516,'humerus.tif',234,2,93,17.8401464,12.258032,14.0204399,1.8,12.2903615,14.0888115,1.327669,3.2137319,4.4581903,48.202628,88.1289272,2.8010358,19.7678703,14.9989576,30.5791903,5.742,8.3252773,1.929567,22.8694679),(36517,'humerus.tif',234,2,94,17.7511761,12.240126,14.0504729,1.8,12.2791349,14.1197146,1.3323143,3.227629,4.4668515,48.7245338,88.6836423,2.7934327,19.8537253,15.0960765,30.7579906,5.7768,8.3427875,1.9466552,22.930624),(36518,'humerus.tif',234,2,95,17.6850479,12.226059,14.062447,1.8,12.2637719,14.1334387,1.3306546,3.2450773,4.4586765,49.5511088,88.9371601,2.7807733,19.9469865,15.2696235,31.0555299,5.8116,8.3040851,1.9575283,22.9594533),(36519,'humerus.tif',234,2,96,17.9189375,12.2265367,14.1048687,1.8,12.2682615,14.1678546,1.3313663,3.246014,4.3999926,50.5977913,90.809848,2.8185306,20.6386366,15.5876686,32.114867,5.8464,8.3206211,1.8766752,22.9798387),(36520,'humerus.tif',234,2,97,18.1544058,12.23637,14.1663751,1.8,12.2777272,14.2357307,1.3193638,3.260372,4.4166637,51.430699,94.2033358,2.8384495,21.3290714,15.774488,32.9075057,5.8812,8.3971903,1.9043419,23.2294094),(36521,'humerus.tif',234,2,98,18.2428196,12.2268981,14.1868567,1.8,12.2766273,14.2736198,1.3063868,3.2833543,4.4544161,52.3734458,94.974377,2.8328112,21.3213975,15.9512012,33.0064151,5.9305155,8.4627705,1.9810876,23.4670387),(36522,'humerus.tif',234,2,99,18.2829674,12.2239962,14.200436,1.8,12.2759377,14.2907561,1.2974556,3.3108462,4.5209976,53.617522,95.588443,2.825106,21.1432192,16.1945071,32.9211488,5.975481,8.5685063,1.9890207,23.5977948),(36523,'humerus.tif',234,2,100,18.3906084,12.2317612,14.2165996,1.8,12.2859637,14.3123362,1.2908265,3.3215564,4.5242873,55.0997851,96.6266109,2.8310612,21.3573112,16.5885444,33.4254452,6.0167944,8.6003186,1.9873773,23.7250533),(36524,'humerus.tif',234,2,101,18.6439087,12.2503632,14.2464453,1.8,12.3036522,14.3379607,1.2794139,3.3195958,4.4802713,56.757944,97.1638073,2.8508778,21.6870367,17.0978479,34.2644595,6.0604594,8.6003186,1.9873773,23.7827118),(36525,'humerus.tif',234,2,102,18.9136981,12.2707959,14.2641968,1.8,12.3267394,14.3517434,1.2736282,3.3143897,4.4462353,58.5922628,98.1548897,2.8820068,22.0759547,17.6781454,35.0770131,6.1173145,8.5798058,2.0017877,23.889585),(36526,'humerus.tif',234,2,103,18.8505251,12.2713029,14.2640483,1.8,12.3340156,14.3554579,1.2624885,3.3411213,4.4816729,60.0340924,98.1206178,2.8524617,21.8937483,17.9682469,35.1406038,6.175784,8.5653257,1.9980963,23.9964581),(36527,'humerus.tif',234,2,104,18.8376748,12.2675444,14.2400912,1.8,12.334465,14.3425948,1.2472662,3.3537543,4.5004757,61.6247845,97.8798116,2.8222909,21.7487702,18.3748658,35.2903107,6.2405053,8.5826989,1.9927259,24.0576143),(36528,'humerus.tif',234,2,105,18.9798426,12.2605596,14.2575783,1.8,12.3247508,14.3490896,1.2322547,3.3911713,4.5133256,63.163741,98.945215,2.8143998,21.9229065,18.6259364,35.8291683,6.3168739,8.6226086,1.9730384,24.1933167),(36529,'humerus.tif',234,2,106,18.907548,12.2394245,14.2547599,1.8,12.3074381,14.3406229,1.2240547,3.4237201,4.5256125,64.6431971,98.0448682,2.7873257,21.6644419,18.8809817,35.8697585,6.3796342,8.6090446,1.9693188,24.1933167),(36530,'humerus.tif',234,2,107,18.9865705,12.2244757,14.2739104,1.8,12.2983755,14.3536478,1.2030827,3.4661671,4.4984408,66.2952502,97.6533222,2.7554959,21.7082597,19.126386,36.3799337,6.4363503,8.6144587,1.9603047,24.2713606),(36531,'humerus.tif',234,2,108,18.9728923,12.221593,14.2980948,1.8,12.3015135,14.3762486,1.1674747,3.4961848,4.4794151,67.1335301,97.3563119,2.6750604,21.734157,19.2019396,36.6847318,6.4828498,8.5956001,1.9655874,24.2713606),(36532,'humerus.tif',234,2,109,18.5146182,12.1840324,14.2686787,1.8,12.2621965,14.3347207,1.143886,3.5333231,4.507947,68.0161597,95.5374623,2.5567267,21.19312,19.2499122,36.2576625,6.5429159,8.5956001,1.9655874,24.3494045),(36533,'humerus.tif',234,2,110,18.4170143,12.1359754,14.2510258,1.8,12.2091861,14.3120772,1.0950697,3.5834225,4.5332046,69.405845,94.1851715,2.4256748,20.776731,19.3685909,36.0867847,6.559021,8.5822756,1.9618445,24.476663),(36534,'humerus.tif',234,2,111,18.3535683,12.1135055,14.2567038,1.8,12.1919398,14.321699,1.0409407,3.6263274,4.5394538,70.9145599,93.2062346,2.2775614,20.5324779,19.5554764,36.1413253,6.5636538,8.5313959,1.9687252,24.5954776),(36535,'humerus.tif',234,2,112,18.1257619,12.0884488,14.2516118,1.8,12.1679731,14.3139529,0.9938765,3.6669399,4.5174705,71.8551251,92.6867842,2.122194,20.517408,19.5953923,36.3445253,6.5528993,8.48585,1.9665338,24.6039215),(36536,'humerus.tif',234,2,113,18.1865699,12.0693319,14.2494228,1.8,12.1454925,14.3016425,0.9397697,3.7040133,4.5002279,72.9888815,93.0074481,1.9760639,20.667275,19.7053511,36.6790233,6.5618259,8.48585,1.9665338,24.6939069),(36537,'humerus.tif',234,2,114,18.1776466,12.0501168,14.258658,1.8,12.1306894,14.3087667,0.8903591,3.7478577,4.4489383,74.5917174,92.587238,1.830464,20.811086,19.9024948,37.1728547,6.5826994,8.4489499,1.9773106,24.7838923),(36538,'humerus.tif',234,2,115,18.4103202,12.0383273,14.252716,1.8,12.1157813,14.2933463,0.7742378,3.755761,4.3569676,77.3731064,93.9276497,1.4999521,21.5580324,20.6011796,38.1933089,6.5918055,8.3989929,1.984393,24.9434776),(36539,'humerus.tif',234,2,116,18.8472816,11.9793523,14.2411554,1.8,12.0588186,14.3026025,0.6790835,3.7962804,4.2771083,78.6121155,94.0947686,1.2391605,21.9996226,20.7076681,38.3136914,6.6151106,8.3850671,1.9805927,25.0707362),(36540,'humerus.tif',234,2,117,18.8788513,11.9751659,14.2397255,1.8,12.0497661,14.3020428,0.6749085,3.8070598,4.270284,79.7204343,96.5754561,1.2284071,22.6156987,20.9401584,39.2401225,6.6492275,8.3712628,1.9767798,25.2879801),(36541,'humerus.tif',234,2,118,18.6427495,11.9252588,14.2121438,1.8,11.9941695,14.275319,0.6132853,3.8259596,4.2270434,80.8885919,97.1321549,1.0292849,22.9787456,21.1420403,39.5379234,6.6761902,8.3499698,1.9373717,25.5305556),(36542,'humerus.tif',234,2,119,18.9179963,11.8632466,14.1874117,1.8,11.9184054,14.2419034,0.4873203,3.8816229,4.0959043,82.7642454,100.391473,0.6913495,24.5102093,21.3220724,40.5057982,6.7101966,8.3363253,1.9559538,25.7681849),(36543,'humerus.tif',234,2,120,18.9733141,11.81459,14.1711605,1.8,11.8584017,14.2284155,0.3455698,3.9788174,3.8696498,84.8642691,104.9850281,0.3628328,27.1303694,21.3290184,42.0835588,6.7425482,8.3939447,0.2771607,26.1007459),(36544,'humerus.tif',234,2,121,18.6384543,11.8234053,14.1276324,1.8,11.8411684,14.1910172,0.2525129,4.0152136,4.2501983,85.4272572,108.1392637,0.193899,25.4433454,21.2758934,41.7813037,6.7944398,8.7098081,0.2876298,26.4944629),(36545,'humerus.tif',234,2,122,18.7492883,11.8005978,14.0977669,1.8,11.8018848,14.1538012,0.1769645,4.0601323,4.5868774,86.2983326,114.178047,0.0968428,24.8923256,21.2550543,41.494129,6.8478655,8.9582122,0.2713627,26.9458385),(36546,'humerus.tif',234,2,123,18.95227,11.7406048,14.0710507,1.8,11.7123937,14.1244165,0.1152227,4.0948878,4.8430965,86.9434932,120.9222723,0.0417507,24.9679667,21.2322041,41.559716,6.8929704,9.2259388,0.2321706,27.4871995),(36547,'humerus.tif',234,2,124,18.9528772,11.6991586,14.0124222,1.8,11.6465417,14.0738422,0.0776235,4.0738906,5.0385283,86.0627314,124.9932102,0.0189949,24.807484,21.1254398,41.1990118,6.9206539,9.4320199,0.1930541,27.7775409),(36548,'humerus.tif',234,2,125,18.4580649,11.7631524,13.9545812,1.8,11.6986476,14.0186742,0.0949186,4.0480235,5.2302373,86.2628528,125.7252952,0.0276333,24.0381626,21.3098698,39.9248516,6.9373633,9.6540996,0.1011034,28.1916434),(36549,'humerus.tif',234,2,126,18.875523,11.778086,13.9159261,1.8,11.6919753,13.9864331,0.073884,4.0411167,5.3419397,86.192784,133.6329391,0.0171419,25.0158081,21.3289519,40.7289005,6.9492656,9.8618559,0.0989664,28.4377165),(36550,'humerus.tif',234,2,127,18.7943372,11.8802086,13.8538534,1.8,11.8087047,13.9177877,0.0703499,4.0366556,5.4588114,86.4398677,138.5015087,0.015477,25.3721001,21.4137335,40.9328331,6.9534753,9.9591861,0.0909762,28.6549604),(36551,'humerus.tif',234,2,128,18.7697766,11.9022166,13.8156662,1.8,11.8295319,13.8760542,0.0895839,4.0299634,5.5147454,85.8723589,140.191107,0.0250384,25.4211384,21.3084711,40.7707689,6.9414284,10.0515992,0.0762408,28.782219),(36552,'humerus.tif',234,2,129,18.3667917,11.881686,13.7620469,1.8,11.79418,13.8129275,0.1075212,4.0390484,5.4943733,85.4736927,138.3594186,0.035253,25.1820202,21.1618392,40.5529694,6.9268363,10.1136369,0.0654237,28.9010336),(36553,'humerus.tif',234,2,130,18.3090997,11.848522,13.7332005,1.8,11.7401648,13.7748402,0.1070216,4.0684147,5.46227,86.5388819,140.4056829,0.0348177,25.7046397,21.2709095,41.4013089,6.9151466,10.1701773,0.0410728,28.9875214),(36554,'humerus.tif',234,2,131,18.1623615,11.8344226,13.6663573,1.8,11.7132395,13.7072495,0.0905718,4.0509857,5.4237905,85.7116973,142.27254,0.0247639,26.2312013,21.1582324,41.957483,6.9170829,10.2411972,0.0441889,29.0451799),(36555,'humerus.tif',234,2,132,17.705441,11.9099302,13.5767585,1.8,11.7985749,13.6155208,0.1023409,3.9956087,5.4580067,85.0018445,142.6442734,0.0307991,26.134866,21.273816,41.582642,6.8966272,10.2919787,0.0710666,29.1351653),(36556,'humerus.tif',234,2,133,17.580248,11.9760771,13.5199611,1.8,11.8508521,13.5587861,0.1133171,3.9774901,5.5124142,84.3188456,146.0608317,0.0374632,26.4967086,21.1990084,41.5940677,6.8733072,10.4135766,0.0401123,29.230097),(36557,'humerus.tif',234,2,134,17.2505508,12.0231987,13.4704854,1.8,11.9012164,13.5012228,0.1197335,3.9616877,5.501395,83.8361405,146.7980708,0.041021,26.6837903,21.1617236,41.784139,6.8735283,10.4655468,0.069886,29.2793116),(36558,'humerus.tif',234,2,135,16.9226647,12.0624895,13.40618,1.8,11.9229015,13.437845,0.1224157,3.934483,5.5052756,83.5530662,144.1379493,0.0420554,26.1817865,21.2360978,41.2158759,6.873853,10.4895883,0.0531062,29.3285262),(36559,'humerus.tif',234,2,136,16.9619805,12.0718973,13.344096,1.8,11.9396888,13.3724692,0.1160516,3.9219681,5.4491663,84.4696422,145.8612406,0.0379033,26.767625,21.537565,42.1503218,6.8805415,10.4165998,0.0467886,29.2708677),(36560,'humerus.tif',234,2,137,16.788973,12.165049,13.3131293,1.8,12.046599,13.3433319,0.1342322,3.9249234,5.4739936,85.7826175,142.8208572,0.050116,26.0907972,21.8558703,41.6151278,6.8975398,10.3937295,0.0670136,29.2793116),(36561,'humerus.tif',234,2,138,16.9357142,12.1596545,13.2894397,1.8,12.0490294,13.3302518,0.137529,3.9591844,5.3997547,86.8947604,145.6272075,0.0530519,26.9692265,21.9476418,42.9222999,6.9342494,10.3835293,0.0502931,29.3285262),(36562,'humerus.tif',234,2,139,16.6486494,12.2370176,13.2091402,1.8,12.1384798,13.2486403,0.1550257,3.9272903,5.3865826,86.2660327,145.445171,0.0661536,27.0013811,21.9657898,42.7428992,6.9759284,10.3741363,3.1147535,29.3861848),(36563,'humerus.tif',234,2,140,16.3460481,12.2823903,13.116912,1.8,12.1805295,13.1423026,0.1480234,3.9111897,5.3495346,87.1608051,143.9945523,0.0592581,26.9172109,22.2849856,43.0592598,7.0183724,10.3487735,3.0911305,29.4557848),(36564,'humerus.tif',234,2,141,16.385713,12.3083883,13.0403161,1.8,12.2150476,13.0701251,0.1380301,3.9232667,5.3096002,88.987556,147.159639,0.0517013,27.7157665,22.6820054,44.3523244,7.0592701,10.3545645,3.0810606,29.554214),(36565,'humerus.tif',234,2,142,16.547486,12.4462154,12.9881749,1.8,12.3552052,13.0407017,0.1557228,3.945181,5.3644798,91.1468852,147.0017226,0.0663394,27.4027918,23.103347,44.3215941,7.1137383,10.356728,3.0777066,29.6526433),(36566,'humerus.tif',234,2,143,16.6179833,12.5461413,12.8885531,1.8,12.4872069,12.9255077,0.16075,4.0374862,5.3880037,92.0977994,148.8714016,0.0709553,27.6301596,22.8106783,44.6196789,7.1803451,10.3721516,3.0576155,29.7918433),(36567,'humerus.tif',234,2,144,16.8052868,12.6071337,12.8486278,1.8,12.5967978,12.9011483,0.1698508,4.087574,5.3525527,94.3372362,153.9113029,0.0800294,28.7547477,23.0790282,46.1892195,7.2517832,10.385337,3.0879529,30.0175311),(36568,'humerus.tif',234,2,145,16.6749653,12.6607859,12.7736309,1.8,12.6799694,12.8181445,0.1812577,4.1404346,5.2785541,96.9272856,147.7135717,0.090312,27.9837182,23.4099303,46.1352048,7.3521381,10.3639168,3.0676536,29.9683164),(36569,'humerus.tif',234,2,146,16.6148751,12.7580524,12.6850592,1.8,12.8332275,12.7245948,0.2549803,4.1126981,5.1655079,99.4995614,146.6832474,0.1761679,28.3966744,24.1932569,46.9390882,7.4510908,10.3158377,0.0540015,30.025975),(36570,'humerus.tif',234,2,147,16.9081668,12.8039791,12.571412,1.8,12.9135935,12.6065967,0.285964,4.1782099,5.0689638,101.8081196,147.5275148,0.224232,29.1040772,24.3664446,48.0160087,7.5486847,10.3242868,3.0741276,30.1159603),(36571,'humerus.tif',234,2,148,16.9204292,12.8718226,12.471164,1.8,12.965914,12.5133586,0.3142805,4.2277215,4.972584,103.3809607,146.5116677,0.2694938,29.46389,24.4531152,48.4479586,7.6575552,10.3140179,3.0909603,30.234775),(36572,'humerus.tif',234,2,149,18.9791589,12.9825432,12.3297355,1.8,13.075107,12.3650954,0.3947772,4.2233407,4.9302298,109.5557946,148.8442323,0.4678968,30.1901203,25.9405535,50.0610475,7.7482039,10.3525175,3.084416,30.3993067),(36573,'humerus.tif',234,2,150,18.7845214,13.0399873,12.3003816,1.8,13.1396161,12.3215471,0.3836677,4.2795552,4.9888666,113.8027942,149.4633955,0.4386765,29.9593893,26.5922013,50.5240204,7.8649638,10.3590079,3.0743541,30.7184774),(36574,'humerus.tif',234,2,151,19.1841127,13.0999508,12.1856698,1.8,13.1889109,12.2219731,0.3962839,4.3666342,5.0387988,120.3357561,154.0204306,0.4763751,30.5668944,27.5580119,52.2004842,7.9738678,10.3961178,3.0712392,30.930775),(36575,'humerus.tif',234,2,152,20.0237636,13.1818331,12.0565748,1.8,13.2759703,12.1262174,0.348829,4.5820439,5.1361259,128.4345851,163.8442372,0.3898812,31.9003543,28.0299767,54.7684019,8.1170911,10.5029721,0.1095595,31.4264189),(36576,'humerus.tif',234,2,153,21.0562157,13.1677197,11.9268241,1.8,13.2441676,11.9924318,0.3371816,4.6964154,5.2897959,135.431458,171.4561012,0.3840922,32.4126118,28.8371977,55.9182006,8.2767481,10.623637,3.0989955,32.0627115),(36577,'humerus.tif',234,2,154,21.8874241,13.2545079,11.7525701,1.8,13.3294827,11.8311881,0.452905,4.6491441,5.207739,146.2089949,177.2506888,0.6984855,34.0360161,31.448583,58.5928749,8.4659513,10.7218456,0.0844889,32.6195115),(36578,'humerus.tif',234,2,155,23.4646816,13.3109593,11.4756432,1.8,13.3722594,11.5719701,0.6546794,4.5549065,5.0747081,165.4547336,189.2635423,1.4499814,37.2954539,36.3245068,63.2591677,8.7249366,10.8777141,3.0807703,33.9532529),(36579,'humerus.tif',234,2,156,24.2982906,13.3788033,11.3145896,1.8,13.4185683,11.324117,0.7846183,4.7640453,4.9332238,182.3946021,194.8250239,2.0216993,39.4924356,38.2856563,66.2644415,9.0752373,11.04937,0.0567214,35.7727456),(36580,'humerus.tif',234,2,157,25.7160896,13.4161936,11.0618066,1.8,13.4381858,11.045378,1.2457836,5.6126665,5.5069638,204.4305202,222.3882921,3.848988,40.3831041,36.4230654,73.5759132,9.4690343,11.4220365,1.5342273,40.3453601),(36581,'humerus.tif',234,2,158,27.7147484,13.5310078,10.7002131,1.8,13.5659348,10.6829007,-1.5551787,5.8249754,6.0774409,221.8666731,267.071243,4.6179982,43.9446876,38.0888599,80.3092869,10.010616,12.1849705,1.59936,43.0815943),(36582,'humerus.tif',234,2,159,30.5036802,13.5899282,10.3611234,1.8,13.6449497,10.3627016,-1.5175147,5.9068757,6.4228646,241.4888524,320.0511641,5.0695274,49.8299722,40.8826703,87.4276765,10.4228054,12.5722436,1.5320346,53.3031503),(36583,'humerus.tif',234,2,160,33.4472547,13.6705913,9.9816249,1.8,13.7161427,9.9821305,-1.4752517,6.0642495,6.7623209,281.2645781,376.4766871,5.5238084,55.6727032,46.3807731,97.1885395,10.8187254,12.710054,1.5351949,50.3054039),(36584,'humerus.tif',234,2,161,35.6458954,13.7062935,9.87565,1.8,13.706138,9.8853386,-1.4571493,6.1402621,6.8044191,317.6054676,411.961456,5.8645807,60.5432224,51.7250672,107.1215094,10.9672467,12.7945266,1.5109225,42.7103114),(36585,'humerus.tif',234,2,162,38.5184927,13.8290179,9.7289451,1.8,13.8384908,9.7632114,-1.5550266,6.0908807,6.8782438,366.0139699,445.9189425,6.4181524,64.8303488,60.0921261,117.8168204,11.1795707,12.8852141,1.5329765,44.3547796),(36586,'humerus.tif',234,2,163,41.0474277,13.9079529,9.6171712,1.8,13.8951296,9.6714134,1.511774,6.1427504,6.8707105,409.4053821,463.0058679,6.8174332,67.388354,66.6485458,125.8117332,11.2521201,12.9535025,1.6057283,47.4165796),(36587,'humerus.tif',234,2,164,44.8094601,13.8442586,9.5812328,1.8,13.8316509,9.6316091,1.3582353,6.2250059,6.6328902,467.4274391,502.8149556,7.1358633,75.8063138,75.0886746,141.3012152,11.2806519,12.8170343,1.6115346,43.1293602),(36588,'humerus.tif',234,2,165,46.9238303,13.6768725,9.688567,1.8,13.6863773,9.7259678,-1.5639857,6.5139905,6.6696518,498.1747757,520.6452022,7.8202756,78.0618267,76.4776643,152.5971527,11.3101231,12.7723586,1.5598976,42.2196138),(36589,'humerus.tif',234,2,166,48.3257424,13.4446134,9.7743306,1.8,13.4838123,9.7998112,-1.3609551,6.8534465,6.3883879,501.3881411,536.2685121,7.704808,83.9442631,73.1585399,151.2563134,11.3406319,12.6577317,1.50752,42.5218968),(36590,'humerus.tif',234,2,167,50.0659863,13.4153648,9.772858,1.8,13.488565,9.7779803,-0.878161,6.3380463,5.7615808,508.69478,538.7145888,4.9417764,93.5011767,80.2605019,151.3838204,11.355427,12.5751331,1.526504,42.1535114),(36591,'humerus.tif',234,2,168,50.2905472,13.3360954,9.7606667,1.8,13.399419,9.7866538,-0.6052089,5.8024807,5.8120433,487.5040085,523.3760483,2.7130561,90.0502663,84.0164808,145.2632223,11.2701508,12.5427331,0.0889015,41.9700431),(36592,'humerus.tif',234,2,169,50.0951012,13.3312116,9.6768495,1.8,13.4333332,9.6916723,-0.4621086,5.9761528,5.947119,459.4869077,522.5181188,1.659569,87.8607132,76.8867402,142.4864941,11.0923442,12.4866067,0.1005006,41.3555846),(36593,'humerus.tif',234,2,170,48.9036275,13.3775595,9.6437918,1.8,13.4544398,9.6704891,-0.33689,6.1890963,6.0491005,424.7233335,486.0401884,0.8905809,80.3491672,68.6244506,133.7092766,10.9239934,12.3379621,0.0932135,41.2198821),(36594,'humerus.tif',234,2,171,47.5931436,13.4598777,9.5876825,1.8,13.5406388,9.6518941,-0.2471203,6.3129026,6.0417265,387.3064899,440.7469737,0.4746257,72.9505006,61.3515702,123.7968526,10.6490373,12.1583551,0.0888459,41.8800577),(36595,'humerus.tif',234,2,172,45.5438651,13.4400158,9.6135955,1.8,13.4772166,9.68455,-0.3042391,6.5005099,5.8490021,339.8709196,395.9727454,0.6811886,67.6991975,52.2837326,111.9052805,10.3478307,11.8876006,0.0967558,42.9051211),(36596,'humerus.tif',234,2,173,42.669374,13.4480037,9.6878278,1.8,13.47524,9.7320223,-0.4150255,6.1946702,5.7432982,289.2125937,352.8368383,1.1562042,61.4345324,46.6873269,100.6248441,9.9804818,11.4907472,0.1153395,43.3803796),(36597,'humerus.tif',234,2,174,37.8072889,13.3569711,9.847613,1.8,13.3800272,9.9089287,-0.5940455,5.6865139,5.3470215,242.7367543,290.5445227,1.9740714,54.3376392,42.6863905,87.1704588,9.5276354,11.094871,0.1068471,43.1785748),(36598,'humerus.tif',234,2,175,32.7219223,13.177461,10.170485,1.8,13.1366374,10.2076585,-1.1271097,5.6960758,4.6156695,185.3611337,227.1352371,4.4486844,49.2095977,32.5419006,70.5235458,7.1854674,10.2654692,1.7548948,32.4008189),(36599,'humerus.tif',234,2,176,25.5518779,12.878405,10.6623114,1.8,12.8651292,10.6307052,-1.3520104,5.6300529,4.5799233,105.7884663,162.6369213,4.0580283,35.5108394,18.7899597,46.7204501,6.5546983,9.4687341,1.744404,31.0685262),(36600,'humerus.tif',234,2,177,13.5741735,12.1503309,11.8831092,1.8,12.2166323,11.7492135,1.4681148,6.0266026,4.7214598,30.5292602,59.207474,2.2385928,12.5400779,5.0657496,14.8431168,2.6750579,7.2283546,2.465348,17.3119606),(36601,'humerus.tif',234,2,178,7.6751632,11.7546999,12.5946916,1.8,11.7734081,12.6010048,0.6115862,1.1546552,3.7134082,1.8339648,17.0123754,0.4217088,4.5813373,1.5883225,4.9322866,2.0471401,6.3425805,2.4728499,14.90539),(36602,'humerus.tif',234,2,179,1.1699941,11.9337928,12.5944203,1.8,11.9987447,12.6396394,0.5599276,0.6948802,2.6260423,0.091695,0.9703349,0.055008,0.3695047,0.131958,0.4039259,1.3082425,3.0828951,2.6476513,9.5249559),(36603,'humerus.tif',234,2,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36604,'humerus.tif',234,2,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36605,'humerus.tif',234,2,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36606,'humerus.tif',234,2,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36607,'humerus.tif',234,2,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36608,'humerus.tif',234,2,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36609,'humerus.tif',234,2,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36610,'humerus.tif',234,2,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36611,'humerus.tif',234,2,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36612,'humerus.tif',234,2,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36613,'humerus.tif',234,2,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36614,'humerus.tif',234,2,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36615,'humerus.tif',234,2,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36616,'humerus.tif',234,2,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36617,'radius.tif',234,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36618,'radius.tif',234,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36619,'radius.tif',234,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36620,'radius.tif',234,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36621,'radius.tif',234,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36622,'radius.tif',234,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36623,'radius.tif',234,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36624,'radius.tif',234,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36625,'radius.tif',234,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36626,'radius.tif',234,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36627,'radius.tif',234,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36628,'radius.tif',234,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36629,'radius.tif',234,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36630,'radius.tif',234,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36631,'radius.tif',234,3,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36632,'radius.tif',234,3,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36633,'radius.tif',234,3,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36634,'radius.tif',234,3,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36635,'radius.tif',234,3,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36636,'radius.tif',234,3,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36637,'radius.tif',234,3,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36638,'radius.tif',234,3,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36639,'radius.tif',234,3,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36640,'radius.tif',234,3,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36641,'radius.tif',234,3,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36642,'radius.tif',234,3,26,0.6117369,8.8333952,6.3973708,1.8,8.8389627,6.4041416,-1.4547576,0.5574676,0.5970835,0.0350734,0.0446447,0.1005895,0.0747713,0.0629156,0.1295122,1.1265,1.2767,1.080839,3.9629935),(36643,'radius.tif',234,3,27,7.5730745,8.5874834,6.4218173,1.8,8.5543728,6.4598701,0.5662733,1.7906304,2.0240238,4.6183113,6.5854378,0.3632834,3.2536366,2.5791539,5.5305742,3.4062088,3.9916198,2.4227627,13.5078623),(36644,'radius.tif',234,3,28,11.2716606,8.6073336,6.4651693,1.8,8.5590691,6.430653,-0.7951224,2.3526769,2.4134122,14.6129014,16.4756282,0.9575719,6.8266947,6.2111808,12.2540228,4.5600781,4.9417855,1.8637087,16.2479069),(36645,'radius.tif',234,3,29,13.0587627,8.6301731,6.6607993,1.8,8.5593157,6.6680342,-1.1464317,2.5013429,10.3931259,21.4142136,53.629177,1.8074821,5.1600623,8.5610868,7.2091786,5.0388113,5.5084712,1.7628443,18.2658483),(36646,'radius.tif',234,3,30,16.0699556,8.0133462,8.0734753,1.8,8.0610404,7.957326,-1.057046,3.4870476,9.3749436,30.8092494,208.819328,2.0314565,22.2741957,8.8353395,25.0234105,5.1056395,5.7046349,1.8509043,18.5844706),(36647,'radius.tif',234,3,31,18.8818738,7.3030022,8.9313,1.8,7.3340973,8.9448177,-0.9455743,5.8633317,8.0321756,64.829647,259.1632266,2.0689829,32.2656324,11.0567933,37.7924549,1.8141389,11.4517037,1.8635094,30.4671981),(36648,'radius.tif',234,3,32,21.5114057,6.8217219,9.1698458,1.8,6.9002399,9.3468084,-0.9471491,6.323151,7.5889308,117.8580114,261.0752207,2.36247,34.4021086,18.6391266,46.0698158,2.4862612,12.4026464,1.9231886,42.7841348),(36649,'radius.tif',234,3,33,23.0078304,6.5433329,9.4204738,1.8,6.6323057,9.573605,-1.2273193,6.230002,7.5643233,153.3121946,258.9508807,3.3997545,34.233185,24.6086913,53.4616466,3.1662414,13.1147913,1.9215243,47.5163505),(36650,'radius.tif',234,3,34,26.6430336,6.3667114,9.3393622,1.8,6.4315332,9.4569008,-1.5211193,5.0498155,7.6528213,180.8670447,288.0539556,4.4295563,37.6402301,35.8165653,61.2524527,3.8622589,13.9233053,1.9232539,54.5273366),(36651,'radius.tif',234,3,35,30.0085834,6.4659559,9.4984998,1.8,6.49727,9.5175002,1.4976159,5.202188,7.3786592,172.4200145,360.9610854,4.9746938,48.9196037,33.1437492,67.3575897,4.3285591,14.6614361,1.9265694,43.4440232),(36652,'radius.tif',234,3,36,37.0771756,6.4812451,9.2736232,1.8,6.537193,9.3258775,1.3173598,5.5574841,7.5897807,187.710092,427.6539225,5.7910431,56.3460187,33.7760914,75.0578757,4.9228109,15.3505578,1.8585043,51.882825),(36653,'radius.tif',234,3,37,42.1950608,6.3975816,9.4300843,1.8,6.4023026,9.4031252,1.2373345,5.7630001,7.9337764,210.1803786,459.9027925,6.2790763,57.9677028,36.4706533,80.9726754,5.5543516,16.2113403,1.82364,54.8641813),(36654,'radius.tif',234,3,38,44.3927842,6.4218143,9.3137655,1.8,6.4666318,9.2390651,1.2333496,5.6073312,7.7170349,208.1767376,495.1878686,6.5877914,64.1681519,37.1258144,88.1493975,11.2207573,16.7802714,1.7918925,88.528277),(36655,'radius.tif',234,3,39,43.0408854,6.5803782,9.1769293,1.8,6.5165098,9.1314132,1.2304816,5.3395418,7.7720948,198.2268711,501.9710737,6.3742718,64.5863296,37.1243226,85.5831782,10.886044,17.1979003,1.8358994,82.5793653),(36656,'radius.tif',234,3,40,43.4134422,6.4718381,9.2904789,1.8,6.3516492,9.2269922,1.3396193,5.3574624,7.5331496,204.6779495,559.1935772,6.8557239,74.231046,38.2042717,93.0821157,11.2661215,17.1058285,1.8328127,74.6609263),(36657,'radius.tif',234,3,41,44.9667389,6.2982849,9.4490684,1.8,6.2563115,9.3591953,1.3645977,5.4824059,7.5691921,210.7210791,617.2882477,7.1802988,81.5527254,38.4358771,100.5655958,11.246891,16.5296792,1.6709171,70.6401394),(36658,'radius.tif',234,3,42,46.0142208,6.2025484,9.3149312,1.8,6.2510893,9.4019191,1.351577,5.5294098,7.2140139,202.3871931,605.2989066,7.3063512,83.9059805,36.6019522,107.9775538,11.4743096,16.1721536,1.6824792,68.8301915),(36659,'radius.tif',234,3,43,45.8163604,6.3320189,9.4646851,1.8,6.3697764,9.5832121,1.3157299,5.4498057,7.0819802,181.6083946,565.9079639,7.1499471,79.908154,33.3238293,104.9436144,11.3264535,14.1006127,1.7963976,65.9430732),(36660,'radius.tif',234,3,44,11.8432878,6.7356554,13.7518011,1.8,6.6915203,13.8038632,1.1313748,2.5776849,2.7603421,13.3861504,18.4965596,1.6166506,6.7008216,5.1930903,10.4512875,4.7262311,5.8990561,2.5924398,28.7408138),(36661,'radius.tif',234,3,45,15.3081974,6.8190596,13.5773641,1.8,6.7978675,13.6129666,0.9175393,2.7106162,3.2244331,29.5455208,40.4234609,1.6089125,12.5366101,10.8999279,21.5683545,5.2627388,6.3733314,2.7676507,20.3686483),(36662,'radius.tif',234,3,46,14.7311655,6.8141414,13.5476157,1.8,6.8103452,13.5432063,0.7748892,2.6780386,3.0918858,24.8656807,32.9292512,1.2017976,10.6502159,9.2850346,18.4858803,5.2556665,6.3235807,2.4909658,20.405093),(36663,'radius.tif',234,3,47,11.5415719,6.7955555,13.465089,1.8,6.7706359,13.5086383,0.752747,2.5772204,2.8905845,20.1577613,25.8669178,0.8990347,8.9486809,7.8215125,15.4654984,5.0717488,5.9632428,2.1133757,18.9106409),(36664,'radius.tif',234,3,48,9.2271806,6.6819096,13.365664,1.8,6.6985164,13.4209503,0.9365027,2.4632364,2.9599249,15.1006206,20.2223157,0.9977888,6.8320368,6.1303984,11.8215918,4.7793348,5.5594295,2.4710711,17.797026),(36665,'radius.tif',234,3,49,8.117249,6.6150018,13.2822194,1.8,6.6648205,13.3201813,0.9760585,2.6546206,2.7189808,13.6430192,17.6170622,0.9281713,6.4792889,5.139348,11.0304207,4.7262311,5.34847,2.2367656,16.7864921),(36666,'radius.tif',234,3,50,7.2918517,6.6693548,13.1569673,1.8,6.7302721,13.2068555,0.7625864,2.6725809,2.6104076,14.1406214,15.6022252,0.5799406,5.9769308,5.2909985,10.8489253,4.8145994,5.1731855,2.053922,16.6985069),(36667,'radius.tif',234,3,51,6.7603149,6.7884691,13.017283,1.8,6.8926058,13.0114475,-0.3584509,2.4449256,2.881788,14.2474333,16.2436628,0.1386737,5.6366613,5.8273484,10.5775133,4.8815001,5.2960146,0.3172663,17.3904185),(36668,'radius.tif',234,3,52,6.5377682,6.9734427,12.8172124,1.8,7.1482174,12.7789921,-0.27535,2.3898138,3.0170323,12.7076425,19.7893165,0.0805462,6.5591994,5.3174194,10.6730583,4.7177427,5.7474812,0.1178721,17.6908185),(36669,'radius.tif',234,3,53,7.1770173,7.1486963,12.7102761,1.8,7.3183496,12.6649651,-0.2638683,2.3377534,3.1203139,12.8930468,24.4245414,0.08137,7.8275912,5.515144,11.8489418,4.5607192,6.1126972,0.0984462,18.4342706),(36670,'radius.tif',234,3,54,7.2585865,7.0728229,12.6741309,1.8,7.2469749,12.6233797,-0.3336335,2.2697725,3.2294796,13.1758799,24.8251382,0.1297376,7.6870399,5.8049341,11.6271475,4.4910782,6.2351095,0.1572281,18.1049739),(36671,'radius.tif',234,3,55,7.3703833,6.9820954,12.6278411,1.8,7.1854405,12.5612634,-0.3626907,2.2229113,3.1609377,12.8125908,24.5612703,0.1546267,7.7702482,5.7638785,11.7159995,4.4230106,6.2006411,0.1950203,18.1671888),(36672,'radius.tif',234,3,56,7.2624709,6.7694641,12.6620964,1.8,6.9562034,12.5924686,-0.3180321,2.2102562,3.0698177,11.9676768,21.8984537,0.1183541,7.1334703,5.4146106,10.8948727,4.46413,6.012692,0.1630953,17.9396781),(36673,'radius.tif',234,3,57,6.7467385,6.3639015,12.7386731,1.8,6.4239639,12.7152574,-0.4833904,2.1899927,2.585807,10.7441552,15.5774235,0.2429096,6.0242019,4.9060234,10.1172461,4.3558001,5.1775446,0.4182243,16.5043144),(36674,'radius.tif',234,3,58,6.2705541,6.0404468,12.7762344,1.8,6.0859708,12.7620277,-0.6112846,2.2319508,2.3535601,10.0548457,11.9520641,0.3442368,5.0782913,4.5049585,9.3193956,4.2807001,4.6887909,0.5569015,15.1676102),(36675,'radius.tif',234,3,59,6.1518353,5.81573,12.7708865,1.8,5.8704491,12.7665768,-0.6207519,2.2126363,2.184128,9.7780424,10.2215193,0.3468745,4.6799085,4.419182,8.754458,4.2056001,4.4613446,2.5115587,14.7352325),(36676,'radius.tif',234,3,60,6.2247761,5.5960551,12.7625689,1.8,5.6452842,12.746781,1.0451947,2.105544,2.1945152,9.3092995,9.6260035,0.7762955,4.3863918,4.4213275,8.3161927,4.1305001,4.3790449,2.6011732,14.0797656),(36677,'radius.tif',234,3,61,6.4031696,5.4416519,12.7710736,1.8,5.4896463,12.7555846,0.9091008,2.0103259,2.202035,8.7424395,9.761096,0.6642696,4.4327616,4.3487674,8.1827905,3.982779,4.3790449,2.6011732,14.1526548),(36678,'radius.tif',234,3,62,6.5482033,5.2939352,12.7653042,1.8,5.3453068,12.7566759,0.8263106,1.9500848,2.2469096,8.3732435,9.8593259,0.5902843,4.3879496,4.2937843,8.0281891,3.9062132,4.4079287,2.3682421,14.1162102),(36679,'radius.tif',234,3,63,6.9171656,5.1421834,12.7387342,1.8,5.1929221,12.7347358,0.768478,1.9041779,2.2872229,8.1724842,10.6412307,0.5569276,4.6524678,4.29187,8.0354306,3.8298016,4.5514566,2.484891,13.9295656),(36680,'radius.tif',234,3,64,7.1090001,5.0220166,12.7645431,1.8,5.0208693,12.7341738,0.6050345,1.8962881,2.3461278,8.1071757,10.9910555,0.3833204,4.6847642,4.2752869,8.0689501,3.8120302,4.7020038,2.677945,14.5228176),(36681,'radius.tif',234,3,65,7.1753603,4.9526586,12.8138829,1.8,4.908953,12.7654647,0.5587585,1.8527859,2.3380231,7.9765168,11.0889161,0.3360963,4.74286,4.3051477,8.1367133,3.7271333,4.7787447,2.6146494,14.1419804),(36682,'radius.tif',234,3,66,7.1298947,4.8827168,12.8601657,1.8,4.8484505,12.8196921,0.5283657,1.801361,2.3089229,7.7329878,10.7204982,0.3019981,4.6430733,4.2928585,7.9478378,3.6662998,4.6743341,2.7282622,13.8673507),(36683,'radius.tif',234,3,67,7.0475109,4.8272402,12.89814,1.8,4.7941398,12.8775828,0.480686,1.7750305,2.3409954,7.4047172,10.4740672,0.251129,4.4741939,4.1716001,7.571726,3.6195503,4.588481,2.7732437,13.8598028),(36684,'radius.tif',234,3,68,6.8076628,4.8054426,12.9536467,1.8,4.7677303,12.9386005,0.3764575,1.7932559,2.3165773,7.0041389,10.1878088,0.1533433,4.397785,3.9058223,7.4182011,3.6149857,4.5184994,2.767259,13.9917804),(36685,'radius.tif',234,3,69,6.6321599,4.8007286,12.9874907,1.8,4.7555957,12.9703688,0.311003,1.8075693,2.2896781,6.727589,9.9143114,0.1035107,4.3300024,3.7218983,7.2226533,3.6048001,4.5681547,2.976444,13.8962474),(36686,'radius.tif',234,3,70,6.3879445,4.7689766,13.0156753,1.8,4.7285398,13.009018,0.298135,1.8224047,2.3313277,6.3421055,9.6191229,0.0918608,4.1260277,3.4800752,6.8451474,3.5697184,4.5539343,2.9086134,13.6216176),(36687,'radius.tif',234,3,71,6.2012474,4.7868533,13.0266963,1.8,4.7679502,13.0195696,0.286461,1.7462493,2.2975425,6.0319354,9.3462399,0.0825176,4.0679291,3.4542235,6.6562241,3.4916237,4.5072516,2.9572682,13.1785656),(36688,'radius.tif',234,3,72,6.2362249,4.8012449,13.0371112,1.8,4.7896508,13.0372188,0.2810831,1.7761483,2.2932767,5.8214359,9.3035654,0.0799783,4.0568873,3.2775619,6.5920367,3.4565135,4.4940935,2.9736967,13.2150102),(36689,'radius.tif',234,3,73,6.1710936,4.8354802,13.0512568,1.8,4.8445721,13.048908,0.2868955,1.7345454,2.2650988,5.6079918,9.1887423,0.0823588,4.0566629,3.233119,6.5115843,3.4261629,4.4200673,2.9708574,13.0283656),(36690,'radius.tif',234,3,74,6.2216576,4.8606959,13.0574394,1.8,4.8826311,13.0642334,0.2883154,1.7164313,2.2895522,5.4510228,9.145946,0.0838346,3.994644,3.1757885,6.3293228,3.395729,4.4334451,2.9541635,13.1270251),(36691,'radius.tif',234,3,75,6.23625,4.8944049,13.0655256,1.8,4.9126833,13.0688151,0.2867877,1.6937917,2.306142,5.3014246,9.0663723,0.0831675,3.9314024,3.1299153,6.153642,3.3351134,4.453753,3.0402462,13.1892399),(36692,'radius.tif',234,3,76,6.2794688,4.9116567,13.0708558,1.8,4.9335919,13.0791575,0.3014894,1.6612246,2.2824708,5.1973812,8.9496156,0.092282,3.9210208,3.1286446,6.1056074,3.3036783,4.3874087,3.0214839,12.7279655),(36693,'radius.tif',234,3,77,6.3314154,4.9344647,13.0657698,1.8,4.9510209,13.075769,0.3128533,1.6234902,2.257656,5.0929002,8.7804904,0.0999575,3.8892065,3.137007,6.0447987,3.2917437,4.346078,2.9679215,12.8963879),(36694,'radius.tif',234,3,78,6.2818295,4.9806324,13.0622801,1.8,5.0041483,13.0739899,0.3344731,1.6040622,2.2303926,4.9480793,8.6549905,0.112824,3.8804784,3.084718,6.0157789,3.2247248,4.3010735,2.9304993,12.7901804),(36695,'radius.tif',234,3,79,6.2546467,5.0146036,13.0507295,1.8,5.0366116,13.0572917,0.3484389,1.601062,2.1713501,4.9028722,8.4721678,0.1215226,3.9017973,3.0622625,6.0308265,3.1888262,4.238329,3.0172377,12.4715581),(36696,'radius.tif',234,3,80,6.2129427,5.0467945,13.0423629,1.8,5.076737,13.0483217,0.3653369,1.5761514,2.1631655,4.840671,8.3280001,0.1321675,3.8499136,3.0711967,5.9868988,3.191406,4.2123001,2.9441971,12.533773),(36697,'radius.tif',234,3,81,6.2092915,5.0800067,13.0288041,1.8,5.1024096,13.032912,0.3793377,1.6158231,2.1037329,4.8491403,8.2267232,0.1419093,3.9105361,3.0010341,6.0637302,3.2200483,4.1638193,3.0150005,12.9328325),(36698,'radius.tif',234,3,82,6.224107,5.108811,13.0150646,1.8,5.1260197,13.0204125,0.4004742,1.6264799,2.0720825,4.8549502,8.1044261,0.1576638,3.9112468,2.9849432,6.0836529,3.2249155,4.1386847,2.9406384,12.7021953),(36699,'radius.tif',234,3,83,6.2468272,5.1172174,12.995413,1.8,5.1407384,13.0063456,0.4251671,1.6175517,2.0222601,4.8484115,8.0083219,0.1771329,3.960085,2.9973765,6.129416,3.2234413,4.0996622,2.9945143,12.5959879),(36700,'radius.tif',234,3,84,6.249739,5.1273828,12.974787,1.8,5.1497144,12.9873925,0.4352223,1.6034052,2.0442589,4.8991902,7.9571147,0.1851554,3.8924202,3.0554911,6.1544025,3.2247248,4.0872619,2.7849725,12.6582027),(36701,'radius.tif',234,3,85,6.1871217,5.133508,12.9470258,1.8,5.1515824,12.9510473,0.4377618,1.6355438,2.0225118,4.9338949,7.9330796,0.1853069,3.9223897,3.0166694,6.1703992,3.2249155,4.0651236,2.9369508,12.3911209),(36702,'radius.tif',234,3,86,6.1986542,5.1561708,12.9382982,1.8,5.1767247,12.9425019,0.4327717,1.6222312,2.0338771,5.0196728,8.0062663,0.1817102,3.9364552,3.0943017,6.3123696,3.2586156,4.1024128,2.7270858,12.5959879),(36703,'radius.tif',234,3,87,6.2494712,5.1661599,12.9127396,1.8,5.1822454,12.9164521,0.4297032,1.6701183,1.9988645,5.1461731,8.0573913,0.1807726,4.0309843,3.0813225,6.586377,3.301796,4.0706695,2.4870219,12.2484688),(36704,'radius.tif',234,3,88,6.3458569,5.1733693,12.8948274,1.8,5.1802724,12.8959836,0.4182301,1.6564095,1.9765701,5.2793627,8.1100554,0.174461,4.1030953,3.1872328,6.7205542,3.3200625,4.0706695,2.4870219,12.4168912),(36705,'radius.tif',234,3,89,6.4942255,5.1888959,12.900842,1.8,5.207096,12.9076095,0.4079555,1.6495448,1.9822937,5.5062236,8.2480714,0.1703624,4.1608726,3.338026,6.8038097,3.3491855,4.0706695,2.6201582,12.6475284),(36706,'radius.tif',234,3,90,6.4886862,5.1981789,12.8804406,1.8,5.2139683,12.8771834,0.4016019,1.6841572,2.0118815,5.6894736,8.2350375,0.1652426,4.0932021,3.3782318,6.9150059,3.4204046,4.0727472,2.7439647,13.0025953),(36707,'radius.tif',234,3,91,6.5690586,5.2070734,12.8552456,1.8,5.2169722,12.8487443,0.4010481,1.6677675,2.0688228,5.8902065,8.3649277,0.1668533,4.0433273,3.5317911,6.8592775,3.420135,4.1658506,2.6537562,13.0723581),(36708,'radius.tif',234,3,92,6.61083,5.2174583,12.820373,1.8,5.2277676,12.8128139,0.3752618,1.709358,2.0599241,6.0815153,8.3964563,0.1480099,4.0760998,3.5577773,6.9906012,3.4626512,4.1359583,2.6292032,13.2332325),(36709,'radius.tif',234,3,93,6.5966397,5.2089072,12.7824827,1.8,5.2111478,12.7772559,0.3675507,1.7302547,2.0635995,6.2529343,8.5268735,0.1419581,4.132039,3.6138809,7.1024246,3.5027492,4.1874565,2.5734879,12.7612837),(36710,'radius.tif',234,3,94,6.640304,5.1997903,12.7461055,1.8,5.1999737,12.7394851,0.3324091,1.7592598,2.0788968,6.4930125,8.646215,0.1178494,4.1590399,3.6907639,7.2441956,3.5297001,4.1658506,2.6537562,12.929706),(36711,'radius.tif',234,3,95,6.6735519,5.1935345,12.7046282,1.8,5.1971347,12.7023606,0.3145756,1.7870547,2.0809155,6.6616989,8.8282626,0.1064836,4.2424897,3.7277531,7.4419164,3.5779231,4.1475331,2.4074317,13.079906),(36712,'radius.tif',234,3,96,6.6888965,5.171374,12.6635491,1.8,5.175922,12.6543235,0.3070539,1.8007702,2.0731516,6.9141626,8.9126849,0.1018452,4.2990995,3.8395586,7.6179173,3.6249004,4.1359583,2.6292032,13.2665507),(36713,'radius.tif',234,3,97,6.6125969,5.1715657,12.611587,1.8,5.1743202,12.6054573,0.2984867,1.8422201,2.0812248,7.0833266,8.9769202,0.0953091,4.3132872,3.8449948,7.633167,3.6758832,4.1759923,2.483704,13.5047358),(36714,'radius.tif',234,3,98,6.5988419,5.1768484,12.5629376,1.8,5.1798602,12.5502892,0.2704051,1.8747698,2.1353715,7.2611309,9.054217,0.0784757,4.2401132,3.8730786,7.6260703,3.6799001,4.250952,2.5829933,13.8962474),(36715,'radius.tif',234,3,99,6.6354406,5.1754309,12.5272271,1.8,5.1761108,12.5165061,0.2328971,1.8760714,2.1403907,7.5006807,9.2021418,0.0589088,4.2992813,3.9980786,7.8006215,3.6799001,4.2701467,2.5438343,13.6291656),(36716,'radius.tif',234,3,100,6.6810952,5.1778755,12.4706316,1.8,5.1723998,12.4552954,0.2022712,1.8929766,2.1774948,7.8178183,9.3104055,0.0449401,4.2757417,4.1299075,7.8419164,3.7497623,4.2701467,2.725154,13.7171507),(36717,'radius.tif',234,3,101,6.6533028,5.1698792,12.4052815,1.8,5.1655069,12.3841552,0.190017,1.8964134,2.1862367,7.9857672,9.367318,0.0395583,4.284677,4.2109844,7.9290403,3.7550001,4.2991061,2.6701327,13.6549358),(36718,'radius.tif',234,3,102,6.631013,5.1809279,12.3400034,1.8,5.1803577,12.3213998,0.1955175,1.9511725,2.1976777,8.2026731,9.5375636,0.0417118,4.3398372,4.2039713,8.0085159,3.8301001,4.340884,2.6160089,13.9295656),(36719,'radius.tif',234,3,103,6.6153033,5.1800392,12.2648872,1.8,5.1724793,12.2444405,0.0915705,1.9207616,2.2102832,8.3552566,9.730173,0.0092192,4.4022291,4.3499707,8.1205978,3.8301001,4.3545051,2.5775089,14.0797656),(36720,'radius.tif',234,3,104,6.6386099,5.1895452,12.1917529,1.8,5.1772859,12.1808914,0.063239,1.9331707,2.2160138,8.5608869,9.8841463,0.0044189,4.460327,4.4284175,8.1832679,3.8985506,4.3745348,2.5393053,14.3104028),(36721,'radius.tif',234,3,105,6.6764134,5.1998723,12.0992712,1.8,5.1731419,12.0790381,0.028645,1.9398442,2.210262,8.7710161,10.1344566,0.0009128,4.5851833,4.5215054,8.3658488,3.9052001,4.3661464,2.4292351,14.1677507),(36722,'radius.tif',234,3,106,6.6383533,5.2277575,12.0245611,1.8,5.2110151,12.0013901,-0.0037592,1.9599079,2.2242741,8.987203,10.1102231,0.0000156,4.5454033,4.585523,8.2079066,3.9624183,4.4008857,2.5015045,14.7716772),(36723,'radius.tif',234,3,107,6.7085144,5.2203638,11.9479091,1.8,5.1972203,11.9311181,-0.0607292,1.9806918,2.2685823,9.2555715,10.3498686,0.0041185,4.5622628,4.6728985,8.4798916,3.9803001,4.3867659,0.6640462,14.3801656),(36724,'radius.tif',234,3,108,6.7236859,5.219175,11.867869,1.8,5.1988698,11.8498621,-0.1283674,2.0354642,2.1966841,9.4883056,10.5273668,0.0183645,4.79239,4.6614947,8.5548681,3.9803001,4.4232562,0.7012599,14.5303656),(36725,'radius.tif',234,3,109,6.720003,5.2125619,11.7775812,1.8,5.1981589,11.7506469,-0.1194529,2.0763198,2.2033365,9.7494391,10.687811,0.0159054,4.8507392,4.6955383,8.8524489,4.109575,4.4607125,0.7853982,14.8049953),(36726,'radius.tif',234,3,110,6.6281483,5.2024534,11.6795846,1.8,5.1979067,11.6695746,-0.1243132,2.0359044,2.1766418,9.8718157,10.7164859,0.0169839,4.9234036,4.8488601,8.7589681,4.0554001,4.4922106,0.6669082,14.5121433),(36727,'radius.tif',234,3,111,6.6357274,5.1989939,11.5663504,1.8,5.2000745,11.5496804,-0.1193554,2.0907762,2.1882069,10.0924308,10.8860469,0.0156804,4.9748709,4.8271215,8.9804117,4.1305001,4.4821553,0.5461666,14.8489879),(36728,'radius.tif',234,3,112,6.6123773,5.2072345,11.4493309,1.8,5.2125747,11.4382062,-0.2105184,2.1746389,2.1681793,10.3567799,10.9222467,0.048124,5.0375201,4.7625287,9.0793924,4.2056001,4.5222425,0.6202495,14.6805656),(36729,'radius.tif',234,3,113,6.6832643,5.2050201,11.3408734,1.8,5.2083511,11.3312832,-0.0867145,2.1441593,2.1926831,10.6977653,11.0824477,0.0083547,5.0542861,4.9892587,9.1585307,4.2608177,4.5663024,0.633633,15.0978474),(36730,'radius.tif',234,3,114,6.7286453,5.2069947,11.223629,1.8,5.2047633,11.2160955,-0.383082,2.2600849,2.2921637,10.9932225,11.2913006,0.1566789,4.9260447,4.864075,9.2612365,4.2807001,4.5866369,0.6926418,15.2298251),(36731,'radius.tif',234,3,115,6.687589,5.2336642,11.1156121,1.8,5.2471543,11.108987,-1.0898048,2.2608446,2.3014105,11.009868,11.5626389,0.8760153,5.0241532,4.8698031,9.4950324,4.3069535,4.5737072,0.5150728,15.0978474),(36732,'radius.tif',234,3,116,6.6512024,5.2545358,10.9897756,1.8,5.2689786,10.9824117,-1.0518469,2.2645766,2.3051594,10.9578321,11.9062714,0.8358518,5.1650534,4.8387996,9.6706582,4.3278004,4.5866369,0.6926418,15.1236177),(36733,'radius.tif',234,3,117,6.6042348,5.2805099,10.8586298,1.8,5.3023503,10.8462749,-1.0242642,2.2437801,2.2818867,10.9393295,12.0843291,0.8033866,5.2957622,4.8754017,9.6687825,4.3446851,4.6270378,0.6240231,15.0796251),(36734,'radius.tif',234,3,118,6.3897825,5.2795199,10.7516297,1.8,5.2941203,10.7526764,-1.0682262,2.2729075,2.3029689,10.775442,11.9940874,0.8178761,5.2080978,4.7408185,9.3887204,4.3244618,4.6713167,0.6370703,15.4164697),(36735,'radius.tif',234,3,119,6.3639194,5.3184471,10.6293758,1.8,5.3348995,10.6241468,-0.9337352,2.2550754,2.3514008,10.798224,12.1416852,0.6853629,5.1635966,4.7884094,9.521975,4.3505438,4.6695053,0.485227,15.1858325),(36736,'radius.tif',234,3,120,6.3646209,5.3543879,10.5242334,1.8,5.3717735,10.512495,-0.9296348,2.2778547,2.3826218,10.8500078,12.3341965,0.6812737,5.1767328,4.7632572,9.4954738,4.3769748,4.7050016,0.4993467,15.2480474),(36737,'radius.tif',234,3,121,6.3067754,5.3576869,10.3961378,1.8,5.3739485,10.3842918,-0.8420942,2.241459,2.3899054,10.9200474,12.2424374,0.5850318,5.1225615,4.871848,9.4337489,4.4056495,4.7139835,0.3923401,15.434692),(36738,'radius.tif',234,3,122,6.3456913,5.3720989,10.2540658,1.8,5.3990638,10.2335662,-0.7340986,2.2067202,2.4138889,11.2823273,12.3259936,0.4746475,5.1062804,5.1127131,9.6460387,4.4341158,4.7139835,0.3923401,15.3102623),(36739,'radius.tif',234,3,123,6.5242719,5.3916027,10.1101071,1.8,5.4288435,10.0961521,-0.5401148,2.2348564,2.4717272,11.6131865,12.7619804,0.2875432,5.1631832,5.1963905,9.7947723,4.4337345,4.7905325,0.1574169,15.3724772),(36740,'radius.tif',234,3,124,6.6153571,5.3780245,9.964026,1.8,5.4110594,9.9576865,-0.3988041,2.2922719,2.5310968,11.940443,13.0505599,0.1662547,5.1560887,5.2089994,9.8606838,4.4500032,4.8280599,0.2676163,15.3800251),(36741,'radius.tif',234,3,125,6.5666714,5.374775,9.8176401,1.8,5.4015822,9.8209814,-0.1292791,2.3167595,2.5094808,11.9794491,13.1171685,0.0181899,5.2270447,5.1707779,9.7431069,4.4585545,4.8647182,0.1549967,15.6288846),(36742,'radius.tif',234,3,126,6.6896561,5.4158708,9.6604368,1.8,5.4645173,9.6597055,0.0017987,2.2807455,2.4689993,12.2203165,13.816989,0.0000036,5.5961899,5.3580361,10.1445155,4.5013254,4.9022529,0.0920468,16.0097218),(36743,'radius.tif',234,3,127,6.6364255,5.4567472,9.4856247,1.8,5.4987653,9.4794267,0.0157742,2.3103087,2.500809,12.1626809,14.2049717,0.0002752,5.6801505,5.2645263,10.1430744,4.5202811,4.9934442,0.2121438,15.9657292),(36744,'radius.tif',234,3,128,6.5527052,5.4690126,9.3254971,1.8,5.512579,9.3274617,0.0909915,2.3790082,2.5344073,12.2533193,14.5550142,0.0090172,5.7429656,5.1505999,10.1967032,4.5707632,5.0590875,0.1040999,16.3101218),(36745,'radius.tif',234,3,129,6.4054822,5.4879386,9.1336257,1.8,5.5307551,9.1235202,0.1360213,2.3662225,2.5821424,12.3939216,14.593344,0.0196306,5.6516418,5.2378512,9.9895073,4.6111202,5.1731855,0.1603754,16.1963664),(36746,'radius.tif',234,3,130,6.2309451,5.540558,8.9704021,1.8,5.5835681,8.9713121,0.0558878,2.4484302,2.6435355,12.4757971,14.7706466,0.0032403,5.5874591,5.0954269,10.1315274,4.6867737,5.2084978,0.1011034,16.6211962),(36747,'radius.tif',234,3,131,6.0739801,5.5757822,8.7723747,1.8,5.627786,8.7700654,0.0702684,2.4719464,2.7545118,12.6298546,15.2929919,0.0049903,5.5519791,5.1092753,10.0303106,4.6887777,5.3658412,0.1122028,16.7091813),(36748,'radius.tif',234,3,132,6.0287866,5.5839133,8.5722002,1.8,5.6483897,8.5765382,0.1864764,2.513178,2.8918377,12.9872887,16.2851429,0.0345372,5.6314166,5.1676756,10.0582097,4.7473848,5.5441912,2.9920329,17.2659888),(36749,'radius.tif',234,3,133,6.0480074,5.5511508,8.3662015,1.8,5.6036475,8.3564636,0.2456961,2.5373331,2.8762134,13.8786821,16.7050655,0.059635,5.8080062,5.4697912,10.4111151,4.8551124,5.5756377,3.0606886,17.5148483),(36750,'radius.tif',234,3,134,6.3599139,5.6039683,8.1824552,1.8,5.659851,8.1083137,0.4897167,2.4975073,2.6774199,15.7708232,17.4244894,0.2345255,6.5079405,6.3146254,11.4561861,5.0327103,5.6299962,2.9808299,17.7348111),(36751,'radius.tif',234,3,135,7.0626012,5.6189619,8.0406038,1.8,5.6255159,8.0042711,0.6109569,2.5958098,2.7337649,18.1586048,19.1232963,0.3873555,6.9952233,6.9953526,12.5212659,5.1510609,5.7670738,2.997854,18.4342706),(36752,'radius.tif',234,3,136,7.4221401,5.6399685,7.8717078,1.8,5.6415365,7.8417397,0.8553955,2.7501131,2.8316876,18.5263437,21.8257435,0.7048175,7.7076805,6.7365753,13.080203,5.2572683,6.0253419,2.9661984,19.0897376),(36753,'radius.tif',234,3,137,7.7990029,5.8272801,7.6078134,1.8,5.8436973,7.6194935,0.8539763,2.7103142,2.9220107,20.3699316,24.5092785,0.7387778,8.3878127,7.5157085,14.3493947,5.4165795,6.2351095,2.9843646,19.8847302),(36754,'radius.tif',234,3,138,9.2524575,5.8771875,7.3214571,1.8,5.9343109,7.3270242,0.7133012,2.8724068,3.2222134,25.2164161,32.0054593,0.660244,9.9327559,8.7788457,16.6486241,5.617873,6.705383,2.8694468,21.5765013),(36755,'radius.tif',234,3,139,15.1929818,6.2295533,7.0266589,1.8,6.1694283,7.1448582,0.8241171,3.0379647,3.5065641,32.325528,49.1630831,1.3640265,14.0203007,10.6405214,22.2765931,5.7352018,7.0068744,2.8028946,22.3532715),(36756,'radius.tif',234,3,140,18.4939115,5.9488033,6.9913957,1.8,6.0724256,7.0620057,0.7037582,2.8523497,3.5457448,40.2922871,64.1939992,1.2906355,18.1045174,14.1259986,27.9238138,5.7824962,7.269587,2.7937043,22.6901162),(36757,'radius.tif',234,3,141,18.2090468,6.1178958,6.7613722,1.8,6.1477073,6.8008956,0.6378227,2.7722053,3.3791798,32.9901023,56.161881,1.0760267,16.6199741,11.90031,25.7083243,5.3638657,6.9034836,2.7509856,21.2911971),(36758,'radius.tif',234,3,142,9.6833184,4.9843909,6.3726925,1.8,5.0912016,6.4497285,1.0791634,3.1670535,3.5616815,4.8352628,24.5033611,1.2542377,6.879717,1.5267386,8.2336645,3.4226569,6.4590367,1.9772148,19.6207748),(36759,'radius.tif',234,3,143,2.7037335,4.1150314,4.797684,1.8,4.1384764,4.7850481,-1.2749065,0.8601413,1.5281485,0.2847059,1.4954035,0.4123079,0.9785721,0.3309991,1.044555,1.5661268,3.2493229,0.9827937,9.5159721),(36760,'radius.tif',234,3,144,14.8449094,8.0614494,7.1493436,1.8,7.9748626,7.0789363,0.7143837,2.1324231,4.8456688,11.8428592,88.1403137,1.0619653,18.1895043,5.5537098,20.5669399,4.0868961,9.7276971,2.5428838,38.9380231),(36761,'radius.tif',234,3,145,14.8035692,7.6721115,6.4663817,1.8,7.69977,6.4691784,0.653619,2.131261,4.8708614,14.6422566,86.9754088,0.9122482,17.8562685,6.8702315,20.815461,4.2451716,9.8254799,2.3399797,29.9575097),(36762,'radius.tif',234,3,146,1.4915957,5.872244,3.5637874,1.8,5.9611472,3.5900845,0.3379579,1.2549451,5.9402169,0.2427773,1.3486072,0.0273292,0.22703,0.1934565,0.2677706,2.5815198,3.5678429,2.2817057,16.9549144),(36763,'ulna.tif',234,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36764,'ulna.tif',234,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36765,'ulna.tif',234,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36766,'ulna.tif',234,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36767,'ulna.tif',234,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36768,'ulna.tif',234,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36769,'ulna.tif',234,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36770,'ulna.tif',234,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36771,'ulna.tif',234,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36772,'ulna.tif',234,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36773,'ulna.tif',234,4,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36774,'ulna.tif',234,4,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36775,'ulna.tif',234,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36776,'ulna.tif',234,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36777,'ulna.tif',234,4,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36778,'ulna.tif',234,4,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36779,'ulna.tif',234,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36780,'ulna.tif',234,4,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36781,'ulna.tif',234,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36782,'ulna.tif',234,4,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36783,'ulna.tif',234,4,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36784,'ulna.tif',234,4,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36785,'ulna.tif',234,4,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36786,'ulna.tif',234,4,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36787,'ulna.tif',234,4,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36788,'ulna.tif',234,4,26,0.6117369,8.8333952,6.3973708,1.8,8.8389627,6.4041416,-1.4547576,0.5574676,0.5970835,0.0350734,0.0446447,0.1005895,0.0747713,0.0629156,0.1295122,1.1265,1.2767,1.080839,3.9629935),(36789,'ulna.tif',234,4,27,7.5730745,8.5874834,6.4218173,1.8,8.5543728,6.4598701,0.5662733,1.7906304,2.0240238,4.6183113,6.5854378,0.3632834,3.2536366,2.5791539,5.5305742,3.4062088,3.9916198,2.4227627,13.5078623),(36790,'ulna.tif',234,4,28,11.2716606,8.6073336,6.4651693,1.8,8.5590691,6.430653,-0.7951224,2.3526769,2.4134122,14.6129014,16.4756282,0.9575719,6.8266947,6.2111808,12.2540228,4.5600781,4.9417855,1.8637087,16.2479069),(36791,'ulna.tif',234,4,29,12.728784,8.7342984,6.440514,1.8,8.6639849,6.4432269,-1.330606,2.6065179,2.766774,21.26066,23.7331025,2.0014094,8.577897,8.156729,15.7859083,5.0388113,5.5084712,1.7628443,18.2658483),(36792,'ulna.tif',234,4,30,13.0004271,8.842478,6.6707191,1.8,8.815677,6.6628034,0.0461415,2.892723,2.8204611,23.6725008,25.8244006,0.0046098,9.1560918,8.1834662,16.5611775,5.1056395,5.7046349,1.8509043,18.5844706),(36793,'ulna.tif',234,4,31,12.2793477,9.012465,6.9931496,1.8,8.9905399,6.936252,0.0654366,2.3843458,2.9334957,17.810074,27.5846278,0.0087508,9.4033299,7.4695852,15.3135603,4.7486698,5.8118862,0.4405303,18.6102409),(36794,'ulna.tif',234,4,32,12.4521292,9.1421732,7.1998609,1.8,9.1026358,7.1928077,0.0121156,2.4052406,3.2903831,16.6432715,32.9577315,0.0003046,10.0163813,6.9195869,14.9191488,4.5811001,6.187438,0.0972532,19.3976855),(36795,'ulna.tif',234,4,33,12.6735837,9.1230615,7.4117719,1.8,9.0873972,7.3924495,0.0322272,2.307609,3.5364005,16.3306804,43.1091076,0.002193,12.1901089,7.0768838,15.6795121,4.4761353,6.819229,2.8511907,21.4049525),(36796,'ulna.tif',234,4,34,14.6616224,8.9795019,7.5927026,1.8,8.9537398,7.6019578,0.07643,2.6853108,4.0340058,20.8818837,58.1990279,0.0142467,14.4271058,7.7763376,17.6354151,4.9461957,7.3217687,2.6733579,24.1814418),(36797,'ulna.tif',234,4,35,17.8623727,8.7535089,7.7992153,1.8,8.6392475,7.7860764,0.1239747,3.4348503,4.6409429,32.9252525,86.2633808,0.0455227,18.5874687,9.5856442,21.8696544,6.0516576,7.9959462,3.0475314,30.5796585),(36798,'ulna.tif',234,4,36,24.3057739,8.4144298,8.2697384,1.8,8.3629023,8.2861812,0.1207819,3.8958521,4.4167849,70.1768135,121.1799737,0.0588097,27.4362404,18.0132129,35.9273004,6.8984579,8.6759193,0.095362,29.9317394),(36799,'ulna.tif',234,4,37,24.666167,8.5920409,8.4483428,1.8,8.6127368,8.4758935,0.0915246,3.8811411,4.5067099,72.7894038,119.0999655,0.034341,26.4272536,18.7546401,39.1679654,6.9996723,8.746813,0.521276,29.4264725),(36800,'ulna.tif',234,4,38,22.3926992,8.9347756,8.4817845,1.8,8.9878941,8.5144673,0.0375077,4.0002401,4.3878335,53.4504682,104.4358989,0.005248,23.8012447,13.361815,34.0769047,6.4272229,8.4766579,0.124355,29.6646576),(36801,'ulna.tif',234,4,39,18.5011799,9.5920244,8.4018019,1.8,9.608056,8.4565886,0.115081,3.7573044,3.7919893,38.4558048,68.9042555,0.0406572,18.1710049,10.2349453,25.0083314,6.0519847,7.6144143,1.8301281,25.818546),(36802,'ulna.tif',234,4,40,15.7489269,10.0313939,8.3479517,1.8,10.0158744,8.3921898,0.2176473,3.474788,3.4095464,29.6762378,53.4755623,0.1223877,15.6840695,8.5404456,19.0603003,5.8226084,7.3590338,2.0024913,24.2694269),(36803,'ulna.tif',234,4,41,13.6132538,10.0941458,8.4159719,1.8,10.0329715,8.4712183,0.3662983,3.2149494,3.372715,28.2482353,49.1992472,0.291051,14.5874312,8.7865256,17.3850994,5.6015313,7.5167561,1.9494474,23.91436),(36804,'ulna.tif',234,4,42,12.6897276,10.1255915,8.447962,1.8,10.0467881,8.5352307,0.4697331,3.445645,3.6828717,30.4072263,51.6968308,0.4333341,14.037098,8.8248284,17.7377929,5.8725385,8.1620953,1.7934573,25.5621385),(36805,'ulna.tif',234,4,43,14.9386563,9.8778142,8.678927,1.8,9.8130132,8.7742874,0.5960274,3.9448329,4.0956039,43.0001914,62.7034594,0.7845889,15.3099422,10.9003834,22.0311054,6.4422729,9.3679538,1.7807698,28.1626576),(36806,'ulna.tif',234,4,44,19.5177177,9.3931331,8.9039338,1.8,9.3106805,8.9880625,0.3199466,4.9996639,4.2819235,62.8074549,90.8873712,0.3217828,21.2258277,12.5623354,29.051522,7.0610197,9.4174923,1.8041701,30.6934138),(36807,'ulna.tif',234,4,45,23.2373875,8.8307207,8.8176282,1.8,8.7139985,8.9488279,0.1937787,5.0224256,5.0343761,68.9738512,142.6650003,0.1436169,28.3381692,13.7331752,39.3196263,7.5717102,9.9279816,1.8781938,34.4697627),(36808,'ulna.tif',234,4,46,23.3298126,8.769449,8.6856272,1.8,8.6555012,8.7813783,0.3257135,4.5209532,5.1032618,59.7099921,149.5558756,0.3981245,29.3059383,13.20739,39.9145988,7.1203241,9.5385871,3.0152845,33.081518),(36809,'ulna.tif',234,4,47,20.1053279,9.2377224,8.7717369,1.8,9.0672676,8.8520065,0.361422,4.4038053,4.6883697,43.9952385,124.8535438,0.4189827,26.6304816,9.9902778,32.2483214,0.2253,0.3755,0.9272952,0.8936521),(36810,'ulna.tif',234,4,48,14.5035193,10.2340246,9.0768175,1.8,9.9127673,9.1450808,0.1641084,2.8652715,5.5148982,25.9489944,70.9252011,0.0645181,12.8606546,9.0563823,16.2974795,4.8468331,9.8154294,0.1613751,30.0015023),(36811,'ulna.tif',234,4,49,13.5978967,10.5891439,9.2246194,1.8,10.261462,9.2665464,0.1416448,2.6147359,4.8948795,20.675179,58.6864569,0.0451664,11.9893569,7.9071767,15.1187427,0.2351382,0.5037861,1.1071487,1.2122744),(36812,'ulna.tif',234,4,50,12.9274635,10.9283054,9.2986831,1.8,10.8784018,9.3226448,0.2428037,2.5733711,4.0624415,17.4112057,44.9974346,0.1245436,11.0764511,6.7659132,14.6636397,4.4717681,6.5857178,3.0158232,19.7087599),(36813,'ulna.tif',234,4,51,12.9210664,11.1271227,9.4062792,1.8,11.1156501,9.4233079,0.2694143,2.3540893,3.1723718,15.8214941,38.8225177,0.1525652,12.2376948,6.7208556,17.200034,4.2597351,6.2314902,2.9229237,17.9987665),(36814,'ulna.tif',234,4,52,13.0171806,11.2740186,9.4750501,1.8,11.287315,9.4988475,0.3050588,2.2605199,3.0952791,14.4074638,34.5605547,0.1957126,11.1655696,6.3735179,15.7473406,4.1596888,5.9854277,2.8357138,17.2477665),(36815,'ulna.tif',234,4,53,13.1395603,11.3694504,9.5616423,1.8,11.3626273,9.5647963,0.3354999,2.163894,3.0797149,13.3449306,31.6848898,0.2373876,10.2882543,6.1670908,14.5508925,4.0526603,5.8491283,2.868584,17.0095813),(36816,'ulna.tif',234,4,54,12.2386231,11.4160478,9.6210358,1.8,11.396516,9.6338766,0.3387027,2.1464918,3.0445437,12.4057042,28.8575871,0.2251891,9.4784605,5.7795255,13.5512974,4.0068977,5.7977979,2.8526172,16.6469665),(36817,'ulna.tif',234,4,55,11.4950452,11.4338281,9.6910058,1.8,11.4088596,9.704405,0.3221838,2.1163505,3.0110717,11.7604155,26.7503248,0.1920823,8.883988,5.5569319,12.7654479,3.9577439,5.6783746,2.7905618,16.3723367),(36818,'ulna.tif',234,4,56,10.615035,11.4627375,9.7755445,1.8,11.4118969,9.800449,0.2969223,2.1005882,2.9699074,11.282199,24.5990908,0.1514451,8.2827805,5.3709712,12.0795809,3.8894616,5.5822089,2.8411155,16.2039144),(36819,'ulna.tif',234,4,57,10.0351422,11.4790944,9.8592885,1.8,11.432875,9.8815716,0.2761924,2.070766,2.955097,11.0076284,22.893909,0.1243725,7.7472616,5.3157278,11.4220617,3.8558958,5.4946314,2.7636243,16.04304),(36820,'ulna.tif',234,4,58,9.7635916,11.4743357,9.9513714,1.8,11.4116452,9.9591563,0.2474062,2.0162444,2.9630773,10.7796353,21.8689775,0.0975889,7.380495,5.3463932,11.0056729,3.8277537,5.4673626,2.863293,16.1416995),(36821,'ulna.tif',234,4,59,9.5464317,11.4189009,10.0348398,1.8,11.3579757,10.044237,0.2156115,1.9751895,2.8725385,10.6173142,21.2165484,0.0728272,7.3859926,5.3753395,11.046699,3.7835797,5.346888,2.9579703,15.9732772),(36822,'ulna.tif',234,4,60,9.3112238,11.3448282,10.129566,1.8,11.2827717,10.13585,0.1966458,1.9540004,2.8307504,10.3753563,20.5554038,0.0592406,7.2614681,5.3098025,10.9216057,3.7660787,5.3199221,2.8109138,15.8048549),(36823,'ulna.tif',234,4,61,9.2123674,11.2846907,10.2179797,1.8,11.2379421,10.2209366,0.1668091,1.901026,2.7735027,10.1865341,19.9988977,0.042328,7.2107005,5.3584401,10.8762318,3.7146918,5.2510961,2.8515057,15.4937805),(36824,'ulna.tif',234,4,62,9.0272439,11.2097002,10.2951513,1.8,11.1544319,10.2984279,0.1567699,1.8863708,2.7223577,9.9757991,19.3883215,0.0366748,7.121886,5.2883552,10.7372345,3.730392,5.1911433,2.8931052,15.8670697),(36825,'ulna.tif',234,4,63,8.8697407,11.1397904,10.3672283,1.8,11.0943184,10.375615,0.1486864,1.8643072,2.6914724,9.7040342,18.7165579,0.0324414,6.9540218,5.2051691,10.5572165,3.6754432,5.1001693,2.9037567,15.5302251),(36826,'ulna.tif',234,4,64,8.8201927,11.0673251,10.4515786,1.8,11.0175902,10.4633571,0.1374593,1.817788,2.6945523,9.5934702,18.1670719,0.0276019,6.7421487,5.2775518,10.2960793,3.6629585,5.1001693,2.9037567,15.5666697),(36827,'ulna.tif',234,4,65,8.7364601,10.9875447,10.5332072,1.8,10.944077,10.5449091,0.1300841,1.7871178,2.631534,9.3876936,17.6273901,0.0245009,6.6985227,5.2529797,10.1885496,3.6336356,5.0137337,2.8530053,15.2738177),(36828,'ulna.tif',234,4,66,8.6802844,10.8933976,10.6176527,1.8,10.8390866,10.6265669,0.1206319,1.7787734,2.614449,9.2000004,17.3713107,0.0209507,6.6443486,5.1721036,10.0893453,3.6091143,5.0272145,2.9002372,15.5044549),(36829,'ulna.tif',234,4,67,8.5358828,10.8146525,10.6859394,1.8,10.7658558,10.6955764,0.114266,1.7779639,2.5908543,8.9590659,16.9625491,0.0184944,6.5470873,5.038947,9.9814905,3.5777586,4.9781728,2.9441971,15.2480474),(36830,'ulna.tif',234,4,68,8.375527,10.7371509,10.7632846,1.8,10.6903727,10.7749035,0.101819,1.7882333,2.5710091,8.6783299,16.4147479,0.0144217,6.3845546,4.8530188,9.7570464,3.564158,4.8901578,2.9562447,15.3178102),(36831,'ulna.tif',234,4,69,8.3923908,10.6476012,10.833294,1.8,10.5957038,10.8424116,0.0943878,1.7824536,2.5556019,8.5797435,16.2590583,0.0124244,6.3621249,4.8134457,9.6714573,3.5504733,4.9045533,2.9411941,15.14184),(36832,'ulna.tif',234,4,70,8.4146501,10.54939,10.8980769,1.8,10.4968247,10.9125583,0.0853701,1.7757499,2.5116703,8.5529194,15.9554384,0.0101963,6.352521,4.8165114,9.5963205,3.5615023,4.8449688,2.8100385,15.14184),(36833,'ulna.tif',234,4,71,8.3712704,10.4591899,10.95882,1.8,10.4072859,10.9721274,0.0889281,1.7877186,2.5015426,8.4382652,15.5190094,0.0110046,6.2037758,4.7201307,9.4785937,3.5306201,4.7905325,2.9841758,14.8489879),(36834,'ulna.tif',234,4,72,8.2896734,10.3863168,11.0149064,1.8,10.334264,11.0221522,0.0870704,1.7819756,2.4826562,8.297865,14.9826347,0.0104479,6.0349213,4.6565535,9.2314383,3.5053858,4.7574532,2.9349094,15.0356325),(36835,'ulna.tif',234,4,73,8.1755979,10.3064286,11.0654486,1.8,10.2498992,11.0750775,0.0674137,1.797507,2.4718576,8.1992364,14.4658831,0.0061831,5.8522315,4.561449,8.8527029,3.5141763,4.7366613,3.0940096,14.7610028),(36836,'ulna.tif',234,4,74,8.0536102,10.2121113,11.1162345,1.8,10.1544789,11.124565,0.0555847,1.8053034,2.4563766,8.0512236,14.0578228,0.0041429,5.7229917,4.459762,8.6615287,3.5278074,4.7336836,3.1098573,14.636573),(36837,'ulna.tif',234,4,75,7.9644175,10.1231317,11.1583045,1.8,10.0690248,11.1701915,0.0564983,1.7730875,2.3992005,7.9018176,13.7783208,0.0042326,5.7428802,4.45653,8.5936397,3.4779118,4.7002042,0.2256012,14.486373),(36838,'ulna.tif',234,4,76,7.9216697,10.0362697,11.1953443,1.8,9.9839649,11.2068801,0.0367768,1.8076192,2.3774243,7.7946643,13.4898829,0.0017849,5.6741587,4.3121163,8.5226721,3.5205503,4.6833748,0.276097,14.4606028),(36839,'ulna.tif',234,4,77,7.9150952,9.961088,11.2249711,1.8,9.9109807,11.2367358,0.0425499,1.8241872,2.3689401,7.6899867,13.0821074,0.0023869,5.5223463,4.2155687,8.3707607,3.5162241,4.6833748,0.276097,14.833892),(36840,'ulna.tif',234,4,78,7.7586021,9.8817801,11.263354,1.8,9.8376372,11.2743993,0.0387843,1.8064418,2.3641086,7.4925986,12.5409417,0.0019441,5.3047232,4.147711,8.2971394,3.4985091,4.5681547,0.1651487,14.1677507),(36841,'ulna.tif',234,4,79,7.7068417,9.8213778,11.2805638,1.8,9.7790599,11.2868154,0.0577049,1.8115709,2.3127593,7.3295609,11.9883603,0.0042724,5.1835747,4.0459697,8.0315217,3.4965551,4.5371838,0.2168736,14.24064),(36842,'ulna.tif',234,4,80,7.612523,9.7555822,11.2951611,1.8,9.7133099,11.2960095,0.0784008,1.770289,2.304152,7.1095681,11.478422,0.0077827,4.9816254,4.0160494,7.8505347,3.4673218,4.4940935,0.1678959,13.9037953),(36843,'ulna.tif',234,4,81,7.5980206,9.6921857,11.2991864,1.8,9.6568438,11.2974682,0.0873243,1.7805995,2.2582157,6.9772527,11.0364258,0.009632,4.8872327,3.9184851,7.6760812,3.4843157,4.4264427,0.2573237,13.5047358),(36844,'ulna.tif',234,4,82,7.5543031,9.6259918,11.3071015,1.8,9.5942393,11.3092131,0.1021157,1.7741504,2.1992805,6.8456048,10.492119,0.0130833,4.7707051,3.8585256,7.5918094,3.4428253,4.3095886,0.3934506,13.4789656),(36845,'ulna.tif',234,4,83,7.4811685,9.5676585,11.3187389,1.8,9.53548,11.3206978,0.1305679,1.7913117,2.1765063,6.7361205,10.1201641,0.0211359,4.6497288,3.7604403,7.4750324,3.4598904,4.3043505,0.1048769,13.6216176),(36846,'ulna.tif',234,4,84,7.3294335,9.5208564,11.3241029,1.8,9.487353,11.3291099,0.1470159,1.7916019,2.0941144,6.580248,9.6020469,0.026213,4.5852543,3.6728293,7.3217854,3.469445,4.1854357,0.1621988,13.2043358),(36847,'ulna.tif',234,4,85,7.271977,9.4760004,11.3253836,1.8,9.4474103,11.3311062,0.1696962,1.7851085,2.0706349,6.467746,9.1411386,0.0345679,4.4146549,3.6231668,7.1967337,3.450528,4.1113393,0.1651487,13.1785656),(36848,'ulna.tif',234,4,86,7.2188392,9.4352917,11.3232838,1.8,9.4072819,11.3335566,0.178687,1.7620072,2.0261084,6.3637942,8.6663834,0.038008,4.2773542,3.6116733,7.0466418,3.4212404,4.03728,0.1682068,12.9221581),(36849,'ulna.tif',234,4,87,7.0818896,9.3985522,11.3173191,1.8,9.3703448,11.3258473,0.211079,1.7378054,1.9729953,6.2656852,8.2993434,0.0518118,4.206469,3.6055159,6.9275875,3.3998465,3.9916198,0.2084652,12.7977284),(36850,'ulna.tif',234,4,88,7.0327361,9.3653492,11.3167908,1.8,9.34029,11.3210395,0.2137797,1.7432909,1.9452906,6.2168188,7.9435667,0.052757,4.0834859,3.5661397,6.8095406,3.4092362,3.9511452,0.1526493,13.0101432),(36851,'ulna.tif',234,4,89,6.9831392,9.3267175,11.3117777,1.8,9.3009799,11.3209436,0.1923624,1.7386181,1.9539386,6.0972694,7.6142132,0.0425379,3.8968539,3.5069631,6.5049953,3.3826207,3.9653939,0.4297623,12.6475284),(36852,'ulna.tif',234,4,90,6.9156624,9.2930933,11.3011686,1.8,9.260835,11.3099544,0.1878075,1.7323927,1.8780077,5.9930379,7.2663841,0.0401788,3.8691983,3.4593993,6.4328191,3.4062928,3.8769353,0.3769093,12.7537358),(36853,'ulna.tif',234,4,91,6.9534367,9.2648765,11.2998655,1.8,9.2384898,11.3132049,0.1844404,1.7409929,1.8929317,5.9460259,7.0097466,0.0389789,3.7031165,3.4153073,6.2955084,3.4242786,3.8972487,0.4377913,12.683973),(36854,'ulna.tif',234,4,92,6.7885027,9.2335736,11.2895552,1.8,9.2070981,11.2954724,0.1206826,1.7395619,1.8450186,5.7951891,6.7067626,0.0163985,3.6350651,3.3314073,6.1435987,3.4111405,3.8293637,0.4461055,12.4533358),(36855,'ulna.tif',234,4,93,6.7220403,9.2004453,11.274949,1.8,9.1691115,11.2768638,0.1027359,1.7395704,1.8396622,5.7090247,6.4323392,0.0117833,3.4964785,3.281859,6.0323592,3.3996123,3.7975658,0.4282642,12.3653507),(36856,'ulna.tif',234,4,94,6.6647504,9.1742302,11.2662402,1.8,9.148491,11.2676765,0.0474051,1.7295869,1.8767898,5.6431004,6.2195618,0.0024943,3.3139363,3.2626868,5.9491973,3.370152,3.7640013,0.4993467,12.0724986),(36857,'ulna.tif',234,4,95,6.5738063,9.1494659,11.2499128,1.8,9.1238816,11.2460605,-0.0343685,1.7314084,1.8719246,5.5020092,6.0561921,0.0012936,3.2352756,3.1777651,5.7855626,3.3795001,3.7497394,0.5713375,12.328906),(36858,'ulna.tif',234,4,96,6.3881626,9.1249147,11.2388125,1.8,9.0970298,11.2441708,-0.0810844,1.7289999,1.8545379,5.3352312,5.8262446,0.0069847,3.1416153,3.0857324,5.6802095,3.3795001,3.7286224,0.5991753,12.028506),(36859,'ulna.tif',234,4,97,6.3259231,9.1048239,11.2224666,1.8,9.0810234,11.2237812,-0.1918508,1.7574739,1.8807588,5.2305037,5.704227,0.0383323,3.0329392,2.9761487,5.5898189,3.3945286,3.6982462,0.5090709,12.1711581),(36860,'ulna.tif',234,4,98,6.3196884,9.0892061,11.2058673,1.8,9.0678497,11.2058654,-0.314354,1.704934,1.893397,5.1286984,5.6048218,0.1007,2.9601937,3.0081507,5.4997795,3.3517878,3.6867906,0.5823529,11.878306),(36861,'ulna.tif',234,4,99,6.3362339,9.0723674,11.1865489,1.8,9.0450941,11.1884243,-0.4696811,1.7025773,1.9375328,5.0270811,5.5372805,0.216328,2.8579029,2.9526302,5.4238301,3.3795001,3.6829641,0.6842948,11.7538763),(36862,'ulna.tif',234,4,100,6.2365892,9.0583254,11.1646899,1.8,9.0242955,11.1688884,-0.5667656,1.6797207,1.9476283,4.9249326,5.4070169,0.2996351,2.7762057,2.9319949,5.3039488,3.3795001,3.6668494,0.610726,11.8525358),(36863,'ulna.tif',234,4,101,6.2045579,9.043396,11.1464464,1.8,9.0113613,11.1520888,-0.6208134,1.6671539,1.9452327,4.7490775,5.4092905,0.3499074,2.7807936,2.8486138,5.2207838,3.3313815,3.6829641,0.6842948,11.8525358),(36864,'ulna.tif',234,4,102,6.1278872,9.0374307,11.1347488,1.8,9.0146823,11.1363156,-0.7011137,1.6310765,1.9383346,4.6184941,5.3819257,0.4249834,2.776572,2.8315619,5.1351363,3.2919344,3.6867906,0.5823529,11.5596837),(36865,'ulna.tif',234,4,103,5.8697536,9.033305,11.1122008,1.8,9.0081753,11.1126146,-0.7404195,1.5933734,1.890945,4.3359643,5.2676561,0.4452032,2.7857267,2.7212481,5.0159112,3.2393269,3.649891,0.6393859,11.5339135),(36866,'ulna.tif',234,4,104,5.6861769,9.0153009,11.0927724,1.8,8.9851203,11.0980553,-0.7684162,1.6046226,1.8301627,4.1313833,5.2131191,0.4577575,2.8484457,2.574676,4.9989011,3.2299739,3.6172951,0.7266423,11.5961283),(36867,'ulna.tif',234,4,105,5.5812348,9.0041006,11.0697436,1.8,8.9758337,11.0742578,-0.7881514,1.577229,1.8313118,3.9756614,5.1617388,0.467664,2.8186019,2.5206622,4.9104254,3.1833553,3.6126145,0.7559949,11.427706),(36868,'ulna.tif',234,4,106,5.451585,8.9963388,11.0465795,1.8,8.9717492,11.0497135,-0.8172342,1.5408706,1.8368846,3.8083156,5.0519618,0.4832054,2.7502881,2.471535,4.7509258,3.1331195,3.6126145,0.7559949,11.5339135),(36869,'ulna.tif',234,4,107,5.3569588,8.9851215,11.0271676,1.8,8.959672,11.0313035,-0.8171961,1.5109523,1.8433727,3.6797588,4.9563939,0.4747841,2.6887639,2.4353904,4.6602468,3.077552,3.6250826,0.6973908,11.277506),(36870,'ulna.tif',234,4,108,5.2619546,8.9762607,11.0072961,1.8,8.9538911,11.0114272,-0.8161673,1.4862574,1.7972622,3.5526035,4.8593961,0.4654634,2.703777,2.3903017,4.6458925,3.026912,3.5773151,0.6812982,11.127306),(36871,'ulna.tif',234,4,109,5.1454993,8.9608329,10.9919992,1.8,8.9332809,10.9934152,-0.8081393,1.4732843,1.7993689,3.4289898,4.7597492,0.4482873,2.6452326,2.3274462,4.434437,3.0219625,3.6172951,0.844154,11.0468688),(36872,'ulna.tif',234,4,110,5.1048833,8.9531558,10.9677472,1.8,8.9357813,10.9762777,-0.8186907,1.47913,1.7584914,3.3408591,4.6653303,0.4537117,2.6530298,2.2586649,4.4395822,3.0107654,3.5304989,0.6647745,10.9588837),(36873,'ulna.tif',234,4,111,5.0549309,8.938738,10.9295669,1.8,8.9184754,10.9282411,-0.8331715,1.4731508,1.7245432,3.2836821,4.5328971,0.4614316,2.6284624,2.2290197,4.4125134,3.0107654,3.5265029,1.1071487,11.1895209),(36874,'ulna.tif',234,4,112,4.8941874,8.9272986,10.9022982,1.8,8.908301,10.9121321,-0.8624834,1.4814549,1.6864858,3.1535759,4.2829556,0.4704785,2.5395741,2.1287019,4.2111115,2.9597018,3.4717001,0.892677,10.8708986),(36875,'ulna.tif',234,4,113,4.8157087,8.9143982,10.8794268,1.8,8.9032833,10.8794819,-0.8846428,1.4557984,1.7024553,3.0262709,4.1569474,0.4804426,2.4417367,2.0787706,4.1104867,2.9333287,3.5200998,0.9827937,10.7464688),(36876,'ulna.tif',234,4,114,4.7372957,8.9004115,10.8379973,1.8,8.8879577,10.8493269,-0.8843594,1.4348075,1.6581754,2.9208423,4.0484075,0.4724003,2.4414832,2.0357032,4.0799051,2.9144523,3.4135408,0.8788749,10.5340539),(36877,'ulna.tif',234,4,115,4.6192785,8.8889233,10.805765,1.8,8.8777723,10.8057998,-0.8934379,1.4799881,1.6644244,2.8079595,3.865097,0.4674717,2.3221823,1.8972852,3.9400086,2.9428866,3.4160183,0.9888912,10.6402614),(36878,'ulna.tif',234,4,116,4.5911857,8.8812262,10.7595709,1.8,8.8670758,10.769635,-0.8731496,1.4346578,1.6414802,2.708575,3.7766198,0.4494018,2.3007404,1.887959,3.8398083,2.8959763,3.4283788,1.0679531,10.5340539),(36879,'ulna.tif',234,4,117,4.5207436,8.8933206,10.7149741,1.8,8.8777092,10.7257307,-0.8672496,1.4337266,1.6440863,2.6453214,3.664164,0.4381251,2.2286931,1.8450668,3.8150523,0.0751,0.1062074,2.3561945,0.2124149),(36880,'ulna.tif',234,4,118,4.4299726,8.8877243,10.6713659,1.8,8.8705791,10.6827158,-0.8614567,1.409352,1.6501836,2.5697254,3.435092,0.4251043,2.0816424,1.8233383,3.6210397,2.8676009,3.3661225,0.8960554,10.6842539),(36881,'ulna.tif',234,4,119,4.3053728,8.8826029,10.6419621,1.8,8.8635144,10.6549759,-0.8406574,1.5146319,1.6337893,2.4645314,3.2298729,0.3983523,1.9769213,1.6271488,3.4349953,2.8539809,3.3349813,0.9453113,9.9665721),(36882,'ulna.tif',234,4,120,4.2781036,8.8681079,10.6106926,1.8,8.8394731,10.6192214,-0.7974844,1.6689005,1.55415,2.3855452,3.0967885,0.3651255,1.992593,1.4294113,3.2530255,2.7613934,3.2327912,1.0343609,9.9150316),(36883,'ulna.tif',234,4,121,4.1244524,8.9018451,10.5783545,1.8,8.8816796,10.5891851,-0.8262444,1.4082691,1.5337133,2.215966,2.8348535,0.3717512,1.8483595,1.5735388,3.2550566,2.7787,3.1871081,0.9697226,9.8345944),(36884,'ulna.tif',234,4,122,4.0681226,8.9003463,10.5373753,1.8,8.8780704,10.5470545,-0.81634,1.3425114,1.5348315,2.0880156,2.6552629,0.359976,1.7300029,1.5553057,3.0746455,2.7315038,3.1452469,0.9894161,9.8088242),(36885,'ulna.tif',234,4,123,4.00819,8.8948267,10.4900985,1.8,8.8585461,10.4852275,-0.7630928,1.600637,1.5269225,2.0631151,2.5317788,0.3191201,1.6580925,1.2889338,2.870153,2.7787,3.1443502,0.8699419,10.3656316),(36886,'ulna.tif',234,4,124,3.9467103,8.9266439,10.4637091,1.8,8.9075628,10.4764063,-0.7642415,1.3176068,1.4619998,1.8947231,2.4227235,0.3149802,1.6571298,1.4380035,2.9081879,2.6883763,3.0413183,0.9964915,9.7648316),(36887,'ulna.tif',234,4,125,3.7478456,8.9528739,10.419374,1.8,8.9342114,10.4257345,-0.7373695,1.3600932,1.4647483,1.7913245,2.2232345,0.2823659,1.517827,1.3170601,2.7349926,2.6793683,3.0040001,0.9272952,9.8088242),(36888,'ulna.tif',234,4,126,3.5332058,9.0012222,10.3942593,1.8,8.9759368,10.3987126,-0.7689253,1.3896561,1.4595261,1.7226212,2.0947174,0.2847352,1.4352038,1.2396025,2.6098139,2.6793683,2.9908287,0.8921338,9.7466093),(36889,'ulna.tif',234,4,127,3.4422217,9.068364,10.3531028,1.8,9.0366484,10.364089,-0.7499053,1.3516917,1.538272,1.6648624,2.1519155,0.2665065,1.3989175,1.231688,2.4775233,2.6554526,3.0873317,0.8542547,9.7648316),(36890,'ulna.tif',234,4,128,3.3082191,9.1306119,10.2791737,1.8,9.0989893,10.2745322,-0.7055028,1.3231283,1.521463,1.6833395,2.1574049,0.2318202,1.4179805,1.272242,2.5191862,2.6872389,3.0273778,0.7678561,9.9772465),(36891,'ulna.tif',234,4,129,3.1422911,9.1804399,10.2333953,1.8,9.1676155,10.233729,-0.7569647,1.3471846,1.5405604,1.7456394,2.2168937,0.2469746,1.4390177,1.2957685,2.571427,2.7315038,3.0873317,0.8542547,9.6843944),(36892,'ulna.tif',234,4,130,3.01,9.2340038,10.1800393,1.8,9.2071551,10.18293,-0.910942,1.5440974,1.6378062,1.8416473,2.3317132,0.3131548,1.4236808,1.1927015,2.4946405,2.7787,3.2992756,0.7209713,10.1532167),(36893,'ulna.tif',234,4,131,3.0021917,9.3469186,10.138352,1.8,9.3287485,10.1550528,-0.8744577,1.4488436,1.7053922,1.977635,2.5218518,0.2945097,1.4787518,1.3649748,2.5600022,2.8676009,3.3795001,0.6435011,10.3216391),(36894,'ulna.tif',234,4,132,3.0414542,9.4335339,10.1044489,1.8,9.4389576,10.1103873,-0.9262219,1.6089885,1.5974008,2.1418582,2.720143,0.3238993,1.7028556,1.331183,2.8864497,2.9591517,3.3078119,0.6889244,10.4900614),(36895,'ulna.tif',234,4,133,3.1585867,9.577879,10.027798,1.8,9.5991537,10.0577811,-0.6856023,1.5767223,1.7181194,2.372385,2.9710781,0.211028,1.7292617,1.5046309,3.1050114,3.0569869,3.5008202,0.6177557,10.8966688),(36896,'ulna.tif',234,4,134,3.2000295,9.6873976,9.9810202,1.8,9.725084,10.0088855,-0.6848436,1.7122113,1.8006219,2.5000032,3.2735748,0.2134003,1.8180246,1.4601021,3.1751657,3.1259449,3.6645415,0.7709064,11.4170316),(36897,'ulna.tif',234,4,135,3.6121326,9.8005555,9.8423889,1.8,9.8631989,9.9028731,-0.6528864,1.8266554,1.8906109,2.849527,4.1659393,0.2221666,2.2034885,1.5599697,3.598838,3.2544064,3.8153462,0.6316906,12.0102837),(36898,'ulna.tif',234,4,136,6.0593212,10.1128496,9.8394491,1.8,10.0091662,9.8560168,-0.4753035,1.7432392,2.1555856,4.6509002,6.8668967,0.2114758,3.1856293,2.6679643,5.2386081,3.4206742,4.2403246,0.4002407,12.7612837),(36899,'ulna.tif',234,4,137,6.3048372,9.9886103,9.9038628,1.8,9.953444,9.9242203,-0.1635101,1.6637752,2.2211235,4.7672912,7.2928432,0.0278444,3.2834028,2.8653457,5.3536133,3.3795001,4.453753,0.1013465,14.2299656),(36900,'ulna.tif',234,4,138,4.2027591,9.9753129,9.9763981,1.8,9.9824953,9.9988819,-0.1430439,1.4837337,2.1346964,2.6776963,4.5980659,0.014235,2.1539672,1.8047014,3.301626,3.0061246,4.2062706,3.1237374,12.7279655),(36901,'ulna.tif',234,4,139,3.733366,10.3246757,9.8286798,1.8,10.3659979,9.7617877,-0.9089876,1.6961704,5.0282215,2.0640501,5.0407384,0.3872339,1.0024893,1.2168884,1.3799541,2.4622637,3.6087094,0.2096398,10.5704986),(36902,'ulna.tif',234,4,140,3.0026254,10.4700081,9.8817358,1.8,10.4793078,9.8950518,-0.7586445,1.1636171,1.321097,0.8276125,1.1513059,0.2368366,0.8714772,0.7112413,1.4957989,2.2509008,2.674235,0.9048271,8.4023572),(36903,'ulna.tif',234,4,141,2.1920311,10.2042038,9.7422022,1.8,10.22464,9.7281375,1.4313911,1.4810136,1.0192983,0.4498623,0.4858097,0.3582845,0.4766119,0.303753,0.6268115,0.1062074,0.2124149,2.3561945,0.4248298),(36904,'ulna.tif',234,4,142,23.8908956,8.6608365,7.3400824,1.8,8.8021224,7.2804731,0.2314185,4.4312947,5.8376132,67.8993712,269.1768932,0.2094647,46.1107791,15.3226938,55.7267293,3.4226569,6.4590367,1.9772148,19.6207748),(36905,'ulna.tif',234,4,143,19.2290649,9.1923346,7.0271164,1.8,9.3277905,7.0693951,0.2471644,4.1391069,6.1624734,63.8983635,205.6972792,0.1918302,33.3790131,15.4377178,42.599325,0.5031253,1.1164418,2.3086114,2.6445116),(36906,'ulna.tif',234,4,144,18.0139384,8.9735119,6.95524,1.8,8.8847927,6.9036915,0.2469135,4.0688644,5.2301684,51.9558185,132.7952427,0.1793508,25.3902424,12.7691203,30.4894907,4.0868961,9.7276971,2.5428838,38.9380231),(36907,'ulna.tif',234,4,145,15.7325035,7.8612747,6.4565844,1.8,7.9050486,6.4553479,0.6005955,3.2595686,4.7971435,19.3430371,100.3910051,0.8374314,20.9272465,5.9342322,24.1568686,4.2451716,9.8254799,2.3399797,29.9575097),(36908,'ulna.tif',234,4,146,3.0805378,7.3458598,3.6745571,1.8,7.3567195,3.6654129,0.366186,1.2843101,6.0643547,1.0632652,28.4749379,0.0658233,4.6954605,0.8278882,4.8665241,2.5815198,3.5678429,2.2817057,16.9549144),(36909,'metacarpal.tif',234,5,1,0.7517586,8.2525652,4.055085,1.8,8.2510663,4.0577842,-0.4804283,0.2791232,1.2492684,0.0122383,0.2754326,0.0267615,0.2204751,0.0438457,0.2300185,4.8064001,5.3410834,1.088283,16.3509879),(36910,'metacarpal.tif',234,5,2,0.7747824,8.2875711,4.0715106,1.8,8.2861605,4.0717925,-0.4804621,0.284486,1.2924129,0.0127289,0.3030671,0.0275847,0.2344971,0.0447436,0.2440598,4.8064001,5.3410834,1.088283,16.3327656),(36911,'metacarpal.tif',234,5,3,0.7969711,8.3276878,4.0819944,1.8,8.3225455,4.0814103,-0.4817372,0.2949948,1.3281912,0.0133417,0.3277385,0.0285136,0.2467555,0.045227,0.2564325,4.8064001,5.4124129,1.0636978,16.4829656),(36912,'metacarpal.tif',234,5,4,0.8075572,8.3741021,4.0926877,1.8,8.3605346,4.095645,-0.4901684,0.3291757,1.2916287,0.0135989,0.3478446,0.0298296,0.269307,0.041312,0.2796168,4.8815001,5.4781835,1.0703555,16.6331656),(36913,'metacarpal.tif',234,5,5,0.8156114,8.4251437,4.1035017,1.8,8.4101222,4.1075029,-0.5022226,0.3650528,1.3172122,0.0138988,0.3669088,0.0314991,0.2785495,0.0380733,0.288708,4.8815001,5.5089831,1.0888581,16.7758177),(36914,'metacarpal.tif',234,5,6,0.8366828,8.4727995,4.1157673,1.8,8.4610329,4.1196211,-0.5045268,0.3976106,1.3470041,0.0148246,0.3958964,0.0325845,0.2939089,0.0372842,0.3044513,4.8815001,5.5441912,1.076855,16.7393731),(36915,'metacarpal.tif',234,5,7,0.8676391,8.5111958,4.1283182,1.8,8.5006526,4.1288312,-0.5032061,0.3915557,1.3356658,0.0162027,0.4240259,0.0336286,0.3174641,0.0413802,0.329456,4.8815001,5.514611,1.0584069,16.8638028),(36916,'metacarpal.tif',234,5,8,0.8936412,8.5422749,4.1452077,1.8,8.5321404,4.145455,-0.4997933,0.3870892,1.3907002,0.0170973,0.4504239,0.0342078,0.3238828,0.0441688,0.3356284,4.9566001,5.5089831,1.0888581,16.8015879),(36917,'metacarpal.tif',234,5,9,0.9414903,8.5610964,4.1551957,1.8,8.5410289,4.1472227,-0.4926361,0.6769987,1.4209824,0.0228814,0.4854243,0.0350991,0.3416118,0.0337983,0.3574672,4.9566001,5.5089831,1.0888581,16.8198102),(36918,'metacarpal.tif',234,5,10,1.0043427,8.5814118,4.1674455,1.8,8.5569332,4.1553473,-0.4859689,0.6822337,1.413687,0.0295071,0.5249707,0.0365162,0.3713486,0.0432507,0.3918586,4.9566001,5.5089831,1.0888581,16.8638028),(36919,'metacarpal.tif',234,5,11,1.0411218,8.6083966,4.1813596,1.8,8.585073,4.1666896,-0.4753686,0.8071393,1.4583748,0.0342693,0.5722424,0.0363453,0.3923836,0.0424577,0.4158511,4.9566001,5.5441912,1.076855,16.9700102),(36920,'metacarpal.tif',234,5,12,1.0755589,8.6383225,4.2030126,1.8,8.6227494,4.1926427,-0.4725054,0.7727521,1.5084988,0.0316198,0.6277521,0.0371306,0.4161436,0.0409184,0.4370835,4.9566001,5.5089831,1.0888581,16.9077954),(36921,'metacarpal.tif',234,5,13,1.1204592,8.6570993,4.219208,1.8,8.6442605,4.2056001,-0.4676775,0.7263219,1.5661292,0.0359082,0.6968683,0.0379525,0.4449622,0.0494384,0.4678575,5.0317001,5.5089831,1.0888581,17.0322251),(36922,'metacarpal.tif',234,5,14,1.1491936,8.6648635,4.244866,1.8,8.6502645,4.2307139,-0.4555266,0.982382,1.5705539,0.0416942,0.7707256,0.0370697,0.4907349,0.0424419,0.517206,5.0317001,5.514611,1.0584069,17.0762177),(36923,'metacarpal.tif',234,5,15,1.1775614,8.6621121,4.2677869,1.8,8.6378952,4.2483815,-0.4395875,0.9903348,1.6501287,0.0482628,0.8341746,0.035544,0.505521,0.0487338,0.5346149,5.0317001,5.5416474,1.1071487,17.0322251),(36924,'metacarpal.tif',234,5,16,1.2477429,8.6611847,4.2711188,1.8,8.6354454,4.2323914,-0.4151998,1.0821945,1.7195838,0.0724638,0.9114803,0.0338366,0.5300587,0.06696,0.5719353,5.0317001,5.5416474,1.1071487,17.0322251),(36925,'metacarpal.tif',234,5,17,1.3186875,8.6645035,4.2797169,1.8,8.6355273,4.2340058,-0.3988822,0.9427885,1.7187839,0.0882077,0.9781151,0.033153,0.5690739,0.0935605,0.6195547,5.1068001,5.5441912,1.076855,17.24464),(36926,'metacarpal.tif',234,5,18,1.3235703,8.710752,4.3020278,1.8,8.6856565,4.265485,-0.4126296,0.9094181,1.7552288,0.0806728,1.0286624,0.0354754,0.586056,0.0887081,0.6314456,5.1068001,5.5441912,1.076855,17.1824251),(36927,'metacarpal.tif',234,5,19,1.2952762,8.7770207,4.3234704,1.8,8.7573484,4.2983111,-0.4265046,0.6129815,1.7730072,0.068609,1.0520799,0.0369457,0.5933873,0.1119268,0.6316432,5.1068001,5.5756377,1.0951011,17.3508474),(36928,'metacarpal.tif',234,5,20,1.3231429,8.8284453,4.321626,1.8,8.8184957,4.2849915,-0.4313258,0.6631993,1.7940418,0.0781219,1.0930134,0.0385447,0.6092463,0.1177955,0.6525761,5.1068001,5.5761435,1.125219,17.3766177),(36929,'metacarpal.tif',234,5,21,1.3870724,8.8506821,4.3226848,1.8,8.8307243,4.288654,-0.4283436,0.6796033,1.7741083,0.0931343,1.1834326,0.0398848,0.6670577,0.1370422,0.71912,5.1730398,5.5801878,1.065005,17.4570549),(36930,'metacarpal.tif',234,5,22,1.4384074,8.8854762,4.3293017,1.8,8.8712788,4.303303,-0.4308263,0.6940378,1.8136421,0.1039017,1.2486309,0.0418116,0.688466,0.1497061,0.7455107,5.1819001,5.5761435,1.125219,17.39484),(36931,'metacarpal.tif',234,5,23,1.4835083,8.9014503,4.3486428,1.8,8.8949274,4.3140008,-0.4189717,0.6806369,1.8748446,0.1139025,1.3481961,0.040921,0.7190975,0.167347,0.7794308,5.1819001,5.832713,2.9340964,17.9258772),(36932,'metacarpal.tif',234,5,24,1.4904888,8.9067726,4.3910751,1.8,8.911752,4.3551111,-0.4081335,0.6911001,1.8860237,0.1139965,1.4471939,0.0391321,0.7673254,0.1649494,0.8260159,5.2402493,5.6559825,2.9546134,17.6876921),(36933,'metacarpal.tif',234,5,25,1.4824981,8.920906,4.4263822,1.8,8.9320838,4.3975421,-0.3911666,0.7169429,1.9534897,0.1092199,1.5259324,0.0359171,0.7811315,0.1523411,0.8340971,5.2570001,5.6345024,2.7734619,17.6512475),(36934,'metacarpal.tif',234,5,26,1.5081259,8.9517652,4.4420243,1.8,8.9532952,4.4171494,-0.3831432,0.7415645,1.9989894,0.1124088,1.6224993,0.0351279,0.8116598,0.1515833,0.8644749,5.2570001,5.6465014,2.8998398,17.7134623),(36935,'metacarpal.tif',234,5,27,1.5457631,9.0001515,4.4541318,1.8,8.9858784,4.4405239,-0.3854112,0.7300748,2.0286936,0.1165324,1.7310839,0.0364107,0.8532998,0.1596171,0.9073886,5.2737588,5.6783746,2.7905618,17.8196698),(36936,'metacarpal.tif',234,5,28,1.5738705,9.0540029,4.4550374,1.8,9.0137031,4.4443534,-0.3908,0.7285326,1.9801586,0.1237118,1.7929976,0.0380631,0.9054818,0.1698095,0.9637611,5.3067947,5.7238815,2.8073946,17.8196698),(36937,'metacarpal.tif',234,5,29,1.6216313,9.1082369,4.4598028,1.8,9.0627789,4.448648,-0.3950986,0.7220522,2.0020281,0.1332334,1.8613876,0.0400401,0.929751,0.1845205,0.992608,5.3070776,5.7317588,2.7659524,17.8636623),(36938,'metacarpal.tif',234,5,30,1.7017097,9.1249182,4.4738842,1.8,9.0852458,4.4579423,-0.3892621,0.727519,2.0603776,0.1499005,1.9544163,0.040848,0.9485719,0.2060435,1.0176459,5.3072683,5.756796,2.8776289,17.9880921),(36939,'metacarpal.tif',234,5,31,1.7764663,9.1073617,4.5024318,1.8,9.0847301,4.476523,-0.3734998,0.7212454,2.0841198,0.1682964,2.0288608,0.0394182,0.9734857,0.2333413,1.0479846,5.3405871,5.7977979,2.8526172,18.0320847),(36940,'metacarpal.tif',234,5,32,1.8441165,9.0927288,4.5316439,1.8,9.0842392,4.4987046,-0.3530134,0.7343924,2.1733107,0.1878347,2.0852053,0.036737,0.9594603,0.2557689,1.0380813,5.3580717,5.8196444,2.7994368,18.0760772),(36941,'metacarpal.tif',234,5,33,1.8983869,9.1089562,4.5492573,1.8,9.1203847,4.5111746,-0.3462033,0.7626123,2.232798,0.2101338,2.1684968,0.0364313,0.9712015,0.2755447,1.0571267,5.3683345,5.8491283,2.868584,18.1822847),(36942,'metacarpal.tif',234,5,34,1.9749572,9.0977363,4.5669482,1.8,9.107437,4.531122,-0.3263673,0.7692088,2.3142715,0.2366177,2.3121172,0.0338333,0.9990691,0.3076117,1.0914543,5.407606,5.8832595,2.896614,18.2444995),(36943,'metacarpal.tif',234,5,35,2.0058839,9.0850117,4.583232,1.8,9.1021461,4.5485438,-0.3040979,0.8052355,2.3237726,0.2594478,2.4256152,0.0299745,1.0438264,0.3222011,1.140724,5.4077966,5.8914024,2.8440309,18.350707),(36944,'metacarpal.tif',234,5,36,1.9960303,9.1023897,4.5971896,1.8,9.1261265,4.5637693,-0.296883,0.8842376,2.3802872,0.2685255,2.5415267,0.0284701,1.0677395,0.3036803,1.1651627,5.4049566,5.9419243,2.8598208,18.350707),(36945,'metacarpal.tif',234,5,37,1.9864929,9.1444456,4.6087389,1.8,9.1296942,4.5782356,-0.303374,0.9895477,2.4177418,0.274575,2.5968775,0.029548,1.0740921,0.2774753,1.1737117,5.4079873,5.9745815,2.8874679,18.6253367),(36946,'metacarpal.tif',234,5,38,1.9894746,9.2097034,4.6159526,1.8,9.1794841,4.5846299,-0.3173999,1.1099031,2.4343491,0.2729346,2.6284133,0.0322974,1.0797191,0.2459085,1.1801353,5.4079873,6.0084695,2.8237946,18.651107),(36947,'metacarpal.tif',234,5,39,1.9773562,9.2750696,4.6224811,1.8,9.250324,4.593637,-0.3250916,1.1491067,2.4482296,0.2700993,2.6818846,0.0336195,1.0954384,0.2350515,1.1950845,5.434432,6.057084,2.8394474,18.7755367),(36948,'metacarpal.tif',234,5,40,1.964436,9.3345185,4.6321105,1.8,9.3008929,4.605447,-0.3284501,1.1828789,2.3961526,0.2703531,2.7294122,0.0340684,1.1390811,0.2285552,1.2389058,5.4369417,6.057084,2.8002368,18.7573144),(36949,'metacarpal.tif',234,5,41,1.9386402,9.4104265,4.6484816,1.8,9.3717156,4.6221646,-0.3336456,1.2319349,2.4025266,0.2653789,2.764202,0.034653,1.1505396,0.2154163,1.2477258,5.4599722,6.1090054,2.7770667,18.7573144),(36950,'metacarpal.tif',234,5,42,1.9653994,9.4724332,4.6665772,1.8,9.4318997,4.6411556,-0.340281,1.2104344,2.3523932,0.2694917,2.8685026,0.0364878,1.2193976,0.2226405,1.3174852,5.4746249,6.1531608,2.7928217,19.0319442),(36951,'metacarpal.tif',234,5,43,2.0490659,9.4991472,4.677936,1.8,9.4596481,4.6507683,-0.3348556,1.2200897,2.3997655,0.2992822,3.1083503,0.036883,1.2952725,0.2452952,1.402444,5.4931198,6.1746635,2.8198421,19.1381516),(36952,'metacarpal.tif',234,5,44,2.1588809,9.4880203,4.6928265,1.8,9.435707,4.6705952,-0.3169123,1.26891,2.5725147,0.3543207,3.4099769,0.0349436,1.3255422,0.2792323,1.3612269,5.4980336,6.2060962,2.7700748,19.1381516),(36953,'metacarpal.tif',234,5,45,2.2909344,9.484512,4.7077135,1.8,9.4357125,4.6897839,-0.3157059,1.279771,2.5866492,0.4157049,3.8003835,0.0368086,1.4692303,0.3248276,1.504918,5.5250584,6.2842145,2.8879186,19.3945591),(36954,'metacarpal.tif',234,5,46,2.3881639,9.4986866,4.7209411,1.8,9.4408064,4.7068558,-0.3227149,1.3095162,2.6227114,0.4554524,4.1356184,0.0400333,1.5768484,0.3478021,1.6374838,5.5507983,6.2725363,2.8501359,19.3945591),(36955,'metacarpal.tif',234,5,47,2.4734311,9.5490468,4.7258082,1.8,9.4863563,4.717602,-0.3278477,1.3396514,2.6496116,0.4835374,4.3939214,0.0427442,1.6583266,0.3609427,1.7469291,5.5789313,6.3235807,2.8649243,19.6069739),(36956,'metacarpal.tif',234,5,48,2.5216909,9.6052535,4.7377405,1.8,9.5451623,4.7300564,-0.3388737,1.3899804,2.6648454,0.4815125,4.5086605,0.0464438,1.6919032,0.3464167,1.7924554,5.5896714,6.356939,2.8908834,19.4385516),(36957,'metacarpal.tif',234,5,49,2.6052792,9.6437166,4.7438753,1.8,9.6269334,4.7182754,-0.3312049,1.3227291,2.6381817,0.5257009,4.6426868,0.0459153,1.7598055,0.3974365,1.9393948,5.6314788,6.356939,2.8908834,19.5447591),(36958,'metacarpal.tif',234,5,50,2.7413309,9.6199787,4.771773,1.8,9.615318,4.7444968,-0.3177455,1.2439694,2.6641374,0.6042731,4.9656674,0.0445968,1.8638931,0.485762,2.0638379,5.6761257,6.3759857,2.8794728,19.8633814),(36959,'metacarpal.tif',234,5,51,2.8997017,9.6194068,4.7814272,1.8,9.6398492,4.7458461,-0.30496,1.2277161,2.7334842,0.6861313,5.4380958,0.0435695,1.9894374,0.558868,2.210453,5.6766349,6.4869188,2.786887,19.8011665),(36960,'metacarpal.tif',234,5,52,3.0144086,9.6739038,4.7898108,1.8,9.7029514,4.7555536,-0.3032438,1.3202603,2.7100189,0.7405242,5.9927748,0.0448004,2.2113406,0.5608926,2.4679762,5.7101444,6.5406022,2.7653506,19.9513665),(36961,'metacarpal.tif',234,5,53,3.1229119,9.7568421,4.7940961,1.8,9.7500725,4.7729974,-0.3130217,1.4409338,2.7551566,0.7970396,6.7320636,0.0493544,2.4434414,0.553141,2.7255293,5.7610946,6.6036777,2.8414215,20.2259963),(36962,'metacarpal.tif',234,5,54,3.2117235,9.8482936,4.7969575,1.8,9.8214922,4.7903749,-0.3316183,1.5113428,2.7438782,0.8174719,7.3613934,0.0567395,2.6828426,0.5408911,2.9758893,5.7714441,6.6754566,2.844748,20.2699888),(36963,'metacarpal.tif',234,5,55,3.2635938,9.9104197,4.8091599,1.8,9.8636861,4.8219678,-0.3458458,1.6444232,2.7876373,0.8326334,7.8931015,0.0625065,2.8314665,0.5063377,3.1224561,5.8112182,10.1829066,0.8741695,33.233013),(36964,'metacarpal.tif',234,5,56,3.336169,9.9701921,4.8158691,1.8,9.8972975,4.84388,-0.3505365,1.68117,2.7862708,0.8473666,8.3500494,0.0655695,2.9968549,0.5040338,3.275138,5.7773539,6.7581656,2.8831377,20.650826),(36965,'metacarpal.tif',234,5,57,3.4630886,10.0336201,4.8194222,1.8,9.926867,4.8589024,-0.3529587,1.7116681,2.7992927,0.8891402,8.8794275,0.0689684,3.1720254,0.5194583,3.4637156,5.8092047,6.7777491,2.8724252,20.7388112),(36966,'metacarpal.tif',234,5,58,3.7522627,10.0997378,4.8171965,1.8,9.9625063,4.8671772,-0.3559896,1.7393427,2.8079635,0.9904333,9.6321668,0.0759614,3.4303034,0.5694297,3.7078427,5.8106727,6.819229,2.8511907,20.9694484),(36967,'metacarpal.tif',234,5,59,4.1699801,10.1535937,4.8214136,1.8,9.9769621,4.8855327,-0.3633509,1.7791357,2.8462745,1.1593734,10.5321647,0.0877885,3.7003334,0.6516498,4.0071592,5.8277885,6.8307982,2.8859477,21.0392112),(36968,'metacarpal.tif',234,5,60,4.5846575,10.1962355,4.8368009,1.8,10.0084341,4.9042963,-0.3751973,1.8363477,2.9031877,1.3761166,11.4010601,0.1026123,3.9270834,0.749377,4.3123439,5.8560214,6.8703162,2.8647945,21.3138409),(36969,'metacarpal.tif',234,5,61,5.0045681,10.2073516,4.8564607,1.8,10.0360816,4.9141045,-0.3890309,2.3076745,2.9291195,1.6455972,12.1869997,0.1199948,4.1606358,0.7130976,4.4032222,5.9067763,6.891218,1.2835149,21.6324632),(36970,'metacarpal.tif',234,5,62,5.5626157,10.1889677,4.9710452,1.8,10.0364424,5.0427695,-0.5440149,4.2009982,3.3214437,4.2801028,13.6665051,0.2483563,4.1146279,1.01883,3.4391962,5.9505274,6.9128725,2.8438924,21.4640409),(36971,'metacarpal.tif',234,5,63,6.2346932,10.1676361,5.1296771,1.8,10.0314123,5.1711653,-0.8314176,3.1968626,4.3833336,7.3303669,16.964321,0.5673097,3.8701871,2.2929878,4.6562288,5.9505274,6.922656,2.878195,21.3138409),(36972,'metacarpal.tif',234,5,64,6.796998,10.1345388,5.2147743,1.8,9.9935906,5.2789573,-0.9743446,3.2421592,4.7440036,9.0256161,20.1869069,0.7754031,4.2552469,2.7838288,5.6544899,5.95554,6.9425879,2.8677506,21.4822632),(36973,'metacarpal.tif',234,5,65,7.1163755,10.0951206,5.221544,1.8,9.9610703,5.3250559,-0.9771146,3.2137161,4.8060137,10.1592897,21.5166298,0.814888,4.4770221,3.1612281,6.1131264,5.9579574,6.9425879,2.8677506,21.5080335),(36974,'metacarpal.tif',234,5,66,7.4736621,10.0376148,5.2371624,1.8,9.9143184,5.3402882,-0.9702961,3.1741497,4.7897513,11.2985545,22.6401298,0.8479026,4.7267861,3.5595531,6.5644556,5.9557904,6.9425879,2.8677506,21.6324632),(36975,'metacarpal.tif',234,5,67,7.8403845,9.9892325,5.2515907,1.8,9.8927278,5.339131,-0.9646999,3.1773067,4.7821465,12.5836753,23.7521216,0.882675,4.9668327,3.9604849,7.0394452,5.9716492,6.958006,2.9018495,21.7204484),(36976,'metacarpal.tif',234,5,68,8.2355087,9.9185892,5.2872246,1.8,9.8499203,5.3687358,-1.013409,3.10117,4.8431886,14.118263,25.4966131,0.9885217,5.264427,4.5525601,7.7252765,5.9596211,6.9762202,2.8913921,21.6142409),(36977,'metacarpal.tif',234,5,69,8.5042481,9.8775894,5.3598452,1.8,9.8341261,5.4361762,-1.0973933,3.0752832,4.8841448,15.1456736,27.6952914,1.1227579,5.6704485,4.9249687,8.4864963,5.9596211,6.9665119,2.9463113,21.7826632),(36978,'metacarpal.tif',234,5,70,8.6243363,9.8587588,5.4514873,1.8,9.8143255,5.5094581,-1.1444124,3.0700351,4.878567,15.5864345,29.4376778,1.1915247,6.0340829,5.0769565,9.0566661,5.9596211,6.958006,2.9018495,21.7386707),(36979,'metacarpal.tif',234,5,71,8.7062809,9.8522776,5.5281876,1.8,9.7963974,5.5453934,-1.1807624,3.0651474,4.836688,15.9318919,31.0060854,1.2412732,6.4106028,5.1977572,9.5884434,5.9572716,6.9847039,0.9380475,21.8448781),(36980,'metacarpal.tif',234,5,72,8.9199505,9.834784,5.5837777,1.8,9.765008,5.5540815,-1.2003376,3.0507489,4.8195773,16.5258951,33.2218472,1.2917944,6.8931039,5.4169961,10.2464519,5.9618111,7.0068744,1.2320982,21.8008856),(36981,'metacarpal.tif',234,5,73,9.3191168,9.770851,5.676432,1.8,9.6990518,5.6689963,-1.191954,3.0340498,4.7047622,17.2794748,37.3592422,1.340733,7.9407292,5.695185,11.5035839,5.980106,7.1028087,1.2256387,21.9510856),(36982,'metacarpal.tif',234,5,74,9.797298,9.6925646,5.7577174,1.8,9.6494111,5.7385251,-1.1829321,3.0021476,4.6222367,18.3491245,41.1797961,1.3993081,8.9090626,6.1119995,12.7469643,5.9833061,7.1864855,0.9712,22.0755153),(36983,'metacarpal.tif',234,5,75,10.1408118,9.6358387,5.8114965,1.8,9.6098781,5.7786791,-1.1716013,2.9839644,4.5427891,19.1611868,43.6433465,1.4348071,9.6071698,6.4213858,13.5080631,6.0036646,7.2068616,0.9856839,22.2439376),(36984,'metacarpal.tif',234,5,76,10.2372747,9.6046386,5.8837749,1.8,9.578837,5.8423893,-1.1543365,3.005248,4.4808183,19.4432604,45.1480579,1.4270064,10.075851,6.469769,14.0768151,6.0121108,7.2676472,0.2399662,22.2697079),(36985,'metacarpal.tif',234,5,77,10.355417,9.5987776,5.9657739,1.8,9.5775963,5.8971127,-1.1457462,3.044304,4.3970122,19.6613821,47.4535777,1.4324198,10.7922323,6.4584161,14.8040316,6.0121108,7.3233092,0.2275675,22.5261153),(36986,'metacarpal.tif',234,5,78,10.5922886,9.5889185,6.0473615,1.8,9.5654021,5.9574847,-1.1377161,3.0799039,4.3440187,19.780137,50.8418461,1.4544594,11.7038737,6.4223229,15.5528749,6.0128734,7.340617,0.2375346,22.4821228),(36987,'metacarpal.tif',234,5,79,11.0155488,9.5745153,6.1318067,1.8,9.5472477,6.0102241,-1.1283924,3.1154899,4.286871,19.9915524,54.4815733,1.4994349,12.7089371,6.4168247,16.1898216,6.0128734,7.3067323,0.2175541,22.3319228),(36988,'metacarpal.tif',234,5,80,11.385436,9.5403722,6.2145132,1.8,9.5092348,6.0836409,-1.1098223,3.1551102,4.1846071,20.0571646,56.6292636,1.5221087,13.5327553,6.3570409,16.1892583,6.0126828,7.4314857,0.2449787,22.5883302),(36989,'metacarpal.tif',234,5,81,11.7030297,9.5030097,6.261272,1.8,9.4885735,6.1265445,-1.0937675,3.2142994,4.2355958,19.9937597,57.9118183,1.5393167,13.6726499,6.2202543,16.2500105,5.9789827,7.8140099,0.2426477,23.4197674),(36990,'metacarpal.tif',234,5,82,12.0820327,9.4795038,6.275205,1.8,9.4871961,6.1300636,-1.0886205,3.2434052,4.2703433,20.0416157,59.7734402,1.5806821,13.9973385,6.1791895,16.5541857,5.9452825,7.3067323,0.2175541,22.3319228),(36991,'metacarpal.tif',234,5,83,12.4020187,9.4696777,6.2512522,1.8,9.4792277,6.1146781,-1.0822288,3.281362,4.3032739,19.9321394,60.8612367,1.6116419,14.143008,6.0743494,16.5625022,5.9115824,7.2501652,0.2299044,22.057293),(36992,'metacarpal.tif',234,5,84,12.4944319,9.4706569,6.1989161,1.8,9.4703996,6.0785026,-1.0639531,3.357047,4.2983059,19.2209081,60.5747969,1.5917233,14.0927144,5.7255403,16.4586003,5.8449448,7.2908913,0.2074962,22.057293),(36993,'metacarpal.tif',234,5,85,12.6473564,9.4745241,6.1512395,1.8,9.4674599,6.0386002,-1.0496867,3.4172309,4.3045925,18.7237311,60.7562313,1.585457,14.1142818,5.4792115,16.4932509,5.8324833,7.2501652,0.2299044,21.8448781),(36994,'metacarpal.tif',234,5,86,12.8850751,9.4709038,6.1292574,1.8,9.4562904,6.0378633,-1.0478933,3.4363778,4.3578708,18.6286932,62.0250468,1.6119277,14.2328789,5.421026,16.5497278,5.7718794,7.2009898,0.1359974,21.9328632),(36995,'metacarpal.tif',234,5,87,13.097314,9.4508027,6.1223196,1.8,9.4315899,6.0501658,-1.0551149,3.4368302,4.3594318,18.8147016,63.1198398,1.6520625,14.4789142,5.4744345,16.7666808,5.7295307,7.1821677,0.1152761,21.8008856),(36996,'metacarpal.tif',234,5,88,13.1628167,9.417633,6.1290566,1.8,9.4121174,6.0803171,-1.0643264,3.4362522,4.3806793,18.7962499,63.7318715,1.6775669,14.5483993,5.4699856,16.779284,5.6669059,7.1139167,0.1911845,21.6946781),(36997,'metacarpal.tif',234,5,89,13.1654656,9.3613934,6.1518556,1.8,9.3814652,6.1107384,-1.0837433,3.4192875,4.3465485,18.838558,64.4741942,1.7136035,14.8334235,5.5094981,16.5229319,5.5897917,7.1166911,3.0146199,21.7129004),(36998,'metacarpal.tif',234,5,90,13.1085051,9.2871052,6.1944593,1.8,9.3417085,6.1233425,-1.1161983,3.3723833,4.326843,18.767572,65.8733025,1.7635093,15.224334,5.5650768,16.5060854,5.4829674,7.1139167,0.1911845,21.9586335),(36999,'metacarpal.tif',234,5,91,12.7862427,9.1932564,6.2620294,1.8,9.2782444,6.1449634,-1.1588605,3.2353807,4.2954588,18.1623316,66.1689385,1.7894191,15.4043937,5.6136613,16.0840485,4.6694575,8.0001772,2.2631308,30.8587097),(37000,'metacarpal.tif',234,5,92,12.2064721,9.0786265,6.3497907,1.8,9.1485394,6.2262311,-1.2086288,3.2926894,4.2632494,17.1598611,64.8637752,1.7790325,15.2146331,5.2115032,15.2269186,4.2007756,8.010745,2.2499296,30.0712651),(37001,'metacarpal.tif',234,5,93,11.7096532,8.9967203,6.424267,1.8,9.0639503,6.3019153,-1.2514451,3.5501132,4.2148297,16.3967082,63.3275353,1.7592485,15.0249332,4.6186438,14.5070131,4.8079948,8.0227051,2.2367656,31.4412874),(37002,'metacarpal.tif',234,5,94,11.171583,8.9220699,6.4926303,1.8,8.9950389,6.3726679,-1.29347,3.77414,4.1491391,15.3780922,61.1466715,1.7223634,14.7371948,4.074595,13.6771989,4.9222316,8.0227051,2.2367656,33.1406064),(37003,'metacarpal.tif',234,5,95,10.4710457,8.8485547,6.5469002,1.8,8.9226157,6.425554,-1.3343662,4.0518459,4.0797764,14.0273099,57.6753173,1.6494247,14.136882,3.4619554,12.4701106,2.3937479,4.9708032,0.0756131,15.1782846),(37004,'metacarpal.tif',234,5,96,9.6215913,8.7785075,6.6038485,1.8,8.8432368,6.4900937,-1.3816167,4.2981116,3.9529473,12.1924002,52.973106,1.5468889,13.4009137,2.8366877,11.159466,4.7968475,8.1696928,2.0796805,33.2757106),(37005,'metacarpal.tif',234,5,97,8.8156574,8.7354834,6.6367277,1.8,8.8067719,6.5283842,-1.4162179,4.5439416,3.8525653,10.6797389,48.305621,1.4344473,12.5385599,2.3503249,9.9013243,4.8283288,8.2439143,2.0955921,31.9132362),(37006,'metacarpal.tif',234,5,98,8.0331335,8.6975181,6.6726528,1.8,8.7683321,6.5972272,-1.4579555,4.7344131,3.6995834,8.9520856,43.07591,1.3218801,11.6434488,1.8908543,8.659124,4.9251401,8.3742395,2.0866054,32.5762511),(37007,'metacarpal.tif',234,5,99,7.4029393,8.7659612,6.6207039,1.8,8.8289204,6.5814944,-1.4526044,4.6527088,3.7285165,8.7873353,38.295318,1.2166676,10.2709262,1.8886493,7.9491774,5.0400424,8.4690029,2.070143,32.5580288),(37008,'metacarpal.tif',234,5,100,6.9485527,8.9375899,6.4684557,1.8,8.9925833,6.4498545,-1.3828903,4.319708,3.907445,9.8099374,34.0902506,1.1176804,8.7244352,2.2709723,7.6192951,4.3195489,5.3410834,0.4825133,21.0498855),(37009,'metacarpal.tif',234,5,101,6.8873145,9.1160269,6.3355856,1.8,9.1765338,6.3012131,-1.2473093,3.637759,4.1789897,10.8701883,32.6568639,1.0318984,7.8145356,2.9881552,7.8561461,4.283777,5.2816182,0.5209098,20.0060335),(37010,'metacarpal.tif',234,5,102,6.9136763,9.2604724,6.2441395,1.8,9.3086752,6.1967314,-1.102536,3.0780734,4.547184,10.8276232,33.1920947,0.9175567,7.2994835,3.5176624,8.0999315,4.2298238,5.1117675,0.1772254,17.5481665),(37011,'metacarpal.tif',234,5,103,6.8903042,9.4177993,6.1549171,1.8,9.4424175,6.1040361,-0.9928182,3.2394616,4.6850467,9.9833769,34.9419312,0.8056164,7.4581821,3.0818012,8.5511456,4.3545051,5.1337869,1.4682165,19.0275227),(37012,'metacarpal.tif',234,5,104,6.7934808,9.5790793,6.0646993,1.8,9.5895342,6.0125504,-0.9205395,3.3013015,4.7205184,8.8075759,36.3555488,0.7172805,7.701601,2.6679102,8.7966844,4.3014013,5.2762762,1.485291,19.0715153),(37013,'metacarpal.tif',234,5,105,6.756683,9.7219997,5.995461,1.8,9.734164,5.952334,-0.8549833,3.3583014,4.6965988,7.4429487,38.2623873,0.641165,8.146829,2.2162837,9.1858058,4.2371336,5.3215121,1.4149281,16.9473665),(37014,'metacarpal.tif',234,5,106,6.8724149,9.8094662,5.9278151,1.8,9.8182529,5.9242047,-0.8115485,3.4040173,4.5771064,6.4391183,40.3027585,0.6026402,8.8052921,1.8916233,9.9917424,4.1715174,5.4118918,1.6124389,16.5847516),(37015,'metacarpal.tif',234,5,107,7.3122632,9.8540063,5.8373855,1.8,9.8671841,5.8495895,-0.7807513,3.4152341,4.6404592,6.1366736,42.7800304,0.6036921,9.2189219,1.796853,10.2369968,4.2161617,5.4843572,1.5981867,16.0279441),(37016,'metacarpal.tif',234,5,108,7.6702977,9.9190341,5.7088378,1.8,9.9392204,5.7320877,-0.7437827,3.4681255,4.7300476,5.9544498,42.5213049,0.5860524,8.9896146,1.7169072,9.8487397,4.2434923,5.5232975,1.3654009,16.1159293),(37017,'metacarpal.tif',234,5,109,8.2643908,9.9586123,5.656524,1.8,9.9592791,5.7185958,-0.7136096,3.4230608,4.7509919,5.9107789,41.7925127,0.5901571,8.7965868,1.7267525,9.5649619,4.1951939,5.5558776,1.3389317,18.3173888),(37018,'metacarpal.tif',234,5,110,9.0530814,9.9757656,5.6687066,1.8,9.9428543,5.7335734,-0.6922332,3.3249098,4.722911,6.3153973,43.0285263,0.6146638,9.1105944,1.8994191,9.8967328,4.2586999,5.5736143,1.3258177,18.5191293),(37019,'metacarpal.tif',234,5,111,9.8417027,9.9967115,5.6830564,1.8,9.9661771,5.7362712,-0.6688261,2.3228384,4.6451882,6.9414391,46.5988121,0.6306582,10.0316307,2.9883435,10.8796278,4.2894465,5.5801878,0.5057913,19.0759367),(37020,'metacarpal.tif',234,5,112,10.4301519,10.0225572,5.6711112,1.8,10.0035965,5.7227959,-0.6420504,2.9042534,4.6278759,7.5731422,49.6661272,0.6233892,10.7319488,2.6076038,11.5749329,4.2724017,5.6927584,0.5404195,20.3215293),(37021,'metacarpal.tif',234,5,113,10.7670908,10.0654923,5.6332975,1.8,10.0396064,5.6888129,-0.6158754,2.8792841,4.6375723,8.1685427,51.1170298,0.5988413,11.0223682,2.8370048,11.8568453,4.4726922,10.2895224,0.5880026,34.9838726),(37022,'metacarpal.tif',234,5,114,11.0487443,10.0967662,5.6178098,1.8,10.0455878,5.6748812,-0.5988653,2.8471696,4.5973348,8.7506287,52.0659754,0.5851489,11.325252,3.0734483,12.2435123,4.4588007,10.2293259,0.655248,37.0897991),(37023,'metacarpal.tif',234,5,115,11.2414247,10.1094077,5.6244375,1.8,10.0571866,5.660648,-0.5887153,2.8521042,4.5848393,9.1576965,52.1673498,0.5777162,11.3782287,3.2108562,12.3422562,4.4106377,10.2930846,0.6143123,37.5510735),(37024,'metacarpal.tif',234,5,116,11.4739747,10.103399,5.6494351,1.8,10.0736442,5.6707899,-0.5865505,2.8263576,4.5202754,9.400734,52.2892239,0.5858472,11.5677076,3.326095,12.6355139,4.2815834,10.3365542,0.6202495,36.3676958),(37025,'metacarpal.tif',234,5,117,11.6884399,10.0988071,5.6640151,1.8,10.076729,5.6749121,-0.584474,2.7930982,4.5045604,9.6211759,52.394613,0.5930713,11.6314598,3.4446249,12.7404514,4.4122044,10.3583567,0.515549,40.2062595),(37026,'metacarpal.tif',234,5,118,11.8372097,10.118146,5.667873,1.8,10.099682,5.662496,-0.5871931,2.7673276,4.4819145,9.7028028,52.9445332,0.6055628,11.812928,3.5061996,13.0146036,4.342802,10.3583567,0.515549,39.3748223),(37027,'metacarpal.tif',234,5,119,11.9875,10.126116,5.687488,1.8,10.1105494,5.6725476,-0.6006477,2.7298301,4.458178,9.9766673,53.9214936,0.6381845,12.0949621,3.6546843,13.4779142,4.3229182,10.3332799,0.567844,39.3126074),(37028,'metacarpal.tif',234,5,120,12.0177208,10.1047763,5.7270753,1.8,10.1104894,5.690798,-0.616496,2.6673545,4.4842829,10.3635566,53.9300332,0.6695711,12.0264564,3.8853316,14.0522434,4.4801786,10.2895224,0.5880026,41.3198744),(37029,'metacarpal.tif',234,5,121,11.9261444,10.0555735,5.8333884,1.8,10.0833421,5.8133362,-0.6541292,3.3298127,4.5666116,11.2726302,52.7763831,0.7359103,11.5570116,3.3853646,13.9065774,4.5387464,10.1884438,0.3147577,41.7447041),(37030,'metacarpal.tif',234,5,122,12.0712115,10.0290932,5.9701245,1.8,10.0802549,5.9436318,-0.7132262,3.2392544,4.6327802,13.0168239,53.1202481,0.8612375,11.4661707,4.018463,14.0772178,4.2870458,10.2604303,0.3356386,35.1994139),(37031,'metacarpal.tif',234,5,123,12.4342823,10.0384066,6.0829131,1.8,10.1102614,6.0231085,-0.7661846,3.1520058,4.6564354,14.4874357,55.2496204,0.9963821,11.8652179,4.5962592,14.6818845,4.5124981,10.3313694,0.3332443,35.7015544),(37032,'metacarpal.tif',234,5,124,12.9124496,10.0807583,6.1449001,1.8,10.159785,6.0770888,-0.7989509,3.2020416,4.6381063,15.3620645,59.1986687,1.1052004,12.7635428,4.7975843,15.7033729,4.6423561,10.3814717,0.3469169,34.1706577),(37033,'metacarpal.tif',234,5,125,13.2696979,10.1090993,6.1997228,1.8,10.1647791,6.1540978,-0.8291292,3.1714781,4.6266178,16.2538907,62.3204962,1.2024012,13.4699902,5.1250207,16.5245523,6.3609218,10.3757657,0.3858827,39.5583405),(37034,'metacarpal.tif',234,5,126,13.5866722,10.1342322,6.2506292,1.8,10.2052954,6.1812514,-0.8549285,3.0499483,4.6186825,17.3623668,64.4388707,1.2891634,13.9517861,5.6926757,17.1738454,6.3863045,10.3901605,0.3697685,40.7599405),(37035,'metacarpal.tif',234,5,127,13.7929051,10.1472,6.3038688,1.8,10.2233891,6.2144961,-0.87406,2.9536467,4.6280773,18.4844525,65.0092217,1.3521596,14.0467017,6.2581799,17.4557154,6.3863045,10.3901605,0.3697685,43.6897562),(37036,'metacarpal.tif',234,5,128,14.0036862,10.1628111,6.3457148,1.8,10.2374492,6.2707934,-0.884636,2.8860789,4.6375263,18.853369,66.1638812,1.397072,14.2670634,6.5325204,17.730699,6.2643812,10.336827,0.3562197,42.3423777),(37037,'metacarpal.tif',234,5,129,14.2927563,10.1735078,6.3730118,1.8,10.2548959,6.3091642,-0.8946783,2.8916421,4.6396549,18.7683956,68.8510267,1.4493144,14.8396869,6.4905667,18.2450164,6.1418515,10.3108774,0.3493933,40.0680289),(37038,'metacarpal.tif',234,5,130,14.7916512,10.1645035,6.413109,1.8,10.2578568,6.3405157,-0.9106206,2.8307512,4.6564993,19.0200349,73.7708125,1.5381283,15.8425478,6.7190769,19.1976532,5.9305495,9.7485472,0.6542865,34.592361),(37039,'metacarpal.tif',234,5,131,15.241236,10.1303437,6.4642825,1.8,10.2445216,6.3834823,-0.9170678,2.86884,4.7094449,19.3705748,78.3025728,1.6007187,16.6267095,6.7520582,19.9682,5.9574716,9.883571,0.6343828,34.7243387),(37040,'metacarpal.tif',234,5,132,15.6460706,10.0749413,6.5038452,1.8,10.1963807,6.4342349,-0.9048606,2.9197308,4.7905667,19.9191537,81.6213821,1.6124033,17.0379387,6.822257,20.4739684,5.9648848,10.0333714,0.6420041,35.2918205),(37041,'metacarpal.tif',234,5,133,15.9800922,10.0216642,6.5357492,1.8,10.1333261,6.4953952,-0.8799015,3.0024246,4.8796404,20.668341,84.203847,1.5818738,17.2561582,6.8838834,20.8856099,6.016302,10.1454515,0.606481,36.1597024),(37042,'metacarpal.tif',234,5,134,16.1462672,10.0150587,6.5405577,1.8,10.1414443,6.4977072,-0.8550932,3.0625457,4.9154756,21.1398283,86.8529964,1.5324678,17.6692967,6.902698,21.4721584,6.0842322,10.3116978,0.6041628,38.4673693),(37043,'metacarpal.tif',234,5,135,16.3728351,10.054057,6.5186635,1.8,10.1675913,6.4852431,-0.8341367,3.1516029,4.8942871,21.6045595,90.0566515,1.4971905,18.4003614,6.855102,22.3990212,6.1396017,10.5407875,0.5721936,38.1411991),(37044,'metacarpal.tif',234,5,136,16.4922491,10.1158521,6.469806,1.8,10.203579,6.4501232,-0.8158741,3.1802958,4.8328396,21.681469,92.8020793,1.4580716,19.2023919,6.8174379,23.333778,6.1949712,10.6446139,0.5743048,38.3900586),(37045,'metacarpal.tif',234,5,137,16.5048102,10.1667347,6.4265618,1.8,10.2226223,6.4432105,-0.8070544,3.1931861,4.7736887,21.7362086,93.5843025,1.4349541,19.6041906,6.8070597,23.8280423,6.2503408,10.7159044,0.5452272,39.1592809),(37046,'metacarpal.tif',234,5,138,16.4685512,10.2001438,6.3925989,1.8,10.2292038,6.4296532,-0.8062481,3.1944294,4.7779146,21.7450662,92.3579537,1.4295907,19.3301808,6.8071832,23.6653106,6.2503408,10.7885537,0.5010134,40.0164884),(37047,'metacarpal.tif',234,5,139,16.4100624,10.2251987,6.3732665,1.8,10.2455662,6.4271916,-0.813119,3.1733983,4.8135101,21.9081614,89.9154006,1.4432832,18.6797989,6.903691,23.0472795,6.2900521,10.8248257,0.5070985,38.0274437),(37048,'metacarpal.tif',234,5,140,16.3980247,10.2424051,6.3589338,1.8,10.273559,6.4215548,-0.8221764,3.148791,4.8410429,22.2290417,87.832363,1.4669264,18.143273,7.0595482,22.5829471,6.3149881,10.8334192,0.5225855,38.3642884),(37049,'metacarpal.tif',234,5,141,16.3167199,10.2317031,6.3677675,1.8,10.2185601,6.4750876,-0.8397578,3.1075016,4.8364679,22.5414177,85.2656573,1.5072641,17.6297369,7.2538717,22.1816151,6.3447171,10.8334192,0.5225855,39.8662884),(37050,'metacarpal.tif',234,5,142,16.3314089,10.2142123,6.3988823,1.8,10.1733484,6.5394479,-0.8595122,3.0508475,4.8100117,22.7652226,84.703479,1.561944,17.6098281,7.4619341,22.2743934,6.3712071,10.7961313,0.5165577,41.8037926),(37051,'metacarpal.tif',234,5,143,16.3524232,10.1814418,6.4608727,1.8,10.1237241,6.6211193,-0.87863,2.9880538,4.7477013,22.7751569,84.8802413,1.6153264,17.8781764,7.6220704,22.63851,5.6384176,9.4174923,0.8474652,32.7748651),(37052,'metacarpal.tif',234,5,144,16.4693236,10.145589,6.5298822,1.8,10.1018271,6.669729,-0.8863244,2.9529125,4.6735096,22.6248166,85.8452301,1.6475974,18.3684719,7.6618648,23.1842776,5.6527753,9.3272267,0.8709035,32.6064428),(37053,'metacarpal.tif',234,5,145,16.6072223,10.1043294,6.6044442,1.8,10.1033562,6.6991529,-0.8818121,2.9483456,4.5886923,22.3237351,86.3116345,1.6491459,18.8096364,7.5716141,23.6464744,5.6210367,9.1772693,0.9305685,33.5623098),(37054,'metacarpal.tif',234,5,146,16.6905439,10.0630837,6.6889807,1.8,10.1145106,6.7351132,-0.8696628,2.9535966,4.4944326,22.0032842,84.7965993,1.6241745,18.8670312,7.4496579,23.52471,5.6321852,9.105701,0.9553407,33.6169767),(37055,'metacarpal.tif',234,5,147,16.785838,10.0448421,6.7624986,1.8,10.1445493,6.7515525,-0.8509839,2.9597491,4.4215515,21.903836,83.6080841,1.5817794,18.9092189,7.4005718,22.7938995,5.6088089,9.8139928,1.1448021,37.950133),(37056,'metacarpal.tif',234,5,148,17.0181273,10.0771483,6.7909353,1.8,10.1887324,6.7584869,-0.8266632,2.9667834,4.4229015,22.0726562,84.4792501,1.5350868,19.1004141,7.4399284,23.0854197,5.5480136,9.8039305,1.1860226,37.8181553),(37057,'metacarpal.tif',234,5,149,17.2295172,10.132182,6.7699545,1.8,10.2100873,6.7599522,-0.7984053,2.9441907,4.4587761,21.9633683,84.2164736,1.47314,18.8878004,7.4599,23.0999842,5.5044216,9.7759896,1.193143,37.6755032),(37058,'metacarpal.tif',234,5,150,17.2760065,10.2131178,6.6920363,1.8,10.2768971,6.693455,-0.7672742,3.0062942,4.5505508,21.5531873,82.3946206,1.3874938,18.106516,7.169354,22.6415776,5.4930568,10.1698823,0.9110485,41.5247413),(37059,'metacarpal.tif',234,5,151,17.1889562,10.2845931,6.613283,1.8,10.3361714,6.6436291,-0.748327,3.0539373,4.5419769,20.8859607,79.8464823,1.326308,17.5796761,6.8390273,21.9912734,5.4552409,10.3488238,0.9243925,43.213386),(37060,'metacarpal.tif',234,5,152,17.2784289,10.306553,6.5973486,1.8,10.351544,6.6450364,-0.7634142,3.0180481,4.4098494,20.2290433,80.5595593,1.3765813,18.2680975,6.7026908,22.4044289,5.4243533,10.4245727,0.9388221,41.1332297),(37061,'metacarpal.tif',234,5,153,17.4302974,10.3020233,6.6168626,1.8,10.3384828,6.6599428,-0.7900405,2.8949336,4.5734786,19.5583058,83.1647581,1.4660108,18.1841361,6.7560464,22.2692073,5.396945,10.5461368,0.9472356,35.7895395),(37062,'metacarpal.tif',234,5,154,17.5711921,10.2859998,6.6429787,1.8,10.3236765,6.6686528,-0.8105116,2.8408476,4.606607,18.8801065,85.8232324,1.5377805,18.6304654,6.6459414,22.6230026,5.3319065,10.6071939,0.9513699,36.0899396),(37063,'metacarpal.tif',234,5,155,17.7597816,10.2610555,6.6593984,1.8,10.3047757,6.665339,-0.8137934,2.8400433,4.6305559,18.4780383,88.8820813,1.5639855,19.1946894,6.5062524,23.1060427,5.2741852,10.7243223,0.9244941,34.3799461),(37064,'metacarpal.tif',234,5,156,0.2032839,9.382771,6.8217475,1.8,9.395119,6.8232161,0.9679294,0.3294993,0.6587935,0.004595,0.0115478,0.0229881,0.0175286,0.0139453,0.0245016,0.6372446,1.1682818,2.3561945,2.9373637),(37065,'metacarpal.tif',234,5,157,1.2264177,9.848303,6.8345234,1.8,9.8301704,6.8266368,0.1442618,0.6807234,1.2640769,0.0865306,0.3809207,0.0042245,0.301343,0.1271157,0.36845,1.255611,2.5189306,2.9617392,6.1386828),(37066,'metacarpal.tif',234,5,158,2.0319966,9.9950092,6.8715082,1.8,10.0088776,6.8841167,0.329716,0.6792177,1.4433366,0.2117392,0.8811324,0.0355023,0.610483,0.3117399,0.7570973,1.4257303,2.854788,2.677945,7.0034382),(37067,'metacarpal.tif',234,5,159,2.5295076,10.0117593,6.8020079,1.8,10.034544,6.820042,0.2923279,0.8215579,1.5765605,0.3436388,1.2623109,0.0350122,0.8006739,0.4182771,1.0162579,1.6464926,3.182681,2.8049178,7.7028977),(37068,'metacarpal.tif',234,5,160,3.024981,10.1076143,6.7555232,1.8,10.1459598,6.775633,0.231882,0.9078833,1.7365052,0.4956885,1.8801187,0.0266261,1.0827026,0.5459825,1.3679793,1.8024,3.5352882,2.927532,8.4903423),(37069,'metacarpal.tif',234,5,161,3.3831619,10.1583589,6.7401913,1.8,10.1911972,6.7678888,0.1825712,1.0094459,1.8840035,0.6186831,2.4044853,0.0185868,1.2762638,0.6128938,1.5983377,1.914543,3.6250826,2.9116882,9.1351349),(37070,'metacarpal.tif',234,5,162,3.7213066,10.1208254,6.7293852,1.8,10.1384154,6.7664593,0.1877491,0.9532105,1.8319381,0.7095136,2.9205401,0.0216068,1.5942352,0.744341,1.9796284,1.8696802,3.6676183,2.9562447,9.1609051),(37071,'metacarpal.tif',234,5,163,4.866702,10.3550411,6.5491059,1.8,10.3953058,6.5467909,0.0236457,1.6254758,2.1777769,1.3682563,5.0541511,0.0004534,2.3207846,0.8417574,2.9138688,2.2858364,4.1739659,2.9971511,11.4867944),(37072,'metacarpal.tif',234,5,164,5.2812207,10.4274606,6.4546436,1.8,10.4453853,6.4337019,-0.0212561,1.3249489,2.2395419,1.7445821,6.2183591,0.0003976,2.7766209,1.3167165,3.5217461,2.5658773,4.2912275,3.0715321,11.7796465),(37073,'metacarpal.tif',234,5,165,5.2979535,10.481598,6.4274339,1.8,10.4651116,6.4249082,-0.0338963,1.2856905,2.365402,1.8278956,6.5831902,0.0010141,2.7831168,1.4217229,3.5359521,2.5515476,4.3719555,3.0555984,11.6294465),(37074,'metacarpal.tif',234,5,166,5.4109719,10.5109801,6.3370381,1.8,10.4935028,6.3381213,-0.0423219,1.4846557,2.3999966,2.0831763,7.1846512,0.0016143,2.993609,1.4031376,3.8577037,2.7982249,4.4410715,3.0738996,12.2666912),(37075,'metacarpal.tif',234,5,167,5.1068306,10.5172646,6.2846492,1.8,10.5015035,6.2989675,-0.0521916,1.3611948,2.4122623,2.0208204,7.2400978,0.0023164,3.0013725,1.4845931,3.8383355,2.765406,4.4410715,3.0738996,12.2924614),(37076,'metacarpal.tif',234,5,168,4.8701656,10.4899241,6.2593338,1.8,10.4848682,6.2899877,-0.064795,1.457838,2.3870339,2.0635291,7.1702433,0.003403,3.0038297,1.4154721,3.8676227,2.8102174,4.4410715,3.0738996,12.4608837),(37077,'metacarpal.tif',234,5,169,4.8628879,10.4876661,6.1747313,1.8,10.4897866,6.1977994,-0.071489,1.5640194,2.3964353,2.3529614,7.1494009,0.0041351,2.9833482,1.5044324,3.9530258,3.0720995,4.453753,0.1013465,12.4608837),(37078,'metacarpal.tif',234,5,170,5.0333577,10.5029678,6.1148259,1.8,10.4987064,6.1296359,-0.0883251,1.6463169,2.4197917,2.6331568,7.4337405,0.0065275,3.072058,1.5994228,4.1452061,3.1759504,4.4821553,0.1513754,12.8052763),(37079,'metacarpal.tif',234,5,171,4.8740761,10.5372275,6.0805175,1.8,10.5332902,6.0987069,-0.0642639,1.6520965,2.450522,2.5929583,7.1365934,0.0033503,2.9122748,1.5694956,3.941667,3.1727098,4.4821553,0.1513754,12.7612837),(37080,'metacarpal.tif',234,5,172,4.8219934,10.5647299,6.0748616,1.8,10.5561326,6.1038481,-0.0608801,1.6569926,2.4727311,2.6446798,6.8845038,0.002975,2.78417,1.5960721,3.8366076,3.1764762,4.4714468,0.1347713,12.6550763),(37081,'metacarpal.tif',234,5,173,4.7321817,10.6404367,6.0341327,1.8,10.6363854,6.0506926,-0.0443581,1.6754746,2.4676144,2.8085891,6.2411816,0.0015509,2.529237,1.6762946,3.6501673,3.2357754,4.3226559,0.1394401,12.6550763),(37082,'metacarpal.tif',234,5,174,4.7763685,10.6917609,6.0493894,1.8,10.6827022,6.0735279,-0.0177857,1.7025172,2.4349828,2.9364108,5.8449992,0.0002518,2.4004273,1.7247466,3.592282,3.2671416,4.1894763,2.8879186,12.5928614),(37083,'metacarpal.tif',234,5,175,4.882969,10.7257234,6.0716064,1.8,10.7137236,6.0759537,0.0264795,1.8796303,2.3904696,3.1597048,5.4472764,0.0005705,2.2787474,1.6810246,3.5842606,3.2828913,4.1577195,2.7912784,12.6110837),(37084,'metacarpal.tif',234,5,176,4.8406574,10.7419553,6.0950829,1.8,10.736276,6.099733,0.1162149,1.9460946,2.3338391,3.2274906,4.9942817,0.0108473,2.1399426,1.6584449,3.5190053,3.2917437,4.1577195,2.7912784,12.3546763),(37085,'metacarpal.tif',234,5,177,4.7854806,10.7281907,6.0923049,1.8,10.7358951,6.0993056,0.1760119,1.9778535,2.2483159,3.2908589,4.6977222,0.0244551,2.0894405,1.6638537,3.5439879,3.3265878,4.114082,2.7678658,12.2666912),(37086,'metacarpal.tif',234,5,178,4.8025234,10.7004711,6.0931817,1.8,10.7164108,6.1042239,0.232786,2.0015492,2.1914244,3.3578452,4.4693772,0.0425964,2.039485,1.6776231,3.525832,3.3265878,4.114082,2.7678658,12.2409209),(37087,'metacarpal.tif',234,5,179,4.9568945,10.6803944,6.1043576,1.8,10.7049793,6.1102247,0.291948,2.0338916,2.1002929,3.4002531,4.3151022,0.0684377,2.0545241,1.6717966,3.4131472,3.3600973,4.0727472,2.7439647,12.1969283),(37088,'metacarpal.tif',234,5,180,5.1131128,10.6674954,6.1275857,1.8,10.700905,6.1298867,0.3560488,2.0620716,2.0418662,3.3635762,4.2601528,0.1035436,2.0864015,1.6311636,3.6044732,3.3659314,4.0442588,2.7610863,12.1347135),(37089,'metacarpal.tif',234,5,181,5.2024336,10.6586205,6.1600753,1.8,10.699342,6.1589136,0.4197255,2.0551646,2.0077595,3.3051265,4.2709577,0.1439897,2.1272257,1.6082052,3.5914318,3.3713654,4.0442588,2.7610863,11.9222986),(37090,'metacarpal.tif',234,5,182,5.1294194,10.6504083,6.1976217,1.8,10.6946477,6.189307,0.4636239,2.0565763,1.9532812,3.2165094,4.2755013,0.1709644,2.1888816,1.5640117,3.6301061,3.3455344,4.003612,2.7367009,11.8160911),(37091,'metacarpal.tif',234,5,183,4.9383746,10.642415,6.2348869,1.8,10.6816067,6.2154631,0.5030389,2.0254739,1.9431275,3.1594858,4.3150727,0.1912887,2.2206842,1.5598748,3.6788075,3.3429827,3.9746281,2.7540688,11.7538763),(37092,'metacarpal.tif',234,5,184,4.6929202,10.6403889,6.280782,1.8,10.6740801,6.2595173,0.5399981,1.9592162,1.9278774,3.065293,4.3530441,0.2067498,2.2579465,1.5645506,3.6474154,3.2393269,3.9746281,2.7540688,11.6218986),(37093,'metacarpal.tif',234,5,185,4.4885828,10.6354522,6.3273809,1.8,10.6614841,6.3115236,0.5613295,1.9333568,1.908997,2.9093228,4.3486776,0.211978,2.2779908,1.5048039,3.562201,3.1862232,3.9746281,2.7540688,11.5156911),(37094,'metacarpal.tif',234,5,186,4.4136409,10.6259153,6.358891,1.8,10.6429987,6.3384814,0.5805502,1.8782385,1.8997046,2.8151628,4.3951169,0.2212961,2.3135791,1.4988314,3.5439841,3.0800158,3.9746281,2.7540688,11.3654911),(37095,'metacarpal.tif',234,5,187,4.4060838,10.6141388,6.3802403,1.8,10.6238623,6.3599582,0.593888,1.8350739,1.9313611,2.8053273,4.4692963,0.2299522,2.3140656,1.5287272,3.5564341,3.0800158,4.003612,2.7367009,11.3472688),(37096,'metacarpal.tif',234,5,188,4.4098302,10.6013969,6.3898557,1.8,10.6118096,6.3692808,0.6249573,1.7772566,1.9074245,2.8234386,4.5162337,0.2515796,2.3677129,1.58865,3.6383069,3.026912,3.9746281,2.7540688,11.3654911),(37097,'metacarpal.tif',234,5,189,4.4393792,10.5882189,6.3951628,1.8,10.60719,6.3750719,0.646173,1.735932,1.9163947,2.8686777,4.5926998,0.2682621,2.3965312,1.6525289,3.8223504,2.9738083,3.9346954,2.7291822,11.1530763),(37098,'metacarpal.tif',234,5,190,4.4624243,10.5673446,6.3983849,1.8,10.5822915,6.3758063,0.6533854,1.7338256,1.9173064,2.9223211,4.6485226,0.2748226,2.4245069,1.6854758,3.9168751,3.026912,3.9052001,2.7468015,11.1970688),(37099,'metacarpal.tif',234,5,191,4.4860301,10.5487539,6.3957434,1.8,10.5583314,6.3651468,0.6470465,1.7451351,1.918277,2.9428746,4.7705525,0.2717091,2.4868945,1.6863305,3.9532343,3.026912,3.9346954,2.7291822,11.4716986),(37100,'metacarpal.tif',234,5,192,4.4934797,10.5327125,6.4004946,1.8,10.53365,6.3709834,0.6538862,1.7107068,1.9118178,2.9665935,4.8223839,0.2770973,2.5224077,1.7341332,3.9881818,3.026912,3.9346954,2.7291822,11.4899209),(37101,'metacarpal.tif',234,5,193,4.4695536,10.5418197,6.4096196,1.8,10.5461568,6.3778015,0.6613125,1.6632604,1.885329,2.9701569,4.7646169,0.2809741,2.5272072,1.7857438,3.9980964,2.9738083,3.9052001,2.7468015,11.3214986),(37102,'metacarpal.tif',234,5,194,4.4624803,10.5599535,6.4258651,1.8,10.5623365,6.3923314,0.6622323,1.664486,1.8741071,2.9992485,4.6610489,0.2811928,2.4870772,1.8019067,3.961518,3.026912,3.8769353,2.7646834,11.5339135),(37103,'metacarpal.tif',234,5,195,4.4028949,10.5709814,6.4486183,1.8,10.5671415,6.4202585,0.6570973,1.6324328,1.8518968,2.963348,4.4930009,0.2737885,2.4261616,1.8152955,3.864242,3.0199823,3.8499282,2.782822,11.1530763),(37104,'metacarpal.tif',234,5,196,4.3668589,10.572217,6.4625543,1.8,10.5681582,6.4337055,0.6783941,1.6186026,1.8285493,2.9753141,4.3456835,0.2866194,2.3765745,1.8381993,3.8835053,3.0235705,3.8072071,2.7574233,11.0908614),(37105,'metacarpal.tif',234,5,197,4.3142323,10.5709641,6.4785515,1.8,10.5683489,6.4591648,0.7007846,1.6197856,1.7785659,2.9632619,4.1834455,0.2989689,2.3521453,1.8294162,3.8303036,2.9882491,3.7534978,2.7945311,11.0028763),(37106,'metacarpal.tif',234,5,198,4.2828235,10.5738204,6.4810795,1.8,10.5785862,6.4630346,0.72912,1.6093187,1.7669763,2.9454042,4.0677771,0.3168152,2.3021118,1.8302181,3.8492787,2.9824323,3.7096664,2.7686049,10.9406614),(37107,'metacarpal.tif',234,5,199,4.2678979,10.5714658,6.4779197,1.8,10.575762,6.45947,0.7553434,1.5894035,1.7592044,2.9041731,3.9638584,0.3342926,2.2532108,1.8272094,3.7764352,2.9295339,3.6829641,2.7875952,10.9406614),(37108,'metacarpal.tif',234,5,200,4.2566371,10.5713854,6.4774183,1.8,10.5759816,6.4634643,0.781099,1.5687974,1.7004606,2.8458262,3.8392461,0.3516698,2.2577683,1.8140176,3.7259186,2.9107599,3.639833,2.7610863,10.8526763),(37109,'metacarpal.tif',234,5,201,4.2343328,10.5742436,6.4723902,1.8,10.5795815,6.4533536,0.8010478,1.6032099,1.6522679,2.7904128,3.6673516,0.3639035,2.2195865,1.7405162,3.6347519,2.8833296,3.5993199,2.7339611,10.7904614),(37110,'metacarpal.tif',234,5,202,4.1722349,10.5705965,6.4768724,1.8,10.5739417,6.4649867,0.7996611,1.5036686,1.6496275,2.6870371,3.5096947,0.3576029,2.127568,1.7869876,3.5469511,2.8379415,3.54246,2.7728968,10.5780465),(37111,'metacarpal.tif',234,5,203,4.1397064,10.5600082,6.4834789,1.8,10.5609183,6.4734653,0.8098649,1.4133115,1.6050726,2.5922511,3.3589696,0.3618496,2.0927212,1.8341682,3.47223,2.7873168,3.4725123,2.7651023,10.2776465),(37112,'metacarpal.tif',234,5,204,4.0797175,10.5440354,6.493656,1.8,10.5416478,6.4875944,0.8252819,1.406846,1.6135968,2.4857191,3.2373527,0.3670667,2.006296,1.7668736,3.3622512,2.7399863,3.4201434,2.8059541,10.2154316),(37113,'metacarpal.tif',234,5,205,4.0153417,10.5363045,6.5006147,1.8,10.5443337,6.4984741,0.8343772,1.3803351,1.6111326,2.3892422,3.0811099,0.3673374,1.9123876,1.7309146,3.2466827,2.7023375,3.3627698,2.6279866,10.0470093),(37114,'metacarpal.tif',234,5,206,3.9603374,10.5199307,6.5040309,1.8,10.5254703,6.5043132,0.83807,1.3712127,1.5755304,2.2910288,2.9581295,0.3647302,1.8775452,1.6708048,3.1402414,2.6683171,3.3358268,2.5973122,10.0030167),(37115,'metacarpal.tif',234,5,207,3.935528,10.5071603,6.5092994,1.8,10.5139153,6.5112125,0.8227554,1.3443496,1.5713889,2.198371,2.8642265,0.3524413,1.8227356,1.6352673,3.1041037,2.6543014,3.2975657,2.6167969,9.8345944),(37116,'metacarpal.tif',234,5,208,3.9104595,10.4925196,6.5173837,1.8,10.4967556,6.5184387,0.8245255,1.3250394,1.5289476,2.1255293,2.7646212,0.3513466,1.8081857,1.6041254,3.0722513,2.6206013,3.2327912,2.6051572,9.6404018),(37117,'metacarpal.tif',234,5,209,3.8940682,10.481636,6.5309109,1.8,10.4878066,6.5335261,0.8255953,1.3249408,1.522504,2.0584717,2.6926414,0.350566,1.7685611,1.5536329,2.9944375,2.613712,3.2082735,2.5730681,9.578187),(37118,'metacarpal.tif',234,5,210,3.8775554,10.4710041,6.5445796,1.8,10.4813633,6.5500186,0.8234448,1.3084591,1.5191921,1.9932806,2.6258219,0.3476939,1.7284331,1.5233801,2.9197165,2.5865199,3.1950616,2.625362,9.4902018),(37119,'metacarpal.tif',234,5,211,3.8521689,10.4570553,6.5515919,1.8,10.4660394,6.553098,0.7979772,1.3236413,1.5150693,1.923806,2.5496019,0.3290893,1.6828286,1.4534194,2.845806,2.583208,3.1684725,2.5930433,9.3217795),(37120,'metacarpal.tif',234,5,212,3.8481325,10.4440743,6.5592764,1.8,10.4504814,6.561406,0.7878946,1.2888575,1.5180908,1.8734144,2.492949,0.3222788,1.6421607,1.4535466,2.7934559,2.5530104,3.1586671,2.646041,9.3217795),(37121,'metacarpal.tif',234,5,213,3.8208841,10.43324,6.566183,1.8,10.4387196,6.5703475,0.7860368,1.3013124,1.4680558,1.8169429,2.4169739,0.3188137,1.6463774,1.3962388,2.7728442,2.5196916,3.104638,2.5804292,9.1533572),(37122,'metacarpal.tif',234,5,214,3.7801283,10.4237905,6.5684956,1.8,10.428028,6.5684179,0.7756254,1.3150407,1.4753346,1.7673906,2.3491902,0.308854,1.5923101,1.3439817,2.7100915,2.5241721,3.104638,2.5804292,9.0911423),(37123,'metacarpal.tif',234,5,215,3.7240934,10.4157015,6.5744111,1.8,10.4229333,6.5775162,0.773087,1.2738243,1.4762732,1.7104826,2.2610064,0.3027006,1.5315637,1.3427932,2.6237471,2.4958748,3.0653315,2.6011732,8.9591646),(37124,'metacarpal.tif',234,5,216,3.660662,10.4015038,6.5749885,1.8,10.4035311,6.573431,0.7728786,1.2842714,1.4349568,1.6681417,2.1786829,0.2974177,1.5182916,1.2989012,2.5578428,2.4861822,3.0570405,2.6559706,8.9151721),(37125,'metacarpal.tif',234,5,217,3.6209566,10.392476,6.5828019,1.8,10.3952108,6.5854801,0.7491318,1.3054828,1.439191,1.6305721,2.1219385,0.2798791,1.4743967,1.2490184,2.5067745,2.4793275,3.0273778,2.6224465,8.9591646),(37126,'metacarpal.tif',234,5,218,3.5659678,10.3838785,6.5897367,1.8,10.385064,6.5942054,0.7395757,1.3156114,1.4376082,1.5874048,2.0403727,0.2699685,1.4192828,1.2065909,2.4343698,2.4590513,3.0011825,2.5882983,8.8969498),(37127,'metacarpal.tif',234,5,219,3.5231283,10.374437,6.591079,1.8,10.3728472,6.5912898,0.7288932,1.2821425,1.4046145,1.5460108,1.9792118,0.2604855,1.4090782,1.2058026,2.3787517,2.437877,2.9908287,2.6442499,8.8089646),(37128,'metacarpal.tif',234,5,220,3.4593256,10.3616467,6.59289,1.8,10.3603187,6.5930838,0.7055857,1.2935881,1.4066833,1.5038423,1.9024433,0.2424561,1.3524318,1.1625357,2.3157323,2.4472921,2.9624071,2.6098686,8.7467498),(37129,'metacarpal.tif',234,5,221,3.425879,10.3481001,6.5971515,1.8,10.3491197,6.6008108,0.6920758,1.2715554,1.4041073,1.4615827,1.838794,0.2325136,1.3095823,1.1494447,2.2646403,2.437877,2.9163565,2.5393053,8.6405423),(37130,'metacarpal.tif',234,5,222,3.3868708,10.3325807,6.5982615,1.8,10.3315275,6.5977381,0.6911888,1.2727097,1.3774554,1.4304656,1.7786948,0.2293742,1.2912903,1.1239528,2.224553,2.4343066,2.8901306,2.7128146,8.4281274),(37131,'metacarpal.tif',234,5,223,3.3637246,10.3204979,6.6020802,1.8,10.3214544,6.5988004,0.6828932,1.2859917,1.3747583,1.40573,1.7466109,0.2232456,1.2704858,1.0931097,2.201507,2.4086127,2.8597229,2.6191892,8.4281274),(37132,'metacarpal.tif',234,5,224,3.3411388,10.3112941,6.612429,1.8,10.3160932,6.6147507,0.6706242,1.2568851,1.3759828,1.385732,1.7126808,0.2150754,1.2446964,1.1025129,2.173216,2.3896674,2.8597229,2.6191892,8.3841349),(37133,'metacarpal.tif',234,5,225,3.3174632,10.3003323,6.6215057,1.8,10.3043201,6.6241098,0.669115,1.2713383,1.3790121,1.3709173,1.6770616,0.2127391,1.2161326,1.0783262,2.1500654,2.4166912,2.8597229,2.6191892,8.4903423),(37134,'metacarpal.tif',234,5,226,3.3001252,10.2896746,6.63138,1.8,10.2926638,6.6325818,0.6678247,1.2736835,1.3688747,1.3555283,1.6433479,0.2109369,1.2005101,1.0642583,2.1266666,2.3955283,2.833968,2.5829933,8.4281274),(37135,'metacarpal.tif',234,5,227,3.2899727,10.2777964,6.6430304,1.8,10.2767762,6.6461409,0.6698133,1.243085,1.3399322,1.3446125,1.6166941,0.2113488,1.2065491,1.0816738,2.1120523,2.3896674,2.823001,2.6422459,8.2779274),(37136,'metacarpal.tif',234,5,228,3.2854149,10.2723489,6.6544139,1.8,10.2779268,6.6567051,0.6556087,1.2595648,1.3359448,1.3335238,1.5895223,0.2035113,1.1898113,1.0587179,2.0874853,2.3896674,2.8220018,2.7017501,8.2339349),(37137,'metacarpal.tif',234,5,229,3.288556,10.2646661,6.6674576,1.8,10.2728677,6.6689009,0.6289109,1.2652363,1.3291221,1.3301336,1.5680339,0.1896702,1.1797515,1.0512926,2.0746468,2.3955283,2.7908519,2.7261006,8.2779274),(37138,'metacarpal.tif',234,5,230,3.2700901,10.254621,6.6805816,1.8,10.2617062,6.6816944,0.5952616,1.2639512,1.3418774,1.3172072,1.5450882,0.1713598,1.1514377,1.0421345,2.0568916,2.3896674,2.7878189,2.6658974,8.2339349),(37139,'metacarpal.tif',234,5,231,3.240378,10.2455775,6.6938368,1.8,10.2519469,6.6984527,0.546054,1.266577,1.3575355,1.3014862,1.5174847,0.1456508,1.1178232,1.0275618,2.0319155,2.3896674,2.7878189,2.6658974,8.17172),(37140,'metacarpal.tif',234,5,232,3.2085708,10.2386136,6.7011267,1.8,10.2483607,6.7034261,0.509393,1.2793006,1.3356402,1.2983503,1.4880032,0.1271663,1.1140749,1.0148906,2.0492923,2.3896674,2.7305848,2.5917395,8.17172),(37141,'metacarpal.tif',234,5,233,3.1799567,10.2290573,6.7091257,1.8,10.2362167,6.7117109,0.4772995,1.2596962,1.3318302,1.2949623,1.4691607,0.1118454,1.1031142,1.0279957,2.0052179,2.4166912,2.7223103,2.7149652,8.2339349),(37142,'metacarpal.tif',234,5,234,3.1528569,10.2193411,6.7167447,1.8,10.2215686,6.7161014,0.430001,1.2762094,1.3359216,1.2913085,1.4517131,0.0913183,1.0866753,1.0118312,2.0024602,2.4166912,2.7223103,2.7149652,8.1277274),(37143,'metacarpal.tif',234,5,235,3.1173357,10.2115742,6.7273688,1.8,10.2111633,6.7267669,0.351724,1.2801539,1.3597364,1.2798637,1.4399982,0.061667,1.0590275,0.9997733,1.9762522,2.3896674,2.7077691,2.8023,8.0837349),(37144,'metacarpal.tif',234,5,236,3.0974647,10.204284,6.7379447,1.8,10.2031573,6.7374477,0.2809264,1.2825971,1.3673042,1.2756971,1.4307106,0.0396812,1.0463733,0.9946203,1.9736952,2.3896674,2.7077691,2.8023,8.0837349),(37145,'metacarpal.tif',234,5,237,3.084199,10.2022616,6.750248,1.8,10.2066919,6.7529832,0.2453172,1.2693227,1.3529202,1.2750169,1.4115355,0.0303192,1.043325,1.004486,1.9785483,2.428132,2.6837088,2.8286914,8.1277274),(37146,'metacarpal.tif',234,5,238,3.0998725,10.1980291,6.7640445,1.8,10.2014129,6.7716266,0.1533231,1.2636844,1.3557326,1.293065,1.4105066,0.0120504,1.0404018,1.0232499,1.9938763,2.4427711,2.6636691,2.7663218,8.0837349),(37147,'metacarpal.tif',234,5,239,3.0929934,10.1951228,6.7734094,1.8,10.1989331,6.7790709,0.0911644,1.2536637,1.3496086,1.2998463,1.4063225,0.0042724,1.0420225,1.0368381,1.9976161,2.4427711,2.6636691,2.7663218,8.0837349),(37148,'metacarpal.tif',234,5,240,3.0889939,10.194009,6.7815363,1.8,10.1976966,6.7859478,0.0109613,1.2292164,1.3348453,1.2997903,1.4075347,0.0000619,1.0544553,1.0574137,1.9979289,2.4427711,2.6636691,2.7663218,8.0837349),(37149,'metacarpal.tif',234,5,241,3.0959108,10.1905801,6.793768,1.8,10.1892256,6.7999538,-0.1699124,1.2174174,1.3291641,1.3053448,1.4139806,0.0147538,1.0638119,1.0722245,2.0083779,2.4189726,2.6636691,2.7663218,8.1277274),(37150,'metacarpal.tif',234,5,242,3.0898872,10.1915524,6.8060589,1.8,10.1926652,6.8115037,-0.2619993,1.2375629,1.3305399,1.3065954,1.4152357,0.0345487,1.0636552,1.055781,2.0247145,2.4427711,2.6231303,2.910502,8.0837349),(37151,'metacarpal.tif',234,5,243,3.1099355,10.1888772,6.818009,1.8,10.1873644,6.8228406,-0.3633447,1.2369261,1.2995369,1.313758,1.4381469,0.0654698,1.1066611,1.0621151,2.0483616,2.4521007,2.6231303,2.910502,8.1899423),(37152,'metacarpal.tif',234,5,244,3.1082831,10.1882152,6.8320849,1.8,10.1894491,6.8377393,-0.4063859,1.2247569,1.3082417,1.3210777,1.4543107,0.0809479,1.1116529,1.0786448,2.0623324,2.4519101,2.6370689,2.7928217,8.1899423),(37153,'metacarpal.tif',234,5,245,3.12729,10.1855043,6.8465998,1.8,10.1849594,6.8533397,-0.4412012,1.2438082,1.2878166,1.3293362,1.4729229,0.0950442,1.1437365,1.0687631,2.0836274,2.4522914,2.6370689,2.7928217,8.2339349),(37154,'metacarpal.tif',234,5,246,3.1394851,10.1845522,6.8605819,1.8,10.1827983,6.8675142,-0.4688677,1.232859,1.3037785,1.3317987,1.4959387,0.1068431,1.1473871,1.0802522,2.0933548,2.4522914,2.6231303,2.910502,8.17172),(37155,'metacarpal.tif',234,5,247,3.1336179,10.1860939,6.8720635,1.8,10.1864107,6.8748844,-0.5251564,1.2295231,1.2774114,1.3269175,1.5055554,0.1312726,1.1785987,1.0792131,2.098055,2.4427711,2.6231303,2.910502,8.1277274),(37156,'metacarpal.tif',234,5,248,3.1263666,10.1849589,6.8854873,1.8,10.1851482,6.8869238,-0.5169621,1.2457181,1.2822758,1.322802,1.5251325,0.127282,1.189395,1.0618791,2.1152429,2.4427711,2.6231303,2.910502,8.2339349),(37157,'metacarpal.tif',234,5,249,3.1332191,10.1806825,6.8993967,1.8,10.178517,6.8985655,-0.5304921,1.2359841,1.2945627,1.3312242,1.5514588,0.1336806,1.1984424,1.0770561,2.125826,2.4427711,2.6370689,0.348771,8.2339349),(37158,'metacarpal.tif',234,5,250,3.1422881,10.1786845,6.917495,1.8,10.1790977,6.9207372,-0.5342996,1.2478429,1.3058047,1.342365,1.5798669,0.1358116,1.2098799,1.0757484,2.1381027,2.4590513,2.674235,0.6659692,8.32192),(37159,'metacarpal.tif',234,5,251,3.1548182,10.1741536,6.9329378,1.8,10.1703314,6.9375784,-0.5322653,1.2370102,1.3208305,1.3489067,1.6154779,0.1354167,1.2230773,1.0904573,2.127745,2.4590513,2.6889576,0.6267429,8.32192),(37160,'metacarpal.tif',234,5,252,3.1547569,10.1761899,6.9447154,1.8,10.1752397,6.946588,-0.5654284,1.2399473,1.3090356,1.3477776,1.6443968,0.1509328,1.2561895,1.0869636,2.1461362,2.4522914,2.7129713,0.7266423,8.3659126),(37161,'metacarpal.tif',234,5,253,3.1621672,10.1754509,6.9596835,1.8,10.1748666,6.965041,-0.5888613,1.2496688,1.3356,1.3544145,1.6896124,0.1625803,1.2650587,1.0838188,2.1655011,2.4427711,2.7336813,0.6489956,8.3841349),(37162,'metacarpal.tif',234,5,254,3.1689349,10.1728671,6.9721957,1.8,10.1724025,6.9767901,-0.5981398,1.2401148,1.3439972,1.3570104,1.7296976,0.1674722,1.2869801,1.0942618,2.1767808,2.4427711,2.7705692,0.5729661,8.3841349),(37163,'metacarpal.tif',234,5,255,3.1850122,10.1698152,6.988172,1.8,10.1676466,6.993661,-0.5995304,1.2481772,1.3547151,1.3699244,1.776094,0.1690092,1.3110462,1.09754,2.2240505,2.4787332,2.7938815,0.6327488,8.47212),(37164,'metacarpal.tif',234,5,256,3.1928789,10.1696831,7.0020484,1.8,10.1669681,7.0034203,-0.5967306,1.259508,1.36729,1.3793634,1.8222609,0.16804,1.3327538,1.0951605,2.2412404,2.4856102,2.8119912,0.5954099,8.47212),(37165,'metacarpal.tif',234,5,257,3.1978415,10.1710301,7.0213406,1.8,10.1657226,7.0296355,-0.6247078,1.2599793,1.3746884,1.3900067,1.8642669,0.1823098,1.3561378,1.103198,2.2726451,2.4859915,2.838939,0.6540827,8.5783274),(37166,'metacarpal.tif',234,5,258,3.1948965,10.174874,7.0379901,1.8,10.1705344,7.0478381,-0.6356853,1.242958,1.3966085,1.389868,1.9229049,0.1877077,1.3768388,1.1181938,2.2641561,2.4427711,2.8852478,0.6747409,8.5783274),(37167,'metacarpal.tif',234,5,259,3.1990993,10.1780722,7.0542319,1.8,10.1744221,7.0611857,-0.6368831,1.2567969,1.4199331,1.408169,1.9876488,0.1885651,1.3998186,1.1204428,2.3031881,2.4958748,2.9442649,0.658806,8.6663126),(37168,'metacarpal.tif',234,5,260,3.1883543,10.1828459,7.0701084,1.8,10.1826581,7.0728258,-0.6444262,1.2564907,1.4431349,1.4071728,2.0405477,0.1917733,1.4139688,1.1199229,2.3223999,2.4859915,2.9595499,0.6231993,8.6663126),(37169,'metacarpal.tif',234,5,261,3.1878193,10.1832375,7.0894319,1.8,10.1772949,7.0948755,-0.6485077,1.2550907,1.4554784,1.4278998,2.1018543,0.1938264,1.4440986,1.1376866,2.3529366,2.4958748,3.0040001,0.6435011,8.8347349),(37170,'metacarpal.tif',234,5,262,3.1631973,10.1875239,7.1075698,1.8,10.1822823,7.1155418,-0.6540997,1.2510833,1.4797227,1.4226373,2.162661,0.1951721,1.4615312,1.1371243,2.3702004,2.4958748,3.0644114,0.6287963,8.8787274),(37171,'metacarpal.tif',234,5,263,3.1705895,10.1898577,7.1243115,1.8,10.186122,7.1330539,-0.6466949,1.2688032,1.4879839,1.4461942,2.2269127,0.191857,1.4965973,1.1398097,2.4000786,2.4958748,3.0827613,0.5947593,8.8787274),(37172,'metacarpal.tif',234,5,264,3.1491853,10.1873507,7.1424457,1.8,10.1757898,7.1527283,-0.6577122,1.2685363,1.5032663,1.4672942,2.2786907,0.1961404,1.5158264,1.1566829,2.4297882,2.4958748,3.1091763,0.648332,8.9849349),(37173,'metacarpal.tif',234,5,265,3.17011,10.1948832,7.1628269,1.8,10.1877527,7.1785629,-0.649276,1.2802786,1.5441713,1.4953451,2.3648051,0.1931406,1.5314397,1.1679841,2.4400178,2.5419523,3.1932959,0.71883,9.1791275),(37174,'metacarpal.tif',234,5,266,3.1562874,10.2034598,7.1805107,1.8,10.197822,7.1971005,-0.6593934,1.2876213,1.5573273,1.5093809,2.4433621,0.1974388,1.5689458,1.1722242,2.4833821,2.5459576,3.2144204,0.6528466,9.1791275),(37175,'metacarpal.tif',234,5,267,3.1714549,10.2137937,7.2020213,1.8,10.2060902,7.2188354,-0.6752758,1.284236,1.5785729,1.5349534,2.5311264,0.2065493,1.603427,1.1952269,2.539588,2.5489786,3.2605857,0.6711438,9.22312),(37176,'metacarpal.tif',234,5,268,3.2041584,10.2261226,7.2240057,1.8,10.2193925,7.2358652,-0.6811713,1.2816458,1.5838096,1.5691656,2.6572336,0.2117555,1.6777481,1.2243364,2.5931926,2.5489786,3.2743945,0.638914,9.3475498),(37177,'metacarpal.tif',234,5,269,3.2461517,10.2310117,7.2493371,1.8,10.2194074,7.259798,-0.6860941,1.2790818,1.6156786,1.5987049,2.793872,0.2171391,1.7292251,1.2498848,2.66667,2.5489786,3.3349813,0.625485,9.3915423),(37178,'metacarpal.tif',234,5,270,3.2906371,10.2374215,7.2752589,1.8,10.229901,7.2868347,-0.6991701,1.2890894,1.6595503,1.6337039,2.9265776,0.227163,1.7634763,1.2673317,2.7147201,2.5489786,3.4052696,0.7229794,9.5417423),(37179,'metacarpal.tif',234,5,271,3.3685328,10.2470075,7.3031011,1.8,10.2436778,7.3167516,-0.6845779,1.3015061,1.6764454,1.6944988,3.1085411,0.2244911,1.8542454,1.3019523,2.8340893,2.6020823,3.425087,0.6610432,9.7101647),(37180,'metacarpal.tif',234,5,272,3.4722165,10.2522788,7.3326064,1.8,10.2421708,7.3410251,-0.6849565,1.3072552,1.701757,1.7534565,3.318803,0.2316156,1.9502214,1.3413268,2.9359261,2.6020823,3.4846724,0.6478114,9.878587),(37181,'metacarpal.tif',234,5,273,3.5892077,10.2668005,7.3708729,1.8,10.2566144,7.3823564,-0.6786639,1.3176228,1.7249611,1.8230893,3.5686297,0.2357359,2.0688175,1.38362,3.0801434,2.655186,3.5448473,0.6350267,10.028787),(37182,'metacarpal.tif',234,5,274,3.7265043,10.2824894,7.4127231,1.8,10.2725054,7.4250826,-0.6768718,1.3341839,1.7388156,1.9115858,3.8238685,0.243666,2.1991225,1.4327753,3.2618426,2.655186,3.5773151,0.6812982,10.1349944),(37183,'metacarpal.tif',234,5,275,3.8769981,10.3000784,7.4574163,1.8,10.2850467,7.4694055,-0.6855153,1.3703636,1.765021,2.0187917,4.1025277,0.2589706,2.3243506,1.4731795,3.4249181,2.7613934,3.6359571,0.6682894,10.3914019),(37184,'metacarpal.tif',234,5,276,4.0545671,10.3268019,7.4992573,1.8,10.3021521,7.5168414,-0.6979869,1.3684406,1.8200747,2.1468968,4.4074817,0.2791119,2.4215939,1.5688637,3.5761167,2.7613934,3.7414576,0.6716062,10.5416019),(37185,'metacarpal.tif',234,5,277,4.2216046,10.357026,7.5333875,1.8,10.3200218,7.564363,-0.7011354,1.3980524,1.8630583,2.3204129,4.6828072,0.2927933,2.5135054,1.6597467,3.6886872,2.8144972,3.800535,0.6593101,10.8162316),(37186,'metacarpal.tif',234,5,278,4.3479311,10.3843778,7.5661948,1.8,10.3619006,7.6054524,-0.703125,1.412055,1.9020851,2.4836939,4.9638276,0.3029766,2.6096769,1.7589215,3.8679776,2.8676009,3.885654,0.7170118,11.0726391),(37187,'metacarpal.tif',234,5,279,4.4242468,10.3900357,7.6087293,1.8,10.3934909,7.648298,-0.7164097,1.4282868,1.9175598,2.6224489,5.2901496,0.3179781,2.7587926,1.83608,4.0755387,2.8676009,3.9375612,0.6091635,11.2592837),(37188,'metacarpal.tif',234,5,280,4.4479958,10.38432,7.6653039,1.8,10.4014136,7.7107531,-0.748135,1.4368671,2.0128857,2.7521681,5.6427674,0.3430675,2.8033223,1.915395,4.1632804,2.9207046,4.0421664,0.6137701,11.6658911),(37189,'metacarpal.tif',234,5,281,4.4803912,10.3851193,7.7131665,1.8,10.406875,7.7489717,-0.7761509,1.440983,2.0426927,2.9004624,5.9623856,0.3664611,2.9188852,2.012836,4.307376,2.9207046,4.0838107,0.5624979,11.7903209),(37190,'metacarpal.tif',234,5,282,4.5256758,10.406733,7.7665502,1.8,10.4352772,7.803277,-0.7978083,1.4879946,2.1176939,3.0824324,6.2454606,0.3864994,2.94918,2.0715347,4.3961582,2.9738083,4.1168229,0.669043,12.0027358),(37191,'metacarpal.tif',234,5,283,4.6333549,10.4494767,7.8151783,1.8,10.4878011,7.8618499,-0.8103951,1.7395915,2.124967,3.3913061,6.4879751,0.4054082,3.0532122,1.9494842,4.634302,3.2689459,4.1475331,0.5528412,12.5155507),(37192,'metacarpal.tif',234,5,284,4.8078953,10.4997344,7.8602949,1.8,10.5355471,7.9035607,-0.8108763,1.829939,2.1748662,3.7904021,6.6821092,0.4210652,3.0724231,2.071327,4.7984236,3.3893853,4.2015749,1.06717,12.7719581),(37193,'metacarpal.tif',234,5,285,4.9568719,10.5438011,7.8869117,1.8,10.5838359,7.9255423,-0.7870715,1.8362569,2.1576565,4.0106159,6.9148014,0.4144551,3.204774,2.1841257,5.0202626,3.3986381,4.2116306,1.0273187,12.6035358),(37194,'metacarpal.tif',234,5,286,5.1125203,10.5771608,7.9051143,1.8,10.6161427,7.9526177,-0.7578264,1.8046563,2.1396392,4.0983724,7.2039109,0.4025617,3.3668812,2.2709989,5.2065458,3.3455344,4.2701467,0.4164386,12.834173),(37195,'metacarpal.tif',234,5,287,5.2473639,10.6059384,7.9156563,1.8,10.6451869,7.9630893,-0.7408002,1.8302679,2.120493,4.1302231,7.4873163,0.3983284,3.5309319,2.2566221,5.372561,3.3657606,4.3389347,0.4094372,13.0025953),(37196,'metacarpal.tif',234,5,288,5.4209232,10.6328469,7.9296761,1.8,10.673543,7.9771415,-0.7286749,1.9086214,2.1054685,4.2083703,7.7467875,0.4006047,3.6793652,2.2049267,5.5391297,3.4338891,4.3389347,0.4094372,12.9403804),(37197,'metacarpal.tif',234,5,289,5.5731105,10.6508208,7.940433,1.8,10.6749288,7.9867197,-0.711579,1.9462039,2.0506182,4.241703,7.9310428,0.3961076,3.8676351,2.1794751,5.6367088,3.471479,4.3010735,1.1383886,13.0465879),(37198,'metacarpal.tif',234,5,290,5.7212376,10.6638633,7.9416404,1.8,10.6773774,7.985617,-0.7088192,1.8310977,2.0407016,4.1763354,8.0266445,0.4040339,3.933277,2.2807823,5.6645798,3.3455344,4.2991061,1.2324727,12.8266251),(37199,'metacarpal.tif',234,5,291,5.857579,10.6726814,7.9402256,1.8,10.6878751,7.987574,-0.7126164,1.7769625,2.0265158,4.2439123,8.0004586,0.4173281,3.9478886,2.3882959,5.7001606,3.2924307,4.3246126,1.2160907,12.7644102),(37200,'metacarpal.tif',234,5,292,6.015782,10.6800985,7.9495638,1.8,10.6990061,8.0023015,-0.7245866,1.763046,2.0254061,4.4380562,7.9208899,0.4404938,3.9107662,2.5172662,5.6121287,3.2924307,4.3233082,1.2710203,13.1270251),(37201,'metacarpal.tif',234,5,293,5.9924339,10.6730453,7.9218201,1.8,10.7046823,7.9658969,-0.7011649,1.792474,1.999281,4.2663735,7.5507177,0.4156398,3.7767166,2.3801593,5.4847608,3.2854961,4.2813588,1.1935473,12.7461879),(37202,'metacarpal.tif',234,5,294,6.0975921,10.6723708,7.9291365,1.8,10.7059834,7.9618358,-0.68994,1.7888189,2.0026721,4.2251403,7.3571679,0.4117101,3.6736757,2.3619721,5.3938335,3.2808328,4.2542676,1.2099595,12.7901804),(37203,'metacarpal.tif',234,5,295,6.2696511,10.6714234,7.9514001,1.8,10.6902331,7.9793317,-0.6870625,1.7725558,1.9804208,4.2096,7.2780196,0.420377,3.6749864,2.3748758,5.4041264,3.2668394,4.2283368,1.2265776,12.7021953),(37204,'metacarpal.tif',234,5,296,6.2077194,10.6646285,7.959373,1.8,10.6846657,7.9872904,-0.6905628,1.7703642,1.9847125,4.0908043,7.2027276,0.4197786,3.6291038,2.3107134,5.3368712,3.264775,4.2296705,0.2880554,12.9328325),(37205,'metacarpal.tif',234,5,297,6.1325318,10.648767,7.9606162,1.8,10.6784009,7.9835398,-0.7036801,1.7695524,2.0115238,4.0108137,7.1030767,0.4278925,3.531192,2.2665696,5.2660304,3.2475401,4.2516153,0.3049923,12.8523953),(37206,'metacarpal.tif',234,5,298,6.074424,10.641121,7.9767095,1.8,10.6720762,7.9953472,-0.7068294,1.721823,1.9932845,4.0142576,6.8811722,0.4269856,3.4521777,2.3313997,5.2065516,3.1862232,4.2516153,0.3049923,13.5776251),(37207,'metacarpal.tif',234,5,299,6.0176711,10.6304126,7.994768,1.8,10.6550799,8.0149419,-0.7251216,1.7058658,2.0124166,3.8456205,6.5336098,0.4411648,3.2466487,2.2543512,4.9697999,3.1648421,4.1712626,0.2362453,12.6399804),(37208,'metacarpal.tif',234,5,300,6.0928386,10.626472,8.0112718,1.8,10.6486558,8.0373389,-0.7185859,1.6540546,2.0186661,3.6489191,6.4007692,0.4400922,3.1707914,2.2060451,4.796382,3.088799,4.1366401,0.2758059,12.3395804),(37209,'metacarpal.tif',234,5,301,6.1151384,10.6203372,8.0187492,1.8,10.6405289,8.0494145,-0.6853687,1.6472469,1.9045793,3.4511818,6.361704,0.4083245,3.3402148,2.0951211,4.7629249,3.0590388,4.1366401,0.2758059,12.1453879),(37210,'metacarpal.tif',234,5,302,6.0386718,10.6175757,8.0296557,1.8,10.6389898,8.0625043,-0.6798772,1.593421,1.8702166,3.2229512,6.3368835,0.3978082,3.3883153,2.0226614,4.7468116,2.9646411,4.1085947,0.3159703,12.0134102),(37211,'metacarpal.tif',234,5,303,5.8992191,10.6067054,8.0367597,1.8,10.6169734,8.0636226,-0.6806261,1.5724736,1.9920171,2.8962528,6.2941592,0.3893415,3.1596914,1.8418452,4.4464506,2.9009813,4.1840879,0.3671738,11.9769655),(37212,'metacarpal.tif',234,5,304,5.6824939,10.6013653,8.0400764,1.8,10.5998142,8.0598832,-0.6836757,1.5262998,2.0207431,2.4829787,6.1491839,0.3778648,3.043031,1.6267962,4.1889675,2.8011493,4.1325477,0.3332443,11.8267655),(37213,'metacarpal.tif',234,5,305,5.3960358,10.6028067,8.0431717,1.8,10.5938109,8.0591993,-0.6864816,1.4756578,2.0187861,2.0718887,5.8465552,0.3612892,2.8960746,1.4040442,3.8424497,2.6913652,4.1024128,0.4145069,11.5703581),(37214,'metacarpal.tif',234,5,306,5.0982956,10.615109,8.0423252,1.8,10.602739,8.052389,-0.6925655,1.4108437,2.0263133,1.7051694,5.4317544,0.346429,2.6806093,1.2086168,3.4484137,2.5649954,4.0651236,0.4388593,11.1712986),(37215,'metacarpal.tif',234,5,307,4.7225423,10.6277645,8.0522589,1.8,10.6052785,8.0640908,-0.6946855,1.3087153,1.9230087,1.3560599,4.7878618,0.3225371,2.4897764,1.0361764,3.0996237,2.3876914,3.9318276,0.4978223,10.6144911),(37216,'metacarpal.tif',234,5,308,4.2541934,10.6464336,8.0582691,1.8,10.6251567,8.0599512,-0.7002575,1.2246999,1.8644106,1.0009808,3.9149047,0.29444,2.0998082,0.8173274,2.5977724,2.2442005,3.8153462,0.6316906,10.1274465),(37217,'metacarpal.tif',234,5,309,3.6327561,10.6706239,8.0766138,1.8,10.6682709,8.0777362,-0.7046826,1.1377116,1.8181559,0.6865871,2.8721018,0.2540717,1.5796785,0.6034809,1.6754818,2.0710451,3.6668494,0.610726,9.3839944),(37218,'metacarpal.tif',234,5,310,2.7063156,10.6755172,8.093127,1.8,10.668445,8.0836988,-0.7081915,1.0161231,2.0647885,0.3744338,1.5809882,0.1908403,0.7656901,0.3684925,0.9395074,1.8396148,3.3349813,0.625485,8.32192),(37219,'metacarpal.tif',234,5,311,1.650922,10.6960013,8.1295594,1.8,10.688406,8.1152999,-0.7159189,0.8199577,2.0542475,0.1685844,0.6340287,0.1185208,0.3086428,0.2056013,0.3860892,1.5400079,2.8754573,0.7114591,7.0216605),(37220,'metacarpal.tif',234,5,312,0.6047507,10.6583152,8.1800873,1.8,10.6219781,8.1447163,0.4324886,1.7180784,1.5290904,0.0696722,0.0902295,0.0177062,0.0590086,0.0405524,0.0800261,1.2016,1.5482262,0.6823166,4.1025191),(37221,'metacarpal.tif',234,5,313,0.0473568,10.538797,8.0519019,1.8,10.5226656,8.0357001,0.7252298,1.1196939,1.3142594,0.002711,0.0193615,0.0034726,0.0147319,0.0024212,0.0145367,0,0,0,0),(37222,'metacarpal.tif',234,5,314,2.7691121,11.2441533,8.8326927,1.8,11.2247257,8.8251978,-0.6939236,0.8328295,2.1510071,0.332479,5.3731121,0.1887772,2.4979519,0.3992162,2.5966192,0,0,0,0),(37223,'metacarpal.tif',234,5,315,4.0165677,11.7260455,8.65483,1.8,11.7032753,8.6456206,-0.5190956,1.3946896,2.7665741,0.9739651,10.3046504,0.1647531,3.724697,0.6983382,4.0690446,1.6193763,2.0151445,1.1071487,5.7836158),(37224,'metacarpal.tif',234,5,316,4.4085049,11.6467039,8.6474296,1.8,11.6259966,8.6406007,-0.5189605,1.4402145,2.8317757,1.1357456,10.9284535,0.1807443,3.8592229,0.7885948,4.2561586,1.7273,2.0825868,1.1232764,5.9778084),(37225,'metacarpal.tif',234,5,317,4.8600872,11.5723487,8.6256747,1.8,11.5534587,8.6160685,-0.5188217,1.4957071,2.8483025,1.3587785,11.6231555,0.1991619,4.0807307,0.9084522,4.557774,1.8140865,2.1830732,1.1071487,6.4284084),(37226,'metacarpal.tif',234,5,318,5.397611,11.4912298,8.5955007,1.8,11.4699812,8.580731,-0.5169191,1.4929478,2.9038975,1.6505649,12.2585666,0.2197167,4.2214185,1.1055744,4.7889049,2.2729111,4.4334451,0.8934099,13.4758391),(37227,'metacarpal.tif',234,5,319,6.0250614,11.3975435,8.5476574,1.8,11.3727856,8.5171272,-0.5109939,1.6537712,2.9625032,2.141411,12.9822095,0.2401634,4.3821757,1.2948653,5.1003329,2.5677822,4.4232562,0.7012599,14.0690912),(37228,'metacarpal.tif',234,5,320,6.9140182,11.2614616,8.4404604,1.8,11.2003583,8.3704496,-0.4864078,2.038835,2.9998123,3.4143528,13.7520828,0.2518001,4.5843144,1.6746587,5.697938,3.2351974,4.4334451,0.8934099,17.1642028),(37229,'metacarpal.tif',234,5,321,8.0146167,11.0931702,8.3070329,1.8,11.0293692,8.2420536,-0.4204056,1.8246436,3.1108536,4.9954858,14.2034379,0.2225001,4.5657686,2.7377872,6.1483267,3.1769569,4.4008857,0.6400882,13.230106),(37230,'metacarpal.tif',234,5,322,8.5493545,11.0094054,8.2328542,1.8,10.9995809,8.2295975,-0.3730082,1.7886772,3.1711673,5.7499115,14.3159835,0.1892268,4.5144207,3.2146166,6.3120459,3.1957663,4.3867659,0.6640462,13.230106),(37231,'metacarpal.tif',234,5,323,8.8549469,10.9696831,8.1813929,1.8,10.9854383,8.1986743,-0.334455,1.865612,3.1733753,6.2106684,14.284204,0.1590216,4.5012652,3.3290247,6.4363131,3.2683929,4.3661464,0.7123576,13.2740986),(37232,'metacarpal.tif',234,5,324,8.877605,10.9569167,8.1657293,1.8,10.9716302,8.1871474,-0.3142989,1.9052633,3.1847252,6.3012387,14.020376,0.1414108,4.4023817,3.3072798,6.3491385,3.301322,4.340884,0.6504214,13.1861135),(37233,'metacarpal.tif',234,5,325,8.688239,10.9587962,8.1683864,1.8,10.971129,8.1804786,-0.3000925,1.8940696,3.1860621,6.1478921,13.6477565,0.1265361,4.2835815,3.2458639,6.1500106,3.2856881,4.3174337,0.6991926,13.0359135),(37234,'metacarpal.tif',234,5,326,8.3118258,10.969562,8.1795028,1.8,10.9865351,8.1851223,-0.282048,1.8781621,3.1808136,5.831914,13.1495552,0.107311,4.1340226,3.1051176,5.921869,3.2777281,4.2760862,0.5343955,12.8674912),(37235,'metacarpal.tif',234,5,327,7.703979,10.9750515,8.1876905,1.8,10.9825848,8.1896777,-0.263925,1.8883925,3.1783653,5.4484767,12.5655471,0.0873811,3.9534622,2.8852459,5.6333604,3.2551128,4.2356667,0.6470472,12.6732986),(37236,'metacarpal.tif',234,5,328,7.0309102,10.9882107,8.1902457,1.8,10.9742081,8.1908363,-0.2412321,1.8885212,3.1474673,5.1959572,12.0331511,0.066879,3.8231218,2.7513364,5.4104829,3.2168979,4.1908223,0.6327488,12.5670912),(37237,'metacarpal.tif',234,5,329,6.3656355,11.0137682,8.1882623,1.8,10.9724528,8.1803795,-0.2156504,1.9127044,3.1209575,5.075377,11.5789823,0.048579,3.7100736,2.6535084,5.2329155,3.2080174,4.1058483,0.6947383,12.4608837),(37238,'metacarpal.tif',234,5,330,5.6415769,11.0716173,8.2049266,1.8,11.0363043,8.2040488,-0.1942109,1.9079959,3.0648177,4.8398769,11.052744,0.0350211,3.60633,2.5366286,5.0898036,3.2067466,4.0442588,1.0240075,12.3728986),(37239,'metacarpal.tif',234,5,331,5.2290363,11.1184856,8.2182466,1.8,11.0825801,8.2173373,-0.1720653,1.8495318,3.0161413,4.5264144,10.4761776,0.0255486,3.4733709,2.4473299,4.8432387,3.1492312,3.9810085,0.9461609,12.0542763),(37240,'metacarpal.tif',234,5,332,4.9206563,11.1559223,8.22393,1.8,11.1260973,8.2235785,-0.1450043,1.8543301,2.9714838,4.2255354,9.9992026,0.0171233,3.3650537,2.2787397,4.6479667,3.0969429,3.9167369,1.0040671,11.9040763),(37241,'metacarpal.tif',234,5,333,4.703655,11.1816707,8.2309142,1.8,11.1553218,8.2406718,-0.1166225,1.8082008,2.926473,3.9737196,9.6176268,0.010614,3.2864226,2.1976097,4.4422748,3.0517466,3.8381905,1.0370881,11.5854539),(37242,'metacarpal.tif',234,5,334,4.5183381,11.20934,8.235587,1.8,11.1838301,8.2440603,-0.0946747,1.8144596,2.8902593,3.7452881,9.2418507,0.0067297,3.1975853,2.0641341,4.2833336,2.9979357,3.8131281,1.0101093,11.4352539),(37243,'metacarpal.tif',234,5,335,4.3502682,11.2402644,8.2439234,1.8,11.2143462,8.2481531,-0.077198,1.7522556,2.8516876,3.514633,8.9605503,0.0043123,3.1421922,2.0057765,4.1203379,2.9665388,3.7497394,0.9994588,11.2850539),(37244,'metacarpal.tif',234,5,336,4.2260945,11.265231,8.2541697,1.8,11.239007,8.2627431,-0.0765664,1.7407225,2.8272517,3.3259278,8.6441649,0.0041211,3.0574444,1.9106594,3.9890716,2.913857,3.7104265,0.9434881,11.0726391),(37245,'metacarpal.tif',234,5,337,4.1579323,11.2781222,8.2505999,1.8,11.2495362,8.2508949,-0.0765238,1.737596,2.8141027,3.153002,8.4010526,0.0040501,2.9853397,1.8145772,3.8640456,2.8771964,3.6706926,1.0338856,10.8784465),(37246,'metacarpal.tif',234,5,338,4.1006535,11.2830893,8.2492665,1.8,11.256069,8.2472538,-0.0827216,1.6695394,2.8122546,3.0145818,8.149939,0.004666,2.8980089,1.8056369,3.7388815,2.8404133,3.6243046,0.9770467,10.7100242),(37247,'metacarpal.tif',234,5,339,4.0798147,11.2837025,8.2477445,1.8,11.2578106,8.2463865,-0.0922929,1.6552894,2.8162432,2.90674,7.952597,0.0057755,2.8238317,1.7560313,3.6366619,2.7628402,3.5828289,0.9944211,10.5780465),(37248,'metacarpal.tif',234,5,340,4.0819201,11.2832151,8.2467145,1.8,11.2570208,8.2497351,-0.0987091,1.6425007,2.8196501,2.8337776,7.8273395,0.0066072,2.7759968,1.7252825,3.5692719,2.759891,3.5678429,1.0412067,10.5780465),(37249,'metacarpal.tif',234,5,341,4.0631034,11.2833346,8.2409755,1.8,11.2628545,8.240894,-0.1034157,1.583871,2.8210777,2.7268196,7.6821261,0.0072166,2.7231176,1.7216173,3.4824143,2.7182555,3.503236,1.0303768,10.3216391),(37250,'metacarpal.tif',234,5,342,4.0558571,11.2766117,8.2362424,1.8,11.2577066,8.2369553,-0.1090078,1.5758678,2.8296739,2.6510539,7.5417379,0.0080007,2.6652321,1.6822819,3.4009672,2.6575414,3.479003,1.0007559,10.1532167),(37251,'metacarpal.tif',234,5,343,4.0314188,11.2667013,8.2287247,1.8,11.2511318,8.2262887,-0.105826,1.5208653,2.8373813,2.549692,7.4102755,0.0074967,2.6116601,1.6764746,3.3099854,2.6187145,3.4283788,1.0679531,10.0030167),(37252,'metacarpal.tif',234,5,344,4.0088794,11.2443901,8.2233761,1.8,11.2196953,8.2225522,-0.1065988,1.5198568,2.8593215,2.4653008,7.2090495,0.0075636,2.5212448,1.6220613,3.1910442,2.590882,3.3753253,1.0074801,9.9150316),(37253,'metacarpal.tif',234,5,345,3.9727926,11.2282832,8.2130541,1.8,11.2154012,8.2088428,-0.1025287,1.4610139,2.872589,2.3711571,6.9900937,0.0069361,2.4333776,1.6229531,3.097251,2.5492934,3.3358268,1.0265158,9.7466093),(37254,'metacarpal.tif',234,5,346,3.9235894,11.2069831,8.2054296,1.8,11.2045518,8.2064961,-0.0979837,1.4676135,2.8837956,2.2890453,6.7126191,0.0062582,2.3277028,1.5597058,2.9561602,2.5093909,3.2975657,1.0460006,9.6586242),(37255,'metacarpal.tif',234,5,347,3.8900609,11.1877033,8.197288,1.8,11.1872931,8.200281,-0.0903017,1.4170124,2.8995669,2.2061833,6.4657998,0.0052725,2.2299192,1.5569259,2.8284599,2.5052818,3.2605857,0.8996525,9.5964093),(37256,'metacarpal.tif',234,5,348,3.8164948,11.1654962,8.1878022,1.8,11.1762378,8.1888217,-0.0842136,1.3721199,2.9123828,2.1096144,6.1179818,0.0045004,2.1006791,1.5374854,2.6625578,2.4606106,3.2144204,0.9179497,9.4902018),(37257,'metacarpal.tif',234,5,349,3.7281814,11.1340888,8.1846653,1.8,11.1535388,8.1949685,-0.0793389,1.5045181,2.9360734,2.0367507,5.6784252,0.0039031,1.9340201,1.3537562,2.4277702,2.4292137,3.1871081,0.9697226,9.3839944),(37258,'metacarpal.tif',234,5,350,3.657141,11.1149153,8.1785238,1.8,11.152619,8.1902018,-0.0667899,1.5516137,2.9518358,1.9668005,5.3747711,0.002715,1.8208232,1.2675839,2.273778,2.404217,3.155094,0.6673061,9.1715795),(37259,'metacarpal.tif',234,5,351,3.5941518,11.0953177,8.1752046,1.8,11.1420183,8.1920902,-0.0505006,1.5095904,2.9630387,1.92395,5.0886037,0.0015264,1.7173598,1.2744848,2.1590529,2.3894358,3.1254596,0.614663,9.0031572),(37260,'metacarpal.tif',234,5,352,3.5341529,11.0750655,8.1735564,1.8,11.144271,8.1940712,-0.0366935,1.5471802,2.982714,1.881238,4.8195594,0.0007927,1.6158302,1.215914,2.0310842,2.3467266,3.1091763,0.648332,9.0031572),(37261,'metacarpal.tif',234,5,353,3.4749403,11.0496404,8.1730874,1.8,11.1409784,8.1941621,-0.0276534,1.5219478,3.0050199,1.8482963,4.5420758,0.0004428,1.5114961,1.2144282,1.9235228,2.3294583,3.1091763,0.648332,8.8969498),(37262,'metacarpal.tif',234,5,354,3.42788,11.0143665,8.1721968,1.8,11.0997614,8.1905058,-0.0205845,1.502651,3.0376846,1.8181065,4.2315778,0.000242,1.3930274,1.2099326,1.803491,2.2990432,3.1091763,0.648332,8.7907423),(37263,'metacarpal.tif',234,5,355,3.4126884,11.0070725,8.1744318,1.8,11.0741489,8.1910531,0.0006643,1.4363508,3.0375826,1.7982388,4.1860346,0.0000003,1.3780809,1.2519496,1.7810013,2.2694808,3.0964524,0.6823166,8.7907423),(37264,'metacarpal.tif',234,5,356,3.4830188,11.0582127,8.1848513,1.8,11.1265199,8.2024953,0.0387838,1.3111155,3.0386098,1.7846177,4.734919,0.0008727,1.5582517,1.3611445,1.9700016,2.2475275,3.0964524,0.6823166,8.6845349),(37265,'metacarpal.tif',234,5,357,3.5756075,11.1072146,8.1958484,1.8,11.1676721,8.2119702,0.0620228,1.3032642,3.0186663,1.7884865,5.3060264,0.0022895,1.7577386,1.3723131,2.1759136,2.2390657,3.1091763,0.648332,8.6845349),(37266,'metacarpal.tif',234,5,358,3.6178617,11.1184035,8.2031761,1.8,11.1620346,8.2184252,0.0686131,1.3112794,3.0150564,1.7760483,5.4760043,0.0028342,1.8162195,1.3544392,2.233315,2.2177224,3.1091763,0.648332,8.6845349),(37267,'metacarpal.tif',234,5,359,3.6542053,11.1134371,8.2050134,1.8,11.1553015,8.2178653,0.0673841,1.3131911,3.0184038,1.7755579,5.4882674,0.0027612,1.8182681,1.352094,2.2344091,2.194722,3.1091763,0.648332,8.6845349),(37268,'metacarpal.tif',234,5,360,3.6645967,11.0916203,8.2020779,1.8,11.1316817,8.2127281,0.060489,1.3100743,3.0274221,1.7679526,5.2910135,0.002232,1.747696,1.3495056,2.1785829,2.1741116,3.1091763,0.648332,8.6845349),(37269,'metacarpal.tif',234,5,361,3.6703267,11.0582031,8.1948398,1.8,11.0934868,8.204012,0.0448928,1.3003655,3.0427537,1.7635433,4.9740861,0.001232,1.6347318,1.3561904,2.0581703,2.1651345,3.1091763,0.648332,8.6845349),(37270,'metacarpal.tif',234,5,362,3.6678745,11.0307026,8.1866531,1.8,11.074955,8.1983862,0.0268058,1.2893125,3.0481269,1.7608651,4.7110926,0.0004392,1.5455697,1.3657396,1.9599863,2.164455,3.1371672,0.7345945,8.7285274),(37271,'metacarpal.tif',234,5,363,3.6787412,10.9963348,8.1808846,1.8,11.0405225,8.1985082,-0.002013,1.362947,3.0473491,1.7592287,4.4163008,0.0000025,1.449227,1.2907536,1.8513036,2.181526,3.155094,0.6673061,8.7907423),(37272,'metacarpal.tif',234,5,364,3.6527134,10.9573909,8.1696608,1.8,10.9982465,8.184506,-0.0555592,1.5373132,3.0806453,1.7166715,4.0065156,0.0018773,1.3005443,1.11667,1.6952969,2.1621712,3.155094,0.6673061,8.7907423),(37273,'metacarpal.tif',234,5,365,3.6305803,10.9187924,8.1581271,1.8,10.9719042,8.1750378,-0.1375243,1.7205542,3.0813008,1.6439653,3.6000229,0.0113722,1.1683452,0.9554859,1.5486116,2.1274476,3.155094,0.6673061,8.8089646),(37274,'metacarpal.tif',234,5,366,3.6142615,10.8804542,8.147662,1.8,10.9376436,8.166132,-0.2536036,2.0665185,3.0336325,1.5351834,3.216606,0.0379183,1.060315,0.7428839,1.387114,2.1062732,3.1693624,0.6340227,8.8089646),(37275,'metacarpal.tif',234,5,367,3.6273737,10.8495476,8.1361467,1.8,10.8971519,8.1474527,-0.3856597,2.360988,2.9125774,1.407105,2.9628624,0.0855481,1.0172648,0.5959814,1.2738483,2.0964518,3.2021147,0.6857295,8.8529572),(37276,'metacarpal.tif',234,5,368,3.6474331,10.8285614,8.1319298,1.8,10.8660137,8.1384536,-0.4891204,2.4863935,2.6716517,1.3040306,2.8198837,0.1342004,1.0554833,0.5244667,1.2129705,2.1129715,3.1871081,0.6010738,8.8089646),(37277,'metacarpal.tif',234,5,369,3.6874015,10.8114962,8.1332243,1.8,10.8344708,8.1373725,-0.5663466,2.5391919,2.4978108,1.2227605,2.783764,0.1769269,1.1144815,0.481555,1.1888733,2.1196341,3.1871081,0.6010738,8.8089646),(37278,'metacarpal.tif',234,5,370,3.7416101,10.8015387,8.1384532,1.8,10.8186704,8.1458901,-0.5850147,2.5812501,2.4279756,1.2206925,2.8457371,0.1901597,1.1720617,0.4729075,1.2037632,2.1741116,3.2327912,0.5364355,8.9151721),(37279,'metacarpal.tif',234,5,371,3.7969361,10.8007625,8.1424932,1.8,10.8154992,8.1458773,-0.6076895,2.5654658,2.3374084,1.2118012,2.9198061,0.206306,1.2491638,0.4723513,1.2305671,2.1867704,3.2493229,0.5880026,9.0213795),(37280,'metacarpal.tif',234,5,372,3.851522,10.809387,8.1541206,1.8,10.8246617,8.1575674,-0.6193221,2.5760122,2.2664094,1.217763,3.0174521,0.216302,1.33138,0.4727319,1.2656968,2.1583437,3.2743945,0.638914,9.127587),(37281,'metacarpal.tif',234,5,373,3.9141435,10.8214667,8.1694899,1.8,10.8397609,8.1785777,-0.6178191,2.6144913,2.269059,1.2544561,3.1434683,0.2188924,1.3853621,0.4798089,1.3126789,2.1480301,3.3120718,0.5754247,9.0835944),(37282,'metacarpal.tif',234,5,374,3.9724996,10.8320754,8.183009,1.8,10.8514648,8.1927836,-0.6166436,2.7173993,2.2275758,1.3016153,3.29065,0.2214212,1.4772337,0.478993,1.3585594,2.1347445,3.3661225,0.6747409,9.1715795),(37283,'metacarpal.tif',234,5,375,4.065088,10.8496961,8.198756,1.8,10.8735361,8.2105329,-0.6012917,2.7251911,2.301189,1.387004,3.5027403,0.216822,1.5221437,0.5089566,1.4455653,2.1614278,3.4160183,0.5819051,9.3839944),(37284,'metacarpal.tif',234,5,376,4.1812624,10.8777,8.2172904,1.8,10.9073177,8.2337743,-0.5706128,2.6949219,2.3568457,1.544691,3.7795773,0.2033207,1.6036592,0.5731858,1.5774001,2.1758567,3.4651958,0.5218343,9.4902018),(37285,'metacarpal.tif',234,5,377,4.3315083,10.9118902,8.2308864,1.8,10.9416707,8.2487764,-0.5609984,2.6455557,2.3560692,1.6488037,4.1035711,0.2043446,1.7417023,0.6232353,1.7230102,2.1997683,3.54246,0.5585993,9.7026167),(37286,'metacarpal.tif',234,5,378,4.4910968,10.9495832,8.2440279,1.8,10.9793121,8.2630028,-0.567963,2.5650112,2.3164237,1.7320914,4.3939263,0.2165859,1.8968578,0.6752763,1.8714687,2.2082819,3.5828289,0.5763752,9.7648316),(37287,'metacarpal.tif',234,5,379,4.667155,10.980146,8.2623783,1.8,11.0058127,8.2837891,-0.5894144,2.5757989,2.2551725,1.8283052,4.6388801,0.2403556,2.0569957,0.7098012,1.9969667,2.2625972,3.6243046,0.5937497,10.1274465),(37288,'metacarpal.tif',234,5,380,4.8174634,10.9957571,8.280246,1.8,11.0052764,8.2998078,-0.6292387,2.5675593,2.1661252,1.8943059,4.8023184,0.2781016,2.2170088,0.7377847,2.0961872,2.3221781,3.6359571,0.9025069,10.2336539),(37289,'metacarpal.tif',234,5,381,4.9168795,11.0063908,8.2952149,1.8,11.0104239,8.3095111,-0.6634725,2.4352716,2.0440348,1.9512158,4.9121846,0.3108116,2.4031805,0.8012313,2.1992849,2.3883171,3.6951948,0.9151007,10.3838539),(37290,'metacarpal.tif',234,5,382,4.988704,11.0116962,8.306171,1.8,11.015291,8.3150194,-0.6816746,1.182768,1.7987102,2.0213608,4.9646936,0.3301015,2.7601409,1.7090087,3.7521947,2.4226947,3.7286224,0.971621,10.5340539),(37291,'metacarpal.tif',234,5,383,5.0206584,11.0128419,8.313305,1.8,11.0197603,8.3235606,-0.6896935,1.1933858,1.803479,2.0991346,5.011595,0.338793,2.7788485,1.758974,3.8095141,2.4417742,3.7497394,0.9994588,10.5962688),(37292,'metacarpal.tif',234,5,384,5.0378093,11.0135922,8.3127552,1.8,11.0291848,8.324635,-0.6862551,1.2082217,1.8020655,2.1723812,5.0213101,0.3371179,2.7864192,1.7979988,3.7965654,2.464936,3.7737284,1.0269639,10.7464688),(37293,'metacarpal.tif',234,5,385,5.0488337,11.0085076,8.3091071,1.8,11.0257031,8.3245929,-0.6848291,1.2233814,1.7928257,2.221793,5.0112678,0.3366795,2.7951785,1.8161081,3.7750451,2.4787989,3.7737284,1.0269639,10.9953283),(37294,'metacarpal.tif',234,5,386,5.0677203,11.0064184,8.3021787,1.8,11.0284783,8.3192342,-0.6781205,2.4581552,1.9671127,2.2475838,5.0196335,0.3323948,2.5517773,0.9143377,2.3298913,2.4971676,3.7737284,1.0269639,11.2517358),(37295,'metacarpal.tif',234,5,387,5.1024589,11.0072175,8.3030816,1.8,11.0399612,8.3304236,-0.6759313,2.511329,1.9723029,2.2895122,4.9843636,0.3328551,2.5271796,0.9116736,2.3194266,2.5533294,3.7640013,1.0714496,11.6143507),(37296,'metacarpal.tif',234,5,388,5.1778703,11.0063096,8.3181038,1.8,11.0468435,8.3662539,-0.6769476,2.4435562,1.9329426,2.3915129,4.9610521,0.3386308,2.5665801,0.9787018,2.3598865,2.7202372,3.7293787,1.1341692,13.3212176),(37297,'metacarpal.tif',234,5,389,5.3071988,11.0141996,8.3438585,1.8,11.0613227,8.4000539,-0.6760781,1.535569,1.7236524,2.5874217,4.9629872,0.3463379,2.8793434,1.6849921,3.9554482,2.8081981,3.7293787,1.1341692,13.2407804),(37298,'metacarpal.tif',234,5,390,5.4917381,11.0279575,8.3840944,1.8,11.0735274,8.4403373,-0.6741029,1.5878629,1.7080398,2.864949,4.999222,0.3566166,2.9268768,1.8042798,4.1921864,2.8859535,3.6982462,1.152572,11.1348539),(37299,'metacarpal.tif',234,5,391,5.701505,11.0479771,8.4302078,1.8,11.0855163,8.476821,-0.6824778,1.5575197,1.6993934,3.1475648,5.0038719,0.3780144,2.9445047,2.0208828,4.429631,2.9177064,3.6829641,1.2167989,11.2152911),(37300,'metacarpal.tif',234,5,392,5.9230662,11.0759118,8.4778503,1.8,11.1044434,8.5132494,-0.6640589,1.6583335,2.5633446,3.3955706,5.0685203,0.3749777,1.9773074,2.0475801,2.8304207,2.9470722,3.6576091,1.2360595,11.2152911),(37301,'metacarpal.tif',234,5,393,6.1177049,11.1092476,8.5198424,1.8,11.1354685,8.5466747,-0.6334458,1.5888827,2.6517234,3.5164097,5.0975134,0.3572494,1.9223398,2.2131336,2.8962904,2.9432759,3.6622321,1.3009472,11.2335135),(37302,'metacarpal.tif',234,5,394,6.2738614,11.1395729,8.5489176,1.8,11.1618278,8.5627394,-0.5867311,1.5557012,2.7025651,3.5427865,5.1222685,0.3205098,1.8953359,2.2772924,2.9381766,2.9595307,3.6982462,1.3455195,11.3654911),(37303,'metacarpal.tif',234,5,395,6.3379404,11.1709969,8.5759454,1.8,11.1946455,8.583992,-0.5294282,1.5159097,2.7901927,3.4937294,5.137219,0.2694314,1.84117,2.304708,2.9378261,2.9693574,3.6829641,1.2812927,11.3837135),(37304,'metacarpal.tif',234,5,396,6.3213516,11.2046421,8.6020248,1.8,11.2248087,8.6046474,-0.4787509,1.5784861,2.8153514,3.412903,5.188435,0.2235837,1.8429084,2.1621368,2.9551622,2.9432759,3.6982462,1.3455195,11.3837135),(37305,'metacarpal.tif',234,5,397,6.2730172,11.2394709,8.6256323,1.8,11.2477364,8.6103227,-0.4426904,1.6008587,2.8187897,3.3866776,5.3040515,0.1918525,1.8816769,2.1155381,3.0155118,2.9257466,3.6982462,1.3455195,11.427706),(37306,'metacarpal.tif',234,5,398,6.2322074,11.2630444,8.6470833,1.8,11.2531742,8.6169418,-0.4281005,1.6054468,2.8147072,3.4173857,5.4293732,0.1790141,1.92893,2.1286197,3.0887996,2.9077925,3.6982462,1.0617254,11.3837135),(37307,'metacarpal.tif',234,5,399,6.2115744,11.2795925,8.663109,1.8,11.2574802,8.62151,-0.4384999,1.6254617,2.7689807,3.4544624,5.4874664,0.1866265,1.981764,2.1252192,3.1547656,2.9253218,3.7096664,1.0164888,11.5156911),(37308,'metacarpal.tif',234,5,400,6.158777,11.2888942,8.6770225,1.8,11.2545432,8.6298958,-0.4669026,1.7403096,2.748624,3.3916571,5.3554888,0.207972,1.9484254,1.9488814,3.0925346,2.9158565,3.7640013,1.0714496,11.6658911),(37309,'metacarpal.tif',234,5,401,6.1595343,11.2912609,8.6874375,1.8,11.2534116,8.6411657,-0.5058327,1.8146601,2.7235452,3.3348587,5.2019805,0.2410176,1.9100034,1.8377318,3.0180994,2.8940482,3.8153462,0.6316906,11.5596837),(37310,'metacarpal.tif',234,5,402,6.2166825,11.2891992,8.693717,1.8,11.2573689,8.6476691,-0.5266808,1.7895905,2.6742248,3.2868501,5.0886657,0.2617989,1.9028564,1.8366492,2.9747828,2.8812862,3.8601693,0.6473921,11.2850539),(37311,'metacarpal.tif',234,5,403,6.2895357,11.28181,8.6965878,1.8,11.264432,8.6508074,-0.5616435,1.6743177,2.6495889,3.2404822,5.0429013,0.2973266,1.9032769,1.9354046,2.9339069,2.8602271,3.8762078,0.6202495,11.2850539),(37312,'metacarpal.tif',234,5,404,6.3927574,11.2651196,8.6971593,1.8,11.2655294,8.6730181,-0.5774073,1.5917223,2.6481852,3.1530176,5.182756,0.31746,1.9570973,1.9808842,2.9353631,2.8155559,3.9059221,0.6627295,12.7537358),(37313,'metacarpal.tif',234,5,405,6.5383466,11.2347461,8.6850718,1.8,11.2315238,8.6724834,-0.5983117,1.5420044,2.6021618,3.1108418,5.489795,0.3457136,2.1097054,2.0174014,3.0146336,2.7767516,3.9059221,0.6627295,12.028506),(37314,'metacarpal.tif',234,5,406,6.5538023,11.2248452,8.6669136,1.8,11.2406293,8.6531832,-0.6273243,1.5691894,2.5644935,3.0665444,5.7853001,0.3763479,2.2559231,1.954222,3.0954824,2.7273961,3.9059221,0.6627295,11.0104242),(37315,'metacarpal.tif',234,5,407,6.4066911,11.2161884,8.6612071,1.8,11.2345109,8.6590195,-0.6463453,1.5633074,2.4982089,2.9730597,5.8474736,0.3873194,2.3406664,1.9017754,3.0887528,2.6839665,3.9203352,0.6358384,11.0286465),(37316,'metacarpal.tif',234,5,408,6.1154338,11.2100633,8.6629227,1.8,11.2208733,8.67242,-0.6490234,1.5719641,2.5004115,2.8316734,5.7050228,0.3723381,2.2816336,1.80136,2.9827737,2.6260211,3.9203352,0.6358384,11.0286465),(37317,'metacarpal.tif',234,5,409,5.7973026,11.2142325,8.6652403,1.8,11.2237665,8.6772585,-0.6446994,1.5573686,2.5044697,2.6454641,5.4876253,0.3489501,2.1911327,1.6986757,2.8455301,2.5789257,3.9059221,0.6627295,10.8602242),(37318,'metacarpal.tif',234,5,410,5.5277325,11.2232581,8.6682502,1.8,11.236768,8.6772386,-0.6383551,1.5948228,2.5077026,2.446631,5.2097543,0.3271195,2.0775009,1.5341084,2.686741,2.5342545,3.833044,0.6043055,10.6660316),(37319,'metacarpal.tif',234,5,411,5.2635709,11.2299451,8.6782884,1.8,11.2422564,8.6896987,-0.6263633,1.5547311,2.5242204,2.2139719,4.9218515,0.3014563,1.9498501,1.4240223,2.508613,2.4449121,3.800535,0.6593101,10.5780465),(37320,'metacarpal.tif',234,5,412,5.0334897,11.2348213,8.6892074,1.8,11.2400567,8.7020947,-0.6197414,1.5274276,2.4916014,1.9930863,4.6647731,0.2830141,1.8721988,1.3048647,2.3517805,2.391815,3.7497394,0.5713375,10.3656316),(37321,'metacarpal.tif',234,5,413,4.8386326,11.2437971,8.7004477,1.8,11.249702,8.7080538,-0.6129745,1.49706,2.4565589,1.7862535,4.457161,0.2669099,1.8143921,1.1931743,2.2180636,2.3169003,3.7286224,0.5991753,10.2594242),(37322,'metacarpal.tif',234,5,414,4.6336847,11.2476302,8.7140339,1.8,11.2487564,8.7207782,-0.6120217,1.0878141,1.7929829,1.5704063,4.2115313,0.2549122,2.3488966,1.4436348,3.2119205,2.2584412,3.6706926,0.5369107,10.1274465),(37323,'metacarpal.tif',234,5,415,4.4452085,11.2521112,8.7220484,1.8,11.249507,8.7249563,-0.6107746,1.059421,1.7738039,1.3812334,3.9407746,0.2436751,2.2216518,1.3037625,2.9984588,2.2085977,3.6243046,0.5937497,9.8345944),(37324,'metacarpal.tif',234,5,416,4.3167398,11.2581029,8.7292552,1.8,11.2531094,8.731001,-0.6087538,1.0243781,1.7747213,1.2235535,3.7325514,0.2352676,2.1031761,1.1944354,2.7905305,2.1369269,3.6055823,0.6226708,9.7466093),(37325,'metacarpal.tif',234,5,417,4.2090088,11.2663493,8.7357738,1.8,11.2632255,8.7330573,-0.610073,0.9737506,1.7346266,1.0731041,3.5211812,0.2302648,2.0299361,1.1020318,2.6396816,2.0343021,3.5200998,0.5880026,9.6146316),(37326,'metacarpal.tif',234,5,418,4.1896014,11.2703227,8.7478867,1.8,11.2667015,8.7482185,-0.6126346,0.9294513,1.7122838,0.9386038,3.3928313,0.2308845,1.9814656,1.0098472,2.528344,1.9381035,3.479003,0.5700405,9.3582242),(37327,'metacarpal.tif',234,5,419,4.1937695,11.269814,8.7572525,1.8,11.2686354,8.7531571,-0.6159293,0.9181275,1.7062689,0.8370353,3.3192396,0.2332835,1.9453203,0.9116765,2.4339813,1.9011331,3.4578637,0.6000502,9.3582242),(37328,'metacarpal.tif',234,5,420,4.176148,11.2708602,8.7667108,1.8,11.2751673,8.7626921,-0.6261901,0.8896648,1.7007911,0.7634117,3.2420785,0.2390626,1.9062179,0.8580892,2.3515409,1.8606691,3.4390553,0.551655,9.1458093),(37329,'metacarpal.tif',234,5,421,4.1680332,11.2708045,8.7759877,1.8,11.2688071,8.7792594,-0.6325842,0.8707532,1.7228648,0.7142673,3.2418717,0.2428254,1.881675,0.8202867,2.2951317,1.8149819,3.4578637,0.6000502,9.2520167),(37330,'metacarpal.tif',234,5,422,4.1385707,11.2766367,8.7815903,1.8,11.2740473,8.7858218,-0.6353513,0.8598919,1.7243766,0.6673845,3.2783748,0.2429308,1.9011942,0.776126,2.2875707,1.7965392,3.5008202,0.6177557,9.2520167),(37331,'metacarpal.tif',234,5,423,4.1168045,11.283517,8.7854365,1.8,11.2781227,8.7878528,-0.6351635,0.8366238,1.7435215,0.6359597,3.3245158,0.24153,1.9067822,0.7601502,2.2696747,1.7557693,3.5200998,0.5880026,9.1898018),(37332,'metacarpal.tif',234,5,424,4.1080735,11.2937371,8.7920494,1.8,11.2889683,8.7982403,-0.6353083,1.092299,1.7478129,0.6267342,3.3939399,0.2411125,1.941821,0.5737753,2.2978566,1.7557693,3.54246,0.5585993,9.2520167),(37333,'metacarpal.tif',234,5,425,4.1437825,11.3014714,8.8030962,1.8,11.2945349,8.8196326,-0.6395422,1.1239273,1.7470616,0.6468259,3.486777,0.2460052,1.9957951,0.5755051,2.3619157,1.7557693,3.54246,0.5585993,9.3582242),(37334,'metacarpal.tif',234,5,426,4.1894274,11.3093224,8.8103465,1.8,11.3050879,8.823863,-0.6380891,1.1590329,1.7336083,0.6691172,3.5840739,0.2477437,2.067407,0.5773065,2.4533598,1.7719063,3.5200998,0.5880026,9.420439),(37335,'metacarpal.tif',234,5,427,4.2692512,11.3188441,8.8212692,1.8,11.317671,8.8335746,-0.6383828,1.1891804,1.7347442,0.7149771,3.6885999,0.2526642,2.1263077,0.6012352,2.5382723,1.833141,3.5200998,0.5880026,9.570639),(37336,'metacarpal.tif',234,5,428,4.3564276,11.3296919,8.8390872,1.8,11.3295584,8.8517487,-0.6362261,1.124818,1.732924,0.7766433,3.7880602,0.2563257,2.1859356,0.6904613,2.6334692,1.8931594,3.5304989,0.5112307,9.7390614),(37337,'metacarpal.tif',234,5,429,4.4273457,11.3440427,8.8595513,1.8,11.3445886,8.8698151,-0.6381608,1.1279469,1.7166015,0.8460086,3.8369367,0.2618637,2.2351936,0.7500429,2.7078758,1.9369673,3.503236,0.5404195,9.8452688),(37338,'metacarpal.tif',234,5,430,4.4840485,11.357943,8.8805575,1.8,11.3517266,8.890159,-0.6419652,1.1013685,1.7001097,0.9279247,3.8473917,0.2679415,2.2630255,0.8425198,2.7220131,2.0154524,3.5265029,0.4636476,9.9696986),(37339,'metacarpal.tif',234,5,431,4.5172398,11.3822773,8.9012565,1.8,11.3841773,8.9156295,-0.6445437,1.1143487,1.7074086,1.0243238,3.8213956,0.2717882,2.238126,0.919213,2.761197,2.1835495,3.503236,0.5404195,11.7570027),(37340,'metacarpal.tif',234,5,432,4.4989399,11.4007862,8.9109416,1.8,11.4008809,8.9187726,-0.6460013,1.1245098,1.7164672,1.1038148,3.743906,0.2717374,2.1811696,0.9815965,2.7861643,2.2112752,3.503236,0.5404195,11.3579432),(37341,'metacarpal.tif',234,5,433,4.4540677,11.4204742,8.9245884,1.8,11.4273131,8.9353103,-0.6425601,1.1486678,1.6637286,1.1788581,3.619355,0.2665736,2.175448,1.0262829,2.7814289,2.2569932,3.4390553,0.551655,12.0134102),(37342,'metacarpal.tif',234,5,434,4.4041876,11.4316343,8.9345312,1.8,11.4419141,8.9432964,-0.6362736,1.1528837,1.6554817,1.2392232,3.5328187,0.2591691,2.1340125,1.07489,2.7251957,2.3138244,3.461939,0.2186689,10.0061432),(37343,'metacarpal.tif',234,5,435,4.348007,11.4419137,8.9395464,1.8,11.4580611,8.9443054,-0.6279283,1.1751503,1.6532698,1.2772266,3.4213265,0.2500977,2.0694303,1.0868623,2.6970287,2.3555697,3.4725123,1.194306,10.1563432),(37344,'metacarpal.tif',234,5,436,4.2691753,11.4455233,8.9461037,1.8,11.463985,8.9576356,-0.6213458,1.1878158,1.6564971,1.2855987,3.2902077,0.2411197,1.9862442,1.0823216,2.6297184,2.3712682,3.4676363,0.3080528,12.881292),(37345,'metacarpal.tif',234,5,437,4.245191,11.4359711,8.9429611,1.8,11.4464048,8.9552646,-0.6160698,1.2241151,1.6642658,1.3003603,3.2296986,0.2362376,1.9406147,1.062286,2.56432,2.4449121,3.5160919,0.348771,13.6065218),(37346,'metacarpal.tif',234,5,438,4.2197523,11.4243669,8.9365572,1.8,11.4308995,8.9565998,-0.6076003,1.2576176,1.6917641,1.3087828,3.1706893,0.2292209,1.8741912,1.0406843,2.5220104,2.2866652,3.54246,0.3686959,10.6949283),(37347,'metacarpal.tif',234,5,439,4.2580077,11.4074773,8.9137005,1.8,11.4145243,8.9279633,-0.6063966,1.2865392,1.6931505,1.3515849,3.1841736,0.2304985,1.8806205,1.0505586,2.5383536,2.2847483,3.54246,0.3686959,10.9695581),(37348,'metacarpal.tif',234,5,440,4.3818285,11.3869773,8.8908935,1.8,11.400744,8.906759,-0.6167598,1.3125184,1.6917062,1.44961,3.2767519,0.2443167,1.9369509,1.1044493,2.6235079,2.29585,3.54246,0.3686959,11.0757655),(37349,'metacarpal.tif',234,5,441,4.5671112,11.3820826,8.8841544,1.8,11.410536,8.9108754,-0.6232903,1.3351157,1.6711773,1.5934876,3.3652392,0.2593489,2.0136936,1.1935202,2.77061,2.5028576,3.5160919,0.348771,12.9070623),(37350,'metacarpal.tif',234,5,442,4.9242774,11.3842438,8.8801147,1.8,11.408952,8.891828,-0.648467,1.4361616,1.6603118,2.0285895,3.4183735,0.2993748,2.0588744,1.4125078,3.0482595,2.8991538,3.5160919,0.348771,13.632292),(37351,'metacarpal.tif',234,5,443,5.3086927,11.3873135,8.8813422,1.8,11.400687,8.8806327,-0.61694,1.4756346,1.668992,2.4856765,3.4580532,0.2961461,2.0719411,1.6844797,3.4068762,2.9775289,3.445609,0.2872815,11.0650911),(37352,'metacarpal.tif',234,5,444,5.6933493,11.3957381,8.8775457,1.8,11.4007514,8.8691365,-0.4288416,1.5537417,1.6771329,2.9515838,3.482389,0.1640674,2.0763942,1.8996618,3.7736751,3.0772621,3.3736539,0.293589,10.7904614),(37353,'metacarpal.tif',234,5,445,6.0445316,11.4054583,8.8661641,1.8,11.4026654,8.8525353,0.1010665,1.5743769,1.7580464,3.3064812,3.6839286,0.0102553,2.0954672,2.100184,3.9671187,3.1862232,3.4749477,1.6790669,10.8708986),(37354,'metacarpal.tif',234,5,446,6.3116081,11.4168045,8.8550491,1.8,11.4098815,8.8482375,0.4359909,1.6807981,1.75276,3.4516581,4.074865,0.187607,2.3248277,2.0535828,4.1452797,3.1862232,3.5519998,2.90687,11.127306),(37355,'metacarpal.tif',234,5,447,6.4788291,11.4343183,8.8351824,1.8,11.4242811,8.8329396,0.5912867,1.6778953,1.7055653,3.5511426,4.4755122,0.3355255,2.6240638,2.1164268,4.3187202,3.1862232,3.5804669,1.7393933,11.1895209),(37356,'metacarpal.tif',234,5,448,6.6343039,11.4544034,8.8124107,1.8,11.4386086,8.8178268,0.6419284,1.7005157,1.729244,3.643092,4.9897604,0.3963896,2.8855155,2.1423454,4.6686776,3.3386106,3.6545238,2.976444,11.6658911),(37357,'metacarpal.tif',234,5,449,6.7470999,11.4712448,8.7928164,1.8,11.4458868,8.8008747,0.6751297,1.7660021,1.7599461,3.6791099,5.3949635,0.4392623,3.0654141,2.0832987,4.9126963,3.4766725,3.7096664,1.1978086,11.885854),(37358,'metacarpal.tif',234,5,450,6.9316328,11.494853,8.7722013,1.8,11.4804674,8.7756323,0.6276591,1.8916735,1.7842298,3.9376454,5.6174612,0.3984124,3.1483955,2.0815672,5.0507015,3.5048455,3.8153462,0.1780929,12.2044763),(37359,'metacarpal.tif',234,5,451,7.0544383,11.5051524,8.7712104,1.8,11.4926925,8.7758175,0.4886273,1.9461832,1.7593066,4.2901574,5.5355276,0.2590739,3.1464257,2.2043954,4.9308219,3.5048455,3.8447974,0.2165503,12.5230986),(37360,'metacarpal.tif',234,5,452,7.1760756,11.4974537,8.7928741,1.8,11.4758365,8.7986605,0.0035318,1.5827084,1.8700478,4.6034017,5.5713269,0.0000149,2.9792431,2.9085596,5.1615957,3.5048455,3.833044,0.6043055,11.8236391),(37361,'metacarpal.tif',234,5,453,7.1861852,11.4943999,8.8189427,1.8,11.4734191,8.8141495,-0.2883546,1.68563,1.9120052,4.5270645,5.9209362,0.0968569,3.0967155,2.685681,5.3592635,3.4517418,3.833044,0.6043055,11.7174316),(37362,'metacarpal.tif',234,5,454,7.039564,11.4985847,8.8511307,1.8,11.4770667,8.830985,-0.3579456,1.7154465,1.8785606,4.4408353,6.0154773,0.1440127,3.2021737,2.5887343,5.2836378,3.4546001,3.8499282,0.3587707,11.7614242),(37363,'metacarpal.tif',234,5,455,6.7721662,11.5149903,8.8935172,1.8,11.5009736,8.8626212,-0.3494286,1.7323096,1.8611181,4.3931471,5.7299218,0.1322955,3.0787524,2.5360057,5.1650593,3.4546001,3.8153462,0.6316906,11.7871944),(37364,'metacarpal.tif',234,5,456,6.4665106,11.5239103,8.9359315,1.8,11.5050911,8.8969597,-0.2993515,1.7374195,1.8227247,4.3174683,5.268829,0.0937282,2.8906335,2.4849889,4.9507753,3.4546001,3.7714859,0.6156199,11.7432019),(37365,'metacarpal.tif',234,5,457,6.1397623,11.5326211,8.9678619,1.8,11.5157331,8.9207961,-0.1244773,1.6941154,1.7410549,4.2165732,4.756032,0.0157738,2.7316957,2.4889527,4.7991886,3.4064037,3.6867906,2.1531493,11.7796465),(37366,'metacarpal.tif',234,5,458,5.7979892,11.53396,8.9805057,1.8,11.5154626,8.9308169,0.3502558,1.6560635,1.7244745,3.9759036,4.3439082,0.1137795,2.518975,2.4008159,4.5685295,3.3570629,3.6951948,2.226492,12.0102837),(37367,'metacarpal.tif',234,5,459,5.5213133,11.5348073,8.9807369,1.8,11.5172928,8.9411231,0.6007108,1.7408706,1.7938657,3.6229141,4.1385702,0.2939951,2.307068,2.0810933,4.2746937,3.2293001,3.7308907,2.2706892,12.2924614),(37368,'metacarpal.tif',234,5,460,5.22188,11.5339393,8.9696965,1.8,11.5206534,8.9311186,0.6813603,1.7142027,1.810573,3.3057249,3.9476452,0.345263,2.1803292,1.9284329,4.005301,3.2293001,3.7286224,2.1699716,14.2739581),(37369,'metacarpal.tif',234,5,461,4.954275,11.5349485,8.9614696,1.8,11.5301453,8.9284211,0.7369183,1.6689577,1.8650598,3.0647903,3.7917672,0.3728885,2.033054,1.8363499,3.6763191,3.1655974,3.7308907,2.2706892,18.6693293),(37370,'metacarpal.tif',234,5,462,4.7088081,11.53766,8.954145,1.8,11.5402312,8.9290984,0.765375,1.6174207,1.9194074,2.8669633,3.6385018,0.3766907,1.8956381,1.7725526,3.3892889,3.1116986,3.735423,2.0974236,19.1381516),(37371,'metacarpal.tif',234,5,463,4.4737254,11.5382227,8.9512419,1.8,11.5392126,8.9386316,0.7736128,1.5662548,1.9222745,2.6795257,3.5274262,0.3640239,1.8350273,1.7107854,3.2234056,3.026912,3.7640013,2.070143,19.1199293),(37372,'metacarpal.tif',234,5,464,4.2947434,11.5487349,8.9509946,1.8,11.549534,8.9336514,0.7514329,1.5264602,1.9167934,2.5419048,3.4974597,0.3336019,1.8246409,1.6652283,3.1490692,2.5167849,3.0928073,1.0636978,12.9479284),(37373,'metacarpal.tif',234,5,465,4.2058378,11.5643993,8.967047,1.8,11.5631665,8.9461432,0.7404142,1.5226847,1.94564,2.4273127,3.5467103,0.3189965,1.8229016,1.5941006,3.0704046,2.4962814,3.0653315,1.0303768,12.2484688),(37374,'metacarpal.tif',234,5,466,4.2211155,11.5908086,8.9930872,1.8,11.5915484,8.9656327,0.72886,1.4715421,1.9143258,2.3653802,3.6387197,0.3120687,1.9007839,1.6074159,3.1341254,2.8722111,3.7550001,2.2142974,18.0063144),(37375,'metacarpal.tif',234,5,467,4.2815977,11.6226458,9.0286255,1.8,11.6246064,8.9955038,0.7022765,1.4354262,1.8683303,2.2961834,3.7419843,0.297757,2.0028494,1.5996528,3.2314719,2.8302257,3.7714859,2.1864162,17.7863516),(37376,'metacarpal.tif',234,5,468,4.3830764,11.6517336,9.0619431,1.8,11.6472189,9.0244671,0.6843897,1.4113235,1.8249435,2.2248496,3.8107381,0.2919692,2.0881403,1.5764278,3.3072701,2.7932126,3.7308907,2.4416998,11.8600837),(37377,'metacarpal.tif',234,5,469,4.4862308,11.6799324,9.0840593,1.8,11.6680517,9.0418476,0.6729705,1.3697059,1.8358298,2.1580487,3.893868,0.2904964,2.1210397,1.5755562,3.2936477,2.7570071,3.7286224,2.1699716,11.6036763),(37378,'metacarpal.tif',234,5,470,4.5674048,11.7000699,9.0983863,1.8,11.6797436,9.0539678,0.6613689,1.3186582,1.8101198,2.0728948,3.9310638,0.2871671,2.1717148,1.5719728,3.3118822,2.7518087,3.7286224,2.1699716,11.4534763),(37379,'metacarpal.tif',234,5,471,4.6229809,11.7149794,9.1094851,1.8,11.6930115,9.0683985,0.6559321,1.3189319,1.8046791,2.0170462,3.9219672,0.2866061,2.1732213,1.5293027,3.2908876,2.770379,3.7104265,2.1981045,11.3654911),(37380,'metacarpal.tif',234,5,472,4.6561702,11.71895,9.1136391,1.8,11.6912967,9.070314,0.6676165,1.3058682,1.883535,1.9543742,3.8677162,0.2974552,2.0534348,1.4966091,3.0883315,2.7169705,3.735423,2.0974236,11.3032763),(37381,'metacarpal.tif',234,5,473,4.6533435,11.7182135,9.1182545,1.8,11.6875844,9.0758792,0.6807986,1.2922282,1.886745,1.8765676,3.7907161,0.3072461,2.0091301,1.4521952,3.0023089,2.669685,3.7286224,2.1699716,11.3032763),(37382,'metacarpal.tif',234,5,474,4.6371283,11.7122793,9.119234,1.8,11.6765748,9.0752966,0.6989347,1.2613354,1.8744056,1.8073112,3.6661828,0.3199362,1.9559176,1.4328554,2.9126521,2.5686624,3.7104265,2.1981045,11.3290465),(37383,'metacarpal.tif',234,5,475,4.6298462,11.6955522,9.1150665,1.8,11.6438971,9.0634699,0.7228629,1.2444006,1.8617822,1.7574263,3.5545104,0.3376915,1.9091977,1.4122673,2.8342117,2.5550841,3.8153462,2.202487,11.9480688),(37384,'metacarpal.tif',234,5,476,4.5908873,11.6843678,9.1117194,1.8,11.6345791,9.0577197,0.7527973,1.2344924,1.8020679,1.7089957,3.3593926,0.3576471,1.8641876,1.3843712,2.8052753,2.5733719,3.7286224,2.1699716,12.1604837),(37385,'metacarpal.tif',234,5,477,4.5578532,11.6614802,9.1008362,1.8,11.6062414,9.0410977,0.7844549,1.2265342,1.7770248,1.6689053,3.1817921,0.3791046,1.7905164,1.3606675,2.7009111,2.5489786,3.6867906,2.1531493,11.2850539),(37386,'metacarpal.tif',234,5,478,4.4756747,11.6439527,9.0911435,1.8,11.5992256,9.0376162,0.8104945,1.2380397,1.7611779,1.6376961,2.8970172,0.3916855,1.6449316,1.3228139,2.5692925,2.5489786,3.5899057,2.2226654,11.4352539),(37387,'metacarpal.tif',234,5,479,4.3940793,11.6282916,9.0780518,1.8,11.5882467,9.0249671,0.8233053,1.3636549,1.6912129,1.6142608,2.6512172,0.3939078,1.5676425,1.1837751,2.5121921,2.5820402,3.3961479,2.1833339,11.4610242),(37388,'metacarpal.tif',234,5,480,4.3315904,11.6159131,9.0698615,1.8,11.5747101,9.0171206,0.8352606,1.3776021,1.6785146,1.6137702,2.4592698,0.3969035,1.4651465,1.1714342,2.4188648,2.5989308,3.3197259,2.2278713,11.5490093),(37389,'metacarpal.tif',234,5,481,4.238216,11.6103451,9.0657174,1.8,11.5718825,9.0130278,0.8435046,1.3860881,1.6665979,1.5984532,2.2685573,0.3941369,1.3611905,1.1532118,2.3201997,2.6095078,3.2501906,2.2744101,9.8603647),(37390,'metacarpal.tif',234,5,482,4.1440806,11.6080672,9.0690042,1.8,11.5699175,9.0228094,0.8363448,1.3837875,1.6224341,1.576692,2.1013893,0.380467,1.2952078,1.1394033,2.250826,2.6095078,3.1693624,2.204819,10.3474093),(37391,'metacarpal.tif',234,5,483,4.0734512,11.6082629,9.0727929,1.8,11.5662972,9.0265961,0.8178882,1.3699589,1.621489,1.561748,1.9768777,0.3614965,1.2191743,1.1399963,2.1615027,2.6358256,3.104638,2.1319597,10.4976093),(37392,'metacarpal.tif',234,5,484,4.0079061,11.6154957,9.0834512,1.8,11.5755847,9.0405663,0.8278596,1.3806646,1.6318922,1.5386957,1.8580051,0.3623217,1.1385587,1.1144602,2.0771348,2.6285,3.0873317,2.287338,10.5233795),(37393,'metacarpal.tif',234,5,485,3.9513342,11.6239503,9.0950861,1.8,11.5857905,9.0553819,0.783945,1.2921372,1.5871834,1.5119345,1.7757755,0.3283209,1.1188219,1.1701037,2.0266634,2.5890898,3.0496519,2.2339993,10.5233795),(37394,'metacarpal.tif',234,5,486,3.8919128,11.6310684,9.1058563,1.8,11.5903481,9.0650572,0.7307205,1.2986513,1.5904207,1.4899362,1.6960125,0.2889299,1.0663924,1.147295,1.9709049,2.5906649,3.0040001,2.2142974,10.329187),(37395,'metacarpal.tif',234,5,487,3.8488428,11.6413456,9.1206822,1.8,11.6023035,9.0838237,0.6418947,1.2883839,1.5677446,1.4647419,1.6212189,0.2299418,1.034109,1.1368831,1.8647109,2.5534,2.9595499,2.5183933,10.4353944),(37396,'metacarpal.tif',234,5,488,3.8076618,11.6511474,9.1334513,1.8,11.6123921,9.0949321,0.5695373,1.2832043,1.5496032,1.4478544,1.5653574,0.1845335,1.0101666,1.1283117,1.8305829,2.5348832,2.9908287,2.4629302,10.4353944),(37397,'metacarpal.tif',234,5,489,3.7616077,11.6652816,9.1494285,1.8,11.6333604,9.1096654,0.308492,1.2879454,1.5544701,1.4230094,1.5085231,0.0577949,0.970442,1.1048678,1.7861723,2.531464,2.9327488,2.4468544,10.3731795),(37398,'metacarpal.tif',234,5,490,3.722948,11.6755151,9.1620072,1.8,11.6430655,9.1154949,0.1154741,1.2899301,1.6150902,1.3973252,1.4927206,0.0082371,0.9242336,1.0832566,1.7794453,2.5827856,2.8852478,2.2455373,10.4096242),(37399,'metacarpal.tif',234,5,491,3.6803743,11.6851809,9.1773419,1.8,11.6475851,9.129521,0.0196404,1.3525266,1.6083868,1.3694634,1.4833962,0.0002366,0.9222882,1.0125224,1.7551721,2.5865128,2.854788,2.1879877,10.5598242),(37400,'metacarpal.tif',234,5,492,3.6393304,11.7000437,9.190047,1.8,11.6642627,9.1374624,-0.0645225,1.3589366,1.670924,1.3410139,1.4878405,0.0025217,0.8904298,0.9868113,1.6929811,2.531464,2.854788,2.1879877,10.3474093),(37401,'metacarpal.tif',234,5,493,3.599099,11.7134835,9.2043087,1.8,11.6777826,9.1488213,-0.0994957,1.3941339,1.6577776,1.3162254,1.4800756,0.0059186,0.8928071,0.944117,1.6860792,2.5396365,2.854788,2.1879877,10.5416019),(37402,'metacarpal.tif',234,5,494,3.5799088,11.7227249,9.2170527,1.8,11.6848288,9.155154,-0.1130775,1.4085929,1.6577066,1.2909806,1.473755,0.0075966,0.8890325,0.9165037,1.6677079,2.5344467,2.8269939,2.2621333,10.479387),(37403,'metacarpal.tif',234,5,495,3.5344785,11.7360927,9.2372375,1.8,11.7048846,9.179,-0.1679415,1.4127402,1.6464001,1.2431415,1.4492643,0.016459,0.8802625,0.8799506,1.6345548,2.5502265,2.838939,2.2248791,10.178987),(37404,'metacarpal.tif',234,5,496,3.5036995,11.7459649,9.2511826,1.8,11.7182401,9.1899644,-0.1742,1.4194929,1.6387448,1.222971,1.4447607,0.0175418,0.8816264,0.8615548,1.6272835,2.5272487,2.8119912,2.1662062,10.2851944),(37405,'metacarpal.tif',234,5,497,3.4678294,11.7533157,9.2627066,1.8,11.7242691,9.1953245,-0.1691668,1.4163084,1.6697438,1.2115385,1.4399041,0.0163829,0.8623503,0.85542,1.5691093,2.5303817,2.8119912,2.1662062,10.2851944),(37406,'metacarpal.tif',234,5,498,3.4283201,11.7666952,9.2779581,1.8,11.7401152,9.2089433,-0.1463321,1.4092822,1.6642191,1.1844467,1.4317543,0.0121481,0.860316,0.840461,1.5603292,2.525215,2.7948907,2.1066076,10.3034167),(37407,'metacarpal.tif',234,5,499,3.3554963,11.7857307,9.2986263,1.8,11.7649463,9.2341984,-0.163519,1.3797523,1.6572727,1.1266978,1.3963503,0.0148207,0.8425592,0.8165943,1.5173713,2.4783,2.7705692,2.1437625,10.178987),(37408,'metacarpal.tif',234,5,500,3.3126431,11.7980551,9.3111829,1.8,11.7712403,9.2404175,-0.1425137,1.3702626,1.6493301,1.1109815,1.3715811,0.0111377,0.8315989,0.81078,1.5031455,2.4783,2.7797147,2.2413179,10.1167721),(37409,'metacarpal.tif',234,5,501,3.273122,11.8116579,9.3263847,1.8,11.7806616,9.2538733,-0.1395929,1.3646411,1.6382194,1.0841287,1.3643367,0.0105612,0.8328168,0.7944424,1.4934365,2.4783,2.7573055,2.0831858,10.178987),(37410,'metacarpal.tif',234,5,502,3.222946,11.8281916,9.3407407,1.8,11.7955855,9.2679532,-0.1244241,1.3182866,1.6802624,1.0481206,1.3501489,0.0082731,0.8035345,0.7950628,1.4190555,2.4783,2.7695512,2.2794226,9.9043572),(37411,'metacarpal.tif',234,5,503,3.1849411,11.8500124,9.3530687,1.8,11.8229961,9.2778869,-0.1263165,1.3249937,1.6692831,1.0156005,1.3248198,0.0084248,0.793646,0.7664946,1.3997724,2.4740885,2.750137,2.1815223,9.7541572),(37412,'metacarpal.tif',234,5,504,3.1582928,11.8709673,9.3666003,1.8,11.8463978,9.292322,-0.1185387,1.2707213,1.6507661,0.9664035,1.321248,0.0073618,0.8003847,0.7605157,1.3846927,2.4783,2.7305848,2.1206495,9.5159721),(37413,'metacarpal.tif',234,5,505,3.1473779,11.8927852,9.3823729,1.8,11.8688812,9.3124964,-0.0972908,1.2663861,1.6316214,0.9266217,1.3082857,0.0049496,0.8018317,0.7317055,1.3696996,2.464266,3.005877,0.2267988,11.4792465),(37414,'metacarpal.tif',234,5,506,3.1061054,11.9129954,9.3947985,1.8,11.8868243,9.3255035,-0.0800158,1.2628278,1.6124585,0.8809612,1.2785192,0.0033074,0.7929006,0.6976099,1.339035,2.4598272,2.9927138,0.3058789,11.3912614),(37415,'metacarpal.tif',234,5,507,3.0554726,11.9335688,9.4097215,1.8,11.9038469,9.347268,-0.0566757,1.1932564,1.6581255,0.8405553,1.2575247,0.001634,0.7584014,0.7044214,1.2636192,2.4032,2.692102,2.0968627,9.4355349),(37416,'metacarpal.tif',234,5,508,3.0470009,11.9640165,9.416032,1.8,11.941778,9.3484872,-0.0334805,1.1802975,1.6316397,0.8260585,1.290142,0.000569,0.7907027,0.6998731,1.295405,2.464266,3.0236495,0.2510027,10.479387),(37417,'metacarpal.tif',234,5,509,2.9967866,11.9903308,9.4303669,1.8,11.9668925,9.3601189,-0.0218651,1.1131473,1.6767637,0.78762,1.2768744,0.0002387,0.7615112,0.7075614,1.2279162,2.4032,3.0431722,2.8666828,9.1533572),(37418,'metacarpal.tif',234,5,510,2.9412717,12.0137863,9.4513078,1.8,11.9880277,9.3841556,-0.0158861,1.1281547,1.6540258,0.7432578,1.2369279,0.0001237,0.7478286,0.6588261,1.1952821,2.4032,3.0236495,0.2510027,11.2046167),(37419,'metacarpal.tif',234,5,511,2.89957,12.0396464,9.4701855,1.8,12.0177396,9.4036661,-0.0168096,1.1456836,1.6284512,0.7017069,1.2272708,0.0001365,0.7536429,0.6124788,1.1834562,2.4598272,3.005877,0.2267988,11.2228391),(37420,'metacarpal.tif',234,5,512,2.8560338,12.0589426,9.4886595,1.8,12.0338959,9.4215331,0.00304,1.0761824,1.6096276,0.664871,1.2039764,0.0000044,0.7479844,0.6178051,1.1578702,2.4032,2.9927138,0.3058789,9.728387),(37421,'metacarpal.tif',234,5,513,2.8150117,12.084859,9.5065991,1.8,12.0635358,9.4388844,0.0290335,1.0798578,1.6608253,0.6332894,1.1868574,0.0003954,0.7146191,0.5864563,1.0952612,2.4032,3.005877,2.9147938,9.3217795),(37422,'metacarpal.tif',234,5,514,2.750377,12.1118494,9.5284325,1.8,12.0918438,9.4651495,0.0291264,1.0279636,1.6332159,0.5864304,1.1604878,0.0003888,0.7105539,0.5704778,1.069347,2.3993342,3.005877,0.2267988,9.1973498),(37423,'metacarpal.tif',234,5,515,2.6819854,12.1418476,9.5443742,1.8,12.1239497,9.4797813,0.0499705,1.0279599,1.6066227,0.5516977,1.1157473,0.0011152,0.6944675,0.5366919,1.0370512,2.4032,2.9927138,0.3058789,8.7907423),(37424,'metacarpal.tif',234,5,516,2.6124046,12.1699547,9.5628796,1.8,12.1481588,9.5061821,0.0648562,0.9747941,1.6530825,0.5139349,1.0945105,0.0018289,0.6621028,0.527224,0.9729405,2.3281,3.005877,0.2267988,8.8347349),(37425,'metacarpal.tif',234,5,517,2.527439,12.2010236,9.569995,1.8,12.1768038,9.5129948,0.0906641,0.9673017,1.6214089,0.4823991,1.0718012,0.0034531,0.6610308,0.498706,0.9583959,2.4032,2.9757043,0.1775962,8.8347349),(37426,'metacarpal.tif',234,5,518,2.410875,12.2324076,9.5841292,1.8,12.20663,9.5345381,0.1048927,0.9118997,1.5960036,0.4294712,1.0305452,0.0044047,0.6457035,0.4709632,0.91477,2.3281,2.9709621,0.2817719,8.7982903),(37427,'metacarpal.tif',234,5,519,2.324201,12.2565067,9.5975353,1.8,12.2253141,9.5474758,0.1065022,0.9140574,1.5786162,0.3955761,1.0027358,0.0043772,0.6351992,0.4327694,0.8848333,2.4032,2.9509618,0.2573237,8.9409423),(37428,'metacarpal.tif',234,5,520,2.2327256,12.284961,9.6238602,1.8,12.2555823,9.5780471,0.1055535,0.9104952,1.6221586,0.3555315,0.9499881,0.0041306,0.5856321,0.3904815,0.8045137,2.4325174,3.0208503,2.1794856,10.1349944),(37429,'metacarpal.tif',234,5,521,2.1438831,12.3068108,9.6456392,1.8,12.2728298,9.5939321,0.1172893,0.8760144,1.6070983,0.3199576,0.8986984,0.004893,0.5592056,0.3652424,0.757357,2.3884852,3.0413183,2.1451012,10.0985498),(37430,'metacarpal.tif',234,5,522,2.0579506,12.3312506,9.6800172,1.8,12.2973974,9.6332347,0.1093215,0.8535892,1.5865584,0.2843597,0.8487793,0.0040829,0.5349815,0.3331342,0.7116026,2.4015262,3.0964524,2.2531129,11.8236391),(37431,'metacarpal.tif',234,5,523,2.0036164,12.3569206,9.6968824,1.8,12.3269591,9.6407812,0.1274186,0.8499381,1.6261025,0.2661969,0.8153294,0.0053923,0.501401,0.3131957,0.6650915,2.3754442,3.0644114,2.1995926,11.8236391),(37432,'metacarpal.tif',234,5,524,1.9192147,12.3787095,9.7269379,1.8,12.3463037,9.6790247,0.1233985,0.813915,1.6099713,0.2339891,0.7854956,0.004846,0.4878942,0.2874859,0.6327368,2.3820571,3.0496519,2.2339993,11.5490093),(37433,'metacarpal.tif',234,5,525,1.8289396,12.4007403,9.7421763,1.8,12.3642427,9.6861966,0.1290094,0.8167189,1.5961568,0.2159782,0.7145667,0.0050452,0.4476795,0.2644462,0.581435,2.3754442,3.0644114,2.1995926,11.5672316),(37434,'metacarpal.tif',234,5,526,1.7195632,12.4174753,9.7738932,1.8,12.3723063,9.723089,0.1221777,0.7818244,1.6493858,0.1823364,0.6588935,0.0042569,0.3994781,0.2332191,0.5092827,2.3724683,3.0496519,2.2339993,11.8236391),(37435,'metacarpal.tif',234,5,527,1.6468029,12.4430045,9.7922833,1.8,12.3990574,9.7356052,0.1297511,0.7864942,1.6223196,0.1678201,0.6114243,0.0045949,0.3768828,0.2133774,0.47998,2.3281,2.9211873,0.3136207,11.0104242),(37436,'metacarpal.tif',234,5,528,1.5605846,12.46957,9.8175063,1.8,12.4265798,9.7638236,0.117283,0.7556861,1.6008772,0.1466809,0.5740193,0.0035613,0.3585655,0.1941029,0.4486081,2.3281,2.878398,2.8776289,10.8859944),(37437,'metacarpal.tif',234,5,529,1.4695465,12.4955979,9.8351464,1.8,12.4513052,9.7788107,0.1256549,0.7479263,1.5833264,0.1311809,0.5272716,0.0038468,0.3330151,0.1753929,0.4131622,2.3281,2.9163565,2.9340964,11.0544167),(37438,'metacarpal.tif',234,5,530,1.3843665,12.5152372,9.8528077,1.8,12.4637528,9.7936096,0.131164,0.7134804,1.5723437,0.1169771,0.488872,0.0039467,0.3109193,0.1639528,0.3811803,2.1779,2.5578139,2.4393357,7.9486307),(37439,'metacarpal.tif',234,5,531,1.2775958,12.5347763,9.87747,1.8,12.476346,9.8163154,0.1325065,0.6999923,1.5500279,0.0991122,0.4322901,0.0037168,0.2788918,0.1415904,0.3397806,2.253,2.5234047,2.2083451,7.966853),(37440,'metacarpal.tif',234,5,532,1.1685925,12.5515456,9.9068817,1.8,12.4854275,9.8450035,0.1254421,0.6724845,1.5282006,0.0822159,0.3764028,0.0030487,0.2463046,0.1222569,0.2977597,2.1779,2.5099584,2.2502101,7.7726605),(37441,'metacarpal.tif',234,5,533,1.0642099,12.5690683,9.9344288,1.8,12.4942444,9.8708124,0.1298354,0.6585478,1.5080881,0.0678607,0.3248489,0.0029732,0.2154045,0.103046,0.2589424,2.1779,2.5009541,2.2924512,7.7726605),(37442,'metacarpal.tif',234,5,534,0.9682771,12.5979711,9.9652209,1.8,12.5172609,9.9009805,0.1202537,0.6413557,1.4740943,0.0555209,0.2829095,0.0023225,0.1919209,0.086568,0.2284413,2.1028,2.4634632,2.226492,7.9486307),(37443,'metacarpal.tif',234,5,535,0.88042,12.6189151,9.9910306,1.8,12.5193656,9.9218548,0.1444187,0.6077513,1.4527926,0.0460435,0.2496588,0.0030392,0.1718475,0.0757605,0.2031553,2.1028,2.4369921,2.1587989,10.5051572),(37444,'metacarpal.tif',234,5,536,0.7978519,12.6424174,10.0155992,1.8,12.5338584,9.9442656,0.1547368,0.5819232,1.4266308,0.0386323,0.2215489,0.0031586,0.1552952,0.0663873,0.1822447,2.1028,2.4184066,2.2018757,10.2305275),(37445,'metacarpal.tif',234,5,537,0.7023576,12.6527342,10.0360892,1.8,12.5316422,9.961814,0.1545392,0.5726832,1.3043882,0.032037,0.1821051,0.0027735,0.1396096,0.0559419,0.1627035,2.1022101,2.4043732,2.2455373,10.2305275),(37446,'metacarpal.tif',234,5,538,0.6137457,12.6825296,10.0547063,1.8,12.575937,9.9831462,0.1512655,0.5238314,1.3695713,0.026189,0.1620342,0.0023227,0.1183102,0.0499952,0.1373478,2.0277,2.3949719,2.2896263,10.0621052),(37447,'metacarpal.tif',234,5,539,0.522164,12.6849707,10.0680213,1.8,12.5798591,10.0004785,0.1457531,0.4841228,1.3654662,0.0215274,0.1315987,0.0018358,0.0963764,0.0444668,0.1120566,2.0273416,2.3581879,2.2206668,10.2305275),(37448,'metacarpal.tif',234,5,540,0.4185706,12.6874009,10.0765941,1.8,12.5881683,10.0155239,0.1582312,0.458709,1.3609441,0.0163004,0.1013995,0.0017321,0.0745067,0.0355353,0.0863407,2.0277,2.3329402,2.1498706,7.666453),(37449,'metacarpal.tif',234,5,541,0.3289491,12.7069432,10.0788919,1.8,12.6335491,10.0304426,0.1435442,0.4063049,1.3530223,0.0125422,0.0871327,0.0011219,0.0643985,0.0308689,0.0736629,2.0183649,2.3329402,2.1498706,9.8861349),(37450,'metacarpal.tif',234,5,542,0.2381824,12.6613396,10.0739809,1.8,12.5983666,10.0374565,0.1368468,0.3456598,1.3987291,0.0083514,0.0585379,0.0007388,0.0418508,0.0241607,0.0478144,1.9526,2.2988453,2.2404353,9.97412),(37451,'metacarpal.tif',234,5,543,0.1729721,12.6230209,10.0647956,1.8,12.5926301,10.0461358,0.1004617,0.2911874,1.4359722,0.0050103,0.0376749,0.00029,0.0262365,0.0172063,0.0296793,1.8775,2.2927035,2.1224513,9.3990903),(37452,'metacarpal.tif',234,5,544,0.141172,12.5911624,10.0610508,1.8,12.5930844,10.0574712,0.0269707,0.2451025,1.4581487,0.0032037,0.0312381,0.0000171,0.0214231,0.0130709,0.0234255,1.9436107,2.2704558,2.167973,9.67372),(37453,'metacarpal.tif',234,5,545,0.118527,12.5827247,10.0814808,1.8,12.5913818,10.0807309,-0.0658292,0.2929955,1.2943052,0.001497,0.0203168,0.0000855,0.0156971,0.0051094,0.0164378,1.8760544,2.253,2.2142974,9.3111051),(37454,'metacarpal.tif',234,5,546,0.107558,12.6402029,10.1239181,1.8,12.6486223,10.1232256,-0.0586655,0.1543698,0.8004615,0.0009267,0.0174072,0.0000616,0.0217465,0.006003,0.0226991,1.8635054,2.2404484,2.2612428,10.5931424),(37455,'metacarpal.tif',234,5,547,0.1037879,12.7313426,10.1654356,1.8,12.7393318,10.1648511,0.0019929,0.1769068,0.7869018,0.0007905,0.0155629,0.0000000687,0.0197775,0.0044684,0.0205379,1.7981176,2.2087573,2.1870933,10.4429424),(37456,'metacarpal.tif',234,5,548,0.085952,12.8120354,10.2122769,1.8,12.8165343,10.2120023,0.0307295,0.1451153,0.7830441,0.0004315,0.0123583,0.0000135,0.0157824,0.0029735,0.016297,1.8024,2.1933829,2.2348425,10.8495498),(37457,'metacarpal.tif',234,5,549,0.0618525,12.853049,10.2426877,1.8,12.857562,10.2423149,0.0430628,0.1003866,0.6663156,0.0001837,0.0065322,0.0000191,0.0098035,0.0018301,0.0100758,1.7744073,2.1662152,2.1587989,10.3367349),(37458,'metacarpal.tif',234,5,550,0.0307322,12.8226263,10.2669592,1.8,12.8244296,10.2666119,0.0582327,0.0544019,0.4705424,0.0000458,0.0017983,0.0000173,0.0038217,0.0008424,0.0039188,1.7534919,2.1347431,2.2565258,10.6553572),(37459,'metacarpal.tif',234,5,551,0.0124531,12.7669049,10.2887002,1.8,12.7670002,10.2887002,0.021356,0.0048132,0.2253439,0.000006,0.0002796,0.0000009,0.0012409,0.001242,0.0012671,1.1506607,1.9583684,1.0040671,5.7729414),(37460,'metacarpal.tif',234,5,552,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37461,'metacarpal.tif',234,5,553,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37462,'metacarpal.tif',234,5,554,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37463,'metacarpal.tif',234,5,555,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37464,'metacarpal.tif',234,5,556,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37465,'metacarpal.tif',234,5,557,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37466,'metacarpal.tif',234,5,558,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37467,'metacarpal.tif',234,5,559,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37468,'metacarpal.tif',234,5,560,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37469,'metacarpal.tif',234,5,561,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37470,'metacarpal.tif',234,5,562,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37471,'metacarpal.tif',234,5,563,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37472,'metacarpal.tif',234,5,564,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37473,'metacarpal.tif',234,5,565,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37474,'metacarpal.tif',234,5,566,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37475,'metacarpal.tif',234,5,567,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37476,'metacarpal.tif',234,5,568,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37477,'metacarpal.tif',234,5,569,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37478,'metacarpal.tif',234,5,570,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37479,'metacarpal.tif',234,5,571,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37480,'metacarpal.tif',234,5,572,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37481,'metacarpal.tif',234,5,573,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37482,'metacarpal.tif',234,5,574,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37483,'metacarpal.tif',234,5,575,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37484,'metacarpal.tif',234,5,576,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37485,'metacarpal.tif',234,5,577,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37486,'metacarpal.tif',234,5,578,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37487,'metacarpal.tif',234,5,579,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37488,'metacarpal.tif',234,5,580,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37489,'metacarpal.tif',234,5,581,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37490,'metacarpal.tif',234,5,582,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37491,'metacarpal.tif',234,5,583,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37492,'metacarpal.tif',234,5,584,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37493,'metacarpal.tif',234,5,585,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37494,'metacarpal.tif',234,5,586,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37495,'metacarpal.tif',234,5,587,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37496,'metacarpal.tif',234,5,588,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37497,'metacarpal.tif',234,5,589,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37498,'metacarpal.tif',234,5,590,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37499,'metacarpal.tif',234,5,591,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37500,'metacarpal.tif',234,5,592,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37501,'metacarpal.tif',234,5,593,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37502,'metacarpal.tif',234,5,594,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37503,'metacarpal.tif',234,5,595,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37504,'metacarpal.tif',234,5,596,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37505,'femur.tif',234,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37506,'femur.tif',234,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37507,'femur.tif',234,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37508,'femur.tif',234,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37509,'femur.tif',234,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37510,'femur.tif',234,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37511,'femur.tif',234,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37512,'femur.tif',234,7,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37513,'femur.tif',234,7,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37514,'femur.tif',234,7,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37515,'femur.tif',234,7,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37516,'femur.tif',234,7,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37517,'femur.tif',234,7,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37518,'femur.tif',234,7,14,7.252903,21.4977341,21.6633655,1.8,21.489615,21.6631318,-0.7931975,1.1320184,2.4012163,2.203586,10.5479658,0.6138362,4.3927595,1.9465991,5.2828159,2.3365637,4.9143182,0.6771276,12.3395804),(37519,'femur.tif',234,7,15,13.8179577,20.7101343,22.1813823,1.8,20.7162772,22.1737006,-0.7871904,1.9221396,3.9086022,11.2358626,59.3971492,1.155624,15.1965194,5.8454976,17.9901439,3.6184841,7.828072,0.7107074,19.6358706),(37520,'femur.tif',234,7,16,15.999666,19.7881362,22.4789299,1.8,20.0012264,22.3914589,-0.6894227,2.3754371,4.9485792,24.0816139,94.3701386,1.078945,19.0701483,10.1377612,23.9357551,4.6216942,9.1953811,0.6696389,23.409093),(37521,'femur.tif',234,7,17,17.4535734,19.2819679,22.5351918,1.8,19.4899327,22.4590858,-0.6331899,2.7119043,5.4848526,38.2166145,125.3552606,1.0185084,22.8548093,14.0921692,29.8193409,5.2233777,10.1540645,0.6331464,26.2660195),(37522,'femur.tif',234,7,18,18.9165719,18.9356365,22.4974664,1.8,19.0970292,22.4218558,-0.5690253,3.1160499,5.8259669,53.9154306,163.4538266,0.9153021,28.0560855,17.3024928,37.2801141,5.8790263,11.0386784,0.5275847,28.3794939),(37523,'femur.tif',234,7,19,20.3695861,18.7488201,22.3602064,1.8,18.7846945,22.3420921,-0.5189672,3.6347807,5.8182506,79.4793945,192.5425816,0.8351521,33.0928652,21.866352,46.4838453,6.6843972,11.7370034,0.5151779,30.4565237),(37524,'femur.tif',234,7,20,22.2648831,18.6080785,22.4013381,1.8,18.675589,22.3543563,-0.3895857,4.0539607,6.1690086,108.1086314,231.1901205,0.5352922,37.4760576,26.6674101,54.999271,7.4901494,12.0171736,0.5307735,31.8598643),(37525,'femur.tif',234,7,21,26.6149876,18.7329353,22.9087427,1.8,18.7812552,22.8855806,-0.3026774,4.928608,6.4236949,181.0019354,293.7051943,0.394123,45.7221585,36.724758,73.8636766,8.9312618,12.0183469,0.3375595,34.6061618),(37526,'femur.tif',234,7,22,30.4937719,19.0747679,23.2648757,1.8,19.1407387,23.362408,-0.2075168,5.1176101,6.8758563,235.4827873,389.0277512,0.2157364,56.5788076,46.0142104,90.577513,9.8712381,13.3096612,0.1586553,37.5541999),(37527,'femur.tif',234,7,23,32.0311906,19.5087732,23.2186183,1.8,19.6647795,23.3423081,-0.1345298,5.2802293,7.3853236,245.4951818,503.5963547,0.0960367,68.1888005,46.4932805,101.4000443,10.2505302,14.4989689,0.25126,41.3349702),(37528,'femur.tif',234,7,24,36.2764385,20.2500203,23.2390278,1.8,20.3813025,23.3343034,-0.1256923,5.4701541,8.0912122,269.392451,664.1365161,0.0950172,82.081214,49.2476899,115.1974772,10.4873931,15.1936045,0.1139323,44.6789414),(37529,'femur.tif',234,7,25,45.2927948,22.5181875,23.4487878,1.8,22.2990438,23.457215,0.0411943,5.4624956,14.104721,346.6351061,1889.3594134,0.0128029,133.9522708,63.4572788,158.1877771,10.5809656,16.3657705,0.0919063,48.1988828),(37530,'femur.tif',234,7,26,64.6838722,26.2009769,23.884282,1.8,25.5693961,23.7823486,0.0726819,5.6589276,14.0728045,430.7090323,3961.8707473,0.0568501,281.5267379,76.1114227,311.032903,10.602795,18.0640092,0.0665682,53.0266316),(37531,'femur.tif',234,7,27,78.8153685,27.6164811,23.9744794,1.8,27.1229462,23.8891473,0.0717545,6.1182709,15.5777496,565.7166126,4760.6584479,0.0675169,305.6063011,92.4634796,340.780873,11.0704487,27.0027065,3.0859399,173.3614009),(37532,'femur.tif',234,7,28,85.8477626,28.2867317,23.9657237,1.8,27.8111743,23.8543233,0.0756828,6.4405832,16.3802708,741.6801471,5289.1649854,0.0817979,322.898506,115.1572964,366.5277074,11.7400502,27.5675319,3.0351472,133.4768902),(37533,'femur.tif',234,7,29,87.0844843,28.593849,24.0292355,1.8,28.2335846,23.893539,0.0731664,6.7960364,16.8693593,861.5037361,5441.6407503,0.0775599,322.5754254,126.7656156,371.4959335,12.2806563,28.1717112,3.0642074,199.2892808),(37534,'femur.tif',234,7,30,88.4814851,28.8322985,24.0706806,1.8,28.4690156,23.9147875,0.0703374,7.119949,17.2058097,940.1606148,5665.3322063,0.0728381,329.2685607,132.0459756,381.4509236,12.7088222,28.6209839,3.0654245,208.1026669),(37535,'femur.tif',234,7,31,89.8228661,28.950128,24.062448,1.8,28.6234189,23.8830079,0.0720617,7.3992835,17.4321327,983.8308113,5881.5252961,0.0776054,337.3956242,132.9629838,390.7619995,13.1124393,29.000369,3.113103,187.4323236),(37536,'femur.tif',234,7,32,88.9117352,28.9980073,24.09104,1.8,28.7401419,23.9108854,0.0640358,7.6211179,17.5630183,977.3503621,5910.9194375,0.0606819,336.5548754,128.2423879,389.3846337,13.3757556,29.0754386,0.0284161,161.6653181),(37537,'femur.tif',234,7,33,87.0368706,28.7568158,24.0499681,1.8,28.5194013,23.8747134,0.058215,7.8467618,17.2608504,962.5354833,5833.7885627,0.0491056,337.9780497,122.6665858,390.4811547,13.6323436,28.8736798,0.0494388,156.0683469),(37538,'femur.tif',234,7,34,83.2459867,28.3511581,24.0741308,1.8,28.1702909,23.8882247,0.0590466,8.2114217,16.780778,924.6177393,5650.2937163,0.0483168,336.712262,112.6014197,387.8432978,13.8192869,28.581545,0.055207,153.0065534),(37539,'femur.tif',234,7,35,76.441783,27.4688226,23.604416,1.8,27.3983457,23.4280162,0.0046651,7.9899181,15.8967001,819.5192283,5162.3550938,0.0002771,324.7438193,102.5691656,372.493436,13.8085083,28.1986254,0.0506234,196.5354353),(37540,'femur.tif',234,7,36,66.0271761,25.4561872,23.1314286,1.8,25.4138628,22.9711373,-0.0838083,7.5067733,13.9934623,719.7490642,3847.2978022,0.0771133,274.9353751,95.8799519,324.4190616,12.1350037,25.0385026,0.1626832,82.7352818),(37541,'femur.tif',234,7,37,61.379925,24.1554453,22.9682034,1.8,24.1064955,22.8072591,-0.1915697,6.839673,12.7294039,723.2261562,2970.7561874,0.3708596,233.3774789,105.7398738,290.1135164,11.9961953,23.2853606,0.1619674,80.2925107),(37542,'femur.tif',234,7,38,61.52934,23.8359821,22.8383298,1.8,23.8721338,22.6626897,-0.2487379,6.3623722,12.3023854,762.4694243,2890.3091197,0.6214978,234.9389193,119.8404305,296.8814202,11.964007,22.5984876,0.5141997,79.2819768),(37543,'femur.tif',234,7,39,62.8840105,23.6745538,22.7999658,1.8,23.7757677,22.6132444,-0.2935874,6.07309,12.0161019,800.583381,2896.4046211,0.8777078,241.0436132,131.8247183,307.35798,11.9977829,22.7662034,0.513827,78.0332577),(37544,'femur.tif',234,7,40,63.322302,23.3648543,22.7965854,1.8,23.5075286,22.5886738,-0.3288169,6.0593163,11.6524234,811.6461198,2922.1318775,1.1005378,250.7746043,133.9501161,318.385685,12.0289811,22.9339223,0.5134597,76.9089684),(37545,'femur.tif',234,7,41,64.1884051,22.9987685,22.8823231,1.8,23.2655094,22.6481839,-0.3265915,6.0244104,11.256385,812.3367886,2889.8452123,1.1010804,256.7294227,134.8408779,306.9952082,11.9502745,22.9428968,0.5207701,75.7771312),(37546,'femur.tif',234,7,42,62.9983462,22.8906022,22.9933942,1.8,23.135692,22.762692,-0.343402,6.0353633,11.2448735,800.6180516,2743.0280055,1.1902674,243.9358712,132.6544927,296.2372528,11.8326823,22.64511,0.5244937,75.0807982),(37547,'femur.tif',234,7,43,61.6625532,22.6829775,23.1223534,1.8,22.9406308,22.8559441,-0.3449432,6.0166887,11.3519897,792.5022851,2596.5422354,1.1750914,228.7301441,131.7173494,286.1518793,11.8427248,22.309125,0.4907494,77.4355842),(37548,'femur.tif',234,7,44,64.8300201,22.4747725,23.1035389,1.8,22.6807579,22.8569112,-0.3628722,6.1191944,11.4715132,824.6691391,2617.8393858,1.3614006,228.2034929,134.7675987,290.1677362,11.8429311,21.9930197,0.5140636,78.0621544),(37549,'femur.tif',234,7,45,64.2008424,22.4406115,23.1915482,1.8,22.6967031,22.9372217,-0.3768044,6.0976112,11.4756005,834.2663039,2446.6767794,1.4486698,213.2068626,136.8185469,277.1268143,11.8742422,21.7694165,0.523853,73.443694),(37550,'femur.tif',234,7,46,67.8295452,22.1571702,23.0541418,1.8,22.4212506,22.7840443,-0.3871387,6.3871989,11.5865236,883.7076365,2271.2198694,1.6113674,196.0225469,138.3560542,265.5861577,11.8756604,21.4461463,0.5530314,57.9178904),(37551,'femur.tif',234,7,47,65.2196527,22.3154969,23.3558649,1.8,22.5796946,23.0414495,-0.4119907,6.1565113,11.4835998,843.0389776,2143.4822418,1.7429688,186.6559516,136.9345297,254.1248548,11.8666871,21.0613666,0.5226844,56.7238383),(37552,'femur.tif',234,7,48,60.5284785,22.5192876,23.5763952,1.8,22.7876812,23.2268503,-0.4688691,6.223262,11.3367591,800.4097836,2009.2629436,2.0599203,177.2343339,128.6157932,243.764374,11.8742422,20.614369,0.5141755,55.7604234),(37553,'femur.tif',234,7,49,58.732096,22.4022929,23.8609169,1.8,22.7356277,23.4720861,-0.4814417,6.2988195,11.3252433,771.8554153,1853.0558258,2.0989113,163.6217239,122.5396937,228.4489276,11.8265479,19.9547077,0.4855296,54.7347936),(37554,'femur.tif',234,7,50,56.6910878,22.5449214,23.9867906,1.8,22.8171985,23.615495,-0.5141449,6.4083325,10.8740947,742.4790452,1689.6101042,2.2851975,155.3793812,115.8615046,221.3670037,11.7468127,19.3462326,0.6504886,53.1856746),(37555,'femur.tif',234,7,51,55.4469493,22.4335328,24.2195718,1.8,22.6777886,23.8642935,-0.514015,6.3512303,10.5083415,715.2355972,1537.2614317,2.2340187,146.2896336,112.6137081,211.8724906,11.6871827,18.7196451,0.6659692,51.6107853),(37556,'femur.tif',234,7,52,54.4232739,22.3127984,24.5055422,1.8,22.4855668,24.206579,-0.5161479,6.3132429,10.10655,690.4601261,1375.8350676,2.2093614,136.1330099,109.3669508,202.1042524,11.5964305,18.0279113,0.6643314,49.7612662),(37557,'femur.tif',234,7,53,54.2167534,22.2029065,24.6768577,1.8,22.3270843,24.4226972,-0.5014293,6.1684117,9.571168,664.2958585,1294.3904665,2.0878212,135.2385073,107.6931783,202.7467925,11.5352559,17.2730003,0.6435011,47.7539993),(37558,'femur.tif',234,7,54,53.1399148,22.0844835,24.8955352,1.8,22.2223401,24.6866989,-0.4951063,6.0909443,9.1390686,651.0608566,1170.9939481,1.9993359,128.1305565,106.8899699,198.8590945,11.488245,16.5390597,0.5980778,46.1457918),(37559,'femur.tif',234,7,55,53.2399953,21.9988258,25.1296599,1.8,22.1011666,24.9535026,-0.5076794,6.078685,8.5985691,636.9979984,1080.2814345,2.0971451,125.6350238,104.7920732,198.9218844,11.4216369,15.8024394,0.6301939,44.7575471),(37560,'femur.tif',234,7,56,52.0137756,21.6913277,25.3679594,1.8,21.7563943,25.2075185,-0.5042281,5.9276625,7.812501,624.3303888,939.6555934,2.0234772,120.2759011,105.3248879,198.3223688,11.3626184,14.7215159,0.6914724,42.5636355),(37561,'femur.tif',234,7,57,51.4928549,21.5551828,25.6018727,1.8,21.6178924,25.4619739,-0.5184979,5.8991628,7.4185207,615.495395,851.6672496,2.1077364,114.8028414,104.336059,195.2669997,11.2909279,14.1511202,0.7253202,41.6184429),(37562,'femur.tif',234,7,58,53.4299649,21.3767025,25.7564577,1.8,21.4385593,25.6188872,-0.5312441,5.7825945,7.1719901,606.6384577,808.8349983,2.2854667,112.7769266,104.9076601,194.7299041,11.2674164,13.7209162,0.8396086,40.7430132),(37563,'femur.tif',234,7,59,50.7330079,21.4973533,25.9381633,1.8,21.6089821,25.8042778,-0.5740953,5.87186,6.8871767,594.1255928,770.3656696,2.4937877,111.855075,101.1818391,196.7029352,11.2339125,13.4162322,0.8567056,40.204428),(37564,'femur.tif',234,7,60,49.1471305,21.4600641,26.1165864,1.8,21.542186,25.994522,-0.5999628,5.8625547,6.6792825,570.8438066,729.0928315,2.6112403,109.1573588,97.371169,193.6030906,11.1847692,13.1255381,0.8826514,39.603628),(37565,'femur.tif',234,7,61,47.5767667,21.4575551,26.323404,1.8,21.5302321,26.2287283,-0.6711203,5.937921,6.5476825,553.7972267,682.2303762,3.0664373,104.1941755,93.2644996,187.9764539,11.1837589,12.9040947,0.8760581,39.0908131),(37566,'femur.tif',234,7,62,47.7116618,21.4977596,26.4221046,1.8,21.5779972,26.3134129,-0.7560445,5.9424365,6.3046066,543.876521,662.3232605,3.7426875,105.053861,91.5241616,190.8790189,11.117941,12.6927889,0.9154615,38.5779983),(37567,'femur.tif',234,7,63,47.389667,21.4926669,26.595137,1.8,21.5581343,26.522472,-0.7968165,5.9200891,6.2116799,533.9296368,641.9370884,4.0393166,103.3435559,90.1894599,188.1502905,11.1035885,12.5027406,0.8960554,38.2336057),(37568,'femur.tif',234,7,64,47.4096799,21.468184,26.7612021,1.8,21.5233653,26.6871944,-0.8597777,5.8893204,6.1055984,527.3516492,625.1219141,4.5363599,102.3850357,89.5437193,186.2390216,11.0824142,12.3315025,0.9236412,37.7830057),(37569,'femur.tif',234,7,65,47.9239138,21.4516664,26.87029,1.8,21.5029219,26.8086043,-0.9575943,5.8196109,6.1184392,521.3087486,613.2618287,5.3420172,100.2317439,89.5779384,184.2251345,11.0397002,12.166432,0.9211225,37.5448206),(37570,'femur.tif',234,7,66,48.2996494,21.4817889,27.0085539,1.8,21.5588893,26.9623686,-0.9933869,5.796667,6.1102129,513.5941885,604.9066542,5.6513978,98.9992763,88.6016381,182.2039329,10.8895002,12.0406172,0.967224,37.350628),(37571,'femur.tif',234,7,67,47.6484963,21.4555111,27.1496729,1.8,21.5240506,27.1053491,-1.0629299,5.7031721,6.0676359,500.385985,590.3773774,6.0632598,97.2994075,87.7381876,179.0535185,10.8144002,11.9409002,1.014197,37.0062354),(37572,'femur.tif',234,7,68,46.9541146,21.4131282,27.2507377,1.8,21.4582713,27.2170634,-1.1512102,5.5407585,6.0521276,481.2920808,584.8814545,6.5269311,96.6406354,86.8639333,175.6387754,10.6642002,11.8374851,1.016232,36.7680503),(37573,'femur.tif',234,7,69,46.924607,21.4129547,27.3681524,1.8,21.4713926,27.3153347,-1.196543,5.4700256,6.0277089,466.6201737,580.5902768,6.7755456,96.3202255,85.3049345,173.3883803,10.5891002,11.7741858,1.0500679,36.5738577),(37574,'femur.tif',234,7,70,46.8003426,21.4650054,27.4927477,1.8,21.511487,27.4445412,-1.1867168,5.4723251,6.0126229,455.5081068,576.9787852,6.7048941,95.9612455,83.2384951,171.355971,10.5140002,11.7598065,1.0785851,36.4236577),(37575,'femur.tif',234,7,71,46.2860194,21.5200493,27.6579043,1.8,21.5592152,27.62289,-1.1774858,5.4931493,5.947156,446.9175116,565.4344483,6.581261,95.0764443,81.3590684,169.641522,10.4326276,11.7468502,1.0413413,36.2552354),(37576,'femur.tif',234,7,72,45.8328377,21.5311537,27.8129854,1.8,21.5819251,27.7775176,-1.2000705,5.4361411,5.8820875,439.6092272,552.9897089,6.6361707,94.0124925,80.8678834,168.0039565,10.3638002,11.6286235,0.9505468,36.0868131),(37577,'femur.tif',234,7,73,45.2272852,21.5207234,27.9634318,1.8,21.5621337,27.9191724,-1.2530219,5.3432798,5.8080468,425.4718632,537.6301558,6.8019803,92.5664293,79.6274723,165.5978461,10.2887002,11.4959436,1.0662359,35.848628),(37578,'femur.tif',234,7,74,45.2411728,21.5461724,28.0706595,1.8,21.5617797,28.0299989,-1.2770532,5.2975905,5.7898321,417.9019597,529.2419388,6.9080882,91.4088583,78.8852891,163.5570875,10.2732592,11.4016049,1.0541012,35.6104428),(37579,'femur.tif',234,7,75,45.6458489,21.5971995,28.1820795,1.8,21.606679,28.1473073,-1.2810063,5.2831981,5.7700034,414.5830955,522.4189673,6.9864498,90.5404955,78.4719945,162.3349334,10.1941998,11.308973,1.0417659,35.4602428),(37580,'femur.tif',234,7,76,45.594262,21.5998854,28.3025509,1.8,21.6312435,28.2270991,-1.3321126,5.2156145,5.7224713,409.2061961,513.5659162,7.1742856,89.7454764,78.4579072,161.0232974,10.1487985,11.2419459,1.172922,35.3540354),(37581,'femur.tif',234,7,77,44.9750884,21.5887894,28.4504325,1.8,21.6158612,28.4005192,-1.3676959,5.1743903,5.6464251,401.1300497,503.193132,7.1908742,89.1171174,77.5221862,159.8073596,10.1197184,11.1858672,1.4089589,35.0536354),(37582,'femur.tif',234,7,78,45.1071213,21.5985913,28.5383231,1.8,21.6080721,28.4815931,-1.380148,5.1243997,5.635672,395.9760303,501.213821,7.2478983,88.9359456,77.2726661,158.9374254,10.1047459,11.1644178,1.2277724,34.947428),(37583,'femur.tif',234,7,79,45.5546769,21.6471612,28.6183267,1.8,21.6549735,28.5642574,-1.352564,5.1345056,5.6438125,394.9043623,501.5141181,7.2365573,88.8608754,76.9118569,158.2670698,10.0634002,11.1333061,1.1614759,34.797228),(37584,'femur.tif',234,7,80,45.2815338,21.6643408,28.7390344,1.8,21.6727381,28.6853062,-1.3702158,5.127843,5.5840196,394.9213335,492.8653889,7.2473406,88.2635494,77.0150979,158.5304951,10.0634002,11.0868563,1.1890321,34.7092428),(37585,'femur.tif',234,7,81,45.0816881,21.7129197,28.8641393,1.8,21.7353824,28.8358097,-1.3742081,5.1686889,5.5292488,394.4744273,483.6261073,7.2269581,87.4668732,76.3200174,157.9025105,9.9883002,11.0317786,1.2016675,34.6288056),(37586,'femur.tif',234,7,82,46.2212655,21.7497766,28.9000894,1.8,21.7607792,28.819509,-1.3441046,5.1752991,5.5791821,400.9366146,487.7315751,7.3144007,87.4199059,77.4711964,159.0753543,9.9883002,10.9956764,1.1560394,34.5225982),(37587,'femur.tif',234,7,83,46.6957576,21.7964475,28.9869515,1.8,21.8419013,28.918245,-1.3064248,5.212903,5.5650976,405.9494039,484.6886397,7.2512357,87.0943648,77.8739608,159.9853542,9.9883002,10.9525055,1.2208537,34.4346131),(37588,'femur.tif',234,7,84,46.7051333,21.8140019,29.0850217,1.8,21.8557277,29.0368374,-1.3280061,5.2114273,5.5432649,406.4627778,480.2691077,7.3342792,86.6401149,77.9945206,159.96442,10.0634002,10.9091638,1.0362799,34.4968279),(37589,'femur.tif',234,7,85,46.4104069,21.8248131,29.1973285,1.8,21.8638771,29.162804,-1.3442446,5.1970764,5.4921883,405.3021852,474.5279106,7.3448059,86.4005173,77.9865744,160.0848157,10.0601189,10.8918306,1.1966919,34.5408205),(37590,'femur.tif',234,7,86,45.8991056,21.8081831,29.2751014,1.8,21.8353212,29.23222,-1.3723059,5.1512897,5.4689211,404.7255452,469.0515114,7.3523961,85.7667361,78.5678094,159.7547887,10.0634002,10.9021821,1.6190347,34.7714577),(37591,'femur.tif',234,7,87,46.388854,21.7928715,29.3028576,1.8,21.8201104,29.2681468,-1.4273877,5.1237514,5.479491,407.3909185,477.0226825,7.573557,87.0560207,79.5102821,159.9179318,10.0634002,11.0488923,1.61159,34.7274651),(37592,'femur.tif',234,7,88,46.5323513,21.7927889,29.332434,1.8,21.8080116,29.306851,-1.4337474,5.1092898,5.512875,406.2208016,481.0247455,7.6106367,87.2547889,79.5063145,159.3298449,10.0547758,11.0827858,1.6590022,34.7274651),(37593,'femur.tif',234,7,89,46.8993565,21.8172675,29.3551336,1.8,21.8359302,29.3300973,-1.4027377,5.0975334,5.558484,405.1120254,488.2533614,7.5978614,87.8393029,79.4721669,160.7096087,10.0537994,11.0970258,1.6724852,34.8336726),(37594,'femur.tif',234,7,90,47.0093085,21.8437556,29.4048374,1.8,21.8657784,29.3730332,-1.390946,5.0887094,5.5668879,406.1888174,493.7923242,7.5841773,88.7016833,79.8215787,161.3038978,10.0547758,11.1454576,1.6449842,34.9656503),(37595,'femur.tif',234,7,91,47.0413797,21.8604363,29.496199,1.8,21.8821104,29.4714915,-1.3766097,5.086001,5.5419345,407.269805,491.2143211,7.5482845,88.6358945,80.0766267,161.4343095,10.0669354,11.1150539,1.0315356,34.9216577),(37596,'femur.tif',234,7,92,46.8465923,21.8712092,29.5975993,1.8,21.8996163,29.5952268,-1.3819301,5.1015657,5.5036024,409.0690638,482.5718554,7.5325546,87.6829066,80.185004,161.0632456,10.078961,11.0256419,1.0186951,34.7532354),(37597,'femur.tif',234,7,93,46.9380051,21.8649077,29.6899141,1.8,21.9007742,29.6838028,-1.4183969,5.1077544,5.4692627,411.9214988,475.0600989,7.6427093,86.8599884,80.6463009,159.3497232,10.0634002,10.9925983,1.7078625,34.7350131),(37598,'femur.tif',234,7,94,46.6460183,21.8313637,29.7505575,1.8,21.8618224,29.7275802,-1.4858217,5.0985188,5.4513299,410.2182973,470.6967382,7.7183353,86.3453047,80.4583282,156.7931387,10.0634002,11.0631759,1.7482212,34.7092428),(37599,'femur.tif',234,7,95,45.9225635,21.7848693,29.8235191,1.8,21.8058759,29.7897008,1.5703666,5.0380166,5.4916694,402.5751659,465.3358418,7.6537592,84.7348614,79.9074712,153.914527,10.0634002,11.0631759,1.7482212,34.7532354),(37600,'femur.tif',234,7,96,46.2814329,21.8096268,29.8897946,1.8,21.869805,29.8430395,1.5252057,5.1015614,5.5430242,402.6632536,464.5432182,7.6975506,83.8068171,78.9294146,152.8727019,10.0540197,11.0782048,1.7894653,34.7532354),(37601,'femur.tif',234,7,97,45.642218,21.7895768,29.9805604,1.8,21.8339279,29.9388028,1.4912486,5.0907323,5.6636963,397.3851894,458.4635745,7.5590017,80.9477686,78.0605161,149.176239,10.0348202,11.1117552,1.7337228,34.9656503),(37602,'femur.tif',234,7,98,45.1082153,21.7790986,30.0315727,1.8,21.8100427,29.9826974,1.4847181,5.0978274,5.7620144,394.2190092,456.5033102,7.4624687,79.2263402,77.3307879,147.1276117,10.0091345,11.1517812,1.7126934,35.247828),(37603,'femur.tif',234,7,99,45.7190995,21.8098081,29.9865533,1.8,21.8386112,29.9401363,1.5175701,5.1141175,5.7507461,392.2226363,476.7102616,7.598283,82.8953763,76.6940998,150.9555359,9.9834488,11.2261315,1.6511598,35.7091024),(37604,'femur.tif',234,7,100,46.3068702,21.856934,29.957958,1.8,21.890591,29.9322317,1.5686639,5.1121992,5.5523727,393.9729248,493.7737691,7.7177766,88.9302277,77.0652531,157.8609775,9.9842263,11.1517812,1.7126934,34.7714577),(37605,'femur.tif',234,7,101,45.733679,21.8801395,30.033708,1.8,21.9144537,30.0159486,-1.5644965,5.1322246,5.4795198,391.4465686,489.2278546,7.6219774,89.2829792,76.2722986,158.1958856,9.9842263,11.0501684,1.7415315,34.7274651),(37606,'femur.tif',234,7,102,44.92258,21.8947202,30.1471777,1.8,21.931592,30.1361964,1.5642181,5.1545078,5.5179833,388.2158459,478.5721287,7.4867727,86.7295348,75.3157938,155.8106862,9.9683188,11.0031113,1.4269688,34.6652503),(37607,'femur.tif',234,7,103,43.8109678,21.9043421,30.2563641,1.8,21.9242185,30.2462755,-1.5548201,5.1550412,5.4742621,385.2923956,460.0141069,7.2999645,84.0321668,74.7408955,150.6219941,9.9889734,10.915366,1.7857339,34.5150503),(37608,'femur.tif',234,7,104,42.827173,21.8941043,30.3843587,1.8,21.9169592,30.3758411,1.545845,5.1684627,5.5461463,384.6543894,445.4672983,7.1334193,80.3201496,74.4233655,146.6880429,10.0140423,10.8835423,1.8576266,34.4528354),(37609,'femur.tif',234,7,105,42.1246415,21.876403,30.4825469,1.8,21.8999474,30.4717682,1.46699,5.1957094,5.6229493,383.6588111,434.9021921,6.9453908,77.344142,73.8414688,144.0493014,10.027882,10.8625344,1.8509953,34.3906205),(37610,'femur.tif',234,7,106,41.7526999,21.8800311,30.5327497,1.8,21.9026106,30.5140125,1.4428723,5.1833836,5.6167492,384.2710882,426.5394277,6.8455258,75.9406217,74.1351829,142.668793,10.0475079,10.8498061,1.9538734,34.3723982),(37611,'femur.tif',234,7,107,41.5946542,21.8941432,30.5777972,1.8,21.9229961,30.559987,1.3795141,5.2196645,5.6421814,385.131009,422.4445627,6.6818706,74.8725601,73.784629,141.9748501,10.0560656,10.8375833,1.9693188,34.3723982),(37612,'femur.tif',234,7,108,41.221163,21.8888359,30.6199806,1.8,21.9169435,30.6063451,1.3617919,5.225397,5.6458963,383.5861177,418.2691374,6.5744287,74.0837445,73.4080333,141.0603848,10.0605059,10.8524049,2.0065874,34.3101833),(37613,'femur.tif',234,7,109,40.9810686,21.8909695,30.6535428,1.8,21.9091995,30.6314177,1.3549557,5.2216618,5.6398434,383.5358351,415.9517591,6.5168901,73.75236,73.4509149,141.2587729,10.0685944,10.8344604,2.1338041,34.3541759),(37614,'femur.tif',234,7,110,41.0228118,21.8990108,30.683958,1.8,21.9213843,30.6579205,1.3475847,5.223728,5.634207,384.9832606,416.0854933,6.5021057,73.8498763,73.698949,141.2724286,10.1046863,10.8446066,2.1088405,34.2479684),(37615,'femur.tif',234,7,111,41.0655113,21.9105804,30.7116608,1.8,21.938002,30.6777916,1.3748167,5.2255892,5.6328028,386.9491891,417.216565,6.5847261,74.0690882,74.0489108,141.5969521,10.1281572,10.8583799,2.1242637,34.3359536),(37616,'femur.tif',234,7,112,41.1091709,21.9267702,30.7322348,1.8,21.959588,30.7000713,1.4165102,5.225883,5.6126388,388.338372,419.049568,6.6897233,74.6617741,74.3105755,141.7771476,10.1385002,10.8936428,2.1549749,34.442161),(37617,'femur.tif',234,7,113,41.0988595,21.9521109,30.7368177,1.8,21.9867702,30.6897451,1.4820137,5.2075345,5.5767972,388.7343575,421.5718395,6.795959,75.593898,74.6484466,142.0084446,10.1385002,10.9223393,2.1206495,34.442161),(37618,'femur.tif',234,7,114,41.0112728,21.9522968,30.7573538,1.8,21.9711542,30.7229993,1.4720401,5.2118825,5.587971,390.5788236,424.371081,6.7687661,75.9436803,74.9400674,142.366218,10.2136002,10.956367,2.1511945,34.5483684),(37619,'femur.tif',234,7,115,40.7037026,21.955302,30.7857081,1.8,21.961977,30.7543158,1.4424658,5.2259275,5.6059047,391.2151331,422.5669468,6.6728394,75.3789033,74.8604205,141.506368,10.2136002,10.9784798,2.1417228,34.592361),(37620,'femur.tif',234,7,116,40.5759405,21.9705283,30.803993,1.8,21.9773092,30.7586492,1.4125659,5.2474388,5.6224929,393.1456024,421.6643039,6.5947494,74.9959689,74.9214273,141.8755579,10.2136002,10.9977279,2.156905,34.5741387),(37621,'femur.tif',234,7,117,40.3051478,21.983559,30.8226973,1.8,21.9877757,30.783314,1.3748737,5.2609252,5.6530051,394.6086293,421.4599369,6.4629505,74.5550245,75.0074589,141.5363201,10.2887002,11.0195018,2.1720307,34.6363536),(37622,'femur.tif',234,7,118,40.4288077,21.9986746,30.8309564,1.8,21.9936252,30.7973404,1.3517398,5.2969861,5.6911197,399.3093095,425.6140603,6.419939,74.7856452,75.3842467,142.7133966,10.2887002,11.0621563,2.1776291,34.7683313),(37623,'femur.tif',234,7,119,40.7179947,22.0170278,30.8377369,1.8,22.0113621,30.813442,1.4081032,5.3009268,5.6648803,405.2311794,430.5387258,6.608284,76.0013808,76.4453456,144.2213877,10.3542749,11.0815135,2.1681971,34.9367536),(37624,'femur.tif',234,7,120,40.8814113,22.0241025,30.8245523,1.8,22.0202192,30.7953998,1.4228775,5.3170463,5.6577652,411.7570645,432.7978208,6.6655719,76.4962504,77.4409399,145.9421502,10.3638002,11.087365,2.1926206,34.9807461),(37625,'femur.tif',234,7,121,41.4036352,22.0566451,30.8025002,1.8,22.0549366,30.7721952,1.3646046,5.385769,5.6990236,421.0785193,436.0570372,6.6113606,76.5143413,78.183546,148.2040364,10.3638002,11.1051548,2.1831843,34.9807461),(37626,'femur.tif',234,7,122,42.0998822,22.0901161,30.7619489,1.8,22.0969774,30.7260151,1.3252816,5.4457052,5.7123189,431.0198887,443.2443209,6.6021312,77.5944635,79.1485908,151.624093,10.4389002,11.1312795,2.1981045,35.1309461),(37627,'femur.tif',234,7,123,42.5760009,22.1054339,30.7363196,1.8,22.1026642,30.6984074,1.2308467,5.5127178,5.7560397,439.4712211,449.6772753,6.3070531,78.1226851,79.7195207,154.3572349,10.4389002,11.1484934,2.1886966,35.1749387),(37628,'femur.tif',234,7,124,43.1360302,22.1201643,30.6793435,1.8,22.1198204,30.6453213,0.8582894,5.5679152,5.649019,447.4864869,456.73898,4.1168545,80.8527964,80.3687686,157.6424961,10.5140002,11.1921681,2.1941659,35.4055759),(37629,'femur.tif',234,7,125,43.659936,22.1133608,30.6666422,1.8,22.1066919,30.6225505,0.9319052,5.5702321,5.7061758,454.5231751,470.0835986,4.6892198,82.3815487,81.598606,160.7757326,10.5774467,11.228392,2.175495,35.5557759),(37630,'femur.tif',234,7,126,43.9630977,22.119826,30.6352095,1.8,22.1345702,30.5895924,0.8885476,5.6048849,5.6931661,461.8715551,478.1765846,4.4140365,83.9913286,82.4051808,163.727939,10.6074235,11.2805102,2.2049768,35.6619833),(37631,'femur.tif',234,7,127,43.6900328,22.0842619,30.5918159,1.8,22.0874559,30.5541426,0.8227036,5.5835575,5.6281305,465.0291319,479.9775792,3.9122302,85.2818849,83.2854556,165.3187313,10.6211626,11.3079756,2.2621333,35.9183908),(37632,'femur.tif',234,7,128,43.4911227,22.0689225,30.5426321,1.8,22.0679589,30.5079123,0.4920572,5.5172231,5.5479149,467.8553233,482.7281575,1.6178664,87.0107352,84.7990576,166.9381238,10.6375336,11.2832597,2.2382609,35.9623833),(37633,'femur.tif',234,7,129,43.6096436,22.1176196,30.5417507,1.8,22.1320821,30.5151655,0.6070066,5.5896915,5.5950872,468.1472331,493.04093,2.364872,88.1203305,83.7518909,167.0996311,10.6557019,11.2825099,2.1089327,35.9806057),(37634,'femur.tif',234,7,130,44.3412864,22.1672132,30.5635682,1.8,22.183881,30.5326644,0.5159605,5.474941,5.6727902,474.2491674,515.9757761,1.7988854,90.9562589,86.6217864,169.557928,10.6641596,11.4161883,2.1405528,36.3432205),(37635,'femur.tif',234,7,131,45.1895846,22.1937503,30.6070418,1.8,22.2302348,30.573981,0.4307278,5.4215912,5.7538817,489.2742888,536.7444613,1.3130071,93.2838895,90.245514,172.9638088,10.6740661,11.5663755,2.2272837,36.6693908),(37636,'femur.tif',234,7,132,45.3252263,22.2219674,30.6130656,1.8,22.237195,30.5716121,0.4306832,5.4278486,5.824443,495.3845424,552.1233982,1.3166928,94.7941975,91.267199,174.0129082,10.7168691,11.6586554,2.2374892,37.0320057),(37637,'femur.tif',234,7,133,45.0573893,22.2238931,30.584691,1.8,22.2269086,30.5408922,0.4019512,5.4112175,5.8788531,499.6478099,561.0985808,1.1493313,95.4435452,92.3355626,173.9746295,10.7393002,11.7218569,2.2745581,37.1639834),(37638,'femur.tif',234,7,134,45.0231349,22.2266378,30.5557397,1.8,22.2240633,30.5161536,0.384562,5.4097656,5.9222657,506.4822777,576.4530522,1.0560919,97.3365742,93.6237019,175.3296939,10.7912396,11.9108697,2.2130364,37.4643834),(37639,'femur.tif',234,7,135,45.0100148,22.2285603,30.5234278,1.8,22.2241565,30.480388,0.3777442,5.4326848,5.9800018,513.0712846,592.0443808,1.0204644,99.0040473,94.4415711,176.0531845,10.8282012,12.0612098,2.2192787,37.8269983),(37640,'femur.tif',234,7,136,45.2269026,22.254258,30.4803068,1.8,22.2563543,30.4391089,0.345823,5.4425772,6.062708,519.7135738,611.0838085,0.8661057,100.7938702,95.4903451,177.2181399,10.8144002,12.1986077,2.2339993,37.9589759),(37641,'femur.tif',234,7,137,45.0853157,22.2490095,30.420607,1.8,22.2559631,30.3735776,0.3604015,5.4917174,6.1289165,522.0174506,629.1923909,0.9344832,102.659645,95.0554101,177.7711791,10.8144002,12.3632486,2.2313067,38.3033685),(37642,'femur.tif',234,7,138,45.0014203,22.2134236,30.3897694,1.8,22.2214321,30.3492196,0.3434916,5.5835573,6.1544696,532.1521245,646.3703068,0.8506664,105.0245348,95.3070046,179.3126766,10.8895002,12.5027406,2.2455373,38.7721908),(37643,'femur.tif',234,7,139,44.9282707,22.2181641,30.3378495,1.8,22.2328036,30.3006441,0.2890293,5.6624119,6.2316542,538.2139712,665.2125244,0.6083099,106.7473429,95.0503032,183.0436093,10.950058,12.5614715,2.2418025,39.153028),(37644,'femur.tif',234,7,140,43.9918881,22.1717132,30.2517275,1.8,22.1824495,30.202592,0.23257,5.7194755,6.2445093,535.7496765,671.0673276,0.3894792,107.4651824,93.6711197,186.3149155,10.8895002,12.5796425,0.0776876,39.3396727),(37645,'femur.tif',234,7,141,43.6595782,22.1865303,30.1223864,1.8,22.1983743,30.0713977,0.1478226,5.7142091,6.3308073,537.6416835,689.1752508,0.1578497,108.8605636,94.0885554,187.1979511,11.0397002,12.8306764,0.0996687,39.8267173),(37646,'femur.tif',234,7,142,44.4278554,22.1939569,30.0223861,1.8,22.2127183,29.9672322,0.0080952,5.7670091,6.638897,547.28607,729.7830099,0.0004852,109.9253392,94.8994632,189.9161367,11.0397002,13.1296196,0.097392,40.2075545),(37647,'femur.tif',234,7,143,45.3105802,22.205283,29.9406206,1.8,22.2304008,29.8905686,-0.0465011,5.8679755,6.8376937,553.4650659,768.3520528,0.0163178,112.3700598,94.3195931,191.2351934,11.1473192,13.4044562,0.1292194,40.7385917),(37648,'femur.tif',234,7,144,46.9362983,22.2838931,29.8669513,1.8,22.3283318,29.8470821,-0.0772673,5.9144845,6.9945221,567.8999668,820.814976,0.0466107,117.3511166,96.0185062,197.8976555,11.1899002,13.7145434,0.0822317,41.2256363),(37649,'femur.tif',234,7,145,48.858545,22.3713558,29.771339,1.8,22.4060956,29.7532889,-0.1065174,5.9909949,7.1002049,582.144924,892.774682,0.0920423,125.7392838,97.1699911,206.9104351,11.3022887,13.9913943,0.1183631,41.8446587),(37650,'femur.tif',234,7,146,50.3554114,22.4903869,29.6652555,1.8,22.5451149,29.6428985,-0.1362583,6.0671021,7.1965386,603.0634571,956.9803926,0.1548571,132.9778732,99.3989299,216.3506484,11.4109784,14.3260019,0.0892361,42.7383108),(37651,'femur.tif',234,7,147,52.4667147,22.5590094,29.5545155,1.8,22.6354954,29.5385196,-0.157819,6.1395042,7.3455385,630.7393288,1024.493115,0.2159945,139.4714789,102.7345712,224.2967083,11.5327675,14.6319782,0.0925186,43.5257554),(37652,'femur.tif',234,7,148,54.777197,22.5982966,29.4852977,1.8,22.6263947,29.4994055,-0.1707802,6.2456623,7.6475999,661.0399611,1111.7065406,0.2636923,145.3667228,105.8398495,231.1921683,11.7004281,15.0818305,0.1348549,44.4194075),(37653,'femur.tif',234,7,149,57.5475733,22.5864512,29.3309,1.8,22.6653512,29.3514119,-0.1209763,6.2411203,8.0125282,705.259131,1234.9913992,0.1396873,154.1325503,113.002008,240.1564252,11.8571346,15.612855,0.1350944,46.0382893),(37654,'femur.tif',234,7,150,59.6947739,22.5181229,29.2109355,1.8,22.5657718,29.2440127,-0.0800667,6.3115374,8.4023085,742.0221263,1334.5278218,0.0636445,158.8287094,117.5659865,244.3142278,12.0841715,16.1061053,0.1168363,47.9211266),(37655,'femur.tif',234,7,151,60.7715523,22.4958581,29.219718,1.8,22.5475948,29.2898781,-0.0721633,6.5317675,8.63947,762.2226222,1422.0862398,0.0526535,164.603412,116.6946952,249.8461339,12.3228303,16.4475861,0.096034,49.2471563),(37656,'femur.tif',234,7,152,61.2929565,22.590607,29.1255498,1.8,22.6761082,29.2279524,-0.0763977,6.6726469,8.8429264,789.494947,1529.5059287,0.059508,172.9637748,118.318106,259.889936,12.5716043,16.9926926,0.0486342,50.0528233),(37657,'femur.tif',234,7,153,62.8151131,22.5899632,28.9752054,1.8,22.6268498,29.0772715,-0.078105,6.7603226,9.3065263,837.4322787,1627.1138294,0.0637365,174.8357841,123.8746024,262.3031217,12.8446797,17.6893585,0.0679802,53.5576688),(37658,'femur.tif',234,7,154,65.3889839,22.711492,28.7997081,1.8,22.7683258,28.9285531,-0.1019389,6.8932353,9.5176866,889.4550911,1794.0999922,0.112857,188.5016882,129.0330374,280.0858152,13.1373911,18.1897102,3.1002938,57.1033805),(37659,'femur.tif',234,7,155,69.4736301,22.6996864,28.4978888,1.8,22.808682,28.6132212,-0.096133,6.8870335,10.2027348,966.5420639,2034.2770026,0.1066782,199.3854632,140.3422917,292.2239445,13.4569208,19.0182505,0.0434509,55.0885656),(37660,'femur.tif',234,7,156,71.5106634,22.7486768,28.3099778,1.8,22.8542202,28.4781764,-0.0671012,7.0063075,10.4381443,1040.0141766,2198.383573,0.0535831,210.6105756,148.439698,305.8330615,13.7920817,19.4178166,0.0657964,56.4403656),(37661,'femur.tif',234,7,157,73.2446306,22.8808034,28.0475996,1.8,22.9738735,28.2077424,-0.0980359,7.1745946,10.3457239,1128.0805686,2314.3479106,0.1169509,223.7009154,157.2326569,329.9122053,14.1881201,19.4927547,0.065543,56.6270102),(37662,'femur.tif',234,7,158,76.3922643,22.9910055,27.7633271,1.8,23.0356156,27.9106931,-0.1065822,7.3985153,10.1049547,1263.9548137,2470.5412988,0.1440862,244.4881111,170.8389808,362.0714553,14.6847708,19.425367,0.1435373,57.9316912),(37663,'femur.tif',234,7,159,80.3966441,23.2065206,27.3181791,1.8,23.2000996,27.4898664,-0.1619663,7.9973354,10.5506214,1422.9848317,2761.8990123,0.3484457,261.775958,177.9323686,362.9972285,15.1419048,19.8390552,0.198138,60.5473061),(37664,'femur.tif',234,7,160,94.4156875,23.9624339,25.9630521,1.8,24.0005453,26.0857087,-0.4164976,9.4505986,11.6331886,1881.2749142,3901.3090027,2.5754827,335.3602473,199.0641005,484.9402194,17.2222613,22.7841572,0.7154192,74.1142568),(37665,'femur.tif',234,7,161,105.8726716,24.0229877,24.7667617,1.8,24.0409985,24.8727146,-0.5189069,10.4517924,12.2673918,2601.8542363,4477.0108112,4.3398584,364.9521337,248.9385679,574.7568252,18.5961142,24.0087551,0.7632779,77.8981536),(37666,'femur.tif',234,7,162,112.3991071,23.8511283,24.0610171,1.8,23.7644962,24.2229082,-0.5832333,11.1086045,12.6852327,3182.1136595,4594.1797958,5.6817503,362.1675629,286.4548519,613.0131159,19.4054033,24.7001381,0.8090497,81.821576),(37667,'femur.tif',234,7,163,124.105014,23.2402007,23.3567598,1.8,23.1317003,23.5304046,-0.2289192,12.3388544,12.6790049,4343.5672898,5056.5024006,1.0651309,398.8090893,352.0235478,713.1837955,20.6525004,25.065856,0.7769238,86.7706281),(37668,'femur.tif',234,7,164,126.5549032,23.2103712,23.3797521,1.8,23.0603203,23.5403066,-0.2919162,12.4208737,13.0379681,4558.1717845,5080.7278853,1.7469187,389.6870917,366.9767437,717.8167737,20.9375708,25.3972393,2.1817645,87.9357835),(37669,'femur.tif',234,7,165,126.7812045,23.1666487,23.5029511,1.8,23.0294497,23.7137866,-0.4567674,13.2191625,13.5293533,4509.2676023,4839.4408468,4.11034,357.6993471,341.1159816,673.3597913,21.2386503,25.9203822,2.18532,89.1845026),(37670,'femur.tif',234,7,166,121.4825263,23.2205908,23.5794528,1.8,23.0852414,23.7478141,-0.6575868,13.9989815,13.3908822,4441.9077642,4764.2871238,7.5638275,355.7859042,317.3022094,653.6734582,21.2188607,26.1557251,2.1930485,89.3711472),(37671,'femur.tif',234,7,167,116.2422764,23.1775254,23.7215312,1.8,23.058703,23.8924353,-0.681877,13.9844785,13.360466,4450.5122428,4536.3531438,7.6955659,339.5355479,318.2465646,641.5845834,20.993919,26.0778739,2.1987457,89.8475174),(37672,'femur.tif',234,7,168,109.8079347,23.1439008,23.8340298,1.8,23.0307451,24.0213403,-0.0562168,11.1312119,12.1773033,4163.7163173,4171.022299,0.0577771,342.5243002,374.0577704,601.7562251,20.6212179,25.8353828,2.2055767,90.7851621),(37673,'femur.tif',234,7,169,104.4687534,23.1263705,23.9244378,1.8,23.1107948,24.133205,0.3163564,11.3729911,11.7071816,3724.2907328,3849.864613,1.6852005,328.8464077,327.4680082,566.2649218,19.9860415,25.203632,2.2166812,87.78871),(37674,'femur.tif',234,7,170,100.3842115,23.0783059,24.1446257,1.8,23.1011909,24.3616923,0.3159939,10.8159967,11.4145648,3238.7819092,3429.6991779,1.6157269,300.4669236,299.4436854,515.784796,19.2852561,24.0028815,2.2230582,84.8651471),(37675,'femur.tif',234,7,171,95.2230306,23.1150366,24.3901437,1.8,23.1031291,24.5669881,0.3466559,10.2670576,11.55998,2672.5958796,2964.8749206,1.8319827,256.477513,260.3078689,453.2819082,18.3714,22.9015604,2.3214057,78.9828718),(37676,'femur.tif',234,7,172,88.1108069,23.157199,24.679652,1.8,23.179723,24.7744508,0.3552317,9.5230124,11.0604054,2048.1259621,2560.2101449,1.776463,231.4752543,215.071226,389.8425768,17.1425786,22.1003367,2.3273563,75.5873601),(37677,'femur.tif',234,7,173,76.6561323,23.2592808,25.0541506,1.8,23.2676526,25.1391874,0.3034058,8.4586428,10.3079842,1442.5685564,2008.1446438,1.1404495,194.8144853,170.5437371,313.0244069,15.5429162,20.6176519,2.3922613,71.0160187),(37678,'femur.tif',234,7,174,63.3418821,23.3640745,25.2675656,1.8,23.3954502,25.3382764,0.2177348,7.2642695,8.9804806,907.0270397,1540.6834404,0.4926309,171.5591294,124.8614245,241.9263265,13.6536793,18.4843668,2.4655827,66.3082782),(37679,'femur.tif',234,7,175,47.674783,23.3345812,25.315835,1.8,23.3642169,25.3726574,0.1164446,5.9329261,8.121752,480.1808429,1126.9397656,0.1072537,138.7557475,80.9349099,175.9344332,6.0739147,11.7571684,1.71179,30.8675527),(37680,'femur.tif',234,7,176,29.0562198,23.0820538,25.2969361,1.8,23.0743892,25.3630633,0.0716254,4.4291254,7.3416878,142.1682762,622.1734975,0.0248016,84.7452953,32.0984988,98.1819088,4.1227959,8.7940787,1.7078625,22.4576475),(37681,'femur.tif',234,7,177,1.541293,19.4870176,25.7452229,1.8,19.5085578,25.7815882,-1.559357,0.6467745,1.2168702,0.1491112,0.490584,0.2568485,0.4031523,0.2305459,0.5141943,1.3518,2.4323591,1.7257931,6.3844158),(37682,'femur.tif',234,7,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37683,'femur.tif',234,7,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37684,'femur.tif',234,7,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37685,'femur.tif',234,7,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37686,'femur.tif',234,7,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37687,'femur.tif',234,7,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37688,'femur.tif',234,7,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37689,'femur.tif',234,7,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37690,'femur.tif',234,7,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37691,'femur.tif',234,7,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37692,'femur.tif',234,7,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37693,'femur.tif',234,7,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37694,'tibia-fibula.tif',234,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37695,'tibia-fibula.tif',234,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37696,'tibia-fibula.tif',234,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37697,'tibia-fibula.tif',234,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37698,'tibia-fibula.tif',234,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37699,'tibia-fibula.tif',234,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37700,'tibia-fibula.tif',234,8,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37701,'tibia-fibula.tif',234,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37702,'tibia-fibula.tif',234,8,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37703,'tibia-fibula.tif',234,8,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37704,'tibia-fibula.tif',234,8,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37705,'tibia-fibula.tif',234,8,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37706,'tibia-fibula.tif',234,8,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37707,'tibia-fibula.tif',234,8,14,12.914483,25.7576963,28.4464236,1.8,25.4662062,27.9199445,1.0043154,1.5920319,9.6543951,5.438805,263.799556,1.5324963,27.3242966,3.4162664,27.8739417,2.6315451,7.9291772,2.3296521,18.413739),(37708,'tibia-fibula.tif',234,8,15,51.8538313,24.0652324,26.2758521,1.8,23.9311153,25.9313913,1.184016,8.5582083,9.5635735,339.0891754,1328.2539222,7.4126238,138.8867787,39.6215148,169.5176448,8.4205811,19.0724741,2.0996196,50.6075178),(37709,'tibia-fibula.tif',234,8,16,85.9824643,23.9858737,26.7463185,1.8,24.0339082,26.5750536,1.4036411,7.7604687,10.8562181,1313.0088428,2536.6478976,13.933722,233.6585249,169.191951,351.8268914,14.0362065,20.8218417,2.0728046,72.0048078),(37710,'tibia-fibula.tif',234,8,17,105.0707889,24.5776676,27.3039088,1.8,24.6253757,27.0779373,1.5386434,10.5567774,11.7351436,2288.8169499,3711.6004549,17.4937005,316.2807875,216.8101936,490.0207948,17.5946854,23.0490088,1.4629908,70.6541776),(37711,'tibia-fibula.tif',234,8,18,115.9548137,25.1398835,28.528212,1.8,25.1236544,28.3298845,1.3484353,11.972832,13.9500669,3039.1483592,4951.7340067,18.3858944,354.9613078,253.8370496,569.2965986,19.7774302,25.2911372,1.6571949,77.4321072),(37712,'tibia-fibula.tif',234,8,19,128.6864443,25.7229002,29.5807784,1.8,25.7988512,29.4316061,1.1587762,12.7731926,15.4062466,3699.7792219,5859.4751261,18.0081837,380.3311258,289.6518779,619.2718915,21.020217,26.5294635,1.7058188,89.0297468),(37713,'tibia-fibula.tif',234,8,20,136.6920084,25.8134822,29.722645,1.8,26.0064703,29.7197542,1.0433543,12.7545911,15.5391473,3818.1706553,5986.2159096,17.010508,385.2345178,299.3565703,622.362374,21.2213586,26.7628662,1.6859562,92.9196967),(37714,'tibia-fibula.tif',234,8,21,130.8757566,25.9025611,29.0548435,1.8,25.8851335,29.2432279,0.9912471,10.6676209,15.0943445,3436.0507478,6388.9880822,15.2706472,423.2703241,322.1009412,641.2766595,20.38456,27.0066425,1.6664445,89.2381169),(37715,'tibia-fibula.tif',234,8,22,103.9903932,24.5573858,28.1100672,1.8,24.6343003,28.5021641,1.189857,11.2899152,14.1459837,2254.3234231,5551.2594563,14.935971,392.4265417,199.6758511,550.4434373,19.0464003,26.6550977,1.7126934,80.1333676),(37716,'tibia-fibula.tif',234,8,23,90.2851747,23.868738,27.8607852,1.8,23.967445,28.1564862,1.232954,11.3055771,13.923831,1706.9098308,4837.4249847,13.3943998,347.4205482,150.9794522,468.1394657,18.3036741,26.1229601,1.7041007,77.2976575),(37717,'tibia-fibula.tif',234,8,24,79.5778915,23.3439698,27.5123704,1.8,23.3833013,27.7181026,1.253754,10.6929994,13.6018205,1329.0553997,4282.3117879,11.9739153,314.8337239,124.2921051,409.6840506,17.1370286,25.7037139,1.6985022,74.3997077),(37718,'tibia-fibula.tif',234,8,25,71.6339181,22.925589,27.1796593,1.8,22.9431377,27.3797847,1.2639397,10.0830373,13.3837232,1078.7083239,3963.1371603,10.8496447,296.1161938,106.9824784,374.7043122,16.2097411,25.3837666,1.6922429,72.3335277),(37719,'tibia-fibula.tif',234,8,26,67.2826881,22.7154277,27.0273353,1.8,22.6549213,27.1514865,1.2605608,9.4722976,13.3596203,926.0945866,3715.16405,10.1686831,278.0890449,97.7687386,345.057839,15.3609427,25.1134752,1.7015207,71.0949878),(37720,'tibia-fibula.tif',234,8,27,63.661102,22.4546704,26.8063375,1.8,22.3793413,26.8881693,1.2672665,9.1782249,13.2393375,821.2314287,3580.3430112,9.662317,270.4321893,89.476063,330.016574,14.7517542,24.9576243,1.7143797,69.7642978),(37721,'tibia-fibula.tif',234,8,28,59.9368303,22.2918352,26.7177231,1.8,22.1581443,26.7548511,1.2674266,8.7101527,13.1656524,712.1151227,3323.1685297,9.0979686,252.4119911,81.7569048,303.6969883,14.0874433,24.7471697,1.7115596,68.2592777),(37722,'tibia-fibula.tif',234,8,29,55.6129965,22.1247237,26.610731,1.8,21.9669775,26.5885472,1.2659979,8.4880963,12.9814407,623.8817292,3060.6532777,8.4340766,235.7714644,73.5007837,281.1621813,13.6955784,24.4668313,1.7172805,67.0107677),(37723,'tibia-fibula.tif',234,8,30,52.861302,21.9987771,26.5033693,1.8,21.8640772,26.4459444,1.2572169,8.0639033,12.7910578,557.9326436,2826.4749447,7.9719165,220.972728,69.1889059,261.6605638,13.2074304,24.1781562,1.6900623,65.5638576),(37724,'tibia-fibula.tif',234,8,31,49.9939605,21.8837211,26.4676512,1.8,21.726101,26.3718638,1.2528954,7.6404644,12.712172,506.701644,2680.6234119,7.518241,210.8706056,66.3181735,248.1855281,12.6796308,23.9203685,1.703896,64.0688077),(37725,'tibia-fibula.tif',234,8,32,48.7696819,21.7789066,26.406727,1.8,21.6295246,26.2762416,1.2441934,7.272936,12.6396646,469.7554559,2574.9861243,7.2916347,203.7226617,64.5895213,238.7410087,12.2758771,23.7653889,1.7174159,63.2511377),(37726,'tibia-fibula.tif',234,8,33,47.4138151,21.6760765,26.3958437,1.8,21.5138284,26.2435082,1.2346129,7.0079441,12.6424317,443.7505969,2522.1299883,7.0423331,199.4972208,63.3210816,232.4130451,11.9643143,23.6971758,1.7263101,62.3512878),(37727,'tibia-fibula.tif',234,8,34,47.3515951,21.5646227,26.3476806,1.8,21.3931805,26.1437993,1.2325404,6.8342422,12.5944811,425.7850539,2486.1329522,7.0228781,197.3986007,62.3017219,229.075432,11.7971789,23.6148099,1.7311108,61.8141978),(37728,'tibia-fibula.tif',234,8,35,47.2246873,21.4718514,26.3601911,1.8,21.3139695,26.1277118,1.2254159,6.6699211,12.6575688,411.6339546,2485.7615107,6.968638,196.3853846,61.714966,226.9417885,11.6267511,23.6672577,1.7180282,61.8042277),(37729,'tibia-fibula.tif',234,8,36,47.6413278,21.3938873,26.3134192,1.8,21.2157442,26.0459583,1.2205723,6.5752831,12.6467685,403.3472911,2471.7352192,7.0054724,195.4440149,61.3429541,224.9540959,11.5004519,23.7127431,1.730443,61.3833577),(37730,'tibia-fibula.tif',234,8,37,47.9847425,21.2664492,26.2020603,1.8,21.074618,25.8908527,1.2133528,6.4901638,12.5901588,397.5942039,2476.7633749,7.0184374,196.7221715,61.2610427,225.5452432,11.3833217,23.8106869,1.7297807,61.2671377),(37731,'tibia-fibula.tif',234,8,38,47.9666939,21.1849371,26.2238518,1.8,20.9638298,25.8276133,1.2089548,6.4445953,12.6678066,394.9720325,2450.3427226,6.9926327,193.4307023,61.2873291,222.1490797,11.3220663,23.908641,1.7291238,61.3493176),(37732,'tibia-fibula.tif',234,8,39,48.4409245,21.1125714,26.2511626,1.8,20.8901501,25.8640953,1.2087437,6.4630866,12.7601337,392.9779389,2504.6260895,7.060638,196.2852537,60.8034463,224.3176292,11.2843455,24.0066053,1.7284723,61.4555676),(37733,'tibia-fibula.tif',234,8,40,49.6563265,21.0556511,26.2307178,1.8,20.8344907,25.8170149,1.2055068,6.41969,12.8075478,392.5814636,2535.0526666,7.2199808,197.9342735,61.1527132,226.1185884,11.2555864,23.9407238,1.7373074,61.5136776),(37734,'tibia-fibula.tif',234,8,41,50.0752831,21.0075721,26.262254,1.8,20.7865618,25.8295426,1.2066549,6.4119753,12.9280524,389.7946482,2534.3982272,7.2872824,196.038673,60.7916641,224.1752404,11.1880922,23.8781637,1.7209188,61.3833577),(37735,'tibia-fibula.tif',234,8,42,51.5667627,20.9422778,26.2487377,1.8,20.7242465,25.7674166,1.2153249,6.4624894,13.1031425,387.509571,2589.9953361,7.5534432,197.6621521,59.9628946,226.0205082,11.1371604,23.8429015,1.737997,61.4173978),(37736,'tibia-fibula.tif',234,8,43,52.7082613,20.8278939,26.1602885,1.8,20.6370538,25.6929438,1.2217214,6.4757527,13.3282803,387.3694855,2666.0857942,7.7570432,200.0322419,59.8184499,227.4969473,11.0375288,24.1364021,1.735945,61.8141978),(37737,'tibia-fibula.tif',234,8,44,53.252698,20.7569609,26.0228135,1.8,20.5885854,25.546822,1.2316339,6.4984253,13.4707211,387.2133322,2791.5228811,7.8930479,207.228913,59.5857168,233.7905617,10.9808458,24.3985626,1.7259186,62.3272178),(37738,'tibia-fibula.tif',234,8,45,53.2929169,20.7247531,26.0107083,1.8,20.5593576,25.5192004,1.2339643,6.4738119,13.4803306,386.5138601,2758.4706412,7.9119599,204.629302,59.7042155,231.2805797,10.9493691,24.3484984,1.7386242,62.4434378),(37739,'tibia-fibula.tif',234,8,46,53.3988059,20.7105447,25.9976891,1.8,20.5558408,25.5314086,1.2325521,6.4408629,13.4001371,386.5719228,2717.3305925,7.919826,202.7837907,60.018654,229.1777765,10.9481365,24.2853679,1.722514,62.1869278),(37740,'tibia-fibula.tif',234,8,47,54.3065362,20.7037291,26.0879646,1.8,20.5453342,25.6475792,1.2270929,6.3748845,13.3800249,389.9032612,2657.0984241,8.023311,198.5869573,61.162404,225.7735329,10.9175364,24.1072333,1.7528581,61.6739078),(37741,'tibia-fibula.tif',234,8,48,52.5799843,20.7385486,26.4477614,1.8,20.6116499,26.0338508,1.2199237,6.3834999,13.3101559,380.7966914,2477.8448914,7.7280164,186.1619734,59.6532773,212.5986265,10.9140907,23.6990444,1.751773,60.8562378),(37742,'tibia-fibula.tif',234,8,49,52.8055847,20.7486293,26.8445078,1.8,20.631375,26.4771986,1.2085302,6.3474752,13.2334724,372.7167417,2315.5648966,7.6955757,174.9778762,58.7188968,201.0333799,10.8234627,23.2113166,1.7556192,59.3371179),(37743,'tibia-fibula.tif',234,8,50,51.6621564,20.7889333,27.0505115,1.8,20.7074206,26.7633566,1.1875486,6.2193983,12.9363489,361.4709642,2130.9435305,7.4063982,164.7252674,58.1199253,190.2853328,10.7813023,22.7055347,1.7553391,57.9242479),(37744,'tibia-fibula.tif',234,8,51,49.9012084,20.8344743,27.3549768,1.8,20.7673214,27.1019818,1.1644737,6.0360856,12.3376769,354.2847158,1906.9534007,7.0176903,154.563409,58.6944483,181.6924638,10.6214139,21.7136998,1.7825278,55.8580679),(37745,'tibia-fibula.tif',234,8,52,48.6901244,20.9132483,27.6673197,1.8,20.8672845,27.4675188,1.1449573,5.9693686,11.9712734,350.5733547,1737.7353741,6.7302796,145.1587743,58.7287159,173.5711342,10.523871,20.9321406,1.8100279,54.1305779),(37746,'tibia-fibula.tif',234,8,53,47.9658295,20.9874312,28.0146787,1.8,20.9638334,27.8568136,1.1281667,5.990431,11.4458197,349.0189919,1582.902915,6.527705,138.2952865,58.2627512,167.8813506,10.5260437,20.0415921,1.815775,52.5193079);
INSERT INTO `slices_w` VALUES (37747,'tibia-fibula.tif',234,8,54,47.6352659,21.0587212,28.3006819,1.8,21.0304003,28.1312801,1.1099183,5.9483064,11.043361,349.2489017,1445.6877679,6.3689227,130.9101251,58.7140063,161.8442711,10.4676536,19.2979064,1.8307365,50.9321079),(37748,'tibia-fibula.tif',234,8,55,47.1872486,21.1168026,28.4976931,1.8,21.1107933,28.3491961,1.0917715,5.8847314,10.5660577,348.9210202,1340.9686081,6.193785,126.9128601,59.2925997,159.4708742,10.3426436,18.5588861,1.8468933,49.5433079),(37749,'tibia-fibula.tif',234,8,56,47.1217217,21.2033414,28.6943641,1.8,21.1990453,28.5481847,1.0688615,5.8155359,10.1978186,352.8447905,1260.8927933,6.0356722,123.6433838,60.6727905,157.8030717,10.2689368,17.9321667,1.8452966,48.4691279),(37750,'tibia-fibula.tif',234,8,57,47.0190712,21.2523134,28.8307744,1.8,21.2463463,28.6827774,1.0522343,5.7847085,9.8727938,353.5873538,1189.3456898,5.9114661,120.4669831,61.1244898,156.2356243,10.2077801,17.3600003,1.8545904,47.4530579),(37751,'tibia-fibula.tif',234,8,58,46.4195942,21.3251301,29.0019803,1.8,21.3312097,28.8864908,1.0388426,5.7480566,9.6257322,352.6369584,1109.5793289,5.7462029,115.2722004,61.3489018,151.8901571,10.1882918,16.8774161,1.8999817,46.436988),(37752,'tibia-fibula.tif',234,8,59,46.4779021,21.4081217,29.140181,1.8,21.4286682,29.0335977,1.0237001,5.6681836,9.2568457,352.8894156,1044.0524095,5.650025,112.7870595,62.257937,150.8732764,10.1336382,16.3122933,1.8925469,45.3046979),(37753,'tibia-fibula.tif',234,8,60,46.5228978,21.4858423,29.2896249,1.8,21.528292,29.1959017,1.0137017,5.6287178,8.9171045,353.6179564,983.4081107,5.5862577,110.2833453,62.8238915,149.9394338,10.0694301,15.7487618,1.9044985,44.230518),(37754,'tibia-fibula.tif',234,8,61,46.8354358,21.5532157,29.4025479,1.8,21.5893473,29.3090328,1.0071926,5.5986974,8.6599903,355.9430162,938.5048093,5.5780372,108.3725018,63.576041,149.4690243,10.0404905,15.3567882,2.4890479,43.495028),(37755,'tibia-fibula.tif',234,8,62,47.1932061,21.5964476,29.466876,1.8,21.6288014,29.3852694,1.0027477,5.5745062,8.3570029,355.1714911,901.1327928,5.5890029,107.8296619,63.713534,150.2906113,9.9923278,15.0607689,2.5152177,42.735468),(37756,'tibia-fibula.tif',234,8,63,46.6647408,21.6690447,29.5587813,1.8,21.7035878,29.4779633,0.9926982,5.5426272,8.1101144,352.5044127,852.5733626,5.455201,105.1247027,63.5987954,148.5802359,9.9449816,14.7501429,2.5330705,41.9759081),(37757,'tibia-fibula.tif',234,8,64,46.3278406,21.7470832,29.6520457,1.8,21.791489,29.5790837,0.9836993,5.5386835,7.9014444,351.5525974,814.4086785,5.3519718,103.070861,63.4722308,147.5495232,9.891246,14.5015338,2.5706662,41.579108),(37758,'tibia-fibula.tif',234,8,65,46.2476044,21.8165557,29.7265906,1.8,21.8692578,29.657559,0.9762601,5.5685542,7.7013348,350.58931,782.0969828,5.2896497,101.553433,62.9587675,146.970884,9.8421896,14.3644891,2.5727448,41.0760581),(37759,'tibia-fibula.tif',234,8,66,46.2026896,21.8918337,29.8042926,1.8,21.9558786,29.7506083,0.9700754,5.601901,7.5338341,351.1002463,751.6792238,5.2402072,99.7737952,62.675197,146.3194382,9.8356338,14.1887216,2.6059693,40.6551882),(37760,'tibia-fibula.tif',234,8,67,46.1179321,21.9500831,29.8554867,1.8,22.0232024,29.8245714,0.9676521,5.5965848,7.3335932,350.2881818,726.0995957,5.2132077,99.0100726,62.5896315,143.3525382,9.7818695,14.0289988,2.6399886,40.2002781),(37761,'tibia-fibula.tif',234,8,68,45.7431298,22.0236396,29.9256857,1.8,22.0834354,29.880805,0.9495867,5.5680835,7.1931999,351.501834,699.4907973,5.0413017,97.2433419,63.1279751,138.1559442,9.763558,13.9903658,2.6303619,40.2343182),(37762,'tibia-fibula.tif',234,8,69,45.3902815,22.1019595,29.9963917,1.8,22.1616675,29.9615781,0.9306145,5.5108791,7.062556,353.9358636,675.7873097,4.8657125,95.6859395,64.2249374,134.9242293,9.7108354,13.9421006,2.6365674,39.9537382),(37763,'tibia-fibula.tif',234,8,70,45.5170139,22.1703598,30.0284953,1.8,22.2274929,29.9888645,0.904333,5.3789792,6.916144,355.612333,659.9817966,4.6868598,95.4262664,66.1114911,133.5317987,9.7157889,13.8883545,2.6587781,39.7312683),(37764,'tibia-fibula.tif',234,8,71,45.8408244,22.2867241,30.104628,1.8,22.344219,30.0722443,0.8742936,5.3049099,6.8479705,359.0825939,645.0125675,4.4956695,94.1903245,67.6887263,132.8126844,9.717034,13.7545014,2.6618174,39.5669083),(37765,'tibia-fibula.tif',234,8,72,45.4908714,22.4011995,30.1830447,1.8,22.4646816,30.1443431,0.8477919,5.2069761,6.7723222,358.0800352,620.7907361,4.2627369,91.6658593,68.7692871,130.16431,9.6981057,13.6222228,2.6974865,39.3444383),(37766,'tibia-fibula.tif',234,8,73,45.2298474,22.5106555,30.2636473,1.8,22.5695062,30.2284336,0.8227601,5.180821,6.6935231,356.1369909,601.807928,4.0505378,89.9089945,68.7414203,127.9118779,9.6663933,13.507602,2.7338079,39.6250183),(37767,'tibia-fibula.tif',234,8,74,45.3088167,22.6330163,30.3318874,1.8,22.688694,30.2829296,0.7876194,5.2146621,6.6595153,355.4316364,595.2959013,3.7925084,89.3902741,68.1600519,127.4571559,9.654079,13.4565086,2.7241168,38.6330183),(37768,'tibia-fibula.tif',234,8,75,44.6487686,22.7334952,30.4189756,1.8,22.8053043,30.3894764,0.7706834,5.1890712,6.578151,352.0277127,575.189208,3.6112474,87.4393445,67.840216,125.5933618,9.6311511,13.3772958,2.7376746,38.3524383),(37769,'tibia-fibula.tif',234,8,76,43.9127901,22.7981677,30.473013,1.8,22.8745,30.4324322,0.7596852,5.2101268,6.5121996,347.8534043,557.8553047,3.4712942,85.6631159,66.7648636,122.5653493,9.6376199,13.2263775,2.7652645,38.3283684),(37770,'tibia-fibula.tif',234,8,77,44.2329384,22.8952187,30.5101159,1.8,22.9790993,30.4732568,0.7278708,5.2482435,6.3988164,349.49923,551.7728001,3.2629128,86.2304466,66.5935617,122.1148918,9.6421377,13.1341701,2.7624888,38.0718584),(37771,'tibia-fibula.tif',234,8,78,44.0033203,22.9309919,30.5528539,1.8,23.0230563,30.52136,0.7312743,5.2190545,6.2922924,347.6728923,540.851811,3.2707799,85.9546527,66.6160685,120.9006923,9.6428176,13.026966,2.7837132,37.8734584),(37772,'tibia-fibula.tif',234,8,79,43.7039277,23.0156817,30.5946107,1.8,23.1289553,30.5770471,0.7151758,5.2205722,6.2050929,348.3882622,528.0439148,3.1321748,85.0984708,66.7337307,119.2727,9.6630522,12.8994336,2.7882225,37.6169483),(37773,'tibia-fibula.tif',234,8,80,43.4279293,23.1293627,30.6371851,1.8,23.2282652,30.613614,0.6774603,5.2866337,6.1695562,350.0160907,513.8402381,2.843795,83.2864187,66.2077439,119.498625,9.6848178,12.738609,2.8001402,37.4525884),(37774,'tibia-fibula.tif',234,8,81,42.8599476,23.2086265,30.6785795,1.8,23.304002,30.6621616,0.6638677,5.2895429,6.1127188,350.0823064,497.5189245,2.7120533,81.3907756,66.1838483,118.4812217,9.7021552,12.6120621,2.8049178,37.2201483),(37775,'tibia-fibula.tif',234,8,82,42.3841786,23.2994504,30.6988137,1.8,23.3951674,30.6829248,0.6422881,5.313397,6.0483403,350.6330495,485.0864353,2.5348274,80.2015782,65.990373,116.6685161,9.7001199,12.516902,2.8273608,37.1379684),(37776,'tibia-fibula.tif',234,8,83,42.2450793,23.3891691,30.7082561,1.8,23.4717824,30.6942545,0.613084,5.3444795,5.9810767,353.053955,475.3644121,2.3310595,79.478067,66.0595586,117.0133448,9.705361,12.3622467,2.8401439,36.8573884),(37777,'tibia-fibula.tif',234,8,84,41.6314709,23.4387361,30.7201467,1.8,23.5283736,30.7046165,0.6106644,5.3324769,5.8880235,351.9094946,460.6042885,2.2814129,78.2273185,65.9936278,115.5616037,9.7087527,12.2096626,2.8532487,36.5427683),(37778,'tibia-fibula.tif',234,8,85,41.6546952,23.4987181,30.736602,1.8,23.5798424,30.729922,0.5988517,5.3332182,5.8236626,353.4106662,451.0328233,2.2059728,77.4483096,66.2659302,116.5775073,9.7380358,11.9913067,2.8564749,36.2381184),(37779,'tibia-fibula.tif',234,8,86,41.752941,23.6095344,30.7311165,1.8,23.689393,30.7163693,0.5597355,5.3795158,5.7417539,353.6556768,445.3336352,1.9618365,77.5605582,65.7411723,117.4676321,9.7437001,11.8152158,2.8782861,35.9816084),(37780,'tibia-fibula.tif',234,8,87,41.308822,23.6701051,30.7198831,1.8,23.7385645,30.6941511,0.5626047,5.3880237,5.6747716,351.5312238,433.7275858,1.9587696,76.4308439,65.2430731,117.7209947,9.7448394,11.6237684,2.8738436,35.5947785),(37781,'tibia-fibula.tif',234,8,88,41.4767443,23.7384923,30.7216424,1.8,23.7987739,30.6927406,0.5425496,5.3821325,5.5753812,352.2010513,426.6667045,1.8428637,76.5269122,65.438941,119.4161475,9.7261152,11.4062748,2.8776289,35.3141985),(37782,'tibia-fibula.tif',234,8,89,41.2638508,23.7935152,30.7432513,1.8,23.8731901,30.7180729,0.5638711,5.3582178,5.5500237,353.1601758,414.1455095,1.9645006,74.6204934,65.910008,118.5564457,9.7466661,11.2599649,2.8923405,35.1157985),(37783,'tibia-fibula.tif',234,8,90,41.5805793,23.8969886,30.7601911,1.8,23.9726219,30.7472161,0.5283177,5.3716205,5.4938312,357.4267395,409.175892,1.7609223,74.4791523,66.5398341,119.36158,9.7627536,11.2148662,2.8730132,34.9173985),(37784,'tibia-fibula.tif',234,8,91,41.7902485,23.9762663,30.7742385,1.8,24.0286274,30.7581838,0.5468923,5.3552618,5.4864158,357.2490544,402.4579646,1.883603,73.3553525,66.7099143,121.5939126,9.7187427,11.0237048,2.8682373,34.6368185),(37785,'tibia-fibula.tif',234,8,92,41.6306884,23.9992753,30.7918789,1.8,24.0725474,30.7850535,0.6493912,5.2179333,5.5401745,353.9337711,392.8356117,2.537141,70.9067223,67.8302593,116.3596916,9.6987926,10.8328037,2.863293,34.3902786),(37786,'tibia-fibula.tif',234,8,93,41.9536615,24.0533123,30.8089018,1.8,24.1059476,30.8100867,0.7060995,5.1328437,5.5577614,352.1388998,388.6465138,2.9439821,69.9286076,68.6050302,123.1427688,9.630217,10.6993537,2.8403671,34.0515886),(37787,'tibia-fibula.tif',234,8,94,41.76718,24.0824173,30.8245384,1.8,24.1315971,30.8292271,0.8432613,5.2616892,5.5993312,347.5438707,379.8444227,3.8824963,67.8374632,66.0517674,123.4360436,9.6118198,10.5884095,1.8362267,33.6888287),(37788,'tibia-fibula.tif',234,8,95,41.4633129,24.112691,30.845896,1.8,24.1577126,30.8473596,0.9522039,5.5291008,5.5815013,344.1559697,372.8878602,4.5867319,66.8078073,62.2444743,122.2073233,9.6328303,10.5660808,1.7884469,33.4904287),(37789,'tibia-fibula.tif',234,8,96,41.5774994,24.2050451,30.8748612,1.8,24.2652091,30.8826552,0.9964278,5.6123001,5.5756323,343.7578394,366.8202877,4.8841085,65.7898998,61.2507945,123.4292907,9.6576681,10.4955289,0.6378301,33.4663587),(37790,'tibia-fibula.tif',234,8,97,41.4734677,24.2686029,30.8937027,1.8,24.3246947,30.9006553,1.0857101,5.6320515,5.4917775,341.1496082,360.0872861,5.4093748,65.5684401,60.5728846,123.5689489,9.6392828,10.4419488,0.6777083,33.2438888),(37791,'tibia-fibula.tif',234,8,98,41.228717,24.3168374,30.9221008,1.8,24.3705451,30.9297321,1.2273695,5.6038166,5.3964898,336.1721553,353.2362755,6.0923847,65.4566745,59.989857,122.7292627,9.6326766,10.4579576,0.6643709,33.0214188),(37792,'tibia-fibula.tif',234,8,99,41.1134967,24.3788807,30.9463975,1.8,24.4384214,30.9543163,1.2915623,5.5410356,5.331503,332.5549907,348.0211057,6.3317109,65.2763589,60.0167578,122.1767182,9.5801231,10.3648575,0.6837093,32.8811288),(37793,'tibia-fibula.tif',234,8,100,40.6506298,24.4320442,30.9738754,1.8,24.4815862,30.9734463,1.3061593,5.4939633,5.2926117,326.7163023,342.3942669,6.3115992,64.6928745,59.4682356,121.4712836,9.5244648,10.2771393,0.6415706,32.7649088),(37794,'tibia-fibula.tif',234,8,101,40.3114516,24.4576654,31.0174617,1.8,24.5046195,31.0136248,1.2883256,5.5133243,5.3007487,320.2069013,337.0364092,6.196609,63.5827935,58.0787349,118.9983346,9.5364499,10.2579709,0.655106,32.6005488),(37795,'tibia-fibula.tif',234,8,102,39.8870565,24.4873927,31.0426067,1.8,24.5255559,31.0332438,1.2535244,5.4391374,5.287727,313.1637305,333.0348115,6.0008157,62.9826034,57.5759919,118.6611825,9.4500484,10.1978374,0.6473921,32.4021488),(37796,'tibia-fibula.tif',234,8,103,40.1656807,24.5412664,31.0744914,1.8,24.5840829,31.0717498,1.2554311,5.4593717,5.2701607,312.3813054,331.020554,6.0502803,62.8103344,57.2192781,117.7504322,9.4240002,10.163039,0.6747409,32.3199689),(37797,'tibia-fibula.tif',234,8,104,40.1658154,24.572479,31.121092,1.8,24.6178932,31.1235631,1.1793976,5.3581156,5.2948508,308.1884321,329.8190421,5.7200922,62.2905258,57.5180638,119.054433,9.4086694,10.0857671,0.6808853,32.0974989),(37798,'tibia-fibula.tif',234,8,105,40.098358,24.6312032,31.1614111,1.8,24.6812367,31.1639338,1.1622181,5.3178231,5.2994817,304.691777,327.640168,5.6281304,61.8249452,57.296336,118.4731897,9.3248001,10.0603671,0.7086263,32.0153189),(37799,'tibia-fibula.tif',234,8,106,40.2507292,24.6784018,31.1888415,1.8,24.7218342,31.1916115,1.1485636,5.283786,5.2559235,304.5736267,323.3796092,5.5818738,61.5266962,57.6430659,118.4050795,9.3248001,9.9960923,0.7010914,31.9572089),(37800,'tibia-fibula.tif',234,8,107,39.7161055,24.6747867,31.250584,1.8,24.7100226,31.2552005,1.1136338,5.3056527,5.2253414,297.7648389,318.2468601,5.3296542,60.9045101,56.122188,115.937099,9.3235133,9.9896914,0.5659676,31.9812789),(37801,'tibia-fibula.tif',234,8,108,39.5026883,24.7054088,31.2891536,1.8,24.7485542,31.2801571,1.1190769,5.1612154,5.227091,293.5723145,314.2010363,5.3292831,60.1101138,56.8804612,116.0410724,9.1264001,9.9323924,0.6934595,31.652559),(37802,'tibia-fibula.tif',234,8,109,39.4521728,24.7350469,31.3343181,1.8,24.7736972,31.3248383,1.1423457,5.1523832,5.1835908,291.5339349,310.9588748,5.4403978,59.9890861,56.5823468,115.5845687,9.1264001,9.9065991,0.6074446,31.594449),(37803,'tibia-fibula.tif',234,8,110,39.294276,24.7524751,31.3785421,1.8,24.7847406,31.3697387,1.1743028,5.1462553,5.1242948,288.1793468,307.2867323,5.5723221,59.9666381,55.9978718,115.0503912,9.0730415,9.9200002,0.6435011,31.512269),(37804,'tibia-fibula.tif',234,8,111,39.4040505,24.774735,31.4315865,1.8,24.804455,31.4213235,1.179632,5.0144186,5.1029103,285.9891297,305.0765338,5.6126931,59.7848125,57.0333577,114.7370112,9.0272001,9.8022453,0.6273082,31.289799),(37805,'tibia-fibula.tif',234,8,112,39.2354373,24.7971532,31.4842117,1.8,24.8285383,31.4754391,1.2574159,4.9643172,5.048832,283.7665583,300.4370022,5.9177881,59.5062383,57.1612461,113.9370644,8.9280001,9.822804,0.6637004,31.2076191),(37806,'tibia-fibula.tif',234,8,113,39.2131036,24.8138401,31.5220395,1.8,24.8538661,31.5114523,1.3938479,4.8059514,4.9006164,281.9277408,295.3751839,6.3330121,60.2730671,58.6622124,113.6849788,8.9280001,9.8408202,0.6495494,31.0092191),(37807,'tibia-fibula.tif',234,8,114,38.9555827,24.8154025,31.5743502,1.8,24.8438223,31.567317,1.5048627,4.7302973,4.7734737,278.1404782,290.3017971,6.4644131,60.8156269,58.7997877,113.2962229,8.8971169,9.7927034,0.6921442,30.951109),(37808,'tibia-fibula.tif',234,8,115,39.0305617,24.8073224,31.6237089,1.8,24.8478098,31.6127755,-1.5593295,4.6402266,4.6340944,275.5450242,286.6855997,6.5042383,61.8644278,59.3818036,113.1133166,8.8924123,9.762006,0.6556956,30.752709),(37809,'tibia-fibula.tif',234,8,116,39.0038095,24.7858259,31.6657715,1.8,24.8151563,31.657438,-1.5395982,4.490813,4.5921806,271.1332155,283.8923102,6.4943097,61.8208074,60.3750845,112.477712,8.7296001,9.696261,0.727492,30.5061691),(37810,'tibia-fibula.tif',234,8,117,39.159256,24.7741312,31.7006707,1.8,24.8096019,31.6982456,-1.510085,4.5022828,4.6747186,269.6724771,282.4404368,6.5025163,60.418704,59.8968316,111.8773391,8.7296001,9.744854,0.6699715,30.5883491),(37811,'tibia-fibula.tif',234,8,118,38.8295593,24.7584752,31.7403167,1.8,24.796003,31.737476,-1.4709778,4.4933506,4.698182,264.4122381,279.2880219,6.4073259,59.4459777,58.8452272,111.3789327,8.7296001,9.6423218,0.6393859,30.4721291),(37812,'tibia-fibula.tif',234,8,119,38.735889,24.7445798,31.7884543,1.8,24.7853459,31.7884933,-1.3800561,4.4444699,4.7648125,260.2351638,275.6128875,6.2239357,57.8433862,58.5525763,110.0773765,8.718256,9.6055111,0.6682894,30.1915491),(37813,'tibia-fibula.tif',234,8,120,38.2931177,24.7202996,31.839783,1.8,24.7451099,31.8432939,-1.2941336,4.4378153,4.7905893,252.9125421,270.0377744,5.9060165,56.3683829,56.9903264,107.5681685,8.5312001,9.6530318,0.6907909,29.9450092),(37814,'tibia-fibula.tif',234,8,121,38.0808302,24.7115276,31.8984044,1.8,24.7413227,31.8989303,-1.1467397,4.4820251,4.798233,249.5330532,266.4083935,5.2722891,55.5221876,55.6741756,106.823338,8.6304001,9.6229115,0.65381,29.9931491),(37815,'tibia-fibula.tif',234,8,122,37.6335805,24.6911768,31.974662,1.8,24.7266458,31.9745773,-1.0403736,4.5188224,4.7804546,243.9182614,261.9942365,4.6669856,54.8052976,53.9782804,105.6285375,8.6304001,9.5767827,0.6973908,29.9109691),(37816,'tibia-fibula.tif',234,8,123,37.2443439,24.6659121,32.0517537,1.8,24.7013984,32.0524606,-0.9577707,4.5052566,4.7670462,237.5413011,257.9188622,4.1526103,54.1045446,52.7253658,103.8000992,8.6304001,9.5133784,0.6893979,29.6303891),(37817,'tibia-fibula.tif',234,8,124,36.8816508,24.6388742,32.1380342,1.8,24.6789456,32.145585,-0.939796,4.5276852,4.7281682,233.1204807,252.9580881,4.0075337,53.5002301,51.4877845,102.6760129,8.5312001,9.5035465,0.6372381,29.4319891),(37818,'tibia-fibula.tif',234,8,125,36.2196613,24.5831691,32.2107376,1.8,24.6043081,32.2148928,-0.9444535,4.4680094,4.6951357,226.6169049,247.8652029,3.9623484,52.7919151,50.7198805,101.0580633,8.5312001,9.45059,0.6812982,29.2916992),(37819,'tibia-fibula.tif',234,8,126,35.7254264,24.5500668,32.2816813,1.8,24.5779291,32.2783635,-0.8657618,4.4738171,4.6700855,222.4220607,243.9750923,3.4535655,52.2421039,49.7163958,99.7096215,8.5312001,9.4161653,0.7257675,29.1514092),(37820,'tibia-fibula.tif',234,8,127,35.2250618,24.5071797,32.3491678,1.8,24.5280446,32.3485949,-0.8464192,4.4825531,4.6508768,217.5841762,238.7427915,3.2927781,51.3328563,48.5402342,97.9543158,8.4320001,9.3611379,0.7028792,29.0111192),(37821,'tibia-fibula.tif',234,8,128,34.8767972,24.4506768,32.4205239,1.8,24.4695382,32.4184174,-0.8180714,4.4414961,4.6185345,214.6707586,233.6305343,3.0961874,50.5854255,48.3329835,96.834448,8.5312001,9.3421967,0.7328151,29.1173691),(37822,'tibia-fibula.tif',234,8,129,34.6374894,24.4166252,32.4841298,1.8,24.453262,32.4747414,-0.7001973,4.476571,4.6038704,211.3726716,231.909982,2.396977,50.3728303,47.2175405,95.9010002,8.5312001,9.3421967,0.7328151,28.9530092),(37823,'tibia-fibula.tif',234,8,130,34.1269511,24.3327385,32.5448257,1.8,24.3469062,32.5318589,-0.7656215,4.3871347,4.5700834,205.3053746,226.0653976,2.7314557,49.4663615,46.7971446,93.1713033,8.3328001,9.2856712,0.709785,28.6724292),(37824,'tibia-fibula.tif',234,8,131,33.9049926,24.276786,32.6119815,1.8,24.2925734,32.5970681,-0.6946164,4.4089632,4.5774677,202.5016308,222.972737,2.3152375,48.7109361,45.9295354,92.9480391,8.3328001,9.2633894,0.7551044,28.5902492),(37825,'tibia-fibula.tif',234,8,132,33.577267,24.2268801,32.6731878,1.8,24.2533052,32.6522915,-0.6349057,4.4053254,4.6063438,198.6178387,220.7606258,1.9685765,47.9253469,45.0858492,91.0214511,8.3328001,9.2761284,0.7248661,28.5321392),(37826,'tibia-fibula.tif',234,8,133,33.0155815,24.1512112,32.7660332,1.8,24.1734189,32.7562224,-0.6062121,4.3985251,4.5220485,194.7836728,216.0284424,1.7862799,47.7722523,44.2838603,90.7892479,8.3328001,9.1457882,0.7086263,28.3337392),(37827,'tibia-fibula.tif',234,8,134,32.851851,24.0931309,32.8479384,1.8,24.1227893,32.8351197,-0.5254223,4.374231,4.4277244,192.2971557,215.4417094,1.377483,48.6574349,43.9613625,90.2912703,8.2336001,9.1285564,0.739277,28.3337392),(37828,'tibia-fibula.tif',234,8,135,32.6745566,24.050064,32.9248029,1.8,24.0894993,32.9180293,-0.4372949,4.3185844,4.376883,188.6446641,216.3351692,0.9766654,49.4267656,43.6820605,89.4864133,8.2336001,9.1285564,0.739277,28.5562092),(37829,'tibia-fibula.tif',234,8,136,32.0353679,23.9465084,33.0050428,1.8,23.9725137,32.9962589,-0.433073,4.2999689,4.366279,183.8362512,211.3216791,0.9403249,48.3985746,42.7529258,87.33803,8.1344001,9.0815421,0.7003326,28.2175192),(37830,'tibia-fibula.tif',234,8,137,31.617612,23.8750564,33.0546012,1.8,23.8977795,33.0480123,-0.440389,4.2661421,4.4102655,179.9626615,209.7653215,0.957615,47.5629692,42.1839347,85.7088062,8.1344001,9.0945358,0.6849621,28.0772292),(37831,'tibia-fibula.tif',234,8,138,30.9368791,23.7797738,33.1175246,1.8,23.8044719,33.1099369,-0.416207,4.2350408,4.3412098,175.3876366,204.9628647,0.8427915,47.2133059,41.413447,84.3499169,8.0352001,9.0179294,0.6919214,27.9369392),(37832,'tibia-fibula.tif',234,8,139,30.5732012,23.6860292,33.1660907,1.8,23.702678,33.1598314,-0.4175836,4.231265,4.3152593,172.3664561,202.5901266,0.8380782,46.9473824,40.7363886,83.8459247,8.0631362,8.9960784,0.7229794,28.0191192),(37833,'tibia-fibula.tif',234,8,140,30.1306669,23.5917271,33.2278933,1.8,23.6104202,33.2235679,-0.4020442,4.1706121,4.3011727,167.8867887,199.8412142,0.7689143,46.4620294,40.2547124,82.7472979,8.0001829,8.9417673,0.6989996,27.8788292),(37834,'tibia-fibula.tif',234,8,141,29.8102128,23.5188473,33.2795582,1.8,23.5398531,33.2680706,-0.3432416,4.1314991,4.3320382,163.771345,199.7641255,0.562718,46.1131954,39.6396902,81.5529678,7.9360001,8.9417673,0.6989996,27.8788292),(37835,'tibia-fibula.tif',234,8,142,29.7335001,23.4485443,33.320073,1.8,23.4678734,33.3120634,-0.3034769,4.0779333,4.3931844,161.1323484,201.6362636,0.4425601,45.8975187,39.5132377,80.8320686,7.8679988,8.9878705,0.6523309,27.8207192),(37836,'tibia-fibula.tif',234,8,143,29.7639763,23.3569064,33.3867541,1.8,23.3660452,33.3719991,-0.2687802,4.0685423,4.363945,160.9390725,199.944131,0.349825,45.8172895,39.5569372,80.3746806,7.8368001,8.9307553,0.7146503,27.7385392),(37837,'tibia-fibula.tif',234,8,144,29.7045119,23.286442,33.451357,1.8,23.3096427,33.4423658,-0.2342753,4.0539036,4.4595159,158.4735213,203.3271857,0.2667868,45.5940039,39.0915864,78.8642553,7.7376001,8.9719807,0.6125376,27.8547592),(37838,'tibia-fibula.tif',234,8,145,29.3523728,23.1499014,33.530911,1.8,23.1565163,33.525294,-0.2294467,4.0476836,4.4184148,155.9559587,199.0282933,0.2530584,45.0451813,38.5296816,78.9021323,7.8368001,8.9092427,0.65909,27.7385392),(37839,'tibia-fibula.tif',234,8,146,29.4517194,23.0934525,33.5862542,1.8,23.1265887,33.5749704,-0.2278398,4.0211158,4.4860826,154.5553459,203.1030902,0.2504324,45.2740421,38.4359352,78.1764295,7.7376001,9.0293801,0.6215266,27.8547592),(37840,'tibia-fibula.tif',234,8,147,29.2087939,22.9995837,33.6515846,1.8,23.029766,33.6429032,-0.2207519,4.0111147,4.4955375,152.718706,201.2396406,0.2334023,44.7643117,38.0738818,77.4668412,7.7376001,9.0075568,0.6368933,27.7385392),(37841,'tibia-fibula.tif',234,8,148,29.5573315,22.9114267,33.700127,1.8,22.9594903,33.6884867,-0.2006395,3.9805947,4.5702938,151.897562,206.6122492,0.1956643,45.2076511,38.1595144,77.7467486,7.6384001,9.0793746,0.5910329,27.8207192),(37842,'tibia-fibula.tif',234,8,149,29.6664397,22.7982268,33.7569326,1.8,22.8281317,33.7505259,-0.1936514,3.9531944,4.5753819,151.5747315,207.0057109,0.1831132,45.243373,38.3423419,77.9770525,7.7376001,9.053325,0.6062377,27.9269691),(37843,'tibia-fibula.tif',234,8,150,29.9167703,22.7100126,33.7963139,1.8,22.7636496,33.783102,-0.1698455,3.932452,4.6666869,151.9238891,213.3914646,0.1424595,45.7265443,38.6333737,77.8333137,7.6384001,9.1699657,0.5459853,27.8788292),(37844,'tibia-fibula.tif',234,8,151,30.046508,22.5828205,33.8188648,1.8,22.61561,33.800778,-0.1811019,3.8900275,4.6120032,153.0142313,213.4892153,0.1624559,46.28991,39.3349996,77.0407549,7.6384001,9.2405214,0.516483,28.0431891),(37845,'tibia-fibula.tif',234,8,152,30.0194986,22.4916892,33.8561772,1.8,22.5368211,33.8355131,-0.1906948,3.8750761,4.6216266,153.6122151,216.2901555,0.1797459,46.7995734,39.6410832,77.5350537,7.7376001,9.2899093,0.5257685,28.0431891),(37846,'tibia-fibula.tif',234,8,153,30.1347837,22.420154,33.90569,1.8,22.4960255,33.8875693,-0.1927099,3.8886617,4.699442,154.1770686,220.8765582,0.1842222,47.0005921,39.6478476,77.5343705,7.6384001,9.3910499,0.5440427,28.5221691),(37847,'tibia-fibula.tif',234,8,154,30.2015841,22.3284911,33.9295777,1.8,22.3918497,33.9130567,-0.1941793,3.8741604,4.6977972,156.3581325,223.4606637,0.1874213,47.567116,40.3592305,77.8449158,7.7376001,9.469834,0.3980143,28.3237691),(37848,'tibia-fibula.tif',234,8,155,30.3187538,22.2397105,33.9642069,1.8,22.2964292,33.9560082,-0.171682,3.9070215,4.7081997,157.6914346,227.5593111,0.1474818,48.3325532,40.3610361,79.5469526,7.7376001,9.4988858,0.430949,29.0011491),(37849,'tibia-fibula.tif',234,8,156,30.5383052,22.1536467,34.0049584,1.8,22.215074,33.992268,-0.1406632,3.9577968,4.7347128,159.7240229,233.0049285,0.1000434,49.2120512,40.3568026,78.8281919,7.7376001,9.6530318,0.3900481,28.8027491),(37850,'tibia-fibula.tif',234,8,157,30.4086006,22.0616119,34.0434234,1.8,22.1143593,34.0314106,-0.1336073,4.0022502,4.7561479,162.0072911,236.716747,0.0899332,49.7706868,40.479051,80.6134898,7.8368001,9.6530318,0.3900481,28.6624591),(37851,'tibia-fibula.tif',234,8,158,30.1970929,21.9400773,34.0611777,1.8,22.0029898,34.0543442,-0.1151496,4.0827682,4.8313655,166.2668224,241.1988275,0.0664383,49.9235314,40.724042,80.5076567,7.9157374,9.8368194,0.382379,29.702599),(37852,'tibia-fibula.tif',234,8,159,29.725477,21.776951,34.1029003,1.8,21.837824,34.0941682,-0.0916029,4.130706,4.9044512,168.7163907,243.8943116,0.0414554,49.7291747,40.8444443,81.0410215,7.9360001,9.8742627,0.3916999,29.305799),(37853,'tibia-fibula.tif',234,8,160,29.4036471,21.6380953,34.1341171,1.8,21.708306,34.1266722,-0.080137,4.1983297,5.0038429,173.0842374,249.5668982,0.0314041,49.8750465,41.2269278,81.4409247,8.0947973,10.0039648,0.3970794,29.726669),(37854,'tibia-fibula.tif',234,8,161,29.2387674,21.4803466,34.1769789,1.8,21.5489925,34.1708944,-0.1052739,4.2574781,5.1193329,179.0075633,256.4435793,0.0538077,50.0931637,42.0454453,82.7767483,8.2280979,10.0955194,0.3932794,29.983179),(37855,'tibia-fibula.tif',234,8,162,29.2532303,21.307023,34.2148161,1.8,21.3923063,34.2094976,-0.1132213,4.3282375,5.2572535,187.2153607,265.0695562,0.0622332,50.4197782,43.2544108,83.2258636,8.3328001,10.2790542,0.3858827,30.404049),(37856,'tibia-fibula.tif',234,8,163,29.3170907,21.1504137,34.2871869,1.8,21.2400213,34.2816052,-0.1224955,4.4137792,5.3992062,196.5772574,275.108958,0.0729519,50.9535936,44.5371755,84.1258547,8.5312001,10.5002159,0.3875238,31.0473889),(37857,'tibia-fibula.tif',234,8,164,29.7355675,21.0244006,34.3699867,1.8,21.1298246,34.3777073,-0.1728409,4.4377328,5.5173703,207.8371684,286.8256622,0.1465848,51.9859363,46.8340875,88.2250937,8.6304001,10.5432383,0.3455556,31.2217189),(37858,'tibia-fibula.tif',234,8,165,30.292069,20.880478,34.4248337,1.8,21.0093481,34.4352538,-0.2289496,4.4982946,5.7847868,218.3766327,301.2190517,0.2600495,52.070899,48.5465386,88.5156033,8.8288001,10.8509567,0.3940879,32.0634588),(37859,'tibia-fibula.tif',234,8,166,30.7392678,20.7689753,34.4980179,1.8,20.9353402,34.528292,-0.2695704,4.5576277,5.8782769,231.4954943,311.1950935,0.3633636,52.939849,50.7929806,91.2007862,8.9280001,11.019687,0.4072558,32.3540089),(37860,'tibia-fibula.tif',234,8,167,31.706042,20.6430092,34.5312576,1.8,20.8156691,34.5936313,-0.359086,4.7265142,5.9392502,246.1018718,332.901974,0.6525899,56.0511786,52.0683663,97.3430029,9.1264001,11.1263316,0.3838176,32.8570589),(37861,'tibia-fibula.tif',234,8,168,32.3852588,20.3945594,34.566782,1.8,20.5757416,34.6410807,-0.4161861,4.7876143,6.0989296,262.0328588,350.571258,0.8821653,57.4807843,54.7314057,100.4419905,9.5232002,11.3105404,0.3772491,33.7228687),(37862,'tibia-fibula.tif',234,8,169,33.7889878,20.2138219,34.6503388,1.8,20.3691322,34.711962,-0.3977861,4.8585477,6.2976889,288.5771823,374.8189562,0.8450735,59.5169059,59.3957695,105.3319733,9.7216002,11.6064002,0.3947911,34.4002487),(37863,'tibia-fibula.tif',234,8,170,35.4324055,20.0099011,34.724669,1.8,20.1712197,34.7904967,-0.4088745,4.9718047,6.5148063,307.1183115,417.4131611,0.9334509,64.0714613,61.7719986,111.2129876,9.9200002,11.9576128,0.4005345,35.3341387),(37864,'tibia-fibula.tif',234,8,171,36.9999918,19.7666299,34.7639336,1.8,19.9198814,34.8461333,-0.4143514,5.0307079,6.7132265,339.670832,444.7369587,0.9995163,66.2478706,67.5194898,116.7957044,10.1579883,12.3239784,0.3879801,36.4904987),(37865,'tibia-fibula.tif',234,8,172,38.0869238,19.5158841,34.7936358,1.8,19.6583204,34.9253772,-0.4269121,5.1733542,6.8934147,351.774102,496.1896786,1.0883169,71.9802444,67.9972965,123.0106864,10.3705826,12.6296056,0.6010738,38.1017687),(37866,'tibia-fibula.tif',234,8,173,41.2237879,19.3187712,34.8825877,1.8,19.4680269,35.027252,-0.4677986,5.2765427,7.1482937,398.4051937,568.7899835,1.3970129,79.5700358,75.5049688,135.2481505,10.606812,13.1790478,0.5817396,39.2680987),(37867,'tibia-fibula.tif',234,8,174,44.6886035,18.9553249,35.03118,1.8,19.0931002,35.1750331,-0.532742,5.5302774,7.5083991,435.2124563,651.715428,1.9213089,86.7981872,78.6963158,144.0893329,10.9143426,13.6196942,0.7441844,41.5708485),(37868,'tibia-fibula.tif',234,8,175,51.0692063,18.7929873,35.0623815,1.8,18.9202556,35.2684464,-0.5269616,5.7789918,7.7760388,529.7315122,754.5332801,2.1527193,97.0331172,91.6650401,163.3969655,11.4027447,14.0989693,0.8850668,42.5047385),(37869,'tibia-fibula.tif',234,8,176,59.1789132,18.6732627,35.043382,1.8,18.868488,35.2452512,-0.3672472,6.2988579,7.9639757,600.5798194,894.1594079,1.2715095,112.2755068,95.3474155,187.6844072,11.6261193,14.351124,0.3676701,43.4527284),(37870,'tibia-fibula.tif',234,8,177,68.6876251,18.7202387,34.9794746,1.8,18.8414674,35.1019439,-0.3258651,6.2187356,7.5778785,580.2079448,943.7871201,1.1732105,124.5450312,93.2999858,199.0075825,11.1709689,14.4672243,0.3499426,42.6591284),(37871,'tibia-fibula.tif',234,8,178,69.7036945,18.823608,34.8546972,1.8,18.8215495,34.9834833,-0.4266477,5.5111789,7.3190316,532.2925637,965.0400364,1.9894373,131.8535139,96.5841556,204.580011,10.5360419,14.6080213,0.3754623,41.9236384),(37872,'tibia-fibula.tif',234,8,179,74.4613744,18.4466696,34.8934083,1.8,18.4997531,34.9512365,-0.390356,5.1621388,7.6189618,492.1690323,1026.8221227,1.7969231,134.7719212,95.3420768,199.2486824,10.0082773,14.8525295,0.2773822,41.8414584),(37873,'tibia-fibula.tif',234,8,180,73.8095115,18.2022497,34.589241,1.8,18.2340174,34.6807657,-0.3291202,5.3055522,7.5043701,434.4893988,1087.0643076,1.2850861,144.8575013,81.8933418,202.7546261,9.7329453,14.8206927,0.4426926,42.3304085),(37874,'tibia-fibula.tif',234,8,181,47.4891779,17.4898525,33.5391409,1.8,17.2990941,33.7651569,-0.4966944,4.0532906,8.4094067,143.8319383,855.8877373,1.7972536,101.7774223,35.4852269,118.8801576,7.8477456,15.8347566,0.6610432,47.7013084),(37875,'tibia-fibula.tif',234,8,182,20.7239962,15.9344282,34.6608777,1.8,15.8675492,34.8905486,-0.7768975,3.4633989,7.6368596,38.4124475,306.3750395,1.6976399,40.1179351,11.0909683,44.6061211,3.4520168,8.754927,1.2239614,24.0669296),(37876,'tibia-fibula.tif',234,8,183,6.0714028,14.516702,34.9463299,1.8,14.5209489,34.987502,-1.4081434,0.9749586,2.8648864,1.2469856,9.1721809,0.9853649,3.2015862,1.2790139,3.6328439,2.0386543,5.2725524,1.3623311,12.5074597),(37877,'tibia-fibula.tif',234,8,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37878,'tibia-fibula.tif',234,8,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37879,'metatarsal.tif',234,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37880,'metatarsal.tif',234,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37881,'metatarsal.tif',234,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37882,'metatarsal.tif',234,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37883,'metatarsal.tif',234,10,5,0.4357226,14.2041751,5.5620849,1.8,14.1814704,5.5591688,0.28009,0.3515046,1.1879292,0.0090703,0.1277868,0.0055497,0.107571,0.0258041,0.1151916,0.9651094,2.493084,2.7305281,6.8961209),(37884,'metatarsal.tif',234,10,6,4.1841267,13.4041046,6.4754069,1.8,13.4292893,6.4204216,0.5135824,1.6297325,2.5452404,2.2955736,3.9138636,0.1683248,1.5377187,1.4085585,2.4396045,2.7811719,4.9896103,2.2730533,16.9674105),(37885,'metatarsal.tif',234,10,7,12.9117764,12.9535946,7.1725563,1.8,12.9604316,7.0911821,0.6796318,2.8831306,4.7470985,16.503816,28.2783726,0.8500697,5.9569804,5.7242694,9.2003419,4.6165432,6.9645307,2.2429092,22.1433085),(37886,'metatarsal.tif',234,10,8,18.472002,12.5775553,7.9781763,1.8,12.6002691,8.0211243,1.0807102,3.697672,8.4305208,42.7166829,105.7590308,2.3965567,12.5447802,11.5523181,17.5822226,6.1950076,9.0061168,2.1804562,29.5626648),(37887,'metatarsal.tif',234,10,9,29.691797,12.2188105,9.3708567,1.8,12.2696545,9.3492358,1.0810336,4.7138773,7.7533705,87.1952401,343.1378866,3.8535416,44.2566091,18.4975625,55.1216291,7.6628296,13.8129539,2.2660778,49.5679358),(37888,'metatarsal.tif',234,10,10,47.1208378,11.4832436,9.9570048,1.8,11.6779339,10.0246105,0.931644,5.9815061,7.5197501,219.1244498,664.7888144,5.0589677,88.4057052,36.633658,117.3242851,9.1799629,13.7680077,2.2688043,53.5291775),(37889,'metatarsal.tif',234,10,11,60.0727441,11.368884,10.6232973,1.8,11.5609475,10.6339145,0.9450803,6.5655969,7.0645689,364.0456633,842.7645564,6.5777802,119.2945478,55.4474587,170.8085865,10.486081,13.799025,2.5618349,53.8582296),(37890,'metatarsal.tif',234,10,12,65.842392,11.2962548,11.0762643,1.8,11.4662019,11.0193053,1.0706068,6.4969177,6.7622318,488.668735,884.8678759,8.4496818,130.854414,75.2154723,191.244718,10.8164301,14.0101807,2.5466296,61.6954006),(37891,'metatarsal.tif',234,10,13,66.1494359,11.2653538,11.1483739,1.8,11.4023279,11.0688151,1.0637441,6.4887493,6.7242854,517.6329701,813.7865301,8.4251257,121.0220085,79.7739201,184.7934628,11.2672187,14.041519,2.4864059,51.5471276),(37892,'metatarsal.tif',234,10,14,64.2181909,11.2060935,10.9769671,1.8,11.3439753,10.9696874,0.8802291,6.7333008,7.046536,506.2024836,754.0256649,6.3604203,107.0065722,75.1789501,174.8019116,11.4382132,13.9405204,2.448469,83.2267111),(37893,'metatarsal.tif',234,10,15,68.0037736,10.9941197,11.1208431,1.8,11.1676285,11.0951244,0.8755341,6.8149984,6.8532616,502.4781697,778.1294205,6.6830539,113.5414729,73.7312237,180.3281049,11.4490651,13.7643907,2.4708411,53.9872088),(37894,'metatarsal.tif',234,10,16,70.8676857,10.7383709,11.1161967,1.8,10.9328641,11.1395152,0.8515575,6.7914037,6.8403136,476.6634011,793.3644268,6.6847884,115.9836334,70.1862855,176.575074,11.3345591,14.5377616,1.4129371,58.971363),(37895,'metatarsal.tif',234,10,17,69.8671126,10.5504193,11.2844177,1.8,10.7385938,11.259551,0.9347638,5.7950781,6.4675848,425.8010971,750.2254778,7.5357961,115.9977798,73.4763342,163.527786,11.2360969,14.6627696,1.4102468,56.8249963),(37896,'metatarsal.tif',234,10,18,11.6505154,8.1510487,9.6225825,1.8,8.1619563,9.7105956,1.4346711,2.556943,6.9389856,12.2215837,56.8155833,1.9059934,8.1878802,4.7797638,9.943863,3.9900993,5.0708474,0.5880026,22.583671),(37897,'metatarsal.tif',234,10,19,35.0048151,9.1199008,11.3584952,1.8,9.2170962,11.3368091,1.2578159,6.890034,5.2281139,131.0473865,215.0052529,5.2810613,41.1248217,19.019846,48.578641,5.1506024,10.0341274,1.8186078,28.488767),(37898,'metatarsal.tif',234,10,20,43.0457004,9.7102366,11.3977552,1.8,9.8089143,11.3481798,0.751548,4.718636,5.2001165,186.8094966,254.9596422,3.3444762,49.029602,39.5897243,77.3098222,8.7309187,10.4467549,2.7683778,37.0565649),(37899,'metatarsal.tif',234,10,21,42.1678156,10.006993,11.3681259,1.8,10.1168706,11.3519042,0.2562054,5.1931907,5.5725793,206.431503,269.1619648,0.4513184,48.3011457,39.7504185,78.4329942,8.7917723,10.5104947,2.9791937,35.71394),(37900,'metatarsal.tif',234,10,22,36.8672234,9.9707115,11.5725336,1.8,10.106137,11.561971,0.2225212,4.8216259,5.9661042,181.7242207,250.9323662,0.2992622,42.0596688,37.689407,69.5278783,8.4522568,10.6661662,2.9592822,33.9760483),(37901,'metatarsal.tif',234,10,23,33.6009284,9.8446051,11.7475826,1.8,10.0031297,11.7294437,0.3198391,4.4038124,5.9068769,157.0145398,227.6839196,0.5536093,38.5455668,35.6542298,61.2980699,8.0129203,10.6032003,2.9073374,34.6816878),(37902,'metatarsal.tif',234,10,24,31.0662186,9.745056,11.9173446,1.8,9.8949305,11.884345,0.4827416,3.9265001,5.2117898,136.5410518,203.5603099,1.1157444,39.0576595,34.7742388,56.4337613,7.4966658,10.1592867,2.9441971,32.3779045),(37903,'metatarsal.tif',234,10,25,29.1191018,9.592604,12.0555428,1.8,9.7213301,12.0291662,0.6328644,4.3894649,4.5915785,117.9396663,179.860491,1.6977466,39.1718207,26.8688026,53.7088669,7.2898059,9.6453537,2.0507468,31.237792),(37904,'metatarsal.tif',234,10,26,30.9316694,9.6683718,12.019198,1.8,9.7825645,11.9874852,0.5835932,4.1231333,4.467471,115.2245843,171.5143996,1.5652952,38.3918328,27.9458793,57.2319059,7.0921811,9.4275,2.0984233,30.9548461),(37905,'metatarsal.tif',234,10,27,28.4770295,9.6942819,11.9767785,1.8,9.8098493,11.9351238,0.4794808,3.9552399,4.5071418,115.3958664,165.9210904,1.0100559,36.812929,29.1754402,58.0775453,7.1615246,9.0693797,2.1677593,29.9461524),(37906,'metatarsal.tif',234,10,28,27.7804404,9.6995526,11.9822041,1.8,9.8195813,11.931869,0.372559,3.8002626,4.6145278,113.9564938,162.292751,0.6134664,35.1699585,29.9864785,56.7873781,7.1369525,8.8625601,2.1918145,29.1233128),(37907,'metatarsal.tif',234,10,29,26.4657788,9.7301173,12.0559486,1.8,9.855511,12.0082001,0.3134161,3.652547,4.5642837,110.5227724,155.4497276,0.4192846,34.0578585,30.2590964,55.811017,7.0303813,8.664085,2.7384771,29.0404399),(37908,'metatarsal.tif',234,10,30,26.6607344,9.7555981,12.101069,1.8,9.8811986,12.0447763,0.2412056,3.6600717,4.4209849,111.1072017,152.4826194,0.253546,34.4906448,30.356564,55.0926017,7.0214346,8.5453591,2.656476,29.0002232),(37909,'metatarsal.tif',234,10,31,25.6790524,9.8203146,12.1993665,1.8,9.9515315,12.1440431,0.1638904,3.6179008,4.6872041,111.2277284,154.8362127,0.1139313,33.0338104,30.7437197,53.4581335,7.0825025,8.6269472,0.0543681,30.4894962),(37910,'metatarsal.tif',234,10,32,25.1012692,9.832427,12.2486177,1.8,9.9694867,12.1933393,0.0809926,3.6348148,4.8094557,107.5149695,155.0471466,0.0273833,32.2379824,29.5792155,51.0028602,6.9347067,8.7860927,0.1607627,29.2321837),(37911,'metatarsal.tif',234,10,33,24.7179257,9.8223611,12.2891086,1.8,9.9457435,12.2281196,0.0322978,3.6436789,4.9692059,104.1164411,153.3300071,0.004296,30.8560385,28.5745376,49.5776093,6.8939289,8.873596,0.1792628,28.6402941),(37912,'metatarsal.tif',234,10,34,24.9861827,9.8314605,12.311991,1.8,9.9433136,12.2472204,0.0133395,3.6259271,4.9180241,103.1395423,154.0208723,0.000741,31.3176329,28.4450129,50.0911809,6.9120879,8.863335,0.1727572,29.8490607),(37913,'metatarsal.tif',234,10,35,24.8728098,9.7891644,12.3641226,1.8,9.8886098,12.3092473,-0.0007444,3.5756417,4.9205247,99.9925117,150.664425,0.0000024,30.6195849,27.9649141,48.8343104,6.753441,8.843942,0.1597021,27.7546899),(37914,'metatarsal.tif',234,10,36,25.2711773,9.7484872,12.4124532,1.8,9.8406772,12.3523104,0.0083572,3.5824581,4.8315701,99.9941593,147.6756977,0.0002942,30.5647428,27.9121642,49.1819891,6.7285998,8.7439764,0.12768,28.2803649),(37915,'metatarsal.tif',234,10,37,25.2588506,9.7372068,12.4706523,1.8,9.8214514,12.4158898,-0.0011815,3.5281728,4.738708,98.1880775,145.1784774,0.0000059,30.6367214,27.8297243,48.9308153,6.7377298,8.6650758,0.1084167,27.0941461),(37916,'metatarsal.tif',234,10,38,25.5847591,9.7230003,12.5148217,1.8,9.8122439,12.4561708,-0.000901,3.5423206,4.6940535,98.4804547,144.6800697,0.0000035,30.8219898,27.8011128,48.9965886,6.6795065,8.665274,0.1973956,27.8542211),(37917,'metatarsal.tif',234,10,39,25.3704779,9.6826188,12.570898,1.8,9.7562802,12.5171564,-0.009473,3.5515859,4.5733641,96.0737491,139.4492207,0.0003795,30.4916067,27.0509437,48.3176649,6.6131694,8.5453591,0.1583844,26.8798545),(37918,'metatarsal.tif',234,10,40,25.3438873,9.6645022,12.61053,1.8,9.7355363,12.5546116,0.0091405,3.5569885,4.4438802,95.1816902,135.5115618,0.000353,30.4939726,26.7590658,47.8778536,6.5755607,8.4355511,0.2028451,27.025492),(37919,'metatarsal.tif',234,10,41,25.2372841,9.6375296,12.6629489,1.8,9.7037506,12.610838,0.0188184,3.5050269,4.3394294,93.4205765,131.8896876,0.0014894,30.3933246,26.6533121,47.9207014,6.5424227,8.3236759,0.1697783,26.1398878),(37920,'metatarsal.tif',234,10,42,25.3184839,9.6324974,12.6931908,1.8,9.7043095,12.6356932,0.017229,3.4802737,4.2282094,92.7614157,130.4603574,0.0012525,30.8547534,26.6534828,48.1477711,6.5284035,8.2659244,0.1709761,26.265417),(37921,'metatarsal.tif',234,10,43,25.2415472,9.5858375,12.7241527,1.8,9.6527132,12.666363,0.0047477,3.5070569,4.2361655,91.9598445,128.0186181,0.0000949,30.2204003,26.221372,47.6209517,6.5816321,8.2467922,0.1569713,26.5140357),(37922,'metatarsal.tif',234,10,44,25.401153,9.584528,12.7455088,1.8,9.6559098,12.6818028,-0.0044074,3.548987,4.1943091,92.1878522,127.6794736,0.0000823,30.4411219,25.9758215,48.1015407,6.6218002,8.2292848,0.1429041,27.1142545),(37923,'metatarsal.tif',234,10,45,25.1659754,9.5420109,12.793563,1.8,9.6048008,12.7399448,0.0129532,3.4975762,4.0945027,90.383549,123.9683195,0.0007038,30.2767706,25.8417669,47.0991968,6.4695635,8.1630875,0.136821,26.1967628),(37924,'metatarsal.tif',234,10,46,25.1571762,9.4838398,12.8337102,1.8,9.5424385,12.7833156,0.0456247,3.5196228,3.9843847,90.2603582,121.1566872,0.0087219,30.4078791,25.6448951,47.3449369,6.5046002,8.0827651,0.1162616,26.031017),(37925,'metatarsal.tif',234,10,47,24.8972327,9.4293267,12.868655,1.8,9.4775667,12.8159697,0.0474911,3.5267587,3.9728868,89.2443719,117.239408,0.0093519,29.5098786,25.3049274,46.1232391,6.5046002,8.0179279,0.1098501,26.0369065),(37926,'metatarsal.tif',234,10,48,24.9996947,9.4132509,12.9178419,1.8,9.4662548,12.8695581,0.0823562,3.500676,3.9413939,88.9035512,116.2997696,0.0281965,29.507269,25.3961098,46.2841067,6.4460002,7.942192,0.0886559,25.9197065),(37927,'metatarsal.tif',234,10,49,25.0897909,9.388339,12.9382771,1.8,9.4430167,12.8928793,0.1086263,3.5342769,4.0018531,88.9149773,115.1982626,0.0491482,28.7862297,25.1578979,46.5077023,6.4965475,7.9153397,0.1261915,25.6024336),(37928,'metatarsal.tif',234,10,50,24.8755812,9.341265,12.9617532,1.8,9.3938534,12.9185908,0.1345928,3.5422852,4.0228975,87.8713892,112.0508857,0.0746521,27.8532789,24.8064126,45.7728644,6.4886768,7.8788132,0.0819059,26.2595274),(37929,'metatarsal.tif',234,10,51,24.6523127,9.2988993,12.9879661,1.8,9.353747,12.9463136,0.1888567,3.525874,4.0407058,86.8790852,109.2920216,0.1448112,27.047755,24.6404398,45.4484062,6.4284516,7.7785846,0.1056656,25.7622899),(37930,'metatarsal.tif',234,10,52,24.6030024,9.2733899,13.0119784,1.8,9.3239924,12.965478,0.2402681,3.4854968,4.0769757,86.2402306,107.6553651,0.2321968,26.4056921,24.7425933,45.2288383,6.4856287,7.7735061,2.436237,26.3139628),(37931,'metatarsal.tif',234,10,53,24.37702,9.2283784,13.0498488,1.8,9.2799832,13.009513,0.2741958,3.4730338,4.0856553,85.2730373,105.1987185,0.2978789,25.74831,24.552896,44.309533,6.4371661,7.7805709,2.4468544,25.5337794),(37932,'metatarsal.tif',234,10,54,24.4177613,9.1945194,13.0835279,1.8,9.2473613,13.0417778,0.3315597,3.5383502,4.1181467,84.1884854,104.6463169,0.4312262,25.4110224,23.793147,44.4952031,6.4805798,7.828969,2.4995885,26.8313086),(37933,'metatarsal.tif',234,10,55,24.378266,9.1397346,13.1171842,1.8,9.1909304,13.0716026,0.4089802,3.7239705,4.1509707,83.677522,103.520152,0.6425483,24.9387818,22.4699743,44.2770282,6.4983418,7.8175565,2.4890963,25.4425774),(37934,'metatarsal.tif',234,10,56,24.2670997,9.0996859,13.1610024,1.8,9.1496548,13.1155997,0.4720626,3.8618457,4.19908,81.6517149,103.0970572,0.8363018,24.5522966,21.1431843,43.8232845,6.3874002,7.8432112,2.472686,25.7740691),(37935,'metatarsal.tif',234,10,57,24.2905391,9.0690258,13.2126614,1.8,9.1183023,13.1719501,0.5125668,3.9990086,4.2022604,79.9572948,102.6764765,0.9736767,24.4336302,19.9942793,43.4513853,6.4853129,7.8561165,2.4353936,26.5081461),(37936,'metatarsal.tif',234,10,58,24.121166,9.001062,13.2612812,1.8,9.041499,13.2265941,0.6074781,3.8737228,4.1823855,78.0187498,101.0588651,1.3098236,24.1629722,20.1405091,42.7388891,6.3760726,7.8641988,2.4936206,25.3253774),(37937,'metatarsal.tif',234,10,59,24.3530945,8.9968043,13.3089101,1.8,9.0385403,13.2771592,0.6291025,3.8391938,4.216673,76.5432957,102.1352506,1.4053249,24.2217624,19.9373355,42.226328,6.3874002,7.8641988,2.4936206,25.3680336),(37938,'metatarsal.tif',234,10,60,24.1127432,8.9521194,13.3379437,1.8,8.988544,13.3032911,0.6764769,4.1458672,4.1932095,74.0080649,100.5710373,1.5751175,23.9842623,17.8510459,41.3800889,6.3874002,7.8641988,2.4936206,25.3479253),(37939,'metatarsal.tif',234,10,61,24.1057715,8.9359169,13.3627818,1.8,8.9761792,13.3314423,0.688771,3.8201588,4.1744632,72.8831665,100.2602872,1.6230144,24.0175283,19.0785699,40.9602984,6.3288002,7.8663818,2.5577223,24.9252315),(37940,'metatarsal.tif',234,10,62,24.0287583,8.9186609,13.3948298,1.8,8.9551965,13.3641227,0.7032669,3.8217509,4.1837187,71.4993374,100.0904083,1.6749552,23.9237899,18.7085289,40.6472057,6.2702002,7.9164243,2.4610714,24.9193419),(37941,'metatarsal.tif',234,10,63,23.907815,8.9029503,13.4262141,1.8,8.9382242,13.3956779,0.7171879,3.7773275,4.1917696,70.0183846,100.0688714,1.7213673,23.8727031,18.5364877,40.2018177,6.3288002,7.9164243,2.4610714,24.7050503),(37942,'metatarsal.tif',234,10,64,23.8448,8.9017596,13.4437156,1.8,8.9424962,13.4111037,0.7244613,3.9686356,4.159628,68.4066958,99.8691935,1.7454944,24.0091647,17.2368295,39.9816503,6.2702002,7.9354875,2.4818448,24.4422128),(37943,'metatarsal.tif',234,10,65,23.7323604,8.8947159,13.4685132,1.8,8.9329704,13.437985,0.7245191,3.6594935,4.1657122,66.755339,99.5457545,1.7374906,23.8964553,18.2416883,39.6346746,6.3288002,7.9164243,2.4610714,24.4221044),(37944,'metatarsal.tif',234,10,66,23.6148291,8.8922787,13.4972601,1.8,8.9290792,13.4699263,0.7312172,3.6294544,4.1405793,65.1753,99.0758384,1.7550738,23.9280139,17.9573269,39.1251799,6.2702002,7.8942707,2.4297458,25.1478524),(37945,'metatarsal.tif',234,10,67,23.5744879,8.8878648,13.5162012,1.8,8.9212756,13.4880316,0.7362206,3.8217083,4.1513491,63.3361189,99.1979342,1.7716295,23.8953486,16.5727244,38.7141858,6.2702002,7.9354875,2.4818448,24.4019961),(37946,'metatarsal.tif',234,10,68,23.4936888,8.8875598,13.5363058,1.8,8.9214716,13.5114034,0.7506722,3.4773597,4.1524805,62.0036406,98.9983886,1.8219434,23.8407836,17.8306664,38.3827341,6.2603183,7.9164243,2.4610714,24.3274523),(37947,'metatarsal.tif',234,10,69,23.3435842,8.8865763,13.5574898,1.8,8.9164952,13.535293,0.7606549,3.4562465,4.1198934,60.7615751,98.731343,1.8490719,23.9645385,17.5802204,38.2309606,6.2362673,7.8942707,2.4297458,24.2931252),(37948,'metatarsal.tif',234,10,70,23.1394774,8.8886752,13.5722965,1.8,8.9169602,13.5470126,0.7699056,3.3861289,4.1649659,59.7325918,98.2957613,1.8685511,23.6006164,17.6403776,37.6036882,6.1640148,7.9231449,2.4032801,23.7934482),(37949,'metatarsal.tif',234,10,71,22.8965494,8.8903617,13.5967722,1.8,8.9128312,13.5727659,0.7831439,3.3267811,4.1343054,58.316704,97.9998267,1.8994434,23.7040607,17.5294685,37.3636915,6.0771729,7.9081782,2.4506494,24.0302878),(37950,'metatarsal.tif',234,10,72,22.5598497,8.8822309,13.6128843,1.8,8.909185,13.5915616,0.7935382,3.2257623,4.0927829,56.9682629,97.2410277,1.9105926,23.7591466,17.6604032,37.0123389,5.9747538,7.8709641,2.456387,23.4702857),(37951,'metatarsal.tif',234,10,73,22.2501256,8.8878973,13.6310182,1.8,8.9105771,13.6073387,0.8059193,3.2380169,4.1010669,56.0390184,96.4262799,1.9302554,23.5124865,17.3065863,36.6950199,5.9473979,7.8892666,2.4772922,23.3246482),(37952,'metatarsal.tif',234,10,74,22.0532454,8.8894008,13.6487671,1.8,8.9056597,13.6248685,0.8172099,3.2077546,4.0697867,55.3230622,96.1191044,1.9546168,23.6177253,17.2466628,36.5377375,5.9216454,7.8709641,2.456387,23.5188315),(37953,'metatarsal.tif',234,10,75,21.9870118,8.8881238,13.6720355,1.8,8.9013003,13.6476288,0.8280168,3.1507169,4.0760637,54.9504383,96.3119749,1.9882379,23.6286729,17.4406146,36.5944179,5.859985,7.9326742,2.4241525,23.4016315),(37954,'metatarsal.tif',234,10,76,21.769322,8.8917609,13.68015,1.8,8.9039076,13.654399,0.8434111,3.148376,4.0345267,53.7978286,95.939588,2.0241219,23.7796391,17.0874851,36.3660732,5.8356947,7.8942707,2.4297458,23.1245753),(37955,'metatarsal.tif',234,10,77,21.5335722,8.8899529,13.6921025,1.8,8.9067329,13.6661572,0.8644919,3.1458209,3.9952504,52.7496881,95.3423513,2.0771437,23.8639238,16.7681793,36.4308545,5.799333,7.8499946,2.4248694,23.4158503),(37956,'metatarsal.tif',234,10,78,21.3238706,8.882062,13.7037311,1.8,8.8949799,13.6749113,0.878851,3.1118656,3.9816719,51.9846781,95.23816,2.1071884,23.9191379,16.7053093,36.2085545,5.7590913,7.8886137,2.4192686,23.5129419),(37957,'metatarsal.tif',234,10,79,21.1278899,8.8884353,13.7024932,1.8,8.9047692,13.6741967,0.8885125,3.1123398,3.9486098,51.3335574,94.9205867,2.1211872,24.0389888,16.4935583,36.252242,5.7871131,7.8447435,2.41433,23.3673044),(37958,'metatarsal.tif',234,10,80,20.9678643,8.903034,13.7077246,1.8,8.9154909,13.6795819,0.9004783,3.1113285,3.9627088,51.0203397,94.8957032,2.1459448,23.9471809,16.398249,36.2037883,5.788256,7.8403648,2.4037776,23.1044669),(37959,'metatarsal.tif',234,10,81,20.8162926,8.9196186,13.7157667,1.8,8.9299274,13.684758,0.915187,3.0684416,3.9439563,50.8557036,95.0519455,2.1799383,24.1006591,16.5737888,36.2888528,5.7397732,7.8182153,2.4410963,23.2702128),(37960,'metatarsal.tif',234,10,82,20.69152,8.9322738,13.7078956,1.8,8.9432528,13.6740137,0.9259793,3.0953568,3.9269032,50.9929903,94.9375387,2.2027373,24.176185,16.4740265,36.4101086,5.7613543,7.8342307,2.3826433,23.5673773),(37961,'metatarsal.tif',234,10,83,20.5114796,8.9507196,13.7033442,1.8,8.9637572,13.6720526,0.936977,3.1073366,3.8785196,51.02978,94.7679648,2.2195733,24.4340561,16.4223532,36.7400193,5.7931976,7.7940205,2.3880986,23.1873398),(37962,'metatarsal.tif',234,10,84,20.3097875,8.9721542,13.7004783,1.8,8.9880481,13.6713921,0.9500585,3.1285563,3.8568405,50.91597,94.4826976,2.2398315,24.4974343,16.2745895,36.9508567,5.7962206,7.7918172,2.3349211,23.3388669),(37963,'metatarsal.tif',234,10,85,20.1409781,8.9888335,13.6932232,1.8,9.0069163,13.6587591,0.960887,3.0900357,3.8326784,50.8613108,94.594913,2.2554808,24.6811508,16.4597808,37.2230876,5.7538321,7.7289825,2.2810673,23.1186857),(37964,'metatarsal.tif',234,10,86,19.9011924,9.0028874,13.6947041,1.8,9.0156593,13.6681954,0.96777,3.0895981,3.8519216,50.61843,94.3487337,2.250012,24.4939393,16.3834998,37.0700294,5.7418754,7.7673191,2.2867874,23.2015586),(37965,'metatarsal.tif',234,10,87,19.6998562,9.0253399,13.6961408,1.8,9.0382605,13.6699971,0.9766835,3.0660959,3.8255019,50.4712577,93.8207277,2.254495,24.5250765,16.4610823,37.1373842,5.7302095,7.7232045,2.2917677,23.2702128),(37966,'metatarsal.tif',234,10,88,19.4880305,9.0510989,13.6795801,1.8,9.0672197,13.6526556,0.995895,3.0685029,3.7987943,50.6405222,92.6289897,2.2876797,24.3837869,16.5033318,37.1858072,5.7583652,7.698042,2.2645599,23.138794),(37967,'metatarsal.tif',234,10,89,19.3376315,9.0824588,13.675491,1.8,9.0996914,13.6473887,1.0065607,3.0613233,3.7918789,50.8230754,92.2236293,2.3012458,24.3213542,16.6016686,36.9623126,5.7441519,7.6792837,2.296805,23.430069),(37968,'metatarsal.tif',234,10,90,19.2246757,9.1091076,13.6659796,1.8,9.1249476,13.6373296,1.0160822,2.9931272,3.7958732,51.0339983,91.6620196,2.3152494,24.1478086,17.0503943,37.1372994,5.7021034,7.698042,2.2645599,23.8728711),(37969,'metatarsal.tif',234,10,91,19.0579367,9.1341339,13.6773467,1.8,9.1498021,13.6506257,1.0185334,2.9254698,3.7538355,50.8357007,91.2133948,2.302132,24.2987192,17.3769356,36.7401607,5.6426371,7.6792837,2.296805,23.3045398),(37970,'metatarsal.tif',234,10,92,18.7029005,9.1526925,13.6973331,1.8,9.1634122,13.6745257,1.0119581,2.8899218,3.7947564,49.8049074,90.2573117,2.2408767,23.7847446,17.2339981,36.3101257,5.6124423,7.6326361,2.2419402,23.195669),(37971,'metatarsal.tif',234,10,93,18.5050179,9.1762082,13.7155906,1.8,9.1874146,13.6917274,1.0062982,2.8602739,3.8083983,49.4418986,89.9432661,2.20143,23.617085,17.285722,35.9086408,5.6078876,7.6530794,2.2694562,23.1186857),(37972,'metatarsal.tif',234,10,94,18.4201127,9.2030282,13.7349965,1.8,9.2126843,13.7167121,1.0003801,2.8361723,3.8296258,49.4201832,90.6485159,2.1748596,23.6703326,17.4249583,36.1199169,5.5923189,7.6530794,2.2694562,23.0985773),(37973,'metatarsal.tif',234,10,95,18.3649497,9.2436025,13.7382098,1.8,9.2511485,13.7164766,0.9952434,2.8300194,3.8574881,49.6051308,91.3513276,2.1540214,23.6815581,17.5281946,35.7395867,5.5932356,7.7232045,2.2917677,22.9730482),(37974,'metatarsal.tif',234,10,96,18.2318268,9.2745249,13.7466233,1.8,9.2848099,13.7274692,0.990452,2.8421642,3.9165484,49.7374962,92.3018519,2.1250836,23.5671418,17.4998674,35.7407452,5.6049641,7.7735061,2.276152,23.2216669),(37975,'metatarsal.tif',234,10,97,18.1062277,9.3047265,13.7552093,1.8,9.3120121,13.73375,0.989325,2.8594548,3.9578522,49.9627679,93.3920472,2.1073234,23.5966487,17.4728299,35.7988022,5.6348869,7.8116242,2.2818636,23.2702128),(37976,'metatarsal.tif',234,10,98,18.09793,9.3324044,13.7399511,1.8,9.3446957,13.7162781,0.9920102,2.8723011,3.9906238,50.2639921,95.6172707,2.1137841,23.9604823,17.4995556,36.0056906,5.6823326,7.8942707,2.2826432,23.4217398),(37977,'metatarsal.tif',234,10,99,18.3282698,9.3499453,13.7077015,1.8,9.3613901,13.6859307,0.9781066,2.8933412,3.9979059,51.2664955,99.0378635,2.1015583,24.7724349,17.7187868,37.1871578,5.6823326,7.9007929,2.2721822,23.9071982),(37978,'metatarsal.tif',234,10,100,18.5154285,9.3928192,13.6737908,1.8,9.3935206,13.6371789,0.9792901,2.9121468,4.0258815,52.6051279,102.2004141,2.126401,25.3858477,18.0640372,37.8720215,5.7403683,7.9456502,2.2674232,24.0302878),(37979,'metatarsal.tif',234,10,101,18.7240754,9.4413644,13.6593241,1.8,9.4388484,13.6211796,0.9894133,2.9423599,4.0842307,54.0928605,106.1098262,2.1794855,25.9803705,18.3841753,38.5735065,5.8183636,8.0751142,2.2172002,23.8361044),(37980,'metatarsal.tif',234,10,102,19.1424689,9.4857871,13.6361693,1.8,9.4817255,13.6028656,0.9932108,2.9673435,4.1531623,55.7831534,111.4029578,2.2392894,26.8236465,18.7990212,39.6947499,5.8967544,8.1689747,2.2085586,24.7074898),(37981,'metatarsal.tif',234,10,103,19.4390634,9.5153935,13.5867499,1.8,9.5247348,13.5614223,1.0093155,2.9946313,4.1808736,57.4447283,115.6740956,2.3213721,27.6674463,19.1825715,40.8076663,5.9493971,8.3057104,2.1705401,24.484869),(37982,'metatarsal.tif',234,10,104,19.5721145,9.5380714,13.5708625,1.8,9.5545,13.5217734,1.0202725,3.0389356,6.4604741,59.5603517,119.2302414,2.3693058,18.4553393,19.5990829,27.6199797,6.0156415,8.4272018,2.2031713,25.2248357),(37983,'metatarsal.tif',234,10,105,20.3613451,9.6231271,13.5665785,1.8,9.6290322,13.5158314,1.0156192,3.0849375,4.2846095,63.1637108,125.7621091,2.4507325,29.3520587,20.4748753,43.1095427,6.1588721,8.55018,2.1759075,25.4307982),(37984,'metatarsal.tif',234,10,106,20.7923229,9.6362339,13.5175718,1.8,9.6585399,13.4919291,1.0224098,3.1542861,4.3361692,66.3669466,132.780604,2.5236156,30.6216384,21.0402434,44.84038,6.2513636,8.7439764,2.1606577,25.9280357),(37985,'metatarsal.tif',234,10,107,21.8107833,9.7100839,13.4941205,1.8,9.7240203,13.4906549,1.0153595,3.1961139,4.5074872,72.4737386,145.8357392,2.6243438,32.3541109,22.6755809,47.2663452,6.3687935,9.0693797,2.1677593,26.8396378),(37986,'metatarsal.tif',234,10,108,23.4386025,9.8362394,13.3940517,1.8,9.8383434,13.3928035,0.9847475,3.2877387,4.6047645,81.1081103,163.6251776,2.7114936,35.533886,24.6698769,51.4490932,6.6296471,9.2093403,2.0828392,29.3743711),(37987,'metatarsal.tif',234,10,109,25.8216675,9.9871618,13.2467747,1.8,9.9863352,13.249569,0.9513531,4.1580749,4.8054963,96.7738448,186.8442548,2.85297,38.8813644,23.2737139,57.0863512,6.7024397,9.5674261,2.1112158,29.2655003),(37988,'metatarsal.tif',234,10,110,27.9865335,10.0404712,13.2537558,1.8,10.0371192,13.2511719,0.9902161,3.4326734,5.0669702,104.4333483,217.0663654,3.2610734,42.8394793,30.423328,62.3072032,6.8948853,10.0122008,2.2400529,30.477717),(37989,'metatarsal.tif',234,10,111,29.842402,10.1443295,13.2552353,1.8,10.1620381,13.1967747,0.9702665,4.3027298,5.2062531,119.9778077,252.2014096,3.3855459,48.4420189,27.8841141,70.54982,7.9353698,10.3217544,2.1745457,34.2756524),(37990,'metatarsal.tif',234,10,112,33.4589587,10.3093999,13.1774638,1.8,10.3264367,13.1143742,0.9444144,4.46397,5.3545936,150.3361233,284.293092,3.6601264,53.093309,33.6776732,80.7216884,8.181249,10.6145293,2.046789,36.153292),(37991,'metatarsal.tif',234,10,113,37.3192252,10.546847,13.0532134,1.8,10.5622924,12.9983462,0.9493712,4.4198984,5.4442948,175.9343982,313.3250741,4.1116434,57.5510849,39.8050776,88.518992,8.2565692,10.7957681,2.5806918,36.0562003),(37992,'metatarsal.tif',234,10,114,41.5385299,10.7077256,12.9580748,1.8,10.7521376,12.9191532,1.0168913,4.3477315,5.4094767,185.940133,334.7615095,5.0075456,61.8842686,42.7671607,93.4002094,8.1039542,10.9971455,2.6231075,36.9712525),(37993,'metatarsal.tif',234,10,115,46.8593979,10.6801077,12.9494513,1.8,10.755229,12.8952921,1.0450884,4.4787547,5.212607,198.4417504,348.4490052,5.8431419,66.8473575,44.3073499,98.1166568,8.0960003,11.0263031,2.6184914,36.6539795),(37994,'metatarsal.tif',234,10,116,48.9071737,10.6210911,13.0371357,1.8,10.7449062,12.974801,1.1565438,4.8380161,5.0300826,207.3503225,333.7933951,6.8306128,66.3594267,42.858543,96.4459882,8.4405206,10.8135661,1.4948557,36.5509983),(37995,'metatarsal.tif',234,10,117,45.0422543,10.6211489,13.0965386,1.8,10.7452322,13.0256461,1.1633212,4.5707695,5.5206775,187.7280601,272.8700785,6.3280786,49.4269186,41.0714343,80.9258238,8.1910102,10.5483258,1.465047,37.1311087),(37996,'metatarsal.tif',234,10,118,41.9796077,10.5130325,13.1220311,1.8,10.6271263,13.0544661,1.1091636,4.2216357,5.1276743,154.7370119,240.1455727,5.6085416,46.8332345,36.6533312,73.6131566,7.5923211,10.0929891,1.5185184,33.9985962),(37997,'metatarsal.tif',234,10,119,40.0664109,10.4876357,13.2012069,1.8,10.5675695,13.1443322,1.1015509,3.8632835,5.1318747,111.5267384,238.2962655,5.3121584,46.4345444,28.8683803,65.0593182,6.9952245,9.7214206,2.5318543,31.8605586),(37998,'metatarsal.tif',234,10,120,33.8592513,10.4631302,13.2525023,1.8,10.5001396,13.2066859,1.1070697,3.8532584,5.4470348,59.1902249,205.2311763,4.51421,37.6775956,15.3610839,41.564537,0.2344,0.4724483,2.0899424,1.2632021),(37999,'metatarsal.tif',234,10,121,20.9250281,10.4543679,13.1790685,1.8,10.463289,13.1599615,1.1147166,3.894179,5.6472704,14.9959261,108.258688,2.8109976,19.1700911,3.8508569,19.0115319,3.6175948,8.6349046,2.0891007,26.3497189),(38000,'metatarsal.tif',234,10,122,14.3754541,12.8442182,12.961936,1.8,12.7968818,12.8993608,1.0364243,1.6841172,5.9618523,6.4583281,93.3917107,1.7744409,15.6648817,3.8348449,16.689146,3.3208742,5.1103099,1.6396528,15.1525355),(38001,'metatarsal.tif',234,10,123,7.7076927,12.5255911,14.2677684,1.8,12.4401704,14.1457575,1.0289171,1.3026898,6.8506909,1.7604666,30.7474014,0.9429143,4.488219,1.3514089,4.7405118,2.4716804,9.5738845,2.2608324,22.9460397),(38002,'metatarsal.tif',234,10,124,2.6716102,12.1317472,15.6178486,1.8,12.0697498,15.5479991,1.0499546,0.830327,3.0508322,0.2724931,2.4336907,0.3350127,0.7977137,0.3281757,0.8867588,1.4976698,4.659345,2.2671449,11.4516918),(38003,'metatarsal.tif',234,10,125,0.8872077,10.8052783,16.0099938,1.8,10.67227,15.8746304,0.9039744,0.6256877,4.7467003,0.0474949,0.7497807,0.0913037,0.1579583,0.0759083,0.1679538,0.0828729,0.1657458,2.3561945,0.3314917),(38004,'metatarsal.tif',234,10,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38005,'humerus.tif',235,2,1,21.7678978,6.5598945,23.5531654,1.8,6.4453531,23.5387572,0.340995,3.0465877,3.6916871,34.8986808,68.1721717,0.4057539,18.4664004,11.4550061,25.0251308,5.5820409,11.0604057,2.7125632,33.8611589),(38006,'humerus.tif',235,2,2,25.5197788,7.1550181,23.6630474,1.8,6.9977784,23.6468061,0.2651436,3.0606002,4.1738439,45.5812748,103.2700011,0.29207,24.7421809,14.8929204,31.6912876,5.7008318,12.0011846,2.757775,40.5860281),(38007,'humerus.tif',235,2,3,27.1094212,7.9179045,23.8149949,1.8,7.6955933,23.7921151,0.2222831,3.0639639,4.8671234,55.0357757,131.5291422,0.2195923,27.0239996,17.9622795,34.4821122,5.7743101,12.8766181,2.802761,47.5638412),(38008,'humerus.tif',235,2,4,28.2546705,8.6510051,23.973333,1.8,8.3790293,23.9549868,0.1942825,11.1349409,11.9578601,65.2831247,172.2508352,0.1755234,14.4048211,5.8629072,14.5441867,5.9157026,13.7236631,2.8408008,34.9969879),(38009,'humerus.tif',235,2,5,29.6043417,9.2910603,24.1140517,1.8,8.974852,24.1002782,0.1838008,3.2467763,6.1772878,75.22606,227.7854152,0.1648173,36.8746643,23.1694617,45.23276,6.0599799,14.5603576,2.8814636,37.3684237),(38010,'humerus.tif',235,2,6,30.9650811,9.8391909,24.2446362,1.8,9.4911663,24.2326661,0.1745181,3.3766926,6.6875744,86.5930742,299.8976442,0.1555924,44.8440087,25.644346,54.0688218,6.2130682,15.3663332,2.9168815,38.879405),(38011,'humerus.tif',235,2,7,32.2100031,10.3480768,24.3761352,1.8,9.9649071,24.3550014,0.1590253,3.4508459,7.1370656,99.000957,389.4729248,0.1346196,54.5704563,28.6888955,64.6905093,6.4822218,16.1999915,2.9454924,40.6066136),(38012,'humerus.tif',235,2,8,33.8833146,10.7512608,24.4964722,1.8,10.3575657,24.4592527,0.1454755,3.5178032,7.4805957,112.4456503,514.64181,0.1186721,68.7969024,31.9647358,79.9507086,6.6411225,17.0277993,2.977477,41.8485201),(38013,'humerus.tif',235,2,9,36.4582066,10.9341412,24.598092,1.8,10.5434539,24.5462148,0.1290411,3.5889291,7.6008491,128.8476688,698.8554205,0.1006208,91.9443879,35.9014251,104.2570481,6.9321337,17.7910636,3.0452154,43.1262205),(38014,'humerus.tif',235,2,10,39.1609615,11.0949796,24.68713,1.8,10.7309672,24.6257427,0.1228732,3.9545663,7.7243173,150.8030112,890.341004,0.098046,115.2646848,38.1338942,129.8838679,7.2760003,17.9846765,3.0043232,44.0708623),(38015,'humerus.tif',235,2,11,41.4632436,11.3478414,24.8442183,1.8,10.9862064,24.7465754,0.1105397,5.1602546,8.2395273,169.8768857,1081.1574761,0.0840966,131.2159583,32.9202529,149.2962987,7.9036927,18.3174039,3.0009348,45.4403543),(38016,'humerus.tif',235,2,12,43.7651984,11.6177438,25.05336,1.8,11.2563038,24.9247711,0.0942466,6.1285857,8.8001351,187.3772775,1233.1862706,0.0645986,140.1326519,30.5743098,159.7946111,8.4725251,18.499323,2.9935607,46.2305254),(38017,'humerus.tif',235,2,13,48.7718091,11.6230848,24.9310152,1.8,11.176446,24.7332819,0.1603522,6.6642013,9.7291036,267.6108628,1519.5284731,0.2072248,156.1838099,40.1564794,158.3892251,8.978182,18.5973888,2.9972546,47.2584318),(38018,'humerus.tif',235,2,14,52.9443233,11.719992,24.8305962,1.8,11.2040546,24.5302225,0.2137452,6.9207292,10.5372265,348.7613282,1781.3462938,0.3970424,169.0526715,50.3937256,180.2279271,9.1807786,18.8563792,3.0506759,50.2879987),(38019,'humerus.tif',235,2,15,56.3503939,11.9228242,24.9790054,1.8,11.3459146,24.6225491,0.2336804,7.4071784,11.1166593,458.6300763,1982.6048598,0.5035826,178.3453828,61.9169746,195.8900322,9.6223058,19.0124586,3.0259634,50.6663009),(38020,'humerus.tif',235,2,16,62.4854622,11.9810545,25.2978717,1.8,11.4597738,24.9756931,0.2542556,8.0769325,11.758524,654.0530318,2255.050419,0.6588556,191.7800583,80.9778998,223.2976345,10.2344519,19.2975628,3.0444068,52.3653197),(38021,'humerus.tif',235,2,17,64.8815464,12.1481465,25.4031747,1.8,11.6889943,25.206455,0.2729805,8.3507313,12.3243143,699.0426871,2493.9656656,0.7859929,202.3614133,83.7103561,237.8887871,9.6385366,19.5971465,3.029428,53.3780176),(38022,'humerus.tif',235,2,18,4.2336062,9.6110451,19.4913654,1.8,9.5886661,19.4401211,0.83993,1.8018256,2.6183935,3.3329616,8.1410033,0.391202,3.1091596,1.8497692,4.0182389,3.4413995,4.9628282,2.3028101,27.627351),(38023,'humerus.tif',235,2,19,8.3485614,9.3967407,19.1576145,1.8,9.4002962,19.1293123,0.9477358,3.0663952,3.9404395,17.5263964,40.0215014,0.9176468,10.1566085,5.7156352,14.0586324,5.5232113,7.2919149,1.8995073,22.2209712),(38024,'humerus.tif',235,2,20,16.0576477,9.5013928,22.1588669,1.8,9.481072,21.8664167,1.41654,4.695928,10.5405774,49.2465448,510.7375349,2.6130961,48.4544172,10.4870741,53.1259817,6.8472688,8.8145211,2.5418061,105.3129517),(38025,'humerus.tif',235,2,21,27.0531849,9.6306676,22.9485944,1.8,9.6378641,22.5799136,1.4816821,5.0636249,10.3054959,101.4645861,1001.7043007,4.4731524,97.2009802,20.0379348,107.0399026,8.1488101,9.9269539,2.1528199,36.3323726),(38026,'humerus.tif',235,2,22,36.8885588,9.7003158,23.2744927,1.8,9.6937301,23.0135153,1.4928635,5.1536681,10.4499473,157.5664305,1387.4056413,6.1108281,132.7667597,30.5736471,147.8154342,8.9853754,11.2142182,1.6472023,55.3854372),(38027,'humerus.tif',235,2,23,45.4140875,9.6583881,23.3736181,1.8,9.6862041,23.2783419,1.5006676,5.4329241,10.7503157,217.5491188,1649.3284514,7.5318509,153.4213962,40.0427312,171.3745209,9.8032248,21.2691949,1.5179489,127.4354497),(38028,'humerus.tif',235,2,24,49.8879323,9.6176276,23.4246353,1.8,9.6597458,23.4238633,1.5003559,5.6308946,11.0723612,268.6755653,1806.2898769,8.2734675,163.1350215,47.7145435,185.022474,10.1347909,21.4644383,1.4659194,177.7462612),(38029,'humerus.tif',235,2,25,52.4767175,9.6064546,23.3786205,1.8,9.6587957,23.4010535,1.4998327,5.5721294,13.2475018,310.7540814,1952.4121631,8.7021495,147.3796486,55.7693579,168.4327731,10.1906444,22.8512658,1.6434382,123.8565967),(38030,'humerus.tif',235,2,26,53.3582802,9.6292004,23.2415934,1.8,9.6956184,23.3337584,1.4985038,5.7326126,13.598203,340.1131408,2045.3335862,8.8466508,150.4120494,59.3295176,174.3618132,9.6935388,23.4843073,1.6369099,194.4775878),(38031,'humerus.tif',235,2,27,53.5530752,9.6901344,23.3822926,1.8,9.7564229,23.4333888,1.4775664,6.0315499,15.122252,339.4495522,2349.5778093,8.848158,155.3722166,56.2789928,177.0324996,10.7000004,26.3204787,1.6603521,238.0071505),(38032,'humerus.tif',235,2,28,51.2126765,9.9518885,23.5778174,1.8,10.0008054,23.5307652,1.4591943,6.016255,15.4307563,305.180764,2699.2423874,8.4295776,174.926124,50.7260354,194.1899166,10.7535005,23.7123333,1.6023885,151.6621537),(38033,'humerus.tif',235,2,29,51.1481856,10.2211438,24.1446176,1.8,10.227169,24.0098932,1.4660628,5.8817646,15.1809115,301.6705545,3042.7119444,8.4315305,200.4301216,51.2891237,220.0200693,10.7000004,27.1285107,1.6359215,97.2764331),(38034,'humerus.tif',235,2,30,51.2226535,10.5247086,24.5470544,1.8,10.5107804,24.3878247,1.4795777,5.6701283,15.0311478,291.4182518,3181.14262,8.4662699,211.6367069,51.3953537,230.9584441,10.5395004,27.320435,1.6217326,95.0433368),(38035,'humerus.tif',235,2,31,51.6654012,10.88851,25.0602013,1.8,10.8676933,24.8636889,1.5148203,5.8635631,14.6901305,272.0193025,3342.0391661,8.5839476,227.5023476,46.3914682,245.8522311,8.5448522,26.9277262,1.5350263,82.9130103),(38036,'humerus.tif',235,2,32,51.5938964,11.3279498,25.6763607,1.8,11.3092348,25.7225249,1.5560552,5.1172397,14.3104543,224.1076334,3545.390751,8.5971143,247.7483014,43.7946327,262.142468,8.4358159,26.9362284,1.5270866,79.4469166),(38037,'humerus.tif',235,2,33,49.0708343,11.817575,26.2586717,1.8,11.7769851,26.3736243,-1.5361661,3.9468193,13.5518223,166.9856664,3421.572154,8.1686683,252.4805946,42.3089213,264.8009992,7.5910003,26.729128,1.4685386,74.2836491),(38038,'humerus.tif',235,2,34,48.6374148,11.9799141,26.4566572,1.8,11.9577931,26.6528417,-1.5135591,3.7170907,13.2993854,158.3841574,3345.8210046,8.0797079,251.5771154,42.6097101,263.4262545,7.2031442,26.5512054,1.4556888,67.9227961),(38039,'humerus.tif',235,2,35,48.7153253,12.1466923,26.2735147,1.8,12.122726,26.484058,-1.5032596,3.6467173,13.2762243,155.6047469,3147.3929067,8.0822437,237.0698796,42.669813,248.7455117,6.9555209,26.2469179,1.4337998,68.6740233),(38040,'humerus.tif',235,2,36,47.5401232,12.2985243,26.0495984,1.8,12.2886159,26.3190348,-1.485389,3.5454387,13.2117399,148.9803524,2837.4189924,7.8656981,214.7649757,42.0202876,225.7645884,6.7259307,25.8759773,1.4318232,64.2274938),(38041,'humerus.tif',235,2,37,47.4851189,12.5230053,25.7675496,1.8,12.5263585,26.0748134,-1.4709901,3.4647362,13.1632354,147.2561081,2639.0075054,7.8356124,200.4831964,42.5013908,211.2503635,6.617188,25.4674622,1.4253342,63.0115499),(38042,'humerus.tif',235,2,38,46.4999735,12.7177198,25.5096149,1.8,12.7362757,25.7735134,-1.4542643,3.3869413,13.1041361,147.7876692,2425.4558989,7.6452285,185.0908655,43.6345525,196.2688771,6.5374134,24.9964126,1.407407,65.0727398),(38043,'humerus.tif',235,2,39,45.4547356,12.8409469,25.391893,1.8,12.8875328,25.5619037,-1.4389023,3.4118175,12.0482217,151.6823399,2153.0133711,7.444763,178.6996802,44.4579296,191.1475428,6.5504097,23.901272,1.3725228,59.4004349),(38044,'humerus.tif',235,2,40,46.2252317,12.9802639,25.5385624,1.8,13.0514663,25.5909499,-1.430567,3.2963465,11.806351,155.8305982,2080.8153092,7.5536981,176.2454217,47.2737317,186.8507415,6.4971718,23.3462388,1.3419363,58.3465659),(38045,'humerus.tif',235,2,41,46.5220552,13.125222,25.6560813,1.8,13.2092158,25.6511617,-1.4225624,3.3808252,11.8131648,159.1189927,2016.9938113,7.5845462,170.7411898,47.0651338,181.333579,6.4826694,22.762412,1.3092855,57.6786033),(38046,'humerus.tif',235,2,42,45.9113725,13.2377539,25.6805876,1.8,13.344612,25.565437,-1.4135767,3.4280138,11.7660829,159.4170842,1919.1533193,7.464309,163.1089405,46.5042135,173.8591654,6.4774057,22.2375383,1.2954709,57.4959429),(38047,'humerus.tif',235,2,43,45.3482039,13.3319273,25.6456455,1.8,13.4486653,25.5167201,-1.4015754,3.4479565,11.6272136,161.7257555,1757.7875363,7.3436622,151.1787435,46.9048129,162.2554651,6.406606,21.7068306,1.2576192,58.4168493),(38048,'humerus.tif',235,2,44,43.0537658,13.4074181,25.2463305,1.8,13.5548105,25.0870767,-1.3779377,3.4055699,11.1423964,162.0090521,1507.9155246,6.9120267,135.331348,47.5717887,147.2846897,6.6561435,19.7359906,1.3771222,48.9574506),(38049,'humerus.tif',235,2,45,42.0261958,13.4834256,24.9437242,1.8,13.6259274,24.8093338,-1.3556242,3.3619729,10.8499904,160.1746511,1353.5057389,6.6850445,124.7471833,47.6430519,136.660106,6.3954424,19.0454748,1.3585258,46.9956565),(38050,'humerus.tif',235,2,46,41.5269457,13.5269638,24.798898,1.8,13.6613845,24.6772915,-1.3273489,3.3199069,10.6533893,160.552272,1228.2740934,6.5190036,115.294209,48.3604737,127.768126,6.4097363,18.2908206,1.3556172,46.4790147),(38051,'humerus.tif',235,2,47,41.8840355,13.5250396,24.768125,1.8,13.6506837,24.6451158,-1.2887598,3.5229998,10.671394,162.0440097,1166.5014149,6.4399655,109.3110628,45.9960315,122.2748855,6.4141758,20.0010601,1.1550163,53.9054133),(38052,'humerus.tif',235,2,48,42.8853157,13.5722428,24.7166873,1.8,13.6920682,24.6009825,-1.2646784,3.5911442,10.6677048,161.4685797,1116.6252394,6.4984303,104.6734289,44.9629901,117.8050302,6.4277019,19.6735302,1.1326906,51.3924881),(38053,'humerus.tif',235,2,49,43.9078703,13.6510624,24.5981427,1.8,13.7720634,24.4706117,-1.2441415,3.6583682,10.6706441,160.614881,1063.2808524,6.5645066,99.6454234,43.9034216,113.0025157,6.4993382,19.4048719,1.1170128,49.4848463),(38054,'humerus.tif',235,2,50,44.7635177,13.7041281,24.4659998,1.8,13.839809,24.3214518,-1.2352703,3.6903772,10.4633468,162.0291843,980.2245583,6.6517387,93.6817423,43.90586,107.2095365,6.5635796,18.9799128,1.0806732,47.7155441),(38055,'humerus.tif',235,2,51,44.4822015,13.829272,24.2498555,1.8,13.9564308,24.1312974,-1.2237549,3.7103948,9.9241801,162.7071341,932.6341724,6.5560859,93.9759421,43.851704,107.920702,6.622715,18.3283387,1.0549087,45.9072981),(38056,'humerus.tif',235,2,52,42.7303471,13.8854013,24.1611129,1.8,14.0258386,24.0153465,-1.2132409,3.7444143,9.7297393,163.0231646,884.4062638,6.2493867,90.8972213,43.5376938,105.224148,6.6808018,17.8378988,1.0427219,44.5216751),(38057,'humerus.tif',235,2,53,41.6809726,13.9501546,24.1005555,1.8,14.0875028,23.9643114,-1.2058918,3.7617151,9.5843856,164.0237149,820.0314791,6.062156,85.5591077,43.6034389,100.1895538,6.7571361,17.3599058,1.0229774,43.5273355),(38058,'humerus.tif',235,2,54,41.919286,14.0456928,24.0231431,1.8,14.1832863,23.8780534,-1.1937448,3.7755739,9.4116613,166.7181134,772.4987925,6.0394719,82.0788981,44.1570262,97.3342022,6.8522422,16.8938912,1.0135397,42.7966937),(38059,'humerus.tif',235,2,55,43.583688,14.143854,23.8631927,1.8,14.2708538,23.7431683,-1.1852861,3.8131057,9.1556944,169.568508,721.5269603,6.2368254,78.8063616,44.4699204,94.6097178,6.9436966,16.3973798,0.9945579,41.1894664),(38060,'humerus.tif',235,2,56,43.7586115,14.2350227,23.6835843,1.8,14.3543289,23.587776,-1.1793949,3.8554252,8.8978864,171.8676749,697.2070196,6.2317355,78.3564755,44.578137,94.8271207,7.0007059,15.9808366,0.9855792,41.0641081),(38061,'humerus.tif',235,2,57,42.2092487,14.3129857,23.6345262,1.8,14.4285424,23.5545316,-1.1682953,3.8766819,8.7602923,173.7222301,665.1240584,5.9554072,75.9248705,44.8120931,92.7155101,7.107661,15.5817321,0.968509,40.8814477),(38062,'humerus.tif',235,2,58,42.9390222,14.3655531,23.5646415,1.8,14.4672141,23.5023191,-1.1565226,3.9286809,8.59625,176.467098,632.4817037,5.9969598,73.5764668,44.9176466,91.1419429,7.1924613,15.1563722,0.9534192,38.9975412),(38063,'humerus.tif',235,2,59,43.1834334,14.4117202,23.4998943,1.8,14.5108479,23.4378104,-1.1483414,3.9535769,8.4384632,180.2306518,594.7140661,5.9873784,70.4765848,45.5867328,88.7571633,7.2650941,14.7553355,0.9294707,38.0636535),(38064,'humerus.tif',235,2,60,43.6810949,14.4882937,23.4132295,1.8,14.5871962,23.3519087,-1.1506467,3.9342737,8.1765412,182.7043913,550.4922855,6.068906,67.3258128,46.4391665,86.5433975,7.3181596,14.3169245,0.9205689,37.1503514),(38065,'humerus.tif',235,2,61,44.5080215,14.5475476,23.2871147,1.8,14.6385436,23.2354763,-1.1584915,3.9252045,7.6611841,183.3965852,509.9998313,6.2268343,66.5693218,46.7228108,86.809935,7.3506407,13.6644075,0.9186815,35.9787283),(38066,'humerus.tif',235,2,62,43.3198431,14.5723066,23.2199701,1.8,14.6497843,23.1832547,-1.1653957,3.9374206,6.9976912,185.1959495,474.8527478,6.0969711,67.8584885,47.0348407,90.2840509,7.3664533,12.7770954,0.9130583,34.3347844),(38067,'humerus.tif',235,2,63,43.6804997,14.6194821,23.1466096,1.8,14.6960944,23.1148563,-1.1644572,3.9463113,6.7094434,189.9845603,443.5136541,6.1427746,66.1028984,48.1423151,91.2181056,7.3913506,12.242152,0.9124362,33.617124),(38068,'humerus.tif',235,2,64,44.4119652,14.6513668,23.0741507,1.8,14.7315439,23.0359143,-1.1549371,3.982173,6.4344909,193.6707712,421.0611193,6.1940133,65.4381407,48.6344449,92.54105,7.4409844,11.759539,0.9209259,32.7611239),(38069,'humerus.tif',235,2,65,44.2777856,14.7045054,22.9649792,1.8,14.7669045,22.9396945,-1.155114,3.9772241,6.1717873,195.940982,393.980025,6.1762644,63.8356457,49.2657629,92.8967371,7.4877135,11.3321542,0.9395703,31.5429528),(38070,'humerus.tif',235,2,66,43.8767932,14.7481053,22.8953907,1.8,14.7888636,22.8807876,-1.1563051,3.9858747,5.9751405,198.309163,371.2896489,6.1267593,62.1390658,49.7529841,92.600841,7.5577186,10.9707622,0.9029098,31.0965945),(38071,'humerus.tif',235,2,67,43.3100776,14.8447561,22.7837335,1.8,14.8755966,22.778119,-1.1600479,4.0004609,5.7863024,199.8474173,351.6869673,6.0674751,60.779224,49.9560976,92.8675539,7.6106979,10.6702666,0.9062351,30.5799528),(38072,'humerus.tif',235,2,68,43.211404,14.868151,22.6814723,1.8,14.8902712,22.6713059,-1.1716436,4.0504667,5.5903614,203.4880273,330.36566,6.1141302,59.0955824,50.2381678,92.1805792,7.6994543,10.3857547,0.8912284,30.1389715),(38073,'humerus.tif',235,2,69,45.05148,14.9115446,22.5938501,1.8,14.9281512,22.583075,-1.1731336,4.1272272,5.4699287,207.8759243,315.3691882,6.3824897,57.655082,50.3669692,92.5442684,7.7817666,10.1318609,0.8638883,29.8622923),(38074,'humerus.tif',235,2,70,43.9741593,14.9751529,22.4698899,1.8,14.9935371,22.4540969,-1.1615142,4.1940726,5.3252035,210.2719497,301.9928457,6.1683662,56.7101045,50.1355056,93.2605485,7.8598441,9.8927276,0.892677,29.5542736),(38075,'humerus.tif',235,2,71,43.8779742,15.0075198,22.3454006,1.8,15.0259985,22.3312528,-1.1524188,4.2440531,5.2094742,212.6892103,293.6238154,6.1058968,56.363426,50.1146434,94.1982054,7.9451836,9.6929544,0.8831251,29.4602549),(38076,'humerus.tif',235,2,72,42.6866826,15.0571641,22.2429547,1.8,15.0721145,22.2319131,-1.1465777,4.3257887,5.1247635,214.7402993,282.997293,5.9091046,55.2215318,49.6418831,94.0825069,8.0366308,9.5407171,0.8250599,29.3532549),(38077,'humerus.tif',235,2,73,42.0430378,15.108045,22.1131048,1.8,15.1195447,22.1032811,-1.1430382,4.409072,5.0471291,216.9365363,275.0985681,5.8013398,54.50595,49.2023126,94.6357272,8.1330456,9.3928697,0.8337476,29.303557),(38078,'humerus.tif',235,2,74,41.3832004,15.1400952,21.9930947,1.8,15.1507987,21.9821211,-1.1277448,4.4671425,5.0104573,219.857642,266.4108083,5.6296168,53.1709566,49.2166176,94.7059769,8.2332354,9.2690973,0.7731539,29.196557),(38079,'humerus.tif',235,2,75,40.8006843,15.1686938,21.8682853,1.8,15.1771079,21.8594794,-1.0907851,4.5050231,4.9691943,222.8386731,259.1748181,5.3499952,52.1563057,49.4644901,95.0935019,8.3299545,9.1596004,0.6528466,29.1468591),(38080,'humerus.tif',235,2,76,40.3458884,15.1985403,21.7475315,1.8,15.2029833,21.7384454,-1.038715,4.5307178,4.9603752,226.9250361,253.0085496,4.9935993,51.0059297,50.0858903,95.5071688,8.4527192,9.1022357,0.5504998,29.1468591),(38081,'humerus.tif',235,2,77,40.1290719,15.2406725,21.6337852,1.8,15.236885,21.6209695,-0.9314949,4.5054526,4.9724797,231.9851063,248.4051498,4.307366,49.9559908,51.4898558,96.3314498,8.5708372,9.0989334,0.4241944,29.2668404),(38082,'humerus.tif',235,2,78,40.458204,15.2913386,21.4997855,1.8,15.2858626,21.4852426,-0.6374012,4.7565209,4.8899515,238.2026385,248.3102887,2.3880772,50.7797042,50.0791736,98.7194155,8.7092225,9.1373869,0.340267,29.3554821),(38083,'humerus.tif',235,2,79,40.9467045,15.3210802,21.3637928,1.8,15.3092128,21.3492686,-0.0808161,4.7413829,4.7919892,241.3784303,253.4907253,0.0444752,52.898852,50.9088663,99.5751561,8.7337732,9.2270057,2.4424001,29.506803),(38084,'humerus.tif',235,2,80,41.1958964,15.3441459,21.2383859,1.8,15.3303647,21.2244003,0.1190229,4.488041,5.0228759,241.1181894,262.1646657,0.0968082,52.1941353,53.7245958,99.3054032,8.6527084,9.3734996,2.5060822,29.6711051),(38085,'humerus.tif',235,2,81,41.3782193,15.3530918,21.1144962,1.8,15.3306531,21.0954293,0.2096521,4.3526987,5.2032513,240.8891494,273.5941806,0.2987078,52.5813887,55.3424822,98.5388018,8.6068157,9.5465653,2.5193888,29.8851051),(38086,'humerus.tif',235,2,82,41.5895083,15.3583638,20.9802708,1.8,15.3214057,20.9519762,0.2612935,4.3982573,5.3304717,240.233625,285.8693809,0.4625765,53.6292836,54.6201847,98.5935676,8.5637011,9.6959068,2.5168531,30.1564072),(38087,'humerus.tif',235,2,83,41.5698665,15.3724277,20.8522377,1.8,15.3341694,20.8252997,0.2907235,4.4042581,5.4453141,239.0780899,297.3525979,0.5692687,54.6070607,54.2833969,98.5105696,8.5327408,9.8702792,2.5295345,30.4277094),(38088,'humerus.tif',235,2,84,41.8551809,15.393819,20.7167147,1.8,15.3415395,20.6822736,0.2951715,4.390505,5.5755104,239.3668317,310.1050827,0.5903329,55.6191381,54.5192029,98.5509237,8.4976814,10.0380604,2.5920326,30.6546907),(38089,'humerus.tif',235,2,85,41.8547331,15.4270748,20.5926805,1.8,15.3664881,20.5588504,0.2920301,4.3665685,5.7511194,240.0534871,323.1534786,0.5781859,56.1896661,54.9753163,97.912198,8.4748967,10.2308176,2.591308,31.0329928),(38090,'humerus.tif',235,2,86,42.0272083,15.4525656,20.463191,1.8,15.3739365,20.4236599,0.2868876,4.363941,5.8711917,240.7967173,335.6088694,0.5608606,57.1619674,55.1787285,98.1660923,8.4598124,10.3923668,3.0280929,31.3042949),(38091,'humerus.tif',235,2,87,42.210552,15.4830976,20.3372198,1.8,15.3953731,20.2932443,0.2769337,4.3281978,5.945747,242.0997445,347.3648864,0.5258846,58.4224134,55.9354616,99.1272747,8.4633831,10.5518498,3.0298156,31.4556158),(38092,'humerus.tif',235,2,88,42.1739512,15.5302068,20.2167256,1.8,15.429887,20.1768983,0.2786316,4.3185316,6.0462138,243.0429006,358.7960419,0.5317232,59.3422686,56.2790601,99.5193981,8.4450773,10.7236481,3.0215693,31.6512575),(38093,'humerus.tif',235,2,89,42.1711793,15.5717222,20.0954116,1.8,15.4617691,20.059198,0.2727807,4.302525,6.1200592,243.5334889,370.6878604,0.5101444,60.569326,56.602458,100.3195837,8.4502448,10.8830104,3.0233351,31.9225597),(38094,'humerus.tif',235,2,90,41.9894525,15.6137909,19.9769918,1.8,15.496607,19.9386266,0.2630279,4.328448,6.1770481,244.9345395,378.3566303,0.4731012,61.2520133,56.5871503,100.8813558,8.4396481,11.0304758,3.0346847,32.0868618),(38095,'humerus.tif',235,2,91,41.9651745,15.6711293,19.8637514,1.8,15.5392369,19.8189576,0.2540759,4.3527329,6.200647,246.607516,386.4808432,0.4418748,62.3291151,56.6557892,102.0675161,8.4315636,11.1084352,3.0160429,32.2695222),(38096,'humerus.tif',235,2,92,41.7514996,15.761925,19.7608273,1.8,15.6235885,19.7168717,0.2414523,4.3942329,6.200172,248.7096736,387.7137496,0.3978574,62.532741,56.599111,102.6455957,8.4582585,11.1426519,3.0309354,32.4208431),(38097,'humerus.tif',235,2,93,41.8844044,15.8040026,19.6536605,1.8,15.6646112,19.6150209,0.2266624,4.4294664,6.1686056,250.4155604,396.7504141,0.3525412,64.3176818,56.5340244,104.8268036,8.4591725,11.2065585,3.0747069,32.5094848),(38098,'humerus.tif',235,2,94,41.6938764,15.8707575,19.5641918,1.8,15.7205724,19.52989,0.2086304,4.4442419,6.1837574,252.210367,400.1053386,0.2981026,64.7026253,56.7499188,105.3013461,8.4761765,11.2477314,3.0940096,32.6608056),(38099,'humerus.tif',235,2,95,41.6603668,15.9381772,19.4725007,1.8,15.7964118,19.4423885,0.1865402,4.4780723,6.1707732,254.7938933,405.0083627,0.2388216,65.6333245,56.898119,106.6853948,8.5182298,11.3011711,3.0942347,32.7364661),(38100,'humerus.tif',235,2,96,41.6713786,16.0344035,19.3739479,1.8,15.8957257,19.3493285,0.1738097,4.5257527,6.1808062,258.369848,408.7398424,0.2077097,66.1305059,57.0888124,107.7726317,8.5490382,11.3250798,3.0611976,32.7807869),(38101,'humerus.tif',235,2,97,41.796999,16.1003217,19.2762665,1.8,15.9656567,19.2579869,0.162259,4.5518091,6.1470813,261.7085007,413.9471369,0.1818012,67.3404358,57.4954919,109.8280444,8.5923713,11.3496948,3.0377026,32.7494473),(38102,'humerus.tif',235,2,98,41.7538739,16.1963483,19.1991672,1.8,16.0634857,19.1881843,0.1479059,4.5750399,6.1592464,266.9029783,413.8844692,0.1511289,67.1972576,58.3389401,110.5275341,8.6482741,11.4029077,3.0381892,32.8510703),(38103,'humerus.tif',235,2,99,41.5087439,16.2976359,19.126764,1.8,16.1593341,19.1183084,0.1349793,4.585092,6.1570999,271.9488985,412.1627375,0.1252805,66.9410514,59.311547,111.0703897,8.7104858,11.4269793,3.0195605,32.8197308),(38104,'humerus.tif',235,2,100,41.5639183,16.3694107,19.0469996,1.8,16.2424848,19.0416843,0.1241168,4.6109866,6.1301075,276.8342107,416.2801877,0.1061683,67.9074862,60.0379564,113.046734,8.770183,11.445625,3.0479704,32.9840329),(38105,'humerus.tif',235,2,101,41.5361919,16.4667577,18.9698206,1.8,16.344354,18.9663275,0.1242355,4.6132207,6.0843817,282.9417738,417.2768819,0.1062996,68.5816411,61.3328073,115.0835473,8.852477,11.4276055,3.0666161,32.9840329),(38106,'humerus.tif',235,2,102,41.4116743,16.5675619,18.897187,1.8,16.4519753,18.8936572,0.1236469,4.6518969,6.0428657,288.8699329,417.3542379,0.1049842,69.0656156,62.0972347,116.7659526,8.9244821,11.4135707,3.0853141,33.1040142),(38107,'humerus.tif',235,2,103,41.3929579,16.6478876,18.8228749,1.8,16.5264932,18.819079,0.1124115,4.7050223,5.9873409,295.0769988,420.2042149,0.0868094,70.1821094,62.7153242,119.4652229,9.0055612,11.3975097,3.0428581,33.1040142),(38108,'humerus.tif',235,2,104,41.5974366,16.7336714,18.7438486,1.8,16.6280678,18.745517,0.1154468,4.7606933,5.9263668,301.7539255,426.0629625,0.0919917,71.8927766,63.3844504,122.6022618,9.0774395,11.3828091,3.0568901,33.255335),(38109,'humerus.tif',235,2,105,41.6669758,16.8302378,18.6541907,1.8,16.7237537,18.6544841,0.1232559,4.8359085,5.8884847,309.274808,428.117517,0.1049677,72.7041907,63.9538165,125.1833933,9.1471954,11.3612895,3.0283353,33.3309955),(38110,'humerus.tif',235,2,106,41.8445467,16.9284294,18.559324,1.8,16.8198708,18.5614508,0.1262444,4.9101808,5.8673155,316.3262043,433.6411129,0.1105612,73.9079249,64.4225165,127.6914877,9.2110556,11.3667047,3.0756507,33.4952976),(38111,'humerus.tif',235,2,107,41.4305003,17.0629582,18.4656421,1.8,16.9549793,18.4641662,0.1427534,4.9946671,5.9214141,322.2984782,434.6115615,0.1397621,73.3965826,64.5285203,127.338521,9.3035298,11.4276055,3.0666161,33.7665997),(38112,'humerus.tif',235,2,108,41.2569133,17.1653135,18.3717922,1.8,17.0706863,18.3651588,0.1437534,5.0920465,5.9181797,330.964042,438.4134481,0.1411199,74.0791043,64.9962727,129.5208358,9.4159479,11.4407475,3.0526262,33.9309019),(38113,'humerus.tif',235,2,109,40.9141674,17.2589068,18.3160401,1.8,17.1724776,18.3055516,0.1270996,5.2574231,5.919063,338.4389987,440.7357471,0.1095648,74.4603909,64.3735519,131.3727481,9.5494656,11.4734743,3.0762652,34.202204),(38114,'humerus.tif',235,2,110,40.6963425,17.3619389,18.2639677,1.8,17.2705408,18.2588243,0.1104101,5.3877425,5.9441538,347.0827787,442.9984142,0.0823487,74.5267412,64.4208182,132.3906975,9.7017778,11.523508,3.0812011,34.4551478),(38115,'humerus.tif',235,2,111,40.5635015,17.4896972,18.2215838,1.8,17.3990213,18.2139768,0.0952988,5.4770587,5.9681259,356.7694928,443.2225652,0.0612131,74.2649491,65.1388845,133.6036428,9.8699519,11.5304607,3.0719381,34.6378083),(38116,'humerus.tif',235,2,112,40.2795879,17.6374707,18.1743822,1.8,17.5483189,18.1668347,0.0499756,5.569056,5.9822663,366.8003546,442.4797043,0.0167529,73.9652308,65.8640093,134.9898813,9.9179293,11.5304607,3.0719381,34.8204687),(38117,'humerus.tif',235,2,113,40.0656433,17.7612043,18.1365963,1.8,17.6719007,18.1272966,-0.0111747,5.6154426,6.0503037,377.0052141,442.9342576,0.0008339,73.2085991,67.1372216,135.1179256,9.9493464,11.5917357,3.0630509,35.0161104),(38118,'humerus.tif',235,2,114,39.8186997,17.8911941,18.1167738,1.8,17.7921884,18.0965933,-0.0834328,5.6334649,6.1416713,382.3928165,446.0202761,0.0460893,72.6219711,67.8787966,134.8837816,9.9871766,11.6870262,3.0774605,35.2744313),(38119,'humerus.tif',235,2,115,39.9695089,17.9898844,18.0995811,1.8,17.8945986,18.0747832,-0.1336769,5.631559,6.1488338,387.7028301,456.4870045,0.118332,74.2396064,68.8446715,137.2561503,10.0250068,11.7517477,0.0774702,35.4570917),(38120,'humerus.tif',235,2,116,39.736136,18.1352149,18.0653888,1.8,18.0567705,18.0410807,-0.1829475,5.5919499,6.1782968,395.4239579,457.9682286,0.2191979,74.1253201,70.7130727,137.3349611,10.062837,11.8381374,0.0497327,35.7597334),(38121,'humerus.tif',235,2,117,39.5003977,18.2524904,18.0519963,1.8,18.177911,18.0075718,-0.2217491,5.6097727,6.2057056,399.2026067,463.9856629,0.3184517,74.7675913,71.161993,138.315717,10.1006672,11.9117728,0.0764274,35.9423939),(38122,'humerus.tif',235,2,118,38.978305,18.3826651,18.0650819,1.8,18.3087016,18.0271949,-0.255557,5.678141,6.21824,398.4304909,466.5505988,0.4151185,75.0293647,70.1691792,137.7615817,10.1384975,11.983284,0.0938935,36.1380356),(38123,'humerus.tif',235,2,119,38.4187557,18.527318,18.078828,1.8,18.4632769,18.0471641,-0.2465868,5.7598685,6.2828868,397.0459872,470.7722174,0.3815148,74.9292856,68.9331693,136.7089806,10.1763277,12.1176029,0.0662745,36.3963564),(38124,'humerus.tif',235,2,120,38.1428294,18.6620324,18.067706,1.8,18.5902708,18.0346047,-0.2676931,5.7672217,6.2670336,397.1701983,475.9747137,0.444772,75.9489649,68.8668166,137.0183008,10.1763277,12.1746305,0.0703682,36.529319),(38125,'humerus.tif',235,2,121,38.1431809,18.7745036,18.0187944,1.8,18.7028861,17.9808199,-0.3045103,5.7384585,6.2654875,403.4986174,482.7528421,0.5714843,77.0495264,70.3148098,138.5656699,10.2440394,12.2496314,0.0918461,36.6806399),(38126,'humerus.tif',235,2,122,38.08153,18.8963608,17.9770426,1.8,18.8148509,17.9443172,-0.3346327,5.7123981,6.2560487,407.8815391,488.6370795,0.6845865,78.1063421,71.4028559,139.1743353,10.2519881,12.3385667,0.0737789,36.8762816),(38127,'humerus.tif',235,2,123,37.6414468,19.0530723,17.9286053,1.8,18.9708796,17.9026286,-0.356172,5.7091966,6.3013933,409.0944626,489.809913,0.7627666,77.7304141,71.6553464,138.2479285,10.2898183,12.3845283,0.064844,37.0276024),(38128,'humerus.tif',235,2,124,37.1759501,19.1900916,17.8833163,1.8,19.1129197,17.8632278,-0.3639636,5.6950867,6.3218259,411.2132431,490.9409445,0.7851713,77.6580933,72.2049131,138.0314145,10.2898183,12.4379164,0.0645653,37.1032629),(38129,'humerus.tif',235,2,125,36.8801941,19.3170567,17.8746747,1.8,19.2512016,17.8546416,-0.3500028,5.7325415,6.3256844,410.9747648,496.2546352,0.7227331,78.4507421,71.6915469,138.4665974,10.3276485,12.4627449,0.0902712,37.2416024),(38130,'humerus.tif',235,2,126,36.6986756,19.4357217,17.8511678,1.8,19.3652401,17.825876,-0.3120231,5.7659096,6.3943921,414.8373319,502.0587335,0.5764113,78.5154756,71.9465547,139.7441306,10.403309,12.5068771,0.081365,37.4556024),(38131,'humerus.tif',235,2,127,36.92799,19.5424563,17.7944511,1.8,19.4791034,17.7836924,-0.2954028,5.7299947,6.4004385,420.7623914,513.6824073,0.5216318,80.2573773,73.4315496,143.2704012,10.4411392,12.5260861,0.0983937,37.593942),(38132,'humerus.tif',235,2,128,36.9809799,19.6779515,17.7311236,1.8,19.6144985,17.720805,-0.2969166,5.6961916,6.3931491,426.9205243,522.6122694,0.5275893,81.7456716,74.948414,145.2537531,10.497048,12.5980862,0.0637433,37.807942),(38133,'humerus.tif',235,2,129,36.9158223,19.8380553,17.7233966,1.8,19.7802103,17.7149106,-0.3166194,5.6849316,6.371234,433.2538062,527.1358302,0.5964517,82.7368495,76.2109096,146.8092588,10.5620002,12.6179503,0.0849018,38.0089608),(38134,'humerus.tif',235,2,130,37.0496644,20.0024136,17.6670922,1.8,19.937152,17.6533702,-0.3037468,5.6800372,6.4263309,438.6723563,534.2395377,0.5524065,83.1329026,77.2305434,147.6200059,10.6376262,12.7016036,0.0590032,38.2229608),(38135,'humerus.tif',235,2,131,37.6486306,20.1983037,17.6542409,1.8,20.1380711,17.6470789,-0.2724085,5.7363449,6.5241311,450.0857302,550.5949271,0.4542239,84.3936031,78.4621104,149.9514935,10.7148665,12.8151212,3.0747468,38.5753004),(38136,'humerus.tif',235,2,132,38.0156885,20.3700881,17.6549658,1.8,20.2954754,17.6646489,-0.2701356,5.7877317,6.5605533,459.1135281,570.3613549,0.4512169,86.9379953,79.3252952,152.8490366,10.7883682,12.9656679,3.0879252,38.9536025),(38137,'humerus.tif',235,2,133,38.5393067,20.5282323,17.6617129,1.8,20.4503985,17.6668498,-0.2142765,5.8787578,6.6610118,478.634115,585.3270274,0.2904322,87.8735906,81.4175598,156.7081803,10.8882427,13.1288831,3.0845119,39.457263),(38138,'humerus.tif',235,2,134,38.7926603,20.7880589,17.6698816,1.8,20.7171731,17.6749714,-0.2000884,5.9575473,6.8115761,490.0738248,605.4861788,0.2554105,88.8907607,82.2610042,157.6502092,10.9737621,13.2955848,3.0771658,39.9295838),(38139,'humerus.tif',235,2,135,38.7818133,20.9404194,17.658659,1.8,20.8621406,17.6576946,-0.2076712,5.9706298,6.848318,501.5863198,618.9297237,0.2747749,90.3768955,84.0089467,159.9199591,11.0827753,13.4364912,3.0458859,40.3262443),(38140,'humerus.tif',235,2,136,39.6020286,21.1445817,17.6511512,1.8,21.0821939,17.6446695,-0.1889471,6.0693307,6.9589522,528.1150913,639.5118857,0.2328477,91.8977269,87.0137286,163.4515121,11.2213249,13.6602175,3.0906564,40.9628673),(38141,'humerus.tif',235,2,137,39.4492929,21.3409425,17.6996701,1.8,21.2797489,17.6972005,-0.2097051,6.1938932,7.0049881,539.8895564,660.5726039,0.2849248,94.300318,87.1648153,165.3426233,11.366031,13.8625929,3.0488363,41.5108486),(38142,'humerus.tif',235,2,138,39.9385268,21.5674029,17.7220474,1.8,21.4902626,17.7102805,-0.1971435,6.341581,7.1287696,563.4108671,683.6150225,0.2553711,95.8952337,88.8439129,168.6482395,11.5571395,14.0274108,3.0460985,43.8097738),(38143,'humerus.tif',235,2,139,40.5646964,21.9121266,17.7663018,1.8,21.89376,17.7331537,-0.1415469,6.5456445,7.4373901,591.2783519,699.6107374,0.1345536,94.0666995,90.3315717,168.5755048,11.7485197,14.2149013,3.0284417,44.3761134),(38144,'humerus.tif',235,2,140,40.8537702,22.1930989,17.7421807,1.8,22.1696016,17.6925788,-0.0286775,6.6357356,7.7316745,618.2607099,728.4128241,0.0055982,94.2115222,93.17139,171.7232499,11.9400356,14.5269994,3.0049039,44.3134342),(38145,'humerus.tif',235,2,141,42.077444,22.6229905,17.7861259,1.8,22.5948711,17.7439841,0.0452566,6.8047224,8.1243274,648.672904,799.424339,0.0143538,98.398833,95.3268723,176.9199678,12.1979327,15.1033074,3.0137227,45.4353594),(38146,'humerus.tif',235,2,142,43.8473241,23.0345192,17.8609842,1.8,23.1533983,17.856302,0.109163,6.9563222,8.4938213,675.906828,902.9281672,0.0867395,106.3041166,97.1643929,185.3843026,12.4685211,16.1056334,2.9409398,47.0349824),(38147,'humerus.tif',235,2,143,46.0450748,23.8040207,17.9841961,1.8,24.0204863,17.9615953,0.1461394,7.1275459,10.023388,700.0804054,1221.0823865,0.162732,121.823318,98.2218018,190.9958225,13.1648624,19.3182426,2.9295322,63.8647823),(38148,'humerus.tif',235,2,144,48.5312962,24.722275,18.0880194,1.8,24.9873818,18.0924357,0.2002689,7.2890327,10.1101545,740.4861716,1560.9923442,0.3200986,154.3984664,101.5890867,227.2167655,13.7185913,20.2184712,2.9120171,104.8576844),(38149,'humerus.tif',235,2,145,51.7234014,25.5412155,18.2265518,1.8,25.7718095,18.180907,0.2158107,7.4887769,10.7937694,773.4871458,1862.6492019,0.3953021,172.5670743,103.2861777,244.220332,14.1398597,20.6599387,2.9355635,92.3436788),(38150,'humerus.tif',235,2,146,55.6031891,26.2508028,18.2963883,1.8,26.5121674,18.2507143,0.2206715,7.6726335,11.4082086,831.2289156,2110.6876294,0.443997,185.0148173,108.3368467,257.8556861,14.5772511,20.9219897,2.951218,61.2305711),(38151,'humerus.tif',235,2,147,58.3314509,26.7410592,18.3292825,1.8,26.9640617,18.276521,0.2130383,7.8122343,11.8541494,885.3757685,2282.8466819,0.4345973,192.5778567,113.3319531,267.26255,14.9476643,21.1866088,2.9278538,86.1569594),(38152,'humerus.tif',235,2,148,60.2656083,27.0777513,18.3288405,1.8,27.2458413,18.2702966,0.218194,8.0107503,12.0950456,923.5575817,2373.4521482,0.4706532,196.2334184,115.2897723,272.5720031,15.2992476,21.2939418,2.9057545,110.3567783),(38153,'humerus.tif',235,2,149,62.9536728,27.3756386,18.3629616,1.8,27.4898751,18.2995553,0.2296732,8.1835943,12.3416581,994.2516866,2431.5034237,0.5438018,197.0159435,121.4932771,277.576345,15.666806,21.3712253,2.8911496,228.4657918),(38154,'humerus.tif',235,2,150,63.9792904,27.6189367,18.173037,1.8,27.6692674,18.0826569,0.2321105,8.5317346,12.455151,1030.0005287,2469.0031679,0.5642408,198.2314914,120.7258053,280.9057052,11.3968645,16.7659993,1.3126605,120.9394068),(38155,'humerus.tif',235,2,151,66.6269905,27.6949644,18.0832974,1.8,27.6787253,17.9760976,0.2445568,8.7778818,12.4263511,1136.3121655,2531.1182667,0.6510027,203.6895824,129.4517502,295.0538058,16.4671886,21.3979946,2.8863051,258.4310118),(38156,'humerus.tif',235,2,152,69.3441853,27.731044,17.9091164,1.8,27.6441279,17.7948188,0.2608293,9.0890165,12.3203679,1237.4633779,2572.9285012,0.7685998,208.8353629,136.1493154,308.9229908,16.7459818,21.3580291,2.8935763,282.761566),(38157,'humerus.tif',235,2,153,70.5342203,27.7792449,17.6947826,1.8,27.6217276,17.6042893,0.2791986,9.5005522,12.184684,1358.7245241,2548.4303941,0.8928139,209.1503065,143.0153207,318.850566,16.8159371,21.2578878,2.9362999,105.3622674),(38158,'humerus.tif',235,2,154,75.1297807,27.6663526,17.5224447,1.8,27.4656704,17.4758412,0.313927,9.8439161,11.9037907,1531.5879865,2576.8185172,1.194,216.4704162,155.5872653,341.1904542,17.7314707,21.1343293,2.9273169,106.4398717),(38159,'humerus.tif',235,2,155,78.6499404,27.6708757,17.2971885,1.8,27.4413095,17.3418286,0.3804031,10.3503118,11.6008414,1680.3656679,2550.539302,1.8071111,219.8581298,162.34928,357.965543,17.8013869,20.8946791,2.8773617,90.0197136),(38160,'humerus.tif',235,2,156,82.7463309,27.4208728,17.2462482,1.8,27.1612,17.3527563,0.4827503,10.5155883,10.9724588,1919.3742583,2532.0918865,2.9719353,230.7679567,182.5265691,393.0720697,17.9023883,20.5284605,2.845393,243.9413082),(38161,'humerus.tif',235,2,157,86.4446756,27.2378946,17.2485971,1.8,26.9481582,17.3909189,0.8080497,10.9008582,9.8722132,2013.7607901,2567.7903243,7.5299621,260.1028026,184.7341521,417.3502892,18.3389293,20.1842541,2.8290623,252.5858779),(38162,'humerus.tif',235,2,158,93.7604182,26.7025096,17.5089232,1.8,26.4813228,17.5452432,1.182613,9.82197,10.0405093,2363.466437,2653.7588041,13.387926,264.305198,240.6305911,480.0965185,0.3212065,0.8356968,2.2655346,1.9282273),(38163,'humerus.tif',235,2,159,91.8557397,26.6462117,17.3417935,1.8,26.5190932,17.4007146,1.0476096,10.1687074,9.8255913,2124.3097056,2562.1070695,11.4874291,260.7585639,208.9065619,444.2580233,18.0111064,19.1780905,2.8993203,87.7015075),(38164,'humerus.tif',235,2,160,87.3549181,26.7561483,17.2894722,1.8,26.678599,17.3546473,1.1785865,9.7796804,9.8141231,1857.7752282,2384.0257699,12.4320481,242.9178599,189.9627745,401.4419556,0.214,0.4074439,1.1659045,0.9262834),(38165,'humerus.tif',235,2,161,84.7138655,26.659591,17.2808444,1.8,26.5964561,17.2790084,1.2912262,9.1556277,9.8311201,1683.2835279,2331.5200832,13.0438991,237.1571156,183.8523346,384.536273,17.1213026,19.0845839,1.6690703,152.6448167),(38166,'humerus.tif',235,2,162,80.1857677,26.425905,17.4499,1.8,26.3952908,17.4028027,1.3562371,8.9901358,9.7937562,1510.4289996,2141.4997788,12.7584435,218.6596992,168.009586,361.1671378,16.4857878,19.0478792,1.5848403,151.3751026),(38167,'humerus.tif',235,2,163,74.3062062,26.0160291,17.6197165,1.8,26.0179859,17.4861988,1.3584345,8.5898901,10.0077851,1318.616821,1957.3891272,11.8342085,195.5866468,153.5079969,326.0771172,8.1216992,16.4832977,0.72799,68.0574454),(38168,'humerus.tif',235,2,164,67.977447,25.493769,17.8615953,1.8,25.5041818,17.7383645,1.3187194,7.8527466,10.1621893,1065.9416574,1776.8162196,10.6247818,174.8458106,135.7412532,276.8038951,7.0926043,15.5194276,0.7512651,46.2425841),(38169,'humerus.tif',235,2,165,50.0522152,23.921967,18.1391241,1.8,23.911709,17.9557812,1.3490014,7.8150597,9.3527728,584.6950309,1548.8506198,7.9383512,165.6033613,74.8164506,219.7444343,2.8759518,4.3215949,1.3078016,12.2458533),(38170,'humerus.tif',235,2,166,37.2449476,22.4059507,18.1548521,1.8,22.4099303,18.026776,1.3691273,4.7866706,8.7110519,172.3964675,1326.6632731,5.9584341,152.2965648,36.0159453,159.2935758,0,0,0,0),(38171,'humerus.tif',235,2,167,31.6510305,22.2158677,18.3834701,1.8,22.22177,18.4054806,1.3397642,3.6242707,8.1869288,95.7322123,1076.8690817,4.9985792,131.5351713,26.4142,141.9808925,0,0,0,0),(38172,'humerus.tif',235,2,168,22.6185079,22.2679793,19.322579,1.8,22.3370723,19.4664609,1.2765886,2.9997487,8.0336538,36.9323456,717.0838266,3.4527553,89.2599862,12.3118131,92.8410507,0,0,0,0),(38173,'humerus.tif',235,2,169,11.1218409,22.9257556,21.3852998,1.8,22.927203,21.3457578,1.2412153,2.0440502,8.7602793,8.893379,254.2380787,1.6594766,29.0216864,4.3508614,30.0291141,0,0,0,0),(38174,'humerus.tif',235,2,170,2.1617417,23.8854871,23.9366275,1.8,23.8430346,23.9058315,0.1523077,9.781627,4.1242948,0.4018126,0.688635,0.0082935,0.1669704,0.0410783,0.1027217,0.321,0.4785186,2.677945,1.1846043),(38175,'humerus.tif',235,2,171,0.1321476,23.9516424,23.8202122,1.8,23.949063,23.8311736,-1.0897702,0.5110176,0.7344283,0.0051953,0.0125264,0.0173095,0.017056,0.0101667,0.0237961,0.6208993,1.0538278,0.4182243,2.7658691),(38176,'humerus.tif',235,2,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38177,'humerus.tif',235,2,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38178,'humerus.tif',235,2,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38179,'humerus.tif',235,2,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38180,'humerus.tif',235,2,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38181,'humerus.tif',235,2,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38182,'humerus.tif',235,2,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38183,'humerus.tif',235,2,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38184,'humerus.tif',235,2,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38185,'humerus.tif',235,2,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38186,'humerus.tif',235,2,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38187,'humerus.tif',235,2,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38188,'radius.tif',235,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38189,'radius.tif',235,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38190,'radius.tif',235,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38191,'radius.tif',235,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38192,'radius.tif',235,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38193,'radius.tif',235,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38194,'radius.tif',235,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38195,'radius.tif',235,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38196,'radius.tif',235,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38197,'radius.tif',235,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38198,'radius.tif',235,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38199,'radius.tif',235,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38200,'radius.tif',235,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38201,'radius.tif',235,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38202,'radius.tif',235,3,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38203,'radius.tif',235,3,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38204,'radius.tif',235,3,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38205,'radius.tif',235,3,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38206,'radius.tif',235,3,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38207,'radius.tif',235,3,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38208,'radius.tif',235,3,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38209,'radius.tif',235,3,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38210,'radius.tif',235,3,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38211,'radius.tif',235,3,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38212,'radius.tif',235,3,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38213,'radius.tif',235,3,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38214,'radius.tif',235,3,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38215,'radius.tif',235,3,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38216,'radius.tif',235,3,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38217,'radius.tif',235,3,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38218,'radius.tif',235,3,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38219,'radius.tif',235,3,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38220,'radius.tif',235,3,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38221,'radius.tif',235,3,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38222,'radius.tif',235,3,35,1.8089447,21.2550372,20.062975,1.8,21.2306865,20.1399677,1.341457,1.1902892,2.2179248,0.3744688,1.2163125,0.2859095,0.5484012,0.3146032,0.6962276,2.2067381,3.7211706,1.6614562,12.9364663),(38223,'radius.tif',235,3,36,9.403739,21.0148375,20.669981,1.8,20.9856724,20.6913798,-1.5610856,2.1571849,2.4848101,7.2943884,14.5890821,1.5671421,5.8713066,3.3814386,7.3722306,4.0876942,6.378383,1.1150226,18.6491561),(38224,'radius.tif',235,3,37,15.6204599,20.7374883,20.606981,1.8,20.7502053,20.5621549,-1.4148465,2.8493074,3.1613049,26.3695316,31.1211236,2.5406058,9.8443918,9.2547162,16.3882841,5.6130585,7.6372021,1.2257941,23.35913),(38225,'radius.tif',235,3,38,16.5715106,20.6702848,20.7172785,1.8,20.6575034,20.6449693,-0.209991,3.2161837,3.6724438,33.7343357,39.8708688,0.1200105,10.8567677,10.4889331,18.4233354,6.3649957,7.9922331,1.2712643,25.1944596),(38226,'radius.tif',235,3,39,15.5238745,20.6572386,20.7787074,1.8,20.5984056,20.7633986,0.0111838,3.1538105,3.3616624,30.2986856,42.8360593,0.0003236,12.7425227,9.6070089,18.4726836,6.9881538,8.191719,0.9903981,26.6895844),(38227,'radius.tif',235,3,40,15.5646922,20.344841,20.5132755,1.8,20.2519659,20.4689774,0.8473025,4.1152399,20.5051791,39.0592862,109.9892807,1.4572347,5.3639756,9.4913752,7.2573099,7.1567908,8.7521713,0.9863524,27.0955728),(38228,'radius.tif',235,3,41,15.7627264,19.6424298,19.7955607,1.8,19.6583946,19.8950321,0.9005971,4.3023674,19.6086084,41.7792846,350.2749156,1.6135316,17.8633235,9.7107665,19.9938244,7.2994775,9.0434347,1.0793781,29.0671447),(38229,'radius.tif',235,3,42,16.157772,18.8856261,18.9842747,1.8,19.0716088,19.3127493,0.9004025,4.371277,18.3631473,46.2873042,578.5675362,1.6534599,31.506992,10.5889661,34.021578,7.0748782,9.0350637,1.006927,29.1488901),(38230,'radius.tif',235,3,43,16.5558391,18.0296172,18.0533086,1.8,18.4516497,18.6322684,0.9073984,4.3466884,16.897024,49.7124245,827.0841158,1.7129589,48.948508,11.4368503,51.8594939,6.8502788,8.944581,1.0734536,28.1687475),(38231,'radius.tif',235,3,44,18.1566248,17.1631533,16.9789296,1.8,17.6288829,17.6174013,0.9244213,4.4312658,15.4573847,55.0692891,1133.8678293,1.9283509,73.3544419,12.4274399,76.8871077,0,0,0,0),(38232,'radius.tif',235,3,45,21.1999898,16.2064268,15.3917032,1.8,16.6598053,16.0020901,0.9617363,7.9289247,13.4208314,79.4085765,1533.2644855,2.3768909,114.2451195,10.0150499,120.1619145,0,0,0,0),(38233,'radius.tif',235,3,46,27.8161438,15.5701618,12.7303776,1.8,16.0149689,13.8240235,1.0610751,8.2260715,12.1802263,219.0329108,1953.3729613,3.5322815,160.3724688,26.6266723,178.0625608,0,0,0,0),(38234,'radius.tif',235,3,47,36.7712539,15.4027414,11.0835424,1.8,15.6920898,12.2898184,1.1100095,8.1456418,13.6310626,402.0984229,2158.4060149,4.9168297,158.3446635,49.3636269,187.6551841,0,0,0,0),(38235,'radius.tif',235,3,48,42.8087506,15.600653,10.4322539,1.8,15.6848857,11.5002832,1.1522276,8.3301361,13.9708352,583.4600818,2037.8085759,5.9560947,145.8616147,70.0420827,187.5347085,7.569984,16.7360396,0.6233696,65.6484488),(38236,'radius.tif',235,3,49,47.1785249,15.8413272,10.3992163,1.8,15.8270376,11.2821591,1.1477933,8.8774183,13.857843,766.4702557,1864.3502728,6.5380727,134.5339437,86.3393193,189.8428437,8.3099859,17.2492414,0.642199,75.7375194),(38237,'radius.tif',235,3,50,53.4505133,16.0208889,10.5805671,1.8,16.013509,11.3004814,1.1251264,9.2156802,13.5656201,961.8395053,1845.9163822,7.2531022,136.0731293,104.3698879,206.8545419,9.0587863,17.9300033,0.2145929,71.2953551),(38238,'radius.tif',235,3,51,56.8812791,16.1891779,10.6983247,1.8,16.179892,11.3163208,0.9763805,9.0332432,13.0293745,1157.1763668,1700.3661215,6.5069543,130.5025135,128.1019823,214.6558854,9.8740813,19.0952344,0.1893219,89.812944),(38239,'radius.tif',235,3,52,58.934183,16.6216839,11.1164871,1.8,16.5836133,11.5515109,0.6321116,10.069943,10.6570061,1330.9181361,1738.9273369,3.4290204,163.172219,132.1673955,241.2690948,11.0595045,20.3460816,0.1551672,65.4783465),(38240,'radius.tif',235,3,53,65.1842695,17.0003522,11.426276,1.8,16.974624,11.919606,0.3757518,11.2553194,10.2068811,1486.1976716,2089.2478683,1.463044,204.6901349,132.0440245,291.5017991,12.1789956,21.8903684,0.0976268,65.4238495),(38241,'radius.tif',235,3,54,64.9519526,16.627131,11.8605679,1.8,16.7865903,12.3226823,0.371518,10.8095813,10.5030856,1437.0304276,2176.8695939,1.4266804,207.2600061,132.9404342,301.4860558,13.3668354,23.1729457,0.0581867,71.4635209),(38242,'radius.tif',235,3,55,66.0167275,16.5098451,12.2479394,1.8,16.81246,12.8085716,0.4494465,10.1922352,10.7334913,1600.3730714,2153.4379404,2.0769039,200.6279109,157.0188522,322.7969739,14.2882831,25.0679893,0.044813,82.0496754),(38243,'radius.tif',235,3,56,72.7992052,16.7278044,12.0921735,1.8,16.9857376,12.6401196,-0.0286266,11.0406315,10.9490835,1983.0039839,2248.1485682,0.0099402,205.3275577,179.609652,363.0427134,14.345296,25.7286324,0.0305582,76.3369856),(38244,'radius.tif',235,3,57,84.900597,17.1167405,11.9826467,1.8,17.1049625,12.7936103,-0.6676865,10.8640975,10.7535316,2207.8509773,2753.083486,5.4247616,256.0166834,203.2245171,424.5054145,14.0809918,26.1718432,0.0214559,77.5370524),(38245,'radius.tif',235,3,58,90.9368922,17.2664651,12.0537507,1.8,17.1225757,12.9911245,-0.6546854,10.7682619,11.2564582,2134.0764005,3007.9501252,5.6194611,267.2199436,198.1820664,430.8543184,13.6554073,26.6209401,0.0210939,79.3610953),(38246,'radius.tif',235,3,59,90.3667367,17.402206,12.7070357,1.8,17.421233,13.5556787,-0.4982216,10.6187929,11.7587115,1934.6972656,2880.5017346,3.4392686,244.9674641,182.1955921,399.9785384,13.1236997,26.7612689,0.0503775,85.9449339),(38247,'radius.tif',235,3,60,89.6174403,17.2733891,13.5846271,1.8,17.3149531,14.269274,-0.2708791,9.9997224,11.7991303,1669.5229811,2636.6876618,1.0694095,223.4645768,166.9569336,364.8828726,13.1172768,26.8036477,0.0754865,98.8588269),(38248,'radius.tif',235,3,61,93.9797854,17.2648312,14.2593825,1.8,17.2880597,14.7671403,-0.1344791,9.1235048,11.6988645,1449.8011672,2582.604595,0.2815614,220.7568602,158.9083579,342.7234883,12.3010254,26.7612689,0.0503775,95.7097615),(38249,'radius.tif',235,3,62,88.976742,17.2474067,15.0044971,1.8,17.1850788,15.3306818,-0.0599796,8.2005349,11.5514872,1159.7349799,2264.1778271,0.0532857,196.007474,141.4218694,291.4576126,11.3948035,26.536957,0.0508037,75.4677733),(38250,'radius.tif',235,3,63,82.3267336,16.9568891,15.5600647,1.8,16.9469422,15.7628911,0.0264318,7.5329469,11.171472,947.5521118,2117.6138626,0.0095839,189.5554905,125.7877071,265.7740146,10.6987997,25.9334404,0.2628339,72.1439305),(38251,'radius.tif',235,3,64,76.4745067,17.2401294,16.0186871,1.8,17.1447992,16.1119865,0.0049151,7.0183986,11.4129074,793.8857484,1991.7698076,0.0003079,174.5190542,113.1149415,238.4843153,10.0224109,23.6213985,0.0570808,69.5370958),(38252,'radius.tif',235,3,65,75.7305352,17.0569943,16.4146296,1.8,16.9065172,16.3963617,0.0382754,6.7218036,11.3173508,707.8207324,1990.6564291,0.018482,175.8942064,105.3022032,233.2707675,9.4868043,23.1380893,3.1221776,65.1992502),(38253,'radius.tif',235,3,66,72.8315828,16.9851194,16.7467855,1.8,16.7633569,16.637014,0.0320639,6.3731158,11.2374658,647.9362929,1916.7155191,0.0124753,170.5647478,101.6671142,221.9645899,9.0632251,22.5230106,3.0667328,65.5168816),(38254,'radius.tif',235,3,67,68.6350885,16.9707107,16.8456511,1.8,16.6847245,16.6617268,0.0389592,6.3028358,11.2495556,556.4007018,1797.7058853,0.0173538,159.8023909,88.2778349,202.9759481,8.9052422,21.9398577,3.0801317,74.1267891),(38255,'radius.tif',235,3,68,66.5184311,16.8902091,16.9403711,1.8,16.4368066,16.7160479,0.074605,6.3269965,11.2529997,517.1885558,1718.8450969,0.0615914,152.7455029,81.7431388,194.6972069,8.9378268,21.6668496,3.0429555,62.4176381),(38256,'radius.tif',235,3,69,66.9838807,16.6485257,17.0640257,1.8,16.0581236,16.8624942,0.0969249,6.2581967,11.0184996,500.5236014,1764.5926695,0.1045514,160.1481806,79.978886,203.3580295,8.9140511,21.3726628,3.0837625,63.2821752),(38257,'radius.tif',235,3,70,67.0159121,16.4410373,17.3077293,1.8,15.6625747,17.0150853,0.1017311,6.0080891,10.8103311,491.62653,1768.2676154,0.1151955,163.5720124,81.8274372,207.048889,9.4184665,21.0300404,0.053425,68.5888767),(38258,'radius.tif',235,3,71,65.774457,16.0653358,17.339924,1.8,15.2711628,17.1493227,0.1867479,6.146877,10.473461,481.9986607,1741.0823741,0.3778879,166.2375382,78.4135844,212.1377841,9.2650807,20.8436143,0.0809041,65.6803724),(38259,'radius.tif',235,3,72,61.6813819,15.3578434,17.2726617,1.8,14.7102281,17.2908047,0.2501391,6.174686,9.717089,423.4887182,1755.4131648,0.6299254,180.6521648,68.5846562,210.5840238,8.7319136,11.9613629,0.2176506,44.4130949),(38260,'radius.tif',235,3,73,54.6545876,14.7186992,17.7320426,1.8,14.0560352,17.6442512,0.3916084,6.719141,9.7993895,282.0700671,1384.7956954,1.3269788,141.314486,41.9800784,161.6278166,1.4901343,4.3144118,2.2455373,10.6087278),(38261,'radius.tif',235,3,74,49.4950482,14.9357627,17.9058215,1.8,14.2753497,17.7253232,0.4021134,5.586531,9.3262867,224.5761338,1233.6940494,1.2634915,132.281378,40.199568,152.8903139,0.5932877,2.1804649,2.1730837,4.6827254),(38262,'radius.tif',235,3,75,1.5399526,13.3902887,19.9856468,1.8,13.1872955,20.0390817,-0.3907185,1.0272549,3.9779826,0.1468481,2.7328201,0.0372281,0.6869864,0.142952,0.7009086,1.3770471,4.7710835,0.4636476,12.328452),(38263,'radius.tif',235,3,76,7.2248029,13.2295543,19.5808852,1.8,13.0389407,19.6486996,-0.4823663,1.6749461,3.8699463,2.6958528,25.9507518,0.2591076,6.7057137,1.6095162,7.1992409,3.1386162,7.4389515,0.504166,21.7324379),(38264,'radius.tif',235,3,77,15.2519731,12.9665449,18.7660727,1.8,12.7656949,18.8493313,-0.5344352,3.2338463,4.6123857,20.0182146,85.8392755,0.6595018,18.6106024,6.1902184,20.2706816,6.0984458,8.9902869,0.3573087,34.1107117),(38265,'radius.tif',235,3,78,26.1034624,12.5401092,17.5905095,1.8,12.4538811,17.6091078,-0.5088924,4.293353,5.5637141,76.0173811,168.5546889,1.0327131,30.295354,17.7058305,43.6076018,7.8533067,11.0608033,0.2671425,49.4407001),(38266,'radius.tif',235,3,79,32.8050494,11.6528362,16.5469687,1.8,11.8370148,16.7789667,-0.2674347,4.8432641,5.7567013,135.460284,177.6535443,0.3818093,30.8603025,27.9687996,53.2693458,8.7902579,10.7532416,0.1256503,39.7961531),(38267,'radius.tif',235,3,80,27.10606,11.6876811,16.5480554,1.8,11.7598279,16.7163442,0.1242051,5.1570436,5.5303592,105.4181708,143.9330524,0.0693361,26.0259864,20.4415898,45.0857356,8.5785497,9.3269578,3.1054638,30.0745358),(38268,'radius.tif',235,3,81,25.0996799,12.0097531,16.7222334,1.8,11.9051493,16.8110262,0.1621108,4.9239856,5.0293107,92.6423423,124.7591824,0.1089765,24.8064176,18.8145029,42.5496077,8.3486448,9.6250696,0.1286965,33.2236012),(38269,'radius.tif',235,3,82,21.6864449,12.0706684,16.8733069,1.8,11.9186331,16.8793997,-0.1108576,3.9961691,4.7853818,84.7994179,109.5414862,0.0442372,22.8908562,21.2201775,39.8705823,7.7996764,9.5196728,0.2993662,30.8028307),(38270,'radius.tif',235,3,83,19.4308691,12.0809779,16.8080276,1.8,11.9448194,16.8647776,-0.1233262,3.8454722,4.6384964,77.528382,101.1737446,0.049006,21.8117543,20.1609522,38.286571,7.5240768,9.0287804,0.0996687,28.8199721),(38271,'radius.tif',235,3,84,17.9432625,12.1646177,16.8260518,1.8,12.0578372,16.9024501,-0.0359028,3.8212173,4.4844294,71.2017147,89.6929267,0.0038532,20.0009676,18.6332548,35.4260642,7.1871778,8.5620661,0.2927131,26.7168329),(38272,'radius.tif',235,3,85,17.5148369,12.2272253,16.8415496,1.8,12.2168805,16.9265678,-0.0231411,3.8130788,4.1829204,62.8766015,87.1981139,0.001563,20.8462285,16.48972,35.5451402,6.9244802,8.3268508,0.1762347,25.65962),(38273,'radius.tif',235,3,86,16.9595201,12.3456309,16.9381562,1.8,12.316929,17.0455793,0.0163503,3.7298704,3.9449489,59.7667126,81.6513058,0.0007556,20.6976842,16.0238042,35.6614975,6.8185931,7.8810037,0.0713075,24.4934132),(38274,'radius.tif',235,3,87,16.5006477,12.4628719,17.0228773,1.8,12.4631351,17.1577088,0.1105663,3.7541634,3.8643544,56.1873061,77.1295365,0.033483,19.9592294,14.9666649,34.4605527,6.81232,7.6495767,3.0828368,23.978431),(38275,'radius.tif',235,3,88,15.970221,12.6174062,17.1749371,1.8,12.6142616,17.3173515,0.3365467,3.7083484,3.7964247,55.6098555,72.3715886,0.2902629,19.0630907,14.9958552,33.1656225,6.7808117,7.4423413,3.0509328,23.6993347),(38276,'radius.tif',235,3,89,16.0759054,12.7290147,17.338787,1.8,12.6951182,17.5014455,0.5377868,3.6804906,3.6219562,56.7434973,71.3924312,0.703016,19.7110145,15.4173731,33.4860755,6.8169298,7.3210417,3.0648208,23.5292324),(38277,'radius.tif',235,3,90,16.0307949,12.8542217,17.4168252,1.8,12.84387,17.665155,0.7148632,3.6635097,3.6711729,56.1757394,71.2451404,1.1480687,19.4066429,15.3338586,31.6796648,6.7290146,7.3511253,1.8973778,23.5292324),(38278,'radius.tif',235,3,91,16.2988032,12.9468529,17.5060755,1.8,12.9859451,17.8128132,0.8287303,3.5783587,3.8298447,57.7883047,72.5743575,1.4757966,18.949687,16.1493886,33.4021422,6.6803109,7.3571273,2.1164514,23.4089518),(38279,'radius.tif',235,3,92,16.5528778,13.008907,17.5089437,1.8,13.062991,17.8553014,0.946107,3.5758192,3.9333334,58.2234272,73.4718828,1.8151774,18.6792921,16.2825424,32.7851126,6.5913151,7.4533475,2.1086319,23.5903409),(38280,'radius.tif',235,3,93,16.9301489,13.0961409,17.545545,1.8,13.1756274,17.9018627,1.0405325,3.3971279,3.9439838,58.9976387,77.1300319,2.0999194,19.5563763,17.3669172,32.9531057,6.5297022,7.5541866,1.3763162,23.6448378),(38281,'radius.tif',235,3,94,17.3388945,13.1588286,17.5428554,1.8,13.2526111,17.9086102,1.0799552,3.2966002,4.0522774,60.0526348,79.2348545,2.2477344,19.5531665,18.2165358,32.9145933,6.4790242,7.6865811,1.364805,24.0282528),(38282,'radius.tif',235,3,95,17.0603287,13.1891233,17.4522307,1.8,13.3065591,17.8259776,1.0421755,3.3514708,4.1470131,58.8312342,77.3445458,2.1201389,18.6506635,17.5538557,31.8654805,6.4240027,7.6372021,2.1995926,23.6561245),(38283,'radius.tif',235,3,96,16.866828,13.2511209,17.3804585,1.8,13.3775974,17.7717305,1.0244147,3.3573738,4.1430414,58.1348161,76.2050694,2.0521781,18.3935092,17.3155626,30.9119484,6.4273851,7.718508,1.4247841,24.307349),(38284,'radius.tif',235,3,97,16.7624512,13.2756868,17.3103054,1.8,13.4277895,17.7145911,1.0608649,3.2459712,4.1951175,58.4347496,75.1159812,2.1281089,17.9055725,18.0022389,30.1523138,6.3805123,7.7884485,2.3969882,24.0395395),(38285,'radius.tif',235,3,98,16.8205126,13.3357528,17.2541368,1.8,13.4961206,17.6080686,1.0514139,3.241215,4.3248083,58.6707495,77.4411519,2.1127756,17.9062622,18.1014679,30.5921371,6.3577806,7.7965404,2.4173427,24.4389163),(38286,'radius.tif',235,3,99,17.3328556,13.3952737,17.2367709,1.8,13.559041,17.5603718,1.0634142,3.1860544,4.3544617,59.233546,81.173393,2.2067905,18.6414299,18.591505,31.4070301,6.3284155,7.8223782,2.2545056,24.15982),(38287,'radius.tif',235,3,100,17.1962312,13.4342712,17.1101766,1.8,13.612691,17.4245702,1.0162944,3.2988227,4.4388323,58.3273606,79.523932,2.0715061,17.9155073,17.6812655,30.9866952,6.3926074,7.7965404,2.2950463,24.1485334),(38288,'radius.tif',235,3,101,17.825019,13.4792169,17.0958938,1.8,13.6559501,17.3819121,1.0534466,3.2209375,4.2786358,59.4366624,82.5364582,2.2441467,19.2903676,18.453218,32.9270737,6.388057,7.6767307,1.4682165,24.1757818),(38289,'radius.tif',235,3,102,18.1122241,13.5026152,17.0177595,1.8,13.6484998,17.221345,1.1189331,3.2156825,4.2515245,60.1434735,82.2358112,2.4431679,19.3426644,18.7031754,33.4671117,6.3934138,7.6824783,1.8370484,23.923934),(38290,'radius.tif',235,3,103,18.5506374,13.5358355,16.9374074,1.8,13.6719,17.0754039,1.1368838,3.1914773,4.1181645,60.3569486,81.0985,2.5452826,19.6928753,18.9119154,34.2707011,6.4138345,7.5541866,1.6601103,23.5019839),(38291,'radius.tif',235,3,104,18.7094283,13.5653765,16.8352694,1.8,13.682384,16.9400455,1.1099703,3.1982835,3.9866443,59.6872405,79.6496746,2.5016142,19.9791273,18.662273,34.7881478,6.424222,7.4423413,1.6614562,23.0913204),(38292,'radius.tif',235,3,105,18.4865114,13.5599982,16.6645441,1.8,13.6536132,16.7624252,1.0715837,3.1715595,3.8913464,58.5233141,74.6803367,2.3749418,19.1913874,18.4525356,34.0465677,6.3790935,7.2925634,1.7410083,23.0527853),(38293,'radius.tif',235,3,106,18.4564854,13.5658859,16.474543,1.8,13.648442,16.5671572,1.0148776,3.3084807,3.8140259,58.4721594,69.5121911,2.2194154,18.2254115,17.6734172,33.5456778,6.4634706,7.1113262,1.8425885,22.4833061),(38294,'radius.tif',235,3,107,18.6891293,13.578155,16.3115309,1.8,13.6507972,16.3602398,0.9312845,3.2562295,3.7128915,58.1691193,65.8233984,2.0054222,17.7283387,17.8639495,33.3313684,6.4634706,6.9335374,2.0054665,22.1656747),(38295,'radius.tif',235,3,108,18.8176891,13.5849152,16.1922093,1.8,13.6320027,16.2275967,0.7748752,3.2356489,3.5649881,57.6648407,63.2090766,1.5351401,17.7305153,17.8217236,33.718024,6.4634706,6.7304884,2.0195197,21.9796106),(38296,'radius.tif',235,3,109,19.0935379,13.5980468,16.0668162,1.8,13.6455042,16.0977256,0.5233281,3.3017674,3.4856255,57.1388258,62.0690256,0.7948182,17.8071412,17.3055274,33.9269039,6.3438712,6.747331,2.8198421,21.913827),(38297,'radius.tif',235,3,110,19.2181857,13.6018436,15.9346291,1.8,13.6467536,15.9521925,0.2828822,3.3314318,3.4485364,56.2086633,60.218832,0.2495496,17.4621418,16.872224,33.1819928,6.325308,6.6598523,3.0402462,21.6234441),(38298,'radius.tif',235,3,111,19.4511503,13.6079457,15.8196141,1.8,13.6353896,15.8469063,0.1053967,3.2166419,3.3505349,55.6076084,59.719547,0.0358789,17.8238842,17.2874727,33.2360202,6.1764809,6.6513256,2.9375747,21.3443478),(38299,'radius.tif',235,3,112,19.4541616,13.6007214,15.695268,1.8,13.6308256,15.7108469,-0.0823352,3.1831464,3.184863,54.1230489,58.6878316,0.0219306,18.4271133,17.0030034,32.9839317,6.1764809,6.6778175,0.8329813,21.2513157),(38300,'radius.tif',235,3,113,19.3721649,13.5942623,15.5665299,1.8,13.6273656,15.5750291,-0.1701294,3.0575116,3.1238027,52.587251,57.6645994,0.0925532,18.4597445,17.1993629,32.5343927,6.0641813,6.5423584,0.688145,20.8679007),(38301,'radius.tif',235,3,114,19.3975345,13.5800108,15.4595722,1.8,13.6114243,15.4671222,-0.2684846,3.0056083,3.1558273,51.5369796,57.1870963,0.2274959,18.121111,17.1469381,32.3627632,6.0641813,6.5596841,0.6640462,20.9609328),(38302,'radius.tif',235,3,115,19.4823847,13.5862336,15.3386985,1.8,13.6187651,15.3649947,-0.3206583,3.0271926,3.1730076,50.7118653,57.1204636,0.3225815,18.0019938,16.7521107,32.1246897,6.0641813,6.5423584,0.688145,21.146997),(38303,'radius.tif',235,3,116,19.703022,13.5871276,15.2304354,1.8,13.610192,15.2425712,-0.4008551,3.0310237,3.2138863,50.419398,56.961803,0.4999989,17.7236524,16.6344452,32.0116773,5.9518816,6.4784345,0.9827937,20.9881813),(38304,'radius.tif',235,3,117,19.5916976,13.5919839,15.1242286,1.8,13.6188248,15.1471029,-0.4536467,3.0415817,3.2317604,49.4620114,56.2793963,0.6271297,17.4144705,16.2619375,31.9406262,5.9518816,6.5143479,0.9445349,20.8951492),(38305,'radius.tif',235,3,118,19.170049,13.5847577,14.9856238,1.8,13.6122695,15.0301757,-0.4353151,3.0560534,3.1844838,47.0347268,55.6133246,0.5681607,17.4638426,15.3906757,31.0770324,5.9518816,6.5143479,0.9445349,20.709085),(38306,'radius.tif',235,3,119,19.4187683,13.5956764,14.9039204,1.8,13.6153292,14.9301963,-0.4953411,3.0068638,3.2924491,47.6490026,54.959301,0.731247,16.6925288,15.8467447,31.0397845,5.9518816,6.4803809,1.0838971,20.5775178),(38307,'radius.tif',235,3,120,19.6598281,13.6024869,14.8509373,1.8,13.6060535,14.8670407,-0.5501356,2.9993242,3.2780905,48.216217,54.6440804,0.8955797,16.6694851,16.0756939,30.8783052,5.9518816,6.5191859,0.83414,20.4844857),(38308,'radius.tif',235,3,121,19.848643,13.6102374,14.7690087,1.8,13.6125128,14.787172,-0.5843022,2.95834,3.286118,48.321879,54.3418362,1.0065969,16.536788,16.3341194,30.9524408,5.948641,6.4442782,0.723748,20.6047663),(38309,'radius.tif',235,3,122,20.1600244,13.6107759,14.6840751,1.8,13.6108735,14.7019212,-0.6665849,2.9660132,3.3143343,48.8350414,54.4993844,1.2845355,16.4435386,16.4648764,31.1780321,5.9462784,6.4910754,0.9203749,20.4187021),(38310,'radius.tif',235,3,123,20.181219,13.6005149,14.6142911,1.8,13.5953141,14.624907,-0.7170992,2.9583331,3.2852251,48.4718354,54.0522566,1.4527559,16.4531364,16.3848472,31.0300378,5.8957585,6.4491687,0.9586438,20.6047663),(38311,'radius.tif',235,3,124,20.1234334,13.5943146,14.5449681,1.8,13.5893918,14.5432228,-0.7829139,2.9718812,3.220255,48.3398791,53.3905944,1.6686207,16.579617,16.2657508,31.0677974,5.9283371,6.4168222,0.9973558,20.2871349),(38312,'radius.tif',235,3,125,20.1264196,13.5880886,14.4784074,1.8,13.5853342,14.4751986,-0.8477906,3.0122262,3.3446149,48.1127121,53.3277006,1.8859482,15.944347,15.9724767,30.3268669,5.8761806,6.5114434,1.0067126,20.2871349),(38313,'radius.tif',235,3,126,20.139375,13.5939578,14.4037093,1.8,13.5951688,14.3981858,-0.8934008,3.0436451,3.2963968,47.8299386,53.1198383,2.0379864,16.1145157,15.7146898,30.4203376,5.9192147,6.4168222,0.9973558,20.4459506),(38314,'radius.tif',235,3,127,20.1426941,13.5883554,14.3427028,1.8,13.5850273,14.3361845,-0.9339344,3.0302477,3.2373541,47.2241062,53.1136042,2.169909,16.4064859,15.5842395,30.4097871,5.8761806,6.4442782,1.1773457,20.1283192),(38315,'radius.tif',235,3,128,19.9913245,13.5893881,14.2861971,1.8,13.5785561,14.2798832,-0.9630452,2.9874395,3.235404,46.3944772,52.4648363,2.245469,16.2158531,15.5298468,29.6361042,5.7967728,6.4315454,1.1383886,20.3143834),(38316,'radius.tif',235,3,129,20.0446517,13.5896872,14.2306901,1.8,13.5714312,14.2332875,-0.959952,2.9883018,3.2465523,46.0822779,51.9550198,2.2417594,16.0031365,15.4208913,29.7048109,5.7967728,6.3575888,1.265804,20.3416318),(38317,'radius.tif',235,3,130,19.9876508,13.5960688,14.1703933,1.8,13.5788847,14.1639965,-0.9818408,2.940347,3.2267804,45.546957,51.3960157,2.3033361,15.927956,15.4903342,29.5648688,5.8424189,6.3247739,1.2827409,19.9695035),(38318,'radius.tif',235,3,131,20.0081523,13.5947305,14.1183257,1.8,13.5744013,14.1106563,-0.994798,2.9118291,3.264008,44.8705975,51.2101781,2.3453958,15.6893542,15.4097636,29.1818803,5.7967728,6.2977982,0.8737749,20.1555677),(38319,'radius.tif',235,3,132,19.9060781,13.595809,14.0653804,1.8,13.5758342,14.0614559,-0.9849998,2.9070476,3.220116,44.1111572,50.7997034,2.303605,15.7757372,15.1738681,29.1854417,5.7954769,6.2827616,1.06717,20.1828161),(38320,'radius.tif',235,3,133,19.8617852,13.5964501,14.0120092,1.8,13.5672971,14.012596,-1.017441,2.9626109,3.1901839,43.5057135,50.8482415,2.3960021,15.9389686,14.6849231,28.7026749,5.7967728,6.244507,0.6578886,20.1828161),(38321,'radius.tif',235,3,134,19.9509493,13.5997823,13.9551306,1.8,13.5696525,13.9491563,-1.0293086,2.9398139,3.1971406,43.1924671,51.3224905,2.4418335,16.0526225,14.6922455,29.048487,5.7173649,6.293792,1.2998495,20.0240004),(38322,'radius.tif',235,3,135,19.9917927,13.6031636,13.9065106,1.8,13.5836091,13.9063196,-1.0238051,2.8996065,3.2226669,42.7959614,51.6872349,2.4305867,16.0386524,14.7592308,28.7366654,5.7051385,6.29279,0.607802,19.996752),(38323,'radius.tif',235,3,136,20.0413286,13.6026715,13.8485214,1.8,13.584585,13.8560912,-1.020557,2.8753672,3.2357613,42.6114093,51.9052335,2.426954,16.0411194,14.8194667,28.9092852,5.7173649,6.2977982,1.1869787,19.996752),(38324,'radius.tif',235,3,137,20.1628408,13.6091331,13.7871813,1.8,13.5924084,13.7850681,-1.0186654,2.89394,3.2187104,42.3693569,52.5448617,2.4359969,16.3248181,14.6407172,28.852108,5.6379571,6.3546126,0.810393,19.9037199),(38325,'radius.tif',235,3,138,20.2810909,13.6144807,13.7392346,1.8,13.6004228,13.7462206,-1.0075189,2.8456327,3.2694806,42.0829366,53.2946005,2.4164464,16.3006319,14.7886047,28.6570548,5.6379571,6.3704694,0.860258,19.996752),(38326,'radius.tif',235,3,139,20.2369937,13.6182641,13.682564,1.8,13.6024236,13.687236,-1.015225,2.8299512,3.2324478,41.718983,53.5473225,2.4345739,16.5655647,14.7419445,28.9489609,5.6379571,6.3813481,1.0756631,19.9037199),(38327,'radius.tif',235,3,140,20.1891276,13.627176,13.6410308,1.8,13.6080473,13.6543025,-1.0068547,2.8519041,3.249365,41.3150246,53.8012141,2.4034705,16.5574547,14.4868209,28.5390502,5.6286378,6.3852994,1.1543577,20.4346639),(38328,'radius.tif',235,3,141,20.1247729,13.6461766,13.5984508,1.8,13.6327541,13.6096283,-0.9957732,2.8236044,3.2618901,40.9704637,54.3962688,2.3620534,16.6763031,14.5099873,28.8822757,5.6012247,6.4168222,0.9973558,20.0897841),(38329,'radius.tif',235,3,142,20.1639539,13.6571646,13.5599235,1.8,13.6367662,13.5712832,-0.9899968,2.8009305,3.3299809,40.8057455,55.3158265,2.3488871,16.6114548,14.5686389,28.7373926,5.5585492,6.4803809,1.0838971,20.5549445),(38330,'radius.tif',235,3,143,20.2745945,13.677217,13.5152471,1.8,13.668042,13.5236481,-0.9961669,2.7820912,3.3153377,40.6424654,56.1727412,2.3808522,16.9432937,14.6086031,29.1299902,5.4791414,6.4803809,1.0838971,20.0512489),(38331,'radius.tif',235,3,144,20.291635,13.6938755,13.4834525,1.8,13.6804935,13.4945852,-0.9905473,2.777283,3.3231081,40.4883007,56.949297,2.3654684,17.137359,14.5783848,29.270003,5.4791414,6.5798398,1.0918827,20.2758482),(38332,'radius.tif',235,3,145,20.2972334,13.7262256,13.4377255,1.8,13.7176598,13.4500661,-0.9789528,2.8312114,3.3173464,40.623546,57.1150897,2.3299755,17.2171015,14.3484678,28.8856688,5.4791414,6.5481388,1.1839206,20.1828161),(38333,'radius.tif',235,3,146,20.358101,13.7407052,13.4023374,1.8,13.7243915,13.4118042,-0.9708572,2.7987582,3.3272511,40.3536096,57.5176182,2.3114438,17.2868283,14.4183981,29.1544054,5.5224147,6.580798,1.1300455,19.9037199),(38334,'radius.tif',235,3,147,20.3718211,13.7638067,13.361944,1.8,13.7520308,13.3723567,-0.9657857,2.7337063,3.3400061,39.979731,57.7953756,2.296922,17.3039732,14.624735,29.2637008,5.5088509,6.5721687,0.9922721,20.3688803),(38335,'radius.tif',235,3,148,20.4043659,13.7902975,13.3210066,1.8,13.7805935,13.3271168,-0.9559348,2.7358916,3.3624823,39.9175346,58.0966581,2.2691334,17.2779076,14.5903203,29.0926985,5.3997335,6.580798,0.9307082,20.0240004),(38336,'radius.tif',235,3,149,20.3905288,13.8188371,13.2816449,1.8,13.8066909,13.2915,-0.9495154,2.7314157,3.3604842,39.7858708,58.6308746,2.2469891,17.4471508,14.5660256,28.9548372,5.3997335,6.6113887,1.2060615,20.4074154),(38337,'radius.tif',235,3,150,20.2729035,13.8488062,13.2350513,1.8,13.8326221,13.2399195,-0.9335486,2.6616351,3.3565346,39.373702,58.713362,2.1826894,17.4922557,14.7930503,29.0499207,5.3997335,6.6027994,0.8455664,20.3688803),(38338,'radius.tif',235,3,151,20.3273029,13.8742767,13.1987446,1.8,13.8600101,13.2041469,-0.9275663,2.6328418,3.35807,39.308169,59.4278722,2.1691272,17.6970321,14.9299395,28.87231,5.3203257,6.6361399,1.152572,20.3961288),(38339,'radius.tif',235,3,152,20.238104,13.9046173,13.1527513,1.8,13.8898475,13.1580539,-0.91527,2.6509943,3.4343945,39.0761365,59.5260786,2.1196595,17.3323355,14.7401815,28.6935996,5.3997335,6.7799608,1.1071487,20.4619124),(38340,'radius.tif',235,3,153,20.2054681,13.9302042,13.1227603,1.8,13.9161754,13.1316838,-0.9183596,2.6440803,3.3638166,38.7917563,59.6324934,2.1262883,17.7276292,14.6711719,29.0953113,5.3203257,6.6947926,1.1747149,20.0512489),(38341,'radius.tif',235,3,154,20.0747458,13.9574882,13.0898999,1.8,13.9411742,13.0970442,-0.9148214,2.6401408,3.4549049,38.5723083,59.8855315,2.1010993,17.3334817,14.6099438,28.346566,5.3203257,6.7164206,1.2120257,20.3416318),(38342,'radius.tif',235,3,155,20.084381,13.9806312,13.0636391,1.8,13.957379,13.0701998,-0.9117215,2.6231782,3.4021504,38.4179119,60.3535918,2.0920684,17.7398363,14.645559,28.7901511,5.3203257,6.6947926,1.1747149,20.3416318),(38343,'radius.tif',235,3,156,20.0615323,14.0216653,13.0264918,1.8,13.9986044,13.0415692,-0.9130039,2.6058702,3.42786,38.4145495,60.7414329,2.0938389,17.7199279,14.7415437,28.9255275,5.2946218,6.6863104,1.0620665,20.3961288),(38344,'radius.tif',235,3,157,20.1222109,14.0575175,12.98846,1.8,14.0434079,13.0017051,-0.9024459,2.591889,3.4104404,38.5814223,61.278686,2.0658186,17.9679686,14.8854456,29.2701293,5.2870645,6.7314252,1.0847644,20.4619124),(38345,'radius.tif',235,3,158,20.1033975,14.0974842,12.9495565,1.8,14.0808234,12.9624264,-0.8994904,2.6003409,3.4473957,38.7306737,61.6694063,2.0542481,17.8886939,14.89446,29.1185794,5.2409179,6.7566699,1.1964627,20.3303451),(38346,'radius.tif',235,3,159,20.1083788,14.130763,12.9176913,1.8,14.1140489,12.9351109,-0.8964761,2.6265357,3.4756346,38.8010201,62.057993,2.0449097,17.8551547,14.7726986,28.9626661,5.3203257,6.7566699,1.1964627,20.6479765),(38347,'radius.tif',235,3,160,20.1914972,14.1661375,12.8842243,1.8,14.1462451,12.9022601,-0.8951644,2.6188732,3.4713199,39.0214557,62.5261768,2.0490556,18.0122198,14.9000935,29.2524532,5.3203257,6.7799608,1.1071487,20.527696),(38348,'radius.tif',235,3,161,20.155537,14.196039,12.8600933,1.8,14.1679558,12.88009,-0.8855999,2.6221954,3.4374463,39.1870618,62.1925405,2.0139829,18.092658,14.9443716,29.468626,5.3203257,6.7846094,1.0701286,19.9309684),(38349,'radius.tif',235,3,162,20.1397713,14.2304759,12.828169,1.8,14.2104363,12.8477002,-0.8852332,2.6471802,3.4839088,39.3167307,62.4509533,2.0112011,17.9255418,14.8523061,29.189254,5.3203257,6.8309212,1.0924439,20.3688803),(38350,'radius.tif',235,3,163,20.1426549,14.267497,12.7935639,1.8,14.2477211,12.8178634,-0.8844953,2.648122,3.4471645,39.6001361,62.4024885,2.0090606,18.1025558,14.954045,29.5860358,5.3326823,6.7566699,1.1964627,20.5549445),(38351,'radius.tif',235,3,164,20.1677883,14.3036518,12.7701264,1.8,14.2866419,12.7956873,-0.8850464,2.6508506,3.4724312,39.9011167,62.5728987,2.0133836,18.0199103,15.0521937,29.4946947,5.3475368,6.762267,0.9505468,20.6207281),(38352,'radius.tif',235,3,165,20.1655412,14.3362244,12.7398076,1.8,14.3243065,12.7604627,-0.8866409,2.6772546,3.4614023,40.1719946,62.7952431,2.0184103,18.1415618,15.0049212,29.7297394,5.3461401,6.798536,1.0332097,20.3416318),(38353,'radius.tif',235,3,166,20.1148619,14.3680415,12.7145988,1.8,14.3581517,12.7403719,-0.8761714,2.677867,3.499702,40.3362074,62.9176228,1.9788849,17.9779942,15.062812,29.4776914,5.3850073,6.8392241,1.0557235,20.4346639),(38354,'radius.tif',235,3,167,20.1178502,14.40425,12.6846576,1.8,14.3910232,12.7048735,-0.8784513,2.6136668,3.4745025,40.6071719,63.3784072,1.9866946,18.2410018,15.536476,29.8702679,5.3653442,6.8833367,1.0779599,20.5934796),(38355,'radius.tif',235,3,168,19.9824418,14.4321815,12.6621012,1.8,14.4107352,12.6911729,-0.8646189,2.6570755,3.493895,40.8472842,63.0922561,1.9279383,18.0578572,15.3730232,29.7368241,5.3515025,6.805952,0.9140947,20.5934796),(38356,'radius.tif',235,3,169,19.9705529,14.467918,12.6328819,1.8,14.4536997,12.6546366,-0.8644965,2.6596353,3.4538716,40.9798284,63.4019107,1.926389,18.3567652,15.4080629,30.2212084,5.3997335,6.798536,1.0332097,20.4074154),(38357,'radius.tif',235,3,170,19.9171059,14.499207,12.6018653,1.8,14.4785487,12.6232201,-0.8577791,2.6628596,3.5090793,41.3165077,63.2234725,1.8991904,18.0171111,15.5158418,29.744385,5.3997335,6.9162365,1.0053124,20.5934796),(38358,'radius.tif',235,3,171,19.9506654,14.5400819,12.5822775,1.8,14.5222407,12.6129081,-0.8517086,2.6608437,3.5494802,41.748074,63.6262949,1.8823992,17.9255247,15.6897883,29.6399804,5.3997335,6.8952353,1.0415495,20.4074154),(38359,'radius.tif',235,3,172,19.9167272,14.575373,12.55429,1.8,14.5610078,12.582186,-0.8507365,2.684234,3.5195419,42.1445361,63.6952646,1.8759982,18.0976011,15.7007682,29.977069,5.4791414,6.8952353,1.0415495,20.5662311),(38360,'radius.tif',235,3,173,19.9009264,14.6044707,12.5352271,1.8,14.5823773,12.5653805,-0.839796,2.6803518,3.6162202,42.6175533,63.8128349,1.8384826,17.64628,15.8999848,29.4262276,5.4791414,6.9189711,0.9467733,20.8838625),(38361,'radius.tif',235,3,174,19.8946988,14.6454295,12.5128695,1.8,14.6275198,12.5396726,-0.8358124,2.6795295,3.5686618,43.0927765,64.1016659,1.8247711,17.962382,16.0822178,30.0048133,5.4791414,6.8952353,0.9240379,20.6977984),(38362,'radius.tif',235,3,175,19.9374954,14.6804846,12.4984821,1.8,14.6612715,12.5242734,-0.8283337,2.6907727,3.5350042,43.6040101,64.2228694,1.803954,18.1676928,16.2050141,30.4938369,5.5319422,6.8539598,0.9600704,20.8838625),(38363,'radius.tif',235,3,176,19.9169101,14.7125597,12.4844727,1.8,14.6936075,12.5173115,-0.8187995,2.7161065,3.4947685,44.0410486,64.0370434,1.7705351,18.3236867,16.2147723,30.7757145,5.5585492,6.8392241,1.0557235,20.7908304),(38364,'radius.tif',235,3,177,19.9117082,14.7514052,12.4716038,1.8,14.7355644,12.491528,-0.8048601,2.7388713,3.5227267,44.693873,63.8362318,1.7238796,18.121256,16.3183547,30.7506699,5.5585492,6.8952353,0.9240379,20.8566141),(38365,'radius.tif',235,3,178,19.8876342,14.788293,12.4646303,1.8,14.7727127,12.4922748,-0.8007749,2.7544137,3.5500576,45.0632988,63.7871693,1.7082625,17.9679253,16.3603957,30.6585405,5.6379571,6.8309212,0.8086498,21.1742454),(38366,'radius.tif',235,3,179,19.9325557,14.825457,12.4569284,1.8,14.8163787,12.4870214,-0.7855254,2.7747185,3.5011837,46.0232199,63.8897903,1.6614691,18.2480543,16.5866269,31.3626753,5.6379571,6.8281514,0.9371633,20.9768946),(38367,'radius.tif',235,3,180,19.9572819,14.8639449,12.4496905,1.8,14.8494876,12.4778761,-0.7790913,2.7990236,3.5355598,46.7402467,64.0070279,1.6421293,18.1037887,16.6987681,31.2018836,5.7034011,6.8567192,0.551655,20.763582),(38368,'radius.tif',235,3,181,19.9686219,14.9042031,12.4414285,1.8,14.8949107,12.4704971,-0.7582269,2.831503,3.4990078,47.4347926,64.0426783,1.5736676,18.3030968,16.7525135,31.7083881,5.7173649,6.821684,0.5743048,21.1742454),(38369,'radius.tif',235,3,182,20.0136976,14.9392469,12.4361734,1.8,14.9300513,12.4549459,-0.7436745,2.8304587,3.5197186,48.4220921,64.5455831,1.5287954,18.3382792,17.1075068,32.0956056,5.7588298,6.805952,0.9140947,20.8293656),(38370,'radius.tif',235,3,183,20.0906507,14.9757825,12.430067,1.8,14.9678645,12.4588477,-0.7371387,2.8637967,3.4752738,49.1429076,64.7436625,1.5128777,18.6298017,17.1600547,32.7182944,5.7967728,6.8318443,0.4415924,21.2014939),(38371,'radius.tif',235,3,184,20.1310649,15.0171612,12.4266492,1.8,15.0086482,12.4470193,-0.7166992,2.8980409,3.4986023,50.1493174,64.6168608,1.4478161,18.4693356,17.304558,32.7805095,5.8676617,6.8318443,0.4415924,21.1742454),(38372,'radius.tif',235,3,185,20.3137252,15.0536944,12.4281,1.8,15.0479239,12.4428131,-0.7173189,2.933932,3.4730447,51.4118701,65.3163857,1.4630315,18.8066641,17.5231976,33.4867934,5.9100151,6.8613158,0.3683489,21.2672775),(38373,'radius.tif',235,3,186,20.4397284,15.0912942,12.4255846,1.8,15.0837733,12.4463636,-0.707142,2.9098754,3.5061151,52.3256663,65.6706628,1.4378086,18.7303213,17.9820985,33.5437357,5.9328295,6.887,0.41988,21.3330611),(38374,'radius.tif',235,3,187,20.5252923,15.1272487,12.42639,1.8,15.120734,12.4492595,-0.6868643,2.9586554,3.4672544,53.4794257,65.6130671,1.3755459,18.9236377,18.0755846,34.1986188,6.0118901,6.798536,0.3897086,21.4260932),(38375,'radius.tif',235,3,188,20.7399635,15.1544256,12.4280506,1.8,15.1435151,12.4478153,-0.6579232,3.0123581,3.4552917,54.6760441,66.2763124,1.2924505,19.1811046,18.1505792,34.7407535,6.0980579,6.8805879,0.4563485,21.3988447),(38376,'radius.tif',235,3,189,20.7474526,15.1870952,12.4339471,1.8,15.1863165,12.4470614,-0.6279109,3.0451892,3.4994155,55.8344316,66.3240627,1.1933377,18.9528975,18.3352914,34.9082368,6.1144042,6.8539598,0.3165693,21.3988447),(38377,'radius.tif',235,3,190,20.8982645,15.2270551,12.4351389,1.8,15.2321505,12.4455196,-0.6018513,3.061043,3.4959951,56.8949021,66.9805252,1.1164823,19.1592159,18.58677,35.3840712,6.1660201,6.887,0.41988,21.530412),(38378,'radius.tif',235,3,191,20.9800649,15.2485319,12.4385094,1.8,15.2406113,12.456206,-0.5554739,3.0835594,3.4810836,58.0355622,67.4429223,0.9724042,19.3741171,18.8209647,36.0251811,6.1840844,6.94535,0.2449787,21.8095082),(38379,'radius.tif',235,3,192,21.0348805,15.2815924,12.4454409,1.8,15.275648,12.4687135,-0.515967,3.1493996,3.4859185,59.0129125,67.7229226,0.8533853,19.4275693,18.7378295,36.3560333,6.193812,6.9734377,0.2606024,21.8095082),(38380,'radius.tif',235,3,193,21.0837678,15.3030637,12.4507274,1.8,15.301649,12.4675999,-0.4672809,3.1639088,3.4985339,60.0336996,67.8832163,0.7130338,19.4033325,18.9745354,36.5437084,6.2732199,6.9025473,0.3835275,21.6234441),(38381,'radius.tif',235,3,194,21.1230341,15.3238022,12.4663884,1.8,15.3161843,12.4871438,-0.418157,3.1480841,3.5124894,61.0085248,68.0729483,0.5805261,19.3802575,19.3795729,36.74741,6.3526277,6.9662001,0.3625442,21.8480434),(38382,'radius.tif',235,3,195,21.1483411,15.3405247,12.4749312,1.8,15.3359594,12.496256,-0.3934158,3.1797616,3.4366074,61.8832243,68.3386511,0.5179714,19.8854982,19.4615921,37.7892287,6.3526277,6.8897462,0.3320595,21.7822597),(38383,'radius.tif',235,3,196,21.137809,15.3575192,12.4941945,1.8,15.3622382,12.509838,-0.3348849,3.1771966,3.4140107,62.779555,68.6408756,0.380543,20.1056419,19.7594176,38.3095405,6.4010802,6.8419894,0.4048918,21.8207949),(38384,'radius.tif',235,3,197,21.1849357,15.3776921,12.5061317,1.8,15.3929601,12.5149589,-0.2446608,3.2246293,3.3874815,63.8613345,69.2654504,0.2071676,20.4474774,19.8042408,38.6653716,6.4010802,6.8897462,0.3320595,22.0068591),(38385,'radius.tif',235,3,198,21.1248442,15.3849461,12.5310404,1.8,15.4016042,12.5322357,-0.1760401,3.2588735,3.3914057,64.4656067,69.6599393,0.1079877,20.5401375,19.7815613,38.9957804,6.4010802,6.9271684,0.2961151,21.9796106),(38386,'radius.tif',235,3,199,21.0441791,15.3987136,12.5659511,1.8,15.413593,12.5707684,-0.0564186,3.2596842,3.4487912,65.1402982,70.3389986,0.0111523,20.3952617,19.9836222,38.9794011,6.4010802,6.9770537,0.0644268,22.2587068),(38387,'radius.tif',235,3,200,20.7780385,15.407602,12.5938637,1.8,15.4062559,12.608581,0.0715084,3.3191814,3.4728063,65.4306641,71.0385061,0.0176777,20.455649,19.7128917,39.2879131,6.5133799,6.94535,0.2449787,22.3517389),(38388,'radius.tif',235,3,201,20.6792875,15.4241899,12.6194974,1.8,15.4346849,12.6196178,0.0992431,3.3564041,3.4878196,66.0132054,71.6409129,0.0338344,20.5403152,19.6678358,39.3335078,6.5133799,6.960767,0.3115468,22.4288092),(38389,'radius.tif',235,3,202,20.7751423,15.4425156,12.6431185,1.8,15.4600104,12.639175,0.1376604,3.4216265,3.5707292,66.6410884,73.2729271,0.0652027,20.5204383,19.4764356,39.1835426,6.5133799,7.0068145,3.0291655,22.4560577),(38390,'radius.tif',235,3,203,20.7518186,15.4527997,12.661918,1.8,15.4654227,12.6548697,0.2031837,3.462595,3.5495936,67.2075781,74.6962976,0.140831,21.0436195,19.4095985,39.8832669,6.5133799,7.0283795,0.2256012,22.680657),(38391,'radius.tif',235,3,204,20.6881292,15.4692593,12.6961696,1.8,15.4784431,12.6898608,0.2209173,3.4493974,3.5703565,67.6769893,75.8961729,0.1655589,21.2573096,19.6199456,40.0364103,6.586022,7.0820047,0.2565166,22.7079054),(38392,'radius.tif',235,3,205,20.7396136,15.4757932,12.7202889,1.8,15.487852,12.7147919,0.2609284,3.5290633,3.6297825,68.5702694,77.5276798,0.2300453,21.3587673,19.4301614,39.9835975,6.6098499,7.1184163,3.0309354,22.773689),(38393,'radius.tif',235,3,206,20.811655,15.4851556,12.7448244,1.8,15.4995732,12.7465795,0.2930129,3.5410315,3.6308424,68.8501676,79.1562851,0.2893771,21.8010797,19.4435344,40.4554682,6.6256795,7.1467062,2.9996956,22.9982884),(38394,'radius.tif',235,3,207,21.072856,15.4918757,12.7689983,1.8,15.5075177,12.7791683,0.2748553,3.5640181,3.6863259,70.0011279,80.8168073,0.258712,21.9234029,19.6410697,40.8595314,6.6412334,7.2020772,2.9533711,23.157104),(38395,'radius.tif',235,3,208,21.2231209,15.5067826,12.7856277,1.8,15.514841,12.793522,0.2699417,3.5579605,3.7167428,70.8811707,82.6804468,0.2515495,22.2454046,19.9218545,41.0441143,6.6420398,7.2300397,3.0326507,23.1026071),(38396,'radius.tif',235,3,209,21.3554912,15.5254214,12.8014483,1.8,15.5309425,12.8185102,0.2976715,3.6400947,3.7712302,71.5803488,84.5584362,0.3061732,22.4219766,19.6644193,41.3757553,6.7188916,7.2821801,2.8442275,23.1956392),(38397,'radius.tif',235,3,210,21.7074884,15.5429116,12.8165557,1.8,15.5555284,12.8278627,0.2982659,3.6496212,3.8244935,72.6673248,87.0556097,0.3124269,22.7626508,19.9109225,41.7627957,6.718225,7.3896244,2.8486803,23.6993347),(38398,'radius.tif',235,3,211,21.9487688,15.572215,12.8456766,1.8,15.5800487,12.8503538,0.3119272,3.707353,3.8595084,73.4680082,89.8263932,0.3445356,23.2740502,19.8168367,42.2358134,6.7379792,7.4668714,2.9294489,23.978431),(38399,'radius.tif',235,3,212,22.3937866,15.5961374,12.8689832,1.8,15.6104454,12.8845995,0.3271876,3.7289991,3.8273625,74.6273639,92.6279548,0.3854933,24.2015109,20.0127063,43.5867415,6.7379792,7.4668714,2.9294489,23.8036535),(38400,'radius.tif',235,3,213,22.7489995,15.6383095,12.8855874,1.8,15.6550312,12.8983284,0.3330986,3.7713747,3.8517372,75.6222684,95.3592005,0.405354,24.7574527,20.0516453,44.3713799,6.7379792,7.5541866,3.0522787,24.0555013),(38401,'radius.tif',235,3,214,22.9229561,15.6662248,12.8881779,1.8,15.6940407,12.9140848,0.3463999,3.7262306,3.8990007,76.378275,97.3637738,0.4403867,24.9714688,20.4974631,44.5271834,6.7379792,7.5766904,2.9325697,23.9624692),(38402,'radius.tif',235,3,215,23.2872104,15.7009157,12.9102852,1.8,15.717962,12.9222555,0.3411986,3.7860301,3.8961595,77.414783,100.078666,0.4345721,25.6864908,20.4474823,45.4936292,6.831369,7.6438044,2.9643673,24.1870685),(38403,'radius.tif',235,3,216,23.4804627,15.7442221,12.92521,1.8,15.7658928,12.9113631,0.3263867,3.7702654,3.9881369,79.0644345,101.8403479,0.4022941,25.5358202,20.9705221,45.3560668,6.8499037,7.7624978,2.8931052,24.4661647),(38404,'radius.tif',235,3,217,23.3397087,15.7856214,12.9326296,1.8,15.8079435,12.9327144,0.3104714,3.7890088,3.9851686,79.7181436,102.567341,0.3630681,25.7372652,21.0393132,45.6607952,6.8502788,7.7624978,2.8931052,24.2528521),(38405,'radius.tif',235,3,218,23.1141999,15.7953639,12.9711331,1.8,15.8128261,12.9878135,0.3131213,3.8245401,3.9633995,79.5137025,102.0893033,0.3655213,25.7580147,20.7903956,45.6227236,6.8502788,7.774673,2.9526955,24.690764),(38406,'radius.tif',235,3,219,23.037189,15.8199048,13.0016804,1.8,15.828561,12.9979907,0.3031896,3.8459046,3.9939141,80.0988039,102.9941627,0.3422617,25.7877762,20.8270388,45.7085848,6.8679893,7.790877,2.8791333,24.597732),(38407,'radius.tif',235,3,220,22.8210737,15.8545678,13.0334796,1.8,15.8614505,13.0386311,0.2977098,3.8886123,3.9911863,80.2380466,102.8850486,0.3272672,25.778062,20.6341081,45.289431,6.8684385,7.7811586,2.7878895,24.2256037),(38408,'radius.tif',235,3,221,22.5771577,15.9003097,13.0460195,1.8,15.9087944,13.0399145,0.2706109,3.9140097,4.0188451,81.7155437,102.6638014,0.2688942,25.5455977,20.8777061,45.7768194,6.8679893,7.8126991,2.8198421,24.7565477),(38409,'radius.tif',235,3,222,22.5159083,15.9472153,13.0512187,1.8,15.9510318,13.0437693,0.2240566,3.8421466,4.00082,82.8503039,102.0895749,0.1852569,25.5171626,21.5635456,45.0316979,6.8684385,7.8296298,2.9976672,25.1014275),(38410,'radius.tif',235,3,223,22.218505,15.9874171,13.0547325,1.8,15.9837364,13.0420797,0.1521997,3.7778131,3.9595988,83.2252525,101.6353779,0.0851207,25.6681001,22.030008,44.8520731,6.8568013,7.7811586,2.7878895,24.9426118),(38411,'radius.tif',235,3,224,22.1119609,16.0579479,13.067028,1.8,16.0686014,13.0679565,0.0697195,3.7189694,3.9503267,84.8919727,101.4980298,0.0178846,25.6935785,22.8267468,44.8223853,6.8679893,7.790877,2.8791333,24.8223313),(38412,'radius.tif',235,3,225,21.8238358,16.1084124,13.0717769,1.8,16.0987519,13.0673688,-0.0157197,3.6159874,3.8776235,84.9473016,100.961957,0.0008987,26.0370707,23.4921456,44.9907919,6.9866255,7.7779165,2.8335399,25.1127142),(38413,'radius.tif',235,3,226,21.3162621,16.1721512,13.0878876,1.8,16.1670993,13.0854718,-0.1001719,3.4815292,3.8603169,85.0840136,100.0670259,0.0355303,25.9219721,24.43869,44.0410639,6.9730559,7.8005832,0.3992208,24.92665),(38414,'radius.tif',235,3,227,21.4509324,16.2339891,13.0975108,1.8,16.220585,13.1092637,-0.186721,3.5272153,3.8638728,85.2338098,101.5142222,0.123205,26.2726613,24.1646179,44.2881214,6.9787489,7.8489344,0.5919708,25.0469306),(38415,'radius.tif',235,3,228,21.1948083,16.326127,13.1151447,1.8,16.2916214,13.1122445,-0.2300237,3.5242476,3.8567701,85.6380002,101.9564719,0.1836328,26.435714,24.2996545,44.4040617,6.9903203,7.9041726,0.3936982,25.3532753),(38416,'radius.tif',235,3,229,21.2199666,16.4052844,13.1382647,1.8,16.3827749,13.1158803,-0.2664078,3.5440463,3.9600121,86.6967507,102.4254899,0.2451255,25.8649437,24.4626465,44.6175785,7.0005628,7.9407846,0.5016041,24.7678343),(38417,'radius.tif',235,3,230,20.8838063,16.4834573,13.1558754,1.8,16.4635971,13.1558751,-0.3192305,3.5447568,3.9684177,85.8296449,102.9788394,0.3428184,25.9495966,24.2131266,43.4750695,7.0256669,7.9867084,0.4825133,25.2329947),(38418,'radius.tif',235,3,231,20.5004701,16.5490337,13.1509943,1.8,16.5158699,13.1340962,-0.3939079,3.5502313,4.0434259,85.1066985,103.0253233,0.5032947,25.4797113,23.972156,43.933221,7.0319212,8.0048466,0.5957845,25.512091),(38419,'radius.tif',235,3,232,19.9665004,16.6175737,13.1693651,1.8,16.569533,13.155139,-0.4290532,3.5684862,4.0685141,84.2915299,101.7866042,0.5759148,25.0181277,23.6210886,43.0219743,7.0315859,8.0362937,0.5763752,25.4190589),(38420,'radius.tif',235,3,233,19.5186425,16.6996118,13.1521301,1.8,16.6688693,13.1355748,-0.4885314,3.5586199,4.1697241,82.7835366,101.8795854,0.7165628,24.4331719,23.2628209,42.6729297,7.0287512,8.1384327,0.488334,25.2987783),(38421,'radius.tif',235,3,234,19.0753476,16.7713987,13.1715403,1.8,16.732167,13.1580969,-0.5494554,3.5504346,4.2645112,81.3532967,101.0345188,0.8670277,23.6919345,22.9136166,41.5852436,7.0594481,8.191719,0.5803982,25.457594),(38422,'radius.tif',235,3,235,18.6883039,16.8666361,13.1631554,1.8,16.8277002,13.1613896,-0.5737428,3.5347427,4.3148793,80.2352038,101.5934312,0.9176249,23.544907,22.6990224,41.2445082,7.0287512,8.2538335,0.5917762,25.6709067),(38423,'radius.tif',235,3,236,17.9956035,16.9167934,13.1810536,1.8,16.8634985,13.1735578,-0.6132266,3.5740542,4.3362941,77.8916137,99.5706853,0.9933896,22.9621614,21.7936296,39.5835235,7.0594481,8.2904225,0.4939414,25.457594),(38424,'radius.tif',235,3,237,17.3602634,17.0081268,13.1902697,1.8,16.9528471,13.2062678,-0.6321013,3.5270987,4.3596493,76.2308678,97.9277043,1.0100593,22.4622896,21.6129102,39.1097825,6.9466243,8.3329067,0.6515872,25.4848425),(38425,'radius.tif',235,3,238,17.0889718,17.0986666,13.190326,1.8,17.0584331,13.2058025,-0.6697875,3.5736704,4.4811135,74.9487315,99.4006768,1.0977293,22.182138,20.9724802,38.8983153,7.007425,8.4754625,0.5585993,26.0543217),(38426,'radius.tif',235,3,239,17.0506584,17.1688705,13.2113734,1.8,17.1421495,13.2412816,-0.7157585,3.5388821,4.5669944,74.7264161,100.774847,1.223627,22.065901,21.1158255,37.9433302,6.9084826,8.4754625,0.5585993,26.1473537),(38427,'radius.tif',235,3,240,17.2431091,17.2930448,13.2220606,1.8,17.231722,13.2518438,-0.7401174,3.5343071,4.6433441,74.9955815,103.9964124,1.3069733,22.3968784,21.2193164,38.1188554,7.0237518,8.5995435,0.7114591,26.4649851),(38428,'radius.tif',235,3,241,17.3678022,17.3913011,13.2544592,1.8,17.3291778,13.3258398,-0.7667991,3.4473285,4.6958333,75.2453828,107.1178384,1.3934919,22.8112523,21.8271577,38.556706,6.9084826,8.8146286,0.9757267,26.371953),(38429,'radius.tif',235,3,242,17.3805197,17.5290761,13.1725456,1.8,17.500705,13.2019999,-0.7563796,3.5209329,4.6916464,74.5275402,109.6502216,1.3643641,23.3713737,21.1669869,39.1107183,6.9878905,8.7370285,0.6486425,26.4649851),(38430,'radius.tif',235,3,243,17.1916106,17.5977891,13.2437924,1.8,17.5881446,13.2369242,-0.8177104,3.5112979,4.7894687,76.0195482,108.2693859,1.5251529,22.6057196,21.6499852,38.4628754,6.9878905,9.0099041,1.1740877,27.0617127),(38431,'radius.tif',235,3,244,16.9765398,17.688551,13.3330131,1.8,17.7039235,13.3192161,-0.8123577,3.5235614,4.9497815,76.0389205,108.6588518,1.4909547,21.9522522,21.5801318,37.2536149,7.0373389,9.1350091,1.2062703,27.19328),(38432,'radius.tif',235,3,245,16.9190212,17.7714624,13.398099,1.8,17.7910931,13.3597847,-0.8689079,3.4443327,5.0530182,76.3456282,110.7639505,1.644309,21.9203546,22.1655789,36.9464143,7.0286518,9.2693143,1.237552,27.19328),(38433,'radius.tif',235,3,246,17.316462,17.8794531,13.3013504,1.8,17.9537814,13.2836144,-0.8655275,3.5523692,5.0664792,78.9384731,116.0902138,1.6733093,22.9133901,22.2213595,38.3957873,7.1171369,9.3066538,1.226149,27.6424786),(38434,'radius.tif',235,3,247,17.410883,17.9844015,13.2751367,1.8,18.0828364,13.2009209,-0.8478523,3.6423035,5.1732574,80.4271489,119.3802287,1.6316662,23.0764138,22.0813968,38.6208385,7.205135,9.3755079,1.2414702,28.3049898),(38435,'radius.tif',235,3,248,18.4594606,18.1232252,13.2588551,1.8,18.2502232,13.1721053,-0.8689903,3.688104,5.2996148,87.2099977,126.5059705,1.7942695,23.8707861,23.6462958,40.30617,7.3055219,9.6603814,1.2637506,28.8086854),(38436,'radius.tif',235,3,249,19.200817,18.2788427,13.2028933,1.8,18.4147216,13.1141628,-0.820786,3.8275373,5.4010905,92.4485329,136.8667566,1.7132193,25.3405783,24.153529,42.3459735,7.4643376,9.8061456,1.1583859,29.6027638),(38437,'radius.tif',235,3,250,19.7017519,18.4208982,13.2063665,1.8,18.5702985,13.0859684,-0.7960666,3.9085401,5.5302311,96.3948298,144.8891201,1.6768412,26.1994691,24.6626178,43.418018,7.6231532,10.0550528,1.2172544,30.024714),(38438,'radius.tif',235,3,251,20.4106409,18.5104466,13.2353491,1.8,18.7196324,13.1373833,-0.7994186,4.8852384,5.807987,103.6700298,152.8468943,1.7485748,26.3166729,21.2210791,38.5669097,7.7800396,10.2734237,1.2939982,30.6327283),(38439,'radius.tif',235,3,252,20.9594145,18.6606871,13.2507407,1.8,18.8873883,13.1459111,-0.7319901,5.141449,5.8193847,110.1129735,159.4076873,1.5604055,27.3925332,21.4167201,39.992713,7.9407846,10.5543752,1.2120257,31.2407426),(38440,'radius.tif',235,3,253,22.5888364,18.8252554,13.2449111,1.8,19.0580266,13.1497959,-0.80335,4.7150736,6.0750149,123.1963218,174.02543,1.9499737,28.6460911,26.1281862,44.8034649,8.2056983,11.6618743,1.2977876,34.4170564),(38441,'radius.tif',235,3,254,23.0562498,19.0332863,13.1664119,1.8,19.2827745,13.1139381,-0.8506928,4.3471596,6.1532562,135.2382323,188.6964011,2.1715497,30.6661052,31.1095623,50.8059934,8.4517631,12.203516,1.3101939,35.7533656),(38442,'radius.tif',235,3,255,23.2774275,19.1303233,13.2303253,1.8,19.4090431,13.2397194,-0.9103305,4.4035099,6.3319784,143.519052,211.0125926,2.4194419,33.3249072,32.5919676,54.2414643,8.7348631,12.5579938,1.3084658,36.6677246),(38443,'radius.tif',235,3,256,26.9787209,19.2647401,13.4132933,1.8,19.5007142,13.4430971,-0.9471618,4.6146258,6.5698593,167.1331448,256.0213999,2.9629667,38.9690843,36.2181358,63.9493577,9.0954569,13.1121568,1.2842616,37.4843764),(38444,'radius.tif',235,3,257,28.6796517,19.2303969,13.490381,1.8,19.5263136,13.4936498,-0.9710028,4.8358672,6.8501264,179.2641166,291.823947,3.2569153,42.6012497,37.069694,68.769268,9.5401966,13.1826592,1.1681417,38.3555252),(38445,'radius.tif',235,3,258,36.5284594,19.4756898,13.8673002,1.8,19.5869473,13.6445847,-0.9383935,5.2332262,7.2787151,225.3603243,380.5691873,3.961018,52.2852156,43.0633643,82.2947238,9.7062592,13.6733763,1.2360595,40.9238247),(38446,'radius.tif',235,3,259,41.0220706,19.6944071,13.6638392,1.8,19.6179184,13.6298386,-0.8587455,5.2740676,7.0069902,242.641334,444.6787136,3.918186,63.462157,46.0064891,97.4411256,9.9833648,13.6049535,1.2255514,40.6560152),(38447,'radius.tif',235,3,260,40.3900606,19.8099883,13.524164,1.8,19.6523905,13.6095439,-0.8495883,5.2132698,6.7035965,237.9974,433.0568906,3.7967597,64.6006802,45.6522317,99.9821884,9.9225009,13.2098956,1.1223567,40.2068166),(38448,'radius.tif',235,3,261,39.3651679,19.66484,13.632309,1.8,19.521403,13.6546177,-0.6909069,5.3691827,7.6788835,265.7953255,389.0606689,2.6641701,50.6663069,49.5038703,84.072039,10.3534132,12.7097213,1.0834377,41.3344882),(38449,'radius.tif',235,3,262,34.9343575,19.3661816,13.4510607,1.8,19.5112805,13.5138859,-0.6208337,5.4725518,7.22206,202.4506739,328.6922046,1.9702431,45.5122504,36.9938339,72.8597351,10.1082177,12.1584797,0.3685001,50.55241),(38450,'radius.tif',235,3,263,24.8937504,19.4246292,12.9178197,1.8,19.4764971,13.0405546,-0.5753262,6.2683574,6.2380231,87.0568859,250.9020404,1.2283161,40.2214027,13.8883092,48.2533951,8.4172317,11.6586296,0.3644076,42.0853564),(38451,'radius.tif',235,3,264,23.7736258,19.5706455,12.4721052,1.8,19.6769688,12.5086791,-0.468327,7.0488824,6.2027719,44.9908547,225.5519121,0.807339,36.3630834,6.3826933,35.8092348,6.1749557,12.3069353,0.4432423,40.2613135),(38452,'radius.tif',235,3,265,20.2814005,19.9412297,12.2661962,1.8,20.0112371,12.3804718,-0.4313509,7.3337609,6.3997907,29.9687111,179.4670368,0.5908859,28.0426416,4.0864042,26.3361068,5.1892838,12.1101522,0.4304648,39.1768521),(38453,'radius.tif',235,3,266,10.4539843,20.984963,11.9324376,1.8,20.5497135,12.1568742,-0.3791321,7.5539202,6.8126116,9.5023965,96.7951705,0.2386725,14.2082326,1.2579424,12.6250026,4.6829759,11.3027244,0.441429,35.7307922),(38454,'radius.tif',235,3,267,5.6344127,22.066449,11.6504235,1.8,21.0652857,12.0836029,-0.4280113,2.0143791,8.0482936,3.6887565,46.1783966,0.1617797,5.737663,1.8312126,6.0850184,3.8058244,11.2035438,0.4905469,32.1710634),(38455,'radius.tif',235,3,268,0.8538463,23.215846,10.9312754,1.8,23.1825789,10.9615691,-1.0144518,2.6982412,9.5401393,0.599617,0.6342438,0.1026217,0.0664816,0.2222251,0.1245743,1.3801272,3.7649704,2.8387078,9.9462166),(38456,'radius.tif',235,3,269,22.0553952,19.2865255,17.0122472,1.8,19.3042743,17.0684096,-0.8788021,3.2065583,8.5494582,46.3936753,337.7011092,2.1792995,39.4997088,14.468371,44.6798265,6.0463978,12.15433,0.6675261,37.5116249),(38457,'radius.tif',235,3,270,24.8845991,19.1209204,16.9214643,1.8,19.1525575,17.0222482,-0.8366968,3.4297969,8.4609529,60.0411355,366.1987542,2.286101,43.2810298,17.5057409,50.3514169,6.2995877,16.4606164,0.8384883,58.3842007),(38458,'radius.tif',235,3,271,34.8920435,18.5024679,17.4721971,1.8,18.7422623,17.3236785,-0.8209088,3.5778769,8.4816629,86.3122535,654.429009,3.114003,77.1581016,24.1238742,83.9848384,6.8443053,17.3334797,1.0259324,58.5270546),(38459,'radius.tif',235,3,272,34.6750009,18.8106768,17.2088445,1.8,18.8982318,17.2420837,-0.8110084,3.9624611,8.3299662,103.2295381,656.8023171,3.0375247,78.8481373,26.051874,86.3500365,7.6739777,17.8581167,0.8744477,56.8844008),(38460,'radius.tif',235,3,273,33.7025201,19.0753712,16.9945172,1.8,19.1179731,17.0552775,-0.7876634,4.2630399,8.6970832,103.9762447,622.7076681,2.8212673,71.5995992,24.3901646,83.53415,10.0738346,18.787299,1.0857616,78.5576667),(38461,'radius.tif',235,3,274,33.0063268,19.0439479,17.0357252,1.8,19.1186124,17.1333801,-0.7335889,4.778259,8.7273314,102.4952527,583.4471993,2.4660312,66.8528757,21.4503343,78.5780854,10.3454056,19.090941,1.080839,82.1606058),(38462,'radius.tif',235,3,275,34.327677,18.9108609,17.1025775,1.8,19.0073328,17.1361331,-0.7033388,4.99386,8.6584477,126.7467867,567.9950038,2.3932602,65.6000965,25.3805247,80.1452428,10.8475382,19.2019272,1.0233559,78.1357165),(38463,'radius.tif',235,3,276,36.3478314,18.7167537,17.466377,1.8,18.8888168,17.3865841,-0.735031,4.7482731,8.594344,146.5874204,621.6330899,2.7243791,72.3304872,30.8717334,87.2016684,7.7226388,12.7775096,1.7923251,44.0024314),(38464,'radius.tif',235,3,277,35.9559479,18.3710595,17.7625439,1.8,18.5694702,17.6327267,-0.7277702,4.7789785,8.4961745,161.8142349,572.2676122,2.6517486,67.3559158,33.859586,83.3303669,7.6179066,12.8557355,1.8178936,58.3024553),(38465,'radius.tif',235,3,278,38.937047,18.4251325,17.3341191,1.8,18.5405253,17.3090447,-0.7596979,5.5259087,8.3263992,160.0571141,593.9554672,3.0780452,71.334013,28.9648494,88.3210904,9.9653425,19.8239903,1.2777118,81.9632549),(38466,'radius.tif',235,3,279,32.756624,19.331434,16.2507397,1.8,19.4059676,16.3128476,-0.6902727,5.2820779,7.2360757,142.8073108,374.9825668,2.2135144,51.8212609,27.0361994,69.2980783,8.1388557,12.916413,0.0173896,50.9198632),(38467,'radius.tif',235,3,280,22.4468141,20.9020231,15.0055785,1.8,20.9976853,15.0795139,-0.3486229,5.5140823,5.2299577,81.3786088,169.4954296,0.4365651,32.4085661,14.7583231,37.6471566,3.2344155,5.8783264,2.3832149,15.4070587),(38468,'radius.tif',235,3,281,11.610894,22.346794,14.074539,1.8,22.540793,14.1939788,0.2346975,4.3230561,4.6340133,23.7262727,55.4468229,0.1046508,11.9651843,5.4883102,16.2450009,5.6985691,9.5454705,2.6516353,38.021932),(38469,'radius.tif',235,3,282,3.1704919,24.9752107,14.2659405,1.8,24.9928464,14.3649483,1.3255842,1.2140295,3.1470559,1.0375183,7.0557723,0.497274,2.2420232,0.8546071,2.4520725,2.2534762,5.1767582,1.7894653,15.9878245),(38470,'radius.tif',235,3,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38471,'ulna.tif',235,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38472,'ulna.tif',235,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38473,'ulna.tif',235,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38474,'ulna.tif',235,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38475,'ulna.tif',235,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38476,'ulna.tif',235,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38477,'ulna.tif',235,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38478,'ulna.tif',235,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38479,'ulna.tif',235,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38480,'ulna.tif',235,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38481,'ulna.tif',235,4,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38482,'ulna.tif',235,4,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38483,'ulna.tif',235,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38484,'ulna.tif',235,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38485,'ulna.tif',235,4,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38486,'ulna.tif',235,4,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38487,'ulna.tif',235,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38488,'ulna.tif',235,4,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38489,'ulna.tif',235,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38490,'ulna.tif',235,4,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38491,'ulna.tif',235,4,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38492,'ulna.tif',235,4,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38493,'ulna.tif',235,4,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38494,'ulna.tif',235,4,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38495,'ulna.tif',235,4,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38496,'ulna.tif',235,4,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38497,'ulna.tif',235,4,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38498,'ulna.tif',235,4,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38499,'ulna.tif',235,4,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38500,'ulna.tif',235,4,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38501,'ulna.tif',235,4,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38502,'ulna.tif',235,4,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38503,'ulna.tif',235,4,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38504,'ulna.tif',235,4,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38505,'ulna.tif',235,4,35,1.8089447,21.2550372,20.062975,1.8,21.2306865,20.1399677,1.341457,1.1902892,2.2179248,0.3744688,1.2163125,0.2859095,0.5484012,0.3146032,0.6962276,2.2067381,3.7211706,1.6614562,12.9364663),(38506,'ulna.tif',235,4,36,9.8341542,20.9656223,20.787904,1.8,20.9049917,20.8880037,-1.436569,2.2173222,3.3095437,7.7346748,17.7768071,1.6096724,5.371377,3.4882954,7.3117982,4.0876942,6.378383,1.1150226,18.6491561),(38507,'ulna.tif',235,4,37,18.9033155,20.596015,21.1488402,1.8,20.6100109,21.114091,-1.3072724,2.8914619,3.7471639,28.9381953,60.0831767,2.9367808,16.0343071,10.0081539,23.3923317,5.6130585,7.6372021,1.2257941,23.35913),(38508,'ulna.tif',235,4,38,23.0401051,20.5431377,21.6113774,1.8,20.5379228,21.4605094,-1.3134544,3.2861863,4.1884721,51.3486276,85.0241315,3.5912772,20.299558,15.6255986,32.2418547,6.3649957,7.9922331,1.2712643,25.1944596),(38509,'ulna.tif',235,4,39,23.8361428,20.5341727,21.9076122,1.8,20.5062992,21.7156039,-1.2950187,3.5915879,4.3172391,66.3353523,91.3660689,3.6781365,21.1630784,18.4696446,36.4042871,6.9881538,8.191719,0.9903981,26.6895844),(38510,'ulna.tif',235,4,40,24.0060879,20.3837243,21.9347446,1.8,20.3636079,21.7261332,-1.4091701,3.6468167,4.7154388,70.8230064,104.1469691,3.8974029,22.0863792,19.4205005,37.0999974,7.1567908,8.7521713,0.9863524,27.0955728),(38511,'ulna.tif',235,4,41,23.5164156,20.2118932,21.934977,1.8,20.2045062,21.7404571,-1.4328308,3.7726623,4.9584782,70.0242631,112.9195045,3.845271,22.7730164,18.5609679,36.8117341,7.2994775,9.0434347,1.0793781,29.0671447),(38512,'ulna.tif',235,4,42,22.70151,20.0182882,21.8448795,1.8,20.0253802,21.7195329,-1.4233032,3.6417144,4.8347541,65.9698632,116.832737,3.7018711,24.165187,18.1150568,37.8083154,7.0748782,9.0350637,1.006927,29.1488901),(38513,'ulna.tif',235,4,43,20.0056927,19.7984798,21.5676809,1.8,19.8732878,21.6863678,-1.289303,3.8287979,4.4703116,57.8857136,100.5477971,3.0769836,22.4923466,15.1185086,35.4362816,6.8502788,8.944581,1.0734536,28.1687475),(38514,'ulna.tif',235,4,44,19.5773192,19.6691864,21.4665268,1.8,19.7505322,21.563687,-1.234517,3.6559836,4.3407741,53.6339455,94.5324298,2.9076074,21.7777816,14.6701822,33.86129,6.6823977,8.6645569,0.7395587,27.2045667),(38515,'ulna.tif',235,4,45,20.9874229,19.6094954,21.7398477,1.8,19.6499634,21.735257,-1.3429432,3.2438228,4.5941661,54.2584467,115.6473903,3.319424,25.1726622,16.7266987,36.9677959,6.4638238,8.8745152,0.9019842,26.991254),(38516,'ulna.tif',235,4,46,20.7351908,19.5364454,21.8182431,1.8,19.5456926,21.8473526,-1.3541046,3.1617278,4.6232945,51.7185974,122.9238206,3.2961179,26.5879277,16.3577009,37.3397778,6.3411746,9.0343658,0.962107,27.5607332),(38517,'ulna.tif',235,4,47,20.9164312,19.4658387,21.9127131,1.8,19.4726343,21.9146546,-1.3788114,3.1787951,4.7193099,50.7367643,130.2509879,3.3591524,27.5995837,15.9610049,37.3434027,6.2637806,9.2092563,0.9151007,28.1302124),(38518,'ulna.tif',235,4,48,20.5248859,19.3367471,22.0126899,1.8,19.3529616,21.984703,-1.3879842,3.0278256,4.8810467,48.8447668,135.718036,3.3077577,27.8051088,16.131962,36.3349453,6.071847,9.331689,0.8791397,28.3820601),(38519,'ulna.tif',235,4,49,20.8286655,19.2732244,22.0378013,1.8,19.2913331,21.9834307,-1.3950541,3.0052848,4.9135992,48.3775699,148.0472834,3.3653268,30.1301098,16.0974995,37.1169576,5.9194496,9.6132701,0.9179497,28.3933468),(38520,'ulna.tif',235,4,50,21.8879311,19.1799838,22.036027,1.8,19.2086953,21.9408923,-1.3962819,3.1873502,4.9989722,49.4293075,161.3924223,3.5380113,32.2851208,15.5079625,37.1631875,6.0322551,10.0506621,0.8803499,29.729656),(38521,'ulna.tif',235,4,51,21.4201124,19.0569608,22.0681511,1.8,19.0974395,21.9561156,-1.4009621,3.619192,5.3026679,49.4105947,172.4580225,3.4680325,32.5228782,13.6523829,35.4006606,5.8403048,9.9110409,1.2239614,28.0870021),(38522,'ulna.tif',235,4,52,22.4006353,18.9572162,22.0945826,1.8,19.0211312,21.9128473,-1.4077715,3.8581561,5.4386794,52.030599,187.4193443,3.6350911,34.460451,13.485872,37.2505479,5.8729945,10.165445,1.2909792,29.3030307),(38523,'ulna.tif',235,4,53,24.1066146,18.81432,21.9775623,1.8,18.9262839,21.6995273,-1.4115274,4.426804,5.5826256,60.8026653,213.0036394,3.9167109,38.154742,13.7351159,39.4709822,6.0539637,10.5406252,1.3232337,30.1243576),(38524,'ulna.tif',235,4,54,24.9139724,18.7117401,21.8353349,1.8,18.8309377,21.4498746,-1.404222,4.9181532,5.8162364,70.5383778,236.8797806,4.0381758,40.7273306,14.3424523,41.0801735,6.5604934,10.9484963,1.39553,32.3750258),(38525,'ulna.tif',235,4,55,27.5698339,18.5165829,21.6734489,1.8,18.5225708,21.1761909,-1.4379433,5.606515,5.8284281,93.8556833,267.815779,4.5143474,45.9499152,16.7404678,45.2649259,7.4253827,11.1222021,1.3674602,36.7514065),(38526,'ulna.tif',235,4,56,28.9039565,18.2756741,21.5296226,1.8,18.2373553,21.0253127,-1.4866383,5.2506597,5.8420821,117.5175344,292.9288744,4.7832875,50.1411773,22.38148,57.614108,7.9000273,11.4507106,1.4330601,34.09475),(38527,'ulna.tif',235,4,57,32.1901626,17.9448319,21.3901009,1.8,17.8005852,20.9490247,1.5609684,6.8031371,5.7962958,161.7353934,319.4125735,5.3645089,55.1063273,23.773649,66.4519986,9.3611326,11.6877992,1.5323537,38.552876),(38528,'ulna.tif',235,4,58,33.4624498,17.7649274,21.2910916,1.8,17.4882067,20.8824018,1.4443395,6.7481486,6.0056661,179.7144622,351.3903072,5.4883645,58.509797,26.6316693,68.9819597,9.2201222,11.610937,1.6579536,35.9845765),(38529,'ulna.tif',235,4,59,33.202575,17.8115549,21.4295811,1.8,17.5687991,21.0612345,1.4691866,5.2295827,5.9132238,153.795296,350.5884634,5.4768253,59.2888882,29.4087126,84.9063121,9.070859,11.5755833,1.6096118,35.8417226),(38530,'ulna.tif',235,4,60,32.1199532,17.8709256,21.7413707,1.8,17.6323759,21.3891181,1.4990471,6.3306068,5.716542,132.116761,330.2765019,5.3258141,57.7755753,20.8695256,71.2617414,8.771427,11.4837035,1.7279066,34.9705738),(38531,'ulna.tif',235,4,61,30.0815471,17.8512468,22.1876183,1.8,17.6267327,21.8254459,1.5291,5.0186,5.5809719,114.7174377,281.6085693,5.0048797,50.458697,22.858454,70.9624507,8.7550521,11.0225413,1.7242202,33.6070162),(38532,'ulna.tif',235,4,62,28.1074317,17.8780627,22.6674162,1.8,17.6932747,22.2698827,-1.5629835,4.8606723,5.2597568,98.6681867,231.2117523,4.684286,43.9586391,20.2992879,62.3205719,8.4669138,10.32302,1.8236904,31.941789),(38533,'ulna.tif',235,4,63,26.8103011,17.944337,23.0935621,1.8,17.7671953,22.6738567,-1.4722106,4.7202811,4.9912986,90.2956852,194.5170165,4.4250951,38.9712238,19.1293027,56.3393755,8.1689641,9.7674879,1.7208233,30.8845761),(38534,'ulna.tif',235,4,64,26.0402746,17.9507946,23.3086218,1.8,17.7955156,22.876663,-1.4324789,4.466011,4.751383,88.3459195,178.8680613,4.2575415,37.6454729,19.781841,53.6856981,7.922794,9.3539612,1.6549346,30.1948164),(38535,'ulna.tif',235,4,65,26.7717885,17.9485863,23.3576555,1.8,17.8180957,22.9949707,-1.3860438,4.3468005,4.5215847,90.8876997,178.7555787,4.3113873,39.5338343,20.9091032,50.7493653,7.8091819,9.5619709,0.7022569,30.3104218),(38536,'ulna.tif',235,4,66,27.5091977,17.9551759,23.3740371,1.8,17.8466187,23.0239154,-1.3429788,4.5192084,4.425877,93.8503853,184.5006776,4.3509962,41.6868062,20.7669966,50.5364544,7.7457144,9.8925733,0.6889244,31.7284764),(38537,'ulna.tif',235,4,67,26.790831,17.9997742,23.4723593,1.8,17.8885288,23.1349465,-1.2796281,4.6023264,4.4498658,95.4118945,190.5684774,4.0971664,42.8256688,20.7312316,49.2248574,7.9635101,10.2087735,0.6919214,32.0846429),(38538,'ulna.tif',235,4,68,27.8806189,18.0030906,23.4285095,1.8,17.8912504,23.0951386,-1.2381148,4.7380438,4.5286706,102.684066,207.8713659,4.1511749,45.9011896,21.6722492,51.5265665,8.0748945,10.4896533,0.6563484,32.5996251),(38539,'ulna.tif',235,4,69,29.9140631,18.0070953,23.2946302,1.8,17.8958261,22.9681028,-1.1849466,4.9087964,4.7686214,118.0523346,236.0577145,4.2795224,49.5022976,24.0491408,56.0716083,8.3090873,10.9156187,0.6393859,33.7226216),(38540,'ulna.tif',235,4,70,32.7241749,17.9807524,23.1124198,1.8,17.8543514,22.7978585,-1.1383641,4.9675062,5.1676865,138.9650267,271.7230981,4.4961468,52.5811889,27.9748067,61.2079535,8.4442121,11.4886442,0.6884805,35.5466646),(38541,'ulna.tif',235,4,71,35.6511337,18.0182185,22.8981017,1.8,17.8640334,22.5838943,-1.1249619,5.0448858,5.367445,156.8922389,318.0566249,4.83701,59.2566154,31.0992645,69.0001321,8.5929046,12.011864,0.2359086,37.2823505),(38542,'ulna.tif',235,4,72,37.0849806,18.0677825,22.674602,1.8,17.8989393,22.2771236,-1.108111,5.2598924,5.6282239,181.3538677,376.3201422,4.9494188,66.8630368,34.4786272,79.2399177,8.8142709,12.5584959,0.2254584,39.0180364),(38543,'ulna.tif',235,4,73,40.579596,18.0631042,22.3920376,1.8,17.9137362,21.9462723,-1.1196783,5.5562295,5.9755758,204.7856509,457.1194182,5.4777613,76.4979705,36.8569459,92.997234,9.1734514,12.8041305,0.266252,40.4201292),(38544,'ulna.tif',235,4,74,41.9215943,18.1005267,22.2610663,1.8,18.0601822,21.7332225,-1.1122076,5.2645345,6.116965,202.4094022,523.9043106,5.617715,85.6477533,38.4477303,102.5134963,8.9234811,12.8728912,0.748378,40.7922575),(38545,'ulna.tif',235,4,75,41.578104,18.1790103,22.2354474,1.8,18.2099526,21.6398945,-1.099868,5.2428729,6.5074982,180.1347809,565.2677214,5.5031658,86.8640612,34.3580293,98.3893949,8.7510208,13.2727549,0.8272898,42.8408997),(38546,'ulna.tif',235,4,76,42.0781527,18.2290476,22.2261932,1.8,18.3053433,21.6442371,-1.094064,5.1202113,7.0253121,162.7481229,599.6138412,5.5362978,85.3504914,31.7854307,100.2598138,8.5175168,13.6438302,0.9668133,39.5057702),(38547,'ulna.tif',235,4,77,41.2678961,18.1779452,22.3706301,1.8,18.2264708,21.8226146,-1.1072542,5.1703174,7.2087508,143.8374585,578.2227528,5.5029668,80.211228,27.8198509,95.1781594,8.4390756,13.6179247,1.0148194,42.0966431),(38548,'ulna.tif',235,4,78,38.0389324,17.9146794,22.8591103,1.8,17.9188444,22.3551107,-1.1723909,4.9377337,7.2085071,120.2693514,442.0330439,5.3856502,61.3210248,24.3571968,75.1285412,7.97226,13.1356996,1.0421065,40.6560152),(38549,'ulna.tif',235,4,79,35.3721845,17.596312,23.3600303,1.8,17.5315768,23.0340816,-1.2490542,4.1225281,6.7954618,108.8920925,329.7164705,5.3058574,48.5200978,26.4139112,61.0085324,7.1052715,10.9990617,1.1162809,31.3450614),(38550,'ulna.tif',235,4,80,34.9256962,17.4604965,23.5628447,1.8,17.3973774,23.289866,-1.27828,5.1127055,6.1371184,101.9808824,292.6783563,5.3369202,47.6898661,19.946559,60.7235927,6.8697717,11.3105321,1.4513674,31.5969091),(38551,'ulna.tif',235,4,81,34.3711808,17.339255,23.7569176,1.8,17.2761748,23.5449903,-1.2956423,5.1180276,5.7916478,98.0582395,262.7515559,5.30566,45.3673225,19.1593807,58.7851469,6.790357,10.637688,1.3796119,31.0819269),(38552,'ulna.tif',235,4,82,34.263595,17.2309374,23.8898808,1.8,17.1772867,23.7020508,-1.3166464,3.6917926,6.0454425,95.7776612,247.1043635,5.3496128,40.8744872,25.9434025,54.7819947,6.6077502,11.1454223,1.5002067,33.0488237),(38553,'ulna.tif',235,4,83,34.4794632,17.1564022,23.9656922,1.8,17.1117049,23.7708934,-1.3333869,3.5844916,5.6207033,92.2610813,238.7988511,5.4287212,42.4855819,25.738959,56.1053535,6.4959445,9.9053132,1.5027199,29.2964191),(38554,'ulna.tif',235,4,84,34.4180513,17.1007791,24.0507202,1.8,17.0688549,23.8234186,-1.3435896,3.4687999,5.7341073,87.7964175,231.4440454,5.4452761,40.3626988,25.3103149,53.3684992,6.3286103,10.7953792,1.6228326,32.0573944),(38555,'ulna.tif',235,4,85,33.9680967,17.0512409,24.1716325,1.8,17.0159157,23.9954072,-1.3307626,3.3678775,4.9370903,82.7355321,216.5593748,5.3413808,43.8637666,24.5660753,59.8829704,6.2084196,9.7228415,1.4550371,28.3820601),(38556,'ulna.tif',235,4,86,33.2955849,17.029214,24.291597,1.8,16.9999626,24.1724649,-1.3125204,3.29068,4.7537329,76.893776,202.0024757,5.1872506,42.4934423,23.3671384,57.3135174,6.075395,9.4997807,1.4523064,27.6265168),(38557,'ulna.tif',235,4,87,32.7972698,16.9938382,24.4223082,1.8,16.9746728,24.3259529,-1.2798882,3.2346123,4.6768512,72.2251809,192.0155555,5.0165225,41.0565886,22.3288526,56.0129935,5.9938917,9.2509289,1.3876855,26.7281196),(38558,'ulna.tif',235,4,88,32.2741829,16.956477,24.5411991,1.8,16.9382062,24.4736403,-1.2487269,3.1431194,4.709181,68.1037116,179.1910594,4.8400979,38.0514277,21.6675546,52.5044044,5.9369202,9.1267221,1.2451547,25.9612896),(38559,'ulna.tif',235,4,89,31.8238135,16.9120324,24.6565966,1.8,16.8876757,24.6256602,-1.2185383,3.1630725,4.5945808,64.3376528,167.8963227,4.6725979,36.5422506,20.3402394,50.4558167,5.8485293,8.9064316,1.1692158,25.4190589),(38560,'ulna.tif',235,4,90,31.2989269,16.8791153,24.7341494,1.8,16.8647193,24.6940137,-1.2008032,3.0954965,4.6188264,61.0567651,159.6849978,4.5343741,34.5726348,19.7243853,47.6627621,5.8004311,8.8631394,1.1808785,25.1944596),(38561,'ulna.tif',235,4,91,30.9904978,16.8453668,24.7993339,1.8,16.831472,24.7566474,-1.1876213,3.0154624,4.5716405,58.1795257,153.2813325,4.443125,33.5287373,19.2937329,45.8891924,5.7919791,8.7478475,1.0612041,25.0628924),(38562,'ulna.tif',235,4,92,30.5982788,16.815455,24.8504339,1.8,16.8027598,24.8098585,-1.1781499,2.9834586,4.6104139,55.4488533,147.2747742,4.3530674,31.9439379,18.5854274,43.9339654,5.677375,8.7802243,1.2045408,24.307349),(38563,'ulna.tif',235,4,93,30.3023514,16.7815963,24.8857992,1.8,16.7727787,24.8357957,-1.1655854,2.946713,4.5993361,53.4625583,142.2522048,4.2655431,30.9288565,18.1431167,42.4652365,5.6480453,8.6907163,1.130266,24.3345975),(38564,'ulna.tif',235,4,94,29.9899152,16.7543474,24.91958,1.8,16.7449603,24.8757204,-1.1574016,2.9148752,4.5658701,51.4151859,138.2760158,4.191694,30.2847024,17.6388977,41.5106012,5.5837395,8.6353979,1.2120257,23.923934),(38565,'ulna.tif',235,4,95,29.7493772,16.7254795,24.9383158,1.8,16.7193552,24.8831374,-1.1484148,2.8796594,4.5929267,49.7605392,134.8661752,4.1250201,29.3638858,17.2800084,40.1562814,5.5574504,8.6652846,1.2408492,23.8581504),(38566,'ulna.tif',235,4,96,29.540389,16.6911254,24.9530917,1.8,16.6878888,24.895635,-1.1417822,2.8690808,4.610468,48.3956703,132.3669827,4.0714793,28.7100965,16.8680053,39.2058087,5.529404,8.6353979,1.2120257,23.4747354),(38567,'ulna.tif',235,4,97,29.1038829,16.6576288,24.9596118,1.8,16.6514385,24.896739,-1.1364432,2.8365011,4.5833473,46.9346626,128.9495792,3.9916337,28.1343677,16.5466753,38.371025,5.4730557,8.6127318,1.1830262,23.8196153),(38568,'ulna.tif',235,4,98,28.6089424,16.6271365,24.9583111,1.8,16.625688,24.8945802,-1.1338495,2.8534695,4.5473716,45.6167032,126.0135032,3.914289,27.7112832,15.9863993,37.7226839,5.4307592,8.5303396,1.2074032,23.5132706),(38569,'ulna.tif',235,4,99,28.1196109,16.5904568,24.9524149,1.8,16.5826065,24.8869539,-1.1326756,2.8644461,4.5510068,44.7492637,123.0523123,3.8431153,27.0384812,15.6223094,36.855538,5.4216117,8.4910718,1.2197654,23.5677675),(38570,'ulna.tif',235,4,100,27.7822443,16.5547923,24.9334908,1.8,16.5483124,24.8743062,-1.1348252,2.8730425,4.5486169,43.9316185,120.5231528,3.8046413,26.4966592,15.290974,36.1255905,5.3941511,8.494784,1.1485452,23.4362003),(38571,'ulna.tif',235,4,101,27.4914081,16.5110834,24.9195109,1.8,16.5051498,24.8666495,-1.1336133,2.867708,4.5137748,43.3499341,118.138845,3.7605573,26.1729598,15.116579,35.7621645,5.3966783,8.4910718,1.2197654,23.2773846),(38572,'ulna.tif',235,4,102,27.2047918,16.4651209,24.9021665,1.8,16.4526752,24.8593999,-1.1326207,2.8376789,4.4633964,42.8585237,114.9854213,3.7178955,25.761866,15.1033732,35.3604152,5.3966783,8.3623664,1.1853025,23.157104),(38573,'ulna.tif',235,4,103,26.989638,16.4131848,24.878785,1.8,16.3970412,24.836494,-1.1332147,2.8699446,4.4100553,42.6566423,112.211484,3.6905442,25.4444621,14.8632284,35.0498372,5.367613,8.338202,1.125219,23.0255368),(38574,'ulna.tif',235,4,104,26.7463502,16.3669513,24.8485758,1.8,16.3519194,24.8025266,-1.135033,2.8706458,4.3612795,42.2553988,109.2838965,3.6634897,25.0577604,14.7198235,34.7462617,5.3529847,8.243896,1.1498058,23.0527853),(38575,'ulna.tif',235,4,105,26.629537,16.3206708,24.8129856,1.8,16.306452,24.7673566,-1.1393449,2.8863196,4.3483371,42.1805521,107.3798492,3.6620825,24.6944626,14.6139577,34.3714511,5.3541237,8.2377747,1.0888581,22.8394727),(38576,'ulna.tif',235,4,106,26.4455482,16.2768132,24.7714701,1.8,16.2632922,24.7322836,-1.1423442,2.9015122,4.2264505,41.8696894,105.8785813,3.646798,25.0514187,14.4302995,34.65851,5.3537638,8.0957068,1.1567973,22.8394727),(38577,'ulna.tif',235,4,107,26.2688363,16.2303038,24.7286363,1.8,16.2147382,24.6912369,-1.1461304,2.889207,4.1961023,41.6719649,104.230968,3.6349175,24.8399489,14.4233225,34.3010921,5.3389369,8.0871346,1.1257801,22.773689),(38578,'ulna.tif',235,4,108,26.1903412,16.1832947,24.6791198,1.8,16.1656512,24.6420708,-1.1501605,2.8515055,4.1788356,41.5348934,102.7708363,3.6372171,24.5931752,14.5659524,34.2885689,5.3220307,8.0394317,1.0759089,22.680657),(38579,'ulna.tif',235,4,109,26.119903,16.1397965,24.62175,1.8,16.1273432,24.5809719,-1.1516362,2.9017318,4.1324741,41.4960517,101.4603015,3.6322177,24.5519509,14.3004436,34.1708562,5.3228098,8.0394317,1.0759089,22.6148734),(38580,'ulna.tif',235,4,110,25.9992959,16.0943864,24.5663837,1.8,16.0726257,24.5318974,-1.1544871,2.8714222,4.0647949,41.2988921,99.6888768,3.6246077,24.5249465,14.3827305,34.0976287,5.2959852,7.897788,1.0498865,22.5218413),(38581,'ulna.tif',235,4,111,25.9045467,16.0478183,24.5080133,1.8,16.0278926,24.4685968,-1.1573732,2.9072972,4.0289542,41.2626631,98.211828,3.6205913,24.3765064,14.1927917,34.2071295,5.2918558,7.897788,1.0498865,22.2699935),(38582,'ulna.tif',235,4,112,25.780236,15.9995175,24.4531159,1.8,15.9761286,24.422842,-1.1612607,2.8226806,4.0407577,41.1688392,96.7936559,3.6154633,23.9543329,14.5850151,33.7265901,5.2907252,7.897788,1.0498865,22.2699935),(38583,'ulna.tif',235,4,113,25.6475544,15.9496478,24.3868928,1.8,15.9293784,24.3517068,-1.1691577,2.8417563,3.9346838,41.2367135,94.9978281,3.6213322,24.1437004,14.5109957,33.7751879,5.2907252,7.7884485,1.0749018,22.1769614),(38584,'ulna.tif',235,4,114,25.4675993,15.9017987,24.3321548,1.8,15.8797978,24.3045737,-1.1691916,2.8485499,3.9341141,40.8651518,93.0611531,3.5960268,23.6549195,14.345949,33.6122242,5.2527982,7.7421632,1.152572,22.0839293),(38585,'ulna.tif',235,4,115,25.4383509,15.8535149,24.2588694,1.8,15.8302404,24.225471,-1.1729839,2.8348376,3.8234895,40.7222936,91.5735604,3.6034241,23.9502584,14.3649476,33.7430838,5.2527982,7.6471034,1.0480072,21.8320816),(38586,'ulna.tif',235,4,116,25.3530921,15.8076787,24.1939467,1.8,15.7918377,24.1586288,-1.1784664,2.8103956,3.7772016,40.5679582,90.1011723,3.6078057,23.8539484,14.4349637,33.5336741,5.235563,7.6363764,1.080839,22.1384263),(38587,'ulna.tif',235,4,117,25.20428,15.7589201,24.1239023,1.8,15.734715,24.0934701,-1.18294,2.8232095,3.7463098,40.6918387,88.2480074,3.599848,23.5559825,14.4133259,33.4827968,5.235563,7.5374738,1.0738277,21.8320816),(38588,'ulna.tif',235,4,118,25.0598582,15.7134465,24.053798,1.8,15.6921211,24.0241577,-1.1899463,2.815622,3.7094852,40.6852088,87.0383779,3.5995642,23.4637352,14.449812,33.6485079,5.219029,7.5916559,1.0608243,21.7935464),(38589,'ulna.tif',235,4,119,24.9227154,15.6634468,23.9877448,1.8,15.6394884,23.9585588,-1.1946394,2.8046831,3.6280035,40.814999,85.4636046,3.5932528,23.556649,14.5524461,33.6188858,5.2306182,7.4160297,1.012197,21.766298),(38590,'ulna.tif',235,4,120,24.8464965,15.6162621,23.9150263,1.8,15.5880345,23.8878265,-1.2012224,2.8761169,3.6181829,40.8731876,84.2434588,3.6007604,23.2833611,14.21124,32.865961,5.3248531,7.5072969,0.9661977,21.7390495),(38591,'ulna.tif',235,4,121,24.7470329,15.5681928,23.842923,1.8,15.5410075,23.8184152,-1.2072188,2.8819703,3.5801666,41.2689546,82.7440501,3.602897,23.1117875,14.3197013,33.1847002,5.3429557,7.4160297,1.012197,21.913827),(38592,'ulna.tif',235,4,122,24.7491041,15.5188407,23.766775,1.8,15.4906252,23.7371447,-1.2172251,2.9070728,3.5951001,41.3672395,81.5720923,3.6303254,22.6897969,14.2298602,33.1548478,5.3846819,7.3511253,0.9700825,21.9796106),(38593,'ulna.tif',235,4,123,24.6149127,15.4737027,23.6964512,1.8,15.4438402,23.6656822,-1.2217366,2.9143276,3.5693749,41.651079,80.189582,3.622602,22.4660015,14.2918315,33.1584022,5.4204401,7.2613689,0.8839787,21.7935464),(38594,'ulna.tif',235,4,124,24.4330944,15.4303977,23.6227538,1.8,15.397626,23.5885548,-1.2292021,2.9176283,3.5587651,41.6377693,79.0093785,3.6152101,22.201347,14.2711015,33.6504414,5.42998,7.1669706,0.9523683,21.5416987),(38595,'ulna.tif',235,4,125,24.2498955,15.3871721,23.5488962,1.8,15.3517861,23.5162413,-1.2302579,2.8886341,3.5833848,41.5123649,77.6633415,3.5907936,21.6731794,14.3709324,32.8554937,5.3998052,7.1748845,0.874054,21.8207949),(38596,'ulna.tif',235,4,126,24.1597073,15.3488447,23.4738244,1.8,15.316705,23.4364029,-1.2383483,2.8923333,3.5361851,41.5807998,76.4938582,3.5977447,21.6317462,14.376213,32.7740999,5.42998,7.1210732,0.90837,21.5416987),(38597,'ulna.tif',235,4,127,24.0563496,15.3110614,23.3971525,1.8,15.2792563,23.3629878,-1.2446728,2.9303186,3.5251348,41.6767528,75.2629034,3.5978715,21.350362,14.2226012,33.0129423,5.465185,7.1068913,1.0222469,21.6619792),(38598,'ulna.tif',235,4,128,23.8542179,15.2710957,23.3211053,1.8,15.2375459,23.2837203,-1.2528323,2.8601693,3.5144782,41.6357309,73.7721421,3.5871194,20.9909233,14.5570862,32.8110634,5.4345428,7.0113126,1.0138948,21.4101314),(38599,'ulna.tif',235,4,129,23.7636195,15.2360307,23.2442703,1.8,15.2041915,23.210737,-1.2549623,2.9038207,3.5065481,41.5814477,72.9480729,3.5784916,20.8033857,14.3195646,32.3939125,5.4960185,7.0167066,0.8760581,21.382883),(38600,'ulna.tif',235,4,130,23.5432395,15.1923355,23.1724032,1.8,15.1564257,23.1376515,-1.2613072,2.8742063,3.4896299,41.2962972,71.2144161,3.5598786,20.4074412,14.3678961,32.2408471,5.5045997,6.9162365,1.0053124,21.2240673),(38601,'ulna.tif',235,4,131,23.5259895,15.1675431,23.0897117,1.8,15.1375647,23.055239,-1.2626194,2.8537269,3.4587415,41.2483018,70.563958,3.5602499,20.4016279,14.4541869,32.1275442,5.491888,6.9162365,1.0053124,21.2785642),(38602,'ulna.tif',235,4,132,23.3520186,15.1341546,23.0163351,1.8,15.1024291,22.9851044,-1.2640087,2.871256,3.4746011,40.9988631,69.3344437,3.5370421,19.9546483,14.2790693,31.7174053,5.5050028,6.8833367,0.9827937,21.1582837),(38603,'ulna.tif',235,4,133,23.2487818,15.1066928,22.9347708,1.8,15.0708676,22.8988047,-1.2686446,2.8830749,3.4766496,40.7516818,68.7702163,3.53168,19.7806005,14.1347984,31.4935268,5.442246,6.8281514,0.9371633,20.999468),(38604,'ulna.tif',235,4,134,23.0263991,15.0780573,22.857705,1.8,15.0442498,22.8234607,-1.2702182,2.8643766,3.4346408,40.4719242,67.4807386,3.5013217,19.647102,14.1294006,31.4190973,5.4919424,6.7379792,0.9272952,20.9609328),(38605,'ulna.tif',235,4,135,22.8702426,15.0530812,22.7752513,1.8,15.0249302,22.7396853,-1.2748945,2.8017398,3.4646988,40.2567741,66.8319269,3.4875898,19.2893899,14.3684915,30.8890725,5.4747756,6.7725164,0.8675657,21.2785642),(38606,'ulna.tif',235,4,136,22.7230945,15.0267374,22.6996211,1.8,14.9931639,22.6706072,-1.2802608,2.7690652,3.42131,40.1000363,65.5861953,3.4763972,19.1699073,14.4814342,30.8693784,5.5050028,6.7023233,1.0246298,20.9881813),(38607,'ulna.tif',235,4,137,22.646416,15.0023911,22.6139715,1.8,14.9671682,22.5818406,-1.2926713,2.7439275,3.4334822,40.0636958,65.2386551,3.4898901,19.0007262,14.6008579,30.6578591,5.4488865,6.6797057,1.0996301,20.9881813),(38608,'ulna.tif',235,4,138,22.4661413,14.9788913,22.5302726,1.8,14.9502667,22.4969453,-1.3033241,2.701111,3.4109044,39.834807,64.0679003,3.4828078,18.7832587,14.7475638,30.2639866,5.4266322,6.6797057,1.0996301,20.9223977),(38609,'ulna.tif',235,4,139,22.3843323,14.9576638,22.4505686,1.8,14.9255401,22.4171394,-1.30892,2.6532388,3.4220081,39.7400025,63.51737,3.4806674,18.5614321,14.9779217,30.1448736,5.4184031,6.6113887,1.2060615,20.5775178),(38610,'ulna.tif',235,4,140,22.2589684,14.9371723,22.3692227,1.8,14.903556,22.3409183,-1.3186731,2.684055,3.3852784,39.7519184,62.7575423,3.4789632,18.5383696,14.8103964,30.2414952,5.4088255,6.5913296,1.724741,20.9223977),(38611,'ulna.tif',235,4,141,22.1321148,14.9173912,22.2854722,1.8,14.8893794,22.2509882,-1.3370928,2.7427404,3.3231572,39.5045166,62.0262766,3.4908608,18.6648637,14.4033013,29.7009381,5.4648187,6.6513256,1.7748143,20.8180789),(38612,'ulna.tif',235,4,142,21.9607043,14.9021199,22.2021636,1.8,14.8753934,22.1670282,-1.3354577,2.7182716,3.3222342,39.3151568,61.2874719,3.4611193,18.4476677,14.4632924,29.3881595,5.4095806,6.6494293,1.6553401,20.5775178),(38613,'ulna.tif',235,4,143,21.8856021,14.8867646,22.121938,1.8,14.8644614,22.0820688,-1.3493716,2.7268475,3.30454,39.1516459,60.6766798,3.4716661,18.3616118,14.3578422,28.9744931,5.4063446,6.6598523,1.6721428,20.6320147),(38614,'ulna.tif',235,4,144,21.8439023,14.8677982,22.0434621,1.8,14.8412125,22.0027663,-1.3585809,2.7416712,3.3265274,39.1576762,59.9351302,3.4791388,18.0173263,14.2824115,28.9313531,5.4095806,6.6294852,1.7582254,20.5389827),(38615,'ulna.tif',235,4,145,21.7996142,14.8515211,21.9674912,1.8,14.823331,21.9229909,-1.3673029,2.8181996,3.2863752,39.0558392,59.2290078,3.4848822,18.0225945,13.8584359,28.5744823,5.465185,6.6294852,1.7582254,20.911111),(38616,'ulna.tif',235,4,146,21.7079242,14.8420747,21.897179,1.8,14.8148336,21.8539851,-1.3703176,2.7351266,3.2652343,38.7588153,58.2552947,3.474512,17.8410766,14.1707573,28.3072449,5.3887771,6.5750464,1.7078625,20.380167),(38617,'ulna.tif',235,4,147,21.5525762,14.8287141,21.8268773,1.8,14.7965842,21.7795035,-1.3773188,2.7638023,3.2410579,38.580888,57.1294527,3.4593006,17.6267916,13.9593514,27.6579836,5.4095806,6.5404305,1.849096,20.4459506),(38618,'ulna.tif',235,4,148,21.4893785,14.819635,21.7546202,1.8,14.7931539,21.7132514,-1.38207,2.7674031,3.1980852,38.5734524,56.2127571,3.4555037,17.577004,13.9385014,28.3148382,5.4148166,6.4256602,1.6582917,20.1010707),(38619,'ulna.tif',235,4,149,21.3590995,14.8070743,21.6856442,1.8,14.7820062,21.6489157,-1.3942476,2.7582766,3.1993322,38.4070214,55.5227543,3.4500394,17.3544824,13.9242819,27.8482376,5.3943516,6.4256602,1.6582917,20.911111),(38620,'ulna.tif',235,4,150,21.2439553,14.7944114,21.6082987,1.8,14.7615286,21.5750621,-1.4142448,2.8296711,3.1602536,38.231026,54.7943075,3.45459,17.3385792,13.5107667,27.4002336,5.4544643,6.4325257,1.8538921,20.1555677),(38621,'ulna.tif',235,4,151,21.1267288,14.7862994,21.5440419,1.8,14.7615303,21.5039439,-1.417372,2.8311656,3.1625249,38.0776585,53.8278763,3.438886,17.0205383,13.4494635,27.1079595,5.4476079,6.4089561,1.7647555,20.1283192),(38622,'ulna.tif',235,4,152,21.0919607,14.7779041,21.4700802,1.8,14.7527377,21.4302568,-1.4400212,2.8407046,3.1113762,37.9888208,53.2296746,3.4555491,17.1080806,13.3730277,26.9764106,5.4762115,6.4089561,1.7647555,20.1555677),(38623,'ulna.tif',235,4,153,21.0766103,14.7687944,21.4005043,1.8,14.7400227,21.3601566,-1.4551696,2.8358049,3.1316664,37.9117476,52.6651378,3.4660132,16.8169693,13.3689546,26.6431159,5.429133,6.4256602,1.6582917,20.2213513),(38624,'ulna.tif',235,4,154,21.0038604,14.7589365,21.3281798,1.8,14.7303583,21.2887974,-1.4785283,2.8503517,3.0840383,37.8044035,52.0169906,3.4709256,16.8665188,13.2630662,26.1713031,5.4832706,6.4020652,1.8370484,20.0625356),(38625,'ulna.tif',235,4,155,20.8664567,14.757381,21.2663943,1.8,14.726539,21.2284264,-1.4822653,2.8388602,3.1199488,37.6111496,50.9942191,3.4505563,16.3445694,13.2486799,26.1074189,5.4466502,6.3882613,1.7475052,20.1828161),(38626,'ulna.tif',235,4,156,20.7836963,14.7497711,21.1959648,1.8,14.7242528,21.1582383,-1.5007944,2.844804,3.0818314,37.4555059,50.3602938,3.4470028,16.3410281,13.1662872,26.4093305,5.4476079,6.2987994,1.7681919,19.7176557),(38627,'ulna.tif',235,4,157,20.687013,14.7452913,21.128843,1.8,14.7209864,21.0826084,-1.520943,2.7859747,3.1272943,37.1414066,49.8055677,3.4392735,15.9260893,13.3315662,25.9770573,5.4476079,6.3137977,1.6598459,19.55884),(38628,'ulna.tif',235,4,158,20.6558937,14.7373611,21.0612546,1.8,14.7184025,21.022306,-1.5475711,2.7896448,3.1884912,37.0228849,49.4797309,3.4407923,15.5182271,13.271541,25.5575867,5.4960185,6.3407053,1.971037,19.7721527),(38629,'ulna.tif',235,4,159,20.6225049,14.7272168,21.0043472,1.8,14.6996718,20.9656397,-1.5603332,2.7948562,3.143663,37.0014496,49.0774098,3.4367079,15.6115365,13.2391248,25.405401,5.4628381,6.3575888,1.8757887,19.9309684),(38630,'ulna.tif',235,4,160,20.5864358,14.7231504,20.938446,1.8,14.6982583,20.8939383,1.5652657,2.7995597,3.2013286,36.7782592,48.5874111,3.4309677,15.1772647,13.1371583,25.1766302,5.4375761,6.3575888,1.8757887,19.9309684),(38631,'ulna.tif',235,4,161,20.5026515,14.7126462,20.8782048,1.8,14.6888065,20.8321498,1.5479801,2.8102759,3.1622577,36.5345523,48.1645822,3.41533,15.2310743,13.0003434,25.1334497,5.4617132,6.2857718,1.8981965,19.7721527),(38632,'ulna.tif',235,4,162,20.3405525,14.7118467,20.8246674,1.8,14.6860261,20.7838254,1.5230481,2.81677,3.2275308,36.2377796,47.4872542,3.3823689,14.713184,12.8650118,24.8933079,5.49094,6.2646701,1.8244704,19.7994011),(38633,'ulna.tif',235,4,163,20.3611508,14.7047254,20.7658674,1.8,14.6783689,20.7200903,1.5015084,2.8377051,3.2123706,36.1439565,47.3675259,3.3772595,14.7453493,12.7370376,24.8026209,5.502683,6.3247739,1.8588518,19.7063691),(38634,'ulna.tif',235,4,164,20.1948716,14.699892,20.7116876,1.8,14.6684223,20.6732144,1.4794031,2.8525172,3.2810705,35.7188827,46.6160449,3.3377764,14.2075718,12.5218817,24.3528318,5.4694718,6.3247739,1.8588518,19.8651847),(38635,'ulna.tif',235,4,165,20.1320139,14.6920182,20.6559232,1.8,14.6637641,20.6132319,1.4546354,2.7938266,3.2179302,35.4868057,46.4551638,3.3102642,14.4363493,12.7018641,24.4571477,5.502683,6.2827616,2.0744226,19.4545213),(38636,'ulna.tif',235,4,166,19.9943615,14.6865326,20.5988242,1.8,14.6586785,20.5564091,1.4193841,2.8070483,3.2706957,35.0176287,45.8295683,3.2565783,14.0121774,12.4748937,24.1180473,5.4837198,6.2827616,2.0744226,19.3614892),(38637,'ulna.tif',235,4,167,19.8959987,14.6806717,20.5490479,1.8,14.6586523,20.5126693,1.3931979,2.8214613,3.19547,34.696604,45.347732,3.2125042,14.1912558,12.297388,24.5460132,5.3903834,6.1805632,2.0019351,19.2957056),(38638,'ulna.tif',235,4,168,19.7623449,14.6709728,20.4997468,1.8,14.6475302,20.4637445,1.3724871,2.8266665,3.2238586,34.3143876,44.9917135,3.1658824,13.9558582,12.1395248,24.3639206,5.3903834,6.1887197,1.7717506,19.4159861),(38639,'ulna.tif',235,4,169,19.6642053,14.6697318,20.4503497,1.8,14.6513985,20.4090721,1.3612987,2.7493987,3.2653973,33.9637915,44.7418491,3.1356185,13.7018086,12.3531707,24.0656814,5.3903834,6.1887197,1.7717506,19.4159861),(38640,'ulna.tif',235,4,170,19.5147107,14.6578758,20.4058275,1.8,14.6413861,20.3649355,1.3417355,2.7713473,3.2149064,33.7521113,44.0814335,3.0847632,13.7115761,12.1789538,23.8264005,5.3903834,6.193812,1.9614034,19.2844189),(38641,'ulna.tif',235,4,171,19.3651831,14.6476231,20.3561558,1.8,14.622374,20.319199,1.3263053,2.8199374,3.2545631,33.5367792,43.792653,3.0384158,13.4557699,11.8927388,23.5866836,5.4790542,6.193812,1.9614034,19.229922),(38642,'ulna.tif',235,4,172,19.286395,14.6415132,20.3110455,1.8,14.6251832,20.2724035,1.3125148,2.8127584,3.1571677,33.4407877,43.3844869,3.0046946,13.7415844,11.8889655,24.2101689,5.4652125,6.0870141,2.0922308,18.9780742),(38643,'ulna.tif',235,4,173,19.2354924,14.6340588,20.2597105,1.8,14.6131573,20.2215415,1.2715871,2.7540039,3.1831749,33.1636313,43.2397446,2.9273655,13.583842,12.0419697,23.9844927,5.4177347,6.1437251,2.108081,19.3502025),(38644,'ulna.tif',235,4,174,19.1031519,14.6296453,20.2179217,1.8,14.615152,20.181607,1.2493595,2.7421638,3.1739898,32.8843964,42.9594707,2.8660719,13.5348483,11.9921342,23.8046688,5.3913895,6.134481,1.9853032,19.0983548),(38645,'ulna.tif',235,4,175,18.9926404,14.6195637,20.1777772,1.8,14.6042269,20.1379066,1.2217009,2.7313614,3.1679792,32.6737897,42.7149398,2.7950937,13.4833395,11.9624557,23.5851345,5.3203257,6.1365364,2.1740262,18.8192585),(38646,'ulna.tif',235,4,176,18.890484,14.6100386,20.1390055,1.8,14.5847979,20.1016379,1.2141334,2.6974693,3.179415,32.5214094,42.5174547,2.7646063,13.3727288,12.0562669,23.4302018,5.3850073,6.134481,1.9853032,18.8192585),(38647,'ulna.tif',235,4,177,18.7335889,14.6046577,20.0995165,1.8,14.5884488,20.0669166,1.1732055,2.6962891,3.214076,32.160398,42.2169905,2.6541673,13.135032,11.927652,23.1255567,5.3203257,6.1846428,2.0831858,19.0325711),(38648,'ulna.tif',235,4,178,18.6082295,14.5902258,20.055437,1.8,14.5828661,20.0175258,1.1718452,2.7353704,3.2278671,31.8201531,42.4507481,2.63339,13.1513308,11.63285,23.0083115,5.3203257,6.1805632,2.0019351,19.0711063),(38649,'ulna.tif',235,4,179,18.3788638,14.5755706,20.020735,1.8,14.5634195,19.9875713,1.1441596,2.6644742,3.1788623,31.3175044,42.1059248,2.5386117,13.2455957,11.753728,23.0772083,5.16151,6.1365364,2.1740262,18.6876913),(38650,'ulna.tif',235,4,180,18.3713842,14.563586,19.9816556,1.8,14.5496003,19.9470064,1.1406318,2.6106823,3.1940322,31.4192397,42.5147357,2.529415,13.3106784,12.0348769,23.1470002,5.2409179,6.130368,2.0672191,18.5946592),(38651,'ulna.tif',235,4,181,18.1838973,14.550868,19.9457566,1.8,14.5398153,19.9095654,1.1229427,2.6483778,3.2078775,30.9415598,42.3243682,2.4623525,13.1938854,11.6832124,22.7839018,5.16151,6.1519304,1.9445231,18.5288756),(38652,'ulna.tif',235,4,182,18.1137921,14.537984,19.9104682,1.8,14.5318907,19.8773016,1.1079433,2.6315181,3.1668288,30.7933932,42.4826317,2.4170902,13.4148811,11.7017601,23.0562866,5.2409179,6.1846428,2.0831858,19.0053227),(38653,'ulna.tif',235,4,183,17.9967776,14.5199787,19.8761052,1.8,14.5034903,19.8374928,1.0933677,2.6217943,3.1753959,30.4588096,42.5504116,2.3661642,13.4000337,11.6175435,22.939912,5.16151,6.1775017,2.0425738,18.9667875),(38654,'ulna.tif',235,4,184,17.8611616,14.5061232,19.8467012,1.8,14.4994287,19.8077827,1.0731983,2.5596959,3.1379735,30.2676261,42.3850961,2.2986399,13.5071557,11.8246963,23.0633392,5.2333795,6.130368,2.0672191,18.9395391),(38655,'ulna.tif',235,4,185,17.789562,14.4842259,19.8181477,1.8,14.4718772,19.7859075,1.0718579,2.5732366,3.1197696,29.9550905,42.5668751,2.2860888,13.6442368,11.6410166,23.099776,5.16151,6.1365364,2.1740262,18.6876913),(38656,'ulna.tif',235,4,186,17.6423849,14.4693823,19.7896755,1.8,14.4592013,19.7562813,1.053941,2.5624059,3.1331807,29.6252271,42.290556,2.2224026,13.4976434,11.5614889,22.9528949,5.16151,6.1365364,2.1740262,18.846507),(38657,'ulna.tif',235,4,187,17.5447164,14.4518602,19.7701259,1.8,14.4462112,19.7379111,1.0500036,2.5028189,3.1490453,29.3801417,42.281403,2.2001839,13.4267372,11.7388202,22.7260091,5.1170334,6.134481,1.9853032,18.5946592),(38658,'ulna.tif',235,4,188,17.329024,14.4263632,19.7426368,1.8,14.4215895,19.7113796,1.0536353,2.534976,3.1552089,28.8839676,42.0678365,2.1821699,13.3328213,11.394178,22.3768715,5.1195924,6.1846428,2.0831858,18.7149398),(38659,'ulna.tif',235,4,189,17.2466818,14.403964,19.7151071,1.8,14.4017159,19.6799357,1.0498275,2.5158478,3.0918436,28.6865601,42.5101357,2.1623721,13.7491222,11.4023432,22.7350806,5.0329392,6.1365364,2.1740262,18.9010039),(38660,'ulna.tif',235,4,190,17.1297459,14.3794846,19.6913691,1.8,14.3744238,19.6527804,1.028545,2.4888456,3.155912,28.3961382,42.5300718,2.0946145,13.4763176,11.4093613,22.4700264,5.0433451,6.2009343,2.1889406,18.7807234),(38661,'ulna.tif',235,4,191,16.9629607,14.3627239,19.6706729,1.8,14.3635682,19.6357742,1.0272102,2.4857656,3.1093953,27.9569913,42.3924363,2.0708815,13.6336595,11.2468334,22.5073273,5.017488,6.1437251,2.108081,18.7807234),(38662,'ulna.tif',235,4,192,16.9001967,14.3396869,19.6466406,1.8,14.334066,19.6002632,1.0273863,2.4583869,3.1150269,27.7893268,42.4897805,2.0636582,13.6402613,11.3038864,22.2991926,5.000251,6.1437251,2.108081,18.5946592),(38663,'ulna.tif',235,4,193,16.7780486,14.3268411,19.6361352,1.8,14.3264959,19.6037436,1.0139039,2.4918512,3.0799833,27.5382549,42.5141924,2.015139,13.8033841,11.0513241,22.7267121,4.9655583,6.130368,2.0672191,18.8079718),(38664,'ulna.tif',235,4,194,16.7069601,14.308912,19.6162634,1.8,14.310503,19.581128,1.0244491,2.4277891,3.0924046,27.3036742,42.7002256,2.0328121,13.8080979,11.2463124,22.5125321,4.9551306,6.1846428,2.0831858,18.7807234),(38665,'ulna.tif',235,4,195,16.6009287,14.287321,19.5988875,1.8,14.282309,19.5617895,1.0118542,2.4664403,3.0985076,27.1753137,42.6641068,1.9887716,13.7692439,11.0180302,22.3044442,4.984107,6.2019511,2.3049573,18.7534749),(38666,'ulna.tif',235,4,196,16.4290526,14.2668563,19.5838019,1.8,14.2688641,19.5543877,1.0297331,2.427784,3.1214488,26.8465363,42.7818185,2.0118085,13.7057567,11.0580417,22.2960552,4.9221247,6.2121099,2.2794226,18.7534749),(38667,'ulna.tif',235,4,197,16.1391258,14.2428676,19.5627394,1.8,14.2500621,19.5190076,1.0325456,2.4559149,3.1296394,26.3163308,42.323599,1.9829755,13.5234745,10.7154897,21.9282123,4.9663349,6.244507,2.2286849,18.846507),(38668,'ulna.tif',235,4,198,15.9763612,14.2202544,19.5490954,1.8,14.2216826,19.5141802,1.0364918,2.442563,3.0316775,25.9445998,41.938517,1.972207,13.8334362,10.6218755,22.1920803,4.9356715,6.2009343,2.1889406,18.5946592),(38669,'ulna.tif',235,4,199,15.8466264,14.2001915,19.5314585,1.8,14.2018541,19.4952053,1.0555451,2.4158154,3.0395551,25.6073561,41.6372566,1.9998283,13.6984706,10.5998812,21.9437035,4.8904619,6.2009343,2.1889406,18.6876913),(38670,'ulna.tif',235,4,200,15.631929,14.1870922,19.5249565,1.8,14.1931448,19.4938343,1.0556141,2.4500098,3.0274332,25.1225472,41.0016458,1.972888,13.5433694,10.2540601,21.6686026,4.9219742,6.1764809,2.2142974,18.3428114),(38671,'ulna.tif',235,4,201,15.4515276,14.1761853,19.5167025,1.8,14.1846841,19.4855373,1.0758053,2.4078263,3.0037662,24.5292679,40.4052895,1.9941546,13.4515427,10.187308,21.5163791,4.8718664,6.1272815,2.2913505,18.5016271),(38672,'ulna.tif',235,4,202,15.2047987,14.1535294,19.5054235,1.8,14.1592757,19.470975,1.0831228,2.3902084,2.9775124,24.0238781,39.7158659,1.9777397,13.3386062,10.0509552,20.8762269,4.8223287,6.193812,2.3561945,18.5674107),(38673,'ulna.tif',235,4,203,15.0841175,14.1453955,19.4970583,1.8,14.1487863,19.4605226,1.1003638,2.3773799,2.9694608,23.6020308,39.2442729,1.9975008,13.215959,9.927749,20.7967484,4.8223287,6.1097617,2.1995926,18.3700599),(38674,'ulna.tif',235,4,204,14.8721193,14.1312935,19.4851463,1.8,14.1397472,19.4527871,1.1054833,2.3685197,2.956299,23.0735021,38.5629922,1.9796427,13.0443476,9.7417397,20.5340769,4.8069164,6.1097617,2.1995926,18.2770278),(38675,'ulna.tif',235,4,205,14.6207336,14.1179775,19.4747765,1.8,14.1298619,19.4387474,1.1208565,2.3607087,2.9437961,22.51616,38.2019357,1.9758755,12.9770999,9.5378817,20.1425485,4.7947579,6.0537742,2.2774105,18.1567473),(38676,'ulna.tif',235,4,206,14.4403783,14.1163774,19.4718786,1.8,14.1237034,19.4361614,1.1364163,2.3666863,2.9507529,21.8827652,37.612521,1.9804664,12.7467538,9.2461619,19.7165705,4.7669219,6.0475214,1.9513027,18.0251801),(38677,'ulna.tif',235,4,207,14.2827578,14.1074191,19.4729005,1.8,14.1242124,19.4415465,1.1416875,2.3121819,2.9881584,21.4599692,37.0074756,1.9683868,12.3847099,9.2812632,19.3191075,4.7234915,6.0870141,2.2253671,18.1839957),(38678,'ulna.tif',235,4,208,13.8991483,14.0996423,19.4674351,1.8,14.1097515,19.436509,1.1574339,2.3514164,2.9807553,20.8064952,36.0423098,1.9427407,12.0916702,8.8484947,18.7840543,4.7238947,6.0787212,2.0096556,18.0524285),(38679,'ulna.tif',235,4,209,13.6143772,14.1043183,19.4491371,1.8,14.1088247,19.421785,1.1790873,2.3010337,2.9242146,20.2853621,35.2224427,1.9383532,12.0450952,8.8157606,18.5111242,4.6854466,6.0475214,2.1175852,18.1182121),(38680,'ulna.tif',235,4,210,13.2879453,14.1033544,19.4440939,1.8,14.1093021,19.4155637,1.1974626,2.29991,2.9618665,19.7005632,34.6501267,1.9200598,11.6987471,8.5657976,18.2363112,4.6705721,6.031861,1.9928014,17.8936128),(38681,'ulna.tif',235,4,211,13.0807268,14.1111205,19.4547949,1.8,14.129549,19.4333887,1.2218754,2.2570985,2.9429915,19.3105735,34.0522176,1.9252985,11.5706135,8.5554855,17.5657301,4.6173983,6.0193033,2.2105661,17.7460838),(38682,'ulna.tif',235,4,212,12.7621821,14.1099047,19.4618401,1.8,14.1118403,19.4296293,1.2355963,2.2580215,2.9288306,18.6702043,33.3983539,1.8968571,11.403307,8.2683909,17.5766873,4.5420392,6.0025189,1.8747973,17.7075487),(38683,'ulna.tif',235,4,213,12.4963762,14.1195924,19.4541556,1.8,14.1267624,19.4193142,1.2573925,2.2728914,2.8943919,18.245332,33.0407977,1.8847702,11.415454,8.0273663,17.1771208,4.5596551,5.9898997,2.1015698,17.5872681),(38684,'ulna.tif',235,4,214,12.1802722,14.1257159,19.4638909,1.8,14.1401056,19.4305598,1.2699424,2.2304715,2.9128889,17.827603,32.0326215,1.851777,10.9968566,7.9927508,16.8961932,4.5420392,5.9434001,1.9583201,17.5214845),(38685,'ulna.tif',235,4,215,11.8783077,14.1328502,19.4788075,1.8,14.1450884,19.4448061,1.2870864,2.285431,2.8831238,17.2673981,31.097251,1.8245976,10.7859576,7.5554231,16.5002832,4.5438481,5.9295918,2.0005586,17.3899173),(38686,'ulna.tif',235,4,216,11.764632,14.135211,19.4671369,1.8,14.1380923,19.4307334,1.2995189,2.2127503,2.8892423,17.0304119,30.3828721,1.8199811,10.5158617,7.6964907,16.3310265,4.486884,5.862214,1.9228406,17.7620456),(38687,'ulna.tif',235,4,217,11.6147777,14.1356759,19.4800732,1.8,14.1499383,19.4453129,1.3163586,2.2135966,2.8440721,16.7818354,29.5326061,1.8131567,10.3839162,7.5812526,16.013654,4.4317288,5.8363417,2.0947157,17.3626688),(38688,'ulna.tif',235,4,218,11.3939231,14.12731,19.4805546,1.8,14.1456828,19.4414493,1.3161224,2.2220195,2.8413275,16.4309167,28.95893,1.7784611,10.1920425,7.394587,15.9286084,4.4919861,5.7973166,1.9477056,17.3241337),(38689,'ulna.tif',235,4,219,11.0834263,14.1270609,19.503345,1.8,14.1490963,19.4558442,1.3144893,2.2526774,2.847777,16.0440421,28.0290086,1.7285207,9.8424168,7.1222102,15.4242238,4.4781388,5.7886087,1.886412,17.2583501),(38690,'ulna.tif',235,4,220,10.7409376,14.1314924,19.5063639,1.8,14.1474167,19.4671254,1.3394697,2.1761331,2.7828767,15.4176508,27.177816,1.696058,9.7660871,7.0848842,14.8284437,4.4217458,5.7393803,2.1045045,17.165318),(38691,'ulna.tif',235,4,221,10.5221054,14.1407929,19.5053086,1.8,14.1565237,19.4819792,1.3613568,2.178935,2.7958673,15.1242077,26.6773743,1.6778773,9.5417171,6.941101,14.6570231,4.4217458,5.7360834,1.9731174,17.3899173),(38692,'ulna.tif',235,4,222,10.2018681,14.1410886,19.5260452,1.8,14.1482509,19.4841404,1.3617162,2.1693973,2.8006907,14.3300414,26.1157319,1.6270598,9.3247469,6.6055402,14.2880294,4.3796865,5.7261812,1.7681919,17.2855985),(38693,'ulna.tif',235,4,223,9.9219503,14.1402362,19.530468,1.8,14.1429162,19.5008348,1.3565018,2.1114867,2.8360701,13.7000117,25.4748161,1.5788742,8.9824352,6.488325,13.7302643,4.2673868,5.7547409,1.8678605,17.1925664),(38694,'ulna.tif',235,4,224,9.5299671,14.148218,19.5420692,1.8,14.157958,19.4940842,1.3777242,2.1125242,2.7544494,13.1864843,24.2959482,1.5298521,8.8206189,6.2420511,13.5180613,4.2673868,5.6474557,1.8736812,17.0065023),(38695,'ulna.tif',235,4,225,9.4578472,14.157251,19.5466334,1.8,14.1780966,19.5068106,1.391885,2.1322023,2.7598183,12.9622506,24.280373,1.5263875,8.7978159,6.079278,13.2653071,4.2673868,5.6930497,1.9549657,17.0065023),(38696,'ulna.tif',235,4,226,9.3047007,14.151983,19.5392582,1.8,14.1698442,19.5150298,1.3951055,2.1449594,2.7719527,12.6678813,23.5972758,1.5034055,8.5128711,5.905884,12.8877262,4.2673868,5.6329219,1.9809237,17.1925664),(38697,'ulna.tif',235,4,227,9.129925,14.1393643,19.5890759,1.8,14.1643899,19.5306007,1.4257843,2.0524612,2.7498048,12.2206645,23.4836405,1.4898797,8.5401119,5.9541514,12.7608465,4.1882136,5.681963,1.8925469,16.7931897),(38698,'ulna.tif',235,4,228,9.1433811,14.1393034,19.6035382,1.8,14.1773518,19.5527121,1.4435942,2.0980435,2.7802336,12.1109171,23.3508564,1.4993723,8.3988829,5.7724814,12.7363193,4.2673868,5.6474557,1.8736812,16.8476866),(38699,'ulna.tif',235,4,229,8.943954,14.1363421,19.6352696,1.8,14.1549146,19.6001044,1.4662177,2.0870422,2.7575568,11.8778409,23.0733726,1.4744155,8.3673244,5.6912317,12.556274,4.1550872,5.6786327,1.9990605,16.634374),(38700,'ulna.tif',235,4,230,8.8318284,14.1373572,19.6615014,1.8,14.160385,19.6342953,1.4923154,2.019709,2.740464,11.5967358,22.9897334,1.4629238,8.3889931,5.7417854,12.3421692,4.0427875,5.681963,1.8925469,16.9134702),(38701,'ulna.tif',235,4,231,8.5839024,14.135135,19.6898688,1.8,14.1538399,19.6862904,1.4892525,2.0118439,2.7314973,11.4496218,22.1423836,1.4211585,8.1063171,5.6911085,12.2354174,4.0427875,5.6149827,1.8545904,16.5028067),(38702,'ulna.tif',235,4,232,8.5901353,14.1396229,19.7008364,1.8,14.1648132,19.6908136,1.49934,2.0106902,2.7848475,11.3705249,22.0442858,1.4243914,7.9157965,5.6550358,11.9463725,4.0427875,5.6429877,1.670465,16.8749351),(38703,'ulna.tif',235,4,233,8.7709912,14.0978753,19.7288826,1.8,14.1230183,19.7389912,1.4977368,2.0542843,2.7932432,11.5778065,22.7470328,1.4540429,8.1435919,5.6359318,12.146879,4.1550872,5.7492597,1.7873466,16.9407187),(38704,'ulna.tif',235,4,234,8.6758476,14.0886773,19.7657823,1.8,14.1225886,19.7807257,1.5066827,2.099846,2.8132411,11.6291192,22.454844,1.440039,7.9818414,5.5380819,12.1153352,4.2256397,5.7052203,1.7488893,16.8862217),(38705,'ulna.tif',235,4,235,8.7316093,14.0953759,19.7933436,1.8,14.1118721,19.7986608,1.5320086,2.0927411,2.8362088,11.7878616,23.0486504,1.4530799,8.1265705,5.6327377,12.2621043,4.2673868,5.7547409,1.6685232,17.1380695),(38706,'ulna.tif',235,4,236,8.7100287,14.0814693,19.8353426,1.8,14.1035876,19.834465,1.563329,2.0951812,2.8766662,11.9583403,23.1239472,1.4515905,8.0384533,5.7075447,12.1267825,4.2673868,5.7667813,1.4536876,17.3241337),(38707,'ulna.tif',235,4,237,8.8113664,14.059468,19.8371404,1.8,14.0664046,19.8701462,-1.5586104,2.110643,2.883516,12.013318,23.536294,1.468343,8.1623594,5.6917812,12.2709419,4.2673868,5.8492921,1.5131679,17.2311016),(38708,'ulna.tif',235,4,238,8.9052245,14.0440425,19.882517,1.8,14.0578748,19.8970129,-1.5626531,2.1251635,2.8183097,12.0773538,23.9592945,1.4841057,8.5012995,5.6830234,12.4650483,4.2673868,5.8589862,1.3583643,17.0450374),(38709,'ulna.tif',235,4,239,9.0032254,14.0341115,19.8873317,1.8,14.0602755,19.8974645,-1.5647551,2.1382942,2.9114599,12.3606232,24.6135145,1.5004828,8.4540113,5.7805998,12.6253848,4.3796865,5.9082853,1.418147,17.5872681),(38710,'ulna.tif',235,4,240,8.9989784,14.0317478,19.9298742,1.8,14.0550162,19.9431117,1.5703914,2.1396963,2.9792571,12.2950413,25.217257,1.4998295,8.4642768,5.7461618,12.5831163,4.3796865,6.0025189,1.2667954,17.6417651),(38711,'ulna.tif',235,4,241,9.3531921,14.0408541,19.9746937,1.8,14.0626418,19.9643828,-1.5649669,2.1408969,3.0493218,13.0770844,26.5616875,1.5588124,8.7106868,6.108227,12.8690266,4.3796865,6.1887197,1.3698421,17.8391159),(38712,'ulna.tif',235,4,242,9.8746864,14.0763337,19.9826767,1.8,14.0960509,19.9909679,-1.5678599,2.2064666,3.1521417,14.2850598,28.3916914,1.6457669,9.0071112,6.4741792,13.4483616,4.4919861,6.3882613,1.3940875,18.0364667),(38713,'ulna.tif',235,4,243,10.3894055,14.0752065,20.0385962,1.8,14.0920568,20.0244195,-1.5404867,2.3080094,3.1186774,15.6208605,30.6814126,1.7299773,9.8379566,6.7681096,14.4563591,4.6042858,6.4560093,1.3426937,18.3813466),(38714,'ulna.tif',235,4,244,10.4036525,14.0596628,20.0596759,1.8,14.0900891,20.0818128,-1.5079617,2.3270597,3.2237686,16.0943656,32.4720703,1.7271052,10.0727051,6.9161806,14.8909118,4.7165854,6.5413946,1.3633001,18.8305452),(38715,'ulna.tif',235,4,245,10.3852743,14.0423439,20.1047062,1.8,14.0686064,20.1106615,-1.4879621,2.4379984,3.4012428,16.8338655,33.8734434,1.7190298,9.9591372,6.9047894,14.8560556,4.7165854,6.7613345,1.3701434,19.6518721),(38716,'ulna.tif',235,4,246,10.4868615,14.0523251,20.2151651,1.8,14.0812128,20.2255748,-1.4860107,2.5228786,3.4044737,17.517358,35.4126436,1.735276,10.4017969,6.9434012,15.4914365,4.9873088,6.8943207,1.3574277,20.1555677),(38717,'ulna.tif',235,4,247,10.9863394,14.0478201,20.3000021,1.8,14.0740469,20.2997631,-1.4515759,2.6241718,3.5639997,18.8246673,37.7161182,1.8051539,10.5825257,7.1735651,15.8216845,5.1623983,7.1467062,1.4288993,20.9496461),(38718,'ulna.tif',235,4,248,11.6907213,14.0605208,20.4543905,1.8,14.0789894,20.4234661,-1.474202,2.7122954,3.5056588,20.3606533,40.6140675,1.93033,11.5852882,7.506798,17.343947,5.2780837,7.1068913,1.665748,21.2127806),(38719,'ulna.tif',235,4,249,13.0727896,14.0737816,20.6226444,1.8,14.0896772,20.5413504,-1.4291702,3.0190413,3.6709098,23.662204,46.6985926,2.1353874,12.7212584,7.8376549,18.9368164,5.6149827,7.4228287,1.2633989,22.061356),(38720,'ulna.tif',235,4,250,13.6277031,14.1151633,20.6249657,1.8,14.097425,20.6003907,-1.4189349,3.0711412,3.7496598,27.4643113,51.7329753,2.2193052,13.7967117,8.9427055,20.930877,5.8310691,7.5449991,1.3149878,22.6534085),(38721,'ulna.tif',235,4,251,14.2306128,14.1950551,20.7626308,1.8,14.1919346,20.7083156,-1.4420183,4.5725591,3.8794254,29.7564493,55.2070914,2.3326529,14.2307394,6.5076139,17.000609,5.9887703,7.8449165,1.3397057,23.4089518),(38722,'ulna.tif',235,4,252,15.7220641,14.1816231,20.7074027,1.8,14.2538408,20.6615696,-1.3774662,4.7038002,4.0695169,36.4158742,57.1311062,2.5236187,14.0387934,7.7417987,17.9520262,6.2692767,8.0237297,1.4585935,25.4735558),(38723,'ulna.tif',235,4,253,17.0401543,14.3215889,20.6339319,1.8,14.3483463,20.6699164,-1.4880365,4.6254764,3.9974774,44.7413162,61.8269119,2.8206182,15.466482,9.6728018,20.951752,6.3812488,8.105048,1.6401295,25.128676),(38724,'ulna.tif',235,4,254,17.0317712,14.3077951,20.3192874,1.8,14.2699879,20.4073936,-1.4497171,3.0467112,4.1913465,34.1922575,69.5307275,2.7972167,16.5891145,11.2226777,24.1169781,5.8674258,8.2163142,1.192828,24.9153634),(38725,'ulna.tif',235,4,255,13.9113942,14.1007673,20.4048386,1.8,14.058058,20.4654082,-1.5337702,2.4602669,3.8765324,19.4706552,59.2123117,2.3153885,15.274556,7.914042,19.8762253,4.775776,7.5641965,1.2537406,23.0800338),(38726,'ulna.tif',235,4,256,9.8251693,13.9831726,20.4131364,1.8,13.9578169,20.5329155,1.4763773,1.9687503,4.549396,9.9191573,26.459552,1.6229731,5.8160582,5.0383012,7.6293203,3.964469,6.3813481,2.0659296,19.7561909),(38727,'ulna.tif',235,4,257,7.1848116,14.0234553,20.5870929,1.8,14.0270129,20.6731106,1.2617673,2.6957874,9.0635592,5.3414049,12.0240922,1.0867059,1.3266413,1.9813895,1.8383404,3.5541127,5.2792782,2.2355708,15.4728423),(38728,'ulna.tif',235,4,258,6.3439856,14.1268234,20.6020742,1.8,14.0937392,20.7008349,1.1864145,1.7959971,4.8523092,4.1240137,6.8190272,0.9086548,1.4053159,2.2962251,2.207136,3.4812892,4.3854417,2.2655346,12.9862881),(38729,'ulna.tif',235,4,259,6.0875802,14.1478534,20.5801645,1.8,14.1490965,20.7175045,1.1482595,2.3750438,2.492546,4.2947508,6.0166924,0.8439802,2.4138742,1.8082828,3.0227282,3.5935889,4.1792976,2.1066076,12.7616888),(38730,'ulna.tif',235,4,260,5.8597953,14.1093992,20.6010098,1.8,14.1089091,20.6465081,1.0772298,2.5564487,2.0436292,4.4455613,6.0427717,0.7574197,2.9568827,1.7389597,3.3819448,3.8178907,4.3348248,2.5032728,13.3969516),(38731,'ulna.tif',235,4,261,6.4568812,14.0763453,20.3916152,1.8,14.0368216,20.2381757,1.1024296,2.5233658,4.6405865,5.2699902,8.696044,0.8568404,1.8739106,2.0884765,2.9180001,3.9242961,5.6329219,1.9809237,20.1283192),(38732,'ulna.tif',235,4,262,5.8561851,14.0997636,20.3176762,1.8,14.0867655,20.296977,0.5925133,1.6708523,2.2309187,3.5042824,5.5516056,0.3043887,2.488484,2.0973023,3.7814131,3.4145374,4.5477893,2.1451012,13.9391823),(38733,'ulna.tif',235,4,263,2.7248562,14.0348081,20.2846081,1.8,13.903676,20.240585,0.4260019,1.132504,2.1081554,0.7417137,1.5495971,0.0775502,0.7350488,0.6549325,1.0084507,0.645288,2.0338332,1.6814535,5.3565233),(38734,'ulna.tif',235,4,264,20.4749218,15.5782762,22.5218557,1.8,15.8200149,22.8283732,1.0131307,3.4056761,9.0932473,33.4618501,288.5464025,2.4567859,31.7319426,9.8253178,35.1483427,6.1144042,8.6536338,1.6097377,34.2309923),(38735,'ulna.tif',235,4,265,19.3193377,15.7575198,22.8399821,1.8,15.8818142,23.1127427,1.0386238,3.4071617,8.6967785,31.7413935,274.998408,2.390892,31.6207213,9.3160807,34.8507585,6.257826,9.5619709,1.7958346,27.2750254),(38736,'ulna.tif',235,4,266,15.5728652,15.4735671,22.5022987,1.8,15.6285242,22.9179423,1.0879226,2.6170375,9.0504176,22.4740218,224.8204531,2.0358955,24.8408927,8.5875811,26.7556726,4.782093,9.9971924,1.8321223,37.8677914),(38737,'ulna.tif',235,4,267,26.8190849,16.9975562,20.257781,1.8,17.3740749,19.9503988,-1.1942536,6.9657338,8.3334124,177.1553362,372.8055101,3.8654845,44.7362366,25.4324013,54.3393295,7.5231093,18.787299,1.0857616,58.0393209),(38738,'ulna.tif',235,4,268,21.8126221,17.3063534,19.8844422,1.8,17.561564,19.7920777,-0.9187628,8.2773583,8.4657173,72.7524594,295.7578871,2.2968286,34.9359514,8.7893332,36.5026238,4.1541562,8.2040258,1.9055332,21.8799669),(38739,'ulna.tif',235,4,269,18.2557712,17.9217002,19.2134852,1.8,18.0495278,19.1772348,-0.9577488,7.6910529,7.4565301,39.7155697,219.6714697,2.0353901,29.4602805,5.1638664,26.088286,6.0463978,12.15433,0.6675261,37.5116249),(38740,'ulna.tif',235,4,270,19.5728532,17.84684,18.75776,1.8,17.9257324,18.8034067,-0.843834,3.2511268,7.4328335,43.6571784,200.2992951,1.8212636,26.9479057,13.4283222,31.3926306,6.2995877,16.4606164,0.8384883,58.3842007),(38741,'ulna.tif',235,4,271,29.8108873,17.0432913,19.668408,1.8,17.3346425,19.4351565,-0.8536315,7.3981449,8.7723378,73.0289152,387.9727683,2.8222053,44.2268385,9.8712469,50.51355,6.8443053,17.3334797,1.0259324,58.5270546),(38742,'ulna.tif',235,4,272,30.8986341,17.217107,19.9557414,1.8,17.3581716,19.9428499,-0.9474772,7.0016631,9.0230274,109.2198704,418.7225113,3.3950152,46.4059893,15.5991325,54.4146405,7.6739777,17.8581167,0.8744477,56.8844008),(38743,'ulna.tif',235,4,273,35.2621171,17.5665888,20.7272046,1.8,17.6302311,20.7703976,-1.1367019,5.6783922,9.1219522,182.4356884,541.5927487,4.8374034,59.3724605,32.1280533,68.3891007,10.0738346,18.787299,1.0857616,78.5576667),(38744,'ulna.tif',235,4,274,37.1819565,17.6658568,20.9102137,1.8,17.7629794,21.0213619,-1.1741571,6.0499517,9.2183294,226.2854952,640.4176438,5.2721311,69.4722024,37.4028598,78.9423198,10.3454056,19.090941,1.080839,82.1606058),(38745,'ulna.tif',235,4,275,40.2173384,17.6331206,21.0776446,1.8,17.8278673,20.9893631,-1.1669343,6.2579297,9.4279853,265.8954546,709.6128938,5.6677795,75.2666525,42.4893645,87.8745996,10.8475382,19.2019272,1.0233559,78.1357165),(38746,'ulna.tif',235,4,276,40.8336216,17.7461236,20.9823331,1.8,17.9239372,20.8505723,-1.1113562,5.9661499,9.553652,279.3124308,734.0642797,5.4673181,76.8359868,46.8161943,93.295328,7.7226388,12.7775096,1.7923251,44.0024314),(38747,'ulna.tif',235,4,277,42.66197,17.7172623,20.9279612,1.8,17.8705594,20.818962,-1.0980154,5.9624818,9.3865224,303.6742859,765.5398035,5.6359569,81.5573406,50.930853,99.6720564,7.6179066,12.8557355,1.8178936,58.3024553),(38748,'ulna.tif',235,4,278,45.2019101,17.4446186,20.9489346,1.8,17.5977779,20.7059574,-1.2121214,7.3301779,8.9810094,286.8709476,835.6292826,6.6053196,93.044027,39.135605,102.6541046,9.9653425,19.8239903,1.2777118,81.9632549),(38749,'ulna.tif',235,4,279,26.9221992,18.5385487,18.7643121,1.8,18.6405893,18.752938,-1.3417096,7.404098,8.8835506,173.2343283,328.0657241,4.2556412,36.9295723,23.3970874,54.4646249,8.1388557,12.916413,0.0173896,50.9198632),(38750,'ulna.tif',235,4,280,11.5258546,20.4672717,16.6545671,1.8,20.6736693,16.6541628,-0.160524,4.5489373,6.0858093,16.992463,87.9794264,0.0490759,14.4564876,3.7354797,17.0745931,3.2344155,5.8783264,2.3832149,15.4070587),(38751,'ulna.tif',235,4,281,3.8601113,22.8808859,15.880601,1.8,23.0345971,15.9376733,0.0050797,2.4314834,3.6255432,2.3600424,14.9327407,0.0000166,4.1187596,0.9706183,4.6780164,0.6106538,3.2177329,2.0812846,6.9832154),(38752,'ulna.tif',235,4,282,1.2545583,25.3144693,15.8383599,1.8,25.3495234,15.9725024,0.9733796,1.2550515,1.5268712,0.2859873,0.6503487,0.1429327,0.4259356,0.227869,0.6057682,2.2534762,5.1767582,1.7894653,15.9878245),(38753,'ulna.tif',235,4,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38754,'metacarpal.tif',235,5,1,25.6038522,8.8466519,10.1019294,1.8,8.855832,10.1362407,-0.5896227,3.9159818,7.0835764,81.8919258,241.0902913,1.3194042,34.0351085,20.9122335,45.5881031,9.1477574,15.7548544,1.0401565,54.4272027),(38755,'metacarpal.tif',235,5,2,25.817244,8.8452687,10.0828897,1.8,8.8860036,10.091417,-0.5938614,4.0072709,7.0935766,81.9302462,247.9583597,1.3472881,34.955337,20.4453973,46.4988517,9.1384984,17.1701532,0.8919696,61.8709268),(38756,'metacarpal.tif',235,5,3,25.8292732,8.8575415,10.0521441,1.8,8.9030944,10.0500616,-0.5998877,4.0430134,7.1216448,80.6239742,251.6828544,1.3720358,35.3405516,19.9415552,46.6575116,9.1384984,17.2974822,0.872733,66.6852346),(38757,'metacarpal.tif',235,5,4,25.91334,8.9042455,10.0129822,1.8,8.9398373,10.008755,-0.6068448,4.0681402,7.1828208,79.6076428,254.9949455,1.4045788,35.5006691,19.5685595,46.5826269,9.2627251,17.3120577,0.8818719,61.5194343),(38758,'metacarpal.tif',235,5,5,25.7983842,8.9694053,9.9773962,1.8,9.0086258,9.9584308,-0.616205,3.9933567,7.256711,78.9372256,254.0820193,1.4361845,35.0133855,19.7671359,45.8909056,7.4545388,10.6026908,2.0676071,29.6047934),(38759,'metacarpal.tif',235,5,6,25.6258957,9.0242515,9.9692744,1.8,9.0687412,9.9553419,-0.6236634,3.9879017,7.3055765,79.6341329,250.0662791,1.4567081,34.2295065,19.9689306,45.1252175,7.4545388,10.6026908,2.0676071,29.8181067),(38760,'metacarpal.tif',235,5,7,25.4098384,9.0654916,9.9814149,1.8,9.1091159,9.9901986,-0.6278867,3.9648594,7.3313065,80.669362,245.374333,1.4614081,33.469387,20.3460839,44.4607206,7.4486614,10.6026908,2.0676071,30.0427067),(38761,'metacarpal.tif',235,5,8,25.5965145,9.1035509,10.0074599,1.8,9.1522589,10.0420078,-0.6308561,4.0196834,7.3461382,82.7863178,247.3736795,1.4842007,33.6739759,20.5952334,44.9201424,7.3343501,10.6139845,2.0912548,29.8838905),(38762,'metacarpal.tif',235,5,9,25.9853743,9.1225311,10.0202244,1.8,9.1950518,10.0638834,-0.6388436,4.017788,7.3516438,84.6497251,253.6517813,1.5397848,34.50273,21.0687387,45.9745758,7.2718372,10.6702736,2.1003859,31.3404848),(38763,'metacarpal.tif',235,5,10,0.1281298,7.0975718,10.3137785,1.8,7.0979363,10.3143237,0.2757422,0.2863446,2.2535085,0.0028531,0.0698157,0.001583,0.0309809,0.0099638,0.0322408,0.6738,0.9594917,2.782822,2.3549943),(38764,'metacarpal.tif',235,5,11,2.0817561,6.9315911,10.4053113,1.8,6.9406346,10.4164434,0.2966156,1.0122547,2.1547828,0.3422666,1.8380167,0.029641,0.8529939,0.338123,1.0055902,1.9327176,4.1200483,2.8370818,10.050567),(38765,'metacarpal.tif',235,5,12,3.7872998,7.0119914,10.4069484,1.8,7.0308501,10.4210247,0.35765,1.2090373,2.3465201,1.0262676,4.1372181,0.0773567,1.7631292,0.8488304,2.2001223,2.4790091,4.5102121,2.8119682,11.3868803),(38766,'metacarpal.tif',235,5,13,5.2687278,7.1530506,10.4047985,1.8,7.1463249,10.4215266,0.3886073,1.4356699,2.5803708,2.0257458,7.4224224,0.1260676,2.8764945,1.4110109,3.6570617,2.9478885,4.9717332,2.8198421,12.8547613),(38767,'metacarpal.tif',235,5,14,6.2789555,7.2887613,10.4164738,1.8,7.2479548,10.4324194,0.3813635,1.5643026,2.7951293,3.0662764,11.00418,0.144963,3.9369126,1.9601556,5.0327779,3.2120114,5.3681282,2.8661665,14.0980423),(38768,'metacarpal.tif',235,5,15,6.9687642,7.4198964,10.4167032,1.8,7.3601611,10.4297983,0.3602455,1.6838504,3.0211387,4.1678632,14.504528,0.144322,4.8010136,2.4751981,6.1802129,3.4095088,5.75695,2.782822,15.1552586),(38769,'metacarpal.tif',235,5,16,7.5999207,7.5273791,10.4171355,1.8,7.4292611,10.4370082,0.3359776,1.7597122,3.1900619,5.3135182,18.3105146,0.1376814,5.7398618,3.0195381,7.4036331,3.6501548,5.9867596,2.7367009,16.8092043),(38770,'metacarpal.tif',235,5,17,8.2423139,7.6649693,10.4236473,1.8,7.5910485,10.4556954,0.3313044,1.8634645,3.3591173,6.4056653,22.5310614,0.1453463,6.7074352,3.4375032,8.6143406,3.7485563,6.5066201,2.7707014,17.269691),(38771,'metacarpal.tif',235,5,18,8.7368175,7.753005,10.3774437,1.8,7.6946185,10.3980909,0.3144645,1.9168662,3.4999465,7.4310284,26.0468937,0.13931,7.4420834,3.8766547,9.557018,3.8915559,6.64091,2.8144946,17.7461396),(38772,'metacarpal.tif',235,5,19,9.3458938,7.7928081,10.3579202,1.8,7.7134083,10.3764911,0.3122723,1.9216733,3.6045049,8.5146252,30.0471261,0.1470191,8.3359926,4.4308391,10.6588751,3.9229228,6.8897678,2.8095332,18.1953396),(38773,'metacarpal.tif',235,5,20,10.2051199,7.8603941,10.3285654,1.8,7.7986647,10.3353599,0.3081464,2.0063339,3.6612524,10.0201433,34.6334461,0.1564556,9.4594532,4.9942551,12.1429201,4.0214228,7.0677666,2.8349163,18.8691397),(38774,'metacarpal.tif',235,5,21,11.0650983,7.8685066,10.2911987,1.8,7.8282037,10.2866168,0.2967057,2.0953975,3.736336,11.5884265,39.3910597,0.1576427,10.5426973,5.5304192,13.5330403,4.0959825,7.2726719,2.9078495,19.5044044),(38775,'metacarpal.tif',235,5,22,11.6426345,7.8274898,10.2679293,1.8,7.8407828,10.2736432,0.2547206,2.1383999,3.7076324,12.9506947,43.6005239,0.1232012,11.7596673,6.0562549,15.1908016,4.1658633,7.4083966,2.896614,19.8333236),(38776,'metacarpal.tif',235,5,23,11.6749501,7.7796218,10.2083491,1.8,7.8285946,10.2254183,0.2186236,2.1628456,3.7185673,13.7689345,44.9185512,0.0915309,12.0795315,6.36612,15.6457813,4.2476919,7.517393,2.9002372,20.3755559),(38777,'metacarpal.tif',235,5,24,11.9185246,7.8534866,10.1329445,1.8,7.946808,10.1489079,0.1416776,2.3131474,3.8788622,15.2523941,50.7515409,0.0396065,13.0841308,6.5937838,17.0105296,4.465453,7.8296544,2.9976672,21.4600207),(38778,'metacarpal.tif',235,5,25,11.9679886,7.9030585,10.0806429,1.8,8.0220608,10.0966434,0.0991177,2.3817676,3.9386416,16.2974256,54.2179779,0.0195321,13.7656541,6.8425758,17.8475955,4.648526,7.9408096,2.9996956,21.8706855),(38779,'metacarpal.tif',235,5,26,12.0299778,7.9579807,10.0415492,1.8,8.1082585,10.0314544,0.069332,2.5949255,3.9797731,17.4983581,57.3886044,0.0096224,14.4200695,6.7432989,18.7436818,4.9412003,8.0237549,3.0293898,22.6647665),(38780,'metacarpal.tif',235,5,27,12.235745,8.0169445,10.0119872,1.8,8.1688544,9.9771338,0.0612041,2.7575031,4.1027006,19.0644282,61.0967454,0.0076295,14.8918363,6.9136561,19.4873502,5.1645981,8.2355039,0.0955981,23.4588474),(38781,'metacarpal.tif',235,5,28,12.5157546,8.0663141,9.9929277,1.8,8.2245839,9.9412763,0.0622855,2.9552701,4.0473299,20.6599032,63.6585807,0.008082,15.7285374,6.9908679,20.7497518,5.3872019,8.2355039,0.0955981,24.8496579),(38782,'metacarpal.tif',235,5,29,12.7347418,8.096007,9.9513413,1.8,8.2354297,9.8907468,0.0560449,3.0223149,4.0507046,21.9012311,65.0307824,0.0066597,16.0541904,7.2465087,21.2128134,5.5699234,8.2469809,0.1091535,25.6005285),(38783,'metacarpal.tif',235,5,30,12.8121312,8.1394495,9.8818777,1.8,8.2858203,9.8319528,0.040666,3.1318891,4.0886756,23.483653,65.7215589,0.0035293,16.074046,7.4982391,21.4860353,5.7820365,8.1794194,0.1516055,24.2256798),(38784,'metacarpal.tif',235,5,31,12.8777463,8.1869332,9.81648,1.8,8.3317501,9.7772453,0.0187133,3.2345552,4.1400725,25.4857863,65.8715274,0.0007515,15.9107182,7.8792243,21.5933242,6.0300954,8.21634,0.3779683,24.9925122),(38785,'metacarpal.tif',235,5,32,12.9464645,8.2709442,9.7733307,1.8,8.3970557,9.7255008,-0.0101657,3.3545332,4.2370254,28.0595617,65.9361776,0.000223,15.5619028,8.3646696,21.7488759,6.1698649,8.258442,0.390607,26.5919609),(38786,'metacarpal.tif',235,5,33,12.8328441,8.4313087,9.6801905,1.8,8.5201577,9.6138723,-0.0235227,3.4633077,4.41054,30.4090193,64.7526629,0.0011832,14.6813456,8.78034,21.1544778,6.2596841,8.3465426,0.4154921,25.4689608),(38787,'metacarpal.tif',235,5,34,12.9106142,8.551038,9.5806058,1.8,8.5795923,9.5391516,-0.0549557,3.5315929,4.5488508,33.052362,62.7921525,0.0064921,13.8039594,9.3590522,20.8804712,6.3118265,8.1917447,0.5004408,25.5347446),(38788,'metacarpal.tif',235,5,35,13.0176307,8.6464572,9.4571949,1.8,8.6314741,9.4382733,-0.1036708,3.4470272,4.592595,35.4212128,60.5166679,0.0232347,13.1770095,10.2758729,20.6236734,6.3962277,8.1917447,0.5004408,26.3673609),(38789,'metacarpal.tif',235,5,36,13.1519499,8.7221723,9.3446518,1.8,8.684436,9.3323477,-0.1502349,3.4803728,4.6801533,37.4552556,57.8479138,0.0491033,12.3602606,10.7618515,20.288067,6.4299836,8.1485244,0.5191461,25.0855446),(38790,'metacarpal.tif',235,5,37,13.5272667,8.7495752,9.2635177,1.8,8.6927224,9.2434066,-0.1916426,3.554742,4.6249478,40.0827023,56.6564246,0.0817936,12.2501759,11.27584,20.8714548,6.4401099,8.3556035,0.6327488,25.6935608),(38791,'metacarpal.tif',235,5,38,13.7548982,8.760704,9.2102361,1.8,8.7012245,9.1738107,-0.2139346,3.5620548,4.6289434,42.2781897,55.3306074,0.1033314,11.9531829,11.8690454,21.0767327,6.4412047,8.289688,0.6218243,24.8609446),(38792,'metacarpal.tif',235,5,39,13.692219,8.7465775,9.1863433,1.8,8.6991245,9.1346308,-0.2570655,3.6027451,4.5487049,43.2365895,53.6743244,0.1475103,11.7999136,12.0010128,21.1404239,6.4199432,8.1755639,0.6489956,24.5705608),(38793,'metacarpal.tif',235,5,40,13.5571589,8.6973367,9.1791665,1.8,8.6624672,9.114003,-0.2955939,3.6103986,4.4006631,43.066811,52.0000935,0.1917443,11.8164224,11.9285473,21.5268357,6.4524371,8.1081849,0.637961,24.2256798),(38794,'metacarpal.tif',235,5,41,13.39797,8.6635344,9.1841096,1.8,8.6527155,9.1210317,-0.3572739,3.643306,4.2701458,42.3984985,50.8647452,0.2731069,11.9117117,11.6373696,21.4667601,6.3896397,8.0863803,0.6573891,24.1871446),(38795,'metacarpal.tif',235,5,42,13.2946389,8.6332862,9.1985749,1.8,8.6358067,9.1305648,-0.3741721,3.6165636,4.186784,41.2747022,50.0401851,0.2960091,11.9519385,11.4126852,21.3627312,6.3896397,7.951126,0.6350267,23.7764798),(38796,'metacarpal.tif',235,5,43,13.2341046,8.6105886,9.2184104,1.8,8.6286183,9.143753,-0.3944594,3.5637063,4.1006345,40.1480455,49.7621443,0.3257653,12.1352302,11.2658122,20.8944795,6.3470219,7.9288894,0.6548321,23.8695122),(38797,'metacarpal.tif',235,5,44,13.267708,8.5824869,9.246219,1.8,8.6121698,9.1736062,-0.3883974,3.5000225,4.0078628,39.2896309,49.4458295,0.317138,12.3372061,11.2255367,20.9045059,6.2853642,7.7941382,0.6319742,23.5133445),(38798,'metacarpal.tif',235,5,45,13.4207684,8.5567634,9.2672269,1.8,8.5951191,9.1963473,-0.3471269,3.4200958,3.9641993,39.0036249,49.1851853,0.258874,12.4073444,11.4042494,20.9422346,6.2638343,7.7038132,0.6405857,23.5405931),(38799,'metacarpal.tif',235,5,46,13.5908867,8.5467416,9.2834366,1.8,8.5916445,9.2102409,-0.341311,3.3604146,3.8848716,38.9721566,48.6050085,0.2537856,12.5113552,11.5974252,20.7036601,6.2422326,7.6825024,0.6610432,23.2887445),(38800,'metacarpal.tif',235,5,47,13.7349198,8.5328778,9.3027572,1.8,8.5733428,9.226679,-0.3444155,3.3130003,3.8637089,38.8619159,48.1590912,0.2609754,12.4644719,11.7301276,20.458582,6.1833646,7.6140729,0.6494007,23.1299283),(38801,'metacarpal.tif',235,5,48,13.8324962,8.5192072,9.3259805,1.8,8.5653079,9.2433765,-0.3557454,3.2702597,3.7703799,38.4615485,47.3259257,0.2796593,12.5520309,11.7610075,20.2754348,6.1255258,7.5073205,0.6045986,22.9325769),(38802,'metacarpal.tif',235,5,49,13.898193,8.510242,9.3495479,1.8,8.5590036,9.2641548,-0.390739,3.269297,3.7351353,38.0336725,46.1704445,0.3360198,12.3611169,11.6335935,20.0225771,6.1061081,7.4364315,0.6676656,22.7465121),(38803,'metacarpal.tif',235,5,50,13.8803665,8.5045475,9.3591049,1.8,8.5522415,9.2692676,-0.4141826,3.2455899,3.6534233,37.4706928,44.8594882,0.374676,12.2787545,11.5451101,19.5254209,6.0482693,7.4194533,0.6889244,22.6534797),(38804,'metacarpal.tif',235,5,51,13.7557152,8.5056685,9.356581,1.8,8.5512456,9.2719492,-0.4568464,3.2400662,3.5794881,36.5400106,43.2235537,0.4461138,12.075345,11.2775508,19.386362,6.0117923,7.2787386,0.6651027,22.3630959),(38805,'metacarpal.tif',235,5,52,13.621211,8.5036333,9.3437098,1.8,8.5441316,9.2739838,-0.5253503,3.2597383,3.7837751,35.8078557,41.7268459,0.5709976,11.0278346,10.9848867,18.142589,5.9673161,7.4567542,0.6465131,22.3358474),(38806,'metacarpal.tif',235,5,53,13.4635438,8.5061747,9.334886,1.8,8.5548872,9.2887485,-0.5816925,3.2406507,3.6037384,35.1063194,39.7470511,0.6774026,11.029394,10.833108,18.9231341,5.9132655,7.1423157,0.6403565,21.7005826),(38807,'metacarpal.tif',235,5,54,13.2157986,8.5063133,9.3286372,1.8,8.5660705,9.2877951,-0.6321359,3.2160371,3.5162828,34.1998661,37.4047715,0.7689975,10.637589,10.6341641,18.8624117,5.8579663,6.7398718,1.3864719,21.1198149),(38808,'metacarpal.tif',235,5,55,12.9786278,8.4873826,9.3305267,1.8,8.5504054,9.299374,-0.6672558,3.1759648,3.4192093,33.0236032,35.538283,0.8283694,10.3937138,10.3979752,18.2989355,5.8026671,6.5654698,1.3465616,20.4573016),(38809,'metacarpal.tif',235,5,56,12.7935313,8.4655099,9.3177215,1.8,8.539057,9.2811025,-0.7094066,3.1415535,3.3888832,31.7498949,34.3494886,0.9047172,10.1359316,10.1064313,18.100027,5.7287927,6.5192064,1.3801574,20.6433663),(38810,'metacarpal.tif',235,5,57,12.6395003,8.4452331,9.3101961,1.8,8.5269605,9.2740786,-0.7634458,3.1606022,3.3742134,30.6189416,32.9999871,1.0070621,9.7800535,9.6876924,17.6873958,5.6717961,6.3576087,0.9484935,20.1941663),(38811,'metacarpal.tif',235,5,58,12.5603488,8.4292101,9.3005974,1.8,8.5160344,9.2557012,-0.7357546,3.091827,3.280907,29.7446018,31.9579077,0.9429429,9.7405711,9.6203966,17.6132974,5.6147996,6.2667026,0.9380475,19.5974368),(38812,'metacarpal.tif',235,5,59,12.4383874,8.4155319,9.283857,1.8,8.5043267,9.2237223,-0.7206215,3.0230509,3.1937154,28.6740949,30.900849,0.9026215,9.6755175,9.4851512,17.4594619,5.5790033,6.1560483,0.9017533,19.2798044),(38813,'metacarpal.tif',235,5,60,12.3351571,8.4067744,9.2656613,1.8,8.4945689,9.2021856,-0.7476284,2.9782079,3.1300422,27.7427201,30.0715256,0.9503542,9.6073867,9.3152396,17.1964922,5.5486271,6.0735515,0.9827937,18.9894206),(38814,'metacarpal.tif',235,5,61,12.2819151,8.3960391,9.2505445,1.8,8.4646231,9.1980092,-0.8247243,2.8786636,3.1076456,26.8322741,29.4160885,1.1039101,9.4657152,9.321087,17.1388506,5.4924771,5.9804366,0.9723774,18.512972),(38815,'metacarpal.tif',235,5,62,12.2162831,8.397766,9.2381159,1.8,8.4677347,9.1881748,-0.9113467,2.8485076,3.1029317,25.9824996,28.6490922,1.2717574,9.2329111,9.1214431,16.9035086,5.4201202,5.8568518,1.0040671,18.3156206),(38816,'metacarpal.tif',235,5,63,12.1398229,8.395352,9.224951,1.8,8.4565976,9.1810344,-0.9556231,2.8081092,3.0616271,25.1403192,27.9614254,1.3494538,9.1328645,8.9527569,16.667957,5.3363179,5.7809966,1.0636978,18.0910206),(38817,'metacarpal.tif',235,5,64,12.0423147,8.3902788,9.202076,1.8,8.4367774,9.1642028,-0.978255,2.7392347,3.0313509,24.2838758,27.2168198,1.3810733,8.9784459,8.8652046,16.6435841,5.2781003,5.7019215,1.0101093,17.7461396),(38818,'metacarpal.tif',235,5,65,11.9558296,8.3832366,9.1755884,1.8,8.4242662,9.1429156,-1.0350161,2.6698505,3.0182834,23.5723313,26.5769992,1.4733117,8.805336,8.829083,16.3257023,5.1615262,5.6830905,1.0541012,17.389972),(38819,'metacarpal.tif',235,5,66,11.8012248,8.3618886,9.1554506,1.8,8.3938166,9.1356281,-1.0788008,2.6416745,2.9867834,22.7730775,25.7202788,1.5279671,8.6113638,8.6206977,16.175795,5.0821181,5.6071338,0.9994588,17.3241881),(38820,'metacarpal.tif',235,5,67,11.62724,8.3394713,9.1295466,1.8,8.3713961,9.1073176,-1.0625658,2.5761571,2.9158335,21.8507821,24.7955983,1.4789639,8.5037772,8.4819291,15.8688125,5.0535003,5.530134,1.0617254,17.0723396),(38821,'metacarpal.tif',235,5,68,11.5244583,8.3177655,9.1090103,1.8,8.3514459,9.1005188,-1.0334761,2.5487677,2.8397606,21.1908637,24.1000565,1.4175549,8.4866506,8.3141606,15.6838508,5.00271,5.4369906,0.9025069,16.9135234),(38822,'metacarpal.tif',235,5,69,11.4267571,8.3020946,9.0801797,1.8,8.3386561,9.0785038,-0.9590054,2.4994944,2.7508519,20.3294877,23.5702148,1.2762544,8.5683328,8.1334401,15.5216464,4.9221402,5.3927394,1.0232341,16.7161719),(38823,'metacarpal.tif',235,5,70,11.2763585,8.2841663,9.0551601,1.8,8.3131275,9.0545417,-0.9124689,2.4691786,2.6934206,19.4479921,23.0575435,1.1759499,8.5606917,7.8763004,15.3143569,4.8223439,5.326857,0.9652517,16.4643234),(38824,'metacarpal.tif',235,5,71,11.1563001,8.2695715,9.0389766,1.8,8.3023198,9.0481297,-0.8761437,2.4260324,2.6133151,18.6504819,22.6669681,1.0974976,8.6736452,7.6876475,14.9462979,4.7361926,5.326857,1.2490458,16.3327557),(38825,'metacarpal.tif',235,5,72,10.9790571,8.2472435,9.023022,1.8,8.2755536,9.0341578,-0.8412352,2.3600532,2.577615,17.764322,22.141694,1.0168822,8.5899927,7.5270855,14.8060054,4.6056696,5.2792948,1.0595656,16.1081557),(38826,'metacarpal.tif',235,5,73,10.8253948,8.2266711,9.0160462,1.8,8.2598344,9.0385638,-0.8214406,2.3549721,2.5011149,17.1339479,21.6336348,0.9670888,8.6495966,7.275648,14.4203907,4.6056696,5.324489,1.088283,15.8563071),(38827,'metacarpal.tif',235,5,74,10.6789247,8.2053085,9.0022612,1.8,8.237029,9.0203268,-0.8219067,2.303731,2.5002247,16.5149439,21.1879882,0.9548313,8.4744335,7.1687814,14.2622983,4.5262615,5.2385275,1.0303768,15.7905233),(38828,'metacarpal.tif',235,5,75,10.5506459,8.1868749,8.9934154,1.8,8.2168439,9.0187476,-0.805102,2.3116339,2.4928114,16.0463554,20.8194656,0.9138596,8.3518012,6.9415643,13.6127626,4.5153666,5.2385275,1.0303768,15.8835557),(38829,'metacarpal.tif',235,5,76,10.384439,8.1666894,8.98162,1.8,8.1931059,9.0009414,-0.782243,2.2481062,2.4434325,15.4440208,20.4179716,0.8599092,8.3562658,6.8697915,13.1535473,4.4468534,5.1767745,1.1459642,15.7519881),(38830,'metacarpal.tif',235,5,77,10.2220382,8.1452995,8.9774645,1.8,8.1675784,8.9973206,-0.7841848,2.186468,2.4298928,14.8966809,20.1439094,0.8497694,8.2900404,6.8131254,13.4621915,4.3674453,5.1816445,1.048962,15.5931719),(38831,'metacarpal.tif',235,5,78,10.0416448,8.127131,8.9771521,1.8,8.1485062,8.9995054,-0.7672888,2.2020375,2.4280377,14.3735838,19.729948,0.8065024,8.125882,6.527402,13.4076502,4.3304681,5.1265906,1.0679531,15.5001395),(38832,'metacarpal.tif',235,5,79,9.901507,8.1075637,8.9765525,1.8,8.1192118,8.9940052,-0.7604778,2.1435038,2.4878689,13.8955725,19.4344409,0.7840177,7.8116821,6.4826441,13.0689796,4.2880372,5.1081075,0.9888912,15.4071071),(38833,'metacarpal.tif',235,5,80,9.8035337,8.0946092,8.9809351,1.8,8.1024342,9.0006083,-0.760189,2.1453561,2.4795177,13.5302751,19.1899857,0.7757887,7.7394026,6.3067735,12.9967743,4.2624787,5.1044028,0.8788749,15.3140747),(38834,'metacarpal.tif',235,5,81,9.6954314,8.0854254,8.9845372,1.8,8.0999098,8.9989967,-0.763765,2.0741672,2.4691659,13.1389037,19.0465346,0.7730063,7.7137523,6.3345443,12.7507854,4.1925703,5.1216683,0.9097532,15.2482909),(38835,'metacarpal.tif',235,5,82,9.6167191,8.0717907,8.989191,1.8,8.0854853,9.0040417,-0.7664745,2.0730854,2.4702505,12.8146333,18.912869,0.77107,7.6562554,6.1814305,12.5235878,4.1553445,5.1044028,0.8788749,15.3413233),(38836,'metacarpal.tif',235,5,83,9.5358486,8.0503449,8.9877257,1.8,8.0469284,8.9984009,-0.7596274,2.0204441,2.4429356,12.4230849,18.8249459,0.7537145,7.7058707,6.1486902,12.3030642,4.1135081,5.1081075,0.9888912,15.2097557),(38837,'metacarpal.tif',235,5,84,9.4463494,8.0409016,8.9852961,1.8,8.0433851,8.9909384,-0.7518404,2.0216597,2.4453805,12.0670889,18.7228128,0.7344024,7.6564006,5.968902,12.1576214,4.0498129,5.1081075,0.9888912,15.0509395),(38838,'metacarpal.tif',235,5,85,9.3732837,8.0284012,8.9880604,1.8,8.030693,8.9945323,-0.7449148,2.0161533,2.494175,11.7434942,18.7038451,0.7179323,7.4990107,5.824703,12.1224416,4.0435548,5.1216683,0.9097532,15.0236909),(38839,'metacarpal.tif',235,5,86,9.3112692,8.015324,8.992962,1.8,8.0196672,8.9998909,-0.7372146,1.9671378,2.4877064,11.4548864,18.6843902,0.7012798,7.5106896,5.8231236,11.9458382,3.9704048,5.1437816,0.9403949,14.9579071),(38840,'metacarpal.tif',235,5,87,9.2196806,7.9949716,8.9965324,1.8,7.9926749,8.9991891,-0.7219282,1.9625151,2.4797877,11.1902186,18.5937556,0.6710397,7.4981239,5.7019783,11.7712226,3.9704048,5.1437816,0.9403949,15.0509395),(38841,'metacarpal.tif',235,5,88,9.144828,7.9732963,9.0016596,1.8,7.9656218,9.0033171,-0.714983,1.9212613,2.4727182,10.9218388,18.5593839,0.6551009,7.5056608,5.6847234,11.6132772,3.8909967,5.1437816,0.9403949,14.9851556),(38842,'metacarpal.tif',235,5,89,9.0581488,7.9590229,9.0048528,1.8,7.9606078,9.0033417,-0.7092216,1.9179142,2.48497,10.7170203,18.5038466,0.640287,7.4463058,5.5878517,11.4641833,3.8909967,5.1437816,0.9403949,14.9851556),(38843,'metacarpal.tif',235,5,90,8.9706779,7.9384365,9.0053239,1.8,7.9351355,8.9979008,-0.7115718,1.9072211,2.5011311,10.4740393,18.5218522,0.6375783,7.4053903,5.4917803,11.3250228,3.8909967,5.1437816,0.6304014,14.8921233),(38844,'metacarpal.tif',235,5,91,8.9037013,7.9231309,9.0074925,1.8,7.9214979,9.0016354,-0.7124851,1.8926109,2.5142176,10.2506403,18.6231027,0.6341588,7.4071166,5.4161373,11.2187538,3.8610068,5.1767745,0.7086263,15.0509395),(38845,'metacarpal.tif',235,5,92,8.8508441,7.9051917,9.0103506,1.8,7.9010549,9.0066079,-0.7112561,1.8752782,2.5295665,10.0410033,18.7765017,0.6286007,7.422814,5.3544074,11.0973165,3.8115886,5.2107687,0.6478114,14.9851556),(38846,'metacarpal.tif',235,5,93,8.8116623,7.8902322,9.008074,1.8,7.8903655,8.9975158,-0.7121949,1.8633655,2.5394748,9.8681548,18.9830508,0.6271817,7.4751878,5.2958772,11.0397331,3.8109261,5.2349151,0.6177557,14.9851556),(38847,'metacarpal.tif',235,5,94,8.7679074,7.8727765,9.0069091,1.8,7.8718364,8.9949596,-0.7143777,1.8249339,2.5520347,9.680279,19.1749208,0.6272242,7.5135815,5.3044546,10.9622306,3.7321805,5.2637446,0.5880026,14.9193718),(38848,'metacarpal.tif',235,5,95,8.7397812,7.855976,9.0068229,1.8,7.8564643,8.9951569,-0.7146102,1.8247152,2.5646793,9.5281678,19.4573924,0.6255474,7.5866765,5.2217286,10.9127509,3.7321805,5.3007506,0.6350267,14.9851556),(38849,'metacarpal.tif',235,5,96,8.685464,7.8380368,9.0058706,1.8,7.8402909,8.9905339,-0.716417,1.8042089,2.5776425,9.3741543,19.6891035,0.6242496,7.638415,5.1957144,10.8786909,3.7200356,5.326857,0.6055447,15.078188),(38850,'metacarpal.tif',235,5,97,8.6746325,7.819019,9.008231,1.8,7.8274452,8.9917158,-0.717182,1.7935807,2.6565254,9.2654593,20.0748356,0.6245668,7.5568018,5.1659006,10.8875201,3.703815,5.4207296,0.6973908,15.2097557),(38851,'metacarpal.tif',235,5,98,8.6413339,7.794501,9.012072,1.8,7.8019725,8.996002,-0.7162489,1.7872369,2.6773074,9.1523288,20.3767433,0.620838,7.6109092,5.1209376,10.8856012,3.6527724,5.4578265,0.6393859,15.1439718),(38852,'metacarpal.tif',235,5,99,8.6073373,7.7701295,9.0167119,1.8,7.7727735,9.0036744,-0.7141936,1.777355,2.6982678,9.0418656,20.7215534,0.615476,7.6795762,5.0872591,10.7981618,3.6527724,5.4935253,0.7130608,15.302788),(38853,'metacarpal.tif',235,5,100,8.5768461,7.7502374,9.0215383,1.8,7.7600649,9.0097843,-0.7112736,1.7625281,2.7158018,8.9308682,21.0537326,0.6091657,7.7523082,5.0670784,10.8186847,3.6250308,5.5483477,0.6273082,15.302788),(38854,'metacarpal.tif',235,5,101,8.5547049,7.7228619,9.0269131,1.8,7.7302886,9.0141179,-0.7132052,1.7612456,2.751915,8.800771,21.4026661,0.6103178,7.7773717,4.9969015,10.8195262,3.5733643,5.6071338,0.5713375,15.302788),(38855,'metacarpal.tif',235,5,102,8.5403072,7.6982065,9.0306049,1.8,7.7098927,9.011651,-0.7082682,1.7637107,2.7727524,8.7499948,21.9228038,0.6023415,7.9065132,4.9611281,10.920379,3.5733643,5.668648,0.5880026,15.302788),(38856,'metacarpal.tif',235,5,103,8.5095273,7.6749436,9.0348227,1.8,7.6858659,9.0120755,-0.7041644,1.7502329,2.7929752,8.6866655,22.5102224,0.5944233,8.0595853,4.9631483,11.0149533,3.5733643,5.7052382,0.6316906,15.5546366),(38857,'metacarpal.tif',235,5,104,8.5315882,7.6567228,9.0369524,1.8,7.673674,9.0109669,-0.7017487,1.7465367,2.8673587,8.642671,23.0755515,0.592576,8.0476683,4.9484624,10.9772478,3.570199,5.8233807,0.6898,15.7792366),(38858,'metacarpal.tif',235,5,105,8.5532706,7.6364075,9.0417846,1.8,7.6650954,9.0118689,-0.697947,1.7543238,2.8987675,8.6361951,23.6044328,0.5887415,8.1429204,4.9228057,11.0929254,3.570199,5.8879912,0.6091635,15.872269),(38859,'metacarpal.tif',235,5,106,8.5342648,7.604426,9.0561213,1.8,7.6214745,9.0336352,-0.6978237,1.7638346,2.9324683,8.6252669,24.1635174,0.5872606,8.2399926,4.8900655,11.1048928,3.570199,5.9529597,0.6246354,15.9380528),(38860,'metacarpal.tif',235,5,107,8.5534865,7.5860546,9.0669038,1.8,7.6057624,9.0473976,-0.6982339,1.7675776,2.9535238,8.6350179,24.7509263,0.5891592,8.3801344,4.885227,11.2316154,3.570199,6.0193222,0.6397698,16.0038366),(38861,'metacarpal.tif',235,5,108,8.6112678,7.5692194,9.0708601,1.8,7.5838617,9.0509844,-0.700488,1.7765006,2.982681,8.677782,25.4334541,0.5963265,8.5270448,4.8847615,11.3407174,3.570199,6.0735515,0.5880026,16.096869),(38862,'metacarpal.tif',235,5,109,8.6604518,7.5603191,9.0708664,1.8,7.5779397,9.0503176,-0.7017801,1.7961502,3.0486478,8.7101664,26.1922465,0.6015711,8.5914307,4.8493531,11.3940926,3.5733643,6.1765003,0.6435011,16.2284366),(38863,'metacarpal.tif',235,5,110,8.7257671,7.5603187,9.0669913,1.8,7.5803641,9.0417418,-0.7054603,1.7876793,3.0594721,8.7688595,27.0042519,0.6113887,8.8264418,4.9051637,11.6261801,3.5618515,6.2293614,0.5930026,16.321469),(38864,'metacarpal.tif',235,5,111,8.7667586,7.56068,9.0698713,1.8,7.5656763,9.0594697,-0.7102992,1.7876347,3.0610935,8.8136487,27.7096798,0.6212463,9.0522161,4.9303411,11.862035,3.5618515,6.2667026,0.6327488,16.5733176),(38865,'metacarpal.tif',235,5,112,8.809822,7.5683649,9.0698309,1.8,7.5683262,9.0630472,-0.7148107,1.7736102,3.1288356,8.8265224,28.4993992,0.6308519,9.108628,4.9765854,11.9213976,3.5456123,6.3576087,0.6223029,16.6391014),(38866,'metacarpal.tif',235,5,113,8.905125,7.5694696,9.0775682,1.8,7.5603017,9.0719489,-0.7181912,1.8316531,3.1333295,8.8698733,29.3626939,0.6426461,9.3710839,4.8425508,12.065018,3.4771092,6.4237174,0.6365082,16.6391014),(38867,'metacarpal.tif',235,5,114,8.9626538,7.5597068,9.0927013,1.8,7.5293064,9.0856761,-0.7235144,1.7129375,3.1642552,8.8811892,30.0343571,0.6546832,9.4917618,5.1847714,12.1215271,3.4978169,6.4910958,0.6504214,16.8637014),(38868,'metacarpal.tif',235,5,115,9.0912637,7.5672732,9.0984312,1.8,7.5345232,9.0808708,-0.7242518,1.7038072,3.2401322,8.9644253,31.2002387,0.6651864,9.6293104,5.2614083,12.2675086,3.5002865,6.6295061,0.6773864,17.2471176),(38869,'metacarpal.tif',235,5,116,9.2270996,7.5776768,9.1154428,1.8,7.5355576,9.1147703,-0.7256195,1.6939843,3.2454682,9.1175444,32.4173128,0.6772131,9.9884858,5.3823077,12.5465343,3.5054543,6.6485018,0.6536359,17.34015),(38870,'metacarpal.tif',235,5,117,9.3868027,7.5886853,9.1226316,1.8,7.5346047,9.1289592,-0.7175589,1.7945246,3.3172682,9.3067508,33.7638324,0.6764266,10.1782039,5.186193,12.8921298,3.6282381,6.7173805,0.6669082,17.7235662),(38871,'metacarpal.tif',235,5,118,9.4759667,7.6098199,9.1207421,1.8,7.5615027,9.1177929,-0.7154044,1.7557215,3.4089666,9.401687,34.6543614,0.6794815,10.16565,5.3548851,12.868164,3.603353,6.8456964,0.7157436,17.9481662),(38872,'metacarpal.tif',235,5,119,9.5206841,7.6187927,9.1341416,1.8,7.5797983,9.1299363,-0.7180267,1.7190807,3.416758,9.5356348,35.4234452,0.6868098,10.3675606,5.5469385,13.0196826,3.5722859,6.8751087,0.6696389,17.9096309),(38873,'metacarpal.tif',235,5,120,9.555249,7.6134475,9.146835,1.8,7.600489,9.1168464,-0.7170355,1.7267945,3.4678311,9.5880246,35.8708559,0.6877393,10.3438877,5.552499,13.0721383,3.5805976,6.9951276,0.7399749,18.0411986),(38874,'metacarpal.tif',235,5,121,9.6037306,7.6047458,9.161305,1.8,7.6060514,9.1116876,-0.7123742,1.7283059,3.4645473,9.5925732,36.3839235,0.6838423,10.5017828,5.5502752,13.1798592,3.5895838,7.032886,0.6722472,18.3202957),(38875,'metacarpal.tif',235,5,122,9.7420214,7.5996122,9.1779919,1.8,7.5917088,9.1301455,-0.7155649,1.732627,3.5110008,9.6699491,37.1251189,0.6988172,10.5739419,5.5810911,13.3098122,3.5978956,7.0891464,0.7069081,18.2930471),(38876,'metacarpal.tif',235,5,123,9.7543361,7.5982508,9.1938129,1.8,7.5839562,9.164615,-0.7181369,1.7792653,3.5157278,9.8389424,37.9692212,0.7038427,10.7998183,5.5297783,13.5493326,3.6327124,7.1907089,0.6747409,18.5176471),(38877,'metacarpal.tif',235,5,124,9.7118835,7.5794459,9.2205157,1.8,7.5635123,9.2088379,-0.7224522,1.836505,3.5506481,10.0968413,38.4495797,0.7077053,10.8288906,5.4978566,13.6236042,3.7056454,7.2613917,0.6868176,18.6492148),(38878,'metacarpal.tif',235,5,125,9.7850405,7.5611748,9.2432176,1.8,7.5487276,9.2328488,-0.7189955,1.8616658,3.6396249,10.4050629,38.8681409,0.707446,10.6791613,5.5891143,13.4943807,3.7430272,7.3956184,0.7316864,18.9668472),(38879,'metacarpal.tif',235,5,126,9.9126021,7.5604357,9.2613416,1.8,7.546916,9.2568984,-0.7124785,1.9104773,3.6592255,10.7181171,39.6526424,0.7060062,10.8363485,5.6101778,13.7440481,3.8034996,7.4711161,0.7428706,19.0984148),(38880,'metacarpal.tif',235,5,127,10.0641848,7.5711891,9.2722043,1.8,7.5531775,9.2722931,-0.7098327,1.9066023,3.660592,10.9790662,40.422612,0.7124133,11.0426433,5.7584459,14.023731,3.8104689,7.4795514,0.7216549,19.0984148),(38881,'metacarpal.tif',235,5,128,10.3092662,7.5937801,9.2749676,1.8,7.578886,9.281578,-0.7107884,1.9631094,3.6757934,11.3600805,41.2869178,0.7313854,11.2321106,5.7867792,14.3122111,3.8834019,7.4913448,0.7004964,19.257231),(38882,'metacarpal.tif',235,5,129,10.5438979,7.6158223,9.2754442,1.8,7.6017235,9.291025,-0.7182849,2.0231759,3.6909216,11.6970045,42.1769067,0.7610728,11.4272019,5.7815063,14.5784921,3.9721143,7.4913448,0.7004964,19.5090796),(38883,'metacarpal.tif',235,5,130,10.73531,7.6367714,9.2904042,1.8,7.6180893,9.3142419,-0.7183991,2.00878,3.7074587,11.9710963,42.80316,0.7750917,11.5451481,5.9593864,14.7023781,3.9788339,7.5249384,0.6584254,19.5090796),(38884,'metacarpal.tif',235,5,131,10.9478921,7.6630988,9.3003865,1.8,7.6417686,9.3188026,-0.7132042,2.0572789,3.7226926,12.4161853,43.4086073,0.7810529,11.6605404,6.0352464,14.9214626,4.0656577,7.5249384,0.6584254,19.9197443),(38885,'metacarpal.tif',235,5,132,11.1013771,7.6736259,9.3082914,1.8,7.6454159,9.3311866,-0.7052265,2.0434505,3.7885091,12.6682361,43.9874679,0.7774136,11.6107593,6.1994338,14.9481564,4.0669328,7.5941712,0.670122,19.9855281),(38886,'metacarpal.tif',235,5,133,11.205184,7.672149,9.3238524,1.8,7.6562707,9.364102,-0.7090751,2.0330826,3.7889088,12.868911,44.4074014,0.7917825,11.720367,6.3297531,15.0711685,4.0669328,7.6140729,0.6494007,20.1715929),(38887,'metacarpal.tif',235,5,134,11.4341552,7.6723688,9.3551707,1.8,7.6800249,9.4153151,-0.7137611,2.0947504,3.8292999,13.2942365,45.0771046,0.8167946,11.7716308,6.3464537,15.238808,4.1566195,7.6825024,0.6610432,20.4619767),(38888,'metacarpal.tif',235,5,135,11.7282841,7.6791279,9.395295,1.8,7.6936547,9.4468377,-0.7131361,2.2918075,3.8816876,14.0925869,46.3627473,0.8365966,11.9439667,6.1491146,15.5736335,4.3679907,7.8078795,0.7039461,21.1630253),(38889,'metacarpal.tif',235,5,136,12.1658883,7.7145258,9.4554424,1.8,7.732552,9.4995356,-0.7092403,2.6242913,3.8815913,15.5130208,47.9131189,0.859999,12.3436794,5.9113182,16.3056902,4.7784157,7.840117,0.6635557,21.6780091),(38890,'metacarpal.tif',235,5,137,12.5198807,7.7391204,9.5099903,1.8,7.7532747,9.5571674,-0.6946462,2.6646874,3.926338,16.8318749,49.0554395,0.8549941,12.4939422,6.3166415,16.780809,4.9036622,7.9097798,0.6747409,21.8753606),(38891,'metacarpal.tif',235,5,138,12.9322687,7.7513241,9.5522419,1.8,7.7663347,9.5917094,-0.6851784,2.6953375,3.9248526,18.0736992,50.121577,0.8631211,12.7703081,6.7055421,17.3588458,5.0089579,7.9977791,0.6659692,21.8753606),(38892,'metacarpal.tif',235,5,139,13.4595896,7.7601566,9.595888,1.8,7.7877613,9.6176167,-0.6801599,2.671924,3.9590215,19.649488,51.9582838,0.8872945,13.1240217,7.3540595,18.0855067,5.0474484,8.0676437,0.6769149,21.9796797),(38893,'metacarpal.tif',235,5,140,14.1769482,7.7785645,9.6263895,1.8,7.8266787,9.6458256,-0.6811082,2.6724907,4.0261627,21.4154301,54.9236517,0.9367762,13.641687,8.0132851,18.9604937,5.0694337,8.1384582,0.6876713,22.1384959),(38894,'metacarpal.tif',235,5,141,14.825053,7.7786611,9.6357197,1.8,7.8330404,9.6756435,-0.6732846,2.9135386,4.049385,22.6591464,57.3547232,0.9607216,14.1638109,7.777191,19.7537443,5.1393421,8.1384582,0.6876713,22.2315283),(38895,'metacarpal.tif',235,5,142,15.3570596,7.7789716,9.6314058,1.8,7.8534865,9.6851697,-0.6585707,3.0421289,4.0475008,23.6134516,59.3206403,0.9586087,14.6561156,7.762147,20.4891211,5.1223461,8.1384582,0.6876713,22.2587768),(38896,'metacarpal.tif',235,5,143,15.8043945,7.7746463,9.6275405,1.8,7.8505921,9.6902123,-0.6472298,3.1659538,4.0488309,24.5699205,61.37448,0.9577027,15.1585684,7.7606692,21.0885509,5.1223461,8.1244999,0.707127,22.2587768),(38897,'metacarpal.tif',235,5,144,16.2793032,7.7950954,9.6162668,1.8,7.8856649,9.6901444,-0.6437667,3.1715655,4.0256884,25.8682787,63.2311171,0.9774501,15.7069081,8.1563124,21.798466,5.1771395,8.0863803,0.6573891,22.1384959),(38898,'metacarpal.tif',235,5,145,16.5724276,7.8174331,9.592533,1.8,7.9075021,9.6780462,-0.6436625,3.3351808,3.9935754,26.4000789,64.6419149,0.9947737,16.1864766,7.9156365,22.7970301,5.1796346,8.0418096,0.6267429,22.0727121),(38899,'metacarpal.tif',235,5,146,16.6867731,7.8419798,9.5858837,1.8,7.9253214,9.6877078,-0.6534332,3.5210887,3.8906543,26.6918852,64.7717111,1.0277989,16.6480252,7.5805774,23.5057862,5.1796346,7.9288894,0.6548321,21.9411444),(38900,'metacarpal.tif',235,5,147,16.611692,7.8577505,9.5859672,1.8,7.936452,9.6864758,-0.657776,2.7771776,3.8483287,25.9696181,64.0479285,1.0347951,16.6430502,9.3510831,23.3597745,5.1520564,7.840117,0.6635557,21.8753606),(38901,'metacarpal.tif',235,5,148,16.4984071,7.8755266,9.5978721,1.8,7.9426604,9.6953276,-0.6608429,2.766553,3.8895022,25.3907815,62.8191443,1.0359047,16.1509472,9.1777681,22.6778262,5.1306926,7.8078795,0.7039461,22.0999606),(38902,'metacarpal.tif',235,5,149,16.3381333,7.8825857,9.6211583,1.8,7.9286281,9.7164271,-0.6660575,2.7339617,3.8934799,24.7002087,61.9603076,1.0396206,15.9138634,9.0345849,21.9213469,5.1099596,7.8810285,0.8559878,23.1458901),(38903,'metacarpal.tif',235,5,150,16.0868494,7.8828688,9.6572686,1.8,7.9212613,9.7383257,-0.6714968,2.7052922,3.9103109,23.8969002,60.7975824,1.0378195,15.5480175,8.8333897,21.4738021,5.0739244,7.840117,0.9072406,23.2389225),(38904,'metacarpal.tif',235,5,151,15.6754746,7.8938769,9.6868929,1.8,7.9442668,9.7429095,-0.6718349,2.6752451,3.8984631,22.7946497,58.2834548,1.012141,14.950367,8.5205838,20.1844403,5.0168586,7.5316392,0.3500449,21.1357767),(38905,'metacarpal.tif',235,5,152,15.1488752,7.8881925,9.7201369,1.8,7.9407669,9.7586393,-0.674368,2.6175809,3.8581532,21.4201515,55.1389498,0.9843741,14.2915399,8.1831862,19.2031703,4.9416975,7.4262492,0.3552309,20.9769606),(38906,'metacarpal.tif',235,5,153,14.4680373,7.8876264,9.7504656,1.8,7.9426683,9.7741493,-0.665732,2.5408435,3.8173978,19.4435849,51.4597081,0.9198609,13.4803105,7.6524135,18.0670222,4.798163,7.403288,0.3889569,20.9111767),(38907,'metacarpal.tif',235,5,154,13.7274395,7.8962392,9.7831326,1.8,7.952161,9.7906297,-0.6574486,2.4884375,3.7800956,17.0532329,47.7492199,0.8544011,12.6317492,6.8529883,16.0059502,4.6405485,7.4711161,0.7428706,20.6978634),(38908,'metacarpal.tif',235,5,155,12.8965961,7.9040322,9.8239416,1.8,7.9594392,9.8105685,-0.65452,2.3820502,3.8252687,14.4812623,44.0926551,0.7966039,11.5266819,6.0793271,14.5960025,4.4810317,7.5542103,0.7328151,20.5117987),(38909,'metacarpal.tif',235,5,156,12.0095899,7.9049335,9.8716599,1.8,7.9581928,9.8401622,-0.6491961,2.2958504,3.870581,11.8566381,40.2502064,0.7315365,10.3990089,5.1643776,13.2386349,4.360646,7.5542103,0.7328151,20.6706149),(38910,'metacarpal.tif',235,5,157,10.9462701,7.882911,9.9456827,1.8,7.9282689,9.9216463,-0.6388203,2.1821085,3.5694142,9.2731469,35.5372148,0.6485896,9.9560356,4.2496268,11.1399291,4.1210069,7.1210956,0.6624263,19.7449663),(38911,'metacarpal.tif',235,5,158,9.7123752,7.8430087,10.034048,1.8,7.9027975,10.009369,-0.6231627,2.0559342,3.5882602,6.9164019,29.7438555,0.5513332,8.2892136,3.3641164,9.9719287,3.7770295,6.9852048,0.6370703,19.0166692),(38912,'metacarpal.tif',235,5,159,8.2948287,7.7645804,10.1594133,1.8,7.8457077,10.1093037,-0.6058326,1.8941921,4.4772413,4.9304383,22.8266539,0.4482934,5.0983747,2.6029241,6.1776706,3.4311186,6.8281728,0.633633,18.4471882),(38913,'metacarpal.tif',235,5,160,6.5537729,7.6351621,10.3573106,1.8,7.7197499,10.2877079,-0.563797,2.1063613,4.7074713,3.2520855,14.3377583,0.3119407,3.0457452,1.5439353,3.7149654,3.0024907,4.767132,0.2621198,13.435529),(38914,'metacarpal.tif',235,5,161,4.7304564,7.5195802,10.5508103,1.8,7.4532625,10.5791978,-0.3623727,1.2788299,2.4163026,1.5183204,6.238909,0.0990762,2.5820065,1.1872732,3.2096706,2.6382805,4.5505758,0.2749098,12.7231937),(38915,'metacarpal.tif',235,5,162,3.1956355,7.6592477,10.536607,1.8,7.5134591,10.593332,-0.350919,1.1065346,2.4565047,0.7315598,3.7303515,0.0629389,1.5185607,0.6611269,1.7882795,2.3352451,4.3041825,0.2639637,11.6659774),(38916,'metacarpal.tif',235,5,163,1.3831933,8.0967459,10.4133604,1.8,7.9577946,10.4603462,-0.2849804,0.8991338,2.287927,0.2369744,0.7950035,0.018221,0.3474776,0.2635585,0.4496534,1.6402899,2.2120536,2.7233683,5.8987725),(38917,'metacarpal.tif',235,5,164,0.3863296,8.3974223,10.3605431,1.8,8.3947558,10.3540606,0.7678311,0.4409244,0.6400176,0.0217146,0.0410695,0.0310633,0.0641693,0.0492479,0.0966952,1.0323052,1.4381418,2.2455373,3.8228753),(38918,'metacarpal.tif',235,5,165,7.6031391,9.6954962,11.3949055,1.8,9.6416113,11.3587973,-0.7712003,4.1145275,3.8798424,3.6579261,38.442994,0.6156059,9.9083906,0.889027,10.0876952,3.0967898,7.7356692,0.8779168,20.9609987),(38919,'metacarpal.tif',235,5,166,7.9273106,9.7104572,11.3588888,1.8,9.6761945,11.3186789,-0.7796133,4.0200722,3.8382306,3.7892478,38.6527365,0.6529663,10.0704571,0.942582,10.3464604,3.1113574,7.7519548,0.8983178,20.7636473),(38920,'metacarpal.tif',235,5,167,8.2175162,9.6970638,11.317686,1.8,9.6702268,11.2668157,-0.784722,3.9807314,3.8568706,4.1820421,38.6482471,0.6838669,10.0206232,1.0505713,10.6860546,3.1418011,7.7519548,0.8983178,20.8566796),(38921,'metacarpal.tif',235,5,168,8.5918609,9.666326,11.2722373,1.8,9.6375266,11.2118422,-0.7881731,3.9283522,3.8672652,4.9498322,38.5941411,0.719962,9.9796987,1.2600276,10.9882767,3.1265793,7.722616,0.8574382,20.725112),(38922,'metacarpal.tif',235,5,169,8.9508907,9.6274025,11.2017469,1.8,9.6013143,11.1150949,-0.7974174,3.7812779,3.8122044,5.8330161,38.6054617,0.7638364,10.1268079,1.5426045,11.4287602,2.9343154,7.6496008,0.8685394,20.1443443),(38923,'metacarpal.tif',235,5,170,9.2489045,9.5862768,11.1211117,1.8,9.567474,11.0251849,-0.7916298,3.6900487,3.8397199,6.4594322,38.1616684,0.7803477,9.9386595,1.7505005,11.5938717,2.9049817,7.664424,0.8891905,19.8267119),(38924,'metacarpal.tif',235,5,171,9.6334583,9.5430387,11.0442425,1.8,9.5184123,10.957261,-0.7902053,3.601579,3.8627675,7.2114268,37.8614027,0.8105063,9.8016262,2.0022959,11.6538548,3.0378141,7.6496008,0.8685394,19.2844795),(38925,'metacarpal.tif',235,5,172,10.1953022,9.5109691,11.0020058,1.8,9.4852047,10.9503416,-0.7858697,3.4675768,3.7898086,8.1830526,38.5305807,0.8504098,10.1668937,2.3598764,12.2196046,3.1647532,7.5775464,0.8798531,19.3117281),(38926,'metacarpal.tif',235,5,173,10.8874622,9.4580089,10.9660621,1.8,9.4253752,10.9379245,-0.7933022,3.4864421,3.7806407,9.5568838,39.9805109,0.9216305,10.5750624,2.7411566,13.0380942,3.404327,7.5642203,0.8589495,19.5363281),(38927,'tibia.tif',235,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38928,'tibia.tif',235,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38929,'tibia.tif',235,8,3,1.5453192,70.8527583,106.8007853,1.8,70.9878784,106.8840292,0.3845966,1.3617251,2.9178538,0.4934379,2.8307806,0.0362542,0.9701585,0.3623624,1.1059523,2.7533461,5.9754186,2.9441971,14.2168809),(38930,'tibia.tif',235,8,4,15.7915992,70.424827,107.5363538,1.8,70.826953,107.6428684,0.1446516,2.947403,5.7062443,30.8035489,105.4028222,0.0546877,18.4714878,10.4510816,23.5707198,6.152349,11.7516728,0.0748598,29.3923791),(38931,'tibia.tif',235,8,5,33.5366821,69.4936406,107.7267039,1.8,69.7121186,107.7803944,0.0781685,3.6433587,7.8557887,108.4507684,439.4303087,0.0340837,55.9371346,29.766701,68.0388873,7.324225,15.8447213,0.0554985,39.8092872),(38932,'tibia.tif',235,8,6,94.8257764,63.6610771,108.081568,1.8,62.2270783,108.0712739,0.1971416,14.7506824,16.5702069,1982.7484623,5421.9257466,0.6063148,327.2092976,134.4174055,446.6932072,14.3626138,31.074055,2.9996956,89.2312339),(38933,'tibia.tif',235,8,7,225.0039993,62.4531264,107.0192593,1.8,62.9413954,106.8959975,0.5858925,16.85768,17.7677805,10246.2951621,15862.9283415,11.4656865,892.7917756,607.8116999,1291.9709964,28.0859631,36.2110158,2.2126793,119.795489),(38934,'tibia.tif',235,8,8,252.3605232,63.8540096,107.4361951,1.8,64.1854694,107.331612,0.6258138,18.4534296,20.0774359,15491.3190256,22957.1508979,14.4312924,1143.4304168,839.4818377,1840.974464,30.7915998,39.8534766,2.4760363,132.6688766),(38935,'tibia.tif',235,8,9,269.7351031,66.1497136,108.0145036,1.8,65.8609067,107.5804458,0.5402002,19.2470985,22.5611372,18810.7032412,29879.4921257,11.8913822,1324.3788161,977.3266971,2134.0147743,32.3170172,42.0091395,2.5497216,130.6267178),(38936,'tibia.tif',235,8,10,256.3358173,66.8962862,107.6439789,1.8,66.7712308,107.5204879,0.3321399,19.4921468,23.5810379,18592.818982,30323.8730436,4.542249,1285.9431026,953.8620441,2073.557563,33.2412737,42.581409,2.566948,130.7688902),(38937,'tibia.tif',235,8,11,279.6516076,67.0977384,108.3394475,1.8,67.3542103,107.5194418,0.3281273,20.5413839,24.0814791,20694.3677472,31398.3237993,4.8406991,1303.8370135,1007.4475906,2162.2337043,34.084346,42.7152419,2.5022067,132.8699388),(38938,'tibia.tif',235,8,12,321.1699332,67.5926319,108.1493056,1.8,67.879355,107.7619626,0.2539495,20.2316748,24.4671692,21621.4425382,32770.545304,3.3784873,1339.3680735,1068.6926668,2211.7974881,34.4986509,42.9177087,2.580099,135.6696528),(38939,'tibia.tif',235,8,13,276.0990433,67.7125166,107.5491582,1.8,67.9912296,107.9901039,0.1264916,18.613161,24.1774039,19513.5846548,28655.6893727,0.7323521,1185.2260673,1048.375644,1965.0410564,34.4966288,42.8226084,2.5460001,135.5274804),(38940,'tibia.tif',235,8,14,226.1808181,68.2721654,108.0616576,1.8,67.8059365,108.1955861,-0.0100309,17.1405885,23.9684262,15375.2155632,20500.4596909,0.0037927,855.3110465,897.0062826,1434.4449701,33.2436061,41.8032989,2.5963655,138.1261324),(38941,'tibia.tif',235,8,15,170.3819842,67.1072891,109.4510534,1.8,66.4686025,109.1727479,0.3480038,17.3514845,24.0793453,9429.4522032,13074.4255165,3.3024568,542.9726322,543.4377805,934.5469486,28.9202807,40.4679173,2.5415424,120.1387236),(38942,'tibia.tif',235,8,16,150.5022103,65.5407742,109.6804625,1.8,65.234302,109.4240903,0.4053515,17.677485,22.5470278,7147.2663968,12647.5712644,3.9006524,560.9418407,404.3146628,877.9355053,27.9145965,38.7893611,2.5934013,116.7947128),(38943,'tibia.tif',235,8,17,139.3522127,64.0713289,109.702745,1.8,64.2205024,109.7046241,0.4126149,16.7652144,21.2427252,5482.4651222,13402.668854,3.7347768,630.9298245,327.0143169,888.9772343,26.1231879,37.7839156,2.549289,109.2658534),(38944,'tibia.tif',235,8,18,134.6069379,63.1252576,109.6343259,1.8,63.6296801,109.8838008,0.4146714,16.018631,20.3488135,4696.6896848,13852.7684195,3.6415602,680.7654112,293.2016912,911.5682219,24.9388895,36.9861034,2.5250264,105.7796703),(38945,'tibia.tif',235,8,19,129.7430345,62.6756259,109.672923,1.8,63.2295234,110.0791274,0.4207449,15.3454414,20.0739023,4169.469768,13604.5669684,3.6073668,677.7240787,271.7073851,885.2195594,24.0071099,36.7276109,2.5491653,103.7791528),(38946,'tibia.tif',235,8,20,124.3927044,62.4559093,109.8007325,1.8,62.9189912,110.2400396,0.4255481,14.9234602,19.9284153,3737.2496776,13031.2519383,3.5331762,653.9030682,250.4278242,840.9566864,23.3005944,36.4095763,2.5335035,102.6072768),(38947,'tibia.tif',235,8,21,120.3697352,62.3336258,109.9418403,1.8,62.7107424,110.395087,0.4267122,14.4541501,19.9003144,3421.7311811,12460.3824674,3.4364895,626.1399806,236.7300149,798.0810645,22.5979475,36.0363779,2.5062214,100.2218835),(38948,'tibia.tif',235,8,22,117.5624426,62.2638521,109.9968058,1.8,62.6055953,110.4451613,0.4223906,14.122046,19.9789053,3168.3410498,11947.4779457,3.2927786,598.0046341,224.3542509,756.3691674,22.1887277,35.7614239,2.5308667,99.292711),(38949,'tibia.tif',235,8,23,115.2350225,62.2146446,110.1019048,1.8,62.5343235,110.5084496,0.4184343,13.6813374,19.9745861,2977.9757442,11462.0672567,3.1709675,573.8325302,217.667006,722.3868297,21.6181218,35.5218117,2.526137,97.3927246),(38950,'tibia.tif',235,8,24,112.0625328,62.0779113,110.12532,1.8,62.293929,110.5180504,0.4124487,13.3376119,19.9717343,2806.7364766,11089.0055298,3.0011069,555.2349822,210.4377084,694.6378353,21.208902,35.353481,2.5329033,96.3924658),(38951,'tibia.tif',235,8,25,108.3421042,61.9051476,110.0876292,1.8,62.0812253,110.4513881,0.4039426,13.0524087,19.7876332,2623.7509156,10685.8217594,2.7895505,540.0252595,201.0166077,671.0745287,20.8772445,35.0217451,2.5466296,95.3922071),(38952,'tibia.tif',235,8,26,107.2469548,61.7353748,110.1288723,1.8,62.0368209,110.5488912,0.3983794,12.738395,19.6820979,2492.043354,10464.5747165,2.6898591,531.6798432,195.6324452,657.6009029,20.4352433,34.7795048,2.5419083,94.3919484),(38953,'tibia.tif',235,8,27,107.0032212,61.6739741,110.2104979,1.8,61.9623025,110.6759178,0.3940399,12.3818884,19.6526312,2402.1895091,10233.1076069,2.6286414,520.6991112,194.0083315,641.8968514,20.12835,34.5380507,2.537121,93.5633069),(38954,'tibia.tif',235,8,28,105.9871922,61.6231446,110.2702276,1.8,61.8725171,110.6816135,0.3898123,12.0455013,19.6235352,2318.5671681,10072.5925874,2.5509568,513.2914382,192.484075,630.1742708,19.7197114,34.2911423,2.5630684,91.906024),(38955,'tibia.tif',235,8,29,105.14051,61.5764101,110.3330749,1.8,61.7759816,110.6757678,0.3827357,11.8020342,19.4849305,2254.2131236,9807.329714,2.4440283,503.3289545,191.0020838,617.8696276,19.5048659,33.9654568,2.5464131,91.320086),(38956,'tibia.tif',235,8,30,106.2039801,61.5881428,110.4601806,1.8,61.8249068,110.8022049,0.3771807,11.7695998,19.3712712,2220.5310131,9587.5002447,2.401015,494.9339739,188.6666542,606.9741645,19.3410397,33.6493741,2.5294402,90.0060376),(38957,'tibia.tif',235,8,31,105.8293675,61.5532335,110.5464513,1.8,61.7753573,110.8476648,0.3684755,11.5313434,19.1423998,2190.87367,9391.6621331,2.2883749,490.620937,189.9929251,603.2073728,19.1829275,33.1663682,2.5829933,89.0057788),(38958,'tibia.tif',235,8,32,106.0064911,61.5753773,110.6339197,1.8,61.7087929,110.884372,0.3556407,11.3445011,18.9686846,2173.0655396,9101.135458,2.1419848,479.797922,191.5523228,593.0163332,19.017065,32.7457573,2.5535901,88.2482236),(38959,'tibia.tif',235,8,33,104.6563201,61.6780508,110.7474666,1.8,61.8197826,110.9589313,0.3473136,11.3551875,18.8171088,2112.2647104,8737.2855727,2.0208057,464.3266744,186.0175987,574.4893417,18.9379669,32.2665156,2.5762562,87.6622856),(38960,'tibia.tif',235,8,34,104.1862272,61.7201439,110.8302314,1.8,61.8675019,111.0188577,0.336771,11.1625919,18.4928841,2085.6694246,8459.717624,1.8960402,457.457992,186.8445469,567.8760604,18.8623728,31.862315,2.5790947,86.3482372),(38961,'tibia.tif',235,8,35,103.5525355,61.7435462,110.9596102,1.8,61.9255801,111.1781476,0.3310913,11.138305,18.3567066,2057.4732307,8218.3074664,1.8238,447.7005406,184.720497,558.2649447,18.7797705,31.527875,2.5613219,85.7622992),(38962,'tibia.tif',235,8,36,102.9463097,61.8118549,111.0477592,1.8,61.9956915,111.2193957,0.3220869,10.9480417,18.0658204,2023.1840521,7976.1376451,1.7192364,441.5043149,184.7987161,551.8466362,18.457047,30.9633723,2.5719607,84.519337),(38963,'tibia.tif',235,8,37,102.3056216,61.8293161,111.098592,1.8,62.0667589,111.2610416,0.3126994,10.9175314,17.8054009,2009.0365662,7842.2850059,1.6136174,440.4441689,184.0193075,550.773742,18.457047,30.6513347,2.5880592,84.1761024),(38964,'tibia.tif',235,8,38,103.4468075,61.828876,111.1810913,1.8,62.194145,111.3494625,0.3072672,10.8648914,17.8204387,2010.274087,7786.1287084,1.5772017,436.9212695,185.0247748,546.7105299,18.4307782,30.5994866,2.6093831,84.1050162),(38965,'tibia.tif',235,8,39,104.0146435,61.8421587,111.2795045,1.8,62.1026799,111.4477758,0.3004929,10.9031997,17.5693036,2015.7050902,7687.0516464,1.5187998,437.527395,184.8728028,548.0819724,18.4282216,30.2482512,2.5912067,83.5190782),(38966,'tibia.tif',235,8,40,105.5740598,61.8345447,111.3627793,1.8,62.0066163,111.4633584,0.2919042,10.9191567,17.3980502,2033.1013935,7651.892305,1.4571901,439.8132094,186.1958259,553.5702244,18.3928797,29.9459607,2.6078845,83.1047575),(38967,'tibia.tif',235,8,41,105.3858041,61.9153625,111.3790861,1.8,62.0572765,111.4359743,0.2837258,10.8487458,17.3825262,2019.3321483,7502.6702896,1.3763967,431.6213998,186.135079,545.1962895,18.1204074,29.764843,2.6383182,82.9331402),(38968,'tibia.tif',235,8,42,104.7017324,61.9525677,111.4380253,1.8,62.0924053,111.494223,0.27556,10.9116527,17.1380024,2005.1053367,7340.1296039,1.2918577,428.2955173,183.7581701,541.7391407,18.0721501,29.3978006,2.6199744,82.3472022),(38969,'tibia.tif',235,8,43,104.5705152,61.9974365,111.5089622,1.8,62.1458869,111.5664357,0.2686916,10.9126668,17.1084088,1993.0859772,7187.8911941,1.2282579,420.1379143,182.6396812,533.498516,0.292969,0.4143207,2.3561945,0.8286415),(38970,'tibia.tif',235,8,44,105.3233557,62.0868957,111.5900876,1.8,62.2228186,111.6149473,0.2585973,10.9613159,16.9127852,2010.9060119,7061.1279953,1.1479392,417.5023758,183.4548003,532.0749897,18.0011894,28.9980118,2.6236997,81.5185608),(38971,'tibia.tif',235,8,45,106.0771585,62.2334354,111.6940123,1.8,62.3755962,111.7327274,0.2436606,10.9010795,16.4081856,2028.1312399,6802.2621321,1.0290334,414.565163,186.0486609,536.3376023,17.9359029,28.199693,2.6314669,80.3466848),(38972,'tibia.tif',235,8,46,105.7876225,62.3499461,111.7663871,1.8,62.4888403,111.8336116,0.2306907,10.8359172,16.085707,2037.5735704,6567.5211446,0.9217769,408.2830265,188.0388653,530.49822,17.9012095,27.8011991,2.6355177,79.5180433),(38973,'tibia.tif',235,8,47,105.7824206,62.5115314,111.8577981,1.8,62.7364276,111.9590016,0.2178225,10.7819991,15.8223465,2049.930197,6316.5407591,0.8233569,399.2164344,190.125242,525.2309614,17.8195845,27.3859423,2.663592,78.6183156),(38974,'tibia.tif',235,8,48,105.2725595,62.6897609,111.9528537,1.8,62.9292477,112.0535822,0.2036922,11.0075389,15.5830831,2068.4495823,6051.2053688,0.7179561,388.3188795,187.9120854,518.3064101,17.9559411,26.8670304,2.6535596,78.0323776),(38975,'tibia.tif',235,8,49,104.5283801,62.8970944,112.0215753,1.8,63.072294,112.0980486,0.1926763,11.0003638,15.2059942,2073.951166,5769.3409457,0.6387905,379.4122806,188.5347802,511.7449172,17.9233764,26.3509289,2.6431332,77.4464396),(38976,'tibia.tif',235,8,50,104.7098733,63.036692,112.0891225,1.8,63.2092136,112.1568534,0.1780134,10.9178655,14.9334855,2083.8647645,5553.4300094,0.5472045,371.8776835,190.8674144,508.296086,17.8546787,25.8228534,2.7083925,76.6888844),(38977,'tibia.tif',235,8,51,105.6173393,63.1648714,112.1564745,1.8,63.3496998,112.1956594,0.1646087,10.8496573,14.4693802,2103.9728251,5394.2152515,0.472676,372.8020956,193.9206717,513.3308174,17.7347119,25.5152285,0.2672591,75.4459222),(38978,'tibia.tif',235,8,52,106.8007645,63.2587728,112.2342414,1.8,63.3803223,112.224016,0.1556514,10.8361327,14.1754468,2124.2371225,5276.9117242,0.4277784,372.2571717,196.0327712,518.5743961,17.731109,25.232779,0.2703253,74.8599842),(38979,'tibia.tif',235,8,53,107.4598672,63.3384158,112.2863568,1.8,63.4585064,112.2891806,0.1478682,10.8101986,13.9156282,2144.6599,5157.2617746,0.3887558,370.6093385,198.3922758,521.4545672,17.6080547,25.0312823,0.2847304,74.20296),(38980,'tibia.tif',235,8,54,107.8587205,63.420734,112.3240503,1.8,63.547601,112.3085936,0.1360706,10.7762355,13.6131623,2157.5282818,5032.4155836,0.3307888,369.6727828,200.2116859,518.3504199,17.5445138,24.8350635,0.2993662,73.7886393),(38981,'tibia.tif',235,8,55,109.0531736,63.5300294,112.3696953,1.8,63.6654283,112.3244277,0.1209117,10.9302352,13.3810747,2192.6820365,4950.9021142,0.2644273,369.9928619,200.6070319,516.7980235,17.6268196,24.6442486,0.3142319,73.617022),(38982,'tibia.tif',235,8,56,109.7241367,63.6461566,112.3993918,1.8,63.7228657,112.3866886,0.103302,10.8274214,13.185138,2226.5814041,4837.7618295,0.1944566,366.9102167,205.6428132,505.8648801,17.556178,24.4835159,0.3671738,72.9599978),(38983,'tibia.tif',235,8,57,108.6252159,63.797425,112.361465,1.8,63.8208697,112.2962601,0.0864808,10.8932603,12.9380643,2218.6726082,4652.1869584,0.1350629,359.5736476,203.6738813,496.4777859,17.5674747,24.458964,0.3293262,72.8594667),(38984,'tibia.tif',235,8,58,108.3161209,63.887167,112.375174,1.8,63.920183,112.2699676,0.070415,10.7826984,12.742434,2222.4402019,4520.8372881,0.0893623,354.786007,206.1116918,482.0546228,17.4977601,24.3181918,0.3827435,72.2024425),(38985,'tibia.tif',235,8,59,109.0181911,63.9617952,112.3996484,1.8,63.9996279,112.2702887,0.0609783,10.7180057,12.5129141,2226.4891027,4429.9621966,0.0674777,354.0312169,207.7335238,476.9923872,17.4899274,24.210303,0.3715179,71.7881218),(38986,'tibia.tif',235,8,60,109.4822238,64.0941059,112.4172164,1.8,64.1493867,112.2784821,0.044679,10.8621557,12.3142742,2243.7421241,4326.8072178,0.0364007,351.3651844,206.5650854,466.7102288,17.3838574,24.1588426,0.3985224,71.6165045),(38987,'tibia.tif',235,8,61,110.0957582,64.2178424,112.429264,1.8,64.2950248,112.2856387,0.0248861,10.7046576,12.1221815,2256.7915229,4235.7656395,0.0113617,349.4227195,210.8233256,463.0916134,17.3373186,24.1250677,0.4256225,70.9594803),(38988,'tibia.tif',235,8,62,110.1085808,64.2964899,112.4391747,1.8,64.3318781,112.2905487,0.0114951,10.5914679,11.8804965,2254.6281612,4121.4606658,0.0024248,346.9098006,212.8721131,456.2392464,17.3141779,23.8585435,0.4306925,70.3735423),(38989,'tibia.tif',235,8,63,109.9966106,64.3688909,112.4519677,1.8,64.3820909,112.3262415,0.0002912,10.5014241,11.6351388,2255.4113644,4028.3419266,0.0000015,346.2220774,214.7719534,450.8620766,17.2365916,23.7178265,0.4470745,69.9592216),(38990,'tibia.tif',235,8,64,109.9289343,64.4684573,112.4506089,1.8,64.4867679,112.2907267,-0.0148595,10.3745751,11.7247708,2256.256523,3937.6250799,0.0040452,335.838129,217.4794139,446.5382467,17.1683473,23.5926464,0.435877,69.7876043),(38991,'tibia.tif',235,8,65,108.4709805,64.6182942,112.4202945,1.8,64.6559825,112.2330535,-0.029756,10.5074283,11.5707158,2231.3819099,3799.1267923,0.0160023,328.3398234,212.3623254,437.3249683,17.0854513,23.3347556,0.4973427,69.2016663),(38992,'tibia.tif',235,8,66,107.8608533,64.728968,112.4177978,1.8,64.8010807,112.2174888,-0.0449601,10.39039,11.3876127,2222.3865646,3696.3909401,0.036314,324.5975293,213.8886568,431.4406917,17.0897656,23.1130075,0.5317241,69.0300491),(38993,'tibia.tif',235,8,67,107.1051258,64.8443853,112.4183731,1.8,64.9350969,112.2296412,-0.0603758,10.5419212,11.2155257,2221.7665004,3596.8490494,0.0649915,320.7026722,210.7553705,424.573832,17.1021393,23.0125238,0.5491529,68.6157283),(38994,'tibia.tif',235,8,68,106.9853008,64.9561611,112.4185509,1.8,65.0025327,112.2554769,-0.0770963,10.4253848,11.292857,2230.978887,3522.1826899,0.105774,311.8947398,213.9948714,421.8188171,17.0908748,22.8609701,0.5382217,68.4441111),(38995,'tibia.tif',235,8,69,107.0894162,65.0618575,112.4183537,1.8,65.0948172,112.2663348,-0.0923238,10.3308718,11.1155881,2241.6917655,3457.5149488,0.1517009,311.0510152,216.9896031,412.335073,17.0663327,22.6099194,0.5448639,68.2014076),(38996,'tibia.tif',235,8,70,107.4193707,65.149256,112.3940726,1.8,65.1958395,112.2334927,-0.1111147,10.1588547,10.9267063,2254.0263852,3412.0035139,0.2201337,312.2627642,221.8780032,414.2449693,17.0313047,22.6724694,0.5736667,67.3016799),(38997,'tibia.tif',235,8,71,107.8050893,65.2580936,112.3568093,1.8,65.2973559,112.1622161,-0.140082,10.1390159,10.9705087,2273.1427653,3368.7366631,0.3502758,307.0720558,224.1975728,415.3421743,17.0284273,22.5148154,0.5627372,67.5443834),(38998,'tibia.tif',235,8,72,108.1917962,65.3601571,112.3347447,1.8,65.3715629,112.1924559,-0.1610395,9.9918214,10.8007937,2284.2907687,3324.4360843,0.4636073,307.7955372,228.6160525,413.040745,17.0339804,22.4269635,0.5807564,66.9584454),(38999,'tibia.tif',235,8,73,107.077712,65.520746,112.2587326,1.8,65.5604283,112.0477022,-0.1825709,9.8094047,10.9732785,2261.4077245,3230.2129383,0.5882748,294.3708155,230.5346541,409.0094272,17.086145,22.1826098,0.5880026,66.7157419),(39000,'tibia.tif',235,8,74,106.9904506,65.6403417,112.2238599,1.8,65.6656164,112.027523,-0.2072219,9.5880961,10.67974,2261.0151156,3173.2974881,0.754814,297.1324652,235.8148158,407.6245905,16.8717842,22.0350864,0.6248862,66.1298039),(39001,'tibia.tif',235,8,75,107.3069583,65.7516021,112.1811686,1.8,65.7973907,111.9697685,-0.2373919,9.3093918,10.6870787,2272.6301703,3143.4200633,0.9890874,294.1327715,244.1223027,409.2173681,16.8717842,21.9570444,0.5472844,65.9581867),(39002,'tibia.tif',235,8,76,107.5436173,65.8609316,112.1531692,1.8,65.9019278,111.9707909,-0.2641231,9.2164985,10.3464359,2280.7269763,3108.1893436,1.2215849,300.4115988,247.4613296,409.7283843,16.8344187,21.7390105,0.6515872,66.9584454),(39003,'tibia.tif',235,8,77,107.3591591,65.9565564,112.1356173,1.8,65.9741317,111.9905461,-0.271771,9.2791066,10.4381023,2280.6623402,3071.6230635,1.2893633,294.2702598,245.7846895,413.8757905,16.8344187,21.4568544,0.610726,65.1295452),(39004,'tibia.tif',235,8,78,107.1090012,66.0485748,112.1214867,1.8,66.1150005,111.9490785,-0.2794025,9.2609294,10.6445466,2277.5731001,3022.9392858,1.3577022,283.9894822,245.9335351,401.1349533,16.8442697,21.2316637,0.6876713,65.058459),(39005,'tibia.tif',235,8,79,107.4641848,66.118882,112.1186888,1.8,66.1769136,111.9786509,-0.269577,9.2165266,11.1413948,2276.0224867,2991.2825947,1.2703757,268.4836733,246.9501336,382.7854734,16.8278648,20.9795263,0.6267429,64.3009037),(39006,'tibia.tif',235,8,80,107.4574484,66.1983446,112.0904512,1.8,66.2145763,111.954965,-0.2695492,9.2106945,10.058568,2268.7703232,2937.7925793,1.2700409,292.0686701,246.3191381,412.4371751,16.6928221,20.8193592,0.6857295,63.6438795),(39007,'tibia.tif',235,8,81,106.6470492,66.3521981,112.0283089,1.8,66.421895,111.8467614,-0.2735993,9.3627541,9.9330327,2241.9832258,2856.0205512,1.2976686,287.5275506,239.4576645,408.0047567,16.7574204,20.635086,0.6747409,63.7149657),(39008,'tibia.tif',235,8,82,106.4977296,66.4340382,111.9971702,1.8,66.5012861,111.7948884,-0.2776735,9.4018103,9.9317618,2227.3083938,2799.4458905,1.3337284,281.8680045,236.9020766,393.217746,16.7584921,20.2742168,0.6521714,62.8863243),(39009,'tibia.tif',235,8,83,106.1224928,66.5183293,111.9516542,1.8,66.5718588,111.7524941,-0.2880679,9.2991685,10.46304,2205.2646977,2746.0201738,1.4275764,262.4495527,237.1464383,366.4312509,16.6412553,20.180865,0.6928795,62.8863243),(39010,'tibia.tif',235,8,84,106.1005669,66.592856,111.9109986,1.8,66.6004651,111.7109164,-0.2872169,9.3710328,9.8050393,2196.3695819,2706.8715423,1.4190947,276.0694228,234.3786048,403.3207109,16.6774437,19.9563292,0.7022569,62.3003863),(39011,'tibia.tif',235,8,85,106.2033558,66.6746938,111.8657849,1.8,66.67944,111.7106777,-0.3124948,9.1590165,9.6558666,2197.1892052,2676.5328911,1.6729753,277.1924045,239.8935749,393.5652179,16.5809354,19.9046511,0.7437556,62.2293001),(39012,'tibia.tif',235,8,86,106.5555744,66.744152,111.7849269,1.8,66.7428713,111.6152163,-0.3278723,9.0796045,9.6106602,2198.6276556,2646.1259461,1.8416875,275.3323796,242.1501584,386.7240101,16.583873,19.6026694,1.4056476,61.4717448),(39013,'tibia.tif',235,8,87,106.9764576,66.8049006,111.7223001,1.8,66.8011084,111.5501896,-0.3223151,9.080854,9.5168582,2198.639001,2620.275354,1.7889843,275.3298723,242.1180878,404.9611563,16.533216,19.4906972,0.7428706,60.8147206),(39014,'tibia.tif',235,8,88,107.5903821,66.8768139,111.6588779,1.8,66.8713686,111.4972821,-0.3502409,8.9377551,9.4447094,2203.7689718,2599.9609336,2.1111771,275.282259,246.5685108,385.6014298,16.502599,19.3647855,1.3882365,60.6431033),(39015,'tibia.tif',235,8,89,107.2792584,67.0015001,111.5348688,1.8,66.9873844,111.3351346,-0.3589601,8.8020327,9.3464099,2184.2654143,2541.3312613,2.206596,271.9045364,248.1546567,384.5450571,16.4058777,19.2246606,1.4332096,60.2998688),(39016,'tibia.tif',235,8,90,107.4518044,67.0602501,111.447083,1.8,67.0602032,111.2484814,-0.3672748,8.7866237,9.3260729,2179.4772346,2505.6793459,2.3090257,268.6746484,248.0449033,384.5477966,16.4728726,19.0767592,0.7419473,59.8144619),(39017,'tibia.tif',235,8,91,107.9934749,67.1306858,111.3433414,1.8,67.1435287,111.1366294,-0.379325,8.6329754,9.3160217,2178.1202225,2474.7305376,2.4679626,265.6424178,252.3023768,385.8504278,16.3831972,18.9775178,1.4157996,60.1282515),(39018,'tibia.tif',235,8,92,108.8209622,67.2066776,111.2627927,1.8,67.2224032,111.0775639,-0.3926327,8.6075869,9.1308298,2185.5907676,2448.6654351,2.6552252,268.175564,253.9144586,392.2838365,16.3983212,18.7888857,1.3825748,59.0569066),(39019,'tibia.tif',235,8,93,109.3159981,67.2639596,111.2039386,1.8,67.2229358,111.0318886,-0.3813133,8.6485368,9.0736458,2189.8637967,2426.2922899,2.5231594,267.3999345,253.2062773,393.3695383,16.3157189,18.736278,1.3979357,59.0569066),(39020,'tibia.tif',235,8,94,110.5213751,67.346366,111.1217937,1.8,67.3414993,110.9654196,-0.4010998,8.5979998,9.3557669,2197.4808633,2407.5803992,2.8079137,257.3365091,255.580473,391.6686665,16.3157189,18.6052616,1.4444882,58.2993513),(39021,'tibia.tif',235,8,95,110.6958458,67.4058368,111.0816329,1.8,67.3641414,110.9436889,-0.3287022,8.9996563,9.0754439,2193.1395382,2375.3170702,1.9225934,261.7301243,243.6914774,420.0361593,16.2496749,18.3988264,1.4108832,58.2993513),(39022,'tibia.tif',235,8,96,110.9291236,67.4654363,111.0261963,1.8,67.42149,110.8727754,-0.2612885,9.3130064,9.1586041,2190.4692156,2348.1718047,1.2337553,256.3897047,235.2053798,420.0589755,16.174171,18.3544552,1.4266419,57.9561168),(39023,'tibia.tif',235,8,97,110.8153847,67.5876228,110.9358092,1.8,67.5776099,110.7375567,-0.1651056,9.664824,9.2731473,2163.7373508,2299.1948134,0.4989106,247.94115,223.8775736,417.8540618,16.1609318,18.1096554,1.4083072,57.3701788),(39024,'tibia.tif',235,8,98,111.5084817,67.6719173,110.8441914,1.8,67.6654872,110.6468473,-0.1382849,9.7239483,9.267581,2160.9500998,2265.2206263,0.3531312,244.4241526,222.2296982,418.8478043,16.1004735,18.064574,1.4243121,57.3701788),(39025,'tibia.tif',235,8,99,111.7189233,67.7330411,110.7640134,1.8,67.7201465,110.576555,-0.0585576,9.8660401,9.1737418,2156.9189909,2236.0040474,0.0637744,243.7395872,218.620537,419.4708837,16.1204427,17.9310431,1.6525807,57.6128823),(39026,'tibia.tif',235,8,100,111.1169631,67.7847798,110.7147375,1.8,67.8172228,110.4678481,0.078082,10.1231619,9.2293848,2147.68345,2221.0683212,0.1126803,240.6518281,212.1553984,423.0770954,15.9947139,17.774794,1.4219064,56.3699201),(39027,'tibia.tif',235,8,101,110.9689699,67.8166034,110.6594838,1.8,67.8248038,110.4687178,0.4321094,10.1381582,8.6878267,2136.4982461,2203.5220257,3.2436742,253.6332858,210.7383022,422.826605,15.9784669,17.7337018,1.7033479,56.1983028),(39028,'tibia.tif',235,8,102,111.4664506,67.8739855,110.5633958,1.8,67.8863503,110.3702602,0.6059836,9.6150883,8.4811049,2128.5866884,2201.1409658,6.0268228,259.5346932,221.3798384,426.3103878,15.892811,17.6973647,1.686938,55.8550683),(39029,'tibia.tif',235,8,103,111.9257496,67.9561184,110.4576154,1.8,67.9797363,110.2650285,0.7665207,8.9953891,8.5071749,2119.1189121,2204.8485116,8.9750839,259.1751725,235.578348,427.0481565,15.8205221,17.7337018,1.7033479,55.683451),(39030,'tibia.tif',235,8,104,112.1453985,68.0315076,110.3642168,1.8,68.0172314,110.1845783,0.8187714,8.4951971,8.5288976,2103.7966387,2208.3017289,9.9687629,258.9199483,247.6454178,430.3375188,15.8356392,17.7337018,1.7033479,55.097513),(39031,'tibia.tif',235,8,105,111.709742,68.1619594,110.224227,1.8,68.1702426,110.0724497,0.8619249,8.2055522,8.5296793,2062.4074566,2190.8389637,10.7283854,256.8489246,251.3429193,429.1225229,15.80801,17.6658121,1.670465,55.1685992),(39032,'tibia.tif',235,8,106,111.1374844,68.2380154,110.1396621,1.8,68.2660528,109.9533152,0.8691329,8.1073452,8.5438738,2028.6459881,2177.1187854,10.8052284,254.8163555,250.2232165,428.532081,15.6598235,17.5316919,1.7386923,54.511575),(39033,'tibia.tif',235,8,107,110.5940972,68.3179869,110.060567,1.8,68.3495197,109.8701814,0.9047574,7.9104163,8.4983885,2000.5322673,2165.501228,11.3954103,254.8131592,252.8984807,428.5043419,15.6598235,17.5316919,1.7386923,53.9967232),(39034,'tibia.tif',235,8,108,110.5375009,68.3869993,109.9867604,1.8,68.3974851,109.8305256,0.9118948,7.8920862,8.509263,1977.2524622,2161.6403015,11.5171142,254.033787,250.5360945,429.449173,15.6587716,17.4851204,1.7221718,53.925637),(39035,'tibia.tif',235,8,109,110.4609034,68.464976,109.908636,1.8,68.4753019,109.7449699,0.9219978,7.8536267,8.3966627,1957.9718087,2157.1791436,11.6887277,256.9091096,249.3079796,431.0103246,15.6192699,17.4064025,1.6888884,53.6534887),(39036,'tibia.tif',235,8,110,110.9043367,68.5452596,109.8309679,1.8,68.5617687,109.6749833,0.9483106,7.8713945,8.4101541,1941.5761171,2151.9051477,12.2003127,255.8698822,246.6622812,432.7963513,15.5923779,17.2950993,1.7582254,52.9964645),(39037,'tibia.tif',235,8,111,111.3384586,68.621827,109.7658464,1.8,68.6093699,109.6287228,0.975492,7.8956697,8.3368552,1928.725506,2144.4376422,12.7212986,257.2238091,244.276366,434.1380797,15.5247374,17.2429119,1.7415315,53.4107852),(39038,'tibia.tif',235,8,112,111.1297857,68.7157899,109.6872251,1.8,68.7091528,109.5814351,1.0104649,7.9572523,8.5005624,1909.5460832,2130.9340049,13.2900633,250.6815332,239.9755593,411.9000204,15.4616558,17.3743215,1.4694498,54.1683405),(39039,'tibia.tif',235,8,113,110.2437514,68.8546012,109.5580842,1.8,68.8365703,109.447814,1.0435261,8.0273061,8.2305935,1874.8071241,2096.9435654,13.7219236,254.7742829,233.5537092,411.584061,15.3298671,17.0652871,1.7782926,52.2389092),(39040,'tibia.tif',235,8,114,110.0567702,68.9370273,109.47176,1.8,68.9357864,109.3210963,1.0701028,8.0493377,8.8594725,1850.2962831,2080.4591276,14.1160155,234.828782,229.8693822,399.8202367,15.3309336,17.4064025,1.4527043,54.8253647),(39041,'tibia.tif',235,8,115,109.7364131,69.0107769,109.3999498,1.8,68.9771559,109.2736829,1.0833451,8.0516792,8.7733377,1821.8933623,2060.0333968,14.2771542,234.8061211,226.2749565,425.824806,15.3290104,16.9542758,1.7444675,51.8245885),(39042,'tibia.tif',235,8,116,109.4934078,69.0866941,109.3233951,1.8,69.0511022,109.2023285,1.09999,8.0437346,8.90776,1800.4981116,2049.4547694,14.4940532,230.0752107,223.8385779,414.6130588,15.1227068,16.9111898,1.815775,51.6529712),(39043,'tibia.tif',235,8,117,109.4416492,69.1546062,109.249936,1.8,69.0930455,109.1346767,1.1094782,8.0208574,8.7647518,1783.2538145,2040.6462781,14.6261532,232.8241941,222.3270819,424.8041101,15.1227068,16.9111898,1.815775,51.1675643),(39044,'tibia.tif',235,8,118,109.2708198,69.2251636,109.1776401,1.8,69.1645103,109.0427796,1.1209032,8.0069423,8.8896084,1766.1229719,2029.6646378,14.7677461,228.3187896,220.573959,413.9703058,15.1010817,16.8425328,1.798899,51.1675643),(39045,'tibia.tif',235,8,119,109.3585233,69.2932995,109.109937,1.8,69.2524416,109.0032521,1.1355704,7.9807296,8.129208,1751.3517799,2019.5532994,14.9865024,248.4317418,219.4475787,434.3554774,14.9155464,16.7787109,1.7818897,50.995947),(39046,'tibia.tif',235,8,120,109.4013607,69.3639178,109.0404831,1.8,69.3272204,108.9249487,1.1504284,7.8806728,8.1377792,1736.8019217,2011.0151911,15.1968953,247.1208837,220.3875178,435.5612725,14.9155464,16.7018027,1.8370484,50.8243297),(39047,'tibia.tif',235,8,121,108.6162427,69.5134837,108.9747935,1.8,69.4704306,108.8650581,1.1749714,7.8963311,8.1999059,1704.6024657,1979.6160596,15.41149,241.4193623,215.8727182,430.5803981,14.708386,16.62712,1.8200485,50.1673055),(39048,'tibia.tif',235,8,122,108.1600908,69.5835276,108.9054762,1.8,69.5339529,108.8092153,1.2028692,7.907923,8.2238277,1682.4368557,1962.1856312,15.6945481,238.5976095,212.7533172,429.8031836,14.9155464,16.62712,1.8200485,50.1673055),(39049,'tibia.tif',235,8,123,107.6917666,69.6543662,108.845011,1.8,69.6288097,108.7696553,1.2177087,7.909145,8.2213633,1661.859919,1944.438701,15.8024153,236.5104942,210.1187836,427.860377,14.708386,16.557285,1.8029002,49.9956883),(39050,'tibia.tif',235,8,124,107.4017104,69.7216559,108.7956733,1.8,69.6861801,108.7413461,1.2272436,7.8230839,8.2149153,1643.3205338,1930.521262,15.8693657,235.0019691,210.0604521,426.0222084,14.708386,16.5001639,1.8588518,49.9956883),(39051,'tibia.tif',235,8,125,107.4850963,69.7874233,108.7439171,1.8,69.7631043,108.6976851,1.2449481,7.8198942,8.2157348,1628.9089434,1921.6890138,16.0784808,233.9034878,208.3031945,425.3705007,14.708386,16.4324011,1.7681919,49.7529848),(39052,'tibia.tif',235,8,126,107.3509661,69.8391343,108.6990513,1.8,69.7979718,108.6293297,1.2467001,7.700244,8.383183,1610.3025349,1911.9515616,16.0773853,228.0698825,209.1235723,417.1338536,14.5012257,16.4193378,1.8417432,49.3386641),(39053,'tibia.tif',235,8,127,107.1740766,69.8954892,108.6638654,1.8,69.8822414,108.6052069,1.2606367,7.6804959,8.4950787,1595.5681131,1904.4655208,16.198405,224.1845658,207.7428499,386.1464385,14.5012257,16.3433644,1.8244704,49.3386641),(39054,'tibia.tif',235,8,128,106.8086973,69.9465507,108.6369049,1.8,69.935601,108.5724855,1.2717211,7.6150349,8.5188712,1576.0248393,1895.3457306,16.2560928,222.4878951,206.9622616,384.2195611,14.5012257,16.3433644,1.8244704,49.0959606),(39055,'tibia.tif',235,8,129,105.7818224,70.0080445,108.5342089,1.8,69.9580239,108.4709239,1.2760572,7.5536599,8.2061624,1541.1477452,1867.4257861,16.1425784,227.5638342,204.0266271,414.0052005,14.5012257,16.3065608,1.8811837,49.0959606),(39056,'tibia.tif',235,8,130,104.9528006,70.0708624,108.5037831,1.8,70.0603718,108.4198991,1.2867164,7.6329548,8.201198,1517.0198022,1846.9934614,16.1180615,225.2102036,198.7460741,409.3949636,14.2940653,16.2723116,1.8070416,48.9243433),(39057,'tibia.tif',235,8,131,104.1948883,70.12948,108.4719853,1.8,70.1192976,108.3865523,1.296779,7.5550737,8.6850978,1492.8722174,1829.6850145,16.094204,210.669477,197.5986312,362.4135205,14.2940653,16.2194793,1.8639832,48.9243433),(39058,'tibia.tif',235,8,132,103.6775624,70.1886671,108.4409225,1.8,70.1590298,108.3983661,1.3031841,7.4812966,8.3294068,1472.6072609,1817.1849382,16.0713544,218.1649884,196.8385093,371.3107657,14.2836691,16.2194793,1.8639832,48.9243433),(39059,'tibia.tif',235,8,133,103.8808775,70.2511779,108.4148753,1.8,70.2391114,108.3442276,1.3095916,7.5567922,8.3395647,1458.8357249,1813.4040865,16.1588385,217.4458909,193.049603,369.515907,14.2829253,16.2194793,1.8639832,48.2673191),(39060,'tibia.tif',235,8,134,104.1259895,70.3087077,108.3989741,1.8,70.2694519,108.3035265,1.3231263,7.315603,8.732578,1444.3730926,1811.9127845,16.3113985,207.4888741,197.4373246,357.7702119,14.2829253,16.0599396,1.8290485,48.2673191),(39061,'tibia.tif',235,8,135,104.2984835,70.3684395,108.3861071,1.8,70.3492649,108.2783591,1.3310137,7.304786,8.3300818,1427.6287334,1804.3402638,16.4026365,216.6053467,195.4374474,366.6379127,14.062512,16.0599396,1.8290485,48.0246157),(39062,'tibia.tif',235,8,136,104.6140289,70.420241,108.3791127,1.8,70.3844645,108.2814762,1.33813,7.2212587,8.1082626,1414.4460721,1798.6069164,16.5087244,221.8239604,195.8725111,372.0618367,14.062512,16.0599396,1.8290485,47.8529984),(39063,'tibia.tif',235,8,137,103.904442,70.5429332,108.341015,1.8,70.5060489,108.2100151,1.3453826,7.270791,8.3002267,1383.6212361,1770.9854258,16.4522888,213.3659109,190.2985858,359.2058978,14.062512,16.0599396,1.8290485,47.8529984),(39064,'tibia.tif',235,8,138,103.5262661,70.5842406,108.336054,1.8,70.5460764,108.2271085,1.3484593,7.473938,8.0374352,1364.1790022,1751.1416751,16.4153918,217.8731948,182.5247955,361.4381309,13.769543,15.9876273,1.8113306,47.6102949),(39065,'tibia.tif',235,8,139,103.1417179,70.6300991,108.3288991,1.8,70.596202,108.1963331,1.3491683,7.4278051,8.3183704,1343.7548221,1729.903744,16.3596513,207.9618553,180.9087351,349.4939786,13.769543,15.9203786,1.7934573,47.6102949),(39066,'tibia.tif',235,8,140,103.256081,70.672619,108.3203654,1.8,70.6482363,108.185658,1.3571905,7.4103717,8.4650487,1331.2621857,1717.7268037,16.4359982,202.9198974,179.6485036,349.4005117,13.769543,15.9203786,1.7934573,47.4386777),(39067,'tibia.tif',235,8,141,103.2686435,70.7127564,108.3091913,1.8,70.6837326,108.1901554,1.3589388,7.3664797,8.4661657,1318.5001787,1708.8629396,16.4504178,201.8461476,178.9864673,347.904235,13.769543,15.858258,1.7754381,47.4386777),(39068,'tibia.tif',235,8,142,103.1750879,70.7518539,108.2969399,1.8,70.7106231,108.1798252,1.3635364,7.3048114,8.4713779,1304.8932834,1699.3449453,16.4676881,200.5984098,178.6347665,345.370487,13.476574,15.8013259,1.7572832,47.1959742),(39069,'tibia.tif',235,8,143,102.5246463,70.7956103,108.2914552,1.8,70.7562867,108.1551299,1.3659202,7.2611743,7.9169805,1292.2615753,1686.9209034,16.3801879,213.0762984,177.9686752,376.1093011,13.476574,15.7032477,1.7206088,47.1959742),(39070,'tibia.tif',235,8,144,102.0011822,70.8444854,108.2860732,1.8,70.8160301,108.1590958,1.377405,7.325709,7.9234874,1279.9878826,1676.3974592,16.3722731,211.5731839,174.7254607,373.0780068,13.476574,15.7032477,1.815775,47.0243569),(39071,'tibia.tif',235,8,145,100.8351313,70.9140656,108.2116025,1.8,70.8930601,108.057979,1.3829393,7.2403419,8.3442834,1252.7307508,1650.6771045,16.219716,197.8213144,173.020939,335.8343224,13.6761803,15.7032477,1.815775,47.1959742),(39072,'tibia.tif',235,8,146,99.8396497,70.960666,108.2028183,1.8,70.956165,108.0669447,1.3888994,7.2956819,7.8634105,1231.1734954,1633.5437233,16.0954293,207.7398499,168.7537243,364.2764721,13.476574,15.6347759,1.7975952,46.6100362),(39073,'tibia.tif',235,8,147,98.8814914,71.0058699,108.2028975,1.8,70.9771497,108.0622854,1.3946623,7.1418292,7.8706662,1208.9482144,1618.1011909,15.9742439,205.586307,169.2771108,348.5216915,13.476574,15.6347759,1.7975952,46.6100362),(39074,'tibia.tif',235,8,148,98.6191612,71.0545426,108.2023689,1.8,71.0072359,108.0548282,1.4070493,6.9296036,7.875046,1196.3008758,1610.7788495,15.9997378,204.542152,172.6362633,356.117412,13.476574,15.6347759,1.7975952,46.6100362),(39075,'tibia.tif',235,8,149,98.4826121,71.1061226,108.2023852,1.8,71.0914965,108.050369,1.4213671,7.1545434,7.8770416,1186.8635324,1607.5879378,16.0499839,204.0852412,165.8894872,354.0309957,13.476574,15.6347759,1.7975952,46.7816535),(39076,'tibia.tif',235,8,150,98.2649399,71.1496705,108.2065641,1.8,71.1233306,108.0576718,1.4314537,6.9076857,7.8410388,1177.3997815,1606.9971652,16.0615515,204.9469731,170.4477926,354.7775974,13.4379843,15.5715159,1.7792615,46.6100362),(39077,'tibia.tif',235,8,151,98.1516953,71.1902918,108.2168698,1.8,71.181334,108.0675177,1.4439676,7.0699839,7.8515657,1171.7576294,1605.3433489,16.0968866,204.4615583,165.7369594,353.0565701,13.183605,15.6347759,1.7975952,46.1957155),(39078,'tibia.tif',235,8,152,97.6775449,71.2304879,108.2284798,1.8,71.2032572,108.0798369,1.4604734,7.0268841,7.858632,1162.9894634,1600.5648312,16.0822522,203.6696494,165.5057125,350.4888602,13.183605,15.6347759,1.7975952,46.1957155),(39079,'tibia.tif',235,8,153,96.2889321,71.3187619,108.1974884,1.8,71.2950866,108.0538397,1.4723671,6.8808974,8.7929401,1139.8250128,1579.2166268,15.8931772,179.6005219,165.6506344,305.7565382,13.183605,15.6347759,1.7975952,46.0240982),(39080,'tibia.tif',235,8,154,95.239299,71.3645187,108.2134029,1.8,71.3513169,108.0535251,1.485504,6.9922067,7.8364847,1124.1622337,1564.1851073,15.7580221,199.6029048,160.7735992,340.4365695,13.183605,15.6347759,1.7975952,46.3673327),(39081,'tibia.tif',235,8,155,94.3961281,71.4076204,108.2319593,1.8,71.3748617,108.071408,1.4962279,6.9147105,7.8254806,1110.4537373,1551.2041288,15.6453692,198.2247742,160.5929482,338.3315703,12.890636,15.5715159,1.7792615,46.1246293),(39082,'tibia.tif',235,8,156,93.8888418,71.4503876,108.2587947,1.8,71.4352813,108.0701198,1.5101043,6.9290902,7.8429054,1103.1221095,1542.2690242,15.5905709,196.6451134,159.2015804,334.8147765,12.890636,15.5715159,1.7792615,46.1246293),(39083,'tibia.tif',235,8,157,93.3705016,71.4825075,108.2898532,1.8,71.4700783,108.1259162,1.5251963,6.8751577,7.8467077,1097.0714472,1533.8720467,15.5294141,195.4796976,159.5703695,333.5068582,12.890636,15.5715159,1.7792615,45.953012),(39084,'tibia.tif',235,8,158,93.1704377,71.5085615,108.3138034,1.8,71.4947156,108.1329121,1.5396766,6.8085465,7.8588607,1089.8025871,1531.8631702,15.5133729,194.9217862,160.0639122,331.1729362,12.890636,15.5715159,1.7792615,45.7813947),(39085,'tibia.tif',235,8,159,93.1434921,71.5343861,108.3349647,1.8,71.5241921,108.1622227,1.5539136,6.7982345,7.8611603,1085.4389542,1532.5616947,15.5194911,194.9536238,159.6648292,331.3344361,12.890636,15.5963004,1.6648576,46.0240982),(39086,'tibia.tif',235,8,160,93.0146418,71.5648128,108.354584,1.8,71.5600348,108.2124551,1.5626001,6.818795,7.871414,1079.1311043,1534.3345748,15.5013989,194.9248992,158.2583302,331.0536579,12.890636,15.5963004,1.6648576,46.0240982),(39087,'tibia.tif',235,8,161,92.7354575,71.6464825,108.3281776,1.8,71.6543653,108.1528141,-1.5675605,6.8637132,7.8411412,1062.809855,1523.8014319,15.4557477,194.33414,154.8447366,328.4414013,12.890636,15.5963004,1.6648576,46.0240982),(39088,'tibia.tif',235,8,162,92.4703182,71.6685272,108.3481064,1.8,71.6827061,108.1888526,-1.5577066,6.8203948,7.8566565,1055.099632,1519.966818,15.4090792,193.4622982,154.6977358,327.0256153,12.890636,15.5963004,1.6648576,46.1957155),(39089,'tibia.tif',235,8,163,92.3017517,71.6895257,108.3616025,1.8,71.6896951,108.2091852,-1.550885,6.7672184,7.6096786,1047.255447,1517.5067439,15.3775271,199.4179804,154.7541963,331.4648039,12.890636,15.4136223,1.7234457,45.953012),(39090,'tibia.tif',235,8,164,92.5494907,71.7084877,108.3814619,1.8,71.719903,108.248952,-1.5459149,6.6741694,7.6359318,1044.7894743,1524.4470893,15.4153677,199.6412662,156.5422463,331.3714203,12.890636,15.4608821,1.7421755,45.953012),(39091,'tibia.tif',235,8,165,92.8090119,71.7357049,108.4077735,1.8,71.753858,108.2793345,-1.5386516,6.6934245,7.6709169,1042.0821415,1531.0454426,15.4521911,199.5909315,155.6874422,330.9992572,12.8600821,15.5135316,1.7607846,45.7813947),(39092,'tibia.tif',235,8,166,93.0489481,71.7558085,108.4344483,1.8,71.7633323,108.2950862,-1.5296541,6.712484,7.7077744,1038.9844005,1538.7788294,15.4819224,199.6398383,154.7838927,330.6465337,12.861343,15.4608821,1.7421755,45.953012),(39093,'tibia.tif',235,8,167,92.6559469,71.7691244,108.468399,1.8,71.7707382,108.3513068,-1.5224997,6.7113881,7.7350749,1036.0211639,1543.4049186,15.4066648,199.5332865,154.3676437,331.6682396,12.7885687,15.5135316,1.7607846,45.953012),(39094,'tibia.tif',235,8,168,92.5037142,71.7905907,108.5062382,1.8,71.7931701,108.3767591,-1.5149643,6.7142658,7.7775237,1033.451228,1543.8604627,15.3692766,198.5028301,153.9187238,329.9458462,12.7203559,15.4608821,1.7421755,45.7813947),(39095,'tibia.tif',235,8,169,92.3262004,71.8783585,108.5137618,1.8,71.8865575,108.3636746,-1.5082614,6.5589859,7.8025467,1022.061291,1532.7692738,15.3276031,196.4447414,155.8261154,325.3819193,12.7195918,15.5135316,1.7607846,45.953012),(39096,'tibia.tif',235,8,170,91.6703488,71.8984311,108.5568321,1.8,71.9144568,108.3926114,-1.4992484,6.9021772,8.7073832,1013.0615182,1523.8844737,15.200313,175.0106135,146.7741966,291.0019602,12.7195918,15.5963004,1.4767351,46.1957155),(39097,'tibia.tif',235,8,171,91.2350564,71.9147388,108.603614,1.8,71.929993,108.4543865,-1.4898139,6.5776687,8.7563569,1006.3987032,1519.2737647,15.1063384,173.5052354,153.0023411,288.2374704,12.6956083,15.6265391,1.4580687,46.1957155),(39098,'tibia.tif',235,8,172,91.0571525,71.9266979,108.6471321,1.8,71.9406174,108.5134995,-1.482567,6.8591038,8.7233489,1004.143359,1521.5525872,15.0583605,174.4229881,146.3957076,288.7868344,12.6945564,15.6265391,1.4580687,46.0240982),(39099,'tibia.tif',235,8,173,90.7506844,71.9340107,108.6962409,1.8,71.9436847,108.5759327,-1.4757161,6.5725548,7.7673373,1000.0115021,1521.108558,14.9887908,195.833977,152.1495879,321.0073369,12.6026479,15.5715159,1.3623311,45.7813947),(39100,'tibia.tif',235,8,174,90.4677028,71.9492837,108.7410033,1.8,71.9556357,108.617456,-1.4689034,6.8187651,7.8180502,995.5962577,1525.9750225,14.9219496,195.186138,146.0082936,319.4459952,12.601596,15.5715159,1.3623311,45.953012),(39101,'tibia.tif',235,8,175,90.295729,71.9620657,108.7893202,1.8,71.9737362,108.691117,-1.4606111,6.5683139,7.8734327,995.6630713,1531.891231,14.8673162,194.5645938,151.5857934,318.4321256,12.601596,15.6347759,1.3439975,45.953012),(39102,'tibia.tif',235,8,176,90.2606424,71.9695097,108.8314417,1.8,71.9790838,108.7216744,-1.4518676,6.5723817,7.9228722,997.3000784,1540.8406652,14.8316665,194.4800597,151.7410478,318.1940551,12.601596,15.7032477,1.3258177,46.1957155),(39103,'tibia.tif',235,8,177,89.4555752,72.01107,108.8321428,1.8,71.9948297,108.7420498,-1.4449746,6.6070696,7.9245413,988.4940911,1532.9585394,14.6744754,193.4444514,149.6115754,316.295479,12.601596,15.7496385,1.4025896,46.1957155),(39104,'tibia.tif',235,8,178,88.8053936,72.0200868,108.8798241,1.8,72.0226726,108.7713143,-1.4385113,6.6157649,8.8470388,982.5362496,1531.9204854,14.5434005,173.1562985,148.5143847,283.4579029,12.6791527,15.7496385,1.4025896,46.1957155),(39105,'tibia.tif',235,8,179,88.1570587,72.0247313,108.9412279,1.8,72.0437748,108.8263817,-1.4311123,6.5806478,8.1729346,977.2673073,1529.7137604,14.4080217,187.1682374,148.5062476,280.5535767,12.601596,15.8013259,1.3843094,46.1957155),(39106,'tibia.tif',235,8,180,87.9081232,72.0195882,109.013069,1.8,72.0146594,108.9010831,-1.4248987,6.5780178,8.0321723,978.4808987,1531.5335863,14.3416898,190.6748922,148.7501132,312.4876325,12.6791527,15.8013259,1.3843094,46.1957155),(39107,'tibia.tif',235,8,181,87.3462954,72.0127409,109.0843944,1.8,71.9963227,108.9871331,-1.4206781,6.5766487,7.9456533,980.4110912,1533.8004394,14.2321076,193.0364166,149.0745717,314.2780001,12.6791527,15.7768635,1.3078016,46.1246293),(39108,'tibia.tif',235,8,182,86.8686598,72.0083636,109.1541815,1.8,72.0160638,109.0487223,-1.4129884,6.5739481,8.022182,983.1603873,1540.407222,14.1205395,192.0184838,149.5540236,283.6594475,12.6935046,15.858258,1.3661545,46.3673327),(39109,'tibia.tif',235,8,183,86.2633443,71.9963829,109.2313535,1.8,71.9938884,109.1415056,-1.4077161,6.5208252,8.0571466,986.3978478,1542.0885397,13.9982374,191.3938786,151.2688689,310.8437613,12.6935046,15.858258,1.3661545,46.1957155),(39110,'tibia.tif',235,8,184,85.4611121,71.9825825,109.314729,1.8,71.9679732,109.1936186,-1.4010844,6.5117675,8.0955154,988.3901478,1541.5042895,13.8371985,190.414595,151.7852335,286.4599493,12.6935046,15.858258,1.3661545,46.1957155),(39111,'tibia.tif',235,8,185,84.0472962,72.0274297,109.3476913,1.8,72.0352645,109.2005863,-1.3919574,6.4968245,8.1734685,980.1059135,1527.4313183,13.5646196,186.87676,150.8592248,306.5050656,12.6945564,15.9876273,1.3302621,46.3673327),(39112,'tibia.tif',235,8,186,82.6620646,72.0217448,109.4237594,1.8,72.0293662,109.325148,-1.3796632,6.4843221,8.1416348,975.0066932,1520.477247,13.2798098,186.7533105,150.3637056,303.7782319,12.6935046,16.0278411,1.2548261,46.7816535),(39113,'tibia.tif',235,8,187,81.6140441,72.0207588,109.4654067,1.8,72.0067715,109.3712507,-1.3653147,6.4667602,8.1293045,972.5051066,1517.9390013,13.0360512,186.724337,150.3852134,305.0567761,12.7105409,16.0278411,1.2548261,46.3673327),(39114,'tibia.tif',235,8,188,81.0425408,72.0275808,109.5032232,1.8,72.0072273,109.3916553,-1.3516392,6.4570451,8.1742359,972.6132557,1529.7588067,12.8686667,187.143951,150.6282274,305.2401098,12.786465,16.1372474,1.2949904,46.53895),(39115,'tibia.tif',235,8,189,80.5240965,72.0258725,109.5620672,1.8,71.9811571,109.4665206,-1.340703,6.3818358,8.1714407,973.5932597,1542.7972096,12.7226034,188.803575,152.5569261,307.8189927,12.8412631,16.1452236,1.3698421,46.9532707),(39116,'tibia.tif',235,8,190,79.8488419,72.0178665,109.638257,1.8,71.9798089,109.5454854,-1.3310077,6.4410223,8.1796951,974.3395396,1551.7607965,12.5574948,189.7088797,151.2709462,308.7829094,12.8794254,16.2062443,1.3521274,46.9532707),(39117,'tibia.tif',235,8,191,79.1271867,71.9936895,109.7224174,1.8,71.9485433,109.6373821,-1.3224608,6.4225976,8.1977989,975.7632639,1556.4315519,12.3911437,189.8596886,151.9265771,307.7008023,12.890636,16.2194793,1.2204821,46.9532707),(39118,'tibia.tif',235,8,192,78.6154528,71.9671635,109.8079234,1.8,71.9057986,109.7509014,-1.3114169,6.3989066,8.2947058,980.6949616,1563.9492719,12.240657,188.5478904,153.2597722,305.8879487,12.890636,16.3433644,1.3171222,47.124888),(39119,'tibia.tif',235,8,193,77.8462265,72.0014782,109.854926,1.8,71.9785418,109.805472,-1.2951922,6.344649,8.339786,976.579443,1569.8748976,12.0135694,188.2392312,153.9217454,290.8223386,12.890636,16.4193378,1.2998495,47.124888),(39120,'tibia.tif',235,8,194,77.3650796,71.9520993,109.9323967,1.8,71.9237871,109.9082109,-1.2828948,6.4606998,8.3498458,977.6059576,1575.4009134,11.8546211,188.6742524,151.3157996,304.6214655,12.890636,16.4297893,1.1869787,47.124888),(39121,'tibia.tif',235,8,195,77.1525052,71.9117264,110.0369856,1.8,71.8793942,110.033757,-1.2604507,6.5722077,9.4776566,985.1606037,1583.6928698,11.6595222,167.0975154,149.897971,270.9805193,13.1041949,16.5961185,1.2099595,47.7819122),(39122,'tibia.tif',235,8,196,76.7604144,71.8988867,110.1357726,1.8,71.8349596,110.2059049,-1.2519612,6.5598754,8.4667636,995.9527171,1584.8642794,11.5363536,187.186552,151.8249439,303.4248413,13.183605,16.62712,1.3215442,47.9535295),(39123,'tibia.tif',235,8,197,75.6189943,71.8902153,110.21023,1.8,71.8052005,110.2663088,-1.2471136,6.6405873,8.5395991,1000.4128761,1586.2443725,11.328201,185.7516202,150.6512648,297.7210065,13.234917,16.7018027,1.1935473,48.1962329),(39124,'tibia.tif',235,8,198,74.9990096,71.8582576,110.3089882,1.8,71.7765935,110.4391686,-1.2438075,6.7358577,9.4770525,1005.5660136,1589.010456,11.2102913,167.6692672,149.2855182,273.7583528,13.3656391,16.8705379,1.2160907,48.0246157),(39125,'tibia.tif',235,8,199,74.7954605,71.8542909,110.3771792,1.8,71.7895375,110.517931,-1.2352331,6.7251077,8.6169231,1014.6501081,1599.2836009,11.1141174,185.59799,150.8749232,296.2233491,13.3663829,16.8705379,1.2160907,48.6105537),(39126,'tibia.tif',235,8,200,74.5927957,71.8166075,110.4246414,1.8,71.7284115,110.5453164,-1.2230842,6.7780452,8.6739456,1018.6919979,1614.9399997,10.9886496,186.1828597,150.2928887,301.2307389,13.476574,16.9542758,1.2545102,48.6105537),(39127,'tibia.tif',235,8,201,72.6611077,71.8351195,110.4998093,1.8,71.7280934,110.630509,-1.2212392,6.8124662,8.7380851,1006.2394398,1591.6859477,10.6897356,182.1550071,147.7056055,296.1099168,13.476574,17.0627721,1.2924967,49.0248744),(39128,'tibia.tif',235,8,202,72.4273357,71.8273129,110.5569837,1.8,71.7494943,110.674472,-1.2290649,6.8119741,8.7953069,1013.6137369,1595.7597625,10.715568,181.4330957,148.7988253,296.0315849,13.476574,17.1455711,1.2220253,49.1964917),(39129,'tibia.tif',235,8,203,71.6331404,71.7868386,110.6477774,1.8,71.7066691,110.7693881,-1.2311103,6.8971544,8.8135277,1011.5725282,1599.0449722,10.6134489,181.4307545,146.6651997,294.630214,13.476574,17.1955583,1.1681417,49.3681089),(39130,'tibia.tif',235,8,204,71.5912654,71.7320724,110.7405166,1.8,71.6905587,110.857161,-1.2369596,6.912069,8.8194105,1019.092007,1605.7761956,10.6507777,182.0729626,147.4366089,297.3180092,13.7585493,17.1455711,1.2220253,49.7824297),(39131,'tibia.tif',235,8,205,72.002291,71.6897385,110.8751528,1.8,71.6443803,110.954667,-1.2386543,6.9160845,8.9598011,1028.7675716,1628.6582832,10.7244912,181.7739335,148.75,296.2822931,13.769543,17.3545498,1.1902899,49.3681089),(39132,'tibia.tif',235,8,206,71.5419777,71.6296053,110.9818478,1.8,71.6102938,111.0728335,-1.2330037,6.9475921,8.9854845,1034.5006909,1641.1372868,10.6140938,182.6431596,148.9006078,297.7527961,13.769543,17.3545498,1.1902899,49.9540469),(39133,'tibia.tif',235,8,207,71.242246,71.5874521,111.1167629,1.8,71.6174352,111.1530792,-1.2435899,7.0153654,8.9419027,1048.0744781,1651.3473705,10.6471859,184.6751666,149.3969915,301.2754279,13.476574,17.3545498,1.1902899,49.8829607),(39134,'tibia.tif',235,8,208,71.2726769,71.5578703,111.2164067,1.8,71.6199445,111.2539462,-1.2455018,7.0130316,8.9510415,1059.5681184,1676.4176872,10.6655237,187.2874446,151.0856042,305.4843985,13.476574,17.3545498,1.1902899,49.6402573),(39135,'tibia.tif',235,8,209,70.6480105,71.6003575,111.2546145,1.8,71.6801208,111.3298148,-1.2496527,7.0462787,8.9725435,1062.3782566,1694.7329107,10.6014857,188.8798768,150.7715343,307.123488,13.476574,17.5218976,1.2120257,50.2261953),(39136,'tibia.tif',235,8,210,69.9550175,71.5560746,111.3726873,1.8,71.6416465,111.4185691,-1.2584309,7.0419443,9.0055934,1067.8042159,1703.9670121,10.5580809,189.2120753,151.6348577,307.7661226,13.769543,17.5218976,1.2120257,50.640516),(39137,'tibia.tif',235,8,211,69.6261814,71.5279671,111.450459,1.8,71.6220683,111.5686917,-1.2695727,7.1203222,9.6081076,1083.4419787,1716.4311406,10.5828971,178.6440381,152.161932,285.9959,13.769543,17.6269005,1.1964627,51.0548367),(39138,'tibia.tif',235,8,212,69.7945399,71.482599,111.604772,1.8,71.6095819,111.7056321,-1.2881771,7.0946727,9.0425019,1106.4679563,1738.1126498,10.7277752,192.2159003,155.9575751,313.5537178,13.769543,17.6269005,1.1964627,51.226454),(39139,'tibia.tif',235,8,213,69.5059402,71.468657,111.7479162,1.8,71.603296,111.8489045,-1.3112814,7.1143761,9.089931,1125.7924829,1755.0267864,10.8215006,193.0737199,158.2419122,316.155857,13.769543,17.7965104,1.2178059,51.5696885),(39140,'tibia.tif',235,8,214,69.6933635,71.3956388,111.8727466,1.8,71.5698493,111.9961144,-1.3105148,7.2294436,9.1544353,1152.2887741,1782.9118629,10.8462577,194.7593488,159.3883056,320.3520412,14.062512,17.974072,1.2387369,52.39833),(39141,'tibia.tif',235,8,215,70.6183598,71.3645567,112.0301781,1.8,71.5373755,112.168046,-1.3295156,7.2573498,9.8703121,1193.1881178,1824.3473401,11.0977293,184.8317794,164.4109983,301.697409,14.355481,18.119132,1.3258177,53.0553542),(39142,'tibia.tif',235,8,216,72.1157178,71.3312683,112.2159432,1.8,71.5193133,112.3030724,-1.3611612,7.3484221,9.3504771,1245.0498275,1884.6842169,11.4987687,201.5602199,169.4309067,334.5806424,14.355481,18.2794814,1.1932661,53.6412922),(39143,'tibia.tif',235,8,217,74.4873278,71.369019,112.3752522,1.8,71.5423586,112.4107262,-1.3871597,7.4032396,10.0992257,1300.7782259,1972.2534229,12.0005907,195.2875879,175.7039204,317.2035592,14.64845,18.4756388,1.3142797,54.6415509),(39144,'tibia.tif',235,8,218,76.9972555,71.3368827,112.584503,1.8,71.5050243,112.6133316,-1.4107179,7.4938544,10.2582909,1378.9686461,2056.881741,12.5068313,200.5092044,184.0132689,326.4694428,14.941419,18.72253,1.2193515,55.2985751),(39145,'tibia.tif',235,8,219,79.9713979,71.2726679,112.7908803,1.8,71.4723085,112.7839694,-1.4388481,7.7082782,10.3625916,1472.8734406,2175.172984,13.0978552,209.9062725,191.0768404,343.0724772,15.234388,19.0249476,1.7410083,56.4704511),(39146,'tibia.tif',235,8,220,83.1452662,71.2251749,112.9282718,1.8,71.4149015,112.9743705,-1.4664861,7.9147708,9.9904243,1566.9225328,2314.8350852,13.7073116,231.7053821,197.9744682,369.0446615,15.527357,19.6026694,1.735945,57.7134133),(39147,'tibia.tif',235,8,221,87.370146,71.1825342,113.1127701,1.8,71.393743,113.1511495,-1.4918875,8.1939028,10.5495852,1702.5512254,2483.0634432,14.4712091,235.370717,207.7826963,381.6708907,16.113295,20.1148342,1.7910451,59.2996101),(39148,'tibia.tif',235,8,222,93.9723318,71.0892437,113.2747261,1.8,71.3656047,113.2915957,-1.5004147,8.3863659,10.712379,1869.8973221,2741.8485741,15.5846001,255.9514167,222.9687266,409.6783199,16.406264,20.751224,1.7986534,64.2003727),(39149,'tibia.tif',235,8,223,101.1972854,71.1005506,113.526947,1.8,71.3778853,113.5100513,-1.5106633,8.7089297,10.8218134,2022.6710828,3103.691213,16.8052999,286.7995504,232.2525453,458.2800194,16.992202,21.5147785,1.6799498,67.1006178),(39150,'tibia.tif',235,8,224,111.9038758,71.1805636,113.8543834,1.8,71.4575604,113.7933698,-1.5371109,9.6968469,11.4275844,2256.4973324,3648.5776219,18.629491,319.2781177,232.7042348,497.4766407,18.3262714,23.0386172,1.6983059,70.8711457),(39151,'tibia.tif',235,8,225,129.212678,71.1573181,114.0877634,1.8,71.4833606,113.9035665,-1.5560825,9.7122002,12.4137459,2737.0263178,4465.6810957,21.5307844,359.7367888,281.8132116,577.1635758,18.9916717,24.7987486,1.8215056,72.5873184),(39152,'tibia.tif',235,8,226,144.7073025,71.0499355,114.2406291,1.8,71.2673276,114.0868417,-1.5369755,9.783495,12.8410592,3154.7662502,5180.5305013,24.090307,403.4348266,322.4580021,646.4248521,19.1152075,24.8730508,1.8329162,72.6167633),(39153,'tibia.tif',235,8,227,161.9736315,70.8798883,114.3380054,1.8,71.0880998,114.1895934,-1.4348084,9.7544945,12.8137894,3547.1290392,5867.0471383,26.4994529,457.8697974,363.6404767,724.2102873,19.433706,24.652954,1.63025,73.1021702),(39154,'tibia.tif',235,8,228,159.2809881,70.6110737,114.1115249,1.8,70.8745928,114.2538141,-1.3746014,9.5002181,12.7842321,3449.1568727,6334.8249304,25.5380229,495.5186123,363.0608091,762.7331913,18.6032695,25.2786583,1.48958,75.6591808),(39155,'tibia.tif',235,8,229,144.6041234,70.2809612,114.2627736,1.8,70.6232427,114.3353111,-1.4274478,10.1254415,13.0188649,2760.8116971,6114.6841327,23.6088297,469.6787455,272.66087,622.1135792,17.1335617,25.6243222,1.4677147,81.9034366),(39156,'tibia.tif',235,8,230,144.0415153,69.9071608,114.8825603,1.8,70.4647139,114.6238148,-1.3462921,9.9266445,12.751385,2574.3264175,5663.7869564,22.8171115,444.1703353,259.3350066,640.3166938,16.6561251,25.2786583,1.6520126,77.7724258),(39157,'tibia.tif',235,8,231,137.0999075,69.3948563,114.2254671,1.8,70.1065415,114.3429467,-1.2572474,10.930834,12.7930296,2084.8822526,5865.2876824,20.6761951,458.4752679,190.7340513,579.5636418,17.2992033,27.0104072,1.6359215,111.6928881),(39158,'tibia.tif',235,8,232,98.9319496,68.1842877,114.130366,1.8,68.6431252,114.5314538,-1.3897677,10.8956964,13.3395643,852.1811051,5210.4135802,15.9541797,390.5984822,78.2126331,425.9973067,13.4584264,27.0104072,1.6359215,86.8752854),(39159,'tibia.tif',235,8,233,53.2647175,67.5138729,116.369631,1.8,67.621971,115.711684,-1.5284619,5.5692162,15.6803748,309.3375686,3100.292259,8.8615523,197.7179947,55.5441843,215.9579115,11.3082855,27.323188,1.6459235,80.3883261),(39160,'tibia.tif',235,8,234,23.8166782,66.9092422,121.3647284,1.8,66.9989389,121.9881176,0.8592301,4.2287576,6.7023816,54.7308552,179.8129887,2.2767311,26.8282231,12.9425378,34.9674049,7.1667858,12.7735828,2.2097103,34.1215245),(39161,'tibia.tif',235,8,235,10.0762279,66.8742972,121.9366829,1.8,66.8728405,121.966696,0.5988421,3.2498004,5.5783316,19.0182796,58.6619886,0.5336074,10.5160454,5.8521377,13.6877486,6.2032191,10.9030136,2.6057814,36.4652765),(39162,'tibia.tif',235,8,236,195.1236067,76.4825954,112.3884559,1.8,75.5111168,112.5639362,0.6747615,16.7527477,16.5731424,7638.9603558,8899.3236521,12.691617,536.9726159,455.9825334,976.9732446,27.14482,34.7041536,2.9375747,143.3040952),(39163,'tibia.tif',235,8,237,203.3655776,76.0035285,112.8660297,1.8,75.2809382,112.8655238,0.324552,14.0722632,15.9923288,7305.3792627,8862.3570922,3.4466103,554.1630108,519.133215,969.2408688,26.9714799,33.0328231,3.0260383,118.7119476),(39164,'tibia.tif',235,8,238,203.0592656,75.5098403,113.101834,1.8,75.184611,112.8703094,0.1038468,14.1318407,15.0326832,6094.8633635,8666.101026,0.3636606,576.4839798,431.2858804,870.5589272,25.3022619,31.9053867,3.0126819,143.357933),(39165,'tibia.tif',235,8,239,203.5286042,74.9353426,112.8239772,1.8,74.8007023,113.0111366,0.0364613,13.8683998,15.0333349,6268.0017737,8870.7838293,0.0450759,590.0742526,451.9628697,876.3778743,24.7461217,30.8509016,3.0655491,136.9715048),(39166,'tibia.tif',235,8,240,203.3632888,74.5994115,112.6713625,1.8,74.5419274,112.9644794,-0.072862,13.1409792,15.1496056,6735.0660745,9000.1001994,0.1796199,594.0814852,512.5239136,914.9305741,24.6045045,30.5503601,0.4250402,110.780964),(39167,'tibia.tif',235,8,241,196.3092166,74.4596393,112.6256211,1.8,74.6159544,112.9711489,-0.0677064,11.9053267,15.2814906,6552.1486688,8619.1770677,0.1497565,564.0272468,550.3543799,915.8140841,23.0782817,29.4867149,0.441429,121.7127238),(39168,'tibia.tif',235,8,242,185.7325429,73.8866455,112.604252,1.8,74.1458385,113.005449,-0.0495532,12.0603733,15.7186566,6261.1159337,8013.4296627,0.0759495,509.8037248,519.1477704,885.0228236,23.0630471,28.4557217,0.5050985,98.4935144),(39169,'tibia.tif',235,8,243,162.9765778,73.3695441,112.7032731,1.8,73.4419692,113.0619925,-0.295992,11.9433661,14.7657677,5819.3280629,7032.4359444,2.311072,476.2661922,487.2435454,827.1590917,23.1107991,27.9121208,0.4448705,101.8375251),(39170,'tibia.tif',235,8,244,150.8645985,72.9222595,112.8316767,1.8,72.8012214,113.0053756,-0.5545356,12.7818808,13.4914916,5317.0874634,6582.1808728,6.9712861,487.8764379,415.9863112,802.0167689,23.9016723,28.0899068,1.2853335,109.4669156),(39171,'tibia.tif',235,8,245,147.8842658,72.1738678,113.1450141,1.8,72.1235626,113.1050916,-0.5714618,11.9707902,13.4280379,4794.0899856,6626.4139544,7.2101436,493.475964,400.4823316,790.1357047,23.3092034,27.647955,1.3026855,96.5051934),(39172,'tibia.tif',235,8,246,153.3282036,71.0480337,113.4343152,1.8,71.3909353,113.2520144,-0.5795035,11.5127355,13.757379,4713.256025,7246.840183,7.6632192,526.7602322,409.3949712,816.3286248,22.2512789,27.2964737,0.2163407,102.2640423),(39173,'tibia.tif',235,8,247,160.5205154,70.0541184,113.6389939,1.8,70.7934617,113.3515854,-0.5677895,11.2673532,14.1042919,4486.61296,7467.4104534,7.7369878,529.4424215,398.1958195,802.3780116,21.6902147,27.4985392,0.2475626,86.9463716),(39174,'tibia.tif',235,8,248,158.974494,69.0913927,113.6311033,1.8,70.1768339,113.2974624,-0.5640716,10.8479215,14.2532847,3995.4285724,7035.9638898,7.573302,493.6380654,368.3128221,733.5581489,20.8785447,27.3655629,0.2709469,86.1888164),(39175,'tibia.tif',235,8,249,146.9058463,68.1306393,113.5530786,1.8,69.2921977,113.3379902,-0.5576022,9.9284263,14.2446961,3325.6471798,6412.3754709,6.8556795,450.1588106,334.9621674,651.41132,19.5095843,26.7822383,0.3459673,94.3330586),(39176,'tibia.tif',235,8,250,144.5618843,67.4744448,113.2942736,1.8,68.4487218,113.1657625,-0.5124121,10.1947658,13.8427708,3307.1695349,5974.8221923,5.7915209,431.6203952,324.3987753,631.8990114,19.6704989,26.4419739,0.1669702,89.0890615),(39177,'tibia.tif',235,8,251,137.9365501,66.0879918,113.4043345,1.8,67.2820004,113.2515189,-0.5072856,10.5652409,14.2330507,3542.5340931,4668.9932934,5.4256858,328.0388307,335.300834,547.0920286,19.8576284,26.4387277,0.2234766,102.2762388),(39178,'tibia.tif',235,8,252,156.9790832,65.4265685,112.8699129,1.8,66.3969583,113.0193834,-0.6958265,10.2636006,13.510433,3878.34946,5713.9887567,10.7506261,422.9315781,377.8741609,630.6951448,19.8167693,25.9571195,0.2860514,81.0869916),(39179,'tibia.tif',235,8,253,165.6585833,65.0863801,113.1363613,1.8,66.1203196,112.9886029,-0.5146808,11.5088469,13.8107234,4354.7919877,6701.0421442,6.6903145,485.2057323,378.3864725,759.41568,20.0171729,26.6472981,0.2556449,83.1585953),(39180,'tibia.tif',235,8,254,162.4590959,64.5930392,113.2605322,1.8,65.6318955,113.003761,-0.4519143,11.6190252,14.1287459,4322.6825454,6619.5115113,5.1634054,468.5137362,372.0348728,755.1067575,20.1911615,26.5051954,0.2342552,82.7442746),(39181,'tibia.tif',235,8,255,170.946647,64.1459423,113.0642133,1.8,64.989563,113.0046317,-0.2940538,11.8351605,14.4002734,4437.8516833,6730.4797864,2.3933663,467.3855559,374.9718203,773.638851,21.1303574,26.5456429,0.1887378,80.287795),(39182,'tibia.tif',235,8,256,182.991028,63.6820017,112.981063,1.8,64.3751597,112.9146772,-0.2191187,11.994613,14.0765248,4622.286213,6923.7847203,1.4410388,491.8674761,385.3635123,819.9686148,21.3590269,26.4711718,0.0886559,90.2903824),(39183,'tibia.tif',235,8,257,171.6513962,62.7528559,113.0999085,1.8,63.6048967,112.8417145,-0.0580667,10.6819427,13.8597699,4387.1291818,6374.7975667,0.0963524,459.9497411,410.7051801,767.3693389,21.0645677,26.0610705,0.1466665,89.7044444),(39184,'tibia.tif',235,8,258,156.4172293,61.4558116,112.8982691,1.8,62.7888786,112.7744183,-0.1471261,11.0797436,14.1647491,4235.1172713,5640.798045,0.5602438,398.2278841,382.2396456,696.0858253,20.4337263,25.6243222,0.1030816,80.4888572),(39185,'tibia.tif',235,8,259,156.5986445,60.9483904,112.4391239,1.8,62.277525,112.5464992,-0.2348437,11.7335102,14.4453482,4112.6238457,6189.2939046,1.4131751,428.4627715,350.5024318,702.6706442,19.8773725,26.3215976,0.293589,79.5891295),(39186,'tibia.tif',235,8,260,156.174146,60.426104,112.1633902,1.8,61.4724186,112.49875,-0.1562898,10.9655922,14.1141488,3817.2700915,6612.7181436,0.630638,468.5169648,348.1134472,734.3448075,19.2327907,26.3753468,0.2126449,83.0753126),(39187,'tibia.tif',235,8,261,157.3824881,59.8103361,112.1416556,1.8,60.7537022,112.5148228,-0.0654883,10.6202729,13.5330431,3453.0909115,6867.2908722,0.1123342,507.4461684,325.1414487,738.5289277,18.457047,26.1580469,0.2721459,76.1323913),(39188,'tibia.tif',235,8,262,152.8578506,59.0345186,112.1601093,1.8,59.8595098,112.6505147,0.0193054,9.9919843,13.0173673,3106.6594316,6943.7105798,0.0094938,533.4189651,310.9151629,726.33063,17.871109,26.2906012,0.2476814,74.788898),(39189,'tibia.tif',235,8,263,150.0761513,58.2381076,112.2109737,1.8,59.0625332,112.752504,0.0496553,9.4164416,12.8935781,2786.6847302,7039.8949891,0.0616217,546.0001055,295.9381949,732.0717437,17.2084148,26.1054942,0.1577687,80.7193642),(39190,'tibia.tif',235,8,264,147.8507138,57.4066299,112.1847841,1.8,58.2772568,112.7410965,0.0550247,8.8158505,13.2446012,2503.2969501,7169.761044,0.0745332,541.33461,283.9541067,718.5182536,16.3254262,26.2383141,0.1118903,76.9315878),(39191,'tibia.tif',235,8,265,142.6605232,56.3675826,111.9714911,1.8,57.3279444,112.5167756,0.035587,8.7521582,13.9862266,2152.9297198,7078.4116079,0.0300989,506.0987357,245.9884383,658.6368052,15.749144,26.7630028,3.053906,83.3180161),(39192,'tibia.tif',235,8,266,139.8439973,55.3427945,111.7721352,1.8,56.3413068,112.1694004,0.0000574,8.6376847,14.9698241,1908.3143203,7135.3638485,0.00000007323,476.6498108,220.9289167,602.7295088,15.0805476,27.6153394,0.0743309,92.4208758),(39193,'tibia.tif',235,8,267,137.5060954,54.1299107,111.6090881,1.8,55.2567344,111.9879996,-0.0275466,8.4722433,15.8833187,1726.914,6919.6194991,0.0173858,435.653256,203.8319639,542.6559693,14.5517107,28.199693,3.0688048,99.1799834),(39194,'tibia.tif',235,8,268,133.1582175,52.6528504,111.3394486,1.8,53.7382969,111.600395,-0.0870481,8.0289395,16.6927715,1513.8805595,6367.056307,0.1677407,381.4259558,188.5529916,469.0134925,14.355481,28.7483062,0.0509762,90.9352101),(39195,'tibia.tif',235,8,269,128.4699552,51.0393084,111.1627556,1.8,51.922046,111.3543859,-0.1456061,8.0312658,17.0587228,1403.5276575,5211.5173961,0.4507525,305.5045474,174.7579635,383.7288549,14.062512,24.8816762,0.2135604,70.1602837),(39196,'tibia.tif',235,8,270,123.0102818,49.8446519,111.0225739,1.8,50.1615337,111.1785686,-0.2080385,8.0622111,13.1155989,1337.2610313,4023.8015829,0.8745868,306.7951079,165.8677769,408.7457556,13.769543,24.4220898,0.1809265,68.6746181),(39197,'tibia.tif',235,8,271,117.744378,49.2137023,110.8628838,1.8,49.4531151,111.0334265,-0.2437474,7.9125729,12.3270611,1280.6994325,3416.894172,1.143012,277.1864387,161.8562569,381.0166815,13.769543,24.023458,0.2213144,73.9897014),(39198,'tibia.tif',235,8,272,110.3798583,48.63616,110.6943403,1.8,48.7608286,110.8530639,-0.3004056,7.8212633,11.5902946,1202.8528258,2770.1104603,1.610835,239.0025932,153.7926514,340.9999971,13.476574,23.845949,0.1853479,71.4032459),(39199,'tibia.tif',235,8,273,101.1593898,48.1019373,110.4060102,1.8,48.1147973,110.6118435,-0.3877298,7.5752075,10.5828209,1095.5767564,2140.4903407,2.4101279,202.2608486,144.6266326,301.2789032,13.476574,23.3273979,0.2023216,71.3321597),(39200,'tibia.tif',235,8,274,92.7169128,47.5386301,110.2206986,1.8,47.4225218,110.4398984,-0.5365439,7.5682236,9.5213573,966.7077025,1665.8861698,4.0377184,174.9630973,127.7324448,268.0630411,13.476574,22.928451,0.1798535,74.9605153),(39201,'tibia.tif',235,8,275,85.8526048,46.8093688,110.0323469,1.8,46.735615,110.2805911,-0.7065752,7.6454566,9.2096412,816.2575188,1371.426611,6.0311901,148.912056,106.7637378,230.3665621,13.476574,22.4078197,0.1973956,71.4743321),(39202,'tibia.tif',235,8,276,79.4033279,46.0266528,109.8324291,1.8,46.0461664,110.0185567,-0.8482426,7.6132005,9.0768203,668.8619155,1171.3010034,7.4464318,129.043097,87.8555495,199.2179242,13.476574,22.2540764,0.280108,71.8175667),(39203,'tibia.tif',235,8,277,72.4661156,45.3201532,109.5603723,1.8,45.4406673,109.7652108,-0.9621056,6.9488481,9.1265089,536.3186086,988.5064283,8.1289084,108.3115612,77.180937,166.5047388,13.769543,22.0272947,0.2417529,71.6165045),(39204,'tibia.tif',235,8,278,64.887487,44.6457513,109.2250512,1.8,44.8482955,109.5043002,-1.0578704,6.1241017,8.4639902,423.0981684,808.5899027,8.2102713,95.5329445,69.0873843,145.1558136,13.769543,21.7764865,0.3004772,68.0592352),(39205,'tibia.tif',235,8,279,54.7488887,44.0875664,108.8911546,1.8,44.3210119,109.2083294,-1.1249957,5.4629715,8.6721309,300.8008707,634.7326027,7.4283605,73.1922306,55.0617679,107.7548842,13.769543,21.6103117,0.2745753,71.9597391),(39206,'tibia.tif',235,8,280,43.4647868,43.6810329,108.4686796,1.8,43.8715705,108.850877,-1.1718641,5.0756652,8.3735088,194.6577468,455.3930415,6.1511261,54.384972,38.3511798,77.5754513,13.769543,21.4968187,0.3045109,71.7881218),(39207,'tibia.tif',235,8,281,32.6849021,43.3132202,107.9336911,1.8,43.4470289,108.3182145,-1.2012946,4.3704714,8.4721274,113.39612,309.2112531,4.7369688,36.4974746,25.9459701,49.7943502,13.769543,21.3083344,0.3217506,66.816273),(39208,'tibia.tif',235,8,282,23.1097963,43.0641524,107.3084468,1.8,43.0689153,107.7217345,-1.2107706,3.6651353,8.6997409,58.9206343,169.9601493,3.3735907,19.5362311,16.0759778,26.2056769,13.769543,21.126295,0.3392926,68.3730249),(39209,'tibia.tif',235,8,283,15.2171048,42.9075697,106.3523123,1.8,42.7906014,106.9084446,-1.3564454,2.9176002,9.048221,26.618725,44.6646064,2.4214296,4.936286,9.1234999,7.8747501,13.476574,20.9508685,0.357134,70.7878631),(39210,'tibia.tif',235,8,284,11.6925006,42.3221623,105.9732798,1.8,42.3828487,106.2045177,1.4605656,2.3156679,4.0139508,12.5751309,18.5960915,1.9251669,4.6328648,5.4304553,7.1129043,13.476574,20.8913809,0.3883187,64.8157555),(39211,'tibia.tif',235,8,285,7.9756093,41.7911072,105.7723519,1.8,41.9402245,105.8854647,1.5682218,1.8628033,3.7952908,4.6951437,10.8220328,1.3292594,2.851437,2.5204721,3.9329102,13.769543,20.8502561,0.3439691,69.3732836),(39212,'tibia.tif',235,8,286,4.2624893,41.3228696,105.5396157,1.8,41.4717595,105.6286413,1.5667786,1.1614417,2.2717237,1.020522,4.4819362,0.7104034,1.9729231,0.8786683,2.3405953,13.769543,20.7822222,0.3752708,64.6441383),(39213,'tibia.tif',235,8,287,1.1823588,40.927632,105.3255231,1.8,41.0473323,105.4530038,1.5464728,0.6845317,1.8955842,0.0765098,0.7436862,0.1969432,0.3923256,0.1117695,0.4289402,14.062512,20.6766387,0.3620874,65.9287418),(39214,'tibia.tif',235,8,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39215,'tibia.tif',235,8,289,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39216,'tibia.tif',235,8,290,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39217,'tibia.tif',235,8,291,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39218,'tibia.tif',235,8,292,0.0065804,84.375072,113.379003,1.8,84.375072,113.379003,0.7853982,0.00000000000001005,0.00000000000001005,0.0000471,0.0000471,0.0005484,4683891308.17004,4683891306.22791,6624022611.32223,0.292969,0.4143207,2.3561945,0.8286415),(39219,'tibia.tif',235,8,293,18.0690554,83.8111566,113.8072175,1.8,83.814194,113.8249153,-1.3390129,5.566951,5.5442429,114.5213056,118.5755029,2.8525968,21.3871406,20.5716389,41.085037,11.132822,11.6194623,0.9827937,37.1223007),(39220,'tibia.tif',235,8,294,40.754145,83.4768213,113.8585763,1.8,83.3452922,113.8826088,-1.4913944,7.3896186,7.8736968,488.1949962,581.9588568,6.7496239,73.9117689,66.0649787,132.5523376,15.527357,16.2062443,0.8621701,51.9545644),(39221,'tibia.tif',235,8,295,59.6088386,82.8966751,113.8716531,1.8,82.734117,113.8675927,-1.550643,8.4966583,9.3273396,917.5787472,1294.4243416,9.9307719,138.7774435,107.9928969,220.9123159,18.750016,19.3559189,0.6889244,62.6141759),(39222,'tibia.tif',235,8,296,78.1996154,82.4517068,113.8792514,1.8,82.2391929,113.8706135,-1.5575653,9.230774,10.5012309,1414.09274,2188.0897617,13.0309877,208.3650747,153.1933009,312.6683236,21.093768,21.9179192,0.9085808,70.3735423),(39223,'tibia.tif',235,8,297,93.1381861,82.0978912,113.8263321,1.8,81.9051514,113.8033554,-1.5643837,9.7466101,11.6039091,1904.962617,3197.392154,15.5223927,275.5443987,195.4487361,402.1147343,23.43752,23.8962873,0.7072965,77.6891431),(39224,'tibia.tif',235,8,298,105.0940053,81.7738874,113.8422177,1.8,81.5915728,113.8098091,-1.5655696,10.2963256,12.4899001,2362.3353799,4137.5946589,17.515189,331.2752404,229.4347968,480.1843472,24.902365,25.3583244,0.7036138,82.276116),(39225,'tibia.tif',235,8,299,115.4363088,81.5039881,113.8535561,1.8,81.3426776,113.8124168,-1.5684673,10.6092959,13.0802362,2792.7063272,5056.4311418,19.2392805,386.570325,263.2320139,550.5420397,26.074241,26.5973258,0.8633648,86.5198544),(39226,'tibia.tif',235,8,300,124.0218372,81.2909387,113.8465207,1.8,81.1391168,113.8162499,-1.568875,10.9792567,13.3679948,3170.1932255,5883.4577623,20.6702299,440.1152057,288.7438836,609.3323541,26.953148,27.584241,1.0358413,89.5206306),(39227,'tibia.tif',235,8,301,130.4106164,81.1324104,113.8408727,1.8,80.9880777,113.8096934,-1.5687356,11.1155589,13.9457001,3471.571857,6542.1263761,21.7350104,469.1142293,312.3164478,659.4167263,27.832055,28.2377134,1.0374941,92.006555),(39228,'tibia.tif',235,8,302,132.1216411,80.962191,114.0567326,1.8,80.8587524,113.9309998,1.542404,11.2533857,14.1348819,3647.9835899,6689.9639556,22.0025273,473.2946486,324.1676484,658.2082962,28.125024,28.719929,1.2490458,93.3500483),(39229,'tibia.tif',235,8,303,130.6831683,80.8137821,114.3659201,1.8,80.7218079,114.2599602,1.4913708,11.1598613,14.5668481,3683.1142216,6521.325771,21.6434161,447.6826934,330.0322569,629.7196745,28.417993,28.9432021,1.0164888,94.1786898),(39230,'tibia.tif',235,8,304,128.6271817,80.7307918,114.5833986,1.8,80.6381262,114.4542651,1.4498031,11.0966002,14.7074962,3635.486149,6311.3546949,21.1255551,429.1250272,327.6216219,605.3200109,28.417993,29.0497637,0.8424789,94.5219243),(39231,'tibia.tif',235,8,305,201.2332536,72.6440223,114.615835,1.8,68.6834958,114.1540581,0.0164659,15.2312606,28.3739794,9224.2859779,27073.6767974,0.0090921,954.1727077,605.6154001,1275.5774719,28.710962,54.1358833,0.0921298,196.2122251),(39232,'tibia.tif',235,8,306,545.5093937,61.556613,113.5311889,1.8,65.6531295,113.6880173,0.0757427,15.7636774,28.9974502,27328.2101228,83318.042572,0.5205976,2873.288585,1733.6189638,3573.0045471,29.0706824,57.3718284,3.0495458,180.2253338),(39233,'tibia.tif',235,8,307,575.0466191,60.8728634,113.3776163,1.8,65.5528243,113.7071858,0.0855139,15.9003199,29.8216506,28886.0139167,87673.0234569,0.6991436,2939.9118279,1816.6938893,3668.1845148,29.0936895,57.3994985,3.0444634,180.1542476),(39234,'tibia.tif',235,8,308,575.4228182,60.8659154,113.3842106,1.8,65.5594997,113.7118589,0.0870262,15.9441991,29.8445565,28891.82088,87462.8378172,0.7245012,2930.6127495,1812.0584622,3661.3497381,29.0860205,57.4286499,3.0393859,179.7399268),(39235,'tibia.tif',235,8,309,575.2255113,60.8781076,113.3905031,1.8,65.5369293,113.7307766,0.0879249,15.9711986,29.8416596,28866.0015606,87238.3267627,0.7392505,2923.3738289,1807.3785412,3655.0493991,29.0936895,57.3994985,3.0444634,179.9115441),(39236,'tibia.tif',235,8,310,575.2948522,60.8997398,113.3960563,1.8,65.5645074,113.7349297,0.0873898,15.9618687,29.813795,28879.4203046,87107.3490528,0.73039,2921.7128865,1809.2756496,3653.8729548,29.0936895,57.3994985,3.0444634,180.0831614),(39237,'tibia.tif',235,8,311,577.0070734,60.9151276,113.4017357,1.8,65.5675401,113.759576,0.0870293,15.9574567,29.7940417,29029.1402002,87226.5396798,0.7265478,2927.6504563,1819.158323,3664.2309526,29.1013586,57.3718284,3.0495458,179.9115441),(39238,'tibia.tif',235,8,312,577.3505267,60.9321368,113.4015327,1.8,65.5893858,113.7588032,0.0869391,15.9535928,29.7761303,29063.4614694,87157.2959322,0.7254788,2927.0860573,1821.7502366,3664.8995822,29.0860205,57.4824291,3.0957065,179.9826303),(39239,'metatarsal.tif',235,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39240,'metatarsal.tif',235,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39241,'metatarsal.tif',235,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39242,'metatarsal.tif',235,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39243,'metatarsal.tif',235,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39244,'metatarsal.tif',235,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39245,'metatarsal.tif',235,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39246,'metatarsal.tif',235,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39247,'metatarsal.tif',235,10,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39248,'metatarsal.tif',235,10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39249,'metatarsal.tif',235,10,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39250,'metatarsal.tif',235,10,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39251,'metatarsal.tif',235,10,13,9.0830274,81.1189832,93.7229371,1.8,81.2081399,93.4676262,-1.1854481,2.5620834,4.6406993,11.0680454,32.6477488,1.299952,7.0350925,4.3199396,9.4141926,5.183675,8.8124685,1.1618885,22.2818711),(39252,'metatarsal.tif',235,10,14,25.7244426,82.1359295,92.9916422,1.8,82.206955,92.9807003,-1.2129717,4.3549466,6.1793457,84.8515723,194.8137888,3.7614867,31.5266048,19.4839526,45.1835623,8.5592822,12.3161216,1.1659045,32.851045),(39253,'metatarsal.tif',235,10,15,38.1744805,82.7342008,92.8504646,1.8,82.3155999,92.7203291,-1.3463419,5.37039,6.3091926,212.4123505,356.5740068,6.0472231,56.5165832,39.5524998,84.9846516,10.242178,13.3138493,1.0164888,38.4649518),(39254,'metatarsal.tif',235,10,16,46.4984572,82.5027708,92.7065059,1.8,82.1556074,92.4985529,1.4644203,5.7518855,6.8811904,328.9558304,535.2464232,7.6623782,77.7839867,57.1909563,117.1554756,12.355464,13.9948635,1.2977876,43.2894206),(39255,'metatarsal.tif',235,10,17,50.7091631,82.2581765,92.6318019,1.8,82.0920174,92.3890044,1.2969137,5.9014655,7.8777715,370.4928023,675.0638885,7.8332575,85.6922399,62.7797967,132.0208296,13.207019,15.2111988,2.0899424,45.9847306),(39256,'metatarsal.tif',235,10,18,47.9449022,82.1847615,92.6092183,1.8,82.0443259,92.3795918,1.330578,5.7873192,8.2112555,336.6429335,687.8177512,7.5385097,83.7652354,58.1690628,123.1305517,13.7204418,15.5792648,2.2212177,47.8906025),(39257,'metatarsal.tif',235,10,19,47.2536114,82.1371245,92.4780835,1.8,82.1499849,92.4507288,1.2991251,5.9652018,8.5331426,338.5729651,693.0857392,7.3085013,81.2228005,56.7580072,118.5549381,13.6561916,15.8748954,2.2720562,48.4296645),(39258,'metatarsal.tif',235,10,20,47.7974949,82.1009072,92.4665616,1.8,82.2373061,92.459525,1.2095932,6.3303864,8.4762252,339.7657578,699.2636059,6.971332,82.4970535,53.6721987,122.2558404,12.9724523,15.4951025,2.2699889,46.4313041),(39259,'metatarsal.tif',235,10,21,47.6767029,81.930132,92.1752596,1.8,82.1846361,92.2436625,1.0863669,6.6952056,8.2170767,344.2516892,665.9335659,6.2227651,81.0426368,51.4176428,122.6556551,12.3576379,15.0865147,2.4194013,45.8651529),(39260,'metatarsal.tif',235,10,22,47.0244873,81.5604575,91.6804776,1.8,82.0498739,91.8500977,0.9622742,6.8650736,8.3978494,344.6322669,591.670395,5.2762256,70.4549896,50.2008118,111.4786268,11.8164063,14.885336,2.3049573,44.1825677),(39261,'metatarsal.tif',235,10,23,47.0474261,81.0448693,91.2134478,1.8,81.6131445,91.316436,0.8204313,7.0213969,25.4809042,346.4219369,655.4771223,4.1950973,25.7242489,49.3380365,39.1068626,11.6258191,13.9454621,2.2878081,41.7376337),(39262,'metatarsal.tif',235,10,24,50.9151502,79.6717238,90.0820307,1.8,80.5792743,90.4371457,0.6988862,6.8190778,24.530098,360.7966239,2160.5772434,3.5124583,88.0786226,52.9098855,102.645049,11.4352319,13.9766833,2.2605964,41.3564593),(39263,'metatarsal.tif',235,10,25,60.249404,77.1835774,88.6526229,1.8,77.9322828,89.155571,0.5854989,11.9327592,21.5119138,644.8776765,4707.5642645,3.0665299,218.8352141,54.0426287,243.6188818,18.1057838,20.7748788,1.9705774,63.7037296),(39264,'metatarsal.tif',235,10,26,72.7734757,74.7119182,87.7405292,1.8,74.961957,88.0937143,0.5223911,13.1310962,18.7248357,1124.5363574,6506.2617336,3.0195513,347.4669596,85.6391837,385.051086,20.6820146,24.8232052,0.8468591,100.6552045),(39265,'metatarsal.tif',235,10,27,85.5930445,73.0970137,87.2184408,1.8,73.0065575,87.578421,0.5050077,14.3267934,17.0736877,1725.9140828,7412.1487529,3.3392148,434.1269952,120.467577,491.3385708,20.6819815,25.406067,1.6451272,91.4416198),(39266,'metatarsal.tif',235,10,28,98.3425199,72.1725218,87.0343832,1.8,71.866009,87.3553318,0.5034997,15.2146861,16.163979,2448.38571,7852.512823,3.8156952,485.8032058,160.9225253,575.5342177,20.9673311,26.5511977,1.4691075,88.7079999),(39267,'metatarsal.tif',235,10,29,110.3251737,71.6002667,86.8886066,1.8,71.4492506,86.8162253,0.5076146,14.8428433,15.624508,3141.5296388,8070.8755687,4.3447418,516.5523005,211.6528196,642.5580477,20.8392613,26.5799113,1.4590193,87.0908139),(39268,'metatarsal.tif',235,10,30,121.2918707,71.3621824,86.4056866,1.8,71.2523229,86.1253037,0.5455626,15.2370263,15.4590932,3535.443343,8436.2037531,5.4430995,545.7114227,232.0297462,714.0933125,20.5588312,27.0674083,0.66541,85.6969147),(39269,'metatarsal.tif',235,10,31,131.5160938,71.1674267,85.9539616,1.8,71.0907398,85.5264913,0.583165,15.7972768,15.6351747,3965.5501855,8563.9910189,6.6467331,547.7387486,251.0274539,780.1851085,20.3625154,28.3840587,0.5273909,99.7620574),(39270,'metatarsal.tif',235,10,32,138.8865681,71.2853382,85.5791263,1.8,71.0515396,85.1173535,0.646163,16.6228396,15.7176181,4440.4888712,8553.211397,8.3923918,544.1798699,267.1317877,781.2358745,19.8105635,29.2996438,0.6876713,91.3874414),(39271,'metatarsal.tif',235,10,33,149.5986045,71.1388679,85.4203534,1.8,71.0084619,85.2371247,0.7210164,17.1644167,15.7942906,5313.9846286,8616.1645183,10.8657447,545.5239968,309.5930791,802.7662784,27.5714015,36.507275,3.0602908,156.4467602),(39272,'metatarsal.tif',235,10,34,153.2958505,71.4568396,85.803201,1.8,71.0857925,85.7443956,0.8958205,16.6369352,15.792126,5429.1564716,8754.5094007,15.5729919,554.3591403,326.331528,813.6035069,28.4804998,35.7776387,0.1056656,145.1152375),(39273,'metatarsal.tif',235,10,35,167.2198291,71.4459105,86.1609506,1.8,71.1840997,86.0463532,0.9959099,15.8295467,16.4014671,5598.19329,8931.8095382,19.6301405,544.5738173,353.6546818,848.1544807,29.1284096,35.411286,0.0761881,203.9132306),(39274,'metatarsal.tif',235,10,36,178.6925893,71.4042369,86.0012719,1.8,71.1653616,86.0323631,1.0416008,15.5584764,15.8366488,5794.2227206,9122.5999695,22.1917577,576.0435845,372.4158191,865.2658557,29.2533748,34.9611942,0.1626138,195.4619947),(39275,'metatarsal.tif',235,10,37,180.6297535,71.1757676,85.922361,1.8,71.07903,86.1039805,1.0935789,14.9849778,15.7333797,6017.6812341,9196.8064187,23.7538671,584.5410567,401.5809255,885.6881999,28.8323079,34.7872543,0.1791605,165.224992),(39276,'metatarsal.tif',235,10,38,175.2532841,71.1065367,86.1633127,1.8,71.1437811,86.1806498,1.1769659,14.0769823,15.5133879,5968.7104553,8558.7215699,24.9079453,551.6990637,424.0049683,857.6304851,27.9133739,33.9951149,0.2565166,112.6182777),(39277,'metatarsal.tif',235,10,39,175.307307,71.4701586,85.9848614,1.8,71.3011905,86.1448385,1.3236551,13.2888206,15.3804374,5779.3037084,7849.734923,27.469331,510.3713713,434.8996707,788.2503074,27.3053966,33.2846232,0.2705134,107.5705221),(39278,'metatarsal.tif',235,10,40,174.688509,71.6913032,86.0406831,1.8,71.5026516,86.2649333,1.4366129,13.244506,14.9010622,5645.5546054,7305.3513322,28.5936734,490.2570857,426.2563362,795.2720016,26.7185639,32.6232733,0.2590058,108.3328709),(39279,'metatarsal.tif',235,10,41,168.1310862,71.8249578,86.5837995,1.8,71.6791976,86.4040773,-1.5000621,13.4803575,13.5000388,5436.6914944,5978.128411,27.8818786,442.8230531,403.3046959,715.9658248,25.8049511,31.331747,0.3789089,160.1006166),(39280,'metatarsal.tif',235,10,42,164.2337089,71.6797926,86.9867489,1.8,71.6978633,87.0600086,-0.8626163,13.1278584,15.5389332,5217.2530302,5592.1703589,15.7913885,359.8812277,397.418442,695.5785638,23.711147,28.8246991,0.4971079,150.1088146),(39281,'metatarsal.tif',235,10,43,164.4190687,71.5114942,87.1159428,1.8,71.6746757,87.3478002,-0.9408689,12.8733921,14.8676943,5172.1073661,5688.1374764,17.8936611,382.5836993,401.7672511,727.7867099,23.2961355,28.2223541,0.4978223,133.2829627),(39282,'metatarsal.tif',235,10,44,162.7155635,71.4215512,87.0534626,1.8,71.6809257,87.3615291,-1.1029756,12.8979066,14.4695705,4902.7951435,6101.8132783,21.6045893,421.699681,380.1233243,760.0126507,22.783052,28.2184927,1.1370543,120.835006),(39283,'metatarsal.tif',235,10,45,158.6359524,71.4646916,87.0761554,1.8,71.8984234,87.5204423,-1.0571151,12.5194772,14.7452672,4648.6425955,6210.1899225,20.0552633,421.1649634,371.3128366,736.1700453,22.6705428,28.6920782,1.1239539,103.9820649),(39284,'metatarsal.tif',235,10,46,158.912319,71.4976999,87.1159994,1.8,72.1203987,87.575878,-1.0201354,12.3439529,14.5032572,4356.7781722,6270.7416264,19.2339225,432.3678143,352.9483804,732.7656329,22.0668789,28.4492492,1.1198599,91.0333562),(39285,'metatarsal.tif',235,10,47,145.4124886,72.3060338,87.1589945,1.8,72.7362047,87.5514198,-1.1431847,11.9575387,14.1699228,3461.0404778,5758.9997635,20.0675291,406.4242159,289.4442216,650.6461638,21.1837165,27.5410041,1.2211892,93.5053794),(39286,'metatarsal.tif',235,10,48,134.1992102,72.9154848,87.7605546,1.8,73.2355529,87.8659704,-1.1418501,10.9736098,13.274184,2757.931489,5516.2060049,18.4974956,415.5589539,251.3239978,620.324887,20.5343018,26.287219,1.3009472,91.8881934),(39287,'metatarsal.tif',235,10,49,122.8070441,72.8908863,88.6089535,1.8,73.3283116,88.3335323,-1.1068813,10.6511299,12.904887,2112.3251874,4891.888777,16.369893,379.0725788,198.319352,523.0641548,19.7751579,25.1762731,1.2998495,97.4096118),(39288,'metatarsal.tif',235,10,50,109.5938609,73.2839552,88.9868812,1.8,73.6523793,88.5857925,-1.0232108,10.2290225,12.0224748,2062.8875725,4728.7283945,13.3146904,393.3240441,201.6700583,531.2001584,19.4398942,24.3787772,1.4711277,84.4067246),(39289,'metatarsal.tif',235,10,51,128.6036771,73.9566476,88.8414622,1.8,74.0576131,88.5603603,-0.9113594,9.7343002,11.6611413,2522.6076961,4915.1806266,13.3883531,421.5008197,259.146281,604.7053383,19.4047651,23.5743344,0.5404195,88.5884222),(39290,'metatarsal.tif',235,10,52,139.6205666,73.7445432,89.2296465,1.8,74.3627373,88.6682966,-0.770113,10.103166,12.1422489,2771.8995443,5240.2404787,11.2794151,431.5708333,274.3594979,629.3032522,19.1531045,23.848544,0.6005411,80.7528683),(39291,'metatarsal.tif',235,10,53,125.1911412,73.9929266,89.8917061,1.8,74.6621643,89.2954515,-0.5899374,10.8015719,12.5167455,2155.1657408,4872.7237163,6.4573523,389.2963806,199.5233432,551.8150671,18.4869582,23.5126214,0.4380122,102.1911228),(39292,'metatarsal.tif',235,10,54,141.1430047,74.0399482,88.8590177,1.8,74.7456767,88.8695797,-0.8753361,9.6037728,12.0982849,3000.4791957,5365.0037512,13.8662114,443.4515952,312.4271338,687.8924157,18.2783913,24.5154706,1.3151514,77.0719227),(39293,'metatarsal.tif',235,10,55,137.8791749,74.0962925,89.4018098,1.8,74.8332303,89.3457901,-0.9716252,9.8169734,11.4059281,3170.5447891,5064.4055326,15.6711434,444.0152068,322.9656093,688.1453653,18.4693356,24.0124743,1.6157099,78.4770426),(39294,'metatarsal.tif',235,10,56,135.2696741,74.2636238,89.6959235,1.8,74.9488884,89.6102518,-1.055462,10.2527619,11.1657562,3244.414799,4514.39871,17.0692912,404.3074765,316.4430074,656.9383074,18.8143553,23.7569828,1.6275535,77.2298103),(39295,'metatarsal.tif',235,10,57,141.6023977,74.519754,89.6269038,1.8,75.2325092,89.3145405,-1.2927492,10.5369481,11.2458827,3313.6677971,4469.1872275,21.8223852,397.4065307,314.4807945,592.4148956,19.39818,23.8805074,0.6412438,80.6874691),(39296,'metatarsal.tif',235,10,58,155.9302274,74.3712521,89.1335472,1.8,75.2758099,89.1208775,-1.1294759,10.6750856,11.4040011,3433.4293123,4955.7010241,21.2469675,434.558099,321.6301428,661.2213731,19.5807893,23.5481262,1.4791002,85.5119378),(39297,'metatarsal.tif',235,10,59,157.4214273,74.5389545,88.8423503,1.8,75.3277359,88.9740635,-0.9501284,11.4705403,11.8316918,3530.3766615,5221.1129098,17.3626992,441.282023,307.7777125,687.631394,19.5815332,23.7707395,0.5093011,73.4451555),(39298,'metatarsal.tif',235,10,60,76.3648553,72.0782464,88.3981,1.8,72.2796894,88.1612234,-1.2014631,8.7675277,10.946312,947.8469439,1499.2049679,11.0688767,136.9598237,108.1088057,221.6890203,14.824205,20.184255,0.9753865,60.3656484),(39299,'metatarsal.tif',235,10,61,97.8536059,72.6971953,88.7300918,1.8,72.7463314,88.5560024,-1.3854443,8.2937591,10.084589,1350.1928538,1728.9144761,15.7550221,171.4412428,162.7962467,297.6837947,15.793606,19.4361568,0.9827937,61.7324584),(39300,'metatarsal.tif',235,10,62,83.9611076,72.3377122,88.6914802,1.8,72.6321765,88.6663895,-1.3216533,8.8758572,9.4072042,1190.3670338,1575.5511378,13.1427327,167.4834623,134.1129096,260.9880024,15.4592998,18.6522463,0.9186249,59.3800129),(39301,'metatarsal.tif',235,10,63,74.8539746,71.9442634,88.5510425,1.8,72.1804761,88.5580112,-1.1896669,9.3775734,9.3522069,882.7163008,1419.9603393,10.7495171,151.8315791,94.1305671,221.3195994,14.2079115,17.8888194,1.0329608,56.3960169),(39302,'metatarsal.tif',235,10,64,72.8332224,71.7556116,88.5866809,1.8,71.9840768,88.6060868,-1.178729,8.5140443,9.1178405,808.4471054,1327.4252355,10.3665933,145.5854859,94.9545335,232.4953687,13.5195451,17.3591356,1.1210367,50.9016877),(39303,'metatarsal.tif',235,10,65,71.0996458,71.6601253,88.5224209,1.8,71.9503867,88.5735276,-1.1639827,8.6617648,8.5446931,757.9450923,1202.4736622,9.9946352,140.7275418,87.5046959,218.720435,13.3186145,16.5996964,1.0053124,54.7788309),(39304,'metatarsal.tif',235,10,66,71.3267446,71.6567488,88.600584,1.8,71.9541514,88.7807577,-1.2077128,8.1352924,7.9907945,753.5395954,1126.0066442,10.3882947,140.9129768,92.6259999,225.5472133,13.5132969,15.8680296,1.2060615,48.7837497),(39305,'metatarsal.tif',235,10,67,70.9287273,71.6623542,88.6567457,1.8,71.9789297,88.882958,-1.2866822,8.0367174,7.5234251,746.4779712,1047.3972283,10.8926176,139.2181375,92.8834411,216.5011174,13.0950683,15.3656311,1.1935473,47.1665637),(39306,'metatarsal.tif',235,10,68,69.9556543,71.6407173,88.8820527,1.8,71.9522369,89.1422889,-1.4067124,7.4638446,7.4531499,742.9774381,980.8262534,11.3481739,131.5988895,99.5435295,212.1782508,12.6612641,14.9218944,1.2776094,46.3771257),(39307,'metatarsal.tif',235,10,69,68.4945478,71.6409755,89.056434,1.8,72.0240013,89.2883165,-1.5039387,7.9717035,6.985609,739.0904082,906.3271264,11.3648062,129.7420346,92.7142366,203.9322962,12.4200516,14.3283045,1.2847449,46.7853893),(39308,'metatarsal.tif',235,10,70,67.8009014,71.7100732,89.3092043,1.8,72.0602175,89.5320122,1.2594446,6.3465494,6.8712546,748.4803482,870.5789438,10.2396576,126.6986881,117.9350076,203.1555646,12.0903735,14.1497357,2.4370986,44.4058545),(39309,'metatarsal.tif',235,10,71,67.6368073,71.7697612,89.4921957,1.8,72.124233,89.6872034,0.9000989,6.4572169,7.8123086,734.765957,868.9860611,6.9180885,111.2329404,113.7898841,199.9275121,11.9427384,14.3561633,2.4492582,43.5781065),(39310,'metatarsal.tif',235,10,72,67.4485196,71.7887148,89.6406903,1.8,72.1775741,89.8062616,0.748868,6.1134068,7.8522248,716.5595855,862.6203995,5.2104244,109.8568138,117.2111729,172.6167321,11.919727,14.3257692,2.4227627,43.5781065),(39311,'metatarsal.tif',235,10,73,66.8348289,71.8158794,89.751857,1.8,72.1523864,89.9347707,0.668781,6.0996407,7.6556845,683.0221936,842.876255,4.2822993,110.0980925,111.9774462,198.8015321,11.6483606,14.0699313,2.5057542,42.2766957),(39312,'metatarsal.tif',235,10,74,67.0681798,71.8225544,89.8598619,1.8,72.15273,89.9928072,0.5664908,6.0566777,8.2295809,658.8783301,835.6967302,3.2194889,101.5479093,108.7854362,160.1429191,11.8164063,14.0182034,2.4788631,43.5781065),(39313,'metatarsal.tif',235,10,75,67.8173901,71.7867279,89.9433593,1.8,72.0420703,90.0468859,0.5538383,6.0310744,7.6045379,651.3497849,815.2931345,3.1267131,107.2113977,107.998964,176.9783139,11.5451207,13.91156,2.5213432,41.3564593),(39314,'metatarsal.tif',235,10,76,68.3390613,71.7405015,89.9975022,1.8,71.9869352,90.0738457,0.5363479,5.9720281,7.5632942,645.5488064,794.865027,2.9741284,105.0950829,108.0954062,172.9316102,11.5649685,13.7566468,2.5372871,41.1985717),(39315,'metatarsal.tif',235,10,77,68.9177493,71.6972228,90.0618937,1.8,71.9073089,90.1285592,0.5000001,6.8289024,8.280442,636.1374214,781.9176066,2.6401119,94.429453,93.1536851,154.5439624,11.4352319,13.639973,2.4822826,40.8173973),(39316,'metatarsal.tif',235,10,78,69.8659903,71.6746981,90.0912154,1.8,71.8519971,90.1642828,0.4467402,6.9723647,7.4329663,634.5039147,779.3976858,2.1733934,104.8568836,91.0026861,180.0896254,11.4352319,13.47655,2.4980915,40.4362229),(39317,'metatarsal.tif',235,10,79,70.5382829,71.6458133,90.1297244,1.8,71.8047662,90.2004425,0.4070052,6.2839726,7.3945613,626.7649459,779.0430357,1.842294,105.3535165,99.740242,178.4535788,11.5731874,13.4062888,2.6149654,40.4362229),(39318,'metatarsal.tif',235,10,80,71.1425075,71.5969005,90.1515686,1.8,71.7435617,90.209397,0.3722299,5.9728914,7.6631883,628.3513279,771.3234031,1.5683718,100.6530667,105.2005279,179.7021526,11.5649685,13.3165772,2.5142845,40.4362229),(39319,'metatarsal.tif',235,10,81,70.47497,71.5857644,90.1684394,1.8,71.752223,90.2253635,0.3412336,7.0477075,7.7645309,618.6862766,753.0238183,1.3154211,96.9825256,87.7854647,167.3560818,11.5649685,13.1739739,2.6046819,39.8971609),(39320,'metatarsal.tif',235,10,82,70.273958,71.5234422,90.1821188,1.8,71.7213118,90.2405686,0.3091335,6.7863722,7.3864866,614.985249,738.2808521,1.0840685,99.9502057,90.6206184,175.2866245,11.7069259,13.1436095,2.6504291,40.0550486),(39321,'metatarsal.tif',235,10,83,69.8857371,71.4433682,90.1800151,1.8,71.6222636,90.2236357,0.2750981,5.999124,7.4629459,612.725482,719.2522104,0.859467,96.3764466,102.1358261,170.7593846,11.7069259,13.0186542,2.668686,39.8971609),(39322,'metatarsal.tif',235,10,84,69.820641,71.3596315,90.1952717,1.8,71.514869,90.2620385,0.2397233,6.8562689,7.6162537,609.6188408,704.1715009,0.656021,92.456413,88.9140799,166.6325274,11.6483606,12.8981215,2.6872906,39.7392733),(39323,'metatarsal.tif',235,10,85,69.8957976,71.2747237,90.1941461,1.8,71.4353546,90.2520584,0.1771414,6.3247652,7.4719725,611.9017988,694.0113449,0.3617366,92.8819458,96.7469584,174.5048234,11.6726782,12.8501572,2.9729957,39.5813857),(39324,'metatarsal.tif',235,10,86,70.0530232,71.1848245,90.1758369,1.8,71.3107736,90.1891899,0.0324439,6.5730978,7.5093247,615.6430581,682.723255,0.0122855,90.9167313,93.6610225,172.6602918,11.6954475,12.6880126,2.927532,39.5813857),(39325,'metatarsal.tif',235,10,87,69.5303393,71.0696068,90.192551,1.8,71.1921731,90.2079431,-0.0198527,6.8990416,7.3658219,611.8159552,664.363092,0.0045667,90.1953783,88.6812966,173.2559998,11.5922512,12.6335019,2.9483812,39.0423237),(39326,'metatarsal.tif',235,10,88,69.4723979,70.9894028,90.1761425,1.8,71.1087575,90.2019354,-0.1956017,6.674857,7.119855,612.1254504,656.2831586,0.4373814,92.1764783,91.7061524,176.4863718,11.6258191,12.5034498,3.0118901,38.8844361),(39327,'metatarsal.tif',235,10,89,69.1599939,70.9541831,90.0617804,1.8,71.0644082,90.0892394,-0.4937326,5.9812347,6.7320269,607.2229238,657.5239473,2.5888474,97.6710213,101.5213337,168.955616,11.6258191,12.4247652,0.4248322,38.6611493),(39328,'metatarsal.tif',235,10,90,68.0917094,70.8529458,90.0136223,1.8,70.9851056,90.0427727,-0.6672112,6.3544184,6.0807338,580.9600812,655.3769386,4.3455052,107.7792524,91.4261612,168.6639079,11.4352319,12.4247652,0.4248322,39.0423237),(39329,'metatarsal.tif',235,10,91,67.6446444,70.7856916,90.0165206,1.8,70.8964613,90.0404204,-0.7752482,6.3471867,6.0388851,568.647882,655.5874221,5.5226298,108.5610022,89.590539,165.4937966,11.3999809,12.4159917,0.473356,38.8190369),(39330,'metatarsal.tif',235,10,92,67.2786358,70.7167806,90.0152572,1.8,70.8184821,90.0511346,-0.8567845,5.6736102,6.5214605,553.7170908,660.6660565,6.4042988,101.3064567,97.5951939,168.1463774,11.2422556,12.4364536,0.5218343,38.2145758),(39331,'metatarsal.tif',235,10,93,66.9595395,70.6600821,90.0089516,1.8,70.7546621,90.0621982,-0.8978089,6.5029931,6.1410964,542.3580682,667.6733358,6.8239154,108.722172,83.4012978,171.7426691,11.0540575,12.541159,0.4924858,38.4378626),(39332,'metatarsal.tif',235,10,94,66.3744894,70.5915556,89.9979156,1.8,70.6492899,90.0403371,-0.9310464,5.4313344,6.150004,526.4014404,672.0382312,7.1197384,109.2744389,96.9193574,168.5162948,10.9391626,12.4860072,0.5700405,38.5032617),(39333,'metatarsal.tif',235,10,95,66.2113639,70.5338896,89.9696599,1.8,70.5927291,90.0146855,-0.9432372,5.3520589,6.152751,512.596681,679.3689164,7.2306184,110.4170989,95.7756048,170.012073,10.806417,12.5729784,0.5404195,38.2799749),(39334,'metatarsal.tif',235,10,96,66.095547,70.4904214,89.9437555,1.8,70.5612163,89.9907083,-0.9653007,5.9622277,6.2288524,502.8423041,688.1280367,7.447271,110.474289,84.3379909,165.319712,10.6112995,12.5729784,0.5404195,38.2799749),(39335,'metatarsal.tif',235,10,97,65.2076251,70.492153,89.8446236,1.8,70.5586254,89.8592387,-0.9667741,5.790572,6.3727872,480.0308532,695.0325642,7.3622032,109.0625727,82.8986931,164.1211595,10.4524279,12.7137518,0.5585993,38.2799749),(39336,'metatarsal.tif',235,10,98,64.6709402,70.4386086,89.8283728,1.8,70.5057895,89.8592205,-0.9862102,5.7898002,6.4510025,466.9727051,697.408066,7.4959744,108.1084786,80.6543736,159.9825004,10.243535,12.72232,0.6350267,38.0566882),(39337,'metatarsal.tif',235,10,99,64.2800335,70.3966788,89.8195978,1.8,70.466905,89.8696579,-0.9997085,5.8671003,6.5073418,455.1542176,702.6152232,7.5829908,107.9726944,77.5773705,161.9702205,10.1100718,12.8048502,0.5295896,38.2799749),(39338,'metatarsal.tif',235,10,100,63.8034694,70.3515986,89.8044308,1.8,70.4332019,89.8504937,-1.0017129,5.48202,6.5247727,442.8339816,710.2051162,7.5461398,108.8474875,80.7793443,161.4974641,9.9938964,12.7849779,0.6055447,38.5032617),(39339,'metatarsal.tif',235,10,101,63.9206512,70.3273313,89.7562087,1.8,70.425469,89.7903283,-0.9982207,5.5032974,6.487227,432.1801415,731.8500994,7.5261683,112.8140108,78.5311266,164.0468236,9.9232695,12.9402953,0.6226708,38.8844361),(39340,'metatarsal.tif',235,10,102,63.3182978,70.2680002,89.7264811,1.8,70.3498439,89.7558711,-1.0081159,5.4795354,6.5218629,419.9964764,740.3587155,7.5499202,113.5195148,76.6481917,163.988869,9.8890304,13.0102812,0.6973908,39.4234981),(39341,'metatarsal.tif',235,10,103,62.4753289,70.2116377,89.7034246,1.8,70.2611495,89.7361181,-1.0070392,5.4551013,6.4589903,407.0873771,748.9668646,7.4392844,115.9572677,74.6250813,163.9672206,9.6210981,13.0493093,0.6682894,38.7265485),(39342,'metatarsal.tif',235,10,104,62.0443563,70.1779479,89.6798086,1.8,70.2360177,89.6988721,-1.0072084,5.3395564,6.4845888,396.310937,768.1496556,7.3895464,118.4577275,74.221697,166.8468643,9.5738431,13.2619113,0.6556956,38.8844361),(39343,'metatarsal.tif',235,10,105,60.0122447,70.1779711,89.6239156,1.8,70.2146224,89.633961,-1.0131521,5.1850323,6.5347208,377.4014036,764.3301421,7.2010614,116.9644673,72.7867023,162.5433716,9.3200689,13.2728625,1.152572,38.6611493),(39344,'metatarsal.tif',235,10,106,59.5957355,70.1660667,89.6017216,1.8,70.2431819,89.5851298,-1.0127796,5.2064448,6.6254496,365.4070431,776.1219445,7.1477601,117.1425332,70.1836012,162.421108,9.2423139,13.5357169,0.9551764,38.5957502),(39345,'metatarsal.tif',235,10,107,58.6162123,70.1538679,89.585436,1.8,70.1804732,89.5614233,-1.0150537,5.0858359,6.6233386,351.9063878,778.9377443,7.0502146,117.6050011,69.193421,160.7567032,9.1396383,13.5357169,0.9551764,38.4378626),(39346,'metatarsal.tif',235,10,108,57.9332648,70.1562533,89.5741048,1.8,70.1755592,89.5848245,-1.0154747,4.8930861,6.7003474,341.1529494,786.6898415,6.9717144,117.4103057,69.721428,156.4221166,9.1027498,13.47655,0.9272952,38.2145758),(39347,'metatarsal.tif',235,10,109,57.4631069,70.1689607,89.5567411,1.8,70.1784521,89.5654787,-1.0193523,4.5472185,6.8303888,330.4866951,796.6768823,6.948345,116.6371201,72.6788677,155.6233024,8.953791,13.6931298,0.9391057,38.2145758),(39348,'metatarsal.tif',235,10,110,56.7696807,70.1934727,89.5336593,1.8,70.2088875,89.57574,-1.0229945,4.7076735,6.8066487,322.2985487,805.2296748,6.8951972,118.3004609,68.4623832,156.2713758,8.8851828,13.7751174,1.0370881,38.4378626),(39349,'metatarsal.tif',235,10,111,56.1660065,70.2006345,89.5104365,1.8,70.2207137,89.5571742,-1.0286013,4.6352935,7.0745388,315.4267544,813.2821285,6.8684099,114.9590313,68.0489277,154.1522161,8.8753486,13.8539983,0.9234042,38.5957502),(39350,'metatarsal.tif',235,10,112,55.8021773,70.2048841,89.4958061,1.8,70.2169773,89.5500477,-1.0338287,4.3665075,7.0695643,309.6045923,822.2300428,6.8667765,116.3056173,70.9043991,154.9014186,8.6857047,13.9792819,0.9774462,38.5957502),(39351,'metatarsal.tif',235,10,113,54.5515709,70.2657913,89.4368453,1.8,70.3118185,89.4599937,-1.0403034,4.5273986,6.9996999,300.1121294,821.4457521,6.7644484,117.3544236,66.2879847,155.0532713,8.6461059,14.0699313,0.9349579,38.9769246),(39352,'metatarsal.tif',235,10,114,53.5582448,70.2880507,89.428334,1.8,70.3332994,89.4327082,-1.0506778,4.8045001,7.5356037,292.204873,822.9152034,6.7216306,109.2036207,60.8189966,146.0137621,8.6362716,14.285143,1.014197,38.7536378),(39353,'metatarsal.tif',235,10,115,52.6656998,70.3228565,89.426284,1.8,70.3720327,89.4421357,-1.058433,4.645612,7.493619,285.12889,821.7363774,6.668059,109.6581473,61.3759584,145.1837565,8.4444922,14.3536329,0.9723774,38.530351),(39354,'metatarsal.tif',235,10,116,52.7406362,70.351523,89.4478443,1.8,70.3902186,89.4658644,-1.0678622,4.5836486,7.5115916,283.0184346,830.0520547,6.7479672,110.5028206,61.74523,145.7820184,8.4431236,14.4293516,0.9983365,38.9115254),(39355,'metatarsal.tif',235,10,117,52.2682109,70.3714612,89.4573119,1.8,70.408219,89.4814363,-1.0715911,4.2670532,7.2140149,279.7633053,833.8773831,6.7148934,115.5913027,65.5635857,154.2035074,8.4431236,14.5870815,1.0906213,39.1348122),(39356,'metatarsal.tif',235,10,118,51.7271671,70.4171397,89.4358359,1.8,70.4498344,89.4549242,-1.0733352,4.5910203,7.1931204,278.3651475,843.1685983,6.6580112,117.2187516,60.6325236,154.6517705,8.4431236,14.6094753,1.0493619,39.1348122),(39357,'metatarsal.tif',235,10,119,51.380509,70.472983,89.4098418,1.8,70.4784565,89.4117093,-1.0734024,4.2911006,7.2518377,277.3042476,846.7690479,6.6138739,116.766134,64.6231058,154.6075331,8.5314845,14.6566388,1.0082984,39.1348122),(39358,'metatarsal.tif',235,10,120,50.9204557,70.5260867,89.3886207,1.8,70.4760786,89.4158629,-1.0756776,4.2382065,7.3347944,275.0440534,851.9946629,6.5708236,116.1579482,64.896331,152.8855044,8.4365316,14.802136,0.9928944,39.5159866),(39359,'metatarsal.tif',235,10,121,50.2285484,70.6527454,89.3154648,1.8,70.6169173,89.3101304,-1.0761681,4.2053512,7.4471448,269.9625619,856.853793,6.4849715,115.0580273,64.1950102,150.9174699,8.4300366,14.9777773,1.0427219,39.5159866),(39360,'metatarsal.tif',235,10,122,49.8964417,70.7251181,89.2737613,1.8,70.6751626,89.3407807,-1.0791319,4.5005516,8.0536391,268.0478713,864.5775153,6.4626487,107.3524032,59.5588932,139.4051475,8.4582865,15.0286193,1.0026916,39.6738742),(39361,'metatarsal.tif',235,10,123,49.6697612,70.7774827,89.2442685,1.8,70.7300496,89.2602075,-1.078114,4.1523162,8.1292762,266.2360958,880.1754587,6.4262707,108.2723029,64.1174913,140.2124449,8.4300366,15.1153792,1.0273187,40.1204477),(39362,'metatarsal.tif',235,10,124,50.11971,70.8359915,89.2188819,1.8,70.788152,89.2667049,-1.0767339,4.1013976,7.6400229,267.0512454,909.6766386,6.4748675,119.067266,65.1122547,153.6458083,8.4265874,15.4457961,1.060308,40.5016221),(39363,'metatarsal.tif',235,10,125,50.2150977,70.9218193,89.1877027,1.8,70.8811717,89.2077676,-1.0745422,4.145589,7.7012256,267.4274974,941.664744,6.4718521,122.2746602,64.5089264,156.3658893,8.4300366,15.5792648,1.0452125,41.2639709),(39364,'metatarsal.tif',235,10,126,50.6287011,71.0567652,89.1319909,1.8,71.130678,89.1185258,-1.0548767,10.831506,14.7997179,278.5552824,993.5099827,6.3844533,67.1303325,25.7171333,75.5643287,8.3235438,15.8198855,1.1681417,42.0263197),(39365,'metatarsal.tif',235,10,127,52.1748045,71.2253336,89.0508728,1.8,71.3999234,88.8743457,-1.0555011,5.0330885,8.8432386,285.139555,1062.9770749,6.5840798,120.2022389,56.6529982,143.5605989,8.4938929,16.0682076,1.1747149,42.4074941),(39366,'metatarsal.tif',235,10,128,53.5321139,71.3441947,89.0518572,1.8,71.4247068,88.9307788,-1.0619333,5.3736313,8.7972453,297.6457894,1104.6413483,6.8043879,125.5667327,55.3900651,156.9576604,8.6850205,16.3971461,1.129204,42.7886685),(39367,'metatarsal.tif',235,10,129,53.9919471,71.5532377,89.0104339,1.8,71.6105132,88.9240871,-1.0665317,5.7642716,8.7679069,313.9568668,1138.4241433,6.8979462,129.8398991,54.4660082,164.6177115,8.926233,17.3779577,1.1557216,46.1538389),(39368,'metatarsal.tif',235,10,130,55.0951903,71.7556887,89.0523831,1.8,71.8593544,88.9707916,-1.0714469,5.8756668,9.0351718,337.0956678,1182.9157969,7.0769621,130.9234423,57.3714746,163.3146975,9.1654979,17.9192512,1.2014627,46.9161877),(39369,'metatarsal.tif',235,10,131,56.7955474,71.9991705,89.0973094,1.8,72.1083083,89.0176371,-1.0671051,5.6489003,9.361619,364.3201747,1251.5863822,7.2607219,133.6933688,64.4940002,169.0249416,9.549455,18.3360337,1.1466019,48.3100869),(39370,'metatarsal.tif',235,10,132,58.7248525,72.3151433,89.19437,1.8,72.3527383,89.0628435,-1.0514764,5.4563526,9.269207,389.1781795,1323.6657692,7.3767847,142.8024817,71.325702,181.2782435,10.0556035,18.5663627,1.0876707,48.3100869),(39371,'metatarsal.tif',235,10,133,62.3883727,72.6007074,89.4030027,1.8,72.6525154,89.2065781,-1.0494648,5.3811676,9.3045326,436.6321771,1422.1598595,7.8189365,152.8459213,81.1407876,195.1527966,10.9453356,18.6930971,1.1393956,56.1568616),(39372,'metatarsal.tif',235,10,134,72.0290425,73.2243671,89.6592748,1.8,73.3959721,89.6516838,-1.0856172,7.1441797,10.049131,632.268613,1674.8902314,9.3938114,166.6701562,88.5012192,221.5424273,13.0415535,19.7200197,1.3921653,66.9110124),(39373,'metatarsal.tif',235,10,135,88.4917683,73.6917155,89.9212444,1.8,73.6062208,89.968774,-1.1134391,6.5836541,9.9940049,886.0253246,2075.1012623,11.8727703,207.6346052,134.5795678,293.1233364,13.1450578,19.9853193,1.3945616,59.3529236),(39374,'metatarsal.tif',235,10,136,101.8622431,73.614683,89.8725924,1.8,73.705198,89.8829828,-1.1209947,6.798912,10.6374555,1095.7781082,2500.4540122,13.7677071,235.0612903,161.1696264,330.7508179,13.4802045,20.5586968,0.5989113,68.2778223),(39375,'metatarsal.tif',235,10,137,102.1029687,73.3702146,89.8731861,1.8,73.6376027,89.7742335,-1.0959088,6.9748391,10.6809828,1096.1280139,2444.362241,13.4594347,228.8518101,157.1545947,325.5623794,13.2118194,21.2365799,1.152572,64.2811015),(39376,'metatarsal.tif',235,10,138,91.7929562,73.4230846,89.7420272,1.8,73.7238057,89.5891539,-1.0956826,6.8783904,10.5400059,929.3163612,2003.0108047,12.0975321,190.0388692,135.1066615,272.437332,12.7227241,20.3794669,1.2197654,64.2811015),(39377,'metatarsal.tif',235,10,139,82.1141357,73.235974,89.7279399,1.8,73.566775,89.494833,-1.1100249,6.2284417,10.619493,617.7214729,1735.7165701,10.9799732,163.4462752,99.1775312,217.4527596,11.8354222,20.288363,1.2322406,57.5507608),(39378,'metatarsal.tif',235,10,140,61.7497619,73.1043093,89.7851102,1.8,73.5093283,89.3371003,-1.1200155,5.3626073,10.6063169,282.119856,1239.0143302,8.3382035,116.8185287,52.6087111,143.3952093,10.2856903,20.0343319,1.2277724,56.6959236),(39379,'metatarsal.tif',235,10,141,13.6218113,72.3255697,90.3335782,1.8,72.5239264,89.6650786,-1.2028535,3.3634924,10.6493702,22.1191101,223.7907048,1.9765664,21.0144544,6.576233,22.9251181,6.8721628,18.4486045,1.1332866,64.0961247),(39380,'metatarsal.tif',235,10,142,43.2637082,76.8964107,89.4651026,1.8,76.4551062,89.7042395,-1.2288716,7.1961877,12.0095337,187.9414352,1041.612761,6.3999516,86.7321567,26.1168057,101.5578726,11.6205912,18.464349,0.9827937,52.1760093),(39381,'metatarsal.tif',235,10,143,61.991324,76.3031228,89.7495544,1.8,75.8552269,89.4881049,-1.2601445,6.8510022,11.421158,369.0991214,1338.6340791,9.3664775,117.2065111,53.8752008,148.7414961,11.9412848,17.7174353,0.9912323,51.3211721),(39382,'metatarsal.tif',235,10,144,78.0684925,75.3006608,89.7861895,1.8,75.2515048,89.8152427,-1.2330903,6.5670809,10.9926968,686.4033186,1486.6513573,11.583083,135.2399133,104.5218307,197.59555,12.5898562,17.0167794,1.0575441,50.0197613),(39383,'metatarsal.tif',235,10,145,75.9634918,75.0544309,89.8605471,1.8,75.3665664,89.869511,-1.1189514,6.2064174,10.4744276,778.8956521,1381.4612285,10.2469393,131.8889469,125.4984325,201.6567517,12.6168287,16.3172028,1.0332097,48.8491489),(39384,'metatarsal.tif',235,10,146,64.5316781,75.5088844,90.003105,1.8,75.5873927,89.9788205,-1.1054451,6.2925471,10.3986875,703.0453274,1175.3164754,8.5895469,113.0254637,111.7266691,176.8576446,12.5227072,15.5161859,1.2710203,47.5477381),(39385,'metatarsal.tif',235,10,147,56.9910338,75.8778807,90.1586139,1.8,75.8142661,90.1131977,-1.104023,6.2105795,10.3014912,598.0646476,970.6478535,7.5749972,94.2240139,96.2977197,149.4439602,12.0592591,14.529696,0.8641821,44.3404553),(39386,'metatarsal.tif',235,10,148,50.0080319,76.4049652,90.2042684,1.8,76.2094982,90.2275494,-1.1312348,5.9882947,10.4208282,489.6162106,797.1590759,6.8253747,76.4967104,81.7622106,122.2494652,11.5754655,13.4576696,0.5713375,40.9752849),(39387,'metatarsal.tif',235,10,149,44.2539303,77.003081,90.0256618,1.8,76.7573214,90.0965308,-1.0762097,5.5870736,10.5087324,401.7333247,592.8113267,5.7138492,56.4113068,71.9040691,92.8275942,10.9178093,12.5063546,0.9229849,37.991289),(39388,'metatarsal.tif',235,10,150,40.6062824,77.6455308,89.7763284,1.8,77.4804372,89.7366458,-0.75659,6.1332593,9.1752297,323.1069816,413.8306792,3.1889996,45.103032,52.6811221,68.0138708,10.2917087,11.8133319,0.9638087,35.835041),(39389,'metatarsal.tif',235,10,151,38.9752041,78.2765311,89.8254356,1.8,78.1953699,89.7975307,-0.7008998,4.8424486,5.689559,278.8297837,355.5638508,2.7016526,62.4940964,57.5803294,111.0707992,9.9105343,11.2881694,0.9894161,34.3103434),(39390,'metatarsal.tif',235,10,152,37.3868554,78.980218,89.9205985,1.8,78.9490774,89.9352863,-0.7748181,6.2552525,9.1685565,242.5339472,315.0594161,3.0496502,34.3630339,38.7728467,52.1494492,9.4964906,10.7711278,1.017502,32.4698706),(39391,'metatarsal.tif',235,10,153,36.5157303,79.7560469,90.0433506,1.8,79.6703051,90.1715005,-0.9451378,4.6890904,10.6388418,215.966201,303.8286984,3.9986924,28.5584376,46.0571626,47.3253193,9.1481855,10.5427629,1.0040671,31.3263474),(39392,'metatarsal.tif',235,10,154,35.9713844,80.3998774,90.217154,1.8,80.329464,90.3848155,-1.0302682,4.5591951,10.8759955,195.0906183,305.7494473,4.407683,28.1123184,42.7905835,45.6706406,8.8960777,10.2457238,0.9536049,30.5639986),(39393,'metatarsal.tif',235,10,155,36.052727,81.0808574,90.3596565,1.8,81.0091855,90.5647169,-1.0228059,4.4277322,10.9579273,183.7889743,309.3654757,4.3779258,28.2321161,41.5086022,44.7950706,8.5764239,10.0921275,0.9753865,29.867049),(39394,'metatarsal.tif',235,10,156,36.5836221,81.810759,90.4193044,1.8,81.7461747,90.5920103,-0.978394,4.299906,11.1076062,175.1159686,303.9885115,4.1963794,27.367599,40.725534,42.9112499,8.5764239,10.0271328,0.9380475,29.6437622),(39395,'metatarsal.tif',235,10,157,36.2573492,82.5128571,90.490153,1.8,82.3962286,90.7232651,-0.9690609,4.167745,11.2830301,164.345928,294.1823911,4.1065093,26.0729954,39.4328175,40.5272311,8.3858367,10.0271328,0.9380475,29.4858746),(39396,'metatarsal.tif',235,10,158,33.6614312,83.0073075,90.5620319,1.8,82.8912053,90.7909871,-1.0927613,4.2345551,11.339816,138.8549172,247.6389848,4.4229294,21.8380073,32.7909104,33.9997287,8.3858367,10.1888422,0.9167136,29.867049),(39397,'metatarsal.tif',235,10,159,30.7189651,83.3659555,90.7173216,1.8,83.3699997,90.7712307,-1.2866747,3.8902852,10.6991452,102.8948509,209.9304076,4.717531,19.6212317,26.4491791,28.4262589,8.3858367,10.5668528,0.9119903,30.6293978),(39398,'metatarsal.tif',235,10,160,27.5581179,83.7056815,91.1023136,1.8,83.8106645,91.1495444,-1.400206,3.4133786,5.5252555,67.5863302,197.8130076,4.4606495,35.8016036,19.8004201,45.414602,8.7586193,13.8303813,0.5771922,36.5319906),(39399,'metatarsal.tif',235,10,161,23.998615,84.3149738,91.7662735,1.8,84.36223,91.7329784,-1.50268,2.9550965,5.9225117,41.9276992,180.9052396,3.9812396,30.5453579,14.1882671,35.9894303,9.713675,14.6640718,0.6287963,41.1985717),(39400,'metatarsal.tif',235,10,162,19.6742277,84.8689437,92.4142052,1.8,84.8190099,92.2957998,-1.5194667,2.6705195,6.2408491,23.2405067,138.4139853,3.2704061,22.1787106,8.7026164,25.3320364,9.6909215,15.2111988,1.0516502,43.6164165),(39401,'metatarsal.tif',235,10,163,14.5865189,85.3111937,92.9787223,1.8,85.2399533,92.9029984,-1.4912513,2.3090513,6.5348564,11.838188,73.3069614,2.4157364,11.2178382,5.1268622,12.9571109,9.2046548,15.3253914,1.1543577,45.6801761),(39402,'metatarsal.tif',235,10,164,9.8054464,85.523981,93.4859342,1.8,85.3911102,93.7762913,-1.4899099,2.0031485,8.0769598,6.0094381,29.9178846,1.6235722,3.7041022,2.9999963,4.4479399,9.4566017,15.4481476,0.748378,55.421602),(39403,'metatarsal.tif',235,10,165,6.3484637,85.7660652,93.6563315,1.8,85.6340417,94.0595807,-1.498788,1.7161291,4.4842634,2.4078204,16.9068379,1.0526004,3.7702598,1.4030532,4.2873706,9.2638975,15.7023496,0.8826514,44.7870289),(39404,'metatarsal.tif',235,10,166,3.6878679,85.9591994,93.9957723,1.8,85.8911917,94.3688142,-1.5268534,1.1120159,3.9931947,0.7896438,8.0450065,0.6134585,2.0146792,0.7101011,2.2022038,8.9806382,15.6351214,0.9445349,43.7359941),(39405,'metatarsal.tif',235,10,167,1.5251679,86.2874663,93.9866008,1.8,86.2342496,93.9472239,-1.5434381,0.5963307,4.5069698,0.0973203,5.9355108,0.2540044,1.3169626,0.1631986,1.3381665,9.3062173,16.1223703,0.9038881,43.0661338),(39406,'metatarsal.tif',235,10,168,0.7612081,86.4578793,91.5498467,1.8,86.4485218,92.4278542,1.5587773,0.2187525,4.9426344,0.0141767,2.0157433,0.1268497,0.4078277,0.0648071,0.4106959,9.2856569,15.4010495,0.9973558,40.5558006),(39407,'metatarsal.tif',235,10,169,0.2838735,86.4855271,91.4391703,1.8,86.4352226,91.4552374,-1.5678012,0.2366175,1.4159116,0.0039759,0.1422806,0.0473118,0.1004869,0.0168032,0.1032723,9.0011644,14.3536329,0.9723774,39.1619014),(39408,'metatarsal.tif',235,10,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39409,'metatarsal.tif',235,10,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39410,'metatarsal.tif',235,10,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39411,'metatarsal.tif',235,10,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39412,'metatarsal.tif',235,10,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39413,'metatarsal.tif',235,10,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39414,'metatarsal.tif',235,10,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39415,'metatarsal.tif',235,10,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39416,'metatarsal.tif',235,10,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39417,'metatarsal.tif',235,10,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39418,'metatarsal.tif',235,10,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39419,'metatarsal.tif',235,10,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39420,'metatarsal.tif',235,10,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39421,'metatarsal.tif',235,10,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39422,'metatarsal.tif',235,10,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39423,'metatarsal.tif',235,10,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39424,'metatarsal.tif',235,10,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39425,'metatarsal.tif',235,10,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39426,'metatarsal.tif',235,10,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39427,'metatarsal.tif',235,10,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39428,'metatarsal.tif',235,10,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39429,'metatarsal.tif',235,10,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39430,'metatarsal.tif',235,10,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39431,'metatarsal.tif',235,10,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39432,'metatarsal.tif',235,10,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39433,'metatarsal.tif',235,10,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39434,'metatarsal.tif',235,10,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39435,'metatarsal.tif',235,10,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39436,'metatarsal.tif',235,10,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39437,'metatarsal.tif',235,10,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39438,'metatarsal.tif',235,10,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39439,'metatarsal.tif',235,10,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39440,'metatarsal.tif',235,10,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39441,'metatarsal.tif',235,10,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39442,'metatarsal.tif',235,10,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39443,'metatarsal.tif',235,10,205,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39444,'metatarsal.tif',235,10,206,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39445,'metatarsal.tif',235,10,207,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39446,'metatarsal.tif',235,10,208,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39447,'metatarsal.tif',235,10,209,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39448,'metatarsal.tif',235,10,210,34.5076582,80.1308344,92.1378029,1.8,79.0716146,91.6099982,-1.3586497,9.4537519,11.9086855,519.9195498,941.8399217,5.4962933,79.0884876,54.9961066,107.7537643,16.005893,26.4154131,1.4274563,96.3427085),(39449,'metatarsal.tif',235,10,211,337.8818913,74.1475744,89.9512897,1.8,73.7634862,89.7090885,0.094001,12.6136885,13.0464271,12724.82026,15496.4210214,0.4961342,1187.7904092,1008.8104081,1747.6426012,28.839817,29.2189506,2.4870219,95.1496546),(39450,'metatarsal.tif',235,10,212,366.6298344,73.7469824,89.7543265,1.8,73.7581446,89.6637929,0.1540269,13.4162387,13.6963095,13988.4100003,17250.7683884,1.4382436,1259.5194647,1042.6476665,1956.0000332,28.839817,29.3132776,2.1332943,95.4654299),(39451,'metatarsal.tif',235,10,213,367.6659782,73.7514144,89.7520336,1.8,73.7797036,89.667831,0.1493744,13.4340782,13.6690213,14031.6181546,17319.2217803,1.3571323,1267.0418323,1044.4794138,1962.3961521,28.839817,29.3281436,0.6287963,95.4654299),(39452,'metatarsal.tif',235,10,214,367.8675845,73.7589094,89.7587548,1.8,73.7910555,89.6763827,0.1438326,13.3592306,13.6325475,14027.5687225,17338.2438233,1.2596739,1271.8271324,1050.0281921,1963.1830345,28.839817,29.2711162,2.2124558,95.3075423),(39453,'metatarsal.tif',235,10,215,368.6264811,73.7695611,89.7640226,1.8,73.8002578,89.6879691,0.1389093,13.4371304,13.6333074,14041.9105361,17393.7707328,1.1778845,1275.82913,1045.0081288,1966.9942059,28.839817,29.2996438,0.6876713,95.4654299),(39454,'metatarsal.tif',235,10,216,369.1657196,73.7808036,89.764379,1.8,73.8038244,89.6914944,0.1339576,13.4325817,13.5950551,14070.6879187,17440.2200527,1.0975029,1282.8355519,1047.5043581,1970.6849504,28.839817,29.2996438,0.8831251,95.6887166),(39455,'femur.tif',235,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39456,'femur.tif',235,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39457,'femur.tif',235,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39458,'femur.tif',235,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39459,'femur.tif',235,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39460,'femur.tif',235,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39461,'femur.tif',235,7,7,0.0040691,28.4119016,43.0667855,1.8,28.4119016,43.0670524,1.2767898,0.016349,0.0539961,0.0000054,0.000016,0.0006212,0.0002968,0.0003275,0.000379,0.1123,0.2511104,2.0344439,0.5422324),(39462,'femur.tif',235,7,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39463,'femur.tif',235,7,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39464,'femur.tif',235,7,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39465,'femur.tif',235,7,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39466,'femur.tif',235,7,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39467,'femur.tif',235,7,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39468,'femur.tif',235,7,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39469,'femur.tif',235,7,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39470,'femur.tif',235,7,16,12.4156058,48.0893055,22.6647724,1.8,48.1939248,22.6830572,0.8033009,2.5840934,3.5077897,14.2336649,30.7165578,1.0716715,8.7566703,5.5081852,12.6647034,4.7943155,7.1749071,2.2675386,20.325734),(39471,'femur.tif',235,7,17,27.9489727,48.4509292,22.1746912,1.8,48.5728714,22.5003436,1.109117,3.4389178,5.4556299,74.4675733,164.9055116,3.7338536,30.2266674,21.6543624,43.7031868,6.5531864,10.3632889,2.0926306,28.8041008),(39472,'femur.tif',235,7,18,35.723734,48.9572638,22.4190137,1.8,48.8609019,22.6069416,0.9115523,4.0706339,6.477831,157.9511645,378.9783484,3.7201498,58.5038958,38.8025968,82.2232064,7.8558583,13.1011326,2.246876,35.3108896),(39473,'femur.tif',235,7,19,44.4720658,49.548157,23.0603753,1.8,49.3291739,23.0930798,0.9817206,4.5791823,7.9272187,281.2817175,700.409371,5.1240471,88.3549957,61.4261894,121.2675824,9.1270741,15.3407728,2.2055129,41.4727974),(39474,'femur.tif',235,7,20,47.6300524,49.9008174,23.3948393,1.8,49.7605309,23.4735963,1.0315892,5.0897549,8.9275438,374.2005314,922.8387786,5.8455027,103.369841,73.5203437,141.068672,10.0565355,17.2591629,2.1804562,46.1508624),(39475,'femur.tif',235,7,21,48.3114164,49.9928689,23.4195267,1.8,50.0474041,23.6139755,0.9887423,5.7156374,9.3005418,460.204079,1102.1381789,5.6184967,118.5025774,80.5166682,163.7011541,10.859298,18.3956186,2.2045297,49.1524082),(39476,'femur.tif',235,7,22,49.3299751,50.2899717,23.4220787,1.8,50.3369333,23.6584591,1.003738,6.0807764,9.2590384,552.0325218,1223.3746931,5.8494373,132.127618,90.7832297,188.5050811,11.5461655,18.5563655,2.2360858,50.4342245),(39477,'femur.tif',235,7,23,53.017623,50.5696017,23.4467195,1.8,50.6615445,23.69786,0.9709052,6.3821282,9.2734625,736.8374305,1323.2767141,6.0199773,142.6949987,115.4532485,221.3162357,12.4490244,18.4185705,2.226492,52.049635),(39478,'femur.tif',235,7,24,58.4112665,50.6581023,23.4633092,1.8,50.7094553,23.7112906,0.8684449,7.3063792,9.2931775,982.4255626,1436.8969386,5.6723706,154.6184763,134.4613434,249.0477169,14.0274377,18.9414527,2.4696295,54.690338),(39479,'femur.tif',235,7,25,63.5642579,50.2825908,23.686358,1.8,50.3032515,23.896615,0.6304035,8.2409874,10.1347841,1281.9634299,1634.2785207,3.6811728,161.2543984,155.5594455,286.4269855,15.1843665,19.7880769,2.4890112,57.1947983),(39480,'femur.tif',235,7,26,72.1110714,49.3750941,24.2927831,1.8,49.3887227,24.3451048,-0.352128,8.9514256,8.7318064,1676.5041336,1971.93079,1.4296414,225.8330862,187.2890662,344.8423177,16.6276841,20.3039529,2.5014101,62.1406737),(39481,'femur.tif',235,7,27,82.192855,48.7461403,24.6822287,1.8,48.665761,24.5917245,-0.3294241,9.6816668,9.7154495,1924.9681078,2213.0510341,1.4335948,227.7867877,198.8261059,365.7983951,17.1526684,20.8953469,2.6611197,65.7163756),(39482,'femur.tif',235,7,28,90.4048235,48.3558986,24.2810364,1.8,48.1193257,24.3263624,0.271317,9.6238618,11.2349453,2087.6710738,2570.9673508,1.0822101,228.8366595,216.9265439,396.512702,18.3335441,21.8243729,2.7285929,71.4384336),(39483,'femur.tif',235,7,29,97.3775633,47.7887211,23.9325737,1.8,47.6381372,24.1390705,0.3656168,9.6313584,11.7334981,2074.9896808,3105.560885,2.0745386,264.6747685,215.4410208,428.9586609,18.5129047,22.7304201,2.7620037,75.0526707),(39484,'femur.tif',235,7,30,118.9454829,43.967797,23.6266313,1.8,44.5729876,23.7558583,0.1145795,9.6149093,22.7787043,2246.4239783,11197.8350279,0.259125,491.5922723,233.6396424,589.6495281,5.3358104,8.5525137,0.2386093,23.8807989),(39485,'femur.tif',235,7,31,164.4063405,39.1680096,23.0860337,1.8,40.4257982,23.1853833,0.0983358,9.6808196,20.3752455,2777.8756416,22770.4145996,0.2641131,1117.5528968,286.9463297,1253.7923803,19.1574641,40.2725109,3.0466409,119.1323111),(39486,'femur.tif',235,7,32,188.4084781,37.4900917,22.7050528,1.8,38.6532101,22.8609738,0.0668464,10.0670257,21.471079,3641.846862,28691.6472637,0.1401061,1336.2927537,361.7599632,1504.218626,19.1353779,41.3588894,3.0300359,123.8714848),(39487,'femur.tif',235,7,33,193.0613302,36.2461842,22.7577885,1.8,37.374772,22.776066,0.0664888,9.7120895,22.7905759,4166.7844731,30153.8831363,0.142037,1323.0856169,429.0306912,1505.6406956,19.0855589,42.191637,3.0803361,128.7901116),(39488,'femur.tif',235,7,34,198.4289166,35.423448,22.8086717,1.8,36.4862682,22.7148244,0.0656784,9.5187118,23.6240816,4708.612897,31718.8189594,0.1424539,1342.6477047,494.6691289,1540.2167327,18.7082384,43.0438761,0.0391445,132.3996736),(39489,'femur.tif',235,7,35,200.5933406,34.771342,22.7559473,1.8,35.6902764,22.6233055,0.0604034,10.1894156,24.263399,5202.9019388,32502.5060299,0.1218311,1339.5693686,510.6182863,1551.7302737,19.642977,43.6963928,0.0231321,135.9707004),(39490,'femur.tif',235,7,36,198.8220178,34.1398239,22.7088514,1.8,35.0223422,22.5495382,0.060642,10.7206994,24.8182323,5520.9464117,32070.8209548,0.1217104,1292.2282542,514.9800573,1514.0040621,20.3430789,43.920933,3.1185788,137.6020727),(39491,'femur.tif',235,7,37,196.1674683,33.7567894,22.6813634,1.8,34.4112976,22.4853998,0.0613468,11.2772834,24.9981785,5677.4952675,31423.000055,0.1228896,1257.0115878,503.4452959,1483.9311606,20.9972829,43.8436253,3.0954715,139.8414612),(39492,'femur.tif',235,7,38,189.3067071,33.6945997,22.6860045,1.8,34.0973698,22.4668613,0.0649899,11.8041754,24.6975533,5621.1066794,30064.9280041,0.1330742,1217.3241447,476.1964718,1444.0322266,21.483623,43.5302696,3.0848062,141.9060717),(39493,'femur.tif',235,7,39,179.5365757,34.0751927,22.6425631,1.8,34.1298215,22.4322351,0.0681421,12.2205892,23.9846367,5458.5740292,28063.9131802,0.1387269,1170.0787263,446.6702833,1396.8748527,21.8408281,43.0818012,3.0842145,143.8504013),(39494,'femur.tif',235,7,40,169.0942024,35.0090339,22.6555028,1.8,34.5950712,22.4271292,0.0701246,12.6728944,22.8343579,5173.2039157,25691.3958354,0.1383586,1125.1201331,408.2101326,1351.0850382,21.8616448,42.5148603,3.0860941,146.6047737),(39495,'femur.tif',235,7,41,150.214679,37.2958251,22.5500854,1.8,37.0538085,22.3610563,0.119175,12.5684365,20.3328533,4653.3986749,19404.5276482,0.3538951,954.3435639,370.2448338,1169.7579634,21.6215493,40.8149889,0.0495462,155.7071186),(39496,'femur.tif',235,7,42,140.3061013,38.7369788,22.3596038,1.8,38.7095854,22.1002709,0.205038,12.1233072,18.6211156,4466.0645238,15432.8856112,0.9693922,828.7841583,368.386649,1062.2092994,20.4452226,35.9249458,3.066499,138.9138761),(39497,'femur.tif',235,7,43,138.2643782,39.3519626,22.2270943,1.8,39.2466983,21.9746024,0.261196,11.9312094,18.056387,4563.0059575,14201.4196334,1.5367141,786.5039481,382.4428682,1038.289139,20.3266163,34.5812913,3.0635754,128.6885311),(39498,'femur.tif',235,7,44,137.8854304,39.6806456,22.0183132,1.8,39.4786513,21.7604834,0.3309844,11.4322531,17.7163515,4702.2093857,13381.3219186,2.426972,755.3091251,411.3108198,1020.4855834,20.2812137,33.4618217,3.0609598,130.0361312),(39499,'femur.tif',235,7,45,137.8168246,39.752831,21.8422842,1.8,39.5686272,21.6311579,0.3861437,10.8730952,17.5337703,4737.8473317,12792.4795249,3.2580308,729.5909165,435.7404431,998.0989815,20.0777737,32.8181278,2.4823502,127.2930456),(39500,'femur.tif',235,7,46,140.3940856,39.8783174,21.8540334,1.8,39.5894055,21.5606077,0.4102317,10.5787782,16.9861603,4710.5676646,12713.945347,3.7218205,748.4884843,445.2846629,998.8317201,19.77429,32.7985237,2.4775465,124.9765865),(39501,'femur.tif',235,7,47,140.6543596,40.0875895,21.9131348,1.8,39.7581422,21.5689544,0.4277891,10.1596417,16.0457078,4600.1880769,12325.9542964,4.0346449,768.1776604,452.7903859,952.714583,19.3469493,32.3876022,2.4939307,121.6461216),(39502,'femur.tif',235,7,48,143.3638715,40.1781256,22.0140388,1.8,39.8429514,21.7085953,0.4295205,10.1362852,15.5577777,4621.4376768,11949.1539795,4.1436461,768.0501794,455.930113,932.3057315,18.8650182,31.8777766,2.4409907,118.3109816),(39503,'femur.tif',235,7,49,146.0782803,40.2710743,21.9181521,1.8,40.0467239,21.675906,0.4312564,9.9229926,16.0635679,4666.0357628,11483.2956099,4.254152,714.8658193,470.224653,924.7807271,18.8361658,31.714166,2.5044654,115.8789167),(39504,'femur.tif',235,7,50,151.8912327,40.3585218,21.751537,1.8,40.2217442,21.5674202,0.4347598,9.6454574,16.500103,4887.3429153,11367.8161106,4.4909976,688.9542498,506.6989257,933.3787744,18.8199478,31.6576486,2.5250545,113.6714518),(39505,'femur.tif',235,7,51,157.3820031,40.7095015,21.4657605,1.8,40.7370247,21.3121942,0.4253094,9.5682844,16.9116279,5200.8676941,10909.2077442,4.4654761,645.0714151,543.5527923,913.1001727,18.7930443,31.5660915,2.5229974,90.8498057),(39506,'femur.tif',235,7,52,158.0064503,40.5507798,21.288119,1.8,40.7223279,21.098417,0.4473131,9.6674588,17.0485866,5223.3959495,10249.8660077,4.9270311,601.2150012,540.3070306,882.4656277,18.734766,31.4000537,2.5367266,87.43292),(39507,'femur.tif',235,7,53,145.9498948,40.0217876,21.6809622,1.8,40.2502958,21.269694,0.5122576,9.6011508,17.0957253,4902.9430149,9698.6189369,5.8439164,567.3125172,510.6620173,838.8208536,18.7344809,31.1168302,2.5435804,86.9179361),(39508,'femur.tif',235,7,54,140.701378,39.6605712,21.8042628,1.8,39.9395551,21.3370977,0.5432341,9.7991419,16.9236184,4703.5424028,9321.5510513,6.2657392,550.8013008,479.9953361,817.6966048,18.6838027,30.7119473,2.5434484,85.6201581),(39509,'femur.tif',235,7,55,138.2820919,39.3405429,21.8927866,1.8,39.5912041,21.4158883,0.5599557,9.8606043,16.6599645,4651.8708774,8818.5818866,6.5019979,529.3277702,471.7632656,800.2508039,18.6097654,30.1821806,2.5628777,83.9662123),(39510,'femur.tif',235,7,56,134.6958587,39.196583,22.0861991,1.8,39.3925213,21.5263578,0.5591121,9.8483791,16.4241479,4486.2344346,8307.8488059,6.3163358,505.831345,455.5302331,769.9031206,18.5006082,29.5579505,2.5535901,82.5913637),(39511,'femur.tif',235,7,57,129.6014571,39.1729857,22.3447115,1.8,39.3491491,21.7415257,0.5600031,9.8440931,16.1744706,4338.4667102,7762.48238,6.0947592,479.9218834,440.717766,738.809521,18.4278133,28.8453666,2.5697873,80.4769312),(39512,'femur.tif',235,7,58,127.8974408,39.0888374,22.5802713,1.8,39.2639904,22.0109754,0.5556074,9.803974,15.7287456,4222.1428025,7358.2504127,5.9304647,467.8218216,430.6562613,726.860254,18.3482328,28.0050639,2.5357944,78.0176178),(39513,'femur.tif',235,7,59,126.3948764,38.8993494,22.7222711,1.8,38.9830343,22.1615222,0.5725097,9.7750708,15.0388307,4138.1164175,6991.7528947,6.1825163,464.9133336,423.3336496,732.9023266,18.2128277,27.0391272,2.5363107,75.3449911),(39514,'femur.tif',235,7,60,126.5678621,38.7766501,22.9162952,1.8,38.8295227,22.299212,0.5801943,9.7153784,14.6566065,4043.4108361,6755.3996894,6.3391182,460.911582,416.1866542,731.2023181,18.0813661,26.355833,2.5748634,73.997391),(39515,'femur.tif',235,7,61,125.0540534,38.6307904,23.1069344,1.8,38.6233993,22.4771803,0.5922486,9.6753638,13.978401,3913.3259069,6374.7902232,6.4948604,456.0457389,404.4629217,728.0790419,17.9310421,25.3919726,2.5290551,71.6809319),(39516,'femur.tif',235,7,62,123.8681807,38.6112178,23.3769585,1.8,38.7195925,22.8872662,0.5924217,9.6294666,13.2694599,3808.0342752,5939.043425,6.4365816,447.5723566,395.4564066,728.9372437,17.8305409,24.2975798,2.5369249,69.4462185),(39517,'femur.tif',235,7,63,123.8896574,38.6856992,23.5353452,1.8,38.843172,23.1500867,0.6063417,9.4343988,12.6255063,3750.002667,5565.9606841,6.7054495,440.8504937,397.4818899,734.7595623,17.718862,23.2723983,2.5763438,67.3045375),(39518,'femur.tif',235,7,64,124.1318796,38.5779375,23.6919416,1.8,38.6752203,23.4063908,0.6543778,9.3940598,11.9576632,3695.9196205,5258.1953474,7.6646047,439.7343565,393.4315631,747.4255596,17.6195691,22.3657523,2.5382709,65.8911536),(39519,'femur.tif',235,7,65,128.3051194,38.5475745,23.7240536,1.8,38.6476004,23.4342145,0.6780489,9.1651004,11.4409618,3642.4409541,4982.8280843,8.4141119,435.5252807,397.4251012,753.7845689,17.4974179,21.6887337,2.5851887,64.8884345),(39520,'femur.tif',235,7,66,120.8077164,38.4836065,24.0226562,1.8,38.5607274,23.8604063,0.6999487,9.1796124,11.1699843,3486.9268443,4731.8809568,8.3551809,423.6246733,379.8555641,735.2813872,17.3856282,21.1535775,2.5756778,63.6451535),(39521,'femur.tif',235,7,67,118.7395227,38.4255596,24.2622673,1.8,38.5511117,24.1072362,0.7364649,9.1162005,10.9107921,3350.8983046,4511.7982677,8.9281195,413.5170234,367.5761956,720.6317584,17.2697986,20.6442724,2.4795953,62.8397858),(39522,'femur.tif',235,7,68,117.5711952,38.3292549,24.4599912,1.8,38.4154373,24.2932206,0.7631726,9.0141847,10.5885399,3248.1148213,4309.8078574,9.3622292,407.025698,360.3337328,712.3236541,17.0727406,20.2155608,2.5659161,61.8756019),(39523,'femur.tif',235,7,69,116.635724,38.1821783,24.6540344,1.8,38.2229513,24.5111384,0.8092819,8.9554303,10.3053732,3145.8455958,4143.5013694,10.1837506,402.0719382,351.2779957,705.8439136,16.9139244,19.8011376,2.4606516,61.1360181),(39524,'femur.tif',235,7,70,117.1973657,38.0896646,24.8240606,1.8,38.146586,24.6358261,0.854428,8.8532359,10.0757235,3072.0141189,4016.5112677,11.1105201,398.6325424,346.9933667,702.9500559,16.7551083,19.4541732,2.4461153,60.5552504),(39525,'femur.tif',235,7,71,116.9938879,37.9964528,25.0319215,1.8,38.0531042,24.9013906,0.8811022,8.7488637,9.9241553,2984.9712787,3922.8621305,11.6042485,395.2842361,341.1838823,696.0041841,16.5962921,19.1872046,2.2400529,59.8542018),(39526,'femur.tif',235,7,72,116.6214047,37.8850739,25.2051125,1.8,37.9005286,25.0945633,0.913952,8.6466513,9.7253694,2909.2116227,3804.2186628,12.1897004,391.1644398,336.4552954,690.1411747,16.5137588,18.9241339,2.2510979,59.2461856),(39527,'femur.tif',235,7,73,117.3768888,37.8239962,25.3817518,1.8,37.8432615,25.293938,0.9308163,8.5076055,9.5804287,2859.3442895,3711.223168,12.5862602,387.375482,336.0927208,685.4990647,16.3580678,18.6958432,2.0720606,58.6381694),(39528,'femur.tif',235,7,74,117.8775218,37.749214,25.5388866,1.8,37.7579683,25.4494319,0.9533683,8.3802397,9.4214111,2803.9922082,3621.3758818,13.0613893,384.3772263,334.5957064,681.4717926,16.2259086,18.4991893,2.0778948,58.095937),(39529,'femur.tif',235,7,75,118.2685937,37.6657849,25.6943817,1.8,37.6855455,25.6196803,0.9781123,8.238037,9.2890413,2748.2187518,3544.6851268,13.5610326,381.5985959,333.6011666,677.3512204,16.0611545,18.3310627,1.9604037,57.5537046),(39530,'femur.tif',235,7,76,118.8871293,37.5863681,25.8558517,1.8,37.609243,25.8099152,1.0035252,8.1051755,9.1943962,2694.2421807,3486.0812131,14.093548,379.152816,332.4100961,672.1774856,15.9177983,18.1939874,2.0730987,57.1702884),(39531,'femur.tif',235,7,77,119.2928973,37.4874498,26.0062815,1.8,37.5059501,25.9728299,1.0163078,7.967996,9.0790123,2638.5115288,3437.3063768,14.3705947,378.5991532,331.1386603,669.2113413,15.7318508,18.0635529,1.9732391,56.628056),(39532,'femur.tif',235,7,78,119.7957099,37.375425,26.1630728,1.8,37.392011,26.1540477,1.029033,7.8738703,8.9423991,2582.1409019,3400.7255534,14.6571565,380.2923046,327.9379518,668.9338655,15.5762229,17.9602787,1.9756881,56.2446398),(39533,'femur.tif',235,7,79,119.5294521,37.2668491,26.3368353,1.8,37.283481,26.322502,1.0417926,7.8043834,8.861466,2531.4284228,3347.0194893,14.8476424,377.7049393,324.359824,661.8723456,15.4825775,17.878288,1.8508216,55.8612236),(39534,'femur.tif',235,7,80,119.7243917,37.1586151,26.5273578,1.8,37.1694558,26.5132234,1.0650756,7.7672514,8.8069863,2486.5738398,3308.3366084,15.2712408,375.6491131,320.1356202,652.226546,15.4035207,17.8447502,1.7928782,55.7296559),(39535,'femur.tif',235,7,81,120.131605,37.0430206,26.7140485,1.8,37.0556339,26.6781392,1.0869846,7.7065555,8.7728877,2444.8078074,3283.0607263,15.689772,374.2280584,317.2374249,646.1626843,15.2710406,17.7966281,1.7805675,55.3189912),(39536,'femur.tif',235,7,82,120.8746781,36.9197794,26.8756972,1.8,36.935319,26.8331698,1.0969361,7.6757929,8.7686634,2411.4178527,3271.082358,15.9507821,373.0423012,314.1587937,641.1175605,15.2156906,17.760451,1.735945,55.160175),(39537,'femur.tif',235,7,83,121.7651046,36.8071426,27.0356683,1.8,36.8242364,27.0030787,1.1006502,7.6446007,8.7280718,2389.8408994,3254.4634657,16.12933,372.8731308,312.6181475,639.2162115,15.1384341,17.7295358,1.7619808,54.935575),(39538,'femur.tif',235,7,84,122.5475878,36.7229584,27.2079597,1.8,36.7375576,27.1873907,1.1084836,7.5485377,8.7116624,2365.318336,3234.9670496,16.3614671,371.3375117,313.347885,633.7577662,15.0683278,17.7106759,1.7880898,54.710975),(39539,'femur.tif',235,7,85,123.0788206,36.6320256,27.3604654,1.8,36.6427324,27.344799,1.1107458,7.5006848,8.7184314,2342.5273526,3214.7675026,16.4693794,368.7323261,312.3084665,630.8737376,14.9692521,17.6882314,1.7495141,54.3933426),(39540,'femur.tif',235,7,86,123.3060148,36.5404501,27.5131689,1.8,36.5471742,27.5052939,1.1080627,7.4459773,8.7205461,2319.3238388,3187.1996818,16.4558187,365.4816607,311.4868284,628.1893491,14.9185739,17.6314586,1.8482211,54.2730617),(39541,'femur.tif',235,7,87,123.0864679,36.4375129,27.6617125,1.8,36.4490034,27.673015,1.0988796,7.4048385,8.7348756,2294.233085,3158.8191082,16.2749841,361.6329818,309.8289149,620.0534307,14.8681808,17.6010333,1.8420847,54.1142455),(39542,'femur.tif',235,7,88,123.0170904,36.351208,27.8203822,1.8,36.3648963,27.8332474,1.0972184,7.3958526,8.7307111,2275.8230208,3136.8881331,16.2381968,359.2935429,307.7161149,616.1632179,14.8667553,17.571273,1.8359273,53.8896454),(39543,'femur.tif',235,7,89,122.9400076,36.2605882,27.9712288,1.8,36.2798903,27.9774645,1.0955156,7.3479484,8.7378575,2258.0675015,3123.8120341,16.1996643,357.5032024,307.3058472,611.2218274,14.8166473,17.5547577,1.8561257,53.8896454),(39544,'femur.tif',235,7,90,122.4379308,36.1825128,28.1265714,1.8,36.2058626,28.1120565,1.1000555,7.3326537,8.7345275,2238.8109313,3116.8479186,16.2086473,356.8421893,305.320696,608.6608007,14.7668244,17.5547577,1.8561257,53.8896454),(39545,'femur.tif',235,7,91,121.738345,36.1249179,28.2873901,1.8,36.149345,28.2671636,1.1151449,7.354135,8.7244501,2223.6012466,3118.1734558,16.3607878,357.4063045,302.3606782,607.0754065,14.765684,17.5795249,1.8824462,53.6377969),(39546,'femur.tif',235,7,92,121.3045081,36.0742896,28.4432011,1.8,36.0997444,28.4289216,1.1284369,7.3867859,8.7207714,2212.130276,3125.8104584,16.5126467,358.4327923,299.471288,608.5121825,14.7167163,17.5482909,1.9168336,53.7966131),(39547,'femur.tif',235,7,93,121.1395152,36.011063,28.5893663,1.8,36.0289296,28.5565124,1.1416652,7.3864613,8.7364719,2208.5152764,3145.6602544,16.694574,360.0607085,298.995039,608.9353118,14.7155759,17.5795249,1.8824462,53.8623969),(39548,'femur.tif',235,7,94,121.0949765,35.9356632,28.7203621,1.8,35.9459798,28.6829443,1.1465064,7.4365361,8.7816469,2208.7473752,3160.6747487,16.762061,359.9182232,297.01293,609.8312429,14.7155759,17.6010333,1.8420847,54.0212131),(39549,'femur.tif',235,7,95,121.2398988,35.8695776,28.8328163,1.8,35.8771578,28.7928774,1.162839,7.457906,8.8249354,2211.4022966,3191.026425,17.0261477,361.5920453,296.5178576,610.264105,14.7127545,17.7106759,1.7880898,54.2072778),(39550,'femur.tif',235,7,96,123.4218111,35.8030026,28.9137274,1.8,35.8062536,28.8647595,1.184292,7.4948785,8.8838587,2230.3796185,3267.8997345,17.6473948,367.8468831,297.5871598,609.4010819,14.7019011,18.0397998,1.7523202,54.2730617),(39551,'femur.tif',235,7,97,124.6658131,35.763078,28.9994451,1.8,35.7298131,28.9079399,1.224739,7.5296999,9.1790745,2233.3170738,3334.0630665,18.3871507,363.2243171,296.6010729,597.1090495,14.6668934,18.3915048,1.755019,54.7767588),(39552,'femur.tif',235,7,98,127.0343893,35.6440857,29.0523074,1.8,35.6201937,28.9290165,1.2207964,7.5484544,9.2889896,2239.7034055,3450.2786135,18.6829722,371.4374493,296.7101998,601.5478346,14.6666083,18.6299584,1.7220708,54.9628235),(39553,'femur.tif',235,7,99,126.010578,35.5782385,29.2488429,1.8,35.5764249,29.1237919,1.2160059,7.5568029,9.2334133,2238.0542621,3431.6500805,18.4672176,371.6556366,296.1641685,600.8381139,14.6663232,18.5543265,1.73495,54.9628235),(39554,'femur.tif',235,7,100,123.8281575,35.5426483,29.4927487,1.8,35.5353285,29.3620406,1.2289737,7.5513531,9.2194978,2228.8387556,3350.9892218,18.3190908,363.4676535,295.1575325,592.8849148,14.665753,18.4041861,1.6747151,54.7767588),(39555,'femur.tif',235,7,101,123.2746699,35.4938574,29.6748545,1.8,35.4871179,29.5266689,1.2559022,7.5946928,9.2413083,2232.4954279,3327.756472,18.5749484,360.0958195,293.9546705,579.8454924,14.7412275,18.5635002,1.6313283,55.1874235),(39556,'femur.tif',235,7,102,122.7345286,35.4421168,29.8331277,1.8,35.4350396,29.6665089,1.287505,7.5592047,9.2273051,2222.5283449,3305.876416,18.8575481,358.2710643,294.0161596,579.3116594,14.665753,18.4585823,1.6377692,55.0943912),(39557,'femur.tif',235,7,103,122.1622286,35.3961288,30.0443781,1.8,35.3808521,29.8648361,1.3035526,7.570088,9.1828094,2209.8742537,3254.9622213,18.9405393,354.4625716,291.9218693,573.7838687,14.6822831,18.3722948,1.485117,54.8425426),(39558,'femur.tif',235,7,104,122.4078654,35.3360916,30.2191774,1.8,35.3194422,30.0742835,1.3254563,7.5595244,9.1793321,2202.587785,3235.6939169,19.1977622,352.49775,291.3659202,581.1051198,14.6654679,18.2147702,1.5214537,54.590694),(39559,'femur.tif',235,7,105,122.3038993,35.2749155,30.4305155,1.8,35.2557218,30.2686432,1.3277138,7.5583002,9.1274403,2189.8379096,3188.2192651,19.2030499,349.3004795,289.7262401,576.5293571,14.6660381,18.1224516,1.5025794,54.4318778),(39560,'femur.tif',235,7,106,121.8758578,35.2033653,30.6213811,1.8,35.1858865,30.4881409,1.3358393,7.5777355,9.0370917,2188.5404919,3141.8958094,19.2117712,347.6666974,288.8119396,571.102107,14.715861,18.0813473,1.4587674,54.1800293),(39561,'femur.tif',235,7,107,121.7410357,35.125358,30.7963765,1.8,35.1084985,30.7071198,1.3426384,7.5962998,8.9489253,2185.6535649,3108.673295,19.2521477,347.3795103,287.7260798,579.1668945,14.7615458,17.8909806,1.507986,54.1142455),(39562,'femur.tif',235,7,108,120.6261587,35.0651061,31.0390216,1.8,35.0627272,30.9898374,1.3322622,7.5867084,8.6669841,2176.739861,3007.1414472,18.9819836,346.9651502,286.9149251,587.2548252,14.7659691,17.4676153,1.6544715,53.6490836),(39563,'femur.tif',235,7,109,119.079447,34.9979421,31.3046081,1.8,34.9913851,31.2840106,1.3087923,7.6008521,8.3987675,2172.6427452,2889.6093939,18.5150748,344.0516003,285.8419985,589.0504957,14.7861958,17.0961776,1.3991683,53.2111703),(39564,'femur.tif',235,7,110,117.913219,34.9443232,31.5400532,1.8,34.9449263,31.5254725,1.2859378,7.6146796,8.2934109,2169.2519111,2800.3639489,18.1002062,337.6613072,284.8776355,582.4513245,14.7662542,16.9584165,1.3708034,52.8662894),(39565,'femur.tif',235,7,111,117.1022935,34.8808906,31.7630477,1.8,34.8804869,31.7414473,1.2862369,7.6303976,8.2182119,2173.2699452,2735.4027172,17.9788726,332.8464556,284.8173936,575.7555657,14.8210394,16.8450009,1.2870022,52.7074732),(39566,'femur.tif',235,7,112,116.6370518,34.8086323,31.9668325,1.8,34.8122992,31.929366,1.3022301,7.6209748,8.1351436,2180.1487064,2688.1155294,18.0707682,330.4324632,286.0721588,573.1128412,14.8664702,16.753791,1.3063079,52.6802246),(39567,'femur.tif',235,7,113,115.888128,34.7364183,32.1517625,1.8,34.7485342,32.1323208,1.3252916,7.6258453,8.1022507,2181.6727436,2647.9167821,18.1737445,326.812497,286.0892991,569.7428811,14.9126108,16.675322,1.298047,52.548657),(39568,'femur.tif',235,7,114,114.9144096,34.665484,32.3232661,1.8,34.6699883,32.3050076,1.3419898,7.6471571,8.057333,2181.7901672,2608.6671558,18.1671034,323.7631073,285.3073535,567.1274214,14.9516297,16.6295038,1.2832205,52.4556246),(39569,'femur.tif',235,7,115,114.462428,34.5898052,32.4782225,1.8,34.5893661,32.4597046,1.3479552,7.6466167,8.0156531,2185.7361485,2580.1303962,18.1453166,321.8864856,285.8435622,566.8723455,15.0167336,16.56111,1.2104384,52.2968084),(39570,'femur.tif',235,7,116,113.9837123,34.5170097,32.6221262,1.8,34.5220845,32.6093528,1.3332709,7.6532733,7.9734466,2190.2405742,2552.6205531,17.9454959,320.1401717,286.1835035,565.5927881,15.0577233,16.5218462,1.2167989,52.2968084),(39571,'femur.tif',235,7,117,113.02722,34.445083,32.771585,1.8,34.4574485,32.7619751,1.3251982,7.6835205,7.9529864,2192.369877,2518.2107192,17.7242624,316.6371218,285.3340324,563.764164,15.1008702,16.5004597,1.1650109,52.2695599),(39572,'femur.tif',235,7,118,111.4286167,34.3626146,32.9134797,1.8,34.3790632,32.9032331,1.3191064,7.7092274,7.9213058,2183.6514898,2477.3803521,17.4196097,312.7489866,283.2516635,559.5362878,15.1289899,16.4564538,1.1712808,52.2968084),(39573,'femur.tif',235,7,119,110.072225,34.2787976,33.073784,1.8,34.2872907,33.0602837,1.3240584,7.7216877,7.8911894,2178.9406363,2437.3306503,17.2509937,308.8673373,282.1845056,553.2281728,15.1594221,16.4756012,1.0888581,52.203776),(39574,'femur.tif',235,7,120,108.9113736,34.2085582,33.2175049,1.8,34.2204775,33.1972761,1.3471586,7.7135374,7.8421777,2174.6945961,2404.3091438,17.2590841,306.5869234,281.9322027,550.6978286,15.1679736,16.4503219,1.04911,52.2695599),(39575,'femur.tif',235,7,121,107.5339727,34.1533169,33.3706598,1.8,34.1558679,33.3621543,1.3561298,7.7541007,7.8302333,2169.2680891,2373.7831286,17.1090456,303.1561167,279.7575343,545.2503245,15.1998534,16.4503219,1.04911,52.1765275),(39576,'femur.tif',235,7,122,106.6834434,34.0904328,33.5153517,1.8,34.0963987,33.5117559,1.3865003,7.7792568,7.850363,2174.9423876,2348.4573481,17.1834627,299.152707,279.5822847,543.4662716,15.2449652,16.4667962,1.0338856,52.203776),(39577,'femur.tif',235,7,123,105.6860598,34.0192515,33.6712658,1.8,34.0269134,33.6689744,1.4051751,7.786649,7.8814826,2180.2186239,2319.0398845,17.1355767,294.2390421,279.9944642,538.967599,15.2940238,16.487079,1.0186951,52.0834951),(39578,'femur.tif',235,7,124,104.6757969,33.9506022,33.8225174,1.8,33.960647,33.8176966,1.4579426,7.7857239,7.9467215,2186.883802,2295.7350803,17.2247166,288.8908428,280.8838111,535.7057799,15.3593044,16.4924326,1.0584069,52.1765275),(39579,'femur.tif',235,7,125,103.9602426,33.8618277,33.9663636,1.8,33.8775995,33.9593495,1.5119096,7.8114732,8.0080462,2202.0213481,2277.921962,17.2666933,284.4541497,281.8957831,532.3603081,15.4190839,16.5477784,1.052492,52.2423113),(39580,'femur.tif',235,7,126,103.8450154,33.772387,34.1068085,1.8,33.7870862,34.0953025,-1.5373715,7.8353996,8.1210138,2228.7513563,2274.88974,17.2881731,280.1238601,284.4464186,533.1214025,15.5173612,16.5827986,1.0222469,52.373879),(39581,'femur.tif',235,7,127,103.9898038,33.6904087,34.2358116,1.8,33.7064247,34.2301894,-1.0580004,8.1310302,8.446141,2263.1784621,2277.1091608,13.1598479,269.603497,278.338466,535.3901898,15.572598,16.6036993,1.0466167,52.5326951),(39582,'femur.tif',235,7,128,104.5191703,33.6309654,34.3551221,1.8,33.6466077,34.343596,-0.165869,7.993403,7.8822271,2279.9891771,2311.2403998,0.4748857,293.221747,285.2338592,541.3788872,15.4974009,16.6207803,1.0315356,52.598479),(39583,'femur.tif',235,7,129,104.8454793,33.5765729,34.4717132,1.8,33.5911498,34.4557517,-0.0839931,8.0714706,7.9173229,2288.0594279,2350.8520899,0.1229888,296.9251255,283.4749139,548.1467012,15.4974009,16.6329162,0.9921567,52.6642628),(39584,'femur.tif',235,7,130,105.3678819,33.5165664,34.5875834,1.8,33.5344177,34.5589164,-0.0443786,8.0890559,7.94925,2299.2653971,2401.1118394,0.034564,302.0551421,284.2439732,553.7221016,15.4974009,16.6416333,1.0164888,52.8888628),(39585,'femur.tif',235,7,131,105.5930746,33.4435991,34.7125082,1.8,33.4571454,34.695748,-0.0272914,8.1815391,7.9924481,2307.0745496,2455.3899759,0.0131052,307.2137527,281.9853972,559.651425,15.6097009,16.6662441,1.0014831,53.2064952),(39586,'femur.tif',235,7,132,106.1401966,33.3587789,34.820671,1.8,33.3719971,34.8251338,-0.0105059,8.2039965,8.09311,2326.5202937,2512.2356996,0.001953,310.4166024,283.5837748,569.5098712,15.6097009,16.7300628,2.7049655,53.4583437),(39587,'femur.tif',235,7,133,106.1524309,33.2678744,34.9265556,1.8,33.2956721,34.9483611,0.0312272,8.2469051,8.2193989,2340.8831836,2558.9031384,0.0172471,311.3248512,283.8498987,575.3376811,15.6097009,16.8412572,2.7226913,53.6171599),(39588,'femur.tif',235,7,134,105.6246388,33.179081,35.0051744,1.8,33.17133,35.0199635,0.0422457,8.3251646,8.3200204,2352.2887745,2602.2769812,0.0313998,312.772908,282.5516229,577.5671298,15.7220009,16.9576728,2.7401791,53.9347923),(39589,'femur.tif',235,7,135,105.3172212,33.1093307,35.0979124,1.8,33.1044934,35.1044092,0.0545489,8.3388148,8.4116589,2369.6825066,2649.8527667,0.0521786,315.0214229,284.1749784,580.2755299,15.7220009,17.09212,2.7220341,54.1593923),(39590,'femur.tif',235,7,136,105.2891987,33.0172361,35.1991269,1.8,33.0154304,35.2120022,0.0753562,8.4117145,8.5206783,2388.0439622,2704.6461713,0.0994606,317.4214647,283.8950331,582.7123784,15.816875,17.2525853,2.7332821,54.5700571),(39591,'femur.tif',235,7,137,105.3453643,32.9222394,35.3096117,1.8,32.9134065,35.3205781,0.0949596,8.4566414,8.6226699,2401.1263922,2771.6165622,0.1578473,321.433687,283.9338081,588.7064077,15.8343009,17.350987,2.7707014,54.7946571),(39592,'femur.tif',235,7,138,106.0263684,32.8539304,35.3960456,1.8,32.8451073,35.3897318,0.1141015,8.4750434,8.7054979,2423.1994276,2859.0464179,0.229066,328.4184839,285.9217706,596.2129506,15.8343009,17.4964707,2.7670457,55.1122895),(39593,'femur.tif',235,7,139,106.454017,32.8134666,35.4560604,1.8,32.8565139,35.4692448,0.1346753,8.4937759,8.7774371,2447.3987135,2942.4390444,0.31986,335.2275866,288.1402492,602.103248,15.9466009,17.6539753,2.7977129,55.5229542),(39594,'femur.tif',235,7,140,106.5041824,32.7421042,35.5209923,1.8,32.8031851,35.5519922,0.1545541,8.5018083,8.8815597,2466.0586345,3023.7753409,0.4206452,340.4554414,290.0628385,607.5865274,16.0589009,17.8302565,2.7540688,55.9063704),(39595,'femur.tif',235,7,141,106.2898974,32.6512224,35.5863496,1.8,32.713542,35.5997544,0.1700284,8.5402607,9.0239661,2477.1070115,3114.0128252,0.5072178,345.0825033,290.0505133,613.5218843,16.0589009,18.0174153,2.8572999,56.3170352),(39596,'femur.tif',235,7,142,106.7109566,32.5861947,35.6622359,1.8,32.6462876,35.6744987,0.1800518,8.5965309,9.140532,2509.138822,3212.2022462,0.5703668,351.4239912,291.8780661,621.2613985,16.0589009,18.2510833,2.8801976,56.7004514),(39597,'femur.tif',235,7,143,107.4013364,32.4851228,35.7397748,1.8,32.5495292,35.7682858,0.1810775,8.6806015,9.2968018,2535.3447537,3336.8333255,0.5805441,358.9227127,292.0701689,628.5581275,16.1712009,18.5209915,2.896614,57.1769),(39598,'femur.tif',235,7,144,108.3070395,32.3930749,35.8357488,1.8,32.4338119,35.8886324,0.1707108,8.7917615,9.4386769,2573.975175,3462.718325,0.5209598,366.8648015,292.771269,637.6071846,16.2835009,18.770569,2.9183812,57.7191324),(39599,'femur.tif',235,7,145,110.3684446,32.2868414,35.9263666,1.8,32.2753476,36.0145281,0.1520701,8.9293936,9.601869,2637.5887511,3609.1200304,0.422115,375.8768254,295.3827405,649.3407026,16.3958009,19.0516555,2.9337928,58.2886133),(39600,'femur.tif',235,7,146,111.487347,32.2315383,36.0415511,1.8,32.1636482,36.0965025,0.1326478,9.0764285,9.7136099,2676.3737411,3731.5874579,0.3250314,384.1607283,294.870802,658.2318466,16.6204009,19.337135,2.9487529,58.8580943),(39601,'femur.tif',235,7,147,112.6416633,32.2109278,36.1123284,1.8,32.1613264,36.15414,0.1169547,9.198119,9.8130615,2717.5586187,3848.9226296,0.2556243,392.2244473,295.4472116,667.5974199,16.7327009,19.6139605,3.0037442,59.493359),(39602,'femur.tif',235,7,148,113.0084399,32.1838103,36.1538129,1.8,32.0794439,36.1676236,0.0960249,9.2822957,9.9225588,2793.1890087,3934.3062868,0.1731374,396.5011819,300.9157533,671.7382178,16.9570773,19.9186151,3.0172377,60.1558724),(39603,'femur.tif',235,7,149,114.969123,32.102988,36.2715239,1.8,32.0602962,36.3146997,0.1066071,9.4952273,10.1081766,2852.0021106,4068.3105283,0.2169482,402.4771933,300.3616485,681.695309,17.069601,20.2517112,3.0805574,61.0157371),(39604,'femur.tif',235,7,150,118.7787945,31.9890363,36.1809797,1.8,31.9263787,36.183386,0.1220492,9.5335655,10.3348813,2984.4031969,4224.3025237,0.2934268,408.7422384,313.0416617,697.0524974,17.294201,20.5879942,3.0815556,62.3905858),(39605,'femur.tif',235,7,151,120.1229483,31.8890911,36.2276624,1.8,31.7596482,36.2053184,0.1241962,9.7197345,10.5121106,3098.1521713,4320.9752475,0.3072257,411.0473544,318.7486428,703.8819865,17.406501,20.8630322,3.0499581,63.3275211),(39606,'femur.tif',235,7,152,120.5970615,31.7655904,36.2742768,1.8,31.6924297,36.342651,0.1613944,9.9511649,10.7587337,3158.7509901,4452.5561914,0.5190249,413.8550437,317.4252479,707.1880425,17.631101,21.2089496,3.0461389,64.3574888),(39607,'femur.tif',235,7,153,120.6742817,31.5391242,36.4042091,1.8,31.4224902,36.362326,0.2329137,10.3378644,11.051938,3210.8856079,4583.0196474,1.0714847,414.6801813,310.5946716,703.8792416,17.9632551,21.618845,3.0688048,65.8639051),(39608,'femur.tif',235,7,154,121.964386,31.3203435,36.2607598,1.8,31.2281774,36.2703341,0.2626889,10.4386284,11.391993,3335.9949257,4700.4512086,1.3707319,412.6100874,319.5817302,704.6821878,18.080301,21.9720925,3.0597248,66.9596566),(39609,'femur.tif',235,7,155,124.0792805,31.1164323,36.2658692,1.8,31.0096262,36.2929154,0.2873153,10.7016564,11.6463917,3443.6708872,4915.0331172,1.6606657,422.0219668,321.788587,715.2058701,18.3874339,22.2733693,3.0253676,68.1484404),(39610,'femur.tif',235,7,156,126.6531837,30.9004838,36.185095,1.8,30.849435,36.1677765,0.3115337,10.9155428,11.949317,3535.5194104,5169.5865776,1.9832579,432.626113,323.8977189,727.660687,18.529501,22.6437028,3.0621582,69.6548567),(39611,'femur.tif',235,7,157,129.7031178,30.7256585,36.1381441,1.8,30.6461602,36.1031224,0.3170886,11.1763451,12.1633851,3687.3207231,5454.7791138,2.1016285,448.4589655,329.9218732,749.5820817,18.8664011,22.9427566,3.0287733,70.6961111),(39612,'femur.tif',235,7,158,132.4816418,30.573882,36.0039899,1.8,30.4791865,35.9631682,0.3044941,11.4002677,12.3923754,3886.8432985,5705.7957678,1.9847159,460.4279315,340.9431618,773.3089712,19.2033011,23.221947,3.0544354,72.3885921),(39613,'femur.tif',235,7,159,135.2260254,30.3932488,35.8575623,1.8,30.3040825,35.8307117,0.3139808,11.6482194,12.6757331,4151.3716605,6079.9706174,2.1497924,479.6543586,356.3953864,805.8333523,19.5402011,23.7784491,2.6335767,75.1223276),(39614,'femur.tif',235,7,160,138.2856223,30.2439622,35.6659114,1.8,30.1720613,35.6643028,0.3168787,11.9744794,12.9434,4474.9429132,6575.350771,2.2378283,508.0080013,373.7066773,853.7304079,19.8771011,24.7389038,2.5271479,77.4341115),(39615,'femur.tif',235,7,161,144.8135353,30.053364,35.3414013,1.8,29.981201,35.3661114,0.3169468,12.257503,13.2606398,4881.149491,7234.4305949,2.344441,545.5566761,398.2172796,912.6722732,20.2562575,26.0114549,2.5715522,80.3153764),(39616,'femur.tif',235,7,162,153.7688273,29.6824623,34.896897,1.8,29.6082737,34.9651791,0.3288985,12.6649621,13.7603479,5379.5906362,8362.5210764,2.6737714,607.7259936,424.761686,997.0244026,20.8128842,27.443971,2.5365656,86.0825813),(39617,'femur.tif',235,7,163,184.7325181,28.2052726,32.6501509,1.8,27.9902819,32.6228535,0.7155749,13.7013449,20.6489449,6989.8324344,15408.534889,13.2515869,746.2141515,510.1566647,1072.6601566,21.7476243,31.9028882,2.4734486,98.7944883),(39618,'femur.tif',235,7,164,219.4910273,27.6325576,30.8639812,1.8,27.6654047,30.8739231,0.7498035,14.6237043,20.6792745,8908.2451661,21747.4643216,16.9899011,1051.6550912,609.164749,1476.6737624,26.2122941,38.604097,2.3315081,123.8706826),(39619,'femur.tif',235,7,165,249.9659499,27.6213734,29.7018222,1.8,28.1999232,29.7938162,0.7546273,15.8961314,20.7523349,11637.046007,25206.9248471,19.5493586,1214.6548781,732.0678042,1774.5105301,28.4641343,39.4754889,2.3340653,132.6826437),(39620,'femur.tif',235,7,166,282.7026299,28.2630489,28.4916212,1.8,28.9989605,28.7255745,0.7199095,17.1240894,20.9529815,16641.9158718,27561.125719,20.4817299,1315.3796636,971.842384,2109.6043182,30.089994,40.0267218,2.3403228,129.0458332),(39621,'femur.tif',235,7,167,303.3695582,28.7188784,27.7515487,1.8,29.3559103,28.2588909,0.7076985,17.7880728,21.0960604,20083.4170203,28725.5871353,21.3679686,1361.6564677,1129.0383899,2310.8764068,31.4921301,40.2731372,2.3305591,132.7869628),(39622,'femur.tif',235,7,168,316.0401068,29.4204611,27.3167263,1.8,30.1425605,27.8058663,0.4896872,21.2414181,21.4333453,24843.1571497,29291.5287371,11.6528712,1366.6335467,1169.5620798,2366.9081384,32.6698145,41.0403903,0.8900725,140.8932002),(39623,'femur.tif',235,7,169,318.773201,29.8270221,27.424854,1.8,30.4313495,27.8916507,0.4189879,21.4714285,21.670224,27588.8071222,29966.5496441,8.7936581,1382.8444795,1284.9078519,2473.2563929,34.2349935,42.2333136,0.8889957,143.670146),(39624,'femur.tif',235,7,170,308.4233604,29.9649413,27.5640037,1.8,30.3843498,28.1118543,0.3783174,21.659407,21.6596395,28095.4081271,29117.1565819,7.0127706,1344.3047633,1297.1457676,2428.5383453,34.7260581,43.1706991,0.9163695,145.6915462),(39625,'femur.tif',235,7,171,291.8783458,29.9982492,27.8099268,1.8,30.3609892,28.2453174,0.2212501,20.3788035,20.886835,27393.8843667,28515.1390136,2.342716,1365.2206749,1344.2341864,2350.7174843,34.8534855,43.6431115,0.9149438,150.7304539),(39626,'femur.tif',235,7,172,275.4173973,30.0539358,28.1529037,1.8,30.2232648,28.4481029,0.0228538,17.949788,19.2814367,26651.7297076,27729.6834847,0.0239713,1438.1544268,1484.7935663,2288.5056787,34.5517667,43.6917748,0.9093023,149.4599244),(39627,'femur.tif',235,7,173,257.9200572,30.112505,28.4230014,1.8,30.325789,28.6776221,-0.36541,18.8679507,21.3461233,24953.7880501,26663.9429635,5.4888101,1249.1234377,1322.5489352,2195.5303141,34.1016909,43.4103079,0.8843387,147.674411),(39628,'femur.tif',235,7,174,241.7925659,29.9785486,28.6464789,1.8,30.253539,29.070635,-0.4904333,19.3518397,22.1097506,21861.1400182,24813.9429851,8.9402269,1122.3076838,1129.6672761,2002.5203612,33.5250316,42.8493326,0.883776,144.3552328),(39629,'femur.tif',235,7,175,228.0624754,30.0797639,28.8094115,1.8,30.1326669,29.4801459,-0.4988425,18.7912303,21.0393313,18927.4920796,22898.0394091,8.6996544,1088.34445,1007.2513494,1889.1299355,32.5720614,41.4606087,0.8947863,139.7044164),(39630,'femur.tif',235,7,176,216.680513,29.9677647,29.1895328,1.8,30.026225,29.8640112,-0.5006902,18.0450212,20.3197032,16059.7648041,20800.3203993,8.3216113,1023.6527666,889.9831473,1715.0471665,31.4494823,40.259983,0.8742723,132.8254981),(39631,'femur.tif',235,7,177,202.0202963,29.6414719,29.735036,1.8,29.89224,30.3105443,-0.5125026,17.1175464,19.899609,13325.7726035,18121.5787488,8.0960581,910.64999,778.4861399,1510.4218639,30.1717602,38.6980673,0.8593372,127.1672874),(39632,'femur.tif',235,7,178,186.2015227,29.3246884,30.3445201,1.8,29.6437324,30.7600778,-0.4923128,16.0198463,19.3035038,10622.9351431,15269.1463508,6.9332891,791.0038783,663.1109297,1298.4132061,28.4878189,36.8539125,0.8069466,121.0758385),(39633,'femur.tif',235,7,179,166.4734564,28.8857314,31.0988654,1.8,29.2949472,31.2661414,-0.3898679,14.7477711,18.0388223,7901.2519967,11948.1499281,4.0078587,662.357538,535.7590622,1060.9515126,26.5631734,34.292899,0.6926418,117.8158325),(39634,'femur.tif',235,7,180,143.6186995,28.6853419,31.6677655,1.8,29.1423755,31.6851498,-0.3027116,13.1897409,16.4323192,5313.2153461,8943.0070703,2.1272165,544.232798,402.829396,816.9185098,24.1755254,31.9376559,0.7082449,113.460075),(39635,'femur.tif',235,7,181,115.8206756,28.714067,32.1864005,1.8,29.208717,32.0750706,-0.1907491,11.2719581,13.8405984,3249.3313381,6500.3862223,0.693883,469.6607783,288.2668049,620.1759118,21.3876273,29.1489371,0.6789527,126.5826468),(39636,'femur.tif',235,7,182,83.3811494,29.4912444,32.5581615,1.8,30.1664784,32.2863055,-0.1116087,9.4406744,12.6590021,1744.6735882,4545.7717554,0.1723886,359.0940055,184.8039145,467.7118201,7.2217851,12.594134,1.4276382,33.5319878),(39637,'femur.tif',235,7,183,43.645659,32.3113941,32.8043966,1.8,32.8365641,32.4875914,-0.1228069,7.9277577,14.1057874,611.7649419,1582.4922899,0.1091568,112.1874481,77.1674617,155.5559765,3.4149057,6.3218022,1.3559809,16.2510101),(39638,'femur.tif',235,7,184,14.8627619,35.1245681,32.8225408,1.8,35.1686594,32.6220916,-1.4268763,2.5140115,4.9565806,21.3602081,76.9634939,2.4261716,15.5275381,8.4964639,19.7499933,5.0432041,9.3755374,1.4627846,23.9080474),(39639,'femur.tif',235,7,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39640,'femur.tif',235,7,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39641,'femur.tif',235,7,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39642,'femur.tif',235,7,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39643,'femur.tif',235,7,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39644,'femur.tif',235,7,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39645,'femur.tif',235,7,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39646,'femur.tif',235,7,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39647,'femur.tif',235,7,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39648,'femur.tif',235,7,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39649,'femur.tif',235,7,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39650,'femur.tif',235,7,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39651,'femur.tif',235,7,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39652,'femur.tif',235,7,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39653,'femur.tif',235,7,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39654,'femur.tif',235,7,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39655,'scapula humerus',248,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39656,'scapula humerus',248,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39657,'scapula humerus',248,2,3,11.1708939,113.4829182,132.7151351,1.8,113.0412819,132.7171028,-0.1316234,2.1211332,21.9462822,6.3460729,1210.5060976,0.0320696,55.1576839,2.9918314,55.3097524,4.2374472,39.9863876,0.1510153,85.1140003),(39658,'scapula humerus',248,2,4,42.5186282,109.4989581,132.4786738,1.8,109.0602786,132.4427571,-0.0967807,4.3002778,26.9425368,54.2914155,9667.633253,0.0661681,358.8241639,12.625095,359.9568445,6.8912462,57.1872597,0.1280828,123.3003977),(39659,'scapula humerus',248,2,5,44.3897873,105.1393256,131.9203229,1.8,105.4485654,131.8990394,-0.0717288,4.4543649,28.0255637,65.2687258,12864.4005386,0.0379991,459.0237923,14.6527567,455.6335427,7.2194667,63.5851135,0.1151348,137.8666038),(39660,'scapula humerus',248,2,6,42.354194,101.9278208,131.1019561,1.8,103.6644655,130.9367111,-0.0629402,5.1304208,31.1660328,72.9029628,13815.768894,0.0279272,443.2957179,14.2099383,441.8086593,7.2223462,68.1959664,0.094653,151.6776938),(39661,'scapula humerus',248,2,7,66.3427854,111.4101539,128.2286206,1.8,109.4106964,128.1368996,-0.1044217,9.4437105,40.1134152,372.3820344,29799.8627013,0.1201282,742.890192,39.4317503,751.4220237,5.585944,56.7448517,0.0302938,124.8106301),(39662,'scapula humerus',248,2,8,65.2224622,108.7123751,127.9554025,1.8,106.9519453,127.8291775,-0.0892623,7.7538963,38.4058863,228.2882282,31819.3528109,0.086383,828.5019799,29.4417438,834.4429025,5.9779061,58.0476523,0.0370201,128.8558047),(39663,'scapula humerus',248,2,9,45.507425,97.0126185,128.9939438,1.8,100.2421864,128.956353,-0.0355712,4.0756579,35.9095593,58.1612874,16063.6656809,0.0095928,447.3367539,14.2704047,446.7915437,6.9828663,73.6285152,0.064239,161.6342406),(39664,'scapula humerus',248,2,10,45.9351553,96.7566141,128.2805964,1.8,99.2560578,128.3701082,-0.0340465,3.6809213,36.1503214,58.4308574,16685.4929,0.008871,461.5586318,15.8739765,461.2550188,6.7683351,74.4365477,0.0519763,159.9586744),(39665,'scapula humerus',248,2,11,45.7338507,96.5103676,127.5708531,1.8,99.3064487,127.6966487,-0.0316894,3.8059924,36.3796877,63.5561863,17708.9195203,0.0076519,486.7804156,16.6989789,486.7642004,6.6248091,74.8656588,0.0516781,162.6410622),(39666,'scapula humerus',248,2,12,46.7588368,97.1807844,126.9070536,1.8,99.2859099,127.0534298,-0.0266069,3.9530266,35.687058,73.2913,19354.317163,0.0055157,542.3343435,18.540553,542.3874757,7.0603119,74.8656588,0.0516781,164.3166284),(39667,'scapula humerus',248,2,13,48.2187707,98.5283183,126.2216405,1.8,99.9135199,126.416751,-0.0188111,4.0452216,34.3099511,82.850266,20619.2297781,0.0028434,600.9693726,20.4810206,600.9114384,7.4730314,75.6690206,0.0340777,165.4277098),(39668,'scapula humerus',248,2,14,49.6849148,100.1874383,125.6283957,1.8,100.6098968,125.8748737,-0.010116,4.1923674,32.6165263,92.3853346,21933.9795744,0.0008474,672.4805499,22.0365549,672.7719277,7.116234,40.8407086,3.1100242,90.1838847),(39669,'scapula humerus',248,2,15,51.8926633,101.6637762,125.1033175,1.8,101.4639452,125.3451763,-0.0015973,4.3895354,31.2009791,105.502601,22880.2275849,0.0000221,733.3176149,24.0350268,731.4260219,8.3824766,76.9441523,3.113667,170.0373692),(39670,'scapula humerus',248,2,16,57.047023,102.6444523,124.6806802,1.8,101.7680905,124.919242,0.0054735,5.1288372,32.1637683,127.217939,24485.5281427,0.0002849,761.2767237,24.8044409,759.6814607,9.3402854,78.232722,3.114127,172.3637918),(39671,'scapula humerus',248,2,17,63.384257,104.045079,124.2525472,1.8,102.4927249,124.4809117,0.0118726,5.4330797,33.5492369,156.5252343,26778.4448883,0.001489,798.1834265,28.80967,797.1290313,9.7774564,78.675157,3.1088175,174.7944742),(39672,'scapula humerus',248,2,18,66.4190999,104.4513309,123.8639266,1.8,102.8270633,124.1039554,0.0180257,5.7792235,33.940304,179.1592242,27325.3784267,0.0035965,805.1011694,31.0005702,804.4813539,10.287414,79.1046155,3.1089955,176.2615208),(39673,'scapula humerus',248,2,19,67.4529259,104.5862796,123.4805022,1.8,102.9940144,123.7133499,0.0237883,6.139478,34.0502782,203.6235423,27308.4441297,0.0063605,802.0035531,33.166263,801.6742527,10.1555477,52.9371431,3.0847434,121.1393088),(39674,'scapula humerus',248,2,20,67.2529641,104.4816932,123.0949481,1.8,102.5908162,123.316864,0.0295352,6.5030994,33.9279224,233.1044883,26944.3142658,0.0097749,794.1634024,35.845137,793.3111261,10.5881372,51.6502135,3.0833254,119.5248166),(39675,'scapula humerus',248,2,21,67.8727115,104.5214437,122.7076628,1.8,102.5093223,122.9407214,0.0357777,6.4522888,33.9474202,264.3219094,25896.5806514,0.0144738,762.8438473,40.9656042,762.8721881,10.7940036,52.0791783,3.0838058,121.495274),(39676,'scapula humerus',248,2,22,71.1077399,104.1541479,122.4028729,1.8,102.2361842,122.6362967,0.0427394,6.8908391,33.5602726,300.3365097,24896.528823,0.0216351,741.8452497,43.5848964,742.9797276,12.031264,79.1197852,3.1035675,180.6626606),(39677,'scapula humerus',248,2,23,72.215139,103.5977751,122.0562652,1.8,101.6711126,122.2936311,0.0509485,7.2789496,32.9559271,352.944308,23950.5446602,0.031215,726.7446791,48.4883569,727.5786373,12.8166978,79.1046155,3.1089955,182.2339669),(39678,'scapula humerus',248,2,24,73.6819545,103.1662258,121.7350577,1.8,100.9724341,121.9485964,0.0590692,7.7201692,32.4960399,420.3734781,23160.369055,0.0427984,712.7135834,54.4513293,715.4045568,13.320328,78.6622488,3.114277,182.8416375),(39679,'scapula humerus',248,2,25,75.0111914,102.1371106,121.3498093,1.8,100.2845679,121.5635561,0.0689389,8.5513588,31.4277103,514.7863145,22101.3703671,0.0593219,703.2446885,60.1993588,708.1925394,14.3591491,77.4201913,3.0971774,183.3450483),(39680,'scapula humerus',248,2,26,76.1242972,101.4002729,120.9625545,1.8,99.2848352,121.0867407,0.0842829,10.1223244,30.623148,648.519795,20941.659063,0.089913,683.8506309,64.0682683,690.7094014,16.4947158,76.5279033,3.1078975,184.3086841),(39681,'scapula humerus',248,2,27,78.0445796,100.6881876,120.4904455,1.8,98.5773153,120.5401942,0.1064767,11.5638035,29.7474535,842.8966318,19942.6559905,0.1469125,670.3987607,72.8909508,680.1602183,18.4009535,75.2395835,3.1073204,186.8868121),(39682,'scapula humerus',248,2,28,79.090155,100.0218943,119.9827853,1.8,97.8173276,119.900236,0.1337576,12.9860838,28.9012816,1108.396571,18816.7273241,0.2344319,651.0689584,85.3526428,666.1015271,20.350126,73.5218644,3.1065193,187.2427773),(39683,'scapula humerus',248,2,29,80.3042488,99.2595775,119.5725429,1.8,96.9270996,119.393928,0.1490977,13.7553222,28.0422466,1366.7002006,17970.1861085,0.2953308,640.825479,99.3579196,661.5868897,21.4908014,71.7900511,3.1116615,186.7393665),(39684,'scapula humerus',248,2,30,82.0664192,98.3638121,119.271229,1.8,96.1737577,119.0438333,0.1557893,14.4225421,27.1288879,1633.7795547,17431.4230235,0.3292858,642.5410088,113.2795832,671.2819581,22.3725437,70.0510055,3.1231898,183.3018625),(39685,'scapula humerus',248,2,31,85.9671292,97.4305539,119.0539504,1.8,95.6909497,118.6654396,0.156317,14.9049831,26.1694558,1930.8625625,17428.5128059,0.3472588,665.9868265,129.5447666,705.3969194,22.6505333,67.4733308,0.019106,179.3609477),(39686,'scapula humerus',248,2,32,92.9327267,96.1861107,118.8778131,1.8,94.8634246,118.4149723,0.1461188,15.8684752,25.0466288,2346.0112934,18080.479019,0.3283497,721.8727576,147.8410034,777.9108361,23.5243817,63.6301049,0.0337709,173.3453157),(39687,'scapula humerus',248,2,33,101.0779533,94.9752044,118.7190844,1.8,93.9282538,118.2178691,0.1358158,16.4532207,24.006754,2773.693648,18419.2253577,0.30884,767.2518065,168.58059,844.0902015,23.7588996,60.1946728,0.0356991,166.8694587),(39688,'scapula humerus',248,2,34,110.669798,94.060083,118.7620395,1.8,92.9686638,118.1926016,0.1183856,17.5342139,23.2429863,3142.4663961,18923.7405875,0.2573035,814.1699336,179.2191208,907.882078,24.7747172,56.7594916,0.0378607,159.3867801),(39689,'scapula humerus',248,2,35,123.434176,93.1945929,118.8705616,1.8,92.3162205,118.2099525,0.0963199,18.2576855,22.591671,3601.4714645,20236.4168623,0.1902709,895.746795,197.2578321,1012.3067854,25.351592,52.5081549,0.0573142,152.0083613),(39690,'scapula humerus',248,2,36,135.7917487,92.4203129,118.899616,1.8,91.8720151,118.1862808,0.0843006,18.8511855,22.8828489,4141.1815767,20881.6953466,0.1604554,912.5478836,219.6775151,1092.8894101,25.78128,48.6762735,0.0706785,143.8137523),(39691,'scapula humerus',248,2,37,145.9205361,92.3158182,118.6805053,1.8,91.940805,117.9202003,0.1187594,19.2621972,22.2233773,4623.9140573,19147.2534534,0.341396,861.5816209,240.0512258,1068.4160501,26.640656,44.4264977,0.0871573,136.226814),(39692,'scapula humerus',248,2,38,150.9988611,92.5450413,118.3838709,1.8,92.43666,117.6715065,0.2023916,18.4329031,21.5338872,4876.7690402,16601.7173197,1.0168797,770.9577556,264.5686902,996.0473614,26.640656,41.3595626,0.0727878,128.9958408),(39693,'scapula humerus',248,2,39,156.6647628,92.4462226,118.132114,1.8,92.5611593,117.4118566,0.3024847,17.6667773,20.6617709,4952.3735604,14829.6920766,2.3170776,717.735773,280.3212766,948.6710837,27.2633718,38.3964157,0.0896467,123.336174),(39694,'scapula humerus',248,2,40,168.0705307,92.1219238,117.9008198,1.8,92.3389578,117.2097135,0.4252731,16.6687325,19.9469414,5157.5584776,14203.9552755,4.7679822,712.08688,309.4151573,933.2625462,27.2156763,36.2596592,2.431681,119.039294),(39695,'scapula humerus',248,2,41,177.2507584,91.7138958,117.5360203,1.8,92.0349049,117.0095141,0.5629674,14.9746541,19.0487828,5220.8951285,14378.0046014,8.4144951,754.7991266,348.6487963,941.6027765,26.4364852,36.4804859,2.3228735,116.3569062),(39696,'scapula humerus',248,2,42,187.3867073,91.3646642,117.3642596,1.8,91.6918497,116.9728185,0.6512476,13.8612888,18.7735739,5422.1796908,15531.3403553,11.4759716,827.2980105,391.1742814,999.2505904,25.7216113,36.8255401,2.2984077,115.60179),(39697,'scapula humerus',248,2,43,203.4439651,90.9832527,117.2452622,1.8,91.4390332,117.1270221,0.7153993,13.4202607,18.6212095,5741.5917981,17518.8546447,14.5879333,940.801113,427.8301249,1103.5870419,25.7868354,37.4716515,2.2831539,116.461166),(39698,'scapula humerus',248,2,44,203.6598724,90.7607445,117.3365117,1.8,91.2682452,117.4167164,0.7703614,13.7018516,18.5364323,6142.7074222,19369.6760732,16.4613364,1044.951682,448.3122131,1196.970634,26.1219581,37.9879188,2.2278713,119.3952591),(39699,'scapula humerus',248,2,45,183.3094781,91.2280235,117.8331472,1.8,91.4378216,118.053012,0.8045217,14.691037,19.8035515,6756.703485,20653.1147356,15.8599029,1042.8995399,459.9201198,1233.4557726,12.2843198,32.8367109,0.1048769,77.7534697),(39700,'scapula humerus',248,2,46,184.4014352,91.2462493,118.5302303,1.8,91.4910424,118.8990698,0.8400981,15.8775692,21.0496503,7856.3134844,21294.0080126,17.0445584,1011.6086335,494.8058091,1267.0075378,14.179704,33.8473068,0.1401017,81.2952334),(39701,'scapula humerus',248,2,47,222.0217824,91.7796222,119.9483629,1.8,91.5213855,119.933749,0.8362407,17.0671648,22.9528799,9720.4908146,22824.7999291,20.3799328,994.4198728,569.5433843,1330.2183829,17.617208,35.1845999,0.1470784,87.97961),(39702,'scapula humerus',248,2,48,273.6227275,92.3444895,121.0809426,1.8,91.5925016,120.8083754,0.7757974,17.6188985,24.1853219,13319.4656918,26107.437839,22.3640874,1079.4744823,755.9760737,1533.0165715,20.625024,35.8988831,0.1927008,93.5529052),(39703,'scapula humerus',248,2,49,188.6296708,89.597996,120.0976869,1.8,90.1797113,120.412639,0.7391674,16.9880581,21.9655714,13412.5656022,20413.7418956,14.2677941,929.3517359,789.5290639,1401.9769411,21.054712,35.6537486,0.2186689,94.915692),(39704,'scapula humerus',248,2,50,87.5267642,81.3932759,118.4052057,1.8,82.0073217,117.4222347,1.5584437,24.7407496,21.6941534,961.4666855,11670.7629304,14.5855682,537.96812,38.8616635,510.5822071,13.1112147,16.9113756,1.0957856,48.3693519),(39705,'scapula humerus',248,2,51,51.8169643,80.7796654,114.7722353,1.8,80.7424331,113.966265,1.5332689,6.4959917,17.9667849,299.5726943,7965.0433394,8.624004,443.3204604,46.1165451,449.1526844,0,0,0,0),(39706,'scapula humerus',248,2,52,20.0417235,79.4951793,102.0959903,1.8,79.7106654,103.4686343,-1.4042125,7.0526296,23.9648119,148.3835832,463.7121613,3.248448,19.34971,21.0394691,24.6372102,5.9631368,14.5397175,0.5961991,33.5514403),(39707,'scapula humerus',248,2,53,13.7087416,78.6467633,101.1057116,1.8,78.8074647,100.9951432,-0.581131,2.3936327,6.2561524,14.8858431,115.4081487,0.6885618,18.4471446,6.2189338,20.8198951,5.2483716,12.89064,0.6435011,30.0096765),(39708,'scapula humerus',248,2,54,5.8134952,77.9686858,101.0924812,1.8,78.0687558,101.0439101,-0.6000595,1.9788868,4.6637575,3.5406772,29.4991319,0.3089646,6.3251856,1.7892268,7.0519827,4.2536942,9.8921606,0.6000502,22.3184783),(39709,'scapula humerus',248,2,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39710,'scapula humerus',248,2,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39711,'scapula humerus',248,2,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39712,'scapula humerus',248,2,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39713,'scapula humerus',248,2,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39714,'scapula humerus',248,2,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39715,'scapula humerus',248,2,61,18.9088677,93.3595999,119.9419345,1.8,93.1055143,119.5119834,0.8767823,5.0104541,8.3728738,87.7793494,200.6431568,1.8621334,23.9634755,17.5192404,34.4444605,10.3304002,15.3007547,2.2367656,41.4943439),(39716,'scapula humerus',248,2,62,98.9100965,92.8409529,119.6647924,1.8,93.0426402,119.4814312,0.8774174,9.0269379,11.5147411,1253.7490459,2633.9211513,9.7508973,228.7434115,138.889739,337.1784669,17.6037905,22.6148187,2.2485046,65.57476),(39717,'scapula humerus',248,2,63,143.9913019,92.7104187,119.8271909,1.8,93.0898198,119.297684,0.8584594,11.3193465,13.0763219,3006.8685748,5710.2604603,13.7464058,436.6870521,265.6397673,663.8063568,21.0992182,25.9703655,2.2507052,78.3790284),(39718,'scapula humerus',248,2,64,178.6052842,92.6223916,119.1257432,1.8,92.54939,117.7140986,0.9443118,12.9835598,19.6890465,5160.7814408,9296.7899673,19.5350039,472.1808126,397.4858602,709.4305742,24.1499645,28.9935938,2.4506494,96.4006267),(39719,'scapula humerus',248,2,65,230.9171736,92.3864019,116.5896598,1.8,92.7743916,115.628559,1.0468636,18.29139,18.9193016,9069.8964056,17413.9175111,28.8535151,920.4313099,495.8560512,1338.8006222,30.0174695,36.4044901,1.7728215,129.9341789),(39720,'scapula humerus',248,2,66,263.7560612,93.7055388,114.996783,1.8,93.7786121,114.3423346,1.2201987,18.4561082,18.9852054,14728.7020942,20567.0634577,38.773717,1083.320568,798.0394305,1853.9625152,31.7308822,37.3111726,1.8269477,113.4407011),(39721,'scapula humerus',248,2,67,254.44799,94.0353026,114.1899283,1.8,94.0604568,113.7197974,1.3290954,17.9550936,18.4649483,14524.3124618,20259.8460923,39.9784202,1097.2056767,808.9243519,1881.3411042,31.6905591,37.4248135,1.7907106,113.6492207),(39722,'scapula humerus',248,2,68,228.8970222,93.5972952,112.6801317,1.8,93.7242996,112.7447245,1.3727427,17.1167776,19.2969527,12744.5130756,16002.4639687,36.6725445,829.2741473,744.5626369,1489.0291596,29.7758593,36.5866148,1.7958346,108.3455191),(39723,'scapula humerus',248,2,69,202.9462426,92.9732981,111.1732803,1.8,92.9914207,110.9332306,-1.087945,14.3169599,13.9329151,11034.0447663,11698.5863007,26.5325011,839.6366588,770.6974675,1372.3304852,27.4797999,31.7882009,0.1629265,97.6770419),(39724,'scapula humerus',248,2,70,186.9023566,92.4452754,110.3987112,1.8,92.5189569,110.097583,-0.5482558,13.551956,15.6768387,9093.6413518,10354.2200294,8.4619685,660.478825,671.0205769,1216.5506038,25.3004569,30.751975,0.268703,91.0969251),(39725,'scapula humerus',248,2,71,180.2864964,92.0863913,110.0477319,1.8,92.1646293,109.7469108,-0.5219631,12.9956854,15.1431626,8173.5664677,9723.1497836,7.4694149,642.0818451,628.9446232,1161.2627194,24.0029886,29.9243065,0.2763273,87.1991961),(39726,'scapula humerus',248,2,72,178.3672211,91.7386084,110.0061391,1.8,91.8067768,109.6839912,-0.5895338,12.3956432,14.3592307,7769.2464657,9277.2958858,9.1890802,646.0858587,626.7723552,1143.5782029,23.4500849,29.0984764,0.2843848,85.6278897),(39727,'scapula humerus',248,2,73,173.7655259,91.3061707,109.9324859,1.8,91.4489265,109.6518564,-0.6318176,11.8775962,13.8367591,7376.9723194,8628.1049375,10.1022379,623.5640053,621.0829375,1113.9269567,22.6927367,28.2746458,0.2929124,83.5531726),(39728,'scapula humerus',248,2,74,169.9217161,90.9300202,109.8783025,1.8,91.0824049,109.6413276,-0.6607258,11.3365157,13.3211388,6924.584746,8261.2235948,10.665859,620.1589608,610.8212564,1097.0188918,22.2123362,27.8635357,0.346136,81.7301608),(39729,'scapula humerus',248,2,75,166.8237067,90.5830145,109.8633623,1.8,90.7354333,109.7011566,-0.6271901,11.3778234,13.2864322,6434.1006641,8081.2438979,9.5762003,608.2328035,565.4948622,1070.8417804,21.5735396,27.4597192,0.3514448,80.4105598),(39730,'scapula humerus',248,2,76,167.8357686,90.2202459,109.9877016,1.8,90.3539039,109.8830846,-0.6016793,11.3273641,13.5407491,6089.9441074,7882.1090977,8.9620756,582.1028826,537.6311806,1006.9909494,21.1043576,27.3687983,0.3863372,79.1952186),(39731,'scapula humerus',248,2,77,168.4435988,89.8488613,110.1100009,1.8,89.9010794,109.9314119,-0.6051845,11.2990149,13.9973359,5876.4136501,7786.6440397,9.0864927,556.2947196,520.0819465,960.8901978,20.9727758,27.4899593,0.4356829,78.8392534),(39732,'scapula humerus',248,2,78,160.2347581,89.34374,110.3641465,1.8,89.4529476,110.2781094,-0.5947999,11.272444,14.1735682,5524.7050436,7829.3411716,8.3851991,552.3902704,490.1071193,924.7428914,20.7171876,27.6740422,0.4497596,78.2315828),(39733,'scapula humerus',248,2,79,160.2453324,89.0120468,110.637419,1.8,88.9647796,110.5485334,-0.5704472,11.2533342,14.9973332,5378.8188167,7936.9721111,7.7881675,529.2255631,477.9755709,878.3823474,20.356965,28.248514,0.456845,78.587548),(39734,'scapula humerus',248,2,80,160.6364721,88.710329,110.9449019,1.8,88.5354299,110.8656022,-0.5443762,11.1733065,15.3676834,5286.8816191,8034.7302793,7.1805681,522.8328881,473.1707319,856.7204161,20.2773763,28.4504079,0.4366272,79.1952186),(39735,'scapula humerus',248,2,81,162.435401,88.4187881,111.1213189,1.8,88.2122957,111.0938793,-0.5182049,11.1727189,15.6699316,5158.7915112,8233.151469,6.642075,525.410812,461.7310767,848.9407577,20.0531297,28.637988,0.4837791,79.1952186),(39736,'scapula humerus',248,2,82,161.3771812,88.1278557,111.3398708,1.8,87.8082885,111.3414352,-0.4944239,11.2854948,15.9310265,5019.5211735,8282.2206449,6.0563134,519.8799114,444.7763504,828.0138186,20.0531297,28.8883304,0.3970794,79.1952186),(39737,'scapula humerus',248,2,83,163.3310889,87.9019396,111.626377,1.8,87.485776,111.6021954,-0.4572278,11.1185344,15.8420615,4985.7509104,8328.5296776,5.3052393,525.7225953,448.4179965,830.7733599,20.2530485,28.5669819,0.3693337,79.446924),(39738,'scapula humerus',248,2,84,165.2537212,87.646278,111.8601757,1.8,87.1451246,111.8350119,-0.4195289,11.1761794,15.9434746,5007.6849909,8464.948673,4.5697591,530.9349989,448.0676978,842.8380179,20.2826522,28.5669819,0.3693337,79.6986294),(39739,'scapula humerus',248,2,85,169.0519325,87.5416925,111.9941792,1.8,86.9135846,111.9606714,-0.3886664,11.2140524,16.0585874,5145.891455,8459.3623106,4.0461629,526.7812233,458.8788504,844.4567273,20.4750891,28.4146927,0.3552309,79.6986294),(39740,'scapula humerus',248,2,86,172.4210708,87.6845076,112.1031387,1.8,87.0242008,112.0356839,-0.3242439,11.0446834,16.0728339,5216.3296114,8306.606022,2.9168177,516.8102948,472.2932691,840.2576419,20.7449585,27.9924501,0.3120421,79.6986294),(39741,'scapula humerus',248,2,87,167.2946856,87.7034848,111.9077145,1.8,87.2532426,111.9876196,-0.2426744,11.3686052,15.9451736,4983.5370281,7976.3724208,1.6100404,500.2374142,438.3595841,812.739608,21.1751036,27.5134565,0.2525543,79.0909588),(39742,'scapula humerus',248,2,88,163.3106116,87.9510013,111.8324861,1.8,87.6419847,111.7297885,-0.164344,11.493768,14.8231313,4918.8027525,7200.6033925,0.7285467,485.7680377,427.9538929,816.0611244,21.10453,25.9596993,0.2168736,106.6267671),(39743,'scapula humerus',248,2,89,169.163383,88.1477531,112.2452052,1.8,88.053149,112.1325172,-0.188422,11.5027264,12.9268014,5462.6645455,6389.5969738,0.9891736,494.2906427,474.9017191,914.4802607,21.0471061,23.7691657,0.2186689,73.3270322),(39744,'scapula humerus',248,2,90,176.6893099,88.4314213,112.5740502,1.8,88.3414433,112.3268684,-0.3374801,11.4843678,12.0071893,5891.7787339,5918.7762234,3.2285291,492.9360306,513.025954,972.9154226,20.9817947,23.4485273,1.8113306,72.111691),(39745,'scapula humerus',248,2,91,177.015213,88.7270214,112.8515684,1.8,88.683052,112.5311376,1.2552205,11.3946369,12.0292469,5390.5067491,6161.729283,26.660682,512.2290161,473.0740266,935.2759115,20.7893147,23.8660645,1.8070416,71.3997606),(39746,'scapula humerus',248,2,92,178.3913352,88.9799921,113.2237477,1.8,88.9820834,112.8631755,1.2720358,10.9634678,12.6312687,4991.7189775,6374.755995,27.1561092,504.6805774,455.3047512,888.1839746,20.1161918,24.3864502,1.8200485,71.7557258),(39747,'scapula humerus',248,2,93,176.6065613,89.353678,113.5184872,1.8,89.3161596,113.1586102,1.2782125,10.5740151,13.033719,4570.8581014,6526.2891538,26.985769,500.7234822,432.2727059,844.2279833,19.5823853,24.8030861,1.815775,71.1480552),(39748,'scapula humerus',248,2,94,177.1690728,89.6388822,113.8929048,1.8,89.6152074,113.5247909,1.2750793,10.2894576,13.4695952,4282.3741906,6693.2369672,27.0203803,496.9144848,416.1904686,809.2819374,19.0319805,25.2201601,1.8116428,71.3997606),(39749,'scapula humerus',248,2,95,175.5111913,89.8863775,114.3473857,1.8,89.8365687,113.9980824,1.2680184,9.8289333,13.9656941,3997.8627768,6763.1089416,26.6511665,484.265865,406.7443201,765.6680369,18.5508697,25.6844182,1.8766752,71.3997606),(39750,'scapula humerus',248,2,96,173.7034784,90.1670227,114.8307311,1.8,90.1312621,114.4967752,1.2566933,9.6804871,14.2278392,3778.0096505,6795.9050047,26.1870027,477.6484279,390.2706158,732.5429877,18.1634728,25.9596993,1.7876699,71.3997606),(39751,'scapula humerus',248,2,97,174.7843016,90.5451638,115.3503128,1.8,90.469434,115.0287797,1.2496458,9.4730471,14.4149936,3645.0597172,6770.4901112,26.2281245,469.6838802,384.7821789,714.2511132,17.8784184,25.9703655,1.8559141,71.3997606),(39752,'scapula humerus',248,2,98,175.8863855,90.8213078,115.9100268,1.8,90.7476138,115.6370667,1.2338014,9.3089002,14.5922885,3599.768991,6647.3274842,26.1094229,455.5370114,386.7018572,694.279266,17.7188073,26.0555377,1.8037756,70.5403846),(39753,'scapula humerus',248,2,99,177.8409646,91.1227831,116.5397429,1.8,91.0361584,116.3375911,1.21599,9.2470728,14.4399168,3595.8845071,6379.1688835,26.0628061,441.773243,388.8673308,683.5293754,17.5306398,25.7418618,1.823872,70.5403846),(39754,'scapula humerus',248,2,100,177.2929439,91.4845282,117.3276399,1.8,91.445123,117.2042084,1.1803294,9.1402902,13.46881,3588.6524195,5918.9028795,25.2680332,439.4525474,392.6190902,695.5342426,17.5168417,24.4959849,1.8370484,68.5699272),(39755,'scapula humerus',248,2,101,176.2023856,91.9033754,118.1516832,1.8,91.8452082,118.1359152,1.1475406,9.0305043,12.3883817,3617.3636423,5398.1164508,24.4128394,435.7402413,400.5716101,709.7357945,17.318612,23.1752851,1.7572832,65.4883884),(39756,'scapula humerus',248,2,102,179.356232,92.2446409,118.9206183,1.8,92.2068961,118.9228216,1.1245541,8.970024,11.425606,3718.5219034,5063.5830287,24.3248827,443.1785101,414.5498296,747.1194419,17.853119,21.909875,1.7681919,63.8128222),(39757,'scapula humerus',248,2,103,184.2793544,92.5466683,119.6652722,1.8,92.5463423,119.7493965,1.1274316,9.0711503,10.70264,3889.0439896,4795.9037269,25.061225,448.1047396,428.7266638,781.3868067,18.2218465,21.1247487,1.6522484,63.2051516),(39758,'scapula humerus',248,2,104,186.1415617,92.8700869,120.3832147,1.8,92.8661078,120.4492053,1.1760416,9.1959381,10.2676391,4149.0613832,4621.9696478,26.4351067,450.1492109,451.1841357,832.6463905,18.7931607,20.5622657,1.3815973,63.1008918),(39759,'scapula humerus',248,2,105,187.9078724,93.235792,121.0603918,1.8,93.2540252,121.1857477,-1.2194013,9.8477028,10.3091701,4422.8263277,4508.5401044,27.6074523,437.3329842,449.1226434,863.7755256,18.906272,20.5622657,1.3815973,63.6043026),(39760,'scapula humerus',248,2,106,192.4113212,93.5150978,121.7286279,1.8,93.5063983,121.8588489,-0.5875042,9.3955879,10.5236576,4366.5860935,4873.6053246,9.8524953,463.1094542,464.7485757,848.1433378,18.9706219,20.7855324,1.0516502,64.3594188),(39761,'scapula humerus',248,2,107,194.3479967,93.7836221,122.3578122,1.8,93.7476845,122.4907137,-0.518483,9.2937046,11.0721005,4258.6361376,5375.0858947,7.9547532,485.4621656,458.2280491,838.158194,18.6516542,21.6768972,0.6871242,65.3662405),(39762,'scapula humerus',248,2,108,196.0491267,93.9944317,122.8676248,1.8,93.9654423,123.0409094,-0.4922235,9.2033364,12.1055587,4164.9429939,5988.7802118,7.2975392,494.713243,452.547078,817.2126166,18.241326,23.2190609,0.6805212,66.9807327),(39763,'scapula humerus',248,2,109,200.0785754,94.2553133,123.2640442,1.8,93.9826167,123.604852,-0.4693799,9.2275853,16.6904324,4037.55093,7142.6060849,6.822861,427.946137,437.5522749,669.7663536,18.0195735,25.4243162,0.5317241,70.5224965),(39764,'scapula humerus',248,2,110,206.3681967,94.3186185,123.7240396,1.8,93.9670538,124.059197,-0.4514508,9.1144474,17.3124617,3894.6505804,9119.1183769,6.5464397,526.7372441,427.3051773,751.6230978,17.5478464,29.6235521,0.4182243,79.2205162),(39765,'scapula humerus',248,2,111,207.5143125,94.7388852,123.9227176,1.8,94.1977119,124.3479018,-0.4118626,9.1550836,18.4017683,3771.1548417,10321.0823069,5.5424846,560.874483,411.9192132,765.7348722,17.2525571,31.3701669,0.4084889,82.0503497),(39766,'scapula humerus',248,2,112,209.3353973,95.0964455,124.1245488,1.8,94.5373065,124.4764951,-0.3864757,9.1214331,19.2174008,3694.3615997,11723.6968773,4.9568361,610.0563236,405.019865,802.2796009,16.9395576,33.2890361,0.4116713,84.6284777),(39767,'scapula humerus',248,2,113,206.0154382,95.6401766,124.2001259,1.8,95.057076,124.5664876,-0.3569417,9.0857843,20.1932948,3614.7471446,13363.9713944,4.1919877,661.80242,397.846463,840.3429369,16.9088211,35.3547328,0.3601931,88.378761),(39768,'scapula humerus',248,2,114,207.1023039,96.2221176,124.297744,1.8,95.6376553,124.5913642,-0.3333789,9.2064274,20.9869255,3564.2195766,15315.2346161,3.696242,729.7512255,387.1447,898.5075601,16.8570118,37.3729768,0.3399304,92.1722302),(39769,'scapula humerus',248,2,115,209.9280653,96.8949286,124.3000462,1.8,96.2801628,124.5831767,-0.3055761,9.2430328,21.777569,3557.942406,17628.0055386,3.1666342,809.4569947,384.9323555,972.7756122,16.8570118,39.1417231,0.3009202,97.5801916),(39770,'scapula humerus',248,2,116,211.1677278,97.6022909,124.2999795,1.8,96.8970493,124.6270308,-0.273655,9.4548824,22.3389902,3619.2018906,20334.5241001,2.5704838,910.2705148,382.7865575,1072.2600307,16.8839662,40.5503466,0.2681108,103.3009324),(39771,'scapula humerus',248,2,117,219.3407052,98.5842059,124.340719,1.8,97.8119994,124.6863516,-0.2202107,9.2272347,23.1704004,3840.3083212,23021.6211801,1.7442688,993.5789117,416.1927639,1159.1708527,16.8083291,41.9006393,0.2275675,110.844685),(39772,'scapula humerus',248,2,118,219.2042455,99.4088724,124.6939605,1.8,98.7022912,124.9413402,-0.1424336,8.7709545,23.776562,3901.5541035,26337.9670811,0.7361789,1107.7281505,444.8266289,1269.9817697,16.6014682,43.315449,0.1896136,123.1887283),(39773,'scapula humerus',248,2,119,218.5437113,100.1786222,125.1709539,1.8,99.4440146,125.3610359,-0.0606403,7.8331016,24.3319254,3532.4367347,31284.5848937,0.1337759,1285.7422659,450.9627121,1422.2189872,15.468768,44.8566284,0.1635739,119.039294),(39774,'scapula humerus',248,2,120,216.2000627,100.2480936,125.3102246,1.8,99.9530609,125.4760702,-0.025368,7.7410265,24.7063011,3310.2445215,34717.2339984,0.0231838,1405.1975568,427.6234563,1528.1758407,15.468768,46.4261927,0.1392793,116.9645768),(39775,'scapula humerus',248,2,121,216.0703169,100.1056079,125.2692919,1.8,100.332075,125.400321,0.0042772,7.5292475,24.8999371,3286.5739182,38013.6707116,0.0006589,1526.6572974,436.5076222,1650.6478759,15.0417052,47.7263265,0.0360204,116.9035028),(39776,'scapula humerus',248,2,122,223.6396603,100.1277639,125.1009334,1.8,100.6501732,125.2688422,0.0259821,7.8096471,24.9032265,3294.1171581,42055.1864462,0.0251564,1688.7444851,421.8010236,1809.6989858,15.1671198,49.2119398,0.0961934,119.5858906),(39777,'scapula humerus',248,2,123,225.6326204,100.1660678,124.7409762,1.8,100.8494642,124.9701762,0.0359231,8.3170069,24.9438464,3110.0112271,44144.4562771,0.0485078,1769.7533704,373.9339499,1888.5872817,15.7788196,49.9344786,0.0602717,121.5131622),(39778,'scapula humerus',248,2,124,214.3871465,99.2928241,124.1708169,1.8,100.3382864,124.3770094,0.0303863,8.9627684,24.9019025,2829.1996166,40243.1840733,0.0329814,1616.0686552,315.6613549,1729.664991,16.9509728,49.4813298,0.0521266,124.4651435),(39779,'scapula humerus',248,2,125,213.3203105,98.3949524,123.292647,1.8,99.1808533,123.3609678,0.0415016,9.2066733,24.5828424,3034.2898357,37361.2828016,0.0612013,1519.8113432,329.5750535,1639.8274079,17.8819781,48.6762735,3.0709141,123.4583219),(39780,'scapula humerus',248,2,126,250.5904727,95.7978337,121.5165724,1.8,96.4747693,121.725389,0.1346829,10.155076,24.8235018,4728.9324174,39804.042218,0.7530272,1603.4821573,465.6717886,1784.5487686,19.6587788,46.7945817,3.0126819,122.8074655),(39781,'scapula humerus',248,2,127,276.2950207,94.9143523,120.2535253,1.8,95.2456683,121.0225124,0.1560352,10.992025,23.620504,5784.306652,36911.1346193,1.1120893,1562.6734541,526.2275742,1789.9583288,20.110387,44.7474203,2.9385474,119.7080385),(39782,'scapula humerus',248,2,128,287.6785768,94.5137382,120.1984273,1.8,94.2648838,120.6007746,0.1954239,10.7916198,20.0920649,5423.4650161,34170.9395369,1.8079058,1700.7181512,502.5626469,1917.7530474,19.7586905,40.5753812,2.7158416,113.422813),(39783,'scapula humerus',248,2,129,202.1725235,93.7133918,119.9823684,1.8,93.3494361,120.2048555,0.1850136,10.3602562,19.4460392,3090.9548637,22241.1727948,1.1402945,1143.7379385,298.3473392,1269.3121316,18.8766552,38.6552063,2.717725,109.3344526),(39784,'scapula humerus',248,2,130,86.1414104,89.5557096,119.3528401,1.8,90.0586985,119.8470031,0.2089784,9.3447865,22.083759,1065.0434344,5580.5973931,0.61792,252.7014256,113.9719388,298.8456248,15.9596686,19.1873855,2.5473789,57.3801511),(39785,'scapula humerus',248,2,131,28.1312249,87.3253391,119.7742988,1.8,86.7786314,119.787701,0.7545181,5.4314414,7.3423306,149.0506497,262.6857953,2.1995782,35.7768954,27.4421903,54.559527,10.9380707,13.7567282,2.4668517,40.3832625),(39786,'scapula humerus',248,2,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39787,'scapula humerus',248,2,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39788,'scapula humerus',248,2,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39789,'scapula humerus',248,2,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39790,'scapula humerus',248,2,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39791,'scapula humerus',248,2,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39792,'scapula humerus',248,2,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39793,'scapula humerus',248,2,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39794,'scapula humerus',248,2,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39795,'scapula humerus',248,2,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39796,'scapula humerus',248,2,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39797,'scapula humerus',248,2,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39798,'scapula humerus',248,2,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39799,'radius ulna',248,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39800,'radius ulna',248,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39801,'radius ulna',248,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39802,'radius ulna',248,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39803,'radius ulna',248,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39804,'radius ulna',248,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39805,'radius ulna',248,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39806,'radius ulna',248,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39807,'radius ulna',248,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39808,'radius ulna',248,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39809,'radius ulna',248,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39810,'radius ulna',248,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39811,'radius ulna',248,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39812,'radius ulna',248,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39813,'radius ulna',248,3,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39814,'radius ulna',248,3,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39815,'radius ulna',248,3,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39816,'radius ulna',248,3,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39817,'radius ulna',248,3,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39818,'radius ulna',248,3,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39819,'radius ulna',248,3,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39820,'radius ulna',248,3,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39821,'radius ulna',248,3,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39822,'radius ulna',248,3,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39823,'radius ulna',248,3,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39824,'radius ulna',248,3,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39825,'radius ulna',248,3,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39826,'radius ulna',248,3,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39827,'radius ulna',248,3,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39828,'radius ulna',248,3,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39829,'radius ulna',248,3,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39830,'radius ulna',248,3,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39831,'radius ulna',248,3,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39832,'radius ulna',248,3,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39833,'radius ulna',248,3,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39834,'radius ulna',248,3,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39835,'radius ulna',248,3,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39836,'radius ulna',248,3,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39837,'radius ulna',248,3,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39838,'radius ulna',248,3,40,5.7634208,81.0325529,118.0341073,1.8,80.7446633,118.1222792,1.4757285,4.9885688,7.1053962,18.3768398,79.7022708,0.9519147,11.2171466,3.68379,12.1971247,6.3479377,12.4015431,1.3258177,34.8099673),(39839,'radius ulna',248,3,41,47.8975114,79.039051,118.377217,1.8,77.9725521,117.9355774,1.5568195,9.4016748,8.4239858,574.8543646,900.5777016,7.9813592,106.9063655,61.1438257,150.0336142,15.1845221,16.9495441,2.1025204,81.0614162),(39840,'radius ulna',248,3,42,80.3332304,77.1294762,117.8962795,1.8,77.2464547,117.597775,0.8728231,7.9146563,8.3186943,1124.3024459,1312.5781118,7.8590021,157.7865547,142.0532251,290.9465012,15.4956002,17.18752,2.2142974,52.6230461),(39841,'radius ulna',248,3,43,83.3850258,77.1547032,117.743462,1.8,77.3373172,117.5168143,0.9168533,7.8053848,8.2239511,1093.361837,1317.7451603,8.7546772,160.2326112,140.0778902,292.4387901,15.3751571,17.0418833,2.1587989,52.0153755),(39842,'radius ulna',248,3,44,76.963085,77.4015727,117.6494489,1.8,77.5150338,117.3844589,1.0380273,7.6415611,8.0606824,1018.4678402,1180.8961894,9.5179823,146.5007709,133.2800749,270.9015707,15.03908,16.5806127,2.1156602,50.5483289),(39843,'radius ulna',248,3,45,74.2920786,77.5764975,117.587258,1.8,77.7608773,117.321837,1.1670378,7.6272321,7.855027,1001.9253037,1102.2103658,10.4708161,140.3191053,131.3615852,261.6668334,15.03908,16.0429641,1.7051178,50.2966235),(39844,'radius ulna',248,3,46,71.2325622,77.784448,117.5595837,1.8,78.0077414,117.2326898,1.4433389,7.5947069,7.9257261,990.5708449,1045.6296316,11.6802688,131.9285598,130.4291084,253.4456708,14.609392,15.9910916,1.4631065,49.6889529),(39845,'radius ulna',248,3,47,72.3603826,78.0431616,117.5135723,1.8,78.3104128,117.1656483,-1.0504812,7.3206547,8.0940525,1009.2171678,1070.8682711,9.0792784,132.3031049,137.8588675,255.1009021,14.8879296,16.0429641,1.2151604,49.4372475),(39846,'radius ulna',248,3,48,73.8476755,78.2203038,117.4588601,1.8,78.5672822,117.1547029,-0.778817,7.1156968,8.0035836,1013.5037536,1154.9167269,6.0729745,144.2999509,142.4321166,260.005503,14.5840943,16.1975849,1.1902899,49.7932127),(39847,'radius ulna',248,3,49,76.5834149,78.5844187,117.2778886,1.8,79.0051234,116.9710643,-0.699983,6.9368197,8.5997879,1009.2525482,1331.5750614,5.2970157,154.8381276,145.492111,269.7195787,13.9764237,16.7357822,1.0612041,49.7932127),(39848,'radius ulna',248,3,50,77.2062395,78.8296214,117.2612044,1.8,79.331201,116.979643,-0.6493554,6.7892382,9.0950273,1011.3943167,1465.8597277,4.7048148,161.1715589,148.9702216,271.9869298,13.9764237,17.2839294,0.6086893,50.6525887),(39849,'radius ulna',248,3,51,78.9339453,79.1518726,117.3034745,1.8,79.7031493,116.9717844,-0.6047384,6.7344262,9.5994671,1029.5962948,1646.5921291,4.2525083,171.5295354,152.8855263,276.6361825,13.6725884,18.0520106,0.6673061,52.2238951),(39850,'radius ulna',248,3,52,82.6688783,79.5015765,117.3230625,1.8,79.9862805,117.0274763,-0.5634153,6.7702317,9.6198297,1076.2493073,1879.6645667,3.9300506,195.3947866,158.9678691,303.1941476,13.9764237,18.5563538,0.7362574,53.3349765),(39851,'radius ulna',248,3,53,84.2748391,79.7472629,117.4216093,1.8,80.2612774,117.0590097,-0.5461863,6.9024825,9.6558246,1122.1707508,2019.9041816,3.7896958,209.1902312,162.5749509,315.9450438,14.2215294,18.8769524,0.7209713,54.9062828),(39852,'radius ulna',248,3,54,86.6150189,79.9387597,117.4922012,1.8,80.5401423,117.0837224,-0.5594618,6.9102616,9.8330988,1199.3854526,2183.305234,4.0662059,222.0363372,173.5658542,332.4642761,14.1543227,19.1873855,0.9765826,56.2258838),(39853,'radius ulna',248,3,55,88.8548821,80.06816,117.6031081,1.8,80.7038593,117.1639427,-0.5710492,6.9643752,10.0554901,1269.9971325,2309.1573531,4.3265894,229.6414524,182.3562196,343.3577809,14.4031083,19.5449008,0.9888912,57.0852598),(39854,'radius ulna',248,3,56,89.8541876,80.1117974,117.741044,1.8,80.6820985,117.385273,-0.5734727,7.1095678,9.8830791,1319.0638072,2368.6562464,4.4082935,239.6678415,185.5336151,350.5624342,14.5348501,19.7843213,0.9707461,57.5886706),(39855,'radius ulna',248,3,57,91.5758509,80.0749957,117.9312611,1.8,80.6975396,117.589759,-0.5823291,7.1455888,9.9759807,1367.0162266,2426.2459384,4.6164564,243.2087648,191.3091098,354.4507159,14.6141264,19.9052705,1.0007559,58.1963412),(39856,'radius ulna',248,3,58,94.3608255,80.1195962,118.1514119,1.8,80.7482618,117.79117,-0.568334,7.0856528,10.0454127,1391.7011256,2533.687568,4.5559004,252.2233423,196.4111375,365.9788944,14.5172092,20.0300987,0.9530406,58.1963412),(39857,'radius ulna',248,3,59,94.4321605,80.1093156,118.3982052,1.8,80.7462438,118.032285,-0.5710194,7.1647106,10.2950188,1381.0121025,2564.5962723,4.5977356,249.1104016,192.7519717,364.6288287,14.6049811,20.1999066,0.9060218,57.840376),(39858,'radius ulna',248,3,60,94.7119056,79.9896586,118.6819859,1.8,80.629854,118.3204865,-0.5639294,7.1872916,10.2976421,1358.0448679,2510.9434464,4.5099021,243.8367366,188.9508525,359.1509874,14.4143461,20.0300987,0.9530406,57.2327054),(39859,'radius ulna',248,3,61,97.3209205,79.8639008,118.9571584,1.8,80.3968863,118.6504259,-0.560137,7.2489946,10.3116109,1346.3923029,2488.3240374,4.5786594,241.3128325,185.7350392,357.5741975,14.4461769,19.9377084,0.9229849,56.2690697),(39860,'radius ulna',248,3,62,99.4780351,79.697828,119.2794535,1.8,80.0509582,119.0809515,-0.5121798,7.1347634,10.1281615,1320.89186,2388.9233694,3.9820554,235.8693993,185.1346411,357.7062536,14.4044282,19.5307258,0.8788749,55.3054339),(39861,'radius ulna',248,3,63,97.2999955,79.3994926,119.7308581,1.8,79.5995898,119.623433,-0.456235,7.116004,9.6170184,1273.6956342,2083.4081586,3.1477049,216.6376381,178.9902911,347.7093389,14.280259,18.3210418,0.6857295,51.9111157),(39862,'radius ulna',248,3,64,96.1490682,79.0853302,120.1055636,1.8,79.2292248,120.0566059,-0.4232446,7.0701726,9.1027195,1256.2396105,1842.4606849,2.7032578,202.407719,177.6816032,340.110544,14.3833325,17.4487192,0.663203,50.6957745),(39863,'radius ulna',248,3,65,94.6947852,78.7467816,120.4271271,1.8,78.8684617,120.409946,-0.4036868,7.0323976,8.460802,1225.2808708,1622.3533577,2.4352478,191.7493581,174.2337303,335.4669293,14.179704,16.5861794,0.6383198,49.2287279),(39864,'radius ulna',248,3,66,94.9613263,78.5559933,120.6613237,1.8,78.6577218,120.6211589,-0.4279192,7.1850271,8.1432124,1219.5048801,1519.6958029,2.7255037,186.621168,169.7286412,334.0191803,14.2681416,16.1290475,0.7288547,48.7253171),(39865,'radius ulna',248,3,67,93.8462623,78.3480531,120.8758022,1.8,78.4327822,120.8855573,-0.4777651,7.1212672,7.8160472,1201.3085761,1426.1811227,3.3067055,182.4683345,168.6930909,331.5372389,14.179704,15.7350314,0.610726,47.5099759),(39866,'radius ulna',248,3,68,93.2219272,78.1413927,121.0820357,1.8,78.193931,121.0796821,-0.5742279,7.169644,7.5152064,1184.0601347,1346.6274304,4.5842155,179.1870198,165.1490828,330.8643486,14.179704,15.3849907,0.6267429,46.9023053),(39867,'radius ulna',248,3,69,91.6352688,77.952121,121.2793754,1.8,78.0373898,121.3138548,-0.722778,7.1921792,7.328913,1144.1460709,1284.2195855,6.6824008,175.2264744,159.0819759,318.7925557,14.179704,15.240301,0.7055682,47.2582705),(39868,'radius ulna',248,3,70,90.9327729,77.7483021,121.4572045,1.8,77.7730001,121.4897951,-0.8984314,6.9366928,7.4799326,1107.1804011,1239.2169842,9.2762483,165.6722134,159.6121418,307.6483131,13.9764237,15.0881073,1.2220253,46.3988945),(39869,'radius ulna',248,3,71,89.8895474,77.5543199,121.6036063,1.8,77.5710067,121.6354575,-1.0263933,6.7397677,7.5462859,1061.9337163,1204.9347732,10.9631067,159.6725571,157.562362,298.6939016,13.6725884,15.1125613,1.3120254,45.8954837),(39870,'radius ulna',248,3,72,89.6950126,77.3684775,121.7460879,1.8,77.4324632,121.7746534,-1.0954073,6.811329,7.5688651,1022.4250215,1187.5189731,11.8176919,156.895248,150.1065382,290.0687135,13.6725884,15.1125613,1.3120254,45.8954837),(39871,'radius ulna',248,3,73,89.0811399,77.1956366,121.8617272,1.8,77.269927,121.9017685,-1.1161682,6.7617054,7.5848425,985.0679684,1164.0055727,11.9838841,153.4646983,145.6833618,282.6632382,13.320328,15.1125613,1.3120254,45.5395185),(39872,'radius ulna',248,3,74,86.9292286,76.9822625,122.0195668,1.8,77.0491,122.0415554,-1.1002439,6.6635397,7.5329179,942.1499839,1103.1739417,11.5101217,146.4470956,141.3888151,271.1720432,13.0649178,15.0881073,1.2220253,44.7844023),(39873,'radius ulna',248,3,75,88.128384,76.8379037,122.0576274,1.8,76.916387,122.0844744,-1.0987051,6.5860185,7.6281789,909.8994957,1106.863805,11.650611,145.1019715,138.1562323,264.3501351,13.0649178,15.0881073,1.2220253,44.6801425),(39874,'radius ulna',248,3,76,88.419207,76.7048186,122.0950779,1.8,76.7748699,122.1295097,-1.1043181,6.4974806,7.5381536,877.2601145,1098.6310462,11.7557856,145.7427246,135.0154262,260.7240948,12.89064,15.0083566,1.1583859,44.3241773),(39875,'radius ulna',248,3,77,87.9743564,76.5631675,122.1633154,1.8,76.5832693,122.2123435,-1.1039445,6.4025966,7.6040696,852.4864682,1085.3115335,11.6922395,142.7277223,133.1469904,254.8126582,12.7610825,15.0083566,1.1583859,44.1767317),(39876,'radius ulna',248,3,78,87.7182217,76.4121031,122.2460716,1.8,76.3964417,122.3093573,-1.1095848,6.3148114,7.4620182,830.960298,1087.7089842,11.7242029,145.7660584,131.5890915,254.878569,12.7610825,15.0881073,1.2220253,44.1767317),(39877,'radius ulna',248,3,79,87.253621,76.2611895,122.3247934,1.8,76.2722507,122.3844962,-1.1083862,6.4112407,7.5159808,814.671731,1080.8160449,11.6481991,143.8023961,127.0692784,251.9586922,12.7574788,15.1125613,1.3120254,44.1767317),(39878,'radius ulna',248,3,80,86.7522618,76.1154757,122.3995279,1.8,76.0945949,122.4860411,-1.1019649,6.3109486,7.5795552,797.2803785,1064.8167403,11.5067748,140.4853856,126.3328901,244.9964121,12.68445,15.0083566,1.1583859,44.1767317),(39879,'radius ulna',248,3,81,86.2974522,75.936257,122.4088994,1.8,75.9157069,122.5074364,-1.1014176,6.2772959,7.4904383,776.2314154,1041.9913634,11.440101,139.109531,123.6569738,242.3864822,12.4572472,15.0083566,1.1583859,43.9250263),(39880,'radius ulna',248,3,82,86.2906824,75.7890967,122.4797824,1.8,75.7856966,122.5833343,-1.1068779,6.1863657,7.5511471,762.7610353,1038.3714996,11.5023074,137.5117558,123.2971139,237.4190095,12.4572472,15.0083566,1.1583859,43.2130959),(39881,'radius ulna',248,3,83,86.2486087,75.6461312,122.5289375,1.8,75.6371749,122.6526568,-1.1253934,6.3060993,7.4479232,752.4272907,1030.6245919,11.7067077,138.3774458,119.3173862,238.7174907,12.4572472,15.0881073,1.2220253,43.3173557),(39882,'radius ulna',248,3,84,86.3818233,75.5218613,122.565942,1.8,75.4919452,122.6613993,-1.149469,6.2437814,7.5010524,744.2146714,1028.8298088,11.9889597,137.1580617,119.192941,233.2385259,12.2999075,15.0083566,1.1583859,43.4648013),(39883,'radius ulna',248,3,85,86.1649649,75.4010245,122.5925285,1.8,75.3557765,122.6856071,-1.1728571,6.3041583,7.3988108,734.6535949,1022.7993684,12.2042433,138.238347,116.5347638,233.9057726,12.365469,15.0083566,1.1583859,43.2130959),(39884,'radius ulna',248,3,86,86.3915585,75.2805761,122.6244537,1.8,75.2524117,122.7011292,-1.1857748,6.2418387,7.3819411,727.7526879,1026.3341348,12.3675326,139.0330978,116.5926784,231.5198839,12.2999075,15.0881073,1.2220253,43.4648013),(39885,'radius ulna',248,3,87,86.4376045,75.1593951,122.6645054,1.8,75.1429696,122.7527616,-1.1970266,6.3439953,7.4529409,718.8182419,1029.2788313,12.4856516,138.103716,113.3068694,231.3052516,12.2999075,15.240301,1.1955255,43.2130959),(39886,'radius ulna',248,3,88,86.04087,75.0575257,122.6845591,1.8,75.0375062,122.7732516,-1.2076404,6.2833371,7.3898335,710.8304743,1025.5186314,12.5306257,138.7742548,113.1294509,232.0115278,12.2975897,15.0881073,1.2220253,43.2130959),(39887,'radius ulna',248,3,89,85.7670555,74.9524681,122.7108395,1.8,74.9365009,122.8310221,-1.2113582,6.275379,7.4766868,702.873392,1024.4609333,12.5258944,137.0207093,112.0049308,225.8619921,12.2306697,15.240301,1.1955255,43.2130959),(39888,'radius ulna',248,3,90,85.3786014,74.8556293,122.7092614,1.8,74.7935509,122.781833,-1.2263703,6.2193286,7.4286858,694.427153,1024.921098,12.6074046,137.9680245,111.6562889,226.4486734,12.031264,15.240301,1.1955255,43.2130959),(39889,'radius ulna',248,3,91,85.1617989,74.7674696,122.7028816,1.8,74.7317254,122.7596767,-1.2426795,6.3074746,7.4202756,689.1067115,1025.7244943,12.7195948,138.2326678,109.2523957,225.7820535,12.031264,15.3549594,1.2578951,43.2130959),(39890,'radius ulna',248,3,92,85.0797217,74.677016,122.6980016,1.8,74.667115,122.755045,-1.2539413,6.262163,7.461596,683.913965,1027.0422613,12.8033367,137.6437774,109.2136962,225.096912,12.031264,15.3549594,1.2578951,43.2130959),(39891,'radius ulna',248,3,93,84.7306558,74.5846636,122.691442,1.8,74.5584866,122.7505861,-1.2650174,6.2279409,7.4987327,679.969425,1022.6901938,12.8420222,136.3817374,109.1804558,223.8412839,12.0958704,15.3549594,1.2578951,43.5690611),(39892,'radius ulna',248,3,94,84.417565,74.4971242,122.6908842,1.8,74.4321865,122.7739123,-1.2723335,6.2862285,7.5330764,676.422095,1021.6164709,12.8530503,135.6174308,107.6038028,221.9966978,12.031264,15.4029813,1.1695675,43.4648013),(39893,'radius ulna',248,3,95,84.1718929,74.410795,122.7037743,1.8,74.3533103,122.7913718,-1.275488,6.2383341,7.5740839,672.5333087,1017.8046604,12.8404045,134.3799031,107.8065555,221.1196467,12.031264,15.4029813,1.1695675,43.2130959),(39894,'radius ulna',248,3,96,84.0761641,74.3315448,122.7006897,1.8,74.2873219,122.7514431,-1.2811252,6.1917984,7.5994778,671.1149202,1016.6880419,12.8694192,133.7839351,108.387721,220.5010828,12.031264,15.4029813,1.1695675,43.2130959),(39895,'radius ulna',248,3,97,83.2903601,74.2257369,122.6190579,1.8,74.1915599,122.7104966,-1.3001335,6.1359294,7.5651317,661.2086254,1011.599392,12.8893665,133.7186751,107.760142,220.3168088,11.9857368,15.3549594,1.2578951,43.2130959),(39896,'radius ulna',248,3,98,82.8742112,74.1452616,122.5943927,1.8,74.0794477,122.6824157,-1.312814,6.099656,7.5694089,654.8746063,1014.8802702,12.9133022,134.0765554,107.3625478,220.1742201,11.9389002,15.3549594,1.2578951,43.2130959),(39897,'radius ulna',248,3,99,82.4986254,74.0730015,122.5776877,1.8,74.0257622,122.6746928,-1.3214467,6.1694791,7.5748002,648.3335515,1012.0363451,12.9124469,133.6056826,105.0872429,218.9921946,12.0098192,15.3549594,1.2578951,43.2130959),(39898,'radius ulna',248,3,100,82.3244002,73.9993465,122.5744436,1.8,73.9415766,122.663868,-1.3298606,6.1346113,7.5917104,642.5459098,1004.4993922,12.9395379,132.3152934,104.7410956,216.8843139,11.9595284,15.3549594,1.2578951,43.2130959),(39899,'radius ulna',248,3,101,81.8500084,73.9243557,122.5716639,1.8,73.8617574,122.6561113,-1.3387607,6.1078802,7.5088408,635.9971437,993.6731551,12.9202803,132.3337628,104.127311,216.6128075,11.9595284,15.2281815,1.2847449,43.2130959),(39900,'radius ulna',248,3,102,81.5139226,73.8595164,122.5551123,1.8,73.771825,122.642919,-1.3503207,5.9457005,7.5117807,631.7969005,988.6055637,12.9358931,131.6073509,106.2611378,215.5259991,11.601576,15.2281815,1.2847449,42.6054253),(39901,'radius ulna',248,3,103,81.5452541,73.8072027,122.5383234,1.8,73.7573113,122.6374259,-1.3588673,5.9935532,7.5087851,630.2368171,994.201614,12.9895403,132.4051237,105.1524524,216.2650033,11.601576,15.2281815,1.2847449,42.6054253),(39902,'radius ulna',248,3,104,81.4076195,73.7504306,122.514097,1.8,73.7194341,122.6113466,-1.3714721,5.9579914,7.4981488,627.8349849,997.1714332,13.0359817,132.9890161,105.3769533,216.7178504,11.601576,15.2281815,1.2847449,42.6054253),(39903,'radius ulna',248,3,105,81.3354452,73.6982964,122.496631,1.8,73.6684508,122.6030639,-1.3872145,6.0038946,7.4902023,627.3697558,999.3347689,13.1041518,133.4189293,104.4937991,217.1439495,11.601576,15.2281815,1.2847449,42.8571307),(39904,'radius ulna',248,3,106,81.1737526,73.6464661,122.4756162,1.8,73.6188334,122.5506505,-1.4012464,5.9770519,7.4756456,626.4404305,999.1297236,13.1437518,133.6512967,104.8075947,217.2834652,11.601576,15.1125613,1.3120254,42.6054253),(39905,'radius ulna',248,3,107,81.3744976,73.6003684,122.4608005,1.8,73.5879565,122.5456496,-1.4168915,6.019923,7.3967232,626.9860719,1004.3436868,13.2436957,135.7822456,104.1518419,220.5455878,11.601576,15.1125613,1.3120254,42.6054253),(39906,'radius ulna',248,3,108,81.7058278,73.5531091,122.4287922,1.8,73.5153699,122.4954301,-1.4320009,5.8176519,7.676897,625.1805503,1011.2900314,13.3569856,131.7316134,107.4626953,212.2477169,11.601576,15.3369125,1.3734008,42.9613905),(39907,'radius ulna',248,3,109,82.1619802,73.5092925,122.4030015,1.8,73.4572306,122.4498054,-1.4496071,5.7793214,7.6680038,627.4375999,1018.6870127,13.4935295,132.8490488,108.5659642,214.1560278,11.601576,15.3369125,1.3734008,42.9613905),(39908,'radius ulna',248,3,110,82.2984958,73.465512,122.3772366,1.8,73.4328661,122.4022872,-1.4679657,5.7966566,7.6553776,629.0021175,1020.2334692,13.5718873,133.2701685,108.5111915,215.2141521,11.601576,15.2584623,1.4010181,42.9613905),(39909,'radius ulna',248,3,111,82.2525057,73.4208947,122.3437262,1.8,73.4038833,122.3939609,-1.4845127,5.8159678,7.6305276,629.4368798,1020.445141,13.6069442,133.7319253,108.2256472,216.1658205,11.601576,15.2584623,1.4010181,42.9613905),(39910,'radius ulna',248,3,112,82.1360198,73.3853232,122.3078035,1.8,73.3681283,122.3732606,-1.5025275,5.7917461,7.5989893,630.5081196,1017.020807,13.6256348,133.8363258,108.863219,216.8089417,11.601576,15.1917649,1.4288993,42.7096851),(39911,'radius ulna',248,3,113,81.4042625,73.3171991,122.1800902,1.8,73.2873581,122.2194199,-1.526462,5.8093319,7.4721809,627.3697182,1004.599131,13.5407275,134.4452365,107.993437,217.9973632,11.601576,15.0083566,1.3397057,42.3537199),(39912,'radius ulna',248,3,114,81.2946584,73.283708,122.1540826,1.8,73.2624359,122.1862061,-1.5405138,5.8245599,7.4428332,627.9670927,1005.9978243,13.5366886,135.1632902,107.8136553,219.1116466,11.601576,15.0083566,1.3397057,42.3537199),(39913,'radius ulna',248,3,115,80.9547681,73.2606723,122.129148,1.8,73.2472276,122.1594111,-1.5566863,5.818151,7.4108251,625.3189585,1004.1580762,13.4897753,135.4988224,107.4772658,219.2940637,11.601576,15.0083566,1.3397057,42.1020145),(39914,'radius ulna',248,3,116,80.8207142,73.2437436,122.099041,1.8,73.2245222,122.1097469,1.5662847,5.8190943,7.3770349,623.9595875,1006.7757778,13.4698448,136.4743135,107.2262368,218.9608002,11.601576,15.0083566,1.3397057,42.3537199),(39915,'radius ulna',248,3,117,80.051583,73.2260301,122.0674964,1.8,73.1746026,122.0895263,1.5468767,5.8254788,7.3635373,618.6062615,1001.5156938,13.3342984,136.0101337,106.1897713,218.5253101,11.601576,15.0083566,1.3397057,42.3537199),(39916,'radius ulna',248,3,118,79.8360114,73.2056005,122.0452805,1.8,73.1518395,122.0841496,1.5292677,5.4945577,7.3545392,616.7286265,1002.3603696,13.2830672,136.2913903,112.2435444,219.1200956,11.171888,15.0083566,1.3397057,41.9977547),(39917,'radius ulna',248,3,119,79.4026303,73.1864688,122.0192946,1.8,73.1486273,122.0518533,1.5151181,5.5329696,7.360797,615.8387674,1000.3088636,13.1927885,135.8968136,111.3034787,217.4812208,11.171888,14.9158068,1.3677511,41.9977547),(39918,'radius ulna',248,3,120,79.5116749,73.1765344,121.9811756,1.8,73.1472417,122.023141,1.5006132,5.5599438,7.3361031,617.4279088,1002.5666985,13.1867782,136.6620236,111.0493069,219.1584319,11.171888,14.9158068,1.3677511,41.9977547),(39919,'radius ulna',248,3,121,79.4558378,73.169439,121.9465637,1.8,73.1349226,121.9744378,1.4844663,5.5839999,7.3146873,619.4432856,1006.7954338,13.1441889,137.640257,110.9318222,221.0597334,11.171888,14.9158068,1.3677511,41.9977547),(39920,'radius ulna',248,3,122,79.7027408,73.1601132,121.939154,1.8,73.1328976,121.9606199,1.4732138,5.605222,7.3147603,622.7521159,1013.0562402,13.1576983,138.4947972,111.1021314,222.6346715,11.171888,14.9158068,1.3677511,41.9977547),(39921,'radius ulna',248,3,123,80.0491772,73.1472715,121.9258464,1.8,73.1205669,121.9552687,1.4608012,5.629568,7.3081599,626.2521026,1019.6566142,13.1807612,139.5230303,111.2433667,224.4831066,11.171888,14.9158068,1.3677511,41.9977547),(39922,'radius ulna',248,3,124,80.1676772,73.1319452,121.9126689,1.8,73.1079845,121.9496066,1.4498453,5.6538243,7.351107,629.4563246,1025.0811315,13.1667665,139.4458188,111.3328407,223.3178121,11.171888,14.9158068,1.7738415,41.9977547),(39923,'radius ulna',248,3,125,81.0545252,73.1146396,121.9066772,1.8,73.0960313,121.9187798,1.4434889,5.6759921,7.3486883,635.7555454,1038.9306151,13.2913235,141.3763341,112.0078272,226.3431097,11.171888,14.8351299,1.7454685,42.2494601),(39924,'radius ulna',248,3,126,81.7244028,73.1026452,121.8971203,1.8,73.0883002,121.8885802,1.4341585,5.6945413,7.3452944,639.9841241,1049.5978462,13.3680148,142.8939115,112.3855452,228.7324108,11.171888,14.8351299,1.7454685,42.2494601),(39925,'radius ulna',248,3,127,82.4276261,73.0934933,121.8811453,1.8,73.0770695,121.8695533,1.4285826,5.7058003,7.3324252,644.8677512,1064.7890432,13.4619594,145.2164899,113.019685,232.00616,11.171888,14.8351299,1.7454685,42.2494601),(39926,'radius ulna',248,3,128,82.8334803,73.0756703,121.8808387,1.8,73.0644728,121.8825336,1.4235953,5.7271426,7.3330743,649.2304573,1077.2992974,13.5085931,146.9096384,113.3602741,234.4405424,11.171888,14.8351299,1.7454685,42.2494601),(39927,'radius ulna',248,3,129,82.523243,73.0710585,121.8194921,1.8,73.0630347,121.7816165,1.419034,5.7257252,7.5695861,647.4638589,1086.2213558,13.4395218,143.4981178,113.0797996,228.8939313,11.171888,15.1917649,1.4288993,42.8571307),(39928,'radius ulna',248,3,130,82.4593492,73.0591824,121.8006279,1.8,73.0580726,121.7492549,1.4154524,5.7368262,7.614599,647.9763989,1095.4887965,13.4142362,143.8669053,112.9503272,228.9328181,11.171888,15.1917649,1.7126934,42.8571307),(39929,'radius ulna',248,3,131,82.7467593,73.0518758,121.7628807,1.8,73.0549513,121.7197299,1.4086136,5.7419636,7.5768418,649.8135924,1107.8673762,13.4315447,146.2175675,113.1692284,231.9703695,11.171888,15.1917649,1.7126934,43.1088361),(39930,'radius ulna',248,3,132,83.006139,73.0475274,121.7270567,1.8,73.062328,121.6766996,1.4026064,5.7433342,7.6130169,652.8267348,1119.6707066,13.4466886,147.0731925,113.6668554,232.4165945,11.171888,15.2584623,1.7405746,43.1088361),(39931,'radius ulna',248,3,133,82.8321376,73.0560144,121.6944372,1.8,73.0683832,121.6586285,1.3966326,5.8064238,7.5849216,653.6183479,1123.6892108,13.3908152,148.1477681,112.5681445,233.9630678,11.171888,15.2584623,1.7405746,43.1088361),(39932,'radius ulna',248,3,134,82.7600193,73.0648807,121.6725936,1.8,73.072486,121.6320921,1.3885552,5.8001609,7.6460642,656.0851053,1130.5294669,13.3402835,147.8576999,113.1149845,232.4155196,11.171888,15.3369125,1.7681919,43.1088361),(39933,'radius ulna',248,3,135,83.031428,73.0736011,121.6479896,1.8,73.0681717,121.6065524,1.3804904,5.7928108,7.6297068,658.7597401,1142.6440161,13.3434101,149.7625064,113.7202238,234.9854369,11.171888,15.3369125,1.7681919,43.3605415),(39934,'radius ulna',248,3,136,83.4349323,73.0880318,121.6323453,1.8,73.0939007,121.5938805,1.3746803,5.7822739,7.6213759,664.6126671,1151.0183326,13.3778051,151.025005,114.9396714,237.1780949,11.601576,15.3369125,1.7681919,43.7165067),(39935,'radius ulna',248,3,137,83.8662434,73.0941043,121.6147608,1.8,73.1193726,121.5861443,1.3691641,5.7734163,7.6092094,672.0585831,1159.0212502,13.4170955,152.318223,116.4057029,239.6691152,11.601576,15.3369125,1.7681919,43.7165067),(39936,'radius ulna',248,3,138,83.9534119,73.1076072,121.5963783,1.8,73.1401091,121.5596366,1.3663636,5.845317,7.5958411,681.0170693,1165.1124673,13.4155629,153.3882103,116.5064388,242.0731994,11.601576,15.3369125,1.7681919,43.9682121),(39937,'radius ulna',248,3,139,84.48241,73.1258977,121.5776865,1.8,73.1646339,121.5321694,1.3634215,5.8930236,7.583287,692.7127257,1173.3355851,13.4835139,154.726517,117.5479306,245.0886154,11.8543756,15.3369125,1.7681919,44.3241773),(39938,'radius ulna',248,3,140,85.0085546,73.1418459,121.5586431,1.8,73.1732694,121.5149401,1.3602963,5.8708402,7.5700863,702.7968387,1182.2285354,13.5495184,156.1710774,119.7097547,248.0213777,11.7767143,15.3369125,1.7681919,44.3241773),(39939,'radius ulna',248,3,141,85.993705,73.1602385,121.5412819,1.8,73.1992024,121.4812033,1.3604792,5.9390913,7.6465296,717.3057658,1200.247845,13.7076123,156.96635,120.777022,248.1281741,11.8806652,15.4269362,1.7955075,44.3241773),(39940,'radius ulna',248,3,142,86.4178545,73.1892219,121.522363,1.8,73.2141583,121.4450286,1.3665944,5.9095199,7.626891,730.1519582,1211.1707536,13.8106958,158.8026833,123.5552085,251.4500595,11.8806652,15.4269362,1.7955075,44.5758827),(39941,'radius ulna',248,3,143,87.1787612,73.2148381,121.4944881,1.8,73.244337,121.4078204,1.3667004,5.9659209,7.7641592,742.7124308,1224.6878973,13.9329102,157.7360614,124.4925048,253.3653038,11.968333,15.6172526,1.7088024,44.9318479),(39942,'radius ulna',248,3,144,87.4449107,73.2307694,121.4733699,1.8,73.2447437,121.3802094,1.3595568,5.9455641,7.8358948,751.1602766,1229.2334488,13.9334377,156.872122,126.3396151,252.5886346,11.9857368,15.6172526,1.7088024,44.9318479),(39943,'radius ulna',248,3,145,86.9052265,73.2732774,121.3871213,1.8,73.2692124,121.2324231,1.3517282,5.9778385,7.8561635,755.2655097,1223.3933336,13.8001438,155.7240161,126.3442481,250.9120523,12.031264,15.6408793,1.849096,44.8275881),(39944,'radius ulna',248,3,146,86.6022066,73.3009846,121.3700815,1.8,73.2811286,121.218054,1.3408672,5.948906,7.8528501,759.9297131,1225.6375173,13.6839815,156.0755005,127.7427662,252.0387284,12.031264,15.6408793,1.849096,44.8275881),(39945,'radius ulna',248,3,147,85.9564429,73.3406769,121.3393791,1.8,73.2965666,121.1874027,1.3279497,6.007567,7.8400667,764.8675726,1225.2852857,13.4976797,156.285058,127.3173603,253.1669243,12.031264,15.5283322,1.8224863,44.8275881),(39946,'radius ulna',248,3,148,85.1701353,73.3895605,121.2946896,1.8,73.3493964,121.1543263,1.3096317,6.0670734,7.8187082,769.1674379,1223.1950724,13.2486364,156.444651,126.7773415,254.3234465,12.2917763,15.5283322,1.8224863,45.1835533),(39947,'radius ulna',248,3,149,84.1626613,73.4342752,121.2490344,1.8,73.4077841,121.1281935,1.2924959,6.0231423,7.794321,770.0484701,1213.0315908,12.9684549,155.6301815,127.8482944,254.0745411,12.225331,15.5283322,1.8224863,44.9318479),(39948,'radius ulna',248,3,150,83.6335514,73.4740483,121.2035176,1.8,73.4324321,121.0824504,1.2794828,6.1025975,7.890235,777.9680429,1206.2042715,12.7891035,152.8730481,127.4814598,250.2781154,12.310997,15.6408793,1.849096,45.1835533),(39949,'radius ulna',248,3,151,83.1702935,73.5165145,121.1538427,1.8,73.4670492,121.0381973,1.2585635,6.0643028,7.8704198,784.4198291,1201.1219036,12.5536941,152.6121778,129.3503738,251.391237,12.3893949,15.6408793,1.9359978,45.1835533),(39950,'radius ulna',248,3,152,82.4561601,73.563528,121.1071013,1.8,73.5004566,120.9872161,1.2315377,6.1649888,7.8570035,789.1000682,1192.9528382,12.2207188,151.8330533,127.9969993,251.7380732,12.460952,15.4926212,1.9100889,45.1835533),(39951,'radius ulna',248,3,153,82.614328,73.618645,121.0481174,1.8,73.5910455,120.957172,1.210922,6.2621218,7.8300308,800.7088972,1193.1352541,12.0614949,152.379382,127.8654297,254.276374,12.5066122,15.4926212,1.9100889,44.9318479),(39952,'radius ulna',248,3,154,82.3494653,73.6757194,120.99102,1.8,73.6182054,120.9351582,1.1911039,6.2101877,7.8049248,809.7278714,1191.6664131,11.8395175,152.6813446,130.3870208,256.1867114,12.6105631,15.4926212,1.9100889,44.9318479),(39953,'radius ulna',248,3,155,82.4388159,73.7306334,120.9435387,1.8,73.6422974,120.8963042,1.1682851,6.2216057,7.7884343,818.3725343,1192.5915283,11.6313958,153.1233975,131.5371895,257.1395559,12.7145141,15.4926212,1.9100889,45.1835533),(39954,'radius ulna',248,3,156,82.7765242,73.7891898,120.8950647,1.8,73.7113747,120.8445032,1.1439463,6.2866224,7.7718223,829.1037202,1190.470897,11.4314297,153.177832,131.8838118,259.8311471,12.774495,15.4926212,1.9100889,44.9318479),(39955,'radius ulna',248,3,157,83.1096447,73.8414298,120.8524485,1.8,73.7745062,120.7985901,1.1166833,6.2573808,7.7566309,843.4136786,1193.5750928,11.1861793,153.8780305,134.7870153,262.6101411,12.8207064,15.4029813,1.9720251,45.2878131),(39956,'radius ulna',248,3,158,83.0642701,73.9010118,120.8182989,1.8,73.8485674,120.7956951,1.0925084,6.2135472,7.7506642,854.5581658,1191.4535942,10.9113335,153.7227739,137.5314505,263.9279981,12.8761759,15.4029813,1.9720251,45.2878131),(39957,'radius ulna',248,3,159,83.1348777,73.9646542,120.7600695,1.8,73.8980302,120.7113196,1.0627731,6.3439383,7.7227956,864.1222698,1193.8950188,10.5770472,154.5936318,136.2122758,266.2870012,13.0456363,15.4029813,1.9720251,45.3920729),(39958,'radius ulna',248,3,160,83.054479,74.0008275,120.7051555,1.8,73.8947078,120.6443193,1.0337315,6.3086395,7.6821907,870.4939082,1195.2231348,10.2191447,155.5836326,137.9844116,266.7723242,13.0286083,15.3549594,1.8836976,45.3920729),(39959,'radius ulna',248,3,161,82.7342827,74.1031861,120.5852189,1.8,74.0337117,120.5384175,0.9873198,6.4196023,7.7235658,879.0337074,1191.9321817,9.6037629,154.3240792,136.9296215,267.9524684,13.0689926,15.3549594,1.8836976,45.8954837),(39960,'radius ulna',248,3,162,82.4297522,74.138062,120.5374288,1.8,74.0657628,120.4857164,0.9532825,6.4859075,7.7100508,888.3408775,1189.8278729,9.1324949,154.3216643,136.9647765,266.2967913,13.2477252,15.4926212,1.9100889,45.8954837),(39961,'radius ulna',248,3,163,82.294971,74.1880603,120.481282,1.8,74.1187105,120.4553206,0.910298,6.4010795,7.6926599,897.3024258,1189.8250219,8.5532587,154.6701716,140.179859,268.4775716,13.0649178,15.4029813,1.9720251,45.6437783),(39962,'radius ulna',248,3,164,82.2497642,74.2404554,120.431408,1.8,74.1864249,120.3989052,0.8760529,6.5312985,7.6772684,908.7986037,1192.0720119,8.0900715,155.2729379,139.1451651,271.037358,13.2629002,15.4029813,1.9720251,46.2514489),(39963,'radius ulna',248,3,165,81.8341189,74.2935956,120.3927353,1.8,74.2442245,120.3590928,0.8380529,6.4728047,7.6644853,913.5814431,1188.3249925,7.536342,155.0430251,141.1415119,271.5813643,13.3529503,15.4029813,1.9720251,46.2514489),(39964,'radius ulna',248,3,166,81.7717357,74.342917,120.3549526,1.8,74.2845279,120.2705572,0.8144423,6.4283449,7.6723021,922.9109187,1192.3671889,7.2099199,155.4119183,143.5689806,271.6994401,13.3687531,15.4029813,1.9720251,46.2514489),(39965,'radius ulna',248,3,167,81.5643327,74.3835568,120.3170971,1.8,74.3026718,120.2242566,0.7930149,6.4180371,7.6437626,926.5931934,1192.1014899,6.9005665,155.9574192,144.3732998,272.4492727,13.3687531,15.4029813,2.0968627,45.8954837),(39966,'radius ulna',248,3,168,81.2441924,74.4182068,120.2701027,1.8,74.354754,120.1837336,0.7646389,6.4982907,7.6051831,933.4919822,1190.9112514,6.4893351,156.5920543,143.6519261,273.8674334,13.3687531,15.2584623,2.1353657,46.2514489),(39967,'radius ulna',248,3,169,81.1536669,74.4728106,120.2210963,1.8,74.4312641,120.1249284,0.7312509,6.5800072,7.5761012,941.6572569,1193.7108208,6.0318619,157.5626815,143.1088492,275.6108234,13.5811867,15.2584623,2.1353657,46.1471891),(39968,'radius ulna',248,3,170,80.552047,74.5089118,120.1796837,1.8,74.4607902,120.0860467,0.6958686,6.4990631,7.5314214,945.7021343,1194.5488446,5.5171178,158.6086854,145.5136108,276.7095983,13.3687531,15.2584623,2.1353657,45.8954837),(39969,'radius ulna',248,3,171,79.9046609,74.5541906,120.1410246,1.8,74.5307787,120.0537111,0.6504366,6.5354199,7.3921032,950.9000262,1194.1787041,4.8831251,161.5478948,145.4994545,277.5187922,13.3687531,15.2584623,2.1353657,46.1471891),(39970,'radius ulna',248,3,172,79.6775638,74.6067207,120.0916487,1.8,74.5976216,120.0182035,0.627182,6.6258312,7.3511392,956.448675,1194.8870323,4.5736382,162.5444699,144.3514995,278.6549423,13.3687531,15.3007547,2.2367656,46.5031543),(39971,'radius ulna',248,3,173,79.7447026,74.6573755,120.0350119,1.8,74.6371967,119.9254179,0.6081608,6.6072459,7.3141499,965.0778785,1202.5265519,4.3387906,164.4109799,146.0635622,281.3209307,13.645261,15.3007547,2.2367656,46.7548597),(39972,'radius ulna',248,3,174,79.2572747,74.7180977,119.9691184,1.8,74.6864276,119.8674278,0.5894229,6.6927858,7.2813108,967.9843151,1204.4099657,4.081804,165.4111453,144.6310019,278.7950258,13.6725884,15.4029813,2.0968627,46.7548597),(39973,'radius ulna',248,3,175,79.4392769,74.7856365,119.9123367,1.8,74.7291192,119.8075487,0.577951,6.6680653,7.2936037,973.0247919,1214.7191888,3.9514865,166.5458169,145.9231052,281.13554,13.6463518,15.4926212,2.1587989,46.7548597),(39974,'radius ulna',248,3,176,79.0279956,74.8331269,119.8669685,1.8,74.8062381,119.777473,0.575537,6.7337263,7.3065058,975.9010563,1217.4118229,3.9019616,166.6202506,144.927343,282.2550166,13.3687531,15.4926212,2.1587989,46.5031543),(39975,'radius ulna',248,3,177,77.5772934,74.9319706,119.7349399,1.8,74.9352525,119.6472629,0.5678158,6.6723393,7.3118635,968.3259871,1203.4597355,3.7394857,164.5900161,145.1254118,281.3730016,13.6725884,15.4029813,2.0968627,46.3988945),(39976,'radius ulna',248,3,178,76.7958534,74.9864078,119.694772,1.8,74.981114,119.5888668,0.5665658,6.7366955,7.3352713,967.7207493,1203.4878706,3.6873178,164.068625,143.6491748,277.0325229,13.6725884,15.6231626,2.1206495,46.7548597),(39977,'radius ulna',248,3,179,76.5979057,75.0539403,119.6455117,1.8,75.049041,119.5377656,0.5668265,6.6824968,7.3659772,970.8860287,1205.8691543,3.6808283,163.7079679,145.2879153,277.9658456,13.6463518,15.6231626,2.1206495,46.6505999),(39978,'radius ulna',248,3,180,76.9545248,75.1373757,119.6090209,1.8,75.1405229,119.5130801,0.5563143,6.7608154,7.4105019,979.7542206,1219.2667356,3.5764259,164.5322756,144.9165762,280.3129511,13.750016,15.6231626,2.1206495,46.6505999),(39979,'radius ulna',248,3,181,76.8171699,75.2183114,119.5710336,1.8,75.1997513,119.4984084,0.5388284,6.8378425,7.4482374,983.5504607,1219.6083293,3.371034,163.7445566,143.8392972,280.4019164,13.750016,15.6408793,2.2197919,46.9023053),(39980,'radius ulna',248,3,182,77.0874037,75.2904633,119.5235614,1.8,75.2783222,119.4354949,0.5340659,6.8480195,7.4828033,992.7690834,1228.9464165,3.3291343,164.2360979,144.971708,282.7460613,13.9484217,15.7350314,2.1815223,47.6142357),(39981,'radius ulna',248,3,183,77.5135674,75.3571099,119.4884673,1.8,75.3779645,119.3998176,0.5266231,6.8236609,7.4227142,1003.8644964,1240.1222273,3.2636275,167.0712609,147.1152384,285.2715399,13.8369868,15.7350314,2.1815223,47.8659411),(39982,'radius ulna',248,3,184,77.8120555,75.438017,119.4473703,1.8,75.4496408,119.3555599,0.5198411,6.8946611,7.4575183,1012.4492823,1246.8299885,3.2000575,167.1910052,146.8454022,286.7594217,13.9652874,15.7350314,2.1815223,47.2582705),(39983,'radius ulna',248,3,185,77.5008111,75.5134675,119.4006655,1.8,75.5317693,119.3130223,0.536103,6.9157193,7.5326827,1015.3505542,1252.3481513,3.370071,166.2552644,146.8177789,283.3258688,13.9534813,15.8519352,2.1437625,47.2582705),(39984,'radius ulna',248,3,186,77.3849406,75.599864,119.376561,1.8,75.6108179,119.2788519,0.5629135,6.9344174,7.5475232,1022.7682567,1256.8815917,3.6730101,166.5290139,147.4915911,283.9288549,13.9073312,15.9910916,2.1066076,47.7616813),(39985,'radius ulna',248,3,187,76.955364,75.665928,119.3278457,1.8,75.6576959,119.2229049,0.572279,7.0219263,7.5832376,1024.6684896,1259.3750649,3.7615224,166.0735341,145.9241305,284.6775797,14.0578756,16.0889326,2.1662062,47.7616813),(39986,'radius ulna',248,3,188,76.8122464,75.7455414,119.271251,1.8,75.746648,119.1615201,0.573535,7.1140996,7.6201362,1026.1813226,1264.5226075,3.7691764,165.9448827,144.2461289,285.6492084,14.0417081,16.0889326,2.1662062,48.1176465),(39987,'radius ulna',248,3,189,77.7015562,75.8400975,119.2351098,1.8,75.839932,119.135964,0.5945787,7.0947106,7.6969874,1040.1138888,1280.0641807,4.0635192,166.3071678,146.6041315,288.5140956,13.750016,16.0889326,2.1662062,47.7616813),(39988,'radius ulna',248,3,190,77.6899188,75.9486883,119.192239,1.8,75.9727824,119.1346306,0.5998212,7.0798594,7.77172,1041.8891868,1288.863304,4.1260403,165.8401615,147.1624131,288.8863224,13.750016,16.2431158,2.2248791,47.6574215),(39989,'radius ulna',248,3,191,78.0194026,76.0555177,119.1437039,1.8,76.0501722,119.1074675,0.6090783,7.1874788,7.7399844,1050.2300891,1302.4637027,4.2561123,168.2773035,146.1193997,290.8051387,14.0133966,16.3337968,2.1879877,48.2650921),(39990,'radius ulna',248,3,192,78.2504161,76.1269964,119.1129102,1.8,76.128408,119.0593833,0.6191295,7.112427,7.8008607,1053.6291581,1313.9246,4.3921807,168.4332856,148.1391873,292.0234877,14.0320559,16.3337968,2.1879877,48.0133867),(39991,'radius ulna',248,3,193,78.0182836,76.2705705,118.992476,1.8,76.2355927,118.9699271,0.6545211,7.2034464,7.9051198,1046.3783638,1315.299933,4.8190892,166.3858323,145.2607961,291.6559993,14.179704,16.5080739,2.2455373,48.5167975),(39992,'radius ulna',248,3,194,77.7289152,76.3592197,118.9706828,1.8,76.3494192,118.9327277,0.6728885,7.0778958,7.9866638,1042.9005798,1322.9747108,5.0321368,165.6479785,147.3461329,290.835558,14.179704,16.5080739,2.2455373,48.6210573),(39993,'radius ulna',248,3,195,77.7382587,76.4573269,118.9497114,1.8,76.4771398,118.9190837,0.690837,7.0826933,8.0128582,1041.1229159,1331.6772694,5.2603082,166.1925407,146.9953412,290.0930877,14.179704,16.5861794,2.2091161,48.2650921),(39994,'radius ulna',248,3,196,78.6787059,76.5849242,118.9382713,1.8,76.5650603,118.9258112,0.7064725,7.1684257,7.9440766,1052.2198825,1357.8901683,5.5258904,170.931152,146.7853502,297.9382569,14.179704,16.5861794,2.2091161,48.5167975),(39995,'radius ulna',248,3,197,78.3831272,76.6760869,118.9198021,1.8,76.687555,118.8726681,0.7242759,6.950825,7.9597277,1047.7809235,1364.1522499,5.7354225,171.3817731,150.7419517,296.8968399,14.280259,16.6860637,2.1730837,48.6210573),(39996,'radius ulna',248,3,198,78.5725146,76.7969769,118.8815429,1.8,76.7936185,118.8326547,0.7456645,7.0437483,8.051789,1060.9155542,1366.2492743,6.027928,169.6826963,150.6180377,297.4603987,14.517614,16.8457425,2.2296024,49.4804333),(39997,'radius ulna',248,3,199,78.3688602,76.9430456,118.8587927,1.8,76.9561516,118.784963,0.7728266,7.1686019,8.1123651,1064.613455,1383.4262181,6.3665527,170.5330314,148.5106128,297.6540091,14.415437,16.9331967,2.1939957,49.3761735),(39998,'radius ulna',248,3,200,79.2533583,77.0825327,118.8091006,1.8,77.0806906,118.7521457,0.7919415,7.02139,8.2397302,1078.421582,1409.6688846,6.6908749,171.0819231,153.5908968,301.0107566,14.2237111,17.1121594,2.2494588,49.3761735),(39999,'radius ulna',248,3,201,80.1381361,77.2457874,118.7878332,1.8,77.2220495,118.7293629,0.8143131,7.1633652,8.3002237,1093.740333,1436.1969747,7.064161,173.0311164,152.6852668,303.110942,14.4143461,17.18752,2.2142974,49.6278789),(40000,'radius ulna',248,3,202,80.7661639,77.3912324,118.7226854,1.8,77.4312189,118.6781141,0.8393204,7.0451941,8.4330192,1104.4448196,1456.853675,7.4549565,172.7558833,156.7657042,302.6688759,14.4143461,17.3851149,2.2686991,49.9838441),(40001,'radius ulna',248,3,203,81.0924027,77.5513472,118.6898348,1.8,77.5666906,118.62458,0.8489347,7.1849834,8.3582564,1116.7579947,1484.3901455,7.614113,177.5956707,155.4294468,309.9114193,14.4143461,17.18752,2.2142974,49.9838441),(40002,'radius ulna',248,3,204,80.7164252,77.7048335,118.6576336,1.8,77.7123354,118.6372141,0.8632105,7.2235811,8.5723285,1118.8517651,1510.3456878,7.7689373,176.1884988,154.8887943,306.2731294,14.5407702,17.4487192,2.2339993,50.5915147),(40003,'radius ulna',248,3,205,81.0743871,77.8759817,118.6213062,1.8,77.9081665,118.5730035,0.8753645,7.201462,8.7707883,1136.6346012,1541.6729027,7.9653114,175.7735854,157.8338668,305.3044432,14.6660363,17.7164901,2.2531129,51.5551505),(40004,'radius ulna',248,3,206,81.8668491,78.0921741,118.5809548,1.8,78.1347277,118.5502649,0.8974386,7.2571247,8.7372289,1156.3477292,1581.2094408,8.3382087,180.9737921,159.3396533,312.0745961,14.609392,17.7892908,2.2191283,51.4508907),(40005,'radius ulna',248,3,207,82.2178173,78.2895125,118.5637586,1.8,78.3136823,118.5382199,0.9072926,7.2682569,8.9011546,1177.004899,1604.983624,8.5053037,180.3118468,161.9377139,312.0041912,14.609392,17.7892908,2.2191283,51.4508907),(40006,'radius ulna',248,3,208,82.4183945,78.4700683,118.5341461,1.8,78.534336,118.543964,0.9177439,7.2956254,9.0810305,1180.3478605,1637.0199173,8.6649996,180.2680791,161.7884401,310.1299578,14.609392,18.0520106,2.2381025,51.7025961),(40007,'radius ulna',248,3,209,82.0608803,78.7526219,118.402981,1.8,78.7497124,118.3757066,0.9266196,7.3428439,9.276132,1180.8496028,1657.5599087,8.7442884,178.6908501,160.816383,305.96029,14.609392,18.3210418,2.2565258,52.5619721),(40008,'radius ulna',248,3,210,83.0241546,78.9570204,118.4076445,1.8,78.997178,118.3919224,0.9264116,7.4179553,9.2349988,1199.2211315,1685.5847707,8.8441692,182.5213858,161.6646482,310.9213539,14.9030872,18.3914495,2.223643,53.2739025),(40009,'radius ulna',248,3,211,83.1522219,79.180649,118.3534084,1.8,79.2144855,118.3831053,0.9367174,7.4665417,9.4095005,1207.2971497,1711.8558292,8.9945748,181.9284479,161.6942887,309.4610679,14.609392,18.3914495,2.223643,53.2739025),(40010,'radius ulna',248,3,212,83.337637,79.4296396,118.3798454,1.8,79.4874968,118.3838272,0.9387437,7.4680345,9.5890755,1217.8615018,1755.4858979,9.0414789,183.0714432,163.0765774,308.1076167,14.9497962,18.6555863,2.2419402,54.1332785),(40011,'radius ulna',248,3,213,83.7881385,79.6670801,118.3721077,1.8,79.746649,118.4271784,0.9521318,7.5666389,9.8688958,1234.8510244,1791.4403019,9.2678146,181.5238841,163.1967705,306.6167528,15.0861382,18.9257932,2.2597207,55.0969143),(40012,'radius ulna',248,3,214,84.4917534,79.9345312,118.3919518,1.8,80.0119388,118.4647489,0.9435557,7.6374985,10.0446283,1246.3438531,1831.6991019,9.2311934,182.3560862,163.1874439,306.1968988,15.03908,18.9939594,2.2278713,54.9926545),(40013,'radius ulna',248,3,215,85.2963563,80.1955239,118.4111275,1.8,80.2693023,118.5203035,0.9480051,7.6189699,10.2274999,1261.1901264,1882.3438453,9.3791271,184.0473102,165.5328923,306.4147197,15.3011004,19.2594195,2.2455373,56.3122555),(40014,'radius ulna',248,3,216,86.0805379,80.464127,118.4666679,1.8,80.5522769,118.5527158,0.9375518,7.7125711,10.3611882,1278.0882438,1953.7733058,9.3227547,188.5665302,165.7149385,309.308713,15.4920788,19.33596,2.2142974,56.6682207),(40015,'radius ulna',248,3,217,86.6897108,80.7461537,118.5094147,1.8,80.8477336,118.6049529,0.9348561,7.7735467,10.6660306,1291.5711848,2017.8925821,9.3515395,189.1887103,166.1495371,309.2128017,15.5668829,19.8076381,2.2794226,57.5275967),(40016,'radius ulna',248,3,218,88.0511184,81.0251319,118.5331287,1.8,81.0793476,118.6223896,0.935775,7.9059674,10.8281861,1329.1890197,2098.7461973,9.5112827,193.8225095,168.1247793,314.1685685,15.7799513,20.1358234,2.2655346,58.3869727),(40017,'radius ulna',248,3,219,88.9018233,81.3212621,118.5644566,1.8,81.3568378,118.6132117,0.9385594,7.9306499,11.1394613,1362.2441028,2172.7191452,9.6425468,195.0470577,171.7695414,316.4390258,15.9514255,20.4677674,2.2520946,59.3506085),(40018,'radius ulna',248,3,220,91.0136192,81.5830826,118.5647971,1.8,81.6110275,118.6345019,0.9535638,7.9090016,11.3493966,1406.2363472,2278.9406109,10.0875417,200.798394,177.8020055,323.0920436,16.1442422,20.8032903,2.2390857,60.5659497),(40019,'radius ulna',248,3,221,94.2098191,81.8199724,118.56893,1.8,81.8817726,118.598896,0.956493,8.0153797,11.5638837,1461.3726384,2426.3066714,10.4851658,209.8176296,182.3210746,332.6209125,16.145333,21.5787243,1.7916251,61.1736202),(40020,'radius ulna',248,3,222,97.000892,82.0225173,118.494528,1.8,82.1167312,118.5491621,0.9590004,8.0467596,11.8640368,1520.9611334,2595.8566658,10.8339519,218.8004561,189.0153554,342.3289402,16.5287847,22.0944884,1.8063413,62.137256),(40021,'radius ulna',248,3,223,100.8920347,82.2971166,118.3403135,1.8,82.3636533,118.4294883,0.9889319,8.3300941,12.490624,1600.5317057,2862.153151,11.7364178,229.1441281,192.1384896,353.6220372,16.7109414,23.139407,1.8337911,63.9602678),(40022,'radius ulna',248,3,224,106.7196291,82.5610536,118.1402381,1.8,82.6439942,118.2384423,1.0012277,8.5615176,12.7697098,1713.7600025,3197.3540781,12.6140662,250.3858048,200.1701193,381.545914,17.2769256,23.6679702,1.8466022,65.4273144),(40023,'radius ulna',248,3,225,106.0932238,82.5875929,118.2401583,1.8,82.7329977,118.1158565,0.8852945,8.7779517,12.2816466,1553.8333088,3174.1393285,10.595761,258.4457467,177.0154764,380.7553087,17.1694146,23.2905166,2.2253671,65.9307252),(40024,'radius ulna',248,3,226,90.7160823,82.1351636,118.5118172,1.8,82.4185494,118.3702621,0.7640171,8.7506205,11.837402,1059.0190728,2501.8761605,7.2365046,211.3534843,121.0221691,299.1043137,16.2848178,22.886685,2.2631308,68.1097022),(40025,'radius ulna',248,3,227,59.9676739,81.202867,118.5158425,1.8,81.5335058,118.6317039,0.5167645,7.5608202,10.9650097,463.9677747,1336.4802652,2.4397333,121.8859177,61.3647416,158.7187357,14.0330761,21.072243,2.2550911,66.3909502),(40026,'radius ulna',248,3,228,24.5815391,80.6548306,118.7550831,1.8,80.7307467,118.6055643,0.2791656,4.6149959,8.5777693,75.2741671,452.0468428,0.3110787,52.6998138,16.3107768,60.6765296,9.2434314,17.1067638,2.7004132,54.2986122),(40027,'radius ulna',248,3,229,0.5918847,84.4041431,119.6150824,1.8,84.4814351,119.6442364,0.9233677,1.2539917,3.1113848,0.2335698,0.590984,0.062762,0.1899424,0.1862611,0.2648508,2.578128,3.3559706,2.2655346,8.9065394),(40028,'radius ulna',248,3,230,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40029,'radius ulna',248,3,231,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40030,'radius ulna',248,3,232,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40031,'radius ulna',248,3,233,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40032,'radius ulna',248,3,234,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40033,'radius ulna',248,3,235,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40034,'radius ulna',248,3,236,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40035,'radius ulna',248,3,237,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40036,'radius ulna',248,3,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40037,'radius ulna',248,3,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40038,'radius ulna',248,3,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40039,'radius ulna',248,3,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40040,'radius ulna',248,3,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40041,'radius ulna',248,3,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40042,'radius ulna',248,3,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40043,'radius ulna',248,3,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40044,'radius ulna',248,3,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40045,'radius ulna',248,3,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40046,'radius ulna',248,3,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40047,'radius ulna',248,3,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40048,'radius ulna',248,3,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40049,'radius ulna',248,3,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40050,'radius ulna',248,3,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40051,'radius ulna',248,3,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40052,'radius ulna',248,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40053,'radius ulna',248,3,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40054,'radius ulna',248,3,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40055,'radius ulna',248,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40056,'radius ulna',248,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40057,'radius ulna',248,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40058,'radius ulna',248,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40059,'radius ulna',248,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40060,'radius ulna',248,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40061,'radius ulna',248,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40062,'radius ulna',248,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40063,'radius ulna',248,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40064,'radius ulna',248,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40065,'radius ulna',248,4,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40066,'radius ulna',248,4,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40067,'radius ulna',248,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40068,'radius ulna',248,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40069,'radius ulna',248,4,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40070,'radius ulna',248,4,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40071,'radius ulna',248,4,17,14.9866173,109.4190237,119.6950479,1.8,109.6371157,119.9496277,-0.3920059,4.2556538,6.0511593,28.1683959,128.1993934,0.3645665,21.1859227,6.6190525,25.7901347,7.2467146,12.4905505,0.4636476,37.4491693),(40072,'radius ulna',248,4,18,36.5337612,109.7989288,120.4310869,1.8,109.8674416,120.9328719,-0.3834348,6.4181911,7.1726935,174.4369392,392.7219318,0.8521918,54.7523652,27.1785206,78.0337371,10.4780396,14.283491,0.3693337,40.4875223),(40073,'radius ulna',248,4,19,54.0725491,110.1140904,121.0727667,1.8,110.2583177,121.2436307,-0.4832012,6.3224805,7.9372754,347.5202446,614.682714,1.9454249,77.4425332,54.9658069,120.9081649,11.815475,15.240301,0.3752708,43.3173557),(40074,'radius ulna',248,4,20,64.4400151,110.6468841,121.2347436,1.8,110.7107658,121.3325588,-0.4361082,6.8354586,8.2922646,462.8720382,787.1792223,1.9163877,94.929342,67.7163102,150.7490714,12.4572472,16.0544686,0.2709469,45.1403675),(40075,'radius ulna',248,4,21,75.9253425,111.3759392,121.5866439,1.8,111.5530266,121.7496963,-0.208959,7.4099429,7.9853313,653.6573394,986.6538688,0.5445371,123.5582885,88.213546,195.4514428,13.320328,16.4688822,0.2639637,49.8363985),(40076,'radius ulna',248,4,22,87.7324328,112.0712116,121.9263613,1.8,112.1249027,121.9854534,0.1002307,7.0232579,9.01967,837.1948119,1268.736053,0.1464048,140.6632459,119.2031999,233.3672572,13.320328,17.1067638,0.2023216,50.9474799),(40077,'radius ulna',248,4,23,95.7198832,112.8192613,122.2378794,1.8,112.6755438,122.2234075,0.3021622,7.2750648,9.8278736,941.3331483,1696.7668328,1.4127761,172.6484178,129.3917199,266.9204998,13.750016,18.280687,2.625362,53.2739025),(40078,'radius ulna',248,4,24,98.2888386,113.228389,122.3999509,1.8,112.9743487,122.3287726,0.3860986,7.5366879,10.1455532,993.5311961,1993.1930853,2.3230617,196.4597733,131.8259705,289.5057278,14.179704,18.7592155,2.7908647,54.1332785),(40079,'radius ulna',248,4,25,100.244145,113.4621359,122.385719,1.8,113.1644876,122.3642489,0.4141294,7.5031036,10.2973894,1030.1188413,2226.6535113,2.705259,216.2347586,137.2923655,308.9083387,14.5765437,19.1873855,2.5473789,55.6003251),(40080,'radius ulna',248,4,26,104.8138934,113.650506,122.3106341,1.8,113.2986153,122.3042913,0.4193104,7.3696871,10.559369,1080.7039792,2514.5724898,2.8955785,238.1366245,146.6417723,335.5886465,14.2237111,19.676708,2.5899377,55.9562903),(40081,'radius ulna',248,4,27,109.303355,113.8205955,122.2036665,1.8,113.4115671,122.2563937,0.4246902,7.0364277,10.87863,1120.1964593,2840.4307558,3.0928427,261.10188,159.1995981,358.6402097,14.0319853,20.3773616,2.7062394,56.8156663),(40082,'radius ulna',248,4,28,115.3691243,113.8715387,122.0765657,1.8,113.4383634,122.0939253,0.4218365,6.8950586,11.2303079,1197.1963561,3293.4317597,3.2233818,293.2628194,173.6310636,394.2830791,13.9083049,21.1596801,2.6325218,58.7429379),(40083,'radius ulna',248,4,29,122.7221128,113.7373407,121.9106019,1.8,113.404208,121.8856358,0.411019,6.7787075,11.2757671,1344.4194958,3889.0174386,3.2651264,344.9004774,198.3297689,458.5468167,13.828547,21.74493,2.6248975,60.8176551),(40084,'radius ulna',248,4,30,131.3506271,113.7245313,121.6715652,1.8,113.4110199,121.584179,0.4146373,7.2004564,11.1142137,1549.4329937,4400.9786376,3.5529156,395.9775076,215.1853852,528.9267514,14.5685626,22.04848,2.5644004,62.6406668),(40085,'radius ulna',248,4,31,140.7961091,113.862947,121.318227,1.8,113.632469,121.2326525,0.4451364,7.6873605,11.0495107,1804.5227289,4824.9840455,4.3505992,436.6694759,234.7389226,590.2961085,15.770324,22.5289315,2.5324292,64.1077134),(40086,'radius ulna',248,4,32,148.0125261,114.1570532,120.9047022,1.8,113.9572008,120.7136241,0.5238958,8.4953117,11.1353195,2090.7897437,5115.299139,6.173536,459.3760541,246.111011,622.6472999,17.1199608,22.951132,2.4756234,66.034985),(40087,'radius ulna',248,4,33,155.8791826,114.7271007,120.1522218,1.8,114.5480957,119.9634324,0.6812999,9.3980523,11.583958,2438.2829303,5532.218044,10.3049698,477.5758027,259.4455597,674.4000309,17.9671141,23.2190609,2.4610714,67.0418066),(40088,'radius ulna',248,4,34,152.3284897,115.3638887,120.2300851,1.8,115.2086358,119.8918459,0.7058333,9.4657827,11.4314617,2330.1220369,5237.5626348,10.6825552,458.1708582,246.1626373,650.3958359,18.3525225,23.44459,2.4210385,67.3366979),(40089,'radius ulna',248,4,35,138.1833457,116.3984488,120.9219545,1.8,116.174414,120.2837938,0.6804146,9.8864609,11.0179999,2046.8709682,4031.1856321,9.1151757,365.8727221,207.0377862,549.6252306,17.9379052,22.3479072,2.2335258,64.1940851),(40090,'radius ulna',248,4,36,127.7948429,117.1967781,121.4530641,1.8,117.0454148,120.8484197,0.611223,10.1477397,9.8590375,1857.6176931,3131.534453,7.0143636,317.6308493,183.0572863,481.5881193,17.617208,20.4677674,2.2520946,61.7202169),(40091,'radius ulna',248,4,37,121.3894071,117.6765385,121.8139256,1.8,117.5608758,121.2959916,0.5100282,10.1863003,9.1105657,1714.1921619,2722.5940821,4.8220125,298.8391913,168.2840782,434.5149958,17.18752,19.7516315,0.8007816,60.5048757),(40092,'radius ulna',248,4,38,119.9539789,117.876624,121.9524374,1.8,117.8054033,121.545642,0.4045435,10.0837061,8.6761542,1670.610244,2634.9614017,3.0972172,303.7015404,165.6742296,408.268426,17.6623704,20.0623347,0.7551044,61.0693605),(40093,'radius ulna',248,4,39,120.5780903,117.9590687,122.0065465,1.8,117.9539116,121.6330468,0.3549413,9.8529678,8.7530953,1618.0127078,2659.1380787,2.4272526,303.7940289,164.2157713,396.7241085,17.4046337,20.0623347,0.7551044,62.5364071),(40094,'radius ulna',248,4,40,116.2346557,117.9914785,122.1311826,1.8,117.9770239,121.8323317,0.3256816,8.5774628,8.6977004,1503.3761484,2671.3875245,1.9831751,307.1372205,175.2704951,380.4196232,16.8006574,19.7142053,0.2872815,61.7812908),(40095,'radius ulna',248,4,41,106.9832609,117.9796272,122.2253012,1.8,117.9696243,121.8754226,0.2752426,8.6142761,9.2059503,1398.6621445,2728.6280759,1.3170454,296.3983066,162.3656043,371.9636009,16.6282768,20.126652,0.2812322,60.9219148),(40096,'radius ulna',248,4,42,110.1620606,117.6778284,121.9892049,1.8,117.5409856,121.6380365,0.2569666,8.940417,9.5807474,1554.4600883,3133.2097403,1.1859156,327.0318695,173.8688573,406.4606616,17.2578407,21.072243,0.2895037,64.316233),(40097,'radius ulna',248,4,43,117.9426115,117.3624954,121.7035132,1.8,117.1275611,121.2391963,0.2537518,9.5736392,9.971336,1775.5957746,3678.7387237,1.2387856,368.9313781,185.4671698,442.9145396,17.7776728,22.1986985,0.2543681,67.5020316),(40098,'radius ulna',248,4,44,129.0343935,116.7846308,121.3480573,1.8,116.5012865,120.7933889,0.2317239,10.2807157,10.7752979,2109.3824896,4590.2664556,1.1342494,425.9990309,205.1785644,517.838982,18.6778371,23.4485273,0.2405342,71.191241),(40099,'radius ulna',248,4,45,151.0268916,115.625312,120.7359982,1.8,115.2785111,120.1538748,0.2594285,10.5535714,12.7928321,2609.8033268,6716.7709365,1.6564313,525.0417491,247.2910088,697.7734093,19.2496266,26.0129864,2.604006,79.6807412),(40100,'radius ulna',248,4,46,163.5235536,114.3673822,120.5781542,1.8,114.228267,119.9888994,0.2246732,10.6672211,13.6236229,2650.6171014,9284.0174301,1.3527325,681.4646531,248.4824382,841.6687534,19.1566251,27.6640329,0.108942,83.1793192),(40101,'radius ulna',248,4,47,160.6281357,113.9716512,120.789899,1.8,113.954682,120.2582762,0.1637487,10.757546,14.664748,2318.3324358,10880.4503526,0.7114444,741.9459496,215.5075558,891.3082724,18.906272,29.3731901,3.0390128,83.7869898),(40102,'radius ulna',248,4,48,150.756434,114.8035261,120.8543447,1.8,114.6489674,120.3177706,0.1660206,10.6991136,15.2816302,2129.2669673,9707.5884698,0.6862066,635.2456083,199.0134002,774.4609966,18.6476273,29.2472054,2.9643673,81.3563074),(40103,'radius ulna',248,4,49,138.6010051,116.3967925,120.8847522,1.8,116.2474888,120.3743567,0.2121668,10.5669245,13.9346615,1979.1194246,6832.1887571,1.0243391,490.3017392,187.2937983,623.0320157,17.9493203,26.4947168,2.9951085,74.5855592),(40104,'radius ulna',248,4,50,132.5076529,117.2703521,121.0833798,1.8,117.1643788,120.5202143,0.2485405,10.1422192,12.2342392,1804.8985138,5677.1239725,1.3363585,464.0357197,177.9589332,598.4364458,17.2569076,24.2497879,3.0172377,69.7241944),(40105,'radius ulna',248,4,51,126.3645621,117.8284706,121.3872072,1.8,117.7411687,120.8970956,0.273492,9.1525166,11.8487507,1531.0189747,5087.3163131,1.5364129,429.3546605,167.2784698,545.0617175,15.9485921,23.4563999,2.9945143,66.3909502),(40106,'radius ulna',248,4,52,125.5857517,118.3023872,121.622052,1.8,118.168021,121.2081417,0.2937786,7.3444743,11.3291053,1362.0421403,4765.4459929,1.7550898,420.637451,185.451278,520.6151687,13.8253934,22.8099178,3.0850492,63.856008),(40107,'radius ulna',248,4,53,119.5914852,118.8145124,121.8345462,1.8,118.6323511,121.4760578,0.2932215,6.7098589,11.0589903,1216.2129453,4304.1874825,1.665168,389.2025737,181.2576047,482.4947108,13.4958354,22.0191518,3.0438657,61.7812908),(40108,'radius ulna',248,4,54,116.5258144,119.2714532,122.0261525,1.8,119.1802168,121.7380323,0.2754995,6.5257573,10.8620478,1094.4175082,3917.9988125,1.4371325,360.7053565,167.7073564,452.9552485,13.2535274,21.2684709,2.9996956,58.8903835),(40109,'radius ulna',248,4,55,117.5856568,119.5263364,122.1123851,1.8,119.5315735,121.9043926,0.2714593,6.4084567,10.6030656,1010.6772119,3694.9554055,1.4090238,348.4799146,157.7099233,443.0005953,13.041144,20.8431901,2.891614,57.7793021),(40110,'radius ulna',248,4,56,118.3923298,119.833433,122.2472953,1.8,119.9060309,122.1077623,0.2505482,6.2820473,10.5287516,939.0438111,3471.5213989,1.2129655,329.7182349,149.480537,418.7848779,12.9092943,20.5398055,2.8661665,56.3122555),(40111,'radius ulna',248,4,57,117.5229379,120.208203,122.4254909,1.8,120.2884755,122.3253197,0.2224981,6.2431103,10.6521343,861.9375452,3210.9623291,0.9537744,301.4383995,138.0622002,380.2412076,12.7901168,20.4180938,2.9937433,55.2011741),(40112,'radius ulna',248,4,58,115.0953657,120.6556346,122.5771474,1.8,120.6539167,122.4949786,0.1952013,6.1970437,10.725689,799.0639028,2892.2151187,0.7216871,269.6530846,128.9427575,343.4465515,12.460952,20.0623347,2.9694018,53.6298677),(40113,'radius ulna',248,4,59,111.7123521,121.0564896,122.6713857,1.8,121.0175969,122.5800115,0.1689503,6.0320876,10.6552335,750.0148609,2597.7906436,0.5264192,243.8041958,124.3375285,313.4539285,12.031264,19.6391391,2.965653,52.1628211),(40114,'radius ulna',248,4,60,108.6469051,121.3953705,122.7539709,1.8,121.2937939,122.6501823,0.1456517,5.994974,10.6539084,709.6332995,2356.2475449,0.3814379,221.1627378,118.3713731,287.7688804,12.031264,19.4121987,0.0886559,51.6594103),(40115,'radius ulna',248,4,61,107.8258532,121.7224587,122.8003715,1.8,121.599653,122.7189954,0.1224213,5.9701329,10.5540305,681.0611833,2179.436538,0.2679877,206.5027697,114.0780611,270.891404,12.031264,19.0279509,3.0284417,51.0517397),(40116,'radius ulna',248,4,62,104.6473332,121.9873445,122.8170902,1.8,121.8503318,122.7239604,0.1010194,5.9671577,10.7228479,652.7984382,2025.9857915,0.1773815,188.9410181,109.3985567,249.7243263,12.031264,18.9842363,3.0509328,50.5483289),(40117,'radius ulna',248,4,63,101.0254172,122.1826868,122.8035713,1.8,122.003037,122.7359058,0.0844925,5.9850391,10.5279065,628.0939893,1915.3435608,0.1199173,181.930145,104.9440074,241.4823208,11.9346907,18.6555863,3.0029529,49.9406583),(40118,'radius ulna',248,4,64,98.6915596,122.348597,122.7698063,1.8,122.1707503,122.6833896,0.073436,5.7107156,10.2897677,609.5258303,1823.0774968,0.0885454,177.1738244,106.733704,235.6165984,11.601576,18.3713606,2.9533711,49.2287279),(40119,'radius ulna',248,4,65,96.0029853,122.4378815,122.607454,1.8,122.2841164,122.5181833,0.0651056,5.7994033,10.3329481,583.4447379,1725.0458272,0.0677261,166.9461432,100.6042704,223.2938809,11.601576,18.2301179,2.9996956,48.7253171),(40120,'radius ulna',248,4,66,94.1380365,122.5103911,122.5385436,1.8,122.3396339,122.4483571,0.0632839,5.8207034,10.3731544,566.117023,1679.4721404,0.0627511,161.9056346,97.2592118,216.4584612,11.601576,18.2301179,0.1418971,48.7253171),(40121,'radius ulna',248,4,67,92.4479843,122.5458624,122.4490971,1.8,122.3446939,122.3517476,0.0666196,5.5625487,10.0305114,550.0513822,1648.1569604,0.0682823,164.3143504,98.8847764,218.7471089,11.171888,17.8721284,2.9724914,47.5099759),(40122,'radius ulna',248,4,68,91.5295811,122.5693282,122.3436074,1.8,122.4164066,122.2612251,0.0716798,5.6349762,10.0185501,539.3142761,1628.6268572,0.0782456,162.5611333,95.7083499,216.3920583,11.171888,18.1285566,0.0949517,48.1176465),(40123,'radius ulna',248,4,69,90.2437047,122.5696217,122.2268078,1.8,122.4551451,122.1192288,0.0798995,5.3476988,9.6153611,526.1905852,1599.4043111,0.0958142,166.3384546,98.3957035,220.9631325,10.7422,17.747727,0.121352,46.9023053),(40124,'radius ulna',248,4,70,89.869126,122.5755497,122.0985245,1.8,122.4711416,122.0278409,0.0872318,5.4329302,9.6119456,519.3222413,1579.704986,0.1136861,164.3480996,95.5878722,218.3674825,10.7422,17.747727,0.121352,46.6505999),(40125,'radius ulna',248,4,71,89.3638503,122.586357,121.9580449,1.8,122.480098,121.8542868,0.09239,5.4881429,9.2218668,513.7114988,1556.7235355,0.1267724,168.807853,93.6038861,224.3365765,11.0405432,17.379804,0.1488899,46.3988945),(40126,'radius ulna',248,4,72,88.4460066,122.5914238,121.8223639,1.8,122.4831306,121.7113609,0.1017901,5.3070949,9.2161578,507.0184244,1535.5084617,0.1522081,166.6104794,95.5359636,221.5974015,10.7422,17.321277,0.124355,46.0429293),(40127,'radius ulna',248,4,73,87.9531517,122.5924325,121.6727545,1.8,122.4844522,121.576534,0.1109167,5.3528583,9.1539711,500.9617483,1519.6318948,0.1796024,166.0079402,93.587709,220.3846889,10.7422,17.2732438,0.0996687,46.0429293),(40128,'radius ulna',248,4,74,87.4151459,122.5843378,121.5179595,1.8,122.5037483,121.3859586,0.1196675,5.1659438,8.7472736,495.7607717,1501.5870299,0.2076412,171.6634352,95.9671245,228.2303106,10.6675149,16.9549897,0.1526493,45.4352587),(40129,'radius ulna',248,4,75,87.0371543,122.5685012,121.3667081,1.8,122.4598848,121.242535,0.1307521,5.1911704,8.7083155,488.6606442,1488.1242686,0.2465895,170.8854327,94.1330388,226.6031447,10.6022792,16.8949912,0.1275096,45.4352587),(40130,'radius ulna',248,4,76,86.6519452,122.5523394,121.2007889,1.8,122.451478,121.0723956,0.1430896,5.0268204,8.358889,482.678673,1473.6512585,0.2936817,176.2975037,96.0206716,234.0147916,10.4219901,16.5304274,0.1566019,45.0792935),(40131,'radius ulna',248,4,77,86.9615671,122.5376379,121.0387574,1.8,122.4018333,120.8973269,0.1535168,5.041897,8.3204547,480.3064183,1474.5106953,0.3389016,177.2151575,95.2630367,234.9175566,10.3180391,16.4688822,3.0107653,45.0792935),(40132,'radius ulna',248,4,78,86.6270479,122.5233247,120.8790526,1.8,122.420532,120.7550371,0.1609376,4.8957859,8.2796308,474.1235053,1467.5687194,0.3707358,177.2505032,96.8431863,234.322641,10.1984194,16.4183554,3.0367157,44.7233283),(40133,'radius ulna',248,4,79,86.2533084,122.4996745,120.7126877,1.8,122.3927892,120.5761336,0.1705288,4.9713863,8.1515777,470.5038579,1462.1895059,0.4140053,179.3750305,94.6423845,235.3379771,10.1984194,16.3789491,3.0628087,45.3309989),(40134,'radius ulna',248,4,80,85.471253,122.4725736,120.5577023,1.8,122.372095,120.4034535,0.1764322,4.8369705,7.9703172,463.0051068,1456.6070646,0.4388474,182.7539636,95.7221265,239.3268349,10.0778865,16.1804778,2.9546134,44.3673631),(40135,'radius ulna',248,4,81,84.3680501,122.3742736,120.2872604,1.8,122.197644,120.1451656,0.1856968,4.7591894,7.9874167,452.4761356,1431.3417069,0.4793334,179.1995795,95.074202,230.3901953,9.9275661,16.1975849,2.7610863,44.3673631),(40136,'radius ulna',248,4,82,83.6193403,122.3490292,120.127221,1.8,122.2209964,119.9832946,0.1898702,4.7214693,8.0180252,446.6256665,1431.5812913,0.4964137,178.5453716,94.5946348,226.7045963,9.8630236,16.3620316,2.7367009,44.6190685),(40137,'radius ulna',248,4,83,83.0829011,122.2874389,119.9446678,1.8,122.1279028,119.7882854,0.197418,4.6245131,8.0159373,440.9139095,1434.5170775,0.5327021,178.9581211,95.3427749,224.398555,9.7062279,16.3620316,2.7367009,44.8707739),(40138,'radius ulna',248,4,84,82.8110448,122.2458046,119.7767664,1.8,122.1512327,119.6457543,0.2007823,4.692734,8.032441,434.2624374,1432.0508685,0.5489644,178.2833972,92.5393252,226.6208599,9.7846257,16.446445,2.7950538,44.0113979),(40139,'radius ulna',248,4,85,82.5427133,122.1846574,119.6036612,1.8,122.0492444,119.4526484,0.203385,4.6127199,8.0289462,428.0997917,1431.9837519,0.561266,178.3526397,92.8085387,223.644475,9.62783,16.446445,2.7950538,44.6190685),(40140,'radius ulna',248,4,86,82.8474116,122.1023836,119.4173627,1.8,121.9854197,119.2853118,0.2060881,4.6952624,8.0915441,423.7254357,1445.5105896,0.5781977,178.6445917,90.2453146,219.4448345,9.7012487,16.757832,2.7468015,44.5148087),(40141,'radius ulna',248,4,87,82.9470009,122.010798,119.242302,1.8,121.8579344,119.1100005,0.2100269,4.7009164,8.1273873,419.1374203,1455.7649902,0.6009025,179.1184461,89.1607906,218.7692089,9.6192604,16.757832,2.7468015,45.4784445),(40142,'radius ulna',248,4,88,82.4586219,121.9307751,119.0690117,1.8,121.7932221,118.919837,0.2113246,4.6765372,8.1945105,412.3520064,1459.5725282,0.6046586,178.1158897,88.174644,216.627211,9.537272,16.927744,2.7233683,44.8707739),(40143,'radius ulna',248,4,89,81.8683597,121.8477652,118.903278,1.8,121.7184471,118.7589175,0.2126203,4.7323277,8.2620745,407.4810693,1461.5926776,0.607603,176.9038372,86.105844,214.2980925,9.6390308,16.998492,2.7798634,45.4784445),(40144,'radius ulna',248,4,90,81.4001223,121.7404882,118.7308393,1.8,121.6257813,118.582158,0.2187416,4.7436196,8.2282593,402.0495302,1469.3679975,0.63885,178.5758018,84.7558539,212.9757672,9.5607264,17.1121594,2.6442499,45.1224793),(40145,'radius ulna',248,4,91,80.8712921,121.6343131,118.5665186,1.8,121.5230201,118.4168492,0.2229891,4.7945375,8.5188722,398.6237948,1475.9449629,0.6591738,173.2559118,83.14124,211.5021219,9.6771552,17.321277,2.7334435,45.8344097),(40146,'radius ulna',248,4,92,80.4089854,121.519847,118.3877854,1.8,121.391194,118.2304487,0.2281329,4.8238454,8.4765977,395.1281989,1481.4465091,0.6854598,174.7690006,81.9114556,211.1367922,9.6830735,17.321277,2.7334435,45.7301499),(40147,'radius ulna',248,4,93,80.3403918,121.3984791,118.2114258,1.8,121.2980661,118.0710595,0.2366128,4.8893995,8.4403531,394.7710479,1497.5759268,0.7357652,177.4304831,80.7401902,212.2251341,9.7890598,17.4962707,2.7109001,45.4784445),(40148,'radius ulna',248,4,94,80.3225441,121.2765505,118.0407371,1.8,121.1950572,117.9119918,0.2414747,4.9336107,8.4039856,393.2459156,1503.1451742,0.7655468,178.8609884,79.7075289,211.724512,9.8443628,17.4962707,2.7109001,46.0861151),(40149,'radius ulna',248,4,95,80.8043771,121.1493994,117.8759421,1.8,121.0669125,117.7672796,0.2473375,4.9702318,8.5636825,392.9684262,1512.2545505,0.807215,176.5892833,79.0644059,214.1241332,9.8764489,17.5542142,2.7656317,45.8344097),(40150,'radius ulna',248,4,96,80.7009833,121.0385266,117.7270261,1.8,120.9518711,117.5817202,0.2501201,4.9882365,8.5324442,388.6392235,1514.2303312,0.8240422,177.4673587,77.9111463,212.6896856,9.9022354,17.5542142,2.7656317,46.0861151),(40151,'radius ulna',248,4,97,79.8820574,120.8265448,117.5086711,1.8,120.7635626,117.432856,0.2531275,5.0453386,8.3881959,381.4123119,1498.1979568,0.8349899,178.6078882,75.5969699,211.5999102,9.9696944,17.4962707,2.7109001,45.7301499),(40152,'radius ulna',248,4,98,79.294313,120.7235162,117.3786107,1.8,120.6533166,117.2395063,0.2504293,4.9385785,8.4515464,371.7913378,1489.3734036,0.8116391,176.2249581,75.2830672,213.3113656,9.8499102,17.5542142,2.7656317,45.4784445),(40153,'radius ulna',248,4,99,78.1631916,120.6121369,117.2651085,1.8,120.5684218,117.1759811,0.2474319,5.0145328,8.4723328,363.4775039,1471.8776156,0.7814142,173.7275496,72.484819,208.2775064,9.8764489,17.5542142,2.7656317,45.7301499),(40154,'radius ulna',248,4,100,77.3078988,120.4980144,117.1556928,1.8,120.4620412,117.0922146,0.244956,4.9834759,8.5061604,355.203496,1447.9940093,0.7577832,170.2288626,71.276255,205.4212992,9.8499102,17.5542142,2.7656317,45.8344097),(40155,'radius ulna',248,4,101,76.2285862,120.3430977,117.035395,1.8,120.2984461,116.9544928,0.248243,4.9674728,8.5781482,347.4036711,1418.2396338,0.7669752,165.331677,69.9356971,202.5987819,9.8226215,17.4010378,2.7886023,46.0861151),(40156,'radius ulna',248,4,102,75.3000562,120.2187383,116.921142,1.8,120.1881877,116.8305952,0.2499668,4.9458724,8.521404,340.9664521,1397.171678,0.7679702,163.9602673,68.9395972,201.0073025,9.8035284,17.4962707,2.7109001,44.8707739),(40157,'radius ulna',248,4,103,74.8573316,120.0896628,116.8149835,1.8,120.0795326,116.7290288,0.2530258,5.023009,8.5653217,335.4997594,1374.4193466,0.781852,160.463248,66.7925856,199.4393885,9.9090005,17.321277,2.7334435,44.7233283),(40158,'radius ulna',248,4,104,73.8511444,119.9620198,116.7243608,1.8,119.9219544,116.6292223,0.251713,4.9693072,8.6049815,327.2498447,1350.3349807,0.7635291,156.9247978,65.8542192,194.2644507,9.7833719,17.4010378,2.7886023,45.3309989),(40159,'radius ulna',248,4,105,73.0886151,119.830036,116.6359248,1.8,119.7777086,116.54801,0.24933,5.018934,8.5443573,319.9714699,1322.930142,0.7417019,154.8308549,63.7528743,189.4378422,9.7833719,17.321277,2.7334435,45.0792935),(40160,'radius ulna',248,4,106,72.227168,119.7130281,116.5464931,1.8,119.7079444,116.4706437,0.245491,4.9676849,8.4772826,312.9877057,1298.8904906,0.7110145,153.2201484,63.0047418,189.8661471,9.6577432,17.1552631,2.7564351,44.7233283),(40161,'radius ulna',248,4,107,71.7505942,119.5860445,116.4583072,1.8,119.6104502,116.3706301,0.2436914,4.9152287,8.5189216,309.6067601,1284.4840449,0.6962109,150.7801226,62.9892894,186.2976905,9.749345,17.1552631,2.7564351,44.3673631),(40162,'radius ulna',248,4,108,71.0479304,119.4321976,116.3688795,1.8,119.4098124,116.2771593,0.2430168,4.9636482,8.5869103,306.1049866,1264.7800773,0.6856564,147.2916377,61.6693552,181.2799676,9.749345,17.1229455,2.8357138,44.4716229),(40163,'radius ulna',248,4,109,71.0973894,119.2929024,116.2848078,1.8,119.3021802,116.2257527,0.2437787,5.0130177,8.4282207,304.9436989,1256.6978275,0.6903567,149.1059463,60.8303654,184.8156832,9.749345,16.998492,2.7798634,44.1156577),(40164,'radius ulna',248,4,110,70.1351781,119.1618774,116.2082792,1.8,119.2188887,116.1468985,0.243865,4.9520406,8.5737952,300.6269837,1240.0080599,0.6814863,144.6276744,60.7076976,179.3083415,9.6237164,17.1552631,2.7564351,44.1156577),(40165,'radius ulna',248,4,111,69.4448231,119.0339767,116.1429421,1.8,119.1288778,116.110461,0.2408446,4.9815662,8.6127521,296.8389287,1220.9016606,0.6584895,141.7551145,59.5874707,175.2255234,9.6237164,16.998492,2.7798634,44.1156577),(40166,'radius ulna',248,4,112,68.7763441,118.9178608,116.082401,1.8,118.9712973,116.040109,0.2389244,4.8985645,8.4258529,292.5003944,1201.4604095,0.6419911,142.5921421,59.7114515,177.1523178,9.5896896,16.8512217,2.8037145,44.1156577),(40167,'radius ulna',248,4,113,67.5975542,118.6767344,115.9421603,1.8,118.705076,115.879465,0.2352473,4.8703316,8.4939564,285.0343128,1164.34873,0.6120725,137.0796692,58.5246211,169.2829183,9.4758467,16.8512217,2.8037145,43.8639523),(40168,'radius ulna',248,4,114,66.8291503,118.5677901,115.9104209,1.8,118.646606,115.8633832,0.23139,4.8701525,8.5128244,279.6559044,1136.1965468,0.5857862,133.4688102,57.4224126,163.9392419,9.4758467,16.757832,2.7468015,43.8639523),(40169,'radius ulna',248,4,115,66.3521849,118.4465106,115.8743677,1.8,118.5230041,115.8169928,0.229104,4.8743371,8.4191373,275.2029147,1109.6147072,0.5703712,131.7967234,56.4595569,164.2015223,9.4758467,16.5973074,2.7707014,43.2562817),(40170,'radius ulna',248,4,116,66.0292471,118.3305766,115.8372803,1.8,118.3910811,115.7618866,0.2286239,4.8835314,8.443313,271.4699501,1090.6495692,0.5652603,129.1731775,55.5888612,160.4182608,9.4758467,16.5973074,2.7707014,43.8639523),(40171,'radius ulna',248,4,117,65.2153007,118.2021321,115.8010878,1.8,118.2519065,115.7180002,0.2296705,4.7930063,8.4778572,265.4001083,1059.3253754,0.563325,124.9520186,55.3723676,154.395871,9.3538087,16.5861794,2.8526172,43.6122469),(40172,'radius ulna',248,4,118,64.5712155,118.0817962,115.7701154,1.8,118.1291387,115.695732,0.2287986,4.7952807,8.2821963,260.1272284,1034.5366703,0.5536086,124.9109098,54.2465067,155.6052327,9.2468306,16.3055132,2.8198421,43.0045763),(40173,'radius ulna',248,4,119,63.9645603,117.9657907,115.739903,1.8,118.0630081,115.632137,0.2304347,4.6752072,8.4007256,256.0458971,1007.8603874,0.5561389,119.9730157,54.7667481,149.7663867,9.2740354,16.3055132,2.8198421,42.3969057),(40174,'radius ulna',248,4,120,63.3803965,117.8223967,115.7166761,1.8,117.9123402,115.6181269,0.2328377,4.6690058,8.2247044,252.1682412,979.4759301,0.5624032,119.0894995,54.0089802,149.6374061,9.2740354,16.1975849,2.7610863,42.0409405),(40175,'radius ulna',248,4,121,62.8448525,117.6906512,115.6908044,1.8,117.7800265,115.6161579,0.2364155,4.6691123,8.2570125,248.6258222,956.135972,0.5745978,115.7968419,53.2490558,145.2756495,9.2481155,16.0429641,2.7859568,41.7892351),(40176,'radius ulna',248,4,122,62.3821541,117.5512527,115.6635651,1.8,117.6529257,115.6070513,0.2401024,4.6678528,8.2938101,245.4426155,933.7218109,0.5879499,112.5805631,52.5814818,140.6467881,9.1669974,15.9448411,2.896614,42.1452003),(40177,'radius ulna',248,4,123,61.9112871,117.4150999,115.6414765,1.8,117.4793603,115.583724,0.242156,4.6593546,8.1146393,243.0139587,911.9231676,0.5933398,112.3799999,52.1561417,141.7495113,9.1117735,15.7643386,2.8370818,41.2858243),(40178,'radius ulna',248,4,124,61.6970583,117.2974798,115.6238912,1.8,117.3926434,115.5515715,0.246406,4.6526736,8.1249955,240.2646488,892.5872919,0.6117985,109.856958,51.6401261,137.9405134,9.1117735,15.7643386,2.8370818,41.5375297),(40179,'radius ulna',248,4,125,61.4037175,117.184396,115.6236518,1.8,117.2564643,115.5583246,0.2489907,4.627705,8.0268668,237.5963463,870.5702733,0.6214642,108.4570471,51.3421544,137.9567762,9.0914086,15.6408793,2.7763912,40.9298591),(40180,'radius ulna',248,4,126,61.1131742,117.07402,115.6151474,1.8,117.1767978,115.5476641,0.2533158,4.612194,8.0267654,235.5498469,846.5207826,0.6397329,105.4622549,51.0711054,134.1815342,9.0914086,15.4926212,2.8023,40.9298591),(40181,'radius ulna',248,4,127,60.5359482,116.9491042,115.6120554,1.8,117.0341287,115.5510121,0.2584816,4.5872564,7.8386243,233.0080307,818.7607448,0.6592155,104.4520973,50.7946383,134.0649625,9.0671153,15.240301,2.7663218,40.3221885),(40182,'radius ulna',248,4,128,59.9506654,116.8445215,115.6064464,1.8,116.9318252,115.5474576,0.2627462,4.5682033,7.8280275,231.3277665,796.4439412,0.6740601,101.7426085,50.6386764,130.627491,9.0400601,15.240301,2.7663218,40.3221885),(40183,'radius ulna',248,4,129,58.9349669,116.654647,115.5467332,1.8,116.7471438,115.4979735,0.2688912,4.5066423,7.7218345,226.7183731,760.6549612,0.6932385,98.5070278,50.3076031,127.7685802,9.0400601,15.0083566,2.7291822,39.8187777),(40184,'radius ulna',248,4,130,58.4259986,116.5577171,115.5443208,1.8,116.6573489,115.4599405,0.2721788,4.4883062,7.6992894,224.1195276,739.6410019,0.7037402,96.0661387,49.9340992,124.5583465,9.0102511,14.8413514,2.75571,39.8187777),(40185,'radius ulna',248,4,131,57.8239312,116.4512844,115.5531121,1.8,116.5402698,115.4792907,0.2754582,4.4559258,7.6798911,221.2179691,713.2230434,0.7129442,92.8689005,49.6457927,120.1097744,8.9179527,14.6975909,2.8753406,39.5670723),(40186,'radius ulna',248,4,132,57.3111584,116.3615101,115.5563035,1.8,116.4779095,115.4903959,0.278262,4.5502065,7.584717,220.469301,693.4195344,0.7207053,91.4232569,48.4525929,120.3639965,9.0858451,14.6157096,2.7173982,38.8551419),(40187,'radius ulna',248,4,133,56.2759895,116.2614848,115.5556585,1.8,116.3468878,115.4814598,0.282687,4.5305843,7.5594809,217.8222032,663.1807735,0.729767,87.7283484,48.0781706,115.8602436,9.0673097,14.5397175,2.8104966,38.3517311),(40188,'radius ulna',248,4,134,55.8534625,116.1809482,115.5631976,1.8,116.2660467,115.5143115,0.282348,4.5003542,7.3420482,216.5915105,641.5381359,0.7225979,87.378633,48.1276582,116.7703464,9.0182714,14.283491,2.772259,38.3517311),(40189,'radius ulna',248,4,135,55.4986897,116.1029684,115.5642764,1.8,116.2073182,115.528956,0.280201,4.4744122,7.2985213,217.0783495,629.8009359,0.7074162,86.2915801,48.5155011,115.4484427,9.0182714,14.1340576,2.8006137,38.2474713),(40190,'radius ulna',248,4,136,55.0134439,116.0342493,115.562802,1.8,116.1305214,115.5095644,0.2822117,4.45967,7.2437777,216.6893183,610.4726271,0.7110618,84.2754497,48.588644,112.700446,9.0182714,13.9962251,2.8295505,37.7440605),(40191,'radius ulna',248,4,137,54.6857504,115.9762185,115.5700454,1.8,116.005913,115.5180381,0.2810216,4.4349348,7.1244287,216.8875378,595.0588743,0.7010346,83.5237327,48.9043354,113.8959041,9.0182714,13.8836442,2.7610863,37.7440605),(40192,'radius ulna',248,4,138,54.3051852,115.8948477,115.5805875,1.8,115.9251577,115.5528811,0.2818494,4.5228131,7.0799363,218.5674626,580.3163447,0.7001542,81.9663225,48.3255574,112.2865862,9.1056026,13.7567282,2.8890384,37.4923551),(40193,'radius ulna',248,4,139,54.2651816,115.815545,115.586107,1.8,115.7888058,115.5466017,0.2817031,4.4952175,6.8613801,220.4311972,568.269491,0.6989318,82.8214562,49.0368258,114.9007425,9.1056026,13.6556983,2.7201734,36.8846845),(40194,'radius ulna',248,4,140,54.1298969,115.7460977,115.5989237,1.8,115.7341158,115.5562827,0.2793048,4.4598488,6.9250541,221.826259,557.4009866,0.6856774,80.490488,49.7385153,112.4704959,9.1056026,13.6556983,2.7201734,36.6329791),(40195,'radius ulna',248,4,141,54.1193225,115.6681665,115.6078488,1.8,115.6188448,115.5614924,0.2787833,4.4873695,6.7027757,224.8025984,546.6657671,0.6830528,81.5581168,50.0967439,114.9866778,9.1056026,13.4513621,2.677945,36.5287193),(40196,'radius ulna',248,4,142,53.7408274,115.5817368,115.6177914,1.8,115.5265204,115.5879044,0.2851616,4.5254986,6.6637771,225.2102334,532.3186846,0.7088125,79.8824269,49.7647343,113.6297378,9.1723375,13.3272566,2.7790484,36.2770139),(40197,'radius ulna',248,4,143,53.551328,115.5046434,115.6335101,1.8,115.4754227,115.6054356,0.2876554,4.5393559,6.6108307,226.3766307,520.6002855,0.7183764,78.7496023,49.8697691,112.4321754,9.2419446,13.1809902,2.8095332,36.0253085),(40198,'radius ulna',248,4,144,53.1154851,115.43344,115.6481036,1.8,115.3675397,115.6321759,0.2928502,4.5066606,6.507959,226.1388064,508.8760049,0.7377516,78.1928718,50.1787968,112.8782291,9.2083568,13.0896253,2.7367009,36.0253085),(40199,'radius ulna',248,4,145,52.237589,115.2901221,115.6108377,1.8,115.2201442,115.5832998,0.2987117,4.5016451,6.5306043,223.7458879,487.9662079,0.7540161,74.7199167,49.7031379,108.9084685,9.2419446,13.0896253,2.7367009,35.5218977),(40200,'radius ulna',248,4,146,51.7544133,115.219595,115.6278267,1.8,115.1385585,115.5851338,0.3069676,4.4648324,6.3107464,222.4521464,476.6432971,0.7875842,75.5288305,49.8231794,110.7175354,9.2404019,12.9263977,2.767259,35.1659325),(40201,'radius ulna',248,4,147,51.2611107,115.1371913,115.6442171,1.8,115.0444564,115.6372931,0.3172491,4.5573946,6.251703,220.7432758,463.4733478,0.8314159,74.1355352,48.4362877,109.3149501,9.2246579,12.7755427,2.7985687,34.9142271),(40202,'radius ulna',248,4,148,50.518835,115.0602455,115.6675422,1.8,114.9891229,115.6629737,0.3252695,4.5176839,6.1819829,219.5758314,451.8559222,0.8598412,73.0923931,48.6036285,107.7751763,9.2419446,12.695808,2.7233683,34.9142271),(40203,'radius ulna',248,4,149,49.4324728,114.9757547,115.6995893,1.8,114.9259857,115.6823143,0.3320552,4.5963239,6.1149282,216.7494518,440.1222865,0.8755092,71.9750536,47.1571319,107.4182326,9.023448,12.695808,2.7233683,34.2022967),(40204,'radius ulna',248,4,150,48.6213239,114.8943414,115.7248358,1.8,114.8239105,115.7027294,0.3429856,4.5503219,6.1832242,215.0716987,431.5657977,0.9164949,69.7962401,47.2651614,104.5718389,9.023448,12.695808,2.7233683,34.8099673),(40205,'radius ulna',248,4,151,48.2441156,114.8159088,115.7582204,1.8,114.7080139,115.7355287,0.348354,4.494134,5.9878586,213.8185998,423.9830638,0.9369055,70.8071271,47.5772644,105.758267,9.023448,12.5274503,2.6011732,34.5582619),(40206,'radius ulna',248,4,152,47.8327224,114.7423404,115.78969,1.8,114.6231803,115.7589238,0.3517267,4.5882382,6.0473462,213.2010408,417.0997297,0.9462394,68.9723587,46.4668636,104.090932,9.3252107,12.5274503,2.6011732,34.5582619),(40207,'radius ulna',248,4,153,47.4603257,114.6671206,115.8228781,1.8,114.5883718,115.8097452,0.3571042,4.534125,5.9575962,212.9335372,410.225546,0.9665614,68.8575609,46.9624319,104.5500754,9.3767439,12.3940969,2.5535901,34.5582619),(40208,'radius ulna',248,4,154,47.1594319,114.5857146,115.8683891,1.8,114.4989216,115.8486591,0.3634531,4.4659701,5.8634711,212.8167833,404.3412286,0.9933584,68.9593627,47.6529798,104.5210034,9.3767439,12.2893773,2.5050844,34.8099673),(40209,'radius ulna',248,4,155,46.5806392,114.5071908,115.9291912,1.8,114.3845557,115.920162,0.3641903,4.5345679,5.9019428,212.6260038,397.3895002,0.9849732,67.3319807,46.8900256,103.1018188,9.3782866,12.3043918,2.7091849,33.6988859),(40210,'radius ulna',248,4,156,46.2095853,114.4362206,115.9885056,1.8,114.3494582,115.9895349,0.3656852,4.5489546,5.8645928,212.6653946,393.3379911,0.9848041,67.0699576,46.7503888,103.0997616,9.4174746,12.3043918,2.7091849,34.0548511),(40211,'radius ulna',248,4,157,46.258149,114.3522574,116.0354724,1.8,114.2758262,116.012734,0.3690313,4.4741268,5.7977248,214.3072082,390.7122837,1.0031327,67.3906227,47.8992251,103.8997904,9.3562957,12.1306029,2.741352,34.0548511),(40212,'radius ulna',248,4,158,46.0502425,114.2598368,116.0835302,1.8,114.1389152,116.0877125,0.3760361,4.5511496,5.817143,214.3082343,385.7936366,1.035076,66.3201231,47.0888131,102.9460842,9.023448,12.1306029,2.741352,33.6988859),(40213,'radius ulna',248,4,159,45.7130377,114.1850054,116.1249622,1.8,114.1035466,116.1236911,0.3827424,4.4847399,5.8091276,214.5371985,381.3684741,1.0626508,65.6498705,47.8371548,102.4229458,9.023448,12.1306029,2.741352,33.3429207),(40214,'radius ulna',248,4,160,45.2450801,114.1255056,116.1785426,1.8,114.0623557,116.2026692,0.3898784,4.5752417,5.7232424,215.7381237,376.2735965,1.0893334,65.7448298,47.153383,103.2810505,9.453136,11.9697226,2.7744188,33.6988859),(40215,'radius ulna',248,4,161,44.4541847,114.0483107,116.2034474,1.8,113.9942964,116.2351751,0.3892061,4.5227335,5.6732773,212.6050798,366.7454228,1.066792,64.6443677,47.0080931,101.303648,9.4174746,11.9388329,2.6135182,33.9505913),(40216,'radius ulna',248,4,162,43.8298495,113.9880101,116.2673504,1.8,113.8932673,116.2741955,0.3877901,4.4404877,5.6301891,212.2575389,361.1425624,1.044557,64.143949,47.8005011,101.7966811,9.3767439,11.7988288,2.5636907,33.6988859),(40217,'radius ulna',248,4,163,43.3724663,113.9268611,116.3455695,1.8,113.8662668,116.318016,0.3863138,4.5128518,5.6032646,212.8835441,355.645359,1.0261959,63.4710986,47.1727309,101.3955374,9.453136,11.7988288,2.5636907,33.3429207),(40218,'radius ulna',248,4,164,42.9606814,113.8611572,116.4239813,1.8,113.7715974,116.3869509,0.3769879,4.4873659,5.5986912,212.9761478,350.5207693,0.9702921,62.607627,47.4612845,99.8692884,9.4174746,11.7360686,2.7270858,33.6988859),(40219,'radius ulna',248,4,165,42.5667444,113.7859868,116.4994252,1.8,113.7079026,116.4697301,0.3663039,4.5530417,5.6402821,212.1485865,346.5760223,0.9101025,61.4465758,46.5949139,99.0498338,9.453136,11.7360686,2.7270858,33.9505913),(40220,'radius ulna',248,4,166,42.2013972,113.7052876,116.5657223,1.8,113.5966587,116.5286474,0.3583169,4.4948203,5.5736832,209.6614511,343.017789,0.8650546,61.5423907,46.6451246,98.6219075,9.4174746,11.6887773,2.5127964,33.6988859),(40221,'radius ulna',248,4,167,41.8148454,113.6314238,116.6528398,1.8,113.5547246,116.6587238,0.3622739,4.5028464,5.5331403,209.5241938,339.3543033,0.8753266,61.3312304,46.5314992,98.6138048,9.453136,11.6887773,2.5127964,33.9505913),(40222,'radius ulna',248,4,168,41.3812405,113.563056,116.741384,1.8,113.4557578,116.7215998,0.3609868,4.5560333,5.5126533,208.7947335,335.2417177,0.8603751,60.813133,45.8281847,98.4809679,9.4174746,11.6095305,2.4610714,33.3429207),(40223,'radius ulna',248,4,169,41.0558969,113.5065024,116.8315078,1.8,113.4679375,116.8296778,0.3549304,4.5164485,5.532091,208.6916672,331.9789331,0.8264122,60.009666,46.2070295,97.6018347,9.4174746,11.5697035,2.7610863,33.0912153),(40224,'radius ulna',248,4,170,40.8535853,113.4419419,116.9170166,1.8,113.3728549,116.8956487,0.3558079,4.5145451,5.4506481,210.0125554,329.9481024,0.8262376,60.5337372,46.5190953,98.6545648,9.453136,11.4413255,2.5431738,33.3429207),(40225,'radius ulna',248,4,171,40.5340044,113.3817385,117.0123029,1.8,113.3508152,117.0366811,0.3540109,4.5202083,5.4372199,211.0383699,327.0067181,0.8118628,60.1422643,46.6877535,98.498029,9.5130859,11.4413255,2.5431738,33.6988859),(40226,'radius ulna',248,4,172,40.6836121,113.3298831,117.1122774,1.8,113.2751358,117.1270597,0.3508532,4.590208,5.4525491,213.7682299,325.3764052,0.8009863,59.6741817,46.5704891,98.3243921,9.453136,11.4413255,2.5431738,33.4471805),(40227,'radius ulna',248,4,173,41.188608,113.2833734,117.2034058,1.8,113.2011956,117.1979418,0.3493565,4.5831462,5.4005244,216.789193,326.2643896,0.8043084,60.4134649,47.3013921,99.0194079,9.453136,11.4413255,2.5431738,33.6988859),(40228,'radius ulna',248,4,174,41.2020917,113.2348678,117.283181,1.8,113.1435778,117.2386347,0.3503845,4.6361523,5.3825637,217.0915334,324.5385971,0.809118,60.2944271,46.8257982,99.4186326,9.453136,11.4413255,2.5431738,33.3429207),(40229,'radius ulna',248,4,175,41.2497044,113.2040942,117.3618115,1.8,113.1245428,117.3285756,0.3641633,4.6106514,5.3853984,217.2770187,322.7832797,0.8721241,59.9367505,47.1250157,99.4534346,9.6092004,11.3522236,2.6271413,33.4471805),(40230,'radius ulna',248,4,176,41.4857533,113.191204,117.4553381,1.8,113.0978544,117.4459624,0.374,4.5439575,5.4103325,217.564962,321.1202896,0.9228826,59.3531521,47.8800609,99.129083,9.5130859,11.3522236,2.6271413,33.6988859),(40231,'radius ulna',248,4,177,40.4942806,113.1357282,117.5115349,1.8,113.0451694,117.4920148,0.3792846,4.6134904,5.3813609,214.9088498,312.6693811,0.9252233,58.1022879,46.5827019,97.5657006,9.6092004,11.2787985,2.4370986,33.6988859),(40232,'radius ulna',248,4,178,40.3434421,113.1169649,117.6245901,1.8,113.0110804,117.6466926,0.3834235,4.5621344,5.3240759,213.7724203,308.4924713,0.9410041,57.9429136,46.8579843,96.7928981,9.453136,11.2048922,2.5748634,32.8395099),(40233,'radius ulna',248,4,179,40.1358712,113.0916043,117.7292721,1.8,113.0173532,117.698966,0.3891828,4.5911157,5.3351969,213.4930387,305.836056,0.9630535,57.32423,46.5013411,96.2630012,9.6092004,11.2048922,2.5748634,33.1954751),(40234,'radius ulna',248,4,180,40.3276085,113.0605426,117.8488593,1.8,112.9297266,117.8218717,0.3939957,4.547906,5.3485085,216.2290267,302.7168558,0.9904771,56.5983686,47.5447444,96.1972528,9.6092004,11.2048922,2.5748634,33.4471805),(40235,'radius ulna',248,4,181,39.9233209,113.0243519,117.9693529,1.8,112.87651,117.9185196,0.3870868,4.676849,5.2917262,216.0008597,295.7765539,0.948182,55.8941525,46.1851257,95.436721,9.7842272,11.1470707,2.6607054,33.4471805),(40236,'radius ulna',248,4,182,39.6747393,112.9968631,118.0801781,1.8,112.8592842,118.0328499,0.403623,4.6113645,5.316137,213.7870859,288.7790125,1.0200028,54.3212135,46.3609168,94.2113724,9.453136,11.1470707,2.6607054,32.4835447),(40237,'radius ulna',248,4,183,39.0836939,112.9782393,118.1730637,1.8,112.8534609,118.1243004,0.4189948,4.6446361,5.2153177,212.9293319,284.5588806,1.0781935,54.5621373,45.8441362,94.0733256,9.7773576,11.0137676,2.782822,33.0912153),(40238,'radius ulna',248,4,184,38.3121009,112.9615508,118.2672239,1.8,112.846811,118.2479892,0.4317705,4.5549697,5.2234718,210.9391944,279.281745,1.1182347,53.4666892,46.3096814,92.5627417,9.6092004,11.0137676,2.782822,33.0912153),(40239,'radius ulna',248,4,185,38.5231965,112.9559065,118.3643952,1.8,112.8657526,118.3416798,0.4377384,4.6415404,5.2293495,207.5615717,275.0009383,1.1536709,52.5879817,44.7182519,91.1875649,9.6932128,11.0053826,2.2455373,32.8395099),(40240,'radius ulna',248,4,186,38.5565422,112.9269773,118.4584185,1.8,112.8346157,118.4330145,0.4487148,4.6897078,5.2453564,205.5826493,271.5370156,1.2093213,51.7671243,43.8369844,90.9035332,9.453136,10.980189,2.6078845,32.2318393),(40241,'radius ulna',248,4,187,37.8405625,112.9083287,118.5626071,1.8,112.7909622,118.5126535,0.4522193,4.6313781,5.1057526,203.3736011,267.2345443,1.2041907,52.3398931,43.9121136,90.3153265,9.6494279,10.8703421,2.8198421,32.8395099),(40242,'radius ulna',248,4,188,37.282471,112.8982608,118.6795019,1.8,112.7523068,118.6569814,0.4662637,4.6782582,5.1308885,201.6677395,260.6514291,1.2557791,50.8004468,43.1074414,88.8059018,9.7227296,10.9549375,2.300696,32.8395099),(40243,'radius ulna',248,4,189,36.5807024,112.9133797,118.7976892,1.8,112.8190195,118.8162199,0.4793781,4.5941321,5.1948114,200.2630282,255.7075069,1.2969733,49.2236363,43.5910466,87.7702698,9.453136,10.8448348,2.5535901,32.2318393),(40244,'radius ulna',248,4,190,35.7840443,112.9120913,118.9068551,1.8,112.8031064,118.8952582,0.5045065,4.6874407,5.075119,195.6727573,249.5259549,1.3935015,49.1665233,41.7440497,87.0445364,9.453136,10.7422,2.2142974,32.2318393),(40245,'radius ulna',248,4,191,35.4511476,112.8854974,119.035857,1.8,112.7316324,119.023576,0.5176155,4.6168456,5.1219614,194.7554793,244.7829625,1.4466217,47.7908639,42.183667,85.3080702,9.6102913,10.7422,2.2142974,32.2318393),(40246,'radius ulna',248,4,192,34.8818663,112.8787029,119.1504938,1.8,112.7441633,119.1644182,0.5488865,4.6927112,4.9667619,192.7959416,238.1049854,1.5825329,47.9396815,41.0841265,85.1964128,9.6932128,10.6125107,2.1251038,31.9801339),(40247,'radius ulna',248,4,193,34.1649914,112.8623189,119.2091353,1.8,112.7575936,119.2173569,0.5491903,4.6342937,4.9834382,188.8235925,230.589372,1.5515499,46.2711409,40.7448481,83.0806612,9.453136,10.4900209,2.1815223,31.6241687),(40248,'radius ulna',248,4,194,33.9057796,112.8832044,119.3250281,1.8,112.7467132,119.2896896,0.6006214,4.6827117,5.0693612,189.0262945,227.2788771,1.8049202,44.8338296,40.3668443,82.1213197,9.4188943,10.6125107,2.1251038,31.0164981),(40249,'radius ulna',248,4,195,33.7040834,112.8795826,119.4407751,1.8,112.7907128,119.4472961,0.6647898,4.756694,5.0555037,189.3981882,224.0474462,2.1377255,44.3175317,39.8171897,81.3825828,9.453136,10.6732285,2.2706892,31.8758741),(40250,'radius ulna',248,4,196,33.582618,112.856696,119.5583816,1.8,112.7668413,119.6000741,0.6692725,4.7227535,4.9524342,188.3196772,220.2753268,2.1544118,44.4781935,39.8749745,81.2855555,9.453136,10.6125107,2.1251038,31.6241687),(40251,'radius ulna',248,4,197,33.9585955,112.8683518,119.6976758,1.8,112.7869933,119.740833,0.661309,4.6957911,4.9391378,188.0716927,217.4450228,2.1347546,44.0248949,40.05112,80.5815497,9.453136,10.6125107,2.1251038,31.2682035),(40252,'radius ulna',248,4,198,34.6361941,112.873816,119.8262136,1.8,112.7739663,119.8621783,0.7087956,4.8493784,4.8013609,188.9814873,214.8130077,2.4458739,44.7400248,38.9702499,81.8829369,9.453136,10.3927662,2.0899424,31.3724633),(40253,'radius ulna',248,4,199,32.9091037,112.8730221,119.9310273,1.8,112.794287,119.9470491,0.7656928,4.7442312,4.9243686,186.5525413,210.6771297,2.6343726,42.7825672,39.3219755,78.9354496,9.453136,10.5689273,2.0344439,31.6241687),(40254,'radius ulna',248,4,200,32.92628,112.856203,120.0392133,1.8,112.7753931,120.1107811,0.8230159,4.686117,4.8922483,185.1040809,209.3612193,2.9500975,42.7944798,39.5005252,79.536879,9.453136,10.4900209,2.1815223,31.2682035),(40255,'radius ulna',248,4,201,32.7208352,112.8779215,120.1870963,1.8,112.7876838,120.2271838,0.8457378,4.6267874,4.8210389,183.1897524,208.7850961,3.0549985,43.3070754,39.5932934,78.7911467,9.4188943,10.3927662,2.0899424,31.1207579),(40256,'radius ulna',248,4,202,32.6451362,112.8896863,120.319882,1.8,112.8212763,120.3948208,0.915685,4.721975,5.0443639,183.1450006,210.4315737,3.421305,41.716176,38.7856781,77.6790133,9.453136,10.6125107,2.1251038,31.6241687),(40257,'radius ulna',248,4,203,32.446685,112.9107181,120.4775452,1.8,112.8145844,120.5036124,0.9438978,4.7208636,4.9728537,183.1048993,209.5949735,3.5467384,42.1478258,38.7863142,78.9686075,9.453136,10.4900209,2.1815223,31.6241687),(40258,'radius ulna',248,4,204,32.958171,112.952568,120.6223327,1.8,112.8866072,120.7033667,1.0250828,4.6585789,5.02386,182.929689,211.5686985,4.0132603,42.1127772,39.2672727,77.9674145,9.7227296,10.6125107,1.943784,31.9801339),(40259,'radius ulna',248,4,205,33.0758877,112.9907929,120.7718229,1.8,112.938887,120.8289233,1.0469359,4.6086235,5.0272531,182.0891029,213.0822332,4.1332368,42.3854195,39.5105183,78.2316907,9.4188943,10.6125107,1.943784,31.7284285),(40260,'radius ulna',248,4,206,32.2300504,113.0300094,120.9059412,1.8,112.9767749,120.9393611,1.0503669,4.6294935,5.0161913,180.0703095,210.7675846,4.0434731,42.0174535,38.896331,77.5075869,9.6102913,10.6732285,2.2706892,32.2318393),(40261,'radius ulna',248,4,207,31.5958682,113.0502907,121.0107493,1.8,113.0184813,121.0678137,1.0404382,4.6048657,5.04634,178.932262,210.9420234,3.9185382,41.8009929,38.8572159,76.9932568,9.6102913,10.6125107,1.943784,31.9801339),(40262,'radius ulna',248,4,208,31.690534,113.0871356,121.1221893,1.8,113.0460615,121.141984,1.0337127,4.5859497,5.0132466,179.2247436,214.5285024,3.8991624,42.7923299,39.0812715,77.9715436,9.6102913,10.6125107,1.943784,31.9801339),(40263,'radius ulna',248,4,209,31.2125615,113.0919198,121.1971337,1.8,113.095473,121.2413572,1.0063503,4.5708338,5.1732502,175.3440576,214.2482344,3.7134147,41.4146283,38.3615038,75.2608183,9.453136,10.8448348,2.1587989,31.8758741),(40264,'radius ulna',248,4,210,30.7698368,113.1502978,121.3145471,1.8,113.1655682,121.423567,1.0042374,4.5584049,5.175152,171.7038483,212.7575143,3.6509384,41.1113559,37.6675287,74.063188,9.4188943,10.7765202,1.9809237,31.7284285),(40265,'radius ulna',248,4,211,30.7709558,113.2093524,121.4682932,1.8,113.2048843,121.5511525,0.9611101,4.6421625,5.239053,169.4387197,214.2310232,3.4469495,40.8911734,36.4999542,73.1584269,9.4188943,10.980189,2.1045045,31.6241687),(40266,'radius ulna',248,4,212,29.7205688,113.2741112,121.5679095,1.8,113.2477446,121.6288308,0.9048208,4.7190405,5.1715325,167.0770255,214.6028751,3.062657,41.4969596,35.4048719,72.122718,9.7227296,10.980189,2.1045045,32.2318393),(40267,'radius ulna',248,4,213,28.9167492,113.3532667,121.7193783,1.8,113.3432561,121.8226547,0.8393409,4.7456713,5.1756108,165.8988737,212.2245963,2.6692001,41.0047438,34.9579359,72.4039554,9.7227296,10.8448348,2.1587989,32.5878045),(40268,'radius ulna',248,4,214,28.5136365,113.4500251,121.9046835,1.8,113.4213147,121.9650351,0.8090523,4.6742337,5.2540784,164.9498932,211.6969851,2.4885052,40.2919349,35.2891837,71.5864341,9.7227296,11.0053826,2.2455373,32.4835447),(40269,'radius ulna',248,4,215,28.7674772,113.5450605,122.0330709,1.8,113.5109934,122.0921771,0.7862315,4.633128,5.2425397,166.4595238,216.4560548,2.4012855,41.2883958,35.9281078,72.9731,9.7227296,11.0053826,2.2455373,33.1954751),(40270,'radius ulna',248,4,216,28.6541805,113.601644,122.1821404,1.8,113.5815466,122.271935,0.7553811,4.898345,5.262059,168.5225598,222.8630838,2.2445821,42.3528286,34.403979,74.0891944,9.9712727,11.0889478,2.1910458,33.4471805),(40271,'radius ulna',248,4,217,28.95099,113.6809796,122.3182445,1.8,113.6734608,122.4221083,0.7106889,4.9252136,5.4078796,172.0332772,230.4626463,2.053438,42.616083,34.9291001,74.0455856,9.882824,11.3522236,2.6271413,33.6988859),(40272,'radius ulna',248,4,218,29.281425,113.7439528,122.4492056,1.8,113.7085636,122.6160339,0.6893266,5.1012261,5.4576444,175.8353638,240.6685962,1.9741461,44.0975222,34.4692352,74.9642868,10.0265649,11.5697035,2.5948038,34.0548511),(40273,'radius ulna',248,4,219,30.298802,113.8143508,122.5929461,1.8,113.8133843,122.7379501,0.6476834,5.1877304,5.6302009,181.9988929,254.1803962,1.8382276,45.1458835,35.082566,75.7725764,10.2716688,11.7988288,2.5636907,34.9142271),(40274,'radius ulna',248,4,220,30.7614445,113.9183328,122.7257012,1.8,113.8996339,122.8820345,0.6123102,5.2670907,5.754412,187.696385,266.7016243,1.6936658,46.3473283,35.6356853,77.7183333,10.3144368,12.0389346,2.5337907,35.5218977),(40275,'radius ulna',248,4,221,31.8937968,113.9857699,122.8727612,1.8,113.9817896,123.0103631,0.5701963,5.3198002,5.8741312,196.8857821,283.188169,1.5488749,48.2093709,37.0099959,79.4785303,10.3793764,12.2291349,2.8198421,36.1295683),(40276,'radius ulna',248,4,222,32.6703133,114.0442579,122.9992949,1.8,114.0499374,123.1584967,0.5257592,5.3770275,6.0739094,203.1272492,301.1803409,1.3714634,49.5859127,37.7768661,81.5400049,10.4916038,12.5274503,2.7547169,36.7372389),(40277,'radius ulna',248,4,223,33.830696,114.1586142,123.1694701,1.8,114.1709126,123.3325033,0.4772023,5.4532098,6.1539739,212.4788062,323.7876748,1.189446,52.6144046,38.9639892,84.8487037,10.5721931,12.7755427,2.7985687,37.2406497),(40278,'radius ulna',248,4,224,34.8802437,114.2609825,123.3461348,1.8,114.286169,123.5132349,0.4287414,5.5443937,6.3864082,221.5757324,344.4737276,1.0047167,53.9385704,39.9639245,86.6215083,10.7601721,13.0896253,2.7367009,37.9525801),(40279,'radius ulna',248,4,225,36.6278115,114.3020238,123.4788553,1.8,114.3086408,123.5989171,0.3851863,5.8389819,6.7161347,233.4633699,381.7765962,0.8618182,56.8446906,39.9835749,89.0921116,11.0914385,13.7567282,2.8890384,39.4196267),(40280,'radius ulna',248,4,226,39.0683079,114.4185941,123.6621522,1.8,114.4109928,123.8033369,0.3597912,5.8589726,6.9571189,248.8169833,435.240163,0.8071479,62.560403,42.4676819,97.849306,11.1484615,14.1340576,2.8006137,40.2790027),(40281,'radius ulna',248,4,227,42.3852457,114.4240428,123.8056699,1.8,114.4480145,123.9329072,0.2681597,5.9356654,7.3618165,276.769977,501.1611704,0.4959243,68.075749,46.6282981,105.5846237,11.4590245,14.8164498,2.8473581,41.7460493),(40282,'radius ulna',248,4,228,39.6568357,114.0835004,123.6361044,1.8,114.2163999,123.8327507,0.1534795,5.9287889,7.6443312,243.4360004,429.7353715,0.1544737,56.2162156,41.0599879,88.0191331,11.4751869,14.6975909,2.8753406,41.4943439),(40283,'radius ulna',248,4,229,26.0775601,113.5877921,123.536828,1.8,113.7060763,123.495875,0.2661665,5.0690103,7.0717308,119.8695185,201.229197,0.3007062,28.4554378,23.647519,44.7002746,10.2356441,13.2369013,2.9123607,41.2426385),(40284,'radius ulna',248,4,230,7.6168441,113.0623861,124.1155109,1.8,113.3352297,124.0111694,0.5246489,3.4984114,4.5064126,18.4400432,22.6803947,0.3185238,5.0329157,5.2709762,8.634104,7.0254822,9.0642783,2.5930433,27.0755833),(40285,'radius ulna',248,4,231,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40286,'radius ulna',248,4,232,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40287,'radius ulna',248,4,233,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40288,'radius ulna',248,4,234,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40289,'radius ulna',248,4,235,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40290,'radius ulna',248,4,236,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40291,'radius ulna',248,4,237,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40292,'radius ulna',248,4,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40293,'radius ulna',248,4,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40294,'radius ulna',248,4,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40295,'radius ulna',248,4,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40296,'radius ulna',248,4,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40297,'radius ulna',248,4,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40298,'radius ulna',248,4,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40299,'radius ulna',248,4,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40300,'radius ulna',248,4,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40301,'radius ulna',248,4,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40302,'radius ulna',248,4,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40303,'radius ulna',248,4,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40304,'radius ulna',248,4,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40305,'radius ulna',248,4,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40306,'radius ulna',248,4,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40307,'radius ulna',248,4,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40308,'radius ulna',248,4,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40309,'radius ulna',248,4,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40310,'radius ulna',248,4,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40311,'femur',248,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40312,'femur',248,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40313,'femur',248,7,3,8.5033004,81.9720719,122.5624157,1.8,81.9034788,122.9139526,0.7849407,4.0906317,5.161892,31.4450034,33.3513138,0.70796,6.4610639,7.6870777,11.2147437,8.2035531,10.1864154,2.0533096,29.4020059),(40314,'femur',248,7,4,65.3748673,82.7382092,124.1494545,1.8,82.7490147,123.9794264,1.119024,6.122551,8.5586638,421.0241432,766.5019907,8.8192301,89.5586048,68.7661312,138.0942092,11.8495766,16.7798528,2.2655346,46.1471891),(40315,'femur',248,7,5,96.9457263,83.212354,125.3093222,1.8,83.171365,124.5643895,0.8780236,7.2158718,10.1817789,932.5272468,2089.1799247,9.5668721,205.1881057,129.23279,293.9949475,13.9249775,20.3818914,2.536048,56.2690697),(40316,'femur',248,7,6,113.7789971,82.9185137,125.5956418,1.8,82.941814,124.7514127,0.8753189,8.0692848,11.4229959,1389.0520477,3514.9282982,11.1775888,307.7063432,172.1406655,428.7296603,15.2605146,22.8382305,2.4227627,62.7449266),(40317,'femur',248,7,7,121.8649178,82.3653244,125.3425164,1.8,82.5321976,124.8113392,0.9086268,8.5115693,12.0542925,1907.3583091,4614.4801392,12.6330225,382.8080458,224.090087,540.3722524,16.5674681,24.375091,2.2813346,67.753737),(40318,'femur',248,7,8,126.4366804,81.8905348,125.2050607,1.8,82.0444085,124.7943021,0.8938158,9.1083834,12.8010664,2507.8631235,5209.6586325,12.8031896,406.9706737,275.3357006,602.5619734,17.8847004,25.5510854,2.3086114,71.191241),(40319,'femur',248,7,9,131.0644479,81.7574598,125.1042798,1.8,81.6660828,124.736334,0.8947329,9.3762057,13.028868,3139.1188994,5715.4392448,13.2913656,438.675043,334.7962914,679.5743057,19.2165865,26.5190958,2.2759077,74.7330048),(40320,'femur',248,7,10,136.4105449,81.6212964,125.0561247,1.8,81.4034413,124.6626187,0.9669247,10.1104854,13.1274057,3775.1669386,6188.260222,15.4045005,471.4000879,373.3912648,757.4344301,20.1835753,26.9095862,2.2430435,77.0594274),(40321,'femur',248,7,11,143.8053833,81.3732135,125.1692352,1.8,81.2608509,124.6005453,1.0555125,10.4777928,13.6760876,4454.1330229,6719.5384096,18.1474259,491.3348456,425.1022239,816.7667,21.2684709,27.4227137,2.1892243,78.8824392),(40322,'femur',248,7,12,155.2627362,81.2349784,125.2825716,1.8,81.329716,124.6531818,1.0981677,11.2361554,14.0609888,5416.4645254,7393.377839,20.5145326,525.8078185,482.0567485,910.6407252,22.1799768,27.5302279,2.1674567,81.0614162),(40323,'femur',248,7,13,165.1319761,81.3312813,125.3306302,1.8,81.695113,124.6809418,1.0926753,12.2771426,13.7640237,6420.3463337,7836.3029114,21.6955117,569.3322723,522.9511915,1033.0239256,23.0914827,26.8271256,2.1276979,81.7733466),(40324,'femur',248,7,14,174.8435516,81.6516778,125.1493635,1.8,82.2195469,124.5393827,1.4240523,13.7959874,13.2396389,7661.0857853,8374.5570053,28.5175753,632.5366605,555.3126128,1125.8224857,24.9144945,27.4597192,2.7901479,84.3514746),(40325,'femur',248,7,15,211.6303702,82.6439341,123.7998137,1.8,82.8240037,124.120161,-1.0916365,14.6411986,13.6700826,8813.3568813,11732.9038759,27.7746476,858.2906372,601.9559702,1402.7963265,25.5339035,28.4925591,2.7386811,88.3966492),(40326,'femur',248,7,16,222.878306,82.8800589,123.4237198,1.8,83.1796584,123.8862696,-1.0429238,15.5486659,14.4229727,10076.0523571,12415.7650793,27.7219657,860.8326004,648.0332402,1444.9528805,26.3340745,29.6827027,2.75571,92.398638),(40327,'femur',248,7,17,245.1732645,83.1329611,123.085829,1.8,83.5234694,123.5737601,-0.1271024,14.5351206,15.4395121,12496.5216022,13329.4919868,0.6565823,863.336348,859.7466775,1551.8877055,28.1414606,30.9852423,2.8023,96.4438126),(40328,'femur',248,7,18,258.8598503,83.4154454,123.4068511,1.8,83.6789805,123.5733113,0.2594921,14.8486217,16.8591758,12966.4641868,15392.9794516,2.8404802,913.0327375,873.2436224,1645.9455753,28.5298554,32.1376751,2.6241049,99.3779057),(40329,'femur',248,7,19,267.6150892,83.5941218,123.7434453,1.8,83.749962,123.6409168,0.3046339,14.8691638,17.5222505,13375.5037849,16883.7605703,4.0127273,963.5611895,899.5464695,1693.3372378,28.8046329,33.0971348,2.6256671,102.6068902),(40330,'femur',248,7,20,266.0992063,83.3600575,123.6156578,1.8,83.8535963,123.6235204,0.1804408,15.1215173,18.1286997,13546.4849403,17934.7050522,1.4283784,989.2990336,895.841644,1648.5392603,29.1526755,34.37504,2.4980915,111.9736545),(40331,'femur',248,7,21,267.8002804,83.4953974,123.7148148,1.8,84.0538573,123.7558631,0.187393,15.2141633,18.6008104,13933.3951063,19185.849141,1.5490912,1031.4523247,915.8173762,1678.9390726,29.4446788,35.7674934,2.4668517,112.9804761),(40332,'femur',248,7,22,269.9858171,83.5266628,123.7241128,1.8,84.2460421,123.870069,0.1619285,15.4491878,19.1908878,14335.8085455,21063.9532266,1.1695998,1097.6018145,927.9328275,1726.3906678,29.6698609,36.9631594,2.5213432,117.8418409),(40333,'femur',248,7,23,274.9250529,83.9101327,123.7438275,1.8,84.5320823,123.9937482,0.1809012,15.5947281,20.3302506,14875.7098329,23776.3545731,1.4832131,1169.5062235,953.8935031,1840.8637571,30.0220528,38.1624876,2.5161076,122.5989459),(40334,'femur',248,7,24,281.4401488,84.596307,123.828523,1.8,85.1333597,124.1335609,0.1908224,15.738703,24.5874487,15340.7510939,27601.891979,1.6873908,1122.600897,974.7150739,1719.1291332,30.2016917,39.1110506,2.520066,128.6756519),(40335,'femur',248,7,25,291.9186176,85.0253016,124.0344567,1.8,85.3775068,124.2707147,0.2014892,15.649582,22.3435777,16224.4161257,30862.7972226,1.948629,1381.2826979,1036.7315989,2075.758854,30.2915111,40.9670948,2.7201734,134.7523578),(40336,'femur',248,7,26,310.2950184,85.9508018,124.363025,1.8,86.1142915,124.4715806,0.2235566,15.6895765,23.2205008,17447.0184738,36482.1548411,2.5418601,1571.1183499,1112.0133476,2298.7402195,30.3674605,42.8073637,2.8039704,140.1171334),(40337,'femur',248,7,27,334.074864,86.9209385,124.7605483,1.8,87.2701354,124.6465545,0.2039581,15.4306152,33.9169531,19206.1601324,43742.3494143,2.2842519,1289.6898299,1244.678835,1787.4789925,30.4218097,44.5240541,2.75571,151.2458356),(40338,'femur',248,7,28,381.0456357,91.4209147,124.6229911,1.8,92.466114,124.615789,0.0806163,15.4186836,36.2984586,20358.0578637,84844.4764736,0.4118417,2337.4126551,1320.3499352,2852.6507452,30.6661125,46.6226331,2.7936091,155.1435646),(40339,'femur',248,7,29,459.4174612,96.8704854,124.354674,1.8,95.853149,124.5329867,0.0603519,15.3695708,33.527166,21376.3746161,130653.7826108,0.2785547,3896.9527788,1390.8244317,4484.0863459,30.2121004,63.2824087,3.0804445,199.7194473),(40340,'femur',248,7,30,516.9470445,99.3512811,124.4678109,1.8,97.6230622,124.6274084,0.0390245,16.3268431,32.4766152,25203.2317377,156253.1586439,0.131144,4811.2513493,1543.6684011,5544.1576116,30.6918147,64.6262751,3.0683904,202.8009861),(40341,'femur',248,7,31,540.4209609,100.6029487,124.5082462,1.8,98.7850083,124.7371703,0.0303596,17.1912235,32.8636569,28537.1719868,169070.607101,0.0829926,5144.607234,1659.9849375,5957.6314471,31.6954222,65.4269651,3.0824512,208.6870606),(40342,'femur',248,7,32,551.1235055,101.492069,124.4316855,1.8,99.6817695,124.8249316,0.0292846,17.7521777,33.3409686,30846.789772,176206.9835453,0.0787503,5284.9989278,1737.6341243,6133.3678976,32.5694333,65.5890266,3.0497465,212.4805298),(40343,'femur',248,7,33,556.740172,102.4254936,124.3234323,1.8,100.6764322,124.8661763,0.0299761,18.7332737,34.2486252,33300.6354091,179765.0811445,0.0833531,5248.8261984,1777.6196506,6173.2344101,33.6397971,65.9791486,3.0568289,217.0901892),(40344,'femur',248,7,34,562.0691487,102.96699,124.3264838,1.8,101.2928132,124.9471875,0.031912,19.5765422,34.743316,35116.8863396,182609.4386167,0.0953672,5255.9588347,1793.8247756,6250.8466974,34.6359166,65.9119543,3.0698207,218.7657554),(40345,'femur',248,7,35,566.9714021,103.2483352,124.3934732,1.8,101.8430709,125.0263474,0.0372258,19.9404536,34.6582155,36630.6010839,183146.0514446,0.1308869,5284.3474114,1836.9993858,6306.3270069,35.1317059,65.9441601,3.0633215,221.1353638),(40346,'femur',248,7,36,569.1759615,103.4650913,124.4427773,1.8,102.2761156,125.0689136,0.0401577,20.7023997,34.4579957,37728.0339103,182151.6517674,0.1528973,5286.1940406,1822.3990712,6346.3786213,36.0088068,65.5510134,3.056274,225.1373526),(40347,'femur',248,7,37,564.9665807,103.3725927,124.5177879,1.8,102.5253914,125.1628114,0.0465416,21.015112,33.9222196,38006.2626357,177744.1515448,0.2038175,5239.7559422,1808.5205878,6341.1240678,36.4074746,65.05482,3.0688734,225.1373526),(40348,'femur',248,7,38,564.1101131,103.2573513,124.5824876,1.8,102.5326196,125.2685478,0.0489864,21.3237788,33.6693292,38313.150963,177029.2420616,0.2254319,5257.8785056,1796.7336513,6395.3802055,36.5754561,64.9184485,0.0331005,225.8924688),(40349,'femur',248,7,39,533.4889888,101.2986694,124.8421084,1.8,101.9249107,125.3472701,0.077921,20.8444649,31.8231449,37426.1096147,153257.0264553,0.5387712,4815.8982109,1795.4939004,5917.3288958,36.5754561,63.8777135,0.094314,221.951554),(40350,'femur',248,7,40,472.737469,97.7544619,125.4860867,1.8,97.8302596,126.0502765,0.2237572,18.4632388,28.5022094,32776.162961,108858.724476,3.8793839,3819.3082898,1775.2119956,4262.5125394,31.9655418,54.2497054,3.0781857,195.3793815),(40351,'femur',248,7,41,457.6087971,96.7989226,125.624805,1.8,97.1077088,126.1499767,0.280923,17.4917831,26.294197,32077.1524876,98310.0911781,5.8622316,3738.8512507,1833.8411994,4906.5413583,31.1108211,51.7412869,3.0584514,191.4816525),(40352,'femur',248,7,42,448.1099398,96.0600386,125.621498,1.8,96.6014207,126.150199,0.3206164,16.7978937,25.1461659,31416.8957216,91161.3649796,7.4177527,3625.259031,1870.2878018,4777.1034411,31.0500452,49.9344786,3.0813209,184.1464195),(40353,'femur',248,7,43,440.466408,95.5017307,125.6664713,1.8,96.1593633,126.1887178,0.3549751,16.6151389,24.2285524,30896.4838332,85361.4519785,8.8682641,3523.1758981,1859.538097,4421.0030756,30.9760738,48.863669,2.5438343,180.3529503),(40354,'femur',248,7,44,437.0918426,94.9726992,125.6618691,1.8,95.7179751,126.1800631,0.375603,16.6186018,23.5581277,30827.0004905,80569.851638,9.803014,3420.0447821,1854.9695638,4216.7252151,31.0473029,48.3852347,2.5585161,175.4483997),(40355,'femur',248,7,45,435.5743932,94.5681151,125.7549532,1.8,95.2037907,126.1585746,0.3886412,16.4003662,23.487992,31020.8036441,76648.8783637,10.4239449,3263.3218919,1891.4701874,4097.3470038,30.9431308,47.6701994,2.5485901,170.0836241),(40356,'femur',248,7,46,432.7309519,94.1561115,125.8343255,1.8,94.6340041,126.1260893,0.4027772,16.2017346,23.5932944,31138.3926991,72297.8392769,11.0811021,3064.3384594,1921.9172186,3996.3559302,30.9431308,46.9619695,2.5713547,163.2086161),(40357,'femur',248,7,47,444.275921,93.7522939,125.9585022,1.8,94.0193333,126.164841,0.3979802,15.7927097,23.3038251,31976.4474853,69316.3885872,11.1217521,2974.4639849,2024.760043,3973.9321583,30.9442217,46.1209573,2.5484221,141.9401452),(40358,'femur',248,7,48,450.0372158,93.5323294,126.1246929,1.8,93.8225287,126.2238301,0.4232756,15.6478001,23.5096648,32457.0656534,65723.9180764,12.6546651,2795.6127223,2074.2254766,3897.8095759,31.1157205,45.6562456,2.5300957,135.967699),(40359,'femur',248,7,49,431.3142108,93.6360177,126.0814178,1.8,93.6762865,126.1482859,0.4862889,15.9018004,23.7546244,31966.7957931,60278.624544,15.7008706,2537.5532617,2010.2626721,3714.585155,31.0940236,45.3050932,2.5246508,130.7935549),(40360,'femur',248,7,50,419.3199151,93.6819516,125.936196,1.8,93.6012994,126.0943011,0.5216626,16.0819872,24.025639,31655.0971812,57512.4451699,17.3546121,2393.7946143,1968.3573121,3582.7811297,31.062855,45.2071802,2.5113987,129.9341789),(40361,'femur',248,7,51,406.3143408,93.6871211,125.7784494,1.8,93.6204473,126.0339386,0.547266,16.2150636,24.1807525,30904.6175836,55008.9322945,18.3362075,2274.9057224,1905.9202218,3478.5092071,30.9431308,44.9553049,2.5191209,129.0748029),(40362,'femur',248,7,52,398.6689627,93.7430439,125.6498009,1.8,93.6082286,125.9543286,0.5745815,16.2705198,24.0985603,30232.0270134,53432.2830608,19.6261004,2217.2396315,1858.0861197,3421.5020699,30.9391603,44.5717166,2.5482425,128.3196867),(40363,'femur',248,7,53,390.339328,93.7387368,125.4166907,1.8,93.6649481,125.8601761,0.6012177,16.4739419,24.3358274,29614.2704816,51253.5836049,20.8152759,2106.0957892,1797.6432557,3285.4036714,31.0429123,44.3641155,2.5912067,129.4307681),(40364,'femur',248,7,54,378.9418406,93.7023718,125.239345,1.8,93.5712111,125.6510989,0.6296747,16.5707844,24.1530239,28940.5868008,49043.6488548,21.9016916,2030.5386646,1746.4826063,3219.5784148,31.0923576,43.8639687,2.5726095,126.2881553),(40365,'femur',248,7,55,376.0468702,93.663737,125.0053433,1.8,93.6241827,125.5778445,0.6431324,16.5211893,24.0027999,28446.7795667,47152.297676,22.5406305,1964.4498933,1721.836063,3139.5490055,30.9417276,43.1831096,2.5977602,125.0296283),(40366,'femur',248,7,56,366.8198132,93.6786961,124.6975869,1.8,93.6249769,125.4064619,0.6551736,16.726056,23.6762361,27701.6755491,44793.5901063,22.6965302,1891.9219206,1656.1989034,3057.9895737,31.0551251,42.5304305,2.6236997,123.1023567),(40367,'femur',248,7,57,364.532841,93.6122969,124.4738844,1.8,93.6247778,125.1901192,0.6652624,16.6239507,23.2742127,27247.8649177,42889.9925513,23.148859,1842.8117454,1639.072768,3010.6116271,30.872038,41.5710649,2.6224465,120.7759341),(40368,'femur',248,7,58,362.8822329,93.6112743,124.2451545,1.8,93.6560168,124.903392,0.6792011,16.624454,22.8265027,26869.5187615,41214.0214858,23.8655318,1805.5337744,1616.2647324,2980.749876,30.8454268,40.827144,2.6120031,118.4495115),(40369,'femur',248,7,59,358.295476,93.559489,123.9280646,1.8,93.5821159,124.5953979,0.6925631,16.5147218,22.2546036,26488.5639487,38650.0965228,24.3460211,1736.7236551,1603.9364336,2926.7587349,30.611004,39.8684709,2.610415,116.1230889),(40370,'femur',248,7,60,355.0048342,93.614706,123.6936253,1.8,93.6817474,124.349097,0.71375,16.4572388,21.424706,25915.9632905,36441.5642999,25.3589889,1700.9131567,1574.7455286,2910.2753419,30.4875804,38.4036279,2.4353936,112.9804761),(40371,'femur',248,7,61,351.2326391,93.5653666,123.4840614,1.8,93.594702,124.128666,0.743092,16.2255163,20.3965229,25465.1564087,34820.8665524,26.7957876,1707.1962083,1569.4512221,2948.1928494,30.149782,37.1475154,2.4216745,109.6904177),(40372,'femur',248,7,62,347.234354,93.5924433,123.1453401,1.8,93.5710484,123.7673315,0.7804692,15.8766977,19.3316085,24880.5912351,32692.5780418,28.6509507,1691.1462923,1567.1137458,2962.9363077,29.7191629,35.9348668,2.2885015,107.1122897),(40373,'femur',248,7,63,342.38542,93.6231079,122.7928175,1.8,93.6197725,123.4703498,0.8231871,15.8648253,18.3451199,24312.6052161,30995.1124013,30.6864605,1689.5562747,1532.4849046,3002.4356224,29.472024,34.7702298,2.2686991,104.429902),(40374,'femur',248,7,64,340.8013913,93.6511645,122.5626772,1.8,93.5879805,123.1151658,0.8658376,15.7643117,17.8288426,23824.3241566,29779.6265388,32.9494114,1670.3062083,1511.2822279,2987.7629918,29.1681887,34.1189589,2.2042222,103.3188206),(40375,'femur',248,7,65,334.6596991,93.6973553,122.0876307,1.8,93.6390619,122.7333251,0.9286619,15.5403876,17.1243357,23077.3273772,28006.2644999,35.7701843,1635.4657519,1484.9904591,2955.1797238,28.8643534,33.2862629,2.2556176,101.6000686),(40376,'femur',248,7,66,337.9544812,93.7846011,121.8699341,1.8,93.7793166,122.4222018,1.0128744,15.2555071,16.5633593,22666.3723624,27382.2534085,40.5381902,1653.1823625,1485.782947,2979.4669102,28.8361663,32.8282757,2.2169152,100.3847274),(40377,'femur',248,7,67,331.8489321,93.8219388,121.5396057,1.8,93.8398645,122.142006,1.0516243,14.9774484,16.2882287,22050.2876333,26559.668396,41.6926049,1630.6050753,1472.232589,2952.5667316,28.5605181,32.4293479,2.1293956,99.273646),(40378,'femur',248,7,68,330.2309423,93.8949788,121.2370546,1.8,93.7899324,121.8908215,1.0917692,14.8207662,16.0176439,21461.6637171,26084.6849695,43.3459143,1628.4969932,1448.0805834,2924.5459163,28.5193063,31.9821833,2.1066076,99.0219406),(40379,'femur',248,7,69,328.0089268,93.9588977,120.9206552,1.8,93.8845581,121.606511,1.1414198,14.5244987,15.7649771,20942.0697491,25444.6774332,45.1936688,1614.0002752,1441.8445824,2875.8113957,28.4080141,31.7649597,2.094976,98.0583048),(40380,'femur',248,7,70,328.3197236,93.9880136,120.6336417,1.8,93.9064082,121.1760532,1.1620171,14.2767012,15.6128646,20536.706235,24913.1511405,46.0743179,1595.6809821,1438.476998,2846.2926255,27.9528475,31.4729961,2.13229,97.3031886),(40381,'femur',248,7,71,326.0739298,94.0812494,120.3916792,1.8,94.0780371,121.0095948,1.1811668,14.1106397,15.42875,20100.4047977,24393.4496974,46.504513,1581.0386256,1424.4857277,2845.0547342,27.8736819,31.1516391,1.9974238,96.4438126),(40382,'femur',248,7,72,325.332941,94.1136122,120.1647928,1.8,94.1741932,120.7559955,1.2092616,13.9007126,15.177048,19833.9527861,23884.0898826,47.4383736,1573.6979892,1426.8299269,2810.6769897,27.7605052,30.8059627,2.0968627,95.7318822),(40383,'femur',248,7,73,323.8641113,94.179534,119.8568958,1.8,94.2050736,120.5027974,1.2223077,13.7741318,15.1223357,19439.9617456,23434.2165098,47.6832134,1549.6426571,1411.3384491,2773.3265904,27.5821397,30.655762,2.1160235,95.836142),(40384,'femur',248,7,74,324.6525449,94.2646623,119.6467445,1.8,94.2001333,120.1888196,1.241,13.7305198,14.9996402,19152.8378707,23064.4456703,48.433884,1537.6665969,1394.909894,2785.905597,27.4855204,30.435138,2.103952,94.6208008),(40385,'femur',248,7,75,324.4179506,94.2765637,119.3865249,1.8,94.1612071,119.8797883,1.266653,13.7520257,14.9557037,18932.0636089,22669.9494934,49.2203767,1515.8062703,1376.6745352,2756.2464948,27.2927037,30.2891945,2.1233807,93.657165),(40386,'femur',248,7,76,325.13421,94.3655405,119.1437743,1.8,94.1887473,119.6526474,1.2610094,13.568306,14.8817251,18706.1122076,22500.069176,49.1528676,1511.9261394,1378.6623202,2737.9443046,27.290522,30.1915068,1.996246,94.0131302),(40387,'femur',248,7,77,323.6747238,94.4500718,118.9823446,1.8,94.3186578,119.4285965,1.2765864,13.5116605,14.7548792,18483.451821,22162.0347789,49.409453,1502.0139717,1367.9630158,2704.2662757,27.0590719,29.9243065,1.9379702,93.4054596),(40388,'femur',248,7,78,322.6446463,94.4553241,118.739686,1.8,94.3538548,119.2537347,1.3030571,13.5590503,14.6907615,18181.0202897,21784.5880572,50.0105824,1482.8767116,1340.8771197,2667.2895531,26.9430612,29.8470824,1.9700171,93.1537542),(40389,'femur',248,7,79,322.6212037,94.5236718,118.582708,1.8,94.4189442,119.1720057,1.3294912,13.459112,14.5003458,17894.6751203,21562.2095497,50.6995599,1487.0134708,1329.5583807,2643.640173,26.8219112,29.6827027,1.956679,92.1901184),(40390,'femur',248,7,80,324.4840824,94.5449296,118.4077803,1.8,94.4592795,118.8905948,1.3480853,13.4509877,14.4825468,17790.4652218,21497.7348934,51.4423256,1484.3891218,1322.614044,2627.5112959,26.7131627,29.523662,1.9431948,92.1901184),(40391,'femur',248,7,81,321.1746417,94.5446654,118.1230379,1.8,94.4555415,118.5619091,1.3788393,13.4765521,14.4489857,17407.766725,21074.5406432,51.5808004,1458.5481027,1291.7077487,2586.5278493,26.5225277,29.3700471,1.929567,91.5824478),(40392,'femur',248,7,82,317.7646606,94.6114421,118.0031471,1.8,94.5412253,118.4861528,1.3989097,13.4409448,14.4097096,17236.5881161,20892.1833171,51.4114002,1449.8684512,1282.3940858,2552.5340241,26.6564143,29.2976643,1.497399,91.6867076),(40393,'femur',248,7,83,318.0525184,94.6240224,117.8959592,1.8,94.5592598,118.312053,1.4128892,13.445255,14.3887585,17074.038933,20837.1672294,51.6979466,1448.1560221,1269.8932788,2549.0006811,26.520346,29.2850577,1.9622015,91.3307424),(40394,'femur',248,7,84,319.3404089,94.6256503,117.7349619,1.8,94.4842259,118.12928,1.4126644,13.2640833,14.4794852,16944.2964043,20801.9092064,51.9035689,1436.6470124,1277.4570269,2527.4221198,26.329711,29.2472054,1.3935709,90.7230718),(40395,'femur',248,7,85,321.9183721,94.6372928,117.5503648,1.8,94.509161,117.9159054,1.4246306,13.2344139,14.620364,16825.6114664,20693.1188428,52.5149354,1415.3627655,1271.3529755,2495.4163077,26.3286201,29.2472054,1.7480217,90.4713664),(40396,'femur',248,7,86,323.965379,94.5931115,117.3771489,1.8,94.4952656,117.6528878,1.4386644,13.2657546,14.7149375,16693.792521,20663.6573891,53.0570265,1404.2640248,1258.4125843,2458.0848846,26.1379852,29.4202952,1.4536876,91.079037),(40397,'femur',248,7,87,329.194095,94.5981829,117.2368932,1.8,94.554523,117.4907143,1.4508398,13.2529748,14.8361916,16688.7366522,20701.0767742,54.0799683,1395.3093444,1259.2445814,2448.8094573,26.1379852,29.4735901,1.4392082,90.8273316),(40398,'femur',248,7,88,330.5516421,94.6109923,117.1000674,1.8,94.623101,117.3583152,1.4569128,13.1804868,14.6603087,16674.1562498,20611.3747186,54.3805113,1405.930469,1265.0637659,2477.3335183,26.2260719,29.1745179,1.408069,90.4713664),(40399,'femur',248,7,89,328.4525466,94.5924509,116.9615711,1.8,94.5657654,117.1747809,1.4654115,13.1495703,14.7728663,16589.3710135,20522.8012659,54.1363754,1389.2227017,1261.5903536,2455.3185833,26.1368943,29.3323044,1.482789,90.5756262),(40400,'femur',248,7,90,328.7393973,94.5877713,116.8375774,1.8,94.5216574,117.012513,1.471234,12.9804878,14.9536582,16518.5248647,20495.2236225,54.2485784,1370.5825885,1272.5658047,2438.1972575,26.210968,29.3731901,1.6733762,90.4713664),(40401,'femur',248,7,91,329.9169004,94.5775999,116.7367213,1.8,94.5070351,116.9300979,1.4725275,12.9796374,15.0575772,16411.6888237,20486.9096224,54.4568689,1360.5714446,1264.4181239,2414.8652166,26.1368943,29.4735901,1.7023845,89.9679556),(40402,'femur',248,7,92,332.2654726,94.5629309,116.6129853,1.8,94.4794413,116.8354423,1.4803468,12.9768856,14.8078996,16331.3924546,20403.9539057,54.9257626,1377.9100668,1258.498611,2433.000149,26.1589261,29.2976643,1.497399,89.9679556),(40403,'femur',248,7,93,332.6793834,94.5324943,116.4986586,1.8,94.4138308,116.6923796,1.476258,12.9992176,14.8782827,16280.302602,20254.7279511,54.9524855,1361.3619532,1252.406349,2422.066411,26.0912726,29.3323044,1.482789,89.7162502),(40404,'femur',248,7,94,329.848195,94.5364502,116.3770545,1.8,94.4601537,116.6019488,1.4769188,12.9835155,14.6126782,16174.1884753,20051.1129544,54.4916296,1372.1723467,1245.7480035,2430.6787191,25.9451685,29.1079925,1.4226363,89.360285),(40405,'femur',248,7,95,327.7896626,94.5350378,116.3125459,1.8,94.4602908,116.5341286,1.4851257,12.9753941,14.6879122,16038.4455214,20047.403979,54.2316242,1364.8913243,1236.0661563,2411.0820984,26.0912726,29.1745179,1.408069,89.1085796),(40406,'femur',248,7,96,329.9817453,94.5054604,116.2557127,1.8,94.3612079,116.4429865,1.4906611,12.9630897,14.7881048,16000.5852925,20284.8214855,54.6445412,1371.6985188,1234.318797,2416.1935701,25.9564733,29.4202952,1.4536876,89.7162502),(40407,'femur',248,7,97,330.8987498,94.4346889,116.1406534,1.8,94.1900596,116.3170533,1.497464,12.7848778,15.3726826,15776.0691776,20643.1213135,54.8537481,1342.8444411,1233.9632335,2366.3982176,25.78128,29.9582221,1.7147218,89.82051),(40408,'femur',248,7,98,332.915824,94.4336953,116.1519971,1.8,94.1722548,116.2710033,1.5038032,12.7696824,15.3909688,15740.1182048,20960.0917675,55.2373173,1361.8435655,1232.6162668,2380.3497807,25.78128,30.2281767,1.670465,89.82051),(40409,'femur',248,7,99,335.1182014,94.4304884,116.054849,1.8,94.1797416,116.181353,1.5107005,12.7479499,15.4853043,15735.1165343,21178.9777945,55.6515625,1367.6823786,1234.3252564,2379.3641279,25.78128,30.3257462,1.6986662,89.82051),(40410,'femur',248,7,100,335.7199891,94.4566061,115.9442674,1.8,94.2359495,116.0525732,1.5167556,12.7778292,15.59124,15772.8183166,21313.7431338,55.7900845,1367.0332241,1234.3895066,2377.3451585,25.78128,30.3835299,1.7126934,90.0722154),(40411,'femur',248,7,101,335.2627737,94.4680412,115.8550627,1.8,94.2626533,115.9776768,1.5156291,12.7929747,15.7276424,15785.4660433,21446.0369418,55.7072438,1363.5887928,1233.9167696,2358.6358536,25.78128,30.5924579,1.7544187,90.9315914),(40412,'femur',248,7,102,335.551023,94.4572495,115.8253574,1.8,94.2924078,115.9095928,1.5121407,12.780461,16.166291,15806.3489188,21692.7633064,55.7329818,1341.8515955,1236.7589022,2316.4123549,25.7360239,31.1782987,1.6951513,92.7546031),(40413,'femur',248,7,103,335.5288672,94.4468401,115.7606522,1.8,94.2996321,115.8312761,1.508426,12.7730019,16.2345526,15855.8594653,21755.7594496,55.7042219,1340.0898705,1241.357328,2314.0051612,25.78128,31.2345051,1.7088024,92.7546031),(40414,'femur',248,7,104,338.2780903,94.4418092,115.6559523,1.8,94.2618895,115.6687747,1.5024729,12.7900059,15.9737687,15862.415397,21783.3058565,56.1169052,1363.6923311,1240.2195564,2345.2646235,25.7420017,30.9405198,1.7382281,92.398638),(40415,'femur',248,7,105,340.2010583,94.4447799,115.534211,1.8,94.2914121,115.5216263,1.4992841,12.7880721,16.0692445,15879.1726763,21730.5991099,56.4107057,1352.3099412,1241.7174841,2335.1193134,25.78128,31.1782987,1.6951513,92.7546031),(40416,'femur',248,7,106,340.8370868,94.4256985,115.3837496,1.8,94.2553888,115.388008,1.5021438,12.8178917,15.8182789,15924.5786186,21616.2045351,56.5388645,1366.5332802,1242.3711284,2361.1685493,25.7420017,30.8718194,1.7245039,92.398638),(40417,'femur',248,7,107,340.2615392,94.3773928,115.2188503,1.8,94.2293844,115.2404172,1.524219,12.8042112,15.5168008,15928.5538256,21344.4499439,56.5873156,1375.5702783,1244.008988,2382.167521,25.78128,30.4472684,1.7266645,92.0426728),(40418,'femur',248,7,108,338.9979864,94.3269974,115.0379941,1.8,94.2139699,115.0919308,1.5504038,12.7478854,15.5880842,15991.0087182,21105.290311,56.4761719,1353.9374061,1254.4048081,2374.1852893,25.78128,30.2281767,1.4711277,92.2943782),(40419,'femur',248,7,109,340.4249103,94.3242944,114.9121724,1.8,94.2116099,114.9473342,1.5387887,12.7912231,15.309592,16181.4299426,21122.003123,56.679378,1379.6581377,1265.041646,2421.3416407,25.78128,30.4108627,1.1640493,92.0426728),(40420,'femur',248,7,110,340.0170979,94.3108084,114.7495904,1.8,94.1801314,114.8460708,1.536844,12.8208333,15.4590446,16249.4170755,20962.285209,56.6042149,1355.9884003,1267.4228472,2397.9140318,25.78128,30.2434427,1.1770981,92.2943782),(40421,'femur',248,7,111,340.9431102,94.2821282,114.5897358,1.8,94.1245375,114.6682277,1.5485212,12.7996856,15.1969677,16303.233339,20813.9417076,56.7956615,1369.6115028,1273.7213876,2406.3435403,25.78128,30.1762146,1.2220253,91.6867076),(40422,'femur',248,7,112,341.0320691,94.2425819,114.4537519,1.8,94.1211687,114.5682857,1.5533363,12.825543,15.314732,16338.1677736,20707.0132567,56.8213526,1352.0976531,1273.8772776,2392.7560544,25.78128,30.081229,1.1902899,91.6867076),(40423,'femur',248,7,113,341.4222016,94.2104678,114.2444521,1.8,94.1319869,114.2814735,1.5612733,12.8216831,15.5114003,16267.9207831,20542.2652407,56.8985399,1324.3333856,1268.7820086,2366.9876761,25.78128,30.2434427,1.1770981,92.398638),(40424,'femur',248,7,114,343.9479644,94.2121383,114.1652605,1.8,94.0851166,114.2274753,1.5614838,12.8224085,15.1931495,16298.8215057,20725.658085,57.3196895,1364.1449416,1271.1201265,2403.0597669,25.78128,29.9243065,1.2036225,91.938413),(40425,'femur',248,7,115,345.8161582,94.2379106,114.0415875,1.8,94.122792,114.1372694,1.5689028,12.7628448,15.2982832,16359.6422364,20775.0434978,57.6358197,1357.9983574,1281.817844,2401.3323841,25.78128,29.5986112,1.3363807,89.360285),(40426,'femur',248,7,116,344.3608682,94.2617214,113.8853295,1.8,94.1690365,113.9902565,-1.5641448,12.721615,15.4600555,16458.5887796,20413.263006,57.3909389,1320.3874368,1293.7499526,2375.9832882,25.78128,29.5330411,1.4247841,89.360285),(40427,'femur',248,7,117,341.4279084,94.2888497,113.6680414,1.8,94.2441141,113.7321107,-1.5556038,12.7089207,15.259027,16472.3489845,19807.8805061,56.891518,1298.109014,1296.1249371,2369.7547002,25.78128,29.1079925,1.4226363,88.7526144),(40428,'femur',248,7,118,340.1644676,94.2878157,113.4985442,1.8,94.3062507,113.6033334,-1.5599859,12.6984505,14.9793048,16468.7012563,19375.7833298,56.6874527,1293.5035093,1296.9063657,2392.9306612,25.78128,28.5184673,1.4651307,88.6483546),(40429,'femur',248,7,119,337.7679471,94.2918582,113.3425162,1.8,94.3543078,113.436005,-1.5650987,12.6983414,14.7078009,16465.6298942,19009.8408538,56.2928304,1292.5005558,1296.6756352,2410.4167128,25.78128,28.1404636,1.6932574,88.2923894),(40430,'femur',248,7,120,334.6638953,94.2862144,113.213431,1.8,94.3785352,113.2994265,1.5661295,12.7269711,14.4089027,16435.3455124,18682.3852253,55.776101,1296.5862543,1291.3791779,2425.4103829,25.78128,27.8337015,1.7257931,87.9364242),(40431,'femur',248,7,121,330.9369071,94.3050835,113.1007118,1.8,94.4209616,113.1478748,1.5477077,12.7851889,14.1280856,16421.6886242,18362.9934858,55.1267535,1299.7510038,1284.4306652,2435.5761987,25.78128,27.6406638,1.7742894,87.3287536),(40432,'femur',248,7,122,329.858098,94.3141068,112.9910983,1.8,94.4142712,113.077514,1.5475552,12.7842307,14.2177355,16431.3536449,18161.4294066,54.9466596,1277.3784806,1285.2829423,2423.1880592,25.78128,27.5570408,1.7590178,87.3287536),(40433,'femur',248,7,123,326.8486,94.2862965,112.8757886,1.8,94.3425863,112.9400985,1.522262,12.9139525,13.9819458,16342.5442068,17978.422363,54.3465479,1285.831217,1265.4951483,2424.7533186,25.78128,27.5033887,2.0763774,87.3287536),(40434,'femur',248,7,124,323.8982402,94.2844488,112.7889324,1.8,94.3024137,112.8489579,1.5011095,12.9908823,14.0719927,16267.8974807,17794.6590319,53.7213092,1264.5443586,1252.2550125,2405.171714,25.78128,27.5134565,2.2455373,87.580459),(40435,'femur',248,7,125,322.526538,94.2894939,112.7185424,1.8,94.2707322,112.7828995,1.509327,12.951405,14.1069481,16261.6440133,17713.475169,53.5515687,1255.6560782,1255.589183,2405.7199211,25.78128,27.5603906,2.1112158,87.3287536),(40436,'femur',248,7,126,319.9820883,94.2706808,112.666091,1.8,94.2224423,112.7071306,1.513277,12.9526593,14.1082517,16168.9158912,17597.9310125,53.1541004,1247.350231,1248.3085922,2393.3232983,25.78128,27.5033887,2.0763774,87.3287536),(40437,'femur',248,7,127,317.0755925,94.2669688,112.6206211,1.8,94.2196759,112.6433505,1.506077,12.9793387,13.8627905,16061.6783878,17502.0298085,52.6248913,1262.518526,1237.4804883,2385.4596116,25.78128,27.4227137,2.1892243,86.9727884),(40438,'femur',248,7,128,315.1582194,94.2702955,112.5827113,1.8,94.2341431,112.6106913,1.4821291,13.0529278,13.9049274,16020.9765346,17443.91715,52.114495,1254.5133542,1227.3856712,2387.3970725,25.78128,27.5033887,2.0763774,86.9727884),(40439,'femur',248,7,129,311.619052,94.2719589,112.4910036,1.8,94.2181098,112.5190668,1.4568119,13.1166019,13.9235946,15880.6421931,17248.3826822,51.2646435,1238.7880521,1210.7283861,2361.2654555,25.78128,27.5134565,2.2455373,87.2244938),(40440,'femur',248,7,130,310.3030751,94.2839914,112.445496,1.8,94.2327383,112.4627344,1.4234892,13.1818768,13.8948668,15871.9039218,17215.8314244,50.6030425,1239.0065862,1204.0701178,2361.3291043,25.78128,27.5871743,2.223643,87.2244938),(40441,'femur',248,7,131,309.9928377,94.3286508,112.4197876,1.8,94.330148,112.424238,1.3902649,13.2009183,13.8362021,15843.5961334,17175.4513653,49.9998267,1241.3414661,1200.1889426,2363.8983453,25.78128,27.5134565,2.2455373,87.580459),(40442,'femur',248,7,132,308.1612345,94.3524558,112.3866762,1.8,94.4183091,112.3595544,1.3403214,13.2434476,13.7844423,15764.2050393,17112.560551,48.6799849,1241.4401775,1190.3399683,2347.2920162,25.78128,27.5871743,2.223643,87.2244938),(40443,'femur',248,7,133,304.7148866,94.3436517,112.365031,1.8,94.4401997,112.2936965,1.2755617,13.2896001,13.7167433,15627.2237812,17034.3323356,46.4862743,1241.8641943,1175.8987229,2346.6678688,26.210968,27.5603906,2.1112158,87.580459),(40444,'femur',248,7,134,303.4427177,94.35288,112.3236219,1.8,94.4651197,112.2470547,1.2449814,13.2738425,13.616634,15614.1938421,17039.2235797,45.3924097,1251.3535689,1176.3130236,2338.9546042,26.210968,27.6506815,2.1458686,87.3287536),(40445,'femur',248,7,135,302.0138915,94.3814754,112.2764745,1.8,94.4824224,112.1583555,1.2293611,13.2473406,13.5149594,15612.1616338,17015.7787707,44.6921308,1259.0329194,1178.512892,2336.6191219,26.210968,27.5302279,2.1674567,87.580459),(40446,'femur',248,7,136,300.4099449,94.4013754,112.241035,1.8,94.5051869,112.1265698,1.2073682,13.2327395,13.5359077,15583.5584898,16986.8108996,43.7413716,1254.9443476,1177.6517231,2325.8327286,26.210968,27.6506815,2.1458686,87.580459),(40447,'femur',248,7,137,298.7659388,94.4059012,112.1872589,1.8,94.5294201,112.0536745,1.1591727,13.2197884,13.4978625,15557.6121947,16948.6180798,41.8233329,1255.6520011,1176.8427589,2327.8822103,26.210968,27.5603906,2.1112158,87.580459),(40448,'femur',248,7,138,296.6305884,94.4239748,112.1453648,1.8,94.5498447,111.9859351,1.1186775,13.1813033,13.4006732,15517.4632307,16846.3514352,40.0027347,1257.1272485,1177.2328445,2310.135175,26.210968,27.6740422,2.2018757,87.8321644),(40449,'femur',248,7,139,294.6921785,94.4459538,112.1294181,1.8,94.5929068,111.9419465,1.0605466,13.171737,13.5126145,15496.2925696,16749.6663843,37.3998843,1239.5577805,1176.4805613,2297.9042963,26.210968,27.5871743,2.223643,87.8321644),(40450,'femur',248,7,140,294.2789391,94.4772892,112.1353161,1.8,94.6177205,111.943157,1.0197437,13.1569314,13.6692629,15556.5609774,16705.8009189,35.6008599,1222.1435105,1182.3851995,2297.9447109,26.210968,27.5871743,2.223643,87.4761992),(40451,'femur',248,7,141,294.7357069,94.5116935,112.1158765,1.8,94.6712546,111.9371681,1.0201718,13.2588113,13.6706493,15649.9277026,16748.1492031,35.6748719,1225.1173194,1180.3416868,2329.6694888,26.210968,27.5871743,2.223643,87.4761992),(40452,'femur',248,7,142,292.4471121,94.4988889,112.1257534,1.8,94.7020739,111.9708862,1.0220536,13.2760229,13.7537424,15616.9264625,16713.3055541,35.479577,1215.1823892,1176.3256655,2327.1178303,26.210968,27.6740422,2.2018757,87.8321644),(40453,'femur',248,7,143,291.4954751,94.5070576,112.1229089,1.8,94.7115734,111.9404484,0.9814191,13.232768,13.7901526,15654.2478407,16724.922377,33.5724146,1212.816338,1182.9911789,2322.569985,26.210968,27.7306933,2.2794226,88.0838698),(40454,'femur',248,7,144,293.1982837,94.5409529,112.1176941,1.8,94.6686076,111.9023199,0.946877,13.1554462,13.9149138,15807.0408059,16825.5284206,32.1876193,1209.1723101,1201.5586992,2334.9226232,26.210968,27.7839065,2.257614,88.0838698),(40455,'femur',248,7,145,291.8429745,94.5570125,112.0427722,1.8,94.6813596,111.8592237,0.9321612,13.1518267,13.9342464,15762.9123032,16764.3390259,31.3568068,1203.1033831,1198.5340684,2329.2094951,26.210968,27.7839065,2.257614,88.0838698),(40456,'femur',248,7,146,290.3073976,94.5368599,112.0599851,1.8,94.7070807,111.8842346,0.9351248,13.1789844,13.9333289,15787.2024176,16770.9314506,31.3289545,1203.6557512,1197.9073601,2331.4081297,26.210968,27.85028,2.47649,88.0838698),(40457,'femur',248,7,147,290.9912066,94.5398834,112.0637668,1.8,94.6650407,111.9443615,0.8799122,13.2549966,13.9688174,15952.2345391,16781.1674541,28.8058101,1201.330572,1203.4883939,2343.1465939,26.210968,27.85028,2.235899,88.0838698),(40458,'femur',248,7,148,291.6567762,94.528919,112.0523483,1.8,94.6503377,111.9691837,0.875582,13.3194564,14.0083574,16121.1461762,16800.2324195,28.6647863,1199.3006719,1210.3456529,2348.6457852,26.210968,27.92972,2.2142974,88.0838698),(40459,'femur',248,7,149,290.53746,94.4980231,112.0789126,1.8,94.6341042,111.9664685,0.7818125,13.4033248,13.9057788,16171.9999456,16836.7866882,24.0378281,1210.7762505,1206.5662985,2354.5267507,26.640656,28.0122304,2.4213197,88.6915404),(40460,'femur',248,7,150,292.2881609,94.498411,112.10326,1.8,94.6453086,111.9937358,0.6597856,13.5835471,13.9647608,16295.1821341,17015.6420915,18.3023345,1218.4700001,1199.6264341,2372.7664502,26.640656,28.1174905,2.4644651,88.6915404),(40461,'femur',248,7,151,292.5820052,94.4449182,112.0934975,1.8,94.6372509,111.9846548,0.5785397,13.5964756,13.8255874,16347.5871488,17163.1631697,14.5799602,1241.4057163,1202.3400535,2393.8809537,26.640656,28.1896288,2.485897,89.0475056),(40462,'femur',248,7,152,294.7057182,94.4124089,112.1154091,1.8,94.6614176,112.0090205,0.4924323,13.6219163,13.7970811,16411.622219,17481.0139087,10.9783809,1267.0081282,1204.7954085,2421.5595072,26.640656,28.2746458,2.5072098,89.0475056),(40463,'femur',248,7,153,296.339094,94.3699842,112.1310538,1.8,94.675046,112.0449132,0.4708063,13.5883338,13.9925978,16512.7184335,17787.2003154,10.162333,1271.1864209,1215.2128913,2436.1522101,26.640656,28.4828375,2.549406,89.0475056),(40464,'femur',248,7,154,298.3379848,94.3535513,112.1746013,1.8,94.6481116,112.1723979,0.4353752,13.5829335,14.1942133,16691.5844085,18142.0670832,8.84441,1278.1312108,1228.8644702,2452.7276499,26.640656,28.5184673,2.6037571,89.4034708),(40465,'femur',248,7,155,300.2021503,94.3271994,112.1827092,1.8,94.6328588,112.2288603,0.405156,13.5982102,14.2791354,16862.5626619,18493.1580631,7.7734257,1295.117498,1240.0575108,2469.7683667,26.640656,28.7216779,2.4621788,90.2628468),(40466,'femur',248,7,156,301.0468686,94.3216018,112.1980492,1.8,94.6054492,112.2695269,0.3658347,13.6071948,14.4615802,17046.5361937,18877.8492496,6.4208246,1305.3794213,1252.7590338,2484.0956964,26.640656,28.9681105,2.5782764,90.5145522),(40467,'femur',248,7,157,305.1788719,94.323154,112.2100997,1.8,94.531217,112.2481229,0.3526872,13.600186,14.6040713,17287.2939201,19497.7235938,6.0687661,1335.0882194,1271.1071685,2517.2768338,27.070344,29.1238456,2.763826,91.2264826),(40468,'femur',248,7,158,305.2066785,94.2826865,112.1742037,1.8,94.562278,112.2516759,0.3167974,13.6265217,14.9004025,17381.6251184,19985.5202236,4.9366059,1341.2738464,1275.5731411,2506.3014633,27.070344,29.4516568,2.7367009,91.8341532),(40469,'femur',248,7,159,307.0274835,94.2879183,112.2009427,1.8,94.6119265,112.2397053,0.2935427,13.7489289,15.0343202,17512.2090993,20533.4762296,4.2840898,1365.7735035,1273.7144248,2528.3167333,27.070344,29.7013574,2.8931052,92.1901184),(40470,'femur',248,7,160,310.9563359,94.2237555,112.2175563,1.8,94.5298254,112.2930994,0.2691017,13.7207972,15.3184412,17711.612849,21153.3313126,3.6632982,1380.9062604,1290.8588745,2531.1668673,27.070344,30.1762146,2.7928217,92.5460836),(40471,'femur',248,7,161,316.637064,94.2109723,112.109284,1.8,94.3916251,112.1674116,0.2471209,13.821352,15.5369071,17855.3271791,21950.2264279,3.1576993,1412.7796661,1291.8654503,2560.3820148,27.070344,30.6407015,2.8864103,93.1537542),(40472,'femur',248,7,162,317.3205373,94.2228275,112.1468519,1.8,94.3561865,112.1079236,0.2172441,13.8685573,15.7281565,17962.5551582,22534.0379389,2.456971,1432.7195928,1295.1999793,2574.7700003,27.070344,31.0952829,2.9469071,94.0131302),(40473,'femur',248,7,163,319.6489678,94.234088,112.1302715,1.8,94.4074386,112.0910285,0.2000341,13.946982,15.8879796,18046.6256142,23285.4290792,2.1034389,1465.6003927,1293.9448565,2594.3004845,27.500032,31.4729961,2.8933027,94.7250606),(40474,'femur',248,7,164,322.3434168,94.2324701,112.0959261,1.8,94.4299744,112.0794184,0.1988138,14.1506641,16.2312527,18208.2130379,23894.46983,2.0957095,1472.127278,1286.7391167,2591.3188786,27.500032,32.0225685,2.938934,95.3327311),(40475,'femur',248,7,165,321.5191198,94.3184681,112.0652177,1.8,94.4630435,112.0434463,0.2029129,14.2859837,16.2426491,18266.5159821,24295.799809,2.1762373,1495.8027926,1278.6320019,2614.0847929,27.500032,32.3609555,2.9546134,95.9404017),(40476,'femur',248,7,166,321.6091418,94.4363157,112.0747197,1.8,94.5386537,111.9728796,0.2176405,14.4050417,16.3744016,18364.6058082,24810.4320072,2.4991295,1515.1962571,1274.8734935,2636.7368385,27.500032,32.7832515,2.9570499,96.5480723),(40477,'femur',248,7,167,321.7092906,94.5655906,112.0950752,1.8,94.5940121,112.0287957,0.2323094,14.5512115,16.3407113,18507.8570253,25329.7550178,2.8419683,1550.1011318,1271.9117563,2671.5656914,27.92972,33.1305888,2.9721796,97.7634135),(40478,'femur',248,7,168,325.3384799,94.5851592,112.0977617,1.8,94.5991988,112.0571881,0.2410464,14.652528,16.5339835,18740.8687419,26071.5712277,3.0899942,1576.8475374,1279.0194803,2706.1842791,27.92972,33.5542036,2.9743387,98.3710841),(40479,'femur',248,7,169,325.4032689,94.6702354,112.1176052,1.8,94.6444883,112.0608842,0.2525738,14.8682787,16.6750119,18770.5256221,26657.6460049,3.3868215,1598.6582856,1262.4545189,2681.1593405,27.92972,33.9779709,2.976444,99.2304601),(40480,'femur',248,7,170,328.4316776,94.8077388,112.214643,1.8,94.6972469,112.1397545,0.2666547,15.007954,17.015722,19045.6500872,27256.1033685,3.8007937,1601.818801,1269.0370807,2695.4797689,28.359408,34.2728372,3.0032417,100.4458013),(40481,'femur',248,7,171,333.5160451,94.8663146,112.2450982,1.8,94.6687488,112.1988124,0.2675567,15.2210354,17.1917356,19364.8212849,27895.6741095,3.8851616,1622.6211668,1272.2407365,2697.094976,28.359408,34.5918856,3.0295637,100.8017665),(40482,'femur',248,7,172,334.7295795,94.9708284,112.323243,1.8,94.7368483,112.2674874,0.2768672,15.3580615,17.4732467,19595.4130696,28388.2585456,4.1683134,1624.6699329,1275.9040666,2706.6007508,28.789096,34.8974383,2.968347,103.0239293),(40483,'femur',248,7,173,339.9518613,95.0918887,112.3858616,1.8,94.8210024,112.3182664,0.2912603,15.5732275,17.6856358,20035.0578006,29319.8710154,4.67211,1657.8352776,1286.5064617,2756.0762879,28.789096,35.3207718,2.970444,103.9875651),(40484,'femur',248,7,174,344.0648978,95.1602461,112.4770869,1.8,94.8916024,112.4204449,0.3027167,15.7663083,17.87281,20346.0973258,30261.6677237,5.0963017,1693.1678773,1290.4794813,2767.7624031,29.218784,35.7907149,3.0574544,105.8105769),(40485,'femur',248,7,175,347.1612287,95.2669384,112.6252051,1.8,94.9496213,112.5027965,0.3104073,15.944039,18.1462667,20856.858192,31150.9704574,5.3982163,1716.6600174,1308.1288974,2813.7240628,29.218784,36.0349177,2.9980093,107.5293289),(40486,'femur',248,7,176,351.642186,95.3587048,112.7596376,1.8,94.9729838,112.6049795,0.3136084,15.9900006,18.3962389,21406.6588438,31954.8583346,5.5775099,1737.0321467,1338.752851,2861.2323552,29.648472,36.2418331,2.9627996,107.0691039),(40487,'femur',248,7,177,357.8801664,95.4247102,112.8913348,1.8,95.006674,112.7114263,0.3043542,16.2720727,18.8074262,22195.6921282,33093.1778353,5.3566545,1759.5803683,1364.0359516,2894.7766472,29.648472,36.8856553,3.001343,110.1074569),(40488,'femur',248,7,178,362.0408715,95.4472261,113.0526666,1.8,95.0171907,112.8412295,0.3000431,16.4026425,19.0177896,22929.2750515,34263.4835401,5.2711045,1801.6543569,1397.9012866,2977.7220955,30.07816,37.01557,2.9783524,109.6472319),(40489,'femur',248,7,179,368.5074036,95.4790242,113.2867759,1.8,95.0509097,113.018539,0.2975277,16.4708403,19.2494901,23858.0829499,35440.4944981,5.2783342,1841.1134154,1448.5042995,3063.7815483,30.507848,37.4396108,2.9802175,110.7583133),(40490,'femur',248,7,180,373.4800969,95.5363276,113.4829889,1.8,95.0751152,113.1985021,0.2799605,16.6441069,19.5099419,24817.170761,36704.2255252,4.7526246,1881.3088026,1491.0485085,3129.6806436,30.937536,37.7978927,2.9932648,112.7287707),(40491,'femur',248,7,181,379.4501934,95.6619925,113.6847918,1.8,95.1173572,113.4007115,0.2774444,16.8924294,19.8666327,25725.4553239,38090.0416114,4.7444228,1917.2872476,1522.8984931,3198.7027098,31.367224,38.2229153,2.9949262,114.4475227),(40492,'femur',248,7,182,387.8283918,95.6814305,113.9397618,1.8,95.1452386,113.5828419,0.2724283,17.1704389,20.0784881,26913.7894654,39682.9410818,4.6797438,1976.3908985,1567.4491285,3291.8601479,31.796912,38.5882791,3.0075695,115.9145693),(40493,'femur',248,7,183,395.530782,95.7715594,114.2089864,1.8,95.2647104,113.8681903,0.2712574,17.3460779,20.422413,28169.213628,41452.82507,4.7327574,2029.7711679,1623.9529111,3396.5508745,32.2266,39.0732667,2.9981404,118.4926973),(40494,'femur',248,7,184,408.3123923,95.877181,114.5807307,1.8,95.3511485,114.1687042,0.2863006,17.761101,20.7213216,29905.7093931,44130.2672333,5.4273424,2129.7033104,1683.7756484,3565.6531498,32.656288,40.3838147,2.782822,122.3904263),(40495,'femur',248,7,185,425.6298459,96.1050732,115.0468334,1.8,95.5588921,114.5612534,0.285498,18.0307647,21.1933323,32053.0397656,48115.1366785,5.6267174,2270.295962,1777.6860958,3781.5990523,33.4497574,41.7417068,2.7840268,123.5446935),(40496,'femur',248,7,186,449.7684367,96.3728097,115.6105467,1.8,95.6032747,114.9794448,0.2749772,18.3547734,21.6718306,35007.8977167,53519.5559263,5.5265913,2469.5447667,1907.291196,4078.8912221,34.1909489,42.5412821,2.7367009,128.1543529),(40497,'femur',248,7,187,475.825911,96.4081248,116.1711022,1.8,95.5769484,115.4646912,0.2534462,18.7902425,21.9746435,38329.4406891,59676.2351158,4.9859661,2715.686159,2039.8587567,4430.7236675,35.1367119,43.2792026,2.7223603,130.8367407),(40498,'femur',248,7,188,507.9983899,96.3756908,116.8660311,1.8,95.5305689,116.0676443,0.2363426,19.7969008,22.0985266,42383.9618213,67975.7975792,4.6418774,3076.0330184,2140.9392457,4882.6961164,36.6036844,44.509538,2.6044844,137.1651521),(40499,'femur',248,7,189,555.7048913,96.337743,117.7712382,1.8,95.6471537,117.0764925,0.2239551,21.8694978,26.7498843,49693.956959,79378.2334696,4.5681651,2967.4234364,2272.2952994,4055.1912781,39.5789857,49.0710469,2.4928377,148.6498195),(40500,'femur',248,7,190,647.8306652,97.0018081,119.988876,1.8,96.5825694,119.7022538,0.4341235,25.7892167,30.5304425,67030.4197857,112130.7971019,19.1020743,3672.7537449,2599.164623,5561.1255838,42.9253819,58.0969321,2.4032801,191.949287),(40501,'femur',248,7,191,746.4826689,97.275134,121.9730127,1.8,96.7930605,121.3534201,0.5272577,26.5778052,31.7072344,86927.9756808,145695.8021861,31.4985032,4595.0334353,3270.6980552,7165.7993744,44.4085634,60.1870042,2.3864883,194.4842292),(40502,'femur',248,7,192,822.5568917,97.296352,123.1490189,1.8,96.7481143,122.3887447,0.5669171,27.1697963,32.5944722,102586.7266023,169967.0811192,39.5383246,5214.5983504,3775.7635564,8226.4677082,45.8111874,61.7152245,2.3217254,198.025993),(40503,'femur',248,7,193,895.0973743,97.2796458,124.1895721,1.8,96.3910111,123.2698336,0.5924586,27.8637635,33.121208,121363.640854,188995.5600934,46.5171854,5706.1795632,4355.6083514,9299.0917346,47.1624739,63.2707373,2.3081546,199.7268568),(40504,'femur',248,7,194,946.5312556,97.01997,124.7496997,1.8,95.937451,123.7448805,0.649105,28.4601396,33.7710819,137367.2813992,202712.9564206,57.6419278,6002.560334,4826.6552261,10057.3151711,49.2423872,64.1272452,2.3325022,203.919477),(40505,'femur',248,7,195,1001.129166,96.3000912,125.5052417,1.8,95.0222977,124.5564779,0.6445921,32.7509663,34.2279485,163482.762895,215606.3663338,60.2425594,6299.1320104,4991.6928125,11073.9172084,53.281312,64.8373422,2.2952372,213.9370978),(40506,'femur',248,7,196,1038.1438091,95.686981,125.9623892,1.8,94.6055553,124.913027,0.5838676,33.0924082,34.6269677,185261.5364924,226796.7702804,52.5788677,6549.7150126,5598.3092936,11874.2031226,53.7052052,65.6734217,2.3191744,217.8780126),(40507,'femur',248,7,197,1049.2461654,95.5025823,126.2244176,1.8,94.3183511,125.0809866,0.5793196,33.67944,34.7514446,193112.3674021,232743.0827996,52.4110118,6697.3642558,5733.8354597,12194.2428353,54.337092,66.0169153,2.3055466,220.5604004),(40508,'femur',248,7,198,1028.8053016,95.349103,126.3430623,1.8,94.2717265,125.0739973,0.5845701,34.0216672,34.8214819,194278.0702117,231287.1090287,52.2167327,6642.081165,5710.4218128,12138.536378,55.0074607,66.2611777,2.3286785,221.7757416),(40509,'femur',248,7,199,1009.5942533,95.1309265,126.0728001,1.8,94.3149704,125.0007686,0.6332349,34.7977453,35.1723302,196294.5504061,230833.4932776,58.9223906,6562.928644,5641.0134802,12099.1382261,55.2137217,66.2611777,2.3286785,223.0953426),(40510,'femur',248,7,200,988.8352633,94.9674409,125.7308191,1.8,94.4222388,124.8231863,0.673029,35.4256289,35.1997518,195049.5729418,231973.4225327,64.0393382,6590.2005108,5505.8887863,11967.8684961,55.2065069,65.7647275,0.9011574,223.347048),(40511,'femur',248,7,201,946.3963625,94.7617034,125.5223043,1.8,94.5290017,124.5367205,0.6665534,35.2408242,35.2370432,189859.3525369,223240.5741539,60.2966726,6335.3946282,5387.4833171,11674.5818886,54.7824611,66.2402762,0.8818719,225.464951),(40512,'femur',248,7,202,868.3127304,94.7044242,125.3222059,1.8,94.6938373,124.0845176,0.6795113,35.0645615,35.0430291,179301.0715893,207355.0343962,57.1498602,5917.15499,5113.4554056,10990.9623571,54.5892728,66.1845066,0.872733,231.6027309),(40513,'femur',248,7,203,830.3441006,94.7614016,125.0829522,1.8,94.9106156,123.7026059,0.6608289,34.8902204,34.6516512,171545.8055663,194850.2998707,52.1338978,5623.1173149,4916.7303547,10444.5456745,53.7839634,65.8559067,0.8685394,232.2535873),(40514,'femur',248,7,204,802.506608,94.7508174,124.6839698,1.8,95.0185375,123.4032039,0.6334175,34.2375206,34.3363388,163853.5549008,179768.2594913,46.85954,5235.5104154,4785.789156,9971.3579988,52.976112,64.7589854,0.8888016,228.104153),(40515,'femur',248,7,205,775.159117,94.8895777,124.3575943,1.8,95.1080786,123.0929876,0.5399976,32.9684476,33.6458609,153205.7687093,166702.6896364,34.1501112,4954.6269615,4647.0422478,9448.6713241,51.7787672,63.711299,0.8665592,221.0206254),(40516,'femur',248,7,206,744.177681,95.0862136,123.7781234,1.8,95.1755556,122.735903,0.3514493,30.0047155,31.9047429,139710.3098651,153925.2510154,14.6992639,4824.5256652,4656.2784456,8924.9999885,50.6112089,61.8049095,0.8493502,215.0481792),(40517,'femur',248,7,207,700.1916218,95.1909772,123.123149,1.8,95.2618254,122.3387813,0.2428665,27.9357082,30.1301918,122687.4288935,139953.6916125,6.7490887,4644.9651786,4391.7780055,8144.307706,49.3239115,60.2697734,0.8459302,210.1868144),(40518,'femur',248,7,208,662.5845346,95.3792955,122.3573712,1.8,95.396819,121.8557788,0.2014264,26.1772178,28.8077895,105829.8211976,127970.4304607,4.4201951,4442.2162509,4042.8215797,7436.2552292,47.695368,58.3189675,2.4553447,204.0669226),(40519,'femur',248,7,209,597.8319323,95.3915209,121.5346535,1.8,95.5219156,121.1803173,0.0775565,23.8705434,26.6736537,84299.5616322,111942.2246941,0.5981275,4196.7338166,3531.5308951,6515.8050873,45.4170431,56.0672867,2.4321351,195.5774224),(40520,'femur',248,7,210,543.3649425,95.6293986,120.7967908,1.8,95.7169893,120.6719422,0.0988391,23.1757164,26.214614,66400.8775021,97707.4460744,0.8818271,3727.2128534,2865.10571,5676.4236724,42.954889,54.0878037,0.678463,188.1990036),(40521,'femur',248,7,211,477.577675,95.895887,120.0249435,1.8,95.9189259,120.0987319,0.108171,22.1903131,25.0840448,48392.3165959,82268.0577784,0.9277266,3279.6966579,2180.7856571,4728.7811174,39.9535616,51.8517882,2.5329033,175.4558092),(40522,'femur',248,7,212,409.4544797,95.8530178,119.4980907,1.8,95.9529633,119.7098259,0.0867009,20.3377254,23.9726284,33620.4585909,68213.3520194,0.5116974,2845.4682105,1653.1080983,3874.1472026,36.52348,49.374872,2.5922182,164.6398864),(40523,'femur',248,7,213,345.3494314,95.8613648,119.2189367,1.8,95.8795051,119.4384742,0.0610591,18.2309213,22.4759663,21826.8253663,54854.7391564,0.2143227,2440.5953628,1197.2420392,3123.3656124,33.085976,46.743261,2.6327084,156.193572),(40524,'femur',248,7,214,258.6903807,95.5411025,119.3553492,1.8,95.6612841,119.4543883,0.0344174,15.5767793,21.5761274,12576.0979228,41738.739083,0.051052,1934.4870476,807.3618857,2384.5547673,20.1184866,29.6702598,1.3961241,81.4605672),(40525,'femur',248,7,215,179.1825663,95.6919592,119.7611539,1.8,95.5374552,119.6319735,0.029542,12.9542249,20.0413339,6057.2528225,29339.8734799,0.0260554,1463.9681016,467.5889799,1711.3463205,15.898456,25.1578563,1.7078625,68.0486282),(40526,'femur',248,7,216,90.1000276,96.1698414,120.1400246,1.8,95.6182179,119.9174429,-0.0147892,9.4670232,17.76289,1511.1584096,14496.8699959,0.0032842,816.1323973,159.623397,876.0000356,11.171888,19.4549516,1.6814535,50.9474799),(40527,'femur',248,7,217,2.1060331,88.4732523,120.3071493,1.8,89.2307007,120.206979,-0.1522745,3.3128897,22.2882648,3.8833626,176.5440843,0.0080762,7.9209434,1.172198,8.0932492,4.0360605,6.5448126,1.9756881,17.2054082),(40528,'femur',248,7,218,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40529,'femur',248,7,219,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40530,'femur',248,7,220,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40531,'femur',248,7,221,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40532,'femur',248,7,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40533,'femur',248,7,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40534,'femur',248,7,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40535,'tibia fibula',248,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40536,'tibia fibula',248,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40537,'tibia fibula',248,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40538,'tibia fibula',248,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40539,'tibia fibula',248,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40540,'tibia fibula',248,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40541,'tibia fibula',248,8,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40542,'tibia fibula',248,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40543,'tibia fibula',248,8,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40544,'tibia fibula',248,8,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40545,'tibia fibula',248,8,11,23.4243455,65.8363858,113.4623578,1.8,65.9064218,113.5023795,-0.3866346,7.7079209,16.1414677,170.9665635,200.6323182,0.5550964,12.4296205,22.180633,22.3219931,12.7610825,15.1917649,1.7126934,56.6861088),(40546,'tibia fibula',248,8,12,149.8544798,62.1798237,118.7043925,1.8,62.6536928,120.2804386,-0.9688677,20.6870431,20.4848104,5557.2194964,14285.6807273,16.968021,697.3792011,268.6328577,955.5234085,31.2991143,40.8768588,0.8747122,171.8023761),(40547,'tibia fibula',248,8,13,372.0210023,62.481544,122.0806115,1.8,63.4278674,121.3942385,-0.9426839,22.6715352,26.9475706,26468.7419381,41547.3319457,40.5939678,1541.7839528,1167.4878545,2518.8114429,36.9504105,48.2113,0.9308603,162.6441313),(40548,'tibia fibula',248,8,14,480.6049088,63.3875781,122.7643632,1.8,64.0705605,121.4920101,-0.8267382,23.660701,28.8590568,43069.6468171,66359.5253457,43.358005,2299.435003,1820.3030773,3730.3700226,40.0935886,52.6345877,0.8373744,171.6981163),(40549,'tibia fibula',248,8,15,510.8805479,64.165245,123.1519386,1.8,64.6108608,121.75208,-0.8551238,24.3225516,35.2921976,51563.5143026,77682.5618791,48.4910665,2201.1256619,2119.9878715,3593.0058288,41.4441488,55.0973292,0.9070172,170.9861859),(40550,'tibia fibula',248,8,16,522.9583755,65.0024276,122.9663494,1.8,65.3112862,121.1705018,-0.9639992,25.3981991,36.8663896,57008.9885645,87541.5793403,58.8177552,2374.5633943,2244.6075114,3894.6381522,42.5308772,62.6490409,0.9314104,209.5032508),(40551,'tibia fibula',248,8,17,521.8158964,66.1416137,121.2467415,1.8,66.2184711,120.1134751,-1.1589877,26.1991507,37.7237115,57875.466463,109178.8173222,73.0356117,2894.1695544,2209.0588812,4425.4294725,43.4343155,64.4073503,1.0235119,187.2890323),(40552,'tibia fibula',248,8,18,502.0727169,66.5005478,119.6948505,1.8,66.4779573,119.0963702,-1.197618,26.5383451,37.6839859,52875.9749351,119663.5391862,72.5565155,3175.4480442,1992.4367847,4578.5663338,43.563436,64.4030502,1.0773068,187.7924431),(40553,'tibia fibula',248,8,19,487.7570962,66.498388,118.3599772,1.8,66.3741195,118.2499825,-1.1965333,26.9624973,36.9994465,47116.9190825,126259.5269642,70.4277659,3412.4706963,1747.4983323,4684.7899684,43.013891,63.9022771,1.0107715,186.4296563),(40554,'tibia fibula',248,8,20,472.0916494,66.3254473,117.6130322,1.8,66.0731238,117.4849138,-1.1909588,25.8306786,36.5331321,42294.1479983,125840.544077,67.8655272,3444.5594151,1637.361085,4598.6661616,41.5765189,63.4077407,0.9978302,183.9989739),(40555,'tibia fibula',248,8,21,451.7927283,66.0992169,117.0829316,1.8,65.8502519,116.8561616,-1.1872512,25.0655475,36.3689783,37679.4866437,121344.3144517,64.7544407,3336.4785091,1503.2381231,4370.3031532,40.2739938,63.0471057,0.9941354,181.2123263),(40556,'tibia fibula',248,8,22,436.8924403,65.9017989,116.6656412,1.8,65.684739,116.2745525,-1.1848375,24.4639699,36.2211426,34460.1127509,117723.6083815,62.4965337,3250.1351423,1408.6067358,4196.2989067,39.2161333,62.5826964,1.0056469,179.0333493),(40557,'tibia fibula',248,8,23,425.0225193,65.8191575,116.2900242,1.8,65.5261028,115.7721579,-1.1879512,23.7789596,36.0583033,32080.0339428,114515.7958738,60.9519178,3175.8509262,1349.0932526,4055.5114657,38.2277825,62.1267036,1.0173289,176.4552213),(40558,'tibia fibula',248,8,24,411.9611638,65.721134,115.8608625,1.8,65.3711663,115.3626342,-1.1905406,23.2147782,35.6894935,29614.4774396,111098.5599663,59.2016891,3112.9206112,1275.6735036,3929.9379905,37.356255,61.6269069,1.0040671,174.5279497),(40559,'tibia fibula',248,8,25,402.4461932,65.6052334,115.4416375,1.8,65.2431972,114.9864298,-1.1902007,22.682641,35.4240029,27280.3710912,108651.0398816,57.818599,3067.1587297,1202.6981829,3830.0725669,36.5600995,61.2648301,1.0003017,173.0609031),(40560,'tibia fibula',248,8,26,396.0528982,65.5060035,115.1504771,1.8,65.1480006,114.6359412,-1.1914433,22.3147404,35.1875625,25593.3467169,106854.7345742,56.9565949,3036.7188575,1146.9255877,3755.2147403,35.8476445,60.9036321,0.9964915,171.8455619),(40561,'tibia fibula',248,8,27,390.1717607,65.4076348,114.8677095,1.8,65.047859,114.3830135,-1.191878,21.9491986,34.9601873,23979.1761746,105106.299028,56.1302621,3006.4569738,1092.4852699,3681.5666294,35.1739293,60.4410816,1.0084291,170.1268099),(40562,'tibia fibula',248,8,28,384.5927479,65.3025349,114.6058866,1.8,64.9561769,114.0861385,-1.1915794,21.5068182,34.7566559,22707.5064859,103304.7991158,55.3145049,2972.2306796,1055.8282645,3612.7492128,34.4756706,60.2130734,1.0144663,168.1995384),(40563,'tibia fibula',248,8,29,380.7981732,65.234579,114.3542085,1.8,64.844853,113.9112756,-1.192599,21.2547257,34.5449711,21640.6735754,101844.5257701,54.8132019,2948.1722673,1018.158215,3559.6955256,34.1173599,59.848613,1.0106749,167.2359026),(40564,'tibia fibula',248,8,30,378.1209565,65.1546843,114.1665853,1.8,64.7598439,113.7096726,-1.1938175,20.9875012,34.3962473,20678.0723388,100591.4716612,54.4804714,2924.4897222,985.2565193,3510.6073058,33.6692212,59.3964982,1.0229328,166.3765266),(40565,'tibia fibula',248,8,31,375.9249573,65.0696302,114.0058248,1.8,64.6995972,113.5228726,-1.1955374,20.7095861,34.272312,19801.9156284,98930.2099194,54.2376933,2886.5928289,956.1714835,3447.5889689,33.3088545,59.1738258,1.0291315,164.3018094),(40566,'tibia fibula',248,8,32,370.9893023,64.9738059,113.7834899,1.8,64.6033598,113.4119316,-1.1959425,20.4763775,34.0270035,18939.2783682,97286.9004961,53.5426627,2859.1086607,924.9330543,3407.6636887,32.8870651,58.8923419,1.0091034,163.4424334),(40567,'tibia fibula',248,8,33,369.4971978,64.9492052,113.4434597,1.8,64.5817223,113.1460193,-1.1979695,20.202578,33.7841086,17914.3290938,95271.794575,53.4121927,2820.0180026,886.7348057,3329.4314565,32.4924931,58.4391477,1.0215498,162.1228324),(40568,'tibia fibula',248,8,34,367.5387022,64.8659946,113.3192106,1.8,64.5218419,113.0062405,-1.2002474,19.9898527,33.6234319,17351.3229469,93844.702561,53.2235209,2791.0506801,868.0065455,3294.5211522,32.1300979,58.166806,1.0012343,161.2634564),(40569,'tibia fibula',248,8,35,363.6190256,64.8067085,113.1766717,1.8,64.4467669,112.9034833,-1.2017063,19.6813864,33.5080099,16706.8064229,92385.0177697,52.7155007,2757.1024961,848.863291,3244.2658528,31.7355259,57.8485174,1.0240075,159.4404446),(40570,'tibia fibula',248,8,36,362.6173702,64.7561311,113.0567256,1.8,64.4019557,112.8005904,-1.204389,19.5902727,33.4065552,16239.292186,91339.8417217,52.6790714,2734.1891822,828.946714,3207.1801709,31.5046547,57.5733819,1.0034947,158.9370338),(40571,'tibia fibula',248,8,37,360.1735728,64.6795915,112.9105182,1.8,64.3382749,112.6992463,-1.2054753,19.4553804,33.2940997,15674.3929128,90026.7150855,52.3676187,2703.9840634,805.6585155,3160.8807592,31.2737835,57.2582437,1.0265158,156.7580568),(40572,'tibia fibula',248,8,38,359.1316341,64.6287021,112.7908403,1.8,64.2685337,112.6521649,-1.2080474,19.1163588,33.0396479,15217.0754181,88964.168955,52.3185707,2692.6488168,796.0237383,3141.0550403,30.9387674,56.8910806,1.022605,156.4020916),(40573,'tibia fibula',248,8,39,356.7909508,64.5640136,112.7303372,1.8,64.2222668,112.5726784,-1.211058,19.0140377,32.996914,14788.1381229,87555.0931853,52.0959593,2653.4327807,777.7484399,3087.8502504,30.7365981,56.7513588,1.012197,154.6833396),(40574,'tibia fibula',248,8,40,355.2712634,64.5322546,112.6251163,1.8,64.1710104,112.4969637,-1.2143905,18.792352,32.8989394,14400.932148,86470.9387372,52.0036072,2628.3807408,766.3187756,3051.2038768,30.5199549,56.4479868,1.0355987,153.4679984),(40575,'tibia fibula',248,8,41,355.1442032,64.472235,112.5221897,1.8,64.103454,112.4459345,-1.2166454,18.560801,32.6667754,14078.1320415,85770.3822358,52.0720642,2625.6152104,758.487309,3043.6033052,29.9855925,56.2300559,1.0421718,152.8603278),(40576,'tibia fibula',248,8,42,353.075488,64.393745,112.4495971,1.8,64.0448685,112.3889397,-1.2184811,18.3849982,32.6201287,13703.4264632,84256.8809734,51.8388665,2582.9720571,745.359141,2988.9112543,29.7916849,56.1758519,1.0592402,151.6449866),(40577,'tibia fibula',248,8,43,353.1587402,64.3183193,112.4070663,1.8,63.9760935,112.3718395,-1.2211983,18.1833219,32.4500728,13411.8824649,83344.325114,51.9543539,2568.3863825,737.5925329,2969.4623343,29.599959,55.85944,1.0382922,150.17794),(40578,'tibia fibula',248,8,44,351.8246357,64.2439796,112.3536176,1.8,63.9022163,112.3609204,-1.2231902,17.9550427,32.2728346,13186.3610746,82289.143991,51.8330859,2549.795985,734.4098973,2948.1081915,29.2165073,55.7105033,1.0277313,149.6745292),(40579,'tibia fibula',248,8,45,352.457643,64.1805118,112.2973145,1.8,63.824419,112.34663,-1.2263636,17.7391173,32.1182756,13020.9587002,81488.250675,52.045295,2537.1303106,734.0251759,2921.8113139,29.0236906,55.4896761,1.0343609,148.7108934),(40580,'tibia fibula',248,8,46,351.4406016,64.1092641,112.2705995,1.8,63.736629,112.3682146,-1.2284893,17.5296769,31.964577,12779.7870782,80456.9577539,51.9740569,2517.066246,729.0372306,2898.8341732,28.8308739,55.1207813,1.0303768,147.8515174),(40581,'tibia fibula',248,8,47,350.9426553,64.0156738,112.2848237,1.8,63.6684356,112.3206767,-1.2298397,17.4527788,31.8607423,12624.4383411,79443.5862878,51.9502827,2493.4631287,723.3483254,2874.3838911,28.6391481,54.9765604,1.0196534,146.8878816),(40582,'tibia fibula',248,8,48,349.5397895,63.9416138,112.254812,1.8,63.579732,112.4001099,-1.231476,17.250942,31.7086406,12461.6280886,78667.3436717,51.8025753,2480.9434335,722.3737726,2860.9978323,28.4463314,54.6109613,1.0155331,146.280211),(40583,'tibia fibula',248,8,49,345.8498955,63.8770346,112.1553746,1.8,63.4947749,112.3224384,-1.2342974,17.0256976,31.5056181,12166.8016626,76806.8516029,51.3574568,2437.8779471,714.6139885,2799.7947353,28.2141914,54.3856697,1.0222469,145.420835),(40584,'tibia fibula',248,8,50,344.4176564,63.8244915,112.1357794,1.8,63.4188813,112.3074543,-1.2367766,16.7874074,31.3530595,12008.8073579,76033.1982546,51.2332069,2425.0647115,715.3461572,2786.7723733,27.9602816,54.0194895,1.0180991,144.561459),(40585,'tibia fibula',248,8,51,342.1279426,63.752024,112.1443634,1.8,63.3623792,112.3669736,-1.2383205,16.6937261,31.2385471,11835.2417107,74858.4218059,50.9470319,2396.3477413,708.9634529,2757.0395989,27.870063,53.7247483,1.0427219,143.5978232),(40586,'tibia fibula',248,8,52,341.3686025,63.6788518,112.161314,1.8,63.2386849,112.4334078,-1.2405371,16.4637518,30.9915845,11701.4778593,73849.5183467,50.9115505,2382.8894053,710.7418783,2748.3466725,27.6772463,53.2050224,1.0276068,142.3824821),(40587,'tibia fibula',248,8,53,338.8126273,63.5748159,112.2411412,1.8,63.1651115,112.5261911,-1.2418368,16.3911256,30.6902813,11554.7560841,72390.6389447,50.5753065,2358.7479753,704.9397552,2720.8174477,27.7826159,52.8376486,1.0234034,142.1307766),(40588,'tibia fibula',248,8,54,338.6869098,63.464091,112.280475,1.8,63.0769742,112.5993119,-1.242476,16.3361453,30.4930068,11495.1860781,71530.1823733,50.5785842,2345.7897385,703.6657605,2701.6329232,27.5665296,52.550333,1.0486076,140.6637301),(40589,'tibia fibula',248,8,55,338.7187448,63.34305,112.382272,1.8,62.9833249,112.7022021,-1.2431364,16.409458,30.3492403,11452.0552895,70447.1810109,50.6060781,2321.2172772,697.8935746,2684.5022721,27.6039794,52.1783498,1.0445002,140.4120246),(40590,'tibia fibula',248,8,56,336.7683059,63.2233123,112.4902473,1.8,62.8805295,112.7815052,-1.2445607,16.3323478,30.2161158,11404.6193134,69114.7629363,50.3633009,2287.347701,698.2841331,2644.2082259,27.5263021,51.8072596,1.0403338,139.4483889),(40591,'tibia fibula',248,8,57,336.9285999,63.1347444,112.5473306,1.8,62.8075386,112.8471696,-1.2464375,16.241672,30.1543658,11360.5674467,68049.6827774,50.4511033,2256.7107935,699.4703156,2615.9764858,27.2133762,51.5911979,1.047518,138.5890129),(40592,'tibia fibula',248,8,58,333.9257598,63.015638,112.6507135,1.8,62.7291758,112.9395303,-1.2477724,16.3042217,30.0127257,11308.5184271,66246.9746789,50.0462697,2207.296179,693.5944966,2572.9353791,27.250826,51.1671633,1.0620665,138.3373075),(40593,'tibia fibula',248,8,59,330.7461209,62.9327734,112.7481097,1.8,62.6587248,113.0246309,-1.2502105,16.3203219,29.7165669,11239.3157792,64671.3481937,49.6503806,2176.2725306,688.6699832,2541.1067923,27.1990775,50.6321264,1.0463871,137.0177065),(40594,'tibia fibula',248,8,60,330.9060232,62.8650068,112.7803301,1.8,62.5724095,113.0888997,-1.2516328,16.3560998,29.4944013,11190.3568199,63864.2020803,49.7212133,2165.2991472,684.1702476,2525.2839597,27.2327904,50.3762224,1.0728111,136.7660011),(40595,'tibia fibula',248,8,61,331.6700631,62.800846,112.8268013,1.8,62.5272724,113.1296165,-1.2523107,16.2591608,29.4180527,11188.0980811,63545.9102373,49.858326,2160.0991339,688.1104262,2524.0859441,27.2327904,50.1098012,1.0303768,136.1583305),(40596,'tibia fibula',248,8,62,331.9933365,62.7595321,112.8291377,1.8,62.4769946,113.196478,-1.2530119,16.1492746,29.2965626,11155.1550243,63149.0326039,49.9299748,2155.5099638,690.752701,2509.0841521,26.9351224,50.0452801,1.0495203,135.6549197),(40597,'tibia fibula',248,8,63,333.2219211,62.7168872,112.8446058,1.8,62.4434063,113.2074971,-1.2545211,16.1647181,29.1788776,11180.8203676,62793.7500401,50.1644024,2152.027607,691.6805042,2511.3379468,26.9725722,49.6731222,1.0452125,135.0472491),(40598,'tibia fibula',248,8,64,332.1573231,62.6737099,112.8353885,1.8,62.4275463,113.1960367,-1.2551061,16.200771,29.0477505,11153.5227917,62351.1429996,50.023265,2146.5050436,688.4562971,2510.3545016,26.9725722,49.5204934,1.033353,135.2989545),(40599,'tibia fibula',248,8,65,329.2385745,62.6057672,112.8242231,1.8,62.3919675,113.1778237,-1.257063,16.2425436,28.9182238,11049.008354,61232.9309848,49.6469127,2117.4513151,680.251114,2467.2428685,27.1316516,49.374872,1.0214218,135.4032143),(40600,'tibia fibula',248,8,66,329.0086799,62.543203,112.8477556,1.8,62.3412515,113.1945722,-1.2577305,16.2858418,28.82527,11046.3781661,60817.4431775,49.6337144,2109.8655161,678.2810688,2465.2294793,27.1653645,49.0089256,1.0168438,135.1515089),(40601,'tibia fibula',248,8,67,327.5253035,62.4826145,112.9086008,1.8,62.3029243,113.2284918,-1.2606179,16.2861693,28.8770135,11006.275842,60004.0181898,49.5019291,2077.916338,675.8050716,2429.1521458,27.1990775,49.0089256,1.0168438,135.1515089),(40602,'tibia fibula',248,8,68,326.2582819,62.4085291,112.9984684,1.8,62.2346364,113.3117253,-1.2638834,16.2858483,28.8402511,10979.4592461,59094.8151791,49.4131857,2049.0395508,674.1717746,2402.9540334,27.1752311,48.8731143,1.0047414,134.5438383),(40603,'tibia fibula',248,8,69,325.5715076,62.3337331,113.0815765,1.8,62.2148743,113.3857799,-1.2675057,16.2840208,28.7979047,10951.8189143,58116.0338776,49.4217998,2018.0646619,672.5500463,2375.3959815,27.1706664,48.6440218,1.012197,134.5438383),(40604,'tibia fibula',248,8,70,324.6663643,62.2719489,113.1715303,1.8,62.1882479,113.4701439,-1.271094,16.2687112,28.76064,10965.0507789,57283.469236,49.3945153,1991.7313784,673.9962783,2353.1747718,27.0855197,48.2801842,1.0074801,133.9361677),(40605,'tibia fibula',248,8,71,324.621661,62.2061102,113.2967806,1.8,62.1166887,113.5437949,-1.2758609,16.2319988,28.5952337,10991.832141,56514.912192,49.5321926,1976.3752483,677.1705869,2332.824628,27.0630316,48.0521072,1.0150406,133.3284971),(40606,'tibia fibula',248,8,72,325.5106351,62.1477372,113.3734819,1.8,62.0880513,113.6079888,-1.2811396,16.1962372,28.4161226,11033.6884981,55706.0978556,49.8258776,1960.3694222,681.2501182,2327.9296125,27.0088973,47.6876252,1.0102868,132.7208265),(40607,'tibia fibula',248,8,73,324.2504952,62.0840059,113.4832356,1.8,62.0749206,113.6686818,-1.2866652,16.153603,28.3974551,11058.264378,54679.682792,49.7950795,1925.5134849,684.5695258,2296.7895698,26.9901545,47.4605908,1.0179551,132.8250863),(40608,'tibia fibula',248,8,74,323.4052733,62.0196753,113.620109,1.8,62.043556,113.7435139,-1.2917521,16.1106914,28.4098455,11082.8794433,53795.9647465,49.8116617,1893.5676662,687.9207851,2268.137606,26.9243451,47.3242375,1.0054599,132.1131559),(40609,'tibia fibula',248,8,75,322.4986753,61.9792204,113.7164603,1.8,61.9918292,113.8631259,-1.2974343,16.1650915,28.1964248,11108.1821548,52877.8025257,49.8322859,1875.3371368,687.1710025,2246.4085482,26.8677332,47.0954514,1.0131641,131.1495201),(40610,'tibia fibula',248,8,76,321.0959214,61.9483798,113.8087185,1.8,61.992632,113.9227548,-1.3039536,16.0823253,28.153342,11149.9159712,51958.9818557,49.7949688,1845.5706589,693.3024792,2221.3667236,26.8677332,46.8694878,1.0209431,131.1495201),(40611,'tibia fibula',248,8,77,324.0139987,61.9066102,113.8694301,1.8,61.9681185,113.9828733,-1.3090604,16.0379001,28.0917863,11283.2077054,51838.1427586,50.386576,1845.313154,703.5339832,2229.109543,26.7940794,46.6463878,1.028797,130.8978147),(40612,'tibia fibula',248,8,78,324.7298665,61.880115,113.9029932,1.8,61.9454579,114.0022495,-1.3129445,16.111996,28.1169452,11356.2361269,51504.2640943,50.6022737,1831.7873344,704.8311155,2216.6808353,26.7918364,46.5810331,1.0493619,130.6461093),(40613,'tibia fibula',248,8,79,327.1052382,61.8760894,113.946552,1.8,61.9664713,114.038415,-1.3170736,16.0472879,28.0367914,11471.6290472,51442.379694,51.0826287,1834.8169364,714.8640413,2227.8276696,26.640656,46.4261927,1.0367259,130.6461093),(40614,'tibia fibula',248,8,80,327.4945315,61.8373492,114.0036572,1.8,61.9648679,114.0832743,-1.3205711,16.0217691,27.7798042,11561.9470306,51097.7749282,51.2356067,1839.3857101,721.6398471,2232.2598657,26.640656,46.2788139,1.0240075,130.2901441),(40615,'tibia fibula',248,8,81,329.0692168,61.8489685,114.0054782,1.8,62.02103,114.0340894,-1.3251711,15.9457267,27.6554458,11608.0646882,50405.0135053,51.6019931,1822.6071583,727.9733859,2222.270994,26.210968,45.9946834,1.052809,129.5782137),(40616,'tibia fibula',248,8,82,329.4606921,61.8387344,114.0570127,1.8,61.9614302,114.0769068,-1.3284459,16.000406,27.5924625,11650.6337765,50155.4240432,51.7476883,1817.7219271,728.1461342,2223.1802442,26.210968,45.8378624,1.0400228,129.5782137),(40617,'tibia fibula',248,8,83,329.5950816,61.8304447,114.0927507,1.8,61.9879633,114.1118944,-1.3312035,15.9600997,27.6196753,11696.9739245,49896.5577671,51.8390081,1806.5584461,732.8885239,2212.6430318,26.210968,45.783453,1.0609631,128.6145779),(40618,'tibia fibula',248,8,84,330.7705706,61.8204478,114.1379057,1.8,61.9968567,114.1370163,-1.3343776,16.2303995,27.438305,11749.0356677,49610.8311831,52.1040737,1808.0865827,723.8907275,2206.8648046,26.5466094,45.783453,1.0609631,128.9705431),(40619,'tibia fibula',248,8,85,332.0525865,61.7989283,114.1901848,1.8,61.9921226,114.2334114,-1.3385447,16.2800102,27.4751637,11756.883175,49053.8351321,52.4101892,1785.3882767,722.1668189,2182.6762169,26.5391103,45.783453,1.0609631,128.6145779),(40620,'tibia fibula',248,8,86,333.1180797,61.7707477,114.2836111,1.8,62.0053468,114.2618393,-1.3443446,16.2029202,27.5452835,11789.1960472,48355.2354388,52.7209444,1755.4814934,727.5969971,2151.2682447,26.4965519,45.783453,1.0609631,128.8662833),(40621,'tibia fibula',248,8,87,334.2359412,61.7166747,114.4466928,1.8,61.9777733,114.4600259,-1.3536839,16.1783425,27.0655837,11810.7779739,47122.6133888,53.1211337,1741.0529127,730.0363417,2150.3077917,26.4350875,45.0353203,1.0516502,127.2949769),(40622,'tibia fibula',248,8,88,334.7478188,61.6728537,114.5972138,1.8,61.9347321,114.6363924,-1.3616433,16.0719745,26.587986,11862.3815508,46181.7911407,53.3860943,1736.9420609,738.078671,2161.2767023,26.2761839,44.509538,1.6771892,125.4719651),(40623,'tibia fibula',248,8,89,336.8388576,61.6445093,114.7344857,1.8,61.9078777,114.832076,-1.3702025,16.0313457,26.273688,11968.4823512,45376.3998574,53.9109978,1727.0662548,746.567542,2156.4835818,26.2160785,44.1304429,1.6879051,125.1159999),(40624,'tibia fibula',248,8,90,337.0901247,61.6285921,114.8770248,1.8,61.9234894,114.9718852,-1.3808002,16.1182772,25.7874769,12050.4740728,44275.1366852,54.1778978,1716.9239467,747.6279219,2163.184175,26.3498471,43.8744904,1.7182335,123.6489533),(40625,'tibia fibula',248,8,91,338.4240054,61.6094526,115.0406986,1.8,61.8770793,115.2275749,-1.3904854,16.0460483,25.4160221,12163.7993971,43450.1804528,54.58998,1709.5586499,758.0557618,2167.7040546,26.2932451,43.8134293,1.7085325,123.0412827),(40626,'tibia fibula',248,8,92,340.4451079,61.5885527,115.2110394,1.8,61.8682473,115.3870854,-1.4006521,15.9606559,25.0543185,12284.5945246,42550.0611959,55.114047,1698.3124584,769.6798042,2168.7756513,26.215343,43.515325,1.7294516,121.9302013),(40627,'tibia fibula',248,8,93,342.9943692,61.5856935,115.3781161,1.8,61.8699599,115.5073721,-1.4109444,15.7808574,24.6908167,12409.8275322,41725.5292003,55.717393,1689.9209826,786.3848715,2173.4814806,26.0830788,43.0910871,1.731027,120.8191199),(40628,'tibia fibula',248,8,94,343.7225457,61.567876,115.5810783,1.8,61.8380183,115.8020613,-1.4233385,15.9424963,24.0016449,12510.1930346,40573.5278893,56.0504543,1690.4478009,784.7072875,2185.9064886,26.2157864,42.4717843,1.7642237,119.6037787),(40629,'tibia fibula',248,8,95,344.3990813,61.5641747,115.769324,1.8,61.8453688,115.9871321,-1.4345907,15.8138997,23.6031457,12623.1648363,39658.1658542,56.3415354,1680.2067972,798.2322541,2195.5402384,26.1182651,42.0501906,1.7661879,117.4248017),(40630,'tibia fibula',248,8,96,345.4477898,61.5624213,115.9516639,1.8,61.868379,116.1828163,-1.4458041,15.6773307,23.2675641,12743.4533635,38884.3570438,56.6798142,1671.1829772,812.8586157,2200.3996669,25.863229,41.9688832,1.7561443,117.1730963),(40631,'tibia fibula',248,8,97,344.3571755,61.5743553,116.1555098,1.8,61.8844832,116.3909975,-1.4602672,15.7980372,22.5685858,12820.699977,37555.4337892,56.694563,1664.0579134,811.537525,2206.966524,26.0376412,41.4821427,1.8007008,116.4179801),(40632,'tibia fibula',248,8,98,342.900151,61.5604851,116.3341914,1.8,61.8220762,116.5894493,-1.4704205,15.6842162,22.2413071,12883.2255802,36678.2634766,56.5761526,1649.1055744,821.413413,2204.8165355,25.8702405,41.1649177,1.8132433,114.742414),(40633,'tibia fibula',248,8,99,343.2191164,61.5648549,116.4882923,1.8,61.8364192,116.7314514,-1.4788669,15.5352997,21.8987217,12944.3131263,35922.830197,56.7211207,1640.4076292,833.2194,2210.3199892,25.9151311,40.7479272,1.815775,114.8466737),(40634,'tibia fibula',248,8,100,342.3222536,61.5865873,116.6289707,1.8,61.872601,116.8755478,-1.488016,15.7535764,21.5446526,13010.4715072,35179.4594294,56.6636356,1632.8626896,825.8741468,2178.9273401,25.9983665,40.5503466,1.8389071,114.6992281),(40635,'tibia fibula',248,8,101,341.2085323,61.5953508,116.7886903,1.8,61.8890612,117.0057019,-1.4966951,15.6349731,21.2495458,13052.1522947,34311.4852914,56.5563978,1614.6926435,834.8049093,2154.3369779,25.9793312,40.1361714,1.8417432,113.3796271),(40636,'tibia fibula',248,8,102,340.5204153,61.6051087,116.9527152,1.8,61.9041403,117.2236806,-1.5046256,15.520984,20.9592668,13133.2889619,33604.4494865,56.5052663,1603.3218029,846.163424,2112.8841971,25.8726515,39.8406751,1.8550218,113.1279217),(40637,'tibia fibula',248,8,103,340.3035569,61.6339032,117.1237384,1.8,61.9405496,117.4010331,-1.5151233,15.7222865,20.6647801,13221.5602358,32922.1244266,56.5416467,1593.1514508,840.943858,2100.3058251,26.0736732,39.7223258,1.8446384,112.5202511),(40638,'tibia fibula',248,8,104,341.264817,61.6607164,117.2961549,1.8,61.9723993,117.5780087,-1.5244665,15.564452,20.3739359,13316.7230245,32311.4790361,56.7554721,1585.9222911,855.5857309,2064.8475286,25.937576,39.5523078,1.8684965,112.2685457),(40639,'tibia fibula',248,8,105,341.0378878,61.6840462,117.4616783,1.8,62.005488,117.7617694,-1.5335186,15.8062009,20.0759218,13396.4952217,31706.1367514,56.7606982,1579.3116287,847.5468137,2027.9402234,26.0071839,39.2712266,1.8821666,112.9804761),(40640,'tibia fibula',248,8,106,341.766456,61.708821,117.628621,1.8,62.076366,117.9036772,-1.5421677,15.6572199,19.7794568,13470.2531534,31133.3819999,56.9144036,1574.026138,860.322156,2014.5930555,25.8462486,39.1370058,1.9064349,111.4091697),(40641,'tibia fibula',248,8,107,340.2690923,61.7370535,117.7957692,1.8,62.1026031,118.0607514,-1.5487896,15.9420486,19.49011,13510.43881,30533.9975994,56.6840547,1566.6406024,847.471939,2002.4899204,26.0196128,38.7315529,1.9100889,111.5134295),(40642,'tibia fibula',248,8,108,339.3771529,61.7675985,117.9601644,1.8,62.1334474,118.2643433,-1.5565491,15.7918249,19.6101314,13543.7377278,29932.0624432,56.5513783,1526.3570604,857.6423432,1966.6302631,25.9270965,38.4732759,1.9243383,110.5497937),(40643,'tibia fibula',248,8,109,340.1144492,61.7996178,118.1013408,1.8,62.1637109,118.3355349,-1.5624454,15.6733829,19.301765,13586.2872851,29443.020685,56.6817884,1525.4056109,866.8382178,1957.4702916,25.8316999,38.2229153,1.9387773,109.586158),(40644,'tibia fibula',248,8,110,339.0733497,61.8334333,118.2373483,1.8,62.1730005,118.4935271,-1.5674002,15.5626026,18.9925857,13560.5016708,28868.5220651,56.5115731,1519.9890384,871.3517937,1940.9254924,25.7729836,37.8223084,1.9428641,108.726782),(40645,'tibia fibula',248,8,111,337.3624286,61.8804131,118.3706595,1.8,62.20204,118.645248,1.5694251,15.4448411,18.6812657,13552.7224472,28328.0028571,56.2269657,1516.3856339,877.4918666,1927.2021173,25.6859283,37.5823509,1.957672,108.1191114),(40646,'tibia fibula',248,8,112,336.8462429,61.9143196,118.4972131,1.8,62.2508869,118.7952637,1.5643492,15.3454692,18.7983782,13585.6371101,27879.1658586,56.1387069,1483.0622897,885.3191061,1918.1914287,25.6467202,37.4223467,1.9470383,108.3276309),(40647,'tibia fibula',248,8,113,334.111119,61.9987956,118.6076693,1.8,62.3934745,118.8505316,1.5546698,15.5511734,18.469169,13575.9379926,27085.2185312,55.670706,1466.5098639,872.9848006,1891.9861576,25.6477134,37.1847735,1.9620319,107.9716657),(40648,'tibia fibula',248,8,114,333.6363355,62.0402163,118.7521744,1.8,62.3851408,118.9790026,1.5468496,15.4136434,18.5820388,13624.2994737,26704.3494391,55.5741751,1437.1054592,883.9116803,1887.7930913,25.7028548,36.9556661,1.9772148,107.4682549),(40649,'tibia fibula',248,8,115,333.7365962,62.1018232,118.8988647,1.8,62.4847047,119.2119142,1.5351452,15.6272475,18.287031,13738.8332212,26339.9117835,55.5520991,1440.3602107,879.1588656,1860.8674236,25.696824,36.9131754,2.0032041,107.1122897),(40650,'tibia fibula',248,8,116,334.4134675,62.1799948,119.0511204,1.8,62.578331,119.3394714,1.5228601,15.797047,18.0065199,13852.9943264,25956.2401211,55.607602,1441.4912103,876.9356916,1834.3480526,25.8288167,36.7351829,1.9925836,106.7563246),(40651,'tibia fibula',248,8,117,334.3779958,62.2630499,119.2039117,1.8,62.6399662,119.4407248,1.5059849,15.885416,18.0749449,13960.2634703,25543.5525251,55.4958998,1413.202236,878.810067,1810.3315947,25.7859314,36.7075294,2.0187384,107.1122897),(40652,'tibia fibula',248,8,118,335.6842936,62.3509404,119.3517003,1.8,62.7562301,119.6089333,1.488557,15.587904,17.8178802,14143.6794709,25293.6771607,55.5698449,1419.5671369,907.3496659,1794.0275041,25.8146604,36.7351829,1.9925836,107.8242201),(40653,'tibia fibula',248,8,119,335.9134048,62.4504688,119.4909454,1.8,62.8620321,119.7770194,1.4671895,15.6211526,17.5308473,14321.9469169,25045.075352,55.3867442,1428.6289124,916.830357,1781.5186167,25.9379931,36.7276431,2.0710768,108.5793363),(40654,'tibia fibula',248,8,120,336.4957223,62.5698293,119.671276,1.8,62.9568919,119.9238747,1.4391826,15.1694037,17.4901976,14513.2527554,24843.7436882,55.1167431,1420.4381378,956.7451077,1771.6856223,25.899716,36.9031705,2.0552743,109.5429721),(40655,'tibia fibula',248,8,121,337.1959243,62.6803342,119.8627785,1.8,63.0520308,120.1201878,1.4091908,14.9395907,17.2899039,14681.3162134,24614.1533402,54.7443331,1423.6142353,982.7120777,1780.8450689,25.9213871,36.561374,2.087027,109.4387123),(40656,'tibia fibula',248,8,122,337.8788381,62.7773967,120.0188948,1.8,63.1420294,120.2505658,1.3861288,14.5899536,17.2176451,14767.1668266,24317.1410325,54.4144746,1412.3383786,1012.1462489,1785.2871664,25.8153827,36.4044901,2.1031188,108.0759255),(40657,'tibia fibula',248,8,123,339.8082402,62.897294,120.1837801,1.8,63.310317,120.4294977,1.3602426,14.4375991,17.4609402,14888.4452461,24106.2226982,54.1608115,1380.579876,1031.2272273,1775.3065133,25.9000199,36.4044901,2.1031188,108.6835961),(40658,'tibia fibula',248,8,124,339.3995325,63.0144943,120.3368354,1.8,63.4292376,120.6309383,1.3354489,14.059417,17.6075928,14963.9245851,23903.5853224,53.4908771,1357.5725874,1064.3346463,1778.9418046,25.8784616,36.1193596,2.1357007,107.3208093),(40659,'tibia fibula',248,8,125,341.9492414,63.1219898,120.4745102,1.8,63.5209046,120.7878483,1.3121538,13.9183358,17.738578,15103.8057008,23772.3291944,53.2632945,1340.1485265,1085.1732508,1793.2101565,25.9048378,35.8911676,2.1255886,106.5046191),(40660,'tibia fibula',248,8,126,343.6420351,63.2233034,120.6152406,1.8,63.6282107,120.9436942,1.2895015,14.0267751,17.8479542,15212.7690163,23573.2628249,52.8600669,1320.782343,1084.5521465,1781.1004741,25.7223025,35.7571679,2.1421338,106.9648441),(40661,'tibia fibula',248,8,127,344.7478116,63.3409756,120.7527743,1.8,63.7115186,121.0571097,1.2688126,14.0065947,17.9214678,15280.0584014,23353.9183247,52.3754941,1303.125313,1090.9188676,1788.6939995,25.7945575,35.5266496,2.1319597,106.6088789),(40662,'tibia fibula',248,8,128,345.1528266,63.4353109,120.8832025,1.8,63.8239516,121.1468344,1.2482828,14.0738841,17.9967583,15352.9846393,23130.2897758,51.7465629,1285.2475668,1090.8846852,1787.6175577,25.8648481,35.3964863,2.1486983,105.6452431),(40663,'tibia fibula',248,8,129,345.4623366,63.569606,121.0175578,1.8,63.9626892,121.269798,1.2140716,14.1085259,18.0842621,15376.6226176,22733.9478811,50.5557888,1257.1122755,1089.8815847,1785.8809872,25.9604406,35.1662288,2.1825233,104.1781966),(40664,'tibia fibula',248,8,130,346.8707973,63.6586596,121.1384303,1.8,63.9992815,121.3801048,1.1915099,14.1153922,18.1864001,15440.4327735,22561.4718022,49.8863335,1240.5683177,1093.8720357,1784.2127581,25.7698056,34.9212384,2.17245,103.570526),(40665,'tibia fibula',248,8,131,347.7552395,63.7592563,121.2626361,1.8,64.1022514,121.499901,1.1709582,14.1041551,18.0820521,15479.6217268,22350.2738335,49.1766174,1236.0474177,1097.5220879,1789.0056199,25.8336156,34.6345587,2.2242227,103.570526),(40666,'tibia fibula',248,8,132,346.7488284,63.8790016,121.3826635,1.8,64.2407072,121.6252163,1.1481748,14.1818529,18.1444331,15529.9008108,22080.3530087,48.0694869,1216.9216229,1095.0544241,1782.4326593,25.9125064,34.4662278,2.1968428,102.9628554),(40667,'tibia fibula',248,8,133,345.2407784,63.9976579,121.4847797,1.8,64.4066798,121.7113273,1.1297396,14.0681671,17.9887687,15494.1770541,21719.1974578,47.0540374,1207.3754382,1101.3643002,1776.6744181,25.8190519,34.2243188,2.2494588,102.3551848),(40668,'tibia fibula',248,8,134,344.4557577,64.1143304,121.5882087,1.8,64.5119871,121.8264436,1.1088652,14.1164623,18.0206528,15486.1361416,21428.1816209,46.0061672,1189.0902006,1097.0267065,1763.6215316,25.9063613,33.9562284,2.2396085,102.1034794),(40669,'tibia fibula',248,8,135,343.2315371,64.2311579,121.6927091,1.8,64.6179333,121.8897302,1.0861607,14.1902928,17.9157324,15482.9049258,21119.7284764,44.7888687,1178.837016,1091.0912941,1761.6837515,25.9907013,33.6914851,2.2296024,102.2077391),(40670,'tibia fibula',248,8,136,343.4876158,64.3534903,121.8016423,1.8,64.7432835,121.9939192,1.0592431,14.0924929,18.0300343,15495.0204742,20853.2129484,43.5289353,1156.5819901,1099.5230312,1763.0892823,25.8903177,33.5597056,2.2655346,100.8881382),(40671,'tibia fibula',248,8,137,343.4294288,64.4794756,121.8990679,1.8,64.867542,122.0957272,1.0327156,14.1651254,18.1328342,15496.3337557,20600.1499962,42.2049085,1136.0689553,1093.9778766,1750.8420019,25.9179138,33.2862629,2.2556176,99.9245024),(40672,'tibia fibula',248,8,138,343.7274133,64.608,121.9916781,1.8,64.9889092,122.197133,1.0055941,14.2244587,18.3250174,15513.3705175,20397.307714,40.8546972,1113.0853098,1090.6123632,1737.2381445,25.9908834,33.4715644,2.301703,99.9245024),(40673,'tibia fibula',248,8,139,343.918703,64.728694,122.0801421,1.8,65.0775279,122.2676242,0.9796221,14.1448577,18.4265143,15511.7886645,20153.7973927,39.5148954,1093.739004,1096.6380112,1737.8885426,25.8840151,33.1862705,2.2920624,100.0287622),(40674,'tibia fibula',248,8,140,344.2277095,64.8548708,122.1753074,1.8,65.2164303,122.3644892,0.9428855,14.1727678,18.5947855,15499.9943851,19982.5208545,37.572238,1074.6303488,1093.64625,1728.1858885,26.0175849,32.9041144,2.2822555,99.4210916),(40675,'tibia fibula',248,8,141,345.4900873,64.9953807,122.2634839,1.8,65.3710148,122.474429,0.9070353,14.1137094,18.7245219,15517.0608376,19948.0672604,35.7260295,1065.3445432,1099.431794,1741.3774492,25.9432881,32.8648125,2.300696,98.7091612),(40676,'tibia fibula',248,8,142,345.820802,65.1346786,122.352212,1.8,65.4862008,122.6025301,0.8700659,14.1175168,18.8341713,15503.1597123,19823.7807223,33.6750894,1052.5432944,1098.1506121,1732.9993954,25.9395424,32.8872764,2.8363695,99.0651264),(40677,'tibia fibula',248,8,143,345.9192723,65.281658,122.4451079,1.8,65.6101665,122.6788183,0.8299158,14.0587158,18.9254457,15481.8954386,19746.0540004,31.3898032,1043.3600509,1101.2311293,1742.9362902,25.9295631,32.7607161,2.8488796,98.813421),(40678,'tibia fibula',248,8,144,346.7626478,65.4106522,122.5325573,1.8,65.7860916,122.7763129,0.7940024,14.0166593,19.2727287,15475.5113943,19723.9226618,29.3941312,1023.4110052,1104.0798679,1738.003881,26.0522257,32.7607161,2.8488796,98.7091612),(40679,'tibia fibula',248,8,145,344.4224121,65.6064375,122.5947904,1.8,66.003077,122.8230398,0.7370501,13.7697954,19.4383284,15337.6208168,19443.5431364,25.9308309,1000.2682715,1113.8597488,1718.476322,26.0043734,32.8282757,2.8902649,97.5980798),(40680,'tibia fibula',248,8,146,343.2231448,65.7255544,122.6670503,1.8,66.0371063,122.8727381,0.7025319,13.7604692,19.4837317,15268.8966988,19286.2201244,23.8833315,989.8627458,1109.6203569,1719.0924703,25.9721966,32.7607161,2.8488796,97.954045),(40681,'tibia fibula',248,8,147,342.7240235,65.8567061,122.7281455,1.8,66.1932401,122.9188502,0.6682598,13.741936,19.5008421,15201.1236006,19129.8832484,21.9303511,980.9772918,1106.185007,1720.3238446,26.0540839,32.6393222,2.8614847,97.3463744),(40682,'tibia fibula',248,8,148,342.9022212,65.9818677,122.7954795,1.8,66.3582103,123.0067657,0.63616,13.6944365,19.5764953,15143.6535569,18989.69732,20.1722429,970.0253827,1105.8252381,1704.9538879,25.9464009,32.7240631,2.9029833,97.094669),(40683,'tibia fibula',248,8,149,342.4258712,66.0979955,122.8619864,1.8,66.5067543,123.0966039,0.6049266,13.5129039,19.5644855,15055.3329411,18913.3390269,18.4579876,966.7179349,1114.1448957,1708.0942601,26.0540839,32.6393222,2.8614847,97.8065994),(40684,'tibia fibula',248,8,150,342.3372479,66.2382985,122.9374587,1.8,66.732025,123.2469744,0.5713558,13.4283869,29.3249238,15003.6155156,18918.8611081,16.6852584,645.1461295,1117.3058747,1139.5691306,25.9687216,32.5231526,2.8741819,96.8429636),(40685,'tibia fibula',248,8,151,341.1300918,66.3644529,122.9939964,1.8,66.8090288,123.2870208,0.5474201,13.517851,19.2976409,14912.9085418,18758.9180761,15.4023498,972.0834892,1103.2011326,1734.1551944,25.9277421,32.2065417,2.9127938,95.9835876),(40686,'tibia fibula',248,8,152,340.7834316,66.5033446,123.0490019,1.8,66.9373196,123.3261993,0.5157701,13.6309192,19.1976013,14833.7816185,18651.5803428,13.8159895,971.5578537,1088.2451445,1740.9210264,25.78128,32.0225685,2.938934,95.1242116),(40687,'tibia fibula',248,8,153,339.4278987,66.6343841,123.1034302,1.8,67.0439257,123.3694808,0.4863846,13.5768909,18.8820624,14752.5267842,18502.6200517,12.3604625,979.9046144,1086.5909504,1753.8933912,25.78128,31.9388567,2.9521125,94.516541),(40688,'tibia fibula',248,8,154,338.0174238,66.7772024,123.1518662,1.8,67.1853123,123.3999712,0.4565272,13.6353514,18.7604811,14655.0470528,18378.617984,10.9480613,979.6453432,1074.783231,1756.157908,25.78128,31.7882009,2.909728,94.0131302),(40689,'tibia fibula',248,8,155,337.3443571,66.9046573,123.2019543,1.8,67.2828264,123.4448961,0.4276694,13.738383,18.6207913,14564.2594934,18211.0083155,9.6715818,977.9932547,1060.1145361,1760.0919434,25.78128,31.5169631,2.9495446,94.0131302),(40690,'tibia fibula',248,8,156,336.9694427,67.0325677,123.2497801,1.8,67.3897612,123.4594183,0.398643,13.7737807,18.3679815,14479.3026183,18030.2985285,8.4621158,981.6156723,1051.2220972,1768.7433824,25.7132114,31.4377783,2.9629616,93.1537542),(40691,'tibia fibula',248,8,157,336.526774,67.1806249,123.3017882,1.8,67.5261908,123.5007729,0.3702078,13.8353178,18.2226507,14406.0844925,17976.2401208,7.3422206,986.4777872,1041.2543282,1776.9856686,25.6938418,31.2965106,2.9899872,92.9020488),(40692,'tibia fibula',248,8,158,335.3942539,67.3163032,123.3467083,1.8,67.6553355,123.5533272,0.3461175,13.7372411,18.0778287,14298.7632371,17889.77337,6.4333797,989.5974609,1040.8759019,1780.3011467,25.5027815,31.0952829,2.9469071,91.938413),(40693,'tibia fibula',248,8,159,334.310857,67.4439404,123.3905294,1.8,67.7302976,123.5909945,0.3140987,13.8130011,17.9238914,14224.6276996,17757.4296487,5.318657,990.7128579,1029.7999405,1782.1761069,25.2832777,31.0150215,2.9605,91.3307424),(40694,'tibia fibula',248,8,160,334.4256084,67.5572472,123.4395811,1.8,67.8169586,123.6396038,0.2821531,13.8921149,17.764137,14173.3750018,17697.8217006,4.3207825,996.2668972,1020.2460264,1788.2895134,25.2636624,30.9405198,2.9741609,91.5824478),(40695,'tibia fibula',248,8,161,332.3160505,67.7238912,123.4441794,1.8,67.9938728,123.6216902,0.2398159,13.9245634,17.5244291,13958.2020688,17495.1845818,3.1247425,998.3312149,1002.4157768,1780.5655889,25.1989464,30.7609795,2.9304993,90.7230718),(40696,'tibia fibula',248,8,162,330.647203,67.8146538,123.4658778,1.8,68.0330896,123.6330714,0.2134533,13.8692641,17.3664504,13848.4506089,17395.8395767,2.4729406,1001.6922978,998.4993047,1778.0404918,24.9722538,30.673825,2.9441971,90.7230718),(40697,'tibia fibula',248,8,163,329.8805895,67.9352712,123.499213,1.8,68.1366021,123.6750437,0.1775338,13.7343431,17.134327,13736.152215,17275.4464494,1.7147474,1008.2360637,1000.1317254,1777.3960973,24.7116703,30.5169246,2.9718144,90.219661),(40698,'tibia fibula',248,8,164,329.6262452,68.0366344,123.5279592,1.8,68.2384256,123.7066192,0.1492075,13.7390832,16.8658207,13653.2104465,17212.2357369,1.2140227,1020.5394719,993.7497431,1795.2358938,24.682292,30.3257462,3.0137227,89.8636958),(40699,'tibia fibula',248,8,165,328.2003844,68.1596764,123.5522333,1.8,68.3548948,123.7427962,0.1248655,13.7341796,16.6544705,13531.3489778,17129.0870556,0.848427,1028.4978498,985.2316867,1796.2667849,24.7671279,30.1700955,2.9553698,89.5077306),(40700,'tibia fibula',248,8,166,327.5020846,68.2884946,123.5831331,1.8,68.4823034,123.7686664,0.0989767,13.689518,16.7635322,13433.066652,17117.2014683,0.5329796,1021.0975408,981.2665918,1789.0509303,24.7085269,30.3835299,2.9996956,89.8636958),(40701,'tibia fibula',248,8,167,328.1260841,68.4255618,123.6279719,1.8,68.5889868,123.8217057,0.0738243,13.7097382,16.5364163,13350.4372529,17085.0272004,0.2975085,1033.175924,973.7922844,1797.5035013,24.6611933,30.2739516,3.0278006,89.6119904),(40702,'tibia fibula',248,8,168,328.4479588,68.5669821,123.6649134,1.8,68.7183804,123.8514242,0.0544083,13.365672,16.3194295,13254.4484605,17088.5013069,0.1618888,1047.1261452,991.6784171,1807.6343723,24.4403149,30.188449,3.0560874,89.0043198),(40703,'tibia fibula',248,8,169,326.7902452,68.6950988,123.6980485,1.8,68.8294461,123.8795107,0.0366069,13.3557119,16.1176421,13146.3449077,17052.4385435,0.0729542,1057.9983343,984.3237898,1813.3310533,24.3701784,29.9582221,2.9976672,88.3966492),(40704,'tibia fibula',248,8,170,326.7104059,68.8160272,123.7322786,1.8,68.9450605,123.9015836,0.0201793,13.3504449,15.9250181,13042.9698244,17037.3074179,0.0221699,1069.8454069,976.9689303,1819.9480364,24.3701784,29.8996165,3.0118901,88.3966492),(40705,'tibia fibula',248,8,171,326.8456347,68.9291861,123.7624518,1.8,69.0102345,123.9185548,0.0032436,13.3403473,15.7345585,12947.9188142,17010.3502999,0.0005732,1081.0821455,970.5833412,1825.4949382,24.2763383,29.8470824,3.026166,88.1449438),(40706,'tibia fibula',248,8,172,326.5560426,69.0585691,123.7912106,1.8,69.1710712,123.919088,-0.0109081,13.3592776,15.5519915,12845.7083595,16955.01118,0.0064756,1090.2147908,961.5571073,1830.640227,24.2412267,29.5986112,2.9812172,87.5372732),(40707,'tibia fibula',248,8,173,326.7082799,69.177104,123.8161842,1.8,69.2374824,123.9647441,-0.0254949,13.3709963,15.3804582,12771.0237497,16946.5789216,0.0353853,1101.8253598,955.1288048,1839.1714006,24.1152662,29.5330411,2.9955804,87.2855678),(40708,'tibia fibula',248,8,174,325.5646818,69.2948982,123.8404534,1.8,69.3304208,123.9793983,-0.0376494,13.0084313,15.2329409,12654.827658,16898.107675,0.0768771,1109.3135452,972.8173471,1842.6403882,23.9996027,29.4202952,3.0244839,86.9296026),(40709,'tibia fibula',248,8,175,324.4544854,69.4119459,123.8705341,1.8,69.4469211,123.9890083,-0.0456312,13.0276779,15.0890189,12567.3825346,16866.6047492,0.1125189,1117.8065917,964.6678896,1849.1452563,23.9483849,29.3323044,3.0535853,86.6778972),(40710,'tibia fibula',248,8,176,323.3619688,69.5140695,123.903754,1.8,69.5591894,124.0213501,-0.0483472,13.0451641,14.9788429,12506.7966287,16819.2651198,0.1258755,1122.8681139,958.7304963,1854.876478,23.9996027,29.1079925,2.9934326,86.0702266),(40711,'tibia fibula',248,8,177,319.0038755,69.6658514,123.8646187,1.8,69.6757305,123.9906209,-0.0635935,12.9824103,14.7685252,12251.77274,16643.5075218,0.2147261,1126.9579962,943.72096,1843.2242096,23.864156,29.0476715,3.0080636,86.321932),(40712,'tibia fibula',248,8,178,318.2020141,69.7579101,123.8824426,1.8,69.791957,123.9705941,-0.0683092,12.973371,14.6889555,12152.7200602,16591.479277,0.2470785,1129.5206954,936.7434332,1844.5560131,23.6942043,28.9457943,3.0374927,86.321932),(40713,'tibia fibula',248,8,179,317.5545161,69.8694736,123.9091673,1.8,69.9321548,123.9971886,-0.0733296,12.9392016,14.5621119,12061.5244424,16525.9815508,0.2840843,1134.8615943,932.1691439,1848.0776294,23.5730246,28.7505907,2.976444,85.7142614),(40714,'tibia fibula',248,8,180,317.518429,69.9790991,123.945119,1.8,70.0436145,124.0646295,-0.0802135,12.644852,14.4313132,11987.3547098,16488.5196141,0.3397665,1142.551578,948.002766,1854.6917701,23.4720192,28.6830821,2.9912212,85.1065908),(40715,'tibia fibula',248,8,181,316.1908705,70.0855918,123.9746873,1.8,70.1178168,124.0861821,-0.0875241,12.6785581,14.301468,11870.4221355,16391.393146,0.4026648,1146.1336086,936.25963,1838.1259909,23.4720192,28.6218657,3.0060649,85.1065908),(40716,'tibia fibula',248,8,182,315.7786941,70.1961039,124.0084431,1.8,70.2477756,124.0945847,-0.0894909,12.682381,14.1872722,11804.7642293,16317.2878021,0.4203679,1150.1356706,930.8003177,1842.8796369,23.5228723,28.5184673,3.0359271,85.3582962),(40717,'tibia fibula',248,8,183,314.8344984,70.299535,124.0397396,1.8,70.3675558,124.1097177,-0.0936072,12.6789019,14.1124344,11729.359052,16235.9547261,0.4584386,1150.4715855,925.1084289,1845.6713074,23.4720192,28.3268372,2.9739502,84.4989202),(40718,'tibia fibula',248,8,184,314.6793517,70.398374,124.0758978,1.8,70.4419657,124.1682188,-0.09647,12.6376905,14.0083423,11658.2093954,16167.5572789,0.4865794,1154.1377974,922.4952481,1831.8452528,23.3844172,28.3268372,2.9739502,84.4989202),(40719,'tibia fibula',248,8,185,314.1679217,70.4995031,124.1061243,1.8,70.5363644,124.202926,-0.099593,12.3716347,13.900699,11573.0651043,16088.1699364,0.5176448,1157.3640988,935.4515671,1833.7299841,23.1720482,28.1961776,3.0040059,84.3946604),(40720,'tibia fibula',248,8,186,313.4748252,70.6284871,124.1428497,1.8,70.6894158,124.2455303,-0.0978404,12.3801472,13.7814894,11503.6793015,16014.1668711,0.4985424,1162.0055325,929.2037606,1840.5392199,23.203152,28.0616202,2.9411941,83.5352844),(40721,'tibia fibula',248,8,187,312.4541472,70.7422401,124.1729258,1.8,70.7761857,124.2723417,-0.098027,12.3789613,13.6706442,11434.0320548,15942.3561109,0.4988099,1166.1744563,923.6665155,1845.5340652,23.203152,27.9792555,2.9562447,83.5352844),(40722,'tibia fibula',248,8,188,311.3222984,70.8576854,124.2143712,1.8,70.9121292,124.3435054,-0.0972826,12.3907082,13.5889677,11362.5242508,15857.3857184,0.4895072,1166.9308539,917.0197591,1830.9858662,23.203152,27.9032651,2.9713807,83.7869898),(40723,'tibia fibula',248,8,189,312.0029183,70.9792839,124.2462915,1.8,71.0987968,124.3509743,-0.093831,12.3993538,13.4945724,11329.0232359,15809.6216199,0.4564842,1171.5540998,913.6785196,1840.9633463,23.1441937,27.7306933,2.9229237,83.1793192),(40724,'tibia fibula',248,8,190,311.9986102,71.0857884,124.2843703,1.8,71.1577201,124.3875571,-0.0908897,12.4136207,13.4434442,11280.9547322,15739.0170094,0.4283849,1170.7577874,908.7561933,1847.0734321,23.1441937,27.6406638,2.9380996,83.1793192),(40725,'tibia fibula',248,8,191,312.1400494,71.1996253,124.3254613,1.8,71.2743592,124.4544059,-0.0854282,12.1581786,13.5104469,11231.9038734,15669.8746664,0.3787425,1159.8339288,923.8146826,1854.3241796,22.9998731,27.7140433,3.0172377,83.5352844),(40726,'tibia fibula',248,8,192,312.2993362,71.2877277,124.3615426,1.8,71.3616261,124.4811432,-0.0794301,12.1712562,13.4963136,11207.5675417,15581.7659429,0.3276999,1154.5201462,920.8225835,1858.7712748,23.0648514,27.6640329,3.0326507,83.3878388),(40727,'tibia fibula',248,8,193,310.4226381,71.4334296,124.2949949,1.8,71.4922068,124.4323939,-0.0783556,12.1173952,13.4101393,11055.5903883,15373.3280554,0.3169958,1146.3958538,912.3735134,1847.8215586,22.773464,27.479883,2.968732,82.3199432),(40728,'tibia fibula',248,8,194,309.849832,71.5301076,124.3289664,1.8,71.620433,124.4486195,-0.0752342,12.1288217,13.3595176,10999.9984537,15277.0000385,0.2917506,1143.5293161,906.9305133,1850.4375072,22.773464,27.4092448,2.9841758,82.3199432),(40729,'tibia fibula',248,8,195,309.6723617,71.6209439,124.3613254,1.8,71.7014461,124.5144464,-0.0715951,12.1409363,13.3825176,10947.4665652,15156.6211231,0.2641045,1132.568744,901.6987044,1850.8127402,23.0302102,27.3451769,2.9996956,82.424203),(40730,'tibia fibula',248,8,196,309.5021088,71.7303265,124.3913476,1.8,71.8211834,124.5619619,-0.067508,12.1550625,13.1868349,10895.4401592,15041.5533126,0.2347272,1140.649244,896.3705599,1853.7558447,23.163657,27.1350609,2.9504082,82.3199432),(40731,'tibia fibula',248,8,197,307.8757826,71.8244062,124.4154972,1.8,71.8992335,124.5948736,-0.0675463,12.1854415,13.2017143,10782.6808648,14874.2118462,0.2337581,1126.6879053,884.8822486,1846.2184576,23.1376248,27.0566997,2.9660005,84.142955),(40732,'tibia fibula',248,8,198,306.0485994,71.9058341,124.4475129,1.8,71.9975227,124.7057351,-0.0671929,12.1945732,13.2508351,10682.3664545,14696.5595376,0.2299496,1109.1044027,875.9934661,1815.4899709,23.2208028,26.9849538,2.9816795,84.2472148),(40733,'tibia fibula',248,8,199,304.7038087,71.9959208,124.4453136,1.8,72.069966,124.6972783,-0.0656638,12.229474,13.280314,10595.4336006,14521.6776577,0.2186524,1093.4739698,866.3850607,1807.2534855,23.373225,26.861515,3.0132694,85.9659668),(40734,'tibia fibula',248,8,200,302.9515972,72.0876904,124.4493669,1.8,72.1729688,124.706346,-0.0639631,12.2143285,13.0220159,10478.3465024,14350.5364559,0.2062949,1102.0211116,857.8733191,1797.5317174,23.4339347,26.7133266,2.9473517,84.4989202),(40735,'tibia fibula',248,8,201,302.1565056,72.1771372,124.467457,1.8,72.2796468,124.6429135,-0.0606028,11.918791,13.073347,10375.8913787,14214.2542422,0.1847289,1087.2697092,870.5489846,1791.5328918,23.203152,26.6337246,2.9631822,81.8165324),(40736,'tibia fibula',248,8,202,301.0660591,72.2698088,124.5112878,1.8,72.3792657,124.8272821,-0.0546736,11.9431753,13.0997338,10347.495376,14072.0821946,0.149842,1074.226576,866.3939991,1792.4702419,23.5100308,26.5608362,2.9791035,83.3878388),(40737,'tibia fibula',248,8,203,299.571381,72.3626632,124.5230711,1.8,72.4809584,124.8472043,-0.0508779,11.9601145,12.8425987,10289.7070024,13911.1629852,0.1291319,1083.2046789,860.335158,1787.8413927,23.588469,26.3794839,2.928224,83.6395442),(40738,'tibia fibula',248,8,204,297.8856929,72.4489866,124.5203143,1.8,72.5561746,124.8498972,-0.0475193,11.9409947,12.8959277,10201.709372,13767.8213579,0.1120241,1067.6099989,854.3433455,1780.5119312,23.588469,26.29185,2.9441971,83.8912496),(40739,'tibia fibula',248,8,205,297.1322274,72.5368192,124.518235,1.8,72.6253447,124.8467474,-0.0413951,11.9442031,12.945246,10150.7729607,13669.78021,0.0848102,1055.9691356,849.8493289,1779.4527969,23.568857,26.210968,2.9602729,83.8912496),(40740,'tibia fibula',248,8,206,296.1297887,72.6195689,124.5135296,1.8,72.7205748,124.8153852,-0.0380606,11.9267173,12.9853536,10064.4795638,13550.9697752,0.0714616,1043.5580117,843.8599922,1767.6949784,23.4590063,26.210968,2.9602729,82.7801682),(40741,'tibia fibula',248,8,207,295.9926576,72.7063909,124.5075929,1.8,72.8410446,124.7979503,-0.0327072,11.925871,12.6731545,10008.7522697,13438.3871931,0.052755,1060.3821761,839.247071,1765.5066607,23.5100308,26.1580842,2.8926299,83.283579),(40742,'tibia fibula',248,8,208,295.1335604,72.7770281,124.5026981,1.8,72.8852934,124.8196309,-0.0276392,11.912428,12.7138375,9933.9392225,13338.8405415,0.037567,1049.1592784,833.9138965,1742.32822,23.5100308,26.0555377,2.9086134,83.0318736),(40743,'tibia fibula',248,8,209,292.4682608,72.8590345,124.3911396,1.8,72.9495416,124.7347989,-0.0181575,11.8292216,12.7591971,9775.8342937,13126.6620004,0.0160692,1028.8000045,826.4139927,1737.4268715,23.486952,25.9596993,2.924719,82.7801682),(40744,'tibia fibula',248,8,210,291.2904779,72.9364299,124.3794946,1.8,72.9990691,124.6435378,-0.0098112,11.8236849,12.8070459,9688.6994053,13025.0623111,0.0046731,1017.0231651,819.4314603,1726.7666009,23.3752315,25.8706435,2.9409398,82.5284628),(40745,'tibia fibula',248,8,211,289.9377424,73.0282424,124.3727522,1.8,73.0789662,124.6091367,0.0003104,11.7954351,12.8715816,9580.7543462,12907.3742448,0.0000047,1002.7807528,812.2425581,1716.4425893,23.2388895,25.7418618,2.888517,83.0318736),(40746,'tibia fibula',248,8,212,289.6379676,73.1216464,124.3674088,1.8,73.1536623,124.6097119,0.0122342,11.8188973,12.5475086,9514.426726,12806.4968455,0.007225,1020.6406135,805.0181388,1708.5140534,23.2388895,25.7418618,2.888517,82.0682378),(40747,'tibia fibula',248,8,213,288.1121258,73.1938843,124.3562646,1.8,73.2461024,124.6192856,0.0198422,11.8239275,12.6174204,9415.1995034,12672.9820026,0.0189032,1004.4035638,796.2835945,1699.0305613,23.3736888,25.6448512,2.9902172,82.424203),(40748,'tibia fibula',248,8,214,286.9958868,73.2563986,124.3317617,1.8,73.3280211,124.5979537,0.0229239,11.8047124,12.6705441,9335.1752733,12559.9520473,0.0251319,991.2717185,790.80074,1682.3127065,23.1780646,25.6448512,2.9902172,83.0318736),(40749,'tibia fibula',248,8,215,286.5366013,73.3358012,124.330899,1.8,73.4237365,124.6031241,0.0303538,11.8036665,12.7224235,9281.3367881,12466.6116273,0.0439869,979.8928344,786.3096406,1679.9138143,23.1970586,25.5583104,2.8517462,81.9207922),(40750,'tibia fibula',248,8,216,286.5631771,73.4127047,124.3206523,1.8,73.5111005,124.5940357,0.0380759,11.78539,12.4260976,9228.3196276,12384.12091,0.0692086,996.6218954,783.0304846,1677.4981004,23.1970586,25.4497205,2.9375747,81.3131216),(40751,'tibia fibula',248,8,217,287.6600577,73.5002124,124.3103987,1.8,73.5519303,124.5649297,0.0493967,11.543047,12.5181682,9188.3167168,12337.2975337,0.1168884,985.5513458,796.0044465,1680.0424603,23.0786205,25.4497205,2.9375747,80.9571564),(40752,'tibia fibula',248,8,218,287.9137306,73.5832099,124.2923554,1.8,73.6195555,124.5172095,0.0592891,11.5770232,12.5775601,9147.906309,12273.8516017,0.1684812,975.8531486,790.1777654,1672.6480593,23.0325532,25.4497205,2.9375747,81.8165324),(40753,'tibia fibula',248,8,219,287.3944677,73.6575054,124.2706339,1.8,73.6711053,124.4595605,0.0657356,11.5260187,12.6204702,9094.0948661,12196.6645646,0.2066822,966.4191914,789.0057375,1665.5937115,22.8246513,25.3661535,2.9541635,81.564827),(40754,'tibia fibula',248,8,220,287.1132679,73.7359174,124.240852,1.8,73.7651699,124.3587356,0.0732806,11.4039958,12.3563942,9032.0521949,12114.4865233,0.2565091,980.4224686,792.0076721,1659.0861385,21.914088,25.2201601,2.9007462,76.7034622),(40755,'tibia fibula',248,8,221,287.4651313,73.8146661,124.2212872,1.8,73.8212374,124.3314513,0.0808669,11.3923616,12.401628,9007.3390706,12064.8138041,0.3126287,972.8411343,790.6472203,1656.6156123,21.914088,25.2201601,2.9007462,76.9551676),(40756,'tibia fibula',248,8,222,287.5125761,73.8988549,124.203947,1.8,73.8884991,124.303688,0.0904222,11.383742,12.4823731,8959.8123527,11999.4831374,0.3907257,961.3142526,787.0709286,1648.6937297,21.914088,25.2201601,2.9007462,76.4517568),(40757,'tibia fibula',248,8,223,286.8966333,73.9689567,124.1764767,1.8,73.9532953,124.2733476,0.0954518,11.3574381,12.5071971,8901.8593203,11929.8114566,0.4343335,953.8357312,783.7911344,1647.8899491,21.914088,25.1578563,3.0045265,76.807722),(40758,'tibia fibula',248,8,224,286.2985942,74.0265018,124.1532449,1.8,74.0516479,124.2517826,0.0997769,11.3347098,12.4730943,8851.1276451,11875.7110807,0.4734632,952.1062535,780.8870076,1640.358794,21.914088,25.102754,3.0214839,76.5560166),(40759,'tibia fibula',248,8,225,284.3086552,74.1179725,124.0084529,1.8,74.1471971,124.1330826,0.1041373,11.2315753,12.3374241,8728.4088968,11739.8010828,0.5120128,951.5601462,777.1313147,1631.2132237,21.914088,25.0290955,2.9340964,75.948346),(40760,'tibia fibula',248,8,226,283.6792847,74.174692,123.9817768,1.8,74.1943709,124.0768302,0.1090981,11.2068675,12.3452861,8682.0926158,11682.5219539,0.5605149,946.3143947,774.7118134,1615.0807195,21.914088,24.9441193,2.9509537,75.6966406),(40761,'tibia fibula',248,8,227,283.5304043,74.2343299,123.9605241,1.8,74.2352102,124.066519,0.1116694,11.182994,12.4014886,8641.1962015,11629.7718532,0.586828,937.7722519,772.7086512,1610.8503265,21.914088,24.9441193,2.9509537,75.6966406),(40762,'tibia fibula',248,8,228,283.2288391,74.2996764,123.9336021,1.8,74.3181972,124.0335291,0.1166478,11.1556929,12.4115312,8597.609297,11564.871532,0.6393947,931.7844318,770.6925382,1602.8647598,21.8816403,24.8662788,2.9679215,75.948346),(40763,'tibia fibula',248,8,229,282.389324,74.3622854,123.9037541,1.8,74.3791563,124.0212031,0.1207066,11.1238096,12.4148507,8533.4944979,11487.94836,0.682415,925.3392281,767.1377686,1596.7679852,21.8313566,24.8662788,2.9679215,75.6966406),(40764,'tibia fibula',248,8,230,281.6988571,74.4305222,123.8730372,1.8,74.4489482,123.9838087,0.1233262,11.0880932,12.2073568,8484.0977366,11430.1417529,0.7104632,936.332242,765.1539007,1597.7118938,21.7817799,24.702389,2.91349,75.3406754),(40765,'tibia fibula',248,8,231,280.8973873,74.4857226,123.8415627,1.8,74.4840574,123.9418256,0.1235435,11.0503012,12.2582379,8432.4096607,11372.9755277,0.710928,927.7822493,763.0931992,1593.0717633,21.7452983,24.702389,2.91349,75.3406754),(40766,'tibia fibula',248,8,232,280.6163554,74.5446921,123.8033305,1.8,74.5697429,123.8910355,0.1242027,11.0589955,12.3119277,8382.6032558,11333.9972513,0.717777,920.570483,757.989568,1587.7472394,21.4844,24.702389,2.91349,75.08897),(40767,'tibia fibula',248,8,233,279.6374153,74.6013058,123.7602965,1.8,74.6438571,123.8719989,0.1238116,11.0087353,12.3098002,8327.8070226,11287.3687196,0.7107987,916.9416709,756.4726359,1579.9981352,21.4844,24.7956411,0.1566019,75.08897),(40768,'tibia fibula',248,8,234,279.4460137,74.6590915,123.7269871,1.8,74.6862166,123.8436801,0.1286674,10.9749241,12.3043708,8286.8908989,11241.7401818,0.766806,913.6379549,755.0750055,1571.8694446,21.4844,24.7956411,0.1566019,75.08897),(40769,'tibia fibula',248,8,235,279.5754238,74.7227065,123.6917258,1.8,74.720776,123.7973579,0.1334606,11.0775404,12.356921,8252.4699431,11213.6400354,0.8250378,907.478494,744.9731282,1563.3148348,21.6089563,24.7956411,0.1566019,75.4449352),(40770,'tibia fibula',248,8,236,279.1484209,74.7817969,123.6510268,1.8,74.8190855,123.7310375,0.1366841,11.0844039,12.2142249,8218.9259973,11172.8536625,0.8638007,914.7411134,741.4856089,1571.2988611,21.5749987,24.702389,0.2281026,75.08897),(40771,'tibia fibula',248,8,237,278.8245879,74.8274335,123.6011421,1.8,74.8679987,123.6874724,0.138304,11.0275986,12.1939237,8185.9929241,11135.568057,0.8832393,913.2063065,742.318723,1569.6734908,21.4726143,24.702389,0.2281026,74.8372646),(40772,'tibia fibula',248,8,238,278.0399029,74.8700015,123.5542651,1.8,74.9021812,123.6337438,0.1419388,11.0332312,12.2289431,8147.2319556,11078.2681498,0.9273416,905.9056086,738.4266512,1564.8730515,21.5448881,24.6087836,0.2110933,74.8372646),(40773,'tibia fibula',248,8,239,277.0183856,74.9117981,123.5057393,1.8,74.9157415,123.5914017,0.1442722,10.978284,12.2628075,8102.7330146,11016.8615738,0.9543486,898.3963576,738.0691729,1550.0808339,21.4699271,24.702389,0.2281026,74.8372646),(40774,'tibia fibula',248,8,240,277.0239245,74.9569847,123.4656025,1.8,74.9882554,123.5265459,0.1486752,10.9935019,12.3001468,8074.3635638,10980.5878663,1.0130735,892.7200659,734.4669297,1546.239118,21.4672755,24.7956411,0.1566019,75.1932298),(40775,'tibia fibula',248,8,241,275.2018886,74.9903324,123.3135448,1.8,75.0008762,123.3568631,0.1476185,10.9014946,12.3111742,7972.0230399,10864.4432396,0.9922589,882.4863535,731.2779884,1528.4111432,21.3362723,24.7956411,0.1566019,74.5855592),(40776,'tibia fibula',248,8,242,274.1209535,75.0237196,123.2575104,1.8,75.0462592,123.2988754,0.153438,10.8427162,12.2666144,7926.4568943,10826.0240987,1.0672003,882.5600733,731.0397832,1521.6434852,21.3317486,24.7956411,0.1566019,74.5855592),(40777,'tibia fibula',248,8,243,273.1536508,75.0554318,123.1953082,1.8,75.0805623,123.2535026,0.1604923,10.7776409,12.2113103,7880.0251138,10762.0712856,1.1626051,881.3199399,731.145639,1511.504564,21.1999303,24.732268,0.1394401,74.3338538),(40778,'tibia fibula',248,8,244,271.7435676,75.0912516,123.1309063,1.8,75.1414759,123.226888,0.1657455,10.708789,12.0868547,7835.2036823,10705.1164237,1.2328517,885.6825579,731.6610416,1525.4368148,21.1400228,24.6087836,0.2110933,74.229594),(40779,'tibia fibula',248,8,245,270.1470622,75.1240391,123.0750791,1.8,75.1764494,123.1807755,0.1721441,10.7772384,12.1091183,7777.8575758,10638.433223,1.3211101,878.5473016,721.6930065,1519.4820546,21.1400228,24.6087836,0.2110933,74.5855592),(40780,'tibia fibula',248,8,246,269.6645019,75.156676,123.0194896,1.8,75.2228949,123.1034806,0.1791886,10.780349,12.1298006,7745.1327119,10591.197533,1.4277101,873.1551246,718.449164,1511.1518528,21.1400228,24.522351,0.1939591,74.3338538),(40781,'tibia fibula',248,8,247,268.8948671,75.1825185,122.9560218,1.8,75.2273867,123.0553929,0.1850727,10.7834046,12.1414322,7712.0824932,10531.4682561,1.5175811,867.3991719,715.1806662,1501.5181943,21.0635883,24.522351,0.1939591,73.9778886),(40782,'tibia fibula',248,8,248,268.2014349,75.2211683,122.8942907,1.8,75.2886241,122.9878496,0.1937027,10.7879349,12.080359,7678.9824439,10477.1928136,1.6563146,867.2915087,711.8120848,1497.2780952,20.948297,24.4431674,0.1767089,74.229594),(40783,'tibia fibula',248,8,249,267.6597365,75.2625493,122.8334921,1.8,75.3461791,122.9211827,0.2030367,10.711835,12.0982803,7648.2598062,10440.2300863,1.8138642,862.9515805,714.0008995,1487.423074,20.9272463,24.4431674,0.1767089,73.9778886),(40784,'tibia fibula',248,8,250,267.0644389,75.3078173,122.7746638,1.8,75.3960367,122.8569309,0.2156561,10.723692,12.021439,7624.960539,10402.5950234,2.0381929,865.3369216,711.038746,1481.7485788,20.948297,24.5862653,0.0874953,74.3338538),(40785,'tibia fibula',248,8,251,266.2365612,75.3534831,122.7141309,1.8,75.4518162,122.8047868,0.2255123,10.6470139,11.9988878,7583.80132,10366.6493857,2.2186172,863.9675221,712.2937342,1495.5762748,20.9272463,24.3713034,0.1593516,74.229594),(40786,'tibia fibula',248,8,252,265.4697798,75.3918953,122.6515099,1.8,75.4839736,122.7549043,0.2346248,10.5690699,12.0185595,7541.0476789,10327.6341692,2.3912649,859.307158,713.5015446,1485.631443,20.7554802,24.3713034,0.1593516,73.9778886),(40787,'tibia fibula',248,8,253,265.1401282,75.4270388,122.5931193,1.8,75.5088555,122.7082108,0.2444048,10.5979805,12.0333775,7519.2013939,10305.4203822,2.5874923,856.4029843,709.4937945,1479.1042827,20.8333614,24.3713034,0.1593516,74.229594),(40788,'tibia fibula',248,8,254,264.2177526,75.4611621,122.5275493,1.8,75.5670636,122.5993274,0.2546161,10.5185611,11.9343865,7493.414297,10265.1142388,2.7936822,860.1291931,712.3991826,1479.7708795,20.7554802,24.3068239,0.1418971,74.5855592),(40789,'tibia fibula',248,8,255,263.3419825,75.4875864,122.4618115,1.8,75.5645904,122.5122703,0.2637335,10.5525617,11.9307636,7468.1897913,10235.0738949,2.9826802,857.8724896,707.7134433,1473.1343702,20.5648453,24.3068239,0.1418971,73.7261832),(40790,'tibia fibula',248,8,256,262.9131892,75.5028526,122.4011074,1.8,75.5942069,122.4595359,0.2716556,10.553881,11.9173952,7461.8931231,10213.0177624,3.1549239,856.9840631,707.028357,1469.9696272,20.5648453,24.3068239,0.1418971,73.7261832),(40791,'tibia fibula',248,8,257,260.9760102,75.5391199,122.2483333,1.8,75.6577986,122.3317953,0.2827506,10.4949774,11.8381611,7393.615488,10130.596007,3.3857264,855.7575715,704.4908429,1461.1195067,20.5637544,24.2002479,0.1067357,73.7261832),(40792,'tibia fibula',248,8,258,260.108017,75.5598037,122.1956424,1.8,75.6758386,122.2580778,0.2930875,10.4602215,11.836642,7378.1281534,10108.4515625,3.6184789,853.9965611,705.3510414,1456.0400991,20.3731194,24.1582501,0.0890496,74.3338538),(40793,'tibia fibula',248,8,259,259.3840367,75.5887776,122.1375229,1.8,75.7243507,122.1986304,0.3021253,10.4689622,11.8401324,7361.5328935,10076.5263327,3.8274692,851.0484472,703.1769453,1467.213597,20.5637544,24.1008625,0.1973956,73.9778886),(40794,'tibia fibula',248,8,260,258.7399515,75.6143819,122.0722205,1.8,75.7344182,122.113558,0.3130457,10.5150943,11.834082,7341.6707467,10052.2976219,4.0897274,849.4361991,698.2030329,1459.1216052,20.5637544,24.0202894,0.1798535,73.9778886),(40795,'tibia fibula',248,8,261,257.7874753,75.6409461,122.011125,1.8,75.7677954,122.0691938,0.3238617,10.4387079,11.8274731,7314.7145668,10006.6388478,4.351033,846.0504438,700.7298825,1449.130396,20.5637544,23.9471564,0.1621988,73.7261832),(40796,'tibia fibula',248,8,262,257.2718491,75.6601612,121.9463389,1.8,75.789716,121.989564,0.3329392,10.4969534,11.8124246,7310.4309652,9980.3111288,4.5799856,844.8994577,696.4335948,1449.7608894,20.5637544,23.9471564,0.1621988,73.9778886),(40797,'tibia fibula',248,8,263,256.7444737,75.6817327,121.8842184,1.8,75.8380268,121.9128187,0.3427847,10.4214413,11.7970434,7293.4722092,9956.0816823,4.8340998,843.9471921,699.8525432,1442.2382167,20.3720286,23.9471564,0.1621988,73.6219234),(40798,'tibia fibula',248,8,264,256.7904637,75.7066174,121.8150824,1.8,75.8287188,121.8064562,0.3536322,10.4848551,11.8213958,7296.9486096,9948.3751572,5.1327652,841.5567296,695.95131,1442.4047327,20.5626635,23.9471564,0.1621988,73.7261832),(40799,'tibia fibula',248,8,265,257.1697422,75.7381498,121.7482712,1.8,75.8623817,121.7397699,0.3639101,10.4985917,11.8216058,7306.7862141,9950.6686623,5.4300045,841.7357896,695.9777458,1454.8256175,20.3731194,23.9394452,2.7744188,73.4744778),(40800,'tibia fibula',248,8,266,258.313564,75.7652749,121.6811954,1.8,75.8685481,121.6701143,0.3788798,10.475395,11.8106836,7327.4088709,9979.4192398,5.8900298,844.9484861,699.4875936,1455.1099959,20.5626635,23.9394452,2.7744188,73.7261832),(40801,'tibia fibula',248,8,267,259.2970359,75.7909099,121.6110032,1.8,75.9019385,121.6072902,0.3906347,10.4627908,11.7960705,7339.5494928,10011.4567782,6.2659078,848.7111709,701.4906087,1453.5090412,20.3731194,23.9394452,2.7744188,73.7261832),(40802,'tibia fibula',248,8,268,260.148692,75.8157021,121.5330707,1.8,75.9457374,121.5428365,0.4049869,10.4125637,11.7707193,7361.3533517,10036.201423,6.73097,852.6413002,706.9683851,1461.1096508,20.542229,23.9394452,2.7744188,73.7261832),(40803,'tibia fibula',248,8,269,261.8387441,75.8463524,121.4574871,1.8,75.9745705,121.4559567,0.4191518,10.4221583,11.7472194,7401.0674074,10092.4659756,7.2283838,859.1365886,710.1280932,1466.5579278,20.3731194,23.9394452,2.7744188,74.0821484),(40804,'tibia fibula',248,8,270,262.5652422,75.8736707,121.3778778,1.8,75.9997509,121.3930112,0.4285565,10.3566625,11.7231486,7418.9327574,10120.9973017,7.5570073,863.3343893,716.3439753,1464.5504114,20.3731194,23.9587186,2.5734879,73.830443),(40805,'tibia fibula',248,8,271,263.412758,75.894454,121.291977,1.8,76.0392776,121.3200371,0.437607,10.402778,11.6885937,7440.862026,10152.4521762,7.8841059,868.5777286,715.276444,1472.0781695,20.3731194,23.9587186,2.5734879,73.7261832),(40806,'tibia fibula',248,8,272,264.5254162,75.9087366,121.204195,1.8,76.0594225,121.2202508,0.4481702,10.3173022,11.6460311,7464.2764014,10195.495611,8.2780473,875.4480862,723.471726,1470.2806889,20.3731194,23.9394452,2.7744188,73.9778886),(40807,'tibia fibula',248,8,273,264.9798342,76.0034263,120.9995644,1.8,76.1099267,121.0096648,0.4580187,10.4421965,11.6518666,7452.5050152,10188.545159,8.6346304,874.4131303,713.6913183,1468.3569961,20.5608247,23.9587186,2.5734879,73.7261832),(40808,'tibia fibula',248,8,274,265.017376,76.0170453,120.9068414,1.8,76.1156447,120.9323736,0.4657368,10.3489174,11.7588318,7477.6831523,10202.5492343,8.9078504,867.6498964,722.5570449,1468.2035371,20.3731194,24.039498,2.6379664,73.7261832),(40809,'tibia fibula',248,8,275,265.0209008,76.0331045,120.7968471,1.8,76.1554701,120.8421251,0.4762648,10.2567264,11.7443267,7495.4310681,10206.3943796,9.2840429,869.0489121,730.7820042,1466.6625396,20.3731194,24.0970318,2.5981151,73.4744778),(40810,'tibia fibula',248,8,276,264.8617258,76.0442122,120.6970951,1.8,76.1523918,120.7372021,0.484567,10.3514487,11.7778921,7512.6144411,10224.291715,9.5788625,868.0918143,725.7548811,1468.0303553,20.3742103,24.039498,2.6379664,73.7261832),(40811,'tibia fibula',248,8,277,264.3163347,76.0620138,120.5961971,1.8,76.1574311,120.647433,0.4976918,10.398241,11.8242971,7517.2315794,10233.4501224,10.0400302,865.4594851,722.9330036,1471.6597167,20.5608247,24.0970318,2.5981151,74.0821484),(40812,'tibia fibula',248,8,278,264.1992334,76.0941612,120.4900485,1.8,76.2223676,120.5235095,0.5057356,10.3602155,11.7285707,7542.1034483,10258.7154821,10.3342778,874.6773793,727.9871174,1466.5398882,20.5648453,24.0778691,2.5337907,74.0821484),(40813,'tibia fibula',248,8,279,264.005482,76.1203678,120.3966201,1.8,76.2265186,120.4406181,0.5173557,10.38172,11.7302445,7569.0094906,10285.1105789,10.7631936,876.8027425,729.0708574,1474.6335893,20.5659361,23.9779765,2.5088438,74.0821484),(40814,'tibia fibula',248,8,280,264.0289806,76.1457562,120.2978683,1.8,76.2189586,120.3348387,0.5303648,10.3333476,11.7785456,7598.5857321,10341.4335085,11.2600539,877.9890043,735.3459877,1479.5147579,20.5608247,24.0970318,2.5981151,74.4381136),(40815,'tibia fibula',248,8,281,263.7220442,76.1685728,120.1841086,1.8,76.2554436,120.2126359,0.5431178,10.3667238,11.8369715,7639.4188287,10376.2340603,11.7395951,876.5953372,736.9173689,1480.2915679,20.5713904,24.1926173,2.5585161,74.689819),(40816,'tibia fibula',248,8,282,263.4913664,76.1920986,120.0762436,1.8,76.2811826,120.1190491,0.5510877,10.3963303,11.8013751,7683.133976,10404.8563994,12.0403179,881.6647507,739.0236487,1487.8543157,20.6248968,24.0970318,2.5981151,74.4381136),(40817,'tibia fibula',248,8,283,263.1279215,76.1972407,119.9662608,1.8,76.2778875,120.008838,0.5601775,10.3788982,11.8603289,7719.3940267,10445.6487565,12.3809808,880.7216799,743.7585268,1492.622613,20.5713904,24.2497879,2.6224465,75.0457842),(40818,'tibia fibula',248,8,284,262.9271205,76.198293,119.8563306,1.8,76.2780106,119.9321917,0.5686918,10.410951,11.8932209,7759.8390645,10482.0626485,12.7087938,881.347678,745.3535269,1486.8000612,20.7409075,24.2345556,2.4945455,75.0457842),(40819,'tibia fibula',248,8,285,263.2523522,76.2033078,119.7460761,1.8,76.2827013,119.7929348,0.5744351,10.4147476,11.8546667,7818.5898992,10534.1008862,12.9538042,888.6037158,750.7229395,1504.2857859,20.6729219,24.1926173,2.5585161,74.9415244),(40820,'tibia fibula',248,8,286,262.9227565,76.2084043,119.642378,1.8,76.3063931,119.699978,0.5815979,10.4461295,11.9156056,7864.0070881,10579.012521,13.2248483,887.8283562,752.8153909,1500.0966405,20.7631163,24.1926173,2.5585161,74.4381136),(40821,'tibia fibula',248,8,287,262.315262,76.2094307,119.5393359,1.8,76.2648059,119.5864919,0.5902667,10.4732553,11.982024,7912.8730899,10635.9857219,13.5435226,887.6618627,755.5313865,1502.5638789,20.9291392,24.3258062,2.5192898,75.0457842),(40822,'tibia fibula',248,8,288,262.3238222,76.2110961,119.4406073,1.8,76.2624808,119.5039074,0.6008152,10.5022253,11.9367007,7949.5216315,10690.562153,13.972291,895.6044404,756.9368796,1521.4828555,20.8558894,24.3258062,2.5192898,75.0457842),(40823,'tibia fibula',248,8,289,260.6691857,76.1956892,119.1989879,1.8,76.2281746,119.2372999,0.6083223,10.446362,11.9615727,7955.7651692,10694.4867314,14.1892048,894.0702861,761.5823766,1514.802227,20.9832076,24.3258062,2.5192898,75.2974896),(40824,'tibia fibula',248,8,290,259.7130169,76.2104203,119.0943838,1.8,76.25818,119.1603989,0.6201813,10.4567157,12.0199866,7993.0907774,10733.0613369,14.6206883,892.9345483,764.3978253,1515.2962587,20.9646356,24.4318345,2.5438343,75.0457842),(40825,'tibia fibula',248,8,291,258.5864274,76.2227425,118.9803879,1.8,76.2719031,119.0701522,0.6322846,10.4461575,11.9939372,8007.7731581,10750.9743582,15.052671,896.3674051,766.5759569,1518.3001257,21.0085863,24.3258062,2.5192898,75.2974896),(40826,'tibia fibula',248,8,292,257.6046899,76.2257279,118.8760785,1.8,76.2722194,118.9315807,0.6424258,10.5216767,12.0674931,8033.2041054,10785.0529928,15.4119746,893.7277109,763.4908684,1521.4566856,21.0566091,24.4959849,2.4805495,75.9051602),(40827,'tibia fibula',248,8,293,255.6353962,76.2437075,118.7663028,1.8,76.282977,118.8019403,0.6499103,10.5049094,12.0472969,8020.0952689,10781.6353952,15.6007527,894.9422864,763.4616292,1528.9199223,20.9646356,24.4959849,2.4805495,75.6534548),(40828,'tibia fibula',248,8,294,253.7366542,76.252119,118.6551622,1.8,76.3040313,118.7127427,0.6579378,10.5144028,12.0156943,8007.6057236,10795.7723933,15.8126863,898.4726268,761.5844539,1516.7346885,21.03058,24.4318345,2.5438343,75.6534548),(40829,'tibia fibula',248,8,295,252.8282099,76.2470785,118.5317751,1.8,76.2845146,118.5516865,0.6674619,10.5712992,12.099404,8030.1661848,10835.7634386,16.1453666,895.5617509,759.6196143,1513.9121332,21.0992182,24.5787546,2.5050844,75.9051602),(40830,'tibia fibula',248,8,296,251.6972563,76.2429817,118.4305904,1.8,76.2878658,118.495817,0.6751716,10.5585545,12.1016541,8065.5154278,10857.1725566,16.3881811,897.1643465,763.8844328,1518.470123,21.1798065,24.4959849,1.8370484,75.9051602),(40831,'tibia fibula',248,8,297,250.6579472,76.2519428,118.3190143,1.8,76.2945378,118.3782402,0.682047,10.5219335,12.1714717,8072.7900606,10883.0127742,16.6012087,894.1410756,767.2344684,1519.5262072,20.9646356,24.5787546,2.5050844,76.00942),(40832,'tibia fibula',248,8,298,248.6816599,76.2604105,118.2160715,1.8,76.2870523,118.2597888,0.691353,10.5816918,12.1821768,8086.5542431,10875.6275332,16.8485285,892.7491118,764.2023941,1528.2601775,21.2171758,24.6575028,2.4178447,76.5128308),(40833,'tibia fibula',248,8,299,246.7423548,76.2667006,118.1091799,1.8,76.3476719,118.1697177,0.6984404,10.6003579,12.0861188,8089.3299042,10875.6329155,17.0038342,899.8449476,763.118562,1517.1570352,21.2203683,24.6125346,1.8538921,75.9051602),(40834,'tibia fibula',248,8,300,245.2837078,76.2779371,117.9958236,1.8,76.3525523,118.0731236,0.7073829,10.5420101,12.1509664,8102.0526539,10883.3548426,17.2639205,895.6781251,768.5491251,1524.320446,21.2684709,24.6762153,2.5294402,76.2611254),(40835,'tibia fibula',248,8,301,243.6952032,76.3043792,117.8883324,1.8,76.365054,117.9347823,0.7150355,10.6244991,12.1584643,8127.5816375,10889.9027653,17.4595168,895.6643268,764.9849242,1515.5702097,21.2684709,24.7434633,1.925502,76.2611254),(40836,'tibia fibula',248,8,302,241.9373968,76.3203523,117.7792512,1.8,76.3380764,117.8159964,0.725312,10.6000647,12.1881138,8129.1133604,10882.8863244,17.7444281,892.9098029,766.8928061,1515.012316,21.2684709,24.8030861,1.815775,76.5128308),(40837,'tibia fibula',248,8,303,240.3859303,76.3237049,117.6703341,1.8,76.3206484,117.6934985,0.7339178,10.5330788,12.04314,8125.7202665,10867.378453,17.9732778,902.3708505,771.4477833,1520.8581522,21.2684709,24.7956411,1.7273982,76.6170906),(40838,'tibia fibula',248,8,304,238.0965522,76.3190262,117.5685738,1.8,76.3236284,117.5908068,0.7382687,10.6826061,12.1134033,8100.9749001,10840.5193627,17.9739223,894.9193791,758.3332025,1505.0638348,21.3997732,24.895961,1.9416876,76.5128308),(40839,'tibia fibula',248,8,305,234.0959733,76.3764995,117.3209282,1.8,76.3583936,117.3567774,0.749993,10.5168526,12.2138152,8021.1766844,10727.4086767,18.1277838,878.3012114,762.6974499,1493.4686163,21.2684709,24.9107889,1.8325098,77.2247612),(40840,'tibia fibula',248,8,306,232.7004368,76.3812774,117.2058831,1.8,76.3544521,117.2240773,0.757738,10.6712312,12.2581048,8020.972013,10711.676804,18.3194942,873.8444455,751.6444817,1495.8849045,21.3997732,24.9441193,1.7614352,77.1205014),(40841,'tibia fibula',248,8,307,231.0733832,76.3821953,117.0791074,1.8,76.3332464,117.0682919,0.7673822,10.5793701,12.0943849,8018.8776298,10680.6989459,18.5624312,883.1122109,757.9730722,1481.867214,21.2684709,25.0032637,1.903416,76.2611254),(40842,'tibia fibula',248,8,308,229.5653892,76.3669161,116.9365348,1.8,76.3100457,116.8936095,0.7824145,10.4658351,12.1952517,8012.7590714,10678.1830411,19.016291,875.6016931,765.6110588,1481.5623187,21.2684709,25.0290955,1.7782926,76.868796),(40843,'tibia fibula',248,8,309,227.0085188,76.3556083,116.8144829,1.8,76.3057653,116.7861445,0.7971413,10.6797311,12.3145445,7979.354102,10608.9971388,19.3616342,861.5013859,747.1493457,1471.4582046,21.4892231,25.1211348,1.7950311,77.1205014),(40844,'tibia fibula',248,8,310,225.3793952,76.3410949,116.7146077,1.8,76.2453539,116.6204009,0.8069146,10.6308036,12.4049198,7958.788383,10603.4747273,19.5895951,854.77979,748.6535036,1474.0789017,21.4892231,25.1211348,1.7950311,77.1205014),(40845,'tibia fibula',248,8,311,224.0701321,76.3281599,116.6174803,1.8,76.2265571,116.4515662,0.8180549,10.5962561,12.247282,7945.5803843,10587.8954457,19.8912112,864.5098131,749.8478982,1463.0424834,21.2684709,25.2201601,1.724741,76.9730558),(40846,'tibia fibula',248,8,312,223.249192,76.3258288,116.5095982,1.8,76.2413418,116.3337432,0.8345776,10.7670685,12.347068,7963.8125571,10590.6162064,20.4310298,857.7434122,739.6453863,1469.5264771,21.5723062,25.2201601,1.8116428,77.1205014),(40847,'tibia fibula',248,8,313,221.4447801,76.330623,116.4153859,1.8,76.2671397,116.2942659,0.8480243,10.7278958,12.4060179,7970.032869,10578.1854802,20.7590647,852.6656636,742.9260115,1458.888199,21.5723062,25.3260892,1.82812,77.1205014),(40848,'tibia fibula',248,8,314,220.4248294,76.3155736,116.2993299,1.8,76.223683,116.2077533,0.8637647,10.7064474,12.4796294,7968.869443,10562.4749174,21.2359513,846.3772882,744.3056662,1456.0775323,21.5723062,25.3661535,1.7582254,77.1205014),(40849,'tibia fibula',248,8,315,219.4019693,76.3015893,116.1882849,1.8,76.2143543,116.0751325,0.8771953,10.8125272,12.4207169,7981.8766359,10545.8764741,21.6214182,849.0553794,738.2063839,1459.3490017,21.8323872,25.4497205,1.7748143,77.1205014),(40850,'tibia fibula',248,8,316,218.0791106,76.2820874,116.0829749,1.8,76.20159,115.9269235,0.8857112,10.8104461,12.4725933,7988.0798461,10520.3529586,21.7948799,843.4775891,738.9223105,1455.2542322,21.8761415,25.3260892,1.82812,77.0162416),(40851,'tibia fibula',248,8,317,218.4355619,76.2658881,115.9679466,1.8,76.1878859,115.8670039,0.8983432,10.8104184,12.5234831,8055.2476415,10565.7433349,22.279951,843.6744979,745.1374546,1460.3121951,21.8761415,25.4388361,1.8444556,77.3722068),(40852,'tibia fibula',248,8,318,217.7532635,76.2751495,115.859765,1.8,76.2135334,115.7661516,0.9057692,10.7814338,12.5362963,8102.9972482,10534.9290948,22.4725595,840.3541889,751.5695382,1461.6142387,21.8761415,25.4497205,1.7748143,77.3722068),(40853,'tibia fibula',248,8,319,217.8492161,76.2769618,115.750898,1.8,76.2098323,115.6586466,0.9107576,10.8537581,12.5109309,8152.4621192,10543.7960238,22.6581419,842.7667036,751.1188303,1471.0386604,21.8761415,25.4497205,1.7748143,77.3722068),(40854,'tibia fibula',248,8,320,217.7379894,76.2403212,115.6339228,1.8,76.1766244,115.5874514,0.9257473,10.7960314,12.5674934,8181.8671921,10567.8545843,23.1714358,840.8880165,757.8587807,1463.1125389,21.8761415,25.5583104,1.8606428,77.3722068),(40855,'tibia fibula',248,8,321,216.177739,76.3909273,115.4713454,1.8,76.3319576,115.3871801,0.9365445,10.8207283,12.6201832,8153.5004727,10531.7892944,23.3779942,834.5195243,753.5075506,1462.5919616,22.1051972,25.5583104,1.8606428,77.9798774),(40856,'tibia fibula',248,8,322,215.7965024,76.3741901,115.379221,1.8,76.2832663,115.3262292,0.9477862,10.8612773,12.618835,8162.0666604,10539.8139977,23.72137,835.2446168,751.4831294,1465.5908741,21.8761415,25.5402441,1.7912901,77.728172),(40857,'tibia fibula',248,8,323,214.5924234,76.348851,115.2676043,1.8,76.2723,115.2437062,0.9596668,10.8060937,12.6240588,8146.7486757,10503.3145727,23.9900639,832.0077363,753.9032033,1463.495131,21.8761415,25.5402441,1.7912901,77.728172),(40858,'tibia fibula',248,8,324,213.580977,76.3410304,115.1728898,1.8,76.3050217,115.1581541,0.9767022,10.8320794,12.6915617,8139.2841768,10494.6851382,24.4432976,826.9025842,751.4055138,1454.7545635,22.1030155,25.5835817,1.7055676,78.3358426),(40859,'tibia fibula',248,8,325,212.6225143,76.3462489,115.070021,1.8,76.2833196,115.0428733,0.9847545,10.8977687,12.6628097,8121.0972417,10464.3779255,24.5974553,826.3867318,745.2073438,1456.2621543,22.1051972,25.6376506,1.8076451,77.9798774),(40860,'tibia fibula',248,8,326,213.1154811,76.3270449,114.9944379,1.8,76.2924666,114.9738256,0.9882714,10.8785506,12.7381862,8160.56863,10496.3108569,24.769432,824.0035669,750.1521951,1463.5815024,22.1051972,25.6376506,1.8076451,77.9798774),(40861,'tibia fibula',248,8,327,213.4351738,76.2995593,114.8922408,1.8,76.2744598,114.9171307,1.0036051,10.8606903,12.7457778,8210.0475239,10504.1947034,25.3043808,824.1313239,755.9415956,1460.0070105,22.1062881,25.7418618,1.823872,78.2315828),(40862,'tibia fibula',248,8,328,212.980644,76.3104566,114.8185628,1.8,76.2723862,114.8570163,1.0106246,10.9158292,12.6753453,8227.0786728,10507.6041632,25.4755601,828.9797175,753.6833464,1466.8815386,22.2553884,25.7884405,1.7551207,78.587548),(40863,'tibia fibula',248,8,329,213.7040649,76.2845939,114.6928403,1.8,76.2578715,114.6731638,1.0210425,10.9679171,12.8020719,8267.7904545,10540.5075297,25.8944293,823.3438806,753.8159145,1467.781432,22.2947413,25.6376506,1.8076451,78.4832882),(40864,'tibia fibula',248,8,330,213.5149572,76.2712935,114.5905844,1.8,76.2546451,114.6311419,1.0365557,11.017049,12.7529001,8289.3306234,10567.031672,26.3594179,828.5983241,752.4093424,1469.3271863,22.2947413,25.7418618,1.823872,78.4832882),(40865,'tibia fibula',248,8,331,213.5462886,76.240277,114.4880285,1.8,76.2506928,114.5652106,1.0460092,10.9858766,12.7961075,8300.5547401,10602.5295111,26.6566334,828.5745861,755.5659883,1472.0502799,22.2901611,25.7418618,1.823872,78.4832882),(40866,'tibia fibula',248,8,332,212.8002084,76.2135917,114.4195338,1.8,76.2516252,114.4829211,1.0513384,11.0025219,12.7660998,8298.3529653,10600.2729703,26.7269063,830.3454552,754.2228117,1476.4502661,22.2958322,25.8706435,1.7714492,78.8392534),(40867,'tibia fibula',248,8,333,214.3221337,76.1985887,114.305123,1.8,76.2296811,114.3544571,1.0701363,11.0609063,12.8183507,8377.9467266,10695.9710741,27.4902253,834.4264665,757.4376384,1482.3990828,22.2969231,25.8706435,1.7714492,78.7349936),(40868,'tibia fibula',248,8,334,213.1899493,76.1711143,114.2252612,1.8,76.2065796,114.2816133,1.0809359,11.0808664,12.8739874,8350.1124633,10676.4534472,27.6659153,829.3043248,753.5613307,1475.9343632,22.2969231,25.8527955,1.8399638,78.3790284),(40869,'tibia fibula',248,8,335,213.1407141,76.1681707,114.1227999,1.8,76.2389007,114.2449188,1.0905009,11.1295916,12.8054528,8370.7672027,10681.1511363,27.9398325,834.1096013,752.1180926,1478.9058647,22.2969231,25.8706435,1.7714492,78.986699),(40870,'tibia fibula',248,8,336,215.5228557,76.1540486,114.0412771,1.8,76.2680717,114.2021087,1.0969001,11.1557443,12.8780772,8403.5662625,10762.9470583,28.4396296,835.7573038,753.2949887,1483.7488402,22.2969231,26.0555377,1.8037756,79.2384044),(40871,'tibia fibula',248,8,337,215.4025094,76.224083,113.7570264,1.8,76.3607524,113.9090927,1.1014889,11.1583111,12.900816,8395.5568684,10713.4603255,28.5570948,830.4482727,752.4039062,1480.1368344,22.2969231,25.9703655,1.8559141,79.3426642),(40872,'tibia fibula',248,8,338,214.1783447,76.1588458,113.6594314,1.8,76.3225733,113.8489557,1.1049875,11.1433184,12.8266641,8433.9244991,10718.7576674,28.4952958,835.662148,756.8593306,1473.7170401,22.2969231,26.1580842,1.819759,79.5943696),(40873,'tibia fibula',248,8,339,214.1836039,76.1092019,113.5599058,1.8,76.2614346,113.7722641,1.1168138,11.3360516,12.9400994,8449.9713989,10773.0857927,28.831811,832.5350136,745.4069293,1474.7799986,22.487558,26.1580842,1.819759,79.5943696),(40874,'tibia fibula',248,8,340,213.834482,76.1044498,113.484543,1.8,76.2261931,113.704183,1.1279037,11.3878282,12.9965623,8504.5027085,10842.398768,29.093636,834.2512833,746.8063779,1478.5177272,22.4886489,26.1580842,1.819759,79.9503348),(40875,'tibia fibula',248,8,341,213.2817616,76.0580431,113.3805666,1.8,76.2048975,113.5891435,1.1392868,11.4017796,12.9557428,8525.4593712,10853.9186199,29.3288479,837.7689163,747.7305909,1475.1018041,22.6771022,26.29185,1.7681919,80.4537456),(40876,'tibia fibula',248,8,342,214.365774,75.9984579,113.3021065,1.8,76.1489211,113.5117756,1.1397619,11.529065,13.0522841,8613.0973125,10946.0627182,29.4908042,838.6319672,747.0768312,1477.7265729,22.868828,26.3829832,1.8513331,80.3494858),(40877,'tibia fibula',248,8,343,213.2687255,75.940733,113.239268,1.8,76.1020057,113.4472148,1.1562926,11.5385207,13.0962659,8655.5879431,10950.0024354,29.7795623,836.1163815,750.1471062,1483.1725403,22.8699189,26.3829832,1.8513331,80.3494858),(40878,'tibia fibula',248,8,344,216.0030662,75.9201416,113.1172265,1.8,76.038523,113.3424844,1.1586448,11.5688993,13.0430811,8789.6583867,11101.9009307,30.2236672,851.1716541,759.7661794,1503.74482,22.8710097,26.3829832,1.8513331,80.705451),(40879,'tibia fibula',248,8,345,216.8796195,75.8680212,113.0364354,1.8,75.9851608,113.2600457,1.1657623,11.6657049,13.1370297,8859.2017264,11283.1469215,30.5339243,858.8811309,759.4227533,1511.7385563,23.0616447,26.5747352,1.815775,81.2088618),(40880,'tibia fibula',248,8,346,218.2559655,75.8129692,112.9432606,1.8,75.9307955,113.1979919,1.173501,11.7663479,13.1787489,8967.9663591,11415.3548045,30.930089,866.1941231,762.1707621,1523.0697943,23.0638264,26.5747352,1.815775,81.564827),(40881,'tibia fibula',248,8,347,219.30031,75.7419292,112.8315876,1.8,75.900003,113.092306,1.1623419,11.8071237,13.3226476,9070.1711684,11583.4633803,30.7838781,869.4565647,768.1948124,1529.0140219,23.384724,26.7444107,1.9841267,82.1724976),(40882,'tibia fibula',248,8,348,220.5021509,75.6321562,112.7299259,1.8,75.8410713,113.011362,1.1744705,11.7833384,13.3428842,9167.2251221,11704.1225351,31.2738057,877.180854,777.981998,1534.8628213,23.4450964,26.7961374,1.8468933,82.424203),(40883,'tibia fibula',248,8,349,222.9489136,75.613217,112.6567873,1.8,75.7959609,112.9491003,1.1611808,11.8648897,13.3644244,9322.7780622,11905.3273764,31.2645573,890.8223047,785.7450252,1553.9973499,23.4472781,26.8271256,2.1276979,82.6759084),(40884,'tibia fibula',248,8,350,223.5303918,75.5410629,112.5642347,1.8,75.6931526,112.8386633,1.1762656,11.991869,13.3981311,9429.6110683,12022.5527376,31.7508485,897.330581,786.3337282,1560.5592006,23.639004,26.9712662,1.9631365,83.8912496),(40885,'tibia fibula',248,8,351,226.3886036,75.4649845,112.4606419,1.8,75.6204916,112.7554567,1.1775262,12.0274978,13.4233913,9603.4541578,12208.9876887,32.1905503,909.5307864,798.4581925,1593.182638,23.829639,27.0566997,1.9277083,83.6395442),(40886,'tibia fibula',248,8,352,227.4428511,75.3765342,112.3680878,1.8,75.5610819,112.6609305,1.1746889,12.1480668,13.5447011,9744.3513953,12302.1004686,32.2641009,908.2592774,802.1318612,1595.5403662,24.0224557,27.2911083,2.1544321,83.8912496),(40887,'tibia fibula',248,8,353,228.0692004,75.3659218,112.0902628,1.8,75.5516926,112.3943031,1.1698335,12.2501647,13.5797775,9835.369945,12409.7015839,32.2209342,913.836886,802.8765489,1596.1217476,24.2152724,27.3687983,1.9571335,84.3946604),(40888,'tibia fibula',248,8,354,230.6989724,75.2745289,112.002354,1.8,75.4602951,112.3240916,1.1603191,12.3812724,13.7063101,10030.1928969,12581.310739,32.3271356,917.9210619,810.1100259,1611.5361743,24.4069982,27.5603906,2.1112158,84.6463658),(40889,'tibia fibula',248,8,355,233.3650552,75.1906736,111.8998258,1.8,75.3635454,112.1888986,1.1617752,12.3956182,13.7798329,10205.219151,12785.4602288,32.7421141,927.8385553,823.2924736,1643.4825557,24.5961387,27.8635357,2.0344439,85.3582962),(40890,'tibia fibula',248,8,356,235.1845734,75.0638767,111.7659279,1.8,75.2637255,112.1026688,1.1511997,12.5142041,13.841342,10402.7039282,12939.8908523,32.6918961,934.8725602,831.271719,1647.2244937,24.7915408,28.0122304,2.1375255,85.861707),(40891,'tibia fibula',248,8,357,237.1437963,74.9804161,111.6550775,1.8,75.185201,111.9946962,1.1459805,12.7030508,13.9421538,10561.3286214,13136.4846812,32.8100252,942.2134389,831.4009578,1664.7454092,24.921904,28.1503035,2.1164514,86.4693776),(40892,'tibia fibula',248,8,358,239.1323925,74.8995796,111.5391397,1.8,75.062384,111.8372293,1.1396902,12.8602224,13.9419686,10828.9115696,13314.308619,32.8958348,954.9805347,842.046989,1684.884079,25.351592,28.3268372,1.9597532,87.0770482),(40893,'tibia fibula',248,8,359,242.5801391,74.8234732,111.4374654,1.8,74.9404203,111.7261774,1.1280935,13.0488219,14.0460955,11124.3511697,13559.1078053,33.0106192,965.3293174,852.5176655,1723.7425314,25.5617168,28.6057343,2.1421338,88.040684),(40894,'tibia fibula',248,8,360,247.9147107,74.6852547,111.2982507,1.8,74.8207966,111.5984265,1.1003505,13.1935211,14.258529,11550.0247174,13880.0003948,32.8294381,973.452479,875.4315553,1754.1411116,25.78128,28.8403564,2.0011229,87.9364242),(40895,'tibia fibula',248,8,361,252.5148953,74.5570682,111.2003132,1.8,74.6833023,111.4530467,1.0857783,13.5054789,14.2662494,11928.1762933,14239.5209427,32.9378265,998.1264546,883.2101716,1794.8738297,26.433671,29.079435,2.1669955,89.759436),(40896,'tibia fibula',248,8,362,258.6398028,74.4445639,111.0401537,1.8,74.6046298,111.3658009,1.0453912,13.7038268,14.50809,12332.2090173,14629.8997071,32.2624725,1008.3959822,899.9098685,1825.8159965,26.640656,29.2598283,2.0935854,90.2628468),(40897,'tibia fibula',248,8,363,263.4384946,74.3402947,110.9051014,1.8,74.4686963,111.2378264,1.016804,13.9149395,14.7117977,12739.8926189,14991.8428236,31.7545617,1019.0354114,915.5550139,1865.1070205,26.7375063,29.5611604,2.1386404,91.2264826),(40898,'tibia fibula',248,8,364,268.4631645,74.2559829,110.7839533,1.8,74.3326283,111.1358626,1.0188028,14.1868821,14.7165893,13128.1737166,15454.7631067,32.4401752,1050.1592965,925.3741345,1904.8185895,27.0413416,29.7944556,2.1507991,92.1901184),(40899,'tibia fibula',248,8,365,277.0981129,74.1517966,110.6378717,1.8,74.2164095,111.0411075,1.01593,14.5388014,14.8127369,13740.5562758,16052.6953758,33.3649433,1083.7089382,945.0955371,1974.8490209,27.0413416,29.9243065,1.9379702,92.797789),(40900,'tibia fibula',248,8,366,285.7074368,74.0515138,110.5099154,1.8,74.1091779,110.9300085,0.9803639,14.7332078,14.992036,14331.2698311,16602.9706801,32.8593323,1107.4526924,972.7189117,2030.1770906,27.2981846,30.2891945,2.1233807,94.2648356),(40901,'tibia fibula',248,8,367,295.7890591,73.8684825,110.3703812,1.8,73.9842262,110.8353863,0.9523641,14.9908337,15.1518634,15023.0645952,17258.5482284,32.7280802,1139.0380009,1002.1500429,2087.3178872,27.4692591,30.5592462,2.0533096,95.1242116),(40902,'tibia fibula',248,8,368,303.5647985,73.7284285,110.2547355,1.8,73.8414774,110.7008667,0.8915473,14.9886356,15.2774553,15565.7024696,17802.0109291,30.6273391,1165.2471292,1038.500294,2132.821239,27.7935165,30.7489729,2.1471715,95.836142),(40903,'tibia fibula',248,8,369,314.8314212,73.4868688,110.0720612,1.8,73.6685338,110.4473135,0.7301814,14.7346214,15.6008403,16248.5996779,18508.4530411,23.3445074,1186.3753957,1102.7497273,2171.1672346,28.1009773,31.0239497,2.1088405,98.2668243),(40904,'tibia fibula',248,8,370,325.9106146,73.3354467,109.9988171,1.8,73.5048055,110.3110051,0.6214849,14.5103518,15.9961391,16994.7295196,19336.3002445,18.4143305,1208.8104579,1171.214158,2224.9044179,28.4463314,31.6017924,0.2053954,99.4821655),(40905,'tibia fibula',248,8,371,351.7029466,73.1687717,109.741683,1.8,73.2769323,110.1044191,0.508301,14.3503887,16.5031247,18783.3889119,21098.1838474,13.8846925,1278.4357011,1308.9115095,2405.4168577,29.177163,32.2065417,0.2287988,100.8449523),(40906,'tibia fibula',248,8,372,379.1430332,73.0300711,109.5372057,1.8,73.1712252,109.9787398,0.443124,14.6494618,16.9520041,20626.768304,23279.6103929,11.6168412,1373.2659704,1408.0222558,2589.3246449,29.549949,32.9965694,0.1437387,103.3798945),(40907,'tibia fibula',248,8,373,406.5738883,72.9603186,109.5542341,1.8,73.0861919,109.9558239,0.4739533,14.6029403,17.1820648,22414.261448,25646.0781595,14.1154123,1492.6074675,1534.9142679,2795.4989132,29.6871269,33.5597056,0.2325569,104.9943867),(40908,'tibia fibula',248,8,374,440.275454,72.8995146,109.5702566,1.8,73.0766629,109.8405755,0.5151423,15.0901516,17.6117736,24621.5033153,28131.0033422,17.8100646,1597.2839503,1631.6272986,2992.1274503,29.9779564,34.2162257,2.5257227,107.0691039),(40909,'tibia fibula',248,8,375,476.110244,72.9184588,109.3528559,1.8,73.1641655,109.7228465,0.5989284,16.1511503,17.7202919,26173.9224568,32661.247441,25.2197759,1843.1551572,1620.5608841,3267.1626059,29.8794586,34.7702298,2.4436898,108.6835961),(40910,'tibia fibula',248,8,376,484.9818568,72.9713215,109.2348124,1.8,73.1450474,109.5790338,0.5452895,15.7506173,17.9876328,25489.3962316,35439.1812284,21.7444904,1970.1970599,1618.3109375,3338.4561996,29.6538007,34.9344536,2.5842971,107.9284799),(40911,'tibia fibula',248,8,377,514.8240029,72.9529671,109.0486971,1.8,72.9051144,109.2554637,0.5017793,15.4104051,17.5787654,25615.7232185,36075.390225,19.8505679,2052.2141058,1662.2355513,3469.1686941,29.3433324,34.7091104,2.5948038,106.0012083),(40912,'tibia fibula',248,8,378,511.2542314,73.3969816,109.2384002,1.8,72.7069951,108.910379,0.3787202,14.3132808,17.1128571,23526.3270933,34833.8040545,11.6482034,2035.5340915,1643.6711731,3257.3034677,28.3511265,34.4876487,2.6054466,105.2460921),(40913,'tibia fibula',248,8,379,456.0158725,73.475171,108.5412028,1.8,72.5353496,108.5446287,0.3805523,14.1207646,17.2503246,19494.7128234,33198.047032,10.4855323,1924.4882557,1380.5706279,2956.4881231,27.1009779,34.7197476,2.5055172,103.3188206),(40914,'tibia fibula',248,8,380,423.3366633,72.6714673,107.8433008,1.8,72.4132443,108.2115366,0.3872673,13.6759688,17.6683536,17238.1394321,32396.2050629,10.0631869,1833.5723707,1260.4693424,2808.9898335,25.9484588,35.1084284,2.7656317,103.0671151),(40915,'tibia fibula',248,8,381,430.3767289,72.2839966,107.4316284,1.8,72.4172984,107.922045,0.4015527,13.2863151,18.2956728,15938.4393562,33884.2622421,10.9575467,1852.0369556,1199.6132244,2713.3858511,25.0213882,35.7674934,2.4668517,103.4230803),(40916,'tibia fibula',248,8,382,438.4991284,72.3217333,107.1957087,1.8,72.389645,107.6569155,0.4218816,12.9571044,18.3857218,15386.0538639,35762.3692834,12.254009,1945.1164199,1187.4608244,2764.9627067,24.2868855,36.1168037,2.5337907,104.1350107),(40917,'tibia fibula',248,8,383,428.0122673,72.9143012,107.2200083,1.8,72.4064686,107.5538387,0.4439906,13.1672748,17.9740736,14106.0181734,37431.1839076,13.1621061,2082.5097736,1071.2936741,2723.4660435,24.2661262,36.7879182,2.8937811,105.0986465),(40918,'tibia fibula',248,8,384,361.6367517,73.2818785,106.7544923,1.8,72.6417823,107.4102502,0.3884228,13.3969246,18.9993386,10616.9291116,33173.4588523,8.6452765,1746.0323012,792.4900251,2186.4393028,23.6477309,37.7978927,2.9932648,104.8037553),(40919,'tibia fibula',248,8,385,166.6408653,69.9850913,103.5637212,1.8,70.4905008,104.5642521,0.1338716,14.0611679,20.3293921,2397.4253533,16148.5491076,0.4947791,794.3449088,170.4997317,905.6890315,12.1534119,23.3024045,0.397628,60.9829888),(40920,'tibia fibula',248,8,386,95.4105411,64.7909521,102.6590765,1.8,66.5789837,103.3067608,-0.1249574,7.5734708,21.9349307,961.6216903,3830.5441632,0.2470059,174.6321523,126.9723896,211.0801872,10.887714,20.7855324,0.5191461,51.9721897),(40921,'tibia fibula',248,8,387,71.7473492,63.5192062,102.5235297,1.8,62.7301634,103.077989,-0.6125695,4.7157627,9.7866165,266.1762828,1210.7406419,3.9531882,123.7139149,56.4439522,150.2910655,9.450165,18.6555863,0.5048614,46.4599685),(40922,'tibia fibula',248,8,388,55.0433206,63.6824606,102.2718219,1.8,63.1842149,102.7195267,-0.6231569,3.8511216,8.4096444,147.2859655,671.8005214,3.1245419,79.8845336,38.2449534,97.361819,7.9968595,16.2146739,0.5585993,40.5917821),(40923,'tibia fibula',248,8,389,22.5941179,64.2952833,101.7032715,1.8,63.7662554,102.0877503,-0.5803986,3.1364221,6.9681949,34.9516604,129.1823535,1.1323258,18.5388547,11.1437999,23.427308,6.5383143,12.5495381,0.6640462,30.8690525),(40924,'tibia fibula',248,8,390,0.7977771,65.070626,101.2897776,1.8,65.0525017,101.3159074,-0.6566748,1.227555,1.5880589,0.2818731,0.4946275,0.0495544,0.3114667,0.2296216,0.4827165,2.8835237,3.6963159,0.6202495,9.8701752),(40925,'tibia fibula',248,8,391,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40926,'tibia fibula',248,8,392,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40927,'tibia fibula',248,8,393,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40928,'tibia fibula',248,8,394,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40929,'tibia fibula',248,8,395,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40930,'tibia fibula',248,8,396,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40931,'tibia fibula',248,8,397,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40932,'tibia fibula',248,8,398,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40933,'tibia fibula',248,8,399,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40934,'tibia fibula',248,8,400,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40935,'tibia fibula',248,8,401,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40936,'tibia fibula',248,8,402,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40937,'tibia fibula',248,8,403,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40938,'tibia fibula',248,8,404,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40939,'tibia fibula',248,8,405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40940,'tibia fibula',248,8,406,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40941,'tibia fibula',248,8,407,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40942,'tibia fibula',248,8,408,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40943,'tibia fibula',248,8,409,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40944,'tibia fibula',248,8,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40945,'tibia fibula',248,8,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40946,'tibia fibula',248,8,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40947,'tibia fibula',248,8,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40948,'tibia fibula',248,8,414,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40949,'tibia fibula',248,8,415,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40950,'tibia fibula',248,8,416,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40951,'metatarsal.tif',248,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40952,'metatarsal.tif',248,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40953,'metatarsal.tif',248,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40954,'metatarsal.tif',248,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40955,'metatarsal.tif',248,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40956,'metatarsal.tif',248,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40957,'metatarsal.tif',248,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40958,'metatarsal.tif',248,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40959,'metatarsal.tif',248,10,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40960,'metatarsal.tif',248,10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40961,'metatarsal.tif',248,10,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40962,'metatarsal.tif',248,10,12,23.8613074,99.1020463,122.6466189,1.8,99.8244146,123.3906091,0.8377087,4.55275,12.8725114,66.3266796,1756.2014703,2.1960961,136.4303687,14.5684872,140.7608338,0,0,0,0),(40963,'metatarsal.tif',248,10,13,144.3849592,99.2687005,123.1600347,1.8,98.6072013,123.2928614,0.8445522,14.5674548,13.9828893,1520.292262,7755.8726036,13.4522531,554.6688108,104.3622434,605.8967292,13.1950481,27.5302279,2.1674567,70.1412336),(40964,'metatarsal.tif',248,10,14,242.0399513,97.9453599,123.5220047,1.8,97.1847141,124.1397659,0.7898592,13.8421089,13.5580459,5367.0449863,10977.9609266,20.3499509,809.7008236,387.7331852,1089.7951284,22.4838121,28.1273384,2.1715101,97.0082973),(40965,'metatarsal.tif',248,10,15,298.9735657,96.8315451,124.0446733,1.8,96.5352037,124.8259686,0.7027928,13.8522485,14.1008974,8443.2434195,12027.7570582,20.8170252,852.9781304,609.5215113,1443.4114587,23.6991533,28.0221154,2.1928283,85.922781),(40966,'metatarsal.tif',248,10,16,298.6478305,96.4025968,124.0853055,1.8,96.2255484,124.9500771,0.6793019,14.7357809,14.1603401,9945.6814027,11465.825215,19.6459566,809.7139697,674.9341244,1449.3670387,24.017878,27.5871743,2.223643,87.0770482),(40967,'metatarsal.tif',248,10,17,270.3111607,95.9293423,123.6854046,1.8,95.7367353,124.6176308,-0.4817672,12.980635,14.9519225,9267.348433,10411.2014745,9.6721596,696.3118957,713.9364444,1304.0286609,23.2409195,26.919876,2.9974383,90.2628468),(40968,'metatarsal.tif',248,10,18,248.9682867,95.6986908,123.1105832,1.8,95.5069696,124.0934984,-0.4475587,12.2661625,14.949254,7864.1626984,9566.5837213,7.7713958,639.9371973,641.1265716,1149.9488335,22.3261768,26.069706,0.1488899,84.3946604),(40969,'metatarsal.tif',248,10,19,233.1179284,95.7642008,122.6266925,1.8,95.4626699,123.5273192,-0.3650101,11.3619696,15.0920067,6873.5820635,8394.5300911,4.9506294,556.2235873,604.9639534,999.7694445,21.4632296,25.7884405,0.1843244,82.424203),(40970,'metatarsal.tif',248,10,20,222.9703981,95.8137386,122.2805691,1.8,95.4840308,123.0507653,-0.25365,10.5438805,14.3500352,6415.9300094,7547.6732917,2.3400856,525.9689749,608.497982,937.1237496,21.0010963,25.1798635,0.4407508,79.3426642),(40971,'metatarsal.tif',248,10,21,213.6690408,96.0018304,122.0804157,1.8,95.6621056,122.7749023,-0.3221852,10.4966491,13.8817136,6027.0976412,6715.3848314,3.5704441,483.757628,574.1925451,897.0152209,20.6309964,24.4053706,0.4557738,76.6602764),(40972,'metatarsal.tif',248,10,22,207.8526922,96.1191893,121.8739664,1.8,95.8096204,122.450522,-0.499739,10.9016338,12.7181862,5658.3971111,6166.6902075,7.9548423,484.8718302,519.0412001,917.9556992,20.3617709,23.139407,2.5948038,72.909993),(40973,'metatarsal.tif',248,10,23,201.5632946,96.0506557,121.6186265,1.8,95.7995382,122.1763194,-0.5866389,10.8190444,12.0986229,5295.4023983,6058.307306,10.2943164,500.7435453,489.4519497,882.5062362,20.1381204,23.0794861,1.0655061,71.7989116),(40974,'metatarsal.tif',248,10,24,200.0668261,96.0475089,121.416368,1.8,95.7859972,121.9627972,-0.6851559,10.8221603,12.2030802,5010.7414294,5916.2499539,13.3520568,484.8161156,463.0075046,853.4315445,19.9393889,23.0794861,1.0655061,69.6199346),(40975,'metatarsal.tif',248,10,25,197.4028693,95.9774317,121.2263775,1.8,95.7575045,121.8093385,-0.7452591,10.7584482,12.1489896,4729.8884845,5882.3821325,15.1310641,484.1869445,439.6441202,834.5495515,19.7165511,23.0794861,1.0655061,69.1165238),(40976,'metatarsal.tif',248,10,26,197.7625656,95.9227734,121.093827,1.8,95.7628342,121.6850645,-0.797631,10.6259455,12.3171109,4516.0503695,5955.7594993,16.883374,483.5354303,425.0022139,827.9914164,19.6573697,23.139407,1.1902899,68.613113),(40977,'metatarsal.tif',248,10,27,199.220765,95.8901052,120.9647114,1.8,95.7350678,121.5121196,-0.8303295,10.4629818,12.1877679,4338.1587827,6021.7877172,18.0915994,494.0845405,414.6197383,827.0173911,19.2869734,23.139407,1.1902899,68.613113),(40978,'metatarsal.tif',248,10,28,199.49402,95.8567398,120.8353067,1.8,95.6493908,121.3730458,-0.8570488,10.3025777,12.0554319,4165.0201023,6106.5300325,18.9986698,506.5376423,404.2697085,826.7606672,19.3281349,23.0794861,1.1487913,68.9690782),(40979,'metatarsal.tif',248,10,29,198.2661627,95.9111011,120.7257126,1.8,95.7848396,121.2686022,-0.9266681,10.0780509,12.3567583,3944.5888973,6195.3017372,21.1284925,501.3695018,391.4039467,819.6567932,18.8183597,23.0794861,1.1487913,68.613113),(40980,'metatarsal.tif',248,10,30,199.5461645,95.8015877,120.6223355,1.8,95.6581976,121.1144945,-0.9101217,9.9624939,12.8207348,3863.8993326,6436.8408434,20.7339798,502.0648909,387.8445887,801.4887827,18.7173325,23.4800019,0.9675665,69.1165238),(40981,'metatarsal.tif',248,10,31,200.5797108,95.7268473,120.5045919,1.8,95.5833639,120.9445341,-0.8989781,9.8204649,12.8755612,3791.5664059,6658.6535051,20.4793753,517.1544292,386.0882808,810.0708584,18.4252345,23.7264049,0.9526521,70.0801596),(40982,'metatarsal.tif',248,10,32,201.1192272,95.7058367,120.4035322,1.8,95.5696847,120.8357614,-0.9118318,9.9099409,12.9335472,3749.6397752,6835.8353779,20.9529555,528.5352318,378.3715594,817.2265457,18.447254,23.8350997,0.9777938,70.4361248),(40983,'metatarsal.tif',248,10,33,200.601419,95.7158105,120.203366,1.8,95.6042571,120.6222059,-0.9196388,9.7682469,13.0928777,3657.456591,6974.8112354,21.1512028,532.7179716,374.4230272,810.9205923,18.2125692,24.0778691,0.9629943,69.3682292),(40984,'metatarsal.tif',248,10,34,200.7202547,95.7054595,120.072895,1.8,95.5891358,120.4551563,-0.9265615,9.687781,13.1858496,3619.1100933,7107.9328546,21.386591,539.057633,373.5747217,812.3835141,18.1743201,24.2345556,0.9237491,69.7241944),(40985,'metatarsal.tif',248,10,35,201.2973689,95.707525,119.9311869,1.8,95.6000168,120.3330383,-0.9370503,9.6945106,13.2931977,3586.2392033,7224.2030033,21.7849918,543.4511055,369.9247275,811.9197624,18.0037978,24.4318345,0.9730379,69.7241944),(40986,'metatarsal.tif',248,10,36,202.0978875,95.7344747,119.7922761,1.8,95.6267359,120.1728271,-0.9573006,9.6229253,13.5082085,3549.3797391,7375.7120249,22.5182801,546.0170394,368.8462337,808.474016,18.0388259,24.687436,1.0214218,70.9395356),(40987,'metatarsal.tif',248,10,37,202.1827622,95.7352831,119.6486419,1.8,95.6184182,120.042251,-0.964944,9.4698576,13.5150104,3528.7462967,7472.0180871,22.769552,552.8680978,372.6292874,811.7991924,18.0647732,24.7881939,0.9827937,70.6878302),(40988,'metatarsal.tif',248,10,38,202.9673913,95.7452326,119.492039,1.8,95.6560697,119.8521849,-0.9718771,9.5605877,13.5132142,3519.9806219,7544.7728157,23.0769114,558.3255536,368.1761771,818.8043326,17.9100236,24.8365611,1.0452125,70.79209),(40989,'metatarsal.tif',248,10,39,203.7296967,95.7561754,119.3259923,1.8,95.6562237,119.6952572,-0.9768713,9.410704,13.6565321,3531.9389614,7612.9750935,23.3211931,557.4603445,375.3108125,816.0842451,18.003671,24.9995713,1.0687061,70.6878302),(40990,'metatarsal.tif',248,10,40,204.142153,95.7730555,119.1600451,1.8,95.661774,119.517299,-0.9816647,9.3758746,13.8035668,3543.6176002,7617.7501858,23.5193892,551.8682467,377.9506194,808.58487,17.9262826,25.0549006,1.0303768,70.79209),(40991,'metatarsal.tif',248,10,41,204.2945581,95.7798924,119.0143549,1.8,95.6629236,119.3715299,-0.9889161,9.3438128,13.9285253,3557.82107,7677.3737928,23.7643783,551.1978911,380.7675899,806.6275611,18.0553351,25.2786586,1.0158006,71.2955008),(40992,'metatarsal.tif',248,10,42,204.0897287,95.7876534,118.8642791,1.8,95.6918028,119.2315481,-0.9927313,9.3153022,13.9484853,3564.1600606,7696.2435148,23.8595277,551.7619561,382.6134661,805.4949079,17.9262826,25.3770692,1.076855,70.79209),(40993,'metatarsal.tif',248,10,43,203.4177809,95.8014732,118.6993291,1.8,95.7202417,119.0546221,-0.996193,9.2740966,13.9704468,3565.7096998,7659.1635029,23.8882208,548.240413,384.4805425,803.1971646,17.8752291,25.3770692,1.076855,71.3997606),(40994,'metatarsal.tif',248,10,44,202.764688,95.8259918,118.527158,1.8,95.730114,118.890063,-1.0012167,9.2522425,14.1303216,3568.9498507,7617.6346788,23.9660819,539.0984663,385.7388995,791.4039754,17.8786824,25.4243162,1.0390723,71.3997606),(40995,'metatarsal.tif',248,10,45,203.2654318,95.8458502,118.3761056,1.8,95.7586303,118.7166932,-1.006468,9.1948209,14.040494,3593.5116074,7618.6469961,24.1864579,542.6195847,390.8190993,797.5082535,17.8741382,25.3916161,1.152572,70.79209),(40996,'metatarsal.tif',248,10,46,202.5642786,95.8703631,118.2287519,1.8,95.7733779,118.6176724,-1.0088129,9.1617464,14.0452625,3600.0735089,7587.9282609,24.1745027,540.2482335,392.9462069,796.5202958,17.6224473,25.3916161,1.152572,70.79209),(40997,'metatarsal.tif',248,10,47,202.0228599,95.8886825,118.0885833,1.8,95.797685,118.4574542,-1.0118299,9.2274184,13.9463431,3612.7234175,7549.4494036,24.2013637,541.3210722,391.520495,799.7797783,17.8728749,25.2201601,1.1681417,71.1480552),(40998,'metatarsal.tif',248,10,48,201.2345941,95.918178,117.946426,1.8,95.8570154,118.2705765,-1.0196123,9.2090746,14.0866267,3619.0702196,7452.7860265,24.3407394,529.068184,392.9895661,785.5377075,17.6224473,25.3770692,1.076855,68.9690782),(40999,'metatarsal.tif',248,10,49,199.0766962,95.9235112,117.7025586,1.8,95.8612205,118.0232666,-1.0229781,9.1981718,13.9322941,3604.1945915,7301.9795586,24.1792025,524.1046111,391.8381488,782.5840906,17.6224473,25.2091765,1.0537644,68.9690782),(41000,'metatarsal.tif',248,10,50,198.6786189,95.9433629,117.5748946,1.8,95.8496907,117.8946805,-1.0318002,9.1920702,13.8338327,3621.9858142,7244.1198007,24.3894267,523.6524071,394.0337416,784.6849967,17.6224473,25.1798635,1.1300455,68.7173728),(41001,'metatarsal.tif',248,10,51,198.176924,95.9665306,117.4353214,1.8,95.8849968,117.7751689,-1.0384585,9.2614419,13.5994449,3624.3611917,7139.2009313,24.5208921,524.9626718,391.3387603,791.1921455,17.6224473,24.895961,1.199905,68.4656674),(41002,'metatarsal.tif',248,10,52,196.6719512,96.0297957,117.24245,1.8,95.9891243,117.5335246,-1.0506654,9.1743162,13.5880921,3612.6545033,6937.4490297,24.6822389,510.5535761,393.7791562,775.6448863,17.6224473,24.8254078,1.1613591,68.1097022),(41003,'metatarsal.tif',248,10,53,195.1276463,96.0579453,117.0708006,1.8,95.9978156,117.3562027,-1.0559682,9.2433056,13.3803984,3605.9852684,6761.6072315,24.63671,505.3367655,390.1185824,774.5136993,17.8541869,24.4959849,1.1935473,68.1097022),(41004,'metatarsal.tif',248,10,54,194.5056051,96.1081344,116.8896026,1.8,96.0542089,117.1800846,-1.0708879,9.2726987,13.3617672,3615.3602221,6587.3101621,24.9689493,492.9969255,389.8929917,762.7895919,17.6224473,24.4959849,1.1935473,67.6062914),(41005,'metatarsal.tif',248,10,55,193.8066899,96.1778895,116.6957076,1.8,96.166403,116.9591168,-1.0927239,9.3445597,13.194534,3629.5358381,6404.5777754,25.4641612,485.3962828,388.4116467,760.4303582,17.6224473,24.2193137,1.1309537,67.6062914),(41006,'metatarsal.tif',248,10,56,194.2381687,96.2066068,116.5357268,1.8,96.1845066,116.7986868,-1.1114344,9.2342038,13.1605158,3655.0951213,6327.3907706,26.0090563,480.7859263,395.8213617,757.8748273,17.9262826,24.2612058,1.1705557,67.5020316),(41007,'metatarsal.tif',248,10,57,194.1360058,96.2355635,116.365563,1.8,96.2249968,116.6436395,-1.1291209,9.3279707,13.146771,3669.6950986,6200.7989217,26.443992,471.6594592,393.4076575,750.1859437,17.9176168,24.1926173,1.2265776,66.894361),(41008,'metatarsal.tif',248,10,58,194.1560915,96.2537454,116.2177086,1.8,96.2413484,116.5133655,-1.1448476,9.4094235,12.9043207,3687.6394502,6092.0397418,26.8349034,472.0930194,391.9091821,757.7796787,17.9262826,23.9394452,1.2036225,65.9307252),(41009,'metatarsal.tif',248,10,59,194.0049732,96.2879262,116.0542826,1.8,96.2838614,116.3299316,-1.1682138,9.4306089,12.9006131,3699.0778534,5954.1072385,27.3707437,461.5367665,392.2416759,748.0500793,17.9262826,23.9394452,1.2036225,66.2866904),(41010,'metatarsal.tif',248,10,60,194.2580306,96.3034388,115.9092842,1.8,96.3009383,116.1756567,-1.1890599,9.4846192,12.6459624,3715.7398921,5868.1231772,27.8831365,464.0313635,391.7647948,757.8464788,17.9262826,23.6445559,1.237552,65.6790198),(41011,'metatarsal.tif',248,10,61,194.3565569,96.3329291,115.7626683,1.8,96.3282871,116.0388822,-1.2137667,9.4685629,12.5355279,3730.2225571,5729.1761641,28.4361396,457.0350943,393.95868,752.6016418,18.046896,23.3854511,1.2141762,66.6426556),(41012,'metatarsal.tif',248,10,62,193.3187584,96.3416098,115.6350117,1.8,96.3479204,115.891758,-1.2403505,9.4087629,12.4909056,3719.8609658,5590.8475359,28.8277784,447.5934508,395.361323,743.8406026,18.046896,23.2389317,1.2315037,65.0713492),(41013,'metatarsal.tif',248,10,63,192.7103128,96.3542466,115.5105285,1.8,96.360836,115.7971222,-1.2635886,9.4538885,12.4612755,3716.1070696,5475.8364882,29.1813281,439.4282514,393.0770987,736.5962505,17.9262826,23.099477,1.2490458,64.5679384),(41014,'metatarsal.tif',248,10,64,192.3406016,96.365802,115.3885957,1.8,96.3678079,115.6391889,-1.2877462,9.501066,12.1493229,3727.1007989,5386.6533205,29.5563227,443.3706616,392.2823822,747.2971364,18.046896,22.724768,1.3028859,64.8196438),(41015,'metatarsal.tif',248,10,65,189.3062623,96.3833468,115.142049,1.8,96.4339357,115.3350377,-1.3335654,9.4661701,11.9140547,3698.25428,5147.8622257,29.8084593,432.0831469,390.6811576,735.2450599,18.046896,22.4303721,1.218752,63.9602678),(41016,'metatarsal.tif',248,10,66,189.2164082,96.3812355,115.0489906,1.8,96.4211221,115.2777925,-1.3587044,9.4975448,11.8682102,3705.0763514,5110.1892189,30.1386249,430.5779171,390.1088578,736.6321574,18.046896,22.4303721,1.2793395,63.9602678),(41017,'metatarsal.tif',248,10,67,188.7502969,96.3856432,114.9317458,1.8,96.4219296,115.096809,-1.39647,9.5134543,11.4948717,3697.4845815,5039.7543812,30.5120178,438.4350267,388.6584698,748.4053934,18.046896,22.0944884,1.3352513,64.2119732),(41018,'metatarsal.tif',248,10,68,188.280437,96.3830972,114.8155913,1.8,96.4063102,115.0036188,-1.4309101,9.456362,11.4725674,3684.5894499,5012.1325772,30.7700178,436.8797692,389.6413278,746.888859,18.046896,22.0944884,1.3352513,63.7085624),(41019,'metatarsal.tif',248,10,69,186.8168105,96.3768782,114.6892884,1.8,96.4148688,114.8616014,-1.4701784,9.4556028,11.1262736,3656.6105244,4944.8536514,30.821976,444.4303499,386.7136329,748.2316981,18.046896,21.897231,1.2924967,64.5679384),(41020,'metatarsal.tif',248,10,70,185.7436523,96.372334,114.5892565,1.8,96.4226775,114.7545941,-1.5056125,9.4040169,11.0884065,3635.4735075,4889.3525306,30.8259264,440.9427576,386.5873023,744.7089201,18.046896,21.897231,1.2924967,63.456857),(41021,'metatarsal.tif',248,10,71,184.6267419,96.36826,114.5032687,1.8,96.4266527,114.6443295,-1.5412367,9.3756121,11.0532257,3614.5775823,4831.8901098,30.7442446,437.1475109,385.5297715,740.756834,18.046896,21.8296729,1.3927034,63.456857),(41022,'metatarsal.tif',248,10,72,183.029733,96.3593348,114.4113193,1.8,96.4276234,114.5549951,1.5633338,9.338093,10.6171582,3581.6764312,4773.963684,30.5032567,449.6460912,383.5554468,745.7679759,17.8703031,21.5787243,1.3499676,62.8491864),(41023,'metatarsal.tif',248,10,73,181.8563701,96.3617108,114.3283619,1.8,96.3888624,114.4310847,1.5255793,8.9624253,10.6365862,3556.2036846,4723.6426193,30.2474673,444.093861,396.7903296,742.1977575,17.617208,21.5787243,1.3499676,62.4932212),(41024,'metatarsal.tif',248,10,74,180.5938244,96.3591023,114.2319365,1.8,96.4155124,114.3329134,1.4837653,8.9871091,10.6074986,3526.7922465,4674.5860752,29.8715643,440.6869384,392.4278897,742.8433992,17.617208,21.4069164,1.3891475,61.9898104),(41025,'metatarsal.tif',248,10,75,179.5795805,96.3615352,114.1434972,1.8,96.4176577,114.26083,1.4474048,8.9840284,10.2669642,3502.2209386,4638.8728534,29.4765412,451.8251694,389.8274584,745.4561276,17.5780915,21.2597881,1.3258177,61.6338452),(41026,'metatarsal.tif',248,10,76,178.3098174,96.3695997,114.0609272,1.8,96.4312697,114.1703474,1.4141553,8.9592145,10.1997091,3463.4308824,4604.1696984,28.9950671,451.4020581,386.5775139,740.9582188,17.5142132,21.1596801,1.3455195,61.3821398),(41027,'metatarsal.tif',248,10,77,177.8399016,96.370982,113.9839582,1.8,96.4230682,114.0627965,1.3842047,8.9291102,9.9280283,3433.4776292,4599.1165292,28.6199459,463.2457124,384.5262907,753.1657902,17.393003,20.9844416,1.3854484,61.6338452),(41028,'metatarsal.tif',248,10,78,176.7528121,96.377124,113.9157509,1.8,96.4256737,113.9863756,1.3571744,8.7955769,9.9146274,3380.7407157,4578.076914,28.1347947,461.7497712,384.3682732,749.8010685,17.2897018,20.9844416,1.3854484,61.3821398),(41029,'metatarsal.tif',248,10,79,174.9689894,96.3787896,113.8484643,1.8,96.4259214,113.9115797,1.3306664,8.7372613,9.8159299,3323.8004162,4533.2217998,27.51205,461.822958,380.4167365,742.6760651,17.1258545,20.9095205,1.4056476,61.3821398),(41030,'metatarsal.tif',248,10,80,173.4503091,96.3736999,113.7966103,1.8,96.4303834,113.8667026,1.3092101,8.689932,9.7619446,3272.3981842,4500.4515214,26.9749696,461.0199833,376.5735082,731.2942616,17.1053777,20.9095205,1.4056476,61.1304344),(41031,'metatarsal.tif',248,10,81,169.6589794,96.3518617,113.6907164,1.8,96.4249111,113.7808739,1.2814244,8.5789929,9.6995368,3169.2958859,4404.2489208,25.9740884,454.0679625,369.4251654,727.5066921,16.8149075,20.5622657,1.3815973,60.7744692),(41032,'metatarsal.tif',248,10,82,169.0708993,96.3331213,113.6686864,1.8,96.4210252,113.7429029,1.2601734,8.4367467,9.6401142,3136.8118088,4386.2022607,25.5459633,454.9948466,371.8034841,728.5886561,16.8149075,20.4858007,1.4021994,60.7744692),(41033,'metatarsal.tif',248,10,83,168.2786051,96.3058923,113.6329923,1.8,96.3615126,113.6839865,1.2346433,8.4275965,9.5912218,3101.2729046,4358.4624242,24.9948078,454.4220226,367.9902001,726.2487657,16.774903,20.4180938,1.422947,60.418504),(41034,'metatarsal.tif',248,10,84,167.3736297,96.2770231,113.6062437,1.8,96.3213556,113.6714001,1.2073597,8.4293321,9.6704509,3076.0233675,4332.7935436,24.3703798,448.0446239,364.9189898,719.7910959,16.6859961,20.3592323,1.4438235,60.7744692),(41035,'metatarsal.tif',248,10,85,165.9048559,96.246739,113.5876255,1.8,96.2896969,113.6039525,1.1753525,8.3224823,9.6228524,3034.5753537,4292.7745377,23.5476305,446.1020884,364.6238264,718.4728724,16.5954759,20.2683424,1.4858945,60.5227638),(41036,'metatarsal.tif',248,10,86,165.0382055,96.199473,113.5730101,1.8,96.2472368,113.6213276,1.1531389,8.2606608,9.5710397,3005.0764568,4287.0590498,22.9808028,447.9198919,363.7816077,714.2698195,16.5954759,20.2364345,1.507053,60.5227638),(41037,'metatarsal.tif',248,10,87,163.9772442,96.1598005,113.5511378,1.8,96.2252303,113.5945782,1.1279271,8.2432328,9.5057226,2964.7058672,4279.2629614,22.3107145,450.177555,359.6532998,725.5751912,16.5386626,19.9931938,1.7218117,60.1667986),(41038,'metatarsal.tif',248,10,88,163.19379,96.12476,113.532054,1.8,96.19472,113.5833161,1.1048866,8.2225973,9.4474521,2930.0280225,4281.4549586,21.7098673,453.1862041,356.3385023,727.1659989,16.4468934,19.9330777,1.7004989,60.1667986),(41039,'metatarsal.tif',248,10,89,161.9800319,96.0886274,113.5027017,1.8,96.1692219,113.5567022,1.0875051,8.0579114,9.5888381,2889.3524982,4281.0231416,21.1669466,446.4590084,358.5733772,721.3300522,16.3008904,19.9931938,1.7218117,59.9150932),(41040,'metatarsal.tif',248,10,90,160.5230634,96.0447073,113.4777453,1.8,96.116727,113.5213627,1.067099,8.0869808,9.5748705,2851.9779299,4282.3215008,20.5210707,447.2458942,352.6628785,716.4122216,16.2912265,19.9931938,1.7218117,60.2710584),(41041,'metatarsal.tif',248,10,91,159.3135574,96.0011716,113.4666464,1.8,96.0739137,113.4982206,1.0535345,8.0671619,9.5479155,2812.0702623,4294.1191537,20.0593763,449.7441526,348.5823528,712.5345968,16.2329838,20.0623347,1.7429871,60.2710584),(41042,'metatarsal.tif',248,10,92,158.1295082,95.9497933,113.4662137,1.8,96.0035483,113.5053226,1.0378308,8.0019334,9.5901666,2774.3862045,4306.59159,19.5512586,449.0632731,346.7144837,709.4034738,16.1103337,20.0623347,1.7429871,60.5227638),(41043,'metatarsal.tif',248,10,93,157.8711916,95.8914494,113.4701901,1.8,95.9605755,113.514468,1.0217255,7.9813997,9.6379214,2755.6655376,4343.0313233,19.1451919,450.6190835,345.2609373,710.7845502,16.0570858,20.0623347,1.7429871,59.9150932),(41044,'metatarsal.tif',248,10,94,157.1740668,95.8236671,113.4812989,1.8,95.9214686,113.6513165,1.0168486,8.6558298,15.9873306,2738.6991487,4403.4455017,18.9466202,275.433443,316.3993778,395.706669,16.0041238,20.0116547,1.8313987,59.9150932),(41045,'metatarsal.tif',248,10,95,156.2238845,95.7492666,113.4705306,1.8,95.8322658,113.5188329,0.9870497,7.8303402,9.6657897,2705.4796453,4381.4201899,18.1279411,453.2914894,345.5123992,712.7238976,15.9414403,20.0116547,1.8313987,59.9150932),(41046,'metatarsal.tif',248,10,96,155.7728235,95.678387,113.4695477,1.8,95.7686584,113.4917659,0.9742378,7.8814607,9.7173505,2686.2269749,4404.1736454,17.7680234,453.2278266,340.8285674,707.2637731,15.893763,20.126652,1.8520285,60.1667986),(41047,'metatarsal.tif',248,10,97,154.0418726,95.5809831,113.4300129,1.8,95.6682286,113.4624872,0.9544905,7.831929,9.7286832,2630.1572123,4384.5542001,17.0957619,450.6832111,335.824958,700.9204614,15.6783731,20.1358234,2.4468544,60.019353),(41048,'metatarsal.tif',248,10,98,153.360973,95.5170591,113.4491432,1.8,95.6100133,113.4632087,0.9441476,7.8008766,9.7690527,2614.5969056,4397.2523867,16.7699137,450.1206539,335.1670658,701.2598094,15.6531423,20.1999066,2.4768182,59.6633878),(41049,'metatarsal.tif',248,10,99,152.712244,95.4513543,113.4730849,1.8,95.5690326,113.4827185,0.9315435,7.7971345,9.8993084,2594.2419328,4412.5701537,16.3929796,445.7452957,332.7173523,700.7755521,15.6531423,20.1999066,2.2355708,60.019353),(41050,'metatarsal.tif',248,10,100,152.941635,95.3668319,113.5103795,1.8,95.4495424,113.5151496,0.9167628,7.7926596,9.9367831,2580.3743116,4438.638688,16.0552671,446.6876878,331.1288358,699.1079517,15.4331422,20.413572,2.4306833,60.019353),(41051,'metatarsal.tif',248,10,101,152.5266611,95.2755338,113.5411658,1.8,95.3851811,113.5618004,0.9013367,7.8049165,9.9847039,2565.6324975,4439.8789259,15.6315002,444.668063,328.7200422,694.2132474,15.6266361,20.4677674,2.4602944,60.2710584),(41052,'metatarsal.tif',248,10,102,152.0332467,95.1968275,113.5669712,1.8,95.3245293,113.5788948,0.8879617,7.8191178,10.0269983,2551.7553757,4455.0991289,15.250095,444.3103521,326.3482476,691.247189,15.6413592,20.5398055,2.4897235,60.6270236),(41053,'metatarsal.tif',248,10,103,151.5913053,95.1157345,113.6186275,1.8,95.2227671,113.598114,0.8713934,7.7642887,10.1063348,2537.5931167,4473.0589529,14.7946003,442.5995233,326.8287927,689.469263,15.6001298,20.6294994,2.5189219,60.2710584),(41054,'metatarsal.tif',248,10,104,151.1409717,95.0158781,113.6672524,1.8,95.1262143,113.644649,0.8548167,7.7923084,10.1384438,2525.3966264,4482.2790615,14.3381329,442.1072052,324.0883809,685.858797,15.4956002,20.7410714,2.4442019,60.2710584),(41055,'metatarsal.tif',248,10,105,150.9730127,94.9104739,113.7159391,1.8,95.0616671,113.7065825,0.8406172,7.857924,10.1745717,2506.9497,4499.3971603,13.967692,442.2198096,319.0346071,682.0869824,15.4956002,20.8830136,2.5022067,60.2710584),(41056,'metatarsal.tif',248,10,106,151.1107032,94.824907,113.7786457,1.8,94.9742595,113.7644591,0.8217199,7.7074209,10.1886299,2490.1432836,4510.6444041,13.5065219,442.7135414,323.0838583,679.4765107,15.1917649,20.8830136,2.5022067,60.019353),(41057,'metatarsal.tif',248,10,107,150.8230693,94.7345956,113.8415925,1.8,94.8872725,113.8503424,0.8089754,7.7756844,10.2201894,2484.9728909,4509.9663299,13.1610349,441.2801105,319.5825304,676.545916,15.4956002,20.9800419,2.5308667,60.2710584),(41058,'metatarsal.tif',248,10,108,149.876244,94.6314606,113.9169794,1.8,94.8074114,113.9056519,0.7990985,7.8618617,10.232358,2475.5993691,4509.8347218,12.8318702,440.7424679,314.8871698,672.999637,15.4956002,21.0941362,2.5592397,60.2710584),(41059,'metatarsal.tif',248,10,109,150.0711704,94.5321472,113.985213,1.8,94.685504,113.9318813,0.7845037,7.6812067,10.2481812,2478.7267049,4534.1985544,12.4835586,442.4393433,322.7001706,672.8826014,15.4956002,21.1422216,2.485897,60.5227638),(41060,'metatarsal.tif',248,10,110,150.0469445,94.420276,114.0368099,1.8,94.5581577,113.9646543,0.7707396,7.8252216,10.3176254,2473.4901013,4552.1505005,12.1373864,441.2013751,316.0920211,670.0157028,15.4956002,21.3334791,2.5424173,60.5227638),(41061,'metatarsal.tif',248,10,111,150.2258135,94.3147121,114.0927321,1.8,94.4527021,114.0304966,0.7539675,7.9143029,10.3862158,2471.8181185,4574.8070152,11.7323876,440.4690883,312.3229094,668.3847997,15.7994355,21.3334791,2.5424173,60.0625388),(41062,'metatarsal.tif',248,10,112,150.4891096,94.2356298,114.1490754,1.8,94.388438,114.086467,0.738258,7.8059115,10.4339423,2483.2274221,4610.5743371,11.3601639,441.8822905,318.1213923,670.5995754,15.4956002,21.4543008,2.5702552,59.8108334),(41063,'metatarsal.tif',248,10,113,148.7286736,94.0583881,114.1868451,1.8,94.2211477,114.1135491,0.7195477,7.9482278,10.5731127,2467.29376,4600.9652073,10.7664613,435.1571156,310.4206164,660.1202207,15.7994355,21.5915548,2.5977602,60.6702094),(41064,'metatarsal.tif',248,10,114,148.3646692,93.9386096,114.2662695,1.8,94.12408,114.1731585,0.705532,8.0053532,10.6354599,2476.8110637,4630.1042426,10.397224,435.345937,309.3943536,660.0338128,16.0367949,21.6896696,2.5535901,60.9219148),(41065,'metatarsal.tif',248,10,115,148.6764172,93.831569,114.3676623,1.8,93.9916959,114.2342074,0.6975982,7.9807778,10.6653645,2477.5192361,4686.1004868,10.2252343,439.3755601,310.4358119,662.876258,15.7994355,21.8169824,2.5809057,61.0261746),(41066,'metatarsal.tif',248,10,116,148.7382408,93.7055666,114.4443382,1.8,93.8805963,114.2976015,0.6879417,8.0729854,10.730358,2482.8739506,4736.9960353,9.9942048,441.4574089,307.5533787,663.7813736,16.1032708,22.04848,2.5644004,61.8855506),(41067,'metatarsal.tif',248,10,117,148.1863037,93.6093847,114.5218742,1.8,93.7896824,114.4203252,0.6842114,7.9856906,10.911269,2471.0194376,4786.0703301,9.8667996,438.6355355,309.4309014,664.4461573,15.7994355,22.1820578,2.5912067,61.8855506),(41068,'metatarsal.tif',248,10,118,149.0353302,93.4967646,114.5903284,1.8,93.6938622,114.4831186,0.6788542,8.0526733,11.0221064,2476.9539384,4893.9952718,9.793123,444.0163352,307.5939947,666.0728233,16.1032708,22.4303721,2.5057542,62.7449266),(41069,'metatarsal.tif',248,10,119,149.3923409,93.3906296,114.6642541,1.8,93.5997895,114.5779578,0.6783893,8.0473784,11.0588081,2486.1741312,5005.6570958,9.8052699,452.6398355,308.9421195,674.085907,16.1032708,22.5289315,2.5324292,62.7449266),(41070,'metatarsal.tif',248,10,120,149.7725704,93.2926188,114.7522406,1.8,93.4938765,114.6758081,0.6761638,8.039806,11.2190359,2487.754258,5137.1249016,9.7759674,457.8936151,309.4296376,679.341943,16.1032708,22.6881774,2.4905159,63.3525972),(41071,'metatarsal.tif',248,10,121,149.1021333,93.1619375,114.8421635,1.8,93.4016599,114.7558514,0.675693,8.0591145,11.3311357,2486.1849181,5242.0415819,9.7207858,462.622786,308.493559,679.928916,16.1032708,22.951132,2.4756234,63.6043026),(41072,'metatarsal.tif',248,10,122,151.5355242,93.0663965,114.969209,1.8,93.2777543,114.8729965,0.6784779,8.0138269,11.3894184,2516.0402387,5437.1720887,9.948123,477.3880359,313.9623895,694.3637124,15.7994355,23.2389317,2.5535901,64.0645276),(41073,'metatarsal.tif',248,10,123,152.9980316,92.9301325,115.075131,1.8,93.1495912,114.9701492,0.6758823,8.0507033,11.4325754,2561.1055154,5589.3603983,9.9794926,488.8977489,318.1219603,707.9788567,16.1032708,23.3775546,2.5127964,64.5679384),(41074,'metatarsal.tif',248,10,124,153.2240098,92.8023479,115.265971,1.8,93.0278576,115.1509757,0.6758888,8.0771357,11.6152664,2575.5221119,5731.0646346,9.9943937,493.4079391,318.8657735,714.0534492,16.1032708,23.63284,2.4980915,65.5315742),(41075,'metatarsal.tif',248,10,125,156.4279306,92.6458384,115.4147787,1.8,92.897324,115.3090852,0.6799647,8.1616363,11.6406883,2649.5206908,5952.603325,10.307196,511.3617988,324.6310658,736.7539598,16.4071061,23.7264049,2.5234484,65.7832796),(41076,'metatarsal.tif',248,10,126,158.7870212,92.4700582,115.6060052,1.8,92.6944242,115.4788457,0.685326,8.2138551,11.6507356,2712.8846399,6154.7432941,10.6015385,528.2707905,330.28153,756.9469405,16.4071061,23.8931257,2.483704,66.7469154),(41077,'metatarsal.tif',248,10,127,161.4057152,92.2850506,115.8168059,1.8,92.5496379,115.6897282,0.693454,8.2737316,11.8109963,2812.4979981,6350.0663057,10.9910067,537.6401904,339.9310187,775.755664,16.7109414,24.0970318,2.4445713,67.2503262),(41078,'metatarsal.tif',248,10,128,163.9841819,92.1026486,116.0455296,1.8,92.3993889,115.9129543,0.6926979,8.4546003,11.8615852,2926.7973315,6509.465042,11.146274,548.785423,346.1780826,793.0010015,16.7109414,24.2345556,2.4945455,67.6062914),(41079,'metatarsal.tif',248,10,129,167.8014719,91.7984768,116.3037338,1.8,92.0904901,116.1919926,0.6987119,8.5717024,11.988424,3106.759883,6696.2048441,11.5712357,558.5558894,362.4437399,812.6600978,17.0147767,24.375091,2.2813346,68.8216326),(41080,'metatarsal.tif',248,10,130,172.6949972,91.5558714,116.5344986,1.8,91.8944893,116.4440438,0.6941781,8.794673,12.0764203,3321.7432816,6965.4758764,11.7802488,576.7831597,377.6994658,848.453111,17.6200897,24.4959849,2.2318395,70.0369738),(41081,'metatarsal.tif',248,10,131,178.2500079,91.3084959,116.8089937,1.8,91.6122888,116.7402076,0.6939097,8.9443363,12.0353983,3611.3729316,7223.585574,12.1513398,600.1949768,403.7608615,878.6087647,17.8847004,24.7881939,2.1587989,71.3565748),(41082,'metatarsal.tif',248,10,132,185.7731934,91.0764007,117.1191529,1.8,91.3847251,117.0532147,0.7026307,9.2311179,12.2451141,3960.6137129,7533.4546574,12.9301228,615.2212687,429.0502791,915.2364016,18.2834172,25.1468455,2.1493205,73.6829974),(41083,'metatarsal.tif',248,10,133,196.734726,90.917128,117.5485518,1.8,91.1618383,117.6191421,0.7037452,10.0949271,12.3873285,4454.9811537,8088.1025514,13.7291174,652.9335662,441.3088983,974.6663798,20.0814275,25.8527955,1.9451299,78.188397),(41084,'metatarsal.tif',248,10,134,218.9865478,90.6448503,118.0160405,1.8,90.7433307,117.9970377,0.661563,10.2424655,12.9711936,5246.7742996,9616.3807172,13.7752388,741.3643664,512.2569639,1115.2339586,20.5821797,26.7167822,2.0560233,81.0182304),(41085,'metatarsal.tif',248,10,135,245.0744585,90.2813822,118.3955812,1.8,90.5394199,118.3329872,0.660117,10.0597279,13.1034912,6170.4228696,11236.3925023,15.3590453,857.5113534,613.3787066,1264.8790843,20.6386306,27.5033887,2.0763774,83.1972074),(41086,'metatarsal.tif',248,10,136,271.3801787,90.106727,118.6135481,1.8,90.3810977,118.4905148,0.6826651,10.2689487,13.1492296,6903.6978897,12307.6007766,18.001021,935.994055,672.2886741,1381.7946222,20.8077734,28.087926,2.0823525,84.5168083),(41087,'metatarsal.tif',248,10,137,289.8822969,90.1022926,118.6974777,1.8,90.3018346,118.6330918,0.689421,10.1960949,13.2268658,7223.3943467,13176.2156043,19.5482697,996.1706589,708.4471448,1450.7510077,20.5930291,28.3268372,1.9597532,85.1244789),(41088,'metatarsal.tif',248,10,138,298.3710506,90.171824,118.6859828,1.8,90.2170245,118.6965053,0.6974442,10.1977993,13.1146881,7391.2511125,13114.8000233,20.5129559,1000.0085376,724.7888355,1453.4232168,20.3793983,28.7248919,1.9540805,84.5168083),(41089,'metatarsal.tif',248,10,139,305.0105212,90.2314705,118.6183547,1.8,90.1184316,118.7001295,0.7242659,10.4518173,12.8874066,7364.0454687,12436.2765898,22.3176152,964.9945055,704.5708157,1403.083034,20.3102649,28.3268372,1.9597532,83.4057269),(41090,'metatarsal.tif',248,10,140,279.8312227,90.2370341,118.4504135,1.8,90.1255505,118.7347183,0.7366019,10.3590691,12.9808356,6602.7812955,10313.5604521,21.0470929,794.5220745,637.3913726,1206.9291544,19.9204645,27.4899593,2.0064792,80.7233391),(41091,'metatarsal.tif',248,10,141,252.0706041,90.4136735,118.2880861,1.8,90.3127986,118.5896316,0.7119893,9.7910427,12.3318399,5528.5827965,8628.7828019,17.9329153,699.7157661,564.6572056,1044.6359487,19.1005189,26.3514727,1.9906763,78.0409514),(41092,'metatarsal.tif',248,10,142,234.4021263,90.5251897,118.0776241,1.8,90.4173012,118.3195398,0.6674818,9.2481946,11.5368488,4307.1785035,7872.3886288,14.969453,682.369057,465.7318189,954.295149,18.0309764,25.1468455,1.9195673,73.891517),(41093,'metatarsal.tif',248,10,143,212.1390588,90.5628129,117.9130979,1.8,90.5142343,118.1213618,0.6438936,8.2178416,11.1470888,2922.6710798,7020.4906143,12.7416657,629.8048508,355.6494776,828.7829756,16.2205003,24.0970318,2.1142739,69.8463424),(41094,'metatarsal.tif',248,10,144,172.614095,90.6137999,117.8501834,1.8,90.5520345,117.9283113,0.637932,7.0126636,10.8682524,1557.0564497,5357.7569086,10.2032903,492.9731753,222.0349559,612.8446022,14.0763709,23.0314371,2.2105661,64.6290124),(41095,'metatarsal.tif',248,10,145,62.7437526,90.6892498,117.7150485,1.8,90.5672667,117.6652968,0.6322684,4.7664465,9.624361,196.1886485,1388.5087793,3.6522386,144.2702311,41.1603589,164.2978801,9.6281086,19.7843213,2.5415424,50.8611082),(41096,'metatarsal.tif',248,10,146,0.2920539,91.3244223,118.6570241,1.8,91.3477625,118.6720131,0.5580669,0.7975304,1.3195495,0.0588153,0.1460932,0.0136496,0.1107144,0.0737468,0.1547012,2.1144386,3.0985242,2.5535901,7.1877874),(41097,'metatarsal.tif',248,10,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41098,'metatarsal.tif',248,10,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41099,'metatarsal.tif',248,10,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41100,'metatarsal.tif',248,10,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41101,'metatarsal.tif',248,10,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41102,'metatarsal.tif',248,10,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41103,'metatarsal.tif',248,10,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41104,'metatarsal.tif',248,10,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41105,'metatarsal.tif',248,10,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41106,'metatarsal.tif',248,10,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41107,'metatarsal.tif',248,10,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41108,'metatarsal.tif',248,10,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41109,'metatarsal.tif',248,10,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41110,'metatarsal.tif',248,10,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41111,'tibia',253,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41112,'tibia',253,8,2,45.6593826,89.5987549,132.7445554,1.8,90.9821141,132.1207082,-0.1816515,8.6280391,22.3719295,401.2134617,4944.2068934,0.248356,221.0004681,46.5011176,235.9340739,13.1325592,20.9095205,0.1651487,68.3182218),(41113,'tibia',253,8,3,433.0189216,90.325575,127.9119516,1.8,92.7575096,125.7569498,-0.3102659,23.6467373,26.6993265,29527.2366504,62764.2747619,6.7273355,2350.7812024,1248.6812134,3297.74517,39.4857764,49.9511145,2.9948295,224.2169026),(41114,'tibia',253,8,4,648.4100733,92.8468059,123.905891,1.8,94.3652199,123.8406539,-0.337024,25.5221451,30.1694288,73539.8751109,120326.2040773,11.8171939,3988.3487649,2881.4143451,6102.0770207,45.3454781,59.6462046,0.1082706,192.4274001),(41115,'tibia',253,8,5,624.3632949,93.7598426,122.4132981,1.8,94.7407423,122.5521403,-0.30034,27.5389095,30.5297339,90727.6816512,117484.6815062,9.1078244,3848.2052309,3294.5270258,6314.0762877,48.0093084,60.0733944,0.1074977,199.7015591),(41116,'tibia',253,8,6,573.7481716,94.3838705,122.563169,1.8,95.9943923,122.9375677,0.0772387,29.0153619,41.3988587,85697.2465759,115044.7749556,0.5693455,2778.9359055,2953.5129272,4845.4361182,47.6014444,62.5546632,3.0521765,203.4339544),(41117,'tibia',253,8,7,525.4140341,96.5723073,124.0963693,1.8,97.9489352,124.3042809,0.1033536,28.1361482,41.9274994,67336.1715454,134308.9559453,0.9320843,3203.3619431,2393.2263625,4808.4814052,45.0967692,68.7567935,0.1127276,230.8908005),(41118,'tibia',253,8,8,511.1893305,99.3361168,125.1866357,1.8,100.2488662,125.5092649,0.107541,26.8676632,40.0977704,56293.272183,165845.824792,0.9815303,4136.0360693,2095.2053696,5539.8948297,42.8232417,68.7097849,0.1065136,196.0197592),(41119,'tibia',253,8,9,494.3248402,100.871837,125.887682,1.8,101.1361813,126.2622899,0.11045,26.0527812,38.8258579,48588.8791339,174120.5732657,1.0009807,4484.654883,1865.0169711,5730.6149238,41.2054284,68.1566983,0.0883768,194.006116),(41120,'tibia',253,8,10,473.1740952,101.2464428,126.3412713,1.8,101.6050545,126.8331302,0.1156879,25.0947327,38.4415552,43237.3768994,166806.3291856,1.0507687,4339.2190593,1722.9662245,5457.4195931,39.9535616,67.4281656,0.108546,190.108387),(41121,'tibia',253,8,11,454.6725364,101.5322432,126.6735607,1.8,101.9872327,127.2918067,0.1246889,24.4141108,38.0981264,39333.5906243,160022.0645332,1.172063,4200.2607425,1611.1006874,5221.2356724,38.8924283,66.6224281,0.1163552,188.2421894),(41122,'tibia',253,8,12,446.5081192,101.7247786,126.9597955,1.8,102.2858662,127.6947822,0.1310315,23.7109207,37.8530622,36779.4892114,156121.8900081,1.2704063,4124.419025,1551.1624233,5079.861539,37.8740303,66.1468356,0.1106572,185.811507),(41123,'tibia',253,8,13,430.1111389,102.1529655,127.2914097,1.8,102.5744308,128.0449989,0.1377943,23.0673974,37.4801032,33696.155028,150809.2205259,1.3525125,4023.7141218,1460.7696928,4910.0367309,37.0301737,65.7197928,0.1113792,184.55298),(41124,'tibia',253,8,14,420.1380576,102.3828385,127.5393052,1.8,102.834112,128.3439462,0.1448335,22.6001925,37.2589443,31647.2980926,147244.6802504,1.4586131,3951.9284072,1400.3109963,4788.2904924,36.5857515,65.2022339,0.0990129,181.514627),(41125,'tibia',253,8,15,415.2248382,102.578689,127.7412303,1.8,103.0079966,128.5983129,0.1530748,21.8927608,37.0106651,29928.6747141,144700.0549691,1.6089579,3909.6853419,1367.0580416,4700.504119,35.8339693,64.6262751,0.0732023,179.6916152),(41126,'tibia',253,8,16,409.8255336,102.7661326,127.9846558,1.8,103.1034006,128.8184688,0.1597005,21.5368021,36.7647047,28261.2580768,142173.1214287,1.7272891,3867.1090322,1312.2309422,4612.7340527,35.4044285,63.9196105,0.1010064,177.9728632),(41127,'tibia',253,8,17,405.0181698,102.77883,128.2066142,1.8,103.171584,128.9992446,0.1641598,20.9232218,36.6263122,26702.3118058,138524.1512569,1.8028197,3782.0938767,1276.2045971,4505.2509798,34.5678429,63.1100365,0.1091535,175.0819559),(41128,'tibia',253,8,18,398.790428,102.8844997,128.4310347,1.8,103.3840036,129.2606163,0.1697988,20.565878,36.4730919,25328.0105197,135258.301348,1.8979498,3708.4407785,1231.5550319,4394.2682747,34.2273218,62.6372514,0.1030816,173.1114985),(41129,'tibia',253,8,19,396.4805726,102.8920952,128.6034587,1.8,103.388087,129.4474107,0.1786241,20.1282999,36.3370653,24138.9093172,132012.666499,2.0860606,3633.0029822,1199.2522692,4280.7791036,33.8126974,62.0895443,0.0831412,171.2884867),(41130,'tibia',253,8,20,391.9012569,102.8891987,128.731981,1.8,103.5171272,129.6587408,0.1866877,19.5714143,36.1858895,23172.2819286,129091.8547081,2.2501192,3567.4639074,1183.9860709,4202.3588207,33.390574,61.2708571,0.0912948,169.2137695),(41131,'tibia',253,8,21,388.3793218,102.8139918,128.8733553,1.8,103.5292848,129.7728814,0.1926251,19.1399881,36.0565191,22105.3972887,125480.5095856,2.3722067,3480.1060266,1154.9326558,4078.5320697,32.9609514,60.8050273,0.0849018,167.6424631),(41132,'tibia',253,8,22,386.94574,102.8306796,129.0899285,1.8,103.4122099,129.9272167,0.1971133,18.7808999,35.7305811,21175.4504925,123087.9481184,2.4734261,3444.8907408,1127.4992446,4027.6635224,32.5613252,60.2804944,0.0641974,165.2117807),(41133,'tibia',253,8,23,387.9491298,102.8521632,129.2456416,1.8,103.3884431,130.0396589,0.2032768,18.4190893,35.4885089,20482.1188075,121848.2708379,2.6351732,3433.4570479,1112.004968,3988.8335964,32.1953754,59.8023204,3.0912754,164.2049591),(41134,'tibia',253,8,24,389.4377655,102.7503206,129.3951437,1.8,103.1913826,130.1405524,0.2088644,18.0848809,35.2936801,19984.7038406,119562.7084992,2.7905597,3387.6520702,1105.0503411,3938.2505794,31.7769528,59.3731802,3.0909115,162.7379125),(41135,'tibia',253,8,25,387.9455491,102.6382319,129.4622386,1.8,102.9799151,130.1797582,0.2150047,17.9937207,35.132429,19370.1926502,117419.3604004,2.9431541,3342.1930639,1076.4973503,3883.5351702,31.7769528,58.5953286,3.0681953,160.5589355),(41136,'tibia',253,8,26,385.2957474,102.5343847,129.6184121,1.8,102.821964,130.2699005,0.2165132,17.9614941,34.8691068,18859.8509482,114834.3054418,2.9635685,3293.2964425,1050.0157083,3826.2889681,31.4742066,58.166806,3.0676536,158.8401835),(41137,'tibia',253,8,27,384.621114,102.2712974,129.7030433,1.8,102.6277094,130.3582215,0.219581,17.7274834,34.7746328,18568.5452413,111841.6253643,3.0414454,3216.1842194,1047.4439502,3744.1288226,31.271362,57.7079143,3.0745292,157.8765477),(41138,'tibia',253,8,28,386.7084042,102.1853403,129.8135398,1.8,102.5669781,130.4200783,0.2207769,17.7421101,34.5067592,18333.570725,111023.3644572,3.0908087,3217.4381747,1033.3365424,3731.4689057,31.2535029,57.2276023,3.0890096,157.0171717),(41139,'tibia',253,8,29,387.0805212,102.0303259,129.8821713,1.8,102.3215395,130.4255678,0.2226497,17.4902997,34.2601568,18099.4234136,109132.7126089,3.1456192,3185.411941,1034.8263741,3694.7990298,30.937536,56.7985127,3.088612,155.6543849),(41140,'tibia',253,8,30,387.4841375,101.8190448,129.9613722,1.8,102.1130267,130.4784216,0.2243664,17.4936054,34.023595,17967.1445972,106782.1310067,3.1968235,3138.4729071,1027.069272,3646.6691354,30.8202783,56.3481382,3.0958231,155.4026795),(41141,'tibia',253,8,31,388.9177752,101.5570665,130.0290777,1.8,101.9954,130.5706591,0.2266542,17.487545,33.7401727,18001.7645587,104850.5228607,3.27329,3107.587022,1029.4049022,3614.7621645,30.8202783,55.536239,3.0796565,152.9719971),(41142,'tibia',253,8,32,390.2114286,101.3182152,130.0889625,1.8,101.869318,130.620804,0.2298134,17.4542401,33.4028982,18043.7362735,102831.5570589,3.3747389,3078.5219997,1033.7738092,3605.5979901,30.7535867,54.7392831,3.0630146,151.1489853),(41143,'tibia',253,8,33,390.4499952,101.1488936,130.1536188,1.8,101.7006733,130.6534442,0.2315962,17.5284325,33.1295068,18017.6200984,101300.8331275,3.4284558,3057.7223456,1027.908233,3587.7282749,30.8891027,54.3466148,3.0545118,150.7930201),(41144,'tibia',253,8,34,390.2255837,100.9756454,130.2141,1.8,101.6006029,130.7218817,0.2348103,17.5781429,33.0564379,18111.4302714,99748.9908658,3.5204849,3017.535981,1030.3380965,3557.6775793,30.8462184,54.0006879,3.0379652,150.5413147),(41145,'tibia',253,8,35,390.5476262,100.804831,130.28154,1.8,101.49059,130.7779993,0.2379652,17.6357501,32.781909,18254.6147641,98454.4948711,3.6169014,3003.3179266,1035.0914854,3551.4963072,30.8462184,53.6198288,3.0291655,150.2896093),(41146,'tibia',253,8,36,394.1363644,100.6268906,130.3607303,1.8,101.413432,130.8942451,0.2409865,17.8118023,32.6140109,18540.7809489,97776.1152986,3.7415998,2997.978861,1040.9267226,3559.8439366,30.9713569,53.2431809,3.0202407,149.8293843),(41147,'tibia',253,8,37,393.6010442,100.4455984,130.4062496,1.8,101.2653015,130.9188076,0.2445805,17.8471481,32.6667656,18676.3881228,96149.3527379,3.8465513,2943.3386217,1046.4634461,3513.8977425,30.9256942,53.0260062,3.0604703,149.5776789),(41148,'tibia',253,8,38,391.9862994,100.2595224,130.46828,1.8,101.1773223,130.960654,0.249567,17.9866373,32.5006472,18732.3669718,94167.7628597,3.9852776,2897.4119318,1041.4602039,3446.0548124,31.184096,53.102553,3.0443395,148.7183029),(41149,'tibia',253,8,39,390.7664429,99.9445642,130.5100316,1.8,100.8945689,130.9869646,0.255775,18.0191868,32.5702329,18818.8114853,91318.8339833,4.168607,2803.7513339,1044.37629,3362.0465164,31.1584306,52.7659663,3.0273383,147.6072215),(41150,'tibia',253,8,40,389.640189,99.643118,130.564563,1.8,100.5999942,131.0432675,0.2628525,18.0516247,32.5181984,18864.9884126,88444.064321,4.3844148,2719.8328496,1045.0576437,3282.621454,31.0183461,52.3902281,3.018255,148.0674465),(41151,'tibia',253,8,41,388.6668439,99.3326684,130.5812644,1.8,100.2911974,131.0021557,0.2704209,18.1160844,32.1880641,18907.1603559,85588.2690089,4.6226867,2659.0064207,1043.6670523,3235.5806989,31.066385,51.6520008,2.9996956,146.2444347),(41152,'tibia',253,8,42,387.9721808,99.0661848,130.6197601,1.8,100.0418135,131.0487634,0.2779304,18.2316388,31.9998669,19015.157907,83381.7414917,4.8675448,2605.6902637,1042.9757906,3187.1347926,30.9272136,51.2897023,2.9902172,145.3850587),(41153,'tibia',253,8,43,389.2912909,98.8346732,130.632987,1.8,99.6814393,131.0264039,0.2853823,18.2017991,31.6627486,19110.150632,81510.1062699,5.1422733,2574.3218721,1049.9044895,3158.8928172,30.9407483,50.8014073,2.9973033,144.1697175),(41154,'tibia',253,8,44,391.9290076,98.6367538,130.6651636,1.8,99.4322653,130.996454,0.2926708,18.1849791,31.4053741,19296.4528136,79870.5784855,5.4372515,2543.2137234,1061.1204273,3136.2922591,30.8609229,50.3157126,3.0045265,143.6663067),(41155,'tibia',253,8,45,391.9539049,98.5372291,130.6966863,1.8,99.2300615,131.0066639,0.2971844,18.3055624,31.189389,19408.822057,78787.0457089,5.6016061,2526.0849342,1060.2690917,3130.5258137,30.8998974,50.1723993,2.5512148,144.0222719),(41156,'tibia',253,8,46,393.0491071,98.3299414,130.7272497,1.8,98.9231397,130.9801168,0.3040461,18.4540831,30.8157787,19581.4356805,76404.693129,5.8715151,2479.4016685,1061.0895997,3089.9149919,30.8129314,49.6396585,3.0462306,143.2671557),(41157,'tibia',253,8,47,395.1084787,98.1468129,130.7923211,1.8,98.6369588,131.0287878,0.3095963,18.6207566,30.391445,19738.3272312,74845.2112878,6.1127461,2462.7065722,1060.0174676,3095.799785,30.8288492,49.106778,2.5366014,142.1560743),(41158,'tibia',253,8,48,400.2726295,98.0541607,130.9062806,1.8,98.4774531,131.0699512,0.3120205,18.5911176,30.5688694,19861.1168946,74604.5885623,6.2868185,2440.5413127,1068.3121562,3076.1432781,30.7003821,49.4608032,2.5415424,141.6958493),(41159,'tibia',253,8,49,399.1776512,97.8749464,130.8704312,1.8,98.2086629,131.0383582,0.325261,18.4186259,30.0268689,19833.4623507,72174.2374747,6.7937445,2403.6551285,1076.8155255,3036.8609124,30.5269657,48.9033272,2.5121504,140.9407331),(41160,'tibia',253,8,50,401.3537885,97.6578476,130.9119007,1.8,97.9134538,131.0829483,0.3386754,18.3306468,29.1109252,19959.2797639,69649.4978153,7.3837139,2392.5552829,1088.8475431,3068.1344862,30.2228328,48.2113,2.5016566,139.1787953),(41161,'tibia',253,8,51,404.318807,97.4678431,130.9028269,1.8,97.7338034,131.0451315,0.3534766,18.3158431,28.70237,20269.5145925,67631.5591986,8.0747739,2356.3057367,1106.6656605,3044.7913324,30.1249863,48.050186,2.4766279,138.3194193),(41162,'tibia',253,8,52,410.126987,97.2898728,130.8691359,1.8,97.4279185,130.9701752,0.371595,18.2399627,27.7744824,20769.4024845,65510.4456251,9.0120689,2358.6558589,1138.6757126,3090.9472118,30.2624438,47.314483,2.4526683,136.3921477),(41163,'tibia',253,8,53,414.1206842,97.0690675,130.7759279,1.8,97.1516232,130.8383403,0.3911786,18.3532717,26.5987718,21240.2360834,63226.3723572,10.0336692,2377.041049,1157.2997147,3152.400203,30.2955228,46.0488432,2.4420754,134.7776555),(41164,'tibia',253,8,54,413.6871352,96.8669029,130.7125659,1.8,97.0328814,130.7720293,0.406312,18.3783576,25.9681587,21565.0032754,61473.7167536,10.769807,2367.2728345,1173.3912104,3171.9577488,30.1992493,45.3946612,2.4298863,132.7029383),(41165,'tibia',253,8,55,415.9282853,96.6383764,130.6494189,1.8,96.7487679,130.6839108,0.4192787,18.3909455,25.3724803,21930.251215,59796.4285098,11.4887574,2356.7435155,1192.4482723,3193.5593696,30.2744137,45.004562,2.3967128,132.4512329),(41166,'tibia',253,8,56,416.7281325,96.4312095,130.5925975,1.8,96.4845911,130.603348,0.429861,18.4477124,24.7665443,22133.4070035,58193.1396712,12.0626102,2349.6673152,1199.7914204,3215.228457,30.1728942,44.376599,2.3835849,130.2722559),(41167,'tibia',253,8,57,416.7733953,96.1916766,130.4841074,1.8,96.2092496,130.4668822,0.4386381,18.5312675,24.4041828,22213.7466551,56092.5722605,12.5293163,2298.4818879,1198.717069,3188.552464,30.0607429,43.7902459,2.3145519,129.1611745),(41168,'tibia',253,8,58,419.9542092,95.9471998,130.4083518,1.8,95.9207491,130.3937202,0.4488025,18.4177139,23.8681041,22442.3869286,54551.9452116,13.176613,2285.5583777,1218.5218567,3189.2912745,29.9221149,43.0224775,2.2642558,128.1543529),(41169,'tibia',253,8,59,419.6974591,95.6895537,130.330834,1.8,95.6833841,130.2929754,0.4643384,18.425768,23.4980635,22895.6620413,52998.4350131,14.0285924,2255.4384085,1242.5892935,3194.5174306,30.0796946,42.692914,2.2706892,127.4424225),(41170,'tibia',253,8,60,418.8736097,95.4779989,130.2655014,1.8,95.5091029,130.2675033,0.4785128,18.2732966,23.1022267,23108.0544288,51490.0755163,14.8018068,2228.7927608,1264.5804904,3169.3398567,29.8864451,42.3215415,2.2915365,126.3313411),(41171,'tibia',253,8,61,415.4521591,95.2579842,130.1499021,1.8,95.3237594,130.1592636,0.4921197,18.2663518,22.7279019,23164.7522274,49777.6440731,15.4583964,2190.1557076,1268.1652315,3120.8038858,29.778565,41.6065805,2.2390857,124.9685543),(41172,'tibia',253,8,62,415.1320747,95.0310048,130.0667085,1.8,95.1094771,130.0698429,0.5062512,18.1444947,22.3738142,23312.346583,48426.9811125,16.2683338,2164.4490578,1284.8165196,3099.2757175,29.8308641,41.2701847,2.2455373,124.0049185),(41173,'tibia',253,8,63,413.6909398,94.831065,130.0135885,1.8,94.9027214,129.9781505,0.5170366,18.0549368,22.167529,23378.7494536,47045.5921627,16.8467833,2122.2749823,1294.8674212,3054.6939391,29.8774995,40.9355348,2.2520946,124.6125891),(41174,'tibia',253,8,64,412.4664954,94.6392324,129.8922514,1.8,94.669011,129.8291803,0.5306187,18.0854617,21.7634856,23437.8395718,45648.3693033,17.6057129,2097.4751032,1295.9491953,3027.554793,29.9067277,40.2188886,2.2121607,122.2861665),(41175,'tibia',253,8,65,410.7667081,94.4478553,129.7411104,1.8,94.4558118,129.6901092,0.5414622,18.0622498,21.5984643,23365.1934132,44252.568902,18.1850797,2048.8757131,1293.5926393,2986.9726141,29.8621205,39.8754168,2.2186078,121.4267905),(41176,'tibia',253,8,66,410.0157044,94.2919651,129.6328662,1.8,94.3408492,129.5998357,0.5542897,17.8805276,21.2898365,23381.611571,43135.1583635,18.9313309,2026.0915793,1307.6578118,2946.0309222,29.7667659,39.5336312,2.2251666,120.8191199),(41177,'tibia',253,8,67,407.1891597,94.0982573,129.4934788,1.8,94.1520534,129.4440825,0.5666171,17.7014252,20.9774204,23316.6249921,41961.4836,19.5541532,2000.3166616,1317.2173814,2913.2754961,29.6437558,39.2147686,2.177034,118.9961081),(41178,'tibia',253,8,68,405.4702379,93.9484684,129.3651651,1.8,94.0054569,129.3577121,0.5793206,17.7409708,20.7627578,23286.6637612,40921.2578529,20.2537482,1970.8970378,1312.5924215,2893.8664926,29.7419128,38.7625258,2.1987776,119.3520733),(41179,'tibia',253,8,69,404.498739,93.8248003,129.2225354,1.8,93.8661465,129.2161355,0.5972865,17.8121305,20.5172083,23348.9382711,39879.0426585,21.3234661,1943.6875679,1310.8447802,2780.8324025,29.6225501,38.4156452,2.2053491,118.8486625),(41180,'tibia',253,8,70,404.458176,93.7254936,129.1198528,1.8,93.7559712,129.0922934,0.616511,18.1250779,20.2274091,23508.4053938,39139.4938603,22.5354684,1934.9731722,1297.0098956,2764.1486004,29.8699117,38.3964157,2.1246507,118.7444027),(41181,'tibia',253,8,71,404.5522822,93.6255852,129.0125191,1.8,93.6959163,129.0015218,0.6328745,17.8753365,19.9557916,23564.9095207,38295.8369063,23.5874792,1919.0337148,1318.2917962,2743.5027188,29.8292161,38.1721625,2.1150768,118.4926973),(41182,'tibia',253,8,72,402.1256052,93.5446562,128.9212448,1.8,93.5894692,128.9125122,0.6464442,17.9240335,19.7589156,23559.3858438,37350.8428969,24.3170554,1890.3285818,1314.4020192,2669.4053216,29.8463702,37.9514492,2.1053907,118.2409919),(41183,'tibia',253,8,73,402.1914013,93.4960948,128.8110768,1.8,93.5431138,128.8043174,0.6544618,17.7584509,19.4852754,23436.8487097,36441.1604658,24.8390074,1870.1896548,1319.7575002,2680.8178117,29.7294704,37.5823509,2.1112158,116.7739453),(41184,'tibia',253,8,74,402.3698227,93.3978324,128.7228146,1.8,93.4966307,128.7334621,0.6592146,17.8716684,19.3320294,23389.7362543,35528.7221319,25.1582807,1837.8164789,1308.7606475,2653.120954,29.7226986,37.1475154,2.0913772,117.1299105),(41185,'tibia',253,8,75,400.5853286,93.3158713,128.6399368,1.8,93.4123783,128.6099674,0.6674677,17.7542505,19.0686138,23434.9337998,34650.0780769,25.5813749,1817.1262223,1319.9618755,2630.2986558,29.7247335,36.7753691,2.0971887,119.6648527),(41186,'tibia',253,8,76,400.3123533,93.245819,128.5100374,1.8,93.3451252,128.4593272,0.6844266,17.484296,18.8485067,23521.4066952,34021.9569163,26.6683626,1805.0213485,1345.2876033,2621.3803714,29.635303,36.3511985,2.0767467,115.4111585),(41187,'tibia',253,8,77,398.8016178,93.1938962,128.3620973,1.8,93.2941979,128.3465829,0.695184,17.2673063,18.5935475,23463.2172033,33292.137374,27.2696875,1790.5210077,1358.8232469,2650.6827844,29.510714,35.9528451,2.0023694,113.3364413),(41188,'tibia',253,8,78,396.8819509,93.1507914,128.2727858,1.8,93.2571999,128.2662887,0.6948406,17.2306456,18.6307021,23355.0802543,32567.8026504,27.1160807,1748.0716793,1355.4384873,2622.3838281,29.6017744,35.4460046,2.1049789,112.6245109),(41189,'tibia',253,8,79,397.0295444,93.1140107,128.2031541,1.8,93.2113625,128.1139005,0.6941267,17.4291117,18.3765572,23250.5452919,31861.0829852,27.079706,1733.7895605,1334.0063301,2592.494785,29.4883507,35.2082058,1.9853032,112.0168403),(41190,'tibia',253,8,80,395.7849024,93.0908332,128.1227885,1.8,93.1786338,128.1001813,0.6960294,17.3603049,18.1621195,23117.1957483,31193.5834768,27.1182763,1717.5078903,1331.6123085,2607.5650677,29.4700101,34.8709748,1.9627439,111.2617241),(41191,'tibia',253,8,81,392.7549831,93.0849579,127.99703,1.8,93.1179707,127.9059576,0.700059,17.2213961,17.9519781,22922.1665495,30521.6243321,27.1704336,1700.1816821,1331.0283548,2581.3483498,29.333314,34.5518317,1.9397559,111.0100187),(41192,'tibia',253,8,82,389.9197103,93.0879827,127.9240684,1.8,93.1899335,127.794158,0.7031095,17.0786972,17.9317329,22772.502625,29898.7562719,27.169756,1667.3656899,1333.3864015,2558.4156138,29.21458,34.2512819,1.9163519,110.1506427),(41193,'tibia',253,8,83,388.4014776,93.1164073,127.8713178,1.8,93.2288187,127.7264757,0.6930945,17.1282044,17.7115567,22650.4554062,29333.0252017,26.4255231,1656.1517231,1322.4068811,2573.2590152,29.165355,33.8554881,1.9890207,109.6472319),(41194,'tibia',253,8,84,387.6952891,93.1126337,127.8007436,1.8,93.2045054,127.7271771,0.6881337,17.0699984,17.7220287,22524.4114911,28764.9937624,26.0626768,1623.1208218,1319.5321387,2554.4174382,29.0827015,33.5624563,1.8965954,109.5429721),(41195,'tibia',253,8,85,384.4956763,93.1004008,127.6768106,1.8,93.1824609,127.6557536,0.683742,17.0252861,17.5543705,22359.4305144,28192.2362347,25.5717011,1605.9952833,1313.3071825,2533.0316634,28.9408436,33.2973546,1.2286404,109.6472319),(41196,'tibia',253,8,86,383.3861512,93.1082941,127.5993053,1.8,93.1468704,127.5067786,0.6673419,16.8521831,17.6569133,22194.4021175,27741.3427611,24.4752188,1571.1320742,1317.0045695,2559.8380662,28.9308643,32.9545765,1.9585665,106.9648441),(41197,'tibia',253,8,87,381.8057592,93.1149128,127.5396571,1.8,93.1525885,127.4087523,0.6449129,16.9315691,17.5031398,21959.3581044,27201.196722,22.9946242,1554.07527,1296.9476131,2535.0572083,28.7389328,32.7240631,1.9756881,105.8537627),(41198,'tibia',253,8,88,380.6001137,93.1382621,127.4755396,1.8,93.1729781,127.4173754,0.628506,16.7556538,17.4802718,21730.5230377,26690.2064433,21.926994,1526.8759432,1296.9069018,2554.4828926,28.5588295,32.3951697,1.1902899,104.0307509),(41199,'tibia',253,8,89,377.7140392,93.1622928,127.3416821,1.8,93.2001232,127.3148647,0.6299775,16.6202746,17.2829672,21571.8882036,26119.6812888,21.8488768,1511.2961223,1297.9261045,2534.1856775,28.6471485,32.2838409,2.9676915,104.2392705),(41200,'tibia',253,8,90,376.350058,93.2262329,127.2607475,1.8,93.2740628,127.1760838,0.6150325,16.6473502,17.3156787,21363.3658342,25679.0928708,20.8818968,1482.9966103,1283.2892695,2511.5826766,28.5052906,32.1462915,2.9940246,107.4250691),(41201,'tibia',253,8,91,375.5439445,93.2773972,127.1797665,1.8,93.3333749,127.0299529,0.5897242,16.6453397,17.1325495,21114.773457,25237.8083207,19.3582019,1473.0912229,1268.5096146,2535.3779982,28.3311295,32.0312158,3.0205654,104.3435303),(41202,'tibia',253,8,92,375.9532675,93.3270673,127.0927822,1.8,93.3937309,126.9309692,0.5673111,16.479672,17.1812526,20920.8405368,24838.2057454,18.093535,1445.6574438,1269.4937445,2524.7269892,28.2809086,31.7213365,2.9920329,101.3051773),(41203,'tibia',253,8,93,374.8472113,93.3777929,127.0009737,1.8,93.4276407,126.8904286,0.5442639,16.3992267,16.9966917,20656.3258809,24374.6259705,16.7497286,1434.0806099,1259.5914606,2505.4361456,28.1815614,31.6017924,2.9361973,101.0534719),(41204,'tibia',253,8,94,375.0951773,93.4203373,126.9440657,1.8,93.5021901,126.8286162,0.5310448,16.2610963,16.8546706,20470.0625209,24053.4250122,16.033813,1427.1073945,1258.8365562,2538.5965811,27.9744164,31.4377783,2.9629616,99.1262003),(41205,'tibia',253,8,95,373.4322045,93.4413053,126.8967013,1.8,93.5431051,126.705143,0.50887,16.1675628,16.8696351,20240.8561103,23728.1634271,14.7726568,1406.5605641,1251.9423211,2521.7978322,27.907624,31.4377783,2.9629616,98.6227895),(41206,'tibia',253,8,96,373.0032993,93.4692227,126.8710545,1.8,93.5757241,126.7051194,0.4910389,16.1888228,16.8320622,20075.4848335,23354.3764378,13.8230141,1387.493475,1240.0830542,2505.5899669,27.7914016,31.2965106,2.9899872,97.4074483),(41207,'tibia',253,8,97,366.5442084,93.5558169,126.8159755,1.8,93.8076598,126.6941635,0.4795694,15.9790942,16.6062779,19771.8319688,22902.3615927,13.005439,1379.1387617,1237.3562447,2515.0325313,27.6237071,31.1782987,3.0172377,96.5480723),(41208,'tibia',253,8,98,363.3241742,93.5765468,126.7770693,1.8,93.7812292,126.4844004,0.4525275,16.0586845,16.4316308,19539.9592357,22570.0095924,11.5766494,1373.5708826,1216.78455,2495.4431718,27.5642295,31.0150215,2.9605,95.9404017),(41209,'tibia',253,8,99,363.0436458,93.5783944,126.712801,1.8,93.8201996,126.4566442,0.4357617,15.9158446,16.4581412,19415.9543633,22310.0878194,10.7805395,1355.5654615,1219.9135436,2482.1192082,27.5076965,30.8718194,2.9878851,95.9404017),(41210,'tibia',253,8,100,362.7852732,93.6034412,126.6721872,1.8,93.8279229,126.4491947,0.4358502,15.8412699,16.2711316,19254.3519274,22083.5027871,10.7769627,1357.2198521,1215.4550785,2471.2892002,27.3916858,30.751975,3.0155046,95.4369909),(41211,'tibia',253,8,101,360.0362739,93.6336909,126.5793508,1.8,93.8611928,126.3627169,0.4232537,15.799098,16.291062,19037.8029163,21708.0518165,10.122929,1332.5129952,1204.9930238,2449.8067594,27.3916858,30.655762,3.0433187,95.4369909),(41212,'tibia',253,8,102,358.066085,93.6662917,126.5205329,1.8,93.8901651,126.2785337,0.4064142,15.8014667,16.291237,18878.5549493,21355.7037735,9.3262157,1310.8706094,1194.7343433,2432.096066,27.3233519,30.3835299,2.9996956,94.5776149),(41213,'tibia',253,8,103,356.0524796,93.7246332,126.457091,1.8,93.9856865,126.2028866,0.3892812,15.7152401,16.0993614,18770.971311,21028.2013608,8.5475212,1306.1512752,1194.4438106,2462.2530966,27.2902534,30.1700955,2.9553698,93.258014),(41214,'tibia',253,8,104,355.1240056,93.7665304,126.4011456,1.8,94.0233275,126.2077792,0.3909296,15.5490083,16.0815232,18645.0518737,20778.2816875,8.5938617,1292.0593014,1199.1151765,2448.2205525,27.1922489,30.0935021,2.9694018,93.5097194),(41215,'tibia',253,8,105,352.9955928,93.8005026,126.2804425,1.8,94.064109,126.1092634,0.3982559,15.3934856,15.9284838,18452.1401776,20453.5768823,8.8482826,1284.0881252,1198.6979858,2434.8315878,27.1922489,29.9582221,2.9976672,93.258014),(41216,'tibia',253,8,106,352.0466974,93.8416053,126.2417406,1.8,94.1198002,126.0628813,0.3953141,15.3544796,15.9071208,18319.5895657,20204.0473106,8.7014522,1270.1259747,1193.1104206,2417.5083256,27.1224671,29.8316135,2.9385474,92.6503434),(41217,'tibia',253,8,107,347.7073471,93.8518642,126.164621,1.8,94.1527026,126.0648076,0.3929068,15.2895264,15.7637903,18041.6062651,19696.783195,8.4952724,1249.4953864,1179.9977201,2379.8495148,26.9571601,29.6702598,2.9669205,92.7546031),(41218,'tibia',253,8,108,348.0946262,93.908977,126.1521179,1.8,94.1764433,126.2138093,0.4247598,15.1128936,15.5071615,18004.7198639,19528.7408001,9.8527038,1259.336909,1191.3482822,2369.8256669,26.9630255,29.7479429,1.3818991,95.8972159),(41219,'tibia',253,8,109,346.875497,93.9315879,126.1041303,1.8,94.1992904,126.2550165,0.4354361,15.0084063,15.4614827,17822.1159761,19319.8131829,10.2860239,1249.5446595,1187.4755775,2352.5847633,26.7353256,29.5986112,1.4104209,94.4301693),(41220,'tibia',253,8,110,345.629848,93.9666448,126.0486674,1.8,94.2431117,126.2257576,0.4448069,14.8966906,15.2607803,17694.0373455,19087.1964151,10.6652126,1250.7352894,1187.7830983,2338.5119708,26.7353256,29.3260093,1.3791478,92.8588629),(41221,'tibia',253,8,111,344.7076402,93.999686,126.0040528,1.8,94.2356571,126.1780817,0.4740255,14.6980764,15.2186143,17546.5054841,18904.9905597,11.9709092,1242.2281125,1193.7960461,2331.2193723,26.5986294,29.4202952,1.4536876,92.3554521),(41222,'tibia',253,8,112,343.9221159,94.0375806,125.959683,1.8,94.2772471,126.1081305,0.4954736,14.5405252,15.1576668,17391.2498878,18751.4091022,12.957332,1237.090733,1196.0537664,2318.5154463,26.4177644,29.1079925,1.4226363,92.2511923),(41223,'tibia',253,8,113,342.1623513,94.0746589,125.86671,1.8,94.2737855,126.0562271,0.521322,14.3111024,14.9587308,17241.46655,18511.5564922,14.1444706,1237.508497,1204.7615954,2307.7046611,26.4177644,29.1745179,1.408069,92.2511923),(41224,'tibia',253,8,114,341.8530651,94.1193204,125.826063,1.8,94.3178779,126.0284778,0.5370388,14.0202292,14.9138882,17115.6014678,18321.4687022,14.9121027,1228.4837124,1220.7790087,2344.1124679,26.2810683,28.8243473,1.3909428,90.4281806),(41225,'tibia',253,8,115,342.6997976,94.1697083,125.8104597,1.8,94.3618129,126.0519355,0.5465679,13.9336881,14.7174218,17000.75023,18139.6348388,15.4299803,1232.5280289,1220.1184708,2327.9480009,26.2617877,28.9904096,1.3617734,90.7841457),(41226,'tibia',253,8,116,342.5284817,94.2280152,125.7902658,1.8,94.3740741,126.016931,0.5663637,13.7829456,14.5517943,16883.44177,17948.4444663,16.4359016,1233.4179599,1224.9516348,2311.7893499,26.1302637,29.0826094,1.3473197,91.6435217),(41227,'tibia',253,8,117,340.8035733,94.2501222,125.7103309,1.8,94.3812094,125.9121405,0.6052235,13.5293756,14.3618973,16701.2585674,17699.9039022,18.3863227,1232.4210065,1234.4441502,2303.6055647,26.0309165,29.1808457,1.3329604,93.1105683),(41228,'tibia',253,8,118,340.9404806,94.3116333,125.6837852,1.8,94.4373164,125.663475,0.587903,13.4103259,14.3647135,16544.8948667,17575.0923922,17.4789051,1223.4906298,1233.7429404,2299.4230927,25.9623645,27.8337015,2.9865959,88.2492036),(41229,'tibia',253,8,119,341.6740282,94.3578057,125.6495396,1.8,94.410219,125.6048776,0.5856336,13.3350943,14.3498627,16508.9353847,17416.2424909,17.3973406,1213.6870446,1238.0066515,2333.8352371,25.9050262,27.8337015,2.9865959,87.8932384),(41230,'tibia',253,8,120,340.0133493,94.3921187,125.6078487,1.8,94.4495312,125.5992997,0.5812151,13.3808055,14.2400717,16426.5546772,17145.6286228,17.0825418,1204.0408932,1227.6207672,2312.1375689,25.8728494,27.7140433,3.0172377,87.8932384),(41231,'tibia',253,8,121,337.4121113,94.4096855,125.5163896,1.8,94.4680822,125.5129076,0.6364268,13.4557403,14.0118398,16298.3292107,16835.8576383,19.8636156,1201.5451115,1211.2547386,2304.1716099,25.8702181,27.5838278,3.063626,87.641533),(41232,'tibia',253,8,122,334.6720079,94.4210559,125.4847795,1.8,94.4916558,125.497483,0.8230655,13.4048948,13.3768603,16188.0096481,16555.0244905,29.9883836,1237.5867116,1207.6192955,2276.8691868,25.7735022,27.4092448,1.3334221,86.6778972),(41233,'tibia',253,8,123,333.8488299,94.4720893,125.4661194,1.8,94.528365,125.490213,1.128669,13.6210623,13.3192318,16053.9460568,16357.9866948,45.4553596,1228.1479095,1178.6118923,2269.7263332,25.6419782,27.4092448,1.3334221,86.6778972),(41234,'tibia',253,8,124,333.0597249,94.5296475,125.4359907,1.8,94.5744535,125.4973875,1.395089,13.3722335,14.0037946,15841.7185101,16266.6646394,53.813756,1161.5897768,1184.6725924,2265.4643641,25.6089285,27.3113965,1.3487144,86.4261918),(41235,'tibia',253,8,125,331.3764985,94.5834813,125.3658897,1.8,94.64685,125.4552983,1.5107471,13.1607495,14.0802406,15557.0718483,16150.1486448,55.0305037,1147.0080035,1182.0809961,2245.5780911,25.5497241,27.2199802,1.3641131,86.321932),(41236,'tibia',253,8,126,331.2005389,94.643823,125.3457276,1.8,94.6733234,125.4339929,1.555369,13.1845072,13.6534757,15348.3539364,16068.7806085,55.1869532,1176.9003696,1164.1204127,2244.7925441,25.4263799,27.2098039,1.2990042,85.462556),(41237,'tibia',253,8,127,330.7103695,94.7039992,125.3413038,1.8,94.7155377,125.4406578,1.5655424,13.1400643,13.6299155,15141.5550403,15982.579415,55.1168734,1172.6103092,1152.3197039,2232.3281925,25.4496873,27.2098039,1.2990042,85.462556),(41238,'tibia',253,8,128,330.243307,94.7738361,125.3274078,1.8,94.806717,125.4284933,1.556903,13.0567153,13.628492,14923.9074307,15902.0697674,55.0299276,1166.8253403,1143.0062695,2232.0715848,25.3083424,27.097612,1.3142797,85.462556),(41239,'tibia',253,8,129,327.9917505,94.8458232,125.2939645,1.8,94.8798355,125.3878681,1.5479149,12.9689649,13.5983877,14668.9415758,15754.7645949,54.6366762,1158.5759217,1131.0803661,2227.293742,25.1793559,27.097612,1.3142797,85.462556),(41240,'tibia',253,8,130,327.506057,94.9172438,125.3063047,1.8,94.959767,125.4052114,1.5388558,12.8814882,13.6065398,14485.9852213,15675.7831961,54.5286751,1152.077124,1124.5583566,2209.225671,25.1943115,27.097612,1.3142797,84.8548854),(41241,'tibia',253,8,131,327.2582028,94.9895216,125.328275,1.8,95.0007732,125.4424733,1.5260106,12.7852613,13.5970235,14338.8549938,15578.1505229,54.4337066,1145.7029961,1121.5144264,2197.3065965,25.0615309,26.9849538,1.4108832,84.8548854),(41242,'tibia',253,8,132,326.4044767,95.066982,125.3671171,1.8,95.0964971,125.4856204,1.5106889,12.6780684,13.3042888,14198.5048248,15463.3641658,54.2044382,1162.2841654,1119.9265051,2209.0655129,25.1260423,26.9164465,1.2793395,84.4989202),(41243,'tibia',253,8,133,324.019146,95.1616698,125.3779395,1.8,95.2156087,125.4492713,1.5130525,12.5892241,13.2932944,14024.8939936,15325.7355069,53.8233252,1152.8922091,1114.039586,2194.9326321,24.921904,26.8924278,1.3451951,83.8912496),(41244,'tibia',253,8,134,322.5376718,95.2130032,125.4187656,1.8,95.2690528,125.473341,1.5161542,12.5701487,13.311087,13847.2230877,15232.6558721,53.5959348,1144.358527,1101.5958031,2178.1022743,24.7937225,26.7995823,1.3608228,83.8912496),(41245,'tibia',253,8,135,320.8793428,95.2639406,125.4774407,1.8,95.329483,125.530149,1.5116871,12.515501,13.3488716,13660.2893033,15152.3687942,53.2932547,1135.1048396,1091.4696346,2149.5789082,24.6019967,26.7995823,1.3608228,83.8912496),(41246,'tibia',253,8,136,318.8447006,95.2703477,125.5182649,1.8,95.4301469,125.6044621,1.548251,12.5598825,13.3635852,13282.4482283,15085.0630774,53.113777,1128.818566,1057.529654,2119.983115,24.492216,26.7133266,1.3765553,83.283579),(41247,'tibia',253,8,137,307.4954412,95.4001234,125.5877272,1.8,95.4619499,125.5689654,-1.4825816,12.5819572,13.1473364,12496.7134355,14863.416525,50.8514606,1130.5268244,993.2249189,2074.7471156,24.492216,26.5747352,1.3258177,82.9276138),(41248,'tibia',253,8,138,316.6169224,95.4339872,125.5550548,1.8,95.5247722,125.5764559,1.4952102,12.3238561,13.0728027,13122.0412968,14950.6751876,52.468575,1143.6472755,1064.7674913,2128.4312685,24.492216,26.6822063,1.3101939,82.6759084),(41249,'tibia',253,8,139,313.3068103,95.5018215,125.6111031,1.8,95.5694773,125.6196506,1.4765546,12.2680117,13.1067716,12907.7971296,14908.0941976,51.7554002,1137.4344996,1052.1507011,2108.6814217,24.062528,26.6822063,1.3101939,82.9276138),(41250,'tibia',253,8,140,310.5243535,95.5787014,125.6932442,1.8,95.6118156,125.7154848,1.4571509,12.1705316,13.197884,12723.0034967,14863.5836083,51.0885135,1126.2095946,1045.39423,2089.2562097,24.062528,26.5747352,1.3258177,82.6759084),(41251,'tibia',253,8,141,306.9546939,95.6406536,125.7419078,1.8,95.6675301,125.7385383,1.4328121,12.0734215,13.1911146,12529.86113,14792.4219748,50.1912302,1121.3928786,1037.8053213,2062.7835728,24.062528,26.6337246,1.3923858,82.6759084),(41252,'tibia',253,8,142,304.4031946,95.7436814,125.8425464,1.8,95.7849577,125.8340821,1.4155222,12.0201226,13.225745,12396.0827027,14755.8385312,49.5204678,1115.6905386,1031.2775619,2043.4399941,23.63284,26.4947168,1.4243121,82.3199432),(41253,'tibia',253,8,143,301.9239815,95.8474682,125.9476309,1.8,95.8717679,125.9323578,1.4028397,11.9153306,13.1931065,12264.9243937,14723.461977,48.914444,1115.9965944,1029.3398342,2044.6778887,23.63284,26.4738027,1.3415644,82.2156834),(41254,'tibia',253,8,144,299.2002711,95.9537263,126.0625139,1.8,95.9735176,126.0108395,1.3938495,11.8923108,13.2523756,12135.9077895,14692.7240972,48.3216038,1108.6860613,1020.4835674,2024.4239715,24.0319689,26.3794839,1.3574277,82.3199432),(41255,'tibia',253,8,145,295.7913531,96.0459164,126.0996747,1.8,96.0771571,126.0593421,1.3915641,11.8455005,13.3052231,11991.6110938,14655.4211911,47.7317686,1101.4787972,1012.3346901,2002.7497238,23.63284,26.3794839,1.3574277,82.2156834),(41256,'tibia',253,8,146,294.3182153,96.1577128,126.2064488,1.8,96.1762128,126.1729248,1.3926904,11.8341703,13.353978,11901.1753748,14705.5958926,47.5133729,1101.214625,1005.6619988,1991.869475,23.63284,26.5608362,1.4083072,82.5716486),(41257,'tibia',253,8,147,292.5246015,96.284946,126.3077553,1.8,96.3064973,126.2506922,1.3898474,11.7968765,13.3982509,11817.0190562,14755.4185056,47.1751161,1101.2943875,1001.7074508,1980.8124174,23.63284,26.5608362,1.4083072,82.823354),(41258,'tibia',253,8,148,291.360638,96.4068316,126.4047229,1.8,96.3980242,126.3276699,1.39069,11.7731363,13.4390706,11764.5051355,14821.8416946,47.0018585,1102.891867,999.2668759,1973.0760447,23.203152,26.6337246,1.3923858,82.4673888),(41259,'tibia',253,8,149,289.2867196,96.5260798,126.4850151,1.8,96.5173791,126.4209973,1.3931205,11.6738814,13.4655668,11679.4272414,14844.051837,46.7083348,1102.3711137,1000.4750656,1961.0982785,23.203152,26.7271462,1.4903253,83.0750594),(41260,'tibia',253,8,150,288.4126839,96.6355075,126.581721,1.8,96.6388008,126.5232193,1.4020603,11.7301397,13.4550979,11641.6923563,14912.2096252,46.7131134,1108.2943957,992.4598183,1961.5719479,23.536286,26.644121,2.2304251,83.3267648),(41261,'tibia',253,8,151,287.5940378,96.745897,126.6638395,1.8,96.739418,126.5803025,1.4138711,11.736283,13.4769349,11605.8355749,14985.9887746,46.7616373,1111.9730752,988.8851171,1955.6304372,23.203152,26.8477645,2.2655346,82.9707996),(41262,'tibia',253,8,152,286.7163096,96.8731663,126.7536719,1.8,96.8596648,126.5663692,1.419953,11.7674006,13.5167401,11573.83438,15079.0995372,46.7069641,1115.5870035,983.5506385,1962.4341616,23.203152,26.8477645,2.2655346,82.9707996),(41263,'tibia',253,8,153,285.7548815,97.0611306,126.8480942,1.8,97.0601926,126.6759341,1.4271525,11.6658729,13.5114648,11570.6757609,15153.9228036,46.6498642,1121.5603232,991.839692,1960.0266532,22.773464,26.9095862,2.2430435,83.222505),(41264,'tibia',253,8,154,286.0299269,97.1921648,126.9376271,1.8,97.1428173,126.8395867,1.4333742,11.6839649,13.5606378,11603.4088986,15285.766182,46.7770364,1127.2158752,993.1054224,1964.77658,23.203152,27.0839815,2.3000737,83.8301756),(41265,'tibia',253,8,155,286.8350334,97.3164004,127.0025621,1.8,97.2790234,126.8846654,1.4385162,11.6966391,13.5870611,11652.0558985,15434.5666011,46.9741991,1135.9753616,996.1883746,1982.0396258,23.203152,26.9849538,2.2206668,83.9344354),(41266,'tibia',253,8,156,287.8426194,97.4209318,127.0590559,1.8,97.3792967,126.9264921,1.4422084,11.7167722,13.4533653,11686.072889,15608.4765076,47.1848931,1160.1912378,997.3798873,1982.0597616,22.773464,27.179252,2.2554135,83.4742104),(41267,'tibia',253,8,157,288.8130552,97.5742989,127.0579698,1.8,97.4946851,126.9724137,1.4448772,11.6744439,13.4144044,11732.5244237,15743.4951101,47.3763156,1173.6261035,1004.9750132,2017.4758161,22.773464,27.097612,1.3142797,83.4742104),(41268,'tibia',253,8,158,289.1295028,97.710999,127.1168738,1.8,97.6324521,127.0273599,1.4464281,11.7057601,13.4350411,11767.432832,15892.5633636,47.4467353,1182.9188491,1005.2685812,2029.5328139,23.203152,27.2199802,1.3641131,84.081881),(41269,'tibia',253,8,159,288.5331981,97.8411866,127.1581517,1.8,97.7379926,127.0388218,1.4477294,11.689669,13.4911195,11760.61041,16019.35602,47.364207,1187.4000528,1006.0687296,2034.5396508,22.773464,27.3113965,1.3487144,83.7259158),(41270,'tibia',253,8,160,286.6960001,97.9711445,127.2180839,1.8,97.8537553,127.1691999,1.4444676,11.67311,13.5153492,11752.286778,16102.6200231,47.0241533,1191.4320405,1006.7828361,2046.0098126,22.773464,27.2877254,1.4444882,84.3335864),(41271,'tibia',253,8,161,282.8706534,98.154711,127.2139742,1.8,98.0614303,127.187648,1.4396711,11.6909893,13.537286,11684.0666764,16089.4965188,46.3391392,1188.5319211,999.4078657,2038.1978723,23.203152,27.3451769,1.4288993,84.7938114),(41272,'tibia',253,8,162,280.40056,98.2800504,127.3023975,1.8,98.2090537,127.2979412,1.4339413,11.684771,13.5863999,11631.9833893,16147.7553952,45.8635927,1188.5234904,995.4823581,2040.258426,22.773464,27.479883,1.3979357,84.081881),(41273,'tibia',253,8,163,277.5064289,98.4035642,127.4045704,1.8,98.3095282,127.3846872,1.4292046,11.6323989,13.6450341,11546.4389884,16176.1540353,45.33,1185.4975136,992.6103012,2031.4716379,22.773464,27.5570408,1.3825748,84.081881),(41274,'tibia',253,8,164,276.2041035,98.5172796,127.5160508,1.8,98.402108,127.5398934,1.4299368,11.6596798,13.7111952,11514.6630444,16237.4256929,45.126663,1184.2458225,987.5625439,2022.5786918,23.203152,27.6206174,1.4773195,84.7938114),(41275,'tibia',253,8,165,272.1444983,98.5555514,127.480695,1.8,98.5335807,127.6520791,1.475662,11.8892241,13.6891801,11049.0188463,16124.421862,44.9481445,1177.8953745,929.3305256,1983.0769578,22.773464,27.7140433,1.4464413,84.6895516),(41276,'tibia',253,8,166,264.6221521,98.7297304,127.573915,1.8,98.6404077,127.8053605,1.4874098,11.7631815,13.7581306,10751.6016232,16118.5415002,43.7977355,1171.5647954,914.0045676,1953.027007,22.773464,27.7140433,1.6951513,84.6895516),(41277,'tibia',253,8,167,271.7690804,98.9329007,127.7773765,1.8,98.8242009,127.9406599,1.4217245,11.648446,13.8351467,11365.4559741,16325.0486361,44.2957202,1179.9693223,975.7057735,1987.7587647,23.1713529,27.7706128,1.4310875,85.0455168),(41278,'tibia',253,8,168,266.0308366,99.0750223,127.8481466,1.8,99.0042325,127.9392488,1.418333,11.7480934,13.6924572,11327.8113244,16251.654904,43.3157834,1186.9056607,964.2255042,1994.2406665,22.773464,27.7306933,1.3521274,84.6895516),(41279,'tibia',253,8,169,263.722268,99.225318,127.8815685,1.8,99.0779318,127.9601571,1.4170713,11.6690378,13.843993,11282.5720585,16231.1675432,42.9231805,1172.4339593,966.8810977,1963.2636875,22.773464,27.9594518,1.5246752,85.0455168),(41280,'tibia',253,8,170,260.8487821,99.3885847,127.9717156,1.8,99.2255293,128.0658558,1.4148669,11.5869737,13.7960109,11203.3589082,16232.9662212,42.4262903,1176.6420252,966.892578,1974.972605,22.773464,27.9032651,1.4005844,84.941257),(41281,'tibia',253,8,171,259.176242,99.5085385,128.0786989,1.8,99.3798883,128.1411192,1.4121716,11.7056299,13.8518756,11190.2654989,16211.3123753,42.1182359,1170.3333764,955.9729489,1960.4973496,22.773464,27.9792555,1.3854484,84.941257),(41282,'tibia',253,8,172,258.1362056,99.5854716,128.1527638,1.8,99.4410177,128.2244863,1.4108244,11.7764634,13.9363524,11232.3595028,16136.8503309,41.9310664,1157.8962647,953.7973447,1949.7424047,22.773464,28.0616202,1.3703978,84.6895516),(41283,'tibia',253,8,173,255.4463444,99.7139586,128.1258592,1.8,99.5252126,128.2275174,1.4120477,11.7138524,13.8629085,11225.6729076,16025.8912773,41.5104506,1156.0266218,958.3245966,1937.9143534,22.773464,28.0616202,1.3703978,84.6895516),(41284,'tibia',253,8,174,254.8357727,99.8260557,128.194247,1.8,99.6957608,128.291964,1.4113553,11.6971318,13.8793885,11266.1564851,16013.0216301,41.4020313,1153.726742,963.1554669,1933.3552063,23.203152,28.1503035,1.3554386,85.401482),(41285,'tibia',253,8,175,251.7262938,99.9497045,128.2668848,1.8,99.8151951,128.4473926,1.4094847,11.7207078,13.8996207,11206.4120809,15969.0870538,40.8721057,1148.886534,956.1207637,1919.0975961,23.203152,28.2583162,1.418147,85.401482),(41286,'tibia',253,8,176,250.6595138,100.0879566,128.3624445,1.8,99.9648908,128.5466658,1.4124144,11.7384085,13.9525324,11210.1316229,15948.2529226,40.7373608,1143.0364369,954.9958696,1908.1233295,22.773464,28.3268372,1.4031539,85.2972222),(41287,'tibia',253,8,177,250.8588602,100.250226,128.3796236,1.8,100.2521044,128.5075767,1.4179396,11.7448261,14.0040784,11266.2927856,15908.881107,40.8405006,1136.0177089,959.2558228,1910.2314349,23.203152,28.2583162,1.418147,85.6531874),(41288,'tibia',253,8,178,248.6239205,100.3830671,128.4192908,1.8,100.3169814,128.5005319,1.42135,11.7537623,14.0044407,11279.0057079,15842.7158453,40.5187199,1131.263728,959.6081164,1903.6497739,23.203152,28.3268372,1.4031539,85.9048928),(41289,'tibia',253,8,179,248.6675048,100.5345361,128.5452861,1.8,100.5912843,128.6791153,1.4096567,11.8297561,14.0616943,11333.6127196,15799.9951193,40.3777166,1123.6195886,958.0597136,1896.4473491,23.63284,28.3268372,1.4031539,85.7574472),(41290,'tibia',253,8,180,247.2885852,100.6387048,128.5810656,1.8,100.6800735,128.682162,1.4209132,11.8854358,13.9693851,11325.6844871,15745.3226844,40.2957892,1127.1306931,952.9044364,1912.0727052,23.63284,28.2452458,1.3405767,85.401482),(41291,'tibia',253,8,181,242.9494586,100.7374787,128.5844537,1.8,100.7655108,128.643783,1.4321389,11.9894243,14.1172605,11331.288572,15568.8476462,39.7180669,1102.8235752,945.1069806,1877.2401723,24.062528,28.3463842,1.3258177,86.1134124),(41292,'tibia',253,8,182,239.5965456,100.9108032,128.6525956,1.8,100.8151159,128.7535494,1.4188134,11.9843232,14.0156159,11385.9624334,15433.634257,39.0174386,1101.1741736,950.0713749,1880.6153308,24.062528,28.3463842,1.3258177,86.3651178),(41293,'tibia',253,8,183,238.9265001,101.0764191,128.815286,1.8,100.9777458,128.9000053,1.4176591,11.9746295,14.1355639,11453.5160626,15438.6606846,38.8945157,1092.1856955,956.4818758,1869.3825979,24.290028,28.4828375,1.3734008,86.721083),(41294,'tibia',253,8,184,237.4765252,101.2091248,128.8838356,1.8,101.085839,128.9314499,1.4226133,12.0911632,14.163189,11584.4519611,15469.3036766,38.7166701,1092.2189714,958.0924336,1885.259309,24.062528,28.4828375,1.3734008,86.6168232),(41295,'tibia',253,8,185,235.4845161,101.3015683,128.8653612,1.8,101.1990896,128.9486943,1.4352084,12.1352963,14.1689814,11642.3649269,15410.7417607,38.5303019,1087.6393547,959.3803623,1879.8670783,24.492216,28.6637647,1.3439975,86.721083),(41296,'tibia',253,8,186,237.3067758,101.4439558,128.9953349,1.8,101.3230061,129.0706874,1.4396825,12.2721835,14.319614,11804.9597757,15560.8339376,38.8750994,1086.6797041,961.9282322,1888.2015915,24.492216,28.7634315,1.3294408,87.3287536),(41297,'tibia',253,8,187,238.341609,101.537489,129.0669837,1.8,101.4476743,129.1760048,1.4498633,12.3228444,14.3550456,12012.314355,15610.2768286,39.1454789,1087.4418125,974.8004549,1898.7774302,24.921904,28.904304,1.3763162,87.6847188),(41298,'tibia',253,8,188,236.7602098,101.6896744,129.1983549,1.8,101.5837809,129.3890726,1.4548162,12.4569735,14.5066676,12134.9206271,15678.591201,38.9316187,1080.7851721,974.1467791,1906.1637641,24.921904,28.904304,1.3763162,87.9364242),(41299,'tibia',253,8,189,234.6419238,101.8570613,129.2230222,1.8,101.7765607,129.4818514,1.4522987,12.5120282,14.5495458,12158.6285302,15623.8310571,38.5604244,1073.8363429,971.7552014,1896.2062263,25.3250772,29.1079925,1.4226363,88.90006),(41300,'tibia',253,8,190,236.0840659,101.9654585,129.330252,1.8,101.9372154,129.5457464,1.451747,12.6191869,14.6176275,12400.600829,15715.839767,38.7923138,1075.1293124,982.6782746,1907.1732626,25.351592,29.2472054,1.3935709,88.90006),(41301,'tibia',253,8,191,235.9089454,102.0985821,129.4515291,1.8,102.0530907,129.6768966,1.4623498,12.8075601,14.7132523,12596.0812918,15782.7924919,38.8575604,1072.6923062,983.4879677,1917.9236197,25.7523517,29.3260093,1.3791478,89.5077306),(41302,'tibia',253,8,192,236.977348,102.2244383,129.5939048,1.8,102.1573458,129.7587473,1.4688937,12.8473764,14.8295927,12842.0963216,16042.4228348,39.0875077,1081.7844557,999.5890163,1935.1020065,25.78128,29.5330411,1.4247841,90.3671066),(41303,'tibia',253,8,193,238.0574998,102.3905761,129.6626045,1.8,102.3595406,129.8270525,1.4356307,13.0060135,14.8744026,13086.8268464,16225.2749023,38.9557791,1090.818593,1006.2135403,1956.5904349,26.1358034,29.6702598,1.3961241,90.9747772),(41304,'tibia',253,8,194,240.5752059,102.5772263,129.843029,1.8,102.5524929,129.9754684,1.4339917,13.1699647,14.9589779,13399.3015143,16523.4246197,39.3501232,1104.5824594,1017.4136257,1978.1973953,26.4664756,29.8996165,1.4410938,91.938413),(41305,'tibia',253,8,195,243.2250635,102.665974,129.9986143,1.8,102.7225244,130.1499825,1.4574273,13.2383712,14.9380559,13792.9861966,16788.6653327,40.0187291,1123.8855597,1041.8945038,2029.3674113,26.640656,30.0167132,1.3397057,91.8341532),(41306,'tibia',253,8,196,244.4584038,102.7652483,130.1876958,1.8,102.8604344,130.3802394,1.4662295,13.4701179,15.0910438,14162.4494337,17084.6267949,40.2991947,1132.1037155,1051.3975829,2050.4462547,26.9070703,30.2525986,1.3706153,93.0494944),(41307,'tibia',253,8,197,246.8709816,102.8369315,130.3232122,1.8,102.9355634,130.4658088,1.4623196,13.6479893,15.2325588,14444.0987423,17386.9435761,40.6628959,1141.4328861,1058.3316292,2062.223914,27.2894311,30.5350696,1.3292306,93.657165),(41308,'tibia',253,8,198,251.1382696,102.991667,130.477904,1.8,103.0646557,130.6670605,1.4898864,13.8617432,15.3647953,14923.9325093,17698.8748932,41.5829664,1151.9108828,1076.6274006,2096.6332057,27.6739737,30.8538724,1.3460852,95.1242116),(41309,'tibia',253,8,199,254.8065673,103.1596105,130.6269622,1.8,103.2063687,130.8341659,1.4939165,14.0406671,15.4935338,15388.842042,18095.2584838,42.2172494,1167.9232564,1096.019297,2125.4736499,27.92972,31.1812594,1.3625904,95.9835876),(41310,'tibia',253,8,200,264.4819998,103.2946997,130.8184413,1.8,103.3954828,131.0246005,1.5089127,14.1467341,15.6691385,16100.8283543,18849.3148395,43.9117395,1202.9579565,1138.1304124,2195.7540091,28.359408,31.5169631,1.3787483,97.4506342),(41311,'tibia',253,8,201,270.1987591,103.4420133,130.9280155,1.8,103.50319,131.1402926,1.5505172,14.5397537,15.7835276,16674.7733027,19489.7766653,45.0146096,1234.817536,1146.8401493,2249.4038382,28.8254196,31.7882009,1.3389317,99.273646),(41312,'tibia',253,8,202,279.4394677,103.5492217,131.1210922,1.8,103.6064516,131.3362356,-1.564083,14.6039214,15.987463,17369.6016219,20509.5935094,46.5711455,1282.8547936,1189.3792876,2319.3560923,29.2121439,32.1118121,1.3550301,99.5253514),(41313,'tibia',253,8,203,290.4014479,103.7495162,131.2959161,1.8,103.7211353,131.4929705,-1.5116224,14.8178577,16.3284721,18303.7681978,21459.9845928,48.230963,1314.2677672,1235.2506405,2402.340516,29.648472,32.5316668,1.357858,101.2441034),(41314,'tibia',253,8,204,303.8884636,103.9463743,131.5061179,1.8,103.8287888,131.6720166,-1.4278877,15.0316309,16.6780715,19399.1734089,22571.9468036,49.6207207,1353.3906962,1290.5567948,2510.9739048,30.07816,32.8648125,1.3734008,102.9628554),(41315,'tibia',253,8,205,320.5600976,104.0945565,131.7559386,1.8,103.8961373,131.7945076,-1.3732783,15.1608121,17.0984093,20644.213044,23901.5761208,51.3692929,1397.883026,1361.682534,2597.3002754,30.07816,33.3638275,1.441649,105.5409834),(41316,'tibia',253,8,206,340.8748523,104.2146659,132.0103676,1.8,103.9186906,132.0119725,-1.2906618,15.3988109,17.4401722,21879.3090189,25652.9208062,52.4695061,1470.9098352,1420.844058,2724.9310017,30.07816,34.3427983,1.017502,106.4435452),(41317,'tibia',253,8,207,368.3348568,104.2700564,132.3763505,1.8,103.9559276,132.2203336,-1.2118241,15.7648578,17.9844273,23482.6369559,28240.1742591,53.8124787,1570.2570807,1489.5559006,2870.7383127,30.937536,35.2998564,1.0199388,109.125933),(41318,'tibia',253,8,208,397.0451542,104.214394,132.4258576,1.8,103.8998184,132.5799637,-1.173764,16.2582552,18.3295256,25304.9123697,31420.6087561,56.2795699,1714.2074157,1556.4346879,3090.6496931,30.937536,36.6244435,1.0283648,110.844685),(41319,'tibia',253,8,209,434.6013278,104.2194699,132.5056793,1.8,103.961023,132.7743006,-1.1850071,16.6524863,18.9708406,27570.6668495,36346.2469716,62.1773624,1915.9007133,1655.648672,3367.8645361,31.6520116,37.734338,1.0460006,113.422813),(41320,'tibia',253,8,210,475.0350716,104.3471407,132.9582542,1.8,104.1564217,132.9563842,-1.0981298,17.3215199,19.6060084,30592.8255875,40268.1852791,62.7629375,2053.8696382,1766.1744309,3585.1866333,32.2266,38.7315529,0.9827937,118.0756582),(41321,'tibia',253,8,211,534.0962035,104.3358154,132.7350282,1.8,104.3693513,133.1399723,-1.1748044,17.8752747,19.9597909,34546.3048343,44558.5782173,75.7719943,2232.4170821,1932.630714,3957.689556,32.656288,39.0898016,0.9888912,119.5427048),(41322,'tibia',253,8,212,504.6571702,105.1625234,133.2022945,1.8,104.6408235,133.4663408,-1.3029527,16.8489999,19.665704,32647.0993039,46627.4127301,78.2184155,2371.0014537,1937.6283214,3993.12181,32.4319069,38.9336216,0.7385575,119.89867),(41323,'tibia',253,8,213,555.9667887,105.2893287,132.9280468,1.8,104.9592553,133.9485959,-1.1989128,16.6227624,18.1805963,32735.209161,46516.0277579,80.4263073,2558.5534755,1969.3001933,4056.4654518,31.6060493,37.1649072,1.3847381,115.60179),(41324,'tibia',253,8,214,450.7730573,105.8864574,133.8052065,1.8,105.5267757,134.3920522,-1.3898881,15.5409703,18.7753877,24919.7152047,41314.6003235,72.6967496,2200.4659003,1603.4851598,3511.9353323,29.0850443,38.1068095,1.4464413,112.3728055),(41325,'tibia',253,8,215,559.2501012,106.538193,133.8568131,1.8,106.4510713,134.5693902,-1.4091072,14.6473245,19.6980228,26564.9899653,51751.5288837,90.7927299,2627.2448462,1813.6411211,3946.1950559,28.4728726,39.3369918,1.6802473,116.2705345),(41326,'tibia',253,8,216,417.9359041,107.344388,135.1545695,1.8,106.5480462,134.6814475,-1.4265986,15.0248424,19.8017872,18805.6409759,43313.56669,68.2176386,2187.3564384,1251.6364891,3103.8714928,26.5394238,38.7100956,1.6152115,113.0668478),(41327,'tibia',253,8,217,165.6734508,108.1742256,140.660159,1.8,108.5038076,139.3093398,-1.0094565,17.4835926,23.3117162,4074.8799643,15978.8391046,19.787885,685.4424184,233.0688012,841.7630657,21.4122208,38.9715409,0.9736197,114.3685606),(41328,'tibia',253,8,218,81.3504955,104.8828312,144.9449264,1.8,104.3250295,145.1651505,-0.2364111,4.711791,11.2535878,350.7250043,2408.2042701,0.7437702,213.9943553,74.4356029,244.712838,9.7982844,22.724768,0.2679104,57.3190771),(41329,'tibia',253,8,219,27.8630053,104.7891117,144.860065,1.8,104.2256219,144.9683877,-0.2477882,3.3925153,8.8969672,56.9030659,552.2420001,0.2793388,62.0708146,16.7731198,68.4132001,7.1036893,17.257203,0.3296244,43.7596925),(41330,'tibia',253,8,220,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41331,'tibia',253,8,221,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41332,'tibia',253,8,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41333,'tibia',253,8,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41334,'tibia',253,8,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41335,'tibia',253,8,225,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41336,'tibia',253,8,226,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41337,'tibia',253,8,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41338,'tibia',253,8,228,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41339,'tibia',253,8,229,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41340,'tibia',253,8,230,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41341,'tibia',253,8,231,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41342,'tibia',253,8,232,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41343,'humerus',253,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41344,'humerus',253,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41345,'humerus',253,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41346,'humerus',253,2,4,3.6604649,108.6277272,131.7385972,1.8,108.6983325,131.9333132,1.1702944,2.3052065,4.6536419,3.9247755,9.3582325,0.5173415,2.0109481,1.70257,2.8392655,5.029227,8.2986537,1.9416876,21.4591023),(41347,'humerus',253,2,5,34.6675255,107.8367439,134.2359342,1.8,107.6475003,134.3589688,-1.4565985,4.8475683,8.8535607,135.2998732,521.4706288,5.7028972,58.8995375,27.9108749,69.5240563,9.453136,17.7164901,1.1722739,47.0065651),(41348,'humerus',253,2,6,80.8909862,105.5578844,134.7915512,1.8,104.3766157,133.5752737,1.0458202,10.0360554,18.3499721,1469.3378513,3062.6198909,10.0952796,166.9005201,146.4059126,228.470914,11.9389002,22.1487388,1.2551807,56.2079957),(41349,'humerus',253,2,7,164.1902421,100.8950231,131.5716318,1.8,100.9093687,131.4063543,0.7409245,12.152714,18.0286737,3529.3023445,13278.4135052,12.4670997,736.5163822,290.4126877,927.5858938,22.6388811,33.7735861,2.2117529,107.3639951),(41350,'humerus',253,2,8,233.650619,99.1925637,130.7040026,1.8,98.8848337,131.2908131,0.7101258,22.3634402,18.3631281,8339.7655275,20028.910321,16.5507037,1090.7134235,372.9196156,1260.0197974,24.7946082,36.7150733,2.1815223,109.8989373),(41351,'humerus',253,2,9,302.4507415,96.938074,131.2230178,1.8,96.9422534,131.7227194,0.5754094,22.1550546,18.5178693,20501.6757443,27627.0641191,14.9274595,1491.9137667,925.3723845,2168.6158825,26.602874,38.988119,2.1282274,117.6943953),(41352,'humerus',253,2,10,381.1497009,95.3931878,131.536389,1.8,95.6785028,132.0980248,0.5923119,22.1209072,19.1563637,31237.1711122,35075.5918362,19.7992774,1831.0151326,1412.1107606,2995.2704492,36.3670248,40.677635,2.114839,145.3344634),(41353,'humerus',253,2,11,437.0509439,94.4317761,131.8103019,1.8,94.9376276,132.1463896,0.9966953,20.7898049,21.2562913,40609.2775731,42396.6781708,51.3581462,1994.5472869,1953.3265313,3735.8133372,37.8023496,41.9446803,2.0848599,140.8290638),(41354,'humerus',253,2,12,476.1945592,93.7983326,131.7952959,1.8,94.3722088,132.0307507,1.4515936,21.1234001,20.5621595,47620.3423492,49835.5424871,78.2433602,2423.6531387,2254.3881255,4331.8325625,38.5267821,42.8677044,2.0613433,141.9401452),(41355,'humerus',253,2,13,506.0087867,93.4893858,131.7879653,1.8,93.9676279,131.9883845,-1.4849367,21.2436004,21.1154113,52838.1567262,56444.920533,83.7146177,2673.1622563,2487.2505423,4764.6031747,38.9283874,43.7290672,1.9640757,142.443556),(41356,'humerus',253,2,14,539.9353233,93.4591869,131.9460943,1.8,93.6173077,131.8568213,1.3825314,21.541033,21.9808688,59749.4726052,62020.8230576,86.8371778,2821.5819675,2773.7514955,5272.6011719,39.3715266,44.4161068,1.9998257,144.561459),(41357,'humerus',253,2,15,550.7645366,93.2005008,131.7984085,1.8,93.3832288,131.6840217,1.3222719,21.4767823,22.2871736,61657.4271091,65447.5204916,86.2402537,2936.5554271,2870.8875588,5452.2660206,39.8235632,44.9860969,2.0045383,145.420835),(41358,'humerus',253,2,16,556.057482,92.9222653,131.7374512,1.8,93.1766683,131.4957648,1.4198374,21.7512632,22.5775954,61664.2792517,66698.0727696,90.58028,2954.1707884,2834.9746284,5530.1551284,39.8460591,45.1683644,2.0131705,146.0285056),(41359,'humerus',253,2,17,550.8637901,92.4738889,131.6728101,1.8,92.9225478,131.1984915,1.4887159,21.9412309,22.4581687,58542.7040049,66350.5718604,91.1934741,2954.4070416,2668.1595199,5497.8634779,39.8326914,45.2500432,2.0981872,144.8563503),(41360,'humerus',253,2,18,557.8324089,92.2942461,131.8883758,1.8,92.9146559,131.1171556,1.409706,21.7720596,22.990244,57257.7677028,67207.9417979,90.5802299,2923.3244291,2629.8737398,5413.2461528,39.4840059,45.2500432,2.0981872,144.9606101),(41361,'humerus',253,2,19,552.2887558,92.0031161,131.8517021,1.8,92.9250611,131.0062973,1.3656222,21.6725507,23.0326556,54469.5716678,67512.5316923,88.2272968,2931.1657698,2513.2976982,5292.920845,39.2851322,45.4088944,2.0852476,143.3461178),(41362,'humerus',253,2,20,518.9981917,91.8115523,131.2437983,1.8,92.9373281,130.9682564,1.2735723,21.1699039,22.3174959,49201.970254,63316.5430217,79.0805239,2837.0809693,2324.1470754,4930.3428916,38.4356783,45.1990112,2.0769715,141.2714006),(41363,'humerus',253,2,21,482.8625078,92.0052422,130.7992623,1.8,93.0049078,130.9935661,1.1045288,19.8174163,22.321125,41641.0336437,59546.1675483,64.2126632,2667.7045815,2101.2342409,4352.1237736,37.5827999,45.11724,2.2142974,139.3009432),(41364,'humerus',253,2,22,444.891696,92.4342884,130.355222,1.8,93.3069042,131.0411638,0.9777315,18.8078968,23.3254451,32828.1669287,56851.1608077,50.9864485,2437.3022933,1745.4459309,3832.8623315,36.3797384,45.2071802,2.2009902,138.1898618),(41365,'humerus',253,2,23,423.1283092,92.6012307,130.3722126,1.8,93.6786436,131.0350028,0.917577,17.6565223,23.4596511,29719.4619959,55076.7694074,44.4739339,2347.7232939,1683.2002049,3609.4333777,34.6241848,45.0353203,2.2276554,134.7955437),(41366,'humerus',253,2,24,404.904817,92.9176816,130.6996612,1.8,93.9100053,131.4466742,0.9019038,17.985396,23.0938799,27952.2367644,53187.1438926,41.5333947,2303.0839386,1554.162987,3513.278155,34.5460862,44.7061404,2.1854593,133.2242373),(41367,'humerus',253,2,25,380.6111356,93.5416135,131.1761481,1.8,94.3184359,131.9205405,0.8710761,18.0021079,22.5484956,25441.440499,49846.8430716,37.1260321,2210.6505048,1413.247862,3338.6816102,34.2525538,44.4327311,2.2259023,132.6165667),(41368,'humerus',253,2,26,359.5043665,94.1473993,131.7539997,1.8,94.7445992,132.396979,0.8626828,17.8005861,21.810997,23664.7953516,45951.035462,34.5709769,2106.7828977,1329.4391109,3186.9588878,33.6174891,44.0068485,2.1967211,129.6824735),(41369,'humerus',253,2,27,335.6441222,94.9953618,132.599328,1.8,95.2976287,133.0079598,0.8692322,17.7221463,21.9427692,22196.0667674,40359.8899646,32.6381371,1839.3252713,1252.4480026,2847.5658304,32.9773076,43.2279796,2.2222496,126.3924151),(41370,'humerus',253,2,28,311.6637553,96.0288199,133.6510853,1.8,95.9813835,133.7572235,0.8845946,17.4448448,22.4276283,20981.4042246,33010.3342129,31.0908997,1471.860235,1202.7280535,2407.2496989,32.2664288,42.4783046,2.2486968,122.7895773),(41371,'humerus',253,2,29,294.6789186,96.8173501,134.4746789,1.8,96.8031123,134.6113817,0.9259976,17.0553731,21.4677795,19987.3980763,27939.3556174,31.3712121,1301.455312,1171.912101,2231.3302199,31.6875674,40.4774307,2.2206668,116.9645768),(41372,'humerus',253,2,30,277.1655875,97.5720503,135.1671344,1.8,97.67413,135.4767436,1.0206615,16.6705962,19.1945733,18875.6796857,23716.8879086,33.5683495,1235.6038089,1132.273822,2194.3515822,30.7812652,37.5798944,2.2508944,111.5998012),(41373,'humerus',253,2,31,267.2628901,98.1265698,135.7175055,1.8,98.2952677,136.0499892,1.1067497,16.1210937,17.8853771,18128.0429488,21288.9146631,35.6208278,1190.2972192,1124.492126,2186.2301071,29.648472,35.5188532,2.1755759,106.946956),(41374,'humerus',253,2,32,255.3841291,98.6146047,136.1557182,1.8,98.8015833,136.5584006,1.2357843,15.627512,16.7646523,17283.0180504,19279.5481655,37.9629942,1150.011811,1105.9353544,2148.7681887,29.0147713,34.0322661,2.221873,103.908603),(41375,'humerus',253,2,33,246.8831785,99.0224112,136.4437003,1.8,99.2054348,136.8939664,1.3932251,15.2597678,15.9766432,16459.679877,18062.5776682,39.8633418,1130.5614992,1078.6323933,2067.8321571,28.4506379,32.89289,2.1515527,100.87025),(41376,'humerus',253,2,34,243.3833993,99.4010161,136.6788927,1.8,99.5524647,137.1455043,1.5130682,14.6923178,15.3578245,15927.7240256,17356.1286524,40.428869,1130.1163559,1084.0851847,2015.1076309,28.072979,32.3523963,2.0998268,100.010874),(41377,'humerus',253,2,35,238.5067145,99.7624582,136.8635824,1.8,99.8372449,137.3574906,-1.5090749,14.4666269,14.7083692,15411.3877962,16769.3334684,39.599878,1140.1218747,1065.3062344,1964.3899734,27.7754277,31.8375322,2.1251038,99.9676882),(41378,'humerus',253,2,36,234.218054,99.9922465,137.0501895,1.8,100.1101446,137.5200608,-1.5270921,14.3295348,14.4625613,15009.0703775,16289.8082541,38.9618282,1126.3432499,1047.4220266,1933.9984244,27.5222903,31.7038704,2.1437625,97.6844514),(41379,'humerus',253,2,37,231.1836588,100.2952334,137.2625028,1.8,100.3887577,137.6931166,-1.5080409,14.0699596,14.3755112,14661.6741274,15787.3834946,38.3790658,1098.213711,1042.0551665,1910.4983017,27.2086922,31.2463252,2.1206495,96.8250754),(41380,'humerus',253,2,38,229.6442214,100.5454626,137.4635689,1.8,100.6123548,137.8415267,-1.5007572,13.8707427,14.2037544,14381.0879829,15410.1633817,38.0865914,1084.9359235,1036.792929,1901.2709981,27.0198524,31.1101234,2.1396442,95.6097342),(41381,'humerus',253,2,39,225.5899313,100.7494854,137.6536141,1.8,100.8125736,138.0496697,-1.5460016,13.6141243,13.8409118,13914.3374364,14935.7803782,37.575212,1079.1037892,1022.0515959,1851.5132808,26.640656,30.8059627,2.0968627,94.5418386),(41382,'humerus',253,2,40,221.683067,100.9147008,137.792315,1.8,101.059093,138.1628332,-1.5342609,13.7607156,13.9095014,13477.6436051,14600.6734848,36.8978814,1049.6906479,979.4289783,1826.6848106,26.4482753,30.5924579,2.084716,93.7867224),(41383,'humerus',253,2,41,219.1636825,101.1511333,137.80186,1.8,101.2887609,138.2420607,1.5407823,13.6945549,13.7758648,13153.8989242,14223.5686587,36.494385,1032.4991454,960.5203715,1795.6828,26.210968,30.389606,2.1548774,93.1790518),(41384,'humerus',253,2,42,216.9404361,101.4092761,137.9225832,1.8,101.4963914,138.3662094,1.4747437,13.7086378,14.1468889,12929.5083828,13888.1441478,35.8241784,981.7101276,943.1650749,1770.7723876,26.1096156,30.1547924,2.14299,92.3196758),(41385,'humerus',253,2,43,213.6783283,101.6653678,138.0324474,1.8,101.6879556,138.4566303,1.4509632,13.5963381,14.1349955,12589.0074701,13545.0015874,35.1040953,958.2600598,925.9116256,1747.4121684,25.78128,29.8223284,2.2027706,91.7120052),(41386,'humerus',253,2,44,212.8809988,101.9046895,138.190383,1.8,101.9996344,138.6180148,1.4895124,13.5430898,13.8231411,12392.0955614,13217.0943262,35.246262,956.157089,915.0124371,1721.8192767,25.78128,29.6982491,2.1186599,91.1043346),(41387,'humerus',253,2,45,209.4062847,102.107858,138.229862,1.8,102.1415283,138.6816572,1.5016472,13.3349598,13.755345,12091.4287442,12930.9659495,34.7344306,940.0684555,906.7465462,1690.6545532,25.351592,29.3323044,2.1262901,89.8889934),(41388,'humerus',253,2,46,206.0619318,102.3318621,138.3030773,1.8,102.3637717,138.764123,1.5128858,13.1230602,13.6489705,11753.3818205,12642.1507797,34.2286079,926.23475,895.6281281,1668.2326744,25.351592,29.2219433,2.1995926,89.8889934),(41389,'humerus',253,2,47,206.0250614,102.5400665,138.3599691,1.8,102.5574434,138.8185313,1.5138997,12.9380111,13.5759565,11575.8131888,12478.674448,34.2264719,919.1746015,894.7134999,1649.324792,24.921904,28.9712972,2.1875976,88.6736522),(41390,'humerus',253,2,48,206.5939511,102.6871936,138.4720958,1.8,102.7031769,138.8820081,1.5393443,13.031162,13.3636431,11440.6246526,12377.384797,34.3982748,926.1983956,877.9435511,1649.2112305,25.257628,28.7409563,2.1214719,88.777912),(41391,'humerus',253,2,49,204.2525963,102.9065865,138.4468431,1.8,102.9403164,138.9070265,1.5649718,12.7123142,13.261599,11191.7061606,12034.4143553,34.0409447,907.4632939,880.3830689,1619.0671872,24.921904,28.6057343,2.1421338,88.0659817),(41392,'humerus',253,2,50,201.4196175,103.0685936,138.495616,1.8,103.0798729,138.9765852,-1.50644,12.4828137,13.4296598,10920.7218579,11770.8163259,33.4310903,876.4791117,874.8605972,1587.0209633,24.921904,28.3724259,2.1840037,87.5625708),(41393,'humerus',253,2,51,202.1893082,103.2694522,138.5767494,1.8,103.2695438,139.0896005,1.5645437,12.7769699,13.5450689,10718.903213,11599.9007527,33.6969007,856.3928957,838.9237254,1581.4219311,24.9184813,28.2974914,0.7316864,87.3108654),(41394,'humerus',253,2,52,200.8437342,103.4987726,138.6294383,1.8,103.3993958,139.0960054,-1.5520692,12.4614603,13.508886,10548.6100145,11449.6427348,33.4622177,847.5637974,846.4987063,1566.1715154,24.7874515,28.0583303,0.6986598,87.05916),(41395,'humerus',253,2,53,200.8563228,103.6556805,138.6593807,1.8,103.6146758,139.1184138,-1.5219662,12.2468176,13.5229565,10434.2143887,11325.3437882,33.3962974,837.4902155,851.993943,1545.3358192,24.492216,27.85028,2.235899,86.0955242),(41396,'humerus',253,2,54,200.7937717,103.8449932,138.7038407,1.8,103.7451719,139.1948468,-1.4058696,12.4218384,13.6241746,10282.6784602,11245.9655672,32.5635594,825.4419748,827.7903894,1525.281242,24.6775562,28.0122304,0.8505233,86.4514894),(41397,'humerus',253,2,55,200.2433453,104.04764,138.6971531,1.8,103.9520474,139.1811691,-1.2978698,12.713842,13.7932418,10175.4738587,11136.8304131,30.9490226,807.4121072,800.346102,1508.0866124,24.5290599,27.7839065,0.6868176,85.5921134),(41398,'humerus',253,2,56,202.5960576,104.1983788,138.7919192,1.8,104.0916612,139.228841,-1.179011,13.0802466,13.7288805,10185.0775593,11230.8649617,28.8428893,818.0466668,778.660972,1501.6676108,24.4934697,28.0122304,0.720273,85.8438188),(41399,'humerus',253,2,57,204.2841516,104.372665,138.771229,1.8,104.2958914,139.1745737,-1.0158674,13.3869428,13.7027574,10140.6742465,11292.9280095,24.5956228,824.1354414,757.5048625,1458.8635516,24.378458,28.3366124,0.710271,85.8438188),(41400,'humerus',253,2,58,204.345136,104.6068372,138.7718308,1.8,104.4774093,139.1212002,-0.9017696,13.5597798,14.3366011,10039.464452,11414.8400341,20.9564004,796.2026667,740.3855072,1408.8848431,24.3074527,28.7216779,0.6794138,86.4514894),(41401,'humerus',253,2,59,206.2369963,104.7564763,138.7548016,1.8,104.5894856,139.0998523,-0.7872059,13.2858209,15.2235495,9997.5117268,11570.50793,17.2485541,760.0400913,752.4948435,1387.3288885,24.3863814,29.2251023,0.7229794,87.05916),(41402,'humerus',253,2,60,207.6898246,104.9514606,138.7797104,1.8,104.7582809,139.0934708,-0.7564747,13.412514,15.2236508,9945.2173594,11659.6675706,16.3068577,765.891687,741.487941,1378.0670248,24.3989362,29.0572042,0.670122,87.519385),(41403,'humerus',253,2,61,206.5017471,105.1641203,138.7683498,1.8,104.9469139,139.0889821,-0.6808481,13.2106475,15.624626,9762.8739672,11609.4710524,13.6363475,743.0239332,739.0155516,1347.4471822,24.413674,29.3260093,0.6816058,87.519385),(41404,'humerus',253,2,62,207.2167196,105.3310732,138.8124494,1.8,105.1189205,139.0641005,-0.6134248,13.1196614,16.0132832,9639.3788474,11762.1658427,11.4451789,734.5255608,734.7277151,1328.2466973,24.2946361,29.3951819,0.6610432,88.1270556),(41405,'humerus',253,2,63,208.7431209,105.4598506,138.817527,1.8,105.2757846,139.0506988,-0.5663468,13.0260988,16.4683162,9552.9834438,11924.2939709,10.0158054,724.0748729,733.3725614,1296.5951854,24.2629103,29.6764819,0.6000502,88.4830208),(41406,'humerus',253,2,64,209.977748,105.6315121,138.8337671,1.8,105.4613445,139.0031231,-0.5167909,13.0044785,16.6074192,9483.5433008,12105.9562481,8.5435582,728.9486781,729.2521025,1299.0247253,24.2366785,29.8223284,0.6319742,88.838986),(41407,'humerus',253,2,65,212.6393549,105.7259938,138.8541041,1.8,105.5253223,138.9830451,-0.4810558,12.9836358,16.5400019,9410.5666005,12208.9279215,7.5878787,738.145497,724.8021059,1306.9108194,24.2183238,29.6764819,0.6000502,88.838986),(41408,'humerus',253,2,66,212.4181884,105.9028292,138.9380929,1.8,105.8652726,139.0830423,-0.4491264,12.8839654,16.8045098,9289.410398,12353.5352336,6.6738673,735.1321377,721.0055375,1287.7165514,23.9728903,29.8934408,0.3217506,88.5872806),(41409,'humerus',253,2,67,212.1678725,106.0180947,138.9927446,1.8,105.991733,139.2440958,-0.4217595,12.8536589,16.9398307,9205.307355,12472.0180252,5.9258791,736.2539952,716.162409,1279.4473299,23.8602556,30.0443798,0.2900869,88.6915404),(41410,'humerus',253,2,68,214.4594886,106.123055,139.026554,1.8,106.076606,139.2144468,-0.3989848,12.9987173,17.0259148,9174.5858555,12733.1228057,5.394339,747.8671744,705.8070133,1286.0793408,23.8419009,30.1762146,0.348771,89.1949512),(41411,'humerus',253,2,69,212.7986418,106.2265982,139.1125556,1.8,106.2426361,139.2394151,-0.3717579,13.0795874,16.7835742,9133.1490397,12703.779954,4.6799156,756.9174347,698.2750128,1299.8896901,23.8496461,30.0443798,0.2900869,89.1949512),(41412,'humerus',253,2,70,215.6567417,106.2641653,139.2315442,1.8,106.3009753,139.2716992,-0.3470469,13.1229968,16.7657732,9226.5341125,12717.6615388,4.1579753,758.5490623,703.0813357,1305.1858908,23.7894372,30.0443798,0.2900869,88.9432458),(41413,'humerus',253,2,71,218.8804126,106.3386107,139.3136135,1.8,106.3176157,139.2882108,-0.3011941,13.1786597,16.6715629,9301.571264,12809.3032195,3.2105247,768.3324766,705.8055575,1317.7612695,23.6472231,30.1180332,0.2449787,89.299211),(41414,'humerus',253,2,72,220.1253902,106.4795168,139.4250046,1.8,106.671415,139.4689853,-0.2753971,13.1639159,16.8375132,9353.7763162,13053.3115505,2.7128783,775.2517483,710.5618427,1329.2296306,23.4576009,30.5169246,0.1697783,89.299211),(41415,'humerus',253,2,73,220.1580645,106.4729165,139.4383775,1.8,106.7626162,139.5321839,-0.218063,13.2271312,16.7725148,9321.5497728,12978.6225933,1.7173261,773.8030171,704.7295159,1322.062563,23.425404,30.5169246,0.1697783,89.299211),(41416,'humerus',253,2,74,222.6600488,106.4642513,139.5606423,1.8,106.5989152,139.685617,-0.164909,13.1008248,16.6118294,9330.5834849,12914.7229047,1.0000904,777.4413415,712.2134381,1325.6617516,23.3234503,30.5169246,0.1697783,89.299211),(41417,'humerus',253,2,75,220.5475816,106.4177324,139.7189325,1.8,106.5361668,140.0039375,-0.110043,12.9946184,15.7133078,9256.4735606,12606.7882891,0.4433252,802.3000928,712.3313113,1349.3104217,23.2485507,29.7479429,0.1888972,87.3287536),(41418,'humerus',253,2,76,220.3899172,106.3743422,139.8647637,1.8,106.4883246,140.1469495,-0.0208768,12.7294641,14.468036,9232.858201,12212.8671553,0.0160069,844.127507,725.3139746,1404.6203679,23.1122014,28.8243473,0.1798535,86.3651178),(41419,'humerus',253,2,77,219.5261202,106.2849539,139.9684028,1.8,106.4464191,140.2452157,0.0653007,12.5820034,13.7729294,9153.4971052,11986.9537726,0.1557951,870.327108,727.5071253,1442.1264454,23.0298377,28.1503035,0.2153577,85.1497766),(41420,'humerus',253,2,78,221.8822455,106.1900819,140.0517969,1.8,106.3741048,140.3143616,0.1454927,12.4260893,14.0312198,9122.8996787,11973.4734062,0.7772974,853.345155,734.1730321,1459.8027348,22.9849231,27.7140433,0.124355,84.6463658),(41421,'humerus',253,2,79,224.0107702,106.0850092,140.1690715,1.8,106.2530977,140.4471612,0.2210455,12.1528879,14.1422767,9039.5847343,11960.1753683,1.7947177,845.7036717,743.8219464,1453.3617335,22.8904104,27.4092448,0.1574169,83.9344354),(41422,'humerus',253,2,80,225.6889052,105.978826,140.2736645,1.8,106.0892779,140.567092,0.2711152,11.7762774,14.233566,8937.3618107,11999.2887311,2.6977371,843.02758,758.9292854,1452.7105124,22.7834525,27.2470985,2.2332226,83.3267648),(41423,'humerus',253,2,81,227.5076401,105.8415699,140.3273999,1.8,105.9472449,140.6286013,0.3195545,11.3671069,14.2054065,8839.9505893,11985.3281823,3.7419781,843.7159613,777.6781437,1453.9374099,22.7352097,27.4529946,2.2675386,82.7190942),(41424,'humerus',253,2,82,229.3953601,105.6670278,140.4500456,1.8,105.7956917,140.7360998,0.3689194,11.1644359,14.2288163,8714.1347013,11947.324728,4.9716838,839.6569635,780.5262001,1450.8328038,22.6728544,27.5134565,2.4668517,82.1114236),(41425,'humerus',253,2,83,230.850874,105.4940666,140.5260101,1.8,105.5358005,140.8110721,0.4259041,11.3018264,14.2188657,8568.2805536,11994.188789,6.5672542,843.5404792,758.132383,1440.6206325,22.4470675,27.7839065,2.454775,82.1114236),(41426,'humerus',253,2,84,231.8864344,105.3090528,140.5721669,1.8,105.2896882,140.8745449,0.4676033,11.392472,14.0929167,8391.6555052,12055.083209,7.8522118,855.4001608,736.5965457,1446.1386127,22.2453412,28.0122304,2.2910693,82.0071638),(41427,'humerus',253,2,85,232.0901448,105.0785713,140.6167269,1.8,105.0839624,140.9254898,0.5120758,11.3075001,13.9505264,8224.6782594,12144.7472914,9.2870146,870.5583504,727.3648629,1456.2417685,21.7206547,28.1174905,2.4644651,81.7554584),(41428,'humerus',253,2,86,232.4816201,104.8746707,140.683852,1.8,104.9648463,141.0042298,0.5579557,11.3812916,13.9658332,8054.3340959,12217.5523123,10.8615631,874.8172898,707.6819047,1410.0144013,21.5005007,28.3886898,2.2597207,82.1114236),(41429,'humerus',253,2,87,231.3363996,104.6649714,140.6908125,1.8,104.806191,141.089637,0.5988198,11.3550238,14.1502529,7836.8450453,12374.2450254,12.2500969,874.4893167,690.1654419,1361.5262042,21.2707373,28.9426048,2.2826432,81.7554584),(41430,'humerus',253,2,88,232.3345861,104.4442185,140.6941415,1.8,104.6205325,141.1296827,0.6302964,11.2865852,14.5937935,7649.7599483,12513.125208,13.4511551,857.4278667,677.7745259,1325.0386023,20.9548421,29.2251023,2.2937757,81.6511986),(41431,'humerus',253,2,89,231.8110152,104.2450712,140.7208569,1.8,104.4246847,141.1407472,0.65754,11.3057671,14.9165362,7443.1428708,12554.0301908,14.4314243,841.6183245,658.3492144,1297.5510156,20.9537513,29.3260093,2.2524021,82.0071638),(41432,'humerus',253,2,90,231.4280441,104.0563126,140.7192521,1.8,104.2713085,141.1764975,0.67199,11.1871718,15.3039101,7255.1443595,12599.6798763,14.9487767,823.2980836,648.5235509,1258.8161611,20.7631163,29.5986112,2.2636759,82.363129),(41433,'humerus',253,2,91,232.151409,103.8435274,140.7456141,1.8,104.1170867,141.1792832,0.6886153,11.1599506,15.5071704,7099.9135239,12737.2473663,15.6245793,821.3779182,636.1957856,1241.9022811,20.5735722,29.6609241,2.2432748,81.7554584),(41434,'humerus',253,2,92,232.1153219,103.5827495,140.7303754,1.8,103.8102867,141.1893232,0.6916515,11.1003946,16.0010425,6939.8591889,12770.350012,15.7374818,798.0948759,625.1903142,1202.4805381,20.4825091,30.1180332,2.3057323,82.9707996),(41435,'humerus',253,2,93,231.7669833,103.3623015,140.7369172,1.8,103.6009693,141.1902567,0.7054018,10.9721809,16.2070906,6779.7954547,12839.9233905,16.2369943,792.2411082,617.9077377,1187.6641399,20.5168056,30.1547924,2.2856049,82.7190942),(41436,'humerus',253,2,94,232.0510365,103.0935593,140.6631793,1.8,103.3468253,141.1310665,0.7179835,10.8500685,16.4513767,6636.9155839,12855.8906265,16.7382068,781.4477107,611.693428,1164.252164,20.3391399,30.2037351,2.2655346,82.1114236),(41437,'humerus',253,2,95,231.6767375,102.8303583,140.6372975,1.8,103.0950962,141.1188944,0.7241599,10.7147549,16.3998999,6487.8654198,12814.3245223,16.9477223,781.3660186,605.5075885,1152.4058387,20.2187393,30.1180332,2.3057323,82.2156834),(41438,'humerus',253,2,96,231.1389555,102.560284,140.5699812,1.8,102.824625,141.0939743,0.7280037,10.5541754,16.5861965,6395.8185457,12709.967226,17.0554155,766.2978821,605.9988859,1126.3641487,20.2122937,30.2037351,2.2655346,82.5716486),(41439,'humerus',253,2,97,229.829021,102.2369856,140.4850003,1.8,102.5326282,140.9744756,0.7182378,10.6730574,16.5673092,6269.5823512,12512.7968045,16.5875819,755.2703122,587.4214038,1099.8669203,20.044797,30.07816,2.2142974,82.3199432),(41440,'humerus',253,2,98,227.3681032,101.966516,140.4451518,1.8,102.252064,140.9165833,0.7149559,10.5818205,16.4624748,6173.6681897,12218.4018813,16.2867745,742.1971484,583.4221214,1080.463189,20.0225737,29.9304758,2.2545056,82.3199432),(41441,'humerus',253,2,99,226.4340343,101.6749674,140.33795,1.8,101.9885259,140.8410921,0.7135072,10.455189,16.4668553,6125.5034269,11895.4434886,16.1657476,722.3870776,585.8816538,1057.7333174,19.9812683,29.7355273,2.2229677,81.4605672),(41442,'humerus',253,2,100,228.3239923,101.3059199,140.1781757,1.8,101.598361,140.6874234,0.7056809,10.3052674,16.45179,6077.4207537,11678.8552858,16.006274,709.8835609,589.7392581,1049.9658053,19.9176876,29.511152,2.3046937,81.4605672),(41443,'humerus',253,2,101,229.6433262,100.9806278,140.0686973,1.8,101.2176162,140.485992,0.6966805,10.3875642,16.1303444,6029.8861306,11395.1834771,15.7591651,706.4439028,580.4908648,1043.9341541,19.6888777,29.0572042,2.2409184,80.245226),(41444,'humerus',253,2,102,228.3712132,100.6273496,139.962407,1.8,100.8088155,140.3146502,0.6824169,10.3224665,15.6015169,5987.2933007,11055.9744383,15.13893,708.6474016,580.0254513,1055.9422915,19.7709102,28.3886898,2.2597207,78.6739196),(41445,'humerus',253,2,103,227.5676174,100.2668488,139.8370392,1.8,100.3971486,140.135078,0.6661386,10.2641338,15.2362945,5970.4751885,10638.2969106,14.4834658,698.2207448,581.6832971,1060.3356131,19.5947512,27.7306933,2.2794226,77.5628382),(41446,'humerus',253,2,104,229.6812037,99.9109232,139.6943609,1.8,100.0267126,139.9244407,0.6472646,10.3011956,14.6739786,5977.1364559,10282.5299415,13.9193264,700.732242,580.2371551,1074.8398026,19.6018526,27.1248527,2.4346846,76.9551676),(41447,'humerus',253,2,105,228.9643288,99.4818191,139.4765794,1.8,99.5542405,139.6704801,0.6192841,10.2196033,14.0999191,5956.201617,9832.0593316,12.8572982,697.3131732,582.8212134,1074.1313292,19.6258103,26.4772895,2.4136026,75.1321558),(41448,'humerus',253,2,106,227.3258617,99.1275329,139.3752892,1.8,99.2029185,139.5331509,0.5918531,10.2171986,13.5026794,5935.4095004,9469.6057306,11.7926162,701.3130832,580.923374,1089.8693318,19.6409613,25.7023831,2.4746844,74.2727798),(41449,'humerus',253,2,107,228.0106218,98.7797624,139.2434417,1.8,98.8277647,139.346535,0.5651953,10.2956956,13.0384096,5961.362469,9183.1732485,10.9006849,704.3169804,579.015025,1099.9839871,19.7538098,25.3078572,2.4403327,73.769369),(41450,'humerus',253,2,108,228.8376043,98.4428063,139.1074687,1.8,98.5114541,139.1943988,0.5428592,10.2715616,12.6292316,5986.9652027,8919.7190277,10.1779865,706.2756698,582.8680639,1120.6460071,19.7946693,24.702389,2.4424001,73.1616984),(41451,'humerus',253,2,109,228.5054909,98.1148687,139.0209687,1.8,98.1520517,139.0864675,0.5107835,10.3131344,12.0875339,6046.4208397,8667.6264178,9.1015633,717.0715294,586.2835324,1135.0337897,19.9759377,24.2345556,2.4945455,72.3023224),(41452,'humerus',253,2,110,231.7294974,97.7518637,138.9234941,1.8,97.777203,138.9854757,0.4731152,10.4043652,11.7066861,6146.16325,8500.1910014,8.0188989,726.0971119,590.7292908,1157.2722123,20.0902156,23.8931257,2.483704,72.050617),(41453,'humerus',253,2,111,234.9616725,97.4162297,138.7876383,1.8,97.4579751,138.8291478,0.4424724,10.4744735,11.4764007,6266.4102572,8355.3368799,7.1794064,728.0450655,598.2553918,1182.5951982,20.3634887,23.5976575,2.5636907,72.1548768),(41454,'humerus',253,2,112,235.1443461,97.1096843,138.6868513,1.8,97.1624385,138.6963916,0.4050766,10.6253693,11.4691996,6329.2817749,8200.7129623,6.0865638,715.0205104,595.676404,1198.5475364,20.3720286,23.2389317,2.5535901,71.2955008),(41455,'humerus',253,2,113,234.3576469,96.7865496,138.5470581,1.8,96.7921799,138.5542063,0.3573009,10.8515353,11.6355907,6392.4400214,8034.5222222,4.7778841,690.5126176,589.0816198,1216.182866,20.5637544,23.139407,2.5948038,70.9395356),(41456,'humerus',253,2,114,236.8625965,96.4883413,138.4451704,1.8,96.4940989,138.4345394,0.3036165,11.0321525,11.7092682,6532.0331598,7925.9687187,3.5286613,676.8970166,592.0905431,1212.9862789,20.9098333,23.0314371,2.896614,71.651466),(41457,'humerus',253,2,115,239.7030166,96.173204,138.3421078,1.8,96.2107444,138.323971,0.2240265,11.1420627,11.8426716,6647.2024566,7881.4115807,1.9717108,665.5095928,596.5863459,1212.3374549,20.948297,23.099477,2.9733859,71.3997606),(41458,'humerus',253,2,116,241.8227013,95.8503161,138.2411812,1.8,95.9036038,138.19073,0.1167119,11.2750696,11.7887355,6743.0518711,7840.4752443,0.5465165,665.0819527,598.0496898,1235.1281902,21.2684709,23.0314371,2.896614,71.0437954),(41459,'humerus',253,2,117,242.9886789,95.5747022,138.1465392,1.8,95.6079068,138.1020334,-0.0176152,10.9528628,11.8026029,6856.9163185,7822.8973132,0.012565,662.8111948,626.0387307,1235.5349046,21.2684709,23.0314371,2.896614,71.3997606),(41460,'humerus',253,2,118,247.3838663,95.303225,138.0262153,1.8,95.3029952,138.0032952,-0.1760962,10.852834,11.8927135,6983.5062405,7923.1716237,1.2653956,666.220673,643.4730532,1244.0964034,21.2619177,23.0314371,2.9917802,71.7557258),(41461,'humerus',253,2,119,247.6242233,95.025933,137.943169,1.8,94.9942023,137.9335806,-0.3512845,11.018749,11.5809781,7037.6717107,8069.1494586,4.8867686,696.7588939,638.6997022,1248.0583582,21.0462082,23.0314371,2.9917802,72.2591366),(41462,'humerus',253,2,120,249.4731148,94.8076719,137.8419026,1.8,94.7475194,137.8368951,-0.5094141,11.0845665,11.3387367,7074.454728,8281.2992768,9.8881985,730.3546678,638.2256545,1259.1394049,20.8247299,22.9832877,1.2076493,72.6151018),(41463,'humerus',253,2,121,250.6584508,94.5456657,137.7015542,1.8,94.4814622,137.7219766,-0.6376184,10.9169359,11.1703899,7040.5371485,8574.5949497,14.8039897,767.6182347,644.9187981,1251.0486578,20.5813519,23.5075075,1.0335116,73.2227724),(41464,'humerus',253,2,122,252.3410058,94.2992768,137.6411248,1.8,94.1969199,137.6473222,-0.7034416,10.8152745,11.854116,6993.228001,8951.6591141,17.5969981,755.1519753,646.6066135,1234.1426348,20.5191649,24.2497879,1.0516502,73.7261832),(41465,'humerus',253,2,123,255.2685944,94.079136,137.5833518,1.8,93.9822555,137.5675828,-0.7431986,10.6684876,12.6944276,6955.0283337,9417.0603631,19.4791439,741.8263097,651.9226178,1240.2637142,20.4031542,24.7881939,0.9827937,74.9415244),(41466,'humerus',253,2,124,260.3084824,93.861518,137.5014336,1.8,93.822024,137.3655987,-0.7753711,10.5214469,17.7817755,6928.2880625,10087.5748609,21.2573791,567.2985174,658.491948,954.6651875,20.2871435,25.5076926,1.0014831,75.4449352),(41467,'humerus',253,2,125,265.3832826,93.7026163,137.3868356,1.8,93.7497827,137.1347058,-0.7946467,10.3762467,18.4392614,6894.2727656,11132.1467117,22.5243172,603.7197749,664.4283788,976.941685,20.2032336,26.4738027,0.9467733,77.1636872),(41468,'humerus',253,2,126,270.6380149,93.5780783,137.250055,1.8,93.7069698,136.9073336,-0.803025,10.2502089,19.0399963,6855.6449716,12457.8863826,23.3480838,654.3008811,668.8297833,1014.2115059,20.1557148,27.4227137,0.9523683,78.3790284),(41469,'humerus',253,2,127,275.0030458,93.4613639,137.1662958,1.8,93.6081166,136.7751324,-0.8032333,10.093739,19.3592046,6802.3711514,13909.1119391,23.7342002,718.4753828,673.9198559,1068.4973584,19.9500194,32.2981353,0.8607271,90.7230718),(41470,'humerus',253,2,128,281.6619867,93.3183524,137.1061751,1.8,93.5071747,136.692206,-0.7961451,10.1804141,20.017758,6796.2753541,15504.8988225,23.9762931,774.5572105,667.5833917,1111.9003366,19.8708359,33.4439727,0.8217458,91.938413),(41471,'humerus',253,2,129,282.7463907,93.0567494,137.130924,1.8,93.3319908,136.671726,-0.783158,10.228696,20.5344622,6740.9488885,16634.7372653,23.4566324,810.0887732,659.0232891,1135.0860272,19.7718185,34.3454862,0.8119406,93.7614248),(41472,'humerus',253,2,130,284.4522764,92.7801152,137.2767839,1.8,93.1012368,136.7425998,-0.7709971,10.085222,21.1601625,6719.7380699,17579.3391035,23.0217166,830.7752429,666.2955064,1144.6552542,19.7126582,35.0057296,0.8461927,94.7250606),(41473,'humerus',253,2,131,287.4857765,92.5087554,137.4002315,1.8,92.8740173,136.8250118,-0.756955,10.2017394,21.7763244,6717.7042605,18654.3294394,22.5950492,856.6335207,658.486168,1161.1872545,19.6617792,35.8988831,0.7345945,96.0878474),(41474,'humerus',253,2,132,292.0479717,92.1817247,137.5255386,1.8,92.5734502,136.9389525,-0.743764,10.2671959,22.1488945,6764.3118495,19655.8300414,22.3131442,887.4406838,658.8275804,1186.7739794,19.6193064,36.8255401,0.7276113,97.3031886),(41475,'humerus',253,2,133,296.8436423,91.8889212,137.6705319,1.8,92.3091335,137.0816415,-0.7334091,10.1789152,22.7731479,6814.0205879,20940.9786752,22.1694984,919.5469496,669.4250281,1215.0442395,19.6203973,37.7539047,0.7209713,98.7702351),(41476,'humerus',253,2,134,296.5800105,91.6170475,137.7793913,1.8,91.9833534,137.247373,-0.7221121,10.2736099,23.1062308,6840.9180152,21907.1020958,21.5951169,948.1036634,665.8728578,1238.4162253,19.6051252,38.6838539,0.7146503,100.4889871),(41477,'humerus',253,2,135,299.1825353,91.3293611,137.9315191,1.8,91.6785911,137.4419969,-0.7134951,10.3910808,23.6792287,6899.1598006,22929.8643388,21.3588668,968.3535143,663.9501638,1258.1711069,19.6073069,39.8592078,0.7320138,102.6679641),(41478,'humerus',253,2,136,298.5985953,91.0427194,138.0468307,1.8,91.3581444,137.6693875,-0.7030794,10.2796557,23.7555227,6944.4969641,24131.6501418,20.8049863,1015.833265,675.5573514,1303.7503962,19.6659753,40.54807,0.7028792,104.4909759),(41479,'humerus',253,2,137,297.7497367,90.7135638,138.1363851,1.8,91.0066546,137.8322204,-0.6913247,10.2926323,24.14464,6962.4260238,25317.6975005,20.1715827,1048.5845939,676.4475626,1330.265672,19.5519873,41.6065805,0.6682894,105.7063171),(41480,'humerus',253,2,138,301.530492,90.4359291,138.2570768,1.8,90.6606485,138.0456863,-0.6807284,10.353971,24.4606723,7017.1476642,26816.1211947,19.9056868,1096.2953463,677.7252558,1377.3653253,19.5519873,42.5477917,0.6637004,107.5293289),(41481,'humerus',253,2,139,300.4502282,90.0771017,138.4314854,1.8,90.4041811,138.1795683,-0.6687179,10.25664,24.8755797,7043.2441443,28373.7276283,19.2476341,1140.6257852,686.700922,1419.0022916,19.4820908,43.48986,0.6593101,109.3523407),(41482,'humerus',253,2,140,296.9996841,89.6499745,138.6860542,1.8,90.0764043,138.3506282,-0.6577853,10.2395044,25.3126969,7068.4532813,29916.8725397,18.5014989,1181.8919446,690.312048,1459.4303688,19.3972283,44.3578725,0.6686896,120.0818919),(41483,'humerus',253,2,141,298.0565612,89.3935597,138.8521827,1.8,89.7553667,138.5324502,-0.645599,10.2153479,25.4566467,7047.3037263,31986.7032498,17.9835026,1256.5167612,689.8740762,1529.1763959,19.3863617,45.11724,0.6435011,121.1929733),(41484,'humerus',253,2,142,299.1344751,89.03043,139.0719719,1.8,89.4756049,138.7303942,-0.6302606,10.0808384,25.9054241,7054.0372851,34068.6448837,17.3168809,1315.1162749,699.7470854,1584.6603485,19.2865675,45.9042751,0.6191613,122.6600199),(41485,'humerus',253,2,143,298.2222262,88.6012604,139.2755022,1.8,89.1448474,138.8629176,-0.6121185,9.8894356,26.1501832,7029.5842803,36238.6130814,16.4105786,1385.7881169,710.8175397,1651.9251019,19.085922,46.6067899,0.6084601,127.3128651),(41486,'humerus',253,2,144,300.9439224,88.2064092,139.4356729,1.8,88.7398088,139.0247274,-0.5912742,9.8023712,26.5926554,7033.8421919,39260.6410403,15.5846976,1476.3715951,717.5653775,1739.5663146,19.0460608,47.4314053,0.58549,132.5733809),(41487,'humerus',253,2,145,299.1942846,87.867218,139.4461112,1.8,88.4271557,139.0633498,-0.5618579,9.5292159,26.6751798,6849.7989172,42263.7898593,14.1535119,1584.3863191,718.8208308,1840.3760264,18.7551788,48.0271256,0.5880026,137.4779315),(41488,'humerus',253,2,146,303.4253735,87.4565567,139.4846804,1.8,88.0019285,139.1024286,-0.5308053,9.1831217,27.0603568,6599.2391578,46415.9946755,12.9596413,1715.2765229,718.6269929,1959.1248194,18.6028959,48.8731143,0.5660549,137.9381564),(41489,'humerus',253,2,147,310.2789051,86.826558,139.7172898,1.8,87.630729,139.2099238,-0.5101244,8.9489388,27.6760006,6415.0215995,51677.299081,12.3296084,1867.2242374,716.8471839,2098.4613857,18.3994585,49.5204934,0.5374433,132.3216755),(41490,'humerus',253,2,148,317.6041988,86.3551469,139.9380583,1.8,87.1482706,139.4479335,-0.4927947,8.8223531,28.2026181,6362.0877014,56243.7651323,11.8473814,1994.274604,721.1327424,2219.8122653,18.1801276,50.3322225,0.54774,130.2901441),(41491,'humerus',253,2,149,318.577488,86.1812058,140.0082771,1.8,86.8403813,139.6041968,-0.4780117,8.784828,28.1913425,6311.6352685,59284.4054583,11.2358826,2102.9294872,718.4699873,2326.774513,17.9998476,51.0045267,0.520191,129.1790627),(41492,'humerus',253,2,150,318.8520858,86.0289321,140.0573955,1.8,86.5052023,139.7974617,-0.4622145,8.8402863,28.3500301,6268.2252966,62001.5698252,10.5675439,2187.0019073,709.0522927,2407.3570255,18.0286293,51.7519909,0.5119372,128.6756519),(41493,'humerus',253,2,151,318.7349845,85.8240672,140.1833113,1.8,85.9967983,140.0514546,-0.4495693,8.8311436,28.3956586,6235.2399485,64794.3051223,10.0325944,2281.8384354,706.0512497,2501.3251618,17.8785017,52.4729806,0.4856221,128.4239465),(41494,'humerus',253,2,152,322.8459509,85.5863261,140.3720014,1.8,85.6262706,140.3696589,-0.4389583,8.8293039,28.5041779,6238.398309,68138.497193,9.7188616,2390.4740392,706.5560762,2609.2460507,17.8821081,53.0590741,0.4346702,128.9273573),(41495,'humerus',253,2,153,327.2907092,85.3847893,140.5186832,1.8,85.4014547,140.6068292,-0.4317205,9.017841,28.5663716,6222.4830549,72518.9095676,9.550728,2538.6111579,690.019157,2756.4204643,17.8018783,53.7127187,0.4027909,129.8909931),(41496,'humerus',253,2,154,332.3271843,85.0841908,140.8281385,1.8,85.0717457,140.9508439,-0.4252486,9.277198,28.7893647,6232.9080957,76308.7694344,9.4267491,2650.5888625,671.8524359,2867.0850549,18.1376633,54.5043604,0.3966104,130.8546289),(41497,'humerus',253,2,155,334.8996085,84.8803461,141.1498498,1.8,84.6863388,141.342298,-0.4202087,9.3440843,29.1061049,6198.7543888,80021.5487495,9.2892243,2749.3046255,663.3881072,2961.9891128,18.3525606,55.5345767,0.3805064,132.3216755),(41498,'humerus',253,2,156,343.7798935,84.4020579,141.5741816,1.8,84.1942568,141.78694,-0.4107705,9.6365918,29.5373502,6181.630813,87177.3770704,9.1361295,2951.4284989,641.4748025,3160.2868066,18.6532171,56.9851182,0.4029116,136.1151446),(41499,'humerus',253,2,157,345.7710633,83.8189797,142.0209628,1.8,83.7011237,142.2160134,-0.4033486,9.889054,30.0759439,5985.2776537,94638.0901549,8.878051,3146.6374091,605.2426887,3345.1995713,18.8555451,58.0094714,0.3873838,139.3441291),(41500,'humerus',253,2,158,344.9461509,83.4265921,142.3886486,1.8,83.1663625,142.6723139,-0.3978803,10.1870547,30.577018,5788.36722,100172.5285386,8.6310811,3276.0725247,568.2081226,3464.0668764,19.252525,59.1316886,0.3953501,142.5299277),(41501,'humerus',253,2,159,346.3782221,82.9693403,142.7428749,1.8,82.6587034,143.105972,-0.3891827,10.4759641,31.1974904,5706.4323503,105745.3509065,8.311284,3389.5467102,544.7166788,3572.2913622,19.424787,59.9256879,0.389827,145.9242458),(41502,'humerus',253,2,160,344.8730255,82.772869,143.0343166,1.8,82.3118818,143.4747189,-0.3794357,10.7234699,31.3243458,5686.2215944,108156.056435,7.8857208,3452.7794212,530.2594838,3634.0015319,19.7475366,60.1624581,0.3805064,150.4728312),(41503,'humerus',253,2,161,342.3409965,82.9341736,143.1871805,1.8,82.2089481,143.742453,-0.3668398,11.2277124,31.3138719,5840.892145,108120.5455929,7.3399182,3452.8002829,520.2210325,3639.3238847,20.4917184,60.5006197,0.3554457,154.2663004),(41504,'humerus',253,2,162,344.9529767,83.2902251,143.3988518,1.8,82.4018659,144.0130886,-0.3517545,12.0869334,30.9002681,6262.1319376,107664.8492151,6.824982,3484.2691001,518.091045,3686.5599867,21.5054581,60.5006197,0.3554457,153.0941451),(41505,'humerus',253,2,163,353.1309335,84.2765001,143.4440801,1.8,83.6169112,144.1369251,-0.3254799,12.2633596,30.0904739,6650.0925348,108071.2991302,6.0178626,3591.5452698,542.2733044,3811.6503676,21.774134,60.4700947,0.332986,153.0941451),(41506,'humerus',253,2,164,391.4450486,86.9096247,143.54449,1.8,85.9154697,144.1338247,-0.2725856,12.5570602,31.9782941,8239.7783255,117894.2305834,4.7287042,3686.6954278,656.1868928,3942.666696,22.4045139,60.9763457,0.2637799,161.2455682),(41507,'humerus',253,2,165,415.6308043,88.519224,143.7348823,1.8,87.3281701,144.155436,-0.2372418,12.4579039,32.6759395,9293.4093635,115705.0483739,3.8262698,3540.986124,745.9849911,3825.3463364,22.4288355,60.3799559,0.2812322,155.733347),(41508,'humerus',253,2,166,426.6604829,89.8691587,143.688506,1.8,88.6344493,143.954772,-0.2192853,12.5814283,32.7887225,10076.8476868,103529.5428097,3.3649449,3157.4741205,800.930346,3461.990863,22.943898,59.142616,0.2872815,152.6949941),(41509,'humerus',253,2,167,431.1209628,91.2379138,143.6253809,1.8,89.8669631,143.7676907,-0.2176416,12.2710097,32.2771775,10611.4745202,87149.3597841,3.3501445,2700.0303812,864.7596879,3023.169574,22.9642678,57.0191281,0.266913,146.6361762),(41510,'humerus',253,2,168,417.717591,92.7738669,143.4706747,1.8,91.5352548,143.4621176,-0.2312998,11.7863239,31.1455783,10337.0238748,67971.4767086,3.6586691,2182.3796613,877.0354501,2513.696686,22.6644292,54.2446001,0.2891806,140.4120246),(41511,'humerus',253,2,169,408.0236394,93.0866981,143.198709,1.8,92.6331557,143.2321279,-0.2174078,11.7304866,24.9004819,9658.9272165,60084.8163072,3.1639597,2412.9981341,823.4037993,2791.0342032,22.3403199,47.0012682,0.2494132,128.0679813),(41512,'humerus',253,2,170,368.7557614,93.6390005,143.1178928,1.8,93.2688084,143.1651741,-0.220499,11.2432593,21.5395855,7940.7102481,48632.4096178,2.9400235,2257.815483,706.2640871,2624.5219214,21.6824084,42.3978182,0.3089307,119.6648527),(41513,'humerus',253,2,171,314.53422,94.2852499,142.9895095,1.8,93.8750803,143.1191569,-0.2324906,10.6658614,20.2710138,6311.201715,38679.2551437,2.7828427,1908.1065981,591.7198297,2155.5686444,20.4849079,40.6185864,3.0356083,117.0256507),(41514,'humerus',253,2,172,234.4776016,94.5635535,143.1533272,1.8,94.5739097,143.0147042,-0.2219165,10.5385689,19.4995651,4211.3703299,29306.1377343,1.8931642,1502.9123783,399.6150122,1650.6028458,19.5449802,39.2923774,3.0430121,122.3472405),(41515,'humerus',253,2,173,170.4009754,95.4896238,143.0433083,1.8,95.5971505,142.7480597,-0.22127,9.8944316,20.0077434,2501.9700448,21804.8961588,1.3679384,1089.8228604,252.8664752,1207.024382,10.8885716,15.6408793,1.9359978,43.1088361),(41516,'humerus',253,2,174,114.1449037,97.6946406,142.3838882,1.8,96.9317283,142.3082523,-0.219974,9.2251217,22.0711808,1329.7181674,12191.2829917,0.9057987,552.3620657,144.1409898,609.0997478,7.304696,12.1306029,1.971037,31.5199089),(41517,'humerus',253,2,175,65.7655034,102.020091,140.9753037,1.8,101.502403,140.9469931,0.1525166,12.5651837,23.4815933,516.4265221,1082.58903,0.2529946,46.1037297,41.0997989,61.5481312,11.6753196,15.9042615,2.4710711,45.7912239),(41518,'humerus',253,2,176,31.7883888,101.6409306,140.3375928,1.8,102.0065515,140.3818291,0.6211416,4.3221353,6.3007845,94.334544,216.4074972,1.7943591,34.3461197,21.8259118,48.5445103,8.9551075,12.5495381,2.4775465,34.2022967),(41519,'humerus',253,2,177,1.1141689,100.9632158,139.1468226,1.8,101.007372,139.195893,0.7572706,1.5531698,2.1938565,0.5243474,1.2110451,0.087627,0.5520165,0.3375982,0.7836752,3.3421883,4.899197,2.2318395,12.1965978),(41520,'humerus',253,2,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41521,'humerus',253,2,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41522,'humerus',253,2,180,0.1938634,124.4731111,142.211847,1.8,124.45606,142.226728,1.5544424,0.3075368,1.7356319,0.0107928,0.172111,0.0323019,0.0991633,0.0350943,0.1051781,6.44532,7.1514336,0.9994588,21.3548425),(41523,'humerus',253,2,181,5.7893252,123.4264838,142.0365732,1.8,123.2049485,142.011884,1.5665924,2.2606663,5.8204523,5.184747,38.3989728,0.9648705,6.5972489,2.2934597,7.3319093,12.89064,13.5879276,2.176341,42.5011655),(41524,'humerus',253,2,182,14.3982574,122.6027715,142.0559855,1.8,122.3665936,142.0804991,1.5698861,3.5801317,7.9914997,30.0272698,187.6574633,2.3997076,23.4821336,8.387197,26.4136242,17.18752,17.7892908,0.9224643,56.4165153),(41525,'humerus',253,2,183,22.4374607,121.9161972,142.1503754,1.8,121.7537127,142.0574114,1.5595997,4.2063326,9.3556621,74.6171733,435.7099135,3.739108,46.5717881,17.739247,52.3094566,19.765648,20.7410714,0.8734055,65.4705002),(41526,'humerus',253,2,184,71.2030211,104.1797101,146.549406,1.8,100.9489522,146.3222557,-0.2645776,12.4321866,24.9023537,1481.4595406,14935.2629598,0.8115134,599.7530646,119.163232,646.7449731,14.9529041,27.1248527,0.8638883,71.0006096),(41527,'humerus',253,2,185,486.2916235,90.971163,143.8119377,1.8,93.5980541,143.0842962,-0.0554045,15.5666399,34.3407695,23490.8003185,52620.5670751,0.2485376,1532.3059973,1509.0475866,2097.3229386,29.648472,30.2891945,2.1233807,97.8065994),(41528,'humerus',253,2,186,564.4747329,89.9521124,143.1599525,1.8,93.7922186,143.1231493,0.0173914,15.0103654,34.8451675,28646.7655418,61391.3998338,0.0284522,1761.8339691,1908.4655702,2423.271981,29.648472,30.435138,1.0376406,98.3100102),(41529,'humerus',253,2,187,567.7310779,90.0837163,143.2272081,1.8,94.045028,143.2164402,0.0312012,15.3909102,34.8799266,28896.3803382,62820.4139316,0.0920858,1801.0477653,1877.4965155,2453.7625261,29.648472,30.4806021,1.1955255,98.5617156),(41530,'humerus',253,2,188,569.7188908,90.1627692,143.2959068,1.8,94.1510342,143.3387438,0.0479198,16.4522328,34.9940561,29041.6916146,63514.480529,0.2178749,1815.007678,1765.212785,2468.2197233,29.648472,30.4806021,1.1955255,98.3100102),(41531,'humerus',253,2,189,570.4613903,90.2293616,143.3576605,1.8,94.2171336,143.4181356,0.0608105,17.3717215,35.0573966,29060.1762625,63925.6451579,0.351153,1823.4567114,1672.8437775,2470.7118827,29.648472,30.435138,2.103952,98.3100102),(41532,'humerus',253,2,190,570.3290149,90.2877182,143.4125917,1.8,94.2978517,143.4897255,0.0692233,17.7027386,35.1086394,28986.2056418,64049.7010167,0.4547629,1824.3287715,1637.3853952,2474.0733321,29.648472,30.435138,1.0376406,98.3100102),(41533,'humerus',253,2,191,570.0977776,90.3199141,143.4648984,1.8,94.2373677,143.5667349,0.0748776,17.939799,35.1295078,28926.53514,63806.3298075,0.5317292,1816.3172135,1612.4224763,2466.5369535,29.648472,30.435138,2.103952,98.3100102),(41534,'humerus',253,2,192,570.4884696,90.3423363,143.5081833,1.8,94.2341576,143.6239901,0.0766025,18.0382033,35.1208826,28944.5161254,63511.3333363,0.5568417,1808.3638152,1604.6230166,2459.3433312,30.07816,30.4381711,2.2962663,98.9176808),(41535,'humerus',253,2,193,570.4183655,90.3844215,143.4659166,1.8,94.2557576,143.5716241,0.0736401,17.8951682,35.052808,28942.1817641,63621.9625578,0.5146201,1815.0318372,1617.3182329,2465.8800244,30.07816,30.4381711,2.2962663,99.1693862),(41536,'humerus',253,2,194,569.8476854,90.4013825,143.4991095,1.8,94.2854845,143.5965013,0.0715758,17.8589067,35.0128837,28921.1071217,63260.4279631,0.4857342,1806.7757152,1619.4220389,2455.8059485,30.07816,30.435138,1.7986534,98.6659754),(41537,'humerus',253,2,195,568.7830874,90.4183219,143.5315039,1.8,94.2590161,143.635109,0.0696137,17.8252307,34.9740452,28818.7759252,62812.3238347,0.4586521,1795.9696542,1616.7407017,2441.2773728,29.648472,30.389606,0.9867153,98.3100102),(41538,'humerus',253,2,196,568.2558798,90.4488346,143.5657092,1.8,94.2753112,143.6476291,0.0662807,17.7471465,34.9076865,28798.0306028,62513.0238771,0.4154617,1790.8097066,1622.6851222,2433.6361736,29.648472,30.4381711,1.2401174,98.3100102),(41539,'humerus',253,2,197,568.2087707,90.4714308,143.6021121,1.8,94.280555,143.6634166,0.0638292,17.70094,34.8578975,28812.8672879,62152.5684988,0.3853063,1783.0268866,1627.7591613,2424.7796293,29.648472,30.4381711,1.9014752,97.954045),(41540,'humerus',253,2,198,568.6921703,90.4846541,143.6352775,1.8,94.2734181,143.704132,0.0609932,17.2104713,34.813689,28893.5755891,61904.0383272,0.3521679,1778.1522196,1678.8369732,2431.6333993,29.648472,30.4381711,2.2962663,98.5617156),(41541,'humerus',253,2,199,568.6025959,90.4956154,143.6664733,1.8,94.2099027,143.7476886,0.0599935,17.2078175,34.7906242,28907.6931925,61531.263811,0.3406779,1768.616266,1679.9163018,2421.8556687,29.648472,30.4381711,2.2962663,98.5617156),(41542,'humerus',253,2,200,568.1662494,90.5160896,143.6935306,1.8,94.2396274,143.7449774,0.0562945,17.1109722,34.7305346,28890.4109774,61217.3853291,0.299776,1762.6387297,1688.4143505,2413.4841226,29.648472,30.4806021,1.9460671,98.3100102),(41543,'humerus',253,2,201,565.6543621,90.5647753,143.7117879,1.8,94.1955033,143.7636818,0.0542985,17.0602918,34.6602108,28741.7273064,60558.7894311,0.2776822,1747.2135372,1684.7148676,2394.2343162,29.648472,30.435138,1.0376406,98.5617156),(41544,'humerus',253,2,202,565.6003153,90.5787218,143.7488608,1.8,94.1462157,143.7772764,0.0517279,17.0112779,34.6175197,28766.2251194,60158.3645876,0.2520118,1737.8011221,1691.0090631,2383.9997682,30.07816,30.4381711,0.72547,98.9176808),(41545,'humerus',253,2,203,565.8130335,90.5865197,143.7819788,1.8,94.1401501,143.8072196,0.050477,17.0024226,34.5949593,28809.5762037,59785.4249463,0.2400712,1728.1542215,1694.4394868,2374.7524617,30.07816,30.4806021,1.1955255,99.1693862),(41546,'humerus',253,2,204,565.2388287,90.5949077,143.8146622,1.8,94.1364207,143.8552455,0.0488129,16.9793742,34.567528,28780.3838454,59304.8337251,0.2242876,1715.6226436,1695.0202923,2360.7225792,30.07816,30.4381711,2.2962663,99.1693862),(41547,'humerus',253,2,205,564.0215458,90.608253,143.8473552,1.8,94.118296,143.8761664,0.04661,16.5089543,34.5294862,28677.7765188,58752.8854934,0.204074,1701.5279397,1737.1043599,2354.1358313,30.07816,30.4230028,2.2058231,98.9176808),(41548,'humerus',253,2,206,563.5477135,90.6322617,143.8864634,1.8,94.1384216,143.908165,0.0444358,16.4745864,34.4807837,28643.5877237,58347.4103233,0.185336,1692.1718166,1738.6529134,2342.6898555,29.648472,30.4381711,1.9014752,98.5617156),(41549,'humerus',253,2,207,564.2070727,90.6506211,143.9190892,1.8,94.1189236,143.931905,0.0422724,16.4343754,34.4381164,28725.7427205,58105.6623197,0.1679356,1687.2485587,1747.9059554,2338.6198793,29.648472,30.4381711,0.72547,98.2057504),(41550,'humerus',253,2,208,564.4094963,90.6666928,143.9470813,1.8,94.1137652,143.9486923,0.0399359,16.3838661,34.3960512,28757.4335695,57849.3053301,0.1499476,1681.8589123,1755.2287917,2332.780532,29.648472,30.4806021,1.9460671,98.2057504),(41551,'humerus',253,2,209,561.9474036,90.6401318,143.9183875,1.8,94.0821623,143.9261597,0.038153,16.2967813,34.388228,28627.9891199,57399.8615088,0.1362667,1669.171829,1756.6652286,2316.3970019,29.648472,30.435138,2.103952,98.2057504),(41552,'humerus',253,2,210,561.2723227,90.666476,143.9531353,1.8,94.1137025,143.9446274,0.0344955,16.2084332,34.3227095,28581.8462155,57121.559972,0.1112691,1664.2497307,1763.3935273,2308.2841347,29.648472,30.4381711,1.9014752,98.4574558),(41553,'humerus',253,2,211,560.8040293,90.6849528,143.9908582,1.8,94.0714417,143.9841709,0.0329181,16.1928152,34.2865274,28536.0320808,56689.1775322,0.1012442,1653.3951341,1762.2650394,2295.5023703,29.648472,30.4381711,2.2962663,98.813421),(41554,'humerus',253,2,212,561.0451696,90.700375,144.0311069,1.8,94.0427064,144.0287927,0.0322554,15.7809397,34.2628943,28567.0737851,56311.7553757,0.0972526,1643.5200954,1810.2264025,2296.7303419,29.648472,30.4381711,0.8453263,98.5617156),(41555,'humerus',253,2,213,561.0512121,90.7113993,144.0621402,1.8,94.016306,144.0521874,0.0298074,15.7297769,34.225348,28592.8413925,55968.6731991,0.083056,1635.2988785,1817.7525027,2288.0055222,29.648472,30.456363,1.8568478,98.5617156),(41556,'humerus',253,2,214,560.6473161,90.7229699,144.0932032,1.8,93.9714085,144.0725897,0.027631,15.6876831,34.1900566,28560.3377672,55563.1908629,0.0713218,1625.1271964,1820.5580544,2276.0452308,30.07816,30.4381711,0.8453263,98.9176808),(41557,'humerus',253,2,215,560.0685794,90.7425529,144.1286965,1.8,93.9578045,144.0976751,0.0264792,15.6840889,34.1574087,28504.4768583,55134.7852569,0.0654333,1614.1384049,1817.4136262,2263.1732186,30.07816,30.4381711,0.8453263,98.9176808),(41558,'humerus',253,2,216,560.124976,90.765511,144.1676967,1.8,93.9787807,144.1455981,0.0243392,15.6508712,34.1109223,28515.0945471,54776.3539745,0.0552917,1605.8303422,1821.9493488,2254.0912348,30.07816,30.4381711,2.2962663,99.1693862),(41559,'humerus',253,2,217,558.8375331,90.7828374,144.1597191,1.8,93.9118546,144.1334685,0.0221649,15.1401115,34.0707524,28463.0849752,54423.8312711,0.0457507,1597.3768551,1879.9785574,2254.7022377,30.07816,30.456363,1.2847449,98.9176808),(41560,'humerus',253,2,218,558.4247412,90.7971404,144.1949522,1.8,93.9258818,144.1597454,0.0201338,15.1069759,34.0340716,28443.0403456,54022.5099529,0.0377228,1587.3067018,1882.7752451,2243.200271,30.07816,30.4381711,1.2401174,98.6659754),(41561,'humerus',253,2,219,557.7617452,90.8091191,144.2308634,1.8,93.9133992,144.1963814,0.0189267,15.1021871,34.008512,28378.1304556,53561.6243364,0.0332962,1574.9475987,1879.0742246,2228.7100048,29.648472,30.4381711,1.9014752,98.3100102),(41562,'humerus',253,2,220,556.7777138,90.8228721,144.2694462,1.8,93.8835735,144.2359541,0.0172421,15.0840399,33.9760663,28298.4133529,53038.2412966,0.027585,1561.0471433,1876.0500208,2212.1520884,29.648472,30.435138,2.103952,97.954045),(41563,'humerus',253,2,221,556.462497,90.834235,144.3067818,1.8,93.8099134,144.244457,0.0145118,15.0295982,33.9286044,28289.5958094,52546.888979,0.0195295,1548.7489074,1882.2589534,2198.2912485,29.648472,30.435138,1.3429393,97.954045),(41564,'humerus',253,2,222,556.8815552,90.8524414,144.3438547,1.8,93.8183044,144.280582,0.0127616,14.6967495,33.8918137,28338.6294661,52252.1850547,0.0151147,1541.7346929,1928.2242944,2201.8055409,29.648472,30.4381711,1.9014752,98.2057504),(41565,'humerus',253,2,223,556.8935283,90.8604237,144.3744963,1.8,93.7822934,144.325054,0.0113807,14.6602516,33.8691698,28359.6523205,51875.1126209,0.0120209,1531.6322475,1934.4587727,2191.8087517,29.648472,30.4381711,1.2401174,97.954045),(41566,'humerus',253,2,224,556.5787591,90.8743865,144.4086549,1.8,93.7379767,144.3571254,0.008893,15.0221539,33.8290306,28347.0200426,51423.4050182,0.0073359,1520.0969126,1887.0143589,2179.1017611,29.648472,30.456363,1.2847449,98.3100102),(41567,'radius ulna',253,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41568,'radius ulna',253,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41569,'radius ulna',253,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41570,'radius ulna',253,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41571,'radius ulna',253,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41572,'radius ulna',253,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41573,'radius ulna',253,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41574,'radius ulna',253,3,8,0.3364215,115.5693504,134.5517271,1.8,115.5487078,134.5483903,0.6493064,0.6594613,1.911186,0.040871,0.3228804,0.0204983,0.1689424,0.0619763,0.1880656,1.7895179,4.29688,2.4980915,9.0107992),(41575,'radius ulna',253,3,9,27.5217722,113.9988754,135.6276785,1.8,113.120189,136.722337,0.5342386,9.8880458,7.7332685,130.8557252,397.8524897,1.189263,51.4468741,13.2337297,45.1254076,14.0984453,16.6028685,0.1821683,63.8128222),(41576,'radius ulna',253,3,10,126.2743722,111.3623267,139.7472517,1.8,110.9964477,140.3840156,-1.1963449,8.4883384,10.5474333,2354.0866733,2869.6650197,18.2301925,272.0723548,277.331861,495.0319703,17.2840896,20.0116547,1.3101939,60.0625388),(41577,'radius ulna',253,3,11,170.5218812,110.8736556,140.4352013,1.8,110.7685078,140.4710542,-1.2394163,8.6881919,10.2704349,2828.8741019,3399.7831368,25.4119809,331.0262112,325.5998655,605.4553457,17.617208,20.7410714,1.3408919,61.5295854),(41578,'radius ulna',253,3,12,160.2542843,110.4787826,140.313374,1.8,110.525367,140.343675,-1.3090924,8.7488838,10.1238769,2777.0829085,3370.6138808,24.9211544,332.9370668,317.4213971,606.8816113,17.617208,20.7899733,1.2555816,60.9219148),(41579,'radius ulna',253,3,13,149.9835542,110.482129,140.0303772,1.8,110.4671163,140.2636148,-1.038923,8.6718992,10.0894171,2480.0364261,3357.0065336,18.5679662,332.7255184,285.9853832,573.8531348,17.617208,20.4271343,1.1824776,61.1736202),(41580,'radius ulna',253,3,14,128.2329238,110.4058502,139.8405031,1.8,110.4577014,140.0649791,-1.1460759,8.4064532,9.8450123,1881.827929,2483.6024521,17.7431949,252.2701206,223.8551592,442.2797297,16.757832,19.8681338,1.194306,58.7429379),(41581,'radius ulna',253,3,15,116.8048322,110.6832427,139.884607,1.8,110.3999393,140.2071944,-1.1708251,8.2858346,9.7595426,1623.5025744,2127.8570307,16.5156971,218.0283572,195.9371219,383.6894053,16.4433874,19.4691818,1.1861916,57.7361162),(41582,'radius ulna',253,3,16,106.5773507,110.5635324,140.0386983,1.8,110.2217346,140.2780461,-1.1671505,8.0640825,9.5685993,1518.1546822,1936.6884982,15.0225879,202.4004171,188.2613035,360.1768784,16.1431513,18.8916179,1.2706252,56.1648099),(41583,'radius ulna',253,3,17,99.6666952,110.5230182,140.0465966,1.8,110.2196425,140.0693062,-1.1660299,7.9721166,9.1496602,1439.3990982,1879.2637262,14.0350362,205.3916407,180.5541957,362.0640655,15.8823984,18.4815797,1.2637506,55.3054339),(41584,'radius ulna',253,3,18,97.0197469,110.4660837,140.0214618,1.8,110.1588615,140.0122105,-1.1513897,7.773942,8.9229833,1400.6805601,1842.5205683,13.4885422,206.4915402,180.176358,360.0129188,15.5668829,18.2351811,0.9697226,54.9494687),(41585,'radius ulna',253,3,19,96.6717439,110.3589237,140.017669,1.8,110.0931455,139.9494946,-1.167926,7.7517812,8.7176694,1411.6090957,1826.6990023,13.635366,209.539835,182.1012565,370.7987556,15.561652,17.9442977,1.2793395,53.8383873),(41586,'radius ulna',253,3,20,94.9245678,110.2923053,140.0338656,1.8,110.0054049,139.9576738,-1.1177196,7.7412269,8.6265683,1429.9046332,1808.6761458,12.7893299,209.6634585,184.7129207,373.6446467,15.4826091,17.7633248,1.0096329,53.8383873),(41587,'radius ulna',253,3,21,94.4246074,110.1672042,140.0145234,1.8,109.8187883,140.0169581,-1.1021001,7.8163506,8.590305,1472.745998,1804.0758839,12.526146,210.0130195,188.4186208,377.9091383,15.5668829,17.6329213,0.8198673,54.3417981),(41588,'radius ulna',253,3,22,94.9783908,110.0538801,140.0376526,1.8,109.6498592,140.059557,-1.0376807,8.1303457,8.537078,1557.9791114,1825.0868467,11.7411242,213.7835502,191.6251978,385.973273,15.898456,17.4487192,0.9075933,53.7341275),(41589,'radius ulna',253,3,23,97.1924056,109.8369143,140.076727,1.8,109.4213195,140.0771834,-0.9108844,8.3513891,8.417724,1695.9713845,1884.0850027,10.1108137,223.8235649,203.0765621,406.067834,16.328144,17.321277,1.0516502,54.0900927),(41590,'radius ulna',253,3,24,98.3716431,109.6224118,140.0444601,1.8,109.1414687,140.0976401,-0.5609587,8.3349129,8.8969904,1813.0164833,1963.0434492,4.6402243,220.6412908,217.5207462,414.0748723,16.9872127,17.5384304,0.5404195,55.9131045),(41591,'radius ulna',253,3,25,99.3251823,109.3435862,140.0071811,1.8,108.788241,140.1043613,-0.0729822,8.6896742,9.3009019,1884.1201864,2123.5503224,0.0880179,228.316603,216.8228809,429.7307348,16.757832,17.9494415,0.1927008,56.4165153),(41592,'radius ulna',253,3,26,101.83237,109.1018627,139.9879301,1.8,108.5414324,140.0592512,0.0970122,8.7227576,9.569327,1937.818075,2379.4927418,0.1592299,248.6583157,222.1565882,448.0125946,16.7216014,18.4565877,0.2110933,57.5275967),(41593,'radius ulna',253,3,27,104.7882688,108.7955139,140.0179872,1.8,108.2787619,140.0459389,0.193376,8.6741361,9.8436739,1968.0547112,2687.3400454,0.6449806,273.0017347,226.8876922,468.9022013,16.7216014,19.0812438,2.5161076,58.3869727),(41594,'radius ulna',253,3,28,105.2820749,108.5717124,140.0630501,1.8,108.0980292,140.0457962,0.1837995,8.7824402,10.1560875,1979.7866632,2944.4283076,0.5861328,289.9175799,225.4255777,482.3820482,16.7205106,19.4549516,3.0309354,59.7065737),(41595,'radius ulna',253,3,29,107.4789692,108.4598024,140.1788661,1.8,107.9683974,140.1111639,0.1790051,8.8120631,10.4177213,2029.13793,3143.8431331,0.5678839,301.778388,230.2682025,492.4617323,16.7216014,19.9330777,0.1297025,60.8176551),(41596,'radius ulna',253,3,30,108.8345021,108.3981059,140.313198,1.8,107.839671,140.25497,0.1873604,8.7365118,10.4505516,2081.1667236,3297.8560661,0.6293367,315.5676548,238.2148347,510.6212454,16.8377719,20.1404075,0.1932115,61.0693605),(41597,'radius ulna',253,3,31,110.1318481,108.4485419,140.4230795,1.8,107.8708525,140.2413543,0.1762083,8.6488986,10.5284927,2129.5606849,3391.541273,0.5640464,322.1298023,246.2233392,515.8331799,16.6648001,20.3229251,0.2347226,61.9287365),(41598,'radius ulna',253,3,32,112.9386428,108.412958,140.5009304,1.8,107.869452,140.4050788,0.1786813,8.6399965,10.6994075,2185.5673936,3524.459242,0.5945967,329.4069548,252.9592914,523.459673,16.6023649,20.5622657,0.189199,61.9287365),(41599,'radius ulna',253,3,33,115.6037745,108.5447266,140.5985819,1.8,107.9090687,140.4355829,0.1628804,8.5726715,10.9442558,2197.0432913,3579.0281491,0.5066573,327.0234368,256.2845542,521.7481681,16.5737617,20.8431901,0.1448125,61.6770311),(41600,'radius ulna',253,3,34,115.6805366,108.6427138,140.7662482,1.8,107.9508729,140.6098783,0.1596329,8.4235475,11.0034179,2156.9610749,3634.0501257,0.4871492,330.2655751,256.0632657,520.7839142,16.35381,20.8431901,0.1448125,61.6770311),(41601,'radius ulna',253,3,35,115.3061816,108.8753081,140.9796228,1.8,108.0323915,140.7414421,0.1276057,8.4484899,11.096518,2086.3982899,3556.075232,0.3112313,320.4676659,246.9551734,507.2239902,16.3559751,20.7410714,2.9116882,61.3210659),(41602,'radius ulna',253,3,36,113.3055005,109.1862757,141.319683,1.8,108.4536034,141.0936901,0.0757791,8.2241511,11.279201,1989.7119837,3363.4477859,0.1082348,298.1991166,241.935242,474.3230907,15.898456,20.73662,3.0378003,60.8176551),(41603,'radius ulna',253,3,37,115.011666,109.4810501,141.5557278,1.8,108.9645415,141.3876302,0.0470211,8.02327,11.1194971,1925.7480494,3224.6680797,0.0423504,290.001252,240.0203458,462.6711371,15.468768,20.4180938,2.9937433,58.7429379),(41604,'radius ulna',253,3,38,116.4473739,109.8025941,141.780493,1.8,109.4416409,141.6721765,0.0344149,7.7986837,10.5969919,1878.8419538,3062.263793,0.0229774,288.9748175,240.9178306,462.5994874,15.468768,19.8076381,2.9229237,57.5275967),(41605,'radius ulna',253,3,39,116.0233922,110.1500646,142.0056461,1.8,109.9326533,141.9505265,-0.0114027,7.9679376,10.0346293,1835.0552941,2852.8982986,0.0025142,284.3053012,230.3049279,458.8739375,15.7978853,19.1825737,2.8694468,56.5207751),(41606,'radius ulna',253,3,40,115.1922135,110.5231717,142.2141572,1.8,110.3327897,142.2294232,-0.0665104,7.86641,9.5547775,1799.9047144,2651.0489703,0.0848028,277.4579479,228.8089117,454.9911113,15.468768,18.5513782,2.9078495,55.2011741),(41607,'radius ulna',253,3,41,115.7736917,110.8495523,142.3841258,1.8,110.6921187,142.402778,-0.1108624,7.8168047,9.3677994,1789.829813,2493.961836,0.2361821,266.227076,228.9720507,448.4085409,15.468768,18.1336482,2.9023611,54.5935035),(41608,'radius ulna',253,3,42,115.175205,111.1800149,142.5659155,1.8,111.0793818,142.5819153,-0.1475585,7.7731043,9.0202279,1778.5355722,2381.8727777,0.4149367,264.0590462,228.8063422,454.752339,15.468768,17.6643059,2.8198421,53.7341275),(41609,'radius ulna',253,3,43,116.2909404,111.4839898,142.735675,1.8,111.4064919,142.8161085,-0.168054,7.9459261,8.938974,1793.4840635,2309.2456014,0.5422504,258.3345251,225.7111426,457.353079,15.855986,17.4116449,2.8666828,53.4824221),(41610,'radius ulna',253,3,44,116.7321544,111.7690618,142.8748562,1.8,111.7155165,142.983517,-0.1702157,7.9811204,8.8459539,1799.5913726,2234.169604,0.5582643,252.5640107,225.4810467,455.4430594,15.468768,17.1552631,0.3851575,52.8747515),(41611,'radius ulna',253,3,45,116.8805872,112.0590367,142.9935024,1.8,112.0333373,143.1110073,-0.1561803,8.0798282,8.8395825,1803.5396138,2155.9460043,0.471313,243.8968132,223.215094,443.1732561,15.898456,17.0256245,2.9639965,52.9790113),(41612,'radius ulna',253,3,46,117.5010059,112.3299709,143.1107586,1.8,112.2955776,143.2268132,-0.1183046,7.9894379,8.7616316,1815.7153291,2090.0026824,0.272814,238.5403528,227.2644639,444.6144468,15.7994355,16.8949912,3.0140831,52.7273059),(41613,'radius ulna',253,3,47,118.5605125,112.6268894,143.231199,1.8,112.5577548,143.3358837,-0.0299334,8.0653697,8.6598995,1832.1398707,2037.9440539,0.0177,235.3311428,227.1613008,446.2807051,15.7994355,16.6860637,2.9340964,52.4756005),(41614,'radius ulna',253,3,48,118.8579375,112.9209262,143.3693389,1.8,112.8681249,143.4966095,0.0997765,8.0720141,8.4926468,1850.9324029,1993.1477126,0.1965585,234.6909925,229.3024239,448.7602314,15.7994355,16.7137033,1.884417,52.2238951),(41615,'radius ulna',253,3,49,118.5727094,113.2591763,143.4570993,1.8,113.1943147,143.5800726,0.352646,8.0070139,8.0675533,1848.1873167,1947.8624755,2.3574,241.4440169,230.8210461,448.4281883,15.734836,16.7137033,1.884417,51.5119647),(41616,'radius ulna',253,3,50,117.3615809,113.544623,143.5559845,1.8,113.5159152,143.6901897,0.6271397,7.8059055,8.0387015,1827.2734483,1926.9161019,6.7359837,239.7048965,234.0885958,447.7756456,15.7618813,16.927744,1.9890207,52.1196353),(41617,'radius ulna',253,3,51,116.6580779,113.8274341,143.6610998,1.8,113.771003,143.7840721,0.8391063,7.6049637,8.2244313,1791.2582072,1929.3990477,10.7637474,234.5936126,235.5380345,441.0808963,15.4956002,16.998492,1.8525682,51.8679299),(41618,'radius ulna',253,3,52,117.24627,114.0979223,143.7296605,1.8,114.0499045,143.8291702,0.8799929,7.5878954,8.3297786,1741.8729331,1952.2833128,11.6079953,234.3739731,229.5594273,438.6670621,15.1917649,16.998492,1.8525682,51.5119647),(41619,'radius ulna',253,3,53,117.7663161,114.358312,143.7780539,1.8,114.3413827,143.9349355,0.8943676,7.6657585,8.4783824,1698.2362155,1994.9681874,11.9357895,235.3005683,221.5353142,429.7989528,15.1917649,17.321277,1.9789454,51.5119647),(41620,'radius ulna',253,3,54,118.1493432,114.6091205,143.8378665,1.8,114.5648999,144.0051589,0.8901258,7.5460616,8.538563,1663.6911919,2021.654567,11.8929833,236.767542,220.4714568,427.1741488,14.8879296,17.321277,1.9789454,51.5119647),(41621,'radius ulna',253,3,55,119.1686784,114.8605308,143.9014737,1.8,114.8540599,144.0798952,0.8843247,7.5078393,8.5950562,1640.2287648,2045.1760292,11.8827533,237.9479539,218.4688172,425.2800289,15.0233539,17.321277,1.9789454,51.4077049),(41622,'radius ulna',253,3,56,120.3937942,115.1211399,143.9727897,1.8,115.1428195,144.1625118,0.8905749,7.4623549,8.7164927,1618.4794425,2081.0466061,12.1277241,238.7481606,216.8858857,418.4430215,14.8879296,17.6956349,2.0778948,51.7636701),(41623,'radius ulna',253,3,57,119.9239902,115.3878096,143.9907255,1.8,115.4339464,144.1754476,0.8827397,7.3118732,8.9490518,1581.6166764,2095.0366705,11.9269959,234.1071113,216.3080004,410.7987441,14.5840943,17.6956349,2.0778948,51.0517397),(41624,'radius ulna',253,3,58,120.1398975,115.6388712,144.0497554,1.8,115.6759038,144.2428542,0.8744549,7.344864,9.0191166,1557.9216188,2114.7643644,11.7854561,234.4757767,212.1103436,407.0768555,14.5840943,17.9082494,2.0988708,51.6594103),(41625,'radius ulna',253,3,59,120.603603,115.8948209,144.1078223,1.8,115.9597904,144.3064179,0.8715473,7.2770982,9.0871378,1535.1521198,2129.8887154,11.7733941,234.3849918,210.9566301,402.9771488,14.5840943,17.9082494,2.0988708,52.0153755),(41626,'radius ulna',253,3,60,120.8339452,116.1460291,144.1398219,1.8,116.2034449,144.2947947,0.8641502,7.2901443,8.9500324,1510.3850579,2146.9011088,11.6489319,239.8763496,207.181779,408.0778049,14.5840943,17.99567,2.1521765,52.0153755),(41627,'radius ulna',253,3,61,121.3602576,116.3815345,144.1775314,1.8,116.4607784,144.3729779,0.8601171,7.2079682,9.0461688,1489.0947369,2170.8861281,11.6190535,239.9785125,206.5900804,404.317347,14.280259,18.1336482,2.204819,52.0153755),(41628,'radius ulna',253,3,62,121.1228659,116.6237037,144.2167335,1.8,116.7116342,144.4161536,0.8565772,7.078788,9.1381466,1463.8446913,2183.384515,11.5256244,238.930782,206.7931247,398.4578773,13.9764237,18.2351811,2.1718701,51.7636701),(41629,'radius ulna',253,3,63,121.3175685,116.8598232,144.2353319,1.8,116.9193881,144.406587,0.8564819,7.1584988,9.2077235,1440.1951478,2200.9900214,11.5422442,239.0373709,201.1867549,394.0937189,14.280259,18.3210418,2.2565258,52.2670809),(41630,'radius ulna',253,3,64,121.4304177,117.0743949,144.2488278,1.8,117.1228961,144.4009671,0.8560806,7.0726493,9.1000422,1421.6078344,2217.8509803,11.5449409,243.7187571,201.0007515,399.2002119,13.9764237,18.2351811,2.1718701,51.4077049),(41631,'radius ulna',253,3,65,120.8891109,117.2841251,144.2229236,1.8,117.3733055,144.4105277,0.8556958,7.1618559,9.2210668,1397.225074,2225.2375395,11.4858008,241.3210523,195.0925974,389.2911377,13.9764237,18.3914495,2.223643,51.6594103),(41632,'radius ulna',253,3,66,120.3332573,117.470501,144.2130781,1.8,117.5597841,144.3546642,0.8567758,7.028725,9.1058481,1379.3547617,2222.0819842,11.4544321,244.0280088,196.2453746,389.3271579,13.9764237,18.3914495,2.223643,51.6594103),(41633,'radius ulna',253,3,67,120.329285,117.6646687,144.2288775,1.8,117.7630686,144.3939083,0.8602056,7.1246902,9.2005925,1365.0849903,2229.676084,11.5221045,242.340488,191.599207,384.8631884,13.9764237,18.3210418,2.2565258,51.6594103),(41634,'radius ulna',253,3,68,119.9312636,117.8546726,144.2435744,1.8,117.9127629,144.3845969,0.8611987,6.9801291,9.1104273,1349.0556495,2232.6729107,11.5036165,245.0678595,193.2708735,386.3675776,13.6725884,18.3914495,2.223643,51.4077049),(41635,'radius ulna',253,3,69,119.5110305,118.0363523,144.2485643,1.8,118.1056874,144.375168,0.8643279,7.0711755,9.218062,1339.9354932,2230.5500021,11.5248937,241.9760243,189.49261,380.8836772,13.9764237,18.5961103,2.2744101,51.9111157),(41636,'radius ulna',253,3,70,119.169126,118.1996409,144.2397082,1.8,118.2644605,144.3912813,0.8681371,7.1542235,9.1643465,1327.9932794,2233.309043,11.5665923,243.6953964,185.6236782,381.2075305,13.9764237,18.3914495,2.223643,51.6594103),(41637,'radius ulna',253,3,71,119.2334674,118.3511965,144.2309422,1.8,118.4200413,144.3895059,0.8753242,7.057062,9.2898904,1317.9973237,2247.2263759,11.713535,241.9002026,186.7628937,376.2302251,13.6725884,18.5961103,2.2744101,51.3034451),(41638,'radius ulna',253,3,72,119.7239165,118.5159621,144.2403451,1.8,118.5850467,144.368537,0.8830202,7.1283871,9.225301,1314.4604522,2273.1467536,11.9125899,246.4035319,184.3980182,380.2264353,13.9764237,18.7345939,2.2097103,51.9111157),(41639,'radius ulna',253,3,73,119.4486473,118.6644263,144.2096495,1.8,118.7472839,144.349602,0.8887705,6.9959039,9.3585844,1301.4773858,2291.1034882,11.997372,244.8130383,186.0341995,374.9319506,13.6725884,18.9257932,2.2597207,51.5551505),(41640,'radius ulna',253,3,74,118.9553448,118.8084173,144.1970365,1.8,118.8643492,144.3334551,0.8957867,7.0563772,9.3331001,1295.7541989,2303.6744059,12.0837602,246.8284257,183.6288183,379.8929422,13.8391686,18.9939594,2.2278713,51.8068559),(41641,'radius ulna',253,3,75,118.5614637,118.9734192,144.2056164,1.8,119.0743655,144.3387614,0.9004475,7.112683,9.416012,1291.8561593,2317.6998058,12.1335168,246.1445244,181.6271239,375.6077046,13.9484217,19.201814,2.2769954,52.0585613),(41642,'radius ulna',253,3,76,118.7713285,119.1283326,144.2217799,1.8,119.1974973,144.3573755,0.8996481,7.02605,9.3778235,1289.8834248,2329.3810351,12.1395851,248.3925004,183.5858579,379.0873125,13.6725884,19.201814,2.2769954,51.8068559),(41643,'radius ulna',253,3,77,119.3712139,119.250373,144.214928,1.8,119.2899826,144.3360664,0.8998476,7.0566984,9.5742246,1288.9694742,2339.2987412,12.2047635,244.3329716,182.6590009,373.2255789,13.8391686,19.2594195,2.2455373,52.0585613),(41644,'radius ulna',253,3,78,118.9475679,119.3885397,144.2200558,1.8,119.4688418,144.3327617,0.9020355,7.0921954,9.4813695,1287.8562648,2348.3967405,12.2036713,247.6853933,181.5878143,378.3118803,13.8391686,19.2594195,2.2455373,52.0585613),(41645,'radius ulna',253,3,79,118.7642229,119.5317455,144.2379966,1.8,119.6004234,144.3441641,0.9034688,6.9991221,9.6426299,1288.8025778,2365.7871625,12.2124535,245.3466724,184.1377471,373.8774419,13.6725884,19.5307258,2.2627177,52.0585613),(41646,'radius ulna',253,3,80,119.1108831,119.6721756,144.27117,1.8,119.7382567,144.3650525,0.9074778,7.0191557,9.5975225,1291.1785182,2382.1071203,12.3254013,248.2002122,183.950687,379.0072,13.8391686,19.5307258,2.2627177,52.3102667),(41647,'radius ulna',253,3,81,118.1913609,119.8147021,144.2316527,1.8,119.8833936,144.3340981,0.9102813,7.0814801,9.538591,1287.7878761,2393.5635701,12.2838001,250.9347104,181.852926,383.1926675,13.8380777,19.5307258,2.2627177,52.3102667),(41648,'radius ulna',253,3,82,118.2565974,119.933476,144.2274046,1.8,120.0127858,144.3460216,0.9157069,6.994675,9.7266932,1287.5321961,2413.0648115,12.3940531,248.0868638,184.0731973,377.5102233,13.6725884,19.8076381,2.2794226,52.3102667),(41649,'radius ulna',253,3,83,118.6545069,120.0497515,144.2268601,1.8,120.1547242,144.3598999,0.9226064,7.0102959,9.648876,1288.3395074,2430.8640842,12.5673446,251.9323585,183.7781919,381.0561617,13.8391686,19.5967879,2.2318395,52.3102667),(41650,'radius ulna',253,3,84,119.189939,120.1564089,144.2325497,1.8,120.2576949,144.3554221,0.9308268,7.0063882,9.5711908,1288.3437265,2458.8505804,12.7808725,256.901218,183.8812946,387.3403116,13.9484217,19.6813991,2.2011977,53.0221971),(41651,'radius ulna',253,3,85,119.2395099,120.2596248,144.2416065,1.8,120.3328758,144.3588071,0.9350284,6.9920723,9.5823456,1288.2061816,2485.1029083,12.8660795,259.3418152,184.2381106,390.3995398,13.8380777,19.6813991,2.2011977,53.0221971),(41652,'radius ulna',253,3,86,119.0947138,120.3658281,144.2330523,1.8,120.4679753,144.3427883,0.9407338,7.012645,9.6891546,1287.0239984,2513.8485833,12.9584753,259.4497337,183.52904,387.9680243,13.9630455,19.9377084,2.2186078,53.2739025),(41653,'radius ulna',253,3,87,119.4780206,120.4801245,144.2499094,1.8,120.5660123,144.3516592,0.9477084,7.0020234,9.6971236,1291.8195826,2535.0572166,13.1321188,261.4236272,184.492327,392.6943746,13.8380777,19.9377084,2.2186078,52.9179373),(41654,'radius ulna',253,3,88,119.5826452,120.5755939,144.2578243,1.8,120.6227777,144.3374837,0.9539018,6.9739853,9.8004969,1292.6173476,2553.3022674,13.2603619,260.5278386,185.3484477,391.008342,13.8369868,20.0300987,2.1885521,52.9179373),(41655,'radius ulna',253,3,89,119.8872877,120.655475,144.2346995,1.8,120.6961985,144.3217773,0.9623139,7.0485847,9.8338517,1291.4785465,2555.9218447,13.4522982,259.9105547,183.2252298,389.273407,13.8380777,20.1999066,2.2355708,53.1696427),(41656,'radius ulna',253,3,90,119.7399739,120.7459271,144.2364796,1.8,120.8065244,144.3062638,0.9673609,7.009487,9.8899158,1291.9518436,2554.9189002,13.5300724,258.3357578,184.3147504,388.3700902,13.9969449,20.1999066,2.2355708,53.4213481),(41657,'radius ulna',253,3,91,119.2390623,120.8487308,144.251276,1.8,120.9191579,144.3286113,0.9693721,6.9517388,9.850203,1290.8276008,2540.0331187,13.510794,257.8660669,185.6841355,388.8701624,13.8380777,20.1999066,2.2355708,53.1696427),(41658,'radius ulna',253,3,92,119.3242167,120.9277063,144.2488327,1.8,120.9927675,144.3412676,0.9775174,7.017784,9.7666267,1291.052996,2536.7938155,13.6711073,259.7410428,183.9687573,391.0355812,13.8621456,20.0300987,2.1885521,52.9179373),(41659,'radius ulna',253,3,93,119.2474546,121.01406,144.2655705,1.8,121.0525874,144.342442,0.9861079,6.9584223,9.8335678,1290.6322385,2537.9544775,13.8200389,258.0909113,185.4777119,388.8062097,13.8380777,20.0300987,2.1885521,52.9179373),(41660,'radius ulna',253,3,94,119.0364149,121.0955975,144.2696652,1.8,121.1852833,144.3803037,0.9986621,7.0156907,9.8868442,1290.4893714,2526.0955533,14.0236024,255.500695,183.9433099,385.8183202,13.9652874,20.0300987,2.1885521,52.5619721),(41661,'radius ulna',253,3,95,118.8970459,121.1554193,144.249596,1.8,121.2299081,144.3305696,1.0101057,6.9329444,9.9047301,1296.193932,2523.1648352,14.2125439,254.7434217,186.9615346,385.565114,13.8369868,20.0300987,2.1885521,53.1696427),(41662,'radius ulna',253,3,96,118.8294035,121.2158188,144.2431936,1.8,121.2928256,144.3353265,1.0199811,6.9738343,9.7069981,1304.5699891,2504.7880541,14.379768,258.0394087,187.0663864,392.1586961,13.9652874,19.7843213,2.1708465,52.5619721),(41663,'radius ulna',253,3,97,118.1711633,121.2746498,144.2180421,1.8,121.3347176,144.2964135,1.0287127,6.9492722,9.7186122,1305.1714368,2481.0350273,14.4528158,255.2869656,187.8141203,389.4870479,13.9095786,19.6813991,2.2011977,52.5619721),(41664,'radius ulna',253,3,98,117.8849281,121.3300229,144.2168626,1.8,121.3606278,144.2940866,1.0371144,6.9929939,9.5958849,1308.7557879,2466.8581821,14.5630623,257.0745905,187.1524278,392.9230372,13.9652874,19.5967879,2.2318395,52.5619721),(41665,'radius ulna',253,3,99,117.6377453,121.3958069,144.2173043,1.8,121.4360725,144.257665,1.0459244,6.8881105,9.6244308,1313.3956136,2458.0857122,14.6830855,255.4006329,190.6757476,390.9913335,13.9534813,19.5967879,2.2318395,52.8136775),(41666,'radius ulna',253,3,100,117.2588585,121.4614547,144.222845,1.8,121.4908027,144.2516544,1.0563739,6.9300476,9.6055374,1317.8840391,2443.4338278,14.8118338,254.3776287,190.1695499,391.5232793,13.9338163,19.3120737,2.1341126,52.3102667),(41667,'radius ulna',253,3,101,117.0106127,121.5184128,144.2203756,1.8,121.5433083,144.2548902,1.0698902,6.9644243,9.4614638,1327.0044652,2428.4622141,15.004431,256.6687634,190.5404396,396.1173335,13.8992651,19.1873855,2.16501,52.3102667),(41668,'radius ulna',253,3,102,116.8709639,121.5711829,144.2355375,1.8,121.5683472,144.2671974,1.0831958,6.9865295,9.4907144,1335.1706337,2419.3409638,15.2029809,254.9166341,191.1064182,394.3066021,13.8468375,19.1873855,2.16501,52.3102667),(41669,'radius ulna',253,3,103,116.768857,121.6316454,144.242941,1.8,121.6264342,144.2652067,1.0964428,7.0188795,9.5036137,1343.8938861,2411.2086606,15.4011735,253.7149265,191.4684363,395.1231017,13.750016,19.0860812,2.1150768,51.7025961),(41670,'radius ulna',253,3,104,116.9727911,121.6806097,144.2242176,1.8,121.6856309,144.2374755,1.1077891,7.0549992,9.5082989,1357.4328996,2410.0851569,15.6063547,253.4717486,192.4072374,396.1891678,13.9688959,19.0860812,2.1150768,52.3102667),(41671,'radius ulna',253,3,105,116.8341495,121.7225304,144.1694838,1.8,121.7277225,144.1813271,1.1229161,6.9141699,9.4738491,1365.9117086,2404.9760048,15.8205639,253.8541599,197.5525219,397.7606921,13.9534813,18.9501664,2.146221,52.3102667),(41672,'radius ulna',253,3,106,116.8033775,121.7613954,144.1635115,1.8,121.7354624,144.1356268,1.136534,6.9284694,9.4791458,1374.5054126,2411.1274139,16.0210769,254.3612529,198.385145,398.773456,13.9165436,18.867169,2.0955921,52.4145265),(41673,'radius ulna',253,3,107,116.5301225,121.7941286,144.1558663,1.8,121.7570393,144.1323199,1.1510189,6.9421688,9.4770336,1383.4873131,2407.8930779,16.195689,254.0766643,199.2874791,399.0144078,13.9221061,18.867169,2.0955921,52.4145265),(41674,'radius ulna',253,3,108,116.7483796,121.8291313,144.1541827,1.8,121.7820507,144.0882727,1.1643689,7.0379123,9.4793161,1394.3270309,2419.2070404,16.4170396,255.2090271,198.1165675,400.7088593,13.9462236,18.867169,2.0955921,52.6662319),(41675,'radius ulna',253,3,109,116.8165255,121.8504074,144.1387825,1.8,121.7943228,144.0605283,1.1760938,7.0172933,9.4627139,1404.3450429,2426.0761033,16.5905532,256.3826973,200.126313,402.6270554,13.9221061,18.867169,2.0955921,52.6662319),(41676,'radius ulna',253,3,110,116.8343173,121.8744574,144.1315343,1.8,121.8061313,144.0626676,1.1920368,7.0789988,9.4480082,1412.0504991,2430.9438813,16.8099561,257.2969707,199.4703675,403.7298769,13.9819071,18.8328873,2.0446477,53.0221971),(41677,'radius ulna',253,3,111,117.0101651,121.8973424,144.1229803,1.8,121.8239414,144.0524671,1.2078637,7.0731413,9.5252283,1420.1031706,2442.5408821,17.0437529,256.4285933,200.774042,405.2016211,13.9221061,18.8475871,1.9936503,53.0221971),(41678,'radius ulna',253,3,112,116.9700496,121.917163,144.1152153,1.8,121.8169812,144.0451052,1.2219309,7.1037164,9.5184745,1430.5285742,2449.3126257,17.2170366,257.3219704,201.3774904,406.9782813,13.9221061,18.8475871,1.9936503,52.7704917),(41679,'radius ulna',253,3,113,116.2517201,121.9371872,144.0873374,1.8,121.8603849,144.0101502,1.235455,7.1933247,9.4906844,1437.965189,2445.286122,17.2769195,257.6511882,199.9027226,408.0936117,14.1070794,18.6753695,1.972667,53.1264569),(41680,'radius ulna',253,3,114,115.8302002,121.9492138,144.0835372,1.8,121.8790481,144.006678,1.2507035,7.1903107,9.4792674,1443.8200299,2442.347361,17.3936896,257.6514883,200.8007855,408.3447847,14.1313608,18.7592155,1.9215243,53.3781623),(41681,'radius ulna',253,3,115,115.4728538,121.9652708,144.0739154,1.8,121.9146384,144.0114523,1.2668068,7.1999271,9.3314352,1453.4256644,2435.0013769,17.5211198,260.9460733,201.8667194,415.1370273,14.1313608,18.6159568,1.899846,53.6298677),(41682,'radius ulna',253,3,116,115.5197391,121.9785718,144.064287,1.8,121.9231072,143.9968182,1.2836534,7.3333115,9.3144353,1465.6573681,2439.3860628,17.708988,261.8930694,199.8629644,416.9484229,14.1948727,18.6159568,1.899846,53.6298677),(41683,'radius ulna',253,3,117,115.0394167,121.9998208,144.0748328,1.8,121.9322998,144.0021659,1.2970641,7.330408,9.3190539,1475.1913951,2437.7011059,17.7721239,261.5824654,201.2427397,416.8771728,14.1948727,18.6159568,1.899846,53.6298677),(41684,'radius ulna',253,3,118,114.9784882,122.0150917,144.0865833,1.8,121.9465795,144.0025986,1.3105252,7.3318928,9.3210964,1484.2701723,2437.5687429,17.8940031,261.5109458,202.4402437,418.0635638,14.1682093,18.6159568,1.899846,53.1264569),(41685,'radius ulna',253,3,119,115.515431,122.0195731,144.0771176,1.8,121.9578534,143.9886626,1.3218831,7.3351622,9.3004075,1492.2447901,2449.5984748,18.0841579,263.3861455,203.4371892,420.5176932,14.1682093,18.6159568,1.899846,53.1264569),(41686,'radius ulna',253,3,120,115.0842319,122.036243,144.0686083,1.8,121.969206,143.9804596,1.3353381,7.3276314,9.2794301,1499.6487442,2452.2780031,18.1368227,264.270325,204.6566843,421.6748336,14.1682093,18.6159568,1.899846,53.1264569),(41687,'radius ulna',253,3,121,115.018268,122.0269166,144.0250736,1.8,121.9669388,143.9699722,1.3501326,7.3374606,9.3085064,1501.3793847,2443.2778083,18.2513429,262.4779627,204.61839,415.462741,14.1682093,18.7592155,1.9215243,53.3781623),(41688,'radius ulna',253,3,122,115.6225174,122.0360449,144.0108806,1.8,122.002605,143.9797704,1.3676859,7.4232009,9.262178,1504.3963089,2442.9241151,18.486313,263.7526624,202.6614036,416.1482771,14.2280104,18.6159568,1.899846,53.3781623),(41689,'radius ulna',253,3,123,115.1035343,122.0331172,143.9969107,1.8,122.0153526,143.9585648,1.3866356,7.4249531,9.207485,1502.1900026,2441.2598679,18.5406186,265.1386202,202.3164301,416.3524428,14.2280104,18.6159568,1.899846,53.3781623),(41690,'radius ulna',253,3,124,114.0986339,122.0246863,143.9790267,1.8,122.0062416,143.9416435,1.3981193,7.4299202,9.1623137,1500.2779382,2437.0527226,18.4550323,265.986607,201.9238294,416.5758099,14.2280104,18.6159568,1.899846,53.1264569),(41691,'radius ulna',253,3,125,113.030567,122.0096107,143.970544,1.8,121.9957635,143.9347485,1.4081634,7.4425795,9.1277304,1497.5809322,2431.8345077,18.3445393,266.4226931,201.217995,416.3504391,14.2583847,18.6159568,1.899846,53.1264569),(41692,'radius ulna',253,3,126,112.4924493,121.9907623,143.9493949,1.8,121.96668,143.9113983,1.4240421,7.3926074,9.0648084,1499.297328,2432.3843654,18.3478441,268.3326836,202.8103535,417.7853311,14.1948727,18.6159568,1.899846,53.1264569),(41693,'radius ulna',253,3,127,112.5402857,121.9832895,143.9299801,1.8,121.9489266,143.8946987,1.4391652,7.3999502,9.0053112,1505.1979345,2436.0778757,18.433594,270.515679,203.4064949,419.7314427,14.1948727,18.4815797,1.8778421,53.1264569),(41694,'radius ulna',253,3,128,112.8575167,121.9821807,143.9250105,1.8,121.9451958,143.877816,1.4494326,7.4013784,9.2429225,1513.8139372,2446.6521512,18.5338946,264.7054694,204.531353,421.9994351,14.2280104,18.5513782,1.8045395,53.7341275),(41695,'radius ulna',253,3,129,112.4824904,121.9622167,143.8832444,1.8,121.9123218,143.8147617,1.4612095,7.4168195,9.2288495,1517.2590074,2448.5517844,18.5228429,265.3149548,204.5700314,420.5193873,14.2600645,18.6555863,1.8269477,53.7341275),(41696,'radius ulna',253,3,130,112.6155931,121.9568377,143.8649045,1.8,121.8916036,143.8095627,1.4749046,7.4199154,9.1826329,1527.0642945,2452.3481421,18.5972061,267.0637252,205.8061586,422.8181142,14.31615,18.5513782,1.8045395,53.7341275),(41697,'radius ulna',253,3,131,112.5038629,121.9503121,143.8407011,1.8,121.9004681,143.7982443,1.486167,7.4231276,9.1341421,1531.578321,2455.0961661,18.6166696,268.7823498,206.3252033,424.719318,14.31615,18.5513782,1.8045395,53.9858329),(41698,'radius ulna',253,3,132,112.3854188,121.9361392,143.8106066,1.8,121.8619135,143.7623062,1.4984576,7.4019036,9.0758357,1535.5740957,2462.2639584,18.6330571,271.2988673,207.4566467,427.4118208,14.2910326,18.5513782,1.8045395,53.9858329),(41699,'radius ulna',253,3,133,112.672773,121.9242076,143.7928607,1.8,121.8600283,143.7408667,1.5103129,7.4150751,9.029941,1544.7413194,2476.4443271,18.7101818,274.2481186,208.3244333,430.8557762,14.3209125,18.5513782,1.8045395,53.7341275),(41700,'radius ulna',253,3,134,113.049254,121.8998918,143.7710792,1.8,121.8080055,143.7148324,1.5195133,7.4174801,9.0068809,1556.9354539,2491.5657184,18.7920335,276.6291399,209.9008607,428.5741111,14.3209125,18.5513782,1.8045395,53.7341275),(41701,'radius ulna',253,3,135,113.3253065,121.8650114,143.7488744,1.8,121.7794769,143.6838758,1.5283106,7.1179348,8.9578115,1569.0496007,2507.3600828,18.8534788,279.9076637,220.4360748,433.0401237,14.1631957,18.5513782,1.8045395,53.3781623),(41702,'radius ulna',253,3,136,113.220458,121.8401579,143.7398424,1.8,121.7466334,143.7223482,1.5371817,7.1131034,8.9219307,1579.775485,2527.3805805,18.8487622,283.2773174,222.0937036,437.0995996,14.1631957,18.5513782,1.8045395,53.3781623),(41703,'radius ulna',253,3,137,112.8518658,121.8025912,143.683688,1.8,121.7110635,143.6944699,1.5460306,7.1377093,9.2360618,1585.3659665,2537.3206401,18.7971106,274.7188906,222.1113117,439.0663946,14.179704,18.6555863,1.7094361,53.7341275),(41704,'radius ulna',253,3,138,112.4852878,121.7744049,143.6824927,1.8,121.7024256,143.7038345,1.5536963,7.1558448,9.2284947,1591.1228305,2544.0137718,18.7420665,275.6694181,222.3528992,436.2537882,14.179704,18.7198054,1.7321714,53.7341275),(41705,'radius ulna',253,3,139,111.7981219,121.7411,143.6872662,1.8,121.6877285,143.6708968,1.5607202,7.175323,9.2175076,1593.9301928,2556.6868225,18.6311286,277.372902,222.1405488,438.0472456,14.179704,18.7198054,1.7321714,53.7341275),(41706,'radius ulna',253,3,140,111.140553,121.6897021,143.6736568,1.8,121.6496895,143.6527687,1.5650417,7.2224322,9.1940307,1598.1963004,2563.4756012,18.5228121,278.8195615,221.2822837,440.3992611,14.179704,18.7198054,1.7321714,53.7341275),(41707,'radius ulna',253,3,141,110.9390806,121.6363992,143.6848518,1.8,121.6184954,143.6794007,-1.5665916,7.2782592,9.1922807,1603.2941426,2568.6938714,18.4895199,279.4403218,220.2853862,441.5648255,14.179704,18.7198054,1.7321714,53.9858329),(41708,'radius ulna',253,3,142,111.2335403,121.5815672,143.676143,1.8,121.5745301,143.6886013,-1.5618698,7.3422875,9.1836129,1610.6400401,2581.2130172,18.5374462,281.0672718,219.3648839,439.7023528,14.179704,18.7198054,1.7321714,53.9858329),(41709,'radius ulna',253,3,143,111.4286905,121.5358967,143.674295,1.8,121.5294556,143.7000044,-1.558596,7.3889898,9.1820705,1621.6726105,2594.1349106,18.5686842,282.5217811,219.4714907,442.8623855,14.5034471,18.7198054,1.7321714,54.3417981),(41710,'radius ulna',253,3,144,111.3651884,121.4896857,143.6657598,1.8,121.4446046,143.6737406,-1.5571114,7.0313604,9.1740897,1632.2008834,2603.6621361,18.5573889,283.8060468,232.1315932,445.9216908,14.179704,18.7198054,1.7321714,53.9858329),(41711,'radius ulna',253,3,145,110.5773702,121.4406291,143.6094403,1.8,121.4059239,143.5959033,-1.5543258,7.0902012,9.5339885,1639.3578373,2604.5115922,18.4245626,273.1817427,231.2145724,438.7323135,14.179704,18.9501664,1.6388728,54.3417981),(41712,'radius ulna',253,3,146,110.5645579,121.3977944,143.6162942,1.8,121.3519855,143.603624,-1.5548696,7.1243219,9.5419876,1653.978223,2615.7927625,18.4227524,274.1350005,232.1593882,441.4116663,14.179704,18.9501664,1.6388728,54.5935035),(41713,'radius ulna',253,3,147,109.9951646,121.3651059,143.6335464,1.8,121.3072233,143.625183,-1.5429973,7.189189,9.5498821,1666.858929,2613.3449445,18.318364,273.6520627,231.8563247,441.942728,14.179704,18.9501664,1.6388728,54.8452089),(41714,'radius ulna',253,3,148,110.2951074,121.321423,143.6594903,1.8,121.3194241,143.6229979,-1.5281161,7.2709771,9.58172,1682.1044548,2623.3365229,18.3490525,273.7855554,231.3450353,443.6750257,14.179704,18.9501664,1.6388728,54.8452089),(41715,'radius ulna',253,3,149,110.9621316,121.2587096,143.6624246,1.8,121.269769,143.6428708,-1.5137008,7.3449927,9.5791786,1696.6841904,2638.0313646,18.4334665,275.3922302,230.9987594,443.7637677,14.179704,18.9842363,1.6614562,54.8452089),(41716,'radius ulna',253,3,150,110.7714014,121.1848947,143.6822308,1.8,121.103724,143.6981867,-1.51128,7.4223567,9.6017766,1714.9361567,2660.0120672,18.3965818,277.0333218,231.0500874,447.6021869,14.609392,18.9501664,1.6388728,54.9494687),(41717,'radius ulna',253,3,151,110.1005726,121.1096684,143.6705255,1.8,121.0355117,143.6956514,-1.5042407,7.4833274,9.5907441,1734.3027247,2662.4823487,18.2689309,277.6095703,231.7555595,450.9705058,14.609392,18.7936316,1.7547398,54.8452089),(41718,'radius ulna',253,3,152,109.9049189,121.0380068,143.6634882,1.8,120.9829706,143.6818571,-1.5010016,7.5301569,9.586803,1757.8120647,2669.0511468,18.2284012,278.4088874,233.4363131,454.935714,14.609392,18.7936316,1.7547398,54.8452089),(41719,'radius ulna',253,3,153,109.4102735,120.9466293,143.6244905,1.8,120.9037919,143.6326989,-1.497095,7.5965565,9.5524731,1773.3020438,2675.0569139,18.1361742,280.0381521,233.4349853,456.087693,14.9927195,18.8769524,1.7771202,54.9494687),(41720,'radius ulna',253,3,154,109.6387134,120.8722752,143.646873,1.8,120.7762056,143.6808917,-1.4845637,7.6389058,9.5744201,1791.9839605,2679.1731671,18.1375754,279.8261547,234.5864732,458.0687555,15.03908,18.8769524,1.7771202,54.9494687),(41721,'radius ulna',253,3,155,110.4541704,120.7823724,143.6497031,1.8,120.6988153,143.6965371,-1.4752005,7.5057978,9.5804662,1817.6446045,2689.8328428,18.2413081,280.7622093,242.1654113,462.4456552,14.609392,18.8769524,1.7771202,54.8452089),(41722,'radius ulna',253,3,156,110.5190713,120.7023548,143.6320596,1.8,120.6867929,143.6617238,-1.4606215,7.6180693,9.5630235,1840.2263819,2697.2444441,18.1971595,282.0493378,241.56073,467.0321203,15.03908,18.8769524,1.7771202,55.2011741),(41723,'radius ulna',253,3,157,109.775285,120.6360191,143.6146499,1.8,120.6078455,143.6318242,-1.4473785,7.6598443,9.5453222,1851.2457161,2702.2846041,18.018611,283.100408,241.6818988,470.0596109,15.03908,18.8769524,1.7771202,55.4528795),(41724,'radius ulna',253,3,158,108.1953405,120.5379388,143.5866769,1.8,120.5224876,143.5392532,-1.4432224,7.7670544,9.5272962,1870.9080561,2710.9124647,17.7406637,284.5416374,240.8774251,475.1119689,15.3975529,18.8769524,1.7771202,55.8088447),(41725,'radius ulna',253,3,159,107.5062164,120.4726331,143.5892438,1.8,120.4548325,143.5135702,-1.4279813,7.7926111,9.5291433,1895.9110493,2722.6792768,17.5547289,285.7213071,243.2959914,479.2976429,15.468768,18.8769524,1.7771202,55.8088447),(41726,'radius ulna',253,3,160,106.6386149,120.3544749,143.6185332,1.8,120.3313414,143.5718963,-1.4186084,7.9137669,9.5693682,1911.2841328,2728.8690827,17.3646251,285.1671121,241.513827,480.9389471,15.468768,18.9842363,1.6614562,56.4165153),(41727,'radius ulna',253,3,161,106.1384866,120.2306479,143.5564691,1.8,120.1676203,143.5014691,-1.4013134,7.9149527,9.7951481,1921.8241295,2733.9298106,17.1864657,279.1106148,242.8093001,468.8767331,15.6129368,19.1440351,1.4130276,56.5207751),(41728,'radius ulna',253,3,162,105.9457422,120.1371995,143.5663508,1.8,120.105143,143.5202447,-1.3886235,7.9254666,9.7229477,1945.0083484,2737.0208718,17.0780754,281.5011398,245.4124723,471.1885589,15.6764932,19.0812438,1.706324,56.5207751),(41729,'radius ulna',253,3,163,105.5885077,120.0383339,143.5609708,1.8,119.9598248,143.4957962,-1.3799075,8.003443,9.7181895,1965.5648363,2742.1157093,16.964587,282.1632278,245.5899085,474.12397,15.7547747,19.3550478,1.5263811,57.4844108),(41730,'radius ulna',253,3,164,105.8520835,119.9266699,143.5562344,1.8,119.8125683,143.5262192,-1.3567417,8.0542117,9.5414537,1988.6699553,2748.3492153,16.8459388,288.0430267,246.9105656,494.1253503,15.8052067,19.0279509,1.6839473,56.7724805),(41731,'radius ulna',253,3,165,106.1572295,119.8273935,143.5553235,1.8,119.7474186,143.5401624,-1.3397728,8.1642561,9.548355,2013.3067041,2759.2833152,16.7652504,288.9799665,246.6001416,497.7967801,15.898456,19.0812438,1.4352686,56.7724805),(41732,'radius ulna',253,3,166,105.8483349,119.7285895,143.5270491,1.8,119.6449973,143.4695706,-1.3323543,8.1703304,9.5375398,2039.1786781,2763.0415571,16.6572598,289.7017068,249.5833806,501.5986621,16.0341033,19.1440351,1.4130276,57.1284457),(41733,'radius ulna',253,3,167,105.9990056,119.6384831,143.5283275,1.8,119.587986,143.4091022,-1.3128376,8.1731184,9.5436938,2062.7460738,2785.2312906,16.5167689,291.839968,252.3817681,505.5721685,16.100554,19.1440351,1.4130276,57.3801511),(41734,'radius ulna',253,3,168,106.2977734,119.5684031,143.5265872,1.8,119.586718,143.4146389,-1.2916126,8.1501253,9.5394038,2093.5535963,2808.8012871,16.3709306,294.4420173,256.8737941,510.724126,16.1538605,19.1440351,1.4130276,57.7361162),(41735,'radius ulna',253,3,169,105.2502399,119.4446727,143.4814874,1.8,119.4421206,143.4257536,-1.2860491,8.1650577,9.5750652,2116.750845,2809.0812783,16.1574348,293.3746381,259.2450562,499.6651279,16.1538605,19.4121987,1.4821404,58.0920814),(41736,'radius ulna',253,3,170,105.2618773,119.3372757,143.4654044,1.8,119.3296064,143.4246056,-1.2798781,8.2744491,9.5758038,2137.731343,2817.2086785,16.1002851,294.2007523,258.3533125,503.1638984,16.3131078,19.4549516,1.4601391,58.3437868),(41737,'radius ulna',253,3,171,105.1965288,119.2241813,143.4738139,1.8,119.1500334,143.4543444,-1.2642411,8.2532163,9.580855,2158.6899994,2817.5441818,15.9360659,294.0806628,261.5574238,504.5421476,16.3640037,19.4549516,1.4601391,57.840376),(41738,'radius ulna',253,3,172,106.5142961,119.127221,143.4826355,1.8,119.0787919,143.4850703,-1.2587588,8.3409359,9.6060357,2188.52172,2819.4606222,16.0792562,293.5092807,262.383232,506.9517521,16.4679546,19.507078,1.4382448,57.840376),(41739,'radius ulna',253,3,173,108.2787605,119.0341033,143.5027049,1.8,119.0364784,143.5537171,-1.2566833,8.2896898,9.5163279,2218.5531627,2833.983462,16.3236665,297.8022095,267.6280079,511.4610785,16.4464728,19.4549516,1.6814535,58.4480466),(41740,'radius ulna',253,3,174,109.2542317,118.9245017,143.5045122,1.8,118.9170134,143.5345073,-1.2387683,8.3897275,9.5187129,2253.3161319,2856.1771112,16.2743186,300.0591711,268.5803711,516.85724,16.551657,19.507078,1.4382448,58.699752),(41741,'radius ulna',253,3,175,109.2677714,118.816976,143.4934972,1.8,118.7878789,143.5046959,-1.224992,8.385006,9.5251696,2278.0387691,2871.1636001,16.1190088,301.4291309,271.6800409,521.1196181,16.58092,19.5685029,1.4164776,59.0557172),(41742,'radius ulna',253,3,176,109.3003337,118.7326787,143.5121371,1.8,118.6986148,143.4611184,-1.2156112,8.4222113,9.5585482,2305.4965273,2875.502855,16.0135967,300.8305036,273.7400491,523.0472368,16.7113124,19.5685029,1.4164776,58.8040118),(41743,'radius ulna',253,3,177,110.3123397,118.6100812,143.4961206,1.8,118.59201,143.4801099,-1.2274029,8.4315609,9.6006101,2335.3740376,2892.9441878,16.3012889,301.3292042,276.9800351,528.1594718,16.7113124,19.5685029,1.4164776,58.699752),(41744,'radius ulna',253,3,178,110.413999,118.5277148,143.499534,1.8,118.4848849,143.515792,-1.2324538,8.3620762,9.6369481,2352.8587253,2899.7127394,16.3748829,300.8953352,281.3725523,530.0336926,16.7160714,19.6391391,1.3948567,58.8040118),(41745,'radius ulna',253,3,179,111.412801,118.4248188,143.4684991,1.8,118.4381261,143.4742555,-1.2212465,8.4718056,9.5929635,2376.2248442,2905.4190578,16.3908832,302.8698113,280.4862319,534.0844888,16.8524134,19.8402356,1.484058,59.6633878),(41746,'radius ulna',253,3,180,113.2118418,118.3073077,143.4335061,1.8,118.3734546,143.4588496,-1.2257725,8.4796915,9.6105511,2405.5743919,2922.8441593,16.7102158,304.1286722,283.6865453,540.0073335,16.8369411,19.8820682,1.4625257,59.4116824),(41747,'radius ulna',253,3,181,114.8724089,118.195002,143.4353368,1.8,118.3097507,143.4628645,-1.2249675,8.4399957,9.6485392,2440.1403927,2967.3800441,16.9454974,307.5470792,289.1163067,547.1650345,16.8369411,19.9330777,1.4410938,59.4116824),(41748,'radius ulna',253,3,182,113.3088015,118.0674882,143.4562578,1.8,118.1570504,143.4131959,-1.2440135,8.5323775,9.7482718,2446.1042428,2980.3315949,16.9389189,305.7292269,286.6849535,546.9891805,16.9715624,19.9931938,1.419781,60.019353),(41749,'radius ulna',253,3,183,110.4837675,117.9263287,143.38612,1.8,117.9018039,143.2598889,-1.2459427,8.5566783,9.7303895,2425.3318573,2966.1190878,16.53814,304.830459,283.4431495,546.1380913,16.9872127,19.9931938,1.419781,59.7676476),(41750,'radius ulna',253,3,184,109.3234407,117.8384147,143.364619,1.8,117.7866433,143.2109031,-1.2577832,8.5208232,9.7560461,2430.7149508,2971.4565612,16.4929193,304.5759047,285.2676189,547.6252339,16.9887554,20.0623347,1.3986055,59.6633878),(41751,'radius ulna',253,3,185,109.6590789,117.7582845,143.3496205,1.8,117.8516318,143.1759953,-1.2812256,8.506025,9.7961005,2420.5983137,2966.3405555,16.7863637,302.8083015,284.5745592,546.1553901,16.9887554,20.0623347,1.3986055,59.6633878),(41752,'radius ulna',253,3,186,111.1139773,117.6130137,143.3661204,1.8,117.645684,143.2676375,-1.2894568,8.5429768,9.8614197,2419.7450581,2977.4335577,17.0914498,301.9274751,283.2437806,544.8617265,17.0646502,20.1404075,1.3775848,60.2710584),(41753,'radius ulna',253,3,187,110.0708077,117.4706111,143.3767202,1.8,117.4951556,143.231376,-1.301411,8.6184546,9.9200017,2408.1496801,2973.956648,17.0457497,299.7939642,279.4178078,541.2731079,17.0591477,20.1404075,1.3775848,60.2710584),(41754,'radius ulna',253,3,188,109.541474,117.3518676,143.3848037,1.8,117.3213367,143.2293333,-1.3122045,8.6256818,9.8550856,2399.5180141,2994.979787,17.0630479,303.9019556,278.1829957,536.9418904,17.0950223,20.3092932,1.464812,60.1236128),(41755,'radius ulna',253,3,189,110.0918446,117.2070122,143.3729971,1.8,117.1346042,143.2779161,-1.3386591,8.6889945,9.931905,2412.4416314,3031.784208,17.3775089,305.2570696,277.6433588,540.57324,17.1775858,20.4180938,1.422947,60.6270236),(41756,'radius ulna',253,3,190,109.9589656,117.0857691,143.3519878,1.8,117.0347446,143.2930572,-1.3566168,8.8289245,10.0444999,2402.8096573,3049.8483818,17.4985822,303.6336727,272.1520226,536.7216807,17.2175247,20.4858007,1.4021994,60.6270236),(41757,'radius ulna',253,3,191,109.6905782,116.9651571,143.3212152,1.8,116.9345416,143.22824,-1.3768228,8.8862227,10.0714149,2404.486055,3074.7359307,17.6024821,305.2933433,270.5858427,536.7486071,17.2598967,20.4858007,1.4021994,60.878729),(41758,'radius ulna',253,3,192,109.6974039,116.8758859,143.311391,1.8,116.8230195,143.216942,-1.3991976,8.7951982,10.15932,2402.9635299,3106.0097041,17.7498034,305.7300783,273.2131189,538.3810616,17.2322297,20.5622657,1.3815973,60.7744692),(41759,'radius ulna',253,3,193,108.8997387,116.7467376,143.2819901,1.8,116.6906186,143.1460265,-1.4265508,8.8504813,10.2401678,2390.3407109,3121.0547536,17.7749262,304.7855083,270.0803071,538.1766789,17.2602647,20.6473915,1.3611565,60.5227638),(41760,'radius ulna',253,3,194,109.1019944,116.6261694,143.3145746,1.8,116.6315022,143.148362,-1.4346068,8.9048433,10.1902198,2383.4290269,3167.8153178,17.8484825,310.8682044,267.6553586,544.2045182,17.2909134,20.6473915,1.3611565,60.7744692),(41761,'radius ulna',253,3,195,110.1034819,116.5135834,143.3702318,1.8,116.4486467,143.2897527,-1.4550887,8.9122363,10.4456161,2383.2710091,3258.8226687,18.1059926,311.9799385,267.4155996,537.9590408,17.3081171,20.9095205,1.4056476,61.3821398),(41762,'radius ulna',253,3,196,110.1515422,116.3754415,143.4000472,1.8,116.3148739,143.2819651,-1.472918,8.7595803,10.4974733,2373.2816751,3309.5766865,18.1832729,315.2736464,270.935546,541.2623104,17.1008237,21.0678616,1.3654009,61.27788),(41763,'radius ulna',253,3,197,110.8962237,116.2183854,143.4974518,1.8,116.1600323,143.3941166,-1.4935694,8.862248,10.4151451,2369.2757966,3382.3176482,18.3726921,324.7499317,267.344786,550.8391996,17.085705,21.1596801,1.3455195,61.27788),(41764,'radius ulna',253,3,198,111.4719391,116.0701227,143.5267635,1.8,115.9938715,143.4518102,-1.495648,8.9429481,10.4055875,2373.3926909,3429.462714,18.4739353,329.5789596,265.3926507,555.1366227,17.18752,21.2597881,1.3258177,61.5295854),(41765,'radius ulna',253,3,199,111.62026,115.9369163,143.4717264,1.8,115.9054891,143.464511,-1.5036463,8.7425105,10.785498,2380.7560864,3468.6934709,18.5196178,321.6071697,272.3195002,540.2653757,16.757832,21.3334791,1.4089589,61.7812908),(41766,'radius ulna',253,3,200,113.6870728,115.831564,143.5513903,1.8,115.8663175,143.474916,-1.5025507,8.813698,10.7570224,2380.31865,3575.1095145,18.8597335,332.3512195,270.070366,553.3005786,16.757832,21.4886965,1.3694792,61.7812908),(41767,'radius ulna',253,3,201,116.2073526,115.7024753,143.4790554,1.8,115.7419737,143.4138809,-1.5129677,8.5646468,10.8421494,2390.8118012,3681.008558,19.3031952,339.5091175,279.1489076,558.5758824,16.757832,21.909875,1.3734008,62.6406668),(41768,'radius ulna',253,3,202,116.3760389,115.6154619,143.4454004,1.8,115.6559916,143.4261677,-1.5144762,8.627315,10.893851,2393.9567444,3732.5025171,19.3345483,342.6247066,277.4857248,559.3409217,16.757832,21.909875,1.3734008,62.8923722),(41769,'radius ulna',253,3,203,115.3308552,115.4652057,143.4535245,1.8,115.5169414,143.440002,-1.5198382,8.7502589,10.8937191,2393.9222278,3781.9826959,19.1719385,347.1709396,273.5830154,561.7998699,16.757832,21.9981792,1.354246,62.8923722),(41770,'radius ulna',253,3,204,115.3089231,115.2880093,143.4981534,1.8,115.3093718,143.5161068,-1.5313335,8.5240516,11.2199125,2393.4489637,3855.0566204,19.1882406,343.5906144,280.7877132,556.2472052,16.757832,22.2526948,1.3961241,63.5000428),(41771,'radius ulna',253,3,205,115.8083241,115.1137033,143.5431112,1.8,115.2011943,143.5470978,-1.5322711,8.6786293,11.1843047,2396.4584608,3891.2910415,19.2727546,347.9242683,276.1332891,560.2129221,16.757832,22.3313777,1.3771743,64.0034537),(41772,'radius ulna',253,3,206,113.0625139,114.9705139,143.5332724,1.8,114.9977906,143.5546064,-1.5299329,8.7540332,11.2077173,2352.8076258,3856.3664347,18.8123042,344.0813442,268.7684143,551.4735306,17.0244412,22.4180217,1.3583643,64.6111242),(41773,'radius ulna',253,3,207,112.0815597,114.7907964,143.5566674,1.8,114.8493781,143.5984821,-1.5343599,8.5694677,11.5710153,2317.3561717,3887.000284,18.6554708,335.9256016,270.4200842,536.1876284,16.757832,22.6759675,1.3994172,64.8628297),(41774,'radius ulna',253,3,208,108.0653709,114.5877278,143.596109,1.8,114.6292473,143.5593394,-1.5463105,8.7386642,11.5459636,2260.0648137,3860.2685921,18.0000988,334.3392313,258.6281789,527.1867332,16.9499459,22.8382305,1.3623311,65.2187948),(41775,'radius ulna',253,3,209,107.4477497,114.4399479,143.6772815,1.8,114.4607131,143.6416724,-1.5461263,8.8738223,11.4719294,2281.6421458,3847.0480202,17.8970615,335.3444636,257.120558,530.7095299,17.0238618,22.9310118,1.3439975,65.4705002),(41776,'radius ulna',253,3,210,108.3507109,114.2575097,143.7397276,1.8,114.3058554,143.701882,-1.546758,8.6563655,11.8132958,2305.3760156,3868.7808982,18.0480189,327.4937794,266.3214749,522.4965286,16.757832,23.2667224,1.4968573,66.3298762),(41777,'radius ulna',253,3,211,109.8547326,114.0809104,143.8235025,1.8,114.0953651,143.7296205,-1.5477469,8.8103288,11.7352654,2324.4764282,3920.6125763,18.2993966,334.0881061,263.8353791,530.4685002,17.1692801,23.2587856,1.3661545,66.5815817),(41778,'radius ulna',253,3,212,110.958383,113.8835546,143.9508946,1.8,113.9247816,143.8619767,-1.560528,8.5858418,11.604541,2337.1544575,3962.8141563,18.491114,341.4882306,272.2102854,540.0371025,16.757832,23.2587856,1.3661545,66.5815817),(41779,'radius ulna',253,3,213,111.819998,113.695688,143.9944318,1.8,113.6984237,143.9496954,-1.5666798,8.7668851,11.5588951,2370.0238258,4025.8944832,18.6363505,348.2940578,270.3381878,548.7346268,17.18752,23.139407,1.3078016,66.8332871),(41780,'radius ulna',253,3,214,112.881351,113.5019254,144.0771362,1.8,113.4910333,143.9606196,1.5683104,8.538313,11.9026157,2408.848418,4128.0321709,18.8134423,346.8172256,282.1222916,546.4489914,17.18752,23.5976575,1.3876855,67.6926631),(41781,'radius ulna',253,3,215,115.6419317,113.2345476,144.1367208,1.8,113.317481,143.8646609,1.5475927,8.8686995,11.8814256,2461.0279517,4248.3425869,19.26328,357.5616867,277.4959233,559.3480886,17.18752,23.6796687,1.3698421,67.6926631),(41782,'radius ulna',253,3,216,118.9304475,112.9992047,144.2256465,1.8,113.0986676,143.9197092,1.5449237,9.0808759,12.2102826,2513.793898,4373.5721272,19.8084757,358.1876238,276.8228447,562.2464595,17.4494057,24.0202894,1.3909428,68.6562988),(41783,'radius ulna',253,3,217,120.9411435,112.7600892,144.2375386,1.8,112.8437732,143.8919629,1.5415165,8.9470106,12.2086718,2565.8798458,4451.6350639,20.1395815,364.6289392,286.7862758,572.1314012,17.617208,24.0202894,1.3909428,69.1597097),(41784,'radius ulna',253,3,218,121.9952231,112.5727054,144.2947503,1.8,112.6870184,143.9214808,1.5384989,9.1049454,12.161046,2592.2441927,4495.5252773,20.3113352,369.6660028,284.7072746,579.3592324,17.617208,24.0202894,1.3909428,69.1597097),(41785,'radius ulna',253,3,219,124.0874368,112.3481661,144.3724183,1.8,112.4573514,144.0086915,1.5313314,8.9864028,12.4969815,2624.3245685,4573.7707026,20.6490456,365.9900342,292.0328207,575.3308896,17.617208,24.2612058,1.971037,69.7673802),(41786,'radius ulna',253,3,220,126.5057774,112.1330681,144.4537562,1.8,112.2504605,144.0660113,1.5297689,9.1931813,12.4430759,2683.379345,4641.7361502,21.048826,373.0376783,291.8880046,585.8582221,18.0099402,24.3409814,1.9316331,70.3750508),(41787,'radius ulna',253,3,221,129.5243391,111.904729,144.5013867,1.8,112.0413913,144.1573809,1.5184331,9.3961285,12.4430371,2741.6030281,4717.5019379,21.5282533,379.1278542,291.7800696,593.661355,18.1557073,24.4959849,1.9480454,70.6267562),(41788,'radius ulna',253,3,222,133.1242671,111.663046,144.5622333,1.8,111.8207177,144.240185,1.5166841,9.3317505,12.7809603,2806.0670201,4841.6707431,22.1224737,378.8190125,300.7010351,596.225417,18.046896,24.597527,1.9091199,70.8784617),(41789,'radius ulna',253,3,223,136.9812809,111.4286635,144.6028138,1.8,111.6020392,144.3069711,1.5173801,9.4960657,12.7521934,2868.9132303,4987.995579,22.7651341,391.148051,302.1159838,612.7981993,18.476584,24.7434633,1.925502,71.8420974),(41790,'radius ulna',253,3,224,141.2907544,111.1990137,144.6546384,1.8,111.3546975,144.3529387,1.5140994,9.7142589,12.7177603,2924.6214793,5131.0555068,23.4728427,403.4559074,301.0648067,628.9410488,18.759358,24.895961,1.9416876,72.1980626),(41791,'radius ulna',253,3,225,146.2412359,110.9086818,144.6072204,1.8,111.1042748,144.3348775,1.5139135,9.6706567,13.1131683,2985.4712169,5371.3610848,24.2947598,409.6158129,308.7144248,637.277744,18.476584,25.2969117,1.9355311,72.9531788),(41792,'radius ulna',253,3,226,151.9959846,110.6729244,144.6244692,1.8,110.8624864,144.386868,1.5184441,9.8644028,13.1528215,3067.8478733,5643.8095761,25.2632967,429.094973,311.001887,659.5161543,18.906272,25.8527955,1.9451299,73.9168146),(41793,'radius ulna',253,3,227,161.0096521,110.3536918,144.5357009,1.8,110.5491613,144.3274746,1.5097991,10.2121482,13.2709292,3247.7448595,6079.2146872,26.735222,458.0850815,318.0275877,698.8322027,19.33596,26.1015566,1.9237867,75.027896),(41794,'radius ulna',253,3,228,169.3437067,110.1088353,144.4595847,1.8,110.2280683,144.2740777,1.5358245,10.3207084,13.3141606,3364.4377847,6519.0928645,28.1894465,489.6360397,325.9890377,734.0545256,19.9719964,26.5051677,1.9181823,75.7398264),(41795,'radius ulna',253,3,229,165.5224443,110.2946837,144.6996047,1.8,110.3225582,144.3675067,-1.5160083,9.843978,13.3980344,2971.0260397,6499.1509786,27.5043479,485.0824232,301.8115276,703.4557615,19.4983624,26.2672601,1.8356137,75.9915318),(41796,'radius ulna',253,3,230,147.2779154,110.8809274,145.0801485,1.8,110.7843086,144.8685931,-1.3723517,9.6840292,13.1320852,2153.1129317,5659.3761833,23.5923012,430.9579252,222.3364765,593.6275207,18.3231286,26.29185,1.3734008,77.3111328),(41797,'radius ulna',253,3,231,115.5685826,111.6343378,145.0322962,1.8,111.4368795,144.982707,-1.2197754,9.5460617,13.0439633,1199.2383411,4111.8475599,16.9840084,315.2299232,125.6265027,405.4394189,16.915509,26.0555377,1.3378171,78.7349936),(41798,'radius ulna',253,3,232,77.3584208,112.4516215,144.7576697,1.8,112.3106012,144.6956336,-1.0847082,7.7297256,12.2692287,463.565782,2389.885947,10.0791775,194.7869755,59.9718288,230.6241396,13.7973109,24.3258062,1.265804,70.2886792),(41799,'radius ulna',253,3,233,28.4023539,112.3423862,145.6465611,1.8,112.4490438,145.5816585,-0.877117,4.8602383,9.5481956,74.3569109,624.2505417,2.798604,65.3789015,15.2990257,70.4860389,8.5622608,19.5449008,0.9888912,53.1264569),(41800,'radius ulna',253,3,234,0.801246,111.2661189,147.3664818,1.8,111.5259589,147.0672949,-0.877375,1.2340768,7.3190938,0.2509543,14.70925,0.078984,2.0097092,0.2033539,2.043832,28.3338885,78.0874451,0.2730087,313.6247138),(41801,'radius ulna',253,3,235,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41802,'radius ulna',253,3,236,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41803,'radius ulna',253,3,237,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41804,'radius ulna',253,3,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41805,'radius ulna',253,3,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41806,'radius ulna',253,3,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41807,'radius ulna',253,3,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41808,'radius ulna',253,3,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41809,'radius ulna',253,3,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41810,'radius ulna',253,3,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41811,'radius ulna',253,3,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41812,'radius ulna',253,3,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41813,'radius ulna',253,3,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41814,'radius ulna',253,3,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41815,'radius ulna',253,3,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41816,'radius ulna',253,3,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41817,'radius ulna',253,3,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41818,'radius ulna',253,3,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41819,'radius ulna',253,3,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41820,'radius ulna',253,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41821,'radius ulna',253,3,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41822,'radius ulna',253,3,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41823,'radius ulna',253,3,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41824,'radius ulna',253,3,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41825,'radius ulna',253,3,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41826,'radius ulna',253,3,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41827,'radius ulna',253,3,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41828,'radius ulna',253,3,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41829,'radius ulna',253,3,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41830,'radius ulna',253,3,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41831,'radius ulna',253,3,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41832,'radius ulna',253,3,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41833,'radius ulna',253,3,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41834,'radius ulna',253,3,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41835,'radius ulna',253,3,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41836,'radius ulna',253,3,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41837,'radius ulna',253,3,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41838,'radius ulna',253,3,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41839,'radius ulna',253,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41840,'radius ulna',253,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41841,'radius ulna',253,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41842,'radius ulna',253,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41843,'radius ulna',253,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41844,'radius ulna',253,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41845,'radius ulna',253,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41846,'radius ulna',253,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(41847,'radius ulna',253,4,9,23.3051741,66.5630824,132.0943455,1.8,66.9078971,132.4905362,0.1151028,5.6937622,6.6670318,79.7093248,228.0033329,0.0512335,34.198627,13.9994123,45.4117745,9.803108,12.8188253,2.9047439,38.3085453),(41848,'radius ulna',253,4,10,75.4966611,67.5659623,132.7215241,1.8,67.167811,132.8934687,0.2195559,6.6450235,8.4335119,570.7296576,918.5213383,0.5968663,108.9132675,85.8882825,176.5495915,12.89064,16.1747714,2.8450468,46.6505999),(41849,'radius ulna',253,4,11,104.8874104,67.5565609,133.0344561,1.8,67.0856249,133.0314048,0.1565121,7.43562,9.4500559,1205.412421,1734.9571991,0.424736,183.592269,162.1132369,307.869479,15.03908,18.280687,2.625362,53.6298677),(41850,'radius ulna',253,4,12,121.0482299,67.7391694,133.0903067,1.8,67.1892563,133.0901322,0.189566,8.0802065,10.1834144,1655.3495528,2355.4215426,0.7163407,231.2997843,204.8647596,390.0198105,15.898456,19.8262718,2.6197584,57.0673717),(41851,'radius ulna',253,4,13,129.121674,67.8826969,133.1921068,1.8,67.4398838,133.1693404,0.2975036,8.6787936,10.4783472,1915.4737244,2823.8222925,1.8491902,269.4911935,220.7073713,450.3400129,16.757832,20.413572,2.6120031,59.4980541),(41852,'radius ulna',253,4,14,132.6706884,68.0845853,133.4560638,1.8,67.6542521,133.322432,0.3240247,8.87786,10.8640667,2026.6460308,3068.3623722,2.2414414,282.4322113,228.2809179,468.0149521,17.0591477,21.0020312,2.6046819,60.9651007),(41853,'radius ulna',253,4,15,129.9309207,68.2419583,133.7592497,1.8,67.8630523,133.5335463,0.2148126,8.9943134,10.9035636,2027.8117591,2960.4259538,0.9839889,271.5099439,225.4548698,454.0691024,17.0591477,21.1596801,2.6325218,61.2168061),(41854,'radius ulna',253,4,16,121.3019587,67.9917132,133.9459083,1.8,68.0252819,133.7861305,0.1012362,8.814233,10.2683228,1866.6183872,2633.3210771,0.2064925,256.4509451,211.7732056,427.6853089,16.757832,21.0020312,2.6046819,60.8608409),(41855,'radius ulna',253,4,17,119.7722565,68.0455715,134.2238309,1.8,68.2171235,134.0577695,0.0949196,8.7210637,10.2521303,1750.2710172,2623.8670951,0.1793132,255.9338412,200.6946715,419.8504653,16.328144,20.8608988,2.5764432,61.4685115),(41856,'radius ulna',253,4,18,123.7056966,68.5790766,134.4911459,1.8,68.6971357,134.3286687,0.0682695,8.4486421,10.663737,1697.3995462,3040.3881817,0.0959438,285.1147018,200.9079723,442.3780098,16.2103839,20.8431901,2.891614,61.2168061),(41857,'radius ulna',253,4,19,126.9713292,69.1215921,134.640266,1.8,69.075718,134.5832272,0.0055599,7.5621313,10.6966264,1651.4395618,3421.8073847,0.0006542,319.8959437,218.3828213,464.2420449,15.468768,21.0678616,2.9361973,61.1125463),(41858,'radius ulna',253,4,20,129.9713159,69.4853122,134.7835757,1.8,69.3207594,134.7727282,-0.0521618,7.6635326,11.06234,1632.1803936,3736.4301909,0.0588853,337.7612871,212.980159,478.098029,15.3975529,21.4069164,2.9599438,61.4685115),(41859,'radius ulna',253,4,21,130.8319797,69.8192567,134.9465702,1.8,69.6075645,134.9677435,-0.1122995,7.6923131,11.1210266,1681.3402527,4002.1334725,0.2738368,359.870867,218.5740783,509.0214584,15.03908,21.4069164,2.9599438,61.3642517),(41860,'radius ulna',253,4,22,131.0896809,70.1002307,135.1816569,1.8,69.851717,135.1788535,-0.1380049,7.5607962,11.4451265,1717.9682688,4317.5321041,0.4134734,377.2376038,227.2205505,526.2102568,15.03908,21.7831051,0.2593317,62.3278875),(41861,'radius ulna',253,4,23,134.3779169,70.3063016,135.4167679,1.8,70.0754813,135.3635296,-0.1627283,7.5184074,11.6254563,1786.5484995,4733.2090962,0.5878493,407.1417923,237.6232616,560.7321949,15.2511621,22.1986985,0.2543681,63.2915233),(41862,'radius ulna',253,4,24,139.7300564,70.4191531,135.6724975,1.8,70.2738918,135.6450084,-0.1833186,7.5809174,11.6915064,1885.3662894,5236.1015083,0.7738937,447.8551649,248.6989617,608.9023005,15.3295599,22.6881774,0.4297623,64.7585699),(41863,'radius ulna',253,4,25,145.7874334,70.4621741,135.9590659,1.8,70.4375006,135.9279943,-0.1940838,7.4917479,11.7573211,2033.8179353,5848.7490607,0.9038311,497.4559269,271.4744221,670.2172361,15.3586326,23.2548162,0.2808377,66.2256165),(41864,'radius ulna',253,4,26,157.0462232,70.4459037,136.2542942,1.8,70.4698976,136.2697019,-0.1903621,7.8159086,12.0271504,2273.5114452,6671.1287245,0.9370976,554.6724302,290.8825533,740.326951,15.7269022,23.9702752,0.2536741,68.6562988),(41865,'radius ulna',253,4,27,171.8893313,70.2696981,136.5622291,1.8,70.3564482,136.5938954,-0.1741094,8.5756962,12.4387987,2716.053834,7730.5557319,0.8597046,621.4873247,316.7152587,821.564811,16.6269117,25.0549006,0.1030816,71.6946518),(41866,'radius ulna',253,4,28,186.7115704,70.1577924,137.0010827,1.8,70.3014003,137.0631426,-0.1881892,9.7543064,12.7925858,3360.8239412,8757.6540337,1.0891214,684.588259,344.5477122,927.4578619,18.3324805,25.9561429,0.1161416,74.229594),(41867,'radius ulna',253,4,29,205.048639,70.4281483,138.0744125,1.8,70.4027419,138.3102242,-0.3656243,11.9181152,13.3824395,4595.3186012,9400.8890078,4.3685405,702.4794725,385.574274,1021.3228539,21.3794837,26.5782087,0.9693416,80.6622652),(41868,'radius ulna',253,4,30,212.4967968,70.8411021,138.7923931,1.8,70.7539651,138.9797104,-0.5224643,11.2533117,13.8633006,4938.8133073,10095.7505722,8.8192614,728.2357098,438.8764319,1068.1590441,21.1244746,27.179252,0.8861792,82.1293118),(41869,'radius ulna',253,4,31,207.4752041,71.4712251,138.9996972,1.8,71.3399304,139.273482,-0.5537529,10.9531959,13.6452048,4437.8079422,10002.6409578,9.5629779,733.0517271,405.1610137,1048.014178,20.6311952,27.1248527,0.8638883,80.5580054),(41870,'radius ulna',253,4,32,195.7669758,72.3022512,138.9127915,1.8,72.1140088,139.2289644,-0.5447,10.7100562,13.2963899,3793.2785022,9065.0030005,8.7602919,681.7642272,354.1791393,958.4320969,20.5036196,27.1758553,0.6055447,78.7781794),(41871,'radius ulna',253,4,33,174.7035112,73.6986023,138.3754501,1.8,73.4076975,138.8016303,-0.519882,10.425598,13.2419058,3262.0666123,6794.9246007,7.1857912,513.1379642,312.8901213,758.5215403,19.9175266,25.7418618,0.583373,75.2364156),(41872,'radius ulna',253,4,34,164.2604582,74.6049911,138.0631809,1.8,74.4637339,138.5106551,-0.4819968,10.4529912,11.3588398,3014.0848993,5564.5556215,5.8826621,489.8876763,288.3466415,746.9730996,19.8963192,23.4917939,0.6947383,71.4861322),(41873,'radius ulna',253,4,35,157.5901037,75.1355146,138.0323796,1.8,75.0945215,138.3606266,-0.4459742,10.3831837,10.833891,2801.3569432,5074.3820643,4.8866496,468.3803888,269.7974946,708.0671728,19.6032726,22.1778956,0.6202495,69.012264),(41874,'radius ulna',253,4,36,152.5459635,75.5337779,138.0109062,1.8,75.5315677,138.3084228,-0.4049459,10.1734492,10.5538448,2661.9588151,4820.8853583,3.9461504,456.7894867,261.6574552,676.5708837,19.3526409,21.6768972,0.6871242,68.2571478),(41875,'radius ulna',253,4,37,150.7237598,75.7453913,138.0215593,1.8,75.7627494,138.1806913,-0.3598142,9.1734612,10.431697,2578.9395474,4781.4057672,3.1143216,458.3535903,281.1304809,670.9696065,17.956075,21.5787243,0.6156199,65.9739111),(41876,'radius ulna',253,4,38,150.5598292,75.9049594,138.0486506,1.8,75.9331226,138.1870251,-0.3315464,8.9551923,10.5173063,2570.8265955,4920.7864413,2.6587338,467.8751676,287.0766504,685.2083414,17.497759,21.4844,0.6435011,65.9739111),(41877,'radius ulna',253,4,39,150.8262584,76.0195974,138.2049728,1.8,75.9402849,138.4241278,-0.3180894,9.6842217,10.5815965,2732.9917609,5162.7731369,2.4588206,487.9011543,282.2107803,697.1545258,18.9581275,21.8169824,0.560687,68.0054424),(41878,'radius ulna',253,4,40,160.6520818,75.7440348,138.6185143,1.8,75.7424409,138.8356978,-0.3199497,10.729564,11.1116045,3124.2497161,5908.3317072,2.6486728,531.7262405,291.1814234,778.9106613,20.1594166,22.5494105,0.5404195,71.2955008),(41879,'radius ulna',253,4,41,165.9000443,75.461424,138.959211,1.8,75.4296649,139.2390612,-0.3013893,11.6303165,11.740259,3615.6914903,6683.8854563,2.4364696,569.3132883,310.8850459,844.416643,21.2344727,23.6640694,0.5123895,75.4449352),(41880,'radius ulna',253,4,42,180.5106842,75.0018197,139.4847447,1.8,74.9780206,139.7383296,-0.3041324,12.0794511,12.491541,4304.7879972,7960.0745239,2.6980206,637.2371922,356.3728157,953.2671609,22.0882733,25.4243162,0.5317241,79.846075),(41881,'radius ulna',253,4,43,201.8249122,74.0523085,140.0652536,1.8,73.842693,140.3445735,-0.3050328,12.2187345,15.0877803,5039.4531599,10538.621016,3.0339254,698.4871716,412.4365876,1032.3878761,22.343776,29.4516568,0.4048918,87.3287536),(41882,'radius ulna',253,4,44,219.2944353,73.1883465,140.3483647,1.8,73.0950594,140.5240091,-0.2706179,12.4440247,14.9912273,5587.802706,13378.424185,2.6119309,892.4168751,449.0350066,1259.9019631,22.343776,30.4108627,0.4067471,91.3739282),(41883,'radius ulna',253,4,45,224.9989978,72.8789801,140.0900711,1.8,72.7843539,140.3285684,-0.1740545,12.9598698,15.3513931,5795.207543,14745.3727145,1.1246298,960.5234294,447.1655671,1337.3010736,22.773464,30.655762,0.5452272,94.4122812),(41884,'radius ulna',253,4,46,224.0472489,72.8366022,139.7590111,1.8,72.5975104,140.0894356,-0.0739291,12.6814554,15.4063641,5705.3885535,15637.3031531,0.2037173,1014.9898509,449.9001378,1376.6946281,22.1090412,30.8089592,0.1399247,93.8477964),(41885,'radius ulna',253,4,47,219.785388,73.114834,139.554095,1.8,72.8765137,139.9199192,-0.0039845,12.5739197,15.5351831,5382.6455052,16038.9251612,0.0005815,1032.4258825,428.0801554,1320.2085397,21.8582568,31.7882009,2.9786662,93.0926802),(41886,'radius ulna',253,4,48,208.4610819,74.1122839,139.6548774,1.8,73.5892448,139.9879964,-0.020908,12.5284961,16.4944139,4916.9944511,13942.6050131,0.0151858,845.2925382,392.4648597,1110.5801964,21.5909447,31.8607205,2.965358,91.1222228),(41887,'radius ulna',253,4,49,187.0294727,75.6727875,139.7125341,1.8,75.0418103,140.1565966,-0.0731643,12.4860043,15.2504142,4328.0073088,10455.225094,0.1665642,685.56991,346.6286902,917.2097624,21.1147544,29.8316135,2.9385474,87.4330134),(41888,'radius ulna',253,4,50,173.4256915,76.8019065,139.6160217,1.8,76.309455,140.1071987,-0.092179,12.0625097,13.7338694,3733.8965519,8488.1236542,0.2449038,618.0431316,309.5455795,831.4536884,20.4329486,27.5570408,2.9533711,81.6690868),(41889,'radius ulna',253,4,51,164.2243151,77.6371099,139.4770831,1.8,77.2787578,139.8658634,-0.0687947,11.2668764,12.9872927,3243.514783,7321.9773869,0.1293336,563.7801156,287.8805675,764.8244109,19.2459289,26.0555377,2.9086134,74.0821484),(41890,'radius ulna',253,4,52,161.891017,78.1131247,139.478095,1.8,77.8557869,139.7686674,-0.0772249,10.0303168,12.181397,2947.1347292,6759.175026,0.1605916,554.8768342,293.8226958,744.2973333,17.9044338,25.0254069,2.863293,70.8352758),(41891,'radius ulna',253,4,53,162.5899882,78.3579426,139.5171749,1.8,78.3418164,139.7671715,-0.0846014,9.500898,11.4311124,2748.8992351,6511.5144672,0.1934911,569.6308683,289.3304635,776.438517,17.2732547,23.9702752,2.8879186,69.012264),(41892,'radius ulna',253,4,54,164.139944,78.6066307,139.6163673,1.8,78.6550022,139.838754,-0.0898018,8.9444775,11.2657527,2637.826611,6332.8053577,0.2200216,562.1289151,294.9112035,761.0662431,16.6040837,23.6679702,2.8657868,67.7969228),(41893,'radius ulna',253,4,55,160.9610324,79.1089876,139.6636105,1.8,79.0949463,139.8438611,-0.0838147,8.4368346,11.0517222,2481.0619565,5798.7102523,0.188015,524.6883853,294.0749792,722.1257552,15.9535915,23.0314371,2.896614,65.8696513),(41894,'radius ulna',253,4,56,157.6276455,79.6378445,139.7144161,1.8,79.5257851,139.8878381,-0.0840611,7.9852836,10.668165,2336.2385458,5256.287057,0.1852029,492.7077,292.5680124,679.531397,15.5722324,22.4303721,2.8501359,64.6543101),(41895,'radius ulna',253,4,57,153.9399335,80.0609522,139.7220625,1.8,79.9541173,139.9193962,-0.0629673,7.664032,10.9901895,2157.2841862,4909.0444696,0.1015914,446.675144,281.4816266,637.9130132,15.2337627,22.0191518,2.8445284,64.5068645),(41896,'radius ulna',253,4,58,150.473276,80.4119755,139.7393643,1.8,80.3968694,139.892945,-0.0256466,7.328462,10.8737713,1993.9753003,4656.8061991,0.016492,428.260449,272.0864633,594.3800743,15.03908,21.6939254,0.1390959,62.3278875),(41897,'radius ulna',253,4,59,147.1640591,80.7832805,139.7371377,1.8,80.7320572,139.899334,0.0293486,7.5034733,11.1716107,1852.1644431,4363.7102381,0.0211203,390.6070815,246.8409459,553.1056709,15.03908,21.6939254,3.0024967,61.2168061),(41898,'radius ulna',253,4,60,143.2322415,81.2041368,139.7485843,1.8,81.1991737,139.9052967,0.0827222,7.3067531,10.7068566,1721.2538435,4000.5227734,0.1629834,373.6412033,235.5702759,531.6583744,14.609392,20.9095205,2.976444,59.1420889),(41899,'radius ulna',253,4,61,141.910278,81.5257852,139.8068641,1.8,81.584658,139.9115488,0.1199,7.4076952,10.4516726,1616.428908,3788.8484606,0.3383913,362.5112066,218.2094255,511.9441424,14.609392,20.8431901,2.891614,57.7793021),(41900,'radius ulna',253,4,62,141.1908295,81.7925292,139.8981405,1.8,81.8288238,139.9982517,0.1451192,7.2239088,10.7011002,1528.1210595,3648.4809135,0.4921007,340.9444688,211.5365927,482.1919089,14.179704,20.9536242,2.8717435,57.1716315),(41901,'radius ulna',253,4,63,138.1135772,82.0717967,139.9831348,1.8,82.1031389,140.068012,0.168324,7.259688,10.6560928,1444.486731,3470.5149659,0.6460583,325.6836276,198.9736659,458.6052046,14.179704,20.7899733,2.826378,56.3122555),(41902,'radius ulna',253,4,64,134.1918864,82.3378655,140.0798561,1.8,82.2901571,140.1548078,0.1872573,7.1865291,10.8752648,1369.1345455,3303.3104259,0.7751229,303.7452864,190.5140204,429.0610438,14.179704,20.6608003,2.8461518,56.3122555),(41903,'radius ulna',253,4,65,130.2377451,82.5684873,140.1649696,1.8,82.5236294,140.2535715,0.1999955,7.0711267,10.7033898,1301.4171241,3145.26799,0.8566984,293.8571848,184.0466407,414.9002755,14.179704,20.3818914,2.8198421,55.4528795),(41904,'radius ulna',253,4,66,127.5112373,82.7358368,140.2988452,1.8,82.6732782,140.4062723,0.2069373,7.0049343,10.809946,1256.5886779,3033.2345687,0.8971536,280.5966448,179.3862187,396.8015977,14.179704,20.4271343,2.8864103,55.3054339),(41905,'radius ulna',253,4,67,124.8903053,82.8737785,140.4448734,1.8,82.8224656,140.5605993,0.2096646,6.9695624,10.6447856,1219.1165993,2932.2844832,0.9016844,275.4667487,174.9201065,389.0408944,13.750016,20.2501155,2.8399736,54.3417981),(41906,'radius ulna',253,4,68,122.6949216,82.9970643,140.5793059,1.8,82.8964102,140.6873603,0.2064574,6.8929659,10.6143985,1185.9754625,2863.422449,0.8593242,269.7677537,172.0559017,381.4970555,13.750016,20.0116547,2.8809903,54.3417981),(41907,'radius ulna',253,4,69,120.5989033,83.0911591,140.7244801,1.8,82.9754595,140.8505422,0.2016119,6.7619457,10.649272,1155.9903754,2798.2497957,0.8059949,262.7644216,170.955287,371.2492017,13.320328,20.0116547,2.8809903,53.7341275),(41908,'radius ulna',253,4,70,118.8731557,83.1681851,140.8880513,1.8,83.0609474,141.0368883,0.196998,6.7299512,10.420363,1134.7856734,2742.5995439,0.758981,263.1961607,168.6172222,371.6716812,13.750016,19.8402356,2.8335399,53.7341275),(41909,'radius ulna',253,4,71,117.6127361,83.2346362,141.062435,1.8,83.1424579,141.2262928,0.1897757,6.6211009,10.4335879,1116.9554111,2703.7638369,0.6975326,259.1403712,168.6963271,366.0320244,13.320328,19.7142053,2.8543112,53.1264569),(41910,'radius ulna',253,4,72,116.5988838,83.2753342,141.2386029,1.8,83.1507167,141.3830086,0.1807747,6.6150395,10.4248234,1103.8524859,2666.4410682,0.6281778,255.7780553,166.8701271,361.6286348,13.320328,19.7142053,2.8543112,53.1264569),(41911,'radius ulna',253,4,73,115.2170548,83.2977468,141.3798072,1.8,83.2000857,141.5350351,0.1729349,6.5481054,10.3218439,1085.3023912,2616.7624595,0.5685871,253.5169578,165.7429623,358.2730559,12.89064,19.5685029,2.9872739,52.8747515),(41912,'radius ulna',253,4,74,114.1898308,83.3390331,141.5553942,1.8,83.2795605,141.7280454,0.1666962,6.4775527,10.1133574,1070.2017147,2581.2074202,0.5239638,255.2275482,165.2169822,360.2639065,13.320328,19.4881391,2.896614,52.8747515),(41913,'radius ulna',253,4,75,113.9593208,83.3727083,141.7433516,1.8,83.2987742,141.8952918,0.1612747,6.4344348,10.104011,1056.9702034,2552.1614699,0.4897367,252.5889443,164.2677623,356.7980501,12.89064,19.4881391,2.896614,52.5187863),(41914,'radius ulna',253,4,76,113.1870005,83.4001769,141.918862,1.8,83.3161972,142.0580001,0.1585558,6.393263,10.089664,1037.6915723,2524.7841359,0.4702916,250.2347096,162.3101646,352.9728108,12.89064,19.3884063,2.9181161,52.2670809),(41915,'radius ulna',253,4,77,112.5814082,83.4199281,142.0967179,1.8,83.3603561,142.206393,0.1575384,6.348673,10.0019884,1019.6552559,2494.3665942,0.4618408,249.3870717,160.6091942,351.0298945,12.460952,19.2977277,2.9398303,51.9111157),(41916,'radius ulna',253,4,78,112.3630392,83.4430845,142.2796033,1.8,83.393069,142.4455506,0.1577577,6.2586937,9.7641573,1006.9951937,2472.1037057,0.4622187,253.1814703,160.8954274,355.4631087,12.89064,19.0715653,2.8911496,51.6594103),(41917,'radius ulna',253,4,79,111.9469463,83.4751412,142.4486085,1.8,83.4306419,142.5852461,0.1562849,6.2540825,9.7542423,991.2369827,2449.8443335,0.4520184,251.1568043,158.4943877,352.4394358,12.460952,19.0715653,2.8911496,51.3034451),(41918,'radius ulna',253,4,80,111.3597054,83.4985401,142.621022,1.8,83.461051,142.757995,0.1548551,6.1988894,9.7370587,970.4556373,2435.8282933,0.4415234,250.1605831,156.553145,349.7645136,12.031264,18.9696424,2.913096,51.1991853),(41919,'radius ulna',253,4,81,111.0226685,83.5348299,142.7667157,1.8,83.4578669,142.886606,0.1520157,6.1245435,9.7293635,949.1097478,2417.889623,0.4243162,248.5146767,154.968243,346.0555055,12.031264,18.9696424,2.913096,50.9474799),(41920,'radius ulna',253,4,82,110.2487256,83.5521185,142.9507019,1.8,83.5312565,143.100155,0.1540841,6.0158644,9.4818045,934.9923751,2397.0215557,0.4328109,252.802254,155.4211193,349.4756869,12.031264,18.8916179,2.8414215,50.8432201),(41921,'radius ulna',253,4,83,109.8450534,83.5493365,143.1310481,1.8,83.5054295,143.2488853,0.1506865,6.054606,9.4381736,923.0665917,2379.8984494,0.4125614,252.1566722,152.4569227,348.7524701,12.031264,18.7690551,2.863293,50.5915147),(41922,'radius ulna',253,4,84,109.0683131,83.519291,143.3053906,1.8,83.4968989,143.423716,0.1443167,5.9444619,9.3665229,904.1137894,2352.3592611,0.375979,251.1454116,152.0934625,346.9669936,12.031264,18.7690551,2.863293,50.8432201),(41923,'radius ulna',253,4,85,108.3488087,83.497267,143.4783823,1.8,83.4906254,143.5909989,0.1401899,5.9551725,9.3063024,887.1320688,2325.0270175,0.3525817,249.8335997,148.9683234,344.8649638,12.031264,18.6555863,2.8854413,50.5915147),(41924,'radius ulna',253,4,86,108.2354,83.4760087,143.6616618,1.8,83.4549582,143.7737884,0.1343673,5.8143468,9.3073905,872.40719,2316.5376382,0.3237355,248.8922801,150.0438853,341.8590747,12.031264,18.6555863,2.8854413,50.5915147),(41925,'radius ulna',253,4,87,106.9854988,83.4502595,143.8338557,1.8,83.431704,143.9482582,0.1283623,5.8273285,9.24498,856.601451,2293.0537898,0.2921877,248.0323157,146.9972816,340.3250296,11.601576,18.6555863,2.8854413,49.9838441),(41926,'radius ulna',253,4,88,106.0692217,83.4121902,144.0084979,1.8,83.4006173,144.1091261,0.120992,5.8000855,9.1730062,841.2722794,2276.0197438,0.2575321,248.1214671,145.0448058,339.710335,11.601576,18.5513782,2.9078495,50.2355495),(41927,'radius ulna',253,4,89,105.2288114,83.3590238,144.1586126,1.8,83.3440425,144.2867991,0.1158989,5.7342263,9.13618,825.2411108,2262.4831934,0.234529,247.6399533,143.9149891,337.5598046,11.601576,18.5513782,2.9078495,50.2355495),(41928,'radius ulna',253,4,90,104.6690974,83.3239117,144.3482196,1.8,83.3299192,144.446939,0.1129133,5.6244319,9.0728604,810.6003315,2252.7443053,0.2214679,248.2948273,144.1212809,337.5188127,11.5948783,18.4565877,2.9304993,50.2355495),(41929,'radius ulna',253,4,91,103.826617,83.2921084,144.5337991,1.8,83.2713671,144.6719919,0.1118159,5.7215246,9.0616929,793.66985,2243.5571229,0.2154538,247.5869745,138.7164963,334.7789585,11.171888,18.5513782,2.9078495,49.8795843),(41930,'radius ulna',253,4,92,103.3203902,83.2527976,144.7161222,1.8,83.2176608,144.8185644,0.1079893,5.6197437,9.0405144,777.1832651,2242.4876008,0.2000357,248.048673,138.2951442,333.1302237,11.4658321,18.5513782,2.9078495,49.9838441),(41931,'radius ulna',253,4,93,103.491874,83.2060726,144.9118696,1.8,83.2103869,145.0213618,0.1052272,5.4759263,8.9676203,762.9159535,2250.1957967,0.1902863,250.9245164,139.3218078,331.4932867,11.171888,18.5513782,2.9078495,50.1312897),(41932,'radius ulna',253,4,94,103.0187131,83.1402116,145.0942633,1.8,83.1535602,145.2354842,0.1005863,5.5929309,9.0414485,750.5067138,2250.838304,0.1731322,248.946648,134.1884467,325.4285094,11.171888,18.6555863,2.8854413,50.1312897),(41933,'radius ulna',253,4,95,102.2018014,83.0599443,145.2654147,1.8,83.0734892,145.3915728,0.094958,5.4813052,9.0947415,732.6902938,2247.0702408,0.1531316,247.0735695,133.6707716,322.1050558,11.171888,18.6555863,2.8854413,49.8795843),(41934,'radius ulna',253,4,96,102.2250202,83.0028602,145.445137,1.8,83.037927,145.5546471,0.0911394,5.3770313,9.128702,717.1944063,2263.2458735,0.1411287,247.9263618,133.3811114,321.4400355,10.7422,18.5513782,2.9078495,49.7753245),(41935,'radius ulna',253,4,97,101.3226744,82.911088,145.6085075,1.8,82.9200735,145.6817108,0.0863028,5.4001369,9.235518,698.0994504,2261.6895677,0.1254663,244.8903851,129.2743986,314.2714644,10.7422,18.6555863,2.8854413,50.0270299),(41936,'radius ulna',253,4,98,101.12551,82.8271576,145.7977113,1.8,82.8899358,145.9614129,0.0818166,5.3838684,9.2953365,687.0289726,2264.2846354,0.1125702,243.5936171,127.6087984,312.3799639,10.7422,18.6555863,2.8854413,49.7753245),(41937,'radius ulna',253,4,99,100.1790204,82.7466046,145.9740745,1.8,82.8103453,146.1274211,0.0781377,6.363132,9.3555944,670.3755178,2259.652944,0.1017331,241.5295956,105.3530742,309.0116298,10.7422,18.6555863,2.8854413,50.0270299),(41938,'radius ulna',253,4,100,99.5678332,82.6442468,146.1435319,1.8,82.7051521,146.25542,0.0728035,5.2128473,9.4369928,653.2343105,2258.0604484,0.0878021,239.2775435,125.3123827,305.0822258,10.312512,18.7198054,2.9802175,50.2787353),(41939,'radius ulna',253,4,101,99.6103545,82.5378846,146.3219286,1.8,82.5641851,146.4570913,0.0686119,5.331663,9.554314,643.0472331,2262.7800471,0.0780317,236.8333343,120.6091295,299.4396436,10.7422,18.8769524,2.9352688,50.7389603),(41940,'radius ulna',253,4,102,98.8851433,82.4227212,146.5020017,1.8,82.5259749,146.6783933,0.0646117,5.1771677,9.6507372,630.7304304,2263.4758583,0.0687065,234.5391674,121.8292438,296.099356,10.312512,18.8769524,2.9352688,50.0270299),(41941,'radius ulna',253,4,103,98.2704873,82.3067183,146.6759811,1.8,82.3903467,146.8352175,0.0576108,5.3555615,9.7454411,620.2685401,2275.5415436,0.0542999,233.4980546,115.8176489,293.9651041,10.7422,18.8769524,2.9352688,50.6347005),(41942,'radius ulna',253,4,104,97.8864532,82.1909824,146.8460416,1.8,82.2723514,146.9994403,0.0508303,5.3344965,9.8205856,608.3781873,2279.0612551,0.0421156,232.0697915,114.0460369,292.796142,10.7422,18.7936316,2.9576492,50.8864059),(41943,'radius ulna',253,4,105,96.6893679,82.0637721,146.9703729,1.8,82.1470847,147.0951976,0.0462417,5.1681096,9.9575488,594.061318,2286.3625328,0.0344338,229.6109796,114.9475074,287.0436107,10.312512,19.0279509,3.0284417,51.1381113),(41944,'radius ulna',253,4,106,96.2770795,81.9619799,147.1370223,1.8,82.0195369,147.3054426,0.0415387,5.2863481,10.0285346,585.7760491,2305.9129295,0.0276711,229.9351825,110.8092089,287.6670411,10.7422,19.2162315,0.1798535,52.1017471),(41945,'radius ulna',253,4,107,95.4257592,81.8347541,147.2987013,1.8,81.9687185,147.4846735,0.038267,5.0942123,9.7671155,572.0726554,2299.0111178,0.0232782,235.3828126,112.2985512,288.762379,10.312512,19.0715653,0.2504431,50.5304407),(41946,'radius ulna',253,4,108,95.0061975,81.6760893,147.4532099,1.8,81.7454004,147.6317245,0.0344215,5.3356232,9.9131425,560.7816315,2312.479997,0.0187537,233.2741608,105.1014314,285.4887633,10.6697,19.2977277,0.2017623,51.2423711),(41947,'radius ulna',253,4,109,94.9186372,81.5600181,147.6046373,1.8,81.6840876,147.7712983,0.0336328,5.3197861,10.0226823,549.6297872,2328.0705263,0.017888,232.2801882,103.3180244,283.5697746,10.7356561,19.3884063,0.2234766,51.8500417),(41948,'radius ulna',253,4,110,94.1122999,81.4289488,147.7509383,1.8,81.6064257,147.9160594,0.0330226,5.0845499,10.1478773,536.5312482,2326.2014584,0.0170986,229.2303493,105.521876,279.2797221,10.312512,19.4881391,0.2449787,51.7457819),(41949,'radius ulna',253,4,111,93.5471029,81.2803408,147.8913465,1.8,81.4162938,148.0648363,0.0309224,5.3031394,10.2757285,525.1553683,2318.4695978,0.0149034,225.625813,99.027261,275.692833,10.6697,19.6391391,0.1759396,52.4577123),(41950,'radius ulna',253,4,112,92.8202691,81.1633674,148.0222949,1.8,81.2906417,148.1918385,0.0324579,5.2948778,10.0021214,511.0715365,2307.7588237,0.0162922,230.726937,96.5218749,276.1113092,10.6697,19.4881391,0.2449787,52.1017471),(41951,'radius ulna',253,4,113,91.5923559,81.0770345,148.1372276,1.8,81.2450769,148.3135448,0.0352548,5.0965928,10.1051754,494.0375975,2313.9598198,0.0189655,228.987595,96.9348777,270.7812284,10.312512,19.4881391,0.2449787,51.3898167),(41952,'radius ulna',253,4,114,91.1003402,81.0161527,148.2686668,1.8,81.1144555,148.4148549,0.0375481,5.137835,10.5473882,482.1677264,2336.4168858,0.0213964,221.5161563,93.8464793,266.3314176,10.312512,19.9330777,0.1297025,52.3534525),(41953,'radius ulna',253,4,115,90.2162337,80.899257,148.403747,1.8,81.0453692,148.5814511,0.0403709,5.290375,10.6611434,470.456689,2338.2180839,0.0244925,219.3215119,88.9269073,262.8869055,10.5988816,19.9330777,0.1297025,52.8136775),(41954,'radius ulna',253,4,116,89.2211803,80.7736903,148.5335387,1.8,80.9292952,148.724513,0.0422435,5.187044,10.4075388,457.3340743,2334.0968592,0.0265203,224.2698199,88.1685362,264.0768976,10.2749224,19.8076381,0.2186689,52.1017471),(41955,'radius ulna',253,4,117,88.2350229,80.6423299,148.6593371,1.8,80.833012,148.8070175,0.0446719,5.0870561,10.5376099,447.7847459,2328.9544027,0.0293271,221.0135334,88.0243388,260.1739109,10.2932771,19.8076381,0.2186689,52.1017471),(41956,'radius ulna',253,4,118,87.6529852,80.5094007,148.7853612,1.8,80.6717948,148.943262,0.0455323,5.1591381,10.6856753,438.5608386,2329.9831564,0.030266,218.0473476,85.0066099,254.750731,10.2932771,20.0623347,0.1721908,52.4577123),(41957,'radius ulna',253,4,119,87.5325269,80.3739173,148.9092496,1.8,80.5720907,149.0969439,0.0460072,5.2310616,10.7964952,431.4313856,2331.6746383,0.0308577,215.9658852,82.4749202,253.752477,10.2749224,20.0623347,0.1721908,52.5619721),(41958,'radius ulna',253,4,120,87.0017385,80.2377563,149.0269913,1.8,80.4641426,149.1955637,0.0478804,5.1399766,10.9294986,424.2675909,2331.7873104,0.033217,213.3480587,82.5427081,250.4764197,10.2749224,20.0623347,0.1721908,52.4577123),(41959,'radius ulna',253,4,121,85.9222581,80.0778978,149.1018328,1.8,80.2732379,149.2682401,0.0471023,5.0825965,10.6959152,415.9773613,2315.6979049,0.031748,216.5030175,81.843475,250.7122822,10.2932771,20.1404075,0.1932115,52.2060069),(41960,'radius ulna',253,4,122,85.4155837,79.9670993,149.2082849,1.8,80.1904549,149.3680445,0.0486701,5.1289491,10.8046462,405.4870947,2302.0815053,0.0336951,213.0640334,79.0585143,246.6159225,10.2408134,20.0623347,0.1721908,52.4577123),(41961,'radius ulna',253,4,123,84.8289023,79.8293131,149.3097149,1.8,80.0499486,149.4736966,0.051813,4.9082889,10.9430642,396.673214,2282.1311777,0.0379211,208.5459002,80.8170066,241.5281819,9.882824,20.3592323,0.1269728,53.0653829),(41962,'radius ulna',253,4,124,84.2973865,79.7235466,149.4054067,1.8,79.9585488,149.5712807,0.0565549,4.9362601,11.0516926,387.1787959,2270.4937312,0.044889,205.4430759,78.4356553,237.8328263,9.882824,20.3592323,0.1269728,53.0653829),(41963,'radius ulna',253,4,125,83.4449472,79.6014495,149.5006838,1.8,79.8251369,149.6271547,0.0594844,5.0077818,11.1471583,378.4023265,2253.1839548,0.0491522,202.1307937,75.5628629,234.9588803,9.882824,20.3592323,0.1269728,53.0653829),(41964,'radius ulna',253,4,126,82.8526708,79.5080619,149.598446,1.8,79.6670495,149.7612959,0.0640623,4.7277307,10.8651723,368.323627,2232.8060455,0.0565934,205.5012087,77.9070655,236.1136956,9.453136,20.3592323,0.1269728,52.4577123),(41965,'radius ulna',253,4,127,82.284005,79.3815942,149.6798831,1.8,79.574072,149.8311412,0.0672841,4.7847699,10.9916835,358.8723111,2212.9545709,0.0619918,201.3299021,75.0030441,231.2475866,9.453136,20.3592323,0.1269728,52.1017471),(41966,'radius ulna',253,4,128,81.2796081,79.2659809,149.7608282,1.8,79.4752739,149.8976225,0.0717206,4.8362835,11.0778175,349.7368617,2191.5106214,0.0695622,197.8287348,72.3152114,228.2193452,9.453136,20.2683424,3.0566909,52.4577123),(41967,'radius ulna',253,4,129,79.8566006,79.1089036,149.8104679,1.8,79.2984878,149.9397718,0.0742053,4.8609798,10.8687573,337.9520918,2131.5895002,0.073153,196.1208105,69.5234509,223.7209943,9.453136,19.9931938,2.9905773,51.5983363),(41968,'radius ulna',253,4,130,79.5894441,78.966524,149.8882173,1.8,79.1839498,150.0255652,0.077178,4.8437295,10.9441438,330.1177809,2091.3470372,0.0788549,191.0927967,68.1536361,220.4266084,9.453136,20.2136123,0.0425275,51.9543015),(41969,'radius ulna',253,4,131,79.0052244,78.8168924,149.9630607,1.8,79.0063164,150.107077,0.0802594,4.7092506,10.7307649,322.3451086,2054.9524008,0.0846377,191.5010182,68.4493423,218.7436953,9.453136,19.8820682,3.0333221,51.3466309),(41970,'radius ulna',253,4,132,78.3129671,78.6626643,150.0343703,1.8,78.8236148,150.1800763,0.0823719,4.7067081,10.8822151,316.5858051,2016.5333292,0.0883604,185.3054092,67.2626809,212.0748059,9.453136,19.9330777,3.0118901,51.0949255),(41971,'radius ulna',253,4,133,77.7378671,78.5269216,150.105407,1.8,78.6683666,150.2672721,0.0851167,4.7161213,10.6242162,310.9053988,1976.3476399,0.0936402,186.022912,65.9239611,211.6876313,9.453136,19.6391391,2.965653,50.3829951),(41972,'radius ulna',253,4,134,77.1514094,78.3697451,150.1686718,1.8,78.526227,150.3204766,0.0891492,4.7466849,10.7447276,306.1969123,1937.2865464,0.101924,180.3011316,64.5075293,206.9997046,9.453136,19.8402356,3.0548543,50.4872549),(41973,'radius ulna',253,4,135,76.3391974,78.1847536,150.226923,1.8,78.3013958,150.3641339,0.0904655,4.7407185,10.5364475,300.2640899,1880.8208111,0.1038429,178.5061634,63.3372538,204.0558189,9.453136,19.507078,3.0090411,49.8795843),(41974,'radius ulna',253,4,136,76.0522908,78.0297516,150.2990033,1.8,78.1812121,150.4543669,0.093692,4.5502733,10.6495714,295.9964413,1853.8986453,0.1109417,174.0819957,65.050256,200.5011021,9.023448,19.507078,3.0090411,49.8795843),(41975,'radius ulna',253,4,137,76.1587618,77.8866016,150.3280503,1.8,78.0428481,150.4813895,0.0999453,4.5435141,10.4549173,291.9232281,1840.0053287,0.1263708,175.9942498,64.2505389,200.1507198,9.023448,19.507078,3.0090411,49.8795843),(41976,'radius ulna',253,4,138,75.6121958,77.7570285,150.3924333,1.8,77.9198309,150.5444795,0.1063309,4.5664392,10.5897235,287.8784309,1825.2055572,0.1419458,172.3563004,63.0422132,196.4273754,9.023448,19.5685029,2.9872739,49.6278789),(41977,'radius ulna',253,4,139,75.3461023,77.6212643,150.4545746,1.8,77.7803386,150.605644,0.1112904,4.5867321,10.6792827,284.4273363,1794.4923438,0.1548929,168.0349135,62.0108887,193.1615206,9.023448,19.5685029,2.9872739,49.6278789),(41978,'radius ulna',253,4,140,74.8287417,77.4557839,150.5108317,1.8,77.5994142,150.6463742,0.114682,4.6052754,10.4640143,280.9749637,1754.519409,0.1633063,167.6717325,61.0115436,192.0013815,9.023448,19.2162315,2.9617392,48.9159485),(41979,'radius ulna',253,4,141,74.1439256,77.3365128,150.5626765,1.8,77.4665181,150.7160543,0.1212475,4.5515428,10.587085,274.985629,1734.7032339,0.1807759,163.8508834,60.4159168,187.7790499,9.1679101,19.507078,3.0090411,49.3761735),(41980,'radius ulna',253,4,142,74.2342833,77.1858054,150.6143895,1.8,77.3324324,150.77866,0.125775,4.4035207,10.3647084,270.3617177,1710.357582,0.1946931,165.0174333,61.3967179,187.876273,8.7984674,19.2162315,2.9617392,48.4125377),(41981,'radius ulna',253,4,143,73.5654687,77.0185886,150.6528857,1.8,77.2031914,150.7972616,0.1284382,4.397964,10.4756808,264.5881917,1665.5967888,0.2011507,158.9965199,60.1615184,182.5942678,8.7834715,19.2162315,2.9617392,47.9091269),(41982,'radius ulna',253,4,144,73.224795,76.8895765,150.6986824,1.8,77.0569486,150.8263297,0.1342025,4.4516617,10.2370591,260.767789,1636.3287103,0.2184838,159.8436324,58.5776298,182.5895396,8.7834715,18.8769524,2.9352688,47.8048671),(41983,'radius ulna',253,4,145,73.0261201,76.7440797,150.7093132,1.8,76.8827593,150.8440325,0.137864,4.4178211,10.3270971,256.7873283,1602.4759009,0.2298663,155.1719603,58.1253347,178.6654341,8.7684757,19.0812438,3.0060649,47.9091269),(41984,'radius ulna',253,4,146,71.8372593,76.5889881,150.7440427,1.8,76.7013035,150.8750304,0.1404345,4.4092782,10.1137496,252.0343767,1550.2298182,0.2345792,153.2794345,57.160008,175.7760228,8.7780168,18.7936316,2.9576492,47.0497509),(41985,'radius ulna',253,4,147,71.4286635,76.460599,150.7817301,1.8,76.6068519,150.8943198,0.1429514,4.4597471,10.1784539,248.9234718,1519.4939418,0.2416227,149.2853391,55.8156021,172.5876107,8.7930127,18.7936316,2.9576492,47.0497509),(41986,'radius ulna',253,4,148,71.0261663,76.3175028,150.8221932,1.8,76.4588713,150.9444106,0.1472693,4.4493859,9.9570734,245.2924045,1485.2741984,0.2548882,149.1677458,55.129497,171.702991,8.8846357,18.5513782,2.9078495,46.7980455),(41987,'radius ulna',253,4,149,70.1897843,76.1528596,150.8458182,1.8,76.2532509,150.9555328,0.1491777,4.4290948,9.758286,241.0881785,1442.4024675,0.2584082,147.8130962,54.4328334,169.0606716,8.7730079,18.3713606,2.9533711,46.4420803),(41988,'radius ulna',253,4,150,69.9534556,76.0163122,150.8731397,1.8,76.1514728,150.9982195,0.1518578,4.4050329,9.82941,238.4264682,1418.5147479,0.2668034,144.3133157,54.1259221,166.6775345,8.8425877,18.3713606,2.9533711,46.1903749),(41989,'radius ulna',253,4,151,69.6069633,75.884123,150.9067821,1.8,75.9985487,151.0398441,0.1543343,4.3855741,9.5999766,236.1020945,1386.7631609,0.2741419,144.4548483,53.8360746,165.8386017,8.8425877,18.1336482,2.9023611,45.5827043),(41990,'radius ulna',253,4,152,69.1449923,75.7528126,150.9360871,1.8,75.869117,151.0631105,0.1566847,4.2714453,9.6624898,232.9526301,1356.902589,0.2806117,140.4299123,54.5371913,162.8346566,8.5338405,18.1336482,2.9023611,44.9750337),(41991,'radius ulna',253,4,153,68.1269438,75.6125096,150.91682,1.8,75.7595434,151.0573855,0.1595533,4.2711417,9.45209,228.9458633,1320.0661058,0.2866096,139.6586473,53.6029656,160.7866148,8.5518645,17.8255796,2.8732264,44.6190685),(41992,'radius ulna',253,4,154,67.4977971,75.4663919,150.9299352,1.8,75.6064059,151.0561697,0.1609909,4.2370321,9.5280072,225.4646742,1285.5825487,0.2890587,134.9266976,53.212878,156.9312129,8.521891,17.9494415,2.9488919,44.7233283),(41993,'radius ulna',253,4,155,66.8285908,75.3280989,150.9407473,1.8,75.4458094,151.0440419,0.1603147,4.2707255,9.3062719,222.1971321,1246.6941454,0.283814,133.9627899,52.0279586,154.7921462,8.521891,17.7164901,2.896614,44.1156577),(41994,'radius ulna',253,4,156,66.0917422,75.2002546,150.9497885,1.8,75.2797244,151.0360653,0.1614197,4.2988011,9.3639865,217.9221112,1206.0650672,0.2845336,128.7982488,50.6936943,150.4185782,8.521891,17.7164901,2.896614,43.8639523),(41995,'radius ulna',253,4,157,65.2115521,75.077787,150.9584586,1.8,75.1502865,151.0379205,0.1617132,4.2575579,9.1289703,214.2597077,1172.4261256,0.2817571,128.4291758,50.3245549,148.8609943,8.4919175,17.4116449,2.8666828,43.5079871),(41996,'radius ulna',253,4,158,64.8137546,74.9444354,150.9586017,1.8,75.0229301,151.0197205,0.1613758,4.2796133,9.1908996,212.3021163,1141.1278142,0.2788813,124.1584469,49.6077798,145.5516893,8.3624716,17.4116449,2.8666828,43.1520219),(41997,'radius ulna',253,4,159,64.2618174,74.8307029,150.9571292,1.8,74.8878339,151.0127168,0.1627179,4.225209,8.9508518,210.519318,1110.004607,0.2810839,124.0110587,49.8245924,144.3945137,8.3437289,17.1229455,2.8357138,42.5443513),(41998,'radius ulna',253,4,160,63.5551813,74.7208949,150.9574259,1.8,74.8189409,151.0141176,0.163401,4.24225,8.9905286,209.0997329,1080.7998467,0.2803113,120.2153842,49.2898184,141.6984865,8.3437289,17.1067638,2.939271,42.6486111),(41999,'radius ulna',253,4,161,62.9914389,74.612404,150.8964633,1.8,74.6621541,150.966551,0.1648492,4.1977047,8.7562612,208.2900599,1051.6693641,0.2827265,120.1048416,49.6199892,140.4481813,8.3437289,16.8840595,2.8842689,42.2926459),(42000,'radius ulna',253,4,162,62.4891286,74.5081798,150.8967408,1.8,74.5655516,150.9541859,0.1661293,4.2134,8.7904389,207.16086,1023.6904672,0.2848043,116.4549886,49.1671482,138.0302564,8.3437289,16.8840595,2.8842689,42.0409405),(42001,'radius ulna',253,4,163,62.0362772,74.4007039,150.8959942,1.8,74.4160563,150.945587,0.1668063,4.2296159,8.4738357,207.3138833,994.9370751,0.2850282,117.4128355,49.0148252,139.5716769,8.5915971,16.4688822,2.8776289,41.7892351),(42002,'radius ulna',253,4,164,61.3956049,74.2812172,150.8869522,1.8,74.3174429,150.9598463,0.1675638,4.2397082,8.5226624,206.7684359,961.3515625,0.2846281,112.7994423,48.7694966,135.9212761,8.59376,16.4688822,2.8776289,41.7892351),(42003,'radius ulna',253,4,165,60.5898271,74.1848712,150.8831716,1.8,74.1665141,150.9292897,0.1677473,4.2518654,8.2665748,205.5510067,929.2558905,0.2815024,112.4112355,48.3437244,134.8140621,8.59376,16.1747714,2.8450468,40.9298591),(42004,'radius ulna',253,4,166,60.3500855,74.1097238,150.8782607,1.8,74.0804269,150.9154467,0.1708312,4.2566893,8.2732711,206.205332,911.0190046,0.2906914,110.1159371,48.4426554,133.797226,8.59376,16.1747714,2.8450468,40.3221885),(42005,'radius ulna',253,4,167,60.1467108,74.0257007,150.8715053,1.8,74.0127578,150.9269098,0.1738827,4.1873426,8.0117374,207.6802718,888.8106937,0.3000488,110.9385697,49.5971533,134.2272413,8.59376,15.898456,2.8112953,40.2179287),(42006,'radius ulna',253,4,168,59.9455181,73.9460944,150.8634945,1.8,73.9485873,150.9209345,0.1778178,4.1884186,8.0217148,208.8651769,873.2208599,0.3125889,108.8571313,49.8673123,133.566336,8.59376,15.7643386,2.8370818,39.9662233),(42007,'radius ulna',253,4,169,59.717358,73.8453807,150.7740854,1.8,73.81317,150.8405669,0.1806216,4.1922816,7.9856207,210.4858754,852.7792229,0.3211892,106.7893473,50.2079528,133.0297019,8.59376,15.7584815,2.9495446,40.0704831),(42008,'radius ulna',253,4,170,59.7343665,73.7596796,150.7579391,1.8,73.7470135,150.820488,0.1833906,4.1900706,7.8079662,213.0446357,841.6544985,0.3310952,107.794332,50.8451189,133.414514,8.59376,15.6408793,2.863293,39.7145179),(42009,'radius ulna',253,4,171,59.7311215,73.6832043,150.7398574,1.8,73.6712999,150.8002959,0.186119,4.1847237,7.8103019,215.6655121,821.6971635,0.3408869,105.2068375,51.5363809,132.1326256,8.59376,15.5283322,2.8899027,39.2111071),(42010,'radius ulna',253,4,172,59.3849649,73.6058307,150.7197841,1.8,73.580001,150.7692184,0.1883606,4.2586841,7.5502046,217.5874918,799.7022756,0.3470269,105.9179607,51.0926578,132.8184327,8.59376,15.2281815,2.8555412,39.1068473),(42011,'radius ulna',253,4,173,58.8783465,73.5489091,150.6995131,1.8,73.5343188,150.7262653,0.1918308,4.2615664,7.5324477,220.0763839,779.0316088,0.3567036,103.4234343,51.6421342,131.8061955,8.8758314,15.1125613,2.8828218,39.2111071),(42012,'radius ulna',253,4,174,58.2566969,73.5028317,150.6727726,1.8,73.464464,150.6750926,0.1964286,4.3179677,7.5028199,222.6751047,756.7855145,0.3698379,100.8668109,51.5694234,130.3511431,8.9356324,15.0083566,2.910502,39.2111071),(42013,'radius ulna',253,4,175,58.1756267,73.4465379,150.6369576,1.8,73.3797012,150.6208433,0.1989222,4.3744878,7.2297775,225.6118583,735.5778478,0.3786347,101.7428057,51.5744631,131.8819085,8.9954334,14.6975909,2.8753406,38.6034365),(42014,'radius ulna',253,4,176,57.923968,73.4013813,150.6055761,1.8,73.3677827,150.6233758,0.2030626,4.3474814,7.2840882,227.6232301,719.9010821,0.3926355,98.8320111,52.3574937,129.071162,8.9954334,14.6975909,2.8753406,38.6034365),(42015,'radius ulna',253,4,177,57.1372128,73.3443718,150.5141768,1.8,73.3245534,150.5295967,0.2048275,4.3547609,7.2726988,228.8060507,696.7958088,0.3939692,95.8097984,52.5415874,126.898508,8.9954334,14.5904229,2.9037567,38.1000257),(42016,'radius ulna',253,4,178,56.4357799,73.2826294,150.4730073,1.8,73.2609615,150.5070685,0.206597,4.3257635,7.1662643,230.2611996,674.2135573,0.395789,94.081593,53.2301868,126.124121,8.9954334,14.4121737,2.9617392,38.1000257),(42017,'radius ulna',253,4,179,55.7252833,73.2270733,150.4285279,1.8,73.1622838,150.4736623,0.2058574,4.3819331,6.9849826,230.8267006,649.1308371,0.3880525,92.9323486,52.6769106,125.3547565,9.023448,14.1731921,2.896614,37.2406497),(42018,'radius ulna',253,4,180,54.8635564,73.1858568,150.37626,1.8,73.1469073,150.4070308,0.2066565,4.356641,6.9484351,232.1099772,629.1400603,0.3849812,90.5441377,53.2772794,123.8222205,9.1783809,13.9962251,2.8295505,37.8483203),(42019,'radius ulna',253,4,181,53.9553919,73.1434163,150.3280409,1.8,73.0670063,150.3271748,0.2077929,4.45494,6.9116179,233.4178253,612.5926776,0.3827236,88.6323127,52.3952794,122.3967832,9.3013377,13.9168507,2.9865959,37.5966149),(42020,'radius ulna',253,4,182,53.6474485,73.0898476,150.2758463,1.8,73.0318677,150.2745001,0.2082087,4.4143312,6.7320183,234.221357,599.8473662,0.3820417,89.1036448,53.0593076,122.8244997,9.2415367,13.7298596,2.7901479,37.2406497),(42021,'radius ulna',253,4,183,53.2459023,73.0381688,150.2117253,1.8,72.9681839,150.2126585,0.203839,4.4551246,6.7046673,235.0261252,585.9869923,0.3636522,87.3998617,52.7541077,122.0410086,9.2779422,13.5879276,2.8198421,36.9889443),(42022,'radius ulna',253,4,184,53.2772338,72.9867985,150.1484013,1.8,72.9348675,150.1541602,0.2028361,4.4909194,6.6806242,237.3464807,574.603458,0.3603435,86.0104453,52.8503094,121.4891446,9.023448,13.5675304,2.9504082,36.6329791),(42023,'radius ulna',253,4,185,52.7974709,72.9494747,150.0396703,1.8,72.8859401,150.0968029,0.2008679,4.4783776,6.6527742,237.6009181,558.8978488,0.3502951,84.0097432,53.0551323,119.7050757,9.023448,13.4924769,2.9816795,36.3812737),(42024,'radius ulna',253,4,186,52.4940034,72.8974533,149.9824149,1.8,72.8357421,149.994653,0.2024563,4.5081609,6.466936,239.8669282,545.7904792,0.353736,84.3970742,53.2072691,120.466667,9.3802393,13.3272566,2.7790484,36.3812737),(42025,'radius ulna',253,4,187,52.3621875,72.8452788,149.9233515,1.8,72.7850208,149.9342004,0.2021982,4.5474957,6.4433995,242.3468839,536.8835617,0.351961,83.3230289,53.2923835,120.6113081,9.453136,13.1809902,2.8095332,36.6329791),(42026,'radius ulna',253,4,188,52.3548582,72.8043518,149.8641466,1.8,72.7046509,149.8710307,0.1981926,4.5867427,6.4086352,243.8635652,523.6092928,0.3382882,81.7037138,53.1670471,119.7326703,9.453136,13.0684503,2.976444,36.3812737),(42027,'radius ulna',253,4,189,51.9969523,72.7652789,149.8042345,1.8,72.6933626,149.8187779,0.1963554,4.6206653,6.4584023,245.2732589,513.0746614,0.3298556,79.4429703,53.0818065,117.3698069,9.453136,13.0684503,2.976444,36.3812737),(42028,'radius ulna',253,4,190,51.5237354,72.741459,149.7444476,1.8,72.6561701,149.7675262,0.1885383,4.5677762,6.4107927,245.7523961,501.4883018,0.3016499,78.2256303,53.8013214,116.5366589,9.453136,13.0047187,3.0090411,36.6329791),(42029,'radius ulna',253,4,191,51.1595073,72.699845,149.6752537,1.8,72.6181882,149.6780127,0.1873036,4.6098133,6.2025684,247.3653937,490.5644111,0.2956533,79.0905285,53.6606095,117.8319833,9.5881412,12.7755427,2.7985687,36.3812737),(42030,'radius ulna',253,4,192,50.8521793,72.6757215,149.6137221,1.8,72.6163479,149.5794751,0.1877625,4.7134369,6.1579435,249.1505605,479.6065068,0.2953019,77.8842005,52.8596359,117.9626264,9.453136,12.6375032,2.8305944,35.6693433),(42031,'radius ulna',253,4,193,50.30483,72.6458255,149.4921278,1.8,72.6116795,149.4782955,0.1822311,4.6823544,6.1286743,249.5387081,467.6284054,0.2753535,76.3017224,53.2934266,116.9420552,9.453136,12.5789281,3.0045265,35.5218977),(42032,'radius ulna',253,4,194,50.1176246,72.6190593,149.4338908,1.8,72.5931947,149.4434491,0.1780492,4.6316402,6.1643524,249.8591891,459.6724818,0.2620145,74.5694681,53.9461572,114.9667132,9.453136,12.5127034,2.863293,35.4176379),(42033,'radius ulna',253,4,195,49.583703,72.5992443,149.3671915,1.8,72.5332026,149.3754286,0.1732035,4.6452833,6.1197899,249.4091926,451.8867864,0.2454447,73.840245,53.6908465,114.5932581,9.453136,12.5127034,2.863293,35.4176379),(42034,'radius ulna',253,4,196,48.846239,72.585062,149.3018294,1.8,72.5218907,149.3123303,0.1649343,4.7945415,6.144563,249.9915624,443.4467354,0.2194624,72.1689621,52.140869,112.844109,9.882824,12.5127034,2.863293,35.5218977),(42035,'radius ulna',253,4,197,48.2054548,72.5603725,149.2297159,1.8,72.4965411,149.2262695,0.1554011,4.804855,6.1125575,249.6904521,434.1385109,0.1924661,71.0240372,51.9662823,111.8021807,9.882824,12.4015431,2.896614,35.5218977),(42036,'radius ulna',253,4,198,47.6639242,72.5360404,149.1616026,1.8,72.4281317,149.1512035,0.1475191,4.7463878,6.0850022,248.5307287,425.2061783,0.1716258,69.8777363,52.3620777,110.3027572,9.8630236,12.3043918,2.9304993,35.2701923),(42037,'radius ulna',253,4,199,47.1783986,72.5216714,149.0946347,1.8,72.4469629,149.0684572,0.1341516,4.7473201,5.8038584,247.9672877,418.5150886,0.1406619,72.109803,52.2331084,114.3680895,9.453136,12.1001239,2.8535372,34.8099673),(42038,'radius ulna',253,4,200,46.8098624,72.5066694,149.0268812,1.8,72.4577295,149.0136451,0.1248322,4.7362865,5.8220385,248.3895728,412.6615728,0.1209435,70.8792242,52.4439497,112.8545035,9.453136,12.1001239,2.8535372,34.8099673),(42039,'radius ulna',253,4,201,46.3182383,72.4891709,148.8770826,1.8,72.3984859,148.843529,0.1202115,4.8083165,5.8028077,247.1877258,404.5817727,0.1110197,69.7217263,51.4083724,112.0656101,9.882824,12.1001239,2.8535372,34.9142271),(42040,'radius ulna',253,4,202,46.0522007,72.4847135,148.810458,1.8,72.3871173,148.7945338,0.1125163,4.8490989,5.7632922,248.4396873,398.0778187,0.0967601,69.0712541,51.2341971,112.169175,9.882824,11.9851376,2.8879186,34.9142271),(42041,'radius ulna',253,4,203,45.8309782,72.4847209,148.7330647,1.8,72.3950196,148.7006939,0.1034138,4.820047,5.7703586,248.9145244,394.1088455,0.0813984,68.2988478,51.6415144,111.366178,9.882824,11.9851376,2.8879186,35.1659325),(42042,'radius ulna',253,4,204,45.3910511,72.4938282,148.6443397,1.8,72.3994441,148.5964547,0.0917845,4.7691621,5.7666619,248.4151955,391.6086374,0.0635533,67.9090678,52.0878072,110.7711794,9.882824,11.9851376,2.8879186,34.9142271),(42043,'radius ulna',253,4,205,44.828036,72.4948809,148.5662748,1.8,72.4099052,148.5344681,0.0801072,4.684539,5.7328776,248.3564789,386.6216155,0.0478423,67.439363,53.0162044,110.2364236,9.453136,11.9851376,0.2536741,34.3065565),(42044,'radius ulna',253,4,206,44.3404403,72.504351,148.4822678,1.8,72.4301011,148.443619,0.0731347,4.9300536,5.7288953,249.1145335,380.3243598,0.0394567,66.387033,50.5297819,109.6952725,9.882824,11.8845829,2.9229237,34.6625217),(42045,'radius ulna',253,4,207,43.9104161,72.5000692,148.3983488,1.8,72.3799965,148.3709673,0.064906,4.9077474,5.7088902,249.9254303,374.0995767,0.0307876,65.5292996,50.9246725,108.8452303,9.882824,11.8845829,0.2186689,34.9142271),(42046,'radius ulna',253,4,208,43.1123033,72.496855,148.3000533,1.8,72.3572244,148.2931505,0.0574096,4.832598,5.6936495,247.1487257,363.5466858,0.023656,63.8512582,51.1420002,106.9076511,9.882824,11.7988288,0.1831108,34.9142271),(42047,'radius ulna',253,4,209,42.8145985,72.5344831,148.1793894,1.8,72.4151256,148.1600793,0.0393161,4.8332511,5.6668273,247.4700372,358.7614141,0.0110245,63.3090426,51.201568,106.7199501,9.882824,11.7988288,0.1831108,34.6625217),(42048,'radius ulna',253,4,210,42.7870157,72.5559605,148.1298309,1.8,72.4109815,148.1175794,0.0073268,5.0440407,5.6479284,249.6214411,355.8066649,0.0003828,62.9977292,49.4883872,106.2219516,10.312512,11.7988288,0.1831108,35.0184869),(42049,'radius ulna',253,4,211,42.7404101,72.5797445,148.0476244,1.8,72.4404004,148.038508,-0.0147063,4.9857075,5.6326375,251.0103123,352.2562942,0.0015405,62.5384283,50.3459765,105.0365859,10.312512,11.8845829,0.2186689,35.2701923),(42050,'radius ulna',253,4,212,42.4371664,72.5989146,147.9511335,1.8,72.4969594,147.8996206,-0.0371617,4.9248456,5.6215407,251.1440897,347.8767551,0.0097631,61.882814,50.9953221,105.3642912,9.882824,11.7988288,0.1831108,34.4108163),(42051,'radius ulna',253,4,213,42.101752,72.6223826,147.8697321,1.8,72.4969594,147.8561463,-0.0634675,4.9105855,5.6579373,251.7721146,344.1245336,0.0282272,60.8215531,51.2713025,104.083417,9.882824,11.7988288,0.1831108,34.4108163),(42052,'radius ulna',253,4,214,41.8949085,72.6551294,147.7845674,1.8,72.4991587,147.8004534,-0.0886813,5.149408,5.6803019,251.7517048,341.6620138,0.0547691,60.1485663,48.8894459,104.2284192,10.312512,11.7282,0.1470784,34.7667815),(42053,'radius ulna',253,4,215,41.764827,72.6954324,147.6872723,1.8,72.5580393,147.6630844,-0.121457,5.1594458,5.7416919,254.2969091,339.4599544,0.1021805,59.121938,49.2876406,103.2786797,10.312512,11.7988288,0.1831108,35.0184869),(42054,'radius ulna',253,4,216,41.5594382,72.7223453,147.6042111,1.8,72.601019,147.5729406,-0.1535858,5.1685676,5.7216533,254.9957726,337.453843,0.1621075,58.9783799,49.3358683,103.4542145,10.312512,11.7282,0.1470784,34.7667815),(42055,'radius ulna',253,4,217,41.2729792,72.691079,147.4494099,1.8,72.5681648,147.3911685,-0.1748516,5.2306373,5.7113964,254.8656248,335.9623434,0.2081725,58.8231528,48.7255394,103.3814549,10.312512,11.7282,0.1470784,35.0184869),(42056,'radius ulna',253,4,218,40.8935329,72.7258923,147.3556333,1.8,72.6162562,147.270229,-0.2004438,5.3045009,5.6715478,256.812712,334.7345476,0.2701871,59.0199641,48.4141143,103.5463245,10.312512,11.7282,0.1470784,35.0184869),(42057,'radius ulna',253,4,219,40.5928069,72.7600104,147.2605103,1.8,72.6674023,147.2008781,-0.223452,5.3211348,5.5752627,258.7649888,334.5480089,0.3322203,60.0057836,48.6296622,105.7643395,10.312512,11.5697035,0.2629947,34.6625217),(42058,'radius ulna',253,4,220,40.6051157,72.8080322,147.1724958,1.8,72.7244388,147.1268042,-0.2576559,5.2690792,5.5526186,260.2012202,336.7113538,0.439418,60.6401009,49.3826742,107.442097,10.312512,11.5697035,0.2629947,34.6625217),(42059,'radius ulna',253,4,221,40.6851787,72.8251526,147.0679395,1.8,72.715342,146.9967703,-0.2846868,5.3584904,5.5987532,262.8762231,339.2509585,0.5348783,60.594019,49.0578886,107.5447884,10.3304002,11.5697035,0.2629947,34.7667815),(42060,'radius ulna',253,4,222,41.0198658,72.8316111,146.9610744,1.8,72.7099889,146.9014543,-0.2672749,5.377736,5.6317829,266.3934817,342.5307377,0.4768624,60.8210129,49.5363628,108.0313249,10.3304002,11.6887773,0.2984989,34.7667815),(42061,'radius ulna',253,4,223,40.8473749,72.9049305,146.8670961,1.8,72.8331294,146.7850691,-0.3180485,5.3088425,5.6009521,267.715456,341.4132099,0.6657425,60.9562806,50.4282155,108.4835492,10.312512,11.6887773,0.2984989,34.4108163),(42062,'radius ulna',253,4,224,40.426974,72.9675629,146.8020624,1.8,72.8750848,146.7648545,-0.3697563,5.2592037,5.5648166,265.4068943,341.6478154,0.8799703,61.3942634,50.4652238,108.4313451,10.312512,11.5697035,0.2629947,34.4108163),(42063,'radius ulna',253,4,225,40.5569995,73.0245192,146.6681179,1.8,72.9322424,146.6051179,-0.4162251,5.3147578,5.5512562,267.5874862,345.9492167,1.1049564,62.3190866,50.3480114,108.0167366,10.3304002,11.6887773,0.2984989,35.0184869),(42064,'radius ulna',253,4,226,40.7810753,73.0736569,146.5759407,1.8,72.9473368,146.533671,-0.4439766,5.2687837,5.5808186,269.8344399,349.1073274,1.2540138,62.5548605,51.2138007,109.1537493,10.5730295,11.5697035,0.2629947,35.0184869),(42065,'radius ulna',253,4,227,41.3970741,73.107553,146.4673559,1.8,72.9994369,146.4127208,-0.4498635,5.1794749,5.4984499,275.9787957,353.4092585,1.3046156,64.2743433,53.2831606,111.0539432,10.5711023,11.5697035,0.2629947,35.2701923),(42066,'radius ulna',253,4,228,41.9387166,73.1790339,146.3520992,1.8,73.1099558,146.2518797,-0.4568377,5.289993,5.5798391,279.7216517,358.0549824,1.3600728,64.1694103,52.8775089,113.564103,10.6342355,11.5697035,0.2629947,35.2701923),(42067,'radius ulna',253,4,229,42.7000709,73.2065703,146.2369339,1.8,73.133952,146.1317044,-0.4814409,5.1858382,5.4897433,284.8947821,362.8559315,1.5259693,66.097067,54.9370749,114.8214401,10.6127538,11.7988288,0.9928944,35.5218977),(42068,'radius ulna',253,4,230,42.3112252,73.2924877,146.1721483,1.8,73.2126335,146.0717711,-0.4872927,5.1652814,5.563904,285.7183093,366.4204727,1.5460835,65.8567209,55.3151488,115.5167625,10.5711023,11.6887773,0.2984989,35.5218977),(42069,'radius ulna',253,4,231,41.9449269,73.3685822,146.1009061,1.8,73.3135681,145.9674873,-0.4973972,5.1659417,5.5146903,286.5850661,371.6926295,1.5915465,67.4004537,55.4758618,116.1591597,10.5711023,11.7988288,0.9928944,35.5218977),(42070,'radius ulna',253,4,232,42.6386948,73.413907,146.0097025,1.8,73.3284797,145.9013012,-0.5001778,5.1090037,5.6047097,291.2832393,381.2847084,1.6344724,68.0293417,57.0137069,117.6153109,10.5711023,11.9388329,1.0427219,35.5218977),(42071,'radius ulna',253,4,233,42.0419425,73.4636967,145.8772625,1.8,73.3758221,145.7773078,-0.5401915,5.1870162,5.6273209,293.5045823,383.0534255,1.8533823,68.0703012,56.5844734,119.1445808,10.5711023,11.9465628,0.9129077,36.1295683),(42072,'radius ulna',253,4,234,41.5391287,73.5315444,145.8156599,1.8,73.4567287,145.701225,-0.5569016,5.1678621,5.6356126,293.3078965,384.840557,1.9341594,68.2872622,56.7561385,118.8316766,10.5711023,11.9465628,0.9129077,36.1295683),(42073,'radius ulna',253,4,235,41.3562872,73.6071818,145.7643665,1.8,73.5444935,145.6557513,-0.5562644,5.3023354,5.682181,292.9348101,386.9332491,1.9217061,68.0959032,55.2463748,117.2528672,10.6342355,11.9465628,0.6578886,36.1295683),(42074,'radius ulna',253,4,236,41.3311102,73.7044863,145.692015,1.8,73.644989,145.5842468,-0.5581048,5.2913555,5.6512388,295.7890812,390.4638317,1.9319158,69.0934933,55.9004368,119.6321553,10.6342355,12.0389346,0.9629943,36.1295683),(42075,'radius ulna',253,4,237,41.776968,73.7901477,145.605765,1.8,73.7289164,145.5034455,-0.5609471,5.2624455,5.7629703,300.9580523,398.0791469,1.9705615,69.0753423,57.1897706,119.1504025,10.6342355,12.2140278,0.8850668,36.3812737),(42076,'radius ulna',253,4,238,41.7062484,73.9042637,145.5198231,1.8,73.8442905,145.4262367,-0.5740495,5.2465728,5.7589531,302.0463718,404.8844756,2.049786,70.3052214,57.570224,120.8208038,10.6342355,12.1610055,1.012197,36.4855335),(42077,'radius ulna',253,4,239,42.0673434,74.0207479,145.4262222,1.8,73.9668173,145.3058578,-0.5768956,5.2479142,5.8278684,305.9632435,413.2579463,2.0857551,70.9106513,58.301876,122.1472491,10.6342355,12.2140278,0.6857295,36.3812737),(42078,'radius ulna',253,4,240,42.283978,74.104868,145.3738215,1.8,74.0246559,145.2407714,-0.5918855,5.347556,5.8106015,310.3493171,420.2888193,2.1937087,72.3313785,58.0357307,123.3432579,10.6342355,12.2893773,0.9342881,36.7372389),(42079,'radius ulna',253,4,241,42.343228,74.204978,145.2570703,1.8,74.1719448,145.1457056,-0.5915838,5.423745,5.9616808,311.1934014,429.0544429,2.1948116,71.968704,57.3761122,124.1212276,10.6342355,12.3940969,0.5880026,36.7372389),(42080,'radius ulna',253,4,242,43.4192396,74.2803182,145.1600749,1.8,74.2168595,145.0692794,-0.5979235,5.3781865,5.9743507,319.7821692,441.7131588,2.2931679,73.9349235,59.4591079,125.1363941,10.9161936,12.5495381,0.6640462,37.2406497),(42081,'radius ulna',253,4,243,43.7291413,74.3878572,145.0511087,1.8,74.2856232,144.9603296,-0.6017415,5.3661628,5.9888175,326.1792698,450.5098785,2.3354671,75.2251809,60.7844532,129.1048833,10.9380707,12.5495381,0.6640462,37.5966149),(42082,'radius ulna',253,4,244,44.1689566,74.4846951,144.9249194,1.8,74.4368354,144.8015507,-0.5950327,5.4271282,6.026094,333.7624038,460.8560158,2.3129838,76.4767387,61.4988982,130.0780179,10.9380707,12.7755427,0.7378151,38.2042855),(42083,'radius ulna',253,4,245,45.506418,74.5525171,144.8246595,1.8,74.4974537,144.709106,-0.5928738,5.4978333,6.1253691,341.9185719,479.7823429,2.367834,78.3270912,62.191513,133.6591209,11.1484615,12.7538463,0.5693132,38.2042855),(42084,'radius ulna',253,4,246,46.8197094,74.6492621,144.7387208,1.8,74.6041981,144.558014,-0.598603,5.4793464,6.1427848,351.2446154,499.9882277,2.477697,81.3943907,64.1033786,136.6089638,11.1747863,12.9905136,0.9736197,38.4559909),(42085,'radius ulna',253,4,247,49.0385358,74.7741471,144.6349586,1.8,74.7621253,144.4483369,-0.5825488,5.5869326,6.3328374,361.3893002,527.4816109,2.4737451,83.2930928,64.6847429,140.2450426,11.2082252,13.2369013,0.6240231,39.0636615),(42086,'radius ulna',253,4,248,51.3735682,74.8700491,144.54164,1.8,74.8173028,144.3801151,-0.5754963,5.6914319,6.3262523,377.8574267,554.2860902,2.5362218,87.6168166,66.3905734,146.1640008,11.3412782,13.2717262,0.5070985,39.3153669),(42087,'radius ulna',253,4,249,52.9956983,75.0111481,144.4284885,1.8,75.0091789,144.1951542,-0.5646214,5.6819582,6.5126129,390.0806094,581.8697268,2.5290233,89.34505,68.6524951,148.8005543,11.3412782,13.4856331,0.5349551,39.6713321),(42088,'radius ulna',253,4,250,53.8473543,75.0532614,144.3060325,1.8,75.0852756,144.1089776,-0.5593852,5.7406193,6.642493,398.5050707,603.8561056,2.527286,90.9080533,69.4184812,150.7468854,11.5330041,13.7096736,0.5619216,39.9230375),(42089,'radius ulna',253,4,251,54.1831044,75.1627451,144.2202111,1.8,75.1577775,144.0306255,-0.5365749,5.8193279,6.6566566,402.6222804,626.0347848,2.35986,94.0464299,69.1870763,153.8214508,11.5319132,13.8570216,0.5191461,41.2426385),(42090,'radius ulna',253,4,252,55.0132201,75.225427,144.120979,1.8,75.2005848,143.9124271,-0.504843,5.8885374,6.7785774,411.566626,650.2106223,2.1449351,95.9213984,69.8928445,155.6117644,11.5457413,14.0488921,0.4089078,41.2426385),(42091,'radius ulna',253,4,253,56.4091482,75.3123012,144.0223558,1.8,75.3026633,143.7956922,-0.4668055,5.8861013,6.8492254,422.7371392,682.5162132,1.9041122,99.6486717,71.8195489,158.0606996,11.5330041,14.283491,0.3693337,41.8503091),(42092,'radius ulna',253,4,254,57.6677215,75.4549077,143.9056061,1.8,75.4754144,143.7109913,-0.4329066,6.0741387,7.0700476,433.0893131,713.1635427,1.6914857,100.8711093,71.3005304,161.6104374,11.7247299,14.4441652,0.3970794,42.1020145),(42093,'radius ulna',253,4,255,60.2662179,75.6393669,143.7716901,1.8,75.6281225,143.5752686,-0.4231533,6.0382313,7.066469,447.8956898,763.042807,1.6937148,107.9807764,74.176637,169.6171184,11.7236391,14.6850235,0.3587707,43.2130959),(42094,'radius ulna',253,4,256,63.4014893,75.88034,143.6110892,1.8,75.8587162,143.4758756,-0.4157486,6.0405352,7.3551208,463.1669953,826.0176796,1.7236218,112.3051138,76.6764831,174.2634496,11.7247299,15.1917649,0.5016041,43.4648013),(42095,'radius ulna',253,4,257,73.2647427,76.2230646,143.6357642,1.8,76.1081431,143.3677945,-0.3804271,6.3976365,7.6280487,550.10929,927.2349478,1.6835794,121.5559815,85.9863311,193.6378072,12.2172662,15.7994355,0.390607,44.9318479),(42096,'radius ulna',253,4,258,84.1295954,76.3826205,143.3918317,1.8,76.2942322,143.2942822,-0.3321776,6.5030769,7.8303843,669.9033489,1028.852812,1.4910953,131.3923775,103.0132903,216.0822293,12.9033909,16.1975849,0.3805064,47.3625303),(42097,'radius ulna',253,4,259,86.2930322,76.6440311,142.7561531,1.8,76.4690513,142.9399167,-0.2403306,7.2213708,8.2569896,826.7176192,1223.0728425,0.8148262,148.1257578,114.4820892,245.1563277,14.0417081,16.5973074,0.3708913,50.4008833),(42098,'radius ulna',253,4,260,88.140469,77.0013401,142.2639073,1.8,76.4233368,142.3777481,0.2041895,7.8538228,8.1022699,1013.924873,1178.5750086,0.6040138,145.4623239,129.099535,256.9914252,14.6733045,16.1975849,2.7610863,50.5051431),(42099,'radius ulna',253,4,261,93.8738452,76.5762753,142.8509437,1.8,76.2381852,142.8506974,-0.0248465,7.9180702,7.8723226,900.9804115,1214.9362684,0.0096568,154.3300912,113.7878786,261.9936704,14.0695717,16.3620316,2.9029833,50.7568485),(42100,'radius ulna',253,4,262,83.6851923,76.6563972,143.3876164,1.8,76.2965088,143.4029124,-0.1699276,5.9168907,7.8867835,567.0737565,1173.4124857,0.3988787,148.7821341,95.8398224,217.8033678,12.031264,16.1804778,0.1869793,46.5463401),(42101,'radius ulna',253,4,263,57.1769367,76.7125632,143.3464891,1.8,76.6659642,143.3095418,-0.2444373,5.1018895,7.5541442,304.8143251,743.6285484,0.5581328,98.4398133,59.7453794,138.1466654,10.3321797,15.1125613,0.2587709,41.3900841),(42102,'radius ulna',253,4,264,48.6483473,76.6815208,143.4211349,1.8,76.9266915,143.3912326,-0.2873433,4.4511073,6.9111769,198.6202918,498.2577878,0.6512282,72.094492,44.6226699,97.9376077,9.1940465,13.6556983,0.2220819,37.8483203),(42103,'radius ulna',253,4,265,36.7115112,77.0867338,143.2945868,1.8,77.161016,143.2947506,-0.5048419,4.029261,5.8497632,116.6809158,285.1190487,1.4313561,48.7402716,28.958391,68.4782165,8.3504958,12.1610055,0.5585993,33.6988859),(42104,'radius ulna',253,4,266,28.4898582,77.3855725,142.809065,1.8,77.5619099,142.8280331,-0.7223957,4.0266221,5.3885645,79.571713,160.3106042,2.0757904,29.7501506,19.7614055,44.3317269,8.0814309,10.9549375,0.8408967,30.1571221),(42105,'radius ulna',253,4,267,23.7575219,77.1547715,142.224354,1.8,77.2066758,142.25752,-0.4683144,3.7557438,4.6408495,68.6722517,116.7316953,0.8067518,25.1530879,18.2845941,39.0087859,7.8803952,9.798394,0.6610432,28.0824049),(42106,'radius ulna',253,4,268,21.3169136,77.0675809,142.0243256,1.8,76.9303945,142.1484687,-0.2196884,3.8910638,4.5747361,67.232235,82.1766677,0.1687288,17.9631492,17.2786255,32.0795417,7.734384,9.2257926,0.4844779,27.2230289),(42107,'radius ulna',253,4,269,14.5993382,76.5747917,142.1630092,1.8,76.5987847,142.2562937,0.6543154,3.5381898,3.740707,33.9133583,36.3951869,0.901299,9.729494,9.584946,18.5402984,7.2920472,7.7463106,2.5535901,23.4295597),(42108,'radius ulna',253,4,270,0.568498,76.0365076,142.3695345,1.8,76.0824978,142.3791979,1.1535193,1.0593431,1.57773,0.161508,0.402692,0.0791874,0.255235,0.1524606,0.3244982,2.5562168,3.6963159,2.1910458,9.1582448),(42109,'radius ulna',253,4,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42110,'radius ulna',253,4,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42111,'femur',253,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42112,'femur',253,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42113,'femur',253,7,3,0.0114695,88.08604,136.211096,1.8,88.08604,136.211096,0.7853982,0.00000000000001005,0.00000000000001005,0.0001765,0.0001765,0.0009558,17561692740.4051,17561692734.1385,24835984047.2789,0.429688,0.6076706,2.3561945,1.2153412),(42114,'femur',253,7,4,31.3956267,90.5598608,137.1233128,1.8,90.7450607,137.6132358,0.2665634,5.4983451,6.3426249,122.3274095,245.4986391,0.3630848,38.7061577,22.2480413,56.2565002,9.993743,13.1809902,2.8095332,36.9889443),(42115,'femur',253,7,5,90.8335193,91.1202526,138.5755502,1.8,91.1239012,138.4714854,0.8514678,6.8304346,8.9117087,893.6108614,1367.715252,8.5667751,153.4739635,130.8278186,245.3642745,14.1543227,18.3914495,2.223643,53.3349765),(42116,'femur',253,7,6,153.6897854,91.5197302,139.45931,1.8,91.3128717,139.1811057,1.0495565,8.2959868,11.5585367,2382.6429624,4813.7575884,19.2634811,416.4677355,287.204286,608.3835435,16.6190061,23.6484599,2.0019351,68.1097022),(42117,'femur',253,7,7,187.3322129,91.2061543,139.8745139,1.8,90.9045788,139.4626218,1.093263,9.8005776,13.3340394,3864.0475601,8594.6821866,24.6272285,644.56703,394.2673285,931.906195,18.8932086,26.8271256,2.1276979,76.3043112),(42118,'femur',253,7,8,188.5187238,90.601969,139.8546797,1.8,90.4039933,139.4316666,1.1147623,10.2474223,14.2468131,4693.5366176,10466.4161632,25.3261025,734.6496459,458.0211962,1059.3779755,20.047514,28.8883304,2.1010121,81.8165324),(42119,'femur',253,7,9,185.7072295,90.2409165,139.7676677,1.8,90.0268563,139.2518045,1.1537744,11.4648981,15.4188483,5419.6423562,11770.1011151,25.8734446,763.3579941,472.7161367,1107.7017868,21.5826314,30.6798436,2.2170985,89.5509164),(42120,'femur',253,7,10,191.4625936,90.032795,139.7644183,1.8,89.8237445,139.21447,1.20014,12.0419964,16.0726834,6298.8184745,13130.2184281,27.7235097,816.9275843,523.0709484,1187.7602724,22.8015897,31.883892,2.2223835,93.8046106),(42121,'femur',253,7,11,197.0513416,89.885096,139.9672712,1.8,89.7267446,139.3460951,1.215751,11.7686916,16.4631175,6991.5147399,13884.6926402,28.872993,843.3817387,594.0774898,1247.6405661,22.8765546,32.6675936,2.1879877,94.7071724),(42122,'femur',253,7,12,202.702137,89.9788978,140.126236,1.8,89.7952526,139.5561092,1.2456949,11.9578975,16.4925234,7708.5732228,14385.6469947,30.3370941,872.2526359,644.6428603,1288.636183,23.2747308,33.2529655,2.144463,95.8182538),(42123,'femur',253,7,13,206.3327251,90.0916674,140.6014938,1.8,89.9905219,140.0624696,1.2467638,12.0608466,16.4084011,8462.9042854,14371.265247,30.902682,875.8479955,701.6840997,1339.7075543,23.2458433,33.0971348,2.0867218,95.4622886),(42124,'femur',253,7,14,208.4210783,90.1895687,140.7361073,1.8,90.0915207,140.5166157,1.2034542,12.3392871,16.4318881,9144.9151738,14478.4758116,30.2565305,881.1206414,741.1218417,1399.6744992,23.8841092,32.5713708,2.206382,93.7435366),(42125,'femur',253,7,15,209.3777507,90.3582072,140.7410396,1.8,90.2534176,140.6666602,1.1799471,12.7865403,16.4491263,10183.5678737,14481.3604225,29.8314093,880.3726213,796.428717,1469.9571572,25.0708355,32.3181368,2.1956826,95.0631376),(42126,'femur',253,7,16,212.9653139,90.4512737,140.4952692,1.8,90.5347514,140.6463522,1.1639236,13.3417616,16.464402,11522.8606788,14942.2389462,29.9354837,907.5482316,863.6686061,1573.618763,26.520346,32.2266,2.2142974,96.634444),(42127,'femur',253,7,17,223.0647281,90.6637844,139.965148,1.8,90.9642288,140.3489356,1.1963517,14.2667883,16.4458625,13468.1518193,16064.5033687,32.2039583,976.8112407,944.0212847,1770.7901861,28.0466947,31.6251536,2.2115801,98.9176808),(42128,'femur',253,7,18,253.3780209,91.1967939,138.6141676,1.8,91.4316454,139.8748368,-1.5053018,15.9699643,16.5026767,15804.3071388,18910.9034966,42.0487832,1145.9294644,989.6269561,2026.985441,29.5621076,32.2924183,2.7017501,102.6679641),(42129,'femur',253,7,19,267.9086537,91.3897198,138.207717,1.8,91.8079264,139.5281076,-1.2849945,17.218388,16.8151685,18106.8752154,18942.3631078,41.102423,1126.5045085,1051.6010684,2077.4336201,30.7689018,33.7380335,3.026716,105.8105769),(42130,'femur',253,7,20,296.5660792,91.902037,137.8940387,1.8,92.0648886,139.3487724,-0.0871038,16.9755862,17.5609243,19966.7248932,22204.6373746,0.374064,1264.4344354,1176.2023802,2285.2314486,31.4659693,35.1242016,3.0066159,108.3887049),(42131,'femur',253,7,21,308.78087,91.8151502,137.8879771,1.8,92.1460251,139.2921341,0.1829478,17.6202944,18.7490181,20712.6289567,25267.1170019,1.7033459,1347.6501456,1175.4984621,2370.887572,32.0524956,36.0349177,2.9980093,112.6855849),(42132,'femur',253,7,22,315.5197061,91.8713848,138.1756916,1.8,92.3198152,139.2368906,0.2538635,17.6730995,19.4126778,21214.4560565,28283.8919729,3.3168515,1456.9804498,1200.3811828,2460.8721779,32.4180794,37.4445419,0.0574081,116.7307595),(42133,'femur',253,7,23,329.0468931,92.1952374,138.539078,1.8,92.5731662,139.2628613,0.2540195,17.6188176,20.0237667,22013.1751697,32212.7951951,3.4632146,1608.7280516,1249.4127408,2634.6717025,32.656288,38.5882791,0.1340232,120.4199689),(42134,'femur',253,7,24,346.3578566,92.5610761,138.9879342,1.8,92.8911363,139.3295581,0.2541059,17.4925327,20.7124705,23709.1513948,36332.7283353,3.6478381,1754.147496,1355.3869994,2849.0449009,33.0385932,40.1913351,0.1071153,124.8211087),(42135,'femur',253,7,25,361.2509831,92.9362442,139.1400332,1.8,93.2542778,139.3386508,0.2346698,17.5846631,21.7111014,24920.5042811,41045.129697,3.2552564,1890.5134703,1417.1726848,2968.7130229,33.085976,41.7881245,0.0720401,129.8299191),(42136,'femur',253,7,26,368.2695643,93.1760075,139.1813518,1.8,93.6852427,139.3425835,0.1901457,17.5200253,23.1819951,25580.3822692,45864.5209958,2.1925374,1978.4544302,1460.0653733,3061.6234539,33.085976,43.4749986,0.0593362,134.9429893),(42137,'femur',253,7,27,379.8955476,93.6333189,139.0863126,1.8,94.2761709,139.3432086,0.1423046,17.4467386,24.2420212,26516.5699742,53178.0875912,1.2735535,2193.6325826,1519.8582693,3285.9500501,33.085976,44.9368195,3.0362152,140.0992453),(42138,'femur',253,7,28,410.3018277,94.7090011,139.2051292,1.8,95.7798938,139.2859401,0.0798331,17.0236501,28.3158258,28428.3711994,68942.6591549,0.4349065,2434.7747984,1669.9339454,3389.6313423,33.085976,50.4567892,0.0852629,153.7628896),(42139,'femur',253,7,29,497.0404939,101.4428188,138.1303352,1.8,102.1159095,138.1973583,-0.0942285,17.410329,42.2455602,32496.8680656,164678.6445916,0.7333628,3898.1290314,1866.528087,4642.1500961,33.515664,71.039006,0.2009543,200.8737145),(42140,'femur',253,7,30,614.6565869,108.2231789,136.9882362,1.8,105.4695882,137.6712973,-0.1358644,18.5519462,38.1906784,37779.7138188,269506.6696889,1.8793982,7056.8704362,2036.4285985,8022.4362438,33.515664,73.6786504,0.1699425,210.6396299),(42141,'femur',253,7,31,664.2622779,111.0213796,136.4756039,1.8,107.4832337,137.418576,-0.1426876,19.4632481,37.7977013,42919.0633228,311083.2756982,2.2387797,8230.2167781,2205.133653,9296.1173219,34.9075795,75.3732034,0.1660859,223.9041232),(42142,'femur',253,7,32,686.6618052,112.4320366,136.231574,1.8,108.9577528,137.204923,-0.1400988,19.9976071,39.2308745,48086.8972227,329516.8036055,2.2316051,8399.4253871,2404.6325688,9566.6810372,36.261256,76.4422077,0.180859,235.9964612),(42143,'femur',253,7,33,682.973142,113.2151357,135.8494762,1.8,110.1641237,136.912589,-0.1370807,19.6165554,40.1930855,51456.0621124,338110.325839,2.1256086,8412.1515269,2623.0936562,9672.5145811,36.3375586,77.4249607,0.1560248,239.7899304),(42144,'femur',253,7,34,674.8050881,114.0338601,135.4326922,1.8,111.1197053,136.7539115,-0.1271376,20.4116047,41.1810087,53307.5083034,340630.7684784,1.8081462,8271.5498954,2611.6275116,9509.9267463,37.0271385,78.1335377,0.1769022,243.6876594),(42145,'femur',253,7,35,676.3821792,114.9327903,135.1630979,1.8,111.9568481,136.6501938,-0.1155377,21.3561638,42.253282,55206.4165653,344889.5509771,1.4981482,8162.4322344,2585.0343277,9445.4741951,38.2085245,78.9971776,0.1418971,251.0839663),(42146,'femur',253,7,36,693.3102276,115.3715759,135.1188154,1.8,112.5760912,136.62075,-0.1197082,22.1680572,42.6814056,59733.0667653,361470.4974295,1.6479666,8469.039198,2694.5557876,9841.4748341,39.3310566,79.6778744,0.124355,252.090788),(42147,'femur',253,7,37,708.6515058,115.8085763,135.1247066,1.8,113.0860055,136.6415219,-0.1188967,22.8117037,43.1681469,63164.4694219,375766.3464114,1.6617813,8704.7133948,2768.9501061,10147.1460714,40.2909645,80.104262,0.1236897,254.9816953),(42148,'femur',253,7,38,718.6062358,116.2395732,135.0629708,1.8,113.5769642,136.6314077,-0.1104133,23.4662296,43.577874,65666.8095699,383639.7196606,1.4541766,8803.5437288,2798.353664,10289.0377144,41.1360444,80.3826703,0.1071153,258.3760135),(42149,'femur',253,7,39,725.512863,116.485576,135.0208289,1.8,114.0932372,136.6327307,-0.102422,23.9219103,43.464468,67661.7551643,391289.6103244,1.2640426,9002.5169529,2828.4428136,10548.3474284,41.6751516,80.0523851,0.1183631,259.8430601),(42150,'femur',253,7,40,729.2702316,116.4305698,135.0206513,1.8,114.4689378,136.6622703,-0.0938074,24.368237,42.7707674,68716.0201537,392844.234017,1.0664409,9184.8769125,2819.9011753,10790.3390871,42.2708959,79.3632689,0.1357716,261.7703317),(42151,'femur',253,7,41,723.336446,116.394181,135.1029999,1.8,114.6816845,136.7277192,-0.0836512,25.230501,42.6831764,69547.4091246,387595.6794545,0.8416273,9080.7599604,2756.4814945,10709.2529572,43.1576955,79.059089,0.1472775,261.7703317),(42152,'femur',253,7,42,719.7195095,116.2103941,135.2205892,1.8,114.6465175,136.8404293,-0.0739837,25.5574316,42.1506444,69537.5540884,379979.2131997,0.6553768,9014.790131,2720.8349857,10650.3238953,43.3917437,78.5565562,0.1759396,261.6228861),(42153,'femur',253,7,43,710.475388,115.6167646,135.43781,1.8,114.4062549,136.961062,-0.0589754,25.4983574,41.4824875,68968.2078958,366279.4942936,0.4113733,8829.7379434,2704.8098411,10477.6091856,42.9511133,78.1465333,0.1434523,258.5845331),(42154,'femur',253,7,44,685.4789869,114.3171808,135.6251134,1.8,113.7191213,137.1146922,-0.0452426,25.7529426,40.0833489,65613.9437382,345469.6256003,0.2336902,8618.7814967,2547.8231665,10249.8846932,42.3496117,77.4928936,0.1222917,257.3691919),(42155,'femur',253,7,45,637.29552,111.3958828,136.4309543,1.8,112.3780714,137.4064538,0.018742,24.546705,38.4577031,60581.284968,290532.3369826,0.0373055,7554.594093,2468.0006895,8947.9060114,41.4697089,76.5098066,0.1522223,258.2717537),(42156,'femur',253,7,46,581.025573,107.6683851,136.8594793,1.8,108.9647034,138.0374659,0.0935822,23.4135665,39.7474324,57621.8394914,217545.6326547,0.8455942,5473.1996352,2461.0449453,6723.7822769,38.6561079,66.0574555,0.0977269,226.8992904),(42157,'femur',253,7,47,563.1836532,106.4817947,136.9392326,1.8,107.6136778,138.1355023,0.1340649,22.6686889,31.3565108,56767.8283098,194560.2705721,1.6769712,6204.7806174,2504.2395982,7891.737633,38.0903557,64.0119757,0.1143637,222.749856),(42158,'femur',253,7,48,552.4554839,105.8621405,136.9981928,1.8,107.0276641,138.102196,0.1580485,22.0515776,30.4760314,56147.1711408,181789.4283766,2.2809063,5964.9967548,2546.1747956,7713.7591537,37.4470086,62.1044107,0.1458109,218.6436074),(42159,'femur',253,7,49,542.6875677,105.0557139,136.8848475,1.8,106.5065637,137.944239,0.180297,21.2733072,29.4200583,55203.1326778,171184.2893104,2.9084713,5818.625089,2594.9483212,7437.7060136,36.6614568,60.5479031,0.113792,214.1992818),(42160,'femur',253,7,50,536.7105335,104.4081528,136.7582955,1.8,105.952679,137.7981113,0.1958961,20.7258451,28.5932555,54179.0230693,162703.6199554,3.3890494,5690.2796595,2614.0802876,7070.014192,36.039178,59.1316886,0.0946072,210.0498474),(42161,'femur',253,7,51,528.0765921,103.9583684,136.7294008,1.8,105.4553127,137.6557501,0.2091377,20.0818368,27.9127257,53397.8975848,153201.995414,3.7937562,5488.6074955,2659.0146191,6798.4407735,35.4279677,57.7287067,0.1418971,204.5808121),(42162,'femur',253,7,52,523.2855654,103.4854291,136.6429631,1.8,105.0463332,137.5287488,0.2169793,19.7315095,27.434616,53386.1166115,146236.4746819,4.0420158,5330.3634698,2705.6276017,6618.131314,34.9017095,56.6096614,0.1064661,198.9643311),(42163,'femur',253,7,53,527.3066217,102.9225503,136.6944794,1.8,104.397394,137.4945062,0.2280472,19.0072016,27.0703766,53696.708242,140937.6857026,4.4917949,5206.3437357,2825.0717535,6446.1713453,34.6276732,55.3764317,0.1166554,192.2367687),(42164,'femur',253,7,54,533.7442282,102.3328166,136.6866498,1.8,103.7877278,137.4073708,0.2397437,18.4203733,26.7394854,54182.174498,134953.3951546,5.0157962,5046.9705429,2941.4265153,6301.5491763,34.6982778,54.8454275,2.5231647,179.6231318),(42165,'femur',253,7,55,545.4446237,101.9495319,136.8269824,1.8,103.2198535,137.4566323,0.2552608,17.5648416,26.4537493,54915.3888234,128916.6962194,5.7958139,4873.2863756,3126.4380408,6151.6638731,34.8150184,54.4755593,2.5754684,166.2111928),(42166,'femur',253,7,56,546.054468,101.7979561,136.838418,1.8,102.8948602,137.3469794,0.2799244,17.463637,26.5040381,55721.9561891,122122.9720352,6.9469334,4607.7119169,3190.7417722,5993.4615718,34.7388847,54.147508,2.5139632,160.6378976),(42167,'femur',253,7,57,522.7758138,101.7844467,136.593032,1.8,102.4062438,137.1263774,0.3196337,17.8111407,26.670966,54513.380136,114973.4083374,8.6025772,4310.8078096,3060.6338451,5791.6858458,34.7863065,53.6542512,2.5846911,158.311475),(42168,'femur',253,7,58,506.6127004,101.7033764,136.2785485,1.8,102.1949005,136.8341466,0.3486061,18.2084684,26.7884098,53212.9693331,110059.5769434,9.8521306,4108.4774326,2922.4297324,5586.9496482,34.7863065,53.2969032,2.5222804,156.1324981),(42169,'femur',253,7,59,490.009492,101.6469948,135.8809115,1.8,101.8561183,136.5752757,0.3717823,18.512924,27.0927722,51599.0880369,105004.6378654,10.7777473,3875.7435728,2787.1927816,5355.294788,34.7863065,52.9842068,2.6053456,155.733347),(42170,'femur',253,7,60,487.1069126,101.3583804,135.6106944,1.8,101.6363045,136.3862181,0.3976478,18.7032356,27.7390784,50953.2700833,102134.0123439,12.1746783,3681.954056,2724.3024266,5165.2111729,34.8920662,52.9842068,2.6053456,154.873971),(42171,'femur',253,7,61,482.5700063,101.2889623,135.3918499,1.8,101.5649187,136.1649436,0.4202277,18.8216477,28.1620547,50370.0978602,99196.0833104,13.3863478,3522.3311748,2676.178976,5057.7548304,34.8698659,52.8376486,2.5941998,154.1188548),(42172,'femur',253,7,62,484.1798276,101.2948912,135.1497268,1.8,101.3692902,135.9139092,0.439681,18.8190732,28.2470037,50061.8992299,97111.1254879,14.6205034,3437.9265975,2660.1681606,4998.6698662,34.8210059,52.6976903,2.5829933,153.7628896),(42173,'femur',253,7,63,478.1312906,101.1928106,134.9514405,1.8,101.1736285,135.8098322,0.4664837,18.9223887,28.4465147,49209.0622529,94611.2636902,16.1188957,3325.9351683,2600.5734763,4897.4728132,34.7695593,52.4712213,2.5899377,152.295843),(42174,'femur',253,7,64,472.9006723,100.9367117,134.6170297,1.8,100.901168,135.4047191,0.4870179,18.8595283,28.5708833,48500.0795117,91355.1081493,17.262222,3197.4898122,2571.6486007,4786.3625735,34.6706192,52.0259729,2.604006,150.8287964),(42175,'femur',253,7,65,468.9851358,100.6982865,134.2356198,1.8,100.5053027,135.1265416,0.5020009,18.7977336,28.2985937,47769.0215734,87604.9944362,18.0977213,3095.7366736,2541.2117574,4668.5147318,34.4465488,51.0678358,2.6026162,149.4660096),(42176,'femur',253,7,66,462.3035356,100.4417162,133.9431532,1.8,100.0973219,134.6959114,0.5286615,18.7038971,28.2384997,46972.8473804,84250.3334541,19.601454,2983.527252,2511.3935884,4560.0613703,34.3858521,50.3322225,2.5938526,147.0353272),(42177,'femur',253,7,67,457.7756371,100.2102942,133.5510696,1.8,99.8189851,134.3964045,0.5480654,18.7138322,28.1518369,45859.6230865,81116.3388948,20.7127873,2881.3870741,2450.5735927,4439.2223061,34.3285221,49.7344139,2.4479606,145.2123155),(42178,'femur',253,7,68,454.3222955,100.0567395,133.176984,1.8,99.5978258,134.0562091,0.5650797,18.6378176,27.9708914,44816.8245769,78322.0819108,21.7122268,2800.1282045,2404.6176172,4341.9724085,34.2582273,49.2550663,2.3932146,142.7816331),(42179,'femur',253,7,69,447.2209098,99.8878462,132.7654997,1.8,99.4365476,133.7014785,0.5748456,18.5578078,27.9135134,43802.6241031,74819.7573107,22.0342296,2680.4134691,2360.3339642,4207.8986007,34.0055755,48.7501819,2.4310543,141.3145865),(42180,'femur',253,7,70,446.0171665,99.7092392,132.429513,1.8,99.2541049,133.247163,0.5944684,18.3113245,27.840309,43048.7885231,72437.7105961,23.317531,2601.9003826,2350.9379968,4126.469369,33.7640117,48.2514944,2.4571163,139.5958345),(42181,'femur',253,7,71,444.3202327,99.6251225,132.0638291,1.8,99.2126176,132.9740229,0.6130193,18.2572926,27.3218704,42055.464925,69891.2375123,24.5128227,2558.0692897,2303.4885773,4084.8483972,33.5209588,47.4955899,2.4202095,136.9134467),(42182,'femur',253,7,72,447.2595706,99.5944557,131.6689657,1.8,99.293265,132.5067843,0.6216671,18.0792731,26.6453862,41339.0789781,68480.1975449,25.2835412,2570.0583601,2286.5454145,4105.5023462,33.2715044,46.6543034,2.4409582,132.8071981),(42183,'femur',253,7,73,447.1645691,99.5081434,131.2330169,1.8,99.2067853,132.0639653,0.6228908,17.9371485,25.2720011,40498.8864241,66453.3702049,25.3645659,2629.5254512,2257.8218826,4222.1424792,32.9810636,45.0701544,2.4236595,129.0137289),(42184,'femur',253,7,74,445.8808747,99.3706162,130.8366302,1.8,99.1200354,131.7435624,0.6296716,17.7461698,24.2683195,39836.0856139,63636.3276167,25.7703461,2622.197533,2244.7709081,4262.0886407,32.760502,43.686825,2.4607074,126.1838955),(42185,'femur',253,7,75,441.5897525,99.2258538,130.3947686,1.8,99.0916735,131.3176111,0.6334669,17.6077037,23.4475552,39030.8926154,60166.1795819,25.7885448,2565.9894615,2216.6940803,4228.9276343,32.5351009,42.692914,2.4416998,124.1091783),(42186,'femur',253,7,76,435.7624938,98.9603356,129.8885916,1.8,98.7824733,130.7288963,0.6421229,17.5094057,22.7652672,38231.2024034,56697.5592763,26.0496959,2490.5290451,2183.466589,4168.773335,32.3354808,41.5399638,2.4587743,121.7827557),(42187,'femur',253,7,77,428.2670591,98.7544122,129.4215535,1.8,98.5568318,130.2751545,0.6590916,17.4458377,21.3347168,37431.5559883,53177.5883615,26.7690103,2492.5378187,2145.5866218,4244.3506341,32.1537712,39.9424985,2.2724215,118.8486625),(42188,'femur',253,7,78,428.5302433,98.6017006,128.9600846,1.8,98.4724648,129.8246832,0.6819879,17.343834,20.6924566,36820.8732877,50935.1233189,28.3776543,2461.5309994,2122.995026,4221.6643546,31.9537451,39.0614517,2.2627177,117.4858757),(42189,'femur',253,7,79,423.2385287,98.4952235,128.6329504,1.8,98.4454786,129.4561865,0.7068607,17.0970113,20.1430745,36218.5442894,49103.4764824,29.7526181,2437.7349383,2118.4137719,4206.0517036,31.6818182,38.5188391,2.2455373,116.1230889),(42190,'femur',253,7,80,415.9938575,98.3683477,128.265196,1.8,98.290245,128.9341682,0.7365914,16.931198,19.8457704,35331.9618552,47238.3387949,31.2876407,2380.2723671,2086.7963293,4130.9483816,31.474796,37.9879188,2.2278713,114.6560423),(42191,'femur',253,7,81,410.4385111,98.2906873,127.8382429,1.8,98.3090288,128.4785626,0.76331,16.8301259,19.3659369,34387.9663386,45493.1116586,32.6927254,2349.1304278,2043.2388011,4082.2837743,31.354419,37.3853254,2.2257912,113.5449609),(42192,'femur',253,7,82,408.5266211,98.2108673,127.5468905,1.8,98.2564128,128.1795861,0.7801292,16.6399779,19.0204869,33717.3270748,44069.1895344,33.6851422,2316.9327795,2026.2843703,4041.1603861,31.1459718,36.9631594,2.1910458,112.0779143),(42193,'femur',253,7,83,407.1573807,98.0801452,127.2130603,1.8,98.1526922,127.8778686,0.811297,16.5120137,18.8151,33181.5548132,42722.5790185,35.6864807,2270.6538359,2009.5401727,3995.8718191,30.9393142,36.4830164,2.1293956,110.8625731),(42194,'femur',253,7,84,402.4710345,98.0460016,126.8967173,1.8,98.1743617,127.4412125,0.8319686,16.4377677,18.7759979,32451.9264677,41304.6494464,36.658616,2199.8644068,1974.2295348,3915.5175555,30.6667834,36.1806482,2.2214232,110.0031971),(42195,'femur',253,7,85,399.4146513,98.0909622,126.6096651,1.8,98.2076483,127.0942376,0.8577924,16.4482378,18.3904859,31783.3022835,40163.2419989,38.0869515,2183.9141314,1932.3226421,3902.496746,30.3835299,35.6666924,2.115348,108.5361505),(42196,'femur',253,7,86,400.7349923,98.0817777,126.3084605,1.8,98.2301182,126.7590506,0.8730386,16.4433891,18.0926523,31274.196403,39084.5181743,39.2180888,2160.2425992,1901.9312961,3868.4217939,30.5958156,35.3207718,2.2094313,108.5361505),(42197,'femur',253,7,87,401.5393714,98.0415618,126.0564238,1.8,98.1421273,126.4202001,0.8630979,16.4045715,17.6850925,30951.8174714,38143.0380639,38.6406272,2156.790414,1886.7800066,3876.537766,30.5734541,34.815336,2.1896111,107.3208093),(42198,'femur',253,7,88,402.2454481,98.0724713,125.7939632,1.8,98.0997751,126.1792459,0.8631746,16.3193654,17.4908781,30603.486353,37270.3522675,38.7136523,2130.8451189,1875.2865428,3861.8625157,30.4385895,34.4876487,2.1069423,107.0691039),(42199,'femur',253,7,89,400.3045764,98.0384448,125.5229739,1.8,98.0134958,125.9164367,0.8575662,16.23195,17.1469636,30122.9690523,36524.0918702,38.1568773,2130.061787,1855.7825223,3848.4582303,30.2767823,34.1189589,2.2042222,106.2097279),(42200,'femur',253,7,90,400.791277,97.9789919,125.2942945,1.8,97.8886211,125.7443844,0.8656957,16.113112,17.0515812,29949.9307962,35738.9496801,38.7400042,2095.9317113,1858.7303824,3823.1519066,30.194513,33.8663934,2.1939957,105.2460921),(42201,'femur',253,7,91,396.7278113,98.0294902,125.0409416,1.8,98.1231307,125.3904792,0.8820217,16.2204214,16.8569305,29499.1098077,34946.6373511,39.4098341,2073.1317268,1818.6401601,3809.4381156,30.2479327,33.5184183,2.2014776,104.8901269),(42202,'femur',253,7,92,400.263342,98.0112883,124.8008289,1.8,98.0704888,125.2386562,0.9040733,16.1568493,16.6187519,29352.8454583,34414.2430615,41.1980414,2070.8079156,1816.7431591,3803.9818345,30.1994287,33.2529655,2.144463,104.3867161),(42203,'femur',253,7,93,399.5160309,97.9523881,124.5736049,1.8,98.0380957,125.0147512,0.9082107,16.0617488,16.5043058,29072.1529869,33784.373766,41.3886197,2047.0036199,1810.0241396,3782.0113507,30.1235945,33.0217395,2.1335335,103.7790455),(42204,'femur',253,7,94,398.2085582,97.9410338,124.4181502,1.8,98.0231074,124.8826162,0.9186482,15.9955995,16.3127625,28861.6009557,33230.0533712,41.9232856,2037.058616,1804.3463062,3787.9496943,30.049793,32.7748025,2.1697076,103.7790455),(42205,'femur',253,7,95,395.840292,97.8899356,124.2046627,1.8,98.0471885,124.6154556,0.9186599,15.9045126,16.1719583,28637.219094,32730.2460939,41.6747028,2023.8888461,1800.5719348,3779.7979445,29.9498074,32.5345044,2.1587989,102.9196695),(42206,'femur',253,7,96,391.7510338,97.8117361,123.9539503,1.8,97.8904831,124.2871535,0.9390482,15.8989023,16.1926365,28412.2513121,32115.6371943,42.5208613,1983.3482411,1787.0574237,3716.0263716,29.8978955,32.4208067,2.1771792,103.4230803),(42207,'femur',253,7,97,391.0934649,97.7900475,123.7311215,1.8,97.7941603,123.9557675,0.9670495,15.8421907,16.0713836,28254.5345559,31642.4965813,44.1728066,1968.8719644,1783.499202,3720.4545289,29.9255577,32.1778652,2.1662062,102.4594446),(42208,'femur',253,7,98,391.0539649,97.747667,123.537587,1.8,97.7132627,123.7276035,1.0094752,15.8180823,15.9198203,28223.079753,31209.6564103,46.708221,1960.4276837,1784.2289084,3662.4953851,29.8645774,32.0196855,2.2706892,102.4594446),(42209,'femur',253,7,99,390.6024003,97.7132422,123.376017,1.8,97.7395142,123.468256,1.0390961,15.8296359,15.8548145,28180.866432,30875.9505333,48.3664344,1947.4179639,1780.2599296,3685.4634913,29.9585436,31.8085231,2.2413179,102.2077391),(42210,'femur',253,7,100,392.2835566,97.6989739,123.281694,1.8,97.7357033,123.3399938,1.0739624,15.7601625,15.5909978,28222.5137728,30650.9343727,50.5267663,1965.9379633,1790.7501755,3676.5381286,29.9696042,31.6514142,2.4138229,101.851774),(42211,'femur',253,7,101,395.7783004,97.7007437,123.169516,1.8,97.7397254,123.2236488,1.0695346,15.7828132,15.489107,28289.39701,30465.8671218,50.7314299,1966.9221147,1792.4179042,3707.9118752,29.988635,31.5813372,2.5498165,101.2441034),(42212,'femur',253,7,102,394.9901465,97.6898389,123.0378868,1.8,97.7127363,123.1244284,1.0279772,15.8217543,15.4189796,28276.9323105,30025.3542278,48.2660881,1947.2984007,1787.2185197,3670.5243339,30.0708758,31.4729961,2.580099,101.6000686),(42213,'femur',253,7,103,396.0699067,97.6329155,122.8755489,1.8,97.6410637,122.966829,1.0359961,15.7921856,15.3677118,28349.0896595,29754.5154259,48.8642903,1936.1708383,1795.1340229,3663.9159857,30.0904592,31.3436706,2.6411518,100.6364328),(42214,'femur',253,7,104,396.750079,97.5739506,122.7219898,1.8,97.6021475,122.8421859,1.1012075,15.6802505,15.3187526,28456.1763257,29488.6586672,52.5843246,1925.0039169,1814.7781696,3640.3348149,29.9834107,31.2049354,2.2390857,100.992398),(42215,'femur',253,7,105,395.4053442,97.4829224,122.5229436,1.8,97.5239225,122.6415317,1.1523916,15.7602504,15.1489995,28493.4851896,29062.4138224,55.0218174,1918.4378351,1807.9335297,3625.492913,29.9834107,31.1516391,2.7149652,100.8881382),(42216,'femur',253,7,106,393.6708686,97.409999,122.3682012,1.8,97.4404089,122.4903174,-1.5552604,15.3629982,15.5644374,28452.1757693,28709.5381482,65.5959766,1844.5599682,1851.9936897,3582.6059342,30.07816,31.1190243,0.952152,100.0287622),(42217,'femur',253,7,107,393.2339067,97.3573266,122.2500926,1.8,97.3570681,122.4287053,-1.0557174,15.1398632,15.3080186,28304.9786237,28721.0462624,49.6354092,1876.2092575,1869.5663337,3578.0553343,30.2680614,31.0566644,1.3191064,100.6364328),(42218,'femur',253,7,108,394.3137788,97.3075944,122.1451217,1.8,97.3037917,122.3199648,-1.0020461,15.1244566,15.3780818,28211.3301681,28878.0005686,46.6560088,1877.8675339,1865.2789251,3583.3259033,30.2970021,31.272904,1.3491468,100.6364328),(42219,'femur',253,7,109,394.4713872,97.2359597,122.0401318,1.8,97.2029796,122.2552836,-0.9258641,15.1453872,15.3984789,28106.5061784,28935.4029992,41.9865831,1879.1078783,1855.7799739,3572.3275944,30.07816,31.3701669,1.3357841,100.0287622),(42220,'femur',253,7,110,391.7923242,97.1700281,121.9029669,1.8,97.1602261,122.0913552,-0.799643,14.9541526,15.3900348,27812.6126597,28899.1190753,33.5794016,1877.7812674,1859.8588289,3559.2846172,30.07816,31.2817586,1.2924967,100.0287622),(42221,'femur',253,7,111,391.9115515,97.0954993,121.843043,1.8,97.1057226,122.0083652,-0.855455,15.1054801,15.5160007,27777.5312353,29200.6100361,37.2203492,1881.9675582,1838.9042288,3536.7094476,30.07816,31.402521,1.2793395,100.3847274),(42222,'femur',253,7,112,396.0638643,97.0388529,121.776566,1.8,96.9909584,122.0049074,-0.932548,15.0863235,15.6555911,28020.8552188,29646.8714254,42.579166,1893.6922388,1857.3680448,3557.4508383,30.3657716,31.5813372,1.3093175,100.7406926),(42223,'femur',253,7,113,398.3803776,96.9698841,121.7280817,1.8,96.9248587,121.91983,-1.0881957,15.287005,15.6015839,28340.1719962,30067.5906644,52.0965825,1927.2139845,1853.8733996,3555.3516767,30.07816,31.6951337,1.296221,100.6364328),(42224,'femur',253,7,114,399.9853873,96.8826484,121.7337705,1.8,96.8466354,121.8980106,-1.2090468,15.5187673,15.6758567,28468.4518271,30570.4315922,58.3143326,1950.160189,1834.4531717,3574.6631128,30.07816,31.9388567,1.2703192,100.6364328),(42225,'femur',253,7,115,402.9712747,96.8433677,121.7249326,1.8,96.7862904,121.9011097,-1.2406513,15.6752493,15.8006889,28575.6200882,30975.9114804,60.1036475,1960.415247,1822.9770722,3602.1256944,30.3646807,31.9966124,1.3127891,100.992398),(42226,'femur',253,7,116,404.1731157,96.7725912,121.6767083,1.8,96.704467,121.8692135,-1.2653721,15.7683593,15.9164566,28615.3266873,31218.6650369,61.2713528,1961.4079824,1814.7307615,3623.5623041,30.1740457,31.9966124,1.9562902,101.3483631),(42227,'femur',253,7,117,404.4675195,96.7039048,121.6171573,1.8,96.5660302,121.7748137,-1.2873378,15.7721726,16.0289794,28615.7974975,31355.2662025,62.1383679,1956.1611187,1814.321862,3646.1702126,30.07816,32.1089371,1.2998495,101.2441034),(42228,'femur',253,7,118,407.1031101,96.6619459,121.6283678,1.8,96.5381507,121.7849,-1.3388551,15.9553362,16.1571686,28780.0960246,31873.1692715,64.2653682,1972.6952219,1803.7912612,3639.8512941,30.07816,32.1089371,1.8417432,101.2441034),(42229,'femur',253,7,119,411.6836007,96.6668227,121.7055169,1.8,96.5824565,121.8074879,-1.4347503,16.2367716,16.4400987,29114.1733929,32631.1911258,67.3518063,1984.8537235,1793.1011266,3610.827277,29.9801381,32.7607161,1.8635094,102.71115),(42230,'femur',253,7,120,415.6046761,96.6410796,121.6467963,1.8,96.5075634,121.7603174,-1.4519096,16.3326814,16.4372851,29469.4020076,32746.691173,68.2930207,1992.2201841,1804.3211164,3624.9927129,30.1033262,32.89289,1.9173352,102.71115),(42231,'femur',253,7,121,411.3904278,96.5239482,121.3815882,1.8,96.4670184,121.6085312,-1.3362564,16.1776508,15.959114,29387.3783023,32102.1523086,64.8620299,2011.5247136,1816.5417657,3631.1490992,30.169191,32.4890731,1.9218272,102.1034794),(42232,'femur',253,7,122,404.3190308,96.3516332,121.1191258,1.8,96.3289433,121.3545651,-1.0984492,15.6258846,16.0778254,28936.2419093,31430.2538373,53.4371857,1954.882144,1851.8146445,3656.7079568,30.2109477,32.1118121,0.4277349,101.851774),(42233,'femur',253,7,123,401.1506376,96.2892498,120.9513075,1.8,96.2385973,121.1504441,-0.9237473,15.3637976,16.3934806,28795.5742666,31163.3582932,42.5614449,1900.9604553,1874.2484743,3626.6536597,30.3063964,32.1118121,0.4277349,102.1034794),(42234,'femur',253,7,124,399.2666661,96.1718259,120.8100502,1.8,96.1165446,120.9852838,-0.8214805,15.2364515,16.521255,28496.0517812,31179.2541743,35.6712175,1887.2206888,1870.2551408,3604.5454646,30.305533,32.1376751,0.5174877,102.1034794),(42235,'femur',253,7,125,400.4683952,96.0304635,120.718103,1.8,95.940679,120.9039657,-0.8025568,15.0668699,16.5503234,28400.5693499,31388.2746863,34.5173914,1896.5354332,1884.9681138,3601.0018309,30.2949789,32.160647,0.3978744,101.851774),(42236,'femur',253,7,126,400.7588825,95.9232835,120.6342738,1.8,95.8571274,120.7986735,-0.7818426,14.8890336,16.5671128,28360.8615023,31504.1051484,33.1590884,1901.605036,1904.8154697,3599.4565261,30.0796946,32.3295606,0.4101273,101.6000686),(42237,'femur',253,7,127,400.1370091,95.8211781,120.5362683,1.8,95.727254,120.7702648,-0.7572392,15.0194004,16.6221044,28179.1566284,31476.1631942,31.4678375,1893.6328676,1876.1838586,3567.9463946,30.1729548,32.3295606,0.4101273,100.8881382),(42238,'femur',253,7,128,400.8832012,95.7530623,120.4549369,1.8,95.6739269,120.7334912,-0.7537968,14.9477413,16.8587008,28142.0939964,31510.9802206,31.2969311,1869.1226967,1882.6987614,3537.9198905,30.171864,32.3295606,0.4101273,101.851774),(42239,'femur',253,7,129,402.7835658,95.6954362,120.3586333,1.8,95.5936137,120.655125,-0.7892617,15.1423706,16.830328,28315.0673606,31567.0499948,33.8246574,1875.605156,1869.9230216,3551.80734,30.1729548,32.2380563,0.3681308,101.4958088),(42240,'femur',253,7,130,405.7520531,95.6118558,120.2925873,1.8,95.5075549,120.6353792,-0.8112074,15.1000688,16.8266194,28457.9153404,31732.7727613,35.5572556,1885.867383,1884.6215648,3566.1384259,30.171864,32.2380563,0.3681308,101.4958088),(42241,'femur',253,7,131,405.489876,95.5575098,120.1839584,1.8,95.4827736,120.5082703,-0.8258247,15.0461986,16.7932158,28458.5788146,31836.8909851,36.5199372,1895.8186065,1891.4132129,3585.6248534,30.0796946,32.2380563,0.3681308,101.6000686),(42242,'femur',253,7,132,402.0405627,95.4731699,120.0712063,1.8,95.474226,120.3271896,-0.8205327,15.1634565,16.771459,28326.4199776,31701.6426462,35.8556939,1890.2137661,1868.0714343,3572.8423579,30.169191,32.2380563,0.3681308,101.851774),(42243,'femur',253,7,133,399.8062944,95.3720425,119.9302763,1.8,95.3294285,120.2758287,-0.790395,14.9244555,16.4597564,28140.5474898,31488.7247332,33.6501444,1913.0735614,1885.5326108,3585.7715462,30.1729548,32.2380563,0.3681308,101.6000686),(42244,'femur',253,7,134,396.2699245,95.2694255,119.7929897,1.8,95.262914,120.1429336,-0.7545686,14.9984452,16.5009956,27977.0185479,31275.1782936,30.9876436,1895.3509866,1865.3279206,3562.835815,30.3024475,32.2380563,1.2026656,101.2441034),(42245,'femur',253,7,135,394.2314778,95.1869323,119.6872301,1.8,95.24238,120.1565259,-0.73511,15.000249,16.5284557,27911.4638274,31124.8138537,29.5539974,1883.1047723,1860.7333705,3548.7986808,30.1729548,32.3438348,1.2322406,101.2441034),(42246,'femur',253,7,136,392.0369892,95.1122962,119.5522666,1.8,95.2096838,119.9737545,-0.7401323,15.0835946,16.4828741,27856.6754954,31066.9037438,29.7161359,1884.7989445,1846.8194268,3545.691918,30.3039902,32.3295606,1.160669,101.851774),(42247,'femur',253,7,137,387.0871232,95.0397207,119.3694866,1.8,95.19366,119.7685573,-0.7457175,15.0169593,16.4000871,27614.9030474,30810.5829083,29.6999672,1878.6840995,1838.9144171,3525.1735903,30.169191,32.3295606,1.160669,101.2441034),(42248,'femur',253,7,138,383.1424373,94.9995338,119.2838773,1.8,95.2335614,119.6131986,-0.7481961,15.0772986,16.3427156,27465.8339434,30540.1991696,29.5551117,1868.7346603,1821.6681013,3523.9789281,30.1676482,32.3295606,1.160669,101.2441034),(42249,'femur',253,7,139,379.7750334,94.9486551,119.2040971,1.8,95.1767792,119.4330069,-0.7796325,15.0020959,16.2544925,27292.8450834,30372.8662517,31.2829835,1868.5828664,1819.2688065,3493.4347899,30.032849,32.3295606,1.160669,101.2441034),(42250,'femur',253,7,140,377.7298728,94.9054431,119.1563425,1.8,95.1349869,119.4164125,-0.8254153,15.0589089,16.2864306,27093.3533099,30278.8110239,33.9940809,1859.1434611,1799.1577936,3485.0734732,29.896507,32.5117967,1.0598468,101.6000686),(42251,'femur',253,7,141,376.7080758,94.8684866,119.1209858,1.8,95.1091757,119.4232858,-0.8661349,15.2818864,16.3075044,26988.3962277,30239.291658,36.4393709,1854.3175589,1766.0382656,3470.3501204,29.8377629,32.5117967,1.0598468,101.851774),(42252,'femur',253,7,142,375.204166,94.8433594,119.0789882,1.8,95.0892006,119.3873401,-0.9070463,15.315893,16.2847694,26950.2219292,30205.8380911,38.7993376,1854.8520565,1759.6245855,3458.2628164,29.8206135,32.5117967,1.0598468,102.1034794),(42253,'femur',253,7,143,375.2234685,94.7812803,119.0489055,1.8,94.9086684,119.4529722,-0.945804,15.3510578,16.1678523,26925.0759033,30238.1453933,41.1287748,1870.2635821,1753.9557323,3469.0029679,29.8377629,32.5117967,1.0598468,101.851774),(42254,'femur',253,7,144,375.9799552,94.7287726,119.0472368,1.8,94.8200746,119.5716298,-0.9781232,15.3130076,16.1290883,26959.9755155,30331.6386504,43.1116247,1880.5550596,1760.5930949,3478.0417409,29.8630196,32.5117967,1.0598468,101.851774),(42255,'femur',253,7,145,374.4251878,94.7105477,118.9710874,1.8,94.822846,119.5308486,-1.0098198,15.3821639,16.1263555,26878.2876608,30282.212606,44.7414306,1877.8088152,1747.3671388,3466.3276804,29.9565118,32.5713708,1.0303768,101.851774),(42256,'femur',253,7,146,374.1788442,94.69084,118.9213801,1.8,94.8364842,119.5094034,-1.0287812,15.4137036,16.0813849,26924.0456274,30316.0040579,45.7673752,1885.1612764,1746.7603049,3469.1898176,29.9566647,32.6817201,1.0777454,101.7475142),(42257,'femur',253,7,147,373.124373,94.6549564,118.8604968,1.8,94.7893177,119.3421103,-1.0340705,15.424937,16.1335334,26923.5855127,30335.3423737,45.9282989,1880.2664945,1745.4583748,3459.774133,29.9566647,32.6817201,1.0777454,101.391549),(42258,'femur',253,7,148,372.8324869,94.6316813,118.8139814,1.8,94.7595001,119.2646488,-1.0408518,15.4471314,16.1849653,26973.2978434,30346.6298608,46.2613309,1874.9888711,1746.1687297,3466.3506961,30.0498402,32.5117967,1.0598468,101.1398436),(42259,'femur',253,7,149,372.295768,94.5960202,118.7802243,1.8,94.731259,119.1827953,-1.0571233,15.5016309,16.2978971,27059.2382252,30329.1638154,47.0672545,1860.9249833,1745.5736397,3466.1464004,30.2038266,32.4293479,1.012197,101.6432544),(42260,'femur',253,7,150,371.4766183,94.5528744,118.7429382,1.8,94.7649585,119.1078626,-1.0570899,15.4937868,16.3090944,27126.8962336,30247.694282,46.9619234,1854.6519789,1750.8241546,3460.7425076,30.1655404,32.4293479,1.012197,101.6432544),(42261,'femur',253,7,151,369.3154194,94.4929188,118.7074804,1.8,94.6602961,119.0096289,-1.0586475,15.5410515,16.3607201,27145.9568648,30136.2192655,46.770692,1841.9861195,1746.7258776,3438.2104162,30.2500325,32.5345044,0.9827937,101.391549),(42262,'femur',253,7,152,367.8178879,94.4492147,118.6893629,1.8,94.5605503,118.9922682,-1.0687664,15.5423652,16.3684433,27168.8951548,30060.0845184,47.1077136,1836.4656876,1748.0541002,3433.4399961,30.2970021,32.5345044,0.9827937,101.391549),(42263,'femur',253,7,153,365.9669263,94.4367861,118.643456,1.8,94.5632691,118.9868651,-1.069571,15.5455712,16.4037208,27170.565012,29963.3723563,46.9120341,1826.6204742,1747.8010126,3434.0366933,30.2970021,32.5345044,0.9827937,101.6432544),(42264,'femur',253,7,154,364.7999975,94.3859296,118.6020374,1.8,94.4812737,118.9567425,-1.0478538,15.6532438,16.3830605,27194.5823129,29911.8184973,45.6345414,1825.7772115,1737.3128974,3411.5801528,30.4509885,32.5345044,0.9827937,101.391549),(42265,'femur',253,7,155,363.2934582,94.3744473,118.5792271,1.8,94.5714313,118.9294084,-1.0220504,15.6240991,16.4086212,27128.8090138,29838.7364607,44.0744565,1818.4792089,1736.3438958,3388.1553953,30.4874684,32.5713708,1.0303768,101.7475142),(42266,'femur',253,7,156,361.8133827,94.3504166,118.5934647,1.8,94.6136407,119.0424601,-1.0099319,15.7393662,16.3381205,27031.8741612,29769.8768143,43.2404871,1822.111471,1717.4690417,3382.5646597,30.507848,32.5713708,1.0303768,101.7475142),(42267,'femur',253,7,157,361.5757113,94.3507136,118.5919047,1.8,94.6372316,119.0926805,-0.9925323,15.8243244,16.3794936,27018.963492,29772.1615836,42.2597727,1817.6484782,1707.4323609,3372.2112627,30.507848,32.6591148,1.0010399,101.9992196),(42268,'femur',253,7,158,361.8540577,94.299243,118.6246658,1.8,94.6249153,119.190701,-1.0051797,15.8045174,16.3635336,27072.8749905,29828.1195443,42.9865774,1822.8409789,1712.9833342,3387.6455171,30.507848,32.6675936,0.9536049,102.250925),(42269,'femur',253,7,159,361.6570052,94.2685266,118.6015473,1.8,94.6032606,119.119634,-0.9791839,15.8693327,16.4039657,27128.4860893,29902.5432231,41.528503,1822.8850094,1709.4912986,3392.3506257,30.5574974,32.7748025,0.9718851,102.6068902),(42270,'femur',253,7,160,358.4693655,94.2225112,118.5825726,1.8,94.3413974,119.1175889,-0.9510285,15.8261804,16.3147337,27202.3009689,29895.294776,39.5880246,1832.4108345,1718.816563,3394.8056301,30.7114735,32.6675936,0.9536049,102.6068902),(42271,'femur',253,7,161,355.9681645,94.1584141,118.490443,1.8,94.1387407,119.0713019,-0.9059345,15.7658846,16.1937438,27190.6027185,29891.3701581,36.7461288,1845.8591471,1724.6480896,3397.9359022,30.5574974,32.6675936,0.9536049,102.3551848),(42272,'femur',253,7,162,355.5558201,94.1275048,118.4784474,1.8,94.1007469,119.0598073,-0.8699228,15.7909317,16.0838385,27247.9824884,30004.8542912,34.6146972,1865.5282041,1725.5462195,3392.8932407,30.5574974,32.940567,1.0370881,102.6068902),(42273,'femur',253,7,163,354.7973752,94.081096,118.475997,1.8,94.041271,119.0564525,-0.8393575,15.7807038,16.0222275,27320.0183222,30082.6183981,32.7510318,1877.5553155,1731.2293957,3404.8936451,30.5574974,32.940567,1.0370881,102.6068902),(42274,'femur',253,7,164,354.5108043,94.0530425,118.4884023,1.8,94.0501641,119.0563952,-0.7973422,15.718852,16.0715068,27370.2431483,30269.5863071,30.2482124,1883.431753,1741.236773,3403.6288664,30.6585218,33.0217395,1.0080591,102.8585956),(42275,'femur',253,7,165,355.7102954,93.9859762,118.5386567,1.8,94.0334038,119.1489574,-0.7793675,15.6785445,16.1629518,27393.9900094,30629.7877412,29.2850041,1895.061501,1747.2278736,3409.1836384,30.5360723,33.1612253,1.0259324,102.8585956),(42276,'femur',253,7,166,356.7860273,93.93741,118.5714435,1.8,94.1190665,119.0457145,-0.7748329,15.6675991,16.2329317,27397.8073271,31022.7786945,29.1039619,1911.1014142,1748.6921347,3417.2749293,30.5766743,33.1612253,1.0259324,103.2145608),(42277,'femur',253,7,167,355.1914801,93.8739247,118.5642576,1.8,94.0367394,118.9654708,-0.7576711,15.6153229,16.3179731,27346.6602778,31257.2328177,27.9587295,1915.5095213,1751.2708786,3430.3148634,30.5751315,33.2640683,1.0724805,103.2145608),(42278,'femur',253,7,168,355.7549987,93.7933641,118.5886375,1.8,93.9867605,118.977843,-0.7243636,15.5988472,16.4675016,27449.3714376,31595.738587,26.0363385,1918.6722629,1759.7051314,3465.5614311,30.5751315,33.2640683,1.0724805,103.2145608),(42279,'femur',253,7,169,354.5467795,93.6955273,118.5799772,1.8,93.9747488,118.8866634,-0.7018978,15.6982851,16.5763906,27514.0658999,31712.7549206,24.634338,1913.1278711,1752.6797187,3480.1616254,30.5574974,33.3112141,1.0436504,103.2145608),(42280,'femur',253,7,170,353.9829812,93.6369765,118.6109908,1.8,93.8801713,118.9022919,-0.6799844,15.7030214,16.6736987,27580.1347088,31966.1900804,23.3254381,1917.1625146,1756.358474,3508.4304967,30.7114735,33.4715644,1.0612041,103.570526),(42281,'femur',253,7,171,354.9508993,93.5747478,118.6254525,1.8,93.8437439,118.8761679,-0.6414739,15.6031875,16.7700484,27627.6295983,32481.0449361,21.1819913,1936.8486125,1770.6401075,3522.5908963,30.7492232,33.5294332,1.0325746,104.1781966),(42282,'femur',253,7,172,357.5609213,93.5276111,118.6714988,1.8,93.8531188,118.968746,-0.6023074,15.5175183,16.8490013,27793.2717798,33018.8123355,19.1279399,1959.6895814,1791.0899974,3575.9516803,30.8462728,33.5294332,1.0325746,104.1781966),(42283,'femur',253,7,173,357.2618737,93.4820123,118.6844489,1.8,93.9183274,118.9390721,-0.5759783,15.5530552,17.0152655,27900.6825126,33392.4651108,17.6635992,1962.5003895,1793.9036494,3582.155771,30.8478155,33.751712,1.0216434,104.5341617),(42284,'femur',253,7,174,359.4442213,93.4594316,118.6870875,1.8,93.8924386,118.9818388,-0.5509699,15.4765657,17.0351407,28073.3521724,34028.5429232,16.4186162,1997.5498579,1813.9264734,3619.4457007,30.8478155,33.751712,1.0216434,104.7858671),(42285,'femur',253,7,175,359.9846329,93.3683452,118.6995461,1.8,93.6867961,118.9646019,-0.5278815,15.4646357,17.1101843,28231.3520361,34570.1922256,15.2224342,2020.4453487,1825.5426466,3644.9915955,31.0580683,33.7735861,0.9298397,106.0012083),(42286,'femur',253,7,176,360.1629984,93.2911785,118.7274659,1.8,93.664248,118.9384799,-0.5055354,15.452893,17.1737401,28393.7539104,35019.5909608,14.077762,2039.1359569,1837.4393669,3680.595534,31.1189568,33.8990882,1.0390723,106.0012083),(42287,'femur',253,7,177,362.797582,93.2529853,118.7192503,1.8,93.6747027,118.9862906,-0.4608817,15.4549615,17.154938,28574.0802605,35592.4979664,11.959736,2074.7669223,1848.8613032,3698.9623633,31.2552988,34.245891,0.3058789,106.3571735),(42288,'femur',253,7,178,365.8318094,93.227244,118.7425293,1.8,93.6923674,118.9390225,-0.4161928,15.5818385,17.3945767,28899.7854829,36167.0412824,9.9654579,2079.2136543,1854.709602,3737.643251,31.367224,34.4099344,0.2782997,106.6088789),(42289,'femur',253,7,179,368.4967733,93.1392085,118.7527703,1.8,93.4555284,118.8811318,-0.3957112,15.6571803,17.5415258,29167.9039504,36914.4649244,9.1253858,2104.4044483,1862.9091175,3764.7202423,31.367224,34.7861563,0.3139382,107.3208093),(42290,'femur',253,7,180,372.0990512,93.1106723,118.7642448,1.8,93.2494313,118.7496544,-0.3751084,15.8571666,17.6541353,29543.8601861,37598.5850605,8.3244445,2129.732462,1863.1235335,3796.0865475,31.5770309,35.1845999,0.1470784,108.2844451),(42291,'femur',253,7,181,375.622385,93.0693719,118.8200946,1.8,93.0993078,118.6986576,-0.3413463,15.976649,17.78237,30053.7070939,38348.5374459,7.0154743,2156.548171,1881.1020456,3843.098593,31.772778,35.4772438,0.1950203,108.5361505),(42292,'femur',253,7,182,379.2653938,92.9973698,118.864292,1.8,92.9301675,118.9313748,-0.3150676,16.1421147,17.9805743,30473.5609217,39091.1679816,6.069896,2174.0778314,1887.8295353,3868.3467968,31.796912,35.9220196,0.119904,109.2480809),(42293,'femur',253,7,183,381.6536338,92.9346786,118.9058866,1.8,92.9081956,118.9785198,-0.283349,16.3043988,18.0860272,30852.5972271,39740.5937641,4.9717294,2197.3091926,1892.2867179,3888.0767203,31.796912,36.4019542,0.1302114,110.1074569),(42294,'femur',253,7,184,380.7986767,92.9369132,118.9257331,1.8,92.8702673,118.7974184,-0.2370288,16.5569953,18.2056785,31316.5645649,40293.1648466,3.4994351,2213.2196177,1891.440079,3927.8910047,32.2081501,36.6647511,0.1767089,110.7151275),(42295,'femur',253,7,185,382.4222615,92.945293,118.9218454,1.8,92.8710089,118.6747772,-0.1986134,16.8384011,18.3050014,31707.9024885,41015.6145715,2.481367,2240.678039,1883.0708643,3968.662221,32.2266,37.0878247,0.1746722,111.5745035),(42296,'femur',253,7,186,386.9739943,92.9107259,118.9915875,1.8,92.8183778,118.792239,-0.1579058,16.9898473,18.6189142,32278.8330751,41628.1920885,1.5948296,2235.8012733,1899.8895329,3961.3506868,32.2266,37.5110487,0.1726815,113.0415501),(42297,'femur',253,7,187,389.4483958,92.9119727,118.997124,1.8,92.8618387,118.8037773,-0.1255488,17.3309303,18.9669678,32693.1151479,42237.1288374,1.0177494,2226.878288,1886.4027781,3938.2520775,32.656288,38.0097837,0.1019184,114.8645619),(42298,'femur',253,7,188,391.7970798,92.95508,119.0850916,1.8,92.873409,118.8612657,-0.0829302,17.4835564,19.1205559,33202.8406941,42991.6688841,0.4480635,2248.4528727,1899.0896356,3973.3250671,32.656288,38.2229153,0.1466665,117.4426899),(42299,'femur',253,7,189,392.541034,92.9416224,119.0791957,1.8,92.833984,118.8867491,-0.0354501,17.9297121,19.4964613,33615.125467,43555.1409601,0.0821839,2234.0023753,1874.8279517,3955.1442199,33.085976,38.6480411,0.1450417,115.9756433),(42300,'femur',253,7,190,396.6487553,92.9948636,119.1477125,1.8,92.9142426,118.9487461,0.0107078,17.9696927,19.5414304,33992.2113191,44644.7360881,0.0075794,2284.6196588,1891.641219,4001.8655377,33.085976,38.7815737,0.1669702,118.3020659),(42301,'femur',253,7,191,401.6818176,93.0733867,119.2505497,1.8,92.950227,119.0804057,0.0377322,18.3761319,20.0693623,34494.5291732,45733.0356792,0.0952684,2278.7488233,1877.1376531,3994.6549833,33.515664,39.2923774,0.0985805,118.5537713),(42302,'femur',253,7,192,405.2727938,93.1608559,119.3554831,1.8,93.0157262,119.2045024,0.0751364,18.474428,20.2433354,34927.6666133,46683.0877819,0.3806095,2306.096642,1890.5952907,4026.9290179,33.515664,39.4401157,0.1311116,119.0571821),(42303,'femur',253,7,193,408.4470057,93.2283926,119.4861443,1.8,93.0528779,119.2662089,0.0941001,18.76454,20.5633974,35437.6886319,47568.0729353,0.6010111,2313.2399729,1888.5455527,4026.2180411,33.8987948,39.7200017,0.0975158,120.5242287),(42304,'femur',253,7,194,413.1964064,93.2387076,119.5922667,1.8,93.035807,119.3932179,0.1174301,18.8653216,20.797756,36008.1657471,48430.8238334,0.9452948,2328.6562158,1908.6960986,4059.6305854,33.945352,40.1085611,0.0858103,121.1318993),(42305,'femur',253,7,195,420.9426606,93.3042503,119.7170193,1.8,93.0343739,119.5653374,0.1469367,19.1427094,20.9430458,36640.5751757,49757.7164537,1.5038502,2375.8586466,1914.074668,4125.1902602,34.2361866,40.1913351,0.1071153,122.2429807),(42306,'femur',253,7,196,423.9354857,93.4381786,119.8724034,1.8,93.0690375,119.6621425,0.1824393,19.3072697,21.2857964,37011.1838064,50749.6154309,2.3257423,2384.2009263,1916.9558578,4109.0625667,34.37504,40.6185864,0.1059844,123.3540621),(42307,'femur',253,7,197,429.4875871,93.5713117,119.985964,1.8,93.0414627,119.8376997,0.2038819,19.6114224,21.5706841,37693.3628245,51719.3780587,2.9344787,2397.6698131,1922.0106594,4137.7893346,34.7065305,40.6662862,0.1164915,124.5694033),(42308,'femur',253,7,198,435.9816462,93.5989271,120.1562133,1.8,93.0585712,119.9902932,0.2220951,19.7141778,21.7974729,38402.2797651,53414.059071,3.525675,2450.4702592,1947.9523937,4210.2131752,34.9463378,41.0458886,3.0367157,125.4287793),(42309,'femur',253,7,199,441.0665732,93.6560093,120.3061889,1.8,93.0352537,120.0925289,0.2236496,19.962956,21.9806172,39319.3642946,54909.4898213,3.6160644,2498.0868089,1969.6163361,4273.6882183,35.2293827,41.4309261,0.0934768,127.3992367),(42310,'femur',253,7,200,447.3668808,93.6376804,120.5493945,1.8,92.9906831,120.2647943,0.2215017,20.0410533,22.3412476,40356.5770763,56601.3210659,3.5987565,2533.4897138,2013.6954093,4339.2195739,35.532554,41.8212485,0.082288,129.4739539),(42311,'femur',253,7,201,452.8793702,93.6717951,120.628894,1.8,92.9491691,120.3490261,0.2117404,20.220364,22.4842962,41425.8332045,58801.037424,3.3337943,2615.2047135,2048.7184695,4457.1739342,35.8096618,42.1882725,3.0804445,131.0884461),(42312,'femur',253,7,202,457.4650081,93.6784666,120.8103753,1.8,92.9315441,120.4838225,0.218451,20.4875805,22.7650464,42804.6060157,60577.6972624,3.5809272,2660.9959973,2089.2953186,4539.7876382,36.0487597,42.6453164,3.0710031,132.6597525),(42313,'femur',253,7,203,467.6155038,93.6790998,121.0289976,1.8,92.8849607,120.679689,0.2023694,20.7238077,22.9023948,44474.0675943,63224.28522,3.1484067,2760.5971281,2146.0374558,4701.707774,36.4940943,42.8008936,3.0309354,133.9182795),(42314,'femur',253,7,204,480.9834039,93.6867719,121.2630798,1.8,92.8321866,120.855634,0.1818422,20.8292728,23.1283418,46609.6570599,66432.0185116,2.6216573,2872.3208508,2237.6996835,4884.6033743,36.8221803,43.4749986,0.0593362,136.4964075),(42315,'femur',253,7,205,488.4546127,93.7293072,121.4975615,1.8,92.7991972,121.0412267,0.1674947,21.0339683,23.3535335,48555.5088668,69226.0733827,2.262612,2964.2654866,2308.4331132,5015.6185963,37.3814327,43.6551166,3.0331093,138.5711247),(42316,'femur',253,7,206,504.7536822,93.6905504,121.7775557,1.8,92.719771,121.2948675,0.1552154,21.243073,23.501152,51278.4944526,73394.9400363,2.0105144,3123.0358413,2413.8924932,5251.7731001,37.9638947,44.3328915,0.0581867,140.8975473),(42317,'femur',253,7,207,524.5274658,93.6080182,122.2361958,1.8,92.5710235,121.7117939,0.1168911,21.3758857,23.5564063,54892.9481654,79525.6843085,1.1890522,3375.9684435,2567.9847332,5581.4201587,38.7131728,45.9304114,2.8080083,148.2327803),(42318,'femur',253,7,208,560.953693,93.464266,122.7980808,1.8,92.4268555,122.176628,0.068718,21.3331452,23.3773581,59641.3348651,90663.0812367,0.4407918,3878.2432473,2795.7122301,6144.4282905,39.5878276,46.9226379,2.7763912,150.1600519),(42319,'femur',253,7,209,600.9454954,93.1879618,123.4413105,1.8,92.2616143,122.6856698,0.0340115,21.7000185,23.3441007,65876.8373208,104526.7053766,0.1158156,4477.6496937,3035.7963605,6868.2393989,40.8937779,47.7959097,2.7544086,153.1984049),(42320,'femur',253,7,210,641.3809177,92.9748118,124.1937488,1.8,92.1289038,123.3119392,0.019557,22.5052216,23.9374959,73373.1856838,118449.3531033,0.0408804,4948.2766945,3260.2738605,7539.9160154,42.3135271,48.8334315,2.6464594,157.3478392),(42321,'femur',253,7,211,690.6353048,92.652329,125.1253532,1.8,91.9781115,124.1042312,-0.0076804,23.4911287,24.6425291,83678.6094365,134408.4055454,0.0067897,5454.326752,3562.1366126,8420.2075046,44.6248818,50.5372276,2.4827866,164.8305178),(42322,'femur',253,7,212,762.1750831,92.4762424,126.5763173,1.8,92.1251333,125.8064334,-0.0162685,27.1210412,24.8503014,104783.3811151,155450.5921664,0.0336171,6255.4811518,3863.5456625,7978.2631737,49.040562,53.6439268,2.4355728,180.3603598),(42323,'femur',253,7,213,892.3152531,93.7756334,129.4462174,1.8,93.3591274,128.4621316,0.4357503,28.5756756,32.273229,144480.2597791,207869.7681097,26.4958992,6440.9349362,5056.0575274,10473.4722059,50.5803284,64.7746643,2.3139661,219.3197615),(42324,'femur',253,7,214,993.5902589,94.4608335,131.3052155,1.8,93.6292888,129.8014766,0.5533802,29.1682654,33.5514088,169807.8512801,252256.8502793,45.7415093,7518.5173888,5821.6643732,12332.0026796,51.6919052,67.519833,2.3111799,227.5575563),(42325,'femur',253,7,215,1084.0575919,94.4205208,132.4533217,1.8,93.4324329,130.7953424,0.6042901,30.2080572,34.5375775,199691.7110407,282168.7560974,58.3270513,8169.9058482,6610.5446623,13872.6126024,52.6754076,69.0836219,2.2989883,226.9319976),(42326,'femur',253,7,216,1163.5256265,94.0281374,133.1628768,1.8,92.5103447,131.8308227,0.6496245,35.0990422,35.5924509,235613.5425037,308135.3223285,70.9535038,8657.3223866,6712.81972,15101.5741525,57.2304375,70.6180169,2.2959228,240.3871224),(42327,'femur',253,7,217,1254.3909249,93.0666236,133.8827743,1.8,91.914545,132.3337907,0.5822533,35.7552328,36.4554448,288082.6472,332861.2618254,63.2208945,9130.6323092,8057.0765239,16803.7970958,59.0624648,72.138972,2.2464675,245.291673),(42328,'femur',253,7,218,1311.4204918,92.6985445,134.0755287,1.8,91.4951244,132.6274103,0.6611671,37.4182709,37.3161415,314241.2018545,350387.5054003,82.4103639,9389.703535,8398.0684917,17498.0023692,60.3106198,73.226198,2.2647833,249.7970725),(42329,'femur',253,7,219,1347.464755,92.5057984,133.970579,1.8,91.2571871,132.6604523,0.8105032,38.4999493,37.5542233,332215.1289509,363373.7916221,117.924392,9675.9767612,8628.9757508,18040.59508,61.1805052,74.0124328,2.2863494,251.0987854),(42330,'femur',253,7,220,1369.288287,92.4650583,133.6942381,1.8,91.0725057,132.6250694,0.9770806,38.9158973,36.6730285,343669.4398942,375761.3104252,156.7884429,10246.2579801,8831.0809544,18318.8169338,61.7545888,74.3844413,2.2744101,252.565832),(42331,'femur',253,7,221,1389.1356436,92.4393691,133.3293572,1.8,90.9819797,132.5034415,1.0907635,38.4096248,36.2941957,347171.3838774,386442.941254,182.1465055,10647.5135588,9038.6559525,18438.3837036,61.8948648,74.5790339,2.2950463,254.8490687),(42332,'femur',253,7,222,1382.8121731,92.4363325,132.9142914,1.8,90.9524553,132.3115396,1.1574582,38.0656523,36.2697646,345824.9498859,393982.0854509,193.2854282,10862.5487314,9084.9605595,18329.2951324,61.943283,74.6631586,0.8627943,256.8195261),(42333,'femur',253,7,223,1363.6029151,92.4405123,132.5712448,1.8,91.0050969,132.0719309,1.2175265,37.3070758,35.9700705,343434.2262125,391938.9613993,200.0647468,10896.2522373,9205.6056016,18111.7643243,61.8262928,75.2248585,0.8541157,258.2865727),(42334,'femur',253,7,224,1313.9212453,92.5227422,132.2459345,1.8,91.079101,131.7185454,1.232241,37.2633561,35.7742834,336019.7019883,382986.9000057,194.8311124,10705.6484036,9017.429909,17706.1273429,61.6311086,75.1597888,0.8906983,260.6129953),(42335,'femur',253,7,225,1219.6360629,92.6552304,131.9973042,1.8,91.15324,131.1519613,1.3096096,35.8748401,35.3608981,317660.3927522,358698.4040021,189.718188,10143.927991,8854.6845488,16673.9857806,61.4317922,75.0983507,0.8826514,267.4016317),(42336,'femur',253,7,226,1160.7134048,92.8280168,131.7171146,1.8,91.3464151,130.7209445,1.3005166,35.8674054,35.1157253,297506.6308506,343217.4920341,179.6611169,9773.8972742,8294.623696,15793.8619243,61.0086321,74.7669467,0.8790014,270.7959499),(42337,'femur',253,7,227,1107.4825528,92.909958,131.4729377,1.8,91.5150418,130.3863188,1.3176824,35.3646908,34.6706219,280368.2559657,324266.4010129,173.0053629,9352.771393,7927.9148085,15039.3366928,60.4551763,74.2216838,0.8879181,267.7575969),(42338,'femur',253,7,228,1074.9427686,92.9029906,131.2495408,1.8,91.6282108,130.0708551,1.32791,34.7059275,34.274229,266589.0929971,305499.318955,168.7941857,8913.3826814,7681.3706598,14397.5934798,59.615361,73.5570135,0.8805457,260.5698095),(42339,'femur',253,7,229,1024.898717,92.8431074,130.9125914,1.8,91.7074864,129.740354,1.3250026,33.9490646,33.6410985,250264.3702975,280759.0551991,160.7028066,8345.7160271,7371.7604041,13609.3158559,58.5370326,72.5193184,0.8608847,255.0575883),(42340,'femur',253,7,230,973.8085865,92.8478477,130.5206555,1.8,91.8128334,129.3107357,1.1690293,35.6332152,33.9263099,231984.2502802,255028.6582398,137.4828853,7517.1351867,6510.3373107,12785.7353598,57.3216398,71.0286091,0.8667632,249.588553),(42341,'femur',253,7,231,910.4472126,93.1003015,129.8120221,1.8,92.0239155,128.7615898,0.873747,37.1678486,35.331735,202076.1423521,227628.3122185,89.2071044,6442.6021629,5436.8533603,11536.2493034,56.2920455,69.658508,2.3081964,245.7518979),(42342,'femur',253,7,232,852.3651327,93.2406063,129.0908909,1.8,92.3949506,128.004038,0.6701415,31.2309263,34.8405645,173115.4843534,204816.1606491,54.8015901,5878.6694107,5543.0787564,10833.6478775,54.5409215,68.0835178,2.3294152,232.5484786),(42343,'femur',253,7,233,786.2105038,93.32419,128.4500349,1.8,92.5480858,127.4241654,0.5143626,29.8425142,32.7943813,147148.6897985,179169.6275753,31.716304,5463.4245413,4930.8409026,9750.8214382,52.421936,65.6987191,2.3099312,223.1385284),(42344,'femur',253,7,234,723.178334,93.5619035,127.770297,1.8,92.7638173,126.8978502,0.4173833,28.6054932,30.8334497,121987.1665494,156207.3786642,19.8060091,5066.1661399,4264.466465,8637.7790267,49.843808,63.5197468,2.3801134,214.692214),(42345,'femur',253,7,235,659.1562582,93.711331,127.041685,1.8,92.8846457,126.4150725,0.3261111,26.9609058,28.8547255,97691.2573993,136057.2696231,11.2750309,4715.2508798,3623.4412173,7582.4855835,47.695368,61.1622796,2.4108663,204.2322564),(42346,'femur',253,7,236,599.6710326,93.7763118,126.4387226,1.8,92.9229983,126.0128252,0.2261648,25.1592587,26.7587153,77858.8230969,119140.7498924,5.0256754,4452.4091956,3094.638992,6701.2345623,44.687552,58.5385838,2.4393357,194.3799694),(42347,'femur',253,7,237,541.5339548,93.6512558,125.9435093,1.8,92.845769,125.7194846,0.1465879,23.0408554,25.3453093,60354.3735343,103936.963891,1.925562,4100.8362849,2619.4502159,5901.501099,41.679736,55.70056,2.47649,182.8521162),(42348,'femur',253,7,238,480.4633018,93.5538068,125.6294777,1.8,92.7729073,125.5035428,0.1081953,21.1944504,24.4712728,45043.3718267,89332.1629599,0.9337496,3650.4910773,2125.2436791,5093.5942285,38.67192,53.0260062,2.4883674,174.0498366),(42349,'femur',253,7,239,416.1822379,93.5088587,125.4646361,1.8,92.7858742,125.4255508,0.0718308,19.1339172,23.5045585,31437.0889866,74877.1483133,0.3572785,3185.6436852,1643.0032915,4291.2760487,35.664104,50.0600351,2.5702552,166.4197124),(42350,'femur',253,7,240,322.1055775,93.5971631,125.4660854,1.8,92.8177643,125.4595656,0.0432291,16.9623874,22.5079985,19438.0036708,59529.8019249,0.1002602,2644.8287663,1145.9473948,3368.6724526,22.773464,32.3666604,1.4777326,89.6119904),(42351,'femur',253,7,241,220.3431998,94.0632681,125.615025,1.8,93.0911027,125.5241539,0.0101386,14.18058,21.4768698,9402.8983363,42186.9445611,0.0037748,1964.2967047,663.0827752,2340.3761076,16.757832,27.6206174,1.6642731,73.4134038),(42352,'femur',253,7,242,114.5664796,96.0019607,125.4374622,1.8,94.5135491,125.5786557,-0.0296481,10.3304398,20.8620365,2439.2471199,21721.8331218,0.0167793,1041.2134543,236.1222924,1145.97063,10.7422,20.73662,1.6745887,53.1696427),(42353,'femur',253,7,243,13.0554808,107.8124013,124.0238306,1.8,106.8621035,124.0925923,-0.1715964,4.9201095,28.0210577,61.7001334,185.7719451,0.0634441,6.6297264,12.5403983,8.8164655,7.6720481,10.7765202,1.160669,29.2977461),(42354,'femur',253,7,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42355,'femur',253,7,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42356,'femur',253,7,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42357,'femur',253,7,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42358,'femur',253,7,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42359,'femur',253,7,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42360,'femur',253,7,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42361,'femur',253,7,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42362,'femur',253,7,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42363,'femur',253,7,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42364,'femur',253,7,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42365,'femur',253,7,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42366,'femur',253,7,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42367,'femur',253,7,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42368,'femur',253,7,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42369,'femur',253,7,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42370,'femur',253,7,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42371,'femur',253,7,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42372,'femur',253,7,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42373,'femur',253,7,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42374,'femur',253,7,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42375,'metatarsal.tif',253,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42376,'metatarsal.tif',253,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42377,'metatarsal.tif',253,10,3,17.9950523,97.2258392,97.774064,1.8,97.3663994,97.8411595,-0.1505688,3.6382085,4.7221966,40.758515,65.8465964,0.0674819,13.9440608,11.2029081,22.498586,7.304696,9.6560368,0.363979,26.8670637),(42378,'metatarsal.tif',253,10,4,64.7292156,97.7335902,97.2708132,1.8,97.740916,97.0826706,-0.075056,6.7637252,7.6275001,357.8242664,687.6373258,0.0606603,90.1523845,52.9034302,136.1597035,12.460952,15.4269362,0.2247112,45.6869641),(42379,'metatarsal.tif',253,10,5,120.789074,98.1335048,96.0558617,1.8,98.0518112,96.142245,0.030716,8.0269872,9.2900794,1514.3784462,2035.1006342,0.0189876,219.061704,188.6608768,382.0144516,16.7109414,18.7936316,0.1839435,57.6318565),(42380,'metatarsal.tif',253,10,6,170.0180043,98.6843713,95.6131907,1.8,98.5749587,96.137093,-0.042812,10.0501888,10.5482715,3217.1358697,4018.6250172,0.0519051,380.9747439,320.1070078,674.864246,19.765648,21.897231,0.2782997,66.5383958),(42381,'metatarsal.tif',253,10,7,207.3682855,99.2202131,95.6502189,1.8,99.0510246,96.3020056,-0.1041992,11.195114,12.1645844,4770.0156367,6637.5909654,0.3738931,545.648809,426.080131,929.7988617,21.9101988,24.1008625,0.1973956,74.8372646),(42382,'metatarsal.tif',253,10,8,229.8764098,99.4491318,96.069385,1.8,99.4529524,96.6126117,-0.1430753,11.9986796,13.4593494,6269.4038037,8753.0066772,0.7789451,650.3291094,522.5078101,1090.3551177,24.0538561,26.210968,2.9602729,81.165676),(42383,'metatarsal.tif',253,10,9,252.2455567,99.7913918,97.0232859,1.8,99.8595277,97.051698,-0.3023923,12.1456071,14.4089896,7557.901494,9828.3067877,3.7285122,682.0954868,622.2744909,1153.6238543,25.786092,27.1350609,2.9504082,86.4261918),(42384,'metatarsal.tif',253,10,10,270.7354781,99.8366898,97.6208334,1.8,100.1368972,97.5669473,-0.3722194,13.3116651,15.2873325,8561.8788785,10861.1823547,5.9681761,710.4694268,643.1861712,1255.6566734,26.4775736,28.8403564,2.0011229,89.8636958),(42385,'metatarsal.tif',253,10,11,287.5300322,99.817041,97.9442938,1.8,100.1494861,98.0110727,-0.411815,13.901661,15.7896567,9687.6959296,11867.6084846,7.6779455,751.6064933,696.8732695,1362.1590873,26.584545,29.7727587,1.9244995,92.5892694),(42386,'metatarsal.tif',253,10,12,288.3477831,99.7811105,97.9976511,1.8,100.1192081,98.2278192,-0.4688432,14.1265363,15.6956846,9989.3075875,12324.5382782,9.8121176,785.2182703,707.1307069,1413.2386862,26.210968,30.5350696,1.812362,92.8409748),(42387,'metatarsal.tif',253,10,13,280.954791,99.6397563,97.9900579,1.8,100.0409968,98.3139262,-0.5856285,14.4021699,15.6610868,9991.6290956,12053.6520702,14.3054241,769.6561709,693.7585923,1404.8897727,26.210968,30.9524521,1.8090411,93.4054596),(42388,'metatarsal.tif',253,10,14,266.8593857,99.6292652,98.1750753,1.8,99.9821984,98.3640396,-0.7333193,14.6468384,15.1282033,9672.823062,11477.6807505,19.9261808,758.694245,660.4034798,1396.8813716,25.257628,31.1812594,1.7790023,92.4418238),(42389,'metatarsal.tif',253,10,15,255.8756972,99.7564171,98.3208566,1.8,99.9955646,98.393026,-0.9237557,14.4527841,14.3412604,9125.7724265,11195.9004243,27.1483521,780.6775789,631.41969,1368.1396387,24.9381475,31.2965106,1.7224018,91.6867076),(42390,'metatarsal.tif',253,10,16,249.5470794,99.9766574,98.4756934,1.8,100.1080744,98.3891515,-1.0464736,14.0067488,14.0736782,8550.1001706,11384.6032741,31.1672984,808.9287783,610.4271806,1345.8125415,24.7253906,31.2965106,1.7224018,90.8273316),(42391,'metatarsal.tif',253,10,17,242.0547219,99.9683019,98.7597086,1.8,100.2382247,98.4392666,-1.1955452,12.9684658,14.7043419,7909.6936671,11459.7810085,34.9233801,779.3467434,609.9174559,1295.2932512,24.3726072,31.6047135,1.693465,90.5756262),(42392,'metatarsal.tif',253,10,18,233.6931963,99.9717793,99.1012253,1.8,100.3175418,98.5173491,-1.285344,12.5436777,14.853576,7363.030262,11421.9582645,35.8604644,768.9702621,586.9913477,1255.2506177,23.9517489,31.9012595,1.4898922,90.3239208),(42393,'metatarsal.tif',253,10,19,230.4420544,99.9668969,99.4365515,1.8,100.3907256,98.6553647,-1.3403025,12.0938104,15.0220854,6950.7873707,11629.1693243,36.4024242,774.1381442,574.7392379,1233.9372615,23.561416,32.2724008,1.5175135,90.5756262),(42394,'metatarsal.tif',253,10,20,228.1845114,100.0837125,99.7935372,1.8,100.4545184,98.8151321,-1.3573019,11.97985,15.04221,6622.2778291,11857.5402567,36.3234917,788.2844531,552.7847043,1225.2759088,23.1567436,32.2981353,1.5042282,90.3239208),(42395,'metatarsal.tif',253,10,21,229.1863346,100.1619235,100.1255547,1.8,100.4981474,98.9812623,-1.3746255,11.9162132,14.9160589,6325.3940273,12148.0205832,36.74652,814.4256229,530.8224948,1204.6696517,22.7408672,31.9012595,1.4898922,89.360285),(42396,'metatarsal.tif',253,10,22,232.6654686,100.2206752,100.449876,1.8,100.5350562,99.2197697,-1.3996037,11.8848862,15.0215472,6080.2362554,12707.3477457,37.6521853,845.9413385,511.5939824,1202.2806793,22.395377,31.660163,1.4346574,89.0043198),(42397,'metatarsal.tif',253,10,23,236.373714,100.2214218,100.8099538,1.8,100.5777875,99.4901624,-1.429906,12.1401885,15.0666994,5932.0989875,13096.4087822,38.618773,869.2287845,488.6331881,1215.1650087,22.1134198,31.5111044,1.4751982,88.3966492),(42398,'metatarsal.tif',253,10,24,240.2896421,100.2102019,101.1711926,1.8,100.6111111,99.8257881,-1.4627488,12.285109,15.0923748,5816.3811408,13565.073961,39.5825561,898.8031437,473.4496971,1234.0139659,22.0897768,31.2965106,1.4191908,87.7889786),(42399,'metatarsal.tif',253,10,25,241.4840418,100.209706,101.6394718,1.8,100.6958275,100.1518454,-1.4856782,12.4033157,15.0524694,5581.4782708,13903.8735686,39.9564483,923.6938586,449.9988897,1244.9901077,21.8273229,31.0150215,1.3897037,87.0770482),(42400,'metatarsal.tif',253,10,26,243.0543071,100.2507302,102.1492924,1.8,100.7921669,100.5289379,-1.4958236,12.7723639,15.2838751,5456.4412581,14178.5197863,40.2817798,927.678333,427.2068422,1249.612795,21.979129,31.0120449,1.6401295,87.7889786),(42401,'metatarsal.tif',253,10,27,244.1176742,100.3292449,102.7301584,1.8,100.8942692,100.9259379,-1.4877407,12.6325558,15.1840962,5347.0512161,14264.0399498,40.40626,939.4065857,423.275488,1245.1406824,21.8106683,31.0120449,1.5014632,87.4330134),(42402,'metatarsal.tif',253,10,28,243.4253051,100.4264666,103.3331454,1.8,101.0108393,101.3745459,-1.4748043,12.4371279,15.2708306,5218.659746,14267.9994302,40.1981916,934.330278,419.6032852,1239.8818771,21.5694672,30.8089592,1.4308717,86.9727884),(42403,'metatarsal.tif',253,10,29,244.6171871,100.5362414,103.9214669,1.8,101.1128918,101.8990337,-1.4568054,12.1894619,15.4047286,5185.4330953,14332.8695861,40.2420654,930.4201309,425.402953,1240.2757642,21.5219719,30.8718194,1.4170888,86.721083),(42404,'metatarsal.tif',253,10,30,246.3431026,100.6747108,104.4365974,1.8,101.2168369,102.4223054,-1.4374468,12.2155711,15.1393145,5170.4603197,14606.5223343,40.3314176,964.8073761,423.2679992,1246.2520313,21.829072,30.5924579,1.387174,87.580459),(42405,'metatarsal.tif',253,10,31,248.6621337,100.7958516,104.9675106,1.8,101.3758437,102.9210227,-1.4236977,12.0304782,15.0254725,5160.4039718,14843.0960263,40.5533799,987.8621802,428.944211,1262.3403789,21.6442566,30.435138,1.3429393,87.120234),(42406,'metatarsal.tif',253,10,32,251.346344,100.9358314,105.502778,1.8,101.4658966,103.4209589,-1.4063336,11.7345754,15.0689624,5182.6143587,15077.2235232,40.7681671,1000.5482192,441.6533332,1266.5308462,21.4259726,30.435138,1.3429393,87.0159742),(42407,'metatarsal.tif',253,10,33,256.1071024,101.036879,105.9493804,1.8,101.5341855,103.9293346,-1.398512,11.8430216,15.1222686,5248.6489367,15665.7099856,41.4300453,1035.9365,443.1849516,1305.7433516,21.799517,30.7008994,1.6829991,88.439835),(42408,'metatarsal.tif',253,10,34,259.4279567,101.1674,106.4259345,1.8,101.6887191,104.3798947,-1.3848661,11.6576644,15.350299,5235.397945,16167.3796648,41.7603984,1053.2289759,449.0949266,1329.2564781,21.7656389,30.9852423,1.5152978,88.439835),(42409,'metatarsal.tif',253,10,35,263.5849691,101.2758334,106.8524928,1.8,101.7727317,104.8403442,-1.3788022,11.496732,15.4001646,5285.5027462,16822.9890413,42.3312606,1092.3902117,459.7395796,1380.1283127,21.4586306,31.0447721,1.4876551,88.838986),(42410,'metatarsal.tif',253,10,36,268.1313308,101.4039592,107.2588553,1.8,101.8510776,105.2321632,-1.3753509,11.3441143,15.4361987,5350.1390847,17453.1408103,43.0031267,1130.6631312,471.6224589,1421.1794719,21.4511315,31.0834054,1.4738787,88.838986),(42411,'metatarsal.tif',253,10,37,270.1443207,101.5468085,107.7018336,1.8,101.9919912,105.6900801,-1.3700855,11.4888706,15.7471116,5408.2957644,17981.8725767,43.2344917,1141.9156094,470.742161,1448.314193,21.8582568,31.2345051,1.4327903,90.3060326),(42412,'metatarsal.tif',253,10,38,275.7039752,101.7119339,108.1019144,1.8,102.1190171,106.1344841,-1.3634969,11.2696194,15.8501896,5473.8167207,18740.7574667,44.0041463,1182.368033,485.714425,1488.8984255,21.4844,31.272904,1.3491468,89.8458076),(42413,'metatarsal.tif',253,10,39,279.2994273,101.8629519,108.5345667,1.8,102.2573823,106.5426584,-1.3627644,11.1141726,15.9753417,5527.8638796,19466.4533728,44.5642458,1218.5312674,497.3707059,1527.7350661,21.4844,31.3642808,1.4056476,91.6688194),(42414,'metatarsal.tif',253,10,40,284.3510646,101.9882571,108.996023,1.8,102.3413028,106.9899455,-1.3618258,11.1288785,16.1563305,5631.8612891,20317.6472394,45.3522554,1257.5657136,506.0582974,1547.7253868,21.6345087,31.660163,1.4346574,92.0247846),(42415,'metatarsal.tif',253,10,41,288.927359,102.0721725,109.496764,1.8,102.4254231,107.4597182,-1.3630598,11.1342955,16.4766519,5709.1601567,21275.4336912,46.106197,1291.2473832,512.7545021,1575.689553,21.4351499,32.0312158,1.4497691,93.4918312),(42416,'metatarsal.tif',253,10,42,297.402573,102.0642122,110.1138006,1.8,102.2727437,108.4977313,-1.3592182,10.9716378,19.0531021,5901.2308306,22703.7522038,47.3811217,1191.6039736,537.862345,1500.0642686,21.4955013,36.52348,1.4172525,108.5793363),(42417,'metatarsal.tif',253,10,43,335.0346695,100.8253113,111.9495132,1.8,100.0118575,111.372487,-1.1827112,15.4787277,19.1409197,9465.0185427,30980.7673677,47.8429983,1618.5621066,611.4855632,1711.5542855,25.3019712,42.7123705,0.635453,148.3549282),(42418,'metatarsal.tif',253,10,44,412.8501938,98.5921566,114.1479379,1.8,98.4866461,113.4191937,-0.9876155,14.0405424,21.5729474,15049.8727329,45371.9754546,47.9421984,2103.1885253,1071.8868495,2753.9293474,27.6816097,43.9585735,0.6884805,156.4020916),(42419,'metatarsal.tif',253,10,45,460.061938,97.9358624,115.4118685,1.8,97.9202019,114.7273692,-0.9880288,14.9557123,22.9728126,18515.5013663,53168.6711509,53.4537861,2314.4171349,1238.0220321,3075.5139573,28.8419334,45.3539704,0.7250688,156.592723),(42420,'metatarsal.tif',253,10,46,496.2626906,97.7223479,116.2398265,1.8,97.7633379,115.6894562,-1.011097,15.2256071,23.7346763,21686.7100046,58575.518792,59.3953489,2467.9299612,1424.357649,3335.4450749,29.7499034,46.8537281,0.7334968,153.5543701),(42421,'metatarsal.tif',253,10,47,532.9898675,97.8502859,117.0503386,1.8,98.3009799,116.8765863,-1.0265641,20.3447742,24.3952058,26834.8028973,62326.9302445,65.0179384,2554.8843771,1319.0022464,3592.3637323,30.7524958,48.0213588,0.7600871,150.2643117),(42422,'metatarsal.tif',253,10,48,587.3557014,98.7964623,118.0202806,1.8,99.0401881,117.8524728,-1.0602643,21.4676714,24.8137694,38728.0944568,65854.0919569,74.5187468,2653.9334249,1804.0193426,4195.2463205,38.1074967,48.6288372,0.7604034,159.4225564),(42423,'metatarsal.tif',253,10,49,627.6050932,99.2725541,118.7448115,1.8,99.2154784,118.4101269,-1.0780806,21.3037501,25.0050498,45663.6335266,70197.8857454,81.1965932,2807.3483665,2143.4551843,4596.0138788,38.242232,49.2812987,0.8347408,161.5404595),(42424,'metatarsal.tif',253,10,50,653.7243353,99.3610523,119.3810743,1.8,99.267703,118.872235,-1.0946966,21.3104703,25.2974967,50232.0111581,73146.8841441,86.0678549,2891.467282,2357.1516899,4822.8983513,38.291039,49.600589,0.8405569,165.2296689),(42425,'metatarsal.tif',253,10,51,673.5876933,99.3693712,119.8691979,1.8,99.2600171,119.200546,-1.0977002,21.07121,25.5315534,52389.5958305,76626.6307558,88.957141,3001.2521978,2486.3116921,4983.2993008,38.7407918,49.9215357,0.8462984,163.7626223),(42426,'metatarsal.tif',253,10,52,681.3864277,99.2815926,120.340353,1.8,99.2579951,119.4483682,-1.0911386,19.6073309,25.8154905,51935.1218265,78449.0988007,89.3797655,3038.8381994,2648.7604079,5005.3661628,37.5143861,49.9215357,0.8462984,162.3566496),(42427,'metatarsal.tif',253,10,53,688.1308587,99.187411,120.6613238,1.8,99.262627,119.5987981,-1.0877229,19.6558732,25.810427,51617.7781917,79862.7878846,89.9429352,3094.206382,2626.0740314,5001.8547903,37.6637011,49.8882387,0.83414,162.7126148),(42428,'metatarsal.tif',253,10,54,696.0107751,98.9923243,120.9289308,1.8,99.222701,119.7793671,-1.0611479,20.1639631,25.8873201,52786.2490991,80636.9176454,88.3913407,3114.9194785,2617.850904,5076.4797451,38.6128956,49.600589,0.8405569,162.9211344),(42429,'metatarsal.tif',253,10,55,716.5243167,98.8463159,121.1671361,1.8,99.1747734,119.9903068,-1.0195602,20.9328329,25.9670914,56247.3922295,83216.8032093,86.6631071,3204.7025141,2687.041578,5317.5097287,40.1209074,49.3150055,0.8470483,163.7805104),(42430,'metatarsal.tif',253,10,56,725.1987652,98.7314942,121.4632927,1.8,98.9894731,120.1458655,-0.9579226,21.0889553,25.711619,59403.4169379,82449.4495938,80.874324,3206.7000385,2816.8022643,5513.3243677,40.7776422,48.7501819,0.860258,164.7441462),(42431,'metatarsal.tif',253,10,57,728.9790728,98.6189409,121.6432543,1.8,98.8233399,120.268274,-0.8307564,20.8445248,24.9087073,62291.9041824,81364.3720134,66.2515692,3266.5032024,2988.4060617,5714.8759151,41.0480536,47.8653917,0.8680122,165.1001114),(42432,'metatarsal.tif',253,10,58,723.1716201,98.5258798,121.7119909,1.8,98.787855,120.415263,-0.6398293,21.488235,24.1897412,62938.9845245,80933.4800444,42.965896,3345.7770099,2928.9974073,5739.6498386,40.8983936,47.1737937,0.8433976,167.4697198),(42433,'metatarsal.tif',253,10,59,696.1331356,98.53247,121.7642845,1.8,98.7239706,120.3916219,-0.4775469,21.3417537,23.3040017,59574.1253021,78405.4323548,24.5078225,3364.4621858,2791.4353333,5552.4798329,40.2935206,47.9732749,3.0339028,168.3722816),(42434,'metatarsal.tif',253,10,60,674.2455419,98.469353,121.6387161,1.8,98.5879987,120.2797768,-0.402426,20.8234625,24.100861,55986.3577225,76516.1929076,17.2372084,3174.8323355,2688.6190394,5274.4563669,39.5147171,48.4481556,3.0260383,170.9682978),(42435,'metatarsal.tif',253,10,61,660.4491841,98.4643352,121.5136659,1.8,98.5832932,120.1178534,-0.3314445,20.4589182,24.635109,51907.3221721,74738.0267259,11.6559548,3033.8013388,2537.1489169,4975.3319162,38.8873961,48.3566072,3.0436923,167.9910188),(42436,'metatarsal.tif',253,10,62,645.391064,98.468065,121.2529111,1.8,98.5373239,119.9850183,-0.2743319,20.1064701,24.7334082,46896.5986159,71835.4111074,7.8940904,2904.3878893,2332.4133157,4670.168173,37.8900244,47.9732749,3.0339028,163.190728),(42437,'metatarsal.tif',253,10,63,616.6711434,98.6834243,120.7877961,1.8,98.6946383,119.7728267,-0.2112927,19.2792626,24.9070051,39848.8893703,68459.00299,4.5206288,2748.5842879,2066.9301582,4291.5571301,36.8503777,47.5014205,3.041924,156.4631656),(42438,'metatarsal.tif',253,10,64,550.0450881,99.2599527,119.9657149,1.8,99.1165905,119.1785506,-0.0590429,19.5096805,23.3119891,30108.7078294,57802.818999,0.319211,2479.5318302,1543.2701611,3766.7284778,34.7841929,44.6089822,3.0160429,148.581336),(42439,'metatarsal.tif',253,10,65,540.5136684,99.1030352,119.3861821,1.8,99.1097123,118.339153,0.0338096,19.0660564,21.7590172,25403.5626579,53831.1437691,0.1029364,2473.9694425,1332.3973298,3622.7050827,34.131891,42.9623542,3.00111,146.7836218),(42440,'metatarsal.tif',253,10,66,528.7134599,98.5767774,119.2891372,1.8,98.6504412,117.9710104,0.0259254,18.9094445,20.4070148,22980.1616351,52343.8619028,0.059214,2564.9935772,1215.2742837,3655.4569079,29.8684741,41.3952597,2.9747375,124.4040695),(42441,'metatarsal.tif',253,10,67,502.7914381,98.0482089,119.1115815,1.8,98.295508,117.6608696,0.0422071,18.4236211,19.8826232,20332.4464581,52134.1501608,0.1491932,2622.0961683,1103.6075002,3549.212544,29.5462763,40.8542687,2.7532739,132.4080471),(42442,'metatarsal.tif',253,10,68,472.3853258,97.726322,118.8122447,1.8,98.0641704,117.5130508,0.0551752,17.7719019,19.8684115,18518.4828788,52422.799445,0.2394373,2638.4997857,1042.0090655,3448.5994715,28.9070585,40.9670948,2.7201734,132.7208265),(42443,'metatarsal.tif',253,10,69,431.3452625,97.741669,118.6542396,1.8,97.8233665,117.9198362,0.1226265,17.1867275,20.0395792,16502.2319017,48684.2492881,1.0756345,2429.404771,960.1730098,3197.9463293,28.2426157,40.7456616,2.6590794,141.8179973),(42444,'metatarsal.tif',253,10,70,409.3611008,97.6487108,119.1370801,1.8,97.712457,118.394732,0.2168551,15.3216499,20.0460203,14814.2964928,47126.768959,3.1584654,2350.9289207,966.8865036,3079.8139905,26.1358474,40.3655229,2.7017501,128.3881702),(42445,'metatarsal.tif',253,10,71,531.6703658,97.6632374,118.4863914,1.8,98.5986505,117.4580674,0.0401766,17.5099845,19.4423352,23347.9994945,51547.5847456,0.1429561,2651.3062408,1333.4106305,3590.8815763,29.2465411,39.8684709,2.610415,130.211182),(42446,'metatarsal.tif',253,10,72,520.7820144,96.8267001,117.4068069,1.8,98.6902965,116.6067274,-0.3681656,16.0981229,21.1589134,23019.0252205,47781.6439635,11.242929,2258.2276851,1429.9198304,3192.8295579,29.372416,39.6525436,2.6197584,132.4512329),(42447,'metatarsal.tif',253,10,73,513.9826415,97.1910812,117.1588322,1.8,98.2816226,115.9375016,-0.4386522,17.449152,21.7013523,22668.8954633,49585.8587039,15.4526132,2284.9202194,1299.1402403,3226.5892357,31.5078479,40.2188886,0.6413644,133.3106089),(42448,'metatarsal.tif',253,10,74,563.002826,98.7495199,117.6489351,1.8,99.4374917,116.4365766,-0.2777329,18.7812088,20.0574133,30977.2622287,55364.4382265,7.0537283,2760.2980234,1649.3753156,3912.9474898,32.3872266,40.7388641,0.658268,129.9773647),(42449,'metatarsal.tif',253,10,75,577.9364596,99.4614497,117.6866122,1.8,99.4915773,116.1689976,-0.1777928,18.5012987,19.5769628,35924.5192695,57516.5479655,3.0128421,2937.9709421,1941.7295954,4311.7503196,32.5219676,40.82036,0.6435011,133.3106089),(42450,'metatarsal.tif',253,10,76,578.4255659,99.1026111,117.342992,1.8,99.3623448,115.9545556,-0.0956965,17.6351172,19.0310269,39174.1917805,55903.6438601,0.8801615,2937.5001298,2221.3740474,4415.3118691,33.0192208,40.6594753,0.6202495,135.6370315),(42451,'metatarsal.tif',253,10,77,586.8505377,98.7932454,117.199602,1.8,99.2930426,115.7855728,-0.0114447,18.0138614,18.5878425,41705.3439394,54537.7295679,0.0128104,2934.053782,2315.1806802,4468.5296749,33.085976,40.280815,0.5880026,131.4875971),(42452,'metatarsal.tif',253,10,78,602.8285717,98.9895971,117.0760455,1.8,99.4083149,115.7516299,0.1636584,18.95391,18.2438923,44618.6353343,52427.2825481,2.6670932,2873.689543,2354.0596809,4615.7276712,34.0446406,39.6851239,0.5849996,129.2654343),(42453,'metatarsal.tif',253,10,79,630.182385,98.9567759,116.9671307,1.8,99.5969084,115.6585599,0.4923944,20.299475,18.8937416,45956.1658138,53985.4550262,23.4722436,2857.3194325,2263.9090869,4808.0162645,34.9758966,39.2806283,2.0980834,128.6577637),(42454,'metatarsal.tif',253,10,80,652.0651111,98.8155571,117.1373125,1.8,99.4700908,115.7934942,0.6412777,20.6690562,19.0509905,46556.092254,56377.3316248,38.8920875,2959.2861136,2252.4537081,4799.8766676,35.5497357,39.9863876,2.0632821,129.9773647),(42455,'metatarsal.tif',253,10,81,671.065903,98.8950954,117.2870784,1.8,99.3997266,115.9450558,0.7445494,20.3932999,19.4101324,45903.4154246,56878.8085906,51.3585421,2930.3668581,2250.906699,4581.8051327,36.1651124,40.5685551,2.0676071,132.3037873),(42456,'metatarsal.tif',253,10,82,693.0976773,99.3515769,117.2665499,1.8,100.0567738,115.7505763,0.5430914,19.8503508,18.6461825,48211.1748235,56608.3801168,30.8505571,3035.9233153,2428.731624,4397.1071618,35.9347404,40.2349528,1.9195673,133.6233883),(42457,'metatarsal.tif',253,10,83,645.765251,99.2928721,117.0582837,1.8,100.2687186,115.5618241,0.014747,22.011945,22.6636467,47273.9988866,56601.9599459,0.0234042,2497.4780372,2147.652053,4181.7286723,35.2613327,39.9632941,1.8653427,137.0787804),(42458,'metatarsal.tif',253,10,84,552.2137841,98.7765629,116.8989041,1.8,100.0444417,115.5644462,-0.1643001,22.1939951,24.9156201,42464.2586982,56692.2326508,2.4621839,2275.3691234,1913.321983,3867.2138582,34.6859552,39.205351,2.0491488,180.1876165),(42459,'metatarsal.tif',253,10,85,321.3142345,98.6372472,122.9538981,1.8,99.2414569,122.2845353,0.1502294,15.7070899,18.2296274,9317.1280595,17726.3352928,1.1995511,972.391533,593.1797752,1380.5679981,25.78128,32.7071325,0.1716281,96.7565919),(42460,'metatarsal.tif',253,10,86,405.0031195,98.7075673,122.2784871,1.8,99.0633468,121.7414221,0.1735979,15.1073147,16.8569275,14676.4808111,19114.6707589,2.0138584,1133.9356342,971.4817669,1944.6769687,26.2639977,33.1305888,0.0519014,100.4889871),(42461,'metatarsal.tif',253,10,87,419.9540413,98.4945323,122.0600055,1.8,98.7879522,121.7514282,0.195734,15.0919455,15.9166487,15876.6208142,19087.9119865,2.6474608,1199.2418982,1051.9929887,2136.7764105,26.5578768,30.9405198,2.9741609,98.813421),(42462,'metatarsal.tif',253,10,88,414.5331404,98.129082,121.6705025,1.8,98.3935506,121.2314607,0.6169246,14.9075917,14.8755735,17326.6681461,18948.1080074,23.123781,1273.7732787,1162.2714451,2172.3608121,26.9810369,31.4729961,0.0820074,103.4662662),(42463,'metatarsal.tif',253,10,89,370.3778354,97.7287053,121.9865996,1.8,97.8988901,121.4514571,0.8261049,13.6263143,14.6977934,15528.6290889,16613.7700398,33.3748547,1130.3581176,1139.6059658,1950.8332734,26.2810683,29.6827027,1.956679,95.8793278),(42464,'metatarsal.tif',253,10,90,338.327885,97.4277515,122.4258909,1.8,97.7237746,121.6562552,0.9610505,13.2705493,15.6138252,13925.7264795,15080.7065184,37.8961926,965.8559851,1049.3707669,1701.2363245,26.5408843,29.6827027,1.956679,97.8497852),(42465,'metatarsal.tif',253,10,91,314.344273,96.8494213,122.8829641,1.8,97.1211102,122.0323882,0.8734988,13.5284325,14.8806292,11879.4799056,14260.903778,30.7871657,958.3535488,878.1120698,1533.2736053,25.5454479,29.3700471,1.929567,95.314843),(42466,'metatarsal.tif',253,10,92,298.8530515,96.6747105,123.4228261,1.8,96.8728225,122.5735582,0.6035877,14.5540581,14.5690913,10530.163795,12656.1635931,16.0468951,868.6995884,723.520802,1512.6930586,24.3744547,28.5669819,2.772259,88.3966492),(42467,'metatarsal.tif',253,10,93,300.6358671,96.493565,123.359137,1.8,96.6312436,122.4196643,1.0367633,12.7943269,14.7844208,10593.0026035,12474.4814329,37.1240144,843.758546,827.9452826,1450.1566211,24.5319664,27.8867181,0.9827937,89.0475056),(42468,'metatarsal.tif',253,10,94,300.4099449,96.367411,123.5215267,1.8,96.4594289,122.4555529,1.2703459,12.2027636,15.8927606,9995.9023994,11900.1879167,45.6830043,748.7804189,819.1507019,1359.5240726,24.1046386,28.0122304,1.0040671,88.0838698),(42469,'metatarsal.tif',253,10,95,280.140453,96.2773751,123.8381434,1.8,96.570886,122.6692101,1.4573682,14.2659935,16.2272508,9376.8746997,11545.7258669,46.0919358,711.5022756,657.2885852,1273.2617972,24.987727,28.1503035,1.0251413,101.9560337),(42470,'metatarsal.tif',253,10,96,278.0653597,96.0594276,123.86978,1.8,96.2284633,122.8059128,1.5273497,12.1969486,16.7786089,8699.1967559,12059.2137839,46.2568018,718.7254818,713.2273038,1218.3029582,22.9742481,28.4114437,1.5102643,85.462556),(42471,'metatarsal.tif',253,10,97,279.997727,95.8251964,123.6946574,1.8,96.0057221,122.6479434,1.5609431,12.4550282,15.4083465,8278.1847872,12846.4115185,46.6617573,833.730699,664.6460099,1281.5543771,23.0311281,28.5184673,1.0329608,85.401482),(42472,'metatarsal.tif',253,10,98,279.5103551,95.7002768,123.8228211,1.8,95.9147024,122.8753514,-1.5294455,12.5495773,16.0867876,7807.923356,12884.757335,46.5054493,800.9527854,622.1662407,1271.4741811,22.6773341,28.1503035,1.0251413,84.6463658),(42473,'metatarsal.tif',253,10,99,281.3680305,95.6078418,123.9153354,1.8,95.874452,122.8776999,-1.5040004,13.0629759,16.2427747,7571.9863885,12975.9472849,46.685753,798.8750416,579.652481,1254.2017684,22.8465934,28.3007535,1.0460006,85.2540364),(42474,'metatarsal.tif',253,10,100,279.6174975,95.3936376,124.0594198,1.8,95.5670888,122.9463446,-1.4976503,14.0848898,16.8125334,7036.7526591,13004.3098502,46.3540189,773.4890117,499.5958636,1185.3984904,21.6429463,28.9935938,1.451956,84.3514746),(42475,'metatarsal.tif',253,10,101,283.2485331,95.2844575,124.0769393,1.8,95.5111495,122.9917912,-1.484552,14.1677238,16.8982896,6875.1598355,13425.2223079,46.857821,794.4722568,485.2691905,1192.1917268,21.2620252,29.3731901,1.4682165,85.8185212),(42476,'metatarsal.tif',253,10,102,276.4901709,95.0945027,124.2297525,1.8,95.3354873,123.3631874,-1.4705364,11.1930453,17.1400726,6381.52333,13695.9697518,45.6200299,799.061361,570.132894,1159.4941797,20.8840463,29.5330411,1.4247841,83.4920986),(42477,'metatarsal.tif',253,10,103,279.9035648,94.9862411,124.2391391,1.8,95.2822629,123.3919305,-1.4596383,11.3096468,16.8078327,6298.5216692,14135.4653152,46.0765446,841.0046394,556.9158579,1198.5794952,20.8884929,29.4735901,1.4392082,83.9955094),(42478,'metatarsal.tif',253,10,104,282.2540952,94.8900225,124.3220796,1.8,95.2146585,123.6076851,-1.4525707,11.4517452,16.1398362,6298.352669,14339.2227408,46.3878823,888.4366949,549.990638,1222.7348375,20.9303318,29.4234329,1.0679531,86.4261918),(42479,'metatarsal.tif',253,10,105,279.6035662,94.6510853,124.4254655,1.8,94.8603026,124.0165549,-1.4499033,11.3046125,16.2709197,5956.8390639,14433.4662101,45.9228324,887.0713217,526.9388101,1253.1641165,20.7424345,28.8691504,1.4963075,83.3878388),(42480,'metatarsal.tif',253,10,106,281.1140779,94.4971524,124.4427297,1.8,94.691601,124.0812222,-1.4410205,11.0966197,16.3635189,5831.0874509,14898.2700834,46.0676903,910.4563725,525.483219,1266.2147984,20.5478209,29.2692919,1.5120405,82.5284628),(42481,'metatarsal.tif',253,10,107,281.3035772,94.3636876,124.5155508,1.8,94.5467602,124.1327637,-1.4249182,10.94467,16.4608789,5666.2019071,15260.2083336,45.8932772,927.0591467,517.7133637,1270.9828987,20.195336,29.3323044,1.6588037,82.9276138),(42482,'metatarsal.tif',253,10,108,286.3313243,94.2847581,124.534868,1.8,94.5178199,124.1616374,-1.4133757,11.8952674,16.5627157,5752.6123317,15780.7600576,46.5490153,952.7881961,483.6051278,1287.8229779,21.3722629,29.4516568,1.1659045,85.2540364),(42483,'metatarsal.tif',253,10,109,288.3175147,94.096921,124.5088071,1.8,94.2265095,124.2094436,-1.4165036,10.9365614,16.563667,5638.0861793,16322.9227242,46.9180087,985.4655229,515.5264055,1310.4931256,20.195336,29.7262121,1.498459,83.68273),(42484,'metatarsal.tif',253,10,110,292.6006922,94.065738,124.5670516,1.8,94.3386702,124.1283107,-1.4052539,11.0636578,17.0581993,5765.5805048,16677.3341034,47.4425258,977.6726024,521.1278791,1307.2213364,20.195336,30.6165892,1.6551031,88.040684),(42485,'metatarsal.tif',253,10,111,292.5365186,93.9565964,124.6535518,1.8,94.2051116,124.2377582,-1.389522,10.594987,17.0596545,5722.8090951,16917.652482,47.1714151,991.6761481,540.1430969,1301.2343163,19.6573697,30.0935021,1.3986055,84.7938114),(42486,'metatarsal.tif',253,10,112,291.4643115,93.7859725,124.7262932,1.8,93.9725966,124.3627768,-1.3850843,10.7694039,17.2518644,5592.1971602,17262.1835925,46.9211738,1000.59815,519.2671034,1302.8564862,19.7443359,30.5924579,1.0568766,87.4761992),(42487,'metatarsal.tif',253,10,113,294.205478,93.7155699,124.6858529,1.8,94.0014321,124.2732514,-1.3779618,10.5380528,17.2449119,5693.1425813,17643.6539027,47.2333899,1023.1222958,540.2461619,1336.7603856,19.33596,30.5834037,1.1511455,84.7938114),(42488,'metatarsal.tif',253,10,114,294.6356141,93.6379386,124.7687488,1.8,93.9697286,124.3366045,-1.3700352,10.9712323,17.3626231,5729.8011702,17764.1725385,47.1531675,1023.1272315,522.256846,1337.755426,19.8552581,30.7609795,1.1383886,85.002331),(42489,'metatarsal.tif',253,10,115,295.4888367,93.5556746,124.8759601,1.8,93.8910763,124.46184,-1.363505,11.5656702,17.4129074,5807.8540617,17878.3007949,47.1620993,1026.7269191,502.1632104,1349.8720384,20.3735695,30.8059627,1.1695675,87.181308),(42490,'metatarsal.tif',253,10,116,291.8597033,93.4328613,125.0708248,1.8,93.7547433,124.6850559,-1.3486304,10.6374905,17.6603176,5708.7744687,17460.1737416,46.2816061,988.667032,536.6655307,1303.7327434,19.3241811,30.976303,1.1567973,85.9659668),(42491,'metatarsal.tif',253,10,117,292.20793,93.3613914,125.1572295,1.8,93.7146859,124.7585661,-1.346509,10.6986494,17.7646197,5765.5323143,17501.4810904,46.2922174,985.1874882,538.9028196,1301.5534423,19.33596,31.0388243,1.1877193,85.861707),(42492,'metatarsal.tif',253,10,118,291.9838542,93.2565344,125.2165069,1.8,93.6063201,124.801792,-1.3402086,10.8180358,17.7603077,5747.7760141,17571.6789986,46.1220143,989.3792003,531.3141995,1308.0139345,19.6486073,30.976303,1.1567973,85.7142614),(42493,'metatarsal.tif',253,10,119,288.8833271,93.1032523,125.3358111,1.8,93.2865411,125.0143201,-1.3342588,10.1169479,17.8204474,5619.7205205,17356.5589554,45.5032519,973.9687562,555.4758779,1286.638555,18.476584,30.880789,1.2006255,84.0386952),(42494,'metatarsal.tif',253,10,120,290.8862462,93.0291247,125.3693286,1.8,93.2364271,124.9989641,-1.3360735,10.1693668,17.6501299,5718.6930275,17536.27347,45.8586813,993.549256,562.3450449,1307.5822752,18.476584,30.976303,1.1567973,83.9344354),(42495,'metatarsal.tif',253,10,121,288.8062853,92.9273266,125.4761233,1.8,93.1516144,125.1019714,-1.3306901,10.277728,17.6873867,5740.3311875,17235.9235975,45.412305,974.4754187,558.5214156,1292.744445,18.476584,30.880789,1.2006255,84.4378462),(42496,'metatarsal.tif',253,10,122,283.7527457,92.7738937,125.5660109,1.8,92.8715637,125.2104807,-1.3269282,9.6984377,17.6105977,5587.453344,16950.5705905,44.5348972,962.5210274,576.1189067,1276.3083601,18.2758366,30.8059627,1.1695675,84.2904006),(42497,'metatarsal.tif',253,10,123,279.997727,92.6986611,125.5914643,1.8,92.8440124,125.2609482,-1.3242733,10.1998616,18.9035132,5567.2643084,16757.5725634,43.8871979,886.4792668,545.8176323,1179.0133408,18.476584,31.9821833,1.4631065,87.4761992),(42498,'metatarsal.tif',253,10,124,276.0876176,92.6077289,125.771262,1.8,92.7805708,125.4481151,-1.3157336,9.8827899,18.7830254,5588.0178218,16369.6419067,43.0853889,871.5125266,565.4291808,1168.229743,18.3058284,30.4806021,1.1955255,83.9344354),(42499,'metatarsal.tif',253,10,125,273.0795184,92.4806132,125.8549413,1.8,92.6143238,125.4273342,-1.312678,9.1368845,18.4787331,5513.0626889,15961.2720241,42.547678,863.76441,603.3853955,1161.6231705,17.7962123,31.402521,1.2793395,85.0455168),(42500,'metatarsal.tif',253,10,126,269.7800926,92.3934057,126.0862467,1.8,92.5090288,125.8091932,-1.3071658,9.265763,16.9832417,5550.2612233,15283.4998626,41.9100771,899.9165279,599.0074697,1218.6914724,17.9995665,30.0167132,1.1583859,82.6148344),(42501,'metatarsal.tif',253,10,127,268.353896,92.3171678,126.2152657,1.8,92.4874796,125.8949115,-1.3044895,9.4397808,16.8294427,5590.2662383,14994.9540505,41.6280135,890.9952829,592.20297,1216.8814798,18.2516879,29.8470824,1.1715756,85.0455168),(42502,'metatarsal.tif',253,10,128,265.4633457,92.2384363,126.4005335,1.8,92.4250377,126.2008277,-1.298988,14.8983667,16.6243012,5612.3353458,14445.5254924,41.0548718,868.9403149,376.7080949,1024.4877576,18.4421448,29.8099437,1.3083369,88.5872806),(42503,'metatarsal.tif',253,10,129,263.5660583,92.1446973,126.4523029,1.8,92.3604312,126.167139,-1.2967452,9.4888398,16.4060518,5614.0440084,14128.3606142,40.7103006,861.167624,591.6470402,1191.4009601,18.7271277,29.4767221,1.0353768,89.0906914),(42504,'metatarsal.tif',253,10,130,260.9222991,92.033892,126.6031793,1.8,92.1911787,126.4470221,-1.2966741,10.2014758,16.3488208,5584.6982458,13697.4945071,40.3003366,837.8276718,547.4402296,1165.4562195,18.046896,29.4234329,1.0679531,81.902904),(42505,'metatarsal.tif',253,10,131,260.4461729,91.9672389,126.6712104,1.8,92.1411649,126.4768391,-1.2925698,9.5713348,16.2617038,5604.1359423,13498.496544,40.1333189,830.078862,585.5124761,1161.1619557,18.046896,29.2598283,1.0480072,79.9756325),(42506,'metatarsal.tif',253,10,132,257.7222388,91.8912527,126.7638705,1.8,92.0237913,126.6068907,-1.2840308,9.6904807,18.6700448,5561.5380258,13103.8105302,39.5172005,701.8628331,573.9176642,999.3708916,18.1363089,29.218784,1.080839,81.3994932),(42507,'metatarsal.tif',253,10,133,257.306034,91.8162179,126.8453549,1.8,91.9716793,126.7021681,-1.2817744,9.7579626,18.7683299,5605.9654558,12851.4740055,39.4006964,684.7425457,574.5016347,983.0771866,18.233593,28.8883304,1.0405806,80.9392682);
INSERT INTO `slices_w` VALUES (42508,'metatarsal.tif',253,10,134,255.4276015,91.6941322,127.0223191,1.8,91.8217739,126.9106063,-1.2750518,9.8781724,15.9315638,5642.1795707,12346.6589528,38.9550789,774.9809815,571.176462,1116.6377557,18.282235,28.8403564,1.0738277,82.1114236),(42509,'metatarsal.tif',253,10,135,255.0414973,91.6153112,127.0987074,1.8,91.7652435,127.0010367,-1.2713493,9.6764834,15.7485342,5683.9055956,12149.8629631,38.8079558,771.4916688,587.3937236,1125.1843371,18.3304527,28.4633842,1.0666304,82.6148344),(42510,'metatarsal.tif',253,10,136,254.3517018,91.5472166,127.156934,1.8,91.7231081,127.0918016,-1.269796,9.7372098,15.4167195,5723.4629406,11936.309088,38.6657881,774.244423,587.7929188,1136.5489673,18.3753673,28.1503035,1.0251413,80.8960824),(42511,'metatarsal.tif',253,10,137,249.9938883,91.3998078,127.2491126,1.8,91.4864896,127.2441796,-1.2716763,9.6128734,15.4179517,5633.8168986,11421.1607199,38.0475707,740.7703009,586.0700201,1099.7428641,18.1827758,27.92972,1.0382922,82.6148344),(42512,'metatarsal.tif',253,10,138,249.6395072,91.3417831,127.3170507,1.8,91.4188915,127.3222349,-1.2688013,9.7661318,15.222369,5666.1556731,11272.0844817,37.9259846,740.4947592,580.1842323,1101.2879172,18.2726963,27.8800965,1.0726796,79.9324466),(42513,'metatarsal.tif',253,10,139,249.4255581,91.2734954,127.3980097,1.8,91.3409798,127.4052115,-1.2654417,9.6810224,14.9176034,5685.4844738,11063.8445882,37.8137783,741.6636755,587.2814109,1109.4764382,18.3026699,27.5603906,1.0303768,79.9324466),(42514,'metatarsal.tif',253,10,140,247.4051829,91.2067019,127.487293,1.8,91.30052,127.5288001,-1.2608524,9.8870976,14.6242716,5689.3473481,10916.5448696,37.3982547,746.4675942,575.4314958,1120.3064919,18.3326434,27.3418007,1.0438531,81.7986442),(42515,'metatarsal.tif',253,10,141,247.6154953,91.139762,127.5481029,1.8,91.2356602,127.4719689,-1.2534674,9.7395723,14.4462231,5696.0351483,10723.7485609,37.2511629,742.3219546,584.8342205,1114.4459746,18.3626169,27.2911083,0.9871605,80.0798922),(42516,'metatarsal.tif',253,10,142,246.7767075,91.0721867,127.6179868,1.8,91.1428662,127.4606006,-1.2422089,9.8368225,14.4271971,5694.5652063,10573.3680507,36.8462554,732.8774938,578.9029108,1112.7043673,18.2403901,27.1928349,1.0222469,76.7898339),(42517,'metatarsal.tif',253,10,143,246.9497579,90.9992071,127.7137182,1.8,91.0349315,127.5613214,-1.2322059,9.9215526,14.4219707,5731.2461118,10455.3184344,36.6173457,724.9576824,577.656172,1113.1849676,18.5648451,27.1282558,1.0575441,75.2185275),(42518,'metatarsal.tif',253,10,144,247.38644,90.9337662,127.8084111,1.8,90.9279856,127.6795989,-1.2175599,10.0165572,14.1559166,5778.8457069,10286.8586114,36.2968735,726.6826248,576.929335,1125.6378322,18.5948369,26.8271256,1.0138948,74.0031863),(42519,'metatarsal.tif',253,10,145,248.4058871,90.8812935,127.8473135,1.8,90.9001523,127.7139421,-1.2079995,10.092905,14.0751768,5844.565342,10200.4408889,36.1866436,724.7113855,579.0766234,1132.9351855,18.6098328,26.696042,0.9917221,74.0031863),(42520,'metatarsal.tif',253,10,146,248.8281344,90.8055376,127.9588246,1.8,90.8211552,127.8401645,-1.1970491,10.1680557,13.9771043,5907.5587893,10030.7543873,35.9431075,717.6561176,580.9919803,1131.4675182,18.6398246,26.696042,0.9917221,74.0031863),(42521,'metatarsal.tif',253,10,147,249.1817882,90.7302457,128.0594549,1.8,90.7876387,127.9479031,-1.1848679,10.247332,13.9572284,5955.3643104,9872.0379696,35.6458033,707.3064707,581.1624228,1129.7220361,18.476584,26.4633394,1.0053124,74.2548917),(42522,'metatarsal.tif',253,10,148,249.7793238,90.647256,128.1682614,1.8,90.6702959,128.0440826,-1.168113,10.3417239,13.9398589,6012.5805752,9749.4721956,35.2365133,699.3953289,581.3905529,1129.6043814,18.906272,26.3829832,1.0415495,73.7514809),(42523,'metatarsal.tif',253,10,149,248.9085332,90.5685788,128.2706433,1.8,90.594562,128.2000097,-1.1511463,10.4281034,13.4641756,6045.1352834,9557.913396,34.5979529,709.8773585,579.6965218,1154.6139401,18.906272,25.9810273,0.9736197,74.0031863),(42524,'metatarsal.tif',253,10,150,247.178981,90.5003178,128.3492173,1.8,90.5333398,128.2714768,-1.1386946,10.4949929,13.3975105,6067.6104571,9369.9740484,33.9715822,699.381729,578.1433626,1151.015042,18.906272,25.795599,1.047518,74.6108569),(42525,'metatarsal.tif',253,10,151,246.0542378,90.4255019,128.4437379,1.8,90.4731956,128.3859504,-1.1225967,10.5663194,13.1510592,6089.5062651,9191.8303726,33.3080864,698.9422117,576.3129058,1161.6031828,18.906272,25.5076926,1.0014831,72.0327289),(42526,'metatarsal.tif',253,10,152,245.3147036,90.3617732,128.5283021,1.8,90.3905494,128.4727357,-1.1045356,10.6377129,13.2470088,6120.1901911,9069.5254806,32.6229897,684.6470505,575.3295114,1145.6443189,19.33596,25.5835817,1.0620665,74.5676711),(42527,'metatarsal.tif',253,10,153,243.6845729,90.2960397,128.57236,1.8,90.2843567,128.5293319,-1.083343,10.7823532,12.7439421,6132.8438796,8873.0826539,31.7042816,696.2588666,568.7852902,1177.4938493,19.33596,25.0990762,0.9067502,71.6767637),(42528,'metatarsal.tif',253,10,154,241.2282988,90.2530052,128.6685891,1.8,90.2402325,128.6337807,-1.0612307,10.5803274,12.4703508,6137.4300125,8701.0863155,30.6381266,697.7419068,580.0794061,1189.8203408,19.33596,24.8365611,0.9203749,73.8557407),(42529,'metatarsal.tif',253,10,155,237.2503233,90.2074087,128.7592255,1.8,90.1910823,128.7186796,-1.0408263,10.9618301,12.4134656,6115.2884845,8487.2953382,29.437315,683.716827,557.8711239,1176.150765,19.33596,24.6762153,0.9586438,74.1074461),(42530,'metatarsal.tif',253,10,156,234.4395562,90.1685666,128.8275571,1.8,90.1500179,128.7812333,-1.0126157,11.0728715,12.2659273,6091.9468967,8345.2806694,28.1123282,680.3628022,550.1686599,1176.0835014,19.33596,24.4318345,0.9730379,72.8921049),(42531,'metatarsal.tif',253,10,157,231.8864344,90.1120851,128.8956504,1.8,90.102209,128.8637651,-0.9812499,11.1962154,12.2142971,6071.9412402,8206.2334807,26.7010172,671.8547446,542.3208681,1168.6897764,19.33596,24.3258062,0.9484935,70.5656823),(42532,'metatarsal.tif',253,10,158,230.0305494,90.0675398,128.9761405,1.8,90.0719302,128.9246901,-0.9567121,11.2657977,12.047892,6066.2159154,8070.4687402,25.6093651,669.865629,538.4630588,1169.8987834,19.33596,24.0778691,0.9629943,72.6403995),(42533,'metatarsal.tif',253,10,159,227.8092053,90.0217178,129.0417521,1.8,90.0371822,128.9687866,-0.9252229,11.3521879,12.007946,6046.6032791,7916.704954,24.2240669,659.2888523,532.6377039,1160.8154952,19.33596,24.0778691,0.9629943,69.7063063),(42534,'metatarsal.tif',253,10,160,225.9599782,89.9881171,129.0944829,1.8,90.006643,129.0381675,-0.8864153,11.4363006,11.9109216,6027.0575531,7816.9597418,22.6084747,656.2850458,527.0111167,1162.2930382,19.33596,23.8931257,0.9129077,69.3503411),(42535,'metatarsal.tif',253,10,161,224.2796052,89.9846575,129.1109697,1.8,90.0171485,129.0669111,-0.8087069,10.6779065,11.8772386,6059.392973,7692.2310419,19.56093,647.6447356,567.4701259,1157.4466909,20.195336,23.8234776,0.8876049,70.0622715),(42536,'metatarsal.tif',253,10,162,223.017619,89.9630693,129.1594752,1.8,89.9474948,129.141254,-0.7601746,10.3766994,11.6323955,6028.6385628,7611.0368196,17.6476506,654.2965988,580.9784308,1164.7840796,20.195336,23.7691657,0.8621701,69.4546009),(42537,'metatarsal.tif',253,10,163,221.7437157,89.9323214,129.204695,1.8,89.9262371,129.1918885,-0.7189819,10.5651723,11.6611153,5991.2758959,7534.7273944,16.0312913,646.141233,567.0779181,1155.8876395,20.195336,23.7302954,0.8366353,69.7063063),(42538,'metatarsal.tif',253,10,164,219.9069652,89.8887754,129.261911,1.8,89.9069593,129.2493522,-0.6811269,10.4863494,11.704891,5942.4059996,7435.390739,14.5315571,635.2379298,566.6801465,1136.2519802,20.195336,23.7302954,0.8366353,69.7063063),(42539,'metatarsal.tif',253,10,165,218.1605165,89.8616335,129.3065413,1.8,89.9279391,129.2941543,-0.6277719,10.3409836,11.5916214,5882.4307197,7353.8675656,12.5432025,634.4123321,568.8463447,1122.3937312,19.765648,23.7302954,0.8366353,69.0986357),(42540,'metatarsal.tif',253,10,166,216.3939261,89.8341109,129.3460438,1.8,89.911881,129.3275635,-0.5836421,10.3956226,11.4143417,5808.1752396,7270.8953635,10.9522225,636.996471,558.7135537,1127.6171454,19.765648,23.44459,0.8502422,68.8469303),(42541,'metatarsal.tif',253,10,167,213.2052234,89.812857,129.3780295,1.8,89.9254785,129.3446103,-0.5390407,13.6590417,11.3599449,5730.5257236,7201.9423026,9.3629141,633.9768688,419.5408331,881.8291955,19.7550129,23.4130679,0.7464568,69.2028955),(42542,'metatarsal.tif',253,10,168,211.9403838,89.7603123,129.4206654,1.8,89.8925336,129.3773621,-0.4963668,10.2700571,11.2879886,5654.5766023,7126.2196007,8.0113046,631.3099598,550.5886262,1098.2864926,19.33596,23.4130679,0.8243395,69.2028955),(42543,'metatarsal.tif',253,10,169,209.5750269,89.8126397,129.4266115,1.8,89.9182164,129.3741721,-0.4545267,10.2672044,11.1671269,5553.4151309,7026.0402701,6.7327227,629.171706,540.8887272,1082.8794578,19.33596,23.1633319,0.7066142,68.5952249),(42544,'metatarsal.tif',253,10,170,207.9549111,89.7995868,129.4437529,1.8,89.8845991,129.3913178,-0.4240888,10.2650205,11.1401435,5490.2841871,6996.0321434,5.8686399,628.0019777,534.853701,1093.9688589,19.33596,22.951132,0.6659692,68.3435195),(42545,'metatarsal.tif',253,10,171,207.349151,89.8429563,129.4601108,1.8,90.0155515,129.3984445,-0.3653126,10.0925055,11.1165213,5445.657264,7063.1977881,4.4103628,635.3784229,539.574368,1098.2751372,19.2998945,22.951132,0.6659692,69.5588607),(42546,'metatarsal.tif',253,10,172,205.6265365,89.8130066,129.4884094,1.8,89.984655,129.4605873,-0.3371901,9.9621687,11.0748228,5362.1880562,6989.9408541,3.7510713,631.1559971,538.2550942,1080.6228792,18.906272,22.951132,0.6659692,68.3435195),(42547,'metatarsal.tif',253,10,173,202.6796455,89.7830148,129.4946591,1.8,89.9268369,129.4733182,-0.31189,9.9056336,10.9258008,5267.9538483,6918.3833088,3.1807817,633.2152156,531.813922,1088.1201372,18.906272,22.6881774,0.6510767,68.0918141),(42548,'metatarsal.tif',253,10,174,210.3447736,89.851222,129.5252422,1.8,90.1161316,129.540865,-0.2771977,9.7538213,10.8061437,5224.6260513,6946.4702928,2.6254722,642.8260126,535.6491476,1015.9355807,18.906272,22.886685,0.6923344,68.5952249),(42549,'metatarsal.tif',253,10,175,211.3407222,89.846353,129.5415555,1.8,90.0405066,129.5683651,-0.2542654,9.6075853,10.6573458,5162.8124721,6923.5938427,2.2285745,649.6546138,537.368374,1025.1040462,18.8185443,22.6881774,0.6510767,68.6994847),(42550,'metatarsal.tif',253,10,176,211.6118511,89.8395783,129.54841,1.8,89.9886301,129.5577679,-0.231575,9.4428136,10.7424297,5107.0202875,6928.5712623,1.8577819,644.9724568,540.8367158,1075.9786696,18.476584,22.6881774,0.6510767,68.3435195),(42551,'metatarsal.tif',253,10,177,211.069817,89.8963842,129.5013669,1.8,90.0616786,129.5001152,-0.2011348,9.2957016,10.8122912,5035.8081893,6904.4414932,1.4040583,638.573396,541.7351387,1049.8827172,18.476584,22.6881774,0.6510767,67.9875543),(42552,'metatarsal.tif',253,10,178,211.1625245,89.9182788,129.5140849,1.8,90.1293972,129.5119458,-0.168616,9.2057256,11.0035512,4975.0085806,6977.7426797,0.9911591,634.1355206,540.425467,1051.8418853,18.476584,22.6881774,0.6510767,68.3435195),(42553,'metatarsal.tif',253,10,179,211.0611449,89.9346827,129.5283556,1.8,90.1229726,129.5591028,-0.1446325,9.2073846,11.0163489,4918.9083161,6985.331094,0.7307325,634.0876785,534.2351319,1053.769502,18.476584,22.4303721,0.6358384,68.4477793),(42554,'metatarsal.tif',253,10,180,207.8336695,89.9284494,129.5577463,1.8,90.100611,129.6212556,-0.1227984,9.199448,11.044818,4832.9294077,6924.0398033,0.5197163,626.9039293,525.349937,1040.739945,18.3804804,22.3106986,2.868584,68.1960739),(42555,'metatarsal.tif',253,10,181,204.8101283,89.953368,129.5852967,1.8,90.1065909,129.6359492,-0.1116329,9.1779538,11.0781952,4758.6645665,6890.8372816,0.4236236,622.0180429,518.4886148,1033.9815138,18.046896,22.3106986,2.868584,67.8401087),(42556,'metatarsal.tif',253,10,182,202.8114614,89.9642417,129.5867522,1.8,90.1183284,129.6113114,-0.1066481,9.1332149,11.1137689,4700.2566292,6878.728565,0.3830015,618.9375191,514.6333093,1028.721491,18.046896,22.3479072,0.6627295,68.0918141),(42557,'metatarsal.tif',253,10,183,201.8857288,90.0191163,129.5833805,1.8,90.1810109,129.6014978,-0.0959356,9.1018233,11.1939408,4653.15804,6926.8891276,0.308732,618.8070185,511.2336163,979.2280083,18.046896,22.9832877,2.7784456,69.5588607),(42558,'metatarsal.tif',253,10,184,201.3053137,90.0733389,129.5816469,1.8,90.205963,129.5676072,-0.0872397,9.0742861,11.161572,4615.0971543,6935.4340772,0.2547008,621.3671417,508.5906608,990.2037675,18.046896,22.9832877,2.7784456,68.4477793),(42559,'metatarsal.tif',253,10,185,199.0138655,90.0729487,129.513138,1.8,90.1628249,129.480127,-0.0841728,8.9731597,11.1636779,4550.512721,6926.3206787,0.2344497,620.4335833,507.1248978,997.6733498,17.617208,22.724768,2.8736822,68.0918141),(42560,'metatarsal.tif',253,10,186,198.0090769,90.111514,129.4810258,1.8,90.2238645,129.4818104,-0.0744504,8.9909054,11.6389222,4508.8446047,6977.6751733,0.1825851,599.5121416,501.4894947,951.7368485,17.617208,23.5075075,2.8256224,70.1665313),(42561,'metatarsal.tif',253,10,187,196.152017,90.1221919,129.4418245,1.8,90.218279,129.4507037,-0.0618147,8.9872484,11.6449352,4449.3104183,6967.6596569,0.1247589,598.342499,495.0692607,965.5433033,17.617208,23.139407,2.8785979,68.4477793),(42562,'metatarsal.tif',253,10,188,195.4980288,90.148971,129.407075,1.8,90.2301201,129.4177142,-0.0497666,9.0097566,11.2683658,4412.9168407,6972.9198962,0.0806324,618.8048934,489.7931241,987.2225383,17.9190667,22.9832877,2.7784456,68.1960739),(42563,'metatarsal.tif',253,10,189,192.9301365,90.1383996,129.3770613,1.8,90.1956162,129.4181878,-0.030097,8.9942284,11.2899591,4335.393768,6948.0215139,0.0291183,615.4160018,482.0195347,976.912604,17.617208,23.099477,2.8198421,67.8401087),(42564,'metatarsal.tif',253,10,190,190.935386,90.1673069,129.3496087,1.8,90.2040316,129.390408,-0.0118658,9.0049916,11.2486273,4271.8399072,6945.2402137,0.0044803,617.4300241,474.3857741,964.4047369,17.617208,23.2389317,2.8023,67.8401087),(42565,'metatarsal.tif',253,10,191,190.4955147,90.1861722,129.3183705,1.8,90.2386186,129.3575115,0.0048272,9.0553463,11.6560561,4230.767131,6979.8592943,0.0007398,598.818265,467.2120765,956.2976865,17.8422921,23.2587856,2.9369508,68.8037445),(42566,'metatarsal.tif',253,10,192,189.9109034,90.1977708,129.258936,1.8,90.2890126,129.3146645,0.0159275,9.1399224,11.6722556,4186.4623621,6992.0642629,0.008029,599.032829,458.0413444,943.4012832,17.8404337,23.4485273,2.9010584,68.5520391),(42567,'metatarsal.tif',253,10,193,190.3373469,90.2656879,129.13546,1.8,90.3263124,129.2077175,0.0293015,8.9048256,11.6342229,4144.1723569,7021.7624632,0.0272289,603.5437474,465.3850084,945.7511611,17.617208,23.5389032,2.7678658,68.6562988),(42568,'metatarsal.tif',253,10,194,189.241809,90.2971164,129.0599713,1.8,90.3364975,129.1541568,0.0393967,9.0177764,11.6424047,4089.5742829,7053.3510414,0.0489284,605.8328321,453.5014069,937.4273179,17.617208,23.6679702,2.8657868,68.3003337),(42569,'metatarsal.tif',253,10,195,188.3361062,90.3073793,128.9893013,1.8,90.3576282,129.0624522,0.0509754,9.1078001,11.6627356,4052.3752401,7068.5486247,0.0814944,606.0798156,444.934581,935.008545,17.617208,23.6679702,2.8657868,68.4477793),(42570,'metatarsal.tif',253,10,196,186.7212496,90.3133276,128.8839675,1.8,90.3876457,128.980317,0.0601833,9.1634678,12.0355039,3998.528828,7094.3828635,0.1125822,589.4545787,436.3554192,918.3957078,17.617208,23.8660645,2.9053474,68.5520391),(42571,'metatarsal.tif',253,10,197,185.8227083,90.344053,128.8067437,1.8,90.408776,128.9223771,0.0668944,8.9397977,12.0452999,3969.7374588,7125.280705,0.1383819,591.5403314,444.0522716,914.5398961,17.18752,24.0817029,2.8706458,68.1960739),(42572,'metatarsal.tif',253,10,198,185.2664071,90.3653879,128.7270698,1.8,90.4438834,128.8486085,0.0717786,9.0064153,12.0366536,3932.1707383,7173.2534394,0.1588141,595.9508097,436.596651,915.8447275,17.617208,24.0970318,2.757775,68.9080042),(42573,'metatarsal.tif',253,10,199,184.5442171,90.3862506,128.6248237,1.8,90.454125,128.7326044,0.0838241,9.0727369,12.0772139,3902.869586,7223.9484213,0.2156105,598.146929,430.1755515,910.627339,17.617208,24.3258062,2.8366003,68.8037445),(42574,'metatarsal.tif',253,10,200,183.6256461,90.404327,128.5198897,1.8,90.4531562,128.6515572,0.0986524,9.1226192,12.095739,3870.6546009,7284.2939041,0.2968851,602.219832,424.292026,912.3735629,17.617208,24.3258062,2.8366003,69.1597097),(42575,'metatarsal.tif',253,10,201,183.2213025,90.5118306,128.3617693,1.8,90.5726737,128.5306026,0.1137361,9.0252728,12.361757,3822.7369048,7381.4478697,0.3933214,597.1196385,423.559152,904.142547,17.18752,24.6125346,2.8584969,68.9080042),(42576,'metatarsal.tif',253,10,202,182.8419121,90.4999214,128.2587112,1.8,90.5456007,128.4081801,0.1222433,9.092746,12.44546,3794.5827755,7468.6906848,0.4531166,600.113672,417.3197821,900.201507,17.617208,24.8030861,2.896614,69.87164),(42577,'metatarsal.tif',253,10,203,182.9150935,90.5368577,128.122382,1.8,90.5779477,128.2851899,0.1328092,9.1369276,12.4398171,3781.0021975,7612.0578372,0.5345639,611.9107514,413.8154922,910.9195693,17.617208,24.9107889,2.8798792,69.7673802),(42578,'metatarsal.tif',253,10,204,183.7133741,90.5768917,127.9840266,1.8,90.6320878,128.1732375,0.1405361,9.1008785,12.6740926,3789.2691276,7781.8838095,0.6007645,613.9992886,416.3630035,912.9767175,17.617208,25.1468455,2.7928217,70.1233454),(42579,'metatarsal.tif',253,10,205,184.6295953,90.5993605,127.8330919,1.8,90.6358748,128.0148204,0.1485279,9.1462328,12.8010265,3793.4083382,7984.2063389,0.6738607,623.7160991,414.7509066,917.7478951,17.617208,25.5402441,2.9210989,71.0869812),(42580,'metatarsal.tif',253,10,206,185.8860985,90.6071603,127.6949243,1.8,90.6327441,127.9110814,0.1556645,9.1619413,12.8875115,3814.0936791,8219.8289416,0.7446699,637.8135118,416.2975442,928.4694847,17.617208,25.8527955,2.8724252,71.2344268),(42581,'metatarsal.tif',253,10,207,187.6232597,90.6271648,127.5527716,1.8,90.6862495,127.7655975,0.1593545,9.1564005,13.0468272,3850.7879742,8508.7131701,0.7873804,652.1672299,420.5569619,947.0835473,17.617208,25.9703655,2.8564749,71.8420974),(42582,'metatarsal.tif',253,10,208,190.5225381,90.6087828,127.3622194,1.8,90.68198,127.592707,0.1689008,9.2914887,13.2380703,3927.0356688,8847.2319814,0.8972736,668.3173439,422.6487053,963.9190517,17.617208,26.3829832,2.8610559,72.449768),(42583,'metatarsal.tif',253,10,209,192.081222,90.6533047,127.1194791,1.8,90.7028206,127.3549278,0.176551,9.4011927,13.3166731,4018.0483626,9131.5693492,0.9875451,685.7245246,427.3977235,983.5671996,18.046896,26.6822063,2.8809903,73.309144),(42584,'metatarsal.tif',253,10,210,193.9364356,90.7125747,126.9197701,1.8,90.7531417,127.1903889,0.180621,9.4208798,13.4900866,4124.1624085,9388.5011947,1.0430777,695.9555905,437.7682875,1001.6734574,18.3109623,26.9917949,2.900475,74.5244852),(42585,'metatarsal.tif',253,10,211,197.6579968,90.7036391,126.6871539,1.8,90.7354744,126.9328354,0.1791077,9.5682025,13.6168652,4313.3435118,9731.5034037,1.0455449,714.6654741,450.7997719,1030.2084934,18.4158896,27.2199802,2.9349094,75.3838612),(42586,'metatarsal.tif',253,10,212,201.0018462,90.7812702,126.4193576,1.8,90.797725,126.6959514,0.1823433,9.6955796,13.7799695,4557.122151,10104.6686136,1.1015641,733.2867189,470.0205987,1063.4289363,18.7702967,27.5570408,2.9533711,76.8509078),(42587,'metatarsal.tif',253,10,213,204.7740412,90.8782923,126.1474473,1.8,90.8503854,126.4352603,0.1792664,9.9008378,13.8109186,4838.2138138,10488.1194053,1.0850858,759.4078075,488.6671118,1109.4620518,19.2006856,27.7306933,2.9229237,78.3179544),(42588,'metatarsal.tif',253,10,214,209.2326189,90.9054576,125.8220939,1.8,90.9133164,126.1103601,0.1877196,10.048746,14.0285757,5151.8372932,10987.1494344,1.2144797,783.1977886,512.6845951,1148.3920973,19.5427706,28.0484581,3.0495458,80.245226),(42589,'metatarsal.tif',253,10,215,214.7482415,90.9783094,125.4796323,1.8,90.9650031,125.7241068,0.1920314,10.3246313,14.1006889,5606.3795517,11523.1628577,1.3037009,817.2056633,543.0101484,1214.7532419,20.1122797,28.2583162,2.9889433,81.963978),(42590,'metatarsal.tif',253,10,216,219.2951067,91.0341145,125.0933524,1.8,91.0298708,125.3094435,0.1970835,12.1189855,14.1214684,6100.1894636,12001.082454,1.4013541,849.8466402,503.3580939,1061.4102902,20.6823853,28.4763545,3.0509328,83.7869898),(42591,'metatarsal.tif',253,10,217,224.6467427,91.313115,124.7294114,1.8,91.2431075,124.9186024,0.1870905,11.441374,14.0941411,6648.9952456,12423.0812766,1.295326,881.4358512,581.136082,1319.0503793,21.7827101,28.9457943,0.1040999,86.8253428),(42592,'metatarsal.tif',253,10,218,232.11521,91.3422356,124.2987036,1.8,91.3027471,124.4771656,0.2023501,11.7442528,14.216825,7312.3258703,13048.8080061,1.562513,917.8426268,622.6301476,1380.4235206,22.6484912,29.3260093,0.1916485,89.1517654),(42593,'metatarsal.tif',253,10,219,252.9474932,91.3571163,123.8708703,1.8,91.5452497,124.1397049,0.2521736,11.7449731,15.0415984,8592.5470568,14894.0669447,2.6245377,990.1917703,731.5935926,1529.2451189,23.3736888,30.3409631,0.2140607,93.5529052),(42594,'metatarsal.tif',253,10,220,280.2252158,91.5003223,123.3772353,1.8,91.607402,123.7948413,0.2665316,12.1877859,15.2709084,9842.0408907,17602.5161478,3.2399986,1152.6829754,807.5331286,1756.4319183,23.7827148,31.0566644,0.25169,94.915692),(42595,'metatarsal.tif',253,10,221,309.5402101,91.8194278,123.0355783,1.8,91.6763161,123.5290334,0.2444175,12.3316419,15.2261698,10921.9719745,19921.5322988,3.0210989,1308.3745021,885.6867601,1946.8187621,24.0268616,31.5550182,0.1091535,96.634444),(42596,'metatarsal.tif',253,10,222,333.1338574,92.043276,122.8620682,1.8,91.7895038,123.3044248,0.242813,12.3400364,15.405436,11680.9776889,21200.1946725,3.2096638,1376.1502524,946.5918347,2037.746224,24.0056601,31.7882009,0.1629265,97.033595),(42597,'metatarsal.tif',253,10,223,354.1951958,91.9786665,122.7613048,1.8,91.8295922,123.068268,0.2292358,11.9321064,15.059461,12220.4419921,21685.0661942,3.0481453,1439.9629728,1024.1646848,2132.4912049,23.9878106,31.883892,2.2223835,97.6412656),(42598,'metatarsal.tif',253,10,224,376.387376,91.9256968,122.7930485,1.8,91.8344952,122.8512345,0.2069724,11.953782,14.8266982,12237.2841414,21669.8727802,2.6491009,1461.5440688,1023.7165205,2120.1755305,23.3836277,31.814327,0.2875758,97.2853004),(42599,'metatarsal.tif',253,10,225,377.1323932,91.8602249,122.9304209,1.8,91.809671,122.6811121,0.1731013,12.3414595,14.5075128,12137.2777447,20458.7575875,1.8646657,1410.2181275,983.4556221,2028.3899751,23.0809091,31.5345327,0.3476069,96.3216646),(42600,'metatarsal.tif',253,10,226,350.3441686,91.8941898,123.0652962,1.8,91.9612508,122.7036116,0.1597547,12.1704072,14.3996329,11398.7594244,17424.8539278,1.4775876,1210.0901467,936.5963888,1805.1726329,22.5960317,30.880789,0.3701708,93.7435366),(42601,'metatarsal.tif',253,10,227,322.5658701,91.830507,123.1785972,1.8,91.8883796,122.8044067,0.0861875,12.0832296,14.8588227,9794.973166,14793.0153647,0.398364,995.5711576,810.6254269,1552.2896666,21.8386247,30.1762146,0.348771,92.27649),(42602,'metatarsal.tif',253,10,228,308.2321779,91.4255321,123.3439958,1.8,91.5280707,122.9616282,0.1068566,10.8818476,14.6816221,8095.1749654,13794.5849297,0.5843536,939.5818001,743.9154863,1400.5754603,20.7001966,29.8099437,0.2624594,87.97961),(42603,'metatarsal.tif',253,10,229,289.5363082,91.1260686,123.4903369,1.8,91.2817618,123.1813225,0.1848475,10.084963,13.4803794,5993.9689605,13114.2834433,1.6301471,972.8423075,594.3471424,1298.801269,19.2673858,28.5702133,0.2121438,83.8301756),(42604,'metatarsal.tif',253,10,230,257.6303145,91.1825659,123.5969438,1.8,91.2211551,123.3598887,0.2155541,8.8695926,12.9219306,3731.3561952,11742.2146314,1.9643628,908.704357,420.6908217,1134.9972602,17.0818571,27.2199802,0.2066832,78.2136946),(42605,'metatarsal.tif',253,10,231,193.5792011,91.4537795,123.63705,1.8,91.4191489,123.5252103,0.230961,7.0901401,12.7496359,1566.4796207,8207.6522556,1.6906308,643.7558154,220.9377538,759.1739003,14.0369309,25.8385082,3.0750245,70.8784617),(42606,'metatarsal.tif',253,10,232,53.7517374,92.0657014,123.7372577,1.8,91.904932,123.6822506,0.2232595,4.9523387,11.5722589,186.4644221,1771.2683328,0.4391708,153.0615884,37.651791,169.1746354,9.8702917,23.0314371,2.896614,57.9267477),(42607,'metatarsal.tif',253,10,233,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42608,'metatarsal.tif',253,10,234,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42609,'metatarsal.tif',253,10,235,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42610,'metatarsal.tif',253,10,236,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42611,'metatarsal.tif',253,10,237,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42612,'metatarsal.tif',253,10,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42613,'metatarsal.tif',253,10,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42614,'metatarsal.tif',253,10,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42615,'metatarsal.tif',253,10,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42616,'metatarsal.tif',253,10,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42617,'metatarsal.tif',253,10,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42618,'metatarsal.tif',253,10,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42619,'metatarsal.tif',253,10,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42620,'metatarsal.tif',253,10,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42621,'metatarsal.tif',253,10,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42622,'metatarsal.tif',253,10,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42623,'metatarsal.tif',253,10,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42624,'metatarsal.tif',253,10,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42625,'metatarsal.tif',253,10,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42626,'metatarsal.tif',253,10,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42627,'metatarsal.tif',253,10,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42628,'metatarsal.tif',253,10,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42629,'metatarsal.tif',253,10,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42630,'metatarsal.tif',253,10,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42631,'humerus.tif',229,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42632,'humerus.tif',229,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42633,'humerus.tif',229,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42634,'humerus.tif',229,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42635,'humerus.tif',229,2,5,0.0012449,18.0267081,12.1841363,1.8,18.0275339,12.1840337,-0.8773829,0.0183478,0.0286417,0.0000004,0.0000008,0.0001227,0.0000287,0.0000219,0.0000397,0.0806,0.1139856,0.7853982,0.2279712),(42636,'humerus.tif',229,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42637,'humerus.tif',229,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42638,'humerus.tif',229,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42639,'humerus.tif',229,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42640,'humerus.tif',229,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42641,'humerus.tif',229,2,11,0.7044256,20.366077,10.4408638,1.8,20.3745213,10.4544828,0.0682743,1.0751554,1.0391562,0.1069189,0.1584788,0.0005464,0.1525072,0.0994451,0.2350338,1.744223,2.1210209,2.8920057,7.7989313),(42642,'humerus.tif',229,2,12,7.185985,20.3383912,10.2966655,1.8,20.3191472,10.2569719,0.9776422,1.4942829,2.2850141,3.2440626,10.973447,0.8234448,4.8023543,2.1709829,5.8205064,2.8635117,4.5865934,2.2002386,13.7292509),(42643,'humerus.tif',229,2,13,14.9020462,18.6866571,9.9378658,1.8,18.7699275,9.91601,0.2085234,3.3123024,9.1899572,24.5631867,214.8631274,0.1064389,23.3802098,7.4157441,26.0191543,3.8618609,6.2035828,1.9995744,18.0809561),(42644,'humerus.tif',229,2,14,23.4920905,17.2713775,9.7848085,1.8,17.4065852,9.7569747,0.1898102,3.9326803,7.8797489,46.2271982,476.8736699,0.1393759,60.518892,11.7546291,65.4466331,3.2534587,4.3168055,1.6174913,12.5087947),(42645,'humerus.tif',229,2,15,30.6739574,16.7874463,9.7476005,1.8,16.91899,9.7048227,0.1924934,4.2389456,7.6957296,70.5938071,641.9118782,0.1871024,83.411439,16.6536241,92.5532202,4.2289418,5.2848347,1.5250268,15.9583934),(42646,'humerus.tif',229,2,16,36.3048676,16.5111713,9.7233302,1.8,16.5756341,9.6736843,0.1966426,4.5240329,7.735891,95.1313287,724.5580052,0.2309744,93.6618683,21.0279921,105.9478026,7.4436866,15.0635777,2.814766,45.2106349),(42647,'humerus.tif',229,2,17,40.0993676,16.3205089,9.711996,1.8,16.3675913,9.6732055,0.1925696,4.7199464,7.7756739,118.9086652,785.4504829,0.244786,101.0138153,25.1928,116.2992859,7.7975373,15.4286385,2.7867963,45.1013946),(42648,'humerus.tif',229,2,18,43.2430403,16.3737459,9.6457106,1.8,16.387656,9.616922,0.1658,4.7243829,8.0242233,148.1677156,884.680088,0.1963139,110.2511806,31.3623428,125.5406018,8.0504534,16.0507878,0.0376706,46.8550378),(42649,'humerus.tif',229,2,19,44.652817,16.4677514,9.5856961,1.8,16.4504431,9.5611258,0.1433983,4.6403888,8.4078825,174.3994986,976.2330481,0.1519871,116.1092645,37.5829497,135.2091274,8.1617554,16.7385268,0.040941,47.8613515),(42650,'humerus.tif',229,2,20,44.8312335,16.4628332,9.5478367,1.8,16.4297803,9.5278706,0.1324013,4.6193769,11.5643136,189.2825275,1089.5479766,0.1302192,94.2163985,40.9757706,110.5503901,8.2341684,17.333686,0.0232516,48.7398508),(42651,'humerus.tif',229,2,21,46.8297789,15.7194413,9.4213198,1.8,15.7344185,9.4084821,0.1244568,4.5900349,11.8730377,194.4233243,1512.5940843,0.1202721,127.3973964,42.3577002,143.6850351,8.1914266,21.1630268,3.1187395,57.9993605),(42652,'humerus.tif',229,2,22,47.3764175,15.2020383,9.3288906,1.8,15.2618349,9.3210088,0.1272394,4.5759482,11.6494712,191.5302567,1798.8150035,0.1271479,154.4117308,41.8558622,170.708241,8.0982807,21.6032065,3.1266684,57.2372195),(42653,'humerus.tif',229,2,23,48.0512226,14.9027852,9.24096,1.8,14.9794804,9.2054653,0.1145035,4.5794767,11.6401506,192.9338809,2023.9317084,0.1045422,173.8750449,42.1301154,190.447941,8.0244239,22.0446901,3.1342802,57.94069),(42654,'humerus.tif',229,2,24,47.7858633,14.8073077,9.1747671,1.8,14.8508831,9.1476219,0.1024716,4.5369759,11.6294686,181.1036148,2149.4398618,0.0833364,184.8270063,39.9172527,200.3539554,7.8580521,22.1811515,3.1034294,59.1041534),(42655,'humerus.tif',229,2,25,46.2685671,14.6637533,9.0285063,1.8,14.6251118,8.9851739,0.0839651,4.2975042,11.5512526,159.8513322,2171.4430871,0.0542389,187.9833441,37.1963179,201.7218078,7.4995819,22.2281451,3.0962517,59.8410095),(42656,'humerus.tif',229,2,26,42.8291352,14.1155368,8.7529969,1.8,14.168696,8.7508167,0.0444077,3.7533608,11.1439089,129.4644691,2027.9030864,0.0140675,181.9741257,34.4929451,192.1860608,6.9688213,22.2469148,3.1307235,63.0275737),(42657,'humerus.tif',229,2,27,38.9465848,13.5485045,8.4515841,1.8,13.4922045,8.4478306,0.0062833,3.4145758,11.7153853,105.742348,1844.7819741,0.0002563,157.4666069,30.9679308,166.0890801,6.6422134,22.2469148,3.1307235,59.4282311),(42658,'humerus.tif',229,2,28,36.3232289,13.4205439,8.3564699,1.8,13.2843879,8.3643394,0.0011216,3.2123863,11.8871553,94.6411995,1744.3688777,0.0000076,146.7440133,29.4613381,154.3978585,6.3159572,22.1711914,0.023632,59.1351663),(42659,'humerus.tif',229,2,29,35.1745226,13.5513783,8.336941,1.8,13.4112373,8.3488713,-0.0003493,3.0595308,11.7572875,86.0003975,1682.5391462,0.0000008,143.1060649,28.1090154,150.1103557,5.9900527,22.0061625,0.014651,57.9423677),(42660,'humerus.tif',229,2,30,34.8460122,13.7769788,8.2920918,1.8,13.6800733,8.2961612,0.0014297,3.0063436,11.3694752,82.4252848,1639.4289394,0.0000118,144.195656,27.4171201,150.8556612,5.7226002,21.6346082,0.0559118,56.8635547),(42661,'humerus.tif',229,2,31,34.1492847,13.9668134,8.219808,1.8,13.9077025,8.2505483,-0.0042497,3.0034854,11.1843908,76.8453965,1557.1648302,0.0001028,139.2266107,25.585407,145.6074294,5.6017002,21.3552745,0.0585342,55.3955705),(42662,'humerus.tif',229,2,32,32.9054424,14.0297805,8.1291503,1.8,13.9795386,8.1588704,-0.0157081,2.9797655,11.1329601,73.3569254,1451.3698923,0.0013531,130.3669353,24.6183556,136.5088962,5.4808002,21.1669786,0.0685945,53.5856294),(42663,'humerus.tif',229,2,33,32.0971119,14.1673941,8.0945757,1.8,14.1310773,8.1119887,-0.0276008,3.0444134,11.0457801,72.7018539,1369.5658474,0.0040743,123.9899616,23.8804144,130.2492813,5.5211002,21.0007479,0.0652917,53.4871503),(42664,'humerus.tif',229,2,34,31.8430448,14.4426275,8.012452,1.8,14.4622799,8.0318206,-0.0374126,3.0203702,10.8538039,71.2374259,1292.4988443,0.007425,119.0825685,23.5856603,125.4823608,5.4636764,20.7494528,0.0582996,52.1469804),(42665,'humerus.tif',229,2,35,32.2319594,14.6395373,7.9115693,1.8,14.6442612,7.9329763,-0.0474246,2.9892554,10.7033253,73.4360512,1231.2666141,0.012073,115.0358955,24.5666702,121.7780466,5.5033793,20.3949065,0.0652538,51.2961386),(42666,'humerus.tif',229,2,36,31.9979616,14.5594314,7.907817,1.8,14.5668116,7.904693,-0.0559339,3.0453829,10.8337301,74.2736496,1166.7742736,0.0166674,107.6982959,24.3889362,114.4360176,5.5935568,20.1484692,0.0620445,50.5552321),(42667,'humerus.tif',229,2,37,32.7965481,14.5534152,7.8582661,1.8,14.612825,7.8444635,-0.0658218,3.0336458,10.9106343,78.77675,1137.6427722,0.0236477,104.2691695,25.9676818,111.4759633,5.6941322,19.9178654,0.0952394,49.8713184),(42668,'humerus.tif',229,2,38,32.9260004,14.6507611,7.8241212,1.8,14.7105208,7.7972847,-0.0726032,3.0286249,10.8324271,82.0371362,1089.3962086,0.0288759,100.5680628,27.087255,108.0851242,5.7916373,19.6895925,0.1210547,48.745291),(42669,'humerus.tif',229,2,39,32.5830937,14.6467189,7.8012897,1.8,14.7002444,7.7671564,-0.086872,3.075033,10.8523429,83.4857584,1041.0931543,0.0408797,95.9325711,27.1495489,103.5768862,5.8850088,19.4807055,0.1495037,48.6825702),(42670,'humerus.tif',229,2,40,32.0895424,14.5936475,7.8097985,1.8,14.6423927,7.7617823,-0.0972171,3.1087704,10.9606919,85.5734702,1011.0760705,0.0503882,92.2456429,27.5264688,100.0048984,5.9853842,19.3393823,0.1696022,48.5392493),(42671,'humerus.tif',229,2,41,32.2385382,14.5471552,7.8240563,1.8,14.6671808,7.7691874,-0.1089218,3.1491545,11.0561272,87.1378662,958.6747084,0.0634945,86.7098119,27.6702416,94.5658152,6.0859063,19.2158334,0.1813542,49.142563),(42672,'humerus.tif',229,2,42,32.8108437,14.4844938,7.7976766,1.8,14.6523041,7.7420197,-0.1104255,3.0957248,11.0891415,88.9787988,929.2236494,0.0664108,83.7958149,28.7424769,91.7788568,6.146624,19.0557652,0.2044465,49.8794191),(42673,'humerus.tif',229,2,43,33.1367529,14.5632362,7.7801164,1.8,14.7668066,7.7124312,-0.117857,3.1217981,11.0157739,92.3094214,895.2241153,0.0763585,81.2674735,29.5693114,89.6181569,6.2476773,18.8979507,0.2061783,50.5535544),(42674,'humerus.tif',229,2,44,32.5971231,14.6869024,7.7642193,1.8,14.911757,7.6912494,-0.1206967,3.2104156,10.896698,94.2531468,812.0898573,0.0787606,74.5262335,29.3585503,83.1468123,5.632497,18.1466838,0.1673393,43.4817009),(42675,'humerus.tif',229,2,45,32.6132963,14.6636006,7.7938473,1.8,14.9386112,7.7110907,-0.1299103,3.2293714,10.901538,97.4146352,747.2449535,0.0912193,68.544911,30.1652002,77.4432353,5.7113356,17.7928043,0.1066552,42.5731714),(42676,'humerus.tif',229,2,46,33.0887801,14.7997935,7.800167,1.8,15.0849537,7.7123743,-0.1460388,3.2671925,10.8116424,100.9199365,720.0244358,0.1167821,66.5971375,30.8888858,75.9205423,5.8711227,17.6081954,0.0939753,42.5886779),(42677,'humerus.tif',229,2,47,33.4006043,14.7864523,7.8410078,1.8,15.0768931,7.7474239,-0.1577476,3.3261321,10.8181688,102.943084,689.1055442,0.1373799,63.6989085,30.9497884,73.1933723,6.0197583,17.379396,0.1022067,42.5944059),(42678,'humerus.tif',229,2,48,34.7117903,14.7767283,7.888729,1.8,15.0489871,7.8041689,-0.1827179,3.4483085,10.8468682,103.7849953,661.028222,0.1910072,60.9418506,30.0973635,70.5083381,5.9669169,17.1789598,0.1034035,41.4366706),(42679,'humerus.tif',229,2,49,35.491261,14.8019289,8.0022467,1.8,15.0439111,7.9404299,-0.2129416,3.6263473,10.8435573,110.323385,673.5133985,0.2641903,62.1118494,30.4227304,72.2802635,6.6378908,17.7030342,0.2814266,48.900068),(42680,'humerus.tif',229,2,50,34.1670815,14.7478061,8.0374832,1.8,15.0291829,7.9745487,-0.2291526,3.6559785,10.9189491,115.0546156,662.6361842,0.2938266,60.6868095,31.4702658,71.2106403,6.6658655,17.5138631,0.3013749,47.2253471),(42681,'humerus.tif',229,2,51,34.4168505,14.7357094,8.0111837,1.8,15.0326538,7.9354271,-0.2421368,3.6059228,10.8912629,116.2845526,656.883976,0.3297897,60.3129296,32.2482088,70.9567166,6.6717695,17.2590372,0.301074,46.171819),(42682,'humerus.tif',229,2,52,36.5146975,14.7430022,8.0445264,1.8,15.042681,7.9630083,-0.2516443,3.611871,10.8799207,117.1500764,643.1957058,0.3773148,59.1176835,32.4347347,69.8629358,6.6748665,17.0259755,0.3202535,45.4228118),(42683,'humerus.tif',229,2,53,37.1917241,14.7093434,8.0649998,1.8,15.0225336,7.9777441,-0.2579772,3.573886,10.9260115,117.0418159,623.0610313,0.4034612,57.0254784,32.7491745,67.7132504,6.6867796,16.7966422,0.3247854,44.2219125),(42684,'humerus.tif',229,2,54,36.9043886,14.7847296,8.0737965,1.8,15.0830485,7.9787093,-0.2657687,3.5698386,10.8246628,119.541871,614.6767995,0.4243117,56.7848449,33.4866323,67.8021134,6.7229338,16.5177902,0.3356386,43.0014563),(42685,'humerus.tif',229,2,55,36.6107107,14.8238258,8.0932857,1.8,15.1196097,7.9990744,-0.2791092,3.5754265,10.7931406,120.2512015,604.6221532,0.4631251,56.0191122,33.6326873,67.1425808,6.7514402,16.268527,0.3515223,42.4176994),(42686,'humerus.tif',229,2,56,35.9916291,14.8195264,8.0689614,1.8,15.1538181,7.9622872,-0.287153,3.5195811,10.7493666,121.3271647,581.4198932,0.4811794,54.0887586,34.4720467,65.3410991,6.798516,15.9700419,0.336913,41.8160635),(42687,'humerus.tif',229,2,57,35.6209374,14.8574523,8.0499969,1.8,15.2132099,7.9442471,-0.2960788,3.4713058,10.5583091,122.9356669,538.2960304,0.5054067,50.9831663,35.4148189,62.6105259,6.8276479,15.6619825,0.2231344,41.1850922),(42688,'humerus.tif',229,2,58,34.8425894,15.0596484,8.0391391,1.8,15.3928942,7.9181626,-0.3115991,3.4938415,10.2931651,124.7704481,517.6501468,0.5458206,50.2906679,35.7115361,62.3877853,6.8846405,15.472734,0.2500323,40.4499138),(42689,'humerus.tif',229,2,59,35.530784,15.1331085,8.0587973,1.8,15.4471432,7.9422039,-0.3276182,3.5201172,10.1865815,124.7589165,486.4200449,0.6131907,47.7510579,35.4416937,59.9772078,6.926789,15.3118793,0.2717922,39.915049),(42690,'humerus.tif',229,2,60,34.9395612,15.1646627,8.1021495,1.8,15.5198595,7.9517116,-0.3456135,3.5614778,10.130177,127.7472918,472.3283847,0.6683227,46.6258769,35.8691808,59.210528,6.9846654,15.1787161,0.2797584,40.5264634),(42691,'humerus.tif',229,2,61,35.6301359,15.2265759,8.1420977,1.8,15.5782285,7.9891178,-0.3592118,3.613626,10.0488077,132.0640543,463.0067831,0.7338495,46.0757928,36.5461328,59.206467,7.0390199,15.0521988,0.307357,40.5696274),(42692,'humerus.tif',229,2,62,36.437605,15.3889941,8.1429805,1.8,15.6872047,7.9984471,-0.381728,3.6502633,9.8015741,136.9864057,457.9721618,0.8427692,46.7243481,37.5278147,60.6568587,7.0973897,14.8726662,0.3140386,40.4515915),(42693,'humerus.tif',229,2,63,37.5731168,15.4495297,8.2451717,1.8,15.7124823,8.11685,-0.405341,3.7489226,9.6054674,141.6351267,430.9234834,0.9737563,44.8623127,37.7802215,59.563853,7.1678567,14.6180165,0.3313405,40.1666274),(42694,'humerus.tif',229,2,64,37.7414702,15.4181738,8.307178,1.8,15.6583935,8.1655718,-0.4259628,3.7685875,9.3764657,144.2672841,419.8489207,1.0739486,44.7768843,38.2815273,60.0960393,7.236385,14.2621585,0.3369415,38.9046849),(42695,'humerus.tif',229,2,65,38.4921821,15.4521937,8.2975265,1.8,15.6941283,8.1455856,-0.442967,3.7854967,9.2006141,147.4136286,417.3021255,1.17861,45.355899,38.9416876,61.343121,7.3186601,14.0316364,0.3826397,42.5667484),(42696,'humerus.tif',229,2,66,39.0924368,15.5443044,8.3252216,1.8,15.7781686,8.177314,-0.4587554,3.8302884,8.8721919,150.5585214,398.8769116,1.2776754,44.9581024,39.307359,61.8499133,7.3876883,13.7176966,0.3728688,37.8707137),(42697,'humerus.tif',229,2,67,38.0815451,15.6128316,8.3680447,1.8,15.8207708,8.228945,-0.4970216,3.8694009,8.6125035,155.1644156,383.5260802,1.442957,44.5313118,40.1003719,62.337247,7.4818849,13.4631562,0.3738361,36.4141856),(42698,'humerus.tif',229,2,68,39.2107207,15.6603696,8.4190204,1.8,15.8430084,8.2854307,-0.5269286,3.9342316,8.3443869,160.2707747,380.6764682,1.6526615,45.6206639,40.7375039,64.5631953,7.5797232,13.1597863,0.3566201,36.0958359),(42699,'humerus.tif',229,2,69,40.3874046,15.6178896,8.5474763,1.8,15.7407109,8.4391631,-0.5679432,4.0354035,8.1207266,163.0706834,361.7618854,1.9475858,44.5479699,40.4100074,64.1086093,7.668938,12.8154638,0.3565624,35.6513496),(42700,'humerus.tif',229,2,70,40.2213557,15.5329678,8.6746096,1.8,15.6450508,8.5628473,-0.6120584,4.0980887,7.7550386,165.0864753,333.5167844,2.2129229,43.0064637,40.2837727,63.5415371,7.7764537,11.3265231,0.4254496,32.5217783),(42701,'humerus.tif',229,2,71,40.4122994,15.4872734,8.7615658,1.8,15.5957008,8.6505615,-0.6583994,4.1305124,6.5939683,168.9369748,316.0432295,2.5214743,47.9291397,40.8997617,73.2988007,7.9048662,10.8695013,0.4818877,32.7301926),(42702,'humerus.tif',229,2,72,40.9516686,15.4241174,8.77297,1.8,15.5285244,8.6826698,-0.672709,4.046623,6.3396091,174.2820375,303.1973105,2.6499988,47.8258687,43.068513,75.0528069,7.9933612,10.5140533,0.4996526,31.2679365),(42703,'humerus.tif',229,2,73,39.8994553,15.4541622,8.8335293,1.8,15.5544488,8.7578972,-0.7274965,4.1127926,6.0512031,178.3020561,287.9077716,2.9407741,47.5785997,43.353039,76.6311507,8.0024253,10.2511829,0.8493776,30.4326012),(42704,'humerus.tif',229,2,74,38.748494,15.6210977,8.9188209,1.8,15.6833012,8.8541485,-0.8293796,4.332648,5.6660756,173.6299903,277.7080892,3.5127111,49.012422,40.0747972,78.4876393,7.9739331,10.0630644,0.9561334,30.167194),(42705,'humerus.tif',229,2,75,37.5560673,15.6439788,9.0725166,1.8,15.687611,9.012375,-0.9066827,4.4562402,5.5090679,172.0937784,268.6297976,3.8814113,48.7613878,38.6186044,78.5379771,7.9308941,9.9544266,1.072742,29.8724515),(42706,'humerus.tif',229,2,76,37.0229771,15.6402964,9.2343145,1.8,15.6771987,9.1698352,-0.9914488,4.5272713,5.3802011,171.8890685,263.5626818,4.3209999,48.9875145,37.9674765,78.9858798,7.9110476,9.8784338,1.0870784,29.6778659),(42707,'humerus.tif',229,2,77,36.6640025,15.6178627,9.3888788,1.8,15.6513564,9.3222083,-1.0936481,4.54142,5.2185978,172.3775873,258.4112313,4.8218751,49.5173687,37.9567593,79.3044754,7.8736083,9.8583556,1.1675148,29.6404299),(42708,'humerus.tif',229,2,78,36.5917516,15.5870859,9.5381802,1.8,15.6146899,9.4769409,-1.1972109,4.537645,5.078095,173.8367734,255.4401854,5.2863323,50.3023647,38.3099104,79.7237424,7.8550597,9.8650254,1.2335431,29.9726084),(42709,'humerus.tif',229,2,79,37.2566432,15.507691,9.6768356,1.8,15.533636,9.6302266,-1.3139911,4.4363933,4.9518695,177.723671,252.807211,5.808858,51.0528822,40.0603961,80.4660932,7.8516065,9.9089664,1.2863515,29.9449508),(42710,'humerus.tif',229,2,80,37.7553633,15.456304,9.7766045,1.8,15.4964502,9.7497947,-1.428927,4.3104316,5.228333,180.4510263,254.6175533,6.1667582,48.699567,41.8637955,80.66877,7.8457387,10.0013042,1.3473197,30.0157724),(42711,'humerus.tif',229,2,81,39.749166,15.4991538,9.7956179,1.8,15.5294795,9.7753237,-1.4976079,4.2688988,5.5787876,180.0247421,264.2762312,6.589438,47.3716242,42.1712367,78.250842,7.8552085,10.1328661,1.3624808,29.9921652),(42712,'humerus.tif',229,2,82,39.2739023,15.577992,9.9305525,1.8,15.5888572,9.9497976,-1.5510595,4.2730774,5.7762148,177.6351698,276.7569006,6.5431009,47.9131941,41.5707821,77.81629,7.8461137,10.298602,1.3818426,30.3145652),(42713,'humerus.tif',229,2,83,37.8323382,15.6529649,10.1845757,1.8,15.6494334,10.2141958,1.5569636,4.27306,5.9032507,168.7894277,286.0607104,6.3041833,48.4581672,39.500833,76.7225649,7.8370598,10.5037761,1.4283567,31.3013221),(42714,'humerus.tif',229,2,84,38.5842502,15.6277986,10.3948505,1.8,15.6379615,10.4265501,1.5338905,4.1769947,6.0361901,165.564239,294.612325,6.4219535,48.8076616,39.6371672,75.7668714,7.8329602,10.7122983,1.4539074,30.9259796),(42715,'humerus.tif',229,2,85,40.0649829,15.5896171,10.4370731,1.8,15.5979264,10.5335009,1.4901926,4.0738361,6.3389219,166.8459932,311.6726245,6.6342076,49.168081,40.9554997,75.3508699,7.8109463,10.9320764,1.4414117,31.6611581),(42716,'humerus.tif',229,2,86,38.0137036,15.6228275,10.6536002,1.8,15.6254362,10.7881527,1.4718853,4.0204792,6.5192109,162.8577704,314.9956671,6.2738354,48.3180667,40.5070546,73.2832918,7.7598723,11.2121672,1.4772077,31.376194),(42717,'humerus.tif',229,2,87,36.190793,15.6478302,10.8339614,1.8,15.6446193,11.0085155,1.4649796,3.9865275,7.0022448,157.9687358,316.2955575,5.9645113,45.170594,39.6256481,67.7153353,7.7948256,11.7814626,1.4748717,32.5339293),(42718,'humerus.tif',229,2,88,35.5157708,15.6809782,11.0342916,1.8,15.6794962,11.2473079,1.4607052,3.9670662,7.2305526,153.8969702,336.0470726,5.8478422,46.4759874,38.7936485,67.6952174,7.7502712,12.1224655,1.497594,35.6790071),(42719,'humerus.tif',229,2,89,35.7350103,15.7300697,11.136898,1.8,15.7403677,11.3264478,1.4768082,4.0331043,7.376256,152.1387979,354.1426972,5.9033774,48.011172,37.7225056,68.6157119,7.7227012,12.2629268,1.4786488,36.9230705),(42720,'humerus.tif',229,2,90,36.2008078,15.774764,11.2266733,1.8,15.7858468,11.4163047,1.4912053,4.0717328,7.5132885,152.4596696,368.1811063,5.9953281,49.0039888,37.4434367,69.2432321,7.7140782,12.3909234,1.4730694,36.262764),(42721,'humerus.tif',229,2,91,35.8255061,15.7680203,11.3635295,1.8,15.7806395,11.5771748,1.4895684,4.0508171,7.5310693,153.6957093,378.1574983,5.9316082,50.212989,37.9419026,70.530895,7.7033101,12.4711413,1.4737,36.6006705),(42722,'humerus.tif',229,2,92,35.0897546,15.7454672,11.5734055,1.8,15.7669536,11.7784798,1.4830365,3.9825013,7.4677777,152.7459018,382.5765466,5.8033657,51.230307,38.3542632,71.4717687,7.6978736,12.5465108,1.4484334,36.4199136),(42723,'humerus.tif',229,2,93,34.1604546,15.737866,11.7284414,1.8,15.7526584,11.9142944,1.4863741,3.9603394,7.4492172,151.0300462,374.3679011,5.6529279,50.2560058,38.135632,70.0721446,7.6809009,12.6126128,1.4329661,35.7636575),(42724,'humerus.tif',229,2,94,34.4165654,15.7567825,11.9208301,1.8,15.7612042,12.1156106,1.5136606,4.0243962,7.3593461,150.5297445,390.5834209,5.7173892,53.0731148,37.404305,73.1095802,7.6848895,12.6345485,1.4009282,36.3612431),(42725,'humerus.tif',229,2,95,33.6048434,15.7746337,12.0201178,1.8,15.7836063,12.2426595,1.5288857,4.0428112,7.3871235,150.1239316,382.4116117,5.5909751,51.7673236,37.1335499,71.5992355,7.7229623,12.6742703,1.4014658,35.6594503),(42726,'humerus.tif',229,2,96,33.1933638,15.7753851,12.1732915,1.8,15.7689653,12.3770914,1.5410775,4.0669072,7.3173568,150.9980388,379.1108791,5.5273426,51.8098119,37.1284695,72.0423587,7.6846001,12.6357696,1.4203293,35.6594503),(42727,'humerus.tif',229,2,97,32.9936973,15.7772192,12.2601012,1.8,15.7681819,12.4655372,1.5507446,4.0874924,7.2335472,152.2212778,373.4600236,5.4967388,51.6288916,37.2407487,72.1339722,7.7391455,12.5901229,1.3382394,35.9346359),(42728,'humerus.tif',229,2,98,32.8065994,15.7659955,12.3851448,1.8,15.7573293,12.5949312,1.5474432,4.0670508,7.1047367,153.0261079,367.2043731,5.4647852,51.6844452,37.6258163,72.5443394,7.7410804,12.5235131,1.3468918,35.7832143),(42729,'humerus.tif',229,2,99,32.4599042,15.7426969,12.4803711,1.8,15.7463714,12.7021006,1.5384737,4.0213322,7.0020965,153.5543241,364.3947863,5.4043339,52.0408116,38.1849388,73.1696415,7.7790308,12.4540045,1.3422997,35.8442575),(42730,'humerus.tif',229,2,100,32.8413039,15.7363777,12.5698808,1.8,15.7483306,12.8172203,1.5432333,3.9924091,6.8740964,155.0330857,366.4750719,5.4693932,53.3124723,38.8319635,74.8729135,7.8080023,12.3663888,1.3439975,35.022751),(42731,'humerus.tif',229,2,101,32.5730508,15.7613121,12.6559281,1.8,15.76096,12.8915975,1.5601973,4.0527079,6.7172737,155.9776262,365.0316836,5.4282318,54.3422373,38.4872608,76.4343486,7.822694,12.2401261,1.3042555,35.5886287),(42732,'humerus.tif',229,2,102,32.5788448,15.7716037,12.6536808,1.8,15.7681009,12.8906912,-1.563331,4.1037402,6.7401663,157.7666244,363.0569832,5.4295049,53.8646924,38.4445939,75.9687944,7.8753334,12.2227984,1.2970256,35.6024575),(42733,'humerus.tif',229,2,103,32.4585536,15.7736103,12.6919266,1.8,15.763197,12.9515037,-1.5429827,4.1533233,6.6880601,159.4968126,361.1355001,5.405575,53.9970478,38.4022145,76.6195213,7.8953852,12.1343163,1.2984273,35.5275855),(42734,'humerus.tif',229,2,104,33.4391116,15.7653312,12.7488112,1.8,15.7354153,13.007762,-1.5305996,4.1743884,6.614477,164.226645,375.4069423,5.5641851,56.7553473,39.3414867,80.2532557,7.9321593,12.0626999,1.2828595,34.6743711),(42735,'humerus.tif',229,2,105,33.2132105,15.7747455,12.7422884,1.8,15.7414467,13.0043721,-1.5254263,4.2191816,6.6542464,168.5515139,368.4548636,5.5241483,55.3713889,39.9488643,79.6539791,7.9841119,12.0087242,1.274518,35.0342071),(42736,'humerus.tif',229,2,106,32.9093551,15.7379056,12.8960326,1.8,15.6779547,13.1275449,-1.5167955,4.2092283,6.5180036,173.4620099,360.0764615,5.4689136,55.2433668,41.2099318,80.6706191,8.0482497,11.9800185,1.2596837,34.7451927),(42737,'humerus.tif',229,2,107,32.2211341,15.6994018,13.0341859,1.8,15.6268067,13.2733954,-1.5060784,4.2288979,6.3997196,176.2555637,346.0031251,5.3477278,54.0653571,41.6788408,80.2470056,8.1148989,11.9584439,1.2767572,34.3283639),(42738,'humerus.tif',229,2,108,32.1037394,15.6803584,13.1166935,1.8,15.6012681,13.3394528,-1.4905548,4.2737623,6.3367737,179.2615168,340.0553695,5.316246,53.6638018,41.9446623,80.675573,8.1977908,11.9411155,1.2479785,34.4227927),(42739,'humerus.tif',229,2,109,32.0997792,15.6713988,13.1848428,1.8,15.615805,13.4251331,-1.4723064,4.3445986,6.3075882,181.7051907,341.9154442,5.2982347,54.2070014,41.8232399,82.2121998,8.324733,11.892598,1.2286842,34.7883567),(42740,'humerus.tif',229,2,110,31.8257525,15.6651086,13.2074027,1.8,15.6146712,13.4377132,-1.4519744,4.4056245,6.2878223,184.7911034,338.1963836,5.2297544,53.7859319,41.9443604,82.3324113,8.3705163,11.8546411,1.2275437,34.9650632),(42741,'humerus.tif',229,2,111,32.2642437,15.6387517,13.2417049,1.8,15.5789867,13.4690367,-1.438556,4.4365158,6.2618772,188.590392,347.6430096,5.2838839,55.5173791,42.5086711,84.8917281,8.4406543,11.8277586,1.2339607,34.5010201),(42742,'humerus.tif',229,2,112,32.3128608,15.6331472,13.1889146,1.8,15.5727658,13.4124796,-1.4490764,4.4242201,6.3146661,193.663321,341.6311176,5.3060802,54.1012169,43.7734373,83.8663368,8.5064894,11.7883531,1.2544511,34.6052273),(42743,'humerus.tif',229,2,113,32.1890849,15.6227053,13.3202134,1.8,15.5241297,13.5274503,-1.4383462,4.5004245,6.1767818,198.5002471,334.1885186,5.2712809,54.1039862,44.1070057,85.5645878,8.5802815,11.7029705,1.2229079,34.9903481),(42744,'humerus.tif',229,2,114,32.1439975,15.6204209,13.4623045,1.8,15.4952165,13.6629775,-1.4174289,4.5596164,6.0351198,201.832232,328.5494651,5.2323049,54.4395926,44.2651785,86.9828298,8.6329142,11.6513709,1.2249804,34.5677913),(42745,'humerus.tif',229,2,115,31.9467796,15.639171,13.5237916,1.8,15.5248103,13.711343,-1.40997,4.6210337,5.9434808,205.5719204,321.0168256,5.1879286,54.0115858,44.4861327,87.8188847,8.6887513,11.5348854,1.2324727,34.2689985),(42746,'humerus.tif',229,2,116,31.6500571,15.6233515,13.5866466,1.8,15.5149964,13.7990655,-1.3831472,4.6461169,5.8488261,207.3699492,318.4475442,5.0914348,54.4464031,44.6329602,89.0381064,8.7411778,11.4620033,1.2190214,35.332305),(42747,'humerus.tif',229,2,117,32.0196665,15.6240954,13.5941188,1.8,15.5280948,13.7848531,-1.382313,4.6580948,5.8573963,209.8153985,323.4888837,5.1492573,55.2274198,45.0431789,89.8916866,8.7793952,11.4578226,1.2000872,34.8055409),(42748,'humerus.tif',229,2,118,31.6878216,15.5975197,13.6112654,1.8,15.5026332,13.8461344,-1.3366139,4.6681792,5.8575139,212.7367697,316.7519311,4.9969255,54.0761722,45.57168,89.6378245,8.8403726,11.4123741,1.1909457,34.4008632),(42749,'humerus.tif',229,2,119,31.5551936,15.5862679,13.6084171,1.8,15.5036186,13.8296115,-1.3025112,4.6460711,5.8394628,214.6153252,314.8386,4.8896535,53.915679,46.1928627,90.2270522,8.8827071,11.3305373,1.1995367,33.5989135),(42750,'humerus.tif',229,2,120,31.053533,15.5681752,13.5616194,1.8,15.4790806,13.7974966,-1.3002604,4.6404175,5.8570519,218.9875365,309.7401631,4.8059407,52.8832884,47.1913437,89.6544366,8.9277605,11.2851517,1.1902899,33.3904992),(42751,'humerus.tif',229,2,121,30.0043299,15.5809505,13.6507372,1.8,15.4897731,13.8670457,-1.2539809,4.6685195,5.751087,219.1665961,297.9913026,4.5153595,51.8147789,46.9456311,89.6719261,8.9898575,11.1976003,1.2103407,32.9052214),(42752,'humerus.tif',229,2,122,29.4461554,15.5819582,13.6882426,1.8,15.5017159,13.9086594,-1.2072883,4.7159634,5.7355644,222.4268681,286.9581175,4.2872645,50.0313655,47.164672,88.6873361,9.0352816,11.1657188,1.1976625,32.9247783),(42753,'humerus.tif',229,2,123,29.5976448,15.5801165,13.7403102,1.8,15.4961284,13.9302183,-1.1814819,4.7358128,5.6926234,228.4642192,284.5087995,4.2222943,49.9785034,48.241818,90.0699346,9.0695331,11.143005,1.1929763,32.9581639),(42754,'humerus.tif',229,2,124,29.5087835,15.5641367,13.7433289,1.8,15.474086,13.9366189,-1.1644618,4.8491918,5.6697389,231.4782066,280.6308788,4.1498272,49.4962613,47.7354199,90.3222466,9.0816301,11.0938518,1.2145767,33.1763567),(42755,'humerus.tif',229,2,125,29.0359051,15.5744812,13.7616091,1.8,15.500471,13.9494543,-1.1677168,4.944774,5.6726734,230.3093367,276.3637163,4.0947287,48.7184259,46.5763118,89.3047366,9.0624609,11.0907039,1.1950133,33.1527495),(42756,'humerus.tif',229,2,126,28.8748732,15.6085833,13.7844545,1.8,15.557122,13.9632177,-1.1868219,5.0007271,5.6390796,230.3291091,278.4215086,4.1371367,49.373573,46.0591237,90.0917147,9.0265842,11.0458032,1.1855474,33.3904992),(42757,'humerus.tif',229,2,127,27.6531208,15.6155782,13.6845065,1.8,15.5807209,13.8539785,-1.0749558,5.0367052,5.5483775,226.5806249,264.4814203,3.5656017,47.6682453,44.985882,88.2519967,9.0076615,10.862925,1.2185388,33.1723063),(42758,'humerus.tif',229,2,128,27.3929139,15.6060239,13.7162498,1.8,15.595742,13.8852209,-0.9731249,4.95799,5.4159485,227.1239624,261.6778936,3.1198118,48.3161714,45.8096852,88.3303051,8.9720787,10.8454933,1.2572712,33.37262),(42759,'humerus.tif',229,2,129,27.3351732,15.6082912,13.6954627,1.8,15.5799785,13.8574598,-0.8670438,4.8630144,5.304602,231.104704,261.2226986,2.6482465,49.2445429,47.5229322,88.4944335,8.9418759,10.8353806,1.2255207,33.2448056),(42760,'humerus.tif',229,2,130,27.4043238,15.5933265,13.6994941,1.8,15.5767625,13.8657341,-0.9276276,4.9691838,5.3929051,230.6961698,263.558168,2.9245852,48.871279,46.425365,88.7494068,8.9313672,10.8391272,1.2137663,33.3685697),(42761,'humerus.tif',229,2,131,27.8553017,15.6081885,13.7208689,1.8,15.6070921,13.8876185,-0.9227551,4.921237,5.4194048,230.7094373,264.7162097,2.9509712,48.845993,46.8803755,88.8311181,8.8899877,10.8597848,1.2302686,33.3685697),(42762,'humerus.tif',229,2,132,27.1552381,15.5961747,13.698814,1.8,15.5886472,13.8464665,-0.9100986,4.9331164,5.4461984,223.5202515,263.4762909,2.8214822,48.3780196,45.3101514,87.0177126,8.8624815,10.8463918,1.2337708,33.3351841),(42763,'humerus.tif',229,2,133,26.6738682,15.6026668,13.7457697,1.8,15.6161671,13.9076523,-0.8655852,4.9398017,5.3173811,222.939357,258.1905463,2.5777795,48.5559604,45.1312361,86.5927925,8.8522579,10.8472902,1.2690196,33.2448056),(42764,'humerus.tif',229,2,134,26.1224775,15.6458068,13.7554098,1.8,15.6758912,13.9308926,-0.8062294,4.9375498,5.2505303,219.9430401,254.4157508,2.2675408,48.4552482,44.544977,84.9873874,8.8434822,10.8463918,1.2337708,33.2309769),(42765,'humerus.tif',229,2,135,25.7123408,15.5485377,13.7463675,1.8,15.5849584,13.892965,-0.8362217,4.9001209,5.273099,213.5803799,255.5445532,2.3601188,48.4619296,43.5867574,84.3549306,8.8250981,10.8353806,1.2255207,33.4825553),(42766,'humerus.tif',229,2,136,26.4460597,15.546927,13.7372542,1.8,15.5888138,13.8283295,-0.8547173,4.9005199,5.3325421,213.3517181,264.3929603,2.5083969,49.5810357,43.5365475,85.6625677,8.8188726,10.8463918,1.2337708,33.4785049),(42767,'humerus.tif',229,2,137,25.5121135,15.5342441,13.7842633,1.8,15.5384608,13.9177311,-0.8275077,4.9206787,5.2723824,210.1374397,261.0435725,2.3048485,49.5115019,42.7049705,84.8727952,8.8328549,10.862925,1.2185388,33.5354977),(42768,'humerus.tif',229,2,138,25.5068463,15.4420102,13.8244201,1.8,15.4266337,13.9299242,-0.8418937,4.891247,5.2105635,209.9888979,263.7258623,2.3652303,50.6136928,42.9315668,86.1038824,8.8511004,10.8892065,1.2818209,33.3270833),(42769,'humerus.tif',229,2,139,25.2513006,15.4114947,13.7721974,1.8,15.3659902,13.8847662,-0.8129775,4.8403983,5.229277,211.7676364,263.4862828,2.2202854,50.3867522,43.7500434,85.3436502,8.8681791,10.9357898,1.2327302,33.682869),(42770,'humerus.tif',229,2,140,25.1140624,15.4163156,13.777162,1.8,15.3880998,13.8664809,-0.7927904,4.8622269,5.2475066,212.6046722,264.5403862,2.1237791,50.4125872,43.7257817,85.3798976,8.8985299,10.9627856,1.2257941,33.6356546),(42771,'humerus.tif',229,2,141,25.1602735,15.4024244,13.7879388,1.8,15.3766104,13.863815,-0.8530634,4.9270142,5.3557753,210.2144824,265.2574963,2.3795702,49.5273755,42.6656945,84.8578297,8.9198089,11.0007193,1.2270331,33.8400186),(42772,'humerus.tif',229,2,142,24.6635257,15.3199103,13.7676888,1.8,15.2659014,13.8656206,-0.7965143,4.8492917,5.2499023,209.9284548,267.4386858,2.1009839,50.94165,43.2905397,85.1486991,8.9644139,11.0325624,1.2086054,34.0207755),(42773,'humerus.tif',229,2,143,24.8231872,15.2338808,13.7695208,1.8,15.1534232,13.8499998,-0.8481874,4.8678478,5.3273439,212.1019655,272.8832774,2.3276881,51.223139,43.5720204,86.4837462,9.0031546,11.1038754,1.2226455,34.1819755),(42774,'humerus.tif',229,2,144,24.8142091,15.2140731,13.7514866,1.8,15.1387991,13.8454123,-0.8557272,4.8959321,5.3773647,217.0885449,274.9694439,2.3577524,51.1346096,44.3405955,87.1643471,9.0371451,11.1881688,1.1829322,34.4295035),(42775,'humerus.tif',229,2,145,24.7730129,15.1795147,13.7199934,1.8,15.1085181,13.8234353,-0.881939,4.9033929,5.4765107,216.9970755,281.6401629,2.460547,51.4269354,44.2544741,87.2553435,9.0857869,11.2716157,1.174355,34.724246),(42776,'humerus.tif',229,2,146,25.0385006,15.1394203,13.7425555,1.8,15.0408128,13.8344452,-0.8688902,4.9337871,5.7281103,219.5311057,286.7478514,2.4333441,50.0597641,44.4954557,85.1692595,9.1385922,11.5678555,1.1585854,35.1606316),(42777,'humerus.tif',229,2,147,25.6323774,15.0477653,13.7250487,1.8,14.9222916,13.7983936,-0.8649991,4.9034949,5.7893825,223.2978765,296.1026297,2.4746572,51.1458056,45.5385149,86.0868453,9.2114286,11.7056069,1.1749459,36.888295),(42778,'humerus.tif',229,2,148,25.8128362,15.0264448,13.7244149,1.8,14.89621,13.7482106,-0.8986637,4.984073,5.9303479,227.9733446,301.7753464,2.6341968,50.8866176,45.7403704,86.6878689,9.2899814,11.8427161,1.1650109,36.6603238),(42779,'humerus.tif',229,2,149,25.9033963,15.0097571,13.7335341,1.8,14.9046959,13.7661059,-0.9423834,5.1301147,6.0181561,231.1420053,311.191194,2.8252778,51.7087278,45.0559141,88.051215,9.3768605,12.0065601,1.2320623,36.9550662),(42780,'humerus.tif',229,2,150,26.3026079,14.9707378,13.6586257,1.8,14.8685759,13.6876053,-0.9391268,5.1549764,6.0926781,238.42313,323.3576786,2.8552273,53.0731602,46.2510617,89.5403884,9.4679252,12.1506342,1.2186249,37.4582231),(42781,'humerus.tif',229,2,151,26.2817519,14.8732252,13.6288211,1.8,14.7853225,13.6713265,-0.9883775,5.3082809,6.1724665,239.4598822,331.5872897,3.0550341,53.7203868,45.1106274,90.4174617,9.5656511,12.2883949,1.2262282,37.4956591),(42782,'humerus.tif',229,2,152,26.5175488,14.8029449,13.6434731,1.8,14.7089706,13.6375566,-0.9662779,5.3451704,6.1460345,247.2948033,335.9672392,2.9918873,54.6640663,46.2650922,91.9494042,9.6808332,12.4294638,1.2234104,37.9654303),(42783,'humerus.tif',229,2,153,27.0265703,14.6914288,13.6175037,1.8,14.6197955,13.655507,-0.9330039,5.3223291,6.0872339,258.8527329,344.4732681,2.9074782,56.5894581,48.6352365,94.713684,9.795507,12.546705,1.2165369,39.4317368),(42784,'humerus.tif',229,2,154,27.2239036,14.6245282,13.6424334,1.8,14.5231249,13.673827,-0.8971584,5.368233,6.081344,263.6293184,354.0383371,2.7715383,58.2171202,49.1091425,96.8689012,9.9167033,12.6570878,1.2299142,39.132944),(42785,'humerus.tif',229,2,155,27.6213089,14.5934136,13.6689288,1.8,14.4932943,13.7318698,-0.8317231,5.378102,6.0756918,277.8420133,355.3580752,2.5147302,58.4884956,51.6617229,97.9300583,10.0278266,12.7258701,1.2149908,39.616544),(42786,'humerus.tif',229,2,156,28.2969105,14.4650328,13.6518017,1.8,14.3939399,13.7222039,-0.8387806,5.4783694,6.20821,293.1680465,366.5229384,2.6093577,59.0384247,53.5137422,101.5655913,10.1690169,12.768488,1.2061151,39.8347369),(42787,'humerus.tif',229,2,157,29.3905448,14.37945,13.6064972,1.8,14.3010661,13.6882489,-0.7506441,5.4118113,6.1603262,310.9703487,382.8177306,2.279109,62.1424443,57.4614174,105.555741,10.2964173,12.8116613,1.2241753,40.1888448),(42788,'humerus.tif',229,2,158,30.102964,14.3227341,13.5148586,1.8,14.2690579,13.597447,-0.6612446,5.3944982,6.0263087,328.2800072,388.9305653,1.8920631,64.5387719,60.8545962,107.1358986,10.4301064,12.8958115,1.2065392,41.3742376),(42789,'humerus.tif',229,2,159,31.2952652,14.2222582,13.4547133,1.8,14.2336623,13.5305751,-0.5476097,5.5143719,6.0487111,348.7542204,417.8465559,1.4138903,69.0802628,63.2445958,112.3417482,10.561771,12.9806048,1.2156594,42.4375441),(42790,'humerus.tif',229,2,160,32.1307605,14.0915469,13.4128601,1.8,14.1217353,13.4772478,-0.53229,5.6685867,6.2042742,380.0795356,444.3288408,1.379289,71.6165709,67.0501407,120.3261181,10.6794921,13.1180683,1.2228127,43.3730363),(42791,'humerus.tif',229,2,161,33.3409128,13.9711256,13.261113,1.8,14.021044,13.3363583,-0.5522478,5.8977526,6.2781379,410.2795564,481.9893318,1.5292782,76.7726572,69.565406,130.3393759,10.8888775,13.3431959,1.3111667,43.9429643),(42792,'humerus.tif',229,2,162,35.1642164,13.9281518,13.1194715,1.8,13.9690707,13.1559718,-0.6892798,6.1802903,6.4258861,448.0687442,520.4465263,2.3704933,80.992181,72.4996276,139.8894619,11.316949,13.7444275,1.3670754,45.0494349),(42793,'humerus.tif',229,2,163,37.0554963,13.8570644,12.8908672,1.8,13.9371446,12.8851737,-0.8351458,6.5610233,6.7820867,501.6452118,558.463316,3.3946883,82.3438777,76.4583804,140.4338694,11.9724418,14.4240793,1.4672356,47.7655329),(42794,'humerus.tif',229,2,164,39.2081245,13.7895443,12.7022455,1.8,13.9704519,12.6635254,-0.9487249,6.8800255,7.6623359,551.590361,616.6384079,4.3157536,80.4765565,80.1727209,145.0608896,12.3757718,15.2860832,1.419951,56.1050569),(42795,'humerus.tif',229,2,165,41.7357872,13.7584939,12.4782971,1.8,13.9434601,12.4547182,-1.1655691,7.1772793,8.2134906,608.9394129,697.4311489,5.8749003,84.9128804,84.8426529,157.0267781,12.7075226,15.4277964,1.3682779,60.1114499),(42796,'humerus.tif',229,2,166,45.1233339,13.7252288,12.197761,1.8,13.9325102,12.2254853,-1.3171816,7.4172724,8.3599813,695.5112965,813.527985,7.0471127,97.3121778,93.7691462,180.4646693,13.3211407,16.032159,1.4320987,64.5403996),(42797,'humerus.tif',229,2,167,49.7392326,13.8169023,11.9509776,1.8,14.0038694,12.0127365,-1.3973925,7.5201107,8.2580874,796.7110285,963.0675822,8.0430933,116.6211424,105.9440558,211.8295846,13.7012132,16.2030564,1.4285475,57.5288944),(42798,'humerus.tif',229,2,168,52.7902888,13.9362156,11.7126834,1.8,14.0875975,11.8229218,-1.3687463,7.9869832,8.1782096,866.7101159,1093.8725713,8.4440556,133.7545283,108.5153301,237.9335484,14.0090138,16.3683504,1.4275065,61.5028845),(42799,'humerus.tif',229,2,169,57.0669172,13.9896296,11.5416711,1.8,14.1038607,11.6968423,-1.3642629,8.2835439,8.2991682,975.4482622,1208.9256065,9.1111804,145.668286,117.7573608,257.7713559,14.3261818,16.4937818,1.4261349,57.2479807),(42800,'humerus.tif',229,2,170,60.4258811,14.0095269,11.4375222,1.8,14.1221733,11.5967514,-1.323799,8.3264583,8.3495851,1083.5324312,1300.9011707,9.4689666,155.8042895,130.1312501,276.7034184,14.5331661,16.5765815,1.4096444,57.8398382),(42801,'humerus.tif',229,2,171,63.9948666,14.0527189,11.4107905,1.8,14.0773136,11.5430773,-1.3193781,8.3697881,8.3651004,1157.2347745,1362.0384962,10.0056997,162.8239265,138.2633293,287.9673551,14.6629043,16.610104,1.3976702,57.531267),(42802,'humerus.tif',229,2,172,65.2771242,14.1497929,11.3746837,1.8,14.1635148,11.5042315,-1.3787326,8.624691,8.4159501,1201.4152783,1400.9873919,10.4831025,166.4681205,139.299516,292.7209826,14.8071216,16.6065836,1.3605505,61.1454211),(42803,'humerus.tif',229,2,173,67.7097997,14.13859,11.3161015,1.8,14.1705261,11.4725038,-1.4499792,8.7257224,8.4174633,1222.2911434,1450.8030994,11.1210424,172.3563329,140.0790772,300.6986758,14.8973324,16.6263759,1.3334601,61.5190859),(42804,'humerus.tif',229,2,174,69.2194747,14.0765905,11.2775626,1.8,14.1177014,11.4427926,-1.393703,8.5662709,8.427634,1227.820942,1474.447432,11.178535,174.9538996,143.3320239,305.8689741,14.9810776,16.580549,1.3051838,63.7337047),(42805,'humerus.tif',229,2,175,70.0664025,14.0162208,11.2360133,1.8,14.0745038,11.416496,-1.3024416,8.2758511,8.3848628,1248.5510313,1473.5723367,10.8567648,175.7419741,150.8667827,310.8982331,14.9508416,16.5187242,2.8901052,62.6386903),(42806,'humerus.tif',229,2,176,72.3796145,14.0450103,11.2348431,1.8,14.0928678,11.4244504,-1.2539816,8.3827768,8.3642436,1269.9005531,1495.9642439,10.8924321,178.8523036,151.489248,317.1553771,14.8668514,16.3914527,2.9007881,62.3537262),(42807,'humerus.tif',229,2,177,73.548073,14.0669485,11.2495874,1.8,14.1595904,11.4432871,-1.3034139,8.2137797,8.3296291,1218.3215798,1479.0669321,11.4023321,177.5669616,148.3265469,310.2433895,14.689828,16.2137278,1.2286084,60.7579276),(42808,'humerus.tif',229,2,178,73.7806888,14.1839982,11.2306565,1.8,14.2329961,11.4099077,-1.2947102,8.0531957,8.2870645,1134.1064968,1427.9595168,11.3830514,172.3118613,140.8268885,300.0087054,14.4730236,15.9759392,1.2179305,56.3084382),(42809,'humerus.tif',229,2,179,73.9490516,14.2602248,11.3287216,1.8,14.3063171,11.5063148,-1.3507687,7.6499394,8.1383941,1053.9281522,1359.6182105,11.7377366,167.0622234,137.7694775,291.1505611,14.2022739,15.7399754,1.2369006,56.4322022),(42810,'humerus.tif',229,2,180,71.6316212,14.3931687,11.4227605,1.8,14.3952066,11.5656012,-1.466472,7.2782893,7.8122682,965.5802185,1246.2689132,11.8091397,159.527154,132.6658202,273.9382359,13.8353507,15.2703506,1.2290151,60.5657146),(42811,'humerus.tif',229,2,181,68.655743,14.4837889,11.5015997,1.8,14.5216816,11.6126189,-1.5504666,7.2526782,7.4611292,872.3656157,1108.4204703,11.4378951,148.5593458,120.2818591,251.2834712,13.4038398,14.7612474,1.2714945,56.0096454),(42812,'humerus.tif',229,2,182,64.3745202,14.6058416,11.5642356,1.8,14.6712772,11.6212608,1.41666,7.5051429,6.8973271,761.8150074,941.3832772,10.4761973,136.4852309,101.5057297,221.1291458,12.7541187,14.0607161,1.2980084,54.4455546),(42813,'humerus.tif',229,2,183,57.2647664,14.7631111,11.534538,1.8,14.8384404,11.5717337,1.2385334,7.5073333,6.4574992,595.0264846,727.0823011,8.5286768,112.5950282,79.2593674,175.9266317,11.9780853,13.1371205,2.9062863,55.8848986),(42814,'humerus.tif',229,2,184,41.1425857,15.5041118,11.0771439,1.8,15.4965083,11.2507876,1.1128951,7.6201891,6.0708582,263.7285193,447.1932668,5.5170644,73.662282,34.609183,92.7704146,8.0088402,11.5717859,1.6929915,41.1999038),(42815,'humerus.tif',229,2,185,24.2862162,15.9108373,10.1836298,1.8,15.8866388,10.2980039,1.1003696,2.8323254,6.3277121,45.5792352,202.6421033,3.2160994,32.0245453,16.0925136,38.9276078,5.453169,6.1050179,2.8052294,19.1149274),(42816,'humerus.tif',229,2,186,10.2675015,15.4418125,9.1628568,1.8,15.4381287,9.1677595,0.4174082,1.8030253,2.0951929,7.4442616,9.7140817,0.2812322,4.6363663,4.1287616,8.0875519,3.6270001,4.1462023,2.8659632,12.7465444),(42817,'humerus.tif',229,2,187,0.7067742,15.538313,9.6852721,1.8,15.5436958,9.6720003,-0.6080486,1.4364513,1.5567136,0.1791987,0.3098567,0.0384421,0.1990454,0.124751,0.2982408,1.8803861,2.5083311,2.7282622,9.5461515),(42818,'humerus.tif',229,2,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42819,'humerus.tif',229,2,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42820,'humerus.tif',229,2,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42821,'humerus.tif',229,2,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42822,'humerus.tif',229,2,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42823,'humerus.tif',229,2,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42824,'humerus.tif',229,2,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42825,'humerus.tif',229,2,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42826,'humerus.tif',229,2,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42827,'radius.tif',229,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42828,'radius.tif',229,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42829,'radius.tif',229,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42830,'radius.tif',229,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42831,'radius.tif',229,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42832,'radius.tif',229,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42833,'radius.tif',229,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42834,'radius.tif',229,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42835,'radius.tif',229,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42836,'radius.tif',229,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42837,'radius.tif',229,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42838,'radius.tif',229,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42839,'radius.tif',229,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42840,'radius.tif',229,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42841,'radius.tif',229,3,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42842,'radius.tif',229,3,16,1.0388363,6.4156169,7.7503304,1.8,6.4192928,7.7745191,-0.87439,0.412215,1.466413,0.0311831,0.4824869,0.1018965,0.3290253,0.0756476,0.3414832,0.8686449,2.8764124,0.8709035,6.5259483),(42843,'radius.tif',229,3,17,5.7706178,7.0829724,7.9853876,1.8,7.1329304,8.0193355,-0.7326606,1.5964038,2.6337912,2.0517346,11.9610903,0.4302575,4.5413965,1.2852228,4.7331472,2.7719456,5.3271147,0.6543702,14.9163352),(42844,'radius.tif',229,3,18,20.5196659,8.7529668,9.5822233,1.8,8.7547006,9.5496111,0.8603895,3.1294666,3.4950014,60.359182,70.5457753,1.965478,20.1847632,19.2873706,37.4226106,6.3006082,7.0538266,2.2981203,21.8095516),(42845,'radius.tif',229,3,19,21.5833108,8.7970726,9.6480263,1.8,8.8248183,9.5662103,-1.3510043,3.4185363,3.4335947,59.4057884,60.252795,3.4262224,17.5480217,17.3775508,33.4482156,6.4687543,7.0278772,2.4436898,22.0552005),(42846,'radius.tif',229,3,20,16.1161519,8.8308251,9.5223243,1.8,8.8403752,9.4697849,0.2211883,3.3028954,3.4063633,49.7544552,51.4070115,0.1292827,15.0914646,15.0638908,29.068371,6.3459299,6.8226251,2.6171834,21.5580835),(42847,'radius.tif',229,3,21,12.5889488,8.7851361,9.5324329,1.8,8.7772051,9.4734826,1.1419814,3.119859,3.342971,36.6674061,40.0371148,1.73542,11.9765069,11.7529049,22.783245,5.9774565,6.583309,2.2565258,20.6515516),(42848,'radius.tif',229,3,22,11.3947655,8.8174971,9.583124,1.8,8.8060013,9.4961392,1.0211902,2.9217417,3.2124693,29.3578413,34.8601461,1.3809487,10.8515109,10.0480617,19.9545023,5.577631,6.3566185,2.2981951,19.5870731),(42849,'radius.tif',229,3,23,11.2807553,8.9068334,9.5132975,1.8,8.9232447,9.4730151,1.1499781,2.8437263,2.9997705,28.0058307,33.4475577,1.5663737,11.1500389,9.8482863,19.9187868,5.3964695,6.1855522,2.323094,19.0419901),(42850,'radius.tif',229,3,24,11.0582353,8.952979,9.5621919,1.8,8.9591577,9.5107144,1.1097331,2.8202499,2.9788831,26.6931294,33.0673336,1.4782345,11.100581,9.46481,19.5413729,5.3325881,6.1234554,2.2691665,18.7624242),(42851,'radius.tif',229,3,25,11.139339,9.042455,9.5611907,1.8,9.0609165,9.5191738,1.0787969,2.7908969,3.0270898,26.9694864,33.4461757,1.4422632,11.0489539,9.6633761,19.615584,5.3499834,6.086389,2.2618805,18.6664923),(42852,'radius.tif',229,3,26,10.9770527,9.0747205,9.6320286,1.8,9.0999501,9.5966916,1.0812388,2.9524772,3.0371169,27.4097856,33.6185778,1.4249652,11.0692408,9.2836571,19.3290732,5.4426001,6.1070092,2.3092491,18.8021604),(42853,'radius.tif',229,3,27,11.0993323,9.139636,9.6619811,1.8,9.2113318,9.6309604,1.0096539,3.1756727,3.0990207,30.3338341,33.0052433,1.3260231,10.6502171,9.5519396,19.8471552,5.5974456,6.0731553,2.2887295,19.0676775),(42854,'radius.tif',229,3,28,11.4512317,9.3613277,9.7424146,1.8,9.5092811,9.7053377,0.0293261,2.8414433,3.4803381,30.8807764,39.454671,0.0016409,11.3364476,10.8679895,19.5238339,5.5009333,6.3894953,0.2471765,19.784756),(42855,'radius.tif',229,3,29,11.6048911,9.6153393,9.7725976,1.8,9.8281349,9.7153957,-0.0843304,2.7824111,3.9044283,30.7377351,49.9485114,0.0137223,12.7927848,11.0471578,20.4067763,5.4426001,7.0087706,0.2249413,20.6912879),(42856,'radius.tif',229,3,30,12.3819505,9.9375082,9.7280604,1.8,10.1250958,9.6870137,-0.1488243,2.7317616,4.0264696,32.2324097,66.0768536,0.0453709,16.4106176,11.7991296,24.3969036,5.3847001,7.4531493,0.1638715,21.637556),(42857,'radius.tif',229,3,31,12.7922892,10.1305885,9.7378458,1.8,10.3020236,9.7194519,-0.1445415,2.6732405,3.9829666,33.0117392,75.4245902,0.044234,18.936787,12.3489595,27.1428158,5.3268001,7.6430194,0.2137388,22.3861412),(42858,'radius.tif',229,3,32,13.3823224,10.2365927,9.7924244,1.8,10.4106158,9.7804681,-0.133362,2.6564339,3.9764071,34.3814771,83.2100439,0.0394338,20.9259367,12.9427188,29.2835553,5.2939799,7.7788818,0.1418971,22.8212434),(42859,'radius.tif',229,3,33,13.745636,10.2146336,9.8764873,1.8,10.4055546,9.8654935,-0.128069,2.631392,4.0518139,34.8504511,87.7822353,0.0373702,21.6649226,13.2441121,29.7098057,5.2676208,7.9049936,0.0880074,23.2166094),(42860,'radius.tif',229,3,34,13.9844345,10.1853978,10.0067863,1.8,10.3726166,9.9949044,-0.1221894,2.6149346,4.1334067,34.4894671,90.828137,0.0346257,21.9741594,13.1894188,29.9019928,5.2213395,8.0203519,0.0867383,23.1826923),(42861,'radius.tif',229,3,35,14.3446262,10.1254707,10.0814147,1.8,10.3187831,10.0565766,-0.1407609,2.6165887,4.1512658,34.3388278,91.8937106,0.0470578,22.1363112,13.1235102,30.1827521,5.2233428,8.0437251,0.1154267,23.0189264),(42862,'radius.tif',229,3,36,15.0799413,10.0724881,10.1632689,1.8,10.21884,10.1156755,-0.1416681,2.6010099,4.141553,34.1346353,94.9491154,0.0501055,22.9259689,13.1236084,31.1603184,5.1531,8.0437251,0.1154267,22.8633901),(42863,'radius.tif',229,3,37,14.5383616,9.8951315,10.2833864,1.8,10.0410337,10.2260956,-0.1594561,2.6349256,4.1599442,32.0339081,86.7938143,0.0610889,20.8641773,12.157424,28.4321954,5.1531,7.9291297,0.1687501,22.264522),(42864,'radius.tif',229,3,38,14.059336,9.6308936,10.4191918,1.8,9.7644605,10.3676711,-0.128247,2.5892609,4.1129169,29.8409827,74.7325805,0.0383288,18.170214,11.5249036,24.8505731,5.1349257,7.7248236,0.2267988,21.5018879),(42865,'radius.tif',229,3,39,14.1415222,9.1070874,10.5887357,1.8,9.1685129,10.564201,0.0295097,2.5253673,3.5137878,28.351493,54.3100118,0.0020519,15.4562584,11.2266811,23.0081745,5.0288154,6.7009089,0.1125656,19.5391071),(42866,'radius.tif',229,3,40,14.017548,8.9263706,10.7295474,1.8,8.9566557,10.7247068,0.0616429,2.5423381,3.2396454,27.7954538,46.2661409,0.0088662,14.281236,10.9330282,22.8076475,5.0111637,6.2983385,3.0217986,18.6945901),(42867,'radius.tif',229,3,41,13.9240767,8.71373,10.8495444,1.8,8.7443958,10.8435483,0.1192062,2.5206475,3.1214402,26.9460572,41.1752811,0.0328212,13.1911164,10.690133,21.8235292,4.9634126,6.0443829,2.9780188,18.0337071),(42868,'radius.tif',229,3,42,13.7852229,8.4980868,10.9580155,1.8,8.5228554,10.9543841,0.1850165,2.5105608,3.0655223,26.4300238,37.0990196,0.077754,12.1020226,10.5275379,20.71992,4.9515461,5.8464667,3.0024967,17.6523901),(42869,'radius.tif',229,3,43,13.9837539,8.3448502,11.0536105,1.8,8.3718572,11.0528576,0.221576,2.5040125,2.9765943,26.5770282,34.3160749,0.1125639,11.528637,10.613776,20.4156176,4.9805979,5.6522976,3.028673,17.3728241),(42870,'radius.tif',229,3,44,14.252438,8.2297666,11.1554872,1.8,8.2523082,11.155966,0.2615844,2.4852357,2.8277008,26.8876888,32.2574594,0.1588668,11.4076636,10.8189695,20.7323993,4.9830696,5.4453712,2.9921769,17.1271752),(42871,'radius.tif',229,3,45,14.3366999,8.1184487,11.2555178,1.8,8.1379382,11.2573764,0.4081235,2.5161371,2.6539235,26.9337296,30.314879,0.3763858,11.4226649,10.7043965,20.6799844,4.9960491,5.3082018,2.2557584,16.9973263),(42872,'radius.tif',229,3,46,14.4150341,8.0095518,11.3498299,1.8,8.0258318,11.3562176,0.7860594,2.5101936,2.6057304,26.8547977,28.993068,1.2028416,11.1266567,10.6982973,21.0425245,4.9948609,5.2574348,2.2076896,16.7516774),(42873,'radius.tif',229,3,47,14.559184,7.9049676,11.4510902,1.8,7.9155465,11.4575682,1.2328347,2.5076547,2.612429,26.1658734,28.9266863,2.1597696,11.0727168,10.4344005,20.957489,4.9256293,5.2574348,1.7703517,16.7376285),(42874,'radius.tif',229,3,48,14.5061493,7.8017915,11.5387366,1.8,7.8122679,11.5476378,1.4017642,2.4826227,2.6226209,25.0097717,29.3340015,2.349269,11.1849949,10.0739317,20.654461,4.8057,5.2892213,1.658483,16.6218285),(42875,'radius.tif',229,3,49,14.4070724,7.7053518,11.6194193,1.8,7.7101363,11.6365694,1.464338,2.4030899,2.6455451,24.0248656,29.9542849,2.3740679,11.3225378,9.9974894,20.3981919,4.7466919,5.34,1.7341625,16.6416967),(42876,'radius.tif',229,3,50,14.6270876,7.6252995,11.7053442,1.8,7.6288441,11.7351551,1.5184729,2.3338343,2.7150163,23.0927647,30.9191496,2.4311798,11.3882004,9.8947746,19.8559007,4.6447307,5.453676,1.507053,16.7715456),(42877,'radius.tif',229,3,51,14.7539669,7.5416227,11.7947292,1.8,7.5479733,11.8285181,-1.5541044,2.2701917,2.8036568,22.1990976,32.4966081,2.4583094,11.5907939,9.7785126,19.2821026,4.5650362,5.6171953,1.4259838,16.7715456),(42878,'radius.tif',229,3,52,14.6798952,7.4514973,11.8936439,1.8,7.4499746,11.9356366,-1.5087354,2.20503,2.9543454,21.5196676,34.3375386,2.4372379,11.6227231,9.7593538,18.7962516,4.4004,5.8159967,1.4007377,16.8054626),(42879,'radius.tif',229,3,53,14.5133188,7.3523069,11.9883004,1.8,7.3465583,12.0503968,-1.4797358,2.1903681,3.1368935,20.9855619,36.5298319,2.3988844,11.6452255,9.5808381,18.3351341,4.4004,6.0443829,1.4072225,17.0990774),(42880,'radius.tif',229,3,54,14.4644131,7.2683389,12.047704,1.8,7.2563707,12.1252048,-1.4662665,2.1738297,3.2202279,20.641896,37.4568198,2.3844905,11.6317295,9.495636,18.0009305,4.3425,6.2115125,1.3642603,17.2148774),(42881,'radius.tif',229,3,55,14.5104329,7.1828249,12.1075457,1.8,7.1755789,12.1796637,-1.4510771,2.1585982,3.2477533,20.2784906,38.6948089,2.3839085,11.9143314,9.3942867,18.1502803,4.2846,6.2927472,1.3481354,17.2967604),(42882,'radius.tif',229,3,56,14.4433946,7.100335,12.1651875,1.8,7.0916592,12.2329,-1.4460501,2.141244,3.1511391,19.8035396,39.123469,2.3699659,12.415659,9.248614,18.6978565,4.2267,6.2681932,1.3661545,17.2347456),(42883,'radius.tif',229,3,57,14.3308224,7.0324926,12.1850975,1.8,7.0253862,12.2380497,-1.4444722,2.1266384,3.0540357,19.4188081,38.1774518,2.350558,12.5006565,9.1312222,18.6974305,4.2267,6.2069233,1.3258177,17.1388137),(42884,'radius.tif',229,3,58,14.1917805,6.9751268,12.1914471,1.8,6.970203,12.2256452,-1.434479,2.1120845,3.0719914,19.055727,37.5276475,2.3216154,12.2160653,9.0222368,18.2430167,4.1688,6.1559437,1.2847449,17.0428819),(42885,'radius.tif',229,3,59,14.1179311,6.9229093,12.1829688,1.8,6.9190685,12.2147048,-1.4185093,2.1051256,3.1088533,18.7579518,37.2299845,2.2988401,11.9754717,8.9106095,17.9506943,4.1688,6.150768,1.3235346,17.0089648),(42886,'radius.tif',229,3,60,14.2001103,6.8661598,12.1949724,1.8,6.8611684,12.2237356,-1.4033797,2.1042092,3.1335899,18.594018,37.4372252,2.3009683,11.9470723,8.8365822,17.8205105,4.1688,6.150768,1.3235346,17.1048967),(42887,'radius.tif',229,3,61,14.2909584,6.8088926,12.2053053,1.8,6.8091793,12.2269511,-1.3890145,2.119441,3.1679568,18.490982,37.560427,2.3039829,11.8563572,8.724462,17.6011718,4.1109,6.1398576,1.293792,16.913033),(42888,'radius.tif',229,3,62,14.2833705,6.7603085,12.2066762,1.8,6.7623723,12.2256929,-1.3799884,2.1313341,3.1813162,18.3754239,37.3500677,2.2949378,11.740445,8.6215596,17.4153962,4.1109,6.119348,1.2131331,16.8989841),(42889,'radius.tif',229,3,63,14.3660508,6.7181288,12.2121547,1.8,6.7208268,12.2308735,-1.3751119,2.1323939,3.2420646,18.2784044,37.9151194,2.3038211,11.6947452,8.5717767,17.2588952,4.1109,6.1896157,1.2667954,17.0147841),(42890,'radius.tif',229,3,64,14.4316154,6.6843287,12.2284309,1.8,6.690664,12.2382739,-1.374032,2.11791,3.2536374,18.1834938,38.3774838,2.313342,11.7952553,8.585584,17.3245052,4.053,6.1896157,1.2667954,17.0007352),(42891,'radius.tif',229,3,65,14.5523505,6.6457374,12.2497336,1.8,6.6528778,12.2590915,-1.3759705,2.1153514,3.2134655,18.2358408,38.9374297,2.3344898,12.1169589,8.6207148,17.6422327,4.1109,6.1822995,1.1868117,17.0826181),(42892,'radius.tif',229,3,66,14.6451854,6.6035086,12.2619686,1.8,6.6126406,12.2729413,-1.3676685,2.1298175,3.2594109,18.242974,39.5175308,2.3415295,12.124133,8.5655104,17.5957837,4.1109,6.2279519,1.2196425,17.0487011),(42893,'radius.tif',229,3,67,14.7825904,6.5714497,12.2753826,1.8,6.5811613,12.2777266,-1.3707441,2.1327336,3.3114474,18.3444764,40.3822625,2.3664714,12.1947469,8.6013912,17.6604181,4.1109,6.2986047,1.2432319,17.1305841),(42894,'radius.tif',229,3,68,14.9025839,6.5507796,12.2928934,1.8,6.5623615,12.3004968,-1.3729104,2.1240304,3.3433977,18.4947944,41.6611602,2.3877656,12.4607254,8.7074056,17.8747581,4.1109,6.3534534,1.2461639,17.2463841),(42895,'radius.tif',229,3,69,14.9459963,6.5313908,12.2923989,1.8,6.542078,12.2967371,-1.3758181,2.1275464,3.3911225,18.6093015,42.5873162,2.3974942,12.5584718,8.7468369,17.9533798,4.1109,6.4083557,1.2490458,17.3621841),(42896,'radius.tif',229,3,70,14.9033778,6.5087012,12.306248,1.8,6.5193396,12.3120165,-1.3803138,2.1276579,3.3855064,18.6551591,43.1367038,2.3948563,12.7415809,8.7679316,18.1956663,4.053,6.4109709,1.2776094,17.3961011),(42897,'radius.tif',229,3,71,14.8545722,6.4860868,12.32784,1.8,6.4967554,12.3356034,-1.3832228,2.1301546,3.3532632,18.7447061,43.3682188,2.3896721,12.933139,8.7996926,18.4468979,4.1109,6.3944777,1.2862778,17.444067),(42898,'radius.tif',229,3,72,14.89029,6.4728119,12.330691,1.8,6.4841523,12.3366457,-1.3926274,2.0967471,3.3554035,18.7500556,44.4570087,2.4037651,13.2493776,8.9424499,18.7361787,4.1109,6.4341986,1.297441,17.5739159),(42899,'radius.tif',229,3,73,14.860718,6.459189,12.3413371,1.8,6.47102,12.3459952,-1.4046113,2.0889561,3.3637303,18.6859775,45.284981,2.4090111,13.4627265,8.9451271,18.8840781,4.053,6.4747114,1.3084658,17.492033),(42900,'radius.tif',229,3,74,14.8905558,6.4515631,12.346838,1.8,6.4642484,12.351545,-1.4169408,2.10804,3.4046037,18.6717139,46.2899448,2.4234744,13.5962797,8.8573811,18.9936955,4.053,6.5444932,1.3386925,17.7517308),(42901,'radius.tif',229,3,75,14.8245999,6.4461735,12.3531041,1.8,6.4558501,12.3606461,-1.4303995,2.1188531,3.4068675,18.5533111,46.84327,2.4223838,13.7496601,8.756299,19.0795557,4.053,6.5754112,1.357858,17.7178137),(42902,'radius.tif',229,3,76,14.9092118,6.4419294,12.3569507,1.8,6.4510976,12.3795865,-1.440124,2.1194637,3.3998706,18.4840152,47.6952369,2.4426798,14.0285446,8.7210814,19.359624,3.9951,6.6087214,1.3768372,17.7037648),(42903,'radius.tif',229,3,77,14.7540518,6.4387123,12.3466346,1.8,6.4475466,12.3604572,-1.450238,2.1331893,3.3932095,18.4041974,47.6727447,2.4234414,14.0494552,8.6275499,19.3028749,3.9951,6.6320148,1.359703,17.7517308),(42904,'radius.tif',229,3,78,14.7051899,6.440918,12.3238326,1.8,6.4469387,12.3334388,-1.4649911,2.1458669,3.4661894,18.4509942,48.771092,2.4235304,14.0705214,8.5983869,19.2813115,4.053,6.7335983,1.3717144,17.9576434),(42905,'radius.tif',229,3,79,14.7826559,6.4439947,12.3200746,1.8,6.4475001,12.3312937,-1.4830215,2.1721223,3.497307,18.5920171,50.2498825,2.4448427,14.3681647,8.5593785,19.6316087,4.053,6.8735373,1.4610693,18.1214093),(42906,'radius.tif',229,3,80,14.9364851,6.4432739,12.3046674,1.8,6.4460333,12.3203245,-1.490268,2.1931631,3.4847161,18.8926825,51.8122908,2.4733057,14.8684397,8.6143536,20.1933918,4.053,6.931092,1.4619841,18.2231604),(42907,'radius.tif',229,3,81,14.9158746,6.4463792,12.2833493,1.8,6.4487383,12.2990245,-1.5011486,2.2028047,3.4633429,19.0476034,52.7745147,2.4739396,15.2380274,8.646978,20.5758729,4.053,6.9951253,1.4546547,18.3389604),(42908,'radius.tif',229,3,82,14.9670102,6.4405582,12.2578436,1.8,6.4430048,12.270357,-1.5034143,2.2076925,3.4989589,19.3164963,54.0388792,2.4831929,15.4442737,8.7496318,20.7502471,4.053,7.0668842,1.4393276,18.4547604),(42909,'radius.tif',229,3,83,15.0435849,6.4357121,12.2662537,1.8,6.4391763,12.2814139,-1.5095158,2.2373121,3.5378864,19.5594399,55.4741,2.4978604,15.6800115,8.7423833,21.1514065,4.1688,7.1169912,1.4484595,18.6325753),(42910,'radius.tif',229,3,84,15.1117566,6.4329061,12.2727302,1.8,6.4364231,12.2862508,-1.5168253,2.2513274,3.5900873,19.8633413,56.6168941,2.5112968,15.7703392,8.8229464,21.2892267,4.1688,7.2131411,1.4743226,18.7285071),(42911,'radius.tif',229,3,85,15.1928348,6.4339033,12.2747946,1.8,6.4373478,12.2885042,-1.5231229,2.2597702,3.5915792,20.1427101,57.5164438,2.5263885,16.0142491,8.9136099,21.5366421,4.1688,7.2189483,1.4663392,18.7285071),(42912,'radius.tif',229,3,86,15.2275836,6.436983,12.2754677,1.8,6.4408783,12.2903519,-1.5332175,2.2666067,3.6448364,20.4394995,58.3709906,2.5343483,16.0147079,9.0176649,21.5697332,4.2267,7.2606231,1.4909663,18.858356),(42913,'radius.tif',229,3,87,15.2106333,6.4414106,12.2672366,1.8,6.4442781,12.280164,-1.5438665,2.3185486,3.655888,20.8888045,59.0281191,2.5332675,16.1460415,9.0094316,21.7734112,4.2846,7.2606231,1.4909663,18.9063219),(42914,'radius.tif',229,3,88,15.1990392,6.4413645,12.2551435,1.8,6.4426368,12.2712789,-1.5559939,2.3282041,3.7242056,21.4552879,60.1443517,2.5326182,16.1495787,9.215381,21.8449781,4.3425,7.3066497,1.6262948,19.0700879),(42915,'radius.tif',229,3,89,15.1488823,6.4425176,12.2438787,1.8,6.4449111,12.2544989,-1.5667402,2.331473,3.7360844,22.0964683,61.047606,2.5247722,16.3399964,9.4774714,22.1317002,4.3425,7.3760601,1.6493744,19.2198049),(42916,'radius.tif',229,3,90,15.1359931,6.4432642,12.2352531,1.8,6.4460738,12.2498284,1.5612828,2.3960405,3.7497793,22.8678988,61.5146873,2.5224372,16.404882,9.5440368,22.3293084,4.4583,7.3860523,1.6650048,19.3496538),(42917,'radius.tif',229,3,91,15.0422744,6.449219,12.2404137,1.8,6.4522003,12.2537204,1.5430953,2.4171,3.7555739,23.6140753,61.5827962,2.5051224,16.3977058,9.7695899,22.4785185,4.5162,7.4044118,1.6883619,19.4315368),(42918,'radius.tif',229,3,92,14.9655323,6.4600242,12.22917,1.8,6.4594883,12.2401411,1.5256574,2.4432086,3.7772664,24.3074617,61.6335058,2.4891767,16.3169602,9.9489916,22.5617809,4.5162,7.4114262,1.6961203,19.4654538),(42919,'radius.tif',229,3,93,14.9793724,6.4720234,12.220118,1.8,6.4735154,12.2362386,1.5055369,2.5129753,3.7984211,25.1771072,61.9164558,2.4859448,16.3005771,10.018844,22.761967,4.632,7.4188859,1.7038636,19.6631368),(42920,'radius.tif',229,3,94,15.0611854,6.4861809,12.2093488,1.8,6.4880861,12.2223959,1.4865601,2.5413415,3.816022,26.0698498,62.5422641,2.492428,16.3893877,10.2583024,23.1105315,4.6899,7.4188859,1.7038636,19.7450197),(42921,'radius.tif',229,3,95,15.0483073,6.5050677,12.1977338,1.8,6.5045898,12.2103112,1.4669752,2.5764447,3.8046173,26.8407387,63.1696563,2.4811144,16.6034192,10.4177428,23.3945251,4.7478,7.4159482,1.7513482,19.8128538),(42922,'radius.tif',229,3,96,15.0088496,6.5235911,12.1940313,1.8,6.519611,12.209604,1.4483281,2.6042983,3.8160487,27.7667182,63.8066021,2.4641438,16.7205942,10.661881,23.806997,4.8057,7.4376151,1.7666652,19.9625709),(42923,'radius.tif',229,3,97,15.146742,6.5316416,12.1897658,1.8,6.5265482,12.2140724,1.4383733,2.6173003,3.8238324,28.8134451,64.8790782,2.4804466,16.9670297,11.008842,24.2844004,4.8636,7.4610166,1.7818897,20.0783709),(42924,'radius.tif',229,3,98,15.0582369,6.562252,12.1844422,1.8,6.5576464,12.1953324,1.4158747,2.6486246,3.8117485,29.5743903,65.2345131,2.4499518,17.1140652,11.1659426,24.6091047,4.9215,7.4993354,1.8045395,20.2620049),(42925,'radius.tif',229,3,99,15.0345169,6.5812368,12.1709592,1.8,6.579317,12.1806245,1.3970616,2.6752512,3.8315497,30.5438799,65.559007,2.4308777,17.110311,11.4172007,24.8529297,4.9794,7.5129574,1.8120367,20.3778049),(42926,'radius.tif',229,3,100,15.1124283,6.5975823,12.1479048,1.8,6.5951596,12.1599955,1.375769,2.6899432,3.8375712,31.4818489,66.0468243,2.4241447,17.2105793,11.7035367,25.1228681,5.0420902,7.5158572,1.843805,20.5415709),(42927,'radius.tif',229,3,101,15.1082731,6.6283779,12.1450286,1.8,6.6258062,12.1491515,1.3566836,2.7163805,3.8305112,32.4305788,66.4206666,2.4043609,17.3398962,11.9388938,25.5821601,5.0924523,7.5004529,1.8363713,20.6573709),(42928,'radius.tif',229,3,102,15.0799688,6.6603424,12.127893,1.8,6.6574387,12.1286839,1.3382612,2.7444767,3.8328814,33.1188892,66.729623,2.379858,17.4097802,12.0674698,25.855478,5.1383364,7.4888229,1.885212,20.561439),(42929,'radius.tif',229,3,103,15.078224,6.6796311,12.1274764,1.8,6.6723537,12.119958,1.3190156,2.7552354,3.8192207,34.2725822,66.8816984,2.3570651,17.5118707,12.4390757,26.2669149,5.1996479,7.453824,1.8704375,20.7252049),(42930,'radius.tif',229,3,104,14.9916373,6.7112831,12.1247986,1.8,6.6964949,12.1085743,1.3046962,2.7766956,3.7870902,35.24459,66.8899196,2.3258184,17.6626159,12.6929973,26.7566335,5.2451163,7.4204673,1.8555268,20.874922),(42931,'radius.tif',229,3,105,14.9503547,6.7435382,12.1132885,1.8,6.7363567,12.1035737,1.2768043,2.8130741,3.7904468,36.0869356,67.61173,2.2824963,17.8374037,12.8282917,27.1974844,5.3022223,7.4294974,1.9541971,20.9708538),(42932,'radius.tif',229,3,106,15.0202746,6.7890125,12.1100963,1.8,6.784111,12.0954733,1.2476096,2.8497342,3.7593045,37.2871752,68.0698993,2.2508799,18.1070459,13.0844396,27.7773072,5.3664244,7.4202414,1.9715898,21.0726049),(42933,'radius.tif',229,3,107,15.1738819,6.8218485,12.0876899,1.8,6.8162284,12.0642675,1.2160756,2.8867041,3.7766498,38.6443289,68.6976638,2.2238915,18.190107,13.3870073,28.26458,5.4170802,7.408033,1.9469486,21.1884049),(42934,'radius.tif',229,3,108,14.9859895,6.8851829,12.0559226,1.8,6.8939813,12.0364711,1.1789734,2.9514003,3.7664224,39.4329047,68.5435829,2.1334363,18.1985916,13.3607442,28.5502109,5.4701027,7.4132353,1.9890207,21.3182538),(42935,'radius.tif',229,3,109,14.9889393,6.933975,12.0193569,1.8,6.9324729,11.9954208,1.148175,2.9906921,3.7789202,40.0831983,69.5899497,2.0779039,18.4153,13.4026497,28.8545481,5.5190553,7.4331064,2.0135411,21.5018879),(42936,'radius.tif',229,3,110,14.9597375,6.9790158,12.0240116,1.8,6.9728348,11.9965016,1.1137211,3.011455,3.7333296,41.133463,70.7403655,2.0076762,18.9483312,13.6589998,29.3342731,5.5673121,7.443022,1.9787525,21.6656538),(42937,'radius.tif',229,3,111,15.0342204,7.0212521,12.0164639,1.8,7.023092,11.9773049,1.0981977,3.0104452,3.7231718,42.262808,72.3804449,1.9865004,19.4405333,14.0387236,29.9634058,5.6008998,7.4771748,2.1072318,21.8633368),(42938,'radius.tif',229,3,112,15.0055297,7.0352258,11.9755344,1.8,7.0391686,11.9507631,1.0724777,3.0288486,3.7558631,43.2985034,73.1226804,1.9296221,19.4689421,14.2953675,29.8537494,5.6410956,7.5192018,2.086122,22.0271027),(42939,'radius.tif',229,3,113,14.8019941,7.0619089,11.9416561,1.8,7.0578089,11.9030375,1.0348844,3.0482683,3.7615343,44.1363817,72.7290088,1.823758,19.3349318,14.4791656,29.6116088,5.7017693,7.5174182,2.2744101,22.1429027),(42940,'radius.tif',229,3,114,14.6133955,7.0868098,11.9206328,1.8,7.0918701,11.8854857,1.0067135,3.0587238,3.7500476,44.6948402,73.4615917,1.7393813,19.5895091,14.6122513,29.6448671,5.7482659,7.5875515,2.415584,22.2587027),(42941,'radius.tif',229,3,115,14.5059399,7.1107134,11.8786057,1.8,7.1294842,11.8580415,0.9760308,3.0579105,3.7900877,45.0101928,74.5302404,1.6586276,19.6645161,14.7192641,29.8368766,5.7804643,7.6060858,2.447829,22.3546346),(42942,'radius.tif',229,3,116,14.3426195,7.1755238,11.8443314,1.8,7.1998169,11.832432,0.9449522,3.1043775,3.7856996,45.3612997,75.3913818,1.5701819,19.9147816,14.6120438,30.1203548,5.8281991,7.6506915,2.4526683,22.3745027),(42943,'radius.tif',229,3,117,14.1876539,7.2097517,11.8184607,1.8,7.2317673,11.8009985,0.910709,3.1218012,3.7896133,45.9829019,75.5887899,1.4755234,19.946307,14.7296061,29.9341899,5.8661629,7.689155,2.4950795,22.5184005),(42944,'radius.tif',229,3,118,13.9357687,7.2543169,11.8094723,1.8,7.273348,11.7815269,0.8723794,3.1299272,3.7963133,46.0332427,75.6840682,1.3623217,19.9362019,14.7074483,29.8458666,5.872841,7.7354487,2.4995885,22.6821665),(42945,'radius.tif',229,3,119,13.873713,7.2830419,11.7751971,1.8,7.2991287,11.7411101,0.8601915,3.1049948,3.8050328,46.5835915,75.6539505,1.3284421,19.8826013,15.002792,29.8529846,5.9222114,7.747574,2.5100491,22.7301324),(42946,'radius.tif',229,3,120,13.7931121,7.3482928,11.7849281,1.8,7.3689593,11.7547449,0.8582671,3.0930974,3.7689329,47.2676175,76.2260948,1.3163485,20.2248478,15.2816454,30.4167198,5.9326447,7.7564393,2.5473789,22.8401131),(42947,'radius.tif',229,3,121,13.680418,7.3844481,11.7448762,1.8,7.4022896,11.7013676,0.8599413,3.0762001,3.7625052,47.7435867,75.3734036,1.3093694,20.0327709,15.5203125,30.1644235,5.96495,7.7562232,2.6178169,22.936045),(42948,'radius.tif',229,3,122,13.5398458,7.3934558,11.702069,1.8,7.4280031,11.6797863,0.8460115,3.0749723,3.7753954,47.9652542,75.2347372,1.2647682,19.9276442,15.5985972,30.0432597,5.9938268,7.7354487,2.6075916,22.936045),(42949,'radius.tif',229,3,123,13.331514,7.4649777,11.6744149,1.8,7.4937982,11.6487949,0.8287369,3.0865745,3.7622692,48.331478,74.0150012,1.2071342,19.6729681,15.6586139,29.8563759,6.0191185,7.77608,2.5845719,23.017928),(42950,'radius.tif',229,3,124,12.9305195,7.517569,11.6590685,1.8,7.5457589,11.626967,0.7925502,3.1312934,3.7773167,47.957657,72.5676477,1.092956,19.2114279,15.3156061,29.4845198,6.0563796,7.77608,2.5845719,23.017928),(42951,'radius.tif',229,3,125,12.6223128,7.6073272,11.6566642,1.8,7.6413986,11.6272985,0.7739905,3.1598391,3.7973937,47.8360616,70.9913588,1.027863,18.6947586,15.138765,29.4219349,6.0927911,7.7650787,2.6011732,22.936045),(42952,'radius.tif',229,3,126,12.7185413,7.6706951,11.6016874,1.8,7.698383,11.5676297,0.7403627,3.1888846,3.8017058,48.8258514,71.2503004,0.9645431,18.7416661,15.3112631,29.6496916,6.1283798,7.7562232,2.6178169,23.0319769),(42953,'radius.tif',229,3,127,12.7194253,7.7488702,11.5776025,1.8,7.7784758,11.551643,0.7270152,3.2115216,3.8378568,49.7063489,71.1046695,0.936467,18.5271814,15.4775072,29.7677188,6.1765957,7.7853435,2.6113769,23.1618258),(42954,'radius.tif',229,3,128,12.7469587,7.841256,11.5447832,1.8,7.884453,11.5146947,0.7183795,3.2147459,3.8462866,49.9559363,71.180652,0.9202919,18.5063308,15.5396222,30.1464897,6.2163226,7.8001853,2.638099,23.0658939),(42955,'radius.tif',229,3,129,12.7408945,7.9299788,11.4865255,1.8,8.0004273,11.4513125,0.6714525,3.2487294,3.8635446,49.6971877,71.616017,0.8218686,18.5363503,15.2974231,30.2853031,6.2635007,7.8064147,2.6215266,23.1957428),(42956,'radius.tif',229,3,130,12.6282108,7.9925294,11.4226684,1.8,8.0521253,11.3915024,0.642798,3.2660265,3.8443865,49.9195505,71.1820686,0.7562722,18.5158459,15.2844905,29.9640614,6.2954578,7.8250732,2.7143528,23.2296598),(42957,'radius.tif',229,3,131,12.5639745,8.0603001,11.3504854,1.8,8.1243694,11.2924836,0.6443273,3.2479162,3.8441181,49.9529059,70.3362232,0.7554997,18.2971028,15.3799862,29.5137961,6.3234,7.8387706,2.7473697,23.2916747),(42958,'radius.tif',229,3,132,12.289297,8.157969,11.3881463,1.8,8.2242538,11.3263424,0.5967494,3.3400755,3.8744293,49.6756773,68.9595387,0.646817,17.7986313,14.8726211,29.2588045,6.3582451,7.8839733,2.7338079,23.3876065),(42959,'radius.tif',229,3,133,12.1980435,8.233637,11.3741477,1.8,8.3005597,11.3203404,0.561714,3.4018172,3.8726585,50.3097667,67.8808984,0.5767698,17.5282426,14.7890861,29.1120798,6.4024662,7.8816343,2.773364,23.4355725),(42960,'radius.tif',229,3,134,11.9325951,8.2926704,11.3986747,1.8,8.3615418,11.3361444,0.5272584,3.5090357,3.8873535,49.9651855,66.1139963,0.5035078,17.0074569,14.2390074,28.9573584,6.4440644,7.860978,2.7802358,23.4835384),(42961,'radius.tif',229,3,135,12.0184753,8.3770037,11.3457505,1.8,8.4466379,11.2697984,0.4892351,3.5214397,3.8784566,50.893427,65.0015119,0.4423877,16.7596339,14.4524487,29.1903928,6.4592731,7.8368458,2.8104966,23.4157043),(42962,'radius.tif',229,3,136,12.1677861,8.4855707,11.2699852,1.8,8.5604732,11.1723621,0.4215876,3.5298322,3.8778807,51.004359,64.3314384,0.3395877,16.5893287,14.4495138,29.5372955,6.4687543,7.7821133,2.8080779,23.3817873),(42963,'radius.tif',229,3,137,11.823034,8.4973968,11.179407,1.8,8.5579056,11.0734962,0.4446244,3.537534,3.8230126,49.7852308,61.8256579,0.3645479,16.1719734,14.073428,28.3612321,6.5042181,7.7562232,2.9310207,23.3817873),(42964,'radius.tif',229,3,138,11.6376724,8.5379329,11.1613515,1.8,8.6147308,11.0574251,0.3769727,3.6229128,3.8215069,49.3025434,61.8650719,0.2628234,16.1886588,13.6085371,28.4523101,6.5304614,7.7120106,2.9221094,23.3958362),(42965,'radius.tif',229,3,139,11.8038906,8.6137927,11.132535,1.8,8.6795833,11.0251636,0.3062364,3.6630363,3.8261063,50.1746952,61.3721264,0.1788005,16.0403611,13.6975697,28.7799293,6.5687724,7.6876288,2.9368117,23.4636703),(42966,'radius.tif',229,3,140,12.2393196,8.6605701,11.0746412,1.8,8.7104624,10.9626475,0.2988823,3.7002456,3.8582314,51.9457664,61.2601103,0.1768625,15.8777698,14.0384645,29.0594088,6.5958653,7.6817395,2.9826397,23.5455532),(42967,'radius.tif',229,3,141,12.0551472,8.7692899,11.0403316,1.8,8.8226891,10.9404758,0.2057707,3.7271046,3.8818944,51.519915,60.2101454,0.0838784,15.5105056,13.8230399,28.7185289,6.6333853,7.7135319,3.0060649,23.689451),(42968,'radius.tif',229,3,142,13.0028974,8.8101739,10.9965564,1.8,8.857971,10.9112702,0.2478852,3.7859969,3.8947865,53.9674333,63.9570803,0.1304597,16.4212033,14.2544843,30.1315162,6.6597232,7.6911167,2.9752064,23.6414851),(42969,'radius.tif',229,3,143,13.2862915,8.9400136,10.9968603,1.8,8.9983963,10.8903136,0.2437469,3.8376273,3.8686701,56.1657955,65.0821218,0.1289771,16.8228666,14.6355522,31.1571513,6.7129035,7.7300296,2.9912212,23.8532169),(42970,'radius.tif',229,3,144,13.2596337,9.0394902,11.0084723,1.8,9.0656733,10.9167855,0.2889826,3.8870901,3.8415181,56.279487,65.420174,0.1794735,17.029771,14.4785649,31.2135612,6.7347858,7.7709049,3.0070717,23.9491488),(42971,'radius.tif',229,3,145,13.6337621,9.1138313,10.9748716,1.8,9.1455,10.9092079,0.4257552,3.8673663,3.7723352,57.3960263,67.0188737,0.3875991,17.7658851,14.8411145,31.9470648,6.756668,7.7579519,2.9690821,23.9830658),(42972,'radius.tif',229,3,146,13.803858,9.2116821,10.929769,1.8,9.2650077,10.8877557,0.3953544,3.8336147,3.8253269,56.8825096,68.3362262,0.3412525,17.8641535,14.8378265,31.8792119,6.7668014,7.7961012,2.9849908,24.0988658),(42973,'radius.tif',229,3,147,13.8856599,9.301554,10.8999324,1.8,9.3073961,10.8518419,0.4559934,3.7796312,3.8006668,57.5000627,68.3614513,0.448766,17.9866996,15.213141,31.7952447,6.7713072,7.8250732,2.9253314,24.2088466),(42974,'radius.tif',229,3,148,14.180517,9.445313,10.8970257,1.8,9.4608346,10.8723098,0.4344492,3.7474725,3.8606553,56.9038452,69.5309695,0.4187174,18.0101472,15.1845932,32.2388041,6.7456281,7.8816343,2.9269078,24.2427636),(42975,'radius.tif',229,3,149,14.9942632,9.5151081,10.8517261,1.8,9.5378854,10.829937,0.4146229,3.7136281,3.9024454,59.4132926,73.4719816,0.4055546,18.8271643,15.998719,33.035545,6.7291108,8.0170073,2.9526955,24.4544955),(42976,'radius.tif',229,3,150,15.8248862,9.5744161,10.8801055,1.8,9.5861368,10.8682217,0.3923525,3.7470903,3.9711695,62.7860203,76.7117784,0.385604,19.3171753,16.7559399,34.1665712,6.7630182,8.1416954,2.9483812,24.6323103),(42977,'radius.tif',229,3,151,16.1987449,9.7168771,10.8556417,1.8,9.7187414,10.8756954,0.4730137,3.6776267,4.0097889,62.7035674,79.7986187,0.5603284,19.9009524,17.0500086,34.4379791,6.7985206,8.3023432,2.9236801,24.7621592),(42978,'radius.tif',229,3,152,16.8049045,9.7734166,10.820721,1.8,9.7819069,10.8486151,0.5183983,3.6849165,4.0286958,67.1949644,82.0161032,0.6876284,20.3579786,18.2351389,35.6647076,6.8369009,8.3845119,2.9116882,25.021857),(42979,'radius.tif',229,3,153,17.7089834,9.9209726,10.8203424,1.8,9.9220848,10.8526139,0.6427825,3.6308431,3.9152622,68.6028711,87.2309194,1.0605032,22.2797134,18.894474,36.5091201,6.9004171,8.3843119,2.8832145,25.4230422),(42980,'radius.tif',229,3,154,19.6149667,10.1766554,10.6665072,1.8,10.1459584,10.7433634,0.5409111,3.7850321,4.0856312,73.1257656,97.7196496,0.8667846,23.9178833,19.3197213,39.2846498,6.891691,8.7292772,2.988439,28.9135015),(42981,'radius.tif',229,3,155,22.7846887,10.4120737,10.4772472,1.8,10.288826,10.6098034,0.8042159,3.8749685,3.8674,91.65727,106.8070837,1.9701667,27.6172839,23.6536815,43.2710653,7.0411215,8.7359954,2.914297,26.8887059),(42982,'radius.tif',229,3,156,26.3013547,10.452364,10.5236551,1.8,10.3405838,10.6270428,1.1150603,4.416963,4.1789449,100.6807666,133.9492417,3.5344263,32.053364,22.7941157,51.7648568,7.0496738,8.6379738,2.8771043,26.7811356),(42983,'radius.tif',229,3,157,29.2418975,10.3996244,10.5064454,1.8,10.3474917,10.5394892,0.9660462,4.1348785,4.0926965,116.9587568,159.7387648,3.2982107,39.0302008,28.2858995,62.2190015,7.6917823,8.8679668,1.5250766,29.7381504),(42984,'radius.tif',229,3,158,29.2993388,10.5182083,10.3153202,1.8,10.4861219,10.3214299,0.8823276,3.9470616,4.2167242,117.2742903,158.7659754,2.9119803,37.6514959,29.7117962,61.7668699,7.5307872,8.7981332,1.682907,27.2361059),(42985,'radius.tif',229,3,159,28.6869999,10.7496906,10.1922715,1.8,10.6952364,10.2833251,0.9620207,3.7611364,4.2272255,90.918252,136.6142346,3.2175921,32.317707,24.1730801,51.8771375,6.9438197,8.3897081,2.7892839,25.8440955),(42986,'radius.tif',229,3,160,21.9695851,10.503111,10.9001829,1.8,10.5978684,10.9464365,0.738894,2.7194485,4.0881907,28.9229038,98.6836467,1.6607646,24.1387091,10.6355768,29.8421144,5.0875062,7.7406476,2.5639631,23.839168),(42987,'radius.tif',229,3,161,12.8958765,11.1048647,11.8137758,1.8,11.0850286,11.8015458,0.5442388,1.9068353,3.9248954,8.2062555,48.4748123,0.5761935,12.3505998,4.3035996,14.3391306,3.591223,7.2247508,2.6671928,19.8385412),(42988,'radius.tif',229,3,162,5.9637334,12.1196267,12.8258985,1.8,12.1166328,12.8348946,-0.163383,1.1288019,2.0426191,1.5180766,5.7187873,0.0262974,2.7997326,1.3448565,3.5420448,2.1707297,3.9753316,0.2202487,10.2736951),(42989,'radius.tif',229,3,163,1.8415381,12.2715008,13.0651395,1.8,12.2680527,13.0563134,-0.212557,0.5543023,1.3295857,0.1090799,0.7496085,0.0136594,0.563791,0.1967877,0.643752,1.090538,2.6463531,0.1759396,6.4217868),(42990,'radius.tif',229,3,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42991,'radius.tif',229,3,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42992,'radius.tif',229,3,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42993,'radius.tif',229,3,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42994,'radius.tif',229,3,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42995,'radius.tif',229,3,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42996,'radius.tif',229,3,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42997,'radius.tif',229,3,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42998,'radius.tif',229,3,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(42999,'radius.tif',229,3,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43000,'ulna.tif',229,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43001,'ulna.tif',229,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43002,'ulna.tif',229,4,3,0.0011155,13.0854001,9.9588001,1.8,13.0854001,9.9588001,0.7853982,0.000000000000001256,0.000000000000001256,0.0000003,0.0000003,0.000093,248096724.397004,248096724.367965,350861752.402049,0.0579,0.081883,2.3561945,0.1637659),(43003,'ulna.tif',229,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43004,'ulna.tif',229,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43005,'ulna.tif',229,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43006,'ulna.tif',229,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43007,'ulna.tif',229,4,8,3.1790946,16.9307857,14.5716822,1.8,16.9292609,14.5772389,-1.2728532,1.0262379,1.1282963,0.8074442,0.9926526,0.4841897,0.8797801,0.7868002,1.5953697,2.0844,2.3253897,1.2411719,7.0908994),(43008,'ulna.tif',229,4,9,4.2142475,16.9578318,14.4814619,1.8,16.9728999,14.4927383,1.5506894,1.2746944,1.3979697,1.7867888,2.2961671,0.7020907,1.6425013,1.4017389,2.7950254,2.5476,2.9209388,1.3306253,8.9378802),(43009,'ulna.tif',229,4,10,4.5941866,17.0855789,14.2561737,1.8,17.0913856,14.233483,1.297014,1.3618104,1.4542232,2.0313177,2.4176279,0.7097233,1.6624876,1.4916303,2.9125492,2.6634,2.9226599,2.1587989,9.1496121),(43010,'ulna.tif',229,4,11,5.1560208,17.3448642,14.1152935,1.8,17.3489563,14.0885397,1.3859718,1.5567905,1.9396365,2.5286472,4.7271063,0.8303145,2.4371093,1.6242694,3.6993415,2.7963077,3.72455,1.7742894,10.5895884),(43011,'ulna.tif',229,4,12,6.5951661,17.2141289,14.5354572,1.8,17.2188326,14.5185613,1.5138824,1.7137969,2.5437486,4.9938557,9.9050665,1.0956377,3.8938858,2.9139134,5.7760625,3.2691114,4.6680473,1.4464413,13.0635351),(43012,'ulna.tif',229,4,13,7.118263,17.1702549,14.6020504,1.8,17.2024179,14.6314394,1.521256,1.991709,2.655743,8.274993,13.8690901,1.1834679,5.2223013,4.15472,8.0752055,3.8500044,5.0849915,1.4337302,28.7332763),(43013,'ulna.tif',229,4,14,8.1358003,17.0978604,14.5329728,1.8,17.1147897,14.6038955,1.4658515,2.3811668,2.5748608,12.3188594,15.796609,1.3410876,6.1349371,5.173455,10.1882602,4.4813757,5.1894036,1.3799652,15.8790626),(43014,'ulna.tif',229,4,15,9.269556,16.905621,14.4360553,1.8,16.9525041,14.4695631,1.2171381,2.5000499,2.5137118,15.2404352,15.676604,1.3596186,6.2364365,6.0960524,10.9717235,4.865837,5.2035965,0.8247479,16.6615648),(43015,'ulna.tif',229,4,16,9.0286891,17.12296,14.4755697,1.8,17.1026243,14.5386346,1.2952935,2.4510851,2.6357207,12.7204951,16.6330992,1.3934265,6.3106456,5.1897402,10.7573052,4.540858,5.2736699,1.4164776,17.1271752),(43016,'ulna.tif',229,4,17,7.3905691,17.0442024,14.6302023,1.8,17.065707,14.5379491,0.9350669,2.2678276,2.6097287,11.2196358,15.6241404,0.7974961,5.986883,4.9473054,9.8852837,4.5118249,5.2257758,1.7377665,16.2148241),(43017,'ulna.tif',229,4,18,6.5399374,17.0668695,14.6361108,1.8,17.0823288,14.5351171,0.9688332,2.2563451,2.6483055,10.3383553,14.3184292,0.740482,5.4066381,4.5819034,9.1179362,4.4538843,5.2357098,1.7486716,16.3165752),(43018,'ulna.tif',229,4,19,6.48085,17.0520737,14.5537722,1.8,17.0580672,14.5224972,1.0240196,2.2979986,2.6977933,10.5180028,14.8629342,0.7881426,5.5092932,4.5770276,9.4078277,4.45373,5.1696628,1.8429422,16.2826582),(43019,'ulna.tif',229,4,20,6.3345134,17.1386264,14.6703629,1.8,17.1116952,14.6242583,1.0731158,2.2692704,2.5687245,9.8742201,14.174764,0.8151463,5.5182112,4.3512753,9.3579188,4.3475988,5.1139174,2.1053907,15.8054093),(43020,'ulna.tif',229,4,21,5.8138827,17.120384,14.7307196,1.8,17.1168594,14.7202114,1.0468254,2.1035493,2.5226552,8.9923389,13.0423221,0.726423,5.1700772,4.2748411,8.6640352,4.225565,4.9878086,1.7340366,15.3480285),(43021,'ulna.tif',229,4,22,5.6609095,17.1864309,14.8139352,1.8,17.1732499,14.8027343,1.1215616,2.0986727,2.4752858,8.706793,12.6909402,0.7655475,5.1270605,4.1487141,8.6111449,4.1609409,4.9351048,1.95566,15.0064478),(43022,'ulna.tif',229,4,23,5.2624226,17.15642,14.8436612,1.8,17.1298488,14.8253015,1.0827186,2.0744173,2.4350985,8.2442346,11.481171,0.6842076,4.7148693,3.9742412,8.0812848,4.1432781,4.8182403,1.9267541,14.7947159),(43023,'ulna.tif',229,4,24,5.5633406,17.21039,14.9234667,1.8,17.1938599,14.9285132,1.1782352,2.0254573,2.343909,8.336667,11.6942489,0.7915251,4.9892078,4.1159432,8.1600316,4.0650585,4.7861277,2.1755759,14.664867),(43024,'ulna.tif',229,4,25,5.4090442,17.2799384,14.9344958,1.8,17.2683157,14.9464604,1.1524676,1.9767855,2.323318,7.9025054,11.3370612,0.7527352,4.8796856,3.9976545,7.9824664,4.0138099,4.7187612,1.6814535,14.433267),(43025,'ulna.tif',229,4,26,5.3641119,17.3510904,14.969961,1.8,17.3313458,14.9768545,1.2311469,1.9885983,2.3456424,7.8770152,11.0499067,0.7947886,4.7108233,3.9610892,7.8037911,3.9734067,4.7027491,1.4968573,14.317467),(43026,'ulna.tif',229,4,27,5.3703615,17.3829045,14.9812457,1.8,17.3936815,14.9772438,1.2460173,1.9766966,2.3148478,7.6755434,10.6858801,0.8039212,4.6162343,3.8830155,7.7063287,3.945077,4.6551024,1.670465,14.235584),(43027,'ulna.tif',229,4,28,5.5414318,17.4072934,14.9911705,1.8,17.4172151,14.9840049,1.3659951,1.9244335,2.3078689,7.6358368,10.9117777,0.8853727,4.7280752,3.9678361,7.7631678,3.8793,4.6838202,1.4219064,14.0379011),(43028,'ulna.tif',229,4,29,5.5763137,17.4131907,15.0371696,1.8,17.4237994,15.0333604,1.3980216,1.9137576,2.3493094,7.5837706,11.0288454,0.9019174,4.6945052,3.9627644,7.7740501,3.8214,4.6558225,1.3831566,13.9080522),(43029,'ulna.tif',229,4,30,5.7771856,17.4037643,15.0994967,1.8,17.4196399,15.0999542,1.4018885,1.9525588,2.3724993,7.7305528,10.5753963,0.9356541,4.4574919,3.9591909,7.5531341,3.7635,4.6265687,1.4200499,13.8261692),(43030,'ulna.tif',229,4,31,5.6188504,17.427172,15.0875933,1.8,17.4419431,15.077549,1.4312802,1.9136308,2.3588691,7.5489022,10.6072565,0.9183648,4.4967551,3.944806,7.543558,3.7056,4.6356174,1.407701,13.8460374),(43031,'ulna.tif',229,4,32,5.3465927,17.4514564,15.0922734,1.8,17.4485136,15.0842587,1.443382,1.8914242,2.352897,7.2933263,10.6844081,0.8767104,4.5409587,3.8559971,7.5064496,3.7056,4.6558225,1.3831566,13.8460374),(43032,'ulna.tif',229,4,33,5.4302248,17.4847518,15.1052265,1.8,17.4844629,15.0794932,1.499526,1.856913,2.3693883,7.3569797,10.849104,0.9004481,4.5788629,3.961941,7.5800277,3.6965734,4.6838202,1.4219064,13.8940033),(43033,'ulna.tif',229,4,34,5.5223929,17.5084131,15.1209663,1.8,17.4937305,15.1036003,1.5051208,1.8441757,2.3831128,7.4301962,11.1798766,0.9164346,4.6912914,4.0290067,7.7108269,3.7182794,4.6927584,1.4097044,13.9419692),(43034,'ulna.tif',229,4,35,5.5891492,17.5206921,15.1259272,1.8,17.5042036,15.1140802,1.5271884,1.8777136,2.3897021,7.4925802,11.4825985,0.9297546,4.8050334,3.9902679,7.8214793,3.7267548,4.7478,1.3494819,13.9419692),(43035,'ulna.tif',229,4,36,5.6824954,17.5028818,15.104586,1.8,17.4898565,15.1022594,-1.5644195,1.931388,2.3693826,7.6303871,11.6944957,0.9470441,4.9356722,3.9507272,8.0243936,3.7565952,4.7696388,1.3876855,14.0379011),(43036,'ulna.tif',229,4,37,5.7162706,17.5018225,15.0828618,1.8,17.4911218,15.0824928,-1.5573381,1.9339491,2.3514466,7.7035172,11.7306989,0.9525392,4.9887158,3.9833091,8.102177,3.7745449,4.7805208,1.3757761,14.0379011),(43037,'ulna.tif',229,4,38,5.9183256,17.4993294,15.0623873,1.8,17.4894742,15.0648346,-1.5198592,1.9486924,2.3932484,7.9095258,12.1258865,0.9838305,5.0667062,4.0588889,8.3542897,3.8057881,4.807095,1.4135683,14.1537011),(43038,'ulna.tif',229,4,39,6.1030837,17.5193617,15.0670361,1.8,17.5082922,15.0686643,-1.501167,1.9686552,2.4110434,7.8981638,12.8909748,1.012257,5.3466374,4.0119589,8.5718001,3.8214,4.8735844,1.4036945,14.201667),(43039,'ulna.tif',229,4,40,6.3359548,17.5306146,15.0739144,1.8,17.5183373,15.0735275,-1.4999856,1.9766019,2.4215133,8.0581234,13.407221,1.0507064,5.5367118,4.0767557,8.7946176,3.8214,4.8941771,1.3803612,14.235584),(43040,'ulna.tif',229,4,41,6.4855316,17.548384,15.0283504,1.8,17.5386825,15.0336835,-1.4917234,1.9393878,2.4348503,8.0995938,13.8079477,1.0741775,5.6709636,4.1763664,8.9438684,3.8214,4.9510426,1.3825748,14.317467),(43041,'ulna.tif',229,4,42,6.4134799,17.5658422,15.0113658,1.8,17.5587252,15.0247751,-1.4869576,1.8987263,2.4438408,7.8391834,13.932318,1.0614176,5.7009926,4.1286536,8.8247053,3.7056,4.9716516,1.3116943,14.2215352),(43042,'ulna.tif',229,4,43,6.4051552,17.578975,15.0368586,1.8,17.5716502,15.0392751,-1.4764611,1.8889731,2.5018734,7.6213378,14.3271756,1.058054,5.726579,4.0346459,8.7468122,3.7056,5.0306405,1.3621146,14.317467),(43043,'ulna.tif',229,4,44,6.4860768,17.5814815,15.0577706,1.8,17.5772291,15.0549432,-1.4546316,1.8476102,2.5700614,7.591282,14.677346,1.0664909,5.7108932,4.1087032,8.6645373,3.6477,5.1021039,1.4112446,14.351384),(43044,'ulna.tif',229,4,45,6.5127381,17.583737,15.0548806,1.8,17.5853892,15.0486377,-1.4497434,1.80609,2.5809309,7.5854491,14.7280716,1.0696278,5.7064958,4.1999286,8.6373567,3.5898,5.1439841,1.3667783,14.2695011),(43045,'ulna.tif',229,4,46,6.5227873,17.5995579,15.0566823,1.8,17.597986,15.0590894,-1.4431287,1.8080957,2.6240751,7.4509598,15.1429996,1.0695081,5.770795,4.1208879,8.6091056,3.5898,5.2164655,1.4147715,14.433267),(43046,'ulna.tif',229,4,47,6.5847327,17.6152948,15.0414086,1.8,17.6135208,15.0365328,-1.4550753,1.8151005,2.6207825,7.3525852,15.6912366,1.0828245,5.9872335,4.0507869,8.7875916,3.5898,5.2574348,1.3712409,14.467184),(43047,'ulna.tif',229,4,48,6.7566475,17.6203298,15.0179603,1.8,17.6227044,15.0173705,-1.4496447,1.8029778,2.6478235,7.3790186,16.2979157,1.1096599,6.1552123,4.092684,8.9419878,3.5898,5.3223928,1.4288993,14.5970329),(43048,'ulna.tif',229,4,49,6.8133802,17.6310706,15.0060656,1.8,17.6303737,15.0074402,-1.4362643,1.8169883,2.6422414,7.4403875,16.5014288,1.1151346,6.2452388,4.0949011,9.060873,3.5898,5.34,1.4074302,14.5970329),(43049,'ulna.tif',229,4,50,6.8398274,17.6281582,15.0102562,1.8,17.6249856,15.0111269,-1.4260036,1.821149,2.6552455,7.5224912,16.7479406,1.1162384,6.3074924,4.1306292,9.1386645,3.6092331,5.3709858,1.3755149,14.6789159),(43050,'ulna.tif',229,4,51,6.8849253,17.6349925,15.0179372,1.8,17.6358318,15.0143353,-1.4125708,1.827141,2.7102943,7.5748823,17.1558276,1.1189988,6.3298762,4.1457567,9.1227961,3.5898,5.4277969,1.3775848,14.7128329),(43051,'ulna.tif',229,4,52,6.9036535,17.6494387,15.0133418,1.8,17.6451417,15.0159363,-1.4126706,1.8406986,2.7126044,7.5180068,17.6346366,1.1220784,6.5009984,4.0843226,9.2724175,3.5810676,5.4638093,1.4004212,14.8286329),(43052,'ulna.tif',229,4,53,7.0895405,17.6432679,14.9917362,1.8,17.6408412,14.9992825,-1.4167885,1.8408067,2.7136355,7.6017233,18.4603577,1.1537855,6.8028141,4.1295609,9.5988823,3.5670603,5.4846308,1.3796119,14.896467),(43053,'ulna.tif',229,4,54,7.3628713,17.625086,14.9704324,1.8,17.6218984,14.9821687,-1.4083943,1.8474471,2.7417379,7.8899213,19.1701501,1.1950635,6.9919703,4.2707158,9.8627713,3.5669093,5.5078089,1.3589688,14.97835),(43054,'ulna.tif',229,4,55,7.6026551,17.6020335,14.958008,1.8,17.603665,14.9648058,-1.3977272,1.8389295,2.7509456,8.1427076,19.8962437,1.229533,7.2325107,4.4279608,10.1411058,3.5629896,5.5442085,1.445146,15.176033),(43055,'ulna.tif',229,4,56,7.7795479,17.5828925,14.947186,1.8,17.5800491,14.9608944,-1.3926417,1.8271768,2.7846171,8.2248066,20.6686393,1.2558722,7.4224349,4.5013741,10.3573875,3.5390457,5.5779672,1.4039412,15.2239989),(43056,'ulna.tif',229,4,57,7.9514106,17.5684059,14.9403999,1.8,17.5674716,14.9539438,-1.3899086,1.8368524,2.8035082,8.3072182,21.5292575,1.2823438,7.6793989,4.5225289,10.5202348,3.5111822,5.6171953,1.4259838,15.291833),(43057,'ulna.tif',229,4,58,7.9274997,17.5653403,14.9263889,1.8,17.5639881,14.9414771,-1.3814089,1.8496012,2.8105817,8.1997784,21.8794281,1.2744238,7.7846617,4.4332683,10.5578364,3.5080012,5.6210733,1.3633001,15.32575),(43058,'ulna.tif',229,4,59,8.0210409,17.5474901,14.9033527,1.8,17.5402324,14.9219138,-1.3748633,1.8480989,2.8402789,8.2223488,22.4722527,1.2861726,7.911988,4.4490848,10.6784769,3.5071978,5.6744955,1.4274563,15.4555989),(43059,'ulna.tif',229,4,60,8.1146078,17.5257024,14.8734777,1.8,17.521016,14.8919909,-1.3666068,1.8422644,2.8613707,8.2438576,22.8481504,1.2968264,7.9850368,4.4748504,10.7085682,3.4911805,5.6921914,1.4073199,15.475467),(43060,'ulna.tif',229,4,61,8.1916315,17.5027394,14.8384478,1.8,17.4969921,14.8635122,-1.3577006,1.8430864,2.8832759,8.2348809,23.1662534,1.3042079,8.0346988,4.4679843,10.8458717,3.4690093,5.7027827,1.3036538,15.4895159),(43061,'ulna.tif',229,4,62,8.2565835,17.4745999,14.826095,1.8,17.4683937,14.8543324,-1.3476765,1.8404205,2.9016209,8.2559023,23.4870207,1.308721,8.0944483,4.4858782,10.9198545,3.4550021,5.734439,1.2841751,15.4614181),(43062,'ulna.tif',229,4,63,8.3903331,17.4421461,14.7929315,1.8,17.435792,14.8217808,-1.3369485,1.8362336,2.9260147,8.370415,23.9590368,1.323302,8.1882831,4.5584697,10.9837699,3.4550021,5.7900001,1.2870022,15.5433011),(43063,'ulna.tif',229,4,64,8.4748691,17.4142178,14.7767175,1.8,17.4103068,14.8045893,-1.3288508,1.8439676,2.9342633,8.340714,24.3787362,1.3313959,8.3082987,4.5232433,11.0678142,3.4484592,5.8280888,1.205049,15.6591011),(43064,'ulna.tif',229,4,65,8.5456754,17.3881163,14.7527234,1.8,17.3845146,14.782717,-1.3225547,1.8406814,2.9643837,8.1820952,24.7718209,1.3382977,8.3564827,4.4451447,11.0923243,3.4268365,5.8456065,1.2897756,15.6111352),(43065,'ulna.tif',229,4,66,8.5860265,17.3560732,14.7253964,1.8,17.3463763,14.7565797,-1.3150952,1.8449752,2.9816254,8.0962155,24.8266922,1.3394625,8.3265632,4.3882516,11.0182966,3.4122448,5.878775,1.2708492,15.5970863),(43066,'ulna.tif',229,4,67,8.6520536,17.3251389,14.7048228,1.8,17.3195037,14.74059,-1.309784,1.850835,2.9924394,8.0206294,25.0920623,1.3459793,8.3851531,4.3335195,11.0281189,3.3962854,5.9029611,1.1993972,15.6789692),(43067,'ulna.tif',229,4,68,8.6626575,17.2849134,14.6811419,1.8,17.2752175,14.7171576,-1.2973325,1.8426836,2.9922386,7.9099154,25.4308576,1.3384718,8.4989404,4.2926065,11.0762865,3.3706564,5.9242199,1.1902899,15.6789692),(43068,'ulna.tif',229,4,69,8.7888946,17.2526019,14.6573351,1.8,17.2419131,14.6937721,-1.2888,1.8537689,3.0208718,7.9449277,25.8979096,1.3513859,8.5729919,4.2858243,11.1722531,3.3705054,5.9707226,1.2245108,15.7269352),(43069,'ulna.tif',229,4,70,8.937424,17.217171,14.6413249,1.8,17.2056518,14.6808689,-1.2770043,1.864851,3.0239151,8.0686531,26.4426933,1.364657,8.7445223,4.3267013,11.3503256,3.380326,5.9995689,1.1849137,15.7128863),(43070,'ulna.tif',229,4,71,9.0851672,17.1809304,14.6172988,1.8,17.1702358,14.653216,-1.2688747,1.8827152,3.0341275,8.1725918,26.9565864,1.380309,8.8844608,4.340854,11.5240491,3.3889082,6.0140795,1.154527,15.7947692),(43071,'ulna.tif',229,4,72,9.3476952,17.1400154,14.5916237,1.8,17.1311968,14.6295093,-1.2645179,1.905191,3.0624193,8.4316821,27.5446812,1.4163165,8.9944188,4.425636,11.6921917,3.4052694,6.0532505,1.1885138,15.9105692),(43072,'ulna.tif',229,4,73,9.5629336,17.0865617,14.565217,1.8,17.0800199,14.6028248,-1.2569554,1.9210382,3.0686874,8.6982359,28.2635139,1.4419239,9.2102944,4.5278827,11.9530842,3.4404908,6.1201697,1.1621778,15.9924522),(43073,'ulna.tif',229,4,74,9.7223252,17.0421896,14.5283268,1.8,17.0351101,14.5686578,-1.248503,1.9396884,3.0864934,8.9305049,28.8759874,1.4578207,9.3555967,4.6040926,12.1156269,3.4687053,6.1434056,1.1535289,16.1082522),(43074,'ulna.tif',229,4,75,9.942852,16.9927318,14.5074202,1.8,16.988606,14.5471474,-1.2386167,1.9604285,3.0890446,9.1693466,29.6327743,1.4809149,9.5928606,4.6772155,12.4191583,3.496285,6.1670975,1.1449458,16.2720181),(43075,'ulna.tif',229,4,76,10.1601076,16.9466952,14.490463,1.8,16.9416346,14.5280105,-1.234353,1.985522,3.0890639,9.4553683,30.3578394,1.5087979,9.8275207,4.7621575,12.7797676,3.521133,6.1963822,1.1573158,16.2720181),(43076,'ulna.tif',229,4,77,10.4032095,16.8993455,14.4711465,1.8,16.89345,14.5160394,-1.2279216,2.005289,3.0897254,9.8011713,31.177903,1.5378931,10.090833,4.8876602,13.1122127,3.5586326,6.1963822,1.1573158,16.3539011),(43077,'ulna.tif',229,4,78,10.7340477,16.852383,14.4429962,1.8,16.8516817,14.4812505,-1.2224577,2.0403515,3.0984061,10.2601935,32.1818214,1.5805693,10.3865732,5.0286401,13.4690227,3.6050519,6.2494462,1.1610384,16.5515841),(43078,'ulna.tif',229,4,79,11.0879653,16.7969355,14.4271424,1.8,16.7985006,14.4644841,-1.2198742,2.0513505,3.1055898,10.7500723,33.2519544,1.62961,10.7071301,5.2404853,13.815629,3.6434553,6.2799484,1.1731683,16.7293989),(43079,'ulna.tif',229,4,80,11.3420948,16.7371005,14.4031566,1.8,16.7424545,14.441282,-1.2113664,2.0384023,3.1304476,11.0054393,33.9358075,1.6564723,10.8405609,5.3990516,13.9105125,3.6442587,6.2964753,1.1441688,16.8112819),(43080,'ulna.tif',229,4,81,11.5458424,16.6898173,14.3653042,1.8,16.7004508,14.4056536,-1.209351,2.0342422,3.1470489,11.3719202,34.5615577,1.6836691,10.9822118,5.5902487,14.1718915,3.6795959,6.325691,1.1562895,16.9270819),(43081,'ulna.tif',229,4,82,11.6988086,16.652737,14.3199865,1.8,16.6643412,14.3611052,-1.2137008,2.0460598,3.1683964,11.6514532,34.9508571,1.7115584,11.0310872,5.694581,14.2399567,3.695069,6.3650511,1.1886008,17.0089648),(43082,'ulna.tif',229,4,83,11.9229046,16.6138817,14.2810248,1.8,16.6306153,14.3272553,-1.2180637,2.0515392,3.1416513,11.8974299,35.4870372,1.7499942,11.2956639,5.7992701,14.5198479,3.7076946,6.3558273,1.1682969,17.0908478),(43083,'ulna.tif',229,4,84,12.1866132,16.5645118,14.2530051,1.8,16.5874389,14.2971224,-1.2257458,2.0368857,3.1308467,12.071588,36.1518302,1.7987255,11.5469818,5.9264925,14.9033465,3.6999157,6.3333709,1.1767084,17.2066478),(43084,'ulna.tif',229,4,85,12.3789214,16.5078857,14.2333716,1.8,16.5346921,14.2808065,-1.2378979,2.033567,3.1536783,12.1881549,36.7386568,1.8428344,11.6494623,5.9934857,15.1901961,3.6937035,6.3227755,1.2055949,17.1727308),(43085,'ulna.tif',229,4,86,12.660494,16.4634858,14.2027034,1.8,16.4955507,14.256706,-1.2512208,2.0205415,3.1772892,12.3646665,37.9160957,1.9018199,11.9334731,6.1194815,15.3277821,3.7064474,6.4020751,1.1516537,17.4043308),(43086,'ulna.tif',229,4,87,12.8615561,16.4129121,14.1655198,1.8,16.4508492,14.2219557,-1.2591367,2.0178196,3.2023345,12.4818968,38.9290892,1.9420364,12.156472,6.1858338,15.4546198,3.7086432,6.4625324,1.175316,17.5201308),(43087,'ulna.tif',229,4,88,13.1156308,16.36373,14.1258675,1.8,16.4028038,14.187984,-1.2679776,2.0164053,3.2315698,12.708109,40.1169231,1.9915423,12.4140667,6.3023586,15.6115407,3.7084922,6.547822,1.1902899,17.7178137),(43088,'ulna.tif',229,4,89,13.3105202,16.3077442,14.0844708,1.8,16.3434574,14.1540589,-1.2775427,2.0254779,3.2785809,12.9455155,41.0529691,2.0330476,12.5215667,6.3913389,15.8324245,3.7339395,6.6016158,1.1935473,18.6185264),(43089,'ulna.tif',229,4,90,13.5831556,16.255165,14.0422963,1.8,16.2886971,14.1113976,-1.288114,2.0301754,3.3350239,13.2612848,42.176374,2.0877235,12.6464982,6.5320881,16.0109065,3.750514,6.6464056,1.2518006,18.2289797),(43090,'ulna.tif',229,4,91,13.8387646,16.2039427,13.9953423,1.8,16.2398181,14.0655513,-1.299442,2.0395857,3.3916167,13.6606158,43.3239202,2.1407565,12.7738256,6.6977405,16.0032406,3.7786796,6.7014092,1.2545102,18.6524434),(43091,'ulna.tif',229,4,92,14.1254388,16.1468473,13.9467119,1.8,16.1829243,14.0224233,-1.3079066,2.0533301,3.4306578,14.0174516,44.2264287,2.1952498,12.8915302,6.8266916,16.276924,3.8179832,6.721639,1.273564,18.6185264),(43092,'ulna.tif',229,4,93,14.4442709,16.0837498,13.9049049,1.8,16.125068,13.9854435,-1.3240032,2.0546472,3.4552109,14.3291619,45.3594282,2.2637054,13.127832,6.9740256,16.4866189,3.8318999,6.7442939,1.2924967,19.1296923),(43093,'ulna.tif',229,4,94,14.7888533,16.0131312,13.8479624,1.8,16.0563652,13.9304327,-1.3298931,2.0554286,3.4715276,14.611412,45.9895771,2.3245111,13.2476484,7.1086934,16.6171773,3.8481256,6.7770213,1.2760662,18.8021604),(43094,'ulna.tif',229,4,95,15.0531599,15.9411585,13.7857474,1.8,15.9842918,13.8673443,-1.3351732,2.0552938,3.5053223,14.8477341,46.7768248,2.3721311,13.3445145,7.2241419,16.7230611,3.8566729,6.8253271,1.3134726,18.8699945),(43095,'ulna.tif',229,4,96,15.3010504,15.8707609,13.7159138,1.8,15.9164944,13.8021657,-1.3351989,2.0538699,3.5162742,15.110898,47.6388188,2.4112243,13.5480953,7.3572811,16.8077326,3.8481256,6.8402915,1.3052867,19.6747753),(43096,'ulna.tif',229,4,97,15.4670958,15.7935816,13.6422235,1.8,15.8432657,13.7312963,-1.3354048,2.0584271,3.5251023,15.35185,48.2238774,2.4376315,13.6801357,7.4580491,17.058157,3.8681276,6.8530222,1.3319651,19.2454923),(43097,'ulna.tif',229,4,98,15.7350897,15.7156889,13.5793052,1.8,15.7680139,13.6715702,-1.3412705,2.0629664,3.5314657,15.7222757,49.1904032,2.4867645,13.9291748,7.6211982,17.2733277,3.8792876,6.8669498,1.3237727,19.5308775),(43098,'ulna.tif',229,4,99,16.0949376,15.6389334,13.5123779,1.8,15.6954415,13.608755,-1.3513748,2.0705403,3.5651783,16.1873926,50.590481,2.5553984,14.1901684,7.8179559,17.5012226,3.9042418,6.8961793,1.3074898,19.9543412),(43099,'ulna.tif',229,4,100,16.4803737,15.5622501,13.4572274,1.8,15.6171252,13.5558543,-1.3654476,2.0731224,3.6106691,16.7227625,52.6397511,2.6325235,14.5789465,8.0664616,17.9586159,3.9248928,6.9655891,1.335898,20.0841901),(43100,'ulna.tif',229,4,101,16.9034084,15.487355,13.4024289,1.8,15.5504974,13.5017559,-1.3822109,2.0884162,3.6667399,17.3583402,54.6172485,2.7182234,14.8953156,8.3117247,18.4610557,3.9730854,7.0288311,1.3717853,19.8865071),(43101,'ulna.tif',229,4,102,17.2665369,15.4041918,13.3340688,1.8,15.4693501,13.4362383,-1.3956507,2.0920226,3.7027386,17.8874189,56.2340846,2.7903771,15.1871603,8.5502991,18.665085,4.006277,7.0638001,1.3894766,20.3017412),(43102,'ulna.tif',229,4,103,17.551339,15.31704,13.2510662,1.8,15.3900434,13.3542271,-1.4007867,2.1052812,3.7386481,18.3634228,57.7167581,2.8414861,15.4378685,8.7225509,19.0085796,4.0253895,7.1106293,1.3989543,20.8889709),(43103,'ulna.tif',229,4,104,17.9336627,15.2276249,13.1700696,1.8,15.3027181,13.2757478,-1.4088689,2.1080476,3.7752515,18.8909425,59.1578088,2.9112548,15.6698987,8.9613451,19.3552828,4.0250328,7.1580888,1.4083072,19.6326286),(43104,'ulna.tif',229,4,105,18.2042863,15.1345706,13.0771155,1.8,15.2090888,13.1805322,-1.4115211,2.104567,3.7981262,19.1907333,60.07786,2.9577268,15.8177629,9.1186138,19.5837922,4.0250328,7.1676833,1.4003356,19.6185797),(43105,'ulna.tif',229,4,106,18.4079882,15.0379614,12.9891586,1.8,15.1156392,13.0877972,-1.4220609,2.1084838,3.8177311,19.5760008,61.1453517,3.0006261,16.0161496,9.284397,19.8792952,4.0283378,7.189399,1.433455,19.9121945),(43106,'ulna.tif',229,4,107,18.7161442,14.9356124,12.9112638,1.8,15.0126755,13.0156892,-1.4326127,2.1177357,3.8199917,19.938254,62.9716537,3.0601723,16.4847619,9.4148924,20.3515443,4.0447337,7.1975546,1.4254863,19.6864138),(43107,'ulna.tif',229,4,108,19.0319952,14.8310944,12.8249729,1.8,14.9091519,12.9314108,-1.4411122,2.1242039,3.8589713,20.3421636,64.6363368,3.118951,16.7496287,9.5763705,20.7341698,4.0447337,7.2467581,1.4345489,19.7062819),(43108,'ulna.tif',229,4,109,19.3857808,14.7240201,12.7482315,1.8,14.8029185,12.8557333,-1.4503231,2.1295666,3.9250988,20.914309,66.330991,3.1842964,16.8991901,9.8209229,21.0549429,4.0569141,7.3121535,1.4277795,19.8220819),(43109,'ulna.tif',229,4,110,19.6985976,14.6115711,12.6651023,1.8,14.6918127,12.7698486,-1.4583372,2.1356735,3.9471669,21.4644848,67.6633119,3.2417528,17.1422476,10.0504524,21.2498808,4.0771576,7.3402953,1.4601391,19.9039649),(43110,'ulna.tif',229,4,111,20.1186597,14.4952435,12.5914868,1.8,14.5738867,12.6926444,-1.4678461,2.1319957,3.968967,22.1048448,69.7672182,3.3176965,17.5781804,10.3681471,21.7496313,4.0716604,7.3808308,1.4843978,20.1156967),(43111,'ulna.tif',229,4,112,20.4964319,14.3709887,12.5074616,1.8,14.4471435,12.6080414,-1.4745391,2.1386543,3.9508441,22.7939858,71.6227226,3.3845181,18.1284608,10.6580972,22.5040199,4.0947586,7.3808308,1.4843978,20.1835308),(43112,'ulna.tif',229,4,113,20.8453578,14.2470909,12.4241953,1.8,14.3206387,12.518496,-1.4793644,2.1506675,3.9289414,23.4391813,73.5128045,3.4452633,18.7105881,10.8985614,23.4336649,4.1152863,7.3860523,1.4765878,20.121516),(43113,'ulna.tif',229,4,114,21.0857112,14.1181326,12.3287639,1.8,14.1937005,12.4253923,-1.4840956,2.1445351,3.9230312,23.968704,74.5789808,3.4879344,19.0105498,11.1766431,23.7457883,4.1208766,7.3917237,1.4687894,20.155433),(43114,'ulna.tif',229,4,115,21.37355,13.9826213,12.2339921,1.8,14.056674,12.328968,-1.4838133,2.1441783,3.9000742,24.4345062,75.2735215,3.535374,19.300536,11.3957436,24.112063,4.1288935,7.3860523,1.4765878,20.237316),(43115,'ulna.tif',229,4,116,21.6066517,13.8458789,12.1418985,1.8,13.9176196,12.2318255,-1.4831713,2.1454001,3.9062831,24.891637,75.8167748,3.5735295,19.40893,11.6023286,24.1285965,4.1274311,7.4193378,1.617637,20.3390671),(43116,'ulna.tif',229,4,117,21.6790367,13.7033186,12.0318642,1.8,13.7747873,12.1197329,-1.4720743,2.1346896,3.7785138,25.066456,74.8451162,3.5780729,19.8080835,11.7424362,24.259681,4.1274836,7.2765352,1.6744238,20.1951693),(43117,'ulna.tif',229,4,118,21.7806203,13.5548331,11.9187019,1.8,13.6183326,12.0076308,-1.4653813,2.1268505,3.7120174,25.3243276,74.1144695,3.5899137,19.9660888,11.906962,24.647732,4.1316887,7.202909,1.4903253,20.1951693),(43118,'ulna.tif',229,4,119,21.8891324,13.4031422,11.8175636,1.8,13.4630088,11.9076025,-1.461099,2.1132739,3.6814975,25.6556164,74.9383479,3.604464,20.3553982,12.140223,25.0632868,4.1306702,7.1501226,1.4816027,20.1670715),(43119,'ulna.tif',229,4,120,22.0919263,13.2519022,11.7201775,1.8,13.3128447,11.8081465,-1.4518613,2.104111,3.608802,25.9004656,75.6580473,3.6301491,20.964865,12.309458,25.6949695,4.1367079,7.0978883,1.472751,20.1331545),(43120,'ulna.tif',229,4,121,22.2189812,13.0989558,11.6274302,1.8,13.1574775,11.7166432,-1.4394822,2.0969339,3.5147317,26.0549071,76.4403316,3.6396746,21.7485536,12.4252404,26.3591821,4.1377264,7.0728115,1.1401038,20.1050567),(43121,'ulna.tif',229,4,122,22.3154762,12.9447703,11.543298,1.8,13.0048672,11.6452946,-1.428174,2.0916447,3.4561971,26.1228216,77.3818442,3.644104,22.3893028,12.4891293,27.0044482,4.1377264,7.1618345,1.1722739,20.0910078),(43122,'ulna.tif',229,4,123,22.3722115,12.7879401,11.4766909,1.8,12.8472341,11.5817649,-1.4248575,2.0883047,3.5094089,26.2180394,78.6497921,3.6498496,22.4111224,12.5547,27.9979741,4.1354479,7.2310124,1.150133,19.9950759),(43123,'ulna.tif',229,4,124,22.2515638,12.62917,11.412526,1.8,12.6871965,11.5094688,-1.4167925,2.1043476,3.5965523,25.9466322,80.2092273,3.6213298,22.301699,12.3300123,28.753519,4.1172469,7.3316126,1.1389401,20.06291),(43124,'ulna.tif',229,4,125,22.1882694,12.4713457,11.3446641,1.8,12.5258398,11.4412217,-1.4039907,2.1241656,3.6916513,25.5666563,81.3028386,3.5961008,22.023434,12.0360939,28.6696657,4.104138,7.4132353,1.152572,20.0430418),(43125,'ulna.tif',229,4,126,22.1918294,12.3115146,11.2915734,1.8,12.3580275,11.3829162,-1.3930424,2.1340077,3.779941,25.2652264,82.3046612,3.583,21.7740598,11.8393326,28.2863811,4.0943705,7.4735871,1.1730255,20.1530226),(43126,'ulna.tif',229,4,127,22.2595069,12.1569329,11.2316019,1.8,12.1931457,11.3216032,-1.3783217,2.0807275,3.8717967,24.6729802,84.0068882,3.5741673,21.697133,11.8578624,27.9910832,4.0661455,7.5585562,1.1860226,20.1530226),(43127,'ulna.tif',229,4,128,22.2047859,12.0026089,11.2092145,1.8,12.0380672,11.2816717,-1.3746297,2.0663132,3.9546226,24.3049268,86.5327579,3.5602034,21.8814199,11.7624602,27.8303048,4.051611,7.7096193,1.1777383,20.2828715),(43128,'ulna.tif',229,4,129,22.2334344,11.8553494,11.1998813,1.8,11.8906616,11.2732563,-1.3743872,2.0562109,4.0713249,24.1043398,89.7627012,3.5644529,22.0475404,11.7226982,27.8237302,4.0296728,7.8611912,1.169773,20.4466374),(43129,'ulna.tif',229,4,130,22.1885069,11.7041547,11.1796441,1.8,11.7363543,11.2447539,-1.3726315,2.0429626,4.1872826,23.7717239,92.7341338,3.5547543,22.1466143,11.6359073,27.5560634,4.0087458,8.0530971,1.1876197,20.7543011),(43130,'ulna.tif',229,4,131,22.1962616,11.5553316,11.1896172,1.8,11.5841797,11.2442531,-1.3722992,2.0441545,4.3072238,23.4798436,95.4391469,3.5555218,22.157926,11.486335,27.5191577,3.9774358,8.2040439,1.1798054,20.9040182),(43131,'ulna.tif',229,4,132,22.7117949,11.4186075,11.2205031,1.8,11.4422199,11.2657609,-1.3754531,2.0651121,4.4078175,23.6221951,99.5274599,3.6426839,22.5797597,11.4386988,27.8014467,3.9640492,8.3353883,1.2160907,21.0677841),(43132,'ulna.tif',229,4,133,22.8749388,11.282432,11.2570965,1.8,11.3054134,11.2949094,-1.3794181,2.0719873,4.5019541,23.7171338,103.9695664,3.6745514,23.0943197,11.4465635,28.1643509,3.9496196,8.4984894,1.2231895,21.1835841),(43133,'ulna.tif',229,4,134,23.0861895,11.1518759,11.3182689,1.8,11.1714383,11.3424574,-1.3905531,2.0946892,4.5933979,24.0338339,108.9478113,3.7240435,23.7183485,11.4736992,28.7850096,3.9369258,8.6340919,1.2002523,21.3812671),(43134,'ulna.tif',229,4,135,23.2252281,11.0147379,11.4068304,1.8,11.02969,11.4197473,-1.4018203,2.1327604,4.6678844,24.601943,115.7534515,3.7613947,24.7978403,11.5352587,29.8905838,3.9535384,8.8078443,1.2635978,21.9345797),(43135,'ulna.tif',229,4,136,23.7546949,10.8922717,11.5055328,1.8,10.9038466,11.5036099,-1.4181649,2.1877435,4.7408443,25.8154757,125.7328987,3.8675969,26.5212038,11.800047,31.6921052,4.029181,8.9931581,1.2225754,22.3498138),(43136,'ulna.tif',229,4,137,24.3798409,10.7789587,11.6455621,1.8,10.7823974,11.6284699,-1.4376746,2.2624626,4.7768174,27.6222838,137.5615647,3.9917237,28.7977437,12.2089461,34.0693742,4.1278676,9.1739988,1.2630169,22.7650479),(43137,'ulna.tif',229,4,138,25.020672,10.6638225,11.7942479,1.8,10.6572858,11.7919694,-1.4529008,2.3326748,4.9035355,29.7025709,153.5977323,4.1124182,31.323875,12.7332668,36.7841359,4.2575489,9.4334366,1.2781638,23.5698286),(43138,'ulna.tif',229,4,139,25.529222,10.5487808,11.9674511,1.8,10.5453173,11.9397947,-1.4745398,2.4204725,5.0622207,31.9345695,173.9166526,4.2155692,34.3558024,13.1935272,39.8405792,4.3631365,9.7907514,1.3014323,24.4424435),(43139,'ulna.tif',229,4,140,25.9560157,10.4231844,12.2387215,1.8,10.4184939,12.1808926,-1.4905296,2.5391059,5.2654155,34.616434,201.2830157,4.2981911,38.2273759,13.6333165,44.3663973,4.5215178,10.2196371,1.3711785,25.656639),(43140,'ulna.tif',229,4,141,26.8120556,10.3315198,12.6087529,1.8,10.3351701,12.5154529,-1.5132634,2.6266243,5.5050743,37.9381987,243.9508382,4.4539007,44.3138142,14.4437097,50.8029548,4.6822667,10.8334908,1.420585,26.9924539),(43141,'ulna.tif',229,4,142,26.9545476,10.2438189,12.9266814,1.8,10.2838653,12.8263025,-1.5281126,2.7523069,5.8595332,41.5968128,290.5031993,4.4842448,49.5778742,15.1134354,56.472756,4.8722107,11.5129314,1.4345891,31.2455473),(43142,'ulna.tif',229,4,143,27.5537552,10.1364234,13.3275068,1.8,10.1959859,13.2343287,-1.5341825,2.9035908,6.0799057,47.0737459,350.1379576,4.586139,57.5893729,16.2122521,64.966331,5.110833,12.2295164,1.3706153,35.2588111),(43143,'ulna.tif',229,4,144,29.219804,10.0042885,13.9246132,1.8,10.0464427,13.8102347,-1.5396357,2.9683924,6.6516363,52.9802145,429.2520828,4.8652402,64.5333059,17.8481171,72.1893193,5.2252768,13.1956121,1.3854484,38.9435445),(43144,'ulna.tif',229,4,145,30.304952,9.8885575,14.4498131,1.8,9.9289652,14.302815,-1.5423575,3.5202232,7.2245651,57.8654324,496.1005948,5.0467415,68.6685751,16.4380008,76.5991409,5.922423,13.8138529,1.4235644,37.3305742),(43145,'ulna.tif',229,4,146,31.4932776,9.8593924,15.1550475,1.8,9.9063673,15.110041,-1.5384946,3.9248487,7.700108,78.5050305,565.8764336,5.2434048,73.489415,20.0020526,83.6151985,6.5344711,14.5163973,1.3984347,38.2312868),(43146,'ulna.tif',229,4,147,31.7415852,9.7640912,15.9440138,1.8,9.850053,15.9284446,-1.538364,4.5506898,8.295652,100.1618713,651.3206696,5.2847016,78.5134995,22.0102611,90.5115171,7.3926396,14.9107959,1.4618544,41.1708439),(43147,'ulna.tif',229,4,148,31.956469,9.83859,16.079932,1.8,9.9166036,16.1433066,1.5482714,4.8515582,8.3874397,109.2461404,632.9009535,5.3233763,75.4581823,22.5177427,88.4373586,7.9291417,14.8675657,1.648763,41.9077906),(43148,'ulna.tif',229,4,149,31.4340107,10.0041214,15.8795319,1.8,10.0849239,15.9605521,1.4777418,5.007112,8.1491892,115.7375689,560.9564782,5.1937673,68.8358639,23.1146354,83.034658,8.2920742,14.6682541,1.6736072,42.4073181),(43149,'ulna.tif',229,4,150,30.6348884,10.0899756,15.6092927,1.8,10.1647531,15.6261664,1.4181207,5.1448204,7.7397254,123.272639,478.9960616,4.9877208,61.8879919,23.9605329,77.794337,8.6215098,14.0402428,1.7406907,41.2071714),(43150,'ulna.tif',229,4,151,28.8892543,9.9983863,15.1230512,1.8,10.0807078,15.0770986,1.4141505,5.3145449,7.0788401,121.2682025,353.7663893,4.697692,49.9751912,22.8181727,67.076304,8.845277,12.0933407,1.7634971,38.0020972),(43151,'ulna.tif',229,4,152,26.7521329,9.861362,14.9165335,1.8,9.9390149,14.8200053,1.4002378,5.1824087,6.618159,112.6939197,297.9649807,4.3302374,45.0223362,21.7454711,61.9649203,8.6748985,11.2665724,1.3532422,36.8159994),(43152,'ulna.tif',229,4,153,24.20012,9.5938911,14.819075,1.8,9.6401066,14.676643,1.4005919,4.9615899,6.1458878,84.8489196,263.1297095,3.9176328,42.8139464,17.1011552,56.2960918,8.3347261,10.8274549,1.3167388,34.681223),(43153,'ulna.tif',229,4,154,22.3249356,9.3339145,14.8274838,1.8,9.3248823,14.6914495,1.3954259,4.0369038,5.8771264,65.2135053,239.83421,3.6075579,40.8080741,16.1543371,51.5054911,7.1928675,10.504024,1.3258177,32.6026423),(43154,'ulna.tif',229,4,155,22.1936974,9.1622761,14.9426814,1.8,9.1750061,14.8364765,1.38739,3.8011197,5.7572631,58.8443561,229.463073,3.5759136,39.8562772,15.4807954,49.851479,6.7644669,10.2835682,1.297137,31.8375978),(43155,'ulna.tif',229,4,156,22.565226,9.0343198,15.1809751,1.8,9.0567576,15.0975174,1.3861186,3.7818691,5.8085712,56.5961578,225.5499992,3.6340548,38.830547,14.9651286,48.4300705,6.6235536,10.142421,1.3521274,31.3545296),(43156,'ulna.tif',229,4,157,22.9921604,9.0044594,15.5230973,1.8,9.0247832,15.4340926,1.3683983,4.0525465,5.8844267,60.2113155,231.0789252,3.6771797,39.2695729,14.8576496,49.268267,6.7404358,10.1564589,1.2995443,31.8855637),(43157,'ulna.tif',229,4,158,25.3900771,9.0344863,16.0849047,1.8,9.043423,16.0277236,1.3356653,4.5818543,6.2342398,71.2174795,260.850036,4.0020043,41.8415146,15.5433751,52.9406745,7.1278289,10.7818445,1.9912017,34.1419593),(43158,'ulna.tif',229,4,159,30.6283698,9.2573547,17.0303893,1.8,9.2356228,16.981349,1.2786824,5.2445862,7.0101551,97.9084735,367.2677393,4.6813887,52.3908153,18.6684839,66.1018703,7.7160029,12.5450744,1.9144412,37.6067313),(43159,'ulna.tif',229,4,160,32.7266403,9.1676108,17.4775216,1.8,9.1798038,17.4879331,1.3087999,5.1409333,7.1850129,134.166864,388.1574367,5.0885244,54.0232069,26.097764,72.2969693,8.392419,12.54307,1.8370484,38.8209269),(43160,'ulna.tif',229,4,161,33.6589639,8.9523005,17.7359988,1.8,9.0106224,17.7465582,1.416292,4.421687,7.0560647,156.7415668,409.3098432,5.476974,58.0082327,35.4483636,78.9166056,8.4826175,12.4238345,1.7535677,38.4197417),(43161,'ulna.tif',229,4,162,31.4659424,8.7591717,17.6065146,1.8,8.7917905,17.6464179,1.450572,4.67906,6.5937384,133.4979847,363.5414991,5.1688873,55.1343528,28.5309409,73.4945253,8.3427784,12.0887658,1.7343702,38.3800054),(43162,'ulna.tif',229,4,163,25.0283292,8.1054541,17.3791622,1.8,8.0979524,17.4686864,1.4493557,2.8176981,6.0242838,51.9990273,301.0518703,4.1101711,49.9730556,18.4544351,57.7914895,5.6486468,11.6850464,1.7049851,32.7184423),(43163,'ulna.tif',229,4,164,22.5155217,7.8380581,17.0459576,1.8,7.8489724,17.09619,1.4391667,2.5968983,5.5417304,36.6404374,243.1029566,3.6879429,43.8676984,14.1093077,49.830393,4.9992013,11.0052656,1.7186457,30.2900511),(43164,'ulna.tif',229,4,165,20.5961941,7.6623592,16.7312011,1.8,7.6767536,16.7353956,1.4078839,2.5397765,5.3786277,28.9788275,195.6594478,3.3423968,36.3772062,11.4099913,41.1933613,4.7693856,10.2706833,1.7350182,28.0254258),(43165,'ulna.tif',229,4,166,19.4869173,7.497871,16.5843055,1.8,7.5088609,16.5768946,1.3600647,2.5068926,5.0692876,26.1385902,156.5477564,3.1057133,30.8816088,10.4266892,35.5779562,4.7776834,9.6291722,1.7705504,26.1222495),(43166,'ulna.tif',229,4,167,18.7728407,7.2733493,16.5106089,1.8,7.2684601,16.5586643,1.3277466,2.5224836,4.9409894,25.6316182,132.1133489,2.9475892,26.7382374,10.1612624,31.5873868,4.9140529,9.1564416,1.8265108,24.9502006),(43167,'ulna.tif',229,4,168,18.8925421,7.0983116,16.5802398,1.8,7.0855738,16.6642788,1.3000178,2.5632412,4.7932878,27.014467,117.118275,2.9234747,24.4338084,10.5391827,29.8398873,5.0259562,8.8259051,1.9049944,23.9278687),(43168,'ulna.tif',229,4,169,18.9860835,6.9443606,16.739437,1.8,6.915644,16.8403605,1.2960436,2.5926876,4.6173474,29.1316325,103.008807,2.9314243,22.3090874,11.2360752,28.4799674,5.0499969,8.4244003,1.8708112,23.5126346),(43169,'ulna.tif',229,4,170,19.2581292,6.8021289,16.9757393,1.8,6.785384,17.0718078,1.2869403,2.5332839,4.4352749,32.2625927,96.8773302,2.9579418,21.8424633,12.7354825,29.1142067,5.0535676,8.1324256,1.9195673,22.0469709),(43170,'ulna.tif',229,4,171,20.3524898,6.7258374,17.2174564,1.8,6.6984425,17.3445696,1.2621131,2.8686643,4.3157392,37.6820869,94.2623384,3.0790024,21.8415279,13.1357606,30.5362664,5.5045436,7.9071137,1.9853032,22.0130538),(43171,'ulna.tif',229,4,172,21.5267604,6.5646838,17.4710956,1.8,6.5796313,17.6478648,1.1996721,2.9307857,4.2628369,44.1874981,90.5538657,3.11591,21.2426297,15.0770144,31.6055405,5.7321001,7.727427,2.0880837,21.7615857),(43172,'ulna.tif',229,4,173,22.1009979,6.4017948,17.6958128,1.8,6.4631391,17.8891036,1.1211444,2.975125,4.0201246,45.5730451,80.799653,2.987604,20.0987932,15.318027,31.4033726,5.8005305,7.3110072,2.0840486,21.4001368),(43173,'ulna.tif',229,4,174,22.1503337,6.3278684,17.9365271,1.8,6.3968302,18.108612,1.0903955,2.699317,3.7595358,39.5130213,68.5317053,2.9032868,18.2287679,14.6381551,28.7258798,5.3991895,6.8742689,2.1401095,20.1602538),(43174,'ulna.tif',229,4,175,20.2300511,6.3728569,18.1696437,1.8,6.4211285,18.2872025,1.1828907,2.2353524,3.4090108,25.8833543,54.9342292,2.8892781,16.1144194,11.5790936,23.2930156,4.4799691,6.5057034,2.1341126,18.7004093),(43175,'ulna.tif',229,4,176,12.6387563,6.3108253,18.0768021,1.8,6.3156806,18.1170403,1.2437437,1.8360197,3.0650784,7.7646893,26.2358557,1.889065,8.5596035,4.2290882,11.0906801,3.5055206,5.6992544,1.9343232,16.5224879),(43176,'ulna.tif',229,4,177,0.9623488,5.7587621,17.187838,1.8,5.7496047,17.1845488,1.1323983,0.699446,1.0734563,0.0766514,0.3428214,0.1314903,0.3193622,0.1095887,0.3619566,0.9830766,1.5198061,2.8318897,4.0297231),(43177,'ulna.tif',229,4,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43178,'ulna.tif',229,4,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43179,'ulna.tif',229,4,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43180,'ulna.tif',229,4,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43181,'ulna.tif',229,4,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43182,'ulna.tif',229,4,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43183,'ulna.tif',229,4,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43184,'ulna.tif',229,4,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43185,'metacarpus.tif',229,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43186,'metacarpus.tif',229,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43187,'metacarpus.tif',229,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43188,'metacarpus.tif',229,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43189,'metacarpus.tif',229,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43190,'metacarpus.tif',229,5,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43191,'metacarpus.tif',229,5,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43192,'metacarpus.tif',229,5,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43193,'metacarpus.tif',229,5,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43194,'metacarpus.tif',229,5,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43195,'metacarpus.tif',229,5,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43196,'metacarpus.tif',229,5,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43197,'metacarpus.tif',229,5,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43198,'metacarpus.tif',229,5,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43199,'metacarpus.tif',229,5,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43200,'metacarpus.tif',229,5,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43201,'metacarpus.tif',229,5,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43202,'metacarpus.tif',229,5,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43203,'metacarpus.tif',229,5,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43204,'metacarpus.tif',229,5,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43205,'metacarpus.tif',229,5,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43206,'metacarpus.tif',229,5,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43207,'metacarpus.tif',229,5,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43208,'metacarpus.tif',229,5,24,0.1078881,6.45972,4.1336908,1.8,6.4451474,4.1380718,0.0951397,0.2344167,0.3509025,0.0013903,0.0026346,0.0001623,0.0075082,0.0059307,0.0114187,0.4824,0.7123458,2.8555412,1.8841764),(43209,'metacarpus.tif',229,5,25,1.6543455,6.2529942,4.390795,1.8,6.2391443,4.4220002,0.1786063,0.7681309,0.9364245,0.194743,0.3056923,0.0087025,0.3264463,0.2535283,0.532213,1.4472001,1.8722155,0.2606024,5.5095639),(43210,'metacarpus.tif',229,5,26,3.3672772,6.2669875,4.6999754,1.8,6.3109088,4.7280004,0.1639896,1.0350492,1.9669266,0.8963766,1.581231,0.0149577,0.8039095,0.8660231,1.2156815,2.1088181,3.3830158,2.789776,9.6701625),(43211,'metacarpus.tif',229,5,27,5.5233138,6.4908398,5.1116504,1.8,6.4898129,5.1452443,0.282078,1.4892795,2.1061882,2.5947982,5.6716432,0.0713243,2.6928473,1.7423179,3.9244118,2.8953223,3.9537269,2.3202388,13.5384236),(43212,'metacarpus.tif',229,5,28,8.4696291,6.5568296,5.8149506,1.8,6.4925679,5.8026588,1.0687477,2.1461622,2.6878804,8.268808,11.0104273,1.0847125,4.0963234,3.8528346,7.1726485,4.082579,4.9124665,2.2110241,14.587664),(43213,'metacarpus.tif',229,5,29,9.067242,6.4887672,6.0047469,1.8,6.4483359,5.9498471,1.2618748,2.2800591,2.9013187,9.9152843,13.5825758,1.3715185,4.681518,4.3486962,8.0516525,4.18701,5.1134655,2.2111528,15.7189779),(43214,'metacarpus.tif',229,5,30,8.119713,6.4425594,6.0052746,1.8,6.4202239,5.9852134,1.2609525,2.3393214,2.8742507,9.2252181,13.7335949,1.2274704,4.7781479,3.9435445,7.9267847,4.1404523,5.0984316,2.1937956,15.7522806),(43215,'metacarpus.tif',229,5,31,7.3762184,6.4525087,5.9668088,1.8,6.4155016,5.9804182,1.3075271,2.3658776,2.8020613,8.5673136,12.1501087,1.1461118,4.3361324,3.621199,7.2306354,4.1004001,4.9873931,1.6030432,15.6540459),(43216,'metacarpus.tif',229,5,32,7.3044425,6.5118679,5.9528135,1.8,6.4806858,5.9736739,1.1845453,2.3207558,2.8113101,8.5604978,11.1579495,1.0446367,3.9689501,3.6886681,6.9773955,4.1004001,4.9085173,1.611757,15.6167028),(43217,'metacarpus.tif',229,5,33,7.3162368,6.593439,5.9494414,1.8,6.561698,5.9640575,0.9644262,2.5286873,2.7968461,8.5497602,10.4476718,0.8233536,3.735519,3.3811061,6.785255,4.1221196,4.8141075,2.4211916,15.4128459),(43218,'metacarpus.tif',229,5,34,7.0568502,6.6568925,5.968695,1.8,6.6167923,5.9801845,0.7214602,2.5377503,2.6716791,8.2858943,9.519195,0.5130756,3.5630009,3.265055,6.4490915,4.1717446,4.749218,2.3861257,15.0148862),(43219,'metacarpus.tif',229,5,35,6.9164588,6.7405956,6.0195524,1.8,6.7170992,6.0304821,0.0844082,2.1403338,2.2068,7.8818983,8.9325018,0.0081935,4.0477169,3.6825556,7.0602493,3.9623004,4.3184607,0.422005,13.8933264),(43220,'metacarpus.tif',229,5,36,6.9304449,6.7621066,6.0494085,1.8,6.7564594,6.0564348,-0.1261483,2.1059727,2.2329537,7.7669346,8.9359564,0.0182838,4.0018547,3.6880509,7.3827321,3.8141375,4.3156532,0.4428173,13.5286695),(43221,'metacarpus.tif',229,5,37,6.9345696,6.7675687,6.0564031,1.8,6.7849179,6.0607009,-0.1092024,2.0510233,2.2174907,7.7191998,8.830131,0.0137279,3.9820374,3.7635847,7.4597329,3.7686956,4.3044047,3.1042269,13.3914181),(43222,'metacarpus.tif',229,5,38,6.8529084,6.7201076,6.0596379,1.8,6.7675195,6.060738,-0.0931491,1.9898649,2.2236675,7.4564495,8.4447278,0.0098815,3.7976575,3.7472139,7.1429718,3.7183551,4.3081575,3.0855766,13.2541667),(43223,'metacarpus.tif',229,5,39,6.9318371,6.6888259,6.0455404,1.8,6.7129465,6.0513173,-0.0599307,1.9385728,2.1342185,7.1363818,8.42424,0.0041445,3.9472247,3.6812555,7.2136036,3.6661342,4.3060939,3.0948976,13.1364236),(43224,'metacarpus.tif',229,5,40,6.8432689,6.6098985,6.0377516,1.8,6.6279948,6.0433134,-0.1245904,1.8747321,2.1151008,6.7728437,7.9494666,0.017613,3.7584339,3.6126994,6.8227716,3.5708879,4.1563769,0.0871573,12.8659611),(43225,'metacarpus.tif',229,5,41,6.7353863,6.5435527,6.0291295,1.8,6.5559228,6.0385822,-0.1959032,1.810602,2.0417105,6.3091922,7.6110129,0.0425335,3.7277631,3.4845825,6.6439129,3.4572001,4.0683514,0.2090229,12.6052528),(43226,'metacarpus.tif',229,5,42,6.5329547,6.481077,6.0307389,1.8,6.4937044,6.0362268,-0.2781003,1.7306265,2.0126123,5.6823132,7.1413089,0.0820609,3.5482786,3.2833852,6.2777162,3.3665722,4.016984,0.2425515,12.1504417),(43227,'metacarpus.tif',229,5,43,6.2741018,6.4147454,6.0365171,1.8,6.4217177,6.0418471,-0.337164,1.6957828,1.9802201,5.0363413,6.5658418,0.1144361,3.3157132,2.9699212,5.8129293,3.2788459,3.9161487,0.3022725,11.8385959),(43228,'metacarpus.tif',229,5,44,6.1535663,6.3800169,6.0503215,1.8,6.3851236,6.0511415,-0.3230071,1.6170941,1.9120355,4.6527289,6.0606164,0.103334,3.1697195,2.877216,5.5256959,3.2109887,3.8221725,0.2551824,11.5307903),(43229,'metacarpus.tif',229,5,45,6.0156479,6.3486714,6.0588485,1.8,6.3574179,6.0579866,-0.345128,1.5996806,1.8733617,4.3364283,5.6130641,0.114757,2.9962522,2.7108089,5.2287818,3.1546357,3.7375193,0.3285532,11.2798362),(43230,'metacarpus.tif',229,5,46,5.842538,6.3157142,6.0659377,1.8,6.3241335,6.0594107,-0.3963268,1.5681536,1.8562222,4.0262842,5.1976829,0.1451102,2.8001404,2.5675317,4.9343376,3.1128236,3.6511252,0.3600593,10.9915389),(43231,'metacarpus.tif',229,5,47,5.6793894,6.2858121,6.0598035,1.8,6.2907559,6.0576134,-0.4122075,1.5409233,1.8100783,3.7692372,4.8513596,0.15193,2.6801932,2.4460901,4.7288324,3.0615954,3.5617292,0.3574497,10.7974361),(43232,'metacarpus.tif',229,5,48,5.5583245,6.261458,6.058564,1.8,6.2638212,6.0553524,-0.4657947,1.5131602,1.7657414,3.5743381,4.5489209,0.1868713,2.5762101,2.3621676,4.5769697,3.0386249,3.4788683,0.3912356,10.5797847),(43233,'metacarpus.tif',229,5,49,5.5049653,6.234128,6.0637479,1.8,6.2340213,6.0593771,-0.5249014,1.5157441,1.7189109,3.4500553,4.277591,0.2304093,2.4885472,2.2761462,4.4915288,2.9846978,3.4001693,0.4266275,10.3718875),(43234,'metacarpus.tif',229,5,50,5.4205252,6.2039656,6.0631298,1.8,6.2025321,6.0594858,-0.5689544,1.5019029,1.6591285,3.3729846,4.0509355,0.2622207,2.4416044,2.2458074,4.464219,2.9562721,3.3259276,0.1333503,10.2443903),(43235,'metacarpus.tif',229,5,51,5.3020405,6.1791753,6.063711,1.8,6.1791867,6.0607815,-0.6188464,1.4977327,1.6042763,3.3239534,3.8518707,0.297366,2.4010021,2.2193235,4.4060155,2.9278464,3.2759918,0.2479548,10.116893),(43236,'metacarpus.tif',229,5,52,5.200778,6.1597453,6.0612162,1.8,6.1579744,6.0578593,-0.7460475,1.4672083,1.5193275,3.3031342,3.6824977,0.3993243,2.4237682,2.2513055,4.3825886,2.9278464,3.2180095,0.2267988,10.036493),(43237,'metacarpus.tif',229,5,53,5.1527667,6.1411717,6.0593825,1.8,6.138964,6.053646,-0.9596945,1.4613449,1.5315507,3.2917689,3.5996162,0.5760688,2.3503083,2.2525613,4.3600974,2.9258332,3.1724908,0.1526493,10.0031903),(43238,'metacarpus.tif',229,5,54,5.0829975,6.1293142,6.057857,1.8,6.1258857,6.0532675,-1.2100308,1.5468931,1.5240835,3.2586993,3.5718997,0.7416073,2.3436378,2.1066092,4.2897888,2.9372007,3.1221714,1.7782926,9.9796416),(43239,'metacarpus.tif',229,5,55,4.9960427,6.1199368,6.0565811,1.8,6.1130901,6.0523928,-1.3903321,1.5602373,1.5488761,3.2010228,3.5761323,0.8058489,2.3088562,2.0516257,4.2412182,2.95356,3.1392057,1.7380503,9.9463389),(43240,'metacarpus.tif',229,5,56,4.934174,6.1137763,6.0568925,1.8,6.1071956,6.0520675,-1.4915488,1.5505771,1.5830554,3.1666421,3.6251125,0.8172085,2.2899468,2.0422346,4.2097518,2.9766013,3.1724908,1.7234457,10.0031903),(43241,'metacarpus.tif',229,5,57,4.9119174,6.1023678,6.0561793,1.8,6.0965334,6.0511419,1.5668555,1.5189775,1.5953608,3.1454686,3.7093457,0.8186402,2.3250826,2.0707803,4.1982865,2.9903456,3.201142,1.696709,10.0600417),(43242,'metacarpus.tif',229,5,58,4.8976151,6.0945234,6.0576522,1.8,6.0845745,6.0540791,1.5169022,1.5080387,1.6139352,3.1222056,3.8145139,0.8139006,2.3634864,2.070375,4.2258137,2.9847114,3.2325401,1.7584361,10.1071389),(43243,'metacarpus.tif',229,5,59,4.9402117,6.088097,6.0578451,1.8,6.0781729,6.0554322,1.4974292,1.481526,1.6533831,3.1184228,3.9712444,0.8189446,2.40189,2.1048722,4.2631806,2.9846093,3.2796895,1.7681919,10.1542361),(43244,'metacarpus.tif',229,5,60,4.9792805,6.0793343,6.0634606,1.8,6.0679317,6.0633167,1.4878833,1.4859467,1.6665416,3.1174412,4.1539257,0.8241881,2.4925425,2.0979496,4.3208642,2.9739632,3.3191182,1.7658166,10.2679389),(43245,'metacarpus.tif',229,5,61,5.0652864,6.071541,6.0761593,1.8,6.0597656,6.0755205,1.4921575,1.4882509,1.7113343,3.137667,4.4017024,0.8390045,2.572088,2.1082918,4.3889991,2.9694878,3.3712921,1.7143797,10.3385847),(43246,'metacarpus.tif',229,5,62,5.0892627,6.0711869,6.0853717,1.8,6.0577367,6.0786828,1.5046473,1.4894799,1.7291408,3.1764366,4.6339771,0.8445043,2.6799305,2.1325811,4.4370401,2.9748001,3.4321009,1.8072525,10.4425334),(43247,'metacarpus.tif',229,5,63,5.1291364,6.0744758,6.0949836,1.8,6.0598101,6.0845107,1.5143143,1.4866971,1.7735225,3.2162422,4.9168086,0.8521318,2.7723408,2.1633473,4.5187705,2.9748001,3.4964759,1.7208233,10.6033334),(43248,'metacarpus.tif',229,5,64,5.1925082,6.0755296,6.1049074,1.8,6.0604993,6.0939605,1.5243402,1.4876841,1.8204776,3.2724939,5.2554952,0.8635517,2.8868772,2.1997237,4.6123825,2.9748001,3.5759929,1.7174628,10.7170361),(43249,'metacarpus.tif',229,5,65,5.2763851,6.0798207,6.1122191,1.8,6.0643201,6.1019262,1.5401762,1.4832962,1.8615224,3.3286968,5.6457493,0.8785733,3.0328667,2.2441214,4.7536275,2.9748001,3.6555486,1.7142486,10.8778361),(43250,'metacarpus.tif',229,5,66,5.4009189,6.0829142,6.1011378,1.8,6.0645013,6.093651,1.5531031,1.47927,1.8864694,3.4056601,6.078903,0.8998714,3.2223703,2.3022572,4.9474124,2.9748001,3.7351405,1.7111713,11.0386361),(43251,'metacarpus.tif',229,5,67,5.4567427,6.0915672,6.1077879,1.8,6.0701904,6.102239,1.5607712,1.5077432,1.9307322,3.4879156,6.4970622,0.9093657,3.3650769,2.3133353,5.0821548,2.9935185,3.8360998,1.6652513,11.2895903),(43252,'metacarpus.tif',229,5,68,5.4736452,6.1076313,6.1086947,1.8,6.0829011,6.1039241,1.5625895,1.4924141,1.9716346,3.5245548,6.987484,0.9122128,3.5440057,2.3616466,5.2128687,2.9748001,3.9496374,1.6421038,11.5072417),(43253,'metacarpus.tif',229,5,69,5.597225,6.1153263,6.1377632,1.8,6.0865332,6.1316164,1.570461,1.5227504,2.0375129,3.6416698,7.6036586,0.9328707,3.7318334,2.391508,5.3912451,3.0150001,4.0538268,1.7000713,11.6680417),(43254,'metacarpus.tif',229,5,70,5.7305824,6.1365966,6.1648268,1.8,6.1042058,6.1635158,-1.5658846,1.5419101,2.1044726,3.7980299,8.2996004,0.955074,3.9437911,2.463198,5.5872844,3.0552001,4.1686064,1.6867783,11.9425445),(43255,'metacarpus.tif',229,5,71,5.9767349,6.1524976,6.1737699,1.8,6.1170041,6.1658657,-1.5692645,1.5659885,2.1936564,4.0252777,9.1912876,0.9961201,4.1899395,2.5704389,5.9244856,3.0954001,4.3134058,1.6454238,12.25035),(43256,'metacarpus.tif',229,5,72,6.2175999,6.1572134,6.191888,1.8,6.1285927,6.1870013,-1.5568486,1.6017766,2.2502945,4.2737898,10.1096806,1.0360651,4.4926033,2.6681559,6.2630228,3.1200518,4.4402353,1.6614562,12.5484014),(43257,'metacarpus.tif',229,5,73,6.2488766,6.186108,6.2235724,1.8,6.1453278,6.2203459,-1.5505707,1.6125127,2.3582925,4.4843012,10.8832624,1.0410534,4.6148909,2.7809402,6.4097707,3.1506602,4.5970596,1.6495803,12.856207),(43258,'metacarpus.tif',229,5,74,6.3022698,6.2220899,6.2221842,1.8,6.1759563,6.2255531,-1.5689979,1.6169959,2.4028347,4.6888972,11.838102,1.0503749,4.9267233,2.8997583,6.7252022,3.1908305,4.7323444,1.6814535,13.2013556),(43259,'metacarpus.tif',229,5,75,6.4016779,6.2441507,6.2265627,1.8,6.1999167,6.2371703,-1.5515649,1.6734791,2.4833843,4.9099241,13.0363952,1.0665518,5.2494473,2.9339621,7.0954015,3.2340399,4.964334,1.6599899,13.6797153),(43260,'metacarpus.tif',229,5,76,6.5687993,6.2609076,6.2452136,1.8,6.2281951,6.2420822,-1.5492483,1.6971259,2.6233607,5.1062158,14.821826,1.0942916,5.6499383,3.008743,7.4847694,3.2882043,5.2046195,1.6558619,15.2365779),(43261,'metacarpus.tif',229,5,77,6.7642765,6.2869075,6.2535425,1.8,6.259725,6.2505155,-1.5566701,1.7118356,2.7539419,5.2472268,17.1046099,1.1271545,6.2109552,3.0652633,7.9805436,0.1191068,0.3061541,1.9756881,0.6627083),(43262,'metacarpus.tif',229,5,78,6.9547374,6.3251583,6.2944508,1.8,6.3079642,6.2633538,-1.5583828,1.7531212,2.9142611,5.4538268,19.3208897,1.1589443,6.6297731,3.110924,8.4064042,3.2860803,5.6331664,1.5279654,15.2503723),(43263,'metacarpus.tif',229,5,79,7.4359997,6.338756,6.3129604,1.8,6.3290453,6.287724,-1.5565368,1.7768552,3.0135707,5.8222771,21.9945834,1.2390813,7.2985126,3.2767314,9.1455945,3.2881709,5.7801396,1.4662834,15.6994696),(43264,'metacarpus.tif',229,5,80,7.9935821,6.3569836,6.2877729,1.8,6.3501256,6.2658552,-1.5582995,1.8414562,3.0694562,6.2321371,24.8881257,1.3320556,8.1083177,3.3843527,10.0431068,3.3434956,5.9400858,1.4691075,16.0917154),(43265,'metacarpus.tif',229,5,81,8.4154749,6.4133952,6.2495667,1.8,6.4129677,6.2564791,-1.5670109,1.9481208,3.0724454,6.905863,27.0374791,1.402559,8.7999868,3.5448843,10.8485838,3.4944089,6.0091943,1.6511598,16.6033779),(43266,'metacarpus.tif',229,5,82,9.0196191,6.5029493,6.2970955,1.8,6.500044,6.2783086,1.5657152,2.100364,3.1246795,8.3368066,27.9892481,1.503231,8.9574781,3.9692199,11.3759738,3.7110694,6.0408445,1.5108682,17.0306001),(43267,'metacarpus.tif',229,5,83,9.8008889,6.6468048,6.311253,1.8,6.6435208,6.2684639,1.5664669,2.1578448,3.0991126,10.1950118,28.606739,1.6334509,9.2306226,4.724627,12.0392292,3.8791618,6.0091943,1.4904329,17.1954404),(43268,'metacarpus.tif',229,5,84,10.3909026,6.7357319,6.3016621,1.8,6.7239168,6.2641635,1.5682304,2.1490553,3.0481913,11.305834,28.662765,1.7318057,9.4032043,5.2608391,12.3851277,3.9665654,5.9529945,1.5370254,17.3700349),(43269,'metacarpus.tif',229,5,85,10.9510307,6.7554081,6.2756923,1.8,6.7416264,6.2390648,1.5657002,2.1696015,2.9447994,11.6972868,27.7500791,1.8251244,9.423419,5.3914447,12.4986862,3.9396001,5.8169277,1.9756881,17.1840127),(43270,'metacarpus.tif',229,5,86,11.4376809,6.7584648,6.30518,1.8,6.7541643,6.2584185,-1.5700137,2.1659083,2.8471887,11.8260488,25.7243511,1.906279,9.0350006,5.4600875,12.0715553,3.9798001,5.796054,1.9847953,17.6583321),(43271,'metacarpus.tif',229,5,87,11.4910169,6.766595,6.2910005,1.8,6.7540036,6.2494687,1.5701832,2.117691,2.6737472,11.3771423,23.8248824,1.9151688,8.9106713,5.3724279,11.9822983,4.0254646,5.6005109,1.9766306,18.0603321),(43272,'metacarpus.tif',229,5,88,10.9136332,6.7795325,6.286074,1.8,6.7718417,6.2479827,1.5679077,2.0249991,2.5163636,10.1394375,22.1566237,1.8189237,8.8050168,5.0071318,11.6336717,3.8840142,5.4369666,1.1600794,17.0370071),(43273,'metacarpus.tif',229,5,89,10.5293821,6.7819873,6.3065179,1.8,6.7771192,6.2420464,1.5536055,1.9826184,2.5310912,8.795094,20.8779694,1.7543784,8.2486043,4.4361004,10.9690326,3.7263714,5.294357,1.1649075,15.9682585),(43274,'metacarpus.tif',229,5,90,10.0026336,6.7876581,6.2645268,1.8,6.7752847,6.2064271,1.5403724,1.859172,2.5042181,7.1497997,18.5018686,1.665563,7.3882816,3.8456903,9.9697254,3.488542,5.135855,1.2440953,15.1074071),(43275,'metacarpus.tif',229,5,91,9.0042097,6.8080359,6.1487716,1.8,6.7909328,6.1238335,1.5038128,1.6756691,2.4984453,5.0578536,14.525579,1.4939783,5.8138471,3.0184084,7.7232461,3.124968,4.865695,1.3117905,14.0289043),(43276,'metacarpus.tif',229,5,92,7.3279551,6.8462791,5.941446,1.8,6.8259759,5.9637671,1.4542792,1.4454776,2.3271356,2.9801349,9.2067428,1.2048197,3.9562554,2.0616956,5.1563798,2.7002053,4.4287559,1.7165445,12.197539),(43277,'metacarpus.tif',229,5,93,4.6766189,6.8893916,5.6915661,1.8,6.8787659,5.7170527,1.3077895,1.06486,1.7337207,1.1544194,3.6431455,0.7267526,2.1013451,1.0841044,2.6738017,2.0699154,3.5087026,1.6510831,9.6758764),(43278,'metacarpus.tif',229,5,94,1.425794,6.8728523,5.5206446,1.8,6.9006131,5.5860433,1.2194905,0.5945344,1.2448751,0.0964066,0.5457276,0.2094916,0.4383794,0.1621548,0.5110148,1.2205009,2.3502394,1.7950311,6.3858833),(43279,'metacarpus.tif',229,5,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43280,'metacarpus.tif',229,5,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43281,'metacarpus.tif',229,5,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43282,'metacarpus.tif',229,5,98,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43283,'metacarpus.tif',229,5,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43284,'metacarpus.tif',229,5,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43285,'metacarpus.tif',229,5,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43286,'metacarpus.tif',229,5,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43287,'metacarpus.tif',229,5,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43288,'metacarpus.tif',229,5,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43289,'metacarpus.tif',229,5,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43290,'metacarpus.tif',229,5,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43291,'metacarpus.tif',229,5,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43292,'metacarpus.tif',229,5,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43293,'metacarpus.tif',229,5,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43294,'femur.tif',229,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43295,'femur.tif',229,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43296,'femur.tif',229,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43297,'femur.tif',229,7,4,14.1523442,29.256713,23.7792783,1.8,29.1577013,23.847469,-0.9547059,2.347626,3.8645113,12.9619793,43.6848095,1.5711243,11.3040968,5.5213136,14.5318036,4.2840528,7.5804538,1.0019485,19.7413217),(43298,'femur.tif',229,7,5,20.8732262,29.9373669,23.9255751,1.8,29.8708166,23.7924969,-0.9407966,3.5899927,4.7040941,50.9001808,129.7655474,2.2713853,27.5856616,14.1783523,37.665552,6.7761297,9.6101829,1.1558906,27.2989624),(43299,'femur.tif',229,7,6,24.5929856,30.945362,24.0731399,1.8,30.6454676,23.9862895,-0.7956273,3.8906576,5.5983166,91.9118509,211.1685917,2.0913399,37.7200162,23.6237318,53.7032694,7.4502898,10.7556006,1.0287074,30.8885257),(43300,'femur.tif',229,7,7,28.2709142,31.5835782,23.9831512,1.8,31.1349543,23.9488444,-0.7763217,4.6444149,6.7831836,132.3201583,308.1820062,2.3131453,45.4332396,28.4901674,64.9080058,8.2864369,12.4275862,0.8868451,34.596394),(43301,'femur.tif',229,7,8,31.4882598,32.0749125,23.8982945,1.8,31.5581247,23.8408187,-0.6694991,5.273431,7.3009849,189.5347376,404.7707602,2.0212104,55.4405693,35.9414462,80.7180537,9.17964,13.3925998,0.8850668,37.4561394),(43302,'femur.tif',229,7,9,33.2510871,31.8206009,24.1376411,1.8,31.3568654,24.0157339,-0.5316631,6.0856665,7.2209535,265.5195289,494.1020578,1.4243445,68.4261519,43.6303123,105.1035456,10.5447154,14.0781605,0.5302158,40.4385485),(43303,'femur.tif',229,7,10,34.5825719,31.2296451,23.869473,1.8,30.8940094,23.6120004,-0.47164,6.6540041,7.4287959,392.8030932,560.7209029,1.1898247,75.4793791,59.0325899,128.1258531,11.6395242,14.916352,0.4039701,46.5347477),(43304,'femur.tif',229,7,11,35.3776038,30.6092048,23.5024704,1.8,30.5201215,23.287099,-0.252118,6.6077248,7.9497374,461.0462108,625.6604499,0.3669134,78.7020269,69.773822,136.4992208,12.51176,15.6175069,0.4066523,49.0983568),(43305,'femur.tif',229,7,12,37.4470354,30.1084783,23.3179414,1.8,30.1528608,23.1919596,-0.1928136,6.7102961,8.5201075,460.4020636,790.1846762,0.2291674,92.7435099,68.6112891,146.6851958,13.0640547,16.4148772,0.4065668,52.6117067),(43306,'femur.tif',229,7,13,39.6297633,29.6004971,23.393861,1.8,29.7269846,23.3645578,-0.1776536,6.7934878,9.0371909,476.455692,987.2095485,0.2062739,109.238541,70.1341799,161.9231869,13.0777168,17.5602852,0.3594685,55.3593113),(43307,'femur.tif',229,7,14,56.1052858,25.7192686,23.1384807,1.8,27.07317,23.2684814,0.0421817,6.8775812,12.790117,552.0206009,2984.1027734,0.0166281,233.3131732,80.2637702,274.2478604,12.9828005,24.9557462,3.087025,74.2165828),(43308,'femur.tif',229,7,15,70.209996,23.1611408,22.8935099,1.8,24.7326124,23.1833365,0.085958,7.5121981,15.4515084,778.9778125,4493.3730793,0.0862483,290.8048172,103.6950573,337.7407097,13.3363726,27.025584,3.1105948,81.5394189),(43309,'femur.tif',229,7,16,74.4398671,22.1089442,22.6382383,1.8,23.6460771,23.0432798,0.1006576,8.2798116,16.5951306,967.5674228,5017.9838592,0.1252797,302.3768819,116.8586273,356.7938272,14.4020011,27.8740043,3.1002628,95.4893951),(43310,'femur.tif',229,7,17,72.9330949,21.8570823,22.4586117,1.8,23.0232699,22.8900967,0.0843456,9.0731755,17.0422335,1078.4887775,5104.2837295,0.0862716,299.5079095,118.8656364,358.1528325,15.255313,28.5061024,3.0975036,100.1259585),(43311,'femur.tif',229,7,18,71.0920001,21.8044653,22.3880939,1.8,22.7141757,22.8069913,0.0769778,9.8243244,17.2147411,1121.4770573,5172.8576086,0.0700717,300.4900028,114.1530971,360.3975145,16.1651224,28.9292383,3.094526,102.3680267),(43312,'femur.tif',229,7,19,69.6317887,21.7601498,22.4132935,1.8,22.4351951,22.8095071,0.0663035,10.2502334,17.3732185,1172.3380399,5203.9458853,0.0509439,299.53839,114.3718386,361.1755766,16.7071097,29.2862587,0.0715622,103.0216313),(43313,'femur.tif',229,7,20,67.7707894,22.1234854,22.5932935,1.8,22.5579671,22.8780571,0.0517883,10.6545037,17.1350143,1222.9134217,5126.6327712,0.0302667,299.1904571,114.7790136,364.748027,17.3053101,29.358038,0.0535203,104.2166995),(43314,'femur.tif',229,7,21,64.0017746,22.7996923,22.7962048,1.8,22.8794706,23.0201556,0.0394698,10.7012724,16.4689668,1203.8267367,4762.682891,0.016609,289.1913591,112.4937948,356.4746365,17.4064978,29.0773985,0.0720771,103.3536949),(43315,'femur.tif',229,7,22,59.2772938,24.1497757,23.1623694,1.8,23.7753508,23.2825887,-0.027422,10.3601386,15.0834126,1091.4891578,4222.5138261,0.0074272,279.9441967,105.3546868,347.406208,17.1489888,28.4315941,0.1069972,107.4382717),(43316,'femur.tif',229,7,23,53.9695214,26.3961651,23.8297404,1.8,26.0975227,23.9836237,-0.2459684,8.3086177,13.0561088,1019.2096595,3092.0514512,0.5333102,236.8279472,122.6689805,314.8911612,15.2328009,24.6381157,0.5549957,89.1627501),(43317,'femur.tif',229,7,24,53.4361514,27.0656514,24.0329134,1.8,26.6639241,24.2447675,-0.363814,7.4369919,12.3312599,1004.1150995,2992.2880869,1.1277072,242.6587471,135.0162961,301.5477444,14.6078813,25.1044324,0.5532943,87.555046),(43318,'femur.tif',229,7,25,53.116579,27.3625616,24.0044718,1.8,27.0029509,24.3011101,-0.451196,7.5000645,13.134329,956.7717812,2925.6355122,1.6832002,222.7472385,127.5684738,283.112014,14.3617122,25.2485531,0.5546433,86.9522505),(43319,'femur.tif',229,7,26,52.5359995,27.7503782,23.8501923,1.8,26.9901499,24.3605697,-0.4678503,7.2593279,13.653626,937.4726272,2685.5279073,1.7807316,196.6897221,129.1404171,257.7904914,13.8991676,25.0707871,0.559042,84.4456145),(43320,'femur.tif',229,7,27,51.9895685,28.1113346,23.6881566,1.8,27.4042961,24.3623357,-0.5020779,7.1594856,13.8192864,914.8322213,2433.786737,2.0067947,176.1152253,127.779044,237.961461,13.7913777,24.5491928,0.5572431,81.647201),(43321,'femur.tif',229,7,28,52.3819388,28.2778529,23.6978976,1.8,27.7235997,24.3579729,-0.563371,7.2427026,13.7141916,905.7064597,2290.1074327,2.4898702,166.9881467,125.0508968,231.264812,13.7219267,23.9872714,0.5771072,78.0111874),(43322,'femur.tif',229,7,29,51.9640473,28.3309271,23.6619255,1.8,27.8415561,24.2920653,-0.6343687,7.2569406,13.3629281,901.7698604,2105.318733,3.0421204,157.5492071,124.2630905,224.8300465,13.8416284,23.0874786,0.5754247,69.2033109),(43323,'femur.tif',229,7,30,53.9947587,28.429158,23.6437547,1.8,27.8924866,24.2517869,-0.7133409,7.3364666,13.0882813,912.6253788,1990.5865384,3.8533529,152.0892234,124.3957662,221.5527286,13.8474861,22.5921649,0.5841466,61.6413115),(43324,'femur.tif',229,7,31,50.7852338,28.5449966,23.404919,1.8,28.1002912,24.2218642,-0.7439114,7.1327913,12.8718845,862.3255431,1917.0475038,3.8813531,148.9329321,120.8959454,215.1288006,13.9026454,22.1301236,0.6037493,60.8142344),(43325,'femur.tif',229,7,32,49.1666944,28.6917855,23.1644577,1.8,28.2070178,23.9825594,-0.7568012,7.1040729,12.688552,821.5934597,1809.7247833,3.8630163,142.6265805,115.6510462,206.1936124,13.876457,21.701207,0.6174452,59.8750164),(43326,'femur.tif',229,7,33,51.1866194,28.7631804,22.9714507,1.8,28.3876307,23.7310339,-0.7413482,7.0444685,12.0872642,813.4766477,1830.7374743,3.8902429,151.4600359,115.4773629,217.4500236,13.6117912,20.9716487,0.611544,58.8026119),(43327,'femur.tif',229,7,34,51.7741077,28.8835304,22.8164231,1.8,28.5575275,23.517932,-0.7376432,6.8610266,11.6234208,802.3181998,1802.3031456,3.903057,155.057893,116.9385067,222.5741512,13.4690931,20.3767298,0.6578886,57.1020074),(43328,'femur.tif',229,7,35,51.4771991,29.0974471,22.3913376,1.8,28.7568867,23.0286546,-0.737887,6.8484381,11.1376192,782.5258409,1617.6200312,3.8827562,145.2393014,114.2634034,212.431351,13.1882899,19.6300641,0.5880026,54.7986073),(43329,'femur.tif',229,7,36,52.0482874,29.3203407,22.1365308,1.8,28.9194788,22.7502117,-0.7530821,6.6574026,10.2460704,768.5523007,1491.7836797,4.0572198,145.5956896,115.4432662,217.8673118,12.8936818,18.475917,0.6162969,52.9858619),(43330,'femur.tif',229,7,37,52.3101937,29.3229999,21.9343783,1.8,28.9523458,22.3936121,-0.749137,6.5820602,9.7288486,738.8102051,1466.893285,4.0433222,150.7776866,112.2460414,223.9264257,12.6149935,17.9049252,0.6318057,50.6929847),(43331,'femur.tif',229,7,38,52.1804146,29.4998677,21.6803803,1.8,29.2008298,22.1280791,-0.7560911,6.415323,9.2851527,716.3627205,1374.2916154,4.0936384,148.0095877,111.6643264,221.4166525,12.3618117,17.2970618,0.6350267,48.8697165),(43332,'femur.tif',229,7,39,53.1784416,29.8047833,21.3949661,1.8,29.5859276,21.7684137,-0.7643787,6.2403092,9.1592299,703.9894841,1255.4704481,4.2452943,137.0716171,112.8132374,211.8437136,12.1415896,16.7970919,0.6971325,47.1796348),(43333,'femur.tif',229,7,40,50.8462654,30.0364555,21.0480565,1.8,29.8627947,21.3173807,-0.8167314,6.1230744,8.1055919,677.6996744,1111.842839,4.5025447,137.1698519,110.6796403,219.1556301,12.0615445,15.4775506,0.7614793,45.2082984),(43334,'femur.tif',229,7,41,51.0718743,30.1779884,20.8434772,1.8,30.0299994,21.033232,-0.8403896,5.9762822,7.6200941,659.8780856,1055.5603173,4.7231323,138.5232647,110.4161529,222.7757341,11.8454533,14.8666632,0.69564,44.0386347),(43335,'femur.tif',229,7,42,50.8261944,30.3723047,20.5762808,1.8,30.1956678,20.7626536,-0.8597697,5.8390386,7.358283,644.7726622,987.7558092,4.8631991,134.2372681,110.4244564,219.1304424,11.6973851,14.4387342,0.888128,43.2010347),(43336,'femur.tif',229,7,43,50.3979413,30.5364945,20.2903537,1.8,30.3473167,20.4974907,-0.8514343,5.7641306,7.1929174,632.1146692,930.467351,4.7528982,129.3588258,109.6634884,214.8236921,11.623351,14.0956694,0.9064958,42.7209028),(43337,'femur.tif',229,7,44,50.3887228,30.6819239,20.0461269,1.8,30.5010479,20.2008381,-0.8721646,5.7044192,7.0593876,622.9825781,894.7861718,4.9240832,126.7512464,109.2105179,212.6686474,11.4752829,13.8663288,0.9031307,42.0059665),(43338,'femur.tif',229,7,45,50.7732371,30.7892112,19.8276772,1.8,30.5884416,19.9926112,-0.9104874,5.6962004,6.8782738,608.9033259,877.8297484,5.278626,127.6235543,106.8964018,212.0280571,11.4012488,13.6371504,0.8996525,41.6739028),(43339,'femur.tif',229,7,46,50.708848,30.8757354,19.6013371,1.8,30.7295191,19.7006509,-0.9136503,5.6541699,6.7687314,593.5971769,860.5949436,5.2978104,127.1427233,104.983965,212.6504388,11.3272147,13.4754234,0.9677087,41.3164346),(43340,'femur.tif',229,7,47,50.4336946,30.9609,19.365752,1.8,30.794791,19.4814624,-0.9108777,5.5945194,6.6877204,582.8853429,833.4523649,5.2465039,124.6242841,104.1886364,208.8585995,11.2397087,13.3413444,1.0263392,40.9589664),(43341,'femur.tif',229,7,48,49.9038425,31.0457681,19.1723774,1.8,30.8907317,19.2864231,-0.9381689,5.5843359,6.6360518,566.669769,817.3926056,5.4096164,123.1745361,101.474871,207.3568524,11.1051124,13.3096727,1.1493771,40.713639),(43342,'femur.tif',229,7,49,50.4625313,31.0883435,19.068843,1.8,30.9722381,19.1131416,-0.9703604,5.5770531,6.5969752,558.3615321,830.142905,5.7255843,125.8369003,100.1176647,209.2342801,11.0310784,13.3577675,1.2019343,40.4175027),(43343,'femur.tif',229,7,50,50.6713635,31.162354,18.8894127,1.8,31.0491996,18.9360421,-0.9600179,5.560247,6.5814152,553.1961572,820.6982479,5.6675212,124.6993581,99.4912913,207.5215232,11.0310784,13.255616,0.9367736,40.3920982),(43344,'femur.tif',229,7,51,50.7268811,31.2657488,18.6802297,1.8,31.1527856,18.6855083,-0.9587429,5.5332647,6.4650205,550.5914204,799.5687704,5.6635979,123.676139,99.5057076,206.1428925,11.0179613,13.0757689,1.150133,40.2694345),(43345,'femur.tif',229,7,52,50.2559269,31.3747308,18.443694,1.8,31.2655743,18.475552,-0.9482485,5.5180013,6.3866063,541.8674213,774.6714216,5.5280374,121.2962541,98.1999445,203.6731289,10.9570443,12.9256809,1.333676,39.9373709),(43346,'femur.tif',229,7,53,49.7127906,31.4486423,18.1994268,1.8,31.3594383,18.2180626,-0.9369599,5.4460914,6.311084,531.8124029,754.7113845,5.3793496,119.5850639,97.6502888,201.8819966,10.9393448,12.8337608,1.3654009,39.6412345),(43347,'femur.tif',229,7,54,49.6189903,31.5562888,17.9694808,1.8,31.4699248,18.0084162,-0.9520851,5.4398468,6.2390133,535.1968102,737.236889,5.487997,118.1656215,98.3845369,201.0253424,10.9442938,12.7480586,1.2360595,39.4931664),(43348,'femur.tif',229,7,55,49.5885021,31.6581841,17.775604,1.8,31.5783528,17.819013,-0.960252,5.4478475,6.1944083,536.733005,724.908223,5.5482227,117.0262259,98.5220313,199.2982477,10.9535365,12.6859945,1.2777585,39.2837663),(43349,'femur.tif',229,7,56,50.323324,31.7319357,17.6282744,1.8,31.6737688,17.6684237,-0.9969944,5.4621836,6.2177642,542.8311731,730.4256753,5.9158141,117.4740075,99.3798834,201.0889609,10.9923257,12.6976546,1.3378171,39.2837663),(43350,'femur.tif',229,7,57,50.9383502,31.8005252,17.4921054,1.8,31.7584908,17.5272507,-1.0143848,5.4735979,6.2261082,547.6761008,738.7800984,6.1216484,118.6584089,100.0577886,203.0602711,10.9927794,12.7278348,1.2958865,39.3450982),(43351,'femur.tif',229,7,58,51.2433717,31.8709577,17.379139,1.8,31.8320253,17.4289217,-1.037193,5.4974056,6.2627977,551.7629706,742.4119569,6.3310018,118.5431799,100.367885,205.4262786,11.022575,12.6859945,1.2777585,39.4931664),(43352,'femur.tif',229,7,59,53.6061476,31.894102,17.4861563,1.8,31.8825725,17.4398765,-1.139079,5.6030912,6.5406805,561.4887757,806.3765756,7.3700892,123.2863419,100.2105362,206.8577685,11.0370637,13.2423777,1.4837155,39.9881798),(43353,'femur.tif',229,7,60,53.9555262,31.9909023,17.4092907,1.8,31.9622858,17.3673481,-1.1760589,5.6616066,6.5928383,566.3114715,829.5095536,7.6626659,125.8197936,100.0266383,204.5956672,11.078278,13.5192803,1.4387566,40.345648),(43354,'femur.tif',229,7,61,54.8043406,32.0776587,17.3266281,1.8,32.0608026,17.2695979,-1.1766954,5.6861465,6.6202745,571.576197,843.4196845,7.7873383,127.3995041,100.5208347,210.9647188,11.1218696,13.4607726,1.4145988,41.602048),(43355,'femur.tif',229,7,62,55.1314309,32.2300908,17.162921,1.8,32.1516263,17.1532948,-1.1957842,5.7578743,6.5957117,582.1266972,836.3574465,7.9557981,126.8032142,101.1009732,212.2290582,11.1811313,13.3917813,1.3979357,40.504239),(43356,'femur.tif',229,7,63,55.8818701,32.3048557,17.0438714,1.8,32.2547088,16.9776684,-1.178075,5.7554869,6.5861697,587.1702924,856.5505276,7.9495465,130.0529093,102.0192212,216.9791449,11.2106514,13.3663816,1.4687894,40.6777117),(43357,'femur.tif',229,7,64,55.3545604,32.4594169,16.8072654,1.8,32.372736,16.7844071,-1.2017693,5.8019735,6.6613896,593.7043906,843.9805964,8.0253931,126.697379,102.3280073,213.6905302,11.2228117,13.3261349,1.4288993,41.6379754),(43358,'femur.tif',229,7,65,55.29668,32.613968,16.6098886,1.8,32.5232223,16.5952739,-1.2229924,5.8241904,6.7266692,599.9109692,828.713179,8.1454972,123.1981461,103.003323,209.7458176,11.2850908,13.3117316,1.4366855,42.3529117),(43359,'femur.tif',229,7,66,54.7714587,32.7643216,16.4056747,1.8,32.6612484,16.3934074,-1.2279098,5.8706762,6.5427987,602.4368806,790.5387571,8.0967264,120.8257799,102.6179705,210.8639584,11.3274793,13.0005199,1.433455,40.8108982),(43360,'femur.tif',229,7,67,54.5806415,32.8939495,16.1972685,1.8,32.7746265,16.1825445,-1.216656,5.8752133,6.42121,603.8225649,764.4691165,8.0028022,119.0537472,102.7745777,211.3279094,11.3331367,12.7789776,1.4393276,40.0959619),(43361,'femur.tif',229,7,68,54.5683954,32.9979341,15.9743459,1.8,32.8907053,15.9890493,-1.186771,5.8317764,6.3451724,608.728203,747.5474486,7.8181335,117.8135753,104.3812651,211.9467501,11.3795878,12.6010272,1.7209188,39.7130892),(43362,'femur.tif',229,7,69,53.9612743,33.1298185,15.7413305,1.8,33.0160979,15.8123668,-1.1687849,5.8151369,6.350845,610.2032581,722.8338357,7.6167024,113.8169535,104.9336006,208.7465101,11.4260389,12.5124171,1.6629714,39.9224893),(43363,'femur.tif',229,7,70,54.1937071,33.2875371,15.5709328,1.8,33.1490958,15.6565324,-1.1888801,5.8740046,6.3238641,617.32092,712.4152555,7.7776572,112.6550552,105.0937068,209.6760846,11.5120722,12.4540204,1.6972368,39.6263529),(43364,'femur.tif',229,7,71,54.4582186,33.4217579,15.3975722,1.8,33.285192,15.4919082,-1.1988983,5.8945362,6.3228022,620.7159452,712.2864664,7.8778512,112.653606,105.3036101,210.5701653,11.5192069,12.4103738,1.7317841,39.8103484),(43365,'femur.tif',229,7,72,54.605564,33.5302715,15.2348718,1.8,33.382095,15.3465788,-1.1818711,5.8985998,6.3387349,625.1582173,711.0317446,7.7923212,112.1725003,105.9841718,210.6532454,11.5661897,12.3639135,1.7067054,39.5142121),(43366,'femur.tif',229,7,73,54.5872182,33.626964,15.1061971,1.8,33.4981435,15.2177594,-1.1710252,5.9249301,6.3032232,629.6564313,709.3946454,7.7197019,112.5447455,106.2723817,210.6124508,11.6410248,12.3501632,1.6983059,39.5142121),(43367,'femur.tif',229,7,74,54.6345216,33.7286871,14.9970865,1.8,33.602545,15.1074971,-1.1569044,5.9234602,6.2777692,636.2966075,709.7623988,7.6329412,113.0596511,107.4197481,213.9729937,11.6667267,12.3243958,1.7415315,39.6009484),(43368,'femur.tif',229,7,75,54.8345111,33.8472369,14.8867022,1.8,33.7397562,14.9817368,-1.1615537,5.9874432,6.2640122,647.3162887,709.0434627,7.6920389,113.1931801,108.1123051,216.1595148,11.7451693,12.3252852,2.0762447,39.575544),(43369,'femur.tif',229,7,76,55.0075856,33.9720742,14.7811238,1.8,33.8839603,14.8857017,-1.1838472,6.0068137,6.2609474,657.5314051,708.5260027,7.8623788,113.1659406,109.4642579,217.9007357,11.7843906,12.3372862,2.0952056,39.6368758),(43370,'femur.tif',229,7,77,54.2629456,34.0758802,14.6829567,1.8,33.976927,14.7835236,-1.2211521,6.0297794,6.2547665,661.7015714,708.3884157,7.9825332,113.2557737,109.7389347,217.6689121,11.860879,12.3816332,1.7665335,39.784944),(43371,'femur.tif',229,7,78,53.8451597,34.1811819,14.6022461,1.8,34.081159,14.7007277,-1.2643807,6.0203912,6.2947476,665.3629384,710.3841149,8.1576443,112.8534707,110.5182234,216.8820008,11.9001003,12.4174381,1.81782,39.8716803),(43372,'femur.tif',229,7,79,53.499927,34.2926463,14.5248482,1.8,34.1964517,14.6209837,-1.2585107,6.0648702,6.3056067,671.350814,710.8033317,8.0749844,112.7256053,110.6950004,218.1304617,11.9785429,12.4280272,1.9779005,39.9689395),(43373,'femur.tif',229,7,80,53.3795104,34.3942701,14.4374136,1.8,34.3073601,14.527165,-1.2036946,6.0888118,6.298586,678.8589056,713.6331626,7.7505475,113.3005345,111.4928375,217.5834565,12.0177642,12.4874234,2.1471715,40.3518121),(43374,'femur.tif',229,7,81,52.7679177,34.5237509,14.3438324,1.8,34.4197282,14.4429904,-1.2027935,6.1314435,6.3342758,685.4263251,709.9474117,7.6564315,112.0802818,111.7887377,218.1674595,12.0879892,12.5522162,2.1240907,40.413144),(43375,'femur.tif',229,7,82,52.0176119,34.6632922,14.2378082,1.8,34.5526766,14.3532875,-1.4550931,6.1527928,6.4623442,694.0984836,705.0853656,8.5540569,109.106748,112.8103138,215.465782,12.1589519,12.6027669,2.1611031,40.9694893),(43376,'femur.tif',229,7,83,51.4464595,34.791274,14.1199202,1.8,34.6776812,14.2768657,0.5130191,6.3926822,6.2650668,696.6528113,710.8462816,2.0655271,113.4618841,108.976607,216.2923133,12.1517086,12.6898824,2.1565106,41.041344),(43377,'femur.tif',229,7,84,51.1264761,34.9337896,14.0139895,1.8,34.8109552,14.1752913,0.3806514,6.5339109,6.2794822,689.7703991,727.4866208,1.1761736,115.8513702,105.5677697,214.3375009,12.1780547,12.7480586,2.1633547,41.2761485),(43378,'femur.tif',229,7,85,50.9775357,35.0551924,13.954441,1.8,34.9351978,14.1335531,0.3403712,6.5927233,6.2935519,690.5062697,743.3672714,0.9468838,118.1156973,104.7376387,217.3940166,12.1655608,12.7926954,0.18937,41.3988122),(43379,'femur.tif',229,7,86,51.0887689,35.1754623,13.9190708,1.8,35.0466509,14.1012363,0.3000157,6.6105097,6.3148218,701.1289379,756.1809633,0.743691,119.7469991,106.0627652,218.8543516,12.1824798,12.9439019,0.1624891,41.460144),(43380,'femur.tif',229,7,87,50.9445859,35.2639752,13.8721219,1.8,35.1599663,14.0187695,0.1972954,6.4133537,6.3337174,708.2617341,764.9921069,0.3262407,120.7809038,110.4354708,224.6132821,12.1224356,12.9612516,0.1704607,41.4960714),(43381,'femur.tif',229,7,88,50.9278355,35.3424415,13.8477149,1.8,35.2711654,13.9636144,0.1523838,6.3418927,6.4177419,719.4835747,774.3617646,0.1955768,120.6595367,113.4493461,228.9599702,12.1033719,13.0510141,0.352198,41.6441396),(43382,'femur.tif',229,7,89,51.0881643,35.4154909,13.8349714,1.8,35.4073823,13.96844,0.2186471,6.2943631,6.5118353,730.7559539,782.5894974,0.4006127,120.1795595,116.0968851,229.6005499,12.1408881,13.1343224,0.1520433,41.9148714),(43383,'femur.tif',229,7,90,49.6383573,35.4113435,13.7405399,1.8,35.397508,13.8346891,0.0847898,6.3054644,6.7140317,723.3007285,774.4934398,0.0593353,115.3544511,114.7101438,223.0357098,12.1181367,13.1855512,0.1755922,42.1242714),(43384,'femur.tif',229,7,91,49.0923483,35.4820326,13.6970927,1.8,35.4680948,13.7933154,0.1413544,6.2656799,6.810403,720.076954,775.7456348,0.1624003,113.9059804,114.9239932,218.9824316,12.1522788,13.2539619,0.1586553,42.3336714),(43385,'femur.tif',229,7,92,48.7054567,35.5649822,13.6036103,1.8,35.5421788,13.68154,0.1367321,6.2975456,6.9041426,708.9059643,789.7086452,0.1508202,114.3818565,112.5686121,215.46067,12.1387033,13.3917813,0.1728606,42.5684759),(43386,'femur.tif',229,7,93,47.5939313,35.7427176,13.5420238,1.8,35.7094419,13.6339568,0.167513,6.2702566,6.8728026,698.3297252,796.6105265,0.2205116,115.9076693,111.3717929,216.7936125,12.1273231,13.4481439,0.2922025,42.6657351),(43387,'femur.tif',229,7,94,47.0470986,35.9286049,13.539279,1.8,35.8369896,13.6501055,0.1746927,6.2538454,6.8619107,694.5011898,810.4832119,0.2368693,118.1133425,111.051864,217.845809,12.1348183,13.580765,0.1626138,43.1099396),(43388,'femur.tif',229,7,95,47.0264319,36.0942595,13.5065195,1.8,36.0622639,13.6276686,0.1649297,6.2778746,6.860315,699.7909678,832.2245059,0.2112745,121.3099553,111.4694091,222.938719,12.1387033,13.6772834,0.3435389,43.355267),(43389,'femur.tif',229,7,96,47.3445545,36.220772,13.4848801,1.8,36.1414915,13.5895752,0.139142,6.285311,6.8953271,706.6111746,858.0395885,0.1517857,124.4378373,112.4226267,225.9826836,12.1872586,13.7862515,0.3649928,43.5033352),(43390,'femur.tif',229,7,97,46.6160885,36.3610523,13.4829888,1.8,36.2895335,13.5973609,0.0951517,6.3142493,6.9553686,707.8585256,871.4251849,0.0701304,125.288138,112.1049372,225.9088738,12.264718,13.9455532,0.3526196,44.0702033),(43391,'femur.tif',229,7,98,45.9189437,36.5026123,13.4538589,1.8,36.430083,13.6165642,0.1038137,6.35717,6.9593169,712.2784476,878.8917304,0.0821844,126.2899432,112.0433215,223.7519963,12.3263098,14.1170398,0.363979,44.3155307),(43392,'femur.tif',229,7,99,46.8089491,36.6786538,13.4675482,1.8,36.6406807,13.6662663,0.1322191,6.3395622,6.953029,724.3865941,910.841636,0.1355918,130.9992565,114.2644503,226.6950478,12.3929709,14.2407402,0.2984989,44.9332078),(43393,'femur.tif',229,7,100,47.3582951,36.8768934,13.5640755,1.8,36.9001547,13.8398214,0.1631617,6.2812713,6.9229039,744.2117866,934.2685882,0.2082687,134.9532804,118.4810765,228.2234701,12.5081536,14.4379749,0.3400971,45.2652715),(43394,'femur.tif',229,7,101,46.485674,36.9735772,13.5164462,1.8,36.9586922,13.8175627,0.1248039,6.432646,7.0359444,757.6213608,937.086925,0.1200516,133.1856628,117.7775616,227.1241171,12.661981,14.6355477,0.3353244,45.6227397),(43395,'femur.tif',229,7,102,47.7366113,37.0106094,13.4687087,1.8,36.8969256,13.6770125,0.0530117,6.5827205,7.1979943,779.2858491,988.2274229,0.0223377,137.2920546,118.3835541,236.0215091,12.7948049,14.8042252,0.3463541,46.3630805),(43396,'femur.tif',229,7,103,48.598995,37.2225965,13.5690674,1.8,37.1607857,13.7821962,0.0652165,6.5161466,7.3100806,799.1968826,1026.500721,0.0344013,140.422627,122.6486955,237.7305121,12.8928269,15.0028201,0.2974728,46.6951442),(43397,'femur.tif',229,7,104,50.8826273,37.4853116,13.5393519,1.8,37.4314919,13.7317654,0.096087,6.5531244,7.5773019,823.9416523,1072.3015989,0.0780568,141.5149628,125.7326424,237.7505073,12.9972735,15.2650308,0.3065673,47.6089577),(43398,'femur.tif',229,7,105,50.3372642,37.519988,13.4879574,1.8,37.4141641,13.6952067,0.036823,6.700547,7.7368345,829.951238,1092.6661619,0.0113705,141.2290982,123.8632076,238.3409689,13.0875005,15.5960839,0.3068897,48.3598214),(43399,'femur.tif',229,7,106,50.9820911,37.6061086,13.506768,1.8,37.4758948,13.5429169,-0.0368463,6.7953724,8.0400013,858.1969015,1147.6231207,0.0115307,142.7391716,126.2913719,244.5740463,13.1922005,15.9271386,0.3071986,49.0642349),(43400,'femur.tif',229,7,107,51.4445975,37.7783898,13.5210636,1.8,37.7676845,13.4213985,-0.0445933,6.8874849,8.318804,881.8649507,1220.1215336,0.0170388,146.6703068,128.0387486,249.1719613,13.4016005,16.1801315,0.2685222,49.4471075),(43401,'femur.tif',229,7,108,51.3247801,37.9281395,13.5832659,1.8,37.8376979,13.5086006,-0.0628106,6.9495208,8.5844104,885.0104303,1285.2378748,0.0337032,149.7176644,127.34841,251.1443633,13.5063005,16.5575037,0.2557144,50.5449165),(43402,'femur.tif',229,7,109,54.8148665,37.9212639,13.7376156,1.8,37.8308276,13.5284885,-0.0983931,7.0072946,8.8816705,924.2524419,1483.8049348,0.0881606,167.0637225,131.8986128,266.9921579,13.8204005,17.1838832,0.3159703,52.8377938),(43403,'femur.tif',229,7,110,58.183209,37.8095144,13.8878877,1.8,37.7738217,13.5933099,-0.058106,7.010376,9.149883,980.9329581,1719.9227049,0.0327039,187.9720973,139.9258695,288.2249875,14.0298006,17.7758901,0.2378359,53.6245848),(43404,'femur.tif',229,7,111,60.2021108,38.0831478,14.0234047,1.8,37.9833707,13.6833641,-0.0098457,7.3075457,9.8405354,1020.1523892,1898.361996,0.0009726,192.9124707,139.6026019,286.510923,14.3200438,18.6271871,0.1466665,55.549471),(43405,'femur.tif',229,7,112,61.8005026,38.5488983,14.0503513,1.8,38.3291941,13.673112,0.0384231,7.5284461,10.1121699,1058.25053,1959.1292447,0.0151988,193.7397481,140.5669261,288.7014787,14.583972,18.8195163,0.1395367,56.4886889),(43406,'femur.tif',229,7,113,63.2277654,38.6938177,14.114867,1.8,38.494735,13.7262215,0.1028361,7.7738788,10.1346046,1104.7150291,2054.4062891,0.1110493,202.7120308,142.106027,302.5426888,14.9109563,19.1703963,0.0327751,56.8102298),(43407,'femur.tif',229,7,114,63.6042949,38.7142851,14.1682762,1.8,38.5970969,13.8178678,0.0808041,7.8114445,10.1997073,1145.9923884,2121.2443007,0.0690648,207.9710959,146.706846,311.0198283,15.1815006,19.5026067,0.1563228,58.893707),(43408,'femur.tif',229,7,115,65.9164464,38.7299448,14.3337924,1.8,38.5946901,14.0118896,0.0611521,8.0074484,10.2594844,1251.238492,2229.207009,0.0410321,217.2825582,156.2593259,331.1618903,15.6434319,19.6635416,0.138885,59.2257706),(43409,'femur.tif',229,7,116,68.8396044,38.7669824,14.4740077,1.8,38.6648947,14.1263983,0.0665357,8.2903092,10.3859469,1343.7960521,2395.9201982,0.0507172,230.6886628,162.0923922,350.1574953,16.20626,19.9634109,0.0840123,60.9158523),(43410,'femur.tif',229,7,117,75.0315361,38.7882567,14.7567582,1.8,38.6353226,14.3353934,0.0431831,8.6138865,10.7461621,1554.7773659,2787.9808069,0.023305,259.4396746,180.4966155,389.6079905,16.8495022,20.6112801,0.1375867,63.1219932),(43411,'femur.tif',229,7,118,81.3574387,38.757636,15.1499008,1.8,38.7607147,14.7642629,0.0321722,9.0919684,10.7624497,1802.6627432,3162.0114659,0.0140301,293.8003483,198.2697978,448.2856381,17.6537915,21.0123805,0.1299174,66.9568839),(43412,'femur.tif',229,7,119,88.9172515,38.8310113,15.700776,1.8,38.8727233,15.3138444,0.0069832,9.5496529,11.5743345,2229.5567758,3616.0925327,0.0007227,312.4233652,233.4699282,457.4084973,19.0665606,21.7999891,0.6319742,74.7134017),(43413,'femur.tif',229,7,120,108.3414311,38.7539557,17.3652094,1.8,38.8827452,16.8432819,0.0102085,11.3602233,12.1198221,3656.8721943,4847.7463554,0.0018818,399.9849425,321.9014374,638.0320777,21.3363801,24.8976962,2.2159795,106.7523508),(43414,'femur.tif',229,7,121,127.3681118,38.6769118,18.7469593,1.8,38.8653125,17.8325445,0.0850168,12.7719421,11.9813159,5220.8497001,5818.2764664,0.1530637,485.612476,408.774926,803.2796631,22.0709554,26.9703634,2.1178735,103.2154018),(43415,'femur.tif',229,7,122,132.2676936,38.5996861,18.9402299,1.8,38.9919157,18.0944816,-0.43977,13.8350209,13.8322255,5617.0941569,5950.5645615,3.995524,430.1957451,406.0054693,803.4659888,22.5397653,27.7794584,2.1222044,112.3869107),(43416,'femur.tif',229,7,123,132.8355136,38.567742,19.0915038,1.8,39.0018033,18.2716425,-0.3501981,13.9830921,13.9895352,5500.560143,5891.7286998,2.605935,421.1525694,393.3722329,783.8406117,22.572519,28.0896667,2.1329515,106.0032925),(43417,'femur.tif',229,7,124,128.2747666,38.6765734,19.2046081,1.8,39.0403162,18.3262251,-0.2456216,13.9953501,13.8970919,5364.4668054,5870.3825172,1.2640717,422.4180529,383.3035091,785.3866663,22.3703383,28.0222671,2.1567264,111.8603286),(43418,'femur.tif',229,7,125,124.3198323,38.8642294,19.138095,1.8,39.1056462,18.2225731,-0.1950621,13.6321984,13.9367846,4966.3565668,5549.0284801,0.7784299,398.1570103,364.3107618,724.7087063,21.9756807,27.5010461,2.1693582,110.5680011),(43419,'femur.tif',229,7,126,118.8835378,38.9356963,18.9705412,1.8,39.0296383,18.1130973,-0.4243356,13.4517859,14.4227415,4330.3378639,5040.6008589,3.35865,349.4897874,321.9154614,648.3867396,21.3177515,26.7220994,0.6576068,105.7282019),(43420,'femur.tif',229,7,127,114.3972636,38.8685585,18.8539306,1.8,38.9466163,18.1116071,-0.4564365,12.9402837,14.0175966,3671.6983341,4373.2599836,3.7038499,311.9835813,283.7417175,573.6821684,20.5588321,25.9049477,0.6564349,110.0983922),(43421,'femur.tif',229,7,128,106.7714257,38.664202,18.596343,1.8,38.6974084,17.9448918,-0.291318,11.90361,13.1871728,3003.2399849,3594.5956319,1.4679724,272.5827357,252.2965705,492.4355792,19.3556742,24.7510898,0.6443471,93.1642014),(43422,'femur.tif',229,7,129,89.3228182,38.3199216,18.1875309,1.8,38.3416276,17.6289394,-0.310341,10.7458059,12.3035876,2064.3753912,2773.7539899,1.3883593,225.442698,192.1098711,387.6028121,17.6943007,23.0044756,0.610726,93.6740965),(43423,'femur.tif',229,7,130,68.8073391,37.8267829,18.0245164,1.8,37.7975228,17.4780231,-0.2256691,9.2569705,10.7742542,1151.1419088,1909.8567011,0.5741732,177.2611517,124.3540643,276.4118322,15.4519205,20.704674,0.5837951,75.3670062),(43424,'femur.tif',229,7,131,45.9440769,37.1959271,18.1890485,1.8,36.9836258,17.6251946,-0.103293,7.5054815,8.7788136,447.4634534,1191.9535325,0.0814095,135.7761529,59.618221,180.2157917,6.6206818,12.8303437,1.0962003,37.0268165),(43425,'femur.tif',229,7,132,17.008939,33.2841639,17.7704202,1.8,33.36078,17.4960034,-1.0587295,2.2589202,4.4405036,19.4247635,74.4924343,2.1542377,16.7756725,8.5991367,20.77471,4.3929492,8.4314387,1.0793781,22.1060537),(43426,'femur.tif',229,7,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43427,'femur.tif',229,7,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43428,'femur.tif',229,7,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43429,'femur.tif',229,7,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43430,'tibia.tif',229,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43431,'tibia.tif',229,8,2,12.6269392,19.3204293,11.9132574,1.8,19.3364463,12.0603774,0.5163831,3.9071425,8.3719969,10.6690257,91.6526978,0.5130268,10.9475312,2.7306467,11.1210785,2.9608132,9.0678908,2.5119475,23.7645667),(43432,'tibia.tif',229,8,3,36.0734581,17.254023,11.529328,1.8,17.0734557,11.5004469,0.198446,5.0102588,9.9178759,106.8128737,772.1367693,0.2336752,77.8530382,21.3188335,87.5536409,6.7535892,17.8230039,2.9465012,48.4745155),(43433,'tibia.tif',229,8,4,68.0060802,16.9108384,11.2639721,1.8,16.8484677,11.3805088,0.0267347,6.7445729,9.8033657,479.2212549,1423.8485369,0.0080992,145.2407861,71.052869,194.019087,11.7448965,18.2850696,2.910502,66.0517879),(43434,'tibia.tif',229,8,5,93.5013205,16.3536005,12.6831237,1.8,16.3272087,12.7212788,-0.1800989,7.6707152,8.7540041,1022.9075625,1657.8876389,0.5000209,189.3862076,133.352307,290.3699238,13.8542517,17.4192616,2.9724914,59.9958747),(43435,'tibia.tif',229,8,6,89.2621969,16.0464757,13.6363071,1.8,15.9123759,13.4721044,-0.3651329,6.7604266,8.4685861,1025.5957166,1495.3451964,1.8968436,176.5755436,151.7057682,290.8834752,13.0859127,16.7090841,0.2404194,53.0051022),(43436,'tibia.tif',229,8,7,74.6289566,15.6467097,13.988222,1.8,15.4929185,13.8528344,-0.2745659,6.5538703,7.8002529,875.8825195,1170.9164186,0.9143415,150.1126217,133.6435536,242.3221367,12.6386708,15.636447,0.3556359,49.2928752),(43437,'tibia.tif',229,8,8,68.2697876,15.1036637,14.145868,1.8,15.0840058,14.1054634,-0.1605536,6.377766,7.7958734,754.7922149,1030.8995519,0.2907921,132.2365692,118.34743,218.9476887,12.5331898,15.2337607,2.7240662,47.6492438),(43438,'tibia.tif',229,8,9,58.6347313,15.0612644,14.2212381,1.8,15.0044289,14.2770754,-0.0851363,6.588913,8.0963601,707.0101615,907.2373632,0.0706617,112.0549672,107.3030042,194.0707714,12.7551522,15.600652,2.644924,48.584103),(43439,'tibia.tif',229,8,10,51.3547537,14.9573454,14.1499829,1.8,14.9396775,14.3280636,0.134676,6.7018024,8.3331519,624.7365716,812.3685886,0.1543059,97.4863528,93.2191877,171.6898087,12.7072024,15.8692191,2.7843664,47.587912),(43440,'tibia.tif',229,8,11,47.179102,14.7865696,14.2689648,1.8,14.7916048,14.4315906,0.1644634,6.7734871,8.2043793,563.9039249,768.3594166,0.2107744,93.6523523,83.2516422,162.3816065,12.5419458,15.8083138,2.7758454,46.7038617),(43441,'tibia.tif',229,8,12,45.3494277,14.6862241,14.4906217,1.8,14.6393058,14.6158783,0.1491628,6.9570821,8.0172927,549.2888393,703.8201983,0.1669238,87.7877638,78.9539106,156.1764794,12.400566,15.4747173,2.8605049,46.0038069),(43442,'tibia.tif',229,8,13,41.327738,14.517152,14.6539451,1.8,14.4583691,14.8128225,0.0545971,6.9819692,7.5651269,509.7552286,601.6848856,0.0205115,79.5340113,73.0102371,145.7817883,11.985342,14.756759,2.8759629,44.4617934),(43443,'tibia.tif',229,8,14,39.0023234,14.398576,14.8268491,1.8,14.3324483,14.953197,-0.0399882,6.792351,7.1324908,484.6785355,538.0448747,0.0103889,75.4357616,71.3565203,138.5407763,11.6863874,14.0082971,2.7985687,43.2413207),(43444,'tibia.tif',229,8,15,37.4355797,14.2357184,14.9215906,1.8,14.1615298,15.0516642,-0.2750297,6.2840214,6.5730667,463.2882532,502.0617302,0.460166,76.3816571,73.7248049,134.9604967,11.4289628,13.5099524,2.8345469,42.2915799),(43445,'tibia.tif',229,8,16,36.3881434,14.1371488,15.0954236,1.8,14.039583,15.2189674,-0.5184687,5.6436034,6.0714085,435.9014919,477.5997141,1.489309,78.6637424,77.2381509,133.8732334,11.2212648,13.2013378,1.1888172,40.9843709),(43446,'tibia.tif',229,8,17,35.4713098,13.9658165,15.1094863,1.8,13.8997545,15.2186205,-0.5693717,5.5979909,6.1528609,401.6992159,465.0084644,1.7181833,75.5759755,71.7577472,130.5947339,10.9946641,12.8478467,1.2645085,40.504239),(43447,'tibia.tif',229,8,18,34.7246967,13.8731324,15.1370223,1.8,13.802356,15.251619,-0.5196412,5.427965,6.0104628,378.7868959,446.626139,1.427072,74.3081112,69.7843291,126.50923,10.8099055,12.6492165,1.2333403,39.3705027),(43448,'tibia.tif',229,8,19,33.7218126,13.7779841,15.2108186,1.8,13.6958322,15.2925598,-0.3855053,5.5369666,5.9337446,353.3802102,427.1596835,0.7946915,71.988215,63.8219866,121.6125053,10.5179536,12.219437,1.2300779,38.3953573),(43449,'tibia.tif',229,8,20,32.584898,13.6839008,15.2385729,1.8,13.6546979,15.3437139,-0.3644977,5.3755203,5.8294818,321.4210528,406.8809532,0.6901374,69.7971051,59.7934779,117.5426504,10.2653658,11.8842576,2.8923405,37.6190892),(43450,'tibia.tif',229,8,21,31.7814495,13.5900415,15.3392743,1.8,13.5515394,15.4359693,-0.3123002,5.3331265,5.7975638,297.414253,393.2423203,0.5000366,67.8288905,55.7673356,114.5430788,10.1012732,11.6065988,2.9141177,36.3837349),(43451,'tibia.tif',229,8,22,30.817568,13.5679148,15.3646642,1.8,13.4142921,15.4214597,-0.337207,5.1472756,5.8127826,278.3727021,376.4600935,0.5622331,64.764179,54.0815614,109.957693,9.8811911,11.4812518,0.2206472,35.8168667),(43452,'tibia.tif',229,8,23,30.3005488,13.5050763,15.417989,1.8,13.3552938,15.5568799,-0.3466131,5.0682158,5.8133916,261.6685367,360.3688096,0.5828099,61.9894257,51.6293198,106.6448015,9.7488193,11.3559692,0.397628,35.1273348),(43453,'tibia.tif',229,8,24,30.4632283,13.4808699,15.4894263,1.8,13.3237018,15.6121827,-0.3808989,4.9143633,5.7528524,252.6482832,352.4147723,0.701679,61.2591373,51.4101762,104.7927452,9.5817819,11.2380714,0.3718561,34.7698666),(43454,'tibia.tif',229,8,25,29.9914976,13.4190747,15.5578787,1.8,13.2562099,15.6570755,-0.3713308,4.8302449,5.6912889,241.9430414,340.117407,0.6581353,59.761051,50.0891875,101.9229843,9.496519,11.1026444,0.3664968,34.2389258),(43455,'tibia.tif',229,8,26,29.9097703,13.3734763,15.6568409,1.8,13.2362835,15.7783269,-0.3804587,4.7796812,5.6106389,234.5167118,328.7874365,0.6874169,58.6007123,49.0653464,99.2954466,9.3665077,10.9954945,0.2403598,33.758794),(43456,'tibia.tif',229,8,27,29.3381927,13.3495228,15.7108656,1.8,13.2152921,15.8541825,-0.3713889,4.7128382,5.6685116,223.5138216,316.0109808,0.6439914,55.7484936,47.4265847,95.0428362,9.2829208,10.8696557,0.3644076,33.4880621),(43457,'tibia.tif',229,8,28,28.872644,13.3207612,15.8168416,1.8,13.2113824,15.9570941,-0.3928486,4.6243862,5.5369033,214.4662164,307.0395198,0.7052258,55.4532925,46.3772287,93.9714165,9.1569871,10.7127088,0.3805064,33.0692621),(43458,'tibia.tif',229,8,29,29.0584529,13.275828,15.8921816,1.8,13.1891307,15.9853054,-0.3800119,4.5586217,5.4715935,210.8414247,303.7144679,0.6663598,55.5074987,46.2511347,93.7078845,9.1503288,10.5948955,0.3217506,32.7731258),(43459,'tibia.tif',229,8,30,28.8468236,13.2644358,16.0040259,1.8,13.167549,16.0836247,-0.3907905,4.5138401,5.4712076,207.8318241,291.8141176,0.6976105,53.3363271,46.0432406,90.6803843,9.0500457,10.5638102,0.240171,32.3289213),(43460,'tibia.tif',229,8,31,29.1459329,13.1858934,16.0782085,1.8,13.0909841,16.156452,-0.3730394,4.4869172,5.3987234,204.6758327,288.81363,0.6452035,53.4966527,45.6161377,91.2986395,8.9549928,10.3964521,0.3281199,31.9460486),(43461,'tibia.tif',229,8,32,29.6957726,13.0805167,16.1531048,1.8,13.0105353,16.2202456,-0.3600476,4.4720289,5.2156042,204.1806698,286.0083134,0.6143487,54.8370435,45.6572785,93.5028096,8.9193332,10.2691438,0.3539974,31.9101213),(43462,'tibia.tif',229,8,33,29.9910703,13.0530213,16.1956082,1.8,12.9887546,16.2687385,-0.3440306,4.4576434,5.1835794,202.529512,280.0861413,0.5686338,54.0333462,45.4342108,92.6505545,8.9057421,10.1645318,0.2074962,31.6139849),(43463,'tibia.tif',229,8,34,30.3998212,12.9805772,16.2571123,1.8,12.9322435,16.32429,-0.3278787,4.4759688,5.1531899,202.8494326,274.6969775,0.525445,53.3062012,45.319671,92.6431375,8.8655653,10.0865834,0.1668552,31.2311123),(43464,'tibia.tif',229,8,35,30.7402942,12.9351202,16.2964615,1.8,12.8914751,16.3608955,-0.3218522,4.4197696,5.0983425,202.5966748,270.6528429,0.5126508,53.0864383,45.8387413,92.2963305,8.8165773,9.9948754,0.3980143,31.0217123),(43465,'tibia.tif',229,8,36,31.0948431,12.873412,16.3505488,1.8,12.8359364,16.421362,-0.3282119,4.4557871,5.0237234,203.4353547,264.5635153,0.5385113,52.6628343,45.6564356,93.1155924,8.8486725,9.8773786,0.3686959,31.0471167),(43466,'tibia.tif',229,8,37,31.3162722,12.8166219,16.3918948,1.8,12.7837102,16.4608973,-0.3268731,4.4346643,5.0203006,204.6677319,258.3896535,0.5380891,51.4689601,46.1517983,92.0421364,8.8594519,9.8807075,0.2681108,30.7255759),(43467,'tibia.tif',229,8,38,31.5946147,12.7378813,16.4353016,1.8,12.7190723,16.5067005,-0.3576656,4.4628872,4.9060274,207.7676829,251.1691563,0.645383,51.1960361,46.5545454,93.5361678,8.8759339,9.7123011,0.1952814,30.5521033),(43468,'tibia.tif',229,8,39,31.883808,12.6813869,16.4674406,1.8,12.6692795,16.5381,-0.336366,4.4395918,4.8443402,211.1955194,244.6726656,0.5788979,50.506912,47.5709323,93.4196365,8.87588,9.6619442,0.5218343,30.3427033),(43469,'tibia.tif',229,8,40,32.1691531,12.6306077,16.5079124,1.8,12.6277718,16.5844179,-0.3723627,4.5185429,4.7588357,213.0630403,240.22849,0.7096674,50.4805173,47.1530417,94.9413701,8.9281136,9.5363256,0.1543188,30.1692306),(43470,'tibia.tif',229,8,41,32.6497405,12.5998487,16.5453756,1.8,12.5831735,16.6253295,-0.370663,4.5327496,4.7597212,216.4359404,237.1987814,0.7140123,49.8345958,47.7493701,95.1423592,8.9444606,9.4971619,0.2449787,30.2813714),(43471,'tibia.tif',229,8,42,33.254066,12.5501664,16.5781897,1.8,12.5394415,16.6534595,-0.4542872,4.5643234,4.7022092,220.2365014,235.1918852,1.0672596,50.0173162,48.2517304,96.6824582,8.9763841,9.3763516,0.513606,30.2813714),(43472,'tibia.tif',229,8,43,33.7648447,12.5339785,16.6129342,1.8,12.5177254,16.6980972,-0.4885205,4.607014,4.6646743,223.0689545,232.6664755,1.2395145,49.8783971,48.4194216,97.4896861,8.973035,9.3347555,0.403419,30.0465669),(43473,'tibia.tif',229,8,44,34.2469675,12.5060699,16.6391313,1.8,12.4968117,16.7212686,-0.6692604,4.6701705,4.6352563,224.4315805,232.4041742,2.1969642,50.1383656,48.0563999,97.8193548,9.0042004,9.276444,0.2860514,29.995758),(43474,'tibia.tif',229,8,45,34.7326974,12.4746718,16.6611723,1.8,12.4586311,16.7532651,-0.9370698,4.5117005,4.6075743,225.736412,231.3813642,3.7589822,50.2176094,50.0335543,97.4419246,8.9848408,9.2385518,1.1629284,29.8984988),(43475,'tibia.tif',229,8,46,35.3152254,12.4329155,16.6889146,1.8,12.4268607,16.7929489,-1.139622,4.4600443,4.5644638,226.318186,232.496802,4.8577733,50.9362793,50.7434841,98.5468071,9.0016922,9.2349914,0.9953717,29.9852351),(43476,'tibia.tif',229,8,47,35.7284641,12.4124516,16.7134767,1.8,12.4058921,16.8120517,-1.3594871,4.4727285,4.5544562,225.2130627,233.561362,5.6927892,51.2819425,50.3525007,96.9212044,8.7948003,9.2159796,1.1987286,29.8984988),(43477,'tibia.tif',229,8,48,36.4394195,12.378505,16.7347616,1.8,12.3751524,16.8381129,-1.3189843,4.4892183,4.5451883,225.8695424,236.6451216,5.6962082,52.064976,50.3137801,99.4760522,8.8927835,9.2118155,1.0206305,29.7250261),(43478,'tibia.tif',229,8,49,37.0883753,12.3647896,16.7424864,1.8,12.3556383,16.8507333,-1.4197292,4.4662561,4.5788506,226.1196531,238.0381613,6.0413983,51.9864442,50.6284564,99.2320933,8.8474086,9.2941528,1.1777383,29.6890988),(43479,'tibia.tif',229,8,50,37.8654186,12.3435607,16.7439904,1.8,12.3422595,16.8550676,-1.3572136,4.4073797,4.591472,227.4834833,240.0215363,6.027366,52.2755093,51.6142243,100.2544302,8.7948003,9.2260845,1.0868469,29.8730943),(43480,'tibia.tif',229,8,51,38.5518089,12.32263,16.760887,1.8,12.3235647,16.8717136,-1.3330378,4.4913103,4.6274195,227.6551488,241.6490078,6.0688775,52.2211154,50.6879137,99.5269884,8.7772678,9.2545565,1.1881891,29.6382898),(43481,'tibia.tif',229,8,52,39.261193,12.3119781,16.7786608,1.8,12.3103515,16.8905115,-1.2960855,4.4543381,4.6084855,228.3997958,244.4696199,6.0620154,53.0477143,51.2758098,101.922635,8.7887091,9.2260845,1.0868469,29.576958),(43482,'tibia.tif',229,8,53,39.6840024,12.3132526,16.7885137,1.8,12.3156664,16.8910992,-1.2915936,4.4571166,4.642286,229.15781,244.1623342,6.1116704,52.5952801,51.4139144,101.6382451,8.7865764,9.276444,1.2133467,29.4542943),(43483,'tibia.tif',229,8,54,39.8392558,12.2935784,16.7931417,1.8,12.2927087,16.8952732,-1.1868,4.4880492,4.6064757,228.7759614,245.8516449,5.7079913,53.3708767,50.9744771,102.7692697,8.7948003,9.1945443,1.0460006,29.8730943),(43484,'tibia.tif',229,8,55,40.2299165,12.2907375,16.8087088,1.8,12.288268,16.8919834,-1.1541027,4.4832035,4.7061921,229.2289122,247.4621688,5.6066166,52.5822496,51.1306062,101.2708774,8.7863581,9.3347555,1.1673773,29.4796988),(43485,'tibia.tif',229,8,56,40.8496607,12.2950163,16.8172875,1.8,12.2852682,16.9091732,-1.1084588,4.4249186,4.6443203,232.0068047,249.8861111,5.4537501,53.8046681,52.4318806,103.699264,8.7787062,9.2752622,1.076855,29.6890988),(43486,'tibia.tif',229,8,57,41.1169315,12.3025737,16.8288057,1.8,12.2923668,16.9090285,-1.0779857,4.5154079,4.6802972,231.9295232,251.832939,5.318973,53.8070403,51.3640252,103.2713695,8.7759498,9.3188886,1.0920745,29.4796988),(43487,'tibia.tif',229,8,58,41.4223505,12.3064943,16.8373558,1.8,12.2897536,16.9140627,-1.0232868,4.4512181,4.6224536,233.7598405,253.6659182,5.0329176,54.876899,52.515926,105.0782047,8.7197273,9.2752622,1.076855,29.5410306),(43488,'tibia.tif',229,8,59,41.6746629,12.3090122,16.8425833,1.8,12.2897935,16.9142265,-0.9837413,4.3981397,4.6332192,235.1882371,255.2100644,4.8146877,55.0826663,53.4744809,104.2760696,8.7746461,9.3517678,1.1923689,29.7145032),(43489,'tibia.tif',229,8,60,41.9971999,12.3106415,16.8473344,1.8,12.2905167,16.9268203,-0.9070794,4.3835843,4.5512516,235.7795121,258.5581915,4.343096,56.8103495,53.7869234,105.1163692,8.6917008,9.3763516,1.1571071,29.5051032),(43490,'tibia.tif',229,8,61,42.2832321,12.3265599,16.8557306,1.8,12.3074261,16.9145936,-0.8657181,4.3090952,4.5494257,237.487759,261.1265311,4.0872026,57.3976908,55.1131386,106.1631572,8.6619877,9.3517678,1.1923689,29.7145032),(43491,'tibia.tif',229,8,62,42.3346827,12.3370028,16.8458612,1.8,12.3145935,16.9061375,-0.7873584,4.3152469,4.4482271,239.3237207,262.5123239,3.5417212,59.0150459,55.460029,106.5769073,8.6619877,9.4113598,1.2068174,29.7399077),(43492,'tibia.tif',229,8,63,42.4547076,12.3452768,16.8452926,1.8,12.3226709,16.9033819,-0.6979362,4.3569651,4.4921624,241.0546608,264.9136124,2.9221815,58.9724036,55.3262777,106.9705105,8.6619877,9.4311402,1.1717354,29.8012396),(43493,'tibia.tif',229,8,64,42.5782914,12.3471937,16.8558585,1.8,12.3112453,16.9064884,-0.6429126,4.4024524,4.4862498,242.3049762,269.8653837,2.5506891,60.1538915,55.0386362,107.922069,8.7679119,9.3909542,1.1820086,30.2813714),(43494,'tibia.tif',229,8,65,42.9935533,12.345849,16.8752523,1.8,12.3155754,16.9181295,-0.5754135,4.3431742,4.5732053,245.5775512,277.2321569,2.1219739,60.6209733,56.5433344,107.065364,8.6527116,9.4931211,3.0199736,30.0106396),(43495,'tibia.tif',229,8,66,43.0497667,12.3421218,16.8937467,1.8,12.3154893,16.9398067,-0.5342018,4.334208,4.5365583,248.1610556,280.9177957,1.8600227,61.9231093,57.2563787,107.6544109,8.70439,9.5644471,3.053906,30.2454441),(43496,'tibia.tif',229,8,67,43.2277921,12.3449714,16.9149441,1.8,12.3210103,16.9560769,-0.5242652,4.3321673,4.5866734,250.5668558,287.7530443,1.805318,62.7367637,57.8386845,109.4466824,8.6972288,9.5850552,3.0321417,30.6283167),(43497,'tibia.tif',229,8,68,43.6506057,12.3294876,16.94178,1.8,12.3200212,16.9857296,-0.5108467,4.4284662,4.6422767,253.9382514,296.0310426,1.7390323,63.7685043,57.3422574,112.2385709,8.7390103,9.6511598,2.878195,30.8123123),(43498,'tibia.tif',229,8,69,43.8676946,12.3596533,16.9514709,1.8,12.3473036,16.9782878,-0.4887768,4.3971323,4.6893722,257.277944,300.5674736,1.6119457,64.0954611,58.5103948,112.0458476,8.8501105,9.7280898,3.0012177,31.7007212),(43499,'tibia.tif',229,8,70,44.3560614,12.3720648,16.9785033,1.8,12.3672075,16.9992423,-0.4937371,4.3450671,4.6514879,261.0856627,307.9381797,1.6603962,66.2020813,60.0878328,114.5408936,8.8057343,9.7932289,3.0344773,31.4045849),(43500,'tibia.tif',229,8,71,44.73841,12.4125284,16.9873149,1.8,12.4082912,17.0011314,-0.4825705,4.4442339,4.7129374,264.4887346,315.8540056,1.6057327,67.0185018,59.5127842,116.0998987,8.8132833,9.7769848,2.9694018,31.4913212),(43501,'tibia.tif',229,8,72,45.2148424,12.4344118,17.0013913,1.8,12.4359116,17.0196488,-0.4576345,4.475141,4.7418026,269.4212747,323.1903665,1.4710751,68.1577014,60.2039748,117.4615215,8.8549967,9.8973352,3.0356083,31.2565167),(43502,'tibia.tif',229,8,73,45.6478301,12.4910419,17.012369,1.8,12.4848808,17.023245,-0.4584848,4.3920241,4.7856825,274.3444082,331.3479483,1.4902935,69.2373451,62.4642315,118.6993939,8.8886584,10.0014539,3.0367157,31.7007212),(43503,'tibia.tif',229,8,74,45.8404151,12.5264732,17.0316896,1.8,12.5230886,17.0342669,-0.4201201,4.4785798,4.9099772,278.6845019,337.4704071,1.2709867,68.7315623,62.2260884,120.4320426,9.0211706,10.0014539,2.9626755,31.8339078),(43504,'tibia.tif',229,8,75,46.0641538,12.5704798,17.0483409,1.8,12.5748431,17.04947,-0.3914886,4.524286,4.9608591,283.22728,344.4133109,1.1177599,69.4261423,62.6015422,121.0184528,9.0304516,10.0827789,2.8789836,31.7620531),(43505,'tibia.tif',229,8,76,46.2177069,12.6278649,17.0580188,1.8,12.6361999,17.0562598,-0.367685,4.5100318,5.0684836,288.5681526,353.3443508,0.9952883,69.7140173,63.9836179,121.121385,9.0381602,10.1903821,3.0593047,32.0327849),(43506,'tibia.tif',229,8,77,46.3886337,12.6915736,17.0691959,1.8,12.7001734,17.0653733,-0.36798,4.6121358,5.1684234,292.706492,361.4103176,1.0004998,69.9266075,63.4644134,121.8879913,9.0449159,10.2867421,3.0702852,32.0941168),(43507,'tibia.tif',229,8,78,46.5262484,12.7617344,17.0737352,1.8,12.7661441,17.0683695,-0.3555605,4.6266501,5.3201456,296.6714389,370.8019002,0.939711,69.6976979,64.1222983,123.3915104,9.1167079,10.3250343,0.111777,32.1554486),(43508,'tibia.tif',229,8,79,46.6307583,12.8341406,17.0725034,1.8,12.8426555,17.0680277,-0.3516288,4.6522189,5.3301198,300.4249216,377.1285596,0.9219695,70.7542364,64.576695,124.3425602,9.1485399,10.3990878,3.0609598,32.7117939),(43509,'tibia.tif',229,8,80,46.7838934,12.9087965,17.0977711,1.8,12.9030245,17.0989188,-0.3419897,4.6494008,5.4701207,303.9717544,386.5667578,0.8769471,70.6687804,65.378694,123.2789596,9.2046278,10.6000675,0.0691963,32.9825258),(43510,'tibia.tif',229,8,81,46.3066053,13.0018904,17.1099833,1.8,12.9942344,17.1002267,-0.3526519,4.6937646,5.6081507,306.8173698,386.9794338,0.920673,69.0030382,65.3670125,122.2049132,9.2612653,10.6372319,0.1084833,32.8090531),(43511,'tibia.tif',229,8,82,45.9368958,13.0953319,17.1366677,1.8,13.0795518,17.120804,-0.3430181,4.7130248,5.7024663,309.3598314,388.9045707,0.866052,68.1993633,65.6393385,121.1437441,9.3282944,10.8454246,0.1063929,33.3653984),(43512,'tibia.tif',229,8,83,45.9581349,13.1794769,17.1597649,1.8,13.1637537,17.1466257,-0.3652364,4.7684407,5.7590735,315.0165131,395.0112628,0.9771501,68.5893769,66.0627931,122.3013862,9.3691194,10.8099902,0.5503859,33.7228666),(43513,'tibia.tif',229,8,84,45.9839835,13.2701265,17.1669481,1.8,13.24219,17.1496625,-0.3933742,4.8451197,5.8408321,319.7796353,403.7881652,1.1260273,69.1319591,66.0003576,122.3768487,9.4023285,11.0094432,0.5616235,33.758794),(43514,'tibia.tif',229,8,85,45.9183966,13.3368736,17.1955002,1.8,13.3191125,17.1720379,-0.4040422,4.8413935,5.9392899,322.6991826,410.7877227,1.1828403,69.164451,66.654194,122.2278015,9.4763626,11.1440355,0.4678493,33.9935985),(43515,'tibia.tif',229,8,86,45.5835094,13.447104,17.2036696,1.8,13.4051497,17.1769345,-0.4353756,4.8588663,6.0501456,327.9277747,417.2629888,1.3513525,68.9674298,67.4905947,121.5110071,9.5503967,11.2969315,0.6008554,34.3002577),(43516,'tibia.tif',229,8,87,45.5454056,13.5423257,17.2337472,1.8,13.4915139,17.1908627,-0.4606914,4.9822761,6.0940517,335.0409029,422.0345865,1.5002676,69.2535293,67.2465548,122.6215587,9.6244308,11.4425178,0.6032299,35.1632622),(43517,'tibia.tif',229,8,88,45.6143579,13.6399453,17.2300286,1.8,13.5816983,17.1872497,-0.5140273,5.0459973,6.1311845,342.3397846,427.9539121,1.8379331,69.7995486,67.8438306,123.4678711,9.681766,11.4931804,0.5247958,35.015194),(43518,'tibia.tif',229,8,89,45.7685618,13.7262925,17.2287131,1.8,13.6573902,17.2006498,-0.5410353,5.0985233,6.2090764,349.8844758,434.8703265,2.0233474,70.0378448,68.62467,122.9553798,9.7724989,11.644787,0.5805214,35.3367348),(43519,'tibia.tif',229,8,90,45.9359403,13.7731346,17.2279182,1.8,13.7059127,17.1953459,-0.5820196,5.2011199,6.2680969,357.9388453,443.9089138,2.313513,70.8203653,68.8195718,124.6958091,9.8353119,11.8315637,0.6346518,36.0262667),(43520,'tibia.tif',229,8,91,46.1192444,13.8483426,17.2204739,1.8,13.751406,17.2059299,-0.6262868,5.2678673,6.2781666,365.2233129,452.0831356,2.6407917,72.0087827,69.330393,125.6712065,9.8461151,11.9086762,0.5660549,36.2356667),(43521,'tibia.tif',229,8,92,45.8525111,13.9134407,17.2167918,1.8,13.810061,17.1873254,-0.6725448,5.3830832,6.2778722,370.8412592,458.5461995,2.9659119,73.0416589,68.8901217,126.317445,9.9060428,11.9656119,0.6049913,36.2102622),(43522,'tibia.tif',229,8,93,45.6955016,13.9940627,17.2105141,1.8,13.8882123,17.1882289,-0.6860429,5.4140401,6.3997522,378.1513159,467.5983201,3.0562472,73.0650663,69.8464189,125.8924717,10.037936,12.1974381,0.6022873,36.9251986),(43523,'tibia.tif',229,8,94,45.5489981,14.0302591,17.2095604,1.8,13.9491608,17.1831183,-0.7286824,5.526996,6.3958006,386.0506975,477.696968,3.3661149,74.6891596,69.8481953,128.2400762,10.0870373,12.3123822,0.5856441,37.0478623),(43524,'tibia.tif',229,8,95,45.7031503,14.096858,17.1977557,1.8,13.9916396,17.1995084,-0.7882086,5.6346698,6.3154242,393.2898426,493.2507329,3.8300031,78.1025503,69.7982064,131.1374131,10.0892389,12.3337316,0.6468967,37.7268712),(43525,'tibia.tif',229,8,96,45.4499448,14.1756723,17.1913213,1.8,14.0542275,17.2181941,-0.8298975,5.6228982,6.2942346,399.9768545,503.4235474,4.1241328,79.9816943,71.1335755,133.413058,10.1829224,12.46106,0.6603062,38.3191439),(43526,'tibia.tif',229,8,97,44.9798243,14.2578591,17.1682641,1.8,14.1288654,17.192552,-0.8955172,5.7100706,6.1959214,405.4781514,511.5754824,4.5671839,82.5664898,71.0110581,133.7673533,10.2459444,12.5242388,0.6251085,38.2937394),(43527,'tibia.tif',229,8,98,44.5338217,14.3275765,17.1266511,1.8,14.1841837,17.1805085,-0.9205002,5.7781453,6.3448405,411.3628552,519.8248926,4.7017627,81.928757,71.1928887,135.1086538,10.2582494,12.5905836,0.6734422,38.6258031),(43528,'tibia.tif',229,8,99,44.129289,14.4033806,17.0669259,1.8,14.2569488,17.1363373,-0.9603876,5.8177066,6.311168,416.7574892,525.6914979,4.9383538,83.2954377,71.636045,134.8806963,10.3073616,12.6725937,0.6682894,39.8462758),(43529,'tibia.tif',229,8,100,43.8706839,14.4871253,17.0359225,1.8,14.3325462,17.1183491,-0.9938109,5.9360772,6.3159404,425.8171799,533.1290742,5.1360132,84.4100862,71.7337676,135.5277009,10.4358254,12.8196594,0.6696389,39.2031942),(43530,'tibia.tif',229,8,101,43.2200201,14.5612733,16.9957283,1.8,14.3988423,17.0847764,-1.0509573,5.9243013,6.2230987,431.5055705,539.7562287,5.4259059,86.7343186,72.8365339,135.4265299,10.4511059,12.8559497,0.6989093,39.784944),(43531,'tibia.tif',229,8,102,42.7795958,14.6516834,16.9364985,1.8,14.4767435,17.0297102,-1.1093492,5.9147096,6.1182633,435.6067264,547.3579215,5.716477,89.4629563,73.6480331,136.0066228,10.5105023,12.9362776,0.693702,40.0916032),(43532,'tibia.tif',229,8,103,42.3060221,14.7066223,16.8980995,1.8,14.529203,17.0075185,-1.1782111,5.9209761,6.3444601,440.2497737,556.1271185,6.0189755,87.6555472,74.3542561,138.3203668,10.5843371,12.9362776,0.693702,40.152935),(43533,'tibia.tif',229,8,104,42.003541,14.8020562,16.8681506,1.8,14.6124714,16.9924734,-1.2233052,5.8609175,6.4030523,446.0401219,568.9150576,6.1887495,88.8506033,76.1041464,139.016285,10.6368255,13.0333633,0.8081215,40.9546077),(43534,'tibia.tif',229,8,105,41.6574282,14.880047,16.7953297,1.8,14.6918401,16.9304205,-1.27252,5.8020031,6.519385,450.367017,577.3218687,6.3433059,88.5546523,77.622678,138.4365128,10.6443556,13.1913695,0.8303118,40.9037987),(43535,'tibia.tif',229,8,106,41.2324639,14.9885802,16.7057147,1.8,14.7616157,16.8433967,-1.3516138,5.695627,6.6505853,451.7862933,587.0404168,6.5471891,88.2689848,79.3216079,138.4584381,10.7037411,13.268841,0.7351611,41.2866714),(43536,'tibia.tif',229,8,107,40.6828871,15.0858307,16.6108532,1.8,14.8654327,16.749173,-1.4283447,5.9091621,6.7136601,453.4880324,595.2074479,6.6438166,88.6561784,76.7432046,138.3905314,10.8709345,13.2985492,0.8690017,41.9043485),(43537,'tibia.tif',229,8,108,40.1808345,15.165738,16.5164881,1.8,14.9479316,16.6516511,-1.480302,6.0302686,6.8289583,453.7358979,600.4689454,6.6421136,87.9298017,75.2430657,138.0109468,10.8401672,13.3663816,0.8630197,41.9762033),(43538,'tibia.tif',229,8,109,40.5940008,15.2209366,16.4104769,1.8,15.011671,16.5546104,-1.5169204,6.1134546,6.9413859,459.697531,622.725912,6.7460477,89.7120435,75.194397,140.2794806,10.9362468,13.4933082,1.9440982,42.3336714),(43539,'tibia.tif',229,8,110,40.6321686,15.2825863,16.3000207,1.8,15.0633598,16.4435346,-1.555551,6.2260745,6.9745796,457.7929864,647.4588989,6.7704543,92.8312438,73.5283508,143.8328361,11.006808,13.6291096,1.9484496,42.2828625),(43540,'tibia.tif',229,8,111,41.6364039,15.4104293,16.1497048,1.8,15.1884743,16.3249762,1.5613552,6.3444961,6.9478414,461.7499996,684.228754,6.9387821,98.4807682,72.779617,147.0971077,11.0808955,13.8473425,1.9260272,42.6403306),(43541,'tibia.tif',229,8,112,42.0194199,15.484467,16.0457522,1.8,15.2638104,16.2202003,1.5263191,6.4683101,7.1852418,455.9827475,713.4748452,6.9893918,99.2972627,70.4948803,149.7811142,11.0801127,14.1189809,1.8103794,43.1099396),(43542,'tibia.tif',229,8,113,41.7695921,15.598836,15.9848942,1.8,15.3511577,16.1461654,1.4987263,6.5908805,7.2467154,450.4329825,731.7056528,6.9255021,100.9706617,68.3418525,150.5360877,11.2267796,14.2714978,1.9622015,43.5900715),(43543,'tibia.tif',229,8,114,41.4977252,15.6788871,15.8550922,1.8,15.4380327,16.0403708,1.4735555,6.7733948,7.3649594,440.5784842,757.8165722,6.8510945,102.8948749,65.0454463,152.6801478,11.1894112,14.5261587,1.8035378,43.7889486),(43544,'tibia.tif',229,8,115,42.2446865,15.7461891,15.6701725,1.8,15.5029305,15.8891114,1.4618707,6.7203736,7.3920044,435.8230555,800.3076792,6.9575736,108.2666676,64.8510156,155.455747,11.2654645,14.729992,1.800259,44.3663397),(43545,'tibia.tif',229,8,116,41.9269928,15.7800633,15.6150376,1.8,15.5291847,15.8134239,1.471789,6.6859983,7.5435699,430.7537788,819.717214,6.9195578,108.6643622,64.4262472,156.3543874,11.2163062,15.013046,1.7887088,45.1066805),(43546,'tibia.tif',229,8,117,42.1730698,15.8282425,15.4982413,1.8,15.5713062,15.7119422,1.477502,6.7118155,7.6172654,430.3654046,854.3592789,6.9678444,112.1608915,64.1205652,159.9922349,11.2775554,15.0840697,1.8090411,45.2547487),(43547,'tibia.tif',229,8,118,42.0799132,15.8223273,15.3505293,1.8,15.5808926,15.570802,1.4867149,6.5847186,7.7779834,427.1422738,891.7083364,6.9638537,114.6451843,64.8687211,160.9878987,11.3457872,15.3423915,1.9335606,45.500076),(43548,'tibia.tif',229,8,119,42.8880601,15.8902436,15.1856677,1.8,15.6410173,15.4206798,1.4863727,6.57231,7.9237637,424.6268866,949.8757549,7.0971846,119.8768402,64.6084688,166.0710354,11.298185,15.5753353,1.9350744,45.5719308),(43549,'tibia.tif',229,8,120,43.5040991,15.9284152,15.0057679,1.8,15.6492623,15.2517454,1.4819506,6.5912439,8.0813625,415.4641155,1013.0034024,7.1935999,125.3505705,63.0327325,170.9904219,11.3173222,15.9312677,1.9195673,46.3736034),(43550,'tibia.tif',229,8,121,44.5720678,15.9315852,14.6775827,1.8,15.6453329,15.004004,1.4805712,6.582107,8.0685239,409.1382985,1093.0598536,7.3683682,135.4720969,62.1591689,178.0051125,11.2029004,16.236942,1.9333406,47.2725353),(43551,'tibia.tif',229,8,122,45.3348922,15.92826,14.433184,1.8,15.6260489,14.7069368,1.4823955,6.4958873,8.2592313,403.4805267,1178.595208,7.4969225,142.7003507,62.1132276,183.5319665,11.2029004,16.720889,1.8826462,47.5791945),(43552,'tibia.tif',229,8,123,46.3809697,15.9092591,14.2208529,1.8,15.6090321,14.508276,1.4759426,6.4632562,8.5626535,399.2179036,1274.5791753,7.66082,148.853293,61.7673026,193.8445584,11.1650506,17.1838832,1.8867666,48.6410762),(43553,'tibia.tif',229,8,124,47.4403465,15.8216447,13.9134672,1.8,15.5700424,14.308188,1.456851,6.4843163,8.7099947,392.1728671,1387.5529544,7.8045108,159.3058327,60.4802186,198.7005758,10.9935004,17.7141145,1.8832014,50.0963533),(43554,'tibia.tif',229,8,125,47.8340719,15.7867042,13.7906971,1.8,15.5405491,14.1091095,1.4525962,6.3780586,9.210683,399.6755454,1462.2219751,7.8614793,158.7528276,62.6641383,201.7594491,11.0982004,18.2766746,1.8853006,51.6996987),(43555,'tibia.tif',229,8,126,47.4286403,15.7129238,13.6231127,1.8,15.4282418,13.8103454,1.4403813,6.3796679,9.7185307,392.2684481,1544.8605605,7.7710889,158.9603007,61.4872835,198.7484606,11.0755506,19.0384226,1.8838514,52.0930942),(43556,'tibia.tif',229,8,127,48.2326953,15.6339108,13.5352272,1.8,15.3850816,13.6559784,1.4316286,6.4687746,10.7672011,399.2427563,1671.7056412,7.8840928,155.2590717,61.7184526,192.1863001,11.0982004,20.0994013,1.8777209,53.9925759),(43557,'tibia.tif',229,8,128,47.5489462,15.5963434,13.3551799,1.8,15.3474426,13.1872536,1.4180104,6.5074216,11.4083433,395.1714833,1737.7217787,7.7412659,152.3202562,60.7262768,186.521737,11.2011801,21.0611026,1.8736812,55.8666531),(43558,'tibia.tif',229,8,129,47.1634817,15.4939267,13.048474,1.8,15.2176959,12.7393747,1.3980661,6.5561157,12.0661871,389.4850529,1889.6009495,7.6283773,156.6029878,59.4078982,188.6860031,11.1938211,22.0231176,1.8699943,58.3838119),(43559,'tibia.tif',229,8,130,47.2917136,15.4011998,12.8413986,1.8,15.1498131,12.4948484,1.3824804,6.6979598,12.4207214,387.7103316,1994.8593181,7.605724,160.6073641,57.8848405,191.1350744,11.2029004,22.7488318,1.9085572,59.7015438),(43560,'tibia.tif',229,8,131,48.6718123,15.229864,12.6711756,1.8,15.0310144,12.3518928,1.3693604,6.6611914,12.6868056,404.6615377,2193.4259689,7.787242,172.8903266,60.7491237,203.5290286,11.3379852,23.2954568,1.9337753,61.6772389),(43561,'tibia.tif',229,8,132,48.9841994,15.1764945,12.5121691,1.8,14.9807525,12.2994364,1.3588405,6.6799298,12.8193319,403.4406875,2333.3660812,7.8027214,182.0193209,60.3959468,212.7204985,11.384502,23.6151318,1.9191885,61.83583),(43562,'tibia.tif',229,8,133,51.0260042,15.0686796,12.4711401,1.8,14.9473761,12.3875224,1.3503512,6.7567675,12.8332094,413.7891843,2474.2806079,8.0977083,192.802948,61.2407021,224.0801017,11.4630381,23.7241985,1.9316331,62.085516),(43563,'tibia.tif',229,8,134,50.4811821,15.006709,12.5149363,1.8,14.8911219,12.41121,1.3455415,6.6908683,12.7974925,420.1145871,2477.5145046,7.9938018,193.5937456,62.7892479,226.0285135,11.4706201,23.6431991,1.909352,62.5761708),(43564,'tibia.tif',229,8,135,50.0885823,14.9810878,12.544123,1.8,14.8673273,12.4924215,1.3445413,6.6884441,12.5383292,425.5296026,2459.9568422,7.9279896,196.1949472,63.6216127,229.5643232,11.5189466,23.3933644,1.9321862,61.8253071),(43565,'tibia.tif',229,8,136,50.6233601,15.0397465,12.6106513,1.8,14.9589637,12.5648028,1.3374809,6.8719248,12.3704003,433.342529,2468.2272106,7.9862109,199.526867,63.0598476,234.2027338,11.6419949,23.1500683,1.9168625,61.2076299),(43566,'tibia.tif',229,8,137,48.8923148,14.9950237,12.730648,1.8,14.888365,12.5364183,1.3456449,6.8114799,12.07174,436.4629394,2284.4438836,7.742568,189.2389893,64.0775498,225.2868921,11.6755889,22.7317188,1.9333406,61.3959842),(43567,'tibia.tif',229,8,138,49.2684154,15.0206756,12.9200335,1.8,14.974271,12.6083806,1.3461105,6.8472604,11.9002864,462.668261,2240.6192918,7.8037896,188.2828046,67.5698361,226.8135568,11.9102684,22.4880888,1.9175785,61.1103707),(43568,'tibia.tif',229,8,139,49.4996265,14.9350199,12.9153484,1.8,14.9242184,12.7616921,1.3464547,6.9206973,11.3838704,471.0107114,2234.7985149,7.8416443,196.3127151,68.0582738,237.6628282,12.0313208,22.1652654,1.9942964,60.8860891),(43569,'tibia.tif',229,8,140,50.2603695,14.9819659,13.2367443,1.8,14.996129,13.0198273,1.3311923,7.1358503,11.5178409,503.7827755,2222.1806499,7.9049522,192.9337861,70.5988428,235.4754786,12.2239584,22.252138,2.0028755,60.9982299),(43570,'tibia.tif',229,8,141,49.4954549,14.886996,13.311731,1.8,14.9289041,13.2021197,1.3164459,7.2400634,11.8101468,514.8920524,2205.3711907,7.7269746,186.7352897,71.1170638,229.7463422,12.352566,22.68586,1.9890207,61.9374479),(43571,'tibia.tif',229,8,142,50.2310509,14.8553561,13.5309429,1.8,14.925772,13.4327521,1.302748,7.5547073,11.8671872,541.3535721,2250.4590114,7.7845948,189.6371033,71.6577826,235.1077827,12.5724023,22.68586,1.9890207,64.3573475),(43572,'tibia.tif',229,8,143,50.4429007,14.7191701,13.5890877,1.8,14.8464186,13.5521958,1.2988483,7.6229581,11.8435554,563.7187564,2287.9743177,7.8005702,193.1830633,73.9501317,240.5834597,12.6641642,22.9541477,2.0038412,62.7899295),(43573,'tibia.tif',229,8,144,51.2701453,14.5742921,13.629089,1.8,14.745127,13.6171491,1.305887,7.6785289,11.6762464,590.8164163,2302.6426567,7.9592573,197.2074399,76.9439593,247.7646065,12.8843829,22.8773702,1.9853032,64.6429609),(43574,'tibia.tif',229,8,145,52.8051557,14.5671545,13.7408629,1.8,14.7660167,13.8227311,1.2922893,7.9600908,11.7203138,621.3932624,2357.2465475,8.135679,201.1248656,78.0635893,254.1231449,13.1650095,23.1536194,1.9899389,66.0728336),(43575,'tibia.tif',229,8,146,53.2267218,14.5371703,13.8042755,1.8,14.8185012,13.9211398,1.2779242,8.2167696,11.6030272,652.8633871,2419.0655376,8.1317165,208.485725,79.4549949,264.7438452,13.4409107,23.1443853,2.0000446,68.1563108),(43576,'tibia.tif',229,8,147,55.6929783,14.3975976,13.9490526,1.8,14.7532373,14.1160085,1.2784188,8.3104954,11.6712061,716.9581122,2496.9842798,8.5110348,213.9439805,86.2714052,273.545116,13.7732205,23.3783645,2.000389,67.2468561),(43577,'tibia.tif',229,8,148,57.0871901,14.3106103,14.0602105,1.8,14.7117003,14.250071,1.2719252,8.5739658,11.6427964,788.9410319,2563.5380715,8.6896612,220.1823326,92.0158829,281.0591378,14.2349014,23.4663519,2.0085017,67.6507745),(43578,'tibia.tif',229,8,149,61.185471,14.1891301,14.2880056,1.8,14.6222674,14.5380457,1.263433,8.8743616,11.7862465,906.1248866,2723.6947394,9.2641491,231.0909361,102.1059238,302.9213701,14.720624,23.7075583,1.9988858,69.0955288),(43579,'tibia.tif',229,8,150,65.4029434,13.8992929,14.3772456,1.8,14.4294678,14.789053,1.2745859,9.2044686,11.7843523,1049.8930066,2882.2712125,9.9717217,244.5846103,114.0634024,319.5569215,15.3691939,23.8901917,2.0638472,70.8828697),(43580,'tibia.tif',229,8,151,67.0851966,13.8160544,14.7483421,1.8,14.305548,15.2112903,1.2777019,9.6314993,11.9901106,1205.5817405,2960.803947,10.2475714,246.9371669,125.1707246,337.9954479,16.1352739,24.3041615,2.049857,71.6845423),(43581,'tibia.tif',229,8,152,73.5276634,13.6137247,15.0448973,1.8,14.0665936,15.7596085,1.2604818,10.1172956,12.1202999,1414.4522628,3322.8288211,11.1119467,274.1540101,139.8053709,374.0666314,16.8621676,24.6312184,2.0477511,73.7215693),(43582,'tibia.tif',229,8,153,82.1241179,13.3592369,15.9323672,1.8,13.8531647,16.6251366,1.3056982,10.925037,12.659851,1864.7245398,3719.6810038,12.7477699,293.8171236,170.68359,437.3002435,18.3020048,25.1098901,2.0661497,92.5893636),(43583,'tibia.tif',229,8,154,97.5586034,13.0809161,16.8932917,1.8,13.5222827,17.5221511,1.3873606,11.03767,13.3345109,2432.0272425,4703.2459756,15.7187568,352.712298,220.3388257,533.790439,19.1655288,25.4438244,2.1062759,93.0738542),(43584,'tibia.tif',229,8,155,117.9463509,12.6058961,17.353964,1.8,12.9765197,17.9359167,-1.5259804,11.218533,13.1804117,3446.3122681,5630.999309,19.6182696,427.2248413,307.1981219,675.8042735,21.1883334,25.3116456,2.0807072,86.7682549),(43585,'tibia.tif',229,8,156,116.1433966,12.8785621,18.0429984,1.8,12.7190022,18.3544395,1.5665585,12.1680351,13.6579012,3686.5531833,5402.8067142,19.3568851,395.5810363,302.9702947,651.2377455,22.0382947,25.177249,2.1668726,91.8236183),(43586,'tibia.tif',229,8,157,110.7356328,12.7160927,18.0189425,1.8,12.5451343,17.8924024,1.4187477,13.106141,13.6526956,3621.0069216,5092.6923093,18.0325378,373.0173473,276.2832256,635.3588407,22.0721883,25.1715882,2.2026507,85.5434235),(43587,'tibia.tif',229,8,158,109.838035,13.0483778,17.3432587,1.8,12.7079008,17.0582492,1.0536543,13.3240082,12.8724981,3452.543725,4692.0957845,13.8317342,364.5054558,259.1220056,607.9708405,21.0117295,24.7599461,2.2633689,81.0400467),(43588,'tibia.tif',229,8,159,101.1025855,12.7913132,15.9046755,1.8,12.5876216,15.8090104,0.968414,11.9102331,11.7534742,2646.289196,3717.8638482,11.4407074,316.3204151,222.1861807,504.1854285,19.2906663,23.478261,2.3278109,75.1049918),(43589,'tibia.tif',229,8,160,96.7702448,12.6611365,15.2165356,1.8,12.6575749,15.0438458,1.1441712,9.8307579,10.4961271,1812.4181057,2754.5186777,13.3666955,262.4319107,184.3619914,396.7470365,16.8441232,20.9622378,2.3879859,69.5484507),(43590,'tibia.tif',229,8,161,65.3530093,13.4187158,14.5884881,1.8,13.162752,14.3540213,1.4034156,8.4312725,9.8731829,565.3150339,1692.9716987,10.5898492,171.4717245,67.0497881,225.41,13.09753,19.1818294,1.6856729,84.822323),(43591,'tibia.tif',229,8,162,30.702863,12.9108628,14.9984686,1.8,12.8502936,14.2633591,1.5055003,3.7708203,8.5659816,58.4768527,732.7018035,5.0953575,85.5362332,15.5077274,92.3439835,6.8551098,8.2918173,2.3561945,27.002826),(43592,'tibia.tif',229,8,163,4.7454799,12.3483694,10.3287221,1.8,12.3940609,10.5747004,1.2769313,2.0022348,2.6357196,3.320466,5.0490083,0.7245563,1.915609,1.6583799,3.0881581,3.8961301,4.7404943,2.3874343,15.8810265),(43593,'tibia.tif',229,8,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43594,'tibia.tif',229,8,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43595,'tibia.tif',229,8,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43596,'tibia.tif',229,8,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43597,'tibia.tif',229,8,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43598,'tibia.tif',229,8,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43599,'tibia.tif',229,8,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43600,'tibia.tif',229,8,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43601,'tibia.tif',229,8,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43602,'tibia.tif',229,8,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43603,'tibia.tif',229,8,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43604,'tibia.tif',229,8,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43605,'metatarsus.tif',229,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43606,'metatarsus.tif',229,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43607,'metatarsus.tif',229,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43608,'metatarsus.tif',229,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43609,'metatarsus.tif',229,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43610,'metatarsus.tif',229,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43611,'metatarsus.tif',229,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43612,'metatarsus.tif',229,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43613,'metatarsus.tif',229,10,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43614,'metatarsus.tif',229,10,10,0.138496,12.1765332,6.8838875,1.8,12.1775473,6.8797977,0.7492992,0.2665535,0.5464344,0.0009824,0.0094556,0.0107088,0.0173041,0.0036855,0.0190029,0.4765773,1.0552022,2.4370986,2.646793),(43615,'metatarsus.tif',229,10,11,3.2284377,12.6910305,7.9905824,1.8,12.7485474,8.107462,1.1626499,1.1932438,5.5639226,0.5078392,16.8450123,0.4533068,3.0275425,0.4255955,3.0734187,1.631465,3.3894585,2.1620884,9.2032305),(43616,'metatarsus.tif',229,10,12,17.9560845,14.89559,8.9671292,1.8,15.0315549,8.9975114,0.6656547,4.2340975,4.8345673,57.8285857,103.2829016,1.1414022,21.363422,13.6578306,30.6863184,7.2296961,9.5585595,2.8690699,38.1878028),(43617,'metatarsus.tif',229,10,13,32.2975112,15.8423684,8.7430293,1.8,15.8961617,8.8082413,-0.0584998,4.9521189,5.9203809,130.5683207,211.7792553,0.0184006,35.7712214,26.3661521,57.8205463,8.3515439,11.053904,2.9327853,34.9334793),(43618,'metatarsus.tif',229,10,14,37.1212774,16.0046273,8.7744885,1.8,16.0699097,8.8712596,-0.0790028,5.4417339,6.2645204,176.8958678,245.1675986,0.0385347,39.135893,32.5072615,67.3238936,9.144906,11.4423215,3.0747908,36.7177474),(43619,'metatarsus.tif',229,10,15,37.0748794,15.9696099,8.9709621,1.8,16.0483035,9.0708887,0.0282067,5.5224447,6.1609465,176.9008902,249.9673348,0.0049149,40.5728787,32.033076,68.1594194,8.8836178,11.5846472,3.0512469,36.2336738),(43620,'metatarsus.tif',229,10,16,35.8575219,15.9147876,8.965999,1.8,15.9838598,9.0357808,-0.0508335,5.1520085,6.2022845,171.4461791,249.2001443,0.0154296,40.1787673,33.2775422,67.3009835,8.5393136,11.6113304,3.0653518,36.1371126),(43621,'metatarsus.tif',229,10,17,33.643257,15.8277074,8.8467852,1.8,15.9097152,8.9009436,-0.0879705,4.9107978,6.1828313,154.454774,244.4315554,0.0432812,39.5339196,31.4520738,64.3625447,8.2408182,11.779698,3.1279416,36.3588043),(43622,'metatarsus.tif',229,10,18,31.8559297,15.7609963,8.7212424,1.8,15.8564142,8.7799055,-0.1234657,4.7011405,6.0802713,140.0533658,241.6902736,0.0805238,39.7499163,29.7913593,62.781556,8.0596117,11.6222508,0.0276746,35.5174612),(43623,'metatarsus.tif',229,10,19,29.9620958,15.6945075,8.5552247,1.8,15.8005461,8.6142254,-0.1616264,4.8804732,5.9248787,131.3592892,225.1197142,0.1293184,37.9956665,26.9152772,60.0988673,8.2329856,11.2663328,0.0428309,36.2329806),(43624,'metatarsus.tif',229,10,20,28.6144013,15.5673387,8.4286978,1.8,15.6649635,8.4855655,-0.2510321,5.0516888,5.7552049,124.7459357,211.5300737,0.2942728,36.7545688,24.6939072,58.049896,8.2289653,10.9734223,0.0843581,35.6385513),(43625,'metatarsus.tif',229,10,21,27.7132534,15.4478645,8.4156097,1.8,15.5564566,8.4646994,-0.3138469,5.0950639,5.558813,122.7860817,195.9183695,0.4402156,35.2446414,24.0990269,56.0463329,8.2084312,10.6723244,0.1056656,35.4192264),(43626,'metatarsus.tif',229,10,22,27.4796122,15.3300112,8.4768605,1.8,15.4312618,8.5277085,-0.4000663,4.9948447,5.386508,123.6557904,180.7002837,0.6947496,33.5468328,24.7566836,54.7672251,8.0343494,10.4777122,0.1424396,33.7331931),(43627,'metatarsus.tif',229,10,23,27.6976372,15.254872,8.5243424,1.8,15.3365576,8.5855486,-0.48771,4.8623724,5.1217265,124.4255366,167.4129785,1.0136866,32.6868253,25.5894705,53.8241606,7.7677187,10.1992403,0.1463563,32.0212444),(43628,'metatarsus.tif',229,10,24,27.5108334,15.2163509,8.5547915,1.8,15.2971377,8.618888,-0.577913,4.656561,4.8139176,125.1953582,163.7525014,1.3682906,34.0164738,26.8857977,55.713371,7.6287379,9.8603974,0.1638082,30.6901139),(43629,'metatarsus.tif',229,10,25,26.318661,15.159636,8.5577196,1.8,15.2028221,8.6333976,-0.6636943,4.4324925,4.989709,124.4531779,158.2867587,1.6646308,31.7226431,28.0774705,52.9225427,7.5414286,9.6584634,0.2096398,30.5293139),(43630,'metatarsus.tif',229,10,26,25.6433061,15.1058291,8.5255234,1.8,15.1184382,8.6333533,-0.8266708,4.0918322,5.1871488,120.994063,152.8491099,2.3131366,29.4668834,29.5696543,51.5882814,7.4248969,9.3610777,0.2606024,29.9079889),(43631,'metatarsus.tif',229,10,27,25.3734211,15.0290562,8.5339711,1.8,15.018565,8.6578627,-1.0154336,3.6424929,5.1399551,114.4051012,153.7203408,3.0532929,29.9069421,31.4084626,52.0701892,7.3070505,9.107319,0.2588964,29.0357098),(43632,'metatarsus.tif',229,10,28,24.9738323,14.9293923,8.6115643,1.8,14.9067233,8.770763,-1.1442444,3.7754727,5.1551794,110.6291872,158.3598118,3.4498187,30.7185841,29.3020756,51.5902715,7.2135332,9.130977,0.6981205,29.5985098),(43633,'metatarsus.tif',229,10,29,24.2960579,14.82317,8.6932665,1.8,14.7986446,8.8656918,-1.2327479,3.8759247,5.2054689,105.7230726,158.2858397,3.6039578,30.4076044,27.2768644,50.5414167,7.111588,9.0795065,0.6913369,29.8787265),(43634,'metatarsus.tif',229,10,30,24.0167636,14.7532001,8.7156503,1.8,14.7316417,8.887399,-1.2950125,3.8944978,5.2044895,102.0552586,157.5018003,3.7059951,30.2626802,26.2049857,49.7345918,7.0263989,9.0156514,1.5217286,29.4353431),(43635,'metatarsus.tif',229,10,31,24.0875356,14.7036417,8.7153065,1.8,14.6938401,8.8803099,-1.3448634,3.7880328,5.296586,98.2969184,158.9347885,3.8131251,30.0070248,25.9493312,48.5250754,6.8690421,9.1243377,1.478142,29.2079375),(43636,'metatarsus.tif',229,10,32,23.4897024,14.5956857,8.748491,1.8,14.5760025,8.9292822,-1.4054072,3.852018,5.348854,93.7668387,158.1996533,3.8088354,29.5763638,24.3422636,46.9369073,6.82127,9.2481849,1.4750204,29.5725945),(43637,'metatarsus.tif',229,10,33,23.2529211,14.4977382,8.7946273,1.8,14.4829167,8.9793658,-1.4465592,3.8849476,5.2726584,89.9998832,159.4712515,3.8159764,30.2449428,23.1663054,46.9868707,6.7683283,9.2444272,1.479349,29.1080292),(43638,'metatarsus.tif',229,10,34,23.3217655,14.4237919,8.8168188,1.8,14.419669,8.9862761,-1.4779707,3.8474296,5.1330615,87.7317265,160.0246767,3.8535646,31.1752889,22.8026852,47.9610572,6.7110092,9.169919,1.6014884,28.7295778),(43639,'metatarsus.tif',229,10,35,23.3202055,14.3412571,8.841543,1.8,14.3376328,9.0135266,-1.5029979,3.8271961,5.2593328,85.5071688,159.9848137,3.8688626,30.4192222,22.3419881,46.6126112,6.6236098,9.3113131,1.644257,28.5021723),(43640,'metatarsus.tif',229,10,36,23.5113335,14.2631815,8.8681661,1.8,14.2592157,9.035993,-1.5192635,3.772868,5.2255866,84.0119166,160.9982111,3.9081586,30.8095958,22.2673881,46.7954049,6.5630251,9.3485533,1.6396528,28.1472695),(43641,'metatarsus.tif',229,10,37,23.9409979,14.2205445,8.880647,1.8,14.2233825,9.0485217,-1.5468984,3.7228948,5.1981933,83.0624838,159.9785816,3.9878879,30.7758048,22.3112627,46.6731516,6.5220037,9.3609914,1.6567906,28.1042125),(43642,'metatarsus.tif',229,10,38,24.0926553,14.1547969,8.8851709,1.8,14.1495358,9.0392806,-1.5627577,3.6857978,5.1477302,82.5497549,160.4686339,4.0151831,31.172697,22.3967129,47.0905992,6.4754073,9.3048893,1.6833619,27.716007),(43643,'metatarsus.tif',229,10,39,24.1350623,14.0886748,8.9205249,1.8,14.0909061,9.084756,1.562501,3.6493725,5.0660786,81.5962299,162.3657713,4.0222336,32.0495959,22.3589753,48.019444,6.436496,9.2669505,1.7188283,27.5023959),(43644,'metatarsus.tif',229,10,40,24.4704637,14.0260365,8.9749654,1.8,14.0330501,9.1299015,1.5446739,3.618413,5.0161726,80.6419397,165.625864,4.0756282,33.0183744,22.2865491,49.0947198,6.4076921,9.2987218,1.7402094,27.496682),(43645,'metatarsus.tif',229,10,41,24.5840354,13.9593767,8.9860639,1.8,13.9677832,9.146343,1.5274368,3.6229036,5.0874385,79.8431001,165.0301597,4.0896409,32.4387531,22.0384278,48.1321079,6.3909046,9.3847848,1.7429871,27.6729501),(43646,'metatarsus.tif',229,10,42,24.6797529,13.9061798,8.9808683,1.8,13.9129178,9.1504259,1.5047616,3.5893611,5.0513908,79.1789418,163.9859223,4.0953819,32.4635194,22.0593412,48.1223688,6.3949711,9.3451819,1.7437242,27.255482),(43647,'metatarsus.tif',229,10,43,24.8513267,13.8512485,8.9732944,1.8,13.8567457,9.1465704,1.4857054,3.582697,4.996249,79.0593411,161.8406267,4.1119709,32.3924258,22.0669909,47.9913678,6.3882228,9.2499321,1.7059326,27.0475848),(43648,'metatarsus.tif',229,10,44,25.1381195,13.7934323,8.9962777,1.8,13.8026741,9.1531006,1.4745698,3.57076,4.8897304,78.8776613,162.6050344,4.1510116,33.2543964,22.0898804,49.0693436,6.3714769,9.1537795,1.7251151,26.853482),(43649,'metatarsus.tif',229,10,45,25.3318733,13.7349255,9.0164081,1.8,13.7464878,9.1583638,1.4659268,3.5559171,4.8757391,78.5657052,163.3200756,4.1757171,33.4964755,22.0943582,49.4280671,6.357327,9.1600447,1.7294516,26.7202709),(43650,'metatarsus.tif',229,10,46,25.4528458,13.6761377,9.0033233,1.8,13.6913062,9.155914,1.461772,3.5415564,4.8402771,78.571961,161.4648632,4.1919171,33.3585992,22.1857149,49.3244998,6.3517105,9.1076739,1.7482811,26.6536654),(43651,'metatarsus.tif',229,10,47,25.4925678,13.6162592,8.9775826,1.8,13.6303356,9.1297891,1.4491197,3.5413899,4.8061246,78.7215941,158.3544655,4.1861673,32.9484726,22.2290106,49.209876,6.3461535,9.0432135,1.7586019,26.5302085),(43652,'metatarsus.tif',229,10,48,25.5001933,13.5623166,8.9430824,1.8,13.5774089,9.0926169,1.4328003,3.5326782,4.7852344,79.1112324,154.8138812,4.1696117,32.3524131,22.3941237,48.6440046,6.3558449,8.9818895,1.7462463,26.4303002),(43653,'metatarsus.tif',229,10,49,25.6457864,13.51335,8.9208894,1.8,13.5320654,9.0746193,1.4162169,3.5217903,4.7328871,79.4848444,152.0803676,4.1729751,32.1326842,22.5694429,48.2836008,6.3758573,8.9009194,1.7708491,26.3596543),(43654,'metatarsus.tif',229,10,50,25.694095,13.4520959,8.9197113,1.8,13.4744203,9.0719135,1.4091008,3.5206037,4.6952227,79.7993628,150.0471641,4.1713576,31.9574117,22.6663859,48.4015724,6.3749714,8.8386082,1.781572,25.9949974),(43655,'metatarsus.tif',229,10,51,25.6884559,13.3960693,8.9021425,1.8,13.4171173,9.0405457,1.3899707,3.5146892,4.6362798,80.1048115,146.6435281,4.1429354,31.6295681,22.7914355,48.3453109,6.4017868,8.7517905,1.7555799,25.8008946),(43656,'metatarsus.tif',229,10,52,25.6396229,13.3358777,8.8769671,1.8,13.359965,9.0131313,1.3723097,3.5259363,4.5493258,80.7287874,142.5780838,4.107116,31.3404868,22.8957021,48.1456762,6.4171799,8.6408498,1.7627175,25.5596946),(43657,'metatarsus.tif',229,10,53,25.6193773,13.2848842,8.8611861,1.8,13.3069526,8.9870114,1.3548294,3.5324138,4.4382778,81.3248776,139.3380271,4.073818,31.3946161,23.0224664,48.2272834,6.428667,8.5119647,2.0788123,25.5321057),(43658,'metatarsus.tif',229,10,54,25.5759509,13.221667,8.829759,1.8,13.2452826,8.9497381,1.3402455,3.5290769,4.3221974,81.6880974,135.1132747,4.0400686,31.2603204,23.1471569,48.2777765,6.4781459,8.3674929,2.0774282,25.2478487),(43659,'metatarsus.tif',229,10,55,25.4304115,13.162412,8.797709,1.8,13.1843096,8.9057826,1.3173366,3.5373848,4.2146002,82.2840339,130.7666567,3.9719002,31.0270606,23.261262,48.2904992,6.487899,8.3308138,2.1360452,24.9968946),(43660,'metatarsus.tif',229,10,56,25.3948585,13.1100478,8.7767255,1.8,13.1329921,8.8800307,1.2916459,3.5500225,4.0933725,82.9512857,127.0833133,3.9111394,31.0461146,23.3664113,48.8007605,6.5124002,8.2174349,2.150658,24.8596432),(43661,'metatarsus.tif',229,10,57,25.3761672,13.0492231,8.7613238,1.8,13.0713965,8.8603142,1.2637088,3.5641086,4.0585764,83.4022423,123.2923476,3.8429015,30.3782251,23.4005894,49.3637283,6.5526002,8.0920915,2.0566625,24.4048321),(43662,'metatarsus.tif',229,10,58,25.382928,12.9881005,8.7353587,1.8,13.0080191,8.8204689,1.2399032,3.5787576,4.0718845,84.2486125,119.9999049,3.783951,29.4703609,23.5413015,49.9405331,6.5928002,8.0592732,2.070143,24.2440321),(43663,'metatarsus.tif',229,10,59,25.4933015,12.9291411,8.7236395,1.8,12.9503343,8.8021487,1.2080747,3.6111225,4.0620312,85.1606284,117.6822571,3.7139606,28.9712834,23.5828686,49.817575,6.6330002,8.004748,2.068139,24.0263807),(43664,'metatarsus.tif',229,10,60,25.503481,12.8653885,8.7010894,1.8,12.8825682,8.7794524,1.1735579,3.6340044,4.0465802,85.934425,114.7111221,3.6143919,28.3476705,23.6473089,49.557716,6.7036723,7.9431378,2.0955921,23.8127696),(43665,'metatarsus.tif',229,10,61,25.517661,12.805272,8.6901284,1.8,12.8264246,8.7688463,1.1322204,3.6631437,4.0283006,86.7093982,112.3918748,3.4860182,27.9005681,23.670761,49.4146957,6.7536002,7.9083733,2.098139,23.7656724),(43666,'metatarsus.tif',229,10,62,25.4908367,12.7490586,8.6807875,1.8,12.7686242,8.755036,1.0919639,3.6857535,4.0111663,87.4409024,110.5885724,3.3465885,27.5701791,23.7240232,49.3433523,6.7763889,7.8838137,2.1418274,23.7128613),(43667,'metatarsus.tif',229,10,63,25.2747589,12.6922615,8.6770585,1.8,12.715734,8.7464481,1.0415391,3.7192597,4.0445521,87.753885,108.7086845,3.1386354,26.8778053,23.5944495,48.5737275,6.757806,7.8826862,2.1602134,23.6462557),(43668,'metatarsus.tif',229,10,64,25.198973,12.6346122,8.6736397,1.8,12.6564789,8.738785,0.9799812,3.7423797,4.0141518,88.2865304,107.2026984,2.8966574,26.7061897,23.5910136,48.4796053,6.7395999,7.8282729,2.1402825,23.6795585),(43669,'metatarsus.tif',229,10,65,25.1197125,12.5785263,8.6783788,1.8,12.6029102,8.7443832,0.9152537,3.752859,3.9721628,88.4237909,105.7124322,2.6308739,26.613318,23.5617142,48.3320931,6.6725056,7.7852158,2.131585,23.6227071),(43670,'metatarsus.tif',229,10,66,24.9294642,12.5184265,8.6777546,1.8,12.5396023,8.7413197,0.8295326,3.7358477,3.8731958,88.3792638,104.0918005,2.260592,26.874913,23.657084,48.4115975,6.6191254,7.7377432,2.1602399,23.4659474),(43671,'metatarsus.tif',229,10,67,24.6429545,12.4614146,8.6660021,1.8,12.4864103,8.7112812,0.7245748,3.7016619,3.7585451,88.0209826,102.7789482,1.8043838,27.3454081,23.7787745,48.2404538,6.5774985,7.6819878,2.1587989,23.4561933),(43672,'metatarsus.tif',229,10,68,24.6574842,12.4029207,8.6708102,1.8,12.4208612,8.7183596,0.6102824,3.6130062,3.7053955,87.8966609,101.8181351,1.3497602,27.4783448,24.3278469,49.2188807,6.542444,7.5752207,2.1941303,23.3855474),(43673,'metatarsus.tif',229,10,69,24.7818357,12.3499662,8.6784685,1.8,12.376288,8.7333799,0.5321179,3.5385816,3.7064323,87.4656856,102.1389229,1.0631972,27.5572074,24.7177248,49.449299,6.5004461,7.5614482,2.1823934,23.3855474),(43674,'metatarsus.tif',229,10,70,24.5559135,12.2836932,8.6685162,1.8,12.3049772,8.7155239,0.4541229,3.4519209,3.6833491,87.1508563,101.9061716,0.7875701,27.6667158,25.247061,49.0667615,6.4736953,7.5100876,2.2003797,23.409096),(43675,'metatarsus.tif',229,10,71,24.3646874,12.2244871,8.6765014,1.8,12.2525659,8.7247869,0.3906753,3.3533037,3.704953,86.1765135,101.7996621,0.5888882,27.4766407,25.6989884,48.6631529,6.4507228,7.4586983,2.2531129,23.328696),(43676,'metatarsus.tif',229,10,72,24.1132096,12.1688256,8.6908421,1.8,12.1951199,8.7368797,0.3449027,3.2567949,3.7208162,84.9770822,102.0221734,0.4594172,27.4192996,26.0922428,48.5748224,6.4296216,7.5028755,2.234659,23.328696),(43677,'metatarsus.tif',229,10,73,24.0602622,12.1191667,8.709977,1.8,12.1464001,8.7522303,0.2910951,3.1966509,3.7337795,84.132419,102.4968604,0.3303065,27.4512352,26.3189258,48.3890302,6.4029438,7.4647625,2.2455373,23.2953932),(43678,'metatarsus.tif',229,10,74,24.0115905,12.0669043,8.7210681,1.8,12.0914486,8.7637271,0.2435455,3.1739037,3.7497865,83.009125,102.8952449,0.2327159,27.440294,26.1536368,48.1286278,6.3712937,7.3864153,2.2752904,23.2149932),(43679,'metatarsus.tif',229,10,75,23.7532975,12.0118256,8.7346027,1.8,12.0367726,8.777697,0.188384,3.1823999,3.7608954,81.9294289,102.8560909,0.1388407,27.3488307,25.7445422,47.5979965,6.3612278,7.3605533,0.3165693,23.2345016),(43680,'metatarsus.tif',229,10,76,23.5647681,11.9558508,8.7590068,1.8,11.9797144,8.799503,0.1524551,3.1439308,3.771746,80.7829125,102.9864463,0.0905792,27.3047144,25.6948761,47.0154078,6.3207736,7.3864153,0.3097029,23.1914446),(43681,'metatarsus.tif',229,10,77,23.2206578,11.9042719,8.7792998,1.8,11.9244152,8.8140121,0.1187713,3.1344051,3.7906084,78.8378724,103.3468937,0.0543379,27.2639329,25.1524198,46.4995906,6.2813968,7.412623,0.3028849,23.1816905),(43682,'metatarsus.tif',229,10,78,23.0370846,11.8487018,8.8017337,1.8,11.8659944,8.8339548,0.0945115,3.1353223,3.8121874,77.6839828,103.8393689,0.0341942,27.2387892,24.7770324,46.0336769,6.2598767,7.4630304,0.3064196,23.2149932),(43683,'metatarsus.tif',229,10,79,22.7955926,11.793214,8.8271633,1.8,11.810111,8.8596578,0.0733633,3.1369819,3.8291208,76.0906193,104.2690512,0.0204117,27.2305464,24.2559956,45.6870751,6.2230413,7.4888621,0.2606024,23.2052391),(43684,'metatarsus.tif',229,10,80,22.5065846,11.7319524,8.8349764,1.8,11.7481479,8.8643741,0.0502928,3.1232162,3.8375916,74.4055677,104.757393,0.0094799,27.2976916,23.8233801,45.1340713,6.1908002,7.5278193,0.2981063,23.2953932),(43685,'metatarsus.tif',229,10,81,22.1649854,11.6764922,8.8404587,1.8,11.6858269,8.8556482,0.0251055,3.1106026,3.8503216,72.4082107,105.4706139,0.0023279,27.3926762,23.2778725,44.7465762,6.1715332,7.5769272,0.2629947,23.167896),(43686,'metatarsus.tif',229,10,82,22.0543686,11.6253574,8.8716223,1.8,11.6425546,8.8978185,0.0127866,3.1293522,3.8724482,70.9209572,106.2057054,0.0006009,27.4259845,22.663143,44.2099633,6.1468345,7.6431822,0.2934719,23.1443474),(43687,'metatarsus.tif',229,10,83,21.8338277,11.5774063,8.8923252,1.8,11.5904672,8.90947,0.0050457,3.1087603,3.9012258,69.7398596,107.0579341,0.0000926,27.4421274,22.4333348,44.0879592,6.1104002,7.6934443,0.2589195,23.1207988),(43688,'metatarsus.tif',229,10,84,21.6408252,11.5356912,8.9163067,1.8,11.5515716,8.9350456,-0.0082033,3.1240896,3.8972964,68.4088598,107.4471243,0.0002427,27.5696569,21.8972146,43.7807022,6.1067324,7.7201798,0.2904593,23.1207988),(43689,'metatarsus.tif',229,10,85,21.4786294,11.4920867,8.9380835,1.8,11.5087594,8.9594945,-0.0153846,3.1098735,3.9325735,67.8176947,107.83039,0.0008472,27.4198031,21.8072196,43.5766402,6.0300002,7.7610994,0.25126,23.1207988),(43690,'metatarsus.tif',229,10,86,21.3248796,11.4544315,8.9493727,1.8,11.4681551,8.9663883,-0.0248662,3.1183444,3.9723822,66.9354791,108.6582361,0.0021972,27.3534192,21.4650691,43.5877469,6.0300002,7.8100854,0.2549658,23.1874043),(43691,'metatarsus.tif',229,10,87,21.2401575,11.4125512,8.971848,1.8,11.4233254,8.9908269,-0.0339613,3.1327014,3.9743774,66.2120862,108.9704784,0.0040814,27.418251,21.1357797,43.4867755,6.0300002,7.8307498,0.2649013,23.1776502),(43692,'metatarsus.tif',229,10,88,21.0413587,11.3704388,8.9714667,1.8,11.3794361,8.976042,-0.0402697,3.0962666,4.010308,65.5022765,110.220405,0.0056839,27.4842742,21.1552444,43.4131635,5.9898002,7.863186,0.2797042,23.2011988),(43693,'metatarsus.tif',229,10,89,21.0698047,11.3180763,9.0003253,1.8,11.3239431,9.0154215,-0.0475117,3.1133567,4.0298905,65.143843,110.6926826,0.007921,27.4679136,20.9239895,43.3305757,5.9898002,7.9009112,0.2153577,23.2109529),(43694,'metatarsus.tif',229,10,90,21.0270932,11.2772192,9.0193622,1.8,11.2817219,9.0326714,-0.055117,3.0997645,4.0364945,64.9893685,111.4056252,0.0106355,27.5995979,20.9659052,43.2683995,5.9898002,7.9275585,0.2302196,23.2580502),(43695,'metatarsus.tif',229,10,91,21.0265634,11.2330126,9.0383073,1.8,11.2303749,9.0598332,-0.066959,3.0988394,4.0633435,64.9057501,112.0519957,0.0156887,27.5763041,20.9451802,43.2286069,5.9898002,7.9576713,0.2241483,23.3246557),(43696,'metatarsus.tif',229,10,92,21.1300787,11.1741291,9.0514708,1.8,11.1674762,9.0776181,-0.0713028,3.0824308,4.0536827,65.0869236,113.4268648,0.0178742,27.98119,21.1154531,43.5458597,5.9892304,7.9791687,0.2755315,23.3149016),(43697,'metatarsus.tif',229,10,93,21.0006659,11.1227581,9.0654815,1.8,11.1136656,9.0873429,-0.0777919,3.0810176,4.0800519,65.0669952,114.1271092,0.0211385,27.9719749,21.1186706,43.6887326,5.9880326,8.004748,0.2486327,23.4148099),(43698,'metatarsus.tif',229,10,94,20.7786554,11.0693671,9.0724704,1.8,11.0577799,9.0849713,-0.0903064,3.0715614,4.0772385,64.917019,114.5749613,0.0281658,28.1011182,21.1348599,43.6557726,5.9898002,8.0273273,0.2170394,23.3482043),(43699,'metatarsus.tif',229,10,95,20.6413518,11.0098043,9.0756527,1.8,10.9914323,9.0923343,-0.1004858,3.0657521,4.0878009,64.941279,114.9609018,0.0346206,28.1229207,21.1828215,43.8008572,5.9898002,8.0360798,0.2219245,23.4148099),(43700,'metatarsus.tif',229,10,96,20.3096088,10.9379758,9.0787503,1.8,10.9232655,9.0963439,-0.1153335,3.0520377,4.0699029,64.5259267,114.5644318,0.0448265,28.1491806,21.1419166,43.8187534,6.0205738,8.0729971,0.2413555,23.3912613),(43701,'metatarsus.tif',229,10,97,19.941534,10.8601387,9.0861643,1.8,10.8433296,9.0986613,-0.1285205,3.04205,4.0532875,63.7288065,114.4427007,0.0545958,28.2345385,20.949296,43.676993,6.0251246,8.0841993,0.2256807,23.467621),(43702,'metatarsus.tif',229,10,98,19.5236752,10.7898886,9.0988566,1.8,10.7827798,9.0951805,-0.136594,3.0424896,4.0476066,63.1997643,114.0157466,0.0603352,28.1686831,20.7723844,43.2972785,6.0385872,8.1145274,0.2197436,23.548021),(43703,'metatarsus.tif',229,10,99,19.6122902,10.714276,9.1119713,1.8,10.6890271,9.1185809,-0.1512726,3.0465584,4.0332987,63.6991584,114.9417983,0.0742305,28.4982111,20.9085633,43.4531007,6.0423123,8.1216938,0.2449787,23.4911696),(43704,'metatarsus.tif',229,10,100,19.7734376,10.6482349,9.0996056,1.8,10.6180295,9.0865315,-0.1746147,3.0150759,4.0568166,64.2743903,116.7995866,0.0994659,28.7909457,21.3176692,44.0305681,6.0557959,8.1367027,0.2090229,23.5244723),(43705,'metatarsus.tif',229,10,101,19.5542089,10.5381381,9.140801,1.8,10.4896755,9.133499,-0.1663669,3.0364078,4.1017832,63.9850676,116.6518923,0.0893742,28.4393121,21.07262,43.2498632,6.0788445,8.1537654,0.2186689,23.5813237),(43706,'metatarsus.tif',229,10,102,19.6973104,10.4434007,9.174148,1.8,10.3619979,9.1677867,-0.1709152,3.0586691,4.1436998,64.444795,117.7622164,0.0949694,28.4195823,21.0695541,43.1897234,6.1033402,8.1625803,0.2234766,23.6617237),(43707,'metatarsus.tif',229,10,103,19.7728341,10.3942509,9.1745335,1.8,10.3196756,9.156989,-0.1796159,3.0511499,4.1357281,65.3451336,119.3096583,0.1051797,28.8485259,21.4165597,44.0313401,6.1230206,8.1804781,0.2533217,23.7185751),(43708,'metatarsus.tif',229,10,104,19.673996,10.3419526,9.1977714,1.8,10.2897019,9.168483,-0.1863758,3.0685876,4.1373899,65.895645,119.6413531,0.1125864,28.9171086,21.4742588,44.0422436,6.1383414,8.194492,0.2782997,23.789221),(43709,'metatarsus.tif',229,10,105,19.8811574,10.2523224,9.2090865,1.8,10.18751,9.1789633,-0.1992573,3.0719839,4.1629989,67.2192962,120.8226485,0.1298266,29.0229832,21.8813959,44.4130164,6.1628294,8.2056268,0.2830103,23.869621),(43710,'metatarsus.tif',229,10,106,19.72703,10.1660515,9.2411375,1.8,10.1021783,9.2210091,-0.2051576,3.083486,4.2012264,67.5860863,121.1013795,0.1364533,28.8252446,21.9187268,44.1287911,6.1799373,8.2222517,0.2722554,24.0068724),(43711,'metatarsus.tif',229,10,107,19.8258125,10.1030011,9.2576874,1.8,10.0412086,9.2391968,-0.2251206,3.0975631,4.2227715,68.5494747,123.4527985,0.1646498,29.2350176,22.13013,44.6746799,6.1929392,8.2669424,0.290991,24.0677641),(43712,'metatarsus.tif',229,10,108,19.9096369,9.9999426,9.3014647,1.8,9.9484698,9.2797644,-0.225624,3.0951494,4.2850824,69.1561083,125.2779999,0.1660737,29.2358442,22.3433826,44.5221092,6.1992683,8.2997184,0.2696505,24.1952613),(43713,'metatarsus.tif',229,10,109,19.7892704,9.9543481,9.3009463,1.8,9.9084025,9.2721026,-0.2405608,3.1171581,4.296825,69.8840754,126.5161721,0.1872124,29.4441064,22.4191629,44.7917956,6.2186655,8.3492219,0.2730087,24.2992099),(43714,'metatarsus.tif',229,10,110,19.7870919,9.8735986,9.3326472,1.8,9.8403778,9.3017361,-0.2442902,3.1271512,4.3453365,70.9398078,128.1198916,0.1929241,29.4844577,22.6851227,44.8753215,6.2312574,8.4141974,0.3973637,24.4697641),(43715,'metatarsus.tif',229,10,111,19.8006542,9.7932454,9.3766871,1.8,9.7594406,9.3462195,-0.2408864,3.1219018,4.40299,71.3110152,130.7269151,0.1878176,29.6904865,22.8421714,44.830323,6.2374977,8.4833434,0.3532244,24.6305641),(43716,'metatarsus.tif',229,10,112,20.0582285,9.7408488,9.4143546,1.8,9.7026799,9.3824088,-0.2587412,3.1349995,4.4635325,72.1230218,134.7958842,0.2188564,30.1993735,23.0057523,45.3243969,6.2511218,8.5723145,0.4048918,24.8482155),(43717,'metatarsus.tif',229,10,113,20.1687467,9.702324,9.46531,1.8,9.6665787,9.436528,-0.2558449,3.161958,4.5036479,73.2369683,137.693483,0.2152706,30.5737671,23.1619042,45.7586757,6.2654715,8.652811,0.3658396,24.9091072),(43718,'metatarsus.tif',229,10,114,20.7127024,9.7045597,9.4801242,1.8,9.6652089,9.4513594,-0.2756179,3.1664884,4.5144442,75.2443685,144.0716981,0.2556673,31.9134965,23.7627171,47.5793852,6.2822557,8.7517905,0.4060981,25.1032099),(43719,'metatarsus.tif',229,10,115,21.0191854,9.6429861,9.5627163,1.8,9.6350123,9.537772,-0.2597183,3.215144,4.5785669,77.4929238,146.5342722,0.2310376,32.0043971,24.1024737,47.7682433,6.2940907,8.8268072,0.3534402,25.3208613),(43720,'metatarsus.tif',229,10,116,21.4012443,9.6019301,9.5916929,1.8,9.5877403,9.5785246,-0.2679303,3.2164511,4.6213958,79.3237186,150.9707548,0.2499852,32.6677827,24.661876,48.7242602,6.3067508,8.9131662,0.3788313,25.4483586),(43721,'metatarsus.tif',229,10,117,21.2462413,9.5379483,9.6612175,1.8,9.5066618,9.6565926,-0.266171,3.2486407,4.6895719,79.9527532,151.9449793,0.2450033,32.4006074,24.6111407,48.2626506,6.3171152,9.0109897,0.3937616,25.6757641),(43722,'metatarsus.tif',229,10,118,21.4154798,9.4949194,9.704918,1.8,9.45904,9.6949105,-0.2590006,3.2517461,4.736966,81.266235,156.1540125,0.2341236,32.9649846,24.991568,48.8931892,6.3329441,9.0857339,0.3665385,25.82681),(43723,'metatarsus.tif',229,10,119,21.7683366,9.4998176,9.7640504,1.8,9.4852334,9.7503355,-0.2728617,3.2924783,4.758818,81.9896886,162.8951814,0.263484,34.2301767,24.9021197,50.2336803,6.3525407,9.1842708,0.3577461,25.9973641),(43724,'metatarsus.tif',229,10,120,21.9732855,9.4442459,9.8305145,1.8,9.4216038,9.8143126,-0.2614701,3.30689,4.8203452,83.4111134,166.7993316,0.2447192,34.6031924,25.2234316,50.6903836,6.3777436,9.2792367,0.3724615,26.2483183),(43725,'metatarsus.tif',229,10,121,22.4737916,9.4258765,9.8846121,1.8,9.4005864,9.869286,-0.2504508,3.3188381,4.8504338,85.0296149,173.7329228,0.2300754,35.8180178,25.620296,52.0351569,6.4126988,9.3630628,0.3597757,26.4188724),(43726,'metatarsus.tif',229,10,122,23.2012008,9.4224335,9.9160921,1.8,9.3787079,9.8965628,-0.2430122,3.3054892,4.8744124,86.9161204,183.1711373,0.2238975,37.5780957,26.2944804,54.216098,6.4379477,9.4726252,0.301619,26.6698266),(43727,'metatarsus.tif',229,10,123,23.2536595,9.3727142,9.9738572,1.8,9.3743191,9.944718,-0.2233358,3.3214356,4.9394432,87.599414,187.4058985,0.1901183,37.9406935,26.3739615,54.4226495,6.4781344,9.5891961,0.35092,26.9207808),(43728,'metatarsus.tif',229,10,124,23.3870402,9.3232018,10.065068,1.8,9.300162,10.0359443,-0.2160281,3.3572897,5.0360757,88.2013285,191.8556175,0.1790927,38.096254,26.2715874,54.3467599,6.5307129,9.7301444,0.2890824,27.1619808),(43729,'metatarsus.tif',229,10,125,23.8686226,9.2958272,10.0876336,1.8,9.2809965,10.0586909,-0.2163578,3.3343255,5.0985538,90.1367747,200.0260466,0.1833302,39.2319186,27.032986,55.9303661,6.5763754,9.8686705,0.2637512,27.5599405),(43730,'metatarsus.tif',229,10,126,24.6337947,9.274822,10.1388781,1.8,9.2611698,10.1103916,-0.2055325,3.3364521,5.1520902,92.1785096,211.3183184,0.1710083,41.0160365,27.6277038,57.8562667,6.6151469,10.0229496,0.2430331,27.8912947),(43731,'metatarsus.tif',229,10,127,24.8696673,9.2826221,10.2037497,1.8,9.2815597,10.1701277,-0.2093797,3.357827,5.2003964,92.4538113,220.2677995,0.1790739,42.3559638,27.5338224,59.162858,6.6596392,10.189729,0.2593317,28.3225571),(43732,'metatarsus.tif',229,10,128,25.5524212,9.1974151,10.263938,1.8,9.2298949,10.2336568,-0.2176381,3.3765065,5.3386203,94.8204989,230.8310738,0.1985558,43.2379641,28.0824279,60.0128443,6.7080785,10.3688733,0.2148843,28.7676141),(43733,'metatarsus.tif',229,10,129,26.0503659,9.1525046,10.3347875,1.8,9.1682197,10.3103506,-0.2202305,3.4189,5.4563685,97.8144925,242.0045061,0.2071977,44.352669,28.6099309,61.3823249,6.7690685,10.5609773,0.2265135,29.6536877),(43734,'metatarsus.tif',229,10,130,27.0548424,9.1259545,10.4107008,1.8,9.1254088,10.3795439,-0.21609,3.4706536,5.5480589,103.5425273,254.3801209,0.2072968,45.8502922,29.8337259,63.6772485,6.8372391,10.7569375,0.2223171,30.2262418),(43735,'metatarsus.tif',229,10,131,28.0181352,9.1278833,10.4814888,1.8,9.1476648,10.4546488,-0.2106992,3.5502164,5.6020323,109.810332,267.5880243,0.2042573,47.7662408,30.9306028,66.4527444,6.9251224,10.9359521,0.2110933,30.4008363),(43736,'metatarsus.tif',229,10,132,28.4804349,9.124754,10.5731871,1.8,9.1145848,10.5593616,-0.2366488,3.6323628,5.6898185,113.2465931,279.5068912,0.2609046,49.1240438,31.1771154,68.3769874,7.0319981,11.1275608,0.2221956,31.2536071),(43737,'metatarsus.tif',229,10,133,29.1635157,9.0920673,10.712162,1.8,9.0963539,10.6778408,-0.2339234,3.6821242,5.821028,119.9154226,293.4499132,0.2611559,50.4120425,32.5669144,70.3439049,7.1644385,11.3504332,0.2286571,31.7222127),(43738,'metatarsus.tif',229,10,134,30.0785169,8.9937158,10.8104162,1.8,9.0117128,10.7734459,-0.2408208,3.8064657,6.0426001,124.4593216,319.6587969,0.2851553,52.9008689,32.6968197,72.7693081,7.309688,11.6158528,0.2197951,32.2614641),(43739,'metatarsus.tif',229,10,135,31.0506557,9.0138821,10.9192298,1.8,9.0166448,10.9001017,-0.2406723,3.882962,6.2241879,134.1397577,348.4778024,0.2940154,55.9876735,34.5457301,76.805987,7.4549356,12.1100795,0.2345121,33.4455891),(43740,'metatarsus.tif',229,10,136,32.4919867,8.9316292,11.0246991,1.8,8.9418925,11.0341857,-0.2413245,3.9960342,6.4180505,144.7328193,391.5632849,0.3093005,61.0096919,36.2191146,82.7004578,7.6055124,12.4140573,0.2253425,34.4924626),(43741,'metatarsus.tif',229,10,137,33.4409266,8.9053257,11.1208227,1.8,8.9339366,11.1409271,-0.2290471,4.1225732,6.4745763,153.9126031,414.3704418,0.2873219,63.9996225,37.3341107,86.5929989,7.724935,12.5682076,0.2356694,35.031714),(43742,'metatarsus.tif',229,10,138,34.6069067,8.9275461,11.2452194,1.8,8.9596235,11.2608248,-0.2567355,4.5725112,6.4798779,167.2638726,440.1702562,0.3718952,67.9287889,36.5803091,92.6663817,8.2193289,12.6189591,0.2248886,36.4472849),(43743,'metatarsus.tif',229,10,139,35.881372,8.9656951,11.5391548,1.8,8.944966,11.5318309,-0.2521158,4.5899204,6.4416148,186.0414842,448.9969415,0.3721319,69.7025444,40.5326165,96.5502176,8.474926,12.5707789,0.1541081,38.7001585),(43744,'metatarsus.tif',229,10,140,37.3860641,8.9865785,11.7193899,1.8,8.9739462,11.6918128,-0.2591849,4.5961336,6.3968101,201.4662531,458.7911514,0.4092901,71.7218652,43.8338549,100.5976156,8.5970089,12.4405853,0.126359,38.7179933),(43745,'metatarsus.tif',229,10,141,39.7552391,9.0552526,11.8065109,1.8,9.0386796,11.7636199,-0.2370148,4.6207222,6.2478484,218.1149831,476.8359419,0.3652974,76.3200247,47.203656,107.5290177,8.6655712,12.3122964,0.0424581,38.2551016),(43746,'metatarsus.tif',229,10,142,42.1596619,9.0625116,11.8848882,1.8,9.0741735,11.8515799,-0.2105092,4.6176358,6.181526,227.159115,481.399724,0.3068056,77.8771652,49.1938141,110.5498801,8.6717656,12.155167,0.1493805,37.4867711),(43747,'metatarsus.tif',229,10,143,44.939576,9.0305316,11.8771963,1.8,9.0705235,11.880324,-0.1845759,4.6815514,6.066924,237.3085957,494.0409717,0.2522842,81.4318702,50.6901618,115.3782991,8.6444614,12.0267897,0.7641248,37.0400406),(43748,'metatarsus.tif',229,10,144,45.927207,9.1094683,11.8097654,1.8,9.1830374,11.8391126,-0.1742049,4.738881,5.814423,243.0089466,483.6606217,0.2299546,83.1829098,51.2798162,118.9272082,8.5683052,11.9793981,0.7402981,37.5281544),(43749,'metatarsus.tif',229,10,145,46.5164808,9.1827438,11.8024516,1.8,9.2411203,11.854726,-0.1874067,4.727187,5.6065705,238.4275763,442.0873118,0.2691134,78.8516452,50.4375177,113.4659931,8.4693265,11.865812,0.7398661,36.4869947),(43750,'metatarsus.tif',229,10,146,46.3896248,9.1696054,11.7978625,1.8,9.2194421,11.87291,-0.166289,4.6596221,5.4443844,230.4829433,401.6941816,0.2118312,73.781378,49.4638705,108.1318674,8.2911889,11.5877158,0.7289471,35.6813211),(43751,'metatarsus.tif',229,10,147,45.0736137,9.0178848,11.8338761,1.8,9.0819772,11.9093971,-0.0836455,4.5178075,5.2324542,214.5947823,365.8620523,0.0524377,69.9216921,47.4997622,100.7384728,8.1224287,11.2059983,0.7066807,35.1363559),(43752,'metatarsus.tif',229,10,148,44.3581959,8.8520931,11.8340207,1.8,8.9425878,11.9091188,-0.0616972,4.3920088,5.2955175,194.8052759,343.5378013,0.0281063,64.8733205,44.3544822,92.1740775,7.9069301,11.0550004,2.8577985,34.2950128),(43753,'metatarsus.tif',229,10,149,43.0102223,8.7009089,11.8446207,1.8,8.8175299,11.9152432,-0.0851306,4.247807,5.2346644,164.9295904,324.607359,0.0518253,62.0111113,38.8269975,84.8872285,7.6034741,10.7815475,2.8033342,32.9029906),(43754,'metatarsus.tif',229,10,150,40.8928913,8.7333463,11.8116008,1.8,8.8288932,11.8826229,-0.1115714,4.0464771,4.9737768,129.503062,309.4308436,0.0844889,62.2124511,32.0039037,80.5776418,7.1509975,10.4135852,2.9078495,31.3558822),(43755,'metatarsus.tif',229,10,151,37.0309282,8.9811158,11.7299088,1.8,9.0303855,11.8030001,-0.1391066,3.7118003,5.1628019,90.9668295,267.2209542,0.1186604,51.7589017,24.5074687,69.3731005,6.4715808,10.0123832,3.0127556,29.212671),(43756,'metatarsus.tif',229,10,152,30.5324177,9.4827737,11.6348765,1.8,9.4647902,11.6943623,-0.1375369,3.0431105,4.9946612,53.6077514,188.5774533,0.0956551,37.7558047,17.6161043,48.372478,5.3927264,9.2239514,0.2555491,26.3361057),(43757,'metatarsus.tif',229,10,153,21.8121639,10.2621983,11.5207935,1.8,10.1665453,11.5637624,-0.1392596,2.1829163,4.4587978,24.1059873,86.267456,0.0700468,19.347694,11.0430197,24.7375447,4.1308429,7.8894487,0.0509762,21.3308169),(43758,'metatarsus.tif',229,10,154,11.2477426,11.0376774,11.4558099,1.8,11.0109706,11.4668893,-0.1990405,1.4179686,2.9238427,5.3537654,22.6542745,0.0732916,7.7481166,3.7756585,9.5774672,2.8369673,5.505199,0.1687501,14.6623501),(43759,'metatarsus.tif',229,10,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43760,'metatarsus.tif',229,10,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43761,'metatarsus.tif',229,10,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43762,'metatarsus.tif',229,10,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43763,'metatarsus.tif',229,10,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43764,'metatarsus.tif',229,10,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43765,'metatarsus.tif',229,10,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43766,'metatarsus.tif',229,10,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43767,'metatarsus.tif',229,10,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43768,'forelimb',254,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43769,'forelimb',254,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43770,'forelimb',254,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43771,'forelimb',254,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43772,'forelimb',254,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43773,'forelimb',254,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43774,'forelimb',254,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43775,'forelimb',254,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43776,'forelimb',254,2,9,2.4709327,73.2491364,127.3722045,1.8,73.1424462,127.3574013,0.1626154,1.0464807,4.1846944,0.5578556,11.3178353,0.0107945,2.7045787,0.5330778,2.8267801,2.7863616,22.4468287,3.0457335,47.5352736),(43777,'forelimb',254,2,10,4.6906542,71.7205075,127.1005552,1.8,71.7544026,127.100313,0.1733687,1.3705619,5.353177,1.476902,37.6543165,0.0232631,7.034013,1.0775887,7.2831105,3.4710534,29.3731901,3.0390128,62.8565959),(43778,'forelimb',254,2,11,8.1070694,70.4830955,126.8253455,1.8,70.3191654,126.7893417,0.1648691,1.7716274,6.6148779,3.540507,95.5405637,0.0363959,14.4432845,1.998449,14.9225421,4.1235974,36.7276431,3.0361033,78.8898487),(43779,'forelimb',254,2,12,9.7770918,69.7047594,126.6148192,1.8,69.5987138,126.6032723,0.1690003,1.733817,7.419848,4.4383047,131.0953819,0.0460994,17.6682031,2.5598461,18.2023668,4.1665189,39.7200017,3.0440769,85.1571861),(43780,'forelimb',254,2,13,10.0969524,69.1999896,126.3408031,1.8,69.2242185,126.3049884,0.1805189,1.6963236,7.8951473,4.6407955,138.9414229,0.0542453,17.5983319,2.7357961,18.1735826,4.4153191,42.4239386,3.0197502,91.5287833),(43781,'forelimb',254,2,14,11.1070561,68.4321965,126.0840835,1.8,68.5801579,126.0685061,0.1905019,1.8788394,8.7001974,5.2872297,175.0361316,0.0663722,20.1186391,2.8140934,20.7122286,4.50972,44.8936575,3.0457335,96.1816285),(43782,'forelimb',254,2,15,11.1755936,68.2087139,125.8342188,1.8,68.2827001,125.8024696,0.1945599,1.9956975,8.9690035,5.3925004,187.8697072,0.0696209,20.9465531,2.7020631,21.5159671,4.5374385,47.0326836,3.0501056,100.7302139),(43783,'forelimb',254,2,16,11.2692523,67.9972066,125.6705285,1.8,68.0950445,125.656049,0.1982872,1.8578684,9.125724,5.4049042,196.8383055,0.0728843,21.5696098,2.9091965,22.1588031,4.5057211,48.6762735,3.0709141,104.0202723),(43784,'forelimb',254,2,17,12.022494,67.6269419,125.4140899,1.8,67.7814916,125.4044428,0.2011547,2.0017947,9.5401581,5.8413827,230.6478726,0.0799904,24.1765251,2.9180729,24.7763072,4.7159964,50.067411,3.0470478,108.1697067),(43785,'forelimb',254,2,18,12.2865734,67.4798899,125.2791041,1.8,67.6024771,125.2920697,0.200186,1.9035523,9.7108174,5.8893215,248.0549492,0.0809726,25.5441885,3.0938584,26.1267517,4.6266693,51.3130956,3.057756,109.8884587),(43786,'forelimb',254,2,19,12.6072732,67.3418586,125.0936648,1.8,67.5314271,125.1042028,0.1985999,2.0082762,9.7972748,5.8185632,253.4971542,0.0817919,25.8742518,2.8972923,26.4644296,4.7834223,52.1358708,3.0673492,111.9631759),(43787,'forelimb',254,2,20,12.6478922,67.1290271,124.9600622,1.8,67.4928447,125.0020745,0.1969388,1.9281039,10.0318476,5.8727097,259.9465838,0.0807063,25.9121344,3.0458471,26.4879569,4.7039999,52.5643848,3.0679555,112.3623269),(43788,'forelimb',254,2,21,12.6411783,67.1376066,124.8217196,1.8,67.6239394,124.8923979,0.1977332,1.9553792,10.0508236,5.9097467,255.7153318,0.081307,25.4422265,3.0223021,26.0097,4.7330784,52.5977428,3.0598083,113.3259627),(43789,'forelimb',254,2,22,12.5708504,67.1003106,124.7295295,1.8,67.5875042,124.8141333,0.1984303,1.9539566,10.1058372,5.7412909,250.0398011,0.0814182,24.7421166,2.9382899,25.2822887,4.6731313,52.9632948,3.0766435,113.3259627),(43790,'forelimb',254,2,23,12.6532633,67.1364031,124.6034344,1.8,67.7889358,124.726365,0.2014909,1.8970245,10.011124,5.7185128,237.4730824,0.084465,23.7209212,3.0144644,24.2892591,4.683643,52.9632948,3.0766435,113.6819279),(43791,'forelimb',254,2,24,12.5158525,67.1266253,124.5376508,1.8,67.985545,124.7082321,0.199424,1.8418454,10.0334,5.659085,231.9540229,0.0818651,23.1181874,3.0725082,23.6755886,4.5433066,52.9371431,3.0847434,112.8225519),(43792,'forelimb',254,2,25,12.4190047,67.1623251,124.4516967,1.8,68.1705008,124.6414968,0.1999726,1.8339256,10.0156146,5.6640274,214.80902,0.0816733,21.4474127,3.0884718,22.0014817,4.5869862,52.5081549,3.0842784,112.8225519),(43793,'forelimb',254,2,26,12.1106697,67.2406843,124.4178567,1.8,68.2274307,124.6136516,0.1973821,1.7934936,9.9445422,5.548152,205.7137837,0.0776221,20.6860989,3.0934886,21.2270428,4.5571996,52.1057606,3.075573,111.8589161),(43794,'forelimb',254,2,27,11.7315031,67.3771469,124.3568655,1.8,68.3161165,124.532561,0.198045,1.7892651,9.7384662,5.4010012,184.0293309,0.0756911,18.8971576,3.0185583,19.4514358,4.5122234,51.7073763,3.0667328,111.5029509),(43795,'forelimb',254,2,28,11.7539387,67.4577742,124.3226632,1.8,68.3888,124.4812549,0.2006885,1.9817484,9.6663904,5.5746285,181.5973702,0.0778465,18.7864718,2.812985,19.3625062,4.8738581,52.0791783,3.0838058,111.7114705),(43796,'forelimb',254,2,29,11.5907913,67.5418961,124.2652482,1.8,68.475857,124.4303034,0.2006929,1.9943569,9.5954029,5.6300424,170.1156018,0.0767692,17.728865,2.8229864,18.3132725,4.85137,51.6502135,3.0833254,111.7114705),(43797,'forelimb',254,2,30,11.6347673,67.6015516,124.2402685,1.8,68.611966,124.4275603,0.1986168,1.965479,9.5415101,5.6718746,167.21568,0.0754954,17.525075,2.8857467,18.1151529,4.8288818,51.626973,3.0916343,111.2080597),(43798,'forelimb',254,2,31,11.8124054,67.7326075,124.1752915,1.8,68.7879282,124.357941,0.2035377,1.9444337,9.4272088,5.8319725,154.8057698,0.0804398,16.421167,2.9993167,17.0336841,5.0576849,51.2212608,3.0828368,110.8520945),(43799,'forelimb',254,2,32,12.0469997,67.7604991,124.1363825,1.8,68.8678625,124.332513,0.2035855,1.9874061,9.407772,6.1089421,154.2853114,0.0820754,16.3997715,3.0738268,17.0406942,5.0424994,51.1978256,3.0912151,110.9563543),(43800,'forelimb',254,2,33,12.0340755,67.9061363,124.0965414,1.8,69.0129211,124.2666838,0.2010856,2.0123702,9.2722577,6.2591642,143.2689884,0.0800132,15.4513596,3.1103443,16.1123331,4.884539,51.1779874,3.0996005,111.2080597),(43801,'forelimb',254,2,34,12.139987,68.0099131,124.0788633,1.8,69.1066296,124.255256,0.2007159,1.9753249,9.1739449,6.45965,140.3736398,0.0804249,15.3013389,3.2701709,15.9879971,4.884539,51.1978256,3.0912151,110.8520945),(43802,'forelimb',254,2,35,12.0194168,68.2115279,124.0392055,1.8,69.1655242,124.182206,0.2027881,1.9767816,8.8987782,6.6360376,130.1712532,0.081256,14.6279916,3.3569907,15.3732599,4.8732911,51.1779874,3.0996005,110.8520945),(43803,'forelimb',254,2,36,12.2520528,68.3506938,124.0341565,1.8,69.2600394,124.1727492,0.2033303,2.0291527,8.7635346,6.8875826,128.5302319,0.0832661,14.666483,3.3943147,15.4514774,5.0660672,51.1617504,3.1079919,111.2080597),(43804,'forelimb',254,2,37,12.1075925,68.5854514,124.01346,1.8,69.4111385,124.1349745,0.2068253,2.0412108,8.5383151,7.0065378,122.3040174,0.0850967,14.3241396,3.43254,15.1428573,5.0623175,51.1617504,3.1079919,111.4597651),(43805,'forelimb',254,2,38,12.1759062,68.679087,124.0016109,1.8,69.540611,124.1537184,0.2069162,2.0101945,8.4491234,7.2016693,119.4887883,0.0856509,14.1421522,3.5825733,14.991662,5.156256,51.1491181,3.1163879,111.9199901),(43806,'forelimb',254,2,39,12.1006548,68.9286564,123.9776792,1.8,69.7210324,124.0991171,0.2094952,2.0188074,8.2103841,7.3313416,113.4866293,0.0872254,13.8223289,3.6315211,14.7100706,5.156256,51.1491181,3.1163879,111.9199901),(43807,'forelimb',254,2,40,12.1351753,69.0767881,123.9765901,1.8,69.9269477,124.1153788,0.2090877,1.9877809,8.0656151,7.4571762,111.347198,0.0871392,13.8051713,3.7515081,14.7224738,5.5379242,51.1491181,3.1163879,112.7793661),(43808,'forelimb',254,2,41,12.3095684,69.3058675,123.950733,1.8,70.0967558,124.0718099,0.2129698,1.9968448,7.8480991,7.6997703,105.7878886,0.091654,13.4794283,3.8559684,14.4502728,5.156256,51.1491181,3.1163879,112.4234009),(43809,'forelimb',254,2,42,12.1549813,69.4528426,123.942938,1.8,70.2378437,124.0655797,0.215814,2.0444171,7.7070121,7.6715694,101.9047196,0.0928986,13.2223381,3.7524484,14.2060664,5.156256,50.732307,3.1077073,111.8157303),(43810,'forelimb',254,2,43,12.4716528,69.6975734,123.9174943,1.8,70.3859098,124.0215259,0.223457,2.0084551,7.4761677,7.8971972,97.8632714,0.1020752,13.0900316,3.9319759,14.1323672,5.585944,51.1400931,3.1247875,112.5276607),(43811,'forelimb',254,2,44,12.5935097,69.8272923,123.909562,1.8,70.4434067,124.0120249,0.2274922,2.052836,7.2559516,8.1755536,94.982966,0.1067637,13.0903528,3.9825655,14.216244,5.585944,50.732307,0.0338853,112.1716955),(43812,'forelimb',254,2,45,12.4764644,70.0829959,123.8859966,1.8,70.6901085,123.9765664,0.2344239,2.0488359,7.0119926,8.3460241,89.7355584,0.1121951,12.7974405,4.0735444,13.9873742,6.0041539,50.732307,0.0338853,113.0310715),(43813,'forelimb',254,2,46,12.5622902,70.2092081,123.8756549,1.8,70.749393,124.0054292,0.2361262,2.2076211,6.8916115,8.6682329,88.5041588,0.1145828,12.8423023,3.9265039,14.1000406,6.015632,50.7486814,0.0423475,113.7430019),(43814,'forelimb',254,2,47,12.8257541,70.4632875,123.8394574,1.8,70.973586,123.9261608,0.2474334,2.1046429,6.6534745,8.8403359,84.6141721,0.1282233,12.7172911,4.2003972,14.0459708,6.4225765,50.3395584,0.0512372,114.2464127),(43815,'forelimb',254,2,48,12.8752131,70.6506601,123.8280661,1.8,71.1273479,123.9001534,0.2509243,2.1680489,6.4747573,9.0619629,82.0617853,0.1322984,12.6741099,4.1797779,14.0734967,6.4150771,50.732307,0.0338853,114.0989671),(43816,'forelimb',254,2,49,12.7671196,70.9427444,123.7953532,1.8,71.389592,123.857566,0.2596553,2.1930807,6.2009151,9.2346726,78.467989,0.1402665,12.6542596,4.2108222,14.1421963,6.44532,50.3193819,0.0427091,114.9583431),(43817,'forelimb',254,2,50,12.9489539,71.1063907,123.7719234,1.8,71.5891841,123.8424083,0.2683476,2.1470604,6.0498362,9.3778501,76.1480385,0.1517152,12.5867934,4.3677626,14.1350997,6.44532,49.9344786,0.0602717,113.6387421),(43818,'forelimb',254,2,51,12.9666338,71.3888554,123.7130707,1.8,71.7685056,123.7713632,0.2868764,2.1875636,5.7963152,9.5115161,71.0863123,0.173029,12.2640522,4.3479952,13.9020003,6.875008,49.8900891,0.0430768,114.8108974),(43819,'forelimb',254,2,52,12.8784581,71.5450513,123.686957,1.8,71.865318,123.7555151,0.2971933,2.144809,5.6555499,9.5709442,68.0095876,0.184063,12.025283,4.4623759,13.7138838,7.304696,49.8900891,0.0430768,115.418568),(43820,'forelimb',254,2,53,12.9688717,71.8139153,123.6389024,1.8,72.1246361,123.7255122,0.3130804,2.1553097,5.4159319,9.6841974,64.1109347,0.2050342,11.8374705,4.4931815,13.6188408,7.304696,49.5055776,0.0607946,114.7066377),(43821,'forelimb',254,2,54,13.1206614,71.9800132,123.5960114,1.8,72.2399178,123.6592485,0.3279708,2.1214294,5.2744376,9.672345,62.4826839,0.2269065,11.8463216,4.5593527,13.6718512,7.734384,49.5055776,0.0607946,115.418568),(43822,'forelimb',254,2,55,13.1015828,72.253451,123.5255344,1.8,72.5091386,123.5993264,0.3435832,2.1414593,4.8982007,9.7707552,57.5092059,0.2477874,11.7408838,4.562662,13.729649,7.734384,49.104898,0.0700606,115.7745332),(43823,'forelimb',254,2,56,13.2118024,72.4136697,123.4832876,1.8,72.5503076,123.5269295,0.3566291,2.2396255,4.7605063,10.0957057,55.7185122,0.2683823,11.7043248,4.5077651,13.8211405,8.164072,49.0766903,0.0613265,116.3822038),(43824,'forelimb',254,2,57,13.2179568,72.6833612,123.4202691,1.8,72.7719597,123.4321749,0.38029,2.1657919,4.5294641,10.150667,52.3096491,0.3035324,11.5487502,4.6868155,13.7882655,8.164072,49.0522306,0.0525831,116.5907234),(43825,'forelimb',254,2,58,13.203466,72.859689,123.3807366,1.8,72.9482479,123.3756186,0.3990785,2.1852301,4.3802923,10.173572,50.0814213,0.3322568,11.4333513,4.6556067,13.755128,8.164072,48.6762735,0.0706785,115.878793),(43826,'forelimb',254,2,59,13.077245,73.1441116,123.2958128,1.8,73.2436482,123.3144041,0.4223406,2.1584115,4.1533862,10.0101453,45.9079368,0.3661958,11.0531345,4.6377372,13.4624652,8.59376,48.2801842,0.0801848,115.9830528),(43827,'forelimb',254,2,60,13.138733,73.304053,123.2553479,1.8,73.3143882,123.2783886,0.437151,2.1142322,4.0258259,10.1229578,44.5074944,0.3924841,11.0554942,4.7880065,13.5667774,9.023448,48.2476678,0.0713075,117.4500994),(43828,'forelimb',254,2,61,13.1635184,73.579407,123.2011708,1.8,73.5958315,123.2295001,0.4676076,2.0782116,3.8052565,10.1290027,40.6898093,0.4457549,10.6930529,4.8739035,13.3461777,9.023448,47.8190816,0.0719477,116.339018),(43829,'forelimb',254,2,62,13.1973675,73.7361126,123.1563442,1.8,73.752652,123.1636356,0.493019,2.1881631,3.6906963,10.1883055,38.9977406,0.492704,10.5664996,4.6560996,13.3153746,9.023448,48.1940635,0.0535203,116.8424288),(43830,'forelimb',254,2,63,12.9742988,74.0115164,123.0801201,1.8,73.9774122,123.0555356,0.5362525,2.1768988,3.4961243,10.057282,35.2225596,0.5644628,10.0747445,4.6200043,12.9300705,9.453136,47.7649963,0.0540015,116.339018),(43831,'forelimb',254,2,64,12.9985247,74.1692815,123.0333562,1.8,74.1114144,123.0112108,0.5634978,2.1614766,3.396049,10.1346512,33.4990725,0.6181068,9.8641312,4.6887629,12.8346942,9.453136,47.3612865,0.0635507,116.4864636),(43832,'forelimb',254,2,65,12.4501124,74.443783,122.9638161,1.8,74.3701262,122.9487418,0.63213,2.153039,3.2256062,9.6817757,29.372167,0.7244324,9.1059369,4.4967953,12.087005,9.882824,46.9324739,0.0641321,115.479642),(43833,'forelimb',254,2,66,12.1790394,74.6001897,122.9032176,1.8,74.5162157,122.8630462,0.6722574,2.1231608,3.233368,9.5176948,27.5289223,0.7872172,8.5140084,4.4827952,11.4382223,9.882824,46.5036774,0.0647243,115.479642),(43834,'forelimb',254,2,67,11.5656702,74.8306127,122.7947316,1.8,74.725314,122.7585563,0.7557524,2.0385286,3.0556513,8.8826258,24.2015103,0.9066937,7.9202462,4.3573712,10.5220696,10.312512,46.0488432,0.0560161,114.9762312),(43835,'forelimb',254,2,68,11.2752948,74.9766648,122.7352042,1.8,74.88848,122.7257985,0.8192747,2.1895253,3.3201961,8.5102123,22.3130656,1.0032205,6.7204059,3.8867841,9.199164,10.312512,45.248003,0.0760436,114.8719714),(43836,'forelimb',254,2,69,10.7175949,75.1941125,122.6403978,1.8,75.0562629,122.6411397,0.917912,2.0383907,3.2916646,7.8178849,19.6771986,1.1270766,5.9778868,3.8353221,8.3055961,10.7422,45.1683644,0.0475831,113.2574792),(43837,'forelimb',254,2,70,10.2413568,75.3192116,122.5618283,1.8,75.208163,122.5674384,0.9881636,2.0965107,3.3050256,7.2353323,18.2580778,1.1901367,5.5243377,3.4511307,7.6883428,10.7422,44.3328915,0.0581867,112.5455488),(43838,'forelimb',254,2,71,9.3776158,75.5288344,122.4190085,1.8,75.3962324,122.3723401,1.1007315,1.9945071,2.9634813,6.0523383,15.7635674,1.2422866,5.3192735,3.0345033,7.3606044,11.1077179,43.4749986,0.0593362,111.4344674),(43839,'forelimb',254,2,72,8.9165399,75.6560078,122.3324262,1.8,75.4688378,122.3048298,1.1599572,1.8777799,2.9840157,5.3525821,14.5208525,1.2490535,4.8662118,2.8504843,6.6580027,11.1114676,43.0224775,0.0499584,109.863161),(43840,'forelimb',254,2,73,7.8392415,75.8630151,122.181872,1.8,75.6903571,122.1619301,1.2514056,1.8104748,3.0428762,4.0100134,12.1273085,1.1777303,3.9854755,2.214896,5.3004042,11.1152173,42.144486,3.100799,108.7520796),(43841,'forelimb',254,2,74,7.2088079,75.9801043,122.0873415,1.8,75.839932,122.15416,1.2994941,1.6841012,3.0942072,3.2481855,10.6524044,1.1151826,3.4426927,1.9287354,4.4896802,11.5411392,41.7151591,3.1003789,107.0333276),(43842,'forelimb',254,2,75,6.1019683,76.1268155,121.9254307,1.8,75.9456489,121.9836489,1.3559269,1.680586,3.2100494,2.3115431,8.3922998,0.9707594,2.6143834,1.3754388,3.3326862,11.5451409,40.8768588,3.0890096,105.8179864),(43843,'forelimb',254,2,76,5.3721133,76.2220813,121.8208083,1.8,76.0625885,121.9532669,1.3919775,1.4706026,2.867341,1.7676636,6.8706611,0.8670261,2.3961786,1.2019995,3.0064084,11.5376419,40.0440631,3.0771658,103.4915638),(43844,'forelimb',254,2,77,4.382487,76.3651245,121.6761383,1.8,76.2069572,121.7986443,1.4379282,1.2634017,2.9802607,1.11392,5.0107625,0.7175955,1.6813168,0.8816832,2.0522882,11.9522662,39.2171226,3.0648208,102.4847422),(43845,'forelimb',254,2,78,3.705336,76.4464567,121.5760176,1.8,76.26962,121.6119347,1.4647875,1.292217,2.6386845,0.8007067,3.8280692,0.6106419,1.4507491,0.619638,1.7496893,11.9597653,38.7887143,3.0639711,101.3736608),(43846,'forelimb',254,2,79,2.6533824,76.5674117,121.4253077,1.8,76.3933181,121.4845164,1.4955657,0.9852114,2.3443214,0.4144409,2.285569,0.4397323,0.9749384,0.4206619,1.1486708,11.9597653,37.5823509,3.038511,99.090424),(43847,'forelimb',254,2,80,2.0877938,76.6433574,121.3595468,1.8,76.5003784,121.474389,1.5178761,1.0296529,2.4015743,0.2518347,1.6164004,0.346992,0.6730587,0.2445821,0.7765271,12.6950081,37.075377,3.0603763,98.0836024),(43848,'forelimb',254,2,81,1.3003113,76.7303777,121.2424197,1.8,76.607232,121.3152453,1.5388944,0.7004234,2.0828407,0.1093152,0.8239592,0.2164981,0.3955939,0.1560702,0.4473676,12.713746,36.2571132,3.0466409,96.2605906),(43849,'forelimb',254,2,82,0.8737,76.7967693,121.2207466,1.8,76.73,121.38686,1.5449294,0.3442808,1.6724987,0.0458829,0.469246,0.1455192,0.2805658,0.1332718,0.3076973,12.6987502,35.0689645,3.0187574,94.1858734),(43850,'forelimb',254,2,83,0.4297444,76.8539588,121.1462828,1.8,76.7852456,121.172016,1.5360743,0.385082,1.3160943,0.0164284,0.1818439,0.0715378,0.1381693,0.042662,0.1506428,12.6878407,34.5918856,3.0295637,92.4671214),(43851,'forelimb',254,2,84,0.2281042,76.914152,121.0839073,1.8,76.914152,120.957172,1.5275171,0.0519602,1.1998307,0.003661,0.0842478,0.0379462,0.0702164,0.0704583,0.0731991,13.1322629,33.4853518,2.9869921,91.35604),(43852,'forelimb',254,2,85,0.057124,76.914152,121.1842207,1.8,76.914152,121.172016,1.4393245,0.0579292,0.4380791,0.0009911,0.007297,0.009357,0.0166569,0.0171094,0.0187561,13.1322629,32.5713708,2.9959643,89.1338772),(43853,'forelimb',254,2,86,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43854,'forelimb',254,2,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43855,'forelimb',254,2,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43856,'forelimb',254,2,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43857,'forelimb',254,2,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43858,'forelimb',254,2,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43859,'forelimb',254,2,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43860,'forelimb',254,2,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43861,'forelimb',254,2,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43862,'forelimb',254,2,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43863,'forelimb',254,2,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43864,'forelimb',254,2,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43865,'forelimb',254,2,98,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43866,'forelimb',254,2,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43867,'forelimb',254,2,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43868,'forelimb',254,2,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43869,'forelimb',254,2,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43870,'forelimb',254,2,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43871,'forelimb',254,2,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43872,'forelimb',254,2,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43873,'forelimb',254,2,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43874,'forelimb',254,2,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43875,'forelimb',254,2,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43876,'forelimb',254,2,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43877,'forelimb',254,2,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43878,'forelimb',254,2,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43879,'forelimb',254,2,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43880,'forelimb',254,2,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43881,'forelimb',254,2,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43882,'forelimb',254,2,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43883,'forelimb',254,2,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43884,'forelimb',254,2,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43885,'forelimb',254,2,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43886,'forelimb',254,2,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43887,'forelimb',254,2,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43888,'forelimb',254,2,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43889,'forelimb',254,2,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43890,'forelimb',254,2,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43891,'forelimb',254,2,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43892,'forelimb',254,2,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43893,'forelimb',254,2,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43894,'forelimb',254,2,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43895,'forelimb',254,2,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43896,'forelimb',254,2,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43897,'forelimb',254,2,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43898,'forelimb',254,2,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43899,'forelimb',254,2,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43900,'forelimb',254,2,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43901,'forelimb',254,2,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43902,'forelimb',254,2,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43903,'forelimb',254,2,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43904,'forelimb',254,2,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43905,'forelimb',254,2,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43906,'forelimb',254,2,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43907,'forelimb',254,2,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43908,'forelimb',254,2,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43909,'forelimb',254,2,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43910,'forelimb',254,2,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43911,'forelimb',254,2,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43912,'forelimb',254,2,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43913,'forelimb',254,2,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43914,'forelimb',254,2,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43915,'forelimb',254,2,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43916,'forelimb',254,2,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43917,'forelimb',254,2,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43918,'forelimb',254,2,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43919,'forelimb',254,2,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43920,'forelimb',254,2,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43921,'forelimb',254,2,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43922,'forelimb',254,2,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43923,'forelimb',254,2,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43924,'forelimb',254,2,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43925,'forelimb',254,2,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43926,'forelimb',254,2,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43927,'forelimb',254,2,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43928,'forelimb',254,2,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43929,'forelimb',254,2,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43930,'forelimb',254,2,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43931,'forelimb',254,2,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43932,'forelimb',254,2,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43933,'forelimb',254,2,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43934,'forelimb',254,2,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43935,'forelimb',254,2,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43936,'forelimb',254,2,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43937,'forelimb',254,2,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43938,'forelimb',254,2,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43939,'forelimb',254,2,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43940,'forelimb',254,2,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43941,'forelimb',254,2,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43942,'forelimb',254,2,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43943,'forelimb',254,2,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43944,'forelimb',254,2,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43945,'forelimb',254,2,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43946,'forelimb',254,2,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43947,'forelimb',254,2,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43948,'forelimb',254,2,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43949,'forelimb',254,2,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43950,'forelimb',254,2,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43951,'forelimb',254,2,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43952,'forelimb',254,2,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43953,'forelimb',254,2,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43954,'forelimb',254,2,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43955,'forelimb',254,2,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43956,'forelimb',254,2,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43957,'forelimb',254,2,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43958,'forelimb',254,2,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43959,'forelimb',254,2,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43960,'forelimb',254,2,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43961,'forelimb',254,2,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43962,'forelimb',254,2,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(43963,'forelimb',254,2,196,0.2199916,62.1482714,119.0903459,1.8,62.181992,119.115652,0.3751557,0.6801406,1.0781913,0.0342823,0.0592439,0.0049227,0.0549475,0.0504047,0.0866991,1.718752,2.5054901,2.6011732,5.9724462),(43964,'forelimb',254,2,197,9.5745004,63.2421045,119.0559239,1.8,63.1846789,118.9859141,-0.2441405,3.4930614,4.0280797,26.3981382,34.095166,0.0932392,8.4643722,7.5573073,14.7428954,7.304696,8.59376,0.6435011,25.6517225),(43965,'forelimb',254,2,198,15.4734298,63.5772323,119.1976618,1.8,63.3878855,119.0413869,-0.2991774,4.6167338,5.2093093,67.2342562,86.512549,0.2240251,16.6072973,14.5631651,29.0744775,9.023448,10.6125107,0.5543075,31.2682035),(43966,'forelimb',254,2,199,24.6571263,63.6724692,119.3256642,1.8,63.4729287,119.0694579,-0.36854,5.4933196,6.4137821,151.7032385,232.1248698,0.5333453,36.1915743,27.6159497,58.6200791,11.0478114,13.2369013,0.6240231,39.2111071),(43967,'forelimb',254,2,200,34.2450545,63.5387142,119.3733906,1.8,63.4703104,119.1059184,-0.4991775,6.1443699,7.1771024,269.1633496,401.8965502,1.3079162,55.9970484,43.8065016,91.1737179,12.460952,14.8972278,0.5800028,43.8639523),(43968,'forelimb',254,2,201,48.626695,63.4815408,119.1915391,1.8,63.5348743,118.9950222,-0.5458587,7.2080226,8.4340168,491.5863352,717.2536827,2.1843034,85.0429512,68.1998881,143.1667489,14.0417081,16.7357822,0.5095923,49.4804333),(43969,'forelimb',254,2,202,57.8270643,63.5518769,119.1107344,1.8,63.5831942,118.9160518,-0.6054135,7.68415,9.0249393,671.8027191,1000.8728543,3.1214787,110.9007846,87.4270696,185.3198875,15.1020964,17.7633248,0.5611634,53.5866819),(43970,'forelimb',254,2,203,68.0383765,63.582044,118.939841,1.8,63.6247213,118.7638231,-0.5415529,8.1778868,9.7673954,897.122811,1372.0305934,3.0130405,140.4704675,109.7010546,232.064888,16.18622,19.0715653,0.393058,57.840376),(43971,'forelimb',254,2,204,74.4202578,63.4769489,118.9058378,1.8,63.5524637,118.6464091,-0.5022039,8.5925269,10.400008,1099.1282724,1603.5838539,2.8739369,154.1906366,127.9167687,258.8131165,16.9689687,20.126652,0.2812322,60.3142442),(43972,'forelimb',254,2,205,85.2829845,63.5828739,118.6629973,1.8,63.695849,118.40699,-0.456147,8.9828028,10.8053836,1356.3284227,1993.1571986,2.7579591,184.4596432,150.9916725,302.9233305,17.5651487,21.0678616,0.2053954,62.7449266),(43973,'forelimb',254,2,206,91.6885323,63.5950461,118.3611066,1.8,63.6319505,118.2282079,-0.413888,9.2904325,11.2001325,1507.2001008,2387.2761425,2.4716538,213.1471346,162.231424,344.3146806,18.2051342,21.6939254,0.1390959,65.4273144),(43974,'forelimb',254,2,207,100.2978561,63.583586,118.0002783,1.8,63.5798909,117.5548741,-0.3593252,11.1037905,11.2679014,1878.5023563,2827.7124128,2.0670138,250.9528888,169.1766743,346.0284127,19.2824747,22.4920224,3.026716,71.191241),(43975,'forelimb',254,2,208,110.4531074,63.4601231,117.2326517,1.8,63.4525322,116.8098556,-0.4373143,10.3739109,11.3837215,2486.4940314,3510.3028534,3.3017949,308.3616249,239.6872361,442.15803,21.1084007,24.4959849,1.3045443,76.3043112),(43976,'forelimb',254,2,209,122.3289031,63.2414334,116.5109066,1.8,63.1988664,116.0579615,-0.5919468,12.2578062,11.782265,3456.5251924,3995.7401827,6.3476276,339.1317539,281.9856285,556.7729318,22.2847936,25.2201601,1.4168517,79.1952186),(43977,'forelimb',254,2,210,124.7919469,63.0590678,116.020659,1.8,63.0762632,115.7778124,-1.0074579,12.3423181,12.4313661,3806.1209129,4214.8531022,14.8675348,339.0498724,308.3797455,608.9537295,22.2429966,25.5835817,1.436025,79.2994784),(43978,'forelimb',254,2,211,122.5487268,62.9418031,115.7076745,1.8,63.041712,115.508403,-1.2998966,11.9625773,13.0571241,3599.4401502,4436.261602,18.9621908,339.7579399,300.8916943,610.7908271,21.6658127,26.0094374,1.4382448,79.5511838),(43979,'forelimb',254,2,212,120.3916681,62.9351488,115.6794661,1.8,62.9195036,115.3740844,-1.3764204,11.5848286,13.1157381,3350.7735526,4516.5932929,19.3166711,344.3644008,289.2380764,599.2215689,21.4166759,26.0094374,1.4382448,78.7349936),(43980,'forelimb',254,2,213,112.9850805,62.884939,115.5696792,1.8,62.8787446,115.1687645,-1.4324227,11.1312156,13.0267725,2901.5101319,4447.8121951,18.4725832,341.4362373,260.6642659,564.1020797,20.6622759,26.069706,1.4219064,77.0162416),(43981,'forelimb',254,2,214,107.4275521,62.85906,115.4359582,1.8,62.8668982,115.0011204,-1.4386973,10.9489801,12.8960946,2673.0179648,4261.2306336,17.5939672,330.4279917,244.1339692,537.5275254,20.3406997,26.069706,1.4219064,76.1568656),(43982,'forelimb',254,2,215,101.5372948,62.9277962,115.1754248,1.8,62.9430854,114.7154764,-1.4511706,10.6217847,12.5811847,2410.8536797,3846.8243713,16.6818637,305.7601052,226.972562,497.1152814,19.6394784,25.3661535,1.3833672,74.0821484),(43983,'forelimb',254,2,216,97.4581075,62.9944162,114.8981485,1.8,62.9839443,114.4598106,-1.4652053,10.557241,12.7663205,2248.6851912,3542.5511673,16.0625889,277.4919503,212.9993238,453.5619816,19.1419848,25.1578563,1.4337302,72.8236214),(43984,'forelimb',254,2,217,83.678926,63.087931,114.070515,1.8,63.1068996,113.8570893,-1.5272738,9.9744302,12.3737003,1998.3135958,2603.0977479,13.9200868,210.3734284,200.3436349,365.0914136,18.4536792,24.1008625,1.3734008,68.4224816),(43985,'forelimb',254,2,218,78.3835748,63.1038946,113.6244557,1.8,63.1310123,113.3394877,1.5169933,9.7521075,10.1142757,1848.3576334,2216.0575386,13.0261486,219.1019517,189.5341741,390.5022646,17.6314737,21.1596801,1.3455195,63.6653766),(43986,'forelimb',254,2,219,73.7059566,63.2266604,113.3095443,1.8,63.1300177,113.0157135,1.2740654,8.9087728,9.4723502,1689.027191,1958.2314084,11.2340754,206.7313143,189.5914547,356.7375256,17.0500144,19.9747158,2.8130395,60.6270236),(43987,'forelimb',254,2,220,71.3043448,63.3251835,113.1402808,1.8,63.2034539,112.853832,1.0893662,8.3825923,8.7865498,1591.5108554,1844.7185672,9.335964,209.9480008,189.8590322,339.749648,16.6937869,19.7142053,2.8543112,59.5159422),(43988,'forelimb',254,2,221,68.4323695,63.3605751,112.9458804,1.8,63.1947188,112.7170253,0.966755,8.1460899,8.6972553,1461.9624675,1718.9434124,7.7260872,197.6420554,179.4680013,323.9757395,16.2358859,19.163314,2.7985687,57.6929304),(43989,'forelimb',254,2,222,66.0503399,63.3748342,112.8046687,1.8,63.1997075,112.6134233,0.9838083,7.9342618,8.406137,1376.8588084,1641.376386,7.6314986,195.2592947,173.5333222,312.7496581,15.7994355,18.8916179,2.8414215,56.2258838),(43990,'forelimb',254,2,223,64.4205448,63.4776601,112.7060998,1.8,63.4114935,112.5004786,0.9702629,7.6903877,8.1982819,1276.3662792,1529.9114663,7.3083137,186.6136683,165.969043,301.4507129,15.4956002,18.3562794,2.782822,55.262248),(43991,'forelimb',254,2,224,61.919064,63.4898409,112.6345182,1.8,63.2976269,112.4622942,0.9762681,7.5179508,8.1106898,1209.0621153,1452.018654,7.0821772,179.0252971,160.8233615,292.6075528,15.3764455,18.1132733,2.7522759,54.7588372),(43992,'forelimb',254,2,225,61.1944682,63.6159795,112.6378912,1.8,63.3741339,112.4688725,1.0150567,7.3015374,7.9565965,1137.0237562,1384.4821698,7.360349,174.0043215,155.7238839,283.2539451,14.8879296,17.7164901,2.7430702,53.2917906),(43993,'forelimb',254,2,226,60.3877392,63.6023725,112.6100367,1.8,63.3205617,112.4527292,1.0471524,7.2514297,7.8557268,1094.1690777,1341.948849,7.5480737,170.8242758,150.8901169,279.385149,14.8698984,17.4010378,2.7886023,52.5798602),(43994,'forelimb',254,2,227,59.464972,63.7167904,112.5702229,1.8,63.3802483,112.4641122,1.1060071,7.2222072,7.9237348,1034.7917264,1285.7684365,7.9196037,162.2679796,143.2791531,270.6770579,14.5840943,17.1552631,2.7564351,51.7204842),(43995,'forelimb',254,2,228,58.4934172,63.7558612,112.616951,1.8,63.4089151,112.4855366,1.1711647,7.426345,8.1210179,1005.6129668,1251.7347591,8.2730895,154.1352053,135.411561,266.7084331,14.423712,16.927744,2.7233683,51.1128137),(43996,'forelimb',254,2,229,59.6043969,63.804458,112.6256807,1.8,63.5304014,112.5106052,1.1932683,7.2853951,8.0276634,986.1098691,1211.0579723,8.5841909,150.8605816,135.3543429,265.3290249,14.2681416,16.6028685,1.7529646,50.6094028),(43997,'forelimb',254,2,230,60.4126925,63.7859462,112.6674188,1.8,63.5317752,112.5187926,1.1755689,7.0949008,7.9561431,979.3839905,1185.8911288,8.5761965,149.0535193,138.0405482,261.6132706,14.0747111,16.5360111,2.7128146,50.0017322),(43998,'forelimb',254,2,231,60.0798517,63.9163993,112.5973853,1.8,63.5905272,112.4315467,1.1375798,6.914635,7.713799,953.0346173,1186.0416976,8.2487073,153.755847,137.8286217,267.900915,13.9265943,16.3337968,2.677945,49.6457671),(43999,'forelimb',254,2,232,59.7314012,63.8843626,112.5194828,1.8,63.616686,112.3789464,1.143925,6.9026868,7.6408389,934.5833735,1182.3841254,8.2487409,154.7453279,135.3941436,270.1432535,13.711257,16.1061369,1.7315591,49.3940617),(44000,'forelimb',254,2,233,59.5605329,63.9348531,112.541401,1.8,63.7121089,112.3929832,1.164444,6.8128323,7.7150221,903.6008157,1144.0102233,8.3758832,148.2834673,132.6321832,260.2375837,13.7061216,15.9448411,1.815775,48.4304259),(44001,'forelimb',254,2,234,58.7150313,64.0012181,112.6784658,1.8,63.8126983,112.5497341,1.1528021,6.6930015,7.8048654,882.3032475,1119.8006185,8.1733507,143.4746871,131.8247498,252.2702767,13.590111,15.8461105,1.7894653,48.1787205),(44002,'forelimb',254,2,235,57.667162,64.0974609,112.5933456,1.8,63.9029898,112.4479086,1.1498067,6.6055607,7.5888683,855.7788062,1076.4689334,8.006065,141.8484146,129.5543021,247.5503151,13.4578986,15.6821404,1.735945,47.8227553),(44003,'forelimb',254,2,236,57.7254609,64.0650573,112.5701025,1.8,63.8452372,112.4358974,1.1547369,6.6402264,7.5591674,843.4693499,1064.2548468,8.0493862,140.7899568,127.0241859,245.2535508,13.4578986,15.6821404,1.735945,47.5710499),(44004,'forelimb',254,2,237,58.4276771,64.1305063,112.648321,1.8,63.9495174,112.4847891,1.1103799,6.4793188,7.4180269,823.1087242,1046.6304551,7.8154679,141.0928372,127.0363061,246.1025867,13.2650819,15.4269362,1.7955075,47.2150847),(44005,'forelimb',254,2,238,58.32792,64.1266678,112.6694516,1.8,63.8967837,112.4607683,1.1019245,6.4705693,7.4260205,811.3597489,1033.9543349,7.7362686,139.2339721,125.3923284,242.2628481,13.2318002,15.4269362,1.7955075,46.3557087),(44006,'forelimb',254,2,239,57.332363,64.2057457,112.6665137,1.8,64.1459731,112.5403002,1.1207757,6.4517275,7.4707034,791.9905083,999.9344592,7.7474069,133.8474307,122.7563485,237.7209006,13.1157896,15.3369125,1.7681919,46.1040033),(44007,'forelimb',254,2,240,57.3551343,64.2331878,112.7128937,1.8,64.1981879,112.5657265,1.129054,6.4715159,7.3449073,779.1353636,994.2957619,7.8120636,135.3721326,120.3945682,235.96184,13.114751,15.1917649,1.7126934,46.1040033),(44008,'forelimb',254,2,241,57.537696,64.3089697,112.7401899,1.8,64.1945028,112.603315,1.1167587,6.3790976,7.3914856,761.2947278,977.8751732,7.7448814,132.2975139,119.342072,233.5720984,13.0722652,15.0083566,1.801887,45.7480381),(44009,'forelimb',254,2,242,58.6330659,64.2612611,112.7221375,1.8,64.159807,112.5423889,1.1041233,6.3760139,7.3448555,759.5898074,970.9095749,7.7940369,132.1890636,119.1323953,235.597466,12.9946395,14.9158068,1.7738415,45.7480381),(44010,'forelimb',254,2,243,58.4245439,64.3157619,112.820782,1.8,64.2783094,112.7169623,1.071248,6.2716955,7.2800656,756.8360099,944.4674737,7.5029884,129.733374,120.6748662,233.3404025,12.8786289,14.8351299,1.7454685,45.3920729),(44011,'forelimb',254,2,244,58.5824321,64.3122485,112.8486095,1.8,64.3214597,112.7919511,1.075863,6.3024577,7.3015331,751.5514377,938.7899456,7.5610459,128.5743593,119.24736,231.0001956,12.8744726,14.8351299,1.7454685,45.1403675),(44012,'forelimb',254,2,245,59.6875372,64.4141667,112.9350921,1.8,64.391816,112.9573925,1.0420362,6.2517419,7.3708491,749.9867903,923.9338818,7.416345,125.3497217,119.9644521,225.5413024,12.8744726,14.7665205,1.7168086,45.1403675),(44013,'forelimb',254,2,246,59.4877992,64.4024679,112.9535606,1.8,64.3989156,112.9230768,1.0135966,6.3593188,7.215203,747.1753477,912.7529569,7.1420886,126.5041274,117.492985,227.5349249,12.9542135,14.7101476,1.6879051,44.8886621),(44014,'forelimb',254,2,247,59.8185698,64.4300482,113.0290016,1.8,64.4364983,112.9570799,1.0119796,6.2549165,7.2929644,741.5841585,892.9979495,7.167318,122.4464973,118.5602003,222.2664182,12.8109139,14.5904229,1.8086323,44.7844023),(44015,'forelimb',254,2,248,60.4678582,64.3988393,113.0726787,1.8,64.4172052,113.0214421,1.0299431,6.2584428,7.3227435,742.6814609,885.0727628,7.4064187,120.8662792,118.6687304,221.8660645,12.8854233,14.4952048,1.7798193,44.5326969),(44016,'forelimb',254,2,249,60.8348279,64.4757714,113.134004,1.8,64.4973096,113.0604192,1.0057266,6.3415409,7.1725631,738.453214,870.2087766,7.231911,121.3246593,116.4469692,222.2997252,12.8564493,14.3415411,1.7211678,44.1767317),(44017,'forelimb',254,2,250,61.1996714,64.4886389,113.1698754,1.8,64.5630849,113.0905472,0.9870441,6.3675542,7.1904099,742.2289969,862.3981974,7.1014481,119.9372791,116.5642221,215.8469715,12.824307,14.4057668,2.8387078,44.5326969),(44018,'forelimb',254,2,251,61.1658782,64.5241531,113.2371381,1.8,64.6067681,113.169077,1.002326,6.3333363,7.1514292,735.5273109,841.5819786,7.2398602,117.6802496,116.1358363,213.540894,12.824307,14.283491,1.69142,44.5326969),(44019,'forelimb',254,2,252,60.9975276,64.4980533,113.2808331,1.8,64.6171799,113.227343,1.0403345,6.3048111,7.1861469,731.2104143,827.8987344,7.5640291,115.2076002,115.9765769,210.6215215,12.7287481,14.283491,2.8674252,44.2809915),(44020,'forelimb',254,2,253,61.5062721,64.5520051,113.3464105,1.8,64.614333,113.2901159,1.0789786,6.3256388,7.0680213,731.4593327,811.1390435,7.9650607,114.761828,115.6340664,210.2521622,12.7287481,14.1731921,2.896614,43.6733209),(44021,'forelimb',254,2,254,61.7457899,64.4919865,113.3823757,1.8,64.4815901,113.2964488,1.1908136,6.4874792,7.1445579,725.8926897,803.7590116,8.8752357,112.4994753,111.8913316,213.5814937,12.6659634,13.9896277,1.7561443,43.0656503),(44022,'forelimb',254,2,255,61.6107849,64.4735993,113.415881,1.8,64.4693421,113.2938902,1.3231972,6.6402372,7.1757901,703.8753862,792.9408998,9.6517119,110.5022427,106.0015433,208.2308564,12.591907,13.9896277,1.7561443,43.0656503),(44023,'forelimb',254,2,256,61.9178331,64.3823612,113.4181965,1.8,64.3623341,113.3082636,1.3896728,6.4834678,7.0402751,691.2198869,794.6524123,9.9847815,112.8723516,106.612681,210.3069625,12.591907,13.9168507,1.7257931,42.7096851),(44024,'forelimb',254,2,257,61.6450257,64.340462,113.4666917,1.8,64.3533814,113.3690067,1.4339475,6.5007098,6.9999971,671.2846125,782.6967792,10.0829585,111.8138722,103.2632794,207.6059575,12.4882081,13.9896277,1.3854484,42.7096851),(44025,'forelimb',254,2,258,61.9257219,64.2359863,113.5011214,1.8,64.2171852,113.4313592,1.4591917,6.5802991,7.014706,660.9344205,782.96145,10.1929328,111.6171443,100.4413946,205.6597838,12.4882081,13.9168507,1.4157996,42.7096851),(44026,'forelimb',254,2,259,62.1477836,64.1768096,113.5559478,1.8,64.1593636,113.5269277,1.4908142,6.3156914,6.9832151,646.1057872,775.4443592,10.2918437,111.0440321,102.301671,203.1138926,12.4043075,13.9896277,1.3854484,42.1020145),(44027,'forelimb',254,2,260,62.198921,64.0897698,113.5703169,1.8,64.1108533,113.5624053,1.5179482,6.377165,6.6631117,637.4226135,778.3855894,10.3375609,116.8201327,99.9539154,207.7215757,12.3991681,13.8836442,1.1902899,41.7460493),(44028,'forelimb',254,2,261,62.1403424,64.0570658,113.6506205,1.8,64.0581389,113.6139143,1.5404556,5.9988213,6.6953671,622.410796,769.9389077,10.3471927,114.9957717,103.7555158,202.7223988,12.031264,13.9962251,1.2587542,41.3900841),(44029,'forelimb',254,2,262,62.3083013,63.9899572,113.6939442,1.8,64.0132813,113.6666415,1.5523936,6.0528791,6.723601,616.1967754,770.5647822,10.3812004,114.6059659,101.8022611,203.0130082,12.031264,13.8703393,1.2882414,41.3900841),(44030,'forelimb',254,2,263,61.7765618,63.9529521,113.7720822,1.8,63.9731017,113.716089,-1.5589093,6.1073244,6.7954527,603.1546431,759.7597504,10.2946389,111.8041402,98.7592287,197.102289,12.031264,13.9962251,1.2587542,41.3900841),(44031,'forelimb',254,2,264,61.8143834,63.8859313,113.8041658,1.8,63.9146792,113.7488132,-1.5434172,6.1879245,6.8483563,594.7493961,763.4944311,10.2946763,111.4857935,96.1145202,195.1599112,12.031264,13.9962251,1.2587542,41.3900841),(44032,'forelimb',254,2,265,61.8616043,63.8524075,113.8721187,1.8,63.8802827,113.7831627,-1.5218635,5.8760275,6.9429934,581.3009556,761.9866973,10.2856,109.7490165,98.9275416,190.9963836,11.601576,13.9962251,1.2587542,41.0341189),(44033,'forelimb',254,2,266,62.0066242,63.7865162,113.925886,1.8,63.7950398,113.8889647,-1.4972573,5.9607506,7.026958,577.4695768,761.5530661,10.2786495,108.3759242,96.8786674,188.6072593,11.9164558,14.1340576,1.2298174,41.7460493),(44034,'forelimb',254,2,267,61.9676277,63.765156,114.0197012,1.8,63.7650591,113.9705411,-1.4758482,6.0072136,7.1424405,567.6353539,753.4455456,10.2351095,105.4885299,94.4922872,183.5920246,11.9164558,14.1731921,1.3258177,41.4943439),(44035,'forelimb',254,2,268,61.9279039,63.695904,114.0866394,1.8,63.697431,114.0504394,-1.4560887,5.9971288,7.2327437,560.7201844,754.8951578,10.1861058,104.3718938,93.4981068,180.8107329,11.9153649,14.283491,1.2966289,41.4943439),(44036,'forelimb',254,2,269,61.6770845,63.6891608,114.1823345,1.8,63.6739353,114.143259,-1.4391397,5.7965921,7.3409149,548.359586,750.1853793,10.1023616,102.1923549,94.6003403,176.1690227,11.601576,14.283491,1.2014627,40.8866733),(44037,'forelimb',254,2,270,61.866416,63.6230968,114.2398426,1.8,63.6164392,114.1936244,-1.4217544,5.8225808,7.4180551,543.7835876,754.1489926,10.0837154,101.6639787,93.3921927,174.4100793,11.601576,14.4057668,1.2679115,41.1383787),(44038,'forelimb',254,2,271,61.5109159,63.6124649,114.3283491,1.8,63.63133,114.2489025,-1.396205,5.8504189,7.5198307,531.7299152,745.7901766,9.9424845,99.176458,90.8874944,169.6470343,11.5330041,14.4441652,1.1737169,41.1383787),(44039,'forelimb',254,2,272,61.7112693,63.5370537,114.3809241,1.8,63.5782437,114.3207884,-1.3785456,5.8511226,7.509636,526.268157,748.5735615,9.9097271,99.6817369,89.9431082,169.7484084,11.5319132,14.4057668,1.2679115,41.1383787),(44040,'forelimb',254,2,273,61.6717693,63.4965311,114.5140617,1.8,63.4913221,114.4905316,-1.352936,5.7325645,7.4098156,517.0747597,741.5741976,9.7984423,100.07998,90.1995534,169.1930317,11.171888,14.4441652,1.1737169,40.7824135),(44041,'forelimb',254,2,274,61.7824924,63.4209626,114.5889065,1.8,63.4334071,114.5777375,-1.3366317,5.8138535,7.410223,514.5431014,738.6955496,9.7427062,99.6860084,88.502935,169.0746834,11.5319132,14.283491,1.2014627,40.8866733),(44042,'forelimb',254,2,275,61.8954535,63.3744222,114.6982452,1.8,63.3569238,114.7414002,-1.3189696,5.7485269,7.2206124,506.9621033,732.3185226,9.6754207,101.4205559,88.1899161,171.0662713,11.5308224,14.2316921,1.0666304,40.7824135),(44043,'forelimb',254,2,276,62.0316894,63.2913103,114.7776965,1.8,63.3182989,114.7988573,-1.3079799,5.704611,7.3249449,503.796343,733.1382155,9.6407925,100.0878815,88.3138818,168.3616924,11.3390965,14.283491,1.2014627,40.5307081),(44044,'forelimb',254,2,277,62.2809423,63.240856,114.899965,1.8,63.2395774,114.8751188,-1.2945242,5.7218716,7.3461043,497.9794201,729.6242906,9.6078315,99.3212535,87.0308624,167.1017698,11.3401874,14.225204,1.1341692,40.2790027),(44045,'forelimb',254,2,278,62.4223254,63.1513551,114.9954854,1.8,63.1468165,114.9567976,-1.2795426,5.7378617,7.4635355,496.1558503,727.8030363,9.5458607,97.5145145,86.4705146,163.9913143,11.171888,14.283491,1.2014627,40.1747429),(44046,'forelimb',254,2,279,62.7099034,63.0860961,115.131393,1.8,63.1119538,115.0936023,-1.2671502,5.7731772,7.3554439,493.4893225,718.1490607,9.5172534,97.6350406,85.4796771,163.5810301,11.171888,14.2316921,1.0666304,40.5307081),(44047,'forelimb',254,2,280,63.0982456,62.9801005,115.2419523,1.8,62.9890179,115.2731294,-1.2573902,5.7161451,7.3406232,493.7307263,716.4186979,9.5168007,97.5964405,86.3747715,164.8483654,11.3390965,14.2316921,1.0666304,40.5307081),(44048,'forelimb',254,2,281,62.9988242,62.9062779,115.4200951,1.8,62.9394892,115.4300446,-1.2439708,5.7394905,7.257461,491.1164242,698.700343,9.4176361,96.2733864,85.5679484,162.8903888,11.3390965,13.8836442,1.1902899,40.2790027),(44049,'forelimb',254,2,282,62.9494212,62.7899107,115.5631715,1.8,62.763425,115.5769649,-1.2309234,5.6761105,7.1578768,491.9133829,684.0068702,9.3256029,95.5600225,86.6638129,164.1285257,11.171888,13.8570216,1.0516502,39.5670723),(44050,'forelimb',254,2,283,62.7854346,62.7243344,115.7453191,1.8,62.7269679,115.7190509,-1.2239706,5.6809576,7.0910878,491.9930311,663.6172807,9.2551829,93.5846934,86.6038907,161.5509848,11.171888,13.8570216,1.0516502,39.5670723),(44051,'forelimb',254,2,284,62.8364042,62.6128611,115.8924135,1.8,62.6336366,115.9149486,-1.2224836,5.7362969,6.9743542,494.9955324,651.2651795,9.2527222,93.3799974,86.2918256,163.7987032,11.3390965,13.5879276,0.9652517,39.9230375),(44052,'forelimb',254,2,285,62.4014565,62.5200457,116.124366,1.8,62.4970328,116.1595466,-1.2078924,5.8008917,6.8133196,496.8083294,623.6614473,9.0896221,91.5356221,85.6434423,163.9771796,11.5308224,13.2717262,1.0636978,39.0636615),(44053,'forelimb',254,2,286,63.0724531,62.4154241,116.2891214,1.8,62.3618279,116.3262767,-1.2040652,5.6905644,6.6014801,502.5619422,614.3771516,9.1605435,93.0665766,88.3149552,168.954224,11.171888,13.1178053,1.0191413,38.6034365),(44054,'forelimb',254,2,287,63.2790169,62.3477352,116.4999521,1.8,62.3474775,116.4948663,-1.1797227,5.8529769,6.4840752,508.1633672,596.113817,9.0141054,91.9350554,86.8213522,166.854841,11.171888,12.8977995,1.047518,38.3517311),(44055,'forelimb',254,2,288,62.8759601,62.2276767,116.6308568,1.8,62.2338406,116.6990891,-1.1343405,5.9097368,6.3788816,513.6575597,584.5756056,8.6066621,91.6423353,86.9171635,170.1145568,11.5308224,12.9905136,0.9736197,38.9594017),(44056,'forelimb',254,2,289,62.8110033,62.1526432,116.8551337,1.8,62.1550459,116.9521077,-1.0555792,5.9984844,6.1886598,522.011222,565.8469466,7.9269919,91.4328729,87.0238533,171.6802635,11.5308224,12.8188253,0.8803499,38.6034365),(44057,'forelimb',254,2,290,63.7638152,62.0468602,117.0093803,1.8,62.0404645,117.0363729,-0.9749569,6.1059764,6.0849191,535.1059546,563.14197,7.2802372,92.5471577,87.636427,173.1854277,11.601576,12.7538463,1.0014831,38.3517311),(44058,'forelimb',254,2,291,64.3229138,61.9771866,117.2178777,1.8,61.9996073,117.2668861,-0.3866888,6.113914,6.2731316,544.7583078,558.0541559,1.5246928,88.9594218,89.1014017,174.2127799,11.601576,12.6375032,0.9544994,38.3517311),(44059,'forelimb',254,2,292,64.4327977,61.873587,117.3594613,1.8,61.8294488,117.3993885,0.1253691,6.1839988,5.8663203,543.9540669,567.3793032,0.1679035,96.7180919,87.9615419,173.5755617,11.601576,12.5274503,1.957672,38.3517311),(44060,'forelimb',254,2,293,65.8401953,61.8313966,117.5996585,1.8,61.7662285,117.651661,0.2966127,6.1391035,6.0169985,538.9232721,587.7803118,0.9374444,97.6866309,87.7853373,172.8816559,11.5378521,12.6375032,2.1870933,38.6034365),(44061,'forelimb',254,2,294,66.9788139,61.731363,117.7628889,1.8,61.7025579,117.786426,0.3149883,6.0574048,6.0953725,538.3775321,606.8209562,1.0714305,99.5543676,88.8792397,175.9088264,11.5481646,12.7538463,2.1401095,38.8551419),(44062,'forelimb',254,2,295,65.9135445,61.6638392,117.9279584,1.8,61.6501129,118.006405,0.322791,5.9568228,6.2556441,527.1774334,627.8994591,1.1054263,100.3732711,88.4997676,172.2795308,11.3901518,12.89064,2.2142974,39.2111071),(44063,'forelimb',254,2,296,66.7322466,61.5759973,118.0763324,1.8,61.5303685,118.1268704,0.3469564,5.968457,6.3290158,525.393869,652.9099511,1.2859891,103.1613713,88.0284248,175.9277613,11.3901518,12.9905136,2.167973,39.2111071),(44064,'forelimb',254,2,297,68.2307293,61.5263398,118.2955253,1.8,61.5134307,118.3660463,0.3845777,5.9141108,6.6656687,521.5012471,689.6876193,1.6005882,103.4686317,88.1791471,169.5860651,11.2348667,13.4924769,2.2206668,39.7145179),(44065,'forelimb',254,2,298,68.093878,61.4380762,118.4150093,1.8,61.4051249,118.4800787,0.4064223,5.7039198,6.9070135,519.1590149,722.9689234,1.7736454,104.6717115,91.0179377,173.394853,11.2494662,13.7029383,2.2896263,40.3221885),(44066,'forelimb',254,2,299,70.0294344,61.3441414,118.5957459,1.8,61.3331299,118.7061421,0.43153,5.6570617,7.3217084,516.91283,775.3424828,2.0418518,105.8963895,91.374791,168.3630438,11.2515658,14.3093201,2.2924512,41.1815645),(44067,'forelimb',254,2,300,73.0117412,61.2523935,118.7307184,1.8,61.2562088,118.8013478,0.4397775,5.6262644,7.5718762,519.7971671,823.5498534,2.2055996,108.7643048,92.3876187,169.1264997,11.1888905,14.6346459,2.4393357,41.7892351),(44068,'forelimb',254,2,301,76.2863256,61.3024679,118.954175,1.8,61.2782831,119.0488116,0.4476159,5.5928478,8.2009293,521.8715334,889.8662852,2.3817997,108.5079809,93.3105201,167.8828862,11.1840823,15.3007547,2.4756234,43.3605415),(44069,'forelimb',254,2,302,75.0203671,61.250321,119.1127723,1.8,61.2899361,119.3134287,0.4630105,5.5961031,9.1645991,521.1545433,954.7751967,2.4943087,104.1807924,93.1281165,155.2439166,11.1114494,16.5080739,2.4668517,44.7233283),(44070,'forelimb',254,2,303,72.947176,61.3275319,119.4043095,1.8,61.5695751,119.6505087,0.4850886,5.6339373,10.7347792,513.3846939,1137.1358418,2.6434031,105.9300635,91.1236084,151.8991078,11.1746796,18.2351811,2.5405189,48.3693519),(44071,'forelimb',254,2,304,74.9431574,61.287146,119.5586396,1.8,61.5260706,119.8323628,0.4804508,5.6620515,11.0723858,511.6349167,1257.5249925,2.6680939,113.5730834,90.3621099,158.5570146,11.0857418,18.7345939,2.5026787,49.8363985),(44072,'forelimb',254,2,305,79.0927286,61.1675674,119.6703732,1.8,61.5057232,119.9762034,0.468122,5.6524828,11.4943078,512.7048624,1365.5313383,2.6837673,118.8006589,90.7043646,162.5693898,11.1030351,19.1873855,2.5473789,50.1923637),(44073,'forelimb',254,2,306,79.7698797,60.9819249,119.7367063,1.8,61.40388,120.0910821,0.4565968,5.6645551,11.8069164,514.0541119,1435.0247812,2.5844027,121.5410304,90.7492479,163.6855328,10.9666414,19.5449008,2.5596875,50.8000343),(44074,'forelimb',254,2,307,77.6299414,61.0491857,119.8791098,1.8,61.417701,120.2019081,0.4469875,5.5322512,12.0567994,499.5691094,1492.3578842,2.4174081,123.7772838,90.3012346,164.1518474,10.8456386,20.1404075,2.5535901,52.1628211),(44075,'forelimb',254,2,308,78.7325288,60.9627457,119.9702216,1.8,61.3522849,120.3007042,0.4343086,5.5481993,12.0785064,496.3501284,1552.8780164,2.3233779,128.5654008,89.4614807,168.5209042,10.7289145,20.2683424,2.5829933,51.3034451),(44076,'forelimb',254,2,309,74.7198089,60.8614473,120.0862647,1.8,61.2856985,120.4388037,0.4181521,5.5538644,12.3178431,480.4464408,1626.247108,2.0534849,132.0236909,86.506692,169.7266101,10.7327222,20.6339739,2.5940304,52.8747515),(44077,'forelimb',254,2,310,74.721935,60.7665853,120.1700646,1.8,61.125811,120.515515,0.4069639,5.5702049,12.5311756,475.8260981,1688.9337877,1.9511877,134.778559,85.4234454,171.8212611,10.7131562,21.0020312,2.6046819,53.1264569),(44078,'forelimb',254,2,311,76.1828759,60.717394,120.2636183,1.8,61.1489462,120.6149478,0.3918801,5.5699313,12.5198036,472.0735395,1764.6337997,1.8521067,140.9474032,84.7539245,177.5652773,10.5640755,21.1596801,2.6325218,53.7341275),(44079,'forelimb',254,2,312,79.0066231,60.6012031,120.3392964,1.8,60.947638,120.6488925,0.3830262,5.4175862,12.58651,470.2553158,1857.1957923,1.8391881,147.5544684,86.8016309,183.8061911,10.370758,21.3723891,2.6149654,53.6298677),(44080,'forelimb',254,2,313,77.5268274,60.4687747,120.4119694,1.8,60.9337957,120.7752035,0.3674955,5.5432137,13.0619505,464.7487123,1929.8495978,1.6678817,147.7458977,83.8410239,182.40985,10.3815579,21.914088,2.6516353,54.6977633),(44081,'forelimb',254,2,314,79.6018647,60.3064112,120.4267889,1.8,60.7694453,120.7923564,0.3591758,5.4295867,13.1973853,465.5036873,2022.6843384,1.6391909,153.2640211,85.7346446,187.5596807,10.3815579,22.2941415,2.6607054,55.5571393),(44082,'forelimb',254,2,315,83.5027426,60.1934225,120.5154795,1.8,60.6410685,120.8438121,0.3417787,5.4810615,13.2486547,466.6305972,2135.9616893,1.5633732,161.2210254,85.1350778,195.2654503,10.275167,22.4961264,2.6437703,56.6682207),(44083,'forelimb',254,2,316,83.0608572,60.1198088,120.5817573,1.8,60.5243175,120.9102335,0.3315976,5.4884772,13.2811653,463.9098752,2226.7505001,1.4672064,167.6622839,84.5243324,201.3042581,10.2344954,22.8705449,2.6947502,56.6682207),(44084,'forelimb',254,2,317,81.7205983,59.9993281,120.6669148,1.8,60.5060413,120.9950229,0.3211081,5.4536871,13.4877134,458.7542786,2325.8965213,1.3567642,172.445577,84.1181881,204.3704506,10.156191,23.2587856,2.7027334,57.5275967),(44085,'forelimb',254,2,318,79.9435454,59.905908,120.7459177,1.8,60.373765,121.0409247,0.3149389,5.4501417,13.6822409,457.2397706,2451.0185235,1.2784336,179.1386757,83.8950248,212.0339469,10.055667,23.6484599,2.7104539,58.7429379),(44086,'forelimb',254,2,319,81.4802973,59.8075664,120.823456,1.8,60.2799639,121.1015083,0.3001562,5.3900186,13.8645935,458.194313,2636.2265461,1.1871735,190.1409185,85.0079274,221.9426058,10.055667,24.2193137,2.7017501,60.2099845),(44087,'forelimb',254,2,320,81.5827959,59.7057093,120.8722384,1.8,60.143697,121.1740357,0.2927299,5.5167325,13.9367324,461.4020641,2742.2948969,1.1322465,196.767421,83.636838,228.557692,10.0326817,24.4318345,2.725154,62.3889614),(44088,'forelimb',254,2,321,83.5679232,59.6027252,121.0037461,1.8,59.9421961,121.235389,0.2822366,5.4093155,13.9825296,468.4970075,2933.9658014,1.0803204,209.8308312,86.6092961,241.9681465,10.0972401,24.8254078,2.7321554,63.1440777),(44089,'forelimb',254,2,322,81.8265658,59.4663836,121.0603415,1.8,59.8381212,121.3040805,0.2734388,5.4356652,14.0848795,475.1662225,3129.9386578,0.9945173,222.2197684,87.4163884,254.4763986,10.0918294,25.2201601,2.738938,64.0034537),(44090,'forelimb',254,2,323,80.9141491,59.4003374,121.165123,1.8,59.7624393,121.3892157,0.2552522,5.4202454,14.3996162,483.6887399,3371.6748317,0.8597255,234.1503266,89.237424,266.9136333,10.0856501,25.8527955,2.767259,67.4409577),(44091,'forelimb',254,2,324,81.943723,59.3331124,121.2060824,1.8,59.629665,121.4399391,0.2454874,5.5031501,14.4431072,492.0250011,3596.7275683,0.8066427,249.0272708,89.4078828,282.0908375,10.0189499,26.1015566,2.7886023,68.9080042),(44092,'forelimb',254,2,325,82.9012905,59.2081842,121.3253435,1.8,59.5217859,121.5141667,0.2308446,5.339626,14.6163505,501.0718708,3859.0534603,0.7233046,264.0230508,93.8402562,296.2981183,9.877033,26.7685623,2.814766,72.0938028),(44093,'forelimb',254,2,326,82.7818394,59.0495309,121.5012549,1.8,59.294324,121.6126209,0.210444,5.1422313,14.696957,508.874707,4084.3907096,0.602055,277.9072368,98.9599031,310.222587,10.0110633,27.1758553,2.8198421,74.7761906),(44094,'forelimb',254,2,327,83.290472,58.9939634,121.6857733,1.8,59.2696351,121.7655572,0.1778044,4.9189449,14.9994721,498.5775368,4468.8683696,0.4342578,297.9350442,101.3586332,329.341405,9.8896432,26.9849538,2.9816795,64.4026047),(44095,'forelimb',254,2,328,82.6760398,58.6840829,121.7420387,1.8,58.916965,121.8241307,0.163298,4.9764834,15.2715149,489.9765248,4720.9165098,0.3641887,309.1321673,98.4583856,339.1306636,9.8979923,28.2746458,2.8486803,77.8145436),(44096,'forelimb',254,2,329,86.0354429,58.3834656,121.8336264,1.8,58.7660537,121.9432617,0.150974,5.076523,15.597498,484.2822337,5406.5250981,0.3243608,346.627715,95.3964417,374.0621201,10.0273722,28.8115336,2.8387078,76.8509078),(44097,'forelimb',254,2,330,87.6428024,58.2283,121.8780663,1.8,58.5247511,122.0081432,0.1455405,5.0939501,16.0330506,483.3224664,5927.4805367,0.3072304,369.7038496,94.8816655,398.5827722,10.1182316,29.4735901,3.0100045,77.8145436),(44098,'forelimb',254,2,331,88.8042482,58.2138552,121.9045591,1.8,58.3170506,122.0116996,0.1391027,5.0799303,16.0946937,474.7913922,6312.7049521,0.2845447,392.2227453,93.4641553,419.1680202,10.2036093,30.0228636,2.9835027,77.4585784),(44099,'forelimb',254,2,332,89.5479226,58.2328147,121.9600457,1.8,58.1613675,122.0402396,0.1316921,5.0987722,16.0549827,479.1798673,6594.1197999,0.2573427,410.7210786,93.9794622,437.6826062,10.3580525,30.751975,3.0155046,78.4222142),(44100,'forelimb',254,2,333,90.5976382,58.2727811,122.0065178,1.8,57.9443609,122.0631515,0.1215638,5.3023272,16.3124576,480.1853428,7009.5164788,0.2220413,429.7032771,90.5612438,458.169316,10.4881939,31.6047135,3.018924,79.6375554),(44101,'forelimb',254,2,334,90.653867,58.3544504,122.0510538,1.8,57.687852,122.0899519,0.1182174,5.3312234,16.2731374,474.7159929,7318.8132865,0.2101713,449.7481402,89.0444754,476.8737915,10.627756,32.0859282,3.0072712,80.4969314),(44102,'forelimb',254,2,335,91.6945748,58.3583651,122.0596961,1.8,57.5118643,122.0800563,0.1114853,5.6196015,16.2577576,467.0590844,7773.5912025,0.1891592,478.14658,83.112492,504.4062996,10.8716775,32.6364937,2.9829374,82.0682378),(44103,'forelimb',254,2,336,90.9336121,58.3066558,122.069488,1.8,57.3169388,122.062212,0.1031466,5.5941808,16.2941896,468.3031957,8023.3371796,0.1606726,492.4047998,83.71256,518.2295616,10.9228409,33.0608548,2.9849908,82.6759084),(44104,'forelimb',254,2,337,90.8792296,58.2054611,122.0351113,1.8,57.2360198,122.0643897,0.0926459,5.5253376,16.5347013,459.1674595,8201.9493364,0.1296353,496.0446016,83.102155,523.3857163,10.9490727,33.4218828,2.9996956,83.5352844),(44105,'forelimb',254,2,338,89.8916734,58.2817743,121.991115,1.8,57.355126,122.0410439,0.0905432,5.5874258,16.6531705,445.3709781,8202.4900384,0.1224877,492.5482538,79.7095109,518.1275208,10.9753045,33.7899824,3.0140831,84.6463658),(44106,'forelimb',254,2,339,88.0391453,58.6948341,121.887231,1.8,57.8234781,121.9715576,0.0940443,5.6964298,16.9667227,436.2173932,7772.6755755,0.1293923,458.112962,76.5773309,482.3796703,10.9228409,33.3638275,3.0124454,84.1861408),(44107,'forelimb',254,2,340,86.8504524,58.8752928,121.8050553,1.8,58.2527301,121.927485,0.0902938,5.7453693,16.9096331,453.0786005,7432.3998551,0.1176944,439.5364362,78.8597871,465.7692418,11.2992638,33.4853518,2.9869921,84.542106),(44108,'forelimb',254,2,341,88.605853,59.1182013,121.6344668,1.8,58.8285744,121.8347606,0.0659847,5.8371961,16.7151637,501.080961,7086.112997,0.0642047,423.9332106,85.8427488,452.065021,11.6242502,33.1305888,2.9721796,85.1497766),(44109,'forelimb',254,2,342,93.9151915,59.1696888,121.5780093,1.8,59.1090329,121.7614439,0.0523975,6.0258902,16.3124389,552.7123953,7204.7629244,0.0429347,441.6729455,91.7229454,472.9869566,12.0229179,32.5117967,3.0090411,84.6895516),(44110,'forelimb',254,2,343,106.5609576,59.3208642,121.3727708,1.8,59.5078922,121.5809266,0.0163723,6.5400913,16.3672286,689.1425097,7305.3378634,0.0047602,446.3393297,105.3720016,487.8730977,12.0796416,32.2981353,3.0750245,85.0455168),(44111,'forelimb',254,2,344,109.4520115,59.4033804,121.2435125,1.8,59.5050697,121.4973553,0.0051107,6.762243,16.0116367,739.6818165,7192.9218753,0.0004765,449.2308942,109.3840929,493.8549594,12.7078827,31.6047135,3.018924,82.823354),(44112,'forelimb',254,2,345,103.2270672,59.6327647,121.1594369,1.8,59.6925768,121.3973727,0.0041817,6.4287008,15.8079916,686.6334408,6570.1112182,0.0003009,415.6196051,106.8074968,458.496649,12.5375372,31.0834054,0.0969176,81.7122726),(44113,'forelimb',254,2,346,94.1909083,59.6632725,121.1325136,1.8,59.7349965,121.341165,0.0047471,6.4477327,15.4091269,612.603416,6129.3156057,0.0003538,397.7717651,95.010672,436.0148523,12.2171688,30.7008994,0.1122028,81.8165324),(44114,'forelimb',254,2,347,76.2542109,59.8042435,121.2103364,1.8,59.9518575,121.3173568,0.0066705,5.9289704,15.1137445,454.6456088,5279.0219165,0.0005655,349.2861684,76.6820505,378.7355758,11.65384,29.8996165,0.1297025,82.9886878),(44115,'forelimb',254,2,348,59.8262348,59.9109717,121.3859472,1.8,60.1525434,121.4837916,0.000725,5.7959136,14.7935713,322.1905809,4504.0631667,0.0000052,304.4608407,55.589266,325.9263393,9.7227296,11.6333612,0.073939,34.8710413),(44116,'forelimb',254,2,349,35.5323855,60.4218174,121.8413343,1.8,60.8718772,121.7885505,-0.0162153,5.0510188,14.4533513,148.5260566,2936.1069349,0.001557,203.1436772,29.4051683,213.3440643,8.5986163,9.2756891,1.8045395,28.5426299),(44117,'forelimb',254,2,350,21.8558706,61.147203,122.0638024,1.8,61.4539606,122.1008625,-0.0244092,4.4487608,14.348106,66.0045732,1888.7128759,0.0021699,131.6349959,14.8366199,135.6479724,6.6843766,7.6503773,2.2367656,24.6449009),(44118,'forelimb',254,2,351,9.0283261,64.293456,122.1374194,1.8,64.4363495,122.1510306,-0.033251,3.4777951,16.1987926,17.1449368,633.4941855,0.0016631,39.1074941,4.9298295,40.1341128,3.437504,4.4239087,2.6344941,11.8406326),(44119,'forelimb',254,2,352,3.6358473,69.2176091,122.0649551,1.8,69.2235325,122.0711779,-0.4658054,2.2585445,2.8636931,3.5620731,6.6716331,0.1222426,2.3297305,1.5771543,3.5732424,4.7123457,5.9848613,0.3671738,16.9537027),(44120,'forelimb',254,2,353,0.0657961,69.430054,122.1201796,1.8,69.4375808,122.1173296,-1.470096,0.2579438,0.5338843,0.0037302,0.0074963,0.0108552,0.014041,0.0144614,0.0204625,0.859376,1.5492621,0.9827937,3.2900584),(44121,'forelimb',254,2,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44122,'forelimb',254,2,355,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44123,'forelimb',254,2,356,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44124,'forelimb',254,2,357,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44125,'forelimb',254,2,358,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44126,'forelimb',254,2,359,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44127,'forelimb',254,2,360,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44128,'forelimb',254,2,361,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44129,'forelimb',254,2,362,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44130,'forelimb',254,2,363,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44131,'forelimb',254,2,364,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44132,'forelimb',254,2,365,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44133,'forelimb',254,2,366,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44134,'forelimb',254,2,367,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44135,'forelimb',254,2,368,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44136,'forelimb',254,2,369,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44137,'forelimb',254,2,370,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44138,'forelimb',254,2,371,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44139,'forelimb',254,2,372,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44140,'forelimb',254,2,373,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44141,'forelimb',254,2,374,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44142,'forelimb',254,2,375,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44143,'forelimb',254,2,376,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44144,'forelimb',254,2,377,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44145,'forelimb',254,2,378,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44146,'forelimb',254,2,379,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44147,'forelimb',254,2,380,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44148,'forelimb',254,2,381,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44149,'forelimb',254,2,382,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44150,'forelimb',254,2,383,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44151,'forelimb',254,2,384,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44152,'forelimb',254,2,385,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44153,'forelimb',254,2,386,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44154,'forelimb',254,2,387,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44155,'forelimb',254,2,388,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44156,'forelimb',254,2,389,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44157,'forelimb',254,2,390,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44158,'forelimb',254,2,391,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44159,'forelimb',254,2,392,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44160,'forelimb',254,2,393,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44161,'forelimb',254,2,394,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44162,'forelimb',254,2,395,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44163,'forelimb',254,2,396,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44164,'forelimb',254,2,397,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44165,'forelimb',254,2,398,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44166,'forelimb',254,2,399,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44167,'forelimb',254,2,400,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44168,'forelimb',254,2,401,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44169,'forelimb',254,2,402,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44170,'forelimb',254,2,403,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44171,'forelimb',254,2,404,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44172,'forelimb',254,2,405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44173,'forelimb',254,2,406,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44174,'forelimb',254,2,407,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44175,'forelimb',254,2,408,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44176,'forelimb',254,2,409,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44177,'forelimb',254,2,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44178,'forelimb',254,2,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44179,'forelimb',254,2,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44180,'forelimb',254,2,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44181,'forelimb',254,2,414,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44182,'forelimb',254,2,415,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44183,'forelimb',254,2,416,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44184,'forelimb',254,2,417,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44185,'forelimb',254,2,418,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44186,'forelimb',254,2,419,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44187,'forelimb',254,2,420,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44188,'forelimb',254,2,421,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44189,'forelimb',254,2,422,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44190,'forelimb',254,2,423,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44191,'forelimb',254,2,424,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44192,'forelimb',254,2,425,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44193,'forelimb',254,2,426,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44194,'forelimb',254,2,427,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44195,'forelimb',254,2,428,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44196,'forelimb',254,2,429,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44197,'forelimb',254,2,430,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44198,'forelimb',254,2,431,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44199,'forelimb',254,2,432,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44200,'forelimb',254,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44201,'forelimb',254,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44202,'forelimb',254,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44203,'forelimb',254,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44204,'forelimb',254,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44205,'forelimb',254,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44206,'forelimb',254,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44207,'forelimb',254,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44208,'forelimb',254,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44209,'forelimb',254,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44210,'forelimb',254,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44211,'forelimb',254,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44212,'forelimb',254,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44213,'forelimb',254,3,14,0.0501303,106.132936,127.6465893,1.8,106.132936,127.617336,1.4351421,0.0620666,0.454725,0.0008727,0.0062155,0.0082022,0.0136687,0.0140612,0.0154447,4.50972,44.8936575,3.0457335,96.1816285),(44214,'forelimb',254,3,15,0.9029053,106.7428011,127.731055,1.8,106.8719994,127.7204611,-1.0844052,1.1279804,1.3241095,0.2324298,0.3129903,0.1176036,0.2363779,0.2060583,0.4119022,4.5374385,47.0326836,3.0501056,100.7302139),(44215,'forelimb',254,3,16,1.6736591,107.2094399,127.7085481,1.8,107.3669118,127.7275124,-0.1761963,1.216565,1.9173989,0.5257988,1.1259359,0.0085706,0.5872205,0.4321995,0.8542874,4.5057211,48.6762735,3.0709141,104.0202723),(44216,'forelimb',254,3,17,2.6435914,107.6880519,127.5791506,1.8,107.9471742,127.5536785,-0.1607142,1.1988109,2.4136905,0.8198195,3.5628787,0.0112826,1.4761125,0.6838605,1.786247,4.7159964,50.067411,3.0470478,108.1697067),(44217,'forelimb',254,3,18,3.2419662,107.9987882,127.5081584,1.8,108.2681548,127.4652926,-0.1648266,1.2585353,2.9450375,1.0160852,5.7358664,0.0145471,1.9476378,0.8073553,2.2830339,4.6266693,51.3130956,3.057756,109.8884587),(44218,'forelimb',254,3,19,3.8047014,108.3368412,127.3489382,1.8,108.6762244,127.2573271,-0.1589885,1.2886868,3.4329477,1.1602771,8.4272671,0.0158942,2.4548196,0.9003562,2.7925284,4.7834223,52.1358708,3.0673492,111.9631759),(44219,'forelimb',254,3,20,4.1035811,108.5236756,127.2686059,1.8,108.7926503,127.1985262,-0.160052,1.3093267,3.3727063,1.282537,10.5738725,0.0173709,3.13513,0.9795393,3.4104106,4.7039999,52.5643848,3.0679555,112.3623269),(44220,'forelimb',254,3,21,4.244181,108.7532409,127.098859,1.8,109.0320358,127.042693,-0.1690071,1.216662,3.6211172,1.2798175,12.7349332,0.0200131,3.516852,1.0519089,3.7210913,4.7330784,52.5977428,3.0598083,113.3259627),(44221,'forelimb',254,3,22,3.9815004,108.8908418,126.9352381,1.8,109.2344019,126.8461011,-0.1724527,1.138179,3.8843413,1.034115,13.5964675,0.0195401,3.5003277,0.9085697,3.6868901,4.6731313,52.9632948,3.0766435,113.3259627),(44222,'forelimb',254,3,23,3.6874882,109.0801988,126.7325469,1.8,109.3951725,126.6674994,-0.1713118,1.1454711,4.0856719,0.8611396,13.8480239,0.0178608,3.3894117,0.7517777,3.564981,4.683643,52.9632948,3.0766435,113.6819279),(44223,'forelimb',254,3,24,3.5609875,109.1350338,126.5977359,1.8,109.355596,126.5100631,-0.1582536,1.1635275,4.0024126,0.8250353,14.0425657,0.01474,3.5085253,0.7090811,3.6855098,4.5433066,52.9371431,3.0847434,112.8225519),(44224,'forelimb',254,3,25,3.3869301,109.2580758,126.4067055,1.8,109.3904356,126.3747248,-0.1692506,1.0272712,3.9266337,0.7153446,14.2865798,0.0160164,3.6383785,0.6963542,3.7585282,4.5869862,52.5081549,3.0842784,112.8225519),(44225,'forelimb',254,3,26,3.0788748,109.3104018,126.2849518,1.8,109.4868896,126.2566573,-0.169277,0.9336023,3.8545627,0.6124917,13.4330935,0.0145641,3.4849851,0.656052,3.5998118,4.5571996,52.1057606,3.075573,111.8589161),(44226,'forelimb',254,3,27,2.8340418,109.4678235,126.0944859,1.8,109.5888552,126.0581824,-0.1789611,0.9840576,3.7479166,0.5374919,12.9487502,0.0149669,3.4549195,0.5461997,3.5129981,4.5122234,51.7073763,3.0667328,111.5029509),(44227,'forelimb',254,3,28,2.6869519,109.572641,125.9601406,1.8,109.6360868,125.9463271,-0.1775121,0.9391631,3.9668762,0.4980348,13.1909211,0.0139636,3.3252666,0.5302964,3.4453277,4.8738581,52.0791783,3.0838058,111.7114705),(44228,'forelimb',254,3,29,2.3483484,109.6480179,125.763135,1.8,109.6327136,125.7491273,-0.1799387,1.0333173,3.9348912,0.4179944,11.87896,0.0125363,3.0188789,0.4045169,3.104262,4.85137,51.6502135,3.0833254,111.7114705),(44229,'forelimb',254,3,30,2.2877556,109.7552615,125.6356641,1.8,109.7179448,125.6356406,-0.1827482,0.918559,3.8075355,0.3921468,12.1858543,0.0125929,3.2004572,0.4269152,3.2903686,4.8288818,51.626973,3.0916343,111.2080597),(44230,'forelimb',254,3,31,2.2184907,109.8876129,125.4643447,1.8,109.8205569,125.4753093,-0.1892864,0.8519002,3.9310178,0.3723976,12.2433687,0.0130904,3.1145544,0.4371376,3.1767533,5.0576849,51.2212608,3.0828368,110.8520945),(44231,'forelimb',254,3,32,2.1213072,109.8498534,125.3918887,1.8,109.7820774,125.4111767,-0.1842331,0.8405125,3.9042703,0.3465234,11.7027741,0.011865,2.9974293,0.4122763,3.0427494,5.0424994,51.1978256,3.0912151,110.9563543),(44232,'forelimb',254,3,33,2.2531231,110.1649995,125.1624988,1.8,109.9878512,125.161976,-0.1864289,0.9405829,4.1782746,0.3868495,13.7328982,0.012901,3.286739,0.411287,3.3640803,4.884539,51.1779874,3.0996005,111.2080597),(44233,'forelimb',254,3,34,2.3008476,110.2356184,125.0907196,1.8,110.0836784,125.1227584,-0.185929,0.8844116,4.2607459,0.4008519,14.6871302,0.0131045,3.4470796,0.4532414,3.5208942,4.884539,51.1978256,3.0912151,110.8520945),(44234,'forelimb',254,3,35,2.410228,110.4184152,124.9441817,1.8,110.3572713,124.9555025,-0.1886921,1.0285774,4.4690336,0.4281427,16.257013,0.0141336,3.6377021,0.4162475,3.7049741,4.8732911,51.1779874,3.0996005,110.8520945),(44235,'forelimb',254,3,36,2.479325,110.5504009,124.8516498,1.8,110.4074945,124.8829578,-0.1873495,0.9666374,4.6151942,0.4367407,17.5114285,0.0143351,3.7942994,0.4518144,3.853419,5.0660672,51.1617504,3.1079919,111.2080597),(44236,'forelimb',254,3,37,2.5476388,110.6947061,124.7097444,1.8,110.4408336,124.7417317,-0.1797443,0.8913492,4.7776346,0.4491747,19.626548,0.0135711,4.1080053,0.5039267,4.1475421,5.0623175,51.1617504,3.1079919,111.2080597),(44237,'forelimb',254,3,38,2.6204844,110.8192663,124.6200611,1.8,110.5277196,124.6530327,-0.1746773,1.0985799,4.8372119,0.4798156,20.9439615,0.0131911,4.329759,0.4367598,4.4103593,5.156256,51.1491181,3.1163879,111.9199901),(44238,'forelimb',254,3,39,2.7126325,110.9606336,124.487342,1.8,110.714549,124.5266886,-0.1818966,1.0444287,5.003339,0.5231408,22.8598575,0.0147943,4.5689204,0.5008871,4.6489492,5.156256,51.1491181,3.1163879,111.9199901),(44239,'forelimb',254,3,40,2.7209689,111.0716135,124.4081985,1.8,110.8236967,124.45606,-0.1833661,0.9822215,5.1276403,0.5194309,23.7756599,0.0150778,4.6367644,0.5288328,4.709573,5.5379242,51.1491181,3.1163879,112.5276607),(44240,'forelimb',254,3,41,2.7505099,111.1944633,124.2682676,1.8,111.0499339,124.287254,-0.194508,1.1734374,5.2811953,0.546911,25.6019945,0.0171259,4.8477651,0.466076,4.9174157,5.156256,51.1491181,3.1163879,112.1716955),(44241,'forelimb',254,3,42,2.8387975,111.2581292,124.1997163,1.8,111.0912458,124.2329395,-0.1996408,1.101441,5.2750963,0.5771751,27.4860278,0.0186082,5.2105263,0.5240181,5.3149984,5.156256,50.732307,3.1077073,111.5640249),(44242,'forelimb',254,3,43,2.9280362,111.3524621,124.1010359,1.8,111.1268654,124.1511861,-0.2106274,1.2286056,5.3901575,0.6099888,29.9393488,0.0213316,5.5544479,0.4964887,5.6617042,5.585944,51.1400931,3.1247875,112.2759553),(44243,'forelimb',254,3,44,2.9610461,111.4432899,124.0298666,1.8,111.2658394,124.0770805,-0.2227726,1.2236717,5.4970591,0.6497412,31.5775923,0.0240891,5.744452,0.5309767,5.8575148,5.585944,50.732307,0.0338853,111.9199901),(44244,'forelimb',254,3,45,3.0289123,111.4919201,123.940276,1.8,111.32119,124.0106995,-0.2396138,1.0866455,5.5686599,0.6621299,33.5718501,0.0284336,6.0287126,0.6093338,6.1431186,6.0041539,50.732307,0.0338853,112.7793661),(44245,'forelimb',254,3,46,3.0925823,111.6021743,123.862201,1.8,111.4113139,123.9310653,-0.2539623,1.2950268,5.6974778,0.6958863,35.6007032,0.0325351,6.2485023,0.5373528,6.3674272,6.015632,50.7486814,0.0423475,113.4912965),(44246,'forelimb',254,3,47,3.1965356,111.6204022,123.7723455,1.8,111.4752425,123.847599,-0.2723829,1.13934,5.7415757,0.7348192,38.1121469,0.0385586,6.6379247,0.6449517,6.7633554,6.4225765,50.3395584,0.0512372,113.9947073),(44247,'forelimb',254,3,48,3.2324548,111.6124304,123.7301303,1.8,111.5084206,123.7983743,-0.283666,1.1018548,5.7471517,0.724594,39.5191622,0.0422003,6.876304,0.657613,7.0004319,6.4150771,50.732307,0.0338853,113.8472617),(44248,'forelimb',254,3,49,3.3803281,111.6740393,123.6152166,1.8,111.6893916,123.6406157,-0.3059635,1.1513801,5.8421095,0.8123033,41.9406153,0.0511155,7.1790191,0.7055041,7.3170211,6.44532,50.3193819,0.0427091,114.7066377),(44249,'forelimb',254,3,50,3.4085264,111.6442513,123.5786976,1.8,111.6938496,123.5791031,-0.3161767,1.1953401,5.8258547,0.822453,42.8856442,0.0549231,7.3612622,0.6880493,7.5016767,6.44532,49.9344786,0.0602717,113.3870367),(44250,'forelimb',254,3,51,3.5365937,111.5885481,123.5269491,1.8,111.6938496,123.5248707,-0.3323067,1.1880163,5.7906589,0.8801505,45.4068802,0.0627288,7.8414013,0.7408572,7.993023,6.875008,49.8900891,0.0430768,114.559192),(44251,'forelimb',254,3,52,3.751438,111.5530569,123.4973784,1.8,111.71888,123.4676639,-0.3436327,1.2352204,6.0541725,0.9565461,49.0850167,0.0709698,8.1076343,0.7743931,8.2629947,7.304696,49.8900891,0.0430768,115.1668626),(44252,'forelimb',254,3,53,3.8818551,111.4966105,123.4577255,1.8,111.7028169,123.4409293,-0.3538033,1.1809611,6.2403884,0.973516,51.7443638,0.077663,8.2918499,0.8243421,8.4459695,7.304696,49.5055776,0.0607946,114.4549322),(44253,'forelimb',254,3,54,3.9765209,111.4798292,123.4048532,1.8,111.7944733,123.3124988,-0.3670464,1.2584802,6.3924738,1.0059989,54.7346164,0.0853498,8.5623528,0.7993761,8.7031411,7.734384,49.5055776,0.0607946,115.1668626),(44254,'forelimb',254,3,55,4.1582433,111.5002203,123.3192997,1.8,111.8378115,123.2322165,-0.3791861,1.1873728,6.5052395,1.0790722,58.4700623,0.0949617,8.988149,0.9087897,9.1094381,7.734384,49.104898,0.0700606,115.5228278),(44255,'forelimb',254,3,56,4.2533007,111.4104662,123.3111977,1.8,111.7641103,123.203611,-0.3851688,1.2100282,6.5891126,1.1090503,59.8500016,0.1000675,9.0831656,0.9165492,9.2177436,8.164072,49.0766903,0.0613265,116.1304984),(44256,'forelimb',254,3,57,4.4446464,111.4051966,123.2430547,1.8,111.8217113,123.1111208,-0.3957774,1.1682299,6.8041354,1.1798666,64.1369043,0.1101013,9.4261652,1.009961,9.5977444,8.164072,49.0522306,0.0525831,116.339018),(44257,'forelimb',254,3,58,4.573497,111.4643704,123.1804542,1.8,111.9025074,123.0303248,-0.4014816,1.2566913,6.8922506,1.2019411,67.7935393,0.1164039,9.8361976,0.9564331,10.0068057,8.164072,48.6762735,0.0706785,115.6270876),(44258,'forelimb',254,3,59,4.8038391,111.5174354,123.0782351,1.8,111.8644768,122.9546885,-0.4058087,1.3386322,6.9735231,1.2843526,71.8443872,0.1247693,10.302452,0.9594515,10.4617184,8.59376,48.2801842,0.0801848,115.7313474),(44259,'forelimb',254,3,60,5.0427974,111.5431137,123.0264078,1.8,111.903032,122.890768,-0.4072022,1.4780988,6.9300829,1.4017444,77.9575509,0.1318264,11.2491512,0.9483429,11.4289925,9.023448,48.2476678,0.0713075,117.198394),(44260,'forelimb',254,3,61,5.3254518,111.4976663,123.0005916,1.8,111.9963163,122.799417,-0.4048098,1.4238947,6.9606305,1.4537942,80.5825023,0.1376745,11.5768969,1.0209984,11.7654314,9.023448,47.8190816,0.0719477,116.0873126),(44261,'forelimb',254,3,62,5.6573974,111.6104944,122.9281416,1.8,112.148568,122.7079903,-0.404252,1.398748,7.0542146,1.5531407,87.2559996,0.1458754,12.3693429,1.1103792,12.5857266,9.023448,48.1940635,0.0535203,116.5907234),(44262,'forelimb',254,3,63,6.1310618,111.7154765,122.8300691,1.8,112.1453614,122.6598909,-0.4036446,1.4163967,6.9192531,1.6569415,96.2110128,0.1576401,13.9048264,1.1698287,14.1372949,9.453136,47.7649963,0.0540015,116.0873126),(44263,'forelimb',254,3,64,6.4486285,111.7234095,122.8187203,1.8,112.1517275,122.6569672,-0.4008442,1.4238263,6.9081033,1.7418476,100.593625,0.1636368,14.5616852,1.2233568,14.8072652,9.453136,47.3612865,0.0635507,116.2347582),(44264,'forelimb',254,3,65,6.9967611,111.7381626,122.7812157,1.8,112.1176552,122.6280092,-0.3970108,1.4151165,6.8807339,1.8824191,105.242607,0.1743459,15.2952589,1.330222,15.5617189,9.882824,46.9324739,0.0641321,115.2279366),(44265,'forelimb',254,3,66,7.3159503,111.7263656,122.7847171,1.8,112.0676123,122.6510146,-0.3936009,1.4316569,6.6616024,1.9691661,107.2954834,0.1793443,16.1065577,1.3754456,16.3761401,9.882824,46.5036774,0.0647243,115.2279366),(44266,'forelimb',254,3,67,7.9317812,111.6504145,122.7943089,1.8,112.0093733,122.6577682,-0.3836095,1.4643987,6.5707182,2.1237832,108.403053,0.1851781,16.4979003,1.4502766,16.8210055,10.312512,46.0488432,0.0560161,114.7245258),(44267,'forelimb',254,3,68,8.3864229,111.5923621,122.8214648,1.8,111.9307401,122.6729401,-0.3778545,1.4986905,6.3935924,2.2774434,109.040177,0.1902422,17.0546025,1.5196223,17.3285431,10.312512,45.248003,0.0760436,114.620266),(44268,'forelimb',254,3,69,8.9920151,111.4858933,122.8591639,1.8,111.7277092,122.7524438,-0.3671127,1.4907391,6.3452046,2.4877273,110.1194448,0.1930661,17.3547507,1.6687878,17.7285247,10.7422,45.1683644,0.0475831,113.0057738),(44269,'forelimb',254,3,70,9.4181229,111.3630589,122.9106629,1.8,111.5393528,122.8319066,-0.3633657,1.4817871,6.0755658,2.6669786,109.6685903,0.1982907,18.0507616,1.7998393,18.434821,10.7422,44.3328915,0.0581867,112.2938434),(44270,'forelimb',254,3,71,9.8431117,111.1332094,122.9909862,1.8,111.4098578,122.8789957,-0.3544701,1.5183917,5.9116161,2.8571804,103.7906809,0.1976397,17.5570739,1.881715,17.9263099,11.1077179,43.4749986,0.0593362,111.182762),(44271,'forelimb',254,3,72,10.1095409,110.9530313,123.0688955,1.8,111.1185358,123.003523,-0.3490761,1.4462835,5.7001126,2.9512592,98.2256946,0.1971098,17.2322377,2.0405814,17.5520728,11.1114676,43.0224775,0.0499584,109.6114556),(44272,'forelimb',254,3,73,10.4076373,110.688853,123.1560372,1.8,110.9239572,123.0779892,-0.3380586,1.485795,5.4205595,3.1522559,89.8786456,0.1907994,16.5810643,2.1215954,17.0394425,11.1152173,42.144486,3.100799,108.5003742),(44273,'forelimb',254,3,74,10.4523406,110.481348,123.2397045,1.8,110.7362846,123.1561635,-0.3306454,1.402333,5.3599991,3.1898772,81.1791566,0.1836127,15.1453676,2.2746931,15.7373002,11.5411392,41.7151591,3.1003789,106.7816222),(44274,'forelimb',254,3,75,10.4786367,110.1524342,123.3510177,1.8,110.4588926,123.2267646,-0.3206762,1.4401833,5.0279169,3.35361,70.3586771,0.1735198,13.9936037,2.3285994,14.5482485,11.5451409,40.8768588,3.0890096,105.566281),(44275,'forelimb',254,3,76,10.2958512,109.9282246,123.444677,1.8,110.1548157,123.3685811,-0.3115924,1.350792,4.7234206,3.3547238,61.5307305,0.1612812,13.0267313,2.4835236,13.6842807,11.5376419,40.0440631,3.0771658,103.4915638),(44276,'forelimb',254,3,77,10.1109397,109.5952345,123.5655334,1.8,109.8246721,123.4923312,-0.2964145,1.4056342,4.5338915,3.4528608,50.8742399,0.1437747,11.2208773,2.4564434,11.96844,11.9522662,39.2171226,3.0648208,102.4847422),(44277,'forelimb',254,3,78,9.95915,109.3611118,123.6531188,1.8,109.6742813,123.5388807,-0.2873218,1.5241481,4.3689812,3.6242688,44.3519544,0.1332982,10.1515553,2.377898,10.9353601,11.9597653,38.7887143,3.0639711,101.3736608),(44278,'forelimb',254,3,79,9.3951279,108.9914923,123.7936827,1.8,109.2590148,123.6791863,-0.265615,1.6216296,3.9235865,3.5833847,33.3645833,0.1078995,8.5035932,2.2097431,9.245507,11.9597653,37.5823509,3.038511,99.090424),(44279,'forelimb',254,3,80,8.9491582,108.7488718,123.8952556,1.8,108.9947415,123.8127199,-0.2515429,1.6239787,3.6496706,3.5324546,27.2127488,0.0924008,7.4562206,2.1751853,8.3324331,12.6950081,37.075377,3.0603763,98.0836024),(44280,'forelimb',254,3,81,7.9248435,108.3824184,124.0069848,1.8,108.64968,123.934296,-0.229474,1.5986359,3.4051617,3.195881,18.6000488,0.0683392,5.46231,1.9991301,6.3985958,12.713746,36.2571132,3.0466409,96.2605906),(44281,'forelimb',254,3,82,7.328259,108.1172573,124.0940689,1.8,108.3383226,124.0141692,-0.2249378,1.6155817,2.9415551,3.0531079,13.9030492,0.0607627,4.7264283,1.8897886,5.6621746,12.6987502,35.0689645,3.0187574,94.1858734),(44282,'forelimb',254,3,83,6.094695,107.7583726,124.2100273,1.8,107.9787788,124.179832,-0.2016484,1.6180781,2.7094215,2.5558501,8.2132442,0.040747,3.0313645,1.5795592,3.9727531,12.6878407,34.5918856,3.0295637,92.4671214),(44283,'forelimb',254,3,84,5.2731955,107.498008,124.2910904,1.8,107.6853572,124.2283452,-0.2008454,1.6445024,2.2244119,2.223466,5.3470813,0.0349783,2.4038179,1.35206,3.3081228,13.1322629,33.4853518,2.9869921,91.35604),(44284,'forelimb',254,3,85,3.846887,107.121049,124.3853613,1.8,107.299232,124.3113691,-0.1903676,1.6545637,1.7627921,1.5918604,2.311055,0.0229557,1.3110196,0.9621028,2.0394818,13.1322629,32.5713708,2.9959643,89.1338772),(44285,'forelimb',254,3,86,2.9555072,106.8937339,124.4854656,1.8,107.0968307,124.5166145,-0.2617226,1.3905022,1.5306476,1.0910332,1.2240237,0.032978,0.799677,0.7846325,1.4424893,13.0547035,31.8607205,2.965358,87.5625708),(44286,'forelimb',254,3,87,1.8039644,106.592742,124.5542948,1.8,106.7609415,124.5599406,1.4706577,1.2471181,1.3345438,0.379805,0.6330981,0.2976558,0.4743929,0.3045461,0.7129347,13.4838026,31.2345051,3.0035866,86.3040438),(44287,'forelimb',254,3,88,1.097552,106.417949,124.5989623,1.8,106.562624,124.60952,1.478298,0.9987836,1.2993665,0.137863,0.3382531,0.1813647,0.2603216,0.1380309,0.3578457,13.5062908,30.5169246,2.9718144,85.0887026),(44288,'forelimb',254,3,89,0.3306587,106.2254171,124.6097381,1.8,106.294069,124.60952,1.4842425,0.3731082,0.8643709,0.0158203,0.0749825,0.054698,0.0867481,0.0424013,0.1050284,13.5287789,29.5986112,2.9812172,82.6148344),(44289,'forelimb',254,3,90,0.0729575,106.132936,124.6039182,1.8,106.132936,124.60952,1.4330412,0.0597739,0.4311662,0.0012723,0.0089142,0.0119303,0.0206747,0.0212847,0.0234017,13.5287789,28.8243473,2.9617392,81.3994932),(44290,'forelimb',254,3,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44291,'forelimb',254,3,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44292,'forelimb',254,3,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44293,'forelimb',254,3,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44294,'forelimb',254,3,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44295,'forelimb',254,3,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44296,'forelimb',254,3,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44297,'forelimb',254,3,98,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44298,'forelimb',254,3,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44299,'forelimb',254,3,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44300,'forelimb',254,3,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44301,'forelimb',254,3,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44302,'forelimb',254,3,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44303,'forelimb',254,3,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44304,'forelimb',254,3,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44305,'forelimb',254,3,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44306,'forelimb',254,3,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44307,'forelimb',254,3,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44308,'forelimb',254,3,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44309,'forelimb',254,3,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44310,'forelimb',254,3,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44311,'forelimb',254,3,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44312,'forelimb',254,3,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44313,'forelimb',254,3,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44314,'forelimb',254,3,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44315,'forelimb',254,3,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44316,'forelimb',254,3,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44317,'forelimb',254,3,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44318,'forelimb',254,3,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44319,'forelimb',254,3,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44320,'forelimb',254,3,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44321,'forelimb',254,3,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44322,'forelimb',254,3,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44323,'forelimb',254,3,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44324,'forelimb',254,3,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44325,'forelimb',254,3,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44326,'forelimb',254,3,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44327,'forelimb',254,3,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44328,'forelimb',254,3,129,0.0113577,106.132936,110.429816,1.8,106.132936,110.429816,0.7853982,0,0,0.0001747,0.0001747,0.0009465,0,0,0,4.3017474,9.4628966,2.4526683,22.3184783),(44329,'forelimb',254,3,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44330,'forelimb',254,3,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44331,'forelimb',254,3,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44332,'forelimb',254,3,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44333,'forelimb',254,3,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44334,'forelimb',254,3,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44335,'forelimb',254,3,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44336,'forelimb',254,3,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44337,'forelimb',254,3,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44338,'forelimb',254,3,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44339,'forelimb',254,3,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44340,'forelimb',254,3,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44341,'forelimb',254,3,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44342,'forelimb',254,3,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44343,'forelimb',254,3,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44344,'forelimb',254,3,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44345,'forelimb',254,3,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44346,'forelimb',254,3,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44347,'forelimb',254,3,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44348,'forelimb',254,3,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44349,'forelimb',254,3,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44350,'forelimb',254,3,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44351,'forelimb',254,3,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44352,'forelimb',254,3,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44353,'forelimb',254,3,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44354,'forelimb',254,3,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44355,'forelimb',254,3,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44356,'forelimb',254,3,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44357,'forelimb',254,3,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44358,'forelimb',254,3,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44359,'forelimb',254,3,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44360,'forelimb',254,3,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44361,'forelimb',254,3,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44362,'forelimb',254,3,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44363,'forelimb',254,3,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44364,'forelimb',254,3,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44365,'forelimb',254,3,166,1.4613885,120.5586413,117.5771297,1.8,120.6173279,117.6095119,-0.4077188,1.1364587,2.8137744,0.3774594,3.0168944,0.0382945,1.0721878,0.3321365,1.1911542,2.7203468,6.1521959,0.4324078,14.271315),(44366,'forelimb',254,3,167,11.8411073,120.8098161,120.230877,1.8,120.559626,120.957172,-1.2545038,4.3197464,7.8577933,43.429067,160.5040842,1.7825818,20.4261016,10.0536148,24.6183922,5.771611,9.8172189,0.4048918,26.7196181),(44367,'forelimb',254,3,168,25.1375605,121.3591178,121.1448869,1.8,121.3626723,121.8265077,-1.2189058,5.7769285,7.0951421,142.6339574,281.3148456,3.6918715,39.6489377,24.6902758,56.6012136,10.7072166,13.0684503,1.4056476,47.4667901),(44368,'forelimb',254,3,169,40.3582126,121.9027434,122.1105729,1.8,121.989164,122.5003446,-1.4628331,5.7190886,6.4078116,280.3187131,382.9750707,6.6482699,59.7669057,49.014578,101.6632146,11.5308224,12.8188253,1.8076451,38.5602507),(44369,'forelimb',254,3,170,43.6569111,122.1359574,122.4072579,1.8,122.0796457,122.5346095,1.5487401,5.298635,6.0846248,292.9141433,383.2023578,7.2726127,62.9787985,55.2810571,110.5450296,10.7422,12.5789281,1.7078625,37.5966149),(44370,'forelimb',254,3,171,40.9206682,122.028226,122.4934309,1.8,121.9133098,122.4036789,-1.4922037,5.24093,6.0632981,263.6454205,333.7711522,6.7780715,55.047789,50.3050836,98.5274549,10.312512,12.2215837,1.7475052,36.6329791),(44371,'forelimb',254,3,172,38.0089691,122.0290853,122.4340653,1.8,121.8386268,122.2971871,-1.4829979,5.2070834,6.0411076,233.8591863,312.8175573,6.2861211,51.7814909,44.9117418,90.3554294,10.312512,12.1534119,1.7126934,36.3812737),(44372,'forelimb',254,3,173,34.3979072,121.8523525,122.2388242,1.8,121.6748232,122.0918733,-1.4940753,5.011408,5.8559244,203.6294341,280.9853192,5.6993057,47.9830848,40.6331778,82.1553691,9.882824,11.8845829,1.3521274,34.6625217),(44373,'forelimb',254,3,174,33.2078155,121.7342793,122.1161478,1.8,121.5477564,121.9736586,-1.4995718,4.914012,5.7386231,190.483176,263.7819593,5.5066065,45.9660712,38.7632708,78.4917362,9.8020172,11.7282,1.423718,34.4108163),(44374,'forelimb',254,3,175,32.0441318,121.5455257,121.9868085,1.8,121.3537691,121.8249442,-1.5263326,4.7210898,5.5765793,180.0288054,255.9988737,5.3301369,45.9060759,38.132892,76.8079636,9.453136,11.3765933,1.7607846,33.4471805),(44375,'forelimb',254,3,176,31.5787478,121.441724,121.8447226,1.8,121.2153883,121.6904658,-1.5276467,5.0021083,5.8119029,180.2039585,252.5328021,5.2533314,43.4509675,36.0256008,74.1597259,9.7842272,11.3033265,1.7234457,33.5514403),(44376,'forelimb',254,3,177,31.1267356,121.2736305,121.6681698,1.8,120.9936549,121.523671,1.5463989,5.2651666,5.6846533,184.2255828,251.7837114,5.1847019,44.2918326,34.9895069,74.9031673,9.882824,11.4655059,1.7975952,33.5514403),(44377,'forelimb',254,3,178,32.1351049,121.1016868,121.518253,1.8,120.8231409,121.3622219,1.3879283,5.2507176,5.710512,203.4637202,259.238237,5.1787348,45.3966714,38.7496976,80.5525083,9.882824,11.3765933,1.7607846,33.8031457),(44378,'forelimb',254,3,179,33.322567,120.8222879,121.3897198,1.8,120.5346935,121.1624033,1.1458442,5.2121962,5.81471,219.2588642,279.8015896,4.6097748,48.1196117,42.0665021,85.7836551,10.312512,11.417094,1.9163519,34.3065565),(44379,'forelimb',254,3,180,33.7919793,120.7421935,121.2920691,1.8,120.3795432,121.0664786,1.0136014,5.1318696,5.9312366,226.8460871,297.4280453,4.0570801,50.1460427,44.2034004,86.7922338,10.3304002,11.5697035,1.9513027,35.3744521),(44380,'forelimb',254,3,181,33.8057427,120.6110707,121.1311077,1.8,120.263316,120.9491094,0.9304414,5.1686566,5.9895009,232.5318547,311.9081974,3.6229476,52.0758242,44.988838,90.509305,10.2910899,11.6887773,1.8692953,35.6261575),(44381,'forelimb',254,3,182,33.9307888,120.5923854,121.085498,1.8,120.2608473,120.8823603,0.9254065,5.1700593,6.11234,235.6125536,316.7609105,3.6090248,51.8231824,45.5725046,89.1259729,10.2716688,11.9388329,2.0988708,35.6261575),(44382,'forelimb',254,3,183,34.8024186,120.5038042,121.0228481,1.8,120.1776234,120.7985028,0.9075223,5.1732099,6.2536865,241.5710212,323.431051,3.6015484,51.7184627,46.6965433,89.5678416,10.2381279,12.1077509,2.0503156,35.2701923),(44383,'forelimb',254,3,184,35.0846255,120.5073324,120.9566444,1.8,120.2176975,120.691431,0.8942022,5.1141758,6.1927099,243.8232992,324.428143,3.5549341,52.3887196,47.6759717,90.8379586,10.145294,11.9697226,1.9379702,35.6261575),(44384,'forelimb',254,3,185,34.840464,120.5239732,120.8985555,1.8,120.2407013,120.6198378,0.9336867,5.2440737,6.2750433,239.9224405,319.2050044,3.7518777,50.8689721,45.7511575,87.5845852,10.0607226,12.1306029,1.971037,35.6261575),(44385,'forelimb',254,3,186,35.6770138,120.5335546,120.8388894,1.8,120.2992123,120.6003775,0.9167079,5.0724637,6.2126912,243.9561962,324.85667,3.7449302,52.2892029,48.094222,89.7964453,9.9619298,12.1306029,1.971037,35.3744521),(44386,'forelimb',254,3,187,35.756853,120.5211119,120.8153988,1.8,120.2645765,120.5692993,0.8897711,4.9335824,6.1510602,242.1227032,321.7757465,3.5972381,52.3122413,49.0764482,89.3956073,9.9311441,12.1077509,2.0503156,35.3744521),(44387,'forelimb',254,3,188,36.0626704,120.5924439,120.7984673,1.8,120.3232377,120.540972,0.8937171,4.8470458,6.1880227,242.4528088,321.9991918,3.6511872,52.0358778,50.0207379,89.2467175,9.7227296,12.1077509,2.0503156,35.1227467),(44388,'forelimb',254,3,189,36.9271388,120.6069486,120.7116164,1.8,120.3341733,120.4310734,0.8706678,4.7540982,6.3242746,239.9650368,329.5796181,3.5995153,52.1134261,50.4754058,89.8312733,9.7227296,12.0389346,2.1785983,35.3744521),(44389,'forelimb',254,3,190,37.0149787,120.6886625,120.6677692,1.8,120.4087802,120.4097613,0.8842839,4.8918577,6.3476752,236.856871,332.9711036,3.6906549,52.4555987,48.4185941,89.6876232,9.7227296,12.1610055,2.1293956,34.6625217),(44390,'forelimb',254,3,191,36.9977464,120.7555648,120.6236062,1.8,120.4829311,120.3799644,0.8761815,4.810274,6.1342129,229.954744,334.2293207,3.6398716,54.4860974,47.8049158,90.3217466,9.7227296,11.9388329,2.0988708,34.7667815),(44391,'forelimb',254,3,192,37.2425234,120.8479737,120.6148381,1.8,120.6594235,120.4329526,0.86291,4.7777166,6.0773499,228.0493827,333.8356737,3.5827417,54.9311258,47.7318771,92.4546322,9.7227296,11.7988288,2.1486983,34.4108163),(44392,'forelimb',254,3,193,38.0654776,120.8825147,120.6017807,1.8,120.8114973,120.4708909,0.8287947,4.711202,5.7981128,222.7019226,333.0699167,3.447096,57.4445394,47.2707227,95.5512098,9.4188943,11.5697035,2.1175852,33.8031457),(44393,'forelimb',254,3,194,38.3717425,121.021498,120.6109,1.8,121.0270096,120.5461429,0.8545902,4.6789052,5.6241203,218.2252763,327.3609227,3.6387376,58.2066008,46.6402432,96.5683334,9.4188943,11.4413255,2.1692152,33.1954751),(44394,'forelimb',254,3,195,38.3805265,121.1422613,120.642884,1.8,121.2005886,120.6016629,0.8705251,4.6288611,5.4573485,210.4213779,311.9358088,3.7402863,57.1588586,45.458564,94.9283453,9.4188943,11.2048922,2.1375255,32.5878045),(44395,'forelimb',254,3,196,38.0443848,121.3110431,120.6844381,1.8,121.3613508,120.672036,0.8932118,4.5499316,5.5447256,205.612766,298.7744602,3.8486974,53.8844451,45.1902982,90.9424382,9.4166716,11.0889478,2.1910458,32.5878045),(44396,'forelimb',254,3,197,37.8302119,121.4438178,120.7131884,1.8,121.5020998,120.705266,0.9348819,4.5874718,5.3813297,199.0384153,283.1385749,4.08104,52.6149834,43.387387,89.5851402,9.4185655,10.8448348,2.1587989,31.9801339),(44397,'forelimb',254,3,198,37.5801198,121.5815203,120.7428148,1.8,121.6537874,120.7281234,0.9650973,4.5279028,5.2338531,194.8251318,273.270912,4.2331218,52.2121861,43.0276756,89.4360741,9.115059,10.7765202,1.9809237,31.1207579),(44398,'forelimb',254,3,199,37.1423187,121.7102373,120.8018828,1.8,121.7839593,120.7990565,1.0001919,4.4853424,5.1174405,188.6584522,259.9046849,4.384328,50.7880226,42.0611035,87.5573264,9.115059,10.6125107,1.943784,31.1207579),(44399,'forelimb',254,3,200,36.9732967,121.8372798,120.8503919,1.8,121.8881627,120.8084338,1.0241106,4.5627492,5.2256617,185.8755187,251.8048865,4.4968575,48.18622,40.7376147,83.7361712,9.023448,10.6125107,2.1251038,30.7647927),(44400,'forelimb',254,3,201,36.8630212,121.9425631,120.915812,1.8,121.9809129,120.8777597,1.0484322,4.5305494,5.1161924,182.024322,239.4417341,4.614442,46.800768,40.1770968,82.3704514,9.115059,10.3927662,2.0899424,30.8690525),(44401,'forelimb',254,3,202,37.0534157,122.0545818,120.9711743,1.8,122.0820162,120.9324773,1.0698452,4.4775572,5.0484132,181.2475557,233.3293537,4.7511763,46.2183547,40.4791158,81.3607444,9.2246579,10.3927662,2.0899424,31.1207579),(44402,'forelimb',254,3,203,37.1389058,122.1398958,121.0294776,1.8,122.1884417,120.9998895,1.1098971,4.4549989,5.1094836,177.5226433,224.3978892,4.9654356,43.9179197,39.8479661,78.6612221,9.023448,10.3838797,1.9974238,29.9054167),(44403,'forelimb',254,3,204,37.2919823,122.2352604,121.0680918,1.8,122.2625692,121.0011459,1.1292339,4.4117494,5.0008999,176.6054733,218.9356225,5.0802234,43.7792453,40.0307126,78.6061432,9.023448,10.2135672,1.959115,30.1571221),(44404,'forelimb',254,3,205,37.3027805,122.3309597,121.118149,1.8,122.3530298,121.0601966,1.1536953,4.3737823,4.9156705,172.4805978,211.4128068,5.1968025,43.0079284,39.4351129,77.7841048,9.023448,10.0587382,1.9195673,30.1571221),(44405,'forelimb',254,3,206,37.2727359,122.4244612,121.1526811,1.8,122.4486253,121.0561871,1.1644156,4.4824757,4.9887903,170.5240786,206.9340499,5.2414651,41.4798055,38.042388,75.5103315,9.023448,10.0587382,1.9195673,29.9054167),(44406,'forelimb',254,3,207,37.0921324,122.4823038,121.199478,1.8,122.5282584,121.1111752,1.1776437,4.4538131,4.8932999,166.7900119,198.5589551,5.2747023,40.5777208,37.4488127,74.0878569,8.59376,9.9201178,1.8788491,29.2977461),(44407,'forelimb',254,3,208,37.3564356,122.5560926,121.2450618,1.8,122.553066,121.1455543,1.1799784,4.4039259,4.8950553,166.577379,195.4604436,5.3225514,39.9301805,37.8247463,73.7023441,8.59376,9.9942879,2.0152155,29.2977461),(44408,'forelimb',254,3,209,37.4177557,122.6093756,121.2854185,1.8,122.6034465,121.214726,1.1848827,4.3713729,4.7886953,164.8617468,188.7125211,5.3527267,39.4079197,37.7139521,73.8273827,8.59376,9.8172189,1.9756881,28.6900755),(44409,'forelimb',254,3,210,37.5213733,122.7016959,121.3280616,1.8,122.7029403,121.2697893,1.1832628,4.3746439,4.8631712,164.2597764,185.9509572,5.3604726,38.2365639,37.5481478,71.9866075,9.023448,9.8172189,1.9756881,29.6537113),(44410,'forelimb',254,3,211,37.4845029,122.7467481,121.3837867,1.8,122.7409685,121.344154,1.1963751,4.3678351,4.7722218,161.2620234,180.128827,5.4117544,37.7452755,36.9203552,71.4843574,8.9692606,9.6942031,1.7942729,29.6537113),(44411,'forelimb',254,3,212,37.5845957,122.8177313,121.4309686,1.8,122.8562869,121.4292983,1.2001713,4.3226286,4.6869396,160.916911,177.3065047,5.4423279,37.8299106,37.2266332,71.7284777,8.59376,9.6942031,1.7942729,29.0460407),(44412,'forelimb',254,3,213,37.7287764,122.8620107,121.464085,1.8,122.8774237,121.4522473,1.2127165,4.4548231,4.6383444,160.3251815,172.5878051,5.5157347,37.2089245,35.989124,71.3143855,8.59376,9.6081158,1.7506498,29.0460407),(44413,'forelimb',254,3,214,37.864173,122.9369868,121.5097553,1.8,122.9325245,121.5410897,1.2533016,4.4119397,4.5457727,159.8294124,169.9356176,5.6956488,37.383219,36.226563,71.7225335,8.59376,9.5115493,1.8925469,28.6900755),(44414,'forelimb',254,3,215,37.7804733,122.9714933,121.5750407,1.8,122.9166857,121.6139808,1.2453269,4.3984668,4.6214228,156.7326632,164.7043064,5.6529515,35.6393068,35.6334764,69.3666594,8.59376,9.5115493,1.8925469,28.1866647),(44415,'forelimb',254,3,216,37.8423529,123.0432157,121.6290777,1.8,123.0160375,121.685217,1.2416392,4.3474716,4.558069,155.7694143,162.8219635,5.6480489,35.7216982,35.8298867,69.8942224,8.59376,9.5115493,1.8925469,28.6900755),(44416,'forelimb',254,3,217,37.665498,123.0520088,121.6770584,1.8,123.0187315,121.6959929,1.1711286,4.3406228,4.5919915,153.9901215,158.4087854,5.3271045,34.4967509,35.4765037,67.8170172,8.59376,9.5115493,1.8925469,28.4383701),(44417,'forelimb',254,3,218,37.5914775,123.1050096,121.7330787,1.8,123.0759069,121.782698,1.083207,4.3724865,4.4381957,153.2672706,155.5098018,4.8900881,35.0389692,35.0526569,67.7656275,8.59376,9.3845276,1.849096,28.1866647),(44418,'forelimb',254,3,219,37.4396878,123.1229861,121.803706,1.8,123.0860807,121.84724,0.796855,4.285259,4.2737792,151.1928474,152.14943,3.1914577,35.6006761,35.2820789,67.2194176,8.59376,9.2557628,1.9513027,27.8306995),(44419,'forelimb',254,3,220,37.3901169,123.1745545,121.8531377,1.8,123.1790748,121.8761499,0.5538965,4.3544988,4.1848784,150.1880953,151.5037332,1.7241913,36.202661,34.4903288,65.876544,8.59376,9.4237936,1.9936503,28.1866647),(44420,'forelimb',254,3,221,37.0340014,123.1733664,121.9146566,1.8,123.1832918,121.9194212,0.2234956,4.2331843,4.3593153,146.7384647,149.2179073,0.3032104,34.2296663,34.6638496,65.6864211,8.59376,9.2557628,1.9513027,28.1866647),(44421,'forelimb',254,3,222,36.9736324,123.2232704,121.967529,1.8,123.2691707,121.9690179,0.2654625,4.2229681,4.3696329,145.5526883,148.9671848,0.4241519,34.0914644,34.4669167,64.9726782,8.59376,9.2557628,1.9513027,27.8306995),(44422,'forelimb',254,3,223,36.7082102,123.2237878,122.03637,1.8,123.2808795,122.031392,0.2103136,4.2272497,4.3854038,142.65065,146.3997874,0.2666455,33.3834226,33.7454987,64.5524005,8.59376,9.2557628,0.3805064,27.8306995),(44423,'forelimb',254,3,224,36.6911458,123.262472,122.0845464,1.8,123.2978408,122.0511803,0.2427932,4.2363891,4.3176611,141.6506378,145.6297781,0.3534538,33.7288579,33.4366448,63.5452406,8.4577545,9.2557628,1.9513027,27.8306995),(44424,'forelimb',254,3,225,36.7169383,123.2653459,122.1433441,1.8,123.3106586,122.1335654,0.3047452,4.2103152,4.37573,140.0552457,143.7618195,0.5509381,32.8543623,33.2647885,63.1240707,8.59376,9.2557628,0.3805064,28.1866647),(44425,'forelimb',254,3,226,36.7614737,123.3107774,122.1919149,1.8,123.3518618,122.2112614,0.240666,4.2288291,4.3490125,139.2867191,142.3585648,0.3480729,32.7335376,32.9374198,62.9073066,8.4577545,9.2557628,0.3805064,27.6832539),(44426,'forelimb',254,3,227,36.6679829,123.3088546,122.2425238,1.8,123.3631402,122.2718465,0.2405016,4.170086,4.3388825,138.0092029,140.8216239,0.3467226,32.4557358,33.0950496,62.807066,8.4577545,9.2557628,0.3805064,27.5789941),(44427,'forelimb',254,3,228,36.756774,123.3528601,122.2854712,1.8,123.3757624,122.2923246,0.1620928,4.2007084,4.3062611,138.3626363,140.5510063,0.1595537,32.6387564,32.9379295,62.2869614,8.4577545,9.2557628,0.3805064,27.5789941),(44428,'forelimb',254,3,229,36.6121458,123.3466601,122.3233821,1.8,123.3615813,122.3135963,0.0405777,4.1895573,4.2901773,137.5169213,138.4660509,0.0100418,32.2751348,32.8237353,61.1881976,8.4577545,9.2557628,0.3805064,27.5789941),(44429,'forelimb',254,3,230,36.5158015,123.3886933,122.3635318,1.8,123.4329247,122.3875428,-0.6502933,4.3423036,4.1500073,136.2652618,137.9099184,2.2307088,33.2312468,31.3808694,62.1256522,8.2660287,9.1049255,1.9074711,27.5789941),(44430,'forelimb',254,3,231,36.388014,123.3749385,122.4048956,1.8,123.3754329,122.4509527,-0.892007,4.0172947,4.3074816,134.0902009,137.7458363,3.6739941,31.9782762,33.3782337,61.1081753,8.2660287,9.1049255,1.9074711,27.5789941),(44431,'forelimb',254,3,232,36.4154849,123.4074982,122.434467,1.8,123.4063936,122.4381633,-0.912675,4.0581583,4.2935795,133.3911183,138.5974469,3.798783,32.2801633,32.8698656,60.6235244,8.4566636,9.1049255,1.9074711,27.5789941),(44432,'forelimb',254,3,233,36.347395,123.3881522,122.4733016,1.8,123.387328,122.4852677,-0.9438216,4.0780722,4.3261133,131.0054938,138.9426089,3.9726853,32.1171911,32.1243684,61.2446632,8.4566636,9.1049255,0.3366748,27.5789941),(44433,'forelimb',254,3,234,36.3410727,123.4236894,122.5056517,1.8,123.4293103,122.4882936,-0.9450597,4.0313667,4.3205384,129.859064,139.6319148,3.979117,32.3181746,32.2121688,60.6021401,8.4016914,9.0642783,0.5485494,27.5789941),(44434,'forelimb',254,3,235,36.2043333,123.4100843,122.555207,1.8,123.4055285,122.5548039,-0.9075803,3.9769894,4.2770514,128.3117635,140.1011794,3.7469661,32.7564875,32.2635421,60.7048026,8.4016914,9.1049255,0.3366748,27.5789941),(44435,'forelimb',254,3,236,36.1484962,123.4530986,122.5916111,1.8,123.4718561,122.6268992,-0.9031568,4.1106497,4.2752477,127.3269801,141.4098531,3.7153004,33.0764119,30.9749038,62.0841735,8.4016914,9.1049255,0.3366748,27.5789941),(44436,'forelimb',254,3,237,36.0250167,123.4540617,122.618011,1.8,123.4923312,122.6673302,-0.9312906,4.0959854,4.2506615,125.6377135,142.5489439,3.865671,33.5357084,30.6733789,62.1591999,8.2649378,9.1049255,0.3366748,27.5789941),(44437,'forelimb',254,3,238,36.0829799,123.4822584,122.6505542,1.8,123.4968842,122.6901521,-0.9314357,4.0539445,4.3297667,125.0367364,144.5861941,3.8727262,33.3935299,30.8432288,62.0802443,8.2649378,9.1049255,0.3366748,27.5789941),(44438,'forelimb',254,3,239,36.0231704,123.455382,122.679388,1.8,123.4960428,122.7094711,-0.9149594,4.05649,4.2843272,123.6622135,145.7065624,3.7711231,34.0092053,30.4850287,62.2594479,8.2546826,9.1049255,0.3366748,27.5789941),(44439,'forelimb',254,3,240,36.0983099,123.480981,122.7115437,1.8,123.5146007,122.7237464,-0.8952101,4.0127756,4.266202,123.3679935,147.0908763,3.6635651,34.478179,30.7438056,63.0304264,8.2546826,9.1049255,0.3366748,27.5789941),(44440,'forelimb',254,3,241,36.1631548,123.4570309,122.7283776,1.8,123.4826561,122.742796,-0.8861344,4.0184032,4.2336655,122.5237887,148.6962658,3.6166536,35.1223465,30.4906658,61.3111123,8.2546826,9.2557628,0.3805064,27.5789941),(44441,'forelimb',254,3,242,36.2227965,123.4811978,122.7602804,1.8,123.5005563,122.7787371,-0.8861794,3.9795208,4.2242571,122.6556539,149.9597536,3.6228845,35.499675,30.8217142,61.508639,8.2257287,9.2557628,0.3805064,27.5789941),(44442,'forelimb',254,3,243,36.007113,123.4630682,122.7860898,1.8,123.4914689,122.8002317,-0.9192018,3.986242,4.208086,120.8513933,149.3545097,3.7940231,35.4922667,30.3171243,61.3416716,8.1803857,9.2257926,0.4844779,27.3272887),(44443,'forelimb',254,3,244,36.0427525,123.4946358,122.814815,1.8,123.5041946,122.8227702,-0.9475363,3.9480993,4.2307568,120.1146211,149.3848514,3.9605667,35.3092505,30.423404,60.9458273,8.1097181,9.2257926,0.4844779,27.3272887),(44444,'forelimb',254,3,245,36.0350875,123.4730741,122.8430731,1.8,123.4602867,122.8558103,-0.981757,3.95139,4.2963989,118.8832665,148.5891264,4.1521447,34.5845743,30.0864423,60.8094685,8.1097181,9.1352922,0.71883,27.2230289),(44445,'forelimb',254,3,246,36.1002122,123.501339,122.8700299,1.8,123.5004604,122.8573801,-1.0099462,4.0468241,4.3037455,118.2702937,149.1678881,4.314431,34.6600157,29.2254596,60.5419391,8.164072,9.2557628,1.1902899,27.2230289),(44446,'forelimb',254,3,247,35.9595563,123.4767574,122.9130172,1.8,123.4495091,122.9098327,-1.0428143,3.9055425,4.3277655,116.4124546,148.248963,4.4721368,34.2553132,29.8069867,59.271993,8.0333769,9.2557628,1.1902899,27.2230289),(44447,'forelimb',254,3,248,35.9262107,123.5024105,122.9452121,1.8,123.4656407,122.9582275,-1.0630874,4.0295314,4.2982101,115.8726957,147.6878305,4.5724033,34.3603097,28.7558734,59.7314987,8.164072,9.1957248,0.9179497,27.2230289),(44448,'forelimb',254,3,249,35.774421,123.4718515,122.9650945,1.8,123.4444896,122.9764103,-1.1030093,4.0580937,4.2326411,113.9747138,146.1528526,4.7501168,34.5299423,28.0857771,58.7438174,8.164072,9.1049255,1.2341215,26.9713235),(44449,'forelimb',254,3,250,35.6890428,123.5034782,122.9918606,1.8,123.4893678,123.0078209,-1.1273547,4.0218963,4.2627924,113.0616252,146.1505024,4.8532069,34.2851556,28.1115214,58.2541568,8.1097181,9.115059,1.4288993,27.5789941),(44450,'forelimb',254,3,251,35.4585888,123.4924686,123.0113264,1.8,123.5063072,123.0230941,-1.1609006,4.0259816,4.3254321,111.0857369,145.460502,4.9712164,33.6291262,27.5922118,57.3852402,7.734384,9.1856803,1.3825748,26.9713235),(44451,'forelimb',254,3,252,35.3576567,123.5239554,123.0387731,1.8,123.5419906,123.0885137,-1.1753396,3.9860298,4.3544952,110.3915411,145.1987807,5.0184187,33.3445722,27.6946104,56.8861574,7.734384,9.2756891,1.3370531,27.2230289),(44452,'forelimb',254,3,253,35.1184187,123.5045606,123.0483404,1.8,123.5182017,123.0766192,-1.194648,3.9990745,4.3910805,108.5934682,144.1139838,5.063261,32.8197092,27.1546498,56.0905822,7.734384,9.2756891,1.3370531,27.2230289),(44453,'forelimb',254,3,254,35.1222792,123.5277833,123.0770954,1.8,123.5583456,123.1628542,-1.1982275,3.9665976,4.3256016,108.2590566,144.6835301,5.0780804,33.4481868,27.2926744,56.3507365,7.734384,9.2257926,1.0863184,26.9713235),(44454,'forelimb',254,3,255,35.0211234,123.4967769,123.0964563,1.8,123.5247832,123.1672106,-1.1997303,3.988326,4.3549851,107.6874604,143.9981163,5.0693928,33.0651228,27.0006664,57.7901574,7.734384,9.2257926,1.0863184,26.6153583),(44455,'forelimb',254,3,256,34.9883372,123.509558,123.1252766,1.8,123.5450999,123.1832574,-1.2027306,3.9657978,4.3773749,108.1534923,143.7874263,5.0764332,32.8478663,27.2715596,57.5517001,7.734384,9.2257926,1.0863184,26.6153583),(44456,'forelimb',254,3,257,34.8875731,123.4628506,123.1476884,1.8,123.5187735,123.1972587,-1.2058471,4.0012197,4.415111,108.0108492,143.5861745,5.0739383,32.5215319,26.9944813,56.9854345,7.734384,9.2557628,1.1902899,26.6153583),(44457,'forelimb',254,3,258,34.9830221,123.478705,123.1698942,1.8,123.5285155,123.2058725,-1.1965889,3.9785089,4.4298015,108.4819834,144.5143462,5.0514565,32.6232107,27.2669953,57.1065453,7.734384,9.2557628,1.1902899,26.6153583),(44458,'forelimb',254,3,259,34.9617615,123.4382979,123.1979403,1.8,123.4851448,123.2470946,-1.1895454,4.0053696,4.3104351,108.7142369,144.6291635,5.0202473,33.5532636,27.1421234,58.4338394,8.0721211,9.1049255,1.2341215,26.9713235),(44459,'forelimb',254,3,260,34.99852,123.4506587,123.22096,1.8,123.4920328,123.2592851,-1.1849545,3.9848227,4.3249255,109.503178,145.3451338,5.0069394,33.6063905,27.4800626,58.5263219,8.0721211,9.1049255,1.2341215,26.9713235),(44460,'forelimb',254,3,261,35.0437827,123.4190689,123.2395376,1.8,123.4421765,123.2867262,-1.1693332,4.0042823,4.3459388,109.9587369,146.4371366,4.9487797,33.6951677,27.4602862,57.9514124,8.0721211,9.1957248,0.9179497,27.2230289),(44461,'forelimb',254,3,262,35.0949201,123.4359629,123.2571262,1.8,123.4455364,123.3013261,-1.1598155,3.9795731,4.3498662,110.800051,147.5008733,4.9155865,33.9092897,27.8421949,58.3424663,8.0721211,9.1957248,0.9179497,27.2230289),(44462,'forelimb',254,3,263,35.1503656,123.3748173,123.274875,1.8,123.3669088,123.2972296,-1.1518917,3.9830594,4.3859383,111.394315,148.8212905,4.8891009,33.9314599,27.967023,58.7796618,8.154294,9.2955727,0.9827937,27.2230289),(44463,'forelimb',254,3,264,35.3318083,123.386366,123.2975556,1.8,123.3918279,123.3248257,-1.1408985,4.0021948,4.3948667,112.7446183,150.4451688,4.8657564,34.2320206,28.170697,59.2028362,8.164072,9.2955727,0.9827937,27.2230289),(44464,'forelimb',254,3,265,35.4906476,123.3354308,123.2985306,1.8,123.3436042,123.3175625,-1.1302499,4.0212591,4.4100914,113.8388688,151.9996678,4.8394704,34.4663307,28.30926,59.5946579,8.164072,9.2955727,0.9827937,27.2230289),(44465,'forelimb',254,3,266,35.6151901,123.3467092,123.3205384,1.8,123.3436042,123.3175625,-1.1230174,4.0051015,4.4200812,114.9693322,153.4018309,4.823138,34.7056587,28.7057223,59.92193,8.164072,9.2955727,0.9827937,27.2230289),(44466,'forelimb',254,3,267,35.7806314,123.3000453,123.3427735,1.8,123.3364241,123.3306175,-1.104012,4.0447782,4.4464156,116.5234802,155.0363783,4.7557513,34.8677211,28.8083735,60.1683395,8.164072,9.2557628,1.1902899,27.2230289),(44467,'forelimb',254,3,268,35.9625776,123.3106332,123.3676033,1.8,123.3276414,123.372191,-1.0987868,4.0257932,4.4596096,117.8466058,157.1505663,4.7546653,35.2386372,29.2728914,60.6514488,8.164072,9.4237936,1.1479424,27.5789941),(44468,'forelimb',254,3,269,36.0310032,123.2782183,123.3890162,1.8,123.3262236,123.3853418,-1.09712,4.0453726,4.4920814,118.6891175,159.108894,4.7555955,35.4198602,29.339477,60.8681932,8.164072,9.4237936,1.1479424,27.5789941),(44469,'forelimb',254,3,270,36.2111032,123.2881027,123.4110395,1.8,123.3346841,123.4186297,-1.0900886,4.0281779,4.5012553,120.2046294,161.7663162,4.7447404,35.9380453,29.8409436,61.5369963,8.164072,9.4237936,0.7531513,27.8306995),(44470,'forelimb',254,3,271,36.3041464,123.2452804,123.4300985,1.8,123.2564296,123.4413947,-1.0947937,4.056426,4.5418012,121.0759731,164.6309652,4.7801999,36.2479459,29.8479431,61.9368848,8.2035531,9.5115493,1.2490458,28.1866647),(44471,'forelimb',254,3,272,36.4891139,123.2603444,123.445378,1.8,123.2697387,123.4500668,-1.0831076,4.0380482,4.5385045,122.5948385,167.555766,4.7461866,36.9187176,30.3599243,62.7617029,8.2035531,9.5115493,1.2490458,28.1866647),(44472,'forelimb',254,3,273,36.5828844,123.2093061,123.4352754,1.8,123.1753482,123.4514756,-1.0801494,4.0882479,4.5769575,123.3916387,170.744195,4.743421,37.305174,30.1820342,63.5478397,8.164072,9.6560368,1.0074801,27.8306995),(44473,'forelimb',254,3,274,36.7713207,123.226342,123.4500752,1.8,123.2231157,123.4664665,-1.0680352,4.0673619,4.5827952,125.2521626,173.5798862,4.7056484,37.8764223,30.7944472,64.4371732,8.2035531,9.6560368,1.0074801,28.1866647),(44474,'forelimb',254,3,275,36.7725516,123.1823049,123.4598957,1.8,123.1633209,123.4775911,-1.0675759,4.1012345,4.6126526,125.8756167,176.081124,4.7034278,38.1735063,30.6921284,64.7941896,8.2035531,9.6560368,1.0074801,28.1866647),(44475,'forelimb',254,3,276,36.8417046,123.1994571,123.4709098,1.8,123.2151131,123.4673816,-1.0540223,4.080986,4.6142917,127.0969862,178.0637549,4.6413604,38.5896181,31.1436958,65.4076914,8.2035531,9.6560368,1.0074801,28.1866647),(44476,'forelimb',254,3,277,36.7882733,123.1488754,123.4488882,1.8,123.1480246,123.4400455,-1.0471275,3.9783234,4.6203232,127.315778,179.4225554,4.5981622,38.8333345,32.0023704,65.8217505,8.2035531,9.6560368,1.0074801,28.1866647),(44477,'forelimb',254,3,278,36.7374156,123.1581344,123.4621126,1.8,123.1661021,123.4678571,-1.0444503,3.9650827,4.6271192,128.0646162,180.3771495,4.5775866,38.982603,32.2980949,66.0501715,8.2035531,9.6560368,1.0074801,28.1866647),(44478,'forelimb',254,3,279,36.6245664,123.1063649,123.4601926,1.8,123.0971867,123.467898,-1.047407,4.0093441,4.6513585,127.5874185,181.2127868,4.579178,38.95911,31.8225163,66.3863448,8.164072,9.807811,1.0679531,28.0824049),(44479,'forelimb',254,3,280,36.6566252,123.1113463,123.4714386,1.8,123.098726,123.4981155,-1.0514772,3.9973634,4.6584339,128.2101559,182.8496853,4.6046653,39.2513211,32.07368,66.7692318,8.164072,9.807811,1.0679531,28.0824049),(44480,'forelimb',254,3,281,36.4616429,123.0603661,123.4658768,1.8,123.0467694,123.4997207,-1.0454966,4.0472416,4.5978871,127.9508936,182.8657779,4.5487449,39.7716977,31.6143457,67.1864026,8.164072,9.798394,0.9097532,28.0824049),(44481,'forelimb',254,3,282,36.4398787,123.0639726,123.4706015,1.8,123.0544587,123.4868748,-1.0488556,4.0401717,4.6814489,128.5222658,183.9929614,4.5636972,39.3025678,31.8110899,66.7458982,8.164072,9.8921606,0.9707461,28.0824049),(44482,'forelimb',254,3,283,36.2723114,123.0086623,123.4780072,1.8,122.983526,123.4882389,-1.0534048,4.0823668,4.557587,128.9948364,183.2178214,4.5664193,40.2006195,31.5980517,67.6869289,8.164072,9.798394,0.9097532,28.3341103),(44483,'forelimb',254,3,284,36.2188241,123.0094092,123.485733,1.8,122.982453,123.4901417,-1.0524625,4.0783237,4.5609348,129.7203681,183.8538499,4.5547927,40.3105628,31.8072765,67.9003131,8.164072,9.798394,0.9097532,28.3341103),(44484,'forelimb',254,3,285,36.0544459,122.9524631,123.4732088,1.8,122.9460333,123.4544744,-1.0521293,3.9739695,4.5785285,129.8246956,183.9098873,4.5323972,40.1679025,32.6687702,67.552531,8.164072,9.798394,0.9097532,28.3341103),(44485,'forelimb',254,3,286,36.0001753,122.9523624,123.4765871,1.8,122.9392812,123.4646094,-1.0527273,3.9717739,4.6918043,130.2785751,184.6908066,4.5286632,39.3645591,32.8011058,67.1058772,8.164072,9.8921606,0.9707461,28.3341103),(44486,'forelimb',254,3,287,35.867688,122.8946066,123.4733292,1.8,122.8768171,123.4543847,-1.0485931,3.9714051,4.6652402,130.6964515,184.5171924,4.4906799,39.5514877,32.9093727,67.503457,8.164072,9.8172189,1.1659045,27.8306995),(44487,'forelimb',254,3,288,35.8272929,122.8927233,123.4778149,1.8,122.8795343,123.4552601,-1.0475236,3.9708106,4.6601955,131.3963171,185.2629595,4.4800972,39.7543321,33.0905523,67.8835294,8.164072,9.8172189,1.1659045,27.8306995),(44488,'forelimb',254,3,289,35.7329628,122.8208824,123.4645976,1.8,122.8154331,123.4627553,-1.0434503,4.0395422,4.6345862,131.6185741,185.1896051,4.4472518,39.9581743,32.5825474,68.2145755,8.2035531,9.8172189,1.1659045,28.1866647),(44489,'forelimb',254,3,290,35.748069,122.8137874,123.4719988,1.8,122.8089887,123.489559,-1.0377708,4.0416391,4.6894697,132.6201783,186.4249785,4.4196065,39.7539574,32.8134637,67.4168452,8.2035531,9.8921606,0.9707461,28.4383701),(44490,'forelimb',254,3,291,35.5833551,122.7394723,123.4581847,1.8,122.7342682,123.4563637,-1.0368195,4.1125751,4.6641403,132.9081844,185.8531074,4.3943019,39.8472378,32.3175096,67.8544198,8.4603756,9.8921606,0.9707461,28.6900755),(44491,'forelimb',254,3,292,35.5398268,122.7316669,123.4644157,1.8,122.7383866,123.4714646,-1.0334477,4.1157448,4.6566562,133.7498794,186.2288776,4.3713945,39.9919744,32.4971261,68.2544018,8.4603756,9.8921606,0.9707461,28.6900755),(44492,'forelimb',254,3,293,35.3887085,122.655808,123.4574715,1.8,122.6489821,123.444803,-1.0298088,4.0368402,4.6598187,133.8331216,185.8397979,4.3338945,39.8813364,33.1529405,68.6014347,8.4566636,9.8921606,0.9707461,28.6900755),(44493,'forelimb',254,3,294,35.3785817,122.6433972,123.4578546,1.8,122.6387395,123.4375184,-1.0265635,4.0486096,4.6664859,134.7272529,186.1067113,4.3157307,39.8815541,33.2774126,68.7519075,8.4566636,9.8921606,0.9707461,28.6900755),(44494,'forelimb',254,3,295,35.211406,122.558499,123.4663312,1.8,122.5392051,123.4515945,-1.0224216,4.0369643,4.7131235,134.5615132,185.4492376,4.273757,39.3474177,33.3323516,67.804483,8.5073884,9.8921606,0.9707461,28.6900755),(44495,'forelimb',254,3,296,35.1331333,122.5419699,123.4677066,1.8,122.528482,123.4552601,-1.022197,4.0502107,4.7032744,135.3313383,185.9343883,4.2630865,39.5329661,33.4134073,68.2012356,8.5073884,9.8921606,0.9707461,28.6900755),(44496,'forelimb',254,3,297,34.862396,122.468311,123.4469792,1.8,122.4496217,123.452227,-1.0271337,3.9815807,4.6841467,134.8053269,185.1024981,4.2556967,39.5168023,33.8572383,68.1445231,8.164072,9.8172189,1.1659045,27.8306995),(44497,'forelimb',254,3,298,34.8836566,122.446919,123.4505264,1.8,122.4239641,123.4503617,-1.0246983,4.0296737,4.6692307,135.6543368,186.2681315,4.24574,39.8926808,33.6638511,68.7632326,8.2035531,9.8172189,1.1659045,28.1866647),(44498,'forelimb',254,3,299,34.9564463,122.354827,123.4332225,1.8,122.3219823,123.4141059,-1.021452,4.085236,4.7170135,137.0387356,187.66356,4.2377827,39.784402,33.5448761,68.4307849,8.5073884,9.8921606,0.9707461,28.6900755),(44499,'forelimb',254,3,300,35.0331524,122.3321987,123.43135,1.8,122.3146269,123.4157887,-1.0240129,4.1058176,4.7055149,137.6145867,188.763798,4.2603818,40.1154393,33.516975,68.9630372,8.5073884,9.8921606,0.9707461,28.6900755),(44500,'forelimb',254,3,301,34.921702,122.2456811,123.4100222,1.8,122.2351473,123.4091658,-1.0213236,4.0483783,4.6798646,137.5120111,189.0039184,4.2329054,40.3866212,33.9671845,69.5060159,8.5073884,9.8921606,0.9707461,28.6900755),(44501,'forelimb',254,3,302,34.8980355,122.2222763,123.4100327,1.8,122.2268307,123.4036214,-1.0192767,4.0691974,4.6684185,138.1064091,189.9764987,4.2194211,40.6939738,33.9394718,70.0465906,8.5073884,9.8921606,0.9707461,28.6900755),(44502,'forelimb',254,3,303,34.7717026,122.1183509,123.3886086,1.8,122.1374189,123.3916056,-1.0288213,4.0899209,4.7757987,137.3838972,190.050415,4.2532772,39.7944775,33.5908448,68.4548623,8.2035531,10.0219602,1.0303768,28.4383701),(44503,'forelimb',254,3,304,34.7367904,122.0813304,123.3847557,1.8,122.0649832,123.3498483,-1.037388,4.0611052,4.7623981,138.0175658,190.6814403,4.2926399,40.0389545,33.9852228,68.9176672,8.5073884,10.0219602,1.0303768,28.6900755),(44504,'forelimb',254,3,305,34.5984285,122.0002093,123.3685512,1.8,121.9769835,123.3623087,-1.0424472,4.0544993,4.798872,138.6426956,190.019574,4.3010161,39.5967165,34.1947759,67.8761023,8.5073884,10.1410009,0.9357696,28.9417809),(44505,'forelimb',254,3,306,34.6421247,121.9664183,123.3633052,1.8,121.9160764,123.3753682,-1.0375628,4.0865366,4.7893086,139.8954337,191.3784664,4.2818253,39.9595185,34.2332514,68.649999,8.5073884,10.1410009,0.9357696,28.9417809),(44506,'forelimb',254,3,307,34.5438223,121.85938,123.3590796,1.8,121.8442698,123.3828301,-1.0401309,4.0764044,4.7372485,140.3876266,191.1645351,4.2826011,40.3534951,34.4390823,69.5891628,8.5073884,10.0219602,1.0303768,28.6900755),(44507,'forelimb',254,3,308,34.6106254,121.8255063,123.3536149,1.8,121.8345672,123.3731274,-1.0484738,4.0548664,4.7206811,141.2994239,191.9751791,4.3326991,40.6668396,34.846875,70.1815488,8.5073884,10.0219602,1.0303768,28.6900755),(44508,'forelimb',254,3,309,34.5373881,121.7028674,123.3285402,1.8,121.6682363,123.3176838,-1.0592058,4.0953128,4.8410147,140.8706227,192.1433034,4.3766142,39.6907086,34.3980133,68.7621499,8.5073884,10.1864154,1.088283,28.6900755),(44509,'forelimb',254,3,310,34.5531657,121.672896,123.3244483,1.8,121.6602978,123.335802,-1.0633632,4.0704686,4.830559,141.8332391,192.756861,4.3990023,39.9036344,34.8444497,69.2336287,8.5073884,10.0219602,1.0303768,28.6900755),(44510,'forelimb',254,3,311,34.6036318,121.554128,123.3177722,1.8,121.5179985,123.3553333,-1.0620358,4.0914928,4.8216703,142.8723121,193.2100596,4.3989195,40.0711883,34.9193609,68.9786822,8.5073884,10.1410009,0.9357696,28.9417809),(44511,'forelimb',254,3,312,34.6638329,121.5162368,123.3084537,1.8,121.464037,123.3218466,-1.0709662,4.1370886,4.8052421,144.3009718,194.0040311,4.4502244,40.3734144,34.8798362,69.6562943,8.5073884,10.1410009,0.9357696,28.9417809),(44512,'forelimb',254,3,313,34.545221,121.4078805,123.2743445,1.8,121.3806426,123.2872968,-1.0722861,4.0595127,4.7824575,145.1129767,193.8665104,4.4413845,40.5370066,35.7464027,70.3275457,8.59376,10.1410009,0.9357696,29.1934863),(44513,'forelimb',254,3,314,34.5851126,121.368509,123.275106,1.8,121.3516283,123.2928233,-1.0810745,4.1710733,4.7578039,146.0912476,194.7557452,4.4888146,40.9339584,35.0248571,71.0614607,8.59376,10.1410009,0.9357696,29.1934863),(44514,'forelimb',254,3,315,34.4982238,121.2745075,123.2503757,1.8,121.2811875,123.2672699,-1.1001755,4.0975626,4.7247387,146.1509312,193.9795745,4.5675215,41.0561485,35.6677725,71.4083614,8.5073884,10.0219602,1.0303768,28.6900755),(44515,'forelimb',254,3,316,34.5618938,121.2306104,123.2440276,1.8,121.2151239,123.2759576,-1.0979038,4.0561428,4.898581,147.561155,195.1000752,4.5653565,39.827876,36.3796747,69.9500539,8.5073884,10.1864154,1.088283,29.0460407),(44516,'forelimb',254,3,317,34.472711,121.1106869,123.2078059,1.8,121.0435241,123.2472294,-1.102643,4.1254289,4.8768643,148.6956621,195.3069833,4.5755819,40.0476557,36.0436854,70.513686,8.59376,10.1864154,1.088283,28.9417809),(44517,'forelimb',254,3,318,34.5949597,121.0690092,123.2027524,1.8,121.0425587,123.2295605,-1.1046492,4.0845607,4.8628921,150.2775744,197.31297,4.6011102,40.5752309,36.7916128,71.4409643,8.59376,10.1864154,1.088283,29.2977461),(44518,'forelimb',254,3,319,34.422301,120.9432766,123.1696695,1.8,120.9328369,123.1633209,-1.1080389,4.1484203,4.8368703,150.8376226,197.0802092,4.5937232,40.7453987,36.3602553,71.2154083,8.5073884,10.2496576,0.9944211,29.2977461),(44519,'forelimb',254,3,320,34.4339943,120.8986263,123.163042,1.8,120.8695923,123.1452966,-1.1159791,4.3003605,4.8251825,152.5958379,198.6569454,4.6314707,41.170867,35.4844291,72.190325,8.59376,10.2496576,0.9944211,29.5494515),(44520,'forelimb',254,3,321,34.4161466,120.7691948,123.1408897,1.8,120.745022,123.1345722,-1.1231127,4.1919262,4.7909435,154.3623846,198.8051665,4.6611859,41.4960369,36.823736,73.382148,8.8112237,10.1410009,0.9357696,29.9054167),(44521,'forelimb',254,3,322,34.4199511,120.7255121,123.1351006,1.8,120.7193573,123.1218266,-1.1254183,4.3204587,4.7781763,156.206406,200.0496388,4.6720046,41.8673621,36.1550511,74.3054889,8.8112237,10.1410009,0.9357696,29.9054167),(44522,'forelimb',254,3,323,34.3986345,120.6186334,123.1212128,1.8,120.5918694,123.1306884,-1.1400148,4.2470104,4.9308512,157.3425798,201.0329627,4.7334017,40.7704377,37.0478445,72.6781308,8.59376,10.2135672,1.1824776,29.5494515),(44523,'forelimb',254,3,324,34.5527181,120.5647301,123.1131524,1.8,120.5207701,123.0962126,-1.1365453,4.3728659,4.9153242,159.815156,202.8542049,4.7393969,41.2697509,36.5470057,73.7658877,8.59376,10.2135672,1.1824776,29.5494515),(44524,'forelimb',254,3,325,34.4147479,120.4397101,123.0750708,1.8,120.4102348,123.0303827,-1.1429434,4.2799255,4.8986848,160.718331,202.9171076,4.7483339,41.422773,37.5516657,74.1661786,8.8112237,10.2135672,1.1824776,29.6537113),(44525,'forelimb',254,3,326,34.5450531,120.3852176,123.0661985,1.8,120.343332,123.0509002,-1.1463162,4.4078633,4.8849914,163.2623363,204.2833,4.7809315,41.8185586,37.0388841,75.0052745,8.8112237,10.2496576,0.9944211,29.9054167),(44526,'forelimb',254,3,327,34.3644497,120.2512289,123.0338143,1.8,120.2214139,123.0110806,-1.1550884,4.4530769,4.8624429,164.3254622,204.4073104,4.7933548,42.0379867,36.9015549,75.6536882,9.023448,10.2496576,0.9944211,30.1571221),(44527,'forelimb',254,3,328,34.2854497,120.2073626,123.0159396,1.8,120.1818654,123.0015261,-1.1649656,4.4094536,4.8646178,165.4661675,204.5506374,4.8236601,42.0486551,37.5253223,75.8840828,9.023448,10.2496576,0.9944211,30.1571221),(44528,'forelimb',254,3,329,34.194029,120.0817661,122.9906876,1.8,119.9853854,122.9865498,-1.1733045,4.4530196,5.0082341,166.1785116,204.6585516,4.8449988,40.864414,37.3181628,74.044696,9.023448,10.3838797,1.1441688,29.9054167),(44529,'forelimb',254,3,330,34.345483,120.0248887,122.9837975,1.8,119.9492619,122.9703399,-1.1908957,4.4755145,4.9931699,168.2094095,206.9854454,4.9370857,41.4537154,37.5843736,75.1414714,9.023448,10.3838797,1.1441688,29.9054167),(44530,'forelimb',254,3,331,34.1854688,119.9053488,122.9670704,1.8,119.8659217,122.9732995,-1.2033527,4.5214413,4.9653289,169.4239097,206.321194,4.9623238,41.5523722,37.4712171,75.6705693,9.023448,10.3927662,1.0516502,30.1571221),(44531,'forelimb',254,3,332,34.1630332,119.8483383,122.9610517,1.8,119.8294043,122.9560701,-1.2116234,4.4680927,4.9511315,171.0244555,207.3702148,4.9903522,41.8833987,38.2768365,76.4202839,9.023448,10.3927662,1.0516502,30.4088275),(44532,'forelimb',254,3,333,33.9314042,119.706988,122.9260445,1.8,119.6327373,122.9182785,-1.2159903,4.4736046,4.9350668,170.8947493,206.3609036,4.9726887,41.8152198,38.2006826,76.3913191,9.023448,10.2496576,0.9944211,30.4088275),(44533,'forelimb',254,3,334,33.8662796,119.6474565,122.9106493,1.8,119.5828315,122.8828353,-1.2243151,4.5227709,4.9306841,172.6810264,206.6015418,4.9934614,41.9011921,38.1803613,76.8576496,9.023448,10.2496576,0.9944211,30.1571221),(44534,'forelimb',254,3,335,33.9643582,119.511211,122.9027797,1.8,119.4468122,122.9010908,-1.2363331,4.5406054,5.0365301,174.5910952,207.319798,5.0507486,41.1632206,38.4510609,75.8026829,9.023448,10.3927662,1.0516502,30.4088275),(44535,'forelimb',254,3,336,33.9336982,119.4515169,122.8855212,1.8,119.4128994,122.8985805,-1.264006,4.482297,5.0294122,175.497369,208.0457628,5.1398002,41.3658208,39.1534448,76.1950084,9.023448,10.3838797,1.1441688,30.1571221),(44536,'forelimb',254,3,337,33.8315352,119.2912938,122.8387927,1.8,119.2257073,122.8183058,-1.2872054,4.6081882,5.0232685,176.8099627,207.85677,5.1971396,41.3787892,38.3686503,76.539348,9.2257488,10.3927662,1.0516502,31.3724633),(44537,'forelimb',254,3,338,33.7029644,119.2331412,122.8187388,1.8,119.1490601,122.7766915,-1.2964424,4.6676313,5.025148,177.2253781,208.4040219,5.2048589,41.4722157,37.9690181,76.7090637,9.023448,10.3927662,1.0516502,30.7647927),(44538,'forelimb',254,3,339,33.5816669,119.0999094,122.8016238,1.8,119.0474476,122.7337183,-1.317179,4.6421997,5.0042511,176.8728708,208.4985271,5.244592,41.6642814,38.1010907,76.9890321,9.023448,10.3927662,1.0516502,30.7647927),(44539,'forelimb',254,3,340,33.5722675,119.0343001,122.7860283,1.8,119.0049479,122.7231152,-1.3085721,4.5787514,5.0030965,176.9546113,209.1628862,5.2193693,41.8066862,38.6469138,77.175691,9.023448,10.3927662,1.0516502,30.7647927),(44540,'forelimb',254,3,341,33.4326187,118.8765276,122.7410382,1.8,118.8118822,122.6778141,-1.309152,4.7183708,5.005742,177.677826,209.7053009,5.1992748,41.8929507,37.6566053,77.3491355,9.4166716,10.3927662,1.0516502,31.3724633),(44541,'forelimb',254,3,342,33.1191363,118.8238427,122.7064742,1.8,118.7532252,122.6896374,-1.3101932,4.6586438,5.1364407,177.0669951,210.6734253,5.1533906,41.0154494,38.0082706,75.4296257,9.023448,10.6125107,1.1978086,30.7647927),(44542,'forelimb',254,3,343,32.7887573,118.6845324,122.6830063,1.8,118.6196951,122.6778595,-1.3308059,4.6209314,5.1208605,177.0155868,210.1883336,5.1560423,41.0455104,38.3073392,75.5727326,9.023448,10.6125107,1.1978086,31.0164981),(44543,'forelimb',254,3,344,32.7262063,118.6104745,122.6586224,1.8,118.5450013,122.6514807,-1.3143743,4.7471494,5.1277223,178.5232314,210.6960398,5.1035226,41.0895966,37.6064065,75.9048638,9.4174746,10.6125107,1.1978086,31.3724633),(44544,'forelimb',254,3,345,32.735382,118.4431657,122.6093377,1.8,118.3476191,122.6098675,-1.3329282,4.6844314,5.1352146,179.1069503,211.8249121,5.1529741,41.249476,38.2345121,76.119808,9.4174746,10.6125107,1.1978086,31.1207579),(44545,'forelimb',254,3,346,32.8337404,118.362141,122.5673087,1.8,118.2975068,122.5840329,-1.329329,4.6980709,5.1563503,180.5081902,213.240594,5.1593734,41.3549469,38.4217679,76.3149339,9.023448,10.6125107,1.1978086,31.0164981),(44546,'forelimb',254,3,347,32.8289847,118.2073624,122.5035182,1.8,118.168048,122.4918636,-1.3241804,4.7406751,5.1794257,180.8824318,213.8184114,5.145416,41.2822627,38.1554161,76.0084958,9.4185655,10.6125107,1.1978086,31.7284285),(44547,'forelimb',254,3,348,33.0169175,118.1311451,122.4663939,1.8,118.0521075,122.4498707,-1.3285272,4.7638886,5.198754,182.8510833,216.2057376,5.1861052,41.5879918,38.3827374,76.4945477,9.4188943,10.6298941,1.3258177,31.4767231),(44548,'forelimb',254,3,349,33.0281632,117.9827884,122.4025852,1.8,117.9179605,122.3625842,-1.3456023,4.7051754,5.007525,183.6495209,216.9412977,5.2302249,43.3230582,39.031387,79.2062557,9.453136,10.5689273,1.1071487,31.3724633),(44549,'forelimb',254,3,350,32.9018303,117.9171185,122.3732613,1.8,117.869486,122.3310591,-1.3529826,4.63323,5.0186548,183.2174707,218.5901777,5.2275675,43.5555314,39.5442213,79.2626313,9.023448,10.6125107,1.1978086,31.0164981),(44550,'forelimb',254,3,351,32.8537142,117.763918,122.2920932,1.8,117.721046,122.306833,-1.3189599,4.7779869,5.1767427,185.1836093,219.1742945,5.1356264,42.3382632,38.7576639,77.786291,9.4188943,10.7765202,1.160669,31.3724633),(44551,'forelimb',254,3,352,33.0095322,117.6849043,122.2641364,1.8,117.6240555,122.2802226,-1.3074277,4.6881456,5.1882774,187.8940009,220.8153171,5.1287237,42.5604303,40.0785335,78.6168324,9.453136,10.7765202,1.160669,31.6241687),(44552,'forelimb',254,3,353,33.6526103,117.5529433,122.1921974,1.8,117.5243898,122.2025589,-1.2733043,4.6443975,5.2266079,189.3350741,225.9824829,5.1268559,43.2369303,40.7663369,79.4621181,9.453136,10.7765202,1.160669,31.9801339),(44553,'forelimb',254,3,354,33.4190231,117.5023715,122.1630603,1.8,117.4385047,122.1686534,-1.240847,4.7123028,5.23521,189.506231,226.9039038,4.9851556,43.3418916,40.2152066,79.4691824,9.4188943,10.8703421,1.2490458,31.7284285),(44554,'forelimb',254,3,355,33.3290011,117.3262614,122.0911563,1.8,117.2414652,122.0982068,-1.2574745,4.8001464,5.2522921,192.6745297,227.0931052,5.0271252,43.2369528,40.1393026,79.7690836,9.453136,11.0137676,1.2120257,31.9801339),(44555,'forelimb',254,3,356,33.104086,117.2522164,122.050039,1.8,117.2224181,122.0702405,-1.2231593,4.693488,5.2515114,193.5729594,227.5775737,4.8769991,43.3356332,41.2428791,79.6984178,9.453136,11.0137676,1.2120257,31.9801339),(44556,'forelimb',254,3,357,33.5312009,117.1216594,121.9528394,1.8,117.0979372,121.9768284,-1.1673797,4.6538842,5.2487202,194.9421739,231.6219109,4.7273088,44.1292169,41.8880585,79.7264038,9.4188943,11.0137676,1.2120257,32.0843937),(44557,'forelimb',254,3,358,33.6352101,117.0534429,121.8969526,1.8,117.0006501,121.9092701,-1.1430196,4.7291796,5.2444342,197.3000573,236.5764443,4.6411007,45.1100037,41.7197219,80.4742123,9.453136,11.1553493,1.2977876,32.3360991),(44558,'forelimb',254,3,359,33.8574396,116.8798976,121.8379419,1.8,116.8555056,121.8230915,-1.1357,4.7523078,5.4039742,199.5118681,241.005558,4.6403856,44.5978368,41.9821015,81.4868108,9.4188943,11.171888,1.1760052,32.3360991),(44559,'forelimb',254,3,360,34.222563,116.815046,121.7563589,1.8,116.7861602,121.7481885,-1.1083173,4.6286889,5.3538221,203.3050117,246.4961976,4.5683359,46.0411635,43.9228078,83.199268,9.6102913,11.171888,1.1760052,32.5878045),(44560,'forelimb',254,3,361,34.6248364,116.6785241,121.6512595,1.8,116.6690928,121.6493321,-1.0691632,4.6520326,5.5219538,205.691296,252.1482761,4.4364543,45.6628735,44.2153603,82.8873773,9.7227296,11.3440887,1.141034,32.9437697),(44561,'forelimb',254,3,362,34.7078648,116.5942915,121.5645714,1.8,116.5187842,121.5428285,-1.0725583,4.7420769,5.4855632,208.1421869,256.461439,4.4636175,46.7520711,43.8926219,84.5379532,9.453136,11.2787985,1.2610934,33.0912153),(44562,'forelimb',254,3,363,34.7205652,116.4649932,121.4284288,1.8,116.4009627,121.4470163,-1.0531151,4.7801734,5.5962128,210.2289622,262.6802719,4.3696244,46.9389354,43.9793588,84.4259463,9.8020172,11.417094,1.2252407,33.4471805),(44563,'forelimb',254,3,364,34.7408747,116.3655852,121.3615204,1.8,116.3585226,121.4189631,-1.0767528,4.8213868,5.5886136,212.508136,266.8650812,4.4881973,47.7515713,44.0761434,85.7766574,9.882824,11.417094,1.2252407,33.4471805),(44564,'forelimb',254,3,365,35.4578615,116.2057432,121.2145832,1.8,116.2097821,121.2335352,-1.0839167,4.8118654,5.7343666,216.6320075,281.5512759,4.6160066,49.0989317,45.0203801,86.3426666,9.882824,11.6887773,0.6287963,34.3065565),(44565,'forelimb',254,3,366,35.85454,116.1729276,121.1131605,1.8,116.1738703,121.156205,-1.0770208,4.9123768,5.8395902,222.2438084,287.913858,4.6334092,49.303778,45.2416046,87.3505297,9.882824,11.7360686,1.1562895,34.3065565),(44566,'forelimb',254,3,367,35.3568175,116.0556971,121.0154292,1.8,115.9775251,121.0099726,-1.0782948,4.9663798,5.8087795,222.5319425,288.8603531,4.5753506,49.7282354,44.807677,87.8016242,10.1523503,11.8845829,1.3521274,35.2701923),(44567,'forelimb',254,3,368,35.9119997,115.9814951,120.9272457,1.8,115.8863142,120.9400924,-1.0780124,5.0625888,5.9695393,226.4034099,299.9478984,4.6457852,50.2464061,44.7208765,87.5117177,9.882824,12.1685942,0.7354398,35.3133781),(44568,'forelimb',254,3,369,36.1544827,115.8393902,120.7717743,1.8,115.7322007,120.8110433,-1.0725566,5.0710066,6.0769099,232.3653696,307.2943497,4.6496513,50.5675342,45.8223361,88.6829104,10.312512,12.2291349,1.2490458,36.0253085),(44569,'forelimb',254,3,370,36.2969849,115.7471662,120.6814704,1.8,115.68222,120.6870216,-1.078034,5.11843,6.2424079,236.2696284,317.0258315,4.6956984,50.7858248,46.1605663,87.8155548,10.312512,12.5495381,0.6640462,36.2770139),(44570,'forelimb',254,3,371,36.9133753,115.6059071,120.553191,1.8,115.5555567,120.5765559,-1.0929621,5.3133669,6.3639657,242.4252269,330.6205129,4.8512267,51.9519633,45.6255387,89.7072098,10.312512,12.8188253,0.6904465,37.1363899),(44571,'forelimb',254,3,372,37.5596425,115.5503032,120.4387629,1.8,115.4369639,120.445715,-1.096942,5.4079506,6.4813422,248.08857,347.8276458,4.9564499,53.6659902,45.8747849,90.7323368,10.4554175,13.096676,0.7157436,37.9957659),(44572,'forelimb',254,3,373,38.1053133,115.3900137,120.332649,1.8,115.2697846,120.3218972,-1.1037993,5.4085497,6.6415463,253.7852459,364.9389334,5.0636483,54.9478867,46.9229754,92.6160288,10.6675149,13.4238823,0.6947383,38.9594017),(44573,'forelimb',254,3,374,39.787085,115.3264215,120.2321521,1.8,115.1937482,120.2349225,-1.0910095,5.5121381,6.9715967,269.8453178,394.109768,5.2183054,56.5307757,48.9547452,94.9526258,10.7908005,13.9896277,0.7419473,39.7145179),(44574,'forelimb',254,3,375,42.2756416,114.971193,120.1746515,1.8,114.8774761,120.1703545,-0.986497,5.6080196,7.2535334,292.768796,448.0581162,4.9020074,61.7710142,52.2053808,100.9957338,11.013638,14.9158068,0.72425,41.7892351),(44575,'forelimb',254,3,376,44.3407201,114.7585686,120.143672,1.8,114.6747782,120.1193146,-0.9976767,5.6424595,7.5862004,311.5423108,487.5746502,5.2171191,64.2712591,55.2139203,105.3085536,11.3567386,15.03908,0.6435011,41.7892351),(44576,'forelimb',254,3,377,46.2836058,114.6735173,120.0354802,1.8,114.6227499,119.9696841,-1.0977321,5.6000444,7.6775274,318.4040717,522.9627331,6.1126294,68.1160362,56.8574194,104.5763184,11.5254968,15.5223861,0.7266423,43.3605415),(44577,'forelimb',254,3,378,46.4080924,114.8688482,119.8390296,1.8,114.7944722,119.7335811,-1.1730828,5.7632699,7.5109352,295.8351213,550.1353137,6.5744017,73.2445826,51.3311242,104.7592059,11.3832073,15.5223861,0.7266423,43.3605415),(44578,'forelimb',254,3,379,42.9667239,115.3369654,119.5201543,1.8,115.1853053,119.5007776,-1.2737376,5.53354,7.4767532,231.1018775,517.2196212,6.5475662,69.1770358,41.7638394,95.2257092,10.7051473,15.6231626,1.0209431,43.3173557),(44579,'forelimb',254,3,380,35.3170378,115.9757575,119.5818145,1.8,115.6878196,119.4164783,-1.2974965,5.127209,7.5948724,128.2864381,453.5476575,5.457356,59.7176138,25.0207157,76.0831125,9.2849945,15.7994355,1.1801893,42.1452003),(44580,'forelimb',254,3,381,28.1584721,116.4884656,119.7668447,1.8,116.4516604,119.7369616,-1.3444522,3.8808459,7.4010234,55.625356,353.4198181,4.4567225,47.7528307,14.333307,54.7852991,7.5357023,15.3549594,1.2578951,38.1000257),(44581,'forelimb',254,3,382,22.269222,116.6813847,119.8609066,1.8,116.635618,119.8865628,-1.4145401,3.2096194,7.0002291,38.0666938,250.0312151,3.6216513,35.717576,11.8601894,41.0890453,6.4207936,14.4057668,1.2679115,34.7057075),(44582,'forelimb',254,3,383,2.5530658,117.5365986,120.6290961,1.8,117.2822088,119.9417514,1.3956923,1.6462649,6.2756381,1.3994225,17.890022,0.412597,2.8507096,0.8500591,3.0442621,3.007816,4.8040579,1.3909428,12.4483032),(44583,'forelimb',254,3,384,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44584,'forelimb',254,3,385,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44585,'forelimb',254,3,386,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44586,'forelimb',254,3,387,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44587,'forelimb',254,3,388,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44588,'forelimb',254,3,389,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44589,'forelimb',254,3,390,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44590,'forelimb',254,3,391,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44591,'forelimb',254,3,392,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44592,'forelimb',254,3,393,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44593,'forelimb',254,3,394,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44594,'forelimb',254,3,395,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44595,'forelimb',254,3,396,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44596,'forelimb',254,3,397,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44597,'forelimb',254,3,398,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44598,'forelimb',254,3,399,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44599,'forelimb',254,3,400,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44600,'forelimb',254,3,401,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44601,'forelimb',254,3,402,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44602,'forelimb',254,3,403,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44603,'forelimb',254,3,404,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44604,'forelimb',254,3,405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44605,'forelimb',254,3,406,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44606,'forelimb',254,3,407,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44607,'forelimb',254,3,408,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44608,'forelimb',254,3,409,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44609,'forelimb',254,3,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44610,'forelimb',254,3,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44611,'forelimb',254,3,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44612,'forelimb',254,3,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44613,'forelimb',254,3,414,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44614,'forelimb',254,3,415,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44615,'forelimb',254,3,416,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44616,'forelimb',254,3,417,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44617,'forelimb',254,3,418,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44618,'forelimb',254,3,419,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44619,'forelimb',254,3,420,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44620,'forelimb',254,3,421,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44621,'forelimb',254,3,422,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44622,'forelimb',254,3,423,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44623,'forelimb',254,3,424,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44624,'forelimb',254,3,425,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44625,'forelimb',254,3,426,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44626,'forelimb',254,3,427,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44627,'forelimb',254,3,428,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44628,'forelimb',254,3,429,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44629,'forelimb',254,3,430,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44630,'forelimb',254,3,431,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44631,'forelimb',254,3,432,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44632,'forelimb',254,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44633,'forelimb',254,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44634,'forelimb',254,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44635,'forelimb',254,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44636,'forelimb',254,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44637,'forelimb',254,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44638,'forelimb',254,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44639,'forelimb',254,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44640,'forelimb',254,4,9,2.0484616,86.2524753,128.2593389,1.8,86.5413388,128.2428312,-0.0167269,0.706387,4.8442546,0.3883271,11.4944943,0.0000955,2.3728097,0.549737,2.4520714,2.7863616,22.4468287,3.0457335,47.2835682),(44641,'forelimb',254,4,10,5.523959,88.4131629,128.242658,1.8,88.8269764,128.2480959,-0.0418139,1.1326851,7.4089644,1.5532117,70.168194,0.0016087,9.4707155,1.3712653,9.6792058,3.4710534,29.3731901,3.0390128,62.6048905),(44642,'forelimb',254,4,11,10.0040211,90.5229044,128.1071278,1.8,91.3967508,128.043502,-0.0261332,1.6847346,10.0334632,3.5441713,242.8504084,0.0011384,24.2040463,2.1036971,24.5509605,4.1235974,36.7276431,3.0361033,78.8898487),(44643,'forelimb',254,4,12,12.6320586,91.6086202,128.0061597,1.8,92.536604,127.9513635,-0.0143722,1.6480604,11.0912548,4.6637327,348.6665674,0.0004348,31.4361697,2.8298312,31.840758,4.1665189,39.7200017,3.0440769,85.1571861),(44644,'forelimb',254,4,13,15.6120155,93.2617262,127.8442788,1.8,93.7899376,127.825159,-0.0038912,1.9407397,11.5829412,6.1812557,511.1721052,0.0000394,44.1314599,3.1849999,44.6017359,4.4153191,42.4239386,3.0197502,91.5287833),(44645,'forelimb',254,4,14,17.4326527,94.5249708,127.7436852,1.8,94.5196056,127.7636128,0.003378,1.8523697,12.0266845,7.3966013,626.9636901,0.0000332,52.1310498,3.993048,52.6562585,4.50972,44.8936575,3.0457335,96.1816285),(44646,'forelimb',254,4,15,19.0911496,95.4999134,127.5824823,1.8,94.9237398,127.5568709,0.0147101,1.7200333,13.0105393,8.2212301,727.8924538,0.0006885,55.9463707,4.7796923,56.4914304,4.5374385,47.0326836,3.0501056,100.7302139),(44647,'forelimb',254,4,16,19.8091434,95.7379287,127.4857379,1.8,94.9951703,127.4846382,0.0177399,2.0332324,13.2486598,8.8220625,765.6921697,0.0010389,57.7939341,4.3389346,58.4194119,4.5057211,48.6762735,3.0709141,104.0202723),(44648,'forelimb',254,4,17,20.1872469,96.1482416,127.3113056,1.8,95.4614773,127.3199605,0.0240566,1.8753344,13.6575069,9.1245033,781.8173376,0.0019468,57.2445135,4.865534,57.8683124,4.7159964,50.067411,3.0470478,108.1697067),(44649,'forelimb',254,4,18,20.7743759,96.0726215,127.1878771,1.8,95.0992073,127.1939856,0.0263076,2.1638972,13.5904406,9.5169341,805.9272812,0.0023957,59.3010416,4.3980528,59.9603704,4.6266693,51.3130956,3.057756,109.8884587),(44650,'forelimb',254,4,19,20.4634113,96.0977779,126.9893283,1.8,95.3312407,126.9747872,0.0297118,1.9920798,13.6113186,9.3139186,770.0472911,0.0030099,56.5740404,4.6754747,57.248129,4.7834223,52.1358708,3.0673492,111.9631759),(44651,'forelimb',254,4,20,21.4867749,96.043241,126.8621748,1.8,95.0755457,126.8621658,0.0312275,1.8822007,13.5666278,9.8244461,807.8898886,0.003491,59.5497937,5.2196591,60.2262186,4.7039999,52.5643848,3.0679555,112.3623269),(44652,'forelimb',254,4,21,21.2894427,96.0326872,126.6831238,1.8,95.214257,126.7323833,0.0303442,2.1183555,13.550164,10.1632886,809.8666683,0.0032661,59.7680343,4.7977257,60.4950931,4.7330784,52.5977428,3.0598083,113.3259627),(44653,'forelimb',254,4,22,21.2453548,96.0436478,126.5506981,1.8,95.219131,126.5350087,0.0315455,2.0009341,13.5573815,9.8642289,784.0475895,0.0035224,57.8317861,4.9298119,58.5513413,4.6731313,52.9632948,3.0766435,113.3259627),(44654,'forelimb',254,4,23,20.846718,95.9741225,126.3640814,1.8,94.9778226,126.3914994,0.031301,2.2187118,13.4954421,10.1476087,777.7528628,0.003403,57.6307805,4.5736488,58.3468729,4.683643,52.9632948,3.0766435,113.6819279),(44655,'forelimb',254,4,24,20.3366308,96.0861902,126.2466409,1.8,95.4848581,126.2655239,0.0326198,2.127111,13.6042321,9.7987638,728.2398682,0.0036053,53.5303914,4.6066067,54.234299,4.5433066,52.9371431,3.0847434,112.8225519),(44656,'forelimb',254,4,25,19.9600379,95.980601,126.0902125,1.8,95.1902149,126.1045614,0.0283178,2.3589274,13.4926923,10.0323958,712.3258796,0.0026669,52.7934576,4.252948,53.5197826,4.5869862,52.5081549,3.0842784,112.8225519),(44657,'forelimb',254,4,26,20.226691,95.8773714,125.9866967,1.8,94.9891584,126.0203959,0.0263355,2.2795365,13.3862717,10.5522375,703.4025695,0.0023375,52.546563,4.6291154,53.2822354,4.5571996,52.1057606,3.075573,111.8589161),(44658,'forelimb',254,4,27,19.9194749,95.6312451,125.8401536,1.8,94.5962186,125.8918279,0.0198051,2.1358935,13.1444357,10.6941651,692.9590142,0.001302,52.7188104,5.0068811,53.456148,4.5122234,51.7073763,3.0667328,111.5029509),(44659,'forelimb',254,4,28,19.5741015,95.5363251,125.7559868,1.8,94.5475746,125.8323742,0.0154293,2.4595128,13.0457364,10.9955545,677.5691032,0.0007766,51.937973,4.4706231,52.6639837,4.8738581,52.0791783,3.0838058,111.7114705),(44660,'forelimb',254,4,29,19.4749039,95.465532,125.6204632,1.8,94.9514994,125.7212524,0.0092892,2.3231615,12.9702759,11.6205377,671.6571745,0.0002801,51.7843396,5.0020362,52.4982864,4.85137,51.6502135,3.0833254,111.7114705),(44661,'forelimb',254,4,30,19.3049867,95.3425152,125.5401786,1.8,94.8910662,125.6620457,0.0042073,2.2307529,12.8444133,11.8861125,661.4556312,0.000057,51.4975355,5.3282964,52.1969209,4.8288818,51.626973,3.0916343,111.2080597),(44662,'forelimb',254,4,31,19.4609726,95.1180529,125.410627,1.8,94.6405546,125.5086031,-0.005373,2.5137401,12.6250139,12.5543428,654.8428521,0.0000936,51.8686837,4.9942883,52.5936712,5.0576849,51.2212608,3.0828368,110.8520945),(44663,'forelimb',254,4,32,19.0228918,95.0078278,125.3390875,1.8,94.6825989,125.4547615,-0.009153,2.4368465,12.5201947,12.8713058,639.2519306,0.0002656,51.0576671,5.2819518,51.8053451,5.0424994,51.1978256,3.0912151,110.9563543),(44664,'forelimb',254,4,33,18.9885391,94.9459642,125.2183491,1.8,94.8938655,125.3471277,-0.0148959,2.7311371,12.4610201,13.6639248,612.3387988,0.0007022,49.1403427,5.0030168,50.099209,4.884539,51.1779874,3.0996005,110.9563543),(44665,'forelimb',254,4,34,18.8991885,94.8790812,125.1412744,1.8,94.8004298,125.2657208,-0.0202758,2.6518467,12.4005064,14.0604725,603.7641126,0.0012948,48.6886658,5.3021439,49.681271,4.884539,51.1978256,3.0912151,110.8520945),(44666,'forelimb',254,4,35,18.6339342,94.7744829,125.020075,1.8,94.367272,125.1490635,-0.0251151,2.5319218,12.303368,14.7558492,595.2957893,0.0019585,48.3847829,5.8279245,49.4212906,4.8732911,51.1779874,3.0996005,110.8520945),(44667,'forelimb',254,4,36,18.4191459,94.7259819,124.9488883,1.8,94.3765049,125.0964067,-0.0277929,2.8620743,12.2594965,15.5088409,584.5227955,0.0023707,47.6791847,5.4187415,48.7693639,5.0660672,51.1617504,3.1079919,111.2080597),(44668,'forelimb',254,4,37,18.3923463,94.7359367,124.8419197,1.8,94.3843615,125.039208,-0.0312543,2.7618382,12.2763124,16.5498194,574.7301274,0.0029934,46.8161861,5.9923204,47.9709664,5.0623175,51.1617504,3.1079919,111.4597651),(44669,'forelimb',254,4,38,18.2088335,94.7461459,124.7568215,1.8,94.4465349,124.9585546,-0.0347515,3.0860287,12.2932553,17.4499431,559.3193769,0.0036636,45.4980689,5.654498,46.7153412,5.156256,51.1491181,3.1163879,111.6682847),(44670,'forelimb',254,4,39,17.8740905,94.8031371,124.6243244,1.8,94.5597222,124.8576896,-0.0372064,2.9667041,12.3579096,18.237047,533.4515068,0.004122,43.1668076,6.1472416,44.417661,5.156256,51.1491181,3.1163879,111.6682847),(44671,'forelimb',254,4,40,17.5639091,94.8522857,124.5299162,1.8,94.7746071,124.714393,-0.0391212,3.2838545,12.3962688,18.8473611,511.9452036,0.0044779,41.2983302,5.739402,42.7101501,5.5379242,51.1491181,3.1163879,112.5276607),(44672,'forelimb',254,4,41,17.3820188,94.8814949,124.4094486,1.8,94.7527144,124.639902,-0.0423964,3.1765165,12.4333881,20.1253525,494.3959869,0.0052041,39.763577,6.3356676,41.2586549,5.156256,51.1491181,3.1163879,112.1716955),(44673,'forelimb',254,4,42,16.9607786,94.8598737,124.333787,1.8,94.6467125,124.5979848,-0.044554,3.0967132,12.4172071,20.6725385,478.1575293,0.0056076,38.5076551,6.6756388,40.0395332,5.156256,50.732307,3.1077073,111.5640249),(44674,'forelimb',254,4,43,16.8995704,94.8343848,124.2050198,1.8,94.3337864,124.4741199,-0.044368,3.3964919,12.397266,22.8275953,475.652972,0.0055409,38.36757,6.7209333,40.0385558,5.585944,51.1400931,3.1247875,112.2759553),(44675,'forelimb',254,4,44,16.6565838,94.8731446,124.1332087,1.8,94.3787998,124.459759,-0.0439591,3.3270943,12.438675,23.8320442,465.0103169,0.0053611,37.3842325,7.1630204,39.1125356,5.585944,50.732307,0.0338853,111.9199901),(44676,'forelimb',254,4,45,16.3628514,94.9913844,123.9916646,1.8,94.8163864,124.287254,-0.0412551,3.62398,12.541586,26.1635148,443.1327959,0.0046389,35.3330747,7.2195527,37.3098926,6.0041539,50.732307,0.0338853,112.7793661),(44677,'forelimb',254,4,46,16.1982494,94.9978653,123.923644,1.8,94.7952288,124.2461597,-0.0418267,3.5554837,12.5514526,27.2970674,436.1489103,0.0047203,34.7488792,7.6774553,36.8020589,6.015632,50.7486814,0.0423475,113.4912965),(44678,'forelimb',254,4,47,16.2306998,95.0217617,123.7936004,1.8,94.7189904,124.1082173,-0.0456144,3.8505697,12.5850323,30.0381252,428.9565055,0.0056246,34.0846567,7.8009562,36.3323003,6.4225765,50.3395584,0.0512372,113.9947073),(44679,'forelimb',254,4,48,15.9623123,95.0140125,123.7222709,1.8,94.5487798,124.0549902,-0.0476017,3.7761517,12.5828524,30.7364944,418.0885844,0.0060237,33.2268529,8.1396345,35.5217438,6.4150771,50.732307,0.0338853,113.8472617),(44680,'forelimb',254,4,49,16.0620694,95.0093655,123.5846428,1.8,94.4871064,123.9014627,-0.0507389,4.0631348,12.5887347,33.8588786,414.261218,0.0068859,32.9072958,8.333191,35.4234362,6.44532,50.3193819,0.0427091,114.7066377),(44681,'forelimb',254,4,50,16.0546842,94.9277948,123.522232,1.8,94.2702313,123.8813992,-0.0489061,3.9994593,12.5080052,35.377775,427.0513078,0.0063949,34.1422394,8.8456395,36.7612989,6.44532,49.9344786,0.0602717,113.3870367),(44682,'forelimb',254,4,51,16.0499285,95.0172389,123.3896469,1.8,94.7124325,123.6840382,-0.0457204,4.3051605,12.5794549,38.2642655,418.5306237,0.0055878,33.2709666,8.8879998,36.1807186,6.875008,49.8900891,0.0430768,114.559192),(44683,'forelimb',254,4,52,16.0909951,95.0165009,123.3191861,1.8,94.7440484,123.6610448,-0.047423,4.6207671,12.5838712,40.3698588,423.7594406,0.0060268,33.6748076,8.736614,36.7364236,7.304696,49.8900891,0.0430768,115.1668626),(44684,'forelimb',254,4,53,16.2605206,95.0440018,123.2142149,1.8,94.8219904,123.5596351,-0.0481255,4.5569553,12.6171771,44.3384039,434.5944543,0.0062719,34.4446663,9.7298308,37.7827436,7.304696,49.5055776,0.0607946,114.4549322),(44685,'forelimb',254,4,54,16.3783493,95.0530897,123.1444412,1.8,94.7957834,123.5118875,-0.0488832,4.8738088,12.630584,46.8229741,439.6361847,0.0065177,34.807273,9.6070602,38.3183902,7.734384,49.5055776,0.0607946,115.1668626),(44686,'forelimb',254,4,55,16.5109485,94.9978917,123.0326913,1.8,94.53136,123.4162378,-0.0480298,4.8027561,12.5797186,50.6205209,461.248387,0.0063432,36.6660336,10.53989,40.4388711,7.734384,49.104898,0.0700606,115.5228278),(44687,'forelimb',254,4,56,16.9133338,94.9758974,122.9602603,1.8,94.4617532,123.3217946,-0.0489376,5.115121,12.5625633,53.2385889,476.390631,0.0067455,37.9214511,10.4080802,41.8751006,8.164072,49.0766903,0.0613265,116.1304984),(44688,'forelimb',254,4,57,17.124933,95.0120606,122.8505424,1.8,94.6991429,123.1922316,-0.0482777,5.0503224,12.5822729,57.5906668,484.3412005,0.0066471,38.4939354,11.4033644,42.8913182,8.164072,49.0522306,0.0525831,116.339018),(44689,'forelimb',254,4,58,17.126052,94.9984957,122.7753787,1.8,94.8961112,123.0938681,-0.0490687,4.9734088,12.5733192,60.3406083,492.4963218,0.006867,39.169953,12.1326461,43.7638867,8.164072,48.6762735,0.0706785,115.6270876),(44690,'forelimb',254,4,59,17.6037448,94.9700217,122.6599684,1.8,94.8367357,122.9934607,-0.0518392,5.2593568,12.5541921,66.0154254,513.8414774,0.0078774,40.9298721,12.551996,45.9423513,8.59376,48.2801842,0.0801848,115.7313474),(44691,'forelimb',254,4,60,17.5074006,94.9234273,122.6042301,1.8,94.7408992,122.9080086,-0.0519369,5.6078827,12.5106812,68.7441625,529.2181933,0.0078638,42.3013091,12.258488,47.5171759,9.023448,48.2476678,0.0713075,117.198394),(44692,'forelimb',254,4,61,18.0695764,94.9509725,122.5224083,1.8,94.7379651,122.8400674,-0.0473575,5.5590985,12.5357206,73.4853753,561.9068409,0.0067492,44.8244548,13.2189375,50.3297168,9.023448,47.8190816,0.0719477,116.0873126),(44693,'forelimb',254,4,62,18.3296274,94.9839795,122.44931,1.8,94.7029809,122.7623701,-0.0468655,5.5087373,12.5713787,77.9120823,576.3711191,0.0067049,45.8478846,14.1433649,51.6427674,9.023448,48.1940635,0.0535203,116.5907234),(44694,'forelimb',254,4,63,18.6246466,95.0827778,122.3616835,1.8,94.7799925,122.6497857,-0.0400787,5.8474952,12.6626436,83.4110086,596.9922005,0.0049835,47.1459374,14.2643997,53.2318254,9.453136,47.7649963,0.0540015,116.0873126),(44695,'forelimb',254,4,64,18.6171494,95.1918565,122.3080552,1.8,95.0638568,122.569161,-0.0322044,5.8254927,12.7592842,85.3684644,595.4144156,0.0032169,46.6651896,14.6542909,52.7790167,9.453136,47.3612865,0.0635507,116.2347582),(44696,'forelimb',254,4,65,18.8911318,95.2834607,122.2317164,1.8,95.0623038,122.4571855,-0.0274309,6.1753199,12.8319874,90.4938702,606.9035978,0.0023685,47.2961497,14.6541187,53.9324073,9.882824,46.9324739,0.0641321,115.2279366),(44697,'forelimb',254,4,66,19.0698889,95.3279867,122.179295,1.8,94.9047793,122.4291092,-0.0228342,6.1310634,12.8702233,94.8212878,622.0584058,0.0016569,48.3331479,15.4657165,55.2170213,9.882824,46.5036774,0.0647243,115.2279366),(44698,'forelimb',254,4,67,19.4348444,95.4373877,122.0823212,1.8,94.7305448,122.2644007,-0.0140952,6.4780924,12.9655703,101.6144662,641.8590666,0.0006435,49.5048849,15.6858623,56.7267597,10.312512,46.0488432,0.0560161,114.7245258),(44699,'forelimb',254,4,68,19.6516469,95.5333675,122.0246905,1.8,94.7191122,122.1964628,-0.0089653,6.4280818,13.0520691,105.4330737,647.9162099,0.0002633,49.6408812,16.4019497,57.0276169,10.312512,45.248003,0.0760436,114.620266),(44700,'forelimb',254,4,69,19.8064578,95.7708716,121.9625441,1.8,95.2017237,122.1321986,0.0081189,6.8202923,13.2662907,110.3276534,653.9596088,0.0002176,49.2948349,16.176382,56.8043411,10.7422,45.1683644,0.0475831,113.0057738),(44701,'forelimb',254,4,70,19.8302362,95.9011428,121.9259564,1.8,95.3718348,122.0351722,0.017472,6.8046646,13.3896522,112.8689282,659.3721416,0.0010088,49.2449045,16.5869937,56.8273049,10.7422,44.3328915,0.0581867,112.2938434),(44702,'forelimb',254,4,71,20.2016817,96.0854796,121.8695692,1.8,95.3982524,122.0088428,0.0302881,7.1836202,13.5612396,118.3760859,673.8572606,0.0030878,49.6899457,16.4786115,57.4897846,11.1077179,43.4749986,0.0593362,111.182762),(44703,'forelimb',254,4,72,20.4599424,96.1882113,121.8169575,1.8,95.2741064,121.9552758,0.0384172,7.1534208,13.6532762,123.8808778,688.0411277,0.0050303,50.393848,17.3177114,58.7329783,11.1114676,43.0224775,0.0499584,109.6114556),(44704,'forelimb',254,4,73,20.8159461,96.3646552,121.7505054,1.8,95.2154525,121.8707155,0.0509124,7.0963471,13.8104327,131.3692353,716.6478177,0.008985,51.8917714,18.5122337,60.5379775,11.1152173,42.144486,3.100799,108.5003742),(44705,'forelimb',254,4,74,20.9656097,96.5291529,121.7451673,1.8,95.4337048,121.8018158,0.0639357,7.4974738,13.9821053,132.5790439,729.9741048,0.0142643,52.207739,17.683162,60.8648909,11.5411392,41.7151591,3.1003789,106.7816222),(44706,'forelimb',254,4,75,21.4222656,96.6748633,121.728079,1.8,95.5526298,121.6978665,0.0740763,7.5064592,14.1134467,139.7390062,767.0031207,0.0195559,54.3455568,18.615835,63.3276439,11.5451409,40.8768588,3.0890096,105.566281),(44707,'forelimb',254,4,76,21.6772813,96.8072124,121.7130966,1.8,95.6341853,121.6844768,0.0827279,7.486717,14.2318841,143.7951963,778.9617251,0.0246699,54.7335629,19.2067092,63.8523964,11.5376419,40.0440631,3.0771658,103.2398584),(44708,'forelimb',254,4,77,22.5715705,97.0045687,121.7015184,1.8,95.7917781,121.6160269,0.0958191,7.849409,14.4063787,152.1651634,816.8070469,0.0344338,56.6975963,19.3855566,66.1485224,11.9522662,39.2171226,3.0648208,102.2330368),(44709,'forelimb',254,4,78,23.0367866,97.0606455,121.7066835,1.8,95.6870318,121.5592074,0.0998471,7.8908513,14.4984941,157.3753243,861.4972136,0.0381503,59.4197722,19.9440236,69.2957729,11.9597653,38.7887143,3.0639711,101.1219554),(44710,'forelimb',254,4,79,24.1307579,97.1293724,121.7358461,1.8,95.7533563,121.5107647,0.1047116,7.9580833,14.5631687,164.7415831,936.6812521,0.0439361,64.3185058,20.7011635,74.585259,11.9597653,37.5823509,3.038511,99.090424),(44711,'forelimb',254,4,80,24.8358834,97.1717678,121.7682749,1.8,95.8136573,121.5475701,0.107509,8.3680757,14.6048379,168.5935206,982.9548376,0.0476589,67.3033718,20.147227,77.7814463,12.6950081,37.075377,3.0603763,98.0836024),(44712,'forelimb',254,4,81,26.1549935,97.1381171,121.7663504,1.8,95.8248198,121.5104915,0.1040158,8.4145724,14.6206148,181.3968095,1079.1416497,0.0469932,73.8095947,21.5574601,84.9668423,12.713746,36.2571132,3.0466409,96.2605906),(44713,'forelimb',254,4,82,26.7072104,97.1360795,121.7998533,1.8,95.7184274,121.524664,0.1043124,8.4482204,14.6218005,186.1475773,1141.4162263,0.0482585,78.0626316,22.0339396,89.5295047,12.6987502,35.0689645,3.0187574,94.1858734),(44714,'forelimb',254,4,83,28.3408659,97.0335986,121.8233265,1.8,95.6428054,121.519808,0.0997011,8.4799128,14.568927,194.5813723,1266.7946963,0.0467975,86.9518188,22.9461524,99.2559557,12.6878407,34.5918856,3.0295637,92.215416),(44715,'forelimb',254,4,84,29.351585,97.0172663,121.8307935,1.8,95.6673285,121.4026799,0.1010192,8.9171688,14.5529292,204.5260049,1331.3935949,0.049752,91.4862962,22.9362041,104.4417507,13.1322629,33.4853518,2.9869921,91.1043346),(44716,'forelimb',254,4,85,30.4815875,96.9453948,121.8462021,1.8,95.5947392,121.3898166,0.0970651,8.9374848,14.5259248,211.869577,1397.4188473,0.0477143,96.2017128,23.7057272,109.421593,13.1322629,32.5713708,2.9959643,88.8821718),(44717,'forelimb',254,4,86,31.677274,96.8746536,121.839184,1.8,95.4801733,121.3985257,0.0960424,8.9778798,14.4546997,220.5382825,1451.4861183,0.0485497,100.4162071,24.5646285,114.2164935,13.0547035,31.8607205,2.965358,87.3108654),(44718,'forelimb',254,4,87,33.6014729,96.5697009,121.8079578,1.8,95.2798187,121.3761411,0.0882937,9.3550151,14.1845439,233.739879,1580.3804413,0.043545,111.4156682,24.9855158,126.4563755,13.4838026,31.2345051,3.0035866,86.0523384),(44719,'forelimb',254,4,88,34.8457232,96.26572,121.7788241,1.8,95.1278997,121.3469412,0.0811927,9.3780879,13.8740376,241.8541622,1684.929145,0.0382013,121.4447588,25.7892829,137.1019276,13.5062908,30.5169246,2.9718144,84.8369972),(44720,'forelimb',254,4,89,36.0819169,95.8136506,121.6988548,1.8,94.8915775,121.318676,0.0682433,9.304935,13.4356927,253.7725043,1766.2624595,0.027963,131.4604691,27.2728939,148.2266804,13.5287789,29.5986112,2.9812172,82.363129),(44721,'forelimb',254,4,90,37.6497763,95.3957338,121.6354843,1.8,94.6901577,121.2976955,0.0580273,9.2410514,13.0004903,259.9253336,1842.5724293,0.0211052,141.7309949,28.1272469,158.8692849,13.5287789,28.8243473,2.9617392,81.1477878),(44722,'forelimb',254,4,91,39.4633639,94.9637857,121.5169653,1.8,94.4373151,121.159855,0.0452642,9.5336633,12.5637464,273.3772202,1886.2364506,0.0134665,150.133279,28.6749397,168.1728649,13.9421012,28.2583162,2.9889433,80.245226),(44723,'forelimb',254,4,92,40.0462409,94.6910395,121.4679031,1.8,94.2451686,121.0958586,0.0380326,9.4699062,12.2750693,281.8818398,1933.8394442,0.0096497,157.5420392,29.7660645,176.001252,13.9421012,27.5570408,2.9533711,79.2815902),(44724,'forelimb',254,4,93,42.6330999,94.2563379,121.3159369,1.8,93.9367647,120.9583333,0.0259751,9.2941785,11.8229736,296.9304648,1997.5882212,0.0047931,168.9581899,31.9480053,187.9384051,13.9434014,27.1350609,2.9504082,78.1705088),(44725,'forelimb',254,4,94,43.9751491,94.025553,121.2501922,1.8,93.8493987,120.9159998,0.0178515,9.1935746,11.571037,310.2731971,2039.1917893,0.0023354,176.2324139,33.748918,195.7063776,13.6807008,27.0566997,2.9660005,76.9551676),(44726,'forelimb',254,4,95,46.3555003,93.7857866,121.1240146,1.8,93.6618907,120.8432614,0.0033211,9.423256,11.2940311,330.7391296,2045.6936663,0.0000852,181.1305151,35.0981794,201.1936235,14.1099799,26.6337246,2.9631822,76.0957916),(44727,'forelimb',254,4,96,47.8075453,93.6364236,121.0194887,1.8,93.6283823,120.78382,-0.0105929,9.249643,11.1691795,351.9895446,2058.1464851,0.0008941,184.27016,38.0543926,208.1997214,14.1287226,26.5608362,2.9791035,75.5923808),(44728,'forelimb',254,4,97,49.5934941,93.4258063,120.9013184,1.8,93.5363637,120.7174867,-0.0292594,9.0330294,11.0169474,384.1236108,2088.8100462,0.0070742,189.5997118,42.5243396,216.7907656,14.1474653,25.7131561,2.9736967,74.7330048),(44729,'forelimb',254,4,98,52.0259898,93.4170034,120.8227328,1.8,93.4850502,120.6579482,-0.0425755,8.8835748,11.0499017,410.7203531,2116.694342,0.0157082,191.5577537,46.2336797,221.2871308,14.1662081,25.7131561,2.9736967,73.6219234),(44730,'forelimb',254,4,99,55.8828357,93.3112024,120.6929719,1.8,93.4596382,120.5324804,-0.0723678,8.9802587,11.0349256,454.6659961,2173.0959436,0.0486923,196.9289162,50.6294989,231.2811165,14.609392,25.0290955,2.9340964,72.909993),(44731,'forelimb',254,4,100,57.2381449,93.439567,120.6316279,1.8,93.5105475,120.4680074,-0.0895155,9.2128598,11.2128663,489.2022648,2172.1779442,0.0762378,193.7219156,53.0999359,231.4140622,15.0184695,24.6087836,2.9304993,72.050617),(44732,'forelimb',254,4,101,60.5246465,93.5003709,120.4948541,1.8,93.5462217,120.4098729,-0.1224083,8.9127052,11.315445,533.7943623,2211.4024042,0.1503947,195.432209,59.8913968,239.2988715,15.03908,24.3713034,2.982241,71.7989116),(44733,'forelimb',254,4,102,63.3953349,93.6325469,120.4439099,1.8,93.6031888,120.3256096,-0.140786,9.1256531,11.4862419,579.7913686,2255.7487747,0.2080434,196.3870159,63.5342329,242.3043551,15.468768,24.0202894,2.9617392,71.191241),(44734,'forelimb',254,4,103,69.030073,93.79207,120.3214556,1.8,93.7206279,120.2861561,-0.1806827,8.8256103,11.724294,650.2541078,2346.6786804,0.3715258,200.1552223,73.6780898,253.9549401,15.7335159,23.4485273,2.9010584,70.9827214),(44735,'forelimb',254,4,104,73.0610323,93.8856905,120.2594296,1.8,93.8270476,120.2097864,-0.2070169,9.0243504,11.7716618,697.3088987,2386.0755351,0.5144384,202.6965763,77.2697053,261.5277072,16.0547664,23.3498959,2.9189317,70.5835704),(44736,'forelimb',254,4,105,78.3645521,94.1443383,120.2100027,1.8,93.958947,120.1426812,-0.2347162,8.8406027,11.9484191,766.1040254,2453.9717801,0.7064227,205.3804579,86.6574431,269.4884729,16.1399501,22.9310118,2.9147938,70.2276052),(44737,'forelimb',254,4,106,78.9195664,94.2124627,120.1050978,1.8,94.0405651,120.1133152,-0.2699165,8.6228763,12.0311006,816.1003362,2513.473693,0.9352326,208.9146936,94.6436325,276.5637842,16.5030256,23.0033622,0.5724598,70.9395356),(44738,'forelimb',254,4,107,81.6709715,94.3886952,120.0435745,1.8,94.1761136,120.1260649,-0.3072082,8.3606518,12.1929807,890.6703459,2619.8660346,1.2447338,214.8667426,106.5312094,287.1655558,16.6251432,23.2389317,0.5880026,71.4429464),(44739,'forelimb',254,4,108,85.903683,94.6670692,120.0553069,1.8,94.358209,120.1536144,-0.3320928,8.2892393,12.286531,982.5232328,2672.3057019,1.5217902,217.4987956,118.5299641,294.6839221,16.891377,23.4800019,0.6032299,72.6582876),(44740,'forelimb',254,4,109,89.9910949,94.8189317,120.0649439,1.8,94.4335841,120.1982027,-0.3619479,8.4944108,12.5212989,1078.2766396,2775.9396915,1.8805799,221.6974227,126.9395447,304.951388,17.3066992,23.7069427,0.8110336,74.3770396),(44741,'forelimb',254,4,110,88.6115598,94.9615431,119.9790282,1.8,94.5781492,120.2594119,-0.3966306,8.8440382,12.6188805,1135.8468891,2826.6618904,2.2040283,224.0025876,128.4307987,309.6410333,17.5275796,23.8350997,0.5930026,75.5923808),(44742,'forelimb',254,4,111,90.7612891,95.0087882,119.9917608,1.8,94.6696986,120.3667178,-0.4374788,9.2034373,12.5588417,1207.5464609,2940.4097645,2.7150534,234.1306504,131.2060289,323.0436491,17.821138,24.0778691,0.607802,76.5992024),(44743,'forelimb',254,4,112,89.6536663,95.1596551,120.0823022,1.8,94.8330558,120.4751236,-0.4458179,9.4578439,12.6331915,1287.7178358,2931.0500218,2.7782168,232.0118413,136.1534246,325.337943,18.2869039,24.3258062,0.6223029,79.0298848),(44744,'forelimb',254,4,113,83.605465,95.2074641,120.3549985,1.8,94.9247839,120.7650985,-0.4508383,9.5875216,12.3553377,1388.8233194,2931.3654059,2.6454454,237.2549808,144.8573867,335.3997962,8.4306447,23.6796687,2.9406384,55.4960653),(44745,'forelimb',254,4,114,82.5662118,95.3070139,120.5813652,1.8,95.040234,121.011977,-0.4299227,9.4427826,12.4249286,1486.2409103,2977.5808256,2.3906038,239.6457089,157.39438,344.8530032,8.507027,23.8660645,2.9053474,56.1037359),(44746,'forelimb',254,4,115,83.1216178,95.7761857,120.9648848,1.8,95.2930984,121.2325761,-0.3492664,9.5523955,12.6924577,1666.5890666,2941.3890112,1.6223499,231.7430618,174.4681804,346.6898861,8.7631286,24.0202894,2.9617392,57.2148173),(44747,'forelimb',254,4,116,82.6572409,95.7483364,121.0431009,1.8,95.2316983,121.3776612,-0.3904256,9.3668649,12.2300457,1631.17793,2878.7782926,1.9953829,235.3857342,174.143425,339.5995652,9.0621337,23.6796687,2.9406384,56.6071467),(44748,'forelimb',254,4,117,81.7741975,95.3025949,120.9560795,1.8,94.9496548,121.4218535,-0.5204557,9.241861,12.6076863,1362.6080584,2793.4676757,3.3702276,221.5686224,147.4387099,303.0067042,9.6300185,22.4180217,2.9291606,55.7477707),(44749,'forelimb',254,4,118,83.4702921,95.023611,120.982287,1.8,94.6299235,121.3609973,-0.5468778,8.7630748,13.1414874,1236.7161605,2713.7639013,3.7620597,206.5035571,141.1281077,284.0755365,10.1309125,22.2526948,2.9669205,55.4960653),(44750,'forelimb',254,4,119,92.2370565,94.8040768,121.0316131,1.8,94.3575405,121.3166711,-0.5664797,8.7709945,13.6666073,1210.9061832,2732.2524576,4.4275216,199.9217797,138.0580259,274.7503792,11.5012412,21.6939254,3.0024967,56.1037359),(44751,'forelimb',254,4,120,104.7873736,94.6911801,121.1189555,1.8,94.2474988,121.2696049,-0.5686066,8.5283243,13.9487667,1322.2127682,2776.8499575,5.0636313,199.0749444,155.0378155,282.8662116,12.460952,21.6385348,3.0221637,56.3122555),(44752,'forelimb',254,4,121,117.2049236,94.4517481,121.2383223,1.8,94.0781957,121.2833507,-0.5842862,8.6886933,14.5087625,1499.2277397,2883.7553743,5.9436014,198.7595685,172.5492762,291.844246,13.320328,21.1640424,3.0399038,56.7724805),(44753,'forelimb',254,4,122,97.0972363,94.282756,121.486768,1.8,93.9985469,121.3897246,-0.5554479,8.5626333,14.8039988,1468.9343012,2809.8906706,4.4999796,189.8061943,171.5516998,279.3643273,13.750016,20.7855324,3.0172377,57.1716315),(44754,'forelimb',254,4,123,45.5390362,93.3066052,121.6233658,1.8,93.5181886,121.8640954,-0.5525807,8.3658696,15.9210776,833.2126621,2120.1342468,2.0910378,133.1652482,99.5966595,180.3343473,11.2927743,17.5384304,2.6011732,56.3733294),(44755,'forelimb',254,4,124,15.9839646,93.9573151,119.1717095,1.8,92.8304057,120.6075738,-0.63308,9.3443113,14.5494488,232.9452883,1242.8650486,0.9324695,85.4235144,24.929102,101.3171885,5.5219319,12.9263977,1.9451299,33.5514403),(44756,'forelimb',254,4,125,3.572457,102.9775031,110.6026616,1.8,102.9681186,110.7355555,0.0909948,1.2153229,2.9031177,0.99357,5.0442032,0.0049164,1.7375124,0.8175358,2.0656257,4.8613648,9.2955727,2.5535901,22.6744435),(44757,'forelimb',254,4,126,3.078595,103.2432461,110.5524479,1.8,103.2439699,110.7132272,0.1117606,1.2202517,2.7410322,0.7651599,3.9582113,0.0063822,1.4440587,0.6270508,1.7161895,4.5575295,9.5406219,2.5161076,22.6744435),(44758,'forelimb',254,4,127,2.4695899,103.6543352,110.4866664,1.8,103.6447427,110.6396636,0.1070882,1.2357927,2.7143193,0.5263027,2.924752,0.0047021,1.0775269,0.4258827,1.2680712,4.5575295,9.5406219,2.5161076,22.6744435),(44759,'forelimb',254,4,128,2.0086259,103.9325998,110.4463926,1.8,103.8293309,110.5491738,0.1164352,0.9308996,2.5609704,0.3650244,2.1734141,0.0045181,0.8486682,0.3921201,0.9895113,4.5703021,9.2955727,2.5535901,22.0667729),(44760,'forelimb',254,4,129,1.6288999,104.2490329,110.4291223,1.8,104.1928296,110.5470036,0.1693379,0.9647653,2.4507614,0.2761417,1.4724571,0.0077107,0.6008162,0.2862268,0.7134765,4.3017474,9.4628966,2.4526683,22.0667729),(44761,'forelimb',254,4,130,1.3095988,104.3798743,110.3915595,1.8,104.3505265,110.5093879,0.2220213,0.8680445,2.1484315,0.1975893,0.9675008,0.0105835,0.4503289,0.2276257,0.5418868,4.0974934,9.4628966,2.4526683,21.7108077),(44762,'forelimb',254,4,131,0.6099563,104.3264491,110.244414,1.8,104.2799065,110.3492495,0.1918731,0.6690121,1.6476708,0.0616521,0.2712704,0.0036969,0.1646387,0.0921539,0.2018679,3.9352634,8.8164606,2.3906636,20.5997263),(44763,'forelimb',254,4,132,0.3927062,104.504664,110.1221964,1.8,104.4923091,110.1563782,0.0850045,0.3506723,1.3849267,0.0208003,0.1589426,0.0004718,0.1147661,0.0593155,0.1297844,3.780657,8.59376,2.4980915,19.9920557),(44764,'forelimb',254,4,133,0.2178655,104.6877322,110.0917153,1.8,104.7006427,110.1433573,0.098377,0.3633334,1.1364419,0.0101847,0.0678572,0.0003503,0.0597102,0.0280314,0.0686614,3.416261,8.3430318,2.5393053,19.1326797),(44765,'forelimb',254,4,134,0.0906934,104.6758139,110.000128,1.8,104.629028,110.000128,0.0804761,0.0555745,0.6890805,0.0015065,0.0184737,0.0000977,0.0268092,0.0271076,0.0289016,3.1694066,8.107337,2.5829933,18.7767145),(44766,'forelimb',254,4,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44767,'forelimb',254,4,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44768,'forelimb',254,4,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44769,'forelimb',254,4,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44770,'forelimb',254,4,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44771,'forelimb',254,4,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44772,'forelimb',254,4,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44773,'forelimb',254,4,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44774,'forelimb',254,4,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44775,'forelimb',254,4,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44776,'forelimb',254,4,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44777,'forelimb',254,4,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44778,'forelimb',254,4,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44779,'forelimb',254,4,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44780,'forelimb',254,4,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44781,'forelimb',254,4,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44782,'forelimb',254,4,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44783,'forelimb',254,4,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44784,'forelimb',254,4,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44785,'forelimb',254,4,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44786,'forelimb',254,4,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44787,'forelimb',254,4,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44788,'forelimb',254,4,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44789,'forelimb',254,4,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44790,'forelimb',254,4,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44791,'forelimb',254,4,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44792,'forelimb',254,4,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44793,'forelimb',254,4,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(44794,'forelimb',254,4,163,0.5926121,99.3787778,122.3900468,1.8,99.380696,122.2564667,-1.2755329,0.9171369,4.9190455,0.12582,0.4361099,0.0904053,0.0886574,0.1371878,0.1141641,2.14844,2.5054901,2.1112158,6.5801168),(44795,'forelimb',254,4,164,6.2453657,100.0522384,120.3949969,1.8,99.9740747,120.4500232,-1.2354253,3.2671798,4.8068227,5.713109,39.6375571,0.9281449,8.2461035,1.7486362,9.2422197,5.2016422,9.6560368,1.2068174,27.6832539),(44796,'forelimb',254,4,165,17.4074756,99.4016817,119.8542054,1.8,99.0824845,119.9543189,-1.3397867,4.0945791,5.67047,40.3204715,111.3315928,2.7491542,19.633574,9.8472811,25.8968101,7.6300303,10.7765202,1.160669,31.0164981),(44797,'forelimb',254,4,166,25.8718355,98.9501685,119.8868501,1.8,98.6623086,119.9807772,-1.3282845,4.2817,6.0670994,76.9327639,157.3686354,4.0633096,25.9380347,17.9678079,37.7858588,8.164072,11.3522236,1.056345,31.8758741),(44798,'forelimb',254,4,167,33.9968087,98.3021598,120.0364255,1.8,97.920884,120.222011,-1.1635752,5.3334191,6.0253309,129.2847285,199.4289589,4.7773283,33.0984245,24.240497,53.6876711,9.7227296,11.417094,1.2252407,39.5238865),(44799,'forelimb',254,4,168,37.6889407,97.7513697,120.2053784,1.8,97.2446916,120.2885627,-0.786696,5.5474653,5.3945371,176.9594721,237.9978207,3.1488973,44.1183025,31.899158,64.50508,10.1854688,11.7360686,1.1562895,35.9821227),(44800,'forelimb',254,4,169,45.7707771,96.768493,120.5611944,1.8,96.6806646,120.5746027,-0.4259102,5.1789711,5.9964613,215.1958195,373.8811446,1.3021236,62.3502976,41.551848,94.950319,10.1369988,12.5127034,0.2782997,36.2338281),(44801,'forelimb',254,4,170,46.0587467,96.5591818,120.7581151,1.8,96.5416258,120.7827692,-0.4728864,5.031563,6.2706046,207.6905484,429.1035191,1.5924185,68.4309647,41.2775415,100.4687446,9.8063806,12.9263977,0.2691675,37.4491693),(44802,'forelimb',254,4,171,43.9736385,96.4588315,120.9551407,1.8,96.4261188,120.9935302,-0.5167578,5.0440087,6.5295912,198.0130002,464.9075021,1.7889878,71.2000934,39.2570699,99.0256249,9.8725499,13.348021,0.5790743,37.7008747),(44803,'forelimb',254,4,172,43.8911137,96.4297943,121.0368026,1.8,96.4121658,121.0721647,-0.5397654,4.9615599,6.6287074,197.2680481,486.9182247,1.9321523,73.4559845,39.7592801,101.0040544,9.7173348,13.5879276,0.6055447,37.9525801),(44804,'forelimb',254,4,173,44.5208759,96.3478386,121.1979267,1.8,96.3533016,121.1937826,-0.562384,4.8410301,6.8134901,200.2844864,525.7232049,2.1096,77.1591649,41.3722868,104.4847682,9.5653022,13.8370211,0.6310794,38.9162159),(44805,'forelimb',254,4,174,45.379078,96.2921686,121.2825331,1.8,96.3699135,121.2694545,-0.5703506,4.7906777,6.9163553,205.0207619,564.5074722,2.2048284,81.6192119,42.7957747,108.2306512,9.4916058,13.943359,0.5880026,39.2721811),(44806,'forelimb',254,4,175,46.907941,96.262446,121.2781658,1.8,96.4060842,121.2117736,-0.5954774,4.7822924,7.210259,215.2278794,647.2417562,2.4596438,89.7667826,45.0051694,115.424022,9.493955,14.4377726,0.6375488,39.5238865),(44807,'forelimb',254,4,176,49.3106718,96.2707376,121.2952782,1.8,96.4440225,121.2006619,-0.6172214,4.9854671,7.4923798,232.2801776,726.6092078,2.7529854,96.9797618,46.5914574,122.3401414,9.7817025,14.9652379,0.6837093,40.9909331),(44808,'forelimb',254,4,177,53.8756086,96.4020167,121.204249,1.8,96.5375007,121.0855204,-0.6481112,5.1239465,7.9831398,267.1651839,863.108982,3.2723287,108.1164811,52.1405104,136.4278388,10.0118558,15.8461105,0.7086263,42.6054253),(44809,'forelimb',254,4,178,56.3089435,96.4436617,121.1899527,1.8,96.5899744,121.1532465,-0.6516053,5.1900458,8.0277528,284.4502548,946.2923728,3.45172,117.8776176,54.8068876,149.1826326,10.0977636,15.9853176,0.6327488,43.3173557),(44810,'forelimb',254,4,179,58.3614334,96.4571615,121.3479243,1.8,96.5793873,121.2809051,-0.6254026,5.3289801,8.1791128,311.3327672,1019.5008242,3.3336141,124.6468713,58.4225805,160.9908427,10.4175807,16.3337968,0.6171914,44.0724719),(44811,'forelimb',254,4,180,61.1469675,96.5064744,121.4542252,1.8,96.610743,121.455917,-0.5888444,5.5813331,8.1671582,331.0678997,1064.4928062,3.1436641,130.3382137,59.3169933,169.1529784,10.7276505,16.446445,0.5807564,44.3241773),(44812,'forelimb',254,4,181,63.6933754,96.547396,121.856994,1.8,96.6950588,121.7896925,-0.4993052,5.8404732,8.3658186,388.4667351,1085.817767,2.4337707,129.7921722,66.5128868,173.0847277,11.6167782,16.8073383,0.5667292,45.9386695),(44813,'forelimb',254,4,182,66.4836091,96.6154644,122.1758427,1.8,96.8241986,122.1588369,-0.3980547,6.3734634,8.0554008,452.2280544,1115.7471729,1.6649025,138.5092074,70.9548363,186.7787598,12.031264,16.7357822,0.5095923,46.4420803),(44814,'forelimb',254,4,183,68.7805963,96.6390781,122.5527289,1.8,96.962008,122.6168766,-0.2387691,6.781791,8.1760861,521.4405778,1170.7619062,0.6412124,143.1934412,76.888329,206.0864874,12.460952,16.5304274,0.4868992,47.4057161),(44815,'forelimb',254,4,184,67.1612637,96.5207361,122.6723246,1.8,96.9530375,122.7547001,-0.2228713,6.8748393,8.1402244,488.9880283,1186.5404484,0.5468564,145.7626212,71.127194,205.6943697,12.6416389,16.446445,0.3465389,47.8659411),(44816,'forelimb',254,4,185,64.8594649,96.1453947,122.7172241,1.8,96.6559284,122.8992936,-0.2451726,6.8638727,7.9800788,434.3836643,1118.0619695,0.636864,140.1066327,63.2855075,191.5017254,12.2166706,16.4688822,0.2639637,46.6505999),(44817,'forelimb',254,4,186,62.5794863,95.8197836,122.7857978,1.8,96.3396303,122.955818,-0.255701,6.4841475,8.0003715,385.7148409,1036.9196206,0.6672056,129.6089335,59.4858216,177.1748017,11.759357,16.3620316,0.2386093,45.5395185),(44818,'forelimb',254,4,187,58.3964575,95.2288509,122.8306854,1.8,95.6905336,123.0606752,-0.2926126,6.1568169,7.6276542,321.5381612,887.7062393,0.8098242,116.3799798,52.2247395,158.100183,11.171888,15.5283322,0.25169,43.2130959),(44819,'forelimb',254,4,188,56.1534052,94.8363487,122.905915,1.8,95.25199,123.1194158,-0.3261159,5.879624,7.3239193,291.2719502,781.7460054,0.9605454,106.7387518,49.539214,146.4579088,10.9844819,14.9467204,0.3217506,41.3900841),(44820,'forelimb',254,4,189,52.9637514,94.328961,122.9963736,1.8,94.5908672,123.2168981,-0.3776641,5.3965716,6.6935292,253.3521069,651.5614695,1.200306,97.3419927,46.9468628,133.223596,10.4486292,14.0751518,0.2153577,39.6713321),(44821,'forelimb',254,4,190,52.0802044,94.0006067,123.0491161,1.8,94.2274742,123.241217,-0.417121,5.0431915,6.432459,238.1250999,596.0822431,1.4246566,92.6678653,47.2171441,127.6848221,10.0505348,13.4582233,0.2914568,37.9525801),(44822,'forelimb',254,4,191,49.594669,93.7211141,123.0514842,1.8,93.9126771,123.2941832,-0.4733625,5.0394975,6.3040501,220.1349013,550.8970689,1.7178606,87.3878,43.6819149,120.8098842,9.9809786,13.0896253,0.4048918,37.5966149),(44823,'forelimb',254,4,192,49.2989225,93.5811382,123.0876801,1.8,93.756882,123.3265201,-0.4871514,5.0735345,6.1716667,214.704712,537.4784051,1.8004583,87.0880479,42.3185671,120.582505,9.8483398,12.7755427,0.3430239,36.9889443),(44824,'forelimb',254,4,193,48.2451786,93.447007,123.0949489,1.8,93.5775965,123.3015785,-0.5147847,5.1539376,6.2089858,218.9454149,526.5721105,1.9491536,84.808072,42.4811924,118.069223,10.0125082,12.6375032,0.9544994,37.3449095),(44825,'forelimb',254,4,194,47.7389518,93.3588729,123.0688165,1.8,93.5013595,123.2489902,-0.5545758,5.2502598,6.1989342,222.1843787,542.5879733,2.2062504,87.529236,42.3187395,119.5414453,10.0522232,12.8977995,1.047518,37.9525801),(44826,'forelimb',254,4,195,49.3575571,93.3772161,123.0113375,1.8,93.5477574,123.1809138,-0.5570359,5.2909458,6.3824253,232.7900971,586.1707028,2.2991955,91.8413727,43.9978231,126.4564189,10.1555231,13.0896253,0.4048918,38.2042855),(44827,'forelimb',254,4,196,48.5884259,93.3088356,122.9631826,1.8,93.5230483,123.1252989,-0.5805623,5.3812595,6.4600036,236.9389444,605.6133935,2.436271,93.748151,44.030388,125.3073118,10.260485,13.3272566,1.2082521,39.4196267),(44828,'forelimb',254,4,197,49.8677562,93.3160154,122.8783591,1.8,93.6087469,123.002649,-0.6122157,5.5644413,6.61434,257.4875958,654.9154898,2.7448838,99.0144876,46.2737556,123.4166433,10.5361811,14.1340576,1.2298174,41.2426385),(44829,'forelimb',254,4,198,52.0283956,93.384116,122.7864082,1.8,93.7184368,122.912446,-0.6410515,5.8427769,6.7961978,281.2323168,708.1031541,3.1013264,104.1910743,48.1333315,128.2221623,10.9427071,14.6850235,1.2120257,42.3537199),(44830,'forelimb',254,4,199,54.6176605,93.5649379,122.6204288,1.8,93.8929871,122.7443987,-0.6669696,6.1358856,7.0078737,327.3630361,803.2217044,3.4834748,114.6170345,53.3522064,141.036747,11.6315189,15.240301,1.1955255,45.0361077),(44831,'forelimb',254,4,200,57.1288205,93.7305559,122.4816305,1.8,94.071662,122.6199964,-0.6716399,6.4592125,7.4159344,358.8132313,899.4740798,3.6869098,121.2893794,55.5506155,152.0294406,11.9002856,15.6408793,1.2055949,46.5031543),(44832,'forelimb',254,4,201,61.2420808,94.0563866,122.2727251,1.8,94.397877,122.403873,-0.667369,6.6910126,7.87449,408.6615651,1078.8071176,3.9099392,137.000252,61.076191,183.9431787,12.1736007,15.9910916,0.5358112,48.5778715),(44833,'forelimb',254,4,202,62.2863134,94.1505226,122.1842418,1.8,94.6071873,122.2693541,-0.673247,6.7644579,7.9969989,413.3793454,1179.0574056,4.0360169,147.4374844,61.1104915,189.3755346,12.1487383,16.5806127,0.5448639,49.7932127),(44834,'forelimb',254,4,203,62.7250097,94.1981357,122.1142036,1.8,94.7228712,122.1035117,-0.6649794,6.8032748,8.159316,393.5485719,1258.8143288,3.9803407,154.2793941,57.8469316,196.5944022,12.0686079,17.1121594,0.4973427,50.1491779),(44835,'forelimb',254,4,204,62.1837588,94.1771607,122.0530624,1.8,94.7246884,122.0201665,-0.6749929,6.7804498,8.2755973,375.2811548,1294.5342064,4.0470197,156.4278882,55.3475312,200.0005596,11.9583637,17.1713991,0.5532943,50.5051431),(44836,'forelimb',254,4,205,60.041135,93.9987685,122.1389421,1.8,94.4779785,122.1414501,-0.6745169,6.5569704,8.2004649,334.9950564,1228.3403752,3.9029276,149.7891138,51.0899147,188.6361057,11.4781571,17.0418833,0.5880026,48.3261661),(44837,'forelimb',254,4,206,58.9235533,93.844543,122.2604174,1.8,94.239786,122.2950642,-0.6594269,6.3104668,8.0700962,310.4156271,1162.1548705,3.6862297,144.0075613,49.190597,179.2657007,11.0325576,16.6860637,0.6022873,46.3557087),(44838,'forelimb',254,4,207,55.4159411,93.4037717,122.6010434,1.8,93.6426168,122.7099281,-0.6293758,5.9835485,7.5348981,276.2073934,953.0032798,3.200246,126.4785882,46.1611353,158.0757399,10.5603144,15.7350314,0.9600704,43.3173557),(44839,'forelimb',254,4,208,53.1139186,93.110811,122.7300291,1.8,93.3410749,122.8413786,-0.627962,5.7992675,7.4662706,248.954596,863.3235587,3.0554,115.629824,42.9286278,146.2000272,10.2347439,15.3007547,0.6659692,42.1020145),(44840,'forelimb',254,4,209,50.9198217,92.811651,122.8552414,1.8,93.0491097,123.0025215,-0.6207491,5.5241283,7.2731446,220.7106841,775.3678305,2.8711187,106.6069591,39.9539392,136.5396743,9.8576519,14.7852638,0.6202495,40.2790027),(44841,'forelimb',254,4,210,50.3809207,92.6655286,122.9577785,1.8,92.8769272,123.0855122,-0.6071829,5.1661379,7.1981393,212.7301081,733.02729,2.7334535,101.8356638,41.1777838,131.2652121,9.5107582,14.5397175,0.5961991,39.7755919),(44842,'forelimb',254,4,211,49.441089,92.4640023,123.0293428,1.8,92.6261051,123.1805788,-0.5992867,4.8596206,6.9174844,197.3775974,684.8565351,2.6216669,99.0036983,40.6158455,127.3299531,9.1631333,14.3028672,0.5713375,38.5602507),(44843,'forelimb',254,4,212,48.7657843,92.3050733,123.0883392,1.8,92.4917493,123.2266377,-0.6042325,4.6634435,6.7261483,186.6220321,654.776436,2.6233752,97.3479035,40.0180748,124.3188641,8.8432556,13.943359,0.5880026,38.0568399),(44844,'forelimb',254,4,213,48.9884054,92.2095451,123.1401803,1.8,92.3886112,123.2787203,-0.5974004,4.6670177,6.5939835,181.6712529,630.5348108,2.583327,95.6227469,38.9266257,120.3467277,8.8432556,13.7096736,0.5619216,37.7008747),(44845,'forelimb',254,4,214,49.397113,92.1275693,123.1757522,1.8,92.3211222,123.3059721,-0.5973879,4.5701254,6.5682007,176.3348623,617.0017472,2.6047838,93.9377124,38.5842504,120.6405222,8.5891788,13.5879276,0.6055447,37.4491693),(44846,'forelimb',254,4,215,49.9253278,92.0416277,123.2265747,1.8,92.202982,123.335205,-0.6060102,4.3485716,6.450984,171.9750697,594.8353585,2.6995942,92.2084693,39.5474845,115.024658,8.3520181,13.4238823,0.6947383,36.4855335),(44847,'forelimb',254,4,216,49.8857159,91.9553288,123.270322,1.8,92.1477328,123.3690812,-0.615699,4.3778398,6.455067,168.5109814,579.1856661,2.7731476,89.7257401,38.4918105,110.7435618,8.3520181,13.4238823,0.8760581,36.4855335),(44848,'forelimb',254,4,217,50.1387174,91.8536181,123.3095818,1.8,91.9735482,123.3803888,-0.6288565,4.1743327,6.5820661,161.6846437,559.9957921,2.89136,85.0790288,38.7330515,106.6332623,8.1148574,13.4238823,0.6947383,35.8778629),(44849,'forelimb',254,4,218,50.336609,91.7717761,123.3313638,1.8,91.8749196,123.3812512,-0.6407462,3.9645388,6.5096858,155.5244117,547.684217,2.9980267,84.1337413,39.2288792,105.5083882,7.8828361,13.2369013,0.6240231,35.3744521),(44850,'forelimb',254,4,219,50.2728272,91.6919318,123.3455052,1.8,91.767421,123.3911909,-0.6573112,3.8335997,6.5892434,145.9881388,528.5195321,3.1278865,80.2094415,38.0812162,100.3665002,7.72709,13.2369013,0.6240231,34.7667815),(44851,'forelimb',254,4,220,50.2156473,91.6173517,123.3745373,1.8,91.7107348,123.4268144,-0.6660249,3.8574496,6.5964624,140.6669631,514.014879,3.195034,77.9228085,36.466313,97.7971501,7.72709,13.1529455,0.6696389,34.7667815),(44852,'forelimb',254,4,221,50.2936961,91.526924,123.4015127,1.8,91.5982253,123.4092077,-0.6810491,3.6876789,6.6964255,132.8479804,496.216224,3.322794,74.1016571,36.0248228,92.8882895,7.6194069,13.1529455,0.6696389,34.1591109),(44853,'forelimb',254,4,222,50.3630729,91.464986,123.4346286,1.8,91.5790227,123.4172718,-0.6925747,3.6925004,6.7735683,128.7814908,484.370054,3.4222444,71.5088457,34.8765,89.6787934,7.6194069,13.1529455,0.6696389,34.1591109),(44854,'forelimb',254,4,223,49.4406973,91.3729431,123.4575216,1.8,91.4274296,123.4414471,-0.7043195,3.6271114,6.5877062,120.8143429,459.9800827,3.4548847,69.8240132,33.3086941,87.397397,7.4692428,12.89064,0.6435011,33.5514403),(44855,'forelimb',254,4,224,48.8316922,91.3021707,123.4902066,1.8,91.3875523,123.4358775,-0.7132722,3.5032443,6.6643254,116.8483255,444.2800149,3.4843358,66.6654142,33.3543184,83.5713052,7.4692428,12.89064,0.6435011,33.2997349),(44856,'forelimb',254,4,225,47.7852776,91.2470742,123.523447,1.8,91.3278101,123.4698623,-0.7215442,3.5013101,6.6898046,112.033042,422.2303722,3.4749414,63.1155018,31.9974638,79.4527577,7.4692428,12.8188253,0.6904465,33.2997349),(44857,'forelimb',254,4,226,47.1003497,91.2048499,123.5505481,1.8,91.2798579,123.5264708,-0.7239687,3.5051633,6.7410183,109.0868665,409.1147907,3.4440167,60.6903542,31.121764,76.5111875,7.4692428,12.8188253,0.6904465,32.9437697),(44858,'forelimb',254,4,227,46.2356575,91.1738485,123.5583485,1.8,91.2422719,123.5239294,-0.7290369,3.4820151,6.486338,105.5875248,393.2419514,3.4195738,60.6261889,30.3236837,76.5818385,7.3785448,12.5495381,0.9067502,32.6920643),(44859,'forelimb',254,4,228,45.6926163,91.1486449,123.5800725,1.8,91.2181758,123.5437489,-0.7319583,3.4860082,6.520415,103.6249128,385.7431081,3.4015245,59.1592874,29.7259521,74.7519991,7.3785448,12.5495381,0.9067502,32.3360991),(44860,'forelimb',254,4,229,44.9658385,91.1393289,123.5916189,1.8,91.2362738,123.5407776,-0.7365004,3.465665,6.5362184,100.5112586,375.8591176,3.3812824,57.5040634,29.0020123,72.6021041,7.2719466,12.5495381,0.9067502,32.3360991),(44861,'forelimb',254,4,230,44.3823461,91.1309014,123.6050195,1.8,91.2210338,123.5760463,-0.73772,3.4725196,6.5517557,98.7488902,369.2017948,3.3463852,56.3515814,28.4372451,71.3773766,7.2719466,12.4905505,0.7123576,32.3360991),(44862,'forelimb',254,4,231,43.6470641,91.1431715,123.6082314,1.8,91.2329458,123.5824912,-0.7359293,3.4252062,6.2559444,96.544192,361.5565027,3.2779802,57.7940719,28.1863881,72.6870945,7.2210815,12.2893773,0.9342881,31.8326883),(44863,'forelimb',254,4,232,43.366144,91.1560074,123.6135698,1.8,91.2590251,123.5750399,-0.733812,3.4132096,6.2501004,95.6587593,358.8287152,3.2416578,57.4116722,28.0260435,72.1540144,7.2210815,12.2893773,0.9342881,31.8326883),(44864,'forelimb',254,4,233,42.8432444,91.1938196,123.5991664,1.8,91.2942936,123.5522119,-0.7296399,3.3659667,6.2124017,93.4363802,354.9500778,3.1729512,57.1357253,27.7591516,71.5749919,7.1152663,12.2893773,0.9342881,31.4767231),(44865,'forelimb',254,4,234,42.5740737,91.217604,123.603888,1.8,91.296799,123.5634865,-0.7250408,3.3451779,6.1976362,92.7441039,353.3286913,3.1206022,57.0102339,27.7247151,71.971914,7.1152663,12.2140278,0.6857295,31.4767231),(44866,'forelimb',254,4,235,42.3657755,91.282329,123.5973429,1.8,91.4082,123.5384688,-0.7184972,3.3053649,6.1441158,91.6956322,350.648115,3.0595047,57.0705574,27.741455,71.9487849,7.0337423,12.2140278,0.8850668,31.1207579),(44867,'forelimb',254,4,236,42.3094348,91.3170532,123.6029624,1.8,91.4348179,123.553679,-0.7106556,3.2988368,6.1202356,91.3971512,351.2837934,3.0006947,57.3971029,27.7058725,72.226281,7.0337423,12.2140278,0.8850668,31.4767231),(44868,'forelimb',254,4,237,42.2079433,91.3953746,123.5984614,1.8,91.5057988,123.5739592,-0.7011955,3.2812024,6.0552518,90.5436664,350.8188394,2.9277878,57.9362921,27.5946607,72.6651976,6.9177932,12.2140278,0.8850668,31.1207579),(44869,'forelimb',254,4,238,42.1777308,91.431751,123.607929,1.8,91.523544,123.6001346,-0.6964779,3.1943301,6.0318794,90.4871017,350.9490224,2.893025,58.1823669,28.3274108,72.8777355,6.9165695,12.2140278,0.8850668,30.8690525),(44870,'forelimb',254,4,239,42.04032,91.4898931,123.5966878,1.8,91.5714271,123.5838132,-0.6909486,3.1645154,5.9777618,89.8865843,349.4844768,2.8455069,58.4641025,28.404534,73.0967234,6.9165695,12.2140278,0.8850668,30.8690525),(44871,'forelimb',254,4,240,41.9099588,91.5316413,123.5993757,1.8,91.6130623,123.5711073,-0.6871878,3.1351241,5.945522,89.3778581,347.0627875,2.8109002,58.3738125,28.508555,72.9119013,6.8477792,12.1685942,0.8353566,30.8690525),(44872,'forelimb',254,4,241,41.7709255,91.6025672,123.5918708,1.8,91.6637982,123.5754637,-0.6840106,3.2439967,5.9457445,88.5377555,343.8944268,2.7798953,57.8387497,27.2928007,72.725711,6.8804128,12.1685942,0.7354398,31.1207579),(44873,'forelimb',254,4,242,41.7018844,91.6445401,123.6002595,1.8,91.7428243,123.5726917,-0.6809499,3.2058729,5.9185762,88.2474287,342.8829947,2.7544774,57.9333582,27.526802,72.8434764,6.8804128,12.1685942,0.7354398,31.4767231),(44874,'forelimb',254,4,243,41.502482,91.7267527,123.5901027,1.8,91.8639793,123.5550631,-0.6769256,3.221328,5.8481258,87.1559359,338.823367,2.7140983,57.9370861,27.055902,72.8369359,6.7932935,11.9465628,0.6578886,30.8690525),(44875,'forelimb',254,4,244,41.3848212,91.7634604,123.5988341,1.8,91.8863345,123.5726082,-0.6748603,3.1894847,5.8247912,86.4704287,336.9446683,2.6924991,57.846652,27.1110967,72.681579,6.7443616,11.9465628,0.6578886,30.6173471),(44876,'forelimb',254,4,245,41.2071272,91.8236294,123.5898447,1.8,91.9274249,123.5630426,-0.6722898,3.1564836,5.7718452,85.2791307,332.5457984,2.6637242,57.615162,27.0171309,72.3678063,6.7443616,11.8845829,0.7086263,30.6173471),(44877,'forelimb',254,4,246,41.1870974,91.8669546,123.5981795,1.8,91.9636172,123.5619121,-0.6697037,3.1205918,5.7426614,84.9123562,330.366493,2.6451397,57.5284649,27.2103371,72.2743616,6.6464977,11.8845829,0.7086263,30.6173471),(44878,'forelimb',254,4,247,41.0043119,91.9376172,123.5997148,1.8,91.9597622,123.5868887,-0.6675627,3.0840485,5.6876941,83.7626634,325.8919588,2.6191658,57.2977297,27.1599693,71.9557273,6.644067,11.8845829,0.7086263,30.6173471),(44879,'forelimb',254,4,248,40.9250881,91.9876266,123.6069427,1.8,92.0655517,123.5633799,-0.6668143,3.2302431,5.7245704,83.3910018,323.1200755,2.6091426,56.4444235,25.8157044,70.9054569,6.6918932,11.8845829,0.7086263,30.8690525),(44880,'forelimb',254,4,249,40.7626122,92.0660913,123.6021409,1.8,92.168076,123.5811509,-0.6677746,3.187141,5.6596827,82.4878335,317.9690333,2.6051276,56.1814236,25.8814506,70.6732462,6.6883468,11.6887773,0.6287963,30.9733123),(44881,'forelimb',254,4,250,40.6836121,92.1110363,123.6126087,1.8,92.2139715,123.6078015,-0.6664436,3.1488352,5.6311858,81.9291486,314.7863978,2.5913048,55.9005528,26.0188749,70.3907769,6.644067,11.6887773,0.6287963,30.3656417),(44882,'forelimb',254,4,251,40.5535866,92.1893221,123.6049758,1.8,92.2722028,123.6077934,-0.6649936,3.1040726,5.5651995,81.3253555,311.3173532,2.5735018,55.9400169,26.199566,70.5163142,6.6464977,11.6887773,0.6287963,30.3656417),(44883,'forelimb',254,4,252,40.4149449,92.2342379,123.6118687,1.8,92.3057624,123.6104621,-0.6637044,3.1426309,5.5342924,80.979099,308.3421863,2.5562734,55.7148348,25.7679316,70.3246465,6.7087746,11.6095305,0.6805212,30.3656417),(44884,'forelimb',254,4,253,40.1698882,92.3146593,123.6070208,1.8,92.3466651,123.630637,-0.6632128,3.0964457,5.536649,80.0500789,303.3854196,2.5375791,54.7958557,25.8522473,69.2003339,6.7087746,11.6095305,0.6805212,30.0096765),(44885,'forelimb',254,4,254,40.0824399,92.360093,123.6138417,1.8,92.3989831,123.655104,-0.6631181,3.1792777,5.5682348,79.8852078,300.9934571,2.5314416,54.0554538,25.126842,68.3641543,6.6883468,11.6887773,0.6287963,30.2613819),(44886,'forelimb',254,4,255,39.9120751,92.443463,123.5962607,1.8,92.5062689,123.6281506,-0.6629919,3.1415121,5.4340797,79.1307029,295.2054225,2.519867,54.3248242,25.1887308,68.4391713,6.6883468,11.4413255,0.5984189,29.7579711),(44887,'forelimb',254,4,256,39.7742727,92.4936515,123.5995632,1.8,92.5778583,123.6156091,-0.6633845,3.1828977,5.4177126,78.6943094,291.1893514,2.5136921,53.7476554,24.7241093,68.1360573,6.778989,11.4413255,0.5984189,29.4020059),(44888,'forelimb',254,4,257,39.5161798,92.5613215,123.5882654,1.8,92.5922552,123.6055375,-0.6637482,3.150738,5.4041525,77.9064141,285.423128,2.4997059,52.8155211,24.7264018,67.0966888,6.778989,11.3440887,0.6510767,29.4020059),(44889,'forelimb',254,4,258,39.3756918,92.6024017,123.5939025,1.8,92.5950096,123.6275727,-0.6638758,3.1211989,5.4330778,77.4776124,282.5595538,2.4916313,52.0072713,24.8230293,66.1583714,6.6775148,11.3440887,0.6510767,29.4020059),(44890,'forelimb',254,4,259,39.2170204,92.681275,123.5845386,1.8,92.6794459,123.6238459,-0.6638715,3.0799676,5.5009679,76.7561263,278.2229412,2.4815638,50.5770883,24.9210822,64.4520326,6.6775148,11.5617216,0.7328151,30.0096765),(44891,'forelimb',254,4,260,39.1085352,92.7291923,123.5850265,1.8,92.7875776,123.5846654,-0.6632317,3.0563954,5.3923491,76.3228506,275.1538492,2.4706517,51.0267125,24.9715235,64.9185709,6.6775148,11.2787985,0.7044941,29.7579711),(44892,'forelimb',254,4,261,38.933135,92.8199752,123.5795255,1.8,92.8940521,123.5844473,-0.6610235,3.0696562,5.3916112,75.5738688,270.5084934,2.445676,50.1721069,24.6196526,64.1857424,6.6775148,11.3440887,0.6510767,29.1503005),(44893,'forelimb',254,4,262,38.8470854,92.8637481,123.580613,1.8,92.940391,123.5886599,-0.6606074,3.1539615,5.3828915,75.226632,268.9283301,2.4376594,49.9598273,23.8514743,63.9070763,6.6775148,11.3440887,0.6510767,29.4020059),(44894,'forelimb',254,4,263,38.6021966,92.9173625,123.5672308,1.8,92.977765,123.5751896,-0.658415,3.1265121,5.4338223,74.7553521,264.8421514,2.4086323,48.739568,23.910143,62.4666169,6.6775148,11.3440887,0.6510767,29.4020059),(44895,'forelimb',254,4,264,38.3970315,92.9559701,123.5689977,1.8,93.0021762,123.5816389,-0.6603466,3.1059458,5.3871003,74.3034185,261.7664625,2.4078016,48.5913474,23.9229603,62.1801241,6.6775148,11.2787985,0.7044941,29.4020059),(44896,'forelimb',254,4,265,37.9863097,93.0223406,123.550495,1.8,93.0638541,123.5402964,-0.6620295,3.0836113,5.2621259,73.3139264,255.1771942,2.3923732,48.4931756,23.7753462,62.0506251,6.6775148,11.0889478,0.6202495,29.1503005),(44897,'forelimb',254,4,266,37.8105738,93.0656271,123.5523539,1.8,93.1076604,123.5582167,-0.6645403,3.1343154,5.2203204,72.9908479,252.130971,2.3966585,48.2979879,23.2876525,62.2797021,6.7700883,11.0053826,0.6747409,29.1503005),(44898,'forelimb',254,4,267,37.5844838,93.1450429,123.5357122,1.8,93.2292312,123.5309451,-0.6667746,3.1018221,5.292967,72.3514072,246.6814526,2.3959239,46.6055153,23.3254531,60.2702949,6.6843766,11.0889478,0.6202495,28.1866647),(44899,'forelimb',254,4,268,37.4720263,93.1846106,123.5347935,1.8,93.2437526,123.530202,-0.6676883,3.0979609,5.3245448,72.0962466,243.9971674,2.3943028,45.8249812,23.2721618,59.3561333,6.6843766,11.0889478,0.6202495,28.1866647),(44900,'forelimb',254,4,269,37.3220829,93.2644441,123.5245625,1.8,93.3194942,123.5068969,-0.6667467,3.0692134,5.3217622,71.6931911,239.4028149,2.3790277,44.9856283,23.3588163,58.2275052,6.6775148,11.0053826,0.6747409,28.5426299),(44901,'forelimb',254,4,270,37.2142691,93.3097235,123.523761,1.8,93.3529953,123.5127232,-0.6685916,3.0942605,5.1631167,71.5849787,236.2232816,2.3832823,45.7520713,23.1347616,59.3339909,6.6843766,10.8448348,0.5880026,28.2909245),(44902,'forelimb',254,4,271,36.9373774,93.3847185,123.5035546,1.8,93.4118328,123.5104541,-0.6682147,3.1253416,5.1636458,70.8820389,231.0247918,2.3632923,44.7406347,22.6797733,58.2671045,6.6843766,10.7422,0.6435011,28.2909245),(44903,'forelimb',254,4,272,36.834655,93.4309522,123.5007477,1.8,93.4564067,123.500837,-0.6689766,3.150905,5.2017069,70.7723018,228.2156455,2.3612705,43.8732225,22.4609445,57.3665784,6.7237639,10.7422,0.6435011,28.5426299),(44904,'forelimb',254,4,273,36.5178716,93.4965727,123.4845566,1.8,93.5451664,123.4771131,-0.6694914,3.1080616,5.1929546,70.1323088,222.6079331,2.3440125,42.8672982,22.5646458,55.9843003,6.618243,10.6732285,0.6998929,28.1866647),(44905,'forelimb',254,4,274,36.2967611,93.5366027,123.4845847,1.8,93.5746679,123.4896363,-0.6723127,3.1316147,5.2259638,69.7136203,219.6713708,2.3464418,42.0346139,22.2612378,55.0445265,6.644067,10.6732285,0.6998929,28.1866647),(44906,'forelimb',254,4,275,35.9637525,93.5979364,123.4708747,1.8,93.6201776,123.5063494,-0.6750284,3.0232991,5.0823629,68.7178891,214.8512064,2.3407872,42.2738811,22.729438,55.6156483,6.5951351,10.4900209,0.610726,27.6832539),(44907,'forelimb',254,4,276,35.7680988,93.6386916,123.4677542,1.8,93.6597943,123.5124443,-0.678257,3.0400821,5.0497292,68.546228,211.0876862,2.3468459,41.801783,22.5474923,54.7703873,6.6193247,10.4016451,0.6682894,27.6832539),(44908,'forelimb',254,4,277,35.48578,93.7013585,123.4458019,1.8,93.7316204,123.4794864,-0.6815246,3.0561553,5.1127108,67.9230827,206.1449731,2.3472187,40.3200923,22.2250101,53.5910786,6.6193247,10.4900209,0.610726,28.0392191),(44909,'forelimb',254,4,278,35.3647623,93.7434782,123.4424763,1.8,93.810098,123.4524316,-0.6828138,3.0777155,5.0854047,67.8685121,203.4980087,2.3466511,40.0160895,22.0515875,52.8753795,6.6193247,10.4016451,0.6682894,28.0392191),(44910,'forelimb',254,4,279,35.0673932,93.79788,123.4289739,1.8,93.8475554,123.4190224,-0.6854747,3.0967487,4.9264971,67.2358552,199.4743739,2.3421535,40.4901028,21.7117569,53.4983576,6.6193247,10.2496576,0.5763752,27.4315485),(44911,'forelimb',254,4,280,34.9258422,93.8365005,123.4301151,1.8,93.8775542,123.4286508,-0.6855292,3.1219833,4.9556547,67.0528714,197.1784229,2.3330099,39.7885718,21.4776523,53.2158093,6.6345522,10.2496576,0.5763752,27.4315485),(44912,'forelimb',254,4,281,34.6726729,93.90528,123.408982,1.8,93.91686,123.4267229,-0.6895157,3.1422897,4.962719,66.6001129,193.5324988,2.3386953,38.9972711,21.1947719,52.2536678,6.6477589,10.1410009,0.6350267,27.4315485),(44913,'forelimb',254,4,282,34.5055531,93.9454853,123.4058513,1.8,93.9445818,123.4313432,-0.690573,3.1636535,4.995967,66.3197063,191.4551917,2.3333935,38.3219492,20.9630121,51.4839499,6.7623766,10.1410009,0.6350267,27.6832539),(44914,'forelimb',254,4,283,34.2446628,94.0162095,123.382548,1.8,94.0563594,123.361081,-0.6909741,3.1900842,4.7915726,65.628795,186.8292889,2.3179994,38.9912261,20.5727466,52.6194931,6.793346,10.0679117,0.6947383,27.6832539),(44915,'forelimb',254,4,284,34.0921458,94.0588564,123.3794643,1.8,94.1207692,123.3554676,-0.6934001,3.1551717,4.8259886,65.2141628,184.2222279,2.3212217,38.1729516,20.668974,51.6515349,6.7087746,10.0679117,0.6947383,27.3272887),(44916,'forelimb',254,4,285,33.8903936,94.1187549,123.3521405,1.8,94.1703582,123.3076772,-0.6956353,3.1703371,4.889074,64.4355979,180.8500327,2.3199022,36.9906519,20.3245256,50.1262407,6.7087746,10.1410009,0.6350267,26.9713235),(44917,'forelimb',254,4,286,33.7746351,94.1608144,123.3475163,1.8,94.228987,123.3124988,-0.6948727,3.1944352,4.8695622,64.312602,178.8742024,2.3077551,36.7331177,20.1326986,49.4829816,6.7509818,10.0679117,0.6947383,27.3272887),(44918,'forelimb',254,4,287,33.4944983,94.2237136,123.329959,1.8,94.2690411,123.2979255,-0.6977046,3.2188081,4.9301019,63.6497292,175.049526,2.3041719,35.5062692,19.7743163,48.3019204,6.7509818,10.0679117,0.6947383,27.3272887),(44919,'forelimb',254,4,288,33.3234622,94.2645685,123.3268464,1.8,94.3115959,123.3106158,-0.6981253,3.0190935,4.6873461,63.0306922,172.5404945,2.294707,36.8098475,20.8773571,49.7523972,6.5604958,9.798394,0.6610432,26.8238779),(44920,'forelimb',254,4,289,33.1552234,94.3266619,123.3101974,1.8,94.416236,123.2945126,-0.6986224,3.0454058,4.7455927,63.0327978,169.3541545,2.2858274,35.6866178,20.6976681,48.570099,6.6193247,9.8921606,0.6000502,26.8238779),(44921,'forelimb',254,4,290,32.9701441,94.3641337,123.3040804,1.8,94.4608387,123.2860154,-0.7006043,3.0615059,4.778084,62.7181531,167.0917507,2.2837981,34.9704506,20.4860471,47.7621015,6.6193247,9.8921606,0.6000502,26.4679127),(44922,'forelimb',254,4,291,32.7239684,94.421209,123.2778493,1.8,94.5014975,123.259072,-0.7008647,3.0778278,4.7872951,62.2208225,163.7446499,2.2681456,34.2040019,20.2158229,46.9312839,6.6193247,9.798394,0.6610432,26.4679127),(44923,'forelimb',254,4,292,32.6073706,94.4559536,123.2699968,1.8,94.5014975,123.259072,-0.7025686,3.0915271,4.8197548,62.0510726,161.9359444,2.2691948,33.5983784,20.0713337,46.2349207,6.6193247,9.798394,0.6610432,26.4679127),(44924,'forelimb',254,4,293,32.4079123,94.5188782,123.2500156,1.8,94.56264,123.2694203,-0.7035556,3.1154275,4.6528434,61.7971849,158.4263164,2.2605728,34.049355,19.8358607,46.858727,6.6477589,9.807811,0.5028432,26.2162073),(44925,'forelimb',254,4,294,32.2223854,94.5506903,123.243998,1.8,94.592744,123.257413,-0.7052702,3.1288351,4.6315081,61.6109678,156.3372058,2.2567192,33.7551405,19.6913438,46.1539562,6.6477589,9.6560368,0.5633163,26.2162073),(44926,'forelimb',254,4,295,31.9611594,94.5976055,123.2294991,1.8,94.6189502,123.2427816,-0.7066506,3.1461827,4.6767471,61.2724299,153.6030742,2.2456846,32.8439982,19.475166,45.9162,6.6589405,9.7417008,0.7229794,26.4679127),(44927,'forelimb',254,4,296,31.8093137,94.6348321,123.2208776,1.8,94.6745893,123.2188631,-0.7090179,3.1603907,4.7107961,61.0989251,151.9075485,2.247415,32.2466829,19.3327126,45.2137971,6.6589405,9.7417008,0.7229794,26.4679127),(44928,'forelimb',254,4,297,31.4939291,94.6947952,123.1944489,1.8,94.7655821,123.1620612,-0.7114526,3.1760038,4.4930262,60.5910993,149.0158311,2.2377682,33.166028,19.0777795,45.4269592,6.6589405,9.5406219,0.625485,25.8602421),(44929,'forelimb',254,4,298,31.3377194,94.7240404,123.187017,1.8,94.7749626,123.1462124,-0.7116583,3.18919,4.5199642,60.4888927,147.6509509,2.2277315,32.6663983,18.9668516,45.9358679,6.6589405,9.5406219,0.625485,25.8602421),(44930,'forelimb',254,4,299,31.1815657,94.7746832,123.1673871,1.8,94.8060233,123.1519509,-0.7153874,3.2024916,4.5698517,60.3645607,145.8060139,2.2358108,31.9060713,18.8492489,44.9816207,6.6680938,9.6560368,0.5633163,25.8602421),(44931,'forelimb',254,4,300,31.0607717,94.8071168,123.1575465,1.8,94.8380393,123.1384705,-0.7151017,3.2167058,4.558211,60.3374699,144.6132342,2.2256848,31.7258756,18.7575343,44.6097328,6.6680938,9.5406219,0.625485,26.2162073),(44932,'forelimb',254,4,301,30.7846633,94.866419,123.1346278,1.8,94.9035307,123.1276039,-0.7130762,3.2407709,4.6175596,60.0746403,142.3909816,2.1956135,30.8368477,18.537145,43.5483512,6.6680938,9.5406219,0.625485,26.2162073),(44933,'forelimb',254,4,302,30.6742759,94.8992447,123.1246937,1.8,94.9473528,123.1030441,-0.7146068,3.2529018,4.6062273,60.0857547,140.5926953,2.1954851,30.5223096,18.4714319,42.9023322,6.6680938,9.4628966,0.6889244,26.2162073),(44934,'forelimb',254,4,303,30.4927213,94.9426711,123.0889857,1.8,94.9871424,123.0473345,-0.7136065,3.2555278,4.4239444,59.8456071,138.2815731,2.1774584,31.2575295,18.3827663,44.2874209,6.6680938,9.2955727,0.5880026,25.6085367),(44935,'forelimb',254,4,304,30.3160902,94.9705354,123.081799,1.8,95.0189243,123.0363358,-0.717169,3.264351,4.4492343,59.7565488,136.974145,2.1826694,30.7860037,18.3057979,43.7612683,6.6680938,9.2955727,0.5880026,25.2525715),(44936,'forelimb',254,4,305,30.199996,95.0320395,123.057676,1.8,95.0835695,123.0150151,-0.7171081,3.2866585,4.4699874,59.9564748,136.167415,2.1740076,30.4625946,18.2423804,43.096413,6.6843766,9.4237936,0.7531513,25.5042769),(44937,'forelimb',254,4,306,30.1395151,95.0627445,123.0453826,1.8,95.1196233,122.9998951,-0.7162441,3.2984613,4.5008355,60.0311745,135.8893203,2.1653545,30.1920209,18.1997511,42.7893458,6.6843766,9.4628966,0.6889244,25.5042769),(44938,'forelimb',254,4,307,29.9822424,95.1033566,123.0118401,1.8,95.1449545,122.9852994,-0.7145875,3.3014352,4.5527668,59.6881922,134.2956669,2.1458579,29.4975941,18.0794682,42.4095772,6.6843766,9.4628966,0.6889244,25.5042769),(44939,'forelimb',254,4,308,29.8923883,95.1312853,123.0018157,1.8,95.1577726,122.9718738,-0.7136352,3.31306,4.3423235,59.7032577,133.4580444,2.1347308,30.7342471,18.0205785,43.7593849,6.6843766,9.2955727,0.5880026,25.2525715),(44940,'forelimb',254,4,309,29.6654591,95.1681232,122.9800674,1.8,95.2129936,122.9666968,-0.7111913,3.3229126,4.3405757,59.5751066,131.9943622,2.1065702,30.4094135,17.9285805,42.8409982,6.8821766,9.2955727,0.5880026,25.5042769),(44941,'forelimb',254,4,310,29.5079626,95.1924153,122.9726543,1.8,95.2337014,122.9787764,-0.7112837,3.3330729,4.3638273,59.5454113,131.1624668,2.0958359,30.0567503,17.8650189,42.6520862,6.8821766,9.2955727,0.5880026,25.5042769),(44942,'forelimb',254,4,311,29.3729576,95.2186807,122.9525184,1.8,95.2360483,122.9921744,-0.7133659,3.3332259,4.3970676,59.4887657,129.7214541,2.0963314,29.5018105,17.8472051,42.0253746,6.9021573,9.2955727,0.5880026,25.5042769),(44943,'forelimb',254,4,312,29.2706268,95.242084,122.9400827,1.8,95.2850466,122.9531421,-0.7144314,3.3382686,4.42299,59.3485881,128.6731738,2.0941734,29.0918977,17.7782544,42.4107064,6.9021573,9.2955727,0.5880026,25.5042769),(44944,'forelimb',254,4,313,29.0030786,95.2708556,122.9094464,1.8,95.3205829,122.9328599,-0.7175614,3.2903418,4.4238504,58.5741951,126.7615598,2.0900157,28.6541244,17.8018571,41.4127964,6.6843766,9.4237936,0.7531513,25.5042769),(44945,'forelimb',254,4,314,28.8677938,95.2902207,122.9003109,1.8,95.3518342,122.924365,-0.7197226,3.295842,4.445887,58.4689777,125.6198509,2.0905724,28.2552954,17.7402245,40.9558665,6.6843766,9.4237936,0.7531513,25.1483117),(44946,'forelimb',254,4,315,28.6884213,95.3250166,122.8663339,1.8,95.3871701,122.8925509,-0.7201505,3.0890416,4.3175513,57.8586258,123.7710061,2.0796109,28.6669452,18.7302838,41.149503,6.3805413,9.1957248,0.6528466,24.6449009),(44947,'forelimb',254,4,316,28.5691379,95.3414819,122.8555643,1.8,95.3961071,122.8764451,-0.7192177,3.0933285,4.2984317,57.7476321,122.6042316,2.066561,28.5230151,18.6684448,41.7911947,6.3805413,9.1957248,0.6528466,24.6449009),(44948,'forelimb',254,4,317,28.3757781,95.3695732,122.8186634,1.8,95.4178172,122.8492435,-0.7181607,3.0857488,4.2755915,57.3836124,120.3952222,2.0476197,28.1587287,18.5963332,40.941326,6.3805413,9.1352922,0.71883,24.6449009),(44949,'forelimb',254,4,318,28.2245479,95.3816988,122.8082952,1.8,95.4215575,122.8327511,-0.7189829,3.0846303,4.2918341,57.1507979,119.1536168,2.0405402,27.7628667,18.5276005,40.4571604,6.3805413,9.1352922,0.71883,24.6449009),(44950,'forelimb',254,4,319,28.0135641,95.3949385,122.7686364,1.8,95.4433139,122.7765471,-0.718385,3.0644245,4.3276938,56.7097008,117.4075349,2.0225198,27.1293534,18.5058242,39.5931319,6.3805413,9.1957248,0.6528466,24.6449009),(44951,'forelimb',254,4,320,27.9411102,95.4090351,122.757575,1.8,95.4467038,122.7607784,-0.7209348,3.0615042,4.3465241,56.7059956,116.494773,2.0290604,26.8018236,18.5222664,39.2309923,6.3805413,9.1957248,0.6528466,24.6449009),(44952,'forelimb',254,4,321,27.7169224,95.4265676,122.7389934,1.8,95.4708473,122.7487525,-0.7227231,3.056438,4.1942019,56.4240448,114.3344332,2.0209743,27.2601166,18.4607193,39.5236187,6.3805413,9.0642783,0.5485494,24.3931955),(44953,'forelimb',254,4,322,27.5421936,95.435116,122.7300656,1.8,95.4843859,122.7236671,-0.7214053,3.0573565,4.1832493,56.116114,112.7589486,2.0022334,26.9548716,18.3544555,39.1938684,6.3805413,8.9412281,0.614663,24.3931955),(44954,'forelimb',254,4,323,27.3597998,95.4638434,122.7087275,1.8,95.5150713,122.6951228,-0.7305491,3.046922,4.1380015,55.6767238,111.0584831,2.0303746,26.8386762,18.2731045,39.0171429,6.3805413,8.9412281,0.614663,24.3931955),(44955,'forelimb',254,4,324,27.1909456,95.4721079,122.6996716,1.8,95.5041005,122.6932944,-0.7325321,3.0427796,4.1486909,55.4846104,109.6936112,2.0267783,26.440536,18.2348438,38.7571193,6.3805413,8.9412281,0.614663,24.3931955),(44956,'forelimb',254,4,325,27.0034605,95.4774163,122.6748931,1.8,95.5145444,122.6795654,-0.7389414,3.0185444,4.1691729,55.071679,107.9987294,2.0415068,25.9041136,18.2444488,38.0750675,6.3805413,8.9412281,0.614663,24.3931955),(44957,'forelimb',254,4,326,26.8979966,95.4879558,122.6667991,1.8,95.5290476,122.6694695,-0.7396886,3.0185702,4.1823988,54.9778615,106.3149902,2.0368692,25.4196202,18.2132129,38.1058113,6.3805413,8.9412281,0.614663,24.3931955),(44958,'forelimb',254,4,327,26.7869377,95.4918151,122.6359738,1.8,95.5223851,122.6274698,-0.7466035,3.2566552,4.2059066,54.7881021,104.5913213,2.05922,24.8677231,16.8234274,37.7524008,6.6843766,8.9412281,0.614663,24.6449009),(44959,'forelimb',254,4,328,26.6218322,95.4951935,122.6373321,1.8,95.5265248,122.6563927,-0.7443522,2.9949607,4.1825974,54.3790534,102.8169413,2.0365707,24.5820796,18.1568503,37.2255472,6.3805413,8.8582451,0.6823166,24.3931955),(44960,'forelimb',254,4,329,26.4597479,95.4951647,122.6215813,1.8,95.5177742,122.6460327,-0.7506459,3.2462304,4.1968957,54.204252,100.4841997,2.0518463,23.9425058,16.6975984,36.5265734,6.6843766,8.8164606,0.7509291,24.6449009),(44961,'forelimb',254,4,330,26.3262535,95.5012929,122.6147071,1.8,95.5377345,122.6156169,-0.7512566,3.2450622,4.002732,54.0870533,99.0634499,2.0441677,24.7489586,16.6674936,37.854667,6.6843766,8.59376,0.6435011,24.3931955),(44962,'forelimb',254,4,331,26.1446989,95.5067742,122.6099359,1.8,95.5383821,122.5992616,-0.754581,3.2435685,3.9934922,53.6078915,97.2071198,2.0445258,24.341382,16.5274424,37.3440602,6.6843766,8.59376,0.6435011,24.3931955),(44963,'forelimb',254,4,332,26.0038193,95.5091215,122.6114847,1.8,95.5683404,122.6023996,-0.7607286,3.2429819,3.989087,53.3451372,96.0454148,2.0601112,24.0770417,16.4494093,37.0009504,6.6843766,8.59376,0.6435011,24.3931955),(44964,'forelimb',254,4,333,25.8267966,95.5112696,122.6029512,1.8,95.5844792,122.5972757,-0.7653707,3.2357261,3.9786899,52.9945759,94.1553247,2.0660485,23.6649068,16.3779547,36.5058484,6.6843766,8.59376,0.6435011,24.3931955),(44965,'forelimb',254,4,334,25.6484311,95.5140293,122.6047505,1.8,95.6007629,122.5940328,-0.7700441,3.2362956,3.9748969,52.9094877,92.8548305,2.071745,23.3603115,16.348781,36.1732996,6.6843766,8.59376,0.6435011,24.0372303),(44966,'forelimb',254,4,335,25.4569176,95.5257462,122.6008763,1.8,95.6075155,122.5772119,-0.7699534,3.2417222,3.963848,52.6584648,91.3801285,2.0558909,23.0533887,16.2439784,35.8503668,6.6843766,8.59376,0.6435011,24.0372303),(44967,'forelimb',254,4,336,25.4020875,95.5225984,122.6039027,1.8,95.6221065,122.5660716,-0.7727914,3.2400861,3.9663368,52.7006323,90.0869463,2.0634732,22.7128838,16.2651952,35.5009036,6.6843766,8.5290633,0.7140907,24.0372303),(44968,'forelimb',254,4,337,25.2125322,95.5150615,122.5956921,1.8,95.6134642,122.5379508,-0.7733599,3.2286188,3.9656144,52.4308532,88.0334137,2.0504633,22.1991863,16.2394067,34.9099662,6.6843766,8.5290633,0.7140907,23.6812651),(44969,'forelimb',254,4,338,25.0538048,95.5112913,122.5996385,1.8,95.5986495,122.5482057,-0.7755276,3.2275408,3.9635866,52.2831539,86.8886448,2.0466037,21.9217224,16.1990684,34.7588801,6.6843766,8.5290633,0.8567056,23.6812651),(44970,'forelimb',254,4,339,24.8402474,95.5095936,122.5844263,1.8,95.5788483,122.5323646,-0.7865525,3.2089098,3.9528772,51.9758905,85.0968704,2.0747998,21.5278305,16.1973674,34.1358719,6.6843766,8.5290633,0.8567056,23.6812651),(44971,'forelimb',254,4,340,24.5997785,95.5026139,122.5823729,1.8,95.576601,122.5290307,-0.7941488,3.1977313,3.9442664,51.6694318,83.4995595,2.0858568,21.1698577,16.1581531,34.257732,6.6843766,8.2540369,0.6747409,23.4295597),(44972,'forelimb',254,4,341,24.3924874,95.4948088,122.5705173,1.8,95.5312881,122.5253324,-0.8055482,3.1886035,3.9483445,51.3549334,81.9372191,2.1146033,20.7522974,16.1057759,33.7531782,6.6843766,8.2540369,0.6747409,23.0735945),(44973,'forelimb',254,4,342,24.2759456,95.4923741,122.5707911,1.8,95.5232566,122.5132851,-0.8123961,3.1864836,3.9468808,51.474903,81.1483955,2.132176,20.5601335,16.1541401,33.5995832,6.6843766,8.2540369,0.6747409,23.0735945),(44974,'forelimb',254,4,343,24.0573527,95.4916338,122.5666016,1.8,95.5319192,122.5060949,-0.8199513,3.1613071,3.6775228,51.1155979,79.8811475,2.1432119,21.7214554,16.1691339,34.4478894,6.6764751,8.107337,0.5585993,22.8218891),(44975,'forelimb',254,4,344,23.9088081,95.4864367,122.5655056,1.8,95.5155501,122.5122333,-0.821833,3.1775285,3.6770594,51.1192525,78.8284372,2.1374578,21.4379017,16.0877399,34.1357942,6.6843766,8.107337,0.5585993,22.8218891),(44976,'forelimb',254,4,345,23.7811324,95.4760246,122.5496581,1.8,95.5062653,122.4914825,-0.8292108,3.1581598,3.6880465,51.1539873,77.8779343,2.1551911,21.1163102,16.1974031,33.8810149,6.6843766,8.107337,0.5585993,22.8218891),(44977,'forelimb',254,4,346,23.6885368,95.4728161,122.5528683,1.8,95.5007035,122.507918,-0.8289382,3.1580017,3.683258,51.1419123,77.2058078,2.1457275,20.9612817,16.1943904,33.6629269,6.6843766,8.107337,0.5585993,22.8218891),(44978,'forelimb',254,4,347,23.6231324,95.4612384,122.5376375,1.8,95.5007035,122.507918,-0.8333979,3.1385153,3.6908717,51.3752916,76.1614911,2.1572881,20.6350958,16.3692976,33.4239067,6.6843766,8.107337,0.5585993,22.8218891),(44979,'forelimb',254,4,348,23.5476012,95.4554379,122.5316656,1.8,95.5094117,122.491772,-0.8339632,3.1301185,3.6800242,51.6291179,75.4181899,2.1525989,20.4939386,16.4943012,33.2754241,6.6843766,8.107337,0.5585993,22.8218891),(44980,'forelimb',254,4,349,23.4609921,95.4575345,122.524125,1.8,95.5094117,122.491772,-0.8374263,3.1260687,3.6748158,51.9563867,74.387628,2.1581544,20.2425459,16.6203599,33.1379321,6.6843766,8.107337,0.5585993,22.8218891),(44981,'forelimb',254,4,350,23.3689,95.4467192,122.5187884,1.8,95.4807659,122.491772,-0.839889,3.1471458,3.6793046,52.1842692,73.9998457,2.1592202,20.1124544,16.5814592,33.9974253,6.6843766,7.9926588,0.6327488,22.8218891),(44982,'forelimb',254,4,351,23.2714368,95.4346655,122.5039383,1.8,95.4807659,122.491772,-0.8450958,3.1304996,3.6786888,52.2115531,73.3397499,2.1702782,19.9363833,16.6783452,33.8628243,6.6843766,7.9926588,0.6327488,22.8218891),(44983,'forelimb',254,4,352,23.1365997,95.4226709,122.5011498,1.8,95.4770848,122.4754715,-0.8423122,3.1185051,3.6833255,52.1242435,72.7877948,2.1470426,19.7614341,16.7144971,33.662775,6.6843766,7.9926588,0.6327488,22.8218891),(44984,'forelimb',254,4,353,23.2044658,95.4210618,122.4903759,1.8,95.4787197,122.4733568,-0.8383071,3.1083759,3.6745601,52.3170534,72.1539751,2.1379444,19.6360852,16.8309931,33.6027003,6.6843766,7.9926588,0.6327488,22.8218891),(44985,'forelimb',254,4,354,23.229531,95.4107596,122.4950335,1.8,95.4799165,122.473241,-0.8365694,3.1030714,3.6841221,52.3918672,71.331895,2.1335625,19.3619792,16.8838743,33.3264325,6.6843766,7.9926588,0.6327488,22.8218891),(44986,'forelimb',254,4,355,23.1664205,95.3870624,122.4794635,1.8,95.4694113,122.46108,-0.8443632,3.3279388,3.6916802,52.7200998,70.24977,2.1576758,19.0292135,15.8416676,33.1150052,6.875008,7.9926588,0.6327488,23.0735945),(44987,'forelimb',254,4,356,22.8154523,95.3627466,122.4860948,1.8,95.4497926,122.4651529,-0.8559482,3.3077162,3.7170274,52.7614719,69.5624066,2.1686704,18.7145259,15.9510273,32.7626889,6.9195843,7.9926588,0.6327488,23.4295597),(44988,'forelimb',254,4,357,22.4884302,95.3411131,122.4766439,1.8,95.4091512,122.4447109,-0.8783162,3.2713234,3.7303384,52.6941738,67.8317436,2.2202982,18.1838042,16.1079074,32.2438129,6.875008,7.9926588,0.9380475,23.0735945),(44989,'forelimb',254,4,358,22.3472708,95.3246232,122.4810163,1.8,95.3825515,122.46108,-0.8745921,3.2638964,3.6892256,52.7034081,66.9464867,2.1927205,18.1464875,16.1473901,32.2766299,6.9882119,7.9230552,0.7086263,23.4295597),(44990,'forelimb',254,4,359,22.1332658,95.3034324,122.4620217,1.8,95.3557853,122.4466885,-0.8659916,3.2899082,3.6258302,52.2795834,65.9041303,2.1404523,18.176287,15.8908943,32.4191829,6.9882119,7.7463106,0.5880026,23.1778543),(44991,'forelimb',254,4,360,21.9166312,95.2714314,122.4652559,1.8,95.3126109,122.4322971,-0.8623664,3.267775,3.6011586,52.0644266,64.6969821,2.1064243,17.9656019,15.9326839,31.9008226,6.9882119,7.7463106,0.5880026,23.1778543),(44992,'forelimb',254,4,361,21.7909697,95.2474144,122.4512612,1.8,95.2957088,122.4362903,-0.8881373,3.2643725,3.6063225,52.1645308,63.2786481,2.186425,17.5465858,15.9799564,31.8633789,6.9882119,7.7463106,0.5880026,23.1778543),(44993,'forelimb',254,4,362,21.6551255,95.2272618,122.4466069,1.8,95.3097803,122.4257916,-0.8959645,3.2905873,3.5999789,52.2343831,62.3775911,2.2004043,17.3272101,15.8738786,31.6185133,6.9882119,7.7463106,0.9827937,23.1778543),(44994,'forelimb',254,4,363,21.4034668,95.2184376,122.4234648,1.8,95.295485,122.3806458,-0.8990577,3.3148613,3.5447118,51.5186843,60.9130749,2.1855906,17.1842108,15.5417316,31.1445454,6.9882119,7.6503773,0.6659692,23.1778543),(44995,'forelimb',254,4,364,21.1753626,95.1910927,122.4181437,1.8,95.2395895,122.3444812,-0.871324,3.3118507,3.5368931,51.4792932,59.8466301,2.0663748,16.9206784,15.5439658,31.3071518,6.875008,7.6503773,0.9048271,22.4659239),(44996,'forelimb',254,4,365,20.8958413,95.1603971,122.4176717,1.8,95.2236351,122.3373819,-0.8346044,3.2644002,3.5191115,51.0339532,58.6546575,1.9124112,16.667462,15.6334856,30.7704463,6.875008,7.6503773,0.9048271,22.4659239),(44997,'forelimb',254,4,366,20.7114892,95.140721,122.4153434,1.8,95.2236351,122.3373819,-0.8146453,3.2680862,3.506195,50.7913764,57.7970417,1.8268585,16.4842635,15.5416269,30.4289421,6.875008,7.6503773,0.9048271,22.4659239),(44998,'forelimb',254,4,367,20.4706846,95.1094631,122.4079857,1.8,95.1932531,122.3438924,-0.7484579,3.2890358,3.4986555,50.4269487,56.6227879,1.5799729,16.1841564,15.3318333,29.973683,6.875008,7.6503773,0.9048271,22.4659239),(44999,'forelimb',254,4,368,20.2281456,95.0845768,122.413831,1.8,95.1520204,122.3742743,-0.6792349,3.3964056,3.4997027,50.0993202,55.6076122,1.3304478,15.8892391,14.7506884,29.8691348,6.875008,7.6019567,0.7454195,22.7176293),(45000,'forelimb',254,4,369,19.908397,95.0595042,122.4062676,1.8,95.1439408,122.3619212,-0.6050521,3.3534032,3.4483232,49.1903206,54.3514587,1.073524,15.7617064,14.6687762,29.085897,6.875008,7.3926319,0.6202495,22.4659239),(45001,'forelimb',254,4,370,19.7817284,95.026093,122.4074393,1.8,95.0662777,122.3711963,-0.5827358,3.3259501,3.418772,48.6165077,54.0076486,0.9984543,15.7973826,14.6173294,29.3726898,6.875008,7.3926319,0.6202495,22.4659239),(45002,'forelimb',254,4,371,19.6314493,94.982825,122.3924817,1.8,95.0155769,122.3127613,-0.5410595,3.4158399,3.4094261,47.9685634,53.0545325,0.8679416,15.5611331,14.0429778,28.8137781,6.875008,7.3926319,0.6202495,22.2142185),(45003,'forelimb',254,4,372,19.4565526,94.9545104,122.3981111,1.8,95.0155769,122.3127613,-0.479767,3.4026922,3.4383045,47.4484672,52.2935209,0.6908669,15.2091011,13.9443898,28.2161631,6.875008,7.3926319,0.6202495,22.2142185),(45004,'forelimb',254,4,373,19.2660462,94.9310578,122.3960721,1.8,95.0155769,122.3127613,-0.4368311,3.3809342,3.4779592,46.7663598,51.5063764,0.5747332,14.8093675,13.8323781,27.6254858,6.875008,7.3926319,0.6202495,22.2142185),(45005,'forelimb',254,4,374,19.0744768,94.899612,122.4020437,1.8,94.9811896,122.3312784,-0.4290954,3.3709742,3.4815233,46.2284099,50.8021112,0.5502867,14.5919206,13.7136645,27.577105,6.875008,7.3926319,0.6202495,22.2142185),(45006,'forelimb',254,4,375,18.8902366,94.8433077,122.386121,1.8,94.9115551,122.3328485,-0.3858111,3.3197509,3.3526884,45.3910202,49.6776392,0.4458403,14.817255,13.67302,27.4733309,6.44532,7.3926319,0.9505468,21.8582533),(45007,'forelimb',254,4,376,18.7808003,94.8118745,122.3942799,1.8,94.8829229,122.3232122,-0.3526065,3.3021184,3.384861,44.6263544,49.1254457,0.37331,14.513283,13.5144623,27.325341,6.44532,7.317323,0.7022569,21.8582533),(45008,'forelimb',254,4,377,18.8186778,94.7604608,122.3813546,1.8,94.7964866,122.3353734,-0.2751586,3.2937126,3.4162867,43.9550904,48.7351708,0.2315345,14.265539,13.3451504,27.0332233,6.875008,7.2028834,0.3028849,21.9625131),(45009,'forelimb',254,4,378,18.8959434,94.7340876,122.3785597,1.8,94.7791695,122.3314916,-0.2115562,3.3227545,3.4160102,43.8347218,48.6604593,0.138861,14.2448227,13.1922843,26.7910425,6.875008,7.2028834,2.8387078,21.9625131),(45010,'forelimb',254,4,379,18.8275178,94.7048929,122.3684622,1.8,94.7370617,122.3193744,-0.2207233,3.3017296,3.4467295,42.884203,48.2998096,0.150409,14.0132288,12.9884055,26.2298333,6.6843766,7.304696,0.4899573,21.7108077),(45011,'forelimb',254,4,380,18.6660489,94.6737281,122.3787218,1.8,94.6962673,122.3217217,-0.2085855,3.3119034,3.3846151,41.9093583,47.7182413,0.1334019,14.0985725,12.6541608,26.4738852,6.6843766,7.1514336,0.5713375,21.7108077),(45012,'forelimb',254,4,381,18.4573031,94.6212403,122.3715514,1.8,94.6637504,122.3542387,-0.2008272,3.1347072,3.433912,40.5261714,47.5784169,0.1224097,13.855456,12.928216,25.6490527,6.44532,7.2028834,2.8387078,21.3548425),(45013,'forelimb',254,4,382,18.3646515,94.5812919,122.3701991,1.8,94.6299769,122.353071,-0.2045112,3.128082,3.4730489,39.5545952,47.1346338,0.1262415,13.5715432,12.6449996,24.9562512,6.44532,7.2028834,0.3028849,21.3548425),(45014,'forelimb',254,4,383,18.1529963,94.513308,122.3693355,1.8,94.5689283,122.3225467,-0.1859928,3.1008169,3.4584518,38.4860441,46.8137351,0.1034608,13.536038,12.4115824,24.5676143,6.44532,7.304696,0.4899573,21.6065479),(45015,'forelimb',254,4,384,18.1140558,94.471978,122.3708025,1.8,94.53136,122.3233899,-0.2087091,3.1090123,3.3380528,37.8863185,46.5509008,0.1296082,13.9455257,12.1859662,24.3145858,6.44532,7.304696,0.4899573,21.2505827),(45016,'forelimb',254,4,385,18.0814935,94.4081208,122.3776282,1.8,94.4163069,122.3436789,-0.2217702,3.0426688,3.3195571,36.8675058,46.7033487,0.1458001,14.0691507,12.1168317,24.5780036,6.44532,7.317323,0.7022569,21.8582533),(45017,'forelimb',254,4,386,17.8955189,94.3440138,122.3909148,1.8,94.3284518,122.3560452,-0.1974378,3.012403,3.372184,35.9564937,46.2700258,0.1147633,13.7210856,11.9361497,24.0445114,6.44532,7.2028834,2.8387078,21.3548425),(45018,'forelimb',254,4,387,17.6508539,94.2802477,122.3907499,1.8,94.2803063,122.3790048,-0.2039108,2.9998013,3.3511925,34.6823509,46.3673191,0.1206333,13.8360655,11.5615495,23.9158808,6.342225,7.2028834,2.8387078,21.3548425),(45019,'forelimb',254,4,388,17.5857292,94.23038,122.3988723,1.8,94.2643223,122.3566925,-0.2172572,2.9967273,3.4028452,34.0113696,46.4841975,0.1361801,13.6603914,11.3495042,23.6510289,6.342225,7.2028834,0.3028849,21.3548425),(45020,'forelimb',254,4,389,17.4689636,94.156999,122.4081503,1.8,94.1914938,122.3591201,-0.2321991,2.9871959,3.3781074,33.2193701,46.4667655,0.1541763,13.7552657,11.1205863,23.4157707,6.342225,7.304696,0.4899573,21.3548425),(45021,'forelimb',254,4,390,17.2650853,94.1083877,122.4311105,1.8,94.143653,122.372179,-0.25334,2.8844789,3.3285816,32.5836948,46.2192118,0.1807649,13.8855579,11.2962154,22.8836727,6.015632,7.3926319,0.6202495,20.8946176),(45022,'forelimb',254,4,391,17.2234593,94.0190151,122.4639498,1.8,93.99425,122.4324341,-0.2755425,2.8746275,3.3444187,31.9199703,47.0648816,0.2124845,14.0726643,11.1040369,23.0836308,6.2516769,7.3926319,0.6202495,21.6065479),(45023,'forelimb',254,4,392,17.1190024,93.9472638,122.4753227,1.8,93.9283724,122.4563321,-0.286359,2.8672057,3.401588,31.6433603,47.6287334,0.2276383,14.0019112,11.0363064,22.7478489,6.2516769,7.3926319,0.6202495,21.3548425),(45024,'forelimb',254,4,393,16.7284223,93.8532269,122.5049924,1.8,93.8785191,122.4871936,-0.3013064,2.9041091,3.50515,31.0957502,47.525879,0.2455488,13.5588716,10.7075005,22.3450133,6.2516769,7.5041783,0.4124104,21.1031371),(45025,'forelimb',254,4,394,16.6548493,93.778484,122.5303474,1.8,93.794752,122.5295468,-0.313738,2.8948492,3.4550009,30.9958536,47.7988106,0.2643792,13.8346738,10.7072429,22.7860029,6.1504992,7.3926319,0.6202495,21.6065479),(45026,'forelimb',254,4,395,16.6030406,93.6884068,122.5473527,1.8,93.7045009,122.5307591,-0.3201524,2.9031515,3.5448536,30.947714,48.1704841,0.2740695,13.58885,10.6600409,22.2907541,6.1504992,7.5164702,0.5404195,21.9625131),(45027,'forelimb',254,4,396,16.2992933,93.6027145,122.5725994,1.8,93.5893517,122.5507951,-0.3317203,2.9008961,3.5053981,30.4952816,47.6845657,0.2881199,13.6031812,10.512366,21.8362863,6.1504992,7.5164702,0.5404195,21.6065479),(45028,'forelimb',254,4,397,16.125068,93.4908713,122.5998039,1.8,93.4854711,122.5885698,-0.3183951,2.9160955,3.4756087,30.4235945,47.7127873,0.2633647,13.7278937,10.4329897,21.8018939,6.015632,7.5164702,0.5404195,21.2505827),(45029,'forelimb',254,4,398,16.0425432,93.4035674,122.6430105,1.8,93.4267816,122.6105367,-0.333981,2.8985841,3.5774056,30.4108738,48.4098692,0.2873144,13.5321166,10.4916308,21.4257671,6.015632,7.7463106,0.5880026,21.2505827),(45030,'forelimb',254,4,399,15.5433101,93.2937805,122.6808177,1.8,93.3073299,122.646891,-0.3316427,2.8991992,3.5528669,30.0174811,47.3595296,0.2746327,13.3299477,10.3537146,21.7729315,6.015632,7.6140908,0.2860514,21.3548425),(45031,'forelimb',254,4,400,15.3676861,93.2022108,122.7218263,1.8,93.1883038,122.6388044,-0.3344609,2.9505053,3.6525783,30.166396,47.4603365,0.2759899,12.9936533,10.2241457,21.2470341,6.015632,7.7463106,0.3392926,21.8582533),(45032,'forelimb',254,4,401,15.0784856,93.0999845,122.7718315,1.8,93.1071879,122.7224366,-0.350227,3.0244595,3.6552436,30.9112101,47.4172308,0.2958529,12.972386,10.2204079,20.9026859,6.44532,7.7463106,0.5880026,21.8582533),(45033,'forelimb',254,4,402,15.3712109,93.0020979,122.8266079,1.8,93.0296443,122.7811537,-0.3735026,3.0181109,3.7845893,31.918917,49.3241126,0.3410782,13.0328837,10.5757932,21.051502,6.44532,7.9926588,0.6327488,22.1099587),(45034,'forelimb',254,4,403,15.270111,92.8960427,122.8694055,1.8,92.919506,122.8299829,-0.4007601,3.0918696,3.9181206,32.6909461,51.1653973,0.3873322,13.058658,10.5731968,21.1135714,6.44532,8.107337,0.5585993,22.4659239),(45035,'forelimb',254,4,404,15.376582,92.770784,122.912794,1.8,92.800447,122.8482046,-0.4115563,3.1038986,3.8851761,34.1829866,52.3188024,0.4101164,13.466263,11.01292,21.5842706,6.44532,8.2540369,0.6747409,22.9693347),(45036,'forelimb',254,4,405,15.690512,92.620516,122.9681567,1.8,92.6622172,122.8692836,-0.4006236,3.2687229,4.0426788,35.9403558,55.5363118,0.3977395,13.7375028,10.9952286,22.5884923,6.44532,8.3430318,0.6022873,23.3252999),(45037,'forelimb',254,4,406,15.8730177,92.4743676,123.0265815,1.8,92.532459,123.0005561,-0.4130365,3.2609231,4.0301627,37.0563964,57.9185662,0.4262322,14.3712724,11.3637748,23.4424574,6.875008,8.4747721,0.5317241,23.6812651),(45038,'forelimb',254,4,407,16.2647728,92.3334768,123.0716686,1.8,92.3902028,123.0145764,-0.4449787,3.4117796,4.150026,39.5139902,62.1986901,0.5022492,14.9875423,11.5816363,24.2554031,6.875008,8.7005189,0.5743048,24.5406411),(45039,'forelimb',254,4,408,16.7871688,92.1895787,123.1429235,1.8,92.2244285,123.103851,-0.4809227,3.4136637,4.3295022,42.0403814,66.4328069,0.5987322,15.3442138,12.315326,24.9209635,7.1916662,8.9412281,0.614663,24.7923465),(45040,'forelimb',254,4,409,17.4769083,92.0361731,123.2329453,1.8,92.1004086,123.196963,-0.5150076,3.5912317,4.3578106,44.4009947,73.3310181,0.7066411,16.827491,12.3637234,26.4708217,7.2920472,9.1957248,0.6528466,25.4000171),(45041,'forelimb',254,4,410,17.9167796,91.8772328,123.3253509,1.8,91.9434292,123.2616394,-0.4990002,3.6371074,4.3211718,46.4724545,76.5780666,0.6838478,17.7215971,12.7773114,28.2173187,7.304696,9.1957248,0.6528466,25.6517225),(45042,'forelimb',254,4,411,18.9967636,91.7371459,123.3917942,1.8,91.8340485,123.336138,-0.5385775,3.782868,4.4953368,49.1741962,86.4729993,0.8329517,19.2361559,12.9991837,30.0560879,7.5958825,9.5406219,0.625485,26.2593931),(45043,'forelimb',254,4,412,20.0724954,91.5655111,123.452245,1.8,91.6346702,123.4063936,-0.5596926,3.7313631,4.6803305,54.5825956,96.8425273,0.9430128,20.6913866,14.628058,32.3015714,7.5958825,9.798394,0.6610432,26.8670637),(45044,'forelimb',254,4,413,22.1277269,91.3612243,123.5770402,1.8,91.4346888,123.5260166,-0.5997291,3.9279073,5.1688048,66.4825185,117.8782906,1.1748667,22.8057152,16.9256842,35.5505867,7.8997178,10.6385751,0.7568345,28.9417809),(45045,'forelimb',254,4,414,22.8692752,91.2234566,123.5964652,1.8,91.2985897,123.5049691,-0.5993332,4.1089331,5.4057668,72.3183839,127.9126454,1.212833,23.6622572,17.6002825,37.0048913,8.2035531,10.8448348,0.5880026,29.9054167),(45046,'forelimb',254,4,415,18.4795148,91.914485,123.1821238,1.8,91.7256714,123.3244718,-0.583444,4.1523395,5.2869289,58.317988,98.685201,0.9347321,18.6658837,14.0446098,29.6549606,8.0251607,10.7422,0.6435011,30.1571221),(45047,'forelimb',254,4,416,11.7377135,93.2388305,122.7036754,1.8,93.0911095,122.6460846,1.1481064,3.4635007,3.8048981,27.2032894,37.7405665,1.6270888,9.9189427,7.8542758,14.2469429,7.1497391,8.2986537,1.199905,24.8966063),(45048,'forelimb',254,4,417,5.5653613,94.1770462,122.8079639,1.8,94.0980612,122.7391134,1.4742605,2.2214414,3.1103811,4.9982227,11.2848621,0.9189429,3.6281284,2.2499908,5.1995786,4.726568,6.5729625,1.7681919,17.8130787),(45049,'forelimb',254,4,418,0.3085589,94.5818474,123.1182728,1.8,94.5765903,123.1169196,1.4782748,0.7867493,1.1265954,0.0463439,0.1458244,0.0509875,0.1294381,0.0589056,0.1617272,1.718752,2.8824347,2.0344439,7.0835276),(45050,'forelimb',254,4,419,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45051,'forelimb',254,4,420,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45052,'forelimb',254,4,421,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45053,'forelimb',254,4,422,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45054,'forelimb',254,4,423,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45055,'forelimb',254,4,424,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45056,'forelimb',254,4,425,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45057,'forelimb',254,4,426,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45058,'forelimb',254,4,427,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45059,'forelimb',254,4,428,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45060,'forelimb',254,4,429,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45061,'forelimb',254,4,430,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45062,'forelimb',254,4,431,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45063,'forelimb',254,4,432,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45064,'tibia fibula',254,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45065,'tibia fibula',254,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45066,'tibia fibula',254,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45067,'tibia fibula',254,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45068,'tibia fibula',254,8,5,1.2848693,57.0165384,113.9465405,1.8,57.0389757,113.9178715,0.4738272,1.4738183,2.0028024,0.5778551,1.0777884,0.0445861,0.5381402,0.3920803,0.8243464,3.007816,4.4239087,2.6344941,10.9812566),(45069,'tibia fibula',254,8,6,17.6491754,57.9438009,115.315001,1.8,58.3422269,115.8747074,0.7087971,3.239341,6.3769831,32.1126828,125.1200222,1.2463208,19.6205668,9.9133383,24.553998,6.3805413,12.2893773,2.5050844,31.4335373),(45070,'tibia fibula',254,8,7,50.6085213,59.6762146,116.5488423,1.8,60.4265226,116.9733316,0.4675053,6.6180232,11.9153517,150.0475849,918.6749918,1.7130565,77.1001152,22.6725687,87.2174566,8.874828,17.4010378,2.5672878,42.9613905),(45071,'tibia fibula',254,8,8,97.8422535,61.3687995,117.686852,1.8,61.6647117,118.3125358,0.4156886,15.1944674,11.5546281,783.1682664,2881.6020547,2.6591992,249.3894238,51.5429889,241.1572521,12.8568127,23.2190609,2.4610714,67.5020316),(45072,'tibia fibula',254,8,9,139.4774466,61.3000428,118.4705591,1.8,61.5715008,119.5116341,0.4899065,17.2025734,12.375648,3194.7542881,4629.0731966,5.1469755,374.0469347,185.7137431,452.1648121,23.5934474,30.4806021,0.7055682,106.9216583),(45073,'tibia fibula',254,8,10,231.3283429,60.6578815,119.6906102,1.8,61.5632897,119.3156834,-1.1660512,12.5718569,16.3974507,7302.1145435,13057.3069608,32.5761887,796.3010352,580.8302326,1183.0312397,24.7307909,34.1649249,0.6963486,100.6364328),(45074,'tibia fibula',254,8,11,316.2722764,60.4543755,118.6124104,1.8,61.1683256,118.2543274,-1.112371,13.1506124,18.7253913,10804.7109793,26107.0985709,42.3889917,1394.2084394,821.6127619,1933.5904287,26.0890304,37.6657746,0.9638087,110.7151275),(45075,'tibia fibula',254,8,12,354.6929743,59.4541421,117.6428511,1.8,60.0941718,117.6893841,-1.0650575,15.1329359,20.1301349,14894.2089836,35026.6790083,45.241348,1740.0121387,984.224679,2461.2084481,27.7892467,39.8128598,0.9618387,116.9392791),(45076,'tibia fibula',254,8,13,410.9757337,57.9067901,116.9999192,1.8,59.1367726,117.0418767,-0.9558323,17.2746311,20.9117345,21755.4344089,43094.9213209,45.6972672,2060.8008987,1259.3863376,3033.4923536,30.5890173,40.9107206,0.942,122.6421317),(45077,'tibia fibula',254,8,14,425.8985691,57.6472096,115.8945173,1.8,58.472399,116.3185581,-1.0441309,18.0565745,21.0513599,27435.645277,43922.0085567,53.0484742,2086.4214332,1519.426913,3344.1069969,32.8651146,41.4220123,0.9252205,127.9026475),(45078,'tibia fibula',254,8,15,478.7641859,57.3681902,115.7353883,1.8,58.0662118,115.7317863,-1.1583164,18.4623403,21.7491287,31487.8150516,48663.4418994,66.9705915,2237.4892569,1705.5159067,3646.239281,33.7418372,41.4220123,0.9252205,129.3696941),(45079,'tibia fibula',254,8,16,538.4340992,57.182578,115.2304996,1.8,57.8014613,115.393823,-1.1662329,19.3480719,21.6085017,32559.7213328,52239.7477716,75.8353258,2417.5553029,1682.8406242,3858.7446986,34.9127251,41.4153258,1.0374941,131.9046363),(45080,'tibia fibula',254,8,17,472.8024258,57.3342262,114.8682723,1.8,57.6827234,115.4481812,-1.2434458,20.290741,21.3925966,29885.7137948,47746.9774954,70.6536257,2231.9393206,1472.8744435,3559.6084671,35.6752946,41.4932684,1.0143924,134.3353187),(45081,'tibia fibula',254,8,18,421.834488,57.5625707,116.032945,1.8,58.0238517,115.7661612,-1.3407714,20.6279014,22.4613383,28930.2994827,38178.2907025,66.6509162,1699.7335717,1402.4838936,2974.0868227,36.5249976,40.3998133,1.0595656,133.8750937),(45082,'tibia fibula',254,8,19,354.2627263,57.9005245,117.7504359,1.8,58.6392868,117.2501821,-0.4701471,20.8770908,19.1066595,24460.2189532,27828.3669279,12.1172481,1456.474738,1171.629669,2291.3485533,35.3630818,41.0728688,2.304389,152.0441376),(45083,'tibia fibula',254,8,20,305.9994202,58.8438798,118.7333614,1.8,59.8617379,119.0276377,-0.1904895,19.0582056,19.1471846,18264.3578948,24760.4602792,1.8283201,1293.1645433,958.3461456,1837.8107619,31.3186266,40.1292706,2.9147938,120.8191199),(45084,'tibia fibula',254,8,21,277.1772808,59.6438273,119.2589159,1.8,60.6877046,119.6474739,0.0579066,18.5050637,23.5317211,15815.127436,23637.9368486,0.1547311,1004.5137257,854.6378253,1657.6753954,30.458207,41.3930295,3.0584514,125.1159999),(45085,'tibia fibula',254,8,22,266.616455,60.730016,119.9537352,1.8,61.6900707,120.2812819,0.182448,18.3365728,24.9119964,13663.1328781,26981.7623114,1.462816,1083.0831025,745.1301309,1618.2703818,29.3887382,42.9042984,3.0110266,122.2861665),(45086,'tibia fibula',254,8,23,260.0906728,61.8451755,120.5187286,1.8,62.3192576,120.7279523,0.2279464,17.7574079,24.1390939,12022.2184059,30270.4356445,2.2136257,1254.0004917,677.0255249,1749.7094633,28.2368988,42.5369418,2.9996956,120.0029297),(45087,'tibia fibula',254,8,24,250.218076,62.4901809,121.0020802,1.8,62.6206166,121.0626712,0.2416859,17.2043278,23.4119938,10516.0195411,30732.9125412,2.3888979,1312.699497,611.242686,1761.2943394,27.4408618,41.9974686,3.0185067,118.4926973),(45088,'tibia fibula',254,8,25,238.308655,62.980061,121.3336511,1.8,62.9030221,121.3727896,0.2485753,16.5504289,22.9648849,9238.6121754,30033.3694331,2.4040364,1307.7953417,558.2098341,1709.3955432,26.4439172,41.5710649,3.0172377,115.9577551),(45089,'tibia fibula',254,8,26,228.8878465,63.2018418,121.5568955,1.8,63.1200214,121.6415218,0.2526433,16.0656382,22.6968114,8297.4508543,29052.5494013,2.3835656,1280.0277946,516.4719099,1645.3504516,25.890179,41.1447295,3.0159423,114.9509335),(45090,'tibia fibula',254,8,27,220.9295455,63.4311967,121.7732551,1.8,63.3330017,121.8005126,0.2570765,15.4740039,22.5307824,7444.612828,28112.2751806,2.3803399,1247.7274309,481.1044961,1577.6532861,24.8753847,40.7184646,3.0146199,111.4091697),(45091,'tibia fibula',254,8,28,214.1638539,63.5027027,121.9054822,1.8,63.4228111,121.9700764,0.2619505,15.0355415,22.4299535,6826.2382905,27065.5481554,2.3937409,1206.6698266,454.006814,1510.8272206,24.3724323,40.3495107,3.0027076,110.0463829),(45092,'tibia fibula',254,8,29,208.4910146,63.5996785,122.04131,1.8,63.5471443,122.1255909,0.266573,14.7040434,22.4151676,6326.0171996,26195.9689269,2.4113301,1168.6715627,430.2229692,1450.4552681,23.9041326,39.9863876,2.9905773,108.4750766),(45093,'tibia fibula',254,8,30,203.459463,63.6920707,122.2023698,1.8,63.6091073,122.2534385,0.2721675,14.4601008,22.2856068,5880.0363865,25374.89442,2.4504678,1138.6225487,406.6386862,1402.3492774,23.7393975,39.701404,2.9675474,107.1122897),(45094,'tibia fibula',254,8,31,199.6021694,63.7859042,122.3192535,1.8,63.7398486,122.3983678,0.2794664,14.0866827,22.1647272,5524.9526364,24701.2191268,2.5312639,1114.4382212,392.211053,1363.7031751,23.0516499,39.4985888,2.9996956,105.3935377),(45095,'tibia fibula',254,8,32,196.7176616,63.8378495,122.4157157,1.8,63.758641,122.4920536,0.2875751,13.8212923,22.0871938,5218.4727276,24065.7689384,2.6374828,1089.5801961,377.5676399,1325.785872,22.6692304,39.205351,2.976444,103.9264911),(45096,'tibia fibula',254,8,33,192.3165995,63.931357,122.5046527,1.8,63.8988966,122.5854995,0.2944155,13.587607,21.9699333,4906.0344507,23216.4697363,2.6989949,1056.7382881,361.0668482,1279.8097335,22.5344865,38.7815737,2.9746225,102.8154097),(45097,'tibia fibula',254,8,34,190.0460762,63.9253821,122.607099,1.8,63.9175532,122.7248669,0.3004287,13.3606069,21.942393,4681.1465771,22630.5851394,2.7738616,1031.3635845,350.3693072,1244.1507129,22.3043981,38.6480411,2.996551,102.0602935),(45098,'tibia fibula',254,8,35,189.1842375,63.9407555,122.6934017,1.8,63.9745731,122.8002005,0.3065175,12.9873291,21.8973121,4516.1928104,22245.5219224,2.8707834,1015.9019421,347.7383834,1221.1952618,21.7462843,38.3579279,2.9727608,101.0966577),(45099,'tibia fibula',254,8,36,188.7153847,63.9178154,122.7679117,1.8,63.9858675,122.8988792,0.3127832,12.6140344,21.8903669,4374.0438294,21856.7408029,2.978061,998.4638869,346.7600992,1196.8256691,21.1842849,38.2229153,2.9949262,100.4889871),(45100,'tibia fibula',254,8,37,188.4976311,63.9335001,122.8420533,1.8,63.9810634,122.9787864,0.3195671,12.4989138,21.7064022,4258.2224218,21457.5061677,3.1005903,988.5335192,340.6873993,1184.5596444,21.1968505,37.7539047,2.9352688,99.5253514),(45101,'tibia fibula',254,8,38,188.5487685,63.9320154,122.9070684,1.8,63.907083,123.0515702,0.327246,12.3671104,21.68364,4148.0971255,21138.9095696,3.2468527,974.8782749,335.4136078,1165.7746326,21.1525894,37.6682255,2.9464342,99.0219406),(45102,'tibia fibula',254,8,39,188.2152004,63.9456451,122.9877778,1.8,63.9503211,123.0953324,0.3345953,12.116958,21.4983748,4055.6216227,20822.2642286,3.3827917,968.5506176,334.7062539,1155.3754204,20.7784701,37.4396108,2.9802175,98.1625646),(45103,'tibia fibula',254,8,40,186.6926596,63.9135354,123.0802879,1.8,63.8723176,123.1485385,0.3400678,12.1746701,21.3724203,3971.6778728,20395.0927132,3.4617882,954.2715519,326.2246808,1137.2670889,20.7784701,37.1649072,2.9555345,97.8065994),(45104,'tibia fibula',254,8,41,186.8372319,63.8375973,123.1150051,1.8,63.8279045,123.2104403,0.3446041,12.0542311,21.2846537,3907.3382166,19890.3355813,3.5538041,934.491858,324.1466167,1116.7605643,20.6737385,36.8255401,2.9419088,97.1989288),(45105,'tibia fibula',254,8,42,187.8250679,63.7597582,123.1695202,1.8,63.7488816,123.2281957,0.3492519,12.0957961,21.334122,3878.8526805,19502.4537304,3.6656369,914.1437229,320.6777513,1094.2092586,20.7182609,36.7427211,2.9533711,96.3395528),(45106,'tibia fibula',254,8,43,187.6152031,63.6508622,123.2114919,1.8,63.712683,123.3181045,0.3530226,12.1433957,21.2685312,3856.4646363,19091.045989,3.7377052,897.6193895,317.5771202,1075.2359455,20.9350215,36.6647511,2.9648838,96.3395528),(45107,'tibia fibula',254,8,44,187.5053192,63.4877502,123.2185523,1.8,63.6568594,123.3437944,0.3583076,12.0154438,21.1574587,3844.3127982,18704.4144261,3.8433395,884.0577083,319.9476338,1063.4636607,20.9199307,36.2418331,2.9627996,95.9835876),(45108,'tibia fibula',254,8,45,189.1918466,63.3471812,123.2392724,1.8,63.4878529,123.3142224,0.3634607,11.9470076,21.1212733,3838.3159892,18444.6109304,3.9852657,873.2717313,321.2784432,1050.4379501,20.6383124,35.9836443,2.9371714,94.7682464),(45109,'tibia fibula',254,8,46,190.0204516,63.3008551,123.2989146,1.8,63.4288584,123.3727095,0.3666579,11.8426863,21.1367308,3814.42605,18239.5632819,4.070253,862.9320912,322.0912852,1038.2348973,20.6383124,35.9836443,2.9371714,94.7682464),(45110,'tibia fibula',254,8,47,190.5282449,63.2978925,123.3679204,1.8,63.3264958,123.4395056,0.3707241,11.8776622,21.0165831,3767.8103285,18140.2338639,4.1679441,863.139063,317.2181748,1040.4135371,20.6383124,35.7494219,2.9111902,94.7682464),(45111,'tibia fibula',254,8,48,191.2281672,63.3191855,123.4463204,1.8,63.2972878,123.4726908,0.3763194,11.9004531,20.8024276,3741.0206613,17952.7341445,4.3044247,863.0114966,314.3595152,1038.5822685,20.6282422,35.5630099,2.9347187,94.516541),(45112,'tibia fibula',254,8,49,189.9888404,63.2820689,123.4386696,1.8,63.2689009,123.4742414,0.3802705,11.7173534,20.6726258,3718.4089305,17609.9214159,4.3624087,851.8473451,317.3420481,1024.9762855,20.5647303,35.4772438,2.9465724,93.7614248),(45113,'tibia fibula',254,8,50,190.2041322,63.2172047,123.4944391,1.8,63.2622313,123.5339833,0.3840118,11.7631625,20.6264076,3696.1915773,17414.4379813,4.4494277,844.2787676,314.2175051,1020.521602,20.5647303,35.234416,2.9202782,94.0131302),(45114,'tibia fibula',254,8,51,189.5415839,63.1743428,123.5482211,1.8,63.2511417,123.5681218,0.3867324,11.7333538,20.4794072,3678.3212726,17250.2030232,4.4938034,842.3194525,313.4927438,1016.6465419,20.3106826,35.1425946,2.9322073,93.0494944),(45115,'tibia fibula',254,8,52,189.8653609,63.0657504,123.5690986,1.8,63.133444,123.6066203,0.3905016,11.6035549,20.4936351,3681.7076065,17001.3556867,4.5851276,829.591997,317.2913493,1007.3102848,20.3080539,34.9133068,2.905569,92.4418238),(45116,'tibia fibula',254,8,53,189.6067086,62.9883034,123.5946972,1.8,63.0299971,123.6029238,0.3956319,11.6186087,20.3828498,3664.2658182,16668.326212,4.6936032,817.7623025,315.3790548,993.558452,20.2683869,34.815336,2.917569,92.5460836),(45117,'tibia fibula',254,8,54,189.7452383,62.9226035,123.6401908,1.8,62.9937654,123.6366373,0.4018605,11.8075742,20.1863651,3652.8674158,16330.2171407,4.8379887,808.9726455,309.3664579,987.3638824,20.4281709,34.4956781,2.9026562,92.0858586),(45118,'tibia fibula',254,8,55,189.2442148,62.8089749,123.6755828,1.8,62.9084225,123.642052,0.4077255,11.8433356,20.0973763,3656.9060108,15907.0558628,4.9591421,791.499131,308.7733158,968.4497653,20.3867006,34.3965177,2.9147938,91.5824478),(45119,'tibia fibula',254,8,56,189.8528283,62.686088,123.6875374,1.8,62.7418371,123.6574442,0.4152941,11.8500133,19.9691266,3676.9473635,15508.7246306,5.1506821,776.6350992,310.2905672,957.3336026,20.2529879,34.0783491,2.8996721,90.7230718),(45120,'tibia fibula',254,8,57,189.6173948,62.613446,123.6700466,1.8,62.6320658,123.6155975,0.4236588,12.0195969,19.8126241,3681.0907728,15038.2519998,5.340952,759.0237368,306.257422,942.7753485,20.2212346,33.6613312,2.896614,90.4713664),(45121,'tibia fibula',254,8,58,188.2709816,62.4887411,123.676292,1.8,62.5473146,123.6038228,0.4328908,12.0064934,19.3400068,3683.2392747,14536.8459942,5.5219098,751.6463739,306.7706084,938.2341636,20.166734,33.1417327,2.9060477,90.3239208),(45122,'tibia fibula',254,8,59,187.3415004,62.3304766,123.6584756,1.8,62.4345347,123.5952592,0.4412894,11.9933532,18.8817637,3702.220552,14028.807832,5.6957838,742.9818563,308.6893615,937.1203175,20.0364576,32.4122633,2.886968,88.500909),(45123,'tibia fibula',254,8,60,185.3242025,62.1954377,123.6434615,1.8,62.3498389,123.56815,0.4492837,12.1640067,18.6125674,3715.3771725,13527.5697688,5.8264159,726.7976241,305.4402438,924.4189225,20.2491308,31.9966124,2.8835854,87.9974982),(45124,'tibia fibula',254,8,61,185.7870128,62.0930515,123.6394509,1.8,62.2209992,123.5982389,0.4578762,12.1435701,18.3095524,3746.0249536,13121.4919578,6.0505564,716.6473357,308.4780598,919.1522823,20.2183117,31.5813372,2.8801138,87.3898276),(45125,'tibia fibula',254,8,62,186.0866757,61.9619806,123.6169949,1.8,62.066538,123.531092,0.4674657,12.3067529,17.8504462,3766.1453141,12611.5551622,6.297893,706.5120407,306.0226648,916.8325452,20.3561379,30.868829,2.8594689,86.4261918),(45126,'tibia fibula',254,8,63,185.9377954,61.8468661,123.5850794,1.8,61.939784,123.4708233,0.4747757,12.4667567,17.5798166,3794.5432842,12249.3419065,6.4760893,696.7843981,304.3729319,912.0322067,20.2906143,30.456363,2.8555412,85.8185212),(45127,'tibia fibula',254,8,64,187.0058623,61.7382785,123.5467883,1.8,61.8030625,123.406441,0.4839067,12.4158197,17.3068478,3845.4706394,11925.0009784,6.7462076,689.033676,309.7234604,910.6537252,20.2744688,30.0443798,2.8515057,85.3151104),(45128,'tibia fibula',254,8,65,186.417838,61.6394723,123.5073978,1.8,61.6837563,123.3744047,0.4918152,12.5722159,17.0283846,3867.7033387,11512.9753928,6.9284701,676.1049651,307.6389528,902.74928,20.4515254,29.6266682,2.8014955,84.9591452),(45129,'tibia fibula',254,8,66,185.9080865,61.5283721,123.4833259,1.8,61.545184,123.3142632,0.4991127,12.7247676,16.5499738,3882.0164503,11122.1212212,7.0986722,672.0325589,305.0756263,905.2933456,20.350721,29.079435,2.8104966,83.8480638),(45130,'tibia fibula',254,8,67,184.8893107,61.4361952,123.4581875,1.8,61.4982835,123.2964108,0.5078615,12.7238118,16.2588831,3883.3140331,10776.7848419,7.2876329,662.8244261,305.2005247,900.4467116,20.4959385,28.6734251,2.805625,83.4920986),(45131,'tibia fibula',254,8,68,183.8783678,61.3388663,123.4165473,1.8,61.4128948,123.2122401,0.517417,12.8332189,15.8208911,3898.2800645,10429.9460653,7.4981215,659.2514922,303.7647921,905.5682655,20.436257,28.1273384,2.8150112,82.6327226),(45132,'tibia fibula',254,8,69,182.8242882,61.2511342,123.3741528,1.8,61.2833787,123.1694172,0.5264165,12.7754974,15.543952,3911.581388,10131.1216321,7.6921542,651.7725774,306.178403,903.3773596,20.3750192,27.7207045,2.8100385,82.025052),(45133,'tibia fibula',254,8,70,182.3749056,61.1628579,123.3338994,1.8,61.2037003,123.1271594,0.5343366,12.7283919,15.2689597,3927.0520591,9859.7394609,7.883342,645.7374715,308.5269597,902.9213915,20.3122297,27.3147764,2.8049178,81.4173814),(45134,'tibia fibula',254,8,71,182.6017789,61.0773201,123.2922142,1.8,61.146912,123.1037085,0.5416671,12.6836251,15.1413327,3942.0150953,9629.7510233,8.0894846,635.9909813,310.7956179,895.7428178,20.2478934,27.1758553,2.8198421,81.165676),(45135,'tibia fibula',254,8,72,182.1247576,60.9895555,123.2552445,1.8,61.0378502,123.0605308,0.5495959,12.6404403,14.8642167,3948.6067617,9385.175877,8.2818765,631.3939072,312.3788935,896.6053023,20.1820151,26.7685623,2.814766,80.5580054),(45136,'tibia fibula',254,8,73,181.0270377,60.9110592,123.1659117,1.8,60.9518341,122.9696098,0.5595473,12.7621186,14.7447431,3955.2058818,9146.8949923,8.5007706,620.3495683,309.9176564,886.7928917,20.1991928,26.5747352,2.7430702,79.9503348),(45137,'tibia fibula',254,8,74,179.2710217,60.8502518,123.1356294,1.8,60.8771642,122.8952882,0.5665291,12.7210278,14.4428208,3944.7421086,8934.1598722,8.6066226,618.5882947,310.096179,890.2834742,20.0874773,26.3619804,2.8095332,81.4173814),(45138,'tibia fibula',254,8,75,178.3732636,60.7997499,123.0771264,1.8,60.8960395,122.8657611,0.5767526,12.7544261,14.3820496,3969.5274914,8745.6384301,8.8400965,608.0940253,311.2274492,858.5625677,20.0398807,26.337456,2.0636327,81.165676),(45139,'tibia fibula',254,8,76,178.6968728,60.7418548,123.0214469,1.8,60.8635704,122.8235125,0.5850716,12.7933019,14.2203444,3983.8093814,8566.4298822,9.0834627,602.4066374,311.3980597,850.4686741,20.122968,26.1792505,1.9756881,81.4173814),(45140,'tibia fibula',254,8,77,178.3337636,60.699671,122.9722543,1.8,60.8119209,122.7822124,0.5940315,12.8320773,14.1593843,3984.469708,8387.1580147,9.3111425,592.3391758,310.5085492,839.447345,20.0369518,26.0129864,1.9605049,83.1361334),(45141,'tibia fibula',254,8,78,177.6011671,60.6460419,122.921688,1.8,60.7807104,122.744137,0.6025865,12.7583332,13.9853629,3981.6175619,8219.857391,9.5085959,587.7471666,312.0797598,830.4950719,19.9722257,25.9596993,1.9974238,83.5963584),(45142,'tibia fibula',254,8,79,177.1722059,60.592058,122.8667312,1.8,60.7332987,122.7177556,0.6096352,12.6925178,13.9488992,3982.6981454,8048.7122893,9.6805306,577.0141563,313.7831454,821.7235137,19.8453746,25.7848605,1.9822526,83.1361334),(45143,'tibia fibula',254,8,80,176.8280635,60.5516265,122.8044882,1.8,60.6658929,122.667472,0.6178398,12.6048889,13.7662503,3986.9086545,7884.3563395,9.8894136,572.7308577,316.2985956,814.032115,19.7347202,25.7418618,1.823872,82.2767574),(45144,'tibia fibula',254,8,81,175.3715426,60.5116963,122.6915649,1.8,60.5729027,122.4917521,0.6259335,12.6322378,13.6067882,3988.1920419,7654.8072228,10.0319818,562.572673,315.7154015,804.3777888,19.8191714,25.4533477,1.9513027,80.3063),(45145,'tibia fibula',254,8,82,176.4810117,60.470254,122.6162656,1.8,60.5535891,122.4830589,0.6386512,12.6030632,13.4920585,4022.666981,7500.7717398,10.4521106,555.9397597,319.1816885,797.3705768,19.7279634,25.4533477,1.9513027,81.6690868),(45146,'tibia fibula',254,8,83,177.4220743,60.4312475,122.5347051,1.8,60.5211443,122.3869109,0.6491103,12.4870111,13.3115169,4048.3175913,7365.4955938,10.8048131,553.3175236,324.2022894,793.9528854,19.8055779,25.2969117,1.9355311,81.7733466),(45147,'tibia fibula',254,8,84,177.3101762,60.3929235,122.4840163,1.8,60.4811453,122.34515,0.6535347,12.6996783,13.1092409,4055.1462959,7222.171252,10.9240741,550.9221542,319.310946,783.4536638,19.8099802,25.1468455,1.9195673,79.846075),(45148,'tibia fibula',254,8,85,177.3031826,60.36282,122.4295078,1.8,60.4776786,122.2974691,0.6604163,12.6281671,13.0844236,4064.0207432,7089.0305547,11.1203248,541.7915823,321.8219,777.458256,19.6428539,25.1211348,1.7950311,81.0614162),(45149,'tibia fibula',254,8,86,177.3474383,60.3414395,122.3601691,1.8,60.4500976,122.2048236,0.6731049,12.7677807,12.8712523,4096.0516869,6940.946012,11.4876313,539.2595715,320.8115632,753.8562674,19.751748,25.1578563,1.7078625,80.4537456),(45150,'tibia fibula',254,8,87,176.4855995,60.3089378,122.2776555,1.8,60.3998565,122.0616241,0.683182,12.7194554,12.8779165,4115.5009538,6791.521603,11.7214197,527.3773606,323.5595254,745.6032798,19.7538598,24.9552196,1.5191182,81.9207922),(45151,'tibia fibula',254,8,88,176.6634615,60.2724609,122.1867472,1.8,60.3587257,121.9836175,0.6945593,12.8649477,12.7402955,4148.6233314,6652.4710834,12.0619926,522.159874,322.4749485,738.5966593,19.6683469,24.9552196,1.6224744,79.8028892),(45152,'tibia fibula',254,8,89,176.0858438,60.2349605,122.0151867,1.8,60.2903643,121.8413763,0.7082078,12.6629377,12.5349739,4166.6825792,6503.336027,12.4174523,518.8152823,329.0454921,737.7345984,19.600293,24.7956411,1.7273982,79.3426642),(45153,'tibia fibula',254,8,90,176.1607036,60.2143159,121.9274334,1.8,60.2816696,121.7124247,0.7228239,12.7915361,12.5911415,4195.1151424,6406.5939638,12.8476629,508.8175635,327.9602328,720.0914458,19.6622228,25.0549006,1.6738779,78.2315828),(45154,'tibia fibula',254,8,91,175.4177565,60.2010879,121.8561012,1.8,60.2593634,121.5964497,0.7314847,12.7208628,12.3505107,4196.5565108,6277.8549763,13.0449679,508.3073165,329.8955868,710.8480609,19.5022806,24.6762153,1.6929915,77.9798774),(45155,'tibia fibula',254,8,92,175.0283513,60.1910639,121.768713,1.8,60.2328922,121.4995095,0.7382028,12.9018852,12.3769579,4199.1181605,6160.5606426,13.2109857,497.7443301,325.4654733,702.6023196,19.5708833,24.5862653,1.483301,77.0162416),(45156,'tibia fibula',254,8,93,174.9611565,60.1845037,121.6598449,1.8,60.2324598,121.3263613,0.7495782,12.7446377,12.1506592,4208.7102045,6045.469224,13.5364731,497.5424879,330.2338058,700.4055998,19.6269073,24.2497879,1.6951513,75.6534548),(45157,'tibia fibula',254,8,94,175.0514582,60.182311,121.5639933,1.8,60.253147,121.2117474,0.7685364,12.8267964,12.1797025,4230.1076934,5936.8160509,14.0957682,487.4352253,329.7867652,698.8700681,19.5356532,24.1238339,1.4994889,76.3043112),(45158,'tibia fibula',254,8,95,174.4890027,60.1856177,121.4941272,1.8,60.2018023,121.1953556,0.793301,12.6115145,11.9029203,4243.8481796,5849.7352346,14.7705679,491.4537843,336.5058329,692.0003406,19.5356532,24.1582501,1.4817467,74.5855592),(45159,'tibia fibula',254,8,96,174.8520559,60.1832166,121.4221359,1.8,60.2014402,121.1236089,0.8075405,12.4798463,11.9376516,4259.0610813,5776.7920622,15.2160663,483.9136065,341.2751241,691.3035395,19.4917848,23.8815318,1.7152379,73.4744778),(45160,'tibia fibula',254,8,97,174.3896372,60.2273852,121.3006462,1.8,60.2360467,120.9877787,0.8249422,12.5459621,11.70962,4265.1000954,5689.1428384,15.6806161,485.8520457,339.9579925,686.1335667,19.4120157,23.7302954,1.6614562,72.7625474),(45161,'tibia fibula',254,8,98,173.5816214,60.2376208,121.2321727,1.8,60.2635168,120.8993698,0.8377646,12.4371604,11.6865168,4259.1133224,5606.3202325,15.9773417,479.7255095,342.4506235,683.2371964,19.5316041,23.5232106,1.735945,72.510842),(45162,'tibia fibula',254,8,99,173.1229513,60.2533401,121.1382371,1.8,60.2911593,120.8361162,0.8617948,12.4905788,11.4745358,4276.7597563,5530.5084721,16.6226812,481.9810214,342.3988456,677.4631866,19.4707314,23.4563999,1.7178747,72.7625474),(45163,'tibia fibula',254,8,100,173.1657523,60.2763095,121.0464536,1.8,60.3137539,120.7660023,0.8905387,12.2146671,11.4403516,4290.8702446,5453.239597,17.442622,476.6671345,351.28835,677.5140275,19.4707314,23.345942,1.6814535,73.370218),(45164,'tibia fibula',254,8,101,172.8908188,60.3020097,120.9430343,1.8,60.3777904,120.6389555,0.9239139,12.147414,11.2710951,4308.8081877,5381.983069,18.34806,477.5031179,354.7099148,672.0580348,19.4773976,23.3657049,1.0082984,74.9415244),(45165,'tibia fibula',254,8,102,172.7719831,60.3159573,120.8435578,1.8,60.4030308,120.5358545,0.9617515,11.8830738,11.192313,4322.316741,5320.7012383,19.3711809,475.3888896,363.7372644,673.326139,19.4444816,23.3657049,1.0082984,72.2591366),(45166,'tibia fibula',254,8,103,171.5810522,60.3365027,120.7572239,1.8,60.4682771,120.4282793,0.9878024,11.7398149,11.0840198,4310.9985838,5252.9459129,19.9297507,473.9206537,367.2118032,671.9370342,19.3877545,23.2389317,0.9827937,72.7625474),(45167,'tibia fibula',254,8,104,171.4372072,60.3706634,120.6563177,1.8,60.5088691,120.3590439,1.0180569,11.4345158,10.969735,4322.8979599,5188.6073178,20.6968512,472.9929512,378.0569305,673.2897277,19.2874909,23.139407,1.0240075,72.510842),(45168,'tibia fibula',254,8,105,171.2806619,60.382742,120.4841177,1.8,60.5359384,120.2024869,1.0524503,11.287401,10.8753475,4323.7697326,5118.4037939,21.5395468,470.6427799,383.0615852,668.7611752,19.2927116,23.2389317,0.9827937,73.7261832),(45169,'tibia fibula',254,8,106,171.4567894,60.4206971,120.3831925,1.8,60.5905184,120.0762966,1.0862203,11.1067747,10.8215666,4330.9088022,5052.7983854,22.3750947,466.9193073,389.9339757,669.7326641,19.2831808,23.139407,1.0240075,71.2955008),(45170,'tibia fibula',254,8,107,171.5064162,60.457658,120.2751282,1.8,60.651258,120.0044313,1.12304,10.7309371,10.6264393,4329.1208205,4992.8647994,23.2265256,469.8530403,403.4243018,678.4820089,19.2831808,22.951132,0.9048271,71.7989116),(45171,'tibia fibula',254,8,108,170.9696413,60.4941367,120.2049948,1.8,60.7002098,119.8928957,1.1414494,10.5167019,10.6329294,4330.33541,4920.2191749,23.5571493,462.7341134,411.7579296,677.151719,19.1975148,22.8826511,0.9723774,71.2955008),(45172,'tibia fibula',254,8,109,170.0386495,60.5258128,120.1209152,1.8,60.6976113,119.7789511,1.1839873,10.3290682,10.4284068,4327.3458987,4841.3864148,24.3068454,464.2498612,418.9483318,678.8621726,19.2415198,22.7775173,0.9461609,70.79209),(45173,'tibia fibula',254,8,110,169.739546,60.5534841,120.030219,1.8,60.7478306,119.7153063,1.245838,10.1108744,10.2960961,4331.375905,4773.1951489,25.4062505,463.5927155,428.387867,669.5681454,19.2780616,22.951132,0.9048271,70.331865),(45174,'tibia fibula',254,8,111,169.0844389,60.5674514,119.9656831,1.8,60.7688275,119.64168,1.2801847,10.1656735,10.4926248,4328.2381163,4704.6119981,25.8669829,448.3732218,425.7699335,667.4352183,19.2415198,22.7775173,0.9461609,69.7241944),(45175,'tibia fibula',254,8,112,169.2850162,60.6034855,119.8705253,1.8,60.8367634,119.5734892,1.3904292,10.1273373,11.1332634,4326.5067196,4661.8696661,27.3062081,418.7334385,427.2106853,669.1546573,19.0422033,22.7775173,0.9461609,68.7605586),(45176,'tibia fibula',254,8,113,168.8205274,60.6353074,119.7468922,1.8,60.8502359,119.4891507,1.4973055,10.0415032,11.5512188,4305.551775,4604.8842683,27.9850639,398.649213,428.7756196,669.5734885,19.0596715,22.6148187,0.893088,69.1165238),(45177,'tibia fibula',254,8,114,169.097475,60.6674491,119.6649799,1.8,60.9163425,119.3482151,-1.5113506,10.0358268,12.1449798,4296.9405375,4569.0312591,28.0834372,376.2074003,428.1600915,670.6482282,19.0596715,22.5289315,0.9616329,68.5088532),(45178,'tibia fibula',254,8,115,168.8254509,60.6963635,119.6086688,1.8,60.931265,119.3377598,-1.4155705,10.0963474,12.462166,4276.6370912,4534.2514267,27.4650265,363.8413611,423.5826007,678.8877069,19.0306842,22.3479072,0.9080668,67.5452174),(45179,'tibia fibula',254,8,116,169.2207867,60.7274058,119.5384926,1.8,60.9700242,119.2708874,-1.3266463,10.0591449,12.6563298,4254.8707748,4502.4933788,26.555418,355.7503204,422.9853369,678.759173,19.0306842,22.2817156,0.8809963,68.152888),(45180,'tibia fibula',254,8,117,169.799915,60.7700081,119.4636648,1.8,61.0246478,119.1930435,-1.2378042,9.910743,12.7398594,4227.8066767,4486.2740629,25.2762602,352.1447065,426.5882668,679.9420791,19.0430665,22.0861304,0.9234042,68.2571478),(45181,'tibia fibula',254,8,118,169.3473993,60.795645,119.4195549,1.8,61.0378417,119.1502986,-1.1730637,10.0727566,12.6840109,4200.2492706,4440.8090546,23.9902118,350.1107884,416.9910431,676.9387674,18.8704787,22.0861304,0.9234042,67.5452174),(45182,'tibia fibula',254,8,119,169.0208249,60.8323566,119.3598222,1.8,61.0872588,119.0509566,-1.0843403,10.0560743,12.6912874,4174.7847918,4409.7552775,22.013484,347.4631947,415.1505532,676.222253,18.8380371,21.9519689,0.8685394,66.5815817),(45183,'tibia fibula',254,8,120,169.1239389,60.8717698,119.2884133,1.8,61.1341761,119.0210484,-1.0352179,10.1485637,12.6092213,4147.9581995,4399.2274088,20.8460625,348.8896974,408.7236705,677.6334435,18.6771316,21.8296729,0.9391057,66.3298762),(45184,'tibia fibula',254,8,121,169.5410389,60.93778,119.1393214,1.8,61.1832175,118.9251453,-0.9657055,10.2701467,12.5318037,4114.1094432,4393.3830086,19.1136244,350.5786642,400.5891585,678.7736062,18.7541465,21.9519689,0.8685394,66.2256165),(45185,'tibia fibula',254,8,122,169.26107,60.9709256,119.0798838,1.8,61.2090085,118.8406364,-0.8884801,10.2748036,12.4109479,4084.2850274,4361.7394764,16.9924942,351.442897,397.5049246,677.5365974,18.5611417,21.8845797,0.8131688,66.2256165),(45186,'tibia fibula',254,8,123,168.2312163,60.9941618,119.0422468,1.8,61.2233577,118.7784415,-0.787181,10.0313328,12.1861517,4046.4922976,4308.1904682,14.0692559,353.5316629,403.38531,672.5942472,18.455861,21.6768972,0.8836721,65.7222057),(45187,'tibia fibula',254,8,124,167.2513811,61.0313199,118.9938009,1.8,61.2995353,118.718048,-0.7244865,10.1123905,11.9514742,4001.3269906,4283.9634945,12.2438844,358.4464489,395.6855675,670.2953425,18.4547701,21.6257322,0.8557046,65.3662405),(45188,'tibia fibula',254,8,125,166.8470934,61.0723705,118.9506709,1.8,61.3256451,118.6587466,-0.663269,10.0854807,11.7512514,3953.5436984,4263.1678016,10.5414447,362.7841529,392.0034975,667.9166817,18.2641351,21.5915548,0.7431698,65.3662405),(45189,'tibia fibula',254,8,126,166.8737811,61.1234028,118.8969083,1.8,61.3910485,118.6322976,-0.6436357,10.0914568,11.6117544,3909.6824811,4247.7670435,10.0160218,365.8161275,387.4249829,667.05923,18.3772802,21.4069164,0.8991902,64.7585699),(45190,'tibia fibula',254,8,127,167.0007294,61.1683029,118.8395886,1.8,61.4222253,118.5923232,-0.630353,10.011889,11.4943818,3869.6209891,4238.4346136,9.6701129,368.7396744,386.5025857,666.9791939,18.1922948,21.346457,0.6998929,64.4026047),(45191,'tibia fibula',254,8,128,166.8709277,61.2136115,118.7702442,1.8,61.4428471,118.5390275,-0.6354961,9.9551465,11.4352194,3830.3595187,4229.9566576,9.7990353,369.9060353,384.7617427,667.6010333,18.1808294,21.3031666,0.7283174,64.4026047),(45192,'tibia fibula',254,8,129,165.5646859,61.244481,118.6603598,1.8,61.4809221,118.4210436,-0.6157314,9.8501052,11.274533,3774.9305945,4194.8544092,9.2045867,372.0645816,383.2375928,666.0925813,18.0691367,21.072243,0.6842948,63.8991939),(45193,'tibia fibula',254,8,130,165.0630469,61.2849198,118.6099481,1.8,61.5055662,118.3690136,-0.6096732,9.8641835,11.1899853,3739.1286122,4178.4586843,9.0198777,373.4105599,379.0611365,665.3098977,18.0691367,21.072243,0.8865015,63.8991939),(45194,'tibia fibula',254,8,131,164.9506453,61.3365835,118.5548636,1.8,61.5612549,118.2884394,-0.6051939,9.7681958,11.0993179,3697.6742617,4170.7281069,8.8983104,375.7643633,378.5421934,665.3415296,17.8774108,21.0196062,0.7130608,63.5432287),(45195,'tibia fibula',254,8,132,164.5541346,61.3790229,118.4941974,1.8,61.5707366,118.1942459,-0.6044787,9.6837822,11.0272219,3659.4681537,4147.9351304,8.8585711,376.1541373,377.8965777,664.3415169,17.995844,20.9844416,0.8288491,63.5432287),(45196,'tibia fibula',254,8,133,164.0616713,61.4255251,118.4442999,1.8,61.6219503,118.1329263,-0.6065893,9.565062,11.0765419,3616.2455604,4122.0878825,8.886078,372.1457398,378.0681759,662.2567095,17.8108585,20.8032903,0.6682894,62.6838527),(45197,'tibia fibula',254,8,134,163.8459878,61.4711203,118.3897041,1.8,61.6686916,118.0883536,-0.6013858,9.5804617,10.9916965,3583.7390118,4104.1538935,8.7415499,373.3867556,374.0674642,661.9452511,17.8087943,20.7410714,0.6973908,62.6838527),(45198,'tibia fibula',254,8,135,163.5467165,61.5216376,118.3350732,1.8,61.7097569,118.0687502,-0.5979225,9.5947278,10.9082026,3551.851332,4087.571956,8.6376201,374.7246087,370.1878145,661.9579036,17.87632,20.7410714,0.6973908,62.6838527),(45199,'tibia fibula',254,8,136,163.5863843,61.5736805,118.2727191,1.8,61.7457677,118.0047247,-0.6098032,9.5169415,10.8667792,3518.9453214,4078.9571721,8.9425129,375.3602683,369.7559065,662.9971897,17.6845941,20.5398055,0.6518691,62.4321473),(45200,'tibia fibula',254,8,137,163.2940507,61.6049925,118.1762243,1.8,61.7423447,117.9359492,-0.6116451,9.4748392,10.7912862,3478.1096601,4054.6868621,8.9736319,375.7371247,367.0890436,662.9703047,17.6835033,20.4677674,0.6812982,62.4321473),(45201,'tibia fibula',254,8,138,163.1436038,61.6436853,118.1246027,1.8,61.7747557,117.8806394,-0.6112275,9.3529763,10.728745,3446.5695223,4037.5711703,8.9546907,376.3321043,368.4997585,662.4431682,17.4928683,20.4677674,0.6812982,61.8244767),(45202,'tibia fibula',254,8,139,163.637242,61.6955215,118.0662845,1.8,61.8574863,117.8141453,-0.615872,9.3730861,10.6662236,3421.7218549,4037.9335018,9.1010451,378.5719924,365.0581895,664.8216342,17.4928683,20.413572,0.7109094,61.8244767),(45203,'tibia fibula',254,8,140,164.0934503,61.7444108,118.0131074,1.8,61.9415595,117.7751984,-0.6271561,9.3917078,10.6270207,3396.8400264,4029.3895347,9.4185921,379.1645514,361.6850195,666.0766219,17.4917774,20.1999066,0.6647745,61.2168061),(45204,'tibia fibula',254,8,141,164.4199688,61.7762936,117.9683496,1.8,61.9382905,117.7299023,-0.6300481,9.3157583,10.5827246,3373.961791,4018.4458374,9.5127196,379.7175114,362.1779031,666.3252176,17.3022333,20.1999066,0.6647745,61.2168061),(45205,'tibia fibula',254,8,142,164.878583,61.8225974,117.9153985,1.8,61.9768922,117.6985948,-0.6361778,9.3354121,10.5302276,3346.3195738,4013.4055673,9.6999413,381.1318936,358.4544031,659.3133187,17.3011424,20.1999066,0.9060218,61.2168061),(45206,'tibia fibula',254,8,143,164.7011127,61.8643485,117.8649342,1.8,62.0074624,117.6472472,-0.6455305,9.2715447,10.5750587,3316.3390387,3993.4690615,9.9355773,377.6309138,357.6900244,658.6554806,17.3011424,20.1358234,0.6947383,61.2168061),(45207,'tibia fibula',254,8,144,164.4973463,61.9121989,117.8242203,1.8,62.0596068,117.5814587,-0.6511965,9.1831637,10.5228109,3285.977873,3978.9762481,10.0728268,378.1286483,357.8263425,658.1285863,17.3011424,20.0300987,0.6177557,60.7133953),(45208,'tibia fibula',254,8,145,163.3560982,61.9376973,117.7554849,1.8,62.0603001,117.5150459,-0.6467667,9.1410791,10.6278472,3243.2948084,3944.2873289,9.8867992,371.1275923,354.8043705,654.4390894,17.3000516,20.1358234,0.6947383,60.6091355),(45209,'tibia fibula',254,8,146,162.977603,61.9908456,117.720061,1.8,62.1146991,117.50514,-0.6415331,9.1374324,10.5494266,3209.5400335,3923.5401478,9.7273676,371.9197552,351.2518513,653.0881784,17.2318222,20.1358234,0.6947383,60.3574301),(45210,'tibia fibula',254,8,147,162.6237814,62.0416632,117.6790039,1.8,62.1627761,117.4440905,-0.6419543,9.0530208,10.4853324,3173.5226568,3898.0439595,9.717198,371.7616002,350.5484776,651.2537853,17.2410636,20.0899245,0.7248661,60.0014649),(45211,'tibia fibula',254,8,148,162.3458266,62.0910445,117.6372148,1.8,62.2228179,117.3999716,-0.6422997,9.057085,10.4217324,3139.1345863,3876.3965894,9.7095528,371.953188,346.5943594,644.5198799,17.0874585,20.0623347,0.7551044,60.0014649),(45212,'tibia fibula',254,8,149,162.1168273,62.136741,117.5935581,1.8,62.2529011,117.3391721,-0.644236,9.0654341,10.4499011,3104.8861226,3853.6125253,9.7460769,368.7702397,342.4972359,642.939201,17.0874585,19.9377084,0.6478114,59.7497595),(45213,'tibia fibula',254,8,150,161.5932004,62.1783721,117.5578665,1.8,62.283495,117.3142751,-0.6480712,8.9869884,10.4034684,3069.513855,3824.1835243,9.8139067,367.5873631,341.5508882,640.0904317,17.0633979,19.8634868,0.6781193,59.7497595),(45214,'tibia fibula',254,8,151,160.7926817,62.2239866,117.5253015,1.8,62.3085232,117.3109819,-0.6505794,8.8906181,10.3527873,3035.5893835,3796.6836216,9.8300319,366.7305723,341.4373829,637.5093911,17.0633979,19.8634868,0.6781193,59.8540193),(45215,'tibia fibula',254,8,152,159.9476836,62.2723476,117.4935227,1.8,62.3709458,117.2563108,-0.6552337,8.8040006,10.3048192,3000.1413846,3764.1372289,9.8981158,365.2793079,340.7702385,634.3389101,16.8746883,19.8076381,0.7086263,59.8540193),(45216,'tibia fibula',254,8,153,158.7188193,62.3319201,117.4243035,1.8,62.4313265,117.2317912,-0.6579723,8.8216988,10.2982177,2959.976201,3729.3007334,9.8921238,362.1306938,335.533581,632.6923445,16.8746883,19.6813991,0.6304014,58.8903835),(45217,'tibia fibula',254,8,154,158.1976541,62.3788409,117.3937484,1.8,62.4936958,117.1983714,-0.6629308,8.8151334,10.2493648,2929.3824389,3702.4521293,9.9863203,361.2372288,332.3128863,630.3437525,16.8746883,19.5967879,0.6610432,58.8903835),(45218,'tibia fibula',254,8,155,157.4351808,62.4244995,117.368076,1.8,62.5327792,117.1685043,-0.6625631,8.807447,10.1970672,2898.2549985,3673.5685884,9.9288289,360.2573672,329.0686838,627.4395438,16.8746883,19.5967879,0.6610432,58.8903835),(45219,'tibia fibula',254,8,156,156.6768478,62.4655997,117.3488248,1.8,62.5742851,117.1570085,-0.6690151,8.7937537,10.1616384,2865.2411558,3640.2924178,10.0446851,358.2387298,325.82686,623.4331782,16.8623594,19.5307258,0.6919214,58.6386781),(45220,'tibia fibula',254,8,157,156.447177,62.5057895,117.3285975,1.8,62.6055065,117.1284517,-0.671528,8.7140408,10.1209095,2836.9019314,3612.0268398,10.0937531,356.8875741,325.5552734,620.3431885,16.7917079,19.4834015,0.7229794,58.6386781),(45221,'tibia fibula',254,8,158,156.3400906,62.5517721,117.3084739,1.8,62.6760779,117.1029902,-0.675567,8.7007285,10.0776815,2805.2033897,3593.1285666,10.1894655,356.5431752,322.4101732,617.9946349,16.6765733,19.33596,0.6435011,58.3869727),(45222,'tibia fibula',254,8,159,156.0541911,62.5962761,117.2924968,1.8,62.7199363,117.0878563,-0.6784914,8.6848161,10.036735,2777.8384808,3574.0338165,10.2451122,356.0952668,319.8500073,615.7688217,16.656374,19.33596,0.6435011,58.0310075),(45223,'tibia fibula',254,8,160,155.6825217,62.6355299,117.2834707,1.8,62.7422799,117.086242,-0.6818147,8.6663711,10.0047527,2750.7057318,3547.2590203,10.3050371,354.5573901,317.3999467,612.2792823,16.656374,19.2594195,0.6747409,58.0310075),(45224,'tibia fibula',254,8,161,154.8265017,62.6597696,117.2361403,1.8,62.7370166,117.0523685,-0.6841403,8.6256627,9.958958,2712.7020814,3511.7107594,10.3071323,352.618291,314.4920182,608.2532825,16.5820771,19.2594195,0.6747409,57.6750423),(45225,'tibia fibula',254,8,162,154.5823961,62.705354,117.2236016,1.8,62.8130049,117.0479612,-0.6931886,8.6082683,9.9264712,2684.949741,3490.254082,10.5196472,351.6107601,311.9035836,605.5519947,16.5337585,19.201814,0.7061991,57.4233369),(45226,'tibia fibula',254,8,163,154.4700505,62.7484044,117.2091301,1.8,62.8334109,117.0224888,-0.701227,8.5924686,9.8931229,2662.2695609,3474.2336639,10.7157362,351.1766393,309.8375676,603.873718,16.5337585,19.201814,0.7061991,57.4233369),(45227,'tibia fibula',254,8,164,154.651661,62.7950509,117.1978426,1.8,62.8869063,116.9844458,-0.7100953,8.5706118,9.8595954,2639.1132449,3455.0125716,10.9540158,350.4213354,307.9258874,601.7739846,16.5337585,19.0812438,0.625485,57.1716315),(45228,'tibia fibula',254,8,165,154.5536383,62.8392315,117.1919228,1.8,62.9340102,116.9704225,-0.7191845,8.5448647,9.8312808,2615.9129542,3434.8133455,11.1788563,349.3759785,306.1386061,599.204924,16.4565968,19.0812438,0.9453113,56.8156663),(45229,'tibia fibula',254,8,166,154.3980441,62.8836886,117.1850198,1.8,62.9659563,116.9632955,-0.7283101,8.518275,9.8017738,2593.9214451,3413.8451073,11.4006467,348.2885026,304.5125285,596.7158838,16.4565968,18.9939594,0.6570749,56.8156663),(45230,'tibia fibula',254,8,167,153.8341898,62.9334978,117.177091,1.8,62.9939232,116.9737944,-0.7407369,8.4859737,9.7699104,2565.4088724,3389.6301003,11.6759675,346.9458738,302.3116699,593.4533711,16.4535084,18.9939594,0.6570749,56.5639609),(45231,'tibia fibula',254,8,168,153.5410169,62.9864426,117.170297,1.8,63.0450397,116.9602048,-0.7508206,8.4497468,9.7340476,2542.8683968,3363.5380613,11.9109453,345.5436231,300.9401897,590.612183,16.4043042,18.9939594,0.9137214,56.5639609),(45232,'tibia fibula',254,8,169,152.4925322,63.0462282,117.1242587,1.8,63.0716106,116.9498965,-0.7577667,8.4378004,9.6805605,2510.9280284,3325.0313065,12.0058032,343.475083,297.5808744,587.7285327,16.3851124,18.9257932,0.6889244,56.5639609),(45233,'tibia fibula',254,8,170,152.2239769,63.0923167,117.1199051,1.8,63.1394878,116.9376762,-0.7703215,8.3990891,9.6443971,2488.5625925,3293.9172229,12.3028834,341.5368738,296.2895815,583.9953901,16.328144,18.8769524,0.7209713,56.2079957),(45234,'tibia fibula',254,8,171,151.7199322,63.131517,117.1143543,1.8,63.157497,116.9323048,-0.7821421,8.3645876,9.6115749,2465.8147094,3264.6094723,12.5609943,339.6539589,294.792143,587.4760579,16.328144,18.7345939,0.638914,55.9562903),(45235,'tibia fibula',254,8,172,150.8434907,63.1733034,117.1107511,1.8,63.2266762,116.9259039,-0.7935051,8.3353252,9.5924211,2441.1117411,3234.7866958,12.7740941,337.2231752,292.8634078,583.4989868,16.329179,18.7345939,0.638914,56.0605501),(45236,'tibia fibula',254,8,173,149.9456767,63.218297,117.1100375,1.8,63.2758476,116.9171191,-0.8035361,8.3039425,9.5763871,2416.3434085,3203.3928545,12.948657,334.5095407,290.9874938,579.2922738,16.2474333,18.7345939,0.638914,56.0605501),(45237,'tibia fibula',254,8,174,149.0097055,63.2627402,117.1128968,1.8,63.3176485,116.9265517,-0.8109311,8.2693591,9.5590478,2393.0409415,3169.6670593,13.0513088,331.5881603,289.3865069,574.7715947,16.2405226,18.6555863,0.6711438,56.0605501),(45238,'tibia fibula',254,8,175,148.1131784,63.3073518,117.1160661,1.8,63.3645585,116.9461344,-0.8178991,8.2336521,9.5411707,2368.9324909,3139.355574,13.1445036,329.0325331,287.7134558,570.4811609,16.2329838,18.6555863,0.6711438,56.0605501),(45239,'tibia fibula',254,8,176,146.8679769,63.3438974,117.1240852,1.8,63.4263058,116.9716656,-0.8254942,8.2239699,9.533256,2344.5495925,3103.2596392,13.2194163,325.5193874,285.0873282,565.0317542,16.1032708,18.6555863,0.8996525,55.4528795),(45240,'tibia fibula',254,8,177,145.2597222,63.5326135,117.1082186,1.8,63.5640704,116.9926047,-0.8312495,8.0969916,9.4024858,2311.3963383,3063.5000071,13.2134809,325.8180935,285.4635967,564.3655676,16.0367949,18.4815797,0.6202495,55.2011741),(45241,'tibia fibula',254,8,178,144.511404,63.5718604,117.1083048,1.8,63.6073241,116.9977938,-0.8411001,8.1025068,9.3908552,2287.7338944,3031.9446518,13.381437,322.861399,282.3489003,559.8239574,16.0152826,18.4815797,0.9505468,55.2011741),(45242,'tibia fibula',254,8,179,143.5319604,63.6089213,117.1182043,1.8,63.6430752,117.0345239,-0.8478613,8.2807328,9.3454283,2263.6328959,2998.0600438,13.4513567,320.8049917,273.3614209,560.8885424,16.1032708,18.3210418,0.6857295,54.8452089),(45243,'tibia fibula',254,8,180,142.6614496,63.6440567,117.1296518,1.8,63.6744387,117.0321225,-0.8562252,8.2813317,9.3375504,2242.1539145,2963.648136,13.5668765,317.3903223,270.7479897,555.6170428,15.898456,18.3210418,0.6857295,54.4892437),(45244,'tibia fibula',254,8,181,141.5240619,63.6806559,117.1440547,1.8,63.7174223,117.061502,-0.8633041,8.2408143,9.3299404,2218.2549432,2931.8654113,13.6238396,314.2426746,269.1790965,550.2570765,15.898456,18.3210418,0.8850668,54.4892437),(45245,'tibia fibula',254,8,182,140.5901048,63.7253468,117.1564217,1.8,63.7462814,117.0954388,-0.8705646,8.19472,9.3157475,2191.2901641,2904.5782968,13.7017986,311.792297,267.4026881,545.401699,15.898456,18.3210418,0.8850668,54.4892437),(45246,'tibia fibula',254,8,183,139.1782872,63.763269,117.1762871,1.8,63.7774144,117.1094398,-0.8767972,8.1490061,9.2555894,2166.7158317,2870.5909451,13.7065304,310.1467464,265.8871295,544.2155308,15.7994355,18.2705844,0.71883,54.5935035),(45247,'tibia fibula',254,8,184,138.0528166,63.8050169,117.2021767,1.8,63.8228051,117.1244267,-0.8796863,8.1556254,9.2491674,2146.4915754,2838.0438437,13.6610238,306.8431689,263.1915344,538.8733566,15.7994355,18.2402429,0.7520772,54.5935035),(45248,'tibia fibula',254,8,185,136.6397681,63.8973831,117.1878555,1.8,63.9730562,117.1135803,-0.8900943,8.0915978,9.1806354,2115.4929808,2798.8371481,13.7535372,304.863121,261.4431689,535.2703657,15.7994355,18.0520106,0.6673061,53.9858329),(45249,'tibia fibula',254,8,186,135.701391,63.9363717,117.2205436,1.8,64.0267858,117.1599578,-0.8983731,8.0385316,9.1823072,2094.2068125,2770.1961624,13.8419053,301.6884655,260.5210663,529.7471868,15.4956002,18.0520106,0.6673061,53.7341275),(45250,'tibia fibula',254,8,187,134.9230842,63.9705695,117.2442074,1.8,64.0352898,117.1797352,-0.9073538,7.9940107,9.1061286,2076.5119833,2740.0270472,13.9589178,300.8992258,259.7584693,527.8465426,15.4956002,17.9905393,0.7008544,53.7341275),(45251,'tibia fibula',254,8,188,134.0918495,64.0074151,117.2720436,1.8,64.0430989,117.2199474,-0.9166578,8.1259378,9.0999642,2056.7914004,2713.5452231,14.0742178,298.1929547,253.1143418,522.9895636,15.7994355,17.9905393,0.7008544,53.9858329),(45252,'tibia fibula',254,8,189,133.0733535,64.0473775,117.3029983,1.8,64.1026435,117.251113,-0.9277755,8.1456538,9.0932831,2036.9370992,2683.5673259,14.2047155,295.1153382,250.0642865,517.7003225,15.7994355,17.9905393,0.8699419,53.9858329),(45253,'tibia fibula',254,8,190,132.5040163,64.085225,117.3348619,1.8,64.1328871,117.3056464,-0.9393395,8.0855847,8.9277824,2020.0060788,2660.8454577,14.3881876,298.0410305,249.8280785,524.1459067,15.7994355,17.7892908,0.648332,53.3781623),(45254,'tibia fibula',254,8,191,132.2730587,64.1260541,117.3739215,1.8,64.1577636,117.3288567,-0.9501703,8.0186767,8.9376482,2005.0376749,2643.264237,14.5898501,295.7449412,250.0459548,519.9792383,15.732869,17.7892908,0.9224643,53.3781623),(45255,'tibia fibula',254,8,192,132.1687697,64.1720007,117.4186367,1.8,64.2198928,117.3740608,-0.9640946,7.9400475,8.9497832,1995.0692831,2627.0308578,14.867148,293.5301118,251.2666692,516.4051328,15.468768,17.7892908,0.9224643,53.0221971),(45256,'tibia fibula',254,8,193,131.5942851,64.2053167,117.4131571,1.8,64.2326183,117.3749511,-0.976151,7.9010745,8.9273245,1980.1736343,2603.6468943,15.0491047,291.6491842,250.6208032,513.4562453,15.468768,17.7892908,0.9224643,53.0221971),(45257,'tibia fibula',254,8,194,131.4919544,64.2485151,117.4520552,1.8,64.2796314,117.400075,-0.9889357,7.9495675,8.9357642,1970.0524999,2589.5421367,15.2960776,289.7952634,247.8188264,510.2616422,15.468768,17.7892908,0.9224643,53.0221971),(45258,'tibia fibula',254,8,195,131.2972518,64.2836028,117.4859711,1.8,64.2987809,117.4286111,-1.0010977,7.891822,8.8143808,1957.1203627,2575.8149328,15.5165125,292.228688,247.993474,512.7478074,15.468768,17.7164901,0.8884798,53.0221971),(45259,'tibia fibula',254,8,196,131.1626944,64.3244887,117.528367,1.8,64.3406527,117.4495874,-1.0141763,7.9120767,8.819145,1945.4145493,2566.2792583,15.7587285,290.9895743,245.8791318,509.8030539,15.468768,17.7164901,0.8884798,53.0221971),(45260,'tibia fibula',254,8,197,130.8223565,64.3573814,117.5808457,1.8,64.3699271,117.519668,-1.0269188,7.8319403,8.8369256,1932.4912394,2554.3461792,15.965501,289.0537148,246.7448897,505.7007708,15.468768,17.7164901,0.8884798,53.3781623),(45261,'tibia fibula',254,8,198,130.2470886,64.3886041,117.6299849,1.8,64.4198262,117.5730661,-1.0401134,7.9065637,8.8522598,1919.9525505,2539.4099581,16.1471675,286.8657303,242.8302147,501.4011053,15.468768,17.7164901,0.8884798,53.3781623),(45262,'tibia fibula',254,8,199,129.6458044,64.4224687,117.684385,1.8,64.4663106,117.6169399,-1.052109,7.8321043,8.8717803,1907.7096237,2523.5475501,16.2973705,284.4465783,243.5756144,496.8801109,15.03908,17.7164901,0.8884798,53.0221971),(45263,'tibia fibula',254,8,200,129.2916471,64.4607485,117.730811,1.8,64.5026973,117.6918419,-1.0621837,7.7603094,8.8840873,1898.4740394,2513.546193,16.4386604,282.9267772,244.6389615,493.8541697,15.03908,17.7164901,0.8884798,52.6662319),(45264,'tibia fibula',254,8,201,128.6647383,64.5794077,117.713882,1.8,64.5777661,117.6906751,-1.0753307,7.6730775,8.7996313,1884.8939187,2504.1995849,16.596797,284.5800585,245.6503154,495.8272366,15.03908,17.6381559,0.9760371,52.6662319),(45265,'tibia fibula',254,8,202,128.6328474,64.6186526,117.7579561,1.8,64.6504268,117.7461136,-1.0900397,7.7594129,8.8054586,1880.9247546,2505.6824368,16.8539013,284.5601277,242.4055494,494.7553762,15.4058319,17.6381559,0.9760371,52.7704917),(45266,'tibia fibula',254,8,203,128.5600017,64.6605857,117.7987911,1.8,64.7053522,117.7559535,-1.1068997,7.6649997,8.8044951,1874.06012,2504.809434,17.1370647,284.492115,244.4957846,493.3076867,15.4058319,17.6381559,0.9760371,52.7704917),(45267,'tibia fibula',254,8,204,128.59704,64.7080941,117.84314,1.8,64.7581674,117.8079775,-1.1222598,7.5806428,8.8054802,1868.5929738,2507.8807284,17.4023958,284.8090801,246.4953197,492.4518521,15.3557368,17.6381559,0.9760371,52.7704917),(45268,'tibia fibula',254,8,205,128.3725725,64.7565747,117.8834438,1.8,64.8096409,117.808185,-1.1366125,7.6784883,8.6510434,1863.0938413,2507.1266248,17.6092225,289.8062717,242.6381027,497.2544134,15.03908,17.533166,0.942,52.4145265),(45269,'tibia fibula',254,8,206,128.3170711,64.8075103,117.9289289,1.8,64.8552348,117.8676727,-1.1486894,7.5891712,8.6720417,1857.5301111,2511.166743,17.7967124,289.5704192,244.7606007,496.7419643,15.03908,17.533166,0.942,53.0221971),(45270,'tibia fibula',254,8,207,128.3575222,64.8598909,117.9820019,1.8,64.8625678,117.9491443,-1.1632876,7.4895904,8.6997236,1851.1163787,2518.2121465,18.0326878,289.4588698,247.1585609,496.1475045,15.03908,17.6381559,0.9760371,53.0221971),(45271,'tibia fibula',254,8,208,127.5105659,64.9189367,118.0345452,1.8,64.9318614,118.025797,-1.1774435,7.5489401,8.7245567,1844.1970082,2514.9539767,18.1296825,288.2615186,244.2988013,494.5357816,15.03908,17.6381559,0.9760371,53.0221971),(45272,'tibia fibula',254,8,209,126.3660727,65.0191493,118.0518339,1.8,65.0032354,118.0638381,-1.1932606,7.4901328,8.7016114,1830.1287876,2507.7340685,18.1990585,288.1919155,244.3386293,494.5703473,15.03908,17.6381559,0.9760371,52.7704917),(45273,'tibia fibula',254,8,210,125.6721929,65.072195,118.1004939,1.8,65.0621791,118.1026914,-1.2048264,7.4021799,8.7263203,1821.8238191,2504.3560471,18.2630959,286.9887829,246.1199063,492.6860799,14.609392,17.6381559,0.9760371,52.4145265),(45274,'tibia fibula',254,8,211,124.8976346,65.1238697,118.1497834,1.8,65.0953278,118.1336017,-1.2098012,7.3805275,8.7534049,1820.1926945,2500.8165863,18.2193579,285.6964376,246.6209498,491.4424995,14.609392,17.6381559,0.9760371,52.6662319),(45275,'tibia fibula',254,8,212,123.6962412,65.17734,118.1984198,1.8,65.145798,118.1695655,-1.2183595,7.3925331,8.7793155,1816.7138541,2490.4048988,18.1595718,283.667319,245.7498434,489.265842,14.609392,17.6381559,0.9760371,52.6662319),(45276,'tibia fibula',254,8,213,122.8686992,65.225761,118.2407334,1.8,65.1944118,118.2152255,-1.2259271,7.3684177,8.8016089,1816.5091427,2487.067288,18.1375955,282.5696193,246.5263531,488.3772483,15.03908,17.6381559,0.9760371,53.0221971),(45277,'tibia fibula',254,8,214,122.0929101,65.2772482,118.2836097,1.8,65.2493338,118.2628757,-1.2356137,7.3710539,8.8235247,1811.4873743,2491.3029202,18.1470233,282.3478144,245.7569036,487.580301,15.03908,17.7633248,1.0096329,53.0221971),(45278,'tibia fibula',254,8,215,121.277565,65.3280342,118.3381073,1.8,65.3388372,118.347123,-1.2473014,7.2727459,8.8567074,1805.9305652,2495.0454937,18.1704299,281.7125351,248.3148159,485.5101434,15.03908,17.7633248,1.0096329,53.0221971),(45279,'tibia fibula',254,8,216,120.7075004,65.370109,118.3877695,1.8,65.3800854,118.3462016,-1.2601264,7.3408444,8.888008,1803.9465044,2502.5508247,18.2378901,281.5648717,245.7410081,484.3450241,14.609392,17.7633248,1.0096329,52.6662319),(45280,'tibia fibula',254,8,217,119.8618309,65.4654549,118.4470992,1.8,65.4547353,118.4136667,-1.2698761,7.3336726,8.9136004,1800.628989,2500.7659488,18.2219448,280.5562099,245.5289587,482.4144664,14.609392,17.8048522,1.226149,52.6662319),(45281,'tibia fibula',254,8,218,119.4628024,65.5100456,118.4993604,1.8,65.4820691,118.440428,-1.2791619,7.4052961,8.9483795,1800.9873639,2506.1545208,18.2645364,280.0679745,243.2026135,481.1473095,14.609392,17.8048522,1.226149,52.9179373),(45282,'tibia fibula',254,8,219,119.3250559,65.5584295,118.5505623,1.8,65.5209236,118.5177877,-1.2899605,7.3618339,8.861874,1805.8151292,2517.8230438,18.3598106,284.1185796,245.2941972,485.7432356,14.609392,17.7633248,1.0096329,53.0221971),(45283,'tibia fibula',254,8,220,120.346797,65.6058457,118.6131921,1.8,65.5807918,118.5794143,-1.3004638,7.4419281,8.9104319,1816.9075261,2540.5507615,18.6273433,285.1209447,244.1447301,487.8688178,15.03908,17.8876178,1.150133,53.3781623),(45284,'tibia fibula',254,8,221,120.7543856,65.6486268,118.6791438,1.8,65.6483528,118.7033034,-1.3116748,7.4075092,8.9637615,1824.3485724,2553.5238253,18.8043849,284.8719055,246.2836733,487.8768662,15.03908,17.9082494,1.0427219,53.6298677),(45285,'tibia fibula',254,8,222,120.4224401,65.6909774,118.7314326,1.8,65.6914787,118.738295,-1.3217523,7.3812578,9.004114,1830.5194113,2553.5882535,18.8511052,283.6023894,247.9955937,486.8571817,15.03908,17.9082494,1.0427219,53.6298677),(45286,'tibia fibula',254,8,223,120.3812057,65.7330992,118.8012364,1.8,65.7589084,118.8194632,-1.3329889,7.4427251,9.0616892,1837.4645517,2558.7639642,18.9501218,282.371631,246.880616,485.1428382,15.03908,17.9545839,1.2036225,53.3781623),(45287,'tibia fibula',254,8,224,119.729959,65.774724,118.8609575,1.8,65.8211418,118.8627698,-1.3446039,7.4028857,9.0133032,1841.1097519,2557.1298328,18.9513287,283.7061815,248.7016329,483.7073243,14.609392,17.9545839,1.2036225,53.2739025),(45288,'tibia fibula',254,8,225,118.5150819,65.929587,118.9041211,1.8,65.9431059,118.9294997,-1.3539742,7.4757782,9.1174049,1839.4178277,2551.9343293,18.8383723,279.8970052,246.0503467,481.6449634,15.03908,17.99567,0.9894161,54.2375383),(45289,'tibia fibula',254,8,226,117.744552,65.9586268,118.9682198,1.8,65.9495462,118.9586335,-1.3587552,7.5218231,9.0834233,1842.8348037,2553.9420822,18.7549089,281.1651505,244.998425,481.5368129,15.03908,17.99567,0.9894161,53.9858329),(45290,'tibia fibula',254,8,227,117.5071043,66.0040878,119.0458909,1.8,66.0143124,119.0550166,-1.37122,7.5059408,9.0746431,1853.9421976,2550.1361476,18.814754,281.0177898,246.9966458,479.6068547,15.03908,17.99567,0.9894161,53.8815731),(45291,'tibia fibula',254,8,228,117.4676043,66.0375074,119.1308967,1.8,66.06453,119.1076454,-1.3776045,7.561655,9.1424994,1859.4083598,2558.9089996,18.8562712,279.8916236,245.8996565,477.599814,15.03908,18.1285566,1.0222469,53.8815731),(45292,'tibia fibula',254,8,229,116.9715043,66.0853027,119.2090734,1.8,66.1201874,119.1839199,-1.3893764,7.6332195,9.1934997,1865.1338068,2562.6519076,18.8606087,278.7460689,244.3443172,475.6632655,15.03908,18.1285566,1.0222469,53.8815731),(45293,'tibia fibula',254,8,230,116.3763186,66.1316239,119.2804048,1.8,66.154884,119.2970914,-1.3980906,7.6975714,9.242741,1874.8345361,2564.056231,18.8232511,277.4129704,243.5618259,474.2012126,15.03908,18.209851,1.2341215,54.2375383),(45294,'tibia fibula',254,8,231,116.3388328,66.1679179,119.3423524,1.8,66.1832157,119.3243576,-1.4096206,7.6813159,9.2803618,1879.8308664,2587.3066102,18.8904509,278.7937234,244.7277129,474.83916,15.03908,18.209851,1.2341215,54.2375383),(45295,'tibia fibula',254,8,232,115.5069827,66.1908905,119.4168983,1.8,66.1896798,119.3983923,-1.4184983,7.7232491,9.3364997,1886.6618918,2597.1354123,18.8080808,278.1701378,244.2834435,473.4206984,15.03908,18.3562794,1.2120257,53.9858329),(45296,'tibia fibula',254,8,233,114.5517091,66.2330281,119.4332496,1.8,66.2412291,119.4120378,-1.4342585,7.7786715,9.3207327,1894.5682164,2594.9771369,18.7382349,278.409135,243.559354,473.9112385,15.468768,18.280687,1.0545657,54.5935035),(45297,'tibia fibula',254,8,234,115.4271434,66.2663174,119.5000079,1.8,66.286269,119.3981041,-1.4411129,7.8246227,9.3707965,1914.1189027,2614.2182213,18.9161286,278.9750278,244.6276288,475.334901,15.468768,18.3562794,1.2120257,54.8452089),(45298,'tibia fibula',254,8,235,117.4653664,66.2977621,119.5823619,1.8,66.344958,119.4178336,-1.4444405,7.8679485,9.4427693,1939.7527602,2643.0788327,19.2666497,279.9050531,246.5385684,477.5984446,15.468768,18.4815797,1.2637506,55.0969143),(45299,'tibia fibula',254,8,236,117.7043806,66.3292989,119.6295935,1.8,66.368551,119.4711366,-1.4474191,7.9063225,9.4806384,1962.5614017,2667.5141528,19.3202942,281.3644013,248.2268334,480.7343779,15.468768,18.5115256,1.1902899,54.9494687),(45300,'tibia fibula',254,8,237,117.5722849,66.3536569,119.7053793,1.8,66.378483,119.5626257,-1.4508632,7.9922101,9.5470659,1990.998016,2682.6840003,19.3148708,280.9956504,249.1173282,481.9945823,15.468768,18.6159568,1.2417466,55.2011741),(45301,'tibia fibula',254,8,238,117.7321872,66.3829058,119.7636624,1.8,66.400996,119.6000587,-1.459979,8.0259676,9.5858999,2016.252111,2713.2097025,19.3820479,283.0417317,251.2160795,485.3778532,15.468768,18.6555863,1.3146449,55.2011741),(45302,'tibia fibula',254,8,239,117.90921,66.3980685,119.8345793,1.8,66.4094112,119.6615423,-1.468278,8.0456756,9.6400605,2038.6811953,2738.3819384,19.4457196,284.0627345,253.3884403,487.0817228,15.468768,18.7690551,1.2924967,55.4528795),(45303,'tibia fibula',254,8,240,118.2007603,66.3964613,119.9089647,1.8,66.4197098,119.7324889,-1.4695738,8.0510429,9.668461,2065.7080919,2757.5412108,19.4989679,285.209942,256.5764619,493.8325108,15.468768,18.7690551,1.2924967,55.4528795),(45304,'tibia fibula',254,8,241,118.8386911,66.5068701,119.918033,1.8,66.5527469,119.7705336,-1.4807972,8.1556551,9.6900502,2098.4427265,2790.7238089,19.6464523,287.9989016,257.2991002,495.9835663,15.898456,18.8916179,1.2706252,56.1648099),(45305,'tibia fibula',254,8,242,119.8537742,66.4995926,120.0158713,1.8,66.5558536,119.8688639,-1.5008509,8.1416917,9.7499289,2139.4052645,2837.6768827,19.8780602,291.0459063,262.7715905,500.0241992,15.898456,19.0715653,1.3203532,56.1648099),(45306,'tibia fibula',254,8,243,120.505972,66.4957658,120.1228935,1.8,66.5601697,119.9317406,-1.5054167,8.1408761,9.8477224,2178.3431243,2881.1228758,19.9986006,292.5674347,267.5809207,503.0383432,15.898456,19.1825737,1.2986504,56.4165153),(45307,'tibia fibula',254,8,244,120.6270457,66.5198811,120.2303373,1.8,66.5709726,120.0617877,-1.5070297,8.1701668,9.9227186,2202.8263492,2928.4593999,20.0228697,295.1267208,269.6182836,510.5213531,15.898456,19.2162315,1.3909428,57.0241859),(45308,'tibia fibula',254,8,245,121.8106473,66.5454826,120.3211739,1.8,66.5586712,120.1523596,-1.5232307,8.5283521,9.984994,2238.1765182,2990.1391906,20.2558766,299.4632935,262.4395074,515.9151158,16.328144,19.3884063,1.3473197,57.3801511),(45309,'tibia fibula',254,8,246,123.3092418,66.5614997,120.4507076,1.8,66.5683803,120.3012175,-1.5279719,8.5700838,10.0870047,2290.7107597,3055.6901793,20.5138733,302.9333547,267.2915226,525.4921513,16.328144,19.507078,1.4382448,58.2395271),(45310,'tibia fibula',254,8,247,123.2243672,66.5819103,120.5486334,1.8,66.6006454,120.3975166,-1.5228706,8.5960765,10.1904849,2324.2670453,3093.5503776,20.4902588,303.5724414,270.3869664,527.6886129,16.5933769,19.6391391,1.3948567,58.5954922),(45311,'tibia fibula',254,8,248,123.4087752,66.6062647,120.7084627,1.8,66.6107962,120.5454694,-1.5140085,8.6313779,10.0035353,2360.3916793,3140.6990203,20.5018712,313.9589087,273.4663821,534.259874,16.757832,19.7142053,1.2835149,58.5954922),(45312,'tibia fibula',254,8,249,125.6686681,66.6896577,120.7819879,1.8,66.6682159,120.6275087,-1.5060456,8.6939536,10.0906174,2425.3063731,3225.281967,20.8570863,319.6317768,278.9647253,546.3117328,16.757832,19.8076381,1.3521274,58.8471977),(45313,'tibia fibula',254,8,250,127.0551409,66.6942751,120.9306763,1.8,66.6589106,120.7363162,-1.4706564,8.7476216,10.3121559,2494.2725663,3289.7098424,20.9642142,319.0128121,285.1372271,551.6646926,16.757832,20.0116547,1.3101939,59.0989031),(45314,'tibia fibula',254,8,251,129.4737612,66.7032754,121.105155,1.8,66.7006564,120.9122907,-1.4422733,8.7803273,10.5336315,2588.3512429,3397.8644624,21.2244735,322.5729386,294.7898347,562.0940326,17.18752,20.3229251,1.3360737,60.0625388),(45315,'tibia fibula',254,8,252,131.6799431,66.7304739,121.2382426,1.8,66.6812895,121.0806886,-1.4013167,9.1047998,10.7156354,2701.9712854,3518.940545,21.322288,328.3930841,296.7633945,577.5803529,17.617208,20.6608003,1.2753555,61.27788),(45316,'tibia fibula',254,8,253,134.5701018,66.7318686,121.4379286,1.8,66.712273,121.2441172,-1.3513891,9.1791525,10.9511343,2826.7002146,3677.0911501,21.3658747,335.7726283,307.9478437,593.2585928,17.617208,20.9536242,1.3009472,61.6338452),(45317,'tibia fibula',254,8,254,139.6247604,66.7496255,121.6092391,1.8,66.7339379,121.4125067,-1.2832289,9.2090042,11.1194211,3012.878856,3896.5192565,21.3988781,350.4246511,327.1666302,621.1452532,18.2301179,21.3680693,1.3063079,63.1008918),(45318,'tibia fibula',254,8,255,145.3538285,66.7636034,121.77102,1.8,66.7553495,121.6137965,-1.2128691,9.2647395,11.2169963,3219.9963245,4165.0303517,21.2523376,371.3142305,347.5538987,654.9025934,18.476584,21.6768972,1.3306253,64.2119732),(45319,'tibia fibula',254,8,256,150.7327676,66.7569229,121.9244136,1.8,66.7252559,121.783902,-1.152736,9.3915,11.4007377,3431.3667444,4443.1709179,20.9813292,389.7266139,365.3694011,689.1356921,18.8377885,22.0944884,1.3352513,65.6790198),(45320,'tibia fibula',254,8,257,156.4932231,66.7989794,122.0730405,1.8,66.806982,121.93884,-1.0865023,9.451703,11.6524824,3633.4121101,4819.5625476,20.4284113,413.608223,384.4187791,716.4278332,19.1416238,22.6148187,1.3212094,66.894361),(45321,'tibia fibula',254,8,258,165.1388578,66.799958,122.3049999,1.8,66.7727085,122.1308063,-1.0458121,9.6144559,11.8607814,3865.8956356,5307.7471792,20.6093087,447.5040059,402.0919808,763.2520905,19.4454591,22.9672155,1.2667954,68.3614076),(45322,'tibia fibula',254,8,259,175.3465893,66.7800431,122.5219707,1.8,66.7974271,122.2884334,-1.0087271,9.9306161,12.2519624,4130.0546056,5855.6478909,20.924017,477.9355085,415.8910739,807.3622143,19.7492944,23.5075075,1.0335116,70.79209),(45323,'tibia fibula',254,8,260,185.0063561,66.6360164,122.6907869,1.8,66.7249361,122.4978296,-0.9799978,10.2139289,12.6831782,4308.0774568,6469.5741895,21.2672164,510.0909303,421.7845572,846.7829558,20.2012136,24.4318345,0.9730379,72.050617),(45324,'tibia fibula',254,8,261,190.2249453,66.562396,122.622787,1.8,66.6426634,122.611217,-0.9780658,10.6778986,13.0227506,4392.4561676,6865.2326413,21.8103975,527.1722444,411.3596071,862.1585061,20.5637544,25.0990762,0.9067502,73.4134038),(45325,'tibia fibula',254,8,262,189.0759202,66.5076083,122.3835888,1.8,66.5887726,122.5039011,-0.9477276,11.3191155,13.0763099,4280.1607843,7006.4806669,20.7823661,535.8148205,378.1356215,861.4673769,20.8960166,25.5871898,0.8567056,84.3946604),(45326,'tibia fibula',254,8,263,180.0776387,66.5646654,122.38337,1.8,66.6351618,122.521158,-0.8694754,11.8095614,13.2128944,3962.2713716,6860.4249581,17.5179986,519.2219639,335.5138478,813.5275373,21.2319117,26.2426472,0.6926418,92.797789),(45327,'tibia fibula',254,8,264,152.4085527,66.5678484,122.6558581,1.8,66.7550669,122.4875009,-0.7620551,12.4142871,13.4814824,3374.4793842,5910.2772085,12.1079818,438.3996545,271.8222443,661.1632122,21.1999303,26.5190958,0.7051113,95.0199518),(45328,'tibia fibula',254,8,265,82.0796232,65.9723714,123.0264004,1.8,66.604334,123.1342354,-0.3778632,12.550715,12.8386877,1616.1452693,3350.0148525,1.8620201,260.9312516,128.7691795,373.923357,13.1541462,25.2201601,0.4026547,81.0614162),(45329,'tibia fibula',254,8,266,15.0646662,62.4782122,122.5577617,1.8,64.0782881,122.0557369,-0.2271931,11.0126377,14.4423786,45.8402893,515.361732,0.1273836,35.6839927,4.1625168,38.8502521,6.6607029,9.3845276,0.2782997,26.0076877),(45330,'tibia fibula',254,8,267,0.0950574,60.575133,123.4522202,1.8,60.586008,123.443224,0.501418,0.4975658,0.5295333,0.0100291,0.0105721,0.0036604,0.0199649,0.0201564,0.0366858,1.289064,1.5492621,2.1587989,3.897729),(45331,'tibia fibula',254,8,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45332,'tibia fibula',254,8,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45333,'tibia fibula',254,8,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45334,'tibia fibula',254,8,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45335,'tibia fibula',254,8,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45336,'femur.tif',254,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45337,'femur.tif',254,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45338,'femur.tif',254,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45339,'femur.tif',254,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45340,'femur.tif',254,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45341,'femur.tif',254,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45342,'femur.tif',254,7,7,0.9660718,131.7934246,108.905266,1.8,131.8991392,108.8166014,-0.7392574,1.2360057,3.2832503,0.3008966,2.3189712,0.0730873,0.7063035,0.2434428,0.7919543,2.7345177,6.3877713,0.7378151,14.3755747),(45343,'femur.tif',254,7,8,17.2121576,133.4661503,110.5146013,1.8,133.5132347,110.8527449,0.4796069,6.0238166,6.4678229,95.08392,126.2834778,0.6107967,19.5248817,15.7846638,33.8997375,10.312512,12.2893773,0.9342881,40.8866733),(45344,'femur.tif',254,7,9,41.8688922,133.9058412,111.3449038,1.8,133.7460149,111.6722344,-0.5080362,7.5827735,13.6109337,314.0066261,515.3799331,1.651349,37.8651417,41.4105241,59.7825879,12.1081816,17.321277,0.7678561,49.9406583),(45345,'femur.tif',254,7,10,60.2720926,133.7031604,112.1480854,1.8,133.3858566,112.725706,-0.5789112,7.6939065,14.7070656,489.895155,1406.3584408,3.0068996,95.6246799,63.6731357,128.5303251,14.0989941,21.346457,0.6998929,59.8108334),(45346,'femur.tif',254,7,11,105.1299495,127.4191619,114.8281698,1.8,127.6246421,115.5344729,-0.282562,10.3672502,23.2092134,1315.9555507,13664.9512,1.3621146,588.7726985,126.9339047,644.8409174,9.485311,11.9697226,2.7744188,34.3065565),(45347,'femur.tif',254,7,12,199.0139214,123.0711659,116.812221,1.8,125.4687521,117.0264265,-0.2008269,9.6542215,23.4121499,3383.6808073,32784.8985023,1.3198651,1400.3369437,350.4871752,1540.5792472,18.9494994,44.7082053,0.2426477,138.7975324),(45348,'femur.tif',254,7,13,241.7411835,122.7444091,117.1599816,1.8,124.1340749,117.4297028,-0.1770467,10.3642445,24.4860488,5094.4413365,42778.6148946,1.2497776,1747.0607515,491.5400592,1954.5297216,20.2545795,46.6997918,0.2226609,125.3855935),(45349,'femur.tif',254,7,14,271.4022226,121.7092116,117.391931,1.8,123.2001909,117.6121921,-0.1749064,11.095765,26.2437615,6649.0870156,48462.8865714,1.3697468,1846.6440677,599.2454797,2096.6050164,21.68252,48.3184108,0.1607627,128.9705431),(45350,'femur.tif',254,7,15,286.1138505,121.0551972,117.4597124,1.8,123.0568835,117.7610187,-0.1759826,11.9107647,27.1988293,7962.5665644,51780.8974814,1.4616352,1903.7914076,668.518501,2193.8614828,22.9139564,49.1293316,0.2025413,132.3648613),(45351,'femur.tif',254,7,16,306.0214641,121.0805135,117.6186076,1.8,123.090359,117.9302898,-0.1482918,12.2618859,27.608449,9458.2018066,58150.1315815,1.113394,2106.2440547,771.3496829,2447.3117015,23.6594089,50.3193819,3.0988836,147.7472576),(45352,'femur.tif',254,7,17,315.5844391,120.9800608,117.6903688,1.8,122.9791782,118.0449262,-0.1320234,12.817489,27.9842653,10603.0992583,62132.2152345,0.9114687,2220.2553653,827.2368514,2585.3641453,24.427075,51.1978256,0.0503775,153.8239636),(45353,'femur.tif',254,7,18,317.6435869,120.8325144,117.7692775,1.8,122.7800192,118.1638498,-0.1319463,13.4408721,28.2541967,11207.4844123,63480.8800717,0.9163499,2246.7770251,833.8361006,2636.9700738,25.1302061,51.4370817,0.1088122,159.9438554),(45354,'femur.tif',254,7,19,313.8516978,120.6659377,117.8094014,1.8,122.5587044,118.2605063,-0.1403236,14.097055,28.1619904,11325.4912216,62448.6276377,1.0232513,2217.4791884,803.3941297,2612.3063934,26.0254615,51.3202913,0.2023216,165.369705),(45355,'femur.tif',254,7,20,306.6528489,120.8369433,117.8303301,1.8,122.3789364,118.3385986,-0.1482349,14.4673576,28.0516913,11221.5156124,59949.835758,1.1148421,2137.1201836,775.6437588,2536.5376606,26.4535144,51.0804882,0.2204938,135.967699),(45356,'femur.tif',254,7,21,293.054159,121.3938457,117.8240042,1.8,122.4044301,118.3851533,-0.1581897,14.6602944,27.4932193,10734.8972006,55548.1222407,1.2120687,2020.4298969,732.2429474,2409.8295712,26.6068078,50.6612903,0.2223488,134.8566176),(45357,'femur.tif',254,7,22,276.8180881,122.5133013,117.8057163,1.8,122.6724148,118.3895717,-0.1809016,14.6369245,26.0950994,10131.6391724,49724.94077,1.4934325,1905.5279294,692.1972694,2291.14816,26.3600254,50.2055079,0.1201087,169.8319187),(45358,'femur.tif',254,7,23,258.8329388,124.1228416,117.7668263,1.8,123.6085002,118.3703234,-0.2164729,14.3918918,24.5787374,9241.3044892,42170.3896174,1.9901283,1715.7264398,642.1188149,2091.223062,26.0516908,49.101138,0.1493227,163.6077671),(45359,'femur.tif',254,7,24,232.704633,126.6344689,117.7824885,1.8,126.5133394,118.4404818,-0.3336859,13.3440378,21.8553116,8202.5939902,30761.837252,4.1605456,1407.5222462,614.7010469,1777.9982621,23.6801907,42.9773929,0.2013171,145.143832),(45360,'femur.tif',254,7,25,224.6677236,127.3321916,117.7425943,1.8,127.1634797,118.404414,-0.3854686,13.1294685,20.6828292,8096.9638677,27082.306468,5.2935838,1309.4101479,616.7015725,1680.9636081,23.3177917,40.3495107,0.138885,140.9943976),(45361,'femur.tif',254,7,26,222.3340898,127.684484,117.7827661,1.8,127.356145,118.4211339,-0.4217512,12.7553365,19.9270045,8117.8681672,25628.5847142,6.2095914,1286.1232936,636.4291676,1664.9344795,23.0508758,38.8552962,0.1778753,138.8154206),(45362,'femur.tif',254,7,27,221.5072752,128.0119147,117.739706,1.8,127.5526442,118.3891477,-0.4423326,12.3964082,19.3277325,8031.3806043,24477.2268975,6.764306,1266.4303439,647.8796476,1652.3122104,22.4925399,37.7978927,0.1483278,135.6728078),(45363,'femur.tif',254,7,28,222.2828405,128.2187553,117.728205,1.8,127.7173828,118.3420609,-0.4543983,11.9700353,18.896397,8037.9387491,23657.1964902,7.1372176,1251.9421798,671.5050154,1621.3873977,22.3254875,37.0454856,0.6620605,131.670819),(45364,'femur.tif',254,7,29,221.8155543,128.4933858,117.6479085,1.8,127.9508166,118.2386273,-0.4584716,11.4842919,18.4069847,7984.2203903,22635.7145666,7.2413657,1229.7350672,695.2296641,1578.8170401,22.3076913,36.52348,0.6435011,128.8409856),(45365,'femur.tif',254,7,30,223.0049186,128.6964913,117.6285704,1.8,128.1854627,118.1335499,-0.4541085,11.2701823,17.8496197,8042.3273922,21763.7377569,7.1519078,1219.2829957,713.5933737,1555.7157875,22.1204693,35.9220196,0.6411088,123.8321752),(45366,'femur.tif',254,7,31,225.6643995,128.9472162,117.6459003,1.8,128.4625087,118.0365196,-0.4534723,10.965042,17.2475313,8200.9580615,20974.0829074,7.2183445,1216.062896,747.9185255,1541.2913334,22.2776237,35.237036,0.6556956,119.2835898),(45367,'femur.tif',254,7,32,227.4690352,129.2271321,117.6971656,1.8,128.7967949,118.004008,-0.4506101,10.9363871,16.8260736,8406.0929918,19896.9996915,7.1907948,1182.5099653,768.6352825,1505.3442557,22.0975916,34.7197476,0.6360755,114.6739305),(45368,'femur.tif',254,7,33,234.7590251,129.4995579,117.8419441,1.8,129.146724,118.054747,-0.4537663,11.3491649,16.5547312,8734.1658417,18435.3378165,7.5183163,1113.5993449,769.586651,1469.3996722,22.0786409,34.2243188,0.6786625,97.4074483),(45369,'femur.tif',254,7,34,237.4323254,129.6509567,117.9008309,1.8,129.2072419,118.0181544,-0.4646832,11.4324106,16.7402603,8903.5708805,17381.6883769,7.9472202,1038.316494,778.8008341,1445.0716843,21.8997534,33.7735861,0.6409566,95.6886963),(45370,'femur.tif',254,7,35,225.264364,129.3579867,117.7912318,1.8,129.1775991,117.9070502,-0.4987779,11.2761274,16.7575864,8600.5866841,16330.2208672,8.5908805,974.4971917,762.725212,1383.4242525,21.8920038,33.5184183,0.6306813,93.8656846),(45371,'femur.tif',254,7,36,211.5701691,129.1371478,117.5812774,1.8,129.2719604,117.8014785,-0.5320975,10.9203279,17.0321477,8132.5334214,15394.9751912,9.0762161,903.8775084,744.7151318,1308.4566372,21.6891592,33.2668435,0.6202495,93.6139791),(45372,'femur.tif',254,7,37,203.07638,129.0253434,117.4372373,1.8,129.196744,117.6838254,-0.5479776,10.9112739,16.8748018,7811.3735908,14680.9114238,9.1858687,869.9901557,715.8993218,1266.7121037,21.6747514,32.8282757,0.6461189,92.7546031),(45373,'femur.tif',254,7,38,195.7433093,128.9367136,117.3226445,1.8,129.1353897,117.6162196,-0.5658092,10.7118642,16.8525933,7524.0967166,13899.1609909,9.3761777,824.7490922,702.4077735,1227.4565641,21.3115634,32.2266,0.6435011,90.9315914),(45374,'femur.tif',254,7,39,191.4051899,128.8491267,117.1314712,1.8,129.0390462,117.4191607,-0.5752253,10.7069261,16.5598384,7265.5632415,13056.7632633,9.4414427,788.4595797,678.585356,1184.8140473,21.2484458,31.4700628,0.610726,89.2128394),(45375,'femur.tif',254,7,40,186.8471349,128.8383022,116.9714764,1.8,129.0529179,117.3054537,-0.5762772,10.6899544,16.1742007,7004.9685101,12427.238596,9.2465271,768.3371078,655.2851607,1166.2415118,21.1762054,30.6798436,0.6463022,86.782157),(45376,'femur.tif',254,7,41,181.8131215,128.7471709,116.664719,1.8,128.9585764,116.9654582,-0.5726565,10.5234476,15.7845776,6701.4464081,11719.4600378,8.8973123,742.4626956,636.8109259,1138.3558708,21.0562421,30.1700955,0.6235607,84.8548854),(45377,'femur.tif',254,7,42,179.126897,128.7391357,116.432888,1.8,128.9263163,116.6993233,-0.5700552,10.5381557,15.3004819,6524.7403024,11074.188648,8.6952048,723.7803806,619.1539095,1117.5787387,20.9202418,29.3228612,0.608325,82.7801682),(45378,'femur.tif',254,7,43,175.6566029,128.7590173,116.1694747,1.8,128.9662391,116.4161292,-0.5517517,10.4970418,14.7981308,6364.272261,10197.5730329,8.0440311,689.1122361,606.2919786,1083.4916196,20.8521308,28.4536526,0.6676656,80.245226),(45379,'femur.tif',254,7,44,176.7247816,128.7876001,115.8601877,1.8,128.9228907,116.0482769,-0.5337034,10.4327119,14.1014403,6237.8871164,9501.0583097,7.6227684,673.7651005,597.9161703,1077.1700321,20.7281786,27.4227137,0.618428,78.6307338),(45380,'femur.tif',254,7,45,174.1951025,128.8114047,115.5684171,1.8,128.960684,115.7354133,-0.5211846,10.2748832,13.4178241,6082.2230782,8863.0208014,7.1975147,660.5408396,591.9505828,1073.5011383,20.5626635,26.2250523,0.610726,76.3043112),(45381,'femur.tif',254,7,46,173.9785238,128.8171784,115.3416097,1.8,128.9576957,115.4659986,-0.5272921,10.2913757,13.0658231,5921.4641682,8310.3065986,7.3420482,636.0339125,575.381208,1070.7757746,20.5626635,25.5076926,0.5693132,74.8372646),(45382,'femur.tif',254,7,47,170.2122034,128.7819532,115.146545,1.8,128.9276375,115.2702266,-0.5325427,10.2540295,12.5571296,5810.1492172,7797.0336689,7.3130326,620.9248372,566.6210751,1061.0487543,20.5626635,24.687436,0.5493745,73.8736288),(45383,'femur.tif',254,7,48,170.1854038,128.7911285,114.9387909,1.8,128.8391116,115.0162629,-0.5188518,10.2536963,12.2122146,5752.9720483,7387.638043,6.9747755,604.9384418,561.0632354,1044.3993211,20.48701,24.0970318,0.3838176,73.1185126),(45384,'femur.tif',254,7,49,167.3638945,128.8088191,114.7133312,1.8,128.9025878,114.8508644,-0.5074381,10.2908937,11.8575005,5606.3066929,6967.0851048,6.5868149,587.5677696,544.7832649,1033.752075,20.3504695,23.5389032,0.3737268,71.9031714),(45385,'femur.tif',254,7,50,168.0090427,128.8043316,114.4875072,1.8,128.8423145,114.5769881,-0.4959002,10.2735046,11.7212534,5534.3256552,6597.0686843,6.3397693,562.8296297,538.6989028,1025.9721968,20.3504695,23.139407,0.3805064,70.79209),(45386,'femur.tif',254,7,51,166.8465339,128.7859007,114.2847292,1.8,128.7366301,114.379059,-0.4991582,10.2881165,11.5941253,5411.2417762,6286.3760944,6.3718929,542.2035663,525.9701115,1005.7386383,20.356965,22.8341879,0.3455556,69.8284542),(45387,'femur.tif',254,7,52,164.6442125,128.7490258,114.1518323,1.8,128.7275523,114.3604975,-0.4997867,10.3591882,11.2824518,5296.7506,6016.0483425,6.3022883,533.2217181,511.3094299,995.30268,20.356965,22.4303721,0.3520443,68.8648184),(45388,'femur.tif',254,7,53,164.2835651,128.7213815,113.971508,1.8,128.6062148,114.2333926,-0.4905411,10.3674172,11.1108582,5205.4324709,5756.0539979,6.0768016,518.0566509,502.0953965,978.0249733,20.2665861,22.0275353,0.3587707,68.2571478),(45389,'femur.tif',254,7,54,165.3498416,128.6703256,113.7763498,1.8,128.5630883,113.99236,-0.5098031,10.1977046,10.9807496,5117.3589681,5553.9705204,6.562991,505.7915668,501.8147881,970.9725429,20.0531297,21.6257322,0.3657473,67.5020316),(45390,'femur.tif',254,7,55,165.5960733,128.583889,113.5828893,1.8,128.4520555,113.7401589,-0.5586594,10.1091244,10.6717528,5028.4885777,5370.6730715,7.7541167,503.2606315,497.4207816,961.2545885,19.9896677,21.3853434,0.3916999,66.434136),(45391,'femur.tif',254,7,56,164.1468816,128.5498039,113.380603,1.8,128.5490988,113.5502658,-0.6195276,10.086961,10.4819034,4932.5301178,5199.4193346,9.2238286,496.0377057,489.0006129,946.78807,19.987486,21.072243,0.2895037,66.1824306),(45392,'femur.tif',254,7,57,161.6711374,128.5238894,113.1368976,1.8,128.607972,113.2768007,-0.7886588,9.8430693,10.2740963,4814.5602347,5023.9153809,13.5604529,488.9885414,489.1320057,939.9803634,19.7957602,20.7899733,0.3152147,65.9307252),(45393,'femur.tif',254,7,58,159.26684,128.4153135,112.9853154,1.8,128.500619,113.0678708,-0.9725939,9.8267317,10.118248,4716.5998162,4927.3194708,18.1259763,486.9735813,479.9764516,932.9107844,19.7047964,20.5936687,0.4076315,64.715384),(45394,'femur.tif',254,7,59,156.7211035,128.3091122,112.8148235,1.8,128.3666904,112.8959098,-1.1247482,9.8580513,9.910828,4601.3824572,4842.336069,21.2589789,488.5904678,466.7638991,922.4556447,19.4454591,20.4858007,1.4021994,64.8196438),(45395,'femur.tif',254,7,60,156.1594312,128.2677569,112.6175642,1.8,128.3531262,112.6738919,-1.2114898,9.7376509,9.8478378,4510.4226534,4769.4692821,22.8086401,484.3163929,463.1941232,909.6985203,19.4321124,20.4271343,1.8259787,64.4636786),(45396,'femur.tif',254,7,61,153.5843215,128.1866576,112.4204536,1.8,128.2323728,112.4777279,-1.281787,9.7069884,9.7717458,4374.9922286,4695.7633775,23.5181982,480.5449768,450.7054151,898.3047826,19.2973131,20.3229251,1.8055189,64.2119732),(45397,'femur.tif',254,7,62,151.8586298,128.1272618,112.2411756,1.8,128.1525801,112.2622985,-1.3406674,9.5947421,9.890173,4267.1063531,4634.5818794,23.9928789,468.6047316,444.7338243,884.0710965,18.906272,20.3092932,1.6767807,64.1077134),(45398,'femur.tif',254,7,63,151.2562266,128.0715014,112.0709266,1.8,128.1155302,112.1187983,-1.3679988,9.5972489,9.8589454,4194.2043794,4590.6613552,24.1867248,465.6341205,437.0215266,874.7195042,18.906272,20.2273087,1.784857,63.5000428),(45399,'femur.tif',254,7,64,150.7116189,128.0351605,111.8900041,1.8,128.050293,111.9462551,-1.4171327,9.5245845,9.87153,4130.3495676,4551.2736491,24.5301436,461.050479,433.6514175,861.2903084,18.8913726,20.2683424,1.6556981,63.6043026),(45400,'femur.tif',254,7,65,150.2474098,128.0290573,111.6764263,1.8,128.0602339,111.6759479,-1.446543,9.4565994,9.9264912,4060.1177879,4513.7262409,24.6566113,454.7151824,429.3422649,851.5634048,18.8633089,20.2683424,1.9394922,63.5000428),(45401,'femur.tif',254,7,66,149.940977,127.9938895,111.5145283,1.8,127.9991572,111.4776907,-1.4897242,9.2373071,10.0792626,4007.2811958,4492.5546438,24.8262697,445.7225514,433.8148741,839.9516024,18.476584,20.3818914,1.8925469,63.2483374),(45402,'femur.tif',254,7,67,150.0483432,127.9776702,111.3471015,1.8,127.9466158,111.2271752,-1.5327747,9.1493628,9.9851858,3968.1502495,4492.0726669,24.9719218,449.8737205,433.7078261,816.1557691,18.476584,20.6608003,1.8662372,62.996632),(45403,'femur.tif',254,7,68,151.5391049,127.959098,111.1920696,1.8,127.9295477,110.8863154,1.5640577,9.1249901,10.6674073,3949.3334217,4545.9490932,25.2553706,426.1531358,432.8041317,761.2512441,18.476584,21.4844,1.8545904,64.2119732),(45404,'femur.tif',254,7,69,151.8324456,127.9358763,111.0628892,1.8,127.8645202,110.7378348,1.5206286,9.2194919,11.0770724,3895.1353145,4617.0232802,25.2417724,416.8089827,422.4891536,751.7987241,18.476584,21.909875,1.7681919,66.7469154),(45405,'femur.tif',254,7,70,152.6162355,127.8945878,110.9474523,1.8,127.8403695,110.6211369,1.5143839,9.2631538,11.0223674,3871.6240009,4673.5039305,25.3551784,424.0018269,417.9595917,746.3306278,18.476584,22.1487388,1.886412,66.2866904),(45406,'femur.tif',254,7,71,153.2805183,127.8618022,110.8074625,1.8,127.7926487,110.4741598,1.502157,9.027276,11.2872509,3853.9040597,4735.7656734,25.4265821,419.5676802,426.9177162,748.7188743,18.046896,22.3106986,1.843805,66.034985),(45407,'femur.tif',254,7,72,153.5419121,127.8332057,110.6537179,1.8,127.7876287,110.3152555,1.4949092,8.9953356,11.5748173,3837.13689,4783.0655157,25.4432305,413.2303258,426.5696179,734.6781009,18.046896,22.6148187,1.8203833,69.5767488),(45408,'femur.tif',254,7,73,153.6910722,127.8312606,110.5173848,1.8,127.7822527,110.3007356,1.4929875,9.0234748,11.4090178,3823.9655668,4805.9807533,25.4604117,421.2440415,423.779715,750.1291772,18.046896,22.4180217,1.7832283,67.2503262),(45409,'femur.tif',254,7,74,154.7280314,127.8006125,110.3977429,1.8,127.7742776,110.1093649,1.4959563,9.0379229,11.3472308,3829.3840363,4885.4844913,25.6438353,430.5442071,423.7017816,752.0687157,18.046896,22.5125349,1.801887,67.5020316),(45410,'femur.tif',254,7,75,156.280449,127.7740437,110.2876491,1.8,127.7068259,109.9639222,1.494484,9.059407,11.6017985,3843.180943,4981.409084,25.8953505,429.3652482,424.2199221,754.9508932,18.046896,22.8099178,1.6273398,68.8216326),(45411,'femur.tif',254,7,76,158.3831811,127.7499364,110.2138224,1.8,127.6939208,109.8960947,1.4919762,9.0830682,11.9581933,3866.1129598,5087.3977628,26.2335407,425.4319729,425.6395388,744.0522599,18.046896,23.099477,1.7390031,67.6062914),(45412,'femur.tif',254,7,77,160.2307298,127.7199446,110.1264035,1.8,127.6538695,109.771542,1.4987407,9.0923898,11.8904142,3891.9349266,5188.5114637,26.566708,436.3608691,428.0431208,754.7960945,18.046896,23.0314371,1.7206088,67.8579968),(45413,'femur.tif',254,7,78,162.6164521,127.6866151,110.0330618,1.8,127.6087752,109.6392559,1.505603,9.1272515,11.7822653,3921.9535176,5268.6223035,26.9877138,447.1654792,429.6971038,770.2515683,18.476584,22.9310118,1.7975952,68.5699272),(45414,'femur.tif',254,7,79,164.3738109,127.6400674,109.9358051,1.8,127.5595246,109.567517,1.5010671,9.1539876,12.1490067,3932.8408804,5340.2014109,27.2626489,439.5586835,429.6314397,751.1753052,18.476584,23.4485273,1.8113306,68.8216326),(45415,'femur.tif',254,7,80,162.8687262,127.6193795,109.7400081,1.8,127.5327697,109.4496311,1.4752998,9.2013255,12.0045054,3937.1832506,5328.1009544,26.8979898,443.8417721,427.8930515,762.583646,18.476584,23.4485273,1.8113306,67.5020316),(45416,'femur.tif',254,7,81,164.9789555,127.5665527,109.5744457,1.8,127.5061304,109.1650988,1.5035225,9.2272843,12.2068265,3992.560145,5393.799511,27.3722373,441.8674669,432.6907068,757.3789574,18.476584,23.5545853,1.8290485,68.8216326),(45417,'femur.tif',254,7,82,163.3425585,127.5528138,109.3756809,1.8,127.5040696,109.0558022,1.4705012,9.2809398,12.1147492,4000.2918578,5351.6732206,26.9508298,441.7485765,431.0222835,759.8457475,18.476584,23.4485273,1.8113306,66.49521),(45418,'femur.tif',254,7,83,161.656199,127.5294377,109.1688837,1.8,127.4762195,108.872197,1.4417431,9.3156926,11.9640757,3999.5016499,5286.0533233,26.4964619,441.8271362,429.3295008,767.2441465,18.476584,23.2548162,1.8516341,66.9986208),(45419,'femur.tif',254,7,84,160.8094105,127.4960842,108.9772215,1.8,127.4269553,108.7077357,1.4145854,9.3421578,11.8147049,3990.0623727,5220.9243385,26.1528625,441.9005278,427.1028655,773.441723,18.476584,22.9310118,1.7975952,68.1097022),(45420,'femur.tif',254,7,85,159.7162785,127.5021891,108.7898299,1.8,127.4054945,108.536253,1.3690623,9.2273398,12.1091673,3946.4899857,5185.8960539,25.5506772,428.2619864,427.6953149,752.0292173,18.476584,23.2587856,1.7754381,67.354586),(45421,'femur.tif',254,7,86,159.091216,127.5160745,108.6445249,1.8,127.4599759,108.4377187,1.3344078,9.2426705,11.6784652,3914.5013182,5181.1298066,25.0609393,443.6481779,423.5249226,775.6469833,18.476584,22.8422723,1.8568478,67.5020316),(45422,'femur.tif',254,7,87,158.7176444,127.5152936,108.500269,1.8,127.4932271,108.420086,1.300724,9.2414831,11.4536759,3903.5249368,5156.9747447,24.5699457,450.2462595,422.391611,790.8023957,18.476584,21.8296729,1.7488893,64.8196438),(45423,'femur.tif',254,7,88,158.8304376,127.4968116,108.3417517,1.8,127.4596202,108.3188773,1.2739196,9.2306299,10.5931051,3917.5600868,5144.4538663,24.2063755,485.6417299,424.4087495,854.7965796,18.7824594,21.6086502,1.8736812,64.8196438),(45424,'femur.tif',254,7,89,159.1778251,127.5107486,108.0917828,1.8,127.4438551,108.0160934,1.2613158,9.2762069,10.5591027,3943.0023824,5148.5998757,24.0687699,487.5982396,425.066239,852.9064903,18.7173325,21.5530404,1.9809237,64.8196438),(45425,'femur.tif',254,7,90,158.2828086,127.4681246,107.8764747,1.8,127.4009238,107.8499456,1.2270334,9.2834401,10.4661156,3961.8678236,5068.9674978,23.3838912,484.321755,426.7672102,855.5188086,18.8377885,21.4758045,1.9178579,64.4636786),(45426,'femur.tif',254,7,91,155.7025515,127.4107637,107.5729777,1.8,127.3600933,107.5616664,1.1524889,9.3246957,10.3940194,3950.4659256,4898.8413651,21.6683411,471.3134724,423.6562832,842.9226347,18.8333432,21.2250215,2.1251038,64.3594188),(45427,'femur.tif',254,7,92,153.7902698,127.3462024,107.3000397,1.8,127.3013259,107.3043899,1.056944,9.2349936,10.4208955,3937.1431813,4768.7562389,19.4389025,457.6148227,426.3287408,835.3485329,18.8333432,21.3723891,2.0974236,64.1077134),(45428,'femur.tif',254,7,93,151.7394024,127.3100226,107.0999783,1.8,127.2504679,107.0881572,1.0035686,9.2482055,10.3557254,3914.6354547,4706.4327384,17.9890359,454.4763921,423.2859518,827.5102301,18.476584,21.1596801,2.0798672,63.3957831),(45429,'femur.tif',254,7,94,150.9529829,127.2633781,106.9449328,1.8,127.1941095,106.930569,0.9822143,9.2062802,10.3650854,3906.461035,4707.0508241,17.404193,454.1256171,424.3256739,828.4841065,18.476584,21.2250215,2.1251038,63.0398179),(45430,'femur.tif',254,7,95,150.0043113,127.2079512,106.8048252,1.8,127.187648,106.8194787,0.9606817,9.1692375,10.3858523,3899.8302164,4716.4745927,16.7933643,454.124944,425.3167418,828.7719032,18.476584,21.0941362,2.1531493,62.7881125),(45431,'femur.tif',254,7,96,150.0453219,127.1316937,106.657371,1.8,127.1047065,106.6894112,0.9279949,9.2968429,10.3574738,3910.7206554,4756.6302029,16.0216291,459.2461723,420.6503957,821.937532,18.8360401,21.1596801,2.0798672,63.3957831),(45432,'femur.tif',254,7,97,147.8506655,127.1972915,106.466425,1.8,127.143825,106.5009747,0.9308757,9.2178685,10.3884682,3900.4576018,4716.5506581,15.8553483,454.0179123,423.140945,822.8887771,18.8349492,21.0941362,2.1531493,64.1077134),(45433,'femur.tif',254,7,98,146.8693197,127.1664688,106.3558035,1.8,127.1191524,106.3822149,0.9166574,9.2686003,10.2137751,3902.9405629,4701.1661665,15.4153254,460.2770389,421.0927708,825.8025562,18.8236033,21.0020312,2.1077071,64.1077134),(45434,'femur.tif',254,7,99,145.9721771,127.1398535,106.2348783,1.8,127.0758319,106.2698079,0.9088952,9.2957048,10.3108644,3897.8091354,4702.8867916,15.1384128,456.1098495,419.3129205,816.3685329,18.8360401,21.0941362,2.1531493,63.3957831),(45435,'femur.tif',254,7,100,145.1865409,127.1168852,106.1080983,1.8,127.0747893,106.1456842,0.8958101,9.3001539,10.3304312,3894.1530538,4714.8143512,14.7489383,456.4005385,418.7192054,819.0859659,18.8360401,21.0941362,2.1531493,63.7517482),(45436,'femur.tif',254,7,101,144.521363,127.0854084,105.9967762,1.8,127.0683738,106.0426338,0.8890882,9.2483833,10.4258976,3896.9766492,4730.1099945,14.5231542,453.6885158,421.368417,811.892074,18.8377885,21.2293704,2.1981045,64.0034537),(45437,'femur.tif',254,7,102,143.4145794,127.0575495,105.8970546,1.8,127.0219166,105.935727,0.8812983,9.198059,10.2919331,3893.6559162,4731.7227331,14.2294322,459.7506284,423.31278,809.7066305,18.5339532,21.2250215,2.1251038,63.5000428),(45438,'femur.tif',254,7,103,141.7440534,127.062572,105.8156558,1.8,127.0503919,105.8801559,0.8916902,9.2960145,10.3156491,3879.0563213,4726.6778088,14.3041774,458.2045956,417.2816547,806.5063548,18.8377885,21.2250215,2.1251038,63.7517482),(45439,'femur.tif',254,7,104,139.8179523,127.0592427,105.761788,1.8,127.0378908,105.8242057,0.8959013,9.3303217,10.3685045,3861.2049374,4712.3815747,14.2056375,454.4899986,413.8340617,808.3924831,18.8377885,21.2293704,2.1981045,64.3594188),(45440,'femur.tif',254,7,105,137.9182592,127.0613075,105.6438023,1.8,126.9679521,105.6360971,0.8917319,9.3180362,10.385766,3846.4626983,4700.0408633,13.9190328,452.546386,412.7975716,809.196967,18.8377885,21.3334791,2.1699716,64.715384),(45441,'femur.tif',254,7,106,136.9464806,127.0362735,105.6001407,1.8,126.9607603,105.6208847,0.8863232,9.3044379,10.4266481,3847.4261608,4715.3945375,13.7001512,452.2445286,413.5044148,806.9559474,18.8377885,21.3334791,2.1699716,64.3594188),(45442,'femur.tif',254,7,107,136.3210824,127.002178,105.5498855,1.8,126.9189472,105.5535377,0.8728682,9.4529748,10.4107224,3858.0418331,4740.6352649,13.3373038,455.3608379,408.1299196,805.8667786,19.026675,21.4069164,2.2424025,64.8628297),(45443,'femur.tif',254,7,108,136.2145555,126.9592688,105.5109148,1.8,126.911143,105.532226,0.8550418,9.5056188,10.3768921,3889.1861902,4768.3034259,12.9271852,459.5117083,409.1460276,807.4994384,19.1416238,21.4543008,2.1421338,64.6111242),(45444,'femur.tif',254,7,109,136.2347531,126.908046,105.463925,1.8,126.8770814,105.4885974,0.8290512,9.4941659,10.3250576,3933.0209776,4789.00998,12.3428146,463.8240465,414.256608,813.73011,19.0277659,21.5915548,2.1146288,64.9670894),(45445,'femur.tif',254,7,110,136.5120924,126.8548704,105.4237143,1.8,126.8483599,105.4208926,0.8080119,9.4982671,10.5170071,3981.0278757,4824.5531479,11.8903401,458.738221,419.13202,823.1561438,19.0277659,21.5787243,2.1864162,65.57476),(45446,'femur.tif',254,7,111,136.4789706,126.8140101,105.3803621,1.8,126.8269413,105.3860882,0.779718,9.4604604,10.452085,4024.6662938,4852.658903,11.2440461,464.2766409,425.4197066,825.6967913,19.1416238,21.6896696,2.1587989,65.57476),(45447,'femur.tif',254,7,112,136.3684713,126.7319737,105.3318032,1.8,126.7378847,105.334944,0.7378456,9.5410368,10.425331,4062.6889587,4890.4210357,10.2848886,469.0902399,425.8121067,834.1221638,19.1416238,21.5915548,2.1146288,65.9307252),(45448,'femur.tif',254,7,113,136.4145173,126.6573549,105.1938509,1.8,126.6855753,105.2042555,0.701144,9.6922338,10.5960658,4107.5005451,4932.3469333,9.4613468,465.4885141,423.7929718,842.2223061,19.2194917,21.8296729,2.202487,66.434136),(45449,'femur.tif',254,7,114,136.6515733,126.6004756,105.1487627,1.8,126.6468868,105.1597965,0.6756101,9.7318774,10.5357289,4163.187702,4957.7340316,8.9072239,470.5639334,427.7887515,845.3237395,19.2194917,21.74493,2.2301064,66.434136),(45450,'femur.tif',254,7,115,136.7572051,126.5507794,105.0895977,1.8,126.6144749,105.0755966,0.643798,9.7741574,10.6382267,4202.8866524,4995.8184444,8.2119286,469.6100757,429.999893,847.0223044,19.2205826,21.9519689,2.2730533,66.6858414),(45451,'femur.tif',254,7,116,136.6159897,126.5081037,105.0169912,1.8,126.5673695,104.9977958,0.6200166,9.7265142,10.6364783,4230.3602798,5028.8561313,7.6873256,472.7933442,434.9307657,858.2038265,19.392706,21.8296729,2.202487,66.6858414),(45452,'femur.tif',254,7,117,136.338035,126.4751764,104.9578026,1.8,126.5415869,104.9841705,0.5948642,9.6738979,10.6742175,4259.2039032,5054.503244,7.1360242,473.5244769,440.2779462,857.9358847,19.4771981,21.930932,2.1751018,66.6858414),(45453,'femur.tif',254,7,118,136.4892092,126.4280738,104.8966599,1.8,126.5004519,104.9162485,0.5677947,9.746659,10.5928852,4290.2028762,5104.1503397,6.5788025,481.8470376,440.1716403,863.1238902,19.553156,21.930932,2.1751018,67.0418066),(45454,'femur.tif',254,7,119,137.2630961,126.3989594,104.841255,1.8,126.443109,104.8952064,0.5479813,9.6967748,10.6712722,4344.3244514,5175.2932335,6.2089756,484.9743425,448.0174624,869.6369018,19.5684544,22.0861304,2.2181885,67.293512),(45455,'femur.tif',254,7,120,137.7069397,126.3841773,104.7999054,1.8,126.4165589,104.84804,0.5373181,9.6571079,10.7072224,4398.3887163,5230.6312605,6.0126033,488.5143007,455.456103,883.8358661,19.5684544,22.0861304,2.2181885,67.5452174),(45456,'femur.tif',254,7,121,138.0671955,126.3759174,104.7088065,1.8,126.442325,104.787035,0.5108907,9.7117529,10.7881284,4447.918683,5287.087074,5.5014354,490.0838116,457.9933952,894.6115331,19.7032537,21.930932,2.1751018,67.293512),(45457,'femur.tif',254,7,122,138.7919032,126.3400185,104.6799799,1.8,126.4145109,104.7252465,0.4866816,9.7004325,10.7450766,4494.3691932,5373.4537822,5.0598664,500.0852014,463.3163701,903.4480327,19.7911058,22.0861304,2.2181885,67.5452174),(45458,'femur.tif',254,7,123,140.1578986,126.3399668,104.6534649,1.8,126.3679125,104.7152274,0.4466821,9.6318704,10.8832318,4561.4691594,5470.2198022,4.3589785,502.628256,473.5808289,912.8860495,19.7946693,22.1778956,2.1910458,67.5452174),(45459,'femur.tif',254,7,124,142.6268731,126.3357832,104.6175535,1.8,126.3792333,104.6942878,0.4123179,9.7294805,10.8648731,4663.5254104,5579.4581552,3.817355,513.5318272,479.3190548,932.748631,19.8411384,22.1778956,2.1910458,68.0486282),(45460,'femur.tif',254,7,125,144.7745882,126.3213184,104.5902512,1.8,126.2921136,104.6318364,0.3646066,9.7955,10.9748618,4751.2547449,5684.5635049,3.0680291,517.9621965,485.0446367,939.2460252,19.9774804,22.3479072,2.2335258,68.6562988),(45461,'femur.tif',254,7,126,147.217994,126.3188864,104.5652365,1.8,126.2792814,104.5785065,0.3297826,9.9109727,10.9209418,4845.4730467,5800.6864406,2.5731407,531.1525817,488.8998471,953.1160832,20.1122797,22.3479072,2.2335258,68.6562988),(45462,'femur.tif',254,7,127,149.5305909,126.2768493,104.5326281,1.8,126.2505412,104.5089289,0.2932368,9.9537184,10.9751346,4931.385078,5939.095317,2.0822452,541.1409987,495.4314431,968.3459652,20.1122797,22.3479072,2.2335258,69.3682292),(45463,'femur.tif',254,7,128,151.944008,126.2439974,104.5304142,1.8,126.2226323,104.4929277,0.2553591,10.0798187,10.9027468,5026.9884397,6076.0894222,1.6157511,557.2989554,498.7181419,991.6020057,20.2180331,22.3479072,2.2335258,69.3682292),(45464,'femur.tif',254,7,129,153.8396169,126.1703162,104.4560869,1.8,126.1470218,104.3488714,0.2221372,10.1727813,10.860945,5114.2000708,6196.138935,1.2445274,570.4972198,502.7337066,1005.847945,20.3111729,22.5575969,2.2752904,70.2276052),(45465,'femur.tif',254,7,130,156.854374,126.1470632,104.4263959,1.8,126.1070555,104.3337692,0.1905482,10.2573157,10.9418279,5233.8612306,6359.7217301,0.9377619,581.2302814,510.2564255,1026.0677773,20.3968389,22.6148187,2.2485046,70.4793106),(45466,'femur.tif',254,7,131,159.0655913,126.1228202,104.4288436,1.8,126.1236448,104.4188545,0.1520325,10.442536,11.0143794,5323.332941,6512.1483375,0.6080635,591.2406065,509.7739599,1037.9767065,20.5310066,22.6148187,2.2485046,70.4793106),(45467,'femur.tif',254,7,132,160.9586265,126.068921,104.4110451,1.8,126.047711,104.369811,0.1170079,10.5914272,11.0771798,5417.1987324,6653.4241828,0.3656039,600.6424276,511.4701402,1063.7436945,20.625024,22.7775173,2.1954317,70.8352758),(45468,'femur.tif',254,7,133,164.2400368,126.0048985,104.4057218,1.8,125.9819685,104.3807759,0.0788021,10.6918437,11.133376,5502.9370505,6868.7323035,0.1696308,616.949639,514.6855105,1081.3669611,20.625024,22.886685,2.2631308,71.590392),(45469,'femur.tif',254,7,134,167.5781793,125.987155,104.4184793,1.8,125.9962643,104.4315611,0.0532609,10.7273932,11.1359962,5615.135556,7046.4554897,0.079154,632.7638187,523.4389626,1099.3810001,20.625024,23.0314371,2.2105661,71.590392),(45470,'femur.tif',254,7,135,168.6823892,125.9555634,104.4015666,1.8,125.987485,104.4315555,0.0457095,10.7461877,11.5134809,5643.1418937,7184.7422502,0.0586987,624.0286766,525.1296615,1099.2200493,20.625024,23.3972909,0.1289108,72.3023224),(45471,'femur.tif',254,7,136,170.8277545,125.8916756,104.3906265,1.8,125.9128237,104.4484091,0.0178005,11.1629558,11.6070647,5718.1167666,7371.4344315,0.0090204,635.0817054,512.2403838,1109.1564087,21.054712,23.5976575,0.1831108,72.6582876),(45472,'femur.tif',254,7,137,172.8613337,125.81769,104.3298081,1.8,125.8514916,104.3644075,-0.0249032,11.3296844,11.7409435,5833.1957346,7541.8415886,0.0178634,642.3539607,514.8595091,1119.6561818,21.054712,23.8815318,0.1444416,73.5176636),(45473,'femur.tif',254,7,138,176.2129599,125.7280076,104.3902851,1.8,125.7229195,104.4544161,-0.0789173,11.4792609,11.9707517,5983.0507253,7757.957613,0.1825281,648.0760601,521.2052229,1131.4653028,21.054712,24.1888012,0.2148154,74.0210744),(45474,'femur.tif',254,7,139,180.6855808,125.5944659,104.4149311,1.8,125.6610771,104.4601896,-0.1283944,11.6683091,12.2479356,6188.6465182,8035.1773698,0.4937151,656.0434038,530.3807509,1147.8027053,21.4844,24.522351,0.1939591,74.9847102),(45475,'femur.tif',254,7,140,184.2911597,125.4973583,104.4040909,1.8,125.5757148,104.403875,-0.1707032,11.8175497,12.6150428,6331.3055383,8296.8954014,0.8863682,657.6985527,535.7545094,1159.5838505,21.4844,24.8662788,0.1736712,75.5923808),(45476,'femur.tif',254,7,141,187.0723856,125.3988105,104.3759324,1.8,125.5092976,104.4385933,-0.2176674,12.30823,12.8766384,6482.3367391,8503.8783592,1.454037,660.4113669,526.6668495,1163.6985442,21.914088,25.289612,0.1707352,76.807722),(45477,'femur.tif',254,7,142,189.284666,125.2625321,104.3767814,1.8,125.4200205,104.4385177,-0.2536339,12.5043998,13.1152147,6653.2132114,8763.334331,1.9863046,668.1807742,532.0697753,1175.4269917,21.914088,25.5402441,0.2204938,77.3111328),(45478,'femur.tif',254,7,143,192.4595493,125.1568754,104.401866,1.8,125.3432669,104.4936884,-0.2764343,12.7269644,13.3401426,6834.3152596,9067.069268,2.389359,679.6830825,536.9949242,1188.9462587,22.343776,26.0094374,0.1325515,78.8824392),(45479,'femur.tif',254,7,144,194.8252978,125.0770363,104.4445058,1.8,125.3111475,104.5654577,-0.2932722,12.9682057,13.5936614,7054.0376797,9346.5038147,2.7136193,687.563383,543.9486282,1203.6626113,22.343776,26.29185,0.1973956,79.6375554),(45480,'femur.tif',254,7,145,194.978654,124.937071,104.3824829,1.8,125.2088767,104.5239361,-0.3148883,13.231498,13.9503864,7204.7293112,9616.4048758,3.1170739,689.3289252,544.5135004,1204.9771722,22.773464,26.7133266,0.194241,80.8528966),(45481,'femur.tif',254,7,146,199.5649633,124.790118,104.4929093,1.8,125.1534716,104.7146813,-0.341531,13.4774792,14.2512108,7437.4759904,10009.7380963,3.7311382,702.3780831,551.8447388,1223.7256872,23.203152,27.097612,0.2565166,82.2156834),(45482,'femur.tif',254,7,147,202.1395136,124.6858328,104.661769,1.8,125.1237368,104.8437002,-0.3590197,13.6724563,14.5495927,7729.8329097,10525.2437983,4.1590702,723.4047018,565.3580247,1252.3305874,23.63284,27.5570408,0.1882215,84.2904006),(45483,'femur.tif',254,7,148,207.0946948,124.6144037,104.8426265,1.8,125.0476953,105.000803,-0.357403,14.0781544,14.8303221,8177.9190535,11030.4747529,4.2243788,743.7785019,580.894259,1294.6838958,23.63284,27.92972,0.24871,85.5489276),(45484,'femur.tif',254,7,149,212.3704639,124.5869553,105.0431579,1.8,125.0404907,105.1669397,-0.3459184,14.2782714,15.0639895,8690.3902111,11715.1530531,4.069097,777.6925944,608.6444182,1350.4747621,24.062528,28.3463842,0.2449787,88.1270556),(45485,'femur.tif',254,7,150,220.3459413,124.577116,105.3234061,1.8,125.044992,105.4187681,-0.3133244,14.4770914,15.4011482,9379.5298271,12470.7103806,3.4888607,809.7260178,647.8877267,1418.7381283,24.8503739,29.2219433,0.6287963,90.7051836),(45486,'femur.tif',254,7,151,228.2799604,124.5750798,105.6079398,1.8,125.0052394,105.6952639,-0.2860529,14.5291327,15.5980616,10116.0025078,13433.5926255,3.0292227,861.2347477,696.25646,1505.7922964,25.2246431,30.389606,0.5840811,93.6392768),(45487,'femur.tif',254,7,152,238.917772,124.4986532,106.0311058,1.8,124.9773569,106.13062,-0.2611008,14.605876,15.9412313,11158.7672223,14892.2847809,2.653517,934.199156,763.991645,1595.7659809,25.6499804,32.0657819,0.5657015,97.9361568),(45488,'femur.tif',254,7,153,268.5498295,124.3665366,107.2659716,1.8,124.3500922,108.0928046,-0.498979,16.437163,22.4911974,14350.2475885,19957.1437106,10.2492144,887.3313131,873.0367649,1401.9234036,26.6153,34.4662278,0.6260465,108.3708168),(45489,'femur.tif',254,7,154,329.7321008,123.3558693,109.8893165,1.8,124.1421543,110.5131035,-0.7544829,19.8808673,24.04626,19783.3674395,33832.7070352,25.7797994,1406.984165,995.0957936,2215.1036198,34.0862622,44.1409011,0.8473876,156.5316491),(45490,'femur.tif',254,7,155,389.3406939,123.7231177,111.559343,1.8,124.5921714,111.9544804,-0.7333815,20.5450313,24.648288,28067.14388,43192.8969324,29.0757787,1752.3690446,1366.1280667,2881.9434707,35.7869603,45.7209031,0.8652281,153.1373309),(45491,'femur.tif',254,7,156,447.2479891,124.0507014,112.8927431,1.8,124.8986149,112.8083174,-0.6478554,20.5427916,24.8123892,36749.7496022,51107.9258678,27.1468602,2059.7744726,1788.9364974,3524.6755517,36.9072907,46.6543034,0.8701619,152.9898853),(45492,'femur.tif',254,7,157,513.4272915,124.850365,114.1405722,1.8,125.9325305,113.7204981,-0.2384195,20.8249039,23.0292397,48271.8396696,60412.4329294,4.7727272,2623.2925501,2317.98619,4069.5622261,37.7256946,47.5887947,0.874902,164.1185875),(45493,'femur.tif',254,7,158,549.4002196,124.9784118,114.6693901,1.8,126.1646555,114.0530469,-0.1008328,20.6401959,23.2164664,52338.3568811,66313.2292985,0.9278317,2856.3015659,2535.7490415,4469.7637452,38.064675,48.1940635,0.8737749,164.0575135),(45494,'femur.tif',254,7,159,569.8167456,125.015143,114.8527358,1.8,126.2891432,114.1265789,-0.1041145,20.9103905,23.1654553,55241.3914724,69289.8924285,1.0257377,2991.087011,2641.8153932,4651.738134,39.3098511,48.9938541,2.300352,166.5924557),(45495,'femur.tif',254,7,160,571.3585888,125.2166577,114.85494,1.8,126.2946913,114.1109904,-0.1496433,21.2995249,22.9211007,56214.8103331,70085.5969244,2.1165469,3057.688973,2639.2518403,4703.0825649,39.4035647,49.5708011,2.3132761,167.5992773),(45496,'femur.tif',254,7,161,543.5833116,125.2401372,114.6607419,1.8,126.1269805,113.9526889,-0.1784976,21.1356765,23.3709647,55146.8311242,68250.2942324,2.8560265,2920.3028241,2609.1822047,4621.94307,39.7953583,49.5484484,2.3255293,168.1026881),(45497,'femur.tif',254,7,162,516.0325018,125.3627565,114.3722382,1.8,126.0298435,113.7060338,-0.2006708,20.7298779,23.6750154,54036.4537792,67103.3156387,3.4170944,2834.3515102,2606.6942665,4584.6952261,39.7953583,48.9636971,2.3996454,167.9552425),(45498,'femur.tif',254,7,163,487.956051,125.4502465,113.8823437,1.8,125.9592171,113.3111722,-0.1648298,20.4244097,23.2161595,51778.8460307,63127.7128488,2.1895964,2719.1281525,2535.1452938,4416.5241316,39.3473365,48.3566072,2.3121977,166.7399013),(45499,'femur.tif',254,7,164,455.722252,125.5961641,113.5786859,1.8,125.9101341,112.9310518,0.0147922,20.8636165,21.9221777,47979.1004046,58167.4514173,0.0166183,2653.3610056,2299.6540647,4126.178351,38.8618293,48.333693,2.3247583,166.2364905),(45500,'femur.tif',254,7,165,427.9317566,125.6871486,113.179581,1.8,125.885841,112.5535117,0.1433428,20.8065059,22.3739265,43035.2373006,53853.4571851,1.4554543,2406.9739009,2068.3548481,3820.5208717,37.8242022,47.7804555,2.4134567,164.1617733),(45501,'femur.tif',254,7,166,395.1428314,125.6027775,112.7627156,1.8,125.8328569,112.1398615,0.1270487,19.8999017,21.8721754,36678.5484792,47010.882772,1.0573174,2149.3464593,1843.1522408,3380.1258693,36.446702,46.8537281,2.4080959,158.6927379),(45502,'femur.tif',254,7,167,361.85154,125.4433532,112.2376264,1.8,125.7798675,111.6964057,0.0996193,18.7750643,21.2228644,30244.6707389,40516.8674909,0.5965256,1909.1140008,1610.8957201,2965.8168916,34.9794052,45.1683644,2.4505084,153.4322221),(45503,'femur.tif',254,7,168,330.868929,125.2715674,111.7028035,1.8,125.6779018,111.2946965,0.0723664,17.5757177,20.3532258,23958.7546815,34481.4412364,0.2882838,1694.1511665,1363.1736147,2519.0200224,33.515664,43.48986,2.4822826,146.5572141),(45504,'femur.tif',254,7,169,286.9399378,124.9433737,111.1060567,1.8,125.460291,110.7720512,0.0315003,15.9406049,19.323241,17429.4871956,27992.2050348,0.0474381,1448.6288818,1093.4018666,2065.0189027,31.3249512,41.1290207,2.5796711,137.3557835),(45505,'femur.tif',254,7,170,244.9557347,124.6480805,110.5460418,1.8,125.1339559,110.3649716,-0.0247775,14.3882162,17.8034232,11979.4225659,22069.6532175,0.0250588,1239.6297588,832.585667,1649.6829541,28.7547149,38.7315529,2.5535901,127.6941279),(45506,'femur.tif',254,7,171,199.139471,124.6976135,110.1339983,1.8,124.9786471,110.0596646,-0.0356967,13.1902187,16.2936259,7412.8067539,16506.3101939,0.0422743,1013.0532176,561.9927098,1272.0553845,25.7623552,35.8911676,2.5868004,116.0620149),(45507,'femur.tif',254,7,172,142.9129964,124.9397557,109.985404,1.8,124.953844,109.8432337,-0.0265909,11.041377,15.5470652,3700.2169444,11455.2803067,0.0168378,736.8130366,335.1227791,898.2948496,22.3328738,32.6817201,2.6485418,107.6335887),(45508,'femur.tif',254,7,173,77.8958112,125.6481623,110.0088852,1.8,125.3474135,109.947823,-0.0205622,9.194628,15.2061145,1285.7698306,6256.6592612,0.0054883,411.4568045,139.8392437,484.5828883,10.7422,15.4269362,1.3460852,41.9977547),(45509,'femur.tif',254,7,174,20.1266541,127.2808845,109.874648,1.8,126.5331233,109.9758599,-0.0285682,6.3568702,15.1542736,134.0419835,1425.3729724,0.002737,94.0574923,21.0861602,102.7486528,5.585944,8.9721488,1.2793395,23.5770053),(45510,'femur.tif',254,7,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45511,'femur.tif',254,7,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45512,'femur.tif',254,7,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45513,'femur.tif',254,7,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45514,'femur.tif',254,7,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45515,'femur.tif',254,7,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45516,'femur.tif',254,7,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45517,'femur.tif',254,7,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45518,'femur.tif',254,7,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45519,'femur.tif',254,7,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45520,'femur.tif',254,7,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45521,'femur.tif',254,7,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45522,'femur.tif',254,7,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45523,'femur.tif',254,7,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45524,'femur.tif',254,7,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45525,'femur.tif',254,7,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45526,'femur.tif',254,7,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45527,'femur.tif',254,7,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45528,'metatarsal.tif',254,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45529,'metatarsal.tif',254,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45530,'metatarsal.tif',254,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45531,'metatarsal.tif',254,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45532,'metatarsal.tif',254,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45533,'metatarsal.tif',254,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45534,'metatarsal.tif',254,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45535,'metatarsal.tif',254,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45536,'metatarsal.tif',254,10,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45537,'metatarsal.tif',254,10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45538,'metatarsal.tif',254,10,11,21.2027776,109.1383653,118.7470419,1.8,108.8917857,118.8226337,1.048488,4.5029568,5.8377741,71.0136607,91.4101895,2.6542934,15.6583979,15.7704512,27.8177066,9.485311,11.9697226,2.7744188,34.3065565),(45539,'metatarsal.tif',254,10,12,62.6262037,108.1092469,118.7475032,1.8,108.0023142,118.8272241,1.5058245,5.5319083,7.3982499,383.6127902,660.2486554,10.3937016,89.2438976,69.3454712,127.0980165,18.9494994,44.7082053,0.2426477,138.7975324),(45540,'metatarsal.tif',254,10,13,75.8945705,107.1104987,118.7118244,1.8,107.4146924,118.8964234,1.5579012,5.73538,8.9697358,648.2311002,1427.7363498,12.6469919,159.1726195,113.023218,202.8931385,20.2545795,46.6997918,0.2226609,125.3855935),(45541,'metatarsal.tif',254,10,14,88.9358963,106.570209,118.7308526,1.8,106.9486847,119.1108307,1.5648833,6.0400871,9.778674,895.303158,2168.0879231,14.8221311,221.7159432,148.2268614,272.8004828,21.68252,48.3184108,0.1607627,128.9705431),(45542,'metatarsal.tif',254,10,15,94.4397696,106.181053,118.8812169,1.8,106.5988672,119.2974554,1.5543928,6.5019466,10.523156,1074.6040643,2552.8258874,15.7357267,242.5912794,165.2742071,310.9175192,22.9139564,49.1293316,0.2025413,132.3648613),(45543,'metatarsal.tif',254,10,16,98.8060873,105.9449287,119.0808692,1.8,106.3080069,119.4650743,1.515604,7.0078777,10.5818227,1245.330877,2682.8891491,16.4175683,253.5375255,177.7044249,327.7449112,23.6594089,50.3193819,3.0988836,147.7472576),(45544,'metatarsal.tif',254,10,17,102.0502355,105.7194971,119.2088375,1.8,106.0580058,119.5152637,1.4660015,7.3121146,11.1715247,1420.6778875,2700.7889878,16.8222701,241.7565256,194.2909771,333.4385864,24.427075,51.1978256,0.0503775,153.8239636),(45545,'metatarsal.tif',254,10,18,105.0237582,105.6524507,119.2989757,1.8,105.9497532,119.5883088,1.4381678,7.6119249,11.2339248,1555.1641139,2753.5347784,17.1978604,245.1088836,204.3062884,349.7654126,25.1302061,51.4370817,0.1088122,159.9438554),(45546,'metatarsal.tif',254,10,19,105.4280459,105.6831521,119.3138894,1.8,105.9378866,119.6148396,1.4211376,7.7177669,11.2990535,1599.8861801,2701.390379,17.1807123,239.081122,207.2991049,349.9824721,26.0254615,51.3202913,0.2023216,165.369705),(45547,'metatarsal.tif',254,10,20,102.2277058,105.8477607,119.1941577,1.8,105.978379,119.5392016,1.4297964,7.6532372,11.3521776,1547.8211714,2543.1890464,16.7014588,224.0265389,202.2439818,332.4165308,26.4535144,51.0804882,0.2204938,135.967699),(45548,'metatarsal.tif',254,10,21,93.7042077,106.1268263,118.9472498,1.8,106.1148187,119.3496877,1.428018,7.6631734,11.5652979,1345.4320438,2166.7671554,15.3011555,187.3507438,175.571135,283.6647666,26.6068078,50.6612903,0.2223488,134.8566176),(45549,'metatarsal.tif',254,10,22,79.4867776,106.5840319,118.6516855,1.8,106.2878626,118.9604854,1.4078975,7.7134283,11.0214081,975.015724,1627.1308602,12.899351,147.6336645,126.4049774,223.0312061,26.3600254,50.2055079,0.1201087,169.8319187),(45550,'metatarsal.tif',254,10,23,59.2675838,107.4306772,118.4465998,1.8,106.6822663,118.5045054,1.1250092,7.571334,10.6963943,554.6441397,879.7296978,8.0415638,82.2454442,73.255801,134.0907395,26.0516908,49.101138,0.1493227,163.6077671),(45551,'metatarsal.tif',254,10,24,28.870871,109.9523113,118.8362197,1.8,109.637891,119.0260742,1.4466906,3.9727619,7.7062981,65.3850507,237.6752377,4.7380789,30.8416875,16.4583363,38.817408,23.6801907,42.9773929,0.2013171,145.143832),(45552,'metatarsal.tif',254,10,25,17.8566344,110.7666824,118.5809149,1.8,110.6263754,118.7904474,1.4724527,2.4745716,6.5627683,17.1894547,102.5392468,2.9474151,15.6243892,6.9464366,18.1284068,23.3177917,40.3495107,0.138885,140.9943976),(45553,'metatarsal.tif',254,10,26,12.107033,111.2675759,118.4193294,1.8,111.1230941,118.6047205,1.4999628,1.7660562,5.808409,5.8839351,51.3060551,2.0077315,8.8330652,3.3316806,9.8138437,23.0508758,38.8552962,0.1778753,138.8154206),(45554,'metatarsal.tif',254,10,27,7.1270664,111.6585311,118.3584155,1.8,111.4657761,118.5997741,1.5276714,1.2747733,4.5492648,1.6881894,20.8202082,1.1856367,4.5766094,1.3243055,4.9373873,22.4925399,37.7978927,0.1483278,135.6728078),(45555,'metatarsal.tif',254,10,28,2.8462387,111.9382597,118.3506048,1.8,111.7980331,118.5825804,1.5466421,0.6858875,3.6847929,0.2694853,5.6605995,0.4740964,1.5362056,0.3929001,1.6084681,22.3254875,37.0454856,0.6620605,131.670819),(45556,'metatarsal.tif',254,10,29,0.5121574,112.1135978,118.3533679,1.8,112.056492,118.501812,1.5503104,0.3995619,2.3891752,0.0150398,0.5686225,0.0853237,0.2379995,0.0376406,0.2442903,22.3076913,36.52348,0.6435011,128.8409856),(45557,'metatarsal.tif',254,10,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45558,'metatarsal.tif',254,10,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45559,'metatarsal.tif',254,10,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45560,'metatarsal.tif',254,10,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45561,'metatarsal.tif',254,10,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45562,'metatarsal.tif',254,10,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45563,'metatarsal.tif',254,10,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45564,'metatarsal.tif',254,10,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45565,'metatarsal.tif',254,10,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45566,'metatarsal.tif',254,10,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45567,'metatarsal.tif',254,10,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45568,'metatarsal.tif',254,10,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45569,'metatarsal.tif',254,10,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45570,'metatarsal.tif',254,10,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45571,'metatarsal.tif',254,10,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45572,'metatarsal.tif',254,10,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45573,'metatarsal.tif',254,10,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45574,'metatarsal.tif',254,10,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45575,'metatarsal.tif',254,10,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45576,'metatarsal.tif',254,10,49,1.529926,91.4674936,125.1225371,1.8,91.4078588,125.1631565,-0.6675904,1.3090793,2.0522107,0.554965,1.4881972,0.0977315,0.7251678,0.4239353,0.9947876,3.038353,4.6477863,0.5880026,11.3372218),(45577,'metatarsal.tif',254,10,50,21.4764802,94.1825593,124.0193603,1.8,95.4025524,123.9445778,0.1972429,5.8945245,10.1492258,147.8914556,395.7420339,0.1374596,38.9923373,25.0896329,50.1272326,7.1725751,11.1553493,1.2977876,33.9074055),(45578,'metatarsal.tif',254,10,51,60.4222038,96.4827819,123.6524062,1.8,96.813646,123.7400524,0.1930094,5.8650182,9.6641618,436.2506477,1378.9301427,0.3705122,142.6849188,74.3818057,176.4653371,11.9549429,19.201814,2.4353936,60.6270236),(45579,'metatarsal.tif',254,10,52,85.0709377,96.881258,123.5949001,1.8,97.1411898,123.6366173,0.1725866,6.3445249,9.9137121,678.7258868,1958.6083262,0.4181461,197.5655852,106.9782049,253.6557603,12.9103838,19.3884063,0.2234766,58.6386781),(45580,'metatarsal.tif',254,10,53,93.1756573,96.9857868,123.6937888,1.8,97.1700481,123.7237777,0.1276782,6.7126763,9.4513467,827.0755792,2018.7413239,0.2517812,213.5929821,123.2110026,283.9761436,13.3263853,19.1825737,0.2721459,56.3554413),(45581,'metatarsal.tif',254,10,54,90.1760064,96.8972365,124.0670768,1.8,97.0663054,124.1152719,0.0979073,6.070971,9.1604884,780.9462998,1914.2600479,0.1436089,208.9692119,128.636144,287.510357,12.5723481,18.4565877,0.2110933,53.6730535),(45582,'metatarsal.tif',254,10,55,84.9771672,96.7469675,124.4694191,1.8,96.8200235,124.5518074,0.106873,5.9444374,8.9659598,693.7016227,1816.6980075,0.1611509,202.6216991,116.6976068,273.5029812,12.0457501,18.2958305,0.1651487,52.4145265),(45583,'metatarsal.tif',254,10,56,82.9586383,96.639165,124.7860946,1.8,96.7121074,124.9219784,0.1004643,5.8055397,9.0437654,669.8218572,1791.2717763,0.1390824,198.0670336,115.3763286,269.7653199,11.7952673,18.2301179,0.1418971,50.5915147),(45584,'metatarsal.tif',254,10,57,81.4985366,96.5684448,125.0094555,1.8,96.6213775,125.1598222,0.1035403,5.823857,8.8392122,655.9955137,1771.1311236,0.1450991,200.3720552,112.6393581,273.356448,11.6680733,17.9494415,2.9488919,50.5915147),(45585,'metatarsal.tif',254,10,58,79.9101998,96.506541,125.2674462,1.8,96.5615637,125.4290033,0.1030154,5.7388957,8.8296298,639.9108084,1721.0361373,0.1408377,194.9160016,111.5041719,267.2500424,11.6011666,17.8048522,2.9962826,49.4804333),(45586,'metatarsal.tif',254,10,59,78.9773617,96.3895416,125.5169265,1.8,96.4344048,125.6379132,0.1080123,5.7059569,8.8270676,627.6375502,1673.5181948,0.1529707,189.5893721,109.9968973,259.0181625,11.5151051,17.700851,3.0443395,48.8727627),(45587,'metatarsal.tif',254,10,60,78.7965904,96.3291362,125.745575,1.8,96.3625773,125.8965667,0.1125786,5.66323,8.622839,613.8872822,1649.2172141,0.1657418,191.2615104,108.3987913,262.0550549,11.3567386,17.4487192,2.968347,48.2650921),(45588,'metatarsal.tif',254,10,61,78.6852519,96.2118903,125.9420174,1.8,96.2414263,126.0677002,0.1104791,5.6940061,8.6693172,607.7342834,1612.7830427,0.1594169,186.0334567,106.732286,256.1014553,11.3884224,17.379804,2.9927027,48.0133867),(45589,'metatarsal.tif',254,10,62,78.029921,96.1300409,126.1408193,1.8,96.172653,126.2701778,0.10958,5.6274638,8.4429198,597.8998134,1575.6891026,0.1555368,186.6284572,106.2467629,255.6975113,11.171888,17.1067638,2.939271,47.0497509),(45590,'metatarsal.tif',254,10,63,77.0343641,96.0609901,126.321059,1.8,96.1109851,126.4165641,0.1135276,5.5357275,8.4462688,584.025251,1526.5019611,0.1647668,180.730923,105.5010837,249.6726971,11.2851041,16.8949912,3.0140831,47.1540107),(45591,'metatarsal.tif',254,10,64,76.8822946,95.9646594,126.49643,1.8,96.050789,126.6098293,0.1132546,5.5936184,8.5220697,576.9142544,1488.8789296,0.163655,174.708607,103.1379363,242.3630175,11.171888,16.7798528,2.9090357,46.1903749),(45592,'metatarsal.tif',254,10,65,75.9734027,95.929769,126.6237505,1.8,95.9823833,126.7210509,0.1084467,5.5502628,8.4956057,568.4133029,1439.5415511,0.1483336,169.4454295,102.4119628,236.1429305,11.171888,16.6860637,2.9340964,45.9386695),(45593,'metatarsal.tif',254,10,66,75.7619154,95.8975548,126.7825376,1.8,95.9315788,126.880175,0.1041815,5.6732877,8.2192764,568.2526346,1402.6367423,0.1365555,170.6520951,100.1628448,238.534374,11.304767,16.4688822,2.8776289,45.9386695),(45594,'metatarsal.tif',254,10,67,75.7908411,95.8526426,126.9149991,1.8,95.8843723,127.01768,0.1046552,5.6270023,8.2056172,567.345914,1370.4292748,0.1378482,167.0111144,100.8256058,236.0184736,11.171888,16.2658334,2.9286543,45.3309989),(45595,'metatarsal.tif',254,10,68,74.6025957,95.8120455,127.0503019,1.8,95.8493726,127.1218041,0.1052655,5.8261732,8.2319403,561.347673,1326.2724682,0.1372683,161.1129838,96.3492936,229.2746957,11.4527176,16.1804778,2.9546134,45.4352587),(45596,'metatarsal.tif',254,10,69,75.0820788,95.7713627,127.1747741,1.8,95.7756065,127.2856863,0.1064281,6.4620856,7.9233516,570.6771406,1304.411834,0.1412074,164.6287968,88.3116036,235.1579919,12.0908085,15.898456,2.8112953,47.5099759),(45597,'metatarsal.tif',254,10,70,76.0694672,95.7287931,127.265873,1.8,95.727902,127.3448786,0.096961,6.067039,7.9480739,571.269348,1296.789127,0.1188207,163.1576591,94.1594983,233.6207924,11.7798893,15.8461105,2.9229237,45.4352587),(45598,'metatarsal.tif',254,10,71,77.3503082,95.696824,127.3693537,1.8,95.7191245,127.4047184,0.0976721,6.3893154,7.9704198,593.6263119,1291.4538277,0.1225944,162.0308406,92.90922,235.4320004,12.460952,15.8461105,2.9229237,46.6505999),(45599,'metatarsal.tif',254,10,72,77.8468558,95.6575375,127.4833219,1.8,95.720675,127.5767787,0.091881,6.6549106,7.9551044,607.7808678,1280.6466534,0.1092243,160.9842667,91.3281786,237.2544193,12.7961624,15.7584815,2.9495446,46.5031543),(45600,'metatarsal.tif',254,10,73,78.2223856,95.6517591,127.5692212,1.8,95.7279595,127.6575853,0.0824717,6.634455,7.9509451,615.9770795,1266.8625233,0.0884718,159.3348354,92.8451672,236.6868771,12.89064,15.6821404,2.976444,48.4736117),(45601,'metatarsal.tif',254,10,74,78.7988844,95.6158427,127.6498011,1.8,95.6514024,127.7490411,0.0761036,6.5747541,7.9788563,618.7304844,1258.4772654,0.0759172,157.7265243,94.1070153,235.1826572,12.89064,15.6821404,2.976444,47.6142357),(45602,'metatarsal.tif',254,10,75,79.3485835,95.609289,127.7173989,1.8,95.6577213,127.8783155,0.0705558,6.8643717,7.9792798,627.1232412,1255.2785697,0.0657252,157.3172768,91.3591611,235.8391666,13.2618093,15.6821404,2.976444,47.1108249),(45603,'metatarsal.tif',254,10,76,79.8447394,95.5952303,127.779447,1.8,95.6523322,127.8848776,0.0673371,6.7981795,7.9884554,637.0756728,1255.9496018,0.0602486,157.2205817,93.712688,236.9225403,13.320328,15.6821404,2.976444,47.9702009),(45604,'metatarsal.tif',254,10,77,80.4765158,95.5711937,127.8443302,1.8,95.631993,127.9620667,0.0583437,7.8338739,7.9818493,642.5132237,1253.9250499,0.0456051,157.0970586,82.0173051,234.5691443,13.2618093,15.6172526,3.0035866,47.1108249),(45605,'metatarsal.tif',254,10,78,81.1350918,95.57104,127.9048403,1.8,95.6164952,128.0496863,0.0587636,6.7128998,7.6250979,660.1260102,1251.0352947,0.0466418,164.0680958,98.3369374,248.574935,13.320328,15.4269362,2.9168815,49.3329877),(45606,'metatarsal.tif',254,10,79,81.512412,95.562725,127.951604,1.8,95.5878996,128.0582752,0.0518223,6.6744127,7.6239576,667.8827049,1247.7736768,0.0364516,163.6648231,100.0661383,249.172192,13.320328,15.4269362,2.9168815,50.6525887),(45607,'metatarsal.tif',254,10,80,82.284005,95.5497444,127.981118,1.8,95.5988912,128.0550506,0.0430335,6.6414353,7.6266534,680.9423391,1250.3912196,0.025381,163.950182,102.529394,250.9659483,13.320328,15.3369125,2.9441971,50.4008833),(45608,'metatarsal.tif',254,10,81,83.0460307,95.6132656,127.9401842,1.8,95.6188748,128.0151165,0.0384615,7.0017635,7.5599744,694.1372438,1248.2695133,0.0204647,165.1155741,99.1374879,254.2266858,13.8956247,15.3369125,2.9441971,50.4008833),(45609,'metatarsal.tif',254,10,82,83.4779571,95.6123823,127.9566195,1.8,95.6096439,127.9581604,0.0351335,6.6451302,7.5565571,704.4219368,1246.7790686,0.0171666,164.9930059,106.0057385,255.4484721,13.320328,15.3369125,2.9441971,49.6889529),(45610,'metatarsal.tif',254,10,83,84.2746712,95.5991564,127.9710111,1.8,95.6126508,127.9926331,0.0252799,6.6114079,7.5472029,719.8537664,1246.0255186,0.0089743,165.097657,108.8805551,258.0856362,13.320328,15.1917649,2.9996956,48.8295769),(45611,'metatarsal.tif',254,10,84,84.8040609,95.5845602,127.971952,1.8,95.6107933,127.9690985,0.0134498,6.5686414,7.5524455,735.375792,1244.494006,0.0025566,164.7802692,111.952495,260.5695622,13.320328,15.1917649,2.9996956,47.6142357),(45612,'metatarsal.tif',254,10,85,85.2486318,95.5897803,128.0053415,1.8,95.5848248,128.1076066,0.0064317,6.5102573,7.5382155,741.451963,1246.6898775,0.0005877,165.3826263,113.8898092,263.3276568,12.89064,15.1369758,3.0278006,46.3988945),(45613,'metatarsal.tif',254,10,86,85.6396596,95.591252,128.012426,1.8,95.5257971,128.1040118,-0.0085098,6.470664,7.1182544,755.882674,1243.7429052,0.0010336,174.72583,116.8168634,269.0807834,12.89064,14.9467204,0.3217506,45.5395185),(45614,'metatarsal.tif',254,10,87,86.0934061,95.5980197,128.014264,1.8,95.5343483,128.0619597,-0.0213707,6.4446252,7.1318197,771.6153128,1240.3601452,0.0065522,173.919168,119.7300519,275.2232806,12.89064,14.9467204,0.3217506,45.5395185),(45615,'metatarsal.tif',254,10,88,86.8901762,95.6011985,128.0174778,1.8,95.5578369,128.0377083,-0.032876,6.4079541,7.1318004,789.2886749,1238.4186026,0.0156466,173.6474011,123.1732731,277.5216546,12.89064,14.8351299,2.9669205,45.5395185),(45616,'metatarsal.tif',254,10,89,87.6853237,95.6295399,127.9169836,1.8,95.6511176,127.9320124,-0.0470048,6.4559271,7.1327372,804.0560893,1234.8151486,0.0322656,173.1193941,124.5454097,279.1537669,12.8177249,14.8164498,0.2942346,44.5758827),(45617,'metatarsal.tif',254,10,90,88.6134061,95.6114902,127.9153754,1.8,95.614921,127.9162494,-0.0640411,6.0510426,7.1434917,822.4999214,1232.0295184,0.0604884,172.4688111,135.9269755,284.3638533,12.031264,14.6975909,0.266252,43.8639523),(45618,'metatarsal.tif',254,10,91,89.9366005,95.6083784,127.91006,1.8,95.623047,127.899719,-0.0827592,6.0896594,7.1580356,845.3174763,1236.3811603,0.1024297,172.7263223,138.8119459,289.5377381,12.031264,14.6975909,0.266252,44.1156577),(45619,'metatarsal.tif',254,10,92,91.8203482,95.6091637,127.9078588,1.8,95.6378354,127.9116665,-0.0973002,6.1203477,7.1644597,870.4115226,1241.2428464,0.1444254,173.2500295,142.2160243,293.6999305,12.4884339,14.6975909,0.266252,44.8275881),(45620,'metatarsal.tif',254,10,93,93.6828352,95.6128607,127.8905483,1.8,95.6337516,127.8876695,-0.1202369,6.1527378,7.1672879,893.053668,1246.4370039,0.2246419,173.9063678,145.1473632,298.2884224,12.460952,14.6975909,0.266252,44.4716229),(45621,'metatarsal.tif',254,10,94,95.0534184,95.6120834,127.8645186,1.8,95.6193412,127.8386394,-0.1497771,6.4180786,6.9398482,913.989658,1249.7064714,0.3527422,180.0769175,142.4086116,305.6120345,12.89064,14.5397175,0.3310961,45.4352587),(45622,'metatarsal.tif',254,10,95,96.6217815,95.6182314,127.8398729,1.8,95.626981,127.8369049,-0.1790354,6.4085272,6.9856415,936.6554255,1255.3041309,0.510689,179.6977605,146.1576741,308.7685048,12.9913863,14.6975909,0.9097532,46.0429293),(45623,'metatarsal.tif',254,10,96,98.0419915,95.6358686,127.8066729,1.8,95.6347767,127.8018815,-0.2118656,6.4792016,7.0431811,959.6240154,1260.5523566,0.7225602,178.9748603,148.1083752,308.9212075,13.0288361,14.7852638,0.9505468,46.0429293),(45624,'metatarsal.tif',254,10,97,98.9164188,95.7384737,127.6837189,1.8,95.7354857,127.7017192,-0.2591639,7.2629531,7.0997746,977.3985825,1263.1691195,1.0827321,177.9167922,134.5731652,306.5149753,13.320328,14.9652379,0.887087,46.2946347),(45625,'metatarsal.tif',254,10,98,99.6726817,95.7586082,127.6462751,1.8,95.746684,127.6766607,-0.3071619,6.6346061,7.1351451,992.7424924,1266.5459599,1.5186516,177.5080876,149.6309611,305.6616971,13.320328,15.03908,0.9272952,46.2946347),(45626,'metatarsal.tif',254,10,99,101.1085015,95.7837859,127.564283,1.8,95.8079771,127.5161374,-0.3974478,7.5664373,7.0938965,1032.1542409,1277.7282874,2.5246847,180.1165671,136.4121844,305.2380713,13.750016,15.1369758,0.967047,46.2946347),(45627,'metatarsal.tif',254,10,100,101.7943806,95.8170548,127.5284941,1.8,95.8339874,127.5147968,-0.469712,7.572607,7.1517444,1043.355807,1287.9285514,3.4758276,180.0859307,137.7802664,306.3989351,13.750016,15.2584623,1.0062269,46.3988945),(45628,'metatarsal.tif',254,10,101,102.4682866,95.8525654,127.4996206,1.8,95.8619371,127.4733878,-0.5385025,7.3088084,7.2355419,1053.6162986,1298.8182403,4.4918028,179.5053161,144.1570555,308.288214,13.750016,15.3849907,0.9440534,46.6505999),(45629,'metatarsal.tif',254,10,102,103.1443746,95.8950535,127.4638347,1.8,95.918883,127.4503838,-0.618374,7.4273856,7.2933202,1060.9058832,1313.4821744,5.7771999,180.0938586,142.837055,307.1903527,13.645261,15.4926212,0.9827937,46.6505999),(45630,'metatarsal.tif',254,10,103,103.7306644,95.9429164,127.4159319,1.8,95.976286,127.4230423,-0.7005608,7.269795,7.3193404,1064.5936569,1327.6726638,7.184543,181.3923919,146.4406708,305.1845293,13.320328,15.6231626,1.0209431,46.6505999),(45631,'metatarsal.tif',254,10,104,104.7856951,95.9879006,127.306393,1.8,96.0234634,127.1824015,-0.8394436,7.0774449,7.6762069,1083.8079159,1367.1238519,9.6741694,178.098879,153.1354788,308.3603861,13.320328,15.7350314,0.9600704,46.5463401),(45632,'metatarsal.tif',254,10,105,104.9985252,96.0575705,127.1773402,1.8,96.0836469,127.1070165,-0.8949128,7.0698,7.828827,1076.8780312,1394.6134077,10.6510703,178.138233,152.320863,310.2715627,13.4531196,15.9042615,0.9002748,47.1540107),(45633,'metatarsal.tif',254,10,106,105.1412512,96.109195,127.115963,1.8,96.1549705,127.0175308,-0.9422998,6.9160744,7.9547303,1068.2063072,1421.839426,11.4663402,178.7413736,154.452692,306.2479661,13.3183203,15.9910916,1.0349851,47.1540107),(45634,'metatarsal.tif',254,10,107,105.1228439,96.1626472,127.0445585,1.8,96.2111427,126.9666509,-0.9914457,6.8188391,8.0471409,1056.7813356,1440.9229302,12.2689745,179.0602335,154.9796548,303.7891312,13.3183203,16.1519256,1.0714496,47.0065651),(45635,'metatarsal.tif',254,10,108,104.5998325,96.2292201,126.9718796,1.8,96.3056219,126.86641,-1.0310029,6.7603498,8.2270533,1040.0651593,1458.5687479,12.8282349,177.2893268,153.8478323,298.7923781,13.183521,16.2146739,1.012197,47.2582705),(45636,'metatarsal.tif',254,10,109,104.2181482,96.2951586,126.8981439,1.8,96.3542011,126.8010314,-1.0584636,6.7032468,8.3158842,1023.867716,1480.7343243,13.1956226,178.0609597,152.7420592,297.6888197,13.047179,16.5973074,1.199905,47.8659411),(45637,'metatarsal.tif',254,10,110,104.1846907,96.3627503,126.8141183,1.8,96.3996129,126.6999903,-1.0876571,6.6360218,8.2625584,1008.4934619,1512.8975596,13.6166391,183.1027985,151.9725963,297.7351629,13.0286083,16.5861794,1.2818209,48.4736117),(45638,'metatarsal.tif',254,10,111,104.199685,96.4285743,126.7308032,1.8,96.4799569,126.6577842,-1.1096974,6.5730201,8.3548185,991.1209449,1539.306222,13.9286335,184.2417309,150.7862345,298.2804382,12.910837,16.7137033,1.2571757,48.4736117),(45639,'metatarsal.tif',254,10,112,104.0127034,96.4968445,126.6404559,1.8,96.5731471,126.5564476,-1.1295987,6.5294891,8.4550812,973.4908104,1557.930122,14.1743592,184.2596291,149.0914219,297.565494,12.8195857,16.8512217,1.2329181,48.1176465),(45640,'metatarsal.tif',254,10,113,103.634544,96.572538,126.4768232,1.8,96.6286467,126.3717523,-1.1531893,6.4936378,8.5131084,956.6408175,1584.2249669,14.4312739,186.0924224,147.3197074,294.9953679,12.8195857,16.757832,1.1760052,47.7616813),(45641,'metatarsal.tif',254,10,114,103.2460899,96.630304,126.4035764,1.8,96.652559,126.274818,-1.1830925,6.4154034,8.6212557,941.9568807,1600.0821743,14.7481508,185.5973458,146.8273818,293.9377914,12.6116838,16.757832,1.1760052,47.9091269),(45642,'metatarsal.tif',254,10,115,102.7621868,96.697121,126.3486411,1.8,96.7628138,126.2212416,-1.2055863,6.3273525,8.5592477,929.2798138,1608.3210886,14.9424286,187.9044907,146.8670842,295.9056218,12.460952,16.757832,1.1760052,47.3014563),(45643,'metatarsal.tif',254,10,116,101.9936151,96.7342019,126.3148579,1.8,96.7712451,126.1588908,-1.2252961,6.3733754,8.6692293,919.2586815,1601.743206,15.0492327,184.7618927,144.2341959,288.4350953,12.460952,16.927744,1.152572,47.6574215),(45644,'metatarsal.tif',254,10,117,101.1478337,96.7701569,126.2684327,1.8,96.8106429,126.081764,-1.247672,6.4581326,8.6112053,909.8937648,1589.245616,15.158254,184.5555374,140.8911565,287.6577281,12.460952,16.757832,1.1760052,48.0133867),(45645,'metatarsal.tif',254,10,118,100.353973,96.8055719,126.23067,1.8,96.8337892,125.9901308,-1.2707419,6.3880967,8.5873937,900.4459758,1574.7272973,15.2644593,183.3766281,140.9568477,286.3390188,12.4592849,16.757832,1.1760052,47.4057161),(45646,'metatarsal.tif',254,10,119,99.7375266,96.8399491,126.2039251,1.8,96.8592831,125.9543041,-1.2895498,6.439743,8.5692472,895.7794818,1559.7074437,15.3423598,182.0121896,139.1017434,285.1360815,12.4592849,16.7192258,1.1186425,47.6574215),(45647,'metatarsal.tif',254,10,120,99.0410172,96.8836077,126.1765778,1.8,96.9378274,125.8819544,-1.3062494,6.5481118,8.6568422,896.4518006,1555.3136381,15.3783038,179.6629304,136.9023362,283.0110345,12.031264,16.5973074,1.199905,47.3014563),(45648,'metatarsal.tif',254,10,121,97.8485757,96.9530118,126.0932938,1.8,97.0107029,125.8046572,-1.3167205,6.5891502,8.6697745,899.8626211,1537.666302,15.2777938,177.3594352,136.567326,281.1209502,12.031264,16.757832,1.1760052,46.9454911),(45649,'metatarsal.tif',254,10,122,95.3642153,97.060461,126.1932249,1.8,97.1747286,125.9880086,-1.2685003,6.7253306,8.601447,872.7680153,1481.4999291,14.4853007,172.2384526,129.7732511,272.4386131,12.460952,16.5360111,1.1420183,46.9023053),(45650,'metatarsal.tif',254,10,123,94.5330925,97.1160512,126.2348399,1.8,97.2159245,125.9729206,-1.2756085,6.7763799,8.6307768,890.8020286,1440.9382154,14.4220606,166.9534789,131.4569188,268.910844,12.460952,16.5360111,1.1420183,46.9023053),(45651,'metatarsal.tif',254,10,124,94.3598184,97.1927965,126.2833203,1.8,97.3042427,125.9845216,-1.2582591,6.8603421,8.6375304,916.1692821,1417.5848492,14.2398366,164.1192313,133.5457139,268.1293101,12.89064,16.5360111,1.1420183,47.2582705),(45652,'metatarsal.tif',254,10,125,94.6764899,97.2450267,126.3102371,1.8,97.3361306,125.9216324,-1.2658094,6.9271951,8.6553713,966.5425376,1393.6088099,14.3566088,161.0108644,139.5287025,270.6395837,12.89064,16.5304274,1.0838971,47.5099759),(45653,'metatarsal.tif',254,10,126,94.2172043,97.322447,126.3864389,1.8,97.3988475,125.9692922,-1.2414616,7.1190049,8.6842517,1009.0970557,1348.5497522,14.0604045,155.2868111,141.7469255,268.4640133,13.320328,16.5304274,1.0838971,47.5099759),(45654,'metatarsal.tif',254,10,127,94.7320472,97.3244336,126.3682855,1.8,97.3589502,125.9176108,-1.3201036,7.1881121,8.640474,1099.067549,1328.4468704,14.8170196,153.7469909,152.9007246,279.014003,13.320328,16.3620316,1.1659045,48.1176465),(45655,'metatarsal.tif',254,10,128,92.8573633,97.4274707,126.505454,1.8,97.5462379,126.0946869,-1.1236275,7.3379482,8.6842227,1128.0517444,1270.787359,12.5824471,146.3328841,153.7284961,273.707922,13.750016,16.3337968,1.1071487,47.5099759),(45656,'metatarsal.tif',254,10,129,94.9849928,97.4133232,126.3918786,1.8,97.5250105,125.9143235,0.0221025,8.696019,7.4653137,1254.1228734,1298.2298793,0.0077324,173.9015841,144.2180461,288.3461066,14.179704,16.5304274,1.0838971,49.4804333),(45657,'metatarsal.tif',254,10,130,94.2777971,97.5928688,126.4889272,1.8,97.7353949,126.0402394,-0.115256,8.7025077,7.5987936,1187.7710359,1371.9911414,0.2078076,180.5538103,136.486066,280.9491473,14.5840943,16.7357822,1.0612041,50.6525887),(45658,'metatarsal.tif',254,10,131,97.0006683,97.5986117,126.4473548,1.8,97.8155481,126.0150839,0.0663927,8.889254,8.1929087,1220.1342813,1534.4031728,0.0711584,187.284301,137.2594685,299.4653796,15.03908,16.9495441,1.0390723,51.1559995),(45659,'metatarsal.tif',254,10,132,101.2822232,97.6428895,126.3092246,1.8,97.8962206,125.854903,0.1241198,9.5614563,8.6930707,1344.0767266,1715.9859029,0.2587217,197.396981,140.5723859,319.7112955,15.4956002,17.1713991,1.017502,53.4392362),(45660,'metatarsal.tif',254,10,133,110.2190167,97.7480927,125.9434607,1.8,98.0246731,125.3337793,0.1273192,10.6732373,9.4364962,1731.6090966,1983.2646102,0.2961726,210.169597,162.2384152,342.7053791,16.4382381,18.6555863,1.065935,58.4480466),(45661,'metatarsal.tif',254,10,134,122.7399046,97.9414217,125.4854136,1.8,98.326515,124.7984814,-0.4532861,10.8091382,9.011186,2290.9869245,2374.4118347,3.9230909,263.4960423,211.9490831,400.5376221,17.49505,19.8402356,1.8788491,63.456857),(45662,'metatarsal.tif',254,10,135,135.6095228,98.4587016,125.2823044,1.8,98.8617782,124.6324323,-0.8826353,9.8889114,10.5712336,2559.918069,3010.3928875,13.4846798,284.7721475,258.8675304,467.2582432,18.7876256,20.8608988,1.0056469,67.293512),(45663,'metatarsal.tif',254,10,136,162.4246588,98.5778122,125.1223323,1.8,98.9399409,124.6644696,-0.6554838,9.8320123,10.46649,3226.9627369,3685.1907858,10.0579444,352.0942345,328.2097933,583.330288,19.2041403,21.5530404,3.0617627,67.1460664),(45664,'metatarsal.tif',254,10,137,174.3198128,98.9545953,125.2171007,1.8,99.1825338,124.9570401,-0.4008983,10.486107,11.2185945,3314.7624675,3908.0209907,4.4245748,348.3521024,316.1099214,626.5153744,18.906272,22.0652214,3.0244839,67.3977718),(45665,'metatarsal.tif',254,10,138,122.4842735,99.25605,126.49192,1.8,99.2637172,125.588218,-0.0924568,11.5249736,10.9570375,1622.1174272,3443.888751,0.1740081,314.3083848,140.7480382,435.8002877,18.046896,22.1820578,0.1555948,66.6426556),(45666,'metatarsal.tif',254,10,139,28.1140486,99.3534396,127.9156841,1.8,100.3086368,127.5727457,-0.0878648,11.8623999,10.8828408,91.928053,1421.8418111,0.0360815,130.6498768,7.7495325,127.1582333,6.1526809,7.7463106,0.5880026,21.9625131),(45667,'metatarsal.tif',254,10,140,0.9996412,89.9524063,128.8314385,1.8,89.9398368,128.8695696,1.5099439,1.1609096,1.8075477,0.2628828,0.6179992,0.1659907,0.3418992,0.2264455,0.4851321,2.578128,3.8909903,1.6814535,9.8701752),(45668,'metatarsal.tif',254,10,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45669,'metatarsal.tif',254,10,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45670,'metatarsal.tif',254,10,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45671,'metatarsal.tif',254,10,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45672,'metatarsal.tif',254,10,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45673,'metatarsal.tif',254,10,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45674,'metatarsal.tif',254,10,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45675,'metatarsal.tif',254,10,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45676,'metatarsal.tif',254,10,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45677,'metatarsal.tif',254,10,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45678,'metatarsal.tif',254,10,151,0.0135397,112.148568,110.429816,1.8,112.148568,110.429816,0.7853982,0.00000000000001005,0.00000000000001005,0.0002083,0.0002083,0.0011283,20731364111.0766,20731364106.8994,29318576289.4257,25.2246431,30.389606,0.5840811,93.6392768),(45679,'metatarsal.tif',254,10,152,0.791287,112.0350621,112.4621676,1.8,111.943065,112.6903485,1.5640657,0.3314165,2.6949193,0.0406717,1.4772856,0.1318752,0.5481743,0.1227207,0.5629139,25.6499804,32.0657819,0.5657015,97.9361568),(45680,'metatarsal.tif',254,10,153,6.8241024,111.2980415,119.2862293,1.8,111.0012567,120.0025559,-1.496908,2.2186678,8.8950353,3.9304831,180.8791367,1.1311523,20.3348418,1.7715509,20.7717548,26.6153,34.4662278,0.6260465,108.1191114),(45681,'metatarsal.tif',254,10,154,28.0264884,110.5501937,120.4627939,1.8,110.1661667,120.7232084,-1.504415,3.3604897,10.1169052,39.1345076,750.5938651,4.6505286,74.1920426,11.6454776,77.7329937,34.0862622,44.1409011,0.8473876,156.5316491),(45682,'metatarsal.tif',254,10,155,39.0623213,110.0585901,121.1137268,1.8,109.7183654,121.5007391,-1.4853529,4.004455,10.8232928,84.5880663,1255.7730366,6.4629729,116.0250453,21.1234901,123.1223982,35.7869603,45.7209031,0.8652281,153.1373309),(45683,'metatarsal.tif',254,10,156,50.5607408,109.7558501,121.3162719,1.8,109.4260917,121.9051712,-1.4837501,3.9548834,11.0532525,129.5631237,1755.2741488,8.363101,158.8015966,32.7602888,169.0998038,36.9072907,46.6543034,0.8701619,152.9898853),(45684,'metatarsal.tif',254,10,157,60.3379446,109.417878,121.4420113,1.8,108.7141201,122.3021627,-1.4298455,24.9899333,11.2866057,464.7603454,2171.9204156,9.8578534,192.4334455,18.5979026,99.6246233,37.7256946,47.5887947,0.874902,164.1185875),(45685,'metatarsal.tif',254,10,158,69.3271063,108.5404818,121.7694915,1.8,107.5273212,122.8095362,-0.9512225,19.2500678,20.5329649,1703.5870874,2874.5540979,7.6583476,139.9970295,88.4977188,176.884692,38.064675,48.1940635,0.8737749,164.0575135),(45686,'metatarsal.tif',254,10,159,74.5077621,107.4231496,122.2218397,1.8,106.3423112,123.2444142,-0.4778202,11.5429078,25.0487761,2243.569117,4494.22885,2.6258657,179.4190994,194.367758,267.0477843,39.3098511,48.9938541,2.300352,166.5924557),(45687,'metatarsal.tif',254,10,160,76.0421081,106.7506959,122.5483731,1.8,105.8585929,123.3040253,-0.3683129,11.4829365,24.484331,2431.2450017,5307.2857905,1.6428931,216.7625408,211.7267655,316.031637,13.8607278,59.3933897,2.4792804,136.4637003),(45688,'metatarsal.tif',254,10,161,77.4688082,106.7016711,122.5163737,1.8,105.816805,123.1279866,-0.3511691,11.5049421,24.3035734,2484.0407651,5198.9706642,1.5278541,213.9179527,215.9107571,316.1076184,13.8523474,59.0551407,2.4748061,135.8560297),(45689,'metatarsal.tif',254,10,162,75.4683509,107.1288719,122.2427522,1.8,106.0098955,122.8387858,-0.3964996,11.652407,24.6002541,2353.8470397,4311.7480389,1.8759439,175.2725002,202.0052195,270.3282937,13.7642868,58.6347024,2.5596875,137.0713709),(45690,'metatarsal.tif',254,10,163,66.2211522,107.9711557,121.9843491,1.8,106.779252,122.3759579,-0.6869802,15.2999772,23.3591773,1957.7402269,2739.0411374,4.4392047,117.2576028,127.957068,185.8284132,13.5841563,57.8054142,2.568022,135.3958047),(45691,'metatarsal.tif',254,10,164,56.2253557,108.7131078,121.6608305,1.8,107.8647088,121.8009796,-1.2831925,23.7951178,11.7442018,1191.2259694,1895.7609398,8.6169076,161.4210118,50.0617808,121.7399984,38.8618293,48.333693,2.3247583,166.2364905),(45692,'metatarsal.tif',254,10,165,47.9624122,109.3043985,121.2871771,1.8,108.6184966,121.3121181,-1.4680494,25.2162011,11.0918172,522.2897749,1480.7504789,7.9096425,133.4993586,20.7124686,77.4701452,37.8242022,47.7804555,2.4134567,164.1617733),(45693,'metatarsal.tif',254,10,166,41.1193991,109.7830658,120.7068056,1.8,109.4772461,120.6107183,-1.5430994,4.0415709,10.3385567,108.7602841,1165.4077364,6.8479773,112.7244135,26.910399,120.8232879,36.446702,46.8537281,2.4080959,158.6927379),(45694,'metatarsal.tif',254,10,167,35.5017255,109.8883913,120.0269802,1.8,109.6082148,119.8774432,-1.5557948,3.737856,9.6299892,84.444823,872.1635965,5.9156228,90.5674531,22.5917807,97.0219243,34.9794052,45.1683644,2.4505084,153.4322221),(45695,'metatarsal.tif',254,10,168,29.069546,110.0661419,119.3752354,1.8,109.7539526,118.9850831,-1.5669979,3.5015641,8.9532648,62.5047533,592.6294426,4.8448544,66.1914346,17.8505237,71.3295754,33.515664,43.48986,2.4822826,146.5572141),(45696,'metatarsal.tif',254,10,169,23.6170339,110.2675428,118.3118434,1.8,109.9763166,117.9304151,1.5615872,3.2974743,7.8999838,42.2655408,388.2705923,3.9358385,49.1482768,12.8175499,52.9667662,31.3249512,41.1290207,2.5796711,137.3557835),(45697,'metatarsal.tif',254,10,170,18.4660871,110.5032915,117.2784349,1.8,110.2243714,117.1168355,1.5535817,2.7108372,6.9286959,25.1906134,246.4997977,3.0767692,35.5766511,9.2925584,38.2942903,28.7547149,38.7315529,2.5535901,127.6941279),(45698,'metatarsal.tif',254,10,171,12.3672519,110.8200721,116.1286983,1.8,110.5911835,116.0326473,1.5378151,2.2033205,6.3727454,11.6816639,121.5916603,2.0589674,19.0799494,5.3018451,20.5979064,25.7623552,35.8911676,2.5868004,116.0620149),(45699,'metatarsal.tif',254,10,172,6.7565719,111.2427516,114.7888313,1.8,111.0276428,114.8263338,1.5215067,1.773072,5.5617294,3.4996844,42.9773839,1.1233617,7.7273418,1.9737971,8.3030561,22.3328738,32.6817201,2.6485418,107.6335887),(45700,'metatarsal.tif',254,10,173,1.9966528,111.7458747,113.0972,1.8,111.5781201,113.4079983,1.5272523,0.956463,4.221165,0.3623093,7.0411179,0.3321449,1.6680508,0.3788012,1.7515235,10.7422,15.4269362,1.3460852,41.9977547),(45701,'metatarsal.tif',254,10,174,0.0276948,112.148568,110.6329412,1.8,112.148568,110.64466,1.276107,0.0658035,0.2167962,0.0005336,0.0015931,0.0042264,0.0073485,0.0081094,0.009387,5.585944,8.9721488,1.2793395,23.5770053),(45702,'metatarsal.tif',254,10,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45703,'metatarsal.tif',254,10,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45704,'metatarsal.tif',254,10,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45705,'metatarsal.tif',254,10,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45706,'metatarsal.tif',254,10,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45707,'metatarsal.tif',254,10,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45708,'metatarsal.tif',254,10,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45709,'metatarsal.tif',254,10,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45710,'metatarsal.tif',254,10,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45711,'metatarsal.tif',254,10,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45712,'metatarsal.tif',254,10,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45713,'metatarsal.tif',254,10,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45714,'metatarsal.tif',254,10,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45715,'metatarsal.tif',254,10,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45716,'metatarsal.tif',254,10,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45717,'metatarsal.tif',254,10,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45718,'metatarsal.tif',254,10,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45719,'metatarsal.tif',254,10,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45720,'humerus.tif',230,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45721,'humerus.tif',230,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45722,'humerus.tif',230,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45723,'humerus.tif',230,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45724,'humerus.tif',230,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45725,'humerus.tif',230,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45726,'humerus.tif',230,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45727,'humerus.tif',230,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45728,'humerus.tif',230,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45729,'humerus.tif',230,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45730,'humerus.tif',230,2,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45731,'humerus.tif',230,2,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45732,'humerus.tif',230,2,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45733,'humerus.tif',230,2,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45734,'humerus.tif',230,2,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45735,'humerus.tif',230,2,16,14.5142088,32.3915287,28.7848332,1.8,32.4331925,28.7506208,-1.3042056,1.6499373,4.6544533,7.379121,61.4337805,2.2511469,13.1989251,4.4723645,14.600465,3.3449937,8.8475684,1.2407357,21.6473673),(45736,'humerus.tif',230,2,17,33.0512591,32.2523041,28.3266019,1.8,32.3336019,28.3317737,-1.3176829,2.6833889,5.8407273,47.2384497,264.5461286,5.1631031,45.2933541,17.6040267,50.318255,5.261421,11.733255,1.1633026,30.2054144),(45737,'humerus.tif',230,2,18,46.5395865,32.1189202,28.4477381,1.8,32.2526069,28.4128352,-1.3380803,3.6256571,6.5389099,134.8171081,494.0769118,7.3440542,75.5595226,37.1841857,86.7930727,6.9311253,13.4146666,1.1226514,34.9274069),(45738,'humerus.tif',230,2,19,58.5150436,32.1316674,28.4606549,1.8,32.2585351,28.4185915,-1.3553916,4.3061912,7.2485215,278.3880138,725.254735,9.306954,100.0555398,64.6483175,129.058653,8.3934169,14.5578349,1.0952445,39.4068289),(45739,'humerus.tif',230,2,20,79.4156756,31.1964712,26.6899273,1.8,31.3675178,26.7603174,1.150966,7.7031795,15.3023499,663.1605858,2926.3276646,11.0368958,191.2338744,86.0892034,234.4296806,9.986426,15.2903012,1.0799445,43.3946571),(45740,'humerus.tif',230,2,21,106.6080633,30.2853719,24.9624597,1.8,30.6473302,25.3622979,1.0952584,8.0420805,14.0681339,924.5669906,5667.1639998,14.043904,402.8369386,114.9661452,468.2156419,11.3511491,15.7736786,1.0851742,47.3072666),(45741,'humerus.tif',230,2,22,126.4636404,29.8055918,24.1358612,1.8,30.1125685,24.4853436,1.0875741,8.2768394,13.3198845,1162.2530427,7204.4978385,16.5269935,540.8829074,140.4223263,626.7699953,13.9012726,25.9924433,1.7810567,76.5217042),(45742,'humerus.tif',230,2,23,137.7071965,29.5326991,23.6896128,1.8,29.8231675,24.0624503,1.0902231,8.4569405,13.2471274,1367.1925192,8215.1269731,18.0463042,620.1440321,161.6651457,714.7350561,14.3072904,26.6352082,1.8538921,78.11254),(45743,'humerus.tif',230,2,24,143.3872435,29.4502292,23.3710943,1.8,29.7087572,23.703418,1.0852822,8.2605457,13.6819708,1584.2029147,9092.2529697,18.6935268,664.5426364,191.7794502,770.4546806,14.3004074,27.5504615,1.847164,79.1929773),(45744,'humerus.tif',230,2,25,144.9656564,29.4265881,23.1566377,1.8,29.5583776,23.3242971,1.0792075,8.2629912,14.3652316,1728.8847947,9916.1624734,18.7776516,690.2890799,209.232316,807.1634671,14.4110738,28.5125246,1.865898,81.0108053),(45745,'humerus.tif',230,2,26,145.6729479,29.3712104,22.8787368,1.8,29.3881854,22.8648007,1.063989,8.2077454,16.7851248,1814.8211593,11429.6308594,18.558687,680.9380926,221.1108004,786.8671224,14.4122676,31.1256847,1.884673,85.9286336),(45746,'humerus.tif',230,2,27,144.177415,29.4749974,22.6695469,1.8,29.4608686,22.5782832,1.0597382,8.0252325,17.8002644,1793.0619672,12573.1531127,18.2812343,706.3464249,223.4280409,805.861664,14.1903413,32.48443,2.103851,87.3236336),(45747,'humerus.tif',230,2,28,141.6380781,29.5746173,22.3610895,1.8,29.4925143,22.1757292,1.0381415,7.7044311,18.1811031,1678.0479994,13381.6404665,17.5186632,736.0191735,217.8029721,827.7419037,13.7672305,33.3740793,2.1124106,89.5234539),(45748,'humerus.tif',230,2,29,138.0781266,29.562016,21.7424837,1.8,29.407227,21.4776867,1.0017499,7.160743,18.1099962,1443.9662693,14038.2952053,16.3314975,775.1683137,201.6503417,853.6955322,12.9649362,33.9526097,2.1315732,90.5928757),(45749,'humerus.tif',230,2,30,123.2871055,29.5500043,20.770115,1.8,29.3505819,20.5745994,0.9437278,6.5311108,17.6840061,1120.5752224,13381.3355715,13.4731614,756.6914137,171.5749835,819.1711581,12.7024205,34.5636989,2.1631521,102.1757044),(45750,'humerus.tif',230,2,31,113.3519703,29.6988607,20.2264778,1.8,29.3774558,19.8722481,0.9101338,6.3101006,17.4378503,948.3733784,13191.6575976,11.7781345,756.4956349,150.2944931,807.6693277,12.2912234,34.9077091,2.1538729,99.6470794),(45751,'humerus.tif',230,2,32,108.8581256,29.8799959,20.2130399,1.8,29.5211376,19.811236,0.9061482,5.9796811,17.5572323,849.7598364,13322.6589241,11.2410482,758.8131609,142.1078862,807.0842122,11.8373458,35.0914168,2.1851409,97.7792901),(45752,'humerus.tif',230,2,33,104.3496821,30.2085496,20.4321057,1.8,29.8324882,19.9696327,0.9095124,5.6402783,17.9395268,752.2879572,13197.3533674,10.8322537,735.6578313,133.3778085,777.1202214,11.2283834,35.2764665,2.1734231,95.8505241),(45753,'humerus.tif',230,2,34,101.5305689,30.5534339,20.6144232,1.8,30.1250078,20.1462005,0.9061893,5.4316302,18.2457711,691.5136088,13228.6528383,10.4850553,725.0256922,127.312351,762.5309735,10.8251018,35.453097,2.1806269,95.5937117),(45754,'humerus.tif',230,2,35,102.5389112,30.7506059,20.6456365,1.8,30.3649212,20.2374911,0.8964548,5.2564303,18.1568823,665.7918033,13409.1354166,10.4272805,738.5153037,126.662347,773.9113286,10.3713661,35.4975403,2.1824166,94.2817194),(45755,'humerus.tif',230,2,36,103.9584069,30.8597399,20.5848252,1.8,30.6148624,20.3592529,0.8818305,5.1746381,18.0953358,667.9430691,13410.9076744,10.3236875,741.1251079,129.0801515,778.0307692,10.105668,35.6355944,2.2064681,93.0527348),(45756,'humerus.tif',230,2,37,104.0650463,30.9513688,20.5206879,1.8,30.7589532,20.3531551,0.8680943,5.1235812,17.7010608,676.7874775,12973.042992,10.099853,732.8963579,132.0926625,766.1113818,10.0257373,35.4963559,2.2230308,91.8691487),(45757,'humerus.tif',230,2,38,105.5159229,31.0084367,20.4332541,1.8,30.9267717,20.4010858,0.8556664,5.137336,17.8555183,696.6797833,12544.4365636,10.0246658,702.5523624,135.6111005,736.111766,10.1391919,35.1891842,2.2297147,92.3795472),(45758,'humerus.tif',230,2,39,108.9004914,30.9533813,20.3328277,1.8,30.984006,20.3810368,0.84069,5.1239966,18.15137,724.6605413,12398.6895309,10.076548,683.0718317,141.4248673,716.4702165,10.1659731,34.9230191,2.2049768,90.145344),(45759,'humerus.tif',230,2,40,109.6445409,30.9375342,20.2575249,1.8,31.1124035,20.4083478,0.8250528,5.1734454,18.3784785,749.1358005,12206.8054427,9.860938,664.1902085,144.804041,699.3468814,10.1734279,34.6898887,2.2071483,90.2815393),(45760,'humerus.tif',230,2,41,112.7740929,30.9731092,20.2212898,1.8,31.248414,20.4673783,0.8080601,5.2299729,18.5981002,766.588127,12108.0883851,9.8236416,651.0389918,146.5759284,687.9466745,10.2215521,34.4142783,2.2300619,90.8937502),(45761,'humerus.tif',230,2,42,114.2045654,30.9314465,20.1674009,1.8,31.3620271,20.5660205,0.7959999,5.2048569,18.7488475,793.6229308,11899.2305424,9.7188267,634.6646407,152.4773767,671.8601886,10.1630897,34.0957746,2.2725194,91.4683518),(45762,'humerus.tif',230,2,43,116.0261402,31.015605,20.256085,1.8,31.6461772,20.8960223,0.786853,5.3212857,18.7145747,833.5567121,11600.4553481,9.6969774,619.8620893,156.6457355,657.5760011,10.2255627,33.759059,2.2749406,93.1921565),(45763,'humerus.tif',230,2,44,115.7118357,31.3106002,20.6678497,1.8,31.862284,21.2084283,0.7627463,5.1738409,18.3728056,894.2907617,10805.8538706,9.2059534,588.1439177,172.8485229,629.8712511,10.2919406,33.4017828,2.3151666,80.8875155),(45764,'humerus.tif',230,2,45,114.3562863,31.592601,21.1367448,1.8,32.1343329,21.6412426,0.7320568,5.3829357,17.8840045,938.8970918,9693.3254241,8.5149639,542.0109041,174.4210111,585.6489822,10.4189523,32.8987292,2.3228735,92.7647658),(45765,'humerus.tif',230,2,46,114.7008237,31.6956966,21.4100599,1.8,32.2998983,21.9399661,0.7053628,5.6203096,17.7325658,972.0719393,8987.1018241,8.0349066,506.8133919,172.9570098,553.0497561,10.5475812,32.2814267,2.3714734,88.1271175),(45766,'humerus.tif',230,2,47,116.726611,31.760288,21.5980755,1.8,32.3576456,22.1190866,0.6847583,5.7333184,17.6963586,998.7336558,8564.9237715,7.7825196,483.9935706,174.1981844,530.1626533,10.6470938,31.8472217,2.378566,85.0615002),(45767,'humerus.tif',230,2,48,118.6825769,31.7822196,21.7183715,1.8,32.3775759,22.2267997,0.6628733,5.810128,17.6412637,1016.26974,8144.3342548,7.4908028,461.6638801,174.9134841,509.7304038,10.7105472,31.3315756,2.406939,82.5062814),(45768,'humerus.tif',230,2,49,118.8557619,31.8869148,21.8691967,1.8,32.6150867,22.4285469,0.6467353,5.8006656,17.4278209,1036.4237551,7860.6214237,7.1929078,451.0386847,178.6732477,501.4263975,10.7476818,30.7517832,2.4203919,80.5444689),(45769,'humerus.tif',230,2,50,124.107109,31.9721904,21.9852136,1.8,32.5249835,22.3829521,0.6280646,5.7939724,17.1283495,1055.4549767,7534.0446631,7.1413295,439.8581815,182.1643098,488.4373002,10.7525737,30.1107217,2.429058,78.502875),(45770,'humerus.tif',230,2,51,124.4018629,32.1069257,22.1231797,1.8,32.6996958,22.509453,0.6099439,5.7859597,16.9041172,1067.2261623,7030.2136181,6.8032157,415.887653,184.4510185,466.210338,10.7842441,29.500741,2.4492089,76.5034531),(45771,'humerus.tif',230,2,52,124.7990025,32.2183473,22.2975522,1.8,32.835775,22.6511085,0.5976056,5.8281855,16.5973302,1085.0538851,6504.6936067,6.585051,391.9120451,186.1735314,445.4930358,10.874253,28.6611741,2.4634733,74.3678359),(45772,'humerus.tif',230,2,53,123.3834954,32.3306963,22.4133765,1.8,33.0268569,22.8043007,0.5857133,5.8445469,16.3303695,1107.7725673,6082.7192535,6.2839451,372.4789736,189.5395123,428.7373852,10.9711916,27.8082502,2.4886158,72.5046095),(45773,'humerus.tif',230,2,54,119.9260294,32.4178408,22.5313006,1.8,33.1132538,22.9119679,0.5747492,5.8500305,16.1955781,1135.5376641,5750.56003,5.906905,355.069759,194.1079912,412.8999995,11.0709698,27.1715724,2.4958097,71.5181954),(45774,'humerus.tif',230,2,55,117.1724808,32.476121,22.5573381,1.8,33.1410375,22.8927986,0.5603386,5.7934138,15.9955289,1159.1858103,5471.2469857,5.5161594,342.0485189,200.0868325,401.7372598,11.1576447,26.6826338,2.2677659,70.8339923),(45775,'humerus.tif',230,2,56,119.9145524,32.5336325,22.5861664,1.8,33.1802951,22.9242196,0.5486383,5.7386418,15.8053415,1186.8775421,5319.55021,5.4359099,336.56661,206.8220304,398.5956546,11.2652326,26.3429345,2.3020807,69.9383752),(45776,'humerus.tif',230,2,57,124.3929849,32.5892831,22.6682064,1.8,33.2441663,22.9873407,0.5368152,5.7467708,15.5106006,1215.3570579,5160.4508234,5.4221197,332.7047714,211.4852157,399.5749404,11.3937334,25.9114402,2.2969419,68.7969611),(45777,'humerus.tif',230,2,58,128.3474718,32.6175581,22.7462554,1.8,33.2121036,23.0429693,0.5206481,5.8081684,15.2310075,1247.3739039,5034.7493669,5.2932418,330.5591818,214.7620084,401.1626456,11.5350626,25.5036255,2.315357,68.6387348),(45778,'humerus.tif',230,2,59,128.7698987,32.6716044,22.8122163,1.8,33.2497407,23.0957147,0.5050099,5.97051,14.8217182,1273.5709299,4865.1364608,5.0237005,328.2437558,213.3102405,399.894244,11.6940361,25.1226758,2.3125541,68.7561255),(45779,'humerus.tif',230,2,60,127.8880596,32.585669,22.833451,1.8,33.0290287,23.0133382,0.4802757,6.0754656,14.638661,1297.4652628,4597.9851003,4.549956,314.0987477,213.5581623,389.4589926,11.8387139,24.6759334,2.3206539,68.3598913),(45780,'humerus.tif',230,2,61,128.6710488,32.3271214,22.7912954,1.8,32.6578334,22.9458109,0.4538298,6.1519225,14.5480493,1318.3493535,4127.6072845,4.1218492,283.7223881,214.2987583,363.5918529,11.9944116,20.2280951,2.8501359,54.5441958),(45781,'humerus.tif',230,2,62,128.7849215,32.1179035,22.7727917,1.8,32.3878411,22.8801433,0.4276063,6.2415163,14.3966689,1336.4781959,3716.8456928,3.691211,258.1740059,214.1271657,341.4923343,12.1274703,19.2700922,2.8771043,53.0285787),(45782,'humerus.tif',230,2,63,126.3775962,31.9195219,22.8059602,1.8,32.1592748,22.8777998,0.4028178,6.3017073,14.1395429,1350.0926521,3358.1319438,3.2368144,237.4993284,214.2423627,322.1176396,12.2847129,18.5943493,2.918855,52.079774),(45783,'humerus.tif',230,2,64,126.3613872,31.7302179,22.8729346,1.8,31.9093836,22.9048313,0.3645002,6.3003765,13.7726329,1361.8370863,3104.7478106,2.6763271,225.428779,216.1516993,314.5045683,12.4103811,18.0310386,2.9205927,51.2217662),(45784,'humerus.tif',230,2,65,125.884257,31.5136914,22.9220821,1.8,31.6562775,22.9305514,0.3206144,6.39266,13.2634942,1373.7819669,2839.3778881,2.0837894,214.074651,214.8998941,308.7432618,12.5525458,17.5362493,2.9996956,50.6471646),(45785,'humerus.tif',230,2,66,125.2725685,31.3244187,23.0070436,1.8,31.3981738,22.9550458,0.269428,6.57005,12.2678096,1393.8593479,2584.2376128,1.4792991,210.651917,212.1535359,313.901202,12.700407,17.2200058,3.0378936,50.2729614),(45786,'humerus.tif',230,2,67,124.6204736,31.1767192,23.142494,1.8,31.2241461,23.072979,0.2345416,6.6844257,9.4207938,1418.5244901,2456.8708499,1.1217595,260.7923389,212.2133678,411.2989144,12.8527411,16.9462936,3.0637685,49.8987583),(45787,'humerus.tif',230,2,68,124.6918976,30.9969487,23.2935695,1.8,31.0224642,23.2117338,0.1998025,6.7863032,9.1909949,1447.5739631,2368.1702027,0.8186571,257.6620069,213.3081776,414.627375,12.9985148,16.6770935,3.0997566,49.6341567),(45788,'humerus.tif',230,2,69,124.852611,30.8308959,23.4342843,1.8,30.8734507,23.3574249,0.1682694,6.854329,8.9802779,1481.3393269,2298.314505,0.5836519,255.9291066,216.1173361,420.2621714,13.161464,16.4668818,0.1179336,49.2599536),(45789,'humerus.tif',230,2,70,125.6528482,30.6542014,23.6124243,1.8,30.701953,23.5459753,0.1224763,6.9708613,8.7660205,1512.7336334,2218.8333297,0.312574,253.1175154,217.0081375,424.9725852,13.2462565,16.3321032,0.128475,48.9499536),(45790,'humerus.tif',230,2,71,126.3578626,30.4727382,23.7888172,1.8,30.4982066,23.7443903,0.0669035,7.0679053,8.5120878,1542.5201563,2160.8008321,0.0941242,253.8508639,218.2428997,432.6055687,13.338782,16.1809914,0.1635739,48.7761489),(45791,'humerus.tif',230,2,72,125.2763129,30.2802184,23.9634311,1.8,30.323933,23.9192025,-0.0017908,7.1497646,8.2363278,1569.031236,2107.3698783,0.0000668,255.8627983,219.4521518,438.3976667,13.4320186,16.0909123,0.233297,48.6931412),(45792,'humerus.tif',230,2,73,124.9963022,30.0971565,24.1817113,1.8,30.1383724,24.1574053,-0.0852929,7.3437688,7.9905859,1595.02089,2099.9495107,0.1511877,262.8029462,217.1937769,432.5618957,13.5324822,16.1308027,0.2974392,49.1205319),(45793,'humerus.tif',230,2,74,124.8797607,29.8627138,24.3981872,1.8,29.8864194,24.393417,-0.1790856,7.427763,8.1701051,1618.232688,2086.132531,0.6604103,255.3372954,217.8627238,424.7429443,13.6256107,16.2093627,0.3565323,49.2113288),(45794,'humerus.tif',230,2,75,124.647715,29.6287532,24.6185129,1.8,29.649787,24.6176301,-0.2862542,7.4251896,8.5854231,1623.2802302,2101.7634295,1.6563109,244.8060389,218.6180174,416.9790509,13.7145432,16.3532356,0.4042695,49.4759304),(45795,'humerus.tif',230,2,76,124.231702,29.361101,24.8693149,1.8,29.3601126,24.8821819,-0.3994145,7.3784342,8.9901091,1619.3254505,2132.3108909,3.131194,237.1840949,219.4673565,409.9279306,13.7175009,16.5416676,0.4301172,49.6951335),(45796,'humerus.tif',230,2,77,124.4032546,29.1310375,25.1271408,1.8,29.1286347,25.133321,-0.4641142,7.2548613,9.4121239,1598.5718721,2210.2560825,4.1545175,234.8307461,220.3449245,401.4571107,13.6855983,16.854603,0.4986128,50.1601335),(45797,'humerus.tif',230,2,78,124.7686855,28.8326479,25.4232286,1.8,28.8306597,25.4417578,-0.5103006,7.1584736,9.8350719,1587.565717,2296.0744465,4.961078,233.4578195,221.7743348,392.5884329,13.6175455,17.2936186,0.5258164,51.0557506),(45798,'humerus.tif',230,2,79,124.2348253,28.5610399,25.7261269,1.8,28.5075189,25.7661652,-0.5489302,7.0640229,10.4232573,1558.123417,2430.935803,5.6371355,233.2222766,220.5716834,382.022408,13.5187938,17.8769851,0.5471109,52.1251724),(45799,'humerus.tif',230,2,80,124.129057,28.1971942,26.053592,1.8,28.0796259,26.1359616,-0.5819984,6.9557302,11.0719582,1536.9862327,2606.4704495,6.2512214,235.4118752,220.9669122,374.1607349,13.4509012,18.6644728,0.5603599,53.799016),(45800,'humerus.tif',230,2,81,124.6823977,27.8460354,26.4135602,1.8,27.6683292,26.5460233,-0.584079,6.9311681,12.0208118,1508.4412455,2895.497895,6.3188308,240.8737396,217.6316072,366.3298012,13.3930539,19.8315229,0.3761523,55.5980393),(45801,'humerus.tif',230,2,82,127.1360616,27.4169658,26.7608993,1.8,27.2061343,26.9178127,-0.5887878,6.8647592,13.2559737,1500.8053591,3329.1773107,6.5351612,251.1454371,218.6246175,364.2390002,13.3543974,21.3498096,0.4067984,58.8672814),(45802,'humerus.tif',230,2,83,126.8361945,27.054482,27.0783774,1.8,26.7617101,27.2748338,-0.5853073,6.8508402,13.8745917,1488.4681001,3647.9030737,6.4518856,262.919671,217.2679628,370.1857002,13.3012074,22.296443,0.3998713,60.4471017),(45803,'humerus.tif',230,2,84,126.2180429,26.7278384,27.3704701,1.8,26.3785302,27.6016098,-0.581567,6.8370304,13.9800083,1478.8285395,3892.7721057,6.3480918,278.4527759,216.2969093,384.144598,13.2537098,22.663021,0.4116272,61.6073204),(45804,'humerus.tif',230,2,85,126.3632833,26.4482704,27.6162872,1.8,26.0820891,27.855925,-0.5763695,6.8172221,13.8956837,1475.5082898,4032.1058718,6.2551316,290.1696648,216.4383484,396.0332886,13.152187,22.768652,0.3691289,61.7623204),(45805,'humerus.tif',230,2,86,127.8216806,26.2034073,27.8021934,1.8,25.8206972,28.0740124,-0.5692687,6.7684234,13.8121913,1474.4562224,4152.3982692,6.1895204,300.6328369,217.8433801,406.8340211,13.0425854,22.7971241,0.390607,63.3155468),(45806,'humerus.tif',230,2,87,124.2820507,25.9506184,28.0638208,1.8,25.5376156,28.342254,-0.5544283,6.8069673,13.7730297,1454.1808108,4137.0283883,5.7409472,300.3717033,213.6312313,405.4308985,13.0425854,22.8856084,0.3635269,62.2649297),(45807,'humerus.tif',230,2,88,120.8091647,25.7014232,28.2790507,1.8,25.2554072,28.5545301,-0.5334199,6.8028118,13.782254,1438.8060772,4012.9364688,5.2059294,291.1669225,211.5016737,394.8323291,13.0269901,23.0262414,0.3792564,61.7967033),(45808,'humerus.tif',230,2,89,120.589187,25.5628411,28.3804578,1.8,25.1219843,28.6410449,-0.529262,6.7372545,13.7649975,1449.0306779,3909.4376637,5.1234406,284.0129583,215.0773239,387.9165882,12.9858554,22.9762355,0.3548228,61.7325002),(45809,'humerus.tif',230,2,90,123.7682764,25.4156784,28.4575305,1.8,24.9506988,28.7456074,-0.5275347,6.8113654,13.723883,1473.1788736,3962.6722432,5.2274841,288.742789,216.2824625,393.9024843,13.0107229,22.9176045,0.337792,61.8797111),(45810,'humerus.tif',230,2,91,124.408346,25.1868204,28.6283912,1.8,24.7409162,28.9192628,-0.5250031,6.9279174,13.5671469,1488.9341954,3931.7276723,5.2089183,289.7976782,214.9180074,396.0012038,13.0536254,22.8714319,0.2992463,62.091125),(45811,'humerus.tif',230,2,92,118.4084079,24.8953019,28.9450606,1.8,24.4315232,29.2237953,-0.5017378,6.9314874,13.3160797,1465.1054328,3897.6970947,4.5648974,292.7060495,211.3695584,398.2788382,13.114966,22.8039731,0.2895037,62.6955468),(45812,'humerus.tif',230,2,93,117.2616881,24.7227513,29.0934289,1.8,24.2547081,29.3606544,-0.4976304,7.0216054,13.163403,1473.9362982,3843.0699014,4.4531671,291.9510942,209.9144304,398.3536234,13.1798185,22.6554665,0.2914568,62.3181173),(45813,'humerus.tif',230,2,94,120.3147411,24.6750087,29.1341172,1.8,24.2100589,29.4194577,-0.5000645,7.1788074,13.0597583,1504.4288459,3811.0532926,4.6101229,291.8165267,209.5652877,400.7310889,13.2435778,22.500375,0.254168,61.682539),(45814,'humerus.tif',230,2,95,117.2741484,24.4229629,29.383592,1.8,23.9874685,29.6446686,-0.4867893,7.2495634,12.6071166,1508.584654,3693.1732384,4.2771444,292.9435289,208.0931741,404.6020082,13.3139577,22.0308674,0.2560704,60.9763048),(45815,'humerus.tif',230,2,96,114.6503232,24.2124013,29.6081308,1.8,23.7986353,29.8349405,-0.4736459,7.306221,12.3453144,1504.552831,3577.7301501,3.9756542,289.8047016,205.9276389,404.6237496,13.4285518,21.7511464,0.2631271,60.7305079),(45816,'humerus.tif',230,2,97,112.1966369,24.0447108,29.7847838,1.8,23.6670804,29.9898563,-0.4613526,7.3846219,12.2467197,1518.6528969,3491.9429066,3.7056149,285.1329175,205.650732,401.5355818,13.5219251,21.6562251,0.2606024,60.1902893),(45817,'humerus.tif',230,2,98,112.3281021,23.9299024,29.8637396,1.8,23.5302471,30.0807925,-0.4584307,7.5703309,12.0823752,1555.5138426,3457.3697035,3.6664426,286.1498367,205.4750142,405.4594519,13.6387092,21.4116118,0.2599029,60.428297),(45818,'humerus.tif',230,2,99,112.703514,23.7455229,30.0193777,1.8,23.3494994,30.2230733,-0.4473379,7.6814636,11.9357175,1592.0979008,3423.2664467,3.5147372,286.8086028,207.2649153,414.0816025,13.7708024,21.146285,0.2405342,60.1072815),(45819,'humerus.tif',230,2,100,110.6922363,23.6006158,30.2043369,1.8,23.2336225,30.3774581,-0.4179589,7.7529762,11.8414377,1607.3181858,3353.9364026,3.0394515,283.237264,207.31628,413.2168727,13.9250773,21.014509,0.2458731,59.6688753),(45820,'humerus.tif',230,2,101,107.6550216,23.4128051,30.3474215,1.8,23.0100499,30.5299824,-0.3893753,7.8536494,11.7526716,1623.114223,3271.8537407,2.5855888,278.3923391,206.6700638,411.863143,14.0789301,20.8657879,0.2323667,59.6688753),(45821,'humerus.tif',230,2,102,107.4293056,23.1894991,30.5051366,1.8,22.8011096,30.6723968,-0.3685829,7.9917444,11.6641798,1659.1532771,3245.0878447,2.3242624,278.209689,207.6084013,414.9971239,14.2621426,20.8475013,0.2594051,59.2194535),(45822,'humerus.tif',230,2,103,107.3606558,23.0933109,30.6034296,1.8,22.6995118,30.7745546,-0.3554524,8.1498324,11.6903051,1704.2877002,3227.4512055,2.1671476,276.0792963,209.1193563,416.5203285,14.4739973,20.7926895,0.2639637,60.2622815),(45823,'humerus.tif',230,2,104,110.0448807,23.0332597,30.6886468,1.8,22.6933371,30.8390124,-0.3501335,8.3275853,11.6539553,1761.5514098,3309.4191915,2.1580697,283.9739045,211.5320774,432.7141808,14.697281,20.6215557,0.2896569,59.6954691),(45824,'humerus.tif',230,2,105,108.3001865,22.9301149,30.8621837,1.8,22.5999205,31.0008724,-0.3100378,8.3960409,11.5855661,1789.0477807,3247.2335763,1.6801461,280.2826844,213.0823088,431.0461198,14.9091357,20.5140917,0.3109983,59.5482582),(45825,'humerus.tif',230,2,106,107.2570644,22.7560983,30.9859945,1.8,22.4662555,31.1263746,-0.3000468,8.5779399,11.438018,1822.051033,3231.2404723,1.5616381,282.5000335,212.4112606,436.7763969,15.1534191,20.3819119,0.3614409,59.9224613),(45826,'humerus.tif',230,2,107,107.5142278,22.6201411,31.1160135,1.8,22.3213472,31.2927829,-0.2639416,8.6803527,11.368619,1856.6334378,3233.3785808,1.2196126,284.4126089,213.8891696,444.9751618,15.4358443,20.2585072,0.283029,60.3310474),(45827,'humerus.tif',230,2,108,105.7105971,22.5035404,31.2344641,1.8,22.2356166,31.4020228,-0.2203345,8.7897784,11.3071973,1907.8711489,3179.9902049,0.8415755,281.2359358,217.0556587,449.0875472,15.5914709,20.1538759,0.2925618,60.2558288),(45828,'humerus.tif',230,2,109,104.3173604,22.3268122,31.3481214,1.8,22.0519171,31.5485064,-0.1852276,8.930159,11.2542395,1937.1138318,3144.4686019,0.5897181,279.4030285,216.91818,450.9468848,15.6488145,20.1316612,0.2888757,60.6112272),(45829,'humerus.tif',230,2,110,103.0127106,22.2669258,31.4198596,1.8,21.9837499,31.6049403,-0.136205,9.0810421,11.2658652,1993.8239397,3112.0427066,0.3165474,276.2364592,219.5589362,453.1648983,15.7532776,20.0880551,0.2814793,61.038618),(45830,'humerus.tif',230,2,111,103.0016893,22.2303948,31.5405406,1.8,22.0163671,31.7403153,-0.088961,9.1719948,11.2072657,2054.5167136,3131.7041408,0.1355025,279.4351644,223.9988973,462.7023559,15.8752172,19.9610286,0.2873661,61.1028211),(45831,'humerus.tif',230,2,112,102.287759,22.250646,31.6407495,1.8,22.0351799,31.8798899,-0.019432,9.2383255,10.884304,2131.0254178,3068.019464,0.0064367,281.875576,230.6722597,472.6815035,16.0083732,19.7472993,0.3652014,61.3752118),(45832,'humerus.tif',230,2,113,102.3074585,22.2129166,31.6585741,1.8,22.1013674,31.9383932,0.0524803,9.1784691,10.5714482,2202.1379011,3086.6491046,0.0469192,291.979778,239.9243151,456.5636614,16.1462795,19.8327343,2.7059098,62.2676025),(45833,'humerus.tif',230,2,114,101.883515,22.174115,31.7466222,1.8,22.1206726,32.0488496,0.1112191,8.9003051,10.4972017,2251.999602,3128.0957835,0.2091802,297.9933001,253.0249901,439.4942034,16.2132487,20.5154092,2.7337247,63.5640166),(45834,'humerus.tif',230,2,115,100.3220955,22.1307183,31.8545785,1.8,22.1378485,32.232801,0.1788266,9.0028588,10.1942521,2267.4410487,3121.6149011,0.5290241,306.2132329,251.8578941,421.313256,16.2505258,20.8394328,2.7078862,64.7320244),(45835,'humerus.tif',230,2,116,97.7059377,22.1456649,31.8654936,1.8,22.1968417,32.2849003,0.2179483,9.0937675,10.5605481,2273.9950477,3117.5687322,0.7613582,295.2089888,250.0608286,411.2268949,16.3568565,21.2820432,2.6893452,65.7262276),(45836,'humerus.tif',230,2,117,95.3559497,22.1645128,31.8226433,1.8,22.2618986,32.2665428,0.2827038,9.1670657,11.2266355,2268.027972,3083.9852335,1.2366847,274.7025341,247.410463,404.1934816,16.3460807,21.3880357,2.6957714,66.2178214),(45837,'humerus.tif',230,2,118,95.9319118,22.0974031,31.864839,1.8,22.1631355,32.2432269,0.3270149,9.3092892,11.6841376,2280.0118439,3146.5001705,1.6497208,269.2967401,244.9179309,410.578628,16.3229944,21.5846905,2.7277431,66.0440167),(45838,'humerus.tif',230,2,119,95.7027368,22.0748003,31.8156926,1.8,22.1705674,32.2447729,0.3626225,9.3378549,11.9016882,2266.7559283,3139.458069,2.0070708,263.7825847,242.7491065,409.4238732,16.218399,21.5447226,2.2798128,65.7606105),(45839,'humerus.tif',230,2,120,95.2046652,22.0484728,31.7432573,1.8,22.1541791,32.1914731,0.3769335,9.3331767,11.8734488,2256.0537868,3118.9996261,2.1496613,262.6869145,241.7241057,413.484338,16.2336383,21.4708585,2.2923428,65.4694151),(45840,'humerus.tif',230,2,121,92.1919396,21.9926407,31.7166937,1.8,22.1414649,32.1306406,0.438138,9.4233031,12.0983958,2204.3450807,3105.7374983,2.7656277,256.7065534,233.9248848,410.5129589,16.1189111,21.5618608,2.307886,65.6698136),(45841,'humerus.tif',230,2,122,92.2223123,21.9471533,31.7160376,1.8,21.9293497,32.0695666,0.4679045,9.5112991,11.8479343,2166.1148357,3152.5090185,3.1265871,266.080899,227.7412178,421.7435088,16.0848951,21.4708585,2.2923428,64.8649934),(45842,'humerus.tif',230,2,123,91.1226421,21.9220347,31.6237948,1.8,21.9348878,32.0126782,0.5109604,9.4890695,11.9205811,2145.9292819,3167.3174674,3.6317821,265.7016002,226.147494,427.7985242,16.0512842,21.4127338,2.2947335,64.3999933),(45843,'humerus.tif',230,2,124,91.4119074,21.9851786,31.5369272,1.8,22.0206986,31.786654,0.5347638,9.4283412,12.2027339,2160.1865094,3215.9270086,3.9570801,263.5415167,229.1162843,435.2087994,16.0067052,21.5451407,2.328212,65.0576027),(45844,'humerus.tif',230,2,125,92.7084177,22.0643287,31.5375632,1.8,22.1622176,31.793264,0.5932457,9.422704,12.5586957,2160.5211082,3367.5449773,4.8292206,268.1444831,229.2888644,438.8479016,15.9672569,21.953441,2.4111391,65.6244151),(45845,'humerus.tif',230,2,126,90.2485079,22.1943497,31.5255729,1.8,22.2827285,31.73763,0.6105238,9.3595929,12.5185018,2137.1913683,3352.1329486,4.9436496,267.7742906,228.3423435,437.3444461,15.9394834,22.2300763,2.2994653,66.0783997),(45846,'humerus.tif',230,2,127,88.9564713,22.1414059,31.3815447,1.8,22.2779888,31.4959833,0.5965437,9.3162659,12.5216252,2119.9767816,3328.380042,4.679171,265.8105463,227.5564925,433.2823313,15.9083601,22.2663867,2.395583,65.7761888),(45847,'humerus.tif',230,2,128,87.393676,22.0720365,31.2923065,1.8,22.2048257,31.4739661,0.6146135,9.3390283,12.425101,2066.3564115,3339.9948148,4.8433127,268.8102743,221.2603226,434.533757,15.8875432,22.2095327,2.3932146,65.538181),(45848,'humerus.tif',230,2,129,87.5291573,22.0382816,31.1428902,1.8,22.2163485,31.2337103,0.6114566,9.3004577,12.1936107,2072.1896616,3304.3301235,4.807477,270.9886517,222.8051264,439.8959637,15.8632557,22.0473552,2.3959745,65.4019857),(45849,'humerus.tif',230,2,130,87.3006906,22.0216806,30.9820734,1.8,22.1513446,30.9658368,0.5950596,9.2222821,11.851666,2085.0535796,3266.5745659,4.5720158,275.6215502,226.0886789,449.6977235,15.8102426,21.7808107,2.4040169,65.0277825),(45850,'humerus.tif',230,2,131,87.5430809,21.9732469,30.9064458,1.8,22.0255888,30.8011047,0.5831265,9.2485798,11.4919378,2115.6556451,3286.4908259,4.4238507,285.9823028,228.7546503,468.1595873,15.7508564,21.5484858,2.3231277,64.3435794),(45851,'humerus.tif',230,2,132,86.4706496,21.9266989,30.7945495,1.8,21.9870447,30.6878008,0.576878,9.2433541,11.3397445,2103.4455212,3267.4372318,4.287098,288.140286,227.5630144,466.9354965,15.6682796,21.646932,2.3485997,63.720353),(45852,'humerus.tif',230,2,133,83.8304098,21.8718419,30.6954119,1.8,21.9463542,30.6614783,0.5535422,9.2174023,11.1867511,2073.8717249,3184.4952994,3.8612901,284.6666797,224.9952499,461.6263381,15.5968188,21.5959573,2.3358927,63.7657514),(45853,'humerus.tif',230,2,134,84.0235369,21.8244016,30.5673055,1.8,21.9365689,30.4423046,0.5534529,9.2088717,11.1468717,2058.7522047,3188.9721769,3.8690683,286.0867387,223.5618301,464.0074495,15.5502922,21.6015189,2.3866419,63.3805328),(45854,'humerus.tif',230,2,135,82.5800181,21.6958407,30.4520954,1.8,21.7853387,30.3847021,0.5337424,9.2415006,11.1580403,2051.4621243,3163.9451809,3.5624396,283.5574251,221.9836608,460.3331421,15.5057485,21.6546996,2.3840354,63.4713297),(45855,'humerus.tif',230,2,136,82.7109217,21.6846432,30.2395356,1.8,21.7376609,30.0161144,0.5154468,9.1092089,11.0527184,2064.2219151,3183.9961074,3.34943,288.0735763,226.6082522,464.284629,15.4774729,21.7080267,2.3814416,63.6529235),(45856,'humerus.tif',230,2,137,83.9583512,21.6404087,30.1176786,1.8,21.6963335,29.9674977,0.4993551,9.0698315,10.940153,2109.9250295,3183.1467245,3.2086982,290.9599811,232.6311178,470.5777668,15.4774519,21.7642589,2.3838952,63.5511111),(45857,'humerus.tif',230,2,138,82.4998746,21.4762308,29.9530147,1.8,21.4424414,29.7978293,0.4762087,9.0331958,10.8930347,2110.5129492,3168.3979262,2.889455,290.8645753,233.6396776,468.6005568,15.5357788,21.7808107,2.4040169,63.8987204),(45858,'humerus.tif',230,2,139,82.9921808,21.4776814,29.6699783,1.8,21.4876413,29.3690092,0.4745735,8.8836619,10.7744144,2157.5029667,3215.7649523,2.8882891,298.4630838,242.8618958,480.2281402,15.5523287,21.7863252,2.409042,63.8423065),(45859,'humerus.tif',230,2,140,83.8216583,21.4291162,29.6066029,1.8,21.4461551,29.3885349,0.4811797,8.9671188,10.6214894,2153.330136,3244.398067,2.9925342,305.4560372,240.1362333,489.9362369,15.6072736,21.7923895,2.4140643,64.0615096),(45860,'humerus.tif',230,2,141,83.1128343,21.2007582,29.3031586,1.8,21.1859766,29.0776098,0.4468837,8.863414,10.5897045,2177.1579547,3252.9883679,2.5870247,307.1840534,245.6342398,487.0691977,15.6733072,21.8175935,2.3813148,64.3903142),(45861,'humerus.tif',230,2,142,81.7803799,21.1432911,29.1087179,1.8,21.1368418,28.841053,0.4173483,8.7957228,10.3547639,2177.8104293,3230.5839045,2.2394018,311.990107,247.5988019,489.0634973,15.7556462,21.8710726,2.3336419,64.6173065),(45862,'humerus.tif',230,2,143,81.5707292,21.0105917,28.9308783,1.8,20.9932554,28.7414739,0.4243751,8.8177819,10.3956751,2184.6787385,3271.3047205,2.3049063,314.6793918,247.7583099,495.7885544,15.8191105,21.8283273,2.3963739,65.1011112),(45863,'humerus.tif',230,2,144,81.1859573,20.9368052,28.6905774,1.8,20.923864,28.5077274,0.3868688,8.662485,10.3971694,2223.0672213,3293.2977739,1.9261114,316.7494575,256.6315811,494.1237405,15.9042103,21.8809567,2.3937708,65.959119),(45864,'humerus.tif',230,2,145,79.6765024,20.9124539,28.4575122,1.8,20.8388275,28.273776,0.324066,8.4793006,10.3674826,2242.7002419,3283.6154926,1.3464469,316.7225458,264.4911838,485.3741803,16.0415649,21.9424947,2.4011642,67.0661501),(45865,'humerus.tif',230,2,146,79.9022828,20.863,28.2415938,1.8,20.7930411,28.0795031,0.333363,8.5824667,10.554532,2272.1244976,3364.9487034,1.4259186,318.8155296,264.7402652,493.3727217,16.262504,22.0880452,2.3735625,67.8067672),(45866,'humerus.tif',230,2,147,80.3577411,20.8449199,27.9059787,1.8,20.839718,27.708231,0.3301099,8.5520652,10.7127305,2354.1574472,3461.378121,1.4072152,323.108857,275.2735625,509.7252128,16.5219859,22.2515457,2.3414172,68.7367672),(45867,'humerus.tif',230,2,148,81.6638581,20.8269194,27.7226441,1.8,20.8855068,27.5097893,0.3752037,8.8404173,11.0681539,2451.4903353,3509.1214802,1.8278337,317.0466819,277.3048203,511.7036331,16.8291439,22.4430433,2.3048948,69.3865875),(45868,'humerus.tif',230,2,149,83.1007011,20.8038736,27.4160183,1.8,20.8639126,27.2109572,0.3562806,8.9181003,11.1299533,2584.8945406,3600.1610464,1.6849366,323.4659627,289.8481117,524.1480485,17.2158071,22.6741493,2.2957356,70.5014077),(45869,'humerus.tif',230,2,150,83.029851,20.9359958,27.1808159,1.8,20.9743039,26.9376502,0.2860178,8.933118,11.2487958,2749.3180593,3662.0704999,1.1015238,325.5522244,307.7669035,529.4186197,17.6229136,22.9580602,2.2893088,72.3004311),(45870,'humerus.tif',230,2,151,85.2827955,21.0758564,26.7543923,1.8,21.1220038,26.5398587,0.2244252,9.1857073,11.5106381,2986.1475788,3861.4993428,0.7039627,335.4722218,325.0862963,556.9026104,18.2073103,23.2727237,2.2996511,74.4626421),(45871,'humerus.tif',230,2,152,88.2621689,21.3352015,26.1190834,1.8,21.496797,25.9315262,0.0690379,10.2479799,11.2717269,3276.30968,4184.5687557,0.0700015,371.2446902,319.7029776,598.5121694,18.9741378,24.1716788,0.4980673,77.6410872),(45872,'humerus.tif',230,2,153,93.8018917,21.9832277,25.2795492,1.8,22.2559211,25.0060008,-0.2796411,11.647865,13.8201423,3660.507617,5015.0865971,1.1910011,362.8824128,314.2642561,608.3498127,20.3656022,25.3789738,0.4895981,82.070548),(45873,'humerus.tif',230,2,154,101.4566815,22.5077724,24.3800699,1.8,22.8318711,24.2039282,-0.4076374,12.2254415,14.0691701,4096.1958218,6014.8981101,2.6575865,427.5233049,335.0550435,714.058869,21.8290714,28.2445788,0.5324197,92.4684541),(45874,'humerus.tif',230,2,155,112.4551765,23.2008487,23.5930795,1.8,23.3504571,23.6254997,-0.4759873,12.5460299,15.1026876,4535.5166984,7531.8767683,3.9352212,498.7110224,361.5101149,796.6851533,22.8798396,28.8766308,0.516483,93.0572976),(45875,'humerus.tif',230,2,156,121.5708716,23.4972222,23.0991307,1.8,23.6756228,23.2548394,-0.4364909,12.9640902,15.4570716,5145.4310041,8469.8229455,3.6213475,547.9578015,396.8987347,874.0200843,23.4485354,29.2322991,0.5217768,95.1741101),(45876,'humerus.tif',230,2,157,129.4178719,23.7578976,22.8081501,1.8,24.0318678,23.0260316,-0.372244,13.306643,15.5052095,5904.6735048,9012.1694817,2.8532866,581.2349383,443.7387781,942.6309353,23.9654284,29.4340896,0.5178398,94.6870791),(45877,'humerus.tif',230,2,158,137.8178073,23.8380714,22.4962876,1.8,24.1873091,22.8666127,-0.3304609,13.7391386,15.4175384,6639.7642281,9671.6931218,2.4183957,627.3175965,483.2736926,1015.0194794,24.4657875,29.6901902,0.5677302,93.6928759),(45878,'humerus.tif',230,2,159,145.7564819,23.8507158,22.2550898,1.8,24.2685062,22.7430381,-0.2829359,14.2688318,15.1172853,7400.5237574,10176.5857471,1.8933588,673.1754751,518.6495911,1086.1019097,25.0418306,29.7930824,0.5779019,94.2752667),(45879,'humerus.tif',230,2,160,155.4704004,24.0640793,22.1758687,1.8,24.3805283,22.692901,-0.2045775,14.4393626,14.7784108,8227.5030771,10943.1118214,1.0694122,740.4796049,569.7968311,1181.1643376,25.2545713,29.7964086,0.6060382,94.1922589),(45880,'humerus.tif',230,2,161,163.4218932,24.055937,22.1211795,1.8,24.3322428,22.7665514,-0.1485866,14.8116924,14.3404297,8774.1349145,11415.1986659,0.5969246,796.0151075,592.3789603,1253.3941245,25.5114095,29.7135463,0.6111533,95.1786729),(45881,'humerus.tif',230,2,162,172.4536901,24.0408178,22.1992107,1.8,24.1167562,22.7912829,-0.1111639,14.8297809,14.0893348,9518.5836107,11747.551905,0.3537197,833.7903881,641.855984,1336.8542735,25.8650931,29.5773974,0.5952699,95.3070791),(45882,'humerus.tif',230,2,163,179.8504679,23.9712413,22.4949497,1.8,23.9832014,22.9644663,-0.0611198,14.5356357,14.0696176,10283.4830109,11901.1192855,0.1118364,845.8736848,707.4670313,1427.7039541,25.8192593,29.4020351,0.552173,95.5074776),(45883,'humerus.tif',230,2,164,187.7517788,23.8285213,22.7474939,1.8,23.7840214,23.1034317,0.0567154,14.2079723,14.0931992,11170.4981202,12147.787799,0.1005466,861.9609774,786.2133962,1492.9660151,25.7917639,29.2631028,0.4908921,97.3972979),(45884,'humerus.tif',230,2,165,191.0940867,23.7285701,22.8619156,1.8,23.6851316,23.1326002,0.3364777,13.6182612,14.8169918,11428.4064347,12043.3627711,3.4718144,812.8075478,839.1971849,1481.9417188,25.6936596,29.3277877,2.1338774,96.4938916),(45885,'humerus.tif',230,2,166,192.49101,23.6260519,22.9247962,1.8,23.6098402,23.2305594,0.6478632,14.1757826,15.8440618,11132.4280815,12065.7348158,11.6839747,761.5304061,785.3131223,1459.2129304,25.5402258,29.6314658,2.1305046,97.1138916),(45886,'humerus.tif',230,2,167,195.3648445,23.615833,22.9148887,1.8,23.6011605,23.2347226,0.7369252,14.4364654,15.9458241,10673.652557,12475.811638,14.7045555,782.3873852,739.3535909,1451.5470291,25.3681334,29.6314658,2.1305046,97.8246886),(45887,'humerus.tif',230,2,168,197.0172348,23.6234333,22.9028312,1.8,23.3957366,23.1974241,0.786302,14.5416237,15.8006281,10104.2447733,12407.1364881,16.4477811,785.2305893,694.8498301,1420.0352627,24.9786964,29.6670181,2.1022555,99.5030949),(45888,'humerus.tif',230,2,169,194.481888,23.6017904,22.9407601,1.8,23.2265254,23.2138487,0.719474,14.3845866,15.815843,9291.9754205,11515.8511147,14.0761672,728.121233,645.967498,1315.2950722,24.5249869,29.4534687,2.1157284,98.9252669),(45889,'humerus.tif',230,2,170,189.6249327,23.4196631,22.9973508,1.8,23.0585791,23.1806306,0.6796989,14.0366073,15.6024954,8311.8442044,10572.1057604,12.486368,677.5906996,592.1547872,1209.8814786,23.8247447,29.0568179,2.1240239,99.1632747),(45890,'humerus.tif',230,2,171,180.1465151,23.3159614,23.2691208,1.8,22.9905978,23.4981911,0.7350067,13.8457326,15.4826286,7390.3764484,9530.8879623,13.5017954,615.5859077,533.7656496,1092.9064051,22.8335479,28.4172556,2.1186993,109.7129545),(45891,'humerus.tif',230,2,172,166.4362732,23.2037503,23.7436548,1.8,22.8233905,24.0650822,0.835008,13.50252,15.2332469,6305.4218413,8405.9029815,15.2435798,551.8129534,466.9811162,965.6882119,17.7442513,25.2403845,0.4375546,81.3973604),(45892,'humerus.tif',230,2,173,142.425157,22.8893212,24.5877991,1.8,22.5226588,24.745539,0.9121132,12.6646438,15.0009186,4962.403249,6302.0262909,14.8445688,420.1093576,391.8312544,750.643123,16.001091,23.7049953,0.5163075,75.4211259),(45893,'humerus.tif',230,2,174,106.5244146,21.8771872,26.1781213,1.8,21.6577101,26.226052,1.1139275,10.8892539,15.0002547,3184.6966581,4291.9699686,14.2990435,286.1264724,292.462337,497.7412162,14.5195076,21.4620449,0.4361909,72.8347505),(45894,'humerus.tif',230,2,175,65.7664291,19.720534,28.9516785,1.8,19.8260024,28.8882366,0.9247689,6.5519521,15.0945098,821.1304303,2585.4305196,6.9884829,171.2828405,125.3260734,214.1028072,6.8137625,18.3851509,2.9119502,44.8337192),(45895,'humerus.tif',230,2,176,49.1474372,20.0501425,30.8301155,1.8,20.2641996,30.6828849,0.2586716,13.2308507,9.1017428,139.6520393,958.2215621,0.5359682,105.2789101,10.555031,71.0860918,6.2053879,17.2456232,2.8639103,41.7836803),(45896,'humerus.tif',230,2,177,38.9999288,19.5929115,30.6355414,1.8,19.9606838,30.6032695,0.2661261,2.7113147,8.4025032,66.4310674,544.3828281,0.4495837,64.7881724,24.501423,72.6050021,5.2245231,15.2753669,2.789354,36.6998365),(45897,'humerus.tif',230,2,178,27.3880307,19.9167052,30.3878333,1.8,20.2089185,30.4716862,0.3090184,1.9527508,6.6353561,21.9359613,278.6870659,0.4221922,42.000318,11.2333642,45.226,3.8256488,12.8717686,2.7912784,30.3007741),(45898,'humerus.tif',230,2,179,2.5224579,23.5481428,31.3284358,1.8,23.4747272,31.3561618,0.035626,0.9454941,1.374639,0.4085104,0.8549879,0.0005334,0.6219727,0.4320603,0.869313,1.8600001,2.7824552,0.2247112,7.6202579),(45899,'humerus.tif',230,2,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45900,'humerus.tif',230,2,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45901,'humerus.tif',230,2,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45902,'humerus.tif',230,2,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45903,'humerus.tif',230,2,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45904,'humerus.tif',230,2,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45905,'humerus.tif',230,2,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45906,'humerus.tif',230,2,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45907,'humerus.tif',230,2,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45908,'humerus.tif',230,2,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45909,'humerus.tif',230,2,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45910,'humerus.tif',230,2,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45911,'humerus.tif',230,2,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45912,'humerus.tif',230,2,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45913,'radius.tif',230,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45914,'radius.tif',230,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45915,'radius.tif',230,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45916,'radius.tif',230,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45917,'radius.tif',230,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45918,'radius.tif',230,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45919,'radius.tif',230,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45920,'radius.tif',230,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45921,'radius.tif',230,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45922,'radius.tif',230,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45923,'radius.tif',230,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45924,'radius.tif',230,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45925,'radius.tif',230,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45926,'radius.tif',230,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45927,'radius.tif',230,3,15,6.4508634,19.6919474,26.6115818,1.8,19.8588737,26.2604528,-0.6379488,1.7753864,4.8764687,1.8689134,14.772644,0.3813305,3.0293733,1.0526798,3.2546386,2.5799141,7.0309757,0.5836358,16.5585887),(45928,'radius.tif',230,3,16,57.7662245,18.8511954,22.4137125,1.8,18.2633488,22.18456,-1.4212597,6.8713785,6.6747964,413.445999,732.2936493,9.414017,109.7102598,60.1692947,157.2315647,11.4021008,13.2923009,1.7975952,40.7587366),(45929,'radius.tif',230,3,17,76.7721308,17.4818121,21.7070727,1.8,17.8297379,21.8589974,-1.5536769,6.2201762,6.7416909,685.8756109,815.7232533,12.7916055,120.9968345,110.2662671,213.7467661,11.6235009,13.6502582,1.9618445,41.8388764),(45930,'radius.tif',230,3,18,60.7294553,17.8486431,21.6263378,1.8,18.1163645,21.8261304,-1.3790852,6.0039694,6.5237615,561.3534619,674.7083708,9.7541111,103.4232119,93.4970563,180.825083,11.4380516,13.154217,1.6888884,40.4613641),(45931,'radius.tif',230,3,19,48.9769899,18.0709173,21.7149861,1.8,18.261387,21.8942885,-1.4604711,5.7659219,6.2368438,476.5281882,529.2862643,8.0638789,84.8644417,82.6456192,152.1266322,11.1807008,12.5945283,1.3940875,38.9875365),(45932,'radius.tif',230,3,20,43.6629681,18.201181,21.7611925,1.8,18.3267096,21.9403394,1.4611774,5.1183789,5.8458966,367.3560813,448.7214588,7.1900665,76.7583642,71.7719594,128.6676373,10.1844008,11.79098,1.7884469,36.4178347),(45933,'radius.tif',230,3,21,41.2786731,18.4526762,21.7708464,1.8,18.5213418,21.9341636,1.4414861,4.8009733,5.5672581,310.5858803,395.1006051,6.765381,70.9686163,64.6922747,118.3410992,9.5005899,11.2528069,1.3019558,34.6846208),(45934,'radius.tif',230,3,22,40.0786659,18.7882831,21.6302567,1.8,18.8741534,21.7545095,-1.5097726,4.7497524,5.6715117,288.2392688,360.8268193,6.6549337,63.6209242,60.6851147,111.3421924,9.3179281,11.0100605,1.3063079,33.4210673),(45935,'radius.tif',230,3,23,39.3715381,19.076506,21.4622218,1.8,19.137702,21.5108975,-1.2817705,4.7614293,5.5747208,281.222071,342.0489538,6.0288613,61.3571451,59.0625318,111.7612703,9.4095007,10.6898614,1.2981865,32.718881),(45936,'radius.tif',230,3,24,38.9603315,19.3189118,21.3013931,1.8,19.423001,21.3364287,-0.7887359,4.548063,5.3174459,287.7712648,343.3049667,3.2683673,64.5620043,63.2733685,115.6246177,9.2366537,10.5832913,1.2953702,32.5780619),(45937,'radius.tif',230,3,25,38.2538619,19.5300651,21.1927369,1.8,19.7986824,21.1994212,-0.4276437,4.6620391,5.7207177,286.1980206,376.1571861,1.0966053,65.7534951,61.3890218,113.2546744,9.1810385,10.9637726,0.2033361,33.5173826),(45938,'radius.tif',230,3,26,38.3855896,19.6165276,21.1328876,1.8,19.9593558,21.0971523,-0.3006635,4.7470219,6.0782348,281.1203237,412.7948659,0.5611156,67.91361,59.220355,111.1814762,9.0127716,11.4294743,2.9859978,34.3492621),(45939,'radius.tif',230,3,27,39.3291181,19.740143,21.0413029,1.8,20.1499246,21.0029187,-0.2531713,4.6605077,6.3814341,275.945004,468.5482717,0.411238,73.4236635,59.209216,114.562345,8.9464475,11.8671235,2.9917802,35.4294018),(45940,'radius.tif',230,3,28,40.6280779,19.7110165,20.9547976,1.8,20.0969844,20.9296595,-0.2423876,4.5695958,6.687362,277.9894768,521.9101212,0.390098,78.0442454,60.8345873,118.3118238,8.9337026,12.2297209,2.9779321,35.9101881),(45941,'radius.tif',230,3,29,42.1553064,19.6506138,20.9092252,1.8,20.1249904,20.8524928,-0.2264669,4.5301828,6.9779346,281.1098854,572.8449767,0.35422,82.0937724,62.0526583,122.2220107,8.9708943,12.6498677,0.1493227,36.666095),(45942,'radius.tif',230,3,30,44.1184747,19.5933198,20.8395342,1.8,20.1326897,20.7511978,-0.2567461,4.5437201,7.1012233,284.1570961,617.7346579,0.4741472,86.9898931,62.538425,126.6013533,8.9778441,12.8645603,0.2700256,37.0820347),(45943,'radius.tif',230,3,31,46.5050983,19.3555547,20.8425512,1.8,19.8444187,20.752071,-0.2974174,4.5350081,7.3744437,283.5471834,626.4360513,0.6656386,84.9468889,62.5240742,123.3499134,9.0137354,13.0010079,0.2759605,37.341421),(45944,'radius.tif',230,3,32,46.9331822,19.0963347,20.8696115,1.8,19.5530719,20.7690068,-0.3444402,4.4839052,7.2416353,275.0969963,563.8479429,0.8918942,77.8619638,61.3520995,115.7498012,8.978309,12.7579058,0.2723403,36.6012485),(45945,'radius.tif',230,3,33,45.5729635,18.6812684,20.7894,1.8,18.784326,20.7707273,-0.4967222,4.4534938,6.084427,247.5518198,463.9020947,1.7249103,76.2441707,55.5859802,114.3024388,8.6162308,11.4920259,0.233297,33.4905223),(45946,'radius.tif',230,3,34,43.0839138,18.1536929,20.8321391,1.8,18.1991723,20.8060678,-0.6609898,4.345723,5.5573839,229.0290292,383.1536723,2.7061818,68.9449715,52.7021696,107.717806,8.3740867,10.5653285,0.6141594,31.822155),(45947,'radius.tif',230,3,35,40.4805834,17.7243903,20.9242091,1.8,17.7992401,20.9201267,-0.8097078,4.3275531,5.3064704,213.1181038,335.8211483,3.5373286,63.2852205,49.2467913,99.8725576,8.2716041,10.1850024,0.6543702,31.0662481),(45948,'radius.tif',230,3,36,39.3234781,17.4152936,20.995766,1.8,17.4944914,20.9869682,-0.9243898,4.2787622,5.1537673,202.6130754,309.1318814,4.1762085,59.9817309,47.3531985,96.1104092,8.2026206,9.9863434,0.942815,30.5048808),(45949,'radius.tif',230,3,37,38.8191726,17.1715831,21.0390442,1.8,17.2481129,20.9949237,-1.017173,4.2857844,4.9459363,195.5938743,289.0874218,4.6813529,58.4494835,45.6378242,94.4842286,8.1532171,9.767982,1.1629284,30.0083601),(45950,'radius.tif',230,3,38,38.4640414,16.9500573,21.0859864,1.8,17.0464467,21.0396303,-1.0915669,4.2473303,4.8062071,189.7223929,273.8869956,5.0477063,56.9860992,44.6686228,93.24658,8.0982258,9.6410746,1.3035372,29.4738532),(45951,'radius.tif',230,3,39,38.9513207,16.7551163,21.1468724,1.8,16.8226218,21.1277471,-1.1339362,4.2502319,4.6810015,190.1660042,262.5830964,5.3297696,56.0954953,44.7425006,93.6104408,8.0834671,9.4873201,1.3711124,29.3441601),(45952,'radius.tif',230,3,40,39.982348,16.5991297,21.1805346,1.8,16.6434773,21.1477502,-1.1450831,4.3157121,4.5797858,193.3081307,254.2236102,5.5272626,55.5099344,44.7917109,94.0929088,8.1262478,9.3788455,1.3687712,28.9393463),(45953,'radius.tif',230,3,41,40.9978534,16.4652562,21.2238469,1.8,16.5088443,21.2037649,-1.1701146,4.3493436,4.5846226,195.0209046,246.305826,5.7934338,53.7243406,44.8391584,93.7148739,8.1925651,9.2485865,1.3780956,28.7179463),(45954,'radius.tif',230,3,42,41.8632805,16.2761242,21.2754471,1.8,16.3448802,21.239105,-1.2694403,4.2749357,4.5778826,193.5477545,236.8928653,6.3625252,51.747257,45.2750094,92.3503653,8.1822149,9.1399601,1.3757761,28.4965462),(45955,'radius.tif',230,3,43,41.6411415,16.0958266,21.3129953,1.8,16.1254944,21.2955794,-1.3376251,4.2665441,4.5791299,195.6934032,228.1073474,6.5696493,49.8145615,45.8669594,91.1678946,8.2361906,9.0645666,1.423718,28.3399928),(45956,'radius.tif',230,3,44,42.0222186,15.9185227,21.349907,1.8,15.9484945,21.3213835,-1.4769166,4.1995405,4.5732625,197.1927516,220.8414772,6.9421578,48.2897006,46.9557918,90.4220813,8.2961703,8.92492,1.4464413,28.1185928),(45957,'radius.tif',230,3,45,41.1800776,15.740391,21.3942091,1.8,15.7919061,21.3814357,1.4798513,4.3917901,4.6395075,196.4307505,215.0201774,6.8067359,46.3454746,44.7268077,88.6841816,8.3190059,8.8898379,1.4835186,28.2102997),(45958,'radius.tif',230,3,46,40.9850158,15.5532519,21.4244659,1.8,15.6013995,21.409759,1.1538622,4.458928,4.5099693,196.0573532,211.7962124,5.7106341,46.961786,43.9696161,88.0844954,8.2190563,8.801869,1.4573613,27.9888996),(45959,'radius.tif',230,3,47,41.1701941,15.3750883,21.460781,1.8,15.4170796,21.4497901,0.7787138,4.2278741,4.3725271,196.1742119,215.3523688,3.3849847,49.2512368,46.4002018,89.3907048,8.1407796,8.8150855,3.01568,28.0806065),(45960,'radius.tif',230,3,48,41.7391911,15.2250761,21.5176494,1.8,15.2550011,21.5197768,0.5046435,4.1562205,4.6207785,194.2327263,224.7995093,1.6262131,48.6497042,46.7330177,90.4044991,8.1407796,9.0103279,2.9562447,28.1454531),(45961,'radius.tif',230,3,49,42.0265995,15.0929652,21.5751854,1.8,15.1041973,21.5859965,0.3757202,4.2030072,4.8000251,191.2584879,238.7264837,0.943125,49.7344236,45.5051537,89.5797285,8.1407796,9.283633,2.9980093,28.45856),(45962,'radius.tif',230,3,50,41.9087949,14.9729061,21.6482912,1.8,14.9888674,21.6591426,0.3064675,4.2381325,4.9794463,187.5205698,252.7449509,0.6357454,50.7576421,44.2460372,88.3217551,8.0625028,9.6417102,2.9216784,28.6419738),(45963,'radius.tif',230,3,51,41.9133081,14.8596201,21.7169015,1.8,14.8406683,21.7129056,0.2419707,4.231639,5.0769962,184.5996432,264.9909104,0.4010824,52.1944278,43.623675,87.9820794,8.1269181,9.9433013,2.9398303,28.9550807),(45964,'radius.tif',230,3,52,42.0377581,14.7738724,21.8004929,1.8,14.7488174,21.7977765,0.1763126,4.1964189,5.2053767,180.5440171,276.0035331,0.2155511,53.0227784,43.0233543,87.2611354,8.089404,10.2060365,2.9229237,29.1116341),(45965,'radius.tif',230,3,53,41.8483552,14.6886005,21.8826178,1.8,14.6134915,21.8734545,0.1214953,4.137494,5.300354,176.6977325,280.1132478,0.1024492,52.8480259,42.7064621,85.2979695,8.013693,10.422275,2.927532,29.203341),(45966,'radius.tif',230,3,54,41.8916982,14.6084064,21.9734373,1.8,14.5212439,21.9560159,0.0724676,3.9914485,5.3717766,172.833818,285.9086099,0.036602,53.2242178,43.3010271,84.7537301,7.9125578,10.5554649,2.9729957,29.424741),(45967,'radius.tif',230,3,55,42.2781018,14.5397224,22.0614029,1.8,14.4433646,22.0558251,0.0260508,3.9360042,5.4814891,168.4052925,290.6351628,0.0047809,53.0212065,42.7858518,83.1352097,7.8423066,10.7241972,3.0069947,29.5164479),(45968,'radius.tif',230,3,56,42.3412828,14.4534697,22.1280802,1.8,14.3699153,22.1326718,-0.0042438,3.8623394,5.4863004,163.6140586,294.0570537,0.0001271,53.5984237,42.3613878,82.6186145,7.7490006,10.7241972,3.0069947,29.424741),(45969,'radius.tif',230,3,57,42.1956496,14.4149213,22.2111671,1.8,14.3061285,22.2043145,-0.037486,3.9230466,5.5564971,158.959461,296.566481,0.0098776,53.3729214,40.5193913,81.7302588,7.6658266,10.8627115,3.0906164,29.6081548),(45970,'radius.tif',230,3,58,42.5716236,14.3786184,22.2662669,1.8,14.2735008,22.2565665,-0.0511244,3.8730361,5.6364761,155.5657964,307.4833237,0.0185288,54.5524047,40.1663686,82.1256685,7.6183338,11.0788533,3.101614,29.7647083),(45971,'radius.tif',230,3,59,42.8831502,14.3537119,22.3170558,1.8,14.2591815,22.3032975,-0.059475,3.8211658,5.6208709,152.8612884,314.7049585,0.0252518,55.9886475,40.0038352,83.1815823,7.5276006,11.2004122,0.0593362,29.8295548),(45972,'radius.tif',230,3,60,43.1792694,14.3486162,22.3539678,1.8,14.286877,22.3374055,-0.0561128,3.8399776,5.6259555,150.3707206,319.6841594,0.0226356,56.8230872,39.15927,83.4714917,7.4905769,11.2250027,0.0888742,29.8944014),(45973,'radius.tif',230,3,61,42.7856035,14.342757,22.3872755,1.8,14.305673,22.3778667,-0.0438827,3.7887657,5.5887171,147.2019534,325.3537426,0.0137232,58.2161771,38.8522189,84.5111693,7.4169005,11.2250027,0.0888742,29.8026945),(45974,'radius.tif',230,3,62,42.8135546,14.3196663,22.4041056,1.8,14.3020721,22.3902912,-0.0280092,3.7999132,5.7159888,144.7811209,331.8778951,0.0055965,58.0613275,38.1011648,83.3345124,7.3818894,11.3179593,0.06852,30.0240945),(45975,'radius.tif',230,3,63,42.948407,14.3115454,22.4179777,1.8,14.3025539,22.4016772,-0.0046358,3.7113209,5.7248437,143.575417,336.8047516,0.0001538,58.8321308,38.6858002,83.809915,7.1955005,11.3049589,0.0489804,30.0352204),(45976,'radius.tif',230,3,64,42.7929983,14.2843305,22.4192204,1.8,14.283283,22.4108661,0.0220986,3.731939,5.7570272,142.5121226,338.7074682,0.0034824,58.8337442,38.1871522,83.5609332,7.1955005,11.1943929,3.0921281,29.9435136),(45977,'radius.tif',230,3,65,42.8489083,14.2752387,22.4092849,1.8,14.2864641,22.3987437,0.0506876,3.7301389,5.6971663,140.7354621,341.771669,0.0183324,59.9897653,37.7292818,83.926535,7.1955005,11.1807008,2.9422553,29.8518067),(45978,'radius.tif',230,3,66,42.6227388,14.2755212,22.3954485,1.8,14.2971106,22.3976068,0.0802748,3.7200412,5.7271996,138.5346487,343.8242222,0.0456789,60.0335671,37.2400848,83.5524858,7.1955005,11.2108014,2.9829374,29.9435136),(45979,'radius.tif',230,3,67,42.3122903,14.2844501,22.3758741,1.8,14.3144965,22.3826633,0.1121363,3.656461,5.7407615,135.9230003,344.4248676,0.0883052,59.9963734,37.1733762,83.2717622,7.1955005,11.2767398,2.9037567,29.7869601),(45980,'radius.tif',230,3,68,41.8339247,14.2623388,22.3414085,1.8,14.2986697,22.3447695,0.1437421,3.645784,5.7825493,134.1592907,340.806202,0.1430712,58.9370167,36.7984748,81.9284097,7.1955005,11.3590292,2.9155243,29.7489739),(45981,'radius.tif',230,3,69,41.8820715,14.3264424,22.3144487,1.8,14.3726049,22.3172833,0.169542,3.6213715,5.8417724,132.941858,345.1058653,0.1987314,59.0755413,36.7103617,81.7367805,7.1955005,11.5064125,2.9479707,29.9055273),(45982,'radius.tif',230,3,70,41.3107753,14.3463646,22.2806573,1.8,14.3977658,22.2852646,0.1942771,3.5778827,5.8553329,131.4905295,339.9422268,0.2566165,58.0568569,36.7509338,80.4188119,7.1932418,11.4920259,2.9082957,29.8138204),(45983,'radius.tif',230,3,71,40.9753923,14.3674857,22.2467442,1.8,14.4059266,22.255695,0.2181215,3.5887139,5.9312815,130.3474723,339.5302751,0.3197942,57.2439997,36.3215004,79.2174558,7.0848005,11.5749021,2.9198117,29.7489739),(45984,'radius.tif',230,3,72,40.6729392,14.4064429,22.2093358,1.8,14.4541439,22.2079995,0.2407662,3.587738,6.0094871,130.2826964,341.8452978,0.3854227,56.8842715,36.3133252,78.5591721,7.1955005,11.6524576,2.8920057,29.9055273),(45985,'radius.tif',230,3,73,40.6020971,14.4399225,22.1837842,1.8,14.5030089,22.1916871,0.261161,3.6212782,6.0595271,130.7876427,342.7215212,0.4511467,56.5591203,36.1164305,78.0537135,7.1955005,11.7331565,2.9034789,30.1269273),(45986,'radius.tif',230,3,74,40.4394937,14.4819549,22.1586274,1.8,14.5087244,22.1669702,0.2783517,3.5956377,6.0505652,131.3682832,345.6763718,0.5088584,57.1312533,36.5354615,78.7748403,7.2107342,11.7091099,2.8736822,30.1269273),(45987,'radius.tif',230,3,75,40.1892634,14.5136039,22.1222746,1.8,14.5511669,22.1317388,0.2945311,3.6030891,6.0259673,132.0020829,343.5028005,0.5644513,57.0037608,36.6358087,78.8080131,7.2120325,11.6324588,2.8619858,30.0352204),(45988,'radius.tif',230,3,76,40.1605101,14.5462439,22.0873894,1.8,14.5961475,22.1017289,0.3089889,3.6066204,5.9623026,132.6639164,341.8826379,0.6189679,57.3407054,36.7834433,79.5788237,7.2284011,11.5175898,2.8289604,29.878667),(45989,'radius.tif',230,3,77,39.6388831,14.5818854,22.0466019,1.8,14.6103694,22.0493083,0.3210247,3.6148243,5.9047267,133.0335039,338.834068,0.6577737,57.3835311,36.8022048,79.8520192,7.2286821,11.4123065,2.825977,30.100067),(45990,'radius.tif',230,3,78,39.1818086,14.632557,21.9981811,1.8,14.6764101,21.9831483,0.3353401,3.6044421,5.8007853,133.4284024,334.5928041,0.7072345,57.6806043,37.017768,80.6670952,7.2284011,11.2462709,2.7793658,29.7332395),(45991,'radius.tif',230,3,79,38.9684473,14.698817,21.960393,1.8,14.7402972,21.9457534,0.3534313,3.6206716,5.8908805,134.0890397,332.6025377,0.7780595,56.4605809,37.0343007,79.2126477,7.2286821,11.2859731,2.7701935,29.798086),(45992,'radius.tif',230,3,80,38.5605897,14.791082,21.9274158,1.8,14.8265031,21.9108458,0.3690604,3.6396521,5.877849,134.488921,328.4835918,0.8363328,55.8850005,36.9510369,78.6856253,7.2289632,11.2658676,2.7483132,29.8897929),(45993,'radius.tif',230,3,81,38.2166802,14.8716059,21.8815173,1.8,14.8945415,21.859176,0.3915589,3.6431421,5.8557299,135.2255199,325.3165694,0.9276546,55.5552557,37.1178272,78.5917401,7.2780762,11.2069749,2.7354039,29.8629326),(45994,'radius.tif',230,3,82,38.4939904,14.9759191,21.8423348,1.8,15.0110398,21.8128178,0.4140526,3.6372822,5.7695247,136.5216121,324.134307,1.0384628,56.1804172,37.5339617,79.7519964,7.2292442,11.1499695,2.7223603,29.7063791),(45995,'radius.tif',230,3,83,38.1531793,15.083112,21.8126817,1.8,15.0831361,21.7836065,0.4356692,3.6393981,5.7311953,137.2265187,322.5985079,1.1325039,56.2881725,37.7058282,79.9575418,7.2786383,11.1417235,2.7001636,29.7712257),(45996,'radius.tif',230,3,84,38.1797823,15.1721492,21.7713115,1.8,15.1558892,21.7222599,0.4569939,3.654102,5.7069596,138.1095036,319.6956196,1.2389579,56.0185532,37.7957438,80.000758,7.2993893,11.0904614,2.664553,29.7712257),(45997,'radius.tif',230,3,85,37.8135141,15.2826264,21.7363817,1.8,15.2455656,21.6802468,0.4753417,3.6328919,5.5711487,139.0372763,315.1453941,1.3199214,56.5673998,38.2717906,81.4518189,7.2789194,10.9732692,2.6011732,29.6795188),(45998,'radius.tif',230,3,86,37.3923669,15.3804321,21.6980259,1.8,15.3459543,21.65076,0.4894571,3.6493643,5.5472842,140.4820653,309.6579978,1.3775223,55.8215494,38.4949413,81.095144,7.3198933,10.9167272,2.6098686,29.274705),(45999,'radius.tif',230,3,87,37.0734512,15.5025761,21.6642538,1.8,15.4931125,21.6301998,0.5047293,3.6643461,5.4530537,142.1014807,305.8736456,1.4448787,56.0921756,38.7794918,82.1000449,7.3779886,10.8214566,2.6046819,29.4312585),(46000,'radius.tif',230,3,88,36.9708552,15.614295,21.6202109,1.8,15.5994486,21.5817552,0.5182901,3.6666553,5.3747126,144.0560189,302.562182,1.5122108,56.2936483,39.2881274,83.053224,7.3808262,10.7264824,2.5994032,29.274705),(46001,'radius.tif',230,3,89,36.8243516,15.7354381,21.5702163,1.8,15.7132645,21.5273798,0.5357143,3.6838223,5.3100557,145.1999697,300.4128946,1.599188,56.5743395,39.4155742,83.907887,7.4017842,10.6554149,2.5708794,29.3015653),(46002,'radius.tif',230,3,90,36.8117698,15.845923,21.5247159,1.8,15.8251392,21.4892404,0.5497743,3.7083746,5.3133927,146.1978117,299.4949641,1.6749404,56.3660512,39.4236903,83.8231729,7.4282258,10.6318123,2.5940304,29.3932722),(46003,'radius.tif',230,3,91,36.7033259,15.9643443,21.4699721,1.8,15.9383689,21.4256128,0.5616643,3.7263547,5.2985562,146.6247117,300.6330485,1.7351989,56.7386737,39.3480291,84.4062841,7.4431953,10.5960207,2.5796711,29.3015653),(46004,'radius.tif',230,3,92,37.0503973,16.0502723,21.4015709,1.8,15.9845153,21.3392312,0.5724967,3.7403684,5.3224206,148.4885211,304.5315619,1.8122207,57.2167416,39.6989022,85.1052719,7.4394883,10.6295068,2.5189219,29.3664119),(46005,'radius.tif',230,3,93,37.1615006,16.1433554,21.3326822,1.8,16.0774874,21.2606107,0.5831225,3.7602669,5.3461281,150.3554403,309.1363744,1.8778748,57.8243484,39.985311,85.9025134,7.4571342,10.6944459,2.5105133,29.4312585),(46006,'radius.tif',230,3,94,36.9597909,16.2527076,21.274452,1.8,16.1992282,21.2194853,0.5919451,3.7511541,5.3479122,152.2952311,311.3303951,1.9178278,58.2153159,40.5995672,86.692322,7.4639641,10.6944459,2.5105133,29.7712257),(46007,'radius.tif',230,3,95,37.2074405,16.3570775,21.2038551,1.8,16.3271801,21.1793664,0.6040863,3.778688,5.3361464,155.6202478,316.6394269,2.0007415,59.3385943,41.1836722,88.3810369,7.4951758,10.7190538,2.4733032,29.8360723),(46008,'radius.tif',230,3,96,37.2423545,16.4745223,21.115138,1.8,16.44524,21.0768923,0.6140398,3.8046817,5.3471788,159.204337,321.6285106,2.0605975,60.1491965,41.844325,89.91746,7.5263875,10.7384714,2.4877826,29.8360723),(46009,'radius.tif',230,3,97,37.1470147,16.6063677,21.0396648,1.8,16.5940336,21.0041347,0.6300486,3.8211253,5.3505786,162.6331241,325.9499337,2.1491889,60.9186328,42.5615784,91.2501286,7.5637021,10.7879984,2.4652491,30.0843326),(46010,'radius.tif',230,3,98,37.0512958,16.7199057,20.9630117,1.8,16.6844811,20.9309673,0.6435675,3.8444935,5.3522273,165.8264725,331.0555613,2.2234714,61.8537937,43.1335035,92.8320247,7.6320769,10.8061581,2.479651,30.1491792),(46011,'radius.tif',230,3,99,36.9980712,16.823147,20.8633324,1.8,16.7785683,20.8212601,0.6595727,3.8793134,5.4176765,169.2868929,336.073833,2.3154525,62.0328348,43.6383649,93.2734676,7.683759,10.8745504,2.4716212,30.3057326),(46012,'radius.tif',230,3,100,37.427332,16.9561854,20.7842393,1.8,16.912007,20.7168757,0.6737518,3.8885755,5.4655577,173.1789152,343.8812892,2.42828,62.9178773,44.5353094,94.526388,7.7079182,10.9436351,2.4636922,30.3705792),(46013,'radius.tif',230,3,101,37.2640816,17.1006911,20.7219547,1.8,17.0659076,20.6935291,0.6908037,3.9138114,5.474631,177.3903248,347.1378036,2.5213423,63.4084385,45.3241886,95.7154693,7.7772268,10.9989246,2.4416998,30.6836861),(46014,'radius.tif',230,3,102,36.8779877,17.2349747,20.6505301,1.8,17.2319218,20.6473615,0.717851,3.9309054,5.4952402,181.5443653,351.7335678,2.65926,64.00695,46.1838546,96.8765014,7.8380933,11.0300768,2.4699865,30.8670999),(46015,'radius.tif',230,3,103,37.0117555,17.3486032,20.5455479,1.8,17.3655262,20.5474003,0.7377151,3.9363049,5.5561862,187.2303125,359.9375566,2.7906194,64.7814066,47.5649919,98.2816301,7.8877195,11.0838297,2.4481331,30.9319464),(46016,'radius.tif',230,3,104,37.433574,17.4523839,20.4689564,1.8,17.4310046,20.4622011,0.7474873,3.9680315,5.6096192,192.4540351,369.3315226,2.883168,65.8389651,48.5011363,99.9467252,7.9814901,11.1549142,2.4405012,31.0616395),(46017,'radius.tif',230,3,105,37.2899534,17.5976909,20.3838471,1.8,17.6230522,20.40121,0.7683621,3.9848735,5.6325804,198.3441071,374.2143611,3.0016374,66.4374651,49.7742543,101.5662648,8.0571765,11.2069749,2.3072825,31.3747465),(46018,'radius.tif',230,3,106,37.9230108,17.7435868,20.3167469,1.8,17.7575132,20.301969,0.7916431,3.9965946,5.6526127,205.1401044,380.1133454,3.199721,67.2456025,51.328725,103.3533371,8.1149496,11.2266401,2.2794226,31.5312999),(46019,'radius.tif',230,3,107,37.9569557,17.9126043,20.258461,1.8,17.9350264,20.2474546,0.809416,4.1082567,5.659666,211.2289718,385.6469805,3.3149621,68.1395297,51.4157194,105.2943512,8.2422916,11.2397311,2.2655346,31.660993),(46020,'radius.tif',230,3,108,38.2346012,18.0938134,20.2186569,1.8,18.1215333,20.1971792,0.8298693,4.1367425,5.6398215,216.5781378,388.1733284,3.4692324,68.8272364,52.3547538,107.2022719,8.3327504,11.28923,2.300696,31.9472396),(46021,'radius.tif',230,3,109,38.2861446,18.2774955,20.1863963,1.8,18.3302777,20.2234227,0.8401445,4.1584804,5.5593912,221.6294243,392.4241758,3.5391521,70.5876172,53.2957721,109.9387424,8.3775526,11.2723922,2.2378687,31.9740999),(46022,'radius.tif',230,3,110,38.2841069,18.4361216,20.164452,1.8,18.4903781,20.2108176,0.8580021,4.2227974,5.5624453,226.033584,395.0880002,3.6519787,71.0277547,53.5269783,111.5963154,8.4510193,11.2723922,2.2378687,32.3789137),(46023,'radius.tif',230,3,111,37.9987801,18.6000875,20.1035379,1.8,18.6593868,20.1410638,0.8809548,4.2823853,5.5672577,230.8604783,394.8688645,3.7680603,70.9269954,53.9093193,112.358412,8.5206582,11.2479053,2.202487,32.3789137),(46024,'radius.tif',230,3,112,38.3842877,18.7524932,20.0700863,1.8,18.7984086,20.1259643,0.9069219,4.3523382,5.6176298,236.2494788,397.5237841,3.9684927,70.7636138,54.281048,112.6586662,8.5883852,11.2919435,2.224101,32.7568672),(46025,'radius.tif',230,3,113,38.4937718,18.8845594,19.9903666,1.8,18.9418351,20.0548477,0.9358311,4.4226861,5.5833047,240.2177952,399.250171,4.1584416,71.5078598,54.3149101,114.3759382,8.6408839,11.3006221,2.1397795,32.9134207),(46026,'radius.tif',230,3,114,38.326647,19.0192828,19.8957721,1.8,19.0740736,19.9574728,0.9590019,4.4878363,5.5866407,243.5850622,396.7623542,4.2806814,71.019845,54.2767267,114.3599545,8.6968696,11.3006221,2.1397795,32.8217138),(46027,'radius.tif',230,3,115,37.7300448,19.1579429,19.7997941,1.8,19.2172291,19.8702159,0.9834256,4.5612407,5.5972518,245.6999489,387.4508448,4.3571335,69.2216211,53.8669116,112.8160547,8.7457808,11.2680428,2.1533494,33.0051275),(46028,'radius.tif',230,3,116,37.6207155,19.3120451,19.6933978,1.8,19.3682437,19.7508721,1.0138413,4.6234181,5.5805323,248.6302742,383.8799942,4.5181099,68.7891352,53.7762902,113.2050612,8.818949,11.1828927,2.1230998,32.9782672),(46029,'radius.tif',230,3,117,37.8786563,19.4806407,19.6216451,1.8,19.5476547,19.6807195,1.0471463,4.7067293,5.6197507,252.3398296,384.6415925,4.7345518,68.4446004,53.6125648,113.1432681,8.8701391,11.1828927,2.1230998,33.161681),(46030,'radius.tif',230,3,118,38.0039883,19.6802064,19.5421729,1.8,19.7537546,19.6145857,1.0555803,4.696118,5.6046033,255.923267,382.0949642,4.7962567,68.1752021,54.4967712,113.7317803,8.9366679,11.1828927,2.1230998,33.383081),(46031,'radius.tif',230,3,119,37.6914426,19.8384079,19.471107,1.8,19.9432653,19.5672133,1.0916146,4.80652,5.594413,257.6994259,372.2653618,4.9465619,66.5423453,53.6145535,112.5095727,9.0106792,11.1477711,2.1367639,33.2913741),(46032,'radius.tif',230,3,120,37.0103413,19.999464,19.3902809,1.8,20.0857849,19.4739008,1.1174632,4.8589722,5.4993446,256.3696608,361.1269298,4.985214,65.6672666,52.7621174,112.1208957,9.0610416,11.0306323,2.1198215,33.2265276),(46033,'radius.tif',230,3,121,36.2826718,20.162166,19.3058248,1.8,20.2483627,19.3841996,1.1375178,4.9520749,5.5050419,254.4961078,348.9864676,4.98117,63.393971,51.3918131,109.5960551,9.1442496,10.9732692,2.1112158,33.1996672),(46034,'radius.tif',230,3,122,35.5413548,20.3408148,19.2263856,1.8,20.4131518,19.3045113,1.1705152,5.0192788,5.4665252,251.8960324,339.9312539,5.0240764,62.1841552,50.1857022,108.1603902,9.1598298,10.9026864,2.0798672,33.3182345),(46035,'radius.tif',230,3,123,34.5627189,20.5273057,19.1109019,1.8,20.603646,19.1745769,1.2155621,5.1155576,5.4498756,250.4831099,326.9925561,5.063601,60.0000037,48.9649675,105.8811766,9.2092239,10.8214566,2.1077071,33.3182345),(46036,'radius.tif',230,3,124,33.5427249,20.7012348,19.0076643,1.8,20.8042517,19.0948327,1.2650056,5.2235547,5.4314757,247.3144205,313.5152122,5.0837942,57.7219212,47.346,102.7221907,9.2326585,10.7007463,1.9974238,33.0857085),(46037,'radius.tif',230,3,125,32.6855427,20.8988337,18.873476,1.8,21.0135816,18.9747288,1.2864505,5.2753515,5.4402775,244.9825944,307.0825706,5.0188823,56.4461224,46.4391033,101.0035671,9.2326585,10.7241972,1.4361984,33.1774154),(46038,'radius.tif',230,3,126,31.6867494,21.1113307,18.7307246,1.8,21.2460913,18.8378855,1.3395868,5.3673422,5.5001424,243.3316457,300.6043354,5.0038024,54.6539182,45.3355936,98.1192293,9.2580441,10.8197579,1.4477104,33.3988154),(46039,'radius.tif',230,3,127,30.8062863,21.3032825,18.6007377,1.8,21.499055,18.7296786,1.3471259,5.4335433,5.5551031,240.8940466,295.5477168,4.8817709,53.2029224,44.3346146,95.8299128,9.2339154,10.9015623,1.3973006,33.5173826),(46040,'radius.tif',230,3,128,29.8993574,21.521456,18.4520473,1.8,21.7094745,18.563828,1.3948345,5.5074722,5.6429827,238.2235776,291.5254136,4.8305187,51.661582,43.2546125,92.7421172,9.2451158,11.0683402,1.4303137,33.8953361),(46041,'radius.tif',230,3,129,29.0122594,21.6955715,18.3685324,1.8,21.9012936,18.4155839,1.411975,5.5575348,5.6525069,230.967976,290.0836529,4.7144301,51.3194694,41.5594292,91.0601235,9.258899,11.1807008,1.371459,33.987043),(46042,'radius.tif',230,3,130,28.5806982,21.8370518,18.2637407,1.8,22.0202472,18.3305834,1.4042463,5.5568917,5.7103543,225.1655764,295.9303596,4.6325339,51.8234676,40.5200585,90.1944912,9.257779,11.2729357,1.4427873,34.3381361),(46043,'radius.tif',230,3,131,27.4742246,22.0705062,18.1441949,1.8,22.2489282,18.222909,1.4236727,5.5423947,5.7311204,217.64204,288.8005042,4.4806356,50.3916312,39.2685927,86.9509091,9.2915065,11.376816,1.3848506,34.429843),(46044,'radius.tif',230,3,132,26.8359384,22.3178394,17.9655435,1.8,22.4511523,18.1091606,1.4355127,5.5020664,5.8024505,214.5622015,288.3143996,4.3912975,49.6883859,38.9966576,84.7867695,9.2089428,11.5282247,1.3677511,34.8457827),(46045,'radius.tif',230,3,133,26.3689824,22.6307799,17.8532913,1.8,22.7013472,17.9478791,1.432488,5.4874371,5.8504707,211.0954642,288.3951177,4.3112956,49.2943442,38.4688628,83.3915808,9.2089428,11.5388497,1.4166882,35.2774569),(46046,'radius.tif',230,3,134,27.9243135,22.9241308,17.8608412,1.8,23.0274252,17.8543091,1.4031585,5.4899383,5.8011204,224.4303117,311.5463685,4.5244826,53.7045168,40.8802978,90.3096735,9.3576872,11.6592915,1.3603661,35.84995),(46047,'radius.tif',230,3,135,29.9638465,23.3384803,17.7643155,1.8,23.4449082,17.7090245,1.2775208,5.5063734,5.7072842,255.3485012,328.8414073,4.5766145,57.6178432,46.3732628,95.892144,9.9450116,12.0941975,2.7270858,38.0908105),(46048,'radius.tif',230,3,136,33.446466,23.8294924,17.8429639,1.8,23.9171783,17.7210648,1.1676216,5.2775838,6.133667,289.6799763,375.8779231,4.7163359,61.28111,54.8887502,102.6527623,10.0832839,12.6459922,2.7367009,38.5604709),(46049,'radius.tif',230,3,137,33.3478574,23.740454,17.8069978,1.8,23.8163256,17.5953736,1.3368729,5.6493482,6.0781465,244.5749116,372.0892142,5.2593499,61.2175459,43.2925896,98.6050549,10.068657,12.1800196,1.707552,40.412252),(46050,'radius.tif',230,3,138,29.8819205,22.9766721,17.7791765,1.8,23.1022016,17.584985,1.3671701,4.6820033,6.313282,130.0820125,329.0162727,4.7766563,52.1149333,27.7834088,71.1206369,7.8985185,12.4403367,2.0822163,37.643402),(46051,'radius.tif',230,3,139,18.500343,22.4433018,17.6166093,1.8,22.4405601,17.2011771,1.5080371,2.7860205,5.944789,31.7629455,201.6709405,3.0712618,33.9239865,11.4008296,38.504784,5.5350004,11.6871111,1.4664152,45.7749645),(46052,'radius.tif',230,3,140,2.6488272,22.5081858,14.5863916,1.8,22.5124661,14.6522821,1.2170836,1.2123333,2.165528,0.7084774,1.9410402,0.3885029,0.8963358,0.5843916,1.1787882,2.4354002,3.8042811,1.7168086,10.3501712),(46053,'radius.tif',230,3,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46054,'radius.tif',230,3,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46055,'radius.tif',230,3,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46056,'radius.tif',230,3,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46057,'radius.tif',230,3,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46058,'radius.tif',230,3,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46059,'radius.tif',230,3,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46060,'radius.tif',230,3,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46061,'radius.tif',230,3,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46062,'radius.tif',230,3,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46063,'radius.tif',230,3,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46064,'radius.tif',230,3,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46065,'ulna.tif',230,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46066,'ulna.tif',230,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46067,'ulna.tif',230,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46068,'ulna.tif',230,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46069,'ulna.tif',230,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46070,'ulna.tif',230,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46071,'ulna.tif',230,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46072,'ulna.tif',230,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46073,'ulna.tif',230,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46074,'ulna.tif',230,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46075,'ulna.tif',230,4,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46076,'ulna.tif',230,4,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46077,'ulna.tif',230,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46078,'ulna.tif',230,4,14,2.1743422,27.6834888,26.8404794,1.8,27.6845451,26.8994658,-0.8855246,1.0592222,1.601763,0.4012283,0.8630853,0.217238,0.5388345,0.3787952,0.7416546,2.1604258,3.0235494,1.1562895,8.1741573),(46079,'ulna.tif',230,4,15,30.5301805,28.5164877,26.7096151,1.8,28.6733384,26.6123066,0.285506,3.3649766,4.6701126,69.0374292,151.1629957,0.403623,32.3681697,20.5164663,46.5612598,6.3158132,9.4582128,2.8568622,26.3047979),(46080,'ulna.tif',230,4,16,46.3102882,28.0315409,26.4475391,1.8,28.4396344,26.3903284,0.1919828,4.3654804,6.1204367,209.7312146,361.2008108,0.2810016,59.0155289,48.0431006,93.1809919,8.3025006,11.2200889,2.6028652,33.5239001),(46081,'ulna.tif',230,4,17,45.4049226,27.5766961,26.3017257,1.8,28.1049589,26.2666472,0.1812629,4.7501905,6.7195374,256.4282314,430.1955926,0.2459281,64.0216083,53.9827254,100.8305526,9.3908117,12.0393575,2.5790947,35.8296071),(46082,'ulna.tif',230,4,18,44.1057485,27.5129424,25.8215351,1.8,27.8454229,25.8746685,0.0677476,4.3297845,6.7510201,232.6575882,475.0937107,0.0336874,70.3736179,53.7342195,102.8278852,8.7294753,12.1275888,0.1005769,36.4289606),(46083,'ulna.tif',230,4,19,43.2324364,27.2976343,25.5963559,1.8,27.4751435,25.6363262,0.035294,4.1794355,6.6223836,200.9351104,516.600194,0.0089718,78.008195,48.0770931,105.8851074,8.0811006,12.3592977,0.1076899,36.2186865),(46084,'ulna.tif',230,4,20,42.506119,27.0319717,25.3688661,1.8,27.1833253,25.3708055,0.0157132,3.9751075,6.6423337,166.8366199,537.7341225,0.001749,80.9556016,41.9703415,102.6578341,7.7463452,12.6047406,0.1232657,36.3752399),(46085,'ulna.tif',230,4,21,41.7502597,26.8796536,25.139084,1.8,26.9783275,25.0979026,0.0122878,3.9654071,6.5837746,149.0028302,598.2161816,0.0010506,90.8621909,37.5756702,105.7467747,7.6383006,13.04993,0.1790948,37.7193745),(46086,'ulna.tif',230,4,22,43.1394235,26.8609499,24.8723949,1.8,26.949277,24.8370415,0.0379974,3.8351863,6.8934163,146.9730419,687.9167198,0.0103758,99.793294,38.3222694,113.6310803,7.5925557,13.5276135,3.0842784,39.5980159),(46087,'ulna.tif',230,4,23,45.9221774,27.0016325,24.6771728,1.8,27.0989777,24.6471349,0.0651192,3.8073885,6.9642272,158.0191456,834.969789,0.0324097,119.8941058,41.5032887,131.6979961,7.514664,14.0501818,2.9673769,41.1746763),(46088,'ulna.tif',230,4,24,50.8058307,27.3881279,24.5183852,1.8,27.3921823,24.5133149,0.0635368,4.0872105,7.8974294,186.7888466,1077.3762535,0.0341372,136.4211316,45.7008138,151.7398693,7.9459738,15.2822153,0.1234565,43.9389178),(46089,'ulna.tif',230,4,25,60.911148,27.977499,24.116939,1.8,28.1048068,24.1818368,0.0750149,5.4574789,8.8801405,310.3094445,1389.627428,0.0570198,156.4870994,56.8594864,180.777591,10.2713761,16.9808184,3.0698207,50.8383957),(46090,'ulna.tif',230,4,26,78.5461429,28.8572166,22.6385611,1.8,28.9294336,22.7710546,-0.1701466,8.3941718,10.7580812,915.7540308,1770.7136391,0.3753403,164.5938158,109.0940303,245.4009347,14.579371,18.9746402,0.594475,61.6582272),(46091,'ulna.tif',230,4,27,79.829919,28.6679576,22.511976,1.8,28.6454395,22.4308912,-0.1625782,7.6531097,10.9056146,820.1085941,1869.7883702,0.3485856,171.4519021,107.1601776,244.2413174,13.5766788,19.0857216,0.515549,58.408591),(46092,'ulna.tif',230,4,28,77.3114783,27.9715452,22.3263924,1.8,27.9447654,22.2196182,-0.1862178,7.7474449,10.4859426,632.5347359,1858.7649838,0.4416814,177.2625562,81.6443021,235.3771876,12.6673056,19.0197949,0.4324078,56.686503),(46093,'ulna.tif',230,4,29,70.866663,26.9328731,22.4647861,1.8,26.9642106,22.325928,-0.147127,7.1731207,9.5442599,455.8217813,1637.4596785,0.2538281,171.564867,63.5458122,216.6550864,11.4943024,18.5057836,0.2725479,54.1593959),(46094,'ulna.tif',230,4,30,61.537439,25.6160028,22.753572,1.8,25.6617591,22.6157081,-0.0893111,6.2143729,8.4859016,343.3731487,1190.9267997,0.0815913,140.3418107,55.2546742,179.0816541,10.8081902,15.8498291,0.2110933,47.6962007),(46095,'ulna.tif',230,4,31,57.6611085,24.9254894,22.9082114,1.8,24.9612954,22.8286114,-0.0451446,5.76504,8.0454967,273.1858588,1050.1704354,0.0195726,130.528975,47.3866373,163.0116867,10.0882884,14.872166,0.1871769,44.6679644),(46096,'ulna.tif',230,4,32,54.5309723,24.5887973,22.9082884,1.8,24.6740488,22.8327364,-0.0155077,5.6214214,7.9949551,248.9084657,1041.4864376,0.0021855,130.267954,44.2785638,160.8579076,9.7217734,14.706445,0.113151,44.3928438),(46097,'ulna.tif',230,4,33,52.1692058,24.3467653,22.9195392,1.8,24.4330215,22.8463455,0.0286454,5.6065183,7.9568594,247.9808601,1049.0334139,0.0071327,131.8401343,44.2308124,162.8164386,9.5862676,15.0364681,2.6087488,44.6411041),(46098,'ulna.tif',230,4,34,54.8928859,24.3870012,22.8343291,1.8,24.5002421,22.7407357,0.0596284,5.856616,8.2317688,293.6676471,1132.0163313,0.0324905,137.5179945,50.1428895,172.4722463,10.1283279,15.7010704,2.592709,46.7411456),(46099,'ulna.tif',230,4,35,59.736468,24.54611,22.7353635,1.8,24.6875953,22.5403199,0.1034274,6.2220396,8.6207904,376.8843632,1282.6928207,0.1061232,148.7906289,60.5724786,185.5375282,10.7366258,16.6156988,2.5794623,49.6350802),(46100,'ulna.tif',230,4,36,69.73799,25.1094048,22.4960854,1.8,25.1833424,22.2740904,0.125843,7.110593,9.3743361,548.9079277,1585.354894,0.1830975,169.1164978,77.1958021,224.8426176,11.8384437,17.789667,2.5915683,53.9648562),(46101,'ulna.tif',230,4,37,84.0685259,26.2704028,22.19677,1.8,26.4134368,21.9916285,0.0497315,7.0204612,10.667851,751.1485079,2351.6434897,0.0346247,220.4421002,106.9941832,290.4451993,12.1260171,21.4383935,0.0827124,62.7115067),(46102,'ulna.tif',230,4,38,91.3967515,27.0698141,22.5131542,1.8,27.2309578,22.2730886,0.090687,6.8506528,11.5981564,739.2413924,3115.9962539,0.1249335,268.6630663,107.9081682,332.3324729,11.5545613,22.1577066,3.101614,63.0468654),(46103,'ulna.tif',230,4,39,101.1193984,27.448201,22.9326168,1.8,27.4599328,22.6712458,0.1730244,6.7962049,12.0553889,699.3640106,3677.6830535,0.4995276,305.0654855,102.9050796,361.6362781,11.0373799,21.7989089,3.0449558,61.1033774),(46104,'ulna.tif',230,4,40,96.1928421,26.1578259,22.4528146,1.8,26.1929229,22.4229899,0.1197197,6.5491068,10.8233408,597.1259927,2659.2443727,0.2286899,245.6953368,91.1767065,300.8108351,10.8667859,19.6550974,2.9718144,57.3729549),(46105,'ulna.tif',230,4,41,80.8113054,24.6522722,22.6310199,1.8,24.734318,22.5382841,0.1751688,6.4914759,9.4335214,446.6639345,1836.2848913,0.4090606,194.6552943,68.8077627,241.6695312,10.4657699,17.9388672,2.7221152,57.7555168),(46106,'ulna.tif',230,4,42,74.3451322,24.0315055,22.8794143,1.8,24.0626728,22.880354,0.2033458,4.3548589,8.9250443,283.2274641,1634.5899303,0.5053328,183.1464229,65.0371155,214.8741842,8.0024559,17.2812605,2.6979997,46.5040111),(46107,'ulna.tif',230,4,43,69.8714123,23.5931055,22.8830142,1.8,23.6752981,22.8795109,0.2168203,4.379769,8.6040638,247.5763428,1518.2429812,0.5389297,176.4564991,56.5272599,205.2127366,7.8403326,17.1670695,2.7443214,45.2404576),(46108,'ulna.tif',230,4,44,66.2790931,23.1104811,22.8219391,1.8,23.1794777,22.7983011,0.2152747,4.2874845,8.2751386,217.5213679,1372.1757439,0.5040712,165.8190643,50.7340299,190.4815409,7.6256564,16.7753435,2.748832,45.2784438),(46109,'ulna.tif',230,4,45,63.4775474,22.7323087,22.8484283,1.8,22.775088,22.8200525,0.2412623,3.7525453,8.0753559,177.9267362,1302.3449104,0.6039554,161.2739949,47.414947,180.9624027,6.8254138,16.3093838,2.7295709,41.4831747),(46110,'ulna.tif',230,4,46,59.9597626,22.0884765,22.7719618,1.8,22.1077686,22.7371046,0.2736917,3.3113144,7.6274439,149.0165715,1090.9417798,0.7300636,143.0284889,45.0022422,161.5991955,6.2072241,15.4809915,2.7451514,39.0589005),(46111,'ulna.tif',230,4,47,57.6052615,21.6846896,22.6977215,1.8,21.7056903,22.6587367,0.2968824,3.0054848,7.4743663,135.7855504,988.2286278,0.821642,132.2157068,45.179251,150.3247661,6.0982828,14.9870804,2.7473697,37.9139141),(46112,'ulna.tif',230,4,48,56.6826767,21.4063402,22.6579125,1.8,21.4456573,22.6123545,0.3125845,2.9426517,7.431287,126.1766536,912.0201683,0.8933936,122.7270814,42.8785553,139.6139613,5.9273408,14.69811,2.7554919,36.8069141),(46113,'ulna.tif',230,4,49,54.9875859,21.2161901,22.6366799,1.8,21.2591109,22.59767,0.3211384,2.9116096,7.440696,117.4442287,854.3738563,0.9130963,114.8244537,40.3365296,130.5619613,5.8357756,14.5371494,2.7837132,36.2344209),(46114,'ulna.tif',230,4,50,54.5616247,21.096853,22.6137525,1.8,21.1437434,22.5792685,0.3281385,2.8720328,7.4190118,111.6886538,810.8992148,0.9445102,109.3001654,38.888363,124.2267431,5.7595626,14.3948325,2.7882225,35.7916209),(46115,'ulna.tif',230,4,51,54.013514,21.0005851,22.5866869,1.8,21.0497558,22.5503022,0.3341961,2.876041,7.4483915,107.7907765,783.3690892,0.9685564,105.1729211,37.478873,119.3318492,5.7477809,14.2910238,2.7855418,35.5702209),(46116,'ulna.tif',230,4,52,53.5375477,20.9578782,22.5644478,1.8,21.0041344,22.5353284,0.3379964,2.8520037,7.4583573,104.350989,761.36177,0.9811374,102.0816967,36.5886589,115.9282723,5.6710594,14.2528141,2.7928217,35.4405277),(46117,'ulna.tif',230,4,53,52.9706704,20.9579164,22.5486099,1.8,21.0096282,22.526352,0.3372488,2.8605028,7.4638385,102.3453125,746.3708296,0.9666227,99.9982555,35.7787842,113.2922798,5.6461204,14.2153639,2.8001402,35.2839743),(46118,'ulna.tif',230,4,54,52.4980484,20.9948162,22.5226808,1.8,21.0457603,22.501377,0.335257,2.858652,7.3653672,101.3672893,731.840359,0.9471419,99.3623723,35.4598211,112.8552159,5.6303516,14.0837213,2.7800621,34.9708674),(46119,'ulna.tif',230,4,55,51.815636,21.0576256,22.4938094,1.8,21.1057416,22.4718808,0.3318986,2.867115,7.2484748,101.5232177,715.1539793,0.9168845,98.6626847,35.4095379,112.2779879,5.6527716,13.9411707,2.7846807,34.7874536),(46120,'ulna.tif',230,4,56,51.6621291,21.1370487,22.4495182,1.8,21.1907457,22.4294208,0.3285739,2.8958982,7.1194827,102.4822295,701.9597396,0.8966061,98.5970147,35.3887542,112.8385113,5.6964528,13.8140127,2.7640625,34.4743467),(46121,'ulna.tif',230,4,57,51.260222,21.2446107,22.4052939,1.8,21.2927758,22.3773053,0.3250939,2.8995474,6.9976735,104.0777287,693.5157453,0.8715515,99.106617,35.894474,113.8147525,5.7632119,13.6928348,2.7430702,34.3826398),(46122,'ulna.tif',230,4,58,51.0252664,21.3588466,22.3680353,1.8,21.4040169,22.3418199,0.321132,2.9317931,6.9000824,104.8403728,685.6765382,0.8472673,99.3722244,35.7598129,114.5651434,5.7814205,13.6084489,2.7580651,34.0695329),(46123,'ulna.tif',230,4,59,50.4506128,21.4677532,22.3285777,1.8,21.5139066,22.3030619,0.3161818,2.9324273,6.8105547,106.21334,677.5086449,0.8129579,99.4792168,36.2202804,115.0180996,5.8251616,13.5479806,2.7474301,34.1075191),(46124,'ulna.tif',230,4,60,50.557156,21.6053711,22.288892,1.8,21.6621579,22.2605492,0.3068548,2.9419015,6.6930481,106.9847418,668.7112196,0.7688175,99.9113126,36.3658474,115.8850278,5.8587866,13.4458364,2.7442683,34.0806588),(46125,'ulna.tif',230,4,61,50.2693821,21.767753,22.2563554,1.8,21.8223378,22.2240643,0.2951803,2.9434558,6.6028038,106.8701099,659.0662418,0.7090496,99.8161176,36.3076995,115.112765,5.8370344,13.3438288,2.7410581,33.897245),(46126,'ulna.tif',230,4,62,49.857176,21.928722,22.2194311,1.8,21.9976894,22.1895603,0.2812461,2.9923143,6.5570066,107.713266,650.0544766,0.6401303,99.1389084,35.9966421,114.2894809,5.8765344,13.1988581,2.7455112,33.9620916),(46127,'ulna.tif',230,4,63,49.9575116,22.1139409,22.1795577,1.8,22.1833949,22.14857,0.269306,3.0411122,6.5796737,108.6540475,648.3102365,0.5894094,98.5322778,35.7283912,114.0861809,5.874949,13.0743224,2.7689477,34.0917847),(46128,'ulna.tif',230,4,64,49.704085,22.2742303,22.133974,1.8,22.3558667,22.0984776,0.2584476,3.0930241,6.5803729,109.2208774,640.4389398,0.5411212,97.3256304,35.3120037,113.2617362,5.8890259,12.9571038,2.7928217,34.118645),(46129,'ulna.tif',230,4,65,49.6115701,22.4682691,22.0919194,1.8,22.5410846,22.0514278,0.2464156,3.1031607,6.5905614,109.5522051,635.5476158,0.4919942,96.4330015,35.3034258,112.2236663,5.9206593,12.8645603,2.871567,34.0537985),(46130,'ulna.tif',230,4,66,49.2614071,22.6444246,22.0475333,1.8,22.7230109,22.0098834,0.2362186,3.1501966,6.5575503,109.6106465,628.690431,0.4496668,95.8727577,34.7948594,111.7734758,5.9349108,12.8988075,3.0470478,34.2751985),(46131,'ulna.tif',230,4,67,49.0047107,22.8593782,21.9974547,1.8,22.9529143,21.9588857,0.2213433,3.2374754,6.5565592,110.1441996,625.1311678,0.3936544,95.3443952,34.0216327,109.5265097,6.0342569,12.9821426,3.0733228,34.642026),(46132,'ulna.tif',230,4,68,48.8065873,23.0740097,21.9535861,1.8,23.1797902,21.9156682,0.2083059,3.2786474,6.5547549,110.18604,624.0314358,0.3478882,95.2028635,33.6071634,107.6514801,6.1123408,13.1005404,3.0654689,34.642026),(46133,'ulna.tif',230,4,69,48.6349561,23.2822811,21.9158836,1.8,23.3932508,21.8807135,0.1982313,3.2302105,6.5909964,109.4588189,621.4851986,0.3143731,94.2930573,33.8859705,104.4027832,6.1015381,13.3134883,3.0750245,34.7985795),(46134,'ulna.tif',230,4,70,48.2700491,23.4946038,21.8868789,1.8,23.6213398,21.8518646,0.1885374,3.1660783,6.6232466,107.3686382,613.0234631,0.2825982,92.5563396,33.9121871,100.9481275,6.0794535,13.4239451,3.075573,34.8634261),(46135,'ulna.tif',230,4,71,47.9005914,23.7255781,21.8679171,1.8,23.8627897,21.835394,0.1790561,3.1963732,6.689048,104.9830157,605.9024376,0.2532338,90.5812663,32.8444175,98.3174957,6.0883052,13.5217239,3.0924519,34.955133),(46136,'ulna.tif',230,4,72,47.7102968,23.9784,21.8436722,1.8,24.1266593,21.8113544,0.1685063,3.2299995,6.7985545,104.0796434,604.1896909,0.2236552,88.8703165,32.2228044,96.6610759,6.12391,13.6322914,0.0487419,35.1385467),(46137,'ulna.tif',230,4,73,47.7193429,24.2273884,21.8272244,1.8,24.3709544,21.7986569,0.1637438,3.1795572,6.8401744,102.4664135,603.6317198,0.211343,88.2480014,32.2266296,96.4221732,6.1136684,13.6448706,3.0766435,34.9819933),(46138,'ulna.tif',230,4,74,47.9166566,24.4650183,21.8153492,1.8,24.6052084,21.7841178,0.163872,3.1659916,6.862801,100.4393531,601.69421,0.2125465,87.6747279,31.7244536,95.375613,6.0614313,13.7379558,0.0403007,35.0468398),(46139,'ulna.tif',230,4,75,47.6413286,24.6872345,21.8051398,1.8,24.8264489,21.7795653,0.1659333,3.0959675,6.8948758,97.5695993,592.3272092,0.2166257,85.9083217,31.5150589,93.4453926,6.0284432,13.7379558,3.1012919,34.7874536),(46140,'ulna.tif',230,4,76,47.4249284,24.9175816,21.798278,1.8,25.0625394,21.7741811,0.1687073,3.0683772,6.8991483,94.5591754,583.4889223,0.2228431,84.5740517,30.8173244,92.2685957,6.00338,13.6525024,3.0685521,34.6309001),(46141,'ulna.tif',230,4,77,47.1382159,25.1540519,21.7966668,1.8,25.3026531,21.7731321,0.1708479,3.0775019,6.8984783,91.5874177,577.8925233,0.227097,83.7710144,29.7603122,90.9918519,5.9532536,13.6525024,3.0685521,34.722607),(46142,'ulna.tif',230,4,78,46.8109028,25.3957518,21.8007058,1.8,25.5406354,21.7779938,0.1756944,2.9988674,6.90579,88.1698828,569.9124061,0.2383627,82.5267504,29.4010609,90.2468975,5.8716302,13.6610269,3.0604703,34.4095001),(46143,'ulna.tif',230,4,79,46.0505519,25.643195,21.8173632,1.8,25.793814,21.8005102,0.1800253,2.9481847,6.8882554,84.8105957,561.5494126,0.2460673,81.5227344,28.7670563,89.1710421,5.7935424,13.5818579,3.0354359,34.2529467),(46144,'ulna.tif',230,4,80,45.7047718,25.9032792,21.8415964,1.8,26.0449096,21.8224099,0.1859306,2.8966533,6.8137273,81.8217886,553.0506595,0.2603166,81.1671252,28.2470075,88.6718484,5.712183,13.5506939,3.0598083,34.0315467),(46145,'ulna.tif',230,4,81,45.1286456,26.1744898,21.8784573,1.8,26.3329557,21.8680805,0.192121,2.880017,6.8080487,79.2455279,545.1616001,0.274221,80.0760431,27.5156461,87.7476518,5.6726283,13.4840608,3.0264024,33.8749932),(46146,'ulna.tif',230,4,82,44.9016453,26.4350238,21.9319204,1.8,26.5849938,21.9258586,0.2026287,2.8404331,6.7837256,76.3768667,534.6139873,0.3030826,78.8083159,26.8891625,86.7805917,5.5860036,13.4840608,3.0264024,33.5887466),(46147,'ulna.tif',230,4,83,44.4851535,26.7255554,21.9985255,1.8,26.9002553,21.9988598,0.2078776,2.8044092,6.7387697,74.16238,522.7531904,0.3158018,77.573981,26.4449207,85.6763409,5.4933703,13.38738,3.0172377,33.2756397),(46148,'ulna.tif',230,4,84,44.1037725,27.0246587,22.0736394,1.8,27.2005587,22.0768696,0.2124471,2.8027643,6.6862028,72.3073481,513.6243918,0.3268003,76.8185486,25.7985834,85.3276545,5.440736,13.3231495,2.9914702,32.9625328),(46149,'ulna.tif',230,4,85,43.4463335,27.3010746,22.1567441,1.8,27.4741986,22.1570525,0.2219676,2.7786803,6.6136444,70.7885647,501.2901719,0.3509433,75.7963605,25.4756057,85.3898935,5.3570406,13.1788813,2.9557287,32.6762862),(46150,'ulna.tif',230,4,86,42.7908522,27.5610167,22.2383543,1.8,27.7195585,22.2378079,0.2320024,2.7928181,6.5718955,69.8548853,485.2810161,0.3770324,73.8418645,25.0123287,83.3430454,5.3808652,13.1131624,2.9375747,32.1797655),(46151,'ulna.tif',230,4,87,42.3515808,27.826515,22.3240221,1.8,27.9933418,22.3348487,0.2410594,2.7917434,6.4703082,69.0300244,470.3818516,0.4022889,72.6985234,24.7264935,82.6267549,5.3694646,12.9689205,2.9090357,31.8666586),(46152,'ulna.tif',230,4,88,41.7913001,28.0819423,22.4165005,1.8,28.2517401,22.4293491,0.2484868,2.8060459,6.4351806,68.0917589,457.3274117,0.421293,71.066756,24.2660887,80.8777653,5.3674113,12.9196917,2.9257118,31.9203793),(46153,'ulna.tif',230,4,89,41.2443747,28.3301899,22.5125458,1.8,28.4746614,22.5208758,0.2558528,2.7941669,6.3551173,67.034988,440.8878792,0.4402474,69.3752545,23.9910465,79.4772032,5.3198782,12.7535826,2.9050348,31.5424258),(46154,'ulna.tif',230,4,90,40.5911773,28.5724662,22.6209338,1.8,28.7018788,22.6268962,0.2634193,2.7944226,6.3302786,65.881004,427.9654601,0.458677,67.6061021,23.5758917,77.5207578,5.2952685,12.6459922,2.9029833,31.2293189),(46155,'ulna.tif',230,4,91,39.8279327,28.8120123,22.7324535,1.8,28.9301194,22.7387645,0.2709485,2.7792502,6.2596092,64.316539,409.6331389,0.4755063,65.4406888,23.1416877,75.4601694,5.2548638,12.486058,2.8815614,30.7865189),(46156,'ulna.tif',230,4,92,39.133767,29.0529055,22.8461732,1.8,29.1708107,22.8540152,0.2779001,2.7716847,6.1905867,62.7068982,390.9792422,0.4908726,63.157058,22.6241093,72.9011655,5.2187805,12.3632632,2.8509935,30.4354257),(46157,'ulna.tif',230,4,93,38.3114459,29.2830255,22.9594103,1.8,29.4085857,22.9653257,0.2857633,2.7663941,6.1164407,61.8446235,373.3248998,0.5073833,61.0362988,22.3556808,70.8359884,5.2127461,12.195102,2.8657868,29.9657654),(46158,'ulna.tif',230,4,94,37.7641296,29.5035947,23.0748071,1.8,29.6231275,23.0876898,0.2917738,2.7577798,6.038145,60.7199444,354.7155504,0.5207888,58.7457822,22.0176914,68.5873674,5.2045668,12.0454632,2.8430937,29.4312585),(46159,'ulna.tif',230,4,95,36.5433553,29.7149437,23.1973232,1.8,29.8124577,23.2013254,0.2960923,2.7496816,5.9686087,59.5152547,338.9602462,0.5185401,56.7904955,21.6444168,66.6269722,5.1903835,11.8676398,2.8286914,29.1450119),(46160,'ulna.tif',230,4,96,35.8989691,29.9343793,23.3239438,1.8,30.0230994,23.3239552,0.300135,2.7297426,5.8911704,58.6079869,325.0304878,0.5229789,55.1724815,21.4701513,65.0467402,5.1842848,11.6954965,2.8437896,28.7670584),(46161,'ulna.tif',230,4,97,35.859717,30.1196441,23.4434326,1.8,30.2141654,23.449743,0.3064085,2.7319746,5.815546,57.8638273,309.6005232,0.5437796,53.2367081,21.1802217,63.1002474,5.1935823,11.5175898,2.8289604,28.3242584),(46162,'ulna.tif',230,4,98,35.3345433,30.320089,23.571595,1.8,30.3924151,23.5763318,0.3103475,2.7402807,5.7235119,57.106598,296.9491537,0.549233,51.8823336,20.8396891,61.7655683,5.2060088,11.3455358,2.8445284,28.1028584),(46163,'ulna.tif',230,4,99,34.927071,30.501413,23.7011189,1.8,30.57473,23.7085346,0.3123741,2.742967,5.6498678,56.3739239,282.8720211,0.54978,50.0670163,20.5521699,59.9463141,5.2097095,11.1763158,2.8605719,27.8166118),(46164,'ulna.tif',230,4,100,34.7619949,30.6892769,23.825087,1.8,30.762086,23.8334869,0.3104949,2.7209748,5.5729392,55.9190442,271.1015551,0.54083,48.646064,20.5511069,58.5937507,5.221467,11.0000387,2.7816441,27.411798),(46165,'ulna.tif',230,4,101,34.2239424,30.8638244,23.9537358,1.8,30.9381729,23.9598318,0.3116973,2.7228709,5.5062958,54.8906313,256.8500287,0.5364562,46.6466094,20.1591018,56.5276012,5.234938,10.8174924,2.8295505,26.8772911),(46166,'ulna.tif',230,4,102,33.6193081,31.0479145,24.1014503,1.8,31.1214368,24.1054667,0.3168461,2.7082911,5.3888823,54.0460392,244.1785519,0.5439414,45.3115392,19.9557718,55.1464669,5.2300346,10.6139316,2.8561298,26.6827514),(46167,'ulna.tif',230,4,103,32.9798178,31.2389329,24.2659548,1.8,31.3079525,24.271384,0.3233689,2.6814764,5.2931288,53.4077304,232.0199155,0.5550124,43.8341719,19.9172855,53.8985473,5.2060151,10.4328518,2.8064201,26.3047979),(46168,'ulna.tif',230,4,104,32.2859519,31.4310949,24.4358545,1.8,31.4968656,24.440355,0.3286049,2.6871612,5.1959929,52.5160489,220.90028,0.5604307,42.5135836,19.5433194,52.5606419,5.2141835,10.2569397,2.8232551,26.0833979),(46169,'ulna.tif',230,4,105,31.4524613,31.6203628,24.6113251,1.8,31.6882117,24.6210563,0.3357509,2.6851495,5.1036624,51.4075912,209.7751913,0.5690585,41.1028739,19.1451506,51.0885418,5.1893678,10.0542182,2.7815333,25.548891),(46170,'ulna.tif',230,4,106,30.7133955,31.808476,24.7840432,1.8,31.8681404,24.786192,0.3387965,2.6585712,5.0101876,50.2533738,199.7576856,0.5654234,39.8703008,18.902399,49.84417,5.1467256,9.8876861,2.7631653,25.3654772),(46171,'ulna.tif',230,4,107,30.1108862,31.9788624,24.9569704,1.8,32.0421561,24.9657935,0.3346771,2.680944,4.9332955,49.4894817,190.1935714,0.5414375,38.553047,18.4597225,48.5002049,5.1583273,9.7044201,2.7801518,24.9875237),(46172,'ulna.tif',230,4,108,29.5688128,32.1390596,25.1321143,1.8,32.2005631,25.1436933,0.3321206,2.6719682,4.833037,48.892971,181.0120519,0.5238984,37.4530652,18.2984853,47.3905777,5.150123,9.5382046,2.7610863,24.7012771),(46173,'ulna.tif',230,4,109,29.0254963,32.3006643,25.3106242,1.8,32.35943,25.3209718,0.3275031,2.6583911,4.760021,47.981057,172.384866,0.5005829,36.215148,18.0489084,46.2648645,5.1136361,9.3827645,2.8049178,24.2964633),(46174,'ulna.tif',230,4,110,28.4298282,32.4496848,25.4803624,1.8,32.5066158,25.4878246,0.3200455,2.6462166,4.6713976,47.0430169,163.8301204,0.468994,35.0709007,17.7774629,45.0570655,5.1050206,9.2306815,2.747724,23.8916495),(46175,'ulna.tif',230,4,111,27.8602351,32.5816727,25.6474726,1.8,32.6360784,25.6609734,0.3143203,2.6341911,4.598446,46.5198805,155.7490215,0.4438422,33.8699252,17.6600246,43.9824424,5.1275507,9.0699726,2.7928217,23.7999427),(46176,'ulna.tif',230,4,112,27.3260291,32.7126791,25.7965511,1.8,32.7660084,25.8062784,0.3107563,2.6372919,4.5337167,45.9176437,148.5296117,0.4258337,32.7611142,17.4109072,42.8551164,5.1108327,8.9420668,2.7610863,23.4219892),(46177,'ulna.tif',230,4,113,26.9710849,32.8618631,25.9587028,1.8,32.9115377,25.9678937,0.3102163,2.6336968,4.4476674,45.6972374,142.755372,0.41889,32.0966832,17.3509864,42.2612311,5.1022022,8.7983876,2.7680955,23.2654357),(46178,'ulna.tif',230,4,114,26.6344604,32.9970304,26.113127,1.8,33.0427794,26.1116468,0.3060299,2.6309553,4.3736144,45.4428257,136.7660214,0.402921,31.2707089,17.2723674,41.6409288,5.1019135,8.6777792,2.7350258,23.0440357),(46179,'ulna.tif',230,4,115,26.322488,33.1232137,26.2694541,1.8,33.1621691,26.2705536,0.3031671,2.5968919,4.3124125,45.5071297,131.9248796,0.391015,30.5918969,17.5236907,41.0889846,5.1013361,8.5762148,2.7299213,22.9523288),(46180,'ulna.tif',230,4,116,25.8550039,33.225272,26.4160732,1.8,33.2549209,26.4131029,0.3008604,2.5922316,4.237605,45.4831283,126.9817587,0.3784251,29.9654545,17.5459356,40.6843076,5.1040681,8.4306615,2.7367009,22.7309288),(46181,'ulna.tif',230,4,117,25.449278,33.3325306,26.5580778,1.8,33.3684902,26.5557475,0.2980126,2.5927338,4.1995027,45.5424967,122.623569,0.3656777,29.1995455,17.5654346,39.9805044,5.1040681,8.345929,2.7610863,22.6660822),(46182,'ulna.tif',230,4,118,25.1193934,33.4427013,26.6922111,1.8,33.4785883,26.6909251,0.2935363,2.5778066,4.1203141,45.7084865,118.5128104,0.3504871,28.7630521,17.731542,39.8440309,5.1401664,8.227625,2.7261006,22.3909616),(46183,'ulna.tif',230,4,119,24.8446494,33.5517794,26.8183694,1.8,33.5850213,26.8166719,0.291001,2.5831231,4.0751571,45.9571203,114.8083507,0.3408607,28.1727424,17.791301,39.4281977,5.1482081,8.1264664,2.7206021,22.326115),(46184,'ulna.tif',230,4,120,24.5677216,33.6641157,26.944463,1.8,33.7030741,26.9411952,0.2869225,2.5662588,4.0059864,46.1125872,111.9024186,0.3279385,27.9337993,17.9687984,39.4379742,5.1631738,8.0255597,2.7149652,22.2612685),(46185,'ulna.tif',230,4,121,24.1807801,33.7762228,27.0683493,1.8,33.812412,27.0677918,0.2770113,2.5631513,3.9556334,46.2369338,108.7173793,0.3014235,27.4841899,18.0390967,38.956093,5.1876468,7.9365035,2.6155262,22.0778547),(46186,'ulna.tif',230,4,122,23.8285313,33.8957745,27.1974532,1.8,33.9462818,27.1957322,0.2667164,2.573475,3.8915786,46.3129826,105.4541376,0.2758816,27.0980363,17.9962823,38.7238792,5.2087478,7.8347144,2.7348456,22.0130081),(46187,'ulna.tif',230,4,123,23.4666655,34.0098791,27.3260903,1.8,34.0529102,27.3277032,0.2529634,2.5743587,3.8216251,46.513393,102.6839584,0.2449809,26.8691867,18.067953,38.6496886,5.2358173,7.7331701,2.7291822,21.883315),(46188,'ulna.tif',230,4,124,23.2127076,34.1212677,27.4492279,1.8,34.1630847,27.447609,0.2461558,2.5882854,3.7889077,47.0394151,100.5637264,0.2297234,26.5416143,18.1739678,38.4277147,5.2631755,7.6775065,2.7101919,21.8184684),(46189,'ulna.tif',230,4,125,22.8548129,34.2395824,27.5751785,1.8,34.2789633,27.5692055,0.2427129,2.6029742,3.7239501,47.1031642,97.6524133,0.2200225,26.2228037,18.0959012,38.2664342,5.2896675,7.5446746,2.7501875,21.661915),(46190,'ulna.tif',230,4,126,22.6549325,34.3619127,27.7280707,1.8,34.3956749,27.7214472,0.2369516,2.593492,3.6731497,47.0283536,95.2752143,0.2080595,25.9382881,18.1332169,38.3325676,5.3074462,7.4663032,2.8714395,21.6887753),(46191,'ulna.tif',230,4,127,22.3271077,34.4644162,27.875787,1.8,34.4956425,27.8700063,0.2448837,2.6022686,3.6476407,46.6897789,92.4264221,0.218727,25.3386858,17.9419524,37.9550909,5.3164483,7.4102886,2.9002372,21.6887753),(46192,'ulna.tif',230,4,128,21.934937,34.5628865,28.0201027,1.8,34.5835694,28.0239623,0.255884,2.6196255,3.6011874,46.1233326,89.1885244,0.234192,24.7664214,17.6068419,36.9986995,5.343229,7.3405041,2.7386811,21.3756684),(46193,'ulna.tif',230,4,129,21.555172,34.6594975,28.1666948,1.8,34.6805378,28.175364,0.2596708,2.6324313,3.56664,45.9031847,85.745446,0.2368444,24.0409587,17.4375626,36.384127,5.3682736,7.2565523,2.7667519,21.4025287),(46194,'ulna.tif',230,4,130,20.9666903,34.7595008,28.3208722,1.8,34.7888474,28.3265947,0.2631483,2.6711962,3.5388713,45.4409626,81.9307294,0.236446,23.1516557,17.0114656,35.7039358,5.4136591,7.188685,2.9713807,21.2459753),(46195,'ulna.tif',230,4,131,20.3868328,34.8521672,28.4778714,1.8,34.8903425,28.4868566,0.2650693,2.6721458,3.5044835,44.8800185,78.4145596,0.2331965,22.375497,16.7954978,35.1615553,5.42386,7.1210313,2.9380996,20.9597287),(46196,'ulna.tif',230,4,132,20.1619028,34.9578813,28.6327426,1.8,34.9883445,28.6385042,0.2522535,2.6859875,3.4934488,44.7919293,76.4472889,0.209326,21.8830426,16.6761497,34.5865846,5.4756784,7.1210313,2.9380996,20.8948821),(46197,'ulna.tif',230,4,133,19.8702883,35.0677652,28.7850833,1.8,35.0940787,28.7925476,0.2258555,2.6881663,3.4913303,44.3767377,74.5651271,0.1660799,21.3572251,16.5081818,33.9892518,5.4936212,7.0994876,2.9533711,20.8300356),(46198,'ulna.tif',230,4,134,19.4136584,35.1666232,28.9441702,1.8,35.1965531,28.9591334,0.200655,2.6984947,3.4981656,43.9904093,72.2345771,0.1285345,20.6492733,16.3018325,33.1708221,5.5042023,7.0796096,2.968732,20.8300356),(46199,'ulna.tif',230,4,135,19.0857853,35.2812437,29.1005168,1.8,35.3083916,29.1051468,0.1708943,2.7162956,3.5097435,43.8212603,70.7115705,0.0919987,20.1472188,16.132729,32.6316099,5.5350004,7.0796096,2.968732,20.6734821),(46200,'ulna.tif',230,4,136,18.7729024,35.3987279,29.2379182,1.8,35.4250503,29.244067,0.1487814,2.7640478,3.4824773,44.0021585,69.6572774,0.0687496,20.0022203,15.9194635,32.6272267,5.6023164,7.0449054,2.9996956,20.765189),(46201,'ulna.tif',230,4,137,18.6256412,35.494892,29.3993461,1.8,35.5041244,29.3995179,0.1371164,2.7824999,3.4264594,44.7806082,68.3419704,0.0579983,19.9453612,16.0936603,32.9303483,5.6457004,6.953864,2.900475,20.6734821),(46202,'ulna.tif',230,4,138,18.3405607,35.5751088,29.57701,1.8,35.6004474,29.5787579,0.1232092,2.7876972,3.4175337,45.321026,66.6836222,0.0461688,19.5122061,16.257514,32.773521,5.6710729,6.9353356,2.9974383,20.8300356),(46203,'ulna.tif',230,4,139,17.9980693,35.6429854,29.7545399,1.8,35.6673856,29.7389261,0.1078174,2.8352765,3.3662379,45.7737325,64.8374226,0.0347351,19.2610933,16.1443628,32.7913697,5.6457004,6.8428366,2.9791035,20.5817752),(46204,'ulna.tif',230,4,140,17.3782423,35.7008665,29.9441321,1.8,35.7161709,29.9198387,0.0938859,2.8776448,3.3186318,45.1524948,63.0911024,0.0254553,19.0111787,15.6907812,32.0201485,5.6457004,6.7970166,2.8610559,20.5549149),(46205,'ulna.tif',230,4,141,16.937841,35.7663002,30.123287,1.8,35.8006858,30.1052872,0.0640574,2.8590654,3.3386191,45.2952504,61.826273,0.0115678,18.5185167,15.8426775,31.5582544,5.6457004,6.7852874,2.5535901,20.684608),(46206,'ulna.tif',230,4,142,16.6166982,35.8320932,30.2958329,1.8,35.8591062,30.2787612,0.0416111,2.8872647,3.2911599,45.4691211,61.2228932,0.0047925,18.6022238,15.7481653,31.4199811,5.6457004,6.8177186,2.5761088,20.7494546),(46207,'ulna.tif',230,4,143,16.2069231,35.9290298,30.4360475,1.8,35.9519862,30.4156971,0.0318258,2.9035364,3.2917999,45.6661615,61.6063687,0.002735,18.7151014,15.7277733,31.639012,5.7564004,6.8535733,2.5984031,20.906008),(46208,'ulna.tif',230,4,144,16.0130908,36.0118171,30.5609217,1.8,36.0159312,30.5408018,0.0146102,2.8996659,3.3599212,45.4998481,62.4452484,0.0005696,18.5853311,15.6914104,31.3421148,5.7564004,6.9114404,2.5846911,21.0357012),(46209,'ulna.tif',230,4,145,16.3093975,36.0556156,30.6828048,1.8,36.0716926,30.661878,-0.0325189,2.8948376,3.3112545,46.5110008,63.7382704,0.0028735,19.2489795,16.0668776,31.583435,5.8671004,6.9485752,2.6066376,21.127408),(46210,'ulna.tif',230,4,146,15.7281205,36.0637684,30.8163319,1.8,36.0698395,30.8114589,-0.0470618,2.9155474,3.3274076,46.0241597,63.0773955,0.0058015,18.956919,15.7857698,30.8417355,5.8671004,7.0012833,2.536048,21.2571012),(46211,'ulna.tif',230,4,147,15.0282265,36.1539178,30.9793041,1.8,36.1661959,30.9925595,-0.0005164,2.9721784,3.3870666,45.2242789,62.4322965,0.0000007,18.4325567,15.2158696,30.1123564,5.9602247,7.0648811,2.5231647,21.5053615),(46212,'ulna.tif',230,4,148,14.2630076,36.0866027,31.148311,1.8,36.1226762,31.1750314,-0.0486056,3.0214736,3.3457295,44.8612032,58.9494652,0.0056116,17.619316,14.8474584,28.9252374,5.9778004,7.0309757,2.5579568,21.4405149),(46213,'ulna.tif',230,4,149,13.4555589,36.1038351,31.2832742,1.8,36.1344383,31.3341786,-0.1048824,3.0791675,3.3693474,43.9040851,56.1151646,0.0245789,16.6546095,14.258427,28.7081375,5.9778004,7.0100294,2.7698837,21.3108218),(46214,'ulna.tif',230,4,150,13.7939015,36.0660902,31.4761929,1.8,36.1234195,31.533836,-0.0728713,3.1443496,3.4473688,45.4839456,57.5386958,0.0121865,16.690612,14.4652955,29.3507423,6.1840995,7.0726823,2.8396415,21.8990494),(46215,'ulna.tif',230,4,151,13.5166868,36.0487438,31.663853,1.8,36.086485,31.7092444,-0.1715559,3.3029152,3.4629377,44.8942739,58.268234,0.0656547,16.8262439,13.592318,29.4848752,6.3099005,7.0449054,2.9996956,22.2121563),(46216,'ulna.tif',230,4,152,13.9967767,36.0711616,31.8202823,1.8,36.085567,31.8329998,-0.1263689,3.4151024,3.5791376,48.2457901,60.8308302,0.0370548,16.9959463,14.127187,30.4698163,6.5247582,7.2371056,0.1072789,22.7466632),(46217,'ulna.tif',230,4,153,15.8386965,36.0123988,32.050036,1.8,36.035662,32.0309466,-0.2933246,3.6138061,3.6525013,55.385385,68.5367182,0.2206855,18.7643243,15.3260534,33.2008829,6.8634005,7.4375249,3.0671039,23.7776908),(46218,'ulna.tif',230,4,154,16.9542361,35.763696,32.2664293,1.8,35.8882967,32.2837901,-0.4920083,3.7207517,4.0154024,59.839985,74.7062579,0.6305813,18.6049245,16.0827674,33.2902317,6.9546939,7.7868624,0.2587709,24.6901512),(46219,'ulna.tif',230,4,155,12.6873653,36.0644049,32.0901206,1.8,36.066523,32.2254858,0.0779254,3.6788574,4.2536176,34.0668066,69.0057212,0.0128144,16.2228312,9.2601596,23.4121393,6.8646647,8.1655796,0.2745753,27.7517652),(46220,'ulna.tif',230,4,156,2.5152322,36.2267687,32.589471,1.8,36.1841427,32.5949255,-0.2738817,1.2125597,1.7333911,0.7554972,1.6002587,0.0306667,0.9231954,0.6230598,1.3578608,2.4161168,3.3958028,0.3320595,9.4645711),(46221,'ulna.tif',230,4,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46222,'ulna.tif',230,4,158,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46223,'ulna.tif',230,4,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46224,'ulna.tif',230,4,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46225,'ulna.tif',230,4,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46226,'ulna.tif',230,4,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46227,'ulna.tif',230,4,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46228,'ulna.tif',230,4,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46229,'ulna.tif',230,4,165,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46230,'ulna.tif',230,4,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46231,'ulna.tif',230,4,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46232,'ulna.tif',230,4,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46233,'ulna.tif',230,4,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46234,'metacarpal.tif',230,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46235,'metacarpal.tif',230,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46236,'metacarpal.tif',230,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46237,'metacarpal.tif',230,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46238,'metacarpal.tif',230,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46239,'metacarpal.tif',230,5,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46240,'metacarpal.tif',230,5,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46241,'metacarpal.tif',230,5,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46242,'metacarpal.tif',230,5,9,0.0006678,7.1292678,4.039134,1.8,7.1292692,4.0391308,-0.4915492,0.0197474,0.0230556,0.00000008823,0.0000001,0.0000248,0.0000052,0.0000045,0.0000086,0.0492,0.0615,0.6435011,0.1463638),(46243,'metacarpal.tif',230,5,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46244,'metacarpal.tif',230,5,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46245,'metacarpal.tif',230,5,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46246,'metacarpal.tif',230,5,13,0.0022787,6.9448853,4.3693497,1.8,6.9524286,4.3542,-1.0813731,0.0269457,1.2260075,0.0000004,0.0019486,0.0002958,0.0015894,0.0000153,0.0015897,0,0,0,0),(46247,'metacarpal.tif',230,5,14,0.0003006,5.6805708,4.9224272,1.8,5.6808429,4.9129714,-1.5346886,0.0093013,0.859272,0.00000001278,0.0001675,0.00005,0.0001949,0.0000014,0.0001949,0,0,0,0),(46248,'metacarpal.tif',230,5,15,0.004465,7.6276635,5.2106891,1.8,7.6276558,5.2018356,1.3170765,0.5550139,1.7361295,0.0003626,0.0019625,0.0006973,0.0011304,0.0006534,0.0012763,0,0,0,0),(46249,'metacarpal.tif',230,5,16,1.2132657,7.5989194,5.0945763,1.8,7.606015,5.0826783,0.0475544,1.3083555,1.4064135,0.0869469,0.2154877,0.0004569,0.1532179,0.0664551,0.1820844,1.1288735,1.799419,2.8717435,5.4255619),(46250,'metacarpal.tif',230,5,17,3.2541154,7.4959261,5.0453693,1.8,7.4723173,5.0455452,0.0391224,0.9663879,1.5876506,0.6527244,1.4512858,0.0008297,0.914109,0.6754268,1.3173376,1.8722518,2.8653721,2.9820896,8.9205981),(46251,'metacarpal.tif',230,5,18,5.1403136,7.2942254,5.0370976,1.8,7.2726972,5.0408447,0.096611,2.3230422,3.5107572,1.6641338,3.742255,0.0079715,1.0659396,0.7163597,1.2851621,2.359936,3.5532526,2.8537831,11.5945808),(46252,'metacarpal.tif',230,5,19,6.8489324,7.1135228,4.9872384,1.8,7.0818406,4.982229,0.2582806,1.4544534,2.021717,3.2630659,6.8286938,0.0744691,3.3776704,2.2434998,4.8752499,2.762998,4.0296722,2.5078592,13.4748825),(46253,'metacarpal.tif',230,5,20,8.404892,6.9438923,4.9545678,1.8,6.9138799,4.9527984,0.3392166,1.6534636,2.3075224,5.2077999,10.7388871,0.1551004,4.6538604,3.1496308,6.809027,3.0841918,4.5563822,2.603025,13.9296204),(46254,'metacarpal.tif',230,5,21,9.6129187,6.8128235,4.9527924,1.8,6.7685637,4.9553196,0.3356809,1.8075262,2.4019291,7.3072657,14.6110279,0.1738534,6.0830389,4.0426887,9.0136598,3.3755229,4.8489152,2.576809,14.5403997),(46255,'metacarpal.tif',230,5,22,10.6652547,6.7064311,4.962982,1.8,6.6729215,4.9705912,0.3162951,1.9490102,2.4803858,9.7903937,18.4795697,0.1719783,7.4502804,5.0232644,10.902607,3.5908178,5.1078332,2.5342204,15.3586808),(46256,'metacarpal.tif',230,5,23,11.7137997,6.582583,4.9927053,1.8,6.5472416,4.9986382,0.2395763,2.0360946,2.6650478,12.7936226,23.0686124,0.1099283,8.6559846,6.2834127,12.5420928,3.8043591,5.3048946,2.5458732,16.3024342),(46257,'metacarpal.tif',230,5,24,12.7594624,6.4415974,5.0228956,1.8,6.4030405,5.0290852,0.1534809,2.0653718,2.964659,15.8236248,28.0777718,0.0497024,9.4708267,7.6613929,13.9427126,3.9801923,5.6619026,2.9757297,17.5598066),(46258,'metacarpal.tif',230,5,25,13.8167563,6.3041636,5.0534899,1.8,6.2767146,5.0550755,0.10218,2.207846,3.1443733,19.017423,33.5396212,0.0239593,10.6665518,8.6135642,16.2704005,4.1552588,6.0091637,2.9542329,18.4561083),(46259,'metacarpal.tif',230,5,26,14.7638158,6.1783537,5.0804755,1.8,6.160525,5.0677835,0.0707072,2.3415462,3.2579546,21.8856377,39.1768026,0.0122814,12.024969,9.3466605,18.4641318,4.3211743,6.2675712,2.958053,19.3864755),(46260,'metacarpal.tif',230,5,27,15.7331164,6.0574855,5.1165436,1.8,6.0459717,5.1107593,0.0382563,2.48242,3.3504347,24.703144,44.8922459,0.0038358,13.3989316,9.9512346,20.5818498,4.4890071,6.5092223,2.926408,19.9431099),(46261,'metacarpal.tif',230,5,28,16.804734,5.9565135,5.1475831,1.8,5.9512992,5.1433398,0.0143604,2.6197594,3.4697014,27.8737022,51.2219425,0.0005777,14.7626369,10.6397947,22.7021387,4.658799,6.784094,2.9278401,20.7300978),(46262,'metacarpal.tif',230,5,29,17.7729317,5.878928,5.1685552,1.8,5.8886738,5.1550734,0.0064872,2.7636069,3.540753,30.7564225,56.7406841,0.0001248,16.0250333,11.1290873,24.6262241,4.8242074,6.9430095,2.914661,21.3905892),(46263,'metacarpal.tif',230,5,30,18.5566255,5.8354848,5.1822896,1.8,5.8493355,5.1670228,0.0095885,2.7689528,3.5969936,33.3024748,61.7330412,0.0002844,17.1623995,12.027101,26.3425403,4.9725031,7.0904459,2.9601876,21.4775633),(46264,'metacarpal.tif',230,5,31,19.3834458,5.8100912,5.1828064,1.8,5.8171018,5.1708448,0.0174489,2.8041082,3.608779,35.7113364,66.3280228,0.0009837,18.37963,12.735363,27.8962925,5.0672619,7.1825471,2.8729375,22.8027668),(46265,'metacarpal.tif',230,5,32,19.9517163,5.8028253,5.2005714,1.8,5.8153323,5.1829192,0.0192484,2.846772,3.603491,37.9957052,70.0152531,0.001232,19.4298397,13.3469437,29.2501609,5.1514213,7.2537262,2.8509479,22.5413323),(46266,'metacarpal.tif',230,5,33,20.3414002,5.8042358,5.2213779,1.8,5.8233438,5.2123644,0.0203598,2.9041458,3.6054207,40.0581368,73.443117,0.001405,20.3701936,13.7934317,30.5585106,5.2405884,7.3503487,2.8478919,22.5162202),(46267,'metacarpal.tif',230,5,34,20.5693849,5.8149387,5.2358432,1.8,5.826222,5.2340153,0.0311046,2.9402064,3.6120264,41.3434331,76.6396753,0.0033159,21.2179165,14.0614051,31.5327563,5.3213494,7.4295462,2.8093713,22.7778668),(46268,'metacarpal.tif',230,5,35,20.8717833,5.8329249,5.2425111,1.8,5.8366048,5.2288698,0.0385974,2.9523557,3.6486091,42.7565997,78.7860414,0.0051798,21.5934457,14.4821978,32.3528181,5.3601757,7.4863261,2.7928217,23.0700823),(46269,'metacarpal.tif',230,5,36,20.630395,5.8499712,5.249982,1.8,5.8544305,5.2448142,0.0475645,2.9584815,3.6691821,43.1045844,80.0877982,0.007773,21.8271527,14.5698341,32.6264701,5.3771052,7.5583375,2.8049178,22.852903),(46270,'metacarpal.tif',230,5,37,20.1623938,5.8592027,5.2664862,1.8,5.8613068,5.2601263,0.0420255,2.9870137,3.6823792,43.145173,80.3182179,0.0059315,21.8115011,14.4442501,32.4786828,5.4090664,7.6054392,2.7830113,22.9518151),(46271,'metacarpal.tif',230,5,38,19.59265,5.872015,5.2906839,1.8,5.8711953,5.2747973,0.0415835,2.9995898,3.6778977,42.7099285,80.3121903,0.0056433,21.8364396,14.2385898,32.1943813,5.4418728,7.6036885,2.7655921,23.2276599),(46272,'metacarpal.tif',230,5,39,19.085637,5.8687756,5.2928413,1.8,5.8728411,5.2650558,0.0411738,2.9727834,3.6938766,42.3410224,79.7096084,0.0053895,21.5788496,14.2428883,32.0572571,5.4596599,7.6126567,2.7850913,23.1970909),(46273,'metacarpal.tif',230,5,40,18.5161786,5.864087,5.3153273,1.8,5.8738837,5.2951282,0.0425061,2.9715838,3.7400476,42.0957042,78.7376359,0.0055724,21.0525761,14.1660836,31.6356774,5.5065217,7.6198972,2.826478,23.1125892),(46274,'metacarpal.tif',230,5,41,18.1969945,5.8520653,5.377414,1.8,5.8618015,5.362049,0.044799,3.0024446,3.7660007,41.4176264,77.820001,0.0060828,20.6638309,13.7946346,31.0866406,5.4981,7.6154087,2.8499812,23.2025478),(46275,'metacarpal.tif',230,5,42,17.6991218,5.847535,5.4343359,1.8,5.8561407,5.4085846,0.0334296,3.0294492,3.7654139,40.1197678,77.2546666,0.0032954,20.516912,13.2432547,30.7538238,5.5072731,7.595626,2.7911614,23.1575685),(46276,'metacarpal.tif',230,5,43,17.2406265,5.8463905,5.4690904,1.8,5.8608855,5.4458883,0.02528,3.0242281,3.7700124,39.1646518,77.3474838,0.001836,20.5165067,12.950297,30.5833406,5.4934457,7.57677,2.7885221,23.3056806),(46277,'metacarpal.tif',230,5,44,17.0081954,5.8221163,5.4842109,1.8,5.8342061,5.4655499,0.0284555,2.9916275,3.7809006,38.5292745,77.0588694,0.0022948,20.3810885,12.8790348,30.2255151,5.4790246,7.5507375,2.7837753,23.5042288),(46278,'metacarpal.tif',230,5,45,16.6545388,5.8078623,5.5252416,1.8,5.8274464,5.5043661,0.0276446,2.9588457,3.7804851,36.46178,75.4915781,0.0021209,19.9687542,12.3229744,29.2978769,5.4201852,7.5284541,2.7686711,23.591715),(46279,'metacarpal.tif',230,5,46,16.4511203,5.79379,5.5762283,1.8,5.8147679,5.5581306,0.0252133,2.9368784,3.7767816,34.4201061,74.972496,0.0017426,19.8508954,11.7199631,28.7867619,5.3676547,7.4871748,2.764747,23.6038651),(46280,'metacarpal.tif',230,5,47,16.1738125,5.7740008,5.6337603,1.8,5.7982584,5.6263245,0.0369465,2.8636786,3.7504444,32.5286062,75.50534,0.003678,20.1323715,11.3590282,28.401598,5.2441528,7.4559207,2.7754848,22.9987548),(46281,'metacarpal.tif',230,5,48,15.8904016,5.7551001,5.6976201,1.8,5.7780219,5.6899871,0.0250709,2.7650653,3.7404896,30.399508,75.0925022,0.0016643,20.0755812,10.9941373,27.955871,5.0820048,7.4259104,2.7721593,23.3173185),(46282,'metacarpal.tif',230,5,49,15.7228297,5.7587402,5.7483547,1.8,5.7788476,5.7492381,-0.0003958,2.3906648,3.7245855,28.776404,73.9855503,0.0000003,19.864103,12.0369882,27.4312163,4.6547413,7.4100023,2.7731079,22.3521617),(46283,'metacarpal.tif',230,5,50,15.654399,5.7422486,5.7873168,1.8,5.7564515,5.7942724,-0.009771,3.088764,3.7293562,27.9004739,72.1728681,0.0002491,19.3526346,9.0328928,26.7986977,4.533314,7.3447584,2.8018356,21.6993875),(46284,'metacarpal.tif',230,5,51,15.3067744,5.7097665,5.8262534,1.8,5.7073674,5.827836,-0.0101112,2.3181734,3.7607526,26.6996069,70.581337,0.0002606,18.7678757,11.5175191,25.8601922,4.5291173,7.2816416,2.9236566,21.5157617),(46285,'metacarpal.tif',230,5,52,15.019442,5.7057776,5.8724197,1.8,5.6997851,5.8720571,-0.0094341,2.8626722,3.740274,25.7959162,68.6640851,0.0002227,18.3580359,9.0111316,23.5230016,4.5305652,7.2537262,2.9175899,21.5684582),(46286,'metacarpal.tif',230,5,53,14.8519296,5.7048365,5.9086158,1.8,5.7001192,5.9098552,-0.0150512,2.3169029,3.7067199,25.1960869,66.8494994,0.0005607,18.0346777,10.8748997,24.8214072,4.4898478,7.2151532,2.951218,21.339341),(46287,'metacarpal.tif',230,5,54,14.9554714,5.7005962,5.943457,1.8,5.6859874,5.9447331,-0.0139771,2.2157324,3.6988571,24.653292,66.3257655,0.0004867,17.9314212,11.1264753,24.5800755,4.3668629,7.1706468,3.0246843,20.9422444),(46288,'metacarpal.tif',230,5,55,14.9725836,5.7179741,6.0010058,1.8,5.6913251,5.9976397,-0.0186346,2.1859931,3.6473973,23.6777492,65.7939623,0.0008665,18.0386058,10.8315755,24.4781528,4.2952793,7.1209777,3.0845611,21.0334393),(46289,'metacarpal.tif',230,5,56,14.8329775,5.7417222,6.0630575,1.8,5.7066454,6.055034,-0.0317666,2.1481524,4.0538327,22.6753761,64.9562825,0.0024939,16.0234247,10.5557576,21.5480601,4.2103342,7.1027362,3.1017524,20.8761617),(46290,'metacarpal.tif',230,5,57,14.8061442,5.7575233,6.092157,1.8,5.7144691,6.0814702,-0.0382145,2.0921167,3.5661596,21.9969581,64.526882,0.0036018,18.0942218,10.514212,24.1970856,4.1533843,7.087885,3.1120873,20.6721565),(46291,'metacarpal.tif',230,5,58,14.8469319,5.7559894,6.1113433,1.8,5.7158443,6.1008966,-0.0328012,2.0631158,3.5595948,21.4278155,63.8317382,0.0026613,17.9323046,10.3861429,23.8708736,4.1106533,7.0387066,3.1118811,20.6744168),(46292,'metacarpal.tif',230,5,59,15.0149992,5.7572287,6.1266021,1.8,5.7232957,6.1166723,-0.020912,2.053584,3.5493097,21.2484563,63.3319852,0.001094,17.8434656,10.3470109,23.7259434,4.0871612,6.9867898,0.0846032,20.2589014),(46293,'metacarpal.tif',230,5,60,15.1399876,5.7332241,6.1466242,1.8,5.7015089,6.1400805,-0.0009164,2.0439224,3.5657065,21.0702831,63.3081646,0.000002,17.7547322,10.3087488,23.6375852,4.0182859,6.939653,3.1150032,20.0998755),(46294,'metacarpal.tif',230,5,61,15.2478955,5.7179083,6.1706455,1.8,5.6937983,6.1639606,0.0094517,2.0214214,3.5554727,20.5342649,62.6341866,0.000227,17.6162755,10.1583297,23.3082523,3.9689225,6.8978768,0.0535203,19.8113686),(46295,'metacarpal.tif',230,5,62,15.3147032,5.7248018,6.189447,1.8,5.7068535,6.1832176,0.0157906,2.0194724,3.5354518,19.951987,61.1518261,0.0006363,17.2967502,9.879802,22.8614118,3.9185058,6.835182,0.0504077,19.8148651),(46296,'metacarpal.tif',230,5,63,15.2508854,5.757074,6.214752,1.8,5.740735,6.2103515,0.0159399,1.9994967,3.490266,19.3707325,59.0020887,0.0006455,16.9047539,9.687804,22.3832241,3.8901342,6.7396031,0.0584343,19.3409841),(46297,'metacarpal.tif',230,5,64,15.1219382,5.8108427,6.2523238,1.8,5.7956527,6.2451528,0.0081584,1.9704758,3.424806,18.7482121,56.2012936,0.0001674,16.4100663,9.5145608,21.836325,3.8688783,6.6452906,0.0314711,19.100441),(46298,'metacarpal.tif',230,5,65,14.9292277,5.8620671,6.2894436,1.8,5.8506443,6.2848934,0.0013201,1.9524573,3.3626484,18.0208481,53.4418864,0.000004,15.8927962,9.2298293,21.1971739,3.8523189,6.564986,0.1013465,18.5917704),(46299,'metacarpal.tif',230,5,66,14.6921623,5.9216423,6.3304572,1.8,5.9140567,6.327053,-0.0078381,1.9240916,3.2814211,17.2817234,50.5056723,0.0001501,15.3914024,8.9817571,20.556157,3.8376,6.4723367,0.1104474,18.3139652),(46300,'metacarpal.tif',230,5,67,14.4899858,5.9667002,6.3627181,1.8,5.9618867,6.359627,-0.0196894,1.9159978,3.2379876,16.7456235,47.7452732,0.0009357,14.7453542,8.7398969,19.8842233,3.8391827,6.3876329,0.0713075,17.8423445),(46301,'metacarpal.tif',230,5,68,14.269247,6.0002364,6.3882929,1.8,5.9960298,6.3870872,-0.0286198,1.9056486,3.195137,16.2367139,45.2415754,0.0019473,14.1595105,8.5203086,19.2003903,3.8213527,6.2973718,0.0880074,17.5339704),(46302,'metacarpal.tif',230,5,69,14.1076074,6.0391033,6.4163936,1.8,6.0334449,6.4154085,-0.0392238,1.907093,3.1476244,15.7188655,43.0625273,0.0036155,13.6809613,8.2423172,18.6306501,3.8138382,6.2249667,0.0910177,17.2501962),(46303,'metacarpal.tif',230,5,70,13.9510923,6.0747579,6.4419027,1.8,6.0702327,6.4408593,-0.0464808,1.9056522,3.1052557,15.2489119,41.0915517,0.0050197,13.2329042,8.0019387,18.0685819,3.7979745,6.1589725,0.1221256,17.02756),(46304,'metacarpal.tif',230,5,71,13.7564747,6.1056931,6.4639074,1.8,6.1010747,6.4632744,-0.0563899,1.8927348,3.0734113,14.781389,39.1268315,0.0072827,12.7307503,7.8095406,17.4796401,3.7750956,6.0986422,0.1396153,16.8019393),(46305,'metacarpal.tif',230,5,72,13.5448105,6.1420442,6.4808613,1.8,6.1382777,6.4807809,-0.0659068,1.8952863,3.0308935,14.3134768,37.3481232,0.0097915,12.3224796,7.5521447,16.9774482,3.7610801,6.0345384,0.1514096,16.5295911),(46306,'metacarpal.tif',230,5,73,13.3674092,6.181552,6.5000166,1.8,6.1762587,6.4994949,-0.0757751,1.892081,2.9913482,13.8875823,35.7596326,0.0127676,11.9543532,7.3398457,16.5620326,3.7392,5.9630014,0.1074682,16.3867238),(46307,'metacarpal.tif',230,5,74,13.2247582,6.2203526,6.5188287,1.8,6.2158686,6.5181068,-0.0855175,1.8888041,2.9498906,13.4877914,34.3543949,0.0160799,11.6459895,7.1409161,16.164548,3.7269,5.907484,0.1336522,16.2115393),(46308,'metacarpal.tif',230,5,75,13.1267211,6.2477511,6.5329183,1.8,6.2440566,6.5328289,-0.0943236,1.8906918,2.9189958,13.1015268,33.1713441,0.0194067,11.3639574,6.9294884,15.8072302,3.7023,5.8484398,0.1520097,16.0291497),(46309,'metacarpal.tif',230,5,76,13.0343015,6.2727428,6.5453874,1.8,6.2700309,6.5462309,-0.1028938,1.8940645,2.8953996,12.7705593,32.0884368,0.0229181,11.0825589,6.7424101,15.4656531,3.7022585,5.7945011,0.1319904,15.901929),(46310,'metacarpal.tif',230,5,77,12.992322,6.2937542,6.5594919,1.8,6.2923844,6.5601127,-0.110577,1.8943628,2.8770295,12.4750449,31.1527645,0.0263688,10.8281004,6.5853516,15.1474354,3.687065,5.7420452,0.1440176,15.7657548),(46311,'metacarpal.tif',230,5,78,12.9219385,6.3140155,6.5717708,1.8,6.3145797,6.5715868,-0.1181473,1.895018,2.8578064,12.2110983,30.2990314,0.0299227,10.6021988,6.4437901,14.838481,3.6654,5.6966,0.1757979,15.6092014),(46312,'metacarpal.tif',230,5,79,12.822022,6.3387231,6.5810035,1.8,6.3395094,6.5806743,-0.1236324,1.8949049,2.8396099,11.9793595,29.4974167,0.0324978,10.3878412,6.3218791,14.5922216,3.6654,5.6481648,0.1773214,15.5749238),(46313,'metacarpal.tif',230,5,80,12.7322355,6.3608678,6.5913166,1.8,6.3617425,6.5911571,-0.1292637,1.8920737,2.8271112,11.750761,28.7625859,0.0352603,10.1738431,6.2105196,14.3209174,3.6620146,5.6175461,0.1583093,15.4429704),(46314,'metacarpal.tif',230,5,81,12.6677737,6.3829983,6.6001925,1.8,6.3836011,6.6000718,-0.134375,1.8830997,2.8134469,11.5227941,28.1238319,0.037894,9.9962193,6.1190568,14.0722688,3.6531,5.5954186,0.1745449,15.3505393),(46315,'metacarpal.tif',230,5,82,12.6329188,6.4042858,6.6097173,1.8,6.4049094,6.6097946,-0.1387237,1.8791093,2.7979774,11.32928,27.573657,0.0402593,9.8548535,6.0290691,13.8877527,3.6531,5.5613549,0.1509678,15.3073083),(46316,'metacarpal.tif',230,5,83,12.6527274,6.4250268,6.6181227,1.8,6.4251448,6.6185359,-0.1436161,1.8795285,2.7945846,11.1615794,27.1395044,0.0431968,9.711463,5.9384997,13.7051443,3.6408,5.5457862,0.1312325,15.2335083),(46317,'metacarpal.tif',230,5,84,12.6683817,6.4446696,6.6259716,1.8,6.4449341,6.6261314,-0.1480134,1.8731907,2.8007023,11.0176603,26.7003754,0.0459198,9.5334573,5.8817612,13.4671836,3.6405183,5.537036,0.151636,15.1800876),(46318,'metacarpal.tif',230,5,85,12.6451714,6.462963,6.6338257,1.8,6.4629786,6.6343109,-0.151786,1.8662382,2.7801197,10.8726078,26.2326436,0.0481837,9.4357966,5.8259485,13.3465438,3.6285,5.5029408,0.123246,15.0553393),(46319,'metacarpal.tif',230,5,86,12.6418454,6.4803501,6.6416665,1.8,6.4807104,6.6417036,-0.1549619,1.8527161,2.7690369,10.7436116,25.8415897,0.0501916,9.3323384,5.7988439,13.2032201,3.6162,5.4859793,0.1644115,15.0295031),(46320,'metacarpal.tif',230,5,87,12.6673772,6.4986038,6.6479414,1.8,6.4990559,6.6479607,-0.1590471,1.8449805,2.7625994,10.6274265,25.5650181,0.052957,9.2539722,5.7601835,13.0945087,3.6097306,5.4689098,0.1854861,14.9641445),(46321,'metacarpal.tif',230,5,88,12.6775077,6.5145326,6.6541952,1.8,6.5153559,6.6545831,-0.1633179,1.836867,2.7563785,10.5114755,25.3383381,0.0558581,9.1926194,5.7225022,13.0033699,3.5948203,5.4501215,0.1792479,14.942529),(46322,'metacarpal.tif',230,5,89,12.6637472,6.5360016,6.6575064,1.8,6.5346869,6.6586945,-0.1640152,1.8321208,2.7459885,10.4010594,25.0184555,0.0562708,9.1109104,5.6770597,12.8971087,3.5848573,5.4436637,0.172578,15.1525031),(46323,'metacarpal.tif',230,5,90,12.6637772,6.5531328,6.661152,1.8,6.5520221,6.6626033,-0.167861,1.8213999,2.7641111,10.2911018,24.8713079,0.0589156,8.9979409,5.6501055,12.7205311,3.5679623,5.4516203,0.1677451,15.3438462),(46324,'metacarpal.tif',230,5,91,12.6842726,6.5675678,6.6635457,1.8,6.5649523,6.6658027,-0.1740004,1.8107931,2.7661212,10.2018006,24.730996,0.0633619,8.9406769,5.6338854,12.627499,3.5509951,5.443622,0.1588338,14.9484979),(46325,'metacarpal.tif',230,5,92,12.7138848,6.581872,6.6647796,1.8,6.580038,6.6663219,-0.1803277,1.7958338,2.7563756,10.101143,24.6191971,0.0681617,8.9317281,5.6247649,12.5956655,3.527806,5.4253179,0.1662668,14.8831393),(46326,'metacarpal.tif',230,5,93,12.7466223,6.5959221,6.6646694,1.8,6.5948616,6.66557,-0.1838626,1.7876492,2.7424215,10.0208795,24.4624731,0.071012,8.9200267,5.6056186,12.5701087,3.509889,5.4107838,0.1898166,14.844129),(46327,'metacarpal.tif',230,5,94,12.7253119,6.6116618,6.6627906,1.8,6.6110347,6.6634545,-0.1875535,1.7776766,2.7414489,9.9139315,24.332059,0.0737341,8.8756201,5.576904,12.4838761,3.4812132,5.4039431,0.1831108,14.8615238),(46328,'metacarpal.tif',230,5,95,12.646993,6.6256279,6.6589852,1.8,6.625231,6.6596996,-0.1912505,1.7639081,2.7336455,9.801518,24.2296509,0.0761622,8.8634942,5.5567056,12.4445105,3.4579286,5.3961685,0.1996307,14.8093393),(46329,'metacarpal.tif',230,5,96,12.5732371,6.6388595,6.6550728,1.8,6.6390135,6.6558514,-0.1953893,1.7469016,2.7293822,9.7162063,24.098953,0.0789884,8.8294533,5.5619653,12.3526256,3.4404711,5.3855743,0.1490029,14.78896),(46330,'metacarpal.tif',230,5,97,12.4922304,6.65043,6.6511001,1.8,6.6500799,6.6521093,-0.1985779,1.7397716,2.7263528,9.6456568,23.8865462,0.0810279,8.7613555,5.5442087,12.2701404,3.4231121,5.3769011,0.1933579,14.7715652),(46331,'metacarpal.tif',230,5,98,12.4123804,6.6633665,6.6471408,1.8,6.6632584,6.6481921,-0.2016881,1.7421503,2.7194101,9.5962616,23.7547291,0.0830171,8.7352506,5.5082857,12.2225224,3.4193859,5.365423,0.182109,14.7134117),(46332,'metacarpal.tif',230,5,99,12.3395356,6.6779288,6.6403831,1.8,6.6776365,6.6415528,-0.2049015,1.7453519,2.7060158,9.5562454,23.6012026,0.0851435,8.7217533,5.4752544,12.1888833,3.4120416,5.3546267,0.1708133,14.73976),(46333,'metacarpal.tif',230,5,100,12.2995481,6.6914342,6.6331799,1.8,6.6910621,6.634061,-0.2073186,1.7531612,2.6902952,9.5295857,23.4863834,0.0868527,8.7300396,5.4356585,12.2105517,3.414471,5.3390077,0.1806777,14.6990014),(46334,'metacarpal.tif',230,5,101,12.3031318,6.7036711,6.6238537,1.8,6.7032158,6.6251574,-0.2105373,1.7632198,2.6756074,9.5216875,23.4008222,0.0895562,8.7459849,5.4001706,12.2299285,3.4195843,5.3239112,0.1905991,14.7193807),(46335,'metacarpal.tif',230,5,102,12.3180623,6.7149579,6.6144242,1.8,6.7139738,6.6159166,-0.2129559,1.773272,2.6697672,9.5450689,23.327269,0.0917054,8.7375668,5.3827438,12.2448901,3.4302423,5.317044,0.1837848,14.7163962),(46336,'metacarpal.tif',230,5,103,12.3396393,6.7259954,6.6047986,1.8,6.7248715,6.6060122,-0.2170869,1.7883989,2.665313,9.571144,23.3131443,0.0954081,8.7468693,5.3517948,12.2639332,3.4421564,5.3165603,0.1955807,14.7295704),(46337,'metacarpal.tif',230,5,104,12.3895214,6.7373332,6.5949322,1.8,6.7364497,6.5959485,-0.2219931,1.8022603,2.6627682,9.6297496,23.3998884,0.1001004,8.7878053,5.3431515,12.3076716,3.4515193,5.3148099,0.1815095,14.6990014),(46338,'metacarpal.tif',230,5,105,12.4389127,6.7459199,6.5849762,1.8,6.7454117,6.5853614,-0.2271078,1.8180827,2.6626591,9.7004254,23.4954254,0.1051029,8.8240457,5.3355249,12.3786302,3.4636676,5.3189643,0.1978491,14.7367755),(46339,'metacarpal.tif',230,5,106,12.5003269,6.7532091,6.5734103,1.8,6.7532454,6.5741178,-0.2310826,1.8363574,2.6551922,9.8043012,23.6104504,0.1092847,8.8921814,5.3389939,12.4368453,3.477685,5.3118344,0.1910378,14.7236014),(46340,'metacarpal.tif',230,5,107,12.5717926,6.7599586,6.5603668,1.8,6.7597581,6.5608746,-0.2340323,1.8561146,2.6513238,9.9401936,23.7703159,0.1126816,8.9654518,5.355377,12.4841687,3.4928593,5.3126034,0.1792323,14.7817548),(46341,'metacarpal.tif',230,5,108,12.6515642,6.7661232,6.5477838,1.8,6.7658866,6.5480884,-0.2367969,1.8745073,2.6472748,10.1156685,23.9397671,0.1160407,9.043174,5.3964413,12.5889312,3.5075663,5.3148099,0.1815095,14.8339393),(46342,'metacarpal.tif',230,5,109,12.7948358,6.7712057,6.5343043,1.8,6.7708416,6.5343779,-0.2386206,1.9043539,2.6498368,10.3326408,24.177611,0.1191347,9.1241888,5.4257986,12.714556,3.5356345,5.3222059,0.1624891,14.8585393),(46343,'metacarpal.tif',230,5,110,12.9374754,6.7776933,6.5175278,1.8,6.7773046,6.517223,-0.2381124,1.925408,2.6632199,10.5748733,24.5586255,0.1199599,9.2214036,5.4922766,12.8523223,3.5645629,5.3525496,0.1685487,14.9455135),(46344,'metacarpal.tif',230,5,111,13.1053948,6.7836034,6.4989121,1.8,6.7834831,6.4986339,-0.2389234,1.9591778,2.6747883,10.8817369,24.9971414,0.1223302,9.3454655,5.5542366,13.0312987,3.6028399,5.3727493,0.1632669,15.0324876),(46345,'metacarpal.tif',230,5,112,13.2250466,6.7930649,6.4757933,1.8,6.7917498,6.4758656,-0.2382842,1.9918029,2.6731915,11.226802,25.4689591,0.1228002,9.5275476,5.6365024,13.2797939,3.6425268,5.3718481,0.1308871,15.090129),(46346,'metacarpal.tif',230,5,113,13.3623183,6.8008298,6.4536665,1.8,6.8001473,6.4529437,-0.237913,2.0285455,2.6876811,11.6393054,26.0666791,0.1236958,9.698576,5.737759,13.5878964,3.6896966,5.3873017,0.1351164,15.2173497),(46347,'metacarpal.tif',230,5,114,13.5803616,6.8048988,6.4311609,1.8,6.8039837,6.4298565,-0.2380417,2.0732381,2.7060516,12.0813459,26.8680587,0.1258479,9.9288789,5.8272834,13.9597381,3.7407317,5.4156468,0.2058586,15.3907859),(46348,'metacarpal.tif',230,5,115,13.8393872,6.806648,6.4074603,1.8,6.8052947,6.4054786,-0.236632,2.0975744,2.7143695,12.5794762,27.7635997,0.1267625,10.228379,5.9971537,14.364844,3.7791212,5.45384,0.1562501,15.6211393),(46349,'metacarpal.tif',230,5,116,14.1092863,6.8084178,6.3832322,1.8,6.8065752,6.3806269,-0.2329128,2.1272192,2.7340236,13.1040424,28.7573763,0.1252774,10.5183352,6.1601749,14.7676846,3.8145119,5.4930484,0.3401621,15.7513445),(46350,'metacarpal.tif',230,5,117,14.3711336,6.8131135,6.3565854,1.8,6.8114048,6.3545195,-0.2256948,2.1412846,2.7695564,13.6983812,29.7977254,0.119949,10.7590246,6.3972726,15.1950448,3.8388809,5.5516074,0.301431,15.9409393),(46351,'metacarpal.tif',230,5,118,14.643888,6.8202428,6.3299407,1.8,6.8181077,6.3279744,-0.2205458,2.1616395,2.8047074,14.349422,30.983409,0.1168021,11.0469309,6.6382125,15.7050853,3.8722605,5.6058996,0.3030158,16.1191083),(46352,'metacarpal.tif',230,5,119,14.9341758,6.8271311,6.3038421,1.8,6.8234487,6.3016249,-0.2158714,2.173053,2.8305604,15.0143912,32.2875979,0.1141998,11.4067864,6.9093533,16.2384685,3.8968578,5.6610074,0.2977002,16.2739135),(46353,'metacarpal.tif',230,5,120,15.2766476,6.8350187,6.2753568,1.8,6.8309139,6.2731304,-0.2135198,2.2134214,2.8504898,15.8371873,33.6590996,0.1143262,11.8081811,7.1550709,16.7916267,3.9502396,5.7140881,0.2836219,16.5144565),(46354,'metacarpal.tif',230,5,121,15.6390881,6.8418348,6.245398,1.8,6.836744,6.2430489,-0.2136882,2.2697769,2.8776254,16.7798044,35.2898956,0.1172207,12.2635477,7.3927109,17.4573836,4.0434465,5.7583445,0.2283999,16.7609686),(46355,'metacarpal.tif',230,5,122,15.9809008,6.8513788,6.2112951,1.8,6.8441331,6.2066044,-0.2113814,2.3202965,2.8998685,17.758131,36.8590858,0.1172488,12.7106058,7.6533888,18.1519204,4.1354642,5.8135427,0.2023748,17.0375376),(46356,'metacarpal.tif',230,5,123,16.3472626,6.8670427,6.1819483,1.8,6.8584618,6.1759915,-0.2144285,2.3560109,2.9641598,18.967783,38.6770912,0.1233657,13.0482475,8.0508045,18.9022659,4.2050509,5.9147143,0.1692512,17.2954755),(46357,'metacarpal.tif',230,5,124,16.7802641,6.8969584,6.1450564,1.8,6.8886893,6.1406639,-0.2206107,2.4096034,3.020574,20.2575369,40.8279573,0.13392,13.5166221,8.4070006,19.594682,4.3125589,5.9838457,0.2983478,17.7375513),(46358,'metacarpal.tif',230,5,125,17.2360337,6.9402719,6.1112891,1.8,6.9316306,6.1059443,-0.2348611,2.4601944,3.0921989,21.487453,43.5365483,0.1555639,14.0794787,8.7340469,20.3642993,4.4051323,6.1785313,0.3879,18.0789669),(46359,'metacarpal.tif',230,5,126,17.6412621,6.981446,6.0794213,1.8,6.9700565,6.072343,-0.2509175,2.5057687,3.1587573,22.8640741,45.8561391,0.1812619,14.5171452,9.1245748,21.0551803,4.4752066,6.2655311,0.3695699,18.4310841),(46360,'metacarpal.tif',230,5,127,18.1174751,7.0221352,6.0447621,1.8,7.0125076,6.0358876,-0.2629109,2.5621821,3.2343472,24.5640778,48.4775506,0.2039546,14.9883571,9.587171,21.8955846,4.585742,6.3202973,0.3703875,18.9211237),(46361,'metacarpal.tif',230,5,128,18.6059966,7.0744512,6.0062984,1.8,7.0666862,5.9939623,-0.2810608,2.5992625,3.3072837,26.4961539,51.3375433,0.2385811,15.52257,10.19372,22.9457386,4.685712,6.4479458,0.2250831,19.5396202),(46362,'metacarpal.tif',230,5,129,19.1228209,7.1495986,5.956059,1.8,7.1388182,5.9431632,-0.2987639,2.6352844,3.4162543,28.8468893,54.878719,0.2761191,16.0640031,10.9464045,23.8813175,4.7551818,6.5346232,0.2239772,19.3890358),(46363,'metacarpal.tif',230,5,130,19.4272513,7.209148,5.9130261,1.8,7.1989705,5.8974976,-0.3237286,2.6618122,3.5388605,31.1986236,57.4561426,0.3276402,16.2357751,11.7208209,24.6302555,4.8532884,6.6200058,0.2134292,20.0627013),(46364,'metacarpal.tif',230,5,131,19.5986247,7.2583522,5.889591,1.8,7.2469622,5.8728665,-0.3275805,2.743271,3.6298631,33.4706819,59.3841913,0.3381578,16.3598983,12.2010117,25.3037562,4.9977073,6.6846511,0.1869304,20.503753),(46365,'metacarpal.tif',230,5,132,19.7385012,7.2898501,5.8826771,1.8,7.2852284,5.8670359,-0.317478,2.8302117,3.7040803,36.1002025,60.9351687,0.320589,16.4508227,12.7553013,25.9742593,5.1344231,6.7619579,0.1681391,21.4569719),(46366,'metacarpal.tif',230,5,133,19.8151466,7.2975063,5.8816673,1.8,7.2992468,5.8653212,-0.3296848,2.8959125,3.8177623,38.5059985,62.1147015,0.3461395,16.2699238,13.2966721,26.2164934,5.2556117,6.8671132,0.1619096,21.9045047),(46367,'metacarpal.tif',230,5,134,19.8597536,7.2765636,5.8913521,1.8,7.2877661,5.8722677,-0.3680797,2.9390019,3.8900162,40.9077284,63.3124326,0.428552,16.275622,13.9189189,26.7606061,5.3692044,6.9603764,0.1561425,22.2854426),(46368,'metacarpal.tif',230,5,135,20.0417361,7.2555837,5.9126888,1.8,7.2678757,5.8963152,-0.4119839,3.1191173,3.9343576,43.8361739,65.0054307,0.5355902,16.5225017,14.0540318,27.6638743,5.5105943,7.0383519,0.0279647,22.5091029),(46369,'metacarpal.tif',230,5,136,20.3618717,7.2447963,5.9409478,1.8,7.2625634,5.9279503,-0.4616589,3.3088951,3.9665518,47.0779252,67.5875916,0.6733376,17.0393821,14.2276874,28.8601673,5.6881981,7.0998281,3.1138701,22.8917891),(46370,'metacarpal.tif',230,5,137,20.6151226,7.2483532,5.9446481,1.8,7.263447,5.9325693,-0.5255103,3.5196302,4.0205941,49.8338395,69.4258015,0.8646576,17.2675481,14.1588282,29.5786846,5.8548,7.1616532,3.1123913,23.7297253),(46371,'metacarpal.tif',230,5,138,20.870136,7.2495649,5.9579722,1.8,7.2678999,5.9507257,-0.5816624,3.6647489,4.0760508,53.2680247,70.9888156,1.0499606,17.4160772,14.5352455,30.4431527,5.9599869,7.2031598,3.0954715,24.4858443),(46372,'metacarpal.tif',230,5,139,21.163127,7.2610762,5.9871746,1.8,7.2750414,5.9779986,-0.6301024,3.7584227,4.1290488,57.0916562,72.8138772,1.2246011,17.6345404,15.1903234,31.2558575,6.0824499,7.2850897,0.8475191,24.5109563),(46373,'metacarpal.tif',230,5,140,21.454635,7.2561443,6.0135597,1.8,7.2728139,6.0041193,-0.6956055,3.8209177,4.1300803,59.4223329,75.3184367,1.4685311,18.2365552,15.5518485,31.7708458,6.1913655,7.366016,0.8527517,23.9699684),(46374,'metacarpal.tif',230,5,141,21.6464071,7.2583583,6.0196442,1.8,7.2821695,6.0057474,-0.765525,3.8651327,4.0841957,61.0394094,76.9362549,1.7321888,18.8375535,15.7923191,32.2883166,6.2924649,7.4297905,0.8580401,24.4798753),(46375,'metacarpal.tif',230,5,142,21.7156991,7.2400488,6.0102877,1.8,7.2604136,6.0013908,-0.8480486,3.8952683,3.9891557,61.2937443,78.5706684,2.0357981,19.6960644,15.7354359,32.6969372,6.3568416,7.482172,0.8726904,24.3024305),(46376,'metacarpal.tif',230,5,143,21.6441972,7.2245811,5.9925215,1.8,7.2519281,5.9873664,-0.9212677,3.9046069,3.8872056,60.7422895,79.0631944,2.2878039,20.3393395,15.5565699,32.7278332,6.4134891,7.5104771,0.8758484,24.3456615),(46377,'metacarpal.tif',230,5,144,21.5335415,7.2254259,5.9636955,1.8,7.2497559,5.960791,-0.9679313,3.8807057,3.8311118,60.3521833,79.7467528,2.4351045,20.8155638,15.551858,32.7309889,6.3765514,7.5483327,0.8800221,24.3036667),(46378,'metacarpal.tif',230,5,145,21.5329372,7.2269755,5.937666,1.8,7.2570304,5.9431202,-1.005211,3.8461173,3.8024029,59.950156,81.0825854,2.5581139,21.3240386,15.5871887,32.8016211,6.341563,7.6114046,0.8700577,24.2713495),(46379,'metacarpal.tif',230,5,146,21.4873804,7.2301049,5.9074922,1.8,7.2590194,5.9078183,-1.0238281,3.8205705,3.821476,59.3597705,82.079028,2.6124919,21.4783577,15.5368866,32.6597877,6.3032374,7.6916317,0.8725773,24.3391805),(46380,'metacarpal.tif',230,5,147,21.5569408,7.2291129,5.8970024,1.8,7.2564147,5.9009094,-1.0414019,3.7958165,3.814039,59.4977121,83.1928785,2.6765244,21.812278,15.6745491,32.9729217,6.2903999,7.7164244,0.8938149,24.3739702),(46381,'metacarpal.tif',230,5,148,21.4072273,7.2258273,5.8805056,1.8,7.2502854,5.8836352,-1.0403712,3.8033373,3.8541968,58.641721,83.5530802,2.6547283,21.6784678,15.4184907,32.7833541,6.280071,7.7343531,0.9218881,25.1520046),(46382,'metacarpal.tif',230,5,149,21.1790923,7.2281428,5.8506344,1.8,7.2465983,5.8623945,-1.041174,3.7990108,3.8672057,58.1284799,83.011309,2.6289091,21.4654498,15.3009516,32.4754895,6.2578837,7.7073217,0.9212308,25.1629185),(46383,'metacarpal.tif',230,5,150,20.9180064,7.235214,5.8005249,1.8,7.2522557,5.8170723,-1.0189747,3.8255282,3.9537009,57.4456078,80.9535971,2.5281957,20.4753972,15.0163859,31.3712441,6.2464668,7.6972649,0.8918128,26.0483064),(46384,'metacarpal.tif',230,5,151,20.6576724,7.2440739,5.7600394,1.8,7.2618923,5.7823299,-0.9831799,3.8258019,4.0623257,56.1898929,78.5731074,2.3848043,19.3419025,14.6870889,30.2480562,6.1849205,7.7087251,0.8950586,25.8544908),(46385,'metacarpal.tif',230,5,152,20.5023239,7.252391,5.7306912,1.8,7.2666022,5.7446531,-0.9603762,3.795979,4.1180412,54.9945504,76.4001923,2.2943064,18.5525565,14.4875801,29.3861211,6.1246731,7.6884839,0.9112966,25.1035288),(46386,'metacarpal.tif',230,5,153,20.6095824,7.2516833,5.6940424,1.8,7.2601786,5.7159854,-0.9419929,3.7369141,4.1185373,54.1062971,74.1028804,2.2466066,17.9925238,14.4788709,28.7500092,6.0324585,7.6284695,0.770576,24.5503909),(46387,'metacarpal.tif',230,5,154,20.6356372,7.2578559,5.6664233,1.8,7.2608458,5.675875,-0.8982621,3.6864934,4.170532,52.7444468,71.3995398,2.1045182,17.1200077,14.3074843,27.9012036,5.9674975,7.5854211,0.7670516,24.342165),(46388,'metacarpal.tif',230,5,155,20.5721591,7.2711828,5.6425707,1.8,7.2737467,5.6427834,-0.8313206,3.6263192,4.2476614,51.0169068,68.2450513,1.8715794,16.0664997,14.0685098,26.8619029,5.8955802,7.5248762,0.8838017,24.0805185),(46389,'metacarpal.tif',230,5,156,20.3460508,7.2880201,5.6112119,1.8,7.2824898,5.6090434,-0.7265886,3.5557757,4.3332104,49.1143971,65.302928,1.4965402,15.0703339,13.8125691,25.8619259,5.8220389,7.4351643,0.8673737,23.2987754),(46390,'metacarpal.tif',230,5,157,20.361091,7.309734,5.5720708,1.8,7.3018182,5.5737643,-0.6156011,3.4551766,4.3186124,47.0323383,63.8703412,1.1315599,14.7895517,13.6121374,25.5605848,5.7462128,7.3094089,0.6828879,22.8997185),(46391,'metacarpal.tif',230,5,158,20.3198974,7.3168906,5.5125694,1.8,7.3014198,5.5080939,-0.5407559,3.3509186,4.2965084,44.5488756,62.884473,0.8974717,14.6361806,13.2945265,25.0025785,5.678025,7.2420161,0.6795154,22.6567029),(46392,'metacarpal.tif',230,5,159,20.0117055,7.313807,5.439197,1.8,7.2871387,5.4484719,-0.4982716,3.2609146,4.2637139,40.9630737,61.4269093,0.7617657,14.4069023,12.5618359,24.0076996,5.5828542,7.1721763,0.6246354,22.5138357),(46393,'metacarpal.tif',230,5,160,19.7184431,7.2899124,5.3511992,1.8,7.2605231,5.3578458,-0.4705304,3.1811353,4.2223287,37.3422858,59.7003975,0.67547,14.1392111,11.7386661,22.950612,5.4749036,7.1641878,0.5960977,22.2270771),(46394,'metacarpal.tif',230,5,161,19.4164129,7.2513617,5.264869,1.8,7.2256,5.2568787,-0.4549451,3.0865549,4.1614418,32.9550207,57.8327428,0.6248323,13.8972852,10.6769591,21.7412413,5.3677924,7.1236117,0.5750723,21.8732116),(46395,'metacarpal.tif',230,5,162,18.7807746,7.205045,5.1879425,1.8,7.1905346,5.1769458,-0.4489572,2.9601569,4.0754072,28.5792534,55.512659,0.5896499,13.6213773,9.6546416,20.5058327,5.2911085,7.0866149,0.5701903,21.5720426),(46396,'metacarpal.tif',230,5,163,17.9322237,7.1603212,5.1021161,1.8,7.1480502,5.1111784,-0.4471117,2.7991163,3.9996521,24.8628527,52.4566656,0.5587013,13.1153072,8.8823936,19.1906274,5.1446127,7.0459141,0.5511975,21.0718133),(46397,'metacarpal.tif',230,5,164,17.1241202,7.1088937,5.0152714,1.8,7.0920525,5.024086,-0.4450808,2.6375082,3.8970525,21.2958994,48.9796813,0.529012,12.5683914,8.0742495,17.8450978,4.814061,6.978253,0.5488836,20.4394185),(46398,'metacarpal.tif',230,5,165,16.0239552,7.0250397,4.9216397,1.8,7.027904,4.9218311,-0.459209,2.4812799,3.7663521,17.0659922,45.1775737,0.5246804,11.9950477,6.8778989,16.3200064,4.4826497,6.8791317,0.5493122,20.092034),(46399,'metacarpal.tif',230,5,166,14.7809691,6.9207341,4.816333,1.8,6.9443905,4.8084058,-0.4881378,2.301432,3.6487676,13.0474642,40.4952012,0.5418313,11.098323,5.6692808,14.4909575,4.0445878,6.7564069,0.5647745,19.0093341),(46400,'metacarpal.tif',230,5,167,13.3278741,6.7777014,4.721692,1.8,6.7985552,4.720777,-0.5202344,2.0738874,3.4771039,9.5786655,35.3860533,0.5488686,10.1768754,4.6187008,12.758068,3.5871656,6.5659423,0.6150231,18.5059082),(46401,'metacarpal.tif',230,5,168,11.5932932,6.5741079,4.6440331,1.8,6.6038096,4.6390976,-0.5645166,1.7439262,3.227399,6.4489121,29.2297303,0.5530639,9.0567452,3.6979271,10.9192351,3.2408259,6.2706963,0.6364396,17.7248893),(46402,'metacarpal.tif',230,5,169,9.8509575,6.3471705,4.6014337,1.8,6.3749093,4.5914065,-0.6130975,1.5036924,2.9712068,4.2672563,22.2037081,0.5435909,7.4729594,2.8378518,8.8383535,2.8107588,5.9064851,0.6405857,16.1166359),(46403,'metacarpal.tif',230,5,170,7.8579025,6.120209,4.5952009,1.8,6.1530257,4.5806479,-0.6610183,1.3024961,2.8716736,2.5412345,15.0574789,0.4936058,5.2434507,1.9510496,6.0601803,2.4668716,5.4708459,0.6722831,14.3930997),(46404,'metacarpal.tif',230,5,171,5.5483925,5.8954528,4.655729,1.8,5.9376749,4.6254363,-0.6772969,1.1144569,2.8607337,1.2958082,8.8999327,0.3631783,3.1110664,1.1627261,3.5530791,2.1206003,5.0316773,0.6919214,13.4878445),(46405,'metacarpal.tif',230,5,172,2.9209888,5.4544789,4.9147789,1.8,5.5340697,4.8702005,-0.7129348,0.8920638,3.0891278,0.4847834,2.3240685,0.2082617,0.7523381,0.5434403,0.9040148,1.6887062,2.4552291,0.8811895,7.0290826),(46406,'metacarpal.tif',230,5,173,1.1593326,5.2004593,5.001052,1.8,5.2099115,5.0111779,-1.043826,0.6058106,0.8814881,0.0823625,0.1483207,0.1443513,0.1682618,0.1359542,0.2610865,1.1892008,1.63553,1.0600455,5.001905),(46407,'metacarpal.tif',230,5,174,0.0574565,5.097602,5.1025271,1.8,5.0992791,5.1062067,0.5430614,0.3036957,0.4096414,0.0007313,0.0012478,0.0025572,0.0030461,0.0024079,0.0047571,0.5155,0.6268175,2.863293,3.1337534),(46408,'metacarpal.tif',230,5,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46409,'metacarpal.tif',230,5,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46410,'metacarpal.tif',230,5,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46411,'metacarpal.tif',230,5,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46412,'metacarpal.tif',230,5,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46413,'metacarpal.tif',230,5,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46414,'metacarpal.tif',230,5,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46415,'metacarpal.tif',230,5,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46416,'metacarpal.tif',230,5,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46417,'metacarpal.tif',230,5,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46418,'metacarpal.tif',230,5,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46419,'metacarpal.tif',230,5,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46420,'femur.tif',230,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46421,'femur.tif',230,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46422,'femur.tif',230,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46423,'femur.tif',230,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46424,'femur.tif',230,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46425,'femur.tif',230,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46426,'femur.tif',230,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46427,'femur.tif',230,7,8,2.4215096,25.1433378,30.784582,1.8,25.1501337,30.7788977,-1.3186142,1.6743743,2.1013664,1.5970972,2.5665835,0.3784581,1.2213879,0.9538472,1.9701998,3.4368871,4.3173003,1.1760052,12.8013058),(46428,'femur.tif',230,7,9,34.8435755,25.1137745,30.5253894,1.8,25.0342885,30.5343763,-0.0463391,3.2712331,5.2992016,82.7549766,231.155245,0.0124611,43.6207682,25.2977924,58.9559538,6.3099005,10.3331209,0.0858103,27.8277377),(46429,'femur.tif',230,7,10,67.9989283,25.2588468,32.7317349,1.8,25.172661,33.7610005,-1.3986995,8.3584353,16.8718795,1088.2684523,2461.1803399,11.0007977,145.874699,130.2000213,209.6396441,9.3543984,16.2352045,0.1505757,42.5188108),(46430,'femur.tif',230,7,11,127.803626,25.5967167,36.8570394,1.8,25.3992337,36.2886138,-1.483241,10.6499817,14.4139514,3116.4682961,9159.730786,21.1377321,635.4767342,292.6266343,842.844078,11.7423492,20.6964612,0.1449228,54.2131166),(46431,'femur.tif',230,7,12,176.3491791,25.7826529,37.994768,1.8,25.4913507,37.7034099,-1.454817,12.4602193,14.7769149,6297.3870214,13534.8274914,28.9979482,915.9440628,505.3993749,1173.7902359,23.3857768,31.8487213,0.8813985,109.9852503),(46432,'femur.tif',230,7,13,220.2046768,26.262883,38.9322712,1.8,25.8458265,38.6889593,-1.5055824,13.7471234,16.7105733,10824.049314,18785.7713772,36.5449177,1124.1847319,787.3683092,1559.0356902,26.4292219,34.7021131,0.8237541,123.8620873),(46433,'femur.tif',230,7,14,261.6362097,26.9888637,39.5130996,1.8,26.401161,39.2947059,1.5339303,14.7598649,18.1731708,16435.1744559,24350.8748389,43.5467969,1339.935394,1113.5043938,2008.1075919,28.8209147,37.6746137,2.2583865,135.1914744),(46434,'femur.tif',230,7,15,292.1848396,27.646186,39.7786433,1.8,26.9560869,39.7835139,1.4679751,16.8397037,19.6660867,21846.1778863,28725.0411146,48.1844449,1460.638385,1297.3017984,2350.7478666,30.711511,39.9567229,2.2580853,144.510618),(46435,'femur.tif',230,7,16,314.5546064,28.07493,40.028235,1.8,27.2797017,40.0276709,1.4761503,17.9646369,20.0978042,26560.4344493,32804.4634609,51.9575446,1632.2411705,1478.4843451,2681.9396164,32.280573,41.1363375,2.2800064,148.166977),(46436,'femur.tif',230,7,17,330.0234854,28.4866007,40.2115119,1.8,27.6192421,40.1809992,1.4737197,19.0209695,20.0522841,31109.9035348,36580.572393,54.4871905,1824.2596313,1635.5582508,2974.6389581,33.586974,42.7092625,2.4332475,152.4921445),(46437,'femur.tif',230,7,18,343.2556582,28.805635,40.2587814,1.8,27.8694052,40.2687133,1.5650625,19.3234077,19.3930435,35431.9531039,39674.6330277,57.2073957,2045.8177751,1833.628603,3229.2623476,35.0832356,44.3791073,2.4391892,157.421274),(46438,'femur.tif',230,7,19,351.5382949,29.0631769,40.2463977,1.8,28.084645,40.3705455,-1.4189598,20.598901,21.1276936,38153.5674619,42024.8445311,57.2493173,1989.0881313,1852.2137392,3359.2013114,36.114446,45.3748517,2.4321725,160.180907),(46439,'femur.tif',230,7,20,355.9021877,29.2437234,40.1647295,1.8,28.2837249,40.4123106,-1.2953695,21.7005838,22.080705,40354.7570514,43415.3263123,54.9298857,1966.2110612,1859.6161953,3461.9182075,36.8538757,45.979432,2.4465461,300.9239069),(46440,'femur.tif',230,7,21,364.6402811,29.2938256,40.1668822,1.8,28.3625982,40.5123705,-1.1442422,22.4557379,23.0151603,42207.1401028,44434.9977933,50.3703394,1930.6838262,1879.5703925,3564.5419587,37.1936531,46.2912703,2.4459358,158.8478984),(46441,'femur.tif',230,7,22,367.3434208,29.2323776,40.2280895,1.8,28.3572553,40.6620892,-0.996738,23.3728047,23.5026598,42966.3984562,45068.999014,43.1691515,1917.612701,1838.307342,3631.6560008,37.460324,46.2985497,2.4646112,158.6264984),(46442,'femur.tif',230,7,23,371.7250567,29.1620292,40.4515815,1.8,28.2798096,40.863032,-0.9953231,23.133184,23.604908,42082.6247453,46000.4827082,43.6040744,1948.7677187,1819.1453771,3663.3588568,37.4130874,46.1779614,2.4717188,155.3008896),(46443,'femur.tif',230,7,24,366.7621988,29.1202362,40.6697408,1.8,28.329691,41.0364413,-1.1375079,22.9945257,23.087997,40928.1824484,46394.752499,50.3515351,2009.4749882,1779.9098382,3708.8631885,37.2136757,45.836354,2.4811849,153.5676757),(46444,'femur.tif',230,7,25,364.4784766,28.9500326,40.716717,1.8,28.0877382,41.0442346,-1.2821441,22.6035101,22.0093421,39583.5812533,46697.586236,55.8240362,2121.7165838,1751.2139101,3726.5218641,36.6417027,45.1677739,2.4882879,150.020667),(46445,'femur.tif',230,7,26,355.9436857,28.4317075,40.6979734,1.8,27.486225,40.7975055,-1.332749,21.8786142,21.5004351,37480.8568307,46015.6931696,56.025284,2140.2214832,1713.1275532,3639.2619806,35.7158811,43.9828839,2.4739271,147.5092943),(46446,'femur.tif',230,7,27,321.6211469,26.7859862,39.7417953,1.8,26.0343898,39.8437538,-1.031236,20.1421316,22.2882824,28423.926638,40567.2878124,39.4549771,1820.1172784,1411.1677534,3075.6848032,34.3608471,42.3044973,0.7446799,150.119682),(46447,'femur.tif',230,7,28,290.6959822,24.9926603,39.721027,1.8,24.5240914,39.72234,-1.1403466,18.3136346,21.4602111,21769.2465068,34381.0891346,40.0132256,1602.0853184,1188.6906645,2527.6367643,32.6945192,40.8152897,0.7451129,137.7788195),(46448,'femur.tif',230,7,29,269.5965807,23.801623,39.789598,1.8,23.4189803,39.7056516,-1.2385708,16.7834284,20.5583173,17547.9004902,29703.0635636,40.1531631,1444.8197843,1045.5492183,2177.511734,29.258147,39.0733395,0.8114444,119.8427186),(46449,'femur.tif',230,7,30,243.9686622,22.4368736,40.2678904,1.8,22.0864627,40.1006774,-1.3865567,14.4520825,18.745015,14277.732518,23268.5010799,39.2967679,1241.3167464,987.9359949,1756.4642095,27.4690597,33.6617229,0.904273,107.8871177),(46450,'femur.tif',230,7,31,229.8772326,21.7310358,40.3429691,1.8,21.3154219,40.2583826,-1.3945298,13.2799199,16.8223509,12287.3873553,20474.4316669,37.1347726,1217.0969285,925.2606528,1904.9268079,26.0343224,31.9532079,1.0404775,100.1177742),(46451,'femur.tif',230,7,32,219.8938652,21.3508518,40.3390369,1.8,20.9807272,40.190971,-1.3812822,12.8241013,16.8023275,10800.2812995,18822.7059601,35.34839,1120.2439643,842.186212,1729.4079688,24.9548381,31.5259941,1.0568766,95.7611379),(46452,'femur.tif',230,7,33,211.3038139,21.1477092,40.3076318,1.8,20.8029107,40.1405363,-1.3702905,12.4151219,16.695011,9693.5948988,17347.4268231,33.8203471,1039.0784891,780.7893448,1591.541492,24.049105,31.1074902,1.0737217,94.4753325),(46453,'femur.tif',230,7,34,204.6341352,20.9532852,40.2751028,1.8,20.6734396,40.0838736,-1.3635583,12.0546241,16.3990481,8744.7519367,16016.4563659,32.661781,976.6698835,725.4271776,1480.1122928,23.2221249,30.5686402,1.0682704,92.1650169),(46454,'femur.tif',230,7,35,199.1910476,20.8241894,40.1073399,1.8,20.5468361,39.9520021,-1.34338,11.746456,16.0624921,7907.4952527,14863.4446308,31.5109369,925.3510947,673.1813607,1393.9577609,22.3740001,29.9678233,1.0741029,90.5457618),(46455,'femur.tif',230,7,36,191.0291767,20.6820387,39.9442902,1.8,20.4077852,39.8748902,-1.3253851,11.5414412,15.4797533,7139.0830293,13467.0683743,29.9588747,869.97952,618.5607937,1305.1922533,21.6175909,29.2604225,1.0953049,86.7236323),(46456,'femur.tif',230,7,37,182.3408505,20.5130007,39.8848033,1.8,20.33062,39.8913735,-1.3040582,11.3775785,14.7429863,6451.5535552,11753.8389889,28.2787036,797.2495347,567.0410067,1216.1873355,20.9409232,28.1859264,1.1757031,83.0626649),(46457,'femur.tif',230,7,38,171.5093404,20.3346718,39.7663406,1.8,20.1776609,39.8493474,-1.2623628,11.3221312,13.7294099,5815.8986339,10154.8266157,25.950718,739.6404304,513.6752548,1148.8033765,20.4015708,26.8980519,1.2178059,78.5160973),(46458,'femur.tif',230,7,39,166.9048753,20.3358797,39.7838124,1.8,20.2161738,39.8852563,-1.2683078,11.0666026,12.8212518,5518.2256096,9177.5975225,25.3488883,715.8113488,498.6377324,1125.4146749,19.9411595,25.7591093,1.1783193,76.1298093),(46459,'femur.tif',230,7,40,162.0513012,20.3385251,39.8693459,1.8,20.2241453,39.9436342,-1.282678,10.7952709,12.4794447,5204.076711,8368.7412506,24.8278676,670.6020537,482.0700452,1079.6970125,19.5161291,24.7515416,1.2617749,73.7972419),(46460,'femur.tif',230,7,41,157.9750387,20.4119675,39.9646711,1.8,20.3343103,40.0080812,-1.2947876,10.4932,12.2068179,5009.3454179,7708.2068361,24.3738145,631.4673412,477.3896836,1036.903681,19.1129291,23.9708337,1.1774262,72.1020142),(46461,'femur.tif',230,7,42,154.2055899,20.4221091,40.0479103,1.8,20.3991517,40.0893953,-1.3217047,10.2688513,11.9284063,4763.4922978,7174.6487437,24.138985,601.4758878,463.8778165,996.6594202,18.8190014,23.2712377,1.2008903,70.643921),(46462,'femur.tif',230,7,43,149.9954539,20.4373891,40.0956053,1.8,20.4269525,40.1229547,-1.33922,10.1465068,11.6569338,4544.0403555,6649.0691561,23.6823881,570.396062,447.842833,956.7695158,18.5803653,22.6245469,1.3887546,68.7430278),(46463,'femur.tif',230,7,44,146.5417826,20.4915607,40.1279123,1.8,20.4599352,40.1248501,-1.3543926,9.9639803,11.4052394,4373.1466329,6230.0793709,23.2976016,546.2471376,438.8955541,927.9513125,18.3762014,22.2308659,1.3294408,67.441488),(46464,'femur.tif',230,7,45,144.0794178,20.5394264,40.1592276,1.8,20.5424482,40.1682877,-1.3541967,9.8393351,11.1686265,4221.5992984,5911.3221559,22.9041539,529.2792401,429.0533108,905.0738587,18.1548013,21.8011574,1.3245861,66.242781),(46465,'femur.tif',230,7,46,141.8368314,20.5387549,40.1665892,1.8,20.4675131,40.0892826,-1.3904191,9.7475082,10.978489,4096.799692,5563.4977721,22.8786448,506.7635248,420.2919987,877.5336734,18.1479713,21.3857403,1.3622337,64.8763947),(46466,'femur.tif',230,7,47,141.0787253,20.5674842,40.230676,1.8,20.4821339,40.1325162,-1.4397928,9.6200647,10.7558165,3991.9896164,5281.7305922,23.1118934,491.0580773,414.9649436,862.0379261,17.9334013,20.9430841,1.3360737,63.6508274),(46467,'femur.tif',230,7,48,139.4615145,20.665064,40.3473116,1.8,20.5794061,40.248883,-1.4523117,9.4854402,10.4910764,3919.6039046,5031.2155599,22.9188025,479.5709558,413.2231965,852.5857254,17.8227013,20.5201509,1.3532977,62.8949204),(46468,'femur.tif',230,7,49,138.6284666,20.7546835,40.4085808,1.8,20.6812309,40.3248897,-1.4679288,9.3244314,10.3113441,3866.7044819,4824.8431122,22.8611176,467.91602,414.6852825,842.4461695,17.8227013,20.1659443,1.3098403,62.3604135),(46469,'femur.tif',230,7,50,137.8255349,20.8023075,40.4611692,1.8,20.7027147,40.4049324,-1.5187363,9.186696,10.149091,3821.6621397,4656.7918019,22.9087219,458.8383155,415.9996293,835.3251258,17.6013013,19.8847538,1.6543999,61.8638928),(46470,'femur.tif',230,7,51,136.4321684,20.8714553,40.4978416,1.8,20.7834846,40.4745458,-1.5600925,9.0385549,9.9885404,3773.1981759,4499.7197802,22.7360896,450.4882208,417.4559121,826.6644117,17.6013013,19.6214008,1.6895531,61.6156325),(46471,'femur.tif',230,7,52,135.5397271,20.899074,40.5384167,1.8,20.8293461,40.4554349,-1.5566932,9.0152607,9.8412712,3727.5355605,4367.9573286,22.5854617,443.8407623,413.4695241,820.3914504,17.6013013,19.3762965,1.6795608,61.1459721),(46472,'femur.tif',230,7,53,136.2070364,20.9148726,40.5423215,1.8,20.8653266,40.4649501,-1.5648698,8.9843141,9.7211721,3697.2756091,4259.5103997,22.7003755,438.1683956,411.5256388,814.7704873,17.4906013,19.1686902,1.6865555,60.6763118),(46473,'femur.tif',230,7,54,136.0612678,20.9672907,40.5593507,1.8,20.9304531,40.4554687,1.5691496,8.920859,9.6987304,3660.2394336,4163.4555597,22.6768164,429.2784088,410.3012309,805.676751,17.4906013,19.012384,1.6640919,60.3900652),(46474,'femur.tif',230,7,55,137.3546814,21.0088076,40.6050337,1.8,20.9810518,40.5175409,-1.5584213,8.9044431,9.5506291,3632.6758013,4064.4795336,22.8889413,425.5719154,407.9621535,804.1698122,17.3799013,18.7710789,1.7068552,59.8555583),(46475,'femur.tif',230,7,56,137.8680428,21.0410499,40.6961439,1.8,20.9951632,40.671071,-1.5394105,25.8072115,31.5584238,3620.3769917,3971.0140435,22.9553797,125.8305569,140.2854775,186.2242777,17.3799013,18.5672659,1.7143797,59.515591),(46476,'femur.tif',230,7,57,138.0344092,21.0519785,40.7730505,1.8,21.0429928,40.7831335,1.5616331,8.9415867,9.2658335,3600.1833764,3901.8458203,23.0038033,421.1003582,402.6336147,807.6675445,17.4135603,18.3991939,1.69142,59.3210514),(46477,'femur.tif',230,7,58,138.4918199,21.0988933,40.8047653,1.8,21.1097705,40.8521213,1.5149378,8.93322,9.1586568,3597.922812,3836.480303,23.0100252,418.8911527,402.7576647,808.7148587,17.3958653,18.2722092,1.728973,58.9430979),(46478,'femur.tif',230,7,59,139.2047122,21.1564148,40.8309556,1.8,21.1366209,40.8585715,1.4615349,8.9242438,9.1236273,3586.5512276,3788.0658996,22.9249133,415.1929695,401.8885293,794.2634282,17.3271251,18.1456866,1.7239095,58.9051117),(46479,'femur.tif',230,7,60,138.2730716,21.1970014,40.8647624,1.8,21.1043075,40.8001617,1.2958183,8.6157388,8.9438463,3569.7815055,3752.7058521,21.346453,419.5852333,414.3326069,781.3329741,17.2890128,18.0980125,2.8817783,58.8671254),(46480,'femur.tif',230,7,61,138.6858363,21.2828312,40.9370862,1.8,21.228701,40.970435,1.113793,8.698638,9.0471128,3548.8373852,3730.1845532,18.6136908,412.3066274,407.9762127,784.7613558,17.2284671,18.0742978,2.7849725,58.6457254),(46481,'femur.tif',230,7,62,139.4787341,21.3629004,40.9874294,1.8,21.3579492,40.9889164,0.9710428,8.7718722,9.1196839,3520.730364,3712.2480893,15.8403349,407.0588556,401.365899,788.5768923,17.1977053,18.0742978,2.7849725,58.3326185),(46482,'femur.tif',230,7,63,139.9259516,21.4352734,41.0586263,1.8,21.4310233,41.0917612,0.8482478,8.7123992,9.1494324,3497.21009,3665.4070746,13.1223551,400.6157866,401.4060903,782.741722,17.1299855,18.0495336,2.7713365,58.176065),(46483,'femur.tif',230,7,64,139.6375603,21.4699352,41.1107536,1.8,21.4213689,41.1751313,0.7391565,8.6704674,9.1081863,3457.0095841,3648.9527058,10.5618186,400.6234155,398.7108668,779.2604894,17.0811535,18.0742978,2.7849725,58.0195116),(46484,'femur.tif',230,7,65,135.9168362,21.5548038,41.1153458,1.8,21.5515564,41.1592278,0.7063288,8.6866509,9.0819724,3416.1616769,3619.6509285,9.5427161,398.5533965,393.2656798,773.4621652,17.0808724,18.0969968,2.7326848,57.7712512),(46485,'femur.tif',230,7,66,135.9977288,21.6070433,41.1463358,1.8,21.5963632,41.1723688,0.6371788,8.6782306,9.0034045,3391.74404,3608.2554244,8.0225488,400.7656682,390.8335902,769.3762043,17.0805914,18.130823,2.7134492,57.7712512),(46486,'femur.tif',230,7,67,136.7727918,21.6652485,41.196095,1.8,21.6573298,41.1959914,0.53461,8.6860119,9.0423561,3376.3957776,3614.8784889,5.9176074,399.7717473,388.716456,767.439508,17.0783784,18.1551388,2.740704,57.7712512),(46487,'femur.tif',230,7,68,136.8287811,21.724502,41.2671112,1.8,21.7285501,41.2541403,0.4441634,8.6954654,9.1047083,3366.7349018,3606.7920336,4.2107756,396.1458103,387.1828287,765.2482402,17.1585013,18.1551388,2.740704,57.5229909),(46488,'femur.tif',230,7,69,137.7981345,21.8135478,41.312346,1.8,21.8752097,41.3021892,0.4011458,8.6827006,9.1150324,3361.2096552,3617.3559831,3.5016685,396.8560771,387.1156939,765.6027687,17.1426031,18.1723429,2.7542991,57.6415581),(46489,'femur.tif',230,7,70,136.8601402,21.9181468,41.3649272,1.8,22.0060207,41.408832,0.3939247,8.6776983,9.0833005,3341.3230935,3618.2628211,3.3602428,398.3423011,385.0471627,765.9699406,17.1426031,18.1986235,2.7351034,57.4581443),(46490,'femur.tif',230,7,71,136.7691876,22.0204307,41.4120698,1.8,22.1947531,41.4701636,0.3580345,8.654888,9.0482,3332.3400224,3609.4013239,2.7993018,398.9082181,385.0240483,765.7316536,17.1426031,18.1986235,2.7351034,57.4581443),(46491,'femur.tif',230,7,72,135.1630709,22.0523712,41.4499733,1.8,22.0790445,41.4692777,0.3676757,8.6582786,9.0853715,3320.6277662,3602.638109,2.9105678,396.5317325,383.5205481,761.7467686,17.1426031,18.1723429,2.7542991,57.3932978),(46492,'femur.tif',230,7,73,134.7480159,22.1359002,41.4924988,1.8,22.1748961,41.4780973,0.3651362,8.6723706,9.1100982,3332.5501136,3582.3459009,2.8634773,393.2280228,384.2721067,757.5639952,17.0478013,18.1986235,2.7351034,57.3015909),(46493,'femur.tif',230,7,74,135.4434059,22.196907,41.5335805,1.8,22.2224241,41.4604455,0.3570019,8.6936085,9.1373777,3355.4806247,3575.2219981,2.7568822,391.2744012,385.9709852,756.9425329,17.1429008,18.231589,2.7159702,57.3664374),(46494,'femur.tif',230,7,75,134.996364,22.2794509,41.5956661,1.8,22.3454808,41.5567144,0.3064321,8.6745986,9.1095286,3365.3914244,3578.4629679,2.0474009,392.8263626,387.9593273,758.3315612,17.0478013,18.231589,2.7159702,57.2747306),(46495,'femur.tif',230,7,76,135.0602196,22.3489567,41.6614599,1.8,22.4053796,41.654799,0.2903444,8.6533939,9.1188508,3373.8523832,3582.9838117,1.8448668,392.9205416,389.8877637,758.7884463,17.0478013,18.231589,2.7159702,57.3664374),(46496,'femur.tif',230,7,77,135.8696974,22.416293,41.7157071,1.8,22.4954033,41.7015233,0.2808986,8.6256558,9.1384433,3383.8931089,3607.3674754,1.7402747,394.7463883,392.3056024,760.9904647,17.0478013,18.231589,2.7159702,57.3664374),(46497,'femur.tif',230,7,78,136.3895366,22.4653257,41.7385728,1.8,22.4899102,41.6687741,0.2768337,8.6142297,9.2030337,3392.8055551,3615.1340038,1.6980276,392.819814,393.8605837,755.3190149,17.0478013,18.2571131,2.7430702,57.4961306),(46498,'femur.tif',230,7,79,136.1404156,22.5620698,41.7938416,1.8,22.6078236,41.7850206,0.2606556,8.5722137,9.2319165,3368.6402113,3634.1933815,1.5069961,393.6553561,392.9720277,751.9531662,17.0478013,18.316754,2.7509856,57.4961306),(46499,'femur.tif',230,7,80,136.4384475,22.6233006,41.8312484,1.8,22.6437615,41.8357432,0.280167,8.6019716,9.3034558,3356.2686716,3661.9272741,1.7387075,393.6093596,390.174348,747.6093638,16.9371013,18.4021908,2.7398604,57.4692702),(46500,'femur.tif',230,7,81,137.2189631,22.6687472,41.8676457,1.8,22.6691473,41.8675514,0.3004804,8.6324216,9.3859991,3366.445768,3674.9549435,2.0034797,391.5358276,389.976988,746.480509,17.0478013,18.4021908,2.7398604,57.5341168),(46501,'femur.tif',230,7,82,137.9589381,22.7505389,41.9061245,1.8,22.7302877,41.9069744,0.2886773,8.669353,9.4573403,3380.156373,3695.5885504,1.863486,390.7640457,389.8971914,744.5216463,17.0478013,18.4394449,2.7666604,57.7823772),(46502,'femur.tif',230,7,83,138.7096429,22.8529485,41.943188,1.8,22.8349372,41.9411517,0.2853731,8.7145352,9.4828742,3394.3813545,3714.5660155,1.8321453,391.7130974,389.5080203,745.2139324,17.0478013,18.4457574,2.7343368,57.7823772),(46503,'femur.tif',230,7,84,140.4434737,22.9457157,41.9853563,1.8,22.9249832,41.989645,0.2956265,8.7933483,9.5392794,3423.9486374,3753.7219927,1.9867728,393.5016295,389.3793961,749.0375003,17.0478013,18.4898841,2.7288394,57.6906703),(46504,'femur.tif',230,7,85,142.5913845,23.0230577,42.0126216,1.8,22.960095,42.0182913,0.3173209,8.868972,9.6434173,3459.7200939,3791.7572855,2.3137341,393.1964323,390.092573,750.423705,17.1585013,18.5345669,2.7233683,57.874084),(46505,'femur.tif',230,7,86,143.663255,23.1463528,42.0619505,1.8,23.1307356,42.082876,0.2961346,8.8614237,9.6842685,3491.4335345,3817.9792109,2.0391071,394.2454931,394.0036805,753.8232559,17.2692013,18.5830993,2.7632987,57.9926513),(46506,'femur.tif',230,7,87,145.0914544,23.2668436,42.1032604,1.8,23.2338404,42.1228657,0.2866441,8.8848652,9.6913063,3523.9828181,3851.9904218,1.9330773,397.46865,396.6276073,760.2675323,17.328405,18.6058362,2.7765547,58.2409116),(46507,'femur.tif',230,7,88,146.0060048,23.4339689,42.1207451,1.8,23.447709,42.1326164,0.2996573,8.8908018,9.7103765,3542.9726979,3880.6665624,2.1204646,399.6412048,398.4986685,764.3644715,17.279292,18.6610797,2.8029582,58.3326185),(46508,'femur.tif',230,7,89,146.9250847,23.5868201,42.1300222,1.8,23.5883809,42.1452757,0.2750959,8.895641,9.6297046,3556.4393657,3910.5108776,1.8068811,406.0883525,399.7957383,774.9771707,17.2692013,18.5939769,2.7953649,58.176065),(46509,'femur.tif',230,7,90,148.3518053,23.7616799,42.1316905,1.8,23.7649321,42.152952,0.2187776,8.9088312,9.5573934,3585.9733392,3959.2245911,1.1646818,414.257781,402.5189454,785.3186901,17.3346004,18.6245979,2.8085644,58.2677719),(46510,'femur.tif',230,7,91,149.6555205,23.9258549,42.1410552,1.8,23.8921342,42.1655878,0.1514214,8.9239167,9.3985833,3601.0490223,4021.2943989,0.5675368,427.8617612,403.5278596,800.6950245,17.359492,18.5567028,2.8009764,58.2409116),(46511,'femur.tif',230,7,92,151.1709197,24.0945216,42.1387251,1.8,24.0497769,42.1349464,0.1103188,8.9450687,9.3323753,3624.2291139,4082.5315447,0.305389,437.4589979,405.1650388,814.219844,17.375537,18.5239851,2.8444118,58.4243254),(46512,'femur.tif',230,7,93,153.6967031,24.2743996,42.1469186,1.8,24.190035,42.1163185,0.0721715,8.9221155,9.2789969,3654.1570642,4172.266997,0.1331959,449.6463409,409.5617319,832.0768782,17.3799013,18.4918723,2.8501359,58.5540185),(46513,'femur.tif',230,7,94,155.5356957,24.5069127,42.1660641,1.8,24.4640644,42.1272216,0.0272737,8.9158134,9.3017386,3683.9437645,4263.2525646,0.019278,458.32857,413.1921123,839.4334194,17.3828201,18.6334784,2.8894095,58.7374323),(46514,'femur.tif',230,7,95,156.259145,24.7257343,42.1832261,1.8,24.748969,42.1671444,-0.0167297,8.8253536,9.2468703,3684.5326151,4326.8974547,0.0072882,467.9310211,417.4940498,839.3367132,17.3319406,18.7945664,2.9037567,58.8291392),(46515,'femur.tif',230,7,96,157.49607,24.9364719,42.1816421,1.8,24.9637367,42.1566187,-0.037002,8.729212,9.3169598,3678.3053649,4403.1779883,0.0359228,472.5981544,421.3788537,840.7851603,17.2692013,18.9037889,2.8809903,58.9588323),(46516,'femur.tif',230,7,97,159.1603126,25.1697899,42.2071095,1.8,25.1746254,42.171566,-0.0362508,8.7036747,9.3796079,3678.9447041,4507.3810188,0.0348439,480.5511113,422.6886714,850.9943071,17.2692013,18.9969084,2.9361973,59.0505392),(46517,'femur.tif',230,7,98,160.8212707,25.4504127,42.2374185,1.8,25.4639184,42.2185849,-0.0350497,8.6757432,9.7405695,3676.7235875,4638.4278009,0.0329141,476.1967771,423.793501,849.6106627,17.1585013,19.2662544,3.0322045,59.3905064),(46518,'femur.tif',230,7,99,162.7541211,25.7203235,42.2649044,1.8,25.7207431,42.2438262,-0.0434581,8.6472782,9.8474191,3683.3721073,4749.3941204,0.0511975,482.2983655,425.9573953,855.0270905,17.1585013,19.4533021,0.0911751,59.7036133),(46519,'femur.tif',230,7,100,162.7499318,25.9801617,42.2879949,1.8,26.0344372,42.2633106,-0.0608003,8.64992,9.9222203,3669.6658292,4824.0040634,0.1001486,486.1819149,424.2427498,855.6751497,17.1704736,19.6214008,0.1187567,59.8870271),(46520,'femur.tif',230,7,101,163.3894613,26.185111,42.3134984,1.8,26.2265736,42.2883847,-0.0633997,8.5874144,9.9619989,3653.7513041,4873.7302523,0.109311,489.2321593,425.4774635,854.3805043,17.1353253,19.7313255,0.118092,59.8870271),(46521,'femur.tif',230,7,102,161.7520053,26.3395856,42.3445187,1.8,26.4139252,42.3252809,-0.0645729,8.5990983,10.0314999,3616.8399805,4835.3349024,0.112252,482.0151476,420.6068897,840.9129551,17.0656315,19.7883812,0.1403148,59.8870271),(46522,'femur.tif',230,7,103,161.4760455,26.4794803,42.3767993,1.8,26.5500472,42.3655934,-0.0607872,8.5847699,9.8846472,3595.1464298,4774.7441627,0.0993221,483.0464916,418.7819206,845.2164164,16.9964448,19.596403,0.1075381,59.6656271),(46523,'femur.tif',230,7,104,163.016495,26.7072663,42.3748094,1.8,26.7833337,42.3624919,-0.0674783,8.5541588,9.9550421,3586.9245611,4849.2692132,0.1235231,487.1168959,419.3193791,847.4252884,16.9869322,19.6949595,0.1013465,59.757334),(46524,'femur.tif',230,7,105,162.2571333,26.8789007,42.399949,1.8,26.9725815,42.3706495,-0.0551257,8.498079,9.9134994,3550.8869716,4808.6167178,0.0820955,485.0574479,417.8458435,842.3669532,16.9371013,19.6488617,0.1299454,59.676753),(46525,'femur.tif',230,7,106,161.296786,27.0587869,42.3872146,1.8,27.1246742,42.3754135,-0.0560479,8.512498,9.9112391,3534.0509903,4756.2326031,0.0843603,479.8827417,415.1602739,834.782845,16.9343728,19.6251477,0.0564372,59.6387668),(46526,'femur.tif',230,7,107,161.030867,27.2481398,42.3850152,1.8,27.2834825,42.3937593,-0.0611777,8.5560867,9.8306974,3514.8954372,4697.5666482,0.1003231,477.846733,410.8064296,831.4454352,16.936439,19.5362777,0.0737297,59.4442271),(46527,'femur.tif',230,7,108,158.8579241,27.3391324,42.4204608,1.8,27.3663599,42.4291561,-0.0559223,8.555679,9.7623225,3509.456733,4573.6229943,0.0827131,468.4974309,410.1903215,827.6345842,16.9772721,19.3645927,0.1030816,59.1311202),(46528,'femur.tif',230,7,109,156.5431157,27.4020913,42.4428205,1.8,27.4169674,42.4526847,-0.0759779,8.5354012,9.5895053,3514.72197,4418.9353795,0.1503216,460.8095266,411.7816931,827.1345816,16.9371013,19.0587353,0.1164301,58.5697529),(46529,'femur.tif',230,7,110,156.6955217,27.5668513,42.4702948,1.8,27.5746319,42.4812069,-0.0862096,8.5208593,9.6559997,3534.8845532,4381.3795922,0.1936157,453.7468666,414.8507118,819.7885582,16.9371013,19.0857216,0.1279521,58.6614598),(46530,'femur.tif',230,7,111,157.0088382,27.759779,42.4819293,1.8,27.7644617,42.4881997,-0.099895,8.4996911,9.6943209,3545.3822535,4394.1176878,0.2602645,453.2672011,417.1189517,818.9332431,16.9371013,19.1331763,0.0985172,58.7263064),(46531,'femur.tif',230,7,112,157.3011984,27.9755112,42.4839025,1.8,27.9822301,42.4969556,-0.117662,8.4674113,9.7676705,3547.1829699,4408.8231776,0.361284,451.3689507,418.9217745,812.8761662,16.9084459,19.2137078,0.0807489,58.8828598),(46532,'femur.tif',230,7,113,156.5500821,28.1908348,42.4977994,1.8,28.1972646,42.5108467,-0.138574,8.4124184,9.6661115,3533.8547029,4415.3257062,0.4978331,456.7840649,420.0759585,820.2974355,16.8741151,19.1331763,0.0985172,58.7263064),(46533,'femur.tif',230,7,114,156.1064607,28.4231262,42.4953813,1.8,28.4264052,42.5074969,-0.1581571,8.4128442,9.5477545,3541.1089971,4411.9294337,0.6453914,462.0907906,420.9169843,830.4053569,16.8737177,19.0378268,0.1517652,58.6994461),(46534,'femur.tif',230,7,115,156.5050536,28.6372724,42.4942905,1.8,28.6426997,42.5088426,-0.1678622,8.4259116,9.5636477,3567.504922,4420.7217417,0.7281153,462.242222,423.3969068,826.270618,16.8741151,19.1033705,0.0812163,58.8559995),(46535,'femur.tif',230,7,116,156.7983674,28.8635567,42.5079463,1.8,28.871613,42.5168543,-0.1728504,8.4131108,9.5159498,3597.9283801,4440.5793576,0.7730395,466.6459416,427.6573153,831.9195192,16.8741151,19.0947086,0.075438,59.012553),(46536,'femur.tif',230,7,117,157.0365336,29.0998408,42.511377,1.8,29.105372,42.5135772,-0.1810928,8.4059479,9.4388257,3618.385461,4488.8158568,0.8489835,475.5693138,430.4553756,846.6816549,16.8397844,19.012384,0.0932956,58.9856926),(46537,'femur.tif',230,7,118,157.0757256,29.3390061,42.5140792,1.8,29.3488456,42.5183117,-0.2037003,8.405448,9.4259845,3645.039772,4551.1416748,1.0713372,482.8293179,433.6520502,849.3523008,16.8697031,19.0866847,3.0719381,59.3367858),(46538,'femur.tif',230,7,119,156.621626,29.5610888,42.5031195,1.8,29.5714157,42.5108292,-0.21847,8.4216981,9.4548744,3670.6985238,4571.5855244,1.2262067,483.5162636,435.8620404,859.0785352,16.8737177,19.0230161,3.042503,59.2070926),(46539,'femur.tif',230,7,120,156.2322295,29.8092865,42.5034342,1.8,29.8276137,42.5179952,-0.2327859,8.443572,9.4824076,3696.1044555,4613.7210445,1.3857147,486.5558643,437.7418041,868.5279149,16.8991026,19.0342862,0.1048769,59.4933392),(46540,'femur.tif',230,7,121,155.4910697,30.0656919,42.4777592,1.8,30.0881766,42.4908578,-0.2726465,8.4975247,9.5592434,3730.7544232,4651.9388625,1.8791692,486.6429985,439.0401407,876.1328934,16.9506516,19.0857216,0.1279521,59.7795858),(46541,'femur.tif',230,7,122,155.7030601,30.336908,42.4588763,1.8,30.3593923,42.4775628,-0.2908124,8.5607663,9.6150378,3783.1178006,4712.3388878,2.1335071,490.1009205,441.9134527,881.6402656,17.0311973,19.1817913,0.1214917,60.0926927),(46542,'femur.tif',230,7,123,155.7939428,30.5959306,42.4441971,1.8,30.6273285,42.4667757,-0.3182627,8.6251214,9.6534754,3838.1327668,4778.8055213,2.5424804,495.0347247,444.9946366,890.5218468,17.1297045,19.29168,0.1207963,60.3409531),(46543,'femur.tif',230,7,124,156.1490529,30.8760693,42.4258986,1.8,30.911722,42.4536814,-0.3443796,8.7206272,9.7517592,3893.2039076,4865.1513181,2.9663732,498.8998598,446.4362276,898.1307853,17.1807848,19.4183087,0.1660859,60.5892134),(46544,'femur.tif',230,7,125,157.1152671,31.1870797,42.4272524,1.8,31.2296771,42.4589924,-0.3571466,8.7805025,9.8205347,3964.5762197,4972.0753614,3.2004844,506.2937516,451.520424,908.9426737,17.2801351,19.545998,0.1707352,60.9671669),(46545,'femur.tif',230,7,126,158.46131,31.4902086,42.4441606,1.8,31.5366706,42.4798717,-0.3665091,8.8317561,9.9028077,4061.4182271,5083.8499005,3.3916223,513.3745954,459.8653069,922.6702573,17.4746359,19.693715,0.180859,61.2802738),(46546,'femur.tif',230,7,127,159.8566368,31.7919311,42.4500001,1.8,31.83428,42.4886382,-0.3829885,8.910427,9.9918546,4147.7831527,5229.365489,3.7205918,523.3628472,465.4976852,934.4437675,17.5764997,19.8970755,0.2301349,61.7230738),(46547,'femur.tif',230,7,128,161.0680812,32.1109495,42.478852,1.8,32.1663508,42.5138135,-0.4173816,8.9926535,10.0790883,4237.1862078,5405.9684372,4.411209,536.3549062,471.1830823,952.2911577,17.7144693,20.0880104,0.267702,62.1278876),(46548,'femur.tif',230,7,129,161.7422305,32.4746205,42.5000409,1.8,32.529636,42.522807,-0.4522783,9.046347,10.2359381,4332.7469485,5587.1257191,5.1483329,545.8342604,478.9498958,966.6770785,17.8246663,20.2922506,0.3977286,62.7003808),(46549,'femur.tif',230,7,130,162.5475945,32.8670067,42.5062531,1.8,32.9281176,42.535581,-0.4856058,9.0985518,10.4017279,4445.5532494,5783.8581763,5.9018376,556.0478273,488.6000944,982.2002425,17.9361201,20.5690624,0.4154921,63.2348877),(46550,'femur.tif',230,7,131,163.6072644,33.2731813,42.4979437,1.8,33.3631961,42.5123461,-0.5153601,9.1597851,10.5647138,4557.2750132,6012.039619,6.6233491,569.0679101,497.5307803,1000.3717874,18.0819238,20.8733371,0.40907,63.9259481),(46551,'femur.tif',230,7,132,164.5332232,33.7009475,42.5039786,1.8,33.8435975,42.4866311,-0.542819,9.1891412,10.7130146,4685.1952592,6240.9312528,7.3169509,582.5560325,509.8621454,1019.8263801,18.2384773,21.1463095,0.4378922,64.7467016),(46552,'femur.tif',230,7,133,163.7717461,34.0789167,42.5445824,1.8,34.2162859,42.5260718,-0.5803949,9.2485945,10.8034508,4828.3190693,6421.3730859,8.2074844,594.3816668,522.0597627,1040.5090364,18.4410106,21.4509653,0.5005823,65.7240085),(46553,'femur.tif',230,7,134,163.2141289,34.5017816,42.5437102,1.8,34.6373213,42.5717341,-0.6186306,9.3718613,10.94008,4948.789926,6660.9656997,9.1483499,608.8589554,528.0477129,1060.6942692,18.6046484,21.837383,0.561286,66.544762),(46554,'femur.tif',230,7,135,162.3223239,34.9585869,42.4920533,1.8,35.1271537,42.4927139,-0.649185,9.5127237,11.1288551,5038.8365906,6948.2572319,9.8872016,624.3460979,529.6944148,1076.2634597,18.7535888,22.3013127,0.6196725,67.5600552),(46555,'femur.tif',230,7,136,163.3410102,35.4622929,42.4897364,1.8,35.6328138,42.5240419,-0.6794078,9.5929325,11.3688794,5207.0940924,7313.711709,10.7478837,643.3098159,542.805246,1101.3151099,18.9302103,22.8624329,0.6996979,68.6022087),(46556,'femur.tif',230,7,137,165.4222526,35.9779052,42.4095261,1.8,36.1712486,42.4751236,-0.720215,9.7294662,11.8376068,5389.770283,7820.9724234,11.9931482,660.6886499,553.9636165,1115.7835286,19.0686902,23.5988428,0.7289797,69.8120416),(46557,'femur.tif',230,7,138,170.6052178,36.6286726,42.1245598,1.8,36.8654247,42.1207118,-0.7761091,9.9073273,13.7343395,5541.3823768,8773.3591708,13.9529905,638.7900327,559.3216242,1028.6930311,19.2509677,26.1479418,0.9205214,76.2483765),(46558,'femur.tif',230,7,139,176.963344,37.5223056,41.5061263,1.8,37.8294914,41.3640988,-0.8311154,10.1058688,14.9027085,5715.7426325,10723.5130114,16.093445,719.5680592,565.5864683,1092.7874277,19.3841381,28.2091772,0.941423,78.1112835),(46559,'femur.tif',230,7,140,184.2418319,38.3840536,41.0392517,1.8,38.8730268,40.703902,-0.876442,10.1327839,16.5219924,5924.1531984,12909.8952556,18.1337419,781.3764203,584.6520814,1137.6718318,19.5535913,30.5540044,0.9345415,82.215051),(46560,'femur.tif',230,7,141,189.8170861,38.9712484,40.9591758,1.8,39.6356347,40.4989017,-0.8949073,10.1111307,17.5955295,6223.0349636,14419.0973689,19.2549096,819.4750493,615.4638064,1171.0178245,19.744756,31.994026,0.9376755,85.4535614),(46561,'femur.tif',230,7,142,193.7479239,39.4261321,41.0206648,1.8,40.127921,40.5518468,-0.9131127,10.1296152,18.5848829,6421.9231719,15999.7962712,20.2250331,860.903799,633.9750353,1205.6697923,19.9913424,33.1752983,0.9513226,88.5309098),(46562,'femur.tif',230,7,143,199.3794753,39.9230411,41.0924121,1.8,40.721724,40.440505,-0.9207037,10.1045004,19.4352814,6558.4403276,18054.9742476,21.0564722,928.9793082,649.0613153,1266.31185,20.1012196,34.7428762,1.0358413,91.8991133),(46563,'femur.tif',230,7,144,207.2776195,40.2311905,41.361036,1.8,40.9769685,40.7662131,-0.9291957,10.522444,20.4848752,6895.0443557,19745.4864483,22.1726044,963.9056267,655.270233,1300.477353,20.1503327,36.4162648,0.9954406,96.0028808),(46564,'femur.tif',230,7,145,224.9049235,40.5812714,41.9496863,1.8,41.3372957,41.2092453,-0.9560213,11.0254337,21.5088954,7181.9397222,21051.1216012,25.0143345,978.7170033,651.3974771,1311.8788027,20.1647956,37.6459788,0.9672974,97.6935),(46565,'femur.tif',230,7,146,228.1679,41.0888953,42.0220116,1.8,41.672047,41.3480616,-0.9606954,11.3777649,21.926448,7517.4279239,21565.1444287,25.5444665,983.5220216,660.7121835,1325.651999,20.0686915,38.6444517,0.9502138,99.5072948),(46566,'femur.tif',230,7,147,216.1220439,41.1999347,41.6404813,1.8,41.9015299,40.8008415,-0.9732532,11.2252009,22.0614465,7221.0692139,22699.8404052,24.6186994,1028.9370829,643.2908679,1353.9087739,20.0027209,39.3780951,0.9531612,136.764317),(46567,'femur.tif',230,7,148,204.9964231,41.2774976,41.2776026,1.8,42.158932,40.2472287,-0.9808254,11.0151403,22.0454095,6927.2955051,24004.9998995,23.5913073,1088.8888173,628.8885426,1395.485012,19.9414391,40.0350065,0.9444396,136.0398789),(46568,'femur.tif',230,7,149,199.1469979,41.3808445,41.1165407,1.8,42.3136132,40.0345133,-0.9932772,10.9109664,22.2831387,6829.6701216,24602.5192219,23.2982649,1104.086798,625.9454826,1395.9261019,20.05163,40.613478,0.948012,138.2918653),(46569,'femur.tif',230,7,150,194.0703521,41.4685334,40.9990662,1.8,42.4428681,39.873302,-1.0069943,10.8591401,22.6154426,6804.8639702,24595.8270964,23.107722,1087.5677953,626.648513,1360.9086342,20.3021699,41.1664144,0.9073947,140.8458327),(46570,'femur.tif',230,7,151,194.3183649,41.6201607,40.9171193,1.8,42.7142199,39.6063901,-1.0218396,10.8513273,22.7744329,6845.5173268,25671.2820648,23.5684646,1127.1974213,630.8460862,1390.8671337,20.5570081,41.6245279,0.9193167,142.6012984),(46571,'femur.tif',230,7,152,194.6328232,41.8052249,40.8632991,1.8,42.9209786,39.4654627,-1.0401396,10.8999312,22.6688741,6912.9091136,26590.7625355,24.1300235,1173.0076401,634.2158455,1429.0604465,20.772438,41.8224865,0.9262365,144.7235917),(46572,'femur.tif',230,7,153,195.0416784,42.2191236,40.4819938,1.8,43.3238695,39.1104057,-1.0492375,11.034781,21.9334128,7121.782736,27669.6133135,24.4375699,1261.5279539,645.3941154,1519.4824004,21.022287,41.9348522,0.9183197,147.1210056),(46573,'femur.tif',230,7,154,196.5899939,42.3740075,40.4372565,1.8,43.2251599,39.2491755,-1.0736363,11.0918981,21.1303828,7404.3015648,28180.2754413,25.3121603,1333.6377129,667.5414369,1587.1570687,21.2824717,41.5574967,0.9214349,149.6212524),(46574,'femur.tif',230,7,155,195.1409157,42.4633628,40.5039582,1.8,43.0974203,39.4334163,-1.1138654,10.9888358,20.5172371,7633.2824261,28141.2196835,26.1926619,1371.5891436,694.6397734,1628.4409785,21.5851261,41.1484007,0.8863918,150.3123128),(46575,'femur.tif',230,7,156,192.5887078,42.4515891,40.6408343,1.8,43.0625461,39.5901364,-1.1649618,11.3994483,20.110786,7628.1227992,27837.8309166,27.095443,1384.2239148,669.1659651,1648.7593537,21.8804099,40.6113658,0.8896698,148.4605316),(46576,'femur.tif',230,7,157,187.7719388,42.3589687,40.6539713,1.8,43.054163,39.5660231,-1.2357005,12.4059764,20.2821672,7338.8238381,26965.1051851,27.9107755,1329.4982174,591.5555202,1658.6337203,22.0928122,40.3508743,1.0948794,147.6666385),(46577,'femur.tif',230,7,158,183.8493078,42.3528638,40.3741042,1.8,43.0489943,39.2638998,-1.2918749,13.0600575,20.6380883,7094.2189252,26831.6522747,28.3189062,1300.1035683,543.1996683,1636.2750224,22.2977593,40.7246659,1.2008903,150.3169213),(46578,'femur.tif',230,7,159,183.9140949,42.5196217,39.8855405,1.8,43.1069259,38.8389111,-1.3328558,13.2457857,21.134913,6902.7662135,27784.5523994,28.9494493,1314.6281881,521.1292373,1627.5637642,22.3989257,41.3450822,1.2380386,147.590666),(46579,'femur.tif',230,7,160,180.8968319,42.7084981,38.9995025,1.8,43.1544174,37.9689635,-1.3694387,13.2623907,21.9461924,6686.9859311,28291.0469769,28.9434974,1289.1095856,504.2066762,1577.802045,22.3814323,42.3809021,1.2820916,148.4002936),(46580,'femur.tif',230,7,161,181.2765346,42.7183774,38.1033821,1.8,43.1190897,36.8913915,-1.4220398,13.4803405,22.5930033,6442.3522323,30395.3414445,29.5491089,1345.3431138,477.9072322,1608.2998209,22.1541097,44.7032073,1.3282201,150.6411541),(46581,'femur.tif',230,7,162,191.0272157,42.8213619,36.151843,1.8,43.1443925,34.751642,-1.4788041,13.4976979,24.7571198,6362.045544,37596.6816911,31.5691981,1518.6209868,471.3430104,1766.8566396,21.9550216,49.2047527,1.4285811,160.6244977),(46582,'femur.tif',230,7,163,205.4802834,42.5544628,34.1914443,1.8,42.8115525,32.9117743,-1.5454376,13.6462435,25.8501494,6579.9156682,46289.2340626,34.2246955,1790.6756856,482.1778014,1997.2073322,21.8022819,50.3520785,1.4805345,166.2354706),(46583,'femur.tif',230,7,164,221.1848832,42.042705,32.3153444,1.8,42.2503234,31.2312237,1.5275436,13.7703537,27.3523295,7409.2291221,53451.7424367,36.795225,1954.1934215,538.0565581,2166.0752391,23.177614,50.6916599,1.507424,165.6203827),(46584,'femur.tif',230,7,165,234.0622535,41.6818171,31.4696948,1.8,41.8388716,30.6596043,1.494416,13.724177,28.0444789,8299.7258197,56786.8095836,38.7832329,2024.8837491,604.7521703,2258.016954,23.9620621,50.8320407,1.4988682,166.18175),(46585,'femur.tif',230,7,166,241.2736178,41.5892226,31.1026526,1.8,41.67222,30.5737012,1.4765592,13.4745519,28.359443,8789.0700137,57872.8599129,39.8562148,2040.6909931,652.271785,2289.2554074,24.1185919,50.8401162,1.4966964,165.2692896),(46586,'femur.tif',230,7,167,249.7632742,41.4269047,30.9912395,1.8,41.5272634,30.7563067,1.4669255,13.2349828,28.509556,9262.1648615,58808.5386524,41.1797034,2062.7658532,699.824471,2330.7364172,23.9984864,50.8320407,1.4988682,165.9872103),(46587,'femur.tif',230,7,168,257.5655143,41.3548187,31.0788321,1.8,41.4908196,31.1346935,1.4605043,12.9175687,28.4815954,9428.9163718,59488.673874,42.4075149,2088.6707016,729.9296479,2370.1104261,23.7115589,50.6847697,1.5096037,163.5203413),(46588,'femur.tif',230,7,169,260.7717274,41.3381956,31.0921688,1.8,41.4359865,31.4216158,1.4544447,12.4360448,28.4935605,9226.2320861,58142.0736087,42.8762302,2040.5338124,741.894406,2326.5642077,23.154949,50.4221221,1.6169174,159.2600203),(46589,'femur.tif',230,7,170,261.2063868,41.3454559,31.2517446,1.8,41.4239269,31.6933703,1.4538236,11.8436942,28.3379012,8786.2598068,56160.3326095,42.9414447,1981.8098802,741.8512908,2266.5166409,22.4263714,49.9569893,1.6462086,155.1562528),(46590,'femur.tif',230,7,171,262.7422287,41.3816637,31.7051061,1.8,41.4128972,32.3267548,1.4550302,11.2640102,27.7901485,8113.4187746,55476.3866625,43.2061182,1996.2608922,720.2957612,2266.4502225,21.6420924,49.1929214,1.6496393,217.2285108),(46591,'femur.tif',230,7,172,260.6936588,41.4402685,32.021349,1.8,41.4159433,32.9523067,1.454042,10.9379136,27.2591575,7107.6389177,53434.310575,42.8593505,1960.2333828,649.8166999,2201.5524107,20.7569324,48.1997802,1.6512673,145.5397367),(46592,'femur.tif',230,7,173,246.9917505,41.5024818,32.6119771,1.8,41.5256196,34.232131,1.4530274,11.0791529,26.4293663,5741.7639806,49985.7617544,40.5969831,1891.2962616,518.2493653,2090.5372771,20.4250269,47.0058097,1.6249885,137.3970482),(46593,'femur.tif',230,7,174,218.0806126,41.8548755,34.292219,1.8,41.8590999,36.5157431,1.4458086,11.2278943,24.4892399,4958.5947002,43721.9826059,35.7819129,1785.3548262,441.631757,1964.2552571,19.307159,27.6406637,1.4543895,89.9824856),(46594,'femur.tif',230,7,175,168.8804453,42.6421297,38.5490372,1.8,42.4185864,40.3156411,1.440586,11.3887233,22.951609,4118.1020872,29957.4979343,27.6722119,1305.2460908,361.5947082,1482.8173138,19.1522863,26.1019727,1.4474934,85.5610027),(46595,'femur.tif',230,7,176,119.7955406,44.1094966,46.4476612,1.8,43.4081388,45.9623758,-1.4336751,10.5827455,13.0498216,3600.7185629,5914.4966383,19.592866,453.2243291,340.2442735,713.7980203,18.9217111,24.8565277,1.172922,80.5401663),(46596,'femur.tif',230,7,177,119.2206888,44.2039727,46.9463174,1.8,43.6459902,46.5388414,-1.3365308,10.2137812,12.5577972,3473.6726623,5456.3565346,18.7994397,434.4994929,340.0966378,708.1616979,18.6041296,23.912483,1.2651498,72.3326313),(46597,'femur.tif',230,7,178,119.5137626,44.1340618,47.4346098,1.8,43.9071608,47.1641492,-1.1502152,9.4172126,11.8698959,3407.0255462,4818.8656771,16.5984387,405.973711,361.7870463,690.6450746,17.6596275,22.88306,1.3809908,68.6382861),(46598,'femur.tif',230,7,179,109.4927089,44.5479992,48.0907112,1.8,44.5144286,48.0057467,-0.9767594,8.5060928,11.1257714,2560.3622675,4055.5599689,12.5318734,364.5194415,301.0033322,588.5756968,16.1819324,21.7707827,0.875407,63.6397015),(46599,'femur.tif',230,7,180,101.3595098,45.0484178,48.8141981,1.8,44.9627808,48.7837323,-0.913394,7.1223723,11.0324594,1680.1141344,3797.6051323,10.5853535,344.2210847,235.8924896,486.597367,13.722577,22.3712638,0.6731953,60.6160737),(46600,'femur.tif',230,7,181,98.075826,45.3505989,49.1741492,1.8,45.2131812,49.0515608,-0.8573199,5.943905,11.5964824,1181.9165842,3830.8690026,9.3445661,330.3475036,198.8451334,430.7603636,11.7482808,22.7654775,0.7096811,58.7309149),(46601,'femur.tif',230,7,182,92.0958653,45.4771875,49.1456304,1.8,45.3967243,48.9372751,-0.8102489,5.4392508,11.756058,853.7608792,3574.5152774,8.0559406,304.0573032,156.9629563,376.6803504,10.8383825,22.6218385,0.7022569,57.5970545),(46602,'femur.tif',230,7,183,81.8552813,45.705532,48.4947404,1.8,45.6036647,48.3127631,-0.7354813,5.2606088,11.1247841,578.9379961,2868.9379423,6.1414107,257.8870662,110.0515196,309.6447484,10.1129734,22.0117718,0.6928065,55.9286871),(46603,'femur.tif',230,7,184,74.4686001,45.9276799,47.8136945,1.8,45.7615729,47.6356572,-0.6870841,5.0552344,10.4626424,422.5286663,2368.4443993,4.9933459,226.371533,83.5824081,265.8994233,9.6030419,21.0064751,0.6846172,53.110725),(46604,'femur.tif',230,7,185,68.8879476,45.9918073,47.1850632,1.8,45.8301393,47.0326523,-0.6756823,4.7016961,9.9632655,310.023027,1900.9529362,4.4910636,190.7961734,65.9385513,220.9588078,8.8432621,19.6448074,0.6976243,49.3803024),(46605,'femur.tif',230,7,186,60.6227173,45.7307958,46.6404574,1.8,45.8005704,46.5690127,-0.6259908,4.0629764,8.7018559,188.3131911,1281.0240154,3.4684213,147.2127366,46.3485815,167.2349707,7.4116213,17.5189539,0.7004016,43.1764935),(46606,'femur.tif',230,7,187,37.1436429,46.3338475,46.0346491,1.8,46.3016692,46.104614,-0.5831473,3.3874527,6.9712363,75.0568664,408.3821014,1.8771135,58.5810158,22.157318,69.0918836,6.0301172,13.236407,0.5648049,33.1125689),(46607,'femur.tif',230,7,188,10.8729231,47.2792285,45.7737525,1.8,47.2857122,45.6842125,-1.0527344,1.8498759,2.8543826,7.3642884,20.7959707,1.3677769,7.2856283,3.9809635,9.7587303,3.5935153,5.8754492,0.7454195,16.5965749),(46608,'femur.tif',230,7,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46609,'femur.tif',230,7,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46610,'femur.tif',230,7,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46611,'femur.tif',230,7,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46612,'femur.tif',230,7,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46613,'femur.tif',230,7,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46614,'femur.tif',230,7,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46615,'tibia fibula',230,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46616,'tibia fibula',230,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46617,'tibia fibula',230,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46618,'tibia fibula',230,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46619,'tibia fibula',230,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46620,'tibia fibula',230,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46621,'tibia fibula',230,8,7,0.0043831,106.515625,104.390625,1.8,106.515625,104.390625,0.7853982,1.564e-24,0.0000000000000201,0.0000258,0.0000258,0.0003653,1282328419.58384,1.648e19,2564656839.16758,0.265625,0.3756505,2.3561945,0.751301),(46622,'tibia fibula',230,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46623,'tibia fibula',230,8,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46624,'tibia fibula',230,8,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46625,'tibia fibula',230,8,11,3.4201156,88.477374,88.3718826,1.8,88.7055701,88.0972686,-1.2435179,2.352277,3.6928052,2.8958787,6.2092329,0.5111129,1.6814407,1.231096,2.4484944,4.3686992,6.4683914,1.2360595,17.4244634),(46626,'tibia fibula',230,8,12,48.2568509,87.6384463,78.3381368,1.8,87.0891995,76.2858226,1.4292519,9.2287295,15.6789695,164.6555167,4317.9133783,7.8827455,275.3952277,17.8416234,285.4158979,9.9083145,29.3031452,1.7255132,83.3814506),(46627,'tibia fibula',230,8,13,137.1335446,85.9070657,75.1697034,1.8,85.7352536,74.9701999,1.3136696,9.9222517,18.6453485,1860.4035802,11177.1900584,21.3775223,599.4626527,187.4981235,697.864917,16.6116715,33.91377,1.7758722,142.0408988),(46628,'tibia fibula',230,8,14,204.5729929,85.6722863,76.205122,1.8,85.6116125,76.3397392,1.3927884,17.5915425,18.6537711,4745.0616294,19493.7107305,33.0264836,1045.027874,269.7353924,1275.4447875,20.6661029,37.0020487,1.7076173,112.242086),(46629,'tibia fibula',230,8,15,268.0362751,86.5049533,77.1982514,1.8,86.7484489,77.3214988,1.3921092,17.7756753,20.8425671,12921.2030976,25779.0320214,43.2614702,1236.845343,726.9036398,1855.9789348,0.9261709,3.453125,1.1760052,7.6953057),(46630,'tibia fibula',230,8,16,297.4788343,87.352231,78.301055,1.8,86.8615179,78.3192594,1.3782977,18.5330757,33.0311809,19525.4107486,30758.2437478,47.7651716,931.1881341,1053.5440033,1486.2080049,1.7416249,4.8834562,1.1801893,12.6966067),(46631,'tibia fibula',230,8,17,302.8303844,87.6072071,80.0242098,1.8,87.3304894,79.866062,1.4194653,20.0216176,31.5328404,24881.6238996,37524.6309751,49.3246712,1190.017472,1242.7379421,1873.6570624,0.751301,2.4489415,0.8621701,5.0390557),(46632,'tibia fibula',230,8,18,318.9149252,88.4494458,82.1240279,1.8,87.9535575,81.75326,1.3233651,22.1627749,27.8896513,28060.0260759,46249.1606449,49.9642436,1658.2911046,1266.0881249,2602.8385177,37.6477121,46.4874106,2.165138,168.1964713),(46633,'tibia fibula',230,8,19,316.6075306,88.3705811,82.8734379,1.8,88.1371739,82.3875276,1.3806553,21.901616,28.7765023,27531.920051,49864.9583241,50.8830511,1732.8359724,1257.0725407,2683.4229685,0.4761082,1.328125,0.9272952,2.7851529),(46634,'tibia fibula',230,8,20,343.0669337,88.2115746,82.8508393,1.8,88.1664256,82.5269482,1.4445237,21.2955314,27.9528045,29840.7507995,52683.4188136,56.27097,1884.7274783,1401.2681946,2869.6366563,0.5946295,1.7818667,1.1071487,3.8476529),(46635,'tibia fibula',230,8,21,371.9660357,88.0888191,82.7785493,1.8,88.2368612,82.3514764,1.4535596,21.0033303,27.3133789,30498.1324863,57603.1144374,61.1461578,2108.9706478,1452.0617498,3199.3919219,1.1318149,5.7463473,0.9827937,13.3300629),(46636,'tibia fibula',230,8,22,333.2698875,88.5744501,80.1777963,1.8,89.0414664,81.2267675,1.361022,18.7625716,25.6838196,20991.8613299,54901.0764402,53.1363524,2137.5744414,1118.8157896,2915.2458979,0.3756505,0.751301,0.7853982,1.5026019),(46637,'tibia fibula',230,8,23,280.5896271,88.9263016,78.3321272,1.8,89.5125916,80.4976016,1.3089535,19.2778944,23.8987468,15001.6875656,43659.7883513,43.6312648,1826.8651775,778.1808159,2402.7942908,32.9970672,47.2140499,2.0822664,156.1600175),(46638,'tibia fibula',230,8,24,241.576701,89.0423158,78.0502072,1.8,89.72245,79.9272688,1.2810673,19.3142328,32.0515775,12494.0130839,37993.2476136,36.9765267,1185.3783981,646.8811466,1565.7066375,0.265625,0.3756505,2.3561945,0.751301),(46639,'tibia fibula',230,8,25,212.1289677,89.4759625,77.7077277,1.8,89.9989484,78.9510541,1.2445435,19.4357468,32.7399526,9948.1484038,33309.8684431,31.7232672,1017.4073524,511.8480151,1305.242621,31.3123537,47.4071796,2.0544914,138.2954522),(46640,'tibia fibula',230,8,26,200.1594398,89.3800544,76.7157095,1.8,90.0580938,77.9538681,1.2395763,17.9359742,23.1918168,8332.6393582,31473.1657731,29.8319933,1357.0806454,464.5769048,1670.6503495,29.0371296,45.8755215,2.065522,129.8110907),(46641,'tibia fibula',230,8,27,191.7922988,89.3057328,76.0460934,1.8,90.0766448,77.1869405,1.2325909,16.7861849,22.7211741,7312.2639606,30123.7989358,28.4463863,1325.8029173,435.6120232,1641.7608287,27.3083672,44.7970085,2.0583121,124.020734),(46642,'tibia fibula',230,8,28,187.1485815,89.2078383,75.4371299,1.8,90.109629,76.5894892,1.2322147,16.0590854,22.397213,6479.7591978,29199.9807977,27.7502875,1303.732781,403.4949081,1590.8635278,26.2636484,43.6894587,2.099746,121.4289355),(46643,'tibia fibula',230,8,29,181.0707683,89.1145307,74.8703739,1.8,90.1126823,76.1511015,1.2239446,15.5505961,21.8220234,5684.3306848,28604.4250492,26.6910892,1310.8053518,365.5377987,1568.7064215,25.2510106,43.3677047,2.1112158,119.6418312),(46644,'tibia fibula',230,8,30,176.4769323,89.0729215,74.5048439,1.8,90.0555948,75.7897883,1.2195824,15.1743338,22.0071276,5159.7127875,27884.4651877,25.9314591,1267.0651848,340.0289498,1501.4362337,24.5028793,42.9130321,2.1175852,117.9191783),(46645,'tibia fibula',230,8,31,171.0477485,89.099662,74.3350861,1.8,90.0569076,75.6388903,1.2195144,14.6682388,21.3829482,4670.8119825,26641.0782486,25.1324446,1245.9029514,318.4303196,1453.7893105,23.6966471,42.5481173,2.1154985,116.4165764),(46646,'tibia fibula',230,8,32,165.518866,89.0910303,74.2154381,1.8,90.1160115,75.4753076,1.2249925,14.3122457,21.0999339,4283.9501067,25455.8087999,24.4170899,1206.4402154,299.3206104,1396.1693013,23.1338824,42.1063803,2.0852476,114.9784259),(46647,'tibia fibula',230,8,33,157.7413434,89.3151655,74.3452219,1.8,90.233567,75.5901425,1.2295138,13.850352,21.2231445,3879.8666601,23642.9121965,23.3451567,1114.015514,280.1276566,1293.9459723,0.265625,0.3756505,2.3561945,0.751301),(46648,'tibia fibula',230,8,34,153.5752731,89.5010982,74.5541611,1.8,90.3295484,75.6986754,1.2332931,13.5852502,20.9501926,3611.3200182,22092.5859792,22.7893279,1054.5290166,265.8265373,1220.1733816,0.265625,0.5939556,2.0344439,1.282551),(46649,'tibia fibula',230,8,35,149.3117277,89.681794,74.862343,1.8,90.3553009,75.8477661,1.2387964,13.1076551,20.8637227,3367.686004,20366.63076,22.2416433,976.1743408,256.9251316,1132.5313106,0.3756505,0.751301,0.7853982,1.5026019),(46650,'tibia fibula',230,8,36,144.1110405,89.8240586,75.1900305,1.8,90.4026336,76.0139815,1.2460854,12.7415479,20.6987578,3164.3367191,18656.1033203,21.5738254,901.3151184,248.347905,1051.4861581,20.7364814,38.8802781,2.0772313,105.0936688),(46651,'tibia fibula',230,8,37,141.5196447,89.9378731,75.4097257,1.8,90.4505075,76.0836057,1.2522026,12.4809552,20.4290568,3024.7764267,17405.240932,21.2724343,851.98456,242.3513574,991.8162397,0.5804229,2.51994,1.2490458,5.4414029),(46652,'tibia fibula',230,8,38,139.8744777,90.015183,75.5739065,1.8,90.5331368,76.1364387,1.2573946,12.2112575,20.3466748,2910.0950212,16591.0955328,21.0966452,815.4204894,238.3124771,953.717175,0.265625,0.83998,1.8925469,1.813801),(46653,'tibia fibula',230,8,39,138.8992566,90.1033484,75.698292,1.8,90.6001905,76.1969597,1.2599147,11.9849965,21.1643124,2842.3137892,15942.7189739,20.9836578,753.2831069,237.1559966,884.9624511,0.9584997,4.9622845,1.2998495,11.4140557),(46654,'tibia fibula',230,8,40,140.6971895,90.3007582,75.8473599,1.8,90.6752657,76.1653767,1.2554227,11.9078968,20.4466552,2893.5909546,15650.2247307,21.1935352,765.4173544,242.9976522,896.934271,0.265625,0.83998,1.8925469,1.813801),(46655,'tibia fibula',230,8,41,139.0631405,90.4532154,75.8670811,1.8,90.7627328,76.12293,1.2564838,11.704176,21.7794441,2798.1074876,15146.8530242,20.9618776,695.4655467,239.0691567,822.75866,2.0972376,13.0805143,1.152572,28.6829196),(46656,'tibia fibula',230,8,42,138.3128882,90.4736773,75.9022305,1.8,90.8043074,76.218696,1.2606847,11.5107121,20.4584554,2672.2876519,14761.5302964,20.9054014,721.5368907,232.1565887,847.0039959,1.7655861,10.0972445,1.1071487,26.311172),(46657,'tibia fibula',230,8,43,137.191679,90.4533211,75.8366922,1.8,90.7341897,76.10604,1.2651747,11.2237387,20.3794748,2563.5572629,14490.2908473,20.7952312,711.0237629,228.4049314,831.2955662,2.2090871,14.7846026,1.2604089,36.0292715),(46658,'tibia fibula',230,8,44,138.1596948,90.4235419,75.6829863,1.8,90.7093277,75.9122196,1.2706035,11.0414735,20.4645126,2459.8026843,14576.1978852,21.0131434,712.2670428,222.7784806,826.7927728,1.1892591,3.4633263,1.0040671,7.8509053),(46659,'tibia fibula',230,8,45,138.7239768,90.3875379,75.4822899,1.8,90.6790914,75.797377,1.2757819,10.8497458,20.4262269,2376.1502993,14686.8201477,21.1660956,719.0177708,219.0051578,830.5435474,0.265625,0.3756505,2.3561945,0.751301),(46660,'tibia fibula',230,8,46,139.4113482,90.3779332,75.3668715,1.8,90.693559,75.743844,1.2805347,10.6567573,20.1237107,2310.8967256,14719.8272962,21.3319783,731.4668508,216.8480197,839.0508348,0.265625,0.3756505,2.3561945,0.751301),(46661,'tibia fibula',230,8,47,139.0126176,90.3901472,75.3655937,1.8,90.6223518,75.6804497,1.2824481,10.5769464,20.092797,2244.0928822,14542.2410111,21.2952101,723.7539412,212.1683128,822.7591482,1.3997975,10.2601417,1.199905,23.4882643),(46662,'tibia fibula',230,8,48,139.5839126,90.405033,75.4293625,1.8,90.6148781,75.7789701,1.2861599,10.4366979,19.7719482,2205.3421533,14394.1883018,21.4295406,728.0106226,211.3065036,833.7428919,0.7870088,3.2855998,1.3258177,7.0351529),(46663,'tibia fibula',230,8,49,140.5586847,90.5301229,75.488089,1.8,90.6598704,75.8442007,1.2875932,10.3468718,19.5306506,2167.0885417,14111.9202807,21.5972501,722.5524942,209.4438382,827.8456145,1.6325337,11.4434752,1.1902899,28.0605215),(46664,'tibia fibula',230,8,50,141.5949693,90.5700909,75.5640116,1.8,90.6770286,75.9617386,1.287325,10.2921602,19.4667497,2129.2865801,14020.3412773,21.7530798,720.2199377,206.8843207,823.4668929,1.5123445,11.347505,1.2120257,26.622371),(46665,'tibia fibula',230,8,51,141.5974922,90.56891,75.5727877,1.8,90.6662552,75.9283878,1.2881293,10.2074357,19.5146679,2078.7161468,13890.8133993,21.7636495,711.8139787,203.6472429,809.4628824,4.5558531,23.9298495,1.6152115,70.164652),(46666,'tibia fibula',230,8,52,142.4619821,90.5368481,75.5386835,1.8,90.6255823,75.8912219,1.2878894,10.155591,19.7287299,2040.6110571,14042.3815315,21.893469,711.7732162,200.9347414,807.1352437,1.9047574,14.3756878,1.2899586,32.7773201),(46667,'tibia fibula',230,8,53,144.7604181,90.4818645,75.4731534,1.8,90.5320726,75.8009476,1.2859288,10.1396298,20.0910259,2015.8363537,14526.5826252,22.2212546,723.0383704,198.8076872,817.9392156,2.1851604,12.0120077,1.2560387,34.1620772),(46668,'tibia fibula',230,8,54,147.7926218,90.4780259,75.5092264,1.8,90.5395426,75.8079282,1.2858459,10.1265889,20.1247574,2002.656305,14775.9239787,22.6856072,734.2162516,197.7621806,828.3162017,16.6488407,35.8987053,1.9980362,93.4862587),(46669,'tibia fibula',230,8,55,148.7793458,90.4678039,75.560586,1.8,90.5074881,75.8113055,1.2848852,10.0063237,20.2482683,1990.125003,14896.9386311,22.8241932,735.7142065,198.8867297,827.6379533,1.7571881,13.0264623,1.2812927,36.8827787),(46670,'tibia fibula',230,8,56,148.1474362,90.4367202,75.5936024,1.8,90.4238537,75.8623582,1.284075,10.050346,20.4528378,1974.5418042,14931.1689312,22.7164116,730.0292061,196.4650568,822.124011,1.6818778,12.8519686,1.2555816,32.9062229),(46671,'tibia fibula',230,8,57,147.0851953,90.4735571,75.6170498,1.8,90.4279647,75.8374066,1.2849078,9.9956959,20.5434079,1957.8464035,14766.4490995,22.5645933,718.7925753,195.868944,789.170402,0.265625,0.5939556,2.0344439,1.282551),(46672,'tibia fibula',230,8,58,147.0822661,90.4646681,75.719333,1.8,90.3731244,75.9037468,1.2882167,9.9258684,20.4654174,1942.7689822,14552.2422676,22.6078111,711.0650131,195.7278596,798.6033478,4.9160468,25.0590124,1.6556981,75.0214116),(46673,'tibia fibula',230,8,59,145.5246962,90.5123453,75.9427356,1.8,90.4145473,76.0785358,1.2916202,9.7676952,20.3551543,1924.5537291,14126.409668,22.4123709,693.9966891,197.0325335,781.8848553,1.8806047,11.0066231,1.226149,30.4055724),(46674,'tibia fibula',230,8,60,144.557942,90.5491556,76.1555457,1.8,90.4259173,76.2011719,1.2977179,9.7549216,20.2259722,1914.8739501,13713.1034575,22.3405502,677.9947746,196.29824,766.4558835,4.8723323,24.5541543,1.6683121,90.0741274),(46675,'tibia fibula',230,8,61,144.6972379,90.5805373,76.3934711,1.8,90.4168714,76.4642024,1.3039042,9.6584476,20.1211243,1910.7980541,13440.5938501,22.4387779,667.9842354,197.8369758,757.1872907,4.7352481,25.0195627,1.6345396,83.0012197),(46676,'tibia fibula',230,8,62,143.5085295,90.5966979,76.5643669,1.8,90.4114284,76.6221822,1.3123486,9.6802273,19.9440652,1897.0979653,13099.1017857,22.3557303,656.7919661,195.9765931,746.34903,0.53125,0.751301,0.7853982,1.5026019),(46677,'tibia fibula',230,8,63,142.8663572,90.6387685,76.7233331,1.8,90.4776687,76.7585039,1.3207578,9.5924931,19.6382735,1873.9822226,12767.9162446,22.3531751,650.1547227,195.3592461,737.0425324,2.9994226,15.7325362,1.7748143,54.9406982),(46678,'tibia fibula',230,8,64,143.162353,90.6608729,76.8927879,1.8,90.4657908,76.8757265,1.3298493,9.477859,19.7166591,1867.7424195,12491.4373859,22.5017655,633.547362,197.0637474,720.5288552,1.7357256,11.1720498,1.2565644,35.9114267),(46679,'tibia fibula',230,8,65,143.399744,90.7528073,77.0569677,1.8,90.5378928,76.9883839,1.3403932,9.4197317,19.7445099,1863.9656806,12138.4410375,22.6535062,614.7755032,197.8788513,702.9163149,4.1068578,25.2567335,1.6128767,81.460863),(46680,'tibia fibula',230,8,66,143.3480025,90.8304424,77.3306018,1.8,90.6411023,77.3490341,1.3530862,9.3621283,19.5618577,1855.2578469,11733.7172744,22.7767176,599.8263283,198.1662488,690.361584,3.9516111,25.5124481,1.6020362,76.0194602),(46681,'tibia fibula',230,8,67,141.5231298,90.9516095,77.7672945,1.8,90.7410296,77.7388507,1.3712217,9.2566821,19.3976413,1854.505491,10828.3063468,22.660117,558.2279931,200.3423554,648.8045668,3.5158314,24.1850067,1.5378412,68.0018973),(46682,'tibia fibula',230,8,68,136.6200206,91.0904995,78.3877886,1.8,90.877193,78.4112527,1.3959686,10.2106356,18.2127583,1847.1197563,9483.9138909,22.081106,520.7291353,180.9015449,617.823773,0.265625,0.3756505,2.3561945,0.751301),(46683,'tibia fibula',230,8,69,135.318165,91.1689215,78.8148504,1.8,90.9566212,78.8882956,1.4143021,10.025948,16.864319,1854.1933178,8798.2034649,22.0051878,521.7052338,184.9394514,628.4607147,3.0174387,21.0916955,1.4698745,58.9973439),(46684,'tibia fibula',230,8,70,134.8425919,91.2281716,79.1194504,1.8,91.0617392,79.2112862,1.4287315,9.0649677,16.0209122,1856.4975271,8391.5681157,22.0232338,523.788409,204.7991341,634.8497846,2.9699427,21.3840498,1.4587674,59.6841935),(46685,'tibia fibula',230,8,71,133.9738045,91.252454,79.4154176,1.8,91.0429316,79.5041489,1.4424719,8.9467687,15.4699454,1863.1551662,8054.4425944,21.9632869,520.6510034,208.2489481,633.195372,2.6528595,20.6248875,1.441649,54.9563368),(46686,'tibia fibula',230,8,72,132.499192,91.2831483,79.6900498,1.8,91.1348406,79.8357683,1.4557158,9.0750383,15.0736042,1868.2615793,7690.6075055,21.7920281,510.203626,205.8681748,633.1659583,2.7188331,18.5196066,1.4268709,53.0246911),(46687,'tibia fibula',230,8,73,130.8345898,91.3375276,79.9038839,1.8,91.1258185,80.0787946,1.4655673,9.0085739,14.5184023,1875.3182025,7339.1651705,21.5651966,505.507769,208.1703746,631.8812581,2.5592003,20.9625084,1.418147,58.1815915),(46688,'tibia fibula',230,8,74,130.1520078,91.3371898,80.1339341,1.8,91.1126797,80.2855051,1.4760865,8.9082052,14.1782178,1885.8465295,7073.3264782,21.4980064,498.8868555,211.6976969,627.6873178,2.5457325,21.2665951,1.407701,60.0865406),(46689,'tibia fibula',230,8,75,128.5728219,91.3344879,80.4009252,1.8,91.0905384,80.6455159,1.4868704,9.2357981,13.8999985,1895.3713238,6803.7434986,21.2782228,489.4780038,205.2200916,622.4318472,2.5156629,19.650865,1.4078699,52.0155844),(46690,'tibia fibula',230,8,76,128.4609575,91.3094157,80.6192406,1.8,91.0745721,80.8986422,1.4984804,9.1511219,13.5682337,1911.8382793,6599.1012259,21.2983882,486.364061,208.9184575,611.7599532,2.4168708,20.7000116,1.4161958,55.7076377),(46691,'tibia fibula',230,8,77,129.3377414,91.2681691,80.8426692,1.8,91.0370966,81.1257419,1.5067158,9.3084018,13.9038078,1931.1416563,6420.8981267,21.4678944,461.8086069,207.4622143,600.3632134,2.1365101,18.1287846,1.3791478,49.1392834),(46692,'tibia fibula',230,8,78,128.461599,91.229405,81.0903816,1.8,90.9832424,81.3768121,1.5171044,9.1452884,13.8879408,1946.8604066,6188.1432291,21.3486039,445.5767291,212.8812486,585.5633576,0.53125,0.751301,0.7853982,1.5026019),(46693,'tibia fibula',230,8,79,127.5725853,91.1908481,81.3170264,1.8,90.9544806,81.6201066,1.5276349,9.2613793,12.8690738,1959.6832054,5987.577002,21.2225128,465.2686801,211.5973383,599.5072736,0.265625,0.3756505,2.3561945,0.751301),(46694,'tibia fibula',230,8,80,126.9722124,91.1239076,81.5476536,1.8,90.8937858,81.8673832,1.5374477,9.1620716,12.7884565,1985.1138656,5834.9977512,21.1385092,456.2706816,216.666486,592.219735,1.8734655,16.5136736,1.3765553,37.8430724),(46695,'tibia fibula',230,8,81,125.8319102,91.0897468,81.7194328,1.8,90.8140188,82.0079437,1.544096,9.2661857,12.4430986,2001.5238565,5641.2837703,20.9570376,453.3664778,216.0029944,577.8698996,2.2064598,19.0732808,1.3460852,48.8280844),(46696,'tibia fibula',230,8,82,124.9277162,91.0210785,81.907082,1.8,90.7372951,82.2079038,1.5518728,9.1255345,12.3496667,2013.2558558,5488.2252576,20.8138307,444.4027021,220.6178557,566.6065516,2.1782259,19.3323182,1.3491468,46.729781),(46697,'tibia fibula',230,8,83,124.1710924,90.9545596,82.135839,1.8,90.6840008,82.4658424,1.5615083,9.2299448,12.2917663,2035.091285,5354.8322341,20.6933968,435.6438373,220.4879162,559.8233788,2.270578,19.1986429,1.3191064,51.3931863),(46698,'tibia fibula',230,8,84,125.5192374,90.8634705,82.3457911,1.8,90.555646,82.6249314,-1.5692072,9.0370326,12.2203222,2077.0250687,5278.1400709,20.91982,431.9149672,229.8348551,558.0199727,2.3645505,18.8762029,1.3292306,47.0409801),(46699,'tibia fibula',230,8,85,126.0773404,90.7933017,82.5435498,1.8,90.5139244,82.7836225,-1.5630736,9.177949,12.1488494,2110.9469175,5215.7502628,21.0116369,429.3205142,230.0020317,555.6837483,2.2093046,18.9415025,1.3156139,49.074832),(46700,'tibia fibula',230,8,86,126.8360167,90.721118,82.7243259,1.8,90.4452727,83.0556919,-1.5563431,9.0482592,12.8577016,2140.6824929,5164.8101225,21.1349206,401.6899981,236.5850102,554.7486584,1.9559516,15.332799,1.3258177,38.1275748),(46701,'tibia fibula',230,8,87,127.2908077,90.6589543,82.868524,1.8,90.356341,83.189382,-1.5489228,9.1894092,12.732898,2168.8035532,5116.2787277,21.2049859,401.8157329,236.0112076,559.0280222,2.1275245,15.332799,1.3258177,37.3762739),(46702,'tibia fibula',230,8,88,125.8026185,90.5873193,83.0481792,1.8,90.3026589,83.3998283,-1.5411307,9.062869,11.8473091,2204.3067185,5050.1523582,20.9486564,426.2699929,243.2239419,556.0394051,2.0452774,17.3329217,1.3072324,43.2577787),(46703,'tibia fibula',230,8,89,125.2555266,90.5481578,83.185283,1.8,90.2428973,83.5157284,-1.5384779,9.2629222,11.7269998,2218.4290385,4928.8389513,20.8541242,420.2983731,239.4955929,560.9160699,2.2446417,17.7333287,1.282209,41.7551767),(46704,'tibia fibula',230,8,90,126.4257833,90.4919606,83.3082636,1.8,90.1840072,83.6598583,-1.5430543,9.2562988,11.5874442,2225.0490729,4828.5475834,21.0547515,416.7051427,240.3821583,558.9838853,2.2995026,17.6595683,1.2966289,42.1952787),(46705,'tibia fibula',230,8,91,127.6261014,90.4107027,83.4838118,1.8,90.1150262,83.8360182,-1.5407267,9.4270721,11.4992719,2257.2290672,4774.9712718,21.2517899,415.2411817,239.4411587,563.7497977,2.3558807,15.7996644,1.2809498,38.7232763),(46706,'tibia fibula',230,8,92,128.7791466,90.3313668,83.6213251,1.8,90.0083153,83.916659,-1.5365386,9.3283693,12.4167855,2290.6689523,4734.387713,21.4380118,381.2893214,245.5594192,562.2533072,2.5111072,17.2247111,1.2734312,43.6978806),(46707,'tibia fibula',230,8,93,129.5417784,90.2755729,83.708409,1.8,89.9509244,84.0145109,-1.546289,9.3478621,12.2459996,2303.1486418,4690.684436,21.5773318,383.0380998,246.3823935,564.2085552,2.4085796,16.6392385,1.2793395,42.6353806),(46708,'tibia fibula',230,8,94,129.6912516,90.2216926,83.7999076,1.8,89.9204883,84.1231773,-1.5579775,9.6428211,11.2811146,2308.7574472,4640.9453026,21.6116569,411.3906719,239.4275923,563.3296935,2.5837316,16.9709224,1.2688452,39.4745772),(46709,'tibia fibula',230,8,95,129.9427539,90.1510571,83.9072923,1.8,89.8598151,84.2354945,-1.566433,9.6363238,11.1254818,2314.5779379,4601.3061164,21.6567133,413.582638,240.1930423,560.2832815,2.3973394,16.7175014,1.26412,40.8215796),(46710,'tibia fibula',230,8,96,131.2088821,90.0554279,84.0565643,1.8,89.7845907,84.3277895,-1.5659635,9.5381402,11.2725738,2333.9603639,4554.9436448,21.8676364,404.073081,244.6976368,564.1281517,2.3509447,14.9601358,1.2827409,36.8183272),(46711,'tibia fibula',230,8,97,132.1618885,90.0217529,84.1547308,1.8,89.7854987,84.5231968,-1.5624847,9.7448603,11.463041,2356.9960989,4524.7242107,22.0254599,394.7228514,241.8706914,559.9381551,2.4992157,16.4644652,1.2592495,42.0129825),(46712,'tibia fibula',230,8,98,132.718217,89.9553948,84.2758909,1.8,89.7043157,84.6568978,-1.5591508,9.6564065,12.2793746,2370.2682834,4499.0789405,22.1167031,366.3931659,245.4606987,557.0919144,2.589708,15.0377536,1.265804,36.5071282),(46713,'tibia fibula',230,8,99,132.6164016,89.8834728,84.3794481,1.8,89.5882225,84.7265058,-1.5582359,9.5794318,12.1272074,2376.2754555,4464.8316948,22.0992467,368.1665148,248.0601679,558.4630993,2.6780629,14.7846026,1.2604089,39.9146791),(46714,'tibia fibula',230,8,100,133.3813639,89.7926434,84.5157113,1.8,89.510996,84.8754039,-1.5444586,9.6624641,12.0026195,2405.8164087,4466.2319598,22.2148104,372.1047683,248.9858051,568.1911651,2.5855316,14.7846026,1.2604089,38.7877277),(46715,'tibia fibula',230,8,101,134.4942131,89.6834369,84.6526833,1.8,89.4097785,84.977496,-1.5310602,9.4872386,11.3034609,2437.5657242,4461.2076558,22.3803272,394.67626,256.9310036,570.7149035,2.6453751,14.7846026,1.2604089,35.9381234),(46716,'tibia fibula',230,8,102,134.5337035,89.5874224,84.768854,1.8,89.3331898,85.0831111,-1.5228033,10.1659504,11.1743991,2462.8998999,4433.3895775,22.3706776,396.7452341,242.2695165,575.1660811,2.5607229,14.8678833,1.2433961,34.8756234),(46717,'tibia fibula',230,8,103,134.5931635,89.4926668,84.8799269,1.8,89.2367702,85.2234799,-1.5097105,9.5200951,11.2334763,2484.7379957,4403.7325643,22.3485928,392.0186827,260.9992823,573.6899944,2.9499417,14.2078341,1.2076493,33.5930724),(46718,'tibia fibula',230,8,104,134.7792192,89.400612,84.9876582,1.8,89.1483381,85.2917045,-1.5017613,9.5693362,11.1069745,2492.9257755,4347.5541338,22.3563172,391.4255984,260.5118807,573.6133871,2.8517449,12.6862011,1.2291808,35.2245772),(46719,'tibia fibula',230,8,105,134.7701537,89.3593563,85.0609169,1.8,89.0929826,85.4408746,-1.5050462,9.5709653,10.9555978,2476.2459734,4276.7242797,22.3647285,390.3688648,258.7247891,573.5615653,3.1382697,13.617006,1.2120257,36.9472301),(46720,'tibia fibula',230,8,106,134.0811788,89.3065121,85.1592216,1.8,89.0353081,85.5141409,-1.5126474,9.5530042,11.0124491,2443.5022993,4193.0628027,22.2713867,380.7566128,255.7836518,554.9033339,3.0101989,12.2821048,1.194306,35.1601258),(46721,'tibia fibula',230,8,107,134.038909,89.2289923,85.2615568,1.8,88.9897672,85.6261217,-1.5145325,9.6419979,10.8854486,2419.9692885,4143.6315568,22.2691734,380.6578603,250.9821427,554.6578502,3.3532005,13.4659038,1.186627,42.9843344),(46722,'tibia fibula',230,8,108,133.9933037,89.1466364,85.3594196,1.8,88.9074523,85.7171004,-1.5157013,9.4372533,10.7228496,2396.4627138,4104.3802072,22.2644972,382.769539,253.9364616,575.4243459,0.265625,0.3756505,2.3561945,0.751301),(46723,'tibia fibula',230,8,109,134.352266,89.0802704,85.4308073,1.8,88.8483795,85.7592355,-1.5231745,9.4909268,10.8745426,2375.7497121,4076.8195427,22.3413011,374.8957257,250.3179898,565.1248711,3.1311101,12.7776393,1.2095926,37.2584291),(46724,'tibia fibula',230,8,110,134.8998283,89.0114586,85.5207413,1.8,88.7668093,85.86182,-1.5261584,9.4373264,10.6264156,2356.3510225,4039.1265895,22.4385356,380.1024483,249.6841706,575.6472859,3.2448761,13.4659038,1.186627,36.1959291),(46725,'tibia fibula',230,8,111,135.7914504,88.9339103,85.5990455,1.8,88.695616,85.8610344,-1.5319488,9.3424311,11.4623292,2333.7595429,4002.861966,22.597771,349.2188967,249.8021675,551.0237273,3.0625635,11.6905181,1.1987286,34.3443734),(46726,'tibia fibula',230,8,112,136.8282054,88.8384859,85.6929542,1.8,88.6255278,85.9362928,-1.5365969,9.3258092,11.5636292,2323.2487161,3991.4483272,22.778039,345.1726321,249.1203348,544.283297,3.1980255,11.7896812,1.1777383,34.7844753),(46727,'tibia fibula',230,8,113,136.8819781,88.7828489,85.7789785,1.8,88.5529693,86.0384785,-1.5396746,9.3145572,10.6149412,2306.9714816,3947.2855947,22.7915737,371.8612783,247.6737679,566.0912146,3.3957335,12.7306168,1.1631648,37.5051767),(46728,'tibia fibula',230,8,114,136.7571784,88.6908575,85.8874813,1.8,88.4824219,86.1252441,-1.5443832,9.2050058,10.7055901,2289.771927,3903.645726,22.7769653,364.6362036,248.7529043,563.1959119,2.9834668,11.7896812,1.1777383,30.8456744),(46729,'tibia fibula',230,8,115,137.098865,88.5901173,86.0140438,1.8,88.3703035,86.2424837,-1.5449826,9.4373302,10.5763403,2284.2624126,3871.1716668,22.8345883,366.0218533,242.0454048,569.7540011,3.1970718,12.1376384,1.1659045,32.5683272),(46730,'tibia fibula',230,8,116,136.5376403,88.5130658,86.1112336,1.8,88.3269838,86.2803207,-1.5477345,9.3125747,11.105945,2262.3280295,3838.3917437,22.7441727,345.6159509,242.9326059,549.234475,3.1044945,12.3822284,1.174355,34.0976258),(46731,'tibia fibula',230,8,117,136.5613517,88.4299435,86.2256614,1.8,88.2563536,86.4371226,-1.5531439,9.2563739,10.9909667,2242.8022018,3817.1293619,22.7531337,347.2969636,242.2981415,551.247998,2.8299132,11.0991844,1.2036225,33.1907253),(46732,'tibia fibula',230,8,118,136.5147629,88.34874,86.3381354,1.8,88.1580421,86.5073904,-1.554926,9.166199,10.6035656,2217.1719709,3770.8380558,22.7467303,355.6198169,241.8856455,551.3675177,2.9273614,8.6725647,1.0934509,26.9980215),(46733,'tibia fibula',230,8,119,137.4845105,88.2766671,86.4632092,1.8,88.1108742,86.6051051,-1.5601432,8.8274318,10.4929138,2196.0671468,3738.762964,22.9114847,356.3131316,248.777583,555.4022842,2.8408824,7.6063424,1.1383886,25.7154705),(46734,'tibia fibula',230,8,120,136.7717601,88.2045445,86.5768711,1.8,88.0393447,86.6679141,-1.5641001,9.5632087,10.6346398,2165.9517776,3671.9054262,22.7942712,345.2778374,226.4879762,545.9457692,2.348902,10.359375,1.1760052,27.3092205),(46735,'tibia fibula',230,8,121,136.2619349,88.1835813,86.6905917,1.8,88.0330296,86.8682235,-1.5676511,8.762803,10.5272585,2136.0746144,3624.7207698,22.7100978,344.3176384,243.7661332,538.8064371,2.7836704,11.4095137,1.1383886,33.3463248),(46736,'tibia fibula',230,8,122,135.1808789,88.1065833,86.8247264,1.8,87.9506304,86.9578431,-1.5650122,9.2079217,10.6513203,2106.5014762,3561.2205396,22.5293927,334.3454572,228.7705686,527.1136372,2.6884643,11.1688916,1.1284221,31.6881234),(46737,'tibia fibula',230,8,123,134.3229529,88.0430585,86.9534181,1.8,87.9076144,87.0563602,-1.5665251,8.6237757,10.5302439,2066.5037402,3495.8964286,22.3867504,331.9862729,239.6286523,502.6015649,0.53125,0.9577246,0.5880026,1.8782524),(46738,'tibia fibula',230,8,124,133.9376495,87.979426,87.0625378,1.8,87.8352487,87.1273507,1.568518,8.8214799,10.8337124,2032.9534076,3444.0431253,22.3228257,317.9005504,230.4549167,493.3576956,15.4383801,19.4342403,1.7494273,56.652293),(46739,'tibia fibula',230,8,125,132.5288045,87.9066968,87.1883093,1.8,87.7589181,87.264462,1.5606412,9.0257536,10.8430961,1999.1136631,3380.5537798,22.0858564,311.7701582,221.4899433,491.4641361,15.2777087,19.3469113,1.7224018,56.2766425),(46740,'tibia fibula',230,8,126,130.7506916,87.8418343,87.3283773,1.8,87.7689585,87.4266054,1.5565382,8.9625485,10.6986642,1970.4472919,3325.1598571,21.7873521,310.8014041,219.8534582,493.8474472,15.2666685,19.1729001,1.751889,55.900992),(46741,'tibia fibula',230,8,127,130.8755982,87.7935133,87.4401605,1.8,87.6992945,87.4930856,1.5498466,8.3631992,10.968457,1941.2956927,3273.9885139,21.8030278,298.4912553,232.1235748,472.4902861,15.152314,19.2426934,1.6814535,55.5253415),(46742,'tibia fibula',230,8,128,131.5802239,87.7378544,87.5516667,1.8,87.6693028,87.5511748,1.5446925,8.3020098,10.7636978,1918.8901086,3234.3892562,21.9150973,300.4905302,231.1356099,475.8094961,15.152314,19.0843753,1.7245039,54.9940915),(46743,'tibia fibula',230,8,129,131.7773335,87.718309,87.6495677,1.8,87.6610829,87.6967366,1.5412811,8.5428494,10.584169,1895.0442733,3180.9572094,21.9437616,300.5391565,221.8281266,475.9341758,15.0916442,18.9787157,1.6829991,54.838492),(46744,'tibia fibula',230,8,130,131.4296389,87.6724016,87.7519993,1.8,87.5820299,87.7446687,1.5376054,8.5170985,10.5493597,1853.9975951,3124.5960443,21.8808174,296.1882183,217.6794835,471.5400927,14.9598006,19.0102897,1.6968844,54.4628415),(46745,'tibia fibula',230,8,131,130.8641809,87.6203879,87.8760969,1.8,87.570669,87.9189144,1.5360039,9.0507924,10.4001034,1823.3692083,3090.7458923,21.7843053,297.1841505,201.4596205,465.1874574,14.8151453,18.9265967,1.6551031,54.6184411),(46746,'tibia fibula',230,8,132,132.0019602,87.559161,87.9860166,1.8,87.5170999,88.0355821,1.532005,8.4044034,10.7705971,1805.4360571,3072.3538913,21.9672378,285.2538127,214.8202513,444.4532194,0.265625,0.5939556,2.0344439,1.282551),(46747,'tibia fibula',230,8,133,131.9554569,87.4877456,88.0755325,1.8,87.4417831,88.0850892,1.5353694,8.3208254,10.489557,1792.1467224,3054.694168,21.9649856,291.2128863,215.3808837,459.631525,14.7692979,18.7825239,1.7126934,54.0871911),(46748,'tibia fibula',230,8,134,131.335713,87.4350886,88.1725258,1.8,87.3678106,88.1973735,1.533548,9.3552003,10.6735647,1769.6819,3019.0029759,21.8589296,282.8486129,189.1655816,444.2406897,14.6879922,18.9060821,1.6411028,53.775992),(46749,'tibia fibula',230,8,135,131.2666103,87.3834901,88.2699764,1.8,87.32557,88.3400027,1.5249907,8.2001534,10.2868546,1749.074781,2987.8981269,21.8318975,290.4578939,213.2978121,450.4800686,14.5568711,18.7468031,1.6986662,53.7115406),(46750,'tibia fibula',230,8,136,131.3595526,87.3312311,88.3550113,1.8,87.3070927,88.3592487,1.5216255,8.261313,10.2216319,1729.9226122,2956.8476912,21.8403686,289.2735444,209.4004446,458.2396962,14.5337532,18.7147846,1.6845883,53.5559411),(46751,'tibia fibula',230,8,137,129.974761,87.3224278,88.410625,1.8,87.3022456,88.4683091,1.515059,8.1706616,10.3303307,1705.4238984,2902.1249098,21.5952322,280.9324311,208.7253138,433.8918167,14.4428751,18.5196066,1.7147218,52.9602396),(46752,'tibia fibula',230,8,138,128.4338681,87.2832444,88.4869732,1.8,87.2551988,88.5666739,1.511977,8.126565,10.0569269,1677.9398766,2848.6607043,21.3316726,283.2535963,206.4759056,439.3040321,14.34375,18.6240824,1.5137155,52.9602396),(46753,'tibia fibula',230,8,139,127.8203246,87.2411738,88.5706365,1.8,87.2207138,88.6776471,1.506939,8.3938323,10.1470108,1660.0117822,2794.9228127,21.2166354,275.4429716,197.7656596,433.2358401,0.265625,0.3756505,2.3561945,0.751301),(46754,'tibia fibula',230,8,140,126.1776805,87.1801406,88.6578535,1.8,87.1718634,88.7449384,1.5068778,7.9944281,10.0794873,1642.7289292,2753.2700215,20.9438123,273.1557601,205.484234,431.3893652,14.3408791,18.4509022,1.4553697,52.6490406),(46755,'tibia fibula',230,8,141,125.6680905,87.1359386,88.7592993,1.8,87.12341,88.8490285,1.5040478,8.2596817,10.0593105,1630.4390688,2736.0949145,20.851504,271.9962668,197.3973252,427.3213043,14.2531853,18.3415938,1.3961241,52.4289896),(46756,'tibia fibula',230,8,142,126.0063134,87.0901506,88.8529555,1.8,87.0912587,88.9398205,1.5025353,8.0665848,9.866256,1622.0254102,2707.3100107,20.9033484,274.4009501,201.0795698,432.3964211,14.2531853,18.397288,1.484058,52.6490406),(46757,'tibia fibula',230,8,143,125.2442375,87.0400723,88.9325224,1.8,87.0238095,89.0074285,1.4969259,8.0033765,9.7808852,1609.5133716,2682.0779669,20.7603404,274.2162825,201.1042926,429.3383673,14.2020904,18.2567678,1.4247841,52.0533392),(46758,'tibia fibula',230,8,144,124.9457402,87.0039686,89.0244664,1.8,87.0178054,89.0890027,1.4936857,7.9267682,10.0331072,1604.6494996,2643.383967,20.7007131,263.466133,202.434265,422.5054608,14.2531853,18.2200163,1.4392082,52.0533392),(46759,'tibia fibula',230,8,145,124.2950583,87.0058938,89.101888,1.8,87.0003559,89.2488907,1.4929496,7.9819895,9.8763803,1592.4627817,2594.971768,20.5905559,262.7452245,199.5070005,414.6816048,14.2020904,18.0351355,1.408069,51.8977396),(46760,'tibia fibula',230,8,146,123.3307414,86.96465,89.1816418,1.8,86.9754043,89.2710416,1.4923967,7.9353939,9.5306195,1580.6643811,2557.0746983,20.4290402,268.3009953,199.1916732,409.8638783,14.1785259,18.0351355,1.408069,51.5220892),(46761,'tibia fibula',230,8,147,123.0776142,86.9110285,89.2744165,1.8,86.9112479,89.3913089,1.4920025,7.9989944,10.1803821,1577.3030377,2525.4073283,20.385845,248.0660657,197.1876657,401.034629,14.1384259,17.8680944,1.3763162,51.3020382),(46762,'tibia fibula',230,8,148,122.1997399,86.8596888,89.3666955,1.8,86.8294112,89.4782715,1.4932641,7.8564231,9.7028048,1571.8172332,2488.9619751,20.2444395,256.5198452,200.0677926,410.6987931,14.1509956,17.8937429,1.4666964,51.3664896),(46763,'tibia fibula',230,8,149,122.3891096,86.8242137,89.4534143,1.8,86.807361,89.5510753,1.4946562,7.8749638,9.8441502,1574.5987254,2459.3060801,20.2801585,249.8241107,199.9499626,394.9544344,14.078125,17.7313392,1.4204249,51.0819872),(46764,'tibia fibula',230,8,150,121.3050389,86.787939,89.539449,1.8,86.762747,89.6366138,1.486588,8.0460579,9.4696151,1570.1191162,2420.8277394,20.0744819,255.6416192,195.1414142,410.9452342,14.078125,17.6934964,1.4352686,50.9263877),(46765,'tibia fibula',230,8,151,121.6107416,86.7448256,89.6120826,1.8,86.7431899,89.7165994,1.4807747,8.0047634,9.5379093,1577.2950287,2387.0477178,20.1046467,250.2694929,197.0445528,408.6166272,14.078125,17.5573905,1.3882365,50.5507372),(46766,'tibia fibula',230,8,152,121.173098,86.6953757,89.6973869,1.8,86.7139211,89.8063247,1.4760988,7.7644413,9.6437665,1581.0056005,2354.1608645,20.0149513,244.1121792,203.6212962,401.2784517,14.078125,17.468757,1.418147,50.5507372),(46767,'tibia fibula',230,8,153,120.3307158,86.693983,89.7609149,1.8,86.6864867,89.8875,1.4701507,7.9527345,9.5065558,1575.3558358,2305.432841,19.8526551,242.5097879,198.0898305,400.5346762,0.265625,0.3756505,2.3561945,0.751301),(46768,'tibia fibula',230,8,154,119.1507095,86.6592271,89.8445178,1.8,86.6898359,89.9683809,1.4706489,7.9092521,9.5322474,1568.696897,2262.8841177,19.6599461,237.3925081,198.3369457,386.9263098,14.078125,17.2492711,1.4005844,50.1750868),(46769,'tibia fibula',230,8,155,118.9716453,86.6240673,89.941612,1.8,86.6573044,90.0810966,1.4678546,8.2131388,9.6286525,1568.6824363,2227.5649365,19.6192249,231.3475255,190.9967037,375.0476355,14.2132306,17.0352418,1.3825748,50.1750868),(46770,'tibia fibula',230,8,156,118.5560025,86.5894033,90.0255047,1.8,86.6475762,90.1473093,1.4697312,7.9071842,9.4818054,1569.839993,2198.138859,19.558195,231.827038,198.5333791,390.466882,14.1384259,17.0352418,1.3825748,50.0194872),(46771,'tibia fibula',230,8,157,117.9622577,86.5536567,90.1027044,1.8,86.5794544,90.2214706,1.4616908,7.8767977,10.3489088,1572.8310882,2165.5343927,19.4272661,209.2524381,199.6790012,358.9308132,14.2132306,16.9438771,1.4133795,49.8638877),(46772,'tibia fibula',230,8,158,117.5497579,86.519679,90.1866167,1.8,86.5567332,90.3066328,1.4608766,7.9773977,9.3697664,1572.3623502,2133.1877852,19.3558652,227.6671247,197.1021633,391.2589641,0.53125,0.751301,0.7853982,1.5026019),(46773,'tibia fibula',230,8,159,116.9547944,86.4830078,90.2777822,1.8,86.5311291,90.3670094,1.4662689,7.933884,9.222042,1577.0106071,2099.6286898,19.2802661,227.6750294,198.7690526,396.1503502,0.265625,0.3756505,2.3561945,0.751301),(46774,'tibia fibula',230,8,160,115.769058,86.4476722,90.3674665,1.8,86.4875663,90.4519421,1.4760929,7.958247,9.2896627,1576.2102229,2058.0812691,19.1223093,221.5453162,198.0599776,389.6631218,0.265625,0.5939556,2.0344439,1.282551),(46775,'tibia fibula',230,8,161,113.878418,86.4585261,90.4430025,1.8,86.468865,90.5732382,1.476992,8.0556891,9.3036758,1565.1465717,2016.2432091,18.8132183,216.7146897,194.2908361,377.884621,0.265625,0.5939556,2.677945,1.1269514),(46776,'tibia fibula',230,8,162,112.5752154,86.4287432,90.5416735,1.8,86.4464103,90.6835697,1.4856137,8.1463623,9.2231269,1560.6093628,1974.0960471,18.6267226,214.0376105,191.5713171,372.4078722,14.078125,16.3656044,1.3415644,48.6724849),(46777,'tibia fibula',230,8,163,111.7585116,86.4041509,90.6403804,1.8,86.4749206,90.8111046,1.4927775,8.1383842,9.2420086,1559.7389947,1935.7694934,18.5132706,209.4533317,191.6521696,378.0631216,0.265625,0.5939556,2.0344439,1.282551),(46778,'tibia fibula',230,8,164,111.3013687,86.3806599,90.7318963,1.8,86.4305491,90.9635545,1.5060224,8.2090225,9.1721098,1561.3071924,1910.3226337,18.4725065,208.2751598,190.194045,378.071265,14.34375,16.2531247,1.3734008,48.7369363),(46779,'tibia fibula',230,8,165,110.9735583,86.3718889,90.8164541,1.8,86.4354093,90.9924076,1.524793,8.2051211,9.0697328,1570.5004682,1882.1645663,18.4564783,207.5215013,191.4049107,374.9564064,0.53125,0.83998,1.8925469,2.0338519),(46780,'tibia fibula',230,8,166,109.8954956,86.3526498,90.9162007,1.8,86.4251046,91.0690981,1.5487671,7.9789998,8.9970427,1570.9273392,1850.8993614,18.3070289,205.7230823,196.882739,365.9202548,0.265625,0.83998,1.8925469,1.813801),(46781,'tibia fibula',230,8,167,108.4752973,86.3479366,90.9936568,1.8,86.4021181,91.1612043,-1.5667617,8.2171068,9.1587623,1572.6833928,1822.2299899,18.0789219,198.9602892,191.3913783,353.3291875,0.53125,0.83998,1.8925469,2.0338519),(46782,'tibia fibula',230,8,168,107.498879,86.3567392,91.0826454,1.8,86.3836596,91.2257222,-1.5232752,7.8353035,8.7907609,1571.2966869,1789.1488716,17.8760502,203.5260534,200.540629,369.561712,14.34375,15.9927428,1.3701434,48.3612858),(46783,'tibia fibula',230,8,169,105.260694,86.4109969,91.1541561,1.8,86.4538286,91.3251248,-1.4735762,7.8051438,8.6811705,1558.4578034,1754.1813404,17.3781545,202.0673759,199.6706067,364.3224991,0.265625,0.83998,1.8925469,1.813801),(46784,'tibia fibula',230,8,170,104.2512423,86.4028907,91.2437895,1.8,86.4333386,91.4047392,-1.4237096,8.0250398,9.0453021,1550.0358087,1727.6445808,17.002006,190.9991016,193.1499222,357.2270355,14.2747181,15.9131324,1.3177207,48.1412349),(46785,'tibia fibula',230,8,171,102.3961158,86.4024751,91.3312074,1.8,86.4343073,91.5136802,-1.3562413,8.0988175,9.2786777,1542.1814676,1702.9757684,16.2923856,183.5364723,190.4205722,349.7397817,14.452553,15.848711,1.3339476,48.3612858),(46786,'tibia fibula',230,8,172,101.1316339,86.3962165,91.4187178,1.8,86.4127247,91.6151541,-1.2618837,8.0519204,8.8142911,1538.1362636,1683.3339239,15.2973402,190.9778,191.0272571,356.9162989,14.2747181,15.7996644,1.2809498,48.1412349),(46787,'tibia fibula',230,8,173,100.7071181,86.3873689,91.4938588,1.8,86.4060202,91.6227022,-1.1170008,8.0768448,8.7233017,1530.6896398,1669.2185862,13.5589192,191.3516966,189.5157919,347.1422467,14.2747181,15.7884962,1.3503026,48.3612858),(46788,'tibia fibula',230,8,174,99.647336,86.3966088,91.5596457,1.8,86.4344213,91.6885626,-1.0303931,8.1371481,8.7784536,1521.7965531,1659.2060871,12.2119223,189.0089255,187.0184168,351.0270674,0.265625,0.3756505,2.3561945,0.751301),(46789,'tibia fibula',230,8,175,98.8196852,86.4101055,91.6262896,1.8,86.4107639,91.7449861,-0.9343267,7.7936686,8.7440694,1513.4021752,1652.1292111,10.6517111,188.9428292,194.1835426,337.5688013,0.265625,0.3756505,2.3561945,0.751301),(46790,'tibia fibula',230,8,176,98.1342381,86.4255868,91.7067563,1.8,86.4520913,91.824602,-0.8533884,7.6769553,8.8639309,1505.4530723,1652.3032214,9.2864582,186.4075034,196.1002781,341.1177993,13.8990677,15.6245312,1.259798,47.8300358),(46791,'tibia fibula',230,8,177,96.3638224,86.4826516,91.7432375,1.8,86.4585461,91.9259648,-0.82221,7.6864378,8.9140114,1480.829465,1644.4009258,8.6210058,184.4737297,192.6548426,337.9498702,0.265625,0.3756505,2.3561945,0.751301),(46792,'tibia fibula',230,8,178,94.794044,86.483232,91.7963444,1.8,86.4811138,91.9204026,-0.782059,8.1159298,8.8223933,1459.5782395,1643.8569148,7.8467487,186.3277755,179.841161,335.1185816,14.0868929,15.6561097,1.3134726,48.5168853),(46793,'tibia fibula',230,8,179,93.4170136,86.5012991,91.8731265,1.8,86.4911541,92.0108369,-0.7606224,7.9367426,8.9407886,1442.9920605,1652.0261218,7.3991622,184.7740956,181.8116231,324.7334433,13.8990677,15.6561097,1.3134726,48.3612858),(46794,'tibia fibula',230,8,180,91.9354524,86.5242855,91.9490642,1.8,86.5198738,92.1128211,-0.751242,8.0429979,8.8918779,1428.595885,1657.9849167,7.1383345,186.4606039,177.6198257,339.9693488,13.8990677,15.7078507,1.2436982,48.1412349),(46795,'tibia fibula',230,8,181,90.9472532,86.5227466,92.011429,1.8,86.5116544,92.1420773,-0.7306519,7.7842291,8.8173679,1413.7173453,1669.6414431,6.7507578,189.3582607,181.6130177,323.0224627,13.8210847,15.7078507,1.2436982,48.2968344),(46796,'tibia fibula',230,8,182,90.4119207,86.5194403,92.0766033,1.8,86.5286663,92.1747047,-0.7244994,8.2003911,8.2724955,1409.2086557,1685.3539819,6.6189309,203.7298166,171.8465175,345.2990513,0.265625,0.3756505,2.3561945,0.751301),(46797,'tibia fibula',230,8,183,90.2245608,86.5251142,92.1489661,1.8,86.5408744,92.2595437,-0.7328447,7.8815149,8.9280096,1407.1624317,1712.4498268,6.7298991,191.8064501,178.5395883,343.4410936,0.265625,0.3756505,2.3561945,0.751301),(46798,'tibia fibula',230,8,184,89.8314961,86.523648,92.2078115,1.8,86.5009921,92.2862253,-0.7239782,7.8010639,8.8761735,1401.7645862,1729.6435774,6.5686938,194.8636507,179.6888986,348.9346211,13.8005818,15.7996644,1.2809498,48.7369363),(46799,'tibia fibula',230,8,185,89.1378388,86.5878455,92.2484354,1.8,86.6068175,92.3594612,-0.7221883,8.372538,8.8476514,1396.1030432,1740.6920806,6.4915873,196.7405815,166.7478902,343.1197369,13.7112424,15.8353497,1.1747149,48.5813368),(46800,'tibia fibula',230,8,186,88.446063,86.5944432,92.3193123,1.8,86.6045894,92.440423,-0.7115431,8.2913166,8.8398455,1388.212842,1754.7486759,6.2857617,198.5044505,167.4297223,322.7960865,13.7112424,15.9397134,1.1593401,49.1125868),(46801,'tibia fibula',230,8,187,88.2629365,86.6166955,92.3759155,1.8,86.610825,92.4563787,-0.7127826,8.3472153,9.5807722,1392.4446009,1777.9601291,6.2907849,185.5758695,166.815465,308.2862264,13.7112424,16.045597,1.2333403,49.1125868),(46802,'tibia fibula',230,8,188,87.990652,86.6472288,92.418298,1.8,86.643608,92.4626119,-0.7068549,8.4063349,8.9230552,1393.5351469,1806.5431648,6.1854395,202.4579157,165.7720239,348.3367788,13.7719278,16.0807365,1.1810878,49.4882372),(46803,'tibia fibula',230,8,189,87.9129969,86.6825198,92.453995,1.8,86.6968247,92.4978305,-0.6973161,8.0527913,8.9389801,1399.105149,1832.5360365,6.0421543,205.0050463,173.7416383,351.6835701,13.7112424,16.1835178,1.1659045,49.3326377),(46804,'tibia fibula',230,8,190,87.3212619,86.7095612,92.4951584,1.8,86.710741,92.5296556,-0.6876453,8.0790496,8.8788164,1398.5440089,1854.024512,5.863167,208.8143757,173.1074903,352.5698083,13.7112424,16.2183586,1.0191413,49.5526887),(46805,'tibia fibula',230,8,191,86.5168093,86.7193235,92.5440652,1.8,86.7320046,92.6454649,-0.6849484,7.8955857,8.8493168,1403.9055691,1870.2414276,5.7710253,211.3430297,177.8089211,356.2604706,13.6739032,16.3094615,1.0415495,49.7082882),(46806,'tibia fibula',230,8,192,85.5584363,86.7091799,92.5795423,1.8,86.691745,92.6348214,-0.6813839,7.9247143,9.1456797,1408.808646,1875.5949215,5.6573289,205.0798832,177.7740624,344.8303862,13.6739032,16.3591362,1.0053124,49.7082882),(46807,'tibia fibula',230,8,193,84.5881115,86.7644212,92.5600342,1.8,86.7943816,92.6391592,-0.6989106,8.1839255,8.9363874,1406.4872056,1876.7584329,5.8357769,210.0131009,171.8597283,356.7730713,13.7607871,16.4451696,1.0276068,50.2395382),(46808,'tibia fibula',230,8,194,83.854579,86.7737183,92.5831516,1.8,86.7849234,92.6454026,-0.6978184,8.3011092,8.8610829,1404.943907,1885.9502064,5.7701366,212.8351841,169.2477325,356.8383118,13.7719278,16.5392895,1.0496582,50.2395382),(46809,'tibia fibula',230,8,195,83.5645912,86.7960407,92.6092324,1.8,86.7952586,92.677682,-0.6912838,8.5667806,9.0502148,1410.1618178,1908.8332937,5.6606711,210.9158001,164.6081405,353.1101141,13.7112424,16.584022,1.0138948,50.4595892),(46810,'tibia fibula',230,8,196,83.0911989,86.8348791,92.6271783,1.8,86.7985537,92.6678719,-0.6781647,8.3777385,9.0384249,1409.3170957,1929.4108843,5.4505984,213.4676016,168.2216623,354.9490174,13.7112424,16.6815884,0.9209259,50.6151887),(46811,'tibia fibula',230,8,197,82.6742305,86.8789042,92.649633,1.8,86.8346257,92.6986251,-0.6648565,8.2194637,9.817944,1419.6292205,1948.3788382,5.2446142,198.4507999,172.7155525,333.6136188,13.8990677,16.736483,0.9431669,50.7707882),(46812,'tibia fibula',230,8,198,82.4410729,86.9201478,92.6889147,1.8,86.8941689,92.7524051,-0.6521288,8.0197783,9.2151692,1425.4837697,1968.2833626,5.0605486,213.5916673,177.7460323,356.9591685,13.8347321,16.8436413,0.90837,51.1464387),(46813,'tibia fibula',230,8,199,82.4923868,86.9480155,92.7520206,1.8,86.9219954,92.8155415,-0.6377854,8.3845882,9.7504577,1435.106845,1991.4596689,4.8742302,204.2426866,171.1600859,342.0315185,13.9397971,16.8833891,0.4214192,51.3020382),(46814,'tibia fibula',230,8,200,82.2661566,87.0022902,92.794807,1.8,86.9908698,92.8020235,-0.6239599,8.2199448,9.2108062,1442.3064721,2009.5754292,4.6802874,218.1758448,175.4642525,357.5138454,13.8990677,16.9750794,0.3514448,51.1464387),(46815,'tibia fibula',230,8,201,81.1926052,87.0901995,92.8438507,1.8,87.063494,92.8868321,-0.6054836,9.0095906,9.2149301,1437.433496,1999.8904593,4.3836268,217.0271973,159.5448191,362.0375099,14.0823982,17.0766096,0.2676163,51.4576377),(46816,'tibia fibula',230,8,202,80.2961083,87.1257915,92.9149079,1.8,87.1016708,92.9555165,-0.5837162,8.7432871,9.0807464,1433.6534472,2000.028659,4.0648929,220.2493694,163.9719056,362.8600187,14.0868929,17.2349487,0.4291785,51.8332882),(46817,'tibia fibula',230,8,203,79.6337952,87.1471142,92.984399,1.8,87.1263195,93.0101838,-0.5676026,8.5390806,9.0789318,1437.3584153,2003.6212917,3.8360507,220.6891,168.3270696,355.8468977,14.186749,17.3166314,0.360566,51.9888877),(46818,'tibia fibula',230,8,204,79.0623506,87.1801665,93.0690181,1.8,87.2008929,93.1975128,-0.5575521,8.8406606,8.8028978,1455.0869341,2017.2708297,3.6890231,229.1598608,164.5902943,366.9629441,14.2747181,17.4121189,0.3748407,51.9888877),(46819,'tibia fibula',230,8,205,79.5436751,87.2468098,93.0946659,1.8,87.2517239,93.2128306,-0.5636508,9.284291,9.3374973,1480.4235791,2052.8834345,3.7842983,219.8537105,159.4546718,378.0341082,14.2747181,17.565426,0.3552309,52.5845892),(46820,'tibia fibula',230,8,206,78.3984981,87.2961061,93.1161625,1.8,87.2700488,93.2683343,-0.5673236,8.5222891,9.3257069,1485.648371,2075.6447941,3.7732404,222.5723818,174.3250371,376.8113377,14.4625434,17.6595683,0.2741675,52.7401887),(46821,'tibia fibula',230,8,207,77.9537561,87.3535825,93.1462894,1.8,87.3269199,93.2562649,-0.5633832,8.0970834,8.9399234,1498.6330664,2107.2236873,3.7055184,235.7093671,185.0830708,379.3489499,14.5714356,17.7571852,0.3832841,53.2714387),(46822,'tibia fibula',230,8,208,77.8740057,87.3931635,93.1630057,1.8,87.3527602,93.2492351,-0.5707289,8.1455832,9.3281409,1526.6092459,2147.4903533,3.7881198,230.2163296,187.4155866,390.1285485,14.6503686,17.9154168,0.2701532,53.4270382),(46823,'tibia fibula',230,8,209,77.6453808,87.4684832,93.1741345,1.8,87.4293759,93.322872,-0.5788843,8.4221108,9.419156,1549.5792018,2173.640779,3.8733116,230.7681045,183.9894111,384.1375603,14.8219841,18.0096884,0.6494007,53.9582882),(46824,'tibia fibula',230,8,210,76.3054674,87.5119395,93.2092102,1.8,87.4896131,93.4155081,-0.572604,8.3801572,9.4887991,1567.2114032,2194.3748021,3.7335201,231.2594859,187.0145595,369.2055129,14.9661064,18.2509698,0.3723984,54.1138877),(46825,'tibia fibula',230,8,211,76.7452491,87.5936339,93.2763578,1.8,87.6395588,93.5687209,-0.5798879,9.0017157,9.376769,1604.3051464,2241.372188,3.8401718,239.0345949,178.222152,394.0268129,15.0260191,18.3608178,0.2484874,54.7095892),(46826,'tibia fibula',230,8,212,76.6990024,87.6592413,93.3232717,1.8,87.7862174,93.6360455,-0.5730952,8.4267699,9.566816,1643.8702855,2300.9330747,3.7584963,240.5118985,195.0771543,397.1597856,15.2138443,18.59375,0.6435011,55.3964387),(46827,'tibia fibula',230,8,213,76.3760882,87.6754021,93.4058716,1.8,87.8740625,93.8009985,-0.562206,8.652343,9.2988094,1685.6508277,2346.7348854,3.6169999,252.3693942,194.8201572,413.1188322,15.4016696,18.7825239,0.5016041,55.9276887),(46828,'tibia fibula',230,8,214,75.7332958,87.7636228,93.465992,1.8,87.8407552,93.9658854,-0.5639956,8.6938625,9.8185214,1728.1188134,2404.4103011,3.6069509,244.8851728,198.7745747,411.0193527,15.7689756,18.9508127,0.5452272,56.7701377),(46829,'tibia fibula',230,8,215,76.6424288,87.805388,93.5142792,1.8,87.7478669,94.0613619,-0.5436887,9.1975018,9.4132765,1799.8253322,2493.4384514,3.418195,264.8852863,195.6863266,430.6141795,15.9202915,19.1784193,0.5380442,57.3013877),(46830,'tibia fibula',230,8,216,77.1877675,87.8685962,93.5934025,1.8,87.7183318,94.1454616,-0.5351613,8.8839723,9.5218776,1851.1870253,2567.7815817,3.3458247,269.6717697,208.3737945,426.2732617,16.1377243,19.4069922,0.5310301,57.8326377),(46831,'tibia fibula',230,8,217,78.1496683,87.9819001,93.6668285,1.8,87.9912475,94.1831426,-0.5011406,9.0662317,9.9513241,1910.1774961,2637.9516426,3.0062784,265.085493,210.69145,430.8582621,16.38103,19.6364977,0.4031156,58.9595892),(46832,'tibia fibula',230,8,218,79.0752432,88.1021224,93.7348106,1.8,88.0963532,94.1424237,-0.46534,9.0933575,9.7953666,1976.0618021,2702.8992422,2.6537079,275.9365054,217.3082713,459.8004425,16.5135723,19.8811041,0.3978744,59.2707882),(46833,'tibia fibula',230,8,219,80.8474977,88.278311,93.8099722,1.8,88.3089798,94.1047112,-0.4292302,9.7272002,9.9751678,2063.6848574,2808.5901439,2.3337743,281.5581849,212.1560989,474.400823,16.6334423,20.0929116,0.4222512,60.3332882),(46834,'tibia fibula',230,8,220,81.2107789,88.3828778,93.8272598,1.8,88.4002035,94.1454043,-0.3895509,9.8374451,10.6493786,2124.2444125,2887.0787317,1.9521385,271.1030227,215.9345636,469.8872373,16.8704849,20.425509,0.3587707,61.6802906),(46835,'tibia fibula',230,8,221,83.201032,88.4433542,93.8451591,1.8,88.5026104,94.108112,-0.3423775,9.2574771,10.3810959,2206.693018,3020.8816185,1.5629726,290.9983347,238.3687262,503.5339333,17.1082018,20.6180445,0.3828987,62.1470892),(46836,'tibia fibula',230,8,222,85.5047277,88.5319052,93.8547611,1.8,88.641941,94.0907584,-0.2742726,9.6336194,10.5595444,2305.8176599,3201.5761916,1.045409,303.1926453,239.3511261,521.5541338,17.3459187,21.0263623,0.457998,63.4296401),(46837,'tibia fibula',230,8,223,89.5931002,88.6661047,93.7325652,1.8,88.8341704,93.9769426,-0.2286259,9.9956312,10.7684413,2441.0484416,3440.8085795,0.7669975,319.527078,244.2115353,544.7082045,17.7028313,21.3113373,0.3967087,65.5279435),(46838,'tibia fibula',230,8,224,95.654835,88.8009363,93.6833624,1.8,88.9797439,93.9346303,-0.210201,10.050708,10.9494135,2655.3796003,3799.2791944,0.6940959,346.9847202,264.1982646,565.0791208,18.1769165,22.7415957,2.8937811,69.3111449),(46839,'tibia fibula',230,8,225,103.7208274,88.9179853,93.8173615,1.8,89.1770002,94.0688096,-0.1427942,10.3255803,11.4198687,2972.1840411,4401.3477516,0.3500918,385.4114134,287.8466825,607.611182,18.9505811,23.7656455,2.7029398,73.8189506),(46840,'tibia fibula',230,8,226,116.0164125,88.8944282,93.7758584,1.8,89.2528998,94.1393348,-0.1119647,10.8787649,11.8439656,3413.640229,5098.7418772,0.2413876,430.4927982,313.78932,671.9610824,19.7569542,24.8682318,2.9043859,75.3215525),(46841,'tibia fibula',230,8,227,134.1382656,89.0451732,93.6787645,1.8,89.3101247,94.1725777,-0.119115,11.3140449,12.3403418,4050.3856934,5938.0445244,0.3157036,481.1896313,357.9962544,770.1237941,20.3855126,25.402973,2.7669115,76.7863997),(46842,'tibia fibula',230,8,228,156.106097,89.0849038,93.7422981,1.8,89.4853112,93.9830794,-0.1411765,11.4279633,12.3495005,4521.162553,6903.166306,0.5151173,558.9834419,395.622776,889.5391932,20.5540844,25.1559637,2.7630471,76.2818463),(46843,'tibia fibula',230,8,229,185.5048897,89.1854788,93.5539202,1.8,89.632992,93.6500285,-0.1616232,11.9568397,12.3832434,4860.4120822,7686.6557363,0.8006204,620.7304104,406.4963814,984.3253158,20.4827003,24.8682318,2.7352983,76.7486449),(46844,'tibia fibula',230,8,230,199.4129933,89.3951077,93.1756578,1.8,89.7057282,93.4831902,-0.1903626,11.9086551,12.5073386,4742.1230044,7971.4158906,1.189908,637.3390981,398.2081062,987.773276,19.4729809,24.381134,0.4149058,75.2193463),(46845,'tibia fibula',230,8,231,177.7649973,89.3404698,92.9843727,1.8,89.6628674,93.2786371,-0.2154083,11.2288747,12.4188392,4150.2848724,7382.4905761,1.3536064,594.4589897,369.6082614,913.7783133,18.335387,24.417281,0.390607,74.4680454),(46846,'tibia fibula',230,8,232,186.189225,89.3917288,93.0787852,1.8,89.6181023,93.0548543,-0.1990625,10.8593523,12.1777109,3932.6243346,7626.4714379,1.213495,626.2647775,362.1417045,932.5838602,17.3848092,24.6287523,0.2842255,74.0279435),(46847,'tibia fibula',230,8,233,201.0973514,89.6865574,92.6472512,1.8,89.637482,92.6886056,-0.187191,10.6463876,12.8570725,3660.1695534,8249.0218768,1.1607704,641.5941005,343.7945052,922.6533968,17.1083172,25.0153322,0.7328151,77.6288487),(46848,'tibia fibula',230,8,234,163.6481101,90.0717248,91.3964247,1.8,90.0038837,91.9256416,-0.1163803,8.9289145,13.4295087,2528.6319345,7263.2258017,0.3677538,540.840768,283.195895,728.9710758,16.233515,25.5345632,0.0520363,73.7811958),(46849,'tibia fibula',230,8,235,96.6858813,92.3707099,89.4432994,1.8,91.3282608,89.9552238,-0.0029023,10.9553889,15.3503982,1000.918529,4493.1538805,0.0001357,292.7060138,91.3631213,347.7043159,13.8768544,25.7998323,3.0900918,82.9524068),(46850,'tibia fibula',230,8,236,58.0113064,96.343068,89.3860771,1.8,95.309086,89.4166958,0.4459244,6.956608,14.8458983,453.3278532,1148.7897466,1.7984746,77.380952,65.1650711,97.7466721,3.4142522,7.7351168,0.2782997,18.7981624),(46851,'tibia fibula',230,8,237,39.6050887,97.100879,90.2773365,1.8,97.6025315,90.2825064,0.7836592,4.9463162,7.6232712,102.1803851,581.4720777,3.2889456,76.2759275,20.6578758,88.637953,0.265625,0.3756505,2.3561945,0.751301),(46852,'tibia fibula',230,8,238,28.1455571,97.055289,90.6696488,1.8,97.6618692,91.101055,0.7393952,4.1030515,7.6159909,35.731525,405.1293399,2.129971,53.1945671,8.7085247,57.4335904,6.2603881,14.9341736,2.4696295,36.2603806),(46853,'tibia fibula',230,8,239,5.4699143,95.9701579,89.649061,1.8,97.0392342,90.558422,0.7311912,1.5466132,7.5717474,2.3100628,46.3086147,0.406505,6.1159746,1.4936267,6.4190089,3.3565609,12.0442706,2.4186133,29.0963248),(46854,'tibia fibula',230,8,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46855,'tibia fibula',230,8,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46856,'tibia fibula',230,8,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46857,'tibia fibula',230,8,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46858,'tibia fibula',230,8,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46859,'tibia fibula',230,8,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46860,'tibia fibula',230,8,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46861,'tibia fibula',230,8,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46862,'tibia fibula',230,8,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46863,'tibia fibula',230,8,249,0.3531894,93.1957831,89.2434715,1.8,93.1954167,89.239375,-1.2044519,1.1439224,1.6705613,0.1178534,0.2345795,0.0513119,0.1404196,0.1030257,0.2104836,2.5672949,3.4633263,1.0040671,10.4804586),(46864,'tibia fibula',230,8,250,18.4984973,93.0967737,89.3625104,1.8,93.0996015,89.383169,-1.0598864,5.7662337,5.8666443,121.8494693,128.5822814,2.34594,21.9175179,21.1315522,42.6054074,11.6434096,12.0735256,0.8788749,38.3476258),(46865,'tibia fibula',230,8,251,43.0215268,93.067996,89.4048095,1.8,93.0831948,89.3985428,-0.9219421,7.9053883,8.0320127,589.1154776,605.0556992,4.5520583,75.3305206,74.5207518,148.1725249,15.9375,16.4086605,1.0636978,52.7668853),(46866,'tibia fibula',230,8,252,82.0011629,88.6031692,89.98337,1.8,84.1495398,90.215274,-0.1344654,15.5833176,24.1556131,2005.0930038,8611.4323933,0.2456241,356.4981915,128.6691995,399.9686969,24.3984533,28.2313268,1.9163519,117.0877874),(46867,'tibia fibula',230,8,253,278.7039901,78.4205592,89.9903912,1.8,83.3871193,89.7353706,-0.0517396,16.4536285,25.2602178,11610.7791172,33320.9724468,0.124237,1319.1086738,705.6667831,1777.2810681,28.953125,29.2742371,0.9399987,95.5845621),(46868,'tibia fibula',230,8,254,312.7491728,79.2015067,89.8890298,1.8,84.2534946,89.7113609,-0.0457602,15.9858917,25.4937812,13434.497305,39364.8198936,0.1090732,1544.0949909,840.3971187,2070.9503997,28.953125,29.3344301,2.5234484,95.804613),(46869,'tibia fibula',230,8,255,330.8407079,79.9408836,89.8679271,1.8,84.9074728,89.6898922,-0.0448471,16.6029426,25.5262012,14605.0128304,43769.8382036,0.1108268,1714.7023868,879.664117,2286.7404698,28.953125,29.3211982,2.5561026,95.804613),(46870,'tibia fibula',230,8,256,346.0404471,80.5310334,89.8561901,1.8,85.4076326,89.6756863,-0.0435877,15.5627865,25.5134518,15712.0245548,47400.0144296,0.1095038,1857.8440412,1009.5894169,2472.3898387,28.953125,29.3211982,0.9853063,95.5845621),(46871,'metatarsal.tif',230,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46872,'metatarsal.tif',230,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46873,'metatarsal.tif',230,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46874,'metatarsal.tif',230,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46875,'metatarsal.tif',230,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46876,'metatarsal.tif',230,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46877,'metatarsal.tif',230,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46878,'metatarsal.tif',230,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46879,'metatarsal.tif',230,10,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46880,'metatarsal.tif',230,10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46881,'metatarsal.tif',230,10,11,24.1913885,17.2637449,17.614191,1.8,17.1906522,17.5777636,-0.314218,3.2764109,3.5594305,47.3823117,55.1283635,0.3851511,15.4879731,14.4616513,27.5849908,5.8088443,6.9788284,0.033321,24.9494916),(46882,'metatarsal.tif',230,10,12,48.8016935,16.3016219,15.9710838,1.8,16.0472517,15.6784768,0.9512082,7.8407579,10.5386773,409.6191281,567.2896516,5.3908594,53.8293029,52.2422874,78.1505308,7.8017971,10.016641,1.5088601,33.5217241),(46883,'metatarsal.tif',230,10,13,104.1074865,14.6049657,12.902486,1.8,14.6681533,12.8789868,1.1764931,8.7113237,8.9807063,1630.4804551,1970.360662,14.7905029,219.399298,187.1679326,357.1550499,14.9636776,18.8125932,1.649148,83.2670446),(46884,'metatarsal.tif',230,10,14,123.7805966,14.3007632,12.3683248,1.8,14.1760567,12.499395,1.3553616,8.9873358,9.4768131,1954.0402385,2270.4310878,19.6873348,239.5774893,217.4215232,429.3916548,15.1359002,19.0429678,1.6890938,60.8805441),(46885,'metatarsal.tif',230,10,15,116.4259596,14.3277814,12.2128171,1.8,14.0286137,12.2823273,1.2910324,9.1989063,9.2850656,1886.3714495,2265.5432334,17.9248026,243.9986241,205.0647532,425.0341776,15.0988475,18.7430248,1.7243888,61.9169125),(46886,'metatarsal.tif',230,10,16,108.4249521,14.3000294,12.0996247,1.8,13.9221656,12.1435878,1.2644975,9.6154785,9.1969108,1835.0051719,2134.4332063,16.4277996,232.0815371,190.838675,409.8586604,15.4816195,18.5871191,1.6542838,63.4279569),(46887,'metatarsal.tif',230,10,17,98.8650695,14.2791693,11.9052757,1.8,13.9212622,11.9344588,1.0217125,9.4513369,9.0084498,1707.5595074,1963.8469449,11.9892713,218.0005417,180.668568,380.6053152,15.4065581,17.8385251,1.6099068,61.9201389),(46888,'metatarsal.tif',230,10,18,93.9409576,14.3426418,11.7388101,1.8,13.9861378,11.744973,0.9496666,8.829096,8.8492229,1522.2066003,1838.9142891,10.354317,207.8051714,172.4079786,340.3552506,15.2943903,17.8990279,1.6618482,61.0387694),(46889,'metatarsal.tif',230,10,19,91.4721465,14.3623555,11.5973851,1.8,14.1039645,11.5673853,0.9346565,8.3097465,8.5952004,1393.3294327,1768.5170863,9.8645307,205.756353,167.6741209,315.4611646,14.7457316,17.1415848,1.7114146,57.6333544),(46890,'metatarsal.tif',230,10,20,88.8232077,14.4609546,11.4778823,1.8,14.2601001,11.4942519,1.0113272,8.3227371,8.4863236,1251.5761142,1688.6833161,10.6338991,198.9887961,150.3803491,297.1042797,14.4170955,16.7680324,1.7473427,56.8427813),(46891,'metatarsal.tif',230,10,21,86.3747417,14.5799432,11.4532202,1.8,14.38941,11.4611535,1.0955535,8.5368433,8.3238014,1137.6139506,1575.7392233,11.3819445,189.3052399,133.2593215,306.2269824,13.859332,16.3947611,1.8387067,55.9627483),(46892,'metatarsal.tif',230,10,22,85.7787563,14.5230878,11.4502255,1.8,14.3537103,11.4581868,1.0421401,8.6046567,8.0450356,1130.5856625,1488.7002159,10.6595461,185.0458198,131.3923037,302.9809301,13.6591381,15.9795613,1.9017491,52.1831326),(46893,'metatarsal.tif',230,10,23,84.4956349,14.5126663,11.4473307,1.8,14.3338831,11.4930413,0.9689601,8.6593427,7.7910677,1124.7645117,1404.6459002,9.5686551,180.2892701,129.8902876,290.7271023,13.5105601,15.6051347,2.0011229,51.1137178),(46894,'metatarsal.tif',230,10,24,83.3608077,14.5114753,11.4096548,1.8,14.3210852,11.4415853,0.8747982,8.5453812,7.5542094,1089.2584698,1357.3716789,8.1822028,179.6841468,127.4675105,281.8679768,13.2156443,15.3206131,2.0208701,51.7447292),(46895,'metatarsal.tif',230,10,25,82.4655495,14.4736316,11.405559,1.8,14.2786935,11.4425574,0.7124644,8.1495373,7.2494908,1070.5474564,1310.5846349,5.8732599,180.7829914,131.362974,278.0668142,12.9352139,15.1169712,2.0619599,50.53912),(46896,'metatarsal.tif',230,10,26,82.2871415,14.4609089,11.4223531,1.8,14.2632554,11.4849657,0.5584775,7.5480786,7.2841152,1036.7006909,1285.7846857,3.8508924,176.5189937,137.3463034,275.2619775,12.6116456,14.6883522,2.0958324,50.0443031),(46897,'metatarsal.tif',230,10,27,81.8510836,14.3710274,11.3887464,1.8,14.1673093,11.4486347,0.4025126,6.7723427,7.0316062,1017.5051107,1280.2504487,2.0933889,182.0708393,150.244185,276.4575209,12.3891391,14.6324299,0.6350267,48.9859038),(46898,'metatarsal.tif',230,10,28,83.9542565,14.2082715,11.4011431,1.8,13.984218,11.471829,0.2241773,6.292704,7.8854208,1010.1609606,1344.2636663,0.6914919,170.4745632,160.5289176,289.1480835,12.3247715,14.6785352,0.6392773,50.0819122),(46899,'metatarsal.tif',230,10,29,84.9103242,14.076721,11.3670736,1.8,13.8548233,11.4326607,0.1400651,6.2046302,8.0479449,983.5572988,1393.3198746,0.2758211,173.1274133,158.5198902,292.5721612,12.1352284,14.5395744,0.6530957,51.4989339),(46900,'metatarsal.tif',230,10,30,84.9653477,14.0060314,11.3196494,1.8,13.8015262,11.3902332,0.0901146,6.1116868,8.1398252,947.5467598,1414.9094802,0.1146845,173.8255365,155.0385021,287.7115072,11.9787713,14.6547835,3.1098573,51.4801294),(46901,'metatarsal.tif',230,10,31,86.0791195,13.916857,11.2868768,1.8,13.7234856,11.3614616,0.0461804,6.2136812,8.3016666,927.22864,1449.3960926,0.030574,174.5909781,149.2237215,283.7598101,11.8242352,14.9089369,0.0624188,50.7771262),(46902,'metatarsal.tif',230,10,32,85.9205688,13.9028233,11.2994354,1.8,13.7205,11.3828855,-0.0312792,6.2551837,8.3532052,890.0087283,1448.3377732,0.0140061,173.3870694,142.2833877,278.5304351,11.7192626,14.9736564,0.0465984,48.4035169),(46903,'metatarsal.tif',230,10,33,85.6254337,13.9061555,11.2682306,1.8,13.7350507,11.3447043,-0.0818237,6.2889854,8.3262589,862.6952847,1425.5760762,0.0953323,171.2144783,137.1755902,273.2777046,11.5285208,14.9089369,0.0624188,48.4489151),(46904,'metatarsal.tif',230,10,34,85.031607,13.9114074,11.2273481,1.8,13.7505555,11.3074334,-0.1201555,6.2615687,8.4676638,838.0032792,1398.7147464,0.2036223,165.1830748,133.8328013,263.4267757,11.4601727,15.045684,0.1083819,53.9445351),(46905,'metatarsal.tif',230,10,35,84.0985795,13.9311426,11.2131194,1.8,13.779852,11.2977385,-0.1749808,6.2593758,8.6280071,799.0214427,1384.4624005,0.424797,160.4614358,127.6519368,252.8135784,11.3852673,15.159226,0.1281597,51.6837529),(46906,'metatarsal.tif',230,10,36,84.6400822,13.9035981,11.1694217,1.8,13.7589325,11.2572777,-0.199872,6.2525279,8.6628366,778.6313596,1383.8894859,0.5560809,159.7501551,124.5306495,249.2966003,11.2817035,15.2360931,0.1275096,51.6383548),(46907,'metatarsal.tif',230,10,37,85.2114936,13.8955514,11.1233071,1.8,13.7678158,11.2009708,-0.2197141,6.2116507,8.7309922,764.9434689,1378.9811795,0.6746261,157.9409474,123.1465689,245.4669215,11.1964682,15.2852895,0.111777,49.6201416),(46908,'metatarsal.tif',230,10,38,84.4593721,13.9494809,11.1193445,1.8,13.8401914,11.1960737,-0.2569153,6.1762442,8.735288,730.4788967,1363.3611024,0.9088664,156.0751181,118.2723474,239.5470985,11.1341131,15.2569718,0.3635269,47.6739201),(46909,'metatarsal.tif',230,10,39,85.2084339,13.9313801,11.0877479,1.8,13.8206331,11.1603952,-0.2632568,6.0964586,8.6673284,718.4575496,1369.0475768,0.9616887,157.9549676,117.8483431,240.8405006,11.0640884,15.1948427,0.4202958,47.2433059),(46910,'metatarsal.tif',230,10,40,85.2536307,13.9348821,11.0658361,1.8,13.8148759,11.151109,-0.2738431,6.045989,8.7279826,707.2329506,1362.0848732,1.0391588,156.0595311,116.9755593,236.7564295,11.0229526,15.2555939,0.3908834,47.9729027),(46911,'metatarsal.tif',230,10,41,85.9254248,13.9482149,11.0416734,1.8,13.8457856,11.1172257,-0.2854935,5.973343,8.6780258,700.0579815,1355.4235614,1.135877,156.1903122,117.1970179,236.6054451,10.876278,15.1819907,0.4773454,47.2167123),(46912,'metatarsal.tif',230,10,42,85.2729235,14.0143652,11.0396938,1.8,13.9162943,11.1193296,-0.3118609,5.9067958,8.6516619,684.8098355,1330.35157,1.3380013,153.7683272,115.9359247,232.5010936,10.7905219,15.185353,0.4887565,46.9787061),(46913,'metatarsal.tif',230,10,43,85.4657586,14.0304039,11.0256661,1.8,13.934135,11.1106417,-0.3284805,5.9009151,8.6018734,679.5076422,1322.3988474,1.4824616,153.7338186,115.1529268,232.3598155,10.7452756,15.1401962,0.5254952,46.9897215),(46914,'metatarsal.tif',230,10,44,85.25649,14.0795992,11.0371999,1.8,13.9852893,11.1159039,-0.3568272,5.8615154,8.6542366,665.1901749,1309.3768098,1.7337275,151.298938,113.4843339,228.0926958,10.6897889,15.1792212,0.529912,46.8081289),(46915,'metatarsal.tif',230,10,45,85.1015427,14.1080144,11.0221996,1.8,14.0072519,11.0994024,-0.3639384,5.8005827,8.6598408,660.8749485,1295.9146135,1.7971419,149.646471,113.9325112,225.9509712,10.6174307,15.1491194,0.4842397,47.193345),(46916,'metatarsal.tif',230,10,46,85.0399326,14.160354,11.0119769,1.8,14.0667479,11.0900256,-0.3815724,5.7894838,8.6550685,655.5072549,1275.0749501,1.9653728,147.3211859,113.2237834,223.00204,10.6352866,15.1304738,0.5140636,46.4417173),(46917,'metatarsal.tif',230,10,47,84.9212736,14.1875062,10.9988421,1.8,14.0888463,11.078968,-0.3901734,5.7860927,8.6443253,652.98852,1261.7318951,2.0475256,145.9607138,112.8548317,221.4269868,10.6373155,15.1570467,0.5667292,46.853527),(46918,'metatarsal.tif',230,10,48,84.1558939,14.2503202,10.9992325,1.8,14.1617237,11.076218,-0.414628,5.8318132,8.6335809,644.7617087,1236.9226908,2.2762441,143.2687897,110.5593893,217.9490714,10.6482749,15.1155805,0.5624036,46.2867183),(46919,'metatarsal.tif',230,10,49,84.1244275,14.2818469,10.9905244,1.8,14.197096,11.0621287,-0.4291759,5.8207974,8.6269773,642.5629101,1219.3139227,2.4277914,141.3373282,110.3908745,215.8201073,10.6032666,15.1570467,0.5667292,45.4066853),(46920,'metatarsal.tif',230,10,50,83.196734,14.3726882,10.9555843,1.8,14.2935441,11.0383447,-0.4447643,5.850976,8.6129378,633.8530866,1182.2534596,2.5667694,137.2648325,108.3328813,210.8232307,10.6662503,15.1554616,0.6036042,46.7173326),(46921,'metatarsal.tif',230,10,51,82.7526696,14.4105444,10.9451838,1.8,14.3383895,11.0183182,-0.4597982,5.8362517,8.5496797,630.1171898,1152.2987116,2.7160717,134.7768276,107.9660743,208.4265991,10.6563951,15.0093133,0.6166481,45.9391113),(46922,'metatarsal.tif',230,10,52,82.0448559,14.4696312,10.9254612,1.8,14.3923915,10.999984,-0.4672842,5.8772592,8.5398408,629.1170937,1117.5810101,2.774719,130.8667259,107.0425973,204.3108036,10.6416983,14.9018852,0.5591506,46.438491),(46923,'metatarsal.tif',230,10,53,81.5917748,14.5200405,10.9315759,1.8,14.4488734,11.0069531,-0.4844539,5.8813558,8.4074234,627.3699287,1085.4341571,2.9495415,129.1042576,106.6709708,203.651845,10.6552218,14.7682805,0.6025576,46.4572955),(46924,'metatarsal.tif',230,10,54,81.4209835,14.5436601,10.9427525,1.8,14.4655181,11.0204689,-0.4961661,5.8873609,8.2889801,628.8314122,1074.7032681,3.0754159,129.6544629,106.8104062,205.5035791,10.6532541,14.6482245,0.6540827,46.2568984),(46925,'metatarsal.tif',230,10,55,81.2620064,14.5562494,10.9465483,1.8,14.4824746,11.0246587,-0.5058066,5.8965056,8.3041256,627.6681634,1057.8160988,3.1794167,127.3844044,106.447481,202.9691984,10.7188811,14.6955063,0.658268,46.283492),(46926,'metatarsal.tif',230,10,56,80.8279804,14.5787253,10.9378525,1.8,14.5003902,11.0164542,-0.5200943,5.9865078,8.2596457,626.5804504,1038.3064262,3.3270301,125.7083486,104.6654354,201.554567,10.7280017,14.6088089,0.6763979,46.2646874),(46927,'metatarsal.tif',230,10,57,80.5379913,14.6083872,10.9325588,1.8,14.5295412,11.0088748,-0.5301106,6.0047275,8.180467,627.7971747,1018.3239958,3.4317302,124.4823796,104.5504847,201.153755,0.1387139,0.2794284,0.5880026,0.5480042),(46928,'metatarsal.tif',230,10,58,79.9039503,14.6453348,10.9347358,1.8,14.579428,11.0114373,-0.5457748,5.9973357,8.2467116,628.2751365,994.9584357,3.5882806,120.6491126,104.7590413,196.7022781,0.154999,0.3465883,0.4636476,0.7030032),(46929,'metatarsal.tif',230,10,59,79.762271,14.675058,10.9315133,1.8,14.6075906,11.0049175,-0.5658497,6.0905046,8.1588379,632.1018653,975.826423,3.8211293,119.6036045,103.7848101,196.7024646,10.7545374,14.3994811,0.6402718,47.0429087),(46930,'metatarsal.tif',230,10,60,79.1130666,14.7087115,10.9323334,1.8,14.6497455,11.0060124,-0.576969,6.0909995,8.1155288,633.2528303,949.7253688,3.9234157,117.0256912,103.9653394,194.5728976,10.8295993,14.3074226,0.631584,45.3911071),(46931,'metatarsal.tif',230,10,61,78.4131096,14.7474168,10.9270834,1.8,14.6893842,11.0040894,-0.5923665,6.143619,7.9701618,636.3271756,918.0951048,4.0739243,115.191526,103.5752998,194.3291196,10.8583834,14.1809252,0.7080335,43.8722736),(46932,'metatarsal.tif',230,10,62,77.9789824,14.7593159,10.9334906,1.8,14.7059529,11.0011753,-0.6105223,6.1970617,7.8785774,639.2993744,902.1766723,4.2715289,114.5100978,103.1616926,194.894901,10.8920042,14.0308334,0.6954455,44.3858951),(46933,'metatarsal.tif',230,10,63,77.3019385,14.7887375,10.9240671,1.8,14.7408446,10.9855049,-0.6238446,6.2318963,7.7721864,642.5502381,879.0024986,4.3964547,113.0959104,103.1066957,194.9343338,10.8499292,13.9035475,0.7104401,44.0836862),(46934,'metatarsal.tif',230,10,64,76.6244598,14.8168441,10.9089229,1.8,14.7708581,10.9689507,-0.6374508,6.2613697,7.6848675,646.1332549,855.2195371,4.5234246,111.2861791,103.193596,194.1906329,10.8499292,13.7942569,0.709845,42.9500687),(46935,'metatarsal.tif',230,10,65,76.4545331,14.842015,10.9030748,1.8,14.7993901,10.9634816,-0.661072,6.3230856,7.5570375,651.8778986,838.7604197,4.8032696,110.9906381,103.0949025,194.2626707,10.8499292,13.6937462,0.7012599,43.1348877),(46936,'metatarsal.tif',230,10,66,76.3394066,14.8415126,10.9246699,1.8,14.7950737,10.9859988,-0.6749901,6.3564864,7.4755929,654.2211395,828.3382608,4.9682575,110.8056943,102.921818,196.5111906,10.8499292,13.5845362,0.7005819,44.3748796),(46937,'metatarsal.tif',230,10,67,76.1316562,14.8669954,10.941985,1.8,14.8350572,11.002125,-0.6984896,6.3608199,7.4294817,657.3935925,812.209436,5.2471,109.3224898,103.3504489,196.1853236,10.9274287,13.5384763,0.765158,43.3994875),(46938,'metatarsal.tif',230,10,68,75.8078487,14.8993924,10.9488926,1.8,14.8734357,11.0110302,-0.7161266,6.3916105,7.3458827,666.7438315,794.5833117,5.4448965,108.1671656,104.3154663,195.4773195,10.9274287,13.4161452,0.7036138,43.4824947),(46939,'metatarsal.tif',230,10,69,75.0150733,14.8822162,10.9527416,1.8,14.845508,11.0100254,-0.7712296,6.4429315,7.1321999,664.3958536,779.820246,6.0741371,109.3379688,103.1201173,196.6503938,10.9819961,13.2478806,0.7067227,43.1880749),(46940,'metatarsal.tif',230,10,70,74.4265927,14.886162,10.9517138,1.8,14.852795,11.0081045,-0.8283707,6.462991,6.9283982,664.9800476,764.8831417,6.7346101,110.3982647,102.8904491,197.1963979,10.9846378,13.1386216,0.7060671,42.3112683),(46941,'metatarsal.tif',230,10,71,74.2250694,14.9090216,10.9618669,1.8,14.8985021,11.0172763,-0.910161,6.4538948,6.6509166,663.7408846,754.4390888,7.712878,113.4338526,102.8434614,198.8583225,11.0442041,12.9970603,0.7474417,42.8248897),(46942,'metatarsal.tif',230,10,72,73.2201205,14.971001,10.9666144,1.8,14.9752461,11.0225184,-1.0997005,6.2527229,6.1942315,652.1809156,730.9979624,9.6895642,118.0126958,104.3035055,197.5698602,11.0554315,12.7519054,0.7079671,41.9370676),(46943,'metatarsal.tif',230,10,73,72.3194811,14.9762111,10.9652388,1.8,14.9717072,11.016527,-1.2162048,6.0872683,6.1605437,645.9781127,720.628933,10.6001923,116.9748915,106.1195407,198.902723,11.0726309,12.659964,0.7724119,41.5440624),(46944,'metatarsal.tif',230,10,74,71.7169088,14.9753461,10.9543346,1.8,14.972567,11.0012235,-1.3200842,5.8886878,6.1156379,643.2054172,714.8884767,11.2171155,116.8951617,109.2272921,201.7282149,11.0348736,12.4542917,0.7369779,41.0602609),(46945,'metatarsal.tif',230,10,75,70.6919074,15.0008586,10.9430626,1.8,14.9938574,10.9904798,-1.4622496,5.6804188,6.0789882,629.4190605,709.3009045,11.643709,116.6807495,110.8050447,204.4553842,11.0595806,12.33119,0.7987307,41.0790654),(46946,'metatarsal.tif',230,10,76,69.7977279,15.0485981,10.9330902,1.8,15.0631887,10.9755397,1.5668357,5.8356054,5.9746647,606.2329359,707.2188368,11.6327722,118.3696274,103.8851832,204.2580692,10.8255386,12.2365787,0.893088,40.5842485),(46947,'metatarsal.tif',230,10,77,69.1950191,15.0745552,10.9320787,1.8,15.0876283,10.9756667,1.5097117,5.7791711,5.9870487,591.11036,707.3647991,11.4895251,118.1491641,102.2828974,203.4966731,10.6864562,12.0921565,0.9080668,41.0070737),(46948,'metatarsal.tif',230,10,78,68.443468,15.1035929,10.9224456,1.8,15.1200649,10.9619773,1.4543995,5.8679937,5.9571115,574.9599385,704.4032464,11.2533936,118.2457723,97.9823716,202.3257899,10.840653,12.094888,2.109018,41.0602609),(46949,'metatarsal.tif',230,10,79,67.5655857,15.1286138,10.924642,1.8,15.1421212,10.9615227,1.3991858,5.9318628,5.9256239,557.974759,698.6862534,10.9325375,117.9093145,94.0640028,198.3905438,10.7630434,12.1229127,2.160572,40.5012413),(46950,'metatarsal.tif',230,10,80,67.1580533,15.1222629,10.9311644,1.8,15.1412136,10.9653495,1.3619305,5.5545066,5.9444178,548.0813557,695.4232387,10.7117741,116.9876113,98.6732748,197.0041679,10.4114175,12.1120082,2.0859742,40.1568606),(46951,'metatarsal.tif',230,10,81,65.8313249,15.1523945,10.9379942,1.8,15.1677842,10.9757146,1.3436093,5.4625987,5.9324722,527.642802,692.4539016,10.4152612,116.7226543,96.5919022,193.3883924,10.1632302,12.1023345,2.1463662,38.9214314),(46952,'metatarsal.tif',230,10,82,64.7674688,15.1593599,10.9486112,1.8,15.1637892,10.9866095,1.3176695,5.390713,5.9506359,513.7377005,689.3342981,10.1175815,115.8421242,95.3005102,191.4309989,10.0749343,12.094888,2.109018,39.0044387),(46953,'metatarsal.tif',230,10,83,64.0848222,15.1704992,10.9548166,1.8,15.1709484,10.9923111,1.2985065,5.3401039,5.9408418,503.2792207,687.5320184,9.9082887,115.7297293,94.2452107,190.1402572,10.0749343,12.1355399,2.0630076,39.4914665),(46954,'metatarsal.tif',230,10,84,63.5843485,15.1789516,10.9654054,1.8,15.1846645,11.0012843,1.2896589,5.2518873,5.9402474,494.1626709,688.219621,9.7816284,115.8570634,94.0923982,189.2035198,9.9701889,12.1120082,2.0859742,39.4648729),(46955,'metatarsal.tif',230,10,85,63.1166475,15.1783078,10.9781271,1.8,15.1808261,11.0175225,1.2783719,5.2095748,5.9388453,486.2821008,689.3072347,9.6452522,116.0675524,93.343913,188.100726,9.9011769,12.1498842,2.1287195,39.2722648),(46956,'metatarsal.tif',230,10,86,62.7029947,15.1807465,10.9801242,1.8,15.1815546,11.020361,1.2648841,5.1641786,5.9635366,480.4026642,692.0657669,9.5026465,116.0495541,93.025959,188.7845696,9.838755,12.1503785,2.0915247,38.7696588),(46957,'metatarsal.tif',230,10,87,62.3865814,15.1839868,10.9829343,1.8,15.1915356,11.0257609,1.2507974,5.1688145,6.0066112,473.6918854,696.3571456,9.3688894,115.9317831,91.6442031,188.9121393,9.8319073,12.1795085,2.0828392,38.7242606),(46958,'metatarsal.tif',230,10,88,62.1530486,15.1877447,10.9709414,1.8,15.1907098,11.0108169,1.2351485,5.1127123,6.0552879,466.2003142,701.4812716,9.234992,115.8460644,91.1845399,187.4748475,9.7556242,12.2405048,2.0655953,38.6334643),(46959,'metatarsal.tif',230,10,89,61.6915744,15.1886916,10.9504724,1.8,15.1863543,10.9858224,1.2224259,5.0422434,6.1096153,459.3215206,703.3958022,9.0837644,115.1293114,91.0946748,186.4376465,9.7004894,12.2471272,2.0797387,38.7618697),(46960,'metatarsal.tif',230,10,90,60.7694735,15.1865054,10.9443859,1.8,15.1892117,10.9880147,1.2133529,4.9592273,6.1336312,449.698384,705.4293797,8.888383,115.0100745,90.6791232,184.8050356,9.6539342,12.3051041,2.0485275,38.542668),(46961,'metatarsal.tif',230,10,91,60.0298178,15.1782069,10.9351061,1.8,15.1799402,10.9739498,1.2067172,4.8663951,6.1702279,442.983959,707.341119,8.7363458,114.6377625,91.0291813,183.1751902,9.6328015,12.3409276,2.0541043,37.6814395),(46962,'metatarsal.tif',230,10,92,59.4236508,15.1748653,10.9190987,1.8,15.1747829,10.9534653,1.1939567,4.8515683,6.2268459,435.2212432,709.7180225,8.5628295,113.9771299,89.7073315,181.6841195,9.6328015,12.4086347,2.0232712,38.7462915),(46963,'metatarsal.tif',230,10,93,58.7860403,15.1581047,10.8919467,1.8,15.1509953,10.9318997,1.1865355,4.8360874,6.2225262,428.831843,709.573409,8.4208017,114.0330125,88.6733038,180.4969689,9.5833414,12.4096027,2.0512021,38.727487),(46964,'metatarsal.tif',230,10,94,58.3776532,15.1415362,10.8784703,1.8,15.1357584,10.9136653,1.1725033,4.8350268,6.206404,424.8407966,711.3843511,8.2660407,114.6210192,87.8673097,181.46989,9.6244487,12.3620804,2.0961632,37.9868748),(46965,'metatarsal.tif',230,10,95,57.91816,15.1175143,10.8763296,1.8,15.1099964,10.9001262,1.1603552,4.8303074,6.2035127,420.2972029,714.0390266,8.1161482,115.1023715,87.0125167,181.3512822,9.6076541,12.3620804,2.0961632,38.4894808),(46966,'metatarsal.tif',230,10,96,57.131109,15.102375,10.8865928,1.8,15.1039504,10.9193342,1.1494433,4.8334672,6.2109809,416.0494028,714.5553966,7.9290616,115.0471081,86.0768025,181.2254147,9.6394601,12.420246,2.079107,38.2702791),(46967,'metatarsal.tif',230,10,97,56.5612778,15.0841697,10.8865442,1.8,15.0868285,10.9223231,1.1396023,4.8735125,6.2349852,413.958027,718.7238814,7.7801257,115.2727482,84.9403846,180.6556318,9.656836,12.4819907,2.0622146,38.6100971),(46968,'metatarsal.tif',230,10,98,56.0368373,15.0667864,10.8916348,1.8,15.0639092,10.9315076,1.1308871,4.8826207,6.2763028,412.1652203,723.581475,7.6457176,115.2878533,84.4147537,179.8621836,9.632245,12.5467828,2.1090972,38.3610754),(46969,'metatarsal.tif',230,10,99,55.5025426,15.0418229,10.9232619,1.8,15.0424915,10.9627654,1.1270796,4.845497,6.3115903,411.0180113,729.8615232,7.5455909,115.6382919,84.8247375,179.9171818,9.6808705,12.5788149,1.9627439,38.6820888),(46970,'metatarsal.tif',230,10,100,54.9466796,15.0130291,10.9512663,1.8,15.0129216,10.9864884,1.1194953,4.8598661,6.359264,410.2013738,735.6242498,7.4158311,115.6775773,84.4059004,179.4891408,9.7561083,12.6694489,2.0891837,38.3986845),(46971,'metatarsal.tif',230,10,101,54.4604125,14.9917501,10.9869303,1.8,14.9884409,11.0262338,1.1103329,4.854334,6.4127111,409.5972622,740.4061716,7.2844548,115.4591504,84.3776434,179.128155,9.7208227,12.7751987,2.0914473,38.7086825),(46972,'metatarsal.tif',230,10,102,53.9715235,14.9642751,11.0186532,1.8,14.9575189,11.0642259,1.100987,4.8575681,6.4676503,409.5022009,744.7452388,7.1516586,115.1492735,84.3018966,178.3070263,9.7300524,12.8719171,2.080234,38.4518717),(46973,'metatarsal.tif',230,10,103,53.4223858,14.9383688,11.0624579,1.8,14.9340685,11.1043326,1.0885495,4.907832,6.5156236,409.7741279,749.4225276,6.9886853,115.0193094,83.4939193,177.6207438,9.7549216,12.9591113,2.1040365,38.8182833),(46974,'metatarsal.tif',230,10,104,53.050032,14.9140201,11.1038949,1.8,14.9161691,11.1535655,1.075014,4.8946408,6.5633681,410.1065592,757.1649877,6.8407184,115.3622616,83.7868555,177.6751684,9.8032687,13.0540071,2.0928879,39.5854891),(46975,'metatarsal.tif',230,10,105,52.4422102,14.8654827,11.1175752,1.8,14.8782321,11.1768809,1.0701013,4.9413056,6.6504086,410.2366072,760.221488,6.7262907,114.3119973,83.0219055,175.6120449,9.8121527,13.1806113,2.1848941,39.2378821),(46976,'metatarsal.tif',230,10,106,52.2628413,14.848094,11.1476099,1.8,14.8532598,11.2185767,1.0653732,4.9363434,6.7023694,409.6414445,771.5636325,6.6684945,115.1180406,82.9847947,175.9209519,9.8041035,13.2777692,2.1102148,39.9596898),(46977,'metatarsal.tif',230,10,107,51.7583245,14.8158765,11.1758906,1.8,14.7992366,11.2262162,1.0623743,4.9565551,6.7622213,409.8512355,776.0243579,6.5821599,114.7587934,82.6887276,175.0827836,9.8041035,13.3986742,2.1251038,40.4999049),(46978,'metatarsal.tif',230,10,108,51.7323215,14.7908042,11.2310449,1.8,14.77493,11.2903547,1.0648588,4.9593732,6.7856115,413.087213,788.4068244,6.5970435,116.1880289,83.2942376,176.9536306,9.8306994,13.5171649,2.1062994,40.0128771),(46979,'metatarsal.tif',230,10,109,51.7153938,14.7481318,11.2601601,1.8,14.7339763,11.3328516,1.0728734,4.9746318,6.8522924,415.5382572,806.5000487,6.6531564,117.697845,83.5314602,177.8949911,9.8259195,13.6579529,2.1950036,40.477874),(46980,'metatarsal.tif',230,10,110,51.343734,14.708689,11.2675382,1.8,14.7046529,11.3428291,1.075773,4.9629259,6.9313053,413.8555034,820.3288231,6.6261267,118.3512762,83.3894175,177.590657,9.8286944,13.7951277,2.2086795,40.5874749),(46981,'metatarsal.tif',230,10,111,51.0833329,14.6779101,11.2851775,1.8,14.6737689,11.3609658,1.0860732,4.9620566,7.0255131,413.8298577,843.1949721,6.6653374,120.0189885,83.3988586,178.5238449,9.8773198,13.9372019,2.1942779,41.2450799),(46982,'metatarsal.tif',230,10,112,51.3856799,14.6253896,11.3106783,1.8,14.6131996,11.3829496,1.0948289,4.949049,7.1247881,417.7349754,875.6601947,6.7662446,122.9033324,84.4071205,181.1736472,9.8778763,14.0908489,2.199997,41.9590985),(46983,'metatarsal.tif',230,10,113,51.6395204,14.5701103,11.4003664,1.8,14.5550268,11.4689849,1.0979417,4.9897789,7.1697822,422.6148996,911.6459529,6.8214425,127.1511365,84.6961181,185.9826424,9.9273365,14.2618022,2.1196033,42.3786973),(46984,'metatarsal.tif',230,10,114,52.2887546,14.4817013,11.3961384,1.8,14.4740509,11.4782648,1.0972666,5.0545447,7.3183427,432.1046374,954.6230533,6.9024316,130.4425187,85.4883399,189.264234,10.0017173,14.4500712,2.1305327,42.4429),(46985,'metatarsal.tif',230,10,115,52.7776436,14.4230172,11.4570495,1.8,14.4050971,11.5375654,1.0849274,5.1098554,7.4366176,444.0349254,999.1806086,6.8780929,134.3595523,86.8977485,193.7211738,10.1314891,14.7471173,2.1427653,42.6056881),(46986,'metatarsal.tif',230,10,116,54.291976,14.3925012,11.4556197,1.8,14.3689965,11.5302906,1.0794022,5.2300034,7.5864777,470.457214,1055.9579804,7.0339992,139.1894928,89.95352,201.081993,10.2850658,14.9399247,2.1717478,43.5012993),(46987,'metatarsal.tif',230,10,117,56.7722731,14.3509836,11.5072331,1.8,14.3260967,11.563754,1.0665064,5.3452191,7.7948193,505.8781619,1142.7302552,7.2529552,146.6012507,94.6412388,210.5836073,10.448365,15.3074744,2.1798632,44.3216924),(46988,'metatarsal.tif',230,10,118,59.5799198,14.2423384,11.5721243,1.8,14.1954754,11.6247016,1.0705741,5.4591109,8.0589765,550.9233239,1247.2048866,7.6457336,154.7597119,100.9181419,222.1922863,10.6470094,15.749949,2.1137475,47.5001166),(46989,'metatarsal.tif',230,10,119,63.1324488,14.13817,11.6732368,1.8,14.1078722,11.6968611,1.0615602,5.568832,8.2448862,602.2499286,1380.678264,8.0213311,167.4587406,108.1465429,240.401992,10.8324714,16.1014409,2.0839724,47.2433059),(46990,'metatarsal.tif',230,10,120,66.3778483,13.9400563,11.7737735,1.8,13.9237432,11.7904425,1.069883,5.6475253,8.4971642,646.148133,1512.2016698,8.5116555,177.9654524,114.4126137,253.1875843,10.980891,16.5241208,2.0911059,48.131128),(46991,'metatarsal.tif',230,10,121,71.2415122,13.7521511,11.923632,1.8,13.7350773,11.93535,1.0772579,5.7153804,8.7903616,732.7518637,1676.1364969,9.2087451,190.6789012,128.2070161,272.9760328,11.3932049,17.1315958,2.166327,49.8627105),(46992,'metatarsal.tif',230,10,122,74.1786073,13.538219,12.0559326,1.8,13.5215286,12.0710066,1.0887624,6.0522181,9.1029607,822.9560079,1832.424979,9.7061648,201.2998898,135.9759341,290.6537357,11.9846289,17.4702495,2.0503156,52.7765349),(46993,'metatarsal.tif',230,10,123,79.5721543,13.2324324,12.2596337,1.8,13.2303381,12.2728934,1.0772419,7.1770997,9.3130486,983.1302658,2017.3008577,10.2853948,216.6101502,136.9815538,320.8505209,13.3571323,17.8526608,2.0150289,57.9777351),(46994,'metatarsal.tif',230,10,124,84.2052011,12.9508309,12.3158574,1.8,12.9286299,12.3691984,1.0775593,7.1491633,9.5749433,1137.8859898,2263.1699702,10.8879726,236.3637996,159.1635196,352.1368141,13.5075062,18.4795265,2.0081836,60.1665255),(46995,'metatarsal.tif',230,10,125,87.1365649,12.8029925,12.4177201,1.8,12.7304179,12.4395042,1.084884,7.1449518,9.5690001,1238.2824562,2458.8133357,11.3552997,256.9561407,173.3087207,383.7394374,13.6435104,18.8636062,2.0032041,61.5615164),(46996,'metatarsal.tif',230,10,126,93.2111403,12.5878286,12.4585443,1.8,12.5475064,12.4310378,1.1406497,7.0742209,9.5093384,1381.1842904,2572.093099,12.8337383,270.4807636,195.2418944,407.5799609,13.7100222,18.9290829,2.0106389,61.8825298),(46997,'metatarsal.tif',230,10,127,103.3908104,12.4755099,12.4863287,1.8,12.4797941,12.4796439,1.165125,7.092913,9.3276714,1527.1683064,2737.4086837,14.5481671,293.471818,215.3090412,431.0659122,13.6896306,18.787834,1.782754,61.772929),(46998,'metatarsal.tif',230,10,128,114.8614446,12.3716371,12.4575349,1.8,12.3583493,12.4691236,1.1621544,7.045466,9.2976699,1618.5198318,2911.0686705,16.1208479,313.0965833,229.7250211,479.1288122,13.4826408,18.8162644,1.7698074,62.7405319),(46999,'metatarsal.tif',230,10,129,126.6293563,12.3638266,12.3981874,1.8,12.2482529,12.5039055,1.1828909,7.579546,9.219788,1689.6791669,3110.0387905,18.0853461,337.3221574,222.9261697,470.8630238,13.9350433,18.8196157,1.4178339,64.4519735),(47000,'metatarsal.tif',230,10,130,131.1538288,12.4061074,12.4474607,1.8,12.2241264,12.6041224,1.2228463,7.3309595,9.2179075,1673.452765,3062.0768547,19.3176146,332.1878469,228.2719955,476.5907037,13.6467567,18.7958244,1.5047767,64.8605569),(47001,'metatarsal.tif',230,10,131,125.7874855,12.4229643,12.3855194,1.8,12.2116585,12.5458075,1.2584297,7.31439,9.3489542,1564.6059189,2668.1051999,18.9846769,285.3907656,213.9079148,414.8908985,13.3222798,18.7857559,1.4633282,65.6699345),(47002,'metatarsal.tif',230,10,132,121.2703652,12.4861939,12.2842503,1.8,12.2859439,12.489567,1.2976373,7.1613389,9.3327363,1439.8813838,2395.7385948,18.7407512,256.7026988,201.0631535,374.0890769,12.929138,18.544578,1.4324454,67.6395232),(47003,'metatarsal.tif',230,10,133,120.7970995,12.6456079,12.2373921,1.8,12.4188985,12.3755482,1.2467875,6.7650041,8.9659039,1274.143545,2346.0409268,18.092203,261.6625109,188.3433518,364.9012121,12.4616197,18.1198061,1.4464413,68.3489791),(47004,'metatarsal.tif',230,10,134,120.2205962,12.754963,12.092261,1.8,12.5696984,12.2718566,1.2035702,6.3176036,8.5835953,1021.3562156,2334.1628,17.4540067,271.9329989,161.6682981,346.7967822,11.6909287,17.6539017,1.4872905,60.4045317),(47005,'metatarsal.tif',230,10,135,113.2976605,12.7448036,11.9629059,1.8,12.629762,12.1661083,1.1873556,5.7675332,8.4545181,732.1194748,2139.1501231,16.2400691,253.0185754,126.9380599,303.5985215,10.6613745,17.2343612,1.5123046,63.930563),(47006,'metatarsal.tif',230,10,136,94.0762636,12.7737906,11.9913775,1.8,12.7177307,12.2807056,1.1973952,5.6429787,9.7229544,423.4804402,1697.2733566,13.5929605,174.5635419,75.0455497,214.4857688,9.1402217,16.3683629,2.221873,49.4165181),(47007,'metatarsal.tif',230,10,137,56.4032556,12.9930362,12.0621567,1.8,12.895952,12.125805,1.1958171,3.7082303,9.8977083,132.4341981,718.7788391,8.1395406,72.6207339,35.7135848,81.6256684,6.9085047,14.2845255,2.0077512,42.635508),(47008,'metatarsal.tif',230,10,138,10.9562504,13.356419,12.9031944,1.8,13.3648586,12.9906905,1.3698261,1.9646476,9.348432,7.3530584,26.1470391,1.7532773,2.7969438,3.7426856,3.5782226,3.6777909,6.6419373,1.9036165,23.2224718),(47009,'metatarsal.tif',230,10,139,67.7160714,8.882031,14.9820373,1.8,8.9646876,15.1352202,1.206043,3.8172464,8.5759848,206.9582974,1291.9675327,9.8498853,150.6494656,54.2166463,170.6963265,7.2624899,16.4088594,1.9328837,53.5515299),(47010,'metatarsal.tif',230,10,140,78.1356525,8.6038224,15.0198526,1.8,8.7349093,15.1641834,1.1928356,4.3635794,9.2056759,313.906607,1598.8756016,11.2491885,173.6836736,71.9378701,205.0312015,8.154518,17.5794069,1.9218272,53.626748),(47011,'metatarsal.tif',230,10,141,50.009111,6.8060204,15.1710195,1.8,6.9433087,15.1784726,1.2404279,3.3839408,8.6459444,104.7438664,867.1140165,7.4577766,100.2914167,30.9532207,108.1246527,5.9550812,16.473702,1.9163519,44.6362531),(47012,'metatarsal.tif',230,10,142,18.3973791,4.8277409,15.8728572,1.8,4.8124964,15.8820226,1.2541777,1.5028858,6.1733566,6.0286913,168.8640154,2.7689835,27.3536791,4.01141,28.10939,2.7343633,12.0585826,1.9047414,29.759023),(47013,'humerus',233,2,1,0.3764691,31.570293,99.4057359,1.8,31.7776757,99.3590434,0.0581272,0.3481402,2.2259866,0.0076754,0.2777447,0.0002118,0.1247737,0.0220469,0.1282001,6.3801312,89.3632388,3.1151438,190.4681423),(47014,'humerus',233,2,2,0.2409206,31.3468547,99.4341053,1.8,31.5684455,99.4070198,0.0510596,0.2045651,1.7398602,0.0034815,0.1193679,0.0001046,0.0686078,0.0170192,0.0705991,6.4213651,89.6060292,3.1125771,190.5492373),(47015,'humerus',233,2,3,0.1259861,31.0883071,99.4555466,1.8,31.254378,99.435006,0.0690856,0.1883864,1.2882155,0.0014507,0.0383869,0.0001001,0.0297985,0.0077009,0.0309009,6.46002,89.3769875,3.1098573,190.0765813),(47016,'humerus',233,2,4,0.0432422,30.8463075,99.494088,1.8,30.958968,99.494088,0.0482468,0.0282287,0.5846354,0.0002109,0.0043501,0.0000168,0.0074407,0.0074722,0.0077924,6.4729075,89.6209871,3.1073053,190.5492373),(47017,'humerus',233,2,5,0.004265,30.486312,99.494088,1.8,30.486312,99.494088,0.7853982,0.000000000000007536,0.00000000000001256,0.0000199,0.0000199,0.0003554,1580341186.53443,2633901977.34675,2710262775.22251,6.4522905,89.8655671,3.1047672,190.6303322),(47018,'humerus',233,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47019,'humerus',233,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47020,'humerus',233,2,8,17.3009575,73.3592467,56.2300854,1.8,73.7048882,56.8288697,0.9463633,3.396693,9.3988187,28.254876,243.0579262,1.8979124,25.8604761,8.3183486,28.2700212,6.55293,16.4888537,2.0472637,40.6402655),(47021,'humerus',233,2,9,49.2039528,73.2187493,56.4536305,1.8,73.5628841,57.0427492,1.0078257,5.0155274,11.7942668,220.2519768,1363.0980067,5.8648122,115.5729326,43.9140216,134.1678958,9.920562,21.9696081,2.1259749,57.4125967),(47022,'humerus',233,2,10,67.2328341,72.8544649,56.9555894,1.8,73.3284952,57.7770611,1.0291026,6.3092065,13.0990275,490.2493344,2676.7287688,8.2267108,204.3456097,77.7038027,240.8562048,12.1261951,25.392891,2.2440838,65.4239965),(47023,'humerus',233,2,11,110.4555084,70.6634239,62.0342636,1.8,70.4180209,63.6166722,-1.3206898,12.077055,19.6244378,2638.7417485,9052.6392296,17.2815039,461.2941941,218.4921534,581.6946809,21.6568191,34.2047533,1.3761108,105.1902066),(47024,'humerus',233,2,12,162.8475166,68.4868452,64.7861999,1.8,68.2742066,65.3447462,-1.2452783,21.1949494,19.3173662,6968.150418,15102.8887959,24.3654682,781.8296046,328.7646645,1017.9002199,24.2760607,37.2709561,1.3535029,112.103943),(47025,'humerus',233,2,13,210.3839132,66.4460549,65.858189,1.8,66.8799787,66.0285791,-1.3648935,20.3261565,19.8700289,14621.590116,21117.8830765,33.5983034,1062.8008245,719.3484949,1655.8066798,26.1303217,39.7846098,1.4036945,121.4047115),(47026,'humerus',233,2,14,260.0859547,65.1805706,66.7273025,1.8,65.7685039,66.467712,-1.5662654,19.1815285,21.1266978,21673.7164021,27425.5047438,43.3467694,1298.1444136,1129.9264474,2253.7161935,34.9638654,41.478762,1.4393743,159.7767057),(47027,'humerus',233,2,15,285.6730738,64.1230364,66.8124454,1.8,65.0252399,66.8683573,1.3489801,20.8199638,20.6782211,26766.0652742,32185.6457849,45.3077144,1556.4997399,1285.5961473,2728.0575789,0.4229961,0.8520927,2.1587989,1.8095291),(47028,'humerus',233,2,16,294.5097392,63.8075115,67.3353487,1.8,64.640888,67.3558672,1.3252516,21.4898675,21.1100693,30194.6383987,35308.5445571,46.1845177,1672.5925477,1405.0639643,2965.8134323,37.70408,43.6823397,1.4296644,148.2035906),(47029,'humerus',233,2,17,301.585425,63.8381777,67.893756,1.8,64.4853866,67.8017292,1.5376772,21.6075521,21.9176315,32934.04839,37606.7050744,50.2091238,1715.8197511,1524.1915503,3116.6574699,0.8026837,3.072264,1.9655874,6.6507746),(47030,'humerus',233,2,18,310.0362621,63.9393025,68.2555186,1.8,64.3575894,68.2744835,-1.4202017,21.05423,22.2491738,35020.5020951,39801.2730231,50.5096703,1788.8876815,1663.3475566,3224.4911277,1.2695883,3.2144083,2.1995926,8.8518647),(47031,'humerus',233,2,19,320.8989621,63.98924,68.5827095,1.8,64.3107688,68.7295632,-1.3057409,21.1112628,23.463889,36598.3096211,42276.4890748,49.8129061,1801.7682007,1733.5916835,3358.9609087,39.6440046,45.063728,1.3487144,147.5826584),(47032,'humerus',233,2,20,320.7195622,63.7223683,69.1138779,1.8,64.2672823,69.1776541,-1.372198,21.0505431,22.4964333,36378.4465332,43477.2451664,51.3725661,1932.6283694,1728.1476505,3495.1715278,39.8875556,45.2813329,1.3283493,148.3895326),(47033,'humerus',233,2,21,318.3801024,63.4077071,69.5980941,1.8,64.1850696,69.5860467,-1.4243411,21.6397757,23.358087,34837.6019605,44280.0576066,51.9333019,1895.7056558,1609.8873874,3386.5374358,39.983938,45.4567555,1.313208,144.0782859),(47034,'humerus',233,2,22,316.6857038,63.0069173,69.9093,1.8,64.0738536,69.9173203,-1.4619188,22.3418567,23.3157683,33726.0475436,44925.1842821,52.1577367,1926.8155228,1509.5454238,3300.782889,39.975562,45.4149618,1.2967854,145.7731293),(47035,'humerus',233,2,23,310.1178721,62.7194623,70.2192517,1.8,63.8589896,70.1222149,-1.4583177,22.4449203,24.9460525,31869.9305032,44780.4946742,51.0351587,1795.0934217,1419.9172932,3066.2849809,39.6376602,45.2523382,1.2903446,143.4909443),(47036,'humerus',233,2,24,297.4912646,62.544413,70.6843328,1.8,63.7051759,70.3131709,-1.4278731,21.9287442,24.5028025,28801.398589,43199.344065,48.5759442,1763.0368613,1313.4084827,2896.2759459,39.0623461,44.7833765,1.2206728,142.9945361),(47037,'humerus',233,2,25,277.5195667,62.5501404,71.3580135,1.8,63.5701864,70.4448324,-1.3441338,20.4667302,23.0846815,25022.7885092,40026.1988999,43.9173761,1733.8856868,1222.60802,2757.0245164,37.7678857,44.5902779,1.2021004,141.0129787),(47038,'humerus',233,2,26,264.1841432,62.7368076,71.945323,1.8,63.5774587,70.4895312,-1.2514289,19.0189906,25.0260876,21999.515253,38090.4909749,39.6903786,1522.0313904,1156.7130815,2397.2282567,36.866883,44.4126904,1.1833731,138.9265742),(47039,'humerus',233,2,27,249.6329636,62.9553418,72.0834689,1.8,63.6881537,70.4176642,-1.1924956,18.1040871,23.8400419,18946.2903082,36960.4865083,35.9299463,1550.3532556,1046.5200616,2342.5555394,35.3503093,44.0661425,1.174355,136.8737603),(47040,'humerus',233,2,28,238.5504817,63.1454831,72.0342197,1.8,63.836669,70.3272511,-1.1690345,17.1104933,24.7461684,16819.2010601,35612.4370304,33.6788494,1439.109136,982.9758144,2093.1051641,34.0579855,43.7589867,1.2063367,140.9081316),(47041,'humerus',233,2,29,225.382391,63.3193407,71.7661721,1.8,63.9680517,70.1941165,-1.1530615,17.3691704,25.0619114,15014.7823083,33830.0622942,31.3812936,1349.8596222,864.450172,1900.8270618,33.1566409,43.538263,1.2044019,129.8314246),(47042,'humerus',233,2,30,211.1282198,63.6123716,71.1735146,1.8,64.1332765,69.9208802,-1.1363209,17.0591191,23.6285028,13569.3669791,31155.9636192,28.953211,1318.5754443,795.4318677,1855.6347466,32.5367177,42.9785714,1.1637385,128.4470472),(47043,'humerus',233,2,31,192.5082158,64.2408901,70.275458,1.8,64.5712268,69.5125849,-1.1445843,17.0495528,22.5091396,12071.9139762,27042.2079255,26.6007871,1201.3878988,708.0487145,1737.6267572,31.8842668,42.266389,1.1747149,124.4937709),(47044,'humerus',233,2,32,172.8045854,65.1522862,69.0667531,1.8,65.0637813,68.8186804,-1.1747241,16.8734095,20.934787,10666.234574,22265.2376898,24.514064,1063.5521478,632.1327396,1572.8975696,31.3030906,41.1326151,1.1379873,122.2926808),(47045,'humerus',233,2,33,146.8721046,66.8805661,66.9796877,1.8,66.8067676,66.7160512,-1.3561521,16.492661,18.2487509,8998.6169898,15435.6501269,23.3681122,845.846939,545.6134085,1288.7423797,29.6497204,36.164362,1.1393014,111.1823831),(47046,'humerus',233,2,34,137.420182,67.5471507,66.1652816,1.8,67.5201203,65.8322619,-1.4678324,15.7689329,20.3358811,8343.4590133,13458.9350108,22.6614093,661.8319092,529.1073959,1071.1337002,28.3454141,33.9688104,1.2006255,104.2211424),(47047,'humerus',233,2,35,131.1404903,68.0520714,65.7916893,1.8,68.0068854,65.3198112,-1.5427273,15.3763266,16.2605091,7786.019403,12265.302613,21.8395328,754.3000358,506.3640764,1047.3413609,27.4193302,32.5892799,1.2306992,100.6831793),(47048,'humerus',233,2,36,128.0503941,68.5138768,65.5522041,1.8,68.4641745,64.9001729,1.5646253,14.9218417,15.7386257,7475.3737212,11595.174615,21.3409197,736.7336163,500.9685702,1073.793124,26.6175296,31.6926334,1.2679115,97.6752149),(47049,'humerus',233,2,37,124.1996083,68.900127,65.2753337,1.8,68.7583932,64.6890152,1.511775,14.7789839,17.2363942,7167.1682866,11009.5730924,20.6279099,638.7399208,484.9567701,1022.8281652,25.9302832,30.9688886,1.2924967,96.3145897),(47050,'humerus',233,2,38,121.8051438,69.1774593,65.0543896,1.8,68.9841243,64.4461151,1.4745252,14.7852241,15.8621857,6947.9260946,10603.6219537,20.1132869,668.4842916,469.9236249,1041.0425899,0.472656,0.9744053,1.815775,2.2821851),(47051,'humerus',233,2,39,118.5706645,69.5271008,64.9339386,1.8,69.3507974,64.4726547,1.4659379,14.3092609,15.7856643,6770.8043308,10161.2572419,19.545286,643.7015903,473.176384,981.0970244,0.236328,0.3342183,2.3561945,0.6684365),(47052,'humerus',233,2,40,118.4185469,69.8022298,64.8237442,1.8,69.6228085,64.3797626,1.4495403,14.0849331,16.2725023,6590.1701899,10059.1215994,19.4476586,618.166855,467.8879306,977.4342877,24.5154552,29.7595043,1.9704744,91.8886573),(47053,'humerus',233,2,41,116.897574,70.1562294,64.7132437,1.8,70.0482194,64.3418889,1.4213234,14.3425446,15.60962,6464.2228583,9700.6211641,19.0508706,621.4514635,450.7026506,985.1417072,0.472656,0.6684365,2.3561945,1.3368731),(47054,'humerus',233,2,42,116.406729,70.5215954,64.6523057,1.8,70.362259,64.3639513,1.4142008,13.6990789,15.2832947,6389.3856942,9476.8584358,18.9292403,620.0795475,466.4098762,962.8385716,0.472656,1.0568909,2.0344439,2.2821851),(47055,'humerus',233,2,43,115.7303066,70.6949392,64.6767059,1.8,70.5196958,64.3564677,1.3948205,13.6149608,15.0599359,6249.1416906,9185.9521361,18.6972119,609.9595769,458.9907945,880.4197092,23.8228244,28.8765353,2.6376738,89.4680345),(47056,'humerus',233,2,44,115.0786786,70.9706268,64.5745399,1.8,70.8341951,64.2378873,1.3797768,13.4873559,15.2814589,6162.3023273,9009.346033,18.4884096,589.5605988,456.8947672,906.1778209,23.6314754,28.7631662,2.6448689,88.6611603),(47057,'humerus',233,2,45,115.7363317,71.2730676,64.6160401,1.8,71.1024487,64.2398856,1.3460489,13.2296766,14.9337641,6186.6506608,8898.1019496,18.3313497,595.8378518,467.6343074,896.810404,23.4304107,28.4939446,2.6111302,88.2458471),(47058,'humerus',233,2,46,116.8353425,71.5251723,64.5974511,1.8,71.3542782,64.3059833,1.3427223,13.8612146,15.5414583,6122.2784449,8836.7242441,18.4770801,568.5904173,441.6841264,859.1353429,0.472656,0.9744053,1.815775,2.2821851),(47059,'humerus',233,2,47,117.9809126,71.776433,64.5760517,1.8,71.6086172,64.2830658,1.3244584,12.971993,14.8009512,6150.9802968,8766.7361476,18.4942003,592.3089676,474.1738844,937.1009959,22.986067,28.3751108,2.6183143,87.2431923),(47060,'humerus',233,2,48,117.2396863,72.0144642,64.624171,1.8,71.9763176,64.3352595,1.2891411,12.8354751,14.4450231,6082.2592364,8621.3998406,18.0304086,596.8422349,473.8631932,975.1237433,22.8866976,28.2577539,2.6255586,86.5747557),(47061,'humerus',233,2,49,116.9759007,72.4341757,64.5623494,1.8,72.4109076,64.4902916,1.2446894,13.3448858,14.6774915,6020.4674149,8437.4281211,17.4951306,574.8549134,451.1441692,916.2374079,0.472656,1.4375271,1.735945,3.4232776),(47062,'humerus',233,2,50,115.7744796,72.6808843,64.571051,1.8,72.4623327,64.5709266,1.2434856,13.2591923,14.5438881,5953.3505676,8195.0142536,17.3013231,563.4679133,448.9979797,900.1807704,0.4864222,2.5453305,1.9513027,5.5096821),(47063,'humerus',233,2,51,116.3122224,72.9049101,64.6206968,1.8,72.7447315,64.6154903,1.1935439,12.7936411,14.6518821,5964.7435128,8088.1190221,16.7548802,552.0191155,466.2272034,903.7949698,22.7902167,28.1418922,2.6328628,85.2952255),(47064,'humerus',233,2,52,118.4249783,73.2065769,64.6286995,1.8,73.0619096,64.6967454,1.1293107,12.6451963,14.7102615,6037.9217994,8070.4216113,16.1340053,548.6252981,477.4873906,931.278475,0.472656,1.4946695,1.8925469,3.2274971),(47065,'humerus',233,2,53,117.9482822,73.5205917,64.730176,1.8,73.3502087,64.6313792,1.0682722,12.3320985,14.8986374,6005.0584936,8004.6653834,15.0978476,537.2749995,486.9453877,892.7701713,0.472656,1.4946695,1.8925469,3.2274971),(47066,'humerus',233,2,54,118.8384951,73.7273832,64.7929009,1.8,73.5362779,64.7332062,1.0301363,12.1832694,14.9048016,6029.8184555,7984.4682691,14.5593366,535.6977212,494.9261363,881.2721039,22.7243406,28.651298,2.6521205,85.1567877),(47067,'humerus',233,2,55,118.3365646,74.0161733,64.8956594,1.8,73.9252787,64.8409378,0.9450454,12.6002868,18.9833143,6027.2866853,7911.8615582,12.956836,416.7797808,478.3451997,662.3939918,22.7243406,28.7631662,2.6448689,85.1567877),(47068,'humerus',233,2,56,119.3511727,74.2699371,65.0199039,1.8,74.2658271,65.0053438,0.9236672,12.4774858,14.9075786,6012.1879847,7934.8768191,12.6614368,532.2713392,481.8429024,932.2729536,22.6206915,28.8600905,2.6559706,84.7652267),(47069,'humerus',233,2,57,119.4289578,74.6457399,65.0187325,1.8,74.783511,65.0107916,0.8873889,12.9146686,14.9754949,5976.4981045,7861.5405596,11.9684718,524.9603186,462.7682138,906.0425161,0.4229961,0.8520927,2.1587989,1.8095291),(47070,'humerus',233,2,58,119.8267349,74.9672725,65.0704768,1.8,75.2144393,65.1060016,0.8382722,13.2982492,15.3052381,5899.6551729,7837.5428267,11.0395488,512.0823844,443.641495,875.3711259,22.4841461,29.3132472,2.6274465,84.9036644),(47071,'humerus',233,2,59,119.745988,75.1717412,65.2145919,1.8,75.544845,65.2558068,0.8063081,13.1686159,14.0459255,5824.8254047,7769.5664542,10.3960252,553.1544679,442.3263203,887.9017311,0.236328,0.3342183,2.3561945,0.6684365),(47072,'humerus',233,2,60,119.5010732,75.3851944,65.3018027,1.8,75.8590516,65.4238788,0.7598138,13.2215851,14.7330474,5805.4000985,7744.8853432,9.4490856,525.6811523,439.0850322,866.1269489,22.2782021,29.789517,2.5998126,85.3763204),(47073,'humerus',233,2,61,120.2521835,75.4366724,65.4651049,1.8,75.8703631,65.6043628,0.7187955,13.2357444,15.8889273,5800.3653007,7798.3716024,8.6901057,490.8054188,438.234913,846.6668127,22.2313794,30.0759299,2.6146494,85.5721009),(47074,'humerus',233,2,62,119.2368137,75.6745749,65.4797773,1.8,76.0120422,65.5477955,0.6781157,13.115562,15.5124803,5700.5266358,7833.0384929,7.8207195,504.9507441,434.6383796,842.9797486,22.1266124,30.0471326,2.6322023,85.4336632),(47075,'humerus',233,2,63,119.4510951,75.9045865,65.6137073,1.8,76.3443354,65.7236996,0.6388316,13.0002331,15.7733568,5688.8198612,7860.6159442,7.0779443,498.3476901,437.5936828,836.7702778,22.0889009,30.1630825,2.625362,85.3763204),(47076,'humerus',233,2,64,121.3323235,76.0594255,65.7572112,1.8,76.6742603,65.9206636,0.6137362,12.9799416,15.787122,5688.844777,7869.309782,6.7074636,498.4638596,438.2796911,841.0732228,22.0512179,30.0471326,2.6322023,84.9036644),(47077,'humerus',233,2,65,123.0970265,76.2195952,65.866163,1.8,76.7785942,66.0873574,0.5900606,13.1032236,16.0550752,5662.8893469,7834.6767594,6.3516758,487.9875471,432.1752827,824.5433822,22.034392,30.1399282,2.6428717,84.7078839),(47078,'humerus',233,2,66,125.1885759,76.1584475,65.9231552,1.8,76.5368852,66.0180529,0.5559304,12.7413956,16.3702997,5547.3757502,7956.1867988,5.8108978,486.0135102,435.3821153,812.1635103,0.236328,0.3342183,2.3561945,0.6684365),(47079,'humerus',233,2,67,126.0295723,76.2090893,66.042143,1.8,76.5151752,66.2484906,0.5419611,12.4509735,16.5033388,5525.7758176,7931.1976963,5.5887239,480.5814011,443.8027138,802.982518,21.937165,30.0424853,2.7201734,84.4310084),(47080,'humerus',233,2,68,121.1184821,76.4398724,66.1932386,1.8,77.0325411,66.3455319,0.4879537,12.3307405,16.5672288,5413.5147435,7790.0591968,4.4368044,470.2089465,439.0259246,790.0535934,21.9420056,29.9773475,2.7449823,84.2352279),(47081,'humerus',233,2,69,120.1425296,76.6017725,66.3864882,1.8,77.3272018,66.4654945,0.4440341,12.1187985,16.6143927,5255.9993854,7811.6395974,3.6952642,470.1730445,433.7063092,781.6396676,21.8509087,29.9465905,2.7273747,83.8199147),(47082,'humerus',233,2,70,119.6596729,76.7821142,66.570298,1.8,77.5793073,66.6831314,0.4163295,12.0826839,16.6114293,5198.3946828,7706.1507418,3.261611,463.9065419,430.2350969,775.263298,21.7369399,29.8522585,2.7346219,83.6241342),(47083,'humerus',233,2,71,121.9091112,76.902783,66.7287016,1.8,77.5971597,66.8229085,0.3872388,12.0711864,16.7229195,5195.0643928,7776.9597293,2.8975101,465.0479681,430.3689968,773.3840147,21.7349326,29.8457096,2.7772613,83.4856964),(47084,'humerus',233,2,72,123.4356354,77.1019098,66.8440246,1.8,77.9181008,66.9550891,0.3585155,11.8661356,16.6092369,5194.9721572,7805.5399995,2.5328977,469.9517526,437.7981467,782.1616297,21.665062,29.6250133,2.7744188,83.1514782),(47085,'humerus',233,2,73,124.6933813,77.202943,66.9499,1.8,77.98183,67.0913545,0.3374791,11.9915822,16.4884676,5143.3977177,7751.0477539,2.2784281,470.089032,428.9173545,781.8529749,21.6301266,29.40456,2.7715337,82.4830416),(47086,'humerus',233,2,74,124.7762099,77.3879819,67.0967688,1.8,78.2648254,67.2473563,0.3051852,12.0332449,16.2705221,5097.7136554,7646.6155132,1.8775104,469.9674331,423.6358263,783.2626974,21.609865,29.2989538,2.8045372,81.8719479),(47087,'humerus',233,2,75,126.5525401,77.3445598,67.1712894,1.8,78.0976616,67.290155,0.2739929,11.8170616,15.9896997,5094.4035118,7518.5078438,1.5441983,470.2094473,431.1057748,788.6156192,21.5679253,28.8533164,2.7991197,81.0650736),(47088,'humerus',233,2,76,126.7111228,77.4113102,67.2196568,1.8,78.0681931,67.2511801,0.2625272,11.8545723,15.3897187,5058.7406217,7375.964439,1.4223673,479.278705,426.7332878,807.7043924,21.4544378,28.1825475,2.8437102,80.1197616),(47089,'humerus',233,2,77,127.5788431,77.402664,67.2896833,1.8,77.9469908,67.290591,0.2444287,11.7274354,14.8554636,5074.6639529,7236.8085785,1.2452759,487.1479457,432.7172802,828.2791684,21.2383862,27.527901,2.863293,79.5086679),(47090,'humerus',233,2,78,129.4678398,77.3983287,67.4572534,1.8,77.8815164,67.4602573,0.1975417,11.5549424,14.3235455,5104.0557783,7125.0289051,0.8311356,497.4347243,441.7205714,851.1558205,21.0727901,26.9838561,2.8392303,78.1717948),(47091,'humerus',233,2,79,128.8581339,77.3323564,67.4882103,1.8,77.7468207,67.4499358,0.1788318,11.7767155,13.852257,5048.7563175,6954.8795177,0.6795409,502.0755474,428.7066567,863.3051903,20.8428701,26.3269816,2.8595939,77.1691401),(47092,'humerus',233,2,80,129.63282,77.3855415,67.5753094,1.8,77.7400528,67.4838167,0.1397621,11.9647494,13.2690383,5071.2731706,6827.9783562,0.4192887,514.5797441,423.851181,890.2118321,20.6546692,25.6815801,2.8809903,76.2238281),(47093,'humerus',233,2,81,130.6153732,77.3363353,67.5765022,1.8,77.6734654,67.479302,0.0951529,11.7891851,13.1413971,5096.9034831,6629.3904953,0.1965062,504.4661878,432.3372182,889.7270647,0.4490794,1.0568909,2.0344439,2.2821851),(47094,'humerus',233,2,82,132.9614505,77.3091815,67.7260398,1.8,77.5714918,67.5817526,0.0255879,12.4204548,12.9724768,5188.2354638,6504.0613849,0.0145059,501.3739069,417.7170291,884.9498394,0.236328,0.3342183,2.3561945,0.6684365),(47095,'humerus',233,2,83,132.3606468,77.3337428,67.7788408,1.8,77.6192582,67.5721101,-0.0301835,11.823306,13.7138772,5149.3487905,6366.5945218,0.0200916,464.2446777,435.5252906,832.702371,20.1013424,24.3142351,2.8659632,74.6100795),(47096,'humerus',233,2,84,134.3559126,77.2699562,67.8055366,1.8,77.5132515,67.5260344,-0.0949834,11.5961399,12.4538162,5194.0469729,6251.8974096,0.2014161,502.0065595,447.9117212,901.2124381,19.9619139,23.9018639,2.8918179,74.0800807),(47097,'humerus',233,2,85,136.0517836,77.2396349,67.9835795,1.8,77.4567399,67.6756686,-0.181939,11.7262822,12.1898088,5184.3469152,6178.1329726,0.7423479,506.8277163,442.1134364,898.7658936,19.8307654,23.9998036,1.1335743,73.8605481),(47098,'humerus',233,2,86,137.1270662,77.1488476,68.1888327,1.8,77.3698404,67.8349657,-0.3108382,11.2979574,11.866117,5193.9294956,6041.5163497,2.1380028,509.1401293,459.7228766,873.4994464,19.7172294,24.2141074,1.1377069,73.3878921),(47099,'humerus',233,2,87,139.3693962,77.0546626,68.3107757,1.8,77.2633832,67.9221743,-0.4413874,11.1258068,11.3843484,5189.9501399,6014.4203791,4.239036,528.3060703,466.4785427,859.1561222,19.5911336,24.3601327,1.1722739,73.2494543),(47100,'humerus',233,2,88,139.6701449,77.0050338,68.4285608,1.8,77.2139163,67.9708476,-0.5436358,11.4400386,12.0215454,5117.7348516,5983.1980766,6.2280928,497.7062317,447.3529354,837.1435981,19.42237,24.578112,1.1760052,72.7767983),(47101,'humerus',233,2,89,141.2735065,77.0316275,68.5704559,1.8,77.2374801,68.1400335,-0.6350465,11.8977724,12.5070426,5008.4026482,5961.0959177,8.2857847,476.6191422,420.9529728,795.6894309,19.2499121,24.6699719,1.1671624,72.6383606),(47102,'humerus',233,2,90,141.3034798,76.950967,68.8121086,1.8,77.1321084,68.393233,-0.6708655,10.9998561,12.0327437,4861.6338798,5891.2519367,9.1015055,489.6017153,441.9724964,801.4316832,19.093232,24.578112,1.1760052,72.4425801),(47103,'humerus',233,2,91,142.5144463,76.7882182,69.0359313,1.8,76.9300212,68.6095068,-0.7594037,10.9550588,12.6244771,4764.8028874,5883.3097302,11.2590504,466.0240325,434.9408782,783.2572202,18.9884753,24.6699719,1.1671624,71.6930486),(47104,'humerus',233,2,92,142.8563893,76.66591,69.2608929,1.8,76.8387256,68.8172924,-0.7891875,10.7847479,12.8289549,4644.0272879,5849.3863838,11.9949204,455.9519008,430.6106504,769.7855468,18.8338381,24.643923,1.1457561,71.3014875),(47105,'humerus',233,2,93,145.6267644,76.5504989,69.521926,1.8,76.7451681,69.1288174,-0.8396141,10.7206144,13.1370874,4573.726468,5865.8412011,13.4488691,446.5100237,426.6291351,762.0185189,18.7082436,24.578112,1.1760052,70.8288315),(47106,'humerus',233,2,94,147.987126,76.4455048,69.7047158,1.8,76.5882023,69.2796317,-0.8889231,10.8441085,13.2196533,4517.7512405,5890.0162923,14.8674495,445.5499824,416.6088199,760.0743879,18.5997271,24.5474156,1.154527,71.105707),(47107,'humerus',233,2,95,148.1931313,76.2831889,69.9501218,1.8,76.46102,69.5667533,-0.8966834,10.7074485,13.207849,4468.9622024,5862.5097672,15.0754076,443.8655968,417.3694773,754.7012188,18.5099292,24.4528115,1.1633665,70.6092988),(47108,'humerus',233,2,96,147.9416667,76.1508536,70.2352723,1.8,76.3478868,69.8047146,-0.8889626,10.636549,13.1871188,4400.1950667,5772.6740685,14.8638353,437.750972,413.6863429,737.019509,18.4122355,24.4881883,1.1849137,70.3324234),(47109,'humerus',233,2,97,148.6589449,76.0036435,70.5030232,1.8,76.1751649,70.1224811,-0.8997024,10.5418918,13.1993254,4317.7478104,5660.3271771,15.1956995,428.8345825,409.5799784,723.1029582,18.2961404,24.3142351,1.2029247,69.9408623),(47110,'humerus',233,2,98,147.866031,75.8690096,70.8236844,1.8,76.0331978,70.4310682,-0.888953,10.6442356,12.9386636,4225.0775048,5533.5336533,14.8560052,427.6742811,396.9357359,720.929682,18.2469431,23.9263864,1.2178059,69.4682063),(47111,'humerus',233,2,99,147.171821,75.693009,71.1673405,1.8,75.7981968,70.9100676,-0.8829801,10.6033856,12.5950764,4126.3649107,5392.3613901,14.6427041,428.1324882,389.1554153,722.5992618,18.1459505,23.4346353,1.1884173,68.1313333),(47112,'humerus',233,2,100,147.5151349,75.5436821,71.516143,1.8,75.6513278,71.3505805,-0.8723659,10.5944887,12.1651633,4072.6703884,5267.3736235,14.4203383,432.9883209,384.4140557,729.3885567,18.1312432,22.9639809,1.1577966,67.324459),(47113,'humerus',233,2,101,148.1936728,75.325735,71.8890837,1.8,75.4026068,71.7206742,-0.8538174,10.5551143,11.8418483,4011.5100806,5148.2555838,14.0340858,434.7510162,380.0536859,738.6290215,18.1072896,22.381397,1.1922507,66.460242),(47114,'humerus',233,2,102,147.57476,75.1194384,72.3105655,1.8,75.1551428,72.1924251,-0.8042319,10.4180977,11.7393597,3976.6035106,4940.8958237,12.7610189,420.8829059,381.7014976,720.0940922,0.236328,0.3342183,2.3561945,0.6684365),(47115,'humerus',233,2,103,147.921425,74.9199945,72.7502521,1.8,74.9362505,72.7396374,-0.7543713,10.5327573,11.4903159,3948.5225982,4777.6149883,11.5623523,415.7949205,374.8802422,749.914524,18.0304475,21.2878931,1.1717354,64.8464934),(47116,'humerus',233,2,104,147.094002,74.7331876,73.1519762,1.8,74.736036,73.111401,-0.68437,10.3153776,11.4451694,3918.8900273,4608.1878726,9.7978791,402.6316877,379.9075693,744.8136466,18.0350568,20.7323107,1.1479424,63.9822764),(47117,'humerus',233,2,105,146.8362585,74.5589188,73.5642437,1.8,74.5794284,73.6016407,-0.5642038,10.4913374,10.3924263,3863.0335167,4446.91405,6.9979782,427.8995049,368.2117338,749.556568,18.153579,20.1434098,1.1859327,63.3138399),(47118,'humerus',233,2,106,146.738147,74.3818797,73.97832,1.8,74.4019982,74.0491347,-0.4710456,10.6852025,10.80869,3820.6992701,4359.9432948,5.0368127,403.3738852,357.5691976,735.930323,18.2768497,19.7909708,0.2044212,62.9796216),(47119,'humerus',233,2,107,147.1740719,74.2097689,74.4335549,1.8,74.2564264,74.4994237,-0.3728914,10.5910804,10.3496721,3805.4970418,4307.160642,3.2555276,416.1639702,359.3115048,738.483951,18.3602755,19.7754435,0.2536741,63.1180593),(47120,'humerus',233,2,108,147.5196707,74.0034191,74.8426601,1.8,74.0454817,74.9483392,-0.2607384,10.8102325,10.2956399,3759.771435,4292.716011,1.6339711,416.9450436,347.7974631,735.5451481,18.4906782,19.7754435,0.2536741,62.5880605),(47121,'humerus',233,2,109,147.4808627,73.8116926,75.2724585,1.8,73.875753,75.4259496,-0.1564564,10.6437272,10.3534404,3709.843768,4296.8145527,0.596794,415.0132123,348.5474318,723.5383268,18.6640268,19.7443523,0.1927008,62.5880605),(47122,'humerus',233,2,110,148.6730261,73.6291091,75.7124155,1.8,73.6804826,75.847876,-0.0328276,10.332145,10.6951367,3690.2636685,4332.7794256,0.0266933,405.1167877,357.1633642,729.9488333,18.4319635,19.7867373,2.6298538,62.6691555),(47123,'humerus',233,2,111,148.4024538,73.456706,76.096309,1.8,73.5133289,76.2917333,0.0572598,10.1038164,10.7383181,3656.9118354,4374.4750325,0.0810055,407.3705942,361.9337174,727.8925396,18.1545133,20.0224357,2.6092701,62.8075932),(47124,'humerus',233,2,112,149.4064164,73.309661,76.534024,1.8,73.3600884,76.6927146,0.1354381,22.8967424,22.4881083,3653.4624878,4467.2322763,0.4539862,198.6486469,159.5625446,253.0344601,17.9438171,20.3914229,2.5793079,63.0844687),(47125,'humerus',233,2,113,150.1877878,73.2080056,76.9445407,1.8,73.303735,77.1733435,0.1880578,9.9405015,11.0943002,3624.1542182,4536.3132162,0.8748633,408.8868277,364.5846453,706.8964365,17.7280872,20.7174889,2.5757383,63.5571247),(47126,'humerus',233,2,114,149.2837136,73.0616513,77.3584233,1.8,73.1708909,77.5784304,0.2419994,9.7671488,11.5146808,3577.7992693,4612.6917229,1.428878,400.5922356,366.3094886,702.64735,17.5859826,21.17214,2.5628777,63.6382196),(47127,'humerus',233,2,115,149.4577146,72.9273799,77.7574853,1.8,73.0590437,78.0209593,0.291473,10.4008469,11.3842932,3547.8052996,4728.8895124,2.0569792,415.3871838,341.1073464,690.8545557,17.4472608,21.604309,2.6143056,64.2493134),(47128,'humerus',233,2,116,151.5276006,72.7946697,78.202526,1.8,72.9152696,78.4684038,0.3382746,10.360164,11.40474,3540.3866265,4965.0968549,2.7813154,435.3537968,341.7307511,683.0740569,17.295263,22.1707911,2.5920326,65.3904059),(47129,'humerus',233,2,117,150.5448613,72.6361302,78.55722,1.8,72.785996,78.8838836,0.3685492,10.2905704,11.6705054,3531.6088242,5141.4081656,3.2565123,440.547175,343.1888323,668.4140241,17.1962604,22.7477209,2.5708794,66.3930607),(47130,'humerus',233,2,118,152.8420437,72.5158352,78.972157,1.8,72.6791353,79.2855903,0.3958783,9.7905124,12.3506369,3555.3838214,5441.0534216,3.7879804,440.5484087,363.1458369,662.4490961,17.1196398,23.4667873,2.5424173,68.2025898),(47131,'humerus',233,2,119,155.4781903,72.4119564,79.3524592,1.8,72.6458006,79.7173598,0.4102362,10.1272411,13.1831451,3565.1733623,5749.6596731,4.1217826,436.1371774,352.0379675,647.5579005,17.1625133,24.3245696,2.5778441,69.6205578),(47132,'humerus',233,2,120,157.1107128,72.2821282,79.6762043,1.8,72.5451596,80.0478292,0.426846,10.1562613,14.6092511,3583.4174886,6073.5032786,4.4880659,415.7299523,352.8284057,614.2723997,0.236328,0.3342183,2.3561945,0.6684365),(47133,'humerus',233,2,121,157.1822697,72.2313908,80.0222736,1.8,72.5374476,80.5703013,0.4495474,10.1028562,16.2171882,3581.3540619,6458.0019104,4.947067,398.2195825,354.4892644,590.1671718,17.2274452,27.3375421,2.5344078,75.440706),(47134,'humerus',233,2,122,156.959543,72.1734647,80.3887396,1.8,72.6022535,81.0197682,0.4586518,10.1239205,17.6362906,3553.9901162,6917.8098079,5.1278269,392.2485728,351.0487966,575.9567789,17.1177915,28.8591229,2.5899377,79.0597641),(47135,'humerus',233,2,123,157.6475248,72.0799199,80.7281405,1.8,72.6137439,81.4642486,0.464324,10.2717865,18.6463204,3553.9977506,7456.1024358,5.2691423,399.869908,345.9960702,581.8958793,17.083494,29.9167353,2.6567468,81.8146051),(47136,'humerus',233,2,124,157.2738991,71.9408849,80.9708741,1.8,72.5342982,81.7409296,0.4622667,10.0237513,19.1848931,3537.3780239,7910.3333105,5.2135357,412.320948,352.8996207,585.7018541,17.0229807,30.5558487,2.6502705,83.4283536),(47137,'humerus',233,2,125,157.5204217,71.8225168,81.222275,1.8,72.4111789,81.9383845,0.4564272,9.8860901,19.6889411,3503.9065989,8393.623765,5.0998588,426.3115879,354.4279453,597.1383292,16.8916003,31.1244963,2.7357039,84.5121034),(47138,'humerus',233,2,126,159.8718133,71.6365905,81.4555324,1.8,72.2754848,82.2084706,0.4419411,10.1071377,20.1381949,3517.1649899,8815.6251746,4.8740358,437.7564727,347.9882334,604.3255347,16.7776718,31.7296194,2.7680018,85.7916336),(47139,'humerus',233,2,127,159.7732787,71.5254085,81.6259772,1.8,72.1148383,82.3321022,0.4349128,9.9193737,20.3762274,3514.2074081,9196.7748466,4.7271616,451.3482623,354.2771449,617.0927557,16.6746588,32.1701354,2.773364,87.3242872),(47140,'humerus',233,2,128,159.6017148,71.364192,81.8380934,1.8,71.9462299,82.5244456,0.4248305,10.2290132,20.8230298,3502.772478,9638.7639701,4.5188855,462.8896015,342.4350319,625.4092216,16.6348719,32.7499792,2.7878895,88.0738187),(47141,'humerus',233,2,129,159.9148185,71.1842227,81.9665618,1.8,71.7961626,82.7144352,0.4156187,10.0980231,21.3448971,3497.0841838,10086.0063572,4.3448568,472.525414,346.3137439,631.7901088,0.236328,0.5284455,2.677945,1.0026548),(47142,'humerus',233,2,130,161.2491478,71.0215289,82.1614249,1.8,71.6054433,82.8611039,0.4042778,10.6685138,21.7941665,3481.3422966,10508.5065019,4.1582953,482.1706077,326.3193321,637.4310281,16.3878314,34.0902628,2.8461518,91.1055352),(47143,'humerus',233,2,131,161.3261375,70.9094827,82.3551909,1.8,71.4041218,82.9989885,0.3992765,9.9473833,22.060591,3494.1852055,10969.5545834,4.0634833,497.2466315,351.2667719,652.8407378,16.3503719,34.7024151,2.8586158,92.5235032),(47144,'humerus',233,2,132,163.2738792,70.6455551,82.4988304,1.8,71.1016057,83.1205671,0.3884151,10.3555833,22.4874511,3530.7960393,11359.2436538,3.9030735,505.1370032,340.9557855,661.0254681,16.353058,35.3655989,2.8917518,94.2756895),(47145,'humerus',233,2,133,162.1846338,70.4649913,82.6932428,1.8,70.8588785,83.1938267,0.3756384,10.138229,22.7862044,3542.8166936,12178.5553681,3.6380984,534.4705576,349.4512388,688.998502,16.3521423,36.0847396,2.6281329,96.1425613),(47146,'humerus',233,2,134,162.7447848,70.3650713,82.9018053,1.8,70.7135324,83.3710247,0.3647106,9.8951901,23.0114864,3584.1678866,13157.2984584,3.4507288,571.7709068,362.2131418,726.6463973,16.3290725,37.025139,2.6351141,98.3100608),(47147,'humerus',233,2,135,164.386785,70.067096,83.0498453,1.8,70.4139487,83.4399593,0.3502873,9.9692632,31.6144709,3636.9760887,14037.9312896,3.2264761,444.03499,364.8189471,557.1385991,16.3998379,37.9518045,2.6556646,100.2006848),(47148,'humerus',233,2,136,167.3659917,69.7763123,83.2279062,1.8,70.1520553,83.6297021,0.3369828,10.0000003,23.7088473,3695.9242949,15043.5455552,3.0495066,634.5118928,369.5924197,790.0885077,16.4552188,39.0198927,2.7104539,102.7359932),(47149,'humerus',233,2,137,167.7077148,69.5264312,83.3053868,1.8,69.9782858,83.7424176,0.3214277,10.4368516,24.0580352,3716.535417,16278.5931186,2.7897163,676.6385107,356.0973719,830.8849661,16.5910115,40.0964423,2.7227699,106.4361462),(47150,'humerus',233,2,138,168.6935513,69.2074871,83.4809216,1.8,69.5904896,83.8808926,0.3081698,10.028888,24.605652,3716.8813953,17646.053174,2.5866372,717.1544643,370.6174982,868.2110985,16.5924156,41.2519308,2.7600224,110.3320798),(47151,'humerus',233,2,139,168.2413111,68.8949621,83.6886552,1.8,69.3252336,84.0573624,0.2940352,10.0195136,25.0883725,3754.9678938,19300.9068549,2.3552011,769.3168172,374.765488,918.6155857,4.2516308,7.2031596,0.7157436,28.9188742),(47152,'humerus',233,2,140,167.8954585,68.4097457,83.7683055,1.8,68.7965023,84.1963493,0.2789935,10.3856386,25.6709423,3798.3559952,20753.8017435,2.1221616,808.4550037,365.7315776,956.4121944,16.8457604,43.6446056,2.8164175,120.5109791),(47153,'humerus',233,2,141,170.1159727,68.0150814,83.8484261,1.8,68.487881,84.2475863,0.2646296,10.1530243,26.1340538,3853.2201716,22612.9942103,1.9395862,865.2692915,379.5145231,1012.5783741,17.1054467,44.7066119,2.8465916,125.3522247),(47154,'humerus',233,2,142,169.7180772,67.5291714,83.9023924,1.8,68.009192,84.2565589,0.2543916,9.9516104,26.7629357,3894.1207526,24440.3910183,1.7914042,913.2178652,391.3055858,1058.4414771,0.236328,0.3342183,2.3561945,0.6684365),(47155,'humerus',233,2,143,172.5568781,67.0612922,83.9713569,1.8,67.5775659,84.2957756,0.2381971,11.2539978,27.2635653,3980.0401437,26545.4235085,1.6011234,973.659287,353.6556704,1119.6302853,17.7840974,46.8442396,2.8709159,136.8442449),(47156,'humerus',233,2,144,173.2425244,66.6364907,84.129572,1.8,67.2877649,84.4749992,0.2150997,33.1060161,27.7705474,3944.054317,28688.7099569,1.31545,1033.0624581,119.1340664,779.6604071,0.236328,0.3342183,2.3561945,0.6684365),(47157,'humerus',233,2,145,170.9438865,66.2043249,84.4543192,1.8,66.903753,84.8276761,0.1828122,10.2268823,28.3197673,3618.9650129,30760.0611779,0.9416055,1086.1692762,353.8678652,1213.9577116,15.1673286,48.530172,3.0831228,149.3725105),(47158,'humerus',233,2,146,174.9350443,65.5676125,84.6078946,1.8,66.3942824,84.9541708,0.1660364,10.3637377,28.9189435,3395.8525715,34075.0043627,0.7964121,1178.2935436,327.6667809,1295.694074,0.236328,0.9744053,2.896614,1.9479668),(47159,'humerus',233,2,147,176.9032308,65.3778174,84.7627322,1.8,66.0922468,85.1127251,0.1528783,9.9330569,29.0780296,3239.3454139,36359.3844492,0.683739,1250.4074352,326.1176733,1361.6918014,17.1067872,50.4774701,2.9579703,138.9879922),(47160,'humerus',233,2,148,174.0450514,65.6133043,85.0143799,1.8,65.6098708,85.2520319,0.1383146,9.4905468,28.6325462,3145.8986848,37391.992091,0.5514111,1305.9261954,331.4770738,1414.7741397,16.7886369,51.3615291,3.0863494,136.5911216),(47161,'humerus',233,2,149,172.4491704,65.6070672,85.1579202,1.8,65.5098934,85.3284137,0.1263612,9.0868962,28.5757944,3065.9551562,38833.2710957,0.4564828,1358.9568359,337.4040023,1465.2527824,16.7144685,52.3054251,3.0873473,136.2569033),(47162,'humerus',233,2,150,168.4321859,65.6716767,85.3188123,1.8,65.1958142,85.3979655,0.1115733,19.106828,33.2656934,2967.2723939,39503.5293851,0.3480099,1187.5155843,155.2990582,1107.0931756,16.6131034,52.8202332,3.0744293,135.3926862),(47163,'humerus',233,2,151,168.9473345,65.6618852,85.4473521,1.8,64.7801707,85.446234,0.0987977,16.9768821,31.3310381,2934.2343845,41326.3626106,0.2739557,1319.0230896,172.83706,1242.0564013,16.1507019,53.7213624,3.0887784,136.9253398),(47164,'humerus',233,2,152,166.9539981,65.6744914,85.5134924,1.8,64.5576284,85.5260708,0.0900214,27.7997367,30.7219316,2890.2251543,42705.1677146,0.2248866,1390.0547766,103.9659181,1100.4707643,16.0472767,54.4868029,3.0721393,136.8442449),(47165,'humerus',233,2,153,164.449118,65.518375,85.5337697,1.8,63.9978017,85.5554552,0.0785127,17.6692339,32.0112204,2817.2527953,44142.2694707,0.1686037,1378.9624038,159.4439697,1306.0241955,15.7300973,56.4066965,3.0661061,138.2958035),(47166,'humerus',233,2,154,166.3068213,64.783921,85.5906943,1.8,63.4315919,85.5998451,0.062579,11.8276297,28.7880358,2838.8385947,47967.1633217,0.1084052,1666.2186891,240.0175403,1757.3718406,16.216767,57.1508343,3.0587948,140.2437703),(47167,'humerus',233,2,155,170.7131545,63.6801926,85.6869356,1.8,62.8189758,85.6855901,0.0433711,10.3895998,29.8302469,2917.3162553,52122.4787977,0.0534863,1747.302966,280.7919759,1835.446224,16.510214,57.8385924,3.0638806,143.4139246),(47168,'humerus',233,2,156,172.4358508,63.2428969,85.7782996,1.8,62.4227245,85.762663,0.0307139,10.140742,30.216109,2956.8539868,54199.1386166,0.0271025,1793.7166789,291.5816219,1881.69717,16.9582101,58.1674217,3.1090838,144.8318926),(47169,'humerus',233,2,157,173.8788018,63.3092359,85.8649058,1.8,62.2528118,85.8922902,0.0229338,9.9173742,30.1227696,3037.5691988,55234.6149896,0.0152396,1833.649948,306.2876457,1923.3288187,17.352341,58.4538091,3.0890096,145.4429863),(47170,'humerus',233,2,158,174.9837531,63.1669178,85.8982615,1.8,62.1901605,85.9265336,0.0103041,11.3391898,30.4478659,3140.9268528,54883.2503681,0.0030963,1802.5319239,276.9974665,1898.5260788,18.5680807,58.8760356,3.1094752,148.6803218),(47171,'humerus',233,2,159,176.6324554,63.4044481,85.9058256,1.8,62.260525,85.9641434,0.0026698,17.1814545,30.1892176,3258.2266267,54179.8234869,0.0002101,1794.6746499,189.6362515,1894.044479,19.8915321,59.1292467,3.101614,149.2676634),(47172,'humerus',233,2,160,174.6276611,63.7593821,85.8988194,1.8,62.6569223,85.979322,-0.0047091,38.2545037,30.2099274,3385.028986,51887.8465188,0.0006454,1717.5760109,88.4870709,1272.0549868,21.74817,59.1292467,0.0399787,151.3065636),(47173,'humerus',233,2,161,179.5191696,64.2648891,85.7602343,1.8,63.4762288,85.764137,-0.014979,16.3387746,29.7722116,3647.2763392,49582.8045439,0.0067125,1665.4054875,223.2282676,1780.9033526,22.8291599,59.1618249,0.0519532,159.6857723),(47174,'humerus',233,2,162,181.3241022,65.5488759,85.5035468,1.8,64.7180951,85.517465,-0.0203171,12.2016561,30.4075202,3975.1276413,45085.7527616,0.0124728,1482.7171832,325.7859092,1604.5223645,22.7920757,59.2028763,0.0639128,157.7140534),(47175,'humerus',233,2,163,186.2260024,66.9701136,85.1024865,1.8,66.4862274,85.1851727,-0.0244249,12.387386,28.0132268,4738.9063054,40483.2495137,0.0185125,1445.147671,382.559025,1612.8782847,24.4141514,55.5692515,0.0340294,155.9717056),(47176,'humerus',233,2,164,206.5656394,68.1537334,84.6526476,1.8,68.1592391,84.5162572,-0.0606245,12.2776357,25.9030374,6071.5179072,40154.8319969,0.1263776,1550.1978131,494.5184942,1772.3395939,24.3199555,52.0919665,0.1136632,148.2846855),(47177,'humerus',233,2,165,236.7669417,68.9668194,83.8226446,1.8,69.2155734,84.0866282,-0.0958426,12.6481788,25.5304563,7673.2391367,41567.0157747,0.3613737,1628.1344612,606.6675083,1925.0091413,24.1478448,50.0267917,0.0803951,137.4414249),(47178,'humerus',233,2,166,252.8606054,69.6968724,83.4868833,1.8,70.1299275,83.8481574,-0.0945141,12.4346657,24.7963528,8445.256941,42590.1133681,0.3753439,1717.5958781,679.1704072,2054.0408766,23.9162902,47.8224175,0.0593362,135.5647146),(47179,'humerus',233,2,167,260.6775514,70.0480146,83.2936121,1.8,70.7227985,83.6982038,-0.0845677,12.2034075,24.4645417,8632.3166079,43570.3001948,0.3099743,1780.9571361,707.3693672,2127.9324938,23.0816129,47.694363,0.1341887,135.1158108),(47180,'humerus',233,2,168,261.6501529,69.9394143,83.2850016,1.8,71.0997401,83.5737346,-0.0771501,12.1415813,24.4715094,7927.2168922,42877.1752847,0.2590486,1752.1263051,652.8982282,2063.9045424,22.1398126,46.5374179,0.0966368,132.4420647),(47181,'humerus',233,2,169,247.5317672,70.3323669,83.2757456,1.8,71.4501609,83.4679565,-0.0710977,11.8716051,23.622143,6647.0775095,38316.7298246,0.2081898,1622.0683232,559.9139653,1894.4657099,21.9347688,45.1033706,0.0944549,130.4703457),(47182,'humerus',233,2,170,221.7862516,71.1006651,83.3160168,1.8,71.8847034,83.4307354,-0.0549507,11.6674003,21.9604422,5215.3106312,32903.8800924,0.1115045,1498.3250237,446.9985176,1707.9200058,21.6532505,43.751328,0.151828,131.7261238),(47183,'humerus',233,2,171,173.4476157,71.8131729,83.338382,1.8,72.5902256,83.3842512,-0.0516969,11.3342138,21.7969514,3646.4597701,25206.6317373,0.0771897,1156.4292328,321.7214558,1303.8082798,20.8920187,42.0404862,2.9320698,126.9283073),(47184,'humerus',233,2,172,116.5302611,73.7455261,83.121551,1.8,74.6077951,83.3244738,-0.0763484,13.1060283,23.3251688,2265.7965453,15651.7354477,0.1129909,671.0234581,172.8820127,705.8334726,9.925776,12.1266435,0.9936041,36.0898091),(47185,'humerus',233,2,173,67.6330313,78.8971585,82.6759254,1.8,78.9449678,83.0907883,-0.3902464,10.2766565,25.6673174,1197.3268743,2452.8334447,1.6312703,95.5625165,116.5093795,136.2057414,3.781248,4.6611167,1.0390723,13.3015493),(47186,'humerus',233,2,174,47.4426178,79.6129834,82.6410913,1.8,80.2039753,82.9954819,-0.8668691,6.7698648,9.7760745,417.2798706,1007.3809659,4.594904,103.0455488,61.6378439,144.7093214,12.700294,18.7311372,1.056345,51.5449442),(47187,'humerus',233,2,175,29.2240804,79.8365396,83.1442376,1.8,80.1450114,83.1733506,-0.8795066,4.6998361,8.130098,114.159287,414.1880827,2.8910105,50.9450294,24.2900571,64.3779033,9.2750253,15.7331273,0.9994588,41.4135492),(47188,'humerus',233,2,176,2.6191883,79.6632892,84.3105672,1.8,79.7965073,84.1230489,-0.8784331,1.8598205,5.6609376,1.5350703,19.5759552,0.2586444,3.4580765,0.8253863,3.7284584,3.9171654,10.6871483,0.9582588,25.4145017),(47189,'humerus',233,2,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47190,'humerus',233,2,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47191,'humerus',233,2,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47192,'humerus',233,2,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47193,'humerus',233,2,181,12.1628756,85.6198566,81.2787661,1.8,85.6112508,81.3071145,-1.5535353,4.9096664,4.9936421,58.9528128,62.1000561,2.026542,12.4358243,12.0074986,23.5812969,9.925776,10.4626866,1.2490458,32.8385599),(47194,'humerus',233,2,182,36.9609565,85.5942962,81.3498791,1.8,85.5791738,81.3693974,-0.821205,7.4530453,7.5238883,437.387928,449.4914684,3.3004672,59.7419111,58.6858003,117.0902511,14.888664,15.3249187,0.2973651,49.506044),(47195,'humerus',233,2,183,60.9576612,85.5892848,81.3630232,1.8,85.5867937,81.373705,-0.8772046,9.1191303,9.255151,1140.1927358,1165.0513418,6.0072901,125.8813969,125.0330564,248.9401809,18.3919305,18.8233435,0.8921338,60.8596264),(47196,'humerus',233,2,184,140.0979968,74.0278549,82.561269,1.8,67.6944399,82.6324477,-0.0994685,14.2877288,30.6893967,4440.3580797,33331.0671593,0.2302601,1086.0776262,310.781241,1227.0501375,26.376176,27.9027216,2.9541635,103.3569254),(47197,'humerus',233,2,185,553.7693034,62.7557046,82.3244744,1.8,68.1114638,82.1222675,-0.0438462,16.5363886,34.4389034,26182.8672622,96782.0061253,0.1773225,2810.252261,1583.3485738,3569.7840988,29.0668822,29.2321592,2.2531129,95.7845909),(47198,'humerus',233,2,186,585.1635306,63.3400172,82.2506751,1.8,68.938167,82.0653123,-0.0417352,16.5784957,34.5686921,28219.4999944,108175.1793456,0.1697768,3129.2818079,1702.1749469,3944.1849215,29.068344,29.3094363,0.5611634,95.7845909),(47199,'humerus',233,2,187,600.6389753,63.927739,82.2418814,1.8,69.6247426,82.0670453,-0.0415523,17.0360213,34.6696793,29351.3221613,116857.65996,0.1727433,3370.6011196,1722.897712,4216.8442233,29.068344,29.3132472,0.6193123,95.7845909),(47200,'humerus',233,2,188,613.3592263,64.4048629,82.2283948,1.8,70.1978829,82.0264371,-0.0412583,16.3718079,34.6840205,30340.9437808,123932.468666,0.1739164,3573.1863513,1853.2433332,4446.4050072,29.068344,29.2684381,0.6709579,95.7845909),(47201,'humerus',233,2,189,619.3504564,64.5963877,82.2986889,1.8,70.4730489,82.0989794,-0.0318665,17.0410933,34.9119032,30760.7597786,127392.2685078,0.1047876,3648.9637286,1805.0930924,4530.0376412,29.068344,29.2684381,2.2417542,95.9803714),(47202,'humerus',233,2,190,622.6195971,64.6618404,82.3802722,1.8,70.5239737,82.2485485,-0.0216883,16.4701121,35.0889494,30992.5804252,129141.2913092,0.0488028,3680.3977727,1881.7467801,4563.0764669,29.1331136,57.273836,0.0536674,182.0013762),(47203,'humerus',233,2,191,624.2047817,64.6638663,82.4375884,1.8,70.5477307,82.3337658,-0.0145969,16.5178495,35.1070611,31055.6559869,129867.8979082,0.0221649,3699.1959388,1880.127072,4572.0384253,29.1331136,57.4063041,0.08656,180.3876277),(47204,'humerus',233,2,192,623.8995987,64.6313363,82.4787966,1.8,70.489118,82.3966446,-0.0100884,16.4643534,35.1306747,30993.423315,129670.5578042,0.0105822,3691.0921513,1882.4561479,4557.2349724,29.010744,57.4063041,0.08656,180.1918472),(47205,'radius.tif',233,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47206,'radius.tif',233,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47207,'radius.tif',233,3,3,25.0876795,100.0555741,112.3138105,1.8,100.0470399,112.1076144,-0.635324,5.3979557,7.7331953,131.9487073,256.9473135,1.4725174,33.226539,24.4441998,50.275225,10.611841,15.0475133,0.6528466,41.1870173),(47208,'radius.tif',233,3,4,73.0174511,99.8699123,112.5834689,1.8,99.7790173,112.5009398,-0.6564637,7.0762285,9.3755017,757.8691504,1503.4736316,4.5330424,160.3619382,107.1007171,240.9062135,14.1697393,19.1173488,0.5624979,53.7372502),(47209,'radius.tif',233,3,5,84.7869252,98.8809802,113.440365,1.8,99.082167,112.8569606,-0.5402327,8.1901997,10.9560049,1265.8991768,2253.8587435,3.7382709,205.7190337,154.5626751,320.654905,16.4302192,21.9353316,0.3775302,62.6012559),(47210,'radius.tif',233,3,6,83.1347853,98.2068386,113.4108514,1.8,98.6079466,112.9811272,-0.6956347,8.8098559,11.1125969,1409.1389976,2344.2191569,5.6908248,210.9515147,159.9502888,336.9635601,17.1423593,23.9604439,0.252096,65.7902992),(47211,'radius.tif',233,3,7,72.2229543,98.0105261,112.3705031,1.8,98.0109994,112.5831847,-0.7025502,8.6313457,10.6368924,1116.1686363,2150.295471,5.0258829,202.1544821,129.3157147,304.2125175,16.5637905,24.6419677,0.2449787,67.1965474),(47212,'radius.tif',233,3,8,71.472952,97.5149341,112.3048297,1.8,97.3485621,112.2853625,-0.8187867,8.526948,10.7157752,1039.7442073,2436.4166597,6.3535138,227.36728,121.9362672,321.3835376,15.4094833,24.4582107,0.3217506,65.4990557),(47213,'radius.tif',233,3,9,73.9555438,97.1648924,111.989503,1.8,96.7901172,111.9556398,-0.8798993,8.6977998,12.4515566,1039.6937247,2759.3051369,7.3208536,221.6032284,119.5352561,305.0950298,15.6612908,24.0299805,0.3587707,66.2021798),(47214,'radius.tif',233,3,10,78.9530871,96.7812313,111.6633194,1.8,96.4895876,111.4350972,-0.9192834,8.9214416,11.9129123,1170.4752432,3073.3032513,8.3202213,257.980851,131.1979947,356.0987821,15.4126989,24.7445752,0.3936982,68.4821587),(47215,'radius.tif',233,3,11,85.0547911,96.8474073,111.2193017,1.8,96.7073943,110.8497301,-0.8805448,10.1553858,13.0671987,1405.9311185,3542.2682589,8.4285537,271.0809203,138.4419207,378.347745,17.0950537,26.8318098,0.3756402,73.7306048),(47216,'radius.tif',233,3,12,95.4253845,97.087228,110.3223467,1.8,96.8633377,109.9308995,-0.7924364,12.6612299,14.0262072,2034.1952727,4074.2918571,8.0640488,290.4770913,160.6633238,429.2880444,21.1435379,28.1644878,0.4245614,83.6596458),(47217,'radius.tif',233,3,13,88.9800091,96.0234527,110.1348951,1.8,96.0769627,109.7625375,-1.1255412,10.8264296,13.7495974,1675.2938397,3285.6676584,12.0791509,238.9646455,154.74112,359.2510245,20.519248,27.3044019,0.6022873,84.3274361),(47218,'radius.tif',233,3,14,76.3997835,95.0565548,110.7883826,1.8,95.0326658,110.337962,-1.2149111,9.9418577,12.6309332,1017.9410626,2418.6272445,11.1875177,191.4844461,102.3894218,269.2798194,18.8840343,24.571648,0.9788255,77.9140158),(47219,'radius.tif',233,3,15,61.4285019,94.0988341,111.9598755,1.8,94.0446061,111.7215677,-1.2129528,8.7799174,11.2017522,594.2996574,1410.0858187,8.9820887,125.8808262,67.6885247,177.7176643,17.7021655,22.2625131,0.2717922,69.6324971),(47220,'radius.tif',233,3,16,52.4678753,93.5891265,112.4214671,1.8,93.3084184,112.4542167,-1.2213569,7.7060662,10.5821147,420.2434205,1018.0177955,7.7196158,96.2017352,54.5341048,135.2034656,16.6320932,21.2484296,0.2851177,64.4547185),(47221,'radius.tif',233,3,17,50.6518024,93.6454013,112.1766183,1.8,93.2662482,112.3813188,-1.214835,8.5120378,10.8380871,422.8063473,903.9239234,7.4167206,83.4025333,49.671578,121.9112871,16.0239017,22.0028423,0.2256012,64.7106283),(47222,'radius.tif',233,3,18,47.8422807,93.9311224,111.7958989,1.8,93.8696024,111.6334045,-1.2075048,9.4838803,11.3024184,454.0236876,844.1603548,6.9668277,74.6884715,47.8731988,114.3782914,0.3515621,0.7861167,2.0344439,1.6974918),(47223,'radius.tif',233,3,19,52.8513971,94.3981914,110.8245914,1.8,94.4052281,110.2907325,-1.329599,10.2044702,12.146707,677.1856815,961.03396,8.3059783,79.1188886,66.3616695,131.8203723,19.4647314,25.2660391,2.7714218,108.4335342),(47224,'radius.tif',233,3,20,22.7706312,113.1870197,111.1716618,1.8,114.4117598,111.0468489,-0.5528281,10.1462992,11.0164675,409.2774595,528.1191255,1.0464092,47.9390626,40.33761,84.6143134,16.7624102,18.0704267,0.6473921,91.4086468),(47225,'radius.tif',233,3,21,108.4089822,116.5547577,111.6361604,1.8,116.2799707,111.3470229,0.3437797,9.7926565,10.2687964,2008.5453964,2451.2468015,2.0525685,238.7082863,205.1073063,429.0060987,18.0121449,20.0421211,2.7643436,62.6365897),(47226,'radius.tif',233,3,22,82.0924975,116.3387798,111.5017708,1.8,116.1830988,111.326359,0.3347015,8.5994409,10.0977763,1525.0923382,1759.9781104,1.4763495,174.293633,177.3478479,324.189191,17.4068786,19.7188399,2.9441971,60.6125206),(47227,'radius.tif',233,3,23,60.1371496,115.9302982,110.87471,1.8,116.0967308,110.9265847,0.1412113,8.1589911,9.0658133,941.898796,1280.6755848,0.1985372,141.2642795,115.4430469,238.9380227,15.8202927,18.0977647,3.00519,55.555379),(47228,'radius.tif',233,3,24,51.9209074,116.1148459,110.8118962,1.8,116.2202093,111.0390166,0.1474829,7.6475763,8.6367489,765.4686365,1080.3105092,0.1868629,125.0830054,100.0929714,210.6537654,14.6662902,17.4829236,2.8771043,53.0694598),(47229,'radius.tif',233,3,25,48.5229569,116.5706373,110.745726,1.8,116.526636,111.1017046,0.0954559,7.3314303,8.0697124,664.8683606,977.5134368,0.0734653,121.1336145,90.6874006,201.9887704,13.698363,16.5831492,2.7728968,49.4685359),(47230,'radius.tif',233,3,26,47.9192472,116.7759492,110.8519367,1.8,116.7136892,111.1921988,0.1296769,6.9615792,7.740499,624.642321,920.4639637,0.1335514,118.9153257,89.7271016,198.2815794,13.0077962,15.741974,2.7279034,47.2738603),(47231,'radius.tif',233,3,27,47.3332529,116.9483495,110.9499104,1.8,116.938174,111.2637622,0.1810261,7.4742231,7.3063512,606.4593632,865.86508,0.2557104,118.5085494,81.1401211,181.7865671,13.0077962,14.9237991,2.8794728,45.6616718),(47232,'radius.tif',233,3,28,47.1001061,117.005243,110.9756479,1.8,117.0466833,111.2433568,0.203639,6.8461556,7.1155894,624.0385247,832.7793638,0.3210563,117.0358934,91.1516709,197.3589754,13.0099634,14.4952751,0.2449787,45.0438509),(47233,'radius.tif',233,3,29,46.2120135,117.0283824,110.9156685,1.8,117.001203,111.0617532,0.2265264,7.4906526,7.0902086,676.5794307,794.9144206,0.3885081,112.1143907,90.3231624,170.419638,13.3420958,14.315096,0.4306925,45.164488),(47234,'radius.tif',233,3,30,46.6299923,117.0678885,110.9855681,1.8,116.9562585,111.4281438,0.9551792,7.3270521,7.657075,773.3181307,818.0918333,5.1801036,106.8412976,105.5428737,191.409813,13.7109204,15.100808,1.7818897,46.8619797),(47235,'radius.tif',233,3,31,49.9350211,117.153603,111.1639686,1.8,117.0727703,112.03111,1.4729665,7.1274859,8.8062095,821.4865211,1019.4169698,8.2431054,115.7611534,115.2561412,208.7553714,13.3593583,16.0683477,1.746736,48.6801086),(47236,'radius.tif',233,3,32,52.5061151,117.2744094,111.1930465,1.8,117.2607074,112.2345585,1.4710551,7.2578051,9.0809269,862.0025164,1210.866688,8.6642497,133.3417498,118.7690367,228.1238536,13.6602557,16.8236313,1.3815973,50.6688439),(47237,'radius.tif',233,3,33,55.193614,117.6744958,110.7900499,1.8,117.7576734,111.7687701,1.4714848,7.0286875,9.1621761,903.1998563,1335.8855047,9.1085064,145.8043905,128.5019233,243.7462338,13.3593583,17.3124237,1.3455195,51.2013615),(47238,'radius.tif',233,3,34,56.749349,117.935938,110.2481033,1.8,118.1085992,111.2133896,1.414079,6.9087777,9.5459725,919.7772084,1340.4915067,9.2278233,140.4248239,133.131684,234.5550268,13.3593583,17.4546226,1.4089589,51.2866648),(47239,'radius.tif',233,3,35,58.4836989,118.0177499,109.5322234,1.8,118.1571213,110.3120224,1.3725144,6.9018434,9.3424716,927.1548245,1324.639193,9.3690576,141.7868047,134.3343761,240.3689837,13.6726019,17.2408845,1.2812927,51.0807245),(47240,'radius.tif',233,3,36,59.4360988,118.1306145,108.8368101,1.8,118.3052368,109.4953848,1.3540097,6.7884678,9.1797809,927.7272833,1290.0795064,9.4477162,140.5348909,136.6622496,234.5895137,13.5639382,17.3943301,1.3258177,50.6688439),(47241,'radius.tif',233,3,37,60.2566256,118.2118007,108.2150243,1.8,118.4275169,108.6308921,1.3453013,6.7254707,8.9541822,916.0491279,1257.9575742,9.5407129,140.4882716,136.205951,234.3382793,13.5652004,17.3124237,1.3455195,49.6391425),(47242,'radius.tif',233,3,38,60.032168,118.2566933,107.225591,1.8,118.4187627,107.3643403,1.211624,6.583919,8.2658341,897.7465841,1101.5040475,8.7691803,133.2598788,136.3544387,234.7117246,13.3593583,16.1335963,1.3734008,47.0325863),(47243,'radius.tif',233,3,39,61.3574904,118.2218457,106.3053753,1.8,118.320079,106.348486,0.9937043,6.6405023,7.4400875,895.0886124,1005.0982474,7.1822257,135.0922614,134.7923057,244.2378486,13.3593583,14.9692797,1.735945,45.5410348),(47244,'radius.tif',233,3,40,61.1211976,118.2204199,105.5502708,1.8,118.3414146,105.5051806,0.8594129,6.6193784,7.1203331,867.9426554,929.6297795,5.8446609,130.5598714,131.1214734,251.5629673,13.3027305,14.2761903,1.3975507,44.5466671),(47245,'radius.tif',233,3,41,59.9630292,118.2177767,104.6697201,1.8,118.2557953,104.6083625,1.106709,7.106446,7.0309989,837.5886788,852.457737,7.9915539,121.2427634,117.8632293,220.1590032,13.0048818,14.3409745,1.3734008,43.6376027),(47246,'radius.tif',233,3,42,60.624005,118.0884624,103.9727236,1.8,118.086931,103.9545312,-1.0377652,6.841841,7.1234538,794.9572262,833.7314475,7.4950204,117.0403389,116.1905435,226.8538341,12.9267797,14.0360905,1.1856388,43.0551156),(47247,'radius.tif',233,3,43,61.4614233,117.8847743,103.281511,1.8,117.9276162,103.2651446,-1.0434724,6.4459032,7.291263,749.0338563,833.9718074,7.6495607,114.3796091,116.2030871,217.0894501,12.6562342,14.2241506,0.8728935,43.1757526),(47248,'radius.tif',233,3,44,61.0975645,117.6191913,102.6086139,1.8,117.7269722,102.4579409,-1.0729837,6.3756124,7.5795278,713.6420065,822.2403482,7.8611094,108.4817384,111.9330923,202.62981,11.9531101,14.4952751,0.8884798,42.8845091),(47249,'radius.tif',233,3,45,60.5945293,117.3508425,101.9399085,1.8,117.4634714,101.7573023,-1.1202019,6.6576812,7.7264796,686.082478,804.9850377,8.1836867,104.1852278,103.0512663,192.5733445,11.9531101,14.5548391,0.9224643,42.8845091),(47250,'radius.tif',233,3,46,60.4206336,117.0538412,101.3110454,1.8,117.1942244,101.1094013,-1.1785108,6.3595793,7.9039247,664.4288033,783.3731074,8.5983163,99.1119141,104.476848,182.7296369,11.601548,14.6310652,0.9561334,42.3873252),(47251,'radius.tif',233,3,47,60.894268,116.756586,100.6877878,1.8,116.8798998,100.4856762,-1.2151357,6.4594532,7.8119448,653.8272566,769.0878151,8.9184731,98.4502371,101.220217,181.8669445,11.601548,14.4311837,0.9760371,42.1813849),(47252,'radius.tif',233,3,48,60.7973389,116.4466098,100.1251011,1.8,116.5205467,99.9416413,-1.2663292,5.9821696,7.5656731,644.7331279,747.0646769,9.2222376,98.7439805,107.7758021,182.7965067,11.601548,14.2371783,0.9964915,41.4782608),(47253,'radius.tif',233,3,49,60.4570382,116.1752096,99.3970811,1.8,116.2401775,99.2399247,-1.3015963,5.8434399,7.3919735,629.0813693,719.5588272,9.3634357,97.3432637,107.6560007,181.6050054,11.601548,13.9433254,0.9827937,41.4782608),(47254,'radius.tif',233,3,50,60.2265132,115.8645585,98.8775532,1.8,115.9559477,98.7559549,-1.314625,5.7755811,7.2982917,611.4949885,699.2434786,9.393321,95.8091982,105.8759238,177.3997362,11.601548,13.8677753,1.0390723,40.7751367),(47255,'radius.tif',233,3,51,59.9256883,115.5463671,98.3660459,1.8,115.6424763,98.2290289,-1.322472,5.7627072,7.0393814,596.5881144,681.6285204,9.3842844,96.830741,103.5256684,180.1934943,11.601548,13.4561498,0.99004,40.2779529),(47256,'radius.tif',233,3,52,60.0066249,115.2275516,97.8837751,1.8,115.3303428,97.8156027,-1.3121582,6.1613799,6.9132967,588.4314573,665.3615694,9.3468785,96.2437458,95.503193,180.1445415,11.2499859,13.3639833,0.9536049,39.9867093),(47257,'radius.tif',233,3,53,59.876175,114.9244386,97.3919957,1.8,115.0081115,97.3092238,-1.2001702,6.2125223,7.4670144,580.4413774,650.0552529,8.6701877,87.0569175,93.4308719,164.7179673,11.2499859,13.1636403,0.9753865,38.9923417),(47258,'radius.tif',233,3,54,60.0446774,114.6028112,96.9203376,1.8,114.6808771,96.8316047,-1.0384375,6.3742451,7.0366512,579.4651969,640.0798909,7.4292834,90.9637092,90.9072658,168.5232606,11.2499859,13.2897899,0.9167136,39.1982819),(47259,'radius.tif',233,3,55,60.3205584,114.2706298,96.4520589,1.8,114.3291009,96.3292955,-0.8933504,6.5136213,6.6750058,577.4638167,634.7096322,6.103591,95.0875033,88.6548031,170.2636335,11.2499859,13.0788647,0.9380475,38.9923417),(47260,'radius.tif',233,3,56,60.7166271,113.9620449,95.9800143,1.8,114.0244425,95.9161993,-0.7942486,6.5099423,6.5173919,578.4077712,636.9615038,5.1492762,97.7325763,88.8499081,173.8328396,11.601548,13.0125462,0.9002748,38.9923417),(47261,'radius.tif',233,3,57,60.7985374,113.7333172,95.3189376,1.8,113.8504616,95.2146528,-0.6919456,6.6494928,6.9608391,574.0939706,636.3966579,4.1250853,91.425279,86.3365058,173.0609459,11.2499859,13.0788647,0.9380475,38.9923417),(47262,'radius.tif',233,3,58,60.5723569,113.429019,94.893534,1.8,113.5019396,94.8199659,-0.6234896,6.8406228,7.1152634,573.9005406,635.1826994,3.4415823,89.2704403,83.8959491,169.9247841,11.2499859,13.0125462,0.9002748,38.7010981),(47263,'radius.tif',233,3,59,60.6204844,113.1237966,94.4396517,1.8,113.1831236,94.3868073,-0.5958114,6.781155,6.9119377,573.7468356,633.2302561,3.181803,91.6139987,84.6090139,173.9753221,11.601548,12.7970522,0.9218008,38.5804611),(47264,'radius.tif',233,3,60,60.8171892,112.816901,94.008749,1.8,112.856486,93.9443041,-0.5271272,6.7017479,6.985052,573.565307,641.408506,2.5650855,91.8258743,85.584435,173.1964051,11.601548,12.9649682,0.7086263,38.9923417),(47265,'radius.tif',233,3,61,61.0303359,112.5118293,93.5729078,1.8,112.5267411,93.5075276,-0.4229574,6.8542329,6.5113198,577.4407808,647.8074139,1.7136974,99.4894179,84.245865,162.9059219,11.601548,12.9363374,0.7469556,38.9923417),(47266,'radius.tif',233,3,62,61.0915346,112.1960374,93.1599281,1.8,112.1655803,93.1420261,-0.3311944,6.7961662,6.7060768,578.7394952,651.6798936,1.0766092,97.1775166,85.1567598,167.352036,11.601548,12.8740855,0.610726,38.5804611),(47267,'radius.tif',233,3,63,61.4050936,111.8943629,92.7615019,1.8,111.9248073,92.7237513,-0.2413465,6.6749446,6.116512,577.5714482,661.8703317,0.5846373,108.2104195,86.5282758,180.1930409,11.601548,12.7970522,0.6489956,38.8717046),(47268,'radius.tif',233,3,64,61.6022852,111.5905129,92.3901857,1.8,111.5849353,92.3646276,-0.176298,6.4352156,6.1600551,576.4121203,679.5449076,0.3158175,110.3147458,89.5715321,166.602447,11.2499859,12.8740855,0.610726,38.5804611),(47269,'radius.tif',233,3,65,61.2829209,111.3439366,91.8863568,1.8,111.367949,91.8583879,-0.1314969,6.7382184,6.2265748,577.5612496,685.3870007,0.1755959,110.074483,85.7142371,182.6715734,11.601548,12.8740855,0.610726,39.1629482),(47270,'radius.tif',233,3,66,61.1637445,111.0482195,91.5226018,1.8,111.08478,91.5457513,-0.1090272,6.6821984,6.2283874,578.9691814,691.8135223,0.1206956,111.0742608,86.6435185,185.3599316,11.601548,12.8740855,0.610726,39.3688885),(47271,'radius.tif',233,3,67,61.0998117,110.7345033,91.1547168,1.8,110.7387048,91.1712037,-0.0939688,6.6831654,7.0171297,583.5668329,701.1423611,0.0896555,99.9186838,87.3189275,181.3076748,11.601548,12.9267797,0.390607,39.3688885),(47272,'radius.tif',233,3,68,61.1450928,110.4284724,90.81484,1.8,110.4317502,90.8622874,-0.0965925,7.1547388,6.441123,587.0001908,710.0348003,0.0947863,110.2346277,82.0435525,173.9832044,11.601548,13.0077962,0.3302974,39.660132),(47273,'radius.tif',233,3,69,61.0433322,110.1465431,90.4751975,1.8,110.1323991,90.4656038,-0.095058,6.6829616,6.4043723,588.4761085,715.920567,0.091655,111.78622,88.0561855,180.4913901,11.601548,13.1260299,0.3556359,39.4541917),(47274,'radius.tif',233,3,70,60.9256539,109.8433287,90.142602,1.8,109.8227702,90.1667656,-0.0944304,6.6588791,6.9574781,595.3967124,719.4673558,0.0902779,103.4092164,89.4139551,179.4510233,11.601548,13.0646819,0.4154921,39.4541917),(47275,'radius.tif',233,3,71,61.3657676,109.5460713,89.8269438,1.8,109.5551086,89.8249435,-0.1046273,6.6271297,6.599549,604.7841962,728.2014485,0.1115525,110.3410925,91.2588438,189.046977,11.79442,13.1354426,0.2709469,39.7454353),(47276,'radius.tif',233,3,72,61.7026975,109.2473794,89.5298059,1.8,109.2053895,89.5588523,-0.1202098,6.629686,6.5668181,613.5224238,735.6117972,0.1478904,112.0195176,92.5417021,188.1270489,11.747092,13.1354426,0.2709469,39.7454353),(47277,'radius.tif',233,3,73,61.0534071,109.0208477,89.1006719,1.8,109.0143011,89.1781843,-0.1721387,6.8883187,6.6919587,613.7358107,728.750778,0.2985532,108.8994727,89.0980562,165.0783774,11.8011904,13.1260299,0.1343214,40.5338627),(47278,'radius.tif',233,3,74,60.3741166,108.7464799,88.8324498,1.8,108.7537472,88.8952753,-0.1968588,6.8452675,6.7598557,614.3184005,720.3582248,0.3849388,106.5641425,89.7435205,171.9522177,11.8162866,13.1354426,0.2709469,39.7454353),(47279,'radius.tif',233,3,75,59.7946392,108.4818902,88.5575402,1.8,108.4570998,88.6071138,-0.2408831,6.8933249,6.6187058,615.94761,713.2131241,0.5671624,107.757187,89.3542119,165.6165619,11.8619875,13.1354426,0.2709469,39.7454353),(47280,'radius.tif',233,3,76,59.6912681,108.2260341,88.2886369,1.8,108.1951682,88.3317071,-0.2680089,6.7832949,7.005528,618.8614751,712.5316337,0.6976455,101.709911,91.2331666,169.9722314,11.6838201,13.0457476,0.2449787,39.539495),(47281,'radius.tif',233,3,77,59.4101062,107.9732235,88.0374598,1.8,107.9675147,88.1145741,-0.3120689,6.862198,6.7708391,619.1144237,712.1443641,0.9333956,105.1781543,90.221008,181.7232512,11.8436732,13.0835888,0.1076899,40.3279224),(47282,'radius.tif',233,3,78,59.4755746,107.7291215,87.8022733,1.8,107.6820959,87.928935,-0.3364449,6.8028288,7.073615,624.6272991,716.100497,1.0803545,101.2354362,91.8187593,177.9035692,11.6838201,13.1354426,0.2709469,39.7454353),(47283,'radius.tif',233,3,79,59.9237033,107.4997987,87.5652691,1.8,107.4282823,87.6634296,-0.355614,6.6640426,6.5042549,633.0156027,726.8984191,1.2106545,111.7573698,94.9897295,185.4220715,11.8854812,13.1354426,0.2709469,40.2426191),(47284,'radius.tif',233,3,80,60.2491724,107.2674221,87.3409808,1.8,107.1872224,87.3829905,-0.3547362,6.8250584,7.1036713,640.1190009,737.3636111,1.2114818,103.8003568,93.7895279,162.9466792,11.86235,13.1777166,0.1607627,40.5338627),(47285,'radius.tif',233,3,81,60.0439284,107.1000726,87.0066796,1.8,107.0313952,87.0584849,-0.3616474,6.8344987,6.8880882,640.3404323,739.0279512,1.2527707,107.2907219,93.6923768,190.3433431,11.932412,13.1354426,0.2709469,40.2426191),(47286,'radius.tif',233,3,82,59.3993197,106.8607273,86.8131903,1.8,106.7990806,86.8808794,-0.3455594,6.8541386,7.2053731,638.609665,734.4232037,1.1358468,101.9271584,93.1713964,178.5899098,11.932412,13.2338719,0.2965458,40.2426191),(47287,'radius.tif',233,3,83,59.5259867,106.6127553,86.6291207,1.8,106.533835,86.6875897,-0.3926086,6.8217389,6.8396757,645.0393366,736.1944832,1.4522615,107.6358757,94.556439,183.31908,11.932412,13.2385408,0.1869793,40.5338627),(47288,'radius.tif',233,3,84,59.9223924,106.3819641,86.4592248,1.8,106.304528,86.5102641,-0.4072723,6.8898687,6.81657,648.4414364,744.7019355,1.5669721,109.2487764,94.115209,179.5420702,11.6838201,13.2385408,0.1869793,40.8251062),(47289,'radius.tif',233,3,85,60.1376365,106.1447674,86.2939075,1.8,106.0615754,86.390706,-0.449353,6.9136213,7.1551927,653.0451761,754.3799979,1.8912129,105.4311228,94.4577587,190.3644266,11.6838201,13.2338719,0.2965458,40.2426191),(47290,'radius.tif',233,3,86,59.9949395,105.9205044,86.1218171,1.8,105.8326213,86.1744428,-0.4547308,7.4459167,6.6500021,655.0816622,758.1888039,1.9289833,114.0133174,87.9786449,177.8544832,11.6838201,13.3870844,0.2386093,40.8251062),(47291,'radius.tif',233,3,87,60.1232919,105.6950112,85.9566598,1.8,105.5804788,85.9691191,-0.4768484,6.8398227,6.8132483,659.6654824,769.1315589,2.1109685,112.8876458,96.4448222,174.7797063,11.6838201,13.308377,0.2129383,40.7398029),(47292,'radius.tif',233,3,88,60.1962884,105.4844049,85.8239765,1.8,105.3864121,85.9158208,-0.4730256,6.6321936,6.9274068,662.6176132,776.9153507,2.082337,112.1509648,99.9092693,197.0777306,11.6838201,13.3408422,0.3217506,40.2426191),(47293,'radius.tif',233,3,89,60.4703342,105.3472266,85.5892615,1.8,105.2486856,85.6544649,-0.4901499,7.4228389,7.2548357,665.8286282,784.8258729,2.2335047,108.1796899,89.6999976,191.8918857,11.6838201,13.3639833,0.4636476,40.7398029),(47294,'radius.tif',233,3,90,59.6297324,105.1407915,85.4656315,1.8,105.0030585,85.5677092,-0.4854129,6.9351966,7.069201,662.5561597,778.5757264,2.1634749,110.1363121,95.5353106,191.4462641,11.6838201,13.3408422,0.3217506,40.7398029),(47295,'radius.tif',233,3,91,59.1627646,104.9417695,85.3592746,1.8,104.8310809,85.4340618,-0.4768495,6.9211389,7.4142967,662.5543167,782.1451476,2.0772525,105.4914821,95.7290884,182.2251746,11.6838201,13.4745075,0.2639637,41.0310465),(47296,'radius.tif',233,3,92,59.1916411,104.7339184,85.2482247,1.8,104.533948,85.3257285,-0.4914774,7.0196818,7.1804737,669.7087128,787.1092003,2.1971634,109.6180046,95.4044261,183.633554,11.932412,13.3870844,0.2386093,40.7398029),(47297,'radius.tif',233,3,93,58.8970335,104.5551887,85.1588809,1.8,104.4054655,85.2050164,-0.4972686,7.0417994,7.5448862,672.3778758,792.8346289,2.2337139,105.0823843,95.4838162,188.8241899,11.932412,13.4745075,0.2639637,41.2369868),(47298,'radius.tif',233,3,94,59.0366219,104.353131,85.0440062,1.8,104.1903954,85.0898051,-0.4693351,7.01263,7.2085149,680.8437145,803.3917291,2.0128471,111.4503798,97.088213,192.9110738,11.932412,13.5795823,0.3708913,41.2369868),(47299,'radius.tif',233,3,95,58.9819401,104.1461695,84.9488133,1.8,103.9836748,84.9638251,-0.4519086,6.8656171,6.761548,688.0720974,816.1668098,1.8745675,120.7070936,100.2199926,199.3996852,12.1090449,13.6522009,0.6022873,41.6488673),(47300,'radius.tif',233,3,96,59.0201799,103.9655909,84.8702849,1.8,103.8274129,84.9539893,-0.4471125,6.8449258,6.8805354,694.7346794,828.0690766,1.8388561,120.3495112,101.496306,201.9756914,12.1090449,13.7109204,0.3947911,41.6488673),(47301,'radius.tif',233,3,97,58.4680434,103.8492411,84.6679035,1.8,103.6983264,84.7289529,-0.4480649,6.9168364,7.2286655,697.882957,831.5702632,1.8288955,115.0378676,100.8962655,199.1631387,12.1810039,13.7514254,0.5667292,41.9401109),(47302,'radius.tif',233,3,98,57.7858316,103.6793689,84.5865684,1.8,103.5424126,84.682142,-0.4382947,6.9542377,7.1711489,695.3944262,835.9805697,1.7346533,116.5755421,99.9957809,199.0993087,12.1810039,13.7514254,0.5667292,41.9401109),(47303,'radius.tif',233,3,99,56.9528703,103.4892367,84.5109672,1.8,103.2705222,84.5848321,-0.4293695,6.9738817,7.1287623,691.6512129,839.3386678,1.6450241,117.739746,99.177365,174.8754478,12.388251,13.8677753,0.5317241,42.3519915),(47304,'radius.tif',233,3,100,55.8661254,103.3169708,84.4402649,1.8,103.152196,84.5185617,-0.416607,7.0729298,7.2608721,688.3411379,834.9333027,1.5246769,114.9907734,97.3205101,170.4884071,12.4212227,13.9433254,0.5880026,42.643235),(47305,'radius.tif',233,3,101,56.0276989,103.1511259,84.3691772,1.8,103.0525194,84.4054834,-0.43147,7.1008917,7.0351442,691.5720488,844.2733636,1.6331768,120.0079687,97.3922828,201.2221733,12.3604345,14.0008239,0.4973427,42.3519915),(47306,'radius.tif',233,3,102,55.8618182,102.9881533,84.3055691,1.8,102.8715542,84.4173025,-0.4278002,7.7849358,7.1428255,700.0031656,845.9807479,1.6024648,118.4378295,89.9176543,198.4463514,12.1810039,13.8677753,0.5317241,42.1460512),(47307,'radius.tif',233,3,103,55.5690084,102.8182889,84.2443843,1.8,102.7078348,84.4066177,-0.4102748,7.2457844,8.947134,707.5743409,854.5032317,1.4734154,95.5058046,97.6532422,155.8605595,12.4295959,14.0492927,0.5532943,42.8491753),(47308,'radius.tif',233,3,104,54.7602793,102.7042044,84.1884126,1.8,102.6674478,84.297424,-0.3851515,6.7752208,9.1491112,702.5820363,861.0980699,1.2882368,94.118221,103.6987658,145.7956625,12.4295959,14.0492927,0.5532943,42.3519915),(47309,'radius.tif',233,3,105,53.8503889,102.613267,84.1074254,1.8,102.4592995,84.3367575,-0.4088169,7.0383812,9.3674895,694.305871,862.9388105,1.4182877,92.1206057,98.6456764,141.2615219,0.3515621,0.4971838,2.3561945,0.9943677),(47310,'radius.tif',233,3,106,52.8345805,102.5099183,84.0509644,1.8,102.3935406,84.1768683,-0.3905519,7.2584974,9.0141923,688.8416063,849.6503049,1.2762334,94.2569539,94.9014051,152.6943462,12.4295959,14.1719197,0.4081491,43.1404189),(47311,'radius.tif',233,3,107,52.6800108,102.3704431,84.031491,1.8,102.2169895,84.1587458,-0.3847406,7.2066435,8.8023136,691.7210376,856.5380568,1.2367875,97.3082873,95.9838007,147.9640123,12.5748278,14.3625042,0.375961,43.1404189),(47312,'radius.tif',233,3,108,52.6202728,102.239087,84.0184187,1.8,101.9885213,84.1392949,-0.3877119,7.2628748,8.6828828,695.0200756,865.9868654,1.2535711,99.7349478,95.6948997,159.0134851,12.4295959,14.3625042,0.375961,43.1404189),(47313,'radius.tif',233,3,109,52.5981004,102.1562675,83.9917552,1.8,101.9504804,84.073256,-0.3858361,7.1897225,8.6178262,700.5954954,873.7682763,1.2415538,101.3907977,97.4440247,159.0411355,12.6781878,14.4952751,0.3985224,43.3463591),(47314,'radius.tif',233,3,110,52.8779889,102.0685014,83.9703339,1.8,101.8343251,84.0346732,-0.3852792,7.2436711,8.5449944,702.3405453,875.8253967,1.2447395,102.4957251,96.9591982,183.9767471,12.4295959,14.6352883,0.4206633,43.4316624),(47315,'radius.tif',233,3,111,51.8158883,101.9692698,83.9514722,1.8,101.6820569,84.0612201,-0.3726679,7.3210581,8.1259826,698.5141935,876.8816371,1.144871,107.910843,95.4116444,190.9371028,12.4295959,14.6816627,0.2914568,43.4316624),(47316,'radius.tif',233,3,112,52.523044,101.9069713,83.967552,1.8,101.7084901,84.1242193,-0.383876,7.1151298,8.2030006,708.5388357,884.1526585,1.2278411,107.7840542,99.5819977,194.089901,12.4295959,14.6900786,0.3671738,43.7229059),(47317,'radius.tif',233,3,113,52.6581006,101.852516,83.8700623,1.8,101.4897018,83.9507056,-0.3773089,7.3020464,8.5224465,711.5087846,894.3268604,1.1912427,104.9378084,97.4396416,182.4288999,12.4295959,14.8365854,0.2392316,44.2200898),(47318,'radius.tif',233,3,114,52.4415831,101.7574458,83.8682801,1.8,101.411006,83.9547162,-0.3906354,6.9914097,8.3877747,708.7649152,890.1910648,1.267254,106.1295866,101.3765384,183.1778843,12.4295959,16.0491065,0.5028432,48.1122572),(47319,'radius.tif',233,3,115,51.4106436,101.6429019,83.8749337,1.8,101.2715451,84.0056741,-0.3995708,7.3321203,8.4376899,709.7147368,890.8548575,1.2967383,105.5804211,96.7952937,177.4540457,12.4295959,15.2636247,0.5048614,47.2031928),(47320,'radius.tif',233,3,116,51.183377,101.5635627,83.9273225,1.8,101.1352691,84.061262,-0.4271875,7.2307322,8.5608786,714.4208801,901.6642613,1.4643138,105.3238001,98.8033934,174.6517316,12.4295959,15.3282671,0.638914,48.1975605),(47321,'radius.tif',233,3,117,50.9240504,101.4683484,83.9900942,1.8,101.0237533,84.162577,-0.4324319,7.1084479,8.4625581,705.9213627,908.4487471,1.4906157,107.3491886,99.3073837,176.0273343,12.4295959,16.2860911,0.5700405,49.8950522),(47322,'radius.tif',233,3,118,49.8864442,101.4565677,83.9923168,1.8,101.0447956,84.1015911,-0.3936769,7.4966457,7.7999361,698.6405863,895.6779002,1.2233712,114.8314413,93.1937581,180.8648379,12.4295959,15.7890118,0.2017623,49.6537782),(47323,'radius.tif',233,3,119,49.1940077,101.3991989,84.1040685,1.8,100.9949174,84.2022637,-0.367348,7.3418949,7.9093476,693.2796687,896.241973,1.0575292,113.3142725,94.4278935,181.0092775,12.4295959,16.0683477,0.1759396,49.5684749),(47324,'radius.tif',233,3,120,48.5334064,101.3792843,84.1804928,1.8,100.9382419,84.2685579,-0.3574475,6.5173178,8.0101011,689.0335176,905.5025006,0.9902347,113.0450771,105.7234794,185.1961088,12.4295959,16.1335963,0.1973956,50.8540861),(47325,'radius.tif',233,3,121,47.5714933,101.4318696,84.1765608,1.8,100.9785826,84.1564024,-0.363777,7.4739127,8.2510796,680.26212,899.6200807,1.0037455,109.0305911,91.0182048,182.3939798,12.5278215,16.7056728,0.1478494,47.6650428),(47326,'radius.tif',233,3,122,46.711266,101.3865889,84.2868509,1.8,100.9121722,84.286689,-0.3711048,7.2225381,8.1499563,676.5211646,890.2518071,1.0238451,109.2339359,93.6680651,182.491294,12.5629843,16.7056728,0.1478494,50.2362653),(47327,'radius.tif',233,3,123,47.248159,101.3502342,84.3687836,1.8,100.8906017,84.3822187,-0.3697723,7.2877582,8.5871116,681.7130885,914.3913866,1.0285313,106.4841622,93.5422215,185.8677888,12.6516096,16.7610692,0.1685969,52.3456376),(47328,'radius.tif',233,3,124,47.4252008,101.395145,84.4584779,1.8,101.0075807,84.4611405,-0.3557517,6.871099,8.4304424,680.002369,939.6259643,0.9588544,111.456305,98.9655903,173.7957004,12.7304213,16.7056728,0.1478494,49.9803555),(47329,'radius.tif',233,3,125,47.9256892,101.4335478,84.5696758,1.8,101.006142,84.6453269,-0.3542617,6.6919799,8.6986768,687.0297939,966.2219605,0.9612157,111.0768895,102.664653,176.4895295,12.6781878,16.8236313,0.189199,52.0543941),(47330,'radius.tif',233,3,126,47.502804,101.4737427,84.7153261,1.8,101.0229374,84.8013009,-0.3581738,6.6402174,8.487127,695.3995229,975.9981274,0.9729799,114.9974691,104.725415,169.3103381,12.7756352,16.8236313,0.189199,49.7744152),(47331,'radius.tif',233,3,127,47.8158012,101.602127,84.8231435,1.8,101.2822991,84.9298847,-0.3876691,6.6855016,8.1863109,714.529325,1000.0953478,1.1388756,122.1667922,106.877445,202.6756375,12.9706782,17.1077482,0.1651487,55.7406212),(47332,'radius.tif',233,3,128,48.0066632,101.7371073,84.9518676,1.8,101.3842437,85.1278491,-0.388156,7.1370243,8.2424987,745.2121865,1024.9865968,1.1461494,124.3538682,104.4149707,204.2420922,13.1809164,16.9699265,0.2299044,52.792852),(47333,'radius.tif',233,3,129,47.5468865,101.9468334,85.0093821,1.8,101.6670742,85.1532797,-0.40878,6.700197,8.3762702,761.3607924,1032.5561126,1.2520553,123.2715857,113.632598,203.7204878,13.2704579,17.3124237,0.2252768,50.1009925),(47334,'radius.tif',233,3,130,48.2996978,102.1009216,85.1642027,1.8,101.8773528,85.2767411,-0.3583627,7.2498531,8.5330214,774.8536913,1061.9732495,0.9903012,124.4545397,106.8785363,204.7342151,13.3705,17.5816183,0.2013171,54.0784632),(47335,'radius.tif',233,3,131,49.9126615,102.343873,85.2761769,1.8,102.1897923,85.37848,-0.3060629,7.0682053,8.6761641,805.0280767,1107.8669952,0.7552268,127.6908754,113.8942683,197.9079804,13.5499394,17.8605983,0.1780929,55.1934679),(47336,'radius.tif',233,3,132,51.4122167,102.5436276,85.4516753,1.8,102.4468893,85.5070742,-0.251336,8.0823211,8.9138361,835.3064908,1169.1077869,0.529981,131.1565267,103.3498278,201.207217,13.7883449,18.4025193,0.1148766,55.896592),(47337,'radius.tif',233,3,133,52.2017696,102.8829347,85.6398188,1.8,102.8549378,85.7119144,-0.2150718,7.2706885,9.3218557,858.0543339,1229.7601902,0.3962728,131.9222512,118.0155543,208.2528931,14.0510378,18.3352338,0.0767719,56.8056564),(47338,'radius.tif',233,3,134,53.3895635,103.1887779,85.8715929,1.8,103.1918895,85.9894843,-0.1767808,7.4311104,9.7752621,891.0058621,1337.8991265,0.2751988,136.8658065,119.9021156,206.2887855,14.4244474,19.7939119,0.5830765,62.0187688),(47339,'radius.tif',233,3,135,55.9121555,103.5264861,86.1423875,1.8,103.5787628,86.2408939,-0.1225423,8.7944512,10.5178366,953.5406145,1530.6757473,0.1392361,145.5314247,108.4252546,196.9220153,14.6893815,20.0883189,3.0715321,67.5231248),(47340,'radius.tif',233,3,136,59.6582343,103.9319618,86.4761326,1.8,104.1086381,86.5570823,-0.1028594,7.8729093,11.1862919,1057.9075392,1787.7503569,0.1048275,159.8161732,134.373139,253.4607299,15.409061,21.6517709,0.5654839,63.9222009),(47341,'radius.tif',233,3,137,68.319197,104.3534737,86.9143543,1.8,104.4063918,87.1869198,-0.1799071,9.9636795,17.4102198,1346.5739278,2418.1827503,0.3645838,138.8944409,135.1482577,189.2785043,16.8239568,36.3352613,0.4939414,96.5218202),(47342,'radius.tif',233,3,138,79.5009165,104.8650701,87.1244819,1.8,104.9952032,87.3766198,-0.1149163,10.4605809,17.2329781,1654.0158776,3063.9661528,0.1742094,177.7966716,158.1189322,234.0344624,17.578103,25.9537581,0.4939414,73.8012724),(47343,'radius.tif',233,3,139,105.3411826,104.7705064,87.7692601,1.8,104.5196596,87.6451517,-0.108113,9.7719624,13.1233899,2365.2501576,4540.8627614,0.2044138,346.0129423,242.0445405,466.7931888,18.6327892,28.3002,0.4636476,82.2887313),(47344,'radius.tif',233,3,140,126.3556661,103.7213518,87.7174632,1.8,103.6821286,87.9929869,-0.0571092,10.417699,13.7885625,3085.4676668,5375.9114524,0.0686094,389.881938,296.1755448,528.6075104,20.2410937,29.7168737,0.453066,85.8189876),(47345,'radius.tif',233,3,141,114.7446195,104.1183185,89.0578341,1.8,104.2808575,88.5447981,0.0655288,10.655974,13.22144,2681.4197184,4751.4006599,0.082002,359.3708895,251.6353472,545.6802865,19.9425063,26.294398,0.5174877,78.5671704),(47346,'radius.tif',233,3,142,75.1504164,105.7249742,87.2876518,1.8,105.9880114,87.0515558,0.2453945,7.5573047,11.9540578,702.9806354,3466.8215335,0.7392215,290.0121107,93.0200204,333.272533,13.7485036,24.4834644,2.7744188,71.9478098),(47347,'radius.tif',233,3,143,47.0716416,108.5016257,87.7261353,1.8,108.8485582,87.45559,0.5074012,5.9311347,11.8933204,245.8006693,1723.0623246,1.8523168,144.8764742,41.4424357,165.20079,11.4038359,23.1844451,2.4313216,63.4250171),(47348,'radius.tif',233,3,144,15.5646916,113.0979758,90.7725109,1.8,112.9256557,90.1196427,1.0244947,4.0022098,6.649645,38.6230495,122.8562788,1.8939321,18.4756146,9.6504309,23.2493862,7.3413848,13.5704777,2.2091161,34.5676566),(47349,'radius.tif',233,3,145,94.6433222,101.4478477,95.5748575,1.8,102.1213805,95.5187393,0.1765355,10.5513149,15.8691911,1384.4996168,6058.8425493,0.4865044,381.7990803,131.2158375,449.5584041,22.6523242,36.887221,0.3911254,142.042157),(47350,'radius.tif',233,3,146,89.9828586,103.242159,96.5118773,1.8,103.6749245,97.3086589,0.2672019,13.9235587,16.997912,1490.4959,5268.1665266,1.0455076,309.9302154,107.0484875,376.8075037,20.8386923,36.6704677,0.0767719,140.9978198),(47351,'radius.tif',233,3,147,121.2658379,102.4316906,97.8989522,1.8,103.2589905,98.7739264,0.3026609,14.2656409,20.8850442,2721.0449756,7899.2041966,1.7955521,378.223006,190.7411664,501.045158,21.8634512,41.3829016,2.9708574,134.5637014),(47352,'radius.tif',233,3,148,131.8908141,102.2032448,99.2811908,1.8,102.9530383,99.6023493,0.3330746,14.501226,21.7461104,2956.9266109,10605.6665396,2.3497765,487.7040687,203.9087317,622.6414751,21.8849222,42.961114,3.0842784,121.8075282),(47353,'radius.tif',233,3,149,154.0085219,102.6478213,99.986437,1.8,103.0270728,100.1835735,0.2091125,13.0219546,20.3218174,3198.1949901,12554.2623402,1.1061494,617.7726167,245.6002259,743.7832573,21.4452857,42.631883,3.075573,124.584691),(47354,'radius.tif',233,3,150,156.6542229,103.5911404,100.4054202,1.8,103.5699288,100.852753,0.2732411,13.4720245,20.6973641,3012.6941865,13592.0527685,1.9012865,656.7045313,223.6259436,773.8058892,20.9330343,43.7352247,3.0611216,127.1412777),(47355,'radius.tif',233,3,151,137.4675352,104.3099736,101.4932058,1.8,103.9765936,101.1788142,0.3025493,12.3999842,20.4106163,2122.7722539,12501.6791561,2.0339921,612.5086556,171.1915284,705.1037892,20.7752599,46.4541075,3.0961694,146.1049309),(47356,'radius.tif',233,3,152,127.8294159,104.278313,101.6741655,1.8,104.2835386,101.6590035,0.2568768,9.9456832,21.208504,1746.0289774,11369.539052,1.3751681,536.0839708,175.5564635,613.4087282,21.1332947,50.0713738,0.0773104,152.8242305),(47357,'radius.tif',233,3,153,109.7445293,104.8344654,102.3928838,1.8,105.0042278,102.4882478,0.2622576,8.6966017,24.3094161,1208.2049812,11229.8809275,1.2294421,461.9560127,138.9284031,499.5030239,13.8207985,29.0416649,3.0202407,97.0482755),(47358,'radius.tif',233,3,154,96.8743403,106.5233009,103.8870788,1.8,107.1099192,104.1304261,0.2866217,7.8354635,22.6894442,876.326772,12687.4291397,1.2904771,559.1776077,111.8410897,584.5556832,8.922752,13.7289373,0.8760581,42.2313544),(47359,'radius.tif',233,3,155,93.6541806,108.9171683,105.6794884,1.8,111.2247273,106.7992796,0.3123549,8.8396505,21.7693035,837.674558,14027.8316562,1.4740165,644.3858732,94.7633118,680.0457046,13.9887484,29.6669223,0.7099116,86.8986586),(47360,'radius.tif',233,3,156,92.6655634,110.8859133,107.0893316,1.8,112.8007834,107.9449799,0.3053914,8.0687702,22.998339,797.4685841,13561.7239374,1.3961663,589.6827558,98.8339694,624.3575294,13.792993,28.2761695,0.6708575,82.18273),(47361,'radius.tif',233,3,157,93.7523083,110.6862836,108.1425795,1.8,111.5004836,109.1438055,0.2397173,13.4927364,22.4220378,1039.4322514,12759.3357088,0.8808352,569.0533494,77.0364305,590.4122724,14.5908523,28.2827253,0.6086893,80.7764818),(47362,'radius.tif',233,3,158,110.2053172,109.1645611,110.0599674,1.8,109.3682696,110.369206,0.1511821,10.7533312,20.8920118,1823.8079685,13742.6114295,0.4166208,657.7926312,169.6039985,719.3137573,15.3663764,30.3343262,0.5622848,85.2365005),(47363,'radius.tif',233,3,159,129.130169,106.3842358,111.5309614,1.8,106.3057272,111.758595,0.0316859,10.442378,22.7474734,2215.006733,13541.8292751,0.0216004,595.311357,212.1170807,686.4924846,18.5154775,45.6570712,0.1157592,146.2609017),(47364,'radius.tif',233,3,160,125.5808697,104.6856494,112.2790273,1.8,104.2545336,112.2183662,-0.0197502,11.8256145,24.3215762,1890.82584,10518.4197636,0.0081632,432.4727845,159.8923965,508.2022792,17.4277855,46.4408026,0.1290498,138.4765669),(47365,'ulna.tif',233,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47366,'ulna.tif',233,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47367,'ulna.tif',233,4,3,25.0876795,100.0555741,112.3138105,1.8,100.0470399,112.1076144,-0.635324,5.3979557,7.7331953,131.9487073,256.9473135,1.4725174,33.226539,24.4441998,50.275225,10.611841,15.0475133,0.6528466,41.1870173),(47368,'ulna.tif',233,4,4,73.0174511,99.8699123,112.5834689,1.8,99.7790173,112.5009398,-0.6564637,7.0762285,9.3755017,757.8691504,1503.4736316,4.5330424,160.3619382,107.1007171,240.9062135,14.1697393,19.1173488,0.5624979,53.7372502),(47369,'ulna.tif',233,4,5,85.1684619,98.8342534,113.4446758,1.8,98.962495,112.8741857,-0.5243121,8.2234676,10.9864784,1273.7602366,2288.0664185,3.5574585,208.2620411,154.893324,322.3880549,16.4302192,21.9353316,0.3775302,62.6012559),(47370,'ulna.tif',233,4,6,87.2183932,97.7174773,113.4689285,1.8,98.0653661,113.0507186,-0.5260368,9.0659701,11.5343212,1510.9731377,2684.2923658,3.6648354,232.7221796,166.6642529,339.9538126,17.1423593,23.9604439,0.252096,65.7902992),(47371,'ulna.tif',233,4,7,79.683389,96.9620776,112.5305834,1.8,97.017247,112.7009826,-0.4560617,9.4419192,12.376963,1274.3283621,2892.0052147,2.5759786,233.6603266,134.9649716,319.1735912,16.5637905,24.6419677,0.2449787,67.1965474),(47372,'ulna.tif',233,4,8,80.6367627,96.3005046,112.4985754,1.8,96.1551505,112.4702644,-0.5690802,8.0468407,11.9142037,1316.1924061,3174.6616523,3.9023807,266.4602471,163.5663556,360.5003692,15.4094833,24.4582107,0.3217506,65.4990557),(47373,'ulna.tif',233,4,9,85.6364408,95.7631521,112.3169417,1.8,95.5281885,112.2388737,-0.6487042,8.3311722,12.1515615,1383.7471066,3647.8896559,5.2095851,300.199251,166.0927272,413.5374354,15.6612908,24.0299805,0.3587707,66.2021798),(47374,'ulna.tif',233,4,10,93.8927582,95.1899137,112.1552338,1.8,95.1094547,111.875923,-0.6898265,8.3594091,12.549998,1570.1091835,4227.2550026,6.3379061,336.8331219,187.8253784,452.1189728,15.4126989,24.7445752,0.3936982,68.4821587),(47375,'ulna.tif',233,4,11,105.228186,94.9120875,111.9238216,1.8,95.0598854,111.4801716,-0.6717278,9.3729849,13.8751383,1900.6709507,5291.979934,6.7925896,381.4001582,202.7818221,495.9622489,17.0950537,26.8318098,0.3756402,73.9365451),(47376,'ulna.tif',233,4,12,128.1109524,94.4251184,111.0911122,1.8,94.3562052,110.4544074,-0.6034816,12.2300502,14.7089427,3205.4098651,6996.0498397,6.8767933,475.6324094,262.0929443,668.5596887,21.1435379,28.1644878,0.4245614,83.6596458),(47377,'ulna.tif',233,4,13,127.828517,93.0496674,111.3013732,1.8,93.1739976,110.5617267,-0.7978817,11.5162115,14.1113486,3171.9722734,6297.264641,10.9183069,446.2553372,275.4353958,645.0631931,20.519248,27.3044019,0.6022873,84.3274361),(47378,'ulna.tif',233,4,14,117.3238783,91.8737238,112.3312811,1.8,91.9928578,111.4458661,-0.8566307,10.6393401,12.5665063,2323.6188509,5223.7991944,11.1651617,415.6922426,218.3987763,584.1108881,18.8840343,24.571648,0.9788255,77.9140158),(47379,'ulna.tif',233,4,15,103.9416277,90.6594505,113.6376192,1.8,90.7207462,112.9081026,-0.8255943,10.0598606,10.8413409,1677.9111538,3788.5635047,9.357394,349.4552507,166.7926837,441.7982983,17.7021655,22.2625131,0.2717922,69.6324971),(47380,'ulna.tif',233,4,16,96.3932527,89.8810845,114.3161101,1.8,89.8090337,113.7535468,-0.8126588,9.1551763,10.3941725,1371.5719706,3275.731437,8.4705116,315.1507675,149.8138232,405.426512,16.6320932,21.2484296,0.2851177,64.4547185),(47381,'ulna.tif',233,4,17,93.8302111,89.7315663,114.1976246,1.8,89.6995581,113.879608,-0.7752014,8.5961796,10.52152,1361.0797502,3335.1708957,7.6597353,316.9856549,158.3354244,384.154288,16.0239017,22.0028423,0.2256012,64.7106283),(47382,'ulna.tif',233,4,18,91.4532002,89.5589691,113.9787159,1.8,89.6180411,113.1759909,-0.7389387,9.7127483,10.6958359,1479.0140258,3593.2306838,6.9139736,335.9466907,152.2755436,376.7407963,17.6631132,23.4679196,0.1503714,91.0820695),(47383,'ulna.tif',233,4,19,100.5954378,89.6824174,113.0865121,1.8,89.9110445,111.7859979,-0.7191645,11.5436726,11.8769991,2026.893208,4497.8778894,7.275731,378.7049099,175.5847802,452.2433882,0.3515621,0.7861167,2.0344439,1.6974918),(47384,'ulna.tif',233,4,20,123.2043456,90.2199549,111.516435,1.8,90.7070325,110.0915989,-0.7552474,12.1924084,13.6952898,3025.5402583,6710.8440212,9.648286,490.0110989,248.1495172,606.9801182,0.6949554,3.3352106,1.2490458,7.2018477),(47385,'ulna.tif',233,4,21,138.2506836,91.2140789,110.4203103,1.8,91.8930928,109.0941818,-0.7189954,11.6041208,15.2453613,3276.7473232,9623.6817951,9.9953458,631.2531152,282.3779055,832.7369924,0.3515621,0.7861167,2.0344439,1.6974918),(47386,'ulna.tif',233,4,22,142.7695364,91.6104351,109.9305954,1.8,92.2795819,108.7500173,-0.6720265,11.3418779,16.3556479,2965.3530251,11540.4954264,9.2228474,705.59696,261.4516788,879.7855978,0.3515621,0.7861167,2.0344439,1.6974918),(47387,'ulna.tif',233,4,23,127.2515115,89.9463819,110.9775595,1.8,91.2287531,109.2761394,-0.7083094,10.7443255,16.4393728,2284.2278698,8714.0586966,8.9758189,530.072455,212.5985365,653.6359308,18.1242594,30.6565342,0.638914,84.4127394),(47388,'ulna.tif',233,4,24,108.3428771,88.2765247,112.4824088,1.8,89.0989146,111.5410538,-0.7258222,9.0024495,14.9997185,1607.7290161,5738.6140891,7.9553457,382.5814532,178.5879517,487.0584521,15.4021363,27.0131466,0.6747409,72.033113),(47389,'ulna.tif',233,4,25,107.2578925,87.6730827,112.7309197,1.8,88.2604162,112.0962068,-0.7547322,8.0315337,13.8562937,1400.3351433,4835.7766509,8.3903064,348.9949596,174.3546373,436.0155975,13.8223215,25.4609584,0.6186444,67.2818507),(47390,'ulna.tif',233,4,26,104.9191588,86.9947236,113.0108643,1.8,87.1553918,112.7384577,-0.7726838,7.4178653,11.902316,1249.6533687,4051.4061233,8.5209579,340.3880504,168.4653622,436.5052435,12.9220608,22.5493561,0.5404195,60.8684304),(47391,'ulna.tif',233,4,27,104.2087072,86.4551002,113.2043081,1.8,86.4329834,113.1618217,-0.7661671,7.6426317,10.7046306,1141.3185309,3566.2612758,8.3501334,333.1512686,149.3358016,432.6825978,12.0845001,21.1054391,0.5232783,57.0615662),(47392,'ulna.tif',233,4,28,102.7054442,86.0823714,113.2755879,1.8,86.0767745,113.2563288,-0.7447278,7.4366233,10.7769386,1030.5698365,3274.9524369,7.863376,303.8852283,138.5803465,399.4399377,11.6838201,20.4994146,0.5404195,54.6609503),(47393,'ulna.tif',233,4,29,100.9846899,85.7303255,113.3267038,1.8,85.6598465,113.3777784,-0.719329,7.2796972,10.7694622,923.9231269,3045.1107087,7.3066276,282.7542049,126.9177964,366.9244118,11.4352282,20.0174387,0.5343955,52.8781552),(47394,'ulna.tif',233,4,30,99.3977188,85.3560114,113.3928913,1.8,85.2407123,113.3885159,-0.6941392,7.059257,9.9913591,838.4633579,2772.0180334,6.7797008,277.4415378,118.7750157,358.8910649,11.4352282,19.6686327,0.5036263,52.0897279),(47395,'ulna.tif',233,4,31,100.2334891,84.9492253,113.4196106,1.8,84.8716612,113.4346642,-0.6726111,6.8415283,9.901965,781.3453461,2538.3601888,6.4845563,256.3491369,114.2062572,332.3274282,11.4352282,19.2333688,0.5372847,51.0953602),(47396,'ulna.tif',233,4,32,100.6671983,84.5937427,113.3612676,1.8,84.4666929,113.3388337,-0.6502688,6.9497549,9.8967321,734.4228245,2356.893763,6.1492493,238.1486874,105.6760752,310.2875547,11.3679996,19.0558312,0.5214344,49.5185054),(47397,'ulna.tif',233,4,33,98.8097394,84.3853511,113.085808,1.8,84.3147094,113.0415254,-0.6288497,7.0673339,9.7704512,697.5996914,2181.3100264,5.6979742,223.2558129,98.7076177,294.5196882,11.1191549,18.5263533,0.5827395,48.8153813),(47398,'ulna.tif',233,4,34,97.0301085,84.116669,112.8895866,1.8,84.0678266,112.7870221,-0.6173936,6.9895789,9.5920257,664.4548096,2051.7743146,5.4197614,213.9041727,95.06364,283.0410377,11.0659423,18.1489125,0.5503859,48.3181975),(47399,'ulna.tif',233,4,35,95.3926878,83.9099584,112.5626559,1.8,83.9138587,112.4443808,-0.6140746,7.0091551,10.2990433,647.2661157,1960.4846483,5.2785416,190.355996,92.3458115,252.0442639,10.9042811,17.9675386,0.5337082,47.3238298),(47400,'ulna.tif',233,4,36,94.8312254,83.7371621,112.1593749,1.8,83.7161596,112.0388041,-0.6180312,7.0268086,9.3123847,647.4520216,1905.5634277,5.306456,204.6267931,92.1402671,274.1231864,10.853697,17.6657749,0.5438325,46.826646),(47401,'ulna.tif',233,4,37,93.3878128,83.604846,111.6984165,1.8,83.5858397,111.6004515,-0.6285001,6.917682,9.0687759,639.2389111,1868.6532815,5.3801368,206.0535303,92.4065188,276.4783445,10.8069296,17.4546226,0.5991753,46.9119492),(47402,'ulna.tif',233,4,38,92.3117421,83.4922798,111.2117228,1.8,83.4699936,111.0849459,-0.6381478,6.7702325,9.8411671,627.1651885,1826.3380623,5.4597612,185.5814512,92.6356938,247.582927,10.6422145,17.2408845,0.6842948,46.6207057),(47403,'ulna.tif',233,4,39,91.1745851,83.4036945,110.7251914,1.8,83.3782145,110.6378944,-0.6453042,6.6410224,8.8573886,612.3050764,1789.8998932,5.4967926,202.0798658,92.2004235,260.6086781,10.5404907,17.0860608,0.6393859,45.626338),(47404,'ulna.tif',233,4,40,90.4073917,83.3297423,110.2490087,1.8,83.3583724,110.1728226,-0.6543717,6.5793959,8.7789215,599.941085,1762.7211641,5.5821751,200.7901723,91.1848278,261.2583669,10.5228137,16.9699265,0.6973908,45.9175816),(47405,'ulna.tif',233,4,41,89.3659653,83.4199755,109.5240651,1.8,83.3707514,109.4292095,-0.6737745,6.6568517,8.7691424,592.2351609,1733.7851874,5.79838,197.7143384,88.9662542,264.9212135,10.3755651,17.0208328,0.6682894,45.3350945),(47406,'ulna.tif',233,4,42,88.1768606,83.4038607,108.9809218,1.8,83.3965238,108.8644969,-0.6894109,6.7495597,8.6654829,579.937034,1704.7077025,5.9460783,196.7239126,85.9222027,263.316516,10.2976704,16.9699265,0.6973908,45.1291542),(47407,'ulna.tif',233,4,43,87.2342734,83.3721396,108.4263531,1.8,83.3343739,108.2901291,-0.7049419,6.3381684,9.082852,569.3315693,1684.4364177,6.1048064,185.4523679,89.825882,238.4276109,10.1375201,16.8052549,0.6518691,45.0085172),(47408,'ulna.tif',233,4,44,86.2910121,83.3414693,107.8839722,1.8,83.3108634,107.7478101,-0.7218832,6.3127027,8.6528745,560.7778001,1678.991653,6.2799108,194.0385996,88.833235,257.9170076,10.0254098,16.9699265,0.6973908,45.2144574),(47409,'ulna.tif',233,4,45,85.6733323,83.3299978,107.3259783,1.8,83.3443541,107.1675128,-0.7331988,6.5834073,9.1279883,550.4323277,1675.6973719,6.3954483,183.5779484,83.6090341,233.1945746,9.9360401,16.9699265,0.6973908,45.2997607),(47410,'ulna.tif',233,4,46,85.2474134,83.3216491,106.7950925,1.8,83.3353814,106.6792313,-0.740723,6.2775985,8.6260372,537.5418483,1675.1326581,6.4700553,194.1949272,85.6285799,244.5218206,0.3515621,0.4971838,2.3561945,0.9943677),(47411,'ulna.tif',233,4,47,84.8133297,83.3244864,106.2544964,1.8,83.3641536,106.1234691,-0.7453398,6.3944908,8.7168524,526.5887286,1685.3924616,6.5021354,193.3487443,82.3503769,240.6473716,0.6292499,1.267575,0.9827937,2.6918595),(47412,'ulna.tif',233,4,48,84.5120179,83.3399946,105.7167224,1.8,83.3600141,105.5612753,-0.7525865,6.2652893,9.0180835,519.1467678,1695.1652013,6.5808365,187.973997,82.8607812,233.197483,9.7065631,17.7912634,0.9114863,46.2088251),(47413,'ulna.tif',233,4,49,83.4490934,83.4710155,105.0068542,1.8,83.4986629,104.9001704,-0.766,6.9244933,9.0941335,513.4215752,1692.4610585,6.684366,186.1047088,74.1457246,233.9865511,9.6181457,17.6552773,0.9551764,45.7969445),(47414,'ulna.tif',233,4,50,82.2106626,83.5164714,104.4693369,1.8,83.5324722,104.2680006,-0.777598,6.1238081,9.0869392,503.5608461,1688.7084826,6.7440173,185.8390869,82.2300177,229.2945055,0.7457758,2.7457875,0.8760581,5.6749625),(47415,'ulna.tif',233,4,51,81.1170263,83.5814706,103.9206736,1.8,83.5802908,103.7956101,-0.7867929,5.8826439,9.1658278,495.0246495,1671.6257941,6.7786085,182.3758669,84.1500288,224.2560719,1.1726893,4.2913618,0.9600704,9.069946),(47416,'ulna.tif',233,4,52,80.1635403,83.6775296,103.3750795,1.8,83.7214223,103.2296177,-0.801028,6.6843508,9.4604711,488.1270176,1665.2499805,6.8890845,176.0218874,73.0253446,220.6124507,0.9943677,8.4521252,0.7853982,17.3161309),(47417,'ulna.tif',233,4,53,79.7823781,83.7830028,102.8403191,1.8,83.8202895,102.6594667,-0.8097882,6.508468,9.3185267,481.15504,1648.3472955,6.9727184,176.8892609,73.9275422,211.9678948,1.3739076,9.6982713,0.8110336,21.9967257),(47418,'ulna.tif',233,4,54,79.0899789,83.876427,102.3492584,1.8,83.8759468,102.2521634,-0.8185288,6.5530312,9.4164493,476.3596116,1636.0672026,7.0272289,173.7456605,72.6930172,211.5496157,1.1709525,9.6982713,0.8110336,20.0079904),(47419,'ulna.tif',233,4,55,78.9904281,84.0007139,101.8533943,1.8,84.0407193,101.7255776,-0.8251396,7.0392706,9.2612095,469.7121788,1625.8608814,7.1051832,175.5559981,66.7273936,216.7240212,9.4464928,18.0396219,0.9936041,45.7969445),(47420,'ulna.tif',233,4,56,78.4214376,84.1207509,101.3957084,1.8,84.1794653,101.3253084,-0.8333932,6.4744542,9.4325098,467.1708646,1611.965024,7.1614635,170.8946031,72.1560233,203.3144298,9.1979009,18.0704267,0.9234042,45.2144574),(47421,'ulna.tif',233,4,57,77.3891498,84.362522,100.763849,1.8,84.4323849,100.6613815,-0.8419303,6.5799406,9.6296755,461.6591843,1572.7031436,7.1767059,163.318395,70.1616034,205.8627165,0.4971838,0.9943677,0.7853982,1.9887353),(47422,'ulna.tif',233,4,58,76.1845019,84.4828321,100.3341111,1.8,84.544322,100.2371912,-0.8487755,6.0767351,10.0196134,453.6682745,1536.1382956,7.1512842,153.3131296,74.6565818,198.3082277,0.7783415,1.7578103,0.9272952,3.6862271),(47423,'ulna.tif',233,4,59,74.9254344,84.6279867,99.894608,1.8,84.69105,99.8239549,-0.8558734,6.6837417,9.8615958,447.8454727,1504.0928067,7.1209401,152.520225,67.0052037,197.6626604,1.0491819,7.9704632,0.847817,16.3217633),(47424,'ulna.tif',233,4,60,74.2293274,84.7801139,99.4606197,1.8,84.8088596,99.3866305,-0.8632041,6.0437533,9.9707557,441.8291514,1473.8854975,7.1444779,147.8208414,73.1050938,191.6141715,0.6301425,1.7578103,0.9272952,3.6862271),(47425,'ulna.tif',233,4,61,73.1714965,84.9309501,99.0555396,1.8,85.0013405,98.927466,-0.8674977,6.1540018,9.8354471,436.8468961,1440.1595938,7.094356,146.4254322,70.9858258,190.2556723,0.9194874,4.5021911,0.8960554,9.3611896),(47426,'ulna.tif',233,4,62,72.2902953,85.0807838,98.6828516,1.8,85.1346169,98.6242237,-0.8737901,6.7298131,9.7716197,434.24529,1401.2349739,7.0836321,143.3984346,64.5256089,186.1804447,0.975146,8.2373624,0.8760581,17.0248874),(47427,'ulna.tif',233,4,63,71.6185704,85.2380109,98.311825,1.8,85.2808575,98.2144813,-0.8812929,5.99043,8.6763111,428.3716304,1373.727858,7.1058503,158.3308677,71.5093291,201.0408499,9.651424,17.0208328,0.9025069,43.6376027),(47428,'ulna.tif',233,4,64,71.1813031,85.412997,97.9429683,1.8,85.4768399,97.8522086,-0.8896157,6.9077029,9.5533218,426.2074443,1351.591041,7.1592326,141.4786469,61.7003148,184.1616695,0.4971838,0.9943677,0.7853982,1.9887353),(47429,'ulna.tif',233,4,65,69.9600635,85.6871174,97.4517219,1.8,85.7498499,97.3591245,-0.8978299,5.9590346,9.2285186,419.0923915,1309.9790304,7.1299402,141.9490044,70.3289077,186.3940155,0.4971838,0.9943677,0.7853982,1.9887353),(47430,'ulna.tif',233,4,66,68.6467636,85.8413931,97.1317672,1.8,85.8594399,97.0822932,-0.905825,6.5239944,9.1654311,414.9429957,1267.4064897,7.0850998,138.2811655,63.6025986,182.4521475,9.6950848,16.4784755,0.9827937,42.4372947),(47431,'ulna.tif',233,4,67,67.5886705,85.9973912,96.7962897,1.8,86.0346657,96.6435679,-0.9114233,6.0168237,9.8870854,413.1127784,1225.3546525,7.0370503,123.9348704,68.6596118,165.494304,0.9760983,3.5156206,0.9272952,7.6636978),(47432,'ulna.tif',233,4,68,66.9004287,86.1536324,96.48918,1.8,86.224706,96.4223548,-0.9161338,6.0990499,9.5458039,410.8333698,1186.8528413,7.0161939,124.3324134,67.3602248,166.1402378,9.6950848,16.102924,0.9403949,41.6488673),(47433,'ulna.tif',233,4,69,66.1429357,86.2964374,96.1874175,1.8,86.337328,96.1105194,-0.9229607,6.1524802,9.0023683,406.2053331,1151.710907,7.0093171,127.934214,66.0230221,172.8140004,0.3515621,0.4971838,2.3561945,0.9943677),(47434,'ulna.tif',233,4,70,65.2019965,86.4243668,95.9184862,1.8,86.4846664,95.8733709,-0.9290047,7.3955167,9.5521481,400.596406,1107.8251079,6.9727046,115.9765425,54.1674671,157.9128794,9.6592595,15.8202927,0.9272952,41.1516835),(47435,'ulna.tif',233,4,71,64.9350294,86.5576384,95.6495575,1.8,86.6663622,95.5539977,-0.9374436,6.5231501,10.1066403,397.5770171,1076.9844073,7.0315218,106.5620602,60.9486233,145.6974345,0.3515621,0.4971838,2.3561945,0.9943677),(47436,'ulna.tif',233,4,72,64.446189,86.6729149,95.3958342,1.8,86.7363462,95.26826,-0.9393024,6.2386163,9.5510068,394.5502041,1040.2543565,6.9976251,108.9156759,63.2432232,150.1738801,9.6950848,15.3282671,0.9318823,40.1573158),(47437,'ulna.tif',233,4,73,63.0943122,86.8569463,95.0510228,1.8,86.9027323,94.9596824,-0.944381,5.6706854,8.958823,386.9065238,990.8250598,6.9016494,110.597682,68.2292349,153.6050478,9.6950848,15.0187378,1.0022718,39.4541917),(47438,'ulna.tif',233,4,74,61.909552,86.9529686,94.8445747,1.8,87.0990718,94.7549787,-0.9466795,6.6946819,8.7361541,384.529677,952.6718854,6.7945633,109.0493454,57.4380802,152.9279069,9.7506964,14.9196576,0.9697226,39.9513756),(47439,'ulna.tif',233,4,75,61.0522835,87.0321673,94.6250284,1.8,87.1166525,94.5130921,-0.9499036,5.8985902,8.7986042,382.044105,923.3143371,6.7315595,104.9387283,64.7687145,148.1363369,9.6950848,14.7236944,0.9894161,39.2482514),(47440,'ulna.tif',233,4,76,60.3641166,87.1168211,94.3970957,1.8,87.1693622,94.2637043,-0.9536292,5.8814237,8.5654686,379.4755713,896.3000661,6.6911088,104.6411012,64.5210393,148.7917007,9.751589,14.6310652,0.9561334,39.1629482),(47441,'ulna.tif',233,4,77,59.4641888,87.2015043,94.1911578,1.8,87.2678222,94.1200392,-0.9605105,6.5702058,8.4372577,376.6509206,871.781662,6.6555736,103.3252388,57.3271115,147.3547049,9.6950848,14.4311837,0.9760371,38.7510676),(47442,'ulna.tif',233,4,78,58.5823509,87.2764867,93.9686685,1.8,87.3182355,93.882049,-0.9687499,5.7352321,8.2174775,373.7617555,845.843373,6.6322057,102.9322406,65.1694208,147.9735027,9.7506964,14.345283,0.942,38.6657643),(47443,'ulna.tif',233,4,79,58.3454588,87.3352394,93.7591378,1.8,87.4150308,93.6317975,-0.9789472,5.8265355,8.1124955,374.13842,827.0057888,6.6975859,101.9422189,64.2128444,147.0097417,9.6575467,14.1719197,1.0516502,38.7510676),(47444,'ulna.tif',233,4,80,58.0995404,87.3989411,93.5749464,1.8,87.5086772,93.5078262,-0.9884956,5.7521022,14.6280798,372.6962984,815.5741485,6.7546362,55.7540128,64.7930591,77.1089135,9.5956153,14.1413627,0.962107,38.4598241),(47445,'ulna.tif',233,4,81,57.0273274,87.552177,93.2808407,1.8,87.6496132,93.3101266,-0.9943886,5.6584379,7.8873461,367.7532523,782.7278017,6.6813029,99.2384251,64.9920098,145.7529622,9.5947227,14.0492927,1.017502,38.2538838),(47446,'ulna.tif',233,4,82,55.7302074,87.6127635,93.1042397,1.8,87.7341097,93.0789735,-0.9991859,6.3072472,7.9154415,360.0538753,755.1509297,6.5699677,95.4022497,57.0857405,140.5115526,9.5947227,14.0008239,1.0734536,37.8420032),(47447,'ulna.tif',233,4,83,54.9146243,87.6637009,92.9318828,1.8,87.8270961,92.9456559,-1.0093364,6.8720124,7.8246856,359.452211,733.4351075,6.5579614,93.7334925,52.3066887,139.5475126,9.6575467,13.7514254,1.0040671,37.4654564),(47448,'ulna.tif',233,4,84,54.1929742,87.7082867,92.740448,1.8,87.8565078,92.6928988,-1.0129783,6.9381158,7.7495895,358.1554224,711.2667311,6.501379,91.7812141,51.6214247,137.9928278,9.7489114,13.6928797,1.0612041,37.5507596),(47449,'ulna.tif',233,4,85,53.2278402,87.7491612,92.5720421,1.8,87.8009482,92.503929,-1.0115997,6.4224413,6.7275283,350.7128252,689.7994515,6.3746018,102.5338607,54.6074004,144.5031487,9.5947227,13.529431,1.1420183,37.2595161),(47450,'ulna.tif',233,4,86,52.7136813,87.7920693,92.4125562,1.8,87.832882,92.3686089,-1.0117624,6.9287739,7.8367255,349.4564383,675.1632997,6.3143118,86.1537514,50.435538,130.3125356,9.7506964,13.5659231,1.0259324,37.2595161),(47451,'ulna.tif',233,4,87,52.1977621,87.8240366,92.2764748,1.8,87.8820617,92.2355636,-1.0098892,5.9708557,7.7032784,347.3614814,658.7047011,6.2378445,85.5096581,58.1761637,130.1960919,9.7506964,13.3870844,1.0483929,37.0535758),(47452,'ulna.tif',233,4,88,51.7138655,87.8616567,92.1380775,1.8,87.9449116,92.1032158,-1.0122558,5.7669939,7.6418813,345.4746097,645.939363,6.1983721,84.5262227,59.9054929,129.6738949,9.7506964,13.2665194,1.012197,36.7623323),(47453,'ulna.tif',233,4,89,50.4067454,87.9890594,91.8943264,1.8,88.0522643,91.9561849,-1.012608,6.1791063,6.5107507,338.1722021,618.237509,6.044361,94.9564092,54.7283354,138.6250976,9.7498039,13.21518,1.0714496,36.556392),(47454,'ulna.tif',233,4,90,49.6848331,88.0438425,91.7610791,1.8,88.1190053,91.7223903,-1.012258,6.6532518,7.0395188,333.6758018,599.5180383,5.9551907,85.1646331,50.1522881,119.7927608,9.7498039,13.0835888,1.0349851,36.556392),(47455,'ulna.tif',233,4,91,49.2794386,88.0977383,91.6726474,1.8,88.2218434,91.7303822,-1.0103752,6.3160618,7.3444125,329.32527,583.8672542,5.8926883,79.4981562,52.1409197,123.7726658,9.6950848,12.9267797,1.1801893,36.3504517),(47456,'ulna.tif',233,4,92,49.2086519,88.1459198,91.5734874,1.8,88.2573404,91.6015045,-1.0118554,6.3279782,7.1610272,327.7984136,570.7064904,5.8951476,79.6961772,51.801445,118.343542,0.6680515,1.5722333,1.1071487,3.3949836),(47457,'ulna.tif',233,4,93,48.9674152,88.1747829,91.471398,1.8,88.274876,91.5234939,-1.0217273,6.4261377,7.2564511,325.4856519,556.2640007,5.9383383,76.6578583,50.6502763,117.7580947,9.7498039,12.6757504,0.9827937,35.7679646),(47458,'ulna.tif',233,4,94,48.2062518,88.2092988,91.3660953,1.8,88.31055,91.3790532,-1.0206028,6.1025782,7.2153916,320.8937472,540.1529592,5.8379822,74.8612117,52.5833074,119.1991185,9.7498039,12.6024089,1.0447299,35.5620243),(47459,'ulna.tif',233,4,95,47.3786838,88.253065,91.2748596,1.8,88.3442632,91.2610634,-1.0176407,6.1206212,7.0436876,315.1587592,524.9918641,5.7168796,74.5336668,51.4913028,117.9572351,9.7498039,12.5778667,1.1071487,35.6473276),(47460,'ulna.tif',233,4,96,47.1980465,88.2886967,91.1762728,1.8,88.3469007,91.1309067,-1.0179071,6.6441287,6.9413586,311.3155807,513.0066524,5.6969568,73.9057992,46.8557422,117.4608104,0.3515621,0.4971838,2.3561945,0.9943677),(47461,'ulna.tif',233,4,97,45.9063946,88.3972605,90.9979028,1.8,88.4676902,90.972433,-1.0094772,7.6458357,6.7236126,304.4951335,490.5849995,5.4831603,72.9644949,39.8249644,102.2442097,0.3515621,0.7861167,2.0344439,1.6974918),(47462,'ulna.tif',233,4,98,45.1355309,88.4198555,90.941588,1.8,88.506164,90.8823913,-1.019748,6.0571712,6.9741534,297.924769,475.4539675,5.4603707,68.1737177,49.1854626,109.3032082,0.3515621,0.7861167,2.0344439,1.6974918),(47463,'ulna.tif',233,4,99,44.6890501,88.4530959,90.8820157,1.8,88.4896561,90.8168979,-1.015252,7.5954401,7.3846802,293.8190972,462.0325903,5.3764136,62.5663638,38.6836171,96.14228,9.6575467,11.9995501,1.0153026,34.5676566),(47464,'ulna.tif',233,4,100,44.158262,88.5091127,90.8149673,1.8,88.6163028,90.7251224,-1.0094533,7.7589622,10.1663005,289.5440559,451.1721813,5.274201,44.3791899,37.3173692,72.6534659,9.6575467,11.958279,1.1466019,34.1557761),(47465,'ulna.tif',233,4,101,43.5785973,88.5390944,90.77107,1.8,88.6048,90.7772303,-1.0064674,7.75203,6.1857374,285.7790069,435.3716384,5.1853928,70.3831424,36.8650543,90.9676286,9.5920452,11.8179248,1.0405806,34.1557761),(47466,'ulna.tif',233,4,102,43.1642889,88.5784674,90.6966785,1.8,88.724558,90.662946,-0.9978387,8.354577,6.3782011,284.4678045,424.4990914,5.0797623,66.5546739,34.0493365,78.9563232,9.5920452,11.7023176,0.9994588,34.1557761),(47467,'ulna.tif',233,4,103,42.7181452,88.5948882,90.6395494,1.8,88.7131587,90.5974847,-0.993772,6.8714118,8.1404046,278.7383883,414.2001255,5.0008305,50.8820069,40.5649374,85.0777669,9.5920452,11.6440836,1.0666304,34.1557761),(47468,'ulna.tif',233,4,104,42.5600923,88.6091626,90.5952698,1.8,88.726598,90.5329203,-0.9945277,7.6803655,6.6515169,275.4096533,406.7121001,4.9872281,61.1457668,35.8589254,84.9366476,9.5619405,11.5160055,1.0251413,33.3673487),(47469,'ulna.tif',233,4,105,42.1675068,88.7478425,90.4548633,1.8,88.9499683,90.3985231,-0.9869497,7.8178442,8.3923777,272.3872515,394.5400173,4.8923958,47.0117087,34.8417345,78.2027376,9.4360715,11.4783801,1.0934509,33.6585922),(47470,'ulna.tif',233,4,106,41.2005376,88.7783813,90.3993186,1.8,88.9213976,90.3136078,-0.9805111,6.2541271,7.9308361,262.4210656,378.7603369,4.7394258,47.7579327,41.9596628,80.3524771,9.4360715,11.3375358,1.0516502,33.4526519),(47471,'ulna.tif',233,4,107,40.4533068,88.8253861,90.3498036,1.8,89.0178331,90.2019136,-0.9759813,7.8851627,7.3885027,258.7045698,364.7479627,4.6251726,49.3669662,32.8090336,75.7427162,9.435179,11.3211718,1.1210367,32.7495278),(47472,'ulna.tif',233,4,108,39.7527055,88.8462503,90.307403,1.8,88.9924804,90.2223414,-0.9869513,6.7432557,7.8117034,251.37659,352.8834162,4.6122331,45.1736836,37.2782231,75.5853713,9.435179,11.1728171,1.1493771,32.7495278),(47473,'ulna.tif',233,4,109,39.0068979,88.8696622,90.2469161,1.8,88.9870686,90.1433445,-0.9930725,6.1764303,6.6117892,244.9795059,338.9129361,4.5622107,51.2588844,39.6636073,82.4307548,9.435179,11.0392726,0.9209259,32.6642246),(47474,'ulna.tif',233,4,110,38.5566719,88.9143245,90.1909473,1.8,89.064289,90.0505631,-1.003102,6.2856116,6.5657423,239.2815638,329.1378422,4.5682592,50.129571,38.0681435,80.978013,9.2783127,11.0336732,1.0358413,32.4582843),(47475,'ulna.tif',233,4,111,38.3979822,88.9688613,90.1246491,1.8,89.0751688,90.0174331,-0.9999638,5.3468348,7.338368,235.4265615,321.0340538,4.5312209,43.7473366,44.0310149,73.6090678,9.1979009,10.9210817,0.9917221,32.252344),(47476,'ulna.tif',233,4,112,37.8743851,89.035207,90.0505097,1.8,89.1199817,89.9144986,-1.003038,5.4002914,7.5421357,231.4339576,314.6280466,4.487054,41.7160417,42.855828,69.9866042,9.1979009,10.7327239,1.0191413,32.0464037),(47477,'ulna.tif',233,4,113,37.3137467,89.1878282,89.8553333,1.8,89.2606215,89.8152353,-0.9895742,5.4336214,6.1759134,227.4137276,303.8949938,4.3442449,49.2064855,41.8530685,85.4814645,9.2652616,10.7096675,1.1659045,31.7551602),(47478,'ulna.tif',233,4,114,36.4538939,89.2573282,89.7896151,1.8,89.3523437,89.686495,-0.9569084,5.4244811,6.1865888,218.9393238,292.4267058,4.0595457,47.2678425,40.3613398,82.657064,9.2285459,10.6285764,0.9736197,31.6698569),(47479,'ulna.tif',233,4,115,35.2991713,89.2811191,89.7404552,1.8,89.3873172,89.5817417,-0.9419009,5.5156246,6.1319824,212.094446,278.1826946,3.8473728,45.3658665,38.4533871,79.9447408,8.949309,10.6285764,0.9736197,31.2579763),(47480,'ulna.tif',233,4,116,33.8594291,89.2814471,89.7029778,1.8,89.3798474,89.5604349,-0.9356679,5.3872956,7.8733808,206.0310876,263.5753965,3.6569186,33.4767748,38.2438799,58.0583874,8.949309,10.4526915,1.2277724,30.8460958),(47481,'ulna.tif',233,4,117,33.1150073,89.3378788,89.626926,1.8,89.5480727,89.4755926,-0.8834933,5.4245265,6.9048995,204.3058552,260.0164572,3.2975208,37.6568055,37.6633531,64.3817227,8.949309,10.43494,1.0014831,31.052036),(47482,'ulna.tif',233,4,118,32.2577762,89.3952259,89.5616244,1.8,89.6147413,89.4082343,-0.869777,5.4721449,6.0247259,201.9732436,252.489132,3.1396432,41.9088164,36.9093373,71.614045,8.949309,10.43494,1.0014831,30.7607925),(47483,'ulna.tif',233,4,119,31.2834662,89.4652919,89.5041349,1.8,89.716869,89.420584,-0.9145695,6.1271253,6.0420207,198.4455824,241.1630935,3.272977,39.9143108,32.3880404,70.8355535,8.949309,10.2497073,1.0303768,30.2636087),(47484,'ulna.tif',233,4,120,30.6033143,89.4975761,89.4744715,1.8,89.6961977,89.3812879,-0.9820933,5.2930972,5.9846139,195.288945,234.5301113,3.5278531,39.1888461,36.8950231,66.0490714,8.949309,10.1223014,1.2160907,30.2636087),(47485,'ulna.tif',233,4,121,28.9822232,89.6378625,89.3724819,1.8,89.8205986,89.3224874,-1.0469519,5.4167408,6.1251918,187.1591002,221.1177256,3.6217499,36.0997225,34.5519762,64.7513741,9.120554,10.1223014,1.2160907,30.8460958),(47486,'ulna.tif',233,4,122,28.2805731,89.7117593,89.3243682,1.8,89.9226565,89.2774556,-1.1069162,5.2762559,6.2848735,182.7167707,218.0954991,3.7698662,34.7016527,34.6300055,61.7011508,9.1876667,10.4881045,0.2368488,32.8348311),(47487,'ulna.tif',233,4,123,27.8815082,89.7804182,89.310931,1.8,90.0165924,89.196534,-1.1403847,5.9866936,6.4421532,179.692928,217.6692849,3.8379208,33.7882813,30.0153875,60.6907244,9.1712103,11.1173685,0.9652517,34.4470196),(47488,'ulna.tif',233,4,124,27.5424435,89.8043898,89.2947775,1.8,90.0640793,89.1952508,-1.1153335,5.480835,6.3858027,177.7828564,218.0244624,3.7021973,34.1420607,32.4371847,60.6530734,8.949309,11.0392726,0.9209259,34.7382632),(47489,'ulna.tif',233,4,125,27.0263745,89.8173008,89.281898,1.8,90.0677596,89.1953366,-1.157058,7.3178337,6.4193339,174.5936512,216.4163582,3.7763404,33.713211,23.8586525,52.6369079,8.949309,10.7614749,0.9011574,31.4639166),(47490,'ulna.tif',233,4,126,26.3907921,89.8388164,89.2608624,1.8,90.0969781,89.1354676,-1.2248223,7.3744072,6.5700925,173.433766,215.3992924,3.8926518,32.784819,23.5183333,52.4556353,8.949309,10.7614749,0.9011574,32.0464037),(47491,'ulna.tif',233,4,127,26.2511662,89.8023066,89.283829,1.8,89.9895474,89.2147815,-1.2258692,6.1972363,5.8238086,175.3866538,219.39017,3.8749758,37.6712535,28.3007852,63.0054019,9.1979009,10.5468618,0.9272952,31.4639166),(47492,'ulna.tif',233,4,128,26.188357,89.7866878,89.3746109,1.8,90.0780893,89.3915744,-1.1718803,7.6012639,6.3954565,182.937906,221.6284538,3.7062204,34.6540475,24.0667746,53.0485764,9.7506964,11.79175,2.9617392,40.3279224),(47493,'ulna.tif',233,4,129,25.4913511,89.8162544,89.3622878,1.8,90.0240892,89.4661755,-1.0725214,6.3607219,5.9808661,180.0323601,220.2018965,3.2781924,36.817727,28.3037622,60.2006256,9.7566692,11.79175,2.9617392,38.6304306),(47494,'ulna.tif',233,4,130,25.2279046,89.733607,89.4749878,1.8,89.8975716,89.5162666,-0.9931655,6.4895887,6.145752,185.5805197,221.2745416,2.9509902,36.0044696,28.5966534,57.6798315,9.4464928,11.3864868,0.1549967,35.8179341),(47495,'ulna.tif',233,4,131,24.8031842,89.5811285,89.5629038,1.8,89.6877746,89.5891516,-0.9500811,5.7839473,6.6715707,187.1704265,228.0509289,2.7354666,34.1824947,32.3603272,61.7970587,9.6950848,11.4783801,0.6986598,35.0295067),(47496,'ulna.tif',233,4,132,25.6744228,89.4745422,89.6674635,1.8,89.5530568,89.7513606,-0.835934,5.8138592,6.9471479,205.7358197,243.3682811,2.3554136,35.0313949,35.3871351,62.6244139,9.9436767,11.8961038,0.5961991,35.4413873),(47497,'ulna.tif',233,4,133,27.2539033,89.3245945,89.8158259,1.8,89.4831559,90.0151126,-0.6327329,7.5407423,6.049031,231.1878547,275.5675879,1.5884292,45.5556582,30.6585008,59.279448,10.8203256,12.4841663,0.5645694,40.2072853),(47498,'ulna.tif',233,4,134,29.5298653,89.1299472,90.0099477,1.8,89.3225661,90.2155821,-0.4413646,6.8801853,6.6353255,268.1653248,340.032223,0.8980887,51.2457487,38.9764686,69.1732036,10.604418,13.4331675,0.1048769,39.1276144),(47499,'ulna.tif',233,4,135,33.4462817,88.8710925,90.252901,1.8,89.0547976,90.418346,-0.3817655,7.1132633,7.0738687,325.2769179,427.4330082,0.7737269,60.4242218,45.7282266,75.0319714,11.5255415,14.5208325,3.0202407,42.7285383),(47500,'ulna.tif',233,4,136,37.6251709,88.666427,90.6624433,1.8,88.872475,90.7698579,-0.2377796,6.5237802,8.8344377,398.8699008,551.419264,0.3479173,62.4170187,61.1409169,86.530562,11.932412,15.3282671,0.638914,44.6319704),(47501,'ulna.tif',233,4,137,47.8177862,87.9696393,90.9119096,1.8,88.1223256,90.9489256,-0.3271932,6.7981407,8.5686415,516.9369632,778.1311629,0.8231771,90.8114966,76.0409334,149.6095871,13.7895672,17.2408845,2.852089,52.7782163),(47502,'ulna.tif',233,4,138,54.1953712,88.324559,90.5874983,1.8,88.1571762,90.9266242,-0.3853539,7.0862842,9.3215447,572.749511,961.8984145,1.2762206,103.1908817,80.8250834,155.9784234,14.0601326,19.181891,0.8502422,61.2656752),(47503,'ulna.tif',233,4,139,33.8041855,87.5817445,90.5984968,1.8,87.7617432,90.6309432,-0.4040521,7.4159484,8.6209729,212.8396976,558.0825107,0.8708231,64.7354439,28.7002668,89.2657249,11.8815307,15.9912439,0.5819051,49.9657198),(47504,'ulna.tif',233,4,140,25.347493,86.9514028,91.1089218,1.8,86.8252821,91.3699751,-0.5132053,7.5190371,7.5245219,119.5211805,213.5865805,1.0183508,28.385402,15.8958093,43.6741033,11.5921433,13.9300228,0.7496991,52.5369422),(47505,'ulna.tif',233,4,141,19.5078497,87.7030282,91.5823089,1.8,87.5973231,91.4665185,-0.566346,7.8540248,6.4626681,86.1199856,109.501899,0.9360133,16.9437602,10.9650768,20.9952233,0.7031241,2.1384685,2.976444,4.5952915),(47506,'ulna.tif',233,4,142,22.8626914,88.5851208,90.9754982,1.8,88.3036912,90.773324,0.1779186,4.2351814,5.7626988,84.218338,125.4303238,0.1193525,21.7658996,19.8854145,36.327016,8.3771717,10.4112242,2.9375747,30.2636087),(47507,'ulna.tif',233,4,143,174.7408698,96.5940952,93.9904151,1.8,96.9980499,93.7759037,-0.3839119,12.5568509,19.1330452,5296.8550145,18658.550331,4.0856762,975.2002446,421.8298889,1124.3108096,23.5317165,42.1229449,0.583373,125.7557275),(47508,'ulna.tif',233,4,144,141.6112931,96.7259155,95.4214955,1.8,97.0952811,95.3138866,-0.3251043,12.1185586,18.8054503,3867.124801,13015.7607514,2.4078928,692.1270465,319.1076534,829.3156368,23.922111,40.7114331,0.6383198,126.4588516),(47509,'ulna.tif',233,4,145,112.8640519,96.9019774,96.4827635,1.8,97.1890398,96.3976411,-0.2395032,12.2547597,16.873192,2663.0429343,8912.3559904,1.0585395,528.1962049,217.3068259,624.7767158,22.6523242,36.887221,0.3911254,142.042157),(47510,'ulna.tif',233,4,146,91.434848,99.7463616,97.0040496,1.8,99.6896564,97.5917151,-0.2467661,13.8815811,19.4483133,2038.8488327,6445.535038,0.9092813,331.4187173,146.8743955,413.707849,20.8386923,36.6704677,0.0767719,140.9978198),(47511,'ulna.tif',233,4,147,122.5761789,99.4645592,97.742007,1.8,98.796085,98.4768308,-0.150298,12.8249863,18.941665,2808.3991928,7830.3488933,0.4580244,413.3928506,218.9787284,548.7975514,21.8634512,41.3829016,2.9708574,134.5637014),(47512,'ulna.tif',233,4,148,147.3382769,97.0342489,98.982605,1.8,97.0252279,99.1245503,-0.0897617,11.0606068,17.8362541,3573.9634327,11055.9329988,0.1973239,619.857339,323.1254407,776.9648395,21.8849222,42.961114,3.0842784,121.8075282),(47513,'ulna.tif',233,4,149,170.6518686,96.9524135,99.8535104,1.8,96.8166549,99.8904758,-0.1352033,11.9345512,18.2861084,3633.7676509,13600.473158,0.5167572,743.7598436,304.4745957,907.334682,21.4452857,42.631883,3.075573,124.584691),(47514,'ulna.tif',233,4,150,166.271256,97.0930517,100.0482345,1.8,96.9568934,100.4507408,-0.1476773,10.8614389,18.8519664,3341.0586297,13478.4790149,0.5999765,714.9640892,307.6073675,868.2982332,20.9330343,43.7352247,3.0611216,127.1412777),(47515,'ulna.tif',233,4,151,148.1875679,96.4858589,101.0751667,1.8,96.3456867,100.8414166,-0.1281365,10.1275939,20.2547733,2605.7465165,13279.255178,0.4033001,655.6111495,257.2917648,746.1784195,20.7752599,46.4541075,3.0961694,146.1049309),(47516,'ulna.tif',233,4,152,140.638219,96.0070476,101.7964897,1.8,95.1063988,101.8303273,-0.2073454,9.83007,23.1469481,2049.1786184,14758.6826191,0.9933632,637.6081432,208.4602269,700.2731779,21.1332947,50.0713738,0.0773104,152.8242305),(47517,'ulna.tif',233,4,153,133.0171845,94.2246351,103.8762693,1.8,92.7588479,104.5070651,-0.3477273,11.6962818,23.3413152,2207.6637751,19910.2524439,2.574298,853.0047369,188.7491959,921.6738095,10.1456118,18.3520783,1.2793395,51.3866037),(47518,'ulna.tif',233,4,154,121.5490222,92.2788105,105.7989,1.8,90.2729239,106.5581276,-0.3876777,9.5650774,22.3325134,1953.9541796,20128.7774506,2.8951725,901.3216336,204.2800182,965.3476141,11.601548,16.8932795,1.3611565,49.1419586),(47519,'ulna.tif',233,4,155,113.1283224,91.0638161,107.0730419,1.8,88.9378543,107.9156402,-0.3762012,9.1975858,23.1177635,1585.7465434,18273.2837286,2.5449241,790.4434051,172.4089964,856.6234651,13.9887484,29.6669223,0.7099116,86.6927183),(47520,'ulna.tif',233,4,156,103.0912881,90.5159162,107.9335273,1.8,88.9272106,108.7381453,-0.3444115,8.649133,23.3740366,1251.8078859,16413.4203709,1.9587804,702.2073533,144.732181,752.9263913,13.792993,28.2761695,0.6708575,82.18273),(47521,'ulna.tif',233,4,157,104.6243639,91.3389536,109.2133282,1.8,90.860314,109.9393935,-0.3043544,14.9487547,22.8242187,1531.2938529,15456.6342748,1.5659913,677.2032134,102.4362149,723.5073877,14.5908523,28.2827253,0.6086893,80.7764818),(47522,'ulna.tif',233,4,158,116.5130518,93.2568392,110.61457,1.8,93.2397732,110.9634281,-0.1873115,12.4094324,21.0947982,2246.9359147,16324.913405,0.6733907,773.8833635,181.0667761,842.8596463,15.3663764,30.3343262,0.5622848,85.2365005),(47523,'ulna.tif',233,4,159,140.1063447,95.1537432,111.8684681,1.8,95.8912585,111.9939785,-0.0764612,10.5261511,22.3066791,2521.1888528,16463.7115165,0.1362517,738.0619709,239.5166893,807.9421746,18.5154775,45.6570712,0.1157592,146.2609017),(47524,'ulna.tif',233,4,160,140.5543611,95.9368474,112.5728659,1.8,96.0771427,112.5180249,-0.0798589,11.6761297,23.0560634,2129.762105,14573.1503629,0.1490789,632.0745276,182.4030874,696.9032309,17.4277855,46.4408026,0.1290498,138.4765669),(47525,'femur.tif',233,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47526,'femur.tif',233,7,2,3.005289,99.6928203,107.7786105,1.8,99.9744218,107.3114389,-0.9328839,2.4572811,6.3715979,2.0038489,33.6566715,0.323247,5.2822968,0.815474,5.5723898,3.6579916,7.1185879,0.9964915,18.4664662),(47527,'femur.tif',233,7,3,35.6435046,101.288054,106.109283,1.8,101.5440376,105.9340664,-0.8415989,4.3040174,8.3946934,122.4317294,428.0407773,3.3034549,50.9894472,28.4459188,65.475103,8.7007156,17.1654444,0.9600704,42.7285309),(47528,'femur.tif',233,7,4,64.9731345,101.9609782,106.2156621,1.8,102.2038519,105.8040711,-0.7165216,6.7003787,10.7724741,410.0591418,1670.7168968,4.6709302,155.0912897,61.1993976,185.6233777,12.5629821,21.0291682,0.6669082,57.9706206),(47529,'femur.tif',233,7,5,89.0787802,103.1980852,106.2274645,1.8,103.0175857,105.6710298,-0.7417955,7.3620897,11.7862779,930.3443026,3295.8285201,6.7767068,279.6326833,126.369596,344.8288487,13.995686,24.1863414,1.0029523,68.2408729),(47530,'femur.tif',233,7,6,103.8473595,104.2534444,105.8226903,1.8,103.8248958,105.1754116,-0.8298206,8.1725442,13.3226134,1708.7184985,4607.8230694,9.4217936,345.8648025,209.0803607,469.512108,16.0828045,26.912295,0.99004,73.4539844),(47531,'femur.tif',233,7,7,110.0956161,104.8616606,105.5407603,1.8,104.4165799,104.9404239,-0.9069047,9.1973367,14.2981726,2399.3085486,5752.0247975,11.3823103,402.2909052,260.8699251,562.3522402,17.9445283,29.0671836,1.0096329,80.0733438),(47532,'femur.tif',233,7,8,113.3727036,105.1145578,105.1062703,1.8,104.8716893,104.8193665,-0.9744584,9.4975561,15.0310083,2936.8971003,7026.2444336,12.9355837,467.4499748,309.2266134,661.802242,19.0081139,30.334321,1.0085115,84.5833313),(47533,'femur.tif',233,7,9,117.1866465,105.2602499,105.0704372,1.8,105.2561796,104.8413152,-0.9868195,9.9523665,15.8106412,3521.0543386,8167.6000867,13.5939935,516.588796,353.790661,735.8883054,20.3021101,31.64058,0.9272952,90.6202038),(47534,'femur.tif',233,7,10,123.6858775,105.6250771,105.2299767,1.8,105.6226488,104.9390879,-0.9902421,10.6271485,16.3588309,4196.0213334,9340.1614604,14.4127344,570.9553149,394.8398152,820.9091505,21.7116443,32.6650101,0.9768236,94.0151868),(47535,'femur.tif',233,7,11,128.6508722,105.9813575,105.4248084,1.8,106.0131364,105.0996091,-0.9890564,11.687928,16.8811673,4945.1576741,10036.105481,14.9679581,594.5148984,423.0996021,877.455232,22.8414507,33.4039405,0.859887,94.7536446),(47536,'femur.tif',233,7,12,135.2310024,106.1246298,105.6805613,1.8,106.2644782,105.3041548,-0.9904517,11.8080624,16.7422634,5900.468231,10369.7422224,15.7623841,619.375168,499.6982598,958.1240126,23.8116511,33.6343979,0.8519663,96.5364393),(47537,'femur.tif',233,7,13,141.1386588,106.3760294,105.9926575,1.8,106.489993,105.6560641,-1.0704444,12.1675716,16.3086097,6778.5920875,10745.7499709,18.109382,658.9004301,557.1031208,1035.1769463,24.6296402,33.8231148,0.8148015,97.7367471),(47538,'femur.tif',233,7,14,144.5008776,106.5187501,106.2908678,1.8,106.7138099,105.9529239,-1.1869681,13.0232824,15.978777,7376.5302639,10906.0768327,20.7062545,682.5351405,566.4109903,1103.2573779,24.6856183,33.5829129,0.748378,95.9892861),(47539,'femur.tif',233,7,15,147.0234313,106.5265935,106.5022827,1.8,106.6447171,106.1042706,-1.3474963,13.7119106,15.9348494,8027.6516925,10818.1219326,23.3022429,678.8970284,585.4509958,1149.8422026,25.7921028,32.8178937,0.8005485,98.2692646),(47540,'femur.tif',233,7,16,149.0722009,106.4733614,106.6581732,1.8,106.4666013,106.2270956,-1.5159847,14.0952014,14.7031554,8707.1729501,10967.4069485,24.7707983,745.9219917,617.7402276,1226.7987757,27.1676099,31.7147118,0.942815,97.8573841),(47541,'femur.tif',233,7,17,150.8929549,106.5442362,106.4775788,1.8,106.2590265,106.0692415,1.3992566,15.4206187,35.80731,9086.4384552,11278.2295837,24.4160295,314.9700324,589.2395504,542.3587808,28.3108434,31.5329753,0.3887878,101.0110931),(47542,'femur.tif',233,7,18,154.2233009,106.4513456,106.3609998,1.8,106.0629401,106.0011923,1.3038903,15.73155,16.0555387,9312.1859156,11594.5309766,23.9158404,722.1514758,591.9433183,1300.5880753,28.9639532,31.3580692,1.9138203,101.4729431),(47543,'femur.tif',233,7,19,175.9844085,106.0476218,105.7488924,1.8,105.7330161,105.8030695,1.1905019,16.4273994,16.8251736,10174.5217364,13221.3370288,25.2894019,785.8068713,619.3629003,1383.7249971,29.7322379,32.332238,2.386954,103.6176488),(47544,'femur.tif',233,7,20,200.3488189,105.5370927,104.9803923,1.8,105.2176235,105.5461093,1.1417839,17.1754121,16.941242,11689.3044732,15434.8905376,27.6136282,911.0837654,680.5836374,1559.6398941,30.4682176,32.6119948,2.3028101,107.0126318),(47545,'femur.tif',233,7,21,207.8120601,105.249187,104.8646939,1.8,105.0300344,105.324195,1.0563607,17.9372567,17.9193185,13843.5442908,16148.8074253,26.2498885,901.1954019,771.7760055,1636.990191,31.6688714,33.5534574,2.5274332,110.3223116),(47546,'femur.tif',233,7,22,213.4704649,105.112905,105.4150405,1.8,104.8292432,105.3434033,0.4051292,16.8476501,18.0701633,15541.5796649,16450.6230744,5.5269061,910.3748972,922.4775929,1742.4415734,32.2566181,34.9304757,0.6998929,113.2554446),(47547,'femur.tif',233,7,23,226.2676905,104.8882033,105.6889208,1.8,104.6566382,105.3583649,-0.2285182,18.0733433,18.3773004,16575.5491202,18688.8791541,1.9352633,1016.9545458,917.1268869,1843.9902187,32.3858466,36.2910081,0.6202495,119.1363463),(47548,'femur.tif',233,7,24,228.2737634,104.6048232,105.5340927,1.8,104.4204059,105.3219827,-0.171619,17.4767289,19.5890109,16440.6389439,21229.8685621,1.1096032,1083.764189,940.7160262,1901.2800657,32.4998443,37.8986445,0.6472117,124.2288208),(47549,'femur.tif',233,7,25,230.0534311,104.0476308,105.6376821,1.8,103.5103008,105.216859,-0.0518419,17.3863918,39.358191,16456.3627677,25886.596824,0.1029559,657.7181557,946.5082187,1045.7473732,32.6365231,39.2381623,0.2167253,140.6212488),(47550,'femur.tif',233,7,26,293.0905304,95.796517,104.3626484,1.8,98.3479293,104.5661052,0.1368791,17.8380942,37.2470041,17610.8536703,97747.4533554,0.9095165,2624.3037693,987.2609422,3095.4950266,13.4305061,16.2214532,2.0926306,52.1250527),(47551,'femur.tif',233,7,27,388.3853948,89.2631876,103.5566904,1.8,94.402866,104.245335,0.145988,17.9687541,33.3544491,20342.2544239,159262.5479251,1.3698036,4774.851705,1132.090424,5350.6084105,17.9993963,24.7245834,2.6206829,78.3405186),(47552,'femur.tif',233,7,28,439.5070312,87.5934908,103.6550039,1.8,92.1346377,104.1812421,0.1492968,18.112343,35.3285841,24440.759674,185398.0971721,1.6206397,5247.82133,1349.3980145,5896.1380701,34.101514,68.6401735,3.028673,249.1547033),(47553,'femur.tif',233,7,29,450.8472491,87.6538108,103.94159,1.8,90.7239764,104.121142,0.1584657,18.3266592,35.4820828,28623.087599,198509.3153514,1.8711585,5594.6353693,1561.8278929,6325.8732833,34.3752044,70.3870673,3.031487,221.6889601),(47554,'femur.tif',233,7,30,443.9659197,87.0837858,103.7597139,1.8,89.6275193,104.0397616,0.1492179,18.4783095,36.3035837,30597.4117231,203452.1041056,1.6353653,5604.1878856,1655.8555689,6375.5426031,34.2664849,71.2969123,3.0527185,227.1933151),(47555,'femur.tif',233,7,31,444.5717265,86.1151468,103.4594492,1.8,88.4946203,103.8600503,0.1383839,31.4446141,37.6092745,32071.659722,209669.2487418,1.4098969,5574.9346811,1019.9412721,6360.9681531,33.9867263,73.2270818,3.0887573,232.9889136),(47556,'femur.tif',233,7,32,452.6326098,85.4027626,103.3445327,1.8,87.6626815,103.7832731,0.1418154,38.4217025,38.5109661,34001.930847,220987.0112891,1.5070523,5738.2879134,884.9667931,6579.46461,34.1779272,73.5327873,3.0362152,231.5826656),(47557,'femur.tif',233,7,33,462.1539464,84.9369498,103.2742859,1.8,87.115946,103.7575446,0.1461217,21.8882396,39.2096285,36301.6653662,231341.6591185,1.632946,5900.1237125,1658.5009144,6766.9761176,34.8548952,74.4199542,3.0611976,232.2358201),(47558,'femur.tif',233,7,34,467.2762449,84.5586795,103.2449005,1.8,86.5801815,103.8017799,0.1477025,19.9609768,40.6233954,37660.0359743,239469.5500989,1.6866987,5894.867916,1886.6830229,6766.3359534,35.7839311,74.895909,3.0428581,243.4151366),(47559,'femur.tif',233,7,35,464.7917063,83.7518426,103.0659541,1.8,85.8693252,103.7550726,0.1437375,21.7144227,40.7216818,38593.7798089,237705.2258116,1.5894768,5837.3135666,1777.3339077,6727.8824835,36.334599,75.5621163,3.0484054,264.538128),(47560,'femur.tif',233,7,36,459.5740143,83.4116182,103.0357102,1.8,85.1509254,103.7358552,0.1408762,19.8230471,41.1269783,39058.4179874,236728.3635336,1.5100958,5756.0358957,1970.3538946,6653.7954528,36.8570197,75.8804046,3.0534495,262.4640898),(47561,'femur.tif',233,7,37,452.935045,83.4902298,103.0333966,1.8,84.6500762,103.700447,0.1367729,20.2330612,41.3211575,39002.9063396,234680.9769182,1.4033794,5679.4386026,1927.6819219,6562.5335268,37.2276266,76.2622176,3.0492633,263.5437605),(47562,'femur.tif',233,7,38,447.8277653,83.6230412,103.0581471,1.8,84.3613674,103.7744109,0.1331799,20.9221207,41.2519036,38688.5105157,232155.7850641,1.3160371,5627.7593208,1849.1677312,6505.7398883,37.8550144,76.2954341,3.044675,264.417491),(47563,'femur.tif',233,7,39,441.8231423,83.9611179,103.1248125,1.8,84.2371457,103.8403337,0.1246352,35.1886338,41.1222733,38254.6930481,227961.7452044,1.1379639,5543.5102895,1087.1320921,6398.4901519,38.2187636,76.4709982,3.072578,269.0127818),(47564,'femur.tif',233,7,40,436.5612554,84.475553,103.2383786,1.8,84.1813798,103.9752484,0.1161797,42.5576263,40.7287289,37778.5635459,223980.8951821,0.9776855,5499.3342875,887.7037283,5959.7351914,38.7753339,76.2622176,3.0492633,277.0883588),(47565,'femur.tif',233,7,41,424.6482644,85.2674628,103.3982018,1.8,84.4482475,104.1006804,0.106391,30.4825044,40.0458396,36913.6050085,212336.2805683,0.7980844,5302.3305918,1210.9767791,6174.526825,38.8935822,75.91216,3.0488363,271.4633668),(47566,'femur.tif',233,7,42,413.111604,86.1844883,103.7240685,1.8,84.7319478,104.3682735,0.0920259,22.5038298,39.1555337,35457.2034316,200659.5973128,0.5814467,5124.6804362,1575.6075196,5980.4912383,38.7749711,75.444255,3.0669651,272.4577343),(47567,'femur.tif',233,7,43,382.5018958,89.4025914,104.8236709,1.8,86.8978544,105.266922,0.0200413,21.6244525,38.208965,31781.9522361,165922.2872032,0.0256021,4342.4962506,1469.7228652,5104.819535,35.087642,74.799308,3.0568901,260.1134438),(47568,'femur.tif',233,7,44,355.6322726,92.6448108,105.2611836,1.8,90.1907579,105.8710252,-0.0147566,21.4297433,35.3394177,30891.2374695,130502.9373101,0.0129061,3692.8434554,1441.5122494,4560.2720514,34.2842773,68.7571151,0.0767719,240.1700621),(47569,'femur.tif',233,7,45,349.3838287,93.7538253,105.5185752,1.8,91.6044731,106.1145068,-0.0317004,20.9647204,32.5529408,31095.2401189,118594.158482,0.0584973,3643.1165832,1483.217499,4593.0040306,33.7492683,64.848658,0.070535,228.6641683),(47570,'femur.tif',233,7,46,349.2037908,94.3857237,105.7757647,1.8,92.269038,106.2996953,-0.0502913,21.0983036,31.2924064,31644.8933106,113591.4759882,0.1470779,3630.0012967,1499.8785649,4625.2718451,33.7092068,62.799838,0.084071,223.4863906),(47571,'femur.tif',233,7,47,350.2967525,94.8359894,106.0502688,1.8,92.6303911,106.6181348,-0.0703402,33.9944559,31.1346425,32384.3239537,110395.9998992,0.288387,3545.7609614,952.6354559,3575.2535981,0.351562,0.4971837,2.3561945,0.9943675),(47572,'femur.tif',233,7,48,352.2267203,95.0926997,106.2856298,1.8,92.9111524,106.8010418,-0.0913672,43.4180712,30.0152681,33410.0656705,107128.7857585,0.4887005,3569.1430631,769.4967731,3231.3140972,33.5800266,59.364031,0.1008472,216.6464551),(47573,'femur.tif',233,7,49,352.1736115,95.4736419,106.5244059,1.8,93.4241556,107.0378132,-0.1193003,27.8485802,32.3291977,34046.0822475,103447.4578761,0.8314325,3199.8151886,1222.5428363,3393.9499686,0.351562,0.4971837,2.3561945,0.9943675);
INSERT INTO `slices_w` VALUES (47574,'femur.tif',233,7,50,350.9227093,95.6372411,106.757308,1.8,93.5995612,107.2399225,-0.1373604,20.2478,28.5537774,34394.7441388,99667.9406188,1.0966048,3490.5343466,1698.690434,4364.8904926,33.5749364,57.5800174,0.5456551,219.7501946),(47575,'femur.tif',233,7,51,353.3320791,95.8011998,106.9786812,1.8,94.0065546,107.4379211,-0.1602188,20.0936877,27.6207437,34853.1280642,96529.0331488,1.4987854,3494.8021027,1734.5311872,4172.3930606,33.4941771,57.5800174,0.5456551,210.0977631),(47576,'femur.tif',233,7,52,347.8995176,96.1069815,106.9893526,1.8,94.4220342,107.5189177,-0.1625754,19.5763852,27.1650408,34314.104694,91999.6138973,1.5190869,3386.6915357,1752.8315001,4061.6757597,0.351562,0.4971837,2.3561945,0.9943675),(47577,'femur.tif',233,7,53,349.6080241,96.3844406,107.0704654,1.8,94.9213275,107.6457102,-0.1612445,19.4827631,26.9755568,34370.0589707,88699.0288011,1.5018721,3288.1259633,1764.1265141,4019.5980462,0.351562,0.4971837,2.3561945,0.9943675),(47578,'femur.tif',233,7,54,347.1912385,96.5944659,107.0674822,1.8,95.4783975,107.6913777,-0.1752503,33.7861546,27.0969542,34174.3330096,83958.7240494,1.7590752,3098.4561341,1011.4892752,3220.5730606,33.4653839,56.5140699,0.5137449,190.0544424),(47579,'femur.tif',233,7,55,352.4685936,96.7998713,107.2125926,1.8,96.0449881,107.8196042,-0.1850896,39.7637894,27.372755,34525.5737781,80259.8994582,1.9896108,2932.1089305,868.266689,2727.5459599,0.4971837,0.9943675,2.3561945,1.988735),(47580,'femur.tif',233,7,56,363.8546918,97.0431067,107.4195453,1.8,96.4711538,108.0439217,-0.1923879,39.1539107,27.921394,35378.9815298,78970.858393,2.2170091,2828.3279257,903.587429,2769.086843,33.3754202,55.6679306,0.4438762,181.1904382),(47581,'femur.tif',233,7,57,369.3044818,97.0568011,107.5155224,1.8,96.6245689,108.0939894,-0.218594,39.5631665,28.1414793,35816.6799512,75537.3070295,2.8945526,2684.1981656,905.3036725,2704.4575077,33.349335,55.6890188,0.4297623,184.9119985),(47582,'femur.tif',233,7,58,369.0841067,97.1177602,107.6369489,1.8,96.7943822,108.3005464,-0.2458331,35.3790401,28.3001136,35950.309909,72936.0777248,3.6432442,2577.2362196,1016.147127,2730.3142842,0.7870085,1.75781,2.4980915,3.6862265),(47583,'femur.tif',233,7,59,358.9681617,97.1099517,107.4052112,1.8,96.8307263,108.2582443,-0.2576259,26.5207071,28.3594082,35312.9308378,70491.7272175,3.8837747,2485.6557928,1331.5229779,3269.576284,33.308453,55.3696199,0.4324078,152.1624763),(47584,'femur.tif',233,7,60,355.5524222,97.2568481,107.2384277,1.8,97.0668685,108.208104,-0.2599438,20.049873,28.4505965,34954.2416826,68746.1840889,3.9147784,2416.3354189,1743.3647386,3530.9605928,0.7783414,1.75781,0.9272952,3.6862265),(47585,'femur.tif',233,7,61,348.4274216,97.4026198,107.010552,1.8,97.1512103,108.1072056,-0.2622264,20.535461,28.4162295,34225.1569906,65765.3391343,3.9024416,2314.3583926,1666.6368943,3411.3450159,0.7870085,2.0499411,2.1112158,4.3893505),(47586,'femur.tif',233,7,62,340.4607334,97.5153608,106.6934415,1.8,97.3477245,107.8729289,-0.2627682,19.2673666,28.3371884,33390.4456225,62844.632597,3.8286249,2217.7441077,1733.0051535,3287.146227,32.8947207,53.9724962,0.4228539,146.7787583),(47587,'femur.tif',233,7,63,338.3186302,97.6738657,106.4487879,1.8,97.5804608,107.6481591,-0.2579852,18.5566317,28.1837469,32858.0175123,60756.1764511,3.6703534,2155.7167896,1770.6886715,3221.8681535,0.351562,0.7861165,2.0344439,1.6974915),(47588,'femur.tif',233,7,64,335.1009062,97.7018971,106.1846444,1.8,97.704559,107.4315421,-0.2429303,18.745578,27.6637213,32216.9110192,58275.5861519,3.2316744,2106.570751,1718.6405809,3176.7963486,0.6680513,1.5722331,2.0344439,3.394983),(47589,'femur.tif',233,7,65,329.8488695,97.8914863,105.8514856,1.8,97.8459294,106.9988902,-0.230332,18.1074537,27.256813,31104.8415955,55706.7229046,2.8653563,2043.772431,1717.7921395,3086.6240025,1.406248,2.55941,1.2924967,7.0812095),(47590,'femur.tif',233,7,66,323.648216,97.955813,105.5819052,1.8,97.861125,106.7341394,-0.2158731,18.551186,26.5978821,30056.4491262,52933.3196745,2.4749258,1990.1328776,1620.1901686,3015.1033631,2.3878337,8.1544198,1.4410938,24.3827017),(47591,'femur.tif',233,7,67,319.3016125,98.1194117,105.3062723,1.8,98.0250092,106.4188785,-0.2139373,18.5043546,26.2351872,29122.8734265,50219.4516919,2.39876,1914.2021469,1573.8389143,2936.8758966,0.703124,2.8343835,1.6951513,6.207479),(47592,'femur.tif',233,7,68,315.286096,98.2639335,105.0206817,1.8,98.2040156,106.1597477,-0.2063592,18.8637862,25.6261335,28379.239209,47222.106913,2.2061128,1842.732419,1504.4296442,2857.2863392,1.054686,2.1384682,1.735945,5.2984147),(47593,'femur.tif',233,7,69,313.6488631,98.2114078,104.7619567,1.8,98.1243966,105.9021055,-0.1997023,17.6381359,24.9580183,27762.3972262,45200.1977889,2.0572053,1811.0491517,1573.9983775,2849.7125874,31.1023611,46.4753795,0.3073975,127.0413168),(47594,'femur.tif',233,7,70,311.2489316,98.3342219,104.4424554,1.8,98.3305578,105.6163528,-0.1764474,17.6145071,24.118082,27280.5790157,42245.6631795,1.5983625,1751.6178615,1548.7563073,2775.4184887,1.620545,5.3200984,1.4382448,12.414958),(47595,'femur.tif',233,7,71,309.6469797,98.3123447,104.2284666,1.8,98.31997,105.4141909,-0.1735898,17.9186042,23.4853583,26833.2050114,40068.5287326,1.5395628,1706.1067711,1497.5053127,2747.8124082,0.9682273,2.3583496,2.0344439,5.383718),(47596,'femur.tif',233,7,72,306.2624387,98.3635232,103.931407,1.8,98.4862413,105.0836837,-0.1611746,17.4179607,22.6951735,26337.0029648,38048.5935597,1.3145335,1676.5059568,1512.0600718,2729.9857207,30.3494855,42.4706685,0.3112797,118.3479191),(47597,'femur.tif',233,7,73,300.9626865,98.5204289,103.5931176,1.8,98.5996092,104.6469245,-0.1517019,22.0096341,21.9851743,25687.6672767,35628.8928747,1.1455378,1620.5872374,1167.1101458,2102.9057381,0.703124,0.9943675,2.3561945,1.988735),(47598,'femur.tif',233,7,74,301.7998049,98.6296798,103.3433485,1.8,98.6645826,104.314829,-0.1349629,17.5155447,20.8837457,25299.2819734,33898.0488798,0.9106634,1623.1785864,1444.3902493,2722.6650035,29.9400936,39.5018668,0.2795222,113.3407478),(47599,'femur.tif',233,7,75,300.5748203,98.6841907,103.1227736,1.8,98.8144826,104.115822,-0.1010215,20.4001889,20.0031171,24985.9126878,32182.0765896,0.5095083,1608.8530829,1224.7882983,2757.5504363,29.779052,37.9116871,0.330548,110.4429486),(47600,'femur.tif',233,7,76,300.0989763,98.7410241,102.8676208,1.8,98.9301133,103.8577875,-0.083734,16.8149054,19.673196,24633.0670604,30553.523046,0.3498654,1553.0533516,1464.9542427,2754.7428033,29.6484254,36.584414,0.3430239,108.5395168),(47601,'femur.tif',233,7,77,297.2694181,98.8573034,102.6156558,1.8,99.1278454,103.565035,-0.0625936,17.0319588,18.7770302,24306.9387945,28980.8483895,0.1938617,1543.4202401,1427.1370125,2717.996148,29.5492419,35.5147229,0.3749917,106.5507818),(47602,'femur.tif',233,7,78,297.9865361,98.8847554,102.4131069,1.8,99.1214889,103.3100686,-0.0113229,17.1476356,18.7819182,24139.52478,27801.4344863,0.0063671,1480.2233854,1407.7465434,2686.0577855,29.4990818,34.4835551,0.4089078,104.6473501),(47603,'femur.tif',233,7,79,298.1332781,98.9100288,102.1972546,1.8,99.1337853,103.1867963,0.0529466,16.8904533,17.7617529,23878.0743327,26948.5233575,0.1391649,1517.2220658,1413.7023958,2715.4062754,29.4771671,33.4944688,0.3649131,103.7382858),(47604,'femur.tif',233,7,80,301.8523893,98.9588024,101.9421986,1.8,99.2274473,102.785523,0.1184786,16.7043516,17.0654127,23694.1884149,26373.0492143,0.7028941,1545.4094041,1418.4440686,2768.5573773,29.3589294,32.7764403,0.3964413,102.3320378),(47605,'femur.tif',233,7,81,302.7368486,98.998472,101.6900867,1.8,99.2497751,102.4824381,0.2617247,16.9056317,16.7845218,23246.255886,25437.9144273,3.378036,1515.5578859,1375.0598787,2728.8101607,29.2302029,32.1616788,2.8647945,101.6289138),(47606,'femur.tif',233,7,82,301.3377063,99.0036566,101.4246859,1.8,99.1435363,102.1611623,0.3439697,16.2043334,16.6726322,22651.8907221,24653.7184068,5.7114529,1478.6938285,1397.89093,2720.3750286,29.179646,31.6893704,2.8373842,99.9314223),(47607,'femur.tif',233,7,83,302.9529541,99.0147835,101.2003615,1.8,99.1423607,101.9658821,0.4607364,16.5014003,16.8015718,22202.8278842,24189.3140988,9.9810963,1439.705431,1345.5117462,2664.0491238,29.0949317,31.2732135,2.7736117,98.7311146),(47608,'femur.tif',233,7,84,305.1967055,99.0209944,101.0590213,1.8,99.1777829,101.7199809,0.5515971,16.2912696,16.9916626,21735.5977222,24002.7783102,13.9691792,1412.6209331,1334.1868508,2657.5478197,29.0132944,30.8894785,2.9352688,98.1132938),(47609,'femur.tif',233,7,85,305.7551714,98.9638962,100.9017332,1.8,99.1927784,101.5687543,0.6396036,15.9940788,16.7200758,21354.1983298,23649.1085901,18.1548611,1414.4139582,1335.1314962,2593.9439123,28.9114456,30.6182045,2.7653506,97.1189263),(47610,'femur.tif',233,7,86,305.6046841,98.9658981,100.6952371,1.8,99.258149,101.2637634,0.7317101,16.2363225,16.5155921,20900.2551455,23325.7080072,22.7377545,1412.3446427,1287.2530173,2610.3716736,28.828084,30.1872842,2.8824906,96.3304991),(47611,'femur.tif',233,7,87,308.9512474,99.0137612,100.4333483,1.8,99.2567338,100.9976689,0.7819431,15.3968875,16.8313809,20660.2312654,23030.3414396,25.5680332,1368.2977971,1341.8446552,2561.3875789,28.4615057,29.9653763,2.756729,96.2098621),(47612,'femur.tif',233,7,88,305.7620628,98.9869164,100.3081021,1.8,99.2501252,100.8139546,0.849724,15.2024042,16.2450929,20004.8976371,22751.743147,28.7492052,1400.5301927,1315.9035481,2498.2332671,28.1376005,29.7085491,2.7786669,94.9242511),(47613,'femur.tif',233,7,89,304.2958416,99.0172077,100.093546,1.8,99.2249868,100.5721502,0.9039263,15.1118896,16.6832196,19363.6923616,22341.3747834,31.3131117,1339.1524741,1281.3548074,2499.8212666,27.8748266,29.4473838,2.5602125,94.2211271),(47614,'femur.tif',233,7,90,303.9950543,99.0548155,99.9603315,1.8,99.2396468,100.4244423,0.9571559,15.1931883,16.7343703,18912.4996881,22071.2881373,33.8650281,1318.9195483,1244.8012475,2396.8688385,27.4984124,29.3233057,2.2286849,93.8092466),(47615,'femur.tif',233,7,91,303.3517941,99.0619245,99.8223655,1.8,99.1913012,100.2128853,0.9954426,15.2480007,16.3464276,18563.0891493,21739.3905601,35.5892746,1329.9169143,1217.411352,2445.8825116,0.351562,0.4971837,2.3561945,0.9943675),(47616,'femur.tif',233,7,92,301.3128747,99.0936194,99.6255684,1.8,99.2804253,99.9599695,1.0404812,14.9902848,16.4326656,18113.6922524,21434.6634463,37.3708885,1304.3935771,1208.3621133,2328.5817747,26.9647913,29.1817638,2.2022498,92.0264518),(47617,'femur.tif',233,7,93,299.44463,99.0901317,99.4481609,1.8,99.2284186,99.7508175,1.0779137,14.2650561,16.1337731,17738.424653,21089.9473594,38.7337937,1307.1925123,1243.4879012,2391.9062707,26.7941026,28.9905452,2.2531129,91.8205116),(47618,'femur.tif',233,7,94,299.0031307,99.1118904,99.2962171,1.8,99.2573435,99.6312581,1.1043766,14.2390766,16.2262285,17428.295387,20886.0832088,39.7563373,1287.1803915,1223.9765177,2360.0416134,0.351562,0.7861165,2.0344439,1.6974915),(47619,'femur.tif',233,7,95,298.9560519,99.1520798,99.1703688,1.8,99.3520039,99.4893144,1.1398442,14.8530861,16.0270475,17164.1611275,20777.4958741,41.1312005,1296.4019648,1155.5956137,2348.4677921,26.2943035,28.8409432,1.7299331,91.1173876),(47620,'femur.tif',233,7,96,298.1906565,99.1876924,99.0193703,1.8,99.3626413,99.2951339,1.15957,14.865201,16.0157909,16839.74138,20679.2742496,41.7572763,1291.1803351,1132.8297157,2341.4129919,26.1040501,28.8302276,1.8423959,90.3289604),(47621,'femur.tif',233,7,97,297.5712541,99.3011473,98.8073844,1.8,99.4992315,99.1304945,1.1932759,14.6763374,16.6357068,16407.9920076,20539.963783,42.8562989,1234.6913801,1117.9895645,2220.9972943,26.0220668,28.8302276,1.8423959,90.3289604),(47622,'femur.tif',233,7,98,297.3764221,99.320474,98.6716917,1.8,99.5050988,98.9250691,1.2197455,14.8415307,16.6287497,16105.9394687,20406.5714911,43.7016124,1227.1861621,1085.1939599,2195.7184931,25.7813802,28.907291,1.8039761,90.4142636),(47623,'femur.tif',233,7,99,296.7494916,99.3524154,98.5126229,1.8,99.5508115,98.770794,1.2350405,14.6924853,16.0857614,15841.4993462,20292.7919982,44.0891132,1261.5375477,1078.2042012,2229.4057805,25.6316665,28.8987386,1.7419449,89.9170798),(47624,'femur.tif',233,7,100,296.2525989,99.3994112,98.3492305,1.8,99.5605355,98.5296342,1.2377871,14.5229141,15.9966278,15623.2884992,20263.950213,44.0993715,1266.7638744,1075.7681509,2016.3164524,0.351562,0.4971837,2.3561945,0.9943675),(47625,'femur.tif',233,7,101,297.1258971,99.4370202,98.2104727,1.8,99.6184413,98.4461535,1.2570165,14.5606608,15.9228464,15484.3536025,20268.8584279,44.8031897,1272.9419021,1063.4375617,2231.4624174,25.4730152,28.9606866,1.7539071,89.9170798),(47626,'femur.tif',233,7,102,297.317995,99.4677161,98.0518257,1.8,99.620484,98.2382675,1.2741955,14.3306362,15.9631592,15316.4855804,20307.7823006,45.320062,1272.1656163,1068.793137,2219.8749836,25.1592828,29.0267608,1.7658166,88.9227124),(47627,'femur.tif',233,7,103,296.4978804,99.5044129,97.9012224,1.8,99.6496619,98.0902353,1.2873548,14.519378,15.9658618,15134.6302427,20351.0071256,45.551435,1274.6576049,1042.3745576,2194.078978,0.351562,1.1117367,1.8925469,2.4006155),(47628,'femur.tif',233,7,104,296.298217,99.5267773,97.7587119,1.8,99.65118,97.9108635,1.3052502,14.4949272,15.9385058,14989.063318,20369.821024,45.9818874,1278.0257658,1034.0902767,2111.8375913,25.1583903,29.1711734,1.7894653,88.9227124),(47629,'femur.tif',233,7,105,295.9909502,99.5890045,97.5603059,1.8,99.7488008,97.75177,1.3129802,14.0498494,15.9973086,14782.7974622,20276.9046051,46.1247922,1267.5197498,1052.1676837,2074.5514633,25.0015241,29.2494513,1.8011988,88.7167721),(47630,'femur.tif',233,7,106,296.9426756,99.6018563,97.4565828,1.8,99.7369485,97.6738302,1.3279861,14.3187497,16.1001994,14684.8769725,20370.542079,46.6295393,1265.235389,1025.5697808,1970.7779095,0.351562,0.7861165,2.0344439,1.6974915),(47631,'femur.tif',233,7,107,298.3850391,99.5886743,97.363405,1.8,99.7946003,97.5699412,1.3429649,14.4243557,16.0982133,14648.5072046,20488.5425722,47.1938089,1272.7215232,1015.5397965,2090.320997,0.351562,0.4971837,2.3561945,0.9943675),(47632,'femur.tif',233,7,108,298.9928685,99.5719939,97.2857946,1.8,99.7966818,97.4760136,1.3657844,14.256213,16.1401298,14639.3295896,20685.0370566,47.7668834,1281.5904996,1026.8736593,2168.7933949,0.8346699,5.3200984,1.4382448,11.4205905),(47633,'femur.tif',233,7,109,299.3903976,99.5351713,97.2370474,1.8,99.7319251,97.4311713,1.3978277,13.8185421,16.3085957,14645.9007071,21000.103228,48.420361,1287.6708442,1059.8730715,2176.946195,0.351562,0.4971837,2.3561945,0.9943675),(47634,'femur.tif',233,7,110,301.0946719,99.4994822,97.2211928,1.8,99.6298703,97.4308464,1.4337435,14.4295374,16.4193181,14733.306904,21379.0765807,49.2457311,1302.0684789,1021.0519235,2198.3746955,1.406248,6.6889232,1.6233794,15.0215137),(47635,'femur.tif',233,7,111,302.0536258,99.5145931,97.1870989,1.8,99.6307666,97.4186221,1.4554835,14.4095869,16.4583833,14765.783893,21750.0574244,49.6758296,1321.5184641,1024.7194429,2218.5731731,0.703124,6.6889232,1.6233794,14.2330865),(47636,'femur.tif',233,7,112,306.4755853,99.425487,97.2399334,1.8,99.4651739,97.53314,1.500553,13.9062049,16.6050519,14969.7497605,22422.3639702,50.8276469,1350.3338652,1076.4798814,2241.9609902,1.054686,6.3378741,1.6262948,14.1124495),(47637,'femur.tif',233,7,113,307.7071242,99.4489605,97.1076826,1.8,99.5294216,97.4013206,1.5323188,14.2333094,16.8417247,14932.3760723,22608.9950752,51.2086307,1342.4394136,1049.1148367,2226.5458168,1.4785264,6.0177721,1.6879051,16.6836715),(47638,'femur.tif',233,7,114,305.7473437,99.4911946,96.9467805,1.8,99.5599259,97.2446132,1.5414361,14.147679,16.6625357,14828.9139979,22588.9750133,50.9139763,1355.6745179,1048.1517136,2235.0682004,1.1791677,5.2263449,1.9138203,12.5855645),(47639,'femur.tif',233,7,115,304.6589137,99.4949346,96.8246402,1.8,99.5741502,97.078864,1.5472725,13.8316895,16.7665358,14765.4320378,22691.7084334,50.7483924,1353.3927758,1067.5074788,2226.718522,2.121955,10.7844186,1.9028558,27.6570477),(47640,'femur.tif',233,7,116,304.8322101,99.4817234,96.7297152,1.8,99.5494087,96.9978761,1.5473008,13.8507822,16.9863023,14755.7218443,22754.0829334,50.7773268,1339.5548091,1065.3349125,2186.4542336,1.9072296,12.7049662,1.8224863,33.9498299),(47641,'femur.tif',233,7,117,306.0091796,99.4605459,96.6155852,1.8,99.5203152,96.9213065,1.555813,15.2678979,16.9480462,14821.0511452,22849.723774,50.9900811,1348.2217098,970.7329213,1976.0192063,1.7429139,11.3484301,1.8533513,28.4808087),(47642,'femur.tif',233,7,118,306.1533373,99.491581,96.4850638,1.8,99.4669647,96.8083459,1.5582782,13.769485,16.7143832,14809.4058,22953.1634301,51.0175609,1373.2581784,1075.5235797,2232.3767963,1.5865575,6.0689011,1.7454685,15.9805475),(47643,'femur.tif',233,7,119,306.7396684,99.5079535,96.3115222,1.8,99.526026,96.5492934,1.5555171,13.7629882,16.5484489,14842.3330591,22911.073335,51.111344,1384.4846398,1078.4237314,2254.2693669,1.5345568,5.3778645,1.7681919,15.1921202),(47644,'femur.tif',233,7,120,306.0321384,99.5502001,96.0915329,1.8,99.5726216,96.3056652,1.5376696,13.7888136,16.7603918,14767.5882682,22653.8479605,50.9494043,1351.6299773,1070.9832388,2208.0597528,24.257778,31.0988335,1.3889206,91.1527214),(47645,'femur.tif',233,7,121,304.6769288,99.6414612,95.7975161,1.8,99.673671,95.9501913,1.5097114,14.2113461,16.662051,14595.6067626,22085.465386,50.5902468,1325.4950024,1027.0390037,1974.7667569,0.351562,0.4971837,2.3561945,0.9943675),(47646,'femur.tif',233,7,122,303.9268144,99.6692537,95.5879894,1.8,99.7361305,95.7071462,1.4855741,13.9640559,16.5150287,14482.830716,21645.1621596,50.2874643,1310.6342476,1037.1507282,1955.6926845,1.9473522,14.340972,1.7681919,33.1967365),(47647,'femur.tif',233,7,123,302.7543768,99.6598288,95.3436182,1.8,99.7470452,95.4218153,1.472934,13.8245709,16.1798504,14380.0931618,21170.2763231,49.977355,1308.4346186,1040.1836875,1940.2099969,1.3162612,8.6186484,1.7761917,19.4961675),(47648,'femur.tif',233,7,124,301.6897671,99.6366085,95.0574791,1.8,99.7329012,95.1895078,1.4599038,13.7314833,16.1939568,14417.4568003,20587.2957722,49.6658377,1271.2949671,1049.956258,2160.4476685,0.351562,0.4971837,2.3561945,0.9943675),(47649,'femur.tif',233,7,125,301.2413764,99.6152747,94.8517185,1.8,99.653433,94.9925758,1.456016,13.7318455,15.8924311,14428.0564667,20358.9859738,49.548344,1281.0491904,1050.7004669,1953.2101671,1.054686,3.1835293,1.6814535,7.49309),(47650,'femur.tif',233,7,126,302.451155,99.5938847,94.7081135,1.8,99.6508103,94.7115747,1.4507393,13.7802759,16.116835,14388.8852705,20413.5272923,49.6854377,1266.596531,1044.1652515,2159.0652907,0.703124,0.9943675,0.7853982,1.988735),(47651,'femur.tif',233,7,127,302.9120551,99.5669126,94.4966097,1.8,99.6505918,94.5526721,1.4374405,14.0853047,16.1379716,14347.5579927,20278.1778488,49.5928325,1256.5506001,1018.6189286,2049.2403014,24.257778,28.7873254,1.7178747,87.3458579),(47652,'femur.tif',233,7,128,301.6296921,99.5580527,94.3154968,1.8,99.6041423,94.3826412,1.4277636,13.6224332,15.5061463,14291.4503297,20041.9573417,49.2501347,1292.5169793,1049.1114275,2173.6704846,0.6680513,1.8932193,1.9513027,4.098107),(47653,'femur.tif',233,7,129,302.045461,99.6140273,94.0974531,1.8,99.7274831,94.1840714,1.4199232,13.6277195,16.2481168,14206.7495384,19737.080148,49.2036841,1214.7303246,1042.4891359,2079.9310697,1.406248,3.33521,1.2490458,9.2758847),(47654,'femur.tif',233,7,130,301.4414519,99.6121582,93.9305085,1.8,99.7613837,94.0062814,1.4146406,13.6540099,15.5272024,14125.6650249,19568.4416691,49.0250793,1260.2683418,1034.5433414,2005.067001,1.003066,3.2412415,1.3521274,7.49309),(47655,'femur.tif',233,7,131,299.921223,99.626566,93.7915763,1.8,99.7860797,93.8785765,1.4151097,13.56403,15.424136,14047.3274933,19382.1234679,48.7850295,1256.6099949,1035.6308192,2147.4894991,1.1943753,2.2510952,0.6747409,5.4690212),(47656,'femur.tif',233,7,132,297.6792694,99.6174656,93.6507263,1.8,99.7623055,93.7149034,1.4100231,13.7299586,15.5846146,13942.8196185,19269.6849125,48.3418193,1236.4556568,1015.5033961,1917.7681137,0.703124,2.2234733,1.2490458,4.801231),(47657,'femur.tif',233,7,133,297.4306919,99.5803839,93.4697173,1.8,99.7095998,93.5301367,1.3968638,13.549583,15.6301711,13898.8135808,19170.6076388,48.0871717,1226.5129744,1025.7742715,2100.1071012,0.6822382,1.8932193,1.9513027,4.098107),(47658,'femur.tif',233,7,134,294.0365255,99.5714853,93.327304,1.8,99.6753042,93.3550731,1.3979219,13.6269071,15.5473442,13837.3532358,19002.8248787,47.5560442,1222.2553661,1015.4434283,2097.0102412,0.351562,0.7861165,2.0344439,1.6974915),(47659,'femur.tif',233,7,135,291.6988038,99.5469111,93.1955271,1.8,99.6313691,93.2353366,1.3951576,13.5967715,15.4357694,13787.1597467,18876.4837422,47.1320586,1222.905273,1014.002459,2098.1451493,0.351562,0.7861165,2.0344439,1.6974915),(47660,'femur.tif',233,7,136,291.3068177,99.5065384,93.0385278,1.8,99.5502738,93.0854657,1.3777585,13.652855,15.3691484,13792.7520762,18809.3215739,46.7643068,1223.8362903,1010.246728,2090.1749407,0.351562,1.1117367,1.8925469,2.4006155),(47661,'femur.tif',233,7,137,288.6951253,99.5350354,92.8399502,1.8,99.6116255,92.9104178,1.3699301,13.6152767,15.3325399,13647.4756257,18571.2314775,46.2004815,1211.2299476,1002.3649139,1999.3142,1.3804113,4.4469466,1.8925469,11.591197),(47662,'femur.tif',233,7,138,284.8647778,99.5526427,92.7524138,1.8,99.6939402,92.830436,1.3700146,13.5189556,15.3570091,13552.8020597,18334.1193052,45.5890708,1193.8600313,1002.5036278,2070.8964575,1.054686,2.2234733,1.8925469,5.7955985),(47663,'femur.tif',233,7,139,282.044508,99.5377053,92.6608743,1.8,99.6320977,92.717269,1.3647418,13.7048323,15.2395609,13504.4181641,18134.3170124,45.0396433,1189.9501033,985.3763911,2059.8726639,1.3529214,3.5331544,1.670465,9.2758847),(47664,'femur.tif',233,7,140,280.0839035,99.4979076,92.5378525,1.8,99.5849856,92.5489935,1.3513332,15.2027425,15.2903944,13445.3196926,18083.9242644,44.4681854,1182.6983502,884.4009347,2048.4598573,1.054686,2.55941,1.2924967,6.5840257),(47665,'femur.tif',233,7,141,277.9094781,99.4792508,92.4267659,1.8,99.5648088,92.4917629,1.3459936,13.6059149,15.5826836,13388.965552,18052.675413,44.016662,1158.5087566,984.0547771,1964.9374608,0.703124,2.2234733,1.8925469,4.801231),(47666,'femur.tif',233,7,142,275.2670365,99.4815336,92.3342473,1.8,99.5999236,92.3764426,1.3424331,14.034156,15.3278777,13391.9348448,17926.1856934,43.5266231,1169.5151832,954.2387039,2034.9099625,1.2737257,5.798109,1.815775,13.9918125),(47667,'femur.tif',233,7,143,273.4582301,99.4596818,92.1999927,1.8,99.4975607,92.1961005,1.330548,14.3022056,15.3554113,13370.1617329,17916.5249908,42.9959621,1166.789001,934.8321614,1991.8932467,1.0416279,2.55941,1.2924967,6.086842),(47668,'femur.tif',233,7,144,268.8145471,99.5159299,92.1548182,1.8,99.5505374,92.1774499,1.3299552,13.9324867,15.8048559,13344.3965089,17782.012172,42.2535437,1125.098028,957.790004,1964.1215786,1.6694972,4.3485818,1.815775,11.591197),(47669,'femur.tif',233,7,145,267.003119,99.5623187,92.0138357,1.8,99.5868492,92.022052,1.320211,13.4768671,15.3789913,13343.0091748,17559.402377,41.7641981,1141.7785521,990.0675749,1951.9922283,1.3133301,3.670415,1.8622531,9.602462),(47670,'femur.tif',233,7,146,265.5436769,99.5691221,91.8953339,1.8,99.6109413,91.9111168,1.3042079,13.77686,15.2636071,13346.7161369,17493.9225823,41.1857525,1146.1198148,968.7778038,1966.7115202,1.054686,2.55941,1.849096,5.7955985),(47671,'femur.tif',233,7,147,262.5681258,99.5754688,91.7812503,1.8,99.652151,91.8052834,1.2881366,13.4966659,15.7349196,13305.2895277,17424.0490334,40.3571034,1107.3490987,985.8204739,1929.49466,0.703124,2.55941,1.849096,5.504355),(47672,'femur.tif',233,7,148,260.3201047,99.5648834,91.6745795,1.8,99.576993,91.6897633,1.2764889,13.9290658,15.5000518,13305.8756249,17412.6783064,39.7359227,1123.3948482,955.2597304,1980.717425,0.351562,1.7926215,1.7681919,3.8068635),(47673,'femur.tif',233,7,149,258.2371777,99.5598965,91.5680955,1.8,99.5661802,91.5948069,1.2620027,14.6168348,15.2956335,13341.0553142,17365.834529,39.0643562,1135.3458864,912.7184868,1993.984844,0.351562,0.4971837,2.3561945,0.9943675),(47674,'femur.tif',233,7,150,255.0998284,99.5579394,91.4959967,1.8,99.5568101,91.5295954,1.2496826,13.7092949,15.3367984,13392.5628543,17269.6450603,38.2812053,1126.0267338,976.8965467,1972.1586708,0.351562,0.4971837,2.3561945,0.9943675),(47675,'femur.tif',233,7,151,253.0456281,99.5352735,91.4057148,1.8,99.4840822,91.4076918,1.2265831,13.6842723,15.427544,13455.786869,17218.2778152,37.3716064,1116.0738095,983.3030661,1984.3375153,0.6944674,3.2412415,1.7894653,6.910603),(47676,'femur.tif',233,7,152,252.1390713,99.5035281,91.2916295,1.8,99.4894822,91.3013244,1.1917153,13.65619,15.3142521,13558.8845624,17213.4928349,36.2681245,1124.0178547,992.8746281,1990.8330251,0.6292498,1.2675748,2.1587989,2.691859),(47677,'femur.tif',233,7,153,249.7975669,99.5163375,91.1579845,1.8,99.4621323,91.209805,1.1529963,13.866201,15.2455412,13536.1253092,17080.2853572,34.7787491,1120.3462759,976.1956657,1965.1033619,0.351562,0.4971837,2.3561945,0.9943675),(47678,'femur.tif',233,7,154,249.1828836,99.4628546,91.0273811,1.8,99.4332858,91.0603541,1.1110198,14.7751263,15.2945495,13556.4966408,17085.7830469,33.3526238,1117.1158067,917.5215382,1973.3521116,0.351562,0.4971837,2.3561945,0.9943675),(47679,'femur.tif',233,7,155,248.1187234,99.4377387,90.910352,1.8,99.4061458,90.9251179,1.099802,14.0130044,15.5675463,13536.6892338,17114.0996257,32.8381182,1099.344709,966.0090636,1966.21023,0.351562,0.4971837,2.3561945,0.9943675),(47680,'femur.tif',233,7,156,245.2868431,99.4456671,90.8628996,1.8,99.387684,90.8577117,1.0809324,14.1532736,15.2668272,13615.708285,17022.1716969,31.8310497,1114.9776892,962.0183032,1829.8925579,1.3100768,5.3778645,1.7681919,12.997445),(47681,'femur.tif',233,7,157,245.511825,99.4191239,90.7938875,1.8,99.2441301,90.8105111,1.0351671,14.0707133,15.4104159,13762.8228615,17117.4728635,30.2597402,1110.7729357,978.1183491,1848.5947965,0.9438747,1.75781,2.2142974,3.6862265),(47682,'femur.tif',233,7,158,245.101337,99.4040042,90.7117051,1.8,99.2813178,90.6926529,1.0015345,14.0550893,15.1417217,13857.1310068,17203.071328,28.9819162,1136.1370679,985.9155461,1862.5969624,1.054686,2.4859187,1.7126934,6.669329),(47683,'femur.tif',233,7,159,244.3864287,99.4342498,90.6584853,1.8,99.3228581,90.6403614,0.9675857,14.1119664,15.2785814,13963.4925644,17195.4000284,27.62311,1125.4578907,989.4788669,1972.4555024,0.6944674,2.55941,1.849096,5.504355),(47684,'femur.tif',233,7,160,245.2403635,99.3964575,90.6104029,1.8,99.1514602,90.6081916,0.9412519,14.3189589,15.1219062,14171.2973175,17275.0515012,26.7043106,1142.3858359,989.6876899,1957.4542577,0.703124,2.1384682,1.735945,4.801231),(47685,'femur.tif',233,7,161,244.9366174,99.4255018,90.5059215,1.8,99.2850195,90.4746017,0.9018595,13.9748522,15.8820321,14194.3133202,17309.9611029,25.1227864,1089.9084555,1015.7040031,1911.7598434,25.604963,28.6172332,2.2167544,88.4255286),(47686,'femur.tif',233,7,162,242.9490839,99.4156783,90.4381791,1.8,99.3505909,90.4379069,0.8689846,14.6245865,15.8297659,14216.1257695,17340.7869602,23.6145568,1095.454416,972.0702724,1942.6075059,25.8535549,28.7185487,2.2608324,88.8374091),(47687,'femur.tif',233,7,163,243.0489719,99.382635,90.3399465,1.8,99.3384879,90.304786,0.8288154,13.9809136,15.790905,14258.7261644,17474.6562978,22.010623,1106.627915,1019.8708469,2004.613223,25.8535549,28.8623624,2.5468334,89.1286526),(47688,'femur.tif',233,7,164,243.0865,99.3644646,90.242351,1.8,99.1965316,90.2032215,0.7862432,14.4302849,15.830509,14366.4003317,17612.6505859,20.2914431,1112.5763953,995.5728816,2000.6729471,0.351562,0.4971837,2.3561945,0.9943675),(47689,'femur.tif',233,7,165,244.3303611,99.3315257,90.1672151,1.8,99.1410938,90.1203117,0.7284034,14.7399357,16.4569975,14543.679058,17811.6177365,18.0449597,1082.3127174,986.6853781,1965.6729541,0.9812984,2.8343835,2.0899424,6.3780855),(47690,'femur.tif',233,7,166,244.7865046,99.2714164,90.0284179,1.8,99.0153275,90.0125409,0.6932353,14.7031114,16.593656,14633.1216144,17997.6760756,16.6600937,1084.6118606,995.2397997,1966.4573524,0.7796036,2.3583496,2.0344439,5.0924745),(47691,'femur.tif',233,7,167,244.0532442,99.246412,89.8875743,1.8,98.975934,89.9321767,0.6557173,14.3865621,16.1990179,14687.2962598,18175.9328383,15.1218704,1122.0391863,1020.9038254,2015.526238,0.9438747,2.8343835,2.0899424,6.086842),(47692,'femur.tif',233,7,168,244.0675888,99.1637172,89.8060059,1.8,98.9393124,89.9123927,0.6051014,14.803054,16.3174091,14744.5859406,18405.8895707,13.1627738,1127.9909354,996.0502689,1882.6192575,0.8898936,2.2234733,1.8925469,5.383718),(47693,'femur.tif',233,7,169,242.5014797,99.1383724,89.6906417,1.8,98.9025984,89.8021308,0.5538567,14.6810015,16.02115,14705.798899,18459.2062031,11.1811691,1152.1773542,1001.6890779,2028.4875631,26.4086698,29.7854149,2.6092701,91.2380246),(47694,'femur.tif',233,7,170,240.9588913,99.0660499,89.6490916,1.8,98.8488485,89.7369656,0.5313226,14.8291244,16.8881038,14661.8623578,18670.1854255,10.3097697,1105.5228987,988.7207066,1970.564828,26.4086698,29.9653763,2.5991611,91.2380246),(47695,'femur.tif',233,7,171,239.1645793,99.0188898,89.5918613,1.8,98.886419,89.7200251,0.4972541,14.6271837,16.0827576,14666.8904503,18811.7473357,9.0700101,1169.6841913,1002.714583,2052.8006673,26.4159975,30.099128,2.7459031,91.9411486),(47696,'femur.tif',233,7,172,239.2008716,98.956518,89.564724,1.8,98.8318563,89.6436172,0.4611409,14.9350746,16.4569749,14808.3916728,19043.6442921,7.8935643,1157.1776942,991.5177549,1944.187898,0.703124,1.2675748,2.1587989,2.691859),(47697,'femur.tif',233,7,173,240.1325969,98.8882205,89.5047078,1.8,98.6963695,89.5187562,0.4079402,14.6576798,16.8397314,14992.7407944,19418.652121,6.298929,1153.1450014,1022.8590774,2022.2346645,26.5726348,30.5211704,2.7140119,92.9355161),(47698,'femur.tif',233,7,174,240.8457075,98.796965,89.5058711,1.8,98.5570843,89.5425389,0.3671431,15.4317276,16.6655478,15194.2605454,19789.4249316,5.1719774,1187.4452085,984.6117637,2006.7785536,0.351562,1.1117367,1.8925469,2.4006155),(47699,'femur.tif',233,7,175,242.8075105,98.7504641,89.4771644,1.8,98.4866728,89.5478217,0.3426111,14.6694379,16.4816284,15336.4722781,20362.4173185,4.5672399,1235.4614965,1045.4710215,2035.2291138,0.351562,0.4971837,2.3561945,0.9943675),(47700,'femur.tif',233,7,176,243.3141786,98.679991,89.4504414,1.8,98.3639169,89.5587213,0.3073781,15.7502976,16.6065017,15521.5091581,20759.8725187,3.7122838,1250.1050999,985.4740248,2030.8984028,26.718712,31.1484726,2.784143,94.4270673),(47701,'femur.tif',233,7,177,244.9887524,98.6691507,89.3599255,1.8,98.4314189,89.4998769,0.272401,14.9944603,16.5176458,15684.450541,21152.071731,2.9555871,1280.5742418,1046.0163473,2102.4671809,1.0353084,2.2234733,1.8925469,5.0924745),(47702,'femur.tif',233,7,178,244.4683764,98.5869434,89.3914626,1.8,98.2989024,89.5505098,0.2294191,15.279902,16.6225855,15846.7016926,21466.6568965,2.1071611,1291.415041,1037.0944566,2141.3019059,0.351562,1.4495273,1.815775,3.1037395),(47703,'femur.tif',233,7,179,245.1730225,98.4921458,89.3873676,1.8,98.2285375,89.4924451,0.1928252,15.2383423,16.6925419,15927.6632282,22015.2541407,1.5005819,1318.8676914,1045.235955,2230.4073533,26.718712,32.1366899,2.965653,96.3304991),(47704,'femur.tif',233,7,180,247.0330276,98.4139338,89.4082834,1.8,98.1408266,89.4678693,0.1712542,15.5010844,17.1033506,16135.5091079,22648.5285924,1.1957393,1324.2158882,1040.9277628,2264.6570767,26.718712,32.490492,2.9123607,96.6217426),(47705,'femur.tif',233,7,181,249.3770414,98.3665998,89.3968019,1.8,98.2053864,89.4676257,0.1448824,16.0888033,17.0486587,16340.9994117,23416.7812167,0.8663545,1373.5263081,1015.6752564,2265.5963908,0.351562,0.7861165,2.0344439,1.6974915),(47706,'femur.tif',233,7,182,250.2346842,98.222524,89.4030837,1.8,97.9292895,89.4473066,0.1154174,16.2172928,17.1131972,16497.8169001,24123.9142042,0.5531079,1409.6672799,1017.2978363,2295.6867344,27.070274,33.3706236,2.9400649,98.3192341),(47707,'femur.tif',233,7,183,253.2548047,98.1627762,89.3690134,1.8,97.8656508,89.3736943,0.0968017,15.6137808,17.5013215,16723.992384,24990.8086268,0.3942901,1427.9383783,1071.1045974,2362.465803,0.351562,0.4971837,2.3561945,0.9943675),(47708,'femur.tif',233,7,184,254.6521868,98.1016752,89.3699853,1.8,97.8593109,89.3737552,0.079464,16.2878983,17.767721,16935.7509003,25664.1354263,0.2674378,1444.4247199,1039.7750897,2373.3507057,27.070274,34.2750413,2.9663263,100.0167256),(47709,'femur.tif',233,7,185,256.370094,98.0216728,89.3330932,1.8,97.8531398,89.3781238,0.057594,17.340129,17.8987165,17064.2147485,26293.7095464,0.1415762,1469.0276554,984.0881108,2392.6535372,27.070274,34.9092392,2.9797552,101.4229736),(47710,'femur.tif',233,7,186,255.9769094,97.9522925,89.3034531,1.8,97.7270284,89.3583193,0.0497879,16.2784419,18.2305421,17212.0046616,26684.052821,0.1056667,1463.7004607,1057.349638,2395.1574858,27.421836,35.3140485,2.971534,101.7995203),(47711,'femur.tif',233,7,187,259.4301023,97.8741271,89.2792288,1.8,97.7730031,89.3471083,0.032194,16.2307499,18.4046625,17479.477282,27517.3647037,0.0447989,1495.1300862,1076.9359023,2412.2314408,0.351562,0.4971837,2.3561945,0.9943675),(47712,'femur.tif',233,7,188,262.5361032,97.7840126,89.2772918,1.8,97.6969674,89.3023667,0.0212956,16.14378,18.7228291,17742.0620343,28536.061528,0.0198404,1524.131921,1099.0029644,2446.4728503,27.773398,36.4981638,3.0160429,118.5331613),(47713,'femur.tif',233,7,189,264.5405281,97.6869039,89.2195152,1.8,97.684033,89.254019,-0.0005761,16.9518281,18.935437,17935.4810449,29592.6609378,0.0000146,1562.8190132,1058.0263612,2484.0227998,27.773398,36.9926092,2.9889433,105.4004436),(47714,'femur.tif',233,7,190,267.6625216,97.5375762,89.2158092,1.8,97.5363165,89.1697834,-0.0339493,16.5059964,19.5782323,18271.8158581,30557.9203461,0.0513961,1560.8109997,1106.980483,2472.9282809,28.12496,37.5447806,3.0195605,110.2869778),(47715,'femur.tif',233,7,191,273.4756833,97.4300967,89.2563942,1.8,97.4417646,89.1644718,-0.0489477,16.6448167,19.7349609,18674.5537499,31931.3650668,0.1091151,1618.0100515,1121.9440901,2557.3201778,28.12496,38.0353691,2.9931597,108.4188798),(47716,'femur.tif',233,7,192,275.3701829,97.2553901,89.2149447,1.8,97.3305063,89.1437987,-0.0748694,16.3667024,19.455144,18786.9909748,33149.9359485,0.256781,1703.9162449,1147.8788161,2634.3881335,28.4162645,38.6350483,3.0138517,110.8194953),(47717,'femur.tif',233,7,193,274.3281576,97.1735204,89.1574325,1.8,97.3212735,89.1254557,-0.1058622,16.6286965,20.1791443,18796.9624934,33667.4442429,0.5104788,1668.4277481,1130.3930213,2591.7508906,28.7710462,39.290101,3.0250066,112.3110466),(47718,'femur.tif',233,7,194,275.948499,97.05067,89.1626624,1.8,97.3540226,89.0662775,-0.1177854,17.3206653,20.6272686,18820.5670111,34792.8103106,0.6351121,1686.7386062,1086.5960767,2596.3154398,28.828084,39.726506,3.0084563,114.4204186),(47719,'femur.tif',233,7,195,280.5943917,96.904842,89.178451,1.8,97.1931039,89.1304852,-0.1292144,17.0490802,20.4211837,19065.8840689,36212.3577455,0.7764814,1773.2741826,1118.2939984,2675.403805,28.828084,40.3378139,3.028048,146.7580602),(47720,'femur.tif',233,7,196,283.545411,96.8458699,89.2073749,1.8,97.1220151,89.1475243,-0.1406585,17.6175319,21.0501212,19188.1999562,37437.3388653,0.9288321,1778.4856679,1089.153693,2679.1409487,29.2870955,40.7720989,3.0118901,117.1476113),(47721,'femur.tif',233,7,197,285.6865403,96.7161494,89.1913169,1.8,96.9255859,89.053474,-0.1442427,17.5509932,21.7270799,19502.7493341,38891.0732394,0.9838119,1789.9816026,1111.2048805,2686.4209234,29.4307387,41.2827208,3.0563298,118.3479191),(47722,'femur.tif',233,7,198,289.2880108,96.5301074,89.2976123,1.8,96.7555588,89.0435736,-0.1533408,17.9844917,21.3731161,19851.6151148,40596.2252186,1.1248332,1899.4060145,1103.8185287,2784.2738422,29.7148875,41.7752709,3.0235006,119.2569833),(47723,'femur.tif',233,7,199,293.6578353,96.4317778,89.359615,1.8,96.7037274,89.0664029,-0.1585911,17.889772,22.3331134,20361.2944471,42171.7241046,1.2206857,1888.3047455,1138.1528202,2800.0058434,29.9371415,42.212335,3.0079404,121.1604151),(47724,'femur.tif',233,7,200,296.8283308,96.321347,89.4925705,1.8,96.5868713,89.1677852,-0.1582263,18.1227002,22.211909,20960.9208401,43781.2139921,1.2282419,1971.0693942,1156.6113549,2887.4360221,30.3405003,42.8646213,3.018255,123.2697871),(47725,'femur.tif',233,7,201,300.4394641,96.2382137,89.5779359,1.8,96.552888,89.309104,-0.1575064,18.105829,22.6524032,21388.6157543,45510.7088729,1.2319914,2009.0896532,1181.3110431,2926.1231006,30.6915713,43.4147044,3.052399,125.7910396),(47726,'femur.tif',233,7,202,304.194905,96.0953572,89.6815438,1.8,96.3367319,89.3893646,-0.1718111,18.2136565,23.2450602,21973.2088541,47353.6154573,1.4819226,2037.1474672,1206.4139288,2979.7006241,31.118908,43.8326058,3.0371355,128.3975953),(47727,'femur.tif',233,7,203,305.5639349,95.9663976,89.8313557,1.8,96.3310702,89.4764173,-0.1772264,18.870132,23.5894036,22459.4168125,49224.5845461,1.5829093,2086.7244185,1190.2098413,3027.6033531,0.351562,1.4495273,1.815775,3.1037395),(47728,'femur.tif',233,7,204,308.7879886,95.7627387,90.0404715,1.8,96.1420466,89.6102145,-0.1817548,18.9319932,23.9000162,23264.4953323,51492.9026017,1.6814864,2154.5132956,1228.8455329,3092.5357718,32.157571,45.0013093,3.0162687,132.9429166),(47729,'femur.tif',233,7,205,315.1465826,95.4878983,90.310719,1.8,95.8720025,89.8835556,-0.1898798,19.0801544,34.7013308,24583.1756983,54071.1023651,1.8710836,1558.1852639,1288.4159758,2207.9765734,32.8300511,45.6570634,3.0258334,135.7554126),(47730,'femur.tif',233,7,206,323.7124859,95.292811,90.6857568,1.8,95.6656602,90.2721969,-0.1969252,19.7990218,34.7684714,26191.8124731,57293.7904494,2.0653307,1647.8662446,1322.8841705,2353.1370856,33.530481,46.2808373,3.0426799,139.0650923),(47731,'femur.tif',233,7,207,339.7364243,95.2395619,91.3044165,1.8,95.7456535,90.8011154,-0.1870949,19.5070306,34.3153348,28663.3579243,63201.533734,1.9590306,1841.7868914,1469.3860138,2614.3571951,34.3499653,48.4709534,0.2045078,166.942716),(47732,'femur.tif',233,7,208,372.0429162,95.2064432,92.175863,1.8,95.6999742,91.4548206,-0.1790873,21.6599507,33.7825475,32528.7178126,75125.4906891,1.9675387,2223.7959026,1501.7909414,3113.0051927,35.3229234,50.1897082,0.4260478,166.822079),(47733,'femur.tif',233,7,209,439.1617494,93.359586,94.9408945,1.8,93.7283435,94.4906439,-0.4021883,22.6964599,31.4757482,44063.9159527,108555.7817916,11.2147093,3448.8705756,1941.4444442,4700.4167121,40.5408191,61.2263164,0.7366563,216.0139986),(47734,'femur.tif',233,7,210,486.8016535,92.7058663,96.6277773,1.8,93.4021834,95.829525,-0.4699767,24.4588212,31.2829679,52979.4781074,133268.9565512,16.6394632,4260.1123064,2166.0683349,5637.8857202,42.513671,63.6880544,0.7463555,205.2818964),(47735,'femur.tif',233,7,211,530.487839,92.9176575,97.5325953,1.8,93.641213,96.92364,-0.49655,24.294555,32.7122932,64126.9242816,151532.1900451,20.0659006,4632.2704712,2639.5595336,6380.9454312,1.054686,1.7926215,1.7681919,4.3893505),(47736,'femur.tif',233,7,212,573.2811757,93.0843389,98.4847856,1.8,94.0515674,97.8935321,-0.5141588,26.8547865,33.7977646,77477.4334183,168051.4927294,23.1098978,4972.2665019,2885.051178,7109.4579181,48.0916296,66.6689852,0.748102,222.1715081),(47737,'femur.tif',233,7,213,604.0801354,93.305664,99.0632306,1.8,94.5056917,98.404442,-0.5186525,28.9562522,34.6507892,89843.001137,179265.1921239,24.7399738,5173.4807834,3102.7151085,7659.2468545,1.406248,1.988735,0.7853982,5.383718),(47738,'femur.tif',233,7,214,638.6978695,93.9265541,99.7611354,1.8,95.3399275,98.992895,-0.4993867,28.2945706,35.3885568,106500.2743514,190347.0602785,24.4124113,5378.7743052,3763.9826989,8269.4795145,0.703124,1.5722331,2.0344439,3.6862265),(47739,'femur.tif',233,7,215,676.4529528,94.6832318,100.5206645,1.8,96.0049644,99.4258508,-0.4529456,40.9354054,35.8973496,125385.1100162,200682.5362662,21.5909997,5590.4555135,3062.999103,7949.4771089,55.2576275,70.4984816,0.8913825,244.2096262),(47740,'femur.tif',233,7,216,707.0032227,95.399999,101.0542862,1.8,96.4650781,99.6992494,-0.411891,41.680047,36.566895,144756.6655561,208834.2144747,18.8857542,5711.0185194,3473.0446803,8433.0434718,57.3695055,71.7048599,0.8408967,261.9376346),(47741,'femur.tif',233,7,217,736.5143887,95.9259485,101.3660248,1.8,96.8416544,99.9025987,-0.4075352,42.3677981,37.0386106,159313.8914749,215636.4108344,19.2833516,5821.9357451,3760.2589418,8844.3718288,59.0000707,72.5283568,0.8574382,262.4348184),(47742,'femur.tif',233,7,218,737.0731917,96.2555407,101.3432369,1.8,97.0610234,99.9914559,-0.421104,34.6234093,37.605132,166723.2418181,216345.152544,20.5264421,5753.0752105,4815.3329014,10076.4255255,60.4820249,73.2228621,0.8465463,257.4776166),(47743,'femur.tif',233,7,219,740.6000926,96.4086949,101.1773737,1.8,97.2332722,99.9402357,-0.4472135,35.3720944,38.0850085,173557.9725422,216495.2252837,23.0841521,5684.5261183,4906.6354531,10173.1010643,0.351562,0.4971837,2.3561945,0.9943675),(47744,'femur.tif',233,7,220,731.9775974,96.2980656,101.1586591,1.8,97.281238,99.7778168,-0.4530313,36.1459258,38.0271955,177582.7590931,216725.5072355,23.3714644,5699.2240509,4912.9398472,10306.5228692,62.0395771,73.8522905,0.8089628,258.0454679),(47745,'femur.tif',233,7,221,715.0945555,96.4466258,101.2362255,1.8,97.3991796,99.6777574,-0.4842229,36.6642879,38.0653037,177549.0362235,213916.3678439,25.8279659,5619.720506,4842.5606118,10242.5528442,62.1683512,73.6251747,0.7516272,256.4186439),(47746,'femur.tif',233,7,222,689.458606,96.6476493,101.0008085,1.8,97.4695746,99.3123377,-0.5417524,37.5022288,38.2662122,176686.2887476,209514.9040928,30.5525289,5475.1931758,4711.3543492,10034.5071448,62.2542006,73.6436382,0.8259165,258.5280159),(47747,'femur.tif',233,7,223,665.5149832,96.9184976,100.6341161,1.8,97.5507655,98.9334804,-0.5753482,38.0356279,38.4881311,176139.0715669,206911.6060918,32.840293,5375.9847626,4630.8969105,9928.0377169,62.440346,73.5571552,2.2783858,265.2826481),(47748,'femur.tif',233,7,224,652.7156227,97.1711109,100.125428,1.8,97.6716521,98.5787011,-0.5988688,42.9456813,38.4565567,177040.1104451,202740.5029383,34.5686069,5271.9359228,4122.4194172,8834.3499505,62.3413379,73.9526356,2.2990178,265.6092254),(47749,'femur.tif',233,7,225,636.8533701,97.3032779,99.4556368,1.8,97.6105732,98.1372517,-0.5739863,38.6165733,38.4804869,174072.4149541,194571.9520067,31.2940622,5056.3796812,4507.7126232,9458.6698411,0.351562,0.4971837,2.3561945,0.9943675),(47750,'femur.tif',233,7,226,620.6922403,97.6002099,98.9893477,1.8,97.7325011,97.8028135,-0.4625968,37.7626572,38.3070004,169425.9071035,185883.0153604,20.6028493,4852.4555127,4486.5991857,9141.1968137,0.351562,0.7861165,2.0344439,1.6974915),(47751,'femur.tif',233,7,227,606.2791676,97.7490554,98.4494824,1.8,97.6294291,97.4372261,-0.2998571,36.0833051,36.9584504,162717.5308917,176861.0136017,8.8164612,4785.4012182,4509.4962955,8725.6266231,0.351562,0.4971837,2.3561945,0.9943675),(47752,'femur.tif',233,7,228,586.8767556,97.8326846,97.8029352,1.8,97.6316257,96.9269992,-0.1835684,34.0046573,35.2215775,151756.9735002,167587.1102214,3.2591757,4758.0807627,4462.8290798,8273.9885464,59.8052458,72.6722109,2.308286,263.8410664),(47753,'femur.tif',233,7,229,559.2440966,97.7911196,97.2347101,1.8,97.6213907,96.5289196,-0.0688947,31.5770833,32.8909368,137632.5361922,158844.9390459,0.4417078,4829.4440535,4358.6209303,7775.1891864,59.1282838,71.5020413,2.2900889,259.4517159),(47754,'femur.tif',233,7,230,536.215495,97.750814,96.4544438,1.8,97.614084,95.9740656,-0.0321059,30.1338939,31.5208564,123620.0415252,148323.2992751,0.0920892,4705.5605827,4102.3586957,7262.1481185,57.5082133,70.1663501,2.313667,250.6730149),(47755,'femur.tif',233,7,231,503.8169055,97.5608471,95.7058739,1.8,97.5667708,95.4225895,-0.0264106,28.9843561,30.8175341,106102.6025408,135281.1563869,0.0585568,4389.7463094,3660.68517,6642.8975425,55.596911,68.1305024,2.3343002,243.5918054),(47756,'femur.tif',233,7,232,470.7068159,97.3982908,94.6549211,1.8,97.4987584,94.7536135,-0.0339411,28.0866148,30.0757172,87975.7391134,120605.1190549,0.0903411,4010.0496396,3132.3012693,6023.1468401,52.6658631,65.1614263,2.3867194,232.9596422),(47757,'femur.tif',233,7,233,433.1024821,97.3698441,93.7104343,1.8,97.5543797,94.0673208,-0.015456,25.3429285,29.0315745,70251.9561385,105779.6161575,0.0172427,3643.6058984,2772.0535986,5355.5600119,50.273366,62.0115906,2.4163627,219.5856504),(47758,'femur.tif',233,7,234,397.7172927,97.1265708,93.009767,1.8,97.545309,93.4311408,-0.0420649,24.8742064,28.4124818,54957.7624941,92217.112533,0.1172219,3245.6549591,2209.4277738,4670.0768184,47.4415419,59.4846644,0.6470472,206.3469314),(47759,'femur.tif',233,7,235,357.1357598,96.6856406,92.2631359,1.8,97.3346341,92.7061366,-0.0785299,24.210718,27.5680788,40756.8878273,77337.6515907,0.3663188,2805.3333718,1683.4233396,3981.1340331,44.5853444,56.9704024,0.6188148,196.8444084),(47760,'femur.tif',233,7,236,316.6907066,96.4675151,91.829153,1.8,97.2547432,92.1702198,-0.0873363,22.3841202,26.2687024,29066.9816056,64021.0953975,0.4015768,2437.1624634,1298.5536804,3350.755115,41.2951788,54.1188564,0.5771922,181.4816817),(47761,'femur.tif',233,7,237,266.8222946,96.8716996,91.613334,1.8,97.713612,91.8942966,-0.0696884,20.5291827,25.191981,19884.7910768,52332.8944138,0.2156202,2077.3632085,968.6109449,2782.5599546,19.33591,27.3043972,1.7782926,77.4521524),(47762,'femur.tif',233,7,238,210.5542772,97.7859003,91.7421024,1.8,98.8123034,91.8482418,-0.0336016,17.9481476,25.1288895,13071.8854297,40894.9562002,0.0396066,1627.4080177,728.3139025,2096.7824252,15.82029,23.8751757,1.8086323,64.4547074),(47763,'femur.tif',233,7,239,153.5112391,99.1285091,92.0511711,1.8,100.0819101,91.9671754,0.0003551,15.524424,25.6539013,7529.5671347,28652.1790495,0.0000033,1116.8741441,485.0142685,1382.2037756,12.656232,20.0421176,1.9480454,52.5369332),(47764,'femur.tif',233,7,240,95.371344,101.8918528,92.797926,1.8,102.1541666,92.5259181,0.020169,13.5277767,27.4399346,3293.5194956,14601.2179656,0.0064651,532.115625,243.4634725,646.4430918,8.4037841,13.9078212,1.9325256,35.5620182),(47765,'femur.tif',233,7,241,38.9613039,107.9516731,94.3740602,1.8,108.002631,94.1953213,-1.4347448,5.8306253,9.6508306,273.5107527,637.9077103,6.3740947,66.0987369,46.9093342,94.236358,11.7317334,19.03636,1.4968573,51.0453819),(47766,'femur.tif',233,7,242,1.98229,107.807666,95.0160686,1.8,107.8086846,95.0030387,-1.2461582,2.4210151,3.4666795,2.0884482,4.103354,0.2967689,1.1836554,0.8626333,1.6897032,4.921868,7.2391046,1.0636978,23.2676972),(47767,'femur.tif',233,7,243,2.5802691,46.0241417,135.9179679,1.8,48.0030379,135.906245,0.01209,0.8759586,87.5689193,0.4307303,308.9447029,0.0000629,3.5280178,0.4917245,3.5328615,11.9674485,162.4311557,3.1307706,344.0653588),(47768,'femur.tif',233,7,244,2.4978719,45.8809522,135.9463101,1.8,47.8915335,135.9358418,0.011055,0.9056134,87.7123305,0.3902511,306.3649724,0.0000509,3.4928381,0.4309246,3.4972282,11.9674485,162.4311557,3.1307706,343.7741153),(47769,'femur.tif',233,7,245,2.4108305,45.2932002,135.9694504,1.8,46.7531803,135.9403505,0.0129122,0.9249212,88.2986364,0.3506157,196.9017517,0.000067,2.2299523,0.3790762,2.2338522,11.9797202,162.4311557,3.1307706,343.688812),(47770,'femur.tif',233,7,246,2.3193321,45.1699036,135.9985686,1.8,46.8147561,135.9737298,0.0121386,0.9539504,88.4220883,0.313739,185.5506019,0.000057,2.0984644,0.328884,2.101953,11.953108,162.0761827,3.1329161,342.6944446),(47771,'femur.tif',233,7,247,2.2314667,44.6767031,136.0231909,1.8,45.6337379,135.9950751,0.0168894,1.1188718,88.9106414,0.2722548,97.6670977,0.0001061,1.098486,0.2433297,1.1014609,11.953108,162.0761827,3.1329161,342.6944446),(47772,'femur.tif',233,7,248,2.108545,44.5760296,136.053039,1.8,45.6543822,136.0436767,0.0150268,0.9846209,89.0127848,0.2349807,94.7995066,0.0000793,1.06501,0.2386509,1.0675845,11.6251037,162.0761827,3.1329161,341.9060173),(47773,'femur.tif',233,7,249,2.1557362,45.1184121,136.0542924,1.8,47.0175962,136.0493989,0.0100135,0.680579,88.4742345,0.2424289,178.473668,0.000036,2.0172389,0.3562098,2.0199422,11.953108,162.0761827,3.1329161,342.6944446),(47774,'femur.tif',233,7,250,2.1079832,44.6182667,136.0643195,1.8,45.6870799,136.0438406,0.0143759,0.9373507,88.971012,0.2270137,95.2310459,0.0000726,1.0703604,0.2421866,1.0728524,11.601546,162.0735137,3.1350852,342.1972608),(47775,'femur.tif',233,7,251,17.9299361,106.6120666,114.2333902,1.8,109.1103888,113.438194,-0.3355199,29.8202309,69.3449153,114.6826162,10441.155237,0.3239707,150.568433,3.8457991,152.2040765,10.898422,11.3593159,0.3805064,35.7679584),(47776,'femur.tif',233,7,252,42.5659203,111.4487844,112.5433613,1.8,112.0037763,112.3520342,-0.3361273,29.8314068,74.4677309,539.0125258,11367.5680707,0.7717923,152.6509259,18.0686258,159.8712694,15.468728,16.0336941,0.9097532,50.9600787),(47777,'femur.tif',233,7,253,66.4970338,112.7074889,112.1331133,1.8,112.9239855,112.090426,-0.3360235,29.802319,75.7914287,1286.7377355,12054.5889003,1.2049881,159.0495008,43.1757587,176.007183,18.632786,19.2718836,0.9017533,62.1393951),(47778,'femur.tif',233,7,254,140.7629649,105.4624054,112.4330551,1.8,100.5889793,112.5196885,-0.1849834,28.7381731,67.9870656,4740.492818,29321.386686,0.7936758,431.2788972,164.9545639,493.7871355,20.7163101,27.6037742,1.6856729,111.7431953),(47779,'femur.tif',233,7,255,540.2783524,92.1127256,112.3258745,1.8,96.9432907,112.2328584,-0.0672111,26.8116865,52.8328735,26323.2871456,99384.513774,0.4061577,1881.1112709,981.7840867,2217.1062185,28.828084,29.3906673,2.2119051,95.1301913),(47780,'femur.tif',233,7,256,589.3583728,92.2694821,112.218722,1.8,97.766753,112.1750043,-0.0568052,26.4944807,52.778468,29243.2480015,114802.5610002,0.3166189,2175.1779705,1103.7486773,2532.162638,28.828084,29.4158881,1.1392233,95.4214348),(47781,'femur.tif',233,7,257,606.316883,92.9305689,112.1757387,1.8,98.5270362,112.0994441,-0.0545873,26.4128065,53.3937104,30492.5668667,123827.4581715,0.3008152,2319.1394145,1154.461451,2683.6577803,28.828084,29.4389882,2.2716507,95.5420718),(47782,'femur.tif',233,7,258,617.7815208,93.4288912,112.1697425,1.8,99.0972491,112.0937465,-0.0536183,26.3540127,53.8709257,31387.3440582,130394.9354486,0.295729,2420.5066777,1190.9891823,2791.3504765,0.351562,0.4971837,2.3561945,0.9943675),(47783,'femur.tif',233,7,259,626.7216573,93.7982733,112.1634587,1.8,99.4461133,112.1016786,-0.0528492,26.3109214,54.2236654,32181.5508879,135208.2978465,0.291472,2493.5292876,1223.1251981,2871.3395798,28.828084,29.4473838,2.5602125,95.5420718),(47784,'femur.tif',233,7,260,633.9497668,94.0461928,112.1529388,1.8,99.7351648,112.0686611,-0.0526372,26.3002288,54.4672552,32848.2089343,138634.0029004,0.2924742,2545.2724293,1248.9704647,2929.9828462,28.9562476,57.3035276,0.1106572,182.2347752),(47785,'femur.tif',233,7,261,638.6532252,94.1902681,112.1468295,1.8,99.9005124,112.0495265,-0.0522863,26.2853869,54.6039335,33260.0066988,140607.4634395,0.2907327,2575.0427546,1265.3421026,2963.9679752,29.0068321,57.5155862,0.0856793,180.6225869),(47786,'femur.tif',233,7,262,640.41514,94.2573455,112.1461038,1.8,99.9769894,112.0473064,-0.0525852,26.2939673,54.6773607,33412.4347238,141296.082703,0.2948747,2584.1789148,1270.7262593,2975.1924708,29.0302513,57.5800174,0.0978461,179.4222792),(47787,'femur.tif',233,7,263,641.1655915,94.284748,112.1543922,1.8,100.0308203,112.0701205,-0.052949,26.298065,54.7120733,33444.3225741,141599.6280887,0.2993151,2588.0874084,1271.7408136,2979.812015,0.351562,0.4971837,2.3561945,0.9943675),(47788,'femur.tif',233,7,264,641.2491123,94.3203331,112.1597627,1.8,100.0741356,112.0843933,-0.0531571,26.2987143,54.7517732,33447.4879026,141678.0424259,0.3017104,2587.6429973,1271.8297759,2979.6690557,29.0057126,57.5155862,0.0856793,179.2163389),(47789,'tibia.tif',233,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47790,'tibia.tif',233,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47791,'tibia.tif',233,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47792,'tibia.tif',233,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47793,'tibia.tif',233,8,5,6.9024157,71.9670901,98.1938777,1.8,71.9679987,98.2610174,-1.3534923,3.7702136,4.8299383,12.1424086,33.2962194,1.0969291,6.8937152,3.2206156,9.3667861,5.761252,9.6535622,1.3876855,24.9651887),(47794,'tibia.tif',233,8,6,38.3140736,70.6597985,96.6221297,1.8,70.9110155,96.8645632,1.2100261,5.4947099,9.1471477,168.8899621,671.707255,5.5899883,73.43352,30.7368296,91.5333875,9.836522,18.5663351,1.8985348,46.5353944),(47795,'tibia.tif',233,8,7,81.5117935,70.6649815,95.4034843,1.8,71.1490615,95.49473,1.1734457,9.5662702,11.8016461,725.417248,2579.8670757,11.5508869,218.6023084,75.8307298,275.2237813,15.5042961,23.8077828,1.8551811,71.0033994),(47796,'tibia.tif',233,8,8,260.0396545,73.41687,87.6744576,1.8,74.3678605,84.7718475,1.2986716,19.1829332,29.9370762,14058.1295756,37840.2504533,40.2089825,1263.9928554,732.8456723,1715.1494999,31.2120309,50.8004049,1.6539376,189.5158626),(47797,'tibia.tif',233,8,9,626.9332684,70.676755,87.7660872,1.8,70.7856871,87.7560125,1.4581022,33.2259335,35.5952287,112553.9726342,146051.4652792,103.1674808,4103.1191662,3387.5337927,7265.1275338,54.2812382,65.9110778,1.328405,246.094871),(47798,'tibia.tif',233,8,10,734.9750587,69.3082431,90.4245357,1.8,70.7330059,90.5850467,1.5189717,34.2326651,39.9309046,149654.7829499,258008.8709352,122.167139,6461.3830743,4371.6953531,10202.0340282,57.4554305,73.7844804,1.4369853,253.3734473),(47799,'tibia.tif',233,8,11,658.61062,70.5780515,92.0484764,1.8,71.024633,91.1826555,1.4111443,34.1577257,41.9449931,140198.7535462,238982.3619311,106.9942647,5697.5182083,4104.4522329,9039.9467279,58.9038786,74.0394914,1.4134539,234.3744636),(47800,'tibia.tif',233,8,12,703.438494,70.7391397,93.9987007,1.8,71.1330725,92.083024,1.4160657,34.6822009,43.8424266,149108.5544326,223227.8163128,114.4551761,5091.5935432,4299.2817751,8492.3214146,59.1183167,73.5336277,1.4268709,239.9641218),(47801,'tibia.tif',233,8,13,740.5718154,70.3854769,94.4589068,1.8,70.877539,92.8275948,1.4012904,34.6208561,44.0483847,157421.4791083,217094.005961,119.9160886,4928.5350071,4547.0128905,8489.0168116,57.9811714,73.3451357,1.4458468,233.4507636),(47802,'tibia.tif',233,8,14,616.8232785,68.0002495,92.0319798,1.8,67.7965698,92.4831352,1.5231004,34.6630441,41.4508646,100164.74378,194345.1773876,102.5701886,4688.5675238,2889.6695741,7105.0268097,53.2825807,73.1468653,1.469693,241.9528568),(47803,'tibia.tif',233,8,15,499.9583557,67.3988847,90.864767,1.8,67.3742532,92.9948277,1.4792637,34.1062763,39.9691394,72343.8388457,164664.7002811,82.6302138,4119.7959906,2121.1297941,5928.1287097,50.7798214,72.1730328,1.4585253,216.5611519),(47804,'tibia.tif',233,8,16,401.7609366,67.0972079,92.4545923,1.8,67.246336,93.1365319,1.4909419,36.3983649,40.8933585,54960.6111743,115105.4075535,66.5340768,2814.7702131,1509.9747307,4158.7408521,49.3340001,70.6989346,1.4661797,210.6302807),(47805,'tibia.tif',233,8,17,344.2691332,66.5367005,92.6620394,1.8,66.7163012,92.6812095,1.5032637,32.9175284,39.0278558,40836.7740347,92579.5568565,57.1169042,2372.1404869,1240.5783807,3417.4221687,45.0047989,66.6300425,1.4438235,192.4903917),(47806,'tibia.tif',233,8,18,322.9920719,65.9117564,91.1568997,1.8,65.9148437,92.0249187,1.495032,31.25533,38.0544948,32729.2708189,98727.4304986,53.5235941,2594.3697566,1047.1580642,3451.1477241,42.4560111,66.1954931,1.4536876,189.301349),(47807,'tibia.tif',233,8,19,311.5737264,65.6386544,89.6279435,1.8,65.5023823,91.3561186,1.4828478,25.6148554,36.9272418,27956.459155,107634.4582451,51.5283212,2914.7711286,1091.4158491,3669.7634815,40.2233087,65.4972366,1.4524333,185.2385757),(47808,'tibia.tif',233,8,20,293.4264115,65.4979305,89.705629,1.8,65.21927,90.9325671,1.4767804,24.1550581,36.950152,24546.4519303,100526.7744953,48.4734087,2720.6051661,1016.2033917,3380.147246,38.1486371,64.5851066,1.434288,181.1404687),(47809,'tibia.tif',233,8,21,280.9703478,65.4310248,89.8442583,1.8,65.0006958,90.7295665,1.4755328,23.1073432,36.7962227,22128.69549,95489.1843802,46.4047012,2595.0811612,957.647763,3194.2968463,0.703124,1.8932193,1.1902899,4.098107),(47810,'tibia.tif',233,8,22,271.3158273,65.4044741,89.8945346,1.8,64.8763708,90.6007592,1.4738702,22.0737803,36.7393211,20086.3196095,91590.6885826,44.7958129,2492.9880538,909.9628324,3032.7084994,35.4567826,62.7496316,1.4415769,174.4711397),(47811,'tibia.tif',233,8,23,264.5886556,65.3795183,89.8184813,1.8,64.7783417,90.4001761,1.4698237,21.4258246,36.4427085,18729.0409923,88118.4999696,43.6500338,2418.0008425,874.1339647,2930.2638849,0.6962812,3.9305827,1.3909428,8.316851),(47812,'tibia.tif',233,8,24,259.5610764,65.3537661,89.8837438,1.8,64.8341268,90.3757215,1.4665173,48.7479738,36.4640764,17731.7140487,85745.5442452,42.7914658,2351.5073654,363.7425863,1899.6471165,0.8532562,3.33521,1.2490458,7.2018465),(47813,'tibia.tif',233,8,25,256.1828651,65.4212513,89.7939975,1.8,64.8402292,90.2170597,1.4647994,20.0675254,36.341749,16466.9038116,83455.0374142,42.2192204,2296.3957369,820.5747083,2745.0675938,1.3003514,11.0392707,1.4108832,24.4180355),(47814,'tibia.tif',233,8,26,252.83765,65.4456488,89.8121879,1.8,64.9137442,90.3398702,1.4585748,19.591015,36.0783705,15578.8393267,81406.9835049,41.6111398,2256.3930264,795.2032781,2685.7723246,1.6161737,9.5957751,1.423718,23.303031),(47815,'tibia.tif',233,8,27,250.7844984,65.445645,89.9991238,1.8,64.9470932,90.4143844,1.4564154,19.1994085,36.1001904,14986.5188999,79060.6270838,41.252961,2190.0335194,780.5719086,2596.0410867,1.9806991,23.1203808,1.418147,62.8278834),(47816,'tibia.tif',233,8,28,249.8803761,65.4567974,90.1637131,1.8,65.0295201,90.4289481,1.4529161,18.8197725,35.9876951,14523.5806684,77418.3061452,41.0706926,2151.2438027,771.7192475,2549.0331657,0.6680513,1.5722331,1.1071487,3.394983),(47817,'tibia.tif',233,8,29,247.4253133,65.5260922,90.3119907,1.8,65.0761477,90.4419231,1.447252,27.3153331,35.8235088,14006.4542325,75443.7845114,40.6113312,2105.985342,512.768934,2094.2773442,1.4386107,19.9401057,1.4114447,46.4354554),(47818,'tibia.tif',233,8,30,247.1035896,65.5751331,90.4428644,1.8,65.1280091,90.4494676,1.4405278,27.107969,35.8900038,13573.2393665,73731.9558094,40.4889896,2054.3869615,500.7103037,2061.6551982,1.6800743,19.2462134,1.4056476,52.7282377),(47819,'tibia.tif',233,8,31,244.6934707,65.6332779,90.6920752,1.8,65.221143,90.7808816,1.4374539,18.055442,35.4944465,13193.2633386,72106.9230802,40.061416,2031.4987313,730.7084131,2334.1682552,0.351562,0.7861165,2.0344439,1.6974915),(47820,'tibia.tif',233,8,32,246.0091671,65.6858312,90.8556099,1.8,65.2697338,91.0238418,1.4324724,34.876104,40.5513055,13018.9769821,71362.0591627,40.2220152,1759.7968354,373.2921829,1577.6287935,0.703124,1.5722331,1.1071487,3.394983),(47821,'tibia.tif',233,8,33,246.0889426,65.8891133,91.0816896,1.8,65.5547841,91.2763157,1.4295927,40.0580726,40.3991316,12745.4293331,69957.2404126,40.2024716,1731.6520843,318.173804,1471.8933336,1.857025,28.964954,1.4735431,68.6588157),(47822,'tibia.tif',233,8,34,243.5842542,65.9626069,91.2587305,1.8,65.6849024,91.3880223,1.4263382,36.8967509,40.724221,12399.4608835,68618.7661303,39.7560605,1684.9620293,336.058341,1482.1393652,1.6925303,32.8837346,1.463681,73.0335304),(47823,'tibia.tif',233,8,35,245.8659458,66.0559663,91.5088904,1.8,65.8542534,91.6884213,1.4213993,36.2943739,40.5815477,12377.8779363,68051.8819281,40.0698423,1676.9168684,341.0412301,1485.0313826,2.1021211,41.6330164,1.4862526,97.6575062),(47824,'tibia.tif',233,8,36,245.640065,66.1172308,91.7818642,1.8,65.9557543,92.0783121,1.4204387,22.9221033,38.6500646,12187.4375782,66987.147193,40.0214165,1733.170382,531.6893224,1761.9383768,1.8822036,22.6750677,1.4464413,61.7835464),(47825,'tibia.tif',233,8,37,244.0187498,66.1649868,91.9803975,1.8,65.8758243,92.1328601,1.420055,34.3598556,40.1976207,12043.0378545,65279.3854354,39.7526323,1623.9614279,350.4973358,1462.1840849,2.2897932,43.4147044,1.4816027,109.4692791),(47826,'tibia.tif',233,8,38,243.7205093,66.2974742,92.2111026,1.8,66.0180966,92.334421,1.4186645,34.9029357,40.1037964,11983.1314673,63950.4228717,39.6871999,1594.6226708,343.327323,1428.2590196,1.6082063,28.2039505,1.4959365,65.7963502),(47827,'tibia.tif',233,8,39,243.4900592,66.4321145,92.43935,1.8,66.1045136,92.5670608,1.4155771,18.4492136,33.5383763,11943.0847077,62214.6691886,39.6117692,1855.0292543,647.3492572,2196.7945234,1.964878,25.1188527,1.4585935,61.6129399),(47828,'tibia.tif',233,8,40,245.0898013,66.5685994,92.8105491,1.8,66.3193784,92.9669259,1.4101819,17.5031471,34.0924975,12046.7525869,61188.575334,39.8035671,1794.7812511,688.2620882,2055.0276209,1.7427717,23.72197,1.451956,55.5760674),(47829,'tibia.tif',233,8,41,248.4848293,66.7628294,93.0576083,1.8,66.5168491,93.1346332,1.408174,17.9017587,33.075,12146.5807173,60101.5399409,40.3285195,1817.12895,678.5132652,2168.2888654,30.0116925,53.9828001,1.4860326,193.9526715),(47830,'tibia.tif',233,8,42,248.0843413,66.851502,93.3091568,1.8,66.6899716,93.3348084,1.4056331,17.3086649,35.2771669,12008.0518362,58425.0918416,40.2296987,1656.1730124,693.7595645,1861.7287283,2.1335091,44.5319576,1.4679855,103.6590449),(47831,'tibia.tif',233,8,43,248.240896,66.9635591,93.551249,1.8,66.7728282,93.5334191,1.3982121,39.2067553,39.5557046,12013.1932731,56858.7687393,40.1533465,1437.435368,306.4062092,1258.142881,30.2820885,53.3135398,1.4783454,228.0231384),(47832,'tibia.tif',233,8,44,247.1220915,67.0766006,93.8192081,1.8,66.948971,93.705562,1.3948213,38.6664778,39.3279398,11926.3552118,55481.5586406,39.9246795,1410.7415461,308.4417276,1243.5456413,30.2820885,52.2634486,1.4764824,189.322047),(47833,'tibia.tif',233,8,45,247.8265503,67.2325805,94.1282164,1.8,67.1128383,94.1385439,1.3887185,18.2080776,31.7715978,11913.8430175,54016.7900176,39.9501529,1700.1596953,654.3163567,2061.8096077,30.2245644,51.7560879,1.5164282,254.7918199),(47834,'tibia.tif',233,8,46,249.0147932,67.369984,94.4432394,1.8,67.2280345,94.2479764,1.3811323,18.0462157,33.9120905,11943.0706862,52757.0323394,40.0273365,1555.6997988,661.8047183,1800.6008252,2.1670523,26.5167255,1.4645315,70.0297299),(47835,'tibia.tif',233,8,47,250.3898906,67.4916052,94.7225587,1.8,67.2771592,94.6463377,1.3745496,22.7554654,30.9027646,11879.113627,51677.6272395,40.144973,1672.2655021,522.0334278,1906.8362764,29.7244679,50.4500657,1.4870764,195.550224),(47836,'tibia.tif',233,8,48,253.3513967,67.6149793,95.132837,1.8,67.5225459,95.1627083,1.3650101,41.5452299,30.4012605,11915.8197027,49946.750029,40.4621796,1642.9170782,286.8155918,1483.9965194,2.1846942,41.385881,1.4601391,100.8965184),(47837,'tibia.tif',233,8,49,253.1348418,67.9014108,95.603361,1.8,67.7310142,95.5859986,1.355223,17.448755,34.4429954,11845.110155,47341.9201842,40.2587156,1374.5006673,678.8513078,1614.4047871,2.252693,29.3148746,1.4747076,80.4559529),(47838,'tibia.tif',233,8,50,251.9133404,68.0274863,96.0040017,1.8,67.8819415,95.9014876,1.3453923,17.8738109,29.1363266,11715.025667,44897.5386515,39.8882809,1540.9471232,655.4296522,1928.2393893,29.2625437,47.5662217,1.5042282,220.0681985),(47839,'tibia.tif',233,8,51,252.2861504,68.1811869,96.4765023,1.8,68.0626028,96.3504837,1.3369185,17.7405958,28.3948932,11684.1608907,42769.8533904,39.789363,1506.2516053,658.6115256,1881.8639499,29.2015026,46.4394639,1.5329356,230.906302),(47840,'tibia.tif',233,8,52,253.5266781,68.3746037,96.8824617,1.8,68.3708848,96.7936895,1.3261643,26.9243626,35.1377207,11709.9826796,41136.2165781,39.7757791,1170.7138585,434.9214446,1193.8016623,29.2013984,45.4182184,1.6250067,215.1816642),(47841,'tibia.tif',233,8,53,254.0910616,68.5058047,97.2159354,1.8,68.4569552,97.1046071,1.3169457,32.8708044,34.4878333,11663.3304309,39731.8482975,39.6776819,1152.0540585,354.8233959,1078.7454519,29.0852271,44.4652971,1.6578771,196.2679837),(47842,'tibia.tif',233,8,54,254.5884787,68.6550393,97.6091016,1.8,68.6418594,97.516839,1.3078996,18.0986659,27.9188672,11661.6154617,38272.4012145,39.565722,1370.8436271,644.3356379,1773.7498742,0.703124,0.9943675,0.7853982,1.988735),(47843,'tibia.tif',233,8,55,254.7196027,68.8403222,98.0220173,1.8,68.8712101,97.9786647,1.2970014,18.2513468,25.864632,11666.0840547,36751.4247468,39.3495459,1420.914271,639.1903135,1862.6764087,2.3330707,35.3315437,1.4711277,88.6168331),(47844,'tibia.tif',233,8,56,255.7773583,69.0351252,98.4350398,1.8,69.1555536,98.355426,1.2839039,29.3894345,33.1028057,11724.6073615,35481.5451194,39.216052,1071.859147,398.9395365,1070.6976659,2.3378974,33.5166017,1.486784,83.3890859),(47845,'tibia.tif',233,8,57,257.2929055,69.3008073,98.7902174,1.8,69.3403089,98.5916426,1.27219,22.5980814,31.5998269,11752.5684689,33723.9679654,39.1708358,1067.2200206,520.0693047,1170.6060583,2.5346845,32.787751,1.4956692,77.8847309),(47846,'tibia.tif',233,8,58,256.5553005,69.5046818,99.2788855,1.8,69.6389296,99.170838,1.2567576,28.7435891,32.4773107,11775.5739021,31986.7523596,38.6791035,984.8953528,409.676532,1009.0426158,2.3949095,31.7653339,1.4821404,76.3578459),(47847,'tibia.tif',233,8,59,257.2695721,69.7088227,99.7135256,1.8,69.8956612,99.6987539,1.2449577,20.5310976,30.0818269,11769.1157861,30488.3195521,38.4846908,1013.5128982,573.2336401,1160.269719,2.5346845,32.4371914,1.4948557,81.9121704),(47848,'tibia.tif',233,8,60,258.3233203,69.9149381,100.1549038,1.8,70.1499661,100.1690051,1.2278231,30.1360408,32.8288156,11864.9134817,29197.6470618,38.1849211,889.3908163,393.7117534,921.4377857,2.7930085,31.7108144,1.5042282,75.4134479),(47849,'tibia.tif',233,8,61,258.008825,70.152193,100.5813257,1.8,70.4056669,100.5954626,1.2096778,19.3490961,29.8188116,11924.2837276,27971.5839694,37.6333568,938.0516004,616.2708405,1122.3591789,2.4877858,29.9344256,1.5120405,68.6234819),(47850,'tibia.tif',233,8,62,258.913659,70.4066277,100.999474,1.8,70.6311782,101.0304273,1.1904445,18.1009189,25.0049855,12049.0632808,26988.5006016,37.2048365,1079.3247833,665.6603089,1559.2141253,2.4853149,28.881626,1.5098961,67.1672644),(47851,'tibia.tif',233,8,63,258.7162427,70.6292911,101.3558282,1.8,70.9320544,101.3902699,1.1728574,18.1231476,23.3493398,12124.8136594,26097.4369064,36.6440904,1117.6948527,669.02361,1612.8064856,2.213233,27.8089764,1.5202066,62.2807302),(47852,'tibia.tif',233,8,64,259.1199142,70.9055611,101.80085,1.8,71.1934605,101.8157026,1.15446,28.552299,33.9336732,12286.2695701,25127.8043901,36.1234982,740.4976236,430.3075404,843.6510561,2.3036428,23.9707543,1.497399,55.5407337),(47853,'tibia.tif',233,8,65,258.9295017,71.2558454,102.1630874,1.8,71.617895,102.291103,1.1364811,27.4533684,33.988552,12372.5917744,24132.6275522,35.5137503,710.0222318,450.6766379,838.0795442,2.355477,27.4781183,1.5067813,60.3772984),(47854,'tibia.tif',233,8,66,257.0481483,71.5010942,102.5159118,1.8,71.8616331,102.5691568,1.1170377,17.7140642,18.9915857,12332.0726766,23012.9248519,34.6094772,1211.7432006,696.1740984,1588.7953223,2.2913834,25.7025245,1.5160565,61.6275757),(47855,'tibia.tif',233,8,67,257.96875,71.7648412,102.8604654,1.8,72.1905771,102.9042837,1.0959056,17.5082403,23.8171914,12422.9428567,22314.5322542,34.005887,936.9086352,709.5483415,1445.4743563,27.8826927,37.937759,2.5741527,321.790989),(47856,'tibia.tif',233,8,68,256.650282,72.0310756,103.2315317,1.8,72.5044646,103.3080788,1.0770812,17.358748,25.6073874,12444.5615825,21473.7061528,33.1685522,838.5746575,716.9043285,1299.7365089,2.3205775,23.5782545,1.5260501,54.0491824),(47857,'tibia.tif',233,8,69,256.463952,72.3204642,103.602463,1.8,72.7811853,103.6971494,1.0557121,17.1389434,24.5623934,12565.4207494,20701.1700866,32.3716171,842.7993874,733.1502581,1354.2318328,2.7289095,23.9990961,1.482789,59.2769297),(47858,'tibia.tif',233,8,70,255.5886312,72.5754347,103.929969,1.8,72.9960602,104.0195419,1.0338795,16.9116702,26.0081352,12621.9758737,19935.9655248,31.4535413,766.5280627,746.3470912,1240.2135076,2.3844481,22.9486791,1.4787495,52.6929039),(47859,'tibia.tif',233,8,71,256.2915919,72.8782791,104.2785503,1.8,73.2862119,104.3642588,0.9997562,16.7626661,24.1806203,12739.0743711,19345.853953,30.2360722,800.0561487,759.9670777,1320.9870638,2.437789,22.6341502,1.4618544,55.5053999),(47860,'tibia.tif',233,8,72,257.041594,73.1870168,104.6163703,1.8,73.6697733,104.8124678,0.9538093,23.2783733,36.9543779,12857.7480903,18893.5018391,28.4992631,511.2655899,552.3473613,726.9885338,2.1987957,19.7657899,1.4817467,48.5947969),(47861,'tibia.tif',233,8,73,257.1728303,73.5795358,104.8433604,1.8,74.0942051,105.0651751,0.9167859,15.832615,23.3955789,12881.4729364,18243.8559044,26.9980405,779.7992936,813.6036215,1272.4629992,2.2602651,20.5385638,1.4506876,46.6060619),(47862,'tibia.tif',233,8,74,257.1150024,73.8962583,105.131439,1.8,74.3893046,105.3560436,0.868033,15.2892426,23.0526822,12823.467134,17743.7704912,24.9512606,769.7052498,838.7248101,1152.9206095,25.8128208,36.0535359,2.7302989,155.110245),(47863,'tibia.tif',233,8,75,257.1879239,74.2582512,105.39851,1.8,74.8078673,105.6726906,0.8078318,17.1032602,36.0473694,12799.7477467,17405.7254743,22.393613,482.8570233,748.3805769,800.5361418,2.4156686,18.7518043,1.4580687,49.4331937),(47864,'tibia.tif',233,8,76,257.4375501,74.6307928,105.6317483,1.8,75.2550447,105.8630294,0.7373821,19.8398185,24.1482064,12736.9959738,17169.4682427,19.3961062,711.0038723,641.991558,1118.0784827,25.5945866,35.4101651,2.7223603,150.550288),(47865,'tibia.tif',233,8,77,257.2430552,75.0390198,105.888441,1.8,75.6130322,106.0987162,0.652795,17.5685307,19.1534796,12681.0282623,16958.6764842,15.818124,885.4096947,721.803574,1170.5785642,2.294112,19.7657899,1.4817467,48.3035534),(47866,'tibia.tif',233,8,78,256.3212924,75.4530919,106.15337,1.8,76.0017767,106.3642919,0.5643777,17.0723534,28.1781027,12567.8902637,16816.9004059,12.2225706,596.807406,736.1545265,1023.6174624,2.2267205,19.4918858,1.4442042,46.1088782),(47867,'tibia.tif',233,8,79,256.8039154,75.8800415,106.3898215,1.8,76.4683135,106.5455423,0.4803233,16.220691,20.0927443,12450.8529577,16836.059992,9.1381508,837.9173985,767.5907848,1336.7912496,1.8931318,19.1431885,1.4418856,44.8232672),(47868,'tibia.tif',233,8,80,256.851144,76.270342,106.6037378,1.8,76.8406331,106.8344989,0.4103064,16.2893705,29.1153217,12341.8579316,16917.8373644,6.8114138,581.0630411,757.6632816,962.738581,1.6359961,15.2636221,1.4321566,35.3061085),(47869,'tibia.tif',233,8,81,257.4247785,76.8029168,106.7349026,1.8,77.56828,106.9841277,0.3281048,16.9102392,28.7532812,12194.8569444,17019.2190138,4.4553696,591.905281,721.1522441,951.3020122,1.9140755,16.0105519,1.4164776,37.8773304),(47870,'tibia.tif',233,8,82,256.3603187,77.2329454,106.9110937,1.8,77.9941868,107.1392627,0.2616242,16.558145,28.7797632,11970.6626468,16955.4757417,2.8584052,589.145769,722.9470838,928.7093415,1.9962462,14.2198029,1.4219064,34.3617104),(47871,'tibia.tif',233,8,83,258.5239575,77.7068206,107.0804481,1.8,78.6559028,107.2921586,0.2090969,17.8302786,37.5473567,11802.8679599,17112.6489152,1.8565474,455.7617477,661.9564529,754.6619418,1.9985737,13.9300204,1.3932002,33.8645267),(47872,'tibia.tif',233,8,84,258.5494632,78.1439218,107.2592006,1.8,79.1493049,107.5101912,0.1576706,18.9525389,26.7262606,11674.4171731,17152.6051393,1.06241,641.7884422,615.9817036,952.0866661,1.9536619,15.6632609,1.4130276,38.1685739),(47873,'tibia.tif',233,8,85,258.9586778,78.5765639,107.3811343,1.8,79.5707498,107.6075303,0.1100731,19.2777793,23.9517161,11434.7721233,17229.6510605,0.5208192,719.3493346,593.1581627,1181.0650482,2.1304527,14.2198029,1.4219064,34.1911039),(47874,'tibia.tif',233,8,86,260.4761725,79.0432949,107.4818457,1.8,80.0948946,107.657734,0.0770454,19.2899898,33.7730932,11209.074064,17411.5335057,0.2571881,515.5445315,581.0824253,798.9312508,2.0818495,15.7223306,1.3909428,38.3745142),(47875,'tibia.tif',233,8,87,261.0662116,79.4662824,107.5641801,1.8,80.3951596,107.658933,0.0466152,19.1910895,21.7042526,10962.3258304,17440.7489265,0.0944802,803.563672,571.2195661,1270.7949403,1.5304844,9.5505879,1.4601391,22.9764537),(47876,'tibia.tif',233,8,88,263.1256554,79.9455922,107.6531251,1.8,80.8257481,107.7212241,0.0165757,14.467386,22.1196612,10817.8538363,17578.296965,0.0120481,794.6910576,747.7407352,1230.3059578,1.0500667,10.0672036,1.359703,21.7261765),(47877,'tibia.tif',233,8,89,266.5620691,80.5524966,107.6572363,1.8,81.7540927,107.7408709,-0.0219295,18.4278693,20.2038824,10754.5987246,17794.1343317,0.0213616,880.728463,583.6051121,1294.0972036,1.6770845,11.5160035,1.3554386,27.983625),(47878,'tibia.tif',233,8,90,266.7232681,80.9894595,107.7434162,1.8,82.2326707,107.8379138,-0.0495646,18.5922009,19.8375559,10563.0202109,17715.9861468,0.1091182,893.0528652,568.1425375,1276.7624588,1.7255141,7.9316002,1.3473197,19.787411),(47879,'tibia.tif',233,8,91,267.5859296,81.433441,107.7997092,1.8,82.7552741,107.8467065,-0.0845952,19.3066647,19.6962514,10450.4228658,17716.4736163,0.3183954,899.4845392,541.2857701,1185.7607064,1.6044495,10.1466908,1.3258177,23.885518),(47880,'tibia.tif',233,8,92,269.0244728,81.8557526,107.8228057,1.8,83.1261419,107.8322717,-0.1221978,19.7884187,19.7445997,10275.6360074,17785.850249,0.6662004,900.7956861,519.2752467,1101.4355408,1.7106281,10.4881027,1.3339476,25.291766),(47881,'tibia.tif',233,8,93,269.9448498,82.2697126,107.8295286,1.8,83.4795116,107.8250413,-0.1516663,20.0772184,23.5199282,10124.7066102,17729.3237192,1.0269979,753.8000785,504.2883134,935.1152265,1.4702017,9.8059963,1.3171222,22.1880265),(47882,'tibia.tif',233,8,94,270.8393466,82.6521551,107.8353786,1.8,83.7934753,107.8695995,-0.1786973,20.3505795,19.1261507,9924.13862,17643.199551,1.4261614,922.4647374,487.6587737,1084.7224117,1.406248,4.3485818,1.3258177,10.184949),(47883,'tibia.tif',233,8,95,271.5913711,82.9818172,107.8428302,1.8,83.9977728,107.8598118,-0.213591,18.8129596,19.0559021,9752.5183262,17547.5184297,2.0338376,920.8442792,518.3936256,1280.3627393,1.0417011,8.2747867,1.3567356,17.919313),(47884,'tibia.tif',233,8,96,271.9098364,83.3335206,107.8387343,1.8,84.2740416,107.8113433,-0.2486882,21.1132323,18.6461517,9541.647382,17451.5372799,2.7454431,935.9323877,451.9273631,1060.6075316,0.703124,3.9305827,1.3909428,8.316851),(47885,'tibia.tif',233,8,97,272.6928722,83.7729737,107.7667822,1.8,84.7651621,107.8361061,-0.2798095,21.2522109,22.0420371,9444.195595,17282.9253904,3.466439,784.0892984,444.3864988,904.6706372,0.351562,1.7926215,1.7681919,3.8068635),(47886,'tibia.tif',233,8,98,270.9366503,84.0797614,107.7715147,1.8,85.0708863,107.8943693,-0.3051349,19.4346736,17.982402,9174.8774354,16926.0840317,4.0754875,941.2582371,472.0880632,1330.5533552,0.351562,1.4495273,1.815775,3.1037395),(47887,'tibia.tif',233,8,99,270.4506939,84.4139956,107.7751878,1.8,85.3909236,107.9030723,-0.3320807,19.9600644,17.7225088,9020.3633174,16671.8014038,4.7907185,940.7133953,451.9205514,1267.9641369,0.703124,2.55941,1.2924967,5.504355),(47888,'tibia.tif',233,8,100,270.4696453,84.7151757,107.7839096,1.8,85.587581,107.9647244,-0.357984,20.1763759,17.610093,8845.2907257,16431.7592041,5.5343003,933.0875872,438.3983915,1235.8910549,26.1575283,31.8352931,0.5328439,181.3549824),(47889,'tibia.tif',233,8,101,270.36766,84.9941002,107.7873337,1.8,85.8363404,107.9949329,-0.3804691,21.6411636,38.8839385,8724.4749424,16221.1743543,6.2141889,417.1690155,403.1425997,639.7599079,0.351562,1.4495273,1.815775,3.1037395),(47890,'tibia.tif',233,8,102,269.6377329,85.2620356,107.7803465,1.8,86.0104076,107.9492486,-0.3986308,20.9925548,19.569059,8549.1275908,15981.6118145,6.7708622,816.6775841,407.2456965,854.757913,24.114466,31.0511054,0.5345943,148.178944),(47891,'tibia.tif',233,8,103,270.0973971,85.5793631,107.7613199,1.8,86.2313565,107.8611495,-0.4054362,12.8284043,16.9226071,8401.8481029,15982.9126391,7.0030347,944.4710603,654.9410138,1440.0897622,0.351562,0.7861165,2.0344439,1.6974915),(47892,'tibia.tif',233,8,104,270.4862371,85.8393471,107.7699246,1.8,86.4418691,107.8947631,-0.4154323,12.4874575,16.8351231,8312.6778564,15776.890234,7.3428553,937.1413647,665.682175,1427.3675194,23.8889324,30.7491167,0.5404195,180.9784356),(47893,'tibia.tif',233,8,105,270.4199073,86.1746939,107.7426858,1.8,86.789966,107.8810427,-0.4314908,12.3123109,16.530646,8257.0892215,15463.2582283,7.883304,935.4297587,670.6368335,1431.3578212,23.79599,30.4217956,0.5880026,158.0373157),(47894,'tibia.tif',233,8,106,267.7298626,86.3752287,107.7827613,1.8,86.9893477,107.9266959,-0.4407604,22.0228421,16.3721336,8144.0950913,15107.5065442,8.1216257,922.7573465,369.802184,987.1945582,23.2024183,30.1299095,0.594475,151.6592302),(47895,'tibia.tif',233,8,107,265.4845007,86.5686905,107.8138518,1.8,87.132433,107.9287126,-0.4547918,18.1816109,23.0010122,8053.0109244,14777.5156896,8.5381047,642.4724072,442.9206505,921.1648627,23.7270934,30.1483632,0.5524189,148.058307),(47896,'tibia.tif',233,8,108,265.2347996,86.820051,107.833776,1.8,87.2789711,107.9147158,-0.4539145,18.0568979,24.0038053,7958.5006054,14692.2004071,8.4994851,612.0779695,440.7457276,891.3016521,23.3781076,29.5521269,0.5649044,140.8917942),(47897,'tibia.tif',233,8,109,264.3166324,87.0057848,107.8744294,1.8,87.4951901,107.9481106,-0.4655752,18.8412103,17.9040285,7913.1545608,14443.6158588,8.878584,806.7243571,419.9918396,1186.0402684,23.1976407,29.35069,0.5979691,144.0308675),(47898,'tibia.tif',233,8,110,263.3086147,87.1773962,107.9384397,1.8,87.6784123,108.0571261,-0.4756979,19.837559,15.5920838,7891.6508956,14143.811825,9.2037972,907.1149186,397.8136064,1102.440631,22.8834532,28.881626,0.5508575,152.5329607),(47899,'tibia.tif',233,8,111,264.0682796,87.3379424,107.995486,1.8,87.7608398,108.1612014,-0.4880384,18.2761409,15.489089,7877.1346413,13936.4247241,9.6764186,899.7575489,431.0064509,1193.5430297,23.0845108,28.690561,0.6287963,153.8892392),(47900,'tibia.tif',233,8,112,266.1088469,87.6100641,108.017466,1.8,87.9915913,108.1420219,-0.4808417,13.3601051,15.263861,7887.0485705,14078.086691,9.488109,922.3149187,590.3433032,1213.8419275,0.351562,0.4971837,2.3561945,0.9943675),(47901,'tibia.tif',233,8,113,265.332328,87.853585,108.0034503,1.8,88.2216393,108.1302599,-0.5001967,16.9810725,15.0802579,7849.1365106,13673.4202398,10.1717084,906.7099714,462.2285497,1200.0883203,22.6047881,28.2761647,0.6708575,130.4156018),(47902,'tibia.tif',233,8,114,264.0438601,87.9957782,108.0437267,1.8,88.3455088,108.1349553,-0.5079323,15.5181166,14.9895282,7769.6800482,13378.602991,10.4102522,892.5299616,500.6844752,1293.7584024,22.8904044,28.0589647,0.6610432,146.2401785),(47903,'tibia.tif',233,8,115,263.3822104,88.1367394,108.1035763,1.8,88.4981297,108.3096767,-0.5213333,14.8458265,14.8751664,7774.0442273,13135.9318755,10.8882474,883.07798,523.6518318,1304.7570129,22.7423282,27.7288608,0.6866216,140.1886702),(47904,'tibia.tif',233,8,116,265.0203047,88.3658341,108.1110718,1.8,88.7205389,108.1778797,-0.5020048,12.5375189,14.9643714,7754.9150832,13281.2529673,10.2270451,887.5249463,618.5366592,1401.124291,22.7603136,27.8445094,0.6510767,135.5580457),(47905,'tibia.tif',233,8,117,264.3452467,88.471225,108.1406553,1.8,88.7847588,108.2333615,-0.5120282,12.4187664,14.9364556,7736.5317221,13092.9652255,10.5758984,876.5777917,622.9710303,1383.0478155,22.6114446,26.6004922,0.5109496,101.9347931),(47906,'tibia.tif',233,8,118,263.2168541,88.5701199,108.1777619,1.8,88.8688841,108.3005668,-0.5225286,12.5010523,14.7660783,7710.2518038,12874.5352382,10.9267347,871.8994267,616.7682203,1390.329338,22.6305885,26.470074,0.5290305,107.8156948),(47907,'tibia.tif',233,8,119,262.9991756,88.6727389,108.1963473,1.8,88.9678443,108.2567973,-0.5308329,12.5692296,14.4685513,7647.1971538,12695.215746,11.2340493,877.4351666,608.4061971,1401.2267019,22.6558617,26.2943935,0.5174877,116.0618783),(47908,'tibia.tif',233,8,120,262.6276765,88.7719837,108.217381,1.8,89.0523416,108.3160856,-0.5385559,11.7295369,14.3440858,7616.8583291,12512.9102713,11.5146106,872.3393363,649.3741761,1400.39939,22.4066388,26.1222631,0.5057913,88.6814383),(47909,'tibia.tif',233,8,121,264.9062969,89.1177783,108.1530636,1.8,89.4914296,108.2399504,-0.5183489,12.3591675,14.9606603,7683.4746977,12584.3184064,10.8376391,841.1606258,621.6822215,1351.5216838,22.6351756,26.1671732,0.5358112,106.7006903),(47910,'tibia.tif',233,8,122,262.8870405,89.2306532,108.1700002,1.8,89.5977519,108.2785477,-0.5267273,12.3567149,14.2223526,7588.2614785,12329.5123311,11.0725487,866.9108898,614.1002329,1399.4177756,22.9985731,25.9894453,0.5241796,107.6950578),(47911,'tibia.tif',233,8,123,260.3040747,89.3461274,108.1825061,1.8,89.7096195,108.2613385,-0.5383577,12.3758535,14.7973784,7470.9230141,12082.7225088,11.4051631,816.5448083,603.6693144,1313.8039318,22.6218606,25.8152817,0.5123895,97.3041686),(47912,'tibia.tif',233,8,124,258.9159061,89.4630993,108.1894768,1.8,89.8440218,108.2881848,-0.5442783,24.0369499,24.2744569,7387.3224919,11882.5498914,11.5699881,489.5083725,307.3319418,564.0776652,22.8554626,25.8655037,0.5427505,98.7457503),(47913,'tibia.tif',233,8,125,258.0700612,89.583391,108.1759945,1.8,89.9399525,108.2435947,-0.5541033,11.8372511,14.6041443,7297.4827772,11683.811684,11.9084907,800.0339777,616.4845798,1297.9542409,23.0893678,25.6664338,0.6298033,101.7288528),(47914,'tibia.tif',233,8,126,257.1071747,89.6894628,108.1716973,1.8,90.0274455,108.225009,-0.563961,11.7712062,14.4098055,7227.9144414,11472.0265546,12.2439107,796.1263965,614.0334567,1293.5668387,22.6390008,25.5481825,0.5994525,103.9941956),(47915,'tibia.tif',233,8,127,258.7692765,89.8752688,108.1459904,1.8,90.1802591,108.2273227,-0.5496225,11.6584779,14.4035228,7189.0893468,11562.3232337,11.7682057,802.7427295,616.6404736,1292.4929466,20.0292604,25.6664338,0.6298033,75.2221434),(47916,'tibia.tif',233,8,128,258.2847808,89.9795965,108.1365374,1.8,90.2210685,108.2234825,-0.5590803,11.6796972,14.064476,7129.9781383,11396.6466837,12.1105992,810.3143462,610.4591615,1316.191068,21.961963,25.5481825,0.5994525,113.52599),(47917,'tibia.tif',233,8,129,259.4782298,90.298835,108.0603486,1.8,90.6349962,108.2135206,-0.5404928,11.7213516,14.5986728,7179.4482229,11411.8200118,11.4503651,781.7025696,612.5102674,1236.7818677,22.5833605,25.5481825,0.5994525,100.7344853),(47918,'tibia.tif',233,8,130,257.2677744,90.4123811,108.0556449,1.8,90.7687274,108.156984,-0.5495337,12.0549605,14.0143333,7086.1711997,11163.702905,11.6965264,796.5917947,587.8220193,1295.2304651,22.4513698,25.3831659,0.637961,99.8254211),(47919,'tibia.tif',233,8,131,254.9734985,90.5305209,108.0631558,1.8,90.8770868,108.2013396,-0.5575643,11.8390603,14.3399384,7007.3798149,10933.2792203,11.8974461,762.435578,591.8864863,1249.4133182,22.3027071,25.2660348,0.5571244,106.5300838),(47920,'tibia.tif',233,8,132,253.8822221,90.6385056,108.064124,1.8,91.0451279,108.2359587,-0.5645279,12.0585303,14.1451426,6956.5148615,10776.5371041,12.1120108,761.8542543,576.8957499,1249.2468895,0.351562,1.4495273,1.815775,3.1037395),(47921,'tibia.tif',233,8,133,252.1600452,90.7232287,108.0570985,1.8,91.1056924,108.2648308,-0.571603,12.3017097,14.1836299,6902.4762664,10610.2640015,12.2995401,748.0640753,561.0989395,1233.4498739,1.3373649,6.4633887,1.1801893,14.283056),(47922,'tibia.tif',233,8,134,250.3022874,90.7982307,108.030211,1.8,91.1397002,108.1391563,-0.5818768,12.6473165,14.3052625,6801.3321931,10468.1281118,12.6007294,731.7676352,537.7687986,1205.2831643,1.2258126,8.2298554,1.2220253,17.798676),(47923,'tibia.tif',233,8,135,252.6861515,91.0281047,108.0230932,1.8,91.3191616,108.1326197,-0.5330279,12.1383307,14.0470806,6869.3969229,10696.8574239,10.8743397,761.5003959,565.9260001,1242.3180458,0.351562,0.4971837,2.3561945,0.9943675),(47924,'tibia.tif',233,8,136,251.4464852,91.093299,108.0074643,1.8,91.3043314,108.1171158,-0.5348137,12.3589291,13.7508083,6805.7633209,10590.8821688,10.8865648,770.2007017,550.6758129,1264.2130252,20.0156963,24.9831742,0.6857295,74.2277759),(47925,'tibia.tif',233,8,137,248.769624,91.2384536,107.928606,1.8,91.5066929,107.9883492,-0.5473556,12.4457724,13.8915304,6723.547038,10371.5776938,11.2298092,746.6115979,540.2273837,1230.5135255,0.351562,1.4495273,1.815775,3.1037395),(47926,'tibia.tif',233,8,138,244.7709241,91.3005164,107.9290551,1.8,91.55905,108.051037,-0.5522339,12.4727378,13.8396333,6633.3957673,10194.9271802,11.2266258,736.6472042,531.8315733,1215.8861301,0.351562,0.7861165,2.0344439,1.6974915),(47927,'tibia.tif',233,8,139,242.3387452,91.3581383,107.9395989,1.8,91.617211,108.0784619,-0.556669,13.2166804,13.7967825,6567.2959551,10025.485893,11.2754337,726.653908,496.8945112,1185.5141546,19.9082885,24.7620468,0.6747409,73.2334084),(47928,'tibia.tif',233,8,140,239.9452931,91.4186057,107.9246488,1.8,91.7481863,108.0355326,-0.5461476,28.177748,14.5369563,6530.6817142,9856.4444629,10.7885575,678.0266976,231.7673403,516.836412,0.351562,2.1384682,1.735945,4.5099875),(47929,'tibia.tif',233,8,141,242.2082954,91.7088047,107.884141,1.8,91.9996535,108.0051024,-0.4779799,14.6853075,13.2684797,6595.9680557,10288.4587333,8.5413736,775.4059958,449.1542345,1149.7472517,22.196196,24.7695327,0.6037493,108.2629091),(47930,'tibia.tif',233,8,142,239.1887742,91.7468447,107.8726998,1.8,92.037301,108.0031296,-0.475862,15.3318923,13.223936,6531.6410828,10144.8777817,8.3660295,767.1602306,426.0166295,1078.5788013,22.097267,24.6845598,0.6235607,89.5905026),(47931,'tibia.tif',233,8,143,237.6607925,91.7901847,107.8570598,1.8,92.0731659,108.0062426,-0.4705873,15.6396867,13.1587935,6477.5232728,10046.740939,8.143071,763.5001593,414.1721899,1031.8074864,21.7335372,24.60934,0.6435011,108.142272),(47932,'tibia.tif',233,8,144,236.6211642,91.8209235,107.8378769,1.8,92.0746027,107.9680373,-0.4683104,15.314001,13.1183399,6428.1698585,9971.0718066,8.0349939,760.0864029,419.7577014,1061.5598691,19.9842079,24.5439631,0.6635557,73.4393486),(47933,'tibia.tif',233,8,145,234.9699238,91.9296523,107.7395558,1.8,92.2172944,107.8926831,-0.4791146,11.6888691,13.7826265,6428.2057234,9805.3793948,8.3224438,711.4303954,549.942485,1168.5759669,21.8647991,24.5439631,0.6635557,93.1414564),(47934,'tibia.tif',233,8,146,232.1004404,91.9533796,107.7234765,1.8,92.2482734,107.8601333,-0.4822365,14.2248423,13.4334246,6381.9402511,9667.893413,8.3198331,719.6894118,448.647523,1123.484294,21.7648586,24.5439631,0.6635557,105.2798066),(47935,'tibia.tif',233,8,147,233.118121,92.1313515,107.7339579,1.8,92.4485758,107.9357603,-0.435927,14.4828481,13.382883,6480.8770754,9878.2280483,6.9273312,738.1240664,447.4863652,1129.4654008,1.0561843,6.78979,1.199905,14.6949365),(47936,'tibia.tif',233,8,148,231.6960947,92.1552651,107.7272964,1.8,92.4745666,107.9821351,-0.4391064,14.0104037,23.1736238,6466.2940833,9824.7796134,6.9793128,423.9638861,461.5351714,650.1060956,22.097267,24.8815506,1.9775434,116.9916406),(47937,'tibia.tif',233,8,149,229.80373,92.167603,107.7190757,1.8,92.4407613,107.9931203,-0.4428742,14.4791764,23.2240609,6437.4631721,9752.0153712,7.0337165,419.9099989,444.6014738,645.6809702,1.5030111,6.3378741,1.2315037,15.1921202),(47938,'tibia.tif',233,8,150,227.4604653,92.1830913,107.7032515,1.8,92.4889941,107.9131849,-0.4400692,13.4022977,13.4780569,6390.2214353,9652.4583035,6.8798357,716.1609703,476.800441,1175.9992044,1.2896425,9.140612,1.1760052,19.787411),(47939,'tibia.tif',233,8,151,226.3155933,92.2107959,107.6997977,1.8,92.475893,107.9015821,-0.4321429,14.8733601,40.4090556,6361.7812696,9644.2418205,6.6162708,238.6653607,427.7299293,394.797198,20.21426,24.4000238,0.6319742,73.1481051),(47940,'tibia.tif',233,8,152,225.2378001,92.23331,107.685099,1.8,92.4343225,107.8506801,-0.4247376,11.7866843,41.2749493,6342.2966369,9665.0870228,6.3746542,234.1635103,538.0899751,386.2434535,20.1333169,24.3772188,0.5800028,73.1481051),(47941,'tibia.tif',233,8,153,226.4351816,92.5056667,107.5846714,1.8,92.7865769,107.7362723,-0.38551,16.1895488,13.6193885,6447.4018665,9754.0312947,5.3363174,716.187168,398.2446919,965.938355,20.3060149,24.4834602,0.5601214,73.8512291),(47942,'tibia.tif',233,8,154,224.6123302,92.5265572,107.5898878,1.8,92.8323237,107.7840286,-0.3851543,15.9111401,18.2663461,6403.3792045,9653.7911111,5.2840827,528.5014876,402.4462842,714.9551888,20.3060149,24.3772188,0.5800028,73.5599856),(47943,'tibia.tif',233,8,155,222.7792916,92.5392277,107.5782913,1.8,92.8792998,107.7158061,-0.3885262,16.0744252,13.4611972,6375.3900015,9542.8410718,5.3284462,708.9147375,396.6169824,803.0479568,20.2557937,24.3772188,0.5800028,73.3540454),(47944,'tibia.tif',233,8,156,220.1041907,92.5479039,107.5837657,1.8,92.8512279,107.7197364,-0.3902048,11.2242218,13.1919257,6314.2821173,9474.2035627,5.3077122,718.1819977,562.5585681,1185.8042403,22.1456359,24.2985046,0.5478635,105.4357773),(47945,'tibia.tif',233,8,157,218.4070326,92.5731816,107.5875328,1.8,92.8659013,107.7358325,-0.3890636,11.5861048,13.5679658,6283.6595571,9434.593124,5.2375946,695.3579699,542.3444422,1134.4575619,20.2710241,24.2985046,0.5478635,73.1481051),(47946,'tibia.tif',233,8,158,217.5547456,92.5867604,107.5867219,1.8,92.8924824,107.7477272,-0.3886644,12.6788093,13.3464103,6269.2775961,9405.4651549,5.207,704.718719,494.4689543,1168.2048845,22.148406,24.2985046,0.5478635,108.2129396),(47947,'tibia.tif',233,8,159,219.6104066,92.6913261,107.5607838,1.8,92.9442621,107.7630906,-0.3776753,12.0059525,12.8293665,6305.4665728,9697.4066204,4.9772633,755.8757201,525.1950281,1225.1125437,22.0618388,24.3822884,0.4958945,108.0923026),(47948,'tibia.tif',233,8,160,219.3625408,92.7004165,107.5370194,1.8,92.9348453,107.6777953,-0.3696741,11.6078263,12.9930298,6277.9442937,9727.3810224,4.7728176,748.6614854,540.837202,1216.2780632,21.3070157,24.3822884,0.4958945,101.0963963),(47949,'tibia.tif',233,8,161,219.4704062,92.7736057,107.4417354,1.8,93.078843,107.5820183,-0.3771445,12.9795319,13.5588164,6291.5679312,9639.6058148,4.9607886,710.9474415,484.7299581,1093.3113126,20.1536761,24.2985046,0.5478635,73.4393486),(47950,'tibia.tif',233,8,162,218.0337357,92.7534316,107.4472136,1.8,93.0307452,107.5956534,-0.3754598,11.2851456,13.2496939,6255.2700587,9573.2611044,4.8864678,722.5269658,554.2923644,1183.558782,0.351562,1.4495273,1.815775,3.1037395),(47951,'tibia.tif',233,8,163,216.3236187,92.7435347,107.4439718,1.8,93.076011,107.564192,-0.3707804,13.7831486,13.2490968,6239.9360963,9514.3098939,4.7336065,718.1100722,452.7221078,991.1295075,21.796844,24.2985046,0.5478635,106.0182643),(47952,'tibia.tif',233,8,164,218.6657973,92.9031506,107.4602283,1.8,93.19003,107.607672,-0.3255479,11.8133942,13.5586114,6325.3363094,9868.2885262,3.7278839,727.824426,535.4376756,1181.8345454,22.0974322,24.5817018,0.2900869,108.0069993),(47953,'tibia.tif',233,8,165,217.8130984,92.9058513,107.4591689,1.8,93.2024435,107.6124433,-0.3201206,13.1866034,13.7678524,6322.5593871,9874.1008416,3.5947919,717.1852646,479.4683821,1006.1196096,20.3522148,24.5817018,0.2900869,74.6396564),(47954,'tibia.tif',233,8,166,216.8683018,92.9020799,107.446974,1.8,93.1530454,107.5709026,-0.3166121,11.7982988,12.8908478,6332.0582652,9874.5225954,3.5038011,766.0103316,536.6924814,1199.3265262,20.3522148,24.5817018,0.2900869,74.6396564),(47955,'tibia.tif',233,8,167,215.5463132,92.8664835,107.4460866,1.8,93.130126,107.5782051,-0.3114081,12.1492068,13.2252083,6331.8146165,9884.5525136,3.3726007,747.4024047,521.1710283,1136.5484202,20.294402,24.5817018,0.2900869,74.6396564),(47956,'tibia.tif',233,8,168,214.4730519,92.8475947,107.4370708,1.8,93.0819348,107.6132838,-0.3077187,12.4708828,13.0035141,6366.2520775,9885.4462395,3.2792746,760.2134466,510.4892861,1119.3300007,20.294402,24.5817018,0.2900869,74.6396564),(47957,'tibia.tif',233,8,169,214.8139891,92.9416804,107.2580365,1.8,93.2836879,107.4848648,-0.3074065,12.2597057,14.5501658,6431.81796,9810.414409,3.2780374,674.2476012,524.6306997,1088.2075953,20.3407604,24.4834602,0.2763273,74.3484129),(47958,'tibia.tif',233,8,170,211.3985866,92.928043,107.231914,1.8,93.2689582,107.4661678,-0.3065605,11.7036009,14.554478,6375.1894268,9698.6735989,3.2087476,666.3704179,544.7203386,1102.1451361,20.1391878,24.4834602,0.2763273,73.4393486),(47959,'tibia.tif',233,8,171,208.4749832,92.9035225,107.2179674,1.8,93.1928395,107.3193738,-0.307639,11.7902412,14.5746187,6332.5578181,9607.0111729,3.1859663,659.1603774,537.1016338,1091.6026692,20.1391878,24.4834602,0.2763273,73.6452889),(47960,'tibia.tif',233,8,172,205.73565,92.8507329,107.2017631,1.8,93.1188668,107.3445147,-0.3203661,12.1101468,13.0706114,6284.5025315,9510.8525036,3.4004966,727.6516921,518.9451972,1183.9232377,20.1598523,24.5817018,0.2900869,73.4393486),(47961,'tibia.tif',233,8,173,206.5160266,92.8766503,107.1907976,1.8,93.1236575,107.316144,-0.3124893,13.7378707,13.0211022,6339.3004979,9529.6850714,3.2530457,731.8647038,461.4470918,1114.2082853,20.1598523,24.6845598,0.3037345,73.4393486),(47962,'tibia.tif',233,8,174,205.9674484,92.8631674,107.1837271,1.8,93.0530843,107.3590147,-0.3076209,21.5248623,12.911695,6362.9583873,9534.6411484,3.1472863,738.4499961,295.6097137,720.056666,20.1843826,24.6845598,0.3037345,73.7305921),(47963,'tibia.tif',233,8,175,208.3415746,93.0205257,107.2100155,1.8,93.1176564,107.3661679,-0.2685791,11.7599166,13.1289884,6466.6743223,9935.2699704,2.4451269,756.7429934,549.891173,1236.7695897,20.3484282,25.0202504,0.299532,74.2277759),(47964,'tibia.tif',233,8,176,207.5936325,93.016688,107.2045925,1.8,93.0805498,107.3049141,-0.2649851,12.2759362,13.2119607,6512.782248,9954.8978633,2.3731051,753.4761942,530.5324302,1228.4883876,20.3484282,25.0696,0.2551824,74.2277759),(47965,'tibia.tif',233,8,177,208.485957,93.1270445,107.0303723,1.8,93.290351,107.1425093,-0.2648424,12.8386635,13.6083913,6569.3427472,9849.9295473,2.380799,723.8129289,511.6843139,1177.7683047,20.3496904,24.918778,0.2860514,74.5190194),(47966,'tibia.tif',233,8,178,206.4810453,93.0829161,107.0466223,1.8,93.2542768,107.1671199,-0.2627447,12.130224,13.6488461,6560.5180637,9745.8568329,2.3215611,714.0425457,540.8406354,1139.4308195,20.4599804,24.918778,0.2860514,74.5190194),(47967,'tibia.tif',233,8,179,204.4257963,93.0590541,107.066141,1.8,93.2417532,107.2141936,-0.2635169,12.9420599,13.5877533,6578.7108953,9662.130549,2.311668,711.0911093,508.3202312,1096.6624425,20.4612427,24.918778,0.2860514,74.7249596),(47968,'tibia.tif',233,8,180,203.7373674,93.0604516,107.0972129,1.8,93.2206834,107.393137,-0.2546461,12.9360772,13.5695425,6639.0212341,9651.4432858,2.1546951,711.2578234,513.2175016,986.6777328,20.545437,24.918778,0.2860514,74.7249596),(47969,'tibia.tif',233,8,181,200.6646625,92.9451329,107.0738972,1.8,93.1063789,107.2993156,-0.2746335,12.8674716,13.7289335,6557.1287639,9432.4227847,2.4596897,687.0470148,509.5895283,1026.1217598,20.545437,24.7445709,0.3936982,74.0218356),(47970,'tibia.tif',233,8,182,200.5305797,92.9144865,107.083334,1.8,93.0876175,107.2502505,-0.2719135,21.6629219,12.9042202,6585.6632983,9409.9192199,2.4107979,729.2125428,304.0062344,718.229326,0.351562,0.7861165,2.0344439,1.6974915),(47971,'tibia.tif',233,8,183,200.0323387,92.8867709,107.1023578,1.8,93.0256793,107.1749707,-0.2731467,20.65604,12.9630974,6594.8839574,9424.2174424,2.4261243,727.0035196,319.2714563,767.9934364,20.5715327,24.7445709,0.3936982,74.0218356),(47972,'tibia.tif',233,8,184,198.0578764,92.7997272,107.1024311,1.8,92.9012433,107.0809106,-0.271095,12.1284327,12.8698407,6606.6437527,9273.0571225,2.3671098,720.5261781,544.7236206,1233.5158822,20.6818227,24.6895663,0.348771,73.7305921),(47973,'tibia.tif',233,8,185,195.5145362,92.8746262,106.9647466,1.8,93.0461882,107.0480746,-0.2696158,12.2934961,13.7548622,6619.0708078,9072.0615928,2.3119017,659.5530696,538.4205405,1122.4858342,20.7490939,24.4834602,0.3671738,73.2334084),(47974,'tibia.tif',233,8,186,193.9509365,92.8641338,106.9696693,1.8,93.0122504,107.0363096,-0.2696355,12.2018605,13.1600659,6603.4565043,8968.1170683,2.2937397,681.4644503,541.1843961,1183.2179185,20.793375,24.5590655,0.4124104,73.2334084),(47975,'tibia.tif',233,8,187,192.5244158,92.8871172,106.9893235,1.8,93.0523468,107.0987054,-0.2618795,12.2040744,13.4809065,6594.7949202,8895.2692634,2.1507334,659.8420699,540.3764927,1089.500757,20.8358521,24.5590655,0.4124104,73.2334084),(47976,'tibia.tif',233,8,188,190.5129871,92.877874,107.0003337,1.8,93.0109709,107.1048093,-0.2648795,13.7895852,15.8291247,6579.5214316,8809.8059525,2.1761528,556.5567345,477.1370072,733.0629821,20.903665,24.611851,0.3805064,73.2334084),(47977,'tibia.tif',233,8,189,189.1246313,92.8602052,107.0040008,1.8,93.0172042,107.1832622,-0.2641063,12.309628,12.7832974,6603.1672759,8752.1789852,2.1479943,684.6573854,536.4229765,1123.6044927,20.9664789,24.611851,0.3805064,73.4393486),(47978,'tibia.tif',233,8,190,187.5054883,92.847037,107.0434133,1.8,93.0353238,107.2733541,-0.265245,12.138274,12.8654407,6641.3725314,8706.2087739,2.1475741,676.7128307,547.1430722,1147.5128109,21.0139551,24.611851,0.3805064,73.7305921),(47979,'tibia.tif',233,8,191,185.5355579,92.8136813,107.0624814,1.8,92.9668422,107.275534,-0.2663756,12.0215441,12.8442652,6657.5171564,8685.5961052,2.1427348,676.223664,553.79884,1099.8924627,21.0139551,24.6895663,0.348771,73.7305921),(47980,'tibia.tif',233,8,192,184.0048422,92.7654384,107.0898657,1.8,92.93143,107.3153176,-0.2775779,11.9294141,12.8047631,6676.3486946,8657.1247749,2.3028455,676.086292,559.6543683,1075.4150887,21.0700515,24.5716438,0.3353244,74.0218356),(47981,'tibia.tif',233,8,193,182.1904552,92.8028351,107.0162713,1.8,93.020489,107.1422687,-0.325174,11.9107389,13.5110968,6671.2314308,8513.3161867,3.0991637,630.0980814,560.1022327,1116.718756,21.2059822,24.4582065,0.3217506,73.8158954),(47982,'tibia.tif',233,8,194,178.4346773,92.6957783,107.0754642,1.8,92.9043005,107.1102848,-0.3576996,11.8759436,13.6747167,6623.7588141,8393.4490975,3.6455483,613.7932701,557.7458954,1094.5864658,21.2269177,24.4834602,0.3671738,74.0218356),(47983,'tibia.tif',233,8,195,175.8939588,92.599476,107.1439556,1.8,92.8886778,107.2184756,-0.3876193,12.105486,13.1061173,6630.7162012,8331.9282685,4.1884149,635.7281939,547.7447336,1130.8988314,21.2287027,24.611851,0.3805064,74.2277759),(47984,'tibia.tif',233,8,196,172.6958977,92.4747639,107.230372,1.8,92.7845789,107.4209339,-0.4278607,12.1895297,12.9630059,6628.3195792,8305.3843877,4.9553085,640.6989596,543.7715592,1084.5586547,21.2295953,24.7445709,0.3936982,74.5190194),(47985,'tibia.tif',233,8,197,171.6204641,92.3982858,107.2693957,1.8,92.8065242,107.4146967,-0.4515098,12.3453533,13.4284658,6628.5980124,8308.2946657,5.445491,618.7076591,536.9306061,1054.251009,0.351562,0.4971837,2.3561945,0.9943675),(47986,'tibia.tif',233,8,198,168.7428908,92.2947827,107.3113301,1.8,92.6821239,107.4422708,-0.4791848,13.0116383,12.9126997,6593.982432,8284.1285811,5.9783526,641.5489224,506.775723,984.4070559,21.3864614,24.8492418,0.4383366,74.8102629),(47987,'tibia.tif',233,8,199,167.3239356,92.2023618,107.334006,1.8,92.4852287,107.4371969,-0.5146604,13.3019273,13.4915565,6580.0620526,8305.3354359,6.7570842,615.5950517,494.6698242,980.5709957,21.387354,24.9386099,0.3752708,75.1015064),(47988,'tibia.tif',233,8,200,168.9283969,92.3957064,107.4366046,1.8,92.6684223,107.5486336,-0.4074516,13.3287162,13.3397816,6797.889876,8614.4051252,4.4211535,645.7680785,510.0183524,978.8704689,21.387354,25.3441824,0.413999,76.5077544),(47989,'tibia.tif',233,8,201,167.1066317,92.4346435,107.3304266,1.8,92.7549554,107.3919216,-0.4572094,12.6510159,13.1378893,6760.9156433,8482.5261393,5.4274686,645.6536459,534.4168172,1134.4021772,21.5442202,25.2048134,0.4012288,76.2165109),(47990,'tibia.tif',233,8,202,167.0406764,92.5957242,107.4140582,1.8,92.8764499,107.4415167,-0.3634357,12.7704311,14.0983539,6812.9983559,8675.003356,3.5181945,615.3203025,533.4979139,1096.54491,0.351562,1.7926215,1.7681919,3.8068635),(47991,'tibia.tif',233,8,203,166.080524,92.5667368,107.4351284,1.8,92.9173427,107.5272074,-0.3862685,12.6301218,14.3422443,6800.0452304,8629.1789775,3.9286037,601.6616931,538.3990233,1075.7697061,0.351562,0.7861165,2.0344439,1.6974915),(47992,'tibia.tif',233,8,204,165.9210854,92.5341293,107.4312132,1.8,92.8427499,107.4805941,-0.4089244,12.7223138,14.368856,6835.836642,8620.6257746,4.3721253,599.9521289,537.3108035,1075.520868,21.7830487,25.395336,0.3830771,77.2108784),(47993,'tibia.tif',233,8,205,165.3095107,92.5148464,107.4490491,1.8,92.8690644,107.4916564,-0.4089521,12.7309775,14.7162056,6868.86993,8571.0208176,4.3565656,582.4205658,539.5398709,1048.8120115,21.8597376,25.395336,0.3830771,77.5021219),(47994,'tibia.tif',233,8,206,164.3460624,92.499217,107.4692773,1.8,92.857822,107.557746,-0.4252389,18.7917115,20.7785292,6899.8515059,8532.998414,4.6616208,410.6642165,367.1752564,550.8656491,21.8597376,25.4876389,0.4266275,77.7080621),(47995,'tibia.tif',233,8,207,163.7757987,92.5354574,107.4590969,1.8,92.9246269,107.5056882,-0.4551423,12.6780537,14.3527362,6905.3993237,8528.6737038,5.2746577,594.2193582,544.6734569,1073.2590247,21.8606301,25.4876389,0.4266275,77.9993056),(47996,'tibia.tif',233,8,208,168.3384702,92.852641,107.5523687,1.8,93.1498419,107.5544918,-0.306448,12.9918337,13.6453522,7136.6277142,9144.7083071,2.5533361,670.1701931,549.3164307,1176.7072225,22.3127204,26.1293593,0.4154921,79.9027374),(47997,'tibia.tif',233,8,209,167.226632,92.9034929,107.4558932,1.8,93.2756327,107.4337703,-0.3329555,13.0619739,14.8877107,7113.0931253,8970.3523352,2.9772707,602.5340289,544.5649475,1080.0945825,22.2464835,25.8535549,0.390607,79.4055536),(47998,'tibia.tif',233,8,210,165.3123946,92.8778248,107.493648,1.8,93.2991074,107.5026157,-0.3670173,13.9876173,14.9268688,7076.2067709,8915.0879286,3.5476346,597.2510398,505.8907888,1071.2323041,22.3312287,26.1293593,0.4154921,79.5261906),(47999,'tibia.tif',233,8,211,164.6529172,92.8568615,107.5803773,1.8,93.2846895,107.561798,-0.3980219,14.8294192,14.9670842,7142.3585321,8872.3656572,4.1226444,592.7918565,481.6344062,923.9962669,22.3330138,26.2732329,0.4277349,80.1086776),(48000,'tibia.tif',233,8,212,167.4726626,93.0414417,107.6461363,1.8,93.4300134,107.6460847,-0.3031402,13.709141,13.9576385,7275.7760201,9379.2183802,2.4873426,671.9774523,530.724427,1162.1590574,22.4415261,26.7741642,0.4048918,81.3089854),(48001,'tibia.tif',233,8,213,165.5616088,92.9662865,107.6946774,1.8,93.3637572,107.7423275,-0.3062152,13.1962387,14.0385884,7257.9120246,9369.3239412,2.5075236,667.3978665,549.9985423,1154.7754173,22.48988,26.9627656,0.3877702,81.5149256),(48002,'tibia.tif',233,8,214,164.2820922,92.9430019,107.7257842,1.8,93.3226021,107.7380659,-0.3132926,13.3139458,15.5933848,7251.6635976,9392.3690019,2.6006588,602.330356,544.6667515,1066.4602761,22.4907725,27.0976546,0.3997811,81.7208659),(48003,'tibia.tif',233,8,215,164.0267731,92.8977206,107.7721406,1.8,93.196011,107.8195285,-0.3427579,13.1716381,14.1745942,7353.1630135,9502.7791133,3.0879056,670.4092511,558.2572903,1166.0075156,22.6476387,27.6753215,0.4466038,82.6299301),(48004,'tibia.tif',233,8,216,166.6022857,92.9495472,107.8067716,1.8,93.2063058,107.9042378,-0.3375983,13.349978,14.3618737,7594.0902689,9872.1729228,3.0462665,687.3875319,568.8466488,1184.2490667,23.8489394,28.164483,0.4245614,94.8036141),(48005,'tibia.tif',233,8,217,169.4222934,93.0076082,107.7802789,1.8,93.2464332,107.883005,-0.3954362,13.7838124,14.2828517,7800.5862532,10111.2303521,4.1900211,707.9279804,565.9237118,1059.0967091,23.487354,28.461327,0.4470745,85.8189729),(48006,'tibia.tif',233,8,218,173.145824,93.1056369,107.8317334,1.8,93.3255365,107.9244414,-0.3723243,13.2869461,14.9236753,8120.6016744,10705.2393234,3.8189325,717.3326362,611.1714168,1148.7561005,24.0262115,29.4158881,0.4315731,88.5108318),(48007,'tibia.tif',233,8,219,177.2166965,93.1135347,107.8454607,1.8,93.235293,107.9477182,-0.3872152,14.7230011,17.1735601,8488.8912007,11196.7569789,4.2115634,651.976463,576.5734288,1140.1764646,24.5928678,29.88277,0.4373379,89.8317766),(48008,'tibia.tif',233,8,220,183.1989973,93.0142133,107.8779803,1.8,93.0758074,107.9716224,-0.4006422,13.9576432,17.0656582,8971.7460367,11878.3594759,4.6443267,696.0387559,642.783735,1202.5332919,25.2317586,30.2016109,0.4324078,91.6145713),(48009,'tibia.tif',233,8,221,192.5321311,92.951882,107.9380664,1.8,93.0121608,108.0051253,-0.3940135,14.2866354,15.5331085,9712.7127238,12984.9822174,4.7291437,835.9551617,679.8460561,1415.0510619,26.5606024,31.3127098,0.503827,101.0110931),(48010,'tibia.tif',233,8,222,202.0939173,92.803398,107.9926576,1.8,92.7762837,108.1069772,-0.433353,15.6448233,18.5213418,10515.5487524,14129.7383926,5.9391915,762.8895653,672.1423778,1316.831937,26.9413594,32.1386128,0.527287,100.5139093),(48011,'tibia.tif',233,8,223,212.7689649,92.4773733,108.00786,1.8,92.4149274,108.2004332,-0.4680767,15.5349306,18.8732378,11343.1730836,15524.3342521,7.2183634,822.5580791,730.1721112,1404.1463474,27.6395804,33.3613629,0.506075,103.3264053),(48012,'tibia.tif',233,8,224,230.4420464,92.3375116,107.9405379,1.8,92.2045013,108.313089,-0.4383582,31.2528202,17.879078,12726.6643322,18082.3790607,6.9194353,1011.3708931,407.2165083,966.691471,28.4399303,35.7575022,0.5252436,104.7326533),(48013,'tibia.tif',233,8,225,261.3459876,92.1542345,107.9041742,1.8,92.0077022,108.358109,-0.4115802,17.7696436,18.8516946,14840.3735889,22063.9504714,6.97125,1170.3961345,835.1531364,1897.7235563,29.6599982,37.6237047,0.4134805,110.4429486),(48014,'tibia.tif',233,8,226,295.8234591,92.0635039,108.1272101,1.8,91.9333627,108.3766848,-0.4374896,16.8731075,19.7572165,17307.439415,26727.8997325,8.8497343,1352.8170703,1025.7410743,2175.3988945,30.7876039,39.881761,0.578223,117.9360386),(48015,'tibia.tif',233,8,227,329.999619,92.117064,108.2102396,1.8,91.7549426,108.2802309,-0.47627,17.1492813,20.5393014,19522.4018728,30321.5549039,11.5605722,1476.2700198,1138.3801736,2419.6381841,31.6903547,40.5166626,0.5374433,117.8007658),(48016,'tibia.tif',233,8,228,386.3935168,91.7846899,107.4288848,1.8,91.4273704,107.9681177,-0.5001351,16.8888255,19.9643757,20882.1321909,31318.8048757,14.8093409,1568.7344949,1236.4466806,2572.304931,32.1378525,40.2841579,0.5613745,122.9432098),(48017,'tibia.tif',233,8,229,314.868829,91.6179904,106.7571954,1.8,91.4409515,107.740449,-0.433973,21.0859484,20.0871546,16800.6311816,27114.6477708,9.2782622,1349.8501038,796.769056,1631.5806056,30.585894,39.0297159,0.5079734,116.0679406),(48018,'tibia.tif',233,8,230,331.1875623,90.7973362,106.9772797,1.8,90.7353295,107.6246009,-0.3190895,15.7741763,19.7272558,16093.912064,28835.7641094,5.4319758,1461.722017,1020.2695697,2268.7759704,28.8149856,39.7000523,0.4002407,112.6729576),(48019,'tibia.tif',233,8,231,320.1798171,89.8305722,106.0160369,1.8,90.6276019,107.6982596,-0.2574597,17.8208813,20.7025192,14573.2356421,29938.615703,3.4597451,1446.1339393,817.761782,2080.3036587,27.773398,40.4433844,0.4208722,120.9398391),(48020,'tibia.tif',233,8,232,185.8431617,86.3663838,104.2944452,1.8,87.8823582,105.8481552,-0.398614,21.8658081,21.7708855,5668.0965384,17794.3351358,4.6663278,817.3454938,259.2219097,928.5549763,22.5130594,39.0027896,0.4878364,129.1506888),(48021,'tibia.tif',233,8,233,79.3473681,81.5085147,107.0383378,1.8,81.9963552,106.8757931,-0.9200421,24.9274577,21.7710651,879.1288323,2821.2552166,8.3714451,129.587377,35.2674887,143.1943613,10.9475497,23.6358456,1.0405806,66.7700196),(48022,'tibia.tif',233,8,234,31.5794487,80.9094653,108.785995,1.8,80.321883,109.3643975,-1.0183818,5.768318,9.8455128,100.9537258,613.5087744,3.8139742,62.313542,17.5014146,72.5545511,1.8248577,7.2476363,1.1722739,15.689304),(48023,'tibia.tif',233,8,235,0.143109,79.5884476,112.3107639,1.8,79.5848477,112.3020864,1.0782729,0.6847555,0.8267664,0.018654,0.0285974,0.0185186,0.0345895,0.0272418,0.0539313,1.406248,2.0499411,2.1112158,5.0924745),(48024,'tibia.tif',233,8,236,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48025,'tibia.tif',233,8,237,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48026,'tibia.tif',233,8,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48027,'tibia.tif',233,8,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48028,'tibia.tif',233,8,240,7.9536545,112.8177195,123.4302062,1.8,112.8472167,123.2529736,-0.0768897,4.3435615,5.7073602,30.2690338,53.5410553,0.0078216,9.3810541,6.9687131,13.7291994,10.5359183,11.93241,0.7853982,37.1388727),(48029,'metatarsal.tif',233,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48030,'metatarsal.tif',233,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48031,'metatarsal.tif',233,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48032,'metatarsal.tif',233,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48033,'metatarsal.tif',233,10,5,5.1197142,104.3666794,97.8233481,1.8,104.443734,97.7122634,-1.1158944,1.898135,5.0859922,3.0552736,28.4656458,0.6885591,5.5968717,1.6096187,6.1928413,3.8664212,10.5351347,1.122073,24.2620647),(48034,'metatarsal.tif',233,10,6,30.837162,103.5537043,97.6335604,1.8,103.0437823,96.8770465,0.454521,8.948476,17.0941577,434.1271299,513.9481558,0.9906393,30.0657199,48.5140854,55.1869882,6.9387717,17.3124207,1.152572,41.0310394),(48035,'metatarsal.tif',233,10,7,63.675528,102.2583977,97.1505044,1.8,102.1213545,96.3430479,0.5042638,11.4631052,16.6078784,1319.8797151,2294.7232495,2.4774718,138.1707645,115.1415514,216.3586512,9.5402159,21.5401667,1.1144479,52.4162962),(48036,'metatarsal.tif',233,10,8,101.0697864,101.5399339,97.0408129,1.8,101.33836,96.1732287,0.4874784,13.270349,16.6561169,2705.6547789,4267.5622503,3.6957532,256.2159164,203.8872358,416.9110349,13.1659708,25.002955,1.088283,67.0758989),(48037,'metatarsal.tif',233,10,9,151.5055782,100.652381,96.9451073,1.8,100.5882228,96.1856548,0.3489602,14.4512671,15.8393717,4646.3254212,7079.0423386,2.9520834,446.9269669,321.5168175,726.2764179,10.0895181,14.5845274,1.8391625,49.8950436),(48038,'metatarsal.tif',233,10,10,194.3234468,99.9987912,97.255289,1.8,100.0233909,96.5000253,0.1362078,14.7733031,16.0966372,6776.1564376,10833.0416758,0.5971601,673.000299,458.6757888,1055.4076374,25.9986609,31.0192459,0.3109983,117.6740665),(48039,'metatarsal.tif',233,10,11,252.4598587,99.6703565,97.083428,1.8,100.2799624,95.8714962,-0.2117042,28.5142077,20.2819305,12636.5072473,18267.9791681,1.8578134,900.7021897,443.1652939,923.4740906,26.8211181,35.2562528,2.981362,141.850828),(48040,'metatarsal.tif',233,10,12,345.2362145,100.9788193,93.8248517,1.8,101.4555707,92.61944,-1.1213085,18.9300782,31.4990034,22713.2365196,46054.197199,46.6762846,1462.084266,1199.8490595,2177.4666046,38.9087286,87.05757,1.2630934,356.1966066),(48041,'metatarsal.tif',233,10,13,494.4904009,101.4462997,90.9294847,1.8,101.4360014,90.5565807,-1.2125371,19.8937799,28.0383231,28907.7860683,72539.4707668,72.2820065,2587.1543921,1453.1067596,3560.6714508,1.2429594,1.5722331,1.1071487,3.97747),(48042,'metatarsal.tif',233,10,14,595.8649821,101.1849739,90.5355323,1.8,101.1093337,90.3941066,-1.2303745,22.2935309,27.8943004,34725.8248398,87725.140244,88.239759,3144.9127278,1557.6637477,4031.72662,39.3552903,89.8961289,1.1859327,408.3155969),(48043,'metatarsal.tif',233,10,15,647.9103288,101.0144433,91.2152616,1.8,100.9547077,90.7758252,-1.2118648,21.2721469,28.7079723,37224.4945074,103069.6809202,94.660407,3590.2807762,1749.9171455,4783.5047385,38.771321,91.9702587,1.2236582,406.7034086),(48044,'metatarsal.tif',233,10,16,671.1887064,100.9007087,91.7736089,1.8,100.9043867,91.1881114,-1.2090215,24.5709443,29.2873826,37505.314391,115107.986162,97.8515075,3930.2927023,1526.409156,5110.6374341,0.351562,0.4971837,2.3561945,0.9943675),(48045,'metatarsal.tif',233,10,17,681.2721045,101.1519547,91.867341,1.8,100.917767,90.90859,-1.2278723,24.8231601,30.5366761,36623.9918154,116094.6480642,100.7080422,3801.8102417,1475.3960283,4301.4131777,0.351562,0.7861165,2.0344439,1.6974915),(48046,'metatarsal.tif',233,10,18,670.5291541,101.1833019,91.9337811,1.8,100.8741553,90.7868581,-1.2383426,21.7884538,29.0483315,35713.8014863,111299.1141866,99.8515047,3831.5148716,1639.1159177,4781.1751064,0.351562,0.4971837,2.3561945,0.9943675),(48047,'metatarsal.tif',233,10,19,656.8272443,101.0233748,92.1835466,1.8,100.7143693,90.722985,-1.2390526,22.1766331,29.2177731,35436.2796689,104942.9544116,97.8590086,3591.7506172,1597.9107141,4151.0264799,38.0485484,91.8007753,1.206647,386.1275704),(48048,'metatarsal.tif',233,10,20,604.595193,101.0103808,92.7451017,1.8,100.5445472,91.0015025,-1.2387889,19.304092,29.6398346,35780.4778747,97208.5471741,90.0607187,3279.6588905,1853.5177867,4417.2663768,38.6370111,91.1895175,1.2246604,411.4486078),(48049,'metatarsal.tif',233,10,21,565.2132887,101.2146726,93.2925725,1.8,100.5155019,91.4062852,-1.3152737,19.7422977,28.827995,38497.9172599,90017.4184079,88.1842857,3122.5695159,1950.0221212,4396.2600318,39.4411205,90.6082428,1.2551807,370.6088729),(48050,'metatarsal.tif',233,10,22,557.4516198,101.2460308,93.2896151,1.8,100.2438448,91.5344985,-1.5362508,20.8995158,27.1806445,44260.6885042,89616.7872134,92.797771,3297.0810295,2117.7853607,4441.6425408,40.9542644,89.5055034,1.1968544,387.6897892),(48051,'metatarsal.tif',233,10,23,571.2483238,100.2817463,93.1642571,1.8,99.0280447,91.1787518,1.2948401,21.4145393,28.8927559,51552.2187037,91609.543249,88.1399664,3170.6751586,2407.3466129,4908.9087514,42.0258455,89.628317,1.226717,389.9051625),(48052,'metatarsal.tif',233,10,24,548.4678502,100.2306867,93.109305,1.8,98.8803294,90.9193321,1.1242942,30.4500307,29.1864349,47568.6473041,91275.1338544,74.3665087,3127.3135707,1562.1871707,4458.3465367,42.890564,86.4192029,1.4893443,326.7567641),(48053,'metatarsal.tif',233,10,25,497.3767008,100.388356,93.0140754,1.8,98.9423513,90.8445835,1.1216023,28.1677969,28.8908736,39344.4389171,86136.0316457,67.2648868,2981.4270345,1396.7879361,3927.4567641,42.4944314,84.8692804,1.5127703,307.4165674),(48054,'metatarsal.tif',233,10,26,439.7143351,99.7189026,92.8681151,1.8,98.7510705,90.8934913,1.1302285,26.8937029,28.1581178,30127.2165527,80703.9886566,59.9578153,2866.1002538,1120.2331145,3629.3492773,0.351562,0.4971837,2.3561945,0.9943675),(48055,'metatarsal.tif',233,10,27,385.6024285,99.2061075,92.8920817,1.8,98.2281619,91.0650622,1.1470455,19.3716099,27.1390264,23085.6839335,73154.6580206,53.4013737,2695.5520417,1191.7276885,3518.9979433,40.9674799,81.2382118,1.5967645,295.1015484),(48056,'metatarsal.tif',233,10,28,344.0962489,98.5288536,92.5912964,1.8,97.6657933,91.2231774,1.1468414,18.5528213,26.8906141,18703.9215635,65512.3508557,47.6444836,2436.2534277,1008.1443269,3091.6423039,38.6345758,67.3550956,1.6491695,258.6657997),(48057,'metatarsal.tif',233,10,29,305.3095522,97.5718658,92.0536822,1.8,97.0084337,91.2791883,1.156211,17.8648848,28.0346682,15370.5999658,55452.1949509,42.6285295,1977.9864883,860.3805817,2524.5822184,37.0450356,60.2905768,1.6466738,229.6378378),(48058,'metatarsal.tif',233,10,30,266.8893734,96.7691483,90.6882854,1.8,96.2624961,91.0130598,1.1590762,17.0298494,27.8949701,13446.7672628,43456.8724352,37.3578796,1557.8748516,789.5998919,2008.1238372,34.6643545,55.3863588,1.7108981,213.4013806),(48059,'metatarsal.tif',233,10,31,233.6336655,95.737679,89.7323292,1.8,95.443831,90.1907607,1.2180846,16.0870481,28.7370832,11834.5980199,31810.021833,34.2923024,1106.9328648,735.6600138,1495.9612821,26.8312191,42.7996956,1.1475679,160.7291747),(48060,'metatarsal.tif',233,10,32,197.0201208,94.3626549,89.3304343,1.8,94.2897088,89.8820343,1.3885232,17.9864595,26.009506,8207.38957,20219.7680192,31.7577657,777.3991567,456.3093461,973.2419125,26.015588,38.9155474,1.1718357,141.6802215),(48061,'metatarsal.tif',233,10,33,153.1201144,93.5976489,89.8430708,1.8,93.2912067,90.2450254,1.375814,16.8067496,22.5856113,5915.2283608,14301.6134587,24.5620295,633.2179031,351.9555235,791.3440363,29.6645253,41.7930187,1.7912901,199.2036278),(48062,'metatarsal.tif',233,10,34,4.9722232,86.2450533,108.5756011,1.8,85.479115,107.3514623,0.9637963,3.5096292,11.8725676,10.3660167,552.1351469,0.5590743,46.5051172,2.9535932,45.7471985,0,0,0,0),(48063,'metatarsal.tif',233,10,35,129.3788517,87.3075225,98.4304777,1.8,86.6872198,98.2234642,1.2748009,12.8094276,21.0588986,2223.7492033,9250.6298946,19.7284575,439.2741547,173.6025422,543.4227042,20.5456351,26.6561903,2.290867,84.7039684),(48064,'metatarsal.tif',233,10,36,181.5407156,87.4978246,101.3445233,1.8,87.4182296,101.2357397,1.2552745,13.6271018,19.0331841,3923.7197485,15742.54625,27.3432424,827.1104923,287.9350135,1027.7918287,21.9883513,36.4286773,1.956679,156.737069),(48065,'metatarsal.tif',233,10,37,249.1431831,88.0559105,103.7364042,1.8,87.7672405,102.3845001,1.1864719,13.8322226,19.5450672,6183.646749,22751.0697232,35.6866604,1164.0312861,447.0465032,1476.7596845,24.4884324,38.3831006,2.0672191,119.1363463),(48066,'metatarsal.tif',233,10,38,264.8383566,87.9506705,104.6205215,1.8,87.264425,102.9683807,1.1360014,14.4199412,20.1763143,7506.0005406,24394.1211966,36.308013,1209.0474426,520.5292056,1580.7779557,24.4986504,38.1116558,2.0922308,145.1312363),(48067,'metatarsal.tif',233,10,39,275.0775603,87.3271355,104.8877337,1.8,86.8339937,103.6185842,1.1633857,13.4601732,20.2957453,9253.8353329,25107.7663501,38.6483614,1237.0950671,687.4974918,1692.3462161,26.0858759,38.7197306,2.1361328,126.6647701),(48068,'metatarsal.tif',233,10,40,302.2041131,86.2461447,105.6743435,1.8,86.5590589,104.0332231,1.2908512,13.5135202,20.7550086,12912.1974135,25931.9953312,46.5221433,1249.4331303,955.502134,1866.8990257,27.181842,38.8312921,2.1236375,119.4982573),(48069,'metatarsal.tif',233,10,41,295.0692249,86.3084549,105.3652793,1.8,86.636403,103.5660913,1.3774505,14.9445973,25.9963553,13067.6147712,26271.7733173,47.3625879,1010.5944855,874.4039404,1513.1934698,26.36715,38.8312921,2.1236375,122.204752),(48070,'metatarsal.tif',233,10,42,285.1221568,86.5138311,105.4672583,1.8,86.797471,103.6121393,1.356663,14.9227336,21.2892979,12500.7532096,25842.3608151,45.374506,1213.8662762,837.6986136,1797.3796186,26.36715,38.5148967,2.1613306,132.148427),(48071,'metatarsal.tif',233,10,43,283.1394923,86.8357295,105.5904808,1.8,87.0352448,103.64959,1.3577433,14.459132,20.2072065,12296.5941993,25356.2866905,45.0801052,1254.8140519,850.4379248,1849.4548542,26.4648102,38.0272445,2.1587989,116.2738808),(48072,'metatarsal.tif',233,10,44,290.6500369,87.1570033,105.5815674,1.8,87.1397022,103.7512346,1.3687453,13.786188,20.8564275,12431.2762981,25051.9493405,46.4908252,1201.1620546,901.7196251,1796.9410176,26.0710331,38.2540814,2.1995926,113.0848381),(48073,'metatarsal.tif',233,10,45,302.9191712,87.3157727,105.583029,1.8,87.2111664,103.8499377,1.3740682,14.1684585,21.0966437,12653.8272661,24710.1917849,48.5576789,1171.2854476,893.0983777,1769.3144914,0.4971837,0.9943675,2.3561945,1.988735),(48074,'metatarsal.tif',233,10,46,427.1945635,89.5594061,103.8373216,1.8,89.5182634,102.288502,1.0454736,18.8568828,28.2999827,28695.0581893,36202.6264619,53.2929127,1279.2455355,1521.7286158,2122.1062087,34.732559,41.2931981,2.3923233,158.0726495),(48075,'metatarsal.tif',233,10,47,459.1352116,89.277985,103.8034482,1.8,88.9744828,102.0783578,0.9874749,19.1205598,28.65215,29781.1874998,39228.1640643,53.3071517,1369.117645,1557.5478896,2269.3788862,33.4601999,41.7826667,2.2429092,128.2062908),(48076,'metatarsal.tif',233,10,48,453.4997282,89.1695085,103.7045494,1.8,88.8192145,101.8471208,0.9575193,19.406453,23.0822866,29954.0671505,41257.980109,50.5457031,1787.4303693,1543.5106649,2607.7261749,32.9368109,41.977445,2.2075974,130.7275433),(48077,'metatarsal.tif',233,10,49,449.2959341,89.093764,103.4293599,1.8,88.7337816,101.5547886,0.9604532,19.3569888,23.0681867,29763.3457662,42198.0092629,50.2837485,1829.2729174,1537.6020538,3119.1482904,32.3553892,41.9303091,2.1471715,130.8981498),(48078,'metatarsal.tif',233,10,50,68.7531822,90.1555727,98.7881368,1.8,89.9922734,99.3633763,0.2299235,7.6836743,8.9017195,929.7803757,1051.3888556,0.5951708,118.1107597,121.0072602,196.1027746,14.414042,18.1897241,2.2878081,55.2141564),(48079,'metatarsal.tif',233,10,51,264.9342745,89.3181014,103.8237623,1.8,89.0226172,103.8267039,0.7921911,15.2671471,17.072221,8667.9457027,14624.3579475,22.3777953,856.6171875,567.7515015,1201.7153898,26.1957921,33.8121505,2.6546934,108.2629091),(48080,'metatarsal.tif',233,10,52,305.1072296,89.5205458,105.1991175,1.8,89.212272,105.1924932,0.9975965,14.3134962,26.8664631,10413.3963481,17369.6098116,35.8951316,646.5164311,727.5229083,969.0551605,25.7479433,32.7160507,2.6491069,112.1051063),(48081,'metatarsal.tif',233,10,53,312.8282617,89.534404,106.1554153,1.8,89.1975553,105.737188,1.2045236,21.5714729,23.4155995,11855.2387048,17025.3501351,45.4506734,727.0943505,549.5794716,1038.4644892,26.4368968,33.0262515,2.65414,108.9306993),(48082,'metatarsal.tif',233,10,54,280.3631177,89.625969,106.8722191,1.8,89.1220313,106.0473278,1.1625215,21.3788284,23.1416756,9947.3595729,14422.3118501,39.3615777,623.2181336,465.2902115,891.8681467,25.7175238,31.4544861,2.6529503,116.4237893),(48083,'metatarsal.tif',233,10,55,254.4752574,89.8220346,107.3534799,1.8,89.3629016,106.3257451,1.0793454,20.735301,23.607834,8502.9371034,12204.832639,32.9674847,516.982313,410.0705904,767.1809722,24.6825575,30.448192,2.5119475,98.8663873),(48084,'metatarsal.tif',233,10,56,237.0748733,90.0527728,107.5517876,1.8,89.7242188,106.4393398,1.1068618,20.3811307,14.1492241,7496.5317218,10927.4165261,31.6009121,772.2979317,367.8172629,887.6605551,0.351562,0.7861165,2.0344439,1.6974915),(48085,'metatarsal.tif',233,10,57,226.5189646,90.2214802,107.389175,1.8,89.9270954,106.3167551,1.1619857,18.8069505,15.1176757,6545.1931859,10348.0208881,31.7873771,684.4981391,348.0199082,867.4382895,0.703124,1.1117367,1.8925469,2.691859),(48086,'metatarsal.tif',233,10,58,222.122361,90.496877,107.2279614,1.8,90.3299868,106.2556807,1.2015934,14.9883049,14.7867781,5987.3499562,10066.2802735,32.1992756,680.7622455,399.4681185,1053.5230211,20.9125776,27.722174,1.7880898,111.537255),(48087,'metatarsal.tif',233,10,59,214.0326013,90.6510353,107.1537663,1.8,90.5244356,106.2167611,1.2296733,14.7528272,14.8659483,5298.6734761,9704.7273702,31.6796516,652.8158973,359.1632573,988.0700924,20.0434657,27.5410179,1.815775,118.9450418),(48088,'metatarsal.tif',233,10,60,208.2831101,90.7928437,106.9963203,1.8,90.6222766,106.1302383,1.2578972,17.9827619,14.8411968,4772.1324388,9581.3185915,31.4246411,645.5893515,265.3726087,778.2262103,19.5483206,27.3789841,1.790858,124.4493968),(48089,'metatarsal.tif',233,10,61,207.7623221,91.0961483,106.6726768,1.8,91.0137206,105.8800969,1.3205131,13.231795,15.1571735,4630.4898815,9631.4459892,32.5028718,635.4381309,349.9517549,939.1741213,1.054686,1.8932193,1.9513027,4.3893505),(48090,'metatarsal.tif',233,10,62,205.9101448,91.2421692,106.4702129,1.8,91.1970798,105.7445281,1.3427852,12.4328713,15.0098855,4320.7572537,9648.1094294,32.5648839,642.7836804,347.5269019,930.3089163,19.26899,27.7199447,1.8403854,86.5720663),(48091,'metatarsal.tif',233,10,63,206.1677485,91.378763,106.2621863,1.8,91.2249817,105.713269,1.3592819,10.9788378,14.6921655,4099.2241501,9712.6865808,32.8468126,661.0793075,373.3750534,939.1231554,2.1139401,17.5147045,2.2424025,38.5597564),(48092,'metatarsal.tif',233,10,64,207.3444933,91.6028331,106.050054,1.8,91.6551962,105.6431063,1.401632,11.2952017,14.8737543,3931.9471534,9901.4023418,33.5778985,665.6962427,348.1077413,921.8843014,1.5279505,3.1444661,2.0344439,9.0699445),(48093,'metatarsal.tif',233,10,65,209.4832257,91.8014214,105.7368726,1.8,91.9018999,105.5192978,1.4081602,12.846611,17.5803408,3817.8565998,10124.4463448,33.9984948,575.8959098,297.1878418,652.8878446,1.4153659,2.5351496,2.1587989,6.3780855),(48094,'metatarsal.tif',233,10,66,211.4108339,91.8854797,105.5395769,1.8,91.8904807,105.463831,1.4080048,13.7934885,16.5883351,3699.5659815,10319.8111348,34.3095889,622.1125317,268.2110467,649.830432,2.3964729,14.4311812,2.1655556,33.3819787),(48095,'metatarsal.tif',233,10,67,214.2087815,92.038365,105.2557151,1.8,91.9919379,104.9844157,1.4264421,14.3902483,15.3843032,3590.0578098,10894.156339,34.962665,708.1345329,249.4785173,687.7656513,17.9673955,29.6064469,1.4994889,135.0255282),(48096,'metatarsal.tif',233,10,68,215.7944038,92.1516032,105.1141843,1.8,92.0611013,104.8576693,1.425901,14.5651742,17.8405521,3523.704106,11102.0779053,35.2159153,622.294524,241.9266702,667.5708248,17.9412734,29.2832364,1.4866581,137.1349002),(48097,'metatarsal.tif',233,10,69,218.5471453,92.2487765,104.9673249,1.8,92.1737331,104.7784701,1.4225348,14.0411478,17.456592,3505.6249857,11397.2623276,35.6297085,652.891602,249.6679783,681.4355104,17.9752961,29.5646711,1.5232132,141.0624007),(48098,'metatarsal.tif',233,10,70,219.2398438,92.470493,104.8524232,1.8,92.4510034,104.7518008,1.4391608,20.4868486,19.2923888,3405.3947214,11629.8684573,35.9104616,602.8215872,166.2234532,534.2861047,3.1946936,18.2338369,2.1641465,47.4590944),(48099,'metatarsal.tif',233,10,71,220.213779,92.5774932,104.78569,1.8,92.4635971,104.6829554,1.4351891,11.1132404,15.5526332,3368.5353981,11724.8937646,36.0314928,753.8848003,303.1100998,969.7883295,17.6294282,29.5500357,1.6064954,129.8477505),(48100,'metatarsal.tif',233,10,72,220.156438,92.7083418,104.7516074,1.8,92.5508716,104.6855811,1.4326624,12.3377347,15.4385479,3319.7498964,11725.071565,35.9970476,759.4672549,269.0728865,971.632212,1.75781,3.6195523,2.0778948,8.9846412),(48101,'metatarsal.tif',233,10,73,220.785803,92.9225334,104.5873658,1.8,92.8501807,104.5515234,1.4334266,11.1587288,15.3174172,3351.2295843,11684.3391714,36.1076032,762.8139291,300.3235989,975.7808205,2.0028822,2.3583496,0.4636476,6.5840257),(48102,'metatarsal.tif',233,10,74,219.3112672,93.0642767,104.5954973,1.8,92.922298,104.5909442,1.4338967,22.8714934,15.1775677,3307.7103545,11567.7437507,35.8711097,762.1605761,144.6215292,546.4239014,0.703124,0.9943675,0.7853982,1.988735),(48103,'metatarsal.tif',233,10,75,219.7241148,93.1591836,104.5235348,1.8,92.9958273,104.4298568,1.4233124,15.882159,21.9262595,3311.1840713,11611.8864666,35.8298897,529.5881157,208.4845065,679.0468167,19.33591,28.6517638,1.4601391,127.5178025),(48104,'metatarsal.tif',233,10,76,220.6198101,93.2409698,104.5024516,1.8,93.0453434,104.4933215,1.4138008,20.2170527,20.3231507,3373.7844375,11611.1402305,35.8710984,571.3257939,166.8781543,524.384921,18.984348,28.565359,1.80682,130.9127855),(48105,'metatarsal.tif',233,10,77,221.5489137,93.3333017,104.4671217,1.8,93.1674515,104.5307101,1.4073229,19.237988,20.5785961,3415.6500508,11552.2988905,35.9468152,561.3744889,177.5471553,531.3335794,20.6769329,29.3064411,1.7517228,141.268341),(48106,'metatarsal.tif',233,10,78,220.6378251,93.5106797,104.4576218,1.8,93.4304253,104.702529,1.4094201,16.4664176,15.0680251,3382.2950043,11478.3043619,35.8236028,761.7656774,205.4056377,897.9480038,0.351562,0.7861165,2.0344439,1.6974915),(48107,'metatarsal.tif',233,10,79,221.0890997,93.588308,104.3956327,1.8,93.4608476,104.5524594,1.401657,17.300823,15.3691199,3417.6812437,11414.4443793,35.8040411,742.6869223,197.5444316,856.738632,18.0893807,29.1711734,1.7894653,98.6957808),(48108,'metatarsal.tif',233,10,80,220.7562524,93.672613,104.3782004,1.8,93.4386298,104.5997763,1.3946132,17.3908908,15.1456021,3453.5268196,11270.3438906,35.6624133,744.1331013,198.582514,846.2773193,0.351562,0.4971837,2.3561945,0.9943675),(48109,'metatarsal.tif',233,10,81,217.3274791,93.8923229,104.3112768,1.8,93.7498667,104.5383725,1.3918694,17.6203407,14.9686835,3388.1320282,10949.5038871,35.0739512,731.4941133,192.2852732,813.3833909,18.4874242,28.6150736,1.6692425,113.3553835),(48110,'metatarsal.tif',233,10,82,216.4450797,93.9939039,104.2847667,1.8,93.8680159,104.5413612,1.3833487,18.1395369,14.9854551,3435.8446487,10769.0225766,34.8214319,718.6316679,189.4119272,782.6213963,19.0187445,29.7168685,1.7612314,118.8244048),(48111,'metatarsal.tif',233,10,83,215.634703,94.1107171,104.271334,1.8,94.0298142,104.5494269,1.3770278,20.127159,20.0318916,3452.6121483,10577.7830447,34.6065413,528.0471401,171.5399648,695.396785,15.7880572,28.0655712,1.7853892,73.2687421),(48112,'metatarsal.tif',233,10,84,215.5403581,94.2211871,104.235194,1.8,94.119188,104.5283227,1.3703312,22.0929948,20.0341486,3496.9533154,10422.2163873,34.4990001,520.2225764,158.2833541,625.9895754,19.7316177,29.7854149,1.7728215,149.7557985),(48113,'metatarsal.tif',233,10,85,215.8039918,94.3194867,104.1943269,1.8,94.1585313,104.4980568,1.3617277,23.2069172,20.0343872,3558.4095028,10282.4295527,34.417984,513.2390349,153.3340023,591.7997802,16.577814,28.6496068,1.8187512,80.2293146),(48114,'metatarsal.tif',233,10,86,216.4781884,94.411573,104.1442373,1.8,94.2249047,104.5388413,1.3521041,21.6009033,15.374712,3622.9214398,10182.0529138,34.3814745,662.259749,167.7208306,638.5097264,20.039034,29.5918321,1.7378981,133.5693107),(48115,'metatarsal.tif',233,10,87,215.3898708,94.5664454,104.0928875,1.8,94.339307,104.4654797,1.3516795,13.7923808,15.2821499,3599.6207105,10015.5994375,34.2021634,655.3789574,260.9861754,890.3364143,20.9862933,30.3445054,1.7454685,145.8636317),(48116,'metatarsal.tif',233,10,88,214.8069105,94.7175388,104.0416128,1.8,94.55773,104.4158001,1.3501342,17.9157934,15.2660283,3593.8108339,9851.5897167,34.0860403,645.3276209,200.5945679,749.0279932,15.8676847,27.1409507,1.8597717,71.9477974),(48117,'metatarsal.tif',233,10,89,214.8687458,94.8472212,103.9107518,1.8,94.7080167,104.3733445,1.3414013,17.6738851,15.1735263,3679.2790051,9730.9999461,33.9598079,641.3143381,208.1760173,754.8358883,18.632786,29.0416599,1.6921483,125.5290675),(48118,'metatarsal.tif',233,10,90,212.8075418,95.0112044,103.8647717,1.8,94.8717967,104.3216167,1.3443765,24.369311,15.0055006,3643.1241792,9540.4227309,33.6804881,635.7950325,149.4963962,477.4161827,15.9166127,26.8594288,1.8221241,70.9534299),(48119,'metatarsal.tif',233,10,91,212.0785885,95.0992402,103.7629294,1.8,94.8881713,104.2214699,1.3364742,13.1901014,21.4607536,3682.8357857,9382.8596775,33.4409318,437.2101672,279.2120897,601.4359512,18.984348,29.6523322,1.7495894,122.425328),(48120,'metatarsal.tif',233,10,92,210.8150645,95.1926846,103.658878,1.8,94.9390299,104.1133634,1.3266576,21.3409559,19.1976698,3710.8985931,9185.8834899,33.0828956,478.4895026,173.886241,584.3627358,18.984348,28.55454,1.6447354,122.0487813),(48121,'metatarsal.tif',233,10,93,210.2256621,95.2749496,103.5458973,1.8,94.9996853,104.0060374,1.3186523,17.2715841,19.133029,3745.5613205,9061.5940501,32.8568468,473.6100108,216.8626401,660.9772511,16.400251,26.36715,1.8545904,72.0684344),(48122,'metatarsal.tif',233,10,94,209.1010898,95.3830895,103.4442631,1.8,95.1320988,103.8762605,1.3098122,16.252629,14.3317579,3744.2858248,8936.7111165,32.5298478,623.5600098,230.3803174,772.9015138,16.1369987,27.0337234,1.929567,75.5487206),(48123,'metatarsal.tif',233,10,95,208.7955833,95.4773458,103.3105936,1.8,95.2162369,103.6045571,1.3066987,19.6974566,19.9357343,3807.2211573,8840.8900523,32.4280072,443.4694958,193.2849113,453.4162864,16.1860278,26.0298366,1.8583722,71.5712506),(48124,'metatarsal.tif',233,10,96,208.2135968,95.561294,103.2195348,1.8,95.3007578,103.5534619,1.2940713,27.5800528,19.9174831,3810.0820385,8734.7260884,32.1120223,438.5456762,138.1462922,414.7782698,16.3862806,25.9323151,1.8453716,71.2800071),(48125,'metatarsal.tif',233,10,97,205.2039631,95.7269229,103.0605566,1.8,95.5070439,103.3687194,1.2977432,23.2673116,20.1599867,3784.7043546,8448.3940414,31.7134741,419.0674409,162.6618676,460.3084417,18.7097,26.1671732,1.6784862,113.52599),(48126,'metatarsal.tif',233,10,98,203.481112,95.8235477,102.9336108,1.8,95.6351268,103.332695,1.2871075,21.7973843,20.1799377,3788.7907728,8303.0741126,31.2566189,411.4519204,173.8185978,465.3965714,18.8141174,25.9037027,1.7069353,108.6394558),(48127,'metatarsal.tif',233,10,99,201.087997,95.8993119,102.8018187,1.8,95.5923496,103.1787477,1.2773797,22.9160954,19.9899581,3790.4005304,8090.5914316,30.7111375,404.7327855,165.4034189,475.7058547,16.4298968,25.0696,1.8259787,68.6734514),(48128,'metatarsal.tif',233,10,100,200.3190061,95.9874195,102.6644753,1.8,95.7207676,103.0412386,1.2644939,14.0277623,20.120243,3803.6733469,7970.87821,30.3508832,396.1621254,271.1532506,483.4757617,16.523414,25.0202504,1.8703283,67.8850242),(48129,'metatarsal.tif',233,10,101,199.0780664,96.0998933,102.5201743,1.8,95.9310882,102.8406935,1.2481362,17.8404231,19.7988862,3772.749407,7808.4118719,29.84358,394.3864202,211.4719697,495.5075939,18.1323847,26.2002155,1.773455,110.0457038),(48130,'metatarsal.tif',233,10,102,198.0734944,96.189023,102.3866539,1.8,95.9978356,102.7326043,1.2354427,24.7302519,19.7742863,3819.2143565,7675.6125317,29.4367294,388.1612932,154.4349151,464.2063373,17.9245509,24.6920691,2.0599161,101.3876398),(48131,'metatarsal.tif',233,10,103,196.0978711,96.3207088,102.3052197,1.8,96.1554561,102.7352751,1.2275984,23.1212583,20.3340876,3801.1414751,7509.4134143,28.9822056,369.3017149,164.4002858,487.9797773,17.221329,24.6845598,1.7570192,97.9926568),(48132,'metatarsal.tif',233,10,104,195.411652,96.4072264,102.1692037,1.8,96.3115586,102.6268517,1.2056605,13.274122,20.6192546,3803.5221005,7392.7541218,28.4159998,358.5364395,286.5366234,491.5363467,17.226538,24.3822884,2.0021971,68.5881482),(48133,'metatarsal.tif',233,10,105,194.159364,96.5196816,101.9746244,1.8,96.490957,102.4927507,1.1921309,17.0721209,20.8003292,3850.7351071,7300.661794,27.9374657,350.9878003,225.556926,502.8428133,0.351562,1.7926215,1.7681919,3.8068635),(48134,'metatarsal.tif',233,10,106,192.7634052,96.5903725,101.8446377,1.8,96.5926756,102.4729565,1.1750424,19.0538685,16.1404427,3860.463567,7199.5749689,27.3527007,446.0580863,202.6078624,577.0886296,0.351562,1.7926215,1.7681919,3.8068635),(48135,'metatarsal.tif',233,10,107,190.5264703,96.7115579,101.7336329,1.8,96.7272259,102.4439022,1.1782404,19.8512461,15.5482142,3831.7971617,7039.7681161,27.1073004,452.7702029,193.0255232,545.1308712,18.0789375,25.2440122,1.7955075,112.5316225),(48136,'metatarsal.tif',233,10,108,189.1820097,96.7853889,101.5876074,1.8,96.7821958,102.268231,1.1603289,19.5456149,16.3003234,3823.0018533,6926.9997708,26.5097178,424.9608799,195.5938388,548.430397,17.226538,23.9165538,1.9949907,65.9815924),(48137,'metatarsal.tif',233,10,109,187.6899458,96.851189,101.4161645,1.8,96.8124783,101.9488056,1.1397207,18.5726329,16.1366835,3789.6786325,6815.4318049,25.8199686,422.3564147,204.0463866,567.3580589,18.0057115,24.3010478,1.8192837,108.2629091),(48138,'metatarsal.tif',233,10,110,185.8943604,96.917909,101.2439455,1.8,96.8562775,101.583299,1.1101171,15.7704426,21.0248115,3737.0720755,6664.3705119,24.8593241,316.9764695,236.9668484,484.7739007,17.226538,23.5965942,2.0011229,66.1875327),(48139,'metatarsal.tif',233,10,111,185.0897889,96.9932989,101.1026931,1.8,96.9612372,101.4850511,1.0920572,17.6744522,16.6071516,3730.7720494,6594.8655732,24.3020419,397.1099764,211.0827537,580.1964934,17.226538,23.4521105,1.9874986,65.9815924),(48140,'metatarsal.tif',233,10,112,183.9291116,97.0477175,100.9526198,1.8,96.9670028,101.293057,1.0728428,15.2996883,16.086416,3728.3344988,6507.2083189,23.6615901,404.5157313,243.6869579,591.6750363,17.5781,23.4283829,2.0210219,65.7756522),(48141,'metatarsal.tif',233,10,113,182.206298,97.1427393,100.7342159,1.8,97.0621362,101.0477868,1.0511888,14.0490439,32.6222553,3705.1475887,6427.160104,22.8805106,197.0176511,263.7295187,295.315897,17.5781,23.2881632,2.0749623,65.2784684),(48142,'metatarsal.tif',233,10,114,180.5544208,97.202938,100.5769507,1.8,97.1398169,100.8899959,1.0269294,15.0478471,15.7877756,3679.1122774,6304.6511982,22.0350622,399.3375233,244.4942625,578.1220521,17.929662,23.1551021,2.0955921,65.3637716),(48143,'metatarsal.tif',233,10,115,179.5071521,97.2504882,100.392433,1.8,97.1137604,100.6084119,1.0033379,15.4529185,41.3789373,3672.1356725,6306.4143834,21.2747064,152.4063881,237.6337948,240.4899502,18.546606,24.1454256,1.851096,110.834131),(48144,'metatarsal.tif',233,10,116,178.0843393,97.3085511,100.2108427,1.8,97.1273697,100.3662488,0.9827111,13.678236,41.1195244,3637.2411771,6302.2033774,20.5459304,153.2654735,265.9144918,241.4146972,17.929662,23.032007,2.1164514,65.0725282),(48145,'metatarsal.tif',233,10,117,176.7133992,97.3767861,100.0286707,1.8,97.2399134,100.1594799,0.9608811,14.0582934,40.8433264,3581.8948489,6199.2778627,19.7890295,151.7819043,254.7887389,239.4019088,18.5007015,23.2376897,1.7533562,98.4545068),(48146,'metatarsal.tif',233,10,118,175.554295,97.4515539,99.852496,1.8,97.4028363,100.0070361,0.9411868,13.2141573,40.6804813,3537.2541778,6151.921675,19.1143567,151.2253906,267.6867021,238.1197356,17.8986149,22.9809709,2.0823525,64.9518911),(48147,'metatarsal.tif',233,10,119,174.1837295,97.5198632,99.6794696,1.8,97.4678089,99.8418676,0.9181572,11.97836,39.8880409,3486.0609937,6094.2054783,18.3242634,152.7827725,291.0299074,240.1750424,17.8628161,22.9567563,2.0481417,64.8665879),(48148,'metatarsal.tif',233,10,120,172.047881,97.5840961,99.4882063,1.8,97.5398116,99.5784569,0.8958814,13.8874657,39.3249601,3430.8880347,6010.371597,17.4796733,152.8385938,247.049254,240.0386878,17.6500231,22.7322284,2.1244776,65.0371944),(48149,'metatarsal.tif',233,10,121,170.0447295,97.6915463,99.2358898,1.8,97.7066112,99.4530805,0.8776181,16.3766179,23.2851507,3381.9948697,5898.4538006,16.7691857,253.3139632,206.5136338,370.4962567,17.5820462,22.7322284,2.1244776,65.4490749),(48150,'metatarsal.tif',233,10,122,168.2178706,97.7604821,99.0390193,1.8,97.8659072,99.0999585,0.8521369,27.8018256,13.3868547,3326.63312,5823.1584988,15.8837122,434.9907887,119.6552041,324.7563974,17.4396655,22.7322284,2.1244776,65.7403184),(48151,'metatarsal.tif',233,10,123,166.956032,97.8114708,98.8609201,1.8,97.8937329,98.9401315,0.8414567,22.0906225,16.4193085,3295.4412458,5801.5307926,15.4696215,353.3358783,149.1782882,389.5076645,17.3594626,22.8109291,2.068913,64.4547074),(48152,'metatarsal.tif',233,10,124,165.4103349,97.8609902,98.6665528,1.8,97.9613513,98.7145503,0.8226937,15.2462863,16.2642652,3246.8782536,5768.370868,14.8114192,354.6653229,212.9619107,540.4853941,17.2468288,23.5965942,2.1546667,68.1409339),(48153,'metatarsal.tif',233,10,125,164.8331424,97.9210652,98.4804349,1.8,98.0321346,98.5910662,0.8126895,14.5325679,18.3623948,3214.1156843,5751.860014,14.4854754,313.2412783,221.1663965,473.4774773,17.1385788,23.5965942,2.1546667,67.9349936),(48154,'metatarsal.tif',233,10,126,163.8299561,97.9614261,98.2826702,1.8,97.9622681,98.426638,0.804554,13.9637771,23.2829948,3181.1114026,5709.2366737,14.1754173,245.2105811,227.8116713,345.1742359,17.0426757,22.5493522,2.1112158,64.3340704),(48155,'metatarsal.tif',233,10,127,162.8546726,98.0238125,98.0788505,1.8,98.0287252,98.2335066,0.7924874,18.6557668,23.2532826,3155.109795,5719.2949424,13.7636358,245.956454,169.1224932,339.2775568,16.9697895,22.5493522,2.1112158,64.2487671),(48156,'metatarsal.tif',233,10,128,163.5789442,98.0287065,97.8310363,1.8,97.9727352,97.8491549,0.7542123,14.4265572,20.0390394,3136.2138856,5829.3097988,12.7819048,290.8976668,217.3917061,431.7055765,16.8748719,22.5493522,2.1112158,66.5287456),(48157,'metatarsal.tif',233,10,129,161.9135839,98.1837776,97.5823807,1.8,98.1832875,97.6253478,0.7454119,13.6110534,22.2671839,3095.9263195,5811.3708428,12.4148951,260.9836462,227.4567756,398.1387728,16.7616612,22.5246736,2.1674567,64.5400106),(48158,'metatarsal.tif',233,10,130,160.8936935,98.2747833,97.4067038,1.8,98.2623938,97.5066763,0.7388618,18.1329889,24.1906832,3083.4782655,5773.3342713,12.1617088,238.6594139,170.0479877,329.6223925,16.6661952,22.6232264,2.1458686,64.6253139),(48159,'metatarsal.tif',233,10,131,160.1468376,98.3615456,97.2181125,1.8,98.3728923,97.3494856,0.7326426,18.2583155,19.1197442,3074.112477,5746.9783838,11.9400755,300.5782042,168.3678039,433.0966587,16.509329,22.7240714,2.1802549,64.8312541),(48160,'metatarsal.tif',233,10,132,160.3872127,98.4156235,97.0702456,1.8,98.1443205,97.5205079,0.7323494,17.7529173,16.5321565,3121.6307204,5737.7155213,11.9502037,347.0639493,175.8376194,442.9692567,16.4616105,22.5712661,2.223643,64.9165574),(48161,'metatarsal.tif',233,10,133,158.9752239,98.5042535,96.879066,1.8,98.0517151,97.4353213,0.7373893,21.418578,20.9741898,3132.5282688,5654.434959,11.9778533,269.5901498,146.252859,392.3122168,16.3446463,22.7240714,2.1802549,64.2487671),(48162,'metatarsal.tif',233,10,134,156.8549185,98.585733,96.6462713,1.8,98.3138781,97.0728628,0.7253107,16.9970684,18.4031114,3020.3849138,5569.6249876,11.5041868,302.6458329,177.7003448,434.9947482,16.1624279,22.5712661,2.223643,64.5400106),(48163,'metatarsal.tif',233,10,135,155.3066747,98.6744782,96.4143811,1.8,98.5213333,96.8338052,0.7131682,20.089967,16.9113612,2978.8822667,5463.920377,11.0790867,323.0916964,148.2771109,411.9637084,16.0378379,22.4367078,2.1892243,63.8368866),(48164,'metatarsal.tif',233,10,136,153.8427756,98.7139732,96.1643682,1.8,98.5276553,96.5541916,0.6968872,25.1908314,14.9317184,2937.94366,5388.7309562,10.5626048,360.8915477,116.6274986,329.5810149,15.8800792,22.2486255,2.1193457,63.9221899),(48165,'metatarsal.tif',233,10,137,152.3661798,98.8304647,95.8407072,1.8,98.6711345,96.2041986,0.670874,28.8935183,20.4044317,2910.0476989,5337.7465791,9.8142774,261.5974147,100.7162807,284.5889667,15.8400244,22.151196,2.1984258,64.2134334),(48166,'metatarsal.tif',233,10,138,150.8450147,98.8454012,95.6230357,1.8,98.5590883,96.1585058,0.6583304,27.4756738,18.7017031,2966.7068883,5267.2858003,9.4101044,281.6473862,107.9757646,299.4673116,0.351562,0.4971837,2.3561945,0.9943675),(48167,'metatarsal.tif',233,10,139,149.3752354,98.8908608,95.3823487,1.8,98.750792,95.9272544,0.6529012,26.3743403,21.0421369,2862.5677976,5205.316119,9.1877783,247.3758318,108.5360911,303.366744,15.6430233,22.0168773,2.2430435,64.8312541),(48168,'metatarsal.tif',233,10,140,148.5231357,98.9385869,95.1658883,1.8,98.8342473,95.8217097,0.6485024,25.8555335,18.4494819,2837.4790354,5160.3388622,9.0304082,279.7010179,109.7435886,307.1414016,15.5596543,21.9268743,2.4242709,64.8312541),(48169,'metatarsal.tif',233,10,141,147.5990883,98.8933819,94.878545,1.8,98.4120795,95.2509783,0.6120885,20.5651073,15.0048653,2804.1003857,5112.6115166,8.1213919,340.7302517,136.3523345,362.5472658,5.3665599,19.6686293,2.7179237,60.0946284),(48170,'metatarsal.tif',233,10,142,146.2721184,98.9515905,94.6095062,1.8,98.4432648,94.7885038,0.5975843,20.4199631,19.1849802,2762.2638598,5057.1970008,7.7176028,263.6018881,135.2727153,289.8741159,15.3810585,22.875856,2.3344588,69.8384254),(48171,'metatarsal.tif',233,10,143,146.4657519,98.9965256,94.3638098,1.8,98.6605546,94.5055369,0.5815694,22.0442464,15.5965933,2719.3447166,5043.7790722,7.3664954,323.3897927,123.3584794,350.6588929,0.351562,0.4971837,2.3561945,0.9943675),(48172,'metatarsal.tif',233,10,144,145.4536892,99.0254713,94.0954868,1.8,98.7451749,94.0789739,0.5624291,28.4827641,14.2497642,2663.7646918,5004.0584983,6.8932391,351.1678109,93.5219871,268.8647259,0.351562,1.1117367,1.8925469,2.4006155),(48173,'metatarsal.tif',233,10,145,144.7724514,99.0309041,93.7458828,1.8,98.6641444,93.6722717,0.5430401,28.7515643,13.4255843,2647.9276116,5023.8874763,6.4428903,374.2025207,92.0968188,266.2992229,2.0610684,4.3485818,1.3258177,13.2886885),(48174,'metatarsal.tif',233,10,146,143.0180272,99.0743083,93.4735351,1.8,98.8382312,93.2932886,0.5309128,15.280606,12.4849728,2572.9728752,4989.6065788,6.1106982,399.6489759,168.3815997,482.8891656,15.1885452,23.6489149,2.3036114,82.5945964),(48175,'metatarsal.tif',233,10,147,142.0975004,99.0774723,93.2180232,1.8,98.938192,93.0459134,0.5222742,14.7401156,13.1557491,2537.4056507,4967.2438175,5.8935834,377.5721013,172.1428594,499.3807593,15.0962198,23.4151905,2.2924512,77.9993056),(48176,'metatarsal.tif',233,10,148,142.387239,99.0883973,92.9555547,1.8,98.9457538,92.8447203,0.5061122,13.7496801,14.0873145,2539.7280962,5000.310119,5.5771214,354.9512669,184.7117951,501.9105264,14.9645223,23.1310698,2.3884414,69.9237286),(48177,'metatarsal.tif',233,10,149,142.2543547,99.0817157,92.700378,1.8,98.836094,92.6527207,0.4788595,16.0026463,12.0823481,2537.2408892,4992.174791,5.0335872,413.1791903,158.5513318,461.8519686,1.75781,2.0499411,2.1112158,7.372453),(48178,'metatarsal.tif',233,10,150,141.9319194,99.1066756,92.4263383,1.8,98.9119843,92.3435147,0.4498355,14.4056715,11.8329109,2520.8502781,4989.4771022,4.4724216,421.661004,174.9901268,438.4226102,0.9447673,1.988735,0.7853982,3.97747),(48179,'metatarsal.tif',233,10,151,141.9654775,99.0423695,92.1652272,1.8,98.7946422,92.0710576,0.4126619,11.7065958,12.3114924,2518.6608372,5043.457093,3.8056319,409.6544041,215.1488686,569.5643074,1.3804113,3.003747,1.2120257,7.7843335),(48180,'metatarsal.tif',233,10,152,140.829482,99.067939,91.8886232,1.8,98.851196,91.6938194,0.3912657,12.6278799,13.0394618,2460.0601744,5011.4092832,3.4135779,384.3263911,194.8118124,520.5544514,0.9255789,3.33521,1.2490458,7.2018465),(48181,'metatarsal.tif',233,10,153,138.2432203,99.2005629,91.5214776,1.8,99.0480262,91.2459869,0.3861749,9.1923113,12.2098004,2405.7218071,4904.2981877,3.2686123,401.6689882,261.71022,544.2120577,1.8913395,2.6774164,1.1659045,9.7730685),(48182,'metatarsal.tif',233,10,154,135.3500664,99.2665399,91.2492185,1.8,99.1764593,90.9720076,0.3799577,8.6894841,12.1316849,2333.0989333,4791.1443661,3.1029649,394.9281895,268.4968305,485.8637933,0.4971837,1.4915512,2.3561945,2.9831025),(48183,'metatarsal.tif',233,10,155,133.487552,99.3711209,90.9446492,1.8,99.2535089,90.6469638,0.3764239,8.9366173,12.4611271,2289.5255284,4723.6153719,3.00631,379.0680684,256.1959917,506.7525782,0.8794877,2.0499411,2.1112158,4.3893505),(48184,'metatarsal.tif',233,10,156,131.0793432,99.4498219,90.6664904,1.8,99.3216163,90.3587312,0.3733082,8.8362274,12.2447722,2234.5164447,4648.7030656,2.905689,379.6479815,252.8812733,503.3851665,1.8526705,3.4624841,1.9890207,10.184949),(48185,'metatarsal.tif',233,10,157,130.2774309,99.5517298,90.3429344,1.8,99.454198,90.1013437,0.3611413,18.124734,12.2653267,2232.656518,4609.2890616,2.710871,375.798311,123.1828571,371.6119227,2.0446157,2.745787,2.4468544,11.3852567),(48186,'metatarsal.tif',233,10,158,128.6385876,99.6361865,90.0397632,1.8,99.5499813,89.8196471,0.3493026,33.8719457,18.1226352,2182.3901301,4558.1644248,2.5112402,251.5177504,64.4306102,175.4651645,1.054686,1.5722331,2.0344439,4.1834102),(48187,'metatarsal.tif',233,10,159,127.4592211,99.7301944,89.739,1.8,99.6911093,89.478017,0.3468499,8.41739,12.5437536,2118.5925505,4519.9920599,2.4548041,360.3380774,251.6923355,474.1516573,1.0014459,1.5722331,1.1071487,3.97747),(48188,'metatarsal.tif',233,10,160,125.5790662,99.8768097,89.4318901,1.8,99.8358443,89.2300812,0.3343675,15.9607471,14.2153973,2068.4375192,4478.2789454,2.2540754,315.0301643,129.5952821,306.3018127,0.351562,0.4971837,2.3561945,0.9943675),(48189,'metatarsal.tif',233,10,161,123.6132931,99.9980142,89.0656238,1.8,99.8371222,88.8577113,0.3150448,20.5232017,14.5274424,2016.4394439,4439.1835669,1.9780727,305.5722712,98.2516995,263.1417308,14.2505985,21.660328,2.9123607,61.3863017),(48190,'metatarsal.tif',233,10,162,120.375569,100.1102755,88.7559718,1.8,100.0399108,88.5539261,0.3051103,15.7934738,15.5777188,1941.1551,4342.5643436,1.8104322,278.7676675,122.9086855,283.2634135,0.703124,1.2675748,2.1587989,2.691859),(48191,'metatarsal.tif',233,10,163,119.8033577,100.2001956,88.3987342,1.8,100.1158929,88.2015872,0.2855614,17.0090571,13.6781618,1937.7239347,4376.1080478,1.5844533,319.9339281,113.9230657,339.9543755,14.0546773,21.8563016,2.9473517,61.1803614),(48192,'metatarsal.tif',233,10,164,118.1642521,100.2436591,88.0974522,1.8,100.0822693,88.0431497,0.2543413,32.60478,14.975574,2018.7520265,4395.2845656,1.2467623,293.4969012,61.9158303,179.8323635,0.351562,0.4971837,2.3561945,0.9943675),(48193,'metatarsal.tif',233,10,165,118.1528663,100.324338,87.7734836,1.8,100.1226228,87.7342317,0.2266138,32.2616306,15.9421531,2100.2902464,4468.4670788,0.9940742,280.2925709,65.1018007,182.8926582,14.0709339,22.2708353,2.9349094,61.8834854),(48194,'metatarsal.tif',233,10,166,118.2832787,100.4453265,87.3693079,1.8,100.3487201,87.248201,0.2584787,9.0192009,12.5437095,1898.3055399,4492.1105449,1.2880358,358.1165969,210.4738057,504.9764341,0.7783414,1.75781,2.2142974,3.6862265),(48195,'metatarsal.tif',233,10,167,118.5214066,100.5127622,86.9837816,1.8,100.4424802,86.9244445,0.2543823,33.2201041,12.3957761,1933.9785294,4593.4045535,1.2509246,370.5620782,58.2171123,184.0906086,0.351562,0.4971837,2.3561945,0.9943675),(48196,'metatarsal.tif',233,10,168,119.0945168,100.6114988,86.5971933,1.8,100.4944027,86.6067317,0.2524462,33.5950392,12.4591181,1995.6345022,4684.735305,1.2383193,376.0085795,59.4026544,186.441376,14.4102192,22.7675416,2.9078495,63.0837932),(48197,'metatarsal.tif',233,10,169,119.9928338,100.6976974,86.1329086,1.8,100.6487118,86.0858045,0.2523951,33.2861131,12.4229831,2046.6728529,4796.6145674,1.247166,386.1081143,61.4872888,195.5297883,14.6591135,23.0346899,2.863293,63.9928574),(48198,'metatarsal.tif',233,10,170,119.7176646,100.7897864,85.6797961,1.8,100.7157611,85.5728295,0.2538946,22.1402413,12.4861504,2075.5515813,4865.4901184,1.258815,389.6709511,93.7456623,312.4004701,14.8363888,23.1924362,2.896614,66.8553229),(48199,'metatarsal.tif',233,10,171,120.5496144,100.7873676,85.2182193,1.8,100.6460603,85.1276682,0.2763069,8.9011679,12.4408339,2142.7754804,4985.9135167,1.4952627,400.7700404,240.7297013,511.428148,15.0074068,23.3755686,2.9294489,65.2784684),(48200,'metatarsal.tif',233,10,172,121.3134741,100.8796617,84.7323649,1.8,100.7439785,84.6367443,0.2829507,8.6487843,12.9650752,2216.5981864,5072.9283763,1.5760074,391.276433,256.2901441,556.0975695,15.5411339,23.9475405,2.4393357,70.0796994),(48201,'metatarsal.tif',233,10,173,123.04052,100.9390676,84.2060238,1.8,100.8729997,84.0949377,0.2742795,22.3086297,12.4095736,2326.0263738,5266.1508608,1.504408,424.3619493,104.2657666,333.8678972,0.703124,0.9943675,2.3561945,1.988735),(48202,'metatarsal.tif',233,10,174,124.5808987,100.9828835,83.6672845,1.8,100.9668507,83.6084943,0.261245,23.3264088,12.7849507,2443.1694356,5379.1246402,1.3851397,420.7387873,104.7383445,330.5977573,15.8382346,24.1249417,2.8152338,68.3822079),(48203,'metatarsal.tif',233,10,175,128.8761537,101.0597954,83.0186701,1.8,101.1349656,82.8868703,0.2453362,35.7227554,15.5039789,2721.3060081,5659.8461313,1.2671084,365.057652,76.1785024,215.2207534,17.0213698,24.3594669,2.7878895,74.1778064),(48204,'metatarsal.tif',233,10,176,134.9339978,101.0503166,82.2498252,1.8,101.057111,81.9995564,0.270468,41.1359091,17.3139675,3068.7473326,5996.8063855,1.6054096,346.3565703,74.600207,220.0513658,18.9480613,25.3514964,2.8023,91.1673571),(48205,'metatarsal.tif',233,10,177,139.4271935,101.106735,81.5073504,1.8,101.0724245,81.3402704,0.2603749,41.1413288,16.4103709,3206.6268407,6304.9618027,1.5401313,384.2059297,77.9417422,231.0845225,18.588699,25.7505666,2.580099,81.6355626),(48206,'metatarsal.tif',233,10,178,150.3482343,101.1990221,80.5061396,1.8,101.049741,80.3104647,0.2387844,38.4361676,19.6272001,3946.807591,7072.377696,1.4018097,360.3355374,102.6847326,257.2798143,19.7123573,27.5656892,2.4827866,88.7021364),(48207,'metatarsal.tif',233,10,179,164.2964743,101.4032363,79.6280458,1.8,101.2735208,79.6127491,0.151359,37.5669003,18.9635659,4652.9512541,7882.1318909,0.62255,415.6460825,123.8577369,297.873295,21.445282,28.083181,2.5431738,94.9595849),(48208,'metatarsal.tif',233,10,180,188.0268006,101.1949209,78.6296114,1.8,101.0644361,78.9074623,0.1644968,38.4154251,20.29543,5629.3500133,9458.424761,0.840355,466.0371697,146.5387927,347.267811,21.7780485,29.9653763,2.5991611,106.8066916),(48209,'metatarsal.tif',233,10,181,205.2294314,101.1824568,78.263341,1.8,101.2076429,78.7960471,0.1090227,11.3534977,13.9355557,5967.2964069,10638.1901304,0.4049498,763.3847071,525.5910189,1053.2712633,21.7757595,29.88277,0.4899573,100.2226658),(48210,'metatarsal.tif',233,10,182,222.1779791,101.2439298,78.2299739,1.8,101.2787797,78.7185465,0.0845714,11.7036894,13.932701,6614.8260412,11704.3109507,0.2642175,840.0604395,565.1915234,1130.7500724,21.436681,31.021238,0.407868,94.6330076),(48211,'metatarsal.tif',233,10,183,236.8074569,101.3360026,78.2445306,1.8,101.4625151,78.6334403,0.0786932,11.4581712,14.4250228,6966.9193337,12565.3708012,0.243906,871.0815239,608.0306559,1228.0829988,21.4244117,30.3770726,0.4170492,93.7946109),(48212,'metatarsal.tif',233,10,184,248.0934799,101.3732678,78.3876633,1.8,101.3555257,78.6643284,0.089449,39.1842569,29.7596478,6877.1324773,12689.3529395,0.3299565,426.3945941,175.5075386,463.6454875,20.8256205,29.8393102,2.5405189,92.4236966),(48213,'metatarsal.tif',233,10,185,252.2277982,101.4170036,78.5791251,1.8,101.2677178,78.6144357,0.1231879,11.4012454,29.3626121,6661.1008015,12569.7591419,0.6347162,428.0872248,584.2432596,653.8716893,1.75781,3.6195523,2.0778948,7.9902737),(48214,'metatarsal.tif',233,10,186,238.5864879,101.0687997,78.6244558,1.8,100.8437462,78.4026099,0.1325095,10.8878188,16.3914285,6118.4824826,11692.4450007,0.6941373,713.3267872,561.9566772,1079.0325941,20.0682621,30.1299095,2.9419088,109.5192486),(48215,'metatarsal.tif',233,10,187,209.8665975,101.0797299,78.8470788,1.8,100.9656553,78.6567583,0.1017214,10.5925759,15.093844,4750.9237315,9382.5650067,0.3606766,621.6153426,448.5144837,935.4329563,18.8485216,28.907291,0.2331798,97.6014744),(48216,'metatarsal.tif',233,10,188,201.0449631,101.2584797,78.9991028,1.8,101.2646781,78.7154961,0.0798731,9.8028596,13.4716621,3864.9870105,8943.5670195,0.2133138,663.8799998,394.2713828,861.4177402,17.4263892,27.1272857,0.3299471,85.2218501),(48217,'metatarsal.tif',233,10,189,188.8775145,101.317507,78.9522488,1.8,101.214712,78.4110611,0.0824144,9.2675202,13.5686612,2995.2529893,8302.6111893,0.2133298,611.8961214,323.1989706,748.6770293,16.7172367,26.9513033,2.6078845,86.1309144),(48218,'metatarsal.tif',233,10,190,151.084491,101.5814574,79.3231175,1.8,101.692509,79.2736202,0.0525893,38.0634754,18.3952572,1434.4171381,5983.3785592,0.0695766,325.2674591,37.6848704,175.4634368,13.359356,25.9037027,0.136139,80.2999821),(48219,'metatarsal.tif',233,10,191,78.0013345,102.8117327,79.4949441,1.8,101.8587104,79.2176923,0.0616348,4.9142968,13.7301071,332.4716548,2426.2262261,0.0493234,176.7084704,67.6539636,196.0838223,9.843736,23.2456665,0.060532,58.9710504),(48220,'metatarsal.tif',233,10,192,3.1317313,106.462368,79.5989352,1.8,106.1973744,79.4922421,0.0601053,2.4449442,14.1117519,3.8053976,24.9649294,0.0018834,1.7690879,1.5564354,2.028646,0.6292498,1.2675748,2.5535901,2.4859187),(48221,'metatarsal.tif',233,10,193,139.2982419,100.8567162,71.9547231,1.8,100.8126571,72.5023007,-0.0345071,35.1914788,12.0442058,1520.4345637,6430.0122503,0.0276338,533.8676823,43.2046227,225.1395563,16.0465127,25.5094511,0.5191461,89.8671104),(48222,'metatarsal.tif',233,10,194,156.6953676,100.8530742,73.3673353,1.8,100.9831897,73.6258067,-0.0397472,9.5396306,11.8329697,2461.3401505,6814.8483824,0.0412372,575.920377,258.0121021,737.9588899,19.2923359,25.0819223,0.5452272,89.8317766),(48223,'metatarsal.tif',233,10,195,164.3576355,101.3532292,74.502071,1.8,101.1504541,73.9206241,0.0513153,31.470974,12.2194454,3192.843624,6511.9692675,0.0720694,532.9185611,101.4536004,305.0177422,19.1545953,24.5590655,2.7291822,76.6990589),(48224,'metatarsal.tif',233,10,196,144.0709888,101.4056902,74.4823576,1.8,101.1814634,73.8074889,0.0490584,38.5138298,11.7517467,2868.1202192,5740.3973268,0.0577437,488.4718383,74.4698784,217.4307956,19.2868367,24.4430417,2.4376465,74.3337772),(48225,'metatarsal.tif',233,10,197,124.5581271,101.5568081,74.343022,1.8,101.292873,73.6226035,0.0179714,9.7411085,11.5592076,2456.9928728,4869.1620346,0.0067041,421.2366629,252.2292904,545.7856943,19.2711193,23.9475405,2.4393357,72.2244052),(48226,'metatarsal.tif',233,10,198,106.3655311,101.6221372,74.1341926,1.8,101.3724974,73.4429831,-0.0158065,8.1410856,10.890711,2047.5266017,3863.329192,0.0044288,354.7361768,251.5053522,452.286871,19.2358135,23.1337413,2.5072098,71.1094007),(48227,'metatarsal.tif',233,10,199,92.8685657,101.4202145,73.9623585,1.8,101.3764316,73.3927922,-0.0111438,7.9687836,9.9963052,1693.8758977,3069.2902249,0.001922,307.04247,212.5639221,380.3971498,18.984348,22.1595639,2.4123153,68.4528754),(48228,'metatarsal.tif',233,10,200,84.1715385,101.1832559,73.6755352,1.8,101.2939899,73.1797804,0.0106235,33.8774077,9.5337114,1374.5610293,2583.1942928,0.0015832,270.9536917,40.5745635,116.4998391,18.632786,21.2484259,0.8908875,65.7256827),(48229,'metatarsal.tif',233,10,201,75.1630122,101.1513899,73.2403814,1.8,101.2451197,72.7617086,-0.0044844,7.2755677,10.0788707,1080.4460211,2098.160044,0.0002519,208.1741211,148.5033285,281.0234855,18.281224,20.3936265,2.1970578,62.4160029),(48230,'metatarsal.tif',233,10,202,71.0890312,101.0244633,72.8100714,1.8,101.0715817,72.3649237,0.0001627,6.9945231,9.619093,910.1480739,1760.5584215,0.0000003,183.0274881,130.1229644,250.3019606,17.226538,19.5013948,2.1637989,59.8094472),(48231,'metatarsal.tif',233,10,203,65.8025,100.8709476,72.3066414,1.8,100.9417291,71.8629458,0.0055716,6.452788,9.134029,715.8291059,1407.9132771,0.0003404,154.139348,110.9333064,207.1704552,16.6503411,18.632786,2.1273956,57.0822544),(48232,'metatarsal.tif',233,10,204,60.0147316,100.7885519,71.5642466,1.8,100.8325088,71.1640713,-0.0009534,5.7805009,8.6760993,496.360934,1118.0787343,0.0000091,128.8688258,85.8681525,170.3435574,15.82029,17.4970539,1.9624963,53.7725747),(48233,'metatarsal.tif',233,10,205,53.8830671,100.7152097,70.8722304,1.8,100.6781411,70.4698349,0.0131649,5.0761969,8.6588714,329.5837751,876.4234272,0.0015564,101.2168203,64.9273028,126.6524064,15.2526144,16.474722,2.2655346,51.1660189),(48234,'metatarsal.tif',233,10,206,47.9990437,100.6640849,70.2574463,1.8,100.6546269,69.922636,0.0113675,4.2907407,8.2420872,225.0296888,672.6314004,0.0010337,81.6093524,52.4454178,100.8226202,14.6242571,15.9912411,2.1527014,49.1772839),(48235,'metatarsal.tif',233,10,207,43.2587312,100.5743975,69.6616031,1.8,100.581522,69.4298329,0.010617,3.8298635,7.0926554,148.7538005,504.4341043,0.0008127,71.1206274,38.840497,84.2046917,14.06248,15.4207132,1.9936503,47.0679119),(48236,'metatarsal.tif',233,10,208,37.9861327,100.4838508,69.0466164,1.8,100.4693441,68.9223666,0.0114052,3.3942667,6.6460353,93.317042,361.1115834,0.0008235,54.334888,27.4925485,63.9157989,13.6725531,14.9196551,2.1718701,45.6616639),(48237,'metatarsal.tif',233,10,209,31.0857395,100.481545,68.391209,1.8,100.450505,68.4564575,0.0065296,2.9845702,6.2663198,52.809199,231.4562551,0.0002209,36.9365532,17.6940717,45.2209603,13.2933201,14.6521662,2.0988708,44.9585399),(48238,'metatarsal.tif',233,10,210,23.3798385,100.4072527,67.8741313,1.8,100.3492253,68.0042045,0.0060822,2.4459282,6.5487686,25.8742065,133.6253348,0.0001441,20.4046505,10.5784814,23.8255497,12.9730459,14.5335918,2.1319597,43.9641724),(48239,'metatarsal.tif',233,10,211,14.9135609,100.3347076,67.4446293,1.8,100.314976,67.5725732,0.0033646,2.1639211,5.7678596,8.9474956,64.5423619,0.0000281,11.1900022,4.134853,12.5612449,0.351562,0.4971837,2.3561945,0.9943675),(48240,'metatarsal.tif',233,10,212,7.6680732,100.2514201,67.0152912,1.8,100.2613054,67.1518228,0.0043518,1.1940901,4.6274632,1.9308111,21.9729446,0.0000242,4.7483781,1.6169727,5.1608885,0.351562,0.7861165,2.0344439,1.6974915),(48241,'metatarsal.tif',233,10,213,2.0074212,100.1495243,66.6191821,1.8,100.1211569,66.7320186,0.01034,0.5432,2.7685011,0.1275773,2.6773918,0.0000358,0.9670907,0.2348624,1.011779,12.656232,14.3625018,2.7656317,42.8491679),(48242,'metatarsal.tif',233,10,214,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48243,'metatarsal.tif',233,10,215,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48244,'metatarsal.tif',233,10,216,0.0075281,79.453012,118.827956,1.8,79.453012,118.827956,0.7853982,0,0,0.0000775,0.0000775,0.0006273,0,0,0,0.351562,0.4971837,2.3561945,0.9943675),(48245,'metatarsal.tif',233,10,217,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48246,'metatarsal.tif',233,10,218,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48247,'metatarsal.tif',233,10,219,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48248,'metatarsal.tif',233,10,220,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48249,'metatarsal.tif',233,10,221,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48250,'metatarsal.tif',233,10,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48251,'metatarsal.tif',233,10,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48252,'metatarsal.tif',233,10,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48253,'metatarsal.tif',233,10,225,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48254,'metatarsal.tif',233,10,226,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48255,'metatarsal.tif',233,10,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48256,'metatarsal.tif',233,10,228,0.0160675,83.671756,121.1020459,1.8,83.671756,121.113109,1.2758784,0.0543084,0.1787773,0.0002073,0.0006182,0.0024517,0.003458,0.0038165,0.004418,0.351562,0.7861165,2.0344439,1.6974915),(48257,'metatarsal.tif',233,10,229,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48258,'metatarsal.tif',233,10,230,10.0071057,114.1177286,104.7394617,1.8,113.7608936,104.8487601,-0.9653268,15.6146658,30.9357889,43.6328093,76.1537552,1.1275845,2.4616717,2.7943479,3.4567294,10.195298,10.9040909,1.2082521,33.8645267),(48259,'metatarsal.tif',233,10,231,24.9995058,113.1240312,104.7445788,1.8,112.8943121,104.7801558,-1.5605126,5.2120841,7.3988807,134.4313938,330.544864,4.1661437,44.6749821,25.7922535,56.7557427,15.117166,15.7105344,0.7061991,49.7597709),(48260,'metatarsal.tif',233,10,232,39.0126898,112.3871257,104.7557112,1.8,112.1746582,104.8036098,-1.5642146,6.2267722,9.1591578,301.2584718,795.8944833,6.5018333,86.8960334,48.3811617,108.5630951,18.281224,19.1818877,0.7205541,61.0597244),(48261,'metatarsal.tif',233,10,233,53.6067367,111.8716596,104.7063499,1.8,111.6453375,104.6821351,-1.5683454,7.1077406,10.4995817,520.9956584,1426.7811501,8.9344025,135.8893321,73.2997565,168.5864128,21.09372,21.7173139,1.0636978,69.5471819),(48262,'metatarsal.tif',233,10,234,193.5729954,94.7056972,102.2122188,1.8,95.3416717,103.9807194,0.1411544,12.9302017,23.7358768,4700.326886,33195.9158351,0.6385518,1398.5544383,363.5153577,1458.5226425,19.687472,28.2061415,2.9661984,89.3845623),(48263,'metatarsal.tif',233,10,235,478.6597214,90.5152276,106.2148182,1.8,93.9139927,106.7255639,-0.0786993,16.822185,27.203566,20874.0327584,59408.6502018,0.4930841,2183.8552404,1240.8633448,2712.8276303,29.0852493,30.4745655,1.3734008,102.7085846),(48264,'metatarsal.tif',233,10,236,542.3529648,90.5680767,107.1618053,1.8,94.297449,106.7194955,-0.1280217,16.6763624,27.9031822,27223.9941039,66195.7393779,1.4734124,2372.3365648,1632.4899553,3078.0575443,0.351562,0.4971837,2.3561945,0.9943675),(48265,'metatarsal.tif',233,10,237,551.0826138,90.785284,107.0687638,1.8,94.5960943,106.6334624,-0.1267854,16.5628767,27.7056245,27959.0067711,68630.6533453,1.4685051,2477.1379336,1688.0525832,3188.1865541,0.351562,0.7861165,2.0344439,1.6974915),(48266,'metatarsal.tif',233,10,238,556.6207187,90.957259,106.9637157,1.8,94.8474158,106.5452877,-0.1245895,16.0365419,27.5386334,28472.6682522,70324.4732839,1.4325938,2553.666058,1775.4867829,3263.0189217,29.1805484,57.2301473,0.0984462,185.7503952),(48267,'metatarsal.tif',233,10,239,561.5521178,91.055712,106.8676996,1.8,94.9911575,106.4655775,-0.1210137,15.9852459,27.4265738,28919.1981465,71547.098298,1.3639146,2608.6779523,1809.1181279,3312.4905896,29.2086348,57.3854298,0.1228352,180.5372837),(48268,'metatarsal.tif',233,10,240,564.4010019,91.1041283,106.7780904,1.8,95.0322452,106.3859551,-0.1176544,16.5062581,27.3243205,29177.3811576,72266.7956391,1.2961281,2644.7792424,1767.6556997,3354.5412032,29.3750151,57.5800174,0.0978461,180.9138304),(48269,'metacarpal.tif',233,5,1,81.489679,88.156161,83.452901,1.8,89.207772,83.341895,-0.071218,5.994605,20.394247,602.560829,7019.812169,0.068769,344.205512,100.517189,369.629014,17.216785,38.939549,0.216874,100.484515),(48270,'metacarpal.tif',233,5,2,84.337362,88.9571,83.38668,1.8,89.705736,83.455962,-0.060483,5.928506,20.200161,617.849012,7127.915848,0.051357,352.864303,104.216639,378.680405,17.815225,39.884242,0.211658,107.196809),(48271,'metacarpal.tif',233,5,3,79.18239,91.300665,83.416578,1.8,91.348775,83.338661,-0.027879,5.363477,18.064898,571.711802,6768.697457,0.010255,374.687834,106.593502,396.913864,18.046896,39.712012,0.262693,101.161436),(48272,'metacarpal.tif',233,5,4,88.096486,91.979299,83.3973,1.8,92.003435,83.358614,-0.011064,5.596214,17.316963,653.45969,7490.280488,0.001797,432.54008,116.768165,456.716651,18.691428,39.549536,0.246955,100.40632),(48273,'metacarpal.tif',233,5,5,94.22153,91.701918,83.355253,1.8,91.873019,83.440833,-0.00909,6.224029,17.585525,700.011468,7972.169073,0.001297,453.336995,112.469191,479.40278,19.314107,38.846089,0.242967,103.264838),(48274,'metacarpal.tif',233,5,6,95.459203,91.782478,83.577439,1.8,91.878981,83.66691,-0.018908,6.614398,17.549966,773.280859,8124.298147,0.005687,462.923881,116.908736,492.477285,20.293754,38.246607,0.281772,110.400496),(48275,'metacarpal.tif',233,5,7,103.002659,91.415721,84.169779,1.8,91.094463,84.17916,-0.04347,6.525379,18.042216,960.473855,9191.589947,0.032419,509.449067,147.190519,546.419457,19.888701,38.834056,0.30338,106.630472),(48276,'metacarpal.tif',233,5,8,115.715721,90.759659,84.968569,1.8,90.768062,84.532097,-0.086779,6.875216,18.940127,1087.812657,10513.353894,0.144871,555.083615,158.222315,596.71055,19.260597,39.047417,0.293038,105.875356),(48277,'metacarpal.tif',233,5,9,135.382027,90.458902,85.052048,1.8,90.369753,85.218959,-0.138519,15.814398,19.68132,1572.31119,12263.040755,0.430178,623.080185,99.422763,632.320562,21.251273,40.565853,0.678463,138.252788),(48278,'metacarpal.tif',233,5,10,158.016047,89.408862,86.21406,1.8,89.778401,86.260528,-0.264996,14.09391,21.190145,3324.71567,17418.542458,1.806504,822.011478,235.897327,945.663161,22.356036,41.925556,0.681944,123.212941),(48279,'metacarpal.tif',233,5,11,161.711033,89.068312,86.968026,1.8,89.738306,86.83813,-0.257588,13.490035,21.702779,3947.537297,19147.888702,1.749093,882.278198,292.626174,1060.104374,22.947936,41.83256,0.654287,123.544694),(48280,'metacarpal.tif',233,5,12,157.227974,89.305853,87.579693,1.8,89.876887,87.346051,-0.260529,12.582951,21.179561,4012.020893,18738.593783,1.738776,884.748933,318.845775,1061.527429,23.396801,42.098598,0.583756,126.325017),(48281,'metacarpal.tif',233,5,13,150.384786,89.851153,87.671955,1.8,90.246304,87.620036,-0.257668,12.395929,19.649301,3993.035821,16719.991737,1.627576,850.920442,322.124767,969.429505,23.46085,41.212265,0.607523,124.26742),(48282,'metacarpal.tif',233,5,14,145.452662,90.091197,87.877386,1.8,90.439641,87.886034,-0.231769,12.373676,18.956515,3897.277917,14844.356457,1.279055,783.074118,314.965244,876.083355,23.136894,39.899863,0.630578,123.922252),(48283,'metacarpal.tif',233,5,15,132.985863,89.321112,88.37368,1.8,90.06553,88.271165,-0.123452,13.203987,19.261448,3733.157651,11800.697949,0.336082,612.658921,282.729575,784.382953,22.829763,37.89744,0.585644,154.646478),(48284,'metacarpal.tif',233,5,16,118.13039,90.139119,89.189009,1.8,90.396419,89.029208,-0.120827,11.846639,18.233567,2866.046619,10711.923482,0.286037,587.483697,241.92909,696.167024,21.973138,36.81316,0.357746,149.600806),(48285,'metacarpal.tif',233,5,17,106.771823,91.96379,89.485589,1.8,92.238157,89.54949,-0.158474,10.761731,18.779047,2395.826415,9689.041488,0.443183,515.949576,222.624628,585.133469,19.786947,36.701556,0.349521,138.883904),(48286,'metacarpal.tif',233,5,18,97.179772,93.660416,89.748509,1.8,94.03161,90.166073,-0.057177,11.165707,19.480911,2522.557354,7439.783865,0.052892,381.90122,225.920081,456.681672,20.397102,36.507205,3.070914,127.581691),(48287,'metacarpal.tif',233,5,19,111.150082,93.919526,90.00715,1.8,94.143568,90.734999,0.084722,13.325476,18.656822,2910.879692,7734.901302,0.132651,414.588371,218.444698,488.463834,21.173129,38.375372,3.006821,141.977007),(48288,'metacarpal.tif',233,5,20,138.172401,92.443328,90.762405,1.8,92.69055,91.395567,0.077632,11.368483,18.255631,3592.757742,10244.990291,0.13851,561.196171,316.027893,663.286596,20.915302,41.335561,2.953371,141.078917),(48289,'metacarpal.tif',233,5,21,147.674066,91.14693,91.268748,1.8,91.348364,91.698796,0.110069,12.021307,19.793126,3897.009385,12190.886051,0.296983,615.915158,324.175174,746.531022,22.141765,41.91069,2.924592,122.81641),(48290,'metacarpal.tif',233,5,22,154.336388,90.269029,91.701714,1.8,90.90167,91.909926,0.081752,11.292955,20.412037,3933.865362,13353.950237,0.171534,654.219383,348.346845,777.4778,21.638994,42.938846,3.081515,122.282462),(48291,'metacarpal.tif',233,5,23,178.036059,90.668532,92.169313,1.8,91.103042,92.259103,0.045511,11.052803,19.688045,4307.573422,16601.638411,0.061417,843.234482,389.726801,951.755813,21.757263,43.213696,3.104297,121.748514),(48292,'metacarpal.tif',233,5,24,7.997651,90.325896,92.878437,1.8,90.343855,93.023546,1.284849,3.233303,6.41787,8.280411,61.999168,1.226891,9.660396,2.560976,10.948938,5.347452,12.334834,1.917335,32.709185),(48293,'metacarpal.tif',233,5,25,27.701187,91.651725,92.510722,1.8,91.847085,92.924423,1.048072,4.189612,8.754003,76.462283,432.494861,3.466141,49.405384,18.250447,57.918983,7.620114,17.309615,2.076087,46.414163),(48294,'metacarpal.tif',233,5,26,41.499286,92.060195,91.7048,1.8,92.157465,91.999515,0.872764,6.619369,9.209601,241.945304,725.601697,4.059471,78.787525,36.551113,104.065041,11.788762,17.610001,2.174026,50.170771),(48295,'metacarpal.tif',233,5,27,45.475342,92.28431,90.986277,1.8,92.392321,91.219897,0.868714,7.058658,8.567606,359.078452,864.362728,4.418166,100.88731,50.870639,133.883211,13.244502,16.896699,2.17996,53.361041),(48296,'metacarpal.tif',233,5,28,49.665969,92.712923,90.657753,1.8,92.822217,90.541224,0.874623,7.935853,9.051766,486.908183,978.133139,4.873492,108.059924,61.355495,157.267316,14.027097,17.780207,2.330559,69.722342),(48297,'metacarpal.tif',233,5,29,49.019957,93.088786,90.834365,1.8,93.016469,90.824899,0.935578,8.722167,9.263424,456.491812,912.270485,5.2936,98.480915,52.336971,143.323586,13.007678,17.165014,2.263131,54.995274),(48298,'metacarpal.tif',233,5,30,46.231535,93.393994,91.481071,1.8,93.262295,91.439835,1.079677,7.67518,10.951461,439.279197,681.622687,5.991458,62.240342,57.233731,99.542622,12.902047,17.092255,2.342862,52.859483),(48299,'metacarpal.tif',233,5,31,41.522354,93.3147,91.972462,1.8,93.478403,92.058771,1.126451,7.235356,8.703285,326.458198,528.310349,5.641602,60.702405,45.119852,95.517469,11.912783,15.283021,2.400941,45.111683),(48300,'metacarpal.tif',233,5,32,36.786455,93.444832,92.577753,1.8,93.586837,92.433402,1.238482,6.469777,10.54133,247.276971,380.044817,5.478564,36.052835,38.220323,56.777352,10.957044,13.228617,2.165556,40.710543),(48301,'metacarpal.tif',233,5,33,34.098489,93.466764,93.066211,1.8,93.568711,92.953225,1.31021,5.308047,6.810507,204.499282,292.447811,5.305828,42.940678,38.526278,71.239334,9.80179,11.928196,2.471071,37.299104),(48302,'metacarpal.tif',233,5,34,31.940123,93.419163,93.488328,1.8,93.548586,93.348065,1.25725,5.033288,5.889251,183.529379,235.020299,4.816935,39.906655,36.463122,70.813453,8.701182,10.571111,2.226492,31.530705),(48303,'metacarpal.tif',233,5,35,30.745377,93.381096,93.903988,1.8,93.490208,93.777602,1.165548,4.900558,5.669567,169.56275,206.191515,4.327767,36.368127,34.600702,63.124624,8.701182,9.953795,2.077895,29.675304),(48304,'metacarpal.tif',233,5,36,30.569137,93.381751,94.326985,1.8,93.60434,94.353669,0.776126,4.808967,20.195113,166.037102,220.714322,2.500192,10.929096,34.526566,19.050318,8.701182,9.521856,1.989021,29.030772),(48305,'metacarpal.tif',233,5,37,28.864461,93.295082,94.760425,1.8,93.349718,94.771781,0.512628,5.147025,5.132584,158.033325,176.145678,1.157272,34.319105,30.70382,57.446047,8.701182,9.367913,2.283154,28.952577),(48306,'metacarpal.tif',233,5,38,27.830723,93.21122,95.250044,1.8,93.257136,95.263823,0.178087,5.874223,6.400978,150.845395,176.707038,0.145559,27.606254,25.679208,45.634709,8.378916,9.395588,0.54042,28.763798),(48307,'metacarpal.tif',233,5,39,27.460085,93.194751,95.855259,1.8,93.479475,96.157793,0.27503,5.350023,7.809625,151.65636,198.136309,0.337547,25.370785,28.346859,36.950917,8.05665,9.657232,0.448723,28.496824),(48308,'metacarpal.tif',233,5,40,29.264305,93.310683,96.861056,1.8,94.138797,97.989489,0.690818,16.39218,20.252312,190.965381,367.104909,1.980136,18.126568,11.649785,27.522234,8.05665,9.995442,0.362544,29.141356),(48309,'metacarpal.tif',233,5,41,29.148396,93.06697,97.393831,1.8,93.403429,98.073799,0.365517,6.985627,8.291278,189.277474,286.792901,0.620656,34.589709,27.095272,50.86114,8.660453,10.412733,0.380506,31.498316),(48310,'metacarpal.tif',233,5,42,32.208667,92.789489,98.424211,1.8,92.88553,99.303406,0.176596,7.580516,7.816463,274.345939,352.789775,0.165678,45.134198,36.190933,59.840075,9.792105,14.157714,0.720971,42.312386),(48311,'metacarpal.tif',233,5,43,33.496663,92.538508,99.085124,1.8,92.591957,99.532653,0.017401,6.528239,6.439028,261.379423,385.232453,0.00169,59.827736,40.038274,73.739886,10.283736,13.710515,0.516231,45.456852),(48312,'metacarpal.tif',233,5,44,35.464659,92.205743,99.930527,1.8,92.352183,100.390454,-0.169491,5.963961,6.502589,282.573038,462.774542,0.168181,71.167736,47.380096,101.877797,10.634778,13.861185,0.620249,40.521764),(48313,'metacarpal.tif',233,5,45,39.864067,91.974211,101.171095,1.8,92.157535,101.468362,-0.162007,6.497842,9.243107,375.560202,721.592948,0.172861,78.068223,57.797684,117.346911,11.538549,16.822779,0.352044,53.42582),(48314,'metacarpal.tif',233,5,46,44.484499,91.811187,102.268382,1.8,91.832489,102.280077,-0.10568,6.308511,8.446197,440.257024,816.656424,0.082494,96.689245,69.787792,129.254259,12.119175,17.736345,0.431139,54.493716),(48315,'metacarpal.tif',233,5,47,55.927032,91.725711,103.433159,1.8,91.837028,103.359161,0.013389,7.097519,9.11703,585.673212,1038.755017,0.001671,113.935682,82.518017,173.869014,12.89064,18.144463,0.344219,59.161829),(48316,'metacarpal.tif',233,5,48,62.89749,91.783611,104.032797,1.8,91.695951,104.034249,-0.00313,6.189399,9.09046,623.371832,1213.826877,0.000103,133.527546,100.716045,188.913925,12.246108,18.91512,0.402655,56.082143),(48317,'metacarpal.tif',233,5,49,59.147021,91.805708,104.153698,1.8,91.775611,104.324546,-0.027698,6.722194,8.686092,518.310109,1078.824296,0.007561,124.201344,77.104306,175.581332,12.51573,17.476803,0.397628,56.192727),(48318,'metacarpal.tif',233,5,50,52.132471,91.800273,104.28393,1.8,91.728751,104.394674,0.012095,6.263992,8.657334,391.009273,951.389031,0.001271,109.893995,62.421736,154.471733,11.601576,17.324608,2.973386,48.835901),(48319,'metacarpal.tif',233,5,51,42.739728,91.72878,103.924217,1.8,91.811617,104.017479,-0.01779,5.969626,12.386862,201.450699,700.590337,0.002254,56.559146,33.745948,72.469756,10.312512,16.270444,3.002497,43.790229),(48320,'metacarpal.tif',233,5,52,25.37426,91.260529,103.978631,1.8,91.715949,103.770607,-0.004618,3.6579,7.668575,51.823939,305.35574,0.00009,39.8191,14.167675,45.405107,7.089852,14.949808,3.01189,38.021831),(48321,'metacarpal.tif',233,5,53,67.389172,92.481258,107.849317,1.8,92.599663,107.910992,-0.062679,6.061034,17.950056,405.28152,5077.927572,0.044068,282.892014,66.866734,300.783399,6.767586,10.492221,0.185348,28.119266),(48322,'metacarpal.tif',233,5,54,55.038282,92.393852,108.002142,1.8,92.482756,108.195977,-0.061893,5.428337,17.850858,333.489235,4401.155287,0.035095,246.551465,61.434885,261.449265,6.565719,10.457519,0.588003,28.496824),(48323,'metacarpal.tif',233,5,55,42.376801,92.101016,108.394329,1.8,92.033583,108.440349,-0.068289,5.088441,18.021811,238.038727,3777.407606,0.032885,209.602002,46.780282,220.248315,6.625842,12.605504,0.566729,32.976159),(48324,'metacarpal.tif',233,5,56,34.860032,91.747914,108.771552,1.8,91.314581,108.788298,-0.08336,4.682066,18.390929,186.333374,3051.754527,0.04028,165.938027,39.797253,174.835568,7.367538,11.832035,0.512389,37.03213),(48325,'metacarpal.tif',233,5,57,30.610679,90.035017,109.306753,1.8,90.091035,109.327166,-0.108126,4.417755,20.095817,157.550224,2177.088234,0.059414,108.335391,35.662957,115.99561,8.286793,12.634307,3.039386,36.543988),(48326,'metacarpal.tif',233,5,58,27.667607,89.30865,109.611297,1.8,89.485429,109.724107,-0.11367,4.033901,20.711723,128.472188,1499.943584,0.059326,72.420028,31.848126,78.622645,8.965444,13.596417,0.548549,39.467285),(48327,'metacarpal.tif',233,5,59,25.522301,90.345036,109.76679,1.8,90.509834,109.879788,-0.114379,4.679066,19.589472,107.300739,1088.987879,0.055408,55.590466,22.932087,61.022598,9.345714,12.439635,0.63832,36.921546),(48328,'metacarpal.tif',233,5,60,25.124913,91.060981,109.895002,1.8,90.738284,110.065801,-0.137091,4.35346,18.875561,93.426847,639.013845,0.078208,33.854031,21.460365,38.751976,7.088898,10.241774,2.720173,29.675304),(48329,'metacarpal.tif',233,5,61,24.990876,91.813841,109.994975,1.8,91.400633,110.158013,-0.110422,4.440318,17.359186,83.755335,305.362335,0.05058,17.590821,18.862464,22.287634,6.840997,10.114225,2.749253,29.675304),(48330,'metacarpal.tif',233,5,62,27.325041,92.093443,110.306254,1.8,91.697864,110.562968,-0.033749,4.243162,17.4344,86.497561,264.898348,0.005185,15.194004,20.385166,19.888206,6.871885,11.646249,2.889903,34.799171),(48331,'metacarpal.tif',233,5,63,29.916422,92.307837,110.683686,1.8,92.469349,111.02007,-0.001333,4.333511,17.546209,96.665863,269.550472,0.000009,15.36232,22.306591,20.562623,8.98026,12.974959,2.89059,42.013023),(48332,'metacarpal.tif',233,5,64,30.263299,92.44363,110.910449,1.8,92.530758,111.044568,-0.013424,4.230742,6.436281,101.383007,331.82699,0.000909,51.555699,23.963411,61.848318,9.654358,13.145925,0.197396,42.657555),(48333,'metacarpal.tif',233,5,65,29.720261,92.461106,110.795886,1.8,92.48935,110.963621,-0.017721,4.113253,7.100608,101.992936,382.293144,0.001555,53.839495,24.796173,65.16366,10.302697,14.157714,0.206324,45.613241),(48334,'metacarpal.tif',233,5,66,29.543959,92.391355,110.745633,1.8,92.485987,110.922409,-0.022431,3.800753,6.547335,98.000561,369.646908,0.002477,56.457616,25.784515,66.56154,10.634778,13.680182,0.26212,42.878724),(48335,'metacarpal.tif',233,5,67,28.751322,92.262147,110.987929,1.8,92.339685,111.054061,-0.017109,3.330151,6.319436,89.128121,322.978255,0.001402,51.108712,26.763991,59.468699,10.457551,13.287368,2.896614,40.678154),(48336,'metacarpal.tif',233,5,68,27.917993,92.314518,111.254771,1.8,92.343955,111.190349,-0.01135,3.593753,6.273697,74.419374,297.264418,0.000599,47.382654,20.707982,54.830687,10.354832,13.369185,2.873226,40.866933),(48337,'metacarpal.tif',233,5,69,21.930447,92.428762,111.606151,1.8,92.423255,111.517829,0.001898,3.331615,6.188711,42.448004,225.192353,0.000013,36.387604,12.740969,40.867879,9.66798,13.058734,2.866683,41.133907),(48338,'metacarpal.tif',233,5,70,12.95728,92.53073,112.300874,1.8,92.423003,112.306334,-0.005532,2.075398,6.171418,11.273543,118.754256,0.000066,19.242621,5.431991,20.529259,7.670794,13.034853,2.992703,37.487883),(48339,'metacarpal.tif',233,5,71,9.668086,92.760089,112.704383,1.8,92.809743,112.730079,0.012439,1.240993,5.543742,4.263654,67.262445,0.000249,12.13304,3.435679,12.70253,6.767586,12.397821,2.984991,32.364016),(48340,'metacarpal.tif',233,5,72,8.011278,92.913069,113.060345,1.8,92.83169,113.013598,0.001553,0.915624,4.73461,1.807717,39.711291,0.000003,8.387447,1.9743,8.677013,6.123054,11.393824,2.999696,30.274031),(48341,'metacarpal.tif',233,5,73,7.101221,93.252657,113.231346,1.8,93.06424,113.035903,0.018535,1.098328,4.402983,1.518359,33.152757,0.000407,7.529613,1.382428,7.834188,6.44532,11.112337,2.626044,31.374316),(48342,'metacarpal.tif',233,5,74,5.843029,93.549813,113.209195,1.8,93.331814,112.985564,0.007629,1.084473,4.282722,1.607414,30.509104,0.000057,7.123765,1.482208,7.438862,7.089852,11.552236,2.615526,37.865441),(48343,'metacarpal.tif',233,5,75,6.143486,93.684765,113.062662,1.8,93.582352,112.866995,-0.028208,1.500802,4.757128,2.284612,35.606211,0.000814,7.484813,1.522261,7.909805,7.760354,11.717372,2.591739,35.020339),(48344,'metacarpal.tif',233,5,76,7.100372,93.695378,112.72032,1.8,93.601036,112.5173,-0.025858,2.18018,4.775252,4.965808,40.686083,0.000791,8.520196,2.277705,9.388772,8.94485,11.832035,2.629203,35.664871),(48345,'metacarpal.tif',233,5,77,11.660126,93.651267,112.127713,1.8,93.594936,112.219689,-0.039328,1.98225,5.063062,12.421135,60.321786,0.003004,11.914093,6.26618,14.195959,9.277988,11.975987,2.726101,36.120624),(48346,'metacarpal.tif',233,5,78,14.466487,93.704108,112.196443,1.8,93.710058,112.215877,-0.016615,2.302168,5.428454,15.888042,97.694057,0.000666,17.996662,6.901338,20.192821,9.66798,11.570202,2.916881,35.365508),(48347,'metacarpal.tif',233,5,79,12.374997,93.626345,112.119063,1.8,93.751753,112.16984,-0.03041,2.250069,5.256973,16.6477,82.364826,0.001907,15.66773,7.39875,17.81735,9.990246,12.135358,0.186979,35.521898),(48348,'metacarpal.tif',233,5,80,11.319071,93.809174,111.833393,1.8,93.831868,111.997606,-0.015669,2.273241,4.57112,15.341771,68.946337,0.000463,15.083029,6.748855,17.085852,9.990246,11.64179,0.083141,35.521898),(48349,'metacarpal.tif',233,5,81,11.495814,94.023912,111.664498,1.8,93.961987,111.736112,0.001932,2.419582,4.431775,17.712801,71.27052,0.000007,16.081709,7.320603,18.144476,9.643057,10.961782,1.146602,34.076444),(48350,'metacarpal.tif',233,5,82,12.247161,94.16548,111.632107,1.8,94.177918,111.655511,0.00946,2.717669,4.558247,20.166297,76.198017,0.000183,16.716516,7.420438,19.096841,9.561695,11.421136,1.284745,36.810962),(48351,'metacarpal.tif',233,5,83,13.637092,94.290203,111.600481,1.8,94.290292,111.580811,0.020918,2.703747,4.689609,23.868169,82.455595,0.000994,17.582615,8.82781,20.754894,9.66798,11.681865,1.144169,35.098534),(48352,'metacarpal.tif',233,5,84,14.190641,94.435833,111.520899,1.8,94.446256,111.549564,0.032178,2.936101,4.891633,25.401703,82.87114,0.002448,16.941407,8.65151,20.365241,9.66798,11.884583,2.279423,36.999741),(48353,'metacarpal.tif',233,5,85,14.916622,94.518686,111.496103,1.8,94.538658,111.485646,0.016338,2.911586,4.775592,26.98703,84.442061,0.000664,17.682008,9.268842,21.215862,9.618743,11.430226,2.276365,36.843351),(48354,'metacarpal.tif',233,5,86,15.373963,94.634481,111.496214,1.8,94.636074,111.430917,0.006738,2.899773,4.960853,27.279882,83.754006,0.000116,16.882986,9.407593,20.413833,7.948736,10.005827,2.88099,30.131057),(48355,'metacarpal.tif',233,5,87,15.592342,94.797489,111.524414,1.8,94.789054,111.450474,0.02257,2.940689,4.831937,27.302222,81.920894,0.001324,16.954049,9.284293,20.6887,7.971817,9.995442,2.779048,30.052862),(48356,'metacarpal.tif',233,5,88,15.81881,94.933442,111.612609,1.8,94.954316,111.505792,0.030954,3.031652,5.033094,28.779313,80.18485,0.002525,15.931522,9.492948,20.129598,7.970062,10.093667,2.850136,30.052862),(48357,'metacarpal.tif',233,5,89,16.290848,95.169259,111.64959,1.8,95.229182,111.529279,0.03873,3.077196,5.133387,30.246793,78.328464,0.004071,15.258631,9.829335,19.819358,7.975513,10.093667,2.850136,30.052862),(48358,'metacarpal.tif',233,5,90,15.484081,95.29765,111.711715,1.8,95.341548,111.608348,0.022467,3.10938,4.971844,28.614741,73.722477,0.001302,14.827994,9.202717,19.179233,8.208807,10.005827,2.88099,30.131057),(48359,'metacarpal.tif',233,5,91,14.455661,95.475852,111.774327,1.8,95.553179,111.676086,0.029131,2.882277,5.126821,25.621415,66.235486,0.002044,12.919407,8.889297,16.866847,8.05665,9.927676,2.912361,36.543988),(48360,'metacarpal.tif',233,5,92,13.323637,95.651725,111.828389,1.8,95.7635,111.747342,0.007948,2.905438,4.907903,22.055182,58.480654,0.00014,11.915609,7.591,15.628954,7.015088,9.543645,2.937575,28.119266),(48361,'metacarpal.tif',233,5,93,11.679607,95.840307,111.897758,1.8,95.983864,111.84113,-0.002226,2.651296,4.70468,18.156155,50.302623,0.00001,10.692038,6.848031,13.823965,6.830359,9.278799,0.354706,27.097176),(48362,'metacarpal.tif',233,5,94,10.373673,96.05452,111.970211,1.8,96.18262,111.968353,-0.00981,2.409328,4.484183,14.219662,43.258439,0.000166,9.646894,5.90192,12.161954,6.591793,9.075093,3.034857,26.641423),(48363,'metacarpal.tif',233,5,95,8.938517,96.265669,112.061493,1.8,96.444165,112.093124,-0.024192,2.197113,4.270168,10.511461,35.840545,0.000872,8.393239,4.784215,10.307196,6.33901,8.802051,0.414507,25.085385),(48364,'metacarpal.tif',233,5,96,7.688004,96.488516,112.172026,1.8,96.661753,112.216888,-0.0356,1.994887,4.34439,7.616873,29.790538,0.001623,6.857242,3.818198,8.203566,5.992908,8.766583,0.298499,24.362659),(48365,'metacarpal.tif',233,5,97,6.370835,96.794186,112.208714,1.8,96.934221,112.288499,-0.051318,1.996985,4.039731,5.467572,24.079015,0.002794,5.960549,2.737914,6.941778,5.327058,8.56282,0.345556,23.262374),(48366,'metacarpal.tif',233,5,98,5.292375,97.081961,112.333381,1.8,97.192795,112.405065,-0.054614,1.797826,3.756555,3.71831,18.955439,0.002628,5.045963,2.068226,5.747472,4.907535,8.260326,0.358771,22.162089),(48367,'metacarpal.tif',233,5,99,4.724475,97.306898,112.516877,1.8,97.41614,112.549527,-0.06824,1.674301,3.60404,2.754244,15.407673,0.003661,4.275111,1.645011,4.856005,4.46731,7.959383,0.372988,21.517557),(48368,'metacarpal.tif',233,5,100,4.118527,97.601649,112.670969,1.8,97.711894,112.700422,-0.049382,1.51698,3.563563,2.032034,12.30489,0.001673,3.452974,1.339526,3.905638,4.302144,7.959383,0.372988,20.951219),(48369,'metacarpal.tif',233,5,101,3.545874,97.892358,112.835195,1.8,98.001091,112.845158,-0.031917,1.348607,3.288545,1.338968,9.361759,0.000602,2.846778,0.992852,3.123109,4.000287,7.660175,0.388319,19.505766),(48370,'metacarpal.tif',233,5,102,2.868139,98.129656,113.01745,1.8,98.205824,113.001625,-0.036626,1.208038,3.086319,0.79763,6.182839,0.000641,2.003305,0.660269,2.215601,3.585569,7.242028,0.363979,18.216702),(48371,'metacarpal.tif',233,5,103,2.014354,98.373824,113.178675,1.8,98.539362,113.16327,-0.062177,1.033255,2.796165,0.353834,3.354186,0.001296,1.199567,0.342446,1.310451,3.114736,6.775255,0.442374,16.660664),(48372,'metacarpal.tif',233,5,104,1.316823,98.723064,113.377233,1.8,98.94909,113.357066,-0.0308,0.726453,11.15256,0.135028,2.418008,0.000208,0.216812,0.185873,0.228435,2.530244,6.054828,0.439843,14.19312),(48373,'metacarpal.tif',233,5,105,1.841859,105.969453,112.952589,1.8,106.34778,112.779811,-0.086047,2.096943,8.682517,0.887003,40.785694,0.002267,4.697451,0.422998,4.799491,15.951353,16.723711,1.133005,53.471626),(48374,'metacarpal.tif',233,5,106,3.757897,108.278871,111.994472,1.8,108.138979,111.831923,-0.890409,2.365099,3.651045,3.488379,8.128321,0.378446,2.2263,1.47494,3.093424,18.913747,19.594727,0.937163,62.729658),(48375,'metacarpal.tif',233,5,107,6.617161,107.747004,111.455846,1.8,107.596124,111.289968,-0.875241,3.123715,4.554235,10.487228,23.022846,0.649982,5.055261,3.357294,7.18463,21.269556,21.895123,0.827041,70.809211),(48376,'metacarpal.tif',233,5,108,9.515639,107.334081,111.03952,1.8,107.179797,110.885424,-0.86613,3.711437,5.231723,20.888719,44.646134,0.92045,8.533734,5.628202,12.263119,23.471277,23.82372,1.046617,77.300336),(48377,'metacarpal.tif',233,5,109,35.090654,95.13156,110.286778,1.8,91.427513,109.984149,0.046219,5.582558,19.232757,192.05914,3256.706287,0.012484,169.331226,34.40343,175.480487,29.00394,143.095177,3.130332,415.924382),(48378,'metacarpal.tif',233,5,110,147.811501,87.978317,109.673388,1.8,90.42121,109.590406,0.041005,7.508761,22.06349,1027.637065,10722.83818,0.041399,485.999196,136.858398,523.089336,30.91802,143.095177,3.130332,379.693173),(48379,'metacarpal.tif',233,5,111,155.771638,88.037365,109.632989,1.8,90.722281,109.510674,0.034432,7.090669,21.984456,1100.876417,11767.98044,0.030767,535.286401,155.257048,570.761326,29.970738,143.095177,3.130332,459.728027),(48380,'metacarpal.tif',233,5,112,158.121035,88.233404,109.623939,1.8,91.028705,109.506668,0.028568,7.031899,21.768605,1124.020926,12276.39906,0.021503,563.949727,159.845995,597.258935,30.087007,143.099168,3.12808,457.98321),(48381,'metacarpal.tif',233,5,113,159.803524,88.392564,109.586618,1.8,91.241888,109.442317,0.024174,7.101738,21.594733,1161.131519,12592.680658,0.015561,583.13667,163.499637,615.122243,30.143678,143.099168,3.12808,392.702256),(48382,'metacarpal.tif',233,5,114,160.129158,88.476504,109.580593,1.8,91.324552,109.401011,0.022049,7.359754,21.503139,1169.306538,12716.109954,0.012973,591.360643,158.878478,623.304027,30.132431,143.426112,3.125864,390.000128),(48383,'metacarpal.tif',233,5,115,160.246326,88.51669,109.5793,1.8,91.375074,109.398503,0.021476,7.449235,21.460861,1171.59248,12754.141251,0.012316,594.297732,157.276885,626.209753,31.855249,143.739668,3.130382,412.005827),(48384,'metacarpal.tif',233,5,116,160.520315,88.525579,109.5831,1.8,91.371217,109.411231,0.021131,7.418373,21.45061,1172.097805,12753.859692,0.011944,594.568631,157.999319,626.430959,30.143678,143.739668,3.130382,389.700765),(48385,'metacarpal.tif',233,5,117,160.800189,88.534897,109.586463,1.8,91.375356,109.420377,0.020876,7.710199,21.440271,1172.477747,12755.144889,0.011677,594.915269,152.068425,624.171267,30.476995,144.065879,3.128171,393.724347),(48386,'metacarpal.tif',233,5,118,160.959214,88.537031,109.590898,1.8,91.376377,109.426207,0.020357,7.432789,21.436114,1170.596201,12746.795061,0.011116,594.64114,157.490851,626.295012,30.139011,144.065879,3.128171,392.168309),(48387,'metacarpal.tif',233,5,119,161.235658,88.545269,109.597466,1.8,91.386525,109.44309,0.020249,7.439196,21.427338,1168.937485,12740.694772,0.011016,594.599972,157.132228,626.117716,30.124954,144.065879,3.128171,391.901335),(48388,'metacarpal.tif',233,5,120,161.615549,88.549921,109.600099,1.8,91.393833,109.464399,0.019869,6.848578,21.421216,1168.716482,12741.601381,0.010632,594.812238,170.650961,626.254031,30.432007,144.070564,3.125934,393.346788),(48389,'forelimb',255,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48390,'forelimb',255,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48391,'forelimb',255,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48392,'forelimb',255,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48393,'forelimb',255,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48394,'forelimb',255,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48395,'forelimb',255,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48396,'forelimb',255,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48397,'forelimb',255,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48398,'forelimb',255,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48399,'forelimb',255,2,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48400,'forelimb',255,2,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48401,'forelimb',255,2,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48402,'forelimb',255,2,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48403,'forelimb',255,2,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48404,'forelimb',255,2,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48405,'forelimb',255,2,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48406,'forelimb',255,2,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48407,'forelimb',255,2,19,0.7511716,90.2140293,128.845272,1.8,90.1877748,128.8410127,0.0550038,0.5598171,4.290224,0.0831061,2.8722619,0.0003784,0.66949,0.1484522,0.6885307,1.289064,8.2091777,3.0367157,17.1443342),(48408,'forelimb',255,2,20,5.2444377,90.6069411,128.7269355,1.8,90.2237378,128.667386,0.0603848,1.0853553,8.9909105,1.2551978,84.4014779,0.0031833,9.3874227,1.1564856,9.525915,2.4837643,16.4183554,3.0367157,34.7920792),(48409,'forelimb',255,2,21,8.0390354,90.6771886,128.6076205,1.8,90.1329174,128.5704621,0.0455986,1.3412169,11.6476639,2.117911,249.3769696,0.0027839,21.4100417,1.5790966,21.5750669,2.8268186,21.5230372,3.0816645,46.4241922),(48410,'forelimb',255,2,22,8.7098083,91.3882318,128.4832067,1.8,90.7834283,128.4626814,0.0332088,1.5276056,12.3618599,2.4778585,375.8699365,0.0016003,30.4056137,1.6220538,30.5278195,3.007816,24.552449,3.0715321,53.0474947),(48411,'forelimb',255,2,23,8.860423,92.9202837,128.372531,1.8,91.707696,128.3416672,0.0225199,1.3369694,13.8808591,2.5083568,433.4796418,0.0007488,31.2285888,1.8761512,31.3474255,3.007816,27.1248527,3.0781857,58.8114213),(48412,'forelimb',255,2,24,9.3007419,94.575798,128.2260865,1.8,92.6531535,128.208157,0.014049,1.5337586,15.5262636,2.8608918,469.9258216,0.0003059,30.2665106,1.8652817,30.4083515,3.007816,30.1057701,3.0987617,64.9313131),(48413,'forelimb',255,2,25,9.7305423,95.9683064,128.0263102,1.8,93.7089983,128.0180563,0.0061915,1.7183733,16.9105829,3.2476766,468.0200122,0.0000622,27.6761609,1.8899716,27.8385391,3.437504,32.2724008,0.0532829,69.4798985),(48414,'forelimb',255,2,26,9.5685698,96.6219507,127.8061371,1.8,94.1361851,127.8175119,-0.0041591,1.9001476,17.5637828,3.150563,464.3862149,0.0000276,26.4399884,1.6580622,26.5739571,3.5419677,34.0132727,0.0632068,73.8810383),(48415,'forelimb',255,2,27,9.3698389,96.6525543,127.5962892,1.8,94.1531702,127.6495224,-0.0148394,1.6843618,17.6010901,3.3399961,476.9032437,0.0003439,27.0950969,1.9829446,27.2679834,3.5344686,35.2763119,0.0487419,76.6676859),(48416,'forelimb',255,2,28,9.1695973,96.6616547,127.3958432,1.8,94.4027791,127.4985208,-0.0266515,1.8914278,17.6216161,3.4600646,453.7417807,0.0010853,25.7491582,1.82934,25.9299039,3.6862537,35.401702,0.0972532,77.8830271),(48417,'forelimb',255,2,29,8.7528331,96.3905764,127.224318,1.8,94.2969847,127.3371047,-0.0379688,2.107313,17.3630361,3.3872707,445.2014962,0.002102,25.6407631,1.6073885,25.8207567,3.9848034,35.7907149,0.0841382,78.8466629),(48418,'forelimb',255,2,30,8.5976864,96.1813541,127.0986933,1.8,94.5380739,127.2631791,-0.0474348,1.9927849,17.1648481,3.6480107,437.6040962,0.0032218,25.4942015,1.8306094,25.6928269,3.8036757,35.8293839,0.0960887,77.8830271),(48419,'forelimb',255,2,31,8.4833266,95.8243687,126.9600516,1.8,94.1149957,127.1343534,-0.0551404,2.2287708,16.8198883,3.8940206,445.8901781,0.0042945,26.5096991,1.7471607,26.7247436,4.176726,35.4460046,0.1093185,78.5949575),(48420,'forelimb',255,2,32,8.4650313,95.4530142,126.8570303,1.8,93.8819079,127.0416853,-0.0627021,2.5142915,16.4597037,4.3005661,460.6962351,0.0055395,27.9893394,1.7104485,28.2325194,4.3059199,35.4460046,0.1093185,78.0915467),(48421,'forelimb',255,2,33,8.8566745,95.2478116,126.709611,1.8,94.0363837,126.9249765,-0.0703257,2.7609494,16.2693826,5.1034825,493.7224008,0.0072884,30.3467201,1.848452,30.6377762,4.7085747,35.018913,0.1106572,77.7355815),(48422,'forelimb',255,2,34,8.8350222,95.0330146,126.5952814,1.8,94.0567792,126.7868196,-0.0786195,3.0341326,16.068856,5.4230781,522.7803718,0.0090828,32.5337642,1.787357,32.8467089,5.1346836,35.018913,0.1106572,79.3068879),(48423,'forelimb',255,2,35,9.2901675,94.727338,126.5170897,1.8,94.1464956,126.6822236,-0.0871972,2.9396149,15.8133087,6.4937949,571.2408904,0.0117429,36.1240585,2.2090631,36.459531,4.9241799,35.018913,0.1106572,78.6992173),(48424,'forelimb',255,2,36,9.7157158,94.4659961,126.4527024,1.8,94.1349577,126.6096874,-0.0947532,3.2551984,15.5664566,7.839938,621.2858177,0.0144948,39.9118331,2.4084363,40.3347493,5.3188303,34.6425541,0.124355,78.5949575),(48425,'forelimb',255,2,37,10.2834865,94.3075517,126.3717619,1.8,94.2108904,126.5222783,-0.1025211,3.6033936,15.4243121,9.7994913,670.1715777,0.0179512,43.4490415,2.7195173,43.9990295,5.7988091,34.9740693,0.0984462,80.1662639),(48426,'forelimb',255,2,38,10.5230602,94.0089506,126.2947323,1.8,94.2458344,126.4374435,-0.1105639,3.895199,15.1432649,12.2032072,716.4929802,0.0213524,47.3143002,3.1328841,48.0264198,6.2608854,35.0689645,0.1228352,81.3816051),(48427,'forelimb',255,2,39,10.9726665,93.6449126,126.2184854,1.8,94.1483474,126.3474913,-0.1202509,4.1678269,15.2534577,15.2127605,772.2025347,0.0263174,50.6247535,3.6500462,51.5762574,6.7042865,34.759608,0.1488899,82.0935355),(48428,'forelimb',255,2,40,11.4601504,93.3148428,126.1497234,1.8,94.0072501,126.2762715,-0.1305345,4.4414329,15.5775764,18.5029455,829.1330373,0.032361,53.2260613,4.1659856,54.3980841,7.0948896,34.759608,0.1488899,82.7012061),(48429,'forelimb',255,2,41,11.9507674,92.9443985,126.1122884,1.8,93.9395256,126.1958524,-0.1386739,4.7426701,16.0012229,21.257438,889.7285966,0.0380582,55.6037875,4.4821668,56.8941869,7.5229425,35.1242016,0.1349767,85.3835939),(48430,'forelimb',255,2,42,12.1584501,92.6033666,126.0575254,1.8,93.8276295,126.1247356,-0.1485109,4.7170977,16.3353842,24.4456273,917.5632333,0.0443658,56.1702881,5.1823449,57.6554626,7.6034693,35.1845999,0.1470784,86.0955242),(48431,'forelimb',255,2,43,12.7032817,92.2371352,126.0268559,1.8,93.6360658,126.0449174,-0.1572242,5.0153942,16.6944953,27.4138411,973.4777116,0.0519065,58.3112992,5.4659395,59.9524461,8.0123745,34.8259407,0.1610919,86.7031948),(48432,'forelimb',255,2,44,12.9970141,91.6948543,126.0410667,1.8,93.5003708,125.9719454,-0.1640813,5.3313207,17.2320632,31.0332937,1027.398379,0.0577976,59.6213214,5.8209392,61.4212831,8.2528019,35.1242016,0.1349767,88.0227958),(48433,'forelimb',255,2,45,13.2981317,91.2083687,126.0670059,1.8,93.2759463,125.9283515,-0.1684136,5.6750804,17.7154386,33.1962978,1073.3622968,0.0622707,60.5890897,5.849485,62.4578663,8.6840071,34.8259407,0.1610919,88.6304664),(48434,'forelimb',255,2,46,13.6009279,90.8037479,126.0888296,1.8,93.1453931,125.8730832,-0.1708428,5.6860638,18.1172777,35.2251262,1108.4841427,0.0655211,61.1838137,6.1949931,63.1184725,8.7289217,34.8974383,0.1732457,89.1338772),(48435,'forelimb',255,2,47,14.2740506,90.5027457,126.0735575,1.8,93.0866119,125.7927188,-0.1732651,6.1017359,18.4103205,40.0624759,1160.0176084,0.0707079,63.0090937,6.5657506,65.1676374,9.2303596,35.1242016,0.1349767,90.097513),(48436,'forelimb',255,2,48,14.9434247,90.1985882,126.073569,1.8,92.8970766,125.7700449,-0.17461,6.3892997,18.7092639,43.0971053,1204.3533986,0.0751655,64.3720354,6.7452001,66.6512948,9.6086434,34.8974383,0.1732457,90.097513),(48437,'forelimb',255,2,49,14.9334657,89.7680842,126.0905134,1.8,92.7680745,125.7216536,-0.1757949,6.3977361,19.135485,43.1914403,1190.2924789,0.0761278,62.203413,6.7510506,64.4303892,9.5921696,34.8259407,0.1610919,89.3855826),(48438,'forelimb',255,2,50,15.3718823,89.6737389,126.063723,1.8,92.7276279,125.665188,-0.1761783,6.7752357,19.2234485,44.8092487,1204.4447797,0.0787014,62.65498,6.6136812,64.9504292,10.0035045,34.8259407,0.1610919,90.097513),(48439,'forelimb',255,2,51,15.871619,89.6920231,126.0247049,1.8,92.6809487,125.5993584,-0.176657,6.7366798,19.1982852,47.4086778,1223.3883659,0.0816976,63.7238353,7.0373951,66.1517462,9.9511387,34.8259407,0.1610919,90.8094434),(48440,'forelimb',255,2,52,15.9131891,89.8235387,125.9848923,1.8,92.8414946,125.5314836,-0.1750865,7.1544757,19.0628899,48.6487053,1199.1583942,0.0804765,62.9053833,6.7997582,65.417437,10.2923041,34.4742621,0.1753942,90.3492184),(48441,'forelimb',255,2,53,16.0003577,89.9626858,125.9134738,1.8,93.0711491,125.4106332,-0.177742,7.0903851,18.9114709,51.8898004,1160.1578385,0.0833644,61.3467798,7.3183332,64.0385493,10.1606019,34.3347331,0.1507464,90.7051836),(48442,'forelimb',255,2,54,16.2887749,90.1223882,125.8303147,1.8,93.2293819,125.3115785,-0.1824564,7.4280567,18.8134898,56.9132268,1124.7252332,0.089378,59.7829136,7.6619269,62.7874323,10.6324399,33.9779709,0.1651487,90.097513),(48443,'forelimb',255,2,55,16.6179789,90.2174123,125.7424037,1.8,93.3563419,125.1728375,-0.1888167,7.3972535,18.7002073,60.6348264,1085.9341822,0.0975755,58.070703,8.1969377,61.273827,10.6622305,33.9099795,0.1526493,89.637288),(48444,'forelimb',255,2,56,16.768258,90.3912219,125.6684582,1.8,93.4740248,125.106747,-0.1950318,7.6577193,18.5108355,63.525568,1027.7090021,0.1049625,55.5193201,8.295625,58.8926183,11.0321569,33.4853518,0.1546005,88.777912),(48445,'forelimb',255,2,57,16.6452261,90.5172918,125.5859085,1.8,93.6992094,125.0013292,-0.2016681,7.6441368,18.364901,65.9757232,968.1062025,0.1113056,52.7150243,8.6308926,56.2235974,11.0643794,33.0608548,0.1566019,88.4219468),(48446,'forelimb',255,2,58,16.7089521,90.7284487,125.4990357,1.8,93.9358487,124.8879094,-0.2075242,7.8987263,18.1341826,69.402841,921.8428624,0.1182203,50.8345418,8.7865864,54.5516098,11.3353258,32.5713708,0.1456284,87.918536),(48447,'forelimb',255,2,59,16.9726398,90.975401,125.4120842,1.8,94.0481132,124.7555896,-0.2111753,7.9320163,17.8701606,71.7699706,889.1376906,0.124285,49.7554393,9.0481371,53.6400909,11.3731199,32.1462915,0.1475681,87.6668306),(48448,'forelimb',255,2,60,17.2575882,91.2391076,125.3689505,1.8,94.1336323,124.7693213,-0.2039956,7.9844687,17.6117139,72.2549566,878.4014128,0.1180424,49.8759755,9.0494383,53.8712226,11.3731199,31.9821833,0.1076899,87.05916),(48449,'forelimb',255,2,61,17.7138525,91.6435513,125.2984008,1.8,94.4684788,124.6875392,-0.1925769,8.3938758,17.2950392,75.1064872,903.7850022,0.108142,52.2568922,8.947772,56.5776165,11.7720098,31.2345051,0.138006,85.5921134),(48450,'forelimb',255,2,62,18.4213838,92.1641367,125.21448,1.8,94.7473653,124.5514541,-0.1779288,8.5584647,16.7730191,77.4616389,964.9438844,0.096178,57.5295289,9.0508802,62.1424738,11.799605,30.8089592,0.1399247,85.5921134),(48451,'forelimb',255,2,63,19.2829428,92.8053707,125.1223337,1.8,95.0566622,124.4862583,-0.162704,8.6371104,16.1267136,79.1244606,1068.9957592,0.0843301,66.2872664,9.1609875,71.1933517,11.6946309,30.751975,0.1260881,84.7327374),(48452,'forelimb',255,2,64,20.7240218,93.6342689,125.0049266,1.8,95.2497622,124.4437349,-0.1496493,8.6908872,15.2875537,82.4753722,1201.0689247,0.0767764,78.5651482,9.489868,83.9472246,11.6998623,29.8996165,0.1297025,83.5173962),(48453,'forelimb',255,2,65,22.0824641,94.4243443,124.8623865,1.8,95.6489941,124.3356774,-0.1362597,9.0590593,14.5388539,87.0049905,1287.7440267,0.0679112,88.5725955,9.604197,94.3903517,12.0729147,29.0476715,0.133529,82.0503497),(48454,'forelimb',255,2,66,23.7457726,95.2267761,124.7809921,1.8,96.1198056,124.216447,-0.122436,9.158541,13.719155,92.9018073,1395.675384,0.0590312,101.7318764,10.1437343,108.1675657,12.1215568,28.1404636,0.1224611,80.3315977),(48455,'forelimb',255,2,67,26.1256203,95.9500461,124.7189531,1.8,96.4628802,124.1372784,-0.1104529,9.1862436,12.9795015,97.0288452,1510.4106861,0.0529058,116.3689288,10.5624072,123.2608558,11.985314,26.861515,0.1283232,77.5017642),(48456,'forelimb',255,2,68,27.9761902,96.1127773,124.7061717,1.8,96.3426286,124.1181543,-0.0986411,9.231506,12.7158284,102.8307164,1466.2067671,0.0452214,115.3056425,11.1391052,123.270465,12.0390365,25.1578563,0.1370662,73.3523299),(48457,'forelimb',255,2,69,28.6158554,95.927469,124.7382904,1.8,96.0867681,124.0955591,-0.0843156,9.629255,11.6092877,108.9374391,1309.7055149,0.0338253,112.815321,11.3131742,121.8549677,12.5714533,23.4563999,0.1470784,71.1301671),(48458,'forelimb',255,2,70,29.4746169,95.72965,124.7386763,1.8,95.9244647,124.0674681,-0.070015,9.6125849,11.1050493,118.814015,1167.5618955,0.0240419,105.13793,12.3602565,115.8360007,12.5780463,22.4920224,0.1148766,68.5520391),(48459,'forelimb',255,2,71,29.7976106,95.4333889,124.7336538,1.8,95.5148449,124.0348644,-0.0574039,9.6132461,10.4049432,126.4464781,1024.4227602,0.0163469,98.4553916,13.1533591,110.4429651,12.6042781,21.2119693,0.1218424,66.1213567),(48460,'forelimb',255,2,72,30.0541369,95.2123007,124.696843,1.8,95.4236257,123.9899205,-0.0514362,9.5628509,9.75334,134.1609574,896.9116117,0.0132406,91.9594329,14.0293893,105.442661,12.7382831,19.8820682,0.1082706,62.8312983),(48461,'forelimb',255,2,73,30.4693906,95.0752886,124.5886728,1.8,95.3151627,123.9239625,-0.0559545,9.4479462,9.3231137,144.9952117,774.3953393,0.0158829,83.0618787,15.346744,97.3110219,12.460952,18.9842363,3.0509328,60.1489105),(48462,'forelimb',255,2,74,30.9429991,94.9789905,124.4773824,1.8,95.1829272,123.8388957,-0.0691285,9.3296553,9.0882831,155.0459827,678.5190632,0.0246056,74.6586629,16.6186185,89.3257831,12.460952,18.1285566,3.0466409,57.9267477),(48463,'forelimb',255,2,75,31.326082,94.9369092,124.2930236,1.8,95.0616365,123.6659558,-0.1027757,9.5574554,8.6450397,170.0455864,582.4859075,0.0549549,67.3780487,17.7919309,78.5940242,12.89064,17.2732438,3.041924,56.6682207),(48464,'forelimb',255,2,76,30.8049169,94.8532836,124.0706363,1.8,94.9270676,123.4750121,-0.1691111,9.3371477,8.1767182,187.0696713,504.0457577,0.145435,61.644017,20.0349912,73.7258933,12.8221428,16.3789491,3.0628087,54.5935035),(48465,'forelimb',255,2,77,31.5396394,94.8266354,123.9249489,1.8,94.8638435,123.3436525,-0.2377385,9.1102669,8.0662236,196.8762022,456.1733544,0.291546,56.5535222,21.610366,70.7776398,12.8221428,15.5639613,3.0309354,53.3781623),(48466,'forelimb',255,2,78,31.0557363,94.8276422,123.7572581,1.8,94.9402743,123.1717599,-0.3429317,9.1535145,7.7339329,199.8730034,404.9796893,0.5852131,52.3640036,21.835657,63.7487977,13.2570967,15.0942245,3.0560874,51.7636701),(48467,'forelimb',255,2,79,31.8306303,94.9597353,123.5791772,1.8,94.9930813,123.0266334,-0.4820442,8.6222486,7.3472137,206.3067968,375.7876565,1.1401571,51.1469619,23.9272616,62.4447917,12.7983111,14.2381773,3.0509328,49.8363985),(48468,'forelimb',255,2,80,32.5686539,94.9672123,123.4638952,1.8,95.06325,122.869888,-0.6526781,8.0693403,6.6844871,201.6651325,359.3997576,2.0020655,53.7662431,24.9915265,60.6036484,12.656143,14.3028672,2.1421338,48.5167975),(48469,'forelimb',255,2,81,33.5872059,95.1349437,123.3030235,1.8,95.1997636,122.7208913,-0.8161805,7.5480597,6.4233728,194.7099514,349.5825877,2.9711405,54.4235247,25.7960269,59.1446154,12.1641667,14.3028672,2.1421338,47.5099759),(48470,'forelimb',255,2,82,32.1813188,95.2343887,123.1166278,1.8,95.2504523,122.5660167,-0.9774741,6.5828322,7.0434064,181.1310235,343.5490823,3.6868341,48.7759846,27.5156676,55.9340101,11.8412875,14.283491,1.2966289,47.3625303),(48471,'forelimb',255,2,83,33.7577385,95.431016,123.0263025,1.8,95.3666209,122.5115026,-1.0669065,6.3389683,7.3787679,178.8890335,348.7915591,4.3146321,47.2696208,28.2205281,56.0356621,11.6280342,14.4441652,2.1010121,47.0065651),(48472,'forelimb',255,2,84,34.5768881,95.4297099,122.9706967,1.8,95.3680069,122.5325143,-1.1067295,6.2225595,7.5461859,179.6050812,374.7352017,4.6083186,49.6588881,28.8635378,59.2086286,11.6036301,14.4952048,1.3617734,47.1108249),(48473,'forelimb',255,2,85,34.0966217,95.3809425,123.0776252,1.8,95.4241203,122.5267716,-1.1402113,6.1783058,7.8356336,177.8328933,383.660517,4.6926905,48.9635603,28.78344,58.7231919,11.5358134,14.6661522,2.1262901,47.8659411),(48474,'forelimb',255,2,86,30.1883586,95.1830612,123.2627466,1.8,95.3277451,122.6433037,-1.1822411,6.0347628,8.2853807,175.4046407,377.7925886,4.3092441,45.5974929,29.065706,57.0904126,11.6311836,14.6661522,2.1262901,51.0085539),(48475,'forelimb',255,2,87,27.8860563,95.0944747,123.4095663,1.8,95.2130542,122.9023812,-1.1855373,6.4616567,8.469716,180.4434013,367.0139347,3.9913079,43.3324961,27.9252536,55.7987202,5.6395378,12.644806,0.1707352,30.6605329),(48476,'forelimb',255,2,88,27.0680256,94.9976205,123.563197,1.8,95.2323099,123.0605916,-1.1670208,6.6996102,8.5641633,190.8730094,362.2523431,3.8149453,42.2986265,28.4901664,55.6518467,5.7776852,13.0047187,0.1325515,31.5199089),(48477,'forelimb',255,2,89,26.4662379,94.8606789,123.662936,1.8,95.2012923,123.2114465,-1.1389337,6.9110084,8.398714,197.5072523,364.0693291,3.6382471,43.3482232,28.5786445,56.1159551,6.2538665,13.145925,0.1973956,32.6309903),(48478,'forelimb',255,2,90,27.3567786,94.9076629,123.8132317,1.8,95.229603,123.3870974,-1.1150236,7.1465979,8.3867527,218.0646667,366.6144587,3.6761237,43.7135174,30.5130734,56.9787229,6.6585923,13.6556983,0.2220819,34.0980369),(48479,'forelimb',255,2,91,29.1794299,95.0045016,123.9714539,1.8,95.2720774,123.6099111,-1.0378216,7.3918543,8.1400969,247.8631407,368.3752197,3.6077286,45.2544025,33.5319302,59.0340805,7.3454983,14.4121737,0.1798535,36.5287193),(48480,'forelimb',255,2,92,35.9383517,94.9280505,124.2277522,1.8,95.3406596,123.7921436,-0.9091305,8.3738123,8.0833727,294.5232244,402.9252176,3.7284441,49.8461757,35.1719403,65.374741,8.2890933,14.8351299,0.1746722,38.6034365),(48481,'forelimb',255,2,93,47.1035947,94.7757242,124.4002228,1.8,95.3711056,123.8788323,-0.6435761,9.8616745,7.4136026,369.8715764,496.5407824,2.8267807,66.9769892,37.5059609,80.2138929,9.023448,15.3369125,0.1973956,40.4264483),(48482,'forelimb',255,2,94,51.9384296,94.7916847,124.4634371,1.8,95.3124252,123.9782668,-0.524494,10.3780093,7.9423613,431.0427942,594.8778924,2.1708158,74.8993742,41.5342462,94.411718,9.453136,15.6821404,0.1651487,41.8934949),(48483,'forelimb',255,2,95,34.5482982,95.8003834,124.1119631,1.8,95.6200042,123.8693331,-0.1888202,10.6233646,7.9452597,350.2270761,498.7133253,0.202864,62.7686627,32.9676226,79.5526038,9.6932128,15.9910916,0.1076899,42.8571307),(48484,'forelimb',255,2,96,19.511047,98.7478912,123.4176619,1.8,97.6417467,122.6287969,0.8738095,10.051189,11.0792734,97.4757735,258.5154018,1.9119244,23.3332452,9.6979346,32.007799,2.2658751,4.0536685,0.5585993,9.6184698),(48485,'forelimb',255,2,97,14.934249,99.5632295,123.244158,1.8,98.7172877,121.9688552,1.0576149,3.4884348,11.1088674,27.3307681,211.5844667,1.8890999,19.0464482,7.8346793,21.3162267,5.7851551,7.1514336,0.5713375,20.3912067),(48486,'forelimb',255,2,98,10.8856098,99.224273,122.7217179,1.8,98.3855312,121.2006619,1.0931587,2.5886987,10.2316544,11.5563772,190.5778621,1.430899,18.6262997,4.4641647,19.5630263,4.726568,5.7808608,0.7328151,15.990067),(48487,'forelimb',255,2,99,7.159293,98.7707987,121.9147364,1.8,98.0829999,120.4804869,1.1229355,2.2427029,8.8731771,5.4541109,149.3362453,0.9694611,16.830076,2.4319364,17.0695773,0,0,0,0),(48488,'forelimb',255,2,100,3.7094203,97.9316892,119.942013,1.8,97.645391,119.4291242,1.1308072,1.9986705,6.7089261,2.5154828,83.4857347,0.5060786,12.4439789,1.258578,12.7411007,0,0,0,0),(48489,'forelimb',255,2,101,1.3625266,96.3948117,116.1762512,1.8,96.3382531,116.1369541,0.3636518,0.9586224,2.1043458,0.2770702,1.3358994,0.02873,0.6348288,0.2890295,0.7593005,2.3116432,4.6477863,2.5535901,10.6252914),(48490,'forelimb',255,2,102,0.3668018,96.7716232,116.2769416,1.8,96.7476455,116.2645267,0.3641528,0.6128629,1.3833585,0.0451394,0.1906425,0.0077547,0.1378113,0.0736533,0.1677721,1.718752,3.2724063,2.7367009,7.1877874),(48491,'forelimb',255,2,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48492,'forelimb',255,2,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48493,'forelimb',255,2,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48494,'forelimb',255,2,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48495,'forelimb',255,2,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48496,'forelimb',255,2,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48497,'forelimb',255,2,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48498,'forelimb',255,2,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48499,'forelimb',255,2,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48500,'forelimb',255,2,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48501,'forelimb',255,2,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48502,'forelimb',255,2,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48503,'forelimb',255,2,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48504,'forelimb',255,2,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48505,'forelimb',255,2,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48506,'forelimb',255,2,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48507,'forelimb',255,2,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48508,'forelimb',255,2,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48509,'forelimb',255,2,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48510,'forelimb',255,2,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48511,'forelimb',255,2,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48512,'forelimb',255,2,124,0.6064315,98.5128025,122.2990996,1.8,98.452263,122.3178507,-1.3843078,1.0063806,1.1660266,0.1455572,0.2055573,0.0975974,0.1762886,0.1446344,0.2999972,2.14844,2.8824347,1.1071487,7.1877874),(48513,'forelimb',255,2,125,5.9703203,98.3745368,122.5888388,1.8,97.9326797,122.3072969,0.9367264,2.7861665,5.9127435,6.0043867,9.1397179,0.645818,1.545766,2.155071,2.4234136,3.867192,5.4351711,1.2490458,14.5230204),(48514,'forelimb',255,2,126,27.1241985,95.9131212,121.9018905,1.8,95.2780881,121.9013243,0.4101013,7.6255045,5.9613027,134.3516111,240.6215108,0.7186262,40.3639141,17.6187178,41.7007504,7.2920472,12.2140278,2.2565258,32.9437697),(48515,'forelimb',255,2,127,47.9943591,94.9980569,122.0735637,1.8,94.6137354,122.031392,-0.1005214,6.3327786,7.7747331,414.6362872,545.7772996,0.080555,70.1988471,65.4746228,110.2800896,12.3988984,15.0329403,0.5404195,53.2307167),(48516,'forelimb',255,2,128,62.5900606,94.1662344,121.9757499,1.8,94.1971582,122.0687812,-0.4057699,7.2488861,8.208154,637.8809012,856.2999991,1.625347,104.3230909,87.9970932,173.4536668,13.6412196,15.8519352,0.5729661,51.7636701),(48517,'forelimb',255,2,129,69.2940405,93.8295521,121.852531,1.8,93.975677,122.0012737,-0.515143,7.8037803,8.586065,808.9790444,1086.1771192,2.8030958,126.5046461,103.6650198,216.1588621,14.5164325,16.4688822,0.2639637,53.1875308),(48518,'forelimb',255,2,130,75.0360328,93.8472832,121.8005293,1.8,93.8865982,122.0074949,-0.5237387,8.0574626,8.8571655,968.5140203,1204.3547245,3.1280172,135.975186,120.2008702,238.6485111,14.9496671,16.9331967,0.6231993,53.5866819),(48519,'forelimb',255,2,131,80.6824082,93.9290867,121.8625161,1.8,93.8559496,121.9709399,-0.5295868,8.0247557,9.0623262,1147.2849707,1319.8655344,3.4317396,145.6431275,142.9682119,269.2122983,15.1495931,17.4010378,0.5743048,54.4460579),(48520,'forelimb',255,2,132,79.4505786,93.7284511,121.880497,1.8,93.7612204,121.9286221,-0.9651249,7.9479576,9.1244403,1152.4201807,1310.9431196,8.9498601,143.6738125,144.9957633,265.9666131,15.2099008,17.533166,0.6287963,54.9494687),(48521,'forelimb',255,2,133,77.8595003,93.6308451,121.9539962,1.8,93.7479578,121.986555,-1.3833965,8.0759732,8.0457112,1145.5009035,1310.6277432,12.5261728,162.8976865,141.840603,267.936988,15.1608597,17.5384304,0.5404195,54.5935035),(48522,'forelimb',255,2,134,74.8883833,93.4956535,122.0798646,1.8,93.721103,122.0900046,-1.5656134,8.3355852,8.2178023,1089.4114141,1286.2190499,12.4810619,156.5161825,130.6940536,264.4507096,15.0845336,17.5384304,0.5404195,55.6613991),(48523,'forelimb',255,2,135,70.6637844,93.3958712,122.2168865,1.8,93.7089826,122.2054535,-1.5668964,8.0164155,8.3522556,979.7634623,1214.3874715,11.7771183,145.3963499,122.2196453,249.6506057,15.0490225,17.4010378,0.5743048,55.5571393),(48524,'forelimb',255,2,136,63.473216,93.5233362,122.2485394,1.8,93.7870323,122.3063749,1.4639537,7.9528807,8.5466844,835.1254459,1084.3736482,10.4585666,126.8765284,105.0091761,222.7702586,14.7133177,17.5384304,2.1112158,54.4460579),(48525,'forelimb',255,2,137,57.8759638,93.7253988,122.311918,1.8,93.9400838,122.4087345,1.31122,7.7162275,8.6165579,723.1920472,933.36252,9.0105154,108.3219687,93.7235257,191.4893483,14.5293602,17.4010378,2.1451012,53.1264569),(48526,'forelimb',255,2,138,51.1077544,94.0818897,122.6549601,1.8,94.2104232,122.6563488,1.400763,7.4697896,8.3922621,626.8117004,737.3775748,8.2740576,87.8639827,83.9128989,158.0102283,14.1322321,17.1713991,2.1240907,51.9111157),(48527,'forelimb',255,2,139,45.7854357,94.454238,122.9644528,1.8,94.6276786,123.041132,1.5281643,7.0222052,7.5148932,530.705335,586.0058896,7.6170453,77.9792708,75.5753098,137.7368797,13.331721,16.1519256,2.070143,48.7253171),(48528,'forelimb',255,2,140,41.6154991,94.7567921,123.3245056,1.8,94.9534994,123.398845,-0.8842028,6.807182,7.3962532,445.4356537,494.7169677,4.1488074,66.8875111,65.4361313,126.1889604,12.6894912,15.0083566,1.9832068,46.0429293),(48529,'forelimb',255,2,141,38.4829132,95.0153871,123.5436133,1.8,95.2109686,123.6994082,-0.8076836,6.5027471,7.1800622,379.1542542,437.7974923,3.3497971,60.9740528,58.3067817,113.1891069,12.1958801,14.5397175,0.5961991,43.7165067),(48530,'forelimb',255,2,142,36.0605443,95.3252506,123.6897333,1.8,95.457709,123.8681756,-0.8824684,6.3511136,6.9898175,331.8635266,397.6387786,3.5847882,56.8882923,52.252809,103.7273463,11.6883871,14.1862129,0.6132073,42.5011655),(48531,'forelimb',255,2,143,35.0048982,95.5061451,123.8667618,1.8,95.622587,123.990325,-0.8486712,6.1464527,6.698197,309.1894888,380.5123959,3.2852348,56.8081819,50.3037289,101.0643248,11.4157031,13.8570216,0.5191461,41.6417895),(48532,'forelimb',255,2,144,32.7889252,95.68931,123.9474933,1.8,95.7210991,124.0560358,-0.8647762,5.9329305,6.7550589,285.5203566,352.5282488,3.1643776,52.1872944,48.1246755,93.5063516,11.2793611,13.7096736,0.5619216,40.4264483),(48533,'forelimb',255,2,145,31.3485176,95.7692039,123.9996323,1.8,95.8515045,124.1246641,-0.8547844,5.852706,6.4885812,269.71964,321.7691058,2.97374,49.5900563,46.084604,90.7913802,11.0082198,13.348021,0.5790743,38.8551419),(48534,'forelimb',255,2,146,31.1281344,95.9582901,124.0293169,1.8,96.0196996,124.1245642,-0.9288541,5.5629574,6.3042606,261.9820716,303.6108924,3.3280948,48.1596353,47.0940283,88.4369581,10.8734205,13.1178053,0.551655,38.3517311),(48535,'forelimb',255,2,147,30.7887476,96.144051,124.1067296,1.8,96.1418883,124.1573856,-0.9812357,5.3750505,6.2012469,254.4804389,294.5554101,3.5451631,47.4993846,47.3447534,85.7132345,10.8547918,12.9905136,0.5971767,38.3517311),(48536,'forelimb',255,2,148,30.2652326,96.2626172,124.1675778,1.8,96.2785349,124.2191225,-0.9262653,5.3269107,6.119141,245.4682449,283.5192646,3.2233027,46.3331803,46.0807885,86.3730302,10.6963626,12.6375032,0.6162969,37.4923551),(48537,'forelimb',255,2,149,30.3362319,96.4098736,124.168445,1.8,96.3796188,124.2467295,-0.9963759,5.2422321,6.0383306,237.9175766,275.76884,3.5633575,45.6697153,45.384785,82.8711693,10.4643945,12.4905505,0.7123576,36.7804247),(48538,'forelimb',255,2,150,29.7639853,96.525623,124.2075396,1.8,96.4789186,124.2807231,-1.0422053,5.1081673,5.7757455,228.3674311,264.0406327,3.6989899,45.7154204,44.7063334,82.4717363,10.3744347,12.1610055,0.5585993,36.0253085),(48539,'forelimb',255,2,151,29.3913088,96.6392534,124.2710326,1.8,96.5974197,124.3090192,-1.1360962,5.012445,5.6348507,219.863161,253.5483957,4.0297564,44.9964712,43.8634558,82.2156008,10.2214909,11.9388329,0.5280744,35.4176379),(48540,'forelimb',255,2,152,29.0586919,96.7893428,124.3528413,1.8,96.7281883,124.4033859,-1.1095553,4.9791391,5.4651268,209.6203515,244.9710584,3.8837997,44.8244053,42.0997176,79.0581227,10.0552132,11.7988288,0.5779019,35.0616727),(48541,'forelimb',255,2,153,29.1896686,96.8937146,124.3884047,1.8,96.8361396,124.4099166,-1.0115026,5.1658448,5.4027698,202.592225,241.9627366,3.4953496,44.7849425,39.2176368,77.8923328,10.0447974,11.7282,0.4964228,34.5582619),(48542,'forelimb',255,2,154,29.8531121,97.0353854,124.4002032,1.8,96.9433818,124.4086011,-1.0135429,5.1537295,5.4657797,201.3854562,239.7096487,3.5839164,43.8564414,39.0756741,77.9809672,9.9050289,11.7988288,0.5779019,34.4540021),(48543,'forelimb',255,2,155,29.9220972,97.1322696,124.4102017,1.8,97.0219403,124.4485128,-1.0662307,4.9706499,5.4402795,198.7990703,233.1574612,3.821541,42.8576256,39.994583,76.3463749,9.7657088,11.7988288,0.5779019,34.2022967),(48544,'forelimb',255,2,156,29.940952,97.2104626,124.4347565,1.8,97.0852233,124.443711,-1.0092541,5.0961786,5.3054645,196.9939679,225.8537373,3.5752094,42.5700211,38.6552321,75.5422138,9.8020172,11.5697035,0.5467888,34.2022967),(48545,'forelimb',255,2,157,29.6243925,97.2954928,124.4982411,1.8,97.2310583,124.501574,-0.8620024,5.1490669,5.4341281,190.3192861,219.350167,2.8454469,40.3652916,36.9618981,70.9823514,9.7057419,11.6887773,0.6287963,34.0980369),(48546,'forelimb',255,2,158,29.2208881,97.4186318,124.5543187,1.8,97.3609593,124.5603191,-0.7480207,5.0959048,5.5841553,184.9883363,213.7305353,2.2532095,38.2744615,36.301372,68.1697425,9.6113822,11.5697035,0.5467888,33.5946261),(48547,'forelimb',255,2,159,29.0332351,97.4793238,124.4904465,1.8,97.4446896,124.5307814,-0.8308926,5.0215534,5.360518,183.9027191,209.2744945,2.6392743,39.0399758,36.6226754,68.1807227,9.4196563,11.5697035,0.5467888,33.5946261),(48548,'forelimb',255,2,160,29.8222842,97.5560725,124.4470107,1.8,97.59025,124.4662907,-0.8703984,5.028935,5.4879113,186.7633867,210.7363999,2.9056417,38.4001102,37.1377614,67.2298742,9.6113822,11.6887773,0.6287963,34.0980369),(48549,'forelimb',255,2,161,30.6356711,97.6524199,124.416941,1.8,97.6901177,124.4112025,-0.7653568,5.1220086,5.5992516,190.2230077,215.1190209,2.45067,38.4192452,37.1383614,67.896115,9.7587078,11.5697035,0.5467888,33.8463315),(48550,'forelimb',255,2,162,30.9235288,97.7354089,124.4046251,1.8,97.7766642,124.4195294,-0.6230219,5.1927153,6.0125682,190.6717833,215.4121514,1.7547191,35.8269786,36.7190909,66.8453393,9.7587078,11.7988288,0.5779019,34.4540021),(48551,'forelimb',255,2,163,31.4387634,97.8313812,124.4171263,1.8,97.928996,124.3924611,-0.5034079,5.2042059,5.9952144,191.2419616,215.4650174,1.2194191,35.9395017,36.7475781,67.2415365,9.6932128,11.5697035,0.5467888,33.9505913),(48552,'forelimb',255,2,164,31.788165,97.9064062,124.4387922,1.8,97.9444373,124.4296506,-0.3987621,5.2046698,6.1399817,190.4085214,213.847315,0.7987291,34.8286568,36.5841694,65.8393471,9.6572864,11.7282,0.4964228,34.5582619),(48553,'forelimb',255,2,165,31.6082329,97.9736154,124.4532997,1.8,98.058851,124.4419192,-0.2538468,5.3568516,6.0105473,189.6665574,209.4318722,0.3322339,34.8440603,35.4063493,65.5977735,9.7857699,11.5697035,0.5467888,34.5582619),(48554,'forelimb',255,2,166,32.0070935,98.0249489,124.4721057,1.8,98.1040078,124.4200877,-0.0645738,5.334473,5.6481034,188.6417319,207.1469937,0.0222129,36.6754959,35.3627684,67.263199,9.5451124,11.3440887,0.4297623,33.6988859),(48555,'forelimb',255,2,167,33.1736866,98.0569362,124.5123007,1.8,98.1199262,124.4170556,0.0345635,5.2236839,5.4830991,190.8468172,209.3334057,0.0066025,38.1779359,36.5349091,68.196369,9.5776351,11.171888,0.3947911,33.6988859),(48556,'forelimb',255,2,168,34.2391798,98.0598484,124.5497667,1.8,98.1233341,124.4082737,0.1765204,5.15224,5.3446093,193.2934399,210.9165443,0.1759732,39.4634171,37.5163889,68.7603073,9.9508312,11.1470707,0.4808873,34.5582619),(48557,'forelimb',255,2,169,34.4186643,98.0597372,124.5721767,1.8,98.1231964,124.4585185,0.3648914,4.6547365,4.9932818,186.4695877,212.2847714,0.7304811,42.514078,40.0601815,67.738871,9.4196563,11.0137676,0.3587707,34.2022967),(48558,'forelimb',255,2,170,34.3475531,98.0621651,124.5863274,1.8,98.1308406,124.5037853,0.4467522,4.5727368,4.7779459,181.7739957,210.578925,1.068538,44.0731076,39.7516854,68.2543394,9.361211,11.0137676,1.929567,33.8031457),(48559,'forelimb',255,2,171,34.6131431,98.0565852,124.6253322,1.8,98.086972,124.5296565,0.5701126,5.0024519,4.8315238,178.0218091,209.4282986,1.6804973,43.3462214,35.5869109,69.5921254,9.6290896,10.980189,2.1045045,35.0184869),(48560,'forelimb',255,2,172,34.9899598,98.0625078,124.6486226,1.8,98.0657773,124.6118553,0.6150437,4.3341761,4.8900407,172.144787,208.6789465,1.9414898,42.6742764,39.7179954,70.9300138,9.1417086,11.0137676,1.929567,33.5514403),(48561,'forelimb',255,2,173,35.1999924,98.0400113,124.6491304,1.8,98.0030036,124.5694943,0.7340945,4.4553734,5.032303,165.1867632,209.2476446,2.6328794,41.5808917,37.0758513,69.6573464,9.3047999,11.0137676,1.929567,33.1954751),(48562,'forelimb',255,2,174,35.1243493,98.0255688,124.6606869,1.8,98.0139694,124.5929022,0.7896797,4.2604993,5.3979294,157.5856533,210.1055963,2.9520933,38.9233684,36.9876019,66.5038377,9.115059,11.2048922,2.1375255,33.1954751),(48563,'forelimb',255,2,175,34.6624342,98.0023396,124.6552398,1.8,97.9785471,124.5889434,0.8229985,4.325764,5.4545708,148.6428088,207.7904904,3.1055512,38.0947461,34.3622094,64.2696585,8.8112237,11.2048922,2.1375255,32.9437697),(48564,'forelimb',255,2,176,34.9713287,97.9786792,124.6395528,1.8,97.9358111,124.5801396,0.8432584,4.0835167,5.5012076,142.1920596,207.8292505,3.2507669,37.7788413,34.8209814,62.8196476,8.7141048,11.2048922,2.1375255,32.3360991),(48565,'forelimb',255,2,177,34.6390475,97.9371967,124.624264,1.8,97.9216728,124.6269062,0.845064,4.0668923,5.541763,133.9432741,205.2515501,3.2302317,37.0372297,32.9350432,60.4936398,8.4220532,11.2048922,2.1375255,31.4767231),(48566,'forelimb',255,2,178,34.3777096,97.8895149,124.5915072,1.8,97.8869587,124.6448023,0.8486913,4.0472425,5.60092,127.2972908,203.6079988,3.2264868,36.3525988,31.4528451,58.4583256,8.392812,11.2048922,2.1375255,31.1207579),(48567,'forelimb',255,2,179,34.1994001,97.8574218,124.5761613,1.8,97.9044108,124.6133114,0.8624232,3.9453586,5.6441765,122.100143,206.6275325,3.2872504,36.6089775,30.9477932,57.763446,8.2035531,11.4413255,2.1692152,31.1207579),(48568,'forelimb',255,2,180,34.1770764,97.812716,124.5454165,1.8,97.8917729,124.5665512,0.8745418,4.0450047,5.7048449,117.3510304,207.2059868,3.3531821,36.3210556,29.0113455,56.5313668,8.3400236,11.4413255,2.1692152,31.7284285),(48569,'forelimb',255,2,181,34.4236997,97.778798,124.5306163,1.8,97.84499,124.5630672,0.889121,3.850134,5.7465051,113.1569046,208.9523451,3.4594697,36.361639,29.3903808,55.8029509,7.8997178,11.4413255,2.1692152,30.8690525),(48570,'forelimb',255,2,182,34.2878555,97.7205949,124.4748624,1.8,97.7778916,124.4967932,0.8879758,3.796722,5.5547304,109.8062572,203.7607565,3.4394126,36.6823844,28.921332,55.5504333,7.8997178,11.2048922,2.1375255,30.2613819),(48571,'forelimb',255,2,183,34.0163908,97.657071,124.4028632,1.8,97.6770005,124.4338614,0.8786502,3.7483638,5.5857189,107.1001616,196.7184849,3.3603227,35.218114,28.5725095,54.3038752,7.8478858,11.0889478,2.1910458,30.2613819),(48572,'forelimb',255,2,184,33.776873,97.5896952,124.3263105,1.8,97.6194026,124.3280472,0.8788235,4.3938041,5.4135427,104.896104,190.8719463,3.3376205,35.2582321,23.8736413,54.2508089,8.2660287,10.980189,2.1045045,32.0843937),(48573,'forelimb',255,2,185,33.5287951,97.5221175,124.2524985,1.8,97.5278684,124.2702926,0.87821,3.7397577,5.5131016,102.4299885,184.0749738,3.3097378,33.3886416,27.3894718,51.6173508,7.834692,10.8448348,2.1587989,29.6537113),(48574,'forelimb',255,2,186,33.3898177,97.4511043,124.1699421,1.8,97.471774,124.1545562,0.8802855,3.7983202,5.3496191,101.9488512,178.5733503,3.3073663,33.3805726,26.84051,51.6110249,7.8804744,10.7679504,2.070143,29.0460407),(48575,'forelimb',255,2,187,33.3399112,97.3963358,124.1187994,1.8,97.456056,124.1305235,0.8892806,3.8059359,5.3692583,101.3638676,174.9504366,3.3514207,32.5837249,26.6330991,51.3829417,7.8997178,10.6125107,2.1251038,29.0460407),(48576,'forelimb',255,2,188,33.4283106,97.323054,124.0474581,1.8,97.4072916,124.0479476,0.8940979,3.8025966,5.2030653,101.1234316,169.8234175,3.3865417,32.6391093,26.5932579,51.7370774,7.8997178,10.4635866,1.9055332,28.7943353),(48577,'forelimb',255,2,189,33.1517546,97.2377167,123.9835781,1.8,97.2678713,123.9701208,0.9052127,3.794495,5.2396679,100.6159829,163.1775451,3.4183391,31.1427266,26.5163039,50.3374224,7.8997178,10.2496576,2.1471715,28.7943353),(48578,'forelimb',255,2,190,33.4254572,97.1600514,123.9107907,1.8,97.170237,123.9012756,0.9136161,3.7910925,5.0812767,101.4046902,157.2996243,3.4919425,30.9567127,26.7481448,50.8793718,7.8997178,10.0587382,1.9195673,28.1866647),(48579,'forelimb',255,2,191,33.822975,97.0813291,123.8359448,1.8,97.0872628,123.8242281,0.9191022,3.863078,4.9288518,102.8458883,150.5188159,3.563342,30.5383126,26.6227829,51.1603456,7.8997178,9.9942879,2.0152155,27.5789941),(48580,'forelimb',255,2,192,33.8116174,96.9887659,123.7444317,1.8,97.0140018,123.7352243,0.942884,3.8877813,4.8149315,104.271009,141.9510653,3.6905085,29.4814299,26.8201837,50.6182111,8.1097181,9.8172189,1.9756881,27.8306995),(48581,'forelimb',255,2,193,33.5882129,96.8819052,123.5983823,1.8,96.894644,123.556939,1.0000573,4.0732909,4.6656134,104.948309,131.8712742,3.9641117,28.2645093,25.7649926,50.7241211,8.164072,9.5115493,1.8925469,27.5789941),(48582,'forelimb',255,2,194,33.8059106,96.7916234,123.5192749,1.8,96.8157377,123.5001437,1.1108215,4.0494389,4.5762298,106.3025362,126.2721464,4.5239641,27.5930517,26.251177,49.7621336,7.734384,9.4335845,2.0955921,27.4747343),(48583,'forelimb',255,2,195,34.0228809,96.7010426,123.4380402,1.8,96.7317403,123.3849879,1.3260448,4.1605372,4.3921697,107.5220338,121.9898487,5.3375283,27.7743931,25.8433057,49.9708572,7.734384,9.2557628,1.9513027,26.8670637),(48584,'forelimb',255,2,196,33.9805834,96.6022155,123.3632317,1.8,96.6016749,123.3501435,-1.4920076,4.209573,4.4337582,106.9806317,120.0591242,5.6283466,27.0784102,25.4136537,49.9014508,8.164072,9.1049255,1.9074711,26.9713235),(48585,'forelimb',255,2,197,33.8768539,96.5092689,123.2907083,1.8,96.5249859,123.2778031,-1.2299824,3.87907,4.5095753,103.4700819,122.0623126,5.0153217,27.0673634,26.6739402,50.0087368,8.0183974,9.1049255,1.9074711,26.7196181),(48586,'forelimb',255,2,198,33.7303235,96.4351047,123.2276386,1.8,96.4507384,123.1972366,-1.1545075,3.8423316,4.6844616,99.9719158,127.1230836,4.7024888,27.1371815,26.018555,47.6743096,7.734384,9.1856803,1.7590178,26.9713235),(48587,'forelimb',255,2,199,33.6867951,96.3584478,123.1768701,1.8,96.3859692,123.1672217,-1.1062156,3.8116213,4.8187733,96.9053327,132.9746296,4.4873786,27.5951207,25.4236517,47.3228839,7.734384,9.3845276,1.2924967,26.7196181),(48588,'forelimb',255,2,200,34.3435248,96.2747207,123.1430167,1.8,96.3304853,123.122614,-1.0736472,3.9362674,5.0113388,94.6907911,141.8993405,4.4219901,28.3156552,24.0559855,47.1249907,7.734384,9.6081158,1.1071487,27.2230289),(48589,'forelimb',255,2,201,34.7927954,96.1919182,123.0986174,1.8,96.1983056,123.0690428,-1.0293088,3.8490638,4.99762,93.3357587,150.241064,4.2583553,30.0625225,24.2489507,48.5584641,7.5958825,9.6560368,1.0074801,27.3272887),(48590,'forelimb',255,2,202,35.5322737,96.1126934,123.0373103,1.8,96.1225721,122.9849046,-0.9763985,3.8521337,5.0767771,93.5904394,160.9029801,4.0648261,31.6939224,24.29574,48.8035484,7.5958825,9.9942879,1.1263771,27.5789941),(48591,'forelimb',255,2,203,35.8856477,96.0444135,122.9875592,1.8,96.0642608,122.9338855,-0.9587765,3.8089442,5.3003716,93.3449189,176.0700411,4.0067801,33.2184331,24.5067699,50.1966213,7.5958825,10.2496576,0.9944211,27.8306995),(48592,'forelimb',255,2,204,37.1458435,95.9933488,122.9269178,1.8,96.0120416,122.8007658,-0.9587064,3.7807816,5.8785887,92.187885,196.5447571,4.147078,33.4340037,24.3832873,48.806338,7.5958825,11.0889478,0.9505468,29.2977461),(48593,'forelimb',255,2,205,38.4655691,95.9706924,122.821034,1.8,96.0722157,122.5815021,-0.9580425,3.7561207,6.754708,92.1436388,231.93153,4.2904123,34.3362778,24.5315969,47.699589,7.5631659,12.1610055,1.012197,30.7647927),(48594,'forelimb',255,2,206,39.5594844,95.9552331,122.7119316,1.8,96.0742704,122.4875223,-0.9534102,3.6899076,7.2703539,91.9759448,270.5762659,4.3836396,37.2163816,24.9263545,49.7069123,7.2920472,12.89064,0.9272952,32.3360991),(48595,'forelimb',255,2,207,40.3277763,95.9071223,122.6535456,1.8,96.0621235,122.4124843,-0.942594,3.7654663,7.4971673,91.4123242,302.1950265,4.3998879,40.3078941,24.276495,52.4734685,7.2920472,13.2369013,0.9467733,32.9437697),(48596,'forelimb',255,2,208,41.793417,95.8382508,122.6366215,1.8,95.9990443,122.3511598,-0.92416,3.7498748,7.7783092,91.3974186,333.9805453,4.4369806,42.9374221,24.3734586,54.6873641,7.467281,13.7567282,0.8960554,34.4108163),(48597,'forelimb',255,2,209,43.3583671,95.7558202,122.5881602,1.8,95.9488503,122.2750419,-0.9013843,3.5933315,8.0567071,91.1402642,377.0875287,4.4438618,46.8041751,25.3637228,58.0808479,7.2695682,14.3608389,0.8913825,35.0184869),(48598,'forelimb',255,2,210,45.0966473,95.6962921,122.5830449,1.8,95.9269582,122.2551139,-0.8816007,3.647405,8.1529938,91.2539302,416.9981893,4.4766694,51.1466341,25.0188641,62.2517215,7.2695682,14.6975909,0.9097532,35.6261575),(48599,'forelimb',255,2,211,44.864347,95.6451813,122.5685804,1.8,95.8512793,122.2862336,-0.8616127,3.4648737,8.4448435,90.3863105,458.2479861,4.3063769,54.2636447,26.0864662,64.9444954,6.9882119,15.240301,0.8652281,36.5897933),(48600,'forelimb',255,2,212,45.9206645,95.5608644,122.5727971,1.8,95.7393717,122.293424,-0.8428759,3.4735724,8.4984616,91.2848718,506.4552437,4.2656565,59.5937559,26.2798241,70.2855094,7.1885817,15.5698916,0.8831251,37.4491693),(48601,'forelimb',255,2,213,48.1934258,95.4568378,122.6116547,1.8,95.6353604,122.3728025,-0.8278759,3.5180007,8.8823616,93.5238741,564.1163772,4.3568998,63.5097289,26.5843818,74.0358988,7.1763826,16.4183554,0.8224183,38.9162159),(48602,'forelimb',255,2,214,48.5045023,95.3828628,122.6173528,1.8,95.5391175,122.3920414,-0.8120459,3.5429246,8.9350145,95.9168618,609.4742033,4.257362,68.2118877,27.0727923,78.932416,7.1075923,16.7357822,0.7309067,39.8798517),(48603,'forelimb',255,2,215,49.0705945,95.2966108,122.6185067,1.8,95.4314224,122.4124548,-0.7942829,3.4149294,8.9918401,99.2479279,654.1504837,4.161876,72.7493457,29.0629518,83.749511,7.1365101,17.321277,0.7678561,41.0951929),(48604,'forelimb',255,2,216,49.4878624,95.2226251,122.6173299,1.8,95.2794429,122.5055972,-0.7749166,3.3575411,9.0369881,102.3224111,688.9748794,4.0375433,76.2394364,30.4754012,87.4805547,7.096608,17.6224473,0.7853982,42.0588287),(48605,'forelimb',255,2,217,47.9074143,95.1455174,122.6073137,1.8,95.129516,122.5604572,-0.7432523,3.4358935,9.0700994,104.1238345,707.3476176,3.6561661,77.9867547,30.3047328,89.2606707,7.096608,17.9494415,0.7345945,42.3105341),(48606,'forelimb',255,2,218,45.082716,95.0733165,122.5245529,1.8,94.985282,122.5794539,-0.698431,3.5114429,8.7591473,103.5567629,723.0868843,3.1067304,82.5522009,29.4912277,94.0740985,7.0823427,17.9905393,0.7008544,45.2446273),(48607,'forelimb',255,2,219,46.0352481,94.8969797,122.5921953,1.8,94.8623112,122.6219844,-0.6608363,3.4780888,8.9117608,105.2675446,804.0358468,2.8904197,90.2218842,30.2659167,101.5286101,6.9716035,18.3210418,0.6857295,47.0676391),(48608,'forelimb',255,2,220,49.1265995,94.5767242,122.7531011,1.8,94.6427281,122.7136313,-0.6270545,3.4331456,9.2314599,108.4821108,976.9210152,2.8189649,105.8251917,31.5984594,116.7501646,7.0106263,18.8769524,0.7209713,47.2150847),(48609,'forelimb',255,2,221,51.7939692,94.3405884,122.8743656,1.8,94.4249932,122.8055057,-0.6030943,3.3534328,9.4657074,109.7373721,1175.5309865,2.7770939,124.1883931,32.7238922,134.5434543,6.9029433,19.201814,0.7061991,46.3557087),(48610,'forelimb',255,2,222,52.1217745,94.268798,122.9753335,1.8,94.2746952,122.9621093,-0.5874075,3.2940968,9.6795957,107.7476648,1284.048519,2.6681405,132.655181,32.7093195,143.1908756,6.8986736,19.5967879,0.6610432,47.0676391),(48611,'forelimb',255,2,223,52.2032363,94.3041119,123.0240392,1.8,94.2052211,123.0815593,-0.5706925,3.2649583,9.7541377,104.4514685,1401.3826301,2.5390973,143.6705807,31.9916702,154.3095301,6.9554958,20.0300987,0.6177557,47.3193445),(48612,'forelimb',255,2,224,52.8524128,94.3255043,123.0695948,1.8,94.0620209,123.2702853,-0.5595,3.3713332,10.1149239,102.6055351,1593.266162,2.4814984,157.5163761,30.4347063,167.4860585,7.1516065,20.3818914,0.6055447,48.5778715),(48613,'forelimb',255,2,225,51.0576241,94.3310823,123.0933505,1.8,93.8620539,123.3700041,-0.5508213,3.2850084,10.8431383,97.1295769,1698.275808,2.3310714,156.6221664,29.5675278,165.07733,7.1140164,21.2250215,0.5543075,51.0085539),(48614,'forelimb',255,2,226,52.2426804,94.108315,123.2841608,1.8,93.5849487,123.5650959,-0.5346017,3.4381479,11.1552021,99.4458251,1904.4116595,2.2602674,170.719602,28.924243,179.0433752,7.3735552,21.8169824,0.560687,53.3349765),(48615,'forelimb',255,2,227,52.50648,93.8059488,123.4752956,1.8,93.2694819,123.782616,-0.5069881,3.7229751,11.3522101,105.7824783,2146.2537848,2.0631137,189.0604348,28.4134261,197.4941798,7.6076314,22.4961264,0.4978223,56.121624),(48616,'forelimb',255,2,228,55.6160708,93.421525,123.695336,1.8,93.1675986,123.8803309,-0.4755694,4.1687381,11.1592096,122.8424829,2326.7364286,1.9430566,208.5036944,29.4675463,218.6960909,8.2619802,22.874581,0.4888524,59.3074226),(48617,'forelimb',255,2,229,58.1306437,93.8246289,123.6414256,1.8,93.8270062,123.820901,-0.4338908,4.1424187,11.5567846,143.6590242,2367.9556104,1.7123321,204.8974432,34.6799863,216.5623566,8.6070663,22.9068442,0.4048918,60.2099845),(48618,'forelimb',255,2,230,66.3777536,95.0141181,123.5734706,1.8,94.766373,123.7489748,-0.3689591,4.5353666,12.4836899,208.6234196,2420.6545468,1.4389,193.905373,45.9992402,210.6164156,9.3618851,23.139407,0.3805064,61.0693605),(48619,'forelimb',255,2,231,64.4117608,96.1491412,123.394613,1.8,95.789732,123.5148387,-0.347776,4.8475129,12.912722,237.0235797,1807.4381965,1.246904,139.9734465,48.8959151,158.131244,9.6432513,18.1285566,0.5485494,49.3761735),(48620,'forelimb',255,2,232,65.0115344,96.844117,123.3631464,1.8,96.9819037,123.1690736,-0.3392071,5.0766343,8.4396877,247.5458157,1340.7071789,1.1996317,158.857439,48.7617975,186.4112102,9.9654612,17.2946084,0.4636476,48.9770225),(48621,'forelimb',255,2,233,67.2557056,97.1365771,123.3733423,1.8,97.1354469,123.1906615,-0.321182,5.0877338,8.1617635,236.3019069,1330.9951012,1.1171076,163.0769017,46.4454152,188.8228102,9.8854524,16.9495441,0.5317241,48.2650921),(48622,'forelimb',255,2,234,58.9092303,97.2761271,123.361868,1.8,97.4211052,123.1822086,-0.2979912,5.0175227,8.0452787,188.8758499,1077.1435035,0.8463419,133.8851696,37.6432479,156.7417106,9.6603265,16.2146739,0.5585993,46.6937857),(48623,'forelimb',255,2,235,43.8693495,97.9033467,123.1477177,1.8,97.8116838,123.1158427,-0.2787075,4.7731881,8.3648888,132.8246306,723.1454703,0.5533922,86.4500996,27.8272356,100.1193917,4.756543,6.9285108,2.0899424,18.0647842),(48624,'forelimb',255,2,236,26.9056056,98.8946114,122.923301,1.8,98.4100959,122.9933801,-0.2076465,4.4272618,9.242186,76.8356119,299.4545295,0.1905856,32.4008334,17.355109,40.7024627,7.4006888,9.798394,2.4805495,27.6221799),(48625,'forelimb',255,2,237,15.7586019,99.7399639,122.8446489,1.8,99.7727429,122.5867435,0.5211691,3.0807836,4.1870959,26.8841387,57.0531001,0.6510898,13.6259358,8.7263962,19.5568683,6.3433159,8.9412281,2.5269297,24.1846759),(48626,'forelimb',255,2,238,10.2427556,99.577242,122.8616993,1.8,99.5993239,122.6141196,0.5815761,2.4167108,3.6983998,9.4134333,27.4135597,0.51517,7.4122759,3.8951426,9.5205189,4.9990532,7.9230552,2.4329664,19.7835362),(48627,'forelimb',255,2,239,4.6143398,99.3510304,122.6561573,1.8,99.4117669,122.6520524,0.6593272,1.5660731,2.6808883,1.9655424,6.6772902,0.2885967,2.4907006,1.255077,3.183162,3.6460236,5.9694165,2.6135182,14.6272802),(48628,'forelimb',255,2,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48629,'forelimb',255,2,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48630,'forelimb',255,2,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48631,'forelimb',255,2,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48632,'forelimb',255,2,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48633,'forelimb',255,2,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48634,'forelimb',255,2,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48635,'forelimb',255,2,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48636,'forelimb',255,2,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48637,'forelimb',255,2,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48638,'forelimb',255,2,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48639,'forelimb',255,2,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48640,'forelimb',255,2,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48641,'forelimb',255,2,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48642,'forelimb',255,2,254,3.7996101,85.6791684,124.339225,1.8,85.7043408,124.3762608,0.6760494,1.6587155,2.1828413,1.8363704,3.2184221,0.2479377,1.4744187,1.1071039,2.3008815,3.6460236,4.899197,2.2318395,13.1602336),(48643,'forelimb',255,2,255,14.9917087,85.8733151,124.2356836,1.8,86.012666,124.179832,0.602687,2.7162469,3.3204633,18.8345962,31.4209774,0.8028762,9.4628292,6.9340517,14.2154041,5.7728707,7.3926319,2.1910458,20.8514317),(48644,'forelimb',255,2,256,21.4676403,85.7720173,123.9542699,1.8,85.9317934,124.0540225,0.512277,3.2050887,4.2107988,42.9274235,68.2567058,0.8596359,16.2099184,13.3935211,24.6510876,6.6843766,8.5614727,2.8357138,23.8897847),(48645,'forelimb',255,2,257,23.8963874,85.6303234,123.7918724,1.8,85.7507791,123.9029974,0.4432285,3.2848028,4.6941954,49.5592654,100.1735747,0.7325014,21.3398818,15.0874401,31.3897021,7.1113101,9.2955727,2.5535901,26.1119475),(48646,'forelimb',255,2,258,23.3146854,85.3169249,123.8133475,1.8,85.5178279,123.8906189,0.4589531,3.4134081,4.9472283,46.5770029,107.5206082,0.7626144,21.7335044,13.6453072,31.1393068,7.1583748,9.6560368,2.5782764,26.0076877),(48647,'forelimb',255,2,259,20.8855467,85.0958123,123.9488167,1.8,85.1935061,123.9562545,0.4106906,3.217913,4.9242864,37.4895321,102.2263566,0.5548408,20.7596284,11.6502627,28.2354413,6.875008,9.6560368,2.5782764,26.0076877),(48648,'forelimb',255,2,260,17.9712739,84.8765606,124.0637736,1.8,84.9324708,124.0586865,0.3607982,2.9576417,4.8566331,27.3468394,90.6723298,0.3732751,18.6697921,9.2461639,24.2921006,6.3231965,9.6560368,2.5782764,25.4000171),(48649,'forelimb',255,2,261,17.045989,84.6104075,124.1055635,1.8,84.5978652,124.1028125,0.3558683,2.8186849,4.6880918,22.4440948,88.0418557,0.3448562,18.7798915,7.9626123,23.5518188,5.9587733,9.4335845,2.6167969,24.5406411),(48650,'forelimb',255,2,262,17.4134062,84.3661712,124.1660869,1.8,84.369652,124.1963585,0.3348602,2.6553508,4.7530479,21.0053455,93.4293576,0.3134482,19.6567256,7.9105725,24.0360277,5.6300939,9.6560368,2.7776137,24.7923465),(48651,'forelimb',255,2,263,18.3324249,84.1859116,124.2310909,1.8,84.165137,124.2418062,0.333163,2.5331812,4.902596,21.3864939,102.3713567,0.3267787,20.881051,8.4425439,25.1651382,5.4553241,9.9201178,2.8335399,24.8966063),(48652,'forelimb',255,2,264,19.5043891,84.0976119,124.3302259,1.8,84.0307357,124.3758648,0.3199145,2.6743161,4.6871768,23.7840697,116.6067914,0.3215008,24.8778307,8.8935147,29.9453893,5.5936373,9.8172189,2.7367009,25.1483117),(48653,'forelimb',255,2,265,22.2764953,84.1010941,124.5147745,1.8,83.9548448,124.5093808,0.2928943,3.0604933,4.8814254,31.3387421,136.0237925,0.3095016,27.8655888,10.2397681,34.2494924,6.1168776,10.2135672,2.8864103,26.9713235),(48654,'forelimb',255,2,266,27.2896957,84.1223999,124.7393452,1.8,83.9245196,124.8172812,0.2609358,4.2228195,5.2545801,50.5069732,162.9829252,0.3027162,31.0173075,11.9604859,40.6261412,7.5602383,10.6298941,2.896614,28.8985951),(48655,'forelimb',255,2,267,33.2580577,84.1480397,125.0230335,1.8,83.9456513,125.1492824,0.1871717,4.7266885,5.4733578,95.1120452,208.1576122,0.1919325,38.0310627,20.1223424,53.2581895,8.4808274,11.0472442,2.9060477,32.3360991),(48656,'forelimb',255,2,268,36.3437583,84.8373101,125.043112,1.8,86.5083138,125.2882067,0.0720857,4.7549426,24.0899993,113.4328191,716.9842971,0.0314213,29.7627363,23.8557702,34.3370113,8.6249495,11.7988288,2.9584818,34.1591109),(48657,'forelimb',255,2,269,44.3585678,88.6378313,125.0832212,1.8,89.0267083,125.1485655,0.0213512,4.3554144,20.1502806,129.139111,4113.2207633,0.0033698,204.1272202,29.6502465,207.6120477,8.3941081,12.1534119,2.9996956,34.0116653),(48658,'forelimb',255,2,270,45.8441263,89.514869,125.0813062,1.8,89.1898073,125.1493844,0.0058198,4.0209419,19.2181312,127.7198376,5030.0032788,0.0002588,261.7321752,31.7636614,263.2806015,7.5656758,12.1001239,2.8535372,32.0843937),(48659,'forelimb',255,2,271,40.9792468,88.3157472,125.059593,1.8,88.8131173,125.1081842,0.0120101,4.1322397,20.4400452,103.0172468,4168.5846724,0.0009851,203.9420477,24.9301236,205.7362055,7.0560922,11.7360686,2.7270858,31.0164981),(48660,'forelimb',255,2,272,31.2466904,87.4354272,124.7837087,1.8,88.9189951,124.8931975,0.0242617,3.6972004,21.369389,62.5155408,3293.5089084,0.0030649,154.1227458,16.9088862,154.8596503,6.4207936,10.9549375,2.6954871,28.3341103),(48661,'forelimb',255,2,273,25.8450359,86.9235405,124.5937013,1.8,88.6210601,124.6580062,0.033603,3.2928513,21.9056801,45.4607318,2770.1427245,0.004862,126.4577365,13.8058868,127.2253479,6.2905995,8.8582451,2.7430702,25.0440519),(48662,'forelimb',255,2,274,23.6173137,86.768805,124.5715402,1.8,88.3366913,124.6471177,0.0335079,3.2738237,22.0607716,40.8479997,2527.5873791,0.0044178,114.5738427,12.4771533,115.2433402,6.015632,8.8582451,0.2449787,24.8966063),(48663,'forelimb',255,2,275,22.0608118,86.5698244,124.6459403,1.8,87.5967734,124.7593692,0.0293918,3.2640964,22.2442537,41.5315033,2309.1016096,0.0031754,103.8066569,12.7237368,104.6111952,6.3917383,8.8582451,0.2449787,25.7559823),(48664,'forelimb',255,2,276,22.1818855,86.4042769,124.8252224,1.8,86.904398,124.9525774,0.020506,3.7748282,22.368159,49.4775307,2258.8026985,0.0015543,100.9829509,13.1072271,102.4161204,7.304696,8.9721488,0.2914568,27.3272887),(48665,'forelimb',255,2,277,24.3522041,86.019928,125.0929692,1.8,86.1611646,125.2056923,0.0071807,3.8602051,22.711763,65.1666935,2239.6168016,0.0002093,98.6104337,16.8816659,100.7220303,7.734384,9.798394,0.9097532,29.5494515),(48666,'forelimb',255,2,278,26.5706948,85.9807236,125.3036624,1.8,86.0058275,125.4035718,-0.0016015,4.0240935,22.7348637,78.1466905,2271.4451975,0.0000114,99.9102184,19.4197006,102.5691531,8.164072,10.6125107,2.5872852,30.9122383),(48667,'forelimb',255,2,279,28.6751613,86.2826101,125.4502848,1.8,86.0821555,125.5723394,-0.0009686,3.8555727,22.4309226,87.1909912,2332.3850536,0.0000045,103.98079,22.6142775,107.1638919,7.734384,11.7988288,2.5636907,32.6309903),(48668,'forelimb',255,2,280,29.5847246,86.6367324,125.3939781,1.8,86.3987286,125.4846163,0.0001449,3.7911769,22.0747157,79.891653,2461.6947141,0.0000001,111.5164856,21.073048,114.3149628,7.6674942,11.9156132,2.6940727,33.0912153),(48669,'forelimb',255,2,281,30.4482418,86.9392463,125.2789475,1.8,86.8974569,125.3922132,0.0025181,3.2287927,21.7787191,67.2289835,2604.9108665,0.0000322,119.6080841,20.8217096,121.7537788,7.1748509,11.9697226,2.7744188,31.7716143),(48670,'forelimb',255,2,282,28.8131316,87.5319167,125.0893491,1.8,87.4110186,125.1682562,0.0094846,3.0297178,21.2062465,49.012246,2836.7805328,0.000432,133.7709874,16.1771656,134.9467982,6.7026021,11.9851376,2.8879186,31.2682035),(48671,'forelimb',255,2,283,25.3504466,88.2846064,125.0451939,1.8,88.1332214,125.0577436,0.0133367,2.8962766,20.4646744,37.6809251,3067.3535449,0.0007515,149.8852844,13.0101267,150.3950842,6.015632,10.7422,2.8577985,27.3704745),(48672,'forelimb',255,2,284,23.3876429,89.0670487,125.0598024,1.8,88.7482432,125.0503687,0.0150123,2.8778846,19.6866452,33.7155697,3270.6243095,0.0008784,166.1341626,11.7154,166.2992091,5.8860435,10.0311674,2.9694018,26.2593931),(48673,'forelimb',255,2,285,21.9005738,89.9265474,125.0467548,1.8,89.6183236,124.9925909,0.0183873,2.8151055,18.836505,30.3154977,3378.2352862,0.0012339,179.3451223,10.7688675,179.1841838,5.7947308,9.5406219,0.1355277,25.1483117),(48674,'forelimb',255,2,286,21.1186303,90.6730028,125.0628757,1.8,90.4514303,124.999188,0.0212113,2.6191216,18.0972965,28.4650078,3430.6618333,0.0015834,189.5676425,10.8681506,189.1966203,5.5836926,9.1856803,2.9533711,23.9329705),(48675,'forelimb',255,2,287,20.8116939,91.3102132,125.0874124,1.8,90.9305746,125.0327627,0.0231343,2.598578,17.4646571,27.3349289,3491.8092137,0.0018561,199.9357444,10.5191876,199.3764869,5.5127737,8.8582451,2.896614,23.5770053),(48676,'forelimb',255,2,288,20.7596614,91.9293288,125.1197454,1.8,91.6288176,125.0692862,0.0244022,2.637785,16.848164,26.6734192,3571.1180423,0.0020599,211.9588841,10.1120519,211.1983776,5.5127737,8.76395,2.9441971,23.3252999),(48677,'forelimb',255,2,289,20.6775841,92.6340971,125.1046822,1.8,92.4024513,125.0652497,0.0245686,2.6081956,16.144397,25.8276498,3629.5890419,0.0020798,224.8203535,9.9024974,223.6550022,5.156256,8.689902,2.9927027,22.7176293),(48678,'forelimb',255,2,290,20.518577,93.3298406,125.1266027,1.8,92.9731756,125.0640847,0.0254163,2.6260035,15.4504738,24.7668995,3645.5350865,0.0022086,235.9497281,9.4314038,234.4339433,5.156256,8.689902,2.9927027,22.7176293),(48679,'forelimb',255,2,291,20.5747498,94.0250811,125.1482118,1.8,93.9637195,125.0844383,0.0261494,2.6406581,15.0276327,24.1663127,3679.2476417,0.0023443,244.8321517,9.1516251,243.6157336,5.156256,8.4420297,0.2573237,22.1099587),(48680,'forelimb',255,2,292,20.6741712,94.8430541,125.1787783,1.8,94.5267147,125.1553399,0.0273369,2.6544722,15.8371054,23.5402283,3692.6660473,0.0025744,233.1654648,8.868139,233.0571979,5.156256,8.3430318,2.9340964,21.8582533),(48681,'forelimb',255,2,293,20.8420183,95.5869469,125.2060988,1.8,94.8416902,125.1895988,0.0286448,2.5131001,16.5838891,23.0988016,3688.7156969,0.0028495,222.4276631,9.1913574,222.4538374,5.156256,8.2652137,2.9849908,21.8582533),(48682,'forelimb',255,2,294,21.051995,96.281017,125.2430143,1.8,95.4584586,125.2236936,0.0298757,2.4827987,17.2810059,23.0456473,3656.7801698,0.0031308,211.6069053,9.2821247,211.7476495,5.156256,8.1527566,0.3217506,21.5022882),(48683,'forelimb',255,2,295,21.2077571,96.8872797,125.2897772,1.8,96.0505301,125.25053,0.030815,2.4578393,17.8901393,22.9438567,3597.847372,0.0033553,201.1078456,9.3349702,201.3183211,5.1525354,8.2652137,2.9849908,21.6065479),(48684,'forelimb',255,2,296,21.4626608,97.3564608,125.3451492,1.8,96.3781042,125.2906212,0.0318405,2.423952,18.3627317,22.8171016,3548.00516,0.0036253,193.2177202,9.4131823,193.45893,4.726568,8.3430318,0.2074962,21.2505827),(48685,'forelimb',255,2,297,21.6557409,97.6575722,125.4044476,1.8,96.6616121,125.3302136,0.0321239,2.4103346,18.6661218,22.6652253,3499.6609214,0.0037233,187.4873082,9.4033522,187.716119,4.726568,8.3430318,0.2074962,21.2505827),(48686,'forelimb',255,2,298,21.6343124,97.8714972,125.4729364,1.8,97.0574731,125.4236657,0.0327454,2.6894865,18.8692933,22.6344579,3420.9153594,0.0038649,181.2953623,8.4159032,181.8936215,4.726568,8.3430318,0.2074962,21.2505827),(48687,'forelimb',255,2,299,21.7441404,97.9440662,125.5457715,1.8,97.1781495,125.5131937,0.0321128,2.6389151,18.9431882,22.8180265,3382.7349447,0.0037359,178.5726303,8.6467452,179.1250226,4.726568,8.0272343,0.2709469,20.6429122),(48688,'forelimb',255,2,300,21.7980193,97.9131795,125.6168508,1.8,97.214127,125.5802141,0.0316871,2.5843955,18.9138786,22.8011795,3354.5372074,0.0036466,177.3585038,8.8226355,177.8487545,4.726568,8.0272343,0.2709469,20.6429122),(48689,'forelimb',255,2,301,21.8886567,97.8661617,125.693476,1.8,97.1116803,125.6749709,0.030644,2.5154766,18.8674491,22.839493,3329.5884807,0.0034247,176.4726363,9.0795889,176.8837725,4.726568,8.1527566,0.3217506,20.6429122),(48690,'forelimb',255,2,302,21.9650831,97.822619,125.7674375,1.8,97.13987,125.7662054,0.0294347,2.4635245,18.8239165,23.0939858,3304.9848398,0.0031709,175.5737092,9.3743684,175.9125321,4.726568,8.0272343,0.2709469,20.3912067),(48691,'forelimb',255,2,303,22.0334528,97.7570974,125.8434585,1.8,97.275256,125.8440551,0.0285512,2.4053387,18.7589114,23.2389119,3284.4490571,0.0029927,175.087402,9.6613886,175.3440375,4.726568,7.9230552,0.2186689,20.3912067),(48692,'forelimb',255,2,304,22.058462,97.6459888,125.9184478,1.8,97.3123356,125.8942217,0.0270104,2.4083253,18.6351779,23.2074189,3265.2652922,0.0026815,175.2205053,9.6363305,175.765168,4.726568,7.7463106,0.3392926,20.286947),(48693,'forelimb',255,2,305,21.9389549,97.4537631,125.9407338,1.8,97.1116581,125.9376465,0.0264511,2.5919639,18.4426745,23.0623803,3236.9464447,0.0025577,175.5139393,8.897647,176.0152442,4.726568,7.7463106,0.3392926,20.0352416),(48694,'forelimb',255,2,306,21.8684591,97.2669382,126.0094502,1.8,97.122251,125.9921794,0.0249809,2.4916518,18.2551,23.1185112,3226.4506743,0.002274,176.7424266,9.2783877,177.1460691,4.726568,7.7463106,0.3392926,19.7835362),(48695,'forelimb',255,2,307,21.8535207,97.0826713,126.083227,1.8,96.7840312,126.0474858,0.0235231,2.5352012,18.0699702,23.0361554,3223.2081841,0.002015,178.3737407,9.0865194,178.6547958,4.726568,7.7463106,0.3392926,20.0352416),(48696,'forelimb',255,2,308,21.8906709,96.8969958,126.1560107,1.8,96.6543997,126.1293032,0.021863,2.5884137,17.8827369,22.9150015,3225.7930513,0.0017436,180.3858703,8.8529132,180.524416,4.726568,7.7463106,0.3392926,20.0352416),(48697,'forelimb',255,2,309,21.8408762,96.7556702,126.229038,1.8,96.7666281,126.2280857,0.0194955,2.6360962,17.7296637,22.7069625,3208.0829172,0.0013833,180.9443751,8.6138597,181.3893673,4.726568,7.6140908,0.2860514,19.7835362),(48698,'forelimb',255,2,310,21.9318493,96.6452975,126.3038355,1.8,96.4606157,126.3478033,0.018194,2.4923987,17.6184375,23.1903331,3213.5275637,0.0012099,182.3957188,9.3044235,182.6955297,4.726568,7.6140908,0.2860514,20.0352416),(48699,'forelimb',255,2,311,22.0654556,96.5399238,126.3746613,1.8,96.4065518,126.4221359,0.016782,2.395046,17.5117027,23.5650249,3221.6910724,0.0010356,183.9736046,9.8390697,184.236638,4.726568,7.6140908,0.2860514,19.7835362),(48700,'forelimb',255,2,312,22.0854294,96.378111,126.4402566,1.8,96.3088011,126.4519383,0.0148888,2.3990085,17.3472535,23.6999722,3219.3898175,0.0008159,185.5849873,9.8790695,185.7180489,4.726568,7.6140908,0.2860514,19.7835362),(48701,'forelimb',255,2,313,22.1470293,96.1785514,126.5041438,1.8,96.0010175,126.4964108,0.0130961,2.4488449,17.1449301,23.8830321,3230.310222,0.000633,188.4119792,9.7527746,188.3970675,4.726568,7.6140908,0.2860514,20.0352416),(48702,'forelimb',255,2,314,22.1203416,96.0307664,126.5631524,1.8,96.2002931,126.5379265,0.0114274,2.4887837,16.9943011,23.8116177,3220.8056225,0.0004814,189.5226876,9.5675722,189.3590505,4.726568,7.5041783,0.4124104,19.427571),(48703,'forelimb',255,2,315,22.1778572,95.847823,126.6262506,1.8,95.9390997,126.6515611,0.0089178,2.5303767,16.802548,24.1366076,3225.3506532,0.0002939,191.9560441,9.5387408,192.2096691,4.726568,7.5041783,0.4124104,19.6792764),(48704,'forelimb',255,2,316,22.2467304,95.7082983,126.6793189,1.8,95.7098732,126.7141569,0.0069017,2.562478,16.6595949,24.3090265,3230.0182813,0.0001766,193.8833632,9.486531,193.7788251,4.726568,7.3425118,0.3587707,19.427571),(48705,'forelimb',255,2,317,22.4000308,95.5785853,126.7249214,1.8,95.3302459,126.7350155,0.0050664,2.5919983,16.5264988,24.5976906,3243.1369979,0.0000958,196.2386006,9.489856,196.1491517,4.726568,7.3425118,0.3587707,19.427571),(48706,'forelimb',255,2,318,22.5538346,95.470823,126.7678432,1.8,95.3260742,126.75796,0.0036518,2.6206535,16.4160034,24.7166797,3257.0156214,0.0000501,198.4049071,9.4314948,198.297085,4.726568,7.3425118,0.3587707,19.427571),(48707,'forelimb',255,2,319,22.70596,95.3592489,126.8141251,1.8,95.3825903,126.8109073,0.0020432,2.6527886,16.3011273,24.989971,3267.8214799,0.0000158,200.4659807,9.4202648,200.2305532,4.726568,7.3425118,0.3587707,19.427571),(48708,'forelimb',255,2,320,22.7270528,95.2244407,126.8595065,1.8,95.4384791,126.8659009,0.0002464,2.6819385,16.1622967,24.9928986,3264.3528894,0.0000002,201.9733307,9.3189679,201.9124317,4.726568,7.2028834,0.3028849,19.427571),(48709,'forelimb',255,2,321,22.8099693,95.0710733,126.8596316,1.8,95.3539056,126.8541283,-0.0017625,2.6648425,16.0120639,25.2304355,3274.6836371,0.0000118,204.5135251,9.46789,204.4708969,4.726568,7.112602,0.4366272,19.427571),(48710,'forelimb',255,2,322,23.0704679,94.8928249,126.9071599,1.8,95.2125244,126.9143902,-0.0041134,2.6916747,15.8383226,25.8238507,3308.1138993,0.0000651,208.8676927,9.5939716,208.9459984,4.726568,7.2028834,0.3028849,19.427571),(48711,'forelimb',255,2,323,23.304167,94.7098096,126.9518248,1.8,95.0752444,126.9476421,-0.0060192,2.7187027,15.6586991,26.4173401,3338.0833065,0.0001407,213.177562,9.7168918,213.3640932,4.726568,7.2028834,2.8387078,19.427571),(48712,'forelimb',255,2,324,23.5108986,94.4767354,127.0004267,1.8,94.704376,127.0469537,-0.007847,2.7492727,15.4319966,26.9515399,3369.1174938,0.0002413,218.3202587,9.8031528,217.8350139,4.726568,7.2028834,2.8387078,19.6792764),(48713,'forelimb',255,2,325,23.5670155,94.3606673,127.0389914,1.8,94.6829017,127.0859807,-0.0096321,2.7704693,15.3194912,27.1573846,3360.7080933,0.0003644,219.3746553,9.8024492,219.0018413,4.726568,7.3550738,3.0244839,19.7835362),(48714,'forelimb',255,2,326,23.7335757,94.2709824,127.0711865,1.8,94.657628,127.1122641,-0.0113084,2.7861867,15.2330299,27.6414693,3368.7931358,0.0005058,221.1505628,9.9208964,220.890294,4.726568,7.2028834,2.8387078,19.427571),(48715,'forelimb',255,2,327,23.9314674,94.123246,127.0971611,1.8,94.4513748,127.1058027,-0.0135101,2.7954503,15.0895268,28.178648,3378.1951018,0.000728,223.8768092,10.0801822,223.718436,4.726568,7.2028834,2.8387078,19.427571),(48716,'forelimb',255,2,328,24.2038832,93.995209,127.1225352,1.8,94.3509282,127.111383,-0.0152621,2.8030239,14.9646601,28.6479789,3401.686487,0.0009396,227.3146508,10.2203834,227.2378284,4.726568,7.2028834,2.8387078,19.427571),(48717,'forelimb',255,2,329,24.5292268,93.928526,127.1417391,1.8,94.4125101,127.1145096,-0.0172415,2.8029117,14.9015565,29.15663,3424.5547504,0.0012152,229.811883,10.4022649,229.8335044,4.726568,7.4175649,2.9669205,19.7835362),(48718,'forelimb',255,2,330,24.7795987,93.8434892,127.1594682,1.8,94.3731485,127.1319144,-0.0188743,2.8039315,14.8193442,29.7396051,3439.3285486,0.0014711,232.0837207,10.6063949,232.1953317,4.726568,7.3550738,3.0244839,19.7835362),(48719,'forelimb',255,2,331,25.1118799,93.7737866,127.1774198,1.8,94.5581041,127.1609039,-0.0206595,2.8126441,14.7526492,30.4019472,3465.2152243,0.0017861,234.8876585,10.8090273,235.0985895,4.726568,7.2028834,2.8387078,19.427571),(48720,'forelimb',255,2,332,25.4216137,93.6866666,127.1916841,1.8,94.5612973,127.1735599,-0.0223002,2.8102225,14.6778365,31.0702017,3490.5395799,0.0021067,237.8102237,11.0561357,237.1631824,4.7006754,7.2028834,0.3028849,19.427571),(48721,'forelimb',255,2,333,25.7720784,93.5695999,127.2105356,1.8,94.4135423,127.2084394,-0.0240355,2.810505,14.5642284,31.8658239,3524.8489381,0.002481,242.0209877,11.3381131,241.455249,4.726568,7.086596,2.896614,19.1758656),(48722,'forelimb',255,2,334,26.0767208,93.4854143,127.2252383,1.8,94.1594166,127.2436943,-0.0259542,2.8053691,14.483895,32.7082656,3548.2712799,0.002927,244.980461,11.6591667,244.5211345,4.726568,7.3550738,0.1171087,19.5318307),(48723,'forelimb',255,2,335,26.4175623,93.4226792,127.2333258,1.8,94.0966756,127.2376117,-0.0273955,2.8101181,14.4240679,33.5636938,3575.1830382,0.0033036,247.8623274,11.9438732,247.4849666,4.726568,7.086596,2.896614,19.1758656),(48724,'forelimb',255,2,336,26.6356516,93.3691075,127.2361559,1.8,94.0448261,127.2394781,-0.0285117,2.8014574,14.372815,34.1422481,3587.0437409,0.0036078,249.5714122,12.1873165,249.2482154,4.726568,7.086596,0.2449787,18.9241602),(48725,'forelimb',255,2,337,26.6463379,93.3927442,127.176466,1.8,94.2521464,127.1558812,-0.0286405,2.7536176,14.3984242,34.3790712,3557.1822026,0.0036419,247.0535767,12.4850564,246.6358281,4.726568,7.086596,0.2449787,19.5318307),(48726,'forelimb',255,2,338,26.8851842,93.3873632,127.1737325,1.8,94.0721515,127.1532074,-0.0297693,3.1450182,14.3955761,35.2795598,3570.4650525,0.0039698,248.0251587,11.2176011,247.6916045,4.726568,7.086596,0.2449787,19.5318307),(48727,'forelimb',255,2,339,26.9875709,93.4004804,127.1681456,1.8,94.2038242,127.142247,-0.0302663,3.1351556,14.4099304,35.9855176,3568.2937936,0.0041191,247.6274128,11.4780642,247.3547165,4.726568,7.086596,0.2449787,19.5318307),(48728,'forelimb',255,2,340,27.0128599,93.442128,127.1574941,1.8,94.316516,127.1117257,-0.0305838,3.135939,14.4394307,36.6320488,3558.0952555,0.0042099,246.4152032,11.6813652,247.1684167,4.726568,6.7939638,2.8198421,18.9241602),(48729,'forelimb',255,2,341,27.0576191,93.4714741,127.1421916,1.8,94.3838068,127.0903602,-0.030707,3.1204449,14.4694469,37.1333138,3549.7456001,0.0042509,245.3269721,11.9000063,246.0989419,4.726568,6.9418221,0.3805064,18.568195),(48730,'forelimb',255,2,342,27.0140348,93.5047322,127.1283733,1.8,94.5915814,127.0704604,-0.0307193,3.1075457,14.5031351,37.5808874,3529.4963611,0.0042474,243.3609237,12.0934304,244.1546658,4.29688,6.7939638,0.3217506,17.9605244),(48731,'forelimb',255,2,343,27.0121326,93.5269079,127.1104295,1.8,94.5345547,127.0630545,-0.0308843,3.0888335,14.5261451,38.2200611,3513.3490748,0.0042928,241.8638297,12.3736231,242.683899,4.29688,6.9948139,0.1853479,18.3164896),(48732,'forelimb',255,2,344,27.0835235,93.5419898,127.0863825,1.8,94.4954225,127.0110853,-0.0313505,3.0746189,14.5428006,39.1930549,3508.1865761,0.0044351,241.2318422,12.7472889,242.0902785,4.29688,6.9948139,0.1853479,18.3164896),(48733,'forelimb',255,2,345,27.0140908,93.5702375,127.0618352,1.8,94.4313599,127.0110853,-0.0315981,3.0488974,14.5722537,39.8533698,3486.1665071,0.0044938,239.2331737,13.0714042,240.1132146,4.29688,6.7939638,0.3217506,17.9605244),(48734,'forelimb',255,2,346,26.9415808,93.6014806,127.0371272,1.8,94.3485473,127.0032728,-0.0315987,3.0251837,14.6042629,40.7316443,3461.3985955,0.0044819,237.0128928,13.4641886,237.9240871,4.726568,6.6705516,2.8809903,18.0647842),(48735,'forelimb',255,2,347,26.870078,93.6101934,127.0108994,1.8,94.3657348,126.9813978,-0.0315928,2.9992938,14.6137889,41.4301801,3437.9049628,0.0044684,235.2507608,13.8133117,236.171324,4.726568,6.7939638,0.3217506,18.0647842),(48736,'forelimb',255,2,348,26.7893436,93.6138023,126.9830805,1.8,94.2878184,126.9441064,-0.0310628,3.3788017,14.6039248,42.2555554,3413.0729444,0.0043068,233.7092935,12.5060772,235.4123909,4.726568,6.6705516,0.2606024,18.3164896),(48737,'forelimb',255,2,349,26.7489484,93.6799038,126.9491709,1.8,94.2641335,126.8976466,-0.0308526,3.3621348,14.6707313,43.3680038,3390.2772656,0.0042423,231.0912244,12.8989485,232.8248009,4.726568,6.5448126,0.4048918,17.708819),(48738,'forelimb',255,2,350,26.5503293,93.7018719,126.9196495,1.8,94.3655155,126.8725435,-0.0305171,3.3362136,14.6930842,44.0680211,3350.0533632,0.0041197,228.0020538,13.2089929,229.7442125,4.726568,6.6705516,0.2606024,18.0647842),(48739,'forelimb',255,2,351,26.3173016,93.7175553,126.8930992,1.8,94.4250609,126.8657563,-0.0300269,3.314396,14.7088013,44.6767635,3310.3178189,0.0039535,225.0569404,13.4796094,226.8020605,4.726568,6.6705516,0.2606024,18.0647842),(48740,'forelimb',255,2,352,26.0530544,93.7766347,126.8638048,1.8,94.4740683,126.8454053,-0.0291764,3.2941941,14.7548326,45.021499,3264.7879058,0.0036953,221.2690579,13.6669236,223.6028394,4.726568,6.6705516,0.2606024,17.5613733),(48741,'forelimb',255,2,353,25.5783269,93.8142052,126.7741965,1.8,94.4602392,126.762405,-0.0290372,3.2193854,14.7948239,45.4628836,3189.6346201,0.0035934,215.5912525,14.1216034,217.8585253,4.726568,6.6705516,0.2606024,18.0647842),(48742,'forelimb',255,2,354,25.3869813,93.9008857,126.7364951,1.8,94.6623265,126.7226432,-0.0284705,3.188767,14.8818185,45.9912281,3149.7461142,0.0034287,211.6506196,14.4228874,213.9049117,4.726568,6.6705516,0.2606024,17.8130787),(48743,'forelimb',255,2,355,25.2023495,94.0131468,126.695796,1.8,94.8060059,126.6900368,-0.0278017,3.1565732,14.9823389,46.7165438,3112.1366421,0.0032458,207.720347,14.7997656,210.4289887,4.726568,6.3877713,0.3430239,17.2054082),(48744,'forelimb',255,2,356,24.8559132,94.0969559,126.6520671,1.8,94.8946014,126.660505,-0.0269239,3.1220623,15.0664682,46.9541437,3056.1858862,0.0030023,202.846868,15.0394639,205.520383,4.726568,6.3877713,0.3430239,17.4571136),(48745,'forelimb',255,2,357,24.5409761,94.1604722,126.6015924,1.8,94.8543568,126.5971924,-0.0256675,3.490555,15.1300036,47.4923448,3003.1677186,0.0026941,198.4908789,13.605958,201.1391509,4.726568,6.5448126,0.4048918,17.4571136),(48746,'forelimb',255,2,358,24.2166956,94.2437544,126.5518019,1.8,94.6872129,126.5569534,-0.0252868,3.4461701,15.2141145,48.0182103,2950.2056062,0.0025802,193.9124104,13.9337899,196.5453181,4.726568,6.6705516,0.2606024,17.8130787),(48747,'forelimb',255,2,359,24.0019632,94.3506524,126.5009106,1.8,94.8418537,126.5122138,-0.0249457,3.4115923,15.311151,48.2981968,2907.9622864,0.0024888,189.9244733,14.1570834,192.8569899,4.726568,6.5729625,0.1973956,17.5613733),(48748,'forelimb',255,2,360,23.9027656,94.437186,126.4441193,1.8,94.9098947,126.4598091,-0.0254261,3.3531743,15.3994516,49.0115648,2876.1914947,0.0025749,186.7723321,14.616468,189.7105905,4.726568,6.6705516,0.2606024,17.3096679),(48749,'forelimb',255,2,361,23.7955113,94.4692639,126.3809804,1.8,94.8901567,126.3977165,-0.0260387,3.2860416,15.4224514,49.3682427,2847.8104558,0.0026883,184.6535532,15.0236207,187.7897908,4.726568,6.5729625,0.1973956,17.5613733),(48750,'forelimb',255,2,362,23.5476012,94.5371252,126.3174296,1.8,95.0611123,126.3385727,-0.0260102,3.2968623,15.0847383,49.3775983,2802.976878,0.0026545,185.8154125,14.9771493,188.3495849,4.726568,6.3877713,0.3430239,17.2054082),(48751,'forelimb',255,2,363,23.2748497,94.6148556,126.2629369,1.8,95.0923416,126.2879887,-0.0257654,3.3356565,15.152449,49.7162889,2758.6077179,0.0025746,182.056888,14.9044992,184.9637428,4.726568,6.2563517,0.2782997,16.9537027),(48752,'forelimb',255,2,364,23.1019672,94.6641185,126.2074454,1.8,95.0540732,126.2116213,-0.02465,3.5366843,15.2019797,50.1670947,2732.1643492,0.0023391,179.7242468,14.1847817,182.6011457,5.1070441,6.3877713,0.3430239,17.3096679),(48753,'forelimb',255,2,365,22.9741237,94.7337495,126.1514068,1.8,95.0437371,126.1289322,-0.023685,3.5007367,15.2719119,50.6089721,2707.1331912,0.0021476,177.2622316,14.4566636,180.1056342,4.726568,6.3877713,0.3430239,17.2054082),(48754,'forelimb',255,2,366,22.8449374,94.894436,126.0880198,1.8,95.263421,126.0664083,-0.0229747,3.4467726,15.4233527,51.4897773,2671.0384842,0.0020094,173.1814438,14.9385476,176.3140232,4.726568,6.2563517,0.2782997,17.2054082),(48755,'forelimb',255,2,367,22.8008496,94.9987145,126.0225172,1.8,95.3579027,126.0056491,-0.0225401,3.3967468,15.5287555,52.0852268,2653.6324509,0.0019304,170.8850688,15.3338559,173.9995036,4.726568,6.3877713,0.3430239,17.2054082),(48756,'forelimb',255,2,368,22.445853,95.0661887,125.9629755,1.8,95.3142162,125.983933,-0.0221613,3.3414971,15.5877009,52.0569399,2604.3870873,0.001837,167.0796162,15.578927,170.348363,4.726568,6.2563517,0.2782997,17.2054082),(48757,'forelimb',255,2,369,22.0026808,95.1755538,125.8407296,1.8,95.694733,125.834277,-0.0213547,3.6387215,15.6901085,51.9330443,2537.8267413,0.001672,161.7469208,14.272333,165.0490429,5.029227,6.1521959,0.2110933,17.0579625),(48758,'forelimb',255,2,370,21.8887686,95.2697244,125.7749891,1.8,95.7287572,125.7267088,-0.0209989,3.5868517,15.3740347,52.2991976,2511.511981,0.0016084,163.3606289,14.5808083,166.3447977,4.726568,5.9848613,0.3671738,16.5977376),(48759,'forelimb',255,2,371,21.4999229,95.3780794,125.7344609,1.8,95.8703877,125.7015842,-0.0197183,3.5580729,15.4817592,51.5543202,2463.0649563,0.001393,159.0946431,14.4893939,161.9798143,4.726568,6.1521959,0.4324078,16.5977376),(48760,'forelimb',255,2,372,21.1641728,95.4460515,125.6826654,1.8,95.9321429,125.6765785,-0.018312,3.5179181,15.5411704,50.7295669,2423.6857242,0.0011827,155.9525868,14.4203376,159.0110414,4.726568,5.9848613,0.3671738,16.3460322),(48761,'forelimb',255,2,373,20.9233682,95.5525475,125.6105152,1.8,96.065147,125.6040628,-0.0180889,3.4634061,15.6487772,51.0351507,2394.8522293,0.0011409,153.0376592,14.7355376,156.0609688,4.726568,5.9848613,0.3671738,16.3460322),(48762,'forelimb',255,2,374,20.7276026,95.7442518,125.5301296,1.8,96.137407,125.5167956,-0.0180884,3.7865105,15.8419036,51.9283655,2365.428386,0.0011302,149.3146559,13.7140423,152.3238286,4.726568,5.9848613,0.3671738,16.849443),(48763,'forelimb',255,2,375,20.8860502,95.9800706,125.4389333,1.8,96.4456751,125.3959041,-0.0181528,3.7069016,16.0716,54.2263693,2367.0694257,0.0011469,147.2827489,14.628489,150.5527177,4.9968715,5.8443887,0.2984989,16.9537027),(48764,'forelimb',255,2,376,21.495447,96.2847479,125.3345498,1.8,96.7301955,125.3070999,-0.0188869,3.6111094,16.3786288,58.1567261,2399.2680428,0.0012778,146.4877236,16.104947,149.9076276,4.726568,5.9848613,0.3671738,16.3460322),(48765,'forelimb',255,2,377,22.1696327,96.5742559,125.2457352,1.8,96.8230293,125.2657708,-0.0182365,3.539638,16.6692596,62.6302637,2436.1491307,0.0012287,146.1462112,17.6939743,149.7401479,4.726568,5.9848613,0.3671738,16.3460322),(48766,'forelimb',255,2,378,22.9471003,97.0061212,125.1164809,1.8,97.0460702,125.1608667,-0.0203873,3.8189041,17.0965467,68.1223892,2466.3089824,0.0015894,144.2577276,17.8382035,148.1946299,4.726568,5.8443887,2.8430937,16.3460322),(48767,'forelimb',255,2,379,24.2863521,97.5135202,125.0056827,1.8,97.0514554,125.081189,-0.0202086,3.7281721,17.6060033,75.4674724,2517.7213736,0.0016528,143.0035727,20.2424864,147.2215083,5.156256,5.8443887,2.8430937,17.2054082),(48768,'forelimb',255,2,380,24.9701051,97.7893274,124.8802363,1.8,97.2765216,124.9714262,-0.0204273,4.0192799,17.8844324,79.3251923,2532.828379,0.0017363,141.6219605,19.7361701,145.9600796,5.156256,5.9848613,0.3671738,16.9537027),(48769,'forelimb',255,2,381,25.7613921,98.1027433,124.7748258,1.8,97.4448834,124.8601713,-0.0197571,3.9409787,18.1994277,84.8514992,2551.8751243,0.0016757,140.2173279,21.5305651,144.7520338,4.726568,5.9848613,0.3671738,16.5977376),(48770,'forelimb',255,2,382,27.2247948,98.6904564,124.6878617,1.8,97.6389669,124.7820996,-0.0174766,3.9108252,18.7792713,93.6239512,2560.7084852,0.0013857,136.3582451,23.939692,141.3026484,4.726568,5.8443887,2.8430937,16.3460322),(48771,'forelimb',255,2,383,29.4142479,99.2270352,124.5370718,1.8,97.8536091,124.5949733,-0.0189122,4.1662111,19.3192367,107.4193492,2601.2051326,0.0017532,134.6432664,25.7834626,140.1432394,4.726568,5.8443887,2.8430937,16.849443),(48772,'forelimb',255,2,384,32.0183393,99.665211,124.3350567,1.8,98.0241704,124.3936124,-0.0224896,4.4021616,19.7637477,127.8635816,2655.7526487,0.0026986,134.374952,29.0456355,140.7589024,5.156256,5.8443887,2.8430937,17.2054082),(48773,'forelimb',255,2,385,32.3982891,99.8236998,124.2679723,1.8,98.2563457,124.2064317,-0.016686,4.773292,19.918999,129.1311959,2665.0619526,0.0015033,133.7949741,27.0528592,140.1445797,5.156256,5.9848613,0.3671738,16.9537027),(48774,'forelimb',255,2,386,28.6909949,99.3577346,124.6130258,1.8,97.9383278,124.4143064,0.0068021,5.1881912,19.4382636,83.2281278,2597.5855637,0.0002212,133.6325929,16.0418391,137.7984344,4.726568,5.9848613,0.3671738,16.5977376),(48775,'forelimb',255,2,387,27.9871562,99.2727893,124.5723533,1.8,98.3258685,124.3561965,0.0055392,5.1546301,19.3526987,80.9552981,2646.5712689,0.0001431,136.754636,15.7053554,140.9104595,5.156256,5.8443887,2.8430937,16.9537027),(48776,'forelimb',255,2,388,31.7514065,100.0344315,124.1669264,1.8,98.6563648,124.0306759,-0.0121691,5.0844442,20.121589,115.093974,2854.4755674,0.0007836,141.8613397,22.6364905,147.5095596,5.156256,5.8443887,2.8430937,16.9537027),(48777,'forelimb',255,2,389,37.9844634,100.6253167,123.960402,1.8,98.7512664,124.0073722,-0.0148053,4.899276,20.7170512,152.2873168,3080.8725655,0.0013876,148.7119253,31.0836371,155.9544528,5.156256,5.8443887,2.5127964,17.2054082),(48778,'forelimb',255,2,390,39.7202259,100.6279664,123.8719364,1.8,98.7238019,124.0027846,-0.0160957,4.7937089,20.7221036,162.6648341,3234.4780327,0.0017149,156.0883053,33.9329809,163.80556,5.156256,5.8443887,2.8430937,16.9537027),(48779,'forelimb',255,2,391,35.979698,99.8083112,123.9065042,1.8,98.0373965,123.8393451,-0.0050279,4.8618693,19.8917869,116.680785,3342.4570635,0.0001516,168.0320162,23.999161,173.663914,5.3825049,5.9694165,2.6135182,17.5613733),(48780,'forelimb',255,2,392,20.1376761,94.116985,123.3019817,1.8,94.2674088,123.5567844,-0.0549504,4.0635113,14.6508446,52.6744762,2358.3955426,0.0101242,160.9733509,12.9627981,164.5666116,5.156256,6.1970485,2.5535901,17.4571136),(48781,'forelimb',255,2,393,13.62935,88.8699146,122.9488704,1.8,89.3259357,122.9206965,-0.1321117,3.1546426,16.7211713,16.8785373,1402.0082285,0.0394165,83.8462932,5.3503803,84.5987142,5.4690354,6.44532,2.4980915,18.0647842),(48782,'forelimb',255,2,394,11.1109725,86.1851297,123.1428674,1.8,87.2119318,122.9668842,-0.145829,2.7409902,19.4219677,14.162,828.8098438,0.0391028,42.673835,5.1667459,43.3588631,5.5714602,6.3877713,2.7985687,18.4207493),(48783,'forelimb',255,2,395,9.8657151,81.9548313,123.4993696,1.8,82.1237269,123.5713687,0.2122624,7.7562439,20.8638935,12.4725165,23.2974332,0.0729779,1.1166388,1.6080614,1.6069909,5.3825049,6.5589027,2.5899377,18.6724547),(48784,'forelimb',255,2,396,9.6963015,82.073946,123.6742359,1.8,82.0337679,123.750144,0.3026711,2.6625256,3.1079981,11.1470247,17.7384469,0.14358,5.7073545,4.1866357,9.2831472,5.156256,6.3877713,2.7985687,18.0647842),(48785,'forelimb',255,2,397,6.9076343,82.0822793,123.7074233,1.8,82.0580132,123.6840382,0.4743081,2.1509464,2.8733202,5.5794529,11.7201492,0.2401508,4.0789568,2.5939526,6.0187666,4.7002087,5.9848613,2.7744188,16.3460322),(48786,'forelimb',255,2,398,5.381289,81.9573503,123.5188866,1.8,81.9683571,123.5299289,0.7254145,1.7945652,2.3792555,3.0614835,6.5860434,0.3947715,2.7681111,1.705975,4.0168464,3.9498589,5.2450105,2.1815223,14.0196096),(48787,'forelimb',255,2,399,4.3975373,81.919157,123.3103861,1.8,81.9183646,123.3006242,1.0582534,1.5817327,2.212992,1.9169491,4.4993743,0.5566643,2.0331633,1.2119299,2.8514648,3.437504,4.899197,1.8370484,12.8042684),(48788,'forelimb',255,2,400,4.153096,81.9099363,123.1497733,1.8,81.931799,123.0848206,1.1669158,1.7724225,1.9693429,2.0829575,3.3277351,0.5852814,1.6897692,1.1752037,2.7107729,3.437504,4.4860744,1.8622531,12.1965978),(48789,'forelimb',255,2,401,4.0929508,82.0580909,123.1885217,1.8,82.0351877,123.1795747,1.0169372,1.746723,1.7951206,2.383058,2.5160583,0.4934407,1.4016096,1.3643022,2.5823343,3.867192,4.231936,2.7233683,11.9448924),(48790,'forelimb',255,2,402,1.0529606,82.1450897,123.2439478,1.8,82.1741258,123.2167382,-1.0200084,1.2056429,1.2863259,0.306139,0.3592502,0.127425,0.279284,0.2539218,0.5032253,2.578128,3.0985242,0.5880026,8.2988688),(48791,'forelimb',255,2,403,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48792,'forelimb',255,2,404,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48793,'forelimb',255,2,405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48794,'forelimb',255,2,406,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48795,'forelimb',255,2,407,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48796,'forelimb',255,2,408,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48797,'forelimb',255,2,409,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48798,'forelimb',255,2,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48799,'forelimb',255,2,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48800,'forelimb',255,2,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48801,'forelimb',255,2,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48802,'forelimb',255,2,414,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48803,'forelimb',255,2,415,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48804,'forelimb',255,2,416,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48805,'forelimb',255,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48806,'forelimb',255,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48807,'forelimb',255,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48808,'forelimb',255,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48809,'forelimb',255,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48810,'forelimb',255,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48811,'forelimb',255,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48812,'forelimb',255,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48813,'forelimb',255,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48814,'forelimb',255,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48815,'forelimb',255,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48816,'forelimb',255,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48817,'forelimb',255,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48818,'forelimb',255,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48819,'forelimb',255,3,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48820,'forelimb',255,3,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48821,'forelimb',255,3,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48822,'forelimb',255,3,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48823,'forelimb',255,3,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48824,'forelimb',255,3,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48825,'forelimb',255,3,21,0.1245425,99.4106159,128.6110619,1.8,99.44208,128.59948,-1.5688936,0.2775616,0.7253153,0.0071763,0.0225048,0.020757,0.0310276,0.0258549,0.0400593,2.8268186,21.5230372,3.0816645,46.4241922),(48826,'forelimb',255,3,22,0.81652,99.9363486,128.6543698,1.8,100.0854753,128.6676844,0.0381459,1.1364704,1.4785616,0.2477682,0.3074598,0.0001979,0.2079452,0.2180156,0.3722696,3.007816,24.552449,3.0715321,53.0474947),(48827,'forelimb',255,3,23,1.9040572,100.5555398,128.5438823,1.8,100.7572649,128.5224235,0.075979,1.286441,2.1612358,0.5998737,1.767919,0.0018284,0.818013,0.4663049,1.0778286,3.007816,27.1248527,3.0781857,58.8114213),(48828,'forelimb',255,3,24,3.0375844,101.1931069,128.3678258,1.8,101.3647853,128.3311725,0.0618552,1.4871626,2.7927817,0.9641506,5.2264187,0.0019345,1.8714025,0.6483155,2.1416824,3.007816,30.1057701,3.0987617,64.9313131),(48829,'forelimb',255,3,25,3.9569387,101.6712321,128.1280598,1.8,101.8671178,128.1039706,0.0379218,1.7069989,3.5803751,1.4213824,10.5452703,0.0009479,2.9452976,0.8326792,3.2890311,3.437504,32.2724008,0.0532829,69.4798985),(48830,'forelimb',255,3,26,4.3009133,101.9506887,127.8560981,1.8,102.2145907,127.83218,0.0075174,1.5107707,3.7538886,1.4954789,15.6070704,0.0000405,4.1575742,0.9898781,4.3741238,3.5419677,34.0132727,0.0632068,73.8810383),(48831,'forelimb',255,3,27,4.189351,102.2469963,127.594095,1.8,102.5505933,127.5835403,-0.0223295,1.7618273,4.3332208,1.5414419,18.9902682,0.0003481,4.3824834,0.8749109,4.6706708,3.5344686,35.2763119,0.0487419,76.6676859),(48832,'forelimb',255,3,28,3.9183339,102.2833404,127.3667716,1.8,102.6857761,127.3711103,-0.0380852,1.5823185,4.3320832,1.4784353,20.8222851,0.0009468,4.8065294,0.9343475,4.9292728,3.6862537,35.401702,0.0972532,78.1347325),(48833,'forelimb',255,3,29,3.493457,102.3575241,127.1444865,1.8,102.7949939,127.1090465,-0.0387815,1.7945075,4.6796088,1.2315195,20.8243964,0.0008753,4.4500293,0.6862716,4.5956276,3.9848034,35.7907149,0.0841382,79.0983683),(48834,'forelimb',255,3,30,3.1683372,102.4181824,126.9878847,1.8,102.8723624,127.0056625,-0.0539648,1.6872371,4.649403,1.1888412,20.4562881,0.0015363,4.3997666,0.7046083,4.4909238,3.8036757,35.8293839,0.0960887,78.1347325),(48835,'forelimb',255,3,31,2.900789,102.4555801,126.8274848,1.8,102.9908425,126.8385265,-0.0374135,1.9066327,4.5843747,1.033446,20.1163873,0.0006764,4.3880329,0.5420268,4.4659575,4.176726,35.4460046,0.1093185,78.8466629),(48836,'forelimb',255,3,32,2.7172203,102.4255034,126.7032824,1.8,102.9577091,126.7077367,-0.0459399,1.8077857,5.0479127,0.9550014,19.8487816,0.0009551,3.932077,0.5282713,4.0421469,4.3059199,35.4460046,0.1093185,78.3432521),(48837,'forelimb',255,3,33,2.6921551,102.5084403,126.5405442,1.8,103.0837043,126.5974741,-0.0609985,1.6966975,4.9959438,1.0068177,21.1917742,0.0016674,4.2417959,0.5933985,4.3206341,4.7085747,35.018913,0.1106572,77.7355815),(48838,'forelimb',255,3,34,2.5817117,102.6880756,126.3859219,1.8,103.4501404,126.3998867,-0.06789,1.5763055,5.2430755,0.8984138,22.313535,0.0019802,4.2558104,0.569949,4.3497877,5.1346836,35.018913,0.1106572,79.3068879),(48839,'forelimb',255,3,35,2.5470233,102.7840332,126.2820695,1.8,103.5705283,126.2549106,-0.080675,1.9512696,5.579622,0.9369946,23.298343,0.0027569,4.1756131,0.4801974,4.3000286,4.9241799,35.018913,0.1106572,78.6992173),(48840,'forelimb',255,3,36,2.548534,102.8582193,126.1974346,1.8,103.5755159,126.188494,-0.0933046,1.9164441,5.5475123,0.9974486,24.5715113,0.0036871,4.4292847,0.5204684,4.5247992,5.3188303,34.6425541,0.124355,78.5949575),(48841,'forelimb',255,3,37,2.5560871,103.0282366,126.1112084,1.8,103.6647282,126.0984389,-0.1082839,1.9003594,5.8118343,1.1202573,25.8750369,0.0049757,4.4521291,0.5894976,4.5926842,5.7988091,34.9740693,0.0984462,80.4179693),(48842,'forelimb',255,3,38,2.5520028,103.2604991,126.0406986,1.8,103.846041,126.037039,-0.1218549,1.9070929,6.062845,1.1998366,26.8683161,0.0062844,4.431635,0.6291443,4.5508492,6.2608854,35.0689645,0.1228352,81.6333105),(48843,'forelimb',255,3,39,2.4637152,103.5188502,125.951901,1.8,104.0561107,125.9415528,-0.1411803,1.928587,5.8757803,1.2721411,26.8120019,0.0081302,4.5631389,0.6596234,4.6514834,6.7042865,34.759608,0.1488899,82.3452409),(48844,'forelimb',255,3,40,2.3914851,103.8685092,125.8483311,1.8,104.3417647,125.8454765,-0.1666695,1.9865353,5.9710048,1.2434461,27.4069657,0.0109699,4.590009,0.6259371,4.7155563,7.0948896,34.759608,0.1488899,82.7012061),(48845,'forelimb',255,3,41,2.4120183,104.2751441,125.6787216,1.8,104.7145036,125.6490877,-0.1976161,2.0334341,6.0765647,1.34624,29.8768005,0.0154958,4.9167255,0.6620524,5.0427442,7.5229425,35.1242016,0.1349767,85.3835939),(48846,'forelimb',255,3,42,2.4065913,104.6923814,125.5105821,1.8,104.9705169,125.5141263,-0.2230482,2.0808598,6.0797684,1.370075,32.2091747,0.0196261,5.2977634,0.6584177,5.4678304,7.6034693,35.1845999,0.1470784,86.0955242),(48847,'forelimb',255,3,43,2.3503066,104.9693886,125.3815325,1.8,105.0564058,125.422693,-0.2341396,2.0760414,5.8893086,1.2896285,32.4344546,0.0210849,5.5073451,0.6211959,5.6191062,8.0123745,34.8259407,0.1610919,86.7031948),(48848,'forelimb',255,3,44,2.3862258,105.3805236,125.2248957,1.8,105.3975936,125.2784158,-0.2585984,1.7452192,6.3110594,1.3077442,33.8470213,0.0260081,5.3631283,0.7493295,5.5698541,8.2528019,35.1242016,0.1349767,88.2745012),(48849,'forelimb',255,3,45,2.4072067,105.811017,125.0634862,1.8,105.6853443,125.1734855,-0.2761836,1.810293,6.6496366,1.3144682,33.9568242,0.0298323,5.1065684,0.726108,5.2848578,8.6840071,34.8259407,0.1610919,88.8821718),(48850,'forelimb',255,3,46,2.4176692,106.1140927,124.9400194,1.8,105.9494234,125.0481598,-0.2872065,1.8470491,6.9685851,1.2618824,33.7592933,0.032334,4.8444975,0.6831883,5.0063857,8.7289217,34.8974383,0.1732457,89.3855826),(48851,'forelimb',255,3,47,2.4972847,106.3771463,124.8310979,1.8,106.1155749,124.9741038,-0.3020044,1.9188094,7.2423295,1.2628041,34.7410092,0.0368213,4.7969385,0.6581186,4.9490164,9.2303596,35.1242016,0.1349767,90.3492184),(48852,'forelimb',255,3,48,2.6618867,106.7423854,124.6769667,1.8,106.3229903,124.8656802,-0.3193473,2.0057956,7.6244695,1.2446374,38.0325065,0.0437271,4.9882167,0.6205206,5.1245822,9.6086434,34.8974383,0.1732457,90.097513),(48853,'forelimb',255,3,49,2.8148513,107.030147,124.5024289,1.8,106.3337248,124.7862141,-0.327392,1.9910806,7.9465365,1.1293102,40.968438,0.0485141,5.1555087,0.5671845,5.2728949,9.5921696,34.8259407,0.1610919,89.3855826),(48854,'forelimb',255,3,50,2.9683754,107.2276179,124.3989725,1.8,106.3379248,124.7356669,-0.3274992,1.9574525,8.1667085,1.0946174,43.4641358,0.0511924,5.3221118,0.5592051,5.4340689,10.0035045,34.8259407,0.1610919,90.097513),(48855,'forelimb',255,3,51,3.1233542,107.451472,124.3068642,1.8,106.5587529,124.6250043,-0.3288008,1.9526512,8.4073473,1.0856529,44.4996403,0.0542786,5.2929466,0.5559892,5.4016072,9.9511387,34.8259407,0.1610919,90.8094434),(48856,'forelimb',255,3,52,3.1967594,107.5132515,124.2773404,1.8,106.6158597,124.5829022,-0.3298636,1.9532218,8.4745758,1.053397,45.3089401,0.0559008,5.3464552,0.5393125,5.45037,10.2923041,34.4742621,0.1753942,90.097513),(48857,'forelimb',255,3,53,3.2147749,107.5166362,124.2304143,1.8,106.6410888,124.5123731,-0.3296376,1.908097,8.4931339,0.9990248,46.2606604,0.0561416,5.4468305,0.5235713,5.546267,10.1606019,34.3347331,0.1507464,90.4534782),(48858,'forelimb',255,3,54,3.2337417,107.3613732,124.2220291,1.8,106.4001369,124.5264711,-0.3210536,1.7817517,8.354047,0.9866119,49.5228388,0.0536705,5.9280058,0.5537314,6.0326368,10.6324399,33.9779709,0.1651487,89.8458076),(48859,'forelimb',255,3,55,3.1997806,107.3416688,124.1783294,1.8,106.4480405,124.4698714,-0.3170275,1.7020766,8.3511286,0.9058202,50.9425211,0.051828,6.1000762,0.5321853,6.1984295,10.6622305,33.9099795,0.1526493,89.3855826),(48860,'forelimb',255,3,56,3.1200532,107.3183959,124.1693606,1.8,106.4047045,124.4919985,-0.3125051,1.6504203,8.3338132,0.8300436,51.4870918,0.049152,6.1780952,0.5029286,6.2695936,11.0321569,33.4853518,0.1546005,88.5262066),(48861,'forelimb',255,3,57,3.0688039,107.3029094,124.1345757,1.8,106.4440894,124.4317181,-0.3094905,1.5886352,8.2000253,0.7569082,51.3643988,0.0474462,6.2639318,0.4764519,6.3283915,11.0643794,33.0608548,0.1566019,88.1702414),(48862,'forelimb',255,3,58,3.0762452,107.3083163,124.104332,1.8,106.445779,124.4022144,-0.3080474,1.5499968,8.2154503,0.747556,52.5954008,0.0471329,6.4020107,0.4822952,6.4674479,11.3353258,32.5713708,0.1456284,87.6668306),(48863,'forelimb',255,3,59,3.1549095,107.303546,124.0607303,1.8,106.4759326,124.3343689,-0.3026298,1.4638362,8.2277315,0.7399485,54.6774712,0.0467046,6.6455099,0.5054859,6.7149363,11.3731199,32.1462915,0.1475681,87.4151252),(48864,'forelimb',255,3,60,3.3750689,107.187062,124.0601584,1.8,106.3404972,124.3254889,-0.2974087,1.3875141,8.1197765,0.8192026,57.9898278,0.0483054,7.141801,0.5904103,7.2251669,11.3731199,31.9821833,0.1076899,86.8074546),(48865,'forelimb',255,3,61,3.8900797,107.0574305,124.0692165,1.8,106.1698623,124.3443219,-0.2868683,1.2765159,7.9983927,1.0234573,64.6743675,0.051907,8.0859205,0.8017584,8.2007791,11.7720098,31.2345051,0.138006,85.340408),(48866,'forelimb',255,3,62,4.5644892,106.955428,124.054733,1.8,106.1910893,124.2799848,-0.2830424,1.233356,7.9061656,1.2399038,71.1797175,0.0593356,9.0030643,1.005309,9.1493708,11.799605,30.8089592,0.1399247,85.340408),(48867,'forelimb',255,3,63,5.472318,106.8691285,124.0428497,1.8,106.1671865,124.2607877,-0.279943,1.2807037,7.8276465,1.5298726,76.3014712,0.0696281,9.7476899,1.1945562,9.9348629,11.6946309,30.751975,0.1260881,84.481032),(48868,'forelimb',255,3,64,6.688482,106.7216372,124.047787,1.8,106.2060122,124.2324469,-0.2774052,1.3778717,7.6852274,2.0159436,82.5849434,0.0836058,10.7459336,1.4630851,11.0017594,11.6998623,29.8996165,0.1297025,83.2656908),(48869,'forelimb',255,3,65,7.5387393,106.1885576,124.1432357,1.8,105.9508166,124.2225162,-0.2766754,1.4598557,7.1465393,2.4717547,84.3542054,0.0937516,11.803504,1.69315,12.1443967,12.0729147,29.0476715,0.133529,81.7986442),(48870,'forelimb',255,3,66,8.8801171,105.7588575,124.234808,1.8,105.58048,124.2635375,-0.2806197,1.5376154,6.7074238,3.0294864,88.4781235,0.1135204,13.191074,1.9702498,13.6365688,12.1215568,28.1404636,0.1224611,80.0798922),(48871,'forelimb',255,3,67,9.6830415,105.0172652,124.3980563,1.8,104.9235492,124.387562,-0.2968815,1.5596507,5.9463496,3.5387929,76.9501049,0.1381115,12.9407301,2.268965,13.5239081,11.985314,26.861515,0.1283232,77.2500588),(48872,'forelimb',255,3,68,10.0584595,104.3097992,124.597364,1.8,104.2104801,124.6127029,-0.3006376,1.6278262,5.2106134,3.9988826,62.043219,0.1470086,11.9070855,2.4565783,12.6596033,12.0390365,25.1578563,0.1370662,73.3523299),(48873,'forelimb',255,3,69,10.0760834,103.6229663,124.8250893,1.8,103.6021752,124.7854552,-0.2768188,1.8136436,4.4922429,4.5345548,49.3218086,0.1254325,10.9793282,2.5002458,11.9811192,12.5714533,23.4563999,0.1470784,71.1301671),(48874,'forelimb',255,3,70,9.8417689,103.0282517,125.0457081,1.8,103.0647506,125.0107989,-0.2273054,1.7871849,3.96237,4.7478796,38.330569,0.0833007,9.673647,2.6566247,10.8169345,12.5780463,22.4920224,0.1148766,68.5520391),(48875,'forelimb',255,3,71,9.2067475,102.4614035,125.2469234,1.8,102.5588956,125.1877917,-0.1439232,1.6880971,3.4230052,4.3317743,28.1647408,0.0315657,8.2280743,2.5660694,9.1008788,12.6042781,21.2119693,0.1218424,66.1213567),(48876,'forelimb',255,3,72,8.5541021,101.9701524,125.3827426,1.8,102.0443896,125.3430278,-0.0434335,1.8160378,2.9232397,3.9763458,20.6073855,0.0026878,7.0495026,2.1895722,7.7656996,12.7382831,19.8820682,0.1082706,62.8312983),(48877,'forelimb',255,3,73,7.7561572,101.5257907,125.4632424,1.8,101.6960453,125.464068,0.038992,1.7277502,2.8864182,3.5497114,14.7884347,0.0019644,5.1234552,2.0545281,6.088525,12.460952,18.9842363,3.0509328,60.1489105),(48878,'forelimb',255,3,74,7.0468914,101.1449465,125.4904671,1.8,101.3419148,125.4957515,0.1310085,1.7046185,2.4986565,3.262361,10.3411901,0.0200428,4.1387002,1.9138364,5.2993668,12.460952,18.1285566,3.0466409,57.9267477),(48879,'forelimb',255,3,75,6.0714761,100.7796938,125.4648414,1.8,100.97668,125.4938054,0.2018238,1.7344847,2.3847667,2.7687892,6.7697246,0.0406615,2.8387366,1.596318,3.9990493,12.89064,17.2732438,3.041924,56.6682207),(48880,'forelimb',255,3,76,5.0452032,100.4892254,125.4077938,1.8,100.6977597,125.4085889,0.2893067,1.64533,2.1319526,2.2295881,4.1498685,0.0684375,1.9465107,1.3551009,2.8904869,12.8221428,16.3789491,3.0628087,54.5935035),(48881,'forelimb',255,3,77,4.2673999,100.2469828,125.3297078,1.8,100.424224,125.3373589,0.4722058,1.7218278,1.8693751,1.8505123,2.5563323,0.1471472,1.3674796,1.0747372,2.3480943,12.8221428,15.5639613,3.0309354,53.3781623),(48882,'forelimb',255,3,78,3.4743784,100.0727154,125.2432958,1.8,100.2442573,125.2442864,0.8807213,1.5925904,2.0015803,1.4233277,1.7297398,0.3443959,0.8641871,0.8937186,1.5098392,13.2570967,15.0942245,3.0560874,51.7636701),(48883,'forelimb',255,3,79,2.8968726,99.9334104,125.1295904,1.8,100.1411756,125.0272722,1.1305085,1.5541341,1.9244861,0.9960224,1.2512544,0.3951111,0.6501758,0.6408857,1.1637137,12.7983111,14.2381773,3.0509328,49.8363985),(48884,'forelimb',255,3,80,2.3057712,99.8421857,125.0519906,1.8,100.009882,124.985497,1.3804035,1.2790453,1.8108134,0.6566681,0.975139,0.3705322,0.5385088,0.5134049,0.8929427,12.656143,14.3028672,2.1421338,48.7685029),(48885,'forelimb',255,3,81,1.8996372,99.7797471,124.9327383,1.8,99.9395021,124.9354902,1.4197082,1.2319461,1.6724561,0.4723993,0.790401,0.3094337,0.4725989,0.3834578,0.7451803,12.1641667,14.3028672,2.1421338,47.7616813),(48886,'forelimb',255,3,82,1.7156209,99.7374735,124.8348035,1.8,99.8859335,124.824364,1.4594886,1.256562,1.5582432,0.3831796,0.6919193,0.2824088,0.4440381,0.3049428,0.6768174,11.8412875,14.283491,1.2966289,47.6142357),(48887,'forelimb',255,3,83,1.6607349,99.737442,124.7583756,1.8,99.90246,124.732288,1.4817149,1.247567,1.5210122,0.3694186,0.7088309,0.2745985,0.4660258,0.2961113,0.6568701,11.6280342,14.4441652,2.1010121,47.2582705),(48888,'forelimb',255,3,84,1.7197611,99.7520734,124.6913254,1.8,99.963844,124.655558,1.4560012,1.2751347,1.4184477,0.4059056,0.6975847,0.2828663,0.4917945,0.3183237,0.7572621,11.6036301,14.4952048,1.3617734,47.3625303),(48889,'forelimb',255,3,85,1.8406669,99.7944143,124.6534566,1.8,99.963844,124.655558,1.4564253,1.2285926,1.3855166,0.4729612,0.7270279,0.3027824,0.5247341,0.3849618,0.8351182,11.5358134,14.6661522,2.1262901,48.1176465),(48890,'forelimb',255,3,86,2.0415799,99.8480925,124.6392531,1.8,99.9987694,124.6243368,1.5179009,1.1740168,1.348155,0.5882887,0.7905788,0.3393122,0.5864153,0.5010905,0.954349,11.6311836,14.6661522,2.1262901,51.0085539),(48891,'forelimb',255,3,87,2.3079532,99.9622242,124.6536752,1.8,100.1295808,124.6586272,-1.4425132,1.481599,1.7509383,0.8391144,0.9612264,0.3783634,0.5489779,0.5663573,0.9910088,5.6395378,12.644806,0.1707352,30.6605329),(48892,'forelimb',255,3,88,2.4613094,100.124903,124.6482185,1.8,100.2569526,124.6524888,-0.5736422,1.5857304,1.6399547,1.0671718,1.1935563,0.1208165,0.7277983,0.6729844,1.1957967,5.7776852,13.0047187,0.1325515,31.5199089),(48893,'forelimb',255,3,89,2.3782251,100.3707984,124.6256332,1.8,100.3788532,124.6655663,-0.2790494,1.5612211,1.6497245,1.256145,1.4850519,0.030072,0.9001817,0.8045914,1.3476383,6.2538665,13.145925,0.1973956,32.6309903),(48894,'forelimb',255,3,90,2.7135836,100.5560551,124.6682576,1.8,100.5548045,124.6563951,-0.3444943,2.11146,1.9193044,1.6748988,2.2311988,0.0515831,1.1625039,0.793242,1.7746552,6.6585923,13.6556983,0.2220819,34.0980369),(48895,'forelimb',255,3,91,3.4041064,100.6399382,124.688377,1.8,100.7112845,124.6537526,-0.3133229,2.1360569,2.2446049,2.6823746,3.3784388,0.0538986,1.5051374,1.2557599,2.4354317,7.3454983,14.4121737,0.1798535,36.5287193),(48896,'forelimb',255,3,92,3.8104642,100.8221258,124.688939,1.8,100.9255267,124.640212,0.2149685,2.355068,2.4163642,4.0965638,4.8930085,0.0288985,2.0249466,1.7394673,3.3023861,8.2890933,14.8351299,0.1746722,38.6034365),(48897,'forelimb',255,3,93,4.7431344,101.0256671,124.7007887,1.8,101.114003,124.6848261,0.401696,2.5845694,2.5027069,5.5134053,6.7563718,0.1208435,2.6996257,2.1332007,4.3002386,9.023448,15.3369125,0.1973956,40.4264483),(48898,'forelimb',255,3,94,5.4527359,101.0040329,124.644756,1.8,101.1685795,124.6428938,0.5298642,2.705942,2.8275079,6.5732305,8.7577726,0.2321461,3.0973468,2.4291838,4.8777989,9.453136,15.6821404,0.1651487,41.8934949),(48899,'forelimb',255,3,95,6.3815456,101.0273264,124.5303747,1.8,101.2166859,124.6133911,0.4830478,3.175088,2.8738022,8.0200244,10.6946405,0.2294613,3.7214254,2.5259219,5.8621249,9.6932128,15.9910916,0.1076899,42.8571307),(48900,'forelimb',255,3,96,9.0597135,101.0711791,124.4912077,1.8,101.2188678,124.593895,0.1911115,2.9917756,2.8827497,9.8670448,14.2471027,0.0544807,4.9421921,3.2980564,7.4210834,6.875008,8.4747721,0.5317241,24.7923465),(48901,'forelimb',255,3,97,9.5454069,100.8542707,124.5567185,1.8,100.9679994,124.579138,-0.0628505,2.6206054,2.6918888,10.4337824,11.6747509,0.0062761,4.3370108,3.9814398,7.1842701,5.7851551,7.1514336,0.5713375,20.3912067),(48902,'forelimb',255,3,98,7.4066436,100.4155104,124.660989,1.8,100.5800449,124.6590994,-1.4212524,2.2468075,2.6709242,5.1772163,7.5163111,1.2070395,2.8141236,2.3042545,4.5673165,4.726568,5.7808608,0.7328151,15.990067),(48903,'forelimb',255,3,99,4.5385848,100.1636628,124.7624957,1.8,100.309129,124.778326,-1.5126952,1.6856394,2.0446918,1.799319,3.6585402,0.7538802,1.7892869,1.06744,2.4905812,3.437504,4.6278814,1.1902899,12.4483032),(48904,'forelimb',255,3,100,1.621067,100.0944508,124.7695667,1.8,100.0793904,124.7485367,-1.5055009,0.9259798,1.5819293,0.3934569,0.7790598,0.2690276,0.4924745,0.4249087,0.7278534,2.14844,3.6712559,1.2120257,8.9065394),(48905,'forelimb',255,3,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48906,'forelimb',255,3,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48907,'forelimb',255,3,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48908,'forelimb',255,3,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48909,'forelimb',255,3,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48910,'forelimb',255,3,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48911,'forelimb',255,3,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48912,'forelimb',255,3,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48913,'forelimb',255,3,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48914,'forelimb',255,3,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48915,'forelimb',255,3,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48916,'forelimb',255,3,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48917,'forelimb',255,3,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48918,'forelimb',255,3,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48919,'forelimb',255,3,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48920,'forelimb',255,3,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48921,'forelimb',255,3,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48922,'forelimb',255,3,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48923,'forelimb',255,3,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48924,'forelimb',255,3,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48925,'forelimb',255,3,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48926,'forelimb',255,3,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48927,'forelimb',255,3,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48928,'forelimb',255,3,124,0.0891827,99.257928,122.2370708,1.8,99.257928,122.246236,1.4945994,0.0497615,0.6518005,0.0014757,0.0191371,0.0147777,0.0293604,0.0296556,0.0315327,2.14844,2.8824347,1.1071487,7.1877874),(48929,'forelimb',255,3,125,1.5007207,99.4683106,122.4683208,1.8,99.598715,122.5055305,-1.5618775,0.6565676,2.5726613,0.1380107,1.9585569,0.2501002,0.761296,0.2102003,0.8127866,3.867192,5.4351711,1.2490458,14.5230204),(48930,'forelimb',255,3,126,3.4669372,99.6048349,122.6657098,1.8,99.7735536,122.710299,-1.5592644,0.9545998,3.2366596,0.549147,8.1850911,0.577746,2.5288699,0.5752641,2.686273,7.2920472,12.2140278,2.2565258,32.9437697),(48931,'forelimb',255,3,127,5.4582748,99.7495336,122.6395742,1.8,99.8993463,122.685265,-1.5567534,1.2365867,4.1248831,1.2583134,17.4946608,0.9095331,4.2412501,1.0175699,4.5213785,12.3988984,15.0329403,0.5404195,53.2307167),(48932,'forelimb',255,3,128,6.8248857,99.9140032,122.3161117,1.8,100.0465319,122.5318521,-1.5705024,1.49266,4.8717289,2.1796763,24.1265237,1.1374808,4.9523535,1.4602631,5.3516657,13.6412196,15.8519352,0.5729661,51.7636701),(48933,'forelimb',255,3,129,7.9387748,100.0332942,122.1207649,1.8,100.1261635,122.3414761,-1.5617687,1.8018815,5.0736763,3.0812938,30.2259447,1.3230213,5.957405,1.7100424,6.497876,14.5164325,16.4688822,0.2639637,53.1875308),(48934,'forelimb',255,3,130,9.0585945,100.0839365,122.0519438,1.8,100.1968759,122.1825785,-1.5496291,1.7694813,5.1520367,4.1476119,36.3812405,1.5090894,7.0615259,2.3439705,7.7914536,14.9496671,16.9331967,0.6231993,53.5866819),(48935,'forelimb',255,3,131,10.6912429,100.0761429,122.1279256,1.8,100.231153,122.1305508,-1.5219506,1.7950608,5.5228135,5.1632232,47.1947863,1.7776258,8.5454246,2.87635,9.4337833,15.1495931,17.4010378,0.5743048,54.4460579),(48936,'forelimb',255,3,132,8.708969,100.103949,121.4973537,1.8,100.2362355,121.7973655,-1.5385771,1.7760951,6.1440595,4.714549,33.9440794,1.4499886,5.524699,2.6544463,6.2572821,15.2099008,17.533166,0.6287963,54.9494687),(48937,'forelimb',255,3,133,7.8987153,100.0528281,121.7195466,1.8,100.206205,121.9758289,-1.5036582,1.8001314,5.9378302,3.7774827,37.3448821,1.3105275,6.2893146,2.0984483,6.9100253,15.1608597,17.5384304,0.5404195,54.5935035),(48938,'forelimb',255,3,134,7.3772144,99.9998874,122.2666391,1.8,100.1987966,122.2943907,-1.5063809,1.7618986,5.8161572,3.0427741,37.4888979,1.224441,6.4456473,1.7269859,6.9548736,15.0845336,17.5384304,0.5404195,55.6613991),(48939,'forelimb',255,3,135,6.5004932,99.9600644,122.6370736,1.8,100.1524603,122.5860801,-1.5261919,1.4944965,5.4358776,2.4178343,32.7035742,1.0812615,6.0162455,1.6178253,6.4380061,15.0490225,17.4010378,0.5743048,55.5571393),(48940,'forelimb',255,3,136,5.8648004,99.9540763,122.9172238,1.8,100.0968427,122.8866757,-1.5361817,1.4802471,5.58025,2.121874,30.1041819,0.976296,5.394773,1.4334593,5.7516704,14.7133177,17.5384304,2.1112158,54.4460579),(48941,'forelimb',255,3,137,5.6006091,99.9736898,123.1353934,1.8,100.0964454,123.1786172,-1.5356861,1.4684582,5.3631522,2.0905394,28.2839557,0.9322847,5.273756,1.4236288,5.6363222,14.5293602,17.4010378,2.1451012,53.1264569),(48942,'forelimb',255,3,138,5.7339916,100.0117834,123.1698686,1.8,100.1132117,123.1690421,-1.5330447,1.4317097,5.3315148,2.1815503,29.2222743,0.9543039,5.4810454,1.5237379,5.8587914,14.1322321,17.1713991,2.1240907,51.9111157),(48943,'forelimb',255,3,139,5.7783032,100.0092933,123.2692527,1.8,100.1130914,123.286755,-1.5289523,1.433943,5.234332,2.1879054,29.1359513,0.9613653,5.566317,1.5257966,5.9535372,13.331721,16.1519256,2.070143,48.7253171),(48944,'forelimb',255,3,140,5.7857445,100.0211705,123.3469825,1.8,100.1130914,123.3583696,-1.5296429,1.4182896,5.1567875,2.1978727,28.5416821,0.9626585,5.5347796,1.5496642,5.9271834,12.6894912,15.0083566,1.9832068,46.0429293),(48945,'forelimb',255,3,141,5.8029768,100.017657,123.4205463,1.8,100.117304,123.4426222,-1.5280624,1.4198805,5.084006,2.1633283,28.9043357,0.9653976,5.6853465,1.5235988,6.0762998,12.1958801,14.5397175,0.5961991,43.7165067),(48946,'forelimb',255,3,142,5.8548975,100.0248024,123.5018581,1.8,100.1089605,123.4956686,-1.5169656,1.4160425,5.4379747,2.1629512,29.5286179,0.9729913,5.4300763,1.527462,5.805722,11.6883871,14.1862129,0.6132073,42.5011655),(48947,'forelimb',255,3,143,6.1378876,100.0319461,123.5531467,1.8,100.1002867,123.5672075,-1.5187224,1.405178,5.3862847,2.2916165,29.9159517,1.0202098,5.5540978,1.6308371,5.9545275,11.4157031,13.8570216,0.5191461,41.6417895),(48948,'forelimb',255,3,144,6.16161,100.040675,123.5937725,1.8,100.1042832,123.6503175,-1.5148727,1.3963155,5.3480734,2.333871,30.3225364,1.0237267,5.6698056,1.6714497,6.0812884,11.2793611,13.7096736,0.5619216,40.4264483),(48949,'forelimb',255,3,145,6.1349783,100.051726,123.6048848,1.8,100.1085349,123.6931446,-1.5109265,1.3866164,5.3395128,2.3726515,30.1955052,1.0188357,5.6551049,1.7111087,6.0754531,11.0082198,13.348021,0.5790743,38.8551419),(48950,'forelimb',255,3,146,6.3466894,100.0859781,123.6406548,1.8,100.1430853,123.6728002,-1.497459,1.6904284,5.3122636,2.5572072,30.2934219,1.0521026,5.7025449,1.5127569,6.1628201,10.8734205,13.1178053,0.551655,38.3517311),(48951,'forelimb',255,3,147,6.7342483,100.1049593,123.720703,1.8,100.1931313,123.7880576,-1.4857507,1.690842,5.2389044,2.8000147,31.1243764,1.1142764,5.9410087,1.6559884,6.4563548,10.8547918,12.9905136,0.5971767,38.3517311),(48952,'forelimb',255,3,148,7.1150933,100.1047652,123.758466,1.8,100.1931313,123.7880576,-1.4852337,1.6875257,5.2014708,3.0231945,32.3724724,1.1771885,6.2237151,1.7914953,6.7845203,10.6963626,12.6375032,0.6162969,37.4923551),(48953,'forelimb',255,3,149,7.4539765,100.1188973,123.7909687,1.8,100.190351,123.9091286,-1.4824178,1.6689279,5.1714588,3.2050067,33.208875,1.2326511,6.4215682,1.9203986,7.0197066,10.4643945,12.4905505,0.7123576,36.7804247),(48954,'forelimb',255,3,150,7.5140657,100.1334962,123.8647247,1.8,100.1989447,123.9392067,-1.475697,1.6839866,5.1020348,3.3262091,32.8661655,1.2410523,6.441776,1.9751993,7.0727756,10.3744347,12.1610055,0.5585993,36.0253085),(48955,'forelimb',255,3,151,7.5926182,100.1600461,123.9193202,1.8,100.2075385,124.0208474,-1.4689402,1.6501216,5.0529599,3.3940358,32.9031307,1.2523532,6.5116548,2.0568399,7.1620077,10.2214909,11.9388329,0.5280744,35.4176379),(48956,'forelimb',255,3,152,7.8318002,100.1829263,123.9756319,1.8,100.2236624,124.0989996,-1.4614832,1.6186629,5.0022509,3.5872235,34.0868364,1.2897646,6.8142997,2.2161646,7.5096076,10.0552132,11.7988288,0.5779019,35.0616727),(48957,'forelimb',255,3,153,8.1562486,100.2333475,123.967122,1.8,100.278437,124.07241,-1.4515954,1.8899758,5.0202245,3.9857388,34.5832369,1.3401509,6.8887829,2.1088835,7.6606748,10.0447974,11.7282,0.4964228,34.5582619),(48958,'forelimb',255,3,154,8.7131652,100.2486075,124.0262707,1.8,100.3280943,124.0501149,-1.4371171,1.9050681,4.9686291,4.3994554,36.7661703,1.4263975,7.3996609,2.3093429,8.2667386,9.9050289,11.7988288,0.5779019,34.4540021),(48959,'forelimb',255,3,155,9.0431526,100.2653283,124.0985211,1.8,100.352041,124.052517,-1.4253307,1.8665054,4.9031264,4.7084699,38.4202413,1.4755239,7.835866,2.5226125,8.7797637,9.7657088,11.7988288,0.5779019,34.2022967),(48960,'forelimb',255,3,156,9.2981682,100.3123843,124.1153775,1.8,100.3617137,124.1246427,-1.4071732,1.8677755,4.8987962,5.0477839,39.6683096,1.5085744,8.0975628,2.7025646,9.1151524,9.8020172,11.5697035,0.5467888,34.2022967),(48961,'forelimb',255,3,157,9.5521768,100.3456102,124.1335763,1.8,100.4280605,124.14914,-1.3949561,2.0961761,4.8895005,5.3709219,40.6667112,1.5433095,8.3171505,2.5622475,9.4046646,9.7057419,11.6887773,0.6287963,34.0980369),(48962,'forelimb',255,3,158,9.8967109,100.3833886,124.1827397,1.8,100.4808862,124.2422653,-1.3754814,2.1007355,5.2737899,5.9075628,42.4630763,1.5873247,8.0517193,2.8121402,9.1701132,9.6113822,11.5697035,0.5467888,33.5946261),(48963,'forelimb',255,3,159,9.9945657,100.404611,124.2192728,1.8,100.4808862,124.2422653,-1.368601,2.0636518,5.2428531,6.1982169,44.220058,1.5985827,8.43435,3.0035187,9.6149683,9.4196563,11.5697035,0.5467888,33.5946261),(48964,'forelimb',255,3,160,10.3495623,100.4429765,124.2292231,1.8,100.5576454,124.2366502,-1.3531755,2.3299001,5.2422744,6.8553404,46.7315163,1.644518,8.9143591,2.9423323,10.2215105,9.6113822,11.6887773,0.6287963,34.0980369),(48965,'forelimb',255,3,161,10.9627636,100.502618,124.2174299,1.8,100.6342724,124.1865459,-1.3372514,2.3437221,5.2677531,8.0693833,50.9259206,1.7292686,9.6674844,3.4429779,11.1991902,9.7587078,11.5697035,0.5467888,33.8463315),(48966,'forelimb',255,3,162,11.3657644,100.5578979,124.2369228,1.8,100.6902213,124.2319154,-1.3215785,2.5722988,5.2622622,8.9723372,53.1013005,1.7790561,10.0909645,3.4880618,11.7959978,9.7587078,11.7988288,0.5779019,34.4540021),(48967,'forelimb',255,3,163,11.8774741,100.5952171,124.2875966,1.8,100.7836318,124.2171962,-1.3068325,2.6047449,5.2225396,9.8380156,54.8183347,1.844822,10.49649,3.7769593,12.3800947,9.6932128,11.5697035,0.5467888,33.9505913),(48968,'forelimb',255,3,164,12.3181286,100.6111738,124.366222,1.8,100.7790862,124.3366524,-1.2979002,2.5528466,5.1506819,10.5729388,56.4988455,1.9038861,10.9691973,4.1416271,13.0215997,9.6572864,11.7282,0.4964228,34.5582619),(48969,'forelimb',255,3,165,12.5596046,100.6227702,124.4318071,1.8,100.8017356,124.4069528,-1.2945438,2.6349425,5.0905955,11.2566954,57.1687159,1.9375414,11.2302611,4.272084,13.4413774,9.7857699,11.5697035,0.5467888,34.5582619),(48970,'forelimb',255,3,166,12.8880813,100.6267706,124.5087582,1.8,100.800477,124.4487734,-1.2941055,2.609435,5.0176528,11.7289314,57.7707949,1.9877203,11.5135099,4.4948165,13.8510423,9.5451124,11.3440887,0.4297623,33.6988859),(48971,'forelimb',255,3,167,13.2379306,100.6463639,124.5538529,1.8,100.8374853,124.4672993,-1.2958608,2.6976698,4.9795667,12.1639132,57.9026119,2.043707,11.6280424,4.5090445,14.0703984,9.5776351,11.171888,0.3947911,33.6988859),(48972,'forelimb',255,3,168,13.5298726,100.6392179,124.6464324,1.8,100.8384587,124.5794719,-1.3044933,2.6900231,4.8878565,12.6305619,59.6280078,2.0988065,12.1992141,4.6953358,14.7802866,9.9508312,11.1470707,0.4808873,34.5582619),(48973,'forelimb',255,3,169,13.6396446,100.6251084,124.7571216,1.8,100.8243084,124.6918007,-1.3188885,2.6933437,4.7752205,12.7888301,59.5868942,2.1320434,12.4783545,4.7483097,15.145437,9.4196563,11.0137676,0.3587707,34.2022967),(48974,'forelimb',255,3,170,13.6577721,100.6026694,124.8136839,1.8,100.777182,124.8120872,-1.3401093,2.7290071,5.1283792,12.3446142,59.6447493,2.1572925,11.6303314,4.5234819,14.0291112,9.361211,11.0137676,1.929567,33.8031457),(48975,'forelimb',255,3,171,13.824668,100.5441314,124.8866711,1.8,100.6653119,124.8897513,-1.3756054,2.733072,5.0807662,11.7418007,60.0747203,2.217435,11.823949,4.2961915,12.8621197,9.6290896,10.980189,2.1045045,35.0184869),(48976,'forelimb',255,3,172,14.1159386,100.4940159,124.9322305,1.8,100.6051453,125.0489002,-1.3989991,2.4637469,4.9737048,11.0232456,59.7989549,2.2838999,12.0230205,4.4741794,14.1953985,9.1417086,11.0137676,1.929567,33.5514403),(48977,'forelimb',255,3,173,14.0857821,100.4280875,125.0125933,1.8,100.5201365,125.1029898,-1.4271604,2.1862986,4.8717345,10.0120786,59.4290789,2.2995279,12.1987517,4.5794653,14.185846,9.3047999,11.0137676,1.929567,33.1954751),(48978,'forelimb',255,3,174,13.9316985,100.3887988,125.095958,1.8,100.4962414,125.2422102,-1.4485262,2.2300839,4.772882,9.2179151,59.3639812,2.2874093,12.4377642,4.1334387,14.273632,9.115059,11.2048922,2.1375255,33.1954751),(48979,'forelimb',255,3,175,13.6064668,100.3404663,125.1647358,1.8,100.4526702,125.3186799,-1.4705961,2.244631,4.6862513,8.3310813,57.8636459,2.2450522,12.3475338,3.7115595,14.0045004,8.8112237,11.2048922,2.1375255,32.9437697),(48980,'forelimb',255,3,176,13.5241658,100.2884251,125.2096412,1.8,100.3881158,125.3858471,-1.4889459,1.9567646,4.6251339,7.6556772,56.4165014,2.2389605,12.1978094,3.9124161,13.7163717,8.7141048,11.2048922,2.1375255,32.3360991),(48981,'forelimb',255,3,177,13.2126416,100.2333219,125.2322642,1.8,100.3649208,125.4288403,-1.5118976,1.9922403,4.5830668,6.875147,53.97755,2.1944765,11.7776049,3.4509628,13.1225721,8.4220532,11.2048922,2.1375255,31.4767231),(48982,'forelimb',255,3,178,12.8143405,100.1961872,125.256277,1.8,100.3153341,125.5697793,-1.5376629,1.6460122,4.5381059,6.1834882,51.6301532,2.1333796,11.3770269,3.7566478,12.5516112,8.392812,11.2048922,2.1375255,31.1207579),(48983,'forelimb',255,3,179,12.6237782,100.1635465,125.3233128,1.8,100.3247396,125.6244727,-1.5517175,1.6749825,4.4589317,5.7755364,51.5151978,2.1031973,11.55326,3.4481174,12.6362747,8.2035531,11.4413255,2.1692152,31.1207579),(48984,'forelimb',255,3,180,12.2996655,100.124575,125.3729088,1.8,100.3078613,125.6594533,-1.5634976,1.7089998,4.3990756,5.2603117,49.6928557,2.049835,11.296204,3.078006,12.2730727,8.3400236,11.4413255,2.1692152,31.7284285),(48985,'forelimb',255,3,181,12.107033,100.0768518,125.4299331,1.8,100.2721465,125.7089019,1.5701169,1.7600531,4.3358694,4.8099169,48.7876833,2.0178379,11.2521109,2.7328249,12.1467607,7.8997178,11.4413255,2.1692152,30.8690525),(48986,'forelimb',255,3,182,11.6553565,100.0300859,125.3947199,1.8,100.2040679,125.6424238,1.5627024,1.3930257,4.368141,4.3018147,45.104521,1.9424322,10.3257932,3.0881087,11.1307269,7.8997178,11.2048922,2.1375255,30.2613819),(48987,'forelimb',255,3,183,11.1212671,99.9871968,125.3375977,1.8,100.1665391,125.5315588,1.5532319,1.4543804,4.1777477,3.8101972,40.5285419,1.8529727,9.7010506,2.6198078,10.4846075,7.8478858,11.0889478,2.1910458,30.2613819),(48988,'forelimb',255,3,184,10.5490765,99.9437018,125.2831061,1.8,100.1219243,125.4088321,1.544383,1.502642,5.8459201,3.3546994,37.2805387,1.7569531,6.3771893,2.2325341,6.9224831,8.2660287,10.980189,2.1045045,32.0843937),(48989,'forelimb',255,3,185,9.933917,99.8943879,125.2307699,1.8,100.0465319,125.4486754,1.5372699,1.160121,4.0816769,2.8487463,33.6094978,1.6537925,8.2342377,2.4555596,8.7758962,7.834692,10.8448348,2.1587989,29.6537113),(48990,'forelimb',255,3,186,9.3486902,99.8549802,125.1531971,1.8,100.0387025,125.3221733,1.5351608,1.2015934,3.9999253,2.5159618,30.291103,1.5561372,7.5729172,2.0938546,8.1494028,7.8804744,10.7679504,2.070143,29.0460407),(48991,'forelimb',255,3,187,8.8581291,99.8131367,125.1139749,1.8,100.0259953,125.307763,1.5332017,1.230132,3.9600415,2.218119,27.9634259,1.4742692,7.0613971,1.8031553,7.5816524,7.8997178,10.6125107,2.1251038,29.0460407),(48992,'forelimb',255,3,188,8.2618804,99.7678748,125.0475243,1.8,100.0112771,125.1842975,1.535984,1.2681839,3.890909,1.890827,25.3315936,1.375312,6.5104565,1.4909723,6.9641899,7.8997178,10.4635866,1.9055332,28.7943353),(48993,'forelimb',255,3,189,7.5497053,99.7133835,124.9719585,1.8,99.8894392,125.0457184,1.5410744,1.2862786,3.8117992,1.4655452,22.5827463,1.257173,5.9244323,1.1393684,6.2836191,7.8997178,10.2496576,2.1471715,28.7943353),(48994,'forelimb',255,3,190,6.8647214,99.6701337,124.8684268,1.8,99.8355414,124.9617233,1.5461528,0.9253235,3.7054456,1.2028786,19.5625669,1.1434255,5.27941,1.2999546,5.5831244,7.8997178,10.0587382,1.9195673,28.1866647),(48995,'forelimb',255,3,191,6.1349783,99.6311252,124.7317338,1.8,99.8283759,124.8021388,1.5521863,0.9499667,3.5660462,0.9843138,16.2892268,1.0221423,4.5678675,1.0361561,4.8260532,7.8997178,9.9942879,2.0152155,27.5789941),(48996,'forelimb',255,3,192,5.3106813,99.5835529,124.5489508,1.8,99.7849038,124.5770907,1.5629428,0.9764318,3.495408,0.7475992,12.9802113,0.885059,3.7135039,0.7656441,3.907499,8.1097181,9.8172189,1.9756881,27.8306995),(48997,'forelimb',255,3,193,4.4059296,99.5309839,124.3291634,1.8,99.7067132,124.3517072,1.5657509,1.0210846,3.286753,0.5179227,9.7232841,0.7343029,2.9583251,0.5072281,3.1038751,8.164072,9.5115493,1.8925469,27.5789941),(48998,'forelimb',255,3,194,3.7273799,99.4915569,124.1503954,1.8,99.6231628,124.2228008,1.5618279,0.6408722,3.4100256,0.3745976,7.5721097,0.62118,2.2205434,0.5845121,2.3262746,7.734384,9.4335845,2.0955921,27.4747343),(48999,'forelimb',255,3,195,3.1116609,99.4605418,123.9705971,1.8,99.5947105,124.0404737,1.5649001,0.6656512,3.2294076,0.2819059,5.6766343,0.5185921,1.7577943,0.4235039,1.8421138,7.734384,9.2557628,1.9513027,26.8670637),(49000,'forelimb',255,3,196,2.5262663,99.4312287,123.7945564,1.8,99.5704284,123.7892065,1.5657545,0.6927897,3.0530634,0.2017169,4.0722071,0.4210337,1.3338102,0.2911661,1.3980118,8.164072,9.1049255,1.9074711,26.9713235),(49001,'forelimb',255,3,197,2.0052689,99.4013731,123.6198265,1.8,99.534156,123.5353,1.5628271,0.7217181,2.8785503,0.1365454,2.8416201,0.3341903,0.9871705,0.1891949,1.0337005,8.0183974,9.1049255,1.9074711,26.7196181),(49002,'forelimb',255,3,198,1.5833014,99.3640176,123.4715506,1.8,99.4260668,123.4512306,1.5640711,0.3361661,2.8559434,0.0789511,2.1263965,0.2638716,0.7445513,0.2348573,0.7714537,7.734384,9.1856803,1.7590178,26.9713235),(49003,'forelimb',255,3,199,1.2455931,99.344819,123.3403549,1.8,99.4083188,123.320456,1.5623334,0.3538622,2.5986692,0.0564843,1.5350059,0.207584,0.5906892,0.1596224,0.6122342,7.734384,9.3845276,1.2924967,26.7196181),(49004,'forelimb',255,3,200,0.9622673,99.3227097,123.2446067,1.8,99.3936189,123.2526105,1.5640521,0.3730801,2.6534801,0.0376998,1.193701,0.1603706,0.4498624,0.1010502,0.463845,7.734384,9.6081158,1.1071487,27.2230289),(49005,'forelimb',255,3,201,0.7505002,99.3088922,123.1846049,1.8,99.3843068,123.1688014,1.551118,0.3928873,2.4428069,0.0261733,0.835905,0.1250349,0.3421904,0.0666179,0.3529046,7.5958825,9.6560368,1.0074801,27.3272887),(49006,'forelimb',255,3,202,0.6439173,99.3052314,123.0305501,1.8,99.3725115,122.9480597,1.5516181,0.3932351,2.2887084,0.0216989,0.661481,0.1072801,0.2890193,0.0551804,0.2984998,7.5958825,9.9942879,1.1263771,27.5789941),(49007,'forelimb',255,3,203,0.5437686,99.3013875,122.9145094,1.8,99.3725115,122.9480597,1.5487833,0.3961154,2.1726117,0.0175921,0.5738682,0.0905842,0.2641375,0.0444115,0.2722341,7.5958825,10.2496576,0.9944211,27.8306995),(49008,'forelimb',255,3,204,0.4381928,99.257928,122.2954482,1.8,99.257928,121.7339157,1.5648749,0.0244629,4.1311758,0.0067819,1.1452222,0.0730296,0.2772146,0.2772338,0.2788514,7.5958825,11.0889478,0.9505468,29.2977461),(49009,'forelimb',255,3,205,0.6231602,99.2941533,120.4545319,1.8,99.3165218,120.3321713,-1.5565386,0.360769,4.1550822,0.0174412,3.7344817,0.1038389,0.8987744,0.0483445,0.9029582,7.5631659,12.1610055,1.012197,30.7647927),(49010,'forelimb',255,3,206,0.9293133,99.3854633,119.047919,1.8,99.4329861,119.4214353,-1.5320021,0.6803501,5.1329982,0.0599255,5.0510611,0.1546526,0.9840372,0.0880803,0.9956149,7.2920472,12.89064,0.9272952,32.3360991),(49011,'forelimb',255,3,207,1.1595995,99.4536365,118.4673202,1.8,99.5098141,119.0383928,-1.5122233,0.9982747,5.285221,0.1061253,4.7348431,0.1926043,0.8958647,0.1063087,0.9157318,7.2920472,13.2369013,0.9467733,32.9437697),(49012,'forelimb',255,3,208,1.4408552,99.5270232,118.1227212,1.8,99.5704284,118.7240965,-1.4892257,0.949935,5.6306374,0.1818018,4.8316198,0.2385482,0.8580947,0.1913834,0.8898744,7.467281,13.7567282,0.8960554,34.4108163),(49013,'forelimb',255,3,209,1.8179516,99.6358307,117.8743428,1.8,99.7427042,118.3514999,-1.4441499,1.2581756,5.4502278,0.3316948,4.5669259,0.2981581,0.837933,0.2636315,0.8973133,7.2695682,14.3608389,0.8913825,35.0184869),(49014,'forelimb',255,3,210,2.215973,99.7287112,117.753595,1.8,99.8133783,118.1642,-1.3942889,1.4973403,5.1400225,0.4922287,4.7809901,0.3579414,0.9301496,0.3287354,1.0221992,7.2695682,14.6975909,0.9097532,35.6261575),(49015,'forelimb',255,3,211,2.5878661,99.80711,117.7622326,1.8,99.9398242,118.0614485,-1.3494431,1.459814,5.1239784,0.6925789,5.4820183,0.4105209,1.0698754,0.4744296,1.1971248,6.9882119,15.240301,0.8652281,36.5897933),(49016,'forelimb',255,3,212,3.0033436,99.8294579,117.8305354,1.8,99.9419211,118.1466617,-1.3335987,1.4092256,5.0528454,0.8290869,6.2485157,0.4729188,1.2366331,0.588328,1.3898347,7.1885817,15.5698916,0.8831251,37.4491693),(49017,'forelimb',255,3,213,3.440809,99.8682975,117.8837384,1.8,100.0038015,118.1479854,-1.3159569,1.6499488,4.9991895,0.9995013,7.5149788,0.5370246,1.5032394,0.6057772,1.6880094,7.1763826,16.4183554,0.8224183,38.9162159),(49018,'forelimb',255,3,214,3.8432503,99.8890549,117.9859557,1.8,100.0569969,118.1868152,-1.3121601,1.5981374,4.9030952,1.1477792,8.9264746,0.5986411,1.8205795,0.7181981,2.0371573,7.1075923,16.7357822,0.7309067,39.8798517),(49019,'forelimb',255,3,215,4.2098843,99.8928406,118.1182589,1.8,100.0750396,118.276905,-1.3224247,1.5779941,4.7821379,1.2262791,10.4984121,0.6592466,2.1953386,0.7771126,2.4352587,7.1365101,17.321277,0.7678561,41.0951929),(49020,'forelimb',255,3,216,4.6694495,99.8494331,118.3029416,1.8,100.0490996,118.409736,-1.350551,1.6267025,4.6062279,1.235109,11.9641552,0.7410971,2.5973867,0.7592716,2.8534011,7.096608,17.6224473,0.7853982,42.0588287),(49021,'forelimb',255,3,217,5.1344419,99.8441194,118.4745568,1.8,100.0233098,118.5133215,-1.3669908,1.3801321,4.4434546,1.283766,13.6528495,0.8206851,3.0725755,0.9301761,3.3528164,7.096608,17.9494415,0.7345945,42.3105341),(49022,'forelimb',255,3,218,5.6450327,99.8425142,118.6569299,1.8,100.0445876,118.6269409,-1.3834706,1.3647116,4.2686392,1.3871362,14.8908415,0.9082082,3.4884283,1.0164318,3.8085997,7.0823427,17.9905393,0.7008544,45.2446273),(49023,'forelimb',255,3,219,6.4280952,99.8647278,118.8105533,1.8,100.0681968,118.7841784,-1.3998677,1.3361423,4.1239698,1.6507669,16.8958085,1.0403517,4.0969768,1.2354724,4.4960427,6.9716035,18.3210418,0.6857295,47.0676391),(49024,'forelimb',255,3,220,7.2957527,99.9139205,118.9298289,1.8,100.117304,118.8746175,-1.413021,1.3536134,4.0148119,2.0060762,19.1712612,1.1859402,4.7751331,1.4820156,5.2746955,7.0106263,18.8769524,0.7209713,47.2150847),(49025,'forelimb',255,3,221,8.1678301,99.9776165,119.051882,1.8,100.1608167,118.9474288,-1.4213479,1.3446337,3.9032517,2.5090009,21.0538533,1.3311262,5.3939267,1.8659363,6.0328403,6.9029433,19.201814,0.7061991,46.3557087),(49026,'forelimb',255,3,222,8.8500725,100.0740611,119.1620461,1.8,100.284124,119.0185208,-1.425877,1.537371,3.8074957,3.2537469,22.1231861,1.4442507,5.8104298,2.1164357,6.6484086,6.8986736,19.5967879,0.6610432,47.3193445),(49027,'forelimb',255,3,223,9.6214417,100.2023156,119.254149,1.8,100.3881943,119.1450096,-1.4310975,1.6455502,3.7326921,4.2345179,23.2778904,1.5724817,6.2362204,2.5733143,7.3225015,6.9554958,20.0300987,0.6177557,47.5710499),(49028,'forelimb',255,3,224,10.5302217,100.3205537,119.2941632,1.8,100.4574737,119.2607996,-1.4487894,1.7327796,3.6991953,5.781927,23.2626305,1.7290414,6.2885651,3.3367931,7.7445986,7.1516065,20.3818914,0.6055447,48.8295769),(49029,'forelimb',255,3,225,11.1325129,100.4883401,119.2600171,1.8,100.6396698,119.204719,-1.4395683,1.9560847,3.3345415,7.8572019,21.5445582,1.82365,6.4610256,4.0168005,8.5734659,7.1140164,21.2250215,0.5543075,51.2602593),(49030,'forelimb',255,3,226,11.5314294,100.6550613,119.3140646,1.8,100.8150542,119.2561594,-1.4230106,2.2284392,3.3184371,10.1412407,20.1266959,1.880234,6.0651129,4.5508268,8.7906187,7.3735552,21.8169824,0.560687,53.5866819),(49031,'forelimb',255,3,227,12.1581144,100.7842619,119.4359683,1.8,100.9470463,119.4310388,-1.4237079,2.5070397,3.2161439,12.9855764,19.7148821,1.9828275,6.1299751,5.1796452,9.6508165,7.6076314,22.4961264,0.4978223,56.3733294),(49032,'forelimb',255,3,228,12.6702158,100.9117164,119.6651727,1.8,101.1038676,119.6217017,-1.4965956,2.7156712,2.9108138,16.2747866,20.1152039,2.1000975,6.9105087,5.9929149,11.2024293,8.2619802,22.874581,0.4888524,59.559128),(49033,'forelimb',255,3,229,14.9524325,101.0180473,120.3136288,1.8,101.2051846,120.7721329,1.4797144,2.6435838,4.2743217,21.4516788,35.5480229,2.4714551,8.3166465,8.1146204,12.9860354,8.6070663,22.9068442,0.4048918,60.2099845),(49034,'forelimb',255,3,230,21.3913258,101.3212139,121.3446583,1.8,101.5313681,121.38686,1.5442858,3.1306293,4.1136558,38.8471456,81.8580591,3.5627159,19.8991028,12.4087339,26.1744846,9.3618851,23.139407,0.3805064,61.0693605),(49035,'forelimb',255,3,231,23.0782448,101.458252,121.7742617,1.8,101.6565661,121.7376812,1.5578451,2.9857429,4.1233044,46.4626182,98.1589494,3.845729,23.8058942,15.5614932,30.9380428,9.6432513,18.1285566,0.5485494,49.3761735),(49036,'forelimb',255,3,232,23.9512734,101.5980263,122.0018733,1.8,101.7203033,121.8753013,-1.560165,3.2505441,4.2742187,51.8582048,108.4509461,3.9914277,25.3732795,15.9536997,32.938854,9.9654612,17.2946084,0.4636476,48.9770225),(49037,'forelimb',255,3,233,26.0223384,101.6589335,122.2093201,1.8,101.6711961,122.1225911,-1.5198744,2.89572,4.4780231,54.5373662,111.3391933,4.32582,24.8634698,18.8337841,34.7920195,9.8854524,16.9495441,0.5317241,48.2650921),(49038,'forelimb',255,3,234,23.0819375,101.5074843,122.4483983,1.8,101.6257831,122.3276025,-1.5212743,3.0313859,4.2952109,47.276848,93.7778807,3.8375628,21.833126,15.5957866,29.150223,9.6603265,16.2146739,0.5585993,46.6937857),(49039,'forelimb',255,3,235,19.717387,101.3498138,122.5939111,1.8,101.5091642,122.514534,1.547931,3.0469579,4.0468049,36.1159509,69.7408985,3.2845134,17.2335708,11.8531177,23.4508007,8.3548025,10.1410009,2.5065659,30.6605329),(49040,'forelimb',255,3,236,14.7736194,101.1472941,122.8069475,1.8,101.3431786,122.759334,1.3379784,2.7197714,4.1172117,23.4436422,42.9054805,2.3311987,10.4210043,8.6197106,15.689448,7.4006888,9.798394,2.4805495,27.6221799),(49041,'forelimb',255,3,237,9.6995465,100.9001826,123.1458485,1.8,101.0599529,122.8807753,1.194983,2.4052714,4.0376323,11.7078369,20.9799833,1.3988194,5.1961105,4.8675741,8.0884234,6.3433159,8.9412281,2.5269297,24.1846759),(49042,'forelimb',255,3,238,6.1696107,100.5588299,123.2644031,1.8,100.7396108,123.0438752,1.0228512,2.0350024,3.1972999,4.8608332,7.8963405,0.7492247,2.4696903,2.388613,3.9548333,4.9990532,7.9230552,2.4329664,19.7835362),(49043,'forelimb',255,3,239,2.7148145,100.0514202,123.0046655,1.8,100.278437,123.0160937,1.006349,1.4355647,2.3358914,0.9680807,2.0501403,0.3229858,0.8776693,0.6743553,1.2589259,3.6460236,5.9694165,2.6135182,14.6272802),(49044,'forelimb',255,3,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49045,'forelimb',255,3,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49046,'forelimb',255,3,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49047,'forelimb',255,3,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49048,'forelimb',255,3,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49049,'forelimb',255,3,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49050,'forelimb',255,3,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49051,'forelimb',255,3,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49052,'forelimb',255,3,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49053,'forelimb',255,3,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49054,'forelimb',255,3,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49055,'forelimb',255,3,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49056,'forelimb',255,3,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49057,'forelimb',255,3,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49058,'forelimb',255,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49059,'forelimb',255,3,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49060,'forelimb',255,3,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49061,'forelimb',255,3,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49062,'forelimb',255,3,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49063,'forelimb',255,3,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49064,'forelimb',255,3,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49065,'forelimb',255,3,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49066,'forelimb',255,3,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49067,'forelimb',255,3,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49068,'forelimb',255,3,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49069,'forelimb',255,3,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49070,'forelimb',255,3,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49071,'forelimb',255,3,267,0.1421105,111.1294969,128.1559685,1.8,111.1602856,128.1329616,-0.2176063,0.4914529,0.7524266,0.0137045,0.0338258,0.001104,0.0449557,0.0278857,0.0595294,1.289064,2.14844,0.6435011,4.757105),(49072,'forelimb',255,3,268,4.7659616,110.5118857,127.5404518,1.8,109.9370545,127.1364008,0.2150598,2.7929018,4.4837631,4.4427036,12.9750116,0.0361753,2.8937773,1.5907124,3.5416034,5.1172477,7.7463106,2.5535901,23.1778543),(49073,'forelimb',255,3,269,23.2274049,109.857816,125.7650676,1.8,109.8542265,125.4977556,0.4871811,3.9919738,4.2347725,63.9212126,89.5859599,0.848389,21.1548461,16.0124331,35.5471783,7.734384,8.8582451,1.9693188,25.7559823),(49074,'forelimb',255,3,270,31.6868973,109.8079632,125.1992201,1.8,109.9441475,125.258591,0.9476843,3.9457288,4.3763713,85.6207844,107.5009403,3.482663,24.5639442,21.6996119,43.95069,7.734384,9.1049255,1.9074711,26.6153583),(49075,'forelimb',255,3,271,28.2455288,110.0439927,125.2214112,1.8,110.1470032,125.1970207,1.2368947,3.8292147,4.2625934,77.5331884,94.837551,4.2019554,22.2487911,20.2478041,40.432882,7.734384,8.9721488,1.8622531,26.1119475),(49076,'forelimb',255,3,272,22.6175046,110.059389,125.2330923,1.8,110.1255233,125.1846666,1.4814413,3.5038569,4.1196823,55.2598366,76.6068716,3.7395665,18.5953348,15.7711454,31.8584386,7.304696,8.689902,1.7196863,25.5042769),(49077,'forelimb',255,3,273,16.1236693,109.8826331,125.4237764,1.8,110.0312366,125.2530799,1.4016084,3.3624966,3.8924196,34.4944323,50.1505668,2.6110873,12.8841626,10.2585775,21.4566256,6.44532,8.1527566,1.8925469,23.3252999),(49078,'forelimb',255,3,274,14.0680462,109.8302959,125.4249248,1.8,109.965753,125.327099,1.3913378,3.1187678,3.8082052,27.0126321,41.946523,2.2699704,11.014775,8.6613155,17.9954092,6.44532,7.9230552,1.7894653,22.8218891),(49079,'forelimb',255,3,275,12.9920906,109.833562,125.4003552,1.8,109.9569192,125.3296675,1.4202446,2.8967059,3.4992114,22.7948166,36.6386157,2.1166387,10.4705351,7.8692203,16.7368892,5.585944,7.5041783,1.801887,20.9988773),(49080,'forelimb',255,3,276,13.0186664,109.8512215,125.4069601,1.8,109.9649489,125.3281795,1.4322303,2.8110409,3.4413458,21.7752499,33.6891503,2.1283828,9.7895279,7.7463298,16.0788485,5.585944,7.3425118,1.929567,20.6429122),(49081,'forelimb',255,3,277,13.0634815,109.8641396,125.3970639,1.8,110.0080364,125.3713595,1.4701865,2.7794924,3.3349933,21.3354105,31.4608802,2.1552824,9.4335662,7.6760096,15.6739129,5.585944,6.9948139,1.7561443,20.1395013),(49082,'forelimb',255,3,278,13.2099001,109.8746226,125.3860216,1.8,109.9867002,125.3963861,1.4758351,2.7650791,3.1701505,22.2136381,30.6789984,2.1818559,9.6774579,8.0336355,16.305671,5.585944,6.9418221,1.9513027,19.7835362),(49083,'forelimb',255,3,279,13.7372756,109.8873369,125.3809098,1.8,109.975806,125.3689057,-1.5361394,2.9051264,3.1198124,24.4548409,30.3539512,2.2867971,9.7294156,8.4178232,17.2108254,6.015632,6.7939638,1.2490458,19.8877959),(49084,'forelimb',255,3,280,14.1924769,109.9381567,125.3216877,1.8,110.0633174,125.2919656,-0.8305105,2.9178856,3.2856093,28.3375905,31.8986664,1.289271,9.7086,9.7116866,18.182545,6.3805413,6.9418221,1.1902899,20.4954665),(49085,'forelimb',255,3,281,15.2713419,110.0772118,125.2550162,1.8,110.211488,125.2412775,-0.2942178,3.0609035,3.8144328,29.6637404,42.4238557,0.2140405,11.1219303,9.6911713,18.7499466,6.3433159,7.5041783,2.910502,21.9625131),(49086,'forelimb',255,3,282,15.9448562,110.0260007,125.2536411,1.8,110.2443717,125.1952526,-0.2513203,3.0085276,3.987682,30.2646245,48.4535913,0.1643469,12.1508162,10.0596133,19.7358818,6.3231965,7.7463106,2.8023,22.2142185),(49087,'forelimb',255,3,283,16.8292984,109.9963353,125.2148919,1.8,110.2588177,125.1444377,-0.2480426,2.8518768,4.1121183,30.8238906,56.5033345,0.1690605,13.7406881,10.8082827,21.0994372,6.005769,8.0272343,0.2709469,22.4659239),(49088,'forelimb',255,3,284,17.2809189,109.9096438,125.2049418,1.8,110.199781,125.1390345,-0.2424232,2.8838476,4.1911827,30.9416117,61.5663071,0.1659738,14.6894829,10.7292813,21.9390319,6.005769,8.1527566,0.3217506,22.4659239),(49089,'forelimb',255,3,285,17.1906731,109.7515361,125.214232,1.8,110.0972936,125.1169405,-0.253567,2.8045714,4.3514555,30.1127134,62.1791972,0.1803015,14.2892871,10.737011,21.1269931,5.93485,8.2986537,0.3708913,22.9693347),(49090,'forelimb',255,3,286,17.678157,109.6394661,125.2163683,1.8,109.974475,125.1183048,-0.2808714,2.8197073,4.4686094,30.1285051,63.8899397,0.2263863,14.2974991,10.6849761,21.0102657,5.93485,8.4420297,0.2573237,23.0735945),(49091,'forelimb',255,3,287,17.967861,109.5011059,125.2322342,1.8,109.8511407,125.1039851,-0.2805573,2.723933,4.4869016,29.5494177,64.5324117,0.2295956,14.3823996,10.8480705,20.9477794,5.863931,8.4420297,0.2573237,23.0735945),(49092,'forelimb',255,3,288,18.0246493,109.3182359,125.2386484,1.8,109.6296317,125.1225149,-0.2959811,2.7598199,4.3744347,28.0999676,63.365958,0.2555785,14.4855194,10.181812,20.8822673,5.8374863,8.3430318,0.6022873,22.9693347),(49093,'forelimb',255,3,289,17.8898121,109.0826669,125.1913804,1.8,109.3385449,125.0846776,-0.3000495,2.7452268,4.3028875,25.7315573,60.0388335,0.260476,13.9531498,9.373199,19.7248073,5.813695,8.2652137,0.4868992,22.4659239),(49094,'forelimb',255,3,290,17.6883957,108.82425,125.2468962,1.8,109.0183409,125.1666155,-0.2651807,2.7851997,4.0150596,23.5726822,52.0832614,0.2024963,12.9719772,8.4635518,18.7202807,5.585944,7.7463106,0.3392926,20.9988773),(49095,'forelimb',255,3,291,16.4358649,108.3797801,125.346277,1.8,108.4163421,125.2815961,-0.2314834,2.8032938,3.5176442,22.1553094,36.4111663,0.1441816,10.3510089,7.9033135,16.5583585,5.585944,7.086596,0.2449787,19.8877959),(49096,'forelimb',255,3,292,15.9338902,108.0885805,125.4232315,1.8,108.1459948,125.4218069,-0.1406916,2.7454113,3.2830922,21.4045417,30.381894,0.0522203,9.2540484,7.796479,15.6813145,5.585944,6.6705516,0.2606024,19.2801253),(49097,'forelimb',255,3,293,15.5692145,107.8579324,125.4796245,1.8,107.9211964,125.4625771,-0.0023416,2.5693901,3.0130209,20.6034735,26.8806701,0.0000142,8.9215015,8.0188186,15.1942344,5.156256,6.5023593,0.1325515,18.6724547),(49098,'forelimb',255,3,294,15.3589581,107.6404605,125.5395749,1.8,107.6448012,125.5261877,0.1871406,2.5842578,2.9207976,19.9301953,25.6354173,0.0886075,8.776855,7.7121545,15.3564301,5.156256,6.2563517,2.863293,18.3164896),(49099,'forelimb',255,3,295,15.2334644,107.451595,125.5964275,1.8,107.4672303,125.5625874,0.3446716,2.6068405,2.9330036,19.0611141,25.1065493,0.2898624,8.5600131,7.3119602,14.8830303,5.156256,6.3442673,2.6476513,17.708819),(49100,'forelimb',255,3,296,15.148254,107.2599063,125.6553029,1.8,107.2469419,125.6280397,0.41362,2.5485096,3.0260758,18.1187825,25.077282,0.4078544,8.2870633,7.1095603,14.2476739,5.156256,6.3877713,2.7985687,18.0647842),(49101,'forelimb',255,3,297,15.0263411,107.0789657,125.7096616,1.8,107.054161,125.6674639,0.4769995,2.5107949,3.0696982,17.1643342,25.1328641,0.5278933,8.1874057,6.8362151,13.7655156,5.156256,6.5589027,2.5899377,17.708819),(49102,'forelimb',255,3,298,14.9322908,106.9222008,125.7733182,1.8,106.8946556,125.7748859,0.5077731,2.4287844,2.9663838,16.4607271,25.6600427,0.5883871,8.6502774,6.777352,13.9102415,5.3814141,6.44532,2.4980915,18.4207493),(49103,'forelimb',255,3,299,14.9076173,106.7616512,125.8311289,1.8,106.7838813,125.8408647,0.5171795,2.560226,3.0179517,16.0463574,26.1693508,0.6073897,8.6712292,6.267555,13.9143872,5.4367103,6.5589027,2.5899377,18.4207493),(49104,'forelimb',255,3,300,14.8225188,106.6094369,125.890601,1.8,106.6320351,125.9184158,0.5335302,2.4747492,3.0576816,15.5074099,26.3227598,0.6389731,8.6087314,6.2662551,13.6513633,5.3643822,6.5589027,2.5899377,18.0647842),(49105,'forelimb',255,3,301,14.8345479,106.4544938,125.9505334,1.8,106.4370229,125.9746057,0.5246138,2.4476195,3.024733,15.0324343,27.0244522,0.6202809,8.9344919,6.1416548,13.6541268,5.156256,6.7119411,2.4468544,18.3164896),(49106,'forelimb',255,3,302,14.8761739,106.3160828,126.0085674,1.8,106.3395798,126.0330665,0.5292503,2.3538446,3.0965027,14.7727442,27.6969223,0.6320147,8.944582,6.2760066,13.5037218,5.156256,6.7939638,2.536048,18.0647842),(49107,'forelimb',255,3,303,14.9202058,106.1880724,126.0732612,1.8,106.2371028,126.1101728,0.5250552,2.4133185,3.1725051,14.5537516,28.250932,0.6248143,8.9049288,6.0305973,13.3626213,5.156256,6.7939638,2.536048,18.0647842),(49108,'forelimb',255,3,304,14.8787476,106.0551222,126.1323648,1.8,106.0436931,126.1035121,0.5129613,2.3720405,3.0893735,14.2632002,28.4979594,0.5972451,9.2245107,6.0130508,13.6735778,5.156256,6.725681,2.677945,17.8130787),(49109,'forelimb',255,3,305,14.7177263,105.9188924,126.1505383,1.8,105.8784285,126.1530915,0.5029899,2.2440639,3.190594,13.7590549,28.8546607,0.5699919,9.0436643,6.1313117,13.3560371,4.9979624,6.9285108,2.6224465,18.0647842),(49110,'forelimb',255,3,306,14.5722029,105.81835,126.2089796,1.8,105.8421697,126.1893503,0.487452,2.3426668,3.2154377,13.6411642,28.7946224,0.5327991,8.9551175,5.8229211,13.189721,5.156256,6.9285108,2.6224465,18.0647842),(49111,'forelimb',255,3,307,14.4609762,105.7220819,126.2717604,1.8,105.703248,126.2298702,0.4777085,2.2576834,3.2729901,13.2442052,28.9207867,0.5094261,8.8361975,5.866281,12.8634405,4.9979624,6.9418221,2.7610863,18.4207493),(49112,'forelimb',255,3,308,14.3802977,105.6259953,126.3326169,1.8,105.6146864,126.3249919,0.461788,2.3446109,3.1998859,13.1091702,28.5091147,0.4757826,8.9094161,5.5911922,12.9923303,5.156256,6.9418221,2.7610863,18.4207493),(49113,'forelimb',255,3,309,14.2785824,105.532546,126.3857462,1.8,105.4986347,126.3657844,0.4613294,2.2425683,3.2009709,12.8212346,28.1429437,0.4715469,8.7920024,5.7172103,12.7541192,4.9968715,6.9285108,2.6224465,18.0647842),(49114,'forelimb',255,3,310,14.2782467,105.4644202,126.449591,1.8,105.4833289,126.4872904,0.4636691,2.3290946,3.2339592,12.7888364,28.2602525,0.4759825,8.7385927,5.4909047,12.6758539,4.8613648,6.9285108,2.6224465,17.8130787),(49115,'forelimb',255,3,311,14.3088508,105.3928504,126.5081896,1.8,105.4102789,126.5626473,0.4576101,2.2259304,3.2711932,12.8540404,28.490184,0.4654955,8.7094165,5.7746821,12.6324576,4.9979624,6.9418221,2.7610863,18.4207493),(49116,'forelimb',255,3,312,14.2179896,105.3156506,126.5579415,1.8,105.3194809,126.5906769,0.4585476,2.3097851,3.3184919,12.756702,28.2729281,0.4643019,8.5198123,5.5228957,12.3636547,5.156256,6.9418221,2.7610863,18.4207493),(49117,'forelimb',255,3,313,14.1119662,105.247659,126.6072662,1.8,105.2471177,126.6257483,0.4527575,2.3821522,3.1699044,12.6471958,28.1028223,0.4500771,8.8655109,5.3091467,12.712182,4.8613648,6.7939638,2.536048,18.1690439),(49118,'forelimb',255,3,314,13.9968791,105.1788824,126.6517437,1.8,105.1856693,126.6537932,0.4446783,2.2722433,3.2161397,12.5658888,28.0617994,0.4316733,8.7253049,5.5301687,12.5035885,4.9979624,6.9418221,2.7610863,18.4207493),(49119,'forelimb',255,3,315,13.9022693,105.1075217,126.6928914,1.8,105.0912681,126.696111,0.4458728,2.3389724,3.2451464,12.5895945,27.7157691,0.4309071,8.5406837,5.3825322,12.3145388,5.1272215,6.9285108,2.6224465,18.4207493),(49120,'forelimb',255,3,316,13.8514676,105.0441691,126.7270333,1.8,105.0385744,126.7344614,0.4490665,2.2367806,3.28874,12.4518998,27.6885998,0.4350846,8.4192121,5.5668848,12.1339974,4.9876057,6.9285108,2.6224465,18.0647842),(49121,'forelimb',255,3,317,13.8544329,104.9834539,126.7548991,1.8,104.9744972,126.73046,0.4560834,2.2503782,3.1441532,12.4424103,27.7015372,0.4479212,8.8104923,5.5290307,12.7609342,4.8613648,6.725681,2.677945,17.5613733),(49122,'forelimb',255,3,318,13.8763089,104.928189,126.7842142,1.8,104.9676221,126.7682725,0.4574724,2.3207772,3.1806408,12.4648927,27.7498386,0.4511717,8.7246061,5.3709993,12.6279638,4.8613648,6.725681,2.677945,17.5613733),(49123,'forelimb',255,3,319,13.8942686,104.8661681,126.8145982,1.8,104.8605266,126.8112546,0.4511913,2.2669141,3.2241383,12.635086,28.1351093,0.440284,8.7263966,5.5736942,12.6227733,4.9979624,6.7939638,2.8198421,18.1690439),(49124,'forelimb',255,3,320,13.7985958,104.8173933,126.8419749,1.8,104.8371053,126.8357775,0.4571736,2.2200686,3.2546091,12.5573881,28.0844595,0.4481004,8.6291344,5.6563063,12.4483967,4.9876057,6.7939638,2.8198421,18.1690439),(49125,'forelimb',255,3,321,13.7176935,104.7773163,126.8219675,1.8,104.8270873,126.8150279,0.4619143,2.2193164,3.2981425,12.6326393,28.0444048,0.4540904,8.5030907,5.6921308,12.2911428,4.9876057,6.7939638,2.8198421,18.1690439),(49126,'forelimb',255,3,322,13.714952,104.7329009,126.8453584,1.8,104.7585904,126.8170011,0.467772,2.370835,3.1357982,12.8873152,28.1868889,0.4647304,8.9887445,5.4357707,12.7841179,5.072647,6.7939638,2.8198421,18.7767145),(49127,'forelimb',255,3,323,13.690782,104.6873008,126.8696468,1.8,104.6952581,126.8258055,0.4734128,2.3290793,3.1666335,13.0937213,28.3640538,0.4743146,8.9571633,5.6218444,12.7502734,5.072647,6.7939638,2.536048,18.7767145),(49128,'forelimb',255,3,324,13.5948854,104.6470042,126.8977133,1.8,104.6811114,126.9076998,0.4776919,2.2859472,3.1902724,13.0787935,28.5002073,0.478885,8.9334715,5.7213892,12.659207,4.9876057,6.7939638,2.536048,18.7767145),(49129,'forelimb',255,3,325,13.5232147,104.597036,126.9171042,1.8,104.5913073,126.9350833,0.477597,2.2591563,3.2257244,13.2194759,28.5530738,0.4761858,8.8516781,5.8515101,12.945155,4.9989937,6.7939638,2.536048,18.6724547),(49130,'forelimb',255,3,326,13.5352437,104.5555407,126.9311364,1.8,104.5757208,126.9679579,0.4789313,2.4122047,3.2561971,13.5069235,28.9530624,0.479069,8.8916798,5.5994101,13.0381647,5.1272215,6.7939638,2.536048,18.6724547),(49131,'forelimb',255,3,327,13.5095631,104.4993699,126.9325102,1.8,104.4626451,126.9194968,0.4877076,2.3877291,3.1041423,13.708347,29.2197092,0.4944227,9.4131347,5.7411651,13.7241372,5.1272215,6.725681,2.677945,18.1690439),(49132,'forelimb',255,3,328,13.5438039,104.4515093,126.9377845,1.8,104.4499913,126.9304862,0.4955957,2.3625347,3.1406031,13.8579107,29.604474,0.5104959,9.4263659,5.8656961,13.7068986,5.072647,6.725681,2.677945,18.1690439),(49133,'forelimb',255,3,329,13.6665001,104.3989397,126.9351515,1.8,104.388721,126.9075551,0.496828,2.340075,3.1875312,14.1072362,30.4824497,0.5174709,9.5630278,6.0285401,13.8432206,5.072647,6.7939638,2.536048,18.7767145),(49134,'forelimb',255,3,330,13.7259739,104.3495758,126.9342927,1.8,104.3389102,126.9210533,0.5005962,2.4885345,3.2294811,14.3472177,31.2225629,0.5269647,9.6679813,5.765328,13.9454574,5.1282753,6.9418221,2.7610863,18.7767145),(49135,'forelimb',255,3,331,13.8458727,104.3014875,126.93283,1.8,104.3006236,126.926766,0.5082987,2.505713,3.2682669,14.7751776,31.9966095,0.5466094,9.7900847,5.8965961,14.115688,5.2483716,6.9418221,2.7610863,19.0284199),(49136,'forelimb',255,3,332,13.9296843,104.2588432,126.9284452,1.8,104.2598594,126.9183365,0.5140092,2.4910501,3.3043889,15.085747,32.785129,0.5612309,9.9216921,6.055979,14.2680392,5.2483716,7.112602,2.7049655,19.0284199),(49137,'forelimb',255,3,333,13.9982778,104.2215296,126.9269847,1.8,104.2429098,126.9262294,0.516185,2.4747439,3.3362893,15.4258274,33.49979,0.5683468,10.0410328,6.2333026,14.4289468,5.2483716,7.112602,2.7049655,19.0284199),(49138,'forelimb',255,3,334,14.0755434,104.180759,126.9198176,1.8,104.2038472,126.9021909,0.5244505,2.463343,3.2132734,15.7173173,34.1601119,0.5882123,10.6309384,6.3804826,15.0439624,5.2483716,7.0474072,2.485897,19.2801253),(49139,'forelimb',255,3,335,14.1891759,104.1439053,126.910731,1.8,104.171188,126.8705679,0.5322591,2.4546667,3.3085969,16.0289164,35.2142834,0.6090401,10.6432681,6.5299766,15.2810337,5.2483716,7.1514336,2.5702552,19.2801253),(49140,'forelimb',255,3,336,14.247195,104.1101579,126.9005296,1.8,104.1486129,126.8713499,0.5419143,2.4481582,3.282166,16.226292,35.8462493,0.6316871,10.9215223,6.6279591,15.3673127,5.2483716,7.1514336,2.5702552,19.2801253),(49141,'forelimb',255,3,337,14.3253558,104.0266907,126.8417452,1.8,104.0195726,126.8105749,0.5453736,2.4557165,3.3981407,16.4804458,36.7801104,0.642465,10.8235984,6.7110538,15.4494237,5.2483716,7.3926319,2.5213432,19.8877959),(49142,'forelimb',255,3,338,14.4464854,103.9974129,126.8272405,1.8,103.9670762,126.7782831,0.5556841,2.4531556,3.4144227,16.8007455,37.7756224,0.6700332,11.0635459,6.8486261,15.9622491,5.2483716,7.3926319,2.5213432,19.8877959),(49143,'forelimb',255,3,339,14.5093162,103.9792105,126.8168648,1.8,103.9531942,126.7750337,0.5653799,2.4521396,3.4334591,17.1830603,38.6553526,0.6940621,11.2584281,7.0073743,16.2319091,5.2483716,7.3926319,2.5213432,19.8877959),(49144,'forelimb',255,3,340,14.5642022,103.9667051,126.8036554,1.8,103.9227108,126.7439179,0.5746874,2.4559935,3.4688192,17.4821354,39.6372153,0.7172166,11.426717,7.1181521,16.3417067,5.2483716,7.5164702,2.6011732,19.8877959),(49145,'forelimb',255,3,341,14.6186965,103.9497244,126.787849,1.8,103.9227108,126.7439179,0.5824881,2.4591851,3.4699036,17.7554053,40.5814485,0.7373033,11.6952667,7.220036,16.7640193,5.2483716,7.5164702,2.6011732,19.8877959),(49146,'forelimb',255,3,342,14.6255783,103.9359876,126.7747442,1.8,103.893014,126.7385547,0.5883986,2.5812732,3.5444682,18.1062344,41.5265383,0.7509209,11.7158729,7.0144589,16.45548,5.3643822,7.6503773,2.4756234,20.3912067),(49147,'forelimb',255,3,343,14.6372716,103.9228344,126.7556836,1.8,103.8804951,126.7278545,0.5947237,2.5947136,3.5275955,18.5258978,42.2628743,0.7658064,11.9806465,7.1398623,16.8808115,5.3835958,7.6503773,2.4756234,20.3912067),(49148,'forelimb',255,3,344,14.6761562,103.9146633,126.7269136,1.8,103.8421618,126.6585946,0.6080917,2.6236422,3.6209914,18.9698555,43.2138333,0.7983495,11.9342546,7.2303516,17.127331,5.4855323,7.6503773,2.4756234,20.3912067),(49149,'forelimb',255,3,345,14.6570216,103.9077292,126.7000638,1.8,103.8547789,126.6471599,0.6191273,2.5003335,3.6001972,19.2461259,43.9927696,0.8226906,12.2195443,7.6974234,17.5434597,5.3685538,7.6503773,2.4756234,20.1395013),(49150,'forelimb',255,3,346,14.6410202,103.8965732,126.676111,1.8,103.8512383,126.6437391,0.6286998,2.6680903,3.5769378,19.7644855,44.7997489,0.8439429,12.5246096,7.4077274,18.0413098,5.5753216,7.6503773,2.4756234,20.3912067),(49151,'forelimb',255,3,347,14.5927921,103.8898791,126.6498226,1.8,103.8757142,126.6219828,0.6422251,2.5224365,3.5548855,20.0896958,45.3879147,0.8725893,12.767757,7.9644011,18.4100535,5.4690354,7.6503773,2.4756234,20.1395013),(49152,'forelimb',255,3,348,14.5283948,103.8865639,126.6271996,1.8,103.8702751,126.602946,0.6535867,2.5337288,3.5370058,20.4860388,45.9055666,0.8952154,12.9786517,8.0853321,18.749563,5.4690354,7.6503773,2.4756234,20.4954665),(49153,'forelimb',255,3,349,14.5568729,103.88608,126.5972397,1.8,103.8537214,126.552457,0.6709878,2.5488498,3.71234,20.9821519,46.7142139,0.9379124,12.5834956,8.2320079,17.9301069,5.4690354,7.8997178,2.3561945,20.7471719),(49154,'forelimb',255,3,350,14.4449189,103.8874243,126.5718784,1.8,103.8500537,126.5154367,0.6907335,2.5588215,3.7100805,21.4260403,46.8295889,0.9771985,12.6222569,8.3734016,18.1658021,5.4690354,7.8997178,2.3561945,20.7471719),(49155,'forelimb',255,3,351,14.3109769,103.8922172,126.550751,1.8,103.8386625,126.5079597,0.7074006,2.6155117,3.7567309,21.8146542,46.9753654,1.0072981,12.5043199,8.3404921,18.3055702,5.4690354,7.9230552,2.4329664,20.7471719),(49156,'forelimb',255,3,352,14.1953862,103.9096105,126.5311155,1.8,103.8351532,126.5064353,0.7171669,2.6296339,3.7558501,22.0355785,47.1806022,1.0220213,12.561897,8.3797134,18.4131076,5.4690354,7.9230552,2.4329664,20.7471719),(49157,'forelimb',255,3,353,13.9647644,103.8989623,126.4439737,1.8,103.7889494,126.4260453,0.7342684,2.6343297,3.686347,22.2898608,47.2748071,1.0449352,12.8242964,8.4613027,18.5840133,5.4690354,7.9230552,2.2794226,21.1031371),(49158,'forelimb',255,3,354,13.9211801,103.9110091,126.4147764,1.8,103.8303138,126.4066269,0.7489642,2.6525142,3.6708166,22.7917126,47.3834516,1.0756391,12.9081501,8.5924939,18.8358322,5.7728707,7.9230552,2.2794226,21.3548425),(49159,'forelimb',255,3,355,13.916872,103.9223685,126.3842187,1.8,103.8588562,126.3785279,0.7715468,2.663458,3.6512003,23.2904755,47.5740943,1.1276156,13.0297136,8.7444502,19.1181644,5.7728707,7.9230552,2.2794226,21.3548425),(49160,'forelimb',255,3,356,13.7965256,103.927014,126.3521897,1.8,103.8645831,126.368243,0.7866089,2.678768,3.6696847,23.6834653,47.502526,1.1524945,12.9445796,8.8411783,19.3289568,5.7728707,7.9230552,2.2794226,21.3548425),(49161,'forelimb',255,3,357,13.6675072,103.9294317,126.3160314,1.8,103.8503737,126.328272,0.8036753,2.73068,3.692445,23.96454,47.6557309,1.1805835,12.9062805,8.7760339,19.3896379,5.7728707,7.9230552,2.2794226,21.7108077),(49162,'forelimb',255,3,358,13.5566162,103.9336133,126.2723884,1.8,103.8714202,126.2780161,0.8222013,2.7669606,3.5903396,24.2185369,47.6220454,1.2127974,13.2639389,8.7527581,19.8319648,5.7728707,7.7463106,2.1587989,21.1031371),(49163,'forelimb',255,3,359,13.5335093,103.9339669,126.227221,1.8,103.8839842,126.242837,0.8249251,2.7998624,3.5826906,24.5857646,47.993569,1.2168559,13.395957,8.7810617,19.4568776,5.7728707,7.8880231,2.0831858,21.1031371),(49164,'forelimb',255,3,360,13.5648967,103.916168,126.1691578,1.8,103.8752112,126.191666,0.8334883,2.831564,3.7961723,25.2145192,48.3498707,1.2389634,12.7364794,8.904803,19.3763688,6.076706,7.9926588,2.2035452,21.6065479),(49165,'forelimb',255,3,361,13.5214243,103.9082302,126.1023868,1.8,103.8980645,126.1183669,0.8423023,2.8754065,3.7414216,25.6646303,48.1079228,1.2547462,12.8581936,8.925566,19.7176332,6.076706,7.9230552,2.2794226,21.6065479),(49166,'forelimb',255,3,362,13.4269264,103.912619,126.0409861,1.8,103.8826624,126.0749299,0.8480546,2.9223421,3.6981274,25.9013231,47.9643236,1.2587577,12.9698948,8.8632069,19.8353722,6.076706,7.9230552,2.2794226,21.6065479),(49167,'forelimb',255,3,363,13.3343867,103.9182681,125.9908152,1.8,103.8663946,126.0116598,0.8606185,2.9194125,3.7081352,26.2468098,47.9839278,1.2777385,12.9401776,8.9904423,19.8774425,6.076706,7.9926588,2.2035452,21.6065479),(49168,'forelimb',255,3,364,13.2610935,103.9360924,125.9474209,1.8,103.877074,125.9535441,0.8692135,2.9591946,3.6901585,26.7265389,47.9877101,1.2894719,13.0042408,9.0316935,20.146532,6.076706,7.9926588,2.2035452,21.9625131),(49169,'forelimb',255,3,365,13.2401126,103.9456192,125.9021973,1.8,103.8745758,125.8785985,0.8812996,2.992097,3.7094008,27.1985839,48.0825641,1.313672,12.9623535,9.0901411,20.2579671,6.076706,7.9926588,2.2035452,21.6065479),(49170,'forelimb',255,3,366,13.3096013,103.9522669,125.8503821,1.8,103.9096627,125.8334066,0.9023065,3.0221967,3.7498184,28.0969303,48.3145537,1.3661109,12.884505,9.2968569,20.3532058,6.3212873,7.9926588,2.2035452,21.8582533),(49171,'forelimb',255,3,367,13.3634802,103.9701186,125.7908503,1.8,103.9726262,125.7727638,0.9067862,2.9534246,3.786481,28.7634214,48.8020345,1.3813365,12.8884931,9.7390065,20.4513525,6.076706,8.107337,2.1293956,21.9625131),(49172,'forelimb',255,3,368,13.2037457,103.9840335,125.7360718,1.8,103.9722192,125.7610838,0.9213262,2.9307258,3.7420978,28.924776,48.6963456,1.3957677,13.0131141,9.8694924,20.6274073,6.076706,7.9926588,2.2035452,21.9625131),(49173,'forelimb',255,3,369,13.0545297,103.9737505,125.6239862,1.8,103.984496,125.6350737,0.9373668,2.994867,3.7226457,29.3168611,48.4305168,1.4134567,13.0097035,9.7890359,20.7330509,6.3128051,7.9926588,2.2035452,22.5701837),(49174,'forelimb',255,3,370,13.061915,103.981761,125.5643873,1.8,103.9612696,125.5316072,0.9437234,3.0379128,3.771949,30.0020243,48.6174952,1.4274337,12.8892238,9.8758675,20.838107,6.360732,7.9926588,2.2035452,22.5701837),(49175,'forelimb',255,3,371,12.9044185,104.0191697,125.5374628,1.8,104.0143674,125.5217453,0.9280193,3.0805309,3.7710454,30.6010105,48.1205842,1.377966,12.7605421,9.9336808,20.8684239,6.3805413,7.9926588,2.2035452,22.5701837),(49176,'forelimb',255,3,372,12.7331026,104.058815,125.4984099,1.8,104.0097718,125.5102563,0.9003796,3.1279037,3.7609668,30.8147023,47.6255735,1.3029586,12.6631198,9.8515508,20.840831,6.3805413,7.9926588,2.2035452,22.5701837),(49177,'forelimb',255,3,373,12.6608724,104.1000179,125.4295659,1.8,104.0342493,125.4259272,0.9042663,3.2040888,3.8049312,31.3756209,47.8169584,1.3035456,12.5671019,9.7923694,20.5075797,6.6193247,8.107337,2.1293956,22.8218891),(49178,'forelimb',255,3,374,12.6887909,104.15248,125.3514457,1.8,104.0423814,125.3464461,0.9299293,3.2990703,3.7893427,31.9593866,48.631218,1.3588147,12.8336815,9.6873919,21.1041558,6.6764751,8.107337,2.1293956,22.8218891),(49179,'forelimb',255,3,375,12.9786628,104.1957474,125.2633201,1.8,104.1127611,125.2572586,0.9582699,3.3886311,3.7539866,33.4243997,50.6479068,1.4480902,13.4917654,9.8636879,22.0377179,6.6843766,8.107337,2.5829933,23.1778543),(49180,'forelimb',255,3,376,13.647981,104.2042528,125.1599133,1.8,104.1136041,125.1743681,1.0191094,3.4455807,3.9056091,35.5813195,53.6254866,1.6497983,13.7303774,10.326654,22.7349508,6.8779174,8.2540369,2.2455373,23.6812651),(49181,'forelimb',255,3,377,14.3584776,104.2164473,125.0798955,1.8,104.1441507,125.123963,1.0569746,3.4832001,3.9878496,37.0915419,58.0129412,1.8149566,14.5474246,10.6486967,23.8484766,6.9177932,8.3430318,2.1730837,23.6812651),(49182,'forelimb',255,3,378,15.2947286,104.2521211,124.9406216,1.8,104.2090177,125.0043684,1.0897611,3.3636841,3.8790963,39.2369438,63.6306657,2.0033834,16.4034768,11.6648718,25.5107782,6.7798397,8.3430318,2.1730837,24.0372303),(49183,'forelimb',255,3,379,16.7524804,104.2577149,124.8408857,1.8,104.1910413,124.9359353,1.12296,3.4154798,3.9835621,42.4362981,70.787265,2.2685564,17.769841,12.4246958,27.7964831,6.8541365,8.59376,2.2142974,24.2889357),(49184,'forelimb',255,3,380,17.534368,104.2663456,124.721497,1.8,104.2180608,124.8555654,1.1622671,3.4865558,4.0521394,44.4918322,73.9947571,2.4611954,18.2606643,12.7609695,28.7356458,7.0416448,8.7005189,2.1451012,24.8966063),(49185,'forelimb',255,3,381,18.4363222,104.2952609,124.6230879,1.8,104.2489194,124.7382524,1.1598051,3.5012414,4.1967514,46.7077987,80.3217282,2.5822687,19.1390245,13.3403539,30.2625004,7.1113101,8.8582451,1.9693188,24.8966063),(49186,'forelimb',255,3,382,20.1713574,104.3469332,124.5572694,1.8,104.2754658,124.6484288,1.1600795,3.574675,4.3286207,50.5034869,90.145881,2.8259606,20.8255441,14.1281339,32.3651658,7.2276856,9.0336729,2.0131705,25.7559823),(49187,'forelimb',255,3,383,22.5047673,104.3610185,124.4073032,1.8,104.3107406,124.4296876,1.1855686,3.6214194,4.5819188,56.3999571,104.3684327,3.2211703,22.7783244,15.5739922,34.9525888,7.3041268,9.2955727,2.1587989,26.6153583),(49188,'forelimb',255,3,384,25.1501491,104.3490854,124.1930165,1.8,104.3213594,124.1843235,1.2051019,3.5116951,4.9237184,62.4099526,125.6600917,3.6556736,25.5213807,17.7720307,37.6955398,7.3041268,9.8921606,2.1708465,27.7264397),(49189,'forelimb',255,3,385,25.6105536,104.416741,124.1507952,1.8,104.384305,123.9905985,1.1689723,3.6222005,5.1646189,64.0868137,128.9395791,3.615538,24.9659425,17.6927846,36.9589595,7.4958527,10.2496576,2.1471715,28.5858157),(49190,'forelimb',255,3,386,21.9430951,104.5516071,124.612603,1.8,104.4545157,124.320993,0.864838,3.7371027,5.4091906,54.6846648,88.787234,2.1178965,16.4141441,14.6329041,25.4245566,7.5958825,10.1864154,2.0533096,28.6900755),(49191,'forelimb',255,3,387,21.1362542,104.7378004,124.5876635,1.8,104.8153263,124.2729811,1.0028009,3.9690831,4.571371,61.301897,76.17042,2.5032968,16.6624891,15.4448511,26.3136132,7.9686341,9.6942031,1.3473197,29.2977461),(49192,'forelimb',255,3,388,24.8382333,104.9863432,124.094565,1.8,104.7846047,123.8794545,1.2829524,3.9448234,5.2226881,77.2215217,107.9813554,3.8060825,20.6754362,19.5754066,34.4249604,8.1268929,10.1410009,2.2058231,29.5494515),(49193,'forelimb',255,3,389,30.8426265,104.9347369,123.8682659,1.8,104.8875019,123.8664903,1.1602774,3.9944576,5.1643545,87.7202403,152.0868719,4.3217253,29.4493477,21.9604884,46.3697555,8.0721211,10.4635866,1.9055332,29.2977461),(49194,'forelimb',255,3,390,32.3266744,104.9562357,123.7864853,1.8,105.0001222,123.9158231,1.2465256,3.9043305,4.8277201,97.4011088,158.5138334,4.8408271,32.8340977,24.9469428,52.2701651,8.164072,10.0679117,2.2655346,29.5494515),(49195,'forelimb',255,3,391,27.8175747,104.9861899,123.8403915,1.8,105.097637,123.7221209,1.0369044,3.607901,4.7236594,62.2768131,120.7630155,3.4356258,25.5655635,17.2612313,37.2042147,7.5958825,9.5406219,2.1962814,26.9713235),(49196,'forelimb',255,3,392,11.0713606,103.8503671,122.7593317,1.8,104.1323756,123.2116389,1.5042678,3.8123387,4.0843957,8.2675015,41.1197985,1.8370717,10.0675356,2.1686167,10.2199879,5.4776735,8.3430318,1.7782926,26.1119475),(49197,'forelimb',255,3,393,4.2139685,103.8073505,120.9520375,1.8,103.7600321,121.1399497,-1.1778858,1.6689457,3.2430436,1.6932858,3.9112742,0.5993695,1.2060504,1.0145842,1.6988121,3.437504,5.9848613,1.2036225,14.8789856),(49198,'forelimb',255,3,394,2.0634559,103.916526,120.4918039,1.8,103.9530554,120.5222439,-0.9081846,1.1495602,1.7280164,0.5410645,1.1470788,0.2137589,0.6638124,0.4706709,0.9721155,2.7345177,4.0536685,1.012197,9.8701752),(49199,'forelimb',255,3,395,0.0134837,103.984496,120.31264,1.8,103.984496,120.31264,0.7853982,0,0,0.0002075,0.0002075,0.0011236,0,0,0,0.429688,0.6076706,2.3561945,1.2153412),(49200,'forelimb',255,3,396,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49201,'forelimb',255,3,397,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49202,'forelimb',255,3,398,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49203,'forelimb',255,3,399,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49204,'forelimb',255,3,400,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49205,'forelimb',255,3,401,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49206,'forelimb',255,3,402,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49207,'forelimb',255,3,403,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49208,'forelimb',255,3,404,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49209,'forelimb',255,3,405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49210,'forelimb',255,3,406,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49211,'forelimb',255,3,407,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49212,'forelimb',255,3,408,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49213,'forelimb',255,3,409,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49214,'forelimb',255,3,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49215,'forelimb',255,3,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49216,'forelimb',255,3,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49217,'forelimb',255,3,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49218,'forelimb',255,3,414,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49219,'forelimb',255,3,415,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49220,'forelimb',255,3,416,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49221,'forelimb',255,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49222,'forelimb',255,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49223,'forelimb',255,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49224,'forelimb',255,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49225,'forelimb',255,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49226,'forelimb',255,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49227,'forelimb',255,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49228,'forelimb',255,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49229,'forelimb',255,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49230,'forelimb',255,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49231,'forelimb',255,4,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49232,'forelimb',255,4,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49233,'forelimb',255,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49234,'forelimb',255,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49235,'forelimb',255,4,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49236,'forelimb',255,4,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49237,'forelimb',255,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49238,'forelimb',255,4,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49239,'forelimb',255,4,19,0.7511716,90.2140293,128.845272,1.8,90.1877748,128.8410127,0.0550038,0.5598171,4.290224,0.0831061,2.8722619,0.0003784,0.66949,0.1484522,0.6885307,1.289064,8.2091777,3.0367157,17.1443342),(49240,'forelimb',255,4,20,3.9032277,88.9428538,128.6767555,1.8,88.3424085,128.59948,0.0954353,1.0775072,7.3289129,0.82726,40.8345023,0.0059071,5.5716998,0.7677536,5.6843244,2.4837643,16.4183554,3.0367157,34.7920792),(49241,'forelimb',255,4,21,5.0780453,87.2880906,128.504696,1.8,86.7219969,128.4824796,0.0766489,1.0123516,8.6648199,1.0596778,92.1832295,0.0049626,10.6387934,1.0467487,10.7580373,2.8268186,21.5230372,3.0816645,46.4241922),(49242,'forelimb',255,4,22,5.1384702,85.403524,128.3374594,1.8,85.266544,128.3149159,0.0527496,1.0404392,8.3096119,1.0891804,127.2816857,0.0023808,15.3174044,1.0468467,15.4133574,3.007816,24.552449,3.0715321,53.0474947),(49243,'forelimb',255,4,23,5.1099362,83.8797063,128.2480786,1.8,84.395327,128.2337337,0.0343333,1.326472,9.8238545,1.1313775,156.7328956,0.0010035,15.9543178,0.8529223,16.0227044,3.007816,27.1248527,3.0781857,58.8114213),(49244,'forelimb',255,4,24,5.3980177,82.0230707,128.1808191,1.8,82.8872874,128.1532655,0.0136034,1.2480383,11.6635506,1.3269153,187.0769619,0.0001665,16.0394522,1.0632008,16.0945601,3.007816,30.1057701,3.0987617,64.9313131),(49245,'forelimb',255,4,25,5.5728025,80.8781225,128.1229404,1.8,82.4105777,128.0828313,-0.0012413,1.2082262,12.7944793,1.5263721,209.8508681,0.0000014,16.4016732,1.2633165,16.4908788,3.437504,32.2724008,0.0532829,69.4798985),(49246,'forelimb',255,4,26,5.9185115,79.5076382,128.0468575,1.8,80.9137226,128.001451,-0.0063124,1.3323666,14.1667749,1.8503595,220.0425673,0.0000393,15.5322978,1.3887766,15.6583877,3.5419677,34.0132727,0.0632068,73.8810383),(49247,'forelimb',255,4,27,6.3339889,79.1329339,127.9588736,1.8,80.8664895,127.9024746,-0.0071982,1.6743669,14.5411319,2.305401,241.3019884,0.0000547,16.5944433,1.3768793,16.7447679,3.5344686,35.2763119,0.0487419,76.6676859),(49248,'forelimb',255,4,28,6.7378849,78.9840751,127.896045,1.8,80.9386405,127.855199,-0.0108097,1.6365035,14.6947082,2.6608498,267.0141032,0.0001312,18.1707659,1.6259359,18.3390196,3.6862537,35.401702,0.0972532,78.1347325),(49249,'forelimb',255,4,29,6.8766945,78.8841199,127.8391929,1.8,80.5694164,127.8039878,-0.0118491,2.0096363,14.794546,2.923208,267.9022701,0.0001609,18.1081778,1.4545955,18.2962861,3.9848034,35.7907149,0.0841382,79.0983683),(49250,'forelimb',255,4,30,6.9279438,78.9876935,127.8281477,1.8,80.5554048,127.8109982,-0.0161541,1.602584,14.6927208,2.7637824,264.1810615,0.0003013,17.9804043,1.7245788,18.1616721,3.8036757,35.8293839,0.0960887,78.1347325),(49251,'forelimb',255,4,31,7.0431988,79.251389,127.8026992,1.8,81.0248999,127.7638655,-0.0218152,1.6094166,14.4305801,2.7966548,264.3110499,0.0005586,18.3160377,1.7376824,18.5058306,4.176726,35.4460046,0.1093185,78.8466629),(49252,'forelimb',255,4,32,7.2377335,79.4678997,127.7726592,1.8,81.3935022,127.7311346,-0.0246598,1.5916761,14.2141905,2.89371,261.2906109,0.0007334,18.3823771,1.8180269,18.5834252,4.3059199,35.4460046,0.1093185,78.3432521),(49253,'forelimb',255,4,33,7.3014035,79.8622764,127.6906293,1.8,81.98604,127.6526528,-0.0295957,1.5380055,13.831259,2.8845413,256.7040514,0.0010656,18.5597024,1.8755078,18.7548202,4.7085747,35.018913,0.1106572,77.9872869),(49254,'forelimb',255,4,34,7.3200905,79.939256,127.6665694,1.8,81.8201043,127.617336,-0.0337418,1.9415107,13.7555636,2.9080229,239.0600376,0.0013885,17.3791525,1.4978145,17.5813697,5.1346836,35.018913,0.1106572,79.5585933),(49255,'forelimb',255,4,35,7.740939,80.1437547,127.6621132,1.8,82.0284872,127.6089518,-0.0360938,1.9409468,13.5520455,3.0839706,239.0176231,0.00168,17.6370145,1.5889001,17.8561936,4.9241799,35.018913,0.1106572,78.9509227),(49256,'forelimb',255,4,36,7.9375999,80.3853776,127.6619972,1.8,82.3153302,127.6216329,-0.0382452,1.5565707,13.3114572,3.1350484,233.297797,0.0019341,17.5260901,2.0140739,17.7537766,5.3188303,34.6425541,0.124355,78.8466629),(49257,'forelimb',255,4,37,8.16576,80.7026459,127.6501036,1.8,82.7305084,127.5716687,-0.0439398,1.5813396,13.0148825,3.3113155,239.8533069,0.0026259,18.4291566,2.0939938,18.6525652,5.7988091,34.9740693,0.0984462,80.4179693),(49258,'forelimb',255,4,38,8.3667289,80.9441831,127.6513393,1.8,83.0241058,127.5565509,-0.0503348,1.6106335,12.7782491,3.449659,237.1910089,0.00353,18.56209,2.1418026,18.8053658,6.2608854,35.0689645,0.1228352,81.6333105),(49259,'forelimb',255,4,39,8.4880823,81.1530609,127.6535325,1.8,83.1530533,127.549934,-0.0537477,1.6203198,12.5720405,3.5923384,226.7556633,0.0040828,18.0365044,2.2170552,18.2977445,6.7042865,34.759608,0.1488899,82.3452409),(49260,'forelimb',255,4,40,8.6465859,81.3082,127.6746976,1.8,83.3573128,127.5525589,-0.0592637,1.6552169,12.4218258,3.6460152,218.8515004,0.0050555,17.6183037,2.2027416,17.8901375,7.0948896,34.759608,0.1488899,82.9529115),(49261,'forelimb',255,4,41,8.8265179,81.4503074,127.6763037,1.8,83.4077023,127.5581443,-0.0623498,1.6816045,12.2819234,3.8063721,212.0961515,0.0057114,17.2689687,2.2635359,17.559054,7.5229425,35.1242016,0.1349767,85.6352993),(49262,'forelimb',255,4,42,8.9427241,81.5882016,127.6724325,1.8,83.4828696,127.5446196,-0.0640031,2.0416834,12.1450126,4.0379847,205.4207936,0.0060972,16.9140042,1.9777722,17.2276191,7.6034693,35.1845999,0.1470784,86.3472297),(49263,'forelimb',255,4,43,9.0038763,81.7625455,127.6724347,1.8,83.6783457,127.5291369,-0.0667356,2.0645683,11.9725651,4.1452428,194.479812,0.0066734,16.2437882,2.0078013,16.5727304,8.0123745,34.8259407,0.1610919,86.9549002),(49264,'forelimb',255,4,44,9.1091165,81.9303993,127.6708903,1.8,83.805159,127.5190563,-0.06938,2.0562149,11.8064126,4.2471597,185.4038603,0.0072962,15.7036576,2.0655232,16.0475082,8.2528019,35.1242016,0.1349767,88.2745012),(49265,'forelimb',255,4,45,9.1131448,82.1494245,127.6513559,1.8,84.0588578,127.4824871,-0.0719634,2.0628678,11.5878677,4.2987412,177.6913954,0.0078522,15.3342617,2.0838665,15.6911415,8.6840071,34.8259407,0.1610919,88.8821718),(49266,'forelimb',255,4,46,9.0773374,82.3686257,127.6217138,1.8,84.3291422,127.4358101,-0.0734385,2.0241118,11.3993217,4.3445351,169.4989567,0.0081447,14.8692143,2.1463909,15.2041574,8.7289217,34.8974383,0.1732457,89.3855826),(49267,'forelimb',255,4,47,9.127132,82.5338504,127.5985426,1.8,84.4116269,127.431525,-0.0730191,2.0113666,11.2324729,4.4467866,159.7244355,0.0080962,14.2198817,2.2108285,14.5708305,9.2303596,35.1242016,0.1349767,90.3492184),(49268,'forelimb',255,4,48,9.218273,82.7338527,127.57098,1.8,84.6065013,127.4001567,-0.0731676,1.9677105,11.0311218,4.4968274,152.1877398,0.0082103,13.7962161,2.2853095,14.1600644,9.6086434,34.8974383,0.1732457,90.3492184),(49269,'forelimb',255,4,49,9.2598991,82.9515169,127.5202222,1.8,84.6884524,127.3379214,-0.0733655,1.9338291,10.8104943,4.5239728,142.1467939,0.008292,13.1489634,2.339386,13.5274904,9.5921696,34.8259407,0.1610919,89.637288),(49270,'forelimb',255,4,50,9.3965825,83.1552647,127.4788961,1.8,84.864567,127.3110943,-0.0706306,1.8651997,10.6020235,4.5637592,135.6360591,0.0077998,12.7934124,2.4467939,13.1831292,10.0035045,34.8259407,0.1610919,90.3492184),(49271,'forelimb',255,4,51,9.6355968,83.3494621,127.4360033,1.8,84.9798038,127.2836677,-0.0664776,1.8187946,10.40185,4.7194583,128.945734,0.0070866,12.3964232,2.5948275,12.8076151,9.9511387,34.8259407,0.1610919,91.0611488),(49272,'forelimb',255,4,52,9.6279317,83.6159629,127.3801117,1.8,85.2038638,127.2404167,-0.059652,1.8603565,10.1264586,4.7158144,118.2477945,0.0057032,11.6771123,2.5348983,12.097276,10.2923041,34.4742621,0.1753942,90.3492184),(49273,'forelimb',255,4,53,9.6840486,83.8854263,127.3134411,1.8,85.4250806,127.1591747,-0.0506969,2.0212498,9.845682,4.7490394,111.3673754,0.0041447,11.3112911,2.3495559,11.7428053,10.1606019,34.3347331,0.1507464,90.7051836),(49274,'forelimb',255,4,54,9.8338801,84.1790952,127.2458899,1.8,85.5969006,127.0910318,-0.044425,1.9452186,9.5624398,4.9383328,105.0935442,0.0032325,10.9902437,2.5387032,11.3930859,10.6324399,33.9779709,0.1651487,90.097513),(49275,'forelimb',255,4,55,10.0332824,84.442149,127.1686326,1.8,85.8263866,126.990497,-0.0377277,1.8528155,9.287379,5.0243477,99.5302106,0.0023791,10.7167168,2.7117366,11.1405565,10.6622305,33.9099795,0.1526493,89.637288),(49276,'forelimb',255,4,56,10.0417867,84.7420862,127.1089242,1.8,86.0799665,126.9702155,-0.0298572,1.793882,8.9748771,5.0793167,90.7997701,0.0014915,10.1171046,2.8314665,10.560244,11.0321569,33.4853518,0.1546005,88.777912),(49277,'forelimb',255,4,57,9.9778929,85.0275738,127.0379358,1.8,86.343118,126.8868664,-0.0205089,1.8602982,8.6747693,5.0021223,82.8604333,0.0006994,9.551889,2.6888821,10.0006849,11.0643794,33.0608548,0.1566019,88.4219468),(49278,'forelimb',255,4,58,9.9396797,85.3370101,126.9717059,1.8,86.5566899,126.811671,-0.0119109,1.971268,8.3522821,4.9223616,75.2771749,0.000235,9.0127673,2.4970534,9.4693627,11.3353258,32.5713708,0.1456284,87.918536),(49279,'forelimb',255,4,59,9.9875721,85.6670423,126.8918379,1.8,86.8084343,126.7379079,-0.0061783,1.8748156,8.0135802,4.9984085,71.9576259,0.0000635,8.9794603,2.66608,9.4651889,11.3731199,32.1462915,0.1475681,87.6668306),(49280,'forelimb',255,4,60,10.1109956,85.9926193,126.8009221,1.8,87.0076617,126.6526171,0.0037806,1.7533712,7.6775229,5.1374192,69.0958675,0.0000241,8.9997605,2.9300236,9.5243753,11.3731199,31.9821833,0.1076899,87.05916),(49281,'forelimb',255,4,61,10.1856876,86.2910193,126.7099386,1.8,87.1782885,126.609988,0.0168789,1.7869914,7.3734715,5.1200358,67.1360287,0.0004836,9.1050775,2.8651709,9.6540002,11.7720098,31.2345051,0.138006,85.5921134),(49282,'forelimb',255,4,62,10.3315467,86.6055803,126.6065291,1.8,87.4444113,126.4937599,0.0280492,1.9172355,7.0558202,5.1752167,66.7221734,0.0013544,9.4563313,2.6993119,9.9331415,11.799605,30.8089592,0.1399247,85.5921134),(49283,'forelimb',255,4,63,10.4835042,86.9090165,126.5101285,1.8,87.6328075,126.3959626,0.0353729,1.8042805,6.7523055,5.1828261,66.0044656,0.0021853,9.7751006,2.8725168,10.2855768,11.6946309,30.751975,0.1260881,84.7327374),(49284,'forelimb',255,4,64,10.6159356,87.2397578,126.419299,1.8,87.8595828,126.3050456,0.0404171,1.7209618,6.4232952,5.2553107,64.6860113,0.0028887,10.0705338,3.0537055,10.6316168,11.6998623,29.8996165,0.1297025,83.5173962),(49285,'forelimb',255,4,65,10.6173343,87.5967833,126.2793409,1.8,88.1601241,126.2186275,0.0430742,1.8189866,6.0716727,5.1835154,63.1263913,0.0032812,10.39687,2.8496721,11.0168681,12.0729147,29.0476715,0.133529,82.0503497),(49286,'forelimb',255,4,66,10.6380354,87.9003393,126.1925213,1.8,88.377614,126.1471892,0.0494116,1.8855131,5.7713053,5.1231854,60.8355348,0.0043253,10.5410357,2.7171307,11.206517,12.1215568,28.1404636,0.1224611,80.3315977),(49287,'forelimb',255,4,67,10.852544,88.1943636,126.0988918,1.8,88.5468648,126.0200176,0.0564664,1.7643876,5.4818356,5.1863716,59.5201746,0.005761,10.8577089,2.9394741,11.5978585,11.985314,26.861515,0.1283232,77.5017642),(49288,'forelimb',255,4,68,11.1556758,88.4729187,125.9966371,1.8,88.7168586,125.9138212,0.0640332,1.7169597,5.2096314,5.4439543,59.4512227,0.0076131,11.4117907,3.1706943,12.0602228,12.0390365,25.1578563,0.1370662,73.3523299),(49289,'forelimb',255,4,69,11.3895427,88.7464133,125.9029723,1.8,88.93007,125.8464076,0.0731152,1.7894125,4.9434791,5.6442109,58.9625254,0.0101297,11.9273338,3.1542258,12.6864708,12.5714533,23.4563999,0.1470784,71.1301671),(49290,'forelimb',255,4,70,11.6446702,89.0036767,125.8131667,1.8,89.1166685,125.7833778,0.0784071,1.870502,4.6943116,5.7789544,58.1925035,0.0119069,12.396387,3.0895205,13.2693858,12.5780463,22.4920224,0.1148766,68.5520391),(49291,'forelimb',255,4,71,12.0210393,89.2654106,125.7126892,1.8,89.2975214,125.6539006,0.0848313,1.9613179,4.4428853,6.154901,58.4469817,0.0143834,13.1551857,3.1381455,14.2214636,12.6042781,21.2119693,0.1218424,66.1213567),(49292,'forelimb',255,4,72,12.330885,89.5371336,125.6249441,1.8,89.4987552,125.5647257,0.0899117,1.9988927,4.1813006,6.4066514,55.8605111,0.0165693,13.3596018,3.2051002,14.6245746,12.7382831,19.8820682,0.1082706,62.8312983),(49293,'forelimb',255,4,73,12.3819665,89.8110536,125.5427014,1.8,89.7985192,125.484578,0.0955792,1.7610564,3.985838,6.7602847,53.1201036,0.018795,13.3272108,3.8387667,14.5828438,12.460952,18.9842363,3.0509328,60.1489105),(49294,'forelimb',255,4,74,12.4841294,90.0652422,125.4619231,1.8,89.9978402,125.3941677,0.1018603,1.8306487,4.149231,7.3549692,49.481123,0.0215136,11.925372,4.0176847,13.6979819,12.460952,18.1285566,3.0466409,57.9267477),(49295,'forelimb',255,4,75,12.2138397,90.2850479,125.3935215,1.8,90.1839285,125.3519956,0.1201129,1.9417204,3.9834753,7.699984,44.0458607,0.0292274,11.0571443,3.9655472,12.9512418,12.89064,17.2732438,3.041924,56.6682207),(49296,'forelimb',255,4,76,12.0479508,90.5117804,125.3315159,1.8,90.4101189,125.2838479,0.1229381,1.9815123,3.7753047,8.2313831,39.8744756,0.0301957,10.5619223,4.1540914,12.7119023,12.8221428,16.3789491,3.0628087,54.5935035),(49297,'forelimb',255,4,77,12.2276591,90.7322398,125.2577168,1.8,90.5888942,125.1301639,0.1158766,10.3734772,3.9341366,10.2408769,36.9710066,0.027242,9.3974893,0.9872174,4.4876469,12.8221428,15.5639613,3.0309354,53.3781623),(49298,'forelimb',255,4,78,11.841443,90.9409994,125.1942816,1.8,90.7998589,125.0295158,0.1139684,10.7102511,3.7567393,12.671204,31.1040184,0.0255236,8.2795254,1.1830912,4.0465258,13.2570967,15.0942245,3.0560874,51.7636701),(49299,'forelimb',255,4,79,11.4725711,91.1817302,125.1471738,1.8,90.9855882,125.0155244,0.1129018,10.6346915,3.5635066,13.933332,26.6987456,0.0242697,7.4922677,1.3101774,3.7924627,12.7983111,14.2381773,3.0509328,49.8363985),(49300,'forelimb',255,4,80,11.5257226,91.4265177,125.0935875,1.8,91.2370853,124.8073129,0.0339704,10.8666153,3.3695852,18.322335,23.9138939,0.0022159,7.0969845,1.6861124,3.8300427,12.656143,14.3028672,2.1421338,48.7685029),(49301,'forelimb',255,4,81,10.991857,91.6787668,125.0230998,1.8,91.5053369,124.6313685,-1.2540245,3.1344952,10.8133137,19.4712043,24.1234039,1.6542147,2.2308984,6.2119107,3.9959425,12.1641667,14.3028672,2.1421338,47.7616813),(49302,'forelimb',255,4,82,9.720975,91.8032776,124.9590262,1.8,91.718189,124.4295652,-1.3665855,2.8693569,11.2401986,15.1492311,30.372685,1.5535324,2.7021484,5.2796607,4.0471039,11.8412875,14.283491,1.2966289,47.6142357),(49303,'forelimb',255,4,83,9.0300045,91.8932689,124.9241725,1.8,91.8733785,124.2939085,-1.4016645,2.5351983,11.1984904,11.7933376,36.2766353,1.4623583,3.2394219,4.6518403,4.2923415,11.6280342,14.4441652,2.1010121,47.2582705),(49304,'forelimb',255,4,84,9.7358574,92.0371013,124.9163635,1.8,91.9826124,124.2385928,-1.4170937,2.6118077,11.1690837,11.0931388,45.3787055,1.5846097,4.0628853,4.247303,5.0559687,11.6036301,14.4952048,1.3617734,47.3625303),(49305,'forelimb',255,4,85,10.0016712,92.1547189,124.9180395,1.8,92.0532456,124.179832,-1.4249054,2.6700062,11.1538961,10.9942903,52.8911781,1.6317167,4.7419465,4.1177022,5.7273816,11.5358134,14.6661522,2.1262901,48.1176465),(49306,'forelimb',255,4,86,10.0443603,92.1442026,124.9592454,1.8,92.0515504,124.2490191,-1.4283419,2.7296965,11.1964738,11.2888123,58.481633,1.6403171,5.2232189,4.1355558,6.231369,11.6311836,14.6661522,2.1262901,51.0085539),(49307,'forelimb',255,4,87,9.7920302,92.0477591,125.0106304,1.8,92.0116696,124.3379572,-1.4179389,2.6371407,11.2606889,11.3125757,65.4284573,1.5941687,5.8103423,4.2897126,6.8147255,5.6395378,12.644806,0.1707352,30.6605329),(49308,'forelimb',255,4,88,10.1362286,91.9849115,125.0289051,1.8,92.0231812,124.3463777,-1.4216755,2.5793134,11.288361,11.3548872,74.7485634,1.6520825,6.6217375,4.4022907,7.6276278,5.7776852,13.0047187,0.1325515,31.5199089),(49309,'forelimb',255,4,89,10.5504752,91.9056497,125.0370479,1.8,91.9828657,124.3457805,-1.4226017,2.5659347,11.3081035,11.7622791,83.2386696,1.7200768,7.3609752,4.5840135,8.4008252,6.2538665,13.145925,0.1973956,32.6309903),(49310,'forelimb',255,4,90,10.6833541,91.8788892,125.0430042,1.8,91.9367055,124.4112025,-1.4236344,2.5402847,11.3178125,13.293629,90.282579,1.7422757,7.9770343,5.2331256,9.1509591,6.6585923,13.6556983,0.2220819,34.0980369),(49311,'forelimb',255,4,91,11.1470596,91.8951203,125.0005754,1.8,91.8751069,124.5826645,-1.4306298,2.9153785,11.2723108,15.8176563,98.9079496,1.8215813,8.7744165,5.4255927,10.1759807,7.3454983,14.4121737,0.1798535,36.5287193),(49312,'forelimb',255,4,92,14.3117042,92.017929,124.9986025,1.8,91.8201814,124.5986142,-1.4553554,3.096879,11.2477155,22.2855192,115.9593811,2.3536372,10.309594,7.196122,12.2846096,8.2890933,14.8351299,0.1746722,38.6034365),(49313,'forelimb',255,4,93,20.1834983,92.002477,125.0170249,1.8,91.7520599,124.5860825,-1.4713505,3.1250752,11.26037,30.2824308,140.8945632,3.3307586,12.5124276,9.6901446,15.1833359,9.023448,15.3369125,0.1973956,40.4264483),(49314,'forelimb',255,4,94,22.0198012,91.7138499,125.0576393,1.8,91.7064277,124.6681138,-1.463886,3.1359784,11.3353747,33.9201932,173.2792835,3.6281794,15.2865951,10.8164626,18.2388298,9.453136,15.6821404,0.1651487,41.8934949),(49315,'forelimb',255,4,95,11.5595158,91.2167595,124.6748754,1.8,91.4171856,124.5776125,-1.4118787,3.2299192,10.9919112,15.8655826,136.4084779,1.8783387,12.4098962,4.9120679,13.8484737,9.6932128,15.9910916,0.1076899,42.8571307),(49316,'forelimb',255,4,96,1.5586838,91.7732995,120.7336753,1.8,91.6954192,121.3438912,-1.3388422,1.5186935,8.6269986,0.6735446,25.2960117,0.2460526,2.9321915,0.4435027,2.9940852,2.2658751,4.0536685,0.5585993,9.6184698),(49317,'forelimb',255,4,97,0.3470518,93.3694083,114.9293829,1.8,93.3139107,114.9773473,1.1725296,0.6012579,1.1186966,0.0374737,0.0816905,0.0491422,0.0730229,0.0623256,0.1056677,2.4989812,7.1514336,2.5702552,15.990067),(49318,'forelimb',255,4,98,0.2774512,93.4351747,115.0155808,1.8,93.3594836,115.0391964,1.2997247,0.6375354,1.0270662,0.0268229,0.0611243,0.0429264,0.0595135,0.0420729,0.0855659,2.500072,6.9285108,2.6224465,15.7383616),(49319,'forelimb',255,4,99,0.161357,93.5414685,115.2223867,1.8,93.487832,115.279152,1.3493424,0.3717493,0.8026659,0.0088426,0.0275348,0.0255954,0.0343042,0.0237864,0.0452434,2.500072,6.725681,2.677945,15.130691),(49320,'forelimb',255,4,100,0.0367026,93.671984,115.3679529,1.8,93.671984,115.371228,1.2767414,0.0632186,0.2087566,0.000707,0.0021161,0.0056032,0.0101369,0.0111832,0.0129431,2.5562168,5.7648695,2.677945,13.411939),(49321,'forelimb',255,4,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49322,'forelimb',255,4,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49323,'forelimb',255,4,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49324,'forelimb',255,4,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49325,'forelimb',255,4,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49326,'forelimb',255,4,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49327,'forelimb',255,4,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49328,'forelimb',255,4,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49329,'forelimb',255,4,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49330,'forelimb',255,4,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49331,'forelimb',255,4,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49332,'forelimb',255,4,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49333,'forelimb',255,4,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49334,'forelimb',255,4,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49335,'forelimb',255,4,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49336,'forelimb',255,4,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49337,'forelimb',255,4,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49338,'forelimb',255,4,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49339,'forelimb',255,4,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49340,'forelimb',255,4,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49341,'forelimb',255,4,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49342,'forelimb',255,4,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49343,'forelimb',255,4,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49344,'forelimb',255,4,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49345,'forelimb',255,4,125,0.1077019,93.4697516,119.6684428,1.8,93.45714,119.668108,1.4701296,0.2910438,0.6644607,0.0067578,0.024394,0.017769,0.0367125,0.0232193,0.0455566,1.718752,2.14844,2.2142974,5.3647756),(49346,'forelimb',255,4,126,6.9587157,91.9549836,121.0801646,1.8,91.523544,121.615454,-1.1456589,2.1337096,6.8050919,5.2240438,74.7403591,0.9624929,10.9830052,2.4483387,11.7443874,7.2920472,12.2140278,2.2565258,32.9437697),(49347,'forelimb',255,4,127,17.4317575,91.1743626,121.9377823,1.8,91.1061328,121.9437006,-1.2109599,2.9758307,6.5028311,20.8830745,249.0943505,2.5450678,38.3055239,7.0175615,41.5148319,12.3988984,15.0329403,0.5404195,53.2307167),(49348,'forelimb',255,4,128,30.1991008,90.9002938,122.1214841,1.8,90.8723922,122.1156445,-1.2721648,3.3810267,7.472291,47.5440442,423.5521975,4.5975058,56.6830438,14.0620137,62.8436266,13.6412196,15.8519352,0.5729661,51.7636701),(49349,'forelimb',255,4,129,36.7547598,90.6768866,122.0482621,1.8,90.7110249,122.1161333,-1.3228236,3.7430409,7.8327282,80.8517452,590.7670465,5.7567731,75.4228962,21.6005507,84.9022411,14.5164325,16.4688822,0.2639637,53.1875308),(49350,'forelimb',255,4,130,39.7429412,90.6479221,121.9382841,1.8,90.6328366,122.1558225,-1.3731789,3.9114699,8.0862803,109.2435801,700.8616228,6.3684955,86.6729319,27.9290353,98.5780041,14.9496671,16.9331967,0.6231993,53.5866819),(49351,'forelimb',255,4,131,41.8183702,90.610347,121.8995158,1.8,90.5790729,122.1434479,-1.4009534,3.984053,8.0106187,130.0673375,791.3333982,6.7706012,98.7855526,32.6469898,112.4230168,15.1495931,17.4010378,0.5743048,54.4460579),(49352,'forelimb',255,4,132,42.8124725,90.6192959,121.866559,1.8,90.5700229,122.0756483,-1.4327165,3.8743212,8.3432796,137.2574358,846.5441656,7.0002305,101.4641968,35.4274798,114.9041208,15.2099008,17.533166,0.6287963,54.9494687),(49353,'forelimb',255,4,133,42.5405602,90.6057513,121.7836762,1.8,90.5512169,122.0700955,-1.4357099,3.8818207,8.2571836,135.8921541,875.6282064,6.961496,106.0444151,35.0073242,119.1505151,15.1608597,17.5384304,0.5404195,54.5935035),(49354,'forelimb',255,4,134,43.2118926,90.6639366,121.9063951,1.8,90.5693725,122.1075392,-1.4561974,3.9102339,8.3303096,135.560798,908.3424819,7.1078124,109.0406625,34.6682067,121.6185886,15.0845336,17.5384304,0.5404195,55.6613991),(49355,'forelimb',255,4,135,41.6447604,90.7036781,122.0408877,1.8,90.6240323,122.1525861,-1.4557903,3.9143714,8.4601948,120.6282836,881.6481468,6.8493959,104.2113298,30.8167704,115.2589837,15.0490225,17.4010378,0.5743048,55.5571393),(49356,'forelimb',255,4,136,36.7459758,90.8395366,121.9633283,1.8,90.7592898,122.1543943,-1.4546468,3.6090677,8.3697074,94.1111711,767.9642025,6.0420787,91.7552035,26.0763107,100.5079562,14.7133177,17.5384304,2.1112158,54.4460579),(49357,'forelimb',255,4,137,32.0872685,90.9743274,121.9471962,1.8,90.8834145,122.1256064,-1.4634499,3.4408493,8.1842848,80.1077402,611.1617424,5.2864895,74.6750339,23.281386,84.2832761,14.5293602,17.4010378,2.1451012,53.1264569),(49358,'forelimb',255,4,138,26.5526792,91.1890636,122.4358621,1.8,91.0958091,122.3448689,-1.4526986,3.4761829,7.9480145,58.6241971,450.4949968,4.3640109,56.6801934,16.864532,62.8608636,14.1322321,17.1713991,2.1240907,51.9111157),(49359,'forelimb',255,4,139,22.2301136,91.4581685,122.8753574,1.8,91.4241121,122.857624,-1.4564959,3.0543273,7.4452043,39.1956616,321.8849764,3.6568248,43.2338677,12.8328297,48.1155267,13.331721,16.1519256,2.070143,48.7253171),(49360,'forelimb',255,4,140,18.6236955,91.601556,123.4921433,1.8,91.6288597,123.4229633,-1.4365028,2.7767023,7.2029271,28.4762292,223.4217201,3.048306,31.0181845,10.255413,34.8156755,12.6894912,15.0083566,1.9832068,46.0429293),(49361,'forelimb',255,4,141,16.2033407,91.8096441,123.8132376,1.8,91.7974291,123.9977886,-1.436526,2.5592883,6.6991395,21.1151664,169.7656415,2.6521616,25.34141,8.2504055,28.196679,12.1958801,14.5397175,0.5961991,43.7165067),(49362,'forelimb',255,4,142,13.5486715,91.9771046,124.1577196,1.8,91.9551249,124.3009775,-1.4372867,2.4043099,6.5916573,15.940267,127.5940484,2.2181001,19.3568995,6.629872,21.606665,11.6883871,14.1862129,0.6132073,42.5011655),(49363,'forelimb',255,4,143,12.5225104,92.0876136,124.3815945,1.8,92.0893708,124.4669997,-1.447684,2.2375539,6.3648998,13.0596232,106.3518643,2.0556113,16.7091185,5.8365625,18.6112521,11.4157031,13.8570216,0.5191461,41.6417895),(49364,'forelimb',255,4,144,11.1788946,92.1770362,124.4625953,1.8,92.1761183,124.5704575,-1.4661486,2.1643839,5.9927596,10.2612008,90.1440012,1.8428198,15.0421519,4.7409338,16.579129,11.2793611,13.7096736,0.5619216,40.4264483),(49365,'forelimb',255,4,145,10.5745892,92.3161561,124.4071571,1.8,92.283171,124.5430207,-1.4748264,2.0115323,5.916438,8.25925,77.2123301,1.7462489,13.0504756,4.1059496,14.3185616,11.0082198,13.348021,0.5790743,38.8551419),(49366,'forelimb',255,4,146,9.7470472,92.449603,124.3824979,1.8,92.3999937,124.6009832,-1.4896189,1.7959893,5.4403953,6.4434837,69.1871793,1.6138262,12.7173073,3.5877073,13.7596158,10.8734205,13.1178053,0.551655,38.3517311),(49367,'forelimb',255,4,147,9.0094712,92.5462938,124.4518699,1.8,92.5017699,124.5668559,-1.501257,1.8069106,5.493391,5.0509444,62.1821232,1.494329,11.3194425,2.7953483,12.1276468,10.8547918,12.9905136,0.5971767,38.3517311),(49368,'forelimb',255,4,148,8.522379,92.633812,124.5542871,1.8,92.5841231,124.6811347,-1.5110269,1.5595738,5.1539284,4.0602915,54.7707068,1.4153283,10.6269824,2.6034622,11.3014897,10.6963626,12.6375032,0.6162969,37.4923551),(49369,'forelimb',255,4,149,8.0092706,92.767506,124.5526097,1.8,92.7334549,124.6132892,-1.5179649,1.3299829,5.1399934,3.1188639,49.5914329,1.331156,9.6481511,2.3450406,10.1778181,10.4643945,12.4905505,0.7123576,36.7804247),(49370,'forelimb',255,4,150,7.4792095,92.864304,124.6051453,1.8,92.7712918,124.7376001,-1.5226623,1.3803459,4.7555858,2.5288322,42.2350395,1.2436491,8.8811433,1.8320279,9.3437781,10.3744347,12.1610055,0.5585993,36.0253085),(49371,'forelimb',255,4,151,6.8683581,92.970572,124.6598109,1.8,92.8911531,124.6788245,-1.5330565,1.4154702,4.7999223,1.9307029,35.1264406,1.1430967,7.3181269,1.3640011,7.675337,10.2214909,11.9388329,0.5280744,35.4176379),(49372,'forelimb',255,4,152,6.2392113,93.0572253,124.7381767,1.8,92.9679169,124.7700059,-1.5358905,1.1378019,4.8737215,1.5120595,28.8560826,1.0386021,5.9207492,1.3289304,6.2051912,10.0552132,11.7988288,0.5779019,35.0616727),(49373,'forelimb',255,4,153,5.7244803,93.1503034,124.8242044,1.8,93.0216454,124.6850057,-1.5460105,1.2020243,4.5231076,1.194652,24.6147203,0.953494,5.4419931,0.9938668,5.6828488,10.0447974,11.7282,0.4964228,34.5582619),(49374,'forelimb',255,4,154,5.2211069,93.2352557,124.8648722,1.8,93.1140309,124.7121321,-1.5505604,0.8921063,4.5601371,0.9084965,20.7513125,0.8698282,4.5505896,1.0183725,4.7363169,9.9050289,11.7988288,0.5779019,34.4540021),(49375,'forelimb',255,4,155,4.5576634,93.3025444,124.9125291,1.8,93.1563584,124.8673328,-1.5531375,0.9400063,4.1760745,0.6921776,17.011476,0.7593737,4.0735567,0.7363542,4.2287141,9.7657088,11.7988288,0.5779019,34.2022967),(49376,'forelimb',255,4,156,4.0165804,93.3708672,124.9198003,1.8,93.2260814,124.7635591,-1.5589646,0.9915491,4.1807426,0.5078614,13.5366022,0.6693364,3.2378464,0.5121898,3.3532526,9.8020172,11.5697035,0.5467888,34.2022967),(49377,'forelimb',255,4,157,3.4819315,93.4313728,124.9579502,1.8,93.3091364,124.8768814,-1.5647019,0.6313516,3.7873303,0.3504191,10.1084295,0.5803004,2.6690119,0.5550301,2.756992,9.7057419,11.6887773,0.6287963,34.0980369),(49378,'forelimb',255,4,158,2.8827734,93.4734727,124.9879373,1.8,93.3414548,124.8188552,-1.5662855,0.6664414,3.8167779,0.2526101,7.2165218,0.4804525,1.8907366,0.3790432,1.9547168,9.6113822,11.5697035,0.5467888,33.5946261),(49379,'forelimb',255,4,159,2.3001203,93.5165225,124.9990414,1.8,93.3985462,124.9610829,-1.5682335,0.7049104,3.3977246,0.1633762,5.1678599,0.3833509,1.5209767,0.2317687,1.5675991,9.4196563,11.5697035,0.5467888,33.5946261),(49380,'forelimb',255,4,160,1.8319948,93.562738,124.9496066,1.8,93.4969259,124.911893,1.568766,0.3249853,3.3476738,0.0924187,3.8555496,0.3053312,1.15171,0.284378,1.178609,9.6113822,11.6887773,0.6287963,34.0980369),(49381,'forelimb',255,4,161,1.4204898,93.5808981,124.8486756,1.8,93.4929473,124.824364,1.559975,0.3592428,2.816133,0.0658453,2.5749757,0.2367206,0.9143658,0.183289,0.9368747,9.7587078,11.5697035,0.5467888,33.8463315),(49382,'forelimb',255,4,162,1.1198757,93.5980938,124.7810217,1.8,93.5287547,124.7527493,1.5549716,0.3734376,2.8371284,0.04679,1.7515587,0.1865992,0.6173703,0.1252953,0.6338292,9.7587078,11.7988288,0.5779019,34.4540021),(49383,'forelimb',255,4,163,0.8793508,93.6084754,124.7842439,1.8,93.5287547,124.824364,1.5588939,0.3794164,2.4039897,0.0341448,1.1396017,0.1465377,0.474046,0.089993,0.488198,9.6932128,11.5697035,0.5467888,33.9505913),(49384,'forelimb',255,4,164,0.6724513,93.621361,124.7510929,1.8,93.5456052,124.7611746,1.5538266,0.3911907,2.4370633,0.023372,0.8191154,0.1120429,0.3361076,0.0597458,0.3456953,9.6572864,11.7282,0.4964228,34.5582619),(49385,'forelimb',255,4,165,0.5097516,93.6388295,124.7379406,1.8,93.5728252,124.7747846,1.5510842,0.4023947,2.0202804,0.0146621,0.507481,0.0849256,0.2511933,0.0364371,0.2584494,9.7857699,11.5697035,0.5467888,34.5582619),(49386,'forelimb',255,4,166,0.3829711,93.671984,124.6837816,1.8,93.671984,124.824364,1.5547304,0.0333221,2.0739107,0.005987,0.3724346,0.063812,0.1795808,0.1796706,0.1824441,9.5451124,11.3440887,0.4297623,33.6988859),(49387,'forelimb',255,4,167,0.3089505,93.671984,124.591545,1.8,93.671984,124.60952,1.5514382,0.0336177,1.7364016,0.0048455,0.2500947,0.0514725,0.1440305,0.1441344,0.1467935,9.5776351,11.171888,0.3947911,33.6988859),(49388,'forelimb',255,4,168,0.2441056,93.671984,124.5675656,1.8,93.671984,124.60952,1.543372,0.0364977,1.3305179,0.0038587,0.1404672,0.0406537,0.1055733,0.1057238,0.1084327,9.9508312,11.1470707,0.4808873,34.5582619),(49389,'forelimb',255,4,169,0.2164668,93.671984,124.5491038,1.8,93.671984,124.60952,1.5427493,0.037844,1.3489495,0.0034238,0.1218616,0.0360494,0.0903381,0.0904727,0.0928398,9.4196563,11.0137676,0.3587707,34.2022967),(49390,'forelimb',255,4,170,0.1976679,93.671984,124.5461553,1.8,93.671984,124.60952,1.5423045,0.038528,1.3518798,0.0031279,0.1095825,0.0329179,0.0810593,0.0811838,0.0833392,9.361211,11.0137676,1.929567,33.8031457),(49391,'forelimb',255,4,171,0.1831212,93.671984,124.5475546,1.8,93.671984,124.60952,1.5423501,0.0384265,1.3504828,0.0028975,0.1016772,0.0304955,0.0752895,0.0754048,0.0774037,9.6290896,10.980189,2.1045045,35.0184869),(49392,'forelimb',255,4,172,0.1633152,93.671984,124.4362611,1.8,93.671984,124.394676,1.5358854,0.0389459,1.1151252,0.0026003,0.0742847,0.027186,0.0666156,0.0667673,0.0689054,9.1417086,11.0137676,1.929567,33.5514403),(49393,'forelimb',255,4,173,0.1554823,93.671984,124.428615,1.8,93.671984,124.394676,1.5345015,0.0402116,1.1074292,0.0024789,0.0681014,0.0258796,0.0614951,0.0616461,0.0636915,9.3047999,11.0137676,1.929567,33.1954751),(49394,'forelimb',255,4,174,0.1541396,93.671984,124.4331218,1.8,93.671984,124.394676,1.5339921,0.0409415,1.1119123,0.0024587,0.0666061,0.0256551,0.0599023,0.0600533,0.0620714,9.115059,11.2048922,2.1375255,33.1954751),(49395,'forelimb',255,4,175,0.1500553,93.671984,124.4071725,1.8,93.671984,124.394676,1.5335917,0.0404215,1.0859645,0.0023944,0.0641639,0.0249746,0.0590847,0.0592369,0.0612472,8.8112237,11.2048922,2.1375255,32.9437697),(49396,'forelimb',255,4,176,0.1533003,93.671984,124.3879327,1.8,93.671984,124.394676,1.5331659,0.0406675,1.080198,0.0024472,0.0648318,0.0255139,0.0600184,0.0601764,0.0622399,8.7141048,11.2048922,2.1375255,32.3360991),(49397,'forelimb',255,4,177,0.1738896,93.671984,124.3468407,1.8,93.671984,124.394676,1.5335695,0.0417609,1.1212779,0.0027748,0.0743124,0.0289414,0.0662747,0.0664456,0.0687018,8.4220532,11.2048922,2.1375255,31.4767231),(49398,'forelimb',255,4,178,0.186534,93.671984,124.3307512,1.8,93.671984,124.394676,1.5327672,0.0432722,1.1373219,0.0029789,0.0780843,0.0310441,0.0686563,0.0688407,0.0712239,8.392812,11.2048922,2.1375255,31.1207579),(49399,'forelimb',255,4,179,0.2006332,93.671984,124.3214637,1.8,93.671984,124.394676,1.532765,0.0436279,1.1466026,0.0032041,0.0839815,0.0333905,0.0732438,0.0734406,0.0759832,8.2035531,11.4413255,2.1692152,31.1207579),(49400,'forelimb',255,4,180,0.2321325,93.671984,124.2369995,1.8,93.671984,124.179832,1.5385718,0.0433741,1.3455325,0.0036865,0.1141377,0.0386486,0.0848272,0.0849926,0.0875215,8.3400236,11.4413255,2.1692152,31.7284285),(49401,'forelimb',255,4,181,0.2639115,93.671984,124.2358545,1.8,93.671984,124.179832,1.5392015,0.0424907,1.3444152,0.0041886,0.1322804,0.0439414,0.0983925,0.0985772,0.1014574,7.8997178,11.4413255,2.1692152,30.8690525),(49402,'forelimb',255,4,182,0.2970893,93.671984,124.211391,1.8,93.671984,124.179832,1.539144,0.0417937,1.3199615,0.0047155,0.1486469,0.0494653,0.1126146,0.1128267,0.1161288,7.8997178,11.2048922,2.1375255,30.2613819),(49403,'forelimb',255,4,183,0.363277,93.6414764,124.1965086,1.8,93.5764978,124.2275751,1.5488715,0.4081389,1.304758,0.01018,0.1727498,0.0605171,0.1323999,0.0249425,0.1400584,7.8478858,11.0889478,2.1910458,30.2613819),(49404,'forelimb',255,4,184,0.4325978,93.6248028,124.1598814,1.8,93.5430776,124.179832,1.5390471,0.3965873,1.3098526,0.0146962,0.2016833,0.072027,0.1539741,0.0370566,0.1651923,8.2660287,10.980189,2.1045045,32.0843937),(49405,'forelimb',255,4,185,0.5140037,93.6205356,124.1056527,1.8,93.5547964,124.0235818,1.5467818,0.3902295,1.6428631,0.0181465,0.267267,0.0856179,0.1626837,0.0465021,0.1734639,7.834692,10.8448348,2.1587989,29.6537113),(49406,'forelimb',255,4,186,0.6285313,93.5985461,124.0765983,1.8,93.5067194,124.0476203,1.5488957,0.3772448,1.6135226,0.026388,0.3378336,0.104705,0.2093764,0.0699494,0.2252193,7.8804744,10.7679504,2.070143,29.0460407),(49407,'forelimb',255,4,187,0.7278408,93.5909282,124.0477448,1.8,93.5067194,124.0476203,1.552618,0.3665968,1.5849293,0.0320523,0.3976841,0.1212667,0.250916,0.0874321,0.2704899,7.8997178,10.6125107,2.1251038,29.0460407),(49408,'forelimb',255,4,188,0.8537821,93.5812596,124.0254991,1.8,93.5067194,124.0476203,1.5557743,0.3541527,1.5628798,0.0396894,0.4697165,0.1422649,0.3005455,0.1120686,0.3250737,7.8997178,10.4635866,1.9055332,28.7943353),(49409,'forelimb',255,4,189,1.0001447,93.5678791,123.9792901,1.8,93.487832,123.964988,1.5467295,0.3509952,1.5152652,0.0497254,0.5713765,0.1665943,0.3770802,0.1416696,0.408143,7.8997178,10.2496576,2.1471715,28.7943353),(49410,'forelimb',255,4,190,1.1795733,93.552573,123.9340194,1.8,93.45714,123.857566,1.5564249,0.7434212,1.9007149,0.0664323,0.7232714,0.1965549,0.380526,0.0893603,0.4142445,7.8997178,10.0587382,1.9195673,28.1866647),(49411,'forelimb',255,4,191,1.3989494,93.5222531,123.9049272,1.8,93.3779869,123.8179895,1.5575957,0.7188841,1.8713955,0.0986355,0.8693924,0.2331176,0.464569,0.1372064,0.515043,7.8997178,9.9942879,2.0152155,27.5789941),(49412,'forelimb',255,4,192,1.6194445,93.4985649,123.8803048,1.8,93.349718,123.7931128,1.5522816,0.6993398,1.8453853,0.1306642,1.0199227,0.2698149,0.5526882,0.1868393,0.6195851,8.1097181,9.8172189,1.9756881,27.8306995),(49413,'forelimb',255,4,193,1.8466535,93.469143,123.8358447,1.8,93.3204211,123.8282691,1.5534168,0.6698813,1.8006551,0.1678541,1.2122582,0.3076826,0.6732318,0.2505729,0.7600501,8.164072,9.5115493,1.8925469,27.5789941),(49414,'forelimb',255,4,194,2.0504758,93.4455387,123.8288852,1.8,93.3204211,123.8282691,1.5541768,0.6458165,1.7934817,0.2015994,1.3641446,0.3416516,0.7606125,0.312162,0.8642399,7.734384,9.4335845,2.0955921,27.4747343),(49415,'forelimb',255,4,195,2.2956444,93.4209635,123.8176483,1.8,93.3139107,123.7859513,1.5684573,0.6112112,2.2153511,0.2431614,1.63376,0.3826053,0.7374723,0.3978353,0.8416248,7.734384,9.2557628,1.9513027,26.8670637),(49416,'forelimb',255,4,196,2.6155049,93.3812267,123.8021316,1.8,93.2136501,123.750144,1.5578658,1.003107,2.1964841,0.3355295,2.0080189,0.4358446,0.9141969,0.3344902,1.0558644,8.164072,9.1049255,1.9074711,26.9713235),(49417,'forelimb',255,4,197,2.9174059,93.3493389,123.795491,1.8,93.1868524,123.7778658,1.5624512,0.9731784,2.1910181,0.4172584,2.3164732,0.4862005,1.0572588,0.4287584,1.2328622,8.0183974,9.1049255,1.9074711,26.7196181),(49418,'forelimb',255,4,198,3.1862409,93.3204033,123.7815016,1.8,93.1617295,123.750144,1.5600547,0.9463233,2.1758954,0.5010689,2.6122021,0.5309789,1.2005182,0.5294902,1.4100158,7.734384,9.1856803,1.7590178,26.9713235),(49419,'forelimb',255,4,199,3.4652028,93.2969028,123.771873,1.8,93.1617295,123.750144,1.5553468,0.9268145,2.1641154,0.5818036,2.9807423,0.577396,1.3773491,0.6277454,1.6176155,7.734384,9.3845276,1.2924967,26.7196181),(49420,'forelimb',255,4,200,3.850132,93.2737288,123.7960382,1.8,93.1468098,123.750144,1.5507317,0.9069507,2.1945231,0.6763381,3.7253218,0.6414304,1.6975542,0.7457275,1.9736779,7.734384,9.6081158,1.1071487,27.2230289),(49421,'forelimb',255,4,201,4.3314055,93.2299299,123.8286697,1.8,93.0524339,123.750144,1.5532177,1.2826733,2.648473,0.8955096,4.5552957,0.7216779,1.7199706,0.6981588,2.0239288,7.5958825,9.6560368,1.0074801,27.3272887),(49422,'forelimb',255,4,202,4.9682733,93.1778428,123.8369671,1.8,92.9994289,123.7968492,1.5512919,1.2394452,2.6548069,1.1873701,5.6453604,0.8277306,2.1264675,0.9579852,2.5209527,7.5958825,9.9942879,1.1263771,27.5789941),(49423,'forelimb',255,4,203,5.5580319,93.1377515,123.8684562,1.8,92.9558373,123.8259713,1.5521267,1.2061692,2.685997,1.4515293,6.9719983,0.9260158,2.5956836,1.2034209,3.0643788,7.5958825,10.2496576,0.9944211,27.8306995),(49424,'forelimb',255,4,204,6.1104166,93.10418,123.9069443,1.8,92.927703,123.849893,1.548362,1.5767209,2.8630355,1.7247156,8.3700184,1.0178903,2.9234769,1.0938624,3.4725519,7.5958825,11.0889478,0.9505468,29.2977461),(49425,'forelimb',255,4,205,6.7659154,93.0593597,123.9590826,1.8,92.8548724,123.9403338,1.5503944,1.5487654,2.8107928,2.124039,9.9866944,1.1271833,3.5529814,1.3714401,4.2269265,7.5631659,12.1610055,1.012197,30.7647927),(49426,'forelimb',255,4,206,7.48307,93.0160567,124.0097469,1.8,92.8258292,123.9352404,1.5572737,1.5004864,3.2582506,2.5588571,11.9296665,1.2469503,3.6613717,1.7053517,4.3475049,7.2920472,12.89064,0.9272952,32.3360991),(49427,'forelimb',255,4,207,8.2430256,92.9713345,124.0817449,1.8,92.8063806,124.0677395,1.5645453,1.4537474,3.3349719,3.0520367,14.2188595,1.3737839,4.263562,2.0994271,5.0616208,7.2920472,13.2369013,0.9467733,32.9437697),(49428,'forelimb',255,4,208,9.1419585,92.915119,124.1559832,1.8,92.7177418,124.1296087,-1.5670144,1.8227849,3.4164932,3.7283429,17.1632799,1.523638,5.023654,2.0454103,5.9749186,7.467281,13.7567282,0.8960554,34.4108163),(49429,'forelimb',255,4,209,10.3304836,92.83759,124.2257351,1.8,92.6277422,124.219803,-1.5510187,1.761296,3.4992271,4.7576744,21.1734179,1.7210739,6.0508842,2.7012349,7.2393863,7.2695682,14.3608389,0.8913825,35.0184869),(49430,'forelimb',255,4,210,11.4104117,92.766195,124.3162645,1.8,92.5738924,124.2753182,-1.5348378,1.7225057,3.60419,5.7802683,24.9916344,1.8992774,6.9340503,3.3557325,8.3462059,7.2695682,14.6975909,0.9097532,35.6261575),(49431,'forelimb',255,4,211,12.4957108,92.6727378,124.4346597,1.8,92.4924483,124.4662907,-1.5120298,2.045306,3.7446462,7.0648795,29.81559,2.0754344,7.9621914,3.4541919,9.6415637,6.9882119,15.240301,0.8652281,36.5897933),(49432,'forelimb',255,4,212,13.8041907,92.5723879,124.5378171,1.8,92.3601047,124.5144563,-1.4844105,2.0061363,3.8762074,8.7638974,35.4724366,2.2835721,9.1513258,4.3685453,11.1946427,7.1885817,15.5698916,0.8831251,37.4491693),(49433,'forelimb',255,4,213,15.1443936,92.4590927,124.6431576,1.8,92.2543519,124.6805708,-1.4387914,2.0099617,4.4524851,10.6344874,43.5519913,2.4803379,9.7815019,5.2908906,12.0490321,7.1763826,16.4183554,0.8224183,38.9162159),(49434,'forelimb',255,4,214,15.9723272,92.307851,124.7376783,1.8,92.1100524,124.7882953,-1.4014216,2.2101666,4.5916642,12.4287582,51.5921324,2.5864135,11.2360422,5.6234485,13.8258187,7.1075923,16.7357822,0.7309067,39.8798517),(49435,'forelimb',255,4,215,16.9117113,92.1611588,124.787505,1.8,91.9818779,124.8386869,-1.3645155,2.2353893,4.6894441,14.5699883,60.5503915,2.7003729,12.9120618,6.5178752,15.9051255,7.1365101,17.321277,0.7678561,41.0951929),(49436,'forelimb',255,4,216,17.4154204,92.01329,124.8056158,1.8,91.8206122,124.9065882,-1.3185257,2.4020443,4.7647805,17.1784576,68.5196198,2.7217346,14.3804359,7.151599,17.8933799,7.096608,17.6224473,0.7853982,42.0588287),(49437,'forelimb',255,4,217,17.4131265,91.8359691,124.7480042,1.8,91.6179263,124.9820818,-1.2431219,2.5235068,4.7902803,19.8696731,74.055886,2.6015724,15.4596145,7.8738337,19.5663784,7.096608,17.9494415,0.7345945,42.3105341),(49438,'forelimb',255,4,218,17.1418296,91.5918337,124.6010085,1.8,91.378732,124.9038919,-1.1279399,2.8037823,4.7660656,20.8813615,77.1565693,2.3323425,16.1887344,7.4475688,20.5692003,7.0823427,17.9905393,0.7008544,45.2446273),(49439,'forelimb',255,4,219,18.622073,91.3422808,124.6172336,1.8,91.1436093,124.9464859,-1.0224534,3.1040488,4.9097524,24.4487224,86.1461031,2.2603274,17.545916,7.8763975,22.5086266,6.9716035,18.3210418,0.6857295,47.0676391),(49440,'forelimb',255,4,220,21.8549754,90.9857121,124.7872228,1.8,90.8157005,125.0142986,-0.8821077,3.3264703,4.9644735,31.1052926,106.5594372,2.1713199,21.4643983,9.3508404,27.701345,7.0106263,18.8769524,0.7209713,47.2150847),(49441,'forelimb',255,4,221,24.1899519,90.5713088,125.0223149,1.8,90.5068715,125.1408752,-0.793927,3.4279026,5.2258386,35.2373466,123.3809275,2.0502131,23.6097856,10.2795646,30.012247,6.9029433,19.201814,0.7061991,46.3557087),(49442,'forelimb',255,4,222,24.7110052,90.3516876,125.2298635,1.8,90.2686393,125.3394502,-0.6844275,3.616044,5.1379941,39.785856,125.9185686,1.6462233,24.5073401,11.0025919,31.6040565,6.8986736,19.5967879,0.6610432,47.3193445),(49443,'forelimb',255,4,223,24.3572955,90.1041912,125.4646391,1.8,89.9265369,125.5834795,-0.5057133,3.23569,4.8960443,40.9994275,124.0216308,0.9526706,25.3309864,12.6709997,33.3281825,6.9554958,20.0300987,0.6177557,47.5710499),(49444,'forelimb',255,4,224,24.0638988,89.709735,125.7899811,1.8,89.6540547,125.8500708,-0.3505772,3.0679158,4.8645215,39.3395593,127.2438342,0.4730603,26.1575234,12.8228939,32.1898025,7.1516065,20.3818914,0.6055447,48.8295769),(49445,'forelimb',255,4,225,23.3791387,89.4895223,125.9759035,1.8,89.2116541,126.0721443,-0.2724768,2.9741531,5.2197643,37.4590896,138.6101745,0.282203,26.5548721,12.5948762,33.4387638,7.1140164,21.2250215,0.5543075,51.2602593),(49446,'forelimb',255,4,226,24.8832163,89.1877862,126.1706736,1.8,88.8771623,126.23675,-0.2328782,2.9283763,5.5867561,39.5274694,168.0235378,0.2208757,30.075331,13.4980839,37.1349851,7.3735552,21.8169824,0.560687,53.5866819),(49447,'forelimb',255,4,227,26.2211253,88.7554326,126.2916332,1.8,88.6326595,126.2423344,-0.2227094,3.5041734,5.6504127,44.8815411,212.8923999,0.2131989,37.6773187,12.8080253,45.4282485,7.6076314,22.4961264,0.4978223,56.3733294),(49448,'forelimb',255,4,228,30.1805258,88.6858933,126.1150191,1.8,88.6474478,126.1070338,-0.2784517,4.0319233,5.9473343,64.4126899,269.3393893,0.3800334,45.2874141,15.9756734,56.1028897,8.2619802,22.874581,0.4888524,59.559128),(49449,'forelimb',255,4,229,29.9880611,88.813835,125.8685205,1.8,88.7888242,125.8885621,-0.3384907,3.9810109,6.1308902,71.490177,279.7127747,0.5511125,45.6235174,17.957795,57.2137399,8.6070663,22.9068442,0.4048918,60.2099845),(49450,'forelimb',255,4,230,29.3146027,89.4567219,125.565633,1.8,89.2824766,125.6708751,-0.3565778,4.6020411,6.5798914,80.7171803,269.7720598,0.5953278,40.9994698,17.5394306,53.2428775,9.3618851,23.139407,0.3805064,61.0693605),(49451,'forelimb',255,4,231,23.6350495,90.5661474,125.2219286,1.8,90.0676414,125.3886246,-0.3630236,4.6437526,7.0333452,78.4559529,152.5052746,0.4967211,21.6831778,16.8949467,32.7311295,9.6432513,18.1285566,0.5485494,49.3761735),(49452,'forelimb',255,4,232,20.3871528,91.7046639,124.9546402,1.8,91.4646528,124.9127009,1.2431303,2.8034518,4.5049118,30.6288703,74.7352001,3.0459182,16.5897143,10.9254135,23.3139302,9.9654612,17.2946084,0.4636476,48.9770225),(49453,'forelimb',255,4,233,19.7773643,91.8629971,125.0424718,1.8,91.5472837,124.9537452,1.2273493,2.7172765,4.1027309,26.1503101,63.2179736,2.9224671,15.4087545,9.6237207,21.0476531,9.8854524,16.9495441,0.5317241,48.2650921),(49454,'forelimb',255,4,234,16.3885879,91.8848812,125.062617,1.8,91.7011484,125.0105621,1.1648662,2.6691527,3.7759384,17.8709433,40.411661,2.3055328,10.7024152,6.695362,14.8098616,9.6603265,16.2146739,0.5585993,46.6937857),(49455,'forelimb',255,4,235,10.0668518,91.7339521,125.156423,1.8,91.6870536,125.1418768,1.0782847,2.3726387,3.2871812,7.3212784,17.7206792,1.3026873,5.3908434,3.0857115,7.5550606,4.756543,6.9285108,2.0899424,18.0647842),(49456,'forelimb',255,4,236,2.9644031,91.3072402,125.2379217,1.8,91.3309252,125.2096015,1.1004612,1.438389,2.1954194,1.0872179,2.6572031,0.3925973,1.2103397,0.755858,1.7042136,3.2614091,4.8040579,2.0344439,12.1965978),(49457,'forelimb',255,4,237,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49458,'forelimb',255,4,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49459,'forelimb',255,4,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49460,'forelimb',255,4,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49461,'forelimb',255,4,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49462,'forelimb',255,4,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49463,'forelimb',255,4,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49464,'forelimb',255,4,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49465,'forelimb',255,4,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49466,'forelimb',255,4,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49467,'forelimb',255,4,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49468,'forelimb',255,4,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49469,'forelimb',255,4,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49470,'forelimb',255,4,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49471,'forelimb',255,4,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49472,'forelimb',255,4,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49473,'forelimb',255,4,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49474,'forelimb',255,4,254,3.7996101,85.6791684,124.339225,1.8,85.7043408,124.3762608,0.6760494,1.6587155,2.1828413,1.8363704,3.2184221,0.2479377,1.4744187,1.1071039,2.3008815,3.6460236,4.899197,2.2318395,13.1602336),(49475,'forelimb',255,4,255,14.9917087,85.8733151,124.2356836,1.8,86.012666,124.179832,0.602687,2.7162469,3.3204633,18.8345962,31.4209774,0.8028762,9.4628292,6.9340517,14.2154041,5.7728707,7.3926319,2.1910458,20.8514317),(49476,'forelimb',255,4,256,21.4676403,85.7720173,123.9542699,1.8,85.9317934,124.0540225,0.512277,3.2050887,4.2107988,42.9274235,68.2567058,0.8596359,16.2099184,13.3935211,24.6510876,6.6843766,8.5614727,2.8357138,23.8897847),(49477,'forelimb',255,4,257,23.8963874,85.6303234,123.7918724,1.8,85.7507791,123.9029974,0.4432285,3.2848028,4.6941954,49.5592654,100.1735747,0.7325014,21.3398818,15.0874401,31.3897021,7.1113101,9.2955727,2.5535901,26.1119475),(49478,'forelimb',255,4,258,23.3146854,85.3169249,123.8133475,1.8,85.5178279,123.8906189,0.4589531,3.4134081,4.9472283,46.5770029,107.5206082,0.7626144,21.7335044,13.6453072,31.1393068,7.1583748,9.6560368,2.5782764,26.0076877),(49479,'forelimb',255,4,259,20.8855467,85.0958123,123.9488167,1.8,85.1935061,123.9562545,0.4106906,3.217913,4.9242864,37.4895321,102.2263566,0.5548408,20.7596284,11.6502627,28.2354413,6.875008,9.6560368,2.5782764,26.0076877),(49480,'forelimb',255,4,260,17.9712739,84.8765606,124.0637736,1.8,84.9324708,124.0586865,0.3607982,2.9576417,4.8566331,27.3468394,90.6723298,0.3732751,18.6697921,9.2461639,24.2921006,6.3231965,9.6560368,2.5782764,25.4000171),(49481,'forelimb',255,4,261,17.045989,84.6104075,124.1055635,1.8,84.5978652,124.1028125,0.3558683,2.8186849,4.6880918,22.4440948,88.0418557,0.3448562,18.7798915,7.9626123,23.5518188,5.9587733,9.4335845,2.6167969,24.5406411),(49482,'forelimb',255,4,262,17.4134062,84.3661712,124.1660869,1.8,84.369652,124.1963585,0.3348602,2.6553508,4.7530479,21.0053455,93.4293576,0.3134482,19.6567256,7.9105725,24.0360277,5.6300939,9.6560368,2.7776137,24.7923465),(49483,'forelimb',255,4,263,18.3324249,84.1859116,124.2310909,1.8,84.165137,124.2418062,0.333163,2.5331812,4.902596,21.3864939,102.3713567,0.3267787,20.881051,8.4425439,25.1651382,5.4553241,9.9201178,2.8335399,24.8966063),(49484,'forelimb',255,4,264,19.5043891,84.0976119,124.3302259,1.8,84.0307357,124.3758648,0.3199145,2.6743161,4.6871768,23.7840697,116.6067914,0.3215008,24.8778307,8.8935147,29.9453893,5.5936373,9.8172189,2.7367009,25.1483117),(49485,'forelimb',255,4,265,22.2764953,84.1010941,124.5147745,1.8,83.9548448,124.5093808,0.2928943,3.0604933,4.8814254,31.3387421,136.0237925,0.3095016,27.8655888,10.2397681,34.2494924,6.1168776,10.2135672,2.8864103,26.9713235),(49486,'forelimb',255,4,266,27.2896957,84.1223999,124.7393452,1.8,83.9245196,124.8172812,0.2609358,4.2228195,5.2545801,50.5069732,162.9829252,0.3027162,31.0173075,11.9604859,40.6261412,7.5602383,10.6298941,2.896614,28.8985951),(49487,'forelimb',255,4,267,33.2580577,84.1480397,125.0230335,1.8,83.9456513,125.1492824,0.1871717,4.7266885,5.4733578,95.1120452,208.1576122,0.1919325,38.0310627,20.1223424,53.2581895,8.4808274,11.0472442,2.9060477,32.3360991),(49488,'forelimb',255,4,268,35.585649,84.2784746,125.0029326,1.8,84.0990195,125.1493534,0.0857212,4.7504602,5.8056768,112.3498285,263.6622154,0.0434747,45.414553,23.6503043,62.3802208,8.6249495,11.7988288,2.9584818,34.1591109),(49489,'forelimb',255,4,269,36.101499,84.0648399,125.0047647,1.8,83.9848001,125.0944193,0.1641921,4.3181315,5.9878638,105.8160558,276.5823599,0.1607579,46.1904892,24.5050565,63.7540941,8.3941081,12.1534119,2.9996956,34.0116653),(49490,'forelimb',255,4,270,35.5957758,83.7617552,125.0809282,1.8,83.7345176,125.1311066,0.2960127,3.9276472,5.9556715,86.2813555,269.6320042,0.5048307,45.2731492,21.9676951,59.5724844,7.5656758,12.1001239,2.8535372,32.0843937),(49491,'forelimb',255,4,271,33.6895926,83.2676427,125.0243846,1.8,83.3278975,125.0515632,0.3686736,3.9089274,5.6478883,62.7090016,235.7605865,0.7292262,41.7431391,16.0425085,52.5828847,7.0560922,11.7360686,2.7270858,31.0164981),(49492,'forelimb',255,4,272,26.5739398,82.2949433,124.6390538,1.8,82.4781041,124.7313213,0.3104331,3.4644882,5.474513,42.5118757,134.0970134,0.4132805,24.494784,12.270752,31.8138302,6.4207936,10.9549375,2.6954871,28.3341103),(49493,'forelimb',255,4,273,22.8748701,81.7152227,124.3674708,1.8,81.7595277,124.3758648,0.2445965,3.1850018,4.2860315,33.7948415,97.1596312,0.2235783,22.6689028,10.6106194,29.3988459,6.2905995,8.8582451,2.7430702,25.0440519),(49494,'forelimb',255,4,274,21.5784194,81.5286566,124.325929,1.8,81.5543712,124.3566414,0.2386417,3.0685673,4.3038955,31.7529659,92.3357341,0.200956,21.4539907,10.3478149,28.2369047,6.015632,8.8582451,0.2449787,24.8966063),(49495,'forelimb',255,4,275,20.9897237,81.3915269,124.3890512,1.8,81.410251,124.4806136,0.2450516,3.2798735,4.2902545,34.9538359,94.0650804,0.2059017,21.9252913,10.6570684,28.3837892,6.3917383,8.8582451,0.2449787,25.7559823),(49496,'forelimb',255,4,276,21.7172289,81.3225009,124.5636189,1.8,81.3621511,124.6987349,0.2734897,4.0298784,4.398672,45.4124861,99.6278279,0.2640463,22.6495242,11.268947,30.9661267,7.304696,8.9721488,0.2914568,27.3272887),(49497,'forelimb',255,4,277,24.5078543,81.4176052,124.8457204,1.8,81.3844986,124.9866906,0.3221136,4.4613368,4.7546898,63.4944557,119.8073452,0.4093545,25.1977205,14.2321592,36.9189198,7.734384,9.798394,0.9097532,29.5494515),(49498,'forelimb',255,4,278,27.1459626,81.6260234,125.0616236,1.8,81.6016575,125.1940114,0.3528879,4.6000029,5.1717866,76.2685714,154.102962,0.5404115,29.7968522,16.5801138,44.4055138,8.164072,10.6125107,2.5872852,30.9122383),(49499,'forelimb',255,4,279,29.5300624,81.9936003,125.203774,1.8,82.0206271,125.364094,0.3717029,4.4764286,5.5726635,79.9087777,212.9238119,0.6492485,38.2086255,17.8510113,52.0232523,7.734384,11.7988288,2.5636907,32.6309903),(49500,'forelimb',255,4,280,30.612676,82.1138399,125.1495755,1.8,82.0691253,125.2675198,0.2888186,4.1031258,5.794799,76.0676739,242.0450215,0.4138956,41.769356,18.5389572,54.3446929,7.6674942,11.9156132,2.6940727,33.0912153),(49501,'forelimb',255,4,281,31.5299603,82.1820137,125.0378935,1.8,82.101753,125.1580579,0.1907287,3.804907,5.9198145,67.7660033,264.6647793,0.1888563,44.7082891,17.8101603,55.8634902,7.1748509,11.9697226,2.7744188,31.7716143),(49502,'forelimb',255,4,282,29.7934145,81.915047,124.8386229,1.8,81.9532204,124.9527124,0.1107069,3.4089573,5.8232636,50.6114787,255.7287463,0.0606099,43.9150216,14.8466157,52.4705201,6.7026021,11.9851376,2.8879186,31.2682035),(49503,'forelimb',255,4,283,26.0818682,81.197511,124.7569408,1.8,81.2444708,124.8068087,0.1226384,3.0475148,5.2180428,38.1068696,176.9305373,0.0650522,33.9074521,12.5042445,40.82808,6.015632,10.7422,2.8577985,27.3704745),(49504,'forelimb',255,4,284,23.9734292,80.628221,124.7369572,1.8,80.7012327,124.7697426,0.1387923,2.9503886,4.8745824,33.3944131,132.544416,0.0764749,27.1909272,11.3186491,33.3312763,5.8860435,10.0311674,2.9694018,26.2593931),(49505,'forelimb',255,4,285,22.3225973,80.2363164,124.6925011,1.8,80.3456323,124.6878276,0.1252885,2.8874961,4.7398914,29.1960213,107.0028576,0.0580954,22.5749596,10.1111899,27.6110984,5.7947308,9.5406219,0.1355277,25.1483117),(49506,'forelimb',255,4,286,21.3880808,80.0178042,124.678074,1.8,80.1272869,124.643387,0.1136736,2.6504653,4.5930696,26.4852868,96.7325494,0.0458637,21.0605452,9.9926931,26.0900601,5.5836926,9.1856803,2.9533711,23.9329705),(49507,'forelimb',255,4,287,20.7869085,79.8680831,124.6837147,1.8,79.9786781,124.6836794,0.1055532,2.6201326,4.3640042,24.5234855,90.5231506,0.0384563,20.7431399,9.3596351,25.2331483,5.5127737,8.8582451,2.896614,23.5770053),(49508,'forelimb',255,4,288,20.4279396,79.7248856,124.7045424,1.8,79.8525913,124.7348457,0.0979134,2.6199662,4.4631486,22.9975777,85.367641,0.0325364,19.1272236,8.7778146,23.9508087,5.5127737,8.76395,2.9441971,23.3252999),(49509,'forelimb',255,4,289,19.9349168,79.5676908,124.6820064,1.8,79.6516804,124.7227174,0.0937285,2.6223466,4.2363709,21.3359713,79.7444246,0.0291028,18.8237591,8.1362133,23.3814765,5.156256,8.689902,2.9927027,22.7176293),(49510,'forelimb',255,4,290,19.4015548,79.4249605,124.6965227,1.8,79.4946805,124.7151416,0.0775463,2.5782857,4.3443442,19.7212527,75.0546894,0.019406,17.2764141,7.6489787,21.71237,5.156256,8.689902,2.9927027,22.7176293),(49511,'forelimb',255,4,291,19.0823096,79.2749592,124.7196878,1.8,79.319417,124.7329936,0.0535591,2.5447981,4.0957609,18.5457635,70.4836947,0.0091144,17.2089378,7.2877152,21.207555,5.156256,8.4420297,0.2573237,22.1099587),(49512,'forelimb',255,4,292,18.7097451,79.1267779,124.7432717,1.8,79.182091,124.7442742,0.0308779,2.48499,4.2398129,17.5003003,65.9874788,0.0029722,15.5637714,7.0424027,19.5520316,5.156256,8.3430318,2.9340964,21.8582533),(49513,'forelimb',255,4,293,18.3660502,79.009241,124.7701229,1.8,79.0887925,124.7850633,0.0033307,2.4230587,4.349672,16.5318056,62.4051502,0.000034,14.3470934,6.8227011,18.1331098,5.156256,8.2652137,2.9849908,21.8582533),(49514,'forelimb',255,4,294,18.0822208,78.9035099,124.8058245,1.8,79.0148489,124.8190592,-0.0219869,2.3879142,4.0485102,15.8190496,59.8303005,0.0014567,14.7783499,6.6246307,18.1745751,5.156256,8.1527566,0.3217506,21.5022882),(49515,'forelimb',255,4,295,17.7345536,78.8112822,124.8467629,1.8,78.89838,124.8613117,-0.0385989,2.4405335,4.1411706,15.1220771,57.6658471,0.0044015,13.9250114,6.1962177,17.4461335,5.1525354,8.2652137,2.9849908,21.6065479),(49516,'forelimb',255,4,296,17.5017497,78.7393233,124.8970995,1.8,78.8259916,124.9005112,-0.0562221,2.3050946,4.2241447,14.8336564,56.2345255,0.0092106,13.312642,6.4351618,16.7164038,4.726568,8.3430318,0.2074962,21.2505827),(49517,'forelimb',255,4,297,17.2961371,78.6891355,124.9580562,1.8,78.7834316,124.9352071,-0.0662577,2.2494258,4.2828691,14.5636363,54.9787542,0.0126367,12.836898,6.4743796,16.1296418,4.726568,8.3430318,0.2074962,21.2505827),(49518,'forelimb',255,4,298,16.9445534,78.6429334,125.0228977,1.8,78.7193996,124.9722436,-0.0756606,2.2567057,4.305833,14.2959398,53.7345598,0.0161357,12.4794808,6.3348712,15.7963037,4.726568,8.3430318,0.2074962,21.2505827),(49519,'forelimb',255,4,299,16.7786086,78.6100334,125.1020326,1.8,78.6663862,125.0559491,-0.0750925,2.3322613,3.9482852,14.3475006,52.6401535,0.0157392,13.3324091,6.1517552,16.755796,4.726568,8.0272343,0.2709469,20.6429122),(49520,'forelimb',255,4,300,16.6898175,78.5918314,125.1911582,1.8,78.6869707,125.2070993,-0.0821539,2.4213654,3.9780741,14.2983502,51.8964623,0.0187318,13.045625,5.9050774,16.3970588,4.726568,8.0272343,0.2709469,20.6429122),(49521,'forelimb',255,4,301,16.6643607,78.5695362,125.2781996,1.8,78.6384484,125.3053373,-0.0804898,2.3712065,4.0061464,14.6128397,51.2992778,0.0179548,12.8051432,6.1626181,16.1504142,4.726568,8.1527566,0.3217506,20.6429122),(49522,'forelimb',255,4,302,16.5766326,78.5572506,125.3670275,1.8,78.6301318,125.3885028,-0.0788982,2.3170038,3.9902838,14.7482188,50.2527644,0.0171624,12.5937819,6.3652112,16.1897245,4.726568,8.0272343,0.2709469,20.3912067),(49523,'forelimb',255,4,303,16.4312211,78.5560763,125.4547653,1.8,78.6046351,125.4293195,-0.0786776,2.2567564,3.9644803,14.6930531,49.2518499,0.0169171,12.4232803,6.5106954,16.1238767,4.726568,7.9230552,0.2186689,20.3912067),(49524,'forelimb',255,4,304,16.2956007,78.5596842,125.5551263,1.8,78.5809954,125.5640618,-0.0792937,2.2899207,3.6086307,14.5593168,48.5465686,0.0170406,13.4529059,6.3580005,16.736774,4.726568,7.7463106,0.3392926,20.286947),(49525,'forelimb',255,4,305,16.1922628,78.5680836,125.5889071,1.8,78.6124427,125.6208945,-0.0797254,2.4896921,3.6034198,14.4688785,47.6872988,0.0171171,13.2339005,5.8115133,16.4645515,4.726568,7.7463106,0.3392926,20.0352416),(49526,'forelimb',255,4,306,16.205243,78.5757132,125.6826741,1.8,78.5650585,125.7120089,-0.0799392,2.4299911,3.5692304,14.777705,47.3452404,0.0172226,13.2648316,6.0813823,16.9931875,4.726568,7.7463106,0.3392926,19.7835362),(49527,'forelimb',255,4,307,16.1655751,78.6015222,125.7784937,1.8,78.6244787,125.7890557,-0.0783595,2.3649328,3.5497479,14.837987,46.6810169,0.0165095,13.1505162,6.2741686,16.8059191,4.726568,7.7463106,0.3392926,20.0352416),(49528,'forelimb',255,4,308,16.2056906,78.6300379,125.8753662,1.8,78.666605,125.8564577,-0.0758881,2.2633555,3.5264388,14.8242886,46.2949441,0.0155249,13.1279591,6.549695,16.67256,4.726568,7.7463106,0.3392926,20.0352416),(49529,'forelimb',255,4,309,16.1998159,78.6499419,125.9825268,1.8,78.6095196,126.0125829,-0.0727463,2.2589475,3.5017653,14.6823872,45.6820599,0.0142631,13.0454374,6.4996585,17.0128879,4.726568,7.6140908,0.2860514,19.7835362),(49530,'forelimb',255,4,310,16.0898761,78.6877929,126.0805052,1.8,78.6706469,126.1337511,-0.0763637,2.4833781,3.5338978,14.779818,45.0834438,0.0156074,12.7574273,5.9514973,16.827375,4.726568,7.6140908,0.2860514,20.0352416),(49531,'forelimb',255,4,311,16.0862954,78.7284864,126.1759846,1.8,78.7353462,126.2144474,-0.0764865,2.4180303,3.5672267,14.9422763,44.7193479,0.0156541,12.5361667,6.179524,16.6620119,4.726568,7.6140908,0.2860514,19.7835362),(49532,'forelimb',255,4,312,16.0395779,78.7722908,126.2711305,1.8,78.7732687,126.2623865,-0.0726672,2.3144278,3.6027965,14.964322,44.3496094,0.0140914,12.3097738,6.4656682,16.4310502,4.726568,7.6140908,0.2860514,19.7835362),(49533,'forelimb',255,4,313,16.0344306,78.8281955,126.3687714,1.8,78.8364404,126.3650216,-0.0721807,2.243309,3.6514036,15.0457804,44.1722995,0.0138992,12.097348,6.7069585,16.2082196,4.726568,7.6140908,0.2860514,20.0352416),(49534,'forelimb',255,4,314,15.902335,78.881248,126.461501,1.8,78.8966435,126.4527334,-0.075128,2.2616217,3.333729,14.8058318,43.2306758,0.0149312,12.9676635,6.5465554,16.6201236,4.726568,7.5041783,0.4124104,19.427571),(49535,'forelimb',255,4,315,15.9007125,78.9339623,126.5589065,1.8,78.9580733,126.6040852,-0.0705516,2.4415912,3.3752546,14.9284127,43.0585254,0.0131692,12.757119,6.1142147,16.6379448,4.726568,7.5041783,0.4124104,19.6792764),(49536,'forelimb',255,4,316,15.8348045,78.9861104,126.6487776,1.8,78.9825811,126.6898026,-0.0715838,2.3802404,3.4216887,14.8504304,42.1428457,0.0135005,12.3163882,6.2390464,16.2940535,4.726568,7.3425118,0.3587707,19.427571),(49537,'forelimb',255,4,317,15.7918916,79.0468617,126.7293583,1.8,79.062592,126.760883,-0.0684299,2.319925,3.4744821,14.8007901,41.7260181,0.0123054,12.009277,6.3798572,15.9900895,4.726568,7.3425118,0.3587707,19.427571),(49538,'forelimb',255,4,318,15.7130035,79.1061445,126.8085244,1.8,79.0920227,126.8197644,-0.0768964,2.253375,3.5329031,14.6281074,40.8359487,0.0154548,11.5587513,6.4916437,15.5197011,4.726568,7.3425118,0.3587707,19.427571),(49539,'forelimb',255,4,319,15.6251076,79.1670268,126.8913018,1.8,79.1426029,126.9298352,-0.0810852,2.2827437,3.5891076,14.4911518,40.1616306,0.0170845,11.1898655,6.3481293,15.1158885,4.726568,7.3425118,0.3587707,19.427571),(49540,'forelimb',255,4,320,15.4970403,79.233054,126.9656688,1.8,79.1997265,126.9865174,-0.0765043,2.2966035,3.6143784,14.2810681,39.5368779,0.0150877,10.9387767,6.218343,14.8882712,4.726568,7.2028834,0.3028849,19.427571),(49541,'forelimb',255,4,321,15.355769,79.3094865,127.0028474,1.8,79.2989204,127.0096344,-0.0801975,2.3365682,3.3279001,14.0498167,38.8955913,0.0164252,11.6877279,6.0130138,15.4896941,4.726568,7.112602,0.4366272,19.427571),(49542,'forelimb',255,4,322,15.3227031,79.3983467,127.0806092,1.8,79.4496159,127.1236519,-0.0706171,2.3777575,3.403426,13.9932193,38.838686,0.012714,11.411644,5.8850489,15.1796878,4.726568,7.2028834,0.3028849,19.427571),(49543,'forelimb',255,4,323,15.2979736,79.4801654,127.150905,1.8,79.5073041,127.1756288,-0.0646702,2.3202412,3.4761408,14.0265466,38.6540621,0.0106484,11.1198206,6.0452966,14.8787251,4.726568,7.2028834,2.8387078,19.427571),(49544,'forelimb',255,4,324,15.3311514,79.5647681,127.2237846,1.8,79.5864582,127.2877123,-0.0642632,2.2688529,3.5556145,14.2075505,38.5116197,0.0105378,10.8312136,6.2619973,14.6229226,4.726568,7.2028834,2.8387078,19.6792764),(49545,'forelimb',255,4,325,15.1827746,79.6493626,127.2908391,1.8,79.6605494,127.3679367,-0.0677583,2.2570998,3.608444,14.0993727,38.0350179,0.0116001,10.5405592,6.2466768,14.444124,4.726568,7.3550738,3.0244839,19.7835362),(49546,'forelimb',255,4,326,15.0816747,79.7291192,127.3512448,1.8,79.7416793,127.4130088,-0.074262,2.3232364,3.3192151,14.0187408,38.0640332,0.0138367,11.4677814,6.034143,15.1654396,4.726568,7.2028834,2.8387078,19.427571),(49547,'forelimb',255,4,327,15.0492802,79.8208664,127.4058898,1.8,79.868257,127.4532191,-0.0755521,2.3522992,3.4077105,13.9908514,38.3117446,0.0142899,11.2426642,5.9477346,14.9264033,4.726568,7.2028834,2.8387078,19.427571),(49548,'forelimb',255,4,328,15.0084934,79.9061502,127.4559625,1.8,79.9129536,127.4731051,-0.0797607,2.4078109,3.4921374,13.8720535,38.1168716,0.0158797,10.9150551,5.761272,14.5598878,4.726568,7.2028834,2.8387078,19.427571),(49549,'forelimb',255,4,329,14.9416343,79.9973208,127.5007179,1.8,80.0036692,127.511427,-0.0818585,2.4242945,3.5808981,13.7480086,37.8862162,0.0166496,10.5800877,5.6709317,14.1621963,4.726568,7.4175649,2.9669205,19.7835362),(49550,'forelimb',255,4,330,14.8659912,80.0857794,127.5383638,1.8,80.1337428,127.5344676,-0.0848007,2.4676558,3.6314574,13.6877518,37.4703771,0.0177746,10.3182752,5.5468643,14.0657906,4.726568,7.3550738,3.0244839,19.7835362),(49551,'forelimb',255,4,331,14.8580465,80.1636533,127.5751105,1.8,80.2021993,127.5830855,-0.089494,2.4705482,3.3554805,13.534178,37.4067749,0.0197806,11.1479636,5.4782084,14.5063287,4.726568,7.2028834,2.8387078,19.427571),(49552,'forelimb',255,4,332,14.846465,80.2448886,127.6075118,1.8,80.2426772,127.6422454,-0.09814,2.2020676,3.4419779,13.4986422,37.184891,0.0237558,10.8033496,6.1299854,14.1770503,4.7006754,7.2028834,0.3028849,19.427571),(49553,'forelimb',255,4,333,14.865096,80.3289384,127.6389651,1.8,80.2924961,127.6982917,-0.1020552,2.2440153,3.482367,13.546718,36.7512869,0.0257145,10.5535363,6.0368208,14.3052711,4.726568,7.086596,2.896614,19.1758656),(49554,'forelimb',255,4,334,14.8526194,80.4100296,127.6694925,1.8,80.3847089,127.7826006,-0.1060784,2.2603004,3.5616952,13.6938229,36.2876311,0.0277508,10.1883033,6.0584085,13.9307016,4.726568,7.3550738,0.1171087,19.5318307),(49555,'forelimb',255,4,335,14.8136229,80.500217,127.6875415,1.8,80.5392663,127.7898164,-0.1028371,2.2662849,3.2787743,13.6903676,35.7093798,0.0260182,10.891076,6.0408856,14.6000257,4.726568,7.086596,2.896614,19.1758656),(49556,'forelimb',255,4,336,14.7248878,80.5785212,127.6969719,1.8,80.5989584,127.7873564,-0.1059217,2.285002,3.3444178,13.5467393,35.0510372,0.0274313,10.48046,5.928546,14.0724982,4.726568,7.086596,0.2449787,18.9241602),(49557,'forelimb',255,4,337,14.521625,80.6115554,127.6396423,1.8,80.6107326,127.7152796,-0.1094582,2.2330857,3.3865399,13.1848254,34.299547,0.0288819,10.1281982,5.9043079,13.5489256,4.726568,7.086596,0.2449787,19.5318307),(49558,'forelimb',255,4,338,14.4168325,80.686983,127.6423257,1.8,80.6731492,127.7224395,-0.1105173,2.2445454,3.4147736,13.1833185,33.7182785,0.0292288,9.8742355,5.8734915,13.6116556,4.726568,7.086596,0.2449787,19.5318307),(49559,'forelimb',255,4,339,14.2159755,80.7631359,127.6356202,1.8,80.765662,127.6988826,-0.1109394,2.2465316,3.4913948,12.9714035,32.7887073,0.0290412,9.3912916,5.7739688,12.9955117,4.726568,7.086596,0.2449787,19.5318307),(49560,'forelimb',255,4,340,13.9625823,80.8314739,127.6232228,1.8,80.8524202,127.6625663,-0.10772,2.2396225,3.1781781,12.7607966,31.5743254,0.0268984,9.9347249,5.6977444,13.3690149,4.726568,6.7939638,2.8198421,18.9241602),(49561,'forelimb',255,4,341,13.7371078,80.8974703,127.6062074,1.8,80.9267769,127.6371678,-0.1132879,2.2338872,3.2508984,12.441651,30.5783526,0.0292585,9.4061238,5.5695073,12.7138439,4.726568,6.9418221,0.3805064,18.568195),(49562,'forelimb',255,4,342,13.4711261,80.9689808,127.5858788,1.8,80.9738442,127.617336,-0.1119801,2.1727074,3.2749862,12.0680078,29.4235482,0.0280362,8.9843273,5.5543641,12.5076153,4.29688,6.7939638,0.3217506,17.9605244),(49563,'forelimb',255,4,343,13.2918654,81.0394505,127.5633526,1.8,81.0655471,127.5936524,-0.1056317,2.1553003,3.3440192,11.938058,28.8941019,0.0246267,8.6405312,5.5389304,12.0404982,4.29688,6.9948139,0.1853479,18.3164896),(49564,'forelimb',255,4,344,13.1565807,81.1146801,127.5388401,1.8,81.1774626,127.5569111,-0.1068302,2.1395026,3.3762906,11.8819719,28.2590896,0.0249303,8.369863,5.5536142,11.8775364,4.29688,6.9948139,0.1853479,18.3164896),(49565,'forelimb',255,4,345,12.9744107,81.176121,127.5134776,1.8,81.2278167,127.5602681,-0.1055918,2.1200891,3.1031551,11.7504022,27.6493839,0.0240205,8.9100878,5.5424095,12.0009818,4.29688,6.7939638,0.3217506,17.9605244),(49566,'forelimb',255,4,346,12.7931359,81.2393325,127.483232,1.8,81.275316,127.5158349,-0.099946,2.3917769,3.120094,11.6845546,26.8678606,0.021228,8.6112343,4.8853029,12.0682685,4.726568,6.6705516,2.8809903,18.0647842),(49567,'forelimb',255,4,347,12.6715027,81.3033602,127.4531961,1.8,81.2820828,127.4955347,-0.1003942,2.368021,3.1871167,11.5769886,26.4771089,0.0212146,8.307543,4.8888877,11.6561148,4.726568,6.7939638,0.3217506,18.0647842),(49568,'forelimb',255,4,348,12.5535621,81.3746763,127.4145213,1.8,81.3734338,127.4244839,-0.0998639,2.3797939,3.2187185,11.641116,25.8678001,0.0207964,8.0366766,4.8916487,11.5986014,4.726568,6.6705516,0.2606024,18.3164896),(49569,'forelimb',255,4,349,12.3887363,81.4486995,127.3750908,1.8,81.4918517,127.3635832,-0.1055391,2.3479225,2.9161765,11.6281781,25.2548489,0.0229134,8.6602607,4.9525392,12.1983042,4.726568,6.5448126,0.4048918,17.708819),(49570,'forelimb',255,4,350,12.2603333,81.511012,127.33929,1.8,81.5730526,127.3601999,-0.1084879,2.3190401,3.1354974,11.5040872,25.0816189,0.0239557,7.9992472,4.9607107,11.6151734,4.726568,6.6705516,0.2606024,18.0647842),(49571,'forelimb',255,4,351,12.1205167,81.5619764,127.3053984,1.8,81.5963871,127.3649796,-0.1156376,2.2915475,3.0795318,11.3865538,24.7415167,0.0268925,8.0341813,4.9689365,11.4525391,4.726568,6.6705516,0.2606024,18.0647842),(49572,'forelimb',255,4,352,11.9334791,81.6268196,127.2644206,1.8,81.7100245,127.3123961,-0.1179672,2.2586828,3.0652152,11.2640891,24.1449274,0.0275501,7.877074,4.9870167,11.4425239,4.726568,6.6705516,0.2606024,17.5613733),(49573,'forelimb',255,4,353,11.6688402,81.6732862,127.1732346,1.8,81.7191551,127.2285707,-0.124107,2.2485678,3.1251627,11.078426,23.599158,0.0298015,7.5513374,4.9268811,10.9619422,4.726568,6.6705516,0.2606024,18.0647842),(49574,'forelimb',255,4,354,11.4942233,81.7394135,127.1278153,1.8,81.8347726,127.1668566,-0.1294352,2.2879848,3.1437078,10.9181524,23.1338889,0.0319159,7.358791,4.7719515,10.8279018,4.726568,6.6705516,0.2606024,17.8130787),(49575,'forelimb',255,4,355,11.2854775,81.7934274,127.0800226,1.8,81.9056943,127.133937,-0.1362381,2.2727793,2.9307535,10.7370263,22.5346846,0.0346958,7.6890412,4.7241835,11.0375113,4.726568,6.3877713,0.3430239,17.2054082),(49576,'forelimb',255,4,356,11.0593875,81.8340121,127.0261626,1.8,81.9295859,127.0829341,-0.1445795,2.2579762,2.8895867,10.449191,22.4492134,0.0382618,7.7690051,4.6276799,10.9883153,4.726568,6.3877713,0.3430239,17.4571136),(49577,'forelimb',255,4,357,10.8734689,81.8812883,126.9605311,1.8,81.9922829,126.9816819,-0.1559278,2.2931186,2.9532283,10.3539399,22.3613247,0.043706,7.5718238,4.5152221,10.8298321,4.726568,6.5448126,0.4048918,17.4571136),(49578,'forelimb',255,4,358,10.6600793,81.9209851,126.9071371,1.8,82.0218948,126.941617,-0.1625889,2.3126825,3.1397475,10.3358632,22.0267962,0.0465544,7.0154674,4.4692098,10.2388817,4.726568,6.6705516,0.2606024,17.8130787),(49579,'forelimb',255,4,359,10.4684539,81.9614422,126.8547338,1.8,82.0633057,126.8929033,-0.1642447,2.2674384,3.0906598,10.1917825,21.4192206,0.046645,6.9303068,4.4948443,10.0848268,4.726568,6.5729625,0.1973956,17.5613733),(49580,'forelimb',255,4,360,10.3378689,81.9992828,126.8049117,1.8,82.0917148,126.8431874,-0.1749109,2.2313501,3.1149078,10.1959081,20.9674732,0.0521771,6.7313302,4.5693897,10.0023173,4.726568,6.6705516,0.2606024,17.3096679),(49581,'forelimb',255,4,361,10.274087,82.0469175,126.7476292,1.8,82.1472628,126.792894,-0.1842677,2.283989,3.056826,10.2701316,20.5839171,0.057487,6.7337548,4.4965767,10.0728962,4.726568,6.5729625,0.1973956,17.5613733),(49582,'forelimb',255,4,362,10.1206748,82.0988178,126.6841825,1.8,82.2365059,126.7218518,-0.1867933,2.2580825,2.9936746,10.1431923,19.9482503,0.0581733,6.6634664,4.4919494,9.9586291,4.726568,6.3877713,0.3430239,17.2054082),(49583,'forelimb',255,4,363,9.940463,82.1350244,126.6279677,1.8,82.2687255,126.6918542,-0.1857548,2.3066612,2.9479184,10.0770123,19.377475,0.0565112,6.5732739,4.3686573,9.8314627,4.726568,6.2563517,0.2782997,16.9537027),(49584,'forelimb',255,4,364,9.8408737,82.1696474,126.557842,1.8,82.3015007,126.5846405,-0.1996589,2.3504518,2.9815496,10.1401133,19.0460507,0.0645181,6.3879704,4.3141124,9.7862823,5.1070441,6.3877713,0.3430239,17.3096679),(49585,'forelimb',255,4,365,9.7340111,82.2038489,126.4903793,1.8,82.2798358,126.4907591,-0.1962827,2.2922052,2.934597,10.1294375,18.6299133,0.061705,6.3483719,4.4190797,9.7234264,4.726568,6.3877713,0.3430239,17.2054082),(49586,'forelimb',255,4,366,9.5353361,82.2513455,126.419719,1.8,82.3303873,126.4149318,-0.2047852,2.3172587,2.8737864,10.1128315,18.0243745,0.0657207,6.2719952,4.3641358,9.788513,4.726568,6.2563517,0.2782997,17.2054082),(49587,'forelimb',255,4,367,9.4373694,82.2950492,126.3505616,1.8,82.3640281,126.3569179,-0.196703,2.2931778,2.912319,10.108882,17.7042347,0.0600777,6.079085,4.4082417,9.5084222,4.726568,6.3877713,0.3430239,17.2054082),(49588,'forelimb',255,4,368,9.2421073,82.3257008,126.2871417,1.8,82.3642118,126.3172544,-0.1960513,2.2652997,2.8708565,9.8310551,17.0947801,0.0584504,5.9545924,4.3398475,9.374405,4.726568,6.2563517,0.2782997,17.2054082),(49589,'forelimb',255,4,369,8.9481511,82.3397938,126.1569384,1.8,82.4164399,126.1533548,-0.1801575,2.339118,2.8321285,9.522398,16.1853779,0.0478832,5.7149164,4.0709353,9.0118494,5.029227,6.1521959,0.2110933,17.0579625),(49590,'forelimb',255,4,370,8.8268536,82.3777147,126.0866362,1.8,82.4851503,126.0405679,-0.1958077,2.351633,2.7690916,9.3992602,15.9042707,0.0556874,5.7434974,3.9969077,9.0931542,4.726568,5.9848613,0.3671738,16.5977376),(49591,'forelimb',255,4,371,8.5955044,82.4052229,126.0302137,1.8,82.5114036,125.996583,-0.1943675,2.3018042,2.8140773,9.0903089,15.4214481,0.0534431,5.4801082,3.9492102,8.5982207,4.726568,6.1521959,0.4324078,16.5977376),(49592,'forelimb',255,4,372,8.4310702,82.438545,125.9609391,1.8,82.5647393,125.9518197,-0.1946007,2.2402547,2.7680945,9.0085305,14.8468336,0.052545,5.3635573,4.0212082,8.5320283,4.726568,5.9848613,0.3671738,16.3460322),(49593,'forelimb',255,4,373,8.2624958,82.455,125.8877894,1.8,82.546134,125.906257,-0.1896075,2.2910064,2.7361464,8.9532583,14.3018782,0.0489171,5.227015,3.9080022,8.4347508,4.726568,5.9848613,0.3671738,16.3460322),(49594,'forelimb',255,4,374,8.0388116,82.4723585,125.8121715,1.8,82.515442,125.8103445,-0.1703204,2.2800481,2.6991758,8.7394246,13.9245365,0.038492,5.1588104,3.8330001,8.3312797,4.726568,5.9848613,0.3671738,16.849443),(49595,'forelimb',255,4,375,7.9073874,82.4954018,125.7271734,1.8,82.562033,125.6469649,-0.171643,2.37055,2.6623743,8.745978,13.5449912,0.0384472,5.0875608,3.6894299,8.3396941,4.9968715,5.8443887,0.2984989,16.9537027),(49596,'forelimb',255,4,376,7.847466,82.5114799,125.6382702,1.8,82.562033,125.5618015,-0.1663972,2.3588552,2.7016843,8.9500023,13.4590134,0.0358805,4.9817122,3.7942144,8.1038496,4.726568,5.9848613,0.3671738,16.3460322),(49597,'forelimb',255,4,377,7.8111551,82.5263675,125.550582,1.8,82.5729895,125.5417895,-0.1784467,2.2756463,2.701084,9.07864,13.417924,0.0410172,4.967607,3.9894777,8.27126,4.726568,5.9848613,0.3671738,16.3460322),(49598,'forelimb',255,4,378,7.6523717,82.5236045,125.4679692,1.8,82.5899399,125.4767085,-0.1575246,2.2594257,2.6576581,9.0647101,13.0047248,0.0313867,4.8933024,4.0119533,8.1872395,4.726568,5.8443887,2.8430937,16.3460322),(49599,'forelimb',255,4,379,7.5338717,82.5169828,125.3721288,1.8,82.5860336,125.3754856,-0.1563338,2.4537291,2.6487427,9.2949035,12.8925901,0.0304391,4.8674377,3.7880723,8.1157165,5.156256,5.8443887,2.8430937,17.2054082),(49600,'forelimb',255,4,380,7.4357371,82.5157346,125.2545628,1.8,82.6018642,125.2163601,-0.1431804,2.403151,2.6896231,9.3084111,12.6487884,0.0252331,4.7028107,3.8734192,7.9018534,5.156256,5.9848613,0.3671738,16.9537027),(49601,'forelimb',255,4,381,7.3250699,82.5169194,125.1567319,1.8,82.5723444,125.1266666,-0.0788055,2.3279092,2.6452993,9.2005121,12.6303546,0.0075661,4.774641,3.9522641,7.9637499,4.726568,5.9848613,0.3671738,16.5977376),(49602,'forelimb',255,4,382,7.0534374,82.5141146,125.0613282,1.8,82.5883355,125.085246,-0.0872343,2.2384001,2.6311587,9.0404594,12.216075,0.0089232,4.64285,4.0388041,7.8396881,4.726568,5.8443887,2.8430937,16.3460322),(49603,'forelimb',255,4,383,6.9094806,82.5052141,124.9597392,1.8,82.5604031,124.9864393,-0.0616555,2.2763118,2.616176,8.9216527,12.1211731,0.0043721,4.6331643,3.9193456,7.682827,4.726568,5.8443887,2.8430937,16.849443),(49604,'forelimb',255,4,384,6.8681902,82.5136561,124.855184,1.8,82.5772195,124.9069963,-0.0422799,2.4106994,2.615312,9.0202025,11.9438404,0.002045,4.5668894,3.7417367,7.5718039,5.156256,5.8443887,2.8430937,17.2054082),(49605,'forelimb',255,4,385,6.7877355,82.493866,124.7100887,1.8,82.5729245,124.7588184,-0.023022,2.4869376,2.605771,8.9523553,11.7409937,0.0005995,4.5057657,3.5997507,7.5060691,5.156256,5.9848613,0.3671738,16.9537027),(49606,'forelimb',255,4,386,6.7478998,82.4680889,124.6144009,1.8,82.5111136,124.6352278,0.0506565,2.2044604,2.6500542,8.8553471,11.6358642,0.0028835,4.3908024,4.0170135,7.452707,4.726568,5.9848613,0.3671738,16.5977376),(49607,'forelimb',255,4,387,6.8638821,82.4628016,124.5269035,1.8,82.5551842,124.569122,0.122769,2.4812957,2.7110943,9.0169892,11.4640245,0.0171559,4.2285599,3.6339841,7.3675645,5.156256,5.8443887,2.8430937,16.9537027),(49608,'forelimb',255,4,388,6.960618,82.4261258,124.4339734,1.8,82.4928744,124.4723087,0.1827874,2.454107,2.7179307,9.2633262,11.272288,0.0383307,4.1473788,3.774622,7.4979226,5.156256,5.8443887,2.8430937,16.9537027),(49609,'forelimb',255,4,389,7.2454545,82.4026521,124.371478,1.8,82.4786116,124.4304833,0.2837504,2.5043609,2.7555181,9.4969754,11.3402559,0.0946456,4.1154714,3.7921752,7.5561976,5.156256,5.8443887,2.5127964,17.2054082),(49610,'forelimb',255,4,390,7.5765049,82.3661013,124.267846,1.8,82.4242687,124.2989892,0.4000958,2.5759947,2.6310135,9.6845152,11.426925,0.1915787,4.3431648,3.7595245,7.6460494,5.156256,5.8443887,2.8430937,16.9537027),(49611,'forelimb',255,4,391,8.2094562,82.3169827,124.1369718,1.8,82.3380825,124.1340456,0.4806157,2.4543576,2.699836,10.0896875,12.1832707,0.2924545,4.5125965,4.110928,8.0653132,5.3825049,5.9694165,2.6135182,17.5613733),(49612,'forelimb',255,4,392,9.0663155,82.2310339,123.9646406,1.8,82.2102271,123.9786289,0.4688167,2.5694724,2.8363314,10.8981608,13.805322,0.3084832,4.8673163,4.2414002,8.6761171,5.156256,6.1970485,2.5535901,17.4571136),(49613,'forelimb',255,4,393,9.4153814,82.1844834,123.8425773,1.8,82.1088875,123.8110699,0.5684299,2.6188304,3.01252,12.0436422,15.8453388,0.4547271,5.2598286,4.598863,9.2165429,5.4690354,6.44532,2.4980915,18.0647842),(49614,'forelimb',255,4,394,9.0475166,82.141152,123.7474922,1.8,82.0896478,123.7148711,0.6386058,2.6163701,2.8936526,11.1353095,15.622221,0.5357748,5.3987895,4.2560147,8.6091426,5.5714602,6.3877713,2.7985687,18.4207493),(49615,'forelimb',255,4,395,9.8522314,81.9246816,123.503731,1.8,81.962986,123.5953299,0.5316225,2.4321229,2.9956341,11.007598,18.0721339,0.4219722,6.0328243,4.5259219,9.5465697,5.3825049,6.5589027,2.5899377,18.6724547),(49616,'forelimb',255,4,396,9.6963015,82.073946,123.6742359,1.8,82.0337679,123.750144,0.3026711,2.6625256,3.1079981,11.1470247,17.7384469,0.14358,5.7073545,4.1866357,9.2831472,5.156256,6.3877713,2.7985687,18.0647842),(49617,'forelimb',255,4,397,6.9076343,82.0822793,123.7074233,1.8,82.0580132,123.6840382,0.4743081,2.1509464,2.8733202,5.5794529,11.7201492,0.2401508,4.0789568,2.5939526,6.0187666,4.7002087,5.9848613,2.7744188,16.3460322),(49618,'forelimb',255,4,398,5.381289,81.9573503,123.5188866,1.8,81.9683571,123.5299289,0.7254145,1.7945652,2.3792555,3.0614835,6.5860434,0.3947715,2.7681111,1.705975,4.0168464,3.9498589,5.2450105,2.1815223,14.0196096),(49619,'forelimb',255,4,399,4.3975373,81.919157,123.3103861,1.8,81.9183646,123.3006242,1.0582534,1.5817327,2.212992,1.9169491,4.4993743,0.5566643,2.0331633,1.2119299,2.8514648,3.437504,4.899197,1.8370484,12.8042684),(49620,'forelimb',255,4,400,4.153096,81.9099363,123.1497733,1.8,81.931799,123.0848206,1.1669158,1.7724225,1.9693429,2.0829575,3.3277351,0.5852814,1.6897692,1.1752037,2.7107729,3.437504,4.4860744,1.8622531,12.1965978),(49621,'forelimb',255,4,401,4.0929508,82.0580909,123.1885217,1.8,82.0351877,123.1795747,1.0169372,1.746723,1.7951206,2.383058,2.5160583,0.4934407,1.4016096,1.3643022,2.5823343,3.867192,4.231936,2.7233683,11.9448924),(49622,'forelimb',255,4,402,1.0529606,82.1450897,123.2439478,1.8,82.1741258,123.2167382,-1.0200084,1.2056429,1.2863259,0.306139,0.3592502,0.127425,0.279284,0.2539218,0.5032253,2.578128,3.0985242,0.5880026,8.2988688),(49623,'forelimb',255,4,403,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49624,'forelimb',255,4,404,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49625,'forelimb',255,4,405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49626,'forelimb',255,4,406,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49627,'forelimb',255,4,407,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49628,'forelimb',255,4,408,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49629,'forelimb',255,4,409,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49630,'forelimb',255,4,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49631,'forelimb',255,4,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49632,'forelimb',255,4,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49633,'forelimb',255,4,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49634,'forelimb',255,4,414,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49635,'forelimb',255,4,415,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49636,'forelimb',255,4,416,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49637,'femur tibia pelvis',255,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49638,'femur tibia pelvis',255,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49639,'femur tibia pelvis',255,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49640,'femur tibia pelvis',255,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49641,'femur tibia pelvis',255,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49642,'femur tibia pelvis',255,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49643,'femur tibia pelvis',255,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49644,'femur tibia pelvis',255,7,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49645,'femur tibia pelvis',255,7,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49646,'femur tibia pelvis',255,7,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49647,'femur tibia pelvis',255,7,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49648,'femur tibia pelvis',255,7,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49649,'femur tibia pelvis',255,7,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49650,'femur tibia pelvis',255,7,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49651,'femur tibia pelvis',255,7,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49652,'femur tibia pelvis',255,7,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49653,'femur tibia pelvis',255,7,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49654,'femur tibia pelvis',255,7,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49655,'femur tibia pelvis',255,7,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49656,'femur tibia pelvis',255,7,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49657,'femur tibia pelvis',255,7,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49658,'femur tibia pelvis',255,7,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49659,'femur tibia pelvis',255,7,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49660,'femur tibia pelvis',255,7,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49661,'femur tibia pelvis',255,7,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49662,'femur tibia pelvis',255,7,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49663,'femur tibia pelvis',255,7,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49664,'femur tibia pelvis',255,7,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49665,'femur tibia pelvis',255,7,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49666,'femur tibia pelvis',255,7,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49667,'femur tibia pelvis',255,7,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49668,'femur tibia pelvis',255,7,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49669,'femur tibia pelvis',255,7,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49670,'femur tibia pelvis',255,7,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49671,'femur tibia pelvis',255,7,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49672,'femur tibia pelvis',255,7,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49673,'femur tibia pelvis',255,7,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49674,'femur tibia pelvis',255,7,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49675,'femur tibia pelvis',255,7,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49676,'femur tibia pelvis',255,7,40,1.7313985,119.0774363,118.5588281,1.8,119.000557,118.425082,0.6491984,1.4033644,2.1701132,0.7580807,1.7150935,0.1054648,0.7903244,0.5401881,1.1390127,3.3387574,4.6477863,2.5535901,11.5889272),(49677,'femur tibia pelvis',255,7,41,9.0556851,118.8297603,118.4751886,1.8,118.439793,118.6146316,0.0745083,2.9308034,3.1938672,10.6639419,15.7573145,0.0083633,4.9336161,3.6385729,6.2634251,5.4919414,7.3926319,0.6202495,20.3912067),(49678,'femur tibia pelvis',255,7,42,16.9323006,117.881837,119.1893372,1.8,117.4223168,119.4163377,-0.6287269,3.1587725,5.6764239,26.0198247,93.2348505,0.9760905,16.4249274,8.2373215,20.5574976,6.5615657,10.6732285,0.8709035,27.5789941),(49679,'femur tibia pelvis',255,7,43,25.7036528,117.3422715,119.8590214,1.8,117.1477338,120.0308016,-0.6596986,4.6318045,6.6410971,54.0854397,230.1991783,1.6091358,34.6628238,11.6769694,41.9925711,7.2765719,13.2647685,0.4346702,34.8710413),(49680,'femur tibia pelvis',255,7,44,37.5432494,116.8824411,120.7377899,1.8,116.9401699,120.8863315,-0.5775197,4.8819321,7.5198957,132.3057658,504.5973127,1.8650159,67.101637,27.1011075,84.6375062,9.4004174,15.4029813,0.4012288,44.1767317),(49681,'femur tibia pelvis',255,7,45,53.0296034,116.3731678,121.3317878,1.8,116.2669358,121.3591105,-0.4131073,6.1360436,11.6273705,248.0282761,1028.0400146,1.4244448,88.4155207,40.4215311,102.8389861,10.1974302,21.3334791,0.1618374,55.0105426),(49682,'femur tibia pelvis',255,7,46,80.8332468,113.9731656,121.7300879,1.8,114.6549431,121.7456246,-0.1416564,5.9953289,12.1794066,454.8704118,3198.6761789,0.2685371,262.629886,75.8708017,299.6556989,11.7494049,24.6762153,3.0193975,67.354586),(49683,'femur tibia pelvis',255,7,47,101.3508167,112.8735166,121.9413166,1.8,114.0389116,121.993812,-0.093301,6.5995588,13.4278758,664.3745278,4901.1029957,0.1466181,364.9946624,100.6695369,409.9558203,12.5788897,26.0094374,3.0090411,72.7625474),(49684,'femur tibia pelvis',255,7,48,110.9281706,112.2082783,122.0946368,1.8,113.5720292,122.1865394,-0.0785796,6.9209762,14.148847,855.6478259,5702.7948512,0.1139242,403.057214,123.6310889,462.7386515,13.2285991,26.7651134,0.0964738,75.6966406),(49685,'femur tibia pelvis',255,7,49,117.210015,111.700534,122.1734087,1.8,113.2675287,122.2785733,-0.0565354,7.2493908,14.6852309,1054.7876657,6299.0033644,0.0623724,428.9345799,145.5001798,500.3404316,13.788698,27.2369323,0.1106572,79.846075),(49686,'femur tibia pelvis',255,7,50,121.7475927,111.5507811,122.1812211,1.8,113.0082261,122.3394808,-0.0459657,7.2932415,14.8674868,1208.9560729,6638.369135,0.0428422,446.502441,165.7638887,524.7242116,14.0037422,27.6640329,0.108942,81.0614162),(49687,'femur tibia pelvis',255,7,51,122.798707,111.3348473,122.1468691,1.8,112.8823555,122.3382337,-0.0400279,7.7313416,15.4841593,1291.5605269,6858.1342551,0.0327745,442.9129219,167.0551634,524.7102699,14.5256503,28.1404636,0.1224611,85.5668158),(49688,'femur tibia pelvis',255,7,52,124.0201861,111.2659743,122.0763422,1.8,112.7226483,122.3668761,-0.036235,7.8097581,15.5612766,1340.2067795,7140.4481432,0.0271274,458.8600487,171.6066955,542.0165218,14.5368982,28.5184673,0.1056656,90.679886),(49689,'femur tibia pelvis',255,7,53,125.34394,111.2288123,122.0257879,1.8,112.5905252,122.4128034,-0.0300343,8.2581288,15.5864929,1374.2081164,7302.9379469,0.0188389,468.5427298,166.4067197,553.5202653,15.03908,28.6218657,0.1355277,93.4665335),(49690,'femur tibia pelvis',255,7,54,124.1149078,111.337025,122.0129124,1.8,112.5785226,122.4520171,-0.0332491,8.6915942,15.4975022,1383.7276991,7338.9396968,0.0228598,473.5562932,159.202981,558.0034542,15.468768,28.6830821,0.1503714,93.5707933),(49691,'femur tibia pelvis',255,7,55,122.1102543,111.5351601,122.0301639,1.8,112.6226598,122.4786791,-0.035468,8.6875192,15.3046042,1364.6305604,7206.9051072,0.0255913,470.8978418,157.0794297,555.1740382,15.3847318,28.6218657,0.1355277,93.9699443),(49692,'femur tibia pelvis',255,7,56,118.9038717,111.9995129,122.1002968,1.8,112.8147083,122.5447604,-0.0490202,9.0142553,15.2785415,1354.6388602,6835.3569697,0.0475825,447.382818,150.277402,533.5801487,15.6742745,28.7505907,0.1651487,95.5412507),(49693,'femur tibia pelvis',255,7,57,115.7967986,112.4536632,122.1984173,1.8,113.0429854,122.5515557,-0.0671882,8.9313498,14.8561958,1300.7647076,6423.1960672,0.0869917,432.3580658,145.6403281,517.8717325,15.5649428,28.6218657,0.1355277,95.2895453),(49694,'femur tibia pelvis',255,7,58,104.9246165,113.9515591,122.3243514,1.8,113.8716918,122.6446967,-0.145968,8.9255144,14.3196361,1198.6462426,4925.0797943,0.3699599,343.9388946,134.2943597,426.6986665,15.349988,28.2583162,0.1526493,94.4301693),(49695,'femur tibia pelvis',255,7,59,93.2116885,115.4439037,122.3383698,1.8,115.6728925,122.6674627,-0.2713804,8.32039,11.9037336,1138.8836767,3381.2954411,1.1163185,284.053352,136.8786408,379.2862593,14.4727146,23.1752851,0.1864869,80.9750446),(49696,'femur tibia pelvis',255,7,60,89.3484084,115.8967249,122.3813417,1.8,116.034291,122.7000529,-0.3513157,7.8889516,11.3533585,1124.3189392,2955.5330529,1.7635559,260.3223577,142.5181694,358.8758402,14.1862418,21.9981792,0.2165503,79.507998),(49697,'femur tibia pelvis',255,7,61,89.3816981,116.1688599,122.4779264,1.8,116.2821117,122.7799187,-0.4269991,7.7786145,10.7130185,1146.9651977,2791.5274106,2.5550201,260.5733763,147.4510922,361.2491339,14.3842838,21.0678616,0.2053954,77.9366916),(49698,'femur tibia pelvis',255,7,62,88.6414925,116.4116528,122.500531,1.8,116.4581913,122.8063437,-0.477186,7.5882209,10.4187501,1151.6840295,2656.6589471,3.1163302,254.9882578,151.7726022,362.4059882,14.4132552,20.3229251,0.2347226,76.469645),(49699,'femur tibia pelvis',255,7,63,89.5232491,116.6897896,122.5210969,1.8,116.6300577,122.784247,-0.5107358,7.2348189,9.9985364,1155.7167569,2587.0597229,3.565178,258.7438424,159.7437016,351.4812896,14.190844,20.1999066,0.9060218,75.0025984),(49700,'femur tibia pelvis',255,7,64,91.5120691,116.9836124,122.577545,1.8,116.8747325,122.8181447,-0.524586,7.0469986,9.7114209,1188.6282756,2488.8603245,3.8260505,256.2817883,168.6715636,343.2427124,14.1500239,20.0300987,0.9530406,72.9278812),(49701,'femur tibia pelvis',255,7,65,94.3908701,117.3266287,122.5486868,1.8,117.0944056,122.7921973,-0.5094904,6.9079713,9.2538261,1233.5432309,2360.471871,3.74233,255.0806377,178.5680896,335.8372713,13.9825272,19.9377084,0.9229849,59.0557172),(49702,'femur tibia pelvis',255,7,66,99.7905663,117.6536529,122.6512721,1.8,117.2748934,122.730455,-0.49512,6.624366,9.214924,1307.8633511,2259.6454867,3.7547092,245.2158563,197.4322305,342.7566857,13.8265357,19.5967879,0.9097532,56.6250348),(49703,'femur tibia pelvis',255,7,67,100.2704411,117.7418215,122.6812307,1.8,117.3600094,122.6750815,-0.5296935,6.8509457,9.2113856,1320.2466615,2140.022003,4.266451,232.3235706,192.7101344,339.0458175,13.9700924,19.33596,0.9272952,55.3054339),(49704,'femur tibia pelvis',255,7,68,95.6500588,117.7643995,122.5751406,1.8,117.4413283,122.5799847,-0.5387236,6.8114765,9.3192419,1279.9485473,1969.1648396,4.1960222,211.3009685,187.9105876,319.4586079,13.8076995,19.2594195,0.8960554,55.3054339),(49705,'femur tibia pelvis',255,7,69,92.8267033,117.7537265,122.4571595,1.8,117.4780994,122.4991481,-0.5860204,6.7938874,9.3075894,1239.3635781,1863.9944495,4.7320599,200.2660797,182.4233322,313.2725517,13.799317,18.9257932,0.8818719,54.0900927),(49706,'femur tibia pelvis',255,7,70,88.6051256,117.749641,122.3395644,1.8,117.4878729,122.4265596,-0.6148958,6.7864554,9.210112,1182.4601727,1755.6599856,4.914379,190.6230874,174.2382578,300.8213131,13.645261,18.6555863,0.8996525,53.4824221),(49707,'femur tibia pelvis',255,7,71,84.8982231,117.7805158,122.2173593,1.8,117.6007457,122.3244267,-0.6457705,6.800405,9.3837849,1124.3220851,1662.301307,5.1247401,177.146143,165.3316366,285.3479038,13.6852138,18.5961103,0.8671825,53.2307167),(49708,'femur tibia pelvis',255,7,72,84.0220054,117.7683269,122.095695,1.8,117.595537,122.203929,-0.6671675,6.6883136,9.2323987,1079.024484,1594.6885029,5.3615567,172.7274297,161.3298287,281.1914749,13.590111,18.2705844,0.8519663,52.6230461),(49709,'femur tibia pelvis',255,7,73,83.4230711,117.8138725,121.9788971,1.8,117.6531025,122.0949781,-0.6651153,6.7013245,9.0711258,1039.9851057,1526.8062871,5.2956127,168.3149731,155.190979,273.5475873,13.590111,17.7892908,0.9224643,51.1559995),(49710,'femur tibia pelvis',255,7,74,80.6120803,117.8072279,121.826511,1.8,117.6440777,121.918474,-0.6754165,6.5564728,8.9094852,983.3024401,1457.2465541,5.251918,163.5612512,149.9743029,266.7053335,13.3529503,17.4487192,0.9075933,50.2966235),(49711,'femur tibia pelvis',255,7,75,78.3649437,117.8414514,121.6792955,1.8,117.6903876,121.7519372,-0.6756165,6.5832902,8.759815,939.0724446,1386.0531837,5.1080661,158.2285913,142.64485,260.0670685,13.3370659,17.1121594,0.6786625,49.6889529),(49712,'femur tibia pelvis',255,7,76,77.3553436,117.8464466,121.5648882,1.8,117.7451085,121.6329637,-0.7010062,6.3906042,8.8635401,903.5856206,1320.7371587,5.3634091,149.0078625,141.3928308,248.3160024,13.0875449,17.1121594,0.6786625,49.4372475),(49713,'femur tibia pelvis',255,7,77,76.7169093,117.8413705,121.4387815,1.8,117.7411141,121.4812153,-0.7144671,6.4821603,8.6304042,868.8722278,1268.0487646,5.4891794,146.9280851,134.0405347,244.9977799,13.154078,16.7357822,0.7309067,48.1176465),(49714,'femur tibia pelvis',255,7,78,75.2324698,117.8166303,121.3164675,1.8,117.7517455,121.3466486,-0.7039491,6.3197237,8.1207417,829.548018,1201.9917199,5.2526142,148.0150172,131.2633364,247.930396,12.8954853,16.1747714,0.6913369,46.2946347),(49715,'femur tibia pelvis',255,7,79,73.6872697,117.806353,121.1664593,1.8,117.7357275,121.2011886,-0.6905571,6.1230118,7.9231371,788.2091942,1130.6274958,4.9828144,142.699473,128.7290009,240.6309103,12.6179362,15.8461105,0.7086263,45.4352587),(49716,'femur tibia pelvis',255,7,80,71.6107217,117.8679165,120.9494587,1.8,117.7994289,121.0279623,-0.6626242,6.2731938,7.4792461,750.9253889,1024.5657203,4.5169184,136.9878344,119.7038405,235.350996,12.4572472,15.2039135,0.7454195,43.6122469),(49717,'femur tibia pelvis',255,7,81,70.2657631,117.8737538,120.7072954,1.8,117.8777413,120.7048302,-0.6541785,6.1265546,7.0201923,715.8672393,943.8619155,4.336351,134.4495807,116.8466275,233.2664105,12.3833627,14.5967486,0.7437556,43.1088361),(49718,'femur tibia pelvis',255,7,82,69.1181367,117.8768557,120.5588669,1.8,117.8675404,120.581195,-0.6517403,6.1630021,6.7419241,687.9226421,891.2561895,4.2384195,132.1961167,111.6213544,232.5811514,12.3833627,14.0948144,0.9151007,42.6054253),(49719,'femur tibia pelvis',255,7,83,67.6553495,117.8833808,120.412386,1.8,117.8795151,120.40044,-0.6454009,6.0176127,6.6448477,661.4896255,844.6950536,4.0798973,127.1203035,109.9255903,223.7026398,12.1503532,13.9896277,0.8288491,41.6417895),(49720,'femur tibia pelvis',255,7,84,66.9016043,117.9094585,120.2754325,1.8,117.9267769,120.3071663,-0.659543,6.0271247,6.54673,641.3150125,805.9516442,4.1865863,123.1075121,106.4048025,219.9124009,12.1071645,13.7567282,0.8960554,41.0341189),(49721,'femur tibia pelvis',255,7,85,66.3305885,117.9241163,120.1541788,1.8,117.903318,120.1724334,-0.6832393,5.9008932,6.4644153,623.9276671,770.4084073,4.4060146,119.1768117,105.7344455,215.0767771,11.8495766,13.4924769,0.6498704,40.5307081),(49722,'femur tibia pelvis',255,7,86,66.5415723,117.9419729,120.0538199,1.8,117.9636336,120.0699207,-0.7228777,5.8753882,6.3824867,611.6053767,739.357179,4.8535678,115.8415536,104.0961649,210.6695716,11.8495766,13.2717262,1.0636978,40.2790027),(49723,'femur tibia pelvis',255,7,87,66.4578166,117.9475885,119.9447344,1.8,117.9770227,119.9710756,-0.7799326,5.8861694,6.277386,596.977504,712.2116889,5.4776149,113.4567294,101.4203737,205.515129,11.8495766,13.1529455,0.9011574,40.2790027),(49724,'femur tibia pelvis',255,7,88,66.1427117,117.9531444,119.8312766,1.8,117.9770778,119.867012,-0.8590292,5.7371889,6.2483736,581.4235213,688.7045661,6.3206547,110.2214129,101.3429276,201.592225,11.5457413,12.9905136,0.9736197,39.7755919),(49725,'femur tibia pelvis',255,7,89,65.8854581,117.9520273,119.7232553,1.8,117.9804565,119.7342413,-0.919683,5.7667073,6.186279,566.326223,668.5166481,6.947362,108.0644202,98.2061672,199.5690319,11.5457413,12.7755427,1.2277724,38.4559909),(49726,'femur tibia pelvis',255,7,90,65.1509593,117.9478516,119.6093379,1.8,118.012416,119.6483101,-0.9673946,5.7121153,6.2037677,550.2302193,651.3806563,7.3621039,104.9975895,96.3268748,193.3658279,11.5457413,12.7755427,1.2277724,38.4559909),(49727,'femur tibia pelvis',255,7,91,64.4721298,117.9388938,119.5008145,1.8,117.977125,119.5343786,-1.0204681,5.6273325,6.126296,535.9186917,636.1476003,7.8065594,103.8388619,95.234944,190.2877586,11.5179504,12.7248603,1.3667783,38.8119561),(49728,'femur tibia pelvis',255,7,92,63.5717981,117.9296126,119.3962121,1.8,117.9786529,119.4104454,-1.0653977,5.6568615,6.0315395,521.8997633,620.3610806,8.1116843,102.8528593,92.2595975,185.7244084,11.5319132,12.644806,1.4000611,38.5602507),(49729,'femur tibia pelvis',255,7,93,62.983662,117.9276285,119.2912809,1.8,117.944023,119.3267955,-1.0942337,5.4948033,6.110787,509.2517182,608.222871,8.2883251,99.5326584,92.6787895,182.868767,11.3401874,12.5274503,1.0303768,38.2042855),(49730,'femur tibia pelvis',255,7,94,63.3986359,117.9381704,119.1780983,1.8,118.0086363,119.1995291,-1.1260824,5.5135114,6.0187572,498.9673082,599.7503156,8.61089,99.6468701,90.4990074,181.2780849,11.241906,12.5127034,1.2924967,38.2042855),(49731,'femur tibia pelvis',255,7,95,63.1004276,117.9460757,119.0795971,1.8,118.0273421,119.1344386,-1.1365884,5.4355716,5.9332391,488.6376001,591.1048457,8.6554677,99.6259947,89.8962683,178.2861213,11.171888,12.4015431,1.3258177,37.5966149),(49732,'femur tibia pelvis',255,7,96,62.6471286,117.9452392,118.9752658,1.8,118.0291552,118.9967205,-1.1516934,5.411463,6.0217686,482.2384848,584.1364429,8.712116,97.0041329,89.1142528,175.740529,11.171888,12.5274503,1.4677147,38.2042855),(49733,'femur tibia pelvis',255,7,97,61.705003,117.9191325,118.8412136,1.8,117.9887843,118.8731047,-1.1645727,5.4328989,5.9647571,473.8127022,575.0269878,8.6784171,96.4040906,87.2117657,173.8898453,11.171888,12.4015431,1.3258177,37.5966149),(49734,'femur tibia pelvis',255,7,98,61.6517395,117.9106033,118.7403589,1.8,117.9590482,118.747348,-1.1847504,5.367448,6.0531836,469.4063896,569.832508,8.8185258,94.1376545,87.454296,171.428233,11.1473707,12.4015431,1.3258177,37.3449095),(49735,'femur tibia pelvis',255,7,99,61.9088253,117.9145025,118.6547227,1.8,117.9825628,118.6939085,-1.2110259,5.3926344,5.9782699,466.0151989,564.5168433,9.039248,94.4281297,86.4169831,170.1334406,11.1473707,12.4015431,1.3258177,37.5966149),(49736,'femur tibia pelvis',255,7,100,61.8786688,117.9231728,118.5562342,1.8,118.008747,118.5739581,-1.2215935,5.3060293,6.0309808,462.7303704,557.6180981,9.1057985,92.4589408,87.2084086,167.5358064,11.1430191,12.4015431,1.3258177,37.3449095),(49737,'femur tibia pelvis',255,7,101,61.8684861,117.9269245,118.4599477,1.8,117.9885611,118.4794091,-1.2399176,5.4338118,5.9313294,461.5499831,555.3846429,9.223114,93.6357778,84.9403699,164.4026256,11.1473707,12.5789281,1.4337302,37.7008747),(49738,'femur tibia pelvis',255,7,102,61.875144,117.9392584,118.3611349,1.8,118.0162227,118.3691525,-1.255268,5.4241365,5.9672173,459.3252385,550.0777975,9.3194515,92.183302,84.6817251,168.8590687,11.1473707,12.4015431,1.3258177,37.3449095),(49739,'femur tibia pelvis',255,7,103,62.294426,117.9437478,118.2727336,1.8,118.033082,118.2653031,-1.2782846,5.4166844,5.8878725,458.6447396,549.1438946,9.5191027,93.266948,84.6725977,167.8253489,11.1473707,12.3043918,1.359703,37.3449095),(49740,'femur tibia pelvis',255,7,104,62.618203,117.9388693,118.1831455,1.8,117.9835719,118.2008031,-1.2864895,5.3917808,5.9338022,458.5248014,548.7337981,9.6152771,92.4759174,85.0414391,165.2869342,10.9556448,12.4015431,1.3258177,37.0932041),(49741,'femur tibia pelvis',255,7,105,62.7952257,117.9446683,118.1004021,1.8,117.9989354,118.1432396,-1.3019436,5.3849567,5.916857,459.1202619,545.6447128,9.7274312,92.2186748,85.2597876,164.3384923,11.1430191,12.3043918,1.359703,37.0932041),(49742,'femur tibia pelvis',255,7,106,62.7636704,117.9451984,118.0139725,1.8,118.0163416,118.0236937,-1.3138949,5.3709935,5.9078628,458.0800312,544.049588,9.7852836,92.08907,85.2877646,162.4263568,11.1430191,12.4905505,1.5019398,37.4491693),(49743,'femur tibia pelvis',255,7,107,62.575402,117.9429389,117.9278903,1.8,117.9815826,117.9154768,-1.3019712,5.4516133,5.858766,457.2204719,543.4242314,9.6935266,92.7540423,83.8688373,168.9795785,11.0870752,12.2215837,1.3940875,37.0932041),(49744,'femur tibia pelvis',255,7,108,62.4566222,117.9439608,117.8492962,1.8,117.9705021,117.8267088,-1.3189809,5.4392037,5.8969987,458.1118978,545.4171951,9.7631985,92.4906427,84.2240742,167.2883713,10.9556448,12.3043918,1.359703,37.0932041),(49745,'femur tibia pelvis',255,7,109,62.7659084,117.9475552,117.7807947,1.8,117.9755771,117.7717291,-1.3313456,5.4308987,5.9514702,461.1221286,550.1780519,9.8725633,92.4440573,84.9071494,166.7283952,11.1430191,12.4015431,1.3258177,37.0932041),(49746,'femur tibia pelvis',255,7,110,62.7316117,117.9462235,117.7126959,1.8,117.9625444,117.747275,-1.3392655,5.416923,6.0235269,460.498942,553.0972278,9.9047415,91.8228202,85.0111661,165.274106,11.1430191,12.4015431,1.3258177,37.0932041),(49747,'femur tibia pelvis',255,7,111,62.8531329,117.9500617,117.6624836,1.8,117.9795618,117.6902669,-1.3477963,5.5079462,6.0796184,460.1520779,559.5649769,9.9631632,92.0394899,83.5433145,164.9603463,11.1473707,12.5127034,1.2924967,37.3449095),(49748,'femur tibia pelvis',255,7,112,63.0392194,117.9491443,117.6199496,1.8,117.99743,117.6094345,-1.3657473,5.49752,6.1329663,456.6362865,569.4787626,10.0709446,92.8553542,83.0622336,164.873797,10.9567357,12.644806,1.4000611,37.7008747),(49749,'femur tibia pelvis',255,7,113,62.9392385,117.9417364,117.5523075,1.8,117.9747584,117.4847935,-1.3850209,5.4756392,6.2882026,450.4975081,577.8410043,10.1319871,91.8928732,82.2730444,163.5152988,11.0849546,12.9263977,1.3016288,37.7008747),(49750,'femur tibia pelvis',255,7,114,62.7354162,117.9313894,117.5034315,1.8,117.9333616,117.4154881,-1.4060874,5.4541572,6.335359,443.7867768,585.6190551,10.1748,92.4366011,81.3667007,162.4851574,10.954554,13.047241,1.2698761,37.7008747),(49751,'femur tibia pelvis',255,7,115,63.1694687,117.9278091,117.458511,1.8,117.9272772,117.3370931,-1.4221885,5.504207,6.378148,446.167423,598.4867894,10.2974425,93.8339456,81.0593468,158.9565765,10.9556448,13.3272566,1.9333406,39.7755919),(49752,'femur tibia pelvis',255,7,116,63.7386941,117.9299968,117.4179444,1.8,117.9228116,117.2766205,-1.4110384,5.5066491,6.4193707,452.4787267,601.355676,10.354285,93.6782908,82.1695219,164.1297313,10.9567357,13.2369013,1.8000283,39.0204757),(49753,'femur tibia pelvis',255,7,117,63.7971608,117.9315529,117.386698,1.8,117.9434814,117.2846824,-1.3957523,5.5102434,6.4501819,454.5390069,600.7080096,10.3103788,93.130398,82.4898238,163.5905024,10.9567357,13.2369013,1.3415644,37.8051345),(49754,'femur tibia pelvis',255,7,118,64.2034626,117.9349333,117.3447525,1.8,117.9572823,117.283131,-1.3872878,5.5876606,6.491234,458.5347498,603.7537098,10.344258,93.010622,82.0620254,163.6184542,11.0870752,13.145925,1.3734008,38.0568399),(49755,'femur tibia pelvis',255,7,119,65.0025266,117.9371229,117.2725601,1.8,117.9754353,117.2145812,-1.3882475,5.5759844,6.4847389,463.1654968,611.0436377,10.476722,94.2279475,83.0643461,165.0503815,11.0870752,13.2369013,1.3415644,38.0568399),(49756,'femur tibia pelvis',255,7,120,65.8782407,117.9354409,117.2040634,1.8,117.9726911,117.1117058,-1.3826715,5.5652583,6.468163,468.2807125,613.04855,10.5956872,94.7793914,84.1435723,165.1095219,11.0870752,13.2369013,1.3415644,38.3085453),(49757,'femur tibia pelvis',255,7,121,66.9281801,117.9336965,117.1365031,1.8,117.9652985,116.9229635,-1.3828191,5.5508327,6.6109832,473.6328184,622.5413044,10.7651615,94.1677333,85.3264445,163.2989977,11.0870752,13.6556983,1.3487144,39.1679213),(49758,'femur tibia pelvis',255,7,122,67.4598077,117.9374424,117.0734051,1.8,117.9945667,116.8743887,-1.3703286,5.5480301,6.5624264,476.9733907,620.5451738,10.7974835,94.5603254,85.9716654,164.9813945,11.1484615,13.5879276,1.2490458,38.8119561),(49759,'femur tibia pelvis',255,7,123,67.5521795,117.9461698,116.9852406,1.8,118.0012922,116.7899457,-1.3592513,5.6322568,6.6665129,480.2186408,611.2173441,10.7623267,91.684716,85.2622058,157.6490044,11.1592018,13.7298596,1.2193515,39.4196267),(49760,'femur tibia pelvis',255,7,124,66.9736666,117.9585105,116.8725045,1.8,118.0121111,116.5945837,-1.3498407,5.6255608,7.0845068,481.5595086,599.5828871,10.6261309,84.6329749,85.6020452,146.0721922,11.171888,14.0488921,1.1618885,41.2426385),(49761,'femur tibia pelvis',255,7,125,66.3820616,117.9815527,116.7571863,1.8,118.0419612,116.4817492,-1.3588954,5.6191191,6.9472307,481.7413826,582.9352333,10.574287,83.9090081,85.7325445,146.0502828,11.171888,13.8836442,1.1902899,40.5307081),(49762,'femur tibia pelvis',255,7,126,65.4965564,118.0107973,116.6666609,1.8,118.0939554,116.5463313,-1.3734312,5.6232221,6.7356384,483.8178399,566.2117259,10.4963709,84.062073,86.0392555,150.1705182,11.171888,13.7298596,1.2193515,40.9909331),(49763,'femur tibia pelvis',255,7,127,64.6963735,118.0402564,116.5414201,1.8,118.0915975,116.2809812,-1.4097705,5.6134043,6.6035502,483.6884648,551.8946041,10.5055483,83.5754387,86.1666893,146.4014331,11.171888,13.8570216,2.0899424,41.9977547),(49764,'femur tibia pelvis',255,7,128,63.8429271,118.0662213,116.4707723,1.8,118.1522642,116.3163924,-1.4370597,5.6142192,6.7696928,483.5767824,533.065688,10.4513095,78.7429656,86.1342891,145.1890364,11.171888,13.7298596,1.2193515,42.3537199),(49765,'femur tibia pelvis',255,7,129,63.6055354,118.06639,116.3580585,1.8,118.1192849,116.3032168,-1.4910678,5.5664065,6.2127329,484.3621044,519.2705986,10.5336789,83.5816708,87.0152231,149.9647742,11.171888,13.4856331,2.1057514,41.0341189),(49766,'femur tibia pelvis',255,7,130,63.1912329,118.1024938,116.2855317,1.8,118.1462026,116.2242299,-1.5441372,5.5523733,6.2619077,484.2822212,507.5683666,10.5243889,81.0565076,87.2207604,149.7642621,11.171888,13.6556983,1.1493771,41.3900841),(49767,'femur tibia pelvis',255,7,131,62.7391088,118.1394685,116.1855538,1.8,118.1867756,115.9992046,1.5098612,5.6106022,6.2771073,484.0700683,495.9762012,10.4177402,79.0134975,86.2777379,142.2662101,11.4648615,13.3272566,1.2082521,40.5307081),(49768,'femur tibia pelvis',255,7,132,62.5642122,118.1683469,116.1181671,1.8,118.2359392,116.0194964,1.1129145,5.5942203,6.6263381,484.422945,491.2054959,8.3897838,74.1292539,86.5934691,143.1463344,11.3891873,13.6556983,1.1493771,42.3537199),(49769,'femur tibia pelvis',255,7,133,62.0072396,118.1936169,116.052622,1.8,118.2358147,115.9102226,0.436706,6.7442007,5.6491677,476.1986692,487.5185102,1.8487719,86.2991747,70.6086149,142.8653748,11.3390965,13.3272566,1.2082521,40.6349679),(49770,'femur tibia pelvis',255,7,134,61.5994272,118.2257044,115.9845701,1.8,118.2655701,115.8833737,0.2696309,6.4385873,5.7784691,468.1337996,488.6560576,0.7284747,84.5649685,72.7075337,147.378295,11.3869017,13.1809902,1.2387369,38.9162159),(49771,'femur tibia pelvis',255,7,135,60.8470807,118.2691968,115.9225783,1.8,118.2943857,115.8389182,0.2284411,6.4259593,5.7166055,461.5204291,488.7893805,0.520079,85.503431,71.8212494,144.0826595,11.5146155,13.3272566,1.2082521,40.0272973),(49772,'femur tibia pelvis',255,7,136,60.0852788,118.3101923,115.8492609,1.8,118.329347,115.7443379,0.2352929,6.4553095,5.735528,453.8896642,488.7890529,0.5442585,85.2212826,70.3126107,140.4538459,11.418385,13.3272566,1.2082521,40.3832625),(49773,'femur tibia pelvis',255,7,137,59.2941596,118.3476991,115.7954605,1.8,118.3366912,115.724681,0.2299907,6.2865881,5.7632144,447.8948938,490.5276444,0.5135827,85.1135516,71.246102,145.5616071,11.4779056,13.1178053,2.1224513,39.3153669),(49774,'femur tibia pelvis',255,7,138,59.5895145,118.3906755,115.7213235,1.8,118.3721873,115.570073,0.2452068,6.6420827,5.7756964,447.0538739,493.3451319,0.5852776,85.4174278,67.3062792,139.3080941,11.5319132,13.348021,2.1498706,41.4943439),(49775,'femur tibia pelvis',255,7,139,60.1352972,118.4326989,115.6701776,1.8,118.4152965,115.5723342,0.250538,6.2787023,5.7990447,445.5336988,495.3370508,0.6160553,85.4170086,70.9595198,144.8487073,11.3401874,12.8977995,2.0940746,39.6713321),(49776,'femur tibia pelvis',255,7,140,60.1566138,118.4632716,115.6154427,1.8,118.4243147,115.4993671,0.2664038,6.2434639,5.7982687,444.0071931,497.3492299,0.6948875,85.7754718,71.1155222,146.3359016,11.3401874,12.8977995,2.0940746,39.4196267),(49777,'femur tibia pelvis',255,7,141,59.8069324,118.5034217,115.571429,1.8,118.4724377,115.4669277,0.2758201,6.2044922,5.8142391,442.6397398,499.4333019,0.7392831,85.8983078,71.3418162,147.7795759,11.5146155,12.8977995,2.0940746,39.4196267),(49778,'femur tibia pelvis',255,7,142,59.8274657,118.5413199,115.5377472,1.8,118.53095,115.4780672,0.2641107,6.1445185,5.7775728,438.9283264,503.1118365,0.6795161,87.0801381,71.4341286,148.8916133,11.5146155,12.695808,1.9890207,39.1679213),(49779,'femur tibia pelvis',255,7,143,60.0448276,118.5691038,115.4898171,1.8,118.5654979,115.3351649,0.2555557,6.3851056,5.7906897,439.17587,507.4560289,0.6394705,87.633089,68.7813008,146.3926778,11.3412782,12.695808,1.9890207,39.5238865),(49780,'femur tibia pelvis',255,7,144,60.2734354,118.6059028,115.456692,1.8,118.6076502,115.2970648,0.2298858,6.3161297,5.8128545,440.1499882,511.1839844,0.5215968,87.9402688,69.6866606,147.6613224,11.5319132,12.5274503,2.1112158,39.6713321),(49781,'femur tibia pelvis',255,7,145,59.5708835,118.6436034,115.3723731,1.8,118.6285038,115.2022876,0.2252311,6.3160283,5.8294428,440.3998482,512.3094289,0.4952029,87.8830873,69.7273393,146.2891066,11.5330041,12.8977995,2.0940746,39.3153669),(49782,'femur tibia pelvis',255,7,146,59.1470137,118.6876365,115.3477822,1.8,118.695757,115.1847235,0.2047462,6.3365166,5.8620642,440.5498345,516.0433675,0.407508,88.0309983,69.5255549,143.3054064,11.601576,12.9263977,1.1964627,39.3153669),(49783,'femur tibia pelvis',255,7,147,59.4256958,118.7185855,115.3267369,1.8,118.6434088,115.2660916,0.1185234,17.38021,9.3575461,450.5385166,521.743913,0.138483,55.7564889,25.9225013,49.3165171,11.601576,12.7538463,2.1401095,39.6713321),(49784,'femur tibia pelvis',255,7,148,59.2786617,118.7678207,115.2831857,1.8,118.7412096,115.1594532,0.1717683,6.1130586,5.9171214,440.2694351,522.163039,0.2886409,88.2461263,72.0211382,150.9220253,11.601576,12.7755427,1.2277724,38.8119561),(49785,'femur tibia pelvis',255,7,149,59.500108,118.7969986,115.2458081,1.8,118.7518728,115.1235659,0.1617712,6.1222206,5.9354984,441.8882179,526.2888057,0.257263,88.6680057,72.1777684,148.2135241,11.601576,13.0896253,1.1659045,40.5307081),(49786,'femur tibia pelvis',255,7,150,59.9570996,118.8234698,115.2318305,1.8,118.8076111,115.1504057,0.1669586,6.115773,5.9614194,443.5341664,534.3678353,0.2759739,89.6376853,72.5229935,150.2553604,11.6868255,13.4924769,2.2206668,41.1383787),(49787,'femur tibia pelvis',255,7,151,60.6835417,118.8495377,115.2249263,1.8,118.8470433,115.0752541,0.1332545,6.0271007,5.9701787,446.9280546,543.6454166,0.1785302,91.0601577,74.1530761,152.6718588,11.601576,12.7538463,2.1401095,39.9230375),(49788,'femur tibia pelvis',255,7,152,61.1361693,118.8752627,115.2173737,1.8,118.8679351,115.0990426,0.1165506,6.0968654,5.9845064,450.9399144,552.650432,0.137787,92.3468696,73.9625828,155.1364571,11.7258208,13.0896253,1.1659045,40.8866733),(49789,'femur tibia pelvis',255,7,153,61.4775702,118.9004036,115.2034469,1.8,118.91991,115.0925318,0.0910452,5.8552772,5.9504674,452.0919706,560.9479449,0.0846992,94.2695596,77.2110279,154.4915658,11.601576,12.6885346,1.076855,40.5307081),(49790,'femur tibia pelvis',255,7,154,61.5875101,118.9405449,115.1946156,1.8,118.9337116,115.1382601,0.0862293,5.6679726,5.9878628,452.803284,568.7580358,0.0761333,94.9851481,79.8880516,156.540278,11.601576,12.6885346,1.076855,40.5307081),(49791,'femur tibia pelvis',255,7,155,61.453736,118.9655362,115.1886524,1.8,118.902948,115.1989586,0.063499,5.5933326,6.0021658,448.5862145,577.6914841,0.0412427,96.2471716,80.2001675,170.3663297,11.171888,12.3043918,2.9304993,37.3449095),(49792,'femur tibia pelvis',255,7,156,61.6714896,119.009382,115.1940848,1.8,118.9760924,115.2303339,0.0535894,5.5855494,6.0421661,449.4370783,591.6223166,0.02949,97.9155994,80.464256,171.5622742,11.171888,12.5789281,3.0045265,37.9525801),(49793,'femur tibia pelvis',255,7,157,62.097989,119.0468145,115.1969032,1.8,119.008945,115.217988,0.0411848,5.5593708,6.0708012,449.3799065,604.3636144,0.017545,99.5525297,80.8328719,172.5877498,11.171888,12.644806,2.9708574,37.9525801),(49794,'femur tibia pelvis',255,7,158,62.6560805,119.0888554,115.2011378,1.8,119.0412239,115.2277429,0.0276735,5.5527643,6.1036003,452.6807056,617.5500278,0.0079952,101.1779925,81.5234871,174.0847072,11.171888,12.644806,2.9708574,37.9525801),(49795,'femur tibia pelvis',255,7,159,63.4013215,119.1215186,115.1973235,1.8,119.0912192,115.1948176,0.0080899,5.2066614,6.120658,459.1926374,634.4002826,0.0006916,103.6490336,88.1932982,176.9707706,10.7422,12.7248603,2.9375747,38.1000257),(49796,'femur tibia pelvis',255,7,160,63.6168371,119.1419255,115.1931239,1.8,119.0669319,115.2144499,-0.020749,5.2210784,6.1497287,463.2990101,645.8597914,0.0045641,105.0224845,88.7362675,178.9227595,10.7422,12.7248603,2.9375747,38.3517311),(49797,'femur tibia pelvis',255,7,161,64.1738096,119.1878948,115.1728263,1.8,119.1279288,115.1985855,-0.0437378,5.2216516,6.1921093,466.2171392,656.4944148,0.0204476,106.0211281,89.2853786,179.8726488,10.7422,12.8188253,2.9047439,38.1000257),(49798,'femur tibia pelvis',255,7,162,64.7750378,119.2228256,115.1683436,1.8,119.1723142,115.1879345,-0.0610445,5.2536279,6.2613796,470.6510278,671.1006108,0.04018,107.1809488,89.5859092,181.9331532,10.7422,13.0047187,0.1325515,38.7076963),(49799,'femur tibia pelvis',255,7,163,65.1636598,119.2535001,115.1717421,1.8,119.2100725,115.1906994,-0.0730566,5.2672206,6.2905026,474.8424533,685.6788658,0.057863,109.0022379,90.1504785,184.0194364,10.7422,13.0684503,0.1651487,38.7076963),(49800,'femur tibia pelvis',255,7,164,65.2484785,119.2839647,115.1811776,1.8,119.2262172,115.2303406,-0.0909861,5.2817863,6.3258914,478.9835479,697.7253678,0.0897781,110.2967675,90.6859011,185.6594643,10.7422,13.145925,0.1973956,38.7076963),(49801,'femur tibia pelvis',255,7,165,65.3336888,119.3141442,115.1882926,1.8,119.2250849,115.2119471,-0.1081262,5.2949148,6.358669,483.0402764,709.110138,0.1268102,111.5186422,91.2272039,187.1838738,10.7422,13.145925,0.1973956,38.7076963),(49802,'femur tibia pelvis',255,7,166,65.6448214,119.341981,115.1953662,1.8,119.2912144,115.2179775,-0.1224055,5.3548975,6.3868146,488.5447686,722.4456274,0.16311,113.1151717,91.2332616,189.2933511,10.7422,13.2369013,0.2292319,38.9594017),(49803,'femur tibia pelvis',255,7,167,65.5066273,119.3768651,115.2035946,1.8,119.3110174,115.2286129,-0.1390441,5.3680926,6.4200175,492.0677112,735.7801052,0.2097195,114.6071804,91.6652806,190.1868636,10.7422,13.3272566,0.3625442,39.2111071),(49804,'femur tibia pelvis',255,7,168,65.4914651,119.3987647,115.2109549,1.8,119.3256775,115.2443747,-0.1589963,5.4022016,6.5056652,495.9033127,749.1056311,0.2736181,115.1466616,91.7965209,191.2761659,11.171888,13.4856331,0.3923401,39.5670723),(49805,'femur tibia pelvis',255,7,169,65.8184871,119.418946,115.227697,1.8,119.3521609,115.2690417,-0.1774806,5.4340639,6.5421668,501.157993,764.9022478,0.341927,116.9187925,92.2252661,193.4057467,11.171888,13.5675304,0.1911845,39.9230375),(49806,'femur tibia pelvis',255,7,170,65.5780742,119.4357726,115.249232,1.8,119.3352258,115.3125688,-0.1962881,5.4748269,6.6214969,504.3990442,777.752025,0.4157293,117.4586405,92.1305915,193.378268,11.171888,13.6556983,0.2220819,40.1747429),(49807,'femur tibia pelvis',255,7,171,65.3793432,119.4567381,115.2757349,1.8,119.3606713,115.3314421,-0.2098967,5.4354202,6.6405083,508.4151557,791.9264974,0.473057,119.2569101,93.5374155,195.7116003,11.171888,13.7567282,0.2525543,40.1747429),(49808,'femur tibia pelvis',255,7,172,65.2252037,119.4739888,115.3073067,1.8,119.3750737,115.3593919,-0.2234809,5.3904993,6.6791949,511.597249,807.7866947,0.5339527,120.9407276,94.9072103,197.1842758,11.171888,13.8836442,0.3805064,40.4264483),(49809,'femur tibia pelvis',255,7,173,64.9610124,119.4925085,115.3333022,1.8,119.3530035,115.3855509,-0.2368373,5.4504592,6.7661242,516.2768821,824.5278639,0.5960275,121.8611781,94.7217221,197.8275194,11.171888,13.9962251,0.3120421,40.4264483),(49810,'femur tibia pelvis',255,7,174,65.0442086,119.5102223,115.3720053,1.8,119.401159,115.3997787,-0.2474595,5.4326866,6.7776325,521.8518122,839.871929,0.6504031,123.9181867,96.0577791,199.9080329,11.171888,14.1340576,0.340979,40.4264483),(49811,'femur tibia pelvis',255,7,175,65.6212668,119.5476075,115.4035793,1.8,119.4779182,115.4261717,-0.2534155,5.4677691,6.8074627,528.2328741,859.1950161,0.687453,126.2136934,96.6084828,203.6033762,11.171888,14.1340576,0.340979,41.0341189),(49812,'femur tibia pelvis',255,7,176,66.4872458,119.5772101,115.4286176,1.8,119.5243039,115.4322671,-0.2585039,5.4349987,6.8306155,535.9474342,882.0093087,0.7241455,129.1258906,98.6104072,207.1447815,11.171888,14.1731921,0.2449787,41.2858243),(49813,'femur tibia pelvis',255,7,177,66.2397833,119.6077673,115.413703,1.8,119.5615426,115.4318777,-0.2666965,5.4392501,6.9781386,539.2744108,902.1193696,0.766798,129.2779384,99.1449922,206.0315389,11.171888,14.4441652,0.3970794,41.5375297),(49814,'femur tibia pelvis',255,7,178,66.0840771,119.656911,115.4172753,1.8,119.6388569,115.4334285,-0.2685403,5.5361929,7.0254821,544.0207588,917.0858059,0.7753538,130.5370639,98.2662211,207.5084887,11.171888,14.5397175,0.3310961,41.2858243),(49815,'femur tibia pelvis',255,7,179,66.2644008,119.7153503,115.4236007,1.8,119.6564858,115.4353159,-0.2711493,5.5145525,7.0812946,548.9976354,936.150374,0.7922756,132.2004567,99.5543403,209.3427623,11.4172458,14.6157096,0.4241944,41.6417895),(49816,'femur tibia pelvis',255,7,180,66.9947034,119.7596727,115.4485183,1.8,119.7119869,115.5061149,-0.2728557,5.594362,7.2337792,559.429975,959.3145622,0.8108691,132.6159578,99.998887,208.6928609,11.5472711,14.8413514,0.3858827,41.8934949),(49817,'femur tibia pelvis',255,7,181,67.5666703,119.8069821,115.4612499,1.8,119.751181,115.5065001,-0.280206,5.5714449,7.2813759,568.7422617,981.5923037,0.861271,134.8086287,102.0816457,211.8923194,11.4648615,14.8413514,0.3858827,42.5011655),(49818,'femur tibia pelvis',255,7,182,68.4287888,119.8445278,115.4652179,1.8,119.8124708,115.5013709,-0.2849466,5.6790605,7.3696082,578.930902,1015.6453665,0.9012148,137.8153809,101.9413155,215.4310122,11.5472711,15.0329403,0.5404195,43.1088361),(49819,'femur tibia pelvis',255,7,183,68.6978477,119.8702563,115.4946105,1.8,119.8122594,115.533821,-0.2918632,5.7712648,7.504483,587.4655369,1044.8708227,0.9479464,139.2328853,101.7914725,216.785478,11.601576,15.240301,0.3752708,43.1088361),(49820,'femur tibia pelvis',255,7,184,68.3512994,119.9348137,115.4984307,1.8,119.8160981,115.5173949,-0.2935447,5.7505534,7.688879,595.7648789,1069.8119611,0.9537483,139.1375725,103.6013118,216.621287,11.6727634,15.4926212,0.3392926,43.4648013),(49821,'femur tibia pelvis',255,7,185,68.3281925,119.9876467,115.487968,1.8,119.8883607,115.4881152,-0.2954369,5.8719816,7.742478,604.3544093,1106.4305965,0.9653966,142.9039384,102.9217134,220.9607926,11.7767143,15.5758196,0.4266275,43.9682121),(49822,'femur tibia pelvis',255,7,186,68.7553633,120.0196057,115.4979461,1.8,119.9420115,115.4836218,-0.2979074,5.8885212,7.8961791,614.3800302,1151.9699612,0.9872611,145.889543,104.3351997,223.4586803,11.8231864,15.7994355,0.390607,44.3241773),(49823,'femur tibia pelvis',255,7,187,69.2366927,120.089163,115.5009355,1.8,120.052223,115.4753948,-0.3065403,5.9928043,7.9644452,625.0319754,1201.8831753,1.0507859,150.9060759,104.2970779,229.249607,11.9153649,16.0429641,0.3556359,44.9318479),(49824,'femur tibia pelvis',255,7,188,70.0729068,120.1529304,115.4973439,1.8,120.1243163,115.4716475,-0.3076016,5.9770658,8.0265918,640.1250249,1249.6134769,1.0706194,155.6841946,107.0968675,235.3221933,11.9595284,16.1975849,0.3805064,44.9318479),(49825,'femur tibia pelvis',255,7,189,71.1516599,120.1998031,115.5246717,1.8,120.1487563,115.5073152,-0.3110726,6.0684361,8.2096915,656.1136574,1290.2067274,1.1109732,157.1565422,108.1190676,236.0410663,12.0525259,16.3620316,0.2386093,45.8954837),(49826,'femur tibia pelvis',255,7,190,72.4924223,120.2780315,115.506082,1.8,120.225914,115.5004723,-0.3169061,6.1979962,8.2851884,672.6070285,1327.3727009,1.1733158,160.2103219,108.5200771,240.2065721,12.2116407,16.5861794,0.2889754,45.8954837),(49827,'femur tibia pelvis',255,7,191,73.2595953,120.3228486,115.4870429,1.8,120.2565937,115.4921121,-0.3289475,6.2097202,8.3232282,683.2650032,1361.557813,1.2742219,163.5853038,110.0315275,244.1882957,12.2116407,16.7137033,0.3136207,46.1471891),(49828,'femur tibia pelvis',255,7,192,73.5176322,120.347519,115.4801015,1.8,120.3613951,115.4789179,-0.3498154,6.3660874,8.3277666,692.7360598,1398.1626734,1.4392301,167.891673,108.8166119,248.9299053,12.3227098,16.8840595,0.2573237,47.1108249),(49829,'femur tibia pelvis',255,7,193,74.5246587,120.3696374,115.4153333,1.8,120.4058001,115.4531356,-0.3726949,6.5232229,8.3447023,700.2398635,1442.8145165,1.646849,172.9018561,107.3456902,254.0545321,12.4242267,16.998492,0.2817719,47.1108249),(49830,'femur tibia pelvis',255,7,194,75.2258119,120.3684341,115.4268709,1.8,120.4177435,115.4783924,-0.3946198,6.6699822,8.1836056,713.6445021,1474.478345,1.8531551,180.1746582,106.993464,262.1612654,12.6199098,16.998492,0.2817719,47.9702009),(49831,'femur tibia pelvis',255,7,195,75.6191335,120.375373,115.4580967,1.8,120.4087477,115.5113215,-0.4115949,6.6368552,8.3549929,727.7033012,1508.4493843,2.0172318,180.544663,109.6457997,265.2131108,12.6199098,17.257203,0.3296244,48.3261661),(49832,'femur tibia pelvis',255,7,196,76.92683,120.3591657,115.4929222,1.8,120.4349089,115.5226918,-0.4269683,6.8219117,8.5605645,750.8817075,1553.2846588,2.1986932,181.4465218,110.0691039,267.5835576,12.8573456,17.4116449,0.2749098,48.3261661),(49833,'femur tibia pelvis',255,7,197,78.4367823,120.3696015,115.537271,1.8,120.4481494,115.5668543,-0.4384519,6.9501737,8.5964739,769.7786503,1615.9914047,2.3561469,187.9830528,110.7567498,276.4431319,13.0183096,17.533166,0.2984989,48.9338367),(49834,'femur tibia pelvis',255,7,198,80.6851497,120.3602221,115.5969265,1.8,120.444926,115.5957279,-0.4565179,6.8979096,8.8054276,798.7566605,1672.2996679,2.6132164,189.9169176,115.7969169,280.2080103,13.1447186,17.6643059,0.3217506,49.5415073),(49835,'femur tibia pelvis',255,7,199,80.5030916,120.307374,115.6661774,1.8,120.4756088,115.6064431,-0.4631649,7.0412485,8.8802446,815.9443735,1694.6254672,2.6782566,190.8309446,115.8806387,279.202176,13.298705,17.6643059,0.3217506,50.6525887),(49836,'femur tibia pelvis',255,7,200,82.1103952,120.3222246,115.7079133,1.8,120.504076,115.658382,-0.4663327,7.186937,9.0798805,839.9850772,1749.7204349,2.7664692,192.7030244,116.8766447,283.9500645,13.4931812,17.9545839,0.3671738,51.2602593),(49837,'femur tibia pelvis',255,7,201,83.163132,120.3174676,115.8023153,1.8,120.5005142,115.721378,-0.4829467,7.2917645,9.1409262,873.155941,1777.3661572,2.9891448,194.4404887,119.7454934,288.8907324,13.6782792,18.0724546,0.3142319,51.5119647),(49838,'femur tibia pelvis',255,7,202,86.1227794,120.3182173,115.9136551,1.8,120.5167864,115.8178539,-0.4988391,7.3914019,9.3766615,921.5815225,1865.6860928,3.2851924,198.9712537,124.6829134,297.2137564,13.9108247,18.209851,0.3366748,52.3713407),(49839,'femur tibia pelvis',255,7,203,87.4420573,120.3077451,116.019611,1.8,120.557432,115.9120272,-0.5075258,7.6781079,9.4804724,963.3684511,1919.6312865,3.4424766,202.4826612,125.4695127,301.9845613,14.2396937,18.3562794,0.2847304,53.4824221),(49840,'femur tibia pelvis',255,7,204,89.4177293,120.3363508,116.1758832,1.8,120.5585357,116.0501686,-0.4917809,7.9098744,9.6860496,1019.2186468,2016.4386486,3.322905,208.1796736,128.8539612,312.2262151,14.6561364,18.7345939,0.638914,54.6977633),(49841,'femur tibia pelvis',255,7,205,92.1512866,120.3371929,116.3326483,1.8,120.571188,116.1799564,-0.4826846,7.9730594,9.7500034,1096.9587714,2101.5556031,3.3088972,215.5440899,137.5831682,326.0954892,14.9009934,18.9939594,0.6570749,55.2011741),(49842,'femur tibia pelvis',255,7,206,97.265419,120.3949678,116.5609624,1.8,120.6242221,116.3968847,-0.4601876,8.3130362,9.9705841,1229.8595938,2230.3395109,3.1974252,223.6919601,147.9434908,345.6122562,15.3652575,19.8076381,0.4248322,57.7361162),(49843,'femur tibia pelvis',255,7,207,105.0421095,120.4328785,116.8843543,1.8,120.739794,116.6829167,-0.3855117,8.3305908,10.030582,1411.1866739,2512.8286877,2.4755106,250.5167373,169.3981503,386.4451578,15.7664058,20.1999066,0.4160645,60.0625388),(49844,'femur tibia pelvis',255,7,208,116.9537125,120.6755813,117.2246515,1.8,120.950005,117.0344772,-0.2974484,8.6243643,10.1311087,1682.1888938,2995.4727873,1.6743258,295.670777,195.0507689,452.14867,16.5687024,20.9536242,0.4911636,61.8244767),(49845,'femur tibia pelvis',255,7,209,133.9851548,120.9078897,117.6892423,1.8,121.1213593,117.6802795,-0.2129805,11.4169828,10.6483376,2119.5717606,3649.7271421,0.9977192,342.7508857,185.6507802,499.4412703,18.9481943,21.74493,0.6593101,69.012264),(49846,'femur tibia pelvis',255,7,210,154.4787226,120.9502778,118.5248665,1.8,120.8756794,118.8138413,-0.3668404,11.8666979,12.0324811,3047.4928002,4609.5769867,3.3120923,383.0944702,256.810514,559.9804367,19.6247343,22.6881774,0.6510767,72.1980626),(49847,'femur tibia pelvis',255,7,211,184.1402092,120.5424081,119.697116,1.8,120.5909099,119.7784333,-0.5976822,12.3344305,13.4284159,4013.0300016,6620.7143265,9.7183925,493.0376297,325.3518676,777.6165593,20.383421,26.5190958,0.865685,82.8665398),(49848,'femur tibia pelvis',255,7,212,213.6207568,120.6480932,120.4916689,1.8,121.0712921,120.4123566,-0.5051497,12.5680518,13.4301324,5397.6904518,8017.041645,8.3382043,596.9443504,429.4771009,972.1273362,22.4724515,27.1248527,0.8638883,86.7642688),(49849,'femur tibia pelvis',255,7,213,228.6665681,120.7288842,120.7724787,1.8,121.2476843,120.6944562,-0.5001045,12.8433843,13.727273,6107.5735232,8666.6623537,8.7631439,631.3462511,475.5423794,1055.3413168,22.5286797,27.4058766,0.8519663,87.6236448),(49850,'femur tibia pelvis',255,7,214,226.5819075,120.7361544,120.8935952,1.8,121.3491597,120.8194466,-0.5504871,13.3254317,14.0158215,6113.7105403,8757.8268956,10.3335007,624.8529128,458.8001876,1046.9097598,22.6190564,27.5134565,0.8960554,88.378761),(49851,'femur tibia pelvis',255,7,215,221.5929331,120.6632916,121.0445645,1.8,121.3649217,120.914241,-0.5246681,13.2820578,13.9694345,5944.957346,8627.1174017,9.2672623,617.5709813,447.5930951,1032.6993113,22.7440784,27.5871743,0.9179497,89.5941022),(49852,'femur tibia pelvis',255,7,216,213.2733693,120.5475983,121.2064917,1.8,121.3723847,120.924793,-0.5170791,13.1690992,13.9344037,5671.1564803,8449.2187403,8.6864553,606.3566781,430.6411844,998.560441,22.4911942,27.7306933,0.8621701,90.2017728),(49853,'femur tibia pelvis',255,7,217,190.6320304,120.6943321,121.1576595,1.8,121.3580845,120.9180918,-0.5186451,12.9850012,14.1410816,5378.334559,8036.2713601,7.8070908,568.2925517,414.1959237,935.9518462,22.3374674,27.7306933,0.8621701,90.4534782),(49854,'femur tibia pelvis',255,7,218,168.3004812,120.6766409,121.3129112,1.8,121.4031837,120.8719036,-0.4057396,12.0880467,13.7660338,4990.5210085,7166.736112,4.3698342,520.610092,412.8475963,865.1852868,22.1304681,27.4529946,0.874054,90.557738),(49855,'femur tibia pelvis',255,7,219,159.3410843,120.8173667,121.2092577,1.8,121.3410562,120.7890838,-0.3737085,11.5464791,13.6806927,4589.7155635,6576.2380479,3.5394019,480.6948137,397.4991449,790.1304128,21.6308124,27.179252,0.8861792,90.0543272),(49856,'femur tibia pelvis',255,7,220,150.5733129,120.9271267,121.0193586,1.8,121.2064971,120.6225282,-0.4059683,11.0722963,13.7733558,4128.3972558,6043.6131628,3.91372,438.790172,372.8582704,722.6336391,21.2432119,26.8477645,0.8760581,88.1881296),(49857,'femur tibia pelvis',255,7,221,144.7992058,120.8915912,120.9923374,1.8,121.1314967,120.5449966,-0.3652355,10.6158139,13.4010643,3732.3206932,5610.9286643,3.0786693,418.6927663,351.5812098,676.4065208,20.6210035,26.2426472,0.6926418,85.861707),(49858,'femur tibia pelvis',255,7,222,138.1553152,120.9187531,121.0373218,1.8,121.0859823,120.5402208,-0.3505456,10.4746047,13.0653749,3188.2363554,5098.5215959,2.7154574,390.2315589,304.3777246,615.7138906,19.897341,25.8420808,0.7501187,85.002331),(49859,'femur tibia pelvis',255,7,223,127.7783939,120.8113711,120.8701502,1.8,121.0347546,120.4086452,-0.3182576,9.9139157,12.5140558,2576.7527256,4432.1030937,2.0852155,354.1699973,259.9127138,533.8649477,19.0015787,25.2347974,0.7492693,82.0682378),(49860,'femur tibia pelvis',255,7,224,115.1651901,120.698808,120.6191028,1.8,120.9156307,120.291798,-0.2980159,9.2903666,12.1557759,1939.1874658,3796.1113389,1.6548307,312.288691,208.7309941,452.5304873,17.7651776,24.1582501,0.6719632,78.2747686),(49861,'femur tibia pelvis',255,7,225,98.8980675,120.4524029,120.2828448,1.8,120.6151112,120.0529057,-0.2645118,8.6155752,11.3668454,1325.2047743,3056.2687789,1.1266114,268.8757241,153.8150082,362.8389717,16.0854369,23.2190609,0.6805212,74.0210744),(49862,'femur tibia pelvis',255,7,226,86.118751,120.3177488,120.1269391,1.8,120.4212171,119.9045134,-0.2443304,7.6790249,10.6786228,899.3929403,2509.8574656,0.8399284,235.0356889,117.1233259,301.4382019,14.4164285,21.930932,0.6043055,69.1165238),(49863,'femur tibia pelvis',255,7,227,65.7541457,120.0353885,120.113496,1.8,120.1551677,119.9242405,-0.2186077,6.6858721,9.9325574,536.7396797,1941.9345718,0.5154347,195.5120417,80.2796815,236.3718635,12.7213456,20.6339739,0.5475622,65.175609),(49864,'femur tibia pelvis',255,7,228,45.5256085,119.613558,120.144623,1.8,119.6262463,119.9576803,-0.2059007,5.9698364,9.080835,259.5785999,1382.3064045,0.3171568,152.2223901,43.4816941,176.7585214,7.8164925,11.7988288,1.3876855,31.4767231),(49865,'femur tibia pelvis',255,7,229,23.7277011,117.5804537,120.3654859,1.8,118.3994482,120.1314029,-0.2213266,4.6395388,10.1390626,81.292656,549.5895857,0.1905761,54.2051677,17.5217106,61.7206109,6.44532,9.6560368,1.2068174,25.4000171),(49866,'femur tibia pelvis',255,7,230,9.2090414,115.0200065,120.8358873,1.8,115.0400775,120.7132514,-1.3809624,2.3071982,3.2335555,8.155932,17.5605089,1.4801905,5.4307121,3.5349941,7.8949987,4.726568,6.9418221,1.1902899,18.3164896),(49867,'femur tibia pelvis',255,7,231,0.4641531,115.0357026,121.0226404,1.8,115.0532589,121.0001408,-1.4843271,0.9892961,1.1829611,0.1151987,0.1870115,0.0767819,0.1580876,0.1164451,0.2387842,2.14844,3.0985242,0.9827937,7.6911982),(49868,'femur tibia pelvis',255,7,232,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49869,'femur tibia pelvis',255,7,233,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49870,'femur tibia pelvis',255,7,234,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49871,'femur tibia pelvis',255,7,235,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49872,'femur tibia pelvis',255,7,236,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49873,'femur tibia pelvis',255,7,237,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49874,'femur tibia pelvis',255,7,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49875,'femur tibia pelvis',255,7,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49876,'femur tibia pelvis',255,7,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49877,'femur tibia pelvis',255,7,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49878,'femur tibia pelvis',255,7,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49879,'femur tibia pelvis',255,7,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49880,'femur tibia pelvis',255,7,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49881,'femur tibia pelvis',255,7,245,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49882,'femur tibia pelvis',255,7,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49883,'femur tibia pelvis',255,7,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49884,'femur tibia pelvis',255,7,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49885,'femur tibia pelvis',255,7,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49886,'femur tibia pelvis',255,7,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49887,'femur tibia pelvis',255,7,251,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49888,'femur tibia pelvis',255,7,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49889,'femur tibia pelvis',255,7,253,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49890,'femur tibia pelvis',255,7,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49891,'femur tibia pelvis',255,7,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49892,'femur tibia pelvis',255,7,256,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49893,'femur tibia pelvis',255,7,257,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49894,'femur tibia pelvis',255,7,258,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49895,'femur tibia pelvis',255,7,259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49896,'femur tibia pelvis',255,7,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49897,'femur tibia pelvis',255,7,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49898,'femur tibia pelvis',255,7,262,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49899,'femur tibia pelvis',255,7,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49900,'femur tibia pelvis',255,7,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49901,'femur tibia pelvis',255,7,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49902,'femur tibia pelvis',255,7,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49903,'femur tibia pelvis',255,7,267,3.5739117,122.6651007,124.0405355,1.8,122.5817789,124.2136277,-1.0057157,2.0094599,2.8644202,2.4794007,4.3919923,0.4248529,1.5332919,1.2338642,2.3547627,4.4327216,5.6024461,1.0040671,15.4866562),(49904,'femur tibia pelvis',255,7,268,20.1878064,122.106188,124.6619233,1.8,122.091513,124.6678727,-1.224614,3.500705,4.3096459,34.1941702,78.2615308,2.9772618,18.1596197,9.7677955,25.8753065,7.112401,9.1049255,1.2341215,25.5042769),(49905,'femur tibia pelvis',255,7,269,29.7911765,121.4988934,124.868302,1.8,121.9167281,124.6264178,-1.4130685,4.1694418,5.5664479,83.2767573,186.2932356,4.8426926,33.4671662,19.973119,47.6230852,8.164072,11.0472442,1.3352513,30.7647927),(49906,'femur tibia pelvis',255,7,270,32.6814471,121.3470627,124.848743,1.8,121.7194405,124.6024759,1.5336417,4.6530335,5.8116879,120.5460712,255.6981065,5.4393921,43.9972194,25.9069855,61.1743955,9.023448,11.8845829,1.7894653,33.4471805),(49907,'femur tibia pelvis',255,7,271,34.2632379,121.2356903,124.6064068,1.8,121.5728174,124.4380059,1.4088109,4.9478458,6.3454799,147.2040681,311.7878767,5.5620052,49.1354291,29.751143,70.3067264,9.453136,12.9263977,1.8399638,35.7736031),(49908,'femur tibia pelvis',255,7,272,34.498,121.2176373,124.201582,1.8,121.6084975,124.2104027,1.3002196,5.0211993,6.9816175,162.3054106,334.2752091,5.3388962,47.879336,32.324033,69.8571264,9.8381587,13.5879276,1.8925469,37.4923551),(49909,'femur tibia pelvis',255,7,273,32.4053387,121.3266615,123.5022207,1.8,121.659995,123.5727728,1.2838114,4.7540441,7.3487527,146.790609,323.3393429,4.9681491,43.9992143,30.8769975,63.0625713,9.023448,14.283491,1.8449638,37.7440605),(49910,'femur tibia pelvis',255,7,274,31.8304065,121.536996,123.0523502,1.8,121.7725741,123.1135692,1.3093148,4.506495,7.3905872,133.2527159,354.2066895,4.9505381,47.9267314,29.5690364,64.376353,9.023448,14.5397175,1.9018924,37.9957659),(49911,'femur tibia pelvis',255,7,275,30.8396612,121.8131118,122.7901751,1.8,121.8864676,122.7221133,1.3637519,4.4538221,7.4014743,118.8276995,372.4532891,4.9227381,50.3215003,26.6799385,65.3712545,8.59376,15.1125613,1.8295672,38.3517311),(49912,'femur tibia pelvis',255,7,276,29.6679768,122.054645,122.6633413,1.8,122.031392,122.4670598,1.4151748,4.502973,7.9109373,106.2469898,384.2633977,4.8258763,48.5736879,23.5948537,61.7028396,8.4423213,15.5283322,1.8224863,39.4628125),(49913,'femur tibia pelvis',255,7,277,29.5137813,122.2402197,122.5653212,1.8,122.171751,122.2285835,1.4219264,4.3978646,8.2715651,102.2608749,398.1594324,4.8107512,48.1359244,23.2523927,60.3429965,8.164072,15.8461105,1.7894653,39.7145179),(49914,'femur tibia pelvis',255,7,278,29.4414951,122.3311243,122.3792995,1.8,122.2541606,122.0032157,1.4253828,4.383847,8.5278388,99.4896147,402.6484981,4.8038879,47.2157726,22.694591,58.776518,8.164072,16.0544686,1.8417432,39.9662233),(49915,'femur tibia pelvis',255,7,279,29.2377847,122.446643,122.3114643,1.8,122.3455336,121.939316,1.4068424,4.2463114,8.8226084,96.5520257,396.8523996,4.7431441,44.9813003,22.7378578,55.5414023,7.961502,16.3620316,1.8094056,40.3221885),(49916,'femur tibia pelvis',255,7,280,29.440544,122.5352191,122.2703558,1.8,122.4435605,121.8303792,1.3986935,4.2836975,8.8621051,95.2521188,385.393216,4.7628514,43.4877732,22.235958,54.115041,8.0248188,16.1747714,1.8673421,39.9662233),(49917,'femur tibia pelvis',255,7,281,29.4982834,122.632022,122.2790803,1.8,122.5449216,121.8179771,1.3846248,4.2406462,8.5366498,94.1094938,363.9363293,4.7479393,42.6322196,22.1922529,53.6508928,7.9829065,15.898456,1.9010937,39.3585527),(49918,'femur tibia pelvis',255,7,282,29.5266495,122.7116666,122.2099495,1.8,122.6170626,121.7380662,1.3734985,4.0869055,8.7354808,91.946016,357.1680941,4.7320199,40.8870561,22.4977103,51.0434964,7.734384,16.0544686,1.8417432,39.3585527),(49919,'femur tibia pelvis',255,7,283,29.5420915,122.7842513,122.1816849,1.8,122.6995719,121.7395664,1.3516445,4.105129,8.6985873,89.9282908,349.8843136,4.6909712,40.223119,21.906325,50.1130793,7.7562583,15.7643386,1.8753072,38.8551419),(49920,'femur tibia pelvis',255,7,284,29.7832877,122.8596163,122.1246913,1.8,122.8005233,121.7114334,1.3410458,4.1054135,8.6474068,91.0212291,348.8176064,4.7064392,40.3378277,22.1710262,50.4029432,7.7136623,15.7643386,1.8753072,38.8551419),(49921,'femur tibia pelvis',255,7,285,29.8237388,122.950775,122.1057651,1.8,122.8687596,121.6163763,1.3335083,3.9880587,8.6413609,90.0494271,345.7914143,4.6959628,40.0158516,22.5797646,50.0003616,7.6085907,15.7643386,1.8753072,38.4991767),(49922,'femur tibia pelvis',255,7,286,29.8596581,123.0010985,122.0678036,1.8,122.9467674,121.5920118,1.3274922,3.9521515,8.5060857,89.7373346,343.7863165,4.6877772,40.4165123,22.705945,50.1354368,7.4756695,15.3549594,1.8836976,38.2474713),(49923,'femur tibia pelvis',255,7,287,30.0612984,123.071244,122.0689924,1.8,123.0274869,121.6722336,1.3133443,4.0361946,8.3055311,90.416537,336.902321,4.685404,40.5636094,22.4014313,51.2847126,7.5989787,15.240301,1.9460671,37.8915061),(49924,'femur tibia pelvis',255,7,288,30.3431696,123.1163111,122.0193729,1.8,123.0934301,121.6471092,1.3091859,3.9860515,8.2664097,91.1085162,337.3082435,4.7189047,40.8046849,22.8568337,51.6690046,7.4965793,15.240301,1.9460671,37.8915061),(49925,'femur tibia pelvis',255,7,289,30.0009294,123.17409,121.9475121,1.8,123.1312565,121.503685,1.3003861,3.9523665,8.3911069,90.8410501,327.1547465,4.6433602,38.9882706,22.9839643,48.9473746,7.5286423,15.0881073,1.9195673,37.6398007),(49926,'femur tibia pelvis',255,7,290,30.2354118,123.2589745,121.9419535,1.8,123.2324614,121.5342796,1.2875782,4.0393137,8.3884881,92.2450584,322.0710194,4.6457182,38.3944062,22.8368148,48.5052801,7.6826287,15.0881073,1.9195673,38.2474713),(49927,'femur tibia pelvis',255,7,291,30.3018232,123.337005,121.9033259,1.8,123.3146651,121.5009416,1.2835294,3.9575196,8.366963,93.0146098,321.4581058,4.64488,38.4199268,23.5032593,48.6991144,7.595996,15.0881073,1.9195673,37.8915061),(49928,'femur tibia pelvis',255,7,292,30.4960783,123.3962142,121.8377408,1.8,123.372857,121.44683,1.2766059,4.0414475,8.4349674,95.2435648,322.32994,4.655329,38.2135369,23.5666959,49.0670538,7.7070535,15.0881073,1.9195673,37.8915061),(49929,'femur tibia pelvis',255,7,293,31.0452739,123.4562206,121.7763011,1.8,123.4237236,121.3381937,1.2724374,4.121925,8.3890995,97.59801,323.8676349,4.7271201,38.6057689,23.6777743,49.8214398,7.8508529,14.8413514,1.956679,37.0321301),(49930,'femur tibia pelvis',255,7,294,30.7076215,123.5298441,121.7456074,1.8,123.5098502,121.3637776,1.2645871,4.0815104,8.3732173,99.9280628,318.9159011,4.6528703,38.0876178,24.4831089,49.6141486,7.8077906,14.8413514,1.956679,37.3880953),(49931,'femur tibia pelvis',255,7,295,30.7303368,123.591444,121.7099107,1.8,123.5394203,121.3026882,1.2562719,4.157742,8.6247738,101.822419,315.7632441,4.631542,36.6111912,24.4898356,47.5877014,7.8809942,15.0881073,1.9195673,37.9957659),(49932,'femur tibia pelvis',255,7,296,30.9670012,123.6607682,121.6623486,1.8,123.5743096,121.2092789,1.2480249,4.2449702,8.7243226,104.0143111,316.9073997,4.6418844,36.3245851,24.5029542,47.7969721,7.9981775,15.0083566,1.9832068,37.8915061),(49933,'femur tibia pelvis',255,7,297,30.8271286,123.7388455,121.630911,1.8,123.6713679,121.1982747,1.2411235,4.1952094,8.7113656,105.1650491,315.7490094,4.5993902,36.2456388,25.0678903,47.8834333,7.9479806,15.0083566,1.9832068,38.9594017),(49934,'femur tibia pelvis',255,7,298,31.1756351,123.7978148,121.562946,1.8,123.754972,121.1635671,1.2395832,4.2736098,8.9310523,108.1493271,317.2170187,4.6464745,35.518437,25.3063176,46.8280257,7.9594459,15.240301,1.9460671,38.8551419),(49935,'femur tibia pelvis',255,7,299,31.7767514,123.8576608,121.4873965,1.8,123.8215603,121.0172807,1.2367286,4.2318581,8.874534,111.8350811,325.2574163,4.7267339,36.6506474,26.4269448,48.4692237,8.1265722,15.0083566,1.9832068,38.6034365),(49936,'femur tibia pelvis',255,7,300,32.225015,123.9152517,121.4230418,1.8,123.8850873,120.9932753,1.2344684,4.3105719,8.9709551,114.734529,330.6265712,4.7858704,36.8552253,26.6170084,49.2482668,8.2660287,15.185687,2.0091329,38.4991767),(49937,'femur tibia pelvis',255,7,301,32.2264137,123.9726553,121.3619566,1.8,123.9302598,120.8930131,1.2344705,4.3849159,8.932239,117.2968778,334.4288795,4.786085,37.4406551,26.7500862,50.215966,8.4163896,15.185687,2.0091329,38.8551419),(49938,'femur tibia pelvis',255,7,302,32.3153167,124.0222122,121.2858491,1.8,123.9914756,120.8529874,1.2290608,4.4649038,8.871241,120.0948817,338.5241329,4.7810119,38.1597266,26.8975297,51.3440304,8.4320673,15.0083566,1.9832068,39.2111071),(49939,'femur tibia pelvis',255,7,303,32.6723274,124.0816904,121.2180115,1.8,124.0335307,120.7020088,1.2248936,4.5500023,9.0817198,123.5533668,349.9617235,4.8194283,38.5347413,27.1545721,51.395857,8.6147974,15.240301,1.9460671,40.0704831),(49940,'femur tibia pelvis',255,7,304,33.2910117,124.1131876,121.1173987,1.8,124.0427466,120.5453397,1.2253979,4.4674624,9.1439741,126.9487079,363.1177059,4.9124732,39.7111477,28.4162903,53.2260358,8.5891726,15.185687,2.0091329,39.1068473),(49941,'femur tibia pelvis',255,7,305,33.4642299,124.157877,120.9888196,1.8,124.0807618,120.4704611,1.2194155,4.5607196,9.0320221,129.5648482,368.5492029,4.9166209,40.8047276,28.4088608,54.7834787,8.5774903,15.185687,2.0091329,39.2111071),(49942,'femur tibia pelvis',255,7,306,33.4847632,124.1889924,120.9257538,1.8,124.0975513,120.404063,1.2118505,4.6214762,9.1266772,131.8647966,371.6048606,4.8921079,40.7163367,28.5330467,55.0205389,8.7047405,15.3729852,2.0344439,39.4628125),(49943,'femur tibia pelvis',255,7,307,33.4772101,124.2324156,120.8735643,1.8,124.1674263,120.3904575,1.1989701,4.6970309,9.0845606,135.537198,373.9942462,4.8430386,41.1681163,28.8559304,55.9127818,8.7491589,15.3729852,2.0344439,39.8187777),(49944,'femur tibia pelvis',255,7,308,33.627601,124.2639888,120.8594534,1.8,124.2023288,120.3002668,1.1838486,4.7500479,9.3072675,139.4869495,374.8442858,4.8064867,40.2743647,29.3653774,54.6621181,8.8652816,15.4029813,1.9720251,39.8187777),(49945,'femur tibia pelvis',255,7,309,33.8639297,124.2898651,120.7988737,1.8,124.2066177,120.2434435,1.1755409,4.8069428,9.2495215,142.5104691,378.8274007,4.807217,40.9564321,29.6467993,55.7184046,8.9881418,15.3729852,2.0344439,40.1747429),(49946,'femur tibia pelvis',255,7,310,34.7215723,124.3136502,120.7429608,1.8,124.2281856,120.1401054,1.1679746,4.8596266,9.3649055,145.5868735,390.3028399,4.8976144,41.6771787,29.9584484,56.8717514,9.0408224,15.5698916,2.0591303,40.4264483),(49947,'femur tibia pelvis',255,7,311,35.0332643,124.3351901,120.6818128,1.8,124.2294114,120.1088136,1.1601214,4.9130459,9.3089638,148.1777372,397.0523668,4.9082584,42.6526919,30.1600555,58.1858601,9.1326837,15.5698916,2.0591303,40.4264483),(49948,'femur tibia pelvis',255,7,312,35.1425887,124.3486266,120.6151396,1.8,124.2246595,120.0786623,1.1570967,4.9557807,9.2500315,150.4946648,404.5123893,4.9105694,43.7309201,30.3674989,59.6096345,9.1552137,15.5698916,2.0591303,40.6781537),(49949,'femur tibia pelvis',255,7,313,35.3479776,124.3772002,120.570273,1.8,124.2298716,120.0243683,1.1487329,5.0104912,9.3876278,153.1220012,412.3236151,4.9027178,43.922024,30.5602774,60.0653592,9.1552137,15.6231626,2.1206495,41.2858243),(49950,'femur tibia pelvis',255,7,314,35.6567043,124.3930319,120.5114472,1.8,124.3058307,119.9777203,1.140894,5.0589332,9.3349619,156.998012,419.8858515,4.9104792,44.9799212,31.0338177,61.6066741,9.3322161,15.6231626,2.1206495,41.2858243),(49951,'femur tibia pelvis',255,7,315,36.4540338,124.4110205,120.4673832,1.8,124.3180979,119.9308133,1.1356602,5.1002582,9.3259939,160.1076114,429.9849956,4.9960813,46.106077,31.3920601,62.2351758,9.3322161,15.6231626,2.1206495,41.6417895),(49952,'femur tibia pelvis',255,7,316,36.8394666,124.3999988,120.4071646,1.8,124.2935729,119.8345068,1.1288538,5.1244352,9.4387611,163.5492841,440.8166661,5.0167742,46.7028099,31.9155728,63.3659508,9.4585579,15.7760463,2.0831858,42.7096851),(49953,'femur tibia pelvis',255,7,317,37.3825079,124.3935625,120.3440791,1.8,124.2856507,119.7856843,1.1259446,5.1675144,9.3750194,166.4465823,452.7124711,5.0766767,48.2892305,32.2101825,65.3430247,9.4585579,15.7760463,2.0831858,42.3537199),(49954,'femur tibia pelvis',255,7,318,37.4510454,124.3805544,120.2665584,1.8,124.2185039,119.668108,1.123286,5.1902652,9.4817466,168.8879426,463.5134071,5.0730644,48.8848129,32.5393665,66.3345719,9.4585579,15.8519352,2.1437625,42.2494601),(49955,'femur tibia pelvis',255,7,319,37.7831588,124.3618007,120.1995866,1.8,124.2355521,119.6407837,1.120665,5.2035999,9.4106535,172.0444315,475.0770768,5.1051475,50.4828995,33.0625788,68.3761887,9.542961,15.8519352,2.1437625,42.2494601),(49956,'femur tibia pelvis',255,7,320,38.5668368,124.3543917,120.1529995,1.8,124.2180265,119.6251392,1.1183686,5.2183776,9.3631828,175.3474448,489.3230528,5.19945,52.2603333,33.601908,70.5761258,9.6349033,15.8519352,2.1437625,42.2494601),(49957,'femur tibia pelvis',255,7,321,38.966145,124.3166951,120.06333,1.8,124.1956682,119.5651729,1.1147154,5.2258472,9.451563,178.3977587,500.9586773,5.2345738,53.002734,34.1375765,71.7054895,9.6349033,16.0889326,2.1662062,42.5011655),(49958,'femur tibia pelvis',255,7,322,39.722352,124.2975333,119.9866819,1.8,124.1986505,119.5191286,1.1129148,5.2435876,9.3786844,183.5502787,516.0883734,5.3267196,55.0278005,35.0047132,73.5147908,9.6349033,16.0889326,2.1662062,43.2130959),(49959,'femur tibia pelvis',255,7,323,41.3563432,124.2768348,119.9021252,1.8,124.1656442,119.4917738,1.1153623,5.4495754,9.4865698,189.5203782,536.2456628,5.5591891,56.526824,34.7770905,75.9105972,9.7508523,16.2146739,2.1293956,43.2130959),(49960,'femur tibia pelvis',255,7,324,42.3036161,124.25401,119.8225964,1.8,124.131755,119.3811485,1.116246,5.4629788,9.4061423,195.8066035,553.9629601,5.6914425,58.8937465,35.8424605,79.1048837,9.8668013,16.0889326,2.1662062,43.2130959),(49961,'femur tibia pelvis',255,7,325,42.6351141,124.2239711,119.7532553,1.8,124.0938944,119.3143649,1.117118,5.4653002,9.5199851,201.5839911,571.0969385,5.7409264,59.9892681,36.8843401,80.9009476,9.8668013,16.3337968,2.1879877,43.4648013),(49962,'femur tibia pelvis',255,7,326,43.9493007,124.1885907,119.701813,1.8,124.0359589,119.2881479,1.1206621,5.4641542,9.4609372,208.4396147,591.0925669,5.9382816,62.4771685,38.1467297,84.2485375,9.8668013,16.3337968,2.1879877,43.8207665),(49963,'femur tibia pelvis',255,7,327,45.2378067,124.1503946,119.6351845,1.8,124.0381976,119.2609092,1.1247177,5.4566764,9.3872899,214.7195485,609.8621088,6.1362605,64.9667918,39.3498778,87.5889773,9.9064111,16.3337968,2.1879877,43.8207665),(49964,'femur tibia pelvis',255,7,328,46.1929684,124.0913777,119.5541844,1.8,123.978562,119.2445049,1.1270821,5.6213597,9.4749177,222.4471866,631.495158,6.2799655,66.6491446,39.5717758,90.0753368,10.0275611,16.6860637,2.1730837,44.0724719),(49965,'femur tibia pelvis',255,7,329,47.5424029,124.0439542,119.5113156,1.8,123.9520789,119.2061473,1.1330782,5.5903471,9.417736,230.772649,654.5033008,6.5000842,69.4968833,41.280558,93.9570852,9.9452664,16.6860637,2.1730837,44.0724719),(49966,'femur tibia pelvis',255,7,330,48.4649464,123.9928631,119.4822958,1.8,123.8972606,119.1303252,1.1386247,5.5498379,9.5816459,239.4768812,682.7799844,6.6604563,71.2591541,43.1502478,95.8847739,10.1117059,16.8073383,2.1375255,45.0361077),(49967,'femur tibia pelvis',255,7,331,49.2308885,123.9373547,119.44814,1.8,123.840099,119.0899506,1.1404879,5.6906492,9.7082416,249.5090447,710.1949014,6.7773284,73.1538144,43.8454445,98.7400298,10.248402,17.0418833,2.1587989,45.5395185),(49968,'femur tibia pelvis',255,7,332,50.1553902,123.8786159,119.4197392,1.8,123.7664721,119.057951,1.1451447,5.6776373,9.6601938,261.5992574,730.4179426,6.9339974,75.6111069,46.0753732,102.572833,10.1510729,17.0418833,2.1587989,45.5395185),(49969,'femur tibia pelvis',255,7,333,51.4533516,123.8176047,119.3943055,1.8,123.7183153,118.9917473,1.1499605,5.8041262,9.7897162,274.9926553,753.9479112,7.1443715,77.0142768,47.3788205,105.1014756,10.3207305,17.4010378,2.1451012,46.1471891),(49970,'femur tibia pelvis',255,7,334,52.6607315,123.7649923,119.3950345,1.8,123.6622156,118.9746347,1.1515079,5.7538596,9.7690609,288.959251,778.0045339,7.322132,79.6396439,50.2200734,109.2124682,10.3196708,17.533166,2.1995926,46.6505999),(49971,'femur tibia pelvis',255,7,335,55.2604588,123.7168167,119.4105946,1.8,123.5516425,118.9605976,1.1566817,5.9173555,9.9847987,308.0238974,815.9926904,7.7188796,81.7234998,52.0543166,112.320087,10.4348054,17.7892908,2.2191283,47.6142357),(49972,'femur tibia pelvis',255,7,336,55.9589264,123.6609626,119.3812185,1.8,123.5083958,118.9619692,1.158234,6.0491109,10.1088071,328.0334101,848.7044285,7.8270931,83.9569315,54.2283673,116.3558255,10.6496494,17.99567,2.1521765,47.8659411),(49973,'femur tibia pelvis',255,7,337,57.040421,123.5826288,119.3246666,1.8,123.4275011,118.8630084,1.1680871,6.1556534,10.1969484,348.1926681,884.5621204,8.0465474,86.7477293,56.564697,120.8823234,10.8431933,18.2351811,2.1718701,48.1176465),(49974,'femur tibia pelvis',255,7,338,58.6704958,123.5247938,119.324952,1.8,123.3379645,118.9083116,1.1768575,6.3186578,10.1733527,376.2101458,932.2773701,8.3378173,91.6391478,59.5395666,128.5988576,11.1000327,18.3562794,2.1393209,49.0812823),(49975,'femur tibia pelvis',255,7,339,60.9189752,123.4648584,119.3291449,1.8,123.2919527,118.8696579,1.1827845,6.4167317,10.3158806,408.3793441,998.1444155,8.6997597,96.7580426,63.6428894,136.1293748,11.3141183,18.5911454,2.1587989,49.5846931),(49976,'femur tibia pelvis',255,7,340,64.0912848,123.3762641,119.3389737,1.8,123.1702012,118.8733212,1.2058603,6.4431324,10.3719691,448.6113281,1061.5738616,9.3213282,102.3502728,69.6262781,145.5689065,11.5125262,18.7345939,2.2097103,51.1559995),(49977,'femur tibia pelvis',255,7,341,66.2571834,123.2253101,119.4122375,1.8,123.0364362,118.8572881,1.2281019,6.4847862,10.5370293,486.4544087,1099.532987,9.7959752,104.349429,75.0147179,150.474738,11.7236391,18.7198054,2.1269626,51.1559995),(49978,'femur tibia pelvis',255,7,342,67.2413267,123.074146,119.5339887,1.8,122.9115384,118.9469851,1.2394537,6.420762,10.5995153,521.7048682,1106.1616591,10.0208797,104.3596451,81.2527963,153.5565372,11.8915619,18.7198054,2.1269626,52.1196353),(49979,'femur tibia pelvis',255,7,343,68.016948,122.9352512,119.6661331,1.8,122.7524263,118.9993503,1.2540919,6.4884986,10.6780216,553.9996614,1096.3179203,10.2366329,102.6705101,85.3817952,154.5343788,12.0786327,18.8328873,2.177784,53.3349765),(49980,'femur tibia pelvis',255,7,344,70.968315,122.7355687,119.6911052,1.8,122.5778765,118.9621042,1.2954235,6.509641,11.0453344,592.6915947,1162.0491495,10.9535723,105.2072405,91.0482762,158.8124398,12.2134898,19.0860812,2.1150768,53.8383873),(49981,'femur tibia pelvis',255,7,345,72.8107723,122.5456984,119.7483854,1.8,122.4182319,118.9940048,1.3410868,6.4327905,10.9352914,623.5480222,1203.2672681,11.5059845,110.035227,96.9327419,167.0348429,12.1114542,18.9501664,2.146221,54.4460579),(49982,'femur tibia pelvis',255,7,346,73.6229842,122.3930268,119.7952801,1.8,122.2530896,119.1201217,1.383421,6.4201055,11.0156584,657.1571996,1239.8152234,11.8447047,112.5502608,102.3592528,171.6304805,12.5598292,18.867169,2.0955921,54.8020231),(49983,'femur tibia pelvis',255,7,347,74.4503584,122.1864157,119.9620306,1.8,122.0898248,119.2933115,1.4246773,6.6470595,11.0413461,695.0808465,1218.8538344,12.1453444,110.3899673,104.5696745,172.9918856,12.9476593,18.6555863,2.0756577,55.4096937),(49984,'femur tibia pelvis',255,7,348,75.9318885,122.0023043,120.1097438,1.8,121.9061652,119.5149871,1.4686803,6.968284,10.7004452,720.227241,1187.8716623,12.5238071,111.0114239,103.3579064,177.4929038,12.980287,18.2958305,1.4056476,54.8020231),(49985,'femur tibia pelvis',255,7,349,75.6767051,121.8028268,120.2934359,1.8,121.7234588,119.744648,1.5493863,7.0555394,10.3228513,744.4912546,1161.8467216,12.6070035,112.5509501,105.5186872,183.2908459,13.3655223,18.4815797,1.2637506,53.8383873),(49986,'femur tibia pelvis',255,7,350,76.1281577,121.5427167,120.4660922,1.8,121.4906082,119.9670086,-1.4889036,7.5724957,10.5411615,760.5729488,1172.9167341,12.603125,111.2701602,100.4388752,183.2270674,13.532196,19.0230987,1.2490458,53.8383873),(49987,'femur tibia pelvis',255,7,351,78.5131527,121.2839518,120.5546573,1.8,121.2458416,120.1557606,-1.3987036,7.6337224,10.6002004,788.0513102,1255.8190591,12.7017964,118.4712562,103.232901,192.4554177,13.7054603,19.3025109,1.2772073,54.0900927),(49988,'femur tibia pelvis',255,7,352,82.3533258,121.0242899,120.6900208,1.8,120.9622074,120.4049558,-1.2909937,7.7133867,10.6709551,830.4380277,1365.4931583,12.678739,127.9635375,107.6619208,203.590545,13.6166235,19.8402356,1.2627435,55.0537285),(49989,'femur tibia pelvis',255,7,353,87.2269333,120.7035885,120.8343663,1.8,120.6900182,120.5731217,-1.1761855,7.9000326,10.5120592,877.6676467,1518.3062941,12.3891177,144.4347169,111.0967119,219.5060013,13.5955206,20.2501155,1.2691773,56.0173642),(49990,'femur tibia pelvis',255,7,354,89.3458907,120.5125187,120.8950526,1.8,120.5009536,120.7709392,-1.1084567,8.0157057,10.2369052,911.2008758,1592.248496,11.9283518,155.540025,113.6769376,228.6415258,13.7140855,20.3818914,1.2490458,55.4096937),(49991,'femur tibia pelvis',255,7,355,88.918608,120.3850507,120.9534687,1.8,120.4182501,120.8510442,-1.0489628,7.8779633,9.7294904,916.1552672,1558.8242403,11.1374583,160.216432,116.2934166,233.6264139,13.6025603,19.9747158,1.2422432,54.5503177),(49992,'femur tibia pelvis',255,7,356,87.7305865,120.2631476,121.056744,1.8,120.3147108,120.9670082,-0.9942022,7.7418505,9.3866272,906.2291028,1514.1379634,10.2759953,161.3079903,117.0558768,235.3362458,13.4709785,19.5685029,1.2351578,54.2986122),(49993,'femur tibia pelvis',255,7,357,86.048591,120.0848457,121.3319115,1.8,120.140978,121.3047608,-0.862639,7.4799984,8.9589366,871.4675859,1410.2442105,8.2740594,157.4120093,116.506387,240.5398846,13.3687531,18.8475871,1.1479424,51.0085539),(49994,'femur tibia pelvis',255,7,358,79.7875595,119.6968808,121.8181928,1.8,119.6828948,121.9734044,-0.6232157,7.0310433,8.3690904,820.871615,1182.7877685,4.5298926,141.328114,116.7496167,231.4468916,13.2643556,16.7357822,1.0612041,48.2219063),(49995,'femur tibia pelvis',255,7,359,76.8084419,119.3908116,122.1028183,1.8,119.3561797,122.3076628,-0.5074579,6.6466614,8.0916046,810.2272136,1137.8909224,3.0231068,140.6261157,121.8998781,226.3507345,13.0287571,16.1519256,1.0714496,47.7184955),(49996,'femur tibia pelvis',255,7,360,74.1766558,119.1051169,122.355092,1.8,119.0116897,122.662552,-0.4363549,6.5324189,8.1130906,819.7765587,1147.6354804,2.2082819,141.4547835,125.4935686,225.4274024,13.183521,15.9910916,1.0349851,47.9702009),(49997,'femur tibia pelvis',255,7,361,75.3428572,118.7466649,122.6683289,1.8,118.5719416,122.9750885,-0.4513215,6.8145769,8.2833847,863.9504741,1237.1533315,2.388761,149.3536008,126.7797678,234.2296788,13.4487732,16.3337968,1.1071487,49.2898019),(49998,'femur tibia pelvis',255,7,362,78.8578546,118.3205945,123.0413595,1.8,118.1354476,123.397129,-0.4923116,7.0775724,8.793005,937.2440011,1420.3970081,2.9362911,161.5371549,132.424503,254.6188704,13.8433839,16.998492,0.3617292,50.8611082),(49999,'femur tibia pelvis',255,7,363,87.6845404,117.6716337,123.6406431,1.8,117.7117182,123.7152258,-0.6122147,7.0869176,8.9526713,1058.7314616,1795.7353468,4.8264294,200.5809545,149.3923771,313.5980608,14.0363487,17.8048522,0.3446473,52.3281548),(50000,'femur tibia pelvis',255,7,364,97.2013014,117.3124702,123.9484166,1.8,117.4708294,123.8689158,-0.5514582,7.4361161,8.8260064,1176.9273921,1925.6171912,4.4469996,218.175368,158.2717887,327.7448556,14.4798358,18.3562794,0.2847304,53.2917906),(50001,'femur tibia pelvis',255,7,365,94.0239564,117.4625783,123.5776995,1.8,117.4210057,123.6962025,-0.1286489,8.0009513,9.2515689,1125.5113073,1690.5224932,0.2579302,182.7281964,140.672185,301.100406,14.6815621,18.5513782,0.2337432,52.7883798),(50002,'femur tibia pelvis',255,7,366,89.2340486,117.6192828,123.2734554,1.8,117.5453533,123.3094137,0.1667326,7.528589,9.304991,939.9110903,1716.6135861,0.4096305,184.4830997,124.8455836,277.7203692,14.8974316,18.8769524,0.2063239,54.402872),(50003,'femur tibia pelvis',255,7,367,88.3789797,118.0126602,123.2026556,1.8,118.3104067,123.252759,0.2725902,7.1447862,18.8307252,820.3560281,2266.2884602,1.0676641,120.3505673,114.8188351,163.9026722,14.2098247,19.1440351,0.1577687,54.863097),(50004,'femur tibia pelvis',255,7,368,90.2722946,118.4911074,123.2247713,1.8,118.7919939,123.2447906,0.2980401,6.9535894,18.4810005,742.6429158,3166.3538129,1.2973444,171.3302166,106.7999375,211.5039745,13.8047829,19.5685029,0.1543188,55.6182132),(50005,'femur tibia pelvis',255,7,369,90.8371,118.9843023,123.2678476,1.8,119.3821677,123.2946836,0.3075379,6.8129604,18.4048616,673.6121401,4162.5561757,1.3873117,226.1661218,98.8721636,262.7097084,13.3942144,20.3092932,0.1059844,56.8335544),(50006,'femur tibia pelvis',255,7,370,94.5871393,119.5501888,123.4255105,1.8,119.8294004,123.4114088,0.3138003,6.906966,17.9478334,654.2212369,5241.031679,1.502053,292.014728,94.7190466,328.4640205,13.342888,21.1640424,3.0399038,59.6633878),(50007,'femur tibia pelvis',255,7,371,98.4758202,120.2752321,123.6372193,1.8,120.4307437,123.6143045,0.3168166,6.8656177,17.1926483,631.637751,6189.5888148,1.592997,360.0136932,92.0001348,396.7468863,13.2755455,30.8718194,2.9878851,81.0182304),(50008,'femur tibia pelvis',255,7,372,100.9552012,120.7815711,123.7796561,1.8,120.7219041,123.7175443,0.3209216,6.8152198,16.666709,613.017162,6711.1573692,1.6742273,402.6684204,89.9482601,439.4343696,13.137619,31.2345051,3.0035866,80.3494858),(50009,'femur tibia pelvis',255,7,373,100.6148633,120.6203707,123.7980354,1.8,120.6778352,123.746583,0.3219087,6.8769053,16.8136703,618.0904244,6862.1663643,1.6785058,408.1301846,89.8791532,444.8524055,13.2168407,31.6047135,3.018924,81.7122726),(50010,'femur tibia pelvis',255,7,374,98.8117941,120.3350036,123.8101177,1.8,120.5266883,123.8245437,0.3223446,6.8397269,16.944292,624.865538,6751.1327969,1.6527376,398.4310935,91.3582578,434.8949971,13.390549,31.6047135,3.018924,81.7122726),(50011,'femur tibia pelvis',255,7,375,92.3785516,119.8815168,123.7331019,1.8,120.1917269,123.8077603,0.3251687,7.0249102,17.1219198,623.3174283,6286.9283269,1.5713624,367.1859462,88.729594,401.6768053,13.757788,31.5111044,3.0459945,82.5716486),(50012,'femur tibia pelvis',255,7,376,85.3698174,119.3784115,123.6954855,1.8,119.6503293,123.7222978,0.3317566,7.1046037,16.7859323,617.9060166,5595.5254955,1.5093855,333.3461264,86.9726223,368.4145618,13.9073308,30.7008994,3.0293898,82.1114236),(50013,'femur tibia pelvis',255,7,377,79.8141353,118.5807279,123.62547,1.8,118.7207788,123.6328731,0.349252,7.0427146,15.472153,613.5035765,4813.5702617,1.5576723,311.1118568,87.111804,345.3197697,13.9697701,29.2692919,3.0828368,79.5332956),(50014,'femur tibia pelvis',255,7,378,78.8909205,118.0604413,123.6623811,1.8,118.0949567,123.6671469,0.3501612,7.2942608,14.4786414,641.3959808,4571.3569557,1.5473502,315.7310713,87.9315938,356.6700185,14.4237543,27.9825547,3.0801317,79.1341446),(50015,'femur tibia pelvis',255,7,379,79.2653873,117.7503997,123.7737638,1.8,117.6696987,123.7463032,0.3454439,7.5825454,14.0465869,679.9543648,4528.8086008,1.5147573,322.413453,89.6736297,363.6817734,14.6637032,27.9594518,0.0461211,80.6011912),(50016,'femur tibia pelvis',255,7,380,81.3211223,117.3915668,123.9110313,1.8,117.283411,123.9109796,0.3357785,7.7754266,14.1024178,728.0894629,4595.4004485,1.4715478,325.8590477,93.6398094,372.3042418,14.8082957,28.0122304,0.0767719,81.2088618),(50017,'femur tibia pelvis',255,7,381,83.9271159,117.0254975,124.0824929,1.8,116.9276844,124.0914762,0.3134217,7.9359344,14.3145759,789.2857424,4728.2553941,1.3296631,330.3105471,99.4571909,378.6233827,15.1267448,28.4114437,0.060532,83.283579),(50018,'femur tibia pelvis',255,7,382,89.326868,116.7077096,124.2939379,1.8,116.6182137,124.2688865,0.291433,7.9502079,14.6147811,869.4320608,4910.3898639,1.2290742,335.9879184,109.3596641,388.8551445,15.5136741,28.4763545,0.0906599,84.8548854),(50019,'femur tibia pelvis',255,7,383,92.3021812,116.4947275,124.5087987,1.8,116.4037392,124.4213957,0.2668887,8.2150504,14.9389559,929.5926498,5021.6350803,1.0700027,336.1436449,113.1572672,394.1257072,15.4546087,28.6218657,0.1355277,86.4693776),(50020,'femur tibia pelvis',255,7,384,94.4212504,116.1669586,124.6649741,1.8,116.1185481,124.6141539,0.2351754,8.6108816,15.3836242,992.0911782,5165.0053835,0.8544387,335.7469805,115.2136588,398.2623665,15.6327158,28.9935938,0.1188403,86.4693776),(50021,'femur tibia pelvis',255,7,385,96.2167105,115.8334465,124.8082849,1.8,115.8515037,124.7209358,0.1951563,8.9207612,16.1535949,1039.0330372,5270.0537626,0.6030371,326.2464981,116.4735845,389.4851407,15.468768,29.1079925,0.14816,86.260858),(50022,'femur tibia pelvis',255,7,386,100.7872982,115.6143836,125.0573309,1.8,115.6481908,124.9972679,0.1598942,9.2912586,16.7868844,1122.2100476,5505.0945003,0.4258098,327.9402162,120.7812742,394.1132514,15.8030246,29.5330411,0.1460123,88.838986),(50023,'femur tibia pelvis',255,7,387,106.572595,115.3675928,125.3798042,1.8,115.4687445,125.2577065,0.1195114,9.7667015,17.4461559,1272.2969616,5814.8468514,0.2524901,333.3024699,130.2688487,405.8964357,16.3043844,29.5986112,0.1603754,87.7710904),(50024,'femur tibia pelvis',255,7,388,105.7091337,115.2680063,125.5472096,1.8,115.4730987,125.3676096,0.0999982,10.0274978,17.9665464,1355.0606156,5880.9503059,0.1755893,327.3278112,135.1344713,402.5352164,16.8081941,29.5986112,0.1603754,88.7347262),(50025,'femur tibia pelvis',255,7,389,99.124717,115.1704364,125.401827,1.8,115.536953,125.286454,0.1192806,9.7619161,18.4927232,1276.2785593,5535.3428887,0.2339426,299.3254608,130.740579,367.9516963,16.9759131,29.2472054,0.1772254,88.838986),(50026,'femur tibia pelvis',255,7,390,87.9658521,115.3632169,124.9253219,1.8,115.5248867,125.01186,0.1838024,8.8597817,18.7194126,994.1268097,5097.2322782,0.4897441,272.2965938,112.2066935,324.197664,15.4956002,19.163314,2.3086114,63.7517482),(50027,'femur tibia pelvis',255,7,391,80.3408394,115.4721965,124.4060395,1.8,116.0611872,124.4219323,0.2336046,7.9306466,19.3665143,738.9254737,4937.5049324,0.7175193,254.950626,93.1734205,290.4348372,12.2756511,18.8769524,2.2917677,55.9131045),(50028,'femur tibia pelvis',255,7,392,77.0092989,115.3053611,124.1951659,1.8,116.0983053,124.3042154,0.2400045,7.6207509,19.9788224,691.2606572,4947.0127056,0.7252305,247.6128279,90.707683,279.6827788,11.4077914,18.8769524,2.2917677,52.8747515),(50029,'femur tibia pelvis',255,7,393,74.421209,115.1300812,124.0944908,1.8,116.0633725,124.2268567,0.2359944,7.4909293,20.6012002,664.8312645,4981.8603772,0.678065,241.8237931,88.7515076,271.8443064,10.8019941,18.3210418,2.2565258,51.1559995),(50030,'femur tibia pelvis',255,7,394,72.6747602,115.0156462,124.0464462,1.8,115.9010138,124.1291728,0.2262032,7.4423418,21.1672606,641.7101222,5105.9952214,0.6092701,241.2213518,86.2242213,269.6184557,10.306481,18.3210418,2.2565258,49.0812823),(50031,'femur tibia pelvis',255,7,395,71.4185368,114.8637458,124.0252128,1.8,115.8635133,124.0854642,0.2137427,7.4530531,21.7699992,626.1157674,5284.9780586,0.5355729,242.7642742,84.0079579,269.9316821,9.7656581,18.0520106,2.2381025,47.2582705),(50032,'femur tibia pelvis',255,7,396,69.9271596,114.6480305,124.0111121,1.8,115.7269321,124.1048789,0.2039206,7.1351943,22.0933317,612.979921,5337.6311848,0.4779567,241.5946701,85.9093524,268.4854331,9.4157653,17.9905393,2.2716507,46.3988945),(50033,'femur tibia pelvis',255,7,397,67.6652525,114.351518,124.0118257,1.8,115.3447961,124.103925,0.1953711,7.170475,22.3983369,595.3187034,5225.8502156,0.4250132,233.3142074,83.0236077,259.2048097,8.9969543,17.533166,2.1995926,44.6801425),(50034,'femur tibia pelvis',255,7,398,65.8257045,113.9804936,123.9794575,1.8,114.8314808,124.0293357,0.1905008,7.0810519,22.7764664,583.9221376,5089.4242996,0.3933488,223.4510045,82.4626261,248.5040202,8.6204936,17.4487192,2.2339993,43.1088361),(50035,'femur tibia pelvis',255,7,399,63.8954073,113.5591964,123.9636773,1.8,114.51508,124.0091045,0.1855656,6.8376972,23.2008762,573.318086,4906.8749643,0.3625122,211.4952437,83.8466617,235.7060937,8.4069333,17.4487192,2.2339993,42.8571307),(50036,'femur tibia pelvis',255,7,400,62.7360316,113.042187,123.9350003,1.8,114.0470346,123.9882843,0.1836961,6.8378804,23.6387232,565.9242837,4675.3501734,0.3488791,197.7835321,82.7631158,220.967666,8.2693528,17.18752,2.2142974,42.6054253),(50037,'femur tibia pelvis',255,7,401,61.0602465,112.4419998,123.8774816,1.8,113.553172,123.9147696,0.1829805,6.7388446,24.2407516,554.088956,4366.999647,0.3369493,180.1511654,82.2231395,202.3259925,8.070656,17.0581265,2.284887,41.7460493),(50038,'femur tibia pelvis',255,7,402,59.1659804,111.9471823,123.8854637,1.8,113.0571628,123.9353005,0.1828948,6.4929003,24.7260353,540.6959176,4059.6571922,0.3261937,164.1855294,83.2749456,185.3924458,7.8412632,16.7798528,2.2655346,41.5986037),(50039,'femur tibia pelvis',255,7,403,57.2591258,111.5366618,123.9263339,1.8,112.6675418,123.9885052,0.180894,6.5412525,25.1266349,526.5278107,3794.9610244,0.3088869,151.033397,80.4934235,171.3600299,7.772473,16.7357822,2.301703,40.8866733),(50040,'femur tibia pelvis',255,7,404,55.7648952,111.0114053,123.9586997,1.8,112.1559201,123.988678,0.1817805,6.5075238,25.6354666,510.8947429,3468.7902453,0.3037494,135.3121558,78.5083177,154.6188134,7.6655884,16.4520572,2.2822555,40.3832625),(50041,'femur tibia pelvis',255,7,405,54.6268361,110.561229,123.9861404,1.8,111.6135643,124.0079568,0.1795834,6.2824171,26.0784995,496.651199,3268.7062586,0.2904781,125.3410405,79.0541589,143.80093,7.4668916,16.1747714,2.2621333,39.5238865),(50042,'femur tibia pelvis',255,7,406,53.6278104,110.1603079,124.0210982,1.8,111.1845136,124.0447631,0.1761975,6.329377,26.3995871,485.5909631,3123.8230943,0.2746245,118.3284829,76.7201834,135.9634169,7.5138932,15.9042615,2.2413179,39.2721811),(50043,'femur tibia pelvis',255,7,407,52.4202066,109.6463896,124.0769076,1.8,110.7906161,124.100611,0.1842655,6.2786437,26.8711844,466.4157223,2812.1184722,0.2933019,104.6518243,74.2860637,121.1768003,7.4989231,15.8461105,2.2794226,38.9162159),(50044,'femur tibia pelvis',255,7,408,51.6299267,109.1732001,124.1293699,1.8,110.3878952,124.1492648,0.1890175,6.3775355,27.310792,447.5306839,2605.5820716,0.3037918,95.404852,70.1729819,110.923446,7.2756869,15.5698916,2.2584676,38.4128051),(50045,'femur tibia pelvis',255,7,409,51.0932636,108.9001842,124.1884482,1.8,110.0417107,124.2058212,0.1734095,6.0805021,27.619622,433.5197551,2667.6954096,0.2535132,96.5869632,71.296703,111.5815447,7.3776789,15.3007547,2.2367656,38.1610997),(50046,'femur tibia pelvis',255,7,410,50.799867,108.5674857,124.2422606,1.8,109.8994334,124.2857349,0.1635023,5.903094,27.9684993,420.8841575,2663.3485196,0.2243291,95.2267224,71.2989087,109.6728472,7.3776789,14.9652379,2.2545056,37.5534291),(50047,'femur tibia pelvis',255,7,411,50.4861608,108.2415186,124.309017,1.8,109.6934555,124.3556922,0.155965,6.2368629,28.3014708,409.1293386,2630.3773055,0.2030257,92.9413643,65.5985787,106.8017848,7.499679,14.9158068,2.2950463,37.1974639),(50048,'femur tibia pelvis',255,7,412,50.4053145,107.9149888,124.3889367,1.8,109.3792762,124.3985509,0.1465722,6.1025293,28.6382641,397.9736389,2620.386331,0.179191,91.4994821,65.2145392,104.8390608,7.499679,14.6975909,2.2318395,37.3017237),(50049,'femur tibia pelvis',255,7,413,50.1854907,107.6672781,124.4723952,1.8,109.2442913,124.4904498,0.1310821,6.2071028,28.9113562,385.0276825,2705.8478378,0.1428976,93.5911764,62.0301762,106.3027753,7.5958825,14.4377726,2.2083451,37.0500183),(50050,'femur tibia pelvis',255,7,414,49.3480458,107.4087204,124.5600177,1.8,109.1476965,124.5713255,0.1164994,5.9093063,29.1895071,371.1693709,2784.950003,0.1111221,95.4092851,62.8109886,107.5660393,7.8351403,14.3093201,2.4199378,36.5897933),(50051,'femur tibia pelvis',255,7,415,49.7128893,107.2109519,124.6615112,1.8,109.1238018,124.6900335,0.0990183,5.9541528,29.4079684,361.1162166,2959.5122869,0.0809709,100.6364073,60.6494703,112.2271187,7.8804744,14.0948144,2.485897,36.3380879),(50052,'femur tibia pelvis',255,7,416,50.1009518,107.0411203,124.7804298,1.8,108.8412467,124.7916056,0.0823808,5.8079644,29.5912904,346.7112822,3132.2415591,0.0565411,105.8501175,59.6958344,116.8615903,8.0778459,13.8370211,2.5105133,36.6940531),(50053,'femur tibia pelvis',255,7,417,49.4666577,106.941314,124.8694893,1.8,108.7619147,124.8714009,0.0734574,5.5500724,29.6949037,324.2680999,3190.4426529,0.044407,107.4407476,58.4259229,117.6326381,8.1477499,13.943359,2.5535901,36.5897933),(50054,'femur tibia pelvis',255,7,418,48.1290844,106.7466809,124.9815049,1.8,108.5335842,125.01628,0.065038,5.2811798,29.8905032,307.9476811,3280.618979,0.0338827,109.7545585,58.3103956,119.4623252,8.2554522,13.8570216,2.6224465,35.9821227),(50055,'femur tibia pelvis',255,7,419,48.7217524,106.4562249,125.0713627,1.8,108.437929,125.0533644,0.0551065,5.3787645,30.1606351,300.5600516,3345.5000045,0.0246342,110.9227305,55.8790134,120.0020288,8.339352,13.943359,2.5535901,36.8414987),(50056,'femur tibia pelvis',255,7,420,48.9645152,106.1950509,125.1536978,1.8,108.1221094,125.1702711,0.0496776,5.0904624,30.4238247,290.9598077,3413.5119099,0.020123,112.198645,57.1578351,121.0397461,8.4783075,14.0751518,2.5959376,37.0932041),(50057,'femur tibia pelvis',255,7,421,48.3503628,105.9011836,125.2548406,1.8,108.0061456,125.2413175,0.0485462,5.1682906,30.7137724,281.0172462,3379.3984701,0.0189766,110.0287658,54.3733449,118.5894125,8.4721139,14.2316921,2.6374267,37.3449095),(50058,'femur tibia pelvis',255,7,422,48.7163253,105.8652833,125.3424738,1.8,107.9341049,125.3088632,0.0330948,5.2947745,30.7628317,277.2091304,3712.6739418,0.0088896,120.6870022,52.3552292,128.9008994,8.520289,14.4441652,2.7445132,37.7008747),(50059,'femur tibia pelvis',255,7,423,49.5436435,105.5979938,125.4482233,1.8,107.5919865,125.3736721,0.0312874,5.0019461,31.0282442,271.9459843,3785.3747899,0.0080804,121.9977117,54.3680357,129.9163024,8.5170361,14.8413514,2.75571,38.2042855),(50060,'femur tibia pelvis',255,7,424,49.8373759,105.1725768,125.4971529,1.8,107.4996359,125.4296937,0.0311235,5.0380608,31.4520879,265.9135499,3706.7159736,0.0080434,117.8527794,52.7809334,125.4838867,8.5991196,14.9467204,2.8198421,38.8119561),(50061,'femur tibia pelvis',255,7,425,50.1657407,104.8719052,125.5984719,1.8,107.208669,125.5407628,0.0306059,4.7346716,31.7500356,260.0213767,3735.7943411,0.0078294,117.662682,54.9185663,125.1687768,8.4599362,15.3549594,2.8286914,39.5670723),(50062,'femur tibia pelvis',255,7,426,49.9606876,104.5015909,125.6705828,1.8,106.6966208,125.60963,0.029698,4.7958965,32.1190325,252.7796125,3747.7423164,0.0073418,116.6829143,52.707479,124.011867,8.4339562,15.7643386,2.8370818,40.4264483),(50063,'femur tibia pelvis',255,7,427,50.965588,104.0770522,125.7636265,1.8,106.4972044,125.6963779,0.0292517,4.878203,32.5286137,250.5894793,3729.6172178,0.0072661,114.6565069,51.3692188,121.8856393,8.4740202,16.1747714,2.8450468,41.0341189),(50064,'femur tibia pelvis',255,7,428,52.4035898,103.7965034,125.8806057,1.8,106.3481563,125.8105393,0.0268126,4.5967403,32.8099178,245.7925018,3626.4880998,0.0062775,110.5302405,53.4710434,117.6509202,8.3955745,16.5861794,2.8526172,41.5375297),(50065,'femur tibia pelvis',255,7,429,50.0156855,103.5834612,125.9920155,1.8,106.1058927,125.9091008,0.0167618,4.7468222,33.0295071,234.8037062,3536.769925,0.0023418,107.079101,49.4654521,113.8304596,8.4849253,16.998492,2.8598208,43.0045763),(50066,'femur tibia pelvis',255,7,430,48.0390624,103.5957514,126.1338639,1.8,106.014715,126.0183207,0.0077991,4.9178127,33.028788,219.5900433,3446.6994704,0.000487,104.3544034,44.6519733,110.7548137,8.5311331,17.533166,2.8430937,43.8639523),(50067,'femur tibia pelvis',255,7,431,46.9486159,103.6995332,126.2893209,1.8,105.9300923,126.1292994,-0.0022457,4.7043342,32.516218,201.7072858,3334.0731907,0.0000395,102.5357004,42.8769036,108.5263467,8.4377771,18.1336482,2.9023611,44.6190685),(50068,'femur tibia pelvis',255,7,432,44.9033994,103.8222619,126.4122472,1.8,106.0144559,126.2255892,-0.0121489,4.9021793,31.9891285,184.3105257,3312.4688457,0.0011045,103.549831,37.5976712,109.0364272,8.4695108,18.5513782,2.9078495,45.4784445),(50069,'femur tibia pelvis',255,7,433,42.3887146,103.8391595,126.4759185,1.8,106.098529,126.2634587,-0.0201636,5.0262358,31.5611123,165.889783,3150.5246652,0.002872,99.822992,33.0047753,104.8495276,8.4839427,19.5685029,2.9872739,47.3014563),(50070,'femur tibia pelvis',255,7,434,40.5733366,104.0294797,126.5827759,1.8,105.9029506,126.3634655,-0.0244331,5.1696401,30.9525347,151.0116432,2978.8891873,0.0040361,96.2405573,29.2112488,100.8924642,8.5233576,20.3092932,3.0356083,49.0202083),(50071,'femur tibia pelvis',255,7,435,38.0857311,104.2783825,126.657086,1.8,105.9442103,126.461391,-0.029042,4.8568677,30.2856322,131.4544647,2876.3557219,0.0053523,94.9742672,27.0656878,99.0927607,8.5463905,20.9844416,2.9562447,50.6347005),(50072,'femur tibia pelvis',255,7,436,36.8353264,104.4118136,126.7609557,1.8,106.0195461,126.5090138,-0.0382925,5.0385522,30.1572929,114.9440247,2842.346762,0.0089976,94.2507265,22.8129075,97.9525107,8.4701613,22.1195436,3.00519,52.7094177),(50073,'femur tibia pelvis',255,7,437,34.5328003,104.4554493,126.810348,1.8,105.9897067,126.5841634,-0.0425111,4.6940517,29.6922502,99.416463,2624.3386786,0.010395,88.3846344,21.1792432,91.6353911,8.164072,23.2667224,3.0676536,54.4281697),(50074,'femur tibia pelvis',255,7,438,33.6476867,104.4040862,126.8391486,1.8,105.9238746,126.6503156,-0.0420329,4.7168356,29.3148111,90.1711799,2444.4720131,0.0099021,83.386927,19.1168798,86.3603762,8.164072,24.552449,3.0715321,57.2580031),(50075,'femur tibia pelvis',255,7,439,31.4210835,104.7973372,126.8870473,1.8,106.0506168,126.7036836,-0.0498461,4.4171848,28.5055492,77.5764423,2415.6156793,0.0130009,84.741945,17.5624173,87.3741778,8.164072,25.8385082,3.0750245,59.5844257),(50076,'femur tibia pelvis',255,7,440,30.7186994,105.06039,126.8917378,1.8,106.1756323,126.7261649,-0.0561932,4.4894716,27.8459021,69.2297321,2426.5976642,0.0161496,87.1437977,15.4204633,89.486006,8.164072,27.9825547,0.061461,63.3778949),(50077,'femur tibia pelvis',255,7,441,30.5334522,105.2834492,126.9100641,1.8,106.3221816,126.7387612,-0.0577826,4.5342674,27.6019353,62.1358007,2369.0598948,0.0169721,85.8294851,13.7036032,88.0058446,8.59376,29.2692919,0.0587558,66.6679533),(50078,'femur tibia pelvis',255,7,442,29.3553896,105.6874316,126.8963062,1.8,106.7695796,126.7143416,-0.0643983,4.1757653,26.7760328,55.3819395,2389.7427773,0.0202621,89.249322,13.2627042,91.2546278,8.59376,31.4407146,0.0683863,72.4318799),(50079,'femur tibia pelvis',255,7,443,27.8724048,106.0354518,126.9146806,1.8,106.9519701,126.7523309,-0.0676968,4.2479219,26.0044866,48.989833,2360.601309,0.0212567,90.7766934,11.5326586,92.5951294,8.59376,33.1862705,0.0777649,75.6176785),(50080,'femur tibia pelvis',255,7,444,26.6820893,106.483643,126.915402,1.8,107.0689086,126.7785103,-0.0693551,3.8668269,25.1601311,44.5649523,2216.8417079,0.0213564,88.1093066,11.524941,89.7367269,8.164072,34.4421133,0.0624188,77.9441011),(50081,'femur tibia pelvis',255,7,445,26.4454249,106.9327155,126.8948734,1.8,107.4478737,126.7616562,-0.0734215,3.919885,24.6848296,41.3363553,2254.6160878,0.0237173,91.3361008,10.545298,92.9479835,8.5585331,35.7287574,0.0601683,80.5222291),(50082,'femur tibia pelvis',255,7,446,25.7028135,107.3443984,126.8723967,1.8,107.7515488,126.7561393,-0.0760664,3.9563135,23.8464955,37.6406128,2257.5667952,0.0247387,94.6707997,9.5140623,96.1833457,8.59376,36.6143597,0.0704713,82.7443919),(50083,'femur tibia pelvis',255,7,447,25.8993065,107.4761105,126.876554,1.8,107.8939377,126.7804332,-0.0772107,3.9830019,23.2880833,36.2369311,2251.563386,0.025682,96.6830697,9.0978945,98.165312,8.59376,37.5036649,0.0802868,85.5742253),(50084,'femur tibia pelvis',255,7,448,25.8693738,107.6880591,126.8689826,1.8,108.0890311,126.7738417,-0.0799162,3.5936729,22.6502483,34.4190581,2144.6810142,0.0274777,94.6868655,9.5776826,96.1333038,8.59376,38.7887143,0.0776215,87.2929773),(50085,'femur tibia pelvis',255,7,449,25.4138928,108.0399244,126.7968713,1.8,108.4562086,126.6788069,-0.0864368,3.625074,21.8706686,30.925993,2069.8698674,0.0315671,94.641362,8.5311343,96.0016908,8.59376,40.0186961,0.0537117,89.0117293),(50086,'femur tibia pelvis',255,7,450,26.1646168,108.655557,126.7111791,1.8,109.2935833,126.5979272,-0.0880618,3.6125726,20.8608124,30.1852886,2089.3352581,0.0337299,100.155987,8.3556213,101.4540393,8.59376,52.5345202,0.06548,116.1736842),(50087,'femur tibia pelvis',255,7,451,26.2132924,108.8696819,126.6859288,1.8,109.2364154,126.5785912,-0.0949649,3.6914204,20.2248147,28.6856251,2037.3963425,0.0392817,100.7374541,7.770891,102.0254545,8.59376,51.7073763,0.0748598,114.3506725),(50088,'femur tibia pelvis',255,7,452,25.8411755,108.7335871,126.6720224,1.8,109.0862511,126.57866,-0.0990414,3.286755,20.3203809,28.8627442,1964.0473006,0.0421089,96.6540595,8.781532,98.0464863,8.164072,51.2482881,0.0671259,111.6682847),(50089,'femur tibia pelvis',255,7,453,25.7375579,108.5868965,126.6430052,1.8,109.0624154,126.5446672,-0.1005464,3.2615457,20.0366075,29.4768431,1920.356285,0.0432201,95.8423869,9.0376912,97.2885375,8.164072,50.3908805,0.0682698,109.5935675),(50090,'femur tibia pelvis',255,7,454,25.3940868,108.4432203,126.6188384,1.8,108.9355857,126.5458257,-0.1010835,3.2294859,19.7932184,30.3156082,1892.6732478,0.0430985,95.622309,9.3871313,97.0589578,8.164072,49.104898,0.0700606,107.2671449),(50091,'femur tibia pelvis',255,7,455,25.5406173,108.4192024,126.5879459,1.8,108.821162,126.5117687,-0.1022224,3.6373314,19.3874982,32.0130957,1906.046169,0.044326,98.3131579,8.801259,99.8652807,7.734384,47.7901149,0.0629797,104.4373115),(50092,'femur tibia pelvis',255,7,456,25.6643206,108.5277743,126.5180954,1.8,108.8763859,126.4563592,-0.1024185,3.5812732,18.8450864,33.4723252,1922.3902456,0.0447112,102.010158,9.3464874,103.6819989,7.734384,45.6461346,0.065942,99.7844663),(50093,'femur tibia pelvis',255,7,457,26.3966933,108.4131351,126.4935173,1.8,108.7692893,126.454304,-0.101815,3.5379427,18.5286572,35.4202545,1896.7899924,0.0454486,102.3706126,10.0115399,104.1689078,7.733206,44.4264977,0.0871573,97.7097491),(50094,'femur tibia pelvis',255,7,458,27.4098182,108.4953951,126.4046412,1.8,108.7570507,126.3778514,-0.1010191,3.4483714,18.3504939,38.2168494,1916.6112754,0.0464605,104.4446696,11.0825793,106.5267839,7.304696,43.9312641,0.06852,96.3469623),(50095,'femur tibia pelvis',255,7,459,28.7839262,108.4427469,126.3324522,1.8,108.8506267,126.298022,-0.0992144,3.3497358,18.0107899,42.9991913,2008.5595708,0.0470677,111.5197934,12.8365917,113.8831206,7.2909449,42.6777751,0.0806329,93.3086093),(50096,'femur tibia pelvis',255,7,460,29.5357133,108.3919244,126.2546151,1.8,108.7624104,126.2661159,-0.0962772,3.6600468,17.6250309,47.4165457,2066.4631098,0.0454884,117.2459285,12.9551747,119.908022,6.875008,41.7881245,0.0720401,91.3381519),(50097,'femur tibia pelvis',255,7,461,31.687177,108.5379364,126.1815793,1.8,108.8201087,126.190668,-0.096285,3.6014795,17.044979,54.733976,2141.1840427,0.0488098,125.6196348,15.1976363,128.8012894,6.8501563,40.5366848,0.0849018,88.9074695),(50098,'femur tibia pelvis',255,7,462,34.2743718,108.4579149,126.0894262,1.8,108.8751379,126.1047599,-0.0954103,3.4916271,16.7287327,61.8332087,2287.4334247,0.0518431,136.7368029,17.7089955,140.2924771,6.5218279,39.6455586,0.0759406,87.6489425),(50099,'femur tibia pelvis',255,7,463,36.6807393,108.7140054,125.998464,1.8,108.825001,126.0894891,-0.0973671,3.449327,16.0387932,68.4897931,2399.3278932,0.0577748,149.5952887,19.8559872,153.7223629,6.6513362,38.3964157,0.0896467,84.7148493),(50100,'femur tibia pelvis',255,7,464,38.4406717,109.0473811,125.9326774,1.8,108.9264966,126.0427944,-0.1051793,3.0866857,15.2779596,72.6412683,2410.4131636,0.0706151,157.7706205,23.5337432,162.407555,6.4516529,36.7276431,0.1054893,81.7807561),(50101,'femur tibia pelvis',255,7,465,40.8093296,109.6228295,125.8214371,1.8,109.0863904,125.9708734,-0.1146748,3.1078728,14.3206983,75.7376458,2428.2430966,0.0890511,169.5617805,24.3696089,174.5301254,6.3563722,35.1242016,0.1349767,77.9872869),(50102,'femur tibia pelvis',255,7,466,42.4897585,110.171343,125.7554054,1.8,109.2626983,125.930221,-0.1259292,3.0505717,14.2607159,77.1281476,2378.4648245,0.1117092,166.7843915,25.283178,170.8315739,6.3335412,34.1189589,0.1009218,75.7651241),(50103,'femur tibia pelvis',255,7,467,43.4460952,110.3776966,125.7059556,1.8,109.3383968,125.9289012,-0.138272,3.0586325,14.4930937,74.1775634,2234.0109968,0.137562,154.1431419,24.2518716,158.2412311,6.2887492,32.9965694,0.1437387,72.8310309),(50104,'femur tibia pelvis',255,7,468,39.3716075,110.2641104,125.6616668,1.8,109.2655979,125.9264622,-0.1566737,3.0297093,14.4827302,62.2662794,1803.0525526,0.1597599,124.4967301,20.5518988,127.738835,6.1682621,31.2965106,0.1516055,70.3571627),(50105,'femur tibia pelvis',255,7,469,28.4399516,109.3136656,125.7743452,1.8,108.7329724,125.9784438,-0.1893453,2.8009102,13.5813284,39.1165342,1299.8749176,0.1679154,95.7104403,13.9656509,98.0248091,5.7174277,29.0476715,0.133529,67.3798837),(50106,'femur tibia pelvis',255,7,470,13.7376673,107.197231,126.2167494,1.8,107.636844,126.162504,-0.2207648,2.6985007,12.6356951,14.4164457,648.8436575,0.1097879,51.3500565,5.3423909,52.0601868,4.8325311,15.1917649,0.1418971,35.2091183),(50107,'femur tibia pelvis',255,7,471,4.0556328,103.1537686,127.304252,1.8,102.9605586,127.3400196,-0.1781336,1.7352522,13.3643656,2.2670293,28.2486145,0.0212227,2.1137266,1.3064552,2.2663235,3.8158746,8.8582451,0.2449787,20.6429122),(50108,'femur tibia pelvis',255,7,472,0.4365143,103.2338913,127.8370816,1.8,103.2372125,127.822839,-0.1633679,1.0125586,1.4133688,0.0922679,0.1867534,0.0019245,0.1321336,0.0911235,0.1973957,2.14844,3.1281759,0.2782997,7.5437526),(50109,'femur tibia pelvis',255,7,473,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50110,'femur tibia pelvis',255,7,474,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50111,'femur tibia pelvis',255,7,475,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50112,'femur tibia pelvis',255,7,476,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50113,'femur tibia pelvis',255,7,477,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50114,'femur tibia pelvis',255,7,478,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50115,'femur tibia pelvis',255,7,479,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50116,'femur tibia pelvis',255,7,480,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50117,'femur tibia pelvis',255,7,481,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50118,'femur tibia pelvis',255,7,482,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50119,'femur tibia pelvis',255,7,483,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50120,'femur tibia pelvis',255,7,484,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50121,'femur tibia pelvis',255,7,485,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50122,'femur tibia pelvis',255,7,486,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50123,'femur tibia pelvis',255,7,487,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50124,'femur tibia pelvis',255,7,488,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50125,'femur tibia pelvis',255,7,489,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50126,'femur tibia pelvis',255,7,490,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50127,'femur tibia pelvis',255,7,491,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50128,'femur tibia pelvis',255,7,492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50129,'femur tibia pelvis',255,7,493,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50130,'femur tibia pelvis',255,7,494,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50131,'femur tibia pelvis',255,7,495,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50132,'femur tibia pelvis',255,7,496,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50133,'femur tibia pelvis',255,7,497,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50134,'femur tibia pelvis',255,7,498,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50135,'femur tibia pelvis',255,7,499,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50136,'femur tibia pelvis',255,7,500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50137,'femur tibia pelvis',255,7,501,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50138,'femur tibia pelvis',255,7,502,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50139,'femur tibia pelvis',255,7,503,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50140,'femur tibia pelvis',255,7,504,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50141,'femur tibia pelvis',255,7,505,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50142,'femur tibia pelvis',255,7,506,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50143,'femur tibia pelvis',255,7,507,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50144,'femur tibia pelvis',255,7,508,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50145,'femur tibia pelvis',255,7,509,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50146,'femur tibia pelvis',255,7,510,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50147,'femur tibia pelvis',255,7,511,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50148,'femur tibia pelvis',255,7,512,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50149,'femur tibia pelvis',255,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50150,'femur tibia pelvis',255,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50151,'femur tibia pelvis',255,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50152,'femur tibia pelvis',255,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50153,'femur tibia pelvis',255,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50154,'femur tibia pelvis',255,8,6,1.8130281,75.7684676,124.5150032,1.8,75.6799418,124.3443934,1.2869957,1.2297395,2.5447248,0.5083205,1.6789654,0.2784801,0.6597827,0.4133563,0.8581399,2.578128,4.899197,1.8370484,11.5889272),(50155,'femur tibia pelvis',255,8,7,8.4081871,75.2471199,123.8266846,1.8,75.2194625,123.5817063,1.4287492,1.9647765,4.4583564,4.3620967,25.7728599,1.3732783,5.7807985,2.2201491,6.7456529,4.132221,8.4420297,1.82812,20.8946176),(50156,'femur tibia pelvis',255,8,8,32.3008259,76.0159711,119.4683698,1.8,76.2747913,118.4462709,-1.3611905,4.5417712,8.6510402,63.7970935,760.993728,5.150394,87.9655754,14.0467431,95.1394577,8.8274324,17.7164901,1.3258177,49.8363985),(50157,'femur tibia pelvis',255,8,9,74.3402507,76.1465615,118.2078433,1.8,76.4807042,118.2576571,-1.4359999,5.8064993,10.4190324,345.0256454,1684.6454832,12.1662739,161.6892445,59.4205957,194.6505123,11.4999365,19.5685029,1.4164776,52.4756005),(50158,'femur tibia pelvis',255,8,10,106.9531603,76.4618051,118.2941086,1.8,76.6441782,118.3551274,1.5476765,6.8193593,10.5901122,831.9869204,2671.5337459,17.8160002,252.2668019,122.0036789,327.8121379,13.0286083,20.7855324,1.4464413,57.2758913),(50159,'femur tibia pelvis',255,8,11,119.2421954,76.5831662,118.305904,1.8,76.8052841,118.8208095,1.4044496,11.3081258,10.5089743,1265.8981572,3648.655491,19.3288232,347.1942536,111.9458854,428.7252771,14.0754341,21.5915548,1.4711277,63.7085624),(50160,'femur tibia pelvis',255,8,12,138.7284011,75.9200206,119.2647125,1.8,75.8660545,119.6835682,1.2809811,12.2704412,11.2861996,2654.1389615,4663.5157057,21.233135,413.2051427,216.3034661,594.3088285,20.631179,23.139407,1.9513027,74.5423734),(50161,'femur tibia pelvis',255,8,13,154.8356214,75.1996493,120.4549888,1.8,75.5042606,120.4856591,1.2480389,12.0544546,12.3613706,3925.7318444,5537.5486199,23.2097322,447.9720584,325.6664838,716.4705117,21.5764476,24.6125346,1.8538921,78.4832882),(50162,'femur tibia pelvis',255,8,14,171.7796712,74.4373825,121.9481397,1.8,74.9843623,121.768335,-1.4572527,12.8736434,14.8105883,4970.8461006,6936.7664765,28.2624271,468.3653571,386.125819,798.9372645,22.3264279,27.3687983,1.1844591,85.3151104),(50163,'femur tibia pelvis',255,8,15,176.7187391,74.2696303,122.8046522,1.8,74.8792145,122.2147422,-1.3535707,13.5045542,15.8689182,5020.6674282,7823.0355799,28.0850429,492.9785071,371.7758731,808.9182226,22.9168275,27.92972,1.1760052,86.0270408),(50164,'femur tibia pelvis',255,8,16,180.4202146,74.7923643,122.9440764,1.8,74.9137787,122.3418274,-1.5025582,12.6947099,16.059314,4967.9918025,7657.3278325,29.9302336,476.8153744,391.3434691,784.5586106,22.8696463,28.0616202,1.1276938,86.0270408),(50165,'femur tibia pelvis',255,8,17,192.5133722,74.5803534,122.9686984,1.8,75.0441977,122.4538189,-1.4421352,13.1933653,16.2540396,5436.2422677,7966.2339044,31.5573521,490.107943,412.0436415,822.622922,22.6420089,28.0122304,1.2102303,86.1744864),(50166,'femur tibia pelvis',255,8,18,176.3377822,74.8286578,121.9786473,1.8,74.817849,122.4590917,-1.5596806,11.6149229,15.0181432,4293.7990442,7495.8631764,29.3859991,499.1205022,369.6795135,771.9317322,22.0592386,28.0977843,1.1618885,86.4261918),(50167,'femur tibia pelvis',255,8,19,162.8857907,74.3776688,121.5398434,1.8,74.4246709,122.2429088,-1.539536,11.2610388,14.6465623,3155.6134451,6353.8189762,27.1211115,433.8095746,280.2240097,636.5667643,20.5626635,28.0977843,1.1618885,86.4261918),(50168,'femur tibia pelvis',255,8,20,152.2344394,73.884876,121.7368896,1.8,74.1077193,121.8168119,-1.3585564,11.8188478,15.2328767,2642.933464,5329.9806758,24.2465446,349.8998102,223.6202309,522.8571166,19.5959718,27.5335809,1.1700029,88.4577231),(50169,'femur tibia pelvis',255,8,21,129.1867427,73.6699329,122.5491172,1.8,73.8724054,121.6872813,-1.0806544,10.8837149,15.657013,2135.461042,3466.407804,16.7596838,221.3964959,196.2069993,348.1815585,18.4714631,27.3687983,1.1844591,81.7301608),(50170,'femur tibia pelvis',255,8,22,116.0115869,73.5927895,122.5611683,1.8,73.742073,121.9789747,-1.0397726,10.4823409,15.3244483,1802.6055081,2766.3126525,14.3765904,180.5162968,171.9659303,285.30136,17.8878082,26.8099144,1.1932661,77.6239122),(50171,'femur tibia pelvis',255,8,23,106.8959244,73.6033078,122.0927472,1.8,73.7367405,121.4635407,-1.1751142,10.4692561,14.35158,1600.6561726,2763.8070138,15.1692049,192.5785885,152.8911091,302.5158578,17.4427899,25.3916161,1.152572,69.7241944),(50172,'femur tibia pelvis',255,8,24,101.5652693,73.6676257,121.3187047,1.8,73.7531247,120.854799,-1.2782846,10.3529996,13.9550396,1417.2858439,3232.0648737,15.5200122,231.6055687,136.8961554,333.0536074,16.9133273,25.3916161,1.152572,69.9758998),(50173,'femur tibia pelvis',255,8,25,98.6482551,73.7507569,120.6546746,1.8,73.7283736,120.5393004,-1.3301364,9.9595211,13.5028823,1283.1984605,3615.6141808,15.5073799,267.7661033,128.8413814,362.5500741,16.4064284,25.2201601,1.1681417,69.1165238),(50174,'femur tibia pelvis',255,8,26,95.263563,73.7478222,120.3715563,1.8,73.692051,120.3581057,-1.3459386,9.6684845,13.3295512,1173.7972729,3641.5150005,15.0879293,273.191118,121.4044733,361.2105243,16.1723513,25.0549006,1.1839206,68.5088532),(50175,'femur tibia pelvis',255,8,27,91.6215613,73.718308,120.184763,1.8,73.6346897,120.1634857,-1.3548343,9.2904086,13.243198,1073.3545363,3553.9898618,14.5690651,268.3634173,115.5336205,348.7669085,15.6349665,24.8254078,1.1613591,67.293512),(50176,'femur tibia pelvis',255,8,28,87.4616395,73.674486,120.0521329,1.8,73.5586648,120.0337829,-1.3586077,9.1674065,13.1196342,974.4717211,3410.063868,13.9304185,259.9206517,106.2974264,333.3650845,15.3060975,24.6575028,1.1773457,67.3977718),(50177,'femur tibia pelvis',255,8,29,83.6463637,73.6624187,120.0036326,1.8,73.5724568,119.9111555,-1.3598343,8.8558747,13.0735889,891.5019743,3241.9402927,13.329764,247.9763069,100.6678627,315.3092252,14.9177961,24.4318345,1.1543577,65.8264654),(50178,'femur tibia pelvis',255,8,30,80.3041369,73.6269867,119.9265073,1.8,73.54812,119.8606972,-1.3585821,8.5812775,13.0068551,817.6658638,3114.1122367,12.790269,239.4208456,95.2848648,301.3961308,14.5870906,24.0970318,1.1869787,65.4705002),(50179,'femur tibia pelvis',255,8,31,78.4356633,73.6460518,119.7987537,1.8,73.5347379,119.7042479,-1.363146,8.4828484,13.2050898,763.264482,3004.5099235,12.5169921,227.5266567,89.9773813,285.0733069,14.4275193,24.0970318,1.1869787,64.9670894),(50180,'femur tibia pelvis',255,8,32,77.0715142,73.6508232,119.7174761,1.8,73.522978,119.6108768,-1.3682044,8.05547,13.1215244,721.2571448,2922.8743596,12.3252117,222.7541766,89.5363208,277.3958254,13.8822861,23.9394452,1.2036225,64.3594188),(50181,'femur tibia pelvis',255,8,33,75.8831569,73.701077,119.6196915,1.8,73.5784409,119.5226896,-1.3716974,7.9273168,13.0984162,675.3829868,2843.4402368,12.1524426,217.0827525,85.1969214,267.7476002,13.61997,23.8660645,1.1635405,62.8923722),(50182,'femur tibia pelvis',255,8,34,74.8680179,73.7314674,119.5323616,1.8,73.5921863,119.4628126,-1.3763416,7.8150469,13.001734,638.737078,2779.3377001,12.0120938,213.7666953,81.7317011,261.9217624,13.4730081,23.6991533,1.1801893,62.6406668),(50183,'femur tibia pelvis',255,8,35,74.3064575,73.7309848,119.469376,1.8,73.6047234,119.3471863,-1.3782024,7.4821138,13.0201411,607.1022127,2733.8956124,11.9306935,209.9743456,81.1404675,254.7344185,13.1063446,23.6484599,1.1396576,61.9287365),(50184,'femur tibia pelvis',255,8,36,73.5923242,73.7162904,119.3903288,1.8,73.6281853,119.2867724,-1.3781723,7.4295251,12.9454165,574.5431885,2691.8562849,11.8158931,207.9389481,77.332424,250.3947668,12.9092943,23.4721372,1.1562895,61.3210659),(50185,'femur tibia pelvis',255,8,37,72.5137389,73.7401742,119.320989,1.8,73.6480147,119.1654493,-1.3803541,7.0711134,13.1285139,546.5111971,2648.5391031,11.6525725,201.7394439,77.2878562,243.020545,12.638153,23.3024045,1.1731683,61.0693605),(50186,'femur tibia pelvis',255,8,38,72.2236992,73.7577165,119.2254596,1.8,73.6609479,119.13954,-1.3846748,7.0541046,13.0282346,522.0730055,2618.7926782,11.6250899,201.0090208,74.0098196,240.6737161,12.555608,23.139407,1.1902899,60.4616899),(50187,'femur tibia pelvis',255,8,39,71.3506706,73.7602499,119.1701271,1.8,73.675208,119.0750545,-1.3885664,6.9675664,13.0481774,499.4875223,2573.3047485,11.5012312,197.2156472,71.687515,234.4405219,12.3670117,23.139407,1.1902899,59.9582791),(50188,'femur tibia pelvis',255,8,40,71.3212414,73.7739719,119.1463715,1.8,73.6965503,119.012927,-1.3900334,6.6073043,13.0205096,483.9371325,2537.5898756,11.502679,194.891748,73.2427491,230.9980184,12.031264,22.9832877,1.2076493,59.2463487),(50189,'femur tibia pelvis',255,8,41,70.8752158,73.778985,119.0996632,1.8,73.7190223,118.9874088,-1.3894377,6.6133858,12.9744051,464.9597245,2509.5285995,11.4282513,193.4214774,70.3058524,228.2096775,11.9595284,22.8341879,1.2252407,59.2463487),(50190,'femur tibia pelvis',255,8,42,70.4351767,73.7791345,119.0526568,1.8,73.7250699,118.9433166,-1.3907847,6.538805,12.9264425,452.0404495,2475.3285017,11.3628881,191.4934065,69.1319669,225.3769863,11.8231864,22.7410116,1.1832725,59.2463487),(50191,'femur tibia pelvis',255,8,43,70.374472,73.7801962,119.0159195,1.8,73.7458898,118.8988456,-1.3913093,6.5422084,12.9661474,439.3178653,2459.6434434,11.3552596,189.6973231,67.1513106,221.6688466,11.8231864,22.8341879,1.2252407,58.9946433),(50192,'femur tibia pelvis',255,8,44,70.1007135,73.8112434,118.9695524,1.8,73.777207,118.8343352,-1.393929,6.4335397,12.9105272,426.4129855,2445.8809702,11.3217651,189.4485736,66.2796855,220.5339941,11.6868444,22.7410116,1.1832725,58.3869727),(50193,'femur tibia pelvis',255,8,45,69.9556377,73.8224405,118.913553,1.8,73.7865408,118.8014206,-1.3957259,6.1521614,12.8503267,416.7266165,2440.9098393,11.3055562,189.949244,67.73662,220.3687941,11.4172458,22.7410116,1.1832725,58.0310075),(50194,'femur tibia pelvis',255,8,46,69.868525,73.8311306,118.8954248,1.8,73.7931112,118.7880685,-1.396269,6.0695875,12.8300182,406.1414742,2421.0147495,11.293644,188.6992448,66.9141811,218.3536071,11.171888,22.7410116,1.1832725,57.6750423),(50195,'femur tibia pelvis',255,8,47,69.7982531,73.83949,118.8879759,1.8,73.8180049,118.7506044,-1.3964911,6.0616924,12.8208456,398.1497576,2407.0757334,11.2831683,187.7470345,65.6829367,216.82122,11.171888,22.5821383,1.2008903,57.7793021),(50196,'femur tibia pelvis',255,8,48,69.8656716,73.8566493,118.9123106,1.8,73.8451155,118.7386431,-1.3997789,6.0264523,12.836125,390.9321097,2383.32129,11.307026,185.6729571,64.8693608,214.1296412,11.171888,22.5821383,1.2008903,57.7793021),(50197,'femur tibia pelvis',255,8,49,69.4342487,73.8626504,118.870654,1.8,73.8428726,118.7691402,-1.4029706,5.9419492,12.7883749,380.8499651,2344.9364952,11.2494819,183.3646971,64.0951227,211.0651366,11.0082198,22.5821383,1.2008903,57.1716315),(50198,'femur tibia pelvis',255,8,50,69.2205794,73.8640704,118.8765821,1.8,73.8413559,118.7782909,-1.4041694,5.934835,12.7918182,373.7980336,2318.745262,11.2194041,181.2678402,62.9837277,208.4067878,11.0082198,22.4303721,1.218752,57.1716315),(50199,'femur tibia pelvis',255,8,51,69.0868612,73.8647166,118.8688057,1.8,73.8588534,118.7603701,-1.4068086,5.9250382,12.7792115,368.3417904,2284.6736007,11.2075954,178.7804829,62.1669903,205.468253,11.0082198,22.4303721,1.218752,57.1716315),(50200,'femur tibia pelvis',255,8,52,69.1345298,73.8674531,118.8563803,1.8,73.8820028,118.6953751,-1.4081682,5.8493784,12.7639835,360.6640184,2266.0002212,11.2203547,177.5308015,61.6585209,203.627255,10.8605273,22.343776,1.1760052,57.1716315),(50201,'femur tibia pelvis',255,8,53,68.3910232,73.8993264,118.8588775,1.8,73.9195203,118.6406323,-1.4115602,5.5855369,12.754999,353.8733292,2234.6253431,11.1119163,175.1960426,63.3552934,200.7811393,10.312512,22.1820578,1.1938871,56.2079957),(50202,'femur tibia pelvis',255,8,54,68.7841211,73.9118607,118.8341876,1.8,73.9309755,118.6329505,-1.4153605,5.5582103,12.6549266,349.5521505,2214.9797048,11.1892695,175.0290445,62.8893346,201.2591022,10.312512,22.0275353,1.2120257,55.8520305),(50203,'femur tibia pelvis',255,8,55,69.133187,73.9134557,118.8176175,1.8,73.9250706,118.6410268,-1.4167517,5.4863204,12.6362217,345.9015444,2208.8334204,11.250935,174.8017312,63.0480029,200.7484282,10.312512,22.0275353,1.2120257,55.8520305),(50204,'femur tibia pelvis',255,8,56,69.0159738,73.935873,118.8243132,1.8,73.9486996,118.6229373,-1.4196934,5.4496702,12.6349717,342.694641,2189.6092419,11.2420251,173.2975178,62.8835563,198.9791475,10.312512,21.880361,1.2304144,55.8520305),(50205,'femur tibia pelvis',255,8,57,69.1491325,73.9456658,118.8424103,1.8,73.9502814,118.6677406,-1.423187,5.4212624,12.2842132,339.0172371,2178.598593,11.2755643,177.3494618,62.5347409,202.1693252,10.312512,21.6257322,1.205049,55.2443599),(50206,'femur tibia pelvis',255,8,58,69.1080659,73.9652384,118.8380733,1.8,73.9862921,118.6213539,-1.4254067,5.3923226,12.2725202,336.4922568,2171.5826049,11.2762523,176.946754,62.4021004,201.5671563,10.312512,21.6257322,1.205049,54.6366893),(50207,'femur tibia pelvis',255,8,59,69.8440753,73.9757795,118.8383652,1.8,74.0210822,118.6323402,-1.4278526,5.6734387,12.2662519,336.2427491,2179.4909658,11.404442,177.6819019,59.2661291,202.2305284,10.603822,21.6257322,1.205049,54.9926545),(50208,'femur tibia pelvis',255,8,60,70.0155031,74.0006921,118.8111218,1.8,74.0489506,118.6129443,-1.429137,5.6478503,12.2330935,334.5559888,2185.4337853,11.4366416,178.6493164,59.2359877,203.1202808,10.6022792,21.6257322,1.205049,54.9926545),(50209,'femur tibia pelvis',255,8,61,70.1177779,74.0251951,118.7933688,1.8,74.0995388,118.5217506,-1.4315139,5.6171211,12.2071644,331.9368719,2184.9040359,11.4610491,178.9853865,59.0937719,203.2654313,10.312512,21.6257322,1.205049,54.6366893),(50210,'femur tibia pelvis',255,8,62,70.5442773,74.0518425,118.7602135,1.8,74.1278247,118.5438948,-1.4328875,5.5900816,12.1678007,331.6594362,2198.5067854,11.5351819,180.682347,59.329981,204.9981724,10.312512,21.4758045,1.2237347,54.6366893),(50211,'femur tibia pelvis',255,8,63,70.8590465,74.0725904,118.7834071,1.8,74.1324218,118.6095017,-1.4348948,5.6169031,12.1837927,331.2252605,2193.1972956,11.593062,180.0094071,58.9693737,204.2698817,10.312512,21.4758045,1.2237347,54.3849839),(50212,'femur tibia pelvis',255,8,64,71.2308278,74.0935348,118.8259831,1.8,74.1441546,118.6398373,-1.436421,5.5839585,12.2200066,330.0130451,2183.0025655,11.6587258,178.641685,59.100197,202.782517,10.312512,21.4844,1.2870022,55.0969143),(50213,'femur tibia pelvis',255,8,65,72.0510964,74.119945,118.8030679,1.8,74.1714758,118.5851949,-1.4380732,5.5538429,12.1903754,327.6884143,2171.8929463,11.7982201,178.1645669,59.0021034,202.1831849,10.312512,21.4758045,1.2237347,54.4892437),(50214,'femur tibia pelvis',255,8,66,72.3146163,74.1365564,118.8077741,1.8,74.182874,118.6496916,-1.4385508,5.5347257,12.1918654,325.8867104,2170.5417048,11.8428784,178.0319605,58.8803724,201.9347057,10.312512,21.4758045,1.2237347,54.8452089),(50215,'femur tibia pelvis',255,8,67,71.5671933,74.161884,118.8266569,1.8,74.2240674,118.6564336,-1.4397277,5.5021422,12.2048583,322.4135037,2148.5767353,11.7241277,176.0427436,58.5978143,199.70528,10.312512,21.4758045,1.2237347,54.8452089),(50216,'femur tibia pelvis',255,8,68,71.4246912,74.1918695,118.8271516,1.8,74.2598607,118.6357778,-1.4429558,5.45862,12.1948965,320.2151383,2128.717912,11.7106215,174.5580964,58.6622882,198.0546077,10.312512,21.3680693,1.3063079,54.8452089),(50217,'femur tibia pelvis',255,8,69,71.5327287,74.205654,118.8590262,1.8,74.2698202,118.6422677,-1.445419,5.4304435,12.2197264,319.0799611,2105.0268051,11.735692,172.2646424,58.7576246,195.6269893,10.312512,21.3680693,1.3063079,54.5935035),(50218,'femur tibia pelvis',255,8,70,71.6061898,74.2153156,118.9221864,1.8,74.2704568,118.7479391,-1.4494617,5.3960011,12.2208333,316.6615621,2059.1507905,11.7595268,168.4951218,58.6844877,192.6344112,10.312512,21.2597881,1.3258177,54.2375383),(50219,'femur tibia pelvis',255,8,71,70.7215798,74.2022915,119.071388,1.8,74.2863454,118.8235711,-1.4603252,5.34649,11.9247213,311.6714418,1943.9673608,11.6436681,163.019941,58.2945894,186.9486479,9.882824,20.8431901,1.3208177,52.7704917),(50220,'femur tibia pelvis',255,8,72,70.1680202,74.1879961,119.205666,1.8,74.2749186,119.046328,-1.4690369,5.3546746,11.5285277,309.4694828,1837.5066132,11.5739894,159.3877948,57.7942649,185.3414965,9.882824,20.2273087,1.3567356,51.8068559),(50221,'femur tibia pelvis',255,8,73,70.070501,74.1843726,119.3013223,1.8,74.2590355,119.1703148,-1.4745328,5.3245319,11.2312991,307.5196144,1764.7662893,11.5705308,157.1293106,57.755239,182.5317947,9.882824,19.9052705,1.3310532,50.9474799),(50222,'femur tibia pelvis',255,8,74,70.3302723,74.1910442,119.4015647,1.8,74.2564521,119.2914679,-1.4815437,5.278064,11.2420484,306.7546637,1698.9026517,11.6285843,151.1203824,58.1187848,177.880824,9.882824,19.7188875,1.3734008,50.0881039),(50223,'femur tibia pelvis',255,8,75,69.7806291,74.1914312,119.5136999,1.8,74.2468688,119.4130436,-1.4890212,5.2360313,10.9538406,305.1018771,1619.6114171,11.5525055,147.8578582,58.2696818,174.2875419,9.882824,19.3884063,1.3473197,49.2287279),(50224,'femur tibia pelvis',255,8,76,68.635968,74.1936607,119.6175222,1.8,74.2409125,119.4917133,-1.4956789,5.1975876,10.6191433,302.5537599,1543.6374052,11.3749015,145.3636483,58.2104201,172.1503603,9.882824,19.0715653,1.3203532,48.2650921),(50225,'femur tibia pelvis',255,8,77,68.2372194,74.2058167,119.7112902,1.8,74.2672467,119.6017141,-1.5024784,5.1504897,10.2727455,301.1726959,1476.8978865,11.3198714,143.7685662,58.4745744,171.0718943,9.882824,18.6555863,1.3146449,47.0497509),(50226,'femur tibia pelvis',255,8,78,67.9451095,74.2243712,119.7996133,1.8,74.2809358,119.721819,-1.5089275,5.5020887,9.9204764,302.0190435,1422.9152212,11.280894,143.432146,54.8917074,171.5202952,10.2870188,18.2402429,1.3086765,47.0497509),(50227,'femur tibia pelvis',255,8,79,67.6507617,74.2437169,119.8828749,1.8,74.3048769,119.7675663,-1.5146512,5.4573073,9.9688032,301.208668,1373.6336587,11.2396219,137.7932368,55.1936429,166.6954447,10.312512,18.1336482,1.3315647,46.7980455),(50228,'femur tibia pelvis',255,8,80,67.1474443,74.2578312,119.9844406,1.8,74.3164927,119.8648675,-1.5197719,5.4196959,9.6338379,299.5348423,1320.2937383,11.1621297,137.0475353,55.2678324,166.6124761,10.2540673,17.7164901,1.3258177,45.9386695),(50229,'femur tibia pelvis',255,8,81,66.6795426,74.2749529,120.0469471,1.8,74.3426009,119.9611435,-1.526473,5.3953261,9.2572817,298.1568332,1267.8884353,11.0914388,136.9612022,55.2620595,167.34378,10.2290165,17.2999454,1.3197936,45.3309989),(50230,'femur tibia pelvis',255,8,82,66.8522013,74.2952512,120.1324028,1.8,74.3738307,120.0690774,-1.5312537,5.3529703,9.3182216,298.381712,1230.5348895,11.1246208,132.0568397,55.7413347,163.2103031,9.882824,17.1982588,1.3439975,44.7233283),(50231,'femur tibia pelvis',255,8,83,67.0162438,74.3194834,120.2218114,1.8,74.3840908,120.1516891,-1.5355021,5.3092412,8.9882894,298.3522375,1194.1333214,11.1554663,132.8543467,56.1948919,164.0164035,9.882824,16.8840595,1.3134726,44.1156577),(50232,'femur tibia pelvis',255,8,84,66.5403414,74.3551921,120.2958799,1.8,74.4008826,120.2345149,-1.5417802,5.2476069,9.0272728,298.410867,1156.4870221,11.0807224,128.1103434,56.866086,160.8369589,9.882824,16.6860637,1.3633001,43.8639523),(50233,'femur tibia pelvis',255,8,85,65.722031,74.3915103,120.3659941,1.8,74.4555499,120.2997796,-1.5481993,5.1953502,8.6727793,298.5464502,1121.0922377,10.9480796,129.2656253,57.4641625,162.5293467,9.882824,16.3620316,1.332187,43.5079871),(50234,'femur tibia pelvis',255,8,86,65.5510508,74.4299687,120.4337665,1.8,74.4899193,120.3865402,-1.5548324,5.5442395,8.7259948,299.5769801,1088.7463471,10.9223911,124.7704559,54.0339173,158.6938893,10.312512,16.2658334,1.357858,43.3605415),(50235,'femur tibia pelvis',255,8,87,65.8813738,74.4685913,120.4977369,1.8,74.5230735,120.4771534,-1.5604743,5.4910922,8.3606613,300.4660117,1062.9216442,10.9790591,127.1336804,54.7188064,161.7518357,10.2518595,16.1061369,1.4100336,43.3605415),(50236,'femur tibia pelvis',255,8,88,66.2711707,74.5041338,120.5681851,1.8,74.5575586,120.55499,-1.565373,5.4373414,8.4255725,301.1162824,1038.1287949,11.0448703,123.2116623,55.3793224,157.6712293,10.312512,16.1061369,1.4100336,43.1088361),(50237,'femur tibia pelvis',255,8,89,66.0002095,74.5403792,120.6351181,1.8,74.603168,120.6572934,-1.5693523,5.3867017,8.4868666,300.5436135,1010.5386298,11.000012,119.0708745,55.7936243,154.4349967,10.2009668,16.0429641,1.4364749,42.8571307),(50238,'femur tibia pelvis',255,8,90,65.6208192,74.5860668,120.7015855,1.8,74.6675408,120.7083456,1.5680024,5.329764,8.1251969,299.9394955,987.5157925,10.9367178,121.5374605,56.276318,157.2078854,9.882824,15.7584815,1.3787483,42.1452003),(50239,'femur tibia pelvis',255,8,91,65.5177052,74.6270597,120.7795222,1.8,74.6893062,120.7506494,1.5645672,5.2816546,8.20292,300.5143315,964.0920478,10.9191938,117.5303494,56.8977632,153.8275546,9.882824,15.6821404,1.4056476,42.1452003),(50240,'femur tibia pelvis',255,8,92,65.3296605,74.6721761,120.858744,1.8,74.7580799,120.8705475,1.5596946,5.6470309,7.8588182,301.5316478,942.1941068,10.8869348,119.8900494,53.3964931,156.0192978,10.1917105,15.4269362,1.3460852,41.8934949),(50241,'femur tibia pelvis',255,8,93,65.2075238,74.7171799,120.9278637,1.8,74.7894559,120.9276836,1.5556551,5.5976049,7.9247828,302.3479846,924.8762878,10.8654293,116.7068308,54.0138132,153.9458985,10.2613628,15.3369125,1.3734008,41.8934949),(50242,'femur tibia pelvis',255,8,94,64.8518558,74.7553832,120.978875,1.8,74.8106974,120.9788891,1.5528676,5.5533942,7.9771682,302.0117787,907.2281214,10.8051687,113.728093,54.3832777,151.4756073,10.2613628,15.2584623,1.4010181,41.6417895),(50243,'femur tibia pelvis',255,8,95,64.6141284,74.7984611,121.0358463,1.8,74.8698076,121.0585283,1.5503299,5.5140709,7.6148804,302.5349304,890.5133293,10.7645112,116.9438366,54.8659852,154.9136544,10.2975213,15.0083566,1.3397057,41.2858243),(50244,'femur tibia pelvis',255,8,96,64.4810257,74.8464683,121.1034435,1.8,74.9308562,121.1078367,1.5471268,5.4613445,7.6859147,302.6192037,875.0729855,10.7408179,113.8541115,55.411118,152.4867038,10.2975213,14.9158068,1.3677511,41.2858243),(50245,'femur tibia pelvis',255,8,97,64.121833,74.9002877,121.1466196,1.8,75.0214787,121.1161408,1.5432474,5.8071096,7.7216053,302.3057322,854.7988162,10.6788634,110.7022153,52.0578661,149.4390684,10.2054505,14.9158068,1.3677511,41.6417895),(50246,'femur tibia pelvis',255,8,98,64.2789938,74.953197,121.2309049,1.8,75.0697143,121.2419287,1.5395943,5.7601225,7.7953285,303.9875004,841.0807573,10.702739,107.8954861,52.7744852,146.859437,10.312512,15.1369758,1.4570043,41.3900841),(50247,'femur tibia pelvis',255,8,99,64.7793459,75.0087188,121.3053189,1.8,75.0923064,121.3128844,1.5348206,5.6964096,7.4728365,305.9836639,828.2967985,10.7825902,110.8410168,53.7151799,150.8502736,10.300339,14.8351299,1.3961241,41.0341189),(50248,'femur tibia pelvis',255,8,100,64.9975471,75.0634327,121.3693004,1.8,75.1544022,121.3714858,1.5321371,5.6382276,7.5244892,307.3870897,818.0954589,10.8167424,108.7243846,54.51839,148.7317607,10.2573392,14.9158068,1.3677511,41.0341189),(50249,'femur tibia pelvis',255,8,101,65.0991505,75.1243973,121.4310662,1.8,75.2334535,121.4241208,1.5285818,5.9833425,7.5902785,309.50131,807.224584,10.8305347,106.3497975,51.7271596,146.8463904,10.2805215,14.8351299,1.3961241,41.1383787),(50250,'femur tibia pelvis',255,8,102,64.7208792,75.1839185,121.504885,1.8,75.3014372,121.5043714,1.5259632,5.9204289,7.6293759,309.6985506,795.1158597,10.7651461,104.2176808,52.3101542,144.6551573,10.2542799,14.7665205,1.4247841,40.8866733),(50251,'femur tibia pelvis',255,8,103,64.2593557,75.2434125,121.5746721,1.8,75.3642346,121.5736983,1.5239737,5.8793668,7.3121587,310.2376059,780.6063447,10.6864299,106.7545686,52.7671798,148.7376607,10.3793764,14.4952048,1.3617734,40.7824135),(50252,'femur tibia pelvis',255,8,104,63.9589094,75.3012911,121.638188,1.8,75.4360899,121.61705,1.5231021,5.8228167,7.3788522,309.0738703,770.234742,10.6355884,104.3840864,53.079787,145.7664745,10.3782856,14.4952048,1.3617734,40.5307081),(50253,'femur tibia pelvis',255,8,105,63.7614094,75.3583282,121.7010187,1.8,75.4772558,121.6455663,1.5221444,6.1544065,7.4240703,309.1949519,759.4796355,10.6017674,102.2996289,50.2396052,143.7029175,10.3793764,14.4952048,1.3617734,40.2790027),(50254,'femur tibia pelvis',255,8,106,63.6692054,75.4247441,121.773155,1.8,75.5642831,121.7930368,1.5196681,6.1068173,7.4780983,310.4978678,748.9016919,10.5838189,100.1460077,50.8444669,141.6373203,10.3534347,14.6346459,1.5120405,40.6349679),(50255,'femur tibia pelvis',255,8,107,63.6852068,75.4921495,121.8347253,1.8,75.627493,121.844606,1.5159723,6.0343741,7.1607015,313.1396734,744.1914406,10.5823302,103.9271691,51.8926516,146.8222227,10.3691124,14.4121737,1.3909428,40.2790027),(50256,'femur tibia pelvis',255,8,108,63.5004072,75.5584047,121.8993712,1.8,75.6685396,121.9018419,1.5143021,5.9923713,7.2059909,314.2695046,735.4278761,10.5496591,102.057842,52.4449317,145.1420023,10.5185645,14.4121737,1.3909428,40.2790027),(50257,'femur tibia pelvis',255,8,109,63.4065807,75.6354255,121.976088,1.8,75.7521332,121.9715108,1.5103534,6.2901117,7.2886898,315.2644085,724.7776454,10.5292027,99.4386736,50.1206373,142.4446717,10.5185645,14.3415411,1.4204249,40.3832625),(50258,'femur tibia pelvis',255,8,110,63.5199893,75.7113512,122.0441341,1.8,75.8225341,122.0411025,1.5079682,6.2393952,7.3353954,317.0029156,717.6964848,10.5449303,97.8401906,50.8066735,141.0516727,10.4923726,14.4121737,1.3909428,40.3832625),(50259,'femur tibia pelvis',255,8,111,63.6975715,75.7882633,122.1100762,1.8,75.935147,122.1103309,1.5035901,6.157823,7.0355204,319.2174416,708.1823958,10.5683838,100.6581402,51.8393338,144.6284317,10.5491086,14.1731921,1.3258177,39.9230375),(50260,'femur tibia pelvis',255,8,112,63.5066735,75.8641974,122.1793274,1.8,75.9819337,122.188535,1.5014975,6.1122988,7.0821497,320.5262681,696.3916375,10.5336969,98.3305443,52.4395613,143.0599617,10.6827491,14.0751518,1.3554386,39.6713321),(50261,'femur tibia pelvis',255,8,113,62.7407313,75.9633365,122.215762,1.8,76.073745,122.191391,1.4983829,6.3775278,7.0964377,319.3306995,683.7133917,10.402052,96.3460002,50.0712358,141.2534406,10.5420362,13.9896277,1.3854484,40.0272973),(50262,'femur tibia pelvis',255,8,114,62.1913119,76.0374106,122.2657281,1.8,76.1567216,122.2445509,1.4956621,6.3330271,7.1524911,318.2763146,671.1232407,10.3068155,93.8306988,50.2565851,138.2029589,10.5671058,13.9168507,1.7257931,39.7755919),(50263,'femur tibia pelvis',255,8,115,61.8743607,76.101166,122.3045301,1.8,76.226482,122.2749946,1.4977937,6.3077869,7.163831,315.7627833,661.291146,10.2575323,92.3097071,50.0592026,136.3841898,10.7339038,13.9168507,1.4157996,39.5238865),(50264,'femur tibia pelvis',255,8,116,61.7485873,76.1783652,122.3673381,1.8,76.3420772,122.3717723,1.4972653,6.2346277,6.8667221,317.7802138,655.8667091,10.2358876,95.5137981,50.9701985,140.5614176,10.6430713,13.9168507,1.4157996,39.6713321),(50265,'femur tibia pelvis',255,8,117,61.7885349,76.26312,122.4458853,1.8,76.4157809,122.4409776,1.4940117,6.5469721,6.9215048,324.9267628,648.0829315,10.2374921,93.633241,49.6300821,140.1544441,10.7904924,13.9168507,1.4157996,39.7755919),(50266,'femur tibia pelvis',255,8,118,61.7691206,76.342209,122.5194762,1.8,76.515156,122.5125098,1.4933049,6.505799,7.0013763,330.2163475,642.1322963,10.2331572,91.715153,50.757232,138.3612666,10.8686402,13.9168507,1.4157996,39.7755919),(50267,'femur tibia pelvis',255,8,119,61.6262827,76.4271769,122.5860672,1.8,76.5723924,122.6004383,1.492127,6.4247813,7.0413801,333.8621056,634.5427338,10.207612,90.1162452,51.9647426,137.4442957,10.8686402,13.9168507,1.4157996,40.0272973),(50268,'femur tibia pelvis',255,8,120,61.529379,76.5217393,122.6478572,1.8,76.6727636,122.6933438,1.4859707,6.7197573,6.7206239,339.7160479,624.7928526,10.1812853,92.9664952,50.5548092,137.6444489,11.0363362,13.6556983,1.3487144,39.7755919),(50269,'femur tibia pelvis',255,8,121,61.4315242,76.6127574,122.6917594,1.8,76.7984668,122.6949294,1.4868813,6.670279,6.7713059,342.9508246,619.2253995,10.1666591,91.4484453,51.4147645,139.2667534,11.0363362,13.6556983,1.3487144,39.5238865),(50270,'femur tibia pelvis',255,8,122,61.3325504,76.6961221,122.7374408,1.8,76.8537271,122.7397058,1.4906671,6.5953032,6.7858427,343.6625977,611.4775265,10.1565992,90.1107717,52.107172,140.0975833,11.0363362,13.6556983,1.3487144,39.4196267),(50271,'femur tibia pelvis',255,8,123,61.4351049,76.7814199,122.7820749,1.8,76.9374233,122.7494779,1.4925465,6.549427,6.8360008,347.3714759,605.1274666,10.1766171,88.5206845,53.0384529,138.7590458,11.161258,13.6556983,1.3487144,39.6713321),(50272,'femur tibia pelvis',255,8,124,61.7494265,76.868685,122.8383044,1.8,76.9886644,122.8659305,1.4963895,6.4689275,6.8641716,349.3775114,600.059338,10.2346981,87.4190468,54.0085681,138.1818823,11.161258,13.8103087,1.6642731,39.5238865),(50273,'femur tibia pelvis',255,8,125,61.8212651,76.9578991,122.8904565,1.8,77.0800547,122.8791548,1.5041949,6.7874983,6.8909631,351.3378048,592.2572981,10.2579078,85.9469557,51.762489,136.9319352,11.323978,13.8570216,1.4464413,40.1315571),(50274,'femur tibia pelvis',255,8,126,61.9031745,77.0441166,122.9438508,1.8,77.1668612,122.97473,1.5119457,6.7112157,6.5706153,354.1859839,587.5786781,10.2815044,89.4252135,52.7752344,138.6362103,11.323978,13.5675304,1.3796119,39.7755919),(50275,'femur tibia pelvis',255,8,127,61.6541454,77.1263059,122.9874672,1.8,77.2552273,122.9559736,1.5204854,6.6592864,6.6092372,354.6764007,580.1670596,10.2497031,87.7812433,53.2604216,139.2782962,11.0866974,13.5675304,1.3796119,39.2721811),(50276,'femur tibia pelvis',255,8,128,61.587622,77.213069,123.0307961,1.8,77.3722629,123.0011159,1.5319402,6.5765669,6.6253729,356.5807825,574.1186702,10.2491139,86.654544,54.2198975,139.1921174,11.171888,13.5675304,1.3796119,38.9162159),(50277,'femur tibia pelvis',255,8,129,61.6218068,77.294367,123.0477886,1.8,77.433115,123.028435,1.5441946,6.5081007,6.6329761,358.584749,566.2189739,10.263035,85.364242,55.0982174,137.6667285,11.171888,13.5675304,1.3796119,38.9162159),(50278,'femur tibia pelvis',255,8,130,61.7687849,77.385482,123.0913635,1.8,77.5024553,123.0560972,1.5588034,6.4107762,6.6562431,360.5701544,560.1362457,10.2933168,84.1520113,56.2443833,137.2812776,11.171888,13.5675304,1.3796119,38.6645105),(50279,'femur tibia pelvis',255,8,131,61.7793593,77.4807734,123.1303152,1.8,77.5827432,123.0815528,-1.5655457,6.3115542,6.6840561,361.8232493,553.9481782,10.296276,82.8760521,57.3271243,136.5022393,11.171888,13.4924769,1.4108832,38.9162159),(50280,'femur tibia pelvis',255,8,132,61.6329407,77.5718336,123.17333,1.8,77.6556414,123.1504602,-1.5511425,6.2274616,6.3093859,361.1382629,547.4376975,10.2681894,86.7656073,57.991247,140.2485655,11.171888,13.2369013,1.3415644,38.5602507),(50281,'femur tibia pelvis',255,8,133,61.6354584,77.6627672,123.2066704,1.8,77.7692311,123.1623308,-1.5340782,6.1422142,6.3471065,360.396853,543.0273756,10.2587329,85.5551065,58.6753961,138.2961983,10.7422,13.2369013,1.3415644,37.4491693),(50282,'femur tibia pelvis',255,8,134,61.6343954,77.7526033,123.2510669,1.8,77.8242312,123.206159,-1.5162031,6.0547959,6.39102,360.4255729,538.309165,10.2418135,84.2289912,59.5272867,138.2494233,10.7422,13.2369013,1.3415644,37.7008747),(50283,'femur tibia pelvis',255,8,135,61.6968904,77.8527394,123.2882988,1.8,77.9431866,123.2190019,-1.4997779,6.321853,6.4218662,360.7162884,534.9925812,10.2310397,83.3079615,57.0586329,136.5929967,10.9556448,13.2369013,1.3415644,38.5602507),(50284,'femur tibia pelvis',255,8,136,61.726991,77.9533219,123.3246767,1.8,77.9999044,123.2768892,-1.4762549,6.1965847,6.5104336,361.0777579,529.7696666,10.1961519,81.3724094,58.2704462,136.3669704,10.7309722,13.3825567,1.4743226,38.4128051),(50285,'femur tibia pelvis',255,8,137,61.6295278,78.0536976,123.3626989,1.8,78.0847708,123.3256434,-1.4533059,6.0673276,6.4925118,359.398955,523.1256603,10.1304503,80.5736943,59.2351325,135.6960202,10.7309722,13.0684503,1.735945,37.5534291),(50286,'femur tibia pelvis',255,8,138,61.28684,78.1472662,123.4013204,1.8,78.2066953,123.3926505,-1.4316531,6.0016856,6.4739707,357.6752057,518.4276391,10.0179854,80.0787746,59.5957918,135.1423892,10.7322624,13.0684503,1.4056476,37.1974639),(50287,'femur tibia pelvis',255,8,139,61.3075412,78.2387153,123.4259261,1.8,78.2912244,123.3610089,-1.4110167,5.8871797,6.4698341,356.6612836,516.650474,9.9592772,79.8552891,60.5827073,134.8381617,10.7004594,13.145925,1.3734008,37.7008747),(50288,'femur tibia pelvis',255,8,140,61.2505291,78.3351969,123.4636038,1.8,78.3844507,123.4336214,-1.3885539,5.760273,6.4553502,356.7170189,515.200419,9.8731134,79.8098326,61.9271028,134.9634238,10.7004594,13.0684503,1.4056476,37.4491693),(50289,'femur tibia pelvis',255,8,141,60.9969681,78.4261712,123.5038131,1.8,78.4632677,123.4875091,-1.3688218,5.6381434,6.4379894,353.8482002,514.436995,9.7570547,79.9064681,62.7597018,134.7866308,10.5278846,13.0684503,1.4056476,37.4491693),(50290,'femur tibia pelvis',255,8,142,60.8855736,78.5179164,123.5339324,1.8,78.544003,123.5078453,-1.3494316,5.6092933,6.4319031,351.221054,512.2087547,9.6584092,79.6356456,62.6141362,134.1792175,10.5158116,13.0047187,1.4382448,37.4491693),(50291,'femur tibia pelvis',255,8,143,61.0803881,78.6178819,123.5691257,1.8,78.631143,123.5555517,-1.3307175,5.4833685,6.4240371,349.4402672,511.9648717,9.6044945,79.6951918,63.7272995,134.0374878,10.312512,13.0047187,1.4382448,37.0932041),(50292,'femur tibia pelvis',255,8,144,61.2913159,78.7146396,123.5897703,1.8,78.7394382,123.5557191,-1.3108953,5.3605655,6.4312852,348.0954647,511.0065699,9.5405936,79.4563685,64.9363327,133.5439778,10.312512,12.8188253,1.3339476,36.7372389),(50293,'femur tibia pelvis',255,8,145,60.8385764,78.805362,123.5973133,1.8,78.8314251,123.546329,-1.2965199,5.4333965,6.4501295,345.4136019,508.1988591,9.3959101,78.7889393,63.5723166,132.3046905,10.3793764,12.8188253,1.3339476,36.8414987),(50294,'femur tibia pelvis',255,8,146,60.6435381,78.90645,123.62954,1.8,78.9158261,123.6051464,-1.2796678,5.4117447,6.4498828,343.0674074,505.5302886,9.2745375,78.3782127,63.3931249,131.5336936,10.3704537,12.8188253,1.3339476,37.0932041),(50295,'femur tibia pelvis',255,8,147,60.7472676,79.0073107,123.6623112,1.8,79.0256107,123.6524076,-1.2660485,5.278718,6.450291,341.6039128,502.2293948,9.2130157,77.861509,64.7134239,130.778004,10.2716688,12.8188253,1.3339476,36.8414987),(50296,'femur tibia pelvis',255,8,148,60.7707103,79.0991585,123.6961072,1.8,79.1305303,123.6530892,-1.2616265,5.3027037,6.3159716,339.4271859,499.9812305,9.19077,79.161412,64.0102115,132.8516812,10.2716688,12.7248603,1.3667783,36.4855335),(50297,'femur tibia pelvis',255,8,149,61.0141445,79.1839789,123.7355,1.8,79.1796208,123.7117166,-1.2562363,5.2009563,6.3037216,337.5888692,498.3503365,9.1955718,79.0565275,64.9089989,132.5880152,10.2400876,12.644806,1.4000611,36.4855335),(50298,'femur tibia pelvis',255,8,150,60.9511459,79.2743636,123.7769471,1.8,79.2752119,123.757261,-1.2460714,5.0847587,6.2917737,333.305548,494.2924444,9.1244709,78.5617005,65.5499246,131.5255912,10.1322212,12.4015431,1.3258177,36.1295683),(50299,'femur tibia pelvis',255,8,151,61.0666247,79.3713026,123.8202967,1.8,79.3881941,123.7848393,-1.2352031,5.0824404,6.2815143,330.7527706,491.9610636,9.073912,78.3188639,65.0775501,130.9706423,10.1322212,12.4015431,1.3258177,36.4855335),(50300,'femur tibia pelvis',255,8,152,61.4465745,79.4707377,123.8616964,1.8,79.5142477,123.8327425,-1.2238692,5.0893763,6.2754918,329.8105094,491.9352618,9.0571581,78.3899138,64.8037184,130.9451508,10.1865597,12.4015431,1.3258177,36.4855335),(50301,'femur tibia pelvis',255,8,153,61.7561964,79.5622259,123.8951865,1.8,79.6037136,123.8455312,-1.2090736,4.9556607,6.275751,328.1180783,489.6983569,9.0036897,78.0302404,66.2107633,130.3137049,9.9959247,12.3043918,1.359703,35.8778629),(50302,'femur tibia pelvis',255,8,154,61.8832007,79.646087,123.9272476,1.8,79.6529691,123.8779851,-1.1991143,4.9968977,6.275998,326.6993355,488.1090398,8.9534475,77.7739319,65.3804332,129.8282956,10.1322212,12.3043918,1.359703,36.1295683),(50303,'femur tibia pelvis',255,8,155,61.6206319,79.736156,123.9629474,1.8,79.7599398,123.9667784,-1.188211,4.8764065,6.2763988,323.2534406,484.3803347,8.8387822,77.1748814,66.2892726,128.6732975,9.9948339,12.1001239,1.2827409,35.7736031),(50304,'femur tibia pelvis',255,8,156,61.3618117,79.8256685,123.9985837,1.8,79.8129696,124.0032726,-1.1767304,4.7545891,6.2780571,319.2669881,481.628096,8.7193655,76.7161066,67.1492287,127.5608584,9.993743,12.1001239,1.2827409,35.5218977),(50305,'femur tibia pelvis',255,8,157,61.4092565,79.9209071,124.0368917,1.8,79.9283136,123.9903704,-1.1711999,4.806624,6.1129823,316.2927433,480.7618206,8.6857534,78.6460351,65.8035122,130.2777637,9.9948339,11.9851376,1.3171222,35.7736031),(50306,'femur tibia pelvis',255,8,158,61.4577083,80.0129831,124.0744526,1.8,80.0534868,124.0411067,-1.1547861,4.7935217,6.1108977,313.6775618,480.1414456,8.5701928,78.5713437,65.4378105,129.7923198,9.993743,12.0389346,0.9629943,35.5218977),(50307,'femur tibia pelvis',255,8,159,61.4081935,80.1025689,124.1103153,1.8,80.126365,124.0826299,-1.1426439,4.7239685,6.1119632,310.2432922,478.3616619,8.4704076,78.2664494,65.6742931,128.9357603,9.803108,12.0389346,0.9629943,35.5218977),(50308,'femur tibia pelvis',255,8,160,61.202301,80.1959835,124.1476247,1.8,80.2072077,124.1505766,-1.1286388,4.8116789,6.1144027,306.6878431,475.4881572,8.3327923,77.7652671,63.7382184,127.1185142,9.8961323,12.0389346,0.9629943,35.2701923),(50309,'femur tibia pelvis',255,8,161,60.7972861,80.3112343,124.1668957,1.8,80.2856911,124.1816644,-1.1221235,4.761487,6.1455043,301.1588804,471.1847107,8.2263133,76.6714479,63.2489136,125.4513179,9.7926212,12.1610055,1.012197,35.5218977),(50310,'femur tibia pelvis',255,8,162,60.4534793,80.3995325,124.206882,1.8,80.4192578,124.2020572,-1.1181647,4.6707345,5.9702168,297.0413249,467.9353758,8.1485173,78.3782884,63.5962765,124.6702112,9.7926212,12.0389346,0.9629943,35.1659325),(50311,'femur tibia pelvis',255,8,163,60.2619658,80.480339,124.2514919,1.8,80.4821469,124.2376208,-1.1102177,4.7572287,5.9547243,293.6401892,465.0128551,8.0595311,78.0914164,61.7250525,124.1513186,9.7749823,11.9388329,1.0427219,34.6625217),(50312,'femur tibia pelvis',255,8,164,60.2636443,80.559014,124.2974069,1.8,80.5335542,124.287486,-1.1040361,4.6643765,5.9435207,290.4289785,463.5901845,8.0100841,77.9992551,62.2653384,123.9158604,9.7749823,11.9697226,1.2036225,34.6625217),(50313,'femur tibia pelvis',255,8,165,60.1788256,80.6434792,124.3449877,1.8,80.6446251,124.3444527,-1.0997621,4.7631217,5.9378726,286.7538653,462.048677,7.9642484,77.8138408,60.2029269,123.5585893,9.7016174,12.0389346,0.9629943,35.2701923),(50314,'femur tibia pelvis',255,8,166,60.1889523,80.7270821,124.3887067,1.8,80.7198268,124.4091232,-1.0920585,4.6826263,5.9352057,283.9938402,460.9604863,7.9027393,77.6654611,60.6484103,123.3243732,9.6102913,12.0389346,0.9629943,34.9142271),(50315,'femur tibia pelvis',255,8,167,60.2143532,80.8115286,124.427906,1.8,80.8252469,124.4423153,-1.0857029,4.6064223,5.93828,281.2756735,461.1186995,7.8536846,77.6518956,61.0616348,123.1801713,9.6102913,12.0389346,0.9629943,34.9142271),(50316,'femur tibia pelvis',255,8,168,60.1918057,80.8875214,124.4694028,1.8,80.8929878,124.471607,-1.078892,4.6808981,5.9362205,278.2280833,460.0536425,7.7941135,77.4994194,59.4390381,122.8455433,9.5378216,12.0389346,0.9629943,34.3065565),(50317,'femur tibia pelvis',255,8,169,60.1817909,80.9616377,124.5111829,1.8,80.9556426,124.5153801,-1.0711773,4.6040367,5.9338342,275.9971862,459.0713451,7.7280607,77.3650443,59.9467827,122.6521666,9.4196563,12.1610055,1.012197,34.5582619),(50318,'femur tibia pelvis',255,8,170,60.071851,81.0344611,124.5520796,1.8,81.0354204,124.5590784,-1.0646576,4.6582551,5.9326168,273.5047389,456.6719882,7.658814,76.9764846,58.7139888,122.1447152,9.5378216,12.1610055,1.012197,34.5582619),(50319,'femur tibia pelvis',255,8,171,59.9687929,81.1052603,124.5905264,1.8,81.0944427,124.5841336,-1.0574438,4.5811138,5.885633,270.6010172,455.0396351,7.5842572,77.3136266,59.0688266,121.6384615,9.4196563,12.1077509,1.091277,34.3065565),(50320,'femur tibia pelvis',255,8,172,59.9840111,81.1744008,124.6290887,1.8,81.1436858,124.60952,-1.047766,4.6730425,5.8770684,268.3804452,454.0468751,7.5029216,77.257375,57.4316298,121.3447917,9.5378216,12.1077509,1.091277,34.0548511),(50321,'femur tibia pelvis',255,8,173,60.0371067,81.2455226,124.6697422,1.8,81.2233903,124.6827191,-1.0382869,4.5488809,5.8688741,266.4792976,454.3765921,7.4270294,77.4214249,58.5812869,121.3301004,9.4166716,12.1077509,1.091277,34.0548511),(50322,'femur tibia pelvis',255,8,174,59.8537058,81.3179955,124.7060123,1.8,81.3121917,124.7077895,-1.0255706,4.6404848,5.8632148,263.6143977,452.4491631,7.2926009,77.1674213,56.8075125,120.6566317,9.4166716,12.1077509,1.091277,34.0548511),(50323,'femur tibia pelvis',255,8,175,59.7339749,81.3844611,124.7447257,1.8,81.3942249,124.7572253,-1.0127853,4.5904316,5.8533451,262.0439871,451.1433598,7.164391,77.0744503,57.0848254,120.3760326,9.4166716,12.1077509,1.091277,33.9505913),(50324,'femur tibia pelvis',255,8,176,59.5754713,81.4445662,124.7873506,1.8,81.4388532,124.8094643,-1.0014614,4.5776276,5.8390914,260.4595049,449.1375849,7.0438198,76.9190875,56.8983601,120.0785495,9.3695159,12.1077509,1.091277,33.6988859),(50325,'femur tibia pelvis',255,8,177,59.2265732,81.4947452,124.8087692,1.8,81.4817547,124.8060589,-0.9934449,4.5249476,5.8410572,257.4732876,445.8509532,6.9304486,76.3305238,56.9008325,118.9994048,9.3006609,12.1610055,1.012197,33.6988859),(50326,'femur tibia pelvis',255,8,178,58.9750823,81.5503633,124.8533061,1.8,81.5453408,124.8474862,-0.9827153,4.5887257,5.8248412,255.965038,443.4561943,6.8041057,76.131894,55.7812897,118.6864305,9.4166716,12.1077509,1.091277,33.9505913),(50327,'femur tibia pelvis',255,8,179,58.6679222,81.6004277,124.8992753,1.8,81.5943716,124.8963005,-0.9774146,4.5360687,5.809905,253.7873335,440.6206682,6.7207167,75.8395646,55.9487409,118.2406218,9.3695159,12.1077509,1.091277,33.6988859),(50328,'femur tibia pelvis',255,8,180,58.2462903,81.6491886,124.9420876,1.8,81.6165802,124.9349242,-0.9710077,4.4874897,5.7964765,251.26819,437.7833812,6.6146024,75.5257747,55.9930399,117.6732716,9.3006609,12.0389346,0.9629943,33.6988859),(50329,'femur tibia pelvis',255,8,181,57.8550388,81.695013,124.9893009,1.8,81.6748997,124.9864736,-0.9645253,4.446652,5.778285,248.2477704,433.7416969,6.5117765,75.0640889,55.8280182,116.9021803,9.2843962,12.0389346,0.9629943,33.6988859),(50330,'femur tibia pelvis',255,8,182,57.6547973,81.73637,125.037779,1.8,81.7043412,125.0108231,-0.9574578,4.4763594,5.7566269,245.8766117,430.2905371,6.4254721,74.7469908,54.9278084,116.3890204,9.2843962,12.0389346,0.9629943,33.6988859),(50331,'femur tibia pelvis',255,8,183,57.2553212,81.7738213,125.0938035,1.8,81.7610724,125.1177852,-0.9530834,4.4355764,5.7291689,242.8804423,426.0723745,6.341595,74.3689668,54.7573579,115.7889873,9.2268396,11.9388329,1.0427219,33.4471805),(50332,'femur tibia pelvis',255,8,184,56.9046887,81.8124108,125.1431893,1.8,81.8070508,125.1718766,-0.9437185,4.4963407,5.704599,241.8291627,422.0380335,6.2186207,73.982068,53.7835498,115.4124399,9.3695159,11.9388329,1.0427219,33.4471805),(50333,'femur tibia pelvis',255,8,185,56.6236568,81.8545353,125.192687,1.8,81.8526074,125.2244863,-0.9362295,4.4685782,5.6840234,240.6577726,419.9209739,6.1205838,73.8774184,53.855558,115.3021164,9.3006609,11.9388329,1.0427219,33.4471805),(50334,'femur tibia pelvis',255,8,186,56.1556991,81.8895313,125.2441884,1.8,81.8949438,125.2844592,-0.9326136,4.3627928,5.6608759,238.0153306,415.3362631,6.0376518,73.3696112,54.5557262,114.03482,9.115059,11.7988288,0.9928944,33.1954751),(50335,'femur tibia pelvis',255,8,187,55.8692401,81.9191053,125.2936135,1.8,81.9251894,125.3037844,-0.9232804,4.4131496,5.6327097,236.5453703,410.789866,5.923455,72.929352,53.6001248,113.7008913,9.115059,11.7988288,0.9928944,33.1954751),(50336,'femur tibia pelvis',255,8,188,55.4442513,81.9500502,125.3386578,1.8,81.9637337,125.334307,-0.9151955,4.3837153,5.6101992,234.0142841,406.3615292,5.8063473,72.4326385,53.3826377,113.0972959,9.2843962,11.7988288,0.9928944,33.4471805),(50337,'femur tibia pelvis',255,8,189,55.0257527,81.9794629,125.3850147,1.8,81.9822669,125.3977821,-0.9095611,4.3615281,5.5877993,231.8089329,401.8450258,5.7125059,71.9147211,53.148559,112.5576732,9.1794877,11.7988288,0.9928944,33.4471805),(50338,'femur tibia pelvis',255,8,190,54.6386414,82.0067938,125.4296073,1.8,82.0106165,125.4415338,-0.9051645,4.2975205,5.5666839,229.3413626,397.5051407,5.6334651,71.4078882,53.3659731,111.8981413,9.115059,11.6887773,0.942,33.1954751),(50339,'femur tibia pelvis',255,8,191,54.14629,82.0303771,125.4796335,1.8,82.0258177,125.5013253,-0.8995369,4.3397656,5.5385601,227.2080511,393.2052549,5.5332995,70.9941296,52.3549132,111.345494,9.115059,11.6887773,0.942,33.1954751),(50340,'femur tibia pelvis',255,8,192,53.713804,82.0531533,125.5295966,1.8,82.0406683,125.5734979,-0.8958905,4.3192166,5.5115235,225.0083963,387.372849,5.4572797,70.2841687,52.0947239,110.4982193,9.115059,11.5697035,1.0240075,32.5878045),(50341,'femur tibia pelvis',255,8,193,53.1937578,82.0741926,125.5349332,1.8,82.0818525,125.5666942,-0.8935996,4.2731474,5.5192038,222.3193905,380.90381,5.3846171,69.0142676,52.0270824,108.7104217,9.0635002,11.5697035,1.0240075,32.5878045),(50342,'femur tibia pelvis',255,8,194,53.0364292,82.0884868,125.5830196,1.8,82.0951977,125.6062722,-0.8891703,4.3167548,5.4882751,221.2786887,376.5255982,5.3304154,68.6054524,51.2604252,108.3685284,9.115059,11.5697035,1.0240075,32.5878045),(50343,'femur tibia pelvis',255,8,195,52.6759496,82.109284,125.6297478,1.8,82.131941,125.6597526,-0.8867052,4.3716523,5.4638161,219.6876359,371.437191,5.2729968,67.9812766,50.2527701,107.6944579,9.115059,11.4413255,0.9723774,32.5878045),(50344,'femur tibia pelvis',255,8,196,52.2147059,82.127202,125.6773883,1.8,82.1313418,125.6958217,-0.8863783,4.3278667,5.4380614,218.4803209,366.2243079,5.2240384,67.3446442,50.4822201,107.1008987,9.115059,11.4413255,0.9723774,32.5878045),(50345,'femur tibia pelvis',255,8,197,51.8219437,82.1505495,125.7239105,1.8,82.2016428,125.7186654,-0.8881577,4.3415983,5.417542,217.0669743,359.8907113,5.1997938,66.4306274,49.9970188,106.1720582,9.115059,11.4413255,0.9723774,32.2318393),(50346,'femur tibia pelvis',255,8,198,51.6248913,82.1657111,125.7717242,1.8,82.2086739,125.7805262,-0.8865338,4.2996502,5.3893783,216.0493813,354.4225744,5.1663385,65.7631644,50.2481296,105.5727021,9.0635002,11.3440887,0.9197196,32.2318393),(50347,'femur tibia pelvis',255,8,199,51.478137,82.1808728,125.8168065,1.8,82.2108011,125.7996707,-0.8856016,4.320153,5.3691659,215.4620607,349.3511105,5.143816,65.0661792,49.8737111,105.071171,9.115059,11.3440887,0.9197196,32.2318393),(50348,'femur tibia pelvis',255,8,200,51.328865,82.1941274,125.8678457,1.8,82.2147062,125.8943085,-0.8833216,4.4298802,5.3318375,215.0464492,343.4478676,5.1097769,64.4145418,48.544529,104.5517687,9.1794877,11.2048922,1.0040671,31.8758741),(50349,'femur tibia pelvis',255,8,201,51.1587799,82.2090095,125.9128743,1.8,82.2451044,125.9181153,-0.8833656,4.3897677,5.3064936,213.3923289,338.7781264,5.0932134,63.8421809,48.6113037,103.563673,9.0351138,11.2048922,1.0040671,31.8758741),(50350,'femur tibia pelvis',255,8,202,50.9428727,82.220694,125.9587454,1.8,82.2604208,125.9709184,-0.8813695,4.4114411,5.2779505,212.2730996,333.2703197,5.0550876,63.1438888,48.1187655,103.2393422,9.0351138,11.0889478,0.9505468,31.6241687),(50351,'femur tibia pelvis',255,8,203,50.5541389,82.2333611,126.0015227,1.8,82.2630641,125.9905827,-0.8785876,4.3748807,5.252365,211.2769375,327.5204555,4.993492,62.3567584,48.2931888,102.4786809,9.115059,11.0889478,0.9505468,31.6241687),(50352,'femur tibia pelvis',255,8,204,50.218165,82.2498796,126.0494528,1.8,82.2656216,126.0458121,-0.8741048,4.3859013,5.2261897,210.2326903,322.2954925,4.9234062,61.6693064,47.9337484,101.0324375,9.115059,11.0889478,0.9505468,31.9801339),(50353,'femur tibia pelvis',255,8,205,50.0049992,82.2675647,126.0930946,1.8,82.2857987,126.0942943,-0.8678873,4.3409736,5.2017862,209.4746645,317.7269707,4.8514472,61.0803599,48.2552265,101.2702326,9.115059,11.0053826,0.8960554,31.9801339),(50354,'femur tibia pelvis',255,8,206,49.6520168,82.2786872,126.1322126,1.8,82.2786073,126.1555108,-0.862134,4.4902923,5.1780502,208.2518893,312.1988704,4.7701929,60.2927471,46.3782478,100.3947958,9.1794877,10.8448348,0.9827937,31.9801339),(50355,'femur tibia pelvis',255,8,207,49.2866137,82.2861183,126.1745541,1.8,82.2869261,126.2322897,-0.8559249,4.4626544,5.1495878,206.5481508,307.6452352,4.6846362,59.7417205,46.2836983,99.5755091,9.0351138,10.8448348,0.9827937,31.6241687),(50356,'femur tibia pelvis',255,8,208,48.8531766,82.2930742,126.2122876,1.8,82.3154644,126.2644902,-0.8491037,4.4771003,5.1243632,205.4248632,302.6944461,4.5883986,59.0696705,45.8834628,98.1414053,9.115059,10.8448348,0.9827937,31.3724633),(50357,'femur tibia pelvis',255,8,209,48.2437239,82.2967377,126.2393884,1.8,82.3104948,126.3159311,-0.8453211,4.4571824,5.1057001,203.5331416,296.0158159,4.5009758,57.9775174,45.6640813,97.3233057,9.115059,10.7422,0.6435011,31.3724633),(50358,'femur tibia pelvis',255,8,210,47.8504582,82.3007225,126.2760845,1.8,82.2998749,126.3237726,-0.8415064,4.4304374,5.0801735,202.6186013,291.8391002,4.4340674,57.4466803,45.7333181,96.686733,9.115059,10.7422,0.9272952,31.3724633),(50359,'femur tibia pelvis',255,8,211,47.4327428,82.3049829,126.3137314,1.8,82.3205919,126.3451005,-0.8365024,4.4337582,5.0540327,201.5020524,287.6945175,4.3560275,56.9237552,45.4472351,95.8853338,9.115059,10.7422,0.9272952,31.3724633),(50360,'femur tibia pelvis',255,8,212,46.9426294,82.3058439,126.3496718,1.8,82.3185218,126.3666169,-0.8318835,4.4065157,5.0553322,200.0460069,283.4261232,4.2750524,56.0647872,45.3977749,94.449081,9.115059,10.7679504,1.0714496,31.3724633),(50361,'femur tibia pelvis',255,8,213,46.4519565,82.3023874,126.3867278,1.8,82.2990388,126.4316729,-0.8268689,4.3811218,5.0216515,199.0080151,278.2849912,4.1916942,55.4170261,45.4239862,93.856184,9.1109232,10.6125107,1.0164888,31.1207579),(50362,'femur tibia pelvis',255,8,214,46.1472581,82.2997645,126.423043,1.8,82.3084937,126.4575185,-0.8220257,4.3553275,4.9893188,198.6999404,275.0582016,4.1270631,55.12941,45.6222732,93.7451662,9.1109232,10.6125107,1.0164888,31.1207579),(50363,'femur tibia pelvis',255,8,215,45.7527615,82.2970656,126.4620811,1.8,82.3218212,126.5294026,-0.8109915,4.6032876,4.9499835,197.7920181,270.7626631,4.007806,54.6997099,42.9675561,93.3420652,9.2257488,10.6125107,1.0164888,31.3724633),(50364,'femur tibia pelvis',255,8,216,45.3964222,82.2883931,126.4964108,1.8,82.3296032,126.5598197,-0.8020185,4.5871144,4.911596,196.7057516,267.203677,3.9087628,54.402617,42.882242,91.8557494,9.0351138,10.6125107,1.0164888,31.3724633),(50365,'femur tibia pelvis',255,8,217,45.0692882,82.283145,126.5365081,1.8,82.3314991,126.6139501,-0.7846937,4.5641211,4.865184,195.8556047,263.8222543,3.7504823,54.2265726,42.9120091,92.8577019,9.115059,10.4900209,0.9600704,30.7647927),(50366,'femur tibia pelvis',255,8,218,44.874138,82.2761461,126.5724073,1.8,82.3342925,126.6306883,-0.7686878,4.5523222,4.8825177,196.018726,260.7523547,3.6145574,53.4053067,43.0590626,91.8058134,9.115059,10.4900209,0.9600704,30.7647927),(50367,'femur tibia pelvis',255,8,219,44.5373809,82.2698884,126.608406,1.8,82.3270436,126.6755541,-0.7465633,4.563788,4.8374716,195.9189476,257.3895082,3.4234712,53.2074457,42.9290199,91.1230287,9.115059,10.3927662,1.0516502,30.5130873),(50368,'femur tibia pelvis',255,8,220,44.4335954,82.2614682,126.6458531,1.8,82.2970566,126.6977565,-0.7268409,4.5598759,4.8558973,196.0945531,255.3827873,3.2701387,52.5922962,43.004362,89.8443614,9.115059,10.3927662,0.5191461,30.5130873),(50369,'femur tibia pelvis',255,8,221,44.3335026,82.2566444,126.6807297,1.8,82.280556,126.7227397,-0.7083171,4.551683,5.0386114,196.5184805,253.7195991,3.1271665,50.3550637,43.1749047,89.1869204,9.115059,10.4016451,0.9025069,30.7647927),(50370,'femur tibia pelvis',255,8,222,44.1949728,82.2459272,126.7162165,1.8,82.2650733,126.7520251,-0.6817212,4.5492035,5.0607423,196.3044185,252.1855577,2.9247086,49.831733,43.1513823,88.5656986,9.115059,10.4016451,0.6682894,30.7647927),(50371,'femur tibia pelvis',255,8,223,43.9586442,82.236347,126.750023,1.8,82.2609859,126.7851854,-0.6534534,4.7245316,5.0356348,196.2940622,250.3159157,2.7077153,49.7089095,41.5478353,88.6841456,9.2257488,10.4016451,0.6682894,31.0164981),(50372,'femur tibia pelvis',255,8,224,43.6936136,82.2260666,126.7846424,1.8,82.2574913,126.8557261,-0.6150807,4.6794147,5.0057571,195.8341834,248.365008,2.4246841,49.6158725,41.8501446,88.7148664,9.023448,10.4016451,0.6682894,30.6605329),(50373,'femur tibia pelvis',255,8,225,43.4479415,82.1987191,126.7630007,1.8,82.2367774,126.7986547,-0.5881061,4.6916799,4.9901287,196.3402885,246.8146483,2.2287913,49.4605776,41.8486114,88.6652115,9.4188943,10.4016451,0.6682894,31.0164981),(50374,'femur tibia pelvis',255,8,226,43.3450512,82.1801772,126.7969552,1.8,82.2003976,126.8674883,-0.5571546,4.6441461,4.9453311,196.4490526,246.1605551,2.0198876,49.7763551,42.3003601,89.184133,9.023448,10.3482574,0.7266423,30.6605329),(50375,'femur tibia pelvis',255,8,227,43.2477559,82.1663509,126.8346083,1.8,82.2000345,126.9391971,-0.5215217,4.7373322,5.0550876,197.3250173,245.8023983,1.7890394,48.624755,41.653194,87.6590332,9.023448,10.3927662,0.5191461,30.4088275),(50376,'femur tibia pelvis',255,8,228,43.067656,82.1568741,126.8564465,1.8,82.2128394,126.9410861,-0.4866816,4.6974218,5.0341114,197.7982472,245.2054138,1.5700955,48.7087777,42.1078316,87.9655479,9.023448,10.3927662,0.5191461,30.4088275),(50377,'femur tibia pelvis',255,8,229,42.7880787,82.1420887,126.8793962,1.8,82.1988343,126.9427979,-0.451775,4.6517662,5.0027799,198.4204849,245.2867449,1.3591448,49.030089,42.6548705,88.5298342,9.023448,10.3927662,0.5191461,30.7647927),(50378,'femur tibia pelvis',255,8,230,42.5271884,82.127847,126.9033976,1.8,82.1601757,126.9722055,-0.4083198,4.6404185,4.9622903,198.5136513,245.3492146,1.1174929,49.4427366,42.779256,88.989837,9.023448,10.3927662,0.5191461,30.7647927),(50379,'femur tibia pelvis',255,8,231,42.2059291,82.1119184,126.9238461,1.8,82.1406105,126.9891442,-0.3675675,4.6121787,4.9154348,198.2216105,244.6022539,0.9083412,49.7620783,42.9778687,89.2084279,9.023448,10.2496576,0.5763752,30.7647927),(50380,'femur tibia pelvis',255,8,232,42.039201,82.0915978,126.9390161,1.8,82.1112164,126.9920079,-0.3271253,4.5810941,4.9900797,198.1130491,244.7835633,0.7234099,49.0540391,43.2457932,88.7468348,9.023448,10.2496576,0.5763752,30.7647927),(50381,'femur tibia pelvis',255,8,233,41.8725848,82.0749621,126.9532408,1.8,82.0970366,126.9927754,-0.2834353,4.5545283,4.9683993,197.9588461,245.1602638,0.5457896,49.3439129,43.4641822,89.1523137,9.023448,10.2496576,0.5763752,30.7647927),(50382,'femur tibia pelvis',255,8,234,41.6388298,82.0568851,126.9786307,1.8,82.0972635,127.014308,-0.2416925,4.5886966,4.9346171,198.2733424,244.8347,0.397558,49.6157439,43.2090764,89.5999309,9.023448,10.2496576,0.5763752,30.7647927),(50383,'femur tibia pelvis',255,8,235,41.5630748,82.0409859,126.9958422,1.8,82.0862322,127.0281887,-0.2082081,4.5195622,4.9018073,198.5216249,245.6863137,0.2959831,50.1215777,43.9249683,90.1935205,9.023448,10.2496576,0.5763752,30.7647927),(50384,'femur tibia pelvis',255,8,236,41.4576669,82.0239257,127.00727,1.8,82.0594217,127.0326185,-0.1654237,4.547231,4.8581697,198.9436879,246.4140779,0.187363,50.7215872,43.7505125,90.7902057,9.023448,10.2496576,0.5763752,31.0164981),(50385,'femur tibia pelvis',255,8,237,41.3445939,82.0134763,127.0221873,1.8,82.0396281,127.0472915,-0.1308835,4.5707446,4.819527,199.3774183,246.9754261,0.1173696,51.244744,43.6203371,91.2614411,9.023448,10.2135672,0.3883187,30.7647927),(50386,'femur tibia pelvis',255,8,238,41.3975776,81.9989073,127.0382959,1.8,82.0142556,127.0484877,-0.1023428,4.5898598,4.8215633,200.0110725,248.4364833,0.0720147,51.5261271,43.5767286,89.4048256,9.023448,10.3838797,0.4266275,30.7647927),(50387,'femur tibia pelvis',255,8,239,41.394948,81.9839017,127.0544844,1.8,82.0079747,127.0529879,-0.0694798,4.6061467,4.8220474,200.5665755,249.5993112,0.0332517,51.7621021,43.5432451,90.1057164,9.023448,10.3838797,0.4266275,30.7647927),(50388,'femur tibia pelvis',255,8,240,41.3645118,81.9681779,127.0645468,1.8,81.9942918,127.0538309,-0.0460103,4.6136561,4.8180259,201.4160791,250.1951855,0.0145841,51.9289832,43.6564999,90.727944,9.023448,10.3838797,0.4266275,30.7647927),(50389,'femur tibia pelvis',255,8,241,41.0660797,81.9573694,127.036509,1.8,81.976837,127.0423667,-0.0154536,4.5797758,4.8366932,201.1923283,250.6695974,0.0016344,51.8266484,43.9306065,90.7705684,9.023448,10.3838797,0.4266275,30.7647927),(50390,'femur tibia pelvis',255,8,242,41.0965719,81.9408141,127.0409704,1.8,81.9709659,127.030505,0.0128816,4.5811798,4.8631833,202.3053411,252.00764,0.0011365,51.8194824,44.1600966,91.5760072,9.023448,10.3838797,0.4266275,30.7647927),(50391,'femur tibia pelvis',255,8,243,41.1489961,81.9232904,127.0501656,1.8,81.9827663,127.0683578,0.0392698,4.5913234,4.8921951,203.7370282,252.9611865,0.0105707,51.7070925,44.3743583,92.4237126,9.3013377,10.3838797,0.4266275,31.1207579),(50392,'femur tibia pelvis',255,8,244,41.1956576,81.8944646,127.0645056,1.8,81.9666481,127.0912123,0.063869,4.6052692,4.9278002,204.1536536,253.8764802,0.0279699,51.5192312,44.3304493,92.839251,9.3013377,10.3838797,0.4266275,31.1207579),(50393,'femur tibia pelvis',255,8,245,41.3457129,81.8709164,127.0767479,1.8,81.9360549,127.1174455,0.0889698,4.5769585,4.9546086,205.3089024,255.2742076,0.0544024,51.5225778,44.8570605,92.3723876,9.2542917,10.3838797,0.4266275,31.4767231),(50394,'femur tibia pelvis',255,8,246,41.5417023,81.8532376,127.0863187,1.8,81.9059743,127.1180337,0.1155836,4.5698686,4.9719924,207.1321537,256.3590723,0.0920853,51.5606325,45.3256259,93.2169889,9.2706297,10.3927662,3.0172377,31.4767231),(50395,'femur tibia pelvis',255,8,247,41.6871698,81.8282346,127.0899611,1.8,81.8525883,127.1055193,0.1421526,4.5556251,4.9115519,208.3795069,257.3348188,0.1394548,52.3937903,45.7411449,94.2302772,9.2706297,10.2135672,2.7532739,31.3724633),(50396,'femur tibia pelvis',255,8,248,41.8230699,81.798505,127.0944454,1.8,81.8221959,127.088129,0.1728012,4.5372307,4.8694665,209.8176943,258.6912584,0.2060777,53.1251751,46.2435589,94.1466285,9.2706297,10.3304002,0.2954408,31.3724633),(50397,'femur tibia pelvis',255,8,249,41.8407498,81.7796509,127.1042784,1.8,81.7936796,127.111752,0.1948751,4.5284082,4.9236731,211.3025833,260.4088456,0.2614907,52.8891419,46.6615584,95.1800368,9.3562957,10.3304002,2.8461518,31.3724633),(50398,'femur tibia pelvis',255,8,250,41.9904694,81.7516033,127.1012882,1.8,81.7605258,127.1070095,0.2206721,4.503415,4.8988696,213.317487,261.6198057,0.3352997,53.4041172,47.3679385,95.7136884,9.3562957,10.3304002,2.8461518,31.6241687),(50399,'femur tibia pelvis',255,8,251,42.1123823,81.7313299,127.106688,1.8,81.7441209,127.1049273,0.247294,4.4862033,4.9354602,214.8000247,262.6685085,0.4205471,53.2206721,47.8801359,95.9487058,9.3562957,10.3304002,2.8461518,31.6241687),(50400,'femur tibia pelvis',255,8,252,42.0218009,81.7151478,127.1145509,1.8,81.7443981,127.1196813,0.2665562,4.5077476,4.9598365,216.6842951,263.223716,0.4859491,53.0710466,48.0693055,96.2551685,9.3802393,10.3304002,2.8461518,31.6241687),(50401,'femur tibia pelvis',255,8,253,42.2689277,81.6958158,127.1183635,1.8,81.7332141,127.1244242,0.2813744,4.5233019,4.9842605,218.585323,265.0076345,0.5431846,53.1688974,48.3242832,96.6804543,9.3802393,10.3304002,2.8461518,31.6241687),(50402,'femur tibia pelvis',255,8,254,42.3401508,81.6739322,127.1240127,1.8,81.7199037,127.1282602,0.2822601,4.5351968,5.0040752,219.6331274,266.8752227,0.547439,53.331577,48.4285774,96.9061437,9.3802393,10.3304002,2.8461518,31.6241687),(50403,'femur tibia pelvis',255,8,255,42.3121204,81.6529977,127.1253126,1.8,81.6874252,127.1140873,0.3028499,4.5507738,5.0309393,220.6434159,269.2081652,0.6272637,53.5105172,48.4848124,97.201947,9.3802393,10.4635866,2.8068558,31.3724633),(50404,'femur tibia pelvis',255,8,256,42.4131084,81.6302282,127.1274602,1.8,81.652209,127.131352,0.3221673,4.566239,5.0565983,221.6848156,271.1545713,0.7086538,53.6239094,48.5486673,97.3976371,9.453136,10.4635866,2.8068558,31.3724633),(50405,'femur tibia pelvis',255,8,257,42.3626983,81.6080419,127.0641957,1.8,81.662433,127.0882255,0.3387777,4.5182773,5.1009661,221.7578287,271.942528,0.7798,53.3119651,49.0801722,96.740523,9.453136,10.4635866,2.8068558,31.6241687),(50406,'femur tibia pelvis',255,8,258,41.9577392,81.5710867,127.0727447,1.8,81.6227226,127.0830381,0.3595179,4.5438036,5.1346857,222.2190448,271.4780827,0.8655842,52.8714118,48.9059532,96.1479,9.453136,10.4900209,2.5308667,31.6241687),(50407,'femur tibia pelvis',255,8,259,41.6557824,81.5369528,127.0779826,1.8,81.6067078,127.0765413,0.3917097,4.565847,5.1625079,222.2774649,271.8712957,1.0118727,52.6626399,48.6826358,95.676102,9.453136,10.4900209,2.1815223,31.6241687),(50408,'femur tibia pelvis',255,8,260,41.5823213,81.516983,127.0836425,1.8,81.5946017,127.0864126,0.4115661,4.5798292,5.1744676,223.2784315,274.0992728,1.1091122,52.9714924,48.7525679,95.9911353,9.5130859,10.6125107,2.7686049,31.9801339),(50409,'femur tibia pelvis',255,8,261,41.7952633,81.4855702,127.0912066,1.8,81.5986372,127.1068046,0.4305795,4.5992013,5.1937914,224.938698,276.4994027,1.2135996,53.2365247,48.908209,96.2772519,9.6092004,10.6125107,2.7686049,31.9801339),(50410,'femur tibia pelvis',255,8,262,41.6335147,81.4746903,127.1012026,1.8,81.588239,127.1089265,0.4408851,4.6121208,5.1950898,226.3391641,277.7410019,1.2636266,53.4622141,49.0748558,96.659623,9.6092004,10.6125107,2.5872852,31.9801339),(50411,'femur tibia pelvis',255,8,263,42.3979462,81.4810984,127.1187377,1.8,81.625038,127.1636022,0.4640753,4.6023178,5.1699675,229.3395426,282.7546565,1.4156835,54.6917669,49.8313137,98.4240048,9.6092004,10.6125107,2.5872852,31.9801339),(50412,'femur tibia pelvis',255,8,264,42.353075,81.4590922,127.1358767,1.8,81.5855784,127.1605974,0.4843476,4.5840849,5.1879478,232.0045891,284.7327497,1.5304445,54.8835028,50.610884,99.0341083,9.6092004,10.6298941,2.896614,32.3360991),(50413,'femur tibia pelvis',255,8,265,42.291643,81.4350763,127.1363046,1.8,81.5114984,127.1960527,0.4925146,4.602349,5.210711,235.9419063,289.502822,1.5759318,55.5591783,51.2655396,100.2714213,9.6102913,10.6298941,2.896614,32.5878045),(50414,'femur tibia pelvis',255,8,266,42.6950914,81.4191396,127.1368472,1.8,81.4669721,127.1814056,0.5025714,4.6060129,5.2260425,240.2952972,295.7659488,1.6509916,56.5946313,52.1699146,102.0088941,9.6102913,10.7765202,2.7314653,32.8395099),(50415,'femur tibia pelvis',255,8,267,42.5064313,81.3864845,127.1327832,1.8,81.425876,127.1761198,0.5064497,4.5981055,5.2570247,243.1570271,299.6197375,1.6669492,56.9941659,52.8820029,102.6593077,9.6102913,10.7765202,2.7314653,32.8395099),(50416,'femur tibia pelvis',255,8,268,42.9707523,81.3630106,127.1347741,1.8,81.4101309,127.1856164,0.5116293,4.7547497,5.2769386,249.1267234,306.3995258,1.71673,58.0638789,52.3953387,104.6460678,9.882824,10.8703421,2.8198421,32.8395099),(50417,'femur tibia pelvis',255,8,269,43.783188,81.3630979,127.1455218,1.8,81.4031045,127.1826977,0.5047894,4.7421187,5.271169,255.022073,314.430613,1.7067514,59.6510212,53.7780875,107.3434268,9.882824,10.8703421,2.8198421,32.8395099),(50418,'femur tibia pelvis',255,8,270,43.9723517,81.3317481,127.1404714,1.8,81.3929365,127.1768321,0.5037663,4.7308951,5.3009765,259.4369044,319.9311069,1.7077813,60.3532405,54.8388618,108.5728854,9.882824,10.980189,2.6078845,32.8395099),(50419,'femur tibia pelvis',255,8,271,44.3994106,81.2928616,127.1230618,1.8,81.3455514,127.1460341,0.5105317,4.775212,5.3438028,265.8365594,327.5820863,1.7668761,61.3013051,55.6701066,110.3281242,9.9948339,11.0137676,2.782822,33.6988859),(50420,'femur tibia pelvis',255,8,272,44.9052457,81.269552,127.1063392,1.8,81.2755326,127.138324,0.4976042,4.9332894,5.3713543,274.3732401,334.3467666,1.7051715,62.2462697,55.6166927,112.5963941,10.1854688,11.0889478,2.5213432,34.0548511),(50421,'femur tibia pelvis',255,8,273,44.5083993,81.2073229,127.0541024,1.8,81.2297141,127.1101173,0.4775693,4.933867,5.4473732,279.9388159,338.3312262,1.5670828,62.1090601,56.7382164,112.7744798,10.1854688,11.171888,2.7468015,34.0548511),(50422,'femur tibia pelvis',255,8,274,44.6796033,81.1662105,127.0474552,1.8,81.2340839,127.0954403,0.4700444,4.9147935,5.6735922,287.0470122,345.1268891,1.5276097,60.830401,58.4046938,111.2522861,10.1876506,11.417094,2.7960371,34.4108163),(50423,'femur tibia pelvis',255,8,275,44.7639744,81.1189929,127.029944,1.8,81.1939165,127.0840545,0.4429467,5.0902305,5.7302176,294.9364108,352.9327677,1.3705315,61.5915125,57.9416609,112.3143333,10.312512,11.5697035,2.7610863,34.9142271),(50424,'femur tibia pelvis',255,8,276,45.2447444,81.0560468,127.0008229,1.8,81.1631904,127.069816,0.4191703,5.124483,5.8018901,303.6036551,362.9117277,1.2491409,62.5506041,59.2457145,114.217785,10.312512,11.5697035,2.5948038,34.9142271),(50425,'femur tibia pelvis',255,8,277,45.7331234,81.0012783,126.984154,1.8,81.0788203,127.0658741,0.4045565,5.2384389,5.8585969,312.9728948,373.3395043,1.180903,63.7250716,59.7454513,116.4751326,10.312512,11.7988288,2.9584818,35.2701923),(50426,'femur tibia pelvis',255,8,278,46.7948121,80.9429663,126.9490461,1.8,81.0517,127.0562838,0.3756106,5.3088148,6.0063004,325.6451443,387.0992179,1.0495454,64.4488611,61.3404602,117.8078704,10.7628281,11.9851376,2.8879186,36.2338281),(50427,'femur tibia pelvis',255,8,279,47.4913774,80.8939647,126.9224981,1.8,80.9734203,127.0535257,0.323274,5.3169962,6.0909692,335.9839323,399.3688892,0.7987726,65.567379,63.1905535,120.4669149,10.8718778,12.1001239,2.8535372,36.4855335),(50428,'femur tibia pelvis',255,8,280,48.2450667,80.8240345,126.8941854,1.8,80.9351528,127.0289564,0.3323765,5.3344622,6.1624031,346.8070894,411.2969676,0.8560718,66.7429508,65.0125684,122.689803,10.9380707,12.2291349,2.8198421,36.4855335),(50429,'femur tibia pelvis',255,8,281,50.0344284,80.7800736,126.8617681,1.8,80.8712602,127.0197514,0.3068909,5.4650365,6.2236458,364.1872906,427.3383445,0.7610415,68.6636678,66.6394987,127.0535144,11.1445618,12.3717316,2.786887,36.9889443),(50430,'femur tibia pelvis',255,8,282,52.1791782,80.7127866,126.7995332,1.8,80.8100935,127.002719,0.3164501,5.6416844,6.3040152,383.6673742,443.4153991,0.8421914,70.3385672,68.0058199,131.0515751,11.171888,12.4015431,2.896614,37.5966149),(50431,'femur tibia pelvis',255,8,283,54.4871874,80.6932354,126.7842578,1.8,80.7457888,126.972804,0.3356518,5.6638592,6.4621275,403.8181391,466.3513548,0.9852576,72.1668453,71.2973472,134.6567394,11.171888,12.695808,2.7233683,38.1000257),(50432,'femur tibia pelvis',255,8,284,58.8205511,80.6239812,126.7620667,1.8,80.6930519,126.9139426,0.3188415,5.7859989,6.534048,432.9400602,498.6140004,0.9632976,76.3101222,74.8254659,142.5521034,11.601576,12.8763091,2.6928693,38.4559909),(50433,'femur tibia pelvis',255,8,285,63.0328412,80.5682506,126.797532,1.8,80.6710382,126.8855687,0.256428,5.7468929,6.6486217,457.5442627,538.7282335,0.6757818,81.0285588,79.6159363,148.5047319,11.601576,12.9263977,2.767259,39.0636615),(50434,'femur tibia pelvis',255,8,286,67.8004253,80.5072319,126.818119,1.8,80.5908419,126.9004838,0.176883,5.6937677,6.8308291,478.5958324,586.5776718,0.34988,85.8721045,84.0560865,155.9349441,11.601576,13.145925,0.1973956,39.6713321),(50435,'femur tibia pelvis',255,8,287,70.6617143,80.4529661,126.8600553,1.8,80.4898677,126.8605925,0.1960042,5.9808584,6.8751632,490.8483699,627.2398337,0.4466786,91.232719,82.0698868,162.5858648,11.8423016,13.4924769,0.1599131,40.6349679),(50436,'femur tibia pelvis',255,8,288,74.4819696,80.473862,126.8869454,1.8,80.4453227,126.8234612,0.2134528,5.9792797,6.9363185,517.0345376,698.9459383,0.5570547,100.7661256,86.4710406,175.2786742,12.031264,13.8703393,0.282555,41.1383787),(50437,'femur tibia pelvis',255,8,289,78.7091981,80.4757656,126.7983334,1.8,80.3998863,126.7830147,0.2067947,5.9014939,7.1957581,568.5266378,797.0528691,0.5530361,110.7670463,96.3360544,188.9515184,12.031264,14.4121737,0.1798535,42.9613905),(50438,'femur tibia pelvis',255,8,290,81.7453278,80.384734,126.7113212,1.8,80.3522638,126.6904984,0.2334752,6.0185959,7.5031466,598.2907379,870.0772503,0.7292684,115.9616494,99.4070297,188.2310603,12.370959,14.9467204,0.3217506,43.8207665),(50439,'femur tibia pelvis',255,8,291,84.8874809,80.4247792,126.6104466,1.8,80.4204296,126.5804418,0.1931334,6.0842086,8.1431147,607.5059789,946.1673863,0.5211953,116.1923194,99.849631,180.7276504,12.3009983,15.6408793,0.2782997,46.1471891),(50440,'femur tibia pelvis',255,8,292,87.9491793,80.640203,126.489809,1.8,80.4399006,126.4015208,0.0991777,6.0331521,8.1633146,599.1026058,1042.1172936,0.1437091,127.6585975,99.3017573,196.1369251,12.2975897,16.1061369,2.9808299,46.6505999),(50441,'femur tibia pelvis',255,8,293,90.3297543,80.6078156,126.2294167,1.8,80.3557876,126.2999409,0.1327858,6.2083533,8.1066249,609.6139901,1176.9176675,0.2638937,145.1797369,98.192541,212.1236409,12.1742664,15.9216654,0.0540015,46.3988945),(50442,'femur tibia pelvis',255,8,294,81.2821818,80.4773033,126.1013169,1.8,80.2669374,126.1570063,0.0670528,5.9809963,7.9491967,561.8804954,1091.267237,0.0608173,137.2801904,93.944298,202.2031085,11.8695,15.6172526,0.138006,45.1835533),(50443,'femur tibia pelvis',255,8,295,79.7755865,80.3988027,125.9781108,1.8,80.2845369,126.0227858,0.0848957,5.709193,7.7256782,464.2763775,1087.9929633,0.0955976,140.8281484,81.3208417,198.8020622,11.2929635,15.4926212,2.8023,44.5758827),(50444,'femur tibia pelvis',255,8,296,85.4329279,80.5099433,125.7506316,1.8,80.4617208,125.8245856,0.106739,5.5655491,7.7470973,444.0688478,1219.8741102,0.1616108,157.4620868,79.788866,201.6426011,10.9315894,16.1061369,0.1607627,45.4352587),(50445,'femur tibia pelvis',255,8,297,72.6468976,80.2255063,125.2578295,1.8,80.18285,125.4809059,0.0587382,5.502008,8.3135395,350.3039408,1070.6718228,0.041726,128.7865196,63.6683812,170.8821132,10.5217887,16.1061369,0.1607627,43.9682121),(50446,'femur tibia pelvis',255,8,298,46.5023106,79.6000764,124.4283894,1.8,79.7588062,124.9580542,0.0054147,5.7768802,8.9188282,166.3388046,798.6545949,0.0002272,89.5470316,28.7938816,107.9827561,10.1994241,16.6028685,0.1821683,57.840376),(50447,'femur tibia pelvis',255,8,299,28.0161378,78.4371819,124.1097682,1.8,78.918473,124.2225339,-0.1245386,3.9569059,9.3525634,73.8341073,400.6938436,0.0720475,42.8432105,18.6595561,50.6680392,5.5009504,9.8921606,0.6000502,25.8602421),(50448,'femur tibia pelvis',255,8,300,15.3663433,76.658225,124.310136,1.8,76.8809165,124.4290985,-0.7620207,5.4363257,6.1671398,15.0290328,80.9024748,1.2206794,13.1183138,2.7645571,11.9766023,4.4128882,9.7417008,0.7229794,23.6380793),(50449,'femur tibia pelvis',255,8,301,7.1901209,77.0788258,123.9055428,1.8,76.7629655,124.2275751,-0.8857329,1.5852097,4.5488976,2.6779672,23.4274007,0.7186079,5.1501271,1.6893458,5.7189092,3.6039272,8.2540369,0.8960554,19.4886449),(50450,'femur tibia pelvis',255,8,302,0.9849826,77.5944771,123.3027608,1.8,77.558684,123.320456,-0.976978,1.0348059,1.4637176,0.2240441,0.4706091,0.1127684,0.3215163,0.2165083,0.4715111,2.4989812,3.4642554,1.0516502,8.654834),(50451,'femur tibia pelvis',255,8,303,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50452,'femur tibia pelvis',255,8,304,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50453,'femur tibia pelvis',255,8,305,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50454,'femur tibia pelvis',255,8,306,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50455,'femur tibia pelvis',255,8,307,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50456,'femur tibia pelvis',255,8,308,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50457,'femur tibia pelvis',255,8,309,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50458,'femur tibia pelvis',255,8,310,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50459,'femur tibia pelvis',255,8,311,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50460,'femur tibia pelvis',255,8,312,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50461,'femur tibia pelvis',255,8,313,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50462,'femur tibia pelvis',255,8,314,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50463,'femur tibia pelvis',255,8,315,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50464,'femur tibia pelvis',255,8,316,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50465,'femur tibia pelvis',255,8,317,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50466,'femur tibia pelvis',255,8,318,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50467,'femur tibia pelvis',255,8,319,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50468,'femur tibia pelvis',255,8,320,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50469,'femur tibia pelvis',255,8,321,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50470,'femur tibia pelvis',255,8,322,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50471,'femur tibia pelvis',255,8,323,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50472,'femur tibia pelvis',255,8,324,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50473,'femur tibia pelvis',255,8,325,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50474,'femur tibia pelvis',255,8,326,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50475,'femur tibia pelvis',255,8,327,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50476,'femur tibia pelvis',255,8,328,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50477,'femur tibia pelvis',255,8,329,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50478,'femur tibia pelvis',255,8,330,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50479,'femur tibia pelvis',255,8,331,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50480,'femur tibia pelvis',255,8,332,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50481,'femur tibia pelvis',255,8,333,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50482,'femur tibia pelvis',255,8,334,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50483,'femur tibia pelvis',255,8,335,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50484,'femur tibia pelvis',255,8,336,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50485,'femur tibia pelvis',255,8,337,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50486,'femur tibia pelvis',255,8,338,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50487,'femur tibia pelvis',255,8,339,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50488,'femur tibia pelvis',255,8,340,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50489,'femur tibia pelvis',255,8,341,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50490,'femur tibia pelvis',255,8,342,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50491,'femur tibia pelvis',255,8,343,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50492,'femur tibia pelvis',255,8,344,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50493,'femur tibia pelvis',255,8,345,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50494,'femur tibia pelvis',255,8,346,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50495,'femur tibia pelvis',255,8,347,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50496,'femur tibia pelvis',255,8,348,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50497,'femur tibia pelvis',255,8,349,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50498,'femur tibia pelvis',255,8,350,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50499,'femur tibia pelvis',255,8,351,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50500,'femur tibia pelvis',255,8,352,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50501,'femur tibia pelvis',255,8,353,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50502,'femur tibia pelvis',255,8,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50503,'femur tibia pelvis',255,8,355,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50504,'femur tibia pelvis',255,8,356,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50505,'femur tibia pelvis',255,8,357,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50506,'femur tibia pelvis',255,8,358,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50507,'femur tibia pelvis',255,8,359,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50508,'femur tibia pelvis',255,8,360,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50509,'femur tibia pelvis',255,8,361,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50510,'femur tibia pelvis',255,8,362,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50511,'femur tibia pelvis',255,8,363,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50512,'femur tibia pelvis',255,8,364,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50513,'femur tibia pelvis',255,8,365,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50514,'femur tibia pelvis',255,8,366,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50515,'femur tibia pelvis',255,8,367,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50516,'femur tibia pelvis',255,8,368,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50517,'femur tibia pelvis',255,8,369,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50518,'femur tibia pelvis',255,8,370,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50519,'femur tibia pelvis',255,8,371,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50520,'femur tibia pelvis',255,8,372,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50521,'femur tibia pelvis',255,8,373,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50522,'femur tibia pelvis',255,8,374,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50523,'femur tibia pelvis',255,8,375,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50524,'femur tibia pelvis',255,8,376,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50525,'femur tibia pelvis',255,8,377,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50526,'femur tibia pelvis',255,8,378,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50527,'femur tibia pelvis',255,8,379,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50528,'femur tibia pelvis',255,8,380,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50529,'femur tibia pelvis',255,8,381,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50530,'femur tibia pelvis',255,8,382,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50531,'femur tibia pelvis',255,8,383,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50532,'femur tibia pelvis',255,8,384,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50533,'femur tibia pelvis',255,8,385,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50534,'femur tibia pelvis',255,8,386,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50535,'femur tibia pelvis',255,8,387,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50536,'femur tibia pelvis',255,8,388,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50537,'femur tibia pelvis',255,8,389,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50538,'femur tibia pelvis',255,8,390,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50539,'femur tibia pelvis',255,8,391,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50540,'femur tibia pelvis',255,8,392,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50541,'femur tibia pelvis',255,8,393,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50542,'femur tibia pelvis',255,8,394,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50543,'femur tibia pelvis',255,8,395,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50544,'femur tibia pelvis',255,8,396,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50545,'femur tibia pelvis',255,8,397,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50546,'femur tibia pelvis',255,8,398,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50547,'femur tibia pelvis',255,8,399,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50548,'femur tibia pelvis',255,8,400,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50549,'femur tibia pelvis',255,8,401,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50550,'femur tibia pelvis',255,8,402,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50551,'femur tibia pelvis',255,8,403,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50552,'femur tibia pelvis',255,8,404,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50553,'femur tibia pelvis',255,8,405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50554,'femur tibia pelvis',255,8,406,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50555,'femur tibia pelvis',255,8,407,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50556,'femur tibia pelvis',255,8,408,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50557,'femur tibia pelvis',255,8,409,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50558,'femur tibia pelvis',255,8,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50559,'femur tibia pelvis',255,8,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50560,'femur tibia pelvis',255,8,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50561,'femur tibia pelvis',255,8,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50562,'femur tibia pelvis',255,8,414,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50563,'femur tibia pelvis',255,8,415,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50564,'femur tibia pelvis',255,8,416,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50565,'femur tibia pelvis',255,8,417,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50566,'femur tibia pelvis',255,8,418,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50567,'femur tibia pelvis',255,8,419,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50568,'femur tibia pelvis',255,8,420,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50569,'femur tibia pelvis',255,8,421,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50570,'femur tibia pelvis',255,8,422,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50571,'femur tibia pelvis',255,8,423,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50572,'femur tibia pelvis',255,8,424,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50573,'femur tibia pelvis',255,8,425,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50574,'femur tibia pelvis',255,8,426,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50575,'femur tibia pelvis',255,8,427,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50576,'femur tibia pelvis',255,8,428,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50577,'femur tibia pelvis',255,8,429,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50578,'femur tibia pelvis',255,8,430,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50579,'femur tibia pelvis',255,8,431,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50580,'femur tibia pelvis',255,8,432,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50581,'femur tibia pelvis',255,8,433,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50582,'femur tibia pelvis',255,8,434,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50583,'femur tibia pelvis',255,8,435,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50584,'femur tibia pelvis',255,8,436,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50585,'femur tibia pelvis',255,8,437,0.0455985,88.945416,125.9175641,1.8,88.945416,125.898584,1.4421924,0.0575416,0.4449629,0.0007893,0.0059483,0.0074747,0.0133682,0.0137174,0.015017,8.164072,23.2667224,3.0676536,54.4281697),(50586,'femur tibia pelvis',255,8,438,1.3813254,88.7246111,126.0610506,1.8,88.6016656,126.0188966,-1.5647229,0.6447654,2.312205,0.1385885,1.1929416,0.2302124,0.5159324,0.2149441,0.5735815,8.164072,24.552449,3.0715321,57.2580031),(50587,'femur tibia pelvis',255,8,439,4.645895,88.2802995,126.0537132,1.8,88.08604,126.0223924,-1.4866479,1.5272283,2.7794883,1.6634981,6.3572916,0.7688459,2.2872165,1.0892269,2.8513104,8.164072,25.8385082,3.0750245,59.5844257),(50588,'femur tibia pelvis',255,8,440,9.2113913,87.6988617,126.1906635,1.8,87.4455617,126.2228768,-1.3180947,2.3018231,3.5067568,7.733481,18.2856706,1.439264,5.2144108,3.35972,7.3761027,8.164072,27.9825547,0.061461,63.3778949),(50589,'femur tibia pelvis',255,8,441,13.5907451,87.195121,126.2911623,1.8,86.98154,126.23599,-1.2319836,3.0571836,4.1940832,19.0649899,34.3140191,2.0149,8.1815305,6.2361286,12.6758949,8.59376,29.2692919,0.0587558,66.6679533),(50590,'femur tibia pelvis',255,8,442,19.5776263,86.3675532,126.4249766,1.8,86.0502737,126.307265,-0.4095142,4.0909747,4.2455012,50.2158754,64.5304995,0.5172877,15.1997366,12.274795,24.2674379,8.59376,31.4407146,0.0683863,72.4318799),(50591,'femur tibia pelvis',255,8,443,27.0793833,85.5434881,126.5241836,1.8,85.4777585,126.3840561,-0.044855,3.9835434,4.8063712,76.9267704,129.7084337,0.0090744,26.98677,19.3111417,38.9933802,8.59376,33.1862705,0.0777649,75.6176785),(50592,'femur tibia pelvis',255,8,444,32.9420017,85.0410954,126.5228871,1.8,85.1131685,126.4111034,-0.0433825,4.0004699,5.1431409,103.8158185,186.9873609,0.0103265,36.3566477,25.9509058,51.6157253,8.164072,34.4421133,0.0624188,77.9441011),(50593,'femur tibia pelvis',255,8,445,37.8344081,84.4927782,126.5419837,1.8,84.7256304,126.494932,-0.0578336,4.0605081,5.4584277,127.9324858,243.6619711,0.0210675,44.6395891,31.5065214,61.5238137,8.5585331,35.7287574,0.0601683,80.5222291),(50594,'femur tibia pelvis',255,8,446,40.8030633,84.1901652,126.5070536,1.8,84.3815454,126.4565526,-0.0692365,4.0937483,5.6207573,145.0430859,281.9484225,0.0325475,50.1619994,35.4303871,68.3888715,8.59376,36.6143597,0.0704713,82.7443919),(50595,'femur tibia pelvis',255,8,447,41.38622,84.0229156,126.3985962,1.8,84.1391321,126.3554921,-0.0860843,4.3341867,5.939878,155.9248526,303.7964231,0.0509893,51.1452297,35.9755732,72.9302582,8.59376,37.5036649,0.0802868,85.5742253),(50596,'femur tibia pelvis',255,8,448,38.7923673,83.8898908,126.3196721,1.8,83.9638683,126.2952191,-0.1344376,4.3456504,6.2926963,152.801165,302.6956672,0.1161499,48.1026977,35.1618633,71.6212408,8.59376,38.7887143,0.0776215,87.2929773),(50597,'femur tibia pelvis',255,8,449,34.9662933,83.8404221,126.1426363,1.8,83.8781262,126.1758937,-0.1297858,4.2533652,6.5771907,142.4136367,292.4058481,0.0976142,44.4575595,33.4825788,66.0810513,8.59376,40.0186961,0.0537117,89.0117293),(50598,'femur tibia pelvis',255,8,450,32.3237091,83.8588155,126.0196331,1.8,83.9551758,126.1007327,-0.1529916,4.4120789,6.5513956,128.9976007,282.6861261,0.1251164,43.1489933,29.237374,62.7884574,8.59376,52.5345202,0.06548,116.4253897),(50599,'femur tibia pelvis',255,8,451,29.9658494,84.0405657,125.8619693,1.8,84.0892272,126.0435144,-0.1581615,4.3569012,6.3976141,113.4096567,250.6500288,0.1238947,39.1786727,26.0298895,56.8335744,8.59376,51.7073763,0.0748598,114.6023779),(50600,'femur tibia pelvis',255,8,452,26.7232118,84.3620183,125.7214038,1.8,84.3198191,125.9905799,-0.1248525,4.2090956,6.2934514,95.0330111,204.2042729,0.0690675,32.447104,22.5780119,47.2659032,8.164072,51.2482881,0.0671259,111.9199901),(50601,'femur tibia pelvis',255,8,453,24.3649605,84.7397642,125.6517491,1.8,84.6303289,125.9374259,-0.1050011,4.2169118,6.2342013,84.245364,161.5785386,0.0446073,25.9180817,19.9779763,39.0380016,8.164072,50.3908805,0.0682698,109.8452729),(50602,'femur tibia pelvis',255,8,454,21.2309759,85.2782072,125.6652818,1.8,85.0809522,125.928594,-0.0547716,4.1539661,5.8370685,69.3202938,113.5023643,0.0106046,19.4450971,16.6877372,31.0489891,8.164072,49.104898,0.0700606,107.5188503),(50603,'femur tibia pelvis',255,8,455,17.2974239,85.8048065,125.8016386,1.8,85.5398591,126.0710981,-0.1936681,4.08098,5.4525589,55.0931841,68.2711389,0.1067849,12.5209356,13.4999887,22.5178148,7.734384,47.7901149,0.0629797,104.6890169),(50604,'femur tibia pelvis',255,8,456,14.3208239,86.3670832,125.8937929,1.8,86.1705864,126.1487579,-1.2086539,3.8640661,3.925232,36.2116771,47.5292432,2.0872285,12.1086457,9.3713917,19.3908167,7.734384,45.6461346,0.065942,100.0361717),(50605,'femur tibia pelvis',255,8,457,12.7191712,86.6911809,125.9937208,1.8,86.4421093,126.1935937,-1.2105092,3.5534387,3.7975775,28.0943989,39.221625,1.8563917,10.3280643,7.9062569,16.6975118,7.733206,44.4264977,0.0871573,97.9614545),(50606,'femur tibia pelvis',255,8,458,10.4075814,86.9466931,126.1386835,1.8,86.6938509,126.3356381,-1.2971518,3.5186341,3.6672075,20.5166646,29.6218648,1.6079178,8.077499,5.8308604,13.1471594,7.304696,43.9312641,0.06852,96.5986677),(50607,'femur tibia pelvis',255,8,459,8.4853408,87.2609797,126.2616296,1.8,86.995959,126.4580435,-1.4912032,3.0613661,3.4957812,13.2472705,22.1390209,1.4052832,6.3330683,4.3272415,9.3905356,7.2909449,42.6777751,0.0806329,93.5603147),(50608,'femur tibia pelvis',255,8,460,7.0177979,87.5274853,126.3667593,1.8,87.3105056,126.5553429,1.5565267,2.8842383,3.412772,8.3306813,16.4103565,1.1693948,4.8085124,2.8883471,6.9894573,6.875008,41.7881245,0.0720401,91.5898573),(50609,'femur tibia pelvis',255,8,461,5.7471956,87.7065315,126.4409876,1.8,87.5594616,126.6484317,1.4766406,2.2590795,3.4265374,5.2892571,11.8396572,0.9493992,3.4552832,2.3413329,4.8276226,6.8501563,40.5366848,0.0849018,89.1591749),(50610,'femur tibia pelvis',255,8,462,4.1314997,87.9676785,126.5169835,1.8,87.8626022,126.7121266,1.4786711,2.0041094,3.3249628,2.4124473,6.9666994,0.6827558,2.0952714,1.2037503,2.7644829,6.5218279,39.6455586,0.0759406,87.9006479),(50611,'femur tibia pelvis',255,8,463,2.5486459,88.3367613,126.5911049,1.8,88.1866053,126.7213908,1.5043804,1.5474642,2.7793258,0.7774862,2.9819702,0.4229034,1.0729113,0.502426,1.3370983,6.6513362,38.3964157,0.0896467,84.9665547),(50612,'femur tibia pelvis',255,8,464,0.6421269,88.7516689,126.914006,1.8,88.6514189,126.9614964,1.5040112,0.6824067,2.0008822,0.0551215,0.4637194,0.1065445,0.2317574,0.0807751,0.2591882,6.4516529,36.7276431,0.1054893,82.0324615),(50613,'femur tibia pelvis',255,8,465,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50614,'femur tibia pelvis',255,8,466,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50615,'femur tibia pelvis',255,8,467,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50616,'femur tibia pelvis',255,8,468,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50617,'femur tibia pelvis',255,8,469,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50618,'femur tibia pelvis',255,8,470,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50619,'femur tibia pelvis',255,8,471,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50620,'femur tibia pelvis',255,8,472,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50621,'femur tibia pelvis',255,8,473,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50622,'femur tibia pelvis',255,8,474,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50623,'femur tibia pelvis',255,8,475,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50624,'femur tibia pelvis',255,8,476,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50625,'femur tibia pelvis',255,8,477,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50626,'femur tibia pelvis',255,8,478,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50627,'femur tibia pelvis',255,8,479,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50628,'femur tibia pelvis',255,8,480,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50629,'femur tibia pelvis',255,8,481,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50630,'femur tibia pelvis',255,8,482,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50631,'femur tibia pelvis',255,8,483,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50632,'femur tibia pelvis',255,8,484,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50633,'femur tibia pelvis',255,8,485,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50634,'femur tibia pelvis',255,8,486,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50635,'femur tibia pelvis',255,8,487,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50636,'femur tibia pelvis',255,8,488,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50637,'femur tibia pelvis',255,8,489,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50638,'femur tibia pelvis',255,8,490,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50639,'femur tibia pelvis',255,8,491,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50640,'femur tibia pelvis',255,8,492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50641,'femur tibia pelvis',255,8,493,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50642,'femur tibia pelvis',255,8,494,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50643,'femur tibia pelvis',255,8,495,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50644,'femur tibia pelvis',255,8,496,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50645,'femur tibia pelvis',255,8,497,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50646,'femur tibia pelvis',255,8,498,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50647,'femur tibia pelvis',255,8,499,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50648,'femur tibia pelvis',255,8,500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50649,'femur tibia pelvis',255,8,501,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50650,'femur tibia pelvis',255,8,502,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50651,'femur tibia pelvis',255,8,503,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50652,'femur tibia pelvis',255,8,504,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50653,'femur tibia pelvis',255,8,505,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50654,'femur tibia pelvis',255,8,506,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50655,'femur tibia pelvis',255,8,507,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50656,'femur tibia pelvis',255,8,508,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50657,'femur tibia pelvis',255,8,509,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50658,'femur tibia pelvis',255,8,510,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50659,'femur tibia pelvis',255,8,511,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50660,'femur tibia pelvis',255,8,512,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50661,'metatarsal.tif',255,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50662,'metatarsal.tif',255,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50663,'metatarsal.tif',255,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50664,'metatarsal.tif',255,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50665,'metatarsal.tif',255,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50666,'metatarsal.tif',255,10,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50667,'metatarsal.tif',255,10,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50668,'metatarsal.tif',255,10,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50669,'metatarsal.tif',255,10,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50670,'metatarsal.tif',255,10,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50671,'metatarsal.tif',255,10,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50672,'metatarsal.tif',255,10,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50673,'metatarsal.tif',255,10,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50674,'metatarsal.tif',255,10,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50675,'metatarsal.tif',255,10,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50676,'metatarsal.tif',255,10,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50677,'metatarsal.tif',255,10,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50678,'metatarsal.tif',255,10,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50679,'metatarsal.tif',255,10,19,7.4680197,83.1822131,126.4543433,1.8,83.25205,126.445035,-0.0136841,1.8598641,2.4106786,5.0248137,8.7070135,0.0002331,3.6118516,2.7017101,5.2809145,3.867192,5.585944,0.3947911,15.0264312),(50680,'metatarsal.tif',255,10,20,18.1032017,83.5684928,126.6890633,1.8,83.6056977,126.762788,-0.0863794,2.6291187,3.7127284,22.9099791,46.1669698,0.0224566,12.4347825,8.7139386,18.4569288,5.585944,7.8997178,0.390607,21.2505827),(50681,'metatarsal.tif',255,10,21,35.954409,84.2122097,126.9739454,1.8,84.192324,126.9303657,-0.1290924,4.3249249,4.8322577,116.8181038,148.0711052,0.099309,30.6422205,27.0104354,54.5732612,8.164072,10.2135672,0.2551824,29.0460407),(50682,'metatarsal.tif',255,10,22,42.1107039,84.4232601,126.9468153,1.8,84.3326214,126.8739426,0.0639749,4.8648291,4.9571107,183.7593873,207.6819859,0.0286858,41.8957735,37.7730408,73.7721655,9.3767439,10.8703421,0.3217506,31.9801339),(50683,'metatarsal.tif',255,10,23,47.7352592,84.4109363,126.8677057,1.8,84.3482372,126.779203,-0.2959907,5.4690362,5.7104261,246.3447451,268.0084261,0.6768991,46.933175,45.0435388,89.863317,10.2432639,11.417094,0.3455556,33.8031457),(50684,'metatarsal.tif',255,10,24,48.7930314,84.2949006,126.8324089,1.8,84.2160396,126.8440848,-0.6833245,5.3348179,5.428925,256.0971719,290.4565185,3.2417594,53.5016639,48.004857,92.7002353,10.312512,11.3440887,0.4297623,34.3065565),(50685,'metatarsal.tif',255,10,25,48.0916545,83.9710666,126.9179259,1.8,83.936957,126.9135873,-0.8958463,5.3276934,5.3124023,237.4454029,281.5705572,4.885728,53.002491,44.5681432,89.3299353,10.312512,11.0889478,0.6202495,34.0548511),(50686,'metatarsal.tif',255,10,26,46.2396859,83.7508996,126.9813334,1.8,83.6751817,127.0413927,-1.1290842,5.2930602,5.2259529,221.6277481,258.3886845,6.298262,49.4433627,41.8713824,84.9719847,10.312512,10.8703421,2.8198421,33.8031457),(50687,'metatarsal.tif',255,10,27,43.8848474,83.5387521,126.9752133,1.8,83.4335561,127.0659383,-1.4610497,5.3272318,5.0826916,198.4302837,245.1389273,7.2264004,48.2301402,37.2482914,80.6568821,9.882824,10.6298941,1.815775,33.1954751),(50688,'metatarsal.tif',255,10,28,43.0780625,83.3449772,126.9224626,1.8,83.2093004,126.9903423,1.5452234,5.1688352,4.9110751,181.9277937,246.2870882,7.1749828,50.1493223,35.1970585,78.2503925,9.453136,10.7765202,1.9809237,32.2318393),(50689,'metatarsal.tif',255,10,29,41.3617143,83.1142963,126.7872214,1.8,83.0042633,126.9470227,1.4253495,5.0418143,5.0952303,161.2810779,243.5167513,6.7488115,47.79308,31.9886985,71.8120716,9.2329009,10.8448348,2.1587989,31.9801339),(50690,'metatarsal.tif',255,10,30,40.1256325,82.8915047,126.6229482,1.8,82.8124908,126.8555108,1.4295273,4.8420939,5.2420384,146.9034946,240.8120806,6.5550267,45.9386333,30.3388364,67.5810903,8.9561886,11.0137676,1.929567,31.9801339),(50691,'metatarsal.tif',255,10,31,38.9841046,82.5740955,126.3760855,1.8,82.5012765,126.7048392,1.4363981,4.9235968,5.3979135,134.2369843,230.5983803,6.3806948,42.7199102,27.2640086,63.3143769,9.076292,11.0137676,1.929567,32.3360991),(50692,'metatarsal.tif',255,10,32,38.4658488,82.3115514,126.2171163,1.8,82.2294168,126.5479712,1.4553921,4.7680263,5.1735999,128.1345361,222.1520613,6.325971,42.9395521,26.8737056,60.4119404,8.8608213,10.9549375,2.0169019,31.9801339),(50693,'metatarsal.tif',255,10,33,37.8351914,81.966149,125.9549017,1.8,81.8703808,126.2949341,1.5224742,4.7179699,5.2235534,123.1955946,212.0677984,6.2911523,40.5983787,26.1119923,58.181807,8.5672683,11.0137676,1.929567,31.0164981),(50694,'metatarsal.tif',255,10,34,37.0718229,81.6534239,125.7552753,1.8,81.5396922,126.098082,-1.5244589,4.6678361,4.8254308,116.8099931,201.9656738,6.1653801,41.8544334,25.0244418,56.847661,8.59376,10.6125107,1.943784,31.0164981),(50695,'metatarsal.tif',255,10,35,36.2059558,81.2824368,125.4810372,1.8,81.2123262,125.8131641,-1.3912435,4.0700136,4.8032515,107.5080443,195.5576891,5.8418656,40.7136061,26.4146647,54.5658595,8.164072,10.6125107,1.943784,30.9122383),(50696,'metatarsal.tif',255,10,36,35.8347341,81.0274893,125.3328265,1.8,80.9005562,125.7309009,-1.3449913,4.1086224,4.7943053,103.3675756,200.0317676,5.6730733,41.7227849,25.1586945,56.2590178,8.164072,10.4635866,1.9055332,30.4088275),(50697,'metatarsal.tif',255,10,37,36.4808893,80.6918186,125.1327954,1.8,80.5929523,125.5295427,-1.3138601,4.0718384,4.7857191,103.0238385,212.7801381,5.6875153,44.461477,25.3015537,58.7442097,8.3748954,10.4016451,0.6682894,31.2682035),(50698,'metatarsal.tif',255,10,38,36.893961,80.4598624,124.994276,1.8,80.3299803,125.3222666,-1.2856827,4.0037578,4.9718785,101.8534439,226.6431948,5.6625414,45.5850228,25.4394617,61.1398891,8.0206559,10.6732285,0.6998929,31.1639437),(50699,'metatarsal.tif',255,10,39,37.1817628,80.1668112,124.7787449,1.8,80.0152141,125.1702565,-1.2512147,3.9198579,5.0814343,101.3838935,243.1943172,5.5853055,47.8593839,25.8641755,61.5820184,8.109687,11.0053826,0.6747409,31.7716143),(50700,'metatarsal.tif',255,10,40,37.8395554,79.9125098,124.6477053,1.8,79.6871385,125.0092298,-1.2338434,3.7541725,5.2739737,104.1102391,260.3458266,5.6172511,49.3642631,27.7318743,63.4020962,7.8187339,11.2787985,0.8663023,31.7716143),(50701,'metatarsal.tif',255,10,41,38.5200634,79.598003,124.403797,1.8,79.3580025,124.7718737,-1.1993042,3.9183314,5.5700978,112.6201863,282.0248806,5.5740236,50.6319442,28.7418739,65.8001832,7.7468107,11.5617216,0.7328151,32.3792849),(50702,'metatarsal.tif',255,10,42,39.9222578,79.3623831,124.2261491,1.8,79.155593,124.5565448,-1.1724054,4.2333839,5.8262089,126.8632393,303.2213859,5.6523653,52.044372,29.967336,71.8084215,8.2638335,11.6887773,0.942,33.6988859),(50703,'metatarsal.tif',255,10,43,47.2524191,78.8032861,123.6379826,1.8,78.3821729,123.6841118,1.4347208,5.3103017,6.5714893,281.2086151,384.4751019,7.7304757,58.5065402,52.9552995,83.7195375,10.9545663,13.8570216,2.0899424,42.8571307),(50704,'metatarsal.tif',255,10,44,57.4215458,78.5239743,123.191786,1.8,78.3677059,123.4547335,0.8486451,6.6359156,8.0377999,366.8820982,571.8190927,5.3888055,71.1412455,55.2873364,116.7426764,11.7462104,14.5397175,2.5453935,44.0724719),(50705,'metatarsal.tif',255,10,45,72.1777091,79.3846084,122.6489512,1.8,79.4086581,122.6527672,-0.4040085,7.4625291,8.9164326,763.1923156,845.8454386,1.8589768,94.8636614,102.2699281,172.268254,11.9740442,15.9042615,2.4710711,46.1471891),(50706,'metatarsal.tif',255,10,46,77.8508841,79.6640325,122.4171286,1.8,79.5067842,122.5988702,-0.7717535,7.9955531,9.2767098,862.3394608,1060.6641234,6.3105537,114.3362403,107.8523833,206.7150125,15.6063566,18.3210418,0.8850668,77.667098),(50707,'metatarsal.tif',255,10,47,78.8545536,79.4181389,122.3330644,1.8,79.5065839,122.5268778,1.4306344,8.0089385,7.6050234,967.1173481,1047.2822377,12.885924,137.7092716,120.754748,221.1694417,16.2555592,18.9257932,0.8818719,78.8824392),(50708,'metatarsal.tif',255,10,48,80.6335088,79.2914325,122.2205024,1.8,79.4473453,122.5060147,1.2152872,8.7472062,8.7885373,987.823468,1097.3199293,11.8107783,124.8580841,112.9301686,228.2987217,16.1953258,19.0812438,0.9453113,77.3543186),(50709,'metatarsal.tif',255,10,49,81.5977902,79.3109163,122.2174229,1.8,79.5605894,122.4946838,1.0471381,9.3691799,8.9910597,997.2191179,1090.5471833,10.199024,121.2923968,106.4361159,220.8605343,16.3316408,19.33596,0.9272952,64.0466395),(50710,'metatarsal.tif',255,10,50,76.6548618,79.5813909,122.3382557,1.8,79.6177941,122.5057449,-1.1370999,7.6259726,8.3794335,898.2829959,1015.3592398,10.5197109,121.1727783,117.7925815,205.4122195,16.1642924,19.4169537,2.0047497,65.1577209),(50711,'metatarsal.tif',255,10,51,75.130195,79.893439,122.1328811,1.8,79.7443031,122.3106608,-1.0008814,8.4713109,8.5133918,856.999647,1055.5210091,8.8763141,123.9836052,101.1649384,213.8186686,15.7501769,19.2402368,1.9844855,61.8244767),(50712,'metatarsal.tif',255,10,52,80.7277269,79.6589235,121.6545687,1.8,79.667915,122.0845659,-0.9971408,8.3805595,8.2491228,1035.2167574,1113.2833125,9.4918341,134.957781,123.5259723,238.6940089,15.7005719,18.9111542,1.9428641,61.6770311),(50713,'metatarsal.tif',255,10,53,86.2709324,79.4772505,121.275314,1.8,79.6412029,121.8904757,-0.5000215,8.9002802,8.7392403,1057.1109563,1160.6621018,3.3051393,132.8104123,118.772773,246.0768747,15.333458,18.280687,1.9818609,58.8471977),(50714,'metatarsal.tif',255,10,54,88.5737942,79.4124795,121.310804,1.8,79.5250132,121.9004593,-0.5716351,8.4198293,8.7391328,1006.2830801,1244.9384146,4.3207705,142.4556005,119.5134777,255.1255267,15.1411752,18.280687,1.0545657,56.2690697),(50715,'metatarsal.tif',255,10,55,95.3054688,79.4471142,121.3549753,1.8,79.7002265,121.7422084,-0.486809,7.9013744,9.1280131,924.6130949,1488.3470509,3.4761759,163.0526858,117.0192732,260.4138996,15.0657583,17.7164901,0.2449787,56.0173642),(50716,'metatarsal.tif',255,10,56,95.2841522,79.388272,121.3635883,1.8,79.8511234,121.6525273,-0.4293101,7.4051971,9.452038,872.9613607,1500.6839657,2.7514688,158.7682959,117.8849601,248.8506731,15.0845336,18.0724546,0.3142319,58.4480466),(50717,'metatarsal.tif',255,10,57,73.9148144,79.9317902,121.2825609,1.8,80.1032516,121.6183408,-0.2649649,6.6029413,8.9884702,384.659867,1268.567954,0.8448303,141.1327986,58.2558366,183.790765,12.7199682,18.209851,0.3366748,57.6929304),(50718,'metatarsal.tif',255,10,58,65.878968,80.334589,121.3912693,1.8,80.6348435,121.4096412,-0.1896388,5.4017024,8.4807908,273.2133107,1129.6217771,0.3901554,133.1976937,50.5791121,164.712593,12.301185,18.1336482,0.2392316,58.1963412),(50719,'metatarsal.tif',255,10,59,49.7724191,81.1760021,121.6582998,1.8,81.1898024,121.6585994,-0.0291857,5.2096096,8.1866234,211.5368266,788.5918025,0.007064,96.3268696,40.6051206,118.7406788,4.726568,6.3442673,2.0647377,16.849443),(50720,'metatarsal.tif',255,10,60,31.8497649,82.8023587,122.2038895,1.8,82.1509745,122.1971955,0.1079503,6.1089249,9.4288957,108.3957358,329.878658,0.0616191,34.9859271,17.7438317,46.4296017,2.578128,4.0763783,1.8925469,10.373586),(50721,'metatarsal.tif',255,10,61,26.2584992,82.665897,123.9443715,1.8,82.0564241,124.2929747,-0.5891897,4.3960096,9.3254818,89.5004387,457.0864693,1.3513876,49.0147831,20.3594728,58.5886016,3.9415764,6.7939638,1.2490458,17.4571136),(50722,'metatarsal.tif',255,10,62,38.2188339,81.3369371,124.7676168,1.8,81.2931502,124.5570026,-0.5743884,5.5910475,7.9988545,111.9866138,659.3764123,1.8803551,82.4338547,20.0296303,96.3812847,10.1700714,15.2584623,0.5645694,50.4440691),(50723,'metatarsal.tif',255,10,63,65.2874749,81.0576503,123.8147093,1.8,81.0295024,123.9731466,-0.6550523,5.5686803,8.6150023,287.2783702,1035.898334,4.0383085,120.2435355,51.5882317,152.7058552,10.9675306,16.7798528,0.6947383,48.9770225),(50724,'metatarsal.tif',255,10,64,73.7040544,80.7063453,123.8195892,1.8,80.8220579,124.2606334,-0.6634288,5.9802223,8.4162639,397.0366287,1109.3774999,4.6585466,131.813536,66.3916174,177.3665758,11.7554822,16.7798528,0.6947383,47.4057161),(50725,'metatarsal.tif',255,10,65,73.1851272,80.4851546,124.0257092,1.8,80.6064164,124.398198,-0.6024205,6.955848,8.0757428,488.8731998,1137.1805301,3.9163705,140.8143573,70.282329,198.3982631,12.5573908,16.5861794,0.6383198,48.7253171),(50726,'metatarsal.tif',255,10,66,77.1525843,80.2694891,124.0596111,1.8,80.2203034,124.315439,-0.4606938,7.4457846,7.8976393,621.6669998,1199.0369711,2.5414345,151.8221988,83.4924766,226.3941058,13.0091066,16.3337968,0.6171914,49.8363985),(50727,'metatarsal.tif',255,10,67,83.0749004,80.1463597,123.9586389,1.8,80.3362911,124.3684497,-0.1441988,7.1825387,7.4690029,798.5726215,1272.6191597,0.2859102,170.3867532,111.1825024,257.1286801,12.89064,16.1747714,0.6913369,49.9838441),(50728,'metatarsal.tif',255,10,68,78.6679636,80.208608,124.0528706,1.8,80.39952,124.4490669,-0.0929073,7.3039525,7.2550562,798.6063935,1123.0631075,0.1128486,154.7973003,109.3389364,242.2848713,13.302073,16.1519256,2.6422459,50.4440691),(50729,'metatarsal.tif',255,10,69,75.2765576,80.1721086,124.1748742,1.8,80.3945691,124.4127887,0.210467,7.0783528,7.6850372,729.2206501,984.0444377,0.5475889,128.0468021,103.0212356,214.6449437,13.2954829,16.1519256,2.6422459,49.8363985),(50730,'metatarsal.tif',255,10,70,76.3296861,80.2058214,124.0198417,1.8,80.2619039,124.3632628,0.2459594,7.0004873,7.7414414,687.3229101,982.5961048,0.7542124,126.9267637,98.1821522,209.778496,13.2024432,16.1519256,2.6422459,50.4008833),(50731,'metatarsal.tif',255,10,71,79.83534,79.7815856,123.4894473,1.8,79.9671389,124.0070534,-0.0335347,6.8510207,7.0747391,554.408254,1133.5266043,0.0149579,160.2216823,80.9234529,195.298798,12.3808512,16.6860637,0.6022873,52.7704917),(50732,'metatarsal.tif',255,10,72,90.6133599,79.5785453,123.4965905,1.8,79.8620378,123.9972146,-0.0942574,7.1463143,7.2838486,616.9418496,1324.8396231,0.1337781,181.8873091,86.3300747,221.6302759,12.4083734,16.9331967,0.6231993,53.4824221),(50733,'metatarsal.tif',255,10,73,91.0987177,79.7191433,124.1209277,1.8,79.9209314,124.5120757,-0.1545739,7.1856009,7.4617082,850.4421488,1249.3099443,0.3598918,167.4294819,118.353658,240.2545031,12.89064,17.18752,0.6435011,51.8068559),(50734,'metatarsal.tif',255,10,74,77.6269202,79.6808062,125.5146691,1.8,79.909767,124.8551318,0.001396,6.9247102,6.6918102,600.8768579,1083.8181735,0.0000252,161.961883,86.7728522,200.128694,12.89064,16.9331967,0.6231993,53.9858329),(50735,'metatarsal.tif',255,10,75,56.0813429,79.5325878,123.489553,1.8,79.4663952,123.0533247,0.2631848,6.5327685,6.3385487,245.9194386,451.7175572,0.632613,71.2651397,37.6439848,84.1231935,10.1200279,13.047241,0.3009202,38.2474713),(50736,'metatarsal.tif',255,10,76,72.3547318,80.3682478,123.1901182,1.8,80.5016414,123.2483008,0.2393939,7.1349438,7.2852535,354.6099588,724.5126088,0.6779999,99.4491964,49.7004556,122.6088798,11.1947109,15.240301,2.4360245,48.5778715),(50737,'metatarsal.tif',255,10,77,64.0102706,80.535262,123.2032159,1.8,80.5465835,123.2577402,0.3038364,7.3141474,7.2711906,315.2597585,638.9679335,0.9549322,87.8766588,43.1027352,112.1142172,10.9266336,14.283491,2.3349211,47.2150847),(50738,'metatarsal.tif',255,10,78,57.7904177,80.5613649,123.1339863,1.8,80.6052424,123.2834747,0.2942797,7.4292329,7.230626,272.7330309,576.7065133,0.8103115,79.7588641,36.710793,99.0872299,9.7311104,13.7298596,2.7901479,41.8503091),(50739,'metatarsal.tif',255,10,79,53.2229632,80.6464336,123.1919438,1.8,80.6927387,123.2547166,0.3058201,5.1715977,7.305259,251.0459807,490.9189972,0.8040778,67.2007654,48.5432157,87.924052,9.4306407,13.047241,2.8406724,38.8119561),(50740,'metatarsal.tif',255,10,80,50.8137983,80.6326018,123.2838982,1.8,80.7319109,123.4269274,0.3546195,5.0271578,7.4793901,245.6538093,445.7157242,1.0211132,59.592523,48.8653471,82.5415126,9.4071916,13.047241,2.8406724,40.1315571),(50741,'metatarsal.tif',255,10,81,48.8227404,80.6476847,123.4607657,1.8,80.8768302,123.5840378,0.4759493,4.9642125,7.7758856,252.7179244,384.3538771,1.7082355,49.4289524,50.9079587,77.4065052,8.8112237,12.5274503,2.1112158,38.6213247),(50742,'metatarsal.tif',255,10,82,49.5290968,80.4507791,123.6450676,1.8,80.6481307,123.7050718,0.4788944,5.0459181,6.1059964,282.3925909,359.1377255,1.7527937,58.8172191,55.9645605,92.0161257,9.4188943,12.3940969,2.1587989,38.5170649),(50743,'metatarsal.tif',255,10,83,48.0698903,80.427828,123.7086987,1.8,80.5880872,123.7933184,0.6845648,4.951087,5.8295285,280.766628,328.5371662,3.2034477,56.357417,56.7080785,96.0253631,9.4638443,11.8222779,2.8083484,37.8051345),(50744,'metatarsal.tif',255,10,84,47.194344,80.4240056,123.7080302,1.8,80.5861277,123.7437783,0.8500154,4.7298311,6.1656311,272.0216868,311.7914112,4.4397095,50.5692611,57.5119234,91.9738638,9.4540873,11.7282,2.0672191,35.9821227),(50745,'metatarsal.tif',255,10,85,46.7670614,80.4476647,123.7207742,1.8,80.6058073,123.7479902,1.1509414,4.5908515,5.7470255,262.1042564,300.4244717,6.4993701,52.2747759,57.0927328,97.8471679,9.4166716,11.171888,2.7468015,34.4108163),(50746,'metatarsal.tif',255,10,86,45.7011206,80.550667,123.7131713,1.8,80.7284593,123.7457369,1.2667669,4.4534814,5.6672864,237.0638691,296.4619785,6.9342255,52.311099,53.2311353,93.4002651,8.8444788,11.171888,2.7468015,34.4108163),(50747,'metatarsal.tif',255,10,87,43.2268309,80.6619769,123.6074146,1.8,80.804022,123.6272055,1.3441722,4.328374,5.6730447,205.0984356,270.1022203,6.8407521,47.6115091,47.3846378,82.4447243,8.4577545,11.1553493,1.843805,34.2633707),(50748,'metatarsal.tif',255,10,88,42.7477954,80.6960873,123.5960236,1.8,80.8156211,123.5616199,1.3824698,4.4272133,5.2324446,197.0926489,262.8040603,6.8749174,50.2258662,44.5184444,86.5922512,8.4577545,10.8788312,1.4121411,32.6920643),(50749,'metatarsal.tif',255,10,89,43.1841418,80.7565909,123.6071483,1.8,80.8838832,123.5426242,1.4780978,4.6153156,5.0292193,192.2015215,260.8320344,7.1356869,51.8633246,41.6442856,85.3526466,8.6359616,10.8703421,1.2490458,32.3360991),(50750,'metatarsal.tif',255,10,90,43.2038918,80.7894353,123.631261,1.8,80.889072,123.5873277,1.5004878,4.3026869,5.2917235,187.16776,260.6340443,7.1651123,49.2531486,43.5002045,84.174629,8.5617773,10.9549375,1.3734008,32.3360991),(50751,'metatarsal.tif',255,10,91,41.0005634,80.8348817,123.5545035,1.8,80.9005562,123.4697988,-1.4914854,4.3135901,5.3052714,149.5552605,252.2425326,6.7905335,47.5456413,34.6707165,74.2389402,7.9115006,11.0137676,1.2120257,30.8690525),(50752,'metatarsal.tif',255,10,92,41.5068461,80.8634144,123.5687622,1.8,80.935457,123.4954657,-1.4944608,4.2819051,5.0852023,148.55194,253.7496393,6.8775751,49.8996153,34.6929547,76.8163867,7.969229,11.0137676,1.2120257,30.7647927),(50753,'metatarsal.tif',255,10,93,40.4778876,80.992046,123.467175,1.8,81.0728203,123.4271938,-1.5086284,4.1492558,5.1197325,136.3079877,238.3142147,6.7202747,46.5481772,32.8511893,69.7846144,7.7136623,11.0137676,1.2120257,30.6173471),(50754,'metatarsal.tif',255,10,94,40.5405505,81.0066592,123.4391507,1.8,81.0998348,123.363013,-1.4890053,4.1535724,5.0742343,136.2523174,234.1711872,6.711658,46.1490685,32.8036454,72.9185024,7.8164925,10.6298941,1.3258177,29.4020059),(50755,'metatarsal.tif',255,10,95,39.2296649,81.0375838,123.3588594,1.8,81.1032555,123.2935119,-1.4104665,4.1198809,5.4361068,123.0636208,226.2417943,6.3716419,41.6183498,29.8706745,61.7732885,7.7141462,11.171888,1.1760052,30.5130873),(50756,'metatarsal.tif',255,10,96,39.1080876,81.0549994,123.3272112,1.8,81.1093392,123.2760549,-1.3933604,4.1105509,4.9973819,123.0259689,222.2579263,6.3149492,44.4748729,29.9293139,67.3972396,7.6720481,10.6125107,1.1978086,29.2977461),(50757,'metatarsal.tif',255,10,97,39.0347385,81.0980326,123.2775115,1.8,81.1784154,123.21977,-1.3505763,4.0811742,5.0050935,123.7727446,216.6626493,6.1953471,43.2884316,30.3277286,67.6465228,7.734384,10.4635866,1.2360595,29.2977461),(50758,'metatarsal.tif',255,10,98,39.0905756,81.1832679,123.2425591,1.8,81.2366425,123.1625243,-1.3706313,4.0889828,5.2156295,126.4644385,210.3423465,6.2575294,40.3292349,30.9280923,61.9196672,7.734384,10.7765202,1.160669,29.6537113),(50759,'metatarsal.tif',255,10,99,39.09231,81.2234704,123.2094335,1.8,81.3004302,123.1185892,-1.3281997,4.0782111,5.0085858,126.9014148,204.6666808,6.1393978,40.8631677,31.1169312,66.1864115,7.734384,10.3304002,1.2753555,28.4383701),(50760,'metatarsal.tif',255,10,100,37.127772,81.3860379,123.1145263,1.8,81.4709856,123.0039243,-1.4248622,3.8703371,4.7303312,112.8273482,189.1053769,6.0571112,39.9771962,29.1518144,61.8102179,7.304696,10.0587382,1.2220253,27.4747343),(50761,'metatarsal.tif',255,10,101,38.0297262,81.4715298,123.1350542,1.8,81.5671433,123.0320353,-1.4654869,3.7868683,4.6654989,121.2243098,189.4493721,6.2682551,40.6064554,32.0117577,63.4050638,7.304696,10.0587382,1.2220253,27.7264397),(50762,'metatarsal.tif',255,10,102,37.8897417,81.4786601,123.1146144,1.8,81.5671433,123.0320353,-1.4454903,3.811874,4.7156724,120.7814426,186.1573338,6.2163199,39.4763078,31.6855812,62.3681454,7.304696,10.0587382,1.2220253,27.7264397),(50763,'metatarsal.tif',255,10,103,38.2709224,81.4902923,123.1415766,1.8,81.5585314,123.1012863,-1.3531556,4.0058212,4.9871606,124.2103832,189.0874761,6.0810945,37.9148559,31.0074708,59.0004443,7.304696,10.5689273,1.1071487,28.8375211),(50764,'metatarsal.tif',255,10,104,37.7435469,81.4871541,123.0968349,1.8,81.5595075,123.0635292,-1.312354,4.0780471,4.7703942,121.825008,182.3453501,5.879699,38.2243777,29.8733695,60.9787684,7.304696,10.0219602,1.0303768,28.2298505),(50765,'metatarsal.tif',255,10,105,37.4664314,81.5161807,123.0574007,1.8,81.5810411,122.9922221,-1.2807765,3.9800259,4.7822949,121.293402,176.8371437,5.7337407,36.9774654,30.4755311,59.1871165,7.304696,10.0219602,1.0303768,27.6221799),(50766,'metatarsal.tif',255,10,106,37.0939228,81.5473299,123.0484057,1.8,81.5944689,123.0071418,-1.2824526,3.9512392,5.3312553,117.9627101,174.4091492,5.6823978,32.714462,29.8546111,51.637577,7.304696,10.6125107,1.0164888,28.8375211),(50767,'metatarsal.tif',255,10,107,36.8810927,81.5748905,123.0250154,1.8,81.6331551,122.9633913,-1.2441097,3.9644128,4.8865774,117.1780528,169.1946914,5.5138398,34.6243755,29.5574799,56.1809072,7.7049523,10.0219602,1.0303768,27.9781451),(50768,'metatarsal.tif',255,10,108,35.0736036,81.7342618,122.9545325,1.8,81.830805,122.8939627,-1.3988335,3.7806074,4.5543207,105.0604916,155.8070094,5.6744362,34.2108124,27.7893154,54.4588991,7.304696,9.6560368,1.2068174,27.1187691),(50769,'metatarsal.tif',255,10,109,35.0569307,81.7629436,122.941279,1.8,81.8579423,122.8939391,-1.3817122,3.8302549,4.5974777,106.4040237,151.7972285,5.6364022,33.0175016,27.7798809,53.6204915,7.304696,9.6560368,1.2068174,27.1187691),(50770,'metatarsal.tif',255,10,110,34.7077529,81.7870705,122.9376264,1.8,81.8908369,122.8715282,-1.3683482,3.8082232,4.5382372,105.1848929,148.2148283,5.5507625,32.659119,27.6204645,54.0032432,7.304696,9.4335845,1.0460006,27.1187691),(50771,'metatarsal.tif',255,10,111,34.3206975,81.8263243,122.9316642,1.8,81.9046482,122.9084705,-1.3428361,3.8684175,4.5762462,105.3438947,143.3906487,5.4279789,31.333683,27.2317802,52.6975763,7.304696,9.4335845,1.0460006,26.7628039),(50772,'metatarsal.tif',255,10,112,34.0553313,81.8411422,122.932631,1.8,81.9180932,122.9035945,-1.3356952,3.8564245,4.5850199,105.3234204,140.7579724,5.3679053,30.6995335,27.3111584,52.0482544,7.304696,9.4335845,1.0460006,26.7628039),(50773,'metatarsal.tif',255,10,113,33.7607597,81.8815901,122.9202135,1.8,81.9564756,122.8972784,-1.3090969,3.8287434,4.5179639,105.1842693,136.8235531,5.2501509,30.2843397,27.4722692,53.3833199,7.304696,9.2557628,1.1902899,26.2593931),(50774,'metatarsal.tif',255,10,114,33.5360684,81.894121,122.9275672,1.8,81.9625776,122.9120073,-1.2956254,3.8180904,4.5189167,105.4830999,134.5902132,5.1766995,29.7837342,27.6271874,52.9878136,7.304696,9.2557628,1.1902899,26.2593931),(50775,'metatarsal.tif',255,10,115,33.2069763,81.9380813,122.9382317,1.8,81.9838169,122.9038384,-1.2387436,3.9196431,4.5344424,105.593229,131.2206715,4.9463686,28.9386565,26.9395011,52.2089342,7.304696,9.1957248,0.9179497,26.5110985),(50776,'metatarsal.tif',255,10,116,32.9456943,81.9582006,122.9425055,1.8,81.9987933,122.9037888,-1.2274218,3.9037212,4.5381976,105.9383448,128.7641043,4.8685809,28.3734019,27.1377843,51.6629268,7.6575927,9.1957248,0.9179497,26.8670637),(50777,'metatarsal.tif',255,10,117,32.5358118,82.0034284,122.9419389,1.8,82.0655436,122.9021182,-1.1733103,3.8767871,4.554105,106.0713388,124.9513693,4.6100663,27.437086,27.3606306,50.710699,7.6987764,9.1352922,0.8519663,26.8670637),(50778,'metatarsal.tif',255,10,118,32.3129668,82.0189311,122.9543541,1.8,82.0736387,122.9359983,-1.1332791,3.886725,4.5409555,106.5002627,123.1304216,4.4187186,27.1155312,27.4010285,50.4706185,7.6987764,9.1352922,0.8519663,26.8670637),(50779,'metatarsal.tif',255,10,119,30.8674679,82.1871676,122.9507413,1.8,82.2895318,122.8839204,-1.3449675,3.8342022,4.4441107,98.0296707,115.2690643,4.8866412,25.9374872,25.5671623,47.7814683,7.2768994,8.9412281,0.9561334,26.5110985),(50780,'metatarsal.tif',255,10,120,30.7501987,82.2019754,122.9719364,1.8,82.2938458,122.9165493,-1.347482,3.9103686,4.4256475,98.9510113,113.5576663,4.8736718,25.6589948,25.3047788,47.7693344,7.2768994,8.8582451,0.8884798,26.5110985),(50781,'metatarsal.tif',255,10,121,31.4934255,82.1441526,123.0008115,1.8,82.1640365,122.999444,-0.8388713,4.0888526,4.8218397,105.4362515,116.1484026,2.9045929,24.0879852,25.7862683,45.8061484,7.734384,9.4237936,0.7531513,27.3704745),(50782,'metatarsal.tif',255,10,122,31.2991705,82.1634661,123.0217552,1.8,82.1653391,123.0140118,-0.7389966,4.1191983,4.8366896,105.0238195,114.9315493,2.3665565,23.7624405,25.4961796,45.4721955,7.734384,9.4237936,0.7531513,27.3704745),(50783,'metatarsal.tif',255,10,123,30.9099332,82.2081002,123.049634,1.8,82.20531,123.0240046,-0.5694369,4.1312504,4.7787506,103.4031415,113.9367661,1.4975411,23.8423755,25.0295024,44.8037867,7.734384,9.4628966,0.6889244,27.3704745),(50784,'metatarsal.tif',255,10,124,30.6212922,82.2357435,123.0910363,1.8,82.2406306,123.0857802,-0.4458601,4.0946267,4.6466326,103.6057197,112.8566837,0.9490705,24.2878431,25.3028483,44.6906949,7.734384,9.4628966,0.6889244,27.1187691),(50785,'metatarsal.tif',255,10,125,30.142928,82.2931155,123.1224384,1.8,82.3190014,123.0965573,-0.2469191,3.9273922,4.1122508,100.6889769,111.9104212,0.300123,27.2139098,25.6376172,48.9811508,7.734384,8.8582451,0.6823166,26.2593931),(50786,'metatarsal.tif',255,10,126,29.874037,82.3081511,123.1456801,1.8,82.3192621,123.0948283,-0.190443,3.9146742,4.1153403,99.302688,111.3895627,0.1784086,27.0669144,25.3667824,48.6671085,7.734384,8.7005189,2.7886023,26.0076877),(50787,'metatarsal.tif',255,10,127,29.1154802,82.4059143,123.1671906,1.8,82.4391953,123.105612,-0.0737349,3.8235142,4.0026278,96.860763,105.840129,0.0263349,26.442661,25.3329157,46.4251204,7.734384,8.7005189,2.5672878,26.2593931),(50788,'metatarsal.tif',255,10,128,28.9701805,82.4201782,123.1970903,1.8,82.4276388,123.1334153,-0.0425989,3.9354448,3.9748727,95.8245917,105.8523134,0.0087566,26.6303656,24.3491134,46.3645314,7.734384,8.7005189,2.5672878,26.6153583),(50789,'metatarsal.tif',255,10,129,28.5334984,82.4601191,123.231199,1.8,82.477572,123.1523925,-0.0121423,3.7928229,3.9214489,92.7899755,105.5973845,0.0007011,26.928155,24.4646211,47.2177316,7.734384,8.6473042,0.4636476,26.0076877),(50790,'metatarsal.tif',255,10,130,28.3027646,82.4680996,123.2761984,1.8,82.4843757,123.2296276,-0.0191924,3.8948508,3.9223597,91.3750474,105.4744531,0.0017373,26.8905612,23.4604745,46.8713458,7.734384,8.6473042,0.4636476,26.0076877),(50791,'metatarsal.tif',255,10,131,28.2549842,82.5306652,123.3434901,1.8,82.6191662,123.3187303,0.1022796,3.6191058,3.945836,90.9857026,105.8899646,0.0490916,26.8358754,25.1403823,48.1426167,7.304696,8.59376,2.4980915,25.2957573),(50792,'metatarsal.tif',255,10,132,28.0614006,82.5354458,123.4040543,1.8,82.5832614,123.4226802,0.1129457,3.9571836,3.9432902,90.7205508,105.4301725,0.0594087,26.7366,22.9255351,47.0337356,7.7290989,8.59376,2.4980915,25.6517225),(50793,'metatarsal.tif',255,10,133,28.0462943,82.5281514,123.4392744,1.8,82.4866682,123.4345919,0.0371406,3.794696,3.9448387,90.218666,109.6637049,0.006445,27.7992873,23.7749388,45.5074297,7.734384,9.0336729,0.4423742,27.2230289),(50794,'metatarsal.tif',255,10,134,28.0212292,82.5390063,123.4714617,1.8,82.5050731,123.4598143,0.0283794,3.7645647,4.2519703,90.2567778,109.4916633,0.0037603,25.7508064,23.975356,45.5299949,7.734384,9.0336729,0.4423742,27.5789941),(50795,'metatarsal.tif',255,10,135,27.7708573,82.5929642,123.5407642,1.8,82.5673373,123.5090595,0.0614971,3.7513291,4.2089329,90.4576122,108.6409493,0.0174823,25.8119939,24.1134837,45.2032686,7.734384,9.0336729,0.4423742,28.4383701),(50796,'metatarsal.tif',255,10,136,27.6862624,82.6097756,123.5992407,1.8,82.5930015,123.5079261,0.079626,3.764146,4.1859364,91.4795414,107.7657347,0.0291948,25.7447135,24.3028674,46.9286107,7.734384,8.76395,2.9441971,26.3636529),(50797,'metatarsal.tif',255,10,137,27.4695158,82.6676893,123.6820563,1.8,82.6339603,123.5815741,0.0956998,4.0154037,4.1579565,91.9539176,107.3236839,0.0418019,25.8116417,22.9002918,45.8479661,8.164072,8.8582451,2.896614,27.8306995),(50798,'metatarsal.tif',255,10,138,27.2271447,82.6789221,123.7475799,1.8,82.6545151,123.6611852,0.08459,3.9799402,4.13985,92.4400065,106.107889,0.0323931,25.6308534,23.226481,47.8533158,8.164072,8.76395,2.9441971,27.5789941),(50799,'metatarsal.tif',255,10,139,26.9383358,82.7250637,123.822787,1.8,82.7291515,123.7083456,0.0785061,3.910057,4.1526499,92.6229232,106.6950325,0.0276143,25.6932406,23.6883816,47.03958,8.164072,8.7005189,2.5672878,26.3636529),(50800,'metatarsal.tif',255,10,140,26.9023046,82.7273578,123.9053393,1.8,82.6826326,123.8389893,0.114594,3.9700197,4.6596108,94.411729,109.611575,0.058622,23.523762,23.7811738,42.9606111,8.164072,8.8582451,0.2449787,28.6900755),(50801,'metatarsal.tif',255,10,141,26.5337125,82.7749634,123.9828642,1.8,82.7832238,123.9166897,0.1160014,3.8407902,4.6674232,94.1370842,110.3048578,0.0592413,23.6329242,24.5098219,43.4947925,7.734384,8.8582451,2.4592761,26.5110985),(50802,'metatarsal.tif',255,10,142,26.4797776,82.7723302,124.0582125,1.8,82.7534195,123.9938476,0.0993259,4.0813651,4.1020874,94.6154424,113.4378722,0.043397,27.6536945,23.1823028,47.5811154,8.164072,8.8582451,2.2531129,26.8670637),(50803,'metatarsal.tif',255,10,143,26.862357,82.7899686,124.1505401,1.8,82.7639118,124.0755695,0.0849974,4.0164611,4.0679852,96.6999885,117.9266689,0.0322669,28.9889622,24.0759178,48.1834832,8.164072,8.8582451,2.2531129,26.8670637),(50804,'metatarsal.tif',255,10,144,26.7147076,82.7998192,124.2455294,1.8,82.7642745,124.1209488,0.0540664,3.9573862,4.0342065,96.8725671,120.2441424,0.0130026,29.806145,24.478927,50.8010206,8.164072,8.7005189,2.5672878,26.6153583),(50805,'metatarsal.tif',255,10,145,26.8979406,82.8249311,124.3150552,1.8,82.8429322,124.1386917,0.0647968,4.0564511,5.0495583,99.5718234,126.365253,0.0187961,25.0250113,24.5465361,44.7115702,0.429688,0.6076706,2.3561945,1.2153412),(50806,'metatarsal.tif',255,10,146,27.2898635,82.8513314,124.4158365,1.8,82.8697201,124.1998533,0.0553843,4.1012478,5.0830817,99.8409339,131.3959472,0.0139373,25.8496625,24.3440381,45.4896562,8.164072,8.9721488,2.8501359,27.2230289),(50807,'metatarsal.tif',255,10,147,28.0386293,82.8991427,124.51067,1.8,82.9666988,124.4190398,0.0682286,4.0133139,4.353486,103.9552092,140.3857711,0.0217203,32.2467489,25.9025859,51.4713934,8.164072,9.8921606,2.1708465,29.1934863),(50808,'metatarsal.tif',255,10,148,28.469213,82.9112358,124.5890515,1.8,82.9584299,124.4619938,0.0808265,3.9428557,4.372377,106.3024657,146.4555025,0.0309304,33.4956252,26.9607803,54.7039674,8.164072,9.5406219,2.1962814,28.3341103),(50809,'metatarsal.tif',255,10,149,29.1270616,82.9611984,124.6789981,1.8,83.0114952,124.5249912,0.0522103,3.9745142,4.662706,108.073808,154.7511861,0.0132209,33.1891367,27.1917024,55.6642334,8.164072,9.4628966,2.2597207,28.3341103),(50810,'metatarsal.tif',255,10,150,29.832299,82.9633601,124.7964261,1.8,82.959794,124.5958791,0.0456827,4.0875802,4.6991829,112.2083162,162.0621165,0.010369,34.4872971,27.4510371,57.9445653,8.164072,9.6942031,2.9181161,28.9417809),(50811,'metatarsal.tif',255,10,151,31.4197407,83.0095411,124.9743995,1.8,82.9959897,124.8392927,0.0094744,4.231126,4.6512874,122.5349108,174.2926175,0.00047,37.4719091,28.9603552,61.7698662,8.59376,9.6942031,2.9181161,29.5494515),(50812,'metatarsal.tif',255,10,152,33.5989551,83.0626941,125.1796382,1.8,83.0584476,125.0780499,0.0777864,4.2543801,4.7024156,135.4572368,195.2517411,0.0338147,41.5215836,31.8394771,68.085764,8.59376,10.2135672,2.7532739,30.0528623),(50813,'metatarsal.tif',255,10,153,36.60532,83.0457152,125.4275922,1.8,82.9986229,125.4200426,0.0391153,4.8359706,5.0212815,159.793994,218.1168505,0.0093296,43.4384825,33.0427965,73.9741897,9.453136,10.2496576,0.5763752,31.6241687),(50814,'metatarsal.tif',255,10,154,39.4432223,83.072082,125.6465602,1.8,83.0665029,125.6467334,0.0971165,5.0939226,5.0147689,182.958017,249.9670863,0.0618076,49.8461826,35.916921,83.5719561,9.882824,10.7422,2.4980915,33.0912153),(50815,'metatarsal.tif',255,10,155,43.2051787,83.1301998,125.9057213,1.8,83.1253595,125.8359613,0.1272447,4.8702929,7.7079708,210.4258376,298.7187359,0.1159628,38.7545234,43.205992,62.7233361,9.882824,11.2787985,2.4370986,34.2022967),(50816,'metatarsal.tif',255,10,156,45.9589337,83.1761742,126.0948785,1.8,83.2502137,126.0225325,0.1330685,5.0058122,5.3233149,230.9597725,334.8859828,0.1348356,62.909294,46.1383219,97.6940468,10.312512,11.8845829,2.4329664,35.3133781),(50817,'metatarsal.tif',255,10,157,48.9960704,83.2361092,126.2862162,1.8,83.2865229,126.1939389,0.1369603,4.8921531,5.3320195,250.1004091,373.9149316,0.1522238,70.1263251,51.1227682,105.7489616,9.882824,12.1077509,0.4795193,35.8167889),(50818,'metatarsal.tif',255,10,158,52.5281323,83.2820711,126.3657937,1.8,83.3166779,126.2348236,0.1355724,4.9631385,5.4901564,265.0918636,401.7476295,0.1599266,73.1759898,53.4121426,108.5411757,9.882824,12.4905505,2.4292351,37.6398007),(50819,'metatarsal.tif',255,10,159,58.6711113,83.3792106,126.3026354,1.8,83.3672219,126.2258013,0.1465596,4.8986506,5.587192,280.4957911,438.8427622,0.2085402,78.5444217,57.2598073,112.5638704,9.882824,12.8188253,2.4511462,38.2474713),(50820,'metatarsal.tif',255,10,160,61.8028019,83.3418325,126.2239182,1.8,83.2847437,126.2393097,0.0904026,4.8871861,5.4337329,280.4373308,443.8201626,0.0839529,81.6786853,57.3821675,117.0585589,9.882824,12.4905505,2.4292351,37.0321301),(50821,'metatarsal.tif',255,10,161,57.2174437,83.2714992,126.1536105,1.8,83.2590505,126.1882613,0.0806246,4.6826287,5.3276212,242.8072722,377.2479633,0.0618545,70.8098319,51.8527704,103.017484,9.453136,11.9465628,2.483704,35.9210487),(50822,'metatarsal.tif',255,10,162,52.5195721,83.3760355,126.0666766,1.8,83.3605099,126.1850427,0.089347,4.6184511,5.3342343,200.018067,317.0047705,0.0696905,59.428355,43.3084734,87.6157742,9.023448,11.3522236,0.5144513,35.0616727),(50823,'metatarsal.tif',255,10,163,44.6684694,83.5141629,125.9069046,1.8,83.5183977,125.965686,0.0666318,3.942442,5.1615706,120.7581189,268.349259,0.0330043,51.9898459,30.6302844,69.197679,8.164072,11.2048922,2.5748634,32.2750251),(50824,'metatarsal.tif',255,10,164,35.9561435,83.3770003,125.8091568,1.8,83.3367822,125.8517863,0.036515,3.3452051,4.7875982,63.3627319,216.144117,0.0079868,45.1466699,18.9413595,53.2858195,6.875008,10.4635866,0.3347368,29.2366722),(50825,'metatarsal.tif',255,10,165,9.1896271,82.0210743,125.7175631,1.8,82.6649449,125.7175205,0.0086828,1.9789658,5.2106961,6.3606605,37.8189443,0.0001155,7.2579448,3.2141336,8.4291459,4.29688,9.0642783,0.0949517,23.0735945),(50826,'metatarsal.tif',255,10,166,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50827,'metatarsal.tif',255,10,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50828,'metatarsal.tif',255,10,168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50829,'metatarsal.tif',255,10,169,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50830,'metatarsal.tif',255,10,170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50831,'metatarsal.tif',255,10,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50832,'metatarsal.tif',255,10,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50833,'metatarsal.tif',255,10,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50834,'metatarsal.tif',255,10,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50835,'metatarsal.tif',255,10,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50836,'metatarsal.tif',255,10,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50837,'metatarsal.tif',255,10,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50838,'metatarsal.tif',255,10,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50839,'metatarsal.tif',255,10,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50840,'metatarsal.tif',255,10,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50841,'metatarsal.tif',255,10,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50842,'metatarsal.tif',255,10,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50843,'metatarsal.tif',255,10,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50844,'metatarsal.tif',255,10,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50845,'metatarsal.tif',255,10,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50846,'metatarsal.tif',255,10,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50847,'metatarsal.tif',255,10,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50848,'metatarsal.tif',255,10,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50849,'metatarsal.tif',255,10,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50850,'metatarsal.tif',255,10,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50851,'metatarsal.tif',255,10,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50852,'metatarsal.tif',255,10,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50853,'metatarsal.tif',255,10,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50854,'metatarsal.tif',255,10,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50855,'metatarsal.tif',255,10,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50856,'metatarsal.tif',255,10,196,0.0510815,74.5558096,117.5326104,1.8,74.550868,117.519668,0.7830244,0.3095218,0.3164669,0.003155,0.0031227,0.0042366,0.0098673,0.0101932,0.0198328,0.859376,1.2153412,2.3561945,2.4306824),(50857,'metatarsal.tif',255,10,197,0.6715561,75.2353152,117.5344706,1.8,75.2133037,117.573379,-0.3159738,0.7726193,1.4588706,0.1070366,0.3745096,0.0108077,0.256712,0.1385374,0.3274427,2.0389592,3.4642554,0.5191461,8.0471634),(50858,'metatarsal.tif',255,10,198,1.5642228,75.2396475,117.5156259,1.8,75.3386293,117.4787453,-0.3460993,1.0217298,2.1966945,0.3263282,1.7207122,0.0300012,0.7833188,0.319388,0.9306793,2.4464425,4.8040579,0.4636476,10.9812566),(50859,'metatarsal.tif',255,10,199,2.2449546,75.2790888,118.1124768,1.8,75.2094881,118.5657117,-1.1470304,2.1566891,9.5819674,2.4017172,13.1516089,0.3108954,1.3725374,1.113613,1.5930171,2.5410718,6.1521959,0.4324078,13.7679042),(50860,'metatarsal.tif',255,10,200,2.5149086,75.0781176,118.9659338,1.8,75.0301354,119.1954512,-1.2428082,2.2849792,9.251314,2.8153646,30.7886497,0.3756546,3.3280299,1.2321183,3.6112103,2.4989812,6.3442673,0.4939414,14.271315),(50861,'metatarsal.tif',255,10,201,3.8890166,74.484959,121.4627029,1.8,74.7022354,120.7569765,-1.2979092,2.6422431,7.1420275,3.4303752,82.1807709,0.6010882,11.5066445,1.2982814,11.9570314,29.3871365,76.1409076,0.3574497,283.1116265),(50862,'metatarsal.tif',255,10,202,5.7065206,74.1603235,123.0368986,1.8,74.5826967,121.7648263,-1.3381538,2.832435,7.4450325,4.1856189,112.3474685,0.9005335,15.0902591,1.4777458,14.6294953,29.4177387,76.6941925,0.3607379,292.4173169),(50863,'metatarsal.tif',255,10,203,10.8971913,74.2663191,124.4030218,1.8,74.8377555,123.2278286,-1.415581,5.8448237,8.5369527,10.5377967,156.1316149,1.7727933,18.2889166,1.8029281,18.3619387,7.5633504,9.4335845,2.6167969,27.1187691),(50864,'metatarsal.tif',255,10,204,19.7157085,75.6364525,124.8756011,1.8,76.3618843,124.6121561,-1.5605289,6.0541599,8.4604741,96.0842288,246.6840644,3.285605,29.1572387,15.8707782,38.3115987,9.453136,15.0881073,2.7928217,53.4824221),(50865,'metatarsal.tif',255,10,205,42.7649158,77.470529,125.7500361,1.8,77.3491448,125.3981655,1.1363617,5.3411616,9.397864,226.8546707,443.5101506,5.8648174,47.1926548,42.4729094,69.9849183,9.453136,15.3369125,2.9441971,40.4264483),(50866,'metatarsal.tif',255,10,206,42.7944009,77.584858,125.7973631,1.8,77.2980689,125.2858115,1.1212951,5.251342,9.4611912,190.2905623,400.0738394,5.7857709,42.2857789,36.2365583,61.1627751,9.023448,14.9158068,2.9385474,39.2111071),(50867,'metatarsal.tif',255,10,207,29.5558549,77.2969493,125.5159209,1.8,77.1723881,125.1450425,1.1583608,4.9081881,9.152278,126.5789984,327.7065853,4.1344989,35.8060131,25.7893535,48.7915353,8.164072,14.3415411,2.9912212,36.8846845),(50868,'metatarsal.tif',255,10,208,24.0021311,77.0355884,125.2480254,1.8,77.0480656,125.0869511,1.158179,4.7763023,8.8017466,103.73904,313.6421326,3.3570671,35.634079,21.7195298,46.412469,7.3393275,13.9896277,2.9562447,35.4176379),(50869,'metatarsal.tif',255,10,209,22.6084968,76.9453388,125.0881633,1.8,76.8755573,124.8783966,1.147753,4.7694354,8.5992214,92.5072548,315.0082379,3.1330065,36.6321815,19.3958503,46.2135477,6.6585923,13.4924769,2.9816795,33.3429207),(50870,'metatarsal.tif',255,10,210,22.2468983,76.85128,124.9842235,1.8,76.716985,124.7332593,1.1293003,4.8708585,8.4275667,85.0582278,317.0547719,3.0308473,37.6211524,17.4626768,46.2313007,6.1799,13.0047187,3.0090411,32.1275795),(50871,'metatarsal.tif',255,10,211,23.4550615,76.5456319,124.848096,1.8,76.5159745,124.5407699,1.1330475,4.674012,8.182713,85.0013078,321.2877609,3.2067267,39.26421,18.1859414,47.7400676,5.793012,12.5789281,3.0045265,30.6605329),(50872,'metatarsal.tif',255,10,212,23.7989242,76.3266231,124.6622936,1.8,76.3300676,124.3415112,1.1327536,4.7956145,8.103129,83.5966318,329.48294,3.2528437,40.661199,17.4318916,49.3890375,5.6180304,12.3043918,2.9304993,29.8011569),(50873,'metatarsal.tif',255,10,213,27.9949331,75.980599,124.4480597,1.8,76.1107614,124.1042517,1.1044216,5.1998351,7.6942423,86.9630264,346.8058343,3.7224577,45.0734228,16.7241891,52.8921961,11.5936924,14.5904229,1.8086323,48.5778715),(50874,'metatarsal.tif',255,10,214,28.9472414,75.8092459,124.329305,1.8,76.0433935,124.0460881,1.0864101,5.0292942,7.462843,86.1188145,336.1565673,3.7783669,45.044036,17.1234393,52.5752849,11.505555,14.6661522,1.0153026,47.3625303),(50875,'metatarsal.tif',255,10,215,28.3895975,75.7217057,124.3031827,1.8,76.0037961,123.9482375,1.0719921,5.1834361,7.3576349,88.559527,313.1498537,3.6488041,42.5612111,17.0851007,50.0670832,11.505555,14.4441652,1.0405806,47.1108249),(50876,'metatarsal.tif',255,10,216,25.3662242,75.8319459,124.2895236,1.8,75.9963863,123.9717253,1.0674701,5.1079203,7.3855663,77.7280689,290.3599758,3.2441128,39.3145175,15.2171655,46.0775255,11.4234167,14.6661522,1.0153026,47.2582705),(50877,'metatarsal.tif',255,10,217,25.2697681,75.8907722,124.4199018,1.8,76.063886,124.0143338,1.0231974,5.0255477,7.3941558,81.9043502,276.7129252,3.0700044,37.4231936,16.2975969,44.5297775,11.6545487,14.4441652,1.0405806,47.8659411),(50878,'metatarsal.tif',255,10,218,24.559719,76.1091059,124.5231901,1.8,76.1295043,124.0381595,0.9868656,5.1249724,7.4799,78.8153124,276.0618095,2.8491726,36.9071522,15.3786804,43.3374782,11.9186375,14.609392,1.080839,48.2219063),(50879,'metatarsal.tif',255,10,219,23.7294355,76.2935467,124.6728558,1.8,76.2522429,124.1577157,0.9179065,5.1496738,7.4634257,82.6844672,265.9262938,2.495398,35.6305943,16.0562534,41.6596602,12.2477722,14.4441652,1.0405806,48.7253171),(50880,'metatarsal.tif',255,10,220,22.1743324,76.5176676,124.6801479,1.8,76.4293758,124.2349202,0.8815041,5.2115732,7.4689161,77.8632332,267.5886902,2.2008588,35.8269777,14.940447,41.0323973,12.6760415,14.8972278,0.9907936,51.0517397),(50881,'metatarsal.tif',255,10,221,21.7163897,76.6580436,124.8670897,1.8,76.5526433,124.3161906,0.8071049,5.6989689,7.3915729,81.091146,258.0930386,1.88824,34.9172011,14.2290909,39.2955144,13.1448921,15.1369758,0.113792,52.5187863),(50882,'metatarsal.tif',255,10,222,20.6948724,76.9328735,124.9609102,1.8,76.6903899,124.4408877,0.7872756,5.3879524,7.5621701,75.211492,258.2336552,1.7310483,34.1480886,13.9591977,37.9479664,12.8239465,16.3507435,0.0525831,53.9858329),(50883,'metatarsal.tif',255,10,223,20.2347476,77.1066837,125.1831482,1.8,76.8417142,124.5420211,0.6922595,6.0549223,7.5487246,76.4539668,251.7833413,1.3739362,33.3544212,12.6267462,36.2859217,12.8228038,17.2357921,0.0748598,56.3122555),(50884,'metatarsal.tif',255,10,224,19.2370087,77.3536227,125.3612675,1.8,76.9443644,124.6430894,0.6622319,5.9683714,7.8618899,70.7218293,237.4333546,1.2121738,30.2005442,11.8494351,32.7384534,12.792812,18.1285566,3.0466409,58.1784531),(50885,'metatarsal.tif',255,10,225,18.4886345,77.6345931,125.5172591,1.8,77.0654022,124.6335825,0.6154671,6.2470012,8.0335794,67.4018157,234.2676593,1.0271097,29.1610561,10.7894674,31.2517214,12.3783817,19.3788812,3.0750245,60.7565811),(50886,'metatarsal.tif',255,10,226,17.7656053,77.8666452,125.6717099,1.8,77.1849638,124.7593692,0.5821793,6.2376138,8.1536918,64.7839301,228.3037164,0.8951797,28.0000423,10.3860118,29.6685721,12.3633858,20.665268,3.0791738,63.6474885),(50887,'metatarsal.tif',255,10,227,16.9612262,78.1890903,125.8162055,1.8,77.3730954,124.8344205,0.5466894,6.4486663,8.4503488,61.598675,227.2573383,0.7639802,26.8932496,9.5521574,28.5093078,12.3633858,22.0652214,3.0244839,67.9443685),(50888,'metatarsal.tif',255,10,228,16.3860143,78.3581155,125.9365434,1.8,77.5736297,125.0186577,0.5149222,6.4912541,8.4993309,58.8788144,226.3178965,0.6623333,26.627731,9.0704836,27.6670889,12.5714533,23.4563999,2.9945143,70.6267562),(50889,'metatarsal.tif',255,10,229,15.401815,78.6710211,126.0628917,1.8,77.7545153,125.1399755,0.4924971,6.6279197,8.7181041,55.1177799,223.9213916,0.573887,25.6846431,8.316,26.4510022,12.4296397,26.4354171,3.0111893,76.4949426),(50890,'metatarsal.tif',255,10,230,14.7841378,78.8735405,126.1947668,1.8,77.8566934,125.2649427,0.4756678,6.5891442,9.053978,51.7677739,218.0945644,0.5167102,24.0882587,7.8565247,25.0952473,12.3921899,27.2877254,3.0152845,78.0051751),(50891,'metatarsal.tif',255,10,231,13.9985016,79.1725501,126.3211861,1.8,78.0606655,125.4057665,0.4725383,6.40515,9.3625291,48.3218863,212.2270702,0.4833206,22.6677075,7.544224,24.0917881,11.9917466,28.1404636,3.0191316,79.9756325),(50892,'metatarsal.tif',255,10,232,13.4167996,79.4150826,126.4592942,1.8,78.2616202,125.6503662,0.462241,6.3133206,9.5906828,45.4451329,204.1249786,0.444713,21.2836754,7.1982932,22.5762989,11.9505628,28.9457943,3.0374927,81.6511986),(50893,'metatarsal.tif',255,10,233,12.8732549,79.6450236,126.5470984,1.8,78.3789975,125.7206324,0.4608772,6.301724,9.8288958,43.4734429,208.5199296,0.4243631,21.2149902,6.8986587,22.4067689,11.8457885,29.0476715,3.0080636,81.6943845),(50894,'metatarsal.tif',255,10,234,12.5053341,79.8572071,126.6885699,1.8,78.6003519,125.928966,0.4418691,6.3261231,9.9851715,41.0422697,202.5360743,0.3811359,20.283685,6.4877444,21.223589,11.8841808,29.8996165,3.0118901,83.2656908),(50895,'metatarsal.tif',255,10,235,12.1356229,80.2156467,126.8485351,1.8,78.7266938,126.0578085,0.4222648,6.2957912,10.2741875,38.7529024,198.4680894,0.3397134,19.3171567,6.1553665,20.3045009,11.57034,29.9582221,2.9976672,83.5173962),(50896,'metatarsal.tif',255,10,236,11.8096639,80.5355425,127.0004495,1.8,79.0897302,126.2649496,0.412491,6.2248057,10.5751238,36.8379306,189.0256542,0.3163314,17.8745571,5.9179245,18.8328796,11.5476676,30.3835299,2.9996956,84.8369972),(50897,'metatarsal.tif',255,10,237,11.5150923,80.872017,127.1311347,1.8,79.3041463,126.4420813,0.3928297,6.4113448,10.8260846,34.7788134,187.1205575,0.281235,17.284232,5.4245738,18.043112,11.5142544,31.1279226,3.0309354,85.4446678),(50898,'metatarsal.tif',255,10,238,11.1967424,81.1752912,127.2739317,1.8,79.6418399,126.686741,0.3748012,6.2161228,11.0563288,32.1657671,178.0366354,0.2500981,16.10269,5.1745708,16.7722236,11.144328,31.2965106,2.9899872,85.9480786),(50899,'metatarsal.tif',255,10,239,10.8725737,81.5283373,127.4231019,1.8,79.8697407,126.8529187,0.3711565,6.26443,11.4178554,29.6839497,171.9722913,0.2383748,15.0616981,4.7384917,15.6608772,11.3731199,31.3642808,2.976444,86.199784),(50900,'metatarsal.tif',255,10,240,10.6113477,81.8245202,127.5672151,1.8,80.1355982,127.0055768,0.3543504,6.3252628,11.6439919,27.2272909,163.0087724,0.2129272,13.999389,4.3045312,14.4330603,11.3353258,31.7213365,2.9920329,86.660009),(50901,'metatarsal.tif',255,10,241,10.2860042,82.2278523,127.7470913,1.8,80.4119631,127.2705702,0.3201624,6.3417454,11.7302931,23.1246366,149.7843946,0.1698032,12.7690241,3.6464152,13.0290459,10.9088406,31.7882009,2.9786662,86.660009),(50902,'metatarsal.tif',255,10,242,10.1511111,82.5349594,127.8914212,1.8,80.7585958,127.3974368,0.2890352,6.7418605,11.8669572,20.6770563,139.8786737,0.1374473,11.7872401,3.0669659,11.8157632,10.9612064,32.2122739,2.9808299,87.05916),(50903,'metatarsal.tif',255,10,243,10.0143157,82.8708846,128.0187446,1.8,80.9924624,127.5900148,0.2522008,7.0913819,11.9722115,18.462965,138.0024336,0.1039287,11.5268957,2.6035779,11.2445342,10.9760714,32.6364937,2.9829374,87.1634198),(50904,'metatarsal.tif',255,10,244,9.9125444,83.159404,128.136907,1.8,81.2889287,127.7103094,0.2173559,7.2304105,11.9324463,16.242867,132.1651155,0.0768293,11.0761123,2.2464654,10.6734989,10.6622305,32.9965694,2.997854,87.6668306),(50905,'metatarsal.tif',255,10,245,9.8208999,83.4874313,128.2784709,1.8,81.545505,127.9103051,0.1661652,7.4716213,11.8274417,12.864128,132.2574037,0.0447795,11.1822494,1.7217318,10.4015336,10.2583205,32.7071325,2.9699646,87.519385),(50906,'metatarsal.tif',255,10,246,9.7319969,83.770717,128.4088982,1.8,81.8021635,128.0892477,0.1240789,7.9859879,11.8028486,9.5917097,127.5751552,0.0248437,10.8088445,1.2010674,9.6252534,10.2059548,33.0608548,2.9849908,87.1634198),(50907,'metatarsal.tif',255,10,247,9.3736434,83.9662759,128.4959627,1.8,81.9030295,128.2044097,0.1125368,7.7592651,11.8657349,8.0932931,130.3323846,0.0197021,10.9839286,1.0430489,9.7637493,9.9382852,33.1305888,2.9721796,87.4151252),(50908,'metatarsal.tif',255,10,248,9.3287723,84.2175646,128.5847132,1.8,82.1892041,128.3200023,0.0935487,7.6202406,11.934613,6.4818898,130.3717039,0.0135669,10.9238317,0.8506148,9.6648631,10.0558703,33.4853518,2.9869921,87.2676796),(50909,'metatarsal.tif',255,10,249,9.2233644,84.4609494,128.6612386,1.8,82.4029914,128.4281597,0.0833234,7.3696812,12.0692191,5.2454576,135.0723184,0.010648,11.1914712,0.7117618,9.9225046,9.6293851,33.4218828,2.9996956,86.7642688),(50910,'metatarsal.tif',255,10,250,9.2275046,84.6752588,128.7331487,1.8,82.6876394,128.5241913,0.0771113,1.8698592,11.7459026,4.4726511,138.6323714,0.0091266,11.8026155,2.3919722,12.1328301,9.6408116,33.5542036,2.9743387,86.5557492),(50911,'metatarsal.tif',255,10,251,8.9223027,84.7986784,128.7780152,1.8,82.745973,128.5698111,0.078605,1.9110751,11.8403137,4.2636641,142.5979639,0.0091692,12.0434278,2.231029,12.3841449,9.2303596,33.2057371,2.9594243,85.9480786),(50912,'metatarsal.tif',255,10,252,8.8139294,84.9101974,128.8269513,1.8,82.7970152,128.6118947,0.0791491,1.9532216,11.9557116,4.1927154,148.2469442,0.0091834,12.3996755,2.1465641,12.7288006,9.1817175,33.4853518,2.9869921,85.800633),(50913,'metatarsal.tif',255,10,253,8.7668763,85.0919296,128.8576819,1.8,82.9176459,128.6466451,0.0784945,2.0007521,12.1388357,4.1650648,157.2610702,0.0089842,12.9552022,2.0817496,13.2749644,8.7289217,33.1305888,2.9721796,85.1929624),(50914,'metatarsal.tif',255,10,254,8.7209421,85.2201504,128.898538,1.8,83.1674327,128.7167612,0.0763275,2.0227381,12.268209,4.1160146,161.8670634,0.0084514,13.1940256,2.0348727,13.5024284,8.3015876,33.4218828,2.9996956,84.481032),(50915,'metatarsal.tif',255,10,255,8.68161,85.3346024,128.9244687,1.8,83.3236647,128.7727193,0.0755442,2.0368134,12.3512491,4.0238358,169.6259465,0.0082419,13.7335054,1.9755545,14.0527781,7.8293388,33.0608548,2.9849908,82.1977953),(50916,'metatarsal.tif',255,10,256,8.7306773,85.3986554,128.9524867,1.8,83.3127668,128.7756254,0.0758248,2.0609923,12.4173456,3.9478732,178.6506342,0.00835,14.3871839,1.9155206,14.6976573,7.6258485,33.3638275,3.0124454,82.0503497),(50917,'metatarsal.tif',255,10,257,8.7181447,85.5938838,128.9718557,1.8,83.3921657,128.7943075,0.0745257,1.7282769,12.6129497,3.9099228,188.4476553,0.0080553,14.9408076,2.2623244,15.2424899,7.5660195,32.9965694,2.997854,80.3747835),(50918,'metatarsal.tif',255,10,258,8.6110023,85.6438667,128.9813947,1.8,83.4238103,128.8121903,0.0720016,1.7216819,12.6623977,3.8027285,193.6103508,0.0074274,15.2901808,2.2087288,15.5804724,7.1005169,33.3112141,3.0252375,79.5154075),(50919,'metatarsal.tif',255,10,259,8.5495143,85.7945853,128.9788746,1.8,83.4635017,128.8159394,0.0680632,1.6895695,12.8107085,3.7065722,202.6917696,0.0065909,15.8220577,2.1937968,16.0995511,6.7042865,32.9965694,2.997854,78.1958065),(50920,'metatarsal.tif',255,10,260,8.4536736,85.8704349,128.9875907,1.8,83.5698862,128.8222343,0.0655472,1.7094479,12.8856893,3.6013724,206.0286927,0.0060448,15.988954,2.106746,16.2548324,6.2387838,33.2640683,3.038068,77.9441011),(50921,'metatarsal.tif',255,10,261,8.2327869,85.9262408,128.9813767,1.8,83.5567777,128.8187086,0.062672,1.6850155,12.9394268,3.3806367,215.4557155,0.0053824,16.651102,2.0062942,16.8968483,5.8481806,32.9377644,3.0107653,76.0168295),(50922,'metatarsal.tif',255,10,262,7.8663208,86.2193583,129.0099636,1.8,84.1628017,128.9180763,0.0532682,1.6730631,13.2049842,3.2070421,200.7855473,0.0037166,15.2052849,1.9168685,15.445152,5.382678,33.2640683,3.038068,75.7651241),(50923,'metatarsal.tif',255,10,263,7.5271578,86.2155928,128.9969233,1.8,84.0169181,128.911096,0.0501934,1.644162,13.1997066,3.0264913,204.7354457,0.003158,15.5106058,1.84075,15.7361453,4.9420822,32.9377644,3.0107653,74.8014883),(50924,'metatarsal.tif',255,10,264,7.2367824,86.2461843,129.0051931,1.8,83.9851166,128.9182046,0.0488181,1.6437322,13.2302566,2.8454752,202.6055531,0.0028722,15.3138037,1.7311063,15.5245353,4.7959629,33.2224136,3.0509328,75.5134187),(50925,'metatarsal.tif',255,10,265,6.6715854,86.2455856,128.9945148,1.8,83.9736588,128.8918343,0.0473145,1.6252682,13.228668,2.5237117,192.6685526,0.0024874,14.5644711,1.5527971,14.750873,4.3673215,33.3112141,3.0252375,74.1938177),(50926,'metatarsal.tif',255,10,266,6.3039443,86.1743816,129.0055379,1.8,83.747656,128.9064,0.0441363,1.6228657,13.1569291,2.2801115,188.5208942,0.0020454,14.3286396,1.4049909,14.4959476,4.3163975,33.6914851,3.0393859,74.8014883),(50927,'metatarsal.tif',255,10,267,5.6529215,85.7662088,129.0206552,1.8,83.5987301,128.9430211,0.0353639,1.6060013,12.7305282,1.9322836,180.6649529,0.0011778,14.1914735,1.2031644,14.3428668,4.2217023,34.0783491,3.0532159,75.5134187),(50928,'metatarsal.tif',255,10,268,5.1991749,85.5718147,129.0604046,1.8,83.5221941,128.9953886,0.0323029,1.6345407,12.5371723,1.6797331,173.9106612,0.0009039,13.8716018,1.0276484,14.0041568,3.8036757,34.0783491,3.0532159,75.6608643),(50929,'metatarsal.tif',255,10,269,4.8771883,85.5446197,129.0844475,1.8,83.6379735,129.033715,0.0263787,1.6242994,12.5093413,1.4342139,165.4910099,0.0005655,13.2293945,0.8829739,13.3407546,4.0747787,34.0783491,3.0532159,75.6608643),(50930,'metatarsal.tif',255,10,270,4.5611882,85.520256,129.1147242,1.8,83.5798964,129.0654404,0.0241456,1.6418905,12.4850638,1.2297596,155.4038938,0.0004431,12.4471846,0.74899,12.5411239,3.6903402,34.0132727,3.0783858,74.3412633),(50931,'metatarsal.tif',255,10,271,4.4447023,85.3579901,129.1486127,1.8,83.291911,129.0901659,0.0187115,1.6463685,12.3214466,1.2042994,158.0317127,0.0002593,12.8257435,0.7314884,12.9151975,3.5569659,33.9698191,3.1036362,73.4818873),(50932,'metatarsal.tif',255,10,272,4.2204586,85.4284043,129.2141834,1.8,83.5573546,129.1721281,0.0126021,1.3448765,12.3843397,1.1052002,146.3092334,0.0001117,11.814052,0.8217856,11.89428,3.437504,33.1556572,3.0767486,72.7699569),(50933,'metatarsal.tif',255,10,273,4.2585599,85.3896328,129.272562,1.8,83.6305503,129.2236193,0.0059638,1.3211098,12.344637,1.0554383,147.2724406,0.0000252,11.9300746,0.7989028,12.0079012,3.867192,32.2981353,0.0665682,71.1554647),(50934,'metatarsal.tif',255,10,274,4.3124388,85.0157649,129.3384015,1.8,83.4333674,129.3005087,-0.0035018,1.3095316,11.9717328,1.1288087,159.335137,0.0000088,13.3092795,0.8619942,13.3726062,3.437504,31.8085231,0.0270204,68.7247823),(50935,'metatarsal.tif',255,10,275,4.5969396,84.69052,129.4249406,1.8,83.514486,129.3796007,-0.0116484,1.2982313,11.6567503,1.2105624,169.3810661,0.000104,14.5307278,0.9324705,14.5739351,3.4594777,29.6982491,0.0579062,65.3915381),(50936,'metatarsal.tif',255,10,276,5.124483,84.4004633,129.5307311,1.8,83.052552,129.5362532,-0.0177052,1.2203582,11.3710998,1.281479,194.4627631,0.0002677,17.1014912,1.0500844,17.16132,3.0545269,28.4406719,0.0756131,62.7091503),(50937,'metatarsal.tif',255,10,277,6.2268466,83.7567177,129.5654544,1.8,83.1035376,129.5356699,-0.029493,1.2882702,10.7363492,1.6049504,225.4929871,0.0009025,21.0027619,1.2458182,21.1017225,2.802203,25.795599,0.033321,55.7298825),(50938,'metatarsal.tif',255,10,278,6.4647978,82.4148151,129.6603621,1.8,82.3030568,129.6684434,-0.0403129,1.2791537,9.4164443,1.5119275,218.7740557,0.0017501,23.2331916,1.1819748,23.2588131,2.6805956,23.2389317,0.0554985,49.6099907),(50939,'metatarsal.tif',255,10,279,5.4128442,80.9434685,129.6936965,1.8,80.9173212,129.7113851,-0.0611709,1.0932793,8.4377269,1.1684329,117.1859223,0.0033715,13.8883284,1.0687414,14.0243312,2.5824966,17.700851,0.0972532,38.333843),(50940,'metatarsal.tif',255,10,280,2.4615332,81.2523444,129.6035052,1.8,81.0722786,129.6359744,-0.0799025,0.8093102,6.0848683,0.3933546,25.596765,0.0026137,4.2066259,0.4860369,4.2706151,2.0561815,12.5789281,0.1370662,26.9534354),(50941,'metatarsal.tif',255,10,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50942,'metatarsal.tif',255,10,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50943,'metatarsal.tif',255,10,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50944,'metatarsal.tif',255,10,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50945,'metatarsal.tif',255,10,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50946,'metatarsal.tif',255,10,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50947,'metatarsal.tif',255,10,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50948,'metatarsal.tif',255,10,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50949,'metatarsal.tif',255,10,289,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50950,'metatarsal.tif',255,10,290,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50951,'metatarsal.tif',255,10,291,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50952,'metatarsal.tif',255,10,292,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50953,'metatarsal.tif',255,10,293,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50954,'metatarsal.tif',255,10,294,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50955,'metatarsal.tif',255,10,295,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50956,'metatarsal.tif',255,10,296,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50957,'metatarsal.tif',255,10,297,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50958,'metatarsal.tif',255,10,298,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50959,'metatarsal.tif',255,10,299,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50960,'metatarsal.tif',255,10,300,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50961,'forelimb',41,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50962,'forelimb',41,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50963,'forelimb',41,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50964,'forelimb',41,2,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50965,'forelimb',41,2,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50966,'forelimb',41,2,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50967,'forelimb',41,2,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50968,'forelimb',41,2,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50969,'forelimb',41,2,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50970,'forelimb',41,2,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50971,'forelimb',41,2,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50972,'forelimb',41,2,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50973,'forelimb',41,2,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50974,'forelimb',41,2,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50975,'forelimb',41,2,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50976,'forelimb',41,2,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50977,'forelimb',41,2,17,1.1806363,82.6322685,126.7189863,1.8,82.8098711,126.6880108,0.0156061,0.9271249,2.882607,0.2190314,2.6053239,0.0000479,0.9038082,0.236248,0.9693751,2.578128,9.115059,2.9996956,20.1826872),(50978,'forelimb',41,2,18,3.1610639,84.0587883,126.8308561,1.8,84.4621653,126.8459684,0.0542057,0.962894,4.9220612,0.6620591,17.2177279,0.0015465,3.4980727,0.6875722,3.6124334,2.578128,15.0942245,3.0560874,32.5699164),(50979,'forelimb',41,2,19,5.7322572,86.5025545,126.9718331,1.8,86.8931748,127.0176968,0.0915767,1.1659957,7.2377129,1.3389654,78.1603701,0.0079897,10.7990426,1.148345,10.9660249,2.9146822,20.6965148,3.0584514,44.2020293),(50980,'forelimb',41,2,20,6.6918389,87.7868111,127.0374803,1.8,87.9870987,127.0463033,0.0999225,1.2758029,8.0942488,1.6139795,120.6800345,0.0110988,14.9093557,1.2650696,15.1039998,3.0180332,23.3024045,3.0492633,49.9659559),(50981,'forelimb',41,2,21,7.7568286,89.5580734,127.1080367,1.8,89.804792,127.1406876,0.1050582,1.4268637,9.3625814,1.9772707,211.0820715,0.0142166,22.5452856,1.385746,22.7368565,3.2404633,26.7651134,3.0451189,57.4486345),(50982,'forelimb',41,2,22,8.3515667,90.7860815,127.127598,1.8,91.1359823,127.1686912,0.0982354,1.4686167,11.0868752,2.0590081,299.860284,0.0133892,27.0464202,1.4020051,27.2289817,3.2104715,30.1547924,3.0702852,64.0719371),(50983,'forelimb',41,2,23,9.3937291,92.9322592,127.1174128,1.8,92.9226934,127.1166252,0.0815783,1.488413,12.3760098,2.2762697,489.8930471,0.0103962,39.584087,1.5293266,39.7671998,3.4258688,33.6146765,3.0648208,71.8063211),(50984,'forelimb',41,2,24,10.1309694,94.2579733,127.0915398,1.8,93.8664056,127.0504092,0.0743114,1.2237454,13.5280049,2.4899647,639.7118188,0.009307,47.2879649,2.0347082,47.4673868,3.4858524,35.7571679,3.069429,75.5997903),(50985,'forelimb',41,2,25,10.5475658,95.1575018,126.9411759,1.8,94.6379863,126.8773178,0.0625737,1.301922,14.4132186,2.7070225,766.190627,0.0068741,53.1588849,2.0792509,53.3441271,3.4834375,37.0429935,3.0719381,78.7855889),(50986,'forelimb',41,2,26,10.9758556,95.7546093,126.8429334,1.8,95.3041801,126.8012379,0.0536404,1.4579928,15.0023602,2.9658112,860.4091511,0.0052584,57.3515859,2.0341741,57.5467626,3.479198,37.9003328,3.0735162,80.5043409),(50987,'forelimb',41,2,27,11.6529507,96.604901,126.6747675,1.8,96.0022715,126.6171749,0.0421025,1.3812263,15.8422041,3.459113,981.2562424,0.0034407,61.9393765,2.5043781,62.1562403,3.3248825,38.3290367,3.0742788,81.8671277),(50988,'forelimb',41,2,28,12.5191535,97.6072624,126.5882759,1.8,96.4685487,126.55102,0.0361054,1.5174071,16.8398487,3.9443703,1099.4124632,0.0027188,65.2863624,2.5994147,65.5198165,3.426124,39.1605866,3.0867028,83.3341743),(50989,'forelimb',41,2,29,13.1985984,98.259852,126.365324,1.8,96.7586935,126.3099574,0.025093,1.826937,17.4847162,4.6883564,1177.7103497,0.0013848,67.3565607,2.5662386,67.5739749,3.8407969,39.1605866,3.0867028,84.4020699),(50990,'forelimb',41,2,30,13.5891786,98.6100568,126.2097051,1.8,96.8386878,126.162476,0.0175828,1.6594403,17.8314271,5.0425006,1212.8060882,0.0007001,68.0150884,3.0386756,68.2057432,3.437504,39.9817699,3.1093458,84.6537753),(50991,'forelimb',41,2,31,13.6295178,98.5537298,125.9512512,1.8,96.761844,125.9500353,0.0035908,1.6280581,17.7724603,5.1069976,1194.6906508,0.0000293,67.2214556,3.1368645,67.3463199,3.5869622,39.9979293,3.0986084,85.4088915),(50992,'forelimb',41,2,32,13.8996397,98.7158947,125.7653851,1.8,96.8564809,125.8052965,-0.0086508,1.9569324,17.9461832,5.2073142,1185.1432512,0.0001734,66.0387357,2.6609577,66.1641941,4.0090857,40.4272247,0.0425275,87.3361631),(50993,'forelimb',41,2,33,14.1031263,98.5175386,125.5146449,1.8,96.6742735,125.5600838,-0.0236215,1.9640449,17.7707618,5.4629311,1167.8819921,0.0013113,65.7192979,2.7814696,65.8630304,4.2083736,40.8565282,0.0420804,88.2997989),(50994,'forelimb',41,2,34,14.3371051,98.4639041,125.355074,1.8,96.7713949,125.4271395,-0.0344861,1.8294436,17.7352321,5.6805634,1170.8043903,0.0028407,66.0157354,3.1050771,66.1791763,4.3341429,41.3059591,0.0520363,89.1591749),(50995,'forelimb',41,2,35,14.7756335,98.3678513,125.1209589,1.8,96.6433171,125.2378374,-0.0502456,1.9237024,17.6896915,6.0245622,1183.9830567,0.0062119,66.9306784,3.1317538,66.9943635,4.4370791,42.1641955,0.0509762,90.6262215),(50996,'forelimb',41,2,36,14.8447865,98.3050748,124.9814125,1.8,96.4903529,125.1490324,-0.0606316,1.7686982,17.6512527,6.1757539,1169.2822435,0.0090842,66.243584,3.4916946,66.3318447,4.2325406,42.2167093,0.0713075,90.8779269),(50997,'forelimb',41,2,37,15.3903455,98.3194322,124.7610709,1.8,96.4988787,124.9487474,-0.074292,2.0651462,17.701714,6.9150778,1178.6147923,0.0141313,66.5819588,3.3484689,66.7184245,4.698094,42.6453164,0.0705896,92.5534931),(50998,'forelimb',41,2,38,15.6183937,98.2119209,124.6333445,1.8,96.5157373,124.8282703,-0.0835838,2.1468101,17.6188481,7.3907894,1185.5380921,0.0181433,67.2880589,3.4426843,67.4575128,4.96135,42.7145318,0.0906599,93.4128691),(50999,'forelimb',41,2,39,15.9741735,98.0564441,124.4515028,1.8,96.3929006,124.6729816,-0.0968476,1.960197,17.5002722,8.0093386,1207.6385945,0.0248936,69.0068462,4.0859866,69.2172457,4.7661118,42.7145318,0.0906599,93.0569039),(51000,'forelimb',41,2,40,16.1286488,97.9608806,124.3393273,1.8,96.4459026,124.5753552,-0.1055509,2.2235789,17.4292815,8.8640824,1217.2085725,0.0298371,69.8369909,3.9864033,70.1034473,5.1318805,42.7145318,0.0906599,93.5171289),(51001,'forelimb',41,2,41,16.5928578,97.7935701,124.1587816,1.8,96.3336987,124.4083894,-0.1179127,2.3893733,17.3009622,9.8736189,1245.7957198,0.0382717,72.0073082,4.1323049,72.3302429,5.3569746,42.3738603,0.111777,93.5171289),(51002,'forelimb',41,2,42,16.4237239,97.5207676,124.085805,1.8,96.232047,124.3449974,-0.1242619,2.3032182,17.0480592,10.7512262,1242.3917687,0.0420494,72.8758477,4.6679147,73.2494044,5.2754653,42.3280849,0.1016889,93.5171289),(51003,'forelimb',41,2,43,16.7675866,97.3829353,123.9402485,1.8,96.4573284,124.1874596,-0.1339655,2.5170941,16.9439724,12.2703486,1263.6338058,0.0498547,74.5771873,4.8748073,75.0358168,5.6061725,42.0523859,0.1332268,93.0137181),(51004,'forelimb',41,2,44,16.8309769,97.2109684,123.8448183,1.8,96.169305,124.1015903,-0.1423515,2.7793237,16.7986524,13.1948618,1256.3152028,0.0564607,74.7866657,4.7475081,75.3097624,5.8696904,41.9974686,0.123086,93.1179779),(51005,'forelimb',41,2,45,16.7363671,96.9135776,123.7349336,1.8,96.1401624,123.9877362,-0.1519753,2.9973142,16.5340534,15.2732037,1252.1805977,0.0639307,75.7334311,5.0956299,76.3856315,6.1916851,41.6863801,0.1448125,93.1179779),(51006,'forelimb',41,2,46,16.6329733,96.7872957,123.6495961,1.8,96.2148297,123.8912732,-0.158705,2.9893117,16.499769,16.7929351,1244.0006718,0.0692389,75.3950356,5.6176595,75.9558515,6.3488264,41.6265448,0.1345979,93.3264974),(51007,'forelimb',41,2,47,16.8433976,96.6413099,123.5110109,1.8,96.2137827,123.7526495,-0.1688748,3.1991448,16.3967325,19.0981162,1243.5377382,0.0793004,75.840582,5.9697567,76.5425148,6.649196,41.2612363,0.1463153,93.5782028),(51008,'forelimb',41,2,48,16.5887176,96.4458401,123.4441306,1.8,96.035898,123.6795794,-0.1752724,3.4878286,16.2271374,20.6228071,1225.2481654,0.0840692,75.5061187,5.9127925,76.3085286,6.9294344,41.5710649,0.124355,93.934168),(51009,'forelimb',41,2,49,16.7561171,96.3158588,123.3383228,1.8,96.0849429,123.5601375,-0.1837255,3.4691278,16.1333171,23.3445701,1225.4783698,0.0932114,75.9594797,6.7292331,76.9336455,7.0178989,41.2612363,0.1463153,93.8299082),(51010,'forelimb',41,2,50,16.6714103,96.2344747,123.2617309,1.8,96.0365027,123.4957885,-0.1903168,3.7677629,16.0793483,25.4549808,1216.8339326,0.0994319,75.676819,6.7559932,76.7930961,7.4154987,41.2612363,0.1463153,94.5418386),(51011,'forelimb',41,2,51,17.1972192,96.1370623,123.1322923,1.8,96.0900322,123.3613787,-0.2011843,3.9866531,16.1139775,29.1675942,1260.9715417,0.1144532,78.2532766,7.3163111,79.3483563,7.6403754,40.9016935,0.1582403,94.0816137),(51012,'forelimb',41,2,52,17.1549777,95.9890407,123.0784365,1.8,95.9689281,123.2888076,-0.2082141,4.0435537,15.9951287,31.7933024,1271.8394891,0.1221727,79.5141766,7.8627131,80.7833631,7.7191222,40.9016935,0.1582403,93.7256485),(51013,'forelimb',41,2,53,17.300613,95.7310558,123.0312256,1.8,95.8334808,123.2219364,-0.2160864,4.3252127,15.7696014,36.6828736,1313.261302,0.1325546,83.2780277,8.4811722,84.8455835,8.1422823,40.54807,0.1703751,93.7256485),(51014,'forelimb',41,2,54,17.5883588,95.5359295,122.9921718,1.8,95.7529523,123.1227758,-0.2229697,4.7235241,15.6021156,40.6765276,1356.9830225,0.1433365,86.9742962,8.6114788,88.7912248,8.6245836,40.4774307,0.1599131,94.5418386),(51015,'forelimb',41,2,55,18.1792924,95.2557859,122.9468213,1.8,95.7071638,123.0460628,-0.2316552,4.9906498,15.4957311,46.0819359,1429.9221855,0.1597082,92.2784589,9.2336545,94.243576,8.968772,40.1246694,0.1721908,94.5418386),(51016,'forelimb',41,2,56,18.4295524,95.0816662,122.9233469,1.8,95.9272776,122.9135028,-0.2369464,5.1006292,15.6472304,50.0693896,1479.5121712,0.1692469,94.5542525,9.8163164,96.6066041,9.0088129,40.1246694,0.1721908,94.6892842),(51017,'forelimb',41,2,57,19.0420263,94.6207566,122.9033539,1.8,95.5187282,122.8427709,-0.2479681,5.3331765,16.0615248,56.6304189,1562.9536039,0.1911763,97.3104124,10.6185158,99.4169,9.4306063,39.701404,0.1740452,94.3333191),(51018,'forelimb',41,2,58,19.4817297,94.3422087,122.9114142,1.8,95.3155686,122.8189663,-0.2514222,5.6697079,16.3238166,60.9143952,1625.7395771,0.2009616,99.5931049,10.743833,101.7949041,9.7044825,39.6292556,0.1633661,94.0816137),(51019,'forelimb',41,2,59,19.888647,93.8553156,122.9582676,1.8,95.2766693,122.7523376,-0.2561184,5.782824,16.9020283,66.4562901,1710.4397851,0.212725,101.1973095,11.4920133,103.9257144,9.8610914,39.2782781,0.1759396,94.5850245),(51020,'forelimb',41,2,60,20.1024282,93.5226392,122.9732999,1.8,95.185859,122.6726017,-0.2605769,6.1030339,17.2156777,71.6669897,1755.8536542,0.2223909,101.99155,11.7428464,104.848008,10.2783188,39.205351,0.1651487,95.4012146),(51021,'forelimb',41,2,61,20.7034326,93.2170773,122.999532,1.8,95.0321075,122.6753688,-0.2616949,6.154016,17.5145642,71.6564264,1807.7218332,0.2309642,103.2124928,11.643848,105.9591013,10.3566232,38.7815737,0.1669702,94.8978038),(51022,'forelimb',41,2,62,21.0691713,92.994904,122.9945541,1.8,95.1980799,122.554161,-0.2639057,6.3814139,17.7215157,76.5125876,1850.8904265,0.2389395,104.443122,11.9899115,107.3324032,10.4349276,38.4324631,0.1798535,93.4739431),(51023,'forelimb',41,2,63,21.4215383,92.6751879,122.9922364,1.8,94.7779729,122.5547714,-0.2685084,6.3786842,18.0156226,79.3453548,1852.1907732,0.2512771,102.810256,12.4391415,105.6917148,10.4381698,38.3579279,0.1688319,93.6824626),(51024,'forelimb',41,2,64,21.7076616,92.5463707,122.9323846,1.8,94.7552669,122.4450867,-0.2747299,6.6600484,18.2204972,84.9357132,1850.9348949,0.2662685,101.585312,12.7530173,104.9615192,10.8599633,37.934418,0.1707352,93.6824626),(51025,'forelimb',41,2,65,22.1497708,92.370066,122.8993435,1.8,94.550696,122.4245565,-0.2787645,6.6712509,18.3692162,87.8333912,1837.1382284,0.2795207,100.0117918,13.1659554,103.4106268,10.9419516,37.2467874,0.1973956,92.9705322),(51026,'forelimb',41,2,66,22.7748333,92.2837674,122.8777981,1.8,94.3800167,122.4420298,-0.2800167,6.6186847,18.4424106,89.8902453,1852.1667979,0.2899285,100.4297562,13.5812854,103.8639779,10.9419516,37.1649072,0.1860582,92.3628617),(51027,'forelimb',41,2,67,22.4757298,92.5069902,122.7290908,1.8,94.4921046,122.3051192,-0.2790389,6.8382606,18.1898674,92.249733,1785.6921418,0.2841782,98.1696072,13.4902335,101.7317636,11.1997683,36.6647511,0.1767089,90.8958151),(51028,'forelimb',41,2,68,22.6601937,92.5289746,122.717521,1.8,94.5132791,122.3079239,-0.2756678,6.9727738,18.293019,92.3867717,1790.7808533,0.2798049,97.8942212,13.2496442,101.8610582,11.2817567,36.1678883,0.1671018,90.1406988),(51029,'forelimb',41,2,69,22.8508121,92.8998066,122.6244074,1.8,94.6301986,122.2498774,-0.2659207,7.1542465,17.9359583,95.7106244,1802.3283125,0.2630229,100.4868704,13.3781559,104.8184471,11.4727583,35.7442569,0.1691012,89.9932532),(51030,'forelimb',41,2,70,22.9559962,93.2695611,122.5592846,1.8,94.7699583,122.1549141,-0.2538289,7.249085,17.5904861,95.633437,1831.2064884,0.2412569,104.1020971,13.1924838,108.6594288,11.4055514,34.9740693,0.1853479,88.1702414),(51031,'forelimb',41,2,71,24.3831999,94.0048142,122.4388281,1.8,95.2634983,122.0522506,-0.2343122,7.3980389,16.987531,100.4121703,2006.4542415,0.2190619,118.1133529,13.5728091,123.588889,11.3161494,34.12978,0.1899883,85.9912645),(51032,'forelimb',41,2,72,25.2572355,94.6347146,122.362299,1.8,95.6398305,122.0168615,-0.2195142,7.5199894,16.3753403,103.5960107,2144.8732905,0.1996056,130.9819063,13.7760846,136.9920798,11.2179718,33.4853518,0.1546005,84.3767722),(51033,'forelimb',41,2,73,27.3986284,95.6512564,122.1763195,1.8,95.8762149,121.8982768,-0.2022516,7.5984101,15.3589358,113.333545,2320.5831646,0.1842603,151.0901013,14.9154288,158.2500784,11.0841522,31.8607205,0.1762347,81.2952334),(51034,'forelimb',41,2,74,28.6038823,96.0091408,122.1158363,1.8,96.1455933,121.8755817,-0.196487,7.7052242,15.0005344,113.9878143,2339.7518515,0.1816959,155.9778999,14.7935753,163.3942835,11.112468,29.8316135,0.2030452,77.6492099),(51035,'forelimb',41,2,75,29.1494412,95.7019546,122.1079565,1.8,95.8720263,121.8656694,-0.2040356,7.9586305,14.3653563,113.7837358,2104.2974615,0.19946,146.4841813,14.296899,153.9217707,11.3947905,28.1503035,0.2153577,74.2117059),(51036,'forelimb',41,2,76,29.0024631,95.5210251,122.1242671,1.8,95.5851424,121.8997938,-0.208259,7.9277903,13.6111621,111.3526989,1910.4473873,0.2066348,140.3588744,14.0458684,147.6881449,11.3205969,27.1350609,0.1911845,72.8489191),(51037,'forelimb',41,2,77,28.8600729,95.2650295,122.0998401,1.8,95.3279043,121.787159,-0.2155821,7.9231462,12.6776139,112.3900294,1661.6749207,0.2201066,131.0715832,14.1850252,139.5483083,11.3318409,25.6376506,0.2368488,69.0554499),(51038,'forelimb',41,2,78,28.9161338,95.1340672,122.0867934,1.8,95.0356886,121.7852796,-0.2200105,7.871554,12.2851502,112.9119825,1532.8398086,0.2295393,124.7717602,14.3443064,133.13781,11.3318409,24.9441193,0.1906389,67.0849925),(51039,'forelimb',41,2,79,29.2834951,94.7282348,122.1130063,1.8,94.7113504,121.8097854,-0.2333528,7.7696411,11.5119126,109.9619526,1370.5623645,0.2609759,119.0560086,14.1527712,128.2290953,11.275092,23.4485273,0.2405342,64.6543101),(51040,'forelimb',41,2,80,29.4957097,94.5451744,122.1260182,1.8,94.5041778,121.8463439,-0.2396327,7.7200326,11.1676473,108.0185904,1271.2726508,0.2769305,113.8353156,13.9919862,122.6741012,11.2375544,22.8382305,0.2084652,62.5795929),(51041,'forelimb',41,2,81,29.8512098,94.3984654,122.1173976,1.8,94.3408579,121.8482983,-0.2485395,7.6467895,10.6912559,105.6638348,1132.5520147,0.3010514,105.9325513,13.8180651,115.5360021,11.2375544,21.6768972,0.240171,60.6091355),(51042,'forelimb',41,2,82,30.2609805,94.2631505,122.114818,1.8,94.2083022,121.8434695,-0.2553575,7.5867031,10.457272,104.8740003,1043.7756347,0.3217871,99.8133771,13.8233959,109.7992566,11.2375544,21.0678616,0.2053954,59.4980541),(51043,'forelimb',41,2,83,31.2402562,94.0055819,122.1133111,1.8,93.9577423,121.8086686,-0.2673821,7.4734821,9.911122,104.1880442,957.3442853,0.3634574,96.5929274,13.9410308,106.7882377,11.1760682,19.9052705,0.2397431,56.2079957),(51044,'forelimb',41,2,84,31.0850536,93.9544742,122.0807121,1.8,93.8644593,121.729674,-0.2744201,7.5168568,9.7594525,107.389101,884.7757421,0.3804547,90.658338,14.286437,101.6052703,11.1760682,19.3884063,0.2234766,55.2443599),(51045,'forelimb',41,2,85,31.7874377,93.8060392,122.0537639,1.8,93.8089405,121.6769778,-0.2952301,7.3711757,9.3438751,108.2669183,801.1898127,0.4485088,85.744919,14.6878766,97.0378362,11.1103722,18.5513782,0.2337432,53.1696427),(51046,'forelimb',41,2,86,32.7357177,93.6940391,122.0738204,1.8,93.7713036,121.6874325,-0.3069798,7.3101417,9.1091144,108.5662045,770.9343707,0.4982013,84.6332957,14.8514501,96.5227334,11.1900578,18.0366624,0.216085,52.6662319),(51047,'forelimb',41,2,87,32.389673,93.6390505,122.0609224,1.8,93.6843195,121.6993604,-0.3246401,7.2068833,8.926577,111.3266821,699.5655461,0.549223,78.3688467,15.4472714,90.7836597,11.1900578,17.5279,0.1973956,51.3034451),(51048,'forelimb',41,2,88,33.3961959,93.6670803,122.0301178,1.8,93.61853,121.6993604,-0.3346553,7.1438313,8.8359716,110.9477341,657.5155307,0.6004369,74.4134954,15.5305646,86.7906164,11.1138986,16.998492,0.2817719,49.7321387),(51049,'forelimb',41,2,89,33.5373553,93.6767839,122.023742,1.8,93.5355428,121.704544,-0.3445964,7.0979194,8.7073144,111.6591377,605.3709155,0.6378816,69.5244123,15.731249,82.3446589,11.0820956,16.4688822,0.2639637,48.3693519),(51050,'forelimb',41,2,90,33.3805302,93.6546891,122.0048736,1.8,93.563049,121.710639,-0.3583052,7.0119481,8.6934992,114.5000728,578.6418439,0.6841993,66.560292,16.3292813,79.7309372,10.8263812,16.3620316,0.2386093,47.5099759),(51051,'forelimb',41,2,91,34.5604951,93.6616737,121.9189953,1.8,93.6078814,121.6157265,-0.4078657,7.0997986,8.5521038,126.7316918,553.9041222,0.9062453,64.7681714,17.8500403,77.7710917,11.0456713,15.9853176,0.9380475,47.8659411),(51052,'forelimb',41,2,92,37.1469065,93.7573881,121.8705141,1.8,93.7004337,121.5654062,-0.444233,7.3004173,8.4412515,141.6884938,555.3187452,1.1434956,65.7863049,19.4082733,76.5982412,11.1818646,16.2431158,0.9167136,48.7253171),(51053,'forelimb',41,2,93,38.3575874,93.8693859,121.7710588,1.8,93.7712169,121.5236665,-0.4891054,7.2227678,8.3354242,158.7086924,549.3376663,1.4112155,65.9039843,21.9733898,78.8674125,11.375715,15.9910916,1.0349851,48.0133867),(51054,'forelimb',41,2,94,39.5385594,93.9001107,121.7392568,1.8,93.7618534,121.5137069,-0.5212567,7.2020783,8.334348,170.5766772,558.6828533,1.6340921,67.0337806,23.6843686,78.5714577,11.375715,16.1519256,1.0714496,48.3693519),(51055,'forelimb',41,2,95,41.9259602,93.9783374,121.6338985,1.8,93.8320993,121.3981676,-0.5784575,7.0450723,8.1245115,190.4735375,588.7497146,2.0887306,72.4658601,27.0364207,84.3214752,11.5875724,16.3620316,1.0483929,48.7253171),(51056,'forelimb',41,2,96,41.8472959,93.9998739,121.6178011,1.8,93.936544,121.3912989,-0.6041909,6.8931627,7.980913,198.8604602,600.883587,2.2509209,75.2900806,28.8489435,86.7302509,11.5718343,16.3620316,1.0483929,48.0133867),(51057,'forelimb',41,2,97,45.3479703,94.0219845,121.7047202,1.8,93.9815995,121.4661936,-0.6556275,6.6617268,7.6026348,219.7215011,634.4755064,2.8091662,83.4546864,32.9826645,91.8296424,11.4880385,16.3620316,1.0483929,48.9770225),(51058,'forelimb',41,2,98,47.6040587,94.0719036,121.7228761,1.8,94.0195874,121.5221321,-0.6782586,6.8323292,7.6155731,243.7286838,677.8824589,3.1234485,89.0126657,35.6728544,98.9885033,11.9300335,16.5304274,1.0838971,50.0881039),(51059,'forelimb',41,2,99,46.9025699,94.0743984,121.7658607,1.8,94.0668762,121.5248295,-0.756697,6.3841003,7.6119324,278.3740399,704.8525753,3.6843111,92.5983752,43.604271,101.2908947,11.9673863,16.5360111,1.1420183,52.2670809),(51060,'forelimb',41,2,100,43.2887106,94.0089315,121.8973703,1.8,94.0443264,121.6267422,-0.7903317,6.1857877,8.2019531,288.8323771,692.1034019,3.6429867,84.3827559,46.6929014,98.9277663,6.509568,15.1369758,0.113792,36.7804247),(51061,'forelimb',41,2,101,41.5236308,93.9748155,122.0080089,1.8,94.0421648,121.7833167,-0.829786,6.341884,8.5200145,309.8329962,718.3569784,3.76709,84.3140558,48.8550401,102.504359,6.875008,15.1369758,0.113792,37.3880953),(51062,'forelimb',41,2,102,42.7154569,93.9740602,122.1370132,1.8,94.0309172,121.9628483,-0.838728,6.5739425,8.6634676,345.4320183,761.6755752,3.9385699,87.9180957,52.54564,105.7936696,7.304696,15.6172526,0.138006,38.8551419),(51063,'forelimb',41,2,103,45.5233146,93.9560858,122.2799572,1.8,93.9987116,122.23594,-0.8495779,6.8496628,8.8786874,409.6918181,853.8615223,4.2792192,96.1697918,59.8119691,118.5536113,8.164072,16.0429641,0.1343214,40.9298591),(51064,'forelimb',41,2,104,49.8640076,93.9189654,122.4830287,1.8,93.9748057,122.3380388,-0.8321604,6.9962228,9.1538757,468.3808676,922.6678634,4.5433934,100.7953239,66.9476772,128.0385099,9.023448,16.1804778,0.1869793,42.1452003),(51065,'forelimb',41,2,105,63.157048,93.4009487,122.9009568,1.8,93.9037586,122.5060338,-0.8286306,7.3715224,9.8240263,548.7774537,1095.408067,5.717593,111.5029654,74.445606,144.7635319,9.882824,16.4688822,0.1308274,43.6122469),(51066,'forelimb',41,2,106,72.9588693,93.1994206,123.0711783,1.8,93.9073157,122.582345,-0.8306563,7.4145125,10.0948401,652.5073571,1231.1999712,6.6294851,121.9632964,88.0040806,162.9242874,10.312512,16.5304274,0.1566019,44.2199175),(51067,'forelimb',41,2,107,51.4489875,94.6251834,121.9927809,1.8,94.4343733,122.2014257,-1.1466463,8.0404311,9.6785791,620.0322017,784.6923156,7.1225089,81.0751568,77.1142985,136.3494654,10.312512,16.1804778,2.9546134,43.9682121),(51068,'forelimb',41,2,108,33.4669714,96.6091241,121.0323178,1.8,96.2747662,121.0619525,1.3466792,9.141902,9.7332818,174.7723076,556.0775231,5.3023222,57.1315546,19.1177183,74.8392253,9.453136,15.5639613,3.0309354,46.3988945),(51069,'forelimb',41,2,109,26.1398313,97.5131606,120.5825258,1.8,97.5679819,120.4650712,1.2847277,4.07782,9.7570717,69.8037207,484.4266862,4.009732,49.6487782,17.1179015,56.7860251,6.9624888,10.980189,2.6078845,28.5426299),(51070,'forelimb',41,2,110,23.3690679,97.7789005,120.3414385,1.8,97.7945943,120.1836006,1.2533032,3.6066584,9.7478034,49.2214027,469.7058312,3.5152529,48.1858127,13.6473701,53.1109385,6.360732,10.1410009,2.5065659,26.1119475),(51071,'forelimb',41,2,111,20.6341677,98.1905476,120.2992928,1.8,97.9436808,119.8184201,1.2127942,2.8595136,10.0221707,32.6874367,468.2251997,3.0167745,46.7189408,11.4311178,49.6954422,5.4690354,9.1352922,2.2896263,22.8218891),(51072,'forelimb',41,2,112,18.6225765,98.3498926,120.2800476,1.8,97.9869181,119.576032,1.202211,2.6533731,10.072444,23.9978887,457.3357063,2.7008531,45.4046414,9.0442947,47.492194,5.0847652,8.2540369,2.2455373,20.7471719),(51073,'forelimb',41,2,113,14.9392285,98.1573577,119.8441245,1.8,97.7721909,118.8953109,1.2175273,2.5485713,9.5784281,15.0548028,402.2835116,2.1918512,41.9989072,5.907154,43.2050743,25.1466371,59.0191758,0.4929552,162.2419112),(51074,'forelimb',41,2,114,10.0824057,97.4747491,118.1588589,1.8,97.3515274,117.8786478,1.2404448,2.5998405,7.7317369,10.0967277,282.5232129,1.50359,36.5407172,3.883595,36.8056796,26.0231542,59.4306815,0.505694,164.7768534),(51075,'forelimb',41,2,115,4.8430034,95.7157781,113.3398215,1.8,95.8047037,113.7153572,0.7061645,5.8529229,8.8447729,3.9272345,14.7843711,0.3398962,1.6715377,0.6709869,1.7897815,3.0752496,7.1514336,2.5702552,16.3460322),(51076,'forelimb',41,2,116,4.5621953,95.5470513,113.1404885,1.8,95.5647868,113.1711167,0.3912145,1.2545964,3.3033012,1.3031832,11.3171972,0.110556,3.4260264,1.038727,3.8059433,3.0203716,7.112602,2.7049655,16.9537027),(51077,'forelimb',41,2,117,4.2552589,95.3800243,113.0830558,1.8,95.390736,113.1210198,0.3525588,1.3258127,3.2520429,1.2441351,10.1549397,0.0845607,3.122634,0.9383943,3.5036466,3.070446,6.9418221,2.7610863,15.7383616),(51078,'forelimb',41,2,118,3.9378042,95.2459906,113.0332557,1.8,95.261241,113.0668054,0.3352977,1.2888098,2.9947398,1.1704496,8.3011023,0.0710604,2.7718944,0.9081632,3.1552372,2.9918105,6.5448126,2.7367009,15.3823964),(51079,'forelimb',41,2,119,2.5918385,95.2206881,113.063495,1.8,95.1961603,113.0241586,0.3761097,1.2290866,2.2098493,0.714687,2.8528637,0.0582787,1.2909766,0.5814781,1.5814258,2.8539258,5.0109801,2.6011732,12.092338),(51080,'forelimb',41,2,120,1.6086463,95.4939287,113.2726881,1.8,95.5184811,113.2750474,0.4557887,1.1543097,1.7123731,0.4120395,0.9134499,0.0519459,0.5334409,0.3569574,0.7699545,2.578128,3.8432463,2.677945,9.2625046),(51081,'forelimb',41,2,121,0.5302848,95.3339309,113.3273312,1.8,95.3477672,113.3087256,0.4562084,0.8867901,1.0603734,0.1057745,0.1454242,0.0171531,0.1371443,0.1192779,0.2288135,2.14844,2.7513456,2.4668517,6.8318222),(51082,'forelimb',41,2,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51083,'forelimb',41,2,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51084,'forelimb',41,2,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51085,'forelimb',41,2,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51086,'forelimb',41,2,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51087,'forelimb',41,2,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51088,'forelimb',41,2,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51089,'forelimb',41,2,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51090,'forelimb',41,2,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51091,'forelimb',41,2,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51092,'forelimb',41,2,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51093,'forelimb',41,2,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51094,'forelimb',41,2,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51095,'forelimb',41,2,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51096,'forelimb',41,2,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51097,'forelimb',41,2,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51098,'forelimb',41,2,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51099,'forelimb',41,2,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51100,'forelimb',41,2,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51101,'forelimb',41,2,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51102,'forelimb',41,2,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51103,'forelimb',41,2,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51104,'forelimb',41,2,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51105,'forelimb',41,2,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51106,'forelimb',41,2,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51107,'forelimb',41,2,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51108,'forelimb',41,2,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51109,'forelimb',41,2,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51110,'forelimb',41,2,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51111,'forelimb',41,2,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51112,'forelimb',41,2,152,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51113,'forelimb',41,2,153,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51114,'forelimb',41,2,154,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51115,'forelimb',41,2,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51116,'forelimb',41,2,156,3.9251037,92.5824121,120.2186237,1.8,92.5776224,120.1850764,1.186245,1.3391943,2.5387219,1.2956214,4.5057205,0.562119,1.7747988,0.9674633,2.2638913,3.1266098,5.585944,1.9655874,13.411939),(51117,'forelimb',41,2,157,14.6856675,92.7074725,120.348872,1.8,92.6318246,120.0925559,1.2050441,2.0488704,4.6236112,10.9788556,56.2523508,2.1345255,12.1663237,5.358492,14.5402186,4.6123289,9.2557628,1.9513027,22.2142185),(51118,'forelimb',41,2,158,19.7900648,92.8156693,120.5713291,1.8,92.6719828,120.2696712,1.2151352,2.4791929,5.2728151,20.6336705,107.9781537,2.8984188,20.4782741,8.322737,24.3849797,5.2699147,10.6125107,1.943784,25.7559823),(51119,'forelimb',41,2,159,33.557441,94.7798291,119.955909,1.8,95.3888958,119.6124418,0.305111,7.1525958,10.6099279,302.6149584,457.7585548,0.5047018,43.1443605,42.3084102,71.6552273,10.0716082,13.7096736,1.0088748,43.0656503),(51120,'forelimb',41,2,160,58.271915,96.3280086,119.059618,1.8,96.4135594,119.33834,0.2062435,7.5705292,9.8045095,695.5779324,921.5580091,0.4072885,93.9932802,91.8796971,156.7266831,11.1296982,15.4029813,1.0447299,45.2878131),(51121,'forelimb',41,2,161,73.3079353,97.4307212,118.9349249,1.8,97.3569956,119.2637228,0.2829301,8.4413756,9.4078471,1081.1631082,1415.9865857,0.952223,150.5112239,128.0790186,244.6871146,15.7586087,18.7345939,2.5026787,68.2571478),(51122,'forelimb',41,2,162,86.4780557,97.9239314,118.9406799,1.8,97.6949926,119.2541209,0.3468392,8.797127,9.6471649,1350.4216399,1785.0382452,1.6654275,185.0324169,153.5071219,306.3648213,16.3662451,19.4549516,2.6087488,68.613113),(51123,'forelimb',41,2,163,96.3035434,98.1188655,118.7634288,1.8,97.9053111,119.2050547,0.5141368,9.3591947,10.1128061,1666.6405355,2034.9927712,3.8818504,201.2292887,178.0752073,354.3275477,16.9764903,19.8262718,2.6197584,66.7901012),(51124,'forelimb',41,2,164,99.3018516,98.2269078,118.6517369,1.8,98.0364103,119.1215516,0.6234351,9.4914155,10.3007827,1779.3295381,2142.8970537,5.6412476,208.0324497,187.4672484,374.8309143,17.4891627,19.8262718,2.6197584,64.316233),(51125,'forelimb',41,2,165,105.1058354,98.2016833,118.523183,1.8,98.0688803,118.9770716,0.6526306,9.2324008,10.4388334,2031.4805882,2295.1166663,6.4602812,219.8633289,220.0381701,408.9524217,17.8140815,20.0439205,2.6011732,64.2119732),(51126,'forelimb',41,2,166,106.3141665,98.3340508,118.4270054,1.8,98.0738781,118.8905995,0.5955475,9.7646801,10.1771245,2150.3731157,2307.7888066,5.5757956,226.7623628,220.2195149,423.9397985,17.8204348,20.0300987,2.5238369,65.6790198),(51127,'forelimb',41,2,167,107.8004523,98.4332292,118.3709068,1.8,98.03927,118.8543599,-0.8647216,10.1374082,10.0287828,2314.4537483,2370.8451262,10.4025832,236.4040746,228.3082329,449.6033144,18.046896,20.0439205,2.6011732,64.6721982),(51128,'forelimb',41,2,168,106.7707105,98.6248883,118.3984604,1.8,98.0811518,118.8226557,-1.2735609,10.2378662,10.1060692,2256.2758466,2469.6048713,16.268697,244.3684896,220.3853622,448.4952539,18.046896,20.4993152,0.9944211,66.034985),(51129,'forelimb',41,2,169,100.891699,98.7465593,118.3547837,1.8,98.0011964,118.8274666,-1.2021444,10.1403716,10.6237451,2080.8984069,2391.6632458,14.6316825,225.1243072,205.2092858,415.1027254,17.617208,20.7544197,1.0978897,64.9670894),(51130,'forelimb',41,2,170,92.9209774,98.5878642,118.148943,1.8,97.9538249,118.8157912,-1.0142024,9.5436646,10.8632779,1717.8084573,2322.623202,11.164486,213.8050058,179.9946378,371.5968839,17.5930642,20.7855324,1.0516502,63.2483374),(51131,'forelimb',41,2,171,86.8998554,98.482089,118.3433757,1.8,97.8225939,118.9795377,-1.0832285,9.1592112,10.8493411,1478.0511919,2254.4258475,11.3046265,207.7938029,161.3731976,343.385117,17.1554618,20.8608988,1.0056469,62.2847017),(51132,'forelimb',41,2,172,83.778795,98.5169367,118.6335869,1.8,97.8410072,119.1533411,-1.1502744,9.4140533,10.5711895,1470.7700999,2150.311643,11.6360731,203.4124574,156.2313328,340.2708584,17.0965007,20.6339739,1.0232341,62.2847017),(51133,'forelimb',41,2,173,75.5599954,98.3986296,118.9348907,1.8,97.7838135,119.3781183,-1.117925,9.3911677,10.2617199,1291.5881115,1957.987289,10.1823478,190.8049831,137.5322171,314.7541435,16.757832,20.413572,1.0412067,61.9287365),(51134,'forelimb',41,2,174,69.2335596,98.1998894,118.9457093,1.8,97.6812157,119.5385592,-1.1019683,9.0072755,10.1701397,1138.0622555,1782.0826941,9.1831355,175.2269629,126.3492226,286.0415099,16.6856541,20.1999066,1.0595656,60.8176551),(51135,'forelimb',41,2,175,61.384583,97.8003349,119.3563458,1.8,97.4774655,119.8467637,-1.1587437,8.7137471,9.6166419,1009.7718682,1430.1973356,8.5898204,148.7210771,115.8826232,252.8480714,16.328144,19.5449008,0.9888912,59.4548682),(51136,'forelimb',41,2,176,55.0850586,97.5231997,119.6715091,1.8,97.2708367,120.1146211,-1.1256092,8.3730596,9.2374897,907.4000416,1214.4448188,7.478353,131.469139,108.3713818,229.6844636,15.4250805,19.0328019,1.076855,56.9199261),(51137,'forelimb',41,2,177,47.5863789,96.868873,120.3377201,1.8,96.8004142,120.7669534,1.5352977,7.5339082,7.6367359,779.3554005,883.8173493,7.921073,115.7323448,103.4463631,197.3930031,14.6306404,17.2839294,0.962107,52.3102667),(51138,'forelimb',41,2,178,42.5412316,96.718087,120.5038699,1.8,96.6201698,121.0077407,1.0982904,7.2676653,8.0851665,675.4058689,763.0507304,5.6215875,94.3766254,92.9329904,176.1924686,13.8223662,16.2146739,2.5829933,49.4804333),(51139,'forelimb',41,2,179,40.5989613,96.3403407,120.8500523,1.8,96.2353359,121.3203677,0.8842647,7.1379823,7.8405904,578.7440267,683.9336113,4.0478755,87.2298611,81.0794992,160.7223794,13.0700834,15.7350314,2.5308667,47.8659411),(51140,'forelimb',41,2,180,39.9644993,96.1628067,120.9462545,1.8,96.1609779,121.3631934,0.7841177,7.0891162,7.8182895,545.4802796,637.1406106,3.321846,81.4936067,76.9461609,150.4706458,12.8783576,15.4926212,2.5535901,46.3988945),(51141,'forelimb',41,2,181,39.0365848,96.0150629,121.1099649,1.8,96.0159668,121.4751391,0.914462,6.7426349,7.4239877,516.0710335,582.9210363,4.0834569,78.5185882,76.5384814,145.8020709,12.6855409,15.03908,2.4980915,45.7912239),(51142,'forelimb',41,2,182,39.214167,95.9968662,121.1562034,1.8,95.9161978,121.5072244,0.9007564,6.71812,7.2163461,506.1215202,568.2776667,4.0151226,78.7486717,75.3367791,147.7355797,12.6833592,14.7852638,2.5213432,44.5758827),(51143,'forelimb',41,2,183,38.4959494,95.839493,121.2325361,1.8,95.800333,121.5453196,1.0183462,6.3480261,6.948355,481.0454007,530.3421464,4.6491032,76.326288,75.7787372,141.4350415,12.4927242,14.3608389,2.4621788,44.3241773),(51144,'forelimb',41,2,184,38.3617277,95.6883262,121.291812,1.8,95.7016163,121.6380064,1.1229362,5.9805155,6.674065,470.3119799,513.9065206,5.1946788,77.0005269,78.6407093,139.6110438,12.3009983,14.1731921,1.3258177,43.2130959),(51145,'forelimb',41,2,185,38.8636464,95.4836722,121.3738647,1.8,95.4832526,121.681885,1.1822178,5.8832199,6.4847275,453.730925,507.6857981,5.5474942,78.2894577,77.12289,139.0392612,12.1081816,13.9962251,1.2587542,42.8571307),(51146,'forelimb',41,2,186,39.7324228,95.4043293,121.4346352,1.8,95.4210345,121.7256525,1.1798691,5.9069443,6.3901105,450.0032287,504.8023291,5.6605725,78.9974334,76.1820677,141.6734582,12.0958704,13.7567282,1.3182421,41.9977547),(51147,'forelimb',41,2,187,39.9625411,95.2956336,121.5247723,1.8,95.3146601,121.7475162,1.1526305,5.8582594,6.2604946,446.0325472,482.9951558,5.5620863,77.1496806,76.1373841,140.1114365,11.9595284,13.6556983,1.3487144,41.7460493),(51148,'forelimb',41,2,188,40.4077275,95.2283054,121.5969045,1.8,95.2231938,121.790189,1.1033706,5.7176897,6.0782101,442.2080157,479.152018,5.3672842,78.8311049,77.3403319,141.289636,11.87127,13.4856331,1.1784562,41.0341189),(51149,'forelimb',41,2,189,40.1202055,95.0933241,121.5899306,1.8,95.0697823,121.8034249,1.0850921,5.6621837,6.1133119,429.4315969,471.1189389,5.2294589,77.0644366,75.8420464,139.4998908,11.6868444,13.3272566,1.2082521,40.4264483),(51150,'forelimb',41,2,190,39.5218307,94.9752722,121.6174891,1.8,94.9277569,121.8192577,1.0827533,5.7579922,5.9674592,416.2990002,467.794072,5.1387235,78.3908286,72.2993344,137.9997341,11.6868444,13.1809902,1.2387369,40.1747429),(51151,'forelimb',41,2,191,37.9743926,94.8285638,121.5959468,1.8,94.7571568,121.7103898,1.0552265,5.7075404,6.0392773,400.1527965,454.1398387,4.7906011,75.1977121,70.1094986,131.4478356,11.5177562,13.2647685,1.1361261,40.1747429),(51152,'forelimb',41,2,192,37.1378987,94.7087353,121.600878,1.8,94.6206573,121.7484699,1.1575525,5.64318,5.9080368,391.0003374,437.9048149,5.1914555,74.1201905,69.2872353,128.505193,11.4120622,13.1809902,1.2387369,39.9230375),(51153,'forelimb',41,2,193,37.6985639,94.6304724,121.6567221,1.8,94.5950849,121.8347551,1.3031314,5.6469348,5.8357937,386.9932824,431.0588901,5.8435927,73.8646557,68.5315657,128.4170802,11.3394079,13.0896253,1.1659045,39.3153669),(51154,'forelimb',41,2,194,38.4497355,94.5649296,121.6796643,1.8,94.493264,121.9215336,1.3474074,5.622064,5.8778884,385.262038,429.7682962,6.093783,73.1161032,68.5267974,128.8400568,11.3394079,12.9263977,1.1964627,39.5670723),(51155,'forelimb',41,2,195,39.3003285,94.5077037,121.6880868,1.8,94.3866691,121.9244085,1.3341198,5.5024299,5.769504,384.0374576,423.5368068,6.1899483,73.4095698,69.7941571,126.8775176,11.1792544,12.9263977,1.1964627,39.3153669),(51156,'forelimb',41,2,196,40.2573365,94.4187139,121.7312877,1.8,94.2801982,121.9465046,1.3683075,5.5834948,5.7884449,386.5945936,426.2038051,6.438192,73.6301043,69.23882,127.366948,11.2557263,12.9263977,1.1964627,38.7076963),(51157,'forelimb',41,2,197,40.5195696,94.2775751,121.7109909,1.8,94.1860439,121.8974407,1.5615358,5.7526298,5.9044629,377.0668322,422.7518952,6.7526825,71.5987046,65.5468619,126.0104324,11.199788,12.9263977,1.1964627,38.7076963),(51158,'forelimb',41,2,198,39.5816402,94.1638416,121.6520542,1.8,94.0606644,121.8709276,-1.5463456,5.700182,6.0175444,372.411652,412.8165821,6.5929969,68.6021662,65.333291,123.4303304,11.1436511,12.7755427,1.2277724,38.7076963),(51159,'forelimb',41,2,199,39.7558654,94.0611682,121.6515294,1.8,93.9280064,121.8613072,-1.5228922,5.6443442,6.059903,367.3691318,402.7148901,6.6107839,66.4556665,65.0862379,121.7088894,11.0970999,12.7755427,1.2277724,38.2042855),(51160,'forelimb',41,2,200,40.3915023,93.9816096,121.6894737,1.8,93.8778762,121.8496698,1.5693439,5.4651243,5.9274063,368.8607699,400.8218358,6.7319028,67.6217919,67.4935738,122.8486668,11.0182905,12.695808,1.152572,38.1000257),(51161,'forelimb',41,2,201,41.1727185,93.8546176,121.7496839,1.8,93.8025331,121.8800934,-1.4957631,5.8600716,6.0258863,368.6106846,397.4679919,6.8235586,65.9600881,62.9020785,121.3352666,11.0634946,12.695808,1.152572,38.1000257),(51162,'forelimb',41,2,202,41.0772135,93.7399309,121.7671531,1.8,93.7102558,121.8052404,-1.3640086,5.9202963,6.1806099,366.04962,390.345461,6.5575997,63.1564634,61.8296112,120.9079535,10.9556448,12.695808,1.152572,38.1000257),(51163,'forelimb',41,2,203,42.0606855,93.6271369,121.7787569,1.8,93.6409222,121.7984286,-1.0479916,5.8043333,6.3235723,360.1979556,392.2748529,5.2624043,62.0337422,62.0567318,117.7475676,10.9556448,12.8763091,1.122073,38.4559909),(51164,'forelimb',41,2,204,42.5855432,93.5612331,121.7789407,1.8,93.5886245,121.8363136,-0.9759072,5.7228941,6.218181,355.0057973,394.0413845,4.8684708,63.3692365,62.0325646,117.4446315,10.7636971,12.8763091,1.122073,38.2042855),(51165,'forelimb',41,2,205,43.2436716,93.4832544,121.7898148,1.8,93.5208945,121.8375084,-0.9065618,5.6166413,6.061486,352.0432783,396.8417543,4.468378,65.4693845,62.6786112,117.8748803,10.5754657,12.695808,1.152572,37.5966149),(51166,'forelimb',41,2,206,43.075265,93.4465086,121.7996954,1.8,93.4668654,121.8492609,-0.8819811,5.356606,5.9866165,344.9485982,396.6839328,4.278691,66.2617909,64.3968584,115.4594478,10.5185645,12.7755427,1.2277724,37.3449095),(51167,'forelimb',41,2,207,43.1229896,93.4025637,121.8424398,1.8,93.4159616,121.9024856,-0.8888824,5.299832,6.2094,333.7799059,397.3758224,4.3320425,63.9958485,62.979337,114.3992628,10.4502305,12.8977995,1.047518,37.3449095),(51168,'forelimb',41,2,208,43.4804479,93.3710906,121.8860848,1.8,93.3858281,121.9160212,-0.8928121,5.3074684,6.1615676,326.32673,402.388136,4.395798,65.3061304,61.4844409,114.96919,10.3394058,12.8977995,1.047518,37.3449095),(51169,'forelimb',41,2,209,43.6794026,93.37856,121.9067896,1.8,93.3981271,121.9152103,-0.8820159,5.0405554,6.133923,313.298921,405.4318677,4.3389488,66.0966671,62.1556346,113.6722053,10.2027097,12.8763091,1.122073,36.7372389),(51170,'forelimb',41,2,210,42.9595065,93.372381,121.9475796,1.8,93.4163344,121.9841951,-0.9037528,5.0929644,6.1299468,301.5273297,408.0433918,4.4194768,66.5655678,59.2046807,112.9286301,10.1705519,12.8763091,1.122073,36.3812737),(51171,'forelimb',41,2,211,42.8760865,93.3385351,121.9399082,1.8,93.359204,121.9831931,-0.9249679,4.9204262,6.4022094,285.9409704,415.1645057,4.5574726,64.8470679,58.1130498,108.3528809,9.9003231,12.9905136,0.9736197,36.7372389),(51172,'forelimb',41,2,212,42.484835,93.3331782,121.9570935,1.8,93.3310127,122.0196344,-0.9412196,4.8321772,6.3995646,277.3292633,416.6058548,4.6259713,65.0990939,57.3921965,107.5380283,9.9003231,12.8977995,1.047518,36.4855335),(51173,'forelimb',41,2,213,43.0008528,93.3174377,121.9922636,1.8,93.3024523,122.050728,-0.9470324,4.7807447,6.3665293,264.713239,425.1020854,4.721735,66.7714017,55.3707127,106.9456199,9.7227296,12.9263977,1.1964627,35.8778629),(51174,'forelimb',41,2,214,43.6585896,93.2905203,122.0079794,1.8,93.3209106,121.9937001,-0.9445533,4.7153437,6.5879005,258.394803,430.1154948,4.7768396,65.2887056,54.7987203,104.2537274,9.7227296,13.1178053,1.0191413,36.1295683),(51175,'forelimb',41,2,215,43.5485938,93.3249278,121.971193,1.8,93.2890012,121.9929899,-0.9494046,4.6773353,6.6400119,247.6323853,427.0415214,4.7981933,64.3133667,52.9430479,101.3999515,9.4188943,13.1178053,1.0191413,35.5218977),(51176,'forelimb',41,2,216,43.8483127,93.3262188,121.9772621,1.8,93.2829284,122.0293604,-0.9531713,4.581346,6.637365,240.7234995,434.3302001,4.857242,65.4371423,52.5442735,101.5251727,9.4188943,13.1178053,1.0191413,35.8778629),(51177,'forelimb',41,2,217,43.7232666,93.3185313,121.950852,1.8,93.2787986,122.0376496,-0.9524716,4.5832465,6.9032284,232.1449454,438.7653475,4.8385748,63.559442,50.6507663,97.1827059,9.4188943,13.348021,0.9917221,36.1295683),(51178,'forelimb',41,2,218,43.2189421,93.2999148,121.9502326,1.8,93.2666379,122.0366837,-0.9542906,4.6016596,6.8930884,224.5678692,437.5369086,4.7951343,63.4747273,48.8014951,96.0478369,9.4188943,13.348021,0.9917221,36.1295683),(51179,'forelimb',41,2,219,43.3638501,93.2962423,121.9119646,1.8,93.3039839,121.9601319,-0.9562688,4.5265156,6.9223714,216.2981284,439.3536899,4.8246918,63.4686681,47.7846863,94.7076394,9.3857155,13.348021,0.9917221,35.7736031),(51180,'forelimb',41,2,220,44.1056782,93.2636916,121.9330747,1.8,93.2592713,121.9963804,-0.9625692,4.5470269,6.8868504,212.5020171,447.0298791,4.9507646,64.9106417,46.7342775,95.763577,9.3857155,13.348021,0.9917221,36.1295683),(51181,'forelimb',41,2,221,44.8086217,93.3168806,121.8640564,1.8,93.2848594,121.9097822,-0.9598093,4.5048049,6.9737122,206.2392543,454.2702251,5.0103183,65.1403745,45.7820615,94.7091557,9.115059,13.348021,0.9917221,35.8778629),(51182,'forelimb',41,2,222,45.0415375,93.3428404,121.8135985,1.8,93.2908255,121.898947,-0.9632976,4.5207278,7.0301687,202.8490895,456.1210018,5.0609397,64.8805203,44.8708923,93.7317334,9.115059,13.348021,0.9917221,35.8778629),(51183,'forelimb',41,2,223,45.5976708,93.3818226,121.7293462,1.8,93.3726625,121.8123763,-0.9644777,4.5394801,7.0134364,197.8176617,457.0350836,5.1318305,65.165642,43.5771626,92.7784137,9.115059,13.2717262,1.0636978,35.8778629),(51184,'forelimb',41,2,224,45.738998,93.4341574,121.6455389,1.8,93.3907527,121.7783884,-0.9653599,4.5461339,7.1116572,195.5996471,456.5645575,5.1540328,64.199461,43.025492,91.127638,9.115059,13.4513621,1.1071487,36.2338281),(51185,'forelimb',41,2,225,45.4661906,93.5242146,121.5019564,1.8,93.4639356,121.6257498,-0.9632281,4.5495569,7.1442795,191.282631,434.690801,5.1081608,60.8445961,42.0442328,87.4551451,9.115059,13.2717262,1.0636978,35.6261575),(51186,'forelimb',41,2,226,44.8922655,93.5662261,121.4527962,1.8,93.5076915,121.5290362,-0.9610299,4.5388727,7.1014822,188.7661197,416.3275231,5.0282493,58.6254408,41.5887672,85.1872622,9.115059,13.1178053,1.0191413,35.2701923),(51187,'forelimb',41,2,227,44.0093899,93.644229,121.3324305,1.8,93.5888186,121.4001878,-0.9710688,4.561673,7.0004659,185.5466324,381.3488585,4.9982402,54.4747829,40.6751282,80.9645439,9.115059,12.8977995,1.047518,34.6625217),(51188,'forelimb',41,2,228,43.9339147,93.7146535,121.2443104,1.8,93.7355603,121.2805341,-0.981872,4.5707179,6.7566114,184.0499433,357.2744896,5.0630654,52.8777619,40.2671853,80.0865616,9.0432536,12.5274503,1.0303768,33.6988859),(51189,'forelimb',41,2,229,43.481455,93.8590219,121.0722419,1.8,93.8756382,121.0455714,-0.9987641,4.5686849,6.3813999,183.0609369,321.7776842,5.1231953,50.4243093,40.0686282,79.0712621,9.115059,12.1077509,1.091277,33.0912153),(51190,'forelimb',41,2,230,43.1205838,93.9560927,120.9445798,1.8,93.99425,120.9160317,-1.0125308,4.5712978,6.1732606,183.7077692,302.1338863,5.1701659,48.9423511,40.187224,78.4099579,9.115059,11.7282,1.0743736,32.8395099),(51191,'forelimb',41,2,231,43.075321,94.067805,120.7689145,1.8,94.0626095,120.7917306,-1.0527781,4.600454,5.9292466,183.8275834,281.4904145,5.4189989,47.474904,39.9585745,78.4762971,9.023448,11.417094,1.2252407,31.9801339),(51192,'forelimb',41,2,232,43.5272772,94.1348311,120.6683945,1.8,94.147875,120.6845742,-1.0903063,4.6095375,5.6625143,184.3115831,270.4830168,5.7046738,47.7672998,39.9848325,80.0323387,9.023448,11.0137676,1.2120257,31.3724633),(51193,'forelimb',41,2,233,43.069782,94.2171089,120.5576937,1.8,94.2562192,120.5292402,-1.1493725,4.6347544,5.4075703,184.0044581,252.8201278,5.9771515,46.7529986,39.7010156,79.9681925,9.023448,10.8703421,1.2490458,31.3724633),(51194,'forelimb',41,2,234,42.3502216,94.2745371,120.4740485,1.8,94.3398556,120.435921,-1.1993623,4.6524608,5.2523299,184.560276,242.0831074,6.1285414,46.0906135,39.6693886,80.0460236,8.59376,10.6125107,1.1978086,30.4088275),(51195,'forelimb',41,2,235,41.4268949,94.361408,120.3330508,1.8,94.3978411,120.33813,-1.318405,4.6421224,5.1584271,184.5974674,230.0609029,6.4739177,44.5990413,39.7657479,78.4370183,8.59376,10.6125107,1.1978086,30.1571221),(51196,'forelimb',41,2,236,41.6668043,94.4194324,120.272485,1.8,94.4254596,120.2822088,-1.4198422,4.5585608,5.0187698,184.8949361,225.9756901,6.7874211,45.0261115,40.5599368,78.7865781,8.59376,10.5339308,1.3654009,30.5130873),(51197,'forelimb',41,2,237,42.4778414,94.4934596,120.1573137,1.8,94.4849732,120.1368585,-1.5682146,4.338495,5.0010109,184.7786858,224.5491227,7.079593,44.9007465,42.5905032,79.4030157,8.59376,10.3304002,1.2753555,30.4088275),(51198,'forelimb',41,2,238,43.4529769,94.5391543,120.0647923,1.8,94.5216769,120.0632999,1.4753865,4.3687703,5.0096299,184.3471621,227.6767366,7.176437,45.4478154,42.1965793,81.1575357,8.59376,10.3304002,1.2753555,30.1571221),(51199,'forelimb',41,2,239,43.0607742,94.5734873,119.9376526,1.8,94.5888966,119.9784382,1.3695677,4.3515988,5.0367438,180.1180695,228.7485369,6.8900874,45.4159565,41.39124,80.2451965,8.59376,10.2135672,1.3156139,30.1571221),(51200,'forelimb',41,2,240,42.692238,94.6021767,119.886592,1.8,94.6074762,119.9271485,1.29555,4.3015409,5.038531,176.8734733,231.5146897,6.5897849,45.9488473,41.1186311,80.750412,8.59376,10.1136544,1.3567356,29.9054167),(51201,'forelimb',41,2,241,43.2386362,94.6464656,119.8016578,1.8,94.6523989,119.7994352,1.218326,4.3416336,5.2477109,174.2573582,238.3444906,6.3476121,45.4187541,40.1363579,78.3574479,8.9633149,10.3304002,1.8662372,30.5130873),(51202,'forelimb',41,2,242,43.2029407,94.6743174,119.7330834,1.8,94.7025069,119.7397227,1.1773684,4.2732826,5.1728762,172.5697753,243.1718974,6.1422892,47.0090306,40.3834219,79.840263,8.8112237,10.3304002,1.8662372,30.2613819),(51203,'forelimb',41,2,243,44.0162717,94.7201255,119.6508032,1.8,94.746204,119.7069499,1.116151,4.1635863,5.2615751,169.9085118,252.1176552,5.9213096,47.9167643,40.8082117,79.9190867,8.8112237,10.4635866,1.9055332,30.2613819),(51204,'forelimb',41,2,244,44.0648354,94.7298245,119.6239686,1.8,94.7730595,119.6424732,1.0915662,4.1532747,5.4277444,167.4674567,261.5282076,5.7827041,48.1835897,40.3217863,78.9962339,8.5073884,10.6125107,1.943784,30.2613819),(51205,'forelimb',41,2,245,44.2054913,94.753775,119.5502673,1.8,94.8009682,119.5639959,1.0690166,4.2022482,5.3693092,165.4599356,275.3047968,5.6631056,51.2737829,39.3741465,80.6319344,8.59376,10.7765202,1.9809237,30.5130873),(51206,'forelimb',41,2,246,44.5859446,94.7576471,119.4814613,1.8,94.7839788,119.4957606,1.0484131,4.1285504,5.6778788,164.7976782,289.0113427,5.5810604,50.9012879,39.916596,79.5814738,8.59376,11.171888,1.9655874,30.7647927),(51207,'forelimb',41,2,247,45.37242,94.7582544,119.4056081,1.8,94.8162618,119.4252409,1.027317,4.1255137,5.8230508,163.6751779,310.6476908,5.539896,53.3479274,39.6738904,81.3864689,8.5073884,11.4413255,2.1692152,31.0164981),(51208,'forelimb',41,2,248,47.3780806,94.7650856,119.3763294,1.8,94.798619,119.3783854,1.0138743,4.0898575,6.0251658,165.2811515,332.8127763,5.6901675,55.237115,40.4124473,82.6638218,8.5073884,11.6887773,2.1995926,31.6241687),(51209,'forelimb',41,2,249,47.5465991,94.7711706,119.3186633,1.8,94.8159585,119.3249156,0.9970217,4.1616519,6.3411861,165.4539929,364.6804458,5.589591,57.5098162,39.7568075,83.5461345,8.5073884,12.1610055,2.1293956,32.2318393),(51210,'forelimb',41,2,250,47.5605864,94.7337082,119.2671269,1.8,94.7748499,119.2494376,0.9812733,4.1348554,6.5119807,165.5975555,385.8526047,5.4766277,59.2527258,40.0491774,84.6818563,8.5073884,12.3940969,2.1587989,33.1954751),(51211,'forelimb',41,2,251,48.6515364,94.6998402,119.182082,1.8,94.6612166,119.1481538,0.9552714,4.0611597,7.0203192,166.2303104,436.9332146,5.4053804,62.2383687,40.9317341,85.9164106,8.5073884,13.1178053,2.1224513,34.4108163),(51212,'forelimb',41,2,252,49.7892038,94.6527451,119.1244121,1.8,94.5814903,119.038922,0.9464968,4.0466268,7.7965051,166.7081799,486.9587769,5.4629195,62.4585976,41.1968261,83.7526532,8.2035531,14.1862129,2.1840037,35.8778629),(51213,'forelimb',41,2,253,50.5182196,94.629606,119.0907289,1.8,94.4939101,118.8856028,0.9418692,4.1297104,8.1047001,169.4330375,531.7587542,5.5058928,65.6111571,41.027825,86.5134134,8.2035531,14.5397175,2.1669955,36.8414987),(51214,'forelimb',41,2,254,49.3804962,94.6371314,119.0703613,1.8,94.493702,118.8497696,0.9345606,4.2550983,8.1833937,169.0701106,569.151875,5.3245323,69.5496146,39.7335382,89.990568,8.5073884,14.8972278,2.1507991,37.7008747),(51215,'forelimb',41,2,255,49.1090875,94.6484137,119.0994393,1.8,94.5606354,118.9102517,0.9143333,4.300381,8.2000803,169.8232883,601.4992051,5.1360811,73.3528432,39.4902891,93.6762303,8.5073884,15.1369758,2.1745457,38.6645105),(51216,'forelimb',41,2,256,49.5228865,94.6576276,119.1407114,1.8,94.5492637,118.9708073,0.9013989,4.2838067,8.4944592,170.8687016,628.8191188,5.0757898,74.0269753,39.8871175,93.9574052,8.5073884,15.4926212,2.1587989,38.9162159),(51217,'forelimb',41,2,257,50.5342769,94.7367341,119.2072697,1.8,94.6211456,119.0602232,0.8787312,4.2032481,8.5819182,172.6242904,656.905467,4.9927189,76.545296,41.0692602,96.3337294,8.5073884,15.9853176,2.2035452,39.4196267),(51218,'forelimb',41,2,258,50.3319653,94.7569103,119.2220016,1.8,94.6202294,119.0730497,0.8640502,4.1575708,8.5949175,171.9871335,694.4854083,4.8513978,80.80187,41.3672173,100.3484739,8.2035531,16.0889326,2.1662062,39.8798517),(51219,'forelimb',41,2,259,50.8891057,94.8661763,119.3802792,1.8,94.6877699,119.1711989,0.8447905,4.1637725,8.7682975,174.2303922,751.3983996,4.7433121,85.6949025,41.8443596,104.8638017,8.2035531,16.5861794,2.2091161,41.4511581),(51220,'forelimb',41,2,260,52.9489809,94.9251394,119.5281628,1.8,94.7256611,119.2581069,0.8353842,4.1887957,8.9075747,179.6032974,803.4420906,4.8527986,90.197626,42.8770731,109.4461222,8.2035531,16.9331967,2.1939957,41.3468983),(51221,'forelimb',41,2,261,54.5403949,94.9931011,119.6681735,1.8,94.824442,119.4060728,0.8164778,4.1945017,9.3081026,186.6607533,882.9704117,4.8273667,94.8604084,44.5012941,114.7811522,8.2035531,17.3851149,2.2686991,42.9182047),(51222,'forelimb',41,2,262,54.601715,95.0719154,119.7649057,1.8,94.8290839,119.4830364,0.8003069,4.1458042,9.4239475,190.060417,943.5511939,4.6857964,100.1227129,45.8440407,120.0399639,8.2035531,17.7164901,2.2531129,43.5258753),(51223,'forelimb',41,2,263,54.967174,95.1329033,119.8276623,1.8,94.8864548,119.5527216,0.7784512,4.0808879,9.5000944,194.0398792,1048.0589873,4.5169572,110.3209025,47.5484468,129.4128648,8.2352514,18.0520106,2.2381025,45.3488871),(51224,'forelimb',41,2,264,55.5534638,95.1344971,119.8608304,1.8,94.9370095,119.6328015,0.7599332,4.3354325,9.8145958,198.9073943,1149.4419073,4.3937798,117.1155619,45.8794809,137.0143543,8.3915854,18.5563538,2.3070538,47.9270151),(51225,'forelimb',41,2,265,55.0773936,95.1823789,119.8494192,1.8,95.0198398,119.6586723,0.7122586,4.1310864,9.8423432,196.3173146,1246.3838545,3.9207851,126.6348699,47.5219585,146.2475546,8.2603307,18.8769524,2.2917677,46.4599685),(51226,'forelimb',41,2,266,54.907924,95.2073907,119.8379023,1.8,95.0851482,119.7229847,0.677462,3.9814512,9.8953149,192.238174,1343.2043322,3.5955561,135.7414442,48.2834441,155.1176422,8.2603307,19.2594195,2.4668517,48.7863911),(51227,'forelimb',41,2,267,55.9409108,95.39407,119.9531646,1.8,95.0969985,119.7195297,0.6381523,3.8163032,10.3522723,189.1844972,1515.4854329,3.3086558,146.3915739,49.572712,163.9497061,8.1436243,19.8634868,2.4634733,52.3281548),(51228,'forelimb',41,2,268,58.5985454,95.6336393,120.1065747,1.8,95.1388017,119.7667823,0.6115534,3.794136,10.7121779,188.1805036,1725.8617818,3.219372,161.1121291,49.5977229,178.3675007,8.0199975,20.1999066,2.4768182,50.7568485),(51229,'forelimb',41,2,269,58.8847806,95.7205855,120.2457085,1.8,95.1086038,119.8228367,0.5847396,3.8056952,11.0778239,183.2302021,1892.3095118,2.990213,170.8196059,48.1463155,185.990462,8.03575,20.8032903,2.4733032,53.0832711),(51230,'forelimb',41,2,270,56.2131028,95.4825263,120.1701517,1.8,95.0386863,119.8448021,0.5760191,3.8436291,10.9511638,176.0975802,1921.4654204,2.7796154,175.4576467,45.8154455,190.8725098,8.0776749,21.2293704,2.5142845,53.3349765),(51231,'forelimb',41,2,271,55.7529781,95.286557,120.1461575,1.8,95.1236684,120.0125195,0.5501133,3.7515426,10.885842,170.4061997,2063.3781203,2.5395756,189.5469471,45.4229681,204.7903257,8.0601234,21.6896696,2.5535901,54.0469068),(51232,'forelimb',41,2,272,54.2828056,95.2443482,120.2451025,1.8,95.131746,120.1138194,0.533343,3.8187341,11.0382547,164.5942383,2128.1805893,2.338555,192.8004607,43.1017807,207.5820007,8.1851404,22.1820578,2.5912067,55.1579882),(51233,'forelimb',41,2,273,53.9167871,95.1309877,120.3120791,1.8,95.1081659,120.2458861,0.5167618,3.8719144,11.3383797,158.1240717,2273.1253969,2.1935375,200.480621,40.8387311,214.2384638,8.0910796,22.9189312,2.6108192,57.2327054),(51234,'forelimb',41,2,274,51.425433,95.0609683,120.389473,1.8,95.1307296,120.3803836,0.5001813,4.0266667,11.3975178,149.7371643,2324.6037812,1.9713201,203.9570209,37.1863812,216.9326661,8.0651979,23.2905166,2.6201582,57.4844108),(51235,'forelimb',41,2,275,52.278208,95.1281802,120.565799,1.8,95.1118489,120.4848938,0.4696093,4.1533796,11.8378249,150.7287463,2606.6400387,1.7843473,220.1958601,36.2906259,232.1168497,8.1412225,24.039498,2.7179237,60.418504),(51236,'forelimb',41,2,276,55.5296296,94.8991351,120.7307912,1.8,94.7232369,120.6498782,0.4254915,4.5034354,12.401904,175.4351448,2980.9874538,1.5768364,240.3653066,38.9558481,253.8582028,9.3023382,24.8254078,2.7321554,63.856008),(51237,'forelimb',41,2,277,65.8696805,94.1985656,120.9983719,1.8,94.2074721,120.8331564,0.3453116,5.4003147,13.2928806,275.6381372,3629.0922638,1.2578411,273.0102203,51.0411251,293.5953765,10.6298919,25.6160367,2.7455112,67.5452174),(51238,'forelimb',41,2,278,72.8427751,94.0461724,121.1841471,1.8,94.0174826,120.9787944,0.3136122,5.7729992,13.5039705,326.7981739,3950.7510729,1.1554103,292.5621809,56.6080404,316.6696143,11.0147907,25.8527955,2.767259,67.293512),(51239,'forelimb',41,2,279,85.0273534,93.729236,121.2548322,1.8,93.7901693,121.0753573,0.2908828,6.0329454,13.7912599,406.6078598,4257.9415321,1.1656272,308.7420268,67.3979012,338.1967346,11.3315892,26.1015566,2.7886023,66.4773219),(51240,'forelimb',41,2,280,88.6982808,93.6619377,121.2994986,1.8,93.656344,121.1234497,0.2796919,5.8456824,13.8447456,440.7266112,4194.2573697,1.1265994,302.9494004,75.3935266,334.7764959,11.1552501,26.1015566,2.7886023,66.2256165),(51241,'forelimb',41,2,281,91.6442206,93.5493114,121.3570253,1.8,93.5394517,121.1415919,0.2675845,6.0859747,13.6373893,449.1903333,3876.9840602,1.0677889,284.2907814,73.8074593,316.9943107,11.3315892,25.6987912,2.782822,64.0466395),(51242,'forelimb',41,2,282,88.9463028,93.2986539,121.3811662,1.8,93.3923805,121.1903937,0.2608991,6.0822219,13.6478484,419.6556813,3354.1812191,0.9863829,245.7663013,68.9971017,276.4473328,11.1844475,25.1468455,2.7928217,63.8991939),(51243,'forelimb',41,2,283,80.9868269,93.0980077,121.4722571,1.8,93.1890823,121.28093,0.2518223,5.8314275,13.2984505,338.9059202,2523.8516321,0.838015,189.7853913,58.1171455,215.0321068,10.6732509,24.0817029,2.8706458,62.7449266),(51244,'forelimb',41,2,284,70.4131328,92.6683601,121.3578557,1.8,92.6590646,121.1977039,0.2568183,5.4008409,13.017725,277.6699536,1641.5879686,0.7571557,126.1040595,51.4123554,147.4328025,10.1367096,18.0724546,2.8273608,49.5846931),(51245,'forelimb',41,2,285,50.6799682,92.9256479,121.4592722,1.8,92.2050141,121.0838169,0.2546501,5.023009,9.1306943,160.4168149,990.397279,0.536,108.469,31.9363982,124.9776643,9.2434874,17.1982588,2.9147938,47.6142357),(51246,'forelimb',41,2,286,35.1977544,92.948675,121.5155142,1.8,92.1793321,121.0849039,0.2615287,4.8331623,8.5511102,91.0216978,731.0895954,0.3921735,85.4964531,18.832742,96.1253087,7.4006888,9.5406219,0.625485,26.8670637),(51247,'forelimb',41,2,287,17.8686634,92.1355777,121.1414564,1.8,91.834814,120.9114965,0.3027904,3.7616119,7.7301003,28.2941159,373.3006082,0.2647964,48.2918197,7.5218062,51.8053612,5.8441936,7.8880231,0.5123895,21.2505827),(51248,'forelimb',41,2,288,5.5011877,89.6918211,119.9895688,1.8,90.4111741,120.2644507,0.3180214,2.4460202,9.8541679,4.7912352,33.7381121,0.0896452,3.4237403,1.9587881,3.899698,4.2731952,5.8443887,0.2984989,15.7383616),(51249,'forelimb',41,2,289,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51250,'forelimb',41,2,290,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51251,'forelimb',41,2,291,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51252,'forelimb',41,2,292,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51253,'forelimb',41,2,293,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51254,'forelimb',41,2,294,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51255,'forelimb',41,2,295,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51256,'forelimb',41,2,296,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51257,'forelimb',41,2,297,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51258,'forelimb',41,2,298,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51259,'forelimb',41,2,299,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51260,'forelimb',41,2,300,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51261,'forelimb',41,2,301,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51262,'forelimb',41,2,302,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51263,'forelimb',41,2,303,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51264,'forelimb',41,2,304,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51265,'forelimb',41,2,305,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51266,'forelimb',41,2,306,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51267,'forelimb',41,2,307,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51268,'forelimb',41,2,308,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51269,'forelimb',41,2,309,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51270,'forelimb',41,2,310,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51271,'forelimb',41,2,311,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51272,'forelimb',41,2,312,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51273,'forelimb',41,2,313,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51274,'forelimb',41,2,314,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51275,'forelimb',41,2,315,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51276,'forelimb',41,2,316,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51277,'forelimb',41,2,317,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51278,'forelimb',41,2,318,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51279,'forelimb',41,2,319,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51280,'forelimb',41,2,320,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51281,'forelimb',41,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51282,'forelimb',41,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51283,'forelimb',41,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51284,'forelimb',41,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51285,'forelimb',41,3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51286,'forelimb',41,3,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51287,'forelimb',41,3,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51288,'forelimb',41,3,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51289,'forelimb',41,3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51290,'forelimb',41,3,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51291,'forelimb',41,3,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51292,'forelimb',41,3,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51293,'forelimb',41,3,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51294,'forelimb',41,3,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51295,'forelimb',41,3,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51296,'forelimb',41,3,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51297,'forelimb',41,3,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51298,'forelimb',41,3,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51299,'forelimb',41,3,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51300,'forelimb',41,3,20,0.0481162,73.04696,126.8019281,1.8,73.04696,126.75796,1.4370492,0.0631614,0.4694259,0.0008364,0.0060468,0.0078768,0.0128812,0.013242,0.014532,3.0180332,23.3024045,3.0492633,50.2176613),(51301,'forelimb',41,3,21,0.2192642,72.9499266,126.7500658,1.8,72.885827,126.75796,1.5155624,0.3563044,0.8713045,0.0106818,0.0562873,0.0364327,0.0646012,0.0299794,0.0767394,3.2404633,26.7651134,3.0451189,57.7003399),(51302,'forelimb',41,3,22,0.4717622,72.8253894,126.6622586,1.8,72.709348,126.665884,-1.567183,0.639008,1.1941554,0.0449084,0.1500284,0.078626,0.1256355,0.0702783,0.160606,3.2104715,30.1547924,3.0702852,64.3236425),(51303,'forelimb',41,3,23,0.656338,72.7371568,126.5759168,1.8,72.6425478,126.6063054,1.5649473,0.5556547,1.107703,0.0790481,0.2381788,0.1093859,0.2150204,0.1422612,0.2693995,3.4258688,33.6146765,3.0648208,72.0580265),(51304,'forelimb',41,3,24,0.9773735,72.5132014,126.5508764,1.8,72.3666207,126.543116,1.4733821,1.1995163,1.113317,0.237551,0.331685,0.1613547,0.297925,0.198039,0.4718178,3.4858524,35.7571679,3.069429,75.8514957),(51305,'forelimb',41,3,25,1.0672276,72.4694773,126.569483,1.8,72.3032692,126.6092218,-1.4546436,1.1615337,1.1600965,0.2834075,0.3728386,0.1754823,0.3213859,0.2439942,0.5056096,3.4834375,37.0429935,3.0719381,79.0372943),(51306,'forelimb',41,3,26,1.1295548,72.4548593,126.5785207,1.8,72.3032692,126.6092218,-1.3568038,1.154097,1.2100554,0.3107751,0.3801723,0.179769,0.3141776,0.2692799,0.5394769,3.479198,37.9003328,3.0735162,80.7560463),(51307,'forelimb',41,3,27,1.0426101,72.6055815,126.5874222,1.8,72.4740427,126.5942693,1.5102718,0.8824396,1.115771,0.2023287,0.3256944,0.1731326,0.2919008,0.2292833,0.4391182,3.3248825,38.3290367,3.0742788,81.8671277),(51308,'forelimb',41,3,28,0.985542,72.6491784,126.6159178,1.8,72.50985,126.6290536,1.5571761,0.8989866,1.14735,0.1689604,0.3041397,0.1642265,0.2650802,0.1879454,0.3896912,3.426124,39.1605866,3.0867028,83.3341743),(51309,'forelimb',41,3,29,0.7674528,72.7773125,126.5758665,1.8,72.670983,126.543116,1.4771607,0.644346,1.1170849,0.0854402,0.2286512,0.1267906,0.2046856,0.1325998,0.2756786,3.8407969,39.1605866,3.0867028,84.6537753),(51310,'forelimb',41,3,30,0.6010044,72.8509164,126.5784367,1.8,72.7605013,126.543116,1.466468,0.678421,1.083092,0.05265,0.1580833,0.0990811,0.1459555,0.0776067,0.1870314,3.437504,39.9817699,3.1093458,84.9054807),(51311,'forelimb',41,3,31,0.3936014,72.9296891,126.5779003,1.8,72.8750848,126.543116,1.5006248,0.3544,1.0980527,0.0208839,0.108645,0.0652777,0.0989434,0.0589273,0.1161499,3.5869622,39.9979293,3.0986084,85.6605969),(51312,'forelimb',41,3,32,0.279913,72.9603868,126.656185,1.8,72.885827,126.75796,1.5058016,0.3769084,0.9647444,0.0129617,0.0635117,0.0464554,0.0658327,0.0343896,0.0792436,4.0090857,40.4272247,0.0425275,87.3361631),(51313,'forelimb',41,3,33,0.1245425,73.04696,126.5940763,1.8,73.04696,126.543116,1.485405,0.0593169,0.6929582,0.0020778,0.0239763,0.0206061,0.0345999,0.0350296,0.0374614,4.2083736,40.8565282,0.0420804,88.5515043),(51314,'forelimb',41,3,34,0.0736289,73.04696,126.7194317,1.8,73.04696,126.75796,1.4336403,0.0640175,0.4638192,0.0012834,0.0090337,0.0120421,0.0194768,0.0200471,0.0220349,4.3341429,41.3059591,0.0520363,89.4108803),(51315,'forelimb',41,3,35,0.0111898,73.04696,126.75796,1.8,73.04696,126.75796,0.7853982,0,0,0.0001722,0.0001722,0.0009325,0,0,0,4.4370791,42.1641955,0.0509762,90.8779269),(51316,'forelimb',41,3,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51317,'forelimb',41,3,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51318,'forelimb',41,3,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51319,'forelimb',41,3,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51320,'forelimb',41,3,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51321,'forelimb',41,3,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51322,'forelimb',41,3,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51323,'forelimb',41,3,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51324,'forelimb',41,3,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51325,'forelimb',41,3,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51326,'forelimb',41,3,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51327,'forelimb',41,3,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51328,'forelimb',41,3,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51329,'forelimb',41,3,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51330,'forelimb',41,3,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51331,'forelimb',41,3,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51332,'forelimb',41,3,52,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51333,'forelimb',41,3,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51334,'forelimb',41,3,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51335,'forelimb',41,3,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51336,'forelimb',41,3,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51337,'forelimb',41,3,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51338,'forelimb',41,3,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51339,'forelimb',41,3,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51340,'forelimb',41,3,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51341,'forelimb',41,3,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51342,'forelimb',41,3,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51343,'forelimb',41,3,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51344,'forelimb',41,3,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51345,'forelimb',41,3,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51346,'forelimb',41,3,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51347,'forelimb',41,3,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51348,'forelimb',41,3,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51349,'forelimb',41,3,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51350,'forelimb',41,3,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51351,'forelimb',41,3,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51352,'forelimb',41,3,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51353,'forelimb',41,3,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51354,'forelimb',41,3,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51355,'forelimb',41,3,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51356,'forelimb',41,3,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51357,'forelimb',41,3,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51358,'forelimb',41,3,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51359,'forelimb',41,3,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51360,'forelimb',41,3,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51361,'forelimb',41,3,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51362,'forelimb',41,3,82,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51363,'forelimb',41,3,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51364,'forelimb',41,3,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51365,'forelimb',41,3,85,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51366,'forelimb',41,3,86,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51367,'forelimb',41,3,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51368,'forelimb',41,3,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51369,'forelimb',41,3,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51370,'forelimb',41,3,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51371,'forelimb',41,3,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51372,'forelimb',41,3,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51373,'forelimb',41,3,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51374,'forelimb',41,3,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51375,'forelimb',41,3,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51376,'forelimb',41,3,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51377,'forelimb',41,3,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51378,'forelimb',41,3,98,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51379,'forelimb',41,3,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51380,'forelimb',41,3,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51381,'forelimb',41,3,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51382,'forelimb',41,3,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51383,'forelimb',41,3,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51384,'forelimb',41,3,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51385,'forelimb',41,3,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51386,'forelimb',41,3,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51387,'forelimb',41,3,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51388,'forelimb',41,3,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51389,'forelimb',41,3,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51390,'forelimb',41,3,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51391,'forelimb',41,3,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51392,'forelimb',41,3,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51393,'forelimb',41,3,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51394,'forelimb',41,3,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51395,'forelimb',41,3,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51396,'forelimb',41,3,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51397,'forelimb',41,3,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51398,'forelimb',41,3,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51399,'forelimb',41,3,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51400,'forelimb',41,3,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51401,'forelimb',41,3,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51402,'forelimb',41,3,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51403,'forelimb',41,3,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51404,'forelimb',41,3,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51405,'forelimb',41,3,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51406,'forelimb',41,3,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51407,'forelimb',41,3,127,0.0519207,45.7682544,127.3964727,1.8,45.761772,127.402492,0.7854926,0.3126754,0.3041619,0.0031965,0.0031902,0.0043275,0.0104886,0.0102231,0.0204261,0.859376,1.2153412,2.3561945,2.4306824),(51408,'forelimb',41,3,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51409,'forelimb',41,3,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51410,'forelimb',41,3,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51411,'forelimb',41,3,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51412,'forelimb',41,3,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51413,'forelimb',41,3,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51414,'forelimb',41,3,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51415,'forelimb',41,3,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51416,'forelimb',41,3,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51417,'forelimb',41,3,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51418,'forelimb',41,3,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51419,'forelimb',41,3,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51420,'forelimb',41,3,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51421,'forelimb',41,3,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51422,'forelimb',41,3,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51423,'forelimb',41,3,143,0.6527013,67.6983647,120.1916452,1.8,67.7802128,120.3003632,0.731247,0.9649972,2.6510859,0.1316559,1.0324366,0.0485125,0.3894391,0.1364314,0.4388293,2.353848,5.2450105,2.5308667,12.552563),(51424,'forelimb',41,3,144,16.6703472,66.6281346,122.0256855,1.8,66.2541667,122.2950994,-0.6423636,3.9641374,4.8363529,66.1718283,76.1774909,0.9971878,15.75102,16.6926174,28.3026313,8.2035531,9.2955727,0.9827937,27.5789941),(51425,'forelimb',41,3,145,26.968884,66.3769761,122.5723605,1.8,66.2215816,122.4506317,-0.7785359,4.1833918,4.6273271,94.1751208,114.3637419,2.2165635,24.71486,22.5116666,44.810371,8.5073884,9.7417008,0.7229794,29.0460407),(51426,'forelimb',41,3,146,23.2258943,66.2490032,122.5026332,1.8,66.2094976,122.4332685,-0.8137462,3.7635504,4.5243727,77.7815184,99.9491067,2.045167,22.0912628,20.6670593,39.1670114,7.8997178,9.5406219,0.625485,27.9349593),(51427,'forelimb',41,3,147,21.0297832,66.1973041,122.4693783,1.8,66.1356403,122.4005606,-0.8413285,3.6647536,4.3256916,64.6316816,92.5206676,1.9481072,21.3886417,17.6360237,35.4822262,7.5958825,9.2955727,0.9827937,26.7196181),(51428,'forelimb',41,3,148,20.9728271,66.1304339,122.4730643,1.8,66.0139785,122.4816166,-0.845902,3.6162192,4.2828988,61.2338695,88.3486039,1.9587091,20.628226,16.9331188,34.0472788,7.5958825,9.0642783,1.0222469,26.1119475),(51429,'forelimb',41,3,149,21.3118782,66.009493,122.5126144,1.8,65.9144672,122.4430397,-0.8332094,3.5853218,4.1304811,59.8507583,85.6367458,1.9455556,20.7328745,16.6932738,34.9783685,7.4796742,8.8582451,0.6823166,25.7559823),(51430,'forelimb',41,3,150,20.9004291,65.8696629,122.5263679,1.8,65.7662307,122.4867586,-0.8388908,3.5245467,4.029516,59.2008607,81.7110671,1.9276836,20.2781345,16.7967303,34.6363336,7.2920472,8.7005189,0.9964915,24.8966063),(51431,'forelimb',41,3,151,20.5148844,65.7580584,122.5135724,1.8,65.6277979,122.5262376,-0.8016266,3.7032632,3.9374008,59.7350536,76.5875067,1.7650514,19.4512852,16.1303831,33.8126919,7.304696,8.4747721,1.0390723,24.5406411),(51432,'forelimb',41,3,152,20.633832,65.6052567,122.5494965,1.8,65.4323251,122.5191935,-0.7454369,3.9066037,3.8224767,61.7234225,75.5918397,1.5822064,19.775618,15.7997654,34.7590368,7.5046397,8.2986537,1.199905,25.1483117),(51433,'forelimb',41,3,153,20.2998163,65.4399273,122.5500145,1.8,65.2623302,122.5061279,-0.3210417,3.7932202,3.7614241,65.9574582,75.6964157,0.3368926,20.1244036,17.3882492,34.4143642,7.304696,8.2540369,2.2455373,24.7923465),(51434,'forelimb',41,3,154,20.6630374,65.2362356,122.5564104,1.8,65.0371775,122.5125098,0.0143527,3.7888783,3.8164972,69.2031604,81.7385248,0.0007094,21.4171583,18.2648146,35.1457013,7.734384,8.5290633,2.284887,25.6517225),(51435,'forelimb',41,3,155,21.2420538,65.1256884,122.5690113,1.8,64.9414818,122.514791,0.1374595,3.8748287,4.2037714,70.4925047,88.1897855,0.0664749,20.9787303,18.1924182,35.2415159,7.734384,8.8164606,2.3217254,26.0076877),(51436,'forelimb',41,3,156,21.2806027,65.0581988,122.6385203,1.8,64.8412019,122.5348324,0.1467805,3.8014032,4.2763598,70.9011971,91.631976,0.0758662,21.4275644,18.6513227,36.0934007,7.734384,8.8582451,2.7430702,26.0076877),(51437,'forelimb',41,3,157,22.6804473,64.9910899,122.6951259,1.8,64.813887,122.6053548,0.2175448,3.8490899,4.3031732,74.8400453,98.8274767,0.1760904,22.9661863,19.4435688,39.2103178,7.8803952,8.8582451,2.7430702,26.3636529),(51438,'forelimb',41,3,158,22.0346277,64.9260266,122.7390111,1.8,64.7448294,122.6518801,0.1629786,3.9437532,4.3973231,75.2278027,101.3255104,0.0966867,23.0425439,19.0751799,40.1501429,7.8468346,8.8582451,2.7430702,26.7196181),(51439,'forelimb',41,3,159,22.3820152,64.9050457,122.802816,1.8,64.7221414,122.6743784,0.1341543,4.0532028,4.38341,77.2605774,104.7527333,0.0667345,23.897544,19.0616114,41.3531513,7.8468346,8.8582451,2.7430702,26.7196181),(51440,'forelimb',41,3,160,22.4913396,64.8587922,122.869448,1.8,64.7293172,122.7666704,0.1331738,3.8150181,4.3462282,77.5168525,106.8190925,0.0660895,24.5774241,20.3188688,41.9557234,7.734384,9.0336729,2.6992184,26.3636529),(51441,'forelimb',41,3,161,22.7826661,64.9060795,122.9462354,1.8,64.8248644,122.8531311,0.1228844,3.8902367,4.399632,76.636558,109.6543741,0.0570505,24.923533,19.6997157,42.1866359,7.8803952,9.1856803,2.9533711,26.8238779),(51442,'forelimb',41,3,162,22.9949927,64.9130906,123.0117469,1.8,64.8297629,122.9345181,0.1393894,3.8855932,4.3616232,76.6357665,110.4903272,0.0739821,25.3323873,19.7230543,42.8993372,7.6886694,9.115059,2.9996956,26.8238779),(51443,'forelimb',41,3,163,22.9399388,65.0540275,123.0578047,1.8,64.9494817,122.9906586,0.185782,3.8538262,4.2378042,75.2235433,108.4709247,0.1304506,25.5960212,19.5191844,41.2336732,7.4980344,8.9721488,2.8501359,26.7196181),(51444,'forelimb',41,3,164,23.2801089,65.0974527,123.1041565,1.8,65.0033909,123.0651801,0.2241881,3.7397107,4.2181019,74.5273339,107.6489148,0.1917656,25.5207006,19.9286362,41.8903281,7.4947618,8.9412281,2.1854593,26.7196181),(51445,'forelimb',41,3,165,23.1206542,65.240608,123.2044716,1.8,65.1836696,123.1965075,0.2374308,3.6390003,4.0657318,70.9700135,103.3221206,0.2131802,25.4129209,19.5026128,40.6505212,7.3950623,8.7005189,2.1451012,25.7559823),(51446,'forelimb',41,3,166,23.3828873,65.2861264,123.2890456,1.8,65.2005562,123.2820014,0.2278119,3.6644447,4.0255454,68.6416207,101.5682875,0.1987804,25.2309383,18.7317932,39.9940333,7.4741267,8.7005189,2.1451012,25.7559823),(51447,'forelimb',41,3,167,23.086861,65.4713167,123.4250235,1.8,65.4980015,123.4684398,0.1935123,3.5491494,4.0407913,63.9182387,94.4008334,0.1422993,23.3619672,18.0094527,38.2463082,7.2509862,8.3430318,2.5393053,25.1483117),(51448,'forelimb',41,3,168,22.9340082,65.5484013,123.5341768,1.8,65.5498932,123.5595711,0.157423,3.5779019,3.9773322,61.7836752,90.1510644,0.0939452,22.6662143,17.26813,37.3609291,7.1916662,8.3430318,0.2074962,25.1483117),(51449,'forelimb',41,3,169,22.6148191,65.7361727,123.6996354,1.8,65.8431473,123.7613533,0.0969975,3.5126403,3.9015815,59.2936193,83.6977811,0.0353509,21.4522704,16.8800712,36.1377687,6.875008,8.1527566,0.3217506,23.9329705),(51450,'forelimb',41,3,170,22.3495647,65.8221245,123.819193,1.8,65.8874031,123.8628177,0.0416091,3.404609,3.7990549,58.0377184,79.5133436,0.0064453,20.9297693,17.0468088,35.2743125,6.875008,8.1527566,0.3217506,23.6812651),(51451,'forelimb',41,3,171,21.8877056,66.031544,123.9693727,1.8,66.0685086,123.9629987,-0.0437884,3.2777647,3.7324244,56.1383082,73.3452188,0.0069902,19.6508251,17.1270099,34.6494625,6.875008,7.9230552,0.2186689,23.4295597),(51452,'forelimb',41,3,172,21.7515816,66.1166681,124.0821656,1.8,66.1456032,124.0622758,-0.1204737,3.3089857,3.6106566,54.9456427,70.3028572,0.0523627,19.470934,16.6049802,33.9390744,6.875008,7.8997178,0.390607,23.3252999),(51453,'forelimb',41,3,173,21.8582204,66.2953006,124.2100326,1.8,66.2742587,124.2207547,-0.24434,3.3802054,3.6556761,54.0788787,66.6230421,0.2132026,18.2245476,15.9986961,33.0136781,6.875008,7.7463106,0.3392926,23.0735945),(51454,'forelimb',41,3,174,22.0379287,66.3751645,124.2905264,1.8,66.3701091,124.2820393,-0.3799127,3.3329294,3.5784037,53.6729377,64.6576207,0.5051162,18.0688444,16.1038326,32.8575736,6.875008,7.7463106,0.5880026,22.4659239),(51455,'forelimb',41,3,175,22.2063912,66.5167545,124.3721016,1.8,66.5152811,124.3778255,-0.5271161,3.3406752,3.4790173,52.9639444,62.2539564,0.9365628,17.8941208,15.8542632,32.3783189,6.875008,7.6019567,0.7454195,22.4659239),(51456,'forelimb',41,3,176,22.2742574,66.5791269,124.4425101,1.8,66.5695737,124.3957449,-0.6693189,3.3036102,3.5355213,52.6116777,60.875851,1.4291187,17.2183521,15.9255099,31.7415452,6.875008,7.5164702,1.0303768,22.2142185),(51457,'forelimb',41,3,177,22.3267375,66.7295294,124.5069539,1.8,66.7463088,124.454055,-0.8575586,3.2819761,3.5191052,51.4764239,59.4849239,2.128148,16.9034229,15.6845822,31.3556469,6.875008,7.5164702,1.0303768,22.2142185),(51458,'forelimb',41,3,178,22.1563728,66.7936927,124.5673509,1.8,66.8089267,124.5469022,-1.0136688,3.2377605,3.5516145,50.8412319,58.4961861,2.6603271,16.4703083,15.7025919,30.6425608,6.875008,7.5164702,1.0303768,22.5701837),(51459,'forelimb',41,3,179,21.9821475,66.9601767,124.6205439,1.8,66.9625779,124.6009262,-1.2253057,3.3166837,3.5598832,49.2688041,57.5098819,3.2435043,16.1549912,14.8548397,29.8943715,6.6843766,7.6140908,1.2847449,22.3184783),(51460,'forelimb',41,3,180,21.5082593,67.0212158,124.6570619,1.8,67.0576354,124.6292506,-1.341849,3.3487466,3.591439,48.207718,56.3954454,3.4000707,15.7027433,14.3957495,29.1221741,6.875008,7.6140908,1.2847449,22.3184783),(51461,'forelimb',41,3,181,21.0265941,67.1694725,124.7012333,1.8,67.1664361,124.7180494,-1.4367952,3.2448238,3.5939357,46.5430782,55.3725247,3.4418814,15.4072106,14.3437921,28.2929215,6.44532,7.6140908,1.2847449,21.7108077),(51462,'forelimb',41,3,182,20.908206,67.2244732,124.7103498,1.8,67.209437,124.7319699,-1.5096395,3.2274016,3.5724381,45.5437034,55.1550329,3.4716839,15.4390452,14.1115699,27.967912,6.44532,7.6140908,1.2847449,21.9625131),(51463,'forelimb',41,3,183,20.4803638,67.3511389,124.708005,1.8,67.3223336,124.7572963,1.5517028,3.3333438,3.5332466,43.4877245,53.6469646,3.4121497,15.1834757,13.0462763,26.831063,6.44532,7.5041783,1.801887,21.9625131),(51464,'forelimb',41,3,184,20.3485479,67.3951435,124.71843,1.8,67.3963318,124.7296478,1.5243151,3.0754292,3.539523,42.6027666,52.7475197,3.3841028,14.9024375,13.8526249,26.5318924,6.44532,7.5041783,1.801887,21.7108077),(51465,'forelimb',41,3,185,20.2642327,67.5226959,124.7345906,1.8,67.5207587,124.7841526,1.5201733,3.1244633,3.5393889,42.1074186,51.3878685,3.3687244,14.5188533,13.4766883,26.1048351,6.44532,7.5041783,1.3397057,21.7108077),(51466,'forelimb',41,3,186,20.1908836,67.5592711,124.752874,1.8,67.5632121,124.8185574,1.5042744,3.1467972,3.3660206,41.4179248,50.8589565,3.3502779,15.1095202,13.1619302,26.1960008,6.44532,7.3926319,2.1910458,21.6065479),(51467,'forelimb',41,3,187,20.1171428,67.6725581,124.7567491,1.8,67.6418137,124.8302341,1.4978952,3.2313805,3.3600186,40.2189509,49.8012364,3.3350696,14.8217145,12.446368,26.0007181,6.44532,7.3425118,1.929567,21.3548425),(51468,'forelimb',41,3,188,20.015875,67.6983214,124.7584969,1.8,67.6652939,124.8396261,1.4820896,3.2572303,3.4068391,39.7727361,49.3197981,3.3097975,14.4767031,12.2105999,24.7011842,6.44532,7.5041783,1.9832068,21.3548425),(51469,'forelimb',41,3,189,19.8083042,67.7983806,124.7571477,1.8,67.8004933,124.8089332,1.4691976,3.0162273,3.4130173,38.955153,48.286665,3.2674232,14.1477938,12.9151914,24.4503241,6.015632,7.5041783,1.9832068,20.9988773),(51470,'forelimb',41,3,190,19.7833509,67.8246788,124.7808661,1.8,67.8167022,124.8148154,1.4743517,3.0357506,3.381468,38.6822306,48.2082133,3.2666508,14.2565929,12.7422292,24.5723445,6.015632,7.5041783,1.9832068,20.9988773),(51471,'forelimb',41,3,191,19.8687851,67.923493,124.7728078,1.8,67.9263135,124.7875675,1.5061182,3.0792377,3.348567,38.4568044,48.044945,3.2976308,14.347912,12.4890666,24.6657859,6.44532,7.3425118,1.929567,21.3548425),(51472,'forelimb',41,3,192,20.049948,67.9482566,124.7834187,1.8,67.9426443,124.7913111,1.5206222,3.0958897,3.3212623,38.4085409,48.2790501,3.3332526,14.5363557,12.4063013,24.8514637,6.44532,7.3425118,1.929567,21.3548425),(51473,'forelimb',41,3,193,19.9887398,68.0532873,124.8056529,1.8,68.0782474,124.8160551,1.5576904,3.1731879,3.2558559,37.90366,48.1803572,3.3308844,14.7980617,11.9449781,25.0861405,6.44532,7.3425118,1.929567,21.1031371),(51474,'forelimb',41,3,194,20.0509551,68.0698599,124.8099901,1.8,68.0959994,124.8148154,1.55791,2.8420824,3.2510674,37.7623426,48.580321,3.3412709,14.9428833,13.2868569,25.2314213,6.015632,7.3425118,1.929567,20.7471719),(51475,'forelimb',41,3,195,20.0734466,68.1460729,124.7899782,1.8,68.1407484,124.8231502,1.5668675,2.8378305,3.2610819,37.3201695,48.8659156,3.3455228,14.9845717,13.1509507,25.2216719,6.015632,7.3425118,1.929567,20.7471719),(51476,'forelimb',41,3,196,20.066397,68.1536876,124.7928941,1.8,68.1407484,124.8231502,1.5643243,2.8482081,3.2607025,37.3099186,49.4213558,3.3442594,15.1566588,13.0994354,25.4189822,6.015632,7.3425118,1.929567,20.7471719),(51477,'forelimb',41,3,197,20.0002093,68.2359959,124.7850796,1.8,68.1874499,124.8018113,1.5658383,3.0930446,3.6147312,37.1846549,50.1009084,3.3332863,13.8602031,12.0220237,24.0487534,6.44532,7.5041783,1.801887,21.4591023),(51478,'forelimb',41,3,198,19.9580797,68.2502856,124.7897493,1.8,68.2212332,124.7865892,-1.5636124,3.079635,3.6181436,37.2134502,50.3559074,3.3261749,13.917609,12.0837209,24.0868997,6.3880189,7.5041783,1.801887,21.4591023),(51479,'forelimb',41,3,199,19.9131526,68.3300888,124.7594984,1.8,68.2990263,124.7780716,-1.5681581,3.017898,3.5874443,37.1072792,50.2739393,3.3188357,14.0138591,12.2957367,24.1765961,6.44532,7.5041783,1.801887,21.4591023),(51480,'forelimb',41,3,200,19.8776809,68.3425802,124.7647404,1.8,68.3156177,124.779008,-1.5634971,3.0279201,3.5924667,37.1421931,50.410027,3.3127703,14.0321485,12.2665698,24.1788142,6.3880189,7.5041783,1.801887,21.4591023),(51481,'forelimb',41,3,201,19.7892815,68.4266265,124.7688329,1.8,68.4177246,124.7875675,-1.5429938,2.9318661,3.5924736,37.3825232,49.9612167,3.2956648,13.907191,12.7504198,24.0184712,6.015632,7.5041783,1.801887,21.6065479),(51482,'forelimb',41,3,202,19.760132,68.4384433,124.7728382,1.8,68.4407991,124.7606191,-1.5200709,2.9431271,3.590205,37.5975607,50.0331857,3.2848886,13.9360248,12.7746981,24.0595508,6.015632,7.5041783,1.801887,21.6065479),(51483,'forelimb',41,3,203,19.8533431,68.514662,124.7574255,1.8,68.4913176,124.7733237,-1.498818,2.8883286,3.5621545,37.6983801,49.860982,3.2917771,13.9974226,13.0519706,24.0594146,6.015632,7.5041783,1.801887,21.6065479),(51484,'forelimb',41,3,204,19.8987178,68.5242479,124.7690598,1.8,68.4927394,124.824364,-1.473586,2.9003506,3.5602757,38.0298917,49.9352062,3.2852116,14.0256572,13.1121704,24.415653,6.015632,7.4175649,1.7454685,21.6065479),(51485,'forelimb',41,3,205,19.8412581,68.604601,124.7638016,1.8,68.5726002,124.770653,-1.443776,3.1627795,3.526846,38.3380183,49.7344392,3.253809,14.101676,12.1216223,24.4441171,6.44532,7.4175649,1.7454685,21.7108077),(51486,'forelimb',41,3,206,19.8047234,68.6140692,124.7714278,1.8,68.5912823,124.7869998,-1.4113051,3.1464537,3.4171463,38.704388,49.6548288,3.2175331,14.5310808,12.3009557,24.9397223,6.44532,7.3425118,1.929567,21.3548425),(51487,'forelimb',41,3,207,19.7002666,68.6823693,124.7602075,1.8,68.6650868,124.8172812,-1.3624286,3.1556042,3.3794887,38.7762509,49.1986464,3.1428742,14.5580149,12.2880591,25.9787228,6.44532,7.2028834,1.8736812,21.1031371),(51488,'forelimb',41,3,208,19.7005463,68.6838383,124.7598283,1.8,68.6772913,124.8044058,-1.3337555,3.1546066,3.3815258,39.035231,49.553959,3.1023638,14.6543194,12.3740409,26.1587585,6.44532,7.2028834,1.8736812,21.3548425),(51489,'forelimb',41,3,209,19.601069,68.7557636,124.7395911,1.8,68.7643238,124.7733237,-1.2856081,3.0860537,3.4172157,38.9568538,49.6848321,3.0082704,14.5395659,12.6235179,25.9285541,6.3880189,7.2028834,1.8736812,21.3548425),(51490,'forelimb',41,3,210,19.6202595,68.762752,124.7404061,1.8,68.7643238,124.7733237,-1.2619028,3.0748498,3.4152241,39.0241471,49.8741256,2.9678296,14.6034708,12.6913996,25.9961035,6.3880189,7.2028834,1.8736812,21.3548425),(51491,'forelimb',41,3,211,19.4937028,68.8166459,124.7096452,1.8,68.7642455,124.7535363,-1.2403421,3.0284701,3.457253,39.013436,50.2398784,2.9068927,14.5317331,12.8822261,25.2252324,6.3880189,7.4175649,1.3961241,21.7108077),(51492,'forelimb',41,3,212,19.4490555,68.8138161,124.7080518,1.8,68.7712122,124.7363132,-1.2279204,3.0285035,3.4549638,39.1980036,50.7014471,2.8751265,14.6749577,12.9430273,25.4196665,6.3880189,7.4175649,1.3961241,21.7108077),(51493,'forelimb',41,3,213,19.4340052,68.8796685,124.6951775,1.8,68.8664044,124.7353402,-1.2172253,3.1168664,3.4869378,39.0501809,50.9217086,2.8506797,14.6035609,12.5286668,25.520002,6.015632,7.4175649,1.3961241,21.3548425),(51494,'forelimb',41,3,214,19.4642177,68.8715811,124.6956757,1.8,68.8294789,124.726283,-1.2092538,3.125211,3.4816447,39.4035789,51.5234856,2.8381553,14.7986051,12.608294,25.4946956,6.44532,7.4175649,1.7454685,21.7108077),(51495,'forelimb',41,3,215,19.31461,68.9400029,124.6621167,1.8,68.8948662,124.6515547,-1.2293936,3.0692417,3.4237035,39.3259628,51.9427314,2.8582494,15.1715039,12.8129247,25.7481138,6.015632,7.4175649,1.7454685,21.6065479),(51496,'forelimb',41,3,216,19.22235,68.9340746,124.6603018,1.8,68.8956574,124.6541324,-1.2390989,3.0731422,3.4154755,39.4692019,52.1803589,2.8639799,15.2776266,12.8432723,25.8761395,6.015632,7.4175649,1.7454685,21.6065479),(51497,'forelimb',41,3,217,19.1773111,68.9654417,124.6436078,1.8,68.8940963,124.6354902,-1.2401563,3.0486264,3.4405625,39.4150454,52.4030026,2.8593479,15.2309404,12.9287884,25.8833925,6.015632,7.4175649,1.3961241,21.6065479),(51498,'forelimb',41,3,218,19.1948231,68.9548762,124.6368686,1.8,68.8980054,124.6165641,-1.248085,3.0584645,3.4935864,39.6381554,52.9139059,2.8773769,15.1460134,12.9601489,26.0909647,6.015632,7.5041783,1.1583859,21.6065479),(51499,'forelimb',41,3,219,19.255304,68.9992108,124.6046108,1.8,68.9335684,124.5862936,-1.259511,3.0366457,3.4848834,39.80075,53.6412956,2.9081641,15.3925652,13.1068138,25.9047106,6.3880189,7.5164702,1.0303768,21.9625131),(51500,'forelimb',41,3,220,19.2544088,68.9822905,124.5953761,1.8,68.9010515,124.5816483,-1.2715287,3.0364496,3.4933725,39.97662,54.1388419,2.9301388,15.4975862,13.1655799,26.1649,6.015632,7.5164702,1.0303768,21.6065479),(51501,'forelimb',41,3,221,19.1961099,69.0412609,124.5640652,1.8,68.9846664,124.5444861,-1.2689468,3.0175855,3.5127533,40.1006378,54.2906291,2.9165951,15.4552922,13.2889816,25.8220861,6.3880189,7.5164702,1.0303768,21.9625131),(51502,'forelimb',41,3,222,19.1558266,69.0218685,124.5490816,1.8,68.9591174,124.5166145,-1.2593469,3.0319348,3.5306206,40.3901119,54.9294929,2.8928342,15.5580277,13.3215633,26.0622563,6.44532,7.6864926,1.1071487,21.6065479),(51503,'forelimb',41,3,223,19.1167742,69.0438225,124.4957303,1.8,68.9848822,124.4874229,-1.2712003,3.0373084,3.4694156,40.3936362,55.1397388,2.9086037,15.8930915,13.2991555,26.2840689,6.44532,7.5164702,1.0303768,21.6065479),(51504,'forelimb',41,3,224,19.2252594,69.0213509,124.4827523,1.8,68.9718545,124.4824617,-1.2756415,3.0661913,3.4997682,40.8887693,55.8131714,2.9330831,15.9476768,13.3353614,25.7854774,6.44532,7.5164702,1.0303768,21.9625131),(51505,'forelimb',41,3,225,19.2850689,69.0504004,124.4455183,1.8,69.0106355,124.4221029,-1.2765604,3.049922,3.5815597,41.1578446,56.6257272,2.9438495,15.8103541,13.4947206,26.3188193,6.44532,7.6503773,0.9048271,22.2142185),(51506,'forelimb',41,3,226,19.2978812,69.0256382,124.4285116,1.8,68.9923509,124.394676,-1.2723888,3.0754226,3.5685899,41.4763857,57.0539123,2.9383112,15.9878029,13.4864021,26.6552492,6.44532,7.6503773,0.9048271,22.2142185),(51507,'forelimb',41,3,227,19.2968182,69.0512528,124.3731405,1.8,68.9917795,124.3230613,-1.2729216,3.0675895,3.6347469,41.7017511,57.7358096,2.9391116,15.8844101,13.5943061,26.6500965,6.44532,7.7463106,0.9827937,22.4659239),(51508,'forelimb',41,3,228,19.3712863,69.0273839,124.3582284,1.8,68.9816217,124.308961,-1.2720036,3.0941516,3.6270317,42.08024,58.3713376,2.9487885,16.0934179,13.5999282,26.9530553,6.44532,7.7463106,0.9827937,22.4659239),(51509,'forelimb',41,3,229,19.3499138,69.0612602,124.3375106,1.8,69.0122999,124.296619,-1.2569057,3.057556,3.6136653,42.4501503,58.8962766,2.9175359,16.2982103,13.8836869,26.9201404,6.44532,7.7463106,0.9827937,22.4659239),(51510,'forelimb',41,3,230,19.3235618,69.0303977,124.32229,1.8,68.983654,124.2900084,-1.2532964,3.0890576,3.620305,42.7207466,59.3855225,2.9067014,16.4034583,13.829702,27.1832967,6.44532,7.7463106,0.9827937,22.4659239),(51511,'forelimb',41,3,231,19.1799407,69.0436322,124.279745,1.8,68.9990787,124.2856014,-1.2341854,3.0966244,3.6730061,43.0560496,59.6754219,2.8479284,16.2470251,13.9041887,27.0540657,6.44532,7.7463106,0.9827937,22.4659239),(51512,'forelimb',41,3,232,19.1790455,69.0031057,124.2669053,1.8,68.9232706,124.2938309,-1.2229475,3.1460014,3.6754291,43.5227002,60.3295567,2.8250842,16.4142893,13.8342915,27.4651324,6.5657193,7.7463106,0.9827937,22.8218891),(51513,'forelimb',41,3,233,19.1112353,69.0062426,124.2225073,1.8,68.9223914,124.2387232,-1.1969001,3.1737243,3.7246712,44.1955471,60.8936661,2.7602864,16.3487361,13.9254525,27.5274624,6.5668399,7.8997178,1.1801893,22.8218891),(51514,'forelimb',41,3,234,19.1171099,68.9567764,124.2059701,1.8,68.8286017,124.2365421,-1.1741405,3.0767153,3.7243671,44.7123097,61.5259304,2.7106294,16.519835,14.5324822,27.9602679,6.44532,7.8997178,1.1801893,22.4659239),(51515,'forelimb',41,3,235,19.4722184,68.94975,124.1385059,1.8,68.8796342,124.1603989,-1.1374848,3.1072203,3.7532624,45.6309437,62.9016073,2.6732174,16.7591818,14.6854551,28.2013212,6.6591601,7.9926588,0.9380475,23.0735945),(51516,'forelimb',41,3,236,19.5380704,68.8927618,124.1303015,1.8,68.8209785,124.1519023,-1.1267557,3.1623319,3.7451019,46.3064636,63.7741512,2.6553897,17.0286826,14.6431384,28.8127619,6.44532,7.9926588,0.9380475,22.9693347),(51517,'forelimb',41,3,237,19.6689911,68.8836021,124.0851288,1.8,68.8305142,124.0866977,-1.121538,3.1900428,3.7857051,47.2758029,65.3524633,2.6598561,17.2629567,14.8198019,29.2437624,6.6607029,8.107337,1.012197,23.6812651),(51518,'forelimb',41,3,238,19.7600201,68.8281681,124.0625501,1.8,68.75008,124.0507139,-1.0944137,3.2484352,3.7981617,47.7968548,66.4200488,2.6007999,17.4874202,14.7138088,29.7661338,6.44532,8.107337,1.012197,23.0735945),(51519,'forelimb',41,3,239,19.6169585,68.8153257,124.0091686,1.8,68.767182,123.9575059,-1.0680551,3.2818111,3.8518093,48.122952,67.0973783,2.510449,17.4197042,14.6635352,29.746652,6.44532,8.107337,1.012197,22.7176293),(51520,'forelimb',41,3,240,19.499018,68.7580237,123.9907066,1.8,68.6923607,123.9660569,-1.0362679,3.1836067,3.8495347,48.5661142,67.6943195,2.4064248,17.5850655,15.2550607,30.1488152,6.7267676,8.107337,1.012197,23.0735945),(51521,'forelimb',41,3,241,19.5025427,68.7355872,123.9366614,1.8,68.6833323,123.9149273,-1.0000111,3.2416437,3.8885871,49.2412393,68.7746533,2.3015714,17.6862833,15.1902072,30.3477584,6.7955022,8.2652137,1.0838971,23.0735945),(51522,'forelimb',41,3,242,19.5621285,68.6682156,123.9056353,1.8,68.6048045,123.9015579,-0.9744932,3.320139,3.8761573,50.081819,69.5049491,2.2321025,17.9314056,15.0842538,30.6409593,6.875008,8.2652137,1.0838971,23.3252999),(51523,'forelimb',41,3,243,19.2336517,68.6407316,123.8528878,1.8,68.5949731,123.8318895,-0.937852,3.3769565,3.8026645,49.7914147,69.5656063,2.0839743,18.2939111,14.7444641,30.5526913,6.7955022,8.107337,0.5585993,23.3252999),(51524,'forelimb',41,3,244,19.2111602,68.5733176,123.8265262,1.8,68.5278999,123.8109291,-0.9085749,3.3719694,3.7883399,50.2523971,70.1515276,1.9913475,18.5177492,14.9029814,31.1652756,6.875008,8.107337,1.012197,23.3252999),(51525,'forelimb',41,3,245,19.1436857,68.5443161,123.7721607,1.8,68.4771976,123.7419983,-0.8531615,3.2145542,3.8718462,50.4531646,71.6574325,1.8108527,18.5073033,15.6952291,30.259373,6.9195843,8.3430318,0.968509,23.6812651),(51526,'forelimb',41,3,246,19.1559385,68.4811143,123.748195,1.8,68.4222138,123.7664355,-0.829277,3.2617471,4.04272,50.7569743,72.741934,1.7362385,17.993315,15.5612842,30.2239539,6.9195843,8.5290633,0.8567056,23.9329705),(51527,'forelimb',41,3,247,19.1978444,68.4459645,123.6799012,1.8,68.3774122,123.7114517,-0.7972131,3.371943,4.0839839,51.0667007,74.0476535,1.6376204,18.1312303,15.1445917,30.4957547,7.0666434,8.5290633,0.8567056,24.1846759),(51528,'forelimb',41,3,248,19.3396751,68.3761948,123.6491319,1.8,68.3244266,123.6976938,-0.7771147,3.3774756,4.06789,51.5705988,75.577536,1.5849407,18.579051,15.2689773,30.6019431,6.9206751,8.5290633,0.7140907,24.1846759),(51529,'forelimb',41,3,249,19.1932565,68.3244152,123.5926714,1.8,68.2376821,123.5827069,-0.7499719,3.2814171,4.0899451,51.2425319,76.593435,1.4862085,18.7272528,15.6159763,30.8586863,6.9882119,8.5290633,0.7140907,24.6449009),(51530,'forelimb',41,3,250,19.0162898,68.235576,123.5721037,1.8,68.1569895,123.5564818,-0.7211801,3.2608013,4.0930644,51.3512725,77.0547992,1.3817184,18.825699,15.748053,30.3464736,6.9882119,8.59376,0.6435011,24.6449009),(51531,'forelimb',41,3,251,18.7310617,68.2011159,123.5101095,1.8,68.1228577,123.4854073,-0.6974972,3.4247069,4.1307296,51.2600254,77.036957,1.28792,18.6497216,14.9677116,30.3380406,7.0754422,8.59376,0.6435011,24.5406411),(51532,'forelimb',41,3,252,18.5152663,68.1177162,123.4890197,1.8,68.0393638,123.4487515,-0.6736871,3.4282627,4.0991062,51.0468382,76.9204521,1.2010729,18.7651766,14.8900018,30.7232318,7.112401,8.59376,0.6435011,24.1846759),(51533,'forelimb',41,3,253,18.2892882,68.0751234,123.4549021,1.8,67.985965,123.4359853,-0.64642,3.3958228,4.1042773,50.7555362,76.8953124,1.105906,18.7354087,14.9464618,30.2998489,7.1559359,8.59376,0.6435011,24.5406411),(51534,'forelimb',41,3,254,18.1978675,67.99647,123.4212363,1.8,67.9108771,123.3769408,-0.6208363,3.3399025,4.1727726,50.8988055,77.3390901,1.0263387,18.534221,15.239608,29.8938038,6.9882119,8.7005189,0.5743048,24.2889357),(51535,'forelimb',41,3,255,18.1669277,67.9381569,123.3649737,1.8,67.8409716,123.3861028,-0.5913503,3.2790977,4.1832502,50.9155922,77.1847871,0.9410068,18.4509135,15.5273178,30.0871743,6.9882119,8.6473042,0.4636476,24.2889357),(51536,'forelimb',41,3,256,18.093019,67.8421631,123.3383207,1.8,67.7273015,123.3648369,-0.5813151,3.4458382,4.3613531,51.2495651,77.2705042,0.9092847,17.7170945,14.8728878,29.3907435,7.1134919,8.7005189,0.5743048,24.5406411),(51537,'forelimb',41,3,257,18.0125084,67.7710835,123.2973597,1.8,67.6147576,123.3500217,-0.5622857,3.3777197,4.3282832,51.371312,77.4969497,0.8532477,17.9047778,15.2088734,29.4320574,6.9882119,8.7005189,0.3529904,24.6449009),(51538,'forelimb',41,3,258,18.0221875,67.6728413,123.2770854,1.8,67.5694419,123.3104166,-0.5693898,3.4361455,4.25522,51.9176727,77.8282004,0.8730202,18.2900533,15.1092768,30.235856,6.9882119,8.7005189,0.5743048,24.6449009),(51539,'forelimb',41,3,259,18.2207506,67.5841301,123.2292822,1.8,67.461016,123.2733669,-0.5655071,3.4495235,4.3389211,52.6494583,78.5929066,0.8719506,18.1134675,15.2628207,29.9531033,7.2719466,8.8478174,0.5070985,24.8966063),(51540,'forelimb',41,3,260,18.2981841,67.4925925,123.186497,1.8,67.3861163,123.1962801,-0.5769612,3.4891632,4.2782679,53.1458506,79.1173204,0.9074312,18.4928392,15.2316897,30.6406738,7.2719466,8.8478174,0.5070985,24.8966063),(51541,'forelimb',41,3,261,18.3858562,67.4342829,123.1234576,1.8,67.3145315,123.1114714,-0.585299,3.3984865,4.2595565,53.5065363,80.2675399,0.9352256,18.8441074,15.7442249,31.1699634,6.9882119,8.7005189,0.5743048,24.6449009),(51542,'forelimb',41,3,262,18.4552889,67.3393623,123.0902024,1.8,67.2607542,123.0949184,-0.5867442,3.4351443,4.3180843,53.6896457,81.534572,0.942854,18.8821169,15.6295166,30.4348843,7.2719466,8.8582451,0.3985224,25.2525715),(51543,'forelimb',41,3,263,18.4542259,67.2531025,122.9985209,1.8,67.1783768,122.9824348,-0.5861363,3.4312457,4.2975712,53.9410703,82.0187545,0.941076,19.0849088,15.7205503,30.9359628,7.2719466,8.8582451,0.3985224,24.8966063),(51544,'forelimb',41,3,264,18.2139248,67.1623271,122.9384112,1.8,67.0852799,122.9620615,-0.5937556,3.4427409,4.3734872,53.7780978,81.2434232,0.9502065,18.5763487,15.6207217,30.8645271,6.9882119,8.9412281,0.614663,24.8966063),(51545,'forelimb',41,3,265,17.8434304,67.0833544,122.8787082,1.8,66.9369123,122.9389393,-0.5821357,3.4759163,4.4615477,53.0712747,80.1475118,0.8989819,17.9640604,15.2682833,29.7677725,7.2920472,8.9412281,0.614663,24.7923465),(51546,'forelimb',41,3,266,17.8157356,66.971289,122.8488069,1.8,66.8855748,122.9040183,-0.5911853,3.5042452,4.3818157,53.6597778,80.6015468,0.9223623,18.3945543,15.3127921,30.2322524,7.2920472,8.9412281,0.614663,25.1483117),(51547,'forelimb',41,3,267,17.8444375,66.8515922,122.8141845,1.8,66.7609209,122.8852117,-0.6150718,3.3850728,4.3985429,53.7103227,82.8003066,0.9902141,18.8244855,15.8668147,30.3927024,6.9882119,9.0642783,0.5485494,24.8966063),(51548,'forelimb',41,3,268,17.7498836,66.7334675,122.7965146,1.8,66.6611639,122.8107828,-0.6470743,3.5240069,4.4588523,54.611284,84.0171617,1.0751513,18.8427773,15.4969289,31.0903103,7.2920472,8.9412281,0.614663,25.5042769),(51549,'forelimb',41,3,269,18.0165367,66.5906395,122.79501,1.8,66.5263528,122.7971181,-0.6893949,3.449782,4.4030249,55.9236642,88.7264256,1.2148718,20.1512431,16.2107819,32.4205034,7.2920472,9.0642783,0.5485494,25.5042769),(51550,'forelimb',41,3,270,17.8009091,66.4891032,122.7647556,1.8,66.3998735,122.7543888,-0.7089627,3.5592679,4.3771017,56.4314528,89.400005,1.2575213,20.424475,15.8547921,31.8900089,7.4796742,9.2257926,0.4844779,25.7559823),(51551,'forelimb',41,3,271,18.030412,66.3634659,122.670178,1.8,66.2631511,122.7539694,-0.7273905,3.4224516,4.5714888,57.4787298,90.590899,1.3286082,19.8164983,16.7946069,32.3094468,7.2920472,9.1957248,0.6528466,25.7559823),(51552,'forelimb',41,3,272,17.9828554,66.2268182,122.6943279,1.8,66.1769874,122.7380273,-0.7438807,3.5859279,4.4738642,58.4943908,93.3330545,1.3742806,20.8618433,16.3122047,33.2257356,7.4980344,9.2955727,0.5880026,26.3636529),(51553,'forelimb',41,3,273,18.0888788,66.0918129,122.6361409,1.8,66.0808061,122.622213,-0.7673585,3.5750663,4.4049783,59.0298024,94.2967498,1.4530323,21.406859,16.5115268,32.9333963,7.4947618,9.4335845,0.5247958,26.7196181),(51554,'forelimb',41,3,274,18.6047847,65.9311489,122.6209297,1.8,65.9226075,122.6022184,-0.7955836,3.5733306,4.578406,60.2595076,97.0107437,1.5819796,21.1887595,16.8636813,33.3039549,7.5642456,9.6560368,0.5633163,26.6153583),(51555,'forelimb',41,3,275,18.1300013,65.8627946,122.5896741,1.8,65.8325608,122.5435926,-0.8199576,3.5265465,4.5535213,59.5576,98.7732054,1.6151773,21.6916092,16.8883638,33.8315633,7.5958825,9.5406219,0.625485,26.6153583),(51556,'forelimb',41,3,276,18.3902202,65.7133097,122.5852923,1.8,65.7044394,122.4686449,-0.8248192,3.682279,4.7227635,60.1442308,101.6426665,1.6532202,21.5218625,16.3334258,33.7003099,7.4958527,9.798394,0.6610432,27.8306995),(51557,'forelimb',41,3,277,17.983303,65.6096357,122.6272186,1.8,65.5688542,122.5347408,-0.8201365,3.6601676,4.6464763,61.4480615,102.5385927,1.602643,22.0680333,16.7883189,34.9445275,7.5958825,9.798394,0.6610432,27.9349593),(51558,'forelimb',41,3,278,17.3507993,65.4822119,122.6343086,1.8,65.4031174,122.5500868,-0.8436572,3.8463381,4.5862181,61.7663731,101.4757668,1.6139925,22.1262409,16.0584878,34.7406119,7.6470592,9.798394,0.6610432,28.1866647),(51559,'forelimb',41,3,279,17.0223225,65.327247,122.6317564,1.8,65.2747514,122.5291644,-0.9132135,3.732212,4.773049,60.9683317,102.2694149,1.7772095,21.426433,16.3357096,34.1866429,7.6470592,9.8921606,0.9707461,27.8306995),(51560,'forelimb',41,3,280,16.9926136,65.2269485,122.6149361,1.8,65.1765805,122.4451656,-0.9435502,3.8736854,4.7215738,62.5173986,102.0730403,1.8565225,21.6184357,16.1389974,34.7409532,7.8507909,9.8921606,0.9707461,27.8306995),(51561,'forelimb',41,3,281,16.3584874,65.1112671,122.5917637,1.8,65.0823281,122.5259386,-0.9827434,3.8377686,4.7848901,64.299791,103.5939033,1.887391,21.650216,16.7544732,34.5274299,7.8176132,10.0219602,1.0303768,28.1866647),(51562,'forelimb',41,3,282,17.5609438,64.9411286,122.4542734,1.8,64.7685001,122.4361493,-0.8432986,9.6617994,14.1111623,75.8201503,117.6359944,1.6324978,8.3363788,7.8474151,11.4186526,7.8793044,10.0679117,0.8760581,28.6900755),(51563,'forelimb',41,3,283,20.0747894,64.9218276,122.2437157,1.8,64.9519697,122.2773228,-1.1000572,3.9002163,5.2102031,75.78898,122.5206258,2.6575568,23.515518,19.4319941,38.0049629,8.017952,10.2135672,1.1824776,28.6900755),(51564,'forelimb',41,3,284,22.3337871,64.8097794,122.1642755,1.8,64.7698122,122.2641951,-1.1242035,3.8676197,5.2414448,80.8260652,134.6087161,3.0279652,25.681605,20.8981421,40.7552779,8.007444,10.4635866,1.2360595,29.0460407),(51565,'forelimb',41,3,285,25.1762213,64.7108829,122.0972377,1.8,64.6845705,122.1903003,-1.14329,4.0046792,5.4517215,88.7767384,153.3240707,3.474757,28.1239736,22.1682521,44.3356232,8.129466,10.7422,1.2870022,29.9054167),(51566,'forelimb',41,3,286,27.6730584,64.6272229,122.061386,1.8,64.5719457,122.0950495,-1.133986,4.0866154,5.6274563,94.8751513,168.5391292,3.7867235,29.9494337,23.2160704,46.8057123,8.164072,11.0137676,1.2120257,30.1571221),(51567,'forelimb',41,3,287,29.9196355,64.5513411,121.982534,1.8,64.4786117,121.938986,-1.1230458,4.1780508,5.6646432,103.1776968,193.4613269,4.051936,34.1524291,24.6951753,52.3242557,8.59376,11.417094,1.2252407,31.1207579),(51568,'forelimb',41,3,288,30.8615932,64.4904891,121.9635512,1.8,64.3944006,122.0019923,-1.1343574,4.2522568,5.8661191,105.5539883,201.302737,4.2245001,34.3161696,24.8230513,51.8320115,8.59376,11.5697035,1.3078016,31.7284285),(51569,'forelimb',41,3,289,25.2388283,64.6599228,122.3436784,1.8,64.5336891,122.1601746,-0.9711449,4.0604752,5.5704975,71.5190493,160.8696051,2.8667257,28.8788577,17.6134677,41.5912908,8.2035531,11.2048922,1.0040671,30.8690525),(51570,'forelimb',41,3,290,16.0326962,65.0587854,122.8501187,1.8,65.0206782,122.8508814,-0.7973853,2.8572788,5.0237908,20.7135461,102.1079077,1.3680859,20.3248725,7.2493961,24.0248561,5.8647806,10.7422,0.9272952,27.6832539),(51571,'forelimb',41,3,291,6.0257098,65.5396883,122.9410898,1.8,65.3510555,123.0510993,-0.7090806,2.2372332,4.3809156,4.3045463,32.7523229,0.4257952,7.4761364,1.924049,8.4258517,4.4986718,8.9412281,0.9561334,24.0372303),(51572,'forelimb',41,3,292,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51573,'forelimb',41,3,293,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51574,'forelimb',41,3,294,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51575,'forelimb',41,3,295,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51576,'forelimb',41,3,296,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51577,'forelimb',41,3,297,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51578,'forelimb',41,3,298,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51579,'forelimb',41,3,299,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51580,'forelimb',41,3,300,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51581,'forelimb',41,3,301,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51582,'forelimb',41,3,302,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51583,'forelimb',41,3,303,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51584,'forelimb',41,3,304,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51585,'forelimb',41,3,305,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51586,'forelimb',41,3,306,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51587,'forelimb',41,3,307,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51588,'forelimb',41,3,308,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51589,'forelimb',41,3,309,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51590,'forelimb',41,3,310,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51591,'forelimb',41,3,311,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51592,'forelimb',41,3,312,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51593,'forelimb',41,3,313,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51594,'forelimb',41,3,314,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51595,'forelimb',41,3,315,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51596,'forelimb',41,3,316,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51597,'forelimb',41,3,317,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51598,'forelimb',41,3,318,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51599,'forelimb',41,3,319,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51600,'forelimb',41,3,320,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51601,'forelimb',41,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51602,'forelimb',41,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51603,'forelimb',41,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51604,'forelimb',41,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51605,'forelimb',41,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51606,'forelimb',41,4,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51607,'forelimb',41,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51608,'forelimb',41,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51609,'forelimb',41,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51610,'forelimb',41,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51611,'forelimb',41,4,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51612,'forelimb',41,4,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51613,'forelimb',41,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51614,'forelimb',41,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51615,'forelimb',41,4,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51616,'forelimb',41,4,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51617,'forelimb',41,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51618,'forelimb',41,4,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51619,'forelimb',41,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51620,'forelimb',41,4,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51621,'forelimb',41,4,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51622,'forelimb',41,4,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51623,'forelimb',41,4,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51624,'forelimb',41,4,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51625,'forelimb',41,4,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51626,'forelimb',41,4,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51627,'forelimb',41,4,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51628,'forelimb',41,4,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51629,'forelimb',41,4,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51630,'forelimb',41,4,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51631,'forelimb',41,4,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51632,'forelimb',41,4,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51633,'forelimb',41,4,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51634,'forelimb',41,4,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51635,'forelimb',41,4,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51636,'forelimb',41,4,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51637,'forelimb',41,4,37,0.0324504,115.586072,124.3961577,1.8,115.586072,124.394676,1.276784,0.06269,0.2070429,0.0006251,0.0018713,0.0049542,0.0090381,0.0099707,0.0115397,4.698094,42.6453164,0.0705896,92.8051985),(51638,'forelimb',41,4,38,0.1146395,115.6301103,124.2957995,1.8,115.6720096,124.3517072,1.4980617,0.3930575,0.7382426,0.0038806,0.0196276,0.0190057,0.0265869,0.0098729,0.0315669,4.96135,42.7145318,0.0906599,93.6645745),(51639,'forelimb',41,4,39,0.1819462,115.6734102,123.9643273,1.8,115.7293013,123.964988,1.4524203,0.365249,0.64968,0.0085725,0.030471,0.0299014,0.0469016,0.0234703,0.0599676,4.7661118,42.7145318,0.0906599,93.3086093),(51640,'forelimb',41,4,40,0.2236842,115.6934403,123.7707793,1.8,115.747205,123.750144,1.4933677,0.3561871,0.8856798,0.0114833,0.0488901,0.0370576,0.0552006,0.0322395,0.0681002,5.1318805,42.7145318,0.0906599,93.7688343),(51641,'forelimb',41,4,41,0.2117111,115.7014428,123.4559258,1.8,115.770224,123.443224,1.5394085,0.3318986,0.719929,0.0111127,0.0373839,0.0352504,0.0519272,0.0334823,0.066158,5.3569746,42.3738603,0.111777,93.7688343),(51642,'forelimb',41,4,42,0.2033188,115.7129447,123.2210153,1.8,115.770224,123.197688,1.3867194,0.3581476,0.7703193,0.0112285,0.033957,0.0327511,0.0440818,0.0313515,0.058648,5.2754653,42.3280849,0.1016889,93.7688343),(51643,'forelimb',41,4,43,0.2080185,115.7135453,123.0284115,1.8,115.770224,123.013536,1.5422798,0.3182679,0.7178045,0.0113766,0.0358409,0.0346416,0.0499314,0.0357453,0.0644253,5.6061725,42.0523859,0.1332268,93.2654235),(51644,'forelimb',41,4,44,0.2324122,115.7101995,122.9013188,1.8,115.747205,122.890768,1.479096,0.3445902,0.8776384,0.0127479,0.0466409,0.0384106,0.0531436,0.0369945,0.0675842,5.8696904,41.9974686,0.123086,93.3696833),(51645,'forelimb',41,4,45,0.2336991,115.7290613,122.6984011,1.8,115.800916,122.675924,1.4673656,0.3540328,0.6782076,0.0135808,0.0434244,0.0385346,0.0640282,0.0383603,0.078518,6.1916851,41.6863801,0.1448125,93.3696833),(51646,'forelimb',41,4,46,0.2308457,115.724372,122.5879244,1.8,115.770224,122.583848,1.533303,0.3120446,0.7268327,0.013084,0.0386968,0.0384202,0.0532404,0.0419298,0.0694604,6.3488264,41.6265448,0.1345979,93.5782028),(51647,'forelimb',41,4,47,0.2468471,115.7282625,122.4307915,1.8,115.747205,122.46108,1.4526262,0.3325798,0.8666964,0.0142882,0.0477668,0.0405693,0.0551136,0.0429617,0.0688768,6.649196,41.2612363,0.1463153,93.8299082),(51648,'forelimb',41,4,48,0.2700659,115.783246,122.2917685,1.8,115.8725307,122.2701076,1.3967785,0.6228861,0.7137814,0.0212451,0.0485197,0.0436617,0.0679756,0.0341075,0.0958066,6.9294344,41.5710649,0.124355,94.1858734),(51649,'forelimb',41,4,49,0.3020688,115.8270602,122.1884959,1.8,115.9298224,122.246236,1.3625318,0.6375084,0.7261128,0.0297262,0.0515898,0.0481925,0.0710493,0.0466287,0.109521,7.0178989,41.2612363,0.1463153,94.0816137),(51650,'forelimb',41,4,50,0.3603117,115.8616328,122.0408665,1.8,115.9496542,122.031392,1.4421893,0.6353176,0.8970165,0.0396077,0.0771996,0.0590642,0.0860626,0.0623431,0.1281482,7.4154987,41.2612363,0.1463153,94.793544),(51651,'forelimb',41,4,51,0.3752501,115.8781471,121.8921134,1.8,115.9766975,121.8751418,1.2553981,0.6294012,0.7751773,0.0425103,0.066339,0.0565239,0.0855791,0.0675409,0.1354751,7.6403754,40.9016935,0.1582403,94.3333191),(51652,'forelimb',41,4,52,0.4073648,115.9106543,121.8206495,1.8,116.01576,121.816548,1.3658634,0.6556008,0.7358605,0.0505852,0.075259,0.0650825,0.1022734,0.0771586,0.1496947,7.7191222,40.9016935,0.1582403,93.9773539),(51653,'forelimb',41,4,53,0.4298004,115.9214546,121.7473572,1.8,116.01576,121.816548,1.3327083,0.6449032,0.8171704,0.0542739,0.0782143,0.0676489,0.0957135,0.0841582,0.149633,8.1422823,40.54807,0.1703751,93.9773539),(51654,'forelimb',41,4,54,0.4574392,115.9109657,121.6191522,1.8,115.9496542,121.601704,1.416117,0.5969883,0.91641,0.0549851,0.0957795,0.0744303,0.104516,0.0921042,0.1612316,8.6245836,40.4774307,0.1599131,94.793544),(51655,'forelimb',41,4,55,0.430192,115.9036578,121.5191082,1.8,115.9441453,121.5300893,1.3461538,0.6054946,0.8475589,0.0526078,0.0824466,0.0681409,0.0972754,0.0868841,0.1358604,8.968772,40.1246694,0.1721908,94.793544),(51656,'forelimb',41,4,56,0.4393117,115.9390378,121.436111,1.8,116.01576,121.38686,1.3216085,0.6618674,0.7594015,0.056516,0.0809158,0.0687655,0.106552,0.0853886,0.1600006,9.0088129,40.1246694,0.1721908,94.9409897),(51657,'forelimb',41,4,57,0.4353953,115.9345378,121.3674793,1.8,116.01576,121.38686,1.3063266,0.6565595,0.7743799,0.0558107,0.0804789,0.0676076,0.1039268,0.0850048,0.1626871,9.4306063,39.701404,0.1740452,94.5850245),(51658,'forelimb',41,4,58,0.4526835,115.9393392,121.3219368,1.8,116.01576,121.38686,1.290287,0.6467892,0.8218396,0.0581961,0.0826387,0.0696647,0.1005533,0.0899769,0.1616046,9.7044825,39.6292556,0.1633661,94.3333191),(51659,'forelimb',41,4,59,0.4790355,115.92106,121.2158781,1.8,115.985068,121.2334,1.3214827,0.6250182,0.9579664,0.0581735,0.1098837,0.0749786,0.1147052,0.0930749,0.1733336,9.8610914,39.2782781,0.1759396,94.8367299),(51660,'forelimb',41,4,60,0.4882112,115.9020104,121.1575388,1.8,115.9496542,121.172016,1.380365,0.6122058,0.8894269,0.0574387,0.1065073,0.0784533,0.1197482,0.0938226,0.1764353,10.2783188,39.205351,0.1651487,95.65292),(51661,'forelimb',41,4,61,0.4562643,115.8714417,121.1041511,1.8,115.9496542,121.172016,1.373414,0.6338156,0.9375382,0.0504745,0.1024999,0.0731197,0.1093288,0.0796359,0.1576795,10.3566232,38.7815737,0.1669702,95.1495092),(51662,'forelimb',41,4,62,0.4116729,115.8673722,121.007277,1.8,115.9766975,121.0157658,1.2439509,0.6325361,0.7485533,0.045031,0.0770411,0.0615398,0.10292,0.0711912,0.1472229,10.4349276,38.4324631,0.1798535,93.7256485),(51663,'forelimb',41,4,63,0.3957834,115.8169519,120.9060273,1.8,115.8985724,120.8595156,1.365623,0.6486655,1.0486558,0.0375645,0.0836879,0.0632258,0.079805,0.0579104,0.1156102,10.4381698,38.3579279,0.1688319,93.934168),(51664,'forelimb',41,4,64,0.4019378,115.8087513,120.8727177,1.8,115.8985724,120.8595156,1.3602623,0.6498872,1.0144472,0.0371,0.087742,0.064064,0.0864924,0.0570869,0.1230569,10.8599633,37.934418,0.1707352,93.934168),(51665,'forelimb',41,4,65,0.333624,115.7306224,120.8474621,1.8,115.7770444,120.8378142,1.4344578,0.3551827,0.9752065,0.0190901,0.0800055,0.0545768,0.0820396,0.0537471,0.1016071,10.9419516,37.2467874,0.1973956,93.2222377),(51666,'forelimb',41,4,66,0.3121956,115.7211388,120.834657,1.8,115.7770444,120.8378142,1.4382933,0.3610052,0.9612071,0.0173971,0.077205,0.0511244,0.0803209,0.0481906,0.0984165,10.9419516,37.1649072,0.1860582,92.6145671),(51667,'forelimb',41,4,67,0.2058924,115.6596327,120.8467142,1.8,115.70884,120.803712,1.451012,0.3660494,0.9656466,0.0087331,0.0478575,0.0338254,0.04956,0.0238578,0.0585482,11.1997683,36.6647511,0.1767089,91.1475205),(51668,'forelimb',41,4,68,0.1241509,115.586072,120.9274482,1.8,115.586072,120.957172,1.4878967,0.0558316,0.6719403,0.0020667,0.0245842,0.0205499,0.0365869,0.0370171,0.0395265,11.2817567,36.1678883,0.1671018,90.3924042),(51669,'forelimb',41,4,69,0.0407868,115.586072,120.9556984,1.8,115.586072,120.957172,1.2767842,0.0626876,0.2070351,0.0007856,0.002352,0.0062269,0.0113604,0.0125327,0.0145048,11.4727583,35.7442569,0.1691012,90.2449586),(51670,'forelimb',41,4,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51671,'forelimb',41,4,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51672,'forelimb',41,4,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51673,'forelimb',41,4,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51674,'forelimb',41,4,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51675,'forelimb',41,4,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51676,'forelimb',41,4,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51677,'forelimb',41,4,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51678,'forelimb',41,4,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51679,'forelimb',41,4,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51680,'forelimb',41,4,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51681,'forelimb',41,4,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51682,'forelimb',41,4,82,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51683,'forelimb',41,4,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51684,'forelimb',41,4,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51685,'forelimb',41,4,85,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51686,'forelimb',41,4,86,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51687,'forelimb',41,4,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51688,'forelimb',41,4,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51689,'forelimb',41,4,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51690,'forelimb',41,4,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51691,'forelimb',41,4,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51692,'forelimb',41,4,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51693,'forelimb',41,4,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51694,'forelimb',41,4,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51695,'forelimb',41,4,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51696,'forelimb',41,4,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51697,'forelimb',41,4,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51698,'forelimb',41,4,98,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51699,'forelimb',41,4,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51700,'forelimb',41,4,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51701,'forelimb',41,4,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51702,'forelimb',41,4,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51703,'forelimb',41,4,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51704,'forelimb',41,4,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51705,'forelimb',41,4,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51706,'forelimb',41,4,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51707,'forelimb',41,4,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51708,'forelimb',41,4,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51709,'forelimb',41,4,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51710,'forelimb',41,4,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51711,'forelimb',41,4,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51712,'forelimb',41,4,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51713,'forelimb',41,4,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51714,'forelimb',41,4,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51715,'forelimb',41,4,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51716,'forelimb',41,4,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51717,'forelimb',41,4,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51718,'forelimb',41,4,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51719,'forelimb',41,4,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51720,'forelimb',41,4,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51721,'forelimb',41,4,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51722,'forelimb',41,4,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51723,'forelimb',41,4,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51724,'forelimb',41,4,124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51725,'forelimb',41,4,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51726,'forelimb',41,4,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51727,'forelimb',41,4,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51728,'forelimb',41,4,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51729,'forelimb',41,4,129,1.1170782,131.2535433,123.4773009,1.8,131.269684,123.5353,1.0575277,1.2667015,1.3107344,0.3929936,0.3877735,0.1412903,0.2958445,0.3102496,0.595605,2.578128,3.0985242,2.1587989,8.2988688),(51730,'forelimb',41,4,130,8.4356021,131.5778822,123.3961778,1.8,131.6931144,123.3454864,-1.5033926,2.4450908,2.531952,7.467164,8.4669839,1.3995558,3.3440538,3.0539414,6.001782,5.156256,5.585944,1.1760052,16.0943267),(51731,'forelimb',41,4,131,21.4005015,132.145733,123.0641227,1.8,132.1945363,123.0503664,-0.7843829,3.325214,3.6058379,39.9352303,58.1060996,1.7797541,16.1144512,12.0098227,25.9402502,6.8477792,7.7463106,0.5880026,23.1778543),(51732,'forelimb',41,4,132,24.3710589,132.2762282,123.1187879,1.8,132.2770265,123.1164796,-0.7315973,3.7652081,4.1958488,61.3061134,86.1435605,1.8128125,20.5306638,16.2822641,34.8182617,7.5142466,8.59376,0.6435011,26.1119475),(51733,'forelimb',41,4,133,25.7712951,132.2317396,123.1380008,1.8,132.1701673,123.1637828,-0.7280651,3.7847665,3.9984631,75.0277711,91.0248521,1.9018894,22.7649599,19.8236196,38.1143812,7.8997178,9.0336729,1.1284221,26.4679127),(51734,'forelimb',41,4,134,25.5285323,131.9343226,123.1787504,1.8,131.9673576,123.1838061,-0.8738901,3.7173334,4.4449787,66.5951739,101.3089449,2.5019267,22.7917729,17.9147701,36.8719878,7.5958825,9.2955727,0.9827937,26.7196181),(51735,'forelimb',41,4,135,22.1859139,131.4953672,123.0533533,1.8,131.5062451,123.0350315,-0.6210848,3.4854015,4.6316398,51.3100211,100.7975485,1.2521293,21.7628212,14.7214089,32.4962948,7.2719466,9.7417008,0.847817,26.9713235),(51736,'forelimb',41,4,136,20.3564367,131.2482462,123.0750747,1.8,131.2776412,123.0674175,-0.5917412,3.3593551,4.7069855,44.3939169,106.8473255,1.0556462,22.6997356,13.2150118,32.0413385,7.0416448,9.798394,0.6610432,26.9713235),(51737,'forelimb',41,4,137,19.3798465,130.8123925,123.0864773,1.8,130.8055554,123.103972,-0.5626305,3.3629452,4.7265586,38.8234047,112.8058959,0.9190229,23.8663911,11.5444655,32.0488613,6.9284334,9.798394,0.6610432,26.9713235),(51738,'forelimb',41,4,138,19.4371943,130.5582948,123.1125117,1.8,130.5718574,123.1089429,-0.5763416,3.2478027,4.824369,37.3795265,120.3090875,0.9620814,24.937787,11.509174,32.6567593,6.8018442,9.8921606,0.6000502,26.7196181),(51739,'forelimb',41,4,139,19.785477,130.1848565,123.1763834,1.8,130.2483487,123.1502334,-0.5653146,3.0679014,4.9412075,35.2672428,131.7704907,0.946256,26.6676697,11.4955593,33.4608273,6.5931006,10.0679117,0.6947383,27.5789941),(51740,'forelimb',41,4,140,20.6082633,130.0200296,123.1914878,1.8,130.0588199,123.1624098,-0.5538479,3.0390336,5.0919039,36.2668912,144.1923868,0.9501711,28.3179712,11.9336921,35.3909903,6.5127221,10.4016451,0.6682894,27.4747343),(51741,'forelimb',41,4,141,21.7820179,129.7332138,123.1766285,1.8,129.7926315,123.1656419,-0.5387031,3.0187833,5.1855763,38.0876993,161.9627327,0.9554782,31.2333137,12.6169039,38.5379238,6.4937534,10.6732285,0.6998929,29.0460407),(51742,'forelimb',41,4,142,22.6993021,129.6089331,123.175655,1.8,129.7317719,123.1504356,-0.5455134,2.9866124,5.2928096,39.7239666,175.0240881,1.0184898,33.068276,13.3006768,40.5600335,6.535442,10.8448348,0.5880026,28.7943353),(51743,'forelimb',41,4,143,24.3992013,129.31638,123.1923419,1.8,129.5427545,123.1152763,-0.5377203,3.2079737,5.4802936,44.0655993,198.3174708,1.0667642,36.1873808,13.7362722,43.6232125,6.6465832,11.1470707,0.4808873,29.4020059),(51744,'forelimb',41,4,144,26.100723,129.2126912,123.1729096,1.8,129.4311015,123.1346833,-0.5343797,3.2687611,5.6305619,49.1432143,218.9040638,1.128395,38.8778366,15.0342019,47.4748676,6.819171,11.4413255,0.5984189,30.2613819),(51745,'forelimb',41,4,145,29.348284,129.1207345,123.0137788,1.8,129.2653467,122.9405489,-0.5163814,3.6263948,5.6312029,63.8178563,253.8147045,1.1924004,45.0729105,17.5981546,55.9352022,7.4991253,11.7360686,0.4145069,31.4767231),(51746,'forelimb',41,4,146,33.0271002,129.1085271,122.8500904,1.8,129.2638815,122.7333341,-0.5004809,4.4497317,5.7870121,88.1024184,295.1925275,1.2674348,51.0094886,19.7994901,64.4622978,8.5674508,12.1306029,0.4002407,33.1954751),(51747,'forelimb',41,4,147,40.97796,129.2068535,122.4518288,1.8,129.1541025,122.396374,-0.4738267,4.9326724,6.2419887,156.562302,391.5000753,1.4219686,62.7204079,31.7398543,85.9555891,9.4246914,12.5274503,0.3868757,36.4855335),(51748,'forelimb',41,4,148,43.5843452,129.1919436,122.3972651,1.8,129.1091196,122.3708746,-0.5203328,4.723743,6.5167795,158.3444207,432.1950703,1.7955076,66.3203455,33.5209645,88.8889794,9.3095204,12.9905136,0.5971767,36.9889443),(51749,'forelimb',41,4,149,41.3146052,128.5949041,122.4621577,1.8,128.5353543,122.422696,-0.6581198,4.5946296,6.3832098,115.7673487,396.5982215,2.5759091,62.1314723,25.1962309,79.2267283,8.7888558,13.1529455,0.6696389,35.6693433),(51750,'forelimb',41,4,150,37.9089322,128.1430275,122.762063,1.8,128.10332,122.664435,-0.6731933,4.3995378,6.2871744,92.8129205,336.0883841,2.4560853,53.4561889,21.0960617,68.1720075,8.4740202,12.89064,0.6435011,34.2022967),(51751,'forelimb',41,4,151,31.7833534,127.2321359,123.3709647,1.8,127.1692732,123.3232829,-0.6047128,3.8992016,5.143598,72.3472081,204.0516804,1.712178,39.6710005,18.5543646,53.418042,7.7751645,10.6732285,0.6998929,29.9054167),(51752,'forelimb',41,4,152,29.7413819,126.8946126,123.6225552,1.8,126.8571188,123.5803722,-0.5582151,3.7696302,4.8292138,66.6485702,170.8929374,1.390675,35.3873204,17.6804003,49.1564478,7.542619,10.0679117,0.6947383,29.0460407),(51753,'forelimb',41,4,153,29.730304,126.4913641,123.7617817,1.8,126.4979676,123.7127798,-0.5238666,3.760972,4.6165094,66.7327814,150.536345,1.2399121,32.6082611,17.7434933,44.592494,7.5286423,9.4628966,0.6889244,28.0824049),(51754,'forelimb',41,4,154,28.1527653,126.3947935,123.8647284,1.8,126.4086453,123.7872394,-0.4860233,3.9751001,4.6289336,64.8075526,147.3477699,1.0237985,31.8319042,16.3033764,40.6156631,7.6476854,9.9665388,3.0118901,29.4020059),(51755,'forelimb',41,4,155,27.7968176,126.2266585,123.9110954,1.8,126.2662396,123.7319882,-0.4401535,3.9670722,4.6422258,66.6552961,151.9200659,0.8410517,32.7256949,16.8021384,39.8584605,7.8537721,10.1136544,2.927532,29.4020059),(51756,'forelimb',41,4,156,28.7147732,126.1878901,123.8662448,1.8,126.274561,123.7240143,-0.422326,4.2802602,4.6243216,73.610488,160.7012775,0.8040338,34.7513198,17.1976666,41.3017878,8.1486835,10.2135672,2.8864103,30.7647927),(51757,'forelimb',41,4,157,30.9109962,126.1246566,123.6878309,1.8,126.1873234,123.5161419,-0.4338202,4.6597925,4.8526293,87.7334804,177.4143389,0.9102561,36.560456,18.8277655,45.731695,8.59376,10.5339308,2.9361973,31.9801339),(51758,'forelimb',41,4,158,33.0738736,126.1573223,123.5570129,1.8,126.2153329,123.3334375,-0.4585412,4.7502491,4.931296,100.0543341,199.0185487,1.0800306,40.3582647,21.062966,51.394926,8.859364,10.6298941,2.896614,32.2318393),(51759,'forelimb',41,4,159,36.1005479,126.3003667,123.3159043,1.8,126.4020332,123.1061974,-0.4881385,4.78551,5.3846542,118.3008102,253.1792799,1.3233539,47.0186698,24.7206274,61.7841848,9.1723375,11.3440887,0.6510767,34.2022967),(51760,'forelimb',41,4,160,38.5718722,126.5125288,123.1231492,1.8,126.5567137,122.9582127,-0.4802557,4.9570804,5.6535206,132.0984332,312.2708826,1.372191,55.2347655,26.6484349,73.1713674,9.114194,11.9465628,0.6578886,35.5650835),(51761,'forelimb',41,4,161,40.9661547,126.8050657,122.9979129,1.8,126.8682157,122.8732507,-0.4230454,4.7017325,6.1508921,138.7647767,393.2272174,1.1507563,63.9301112,29.5135415,86.1123149,8.8888364,12.6375032,0.6162969,36.1727541),(51762,'forelimb',41,4,162,41.8959156,127.043233,122.9849453,1.8,127.1136687,122.8694863,-0.3765344,4.4951359,6.3732544,136.2489205,453.1043058,0.9440767,71.0946526,30.3103003,92.2803178,8.535199,13.1178053,0.551655,36.7804247),(51763,'forelimb',41,4,163,43.2686249,127.2170122,123.0236351,1.8,127.2018024,122.9150327,-0.3279168,4.2199242,6.6488298,119.6029594,525.2333106,0.7480431,78.9963539,28.3424429,95.6211988,8.1960146,13.4856331,0.3923401,36.5287193),(51764,'forelimb',41,4,164,39.0825749,126.7132466,123.2961838,1.8,126.8308836,123.1544147,-0.3033828,4.0142123,6.6998684,91.8944834,431.7713164,0.5813644,64.4447455,22.8922828,78.0706063,7.7758042,13.3411032,0.2606024,34.8099673),(51765,'forelimb',41,4,165,32.7999471,125.5342412,123.5809124,1.8,125.5752683,123.5038082,-0.3545322,3.9381659,5.566019,76.5409937,235.3810087,0.6588103,42.288934,19.4356954,55.3737433,7.5150679,11.2787985,0.3097029,30.0096765),(51766,'forelimb',41,4,166,31.6912053,125.2655689,123.6492607,1.8,125.3006266,123.5623433,-0.3687624,3.7495957,5.026772,71.9440785,202.5871278,0.6862853,40.3016347,19.1871562,54.1368596,7.2432518,10.4635866,0.3347368,28.4383701),(51767,'forelimb',41,4,167,30.5417327,124.9277568,123.7100463,1.8,124.9911086,123.6555485,-0.377992,3.592179,4.7988504,66.1518917,174.3084434,0.6933053,36.3229586,18.4155333,49.0045529,7.0254822,10.0587382,0.348771,26.9713235),(51768,'forelimb',41,4,168,29.8842757,124.7540786,123.7457565,1.8,124.8045322,123.6741223,-0.3896316,3.5571433,4.5633488,63.4073591,160.3668742,0.7186385,35.1423658,17.8253595,47.812669,7.0084465,9.6942031,0.2234766,26.9713235),(51769,'forelimb',41,4,169,29.1941445,124.4888917,123.7687158,1.8,124.5088119,123.7165746,-0.4045303,3.4678884,4.5083443,59.9350118,145.7030111,0.7537477,32.318519,17.282855,45.3205974,6.9206751,9.5115493,0.3217506,26.3636529),(51770,'forelimb',41,4,170,28.8581146,124.3859901,123.7871986,1.8,124.4594702,123.7296827,-0.4120855,3.388845,4.4059152,57.4318036,139.7289461,0.7715561,31.7139438,16.9473091,42.9114381,6.7956358,9.3845276,0.2782997,26.3636529),(51771,'forelimb',41,4,171,28.3186542,124.2069545,123.8016615,1.8,124.2346482,123.7731314,-0.4113967,3.3304021,4.4079235,53.738495,132.3606651,0.7547484,30.0278955,16.1357377,42.0754956,6.7278584,9.2955727,0.5880026,25.7559823),(51772,'forelimb',41,4,172,28.0143474,124.1348896,123.8247536,1.8,124.1743929,123.7972828,-0.4002092,3.3235743,4.3282007,51.3740038,127.9083593,0.7087477,29.5523169,15.457456,40.6335655,6.7278584,9.2257926,0.4844779,25.1483117),(51773,'forelimb',41,4,173,27.292605,123.9791556,123.8522756,1.8,124.0261074,123.8260802,-0.3774999,3.2921503,4.2942374,47.5630266,119.9009595,0.6180146,27.9213629,14.4474043,37.2248413,6.6379681,9.115059,0.1418971,25.2525715),(51774,'forelimb',41,4,174,26.883282,123.9082383,123.8867045,1.8,123.9468456,123.8742761,-0.3527001,3.1538589,4.3764739,44.7621159,115.738979,0.5346364,26.4457142,14.1928087,36.665543,6.3444067,9.1049255,0.3366748,24.6449009),(51775,'forelimb',41,4,175,26.2310283,123.7203991,123.9236128,1.8,123.7462377,123.9063942,-0.3147282,3.1392856,4.4338288,41.4370036,109.238987,0.4189365,24.6376193,13.199501,33.8735023,6.44532,9.1049255,0.3366748,24.2889357),(51776,'forelimb',41,4,176,25.7580352,123.6369569,123.9527054,1.8,123.6828196,123.9441966,-0.2957694,3.1279303,4.5281031,39.546944,104.0950173,0.3647261,22.9886586,12.6431667,31.6662469,6.44532,9.1049255,0.3366748,24.2889357),(51777,'forelimb',41,4,177,25.1505407,123.4560575,123.9686031,1.8,123.5019262,123.9629021,-0.275736,3.0788188,4.4145175,36.9766137,96.0353106,0.3107051,21.7544295,12.0099999,30.0528694,6.293682,8.8582451,0.3985224,23.6812651),(51778,'forelimb',41,4,178,24.8554656,123.3947044,123.9799199,1.8,123.4792077,123.9787465,-0.2604482,3.0642779,4.4713439,35.6320381,92.211464,0.2747079,20.6227625,11.6282004,28.4889187,6.293682,8.8582451,0.3985224,23.6812651),(51779,'forelimb',41,4,179,24.3746397,123.2594585,123.9603248,1.8,123.3530081,123.9063942,-0.2397186,3.0001555,4.4872073,33.8966095,86.6690756,0.2290105,19.3147026,11.2982841,26.868745,6.015632,8.8582451,0.2449787,23.6812651),(51780,'forelimb',41,4,180,23.9958088,123.2145746,123.9551983,1.8,123.3007254,123.9321037,-0.2291399,2.9791839,4.5294572,33.0498321,83.8890812,0.2063343,18.5207802,11.0935859,25.816582,6.015632,8.8582451,0.2449787,23.6812651),(51781,'forelimb',41,4,181,23.5300891,123.1048146,123.9178045,1.8,123.1801497,123.903604,-0.2195785,3.0072652,4.5342863,32.131551,80.6982513,0.1860633,17.7973437,10.6846416,24.787479,6.015632,8.76395,0.1973956,23.4295597),(51782,'forelimb',41,4,182,23.2681358,123.074692,123.8929652,1.8,123.1458952,123.8709937,-0.213678,2.9714237,4.5607372,31.6282892,78.713349,0.1743854,17.2589093,10.6441531,24.0995402,6.015632,8.8582451,0.2449787,23.1778543),(51783,'forelimb',41,4,183,22.8644636,122.9895098,123.8379225,1.8,123.105612,123.8541737,-0.2104311,2.8969861,4.3931282,30.9231523,76.2961982,0.1662685,17.3671686,10.6742494,24.2679229,6.015632,8.7005189,0.3529904,22.8218891),(51784,'forelimb',41,4,184,22.7161987,122.9853041,123.7949282,1.8,123.0906763,123.7892065,-0.220903,2.8703162,4.3924874,30.5359983,75.6827689,0.1817657,17.230048,10.6385486,24.0916211,6.015632,8.7005189,0.3529904,22.5701837),(51785,'forelimb',41,4,185,22.6790485,122.9326331,123.7097333,1.8,123.0243498,123.6722213,-0.231247,3.0949738,4.4279329,30.8357576,75.4572486,0.1985503,17.0411907,9.9631726,23.9698651,6.15159,8.7005189,0.3529904,23.1778543),(51786,'forelimb',41,4,186,22.7470826,122.9395308,123.647386,1.8,123.0167498,123.5881674,-0.2405107,3.0377575,4.3060667,30.756594,75.5640131,0.2151063,17.548268,10.1247693,24.6399381,6.015632,8.5614727,0.3058789,22.8218891),(51787,'forelimb',41,4,187,22.5880754,122.8959629,123.5623653,1.8,122.9726133,123.5318898,-0.2614185,2.947674,4.3194473,30.7883183,75.209601,0.2514692,17.4118574,10.4449538,24.4014675,5.9587733,8.5614727,0.3058789,22.8218891),(51788,'forelimb',41,4,188,22.5316788,122.9112965,123.4981172,1.8,122.9635194,123.4614119,-0.2775931,3.0091745,4.2790824,30.8726647,75.3478547,0.2820171,17.608414,10.2595131,24.592264,6.015632,8.5614727,0.3058789,22.5701837),(51789,'forelimb',41,4,189,22.4273898,122.8804582,123.3954548,1.8,122.9339641,123.3977544,-0.2973344,2.9113497,4.1069933,30.5255023,75.4124912,0.3208348,18.3619708,10.4850002,25.7729307,5.9587733,8.463872,0.4182243,22.2142185),(51790,'forelimb',41,4,190,22.392142,122.9046703,123.3299511,1.8,122.9410506,123.3410262,-0.3119278,2.8626265,4.0658642,30.301486,75.6422346,0.3514965,18.6042206,10.5852043,26.054634,5.9587733,8.463872,0.4182243,22.2142185),(51791,'forelimb',41,4,191,22.2872935,122.8789684,123.2228396,1.8,122.925235,123.196375,-0.3323015,2.8873178,4.0554611,30.0033444,75.4095975,0.3952991,18.5945804,10.3914244,25.977554,5.8962018,8.463872,0.4182243,21.9625131),(51792,'forelimb',41,4,192,22.289979,122.9120756,123.1567963,1.8,122.9762436,123.1287135,-0.343985,2.8296349,4.0001185,29.9231443,75.5371526,0.422513,18.8837288,10.5749135,26.3179404,5.7670475,8.2986537,0.3708913,21.9625131),(51793,'forelimb',41,4,193,22.2446603,122.8994409,123.0297637,1.8,122.9518289,122.9925362,-0.360944,2.8486008,3.9624735,29.9412462,75.4516556,0.4623933,19.0415545,10.5108607,26.4434981,5.9576825,8.2986537,0.3708913,22.2142185),(51794,'forelimb',41,4,194,22.1806546,122.933926,122.9616782,1.8,122.9748868,122.952152,-0.3723046,2.7958651,3.9004589,29.6927702,75.8104415,0.4891706,19.4362877,10.6202442,26.8076438,5.7670475,8.2986537,0.3708913,22.2142185),(51795,'forelimb',41,4,195,22.055105,122.9250744,122.8525081,1.8,122.9730487,122.8130585,-0.393721,2.6883787,3.880213,29.3844414,75.4016021,0.5409748,19.4323359,10.930172,26.7321391,5.7659566,8.2986537,0.3708913,22.3184783),(51796,'forelimb',41,4,196,22.0747431,122.9635082,122.7729507,1.8,122.9844766,122.7102076,-0.4071713,2.7984601,3.9505693,29.3438059,75.8192268,0.5769847,19.1919748,10.4856976,26.482051,5.7659566,8.463872,0.4182243,21.9625131),(51797,'forelimb',41,4,197,22.0113529,122.9661708,122.6543663,1.8,123.0219359,122.6306937,-0.4249847,2.7331356,3.8885107,29.2350484,75.3708,0.6236437,19.382948,10.6965231,26.5821224,5.7670475,8.3430318,0.6022873,22.2142185),(51798,'forelimb',41,4,198,21.9562991,123.0060653,122.5810537,1.8,123.0408178,122.5611132,-0.4346129,2.6767387,3.8956889,29.0268405,75.2639108,0.6487755,19.3197952,10.8441068,26.7689618,5.7659566,8.2986537,0.3708913,22.3184783),(51799,'forelimb',41,4,199,21.9075675,123.0090377,122.4706359,1.8,123.0585072,122.472569,-0.4495465,2.5687016,3.9452306,28.6159717,74.7315941,0.6895037,18.9422626,11.1402475,26.1955419,5.5742308,8.2986537,0.3708913,22.3184783),(51800,'forelimb',41,4,200,21.8724315,123.0630114,122.3933671,1.8,123.1299997,122.3472707,-0.4626366,2.7069385,3.8358286,28.5790083,74.148085,0.7261349,19.330396,10.5576866,26.5027291,5.7659566,8.2540369,0.6747409,22.2142185),(51801,'forelimb',41,4,201,21.8628642,123.0723433,122.2728664,1.8,123.0908344,122.2246379,-0.4816439,2.6175217,3.9089726,28.844223,73.9464742,0.7819188,18.9171124,11.0196689,25.9982561,5.7465811,8.3430318,0.6022873,22.5701837),(51802,'forelimb',41,4,202,21.8259938,123.1237548,122.204828,1.8,123.1369676,122.191654,-0.4926186,2.6182236,3.7895112,28.8559477,73.2834225,0.8136269,19.3384897,11.021193,26.6245104,5.7465811,8.107337,0.5585993,22.3184783),(51803,'forelimb',41,4,203,21.7378741,123.1312132,122.0976528,1.8,123.1297389,122.0704545,-0.5047155,2.6781615,3.8500976,28.8809371,72.3776318,0.8471567,18.7989083,10.7838669,26.1252129,5.7465811,8.2540369,0.6747409,22.5701837),(51804,'forelimb',41,4,204,21.6291092,123.1774134,122.0384366,1.8,123.198018,122.0129108,-0.5132231,2.6514399,3.9214232,28.767325,71.4881824,0.8690174,18.2301627,10.8496989,25.5151399,5.7566227,8.3430318,0.6022873,22.5701837),(51805,'forelimb',41,4,205,21.4675843,123.1766462,121.9269149,1.8,123.2212972,121.8566837,-0.5220355,2.6673381,3.7641389,28.5828954,69.8417286,0.8896432,18.5545035,10.7158875,25.7781494,5.7681383,8.107337,0.5585993,21.6065479),(51806,'forelimb',41,4,206,21.4323365,123.211216,121.8727389,1.8,123.2183754,121.817735,-0.5279401,2.6973771,3.8208616,28.3946504,69.515945,0.9064772,18.1937875,10.5267635,24.9989401,5.7670475,8.2540369,0.6747409,21.6065479),(51807,'forelimb',41,4,207,21.3072904,123.1992312,121.8019559,1.8,123.2094926,121.7787732,-0.5293527,2.6106894,3.8461795,28.1421383,68.1707795,0.905558,17.7242846,10.7795811,24.5085492,5.5764125,8.2540369,0.6747409,21.8582533),(51808,'forelimb',41,4,208,21.2472571,123.2330783,121.7537147,1.8,123.2165754,121.7504422,-0.5323274,2.636863,3.899831,28.1233394,67.3927312,0.9122048,17.2809363,10.6654536,24.492044,5.7659566,8.2540369,0.6747409,21.8582533),(51809,'forelimb',41,4,209,21.0975375,123.220245,121.6669004,1.8,123.2382752,121.6322283,-0.5332628,2.7186537,3.8017796,27.9108598,65.9803274,0.9086549,17.3551162,10.266427,24.431459,5.7670475,8.2540369,0.6747409,21.8582533),(51810,'forelimb',41,4,210,20.9793172,123.2466691,121.6248333,1.8,123.2464542,121.5969297,-0.5357721,2.7426013,3.7583897,27.6842093,65.0333089,0.9112557,17.3035036,10.094143,24.5942937,5.7670475,8.107337,0.5585993,21.6065479),(51811,'forelimb',41,4,211,20.7988816,123.2313738,121.5592249,1.8,123.2423309,121.535786,-0.5351487,2.6560652,3.7784615,27.1743703,63.6831864,0.9015218,16.8542638,10.231063,24.0150018,5.5753216,8.107337,0.5585993,21.2505827),(51812,'forelimb',41,4,212,20.7037123,123.2584597,121.5200827,1.8,123.2601066,121.497903,-0.5368481,2.6775891,3.8214229,27.1249278,63.0967375,0.9025462,16.5113204,10.1303547,23.5835182,5.5764125,8.107337,0.5585993,21.6065479),(51813,'forelimb',41,4,213,20.3816697,123.2438531,121.447708,1.8,123.2670485,121.41235,-0.5356374,2.6769866,3.7394776,26.7572179,61.509756,0.8848946,16.4487564,9.9952754,22.6460474,5.7659566,8.2091777,0.748378,21.6065479),(51814,'forelimb',41,4,214,20.2063255,123.2764695,121.4100579,1.8,123.2813935,121.3673287,-0.5290401,2.6929746,3.6849851,26.5726592,60.5359431,0.8578497,16.4277308,9.8674006,22.6379873,5.7659566,7.9926588,0.6327488,21.3548425),(51815,'forelimb',41,4,215,20.0661732,123.2835268,121.3480504,1.8,123.293447,121.3512573,-0.5243376,2.743231,3.7160728,26.3056259,59.2438706,0.8382314,15.9426023,9.5892857,22.5255592,5.7659566,7.9926588,0.6327488,21.3548425),(51816,'forelimb',41,4,216,20.012574,123.3184246,121.3107249,1.8,123.3424287,121.3111763,-0.5230188,2.758205,3.7499022,26.2369227,58.5974605,0.8321826,15.6263971,9.5123178,22.2593076,5.7659566,7.9926588,0.6327488,21.3548425),(51817,'forelimb',41,4,217,19.740382,123.2928646,121.2314161,1.8,123.3254524,121.1695178,-0.5146593,2.6780437,3.7289857,25.6671768,56.7523728,0.7971776,15.2192521,9.5843008,21.9159641,5.7465811,7.9926588,0.6327488,21.2505827),(51818,'forelimb',41,4,218,19.5956979,123.3231857,121.2005104,1.8,123.3556351,121.1267857,-0.5118811,2.6887596,3.6862102,25.5981716,55.5295755,0.7835724,15.064137,9.5204388,21.820479,5.7659566,7.8880231,0.5123895,20.9988773),(51819,'forelimb',41,4,219,19.3735243,123.3049708,121.1436081,1.8,123.3631735,121.1091961,-0.5095788,2.7462571,3.6733629,25.3545457,53.9588486,0.7683481,14.6892234,9.2324007,21.4793324,5.7659566,7.7463106,0.5880026,20.9988773),(51820,'forelimb',41,4,220,19.2305186,123.3274367,121.1177104,1.8,123.3631735,121.1091961,-0.5065704,2.75663,3.6400059,25.2148649,52.956845,0.7544798,14.5485602,9.1469892,21.3625284,5.7659566,7.7463106,0.5880026,20.9988773),(51821,'forelimb',41,4,221,18.9722019,123.3164518,121.0555548,1.8,123.3535089,121.0067514,-0.5091368,2.6515973,3.6202524,24.8916386,51.1771733,0.7512419,14.1363552,9.3874128,20.9372525,5.7659566,7.7463106,0.5880026,20.9988773),(51822,'forelimb',41,4,222,18.8093903,123.3392903,121.031377,1.8,123.3564777,120.9996262,-0.5112744,2.663608,3.5891508,24.682095,50.0686714,0.7505067,13.9500051,9.2664141,20.7598765,5.7659566,7.7463106,0.5880026,20.6429122),(51823,'forelimb',41,4,223,18.5029015,123.304107,120.9832163,1.8,123.3491019,120.9454532,-0.5007569,2.6769874,3.5936593,24.2870217,48.3286955,0.7107767,13.4483244,9.0725201,20.151013,5.7659566,7.5164702,0.5404195,20.4954665),(51824,'forelimb',41,4,224,18.303779,123.3270468,120.9641456,1.8,123.3702369,120.9414517,-0.5006538,2.682704,3.5643535,24.0440594,47.3789047,0.7028628,13.2924258,8.9626211,19.984286,5.7659566,7.5164702,0.5404195,20.1395013),(51825,'forelimb',41,4,225,18.1510941,123.2980009,120.9059613,1.8,123.3494533,120.8873147,-0.4996422,2.7476964,3.3904132,23.9424798,46.0187104,0.694424,13.5731863,8.7136555,20.0052159,5.7728707,7.3926319,0.6202495,20.1395013),(51826,'forelimb',41,4,226,18.0768497,123.320057,120.8827268,1.8,123.3676169,120.8759505,-0.4969442,2.7576106,3.5306863,23.9133642,45.5071825,0.6847588,12.8890472,8.6717698,19.6305426,5.7728707,7.5164702,0.5404195,20.1395013),(51827,'forelimb',41,4,227,17.8022519,123.2857217,120.8432237,1.8,123.3122974,120.8266339,-0.4982393,2.6365701,3.3847708,23.4931964,43.9834256,0.6775803,12.9945062,8.9105144,19.5249088,5.7078516,7.3926319,0.6202495,20.1395013),(51828,'forelimb',41,4,228,17.6659042,123.3086506,120.8211429,1.8,123.3481778,120.7811385,-0.4927051,2.6420293,3.3353937,23.3522061,43.1116372,0.6587598,12.9255016,8.8387384,19.4093236,5.585944,7.317323,0.7022569,19.7835362),(51829,'forelimb',41,4,229,17.5372773,123.2845471,120.7816516,1.8,123.3314035,120.7313805,-0.488246,2.6857529,3.3348357,23.3072394,41.8080678,0.643132,12.5367699,8.6781028,19.1000527,5.585944,7.1514336,0.5713375,19.7835362),(51830,'forelimb',41,4,230,17.4364013,123.3052538,120.7671664,1.8,123.3480001,120.7395736,-0.4908864,2.6902364,3.3115981,23.0974752,41.1404085,0.6458015,12.4231285,8.5856675,18.9784137,5.585944,7.1514336,0.5713375,19.7835362),(51831,'forelimb',41,4,231,17.2751562,123.2653363,120.7395698,1.8,123.2761011,120.6924287,-0.4976131,2.7044034,3.3380962,22.8483722,39.8861972,0.6560052,11.9487861,8.4485813,18.4689716,5.585944,7.1514336,0.5713375,19.5318307),(51832,'forelimb',41,4,232,17.1619713,123.2795972,120.7285847,1.8,123.2761011,120.6924287,-0.4977575,2.7071847,3.3204115,22.6863075,39.2188072,0.6520536,11.8114296,8.3800368,18.3218424,5.585944,7.1514336,0.5713375,19.5318307),(51833,'forelimb',41,4,233,16.8745052,123.2311761,120.708522,1.8,123.2395407,120.6865244,-0.5004186,2.7468217,3.3549214,22.362674,37.6664183,0.6474218,11.2272134,8.1412907,17.6352294,5.585944,7.1514336,0.5713375,19.5318307),(51834,'forelimb',41,4,234,16.7152183,123.2465703,120.7008691,1.8,123.2695719,120.6603481,-0.4980741,2.7471696,3.3363829,22.2201413,36.7145572,0.6358198,11.0042997,8.0883763,17.3996763,5.585944,7.0474072,0.6556956,19.5318307),(51835,'forelimb',41,4,235,16.479617,123.1853702,120.6931224,1.8,123.1636779,120.6813588,-0.5035495,2.6120692,3.1820557,21.8089013,35.3131638,0.6395256,11.0975946,8.3492815,17.9305708,5.585944,6.9285108,0.5191461,18.9241602),(51836,'forelimb',41,4,236,16.3444442,123.1972026,120.6947482,1.8,123.1898076,120.6900686,-0.5055219,2.7731413,3.1727864,21.7724473,34.5776728,0.6388274,10.898204,7.8511856,17.739578,5.585944,6.7939638,0.6055447,18.9241602),(51837,'forelimb',41,4,237,16.0956948,123.153087,120.679852,1.8,123.1674164,120.6628652,-0.5056911,2.6397114,3.2041905,21.2652688,33.6117337,0.6294897,10.4899297,8.0559066,17.1148313,5.585944,6.7939638,0.6055447,18.9241602),(51838,'forelimb',41,4,238,15.9181126,123.1642202,120.6846931,1.8,123.1674164,120.6628652,-0.5032602,2.6295995,3.1964737,21.0789138,33.002665,0.6170867,10.3247104,8.0160169,16.9037495,5.585944,6.7939638,0.6055447,18.9241602),(51839,'forelimb',41,4,239,15.6888335,123.1272586,120.6813531,1.8,123.1291565,120.6540359,-0.5033014,2.650361,3.2272466,20.6811198,32.1395211,0.6082895,9.9588056,7.8031333,16.356613,5.585944,6.7939638,0.6055447,18.9241602),(51840,'forelimb',41,4,240,15.5953986,123.1441292,120.6840632,1.8,123.1485808,120.6593538,-0.5171193,2.6426286,3.21521,20.5744655,31.7425123,0.635278,9.8726094,7.785606,16.2664723,5.585944,6.7939638,0.6055447,18.9241602),(51841,'forelimb',41,4,241,15.4466861,123.1126351,120.6656336,1.8,123.1291565,120.6540359,-0.5237069,2.6754852,3.2337345,20.3719749,31.1021103,0.6438529,9.6180161,7.6143104,15.9172167,5.585944,6.7939638,0.6055447,18.9241602),(51842,'forelimb',41,4,242,15.4025424,123.1296939,120.672784,1.8,123.1485808,120.6593538,-0.5394934,2.6631503,3.2228224,20.2711651,30.7178099,0.6774274,9.531338,7.611724,15.8211758,5.585944,6.7939638,0.6055447,18.9241602),(51843,'forelimb',41,4,243,15.239395,123.0890432,120.6834214,1.8,123.110057,120.6652805,-0.5460607,2.6759688,3.1189139,20.0820058,29.9168405,0.6850065,9.59207,7.5045739,15.6940527,5.585944,6.7119411,0.6947383,18.9241602),(51844,'forelimb',41,4,244,15.1170904,123.1057551,120.6933088,1.8,123.1294836,120.6707133,-0.5566613,2.6602163,3.1156014,19.9342855,29.4082756,0.703344,9.4390366,7.4934831,15.4995009,5.585944,6.7119411,0.6947383,18.9241602),(51845,'forelimb',41,4,245,14.9820295,123.0724635,120.6901438,1.8,123.0830759,120.6702125,-0.5611711,2.6811076,3.1444788,19.6848375,28.6394201,0.7071855,9.1078431,7.3420543,15.1777249,5.585944,6.7119411,0.6947383,18.9241602),(51846,'forelimb',41,4,246,14.8815451,123.0853347,120.7027523,1.8,123.0858037,120.6905216,-0.5660353,2.6641645,3.0445656,19.6043664,28.1358061,0.7133391,9.2413203,7.358542,15.5088926,5.585944,6.5589027,0.551655,18.6724547),(51847,'forelimb',41,4,247,14.7214189,123.0355318,120.719699,1.8,123.0258128,120.6932208,-0.5809639,2.6787223,2.965015,19.4697454,27.4946501,0.7390503,9.2730223,7.2682956,15.6478334,5.585944,6.44532,0.6435011,18.6724547),(51848,'forelimb',41,4,248,14.6093531,123.0471328,120.7322374,1.8,123.045332,120.6990501,-0.597892,2.6635474,2.9634535,19.3751024,27.1856673,0.7715151,9.1736441,7.2741721,15.4894203,5.585944,6.44532,0.6435011,18.6724547),(51849,'forelimb',41,4,249,14.4465973,123.0012927,120.7390847,1.8,123.0162244,120.6764634,-0.6147669,2.5596663,3.0052553,19.1357226,26.6234769,0.8009711,8.8589733,7.4758662,15.0729114,5.4690354,6.44532,0.6435011,18.4207493),(51850,'forelimb',41,4,250,14.387739,123.012691,120.7542817,1.8,123.0246563,120.7049638,-0.6331099,2.6671885,3.0041517,19.3035888,26.3520598,0.8394176,8.7718805,7.2374296,15.0046847,5.585944,6.44532,0.6435011,18.6724547),(51851,'forelimb',41,4,251,14.1960576,122.9710674,120.7694202,1.8,122.9512426,120.7232308,-0.6758277,2.5539233,3.0408807,19.0463924,25.8715688,0.9258301,8.5079198,7.4576994,14.7393901,5.4690354,6.44532,0.6435011,18.0647842),(51852,'forelimb',41,4,252,14.1156589,122.9814181,120.7873703,1.8,122.9634358,120.7391685,-0.7020722,2.657386,3.0382638,19.0943743,25.6733387,0.9811775,8.4500032,7.1853972,14.6810823,5.5742308,6.44532,0.6435011,18.3164896),(51853,'forelimb',41,4,253,13.9259357,122.936462,120.7843535,1.8,122.9324541,120.7359147,-0.742298,2.5164654,3.0302673,18.8691512,25.1887111,1.0605835,8.3123728,7.4982757,14.5099359,5.4690354,6.44532,0.9272952,18.0647842),(51854,'forelimb',41,4,254,13.824612,122.9443475,120.8057501,1.8,122.9324541,120.7359147,-0.7677149,2.5238901,3.0433737,18.7952915,24.9988241,1.1113156,8.2141815,7.4469532,14.375523,5.4690354,6.44532,0.9272952,18.0647842),(51855,'forelimb',41,4,255,13.5464895,122.8915985,120.8339297,1.8,122.8971813,120.7615678,-0.7943957,2.5008307,2.8073785,18.4227012,24.47308,1.1491871,8.7174137,7.3666326,14.470856,5.4690354,6.3442673,0.4939414,17.8130787),(51856,'forelimb',41,4,256,13.3981686,122.897642,120.8597394,1.8,122.8971813,120.7615678,-0.8117244,2.5316311,2.8380119,18.1546702,24.1736382,1.1752741,8.5178072,7.1711356,14.1805615,5.4690354,6.3442673,0.4939414,17.8130787),(51857,'forelimb',41,4,257,13.2341261,122.8518372,120.8953335,1.8,122.865115,120.8353202,-0.8615265,2.5399658,2.8911668,17.8351076,23.6931612,1.2701111,8.195017,7.0217905,14.340484,5.4690354,6.2563517,1.2924967,18.1690439),(51858,'forelimb',41,4,258,13.1230113,122.8636571,120.9218201,1.8,122.865115,120.8353202,-0.880601,2.5708145,2.9066885,17.5689811,23.498735,1.3005529,8.0843664,6.8340134,14.1132797,5.4690354,6.2563517,1.2924967,18.1690439),(51859,'forelimb',41,4,259,12.9415127,122.8198007,120.9706742,1.8,122.8374491,120.9305125,-0.9008385,2.5706629,2.9743702,17.1735379,23.4626308,1.3252485,7.8882685,6.6805874,13.6579951,5.4690354,6.44532,0.9272952,18.4207493),(51860,'forelimb',41,4,260,12.7557619,122.8288296,121.0066893,1.8,122.8554951,120.9796184,-0.9004255,2.5303268,2.9969515,16.7648155,23.0823363,1.3053722,7.7019386,6.6255536,13.287945,5.4690354,6.44532,0.9272952,18.4207493),(51861,'forelimb',41,4,261,12.5325813,122.7865667,121.038454,1.8,122.8054864,121.0211332,-0.9326854,2.4970643,2.7947095,16.3359563,22.3925154,1.3475998,8.0124662,6.5420647,13.2476674,5.4690354,6.2563517,1.2924967,18.1690439),(51862,'forelimb',41,4,262,12.3030784,122.7967067,121.0753383,1.8,122.8135584,121.0813787,-0.9240775,2.4420272,2.8137905,15.8973212,21.9838821,1.3059884,7.8129066,6.5098871,13.3342939,5.1652001,6.1970485,0.9827937,17.5613733),(51863,'forelimb',41,4,263,12.0485662,122.7469221,121.1042194,1.8,122.7498303,121.0895159,-0.9645092,2.4514764,2.8794145,15.3857303,21.3090657,1.356076,7.4004857,6.2761078,12.6949618,5.156256,6.1970485,0.9827937,17.2054082),(51864,'forelimb',41,4,264,11.8911816,122.7565481,121.1382796,1.8,122.7601428,121.1170159,-0.9857063,2.3962108,2.9072068,15.0917447,21.0623657,1.3773812,7.2448804,6.2981708,12.4010016,5.156256,6.3442673,1.076855,17.2054082),(51865,'forelimb',41,4,265,11.7145506,122.7151837,121.1651842,1.8,122.7407182,121.1276831,-0.9810808,2.4132136,2.9515285,14.7960313,20.6828976,1.3485896,7.0075209,6.1312565,11.9894373,5.156256,6.3442673,1.076855,17.2054082),(51866,'forelimb',41,4,266,11.6121079,122.7223175,121.199489,1.8,122.7105763,121.1616203,-0.9908691,2.3939369,2.854274,14.6057625,20.2879631,1.3542359,7.1079243,6.1011477,12.1146132,5.156256,6.1970485,0.9827937,17.2054082),(51867,'forelimb',41,4,267,11.4205944,122.6808676,121.2327859,1.8,122.6846575,121.2174302,-0.983991,2.4060136,2.8118081,14.2229373,19.9337946,1.3198634,7.0893153,5.9114117,11.9893932,5.156256,6.1970485,0.9827937,17.2054082),(51868,'forelimb',41,4,268,11.2812813,122.6935678,121.2622647,1.8,122.6846575,121.2174302,-0.9870466,2.3883353,2.8088373,13.9966493,19.6975535,1.3090543,7.0127072,5.8604206,11.7403632,5.156256,6.1970485,0.9827937,17.2054082),(51869,'forelimb',41,4,269,11.091726,122.644378,121.3039089,1.8,122.6636971,121.259351,-0.9822281,2.3957446,2.8520351,13.6231001,19.2531565,1.2788492,6.750673,5.6863741,11.5146969,5.156256,6.1970485,0.9827937,17.2054082),(51870,'forelimb',41,4,270,10.9950461,122.6507629,121.3309786,1.8,122.6442257,121.2706329,-0.9853083,2.3907592,2.8333999,13.396452,18.8659691,1.2729082,6.6584208,5.60343,11.3787485,5.156256,6.1970485,0.9827937,17.2054082),(51871,'forelimb',41,4,271,10.8980865,122.5972952,121.3834518,1.8,122.5924722,121.3921867,-0.9821356,2.3758975,2.8413733,13.0276266,18.5871625,1.2563677,6.5416122,5.4832444,11.0809856,5.156256,6.1970485,0.9827937,17.2054082),(51872,'forelimb',41,4,272,10.8388924,122.6025327,121.4269614,1.8,122.5910696,121.4536602,-0.9710947,2.4070395,2.7251749,12.8652028,18.3128399,1.2310398,6.719877,5.3448241,11.089493,5.156256,5.9848613,1.2036225,16.9537027),(51873,'forelimb',41,4,273,10.7118881,122.5597369,121.4587245,1.8,122.5411913,121.481537,-0.9745003,2.3886878,2.7895161,12.5184779,18.0340198,1.2222731,6.4649276,5.2407342,10.590739,5.156256,6.1521959,1.1383886,16.9537027),(51874,'forelimb',41,4,274,10.4921763,122.5728217,121.4923499,1.8,122.5573894,121.494282,-0.9629472,2.3144194,2.7607041,12.1921217,17.7428105,1.1783434,6.426915,5.2678965,10.4757093,5.1272215,6.1521959,1.1383886,16.9537027),(51875,'forelimb',41,4,275,10.2468398,122.5384818,121.5375603,1.8,122.5432812,121.5531306,-0.9499596,2.2730812,2.8445493,11.7669169,17.3566624,1.129896,6.1017268,5.1766372,10.2193059,4.8613648,6.1070139,0.8850668,16.9537027),(51876,'forelimb',41,4,276,10.1228568,122.5424364,121.5865119,1.8,122.5271858,121.5906864,-0.9492166,2.3043196,2.8071849,11.5940042,17.3249949,1.1150381,6.1716616,5.031422,10.2381421,4.8613648,6.1070139,0.6857295,16.9537027),(51877,'forelimb',41,4,277,9.8758978,122.4833998,121.6416601,1.8,122.4196189,121.6808571,-0.9506615,2.2892069,2.8276686,11.1730779,16.8558404,1.0900862,5.9610382,4.8807637,9.8108554,4.8613648,6.1521959,1.1383886,17.0579625),(51878,'forelimb',41,4,278,9.6868461,122.4740945,121.6962425,1.8,122.3881865,121.709126,-0.9468771,2.311522,2.7763697,10.9693692,16.4275153,1.0634324,5.9169047,4.745518,9.7698922,4.8613648,5.9848613,1.2036225,16.7019973),(51879,'forelimb',41,4,279,9.425676,122.3980637,121.7610596,1.8,122.3393984,121.761411,-0.9136101,2.2733942,2.6639588,10.7598201,15.9231428,0.984687,5.9772482,4.732932,9.8397144,4.8613648,5.9694165,1.0427219,16.3460322),(51880,'forelimb',41,4,280,9.2827263,122.38626,121.821277,1.8,122.3055033,121.8202522,-0.8932077,2.3372077,2.8681264,10.6965265,16.0140864,0.9390655,5.583466,4.5766265,9.290834,5.156256,6.1970485,0.9827937,16.849443),(51881,'forelimb',41,4,281,9.0341448,122.3091028,121.8860462,1.8,122.2500052,121.8957011,-0.8836005,2.3560753,2.7670785,10.5109948,15.6025516,0.8997589,5.6386371,4.4612304,9.2803791,5.156256,5.9848613,1.2036225,16.9537027),(51882,'forelimb',41,4,282,8.8423515,122.3086774,121.9421581,1.8,122.2667863,121.9566637,-0.8700498,2.3189483,2.7203548,10.4459328,15.4126912,0.8610208,5.6656915,4.5045993,9.3708931,5.156256,5.9848613,1.2036225,16.9537027),(51883,'forelimb',41,4,283,8.689275,122.2290479,122.0262681,1.8,122.1883215,122.0426013,-0.852902,2.320633,2.8826616,10.355981,15.4518177,0.8215694,5.3602607,4.4625673,8.9523802,5.156256,6.1070139,0.8850668,17.2054082),(51884,'forelimb',41,4,284,8.5746914,122.2080093,122.0908915,1.8,122.1896981,122.0653147,-0.834135,2.3099199,2.8206554,10.2755243,15.4266985,0.784098,5.4691894,4.4484332,9.1121455,5.156256,6.1070139,0.8850668,17.2054082),(51885,'forelimb',41,4,285,8.4244683,122.0874266,122.165637,1.8,122.0728531,122.1783905,-0.794382,2.3019977,2.6860864,10.2263681,15.2969015,0.7146524,5.6948657,4.4423885,9.1494453,5.156256,5.9694165,0.5280744,16.9537027),(51886,'forelimb',41,4,286,8.271112,122.0572983,122.2275017,1.8,122.0724926,122.2406314,-0.7862636,2.2845199,2.6148178,10.261755,15.2883218,0.6904524,5.846802,4.4918649,9.2510308,5.156256,5.9848613,0.3671738,16.9537027),(51887,'forelimb',41,4,287,8.0991247,121.9771701,122.2823498,1.8,121.9763038,122.2921428,-0.7867227,2.2926578,2.8231765,10.1757492,15.4526072,0.676715,5.4734826,4.4384073,8.9572514,5.156256,6.1970485,0.9827937,17.2054082),(51888,'forelimb',41,4,288,7.9953952,121.9625601,122.3234674,1.8,121.9763038,122.2921428,-0.7742011,2.2908203,2.784746,10.2438023,15.4219114,0.6513634,5.5379956,4.4716744,9.1036794,5.156256,6.1970485,0.9827937,17.2054082),(51889,'forelimb',41,4,289,7.8954702,121.8517969,122.3980666,1.8,121.8572943,122.3795874,-0.7718866,2.3011788,2.8231193,10.2097629,15.5449952,0.640178,5.5063189,4.4367533,8.9903621,5.156256,6.1970485,0.5880026,17.2054082),(51890,'forelimb',41,4,290,7.8554107,121.8078672,122.4752955,1.8,121.7966885,122.46108,-0.7555638,2.304804,2.864553,10.3964861,15.6114312,0.6155805,5.4498665,4.5107897,9.0491953,5.156256,6.1970485,0.9827937,17.2054082),(51891,'forelimb',41,4,291,7.6854936,121.6949669,122.587519,1.8,121.6940337,122.5818188,-0.6945971,2.3575773,2.8151802,10.3603429,15.7928301,0.5247875,5.6098824,4.3944871,9.1452469,5.1652001,6.1970485,0.5880026,17.5613733),(51892,'forelimb',41,4,292,7.5531741,121.6533935,122.6640504,1.8,121.6599668,122.6467926,-0.6837357,2.3366995,2.8393788,10.3127431,15.764493,0.5023321,5.5520923,4.4133801,9.0470575,5.156256,6.1970485,0.5880026,17.2054082),(51893,'forelimb',41,4,293,7.3541075,121.5443918,122.7443917,1.8,121.5265086,122.7618616,-0.6828861,2.3586766,2.8613472,10.2608905,16.0293329,0.4880732,5.602023,4.3502745,9.0629,5.1652001,6.3442673,0.4939414,17.5613733),(51894,'forelimb',41,4,294,7.0514792,121.4917506,122.813786,1.8,121.5006009,122.8113299,-0.7010599,2.3434825,2.7847591,10.1397776,15.7264462,0.4889743,5.6473273,4.326799,8.9035683,5.1652001,6.3442673,1.076855,17.5613733),(51895,'forelimb',41,4,295,6.8150386,121.3715573,122.9038165,1.8,121.3637776,122.8978703,-0.679564,2.3467877,2.9385329,10.0401372,15.9667082,0.4486049,5.4335646,4.2782469,8.8391152,5.1652001,6.44532,0.6435011,18.1690439),(51896,'forelimb',41,4,296,6.7923233,121.3335711,122.9986307,1.8,121.2898337,123.0259118,-0.6753288,2.5661614,2.8767593,10.4173776,16.1082847,0.4424265,5.5994551,4.0595176,8.8908728,5.4690354,6.3877713,0.3430239,18.1690439),(51897,'forelimb',41,4,297,6.8576718,121.2024836,123.105293,1.8,121.2167036,123.1038932,-0.6640498,2.5634719,2.9813481,11.0133226,16.4534572,0.4341357,5.5187978,4.2962526,9.1214668,5.4690354,6.5589027,0.551655,18.4207493),(51898,'forelimb',41,4,298,7.2147385,121.1701533,123.1659507,1.8,121.1653542,123.2105358,-0.6729618,2.6054957,2.9925009,11.6905916,17.4994154,0.467165,5.847756,4.4868974,9.5323807,5.4690354,6.5589027,0.551655,18.4207493),(51899,'forelimb',41,4,299,7.9739667,121.064894,123.2614607,1.8,121.0176914,123.3476897,-0.6527406,2.6016315,3.0427652,12.5420436,18.8183546,0.4902572,6.1846227,4.8208379,10.1470459,5.4690354,6.5589027,0.551655,18.4207493),(51900,'forelimb',41,4,300,8.651957,120.9874619,123.395682,1.8,120.9912507,123.3975035,-0.6736807,2.5396218,3.0102561,13.2529173,20.0154065,0.5612377,6.649071,5.218461,10.7972506,5.4690354,6.725681,0.4636476,18.7767145),(51901,'forelimb',41,4,301,10.1979404,120.8316145,123.5165045,1.8,120.8157557,123.5162632,-0.705797,2.639533,3.1362617,16.2675958,23.1944788,0.7151045,7.3955814,6.1630582,12.2654729,5.7728707,6.9285108,1.0516502,19.6360905),(51902,'forelimb',41,4,302,10.6427911,120.7842774,123.5581044,1.8,120.7631614,123.5574354,-0.6765538,2.8748162,3.2393312,16.9233003,25.0459301,0.6953526,7.7318214,5.8867416,12.806296,6.015632,7.0474072,0.6556956,20.1395013),(51903,'forelimb',41,4,303,9.9453306,120.7356442,123.5014787,1.8,120.7344196,123.5603432,-0.6109144,2.8477734,3.3403662,15.1527432,24.2397012,0.5453955,7.2565999,5.320909,11.2638651,5.9587733,7.2028834,0.3028849,20.4954665),(51904,'forelimb',41,4,304,7.7026699,120.9209441,123.2627691,1.8,120.8174483,123.4106003,-0.3688203,2.8588985,3.4576793,10.5072121,16.7822144,0.1668543,4.8536063,3.6752659,7.8886044,5.4690354,6.7939638,0.3217506,19.3843851),(51905,'forelimb',41,4,305,1.315921,121.7709119,122.9643923,1.8,121.7870596,122.823366,1.2283273,1.4842836,2.2941429,0.6197505,1.6894329,0.1945872,0.7364114,0.4175419,0.9993591,3.2900972,4.6477863,2.1587989,13.1602336),(51906,'forelimb',41,4,306,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51907,'forelimb',41,4,307,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51908,'forelimb',41,4,308,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51909,'forelimb',41,4,309,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51910,'forelimb',41,4,310,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51911,'forelimb',41,4,311,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51912,'forelimb',41,4,312,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51913,'forelimb',41,4,313,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51914,'forelimb',41,4,314,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51915,'forelimb',41,4,315,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51916,'forelimb',41,4,316,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51917,'forelimb',41,4,317,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51918,'forelimb',41,4,318,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51919,'forelimb',41,4,319,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51920,'forelimb',41,4,320,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51921,'hindlimb',41,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51922,'hindlimb',41,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51923,'hindlimb',41,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51924,'hindlimb',41,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51925,'hindlimb',41,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51926,'hindlimb',41,7,6,0.1835128,98.2027034,120.7121974,1.8,98.2002345,120.742328,1.5373017,0.2778859,1.3250133,0.0112655,0.1459167,0.0305512,0.1101247,0.0405399,0.1173212,0.859376,3.1281759,1.849096,7.0835276),(51927,'hindlimb',41,7,7,1.9310805,98.6753127,120.5084801,1.8,99.0133364,120.2994188,-0.9188077,1.9086053,4.6442493,1.6555675,5.2218339,0.2033532,1.1243655,0.8674227,1.4080666,2.578128,5.0293691,1.9195673,12.7000086),(51928,'hindlimb',41,7,8,3.3897835,98.966025,120.2458113,1.8,99.2245542,120.2083468,-0.9790527,2.1738359,4.5212261,3.2539368,13.4037915,0.3891749,2.9646364,1.4968641,3.428598,4.7142619,8.9412281,0.9561334,23.0735945),(51929,'hindlimb',41,7,9,4.5249332,98.9201217,120.685501,1.8,99.1212091,120.6186299,-0.9109543,2.1859134,5.5120618,4.2539454,23.1669613,0.4707746,4.2029574,1.9460723,4.7799409,4.8454632,10.7422,0.9272952,26.3636529),(51930,'hindlimb',41,7,10,12.0585252,98.5146908,120.4049904,1.8,98.8166268,120.4287719,-0.8100963,3.1108369,6.0166572,17.1557061,64.3297043,1.0544941,10.6919345,5.5148201,12.5831413,6.2758968,11.0053826,0.8960554,29.5062657),(51931,'hindlimb',41,7,11,32.1200546,98.7377817,120.089579,1.8,99.2012409,119.2809353,-1.0449861,4.6865349,9.2263645,71.3154022,237.281844,4.0047413,25.7178051,15.2170854,33.3289466,8.8875325,16.0429641,1.2151604,49.7500268),(51932,'hindlimb',41,7,12,40.0927905,99.2156539,119.8673965,1.8,99.516636,119.1148847,-1.1205574,5.2868546,9.0249023,107.6923094,442.9766162,5.4166547,49.0838128,20.3698263,59.7958593,9.1731285,16.3620316,1.0483929,46.3557087),(51933,'hindlimb',41,7,13,46.8871839,99.7959232,119.7219204,1.8,99.9370882,119.2909209,-1.0983409,5.3250171,9.4319892,156.9651465,690.1388926,6.1962003,73.1700254,29.4769282,88.1959208,9.4188943,17.6381559,0.9760371,46.6074141),(51934,'hindlimb',41,7,14,49.1060103,100.3262301,119.4653303,1.8,100.2514946,119.5109729,-1.0941657,5.3386499,9.1528512,191.6048101,790.2319149,6.4616439,86.3372409,35.8901246,106.8201431,9.5682644,18.1285566,1.0222469,47.6753097),(51935,'hindlimb',41,7,15,51.2361574,100.9384472,119.3367685,1.8,100.6402081,119.5841496,-1.1155263,5.2914709,8.9370541,236.6991504,886.9755441,6.888357,99.2469703,44.7322032,125.0570534,10.2298654,18.4965587,1.0343609,47.1108249),(51936,'hindlimb',41,7,16,52.491094,101.2331724,119.3616404,1.8,100.8835309,119.5896824,-1.124705,5.4204683,9.2269296,270.8663861,969.0994016,7.1200427,105.0294568,49.97103,134.3657576,10.6076144,18.6555863,1.065935,47.8227553),(51937,'hindlimb',41,7,17,53.9189131,101.4604226,119.6579309,1.8,101.1325195,119.7903517,-1.1249619,5.3793502,9.0917813,316.9050318,1043.1549008,7.3155128,114.7360306,58.9113964,147.7808543,10.5565741,18.280687,1.0545657,48.8295769),(51938,'hindlimb',41,7,18,55.3330806,101.6255595,119.8649032,1.8,101.297993,119.9434024,-1.1197976,5.6035506,9.1572717,375.4350359,1048.96058,7.4701689,114.5494654,66.9994908,154.8834203,10.7948057,18.209851,1.2341215,48.3261661),(51939,'hindlimb',41,7,19,57.7561209,101.6712614,120.3241737,1.8,101.4720222,120.2288375,-1.0765949,6.0301997,8.9332226,467.7060662,976.6327402,7.4602833,109.3259155,77.560626,159.7565698,11.4495626,17.8048522,1.226149,48.3261661),(51940,'hindlimb',41,7,20,58.397017,101.7063794,120.4696428,1.8,101.5058972,120.4544424,-1.0850065,6.3026884,8.8257749,520.0555461,917.7307875,7.6110573,103.9830266,82.5132888,162.7115521,11.9385481,17.18752,0.9272952,47.8659411),(51941,'hindlimb',41,7,21,60.5991706,101.7597196,120.5710846,1.8,101.5801506,120.5780823,-1.1078817,6.5809068,8.7664341,615.979117,886.1384573,8.0858082,101.0831141,93.6009481,171.3273952,12.8995075,16.9331967,0.947597,48.0133867),(51942,'hindlimb',41,7,22,61.942059,101.7218521,120.6603221,1.8,101.5495973,120.6588634,-1.2066134,7.0156624,8.6405143,713.2789043,870.921364,9.0139279,100.7950834,101.6695023,182.7075131,13.4065275,17.1121594,0.8921338,48.9770225),(51943,'hindlimb',41,7,23,63.9882267,101.7325169,120.6737038,1.8,101.4476842,120.6246985,1.2097109,8.0223279,8.0419898,821.9154992,936.0195825,9.3336026,116.39154,102.4534915,207.1713866,14.3949079,16.5861794,0.9324765,50.5915147),(51944,'hindlimb',41,7,24,65.0960174,101.6737165,120.5978845,1.8,101.3791082,120.5256359,0.9686882,8.1516455,8.6187778,848.1465919,1049.9108981,7.3690042,121.81668,104.046059,215.7439337,15.0861382,17.4010378,1.9237867,53.0221971),(51945,'hindlimb',41,7,25,72.211838,101.1614189,119.9262776,1.8,101.0933531,120.2159929,0.9171443,8.1100808,8.4787611,908.9937898,1398.7708268,7.5849741,164.9734929,112.0819651,253.3164936,15.6268781,17.8048522,1.9154436,55.0969143),(51946,'hindlimb',41,7,26,74.7486786,100.8868926,119.5596287,1.8,100.9075107,119.8846288,0.9028823,8.142871,8.4241984,959.072262,1518.1011122,7.6792566,180.2071888,117.7806035,270.6809594,15.7640631,17.533166,1.8692953,56.6682207),(51947,'hindlimb',41,7,27,80.5532219,100.6352947,119.1614276,1.8,100.6719563,119.6373597,0.8922393,8.4305957,8.3504405,1084.3171508,1628.7155112,8.1362778,195.0454614,128.6169076,285.9152695,15.9408885,18.2402429,0.2621198,58.9514574),(51948,'hindlimb',41,7,28,84.8783612,100.4841459,119.0024588,1.8,100.5519135,119.5607806,0.7840532,8.7789281,8.2649997,1207.6979505,1669.8704779,7.0541697,202.0412034,137.5678135,300.6794035,15.9888406,18.6555863,0.2561514,60.0625388),(51949,'hindlimb',41,7,29,94.0195364,100.2449253,119.1891191,1.8,100.466899,119.4756323,0.3268189,9.112843,9.1856992,1400.240393,1801.2765041,1.6149663,196.0957432,153.6557133,324.5968678,16.7109414,19.507078,0.1325515,62.3457756),(51950,'hindlimb',41,7,30,107.9709849,99.0464611,119.2132195,1.8,98.9886526,119.4551851,0.0226146,9.6567708,17.8545897,1515.9971412,3801.2155163,0.0092015,212.8985084,156.9879999,297.5616215,5.156256,5.7808608,0.8379812,16.849443),(51951,'hindlimb',41,7,31,143.7635334,95.9765461,119.2854592,1.8,96.6240031,119.5479101,-0.0026538,9.6353167,16.9154802,1690.8225936,10031.1615259,0.0001687,593.0166584,175.4817863,692.6042866,17.6105283,31.8694118,0.067465,96.4617007),(51952,'hindlimb',41,7,32,169.7806686,94.9299165,119.4392047,1.8,95.6266063,119.6130168,0.0085949,9.425954,16.7333481,1930.998841,13484.0896966,0.0020903,805.8213847,204.859778,920.3318412,17.18752,32.7945133,0.0918461,98.5796037),(51953,'hindlimb',41,7,33,184.1637638,93.6628059,119.534819,1.8,94.5691418,119.6359828,0.0028656,9.3542779,16.7667075,2231.7130699,15855.5502572,0.0002521,945.6567553,238.5767342,1069.3250831,17.18752,33.7380335,0.1148766,100.5932469),(51954,'hindlimb',41,7,34,186.0003464,92.7626013,119.5615924,1.8,94.0407826,119.6481509,0.0016181,9.3335901,17.6670163,2449.6642582,16597.8545928,0.0000812,939.4826095,262.4568082,1065.8758815,17.18752,34.2728372,0.138351,102.9196695),(51955,'hindlimb',41,7,35,188.2399299,92.2723047,119.678626,1.8,93.4887148,119.6880957,0.0168149,9.1017874,18.1511551,2809.6922653,17563.7429767,0.0088697,967.6377547,308.6967584,1108.8993718,17.18752,34.69847,0.1366432,106.4614333),(51956,'hindlimb',41,7,36,186.2837842,91.896196,119.7190766,1.8,93.1118651,119.7284299,0.0202505,9.0276705,18.5157367,3010.3746203,17649.9996871,0.0127302,953.243179,333.4608446,1101.8544006,17.1864532,35.0689645,0.1228352,109.7514917),(51957,'hindlimb',41,7,37,182.3789899,91.2846589,119.7007608,1.8,92.6625845,119.7536783,0.0138059,9.0946876,19.1280517,3158.840689,17400.6665188,0.0057932,909.6936145,347.3281127,1065.5633522,17.0792513,35.2998564,0.0609002,113.1889957),(51958,'hindlimb',41,7,38,181.8264374,91.0903928,119.6889959,1.8,92.4001075,119.8104026,0.0131054,9.1095768,18.9162842,3272.7651644,17543.5074784,0.0052046,927.4288393,359.2664329,1084.9777527,16.8959321,35.1242016,0.1349767,114.8034879),(51959,'hindlimb',41,7,39,180.4063952,90.7991705,119.6606254,1.8,92.1474453,119.8392007,0.0126781,9.1377933,19.626439,3325.1612297,17665.1869933,0.0048326,900.0709206,363.8910519,1067.6890732,16.9857814,35.7287574,3.0814244,118.6580311),(51960,'hindlimb',41,7,40,176.5358418,90.5746352,119.6500206,1.8,91.9326439,119.8598791,0.0052533,9.2106359,19.8538732,3307.2726881,17432.8526552,0.000812,878.0580228,359.0710497,1041.6574074,17.2146111,35.8293839,0.0960887,118.8054767),(51961,'hindlimb',41,7,41,173.5739564,90.3556441,119.6057107,1.8,91.7891076,119.9002752,0.0059723,9.2986809,20.0729035,3245.7638119,17269.4769915,0.0010318,860.3377694,349.0563712,1019.3471742,17.5489965,35.8731583,0.1080117,120.0208179),(51962,'hindlimb',41,7,42,169.4154893,90.6307464,119.570755,1.8,91.7250442,119.9062365,0.0017084,9.3370424,19.79884,3170.8119873,17062.1664777,0.0000824,861.7760662,339.5949001,1005.8304918,17.6164224,36.3486588,0.11849,122.3040547),(51963,'hindlimb',41,7,43,167.9620456,90.7639815,119.585061,1.8,91.6731512,119.9290551,0.0076992,9.7614311,19.664237,3149.3184508,16903.7509313,0.0016594,859.6189608,322.6287639,1003.2996043,18.0718937,36.1678883,0.1671018,123.1634307),(51964,'hindlimb',41,7,44,167.9912509,90.8028279,119.6395835,1.8,91.6295853,120.0018802,0.0091742,10.1428063,19.6244528,3178.5344552,16706.0640087,0.0023565,851.2881441,313.3782079,992.1861208,18.500535,36.2418331,0.1787931,125.2381479),(51965,'hindlimb',41,7,45,168.174428,91.030641,119.8182103,1.8,91.6951953,120.2305459,0.0021428,12.9607409,19.3974278,3306.1614804,16488.9107723,0.0001287,850.0565634,255.0904697,996.9590199,18.6821074,36.098907,0.1553643,128.0247955),(51966,'hindlimb',41,7,46,166.31306,91.1818622,120.0439426,1.8,91.8253532,120.420728,-0.0116216,13.1374519,19.2984603,3400.2294104,16137.8386256,0.0037435,836.2241531,258.8195523,988.896868,21.3849347,35.975947,0.1317623,134.6049122),(51967,'hindlimb',41,7,47,153.3663441,92.4787119,120.6086924,1.8,92.6329809,120.8046348,-0.1117283,12.5491193,18.4470875,3019.8468385,13756.9639294,0.3177588,745.7526244,240.6421331,894.2453729,20.4486118,35.5630099,0.2068739,129.8478072),(51968,'hindlimb',41,7,48,138.8519365,93.9296001,120.7141736,1.8,93.3872138,121.0011099,-0.1707725,11.8838441,17.4152282,2970.8208102,10753.8069906,0.6683604,617.4944618,249.9882006,784.4977938,19.8895565,35.1425946,0.2093854,128.8409856),(51969,'hindlimb',41,7,49,130.682428,94.9702651,120.8083645,1.8,94.4411546,121.0592593,-0.2580904,10.7524196,16.3900987,2902.8089759,9077.5505114,1.418879,553.8435545,269.9679766,727.8320963,19.5022208,32.1118121,0.2157662,138.4594554),(51970,'hindlimb',41,7,50,127.6403117,95.3429992,120.924004,1.8,94.9398067,121.2019585,-0.3171098,9.475089,16.1330668,2830.2642004,8636.7588097,2.0684711,535.3451325,298.705816,709.9575578,1.718752,6.076706,1.4288993,13.81109),(51971,'hindlimb',41,7,51,127.7621127,95.7105527,120.9927105,1.8,95.4255828,121.2258945,-0.3709306,9.4401185,15.833781,2834.430752,8568.6294321,2.7978593,541.1612958,300.2537258,718.0434688,1.718752,2.7513456,0.8960554,5.9724462),(51972,'hindlimb',41,7,52,128.7508998,96.0058132,120.9627541,1.8,95.7292948,121.1910703,-0.3842737,9.3889153,15.5488004,2801.4021414,8645.7307903,3.0157627,556.0384448,298.3733548,709.9833901,0.429688,0.6076706,2.3561945,1.2153412),(51973,'hindlimb',41,7,53,126.7250976,96.2077962,120.8774169,1.8,95.9886496,121.0893289,-0.379301,9.3022491,15.1704039,2713.1935807,8115.8163735,2.8956855,534.9769482,291.6707089,701.4181515,17.5294952,30.1700955,0.6235607,108.4497789),(51974,'hindlimb',41,7,54,125.7981342,96.1679832,120.8970468,1.8,95.9600005,121.113763,-0.3902515,9.3294923,14.8830161,2697.1484471,7811.1996832,3.0342537,524.8398342,289.0991655,698.7521757,17.5294952,29.8470824,0.5280744,106.6267671),(51975,'hindlimb',41,7,55,125.292299,96.1485647,120.972032,1.8,95.941467,121.1988163,-0.4201147,9.171819,14.4932973,2655.0299198,7588.8341313,3.4738129,523.6099135,289.4769203,671.0042345,17.368821,29.6982491,0.5478635,106.1233563),(51976,'hindlimb',41,7,56,125.5662255,96.1377828,121.0045449,1.8,95.9500456,121.280183,-0.4371544,9.181924,14.6382716,2650.4656314,7484.3075042,3.7510061,511.283554,288.6612468,652.3851813,17.368821,29.7944556,0.5800028,105.8716509),(51977,'hindlimb',41,7,57,126.1464168,96.3360341,120.9531641,1.8,95.9938327,121.2805439,-0.4417021,9.1526211,14.679281,2639.1722072,7181.6967589,3.8419608,489.2403611,288.3515203,632.5403997,17.522234,29.3323044,0.5554937,103.1892631),(51978,'hindlimb',41,7,58,129.6773597,96.4372208,121.0393436,1.8,96.1090204,121.3271001,-0.4458824,9.0384906,14.7529624,2682.189811,7259.1275085,4.0195692,492.0454156,296.7519601,631.3575082,17.4885048,29.4767221,0.6405857,102.5815925),(51979,'hindlimb',41,7,59,135.5055695,96.8035521,121.0902701,1.8,96.3108473,121.3380447,-0.4360025,8.8207427,14.8366204,2736.3689326,7248.5397366,4.0279848,488.5573344,310.2197886,637.3720218,17.4885048,29.4359802,0.5880026,97.6159679),(51980,'hindlimb',41,7,60,139.8925324,96.9792989,121.2219283,1.8,96.4325975,121.4269957,-0.4346514,8.6253638,14.9350586,2799.842466,7193.2191353,4.1342999,481.6331362,324.6057228,637.240897,17.4885048,29.3228612,0.608325,96.4006267),(51981,'hindlimb',41,7,61,149.0434428,97.1330124,121.497467,1.8,96.6277406,121.558101,-0.4448909,8.6158786,14.8095316,2944.5064754,6916.4433313,4.6007026,467.0264738,341.7534769,643.4157835,17.296779,29.079435,0.5961991,77.7713578),(51982,'hindlimb',41,7,62,157.2833911,97.2582815,121.6724982,1.8,96.6190174,121.6548559,-0.462917,8.7791963,14.8960486,3049.431639,6794.6861597,5.2274673,456.1401704,347.3474709,643.0533393,17.296779,28.9712972,0.6168012,76.4517568),(51983,'hindlimb',41,7,63,154.3413117,97.0345697,121.7441691,1.8,96.5364835,121.7288059,-0.5148358,8.8855005,14.779412,3004.5797108,6573.1160423,6.2366717,444.7481441,338.1441149,643.0648246,17.2956881,28.6057343,0.5713375,75.1321558),(51984,'hindlimb',41,7,64,147.340914,96.9218622,121.6964888,1.8,96.5144336,121.7604557,-0.5473126,8.8412344,14.6167024,2941.1428759,6309.8564566,6.6502369,431.6880976,332.6620164,626.762342,17.296779,28.3724259,0.6132073,75.3838612),(51985,'hindlimb',41,7,65,140.5849016,96.9023033,121.5611149,1.8,96.4737028,121.7905808,-0.5682721,8.65499,14.7128593,2856.0615016,5849.682281,6.7863616,397.589765,329.9901562,586.9905309,17.2956881,27.7739368,0.6094585,74.8804504),(51986,'hindlimb',41,7,66,138.1000376,96.8987615,121.4756688,1.8,96.4805204,121.7706887,-0.5862374,8.5985539,14.670898,2800.6203394,5678.6259672,7.0445769,387.0673748,325.7082953,577.2605134,17.11378,27.2911083,0.5836358,77.9188034),(51987,'hindlimb',41,7,67,132.0483115,96.8888756,121.3321392,1.8,96.4492918,121.7250058,-0.6069438,8.5151904,14.6486272,2688.7388738,5375.2044574,7.1594461,366.9425379,315.7579259,548.82616,17.1136233,26.9335897,0.5924274,73.6219234),(51988,'hindlimb',41,7,68,129.9752882,96.7912297,121.3056122,1.8,96.4537252,121.6498361,-0.6325982,8.4894023,14.6100339,2644.2394576,5184.6664946,7.5725196,354.8702587,311.4753381,534.9641982,17.0469289,26.5782087,0.6014547,71.2955008),(51989,'hindlimb',41,7,69,128.1148154,96.7310894,121.1472221,1.8,96.3396056,121.4553137,-0.6430483,8.3470152,14.493467,2533.4258513,4916.1761394,7.6776086,339.1994572,303.5127879,513.987258,16.8760947,26.1015566,0.5743048,69.1165238),(51990,'hindlimb',41,7,70,124.7527826,96.6166909,121.1489674,1.8,96.2650233,121.4069446,-0.658689,8.3055396,14.3219561,2464.8566373,4825.3548894,7.7896203,336.9200995,296.7726085,508.8676256,16.9133273,25.7418618,0.583373,68.5088532),(51991,'hindlimb',41,7,71,121.7265559,96.5881802,121.0854632,1.8,96.265458,121.3648001,-0.6832504,8.2761139,14.0730527,2382.4023766,4642.5200942,8.0859162,329.88721,287.8648618,499.088066,16.6886181,25.2750064,0.6162969,67.9011826),(51992,'hindlimb',41,7,72,120.9610613,96.52813,121.0616917,1.8,96.2419368,121.2969329,-0.6997489,8.1901594,13.7594332,2333.0860334,4556.3039984,8.3618166,331.1403846,284.8645447,499.9261985,16.6455902,24.7881939,0.5880026,66.434136),(51993,'hindlimb',41,7,73,119.4807061,96.4814865,120.9587797,1.8,96.1872388,121.1905848,-0.7215437,8.0314607,13.7336249,2262.692781,4320.5747365,8.6886166,314.5982782,281.728676,479.1961195,16.4071061,24.5787546,0.6365082,66.1824306),(51994,'hindlimb',41,7,74,118.3029792,96.4428479,120.8572875,1.8,96.1864915,121.1057308,-0.733198,7.9109149,13.4802291,2203.0630675,4241.5754978,8.8312113,314.651589,278.4839795,477.3802512,16.1032708,24.3258062,0.6223029,64.9670894),(51995,'hindlimb',41,7,75,116.521898,96.4171128,120.681803,1.8,96.1542919,120.959676,-0.7356663,7.85296,13.2887139,2114.1411016,4061.8930113,8.745941,305.6648697,269.2158238,463.6116363,16.1032708,23.9779765,0.6327488,64.3594188),(51996,'hindlimb',41,7,76,114.4652119,96.4185502,120.6040883,1.8,96.1628049,120.8368251,-0.7484615,7.7050135,13.0371938,2065.1882745,3905.3511396,8.8347473,299.5545816,268.0317528,455.4764673,15.7994355,23.5976575,0.5779019,63.6043026),(51997,'hindlimb',41,7,77,115.1314528,96.4265019,120.4688843,1.8,96.1422565,120.6733144,-0.7652827,7.6754685,12.8019196,2011.5837618,3783.0520587,9.2084047,295.5066261,262.0796062,450.6844009,15.7994355,23.1274352,0.6137701,62.6406668),(51998,'hindlimb',41,7,78,114.2395695,96.3892034,120.3851653,1.8,96.2132106,120.5024691,-0.7738738,7.4756605,12.5157149,1983.6585149,3691.9257881,9.3005606,294.9832116,265.348929,452.2644202,15.4956002,22.7775173,0.6246354,61.7812908),(51999,'hindlimb',41,7,79,110.5565012,96.4393614,120.187151,1.8,96.2762094,120.3424131,-0.7837601,7.5526447,12.0736811,1893.4788781,3469.9171831,9.182858,287.3951329,250.7040857,442.8909102,15.4956002,22.0861304,0.6473921,60.5659497),(52000,'hindlimb',41,7,80,110.2360252,96.493999,120.0541423,1.8,96.3234464,120.1523362,-0.8087884,7.5846784,11.6013212,1858.1840941,3303.1974577,9.61592,284.7259727,244.9918092,443.7185569,15.4956002,21.4844,0.6435011,59.7065737),(52001,'hindlimb',41,7,81,108.1679814,96.5724748,119.8335535,1.8,96.4249717,119.9219798,-0.8468871,7.4870702,11.2052583,1796.4687354,3069.5147099,10.1197284,273.9352024,239.942821,434.1287479,15.4716552,20.8032903,0.6682894,57.7793021),(52002,'hindlimb',41,7,82,106.267561,96.6038906,119.7022491,1.8,96.5095989,119.7693517,-0.8604463,7.4674586,10.7601414,1751.0734027,2958.978514,10.1798418,274.9943892,234.4938898,437.5757963,15.1917649,20.1999066,0.6647745,56.3122555),(52003,'hindlimb',41,7,83,106.5606779,96.6934274,119.4770272,1.8,96.605991,119.551809,-0.9014228,7.4091456,10.5877319,1702.4575991,2812.2223414,10.9222239,265.6114038,229.7778585,424.6836954,15.1917649,19.8634868,0.892677,56.0605501),(52004,'hindlimb',41,7,84,103.3089766,96.7221853,119.3141791,1.8,96.6528424,119.3662644,-0.9161906,7.3372117,10.1959455,1655.619969,2680.4874845,10.835491,262.8973912,225.6470208,425.0231346,14.8879296,19.4549516,0.7541583,55.2011741),(52005,'hindlimb',41,7,85,101.4321107,96.7543092,119.1490423,1.8,96.7128204,119.1429573,-0.9459832,7.2750341,9.9851296,1613.0544034,2554.5952515,11.1209918,255.8399691,221.7246518,415.926054,14.8879296,19.163314,0.8329813,54.9494687),(52006,'hindlimb',41,7,86,99.461586,96.7885254,119.0420869,1.8,96.7355336,119.0878494,-0.9589381,7.2451965,9.7289159,1573.8896148,2487.7639665,11.1078135,255.7082409,217.2321516,414.4458079,14.8021612,18.8769524,0.849825,53.9858329),(52007,'hindlimb',41,7,87,97.1978326,96.8513282,118.8342242,1.8,96.9059764,118.9022246,-0.9790895,7.1867004,9.5483438,1513.8342275,2379.1704563,11.1596586,249.171009,210.6438494,407.7151656,14.5840943,18.4965587,1.0343609,53.2307167),(52008,'hindlimb',41,7,88,97.6525303,96.8438306,118.7032211,1.8,96.8629083,118.7596444,-0.9935597,7.1139415,9.2929289,1496.2673573,2345.6104417,11.4286038,252.408091,210.3288806,413.2082272,14.6082537,18.2351811,0.9697226,52.8747515),(52009,'hindlimb',41,7,89,96.3100895,96.8416955,118.5060526,1.8,96.8115834,118.6375064,-1.0075678,7.0117714,9.2240088,1464.389025,2272.7691268,11.4758395,246.3971117,208.8472287,405.151113,14.5438931,18.0724546,1.0752447,52.3713407),(52010,'hindlimb',41,7,90,96.0657041,96.8257757,118.4114882,1.8,96.7628292,118.5244624,-0.9997116,7.0464122,9.1651016,1453.2224038,2240.1083311,11.3327297,244.4171846,206.235791,402.567632,14.4165278,17.99567,0.9894161,52.0153755),(52011,'hindlimb',41,7,91,95.4519433,96.8699735,118.2363101,1.8,96.8089464,118.4119307,-1.0117702,6.9860822,8.9671207,1414.9872812,2189.5631522,11.433829,244.1768354,202.5437478,400.7664166,14.280259,17.7164901,0.8884798,51.7636701),(52012,'hindlimb',41,7,92,93.3887112,96.8679074,118.1426563,1.8,96.9313738,118.2280997,-1.0106067,6.934886,8.8178533,1389.0934509,2140.2266816,11.1703869,242.7151619,200.3051596,400.0586035,14.280259,17.5384304,1.0303768,51.8679299),(52013,'hindlimb',41,7,93,91.9330855,96.8497204,117.9778617,1.8,96.9134719,118.0311154,-1.0280181,6.8773241,8.7215782,1355.9912647,2076.5922992,11.2343812,238.0982257,197.1684398,393.5685658,14.224802,17.4010378,0.9964915,51.1559995),(52014,'hindlimb',41,7,94,92.0755317,96.8157539,117.8627682,1.8,96.842243,117.9084832,-1.0380708,6.9638499,8.6515645,1348.2653896,2061.6887425,11.3875147,238.3024183,193.609197,393.3664505,14.280259,17.321277,1.0516502,50.5483289),(52015,'hindlimb',41,7,95,90.4954753,96.7946169,117.7334388,1.8,96.8695113,117.7680223,-1.0480868,6.9873159,8.5326776,1314.9730051,2006.6625543,11.3235442,235.1738388,188.1942961,389.2019093,14.280259,17.1713991,1.017502,50.2966235),(52016,'hindlimb',41,7,96,89.1027922,96.78923,117.6540302,1.8,96.852663,117.6214651,-1.0508452,6.8735269,8.4389825,1296.7200913,1975.4855126,11.1846624,234.0904853,188.6542556,386.262083,14.1855824,17.1552631,1.1856388,50.2966235),(52017,'hindlimb',41,7,97,88.3260519,96.7831717,117.5229257,1.8,96.8425353,117.5556147,-1.0496121,6.9441998,8.3366265,1278.4466353,1941.0827795,11.0714961,232.8379214,184.102802,383.9065607,14.1994373,17.1229455,1.2649175,50.0449181),(52018,'hindlimb',41,7,98,88.3379691,96.7793385,117.4142247,1.8,96.8070103,117.4795261,-1.0525341,6.9482538,8.3758301,1272.9445227,1932.1528238,11.1100791,230.6819511,183.2035159,381.3132927,14.1821825,16.998492,1.2090671,50.2966235),(52019,'hindlimb',41,7,99,88.0842962,96.8029394,117.2419835,1.8,96.7949979,117.2748726,-1.0601924,6.8515355,8.3778955,1254.6236228,1905.8316207,11.1744933,227.4833357,183.1156856,376.1391612,13.9764237,16.998492,1.2090671,49.7932127),(52020,'hindlimb',41,7,100,87.4895021,96.7648882,117.1740652,1.8,96.7942684,117.1828777,-1.072834,6.9146565,8.2479572,1251.6531878,1886.5327152,11.254993,228.7272692,181.0145135,377.9213975,13.9764237,16.998492,1.2090671,49.7932127),(52021,'hindlimb',41,7,101,86.573169,96.7493661,117.0352409,1.8,96.7990934,117.0668162,-1.0811569,6.9659192,8.1566072,1236.3517568,1843.5539222,11.2373512,226.0197018,177.4858025,370.8226482,13.9764237,16.998492,1.2890245,49.5415073),(52022,'hindlimb',41,7,102,86.6012554,96.7462314,116.9098545,1.8,96.7848994,117.0261075,-1.0966517,7.0326423,8.263984,1237.7339525,1833.289387,11.4246809,221.8408672,175.9984239,364.4838396,14.0989988,16.998492,1.2890245,49.7932127),(52023,'hindlimb',41,7,103,85.7607892,96.7570177,116.7787981,1.8,96.7691942,116.828651,-1.0936361,6.8980562,8.188524,1228.13488,1792.1389172,11.2787109,218.8598226,178.0407191,365.2667463,13.9764237,16.8512217,1.2329181,48.9338367),(52024,'hindlimb',41,7,104,85.2566885,96.7718417,116.6967046,1.8,96.8114215,116.7163639,-1.0971217,6.9208346,8.2692562,1229.7722452,1775.7279638,11.2527258,214.7385345,177.691321,359.8886484,13.9764237,16.8840595,1.3134726,49.5415073),(52025,'hindlimb',41,7,105,84.8841799,96.7988006,116.6081824,1.8,96.8830228,116.6319838,-1.1180567,6.9439625,8.1870678,1224.0559305,1751.5611801,11.4403261,213.9424297,176.2762886,357.8006351,13.9764237,16.998492,1.2890245,49.5415073),(52026,'hindlimb',41,7,106,84.9706211,96.7909392,116.5374275,1.8,96.8609722,116.5509331,-1.123565,6.9879875,8.06956,1224.6652511,1748.2209358,11.5130802,216.6438974,175.2529259,359.1784258,14.0989988,16.8840595,1.3134726,49.1855421),(52027,'hindlimb',41,7,107,84.8760113,96.7868668,116.4359024,1.8,96.8122422,116.4766109,-1.1280246,7.0398717,8.1476237,1223.8829218,1726.9135053,11.5492827,211.9530278,173.8501739,360.0173215,13.9764237,16.7137033,1.2571757,48.9338367),(52028,'hindlimb',41,7,108,84.3182555,96.8097549,116.3558238,1.8,96.8379448,116.411122,-1.1387077,6.8824268,8.2389872,1222.4493339,1714.8376406,11.5886034,208.1369469,177.6189371,354.7695992,13.9764237,16.8512217,1.2329181,48.9338367),(52029,'hindlimb',41,7,109,84.0004091,96.8214501,116.2560643,1.8,96.860979,116.284468,-1.1386546,6.9135249,8.1544701,1218.7884371,1703.3533903,11.5443534,208.8858456,176.2904537,354.2820251,14.0298035,16.7798528,1.3382394,49.1855421),(52030,'hindlimb',41,7,110,84.1262944,96.8323111,116.1759577,1.8,96.8860991,116.1726205,-1.1487425,6.9470482,8.0680654,1222.9491184,1709.6824801,11.6683064,211.9073644,176.0386679,356.780429,14.1332869,16.7798528,1.3382394,49.1855421),(52031,'hindlimb',41,7,111,84.1200841,96.8528592,116.0982465,1.8,96.8872779,116.0912623,-1.1596842,6.969137,7.99251,1220.3006723,1704.0458301,11.7809703,213.2053434,175.1006864,356.0724782,13.9764237,16.7798528,1.3382394,48.9338367),(52032,'hindlimb',41,7,112,84.1753617,96.863846,116.0223643,1.8,96.8912239,116.0114072,-1.1735335,6.896052,8.064407,1219.3402724,1707.9057421,11.9292147,211.7831786,176.8171509,355.9425168,13.9764237,16.7798528,1.3382394,48.6821313),(52033,'hindlimb',41,7,113,84.4465466,96.8814773,115.9285737,1.8,96.9106038,115.8623,-1.2010732,6.8749855,8.1422787,1213.0770486,1712.3930554,12.2365987,210.3088227,176.4479425,358.2058725,14.0298035,16.7137033,1.2571757,49.1855421),(52034,'hindlimb',41,7,114,84.4360282,96.8932415,115.8471224,1.8,96.8974182,115.79321,-1.2142026,6.9013543,8.0803515,1213.642857,1715.8208388,12.3577784,212.3448267,175.855752,360.066168,14.1332869,16.7798528,1.3382394,49.1855421),(52035,'hindlimb',41,7,115,84.7255085,96.9247904,115.7403232,1.8,96.9283748,115.6699432,-1.2208053,6.9118641,8.1975782,1218.1127874,1721.5065239,12.4606776,210.0018434,176.2350594,356.4457875,14.1332869,16.8840595,1.3134726,49.1855421),(52036,'hindlimb',41,7,116,85.2677104,96.9268995,115.6686474,1.8,96.9345654,115.6348309,-1.2246278,6.9356782,8.2691049,1228.0733499,1734.7015263,12.5752553,209.7810528,177.0660792,356.2243233,13.9764237,16.8840595,1.3134726,48.9338367),(52037,'hindlimb',41,7,117,85.6178394,96.9324463,115.5859075,1.8,96.9513095,115.5557696,-1.2392554,6.9610921,8.2214551,1229.8536159,1736.388385,12.7577642,211.2020766,176.6753835,357.0117575,14.179704,16.8840595,1.3134726,49.1855421),(52038,'hindlimb',41,7,118,86.0332609,96.9399853,115.5075125,1.8,96.9730696,115.4141968,-1.2472997,6.9796368,8.1709741,1238.3526321,1748.6413837,12.8899323,214.0064779,177.4236481,359.0863559,14.179704,16.9549897,1.418147,49.5415073),(52039,'hindlimb',41,7,119,86.1636781,96.9683661,115.4137042,1.8,97.0008658,115.2872108,-1.2668645,7.003335,8.1451014,1236.9179268,1748.1799019,13.0744045,214.6296067,176.6184149,365.9295057,14.179704,16.7798528,1.3382394,49.1855421),(52040,'hindlimb',41,7,120,86.5774771,96.9766129,115.3432674,1.8,97.0097283,115.2501341,-1.2830639,7.0325631,8.2212192,1242.2130713,1758.6499088,13.2675613,213.9159489,176.6373158,364.7187735,14.179704,16.8840595,1.3134726,48.9338367),(52041,'hindlimb',41,7,121,87.4605205,96.991984,115.2717052,1.8,96.9787392,115.1926371,-1.3014148,7.0527062,8.2989819,1249.9374801,1769.4869606,13.5443112,213.2173543,177.2280659,363.7409602,14.179704,16.998492,1.2890245,49.1855421),(52042,'hindlimb',41,7,122,88.5936561,97.006523,115.235441,1.8,97.025085,115.1528426,-1.3158029,6.9491668,8.3395343,1263.350357,1787.9330192,13.8261542,214.3924283,181.7988237,365.8722685,14.179704,16.998492,1.2890245,49.7932127),(52043,'hindlimb',41,7,123,89.4614254,97.0035231,115.1870921,1.8,97.0553403,115.0981607,-1.3281144,7.0788008,8.2825955,1264.0468258,1795.9042516,14.0492104,216.8286807,178.5679326,369.0367662,14.179704,17.0256245,1.3932002,49.5415073),(52044,'hindlimb',41,7,124,91.0052268,96.9848918,115.1539103,1.8,97.0167209,115.0567874,-1.3293584,7.0026494,8.3108376,1273.5631166,1817.0300077,14.3004346,218.6337993,181.8687539,371.4349336,14.179704,17.1067638,1.3684747,49.5415073),(52045,'hindlimb',41,7,125,90.7309088,97.0152991,115.0593952,1.8,97.0406241,114.9970295,-1.3386448,7.0022713,8.2677795,1281.093271,1816.1600746,14.3213739,219.6672133,182.953961,374.5942742,14.179704,16.998492,1.2890245,49.4372475),(52046,'hindlimb',41,7,126,91.7412363,97.024174,115.045828,1.8,97.0407152,115.01827,-1.3547798,7.0064529,8.2530286,1288.1088,1846.1518984,14.5877463,223.6938682,183.8460651,378.0481425,14.179704,16.9549897,1.7234457,49.7932127),(52047,'hindlimb',41,7,127,92.2305664,97.0354841,114.9952646,1.8,97.058414,114.9315473,-1.3800463,7.0164541,8.4566564,1284.2379148,1874.1970307,14.8192012,221.6238822,183.032327,372.2752197,14.179704,17.321277,1.4464413,50.4008833),(52048,'hindlimb',41,7,128,91.2832935,97.060035,114.8984157,1.8,97.0735872,114.8411299,-1.3913473,7.0127012,8.4408456,1286.0446484,1870.2297775,14.7292019,221.5690079,183.3879144,372.6004936,14.179704,17.379804,1.4219064,50.4008833),(52049,'hindlimb',41,7,129,91.1541631,97.0877443,114.8080166,1.8,97.0880881,114.7644274,-1.4123555,7.0009226,8.605773,1285.1082147,1870.6066795,14.8141601,217.3664917,183.5626941,366.6766504,14.179704,17.5279,1.3734008,50.1491779),(52050,'hindlimb',41,7,130,91.7955628,97.0933116,114.7767147,1.8,97.0957196,114.7083382,-1.420086,6.9991014,8.5734936,1288.3375628,1882.3019235,14.9543821,219.5489972,184.0718534,369.3124652,14.179704,17.4487192,1.3975507,50.1491779),(52051,'hindlimb',41,7,131,91.4094026,97.1018571,114.6995103,1.8,97.1071654,114.5943056,-1.4266481,6.9386107,8.3521049,1278.5487403,1864.4245435,14.9205254,223.2281055,184.2658137,375.5910645,13.750016,17.1982588,1.3439975,49.6889529),(52052,'hindlimb',41,7,132,91.2253863,97.1255812,114.6206486,1.8,97.1502443,114.4914738,-1.4308182,6.9265253,8.3713272,1278.3595751,1854.984593,14.9082618,221.5878745,184.5600092,374.2435531,13.750016,17.1067638,1.773118,49.6889529),(52053,'hindlimb',41,7,133,91.0453423,97.1791766,114.4825831,1.8,97.2367612,114.2784239,-1.4341363,6.8922041,8.4563627,1273.2258151,1824.2240164,14.8925903,215.7220644,184.7342001,366.1566176,13.750016,17.1067638,1.3684747,49.4372475),(52054,'hindlimb',41,7,134,90.8253507,97.2059257,114.3511399,1.8,97.2604138,114.1680453,-1.4398196,6.8817958,8.2775453,1272.1968778,1802.1920517,14.8793568,217.7205912,184.8640832,369.9359376,13.750016,16.9549897,1.418147,49.4372475),(52055,'hindlimb',41,7,135,90.4790263,97.2408687,114.1823735,1.8,97.286319,114.0272563,-1.4486352,6.8644223,8.3377414,1267.9529516,1748.7038913,14.8559134,209.7335242,184.713716,361.8057505,13.750016,16.8949912,1.4432868,49.1855421),(52056,'hindlimb',41,7,136,90.2406834,97.275037,114.0543402,1.8,97.3308424,113.8707167,-1.4558341,7.0705694,8.0912537,1273.8759277,1711.257829,14.8422131,211.4947694,180.1659602,367.3171527,14.179704,16.6028685,1.7529646,49.1855421),(52057,'hindlimb',41,7,137,89.4764757,97.2981418,113.8764256,1.8,97.3087803,113.6737876,-1.4696482,6.8248123,7.8350073,1267.6042514,1642.4031517,14.7606942,209.6236924,185.7346693,365.120734,13.750016,16.3620316,1.8094056,48.4736117),(52058,'hindlimb',41,7,138,88.7425924,97.3264371,113.7390805,1.8,97.3757328,113.5531395,-1.4696162,7.0644509,7.8877265,1268.6059636,1595.5254275,14.6395322,202.2795057,179.5760174,360.9317865,14.179704,16.1804778,1.7577756,48.8295769),(52059,'hindlimb',41,7,139,88.1983203,97.3523931,113.6068733,1.8,97.3899707,113.4370537,-1.4900154,7.0597786,7.664092,1259.6727119,1554.5262148,14.6040047,202.8324047,178.429493,360.7281948,14.179704,16.0544686,1.8417432,47.9702009),(52060,'hindlimb',41,7,140,88.2717814,97.3628913,113.5189722,1.8,97.3624495,113.3804558,-1.5143706,7.0597159,7.7036199,1255.263575,1540.8781715,14.6651724,200.0200143,177.8065287,358.8446211,14.179704,15.8461105,1.7894653,47.9702009),(52061,'hindlimb',41,7,141,87.6603704,97.3883745,113.3997859,1.8,97.3963402,113.2735478,-1.536377,7.0377372,7.406937,1251.3371966,1504.5403627,14.5927602,203.1258491,177.8039102,358.1798353,14.179704,15.6408793,1.849096,47.6142357),(52062,'hindlimb',41,7,142,87.1126295,97.4067819,113.3090747,1.8,97.4569079,113.226931,-1.5485211,7.0180977,7.4667428,1259.0029754,1480.3603556,14.5115688,198.260527,179.3937653,357.6058364,14.179704,15.5283322,1.8224863,47.8659411),(52063,'hindlimb',41,7,143,86.5075408,97.4199093,113.1810603,1.8,97.4443566,113.0733574,1.5566257,7.008203,7.5621986,1256.2273236,1442.9834467,14.4150284,190.8153345,179.2509898,356.9342024,14.179704,15.3549594,1.8836976,47.8659411),(52064,'hindlimb',41,7,144,85.9219224,97.4348006,113.0857545,1.8,97.4606114,113.029096,1.5165818,7.0199132,7.3383429,1253.8830429,1423.7656382,14.2782711,194.0173225,178.6180263,353.7241561,14.179704,15.4029813,1.9720251,47.5099759),(52065,'hindlimb',41,7,145,85.2884116,97.4731435,112.9739967,1.8,97.4822075,112.9558239,1.4791913,7.0267523,7.4711404,1249.5304898,1386.6152582,14.0957858,185.5961978,177.8247525,349.0400943,14.179704,15.2584623,2.1353657,47.2582705),(52066,'hindlimb',41,7,146,85.3203025,97.4944601,112.8942688,1.8,97.4951054,112.8983797,1.4404197,7.0138057,7.4170876,1257.1150424,1369.1210283,13.9797035,184.5901113,179.2343704,351.8230567,14.179704,15.2584623,2.1353657,47.2582705),(52067,'hindlimb',41,7,147,84.8981112,97.5189293,112.7954295,1.8,97.5261926,112.776098,1.3716223,6.9719437,7.4615183,1248.3256414,1347.7949071,13.5957467,180.6327951,179.049875,343.9112511,14.179704,15.240301,1.9460671,47.5099759),(52068,'hindlimb',41,7,148,84.8852429,97.53523,112.7079314,1.8,97.5453586,112.67965,1.32894,7.018538,7.4816999,1249.7507414,1337.846412,13.3359976,178.8158344,178.0642543,345.4317604,14.179704,15.1125613,1.8295672,47.0065651),(52069,'hindlimb',41,7,149,84.4144878,97.5554684,112.6172373,1.8,97.5626023,112.6232592,1.2941589,6.9606612,7.4544469,1242.8382768,1315.9970768,13.0195857,176.5385269,178.5517552,342.8922855,14.179704,15.1917649,2.0724004,47.0065651),(52070,'hindlimb',41,7,150,84.5005934,97.580092,112.5348332,1.8,97.5195611,112.5586411,1.2432206,6.9848116,7.50514,1244.9604325,1308.7675325,12.6254851,174.3828263,178.2382276,339.2413893,14.179704,15.1917649,2.0724004,47.0065651),(52071,'hindlimb',41,7,151,83.5685946,97.6206186,112.4479135,1.8,97.5799809,112.4447127,1.1405804,7.0616299,7.4082782,1227.4176827,1292.0176355,11.5053765,174.4018787,173.8150687,338.7722025,14.179704,15.03908,2.2142974,46.6505999),(52072,'hindlimb',41,7,152,83.2163395,97.6259702,112.3892986,1.8,97.5613059,112.3876934,1.0666041,7.0950155,7.4274702,1223.8039079,1288.324391,10.6324694,173.4539975,172.4878414,335.378949,14.179704,15.1369758,2.1745457,46.6505999),(52073,'hindlimb',41,7,153,82.3035312,97.6574479,112.3381548,1.8,97.6056162,112.3466467,0.9840662,7.0241828,7.404984,1208.3592845,1272.840848,9.5126654,171.8897499,172.0284515,332.4197382,14.179704,15.1369758,2.1745457,46.6505999),(52074,'hindlimb',41,7,154,81.8450289,97.6757392,112.2797382,1.8,97.6118346,112.2945116,0.9370687,7.0780801,7.2972066,1204.2520242,1265.9831956,8.8577494,173.4887417,170.1382314,336.2723012,14.179704,15.03908,2.2142974,46.9023053),(52075,'hindlimb',41,7,155,80.7678424,97.7057081,112.2249899,1.8,97.6800986,112.2259496,0.8377141,7.0353765,7.209172,1188.0884856,1249.7758124,7.4336098,173.3591335,168.8734751,330.8528946,14.179704,15.03908,2.2142974,46.9023053),(52076,'hindlimb',41,7,156,80.4173777,97.7287399,112.15974,1.8,97.7172166,112.0963512,0.8093118,6.8930393,7.194668,1184.4586111,1246.7844215,7.0218378,173.2928358,171.8340142,327.665578,14.179704,15.1369758,2.1745457,46.6505999),(52077,'hindlimb',41,7,157,79.8039526,97.7571926,112.0878223,1.8,97.7495441,112.0245212,0.7828587,6.884273,7.1803161,1171.7538004,1239.544342,6.616553,172.6308872,170.207342,329.1286397,13.750016,15.03908,2.2142974,46.2946347),(52078,'hindlimb',41,7,158,79.5863109,97.765024,112.0371517,1.8,97.7498452,112.0303877,0.7468807,6.9614081,7.1965998,1171.5900266,1240.3995297,6.1217873,172.3591086,168.2978511,327.1916661,13.750016,15.03908,2.2142974,46.2946347),(52079,'hindlimb',41,7,159,78.9804949,97.7773417,111.9695508,1.8,97.7377439,111.9851564,0.7214895,7.0012591,7.0927378,1162.7283397,1228.7834622,5.7427409,173.2452966,166.0741754,325.089713,13.750016,14.8972278,2.1507991,46.0429293),(52080,'hindlimb',41,7,160,78.9459743,97.8024043,111.9011443,1.8,97.7929339,111.8961181,0.6777808,7.0035025,7.0955836,1164.640434,1230.0672932,5.1737454,173.3567485,166.2939987,323.2880182,13.750016,15.0329403,2.1112158,46.2946347),(52081,'hindlimb',41,7,161,78.4194381,97.8284635,111.8435509,1.8,97.8048865,111.868133,0.6505113,6.9447955,7.0928038,1157.1344653,1224.1043998,4.7933003,172.5839935,166.6189412,319.6990325,13.750016,15.0329403,2.1112158,46.0429293),(52082,'hindlimb',41,7,162,77.8728161,97.8578946,111.8119126,1.8,97.8145823,111.841358,0.5915861,7.0108599,7.2323286,1154.5961664,1220.0828349,4.0364728,168.6984793,164.686811,325.4926789,13.750016,14.9652379,2.2545056,46.2946347),(52083,'hindlimb',41,7,163,76.9238647,97.8660108,111.779402,1.8,97.8267732,111.8117855,0.5620393,6.9104979,7.1907295,1141.3030531,1213.4636503,3.6410137,168.7539,165.1549678,321.5620004,13.750016,14.9652379,2.2545056,45.9386695),(52084,'hindlimb',41,7,164,76.4717407,97.8683965,111.7491072,1.8,97.813737,111.8376276,0.5431043,6.924986,7.1544563,1136.4049283,1216.244303,3.4039888,169.9981454,164.1021265,320.0782658,13.750016,15.03908,2.2142974,45.9386695),(52085,'hindlimb',41,7,165,76.0962668,97.8718147,111.6953462,1.8,97.8144769,111.7475714,0.5341585,6.8985761,7.2020499,1128.7275393,1213.9018925,3.2873591,168.5494973,163.6174649,317.7951242,13.750016,15.03908,2.2142974,46.2946347),(52086,'hindlimb',41,7,166,75.9776548,97.8884681,111.6499255,1.8,97.8629693,111.6958004,0.5205392,6.948341,7.1972385,1129.0050128,1217.5864889,3.132242,169.1741204,162.4855513,316.9582615,14.179704,15.1369758,2.1745457,46.9023053),(52087,'hindlimb',41,7,167,75.5727518,97.9184282,111.6163031,1.8,97.8985017,111.6758429,0.4776873,6.8546494,7.2121988,1124.233029,1211.5465296,2.662032,167.9857369,164.0102901,314.840046,14.179704,15.1369758,2.1745457,46.9023053),(52088,'hindlimb',41,7,168,75.4127935,97.9366553,111.5760261,1.8,97.9228014,111.6240049,0.4462077,6.8563814,7.207003,1124.8699232,1212.8299864,2.3407302,168.2849277,164.0617495,320.7078259,14.1332869,15.03908,2.2142974,46.6505999),(52089,'hindlimb',41,7,169,75.1395385,97.9351858,111.5436281,1.8,97.9188365,111.6023777,0.4375242,6.8929575,7.1898974,1122.2379744,1210.0147554,2.248177,168.2937442,162.8093575,318.7284903,14.179704,15.03908,2.2142974,46.6505999),(52090,'hindlimb',41,7,170,75.0825824,97.9438556,111.5031708,1.8,97.9377772,111.5544656,0.419728,6.9481747,7.1759477,1124.9545128,1215.218988,2.0781115,169.346132,161.9064813,318.5197005,14.179704,15.03908,2.2142974,46.6505999),(52091,'hindlimb',41,7,171,74.8236503,97.9471591,111.4700887,1.8,97.9577753,111.5241343,0.3780296,6.924259,7.146989,1122.5219429,1212.4288106,1.6988379,169.6419016,162.114379,316.6736769,14.1332869,15.03908,2.2142974,46.6505999),(52092,'hindlimb',41,7,172,74.5746771,97.958652,111.4394589,1.8,97.9737468,111.4670661,0.3588584,6.896413,7.1343174,1123.1847963,1214.3002593,1.5330732,170.2055274,162.8650726,316.1595172,14.1593084,15.03908,2.2142974,46.9023053),(52093,'hindlimb',41,7,173,74.2133583,97.9721802,111.4199342,1.8,97.9493644,111.4236001,0.325552,6.9407909,7.1137281,1121.0095123,1212.1912783,1.2652439,170.4016894,161.5103426,316.0134003,13.750016,14.9898924,2.0472637,46.5463401),(52094,'hindlimb',41,7,174,74.1227209,97.9839002,111.3910298,1.8,97.9619224,111.4190008,0.3033668,6.9818241,7.1192918,1124.0649848,1215.8358203,1.1024835,170.7804439,160.9987534,315.9935087,13.750016,15.03908,2.2142974,46.5463401),(52095,'hindlimb',41,7,175,73.7053412,97.9820948,111.3585261,1.8,97.9577033,111.3959165,0.3001994,6.88641,7.2359994,1118.0228566,1212.3984947,1.0741917,167.5509392,162.3520614,317.9907736,13.750016,15.03908,2.2142974,46.5463401),(52096,'hindlimb',41,7,176,73.5937229,97.9821201,111.323249,1.8,97.9695661,111.3453604,0.2773765,6.9360891,7.2226156,1117.9391954,1219.0537947,0.9197343,168.7828717,161.1771682,319.874487,13.750016,14.9652379,2.2545056,46.5463401),(52097,'hindlimb',41,7,177,73.5357038,97.9985017,111.3044218,1.8,97.9744534,111.3255233,0.2419544,6.9759252,7.2219406,1117.7423649,1219.8123818,0.7035951,168.9036859,160.2285484,319.4306151,13.750016,14.8972278,2.1507991,46.2946347),(52098,'hindlimb',41,7,178,73.5800154,98.0082249,111.2847122,1.8,97.9869708,111.3351554,0.2179625,7.0039792,7.214387,1120.4828199,1225.9350982,0.5734348,169.9292113,159.9780345,319.9812153,14.179704,14.8972278,2.1507991,46.6505999),(52099,'hindlimb',41,7,179,73.4801464,98.0156505,111.2735372,1.8,98.0007956,111.3204294,0.1980257,7.0188051,7.2061126,1119.6387437,1224.956573,0.4739994,169.9885419,159.51985,319.3876634,14.179704,14.8972278,2.1507991,46.6505999),(52100,'hindlimb',41,7,180,73.4922873,98.021858,111.2493406,1.8,98.0085596,111.3121737,0.1946881,6.9607319,7.2050473,1122.0317912,1231.1108145,0.4584323,170.8678329,161.1945129,319.6556097,14.179704,15.03908,2.2142974,46.9023053),(52101,'hindlimb',41,7,181,73.4788596,98.0223058,111.2231084,1.8,98.0112081,111.2683671,0.185586,6.9903366,7.1937181,1122.869956,1235.3108213,0.416975,171.7207712,160.631743,321.353635,14.179704,15.03908,2.2142974,47.1540107),(52102,'hindlimb',41,7,182,73.5055472,98.0250484,111.1916088,1.8,98.0186829,111.2345296,0.1670947,7.0277522,7.2421292,1126.9856046,1242.8298834,0.3388819,171.6111166,160.3621708,321.76816,14.179704,15.03908,2.2142974,47.5099759),(52103,'hindlimb',41,7,183,73.1174848,98.0168795,111.1603845,1.8,97.9730089,111.1786613,0.1729255,6.9815539,7.2948212,1121.9609524,1240.3716437,0.3607904,170.0345498,160.7036156,320.3644137,14.1332869,15.03908,2.2142974,47.5099759),(52104,'hindlimb',41,7,184,73.0542065,98.0235639,111.124604,1.8,97.9702346,111.1164944,0.1720961,7.0185574,7.2960806,1124.9094172,1243.7168388,0.3570624,170.4636927,160.2764441,320.806401,14.179704,15.03908,2.2142974,47.5099759),(52105,'hindlimb',41,7,185,73.1252617,98.0319329,111.1017488,1.8,97.997739,111.1070043,0.1650245,7.0474514,7.307464,1126.6680473,1248.3213272,0.3289026,170.8282564,159.8688629,321.2238239,14.179704,15.03908,2.2142974,47.5099759),(52106,'hindlimb',41,7,186,73.1651534,98.0407294,111.074799,1.8,98.0107346,111.0873896,0.1732801,7.0697089,7.3772982,1132.1822851,1256.6494135,0.3624928,170.340059,160.1455314,322.6099596,14.179704,15.0881073,0.348771,47.2582705),(52107,'hindlimb',41,7,187,73.1123935,98.0453542,111.058041,1.8,98.0180493,111.0904015,0.1647959,7.0929228,7.3842457,1136.492829,1257.7015667,0.3279424,170.3222799,160.2291268,320.8812062,14.179704,15.1369758,2.5378433,47.2582705),(52108,'hindlimb',41,7,188,73.3972859,98.0349025,111.0359789,1.8,98.0078643,111.0777691,0.1428956,7.1261651,7.3819339,1143.5603245,1269.8434055,0.2480897,172.0204248,160.4734542,323.7628745,14.179704,15.1369758,2.5378433,47.2582705),(52109,'hindlimb',41,7,189,73.4939099,98.036307,111.0370183,1.8,98.009917,111.0825586,0.1106207,7.1384996,7.394111,1147.1051333,1277.6652597,0.1492797,172.79498,160.6927508,325.2339075,14.179704,15.1369758,2.5378433,47.2582705),(52110,'hindlimb',41,7,190,73.6213617,98.0337597,111.0308136,1.8,98.0043867,111.0740064,0.0938356,7.1483457,7.3934827,1154.1256553,1288.7666771,0.107724,174.311177,161.4535302,327.7345307,14.179704,15.1917649,0.5016041,47.2582705),(52111,'hindlimb',41,7,191,73.397174,98.0226499,111.0521354,1.8,97.984551,111.090035,0.0796203,7.1279871,7.384667,1153.518932,1295.1110565,0.0773852,175.378396,161.8295491,329.1293594,14.179704,15.1917649,0.5016041,47.8659411),(52112,'hindlimb',41,7,192,73.3288043,98.0180181,111.0513767,1.8,98.0105349,111.0965497,0.069132,7.12891,7.4089013,1158.6425961,1304.9112365,0.0583162,176.1274974,162.5273132,331.3343726,14.179704,15.240301,0.3752708,48.1176465),(52113,'hindlimb',41,7,193,73.3624296,98.0049585,111.0569632,1.8,97.9961458,111.090035,0.0510133,7.1217418,7.3851302,1163.8126289,1311.6573646,0.0317916,177.6078873,163.416852,330.204944,14.179704,15.3549594,0.3129012,48.1176465),(52114,'hindlimb',41,7,194,73.6780381,98.0040873,111.0420486,1.8,98.005462,111.0797699,0.032294,7.1334491,7.3697342,1174.2040004,1325.9988198,0.0128021,179.9249176,164.6053655,333.4067631,14.179704,15.3849907,0.6267429,48.1176465),(52115,'hindlimb',41,7,195,73.7356656,98.0054839,111.0391656,1.8,98.0135949,111.0994244,0.0090717,7.1289714,7.3504395,1180.2860095,1335.3405836,0.0010113,181.668127,165.5618946,335.3759839,14.179704,15.3849907,0.6267429,48.1176465),(52116,'hindlimb',41,7,196,74.0802556,98.0159202,111.0279088,1.8,98.0351781,111.0882198,-0.0016556,7.1397605,7.3543089,1189.9605113,1352.8891892,0.0000339,183.9587105,166.6667275,338.4399719,14.179704,15.4269362,0.2247112,48.1176465),(52117,'hindlimb',41,7,197,74.52326,98.0178829,111.0350635,1.8,98.034353,111.0786917,-0.0135413,7.156911,7.3739369,1199.3135983,1369.1789155,0.0022774,185.6781435,167.5741955,341.8325271,14.179704,15.4269362,0.2247112,48.1176465),(52118,'hindlimb',41,7,198,74.8618635,98.0144148,111.0261207,1.8,98.0436787,111.056803,-0.0187595,7.1762702,7.3780691,1212.1450526,1384.2684401,0.0043904,187.6193383,168.9101754,343.2156438,14.179704,15.5758196,0.4266275,48.1176465),(52119,'hindlimb',41,7,199,75.2496462,98.0207351,111.0392971,1.8,98.030713,111.058723,-0.0122416,7.1500338,7.3801147,1220.3594112,1402.4366819,0.0018794,190.0291178,170.6788321,344.4058821,14.179704,15.6408793,0.2782997,48.1176465),(52120,'hindlimb',41,7,200,75.7317589,98.0267427,111.0311218,1.8,98.0049398,111.0121817,-0.0015591,7.136999,7.3656479,1234.6556742,1420.916179,0.0000307,192.9112283,172.9936736,348.347497,14.179704,15.6408793,0.2782997,48.3693519),(52121,'hindlimb',41,7,201,76.2497909,98.0048197,111.0358375,1.8,97.9965858,110.966611,-0.0077524,7.147856,7.3557195,1250.4625966,1433.3802284,0.0007638,194.8660801,174.942332,353.0932881,14.179704,15.6408793,0.2782997,48.3693519),(52122,'hindlimb',41,7,202,76.7983711,97.9943335,111.0332156,1.8,97.9813007,110.9614849,-0.003415,7.1396602,7.3368665,1261.8170055,1459.2410595,0.0001493,198.8915916,176.7334812,356.1291525,14.179704,15.7643386,0.3045109,48.3693519),(52123,'hindlimb',41,7,203,77.756554,98.0069572,111.0227012,1.8,98.0029469,110.9763597,-0.0077339,7.5806352,7.3579231,1279.9652935,1485.7624322,0.0007751,201.9268766,168.8467084,357.5899298,14.609392,15.7643386,0.3045109,48.7253171),(52124,'hindlimb',41,7,204,77.9570194,98.0211951,111.0180508,1.8,98.0084639,110.9907155,-0.0031321,7.5810194,7.7875261,1297.4929913,1497.7393714,0.0001275,192.3254381,171.1501999,358.7570969,14.609392,15.9679831,0.4154921,49.5846931),(52125,'hindlimb',41,7,205,78.3166038,98.0132772,111.0362922,1.8,98.0488467,111.0072093,-0.0033381,7.5631429,7.7810325,1313.8853884,1513.7695968,0.0001455,194.5461099,173.7221435,362.1165153,14.609392,16.0429641,0.3556359,49.9406583),(52126,'hindlimb',41,7,206,78.9709836,98.0376025,111.0440078,1.8,98.0950741,111.0241508,-0.0303895,7.6095857,7.8330815,1328.6253962,1545.4092005,0.0121515,197.2926233,174.5989145,364.6829943,14.609392,16.1061369,0.1607627,50.1923637),(52127,'hindlimb',41,7,207,79.7279179,98.063088,111.0462101,1.8,98.1160878,111.007869,-0.0756247,7.6813066,7.9219825,1343.0092207,1584.2889269,0.0758504,199.9864208,174.8412462,366.962284,14.609392,16.2658334,0.2129383,50.1923637),(52128,'hindlimb',41,7,208,80.5393466,98.0643195,111.0303905,1.8,98.1346888,111.007962,-0.1079239,7.7406283,7.9510121,1365.424389,1617.4009073,0.1557419,203.4207582,176.3971007,373.7234479,14.609392,16.3620316,0.4048918,50.1923637),(52129,'hindlimb',41,7,209,81.888837,98.0754407,111.0202141,1.8,98.1185121,110.987145,-0.1542734,7.7974818,7.9872492,1389.2904174,1662.0301331,0.3222608,208.0854237,178.1716773,381.2210707,14.609392,16.446445,0.5807564,50.4440691),(52130,'hindlimb',41,7,210,82.3581374,98.0615938,111.0302961,1.8,98.1500966,110.9536159,-0.1843512,7.8122594,8.0570066,1405.95275,1696.3285168,0.4612345,210.540787,179.9674934,384.2742728,15.03908,16.5973074,0.3708913,50.8000343),(52131,'hindlimb',41,7,211,83.7084112,98.0599418,111.0534697,1.8,98.1778184,111.0331205,-0.207497,8.0459432,8.1487669,1437.8406084,1740.7998186,0.5921061,213.6273905,178.7037977,388.5587367,15.4224941,16.757832,0.3947911,51.1559995),(52132,'hindlimb',41,7,212,84.8634788,98.0933027,111.0423194,1.8,98.1491704,111.0413341,-0.2256676,8.1356303,8.19553,1462.2784121,1790.1991472,0.7081466,218.4360441,179.7375696,395.8830184,15.468768,16.8512217,0.3378782,51.4077049),(52133,'hindlimb',41,7,213,86.6480288,98.1193345,111.0284667,1.8,98.1923018,111.016647,-0.2614038,8.1288024,8.2396086,1492.8399729,1853.8048561,0.9645315,224.9870049,183.6482053,402.1421931,15.468768,17.1713991,0.5532943,52.0153755),(52134,'hindlimb',41,7,214,87.0539949,98.1261893,111.0420105,1.8,98.1984831,111.0353515,-0.2846669,8.2195296,8.3675631,1518.4309914,1902.5932708,1.1443229,227.3772231,184.7345362,408.1291361,15.468768,17.1713991,0.5532943,52.3713407),(52135,'hindlimb',41,7,215,88.1632962,98.1166748,111.0827852,1.8,98.2226619,111.0373059,-0.3196523,8.1672187,8.3579225,1552.0066139,1968.7618698,1.4509407,235.556367,190.0287818,410.9344169,15.468768,17.321277,0.4081491,53.1264569),(52136,'hindlimb',41,7,216,89.1331725,98.1107156,111.0771204,1.8,98.2108829,111.0439214,-0.3267291,8.3079811,8.4929735,1577.6961895,2025.0821762,1.5302217,238.4420681,189.9012728,418.2104885,15.840887,17.5384304,0.5404195,53.7341275),(52137,'hindlimb',41,7,217,91.327717,98.0839989,111.0683291,1.8,98.1619516,111.0648296,-0.3547645,8.4198386,8.5606699,1626.1818875,2114.6176836,1.8366858,247.0154454,193.1369435,428.9639972,15.898456,17.7633248,0.5611634,53.7341275),(52138,'hindlimb',41,7,218,92.5390134,98.1048256,111.0553831,1.8,98.168698,111.0606822,-0.3766292,8.549436,8.6689753,1660.4225005,2186.0008454,2.0862615,252.1636948,194.2142742,433.1837324,15.898456,17.99567,0.5813802,53.9858329),(52139,'hindlimb',41,7,219,94.2268835,98.1085423,111.0985583,1.8,98.1705811,111.1080404,-0.3920917,8.6524679,8.7516384,1692.0728587,2267.9719626,2.2931271,259.1482711,195.559565,441.5151121,15.898456,18.1285566,0.5485494,53.9858329),(52140,'hindlimb',41,7,220,95.5118088,98.1217445,111.1234684,1.8,98.2498138,111.1268937,-0.3903941,9.9815824,8.9102264,1741.5754615,2335.2220278,2.3053452,262.0833546,174.4788938,406.3145555,16.3315711,18.3914495,0.6528466,55.8088447),(52141,'hindlimb',41,7,221,97.3946053,98.1251888,111.1982559,1.8,98.2212853,111.2385444,-0.4170761,10.8855359,9.1544143,1818.3734419,2430.069738,2.6636948,265.4533264,167.0449171,382.7240403,16.7614584,19.0279509,2.0142447,60.8176551),(52142,'hindlimb',41,7,222,98.3725383,98.0945157,111.2009727,1.8,98.2277939,111.2457045,-0.4229525,10.8826842,9.2339145,1849.4318363,2506.8114614,2.7621854,271.4787375,169.9426178,392.2910161,16.951623,19.0812438,1.4352686,61.0693605),(52143,'hindlimb',41,7,223,100.7941239,98.1008583,111.2681245,1.8,98.2311713,111.2818303,-0.4390889,10.7821452,9.4531951,1917.4746823,2606.0385996,3.0359646,275.6780712,177.8379574,409.8227633,16.8610744,18.9501664,0.5754247,58.1352673),(52144,'hindlimb',41,7,224,103.7674229,98.1371864,111.4267932,1.8,98.3720644,111.5555397,-0.4756788,13.2625411,9.7291298,2119.5730188,2700.8913874,3.6268599,277.6087308,159.8165085,362.9415556,17.6102106,20.413572,2.1003859,65.3230546),(52145,'hindlimb',41,7,225,104.2232955,98.1095832,111.3883365,1.8,98.2394621,111.41196,-0.5043158,9.9510688,9.7715711,2062.9287423,2799.5547345,4.0558581,286.4999617,207.3072539,476.9418906,17.0721162,19.3120737,0.5633163,59.4548682),(52146,'hindlimb',41,7,226,106.4378698,98.0474606,111.4506247,1.8,98.2005585,111.4296129,-0.5468005,9.8270073,10.1183599,2109.1925298,2930.0219162,4.7960053,289.5747884,214.632235,495.2534965,17.2385183,19.6813991,0.6304014,60.5659497),(52147,'hindlimb',41,7,227,108.8920737,97.9964023,111.5504478,1.8,98.1241689,111.5729672,-0.5687091,9.7121163,10.2362032,2173.9352141,3085.2149907,5.2636707,301.4022817,223.8374365,511.7743005,17.425557,19.9377084,0.6478114,61.0693605),(52148,'hindlimb',41,7,228,111.8291736,97.9928205,111.7379013,1.8,98.2678327,111.8015735,-0.5438459,10.6516452,10.532884,2335.5863902,3212.3933674,4.9900919,304.9870641,219.2700147,516.1135197,18.7773489,20.4677674,0.6812982,70.8352758),(52149,'hindlimb',41,7,229,113.3682753,97.910757,111.8624783,1.8,98.2147478,111.9443749,-0.5737645,9.7161506,10.8428367,2436.9127758,3369.9525813,5.5669341,310.7999026,250.8105188,533.9578078,18.5093375,20.8032903,0.6682894,71.0437954),(52150,'hindlimb',41,7,230,114.5344768,97.9009557,111.9739966,1.8,98.1724317,112.0209673,-0.5954929,9.9483598,10.9291417,2513.0559746,3497.185513,6.0059544,319.9872049,252.6100813,548.8396538,18.6880118,21.072243,0.8865015,74.5855592),(52151,'hindlimb',41,7,231,122.1449986,97.8687741,112.2751516,1.8,98.1009326,112.5548716,-0.5802039,15.5136433,11.3448955,2862.9388694,3878.7471309,6.1177781,341.8935969,184.5432958,375.6655417,19.1446806,23.0033622,0.5724598,69.1597097),(52152,'hindlimb',41,7,232,128.217314,97.6682192,112.5443843,1.8,97.8432551,112.8584216,-0.6009963,15.4570518,11.8016496,3070.9440957,4355.3035949,6.8329156,369.0419352,198.6759274,419.0288301,19.3550904,23.9587186,0.5681047,71.1301671),(52153,'hindlimb',41,7,233,141.7296745,97.30898,113.0608357,1.8,97.7318258,113.4601641,-0.6081224,14.8236026,12.5347407,3638.9808657,5232.790831,7.7104509,417.4630303,245.4855917,527.5087083,20.195336,24.6762153,0.6121525,76.9983534),(52154,'hindlimb',41,7,234,153.3277392,97.1741967,113.5340084,1.8,97.5744843,114.07917,-0.6514974,13.9100989,13.0766421,4162.9210287,5988.1166087,9.396281,457.9246381,299.2732883,622.1590233,22.343776,28.1535827,1.2924967,91.6688194),(52155,'hindlimb',41,7,235,179.8779567,97.2045578,114.6101218,1.8,97.3476548,115.1988223,-0.7439045,13.8712749,15.2267552,5533.8856624,7588.1285076,13.747292,498.3417942,398.9457145,831.9686155,22.4270084,28.4146927,1.2155655,96.9904092),(52156,'hindlimb',41,7,236,223.8293834,97.1196669,116.1254019,1.8,97.2144082,116.3752406,-0.8564376,13.7322547,15.812815,7910.67175,11063.6564473,21.2936613,699.6639407,576.0650344,1199.0198738,23.2472212,31.6251536,0.9300126,109.9421231),(52157,'hindlimb',41,7,237,267.5573498,96.7026943,117.3343187,1.8,96.9807398,117.0601306,-0.7960958,14.5397668,16.1366649,10002.5174641,14826.0583177,22.7734462,918.7808286,687.942083,1519.0654074,23.8940527,32.6817201,0.887842,99.7159828),(52158,'hindlimb',41,7,238,292.1176283,97.1451702,117.8264824,1.8,97.4053696,117.5438985,-0.7166274,18.5752034,16.3765754,12597.5323158,16173.0068896,21.0054906,987.5695333,678.190813,1527.1112669,27.3422657,33.2862629,0.8859751,111.3480958),(52159,'hindlimb',41,7,239,324.1800554,98.1282394,118.4334063,1.8,98.3132572,118.0865694,-0.042547,14.7805301,15.9828221,15951.9148243,18464.1926959,0.0977488,1155.2523406,1079.2518782,1847.1569679,27.500032,34.1649249,2.2671449,115.4975302),(52160,'hindlimb',41,7,240,329.2375674,98.1027765,118.4940283,1.8,98.3174811,118.2180027,-0.1451609,14.9456136,15.5449318,16568.0012625,18841.8456766,1.1481671,1212.089308,1108.5527604,1874.8661209,27.92972,34.5598462,2.2416538,113.5270728),(52161,'hindlimb',41,7,241,333.9247528,98.1078889,118.5952062,1.8,98.3744991,118.3543264,-0.2015689,15.4393988,16.0071712,17133.9742863,19008.1497372,2.2307692,1187.4771308,1109.7565748,1892.7144273,28.2501015,35.1005392,2.2608324,113.6745184),(52162,'hindlimb',41,7,242,335.3558169,98.1936001,118.5674405,1.8,98.4912697,118.4355252,-0.0779183,14.6835558,15.1655151,17424.8643493,19160.7049182,0.3386527,1263.4391152,1186.6924213,1915.3614486,28.359408,35.1005392,2.2608324,116.2094606),(52163,'hindlimb',41,7,243,332.3304853,98.26631,118.639567,1.8,98.4904997,118.5695841,-0.066854,14.6727549,15.1593819,16768.1243104,18766.3596866,0.2471873,1237.9369961,1142.8068166,1870.3136634,27.92972,35.1005392,2.2608324,116.5654257),(52164,'hindlimb',41,7,244,328.9431636,98.3774493,118.6352074,1.8,98.5131992,118.6489425,0.0256755,14.8229239,15.2747826,16623.5104744,18560.1429035,0.0361336,1215.0839324,1121.4731045,1860.0071227,27.92972,35.1005392,2.2608324,118.7875886),(52165,'hindlimb',41,7,245,310.4586693,98.3649314,118.7124534,1.8,98.5023198,118.6376178,-0.0526107,14.6608457,15.1142628,15615.4512223,18038.2111313,0.1430868,1193.4562339,1065.1125808,1814.6659136,27.92972,34.8285914,2.2513176,120.1071895),(52166,'hindlimb',41,7,246,293.5872413,98.3750512,118.5527457,1.8,98.4854995,118.5329262,-0.0360374,14.4031292,14.949459,14998.1920178,17509.2338764,0.0635192,1171.2285938,1041.3148257,1770.0468655,27.7079926,34.4956781,2.2591551,119.2478135),(52167,'hindlimb',41,7,247,269.840014,98.2739086,118.4563017,1.8,98.4439452,118.3253975,-0.0133176,13.9934348,14.6507854,13536.6449449,16398.2465666,0.0079759,1119.274232,967.3568483,1672.3393101,27.070344,33.7927143,2.2932148,116.0620149),(52168,'hindlimb',41,7,248,258.854647,98.1574835,118.420814,1.8,98.4286753,118.2102475,0.0558832,14.3102277,15.2209427,12679.2071813,15661.6445425,0.1345909,1028.9536516,886.0241398,1600.8235748,26.7440061,33.4715644,0.8398896,114.2390031),(52169,'hindlimb',41,7,249,241.5527472,98.1618891,118.5050449,1.8,98.4461102,118.1374398,0.0409455,13.9232436,14.7772871,11270.8712701,14378.3024645,0.0674576,973.0001415,809.5003998,1474.4884341,26.210968,32.8367109,0.8224183,110.5929796),(52170,'hindlimb',41,7,250,233.6301977,98.2409276,118.4560027,1.8,98.4129128,118.0894098,0.0570238,13.5618259,14.8361552,10485.1157112,13754.0264995,0.1264792,927.0613777,773.1345184,1406.4187674,25.7698543,32.5231526,0.8134282,109.7336036),(52171,'hindlimb',41,7,251,214.9641488,98.2539158,118.514752,1.8,98.2942675,117.9738584,-0.0450748,13.1404818,14.4309706,8968.0844353,12167.4157587,0.0727424,843.1460452,682.4775962,1253.3956966,25.0145952,31.9041532,0.7758746,106.148654),(52172,'hindlimb',41,7,252,205.3456724,98.1357851,118.3952667,1.8,98.2874098,117.9231593,-0.0858933,12.8949599,14.6199099,8147.7770015,11197.1196118,0.2518748,765.8815757,631.8574905,1166.4090288,24.1892574,31.3318873,0.7368926,105.0375726),(52173,'hindlimb',41,7,253,188.4103506,97.9644813,118.0931981,1.8,98.1244609,117.7849849,-0.1527137,12.5722745,14.5444285,6786.7695943,9620.085899,0.7266596,661.4275635,539.8203485,1017.4641615,23.2985519,30.4381711,0.72547,102.250925),(52174,'hindlimb',41,7,254,176.6191499,97.8795008,117.9273477,1.8,98.0081203,117.6373482,-0.1708313,12.4259145,14.1892046,5935.2871651,8657.3533906,0.8507316,610.1366231,477.6539527,923.6110202,22.733046,29.8316135,0.72425,101.391549),(52175,'hindlimb',41,7,255,157.6790626,97.7172376,117.761519,1.8,97.9336245,117.5326151,-0.202861,11.8828047,13.9326647,4683.8008991,7434.8294375,1.0667296,533.6258068,394.1662767,799.072597,21.4770378,28.6637647,0.7004964,97.7023396),(52176,'hindlimb',41,7,256,143.2650836,97.6976083,117.5167531,1.8,97.9284029,117.438219,-0.1823893,11.2030365,13.5078019,3893.9967655,6515.2169723,0.7855373,482.3299164,347.5840477,685.947269,20.6192463,27.85028,0.6651027,96.0878474),(52177,'hindlimb',41,7,257,124.0315437,97.5674255,117.3611448,1.8,97.8449573,117.3712457,-0.1666135,10.1701557,12.7572168,2836.0279074,5378.7058545,0.5685637,421.6206364,278.8578643,549.114855,18.906272,26.8271256,2.5846911,92.797789),(52178,'hindlimb',41,7,258,110.1136087,97.5396467,117.2951155,1.8,97.7080111,117.3496114,-0.1654442,9.5991649,12.295182,2153.267912,4557.2967447,0.497768,370.6571188,224.3182534,459.0215791,18.0446515,26.1015566,2.5672878,89.4645448),(52179,'hindlimb',41,7,259,91.0561964,97.3401831,117.343189,1.8,97.2781728,117.3160244,-0.1728385,8.8050757,11.4879828,1300.9512846,3431.3783968,0.4488596,298.6928566,147.7501537,380.0083388,16.3115227,23.7264049,0.6181442,79.446924),(52180,'hindlimb',41,7,260,68.5119291,97.1654154,117.5089449,1.8,96.8843279,117.3420517,-0.1612157,8.030902,10.6737553,783.9393248,2658.4852451,0.2942144,249.0674727,97.6153517,302.6491793,9.4197285,15.1125613,1.3120254,40.5307081),(52181,'hindlimb',41,7,261,35.2253373,95.6007709,117.5885484,1.8,95.6833753,117.4483221,-0.2148241,6.6955118,10.4803376,227.9184649,1250.5943868,0.2667956,119.3276809,34.0404844,140.8105927,7.1191067,12.4015431,1.3258177,31.8758741),(52182,'hindlimb',41,7,262,15.2384998,92.1460397,118.1188906,1.8,93.1430055,117.7619025,-0.414668,5.2748201,12.4219734,73.4413974,131.0957448,0.4122451,10.5535361,13.9230146,15.9699462,5.4610753,10.1136544,1.3567356,25.9034279),(52183,'hindlimb',41,7,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52184,'hindlimb',41,7,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52185,'hindlimb',41,7,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52186,'hindlimb',41,7,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52187,'hindlimb',41,7,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52188,'hindlimb',41,7,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52189,'hindlimb',41,7,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52190,'hindlimb',41,7,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52191,'hindlimb',41,7,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52192,'hindlimb',41,7,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52193,'hindlimb',41,7,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52194,'hindlimb',41,7,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52195,'hindlimb',41,7,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52196,'hindlimb',41,7,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52197,'hindlimb',41,7,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52198,'hindlimb',41,7,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52199,'hindlimb',41,7,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52200,'hindlimb',41,7,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52201,'hindlimb',41,7,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52202,'hindlimb',41,7,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52203,'hindlimb',41,7,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52204,'hindlimb',41,7,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52205,'hindlimb',41,7,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52206,'hindlimb',41,7,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52207,'hindlimb',41,7,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52208,'hindlimb',41,7,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52209,'hindlimb',41,7,289,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52210,'hindlimb',41,7,290,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52211,'hindlimb',41,7,291,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52212,'hindlimb',41,7,292,1.499266,95.8510026,116.9570264,1.8,95.8084882,116.8452966,1.5036745,1.7975385,6.543383,0.8445129,19.340731,0.2487536,2.9557694,0.4698163,3.0848165,2.3273342,6.1070139,2.2565258,13.411939),(52213,'hindlimb',41,7,293,8.9633692,95.5947121,115.8784206,1.8,95.4422986,116.0673226,-1.3392594,10.9787404,6.2900482,31.7179631,78.6578573,1.4152291,12.5051279,2.8890348,10.0363984,4.726568,13.0684503,1.735945,36.3812737),(52214,'hindlimb',41,7,294,20.9369638,94.8695231,116.0279727,1.8,95.1212908,115.7842982,-0.1985008,6.4119871,11.0422237,183.5396456,409.1412104,0.1356986,37.0524291,28.6244564,48.6423303,3.007816,7.5041783,1.801887,18.0647842),(52215,'hindlimb',41,7,295,40.8822871,94.8926813,116.1222955,1.8,94.9824559,116.0501656,-0.1531318,6.7338319,11.2219237,429.9563417,1005.3167965,0.1585322,89.585068,63.8501741,118.265582,4.29688,11.3765933,1.7607846,28.7943353),(52216,'hindlimb',41,7,296,63.8000142,94.660339,116.40076,1.8,94.8125609,116.3540713,-0.092884,7.8572246,11.6874188,731.1381372,1660.6437496,0.0914749,142.0881526,93.0529763,194.6519434,14.5106044,17.2839294,0.6086893,75.3406754),(52217,'hindlimb',41,7,297,93.6691277,94.8431062,116.7493061,1.8,95.2194387,116.5123159,0.0688497,9.5498058,12.3064415,1072.7501739,2455.3581343,0.0738861,199.5181252,112.332145,283.4625877,15.8256937,22.0191518,2.8445284,79.6375554),(52218,'hindlimb',41,7,298,105.3603475,95.4404113,116.880677,1.8,95.4859296,116.5970805,0.1036503,10.1858164,11.8449904,1176.0045924,2849.4434878,0.1879799,240.561064,115.455114,334.0364565,16.328144,22.5575969,2.8318897,65.0102753),(52219,'hindlimb',41,7,299,120.4861101,96.2516612,117.0672828,1.8,96.2314299,116.5687498,0.0031229,10.0843101,11.1790775,1349.8041963,3548.4791353,0.0001959,317.4214624,133.8519131,376.9779593,16.2064365,23.8350997,0.4878364,78.6307338),(52220,'hindlimb',41,7,300,134.3880437,96.6340257,116.9803118,1.8,96.5474422,116.4473479,-0.1304673,9.617652,12.0304302,1569.2203043,4365.497214,0.3790944,362.871248,163.1604365,449.1889227,16.1538605,24.6237844,0.5104883,77.4153926),(52221,'hindlimb',41,7,301,150.3351938,97.1257483,116.1906793,1.8,97.5305477,115.5829083,-0.3772349,8.4144533,13.1263642,2119.67291,6266.1158664,3.3996453,477.3687359,251.9085724,607.3744842,16.795858,25.8742116,0.6202495,83.1793192),(52222,'hindlimb',41,7,302,152.2762333,97.6510723,115.6504268,1.8,97.8670654,115.4485142,-0.4732998,8.9859847,13.2031593,2240.830973,6748.3961072,5.2732547,511.1197957,249.3695526,670.7232217,16.7959704,26.2356106,0.551655,85.2108506),(52223,'hindlimb',41,7,303,125.852125,98.4549952,115.9897987,1.8,98.044584,115.7007163,-0.5187661,8.8500214,12.8887109,1688.272861,4724.6603211,5.1562977,366.5735362,190.7648329,488.4777542,16.0835959,26.1686695,0.5150728,93.7182389),(52224,'hindlimb',41,7,304,119.1032181,99.0084252,116.1161629,1.8,98.6311795,115.7856959,-0.533147,8.9681991,13.1044839,1376.3324253,3907.5663786,5.1276723,298.185445,153.4680948,382.6131523,15.5708336,26.4109609,0.3835275,85.3151104),(52225,'hindlimb',41,7,305,128.4492786,99.4428448,116.0127115,1.8,99.0214231,115.9952223,-0.4573882,7.5213876,14.7929558,1391.0253008,4099.4735049,4.1749462,277.1233527,184.9426425,361.4760753,15.0739401,26.6337246,0.3115468,89.6730643),(52226,'hindlimb',41,7,306,144.0690151,99.6647833,116.1088189,1.8,98.9902938,116.1992982,-0.3808646,7.337517,15.502895,1465.121318,5269.9908251,3.317866,339.9359168,199.6753562,431.9156555,14.4325139,26.9164465,0.2914568,90.4281806),(52227,'hindlimb',41,7,307,134.2980217,98.4138852,116.7310956,1.8,98.0054851,116.6581558,-0.3280844,7.2248509,14.5919748,1309.8202486,6091.9334241,2.3240781,417.4851927,181.2937409,505.5878738,14.2345508,27.5134565,0.2525543,87.7026069),(52228,'hindlimb',41,7,308,147.2148608,97.4201639,116.6644231,1.8,97.219316,116.5994337,-0.2993488,7.4732563,13.9435169,1408.5650081,6789.8115929,2.1337535,486.9511506,188.4807568,587.7113883,15.0171271,27.2098039,0.2717922,83.9523236),(52229,'hindlimb',41,7,309,166.2617547,96.8180149,116.5684147,1.8,96.7524346,116.5800747,-0.2948717,8.9968618,13.6430143,1632.9879208,7842.226065,2.3403635,574.8162313,181.5063919,689.9817575,16.2822701,27.3418007,0.5269432,82.884428),(52230,'hindlimb',41,7,310,176.0905994,96.519937,116.6606506,1.8,96.2880914,116.9620169,-0.3171374,9.6624346,13.5027789,1967.9870821,8264.6207159,2.8541108,612.0681346,203.6740381,740.0354384,16.8887028,27.7140433,0.5191461,92.5460836),(52231,'hindlimb',41,7,311,193.0280473,95.929991,117.3351902,1.8,95.8789545,117.3837937,-0.4511346,9.1204465,14.1263189,2660.6043725,9718.5255398,6.1152766,687.9729683,291.7186538,874.8099627,17.4299624,27.92972,0.5325041,85.401482),(52232,'hindlimb',41,7,312,198.8744964,95.7072573,117.7447646,1.8,95.7883406,117.5344493,-0.4932721,9.2989643,14.53884,2863.7643624,10526.3366393,7.431679,724.0148918,307.96595,920.4678928,17.401014,28.0122304,0.5667292,91.3307424),(52233,'hindlimb',41,7,313,215.4996369,95.5438017,117.7589663,1.8,95.7430128,117.2693719,-0.5044418,9.4760808,14.6933545,3105.5424144,10903.4343543,8.3900155,742.0656974,327.7243488,953.2734575,17.9913428,28.2713807,0.817645,93.5529052),(52234,'hindlimb',41,7,314,223.9045789,95.4777235,117.3633161,1.8,95.7753333,116.8039634,-0.5345936,16.1976286,14.6178998,3513.8683935,10368.3531543,9.6869138,709.2915762,216.9372118,795.5097669,17.9021116,28.3366124,0.8605253,84.0997692),(52235,'hindlimb',41,7,315,234.1048132,94.8813528,116.6330039,1.8,95.4916906,115.9964104,-0.7139495,21.716487,14.6220845,4881.905452,8662.509282,16.7304678,592.4264285,224.8018042,579.076639,21.6109075,28.5863647,0.8279257,94.056316),(52236,'hindlimb',41,7,316,243.9548626,94.4017355,115.8036862,1.8,94.9484571,115.0044943,-1.5149215,13.0357849,20.9344163,6428.1478687,9149.6503409,40.532338,437.0625957,493.1155226,670.7097346,22.199825,28.2974914,0.8391099,92.6324552),(52237,'hindlimb',41,7,317,252.2787345,93.6036439,114.4243926,1.8,94.0834314,113.8323432,1.260102,13.5747679,21.9410667,4837.9627229,14014.6761192,38.1166003,638.7417855,356.3937715,849.8935071,21.949306,36.8255401,1.7704802,122.6242436),(52238,'hindlimb',41,7,318,266.4919125,93.7491386,113.6162427,1.8,93.961974,113.3810705,1.1582418,12.4010388,21.821682,4870.9054237,17033.0783656,37.2750438,780.5575367,392.7820496,998.433531,21.7051283,37.5208915,2.0856811,113.76089),(52239,'hindlimb',41,7,319,272.6003709,93.7026198,112.8153708,1.8,93.6108517,112.8552013,1.0707296,12.3682285,21.6226046,4493.0747796,20033.1553726,34.9880306,926.4913152,363.2755315,1131.776205,21.7518417,39.0259853,2.063992,114.0736694),(52240,'hindlimb',41,7,320,265.7399576,93.4902036,112.3093605,1.8,93.2943155,112.619028,1.0435676,12.560557,21.3257851,4156.0423849,21159.4004834,33.0779726,992.1979592,330.8804199,1184.8969148,21.4803053,40.1844438,2.0009636,114.5338944),(52241,'hindlimb',41,7,321,245.7563092,93.1504058,111.9246515,1.8,92.888146,112.3189676,1.0397289,12.861284,21.2620218,4001.0257267,21047.1963401,30.4534801,989.8962816,311.0906904,1173.6079598,21.7580192,41.898436,2.0160974,116.8171311),(52242,'hindlimb',41,7,322,233.3709858,92.7013183,111.5842172,1.8,92.4674687,112.1470055,1.0473199,12.5840355,21.1575718,4125.8084468,20747.8317742,29.1754933,980.6338842,327.8605221,1167.2341526,21.7920109,42.4717843,2.0208701,118.6401429),(52243,'hindlimb',41,7,323,213.684147,91.6709247,110.9848219,1.8,91.7467073,111.8557626,1.0674209,11.8017843,20.2873587,4102.2555655,19297.7898172,27.3268086,951.2223916,347.5962169,1143.1181964,21.8313566,42.2866263,2.0117206,116.6696855),(52244,'hindlimb',41,7,324,198.3857258,90.7658714,110.4529879,1.8,91.1316117,111.5801536,1.1008262,10.9042351,19.3007887,3723.9581855,18281.9289286,26.2834013,947.2114965,341.5148484,1127.9997336,21.4841098,41.6996652,2.0298357,114.8898596),(52245,'hindlimb',41,7,325,194.3843635,89.9254007,110.2212986,1.8,90.325061,111.3547972,1.141913,10.5881978,18.7862706,3431.1505117,17737.915727,26.7947251,944.1956892,324.0542518,1109.2942572,20.6796521,41.1290207,2.1327179,127.0864573),(52246,'hindlimb',41,7,326,196.9483394,89.6366692,110.5341307,1.8,89.9626366,111.1172094,1.1694592,10.5029429,18.8619406,3203.0979917,17456.8434484,27.8154386,925.506223,304.9714744,1077.1205773,19.9885769,40.5366848,2.1293956,120.4631547),(52247,'hindlimb',41,7,327,201.4458017,89.3828694,110.8136738,1.8,89.454317,110.6296532,1.1958027,9.7675318,18.9308281,2577.7744772,17693.3724593,29.0702666,934.6327802,263.9125746,1051.5445831,18.6575144,39.2923774,1.8025132,119.7080385),(52248,'hindlimb',41,7,328,175.3001516,88.9351752,109.9113746,1.8,89.1115261,110.1461224,1.1959287,9.1405567,17.7694763,2040.5315046,15904.232799,25.2997461,895.0310374,223.2393039,994.3061676,17.5332237,39.0732667,1.7142486,126.0364499),(52249,'hindlimb',41,7,329,150.8162435,88.7450202,108.775188,1.8,88.7658059,109.285484,1.1615131,8.3778399,16.8057336,1721.7831235,13843.2305257,21.1553539,823.7206931,205.516355,848.5209629,12.9152022,37.934418,1.7415315,93.2833116),(52250,'hindlimb',41,7,330,143.5756566,88.8408919,108.5493324,1.8,88.8479461,109.6379934,1.1504107,9.5464464,21.3083845,1651.9679372,13713.9165098,19.9437155,643.5925039,173.0453267,720.4131534,13.2364332,37.3729768,1.7208233,97.6412656),(52251,'hindlimb',41,7,331,158.168225,89.9450898,111.2710036,1.8,89.9336359,112.1127085,1.1786601,9.800889,19.3214301,1875.8666729,19876.0774989,22.5113228,1028.7063303,191.3976047,1103.0111682,19.3351932,42.450043,1.943784,130.5418495),(52252,'hindlimb',41,7,332,176.8158666,91.3340318,113.8472592,1.8,90.6476879,113.0913493,1.166236,10.326342,21.910326,2237.7662703,25094.822919,24.9035578,1145.3422888,216.7046438,1241.7963693,19.2637669,42.6084999,1.9531754,123.2929881),(52253,'hindlimb',41,7,333,179.3904169,91.6893471,115.1692299,1.8,90.8621478,113.9768874,1.1788728,10.0864083,22.911267,2597.1247841,24741.5139393,25.536267,1079.8841454,257.4875728,1191.0066734,19.0551064,41.8940291,1.9379702,121.2182709),(52254,'hindlimb',41,7,334,168.9466924,91.6897001,115.9365813,1.8,91.0327962,114.7743474,1.1999323,10.0171772,23.4362099,2718.0568858,22794.7796682,24.4592882,972.6308051,271.3396019,1087.1652889,19.3076178,41.4153258,1.9647894,135.4895859),(52255,'hindlimb',41,7,335,158.1427681,91.9111201,118.3402432,1.8,91.48983,117.0589103,1.2490704,9.6073337,25.291344,3069.7050387,18879.789394,23.7218053,746.4921355,319.5168546,867.6342839,19.2194917,40.5503466,1.8389071,113.2321815),(52256,'hindlimb',41,7,336,150.3250111,92.5187994,120.6969771,1.8,92.0588496,118.7182714,1.2523942,9.919953,27.3142319,3299.0744704,12602.0229506,22.5988614,461.3720429,332.569568,581.9541345,18.8377885,28.2452458,2.1503603,91.2264826),(52257,'hindlimb',41,7,337,132.5018342,93.5726121,122.9264803,1.8,93.0547557,121.6259739,0.5774899,9.5258089,14.7519866,2625.2887367,3946.4018018,6.5816202,267.5166347,275.5974601,384.3780094,18.8289607,26.9849538,2.2206668,76.746648),(52258,'hindlimb',41,7,338,128.7058049,93.8641059,122.9919545,1.8,93.1744206,121.8581536,0.5190904,9.4799928,14.3400543,2440.3662723,3740.7745991,5.2792092,260.8619551,257.4227993,369.9023799,18.833412,26.5190958,2.2759077,74.4202254),(52259,'hindlimb',41,7,339,120.8261123,93.762166,123.1948908,1.8,93.3166075,122.4811561,0.2765781,11.5007324,11.7782541,2195.9869076,2936.1857818,1.5015608,249.28871,190.9432226,314.8800195,18.698729,22.5166352,2.302193,71.0869812),(52260,'hindlimb',41,7,340,123.5678942,94.0150682,123.5205824,1.8,93.4364848,122.864836,0.2345689,10.0820194,10.1308035,2114.3147375,3076.4722092,1.1125393,303.6750455,209.7114341,416.9016515,18.5595784,21.6257322,2.285888,70.0801596),(52261,'hindlimb',41,7,341,126.0548283,94.0435852,123.7688318,1.8,93.5972158,123.1336882,0.2284032,9.618952,10.1355964,2121.5859881,2866.2795759,1.0770781,282.7933798,220.5631109,431.2657756,18.2142907,20.8032903,2.4733032,68.8648184),(52262,'hindlimb',41,7,342,134.2892377,94.1460163,123.9885725,1.8,93.7296251,123.278227,0.2418488,9.4099788,10.004048,2182.2662742,2812.4979824,1.2837901,281.135994,231.909796,443.8739096,18.1579859,20.7677594,2.7149652,64.6111242),(52263,'hindlimb',41,7,343,150.8959709,94.2801339,124.4499661,1.8,93.8204161,123.3721777,-0.0487523,10.7672291,9.5232296,2189.2978619,2857.019219,0.0597273,300.0052858,203.3297364,445.4102064,17.8951111,20.8254663,2.7610863,64.1077134),(52264,'hindlimb',41,7,344,150.0320061,94.2293779,124.5614413,1.8,93.8409555,123.3708076,-0.1011534,10.6587642,9.7038727,2018.9392512,3025.9748139,0.2549834,311.8316676,189.4158841,451.3472012,17.4311177,20.9271731,2.8068558,62.996632),(52265,'hindlimb',41,7,345,121.5613384,94.4207124,123.92732,1.8,93.8973358,123.2147314,-0.0264549,9.33087,10.5663157,1699.6536237,3061.8414119,0.014176,289.7737975,182.1538207,433.5416035,16.7459216,21.072243,2.7875952,61.7812908),(52266,'hindlimb',41,7,346,133.4422254,94.2854597,123.9200477,1.8,93.8780426,123.2258927,0.0275134,9.1020717,10.5797459,1741.4190458,3360.1825143,0.0168314,317.6052192,191.321175,465.1869272,16.6040837,21.1989091,2.8326619,61.5295854),(52267,'hindlimb',41,7,347,153.781262,94.1900805,124.0219414,1.8,93.7340465,123.145351,0.1247823,9.6368363,10.7282277,1978.7706004,3413.2330357,0.3970115,318.1544179,205.3340474,491.6097051,16.9899507,20.9536242,2.8717435,62.4932212),(52268,'hindlimb',41,7,348,150.3680359,94.1627349,123.9682123,1.8,93.7110177,123.0062824,0.1634575,9.9607363,10.5460604,2005.58308,3277.1098773,0.6636554,310.7425656,201.348879,476.0668903,17.2614394,20.6697347,2.7803889,62.996632),(52269,'hindlimb',41,7,349,141.5801228,93.9824822,123.5588582,1.8,93.7195544,122.4013838,0.2726755,12.4761048,10.5085788,2091.411741,3158.8647903,1.711406,300.5986679,167.63339,420.2557507,18.1451111,20.9888404,1.1712808,68.5088532),(52270,'hindlimb',41,7,350,138.0606495,93.9761661,123.2592072,1.8,93.7645565,122.2614015,0.3223423,12.0746769,10.4604586,2111.9178681,3105.6833813,2.3091874,296.8974414,174.9047105,431.997919,17.8730474,20.6697347,1.2095926,67.0418066),(52271,'hindlimb',41,7,351,137.4529312,93.9321052,122.9805715,1.8,93.7961016,122.1923214,0.4295676,11.1711809,10.0881195,2074.6082182,3024.3093493,3.97362,299.7892067,185.7107344,451.6951763,17.4831373,20.1404075,2.5535901,64.8628297),(52272,'hindlimb',41,7,352,133.6650144,93.880158,122.986529,1.8,93.7951908,122.3317299,0.4667526,9.7843162,10.0304221,1935.8260813,3005.0138229,4.5109662,299.5899678,197.8499101,481.8880401,16.4071061,20.0439205,2.6011732,66.7901012),(52273,'hindlimb',41,7,353,125.596326,93.8350866,122.9235586,1.8,93.8006077,122.3328097,0.6050726,8.6866902,9.9094031,1767.9439806,2994.965802,6.7729536,302.2347322,203.5233153,458.1611678,15.8881158,19.9052705,2.5715522,63.1008918),(52274,'hindlimb',41,7,354,119.230614,93.8597058,122.8987937,1.8,93.7632611,122.242087,0.7037681,8.5315977,9.7588156,1648.9258183,2946.8350378,8.3209477,301.9664625,193.2728043,453.8288454,15.4956002,20.0300987,2.1885521,61.27788),(52275,'hindlimb',41,7,355,111.394114,93.8634332,122.956335,1.8,93.7119894,122.0369483,0.7905908,8.3889206,10.2219022,1431.814674,2899.1022635,9.3792454,283.6167095,170.6792499,399.9595814,15.280962,20.3818914,2.176341,61.27788),(52276,'hindlimb',41,7,356,111.4989065,93.8447119,122.9428446,1.8,93.6794245,121.8669573,0.8379197,8.8817004,10.6299236,1402.8103647,2947.8501737,10.2657972,277.3162146,157.9438969,347.1681412,15.3136782,21.4886965,1.7721134,83.0929476),(52277,'hindlimb',41,7,357,108.0945204,93.80677,122.8030773,1.8,93.6465038,121.7812232,0.8728253,8.3900316,11.1810291,1340.7561281,3012.8067272,10.5749284,269.457014,159.8034655,363.8419567,15.0931569,21.4543008,2.1421338,84.8116996),(52278,'hindlimb',41,7,358,106.4085525,93.7807159,122.7462433,1.8,93.5972728,121.7531028,0.8833937,8.5142432,11.6854542,1293.1265412,3067.9672761,10.5942008,262.5458304,151.8780358,366.1579403,13.888917,19.5967879,2.4805495,58.4480466),(52279,'hindlimb',41,7,359,105.5521408,93.8081603,122.7756539,1.8,93.5765433,121.8044643,0.8938013,8.3635432,12.3406323,1219.2133925,3152.6224869,10.6881378,255.4668521,145.7771383,353.2762024,13.5480226,19.6813991,2.5111912,56.981),(52280,'hindlimb',41,7,360,102.6044105,93.7833843,122.7101517,1.8,93.5443414,121.7870596,0.8930773,8.2826657,12.6734352,1176.3776003,3212.4213933,10.3775588,253.4767678,142.0288643,342.9182126,13.3280992,19.6813991,2.5111912,56.7292946),(52281,'hindlimb',41,7,361,100.6300814,93.8413137,122.7079373,1.8,93.5526501,121.7373498,0.8899155,8.2649819,13.3068305,1120.7728534,3285.6727524,10.1260341,246.9162551,135.6049986,328.4275414,13.2535348,19.6813991,2.5111912,55.4096937),(52282,'hindlimb',41,7,362,99.2262085,93.883584,122.7507684,1.8,93.515336,121.7062818,0.8882512,8.211951,13.6972824,1092.584298,3312.9512887,9.9578333,241.8692412,133.0480779,318.2554319,13.2019353,19.4312116,2.5290551,54.8020231),(52283,'hindlimb',41,7,363,96.8376328,93.9832757,122.9352666,1.8,93.6034168,121.9376834,0.8461027,8.8745368,14.1267047,1000.3659066,3201.9659914,9.0471453,226.6605022,112.7231684,291.3588419,13.1118932,19.4312116,2.5290551,54.8020231),(52284,'hindlimb',41,7,364,95.2209298,94.0802704,123.0842876,1.8,93.6818781,122.1449389,0.8276503,9.1079981,14.5367031,960.1315249,3119.6102402,8.6048279,214.6023215,105.4163073,275.2903871,12.8593289,19.1873855,2.5473789,54.1943525),(52285,'hindlimb',41,7,365,93.2231021,94.2803501,123.2986964,1.8,93.8786205,122.2988607,0.8002021,9.7156893,14.7633091,919.2021283,2933.4235081,7.9985705,198.6968838,94.6100784,248.2908603,12.7642683,19.0860812,2.5973122,53.9426471),(52286,'hindlimb',41,7,366,92.2242442,94.4021756,123.452609,1.8,94.008326,122.4729335,0.7801138,10.2738438,14.8711831,900.1671363,2812.8428006,7.604131,189.1472104,87.6173662,236.0305563,12.7642683,19.0812438,2.5161076,53.5866819),(52287,'hindlimb',41,7,367,90.8969095,94.607975,123.6481797,1.8,94.2371774,122.6842357,0.7423666,10.7428684,14.982239,865.5871022,2633.5309624,6.9236407,175.7768619,80.573183,214.3384114,12.7031765,19.0860812,2.5973122,52.8315657),(52288,'hindlimb',41,7,368,89.7675226,94.7298384,123.8036671,1.8,94.3572179,122.8088491,0.7081434,11.4755015,15.0037326,840.3210486,2487.2162719,6.3293917,165.773167,73.2273922,201.7486839,12.6414682,18.9501664,2.566168,52.4756005),(52289,'hindlimb',41,7,369,87.1195112,95.0242988,124.2271519,1.8,94.7041044,123.4155197,0.5439406,13.6799264,13.889598,682.0069333,2079.0271332,3.8887037,149.6823112,49.8545761,162.8922398,12.567213,18.867169,2.6167969,53.0832711),(52290,'hindlimb',41,7,370,85.9137538,95.1768915,124.4968603,1.8,95.0562176,124.0612974,0.4140666,15.4198009,11.883176,542.1786637,1871.7722616,2.3178657,157.5144772,35.1611975,137.0696282,12.567213,18.6753695,2.739722,53.7952014),(52291,'hindlimb',41,7,371,85.4530696,95.3207332,124.572741,1.8,95.2212897,124.2324587,0.3963902,15.5806882,9.9685609,531.4237301,1829.632923,2.1230276,183.5403261,34.1078472,133.3714526,12.567213,18.5911454,2.5535901,54.7588372),(52292,'hindlimb',41,7,372,85.0871629,95.3972972,124.6089357,1.8,95.295379,124.2123929,0.3883146,15.651786,9.9844139,531.3014977,1814.7109761,2.0330155,181.7543819,33.9451036,132.1850396,12.5203181,18.6555863,2.6367313,54.7588372),(52293,'hindlimb',41,7,373,84.7761983,95.5006331,124.6183344,1.8,95.3982642,124.1172898,0.3871094,15.8671105,9.9207595,551.5815373,1793.3804581,2.0136652,180.7704796,34.7625699,128.8695967,12.5710938,18.4965587,2.6051572,54.7588372),(52294,'hindlimb',41,7,374,84.3371103,95.5792062,124.6401821,1.8,95.4335313,124.08441,0.3857469,15.7082409,10.0015775,568.0659597,1775.3956977,1.989864,177.5115668,36.163563,128.1418062,12.5710938,18.5115256,2.7610863,55.8699186),(52295,'hindlimb',41,7,375,83.5513623,95.7110253,124.7164488,1.8,95.593611,124.4156218,0.3455297,15.322909,9.9919688,501.1362928,1718.2329919,1.5974237,171.9614054,32.705036,130.6465894,12.5290327,18.5115256,2.7610863,55.0105426),(52296,'hindlimb',41,7,376,83.3122361,95.7700861,124.7452817,1.8,95.6563613,124.4652891,0.3369525,15.5340708,9.9133527,496.8500188,1700.1608954,1.5177357,171.5021086,31.9845342,129.4203206,12.5678203,18.3562794,2.782822,56.3733294),(52297,'hindlimb',41,7,377,82.9806263,95.8772792,124.7698878,1.8,95.8095458,124.5243076,0.3217291,15.216898,9.8879378,482.5080564,1672.7451723,1.3828325,169.1702762,31.7087002,130.2791072,12.5678203,18.280687,2.7305281,56.6250348),(52298,'hindlimb',41,7,378,82.83169,95.9337731,124.7889526,1.8,95.877756,124.5280483,0.3125268,7.4705523,9.8062858,478.1690787,1661.055034,1.3050699,169.3867653,64.0071927,217.6959022,12.6235746,18.209851,2.8049178,56.7292946),(52299,'hindlimb',41,7,379,82.3940567,96.0374562,124.7889282,1.8,95.9564012,124.524912,0.3012674,15.4446681,9.7700473,478.4834821,1632.0131725,1.2091211,167.0425044,30.9804963,127.5794265,12.6235746,18.1132733,2.7522759,57.5886706),(52300,'hindlimb',41,7,380,82.1364114,96.0920932,124.8029879,1.8,96.0090972,124.5590043,0.2913808,7.3096758,9.8229596,472.2729011,1621.4108137,1.129745,165.0633695,64.6092811,212.9687781,12.4509868,18.1132733,2.7522759,57.5886706),(52301,'hindlimb',41,7,381,81.6552498,96.1722625,124.8037031,1.8,96.1253242,124.5972256,0.2771886,7.2909948,9.5979532,467.1996207,1597.523511,1.0191364,166.444187,64.0789953,213.8571884,12.4385123,17.9545839,2.7744188,56.7292946),(52302,'hindlimb',41,7,382,81.1080124,96.2084467,124.8078522,1.8,96.1498102,124.6008519,0.2677628,7.287045,9.6236687,463.8938892,1584.5860337,0.9462562,164.6550894,63.6600833,211.4063622,12.4385123,17.9545839,2.7744188,55.8699186),(52303,'hindlimb',41,7,383,80.2159053,96.2795047,124.7914888,1.8,96.2282211,124.553229,0.2530892,7.2551751,9.5631582,457.834641,1558.6179215,0.8382314,162.9815051,63.1045613,210.0828751,12.3031801,17.8048522,2.7969453,58.1963412),(52304,'hindlimb',41,7,384,79.8270596,96.3186609,124.7960171,1.8,96.272563,124.5596288,0.2422157,7.3542428,9.5927611,456.5984694,1556.5370868,0.7654093,162.2616328,62.0864011,208.9006886,12.4949059,17.8255796,2.8732264,59.159977),(52305,'hindlimb',41,7,385,78.9398199,96.3787281,124.7923281,1.8,96.3085345,124.5592641,0.2304515,7.3325936,9.5407594,448.248091,1541.7011561,0.6864395,161.5910319,61.1309064,208.1657068,12.493815,17.8255796,2.8732264,58.5523064),(52306,'hindlimb',41,7,386,78.4234664,96.4194695,124.7944907,1.8,96.345738,124.561707,0.2205255,7.3219139,9.5745869,446.1023559,1538.5778664,0.6254042,160.6939165,60.9270149,206.7572806,12.493815,17.8255796,2.8732264,60.1667986),(52307,'hindlimb',41,7,387,77.6069464,96.4782808,124.7715297,1.8,96.3724273,124.4992461,0.2054573,7.2807775,9.6160636,441.7736544,1522.7677571,0.53836,158.3566641,60.6767139,203.6031801,12.460952,17.8255796,2.8732264,59.559128),(52308,'hindlimb',41,7,388,77.0303357,96.5132326,124.7682065,1.8,96.4094203,124.5003526,0.1944072,7.5209868,9.5573336,441.102506,1518.9185184,0.4791339,158.9270167,58.649552,204.8331655,12.4478166,17.7164901,2.896614,60.7744692),(52309,'hindlimb',41,7,389,76.1472923,96.5709128,124.7487396,1.8,96.5054986,124.495873,0.1789084,7.5738729,9.3323037,438.4570891,1502.4049002,0.4019077,160.9897137,57.8907377,205.3009389,12.7053591,17.6643059,2.8198421,62.137256),(52310,'hindlimb',41,7,390,75.5193204,96.6007304,124.7412356,1.8,96.5617326,124.5082272,0.1682729,7.5605108,9.3438518,436.0416925,1499.5760819,0.3530466,160.4879987,57.6735757,204.1925371,12.7053591,17.6643059,2.8198421,64.1077134),(52311,'hindlimb',41,7,391,74.7148854,96.6310687,124.7101224,1.8,96.6054931,124.4369987,0.1548578,7.5892986,9.2804869,433.8484019,1488.0976524,0.2962429,160.3469375,57.16581,205.2055342,6.0175679,8.107337,2.1293956,21.9625131),(52312,'hindlimb',41,7,392,74.050211,96.6507101,124.6972276,1.8,96.5959426,124.4320543,0.1438964,7.5666425,9.283681,432.0406357,1487.8670551,0.2537904,160.2669309,57.0980641,204.6568504,6.0175679,7.9926588,2.2035452,21.9625131),(52313,'hindlimb',41,7,393,73.0750755,96.6894741,124.6512524,1.8,96.6732698,124.3535357,0.1312879,7.563194,9.2983528,431.7182366,1483.9011592,0.2087232,159.5875298,57.0814705,203.6729674,6.0175679,7.7463106,2.1587989,21.3548425),(52314,'hindlimb',41,7,394,72.4114081,96.7070825,124.6292196,1.8,96.7192209,124.2941527,0.1199298,7.849349,9.2965301,433.2458491,1488.1775967,0.1727536,160.0788233,55.1951313,204.0555315,5.964993,7.7463106,2.1587989,21.3548425),(52315,'hindlimb',41,7,395,71.6626424,96.7300641,124.5824221,1.8,96.725343,124.2907192,0.1053298,7.8399886,9.2916279,435.6009972,1486.8590441,0.1320193,160.0213713,55.5614323,203.9637717,5.7728707,7.7463106,2.1587989,21.1031371),(52316,'hindlimb',41,7,396,71.2763144,96.7510837,124.5639423,1.8,96.7252035,124.2502403,0.0951702,7.8513975,9.5994835,437.5128783,1495.0713122,0.1072715,155.7449748,55.7242041,201.2008194,5.9329965,7.7463106,2.1587989,21.3548425),(52317,'hindlimb',41,7,397,70.3303283,96.7552301,124.5150578,1.8,96.6724946,124.228313,0.0811842,8.1414512,9.6289043,434.5388876,1502.3785928,0.0770867,156.0279903,53.37364,200.3842369,6.0175679,7.7463106,2.1587989,21.3548425),(52318,'hindlimb',41,7,398,69.944336,96.768806,124.490893,1.8,96.715053,124.1864835,0.0716254,8.1414479,9.6321875,438.0317849,1515.8428238,0.0597024,157.3726452,53.8026886,201.9430451,6.076706,7.5164702,2.1112158,21.1031371),(52319,'hindlimb',41,7,399,69.3741035,96.7870376,124.4276839,1.8,96.7469803,124.1026744,0.0577309,8.0867128,9.6331247,442.0306515,1528.5641624,0.0384929,158.6779176,54.6613515,203.5082055,5.9598642,7.5164702,2.1112158,21.1031371),(52320,'hindlimb',41,7,400,68.7737705,96.7944535,124.4024957,1.8,96.7421416,124.1081056,0.0486725,8.0674806,9.650915,443.6090508,1543.6272689,0.0271329,159.9462095,54.9873095,203.5524937,5.964993,7.5164702,2.1112158,21.1031371),(52321,'hindlimb',41,7,401,68.16622,96.8124413,124.3444995,1.8,96.781657,124.0536913,0.0347063,8.3936708,9.6453581,447.1732009,1559.4931695,0.0136792,161.6832831,53.2750463,205.4105333,6.076706,7.3926319,2.1910458,21.1031371),(52322,'hindlimb',41,7,402,67.8033347,96.8238218,124.3099673,1.8,96.8246008,124.0161734,0.0247717,8.3413103,9.6400087,450.369007,1582.7161258,0.006933,164.1820224,53.992597,208.0174268,6.076706,7.304696,2.0607537,20.8514317),(52323,'hindlimb',41,7,403,67.2880442,96.8191075,124.239816,1.8,96.7988946,123.9490862,0.0116354,8.2518752,10.0321499,450.8838782,1609.1166386,0.0015182,160.3959918,54.6401715,204.685745,6.076706,7.3425118,1.929567,20.8514317),(52324,'hindlimb',41,7,404,67.1136511,96.8189314,124.1993414,1.8,96.8503219,123.876682,0.0015997,8.6164727,10.024036,454.1510052,1642.574655,0.0000286,163.8636034,52.707299,207.4523068,6.076706,7.317323,2.2730533,21.1031371),(52325,'hindlimb',41,7,405,66.8844279,96.8232007,124.1218253,1.8,96.8382475,123.795127,-0.0125641,8.5206856,10.0315606,458.6762394,1683.2208968,0.0017596,167.792526,53.8309074,212.0371371,6.2761606,7.317323,2.2730533,21.3548425),(52326,'hindlimb',41,7,406,66.8565094,96.8337835,124.07632,1.8,96.8299239,123.76549,-0.022664,8.4623442,10.0463132,463.3748022,1718.7069121,0.0057226,171.0783718,54.7572623,214.6461559,6.076706,7.1514336,2.1421338,20.8514317),(52327,'hindlimb',41,7,407,66.7396318,96.825351,123.9921736,1.8,96.7885482,123.7269355,-0.0345441,8.761344,10.4583051,472.2318035,1763.4620288,0.0132681,168.6183388,53.8994709,213.3374437,6.076706,7.1514336,2.1421338,20.8514317),(52328,'hindlimb',41,7,408,66.7585426,96.8142903,123.9313594,1.8,96.802568,123.6071323,-0.043202,8.6983658,10.4665434,484.5636609,1809.7175548,0.0207536,172.9049869,55.7074362,218.5300421,6.076706,7.2920472,2.3561945,21.1031371),(52329,'hindlimb',41,7,409,66.3986225,96.8086709,123.8544513,1.8,96.773239,123.5994571,-0.0529667,8.6016978,10.4667146,485.8125732,1854.2903155,0.0310175,177.1606833,56.4786841,222.1488029,6.3805413,7.304696,2.6516353,21.1031371),(52330,'hindlimb',41,7,410,66.026002,96.8012589,123.8018958,1.8,96.7968073,123.4996028,-0.0613784,8.907419,10.8663845,491.4912612,1894.7080664,0.0414047,174.364165,55.1777413,219.4343171,6.3805413,7.2028834,2.8387078,21.1031371),(52331,'hindlimb',41,7,411,65.877905,96.8272674,123.7246601,1.8,96.8561843,123.4577174,-0.0713243,8.8018685,10.9250389,494.910254,1949.3731983,0.0557606,178.4316941,56.2278629,223.7215988,6.3805413,7.2028834,2.8387078,21.1031371),(52332,'hindlimb',41,7,412,65.787939,96.8271434,123.6694594,1.8,96.8250095,123.3884404,-0.0780727,8.7259375,10.929691,498.2564151,1995.255405,0.0666977,182.5536878,57.1006168,227.585302,6.3805413,7.304696,2.6516353,20.7471719),(52333,'hindlimb',41,7,413,65.2194969,96.8396526,123.581043,1.8,96.8665641,123.3171909,-0.0880719,8.9975502,11.3404891,503.6037345,2043.7403208,0.0840965,180.2162415,55.9712056,224.4840548,6.3805413,7.2028834,2.8387078,21.1031371),(52334,'hindlimb',41,7,414,65.2277214,96.8422282,123.510622,1.8,96.8269356,123.2052215,-0.0955438,8.9001465,11.3874555,513.5962154,2094.6250216,0.0989382,183.9414456,57.7064899,229.0432349,6.3805413,7.3425118,2.782822,21.1031371),(52335,'hindlimb',41,7,415,64.6797007,96.8092557,123.4066652,1.8,96.7825091,123.1644422,-0.1051699,9.0942645,11.7473788,517.6327633,2145.2225452,0.118795,182.6128693,56.9185956,226.5010133,6.44532,7.5041783,2.910502,21.7108077),(52336,'hindlimb',41,7,416,64.5420661,96.7914244,123.3379838,1.8,96.8204369,123.0463112,-0.113576,9.0327176,11.7331427,526.6580372,2200.5686015,0.1381644,187.5515081,58.3056019,232.2345648,6.44532,7.3425118,2.782822,21.6065479),(52337,'hindlimb',41,7,417,64.1869576,96.789243,123.2334004,1.8,96.8215056,122.9645594,-0.1229354,8.8872874,12.1124468,527.6636769,2263.1903574,0.1608646,186.8483226,59.3728607,229.667803,6.015632,7.5041783,2.7291822,21.3548425),(52338,'hindlimb',41,7,418,63.8225617,96.7821407,123.1610416,1.8,96.7906452,122.8803355,-0.1309676,9.0923588,12.1627399,531.4375417,2317.9556717,0.181412,190.5784136,58.4488086,234.0114049,6.015632,7.6140908,2.8555412,21.1031371),(52339,'hindlimb',41,7,419,63.3451486,96.8046652,123.0478444,1.8,96.7683616,122.7871181,-0.1403843,8.9319067,12.2550562,532.9401011,2379.3714693,0.2067017,194.1542688,59.6670025,237.6227224,6.015632,7.6140908,2.8555412,21.3548425),(52340,'hindlimb',41,7,420,62.7175125,96.7779438,122.9818201,1.8,96.7543849,122.7303775,-0.144992,8.8373893,12.5383249,527.4565691,2430.9088172,0.2182127,193.8782754,59.6846592,235.1160422,6.015632,7.6140908,2.8555412,21.3548425),(52341,'hindlimb',41,7,421,62.3895393,96.7975444,122.8489804,1.8,96.7932533,122.5817056,-0.1567557,8.9337901,12.6322338,534.014685,2498.2629237,0.2534237,197.7688951,59.7747067,239.7265115,6.015632,7.7463106,2.8023,21.6065479),(52342,'hindlimb',41,7,422,62.0610626,96.7889579,122.7768497,1.8,96.7323751,122.5337765,-0.1636918,8.815835,12.9846314,535.3575121,2553.0014045,0.2746877,196.6171639,60.726807,236.9067002,6.44532,7.8410702,2.976444,22.3184783),(52343,'hindlimb',41,7,423,61.8830328,96.807981,122.6583468,1.8,96.7402553,122.3941241,-0.1712883,8.6521335,13.0876435,535.4056457,2637.1059037,0.2996569,201.4958535,61.8813438,242.0392489,6.015632,7.9230552,2.9229237,22.2142185),(52344,'hindlimb',41,7,424,61.3180036,96.7826637,122.5791856,1.8,96.6895953,122.3167623,-0.1770358,8.8033032,13.4196082,533.8641293,2686.3624505,0.3169692,200.1818834,60.6436147,238.9926005,6.015632,8.0272343,2.8706458,22.2142185),(52345,'hindlimb',41,7,425,61.422908,96.7631507,122.4673141,1.8,96.6295106,122.2586492,-0.1827574,8.6462253,13.7580414,535.0950216,2791.0092382,0.3381339,202.8638501,61.8877029,239.9847303,6.015632,8.3430318,2.9340964,22.8218891),(52346,'hindlimb',41,7,426,61.8375463,96.7250412,122.3894027,1.8,96.5020197,122.2035185,-0.1862276,8.7992154,13.8086785,538.5125137,2893.0419081,0.3533155,209.5089634,61.2000601,247.547509,6.015632,8.4420297,2.8842689,23.3252999),(52347,'hindlimb',41,7,427,62.2842433,96.6185002,122.2576931,1.8,96.2883339,122.0677644,-0.1867769,8.6452833,14.1499922,544.7101503,3042.933346,0.3579456,215.0484122,63.0066284,252.7031239,6.44532,8.8582451,2.896614,24.0372303),(52348,'hindlimb',41,7,428,62.7646775,96.4967854,122.1779515,1.8,96.1635734,121.9773054,-0.185764,8.5532334,14.1256246,549.6197579,3179.1433197,0.3568502,225.0621415,64.2587116,263.7195173,6.44532,8.8582451,2.896614,24.5406411),(52349,'hindlimb',41,7,429,63.5352075,96.3159222,122.0262078,1.8,95.882882,121.8764036,-0.178529,8.7053959,14.325236,559.4850811,3382.1539313,0.333935,236.0976064,64.2687693,274.689261,6.875008,9.2756891,2.9078495,26.0076877),(52350,'hindlimb',41,7,430,64.8322177,96.1425499,121.9379783,1.8,95.6918559,121.7703086,-0.1746862,8.6259726,14.5214018,574.1599102,3594.1500926,0.3263884,247.5071026,66.5617594,286.136112,6.875008,9.6081158,2.9617392,26.6153583),(52351,'hindlimb',41,7,431,66.7067898,95.8617452,121.7880604,1.8,95.3822062,121.6262271,-0.1635226,8.7566672,14.5648359,599.4046826,3929.2505674,0.2946456,269.7765075,68.4512351,301.7240677,7.304696,10.0587382,2.7928217,27.9781451),(52352,'hindlimb',41,7,432,70.1781469,95.3983533,121.6343574,1.8,95.0282025,121.3749944,-0.1434152,8.8275539,14.5236919,644.1108519,4406.3973191,0.2389248,303.3937478,72.9659491,322.6218467,8.1866378,10.6125107,2.7686049,30.1571221),(52353,'hindlimb',41,7,433,75.3067701,94.7049515,121.4777198,1.8,94.8647553,121.1454024,-0.1238504,9.1251395,14.677982,682.3286411,5116.1862076,0.1915383,348.5619623,74.774598,346.8036981,8.59376,10.9549375,2.6954871,30.9122383),(52354,'hindlimb',41,7,434,80.6007786,94.2595201,121.3328698,1.8,94.7457488,120.8807021,-0.124158,8.9755623,15.9572697,732.8760819,5731.4829025,0.2060177,359.1769141,81.6523868,364.8746909,8.59376,10.8448348,2.5535901,32.2750251),(52355,'hindlimb',41,7,435,88.8030173,93.9161935,121.0559468,1.8,94.5047095,120.3720911,-0.1334012,10.1493804,17.2400682,880.247584,6619.4731892,0.2618291,383.9586419,86.7291946,398.5592519,9.023448,11.2048922,0.5667292,33.9505913),(52356,'hindlimb',41,7,436,92.137747,93.9719755,120.8755803,1.8,94.5230511,120.2125377,-0.1588435,9.5666901,17.4106786,987.07194,7143.317857,0.3842107,410.283712,103.1779984,430.1712507,9.023448,11.0889478,0.6202495,32.8826957),(52357,'hindlimb',41,7,437,92.3219871,94.3793376,120.6852843,1.8,94.7330896,119.9323237,-0.172465,9.9707533,17.4985801,1064.3231154,7209.1274605,0.4531537,411.9835671,106.7445041,439.6272282,9.023448,10.7422,0.6435011,32.1275795),(52358,'hindlimb',41,7,438,92.4931911,94.6065472,120.4771362,1.8,95.1193341,119.6377414,-0.1747563,10.2300606,17.329173,1158.6000215,7340.3929287,0.4660138,423.5858769,113.2544632,453.4331452,9.023448,10.3482574,0.7266423,31.3724633),(52359,'hindlimb',41,7,439,95.4613428,94.535059,119.8104043,1.8,94.7345375,119.1266006,-0.119427,9.6384712,18.1278616,1464.19843,7839.5305209,0.2258476,432.4575443,151.9118961,479.2029682,9.7842272,15.4029813,1.9720251,51.1559995),(52360,'hindlimb',41,7,440,99.7624239,94.406512,119.3617745,1.8,94.5690458,118.9545442,-0.0942177,9.4598458,18.1163122,1649.2839283,8443.4097835,0.1471617,466.0666978,174.3457523,512.8029836,9.8936139,15.3729852,2.0344439,46.7548597),(52361,'hindlimb',41,7,441,99.8931768,94.496208,119.0635073,1.8,94.6925812,118.7596954,-0.0726538,9.2308946,17.8351466,1618.498157,8376.840453,0.0877278,469.6816159,175.3349188,512.4363578,10.1991563,14.8413514,1.956679,45.7912239),(52362,'hindlimb',41,7,442,100.306752,94.2557522,118.9780011,1.8,94.53136,118.7419962,-0.0598283,9.761782,17.9686935,1556.9371595,8308.2505924,0.0597687,462.3736606,159.4931295,501.5342945,10.3305846,15.240301,1.9460671,49.4372475),(52363,'hindlimb',41,7,443,98.9898239,94.2273708,118.7269636,1.8,94.1960602,118.7499523,-0.0575892,9.9988714,17.6100251,1463.0711023,8363.8746679,0.0546564,474.9496162,146.3236243,496.7007778,10.7049901,15.1917649,2.0724004,47.5099759),(52364,'hindlimb',41,7,444,101.9583112,94.2699577,118.7859797,1.8,94.4049812,118.6218244,-0.0998254,9.8253857,17.9813912,1421.2272422,8478.3152362,0.168776,471.5049645,144.6484936,492.3055662,10.2462217,14.609392,2.0607537,41.7460493),(52365,'hindlimb',41,7,445,107.5979168,94.7910981,118.9086422,1.8,94.7159261,118.6222332,-0.1881323,9.3640771,18.3552725,1360.7821441,8859.3047955,0.6272628,482.6572196,145.3194082,508.3865085,10.281938,13.8370211,2.0205559,40.4264483),(52366,'hindlimb',41,7,446,113.8900559,95.3096109,119.0285424,1.8,94.9168865,118.7998675,-0.240345,9.4163082,18.3853392,1324.2279676,9046.5563,1.0755386,492.0527267,140.6313321,518.3980632,10.312512,13.4513621,2.0344439,41.4943439),(52367,'hindlimb',41,7,447,124.9423379,95.7239739,119.2426514,1.8,95.1291023,118.944244,-0.2840533,10.2749421,18.6154615,1348.4479043,9029.2029317,1.6354828,485.0378223,131.2365451,509.9470965,9.453136,13.9896277,1.7561443,39.4196267),(52368,'hindlimb',41,7,448,123.563754,96.1148477,119.264553,1.8,95.4699858,119.1178733,-0.3002445,9.6689357,18.6333972,1353.4332795,8526.8565274,1.80136,457.6114824,139.977482,478.6967684,9.023448,10.5339308,1.7761917,31.1207579),(52369,'hindlimb',41,7,449,125.2113408,96.5881701,119.2531591,1.8,95.7271898,119.0583699,-0.2885459,10.6986768,18.4832009,1496.9242202,8183.5876487,1.689802,442.7581396,139.9167629,463.444932,8.59376,10.2135672,1.8259787,29.6537113),(52370,'hindlimb',41,7,450,124.2731316,96.7211147,119.2443563,1.8,96.0951764,118.9832928,-0.2771393,11.3400948,18.4830947,1594.1140461,8034.8523928,1.5505111,434.7135861,140.5732562,455.9161653,8.5073884,9.5115493,1.8925469,27.9349593),(52371,'hindlimb',41,7,451,118.7757484,96.8990564,119.031782,1.8,96.8264234,118.4896904,-0.2764077,12.0236903,18.4809817,1695.108597,7559.2306061,1.4743083,409.0275476,140.9807268,430.6578365,7.734384,8.689902,1.7196863,25.8602421),(52372,'hindlimb',41,7,452,112.4730909,96.966059,118.8210012,1.8,96.8505509,118.3177353,-0.2881661,12.046305,18.8950501,1736.1504335,7162.6800417,1.5140086,379.0770595,144.1230675,406.5009195,7.304696,7.9230552,1.7894653,24.0372303),(52373,'hindlimb',41,7,453,110.3172632,97.1313801,118.6733119,1.8,96.9422049,118.0894875,-0.3055538,12.7472205,19.3866052,1842.8409987,7169.3370501,1.663832,369.8087914,144.5680646,392.9623618,7.2920472,7.7463106,1.2315037,23.4295597),(52374,'hindlimb',41,7,454,108.7833088,97.1360552,118.5361644,1.8,97.1312444,117.6279059,-0.3302728,13.3793286,20.3021703,1965.5801463,7248.7993628,1.9068119,357.045541,146.9117179,387.778866,6.875008,7.6019567,0.7454195,22.7176293),(52375,'hindlimb',41,7,455,110.5185678,97.2599964,117.8887364,1.8,97.3356588,116.9536929,-0.4108849,12.2137487,21.3638627,2261.8776345,7741.3270687,2.9386323,362.3561516,185.1911068,418.1227726,6.44532,7.304696,2.0607537,20.9988773),(52376,'hindlimb',41,7,456,112.030758,97.1741715,117.314234,1.8,97.3923813,116.493396,-0.441705,11.2500069,21.8280835,2336.1367043,8074.2800651,3.4120907,369.9032983,207.6564678,431.5124707,6.44532,7.1514336,2.1421338,21.7108077),(52377,'hindlimb',41,7,457,113.8336033,96.9837274,117.1238794,1.8,98.1122039,116.849587,-0.4787653,13.3160345,23.0614519,3032.5657805,8463.2421915,4.0264741,366.9865292,227.737903,453.0809027,6.44532,7.1514336,2.1421338,21.6065479),(52378,'hindlimb',41,7,458,144.620057,98.2620864,118.5623195,1.8,98.7809499,118.0527692,-0.4475313,14.678922,22.9490714,5693.9861747,9551.4599838,4.5137125,416.2024611,387.9022021,567.3191918,6.44532,7.0474072,2.226492,21.2505827),(52379,'hindlimb',41,7,459,164.2725432,98.5956019,119.8788973,1.8,98.5955599,118.490925,-0.2556811,19.9574269,20.3353597,6934.4002049,9733.0702495,1.7511636,478.6278862,347.4596315,594.3102527,6.4945285,7.8880231,2.0831858,22.2142185),(52380,'hindlimb',41,7,460,159.5505575,98.0579999,120.0235596,1.8,98.2255396,118.8224051,-0.017116,23.9804908,20.6719484,6357.515553,10197.9455785,0.0077894,493.3229012,265.111987,577.3239494,6.6591601,8.59376,2.2142974,23.3252999),(52381,'hindlimb',41,7,461,140.7119058,97.4546452,120.2639346,1.8,97.5142413,119.3944066,0.1466242,26.3280026,21.742488,5477.3446258,10955.3732045,0.5005832,503.8693454,208.0425435,569.6610649,1.1536277,1.5492621,0.5880026,3.6460236),(52382,'hindlimb',41,7,462,127.0346076,96.6071136,120.6302372,1.8,96.8555232,119.7267893,0.2701688,28.0131582,21.7264833,4259.2560145,11705.9221182,1.5081653,538.7858668,152.0448347,549.579155,15.6931488,19.3025109,1.2772073,75.549195),(52383,'hindlimb',41,7,463,103.1631175,95.0132574,120.7302624,1.8,96.1057781,120.1970256,0.3582314,29.2869191,20.763867,2993.2681806,12285.4687461,2.1136974,591.6753731,102.2049525,511.227586,0.429688,0.6076706,2.3561945,1.2153412),(52384,'hindlimb',41,7,464,90.1038881,93.8822287,120.9716947,1.8,95.30555,120.5506596,0.4136967,29.6816144,20.0911235,1784.1266177,12337.2271685,2.4268211,614.0635781,60.1088133,467.0522391,11.0663164,15.6231626,0.5498532,42.3969057),(52385,'hindlimb',41,7,465,80.1375766,92.3859448,120.7351684,1.8,93.6877217,121.2507047,0.4639637,6.5295887,19.7928868,559.3902471,12389.8231843,2.6746308,625.9735282,85.6700583,650.5849522,10.4906669,14.4121737,0.4636476,40.2790027),(52386,'hindlimb',41,7,466,75.1183897,91.9009732,120.3337006,1.8,93.2649112,120.9549105,0.480969,6.2219861,19.4088362,483.9238848,12144.7459833,2.6796527,625.7328275,77.776433,647.19684,10.1513001,13.6556983,0.4214192,38.1000257),(52387,'hindlimb',41,7,467,67.9009657,91.6899024,119.8496635,1.8,92.7190339,120.4051385,0.5135897,5.7810689,19.2535992,414.4215311,11498.6384213,2.7316851,597.2202033,71.6859696,617.0341932,0,0,0,0),(52388,'hindlimb',41,7,468,63.7886006,91.9033452,119.6505597,1.8,92.241337,119.8840495,0.543497,5.6885851,19.5131773,374.6019237,11174.5141815,2.8431192,572.665026,65.8515107,591.8622851,0,0,0,0),(52389,'hindlimb',41,7,469,53.3456594,93.1300327,119.9875158,1.8,92.6536103,119.7305245,0.5796404,5.3007646,20.7108569,287.8517855,9726.2167793,2.6672885,469.6192346,54.3038239,482.8277895,0,0,0,0),(52390,'hindlimb',41,7,470,48.346782,94.0158878,120.5014692,1.8,93.5058989,120.1092239,0.5916027,5.1310103,21.9632661,250.0884401,8742.7090348,2.5061392,398.0605153,48.7405846,409.3481486,0,0,0,0),(52391,'hindlimb',41,7,471,46.8964155,94.0862817,120.5395014,1.8,93.5556961,120.230991,0.5983491,4.9558587,21.9165811,218.3646342,8747.2902402,2.4799092,399.1174626,44.0619165,408.9144767,0,0,0,0),(52392,'hindlimb',41,7,472,48.3158982,93.173759,120.1500027,1.8,92.9891921,120.0401959,0.5838749,4.7419408,21.0689061,210.1468807,9630.7709092,2.4471093,457.1082555,44.3166391,466.8059324,0,0,0,0),(52393,'hindlimb',41,7,473,45.0301799,93.8309937,120.664937,1.8,92.9722064,120.1644415,0.5845661,4.695321,21.8953377,190.1309557,8790.1053116,2.2854673,401.4601386,40.4937072,409.8158719,0,0,0,0),(52394,'hindlimb',41,7,474,44.5336323,93.7647944,120.6654442,1.8,92.7171218,120.0018594,0.5859599,4.5102418,21.8416619,183.3863169,8732.5075466,2.2697928,399.809666,40.659975,407.8729995,0,0,0,0),(52395,'hindlimb',41,7,475,44.0523028,93.4296448,120.5703142,1.8,92.723515,120.1381663,0.5831608,4.463029,21.1557923,171.5727237,8816.6469579,2.2263449,416.748606,38.4431118,424.2263261,0,0,0,0),(52396,'hindlimb',41,7,476,42.2519192,93.6625395,120.9036518,1.8,92.9359353,120.4486916,0.5744843,4.2806102,21.4067117,158.592139,8438.0632986,2.0793978,394.1783967,37.0489562,401.391976,0,0,0,0),(52397,'hindlimb',41,7,477,40.2237112,93.9482356,121.3167652,1.8,93.3118349,120.9530204,0.561795,4.2025988,21.4411773,140.8817795,7904.2720151,1.9024199,368.6491613,33.5225385,374.6907581,0,0,0,0),(52398,'hindlimb',41,7,478,37.5369272,94.8922525,122.1439343,1.8,93.5572562,121.2672617,0.5470074,4.0278281,22.8356907,126.0479468,6968.6852879,1.692534,305.1663902,31.2942719,310.2597784,0,0,0,0),(52399,'hindlimb',41,7,479,32.8748629,97.1476899,123.7993472,1.8,94.961048,122.4431763,0.5174275,4.0621918,25.8010492,103.9403644,4870.9440548,1.3406079,188.7886036,25.5872618,192.7280371,6.875008,9.1049255,0.3366748,24.8966063),(52400,'hindlimb',41,7,480,31.6277592,97.9356205,124.3426357,1.8,95.6905466,122.9393203,0.5077303,3.9188487,26.7601224,98.9606655,4200.5014815,1.2460583,156.9686948,25.2524844,160.6447749,6.875008,9.1049255,0.3366748,25.1483117),(52401,'hindlimb',41,7,481,30.4104203,98.8944587,124.92019,1.8,96.5635027,123.3522847,0.4977331,4.7633051,27.8814553,98.8289157,3396.3561969,1.1553125,121.8141649,20.7479707,125.3575061,7.463933,9.2557628,1.1902899,28.1866647),(52402,'hindlimb',41,7,482,29.4366275,99.5865358,125.3861293,1.8,97.0363769,123.7334695,0.4914047,4.8302623,28.7117358,96.0947402,2813.0910586,1.0923755,97.9770459,19.8943111,101.322803,7.2920472,9.2557628,1.1902899,28.2909245),(52403,'hindlimb',41,7,483,28.6091974,100.7529909,126.0709889,1.8,97.9585721,124.3084811,0.4809833,5.0763255,30.0597286,96.9444777,1827.4370646,1.0206143,60.7935318,19.0973724,64.0096722,7.278446,9.4335845,1.0460006,28.8985951),(52404,'hindlimb',41,7,484,28.8945934,101.2109718,126.3592253,1.8,98.8500451,124.7441983,0.4725149,5.5155683,30.5933832,101.5923121,1443.6256123,0.9975407,47.1875113,18.4191921,50.4907792,7.2184476,10.1410009,0.9357696,32.7963241),(52405,'hindlimb',41,7,485,29.4341098,101.5761954,126.6214172,1.8,99.3816067,125.2113382,0.4569546,5.1688125,30.8310093,102.8503222,1097.2743188,0.9550026,35.5899578,19.8982497,38.9066797,8.1517796,11.0472442,2.9060477,35.7304173),(52406,'hindlimb',41,7,486,29.3710553,101.9681314,126.8808509,1.8,100.1833062,125.7140471,0.435461,4.8578586,31.0866008,103.6613833,742.6817143,0.8710439,23.8907341,21.3389048,27.2011264,7.7726337,9.6942031,2.9181161,32.6920643),(52407,'hindlimb',41,7,487,28.8933625,102.5682337,127.2171782,1.8,101.872225,126.6103904,0.097917,11.9768291,28.6308202,92.5243651,191.1930915,0.046023,6.6778768,7.7252806,9.1993256,7.2920472,9.4335845,0.5247958,30.2613819),(52408,'hindlimb',41,7,488,28.5431216,102.6699192,127.3221791,1.8,102.4129382,126.8962333,-0.3101682,4.9675848,4.5510812,70.8717657,143.5652608,0.4431724,31.5453086,14.2668456,34.3005034,7.278446,9.6560368,0.363979,30.6173471),(52409,'hindlimb',41,7,489,29.2228463,102.6320391,127.3017788,1.8,102.2202962,126.8268203,-0.3391901,4.9490114,4.7647204,75.8509572,157.4498652,0.5391852,33.0449324,15.3264866,39.0553635,8.55142,10.4635866,2.8068558,37.0932041),(52410,'hindlimb',41,7,490,30.5262348,102.558104,127.2839862,1.8,102.1472543,126.773585,-0.3391407,5.0506724,4.9284252,81.2145886,177.2422518,0.5630763,35.9632628,16.0799558,45.4466484,8.6483895,10.4635866,2.8068558,36.4855335),(52411,'hindlimb',41,7,491,34.3941027,102.4274848,127.155651,1.8,102.0798104,126.6151086,-0.3552887,4.9644012,5.6987934,97.6764845,233.0801612,0.6936563,40.8999144,19.6753807,56.8662836,8.4599362,11.5697035,0.2629947,33.1954751),(52412,'hindlimb',41,7,492,38.3626228,102.3330356,127.0550626,1.8,101.9912782,126.5256407,-0.3637719,4.8146734,6.0378074,114.1313078,305.395382,0.8094191,50.5805109,23.7048908,68.0688036,8.6070663,12.2291349,0.3217506,34.4108163),(52413,'hindlimb',41,7,493,42.9198946,102.1586341,126.8664231,1.8,101.7997187,126.3827779,-0.3618172,4.7994551,6.4978445,145.489801,404.5928333,0.8962949,62.2656994,30.3138167,84.1160624,9.1413377,13.0896253,0.4048918,35.7736031),(52414,'hindlimb',41,7,494,45.7573493,102.0349443,126.8091848,1.8,101.7248426,126.3425949,-0.3686271,4.8743493,6.7987384,170.0039014,471.7031282,0.9901995,69.3809788,34.8772504,93.676214,9.5451124,13.6556983,0.4214192,37.8483203),(52415,'hindlimb',41,7,495,49.8238922,102.0777848,126.655914,1.8,101.7027046,126.2994182,-0.3998698,5.0064794,7.6599339,200.9520709,540.0044406,1.2584954,70.4972714,40.1383996,95.4474528,9.7857699,14.8413514,0.3858827,40.4264483),(52416,'hindlimb',41,7,496,52.4893037,102.1544247,126.4517144,1.8,101.8149622,126.1571781,-0.410065,5.0542239,7.4043128,218.9685504,556.5244337,1.3904146,75.1621991,43.3238723,103.7730601,9.8854524,14.6157096,0.4241944,40.0704831),(52417,'hindlimb',41,7,497,50.469488,102.1850297,126.2757036,1.8,101.9887812,125.9152018,-0.4297884,5.0129161,7.1313791,209.9682325,534.7393465,1.4604263,74.9840023,41.8854476,103.5547404,9.7842272,14.2316921,0.504166,39.2111071),(52418,'hindlimb',41,7,498,50.8227501,102.1646294,126.2079808,1.8,102.0598034,125.7243862,-0.4342478,5.1361718,7.1254582,218.1740314,525.0731774,1.4993743,73.689742,42.4779465,103.6154049,9.8146866,14.0488921,0.4089078,39.9230375),(52419,'hindlimb',41,7,499,57.6129474,102.0314974,125.8062324,1.8,101.9835721,125.527146,-0.4387307,5.1191622,6.8964247,299.2945348,574.9875059,1.7326821,83.374724,58.4655303,126.7729088,10.1597585,13.8836442,0.3805064,39.6713321),(52420,'hindlimb',41,7,500,64.9897702,101.8147856,125.4907283,1.8,101.8287109,125.4123388,-0.4202635,4.9358044,6.5723665,378.1278467,624.4097262,1.8030852,95.0053111,76.6091637,147.2740225,10.4235754,13.8703393,2.8590377,41.1383787),(52421,'hindlimb',41,7,501,70.3672546,101.667969,125.1394514,1.8,101.680668,125.1085125,-0.409279,5.2992223,6.3506536,417.8340023,648.6763261,1.8572569,102.143238,78.8481745,147.6273132,10.3805823,13.3411032,2.8809903,39.9230375),(52422,'hindlimb',41,7,502,69.822479,101.5938548,124.9729158,1.8,101.5432207,124.9774036,-0.3952999,4.9786774,6.2466686,400.1171315,629.2020057,1.7256675,100.726011,80.3661494,158.2230992,10.4235754,13.1529455,0.6696389,39.5670723),(52423,'hindlimb',41,7,503,60.5857988,101.4287239,124.5799737,1.8,101.4220787,124.5301809,-0.3933901,4.7436749,6.0822275,313.6227262,529.0449911,1.4837012,86.9821119,66.1138749,136.3475186,9.9479922,12.7248603,0.204018,38.8119561),(52424,'hindlimb',41,7,504,46.3814047,101.204733,123.8650135,1.8,101.2570623,124.0626444,-0.3569456,4.4937961,6.0079507,191.8543378,364.1141929,0.9437854,60.60539,42.6931561,92.1825484,9.3401993,12.3717316,0.3547057,36.9889443),(52425,'hindlimb',41,7,505,41.6008964,101.180139,123.7847409,1.8,101.0917927,123.5417503,-0.3537053,4.3880683,5.805438,189.2595427,280.6162878,0.8318542,48.3367989,43.130492,80.3500695,9.2637274,12.1306029,0.4002407,34.3065565),(52426,'hindlimb',41,7,506,36.7806083,101.0800504,123.6833281,1.8,100.9776982,123.4589336,-0.3265834,4.5778991,5.692297,180.7009984,247.3407124,0.6308998,43.4518281,39.4724728,75.0015706,9.4246914,11.9156132,0.44752,33.6988859),(52427,'hindlimb',41,7,507,32.3139739,101.0096178,123.4037114,1.8,100.9114109,123.1986204,-0.3344859,4.5540721,5.4385112,165.8106533,205.1743456,0.5804136,37.7261969,36.4093169,68.1854262,9.453136,11.417094,0.3455556,32.8395099),(52428,'hindlimb',41,7,508,29.492129,100.8464861,123.0772271,1.8,100.7968387,122.9221497,-0.3596645,4.4981708,5.1168321,146.1915331,173.6431115,0.6088945,33.9356672,32.500218,61.2782852,9.023448,10.7679504,0.4993467,31.0164981),(52429,'hindlimb',41,7,509,26.5422727,100.6371493,122.4753474,1.8,100.6235701,122.3646484,-0.3159765,4.30178,4.5659864,119.8455816,134.1050979,0.4271639,29.3704552,27.8595329,55.0822179,8.59376,9.6560368,0.363979,28.6900755),(52430,'hindlimb',41,7,510,24.6422998,100.4590197,122.1042222,1.8,100.4585724,122.0344944,-0.3317745,4.1759279,4.3755317,103.7643064,111.9438966,0.4357347,25.5840672,24.8482033,48.7612712,8.164072,9.2557628,0.3805064,27.2230289),(52431,'hindlimb',41,7,511,23.2329439,100.2765936,121.6247554,1.8,100.2062628,121.5379222,0.3502807,4.1891614,4.2322467,90.5747986,91.1445403,0.4559846,21.5357344,21.6212244,42.9101601,8.164072,8.7005189,0.5743048,26.6153583),(52432,'hindlimb',41,7,512,22.5015782,100.1473837,121.301947,1.8,100.1033304,121.2174302,0.7029748,4.0411454,3.890682,80.4482,82.5964788,1.5674202,21.2293058,19.9072767,39.3109654,7.734384,8.3430318,2.5393053,25.7559823),(52433,'hindlimb',41,7,513,21.6415299,99.9387417,120.8211954,1.8,99.9043613,120.7366242,0.9257224,3.8002866,3.8245109,68.8157236,72.3360118,2.3029812,18.9137942,18.1080354,35.8789455,7.304696,7.9926588,2.2035452,24.1846759),(52434,'hindlimb',41,7,514,21.0249716,99.7692708,120.4503504,1.8,99.7425533,120.3695393,0.9935583,3.5740418,3.6585211,62.8344234,65.2158377,2.4606185,17.8257376,17.5807746,33.7206064,7.304696,7.7463106,2.1587989,23.6812651),(52435,'hindlimb',41,7,515,20.8075537,99.534482,119.8854534,1.8,99.5381593,119.8372847,1.3340396,3.6098632,3.5766644,57.4814805,57.9509174,3.2771405,16.2025036,15.9234513,30.9462759,7.2920472,7.5164702,1.0303768,23.1778543),(52436,'hindlimb',41,7,516,21.0029277,99.3641086,119.4461593,1.8,99.36273,119.3903828,-0.9612664,3.3671229,3.6294918,53.9838326,56.5941843,2.3532529,15.5928675,16.0326293,30.4643544,6.9882119,7.5164702,1.0303768,22.9261489),(52437,'hindlimb',41,7,517,21.6744838,99.0892714,118.8383429,1.8,99.1154184,118.8400409,-0.5723661,3.3452047,3.3723242,50.0589818,56.8960867,1.0597198,16.8714762,14.9644003,30.0096987,6.875008,7.3926319,0.9505468,22.2142185),(52438,'hindlimb',41,7,518,21.8643189,98.8795972,118.3981902,1.8,98.8390362,118.3995567,-0.5426103,3.2364016,3.5325458,47.5715973,60.4472074,0.9716548,17.1115142,14.6989167,29.6308992,6.6843766,7.5164702,0.5404195,21.9625131),(52439,'hindlimb',41,7,519,22.7661612,98.5666483,117.7809561,1.8,98.5404301,117.7061364,-0.4626174,3.1503733,3.7811776,45.8197608,71.461973,0.7557471,18.899396,14.5442321,28.8638003,6.5361326,8.107337,0.5585993,23.4295597),(52440,'hindlimb',41,7,520,25.3297454,98.2261857,117.2013268,1.8,98.1020318,117.0704487,-0.375361,3.2729345,4.4325872,51.6950521,103.1547987,0.5673936,23.2719166,15.7947104,32.9048553,6.8195212,9.2257926,0.4844779,26.0076877),(52441,'hindlimb',41,7,521,32.9352319,97.7131301,116.1681824,1.8,97.6296366,115.9973852,-0.3887262,3.553566,4.9657053,79.2349853,169.9114935,0.7885164,34.216991,22.2973165,48.1196074,7.5776346,10.2496576,0.5763752,29.2977461),(52442,'hindlimb',41,7,522,37.2544405,97.3720339,115.5977347,1.8,97.1843213,115.2179404,-0.3777799,4.570744,5.2669839,96.3024522,206.9063676,0.8447825,39.283653,21.0693165,56.6533719,8.7529726,10.980189,0.5337082,31.6241687),(52443,'hindlimb',41,7,523,37.2282564,97.1328788,114.9335539,1.8,97.0321896,114.6289363,-0.4326602,4.2787047,5.4866735,108.3916631,231.4214098,1.0907998,42.1788196,25.3328218,61.6240023,8.4208704,11.4413255,0.5984189,31.8758741),(52444,'hindlimb',41,7,524,33.674878,97.0544532,114.7023326,1.8,96.929019,114.4725662,-0.4174312,3.8833381,5.5440805,83.3284518,210.8660763,0.9224682,38.0344542,21.457944,53.0588352,7.853561,11.2048922,0.5667292,31.3724633),(52445,'hindlimb',41,7,525,27.9976746,96.9820175,114.5180318,1.8,96.9429314,114.4831595,-0.4328751,3.5435764,5.3734649,52.8372782,150.8865917,0.8211043,28.0799438,14.9107207,37.8282144,7.2967479,10.7422,0.6435011,29.6537113),(52446,'hindlimb',41,7,526,26.3518222,96.7892963,114.3096551,1.8,96.8255599,114.3759613,-0.3468209,3.6218808,5.1280374,49.1319511,119.8986348,0.5074422,23.3809987,13.5653142,32.9610744,7.303036,10.3304002,0.2954408,27.9349593),(52447,'hindlimb',41,7,527,23.7679844,96.4205236,113.9972252,1.8,96.5557024,114.1791153,-0.1930004,3.8824597,5.0006055,56.7484642,93.5127287,0.1457331,18.700281,14.6166268,29.9495148,7.6650624,10.2135672,0.2551824,27.4315485),(52448,'hindlimb',41,7,528,24.4793203,96.2247714,114.116934,1.8,96.3431042,114.1046104,0.9918862,4.019641,4.0928422,64.6330083,79.1519612,2.8586482,19.3391188,16.0792988,32.8630611,8.0732119,8.9721488,0.2914568,26.7196181),(52449,'hindlimb',41,7,529,26.8216821,96.3268373,114.1199055,1.8,96.2678811,114.0433952,-1.0477175,3.9720373,4.446245,85.1344134,89.2980964,3.3547224,20.0839352,21.4334373,39.1279625,7.734384,8.8582451,0.6823166,26.2593931),(52450,'hindlimb',41,7,530,26.0593207,96.4226822,114.0285062,1.8,96.4244781,113.9731852,-0.4838057,4.1997504,4.120124,83.4271401,98.9240516,0.9397245,24.0099692,19.8647855,42.1264967,8.164072,8.8582451,0.6823166,26.6153583),(52451,'hindlimb',41,7,531,26.2320353,96.5296132,113.9285579,1.8,96.4881176,113.9727453,-0.0785068,4.335471,4.1628172,86.0421548,89.8492363,0.0268908,21.5837573,19.8460918,39.3186118,8.164072,8.76395,1.7681919,26.7196181),(52452,'hindlimb',41,7,532,24.2472997,96.4275714,113.9785359,1.8,96.4457162,114.056511,0.9172242,3.7675298,4.5214775,70.6749874,93.1979028,2.5471954,20.6122671,18.7589725,35.4204502,7.8997178,9.0336729,2.0131705,26.7196181),(52453,'hindlimb',41,7,533,22.1421617,96.2568924,114.1965054,1.8,96.3188621,114.2506017,0.9435226,3.6317461,4.7215931,56.0217026,83.6889705,2.4190378,17.7247316,15.4255558,29.5493409,7.5958825,9.0642783,2.1193457,25.7559823),(52454,'hindlimb',41,7,534,22.3151561,96.340313,114.243798,1.8,96.3939482,114.3752986,1.0506493,3.3595363,4.7977344,51.2881322,76.3454794,2.8004902,15.9128189,15.2664319,26.5215706,6.875008,9.1049255,1.9074711,25.1483117),(52455,'hindlimb',41,7,535,21.2097153,96.3911602,114.4491404,1.8,96.464956,114.6309928,1.0225973,3.2799568,4.6646904,40.2614708,68.0243815,2.5748652,14.5828288,12.2750004,23.076121,6.44532,8.8582451,1.9693188,23.9329705),(52456,'hindlimb',41,7,536,20.1787986,96.4305132,114.6311795,1.8,96.4490416,114.7843856,1.0159212,3.3004808,4.63138,35.1534699,60.8212722,2.4296706,13.1324295,10.6510149,20.7215154,6.44532,8.9412281,2.1854593,23.8287107),(52457,'hindlimb',41,7,537,16.4534888,96.6319014,115.0841751,1.8,96.5735088,115.1134152,0.9746258,3.2244701,3.8961938,28.4692533,35.684887,1.8777346,9.1589097,8.8291262,16.3272541,6.44532,7.8997178,1.9614034,22.4659239),(52458,'hindlimb',41,7,538,15.0126336,96.6462996,115.2457222,1.8,96.7017727,115.3028685,0.8330389,3.408808,3.6561897,26.0859728,27.8826727,1.3700748,7.626156,7.6525205,14.2813168,6.44532,7.3926319,2.5213432,21.8582533),(52459,'hindlimb',41,7,539,14.0641858,96.6224803,115.3422656,1.8,96.5896186,115.3553136,-0.6375742,3.6700184,3.1619209,22.7007142,23.5126613,0.8305374,7.4361953,6.1854497,12.4730397,6.44532,7.1514336,2.5702552,21.3548425),(52460,'hindlimb',41,7,540,12.733662,96.5618668,115.3545309,1.8,96.5519814,115.3603498,-0.543276,3.5767183,3.1834361,20.2023251,21.7524934,0.5671364,6.8330235,5.6482853,11.622463,6.015632,7.1514336,2.5702552,20.9988773),(52461,'hindlimb',41,7,541,11.5380314,96.4638329,115.3198506,1.8,96.5217857,115.3005374,-0.5870834,3.4397999,3.2491566,17.2544434,19.5091566,0.5900628,6.0043755,5.0161184,10.473088,6.015632,6.9285108,2.6224465,20.3912067),(52462,'hindlimb',41,7,542,10.5370474,96.3834539,115.2783662,1.8,96.379607,115.2741067,-0.7498568,3.485172,3.3148383,15.1744993,17.2858063,0.815723,5.2146756,4.3540174,9.2223264,6.015632,6.7939638,2.536048,20.3912067),(52463,'hindlimb',41,7,543,9.2355053,96.2207963,115.1719477,1.8,96.2409044,115.1471764,-0.5399946,3.2443094,3.2013843,12.9202557,14.3137304,0.4068718,4.4711065,3.9824363,7.7981652,6.015632,6.9285108,0.5191461,19.8877959),(52464,'hindlimb',41,7,544,8.1906573,96.0738429,115.0984505,1.8,96.0467482,115.100623,-0.4466982,3.1960371,3.1518849,11.2875659,11.7089961,0.2547505,3.7149187,3.531738,6.9739636,5.9707924,6.5589027,0.551655,19.5318307),(52465,'hindlimb',41,7,545,7.0087342,95.9314973,114.9584469,1.8,95.9270133,114.9332127,0.0489104,2.8851195,3.12649,9.5466806,9.7198167,0.0027922,3.108859,3.3089377,5.9514266,5.585944,6.5589027,0.551655,18.9241602),(52466,'hindlimb',41,7,546,5.9685859,95.7616132,114.7906826,1.8,95.6933858,114.7752694,0.6223059,2.9325046,2.9098536,7.5939833,7.9815911,0.3380055,2.7429528,2.5895896,5.0585416,5.4919414,6.1970485,2.5535901,18.0647842),(52467,'hindlimb',41,7,547,4.772172,95.4389616,114.4770493,1.8,95.4027833,114.4616548,0.7343305,2.8477876,2.8469324,5.8648746,6.2023107,0.3571343,2.1785943,2.0594494,4.1289484,5.156256,5.8443887,2.5127964,17.4571136),(52468,'hindlimb',41,7,548,4.0019777,95.1937243,114.1877974,1.8,95.2077995,114.1821409,0.4573025,2.6816544,2.6634853,4.7054592,5.2430834,0.1300297,1.9685047,1.7546852,3.5166099,5.156256,5.7648695,2.677945,16.3460322),(52469,'hindlimb',41,7,549,3.3397091,94.7821385,113.7784771,1.8,94.8085781,113.8118764,0.6333947,2.2746274,2.5994458,3.4897324,4.5193223,0.1949985,1.7385715,1.5341996,2.9930447,4.7169615,5.6024461,2.5748634,15.3823964),(52470,'hindlimb',41,7,550,3.1942976,94.5030468,113.4853701,1.8,94.5206178,113.5074563,0.7277391,2.1953004,2.4160294,2.6059188,3.6857743,0.2355628,1.5255503,1.1870443,2.5373792,4.29688,5.2450105,2.5308667,14.1670552),(52471,'hindlimb',41,7,551,2.1054177,94.2990172,113.2483254,1.8,94.324189,113.25348,0.7663434,1.561013,1.8335733,1.1390417,1.5478243,0.1687667,0.8441573,0.7296811,1.3303644,3.6460236,4.29688,2.2142974,11.9448924),(52472,'hindlimb',41,7,552,1.0080336,94.1583611,113.1834013,1.8,94.155383,113.222788,0.565046,1.3037854,1.2742063,0.353141,0.3775503,0.0481692,0.2963024,0.2708582,0.5322852,2.578128,3.1281759,2.863293,8.654834),(52473,'hindlimb',41,7,553,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52474,'hindlimb',41,7,554,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52475,'hindlimb',41,7,555,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52476,'hindlimb',41,7,556,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52477,'hindlimb',41,7,557,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52478,'hindlimb',41,7,558,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52479,'hindlimb',41,7,559,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52480,'hindlimb',41,7,560,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52481,'hindlimb',41,7,561,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52482,'hindlimb',41,7,562,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52483,'hindlimb',41,7,563,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52484,'hindlimb',41,7,564,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52485,'hindlimb',41,7,565,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52486,'hindlimb',41,7,566,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52487,'hindlimb',41,7,567,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52488,'hindlimb',41,7,568,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52489,'hindlimb',41,7,569,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52490,'hindlimb',41,7,570,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52491,'hindlimb',41,7,571,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52492,'hindlimb',41,7,572,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52493,'hindlimb',41,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52494,'hindlimb',41,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52495,'hindlimb',41,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52496,'hindlimb',41,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52497,'hindlimb',41,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52498,'hindlimb',41,8,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52499,'hindlimb',41,8,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52500,'hindlimb',41,8,8,4.0622907,52.1123833,122.7311655,1.8,52.1756514,121.5964639,-1.4841903,1.81819,11.9654439,2.4443634,27.530261,0.6719829,2.300814,1.3443938,2.5023037,3.867192,4.8040579,2.0344439,13.0559738),(52501,'hindlimb',41,8,9,26.4395503,52.0842213,117.0148186,1.8,51.7468506,116.9440025,-1.452699,7.4845389,9.4428591,74.605352,940.0969649,4.3454183,99.5563904,9.967929,105.5236315,0,0,0,0),(52502,'hindlimb',41,8,10,51.4049557,51.945746,116.4736126,1.8,51.631432,116.5722212,-1.4041643,7.5109225,10.6291911,206.9369147,1692.8226006,8.3317992,159.261659,27.5514647,177.1401554,8.3839729,21.2684709,1.4288993,54.9494687),(52503,'hindlimb',41,8,11,82.4077642,51.8800644,116.4229972,1.8,51.5973996,116.4234659,-1.3683657,7.7965722,11.4505078,512.467785,2790.0414634,13.1794533,243.6609365,65.7298834,284.0046767,14.4448982,23.2587856,1.3661545,78.8824392),(52504,'hindlimb',41,8,12,103.1420247,51.9332564,116.2464898,1.8,51.6845955,116.2420555,-1.3757358,8.3343513,12.0357746,789.5362145,3772.4269145,16.5445226,313.4344923,94.7327737,379.0122327,15.0247115,24.3713034,1.4114447,79.2384044),(52505,'hindlimb',41,8,13,142.4222115,52.924066,116.2493103,1.8,52.5456341,116.1347004,-1.4631008,13.0631656,12.9364718,2062.1575962,5660.0287351,23.4627883,437.5249155,157.8604808,560.7701838,3.6371421,6.9948139,0.8288491,16.5977376),(52506,'hindlimb',41,8,14,185.2049751,52.8643269,116.5312551,1.8,52.4864092,116.5095208,-1.3364919,13.1262218,14.0533797,4919.3694625,7278.6692888,29.2036981,517.9301668,374.7742148,830.5035559,22.8295902,27.073754,0.6276294,97.4685223),(52507,'hindlimb',41,8,15,227.8722599,52.4673417,117.0493316,1.8,52.6343338,116.9416052,-1.257486,13.8763931,15.9154493,8095.425635,9758.8291442,34.3709938,613.1670526,583.3955237,1121.6961895,24.9937158,29.0572042,0.670122,93.9699443),(52508,'hindlimb',41,8,16,242.0890186,52.4312756,117.5091899,1.8,52.6784334,117.4452869,-1.4024622,14.2404418,16.5935479,9732.3972776,11560.4258144,39.2156072,696.6819798,683.4336617,1277.7853805,26.1306333,30.1547924,0.7148086,98.0151189),(52509,'hindlimb',41,8,17,253.5693106,52.7153555,118.3125399,1.8,52.8637053,118.1985518,1.5209962,14.7900306,16.6859217,11422.0206604,13984.2650803,42.1568276,838.0876606,772.2783672,1453.6366446,27.5609519,31.1190243,0.952152,99.7338709),(52510,'hindlimb',41,8,18,255.4077396,52.5449601,118.7079278,1.8,52.8127648,118.6096833,1.5666779,14.753057,17.2806843,11959.84208,15228.8061587,42.5672346,881.261752,810.6687392,1498.531823,28.1397406,32.4208067,0.9644134,102.0171077),(52511,'hindlimb',41,8,19,251.9270389,52.4414532,119.0100588,1.8,52.7283551,119.1391575,-1.4945333,15.5007375,17.5809234,11915.1664989,16086.116467,41.7441094,914.9756318,768.683844,1539.3227983,28.5957152,33.0189437,0.9611365,102.4162587),(52512,'hindlimb',41,8,20,249.9804605,52.3051119,119.2340131,1.8,52.544647,119.4313276,-1.4758615,15.7601393,17.6565383,11498.3570633,16646.5726491,41.2890401,942.7993395,729.5847364,1559.9303596,28.7326447,33.1305888,0.9791966,103.1281891),(52513,'hindlimb',41,8,21,260.0959321,52.2749531,119.5040787,1.8,52.4262009,119.6611775,-1.5167768,15.5555715,17.8589886,11692.8323643,17064.8178615,43.2229471,955.5310342,751.6813111,1582.9926635,28.4662594,33.4881086,0.9863524,103.3798945),(52514,'hindlimb',41,8,22,291.0255033,52.0840951,119.9607171,1.8,52.2190647,119.7529814,1.5505175,15.2620676,18.0705192,13453.9355568,17606.2924781,48.4843068,974.3102729,881.5277111,1660.2770267,28.1998741,33.5294332,1.0325746,103.3798945),(52515,'hindlimb',41,8,23,307.1026231,51.8034142,120.0876823,1.8,52.0170482,119.8163613,-1.5610993,15.2918785,18.298432,13452.5494484,17771.3168511,51.1789578,971.193423,879.7185654,1651.8875501,27.7150682,33.683264,1.0500679,103.7358597),(52516,'hindlimb',41,8,24,299.8451955,51.4700056,119.5358173,1.8,51.6786651,119.6908612,-1.4328538,15.3070239,18.2533716,11485.9025902,17779.5748073,49.0292992,974.0433279,750.3681098,1584.8162351,26.9348678,33.8473068,1.0673969,105.3071661),(52517,'hindlimb',41,8,25,261.5517256,50.9639231,118.5127159,1.8,51.2168039,118.9701929,-1.2418628,14.7355561,17.6513663,8205.1083498,15387.8945995,39.0430936,871.767904,556.8238012,1332.3184984,26.061346,33.683264,1.0500679,107.1301779),(52518,'hindlimb',41,8,26,238.6271728,50.8622635,118.1435891,1.8,50.882151,118.4438568,-1.1606346,14.6479458,17.2902718,6845.975998,13871.6207355,33.4472714,802.2789295,467.3676496,1195.6631105,24.5173062,33.5294332,1.0325746,98.0151189),(52519,'hindlimb',41,8,27,193.9381701,50.699462,118.0836451,1.8,50.5961409,117.8548171,-1.1098574,13.87532,17.2344626,5163.6170537,10725.3284105,25.9283216,622.3187017,372.1439973,900.7717474,23.3212804,32.8956965,1.1538983,94.8725062),(52520,'hindlimb',41,8,28,168.9685685,50.5196959,118.1144399,1.8,50.4143472,117.7067902,-1.078721,13.428146,17.4242233,4424.4328391,8664.727969,21.8753849,497.2805872,329.4894785,734.2213741,22.2814263,32.5032772,1.1485452,93.258014),(52521,'hindlimb',41,8,29,145.1784842,50.2813986,118.2213043,1.8,50.2917375,117.5951111,-1.0541071,12.9728282,17.5877496,3660.3674394,6823.513708,18.2915153,387.9696875,282.1564728,582.5433839,21.5133847,31.7213365,1.076855,92.5460836),(52522,'hindlimb',41,8,30,136.4165874,50.0696767,118.243621,1.8,50.1365285,117.5545044,-1.0582016,12.7779891,18.097974,3342.0728465,6018.9786519,17.2673499,332.5774843,261.5492007,510.0585234,21.1622337,31.7213365,1.076855,91.938413),(52523,'hindlimb',41,8,31,127.0369574,49.9908196,118.1699516,1.8,50.0477495,117.4638727,-1.0721966,12.3510579,17.7344953,2969.3274443,5255.5051931,16.3312017,296.3436578,240.410778,459.2897807,20.6732442,30.7609795,1.0759089,90.4713664),(52524,'hindlimb',41,8,32,123.7341747,49.8702813,118.0254062,1.8,49.9754908,117.3373481,-1.1032268,12.3357113,17.3447784,2815.6418419,4997.9091622,16.4329965,288.1506488,228.251275,448.657202,20.4367909,30.1792736,1.0816765,88.8568742),(52525,'hindlimb',41,8,33,118.1691491,49.8689592,117.7414463,1.8,49.9092441,117.2489365,-1.1640205,12.0498878,16.6984324,2547.1580708,4732.3430889,16.6118412,283.4004408,211.3843807,435.520275,19.8808384,29.3323044,1.0153026,82.424203),(52526,'hindlimb',41,8,34,116.5518307,49.8132747,117.499325,1.8,49.7885789,117.1900285,-1.192698,12.0021087,14.3928803,2399.4493257,4798.6315998,16.7781308,333.4031469,199.9189797,499.3648386,19.6516393,26.9712662,1.0358413,76.807722),(52527,'hindlimb',41,8,35,113.6006876,49.9029074,117.034404,1.8,49.8625678,116.7655551,-1.2239392,11.6336129,14.0395883,2191.4597763,4987.692123,16.7454655,355.259145,188.3731045,507.5744784,19.21731,26.8271256,1.0138948,77.8756176),(52528,'hindlimb',41,8,36,112.9874863,49.900448,116.667748,1.8,49.8670099,116.4801003,-1.2472375,11.4314825,13.9197351,2074.5812849,5240.791474,16.9276429,376.5008046,181.4796358,521.6756418,18.8338583,26.9712662,1.0358413,77.1636872),(52529,'hindlimb',41,8,37,112.5826391,50.085959,116.0880865,1.8,50.0030995,116.084817,-1.2570771,11.2694321,13.8576733,1910.6481977,5660.8184226,16.9768422,408.4970341,169.5425444,541.4238225,18.5593046,27.1282558,1.0575441,77.6239122),(52530,'hindlimb',41,8,38,112.7749919,50.1332429,115.7298012,1.8,50.0261376,115.7792916,-1.2591799,11.0496468,14.0442908,1812.4897286,5924.7365557,17.0289844,421.8608573,164.0314626,550.7788305,18.046896,27.1384627,1.1638255,76.5560166),(52531,'hindlimb',41,8,39,113.0809771,50.257982,115.3558217,1.8,50.1345358,115.5092276,-1.2614061,10.9040111,14.0600373,1690.810477,6159.0014917,17.0996009,438.0501538,155.0631653,557.724771,17.9048309,27.2978727,1.0789872,76.9119818),(52532,'hindlimb',41,8,40,113.6269836,50.2545097,115.1827342,1.8,50.1308011,115.3885438,-1.2639147,10.8186704,14.1566966,1622.749942,6253.4935436,17.2096251,441.7339513,149.9953217,556.0260128,17.6802307,27.3418007,1.0438531,76.807722),(52533,'hindlimb',41,8,41,111.9409038,50.313525,115.035151,1.8,50.2246976,115.182257,-1.2656255,10.5187792,14.2780707,1525.0523315,6196.3718826,16.9725946,433.9782319,144.9837759,539.3228067,17.18752,27.4899593,1.1351135,75.8440862),(52534,'hindlimb',41,8,42,111.3430326,50.2896603,114.9304007,1.8,50.1853719,115.131537,-1.2731765,10.5348422,14.3107827,1474.257533,6123.115959,16.9613868,427.8672998,139.9411123,530.5105498,17.18752,27.3418007,1.0438531,75.8440862),(52535,'hindlimb',41,8,43,108.5618066,50.3573786,114.8656961,1.8,50.2517912,115.011572,-1.2806073,10.0385956,14.3479662,1389.8756564,5951.0205534,16.6122674,414.7640487,138.4531967,510.3724467,16.7145287,27.3113965,1.1493771,74.9847102),(52536,'hindlimb',41,8,44,107.8345253,50.3307659,114.8003779,1.8,50.2535425,114.9520328,-1.2864347,10.050957,14.4071596,1344.6538782,5889.0014575,16.5578951,408.7552036,133.7836659,499.2103674,16.7145287,27.3113965,1.1493771,74.8804504),(52537,'hindlimb',41,8,45,106.2008697,50.3807484,114.754807,1.8,50.3040875,114.8518752,-1.2932526,9.85997,14.3987902,1279.8123499,5746.3468633,16.3713452,399.0853929,129.7988079,486.946079,16.328144,27.1010186,1.1284221,74.7330048),(52538,'hindlimb',41,8,46,105.2397774,50.3320114,114.7154144,1.8,50.2503562,114.7701276,-1.29653,9.6031956,14.4895367,1241.9749759,5700.2442063,16.2533237,393.404174,129.3293423,478.4398686,15.898456,26.9712662,1.1784562,74.0210744),(52539,'hindlimb',41,8,47,104.6000003,50.3919453,114.6642756,1.8,50.3210359,114.7343755,-1.3052419,9.5079704,14.4171808,1195.6712437,5556.985291,16.2325777,385.4418814,125.7546243,467.555413,15.898456,26.8099144,1.1932661,74.0210744),(52540,'hindlimb',41,8,48,104.4342793,50.3712864,114.6539894,1.8,50.3022895,114.7433076,-1.313499,9.481201,14.4049442,1176.0823066,5504.1633139,16.2786265,382.1023694,124.0435996,462.6422175,15.8833242,26.8099144,1.1932661,73.769369),(52541,'hindlimb',41,8,49,102.8480685,50.4209355,114.6496409,1.8,50.368773,114.7466552,-1.3209289,9.3891624,14.3806563,1132.6019399,5384.1995044,16.0932343,374.4056867,120.6286454,451.9476724,15.468768,26.6545133,1.2082521,72.8057332),(52542,'hindlimb',41,8,50,102.4087568,50.3713581,114.62627,1.8,50.3304058,114.6965224,-1.3269034,9.302488,14.3633838,1106.6473642,5322.5704704,16.0728214,370.5652193,118.962514,446.0689808,15.468768,26.5747352,1.1722739,72.3023224),(52543,'hindlimb',41,8,51,101.5748926,50.4218238,114.6581084,1.8,50.3931755,114.751018,-1.3360788,9.1927705,14.371038,1071.5558922,5214.4753482,16.0134852,362.8461184,116.565065,435.7093881,15.4399156,26.4109609,1.1872688,72.050617),(52544,'hindlimb',41,8,52,101.2160915,50.3772813,114.6587479,1.8,50.3442635,114.7173125,-1.3435203,8.8706059,14.468662,1052.046295,5145.277212,16.0128731,355.6152745,118.5991476,424.9065544,15.03908,26.5747352,1.1722739,71.9463572),(52545,'hindlimb',41,8,53,99.9280331,50.4139727,114.7112123,1.8,50.3735439,114.7498146,-1.351034,8.7750386,14.4976352,1024.9442579,5014.5461578,15.8631927,345.8871803,116.8022505,413.0485462,14.609392,26.4109609,1.1872688,70.731016),(52546,'hindlimb',41,8,54,99.3221611,50.3808896,114.7037178,1.8,50.3422461,114.7582731,-1.3584618,8.7610224,14.392207,1009.3043469,4947.7616544,15.8185039,343.7806059,115.2039461,411.3035359,14.609392,26.2531984,1.2024474,70.9827214),(52547,'hindlimb',41,8,55,98.9934046,50.409448,114.6810022,1.8,50.380918,114.772269,-1.3658541,8.6894964,14.3517674,984.7920697,4836.6751939,15.8155728,337.0090297,113.3313167,402.7928395,14.609392,26.1015566,1.2178059,70.4793106),(52548,'hindlimb',41,8,56,99.0145534,50.3662466,114.6792893,1.8,50.3516211,114.788545,-1.3710669,8.6977652,14.349574,978.9798374,4818.6668345,15.852821,335.8055681,112.5553311,400.8075191,14.609392,26.1015566,1.2178059,70.4793106),(52549,'hindlimb',41,8,57,97.9109589,50.4205168,114.7046027,1.8,50.3940233,114.8447467,-1.3797468,8.581911,14.3477574,953.3702423,4706.1962834,15.730081,328.0091903,111.0906695,391.0800644,14.5821425,25.9561429,1.2333403,70.2276052),(52550,'hindlimb',41,8,58,98.2844745,50.3698686,114.7151554,1.8,50.3575294,114.8392925,-1.3848972,8.5952278,14.357568,946.8419613,4690.2362226,15.8211431,326.6734467,110.15903,388.8246613,14.564277,25.8527955,1.1964627,70.1233454),(52551,'hindlimb',41,8,59,97.2601039,50.4155775,114.7255088,1.8,50.4306989,114.8600041,-1.390369,8.5115999,14.3483314,924.4400415,4590.4523023,15.6880177,319.929348,108.6094332,380.5204138,14.179704,25.8527955,1.1964627,68.9080042),(52552,'hindlimb',41,8,60,96.3997757,50.3843078,114.7070724,1.8,50.3906836,114.8359031,-1.3948749,8.5151245,14.3263018,916.5183453,4550.4668727,15.574502,317.6302524,107.6341679,377.4116198,14.1697056,25.8527955,1.1964627,68.9080042),(52553,'hindlimb',41,8,61,95.3329957,50.4160113,114.742169,1.8,50.4261428,114.8932581,-1.4024559,8.4262066,14.2669517,904.9429674,4490.0533644,15.442804,314.7170794,107.3962475,375.2071376,14.179704,25.5510854,1.2277724,68.9080042),(52554,'hindlimb',41,8,62,94.9524305,50.368418,114.723878,1.8,50.3813443,114.8818611,-1.4066851,8.4471737,14.2489873,899.0268526,4457.9819538,15.4029998,312.8630721,106.4293078,372.6603277,14.1697056,25.5510854,1.2277724,68.9080042),(52555,'hindlimb',41,8,63,94.9705579,50.4046446,114.7637974,1.8,50.4345222,114.9197566,-1.4119483,8.3687649,14.2724787,894.8024483,4387.6894596,15.4323803,307.4230863,106.9216854,366.7708081,14.1359927,25.5510854,1.2277724,68.6562988),(52556,'hindlimb',41,8,64,94.9377159,50.3648845,114.7630683,1.8,50.385982,114.907708,-1.4160195,8.3800426,14.2699022,895.2006136,4372.5115294,15.4469171,306.4149613,106.8253056,365.4692386,14.1359927,25.5510854,1.2277724,68.6562988),(52557,'hindlimb',41,8,65,94.8899354,50.415142,114.7431277,1.8,50.4477993,114.9343858,-1.4185845,8.3156159,14.1721668,887.1734994,4329.2761483,15.4514015,305.4773626,106.6876477,365.7675077,14.1359927,25.2750064,1.259798,68.4045934),(52558,'hindlimb',41,8,66,94.8707449,50.3667492,114.7500596,1.8,50.4037969,114.9092916,-1.4192404,8.3578355,14.1852761,885.7808173,4321.3191758,15.4513789,304.6341256,105.9820834,364.6158584,14.1359927,25.2750064,1.259798,68.4045934),(52559,'hindlimb',41,8,67,94.822293,50.425309,114.7609725,1.8,50.4543485,114.9533063,-1.4198705,8.2939141,14.250822,883.3068696,4284.0857702,15.4464541,300.6202564,106.5006045,358.9953723,14.1359927,25.409788,1.2436982,68.152888),(52560,'hindlimb',41,8,68,95.2381062,50.3826743,114.7651595,1.8,50.434629,114.9454701,-1.4202209,8.3329989,14.2606467,884.7609892,4287.5880616,15.515841,300.6587387,106.1755799,358.9322099,14.1359927,25.409788,1.2436982,68.4045934),(52561,'hindlimb',41,8,69,94.9706139,50.4072544,114.8373019,1.8,50.4615118,114.9997769,-1.4234541,8.2755659,14.258543,880.9505339,4235.8671077,15.4872839,297.075733,106.451999,356.4576789,14.0987743,25.2750064,1.259798,68.152888),(52562,'hindlimb',41,8,70,95.6765787,50.3675108,114.8255209,1.8,50.4246095,114.9978243,-1.4247143,8.2453352,14.2505717,884.0861784,4254.5491429,15.6082211,298.5528748,107.2225885,358.0020017,14.1257459,25.2750064,1.259798,68.4045934),(52563,'hindlimb',41,8,71,95.788141,50.4020118,114.8380708,1.8,50.4686896,115.0183948,-1.4278097,8.2504547,13.9498519,882.3209537,4224.3413535,15.6405075,302.8233839,106.9421002,359.7019589,14.0987743,25.0032637,1.2381766,67.7969228),(52564,'hindlimb',41,8,72,95.5966835,50.366419,114.8607083,1.8,50.4259518,115.0215024,-1.4290219,8.2133481,13.9133695,882.8172802,4208.8135668,15.6146719,302.5013872,107.4856764,361.2153045,14.1257459,24.895961,1.199905,67.7969228),(52565,'hindlimb',41,8,73,96.0624591,50.425614,114.9284739,1.8,50.4672078,115.0445595,-1.4330248,8.1783145,13.9632028,881.9866655,4182.2036522,15.7084341,299.5160718,107.8445526,358.0686995,14.0882962,24.8662788,1.2545102,67.5452174),(52566,'hindlimb',41,8,74,96.8104416,50.3898522,114.9404162,1.8,50.4459857,115.0773811,-1.4370824,8.1840816,13.9705679,889.0209313,4183.2083366,15.8483031,299.4300841,108.6280627,358.0818273,14.0882962,24.895961,1.199905,67.5452174),(52567,'hindlimb',41,8,75,97.4112222,50.4300733,115.000419,1.8,50.4669863,115.1367735,-1.4425813,8.0983366,13.9569212,890.353004,4144.345068,15.969771,296.9383434,109.9427011,357.2893073,14.0571115,24.7360003,1.2710203,67.1892522),(52568,'hindlimb',41,8,76,97.6885055,50.3926058,115.034781,1.8,50.4254855,115.1962429,-1.4443899,8.1186598,13.9921975,894.4257963,4152.5803273,16.0226461,296.7782808,110.1691431,357.072097,14.0571115,24.7434633,1.2160907,66.9375468),(52569,'hindlimb',41,8,77,97.7800381,50.4414801,115.047979,1.8,50.4824148,115.193252,-1.4471374,8.049577,13.9937185,893.3253376,4117.354843,16.0487395,294.2287895,110.9779228,354.5056745,14.0571115,24.7360003,1.2710203,66.9375468),(52570,'hindlimb',41,8,78,97.8599893,50.4017793,115.0880033,1.8,50.4325421,115.2196509,-1.4501392,8.0634151,14.0321987,896.6111847,4107.6412972,16.0737049,292.729698,111.1949676,352.8265781,14.0571115,24.7434633,1.2160907,66.9375468),(52571,'hindlimb',41,8,79,97.4248178,50.4552062,115.1513984,1.8,50.5007178,115.270437,-1.454651,7.9718681,14.0297218,894.606,4027.1466547,16.0194136,287.0439422,112.2203714,348.4335583,14.0121968,24.6125346,1.2877005,66.9375468),(52572,'hindlimb',41,8,80,97.0702129,50.4108829,115.1822518,1.8,50.4493376,115.330022,-1.4580888,7.9888038,13.7293316,897.5969697,3997.8683121,15.9737239,291.1917666,112.3568671,350.1925366,13.9968919,24.4582697,1.2490458,66.9375468),(52573,'hindlimb',41,8,81,96.6960258,50.4571548,115.2566211,1.8,50.5180195,115.3880611,-1.4651116,7.9319448,13.779582,895.0766316,3921.03387,15.9366695,284.5539061,112.844536,343.1074052,13.9140011,24.4582697,1.2490458,66.4773219),(52574,'hindlimb',41,8,82,96.9594898,50.4099803,115.3422937,1.8,50.4623454,115.4585431,-1.4702923,7.9325273,13.8124017,901.5630733,3884.5783917,15.9972315,281.2384457,113.6539516,341.5740413,13.9462236,24.3409814,1.2099595,66.5815817),(52575,'hindlimb',41,8,83,97.0825217,50.4358507,115.4473349,1.8,50.5114224,115.5581068,-1.480804,7.8210036,13.8505404,901.8018974,3763.0283356,16.0497347,271.688197,115.3051371,333.2076719,13.8807107,24.2002479,1.2827409,65.9739111),(52576,'hindlimb',41,8,84,96.8336604,50.3764184,115.5505748,1.8,50.4376966,115.6739729,-1.4887382,7.8144074,13.5134515,905.018915,3665.3484933,16.0305149,271.2370328,115.814146,333.6779925,13.9379103,23.788577,1.2204821,64.7585699),(52577,'hindlimb',41,8,85,95.7528372,50.4154053,115.6975067,1.8,50.4881127,115.877987,-1.4997432,8.0839909,13.203233,903.8477426,3529.5244085,15.878373,267.3227387,111.8071203,330.5221988,13.8371946,23.3775546,1.2722974,63.5432287),(52578,'hindlimb',41,8,86,95.8001141,50.3646096,115.7839058,1.8,50.4381641,115.8816536,-1.5076774,8.0763295,13.246387,907.0168444,3450.4441875,15.903159,260.4819101,112.3055776,324.9527321,13.9310346,23.2548162,1.2899586,63.6474885),(52579,'hindlimb',41,8,87,95.2474497,50.3981519,115.9535462,1.8,50.4913208,116.0822539,-1.5209872,7.9670782,12.934671,907.4570942,3287.5307,15.8352234,254.1642297,113.9008643,321.185851,13.8435884,22.724768,1.3028859,62.5795929),(52580,'hindlimb',41,8,88,95.2178526,50.3475527,116.0542855,1.8,50.4458283,116.1547229,-1.5300104,7.9327114,12.591185,910.8906072,3205.8711661,15.8432578,254.612348,114.8271464,322.9381003,13.8162791,22.3106986,1.2977876,61.7202169),(52581,'hindlimb',41,8,89,94.6042037,50.3906129,116.1710029,1.8,50.4786165,116.3102444,-1.5417767,7.8215051,12.2527835,912.5646692,3075.1341569,15.7540927,250.9743332,116.6737935,320.7474566,13.7585062,21.897231,1.2924967,60.8608409),(52582,'hindlimb',41,8,90,94.0904238,50.3554159,116.264766,1.8,50.4232783,116.4037898,-1.5520722,7.7832267,12.3087638,915.0500541,2999.2268435,15.67624,243.6659668,117.566928,315.9509287,13.6965423,21.6939254,1.4317004,60.6091355),(52583,'hindlimb',41,8,91,93.8253374,50.41556,116.3831719,1.8,50.5068489,116.4974604,-1.5623431,7.6506906,11.9855205,916.6294276,2885.8905215,15.6364388,240.7814102,119.810025,313.3259357,13.6639946,21.3680693,1.3063079,59.6454997),(52584,'hindlimb',41,8,92,93.8497871,50.374027,116.4541226,1.8,50.4559727,116.55287,-1.5688259,7.6473681,11.6142634,921.0374088,2825.4828264,15.6415705,243.2769707,120.4384826,317.7850145,13.59578,20.9536242,1.3009472,59.0378291),(52585,'hindlimb',41,8,93,93.4998819,50.4311214,116.588575,1.8,50.529991,116.6967661,1.5607984,7.5219637,11.3117295,924.5238846,2722.7179767,15.581756,240.6986472,122.9099112,317.4601864,13.562709,20.5398055,1.2953702,58.7861237),(52586,'hindlimb',41,8,94,93.9216816,50.397078,116.6521468,1.8,50.4864513,116.7806991,1.5527797,7.5126561,11.3634843,928.8906786,2671.4946985,15.648533,235.0946792,123.6434447,314.7707329,13.5379546,20.4180938,1.422947,58.5344183),(52587,'hindlimb',41,8,95,93.5927013,50.4609232,116.7281105,1.8,50.5696195,116.8618271,1.5421067,7.7965824,11.0133761,927.6953341,2587.4487365,15.5859478,234.9369263,118.9874334,315.8061164,13.4654613,20.0623347,1.3986055,58.0310075),(52588,'hindlimb',41,8,96,93.3648769,50.4332239,116.808788,1.8,50.5341734,116.9644156,1.5340929,7.7757735,11.0723867,931.5848793,2532.6232971,15.5398596,228.733277,119.8060718,311.3179428,13.5545757,19.9931938,1.419781,57.7793021),(52589,'hindlimb',41,8,97,93.1543407,50.5067545,116.9284978,1.8,50.5964797,117.0856736,1.5215386,7.6487818,10.7727959,932.1731882,2458.9873673,15.4880835,228.2589769,121.8721118,312.6338501,13.5260245,19.6391391,1.3948567,57.1716315),(52590,'hindlimb',41,8,98,93.1053294,50.4911741,117.0091301,1.8,50.6155315,117.2205061,1.5113656,7.6085419,10.4665138,940.2677821,2415.2630427,15.4628112,230.7609862,123.5805485,317.945246,13.4759738,19.8076381,1.9956285,56.8156663),(52591,'hindlimb',41,8,99,93.0570454,50.565873,117.0746622,1.8,50.686418,117.2933273,1.5012011,7.4780733,10.5069226,940.3619781,2350.6557858,15.4345086,223.7244789,125.749233,311.6735415,13.3290119,19.6344379,1.9756881,56.5639609),(52592,'hindlimb',41,8,100,93.3303564,50.5484292,117.1378017,1.8,50.6612279,117.3757153,1.4944055,7.4598769,10.169676,946.5986129,2317.7306143,15.4644633,227.9060422,126.891989,317.1171556,13.4322143,19.4169537,2.0047497,55.9562903),(52593,'hindlimb',41,8,101,93.1609987,50.6317901,117.2395537,1.8,50.7470199,117.4209168,1.4829809,7.3177586,10.2391794,945.8414304,2253.5932161,15.4074047,220.0951,129.2528868,310.9439263,13.2817344,19.4169537,2.0047497,55.6003251),(52594,'hindlimb',41,8,102,93.0793131,50.6141377,117.315102,1.8,50.7312808,117.5354119,1.4764488,7.3038461,9.9216741,950.5604318,2212.940735,15.375538,223.0410623,130.1451895,312.2919761,13.2378941,19.2402368,2.0844023,55.3486197),(52595,'hindlimb',41,8,103,93.0901672,50.7132925,117.3812534,1.8,50.8438528,117.5525547,1.4646623,7.524432,9.9498031,953.9369716,2153.225342,15.3409152,216.4088388,126.7786016,308.0156092,13.4327499,19.0328019,2.0647377,55.0969143),(52596,'hindlimb',41,8,104,93.0841807,50.6997253,117.4326138,1.8,50.8209861,117.6239518,1.456378,7.4909753,9.9447631,957.3080826,2118.8840932,15.3118122,213.0653155,127.7948531,305.52553,13.3846284,19.0328019,2.0647377,54.8452089),(52597,'hindlimb',41,8,105,92.3455976,50.8002172,117.5106372,1.8,50.9243469,117.6664619,1.4469942,7.3409245,9.7031257,954.0655733,2061.7941076,15.1562393,212.4876216,129.9653164,295.7172023,13.2717859,18.9501664,2.146221,54.4892437),(52598,'hindlimb',41,8,106,92.2763887,50.7891792,117.5669651,1.8,50.91461,117.7286526,1.4398822,7.3139805,9.6994608,957.2095555,2031.0317124,15.1173205,209.3963523,130.8739552,293.7465043,13.1732898,18.8328873,2.177784,54.4892437),(52599,'hindlimb',41,8,107,91.5412744,50.8902276,117.6713339,1.8,51.0099646,117.8496157,1.4284257,7.216702,9.4434308,955.330291,1971.8503368,14.949715,208.8065646,132.377683,291.8657258,13.2203788,18.7198054,2.1269626,53.9858329),(52600,'hindlimb',41,8,108,91.5484359,50.8849783,117.7264985,1.8,50.9964864,117.8503664,1.4209507,7.186025,9.4947134,960.1119028,1944.4974996,14.9180288,204.7979151,133.6082057,290.4593982,13.2801238,18.7198054,2.1269626,53.9858329),(52601,'hindlimb',41,8,109,90.8504159,50.9827052,117.8178105,1.8,51.085238,117.959914,1.4110481,7.333073,9.4594739,957.6563772,1892.1224743,14.7586025,200.0240707,130.5941424,285.8285262,13.1719762,18.5911454,2.1587989,53.9858329),(52602,'hindlimb',41,8,110,91.3157999,50.9873021,117.8752151,1.8,51.1018636,117.9958686,1.4026124,7.2809053,9.2981869,961.2828655,1873.8640799,14.7928531,201.5300518,132.0279307,285.3745528,13.1122313,18.4965587,2.1072318,53.3781623),(52603,'hindlimb',41,8,111,91.1320073,51.0905015,117.9287065,1.8,51.1965844,118.0313424,1.3916869,7.1911544,9.2157378,960.111288,1828.9876352,14.7066009,198.4635066,133.5128187,277.2036428,13.1798857,18.4815797,2.1910458,53.0221971),(52604,'hindlimb',41,8,112,91.131224,51.0945339,117.9791387,1.8,51.2016023,118.0875583,1.3850149,7.1540154,8.9966946,964.3742401,1805.1455818,14.6703126,200.6454223,134.801812,276.1467615,13.1798857,18.3914495,2.223643,53.0221971),(52605,'hindlimb',41,8,113,90.7799201,51.1834755,118.0299601,1.8,51.3184416,118.1642,1.3739574,7.0061654,8.9795539,959.6699962,1767.2274004,14.551299,196.805702,136.9750708,274.6900703,13.0051158,18.2351811,2.1718701,52.4145265),(52606,'hindlimb',41,8,114,91.2518501,51.1836795,118.0681564,1.8,51.3303899,118.1815261,1.367691,7.0603913,9.0141688,964.1528411,1750.0887943,14.589838,194.1486596,136.5579897,274.0260025,13.1073007,18.2351811,2.1718701,52.4145265),(52607,'hindlimb',41,8,115,90.4150765,51.3098948,118.1090341,1.8,51.4194974,118.2227256,1.3570581,6.8821702,8.7464182,959.382459,1697.602339,14.3911782,194.0911472,139.4011528,271.722675,13.0811702,18.1336482,2.204819,52.1628211),(52608,'hindlimb',41,8,116,90.6183394,51.3038697,118.1449725,1.8,51.3914898,118.2175336,1.353784,6.8762833,8.6877878,961.5238791,1674.5249657,14.4028834,192.7446895,139.8319184,270.0167047,13.1073007,18.0520106,2.2381025,51.8068559),(52609,'hindlimb',41,8,117,90.5379966,51.4056215,118.2218319,1.8,51.5213983,118.3183054,1.3377387,7.0177425,8.6789679,960.6028308,1641.5788491,14.28479,189.144477,136.8820282,266.648351,13.0190959,17.8824562,2.1854593,52.0153755),(52610,'hindlimb',41,8,118,90.31476,51.4139999,118.2683071,1.8,51.513525,118.3588234,1.3292675,6.8629351,8.6154161,961.656094,1618.2963196,14.1913002,187.8372785,140.1231512,265.2228302,12.9257067,17.7892908,2.2191283,51.6594103),(52611,'hindlimb',41,8,119,90.2804073,51.546919,118.3374837,1.8,51.6863426,118.4422036,1.3126514,6.7462838,8.495882,959.7343172,1585.3464423,14.0661139,186.6017492,142.2611824,265.7220553,13.0012368,17.533166,2.1995926,51.0517397),(52612,'hindlimb',41,8,120,90.0173909,51.5409025,118.3852624,1.8,51.6830144,118.4941842,1.3071914,6.7369695,8.5376856,960.1961202,1570.4476794,13.9843084,183.9430199,142.5264171,264.7570299,13.0012368,17.533166,2.1995926,51.0517397),(52613,'hindlimb',41,8,121,89.3641301,51.653063,118.4542745,1.8,51.7936955,118.5526502,1.2956898,6.731519,8.3942732,956.8349679,1536.0613617,13.7949409,182.9892027,142.142504,258.1839784,12.8827211,17.6643059,2.287338,51.3034451),(52614,'hindlimb',41,8,122,89.1738475,51.6432262,118.4939149,1.8,51.8107902,118.6540341,1.2899568,6.7188264,8.3024775,956.8484117,1519.0702754,13.7206002,182.9659003,142.4130289,256.7830652,12.8827211,17.3851149,2.2686991,51.4077049),(52615,'hindlimb',41,8,123,88.3373536,51.7412263,118.5495525,1.8,51.8961336,118.6900024,1.2782059,6.6874466,8.3219261,949.2580585,1481.7985095,13.4980372,178.0595613,141.9462641,255.1064255,12.8816302,17.3851149,2.2686991,51.3034451),(52616,'hindlimb',41,8,124,88.2045866,51.7439322,118.5927915,1.8,51.8841765,118.695205,1.2700086,6.6829335,8.2321358,951.0580879,1467.3073534,13.4103685,178.2413941,142.3114706,254.4636083,12.8816302,17.3425824,2.3036114,50.8000343),(52617,'hindlimb',41,8,125,87.889146,51.8722322,118.6469529,1.8,52.025541,118.7551511,1.2551101,6.6632788,8.1740283,949.9997051,1436.6742812,13.2362384,175.7608654,142.5724081,250.9263241,12.8073144,17.1121594,2.2494588,50.2966235),(52618,'hindlimb',41,8,126,88.1114874,51.8847093,118.6783338,1.8,52.025703,118.7836407,1.2418073,6.6745667,8.0588893,952.750674,1423.2996744,13.1523307,176.6123874,142.7434503,250.5010631,12.8073144,17.0581265,2.284887,50.2966235),(52619,'hindlimb',41,8,127,87.9020702,51.9942232,118.7308496,1.8,52.1138779,118.8546752,1.2205645,6.784765,7.9839096,948.7448564,1390.6180281,12.9255849,174.1775762,139.8345946,249.8254319,12.8389837,16.7798528,2.2655346,49.3329877),(52620,'hindlimb',41,8,128,88.087821,52.0085892,118.7820964,1.8,52.1493609,118.9318389,1.2089322,6.7916435,8.0237683,950.5573774,1385.0695399,12.8413118,172.6208305,139.9598456,250.4310729,12.8916905,16.7798528,2.2655346,50.1923637),(52621,'hindlimb',41,8,129,87.5723067,52.1001123,118.8452458,1.8,52.2290797,118.9626461,1.199788,6.706236,7.9488736,943.7424908,1354.5295373,12.6768741,170.4052171,140.7261086,249.3853259,12.769783,16.7357822,2.301703,51.0517397),(52622,'hindlimb',41,8,130,87.4893343,52.0945897,118.8940093,1.8,52.2212722,118.9984261,1.1915591,6.6856962,7.8977408,944.2494031,1342.1615327,12.5830527,169.9424633,141.2342666,248.603823,12.769783,16.7357822,2.301703,49.9406583),(52623,'hindlimb',41,8,131,86.9457895,52.197467,118.9381941,1.8,52.3533803,119.0732384,1.1727825,6.703912,7.7968081,938.2536389,1311.6510406,12.3140656,168.2292317,139.9561395,247.6349826,12.8184823,16.5080739,2.2455373,48.4736117),(52624,'hindlimb',41,8,132,86.6646457,52.1967144,118.9582565,1.8,52.3265702,119.0522941,1.165003,6.7029002,7.8054423,939.3206481,1295.4618925,12.1933427,165.9690569,140.1364507,246.2144586,12.8184823,16.4520572,2.2822555,50.1923637),(52625,'hindlimb',41,8,133,86.1285421,52.3183519,119.0231308,1.8,52.4518756,119.0729208,1.149528,6.6252965,7.7182401,931.3601524,1263.2860949,11.9544389,163.6754085,140.5763735,239.7720197,12.7533411,16.4520572,2.2822555,47.8659411),(52626,'hindlimb',41,8,134,86.4318418,52.3224217,119.0629305,1.8,52.4619587,119.08361,1.1336331,6.6165052,7.7027626,933.0861915,1249.9828922,11.8232547,162.2772194,141.0240246,239.1337671,12.7533411,16.4520572,2.2822555,47.5099759),(52627,'hindlimb',41,8,135,86.5685252,52.4287351,119.115281,1.8,52.575436,119.1574683,1.1073992,6.690531,7.600216,930.780871,1227.0881202,11.5453611,161.4543744,139.119133,239.4714159,12.7980894,16.4183554,2.3191744,47.5099759),(52628,'hindlimb',41,8,136,86.3025436,52.433488,119.1609166,1.8,52.5636596,119.1980485,1.0970527,6.6826606,7.6078531,929.9999985,1218.6974618,11.3899589,160.1894045,139.1661286,239.1828562,12.8333421,16.4183554,2.3932146,47.8659411),(52629,'hindlimb',41,8,137,85.7636426,52.5431782,119.2271793,1.8,52.7204087,119.2972698,1.0775237,6.586568,7.5886784,924.0085512,1201.1265724,11.0890594,158.278755,140.2868014,235.4844674,12.7980894,16.1747714,2.4502557,48.9770225),(52630,'hindlimb',41,8,138,85.4107161,52.5531867,119.2576319,1.8,52.6762296,119.2863839,1.0587085,6.6000201,7.6417502,922.5161199,1185.9622059,10.817291,155.1951022,139.7747434,234.2280116,12.7980894,16.1747714,2.4502557,47.7184955),(52631,'hindlimb',41,8,139,85.2283783,52.6882445,119.3001029,1.8,52.8258083,119.3046803,1.0279549,6.5738846,7.6681142,915.3792568,1162.220463,10.4142591,151.5653571,139.2448009,234.434873,12.7503384,16.1290475,2.4127379,47.6142357),(52632,'hindlimb',41,8,140,85.0490057,52.7130184,119.3507977,1.8,52.8493076,119.3930382,1.0008076,6.5983817,7.7204141,914.4927705,1152.0165665,10.0472288,149.2169392,138.5934926,234.3738159,12.7503384,15.9042615,2.4710711,46.7548597),(52633,'hindlimb',41,8,141,84.731551,52.8652877,119.4280756,1.8,52.9670193,119.4573231,0.9543694,6.6148906,7.7417055,909.3993597,1144.5360636,9.4020005,147.8403007,137.4776112,236.1808598,12.7980894,15.8461105,2.4329664,46.7548597),(52634,'hindlimb',41,8,142,85.1471403,52.8896097,119.475573,1.8,52.9694417,119.4913815,0.9351308,6.6269062,7.7539895,911.0901491,1145.5843334,9.1888618,147.7412798,137.4834843,237.5690138,12.7980894,15.8461105,2.4329664,46.7548597),(52635,'hindlimb',41,8,143,85.0699306,53.0229693,119.5323099,1.8,53.1122165,119.5297045,0.9020577,6.653643,7.7319855,905.0778178,1133.9469156,8.7282315,146.6566278,136.0274094,235.1909846,12.7487535,15.7350314,2.5308667,46.7548597),(52636,'hindlimb',41,8,144,85.5304471,53.0520596,119.5806699,1.8,53.1287289,119.610524,0.867493,6.6825093,7.7747136,906.2205777,1130.7311509,8.2925546,145.4370161,135.6108213,236.1911311,12.7487535,15.7350314,2.5308667,46.1471891),(52637,'hindlimb',41,8,145,85.7968204,53.2040009,119.6598347,1.8,53.2689342,119.6377528,0.8422966,6.5474609,7.6805955,900.9691674,1118.4826656,7.9615975,145.6244714,137.6058875,238.8896876,12.8441052,15.5698916,2.4539214,45.7912239),(52638,'hindlimb',41,8,146,85.663326,53.2176481,119.7000994,1.8,53.3071756,119.6783946,0.8287257,6.5170046,7.6744319,898.7812109,1112.4368412,7.7564339,144.9536401,137.9132378,238.7046185,12.8441052,15.5698916,2.4539214,45.7912239),(52639,'hindlimb',41,8,147,85.427333,53.333141,119.7388324,1.8,53.4155529,119.7035734,0.80124,6.5316854,7.6286836,892.1041982,1099.591482,7.3444614,144.1390861,136.5810114,239.8478601,12.8230503,15.3849907,2.5148498,45.5395185),(52640,'hindlimb',41,8,148,84.9482415,53.3582334,119.7774648,1.8,53.4203811,119.7438829,0.774753,6.5190728,7.6498545,889.0739153,1093.5579294,6.9283166,142.9514676,136.3804251,239.8492171,12.8531659,15.3849907,2.5148498,45.5395185),(52641,'hindlimb',41,8,149,84.7884511,53.4759394,119.8385235,1.8,53.5075903,119.8071247,0.7390367,6.5798633,7.6286872,882.2282037,1079.5979804,6.4114903,141.5181865,134.0800211,241.1844133,12.8441052,15.1369758,2.5378433,44.9318479),(52642,'hindlimb',41,8,150,84.7905212,53.4985314,119.8743293,1.8,53.5214497,119.8268792,0.719681,6.5762902,7.6412982,880.8323778,1078.5300595,6.1398497,141.1448722,133.9406188,241.9027436,12.7216419,15.1369758,2.5378433,44.9318479),(52643,'hindlimb',41,8,151,84.7755828,53.6324938,119.8993213,1.8,53.7254636,119.8467931,0.6952882,6.5943959,7.8609349,875.3156515,1070.7626022,5.7983254,136.2131374,132.7362905,239.1549446,12.8531659,15.3007547,2.4756234,45.1835533),(52644,'hindlimb',41,8,152,84.9637394,53.657551,119.9357697,1.8,53.7213028,119.8781036,0.6743912,6.5686046,7.5925189,875.3688966,1071.2172221,5.5212652,141.0885158,133.2655794,241.366371,12.8531659,15.03908,2.4980915,44.9318479),(52645,'hindlimb',41,8,153,84.977335,53.7845678,120.0001307,1.8,53.8683505,119.9362091,0.6563766,6.4750359,7.5707598,870.9271382,1060.8334778,5.2743382,140.1224592,134.5053768,240.0779541,12.7585235,14.8972278,2.5615899,44.4284371),(52646,'hindlimb',41,8,154,84.7911926,53.7978405,120.0257545,1.8,53.8874682,119.9736035,0.6499691,6.4660972,7.5619944,871.0803218,1056.0896609,5.1753836,139.6575565,134.7150064,240.1176302,12.7610825,14.8972278,2.5615899,44.7844023),(52647,'hindlimb',41,8,155,84.7122485,53.9190987,120.061061,1.8,53.9823819,120.0705967,0.6330814,6.5166959,7.4876812,866.9039146,1041.26079,4.9419457,139.0631844,133.028137,241.5493931,12.7610825,14.7852638,2.5213432,44.4284371),(52648,'hindlimb',41,8,156,84.8804873,53.9310192,120.0845358,1.8,54.0080081,120.0752769,0.6279561,6.5059513,7.4770499,868.1942939,1035.7484634,4.8827061,138.5236801,133.4461723,241.5796746,12.7610825,14.6661522,2.5860989,44.1767317),(52649,'hindlimb',41,8,157,84.5203993,54.0486466,120.1479776,1.8,54.1254508,120.1218707,0.6224,6.5240114,7.3582215,861.7103406,1021.6096166,4.7877084,138.839204,132.0828992,243.0096998,12.7610825,14.5397175,2.5453935,43.8207665),(52650,'hindlimb',41,8,158,84.5091536,54.0631749,120.1766602,1.8,54.1333638,120.1460138,0.6126866,6.5089309,7.353125,862.2084943,1017.1600848,4.6578994,138.3303138,132.4654559,243.2025458,12.7610825,14.5397175,2.5453935,43.8207665),(52651,'hindlimb',41,8,159,83.9620281,54.1641938,120.201352,1.8,54.2173518,120.160549,0.6084366,6.4391362,7.2661543,856.2044946,1002.1224117,4.5718699,137.9164785,132.9688429,243.753836,12.8891543,14.3028672,2.5702552,43.8207665),(52652,'hindlimb',41,8,160,83.6522383,54.1786329,120.2263317,1.8,54.261324,120.1783236,0.6060989,6.4249909,7.2454316,855.4000325,995.7546201,4.5244556,137.4320636,133.1363796,238.7255664,12.8891543,14.3415411,2.9912212,44.1767317),(52653,'hindlimb',41,8,161,83.2991441,54.3039939,120.2525009,1.8,54.3870178,120.2218869,0.5739568,19.2543125,13.8409806,854.5110705,984.5103057,4.0928279,71.1300979,44.3802433,77.553649,12.7610825,14.283491,2.8674252,43.9250263),(52654,'hindlimb',41,8,162,83.0251617,54.3129488,120.2724455,1.8,54.4337988,120.2396741,0.6023188,6.4377613,7.1172797,849.4478072,974.7120182,4.4416287,136.9500792,131.9477016,237.5807652,12.7610825,14.283491,2.8674252,43.5690611),(52655,'hindlimb',41,8,163,82.7196241,54.4216955,120.2905401,1.8,54.5446949,120.2656624,0.614843,6.3749626,6.9894316,844.1564881,959.2413954,4.5872604,137.2416882,132.41748,238.2980478,12.7610825,14.1731921,2.896614,42.9613905),(52656,'hindlimb',41,8,164,82.620874,54.437705,120.3175872,1.8,54.5590684,120.2686661,0.6256644,6.3625878,6.9355502,843.6842491,954.3421925,4.72274,137.6015122,132.6008028,238.2309503,12.7610825,14.0751518,2.926235,42.9613905),(52657,'hindlimb',41,8,165,82.4362982,54.5482949,120.3595694,1.8,54.6448052,120.2976291,0.6327114,6.3940424,6.8046932,837.1562562,943.9793758,4.8043231,138.7247511,130.9275429,239.6794813,12.7610825,13.9896277,2.9562447,42.9613905),(52658,'hindlimb',41,8,166,82.6303854,54.5682207,120.3875389,1.8,54.674373,120.3151309,0.6348919,6.3834991,6.766848,837.7931794,944.0370806,4.8442931,139.5091299,131.2435651,240.5589483,12.7610825,13.9896277,2.9562447,42.7096851),(52659,'hindlimb',41,8,167,82.3880142,54.6997707,120.4258712,1.8,54.8002528,120.350222,0.6529436,6.4337041,6.6747315,832.1038375,936.1268536,5.0680883,140.2493654,129.3351121,240.486265,12.7610825,13.9168507,2.9865959,43.0656503),(52660,'hindlimb',41,8,168,82.6877331,54.7219704,120.4588621,1.8,54.8115274,120.380914,0.6582943,6.4216884,6.6203914,834.2655891,936.5601292,5.1577939,141.4659751,129.9137458,241.7868066,12.7610825,13.9168507,2.9865959,43.0656503),(52661,'hindlimb',41,8,169,82.7699782,54.8385944,120.5206918,1.8,54.9479421,120.4632851,0.6591044,6.2577177,6.6743945,829.3063442,928.7765537,5.1737424,139.1551788,132.5253688,244.2860416,12.4572472,13.7567282,2.8890384,42.4579797),(52662,'hindlimb',41,8,170,82.997355,54.8545965,120.553469,1.8,54.9610015,120.5233216,0.6573459,6.2427759,6.6455094,829.9336492,926.7061007,5.1644128,139.4484683,132.9430464,244.8499385,12.4572472,13.7567282,2.8890384,42.1020145),(52663,'hindlimb',41,8,171,83.152166,54.9653866,120.5839043,1.8,55.0352843,120.560463,0.6822804,6.2706203,6.483991,827.3962916,918.0428729,5.5103788,141.5860815,131.9480763,247.2408178,12.4572472,13.6556983,1.9922155,42.1020145),(52664,'hindlimb',41,8,172,83.3056901,54.9806181,120.6140663,1.8,55.0561103,120.5973808,0.6884925,6.252474,6.4389162,829.460426,913.941021,5.6050832,141.940196,132.6611546,247.6904665,12.4572472,13.6556983,2.9195108,42.1020145),(52665,'hindlimb',41,8,173,83.2661341,55.0978937,120.6568983,1.8,55.1556072,120.6075239,0.7260269,6.2669485,6.3677122,825.9479585,901.1973597,6.1168429,141.5260817,131.7942793,249.7623172,12.721464,13.4924769,2.9816795,42.1020145),(52666,'hindlimb',41,8,174,83.4274911,55.1028122,120.6895226,1.8,55.1512986,120.6274416,0.7594281,6.2152546,6.4086592,826.6367962,897.6386012,6.5913509,140.0665218,133.0012758,249.7530822,12.721464,13.4924769,2.9816795,42.1020145),(52667,'hindlimb',41,8,175,83.1195477,55.1966828,120.7115768,1.8,55.2626872,120.6545702,0.7877732,6.239185,6.5010353,821.0332483,884.8932644,6.959531,136.1157447,131.5930279,250.5931579,12.7610825,13.4856331,1.9631365,41.9977547),(52668,'hindlimb',41,8,176,83.1920017,55.2036675,120.7445398,1.8,55.2873934,120.6907393,0.8120058,6.2369487,6.2809154,820.3774794,880.35516,7.3014166,140.1635112,131.5350699,250.3145456,12.7610825,13.4856331,1.9631365,41.7460493),(52669,'hindlimb',41,8,177,82.9071092,55.3132189,120.7977976,1.8,55.3873056,120.743634,0.8247557,6.2643262,6.3970164,811.458204,869.0669339,7.4522008,135.8550428,129.5363907,248.2541428,12.7610825,13.348021,2.1498706,41.7460493),(52670,'hindlimb',41,8,178,82.9146064,55.3231461,120.8269575,1.8,55.4114952,120.7834059,0.8451187,6.2513906,6.4523974,809.8385539,864.6417703,7.7328733,134.0031797,129.545346,247.9743315,12.7610825,13.4856331,1.9631365,41.7460493),(52671,'hindlimb',41,8,179,82.5312997,55.4208729,120.8591954,1.8,55.4774951,120.8066486,0.8790056,6.0823116,6.3616362,800.3961238,850.8720659,8.1576908,133.7505078,131.5940672,248.3103863,12.4572472,13.4856331,1.9631365,40.8866733),(52672,'hindlimb',41,8,180,82.2819349,55.4226516,120.8902115,1.8,55.4847044,120.8515707,0.9335543,6.1720968,6.3938738,799.5677105,846.0759911,8.858988,132.3260377,129.5455555,247.8048689,12.7574788,13.3272566,1.9333406,41.4943439),(52673,'hindlimb',41,8,181,81.9809851,55.5196461,120.9376752,1.8,55.5689656,120.8708328,1.0256656,6.1669257,6.5496033,790.9651417,833.836608,9.9897483,127.3110103,128.2592305,246.1075099,12.4572472,13.3411032,1.8313987,40.8866733),(52674,'hindlimb',41,8,182,81.8324404,55.5193786,120.9698375,1.8,55.5881995,120.9249454,1.0621066,6.145041,6.4199215,788.6014478,829.5731767,10.403611,129.2185856,128.3313572,247.8709195,12.4572472,13.3411032,1.8313987,40.8866733),(52675,'hindlimb',41,8,183,81.3163107,55.5966607,120.9959019,1.8,55.6611225,120.9622311,1.1235085,6.1421382,6.4680526,780.4281844,817.9537348,11.0173427,126.4605881,127.0613195,244.1525542,12.4572472,13.3411032,1.8313987,40.8866733),(52676,'hindlimb',41,8,184,81.1595974,55.5971539,121.026047,1.8,55.6571145,120.9845773,1.1741906,6.2321762,6.474615,778.1631416,814.7704899,11.5081636,125.8407619,124.8621851,245.8216924,12.4572472,13.2717262,2.0778948,40.8866733),(52677,'hindlimb',41,8,185,80.785802,55.6959719,121.0629244,1.8,55.7611101,121.0299092,1.2392031,6.3665175,6.3708731,771.6398421,805.6074889,12.0373174,126.4516621,121.202814,238.3787663,12.4572472,13.2369013,1.8000283,41.2426385),(52678,'hindlimb',41,8,186,80.5673211,55.6946006,121.0923394,1.8,55.738992,121.0488613,1.2955964,6.393307,6.431606,768.3439546,802.7345029,12.4363411,124.8108953,120.1794242,243.0446832,12.4572472,13.2369013,1.8000283,40.8866733),(52679,'hindlimb',41,8,187,80.0598075,55.7888986,121.1124899,1.8,55.8512814,121.0795515,1.3566059,6.4456463,6.4075427,758.8486842,791.608322,12.7404475,123.543199,117.7304256,237.2833439,12.4572472,13.2647685,2.0054665,40.9909331),(52680,'hindlimb',41,8,188,79.9185922,55.7894451,121.1411699,1.8,55.8457338,121.1398065,1.4098167,6.4950052,6.2550113,755.7933722,788.6865307,12.9775626,126.0887465,116.3653229,236.6108379,12.4572472,13.1809902,1.9028558,40.6349679),(52681,'hindlimb',41,8,189,79.6664859,55.8825115,121.1799428,1.8,55.9276117,121.1630642,1.5102369,6.4629668,6.1439418,747.5523594,779.9928233,13.2291117,126.9531587,115.6670594,235.7123828,12.4572472,13.1809902,1.9028558,40.6349679),(52682,'hindlimb',41,8,190,79.4307726,55.8810948,121.2090433,1.8,55.9432985,121.1803325,1.5539307,6.4378693,6.0883967,743.7337638,777.6696905,13.2346968,127.7298,115.5248317,234.5705892,12.4572472,13.1809902,1.9028558,40.2790027),(52683,'hindlimb',41,8,191,79.036332,55.9747181,121.232113,1.8,56.0565828,121.2039476,-1.5366013,6.3536675,6.112307,735.8889511,769.6781462,13.1573251,125.9226904,115.8211309,235.3745878,12.4572472,13.047241,1.8717166,40.5307081),(52684,'hindlimb',41,8,192,78.8316705,55.9709162,121.2626832,1.8,56.0308987,121.2532333,-1.5311103,6.3423074,6.1482127,732.219939,767.9273654,13.1179295,124.9025368,115.4500859,234.2260728,12.4572472,13.1809902,1.9028558,40.2790027),(52685,'hindlimb',41,8,193,78.4175358,56.0608578,121.3055162,1.8,56.1475263,121.2529313,-1.4628235,6.2857641,6.2305314,725.2421681,758.0577415,12.9178136,121.6682313,115.3785221,231.624273,12.4572472,13.047241,1.8717166,40.5307081),(52686,'hindlimb',41,8,194,78.1708566,56.056721,121.335082,1.8,56.1154243,121.2873496,-1.4431276,6.2858445,6.2127115,721.9366419,754.8076952,12.8172722,121.4940836,114.8511782,232.3766119,12.4572472,13.047241,1.8717166,40.2790027),(52687,'hindlimb',41,8,195,77.5061822,56.1509423,121.3639913,1.8,56.2127549,121.2897876,-1.3572994,6.1555092,6.1869899,712.4265146,746.2136502,12.3377883,120.6101285,115.7380309,230.4499991,12.1534119,12.9263977,1.8399638,40.0272973),(52688,'hindlimb',41,8,196,77.320935,56.1484168,121.3941139,1.8,56.2110029,121.3217558,-1.3108354,6.113298,6.1149437,710.1167933,743.3234793,12.0353776,121.5585164,116.159362,229.2818506,12.1534119,12.9263977,1.9451299,40.0272973),(52689,'hindlimb',41,8,197,76.9886537,56.237374,121.4296658,1.8,56.2949053,121.3821659,-1.2576714,6.0900729,6.1238527,702.3079489,737.2427104,11.6139385,120.3887072,115.3201217,229.057995,12.3009983,12.9263977,1.9451299,40.2790027),(52690,'hindlimb',41,8,198,77.0079561,56.2345302,121.4585325,1.8,56.3079676,121.4444657,-1.2184694,6.0433111,6.123681,699.6943395,736.1079917,11.306281,120.2067829,115.7799627,228.9453816,12.2999075,12.9263977,1.9451299,40.2790027),(52691,'hindlimb',41,8,199,76.8893442,56.3135212,121.4781506,1.8,56.397271,121.4748163,-1.1786289,6.0076719,6.1064886,689.8855954,729.9320547,10.9430085,119.5338443,114.8341,229.0040358,12.031264,12.7755427,1.9138203,39.6713321),(52692,'hindlimb',41,8,200,76.9045064,56.3059901,121.4996708,1.8,56.3883982,121.4756235,-1.1553576,6.0036437,6.0974523,687.4542359,728.7055214,10.7296401,119.5098354,114.506169,227.9418732,12.031264,12.7755427,1.9138203,39.6713321),(52693,'hindlimb',41,8,201,76.8987436,56.386199,121.5326506,1.8,56.4354658,121.4941027,-1.1119368,5.9032795,6.0646294,679.7662528,723.2088339,10.3020816,119.2502939,115.1506136,223.6453436,12.031264,12.8188253,1.3339476,39.6713321),(52694,'hindlimb',41,8,202,76.8910786,56.3797732,121.5570486,1.8,56.4412046,121.5335565,-1.0920115,5.9022868,6.0641864,677.0738504,721.9482822,10.0952165,119.0511362,114.7138169,222.5120881,12.031264,12.8763091,2.0195197,39.6713321),(52695,'hindlimb',41,8,203,76.4794057,56.4614989,121.5760887,1.8,56.504693,121.5490744,-1.0686367,5.8286505,6.0728306,667.627046,715.3597527,9.7935879,117.7967572,114.5423029,222.4553249,12.031264,12.7755427,1.9138203,39.6713321),(52696,'hindlimb',41,8,204,76.3246507,56.4472264,121.5991744,1.8,56.4805803,121.5642772,-1.0385406,5.8344202,6.0517755,664.3723139,713.9926516,9.4447402,117.980691,113.8711801,220.9541621,12.031264,12.7755427,1.9138203,39.6713321),(52697,'hindlimb',41,8,205,75.8363836,56.5217261,121.6377194,1.8,56.5534403,121.6132586,-1.0283257,5.7509995,6.0580326,655.4111293,706.0821098,9.2707748,116.5530392,113.9647349,220.2402553,11.9175466,12.7248603,1.7748143,39.6713321),(52698,'hindlimb',41,8,206,75.5183693,56.5087517,121.6631875,1.8,56.5431665,121.6343661,-0.9924259,5.7443542,6.0304437,650.8367848,703.5197647,8.8251106,116.6613595,113.3002537,218.3382059,11.9175466,12.7248603,1.7748143,39.6713321),(52699,'hindlimb',41,8,207,75.2773409,56.5878439,121.6822235,1.8,56.6101259,121.6676426,-0.9811186,5.785819,6.0572858,641.8136064,697.1078968,8.6664342,115.0858523,110.9287399,218.0826455,12.031264,12.695808,1.9890207,39.6713321),(52700,'hindlimb',41,8,208,75.3951136,56.5764643,121.7002396,1.8,56.588453,121.6941962,-0.9534595,5.801397,6.0316317,639.3388877,697.7346803,8.3552189,115.679259,110.2042981,217.2961199,11.9164558,12.695808,1.9890207,39.6713321),(52701,'hindlimb',41,8,209,74.8947615,56.6714992,121.7288416,1.8,56.7520393,121.7471482,-0.9196277,5.722178,5.9735654,631.5737166,691.4512279,7.8966913,115.7518479,110.3729593,212.494786,11.8495766,12.644806,0.1707352,39.4196267),(52702,'hindlimb',41,8,210,74.6803648,56.6540515,121.7508359,1.8,56.7254836,121.7639483,-0.9178071,5.7232857,6.0261674,628.704757,690.0800922,7.8522265,114.5139259,109.8503175,213.9680668,11.8495766,12.6375032,0.9544994,39.4196267),(52703,'hindlimb',41,8,211,74.2194568,56.7066404,121.7564526,1.8,56.7730846,121.754102,-0.8948645,5.7505814,5.9783803,621.1368155,684.2154882,7.5282524,114.4483045,108.0128732,210.5980662,11.8495766,12.6375032,0.3109983,39.0636615),(52704,'hindlimb',41,8,212,73.9708753,56.6870741,121.7831301,1.8,56.7395954,121.7783288,-0.8858433,5.7449814,6.0073608,618.2574499,682.0955,7.3942631,113.5432889,107.6169628,211.9120673,11.8495766,12.5495381,0.6640462,39.0636615),(52705,'hindlimb',41,8,213,73.010846,56.7689975,121.8153957,1.8,56.823051,121.7876772,-0.8525622,5.6426231,5.975907,608.738725,675.0070211,6.8990659,112.9547395,107.882224,208.6774308,11.7247299,12.6375032,0.3109983,39.0636615),(52706,'hindlimb',41,8,214,72.3486333,56.7470944,121.8458573,1.8,56.7968021,121.8234291,-0.847124,5.6414752,5.9448583,605.6568515,672.1408858,6.7714598,113.0625574,107.357886,206.7450965,11.7247299,12.6375032,0.3109983,39.0636615),(52707,'hindlimb',41,8,215,71.8038577,56.8316777,121.8753439,1.8,56.8914585,121.8725609,-0.8356494,5.7712695,5.9722869,597.7790673,666.0308841,6.5840145,111.5202435,103.5784358,206.9741957,11.7765431,12.5495381,0.6640462,39.0636615),(52708,'hindlimb',41,8,216,71.4496444,56.8097257,121.9031204,1.8,56.8775296,121.8951306,-0.8305444,5.7726736,5.9419201,594.3161841,664.4940595,6.4910204,111.8315378,102.9533673,205.2021158,11.7765431,12.6375032,0.3109983,39.0636615),(52709,'hindlimb',41,8,217,70.9213738,56.8455407,121.9371557,1.8,56.902417,121.91722,-0.8348789,5.7501604,5.9444087,586.6908894,657.4733604,6.4940336,110.6036596,102.0303512,203.6652369,11.7247299,12.5274503,0.3868757,39.0636615),(52710,'hindlimb',41,8,218,70.8954134,56.8208823,121.9625429,1.8,56.8594693,121.9811587,-0.8259388,5.7520746,5.9248745,584.8356695,656.070046,6.3864507,110.7314674,101.673867,202.1211073,11.7247299,12.6375032,0.3109983,38.8119561),(52711,'hindlimb',41,8,219,70.2551328,56.8777805,121.9919874,1.8,56.9164098,121.9898346,-0.8246564,5.6903659,5.9351819,578.0278406,649.8225981,6.3138044,109.4865515,101.5800837,201.528758,11.6825466,12.5274503,0.3868757,39.0636615),(52712,'hindlimb',41,8,220,70.1281844,56.8537689,122.0201989,1.8,56.8880155,122.0494924,-0.8070008,5.6883636,5.8926395,576.4667775,648.5508703,6.0964295,110.0611826,101.3414081,200.0494937,11.601576,12.5274503,0.3868757,38.4559909),(52713,'hindlimb',41,8,221,69.5323833,56.9093365,122.0568072,1.8,56.9420305,122.096762,-0.7947078,5.6273363,5.8964267,568.8511648,641.6215213,5.9022454,108.8153133,101.08711,199.070324,11.5457413,12.5274503,0.3868757,38.2042855),(52714,'hindlimb',41,8,222,69.2388188,56.8867189,122.0882766,1.8,56.9352574,122.1208438,-0.7969795,5.6231925,5.8596955,567.4041901,640.4115424,5.9035361,109.290926,100.9042795,197.63426,11.5457413,12.5274503,0.3868757,38.5602507),(52715,'hindlimb',41,8,223,68.8274256,56.9603004,122.1053402,1.8,56.9891815,122.1078346,-0.7885566,5.5523032,5.8915624,560.8545705,633.3906822,5.7718501,107.5080996,101.0129573,197.5253209,11.5330041,12.4015431,0.2449787,38.5602507),(52716,'hindlimb',41,8,224,68.7562025,56.9299673,122.128143,1.8,56.9600163,122.1208438,-0.7811566,5.5618877,5.8559235,559.8510634,633.4310056,5.681078,108.1692764,100.6584624,196.2060591,11.5330041,12.5274503,0.3868757,38.5602507),(52717,'hindlimb',41,8,225,68.1949219,56.9772286,122.158594,1.8,57.0316095,122.1636037,-0.7811738,5.5095274,5.8680336,552.9607811,625.9170299,5.6348975,106.6655498,100.3644677,194.9874046,11.5457413,12.3940969,0.5880026,38.5602507),(52718,'hindlimb',41,8,226,67.9947363,56.9470029,122.1825411,1.8,57.0017813,122.1958504,-0.7709457,5.5355891,5.8350035,551.1253674,625.4073114,5.5024688,107.1819939,99.5603815,193.4441755,11.5457413,12.5274503,0.3868757,38.5602507),(52719,'hindlimb',41,8,227,67.8560946,56.9903401,122.1870628,1.8,57.0521254,122.1888104,-0.7755255,5.4923378,5.8604879,546.4287512,619.3188053,5.5430283,105.6770049,99.4892841,192.9341423,11.5457413,12.3940969,0.5880026,38.2042855),(52720,'hindlimb',41,8,228,67.6658679,56.9636694,122.2086697,1.8,57.0324157,122.1845641,-0.7724636,5.5020482,5.8279577,544.9376998,618.8261316,5.4929667,106.1823304,99.0426989,191.5889357,11.5179504,12.3940969,0.5880026,38.5602507),(52721,'hindlimb',41,8,229,67.1215399,57.0108441,122.2475155,1.8,57.0938757,122.2572432,-0.7699543,5.72692,5.8360897,539.3822951,612.9038991,5.4207195,105.0196153,94.1836624,190.7189258,11.5179504,12.3940969,0.5880026,38.2042855),(52722,'hindlimb',41,8,230,67.1003352,56.9895142,122.2671036,1.8,57.0755381,122.2600184,-0.761575,5.4645012,5.8117324,538.4014569,612.5259378,5.3253715,105.3947247,98.527101,189.6624316,11.241906,12.3940969,0.5880026,37.9525801),(52723,'hindlimb',41,8,231,66.843753,57.0324807,122.2830865,1.8,57.1130326,122.2837229,-0.7451424,5.7230122,5.8402943,534.4096071,607.2347759,5.1223231,103.9733184,93.3790787,189.238476,11.5330041,12.3940969,0.5880026,38.2042855),(52724,'hindlimb',41,8,232,66.9163189,57.0018154,122.2970641,1.8,57.0841313,122.2969295,-0.7460954,5.7325788,5.8244948,532.8216299,606.3321645,5.138479,104.1003874,92.9462376,187.7813517,11.5179504,12.3940969,0.5880026,38.2042855),(52725,'hindlimb',41,8,233,66.4997224,57.0425961,122.3284576,1.8,57.1088529,122.3502189,-0.7297562,5.6976163,5.8389421,527.5048395,600.3690544,4.9262201,102.8215456,92.5834259,186.7876042,11.4453859,12.3940969,0.5880026,38.2042855),(52726,'hindlimb',41,8,234,66.4907706,57.0107552,122.3497742,1.8,57.0747274,122.3986536,-0.7334459,5.6996674,5.8402332,526.9020463,600.054741,4.9662084,102.7449969,92.4443494,185.4948521,11.4453859,12.5274503,0.3868757,37.8483203),(52727,'hindlimb',41,8,235,65.9259092,57.0555734,122.3616372,1.8,57.1175795,122.4130656,-0.7325805,5.693733,5.8155245,522.7587424,593.3837698,4.9145624,102.0344373,91.8130053,184.8769459,11.5330041,12.3717316,0.3547057,37.8483203),(52728,'hindlimb',41,8,236,65.6628369,57.023217,122.3877556,1.8,57.0723878,122.4414371,-0.7400951,5.6846153,5.765162,522.1329668,591.9262025,4.9767927,102.6729526,91.8501846,187.4405432,11.4453859,12.2291349,0.3217506,37.5966149),(52729,'hindlimb',41,8,237,65.468526,57.0629105,122.4164109,1.8,57.1010337,122.4709014,-0.734102,5.6458188,5.7783909,517.970618,586.8275377,4.8969779,101.5555275,91.7441102,186.8280211,11.4791976,12.2291349,0.3217506,37.5966149),(52730,'hindlimb',41,8,238,65.2417646,57.0283531,122.4407496,1.8,57.0915378,122.4887493,-0.7273918,5.6606002,5.739781,518.136107,587.2849933,4.8074877,102.318363,91.5337746,185.6758584,11.4791976,12.2291349,1.8925469,37.5966149),(52731,'hindlimb',41,8,239,64.5966164,57.0695264,122.4607759,1.8,57.1385498,122.5075328,-0.7085313,5.6445008,5.7660489,514.4723953,582.0130477,4.5587503,100.9379316,91.1457742,185.222421,11.241906,12.2291349,1.8925469,37.3449095),(52732,'hindlimb',41,8,240,64.3526227,57.0376366,122.4833336,1.8,57.1292767,122.5195978,-0.702139,5.6563118,5.7296612,514.2932368,581.7970293,4.4738483,101.5412626,90.923778,184.0032023,11.241906,12.2291349,1.8925469,37.3449095),(52733,'hindlimb',41,8,241,63.9583499,57.0753808,122.5189365,1.8,57.1293512,122.519371,-0.6716231,5.6408526,5.7457864,510.0258079,578.2549816,4.1274907,100.6398327,90.4164392,183.478226,11.241906,12.2291349,1.8925469,37.3449095),(52734,'hindlimb',41,8,242,63.6640581,57.036496,122.5420063,1.8,57.1059524,122.5386741,-0.6472234,5.6709816,5.8061557,509.9027919,578.2448071,3.857801,99.5916813,89.9143789,182.1043233,11.241906,12.3717316,0.3547057,37.3449095),(52735,'hindlimb',41,8,243,63.7132932,57.06379,122.5482753,1.8,57.1238093,122.545042,-0.6207059,5.7718804,5.8241985,508.2231517,574.1068372,3.5920453,98.5726772,88.0515743,181.8648852,11.241906,12.3118922,0.5104883,37.3449095),(52736,'hindlimb',41,8,244,63.3472188,57.0305248,122.5698175,1.8,57.1071082,122.5546344,-0.5996109,5.8007253,5.870428,507.7023247,573.7555604,3.3622433,97.7365811,87.5239389,180.5580854,11.241906,12.3717316,0.3547057,37.3449095),(52737,'hindlimb',41,8,245,63.1835119,57.0750263,122.5703956,1.8,57.1287103,122.5476774,-0.5735073,5.8059566,5.85115,505.8650745,571.6218233,3.1001485,97.6939266,87.1286348,181.1711462,11.241906,12.3717316,0.3547057,37.3449095),(52738,'hindlimb',41,8,246,63.0454857,57.0471894,122.5870726,1.8,57.119527,122.5769881,-0.5470988,5.8333511,5.8968768,506.335271,572.2449352,2.8435633,97.0420371,86.8000676,180.3958811,11.241906,12.3717316,0.3547057,37.3449095),(52739,'hindlimb',41,8,247,63.0131471,57.1060655,122.5859274,1.8,57.168374,122.5728486,-0.5100864,5.8802168,5.8704575,505.3544484,571.185858,2.5036239,97.2983554,85.9414655,175.4036982,11.4104074,12.4015431,0.2449787,37.9525801),(52740,'hindlimb',41,8,248,62.7129247,57.0692407,122.6064456,1.8,57.1182916,122.5911613,-0.4828433,5.8529237,5.9015023,506.2181339,572.3796232,2.2532108,96.9887995,86.4897892,176.1849424,11.241906,12.4015431,0.2449787,37.7008747),(52741,'hindlimb',41,8,249,62.2138034,57.1167442,122.6309728,1.8,57.1662667,122.6378611,-0.442587,5.82793,5.9055197,503.3438332,571.1560102,1.9019026,96.7156218,86.3675157,175.1609427,11.4327914,12.5127034,0.2782997,37.9525801),(52742,'hindlimb',41,8,250,62.0861278,57.0830067,122.6476533,1.8,57.125576,122.6504484,-0.4224846,5.8323962,5.9753022,504.2164132,571.1506149,1.7396824,95.5852262,86.4509881,174.2776309,11.5179504,12.5127034,0.2782997,37.9525801),(52743,'hindlimb',41,8,251,61.6690837,57.1256812,122.6689739,1.8,57.1741826,122.6887633,-0.3941554,5.7994947,5.9852956,501.9010784,569.1686245,1.5158042,95.0944886,86.5422084,174.6675617,11.5179504,12.5127034,0.2782997,37.9525801),(52744,'hindlimb',41,8,252,61.6138621,57.0860265,122.682943,1.8,57.1407229,122.7022932,-0.3767661,5.801271,6.049591,502.9360929,569.9874209,1.3900263,94.2191666,86.6941208,173.7941223,11.5179504,12.5127034,0.2782997,37.7008747),(52745,'hindlimb',41,8,253,61.4688981,57.1256797,122.7138615,1.8,57.1760591,122.741798,-0.3422649,5.7525457,6.0614713,501.5714611,569.547132,1.153994,93.9618617,87.1912178,174.4487056,11.171888,12.5127034,0.2782997,37.3449095),(52746,'hindlimb',41,8,254,61.4461828,57.091981,122.7274232,1.8,57.1718472,122.7463859,-0.3227082,5.7442765,6.1157168,503.4860452,571.4661334,1.0299947,93.4422159,87.6500359,174.0637832,11.171888,12.5127034,0.2782997,37.5966149),(52747,'hindlimb',41,8,255,61.2680971,57.134255,122.7407231,1.8,57.1676012,122.7596915,-0.3004599,5.7086496,6.0968488,502.6952079,571.0513849,0.8944328,93.6633662,88.0585154,174.976579,11.171888,12.5127034,0.2782997,37.5966149),(52748,'hindlimb',41,8,256,61.3705957,57.0931594,122.7564164,1.8,57.1545804,122.7909415,-0.2867667,5.8194415,6.149672,505.4976368,573.4094897,0.8183311,93.2422885,86.8635991,174.5856577,11.171888,12.5127034,0.2782997,37.5966149),(52749,'hindlimb',41,8,257,61.2551729,57.1348571,122.7712332,1.8,57.1691704,122.7977694,-0.2524804,5.7559682,6.1302812,505.3513564,574.2686701,0.6370875,93.6773774,87.7960649,175.7863214,11.171888,12.5127034,0.2782997,37.5966149),(52750,'hindlimb',41,8,258,61.2993167,57.0972526,122.7885342,1.8,57.1596759,122.8194398,-0.2430073,5.7401696,6.174209,508.0884043,576.9719901,0.5915308,93.4487304,88.5145289,175.5227204,11.5457413,12.5127034,0.2782997,37.9525801),(52751,'hindlimb',41,8,259,61.0636034,57.1292904,122.7884187,1.8,57.1751447,122.8228773,-0.2322319,5.7377994,6.1459636,508.0039602,577.430065,0.5390802,93.9527311,88.5363753,176.481314,11.5457413,12.5127034,0.2782997,37.9525801),(52752,'hindlimb',41,8,260,60.9198704,57.0952803,122.8058766,1.8,57.148504,122.8410237,-0.2237247,5.7334737,6.1847681,510.5882832,580.7911188,0.4997785,93.9066923,89.0539162,176.3940288,11.5457413,12.6375032,0.3109983,37.9525801),(52753,'hindlimb',41,8,261,60.6806323,57.140351,122.8140365,1.8,57.1889756,122.8330744,-0.1934603,5.7353099,6.1444884,510.788233,581.7515111,0.3738159,94.6785927,89.060268,177.805738,11.5457413,12.5127034,0.2782997,37.9525801),(52754,'hindlimb',41,8,262,60.7765849,57.0969941,122.8329573,1.8,57.1570635,122.8830644,-0.1863246,5.7944102,6.1902178,514.2958547,586.3024771,0.3476112,94.7143532,88.7572395,177.7792202,11.5457413,12.6375032,0.3109983,37.9525801),(52755,'hindlimb',41,8,263,60.3994885,57.1150092,122.8456485,1.8,57.1605112,122.8804761,-0.1585881,5.7692647,6.1696666,513.6439405,585.8570022,0.2510611,94.9576429,89.0310928,178.036506,11.5457413,12.6375032,0.3109983,37.9525801),(52756,'hindlimb',41,8,264,60.3516521,57.0752707,122.8607059,1.8,57.1159129,122.8941986,-0.1384267,5.7502618,6.2043445,516.3503632,588.5421631,0.1915147,94.8596844,89.7959747,177.7021459,11.5457413,12.644806,0.1707352,38.3085453),(52757,'hindlimb',41,8,265,60.165174,57.1164204,122.8868953,1.8,57.1769773,122.8873167,-0.10687,5.730136,6.1502995,515.7637735,589.7547087,0.1140911,95.8904044,90.0089935,178.8064902,11.5457413,12.6375032,0.3109983,37.9525801),(52758,'hindlimb',41,8,266,60.1160508,57.0677783,122.9116906,1.8,57.1122653,122.9304581,-0.0723972,5.7106641,6.1751446,518.1520985,594.3163724,0.0524232,96.2433122,90.734123,178.4084459,11.5457413,12.7248603,0.204018,38.3085453),(52759,'hindlimb',41,8,267,59.6936916,57.0940166,122.9203564,1.8,57.1287384,122.9466274,-0.0437281,5.6829164,6.1219606,517.6155565,594.9046593,0.0190118,97.1755122,91.0827335,179.1008188,11.601576,12.7248603,0.204018,38.5602507),(52760,'hindlimb',41,8,268,59.3983367,57.0551011,122.9388939,1.8,57.0830605,122.9777389,-0.0223024,5.6689149,6.1373356,518.6261904,598.3696721,0.0049233,97.4966512,91.4859723,178.6144661,11.601576,12.8188253,0.2368488,38.8119561),(52761,'hindlimb',41,8,269,58.9867197,57.0858082,122.9411286,1.8,57.1278376,122.969989,-0.0031486,5.6414908,6.0825149,517.564818,598.0214604,0.0000975,98.3181247,91.742561,179.2349284,11.601576,12.7248603,0.204018,38.5602507),(52762,'hindlimb',41,8,270,58.8523861,57.0363073,122.9531199,1.8,57.0656726,122.9925816,0.0063141,5.6516049,6.1327391,519.182998,600.7566859,0.0003911,97.9589513,91.8647025,180.7298012,11.601576,12.7248603,0.204018,38.8119561),(52763,'hindlimb',41,8,271,58.4390347,57.0831378,122.9397181,1.8,57.1190496,122.9773986,0.0388839,5.6498795,6.1079062,518.3328475,600.0307273,0.0147188,98.2383662,91.7422833,179.6146355,11.601576,12.8188253,0.2368488,38.5602507),(52764,'hindlimb',41,8,272,58.353097,57.0288507,122.9451196,1.8,57.0370081,122.9670998,0.0564021,5.6622941,6.1709101,521.3192792,603.0063471,0.030906,97.7175707,92.0685628,181.2565163,11.601576,12.7248603,0.204018,39.0636615),(52765,'hindlimb',41,8,273,57.9926734,57.0220165,122.9507627,1.8,57.0327198,122.984253,0.0660891,5.6703435,6.1815026,520.5832111,601.6521323,0.0421551,97.3310483,91.8080549,180.6983556,11.601576,12.7248603,0.204018,39.0636615),(52766,'hindlimb',41,8,274,57.8258894,56.9596027,122.9658031,1.8,56.9725284,123.0103631,0.0780501,5.691977,6.2468002,521.7909534,604.9179144,0.0585917,96.8364432,91.671304,179.5694893,11.601576,12.8188253,0.2368488,38.8119561),(52767,'hindlimb',41,8,275,57.3084728,56.976261,122.9718056,1.8,56.9731913,123.0196744,0.0933196,5.6984144,6.2334797,519.9668235,603.9183938,0.0829377,96.8830289,91.2476322,179.5651404,11.601576,12.8188253,0.2368488,38.8119561),(52768,'hindlimb',41,8,276,57.3150748,56.9278788,122.9750407,1.8,56.9482694,122.9930337,0.1023611,5.7069876,6.2828166,523.0708693,608.3301601,0.0997401,96.8244341,91.654461,179.3810915,11.601576,12.8188253,0.2368488,38.8119561),(52769,'hindlimb',41,8,277,56.8610485,56.9493392,123.0144735,1.8,56.9095008,123.0710989,0.0555411,7.326163,10.1758486,524.4733458,613.565092,0.0292043,60.2962091,71.5890901,90.901908,11.601576,12.8188253,0.2368488,38.8119561),(52770,'hindlimb',41,8,278,56.6866554,56.9154043,123.0100367,1.8,56.9401968,122.9944858,0.1073823,5.743386,6.2920611,523.923251,609.5342455,0.1085238,96.8735419,91.2220164,179.2055258,11.601576,12.8188253,0.2368488,38.8119561),(52771,'hindlimb',41,8,279,56.2225582,56.9175522,123.0133333,1.8,56.9559758,123.0141611,0.1199845,5.7465444,6.3413001,522.669386,608.6214157,0.1342533,95.9773866,90.953685,178.0279767,11.601576,12.8188253,2.9047439,38.8119561),(52772,'hindlimb',41,8,280,56.0881687,56.855792,123.0230776,1.8,56.9186914,123.0122781,0.1253332,5.7637039,6.3497489,525.2485617,609.9893457,0.1460755,96.0651124,91.1303863,178.7746765,11.601576,12.8188253,0.2368488,38.8119561),(52773,'hindlimb',41,8,281,55.7587408,56.8826284,123.0280588,1.8,56.9230504,123.0189671,0.1361067,5.7646838,6.3213923,524.9515564,609.1659985,0.1710951,96.3657954,91.0633735,179.3673915,11.601576,12.8188253,0.2368488,38.8119561),(52774,'hindlimb',41,8,282,55.8830595,56.8315259,123.0310654,1.8,56.8859655,123.0194119,0.1480466,5.7737407,6.3694071,528.2301053,612.7546491,0.2026517,96.2027771,91.4883669,179.0255813,11.601576,12.9549329,0.0996687,39.1679213),(52775,'hindlimb',41,8,283,55.6598789,56.830784,123.0063187,1.8,56.8889374,123.0082745,0.1573011,5.7481861,6.371681,527.7439084,613.5250317,0.2276509,96.2893513,91.8105123,178.9697441,11.601576,12.9549329,3.041924,39.1679213),(52776,'hindlimb',41,8,284,55.4365304,56.7680226,123.0200105,1.8,56.8089542,123.0439155,0.1606082,5.7711944,6.4305587,528.7004865,616.9491999,0.2362887,95.9402177,91.6102375,177.9608007,11.601576,13.0684503,0.1651487,39.4196267),(52777,'hindlimb',41,8,285,55.410626,56.7747297,123.0486061,1.8,56.8054466,123.0484358,0.1737993,5.7961906,6.4144631,529.2792014,619.5248434,0.27616,96.5824946,91.3150104,178.7241775,11.601576,13.0684503,0.1651487,39.4196267),(52778,'hindlimb',41,8,286,55.3781756,56.7186979,123.0584237,1.8,56.7598634,123.0549577,0.1674543,5.8163741,6.4705719,531.1580925,623.6136184,0.2563992,96.3768927,91.3211708,178.1381783,11.601576,13.0047187,3.0090411,39.4196267),(52779,'hindlimb',41,8,287,55.1767031,56.7186182,123.0479463,1.8,56.7503206,123.0456657,0.1785427,5.8044836,6.4677642,529.9091979,625.5340317,0.2900476,96.7156527,91.2930818,178.2086247,11.601576,13.0047187,3.0090411,39.4196267),(52780,'hindlimb',41,8,288,54.9820005,56.6579256,123.0656832,1.8,56.6837394,123.0696585,0.1752434,5.8330731,6.5258964,530.0653245,630.4655092,0.2785493,96.6097951,90.8723959,177.3938482,11.601576,13.0684503,2.976444,39.6713321),(52781,'hindlimb',41,8,289,55.3101415,56.6588672,123.0754648,1.8,56.6690717,123.0914606,0.17781,5.8422626,6.5220365,532.081763,636.6937449,0.2883928,97.6219235,91.0746056,178.7074335,12.031264,13.0684503,2.976444,40.0272973),(52782,'hindlimb',41,8,290,55.1689262,56.5745973,123.087094,1.8,56.5410736,123.0987094,0.1847647,5.8682285,6.41364,535.0902009,638.9873213,0.3103369,99.6294333,91.184281,181.6958808,11.8495766,13.047241,2.8406724,39.4196267),(52783,'hindlimb',41,8,291,55.0891988,56.5433042,123.078988,1.8,56.5111758,123.0916281,0.1851447,5.8659926,6.4461893,538.3009852,640.3813879,0.31115,99.342629,91.7663939,181.5018117,11.8495766,13.047241,2.8406724,39.4196267),(52784,'hindlimb',41,8,292,55.4147103,56.4699154,123.0808116,1.8,56.4410805,123.091683,0.1933155,5.8813115,6.4415269,543.9459058,646.9532409,0.3408713,100.4347644,92.4871779,184.6825481,11.8495766,13.0684503,2.976444,39.7755919),(52785,'hindlimb',41,8,293,55.4274666,56.4481096,123.0772915,1.8,56.4326354,123.1051948,0.1977575,5.8819884,6.5492751,546.9802593,650.0186056,0.3565915,99.2504655,92.9924063,181.7662354,12.031264,13.145925,2.9441971,40.0272973),(52786,'hindlimb',41,8,294,55.0383412,56.3722834,123.0926542,1.8,56.329099,123.1664012,0.1737617,5.9091613,6.5286081,550.4064384,651.5697195,0.2741871,99.8022417,93.1445949,183.7746102,12.031264,13.145925,2.9441971,40.0272973),(52787,'hindlimb',41,8,295,54.9201209,56.33644,123.0715744,1.8,56.2989308,123.1203162,0.1848844,5.9020648,6.571695,550.8470729,654.6416887,0.3093333,99.615349,93.3312485,183.1978227,12.031264,13.145925,2.9441971,40.0272973),(52788,'hindlimb',41,8,296,54.6442922,56.2588117,123.0742798,1.8,56.2355185,123.1108917,0.1868987,5.9141394,6.6481314,554.0712501,659.5965863,0.3144441,99.2153356,93.6858629,182.3656087,12.031264,13.2369013,2.9123607,40.2790027),(52789,'hindlimb',41,8,297,54.6032816,56.24146,123.0902602,1.8,56.2212825,123.1282272,0.1928651,5.9462438,6.6638013,557.466319,666.0553964,0.334336,99.9512697,93.7510024,183.4816142,12.031264,13.2369013,2.9123607,40.2790027),(52790,'hindlimb',41,8,298,54.5416258,56.1876667,123.095578,1.8,56.1609472,123.1318125,0.1968592,6.0361007,6.7164471,564.2363329,675.4209787,0.347753,100.5622419,93.4769582,184.4851407,12.1534119,13.3411032,2.8809903,40.6349679),(52791,'hindlimb',41,8,299,53.5715816,56.1723919,123.0854927,1.8,56.1927341,123.0982599,0.1636549,6.1463956,6.7226792,567.0684483,675.376573,0.2370068,100.4624129,92.2603242,184.4290951,12.1534119,13.4924769,2.9816795,40.9909331),(52792,'hindlimb',41,8,300,53.6355313,56.0983791,123.0983333,1.8,56.098606,123.1380413,0.1543931,6.1785061,6.7895241,575.5521086,684.8936475,0.2113993,100.8750591,93.1539271,185.197341,12.4572472,13.5675304,2.9504082,41.2426385),(52793,'hindlimb',41,8,301,53.7637105,56.0736622,123.0888945,1.8,56.0738854,123.1299264,0.1452399,6.2417082,6.8107356,586.0947212,694.2305235,0.1876955,101.9317977,93.8997318,187.3969303,12.4572472,13.5675304,2.9504082,41.4943439),(52794,'hindlimb',41,8,302,54.4051101,55.9836574,123.0809013,1.8,55.9896721,123.1317364,0.1174432,6.2491578,6.8834011,600.2088167,705.7558073,0.1244936,102.5301006,96.0463538,188.6770212,12.4572472,13.6556983,2.9195108,41.4943439),(52795,'hindlimb',41,8,303,54.617101,55.9481613,123.0610575,1.8,55.9553525,123.1171215,0.1122629,6.2333162,6.917038,606.3209437,720.0298187,0.1142418,104.0951088,97.2710063,190.5483187,12.4572472,13.7567282,2.8890384,41.4943439),(52796,'hindlimb',41,8,304,55.4321104,55.8685701,123.066404,1.8,55.89346,123.1525745,0.0993751,6.2877069,6.9850991,620.3883539,737.6562805,0.090936,105.6042679,98.6668697,192.9821816,12.460952,13.8703393,2.8590377,41.7460493),(52797,'hindlimb',41,8,305,55.6660333,55.8408811,123.0359272,1.8,55.827267,123.1259882,0.1165583,6.3052248,7.0297927,633.1874242,754.3184818,0.1254751,107.3030912,100.4226562,196.2279548,12.7610825,13.9896277,2.9562447,42.7096851);
INSERT INTO `slices_w` VALUES (52798,'hindlimb',41,8,306,56.3271829,55.7570597,123.0355619,1.8,55.7591563,123.1345132,0.0841161,6.34185,7.0488566,650.4800438,771.6718707,0.0662675,109.4747583,102.5694463,201.1361263,12.89064,13.9896277,2.9562447,42.9613905),(52799,'hindlimb',41,8,307,56.2336921,55.7151215,123.0358274,1.8,55.7614655,123.170695,0.0526554,6.3517778,7.092423,665.5125552,784.553407,0.0259615,110.6185299,104.7757928,201.5780638,12.89064,14.1731921,2.896614,42.9613905),(52800,'hindlimb',41,8,308,56.6578976,55.6281064,123.0579906,1.8,55.6561908,123.1540372,0.0246264,6.3128198,7.1318109,682.4888301,801.1724561,0.0057256,112.3378707,108.1115657,206.2260026,12.89064,14.1731921,2.896614,43.2130959),(52801,'hindlimb',41,8,309,56.6819556,55.6104776,123.0349974,1.8,55.6852605,123.102901,0.0020597,6.5900482,7.1271983,695.914449,818.3354198,0.0000401,114.8186684,105.6008126,207.5482142,13.3171847,14.283491,2.8674252,43.8207665),(52802,'hindlimb',41,8,310,57.4546117,55.5422594,123.0343683,1.8,55.533036,123.140371,-0.0235254,6.5998513,7.2036841,714.4664999,843.7870867,0.0052987,117.1327165,108.2549386,213.9625433,13.320328,14.4121737,2.9617392,44.1767317),(52803,'hindlimb',41,8,311,58.0955637,55.4629041,122.9735059,1.8,55.4621214,123.0684824,-0.0382131,6.5738059,7.2858121,728.6443384,871.9350958,0.014132,119.6757602,110.8405612,217.1476277,13.320328,14.4952048,2.9325697,44.4284371),(52804,'hindlimb',41,8,312,59.0428925,55.3701697,122.9816171,1.8,55.4242116,123.090222,-0.0705992,6.6369257,7.3826522,750.977476,896.7340025,0.048966,121.4650202,113.151406,220.8396917,13.320328,14.5904229,2.9037567,44.6801425),(52805,'hindlimb',41,8,313,60.833541,55.3033669,122.9976357,1.8,55.3169224,123.1064889,-0.0880688,6.715233,7.4494744,785.3685007,933.2986401,0.0784356,125.2838247,116.9532758,228.4085634,13.750016,14.8351299,2.9669205,45.6437783),(52806,'hindlimb',41,8,314,62.1361462,55.1784175,123.0107116,1.8,55.2221814,123.0877083,-0.1327922,6.8155362,7.5622802,805.5640729,971.6666519,0.1815449,128.4885816,118.1952595,232.4410212,13.750016,14.9158068,2.9385474,45.8954837),(52807,'hindlimb',41,8,315,63.5396834,55.1569096,122.95377,1.8,55.1922788,123.0126993,-0.1473035,7.0120266,7.6308557,839.4403941,1008.3943772,0.2281269,132.1469596,119.7143764,238.2358248,14.1332869,15.1125613,2.8828218,46.7548597),(52808,'hindlimb',41,8,316,65.0052121,55.0544403,122.9319474,1.8,55.1032908,123.0367094,-0.147095,7.0384011,7.7290615,865.8141827,1042.925095,0.2327331,134.9355407,123.0129067,242.8084114,14.179704,15.3549594,2.8286914,47.1108249),(52809,'hindlimb',41,8,317,67.2133522,54.9914218,122.8968041,1.8,55.0267957,123.0363075,-0.1980248,7.1675375,7.7619601,914.8503269,1093.6892323,0.4335699,140.9037437,127.6380245,253.2777365,14.179704,15.5283322,2.8899027,47.8659411),(52810,'hindlimb',41,8,318,69.2720525,54.8717876,122.9019117,1.8,54.9759242,123.0322271,-0.1764241,7.2092362,7.8933981,955.4936464,1138.9272908,0.3556412,144.2885905,132.5374305,260.3073897,14.179704,15.7350314,0.610726,48.6210573),(52811,'hindlimb',41,8,319,74.5389257,54.8096988,122.8300341,1.8,54.9328401,123.0320291,-0.1639571,7.2560124,8.2324836,1027.869289,1236.316861,0.3309767,150.1754422,141.6575979,269.3871503,14.8373684,16.1061369,2.9808299,50.0449181),(52812,'hindlimb',41,8,320,78.6298624,54.6843122,122.7812498,1.8,54.8210273,123.0270105,-0.1627834,7.3970731,8.3499715,1085.0008182,1302.8671482,0.3442051,156.0325268,146.679748,279.7737438,15.03908,16.3620316,0.2386093,50.5483289),(52813,'hindlimb',41,8,321,84.8774101,54.5734367,122.7382331,1.8,54.7033345,123.0714227,-0.1859714,7.4266523,8.4938167,1176.8756199,1419.9777167,0.4836383,167.1778148,158.4665021,266.7330163,15.03908,16.927744,0.4182243,51.4077049),(52814,'hindlimb',41,8,322,90.380612,54.390039,122.7806173,1.8,54.5630725,123.0989171,-0.1798,7.5842116,8.76664,1246.6864967,1577.9514528,0.4817465,179.9950102,164.3791827,286.2616291,15.03908,17.4116449,0.2749098,52.2670809),(52815,'hindlimb',41,8,323,96.7516951,54.2021693,122.9354207,1.8,54.4907472,123.1885106,-0.1659417,7.9662389,9.0591632,1334.6715379,1766.4859461,0.4399754,194.9943837,167.5409877,318.6417817,15.468768,17.9545839,0.3671738,56.0605501),(52816,'hindlimb',41,8,324,98.8423423,54.1716801,123.0788418,1.8,54.3854754,123.2145312,-0.0947862,8.093166,9.3976494,1361.2066724,1849.9625773,0.1475643,196.8537545,168.1921111,324.7973464,15.468768,18.280687,2.625362,57.1716315),(52817,'hindlimb',41,8,325,99.3375471,54.3598597,123.2590401,1.8,54.4223477,123.3773048,-0.023516,8.1762947,9.2602779,1332.7575279,1908.9191039,0.009154,206.1405842,163.0026277,336.2379789,15.898456,18.6753695,0.4018706,57.5275967),(52818,'hindlimb',41,8,326,97.1792016,54.4429824,123.2912493,1.8,54.4172124,123.5098356,0.0392006,8.0494098,9.1954753,1291.9749223,1902.5335724,0.0248762,206.8988845,160.5055463,330.0113438,15.898456,18.8328873,0.6069877,65.3230546),(52819,'hindlimb',41,8,327,90.5809654,54.5680118,123.1312473,1.8,54.6274864,123.412532,0.0920237,8.3636777,9.472365,1163.8752968,1877.8345391,0.127485,198.2434739,139.1583154,316.5735281,16.2877145,19.0860812,2.5973122,67.5020316),(52820,'hindlimb',41,8,328,83.9459148,54.5674154,122.9807072,1.8,54.6996878,123.2381667,0.1009156,8.5089314,9.572081,1071.0689184,1833.5912441,0.1420007,191.556177,125.8758431,301.7151109,16.3131078,19.6344379,2.7367009,76.408571),(52821,'hindlimb',41,8,329,65.0945068,55.1532925,122.6823001,1.8,55.2502682,123.0765922,0.0607361,8.2504855,9.3997396,810.9451493,1566.2002978,0.0399717,166.6216696,98.290597,246.2009598,7.2719466,8.463872,1.152572,24.0372303),(52822,'hindlimb',41,8,330,45.722605,56.048095,122.3461159,1.8,55.9373894,122.8308565,-0.0103839,8.2498603,9.1949531,504.0111225,1098.4675331,0.0008216,119.4641796,61.0932918,164.4469716,5.6066823,7.3425118,1.2120257,20.2437611),(52823,'hindlimb',41,8,331,17.8743143,58.8533664,121.3980038,1.8,57.9262775,121.6399552,0.217643,8.4860102,10.8951453,65.7858956,260.1297782,0.138899,23.8757511,7.7522763,29.891885,6.6764751,9.4237936,1.9936503,25.8602421),(52824,'hindlimb',41,8,332,5.6550475,60.1490547,120.9452071,1.8,60.1773537,121.0668476,1.0790422,2.6032124,3.1116617,7.2000451,11.4036514,0.7323784,3.6648108,2.7658308,5.7495914,5.5715096,6.7939638,2.536048,18.9241602),(52825,'hindlimb',41,8,333,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52826,'hindlimb',41,8,334,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52827,'hindlimb',41,8,335,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52828,'hindlimb',41,8,336,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52829,'hindlimb',41,8,337,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52830,'hindlimb',41,8,338,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52831,'hindlimb',41,8,339,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52832,'hindlimb',41,8,340,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52833,'hindlimb',41,8,341,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52834,'hindlimb',41,8,342,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52835,'hindlimb',41,8,343,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52836,'hindlimb',41,8,344,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52837,'hindlimb',41,8,345,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52838,'hindlimb',41,8,346,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52839,'hindlimb',41,8,347,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52840,'hindlimb',41,8,348,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52841,'hindlimb',41,8,349,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52842,'hindlimb',41,8,350,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52843,'hindlimb',41,8,351,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52844,'hindlimb',41,8,352,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52845,'hindlimb',41,8,353,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52846,'hindlimb',41,8,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52847,'hindlimb',41,8,355,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52848,'hindlimb',41,8,356,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52849,'hindlimb',41,8,357,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52850,'hindlimb',41,8,358,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52851,'hindlimb',41,8,359,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52852,'hindlimb',41,8,360,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52853,'hindlimb',41,8,361,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52854,'hindlimb',41,8,362,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52855,'hindlimb',41,8,363,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52856,'hindlimb',41,8,364,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52857,'hindlimb',41,8,365,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52858,'hindlimb',41,8,366,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52859,'hindlimb',41,8,367,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52860,'hindlimb',41,8,368,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52861,'hindlimb',41,8,369,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52862,'hindlimb',41,8,370,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52863,'hindlimb',41,8,371,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52864,'hindlimb',41,8,372,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52865,'hindlimb',41,8,373,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52866,'hindlimb',41,8,374,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52867,'hindlimb',41,8,375,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52868,'hindlimb',41,8,376,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52869,'hindlimb',41,8,377,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52870,'hindlimb',41,8,378,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52871,'hindlimb',41,8,379,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52872,'hindlimb',41,8,380,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52873,'hindlimb',41,8,381,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52874,'hindlimb',41,8,382,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52875,'hindlimb',41,8,383,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52876,'hindlimb',41,8,384,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52877,'hindlimb',41,8,385,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52878,'hindlimb',41,8,386,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52879,'hindlimb',41,8,387,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52880,'hindlimb',41,8,388,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52881,'hindlimb',41,8,389,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52882,'hindlimb',41,8,390,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52883,'hindlimb',41,8,391,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52884,'hindlimb',41,8,392,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52885,'hindlimb',41,8,393,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52886,'hindlimb',41,8,394,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52887,'hindlimb',41,8,395,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52888,'hindlimb',41,8,396,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52889,'hindlimb',41,8,397,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52890,'hindlimb',41,8,398,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52891,'hindlimb',41,8,399,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52892,'hindlimb',41,8,400,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52893,'hindlimb',41,8,401,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52894,'hindlimb',41,8,402,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52895,'hindlimb',41,8,403,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52896,'hindlimb',41,8,404,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52897,'hindlimb',41,8,405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52898,'hindlimb',41,8,406,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52899,'hindlimb',41,8,407,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52900,'hindlimb',41,8,408,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52901,'hindlimb',41,8,409,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52902,'hindlimb',41,8,410,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52903,'hindlimb',41,8,411,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52904,'hindlimb',41,8,412,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52905,'hindlimb',41,8,413,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52906,'hindlimb',41,8,414,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52907,'hindlimb',41,8,415,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52908,'hindlimb',41,8,416,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52909,'hindlimb',41,8,417,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52910,'hindlimb',41,8,418,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52911,'hindlimb',41,8,419,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52912,'hindlimb',41,8,420,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52913,'hindlimb',41,8,421,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52914,'hindlimb',41,8,422,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52915,'hindlimb',41,8,423,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52916,'hindlimb',41,8,424,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52917,'hindlimb',41,8,425,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52918,'hindlimb',41,8,426,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52919,'hindlimb',41,8,427,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52920,'hindlimb',41,8,428,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52921,'hindlimb',41,8,429,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52922,'hindlimb',41,8,430,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52923,'hindlimb',41,8,431,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52924,'hindlimb',41,8,432,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52925,'hindlimb',41,8,433,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52926,'hindlimb',41,8,434,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52927,'hindlimb',41,8,435,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52928,'hindlimb',41,8,436,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52929,'hindlimb',41,8,437,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52930,'hindlimb',41,8,438,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52931,'hindlimb',41,8,439,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52932,'hindlimb',41,8,440,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52933,'hindlimb',41,8,441,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52934,'hindlimb',41,8,442,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52935,'hindlimb',41,8,443,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52936,'hindlimb',41,8,444,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52937,'hindlimb',41,8,445,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52938,'hindlimb',41,8,446,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52939,'hindlimb',41,8,447,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52940,'hindlimb',41,8,448,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52941,'hindlimb',41,8,449,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52942,'hindlimb',41,8,450,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52943,'hindlimb',41,8,451,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52944,'hindlimb',41,8,452,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52945,'hindlimb',41,8,453,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52946,'hindlimb',41,8,454,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52947,'hindlimb',41,8,455,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52948,'hindlimb',41,8,456,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52949,'hindlimb',41,8,457,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52950,'hindlimb',41,8,458,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52951,'hindlimb',41,8,459,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52952,'hindlimb',41,8,460,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52953,'hindlimb',41,8,461,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52954,'hindlimb',41,8,462,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52955,'hindlimb',41,8,463,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52956,'hindlimb',41,8,464,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52957,'hindlimb',41,8,465,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52958,'hindlimb',41,8,466,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52959,'hindlimb',41,8,467,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52960,'hindlimb',41,8,468,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52961,'hindlimb',41,8,469,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52962,'hindlimb',41,8,470,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52963,'hindlimb',41,8,471,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52964,'hindlimb',41,8,472,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52965,'hindlimb',41,8,473,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52966,'hindlimb',41,8,474,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52967,'hindlimb',41,8,475,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52968,'hindlimb',41,8,476,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52969,'hindlimb',41,8,477,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52970,'hindlimb',41,8,478,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52971,'hindlimb',41,8,479,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52972,'hindlimb',41,8,480,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52973,'hindlimb',41,8,481,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52974,'hindlimb',41,8,482,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52975,'hindlimb',41,8,483,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52976,'hindlimb',41,8,484,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52977,'hindlimb',41,8,485,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52978,'hindlimb',41,8,486,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52979,'hindlimb',41,8,487,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52980,'hindlimb',41,8,488,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52981,'hindlimb',41,8,489,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52982,'hindlimb',41,8,490,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52983,'hindlimb',41,8,491,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52984,'hindlimb',41,8,492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52985,'hindlimb',41,8,493,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52986,'hindlimb',41,8,494,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52987,'hindlimb',41,8,495,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52988,'hindlimb',41,8,496,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52989,'hindlimb',41,8,497,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52990,'hindlimb',41,8,498,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52991,'hindlimb',41,8,499,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52992,'hindlimb',41,8,500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52993,'hindlimb',41,8,501,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52994,'hindlimb',41,8,502,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52995,'hindlimb',41,8,503,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52996,'hindlimb',41,8,504,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52997,'hindlimb',41,8,505,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52998,'hindlimb',41,8,506,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52999,'hindlimb',41,8,507,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53000,'hindlimb',41,8,508,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53001,'hindlimb',41,8,509,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53002,'hindlimb',41,8,510,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53003,'hindlimb',41,8,511,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53004,'hindlimb',41,8,512,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53005,'hindlimb',41,8,513,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53006,'hindlimb',41,8,514,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53007,'hindlimb',41,8,515,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53008,'hindlimb',41,8,516,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53009,'hindlimb',41,8,517,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53010,'hindlimb',41,8,518,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53011,'hindlimb',41,8,519,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53012,'hindlimb',41,8,520,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53013,'hindlimb',41,8,521,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53014,'hindlimb',41,8,522,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53015,'hindlimb',41,8,523,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53016,'hindlimb',41,8,524,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53017,'hindlimb',41,8,525,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53018,'hindlimb',41,8,526,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53019,'hindlimb',41,8,527,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53020,'hindlimb',41,8,528,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53021,'hindlimb',41,8,529,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53022,'hindlimb',41,8,530,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53023,'hindlimb',41,8,531,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53024,'hindlimb',41,8,532,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53025,'hindlimb',41,8,533,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53026,'hindlimb',41,8,534,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53027,'hindlimb',41,8,535,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53028,'hindlimb',41,8,536,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53029,'hindlimb',41,8,537,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53030,'hindlimb',41,8,538,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53031,'hindlimb',41,8,539,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53032,'hindlimb',41,8,540,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53033,'hindlimb',41,8,541,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53034,'hindlimb',41,8,542,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53035,'hindlimb',41,8,543,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53036,'hindlimb',41,8,544,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53037,'hindlimb',41,8,545,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53038,'hindlimb',41,8,546,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53039,'hindlimb',41,8,547,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53040,'hindlimb',41,8,548,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53041,'hindlimb',41,8,549,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53042,'hindlimb',41,8,550,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53043,'hindlimb',41,8,551,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53044,'hindlimb',41,8,552,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53045,'hindlimb',41,8,553,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53046,'hindlimb',41,8,554,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53047,'hindlimb',41,8,555,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53048,'hindlimb',41,8,556,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53049,'hindlimb',41,8,557,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53050,'hindlimb',41,8,558,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53051,'hindlimb',41,8,559,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53052,'hindlimb',41,8,560,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53053,'hindlimb',41,8,561,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53054,'hindlimb',41,8,562,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53055,'hindlimb',41,8,563,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53056,'hindlimb',41,8,564,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53057,'hindlimb',41,8,565,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53058,'hindlimb',41,8,566,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53059,'hindlimb',41,8,567,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53060,'hindlimb',41,8,568,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53061,'hindlimb',41,8,569,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53062,'hindlimb',41,8,570,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53063,'hindlimb',41,8,571,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53064,'hindlimb',41,8,572,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53065,'hindlimb',41,10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53066,'hindlimb',41,10,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53067,'hindlimb',41,10,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53068,'hindlimb',41,10,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53069,'hindlimb',41,10,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53070,'hindlimb',41,10,6,0.1835128,98.2027034,120.7121974,1.8,98.2002345,120.742328,1.5373017,0.2778859,1.3250133,0.0112655,0.1459167,0.0305512,0.1101247,0.0405399,0.1173212,0.859376,3.1281759,1.849096,7.0835276),(53071,'hindlimb',41,10,7,1.9310805,98.6753127,120.5084801,1.8,99.0133364,120.2994188,-0.9188077,1.9086053,4.6442493,1.6555675,5.2218339,0.2033532,1.1243655,0.8674227,1.4080666,2.578128,5.0293691,1.9195673,12.7000086),(53072,'hindlimb',41,10,8,3.3897835,98.966025,120.2458113,1.8,99.2245542,120.2083468,-0.9790527,2.1738359,4.5212261,3.2539368,13.4037915,0.3891749,2.9646364,1.4968641,3.428598,4.7142619,8.9412281,0.9561334,23.0735945),(53073,'hindlimb',41,10,9,4.5249332,98.9201217,120.685501,1.8,99.1212091,120.6186299,-0.9109543,2.1859134,5.5120618,4.2539454,23.1669613,0.4707746,4.2029574,1.9460723,4.7799409,4.8454632,10.7422,0.9272952,26.3636529),(53074,'hindlimb',41,10,10,12.0585252,98.5146908,120.4049904,1.8,98.8166268,120.4287719,-0.8100963,3.1108369,6.0166572,17.1557061,64.3297043,1.0544941,10.6919345,5.5148201,12.5831413,6.2758968,11.0053826,0.8960554,29.5062657),(53075,'hindlimb',41,10,11,32.1200546,98.7377817,120.089579,1.8,99.2012409,119.2809353,-1.0449861,4.6865349,9.2263645,71.3154022,237.281844,4.0047413,25.7178051,15.2170854,33.3289466,8.8875325,16.0429641,1.2151604,49.7500268),(53076,'hindlimb',41,10,12,40.0927905,99.2156539,119.8673965,1.8,99.516636,119.1148847,-1.1205574,5.2868546,9.0249023,107.6923094,442.9766162,5.4166547,49.0838128,20.3698263,59.7958593,9.1731285,16.3620316,1.0483929,46.3557087),(53077,'hindlimb',41,10,13,46.8871839,99.7959232,119.7219204,1.8,99.9370882,119.2909209,-1.0983409,5.3250171,9.4319892,156.9651465,690.1388926,6.1962003,73.1700254,29.4769282,88.1959208,9.4188943,17.6381559,0.9760371,46.6074141),(53078,'hindlimb',41,10,14,49.1060103,100.3262301,119.4653303,1.8,100.2514946,119.5109729,-1.0941657,5.3386499,9.1528512,191.6048101,790.2319149,6.4616439,86.3372409,35.8901246,106.8201431,9.5682644,18.1285566,1.0222469,47.6753097),(53079,'hindlimb',41,10,15,51.2361574,100.9384472,119.3367685,1.8,100.6402081,119.5841496,-1.1155263,5.2914709,8.9370541,236.6991504,886.9755441,6.888357,99.2469703,44.7322032,125.0570534,10.2298654,18.4965587,1.0343609,47.1108249),(53080,'hindlimb',41,10,16,52.491094,101.2331724,119.3616404,1.8,100.8835309,119.5896824,-1.124705,5.4204683,9.2269296,270.8663861,969.0994016,7.1200427,105.0294568,49.97103,134.3657576,10.6076144,18.6555863,1.065935,47.8227553),(53081,'hindlimb',41,10,17,53.9189131,101.4604226,119.6579309,1.8,101.1325195,119.7903517,-1.1249619,5.3793502,9.0917813,316.9050318,1043.1549008,7.3155128,114.7360306,58.9113964,147.7808543,10.5565741,18.280687,1.0545657,48.8295769),(53082,'hindlimb',41,10,18,55.3330806,101.6255595,119.8649032,1.8,101.297993,119.9434024,-1.1197976,5.6035506,9.1572717,375.4350359,1048.96058,7.4701689,114.5494654,66.9994908,154.8834203,10.7948057,18.209851,1.2341215,48.3261661),(53083,'hindlimb',41,10,19,57.7561209,101.6712614,120.3241737,1.8,101.4720222,120.2288375,-1.0765949,6.0301997,8.9332226,467.7060662,976.6327402,7.4602833,109.3259155,77.560626,159.7565698,11.4495626,17.8048522,1.226149,48.3261661),(53084,'hindlimb',41,10,20,58.397017,101.7063794,120.4696428,1.8,101.5058972,120.4544424,-1.0850065,6.3026884,8.8257749,520.0555461,917.7307875,7.6110573,103.9830266,82.5132888,162.7115521,11.9385481,17.18752,0.9272952,47.8659411),(53085,'hindlimb',41,10,21,60.5991706,101.7597196,120.5710846,1.8,101.5801506,120.5780823,-1.1078817,6.5809068,8.7664341,615.979117,886.1384573,8.0858082,101.0831141,93.6009481,171.3273952,12.8995075,16.9331967,0.947597,48.0133867),(53086,'hindlimb',41,10,22,61.942059,101.7218521,120.6603221,1.8,101.5495973,120.6588634,-1.2066134,7.0156624,8.6405143,713.2789043,870.921364,9.0139279,100.7950834,101.6695023,182.7075131,13.4065275,17.1121594,0.8921338,48.9770225),(53087,'hindlimb',41,10,23,63.9882267,101.7325169,120.6737038,1.8,101.4476842,120.6246985,1.2097109,8.0223279,8.0419898,821.9154992,936.0195825,9.3336026,116.39154,102.4534915,207.1713866,14.3949079,16.5861794,0.9324765,50.5915147),(53088,'hindlimb',41,10,24,65.0960174,101.6737165,120.5978845,1.8,101.3791082,120.5256359,0.9686882,8.1516455,8.6187778,848.1465919,1049.9108981,7.3690042,121.81668,104.046059,215.7439337,15.0861382,17.4010378,1.9237867,53.0221971),(53089,'hindlimb',41,10,25,72.211838,101.1614189,119.9262776,1.8,101.0933531,120.2159929,0.9171443,8.1100808,8.4787611,908.9937898,1398.7708268,7.5849741,164.9734929,112.0819651,253.3164936,15.6268781,17.8048522,1.9154436,55.0969143),(53090,'hindlimb',41,10,26,74.7486786,100.8868926,119.5596287,1.8,100.9075107,119.8846288,0.9028823,8.142871,8.4241984,959.072262,1518.1011122,7.6792566,180.2071888,117.7806035,270.6809594,15.7640631,17.533166,1.8692953,56.6682207),(53091,'hindlimb',41,10,27,80.5532219,100.6352947,119.1614276,1.8,100.6719563,119.6373597,0.8922393,8.4305957,8.3504405,1084.3171508,1628.7155112,8.1362778,195.0454614,128.6169076,285.9152695,15.9408885,18.2402429,0.2621198,58.9514574),(53092,'hindlimb',41,10,28,84.8783612,100.4841459,119.0024588,1.8,100.5519135,119.5607806,0.7840532,8.7789281,8.2649997,1207.6979505,1669.8704779,7.0541697,202.0412034,137.5678135,300.6794035,15.9888406,18.6555863,0.2561514,60.0625388),(53093,'hindlimb',41,10,29,94.0195364,100.2449253,119.1891191,1.8,100.466899,119.4756323,0.3268189,9.112843,9.1856992,1400.240393,1801.2765041,1.6149663,196.0957432,153.6557133,324.5968678,16.7109414,19.507078,0.1325515,62.3457756),(53094,'hindlimb',41,10,30,107.9709849,99.0464611,119.2132195,1.8,98.9886526,119.4551851,0.0226146,9.6567708,17.8545897,1515.9971412,3801.2155163,0.0092015,212.8985084,156.9879999,297.5616215,5.156256,5.7808608,0.8379812,16.849443),(53095,'hindlimb',41,10,31,141.1359435,96.2724447,119.2843652,1.8,97.028838,119.5518065,-0.0025659,9.6351765,15.5003035,1686.6513596,9354.7237396,0.0001549,603.5187483,175.051424,694.1922757,17.6105283,31.8694118,0.067465,96.4617007),(53096,'hindlimb',41,10,32,161.9478612,95.6642594,119.4444241,1.8,96.3814534,119.6283858,0.0088644,9.4259401,14.9203409,1908.0014198,11588.601302,0.0021208,776.6981588,202.4202779,871.1286521,17.18752,32.7945133,0.0918461,98.5796037),(53097,'hindlimb',41,10,33,168.8037427,94.9670344,119.5549304,1.8,95.7292989,119.6566313,-0.0013521,9.3607488,15.4658099,2154.6197637,12403.4373668,0.0000514,801.9908073,230.1760045,931.6775546,17.18752,33.7380335,0.1148766,100.5932469),(53098,'hindlimb',41,10,34,166.599519,94.3571312,119.5892451,1.8,95.4390231,119.6682193,-0.0046028,9.3514803,16.0850071,2321.6596443,12520.6070215,0.0005883,778.4023324,248.2665398,910.55551,17.18752,34.2728372,0.138351,102.9196695),(53099,'hindlimb',41,10,35,164.3468435,94.2232185,119.7288538,1.8,95.1460287,119.7252565,0.0120327,9.111132,16.2021082,2608.481057,12606.1370407,0.0039657,778.0553523,286.2960443,924.5677154,17.18752,34.69847,0.1366432,106.4614333),(53100,'hindlimb',41,10,36,159.8205115,94.0810824,119.7802418,1.8,94.9508678,119.7762723,0.015164,9.0400945,16.3353802,2751.9721097,12240.3480633,0.0061247,749.3151607,304.4185105,902.8885383,17.1864532,35.0689645,0.1228352,109.7514917),(53101,'hindlimb',41,10,37,153.5158399,93.6799755,119.7592829,1.8,94.6927816,119.8147309,0.0062755,9.111933,16.7421974,2826.3005005,11787.9421128,0.0010076,704.0857213,310.1757331,863.2810689,17.0792513,35.2998564,0.0609002,113.1889957),(53102,'hindlimb',41,10,38,151.2145446,93.6528629,119.7542125,1.8,94.5257336,119.8837855,0.0036297,9.1317827,16.3491843,2886.7582053,11591.1040499,0.000332,708.9713966,316.1220887,868.04194,16.8959321,35.1242016,0.1349767,114.8034879),(53103,'hindlimb',41,10,39,147.741509,93.5638348,119.7260458,1.8,94.411577,119.930948,0.0033922,9.160986,16.8649588,2889.1437796,11363.5279687,0.0002833,673.7951813,315.3747629,843.1569141,16.9857814,35.7287574,3.0814244,118.6580311),(53104,'hindlimb',41,10,40,142.9950736,93.4772444,119.7166732,1.8,94.2892705,119.9443063,-0.0090506,9.2611131,16.965928,2836.5783439,11022.1147824,0.0019522,649.661768,306.2891376,813.7157175,17.2146111,35.8293839,0.0960887,118.8054767),(53105,'hindlimb',41,10,41,138.3309392,93.4558322,119.686295,1.8,94.1808472,120.0039199,-0.0108124,9.300883,16.9894488,2757.375825,10647.9223573,0.0026952,626.7373643,296.4638756,786.4738944,17.5489965,35.8731583,0.1080117,119.7691125),(53106,'hindlimb',41,10,42,136.0911319,93.6937442,119.6492342,1.8,94.1767405,120.0153264,-0.0178671,9.3858061,16.7983166,2686.7052215,10501.8849826,0.00724,625.1748445,286.2519407,770.0938418,17.6164224,36.3486588,0.11849,122.0523493),(53107,'hindlimb',41,10,43,135.3274837,93.8115487,119.6837829,1.8,94.1036075,120.0491927,-0.0126948,9.6224824,16.6634917,2700.1449352,10367.7770144,0.0036347,622.1851444,280.6079378,767.8764658,18.0718937,36.1678883,0.1671018,122.9117253),(53108,'hindlimb',41,10,44,136.2373827,93.7526861,119.7468645,1.8,94.0460602,120.1295121,-0.0127513,9.9787153,16.7288283,2749.9569037,10368.3943372,0.0036917,619.7920238,275.582258,763.2124535,18.500535,36.2418331,0.1787931,124.9864425),(53109,'hindlimb',41,10,45,138.0054278,93.8310755,119.9622282,1.8,94.0078623,120.4020763,-0.0365207,12.6558109,16.7474573,2920.5519635,10407.4393224,0.0306642,621.4339968,230.7676679,776.4214522,18.6821074,36.098907,0.1553643,127.7730901),(53110,'hindlimb',41,10,46,137.8025566,93.831314,120.2172753,1.8,94.0338615,120.5759042,-0.0691912,12.2478948,16.8789687,3040.3895048,10470.7883364,0.1097778,620.345265,248.237723,784.0530842,21.3849347,35.975947,0.1317623,134.3532068),(53111,'hindlimb',41,10,47,136.543312,94.1673948,120.564918,1.8,94.3407518,120.8310755,-0.1550994,11.3881958,16.9027112,2869.153423,10206.3194139,0.543068,603.8273543,251.9409993,762.942292,20.4486118,35.5630099,0.2068739,129.5961018),(53112,'hindlimb',41,10,48,133.8571434,94.4733867,120.6769523,1.8,94.3684887,120.9523401,-0.1906982,10.9110019,16.7135667,2897.0923197,9640.6774577,0.801517,576.8174829,265.5202845,742.5635575,19.8895565,35.1425946,0.2093854,128.5892802),(53113,'hindlimb',41,10,49,129.6949277,95.0739746,120.7943799,1.8,94.7276189,121.0206092,-0.263232,9.9719096,16.293916,2872.5613366,8889.7012922,1.4635078,545.5840889,288.0653193,719.0462976,19.5022208,32.1118121,0.2157662,138.4594554),(53114,'hindlimb',41,10,50,127.1896423,95.3966512,120.9220125,1.8,95.1269107,121.1984504,-0.3218963,9.4757551,16.0850683,2821.5149136,8540.8975484,2.1216809,530.9829828,297.7614853,705.7010884,1.718752,6.076706,1.4288993,13.81109),(53115,'hindlimb',41,10,51,127.6137919,95.7285494,120.9923757,1.8,95.5019969,121.2253566,-0.3729504,9.4387816,15.817077,2830.1261935,8537.2687856,2.8237003,539.7500921,299.8402026,715.1790942,1.718752,2.7513456,0.8960554,5.9724462),(53116,'hindlimb',41,10,52,128.7508998,96.0058132,120.9627541,1.8,95.7292948,121.1910703,-0.3842737,9.3889153,15.5488004,2801.4021414,8645.7307903,3.0157627,556.0384448,298.3733548,709.9833901,0.429688,0.6076706,2.3561945,1.2153412),(53117,'hindlimb',41,10,53,126.6990253,96.2095986,120.8748805,1.8,96.0000079,121.0732306,-0.3787976,9.3025215,15.1679659,2711.4367843,8111.6086391,2.8877807,534.7855265,291.4733145,700.8909333,17.5294952,30.1700955,0.6235607,108.4497789),(53118,'hindlimb',41,10,54,125.7981342,96.1679832,120.8970468,1.8,95.9600005,121.113763,-0.3902515,9.3294923,14.8830161,2697.1484471,7811.1996832,3.0342537,524.8398342,289.0991655,698.7521757,17.5294952,29.8470824,0.5280744,106.6267671),(53119,'hindlimb',41,10,55,125.2801021,96.1493915,120.9708412,1.8,95.9471495,121.1905828,-0.4198718,9.1720512,14.4924248,2654.306097,7586.8530082,3.4696984,523.5047346,289.3906746,670.764683,17.368821,29.6982491,0.5478635,106.1233563),(53120,'hindlimb',41,10,56,125.5130179,96.1415391,120.9993736,1.8,95.9682319,121.2553259,-0.4360924,9.1828966,14.6383285,2647.6241994,7475.0408582,3.7323901,510.6485265,288.3212483,651.341384,17.368821,29.7944556,0.5800028,105.8716509),(53121,'hindlimb',41,10,57,126.0966781,96.3396114,120.948332,1.8,96.0119218,121.2559441,-0.4406413,9.1535977,14.6795746,2636.5902496,7172.7118904,3.8232288,488.6185102,288.0386851,634.134343,17.522234,29.3323044,0.5554937,103.1892631),(53122,'hindlimb',41,10,58,129.6326005,96.440406,121.0351437,1.8,96.1271354,121.3028795,-0.4449524,9.0393596,14.7534301,2679.9948848,7250.8805693,4.0025572,491.4708312,296.4806148,630.4839925,17.4885048,29.4767221,0.6405857,102.5815925),(53123,'hindlimb',41,10,59,135.5055695,96.8035521,121.0902701,1.8,96.3108473,121.3380447,-0.4360025,8.8207427,14.8366204,2736.3689326,7248.5397366,4.0279848,488.5573344,310.2197886,637.3720218,17.4885048,29.4359802,0.5880026,97.6159679),(53124,'hindlimb',41,10,60,139.8925324,96.9792989,121.2219283,1.8,96.4325975,121.4269957,-0.4346514,8.6253638,14.9350586,2799.842466,7193.2191353,4.1342999,481.6331362,324.6057228,637.240897,17.4885048,29.3228612,0.608325,96.4006267),(53125,'hindlimb',41,10,61,149.0434428,97.1330124,121.497467,1.8,96.6277406,121.558101,-0.4448909,8.6158786,14.8095316,2944.5064754,6916.4433313,4.6007026,467.0264738,341.7534769,643.4157835,17.296779,29.079435,0.5961991,77.7713578),(53126,'hindlimb',41,10,62,157.2833911,97.2582815,121.6724982,1.8,96.6190174,121.6548559,-0.462917,8.7791963,14.8960486,3049.431639,6794.6861597,5.2274673,456.1401704,347.3474709,643.0533393,17.296779,28.9712972,0.6168012,76.4517568),(53127,'hindlimb',41,10,63,154.3413117,97.0345697,121.7441691,1.8,96.5364835,121.7288059,-0.5148358,8.8855005,14.779412,3004.5797108,6573.1160423,6.2366717,444.7481441,338.1441149,643.0648246,17.2956881,28.6057343,0.5713375,75.1321558),(53128,'hindlimb',41,10,64,147.340914,96.9218622,121.6964888,1.8,96.5144336,121.7604557,-0.5473126,8.8412344,14.6167024,2941.1428759,6309.8564566,6.6502369,431.6880976,332.6620164,626.762342,17.296779,28.3724259,0.6132073,75.3838612),(53129,'hindlimb',41,10,65,140.5849016,96.9023033,121.5611149,1.8,96.4737028,121.7905808,-0.5682721,8.65499,14.7128593,2856.0615016,5849.682281,6.7863616,397.589765,329.9901562,586.9905309,17.2956881,27.7739368,0.6094585,74.8804504),(53130,'hindlimb',41,10,66,138.1000376,96.8987615,121.4756688,1.8,96.4805204,121.7706887,-0.5862374,8.5985539,14.670898,2800.6203394,5678.6259672,7.0445769,387.0673748,325.7082953,577.2605134,17.11378,27.2911083,0.5836358,77.9188034),(53131,'hindlimb',41,10,67,132.0483115,96.8888756,121.3321392,1.8,96.4492918,121.7250058,-0.6069438,8.5151904,14.6486272,2688.7388738,5375.2044574,7.1594461,366.9425379,315.7579259,548.82616,17.1136233,26.9335897,0.5924274,73.6219234),(53132,'hindlimb',41,10,68,129.9752882,96.7912297,121.3056122,1.8,96.4537252,121.6498361,-0.6325982,8.4894023,14.6100339,2644.2394576,5184.6664946,7.5725196,354.8702587,311.4753381,534.9641982,17.0469289,26.5782087,0.6014547,71.2955008),(53133,'hindlimb',41,10,69,128.1148154,96.7310894,121.1472221,1.8,96.3396056,121.4553137,-0.6430483,8.3470152,14.493467,2533.4258513,4916.1761394,7.6776086,339.1994572,303.5127879,513.987258,16.8760947,26.1015566,0.5743048,69.1165238),(53134,'hindlimb',41,10,70,124.7527826,96.6166909,121.1489674,1.8,96.2650233,121.4069446,-0.658689,8.3055396,14.3219561,2464.8566373,4825.3548894,7.7896203,336.9200995,296.7726085,508.8676256,16.9133273,25.7418618,0.583373,68.5088532),(53135,'hindlimb',41,10,71,121.7265559,96.5881802,121.0854632,1.8,96.265458,121.3648001,-0.6832504,8.2761139,14.0730527,2382.4023766,4642.5200942,8.0859162,329.88721,287.8648618,499.088066,16.6886181,25.2750064,0.6162969,67.9011826),(53136,'hindlimb',41,10,72,120.9610613,96.52813,121.0616917,1.8,96.2419368,121.2969329,-0.6997489,8.1901594,13.7594332,2333.0860334,4556.3039984,8.3618166,331.1403846,284.8645447,499.9261985,16.6455902,24.7881939,0.5880026,66.434136),(53137,'hindlimb',41,10,73,119.4807061,96.4814865,120.9587797,1.8,96.1872388,121.1905848,-0.7215437,8.0314607,13.7336249,2262.692781,4320.5747365,8.6886166,314.5982782,281.728676,479.1961195,16.4071061,24.5787546,0.6365082,66.1824306),(53138,'hindlimb',41,10,74,118.3029792,96.4428479,120.8572875,1.8,96.1864915,121.1057308,-0.733198,7.9109149,13.4802291,2203.0630675,4241.5754978,8.8312113,314.651589,278.4839795,477.3802512,16.1032708,24.3258062,0.6223029,64.9670894),(53139,'hindlimb',41,10,75,116.521898,96.4171128,120.681803,1.8,96.1542919,120.959676,-0.7356663,7.85296,13.2887139,2114.1411016,4061.8930113,8.745941,305.6648697,269.2158238,463.6116363,16.1032708,23.9779765,0.6327488,64.3594188),(53140,'hindlimb',41,10,76,114.4652119,96.4185502,120.6040883,1.8,96.1628049,120.8368251,-0.7484615,7.7050135,13.0371938,2065.1882745,3905.3511396,8.8347473,299.5545816,268.0317528,455.4764673,15.7994355,23.5976575,0.5779019,63.6043026),(53141,'hindlimb',41,10,77,115.1314528,96.4265019,120.4688843,1.8,96.1422565,120.6733144,-0.7652827,7.6754685,12.8019196,2011.5837618,3783.0520587,9.2084047,295.5066261,262.0796062,450.6844009,15.7994355,23.1274352,0.6137701,62.6406668),(53142,'hindlimb',41,10,78,114.2395695,96.3892034,120.3851653,1.8,96.2132106,120.5024691,-0.7738738,7.4756605,12.5157149,1983.6585149,3691.9257881,9.3005606,294.9832116,265.348929,452.2644202,15.4956002,22.7775173,0.6246354,61.7812908),(53143,'hindlimb',41,10,79,110.5565012,96.4393614,120.187151,1.8,96.2762094,120.3424131,-0.7837601,7.5526447,12.0736811,1893.4788781,3469.9171831,9.182858,287.3951329,250.7040857,442.8909102,15.4956002,22.0861304,0.6473921,60.5659497),(53144,'hindlimb',41,10,80,110.2360252,96.493999,120.0541423,1.8,96.3234464,120.1523362,-0.8087884,7.5846784,11.6013212,1858.1840941,3303.1974577,9.61592,284.7259727,244.9918092,443.7185569,15.4956002,21.4844,0.6435011,59.7065737),(53145,'hindlimb',41,10,81,108.1679814,96.5724748,119.8335535,1.8,96.4249717,119.9219798,-0.8468871,7.4870702,11.2052583,1796.4687354,3069.5147099,10.1197284,273.9352024,239.942821,434.1287479,15.4716552,20.8032903,0.6682894,57.7793021),(53146,'hindlimb',41,10,82,106.267561,96.6038906,119.7022491,1.8,96.5095989,119.7693517,-0.8604463,7.4674586,10.7601414,1751.0734027,2958.978514,10.1798418,274.9943892,234.4938898,437.5757963,15.1917649,20.1999066,0.6647745,56.3122555),(53147,'hindlimb',41,10,83,106.5606779,96.6934274,119.4770272,1.8,96.605991,119.551809,-0.9014228,7.4091456,10.5877319,1702.4575991,2812.2223414,10.9222239,265.6114038,229.7778585,424.6836954,15.1917649,19.8634868,0.892677,56.0605501),(53148,'hindlimb',41,10,84,103.3089766,96.7221853,119.3141791,1.8,96.6528424,119.3662644,-0.9161906,7.3372117,10.1959455,1655.619969,2680.4874845,10.835491,262.8973912,225.6470208,425.0231346,14.8879296,19.4549516,0.7541583,55.2011741),(53149,'hindlimb',41,10,85,101.4321107,96.7543092,119.1490423,1.8,96.7128204,119.1429573,-0.9459832,7.2750341,9.9851296,1613.0544034,2554.5952515,11.1209918,255.8399691,221.7246518,415.926054,14.8879296,19.163314,0.8329813,54.9494687),(53150,'hindlimb',41,10,86,99.461586,96.7885254,119.0420869,1.8,96.7355336,119.0878494,-0.9589381,7.2451965,9.7289159,1573.8896148,2487.7639665,11.1078135,255.7082409,217.2321516,414.4458079,14.8021612,18.8769524,0.849825,53.9858329),(53151,'hindlimb',41,10,87,97.1978326,96.8513282,118.8342242,1.8,96.9059764,118.9022246,-0.9790895,7.1867004,9.5483438,1513.8342275,2379.1704563,11.1596586,249.171009,210.6438494,407.7151656,14.5840943,18.4965587,1.0343609,53.2307167),(53152,'hindlimb',41,10,88,97.6525303,96.8438306,118.7032211,1.8,96.8629083,118.7596444,-0.9935597,7.1139415,9.2929289,1496.2673573,2345.6104417,11.4286038,252.408091,210.3288806,413.2082272,14.6082537,18.2351811,0.9697226,52.8747515),(53153,'hindlimb',41,10,89,96.3100895,96.8416955,118.5060526,1.8,96.8115834,118.6375064,-1.0075678,7.0117714,9.2240088,1464.389025,2272.7691268,11.4758395,246.3971117,208.8472287,405.151113,14.5438931,18.0724546,1.0752447,52.3713407),(53154,'hindlimb',41,10,90,96.0657041,96.8257757,118.4114882,1.8,96.7628292,118.5244624,-0.9997116,7.0464122,9.1651016,1453.2224038,2240.1083311,11.3327297,244.4171846,206.235791,402.567632,14.4165278,17.99567,0.9894161,52.0153755),(53155,'hindlimb',41,10,91,95.4519433,96.8699735,118.2363101,1.8,96.8089464,118.4119307,-1.0117702,6.9860822,8.9671207,1414.9872812,2189.5631522,11.433829,244.1768354,202.5437478,400.7664166,14.280259,17.7164901,0.8884798,51.7636701),(53156,'hindlimb',41,10,92,93.3887112,96.8679074,118.1426563,1.8,96.9313738,118.2280997,-1.0106067,6.934886,8.8178533,1389.0934509,2140.2266816,11.1703869,242.7151619,200.3051596,400.0586035,14.280259,17.5384304,1.0303768,51.8679299),(53157,'hindlimb',41,10,93,91.9330855,96.8497204,117.9778617,1.8,96.9134719,118.0311154,-1.0280181,6.8773241,8.7215782,1355.9912647,2076.5922992,11.2343812,238.0982257,197.1684398,393.5685658,14.224802,17.4010378,0.9964915,51.1559995),(53158,'hindlimb',41,10,94,92.0755317,96.8157539,117.8627682,1.8,96.842243,117.9084832,-1.0380708,6.9638499,8.6515645,1348.2653896,2061.6887425,11.3875147,238.3024183,193.609197,393.3664505,14.280259,17.321277,1.0516502,50.5483289),(53159,'hindlimb',41,10,95,90.4954753,96.7946169,117.7334388,1.8,96.8695113,117.7680223,-1.0480868,6.9873159,8.5326776,1314.9730051,2006.6625543,11.3235442,235.1738388,188.1942961,389.2019093,14.280259,17.1713991,1.017502,50.2966235),(53160,'hindlimb',41,10,96,89.1027922,96.78923,117.6540302,1.8,96.852663,117.6214651,-1.0508452,6.8735269,8.4389825,1296.7200913,1975.4855126,11.1846624,234.0904853,188.6542556,386.262083,14.1855824,17.1552631,1.1856388,50.2966235),(53161,'hindlimb',41,10,97,88.3260519,96.7831717,117.5229257,1.8,96.8425353,117.5556147,-1.0496121,6.9441998,8.3366265,1278.4466353,1941.0827795,11.0714961,232.8379214,184.102802,383.9065607,14.1994373,17.1229455,1.2649175,50.0449181),(53162,'hindlimb',41,10,98,88.3379691,96.7793385,117.4142247,1.8,96.8070103,117.4795261,-1.0525341,6.9482538,8.3758301,1272.9445227,1932.1528238,11.1100791,230.6819511,183.2035159,381.3132927,14.1821825,16.998492,1.2090671,50.2966235),(53163,'hindlimb',41,10,99,88.0842962,96.8029394,117.2419835,1.8,96.7949979,117.2748726,-1.0601924,6.8515355,8.3778955,1254.6236228,1905.8316207,11.1744933,227.4833357,183.1156856,376.1391612,13.9764237,16.998492,1.2090671,49.7932127),(53164,'hindlimb',41,10,100,87.4895021,96.7648882,117.1740652,1.8,96.7942684,117.1828777,-1.072834,6.9146565,8.2479572,1251.6531878,1886.5327152,11.254993,228.7272692,181.0145135,377.9213975,13.9764237,16.998492,1.2090671,49.7932127),(53165,'hindlimb',41,10,101,86.573169,96.7493661,117.0352409,1.8,96.7990934,117.0668162,-1.0811569,6.9659192,8.1566072,1236.3517568,1843.5539222,11.2373512,226.0197018,177.4858025,370.8226482,13.9764237,16.998492,1.2890245,49.5415073),(53166,'hindlimb',41,10,102,86.6012554,96.7462314,116.9098545,1.8,96.7848994,117.0261075,-1.0966517,7.0326423,8.263984,1237.7339525,1833.289387,11.4246809,221.8408672,175.9984239,364.4838396,14.0989988,16.998492,1.2890245,49.7932127),(53167,'hindlimb',41,10,103,85.7607892,96.7570177,116.7787981,1.8,96.7691942,116.828651,-1.0936361,6.8980562,8.188524,1228.13488,1792.1389172,11.2787109,218.8598226,178.0407191,365.2667463,13.9764237,16.8512217,1.2329181,48.9338367),(53168,'hindlimb',41,10,104,85.2566885,96.7718417,116.6967046,1.8,96.8114215,116.7163639,-1.0971217,6.9208346,8.2692562,1229.7722452,1775.7279638,11.2527258,214.7385345,177.691321,359.8886484,13.9764237,16.8840595,1.3134726,49.5415073),(53169,'hindlimb',41,10,105,84.8841799,96.7988006,116.6081824,1.8,96.8830228,116.6319838,-1.1180567,6.9439625,8.1870678,1224.0559305,1751.5611801,11.4403261,213.9424297,176.2762886,357.8006351,13.9764237,16.998492,1.2890245,49.5415073),(53170,'hindlimb',41,10,106,84.9706211,96.7909392,116.5374275,1.8,96.8609722,116.5509331,-1.123565,6.9879875,8.06956,1224.6652511,1748.2209358,11.5130802,216.6438974,175.2529259,359.1784258,14.0989988,16.8840595,1.3134726,49.1855421),(53171,'hindlimb',41,10,107,84.8760113,96.7868668,116.4359024,1.8,96.8122422,116.4766109,-1.1280246,7.0398717,8.1476237,1223.8829218,1726.9135053,11.5492827,211.9530278,173.8501739,360.0173215,13.9764237,16.7137033,1.2571757,48.9338367),(53172,'hindlimb',41,10,108,84.3182555,96.8097549,116.3558238,1.8,96.8379448,116.411122,-1.1387077,6.8824268,8.2389872,1222.4493339,1714.8376406,11.5886034,208.1369469,177.6189371,354.7695992,13.9764237,16.8512217,1.2329181,48.9338367),(53173,'hindlimb',41,10,109,84.0004091,96.8214501,116.2560643,1.8,96.860979,116.284468,-1.1386546,6.9135249,8.1544701,1218.7884371,1703.3533903,11.5443534,208.8858456,176.2904537,354.2820251,14.0298035,16.7798528,1.3382394,49.1855421),(53174,'hindlimb',41,10,110,84.1262944,96.8323111,116.1759577,1.8,96.8860991,116.1726205,-1.1487425,6.9470482,8.0680654,1222.9491184,1709.6824801,11.6683064,211.9073644,176.0386679,356.780429,14.1332869,16.7798528,1.3382394,49.1855421),(53175,'hindlimb',41,10,111,84.1200841,96.8528592,116.0982465,1.8,96.8872779,116.0912623,-1.1596842,6.969137,7.99251,1220.3006723,1704.0458301,11.7809703,213.2053434,175.1006864,356.0724782,13.9764237,16.7798528,1.3382394,48.9338367),(53176,'hindlimb',41,10,112,84.1753617,96.863846,116.0223643,1.8,96.8912239,116.0114072,-1.1735335,6.896052,8.064407,1219.3402724,1707.9057421,11.9292147,211.7831786,176.8171509,355.9425168,13.9764237,16.7798528,1.3382394,48.6821313),(53177,'hindlimb',41,10,113,84.4465466,96.8814773,115.9285737,1.8,96.9106038,115.8623,-1.2010732,6.8749855,8.1422787,1213.0770486,1712.3930554,12.2365987,210.3088227,176.4479425,358.2058725,14.0298035,16.7137033,1.2571757,49.1855421),(53178,'hindlimb',41,10,114,84.4360282,96.8932415,115.8471224,1.8,96.8974182,115.79321,-1.2142026,6.9013543,8.0803515,1213.642857,1715.8208388,12.3577784,212.3448267,175.855752,360.066168,14.1332869,16.7798528,1.3382394,49.1855421),(53179,'hindlimb',41,10,115,84.7255085,96.9247904,115.7403232,1.8,96.9283748,115.6699432,-1.2208053,6.9118641,8.1975782,1218.1127874,1721.5065239,12.4606776,210.0018434,176.2350594,356.4457875,14.1332869,16.8840595,1.3134726,49.1855421),(53180,'hindlimb',41,10,116,85.2677104,96.9268995,115.6686474,1.8,96.9345654,115.6348309,-1.2246278,6.9356782,8.2691049,1228.0733499,1734.7015263,12.5752553,209.7810528,177.0660792,356.2243233,13.9764237,16.8840595,1.3134726,48.9338367),(53181,'hindlimb',41,10,117,85.6178394,96.9324463,115.5859075,1.8,96.9513095,115.5557696,-1.2392554,6.9610921,8.2214551,1229.8536159,1736.388385,12.7577642,211.2020766,176.6753835,357.0117575,14.179704,16.8840595,1.3134726,49.1855421),(53182,'hindlimb',41,10,118,86.0332609,96.9399853,115.5075125,1.8,96.9730696,115.4141968,-1.2472997,6.9796368,8.1709741,1238.3526321,1748.6413837,12.8899323,214.0064779,177.4236481,359.0863559,14.179704,16.9549897,1.418147,49.5415073),(53183,'hindlimb',41,10,119,86.1636781,96.9683661,115.4137042,1.8,97.0008658,115.2872108,-1.2668645,7.003335,8.1451014,1236.9179268,1748.1799019,13.0744045,214.6296067,176.6184149,365.9295057,14.179704,16.7798528,1.3382394,49.1855421),(53184,'hindlimb',41,10,120,86.5774771,96.9766129,115.3432674,1.8,97.0097283,115.2501341,-1.2830639,7.0325631,8.2212192,1242.2130713,1758.6499088,13.2675613,213.9159489,176.6373158,364.7187735,14.179704,16.8840595,1.3134726,48.9338367),(53185,'hindlimb',41,10,121,87.4605205,96.991984,115.2717052,1.8,96.9787392,115.1926371,-1.3014148,7.0527062,8.2989819,1249.9374801,1769.4869606,13.5443112,213.2173543,177.2280659,363.7409602,14.179704,16.998492,1.2890245,49.1855421),(53186,'hindlimb',41,10,122,88.5936561,97.006523,115.235441,1.8,97.025085,115.1528426,-1.3158029,6.9491668,8.3395343,1263.350357,1787.9330192,13.8261542,214.3924283,181.7988237,365.8722685,14.179704,16.998492,1.2890245,49.7932127),(53187,'hindlimb',41,10,123,89.4614254,97.0035231,115.1870921,1.8,97.0553403,115.0981607,-1.3281144,7.0788008,8.2825955,1264.0468258,1795.9042516,14.0492104,216.8286807,178.5679326,369.0367662,14.179704,17.0256245,1.3932002,49.5415073),(53188,'hindlimb',41,10,124,91.0052268,96.9848918,115.1539103,1.8,97.0167209,115.0567874,-1.3293584,7.0026494,8.3108376,1273.5631166,1817.0300077,14.3004346,218.6337993,181.8687539,371.4349336,14.179704,17.1067638,1.3684747,49.5415073),(53189,'hindlimb',41,10,125,90.7309088,97.0152991,115.0593952,1.8,97.0406241,114.9970295,-1.3386448,7.0022713,8.2677795,1281.093271,1816.1600746,14.3213739,219.6672133,182.953961,374.5942742,14.179704,16.998492,1.2890245,49.4372475),(53190,'hindlimb',41,10,126,91.7412363,97.024174,115.045828,1.8,97.0407152,115.01827,-1.3547798,7.0064529,8.2530286,1288.1088,1846.1518984,14.5877463,223.6938682,183.8460651,378.0481425,14.179704,16.9549897,1.7234457,49.7932127),(53191,'hindlimb',41,10,127,92.2305664,97.0354841,114.9952646,1.8,97.058414,114.9315473,-1.3800463,7.0164541,8.4566564,1284.2379148,1874.1970307,14.8192012,221.6238822,183.032327,372.2752197,14.179704,17.321277,1.4464413,50.4008833),(53192,'hindlimb',41,10,128,91.2832935,97.060035,114.8984157,1.8,97.0735872,114.8411299,-1.3913473,7.0127012,8.4408456,1286.0446484,1870.2297775,14.7292019,221.5690079,183.3879144,372.6004936,14.179704,17.379804,1.4219064,50.4008833),(53193,'hindlimb',41,10,129,91.1541631,97.0877443,114.8080166,1.8,97.0880881,114.7644274,-1.4123555,7.0009226,8.605773,1285.1082147,1870.6066795,14.8141601,217.3664917,183.5626941,366.6766504,14.179704,17.5279,1.3734008,50.1491779),(53194,'hindlimb',41,10,130,91.7955628,97.0933116,114.7767147,1.8,97.0957196,114.7083382,-1.420086,6.9991014,8.5734936,1288.3375628,1882.3019235,14.9543821,219.5489972,184.0718534,369.3124652,14.179704,17.4487192,1.3975507,50.1491779),(53195,'hindlimb',41,10,131,91.4094026,97.1018571,114.6995103,1.8,97.1071654,114.5943056,-1.4266481,6.9386107,8.3521049,1278.5487403,1864.4245435,14.9205254,223.2281055,184.2658137,375.5910645,13.750016,17.1982588,1.3439975,49.6889529),(53196,'hindlimb',41,10,132,91.2253863,97.1255812,114.6206486,1.8,97.1502443,114.4914738,-1.4308182,6.9265253,8.3713272,1278.3595751,1854.984593,14.9082618,221.5878745,184.5600092,374.2435531,13.750016,17.1067638,1.773118,49.6889529),(53197,'hindlimb',41,10,133,91.0453423,97.1791766,114.4825831,1.8,97.2367612,114.2784239,-1.4341363,6.8922041,8.4563627,1273.2258151,1824.2240164,14.8925903,215.7220644,184.7342001,366.1566176,13.750016,17.1067638,1.3684747,49.4372475),(53198,'hindlimb',41,10,134,90.8253507,97.2059257,114.3511399,1.8,97.2604138,114.1680453,-1.4398196,6.8817958,8.2775453,1272.1968778,1802.1920517,14.8793568,217.7205912,184.8640832,369.9359376,13.750016,16.9549897,1.418147,49.4372475),(53199,'hindlimb',41,10,135,90.4790263,97.2408687,114.1823735,1.8,97.286319,114.0272563,-1.4486352,6.8644223,8.3377414,1267.9529516,1748.7038913,14.8559134,209.7335242,184.713716,361.8057505,13.750016,16.8949912,1.4432868,49.1855421),(53200,'hindlimb',41,10,136,90.2406834,97.275037,114.0543402,1.8,97.3308424,113.8707167,-1.4558341,7.0705694,8.0912537,1273.8759277,1711.257829,14.8422131,211.4947694,180.1659602,367.3171527,14.179704,16.6028685,1.7529646,49.1855421),(53201,'hindlimb',41,10,137,89.4764757,97.2981418,113.8764256,1.8,97.3087803,113.6737876,-1.4696482,6.8248123,7.8350073,1267.6042514,1642.4031517,14.7606942,209.6236924,185.7346693,365.120734,13.750016,16.3620316,1.8094056,48.4736117),(53202,'hindlimb',41,10,138,88.7425924,97.3264371,113.7390805,1.8,97.3757328,113.5531395,-1.4696162,7.0644509,7.8877265,1268.6059636,1595.5254275,14.6395322,202.2795057,179.5760174,360.9317865,14.179704,16.1804778,1.7577756,48.8295769),(53203,'hindlimb',41,10,139,88.1983203,97.3523931,113.6068733,1.8,97.3899707,113.4370537,-1.4900154,7.0597786,7.664092,1259.6727119,1554.5262148,14.6040047,202.8324047,178.429493,360.7281948,14.179704,16.0544686,1.8417432,47.9702009),(53204,'hindlimb',41,10,140,88.2717814,97.3628913,113.5189722,1.8,97.3624495,113.3804558,-1.5143706,7.0597159,7.7036199,1255.263575,1540.8781715,14.6651724,200.0200143,177.8065287,358.8446211,14.179704,15.8461105,1.7894653,47.9702009),(53205,'hindlimb',41,10,141,87.6603704,97.3883745,113.3997859,1.8,97.3963402,113.2735478,-1.536377,7.0377372,7.406937,1251.3371966,1504.5403627,14.5927602,203.1258491,177.8039102,358.1798353,14.179704,15.6408793,1.849096,47.6142357),(53206,'hindlimb',41,10,142,87.1126295,97.4067819,113.3090747,1.8,97.4569079,113.226931,-1.5485211,7.0180977,7.4667428,1259.0029754,1480.3603556,14.5115688,198.260527,179.3937653,357.6058364,14.179704,15.5283322,1.8224863,47.8659411),(53207,'hindlimb',41,10,143,86.5075408,97.4199093,113.1810603,1.8,97.4443566,113.0733574,1.5566257,7.008203,7.5621986,1256.2273236,1442.9834467,14.4150284,190.8153345,179.2509898,356.9342024,14.179704,15.3549594,1.8836976,47.8659411),(53208,'hindlimb',41,10,144,85.9219224,97.4348006,113.0857545,1.8,97.4606114,113.029096,1.5165818,7.0199132,7.3383429,1253.8830429,1423.7656382,14.2782711,194.0173225,178.6180263,353.7241561,14.179704,15.4029813,1.9720251,47.5099759),(53209,'hindlimb',41,10,145,85.2884116,97.4731435,112.9739967,1.8,97.4822075,112.9558239,1.4791913,7.0267523,7.4711404,1249.5304898,1386.6152582,14.0957858,185.5961978,177.8247525,349.0400943,14.179704,15.2584623,2.1353657,47.2582705),(53210,'hindlimb',41,10,146,85.3203025,97.4944601,112.8942688,1.8,97.4951054,112.8983797,1.4404197,7.0138057,7.4170876,1257.1150424,1369.1210283,13.9797035,184.5901113,179.2343704,351.8230567,14.179704,15.2584623,2.1353657,47.2582705),(53211,'hindlimb',41,10,147,84.8981112,97.5189293,112.7954295,1.8,97.5261926,112.776098,1.3716223,6.9719437,7.4615183,1248.3256414,1347.7949071,13.5957467,180.6327951,179.049875,343.9112511,14.179704,15.240301,1.9460671,47.5099759),(53212,'hindlimb',41,10,148,84.8852429,97.53523,112.7079314,1.8,97.5453586,112.67965,1.32894,7.018538,7.4816999,1249.7507414,1337.846412,13.3359976,178.8158344,178.0642543,345.4317604,14.179704,15.1125613,1.8295672,47.0065651),(53213,'hindlimb',41,10,149,84.4144878,97.5554684,112.6172373,1.8,97.5626023,112.6232592,1.2941589,6.9606612,7.4544469,1242.8382768,1315.9970768,13.0195857,176.5385269,178.5517552,342.8922855,14.179704,15.1917649,2.0724004,47.0065651),(53214,'hindlimb',41,10,150,84.5005934,97.580092,112.5348332,1.8,97.5195611,112.5586411,1.2432206,6.9848116,7.50514,1244.9604325,1308.7675325,12.6254851,174.3828263,178.2382276,339.2413893,14.179704,15.1917649,2.0724004,47.0065651),(53215,'hindlimb',41,10,151,83.5685946,97.6206186,112.4479135,1.8,97.5799809,112.4447127,1.1405804,7.0616299,7.4082782,1227.4176827,1292.0176355,11.5053765,174.4018787,173.8150687,338.7722025,14.179704,15.03908,2.2142974,46.6505999),(53216,'hindlimb',41,10,152,83.2163395,97.6259702,112.3892986,1.8,97.5613059,112.3876934,1.0666041,7.0950155,7.4274702,1223.8039079,1288.324391,10.6324694,173.4539975,172.4878414,335.378949,14.179704,15.1369758,2.1745457,46.6505999),(53217,'hindlimb',41,10,153,82.3035312,97.6574479,112.3381548,1.8,97.6056162,112.3466467,0.9840662,7.0241828,7.404984,1208.3592845,1272.840848,9.5126654,171.8897499,172.0284515,332.4197382,14.179704,15.1369758,2.1745457,46.6505999),(53218,'hindlimb',41,10,154,81.8450289,97.6757392,112.2797382,1.8,97.6118346,112.2945116,0.9370687,7.0780801,7.2972066,1204.2520242,1265.9831956,8.8577494,173.4887417,170.1382314,336.2723012,14.179704,15.03908,2.2142974,46.9023053),(53219,'hindlimb',41,10,155,80.7678424,97.7057081,112.2249899,1.8,97.6800986,112.2259496,0.8377141,7.0353765,7.209172,1188.0884856,1249.7758124,7.4336098,173.3591335,168.8734751,330.8528946,14.179704,15.03908,2.2142974,46.9023053),(53220,'hindlimb',41,10,156,80.4173777,97.7287399,112.15974,1.8,97.7172166,112.0963512,0.8093118,6.8930393,7.194668,1184.4586111,1246.7844215,7.0218378,173.2928358,171.8340142,327.665578,14.179704,15.1369758,2.1745457,46.6505999),(53221,'hindlimb',41,10,157,79.8039526,97.7571926,112.0878223,1.8,97.7495441,112.0245212,0.7828587,6.884273,7.1803161,1171.7538004,1239.544342,6.616553,172.6308872,170.207342,329.1286397,13.750016,15.03908,2.2142974,46.2946347),(53222,'hindlimb',41,10,158,79.5863109,97.765024,112.0371517,1.8,97.7498452,112.0303877,0.7468807,6.9614081,7.1965998,1171.5900266,1240.3995297,6.1217873,172.3591086,168.2978511,327.1916661,13.750016,15.03908,2.2142974,46.2946347),(53223,'hindlimb',41,10,159,78.9804949,97.7773417,111.9695508,1.8,97.7377439,111.9851564,0.7214895,7.0012591,7.0927378,1162.7283397,1228.7834622,5.7427409,173.2452966,166.0741754,325.089713,13.750016,14.8972278,2.1507991,46.0429293),(53224,'hindlimb',41,10,160,78.9459743,97.8024043,111.9011443,1.8,97.7929339,111.8961181,0.6777808,7.0035025,7.0955836,1164.640434,1230.0672932,5.1737454,173.3567485,166.2939987,323.2880182,13.750016,15.0329403,2.1112158,46.2946347),(53225,'hindlimb',41,10,161,78.4194381,97.8284635,111.8435509,1.8,97.8048865,111.868133,0.6505113,6.9447955,7.0928038,1157.1344653,1224.1043998,4.7933003,172.5839935,166.6189412,319.6990325,13.750016,15.0329403,2.1112158,46.0429293),(53226,'hindlimb',41,10,162,77.8728161,97.8578946,111.8119126,1.8,97.8145823,111.841358,0.5915861,7.0108599,7.2323286,1154.5961664,1220.0828349,4.0364728,168.6984793,164.686811,325.4926789,13.750016,14.9652379,2.2545056,46.2946347),(53227,'hindlimb',41,10,163,76.9238647,97.8660108,111.779402,1.8,97.8267732,111.8117855,0.5620393,6.9104979,7.1907295,1141.3030531,1213.4636503,3.6410137,168.7539,165.1549678,321.5620004,13.750016,14.9652379,2.2545056,45.9386695),(53228,'hindlimb',41,10,164,76.4717407,97.8683965,111.7491072,1.8,97.813737,111.8376276,0.5431043,6.924986,7.1544563,1136.4049283,1216.244303,3.4039888,169.9981454,164.1021265,320.0782658,13.750016,15.03908,2.2142974,45.9386695),(53229,'hindlimb',41,10,165,76.0962668,97.8718147,111.6953462,1.8,97.8144769,111.7475714,0.5341585,6.8985761,7.2020499,1128.7275393,1213.9018925,3.2873591,168.5494973,163.6174649,317.7951242,13.750016,15.03908,2.2142974,46.2946347),(53230,'hindlimb',41,10,166,75.9776548,97.8884681,111.6499255,1.8,97.8629693,111.6958004,0.5205392,6.948341,7.1972385,1129.0050128,1217.5864889,3.132242,169.1741204,162.4855513,316.9582615,14.179704,15.1369758,2.1745457,46.9023053),(53231,'hindlimb',41,10,167,75.5727518,97.9184282,111.6163031,1.8,97.8985017,111.6758429,0.4776873,6.8546494,7.2121988,1124.233029,1211.5465296,2.662032,167.9857369,164.0102901,314.840046,14.179704,15.1369758,2.1745457,46.9023053),(53232,'hindlimb',41,10,168,75.4127935,97.9366553,111.5760261,1.8,97.9228014,111.6240049,0.4462077,6.8563814,7.207003,1124.8699232,1212.8299864,2.3407302,168.2849277,164.0617495,320.7078259,14.1332869,15.03908,2.2142974,46.6505999),(53233,'hindlimb',41,10,169,75.1395385,97.9351858,111.5436281,1.8,97.9188365,111.6023777,0.4375242,6.8929575,7.1898974,1122.2379744,1210.0147554,2.248177,168.2937442,162.8093575,318.7284903,14.179704,15.03908,2.2142974,46.6505999),(53234,'hindlimb',41,10,170,75.0825824,97.9438556,111.5031708,1.8,97.9377772,111.5544656,0.419728,6.9481747,7.1759477,1124.9545128,1215.218988,2.0781115,169.346132,161.9064813,318.5197005,14.179704,15.03908,2.2142974,46.6505999),(53235,'hindlimb',41,10,171,74.8236503,97.9471591,111.4700887,1.8,97.9577753,111.5241343,0.3780296,6.924259,7.146989,1122.5219429,1212.4288106,1.6988379,169.6419016,162.114379,316.6736769,14.1332869,15.03908,2.2142974,46.6505999),(53236,'hindlimb',41,10,172,74.5746771,97.958652,111.4394589,1.8,97.9737468,111.4670661,0.3588584,6.896413,7.1343174,1123.1847963,1214.3002593,1.5330732,170.2055274,162.8650726,316.1595172,14.1593084,15.03908,2.2142974,46.9023053),(53237,'hindlimb',41,10,173,74.2133583,97.9721802,111.4199342,1.8,97.9493644,111.4236001,0.325552,6.9407909,7.1137281,1121.0095123,1212.1912783,1.2652439,170.4016894,161.5103426,316.0134003,13.750016,14.9898924,2.0472637,46.5463401),(53238,'hindlimb',41,10,174,74.1227209,97.9839002,111.3910298,1.8,97.9619224,111.4190008,0.3033668,6.9818241,7.1192918,1124.0649848,1215.8358203,1.1024835,170.7804439,160.9987534,315.9935087,13.750016,15.03908,2.2142974,46.5463401),(53239,'hindlimb',41,10,175,73.7053412,97.9820948,111.3585261,1.8,97.9577033,111.3959165,0.3001994,6.88641,7.2359994,1118.0228566,1212.3984947,1.0741917,167.5509392,162.3520614,317.9907736,13.750016,15.03908,2.2142974,46.5463401),(53240,'hindlimb',41,10,176,73.5937229,97.9821201,111.323249,1.8,97.9695661,111.3453604,0.2773765,6.9360891,7.2226156,1117.9391954,1219.0537947,0.9197343,168.7828717,161.1771682,319.874487,13.750016,14.9652379,2.2545056,46.5463401),(53241,'hindlimb',41,10,177,73.5357038,97.9985017,111.3044218,1.8,97.9744534,111.3255233,0.2419544,6.9759252,7.2219406,1117.7423649,1219.8123818,0.7035951,168.9036859,160.2285484,319.4306151,13.750016,14.8972278,2.1507991,46.2946347),(53242,'hindlimb',41,10,178,73.5800154,98.0082249,111.2847122,1.8,97.9869708,111.3351554,0.2179625,7.0039792,7.214387,1120.4828199,1225.9350982,0.5734348,169.9292113,159.9780345,319.9812153,14.179704,14.8972278,2.1507991,46.6505999),(53243,'hindlimb',41,10,179,73.4801464,98.0156505,111.2735372,1.8,98.0007956,111.3204294,0.1980257,7.0188051,7.2061126,1119.6387437,1224.956573,0.4739994,169.9885419,159.51985,319.3876634,14.179704,14.8972278,2.1507991,46.6505999),(53244,'hindlimb',41,10,180,73.4922873,98.021858,111.2493406,1.8,98.0085596,111.3121737,0.1946881,6.9607319,7.2050473,1122.0317912,1231.1108145,0.4584323,170.8678329,161.1945129,319.6556097,14.179704,15.03908,2.2142974,46.9023053),(53245,'hindlimb',41,10,181,73.4788596,98.0223058,111.2231084,1.8,98.0112081,111.2683671,0.185586,6.9903366,7.1937181,1122.869956,1235.3108213,0.416975,171.7207712,160.631743,321.353635,14.179704,15.03908,2.2142974,47.1540107),(53246,'hindlimb',41,10,182,73.5055472,98.0250484,111.1916088,1.8,98.0186829,111.2345296,0.1670947,7.0277522,7.2421292,1126.9856046,1242.8298834,0.3388819,171.6111166,160.3621708,321.76816,14.179704,15.03908,2.2142974,47.5099759),(53247,'hindlimb',41,10,183,73.1174848,98.0168795,111.1603845,1.8,97.9730089,111.1786613,0.1729255,6.9815539,7.2948212,1121.9609524,1240.3716437,0.3607904,170.0345498,160.7036156,320.3644137,14.1332869,15.03908,2.2142974,47.5099759),(53248,'hindlimb',41,10,184,73.0542065,98.0235639,111.124604,1.8,97.9702346,111.1164944,0.1720961,7.0185574,7.2960806,1124.9094172,1243.7168388,0.3570624,170.4636927,160.2764441,320.806401,14.179704,15.03908,2.2142974,47.5099759),(53249,'hindlimb',41,10,185,73.1252617,98.0319329,111.1017488,1.8,97.997739,111.1070043,0.1650245,7.0474514,7.307464,1126.6680473,1248.3213272,0.3289026,170.8282564,159.8688629,321.2238239,14.179704,15.03908,2.2142974,47.5099759),(53250,'hindlimb',41,10,186,73.1651534,98.0407294,111.074799,1.8,98.0107346,111.0873896,0.1732801,7.0697089,7.3772982,1132.1822851,1256.6494135,0.3624928,170.340059,160.1455314,322.6099596,14.179704,15.0881073,0.348771,47.2582705),(53251,'hindlimb',41,10,187,73.1123935,98.0453542,111.058041,1.8,98.0180493,111.0904015,0.1647959,7.0929228,7.3842457,1136.492829,1257.7015667,0.3279424,170.3222799,160.2291268,320.8812062,14.179704,15.1369758,2.5378433,47.2582705),(53252,'hindlimb',41,10,188,73.3972859,98.0349025,111.0359789,1.8,98.0078643,111.0777691,0.1428956,7.1261651,7.3819339,1143.5603245,1269.8434055,0.2480897,172.0204248,160.4734542,323.7628745,14.179704,15.1369758,2.5378433,47.2582705),(53253,'hindlimb',41,10,189,73.4939099,98.036307,111.0370183,1.8,98.009917,111.0825586,0.1106207,7.1384996,7.394111,1147.1051333,1277.6652597,0.1492797,172.79498,160.6927508,325.2339075,14.179704,15.1369758,2.5378433,47.2582705),(53254,'hindlimb',41,10,190,73.6213617,98.0337597,111.0308136,1.8,98.0043867,111.0740064,0.0938356,7.1483457,7.3934827,1154.1256553,1288.7666771,0.107724,174.311177,161.4535302,327.7345307,14.179704,15.1917649,0.5016041,47.2582705),(53255,'hindlimb',41,10,191,73.397174,98.0226499,111.0521354,1.8,97.984551,111.090035,0.0796203,7.1279871,7.384667,1153.518932,1295.1110565,0.0773852,175.378396,161.8295491,329.1293594,14.179704,15.1917649,0.5016041,47.8659411),(53256,'hindlimb',41,10,192,73.3288043,98.0180181,111.0513767,1.8,98.0105349,111.0965497,0.069132,7.12891,7.4089013,1158.6425961,1304.9112365,0.0583162,176.1274974,162.5273132,331.3343726,14.179704,15.240301,0.3752708,48.1176465),(53257,'hindlimb',41,10,193,73.3624296,98.0049585,111.0569632,1.8,97.9961458,111.090035,0.0510133,7.1217418,7.3851302,1163.8126289,1311.6573646,0.0317916,177.6078873,163.416852,330.204944,14.179704,15.3549594,0.3129012,48.1176465),(53258,'hindlimb',41,10,194,73.6780381,98.0040873,111.0420486,1.8,98.005462,111.0797699,0.032294,7.1334491,7.3697342,1174.2040004,1325.9988198,0.0128021,179.9249176,164.6053655,333.4067631,14.179704,15.3849907,0.6267429,48.1176465),(53259,'hindlimb',41,10,195,73.7356656,98.0054839,111.0391656,1.8,98.0135949,111.0994244,0.0090717,7.1289714,7.3504395,1180.2860095,1335.3405836,0.0010113,181.668127,165.5618946,335.3759839,14.179704,15.3849907,0.6267429,48.1176465),(53260,'hindlimb',41,10,196,74.0802556,98.0159202,111.0279088,1.8,98.0351781,111.0882198,-0.0016556,7.1397605,7.3543089,1189.9605113,1352.8891892,0.0000339,183.9587105,166.6667275,338.4399719,14.179704,15.4269362,0.2247112,48.1176465),(53261,'hindlimb',41,10,197,74.52326,98.0178829,111.0350635,1.8,98.034353,111.0786917,-0.0135413,7.156911,7.3739369,1199.3135983,1369.1789155,0.0022774,185.6781435,167.5741955,341.8325271,14.179704,15.4269362,0.2247112,48.1176465),(53262,'hindlimb',41,10,198,74.8618635,98.0144148,111.0261207,1.8,98.0436787,111.056803,-0.0187595,7.1762702,7.3780691,1212.1450526,1384.2684401,0.0043904,187.6193383,168.9101754,343.2156438,14.179704,15.5758196,0.4266275,48.1176465),(53263,'hindlimb',41,10,199,75.2496462,98.0207351,111.0392971,1.8,98.030713,111.058723,-0.0122416,7.1500338,7.3801147,1220.3594112,1402.4366819,0.0018794,190.0291178,170.6788321,344.4058821,14.179704,15.6408793,0.2782997,48.1176465),(53264,'hindlimb',41,10,200,75.7317589,98.0267427,111.0311218,1.8,98.0049398,111.0121817,-0.0015591,7.136999,7.3656479,1234.6556742,1420.916179,0.0000307,192.9112283,172.9936736,348.347497,14.179704,15.6408793,0.2782997,48.3693519),(53265,'hindlimb',41,10,201,76.2497909,98.0048197,111.0358375,1.8,97.9965858,110.966611,-0.0077524,7.147856,7.3557195,1250.4625966,1433.3802284,0.0007638,194.8660801,174.942332,353.0932881,14.179704,15.6408793,0.2782997,48.3693519),(53266,'hindlimb',41,10,202,76.7983711,97.9943335,111.0332156,1.8,97.9813007,110.9614849,-0.003415,7.1396602,7.3368665,1261.8170055,1459.2410595,0.0001493,198.8915916,176.7334812,356.1291525,14.179704,15.7643386,0.3045109,48.3693519),(53267,'hindlimb',41,10,203,77.756554,98.0069572,111.0227012,1.8,98.0029469,110.9763597,-0.0077339,7.5806352,7.3579231,1279.9652935,1485.7624322,0.0007751,201.9268766,168.8467084,357.5899298,14.609392,15.7643386,0.3045109,48.7253171),(53268,'hindlimb',41,10,204,77.9570194,98.0211951,111.0180508,1.8,98.0084639,110.9907155,-0.0031321,7.5810194,7.7875261,1297.4929913,1497.7393714,0.0001275,192.3254381,171.1501999,358.7570969,14.609392,15.9679831,0.4154921,49.5846931),(53269,'hindlimb',41,10,205,78.3166038,98.0132772,111.0362922,1.8,98.0488467,111.0072093,-0.0033381,7.5631429,7.7810325,1313.8853884,1513.7695968,0.0001455,194.5461099,173.7221435,362.1165153,14.609392,16.0429641,0.3556359,49.9406583),(53270,'hindlimb',41,10,206,78.9709836,98.0376025,111.0440078,1.8,98.0950741,111.0241508,-0.0303895,7.6095857,7.8330815,1328.6253962,1545.4092005,0.0121515,197.2926233,174.5989145,364.6829943,14.609392,16.1061369,0.1607627,50.1923637),(53271,'hindlimb',41,10,207,79.7279179,98.063088,111.0462101,1.8,98.1160878,111.007869,-0.0756247,7.6813066,7.9219825,1343.0092207,1584.2889269,0.0758504,199.9864208,174.8412462,366.962284,14.609392,16.2658334,0.2129383,50.1923637),(53272,'hindlimb',41,10,208,80.5393466,98.0643195,111.0303905,1.8,98.1346888,111.007962,-0.1079239,7.7406283,7.9510121,1365.424389,1617.4009073,0.1557419,203.4207582,176.3971007,373.7234479,14.609392,16.3620316,0.4048918,50.1923637),(53273,'hindlimb',41,10,209,81.888837,98.0754407,111.0202141,1.8,98.1185121,110.987145,-0.1542734,7.7974818,7.9872492,1389.2904174,1662.0301331,0.3222608,208.0854237,178.1716773,381.2210707,14.609392,16.446445,0.5807564,50.4440691),(53274,'hindlimb',41,10,210,82.3581374,98.0615938,111.0302961,1.8,98.1500966,110.9536159,-0.1843512,7.8122594,8.0570066,1405.95275,1696.3285168,0.4612345,210.540787,179.9674934,384.2742728,15.03908,16.5973074,0.3708913,50.8000343),(53275,'hindlimb',41,10,211,83.7084112,98.0599418,111.0534697,1.8,98.1778184,111.0331205,-0.207497,8.0459432,8.1487669,1437.8406084,1740.7998186,0.5921061,213.6273905,178.7037977,388.5587367,15.4224941,16.757832,0.3947911,51.1559995),(53276,'hindlimb',41,10,212,84.8634788,98.0933027,111.0423194,1.8,98.1491704,111.0413341,-0.2256676,8.1356303,8.19553,1462.2784121,1790.1991472,0.7081466,218.4360441,179.7375696,395.8830184,15.468768,16.8512217,0.3378782,51.4077049),(53277,'hindlimb',41,10,213,86.6480288,98.1193345,111.0284667,1.8,98.1923018,111.016647,-0.2614038,8.1288024,8.2396086,1492.8399729,1853.8048561,0.9645315,224.9870049,183.6482053,402.1421931,15.468768,17.1713991,0.5532943,52.0153755),(53278,'hindlimb',41,10,214,87.0539949,98.1261893,111.0420105,1.8,98.1984831,111.0353515,-0.2846669,8.2195296,8.3675631,1518.4309914,1902.5932708,1.1443229,227.3772231,184.7345362,408.1291361,15.468768,17.1713991,0.5532943,52.3713407),(53279,'hindlimb',41,10,215,88.1632962,98.1166748,111.0827852,1.8,98.2226619,111.0373059,-0.3196523,8.1672187,8.3579225,1552.0066139,1968.7618698,1.4509407,235.556367,190.0287818,410.9344169,15.468768,17.321277,0.4081491,53.1264569),(53280,'hindlimb',41,10,216,89.1331725,98.1107156,111.0771204,1.8,98.2108829,111.0439214,-0.3267291,8.3079811,8.4929735,1577.6961895,2025.0821762,1.5302217,238.4420681,189.9012728,418.2104885,15.840887,17.5384304,0.5404195,53.7341275),(53281,'hindlimb',41,10,217,91.327717,98.0839989,111.0683291,1.8,98.1619516,111.0648296,-0.3547645,8.4198386,8.5606699,1626.1818875,2114.6176836,1.8366858,247.0154454,193.1369435,428.9639972,15.898456,17.7633248,0.5611634,53.7341275),(53282,'hindlimb',41,10,218,92.5390134,98.1048256,111.0553831,1.8,98.168698,111.0606822,-0.3766292,8.549436,8.6689753,1660.4225005,2186.0008454,2.0862615,252.1636948,194.2142742,433.1837324,15.898456,17.99567,0.5813802,53.9858329),(53283,'hindlimb',41,10,219,94.2268835,98.1085423,111.0985583,1.8,98.1705811,111.1080404,-0.3920917,8.6524679,8.7516384,1692.0728587,2267.9719626,2.2931271,259.1482711,195.559565,441.5151121,15.898456,18.1285566,0.5485494,53.9858329),(53284,'hindlimb',41,10,220,95.5118088,98.1217445,111.1234684,1.8,98.2498138,111.1268937,-0.3903941,9.9815824,8.9102264,1741.5754615,2335.2220278,2.3053452,262.0833546,174.4788938,406.3145555,16.3315711,18.3914495,0.6528466,55.8088447),(53285,'hindlimb',41,10,221,97.3946053,98.1251888,111.1982559,1.8,98.2212853,111.2385444,-0.4170761,10.8855359,9.1544143,1818.3734419,2430.069738,2.6636948,265.4533264,167.0449171,382.7240403,16.7614584,19.0279509,2.0142447,60.8176551),(53286,'hindlimb',41,10,222,98.3725383,98.0945157,111.2009727,1.8,98.2277939,111.2457045,-0.4229525,10.8826842,9.2339145,1849.4318363,2506.8114614,2.7621854,271.4787375,169.9426178,392.2910161,16.951623,19.0812438,1.4352686,61.0693605),(53287,'hindlimb',41,10,223,100.7941239,98.1008583,111.2681245,1.8,98.2311713,111.2818303,-0.4390889,10.7821452,9.4531951,1917.4746823,2606.0385996,3.0359646,275.6780712,177.8379574,409.8227633,16.8610744,18.9501664,0.5754247,58.1352673),(53288,'hindlimb',41,10,224,103.7674229,98.1371864,111.4267932,1.8,98.3720644,111.5555397,-0.4756788,13.2625411,9.7291298,2119.5730188,2700.8913874,3.6268599,277.6087308,159.8165085,362.9415556,17.6102106,20.413572,2.1003859,65.3230546),(53289,'hindlimb',41,10,225,104.2232955,98.1095832,111.3883365,1.8,98.2394621,111.41196,-0.5043158,9.9510688,9.7715711,2062.9287423,2799.5547345,4.0558581,286.4999617,207.3072539,476.9418906,17.0721162,19.3120737,0.5633163,59.4548682),(53290,'hindlimb',41,10,226,106.4378698,98.0474606,111.4506247,1.8,98.2005585,111.4296129,-0.5468005,9.8270073,10.1183599,2109.1925298,2930.0219162,4.7960053,289.5747884,214.632235,495.2534965,17.2385183,19.6813991,0.6304014,60.5659497),(53291,'hindlimb',41,10,227,108.8920737,97.9964023,111.5504478,1.8,98.1241689,111.5729672,-0.5687091,9.7121163,10.2362032,2173.9352141,3085.2149907,5.2636707,301.4022817,223.8374365,511.7743005,17.425557,19.9377084,0.6478114,61.0693605),(53292,'hindlimb',41,10,228,111.8291736,97.9928205,111.7379013,1.8,98.2678327,111.8015735,-0.5438459,10.6516452,10.532884,2335.5863902,3212.3933674,4.9900919,304.9870641,219.2700147,516.1135197,18.7773489,20.4677674,0.6812982,70.8352758),(53293,'hindlimb',41,10,229,113.3682753,97.910757,111.8624783,1.8,98.2147478,111.9443749,-0.5737645,9.7161506,10.8428367,2436.9127758,3369.9525813,5.5669341,310.7999026,250.8105188,533.9578078,18.5093375,20.8032903,0.6682894,71.0437954),(53294,'hindlimb',41,10,230,114.5344768,97.9009557,111.9739966,1.8,98.1724317,112.0209673,-0.5954929,9.9483598,10.9291417,2513.0559746,3497.185513,6.0059544,319.9872049,252.6100813,548.8396538,18.6880118,21.072243,0.8865015,74.5855592),(53295,'hindlimb',41,10,231,122.1449986,97.8687741,112.2751516,1.8,98.1009326,112.5548716,-0.5802039,15.5136433,11.3448955,2862.9388694,3878.7471309,6.1177781,341.8935969,184.5432958,375.6655417,19.1446806,23.0033622,0.5724598,69.1597097),(53296,'hindlimb',41,10,232,128.217314,97.6682192,112.5443843,1.8,97.8432551,112.8584216,-0.6009963,15.4570518,11.8016496,3070.9440957,4355.3035949,6.8329156,369.0419352,198.6759274,419.0288301,19.3550904,23.9587186,0.5681047,71.1301671),(53297,'hindlimb',41,10,233,141.7296745,97.30898,113.0608357,1.8,97.7318258,113.4601641,-0.6081224,14.8236026,12.5347407,3638.9808657,5232.790831,7.7104509,417.4630303,245.4855917,527.5087083,20.195336,24.6762153,0.6121525,76.9983534),(53298,'hindlimb',41,10,234,153.3277392,97.1741967,113.5340084,1.8,97.5744843,114.07917,-0.6514974,13.9100989,13.0766421,4162.9210287,5988.1166087,9.396281,457.9246381,299.2732883,622.1590233,22.343776,28.1535827,1.2924967,91.6688194),(53299,'hindlimb',41,10,235,179.8779567,97.2045578,114.6101218,1.8,97.3476548,115.1988223,-0.7439045,13.8712749,15.2267552,5533.8856624,7588.1285076,13.747292,498.3417942,398.9457145,831.9686155,22.4270084,28.4146927,1.2155655,96.9904092),(53300,'hindlimb',41,10,236,223.8293834,97.1196669,116.1254019,1.8,97.2144082,116.3752406,-0.8564376,13.7322547,15.812815,7910.67175,11063.6564473,21.2936613,699.6639407,576.0650344,1199.0198738,23.2472212,31.6251536,0.9300126,109.9421231),(53301,'hindlimb',41,10,237,267.5573498,96.7026943,117.3343187,1.8,96.9807398,117.0601306,-0.7960958,14.5397668,16.1366649,10002.5174641,14826.0583177,22.7734462,918.7808286,687.942083,1519.0654074,23.8940527,32.6817201,0.887842,99.7159828),(53302,'hindlimb',41,10,238,291.7251459,97.1254373,117.8126689,1.8,97.3461611,117.5004071,-0.7246081,18.3383317,16.3738538,12478.4854459,16165.8098202,21.3620389,987.294134,680.4591422,1545.5458877,27.3422657,33.2862629,0.8859751,111.3480958),(53303,'hindlimb',41,10,239,318.2635581,97.8655662,118.2992328,1.8,97.8662234,117.8652035,-0.3576461,16.2451897,16.3460337,15326.7343279,17526.0491356,6.50049,1072.189709,943.4629343,1802.6995066,27.500032,34.1649249,2.2671449,115.4975302),(53304,'hindlimb',41,10,240,323.6883194,97.8604734,118.3552515,1.8,97.926134,117.9965475,-0.4647165,17.3711204,16.9236143,15723.2694776,18154.8814378,10.8357777,1072.7543817,905.1384773,1832.9659231,27.92972,34.5598462,2.2416538,113.5270728),(53305,'hindlimb',41,10,241,328.0693518,97.8551021,118.4488834,1.8,97.9727183,118.1224248,-0.5727276,18.2357822,17.3603255,16086.9355672,18421.7061402,16.0581345,1061.1382929,882.1631785,1843.503984,28.2501015,35.1005392,2.2608324,113.6745184),(53306,'hindlimb',41,10,242,328.8506239,97.9154938,118.4181105,1.8,98.0279136,118.2019571,-0.5526312,18.1416689,17.6145629,16469.5765606,18359.2653104,15.1024645,1042.2776537,907.831394,1862.7790855,28.359408,35.1005392,2.2608324,116.2094606),(53307,'hindlimb',41,10,243,326.0516062,97.9976747,118.4986519,1.8,98.0280033,118.3458245,-0.4710135,17.6033819,17.5792493,15958.4399533,17915.2746807,11.1903659,1019.1148859,906.5553429,1822.9139327,27.92972,35.1005392,2.2608324,116.5654257),(53308,'hindlimb',41,10,244,322.530846,98.103022,118.4933957,1.8,98.0618562,118.4342966,-0.4143233,17.2003033,17.4677002,15953.005369,17577.4415462,8.7117246,1006.2825312,927.4839568,1811.4126521,27.92972,35.1005392,2.2608324,118.7875886),(53309,'hindlimb',41,10,245,304.4615494,98.0942849,118.5789676,1.8,98.0845014,118.4443934,-0.3587098,16.7164177,17.1710756,15010.6624372,17140.222037,6.2540284,998.203168,897.9592811,1741.9390336,27.92972,34.8285914,2.2513176,120.1071895),(53310,'hindlimb',41,10,246,288.5135041,98.1346921,118.4365729,1.8,98.1108281,118.3671504,-0.2749839,15.7160537,16.6494516,14562.11104,16700.0075089,3.5453176,1003.0364928,926.5755443,1715.0562702,27.7079926,34.4956781,2.2591551,119.2478135),(53311,'hindlimb',41,10,247,266.1228168,98.0825332,118.3732545,1.8,98.1296837,118.1928283,-0.1448107,14.4582818,15.6637549,13318.5054812,15741.1941322,0.9236225,1004.9438484,921.1679253,1636.6852763,27.070344,33.7927143,2.2932148,116.0620149),(53312,'hindlimb',41,10,248,256.0623432,98.0068526,118.3620052,1.8,98.1535188,118.1003018,-0.0175635,13.8557799,14.3931402,12584.044087,15114.7589807,0.0131635,1050.1362973,908.2162217,1571.8190005,26.7440061,33.4715644,0.8398896,114.2390031),(53313,'hindlimb',41,10,249,239.5037821,98.0441554,118.4604465,1.8,98.2102285,118.0445758,-0.0077463,13.5834647,14.3288272,11204.349604,13982.0643191,0.0023951,975.7996336,824.8521144,1453.5156587,26.210968,32.8367109,0.8224183,110.5929796),(53314,'hindlimb',41,10,250,231.8338983,98.1350847,118.4153819,1.8,98.1844309,117.9963441,0.0188858,13.2742863,13.7805514,10432.4402965,13406.8022307,0.0137799,972.8785032,785.9134635,1388.228486,25.7698543,32.5231526,0.8134282,109.7336036),(53315,'hindlimb',41,10,251,213.8109275,98.1806384,118.4901569,1.8,98.1460253,117.9214905,-0.0714444,13.2908416,14.5777042,8930.0526564,11962.4733668,0.1815833,820.6006392,671.8951964,1242.263052,25.0145952,31.9041532,0.7758746,106.148654),(53316,'hindlimb',41,10,252,204.390119,98.071798,118.3735055,1.8,98.1435276,117.8706399,-0.1111111,13.0341105,14.7448611,8110.1929002,11030.8488838,0.4188279,748.1148025,622.2283364,1156.8574375,24.1892574,31.3318873,0.7368926,105.0375726),(53317,'hindlimb',41,10,253,188.1842606,97.9479564,118.087177,1.8,98.0660473,117.763046,-0.1599882,12.6061824,14.5793406,6774.979592,9582.9899622,0.7959752,657.2992713,537.4330942,1015.077366,23.2985519,30.4381711,0.72547,102.250925),(53318,'hindlimb',41,10,254,176.6191499,97.8795008,117.9273477,1.8,98.0081203,117.6373482,-0.1708313,12.4259145,14.1892046,5935.2871651,8657.3533906,0.8507316,610.1366231,477.6539527,923.6110202,22.733046,29.8316135,0.72425,101.391549),(53319,'hindlimb',41,10,255,157.6790626,97.7172376,117.761519,1.8,97.9336245,117.5326151,-0.202861,11.8828047,13.9326647,4683.8008991,7434.8294375,1.0667296,533.6258068,394.1662767,799.072597,21.4770378,28.6637647,0.7004964,97.7023396),(53320,'hindlimb',41,10,256,143.2534462,97.6964692,117.5162816,1.8,97.9216363,117.4353328,-0.1828564,11.2047401,13.5095836,3893.2018396,6513.331474,0.7894569,482.1267381,347.4602541,695.9013763,20.6192463,27.85028,0.6651027,96.0878474),(53321,'hindlimb',41,10,257,124.0315437,97.5674255,117.3611448,1.8,97.8449573,117.3712457,-0.1666135,10.1701557,12.7572168,2836.0279074,5378.7058545,0.5685637,421.6206364,278.8578643,549.114855,18.906272,26.8271256,2.5846911,92.797789),(53322,'hindlimb',41,10,258,110.1136087,97.5396467,117.2951155,1.8,97.7080111,117.3496114,-0.1654442,9.5991649,12.295182,2153.267912,4557.2967447,0.497768,370.6571188,224.3182534,459.0215791,18.0446515,26.1015566,2.5672878,89.4645448),(53323,'hindlimb',41,10,259,91.0561964,97.3401831,117.343189,1.8,97.2781728,117.3160244,-0.1728385,8.8050757,11.4879828,1300.9512846,3431.3783968,0.4488596,298.6928566,147.7501537,380.0083388,16.3115227,23.7264049,0.6181442,79.446924),(53324,'hindlimb',41,10,260,68.5119291,97.1654154,117.5089449,1.8,96.8843279,117.3420517,-0.1612157,8.030902,10.6737553,783.9393248,2658.4852451,0.2942144,249.0674727,97.6153517,302.6491793,9.4197285,15.1125613,1.3120254,40.5307081),(53325,'hindlimb',41,10,261,35.2253373,95.6007709,117.5885484,1.8,95.6833753,117.4483221,-0.2148241,6.6955118,10.4803376,227.9184649,1250.5943868,0.2667956,119.3276809,34.0404844,140.8105927,7.1191067,12.4015431,1.3258177,31.8758741),(53326,'hindlimb',41,10,262,15.2384998,92.1460397,118.1188906,1.8,93.1430055,117.7619025,-0.414668,5.2748201,12.4219734,73.4413974,131.0957448,0.4122451,10.5535361,13.9230146,15.9699462,5.4610753,10.1136544,1.3567356,25.9034279),(53327,'hindlimb',41,10,263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53328,'hindlimb',41,10,264,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53329,'hindlimb',41,10,265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53330,'hindlimb',41,10,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53331,'hindlimb',41,10,267,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53332,'hindlimb',41,10,268,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53333,'hindlimb',41,10,269,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53334,'hindlimb',41,10,270,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53335,'hindlimb',41,10,271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53336,'hindlimb',41,10,272,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53337,'hindlimb',41,10,273,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53338,'hindlimb',41,10,274,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53339,'hindlimb',41,10,275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53340,'hindlimb',41,10,276,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53341,'hindlimb',41,10,277,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53342,'hindlimb',41,10,278,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53343,'hindlimb',41,10,279,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53344,'hindlimb',41,10,280,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53345,'hindlimb',41,10,281,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53346,'hindlimb',41,10,282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53347,'hindlimb',41,10,283,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53348,'hindlimb',41,10,284,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53349,'hindlimb',41,10,285,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53350,'hindlimb',41,10,286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53351,'hindlimb',41,10,287,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53352,'hindlimb',41,10,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53353,'hindlimb',41,10,289,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53354,'hindlimb',41,10,290,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53355,'hindlimb',41,10,291,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53356,'hindlimb',41,10,292,1.499266,95.8510026,116.9570264,1.8,95.8084882,116.8452966,1.5036745,1.7975385,6.543383,0.8445129,19.340731,0.2487536,2.9557694,0.4698163,3.0848165,2.3273342,6.1070139,2.2565258,13.411939),(53357,'hindlimb',41,10,293,8.9633692,95.5947121,115.8784206,1.8,95.4422986,116.0673226,-1.3392594,10.9787404,6.2900482,31.7179631,78.6578573,1.4152291,12.5051279,2.8890348,10.0363984,4.726568,13.0684503,1.735945,36.3812737),(53358,'hindlimb',41,10,294,20.9369638,94.8695231,116.0279727,1.8,95.1212908,115.7842982,-0.1985008,6.4119871,11.0422237,183.5396456,409.1412104,0.1356986,37.0524291,28.6244564,48.6423303,3.007816,7.5041783,1.801887,18.0647842),(53359,'hindlimb',41,10,295,40.8822871,94.8926813,116.1222955,1.8,94.9824559,116.0501656,-0.1531318,6.7338319,11.2219237,429.9563417,1005.3167965,0.1585322,89.585068,63.8501741,118.265582,4.29688,11.3765933,1.7607846,28.7943353),(53360,'hindlimb',41,10,296,63.8000142,94.660339,116.40076,1.8,94.8125609,116.3540713,-0.092884,7.8572246,11.6874188,731.1381372,1660.6437496,0.0914749,142.0881526,93.0529763,194.6519434,14.5106044,17.2839294,0.6086893,75.3406754),(53361,'hindlimb',41,10,297,93.6691277,94.8431062,116.7493061,1.8,95.2194387,116.5123159,0.0688497,9.5498058,12.3064415,1072.7501739,2455.3581343,0.0738861,199.5181252,112.332145,283.4625877,15.8256937,22.0191518,2.8445284,79.6375554),(53362,'hindlimb',41,10,298,105.3603475,95.4404113,116.880677,1.8,95.4859296,116.5970805,0.1036503,10.1858164,11.8449904,1176.0045924,2849.4434878,0.1879799,240.561064,115.455114,334.0364565,16.328144,22.5575969,2.8318897,65.0102753),(53363,'hindlimb',41,10,299,120.4861101,96.2516612,117.0672828,1.8,96.2314299,116.5687498,0.0031229,10.0843101,11.1790775,1349.8041963,3548.4791353,0.0001959,317.4214624,133.8519131,376.9779593,16.2064365,23.8350997,0.4878364,78.6307338),(53364,'hindlimb',41,10,300,134.3880437,96.6340257,116.9803118,1.8,96.5474422,116.4473479,-0.1304673,9.617652,12.0304302,1569.2203043,4365.497214,0.3790944,362.871248,163.1604365,449.1889227,16.1538605,24.6237844,0.5104883,77.4153926),(53365,'hindlimb',41,10,301,150.3351938,97.1257483,116.1906793,1.8,97.5305477,115.5829083,-0.3772349,8.4144533,13.1263642,2119.67291,6266.1158664,3.3996453,477.3687359,251.9085724,607.3744842,16.795858,25.8742116,0.6202495,83.1793192),(53366,'hindlimb',41,10,302,152.2762333,97.6510723,115.6504268,1.8,97.8670654,115.4485142,-0.4732998,8.9859847,13.2031593,2240.830973,6748.3961072,5.2732547,511.1197957,249.3695526,670.7232217,16.7959704,26.2356106,0.551655,85.2108506),(53367,'hindlimb',41,10,303,125.852125,98.4549952,115.9897987,1.8,98.044584,115.7007163,-0.5187661,8.8500214,12.8887109,1688.272861,4724.6603211,5.1562977,366.5735362,190.7648329,488.4777542,16.0835959,26.1686695,0.5150728,93.7182389),(53368,'hindlimb',41,10,304,119.1032181,99.0084252,116.1161629,1.8,98.6311795,115.7856959,-0.533147,8.9681991,13.1044839,1376.3324253,3907.5663786,5.1276723,298.185445,153.4680948,382.6131523,15.5708336,26.4109609,0.3835275,85.3151104),(53369,'hindlimb',41,10,305,128.4492786,99.4428448,116.0127115,1.8,99.0214231,115.9952223,-0.4573882,7.5213876,14.7929558,1391.0253008,4099.4735049,4.1749462,277.1233527,184.9426425,361.4760753,15.0739401,26.6337246,0.3115468,89.6730643),(53370,'hindlimb',41,10,306,144.0690151,99.6647833,116.1088189,1.8,98.9902938,116.1992982,-0.3808646,7.337517,15.502895,1465.121318,5269.9908251,3.317866,339.9359168,199.6753562,431.9156555,14.4325139,26.9164465,0.2914568,90.4281806),(53371,'hindlimb',41,10,307,134.2980217,98.4138852,116.7310956,1.8,98.0054851,116.6581558,-0.3280844,7.2248509,14.5919748,1309.8202486,6091.9334241,2.3240781,417.4851927,181.2937409,505.5878738,14.2345508,27.5134565,0.2525543,87.7026069),(53372,'hindlimb',41,10,308,147.2148608,97.4201639,116.6644231,1.8,97.219316,116.5994337,-0.2993488,7.4732563,13.9435169,1408.5650081,6789.8115929,2.1337535,486.9511506,188.4807568,587.7113883,15.0171271,27.2098039,0.2717922,83.9523236),(53373,'hindlimb',41,10,309,166.2617547,96.8180149,116.5684147,1.8,96.7524346,116.5800747,-0.2948717,8.9968618,13.6430143,1632.9879208,7842.226065,2.3403635,574.8162313,181.5063919,689.9817575,16.2822701,27.3418007,0.5269432,82.884428),(53374,'hindlimb',41,10,310,176.0905994,96.519937,116.6606506,1.8,96.2880914,116.9620169,-0.3171374,9.6624346,13.5027789,1967.9870821,8264.6207159,2.8541108,612.0681346,203.6740381,740.0354384,16.8887028,27.7140433,0.5191461,92.5460836),(53375,'hindlimb',41,10,311,193.0280473,95.929991,117.3351902,1.8,95.8789545,117.3837937,-0.4511346,9.1204465,14.1263189,2660.6043725,9718.5255398,6.1152766,687.9729683,291.7186538,874.8099627,17.4299624,27.92972,0.5325041,85.401482),(53376,'hindlimb',41,10,312,198.8744964,95.7072573,117.7447646,1.8,95.7883406,117.5344493,-0.4932721,9.2989643,14.53884,2863.7643624,10526.3366393,7.431679,724.0148918,307.96595,920.4678928,17.401014,28.0122304,0.5667292,91.3307424),(53377,'hindlimb',41,10,313,215.4996369,95.5438017,117.7589663,1.8,95.7430128,117.2693719,-0.5044418,9.4760808,14.6933545,3105.5424144,10903.4343543,8.3900155,742.0656974,327.7243488,953.2734575,17.9913428,28.2713807,0.817645,93.5529052),(53378,'hindlimb',41,10,314,223.5660314,95.4813788,117.3881028,1.8,95.7981373,116.9353101,-0.5298901,9.3339538,14.6252253,3434.138561,10355.1266131,9.5189964,708.0319394,367.9189589,942.3057001,17.9021116,28.3366124,0.8605253,84.0997692),(53379,'hindlimb',41,10,315,232.9378844,94.8975937,116.7185578,1.8,95.5938534,116.3884288,-0.6754714,12.8514919,14.7143436,4597.91124,8578.327206,15.1781012,582.9908159,357.7725659,893.4978606,21.6109075,28.5863647,0.8279257,94.056316),(53380,'hindlimb',41,10,316,239.1034668,94.5190016,116.189577,1.8,95.2229251,115.8504632,-1.1071339,11.6551396,14.0590273,5870.0715909,7687.6687103,31.8799909,546.8136963,503.6466122,932.2237992,22.199825,28.2974914,0.8391099,92.6324552),(53381,'hindlimb',41,10,317,237.033297,93.9441818,115.4697461,1.8,94.6735454,115.5503691,1.2711297,13.5739018,14.5985879,4801.0186179,9160.5810983,36.0628758,627.4977523,353.6948105,942.425201,21.949306,36.8255401,1.7704802,122.6242436),(53382,'hindlimb',41,10,318,242.9381569,94.2991127,115.0761992,1.8,94.7258203,115.4117915,1.0985254,12.4649649,15.2119251,4781.2143109,10222.216134,32.1106358,671.9870131,383.572225,980.7574519,21.7051283,37.5208915,2.0856811,113.76089),(53383,'hindlimb',41,10,319,241.1032528,94.5155286,114.6714231,1.8,94.583636,115.2394105,0.969826,12.8460115,15.5683053,4267.7043202,11389.245239,27.3360525,731.5661534,332.2201855,1004.469036,21.7518417,39.0259853,2.063992,114.0736694),(53384,'hindlimb',41,10,320,230.4771345,94.478595,114.4216644,1.8,94.368753,115.1611422,0.9394507,12.8145317,15.6146831,3879.3652788,11626.5413899,25.0308454,744.59029,302.7317232,991.8584768,21.4803053,40.1844438,2.0009636,114.5338944),(53385,'hindlimb',41,10,321,208.6680933,94.3174372,114.343567,1.8,94.0661087,115.0132941,0.9349958,13.0936932,15.9696956,3702.9819661,10943.4678042,22.5144413,685.2646448,282.8065326,914.1213339,21.7580192,41.898436,2.0160974,116.8171311),(53386,'hindlimb',41,10,322,194.29602,93.9878136,114.2766358,1.8,93.6669973,114.8987374,0.9333062,12.8747603,15.9776386,3800.1682293,10264.9355127,20.9114417,642.4563581,295.1641918,876.9763856,21.7920109,42.4717843,2.0208701,118.6401429),(53387,'hindlimb',41,10,323,173.2518579,93.0036262,114.0005178,1.8,92.9298332,114.6470324,0.9241186,12.290558,15.6941844,3691.4403475,9233.4053074,18.3920606,588.3329195,300.3476615,820.6804361,21.8313566,42.2866263,2.0117206,116.6696855),(53388,'hindlimb',41,10,324,156.4185871,92.1349165,113.7935159,1.8,92.3222879,114.4932203,0.9667181,11.3785671,15.204334,3303.8575644,8507.283063,17.6589238,559.5301347,290.3579618,771.8152651,21.4841098,41.6996652,2.0298357,114.8898596),(53389,'hindlimb',41,10,325,149.7025782,91.2980025,113.863713,1.8,91.5353163,114.5376856,1.019757,10.0254541,14.9375394,2971.1654785,7690.9285453,18.110802,514.8725192,296.3621855,691.6700617,20.6796521,41.1290207,2.1327179,127.0864573),(53390,'hindlimb',41,10,326,152.9042051,90.8965609,114.1391623,1.8,91.2052649,114.4355953,1.0502791,9.8348326,15.1178209,2727.0077875,7307.4950026,19.1809139,483.3695962,277.2805498,654.8748973,19.9885769,40.5366848,2.1293956,120.4631547),(53391,'hindlimb',41,10,327,156.8676899,90.5809915,114.4638838,1.8,90.6532437,114.1161506,1.0945245,9.278876,15.3334486,2106.1251127,7036.9062139,20.6491763,458.925216,226.9806285,584.3323444,18.6575144,39.2923774,1.8025132,119.7080385),(53392,'hindlimb',41,10,328,129.8325063,90.2732635,114.0892699,1.8,90.3344327,113.8814438,1.0806862,8.4857327,14.899738,1543.9461911,6090.2398952,16.8440318,408.7481197,181.9461266,503.5012209,17.5332237,39.0732667,1.7142486,126.0364499),(53393,'hindlimb',41,10,329,105.1385656,90.3336827,113.4924661,1.8,90.0636402,113.3531828,1.0030119,8.6520963,14.3710339,1176.1880882,5117.6301627,12.4555618,356.1073068,135.9425566,435.079845,12.9152022,37.934418,1.7415315,93.2833116),(53394,'hindlimb',41,10,330,97.4049559,90.5622965,113.5934996,1.8,90.1232744,113.8278387,0.9763455,9.7502848,16.0068594,1088.0341782,5013.9957896,11.1421479,313.2404475,111.5899896,379.8406697,13.2364332,37.3729768,1.7208233,97.6412656),(53395,'hindlimb',41,10,331,114.4165362,91.7320144,116.3924986,1.8,91.2100389,116.2055344,1.0812524,9.6614853,17.0106443,1444.4523398,7559.2982879,14.8529818,444.3863598,149.5062403,526.0838857,19.3351932,42.450043,1.943784,130.5418495),(53396,'hindlimb',41,10,332,134.6021046,93.1903667,118.8500999,1.8,91.9509397,117.0857774,1.0655328,9.9743491,20.1025585,1836.409922,8917.8125088,17.1776333,443.6157975,184.1132591,532.1296189,19.2637669,42.6084999,1.9531754,123.2929881),(53397,'hindlimb',41,10,333,141.3844691,93.3324606,119.8191392,1.8,92.0290303,117.6464087,1.0492029,9.5991506,21.0448096,2250.7357485,8460.0641884,17.7139352,402.0024099,234.4723874,507.8441978,19.0551064,41.8940291,1.9379702,121.2182709),(53398,'hindlimb',41,10,334,134.1249714,93.19639,120.6362958,1.8,92.1122642,118.3616107,0.9982425,9.802851,21.7014531,2328.9658656,7016.3121665,15.7926357,323.3107077,237.5804612,430.6027988,19.3076178,41.4153258,1.9647894,135.4895859),(53399,'hindlimb',41,10,335,132.4678732,93.0128618,122.3813002,1.8,92.4552258,120.4347046,0.8569094,9.7721584,22.0004665,2628.4152725,4848.3488628,12.612437,220.3748205,268.9697788,334.3289058,19.2194917,40.5503466,1.8389071,113.2321815),(53400,'hindlimb',41,10,336,136.621137,93.1150718,123.0592651,1.8,92.8120672,121.351571,0.6568159,10.4897668,15.8634779,2798.9050127,4149.704486,8.489418,261.5885694,266.8224255,368.1465102,18.8377885,28.2452458,2.1503603,91.2264826),(53401,'hindlimb',41,10,337,132.5018342,93.5726121,122.9264803,1.8,93.0547557,121.6259739,0.5774899,9.5258089,14.7519866,2625.2887367,3946.4018018,6.5816202,267.5166347,275.5974601,384.3780094,18.8289607,26.9849538,2.2206668,76.746648),(53402,'hindlimb',41,10,338,128.7058049,93.8641059,122.9919545,1.8,93.1744206,121.8581536,0.5190904,9.4799928,14.3400543,2440.3662723,3740.7745991,5.2792092,260.8619551,257.4227993,369.9023799,18.833412,26.5190958,2.2759077,74.4202254),(53403,'hindlimb',41,10,339,120.8261123,93.762166,123.1948908,1.8,93.3166075,122.4811561,0.2765781,11.5007324,11.7782541,2195.9869076,2936.1857818,1.5015608,249.28871,190.9432226,314.8800195,18.698729,22.5166352,2.302193,71.0869812),(53404,'hindlimb',41,10,340,123.5678942,94.0150682,123.5205824,1.8,93.4364848,122.864836,0.2345689,10.0820194,10.1308035,2114.3147375,3076.4722092,1.1125393,303.6750455,209.7114341,416.9016515,18.5595784,21.6257322,2.285888,70.0801596),(53405,'hindlimb',41,10,341,126.0548283,94.0435852,123.7688318,1.8,93.5972158,123.1336882,0.2284032,9.618952,10.1355964,2121.5859881,2866.2795759,1.0770781,282.7933798,220.5631109,431.2657756,18.2142907,20.8032903,2.4733032,68.8648184),(53406,'hindlimb',41,10,342,134.2892377,94.1460163,123.9885725,1.8,93.7296251,123.278227,0.2418488,9.4099788,10.004048,2182.2662742,2812.4979824,1.2837901,281.135994,231.909796,443.8739096,18.1579859,20.7677594,2.7149652,64.6111242),(53407,'hindlimb',41,10,343,150.8959709,94.2801339,124.4499661,1.8,93.8204161,123.3721777,-0.0487523,10.7672291,9.5232296,2189.2978619,2857.019219,0.0597273,300.0052858,203.3297364,445.4102064,17.8951111,20.8254663,2.7610863,64.1077134),(53408,'hindlimb',41,10,344,150.0320061,94.2293779,124.5614413,1.8,93.8409555,123.3708076,-0.1011534,10.6587642,9.7038727,2018.9392512,3025.9748139,0.2549834,311.8316676,189.4158841,451.3472012,17.4311177,20.9271731,2.8068558,62.996632),(53409,'hindlimb',41,10,345,121.5613384,94.4207124,123.92732,1.8,93.8973358,123.2147314,-0.0264549,9.33087,10.5663157,1699.6536237,3061.8414119,0.014176,289.7737975,182.1538207,433.5416035,16.7459216,21.072243,2.7875952,61.7812908),(53410,'hindlimb',41,10,346,66.3571084,94.2428494,121.6976106,1.8,93.7375985,120.8898155,0.0692619,8.4749123,10.494737,577.6984181,2656.389629,0.05297,253.1163606,68.1657104,302.982659,13.4229447,21.1989091,2.8326619,76.6170906),(53411,'hindlimb',41,10,347,92.457104,94.7029308,125.9501955,1.8,94.4106106,126.0912692,0.0575335,6.9052931,8.2754029,682.5041961,1012.3781676,0.0509508,122.3358167,98.8378313,201.1253762,12.460952,16.4183554,3.0367157,45.4963327),(53412,'hindlimb',41,10,348,89.9028073,94.8265349,125.8753816,1.8,94.6392695,125.8491796,-0.209354,8.3554671,8.8782728,729.2742195,935.2787324,0.647188,105.3446712,87.2810835,186.3449579,13.6061461,16.8073383,3.0648208,49.3940617),(53413,'hindlimb',41,10,349,77.7352934,94.8645955,125.812446,1.8,94.725154,125.5911867,-0.2002301,13.2800283,8.0944931,719.5553913,849.9241378,0.5125236,105.0002922,54.1832725,108.7545463,13.2505547,15.9506297,3.0606886,47.2150847),(53414,'hindlimb',41,10,350,71.5661303,94.9589455,125.6626053,1.8,94.7854243,125.5646907,0.4440142,13.7000502,7.4379812,762.4171534,775.8537703,2.200999,104.3097242,55.650683,108.4783131,12.8881595,15.5223861,3.0584514,46.3557087),(53415,'hindlimb',41,10,351,66.3807748,95.77391,125.6619471,1.8,95.6029554,125.7358575,-0.8085158,6.3142791,7.0902574,619.9694275,755.5787279,5.7874014,106.565768,98.1853063,172.3954874,12.607043,14.6661522,0.0880074,45.6437783),(53416,'hindlimb',41,10,352,65.0612171,95.766358,125.9055895,1.8,95.5947993,125.9432469,-0.2472324,6.453209,8.3834707,532.7914454,734.204984,0.6494038,87.5776883,82.5622479,148.1841486,11.601576,15.5223861,0.0831412,42.5622395),(53417,'hindlimb',41,10,353,60.1154913,95.9809164,126.1299312,1.8,95.7143868,125.9365675,-0.1733517,6.6783957,8.2340082,443.564559,623.7243531,0.2980825,75.7497854,66.4178316,128.1732055,11.6659524,14.7101476,3.0244839,41.4511581),(53418,'hindlimb',41,10,354,57.7020182,96.0324957,126.2719806,1.8,95.7850282,126.0278197,-0.0811725,6.2458248,8.3531281,390.6144863,568.7540552,0.0632272,68.0887509,62.5400969,114.5332399,11.4886703,14.7101476,0.1171087,41.7028635),(53419,'hindlimb',41,10,355,56.5352014,96.1273435,126.2735883,1.8,95.9225281,126.0645031,0.0202426,6.4179042,7.6089492,377.2668918,514.8887013,0.0038604,67.6688317,58.7835032,117.2067317,11.5125753,13.8570216,0.124355,39.8798517),(53420,'hindlimb',41,10,356,55.6686069,96.089877,126.3586148,1.8,95.9867258,126.1943316,0.2408266,5.6973901,6.5282294,344.2821898,477.4721467,0.5277833,73.139609,60.4280532,122.3788119,10.4324027,12.9549329,0.0996687,36.9457585),(53421,'hindlimb',41,10,357,53.6460497,96.4436571,126.2581018,1.8,96.4156628,126.1673715,0.0802552,5.5858468,6.183566,362.5711649,427.1110018,0.0574646,69.0719564,64.9088986,127.1717225,10.7339038,12.1306029,0.4002407,36.2338281),(53422,'hindlimb',41,10,358,52.8524128,96.5267717,126.2032933,1.8,96.4234949,126.1511199,0.2690393,5.5336189,6.0327171,361.0029128,411.4463756,0.6223596,68.2024979,65.2381236,122.7369935,10.4884581,12.1001239,0.1067357,35.9821227),(53423,'hindlimb',41,10,359,54.1024259,96.5958513,126.1111562,1.8,96.5232109,126.0738147,0.5066588,5.3192996,5.4568398,355.8292233,408.4341393,2.1233018,74.8481091,66.8939997,120.0713768,10.4438848,12.1534119,0.1418971,36.3380879),(53424,'hindlimb',41,10,360,52.4024708,96.7103421,126.0645372,1.8,96.5999465,126.0345251,0.6150027,4.9282796,5.3721812,347.4782893,404.6135245,2.9073209,75.316433,70.5070162,116.0415204,10.2533989,12.1534119,2.9996956,36.3380879),(53425,'hindlimb',41,10,361,51.671329,96.9032641,125.9970606,1.8,96.7855246,125.9645406,0.8086491,4.9960819,5.4387809,330.6686523,389.8996923,4.5061064,71.6888033,66.185595,124.5227955,10.2533989,11.4413255,2.1692152,34.6625217),(53426,'hindlimb',41,10,362,51.7474756,96.9772892,125.9721361,1.8,96.8181576,125.9473015,0.8076815,5.0649313,5.4700795,325.185329,388.4580395,4.5044101,71.0150629,64.2033052,123.542,10.1793425,11.5697035,2.1175852,34.6625217),(53427,'hindlimb',41,10,363,52.6640884,97.1440927,125.8526566,1.8,97.0338319,125.840387,0.7924756,5.407711,5.4733913,336.1140825,384.3095378,4.4507932,70.214153,62.1545946,125.5203331,10.6267495,11.5697035,2.1175852,35.8778629),(53428,'hindlimb',41,10,364,51.2379478,97.1903769,125.944332,1.8,97.0442316,125.9457694,0.7533619,4.9197661,5.5370607,299.9619299,377.6910308,3.9964373,68.2114668,60.9707711,115.9929138,10.1876506,11.5697035,2.1175852,34.6625217),(53429,'hindlimb',41,10,365,51.2540052,97.34279,125.9188882,1.8,97.2764758,125.96375,0.7816765,5.0135364,5.6443604,292.9788457,370.367461,4.2393761,65.6172594,58.4375623,112.6081591,9.9959247,11.6887773,2.1995926,34.5582619),(53430,'hindlimb',41,10,366,51.7787511,97.3994023,125.9032186,1.8,97.30001,125.9563487,0.763561,5.0706017,5.6538265,293.4729104,373.3810209,4.126506,66.0404097,57.8773342,112.9442616,9.9959247,11.6887773,2.1995926,34.5582619),(53431,'hindlimb',41,10,367,53.4293592,97.5396894,125.7927932,1.8,97.4594601,125.7994252,0.828829,8.9293455,16.7361325,311.310999,383.8457023,4.8387074,22.9351496,34.8638093,36.6465605,10.4554175,11.7988288,2.1486983,35.5218977),(53432,'hindlimb',41,10,368,53.6357551,97.5851504,125.7904079,1.8,97.460787,125.7495481,0.8146845,9.4430609,16.6376167,311.365152,390.1839605,4.7312956,23.4519143,32.9729053,36.9658719,10.3304002,11.7988288,2.1486983,35.2701923),(53433,'hindlimb',41,10,369,53.9730158,97.7317018,125.7264927,1.8,97.5972934,125.4698487,0.9933241,6.5911493,18.0217043,314.8711886,413.5250838,6.3147053,22.9459477,47.7718185,38.4298028,10.312512,11.6887773,2.1995926,34.9142271),(53434,'hindlimb',41,10,370,54.3878219,97.7912931,125.7287723,1.8,97.6515559,125.4339543,0.9906585,6.8248511,18.1644178,322.0323348,416.2607233,6.3411072,22.9162711,47.1852542,38.2916674,10.312512,11.6887773,2.1995926,34.8099673),(53435,'hindlimb',41,10,371,54.8367569,97.8796375,125.7361235,1.8,97.7095534,125.4660876,0.9497918,7.4840711,17.9424851,326.7874184,415.4601299,6.045275,23.1551052,43.6643925,38.4406035,10.312512,11.6887773,2.1995926,34.9142271),(53436,'hindlimb',41,10,372,54.8844814,97.9414552,125.7449127,1.8,97.781757,125.4200037,0.915766,8.037954,17.7340142,327.9241152,414.0365439,5.7527695,23.347029,40.7969633,38.3791057,10.312512,11.6095305,2.2513176,34.9142271),(53437,'hindlimb',41,10,373,54.6915691,98.0419214,125.7064724,1.8,97.8853657,125.1940083,1.0342097,5.8109987,18.9069394,328.6639018,440.0781435,6.7331619,23.2760117,56.5589357,38.9505768,10.312512,11.6095305,2.2513176,34.8099673),(53438,'hindlimb',41,10,374,54.8020125,98.0880318,125.686739,1.8,97.8953892,125.0605994,1.0787237,5.3859412,19.3475378,333.8540289,464.9202495,7.0949207,24.0299439,61.9861996,40.2640598,10.312512,11.4413255,2.1692152,34.5582619),(53439,'hindlimb',41,10,375,54.5716704,98.2021412,125.7605298,1.8,98.0992188,125.5866981,0.6349104,11.9868435,14.2691721,320.4934856,375.2241992,3.1994821,26.2961437,26.7371043,37.6614806,9.882824,11.3440887,2.221873,33.9505913),(53440,'hindlimb',41,10,376,53.5789109,98.2594976,125.8495357,1.8,98.1316096,125.7368308,0.4091354,15.0292842,10.9744955,305.0235313,365.090662,1.4132128,33.2671931,20.2952801,36.2775473,9.453136,11.3440887,2.221873,33.8463315),(53441,'hindlimb',41,10,377,53.5283889,98.3609643,125.8483788,1.8,98.2732263,125.8309479,0.2317017,16.2181526,7.7612487,292.4648956,356.6789431,0.4704415,45.9563865,18.0331818,36.1044963,9.4239951,11.2787985,2.2752904,34.2022967),(53442,'hindlimb',41,10,378,53.5705745,98.4138841,125.8502964,1.8,98.3626616,125.8646875,0.155184,4.6273889,5.2194362,286.6913148,355.0965011,0.2132947,68.0334977,61.9553096,115.2206848,9.4239951,11.0889478,2.1910458,33.9505913),(53443,'hindlimb',41,10,379,53.5098698,98.4955989,125.8211443,1.8,98.3995398,125.8195609,0.0946928,17.1269934,5.1818184,286.1241755,353.7935401,0.0797293,68.275943,16.7060364,35.7648593,9.453136,11.0889478,2.5213432,34.5582619),(53444,'hindlimb',41,10,380,53.387789,98.5593845,125.8167894,1.8,98.4783085,125.8507301,0.0248106,4.6926526,5.0172347,279.7133037,350.601964,0.0054762,69.8795226,59.6066507,113.7320262,9.453136,11.0889478,2.5213432,34.2022967),(53445,'hindlimb',41,10,381,53.1827918,98.6338299,125.7906528,1.8,98.5634323,125.8506188,-0.0493534,4.5186302,5.0459207,272.7398334,349.5524543,0.0215726,69.2742666,60.358963,117.4660276,9.453136,11.0137676,0.3587707,33.3429207),(53446,'hindlimb',41,10,382,52.3376818,98.6996698,125.817901,1.8,98.634319,125.8802125,-0.1424914,4.5345153,5.2322687,259.092093,346.5873731,0.1759135,66.2403615,57.1377697,113.1704884,9.453136,11.0137676,0.3587707,33.6988859),(53447,'hindlimb',41,10,383,51.8496944,98.7691665,125.7768598,1.8,98.7187522,125.834544,-0.1921929,4.5126824,5.0972591,250.7936137,345.3467188,0.3152939,67.7514553,55.575286,110.5581686,9.3841362,11.1470707,0.4808873,33.5946261),(53448,'hindlimb',41,10,384,51.6266816,98.8211438,125.7666175,1.8,98.7686182,125.8153191,-0.2229566,4.4158027,5.2018951,246.008101,347.5525462,0.4206834,66.8126794,55.7108456,109.0654122,9.1608272,11.2048922,0.5667292,33.3429207),(53449,'hindlimb',41,10,385,51.1614096,98.8932922,125.7388738,1.8,98.8148765,125.7762566,-0.2546346,4.4218447,5.2185204,238.0602585,347.463022,0.5410276,66.5826695,53.8373176,108.6172481,9.1608272,11.0889478,0.6202495,33.3429207),(53450,'hindlimb',41,10,386,50.862362,98.9477782,125.7279144,1.8,98.8787309,125.751233,-0.2749449,4.4370347,5.2937113,232.5717548,348.8964867,0.624835,65.9077283,52.416033,106.862414,9.1608272,11.2787985,0.7044941,33.5946261),(53451,'hindlimb',41,10,387,50.3752698,99.011981,125.6859734,1.8,98.9283615,125.668096,-0.2983086,4.3507637,5.387367,223.7966011,349.2658949,0.7252319,64.8305365,51.4384637,105.1788419,9.017974,11.2048922,0.5667292,32.7352501),(53452,'hindlimb',41,10,388,50.0128321,99.0588559,125.669862,1.8,98.965907,125.6555808,-0.3128812,4.3551103,5.4482094,219.472557,350.4671328,0.7897161,64.3270306,50.3942594,103.6689805,9.017974,11.2048922,0.5667292,32.7352501),(53453,'hindlimb',41,10,389,49.5028008,99.1170817,125.6299309,1.8,99.0341975,125.6330347,-0.3282834,4.2463464,5.3883491,213.1471302,350.5387555,0.8576668,65.054945,50.195418,101.7504642,8.895936,11.2048922,0.5667292,33.5946261),(53454,'hindlimb',41,10,390,49.0707624,99.1668979,125.6084833,1.8,99.1280714,125.6262019,-0.3480932,4.2679377,5.4466699,208.8257116,349.542076,0.9515907,64.175374,48.9289506,102.431344,8.895936,11.3440887,0.6510767,32.6309903),(53455,'hindlimb',41,10,391,48.5581574,99.202982,125.5649339,1.8,99.1584436,125.5525052,-0.3559874,4.3026287,5.4967673,202.5092058,349.3444337,0.9830065,63.5545251,47.0663915,100.2500631,8.8804235,11.3522236,0.5144513,32.9869555),(53456,'hindlimb',41,10,392,48.1328889,99.235608,125.5402144,1.8,99.1683652,125.5254058,-0.359016,4.233726,5.5364149,198.4438602,350.7696736,0.9903266,63.3568261,46.8721547,99.0370552,8.7547949,11.4413255,0.5984189,32.9869555),(53457,'hindlimb',41,10,393,47.4477931,99.2912819,125.4873182,1.8,99.2525703,125.4656814,-0.3608418,4.2084826,5.4557205,193.784687,349.4924999,0.9857494,64.0598246,46.0462135,99.4820091,8.8360041,11.2048922,0.5667292,33.0912153),(53458,'hindlimb',41,10,394,46.9890671,99.3279915,125.4579647,1.8,99.3205458,125.4149151,-0.3652909,4.2111905,5.4993656,190.0696847,351.2638261,0.9993544,63.8735179,45.1344309,98.3329406,8.7746743,11.3522236,0.5144513,32.8395099),(53459,'hindlimb',41,10,395,46.4574395,99.36041,125.4047476,1.8,99.3162274,125.3846858,-0.3689848,4.1588583,5.4570124,185.5490447,352.4931438,1.0072124,64.5945283,44.6153806,97.7429288,8.6648236,11.4413255,0.5984189,32.8395099),(53460,'hindlimb',41,10,396,46.2649748,99.3889613,125.3785341,1.8,99.3356605,125.3490584,-0.3695963,4.1736268,5.493546,182.6628834,354.9825598,1.0062143,64.6181099,43.7659843,97.0075776,8.5648628,11.4413255,0.5984189,32.8395099),(53461,'hindlimb',41,10,397,45.7266333,99.4191025,125.3071243,1.8,99.3453771,125.2594501,-0.3730685,4.379243,5.5501548,179.3717001,354.9015599,1.0124008,63.9444436,40.9595216,95.3495901,8.8758314,11.5697035,0.5467888,34.9142271),(53462,'hindlimb',41,10,398,45.428425,99.45244,125.2838366,1.8,99.410923,125.2399461,-0.3743202,4.3695579,5.5192598,176.1367014,356.7470341,1.01224,64.6367527,40.3099597,96.0131275,8.4839427,11.5617216,0.7328151,32.7352501),(53463,'hindlimb',41,10,399,44.9373604,99.4957676,125.2196891,1.8,99.452545,125.1693171,-0.376734,4.3255399,5.4983187,172.1322688,356.4699726,1.0136352,64.8325411,39.7944005,95.881471,8.7534127,11.4413255,0.5984189,33.6988859),(53464,'hindlimb',41,10,400,44.5256875,99.5283899,125.1928993,1.8,99.4722225,125.1688837,-0.3784504,3.9902935,5.5392148,169.016092,358.1889513,1.0130796,64.6642108,42.3568074,94.9215094,8.3619047,11.5697035,0.5467888,32.4835447),(53465,'hindlimb',41,10,401,44.1447306,99.5641267,125.1306299,1.8,99.502673,125.1311258,-0.3807919,3.9507799,5.5964713,165.755421,357.8891984,1.0162704,63.9490814,41.9551143,93.2815124,8.2921788,11.5697035,0.5467888,32.4835447),(53466,'hindlimb',41,10,402,43.9199274,99.5983426,125.091873,1.8,99.5546435,125.0710774,-0.3814279,3.9745645,5.6429329,164.0952171,359.7924972,1.0143103,63.7598395,41.2863391,92.5355858,8.2921788,11.7282,0.4964228,32.7352501),(53467,'hindlimb',41,10,403,43.5325364,99.6254277,125.01339,1.8,99.5912684,124.9782986,-0.3815719,3.8774276,5.5373543,161.0862052,360.5832881,1.0060855,65.1183343,41.5446072,93.7560626,8.1558368,11.6887773,0.6287963,33.0912153),(53468,'hindlimb',41,10,404,43.3478487,99.6558891,124.9708655,1.8,99.6566076,124.911852,-0.381279,3.9054569,5.5814163,159.5312557,363.6733541,1.0003548,65.1578978,40.8482951,93.2152033,8.1558368,11.7988288,0.5779019,33.0912153),(53469,'hindlimb',41,10,405,43.0816432,99.6997123,124.8862099,1.8,99.6710471,124.8260209,-0.3809115,3.9676349,5.6535149,157.8123239,366.8278985,0.9923897,64.8849265,39.7749102,92.5209273,8.2398667,11.7988288,0.5779019,32.4835447),(53470,'hindlimb',41,10,406,43.0952948,99.7271278,124.8357201,1.8,99.6712157,124.7735231,-0.3840046,3.9284885,5.6984873,157.0224387,371.5753269,1.0080886,65.2059589,39.9701913,92.6828813,8.116173,11.9388329,0.5280744,32.7352501),(53471,'hindlimb',41,10,407,42.8454824,99.7559811,124.7599303,1.8,99.6377027,124.7256226,-0.3829336,3.918328,5.7533151,155.6578377,374.3084968,0.9969374,65.0596209,39.7255763,91.9901922,8.1420627,11.9388329,0.5280744,32.9869555),(53472,'hindlimb',41,10,408,42.6611304,99.7848827,124.7163965,1.8,99.6573867,124.682934,-0.3838064,4.0584288,5.7966748,155.0281001,377.2639262,0.9969536,65.0828173,38.1990439,91.6837957,8.0724896,12.0389346,0.607802,33.8463315),(53473,'hindlimb',41,10,409,42.4766664,99.813936,124.6286974,1.8,99.6930141,124.6159977,-0.3889206,4.4064349,5.8583954,153.2582842,378.654173,1.0179175,64.634451,34.7805622,90.3604716,8.1059534,12.1610055,0.5585993,35.0616727),(53474,'hindlimb',41,10,410,42.1781225,99.8420072,124.5806175,1.8,99.7257863,124.5768026,-0.3946356,3.8014198,5.7395803,151.8978181,379.9950114,1.0391184,66.2060621,39.9581807,92.5270007,8.0194948,12.0389346,0.607802,33.3429207),(53475,'hindlimb',41,10,411,42.1804164,99.8949401,124.4918065,1.8,99.8171702,124.4702493,-0.4005975,3.9150914,5.8226643,151.4514798,383.3535797,1.0691015,65.838173,38.684021,91.0748183,8.116173,12.2893773,0.6365082,33.3429207),(53476,'hindlimb',41,10,412,42.1947393,99.9175813,124.4281502,1.8,99.8441606,124.4000741,-0.403277,3.8703258,5.8684361,151.2246596,387.3716411,1.0830329,66.009348,39.0728497,91.7773724,8.0197408,12.1610055,0.5585993,32.7352501),(53477,'hindlimb',41,10,413,41.7649389,99.9603746,124.3445202,1.8,99.9131488,124.3273368,-0.4012214,3.9132501,5.9404197,151.0457062,391.5813262,1.0616916,65.9181243,38.5985317,90.3219049,8.0724896,12.3940969,0.5880026,33.3429207),(53478,'hindlimb',41,10,414,41.7858638,99.9783246,124.2820956,1.8,99.9169983,124.2649081,-0.4054062,3.8199645,5.9819073,151.6633961,397.2524227,1.0832644,66.4089899,39.7028289,91.7420222,8.0194948,12.3940969,0.5880026,33.0912153),(53479,'hindlimb',41,10,415,41.4404905,99.9690034,124.1775312,1.8,99.9013911,124.1819698,-0.4102512,3.8966078,6.0156088,152.1497824,401.8740753,1.0986778,66.8052211,39.0467274,92.0480956,8.0210375,12.5274503,0.5404195,33.3429207),(53480,'hindlimb',41,10,416,41.2801966,99.9767765,124.115565,1.8,99.9104567,124.1115937,-0.4106478,3.9019738,6.0475507,153.2635882,406.7916959,1.0964247,67.2655293,39.2784772,92.5302879,8.0210375,12.5274503,0.5404195,34.0548511),(53481,'hindlimb',41,10,417,41.0844309,100.0007898,124.0000202,1.8,99.9307149,123.9783158,-0.4112417,3.8272704,6.1158974,153.1803513,412.0459999,1.0942039,67.3729421,40.0233939,92.2753733,8.0194948,12.7538463,0.5693132,34.3065565),(53482,'hindlimb',41,10,418,40.7856072,100.0267933,123.9249274,1.8,99.9394282,123.9001598,-0.4141214,3.9145567,6.1708775,153.5594074,416.6717202,1.100629,67.5222807,39.2277895,92.2300157,8.154294,12.7538463,0.5693132,33.9505913),(53483,'hindlimb',41,10,419,40.480741,100.0681006,123.8086861,1.8,99.9845902,123.8349938,-0.4172482,3.828125,6.127348,153.7687058,422.0779807,1.1079884,68.884284,40.1681515,92.9818813,8.0194948,12.89064,0.6435011,34.2022967),(53484,'hindlimb',41,10,420,40.017539,100.0870699,123.7307487,1.8,100.017555,123.7512401,-0.4178939,3.8252752,6.1757323,152.734547,426.4021958,1.0985031,69.0447989,39.9277275,92.9195629,8.0194948,12.89064,0.6435011,34.2022967),(53485,'hindlimb',41,10,421,39.750886,100.1146823,123.6069909,1.8,100.0382934,123.6300045,-0.4207197,3.8834575,6.2490818,151.9697097,433.1577528,1.1051069,69.3154242,39.1325793,92.9558864,8.1328281,12.9905136,0.5971767,34.6625217),(53486,'hindlimb',41,10,422,39.5453852,100.1193047,123.5331543,1.8,100.0471288,123.5417777,-0.422281,3.8212286,6.2823711,151.2787599,440.1330703,1.1070769,70.0584326,39.5890365,93.5583832,8.0194948,12.9905136,0.5971767,34.9142271),(53487,'hindlimb',41,10,423,39.4912266,100.1513513,123.4081532,1.8,100.0924728,123.3981885,-0.4221967,3.8940779,6.3628839,150.5252935,450.6407172,1.1051459,70.8233448,38.654926,94.0640076,8.0194948,13.1178053,0.551655,34.5582619),(53488,'hindlimb',41,10,424,39.1299637,100.1377014,123.327232,1.8,100.1063705,123.3379497,-0.4201175,3.8541118,6.3846581,149.854107,455.5032908,1.0849179,71.3434116,38.8816187,94.5174592,8.1317074,13.1178053,0.551655,34.5582619),(53489,'hindlimb',41,10,425,39.2058306,100.1493131,123.2041927,1.8,100.0960848,123.2334574,-0.4239495,3.924173,6.4438681,149.2072067,466.1981194,1.1057347,72.3475582,38.0225859,95.2968209,8.1328281,13.348021,0.5790743,35.1659325),(53490,'hindlimb',41,10,426,39.3860983,100.1478,123.1216205,1.8,100.0486806,123.1557599,-0.4251883,3.8490953,6.6532634,148.5559116,476.5718655,1.1169236,71.6297911,38.59502,93.9567144,8.017952,13.4856331,0.5349551,35.1659325),(53491,'hindlimb',41,10,427,39.2717945,100.1370321,123.0019044,1.8,100.0524254,123.049242,-0.4222923,3.7733105,6.692376,147.1732181,486.0923683,1.099473,72.6337506,39.0037388,94.594911,8.017952,13.6489363,0.4918092,35.1659325),(53492,'hindlimb',41,10,428,39.1447902,100.1240774,122.9257234,1.8,100.0267325,122.9760737,-0.417845,3.8739123,6.7106335,146.4701318,491.2023076,1.0743092,73.1976059,37.8093569,94.9455004,8.1305867,13.7096736,0.5619216,35.0616727),(53493,'hindlimb',41,10,429,39.0669092,100.1168529,122.7893451,1.8,100.0615272,122.8380899,-0.4166952,3.9199962,6.7589064,144.9860096,500.1848644,1.0666244,74.0038154,36.9862632,95.2809724,8.0194948,13.8570216,0.5191461,35.7736031),(53494,'hindlimb',41,10,430,39.2830962,100.0993729,122.7141605,1.8,100.047235,122.7506299,-0.4190371,3.8456311,6.7744683,144.2712239,509.7510368,1.0839005,75.2459108,37.5156168,96.31213,7.9836126,13.8570216,0.5191461,35.7736031),(53495,'hindlimb',41,10,431,39.4085898,100.093642,122.6056516,1.8,100.0359845,122.6508254,-0.4178344,3.9177438,6.8126929,142.8086383,520.7332867,1.0814971,76.4357494,36.4517555,97.0489846,8.017952,14.0291651,0.4773454,36.0253085),(53496,'hindlimb',41,10,432,39.7485361,100.0846432,122.518072,1.8,100.0329542,122.537491,-0.4167901,3.877919,6.8393116,142.1748003,531.8498972,1.0856996,77.7636591,36.6626533,98.0833558,7.9836126,14.0751518,0.5456551,36.0253085),(53497,'hindlimb',41,10,433,40.0148535,100.1182707,122.3911928,1.8,100.0583079,122.4325652,-0.4173994,3.9498305,6.9218933,142.4059929,547.1203064,1.095984,79.0420028,36.0536973,99.0089279,8.017952,14.2316921,0.504166,35.6693433),(53498,'hindlimb',41,10,434,40.5634336,100.1281623,122.2687031,1.8,99.9811557,122.3316908,-0.4145386,13.5156056,15.1897031,145.9419912,566.1131749,1.0967121,37.2695353,10.7980356,35.0210451,7.8831527,14.5397175,0.5961991,36.8846845),(53499,'hindlimb',41,10,435,42.4061147,99.8823345,121.9939422,1.8,99.257928,121.8730391,-0.1975711,12.9818156,17.6403002,230.5495696,721.7239515,0.2723114,40.9133598,17.7594242,44.7168942,8.154294,14.8164498,0.515549,37.4923551),(53500,'hindlimb',41,10,436,42.4534476,100.0632909,121.9726584,1.8,99.9761854,122.056721,-0.42179,3.9400931,7.4384086,150.6289325,611.5434515,1.185892,82.2142857,38.2297907,101.6124211,8.0984989,14.9898924,0.4764674,37.5966149),(53501,'hindlimb',41,10,437,44.1393595,100.0003622,121.8004821,1.8,99.9342726,121.824828,-0.4214384,4.1491447,7.6673959,158.7461995,645.006342,1.2310543,84.1232603,38.2599819,104.5257098,8.290636,15.1917649,0.5016041,38.1000257),(53502,'hindlimb',41,10,438,45.3486417,99.9760422,121.6854463,1.8,99.9285146,121.7341128,-0.4230316,4.2112421,7.693364,166.3815271,667.6989812,1.2737843,86.7889501,39.5088963,107.98769,8.3994587,15.3729852,0.4636476,38.4559909),(53503,'hindlimb',41,10,439,47.0667803,99.8837829,121.4324938,1.8,99.7379764,121.4944851,-0.4052083,15.2716727,10.9620798,190.5277431,699.2261239,1.2190427,63.7858998,12.4758922,47.3306022,8.5408831,15.4029813,0.5260664,39.5670723),(53504,'hindlimb',41,10,440,47.8161055,99.8512081,121.3040511,1.8,99.777366,121.3840801,-0.4178325,4.37499,7.7303638,191.8575498,718.6123632,1.3122149,92.9597084,43.853254,116.551133,8.6981193,15.4029813,0.5260664,39.5670723),(53505,'hindlimb',41,10,441,49.2003963,99.7953504,121.0475892,1.8,99.7083702,121.1036041,-0.4145128,4.3344611,7.7787485,210.7263942,739.5702273,1.3300736,95.075734,48.6165153,120.2132313,8.9034525,15.5698916,0.488334,40.0704831),(53506,'hindlimb',41,10,442,50.1773222,99.7417865,120.8468207,1.8,99.706169,120.8803625,-0.4146862,4.4754697,7.8108587,226.8660828,753.9796354,1.3575527,96.5296731,50.6910103,122.9839373,9.1829804,15.6231626,0.5498532,40.6781537),(53507,'hindlimb',41,10,443,51.673455,99.6837489,120.5341065,1.8,99.6087225,120.6458243,-0.4149351,4.5733826,7.7109913,255.6221042,765.4544268,1.3996121,99.2679672,55.8934437,129.8988564,9.6102913,15.4029813,0.5260664,41.7460493),(53508,'hindlimb',41,10,444,53.4069236,99.6648254,120.2918458,1.8,99.5468446,120.3850367,-0.4225585,4.7716915,7.8044918,284.0236532,791.3279617,1.4969793,101.3939135,59.5226352,134.6438984,10.0797987,15.4029813,0.5260664,42.8571307),(53509,'hindlimb',41,10,445,59.6040053,99.5749126,119.883536,1.8,99.4570967,119.9573329,-0.432248,5.5051791,7.9099611,364.0924054,874.4298235,1.7432999,110.547929,66.1363415,151.6688123,10.9776207,15.6408793,0.6489956,45.2878131),(53510,'hindlimb',41,10,446,68.2695579,99.5371032,119.6396094,1.8,99.3344947,119.7841009,-0.412407,10.8868863,8.5463854,436.1779872,1049.1873655,1.8279541,122.7638725,40.0645304,136.4038374,11.2310997,16.7192258,0.4521539,47.3625303),(53511,'hindlimb',41,10,447,82.4352911,99.2738041,119.5584477,1.8,99.170171,119.6587437,-0.3756296,10.1587846,8.5055517,537.0533133,1392.3833236,1.8490922,163.7028812,52.8659024,189.8484419,11.3745325,16.998492,0.3617292,49.0812823),(53512,'hindlimb',41,10,448,86.2257815,99.189208,119.5925631,1.8,99.0784578,119.6431382,-0.3689814,10.006849,8.804198,578.0854699,1489.8615898,1.8693701,169.2217268,57.7689811,206.1227108,11.4927086,17.4010378,0.3529904,49.7932127),(53513,'hindlimb',41,10,449,92.5853392,99.2555121,119.7164576,1.8,99.0010219,119.7041252,-0.356862,9.6013494,9.2066685,634.0957633,1601.7127037,1.8831147,173.9731057,66.0423587,231.9972488,11.4187885,18.7690551,0.2782997,52.1196353),(53514,'hindlimb',41,10,450,93.3958167,99.2955648,119.7933519,1.8,99.1699016,119.7362414,-0.3308499,9.2990581,9.967693,662.8371523,1623.5628659,1.6426078,162.8825119,71.280031,221.9015196,11.5291031,19.8402356,0.3080528,54.8020231),(53515,'hindlimb',41,10,451,90.9557679,99.286143,119.6913994,1.8,99.4601341,119.1609842,-0.3096844,9.4679661,11.3408944,718.2305698,1525.6596036,1.4079571,134.5272741,75.8590134,196.895211,15.2221664,20.5936687,0.4076315,75.549195),(53516,'hindlimb',41,10,452,86.2258934,99.2940829,119.5922719,1.8,99.2185673,119.0910515,-0.3402414,9.6530279,10.5940041,704.8989673,1276.10016,1.6004312,120.4549431,73.0236123,186.3679853,13.8621456,19.8076381,0.4248322,58.300601),(53517,'hindlimb',41,10,453,84.9556827,99.3401545,119.623531,1.8,99.0333405,119.1935999,-0.3261419,7.1192024,9.0751136,638.8602039,1247.2440642,1.4534527,137.4356423,89.7376098,206.3889697,12.7760377,18.0673457,0.4423742,52.1196353),(53518,'hindlimb',41,10,454,83.7126633,99.2626039,119.6289735,1.8,98.9236181,118.9768602,-0.3247789,7.6475139,8.3373548,616.4474868,1209.850931,1.4206642,145.1120841,80.6075664,208.6677867,13.183521,17.2946084,0.4636476,50.4440691),(53519,'hindlimb',41,10,455,72.4968983,99.3495953,120.0466422,1.8,99.0296563,119.9884558,-0.3370732,5.7614378,8.0837015,327.8980173,1055.3224776,1.3216177,130.5494119,56.9125331,166.0941532,10.5700114,16.7192258,0.4521539,48.1176465),(53520,'hindlimb',41,10,456,61.3718825,99.3633839,120.2334145,1.8,99.0854312,120.3584837,-0.3518864,4.5879627,7.912939,191.5269869,870.2960579,1.2151312,109.9839211,41.7455416,130.6931491,8.8329186,16.3620316,0.4048918,46.5031543),(53521,'hindlimb',41,10,457,41.0815216,98.5711617,120.718221,1.8,99.2073765,120.709975,-0.3027116,3.5917088,8.6715385,76.1070629,475.0990456,0.6084812,54.7883222,21.1896532,63.4667277,6.9784683,15.9910916,0.5358112,43.7165067),(53522,'hindlimb',41,10,458,19.0959612,97.7848728,120.6114803,1.8,97.7999817,120.742328,-0.4096849,1.9928023,8.9743392,15.1629167,179.1937692,0.504958,19.9673498,7.6088414,21.6454665,4.2142604,15.1917649,0.5016041,34.8099673),(53523,'hindlimb',41,10,459,148.4237514,98.8613764,121.1777464,1.8,98.4817376,120.5234185,0.351733,21.8878117,19.0476309,2768.5717809,6006.5666294,2.9362581,315.3445514,126.4891994,391.802343,15.7926606,20.1999066,2.2355708,62.0329962),(53524,'hindlimb',41,10,460,142.589667,98.8019119,121.2654324,1.8,98.5926557,120.8509374,0.3495682,21.8330662,19.1701623,2474.9425463,5791.73639,2.7876487,302.1224495,113.357534,371.1114078,15.8894871,20.413572,2.2817057,64.6111242),(53525,'hindlimb',41,10,461,122.76911,98.821814,121.6458851,1.8,98.6745585,121.4245912,0.3397577,10.7691795,19.7446658,2019.5668178,5700.280821,2.2724828,288.6997881,187.5320966,389.4970817,15.7586087,19.8634868,2.2489156,69.472489),(53526,'hindlimb',41,10,462,108.2603533,98.7172682,122.0963528,1.8,98.6828131,121.7967699,0.3611277,10.961896,20.1420622,1712.1434599,5583.5182051,2.2525673,277.2068793,156.1904496,359.3043474,15.6931488,19.3025109,1.2772073,75.549195),(53527,'hindlimb',41,10,463,83.4819295,98.0499442,122.5762276,1.8,98.5587823,122.2800875,0.4071114,11.639241,20.3264074,1191.8633603,5890.6105766,2.1814257,289.8008709,102.4004365,343.307503,11.0173535,16.0889326,0.5954099,44.8275881),(53528,'hindlimb',41,10,464,70.2522794,97.697724,123.0579909,1.8,98.5394939,122.8464267,0.4423457,12.5914418,20.325938,755.9031873,5798.6387324,2.145456,285.2827132,60.0330923,318.0660397,11.0663164,15.6231626,0.5498532,42.6486111),(53529,'hindlimb',41,10,465,59.2347977,97.3203973,123.1059898,1.8,98.2046384,123.4281858,0.4784245,6.5368428,20.5179421,492.504401,5522.3285111,2.0924769,269.1463155,75.3428552,288.6461854,10.4906669,14.4121737,0.4636476,40.5307081),(53530,'hindlimb',41,10,466,53.6619393,97.3002788,123.0220131,1.8,98.0516236,123.3389942,0.499598,6.2325362,20.7383415,413.3141709,5242.5108289,2.0526646,252.7931578,66.315567,268.8849315,10.1513001,13.6556983,0.4214192,38.3517311),(53531,'hindlimb',41,10,467,48.2975469,97.0698488,122.7044586,1.8,97.843599,123.1099817,0.5385396,5.8153504,20.9395995,348.3759251,5230.4482542,2.1174351,249.7874063,59.9062655,263.1961468,9.7873126,12.8977995,0.5232783,36.5287193),(53532,'hindlimb',41,10,468,46.0892389,97.0811072,122.5845269,1.8,97.6458361,122.9372413,0.5710245,5.7193575,21.4445393,314.0726261,5238.5346138,2.2440395,244.2829164,54.9139698,256.0512052,9.6028256,12.5274503,0.3868757,35.1659325),(53533,'hindlimb',41,10,469,39.0233808,98.5427463,123.3568446,1.8,97.9805746,123.0006672,0.6164456,5.3674903,23.456343,251.2076153,3793.5573669,2.1738906,161.7284229,46.8016895,171.5551758,9.1784489,11.7360686,0.4145069,33.6988859),(53534,'hindlimb',41,10,470,35.8675761,99.4610827,123.9988543,1.8,99.2967047,123.854946,0.6372935,5.2058251,24.8766757,219.9271112,2910.4424529,2.1164954,116.9948303,42.2463505,125.3427242,8.9216362,11.417094,0.3455556,32.4835447),(53535,'hindlimb',41,10,471,33.3715783,100.4566764,124.7776163,1.8,99.7999603,124.2713289,0.6405526,4.9928729,25.8905932,191.655574,1953.7988891,1.9865651,75.4636588,38.3858306,82.6639981,8.59376,10.9549375,0.4461055,31.0164981),(53536,'hindlimb',41,10,472,31.3975849,101.3078413,125.4691678,1.8,100.4100447,124.799236,0.6249625,4.7597249,26.9540863,174.5194234,1133.3188712,1.7912492,42.0462729,36.6658636,48.3485837,8.5009757,10.5689273,0.4636476,29.8011569),(53537,'hindlimb',41,10,473,29.8120455,101.8515696,125.9761917,1.8,101.0292124,125.4123227,0.5733988,4.6814457,27.2995635,155.2848155,597.9792495,1.46226,21.904352,33.1702692,27.3767467,8.1558368,10.2496576,0.5763752,29.1934863),(53538,'hindlimb',41,10,474,29.3645652,101.8054777,125.9937344,1.8,101.0513471,125.4097258,0.5906775,4.5086685,27.5656177,145.4483207,681.8850879,1.5179728,24.7367969,32.2597058,29.7928247,7.948019,9.9942879,0.4444192,28.0824049),(53539,'hindlimb',41,10,475,28.2984566,101.9381705,126.1716443,1.8,101.2978461,125.6830067,0.5954257,4.4722129,27.5499025,131.0862516,578.6314494,1.483619,21.0030307,29.3112729,25.6151853,7.734384,9.8172189,0.4048918,27.4747343),(53540,'hindlimb',41,10,476,27.1903862,102.3469186,126.5457035,1.8,101.9063686,126.2126469,0.4376689,7.0134628,27.0916909,118.1227277,237.6719945,0.8140404,8.7728741,16.8422834,12.7138615,7.6104687,9.5115493,0.3217506,26.9713235),(53541,'hindlimb',41,10,477,26.2458547,102.5221216,126.7501522,1.8,102.4155586,126.6756443,-0.2450321,21.5237336,17.0280244,83.3536171,132.4880589,0.2574223,7.780589,3.8726375,7.8645345,7.304696,9.4335845,0.5247958,26.2593931),(53542,'hindlimb',41,10,478,26.0114843,102.5633159,126.8529663,1.8,102.5431803,126.8070189,-0.3348971,3.482678,4.3732546,73.061631,123.6627195,0.4683164,28.2770454,20.9785779,44.7978821,7.2637083,9.2557628,0.3805064,25.7559823),(53543,'hindlimb',41,10,479,25.8534842,102.5889078,126.9340494,1.8,102.5018176,126.817403,-0.3314758,5.313505,4.3244509,69.2831032,117.3965769,0.456359,27.1471635,13.0390587,33.4731615,6.875008,9.1049255,0.3366748,25.1483117),(53544,'hindlimb',41,10,480,25.8736818,102.6145854,126.9806344,1.8,102.4607562,126.7563074,-0.307294,5.7327214,4.3410978,70.5673086,114.8127418,0.3945497,26.4478588,12.3095653,30.99925,6.875008,9.1049255,0.3366748,25.4000171),(53545,'hindlimb',41,10,481,26.023849,102.6399195,126.9853828,1.8,102.5187825,126.568579,-0.3374453,5.6733697,4.2327199,73.9318836,113.2487848,0.4754225,26.7555582,13.0313883,30.1831626,7.463933,9.2557628,1.1902899,28.1866647),(53546,'hindlimb',41,10,482,25.9761245,102.6663559,127.0668263,1.8,102.5587131,126.7009938,-0.3381323,5.6181517,4.2310199,70.0313693,113.5222805,0.4764106,26.8309495,12.4651972,30.6160828,7.2920472,9.2557628,1.1902899,28.2909245),(53547,'hindlimb',41,10,483,26.5337684,102.6675912,127.1049593,1.8,102.5008269,126.7143685,-0.317914,5.3374573,4.3495917,70.2874643,119.063898,0.4321019,27.3735802,13.1687171,31.384466,7.278446,9.4335845,1.0460006,28.8985951),(53548,'hindlimb',41,10,484,27.3445257,102.6403086,127.1259704,1.8,102.4813314,126.6419888,-0.2966251,5.4156811,4.5780244,74.4116892,127.701072,0.3893677,27.8943622,13.7400426,31.7575868,7.2184476,10.1410009,0.9357696,32.7963241),(53549,'hindlimb',41,10,485,28.3267668,102.5850379,127.1584641,1.8,102.2029325,126.6837282,-0.2257772,5.1927786,5.7959146,75.3081161,140.2479117,0.2365996,24.1977187,14.5024699,32.8773668,8.1517796,11.0472442,2.9060477,35.7304173),(53550,'hindlimb',41,10,486,28.6795254,102.6026662,127.2184738,1.8,102.268667,126.8047288,-0.2484814,5.0235739,4.6890458,73.8055656,142.776415,0.2891026,30.4489273,14.6918443,33.3383327,7.7726337,9.6942031,2.9181161,32.6920643),(53551,'hindlimb',41,10,487,28.8223632,102.6343912,127.2525882,1.8,102.3201908,126.8462521,-0.2673382,4.8375153,4.6304381,73.5532357,144.1080773,0.3352195,31.1219096,15.2047551,33.2737404,7.2920472,9.4335845,0.5247958,30.2613819),(53552,'hindlimb',41,10,488,28.5431216,102.6699192,127.3221791,1.8,102.4129382,126.8962333,-0.3101682,4.9675848,4.5510812,70.8717657,143.5652608,0.4431724,31.5453086,14.2668456,34.3005034,7.278446,9.6560368,0.363979,30.6173471),(53553,'hindlimb',41,10,489,29.2228463,102.6320391,127.3017788,1.8,102.2202962,126.8268203,-0.3391901,4.9490114,4.7647204,75.8509572,157.4498652,0.5391852,33.0449324,15.3264866,39.0553635,8.55142,10.4635866,2.8068558,37.0932041),(53554,'hindlimb',41,10,490,30.5262348,102.558104,127.2839862,1.8,102.1472543,126.773585,-0.3391407,5.0506724,4.9284252,81.2145886,177.2422518,0.5630763,35.9632628,16.0799558,45.4466484,8.6483895,10.4635866,2.8068558,36.4855335),(53555,'hindlimb',41,10,491,34.3941027,102.4274848,127.155651,1.8,102.0798104,126.6151086,-0.3552887,4.9644012,5.6987934,97.6764845,233.0801612,0.6936563,40.8999144,19.6753807,56.8662836,8.4599362,11.5697035,0.2629947,33.1954751),(53556,'hindlimb',41,10,492,38.3626228,102.3330356,127.0550626,1.8,101.9912782,126.5256407,-0.3637719,4.8146734,6.0378074,114.1313078,305.395382,0.8094191,50.5805109,23.7048908,68.0688036,8.6070663,12.2291349,0.3217506,34.4108163),(53557,'hindlimb',41,10,493,42.9198946,102.1586341,126.8664231,1.8,101.7997187,126.3827779,-0.3618172,4.7994551,6.4978445,145.489801,404.5928333,0.8962949,62.2656994,30.3138167,84.1160624,9.1413377,13.0896253,0.4048918,35.7736031),(53558,'hindlimb',41,10,494,45.7573493,102.0349443,126.8091848,1.8,101.7248426,126.3425949,-0.3686271,4.8743493,6.7987384,170.0039014,471.7031282,0.9901995,69.3809788,34.8772504,93.676214,9.5451124,13.6556983,0.4214192,37.8483203),(53559,'hindlimb',41,10,495,49.8238922,102.0777848,126.655914,1.8,101.7027046,126.2994182,-0.3998698,5.0064794,7.6599339,200.9520709,540.0044406,1.2584954,70.4972714,40.1383996,95.4474528,9.7857699,14.8413514,0.3858827,40.4264483),(53560,'hindlimb',41,10,496,52.4893037,102.1544247,126.4517144,1.8,101.8149622,126.1571781,-0.410065,5.0542239,7.4043128,218.9685504,556.5244337,1.3904146,75.1621991,43.3238723,103.7730601,9.8854524,14.6157096,0.4241944,40.0704831),(53561,'hindlimb',41,10,497,50.469488,102.1850297,126.2757036,1.8,101.9887812,125.9152018,-0.4297884,5.0129161,7.1313791,209.9682325,534.7393465,1.4604263,74.9840023,41.8854476,103.5547404,9.7842272,14.2316921,0.504166,39.2111071),(53562,'hindlimb',41,10,498,50.8227501,102.1646294,126.2079808,1.8,102.0598034,125.7243862,-0.4342478,5.1361718,7.1254582,218.1740314,525.0731774,1.4993743,73.689742,42.4779465,103.6154049,9.8146866,14.0488921,0.4089078,39.9230375),(53563,'hindlimb',41,10,499,57.6129474,102.0314974,125.8062324,1.8,101.9835721,125.527146,-0.4387307,5.1191622,6.8964247,299.2945348,574.9875059,1.7326821,83.374724,58.4655303,126.7729088,10.1597585,13.8836442,0.3805064,39.6713321),(53564,'hindlimb',41,10,500,64.9897702,101.8147856,125.4907283,1.8,101.8287109,125.4123388,-0.4202635,4.9358044,6.5723665,378.1278467,624.4097262,1.8030852,95.0053111,76.6091637,147.2740225,10.4235754,13.8703393,2.8590377,41.1383787),(53565,'hindlimb',41,10,501,70.3672546,101.667969,125.1394514,1.8,101.680668,125.1085125,-0.409279,5.2992223,6.3506536,417.8340023,648.6763261,1.8572569,102.143238,78.8481745,147.6273132,10.3805823,13.3411032,2.8809903,39.9230375),(53566,'hindlimb',41,10,502,69.822479,101.5938548,124.9729158,1.8,101.5432207,124.9774036,-0.3952999,4.9786774,6.2466686,400.1171315,629.2020057,1.7256675,100.726011,80.3661494,158.2230992,10.4235754,13.1529455,0.6696389,39.5670723),(53567,'hindlimb',41,10,503,60.5857988,101.4287239,124.5799737,1.8,101.4220787,124.5301809,-0.3933901,4.7436749,6.0822275,313.6227262,529.0449911,1.4837012,86.9821119,66.1138749,136.3475186,9.9479922,12.7248603,0.204018,38.8119561),(53568,'hindlimb',41,10,504,46.3814047,101.204733,123.8650135,1.8,101.2570623,124.0626444,-0.3569456,4.4937961,6.0079507,191.8543378,364.1141929,0.9437854,60.60539,42.6931561,92.1825484,9.3401993,12.3717316,0.3547057,36.9889443),(53569,'hindlimb',41,10,505,41.6008964,101.180139,123.7847409,1.8,101.0917927,123.5417503,-0.3537053,4.3880683,5.805438,189.2595427,280.6162878,0.8318542,48.3367989,43.130492,80.3500695,9.2637274,12.1306029,0.4002407,34.3065565),(53570,'hindlimb',41,10,506,36.7806083,101.0800504,123.6833281,1.8,100.9776982,123.4589336,-0.3265834,4.5778991,5.692297,180.7009984,247.3407124,0.6308998,43.4518281,39.4724728,75.0015706,9.4246914,11.9156132,0.44752,33.6988859),(53571,'hindlimb',41,10,507,32.3139739,101.0096178,123.4037114,1.8,100.9114109,123.1986204,-0.3344859,4.5540721,5.4385112,165.8106533,205.1743456,0.5804136,37.7261969,36.4093169,68.1854262,9.453136,11.417094,0.3455556,32.8395099),(53572,'hindlimb',41,10,508,29.492129,100.8464861,123.0772271,1.8,100.7968387,122.9221497,-0.3596645,4.4981708,5.1168321,146.1915331,173.6431115,0.6088945,33.9356672,32.500218,61.2782852,9.023448,10.7679504,0.4993467,31.0164981),(53573,'hindlimb',41,10,509,26.5422727,100.6371493,122.4753474,1.8,100.6235701,122.3646484,-0.3159765,4.30178,4.5659864,119.8455816,134.1050979,0.4271639,29.3704552,27.8595329,55.0822179,8.59376,9.6560368,0.363979,28.6900755),(53574,'hindlimb',41,10,510,24.6422998,100.4590197,122.1042222,1.8,100.4585724,122.0344944,-0.3317745,4.1759279,4.3755317,103.7643064,111.9438966,0.4357347,25.5840672,24.8482033,48.7612712,8.164072,9.2557628,0.3805064,27.2230289),(53575,'hindlimb',41,10,511,23.2329439,100.2765936,121.6247554,1.8,100.2062628,121.5379222,0.3502807,4.1891614,4.2322467,90.5747986,91.1445403,0.4559846,21.5357344,21.6212244,42.9101601,8.164072,8.7005189,0.5743048,26.6153583),(53576,'hindlimb',41,10,512,22.5015782,100.1473837,121.301947,1.8,100.1033304,121.2174302,0.7029748,4.0411454,3.890682,80.4482,82.5964788,1.5674202,21.2293058,19.9072767,39.3109654,7.734384,8.3430318,2.5393053,25.7559823),(53577,'hindlimb',41,10,513,21.6415299,99.9387417,120.8211954,1.8,99.9043613,120.7366242,0.9257224,3.8002866,3.8245109,68.8157236,72.3360118,2.3029812,18.9137942,18.1080354,35.8789455,7.304696,7.9926588,2.2035452,24.1846759),(53578,'hindlimb',41,10,514,21.0249716,99.7692708,120.4503504,1.8,99.7425533,120.3695393,0.9935583,3.5740418,3.6585211,62.8344234,65.2158377,2.4606185,17.8257376,17.5807746,33.7206064,7.304696,7.7463106,2.1587989,23.6812651),(53579,'hindlimb',41,10,515,20.8075537,99.534482,119.8854534,1.8,99.5381593,119.8372847,1.3340396,3.6098632,3.5766644,57.4814805,57.9509174,3.2771405,16.2025036,15.9234513,30.9462759,7.2920472,7.5164702,1.0303768,23.1778543),(53580,'hindlimb',41,10,516,21.0029277,99.3641086,119.4461593,1.8,99.36273,119.3903828,-0.9612664,3.3671229,3.6294918,53.9838326,56.5941843,2.3532529,15.5928675,16.0326293,30.4643544,6.9882119,7.5164702,1.0303768,22.9261489),(53581,'hindlimb',41,10,517,21.6744838,99.0892714,118.8383429,1.8,99.1154184,118.8400409,-0.5723661,3.3452047,3.3723242,50.0589818,56.8960867,1.0597198,16.8714762,14.9644003,30.0096987,6.875008,7.3926319,0.9505468,22.2142185),(53582,'hindlimb',41,10,518,21.8643189,98.8795972,118.3981902,1.8,98.8390362,118.3995567,-0.5426103,3.2364016,3.5325458,47.5715973,60.4472074,0.9716548,17.1115142,14.6989167,29.6308992,6.6843766,7.5164702,0.5404195,21.9625131),(53583,'hindlimb',41,10,519,22.7661612,98.5666483,117.7809561,1.8,98.5404301,117.7061364,-0.4626174,3.1503733,3.7811776,45.8197608,71.461973,0.7557471,18.899396,14.5442321,28.8638003,6.5361326,8.107337,0.5585993,23.4295597),(53584,'hindlimb',41,10,520,25.3297454,98.2261857,117.2013268,1.8,98.1020318,117.0704487,-0.375361,3.2729345,4.4325872,51.6950521,103.1547987,0.5673936,23.2719166,15.7947104,32.9048553,6.8195212,9.2257926,0.4844779,26.0076877),(53585,'hindlimb',41,10,521,32.9352319,97.7131301,116.1681824,1.8,97.6296366,115.9973852,-0.3887262,3.553566,4.9657053,79.2349853,169.9114935,0.7885164,34.216991,22.2973165,48.1196074,7.5776346,10.2496576,0.5763752,29.2977461),(53586,'hindlimb',41,10,522,37.2544405,97.3720339,115.5977347,1.8,97.1843213,115.2179404,-0.3777799,4.570744,5.2669839,96.3024522,206.9063676,0.8447825,39.283653,21.0693165,56.6533719,8.7529726,10.980189,0.5337082,31.6241687),(53587,'hindlimb',41,10,523,37.2282564,97.1328788,114.9335539,1.8,97.0321896,114.6289363,-0.4326602,4.2787047,5.4866735,108.3916631,231.4214098,1.0907998,42.1788196,25.3328218,61.6240023,8.4208704,11.4413255,0.5984189,31.8758741),(53588,'hindlimb',41,10,524,33.674878,97.0544532,114.7023326,1.8,96.929019,114.4725662,-0.4174312,3.8833381,5.5440805,83.3284518,210.8660763,0.9224682,38.0344542,21.457944,53.0588352,7.853561,11.2048922,0.5667292,31.3724633),(53589,'hindlimb',41,10,525,27.9976746,96.9820175,114.5180318,1.8,96.9429314,114.4831595,-0.4328751,3.5435764,5.3734649,52.8372782,150.8865917,0.8211043,28.0799438,14.9107207,37.8282144,7.2967479,10.7422,0.6435011,29.6537113),(53590,'hindlimb',41,10,526,26.3518222,96.7892963,114.3096551,1.8,96.8255599,114.3759613,-0.3468209,3.6218808,5.1280374,49.1319511,119.8986348,0.5074422,23.3809987,13.5653142,32.9610744,7.303036,10.3304002,0.2954408,27.9349593),(53591,'hindlimb',41,10,527,23.7679844,96.4205236,113.9972252,1.8,96.5557024,114.1791153,-0.1930004,3.8824597,5.0006055,56.7484642,93.5127287,0.1457331,18.700281,14.6166268,29.9495148,7.6650624,10.2135672,0.2551824,27.4315485),(53592,'hindlimb',41,10,528,24.4793203,96.2247714,114.116934,1.8,96.3431042,114.1046104,0.9918862,4.019641,4.0928422,64.6330083,79.1519612,2.8586482,19.3391188,16.0792988,32.8630611,8.0732119,8.9721488,0.2914568,26.7196181),(53593,'hindlimb',41,10,529,26.8216821,96.3268373,114.1199055,1.8,96.2678811,114.0433952,-1.0477175,3.9720373,4.446245,85.1344134,89.2980964,3.3547224,20.0839352,21.4334373,39.1279625,7.734384,8.8582451,0.6823166,26.2593931),(53594,'hindlimb',41,10,530,26.0593207,96.4226822,114.0285062,1.8,96.4244781,113.9731852,-0.4838057,4.1997504,4.120124,83.4271401,98.9240516,0.9397245,24.0099692,19.8647855,42.1264967,8.164072,8.8582451,0.6823166,26.6153583),(53595,'hindlimb',41,10,531,26.2320353,96.5296132,113.9285579,1.8,96.4881176,113.9727453,-0.0785068,4.335471,4.1628172,86.0421548,89.8492363,0.0268908,21.5837573,19.8460918,39.3186118,8.164072,8.76395,1.7681919,26.7196181),(53596,'hindlimb',41,10,532,24.2472997,96.4275714,113.9785359,1.8,96.4457162,114.056511,0.9172242,3.7675298,4.5214775,70.6749874,93.1979028,2.5471954,20.6122671,18.7589725,35.4204502,7.8997178,9.0336729,2.0131705,26.7196181),(53597,'hindlimb',41,10,533,22.1421617,96.2568924,114.1965054,1.8,96.3188621,114.2506017,0.9435226,3.6317461,4.7215931,56.0217026,83.6889705,2.4190378,17.7247316,15.4255558,29.5493409,7.5958825,9.0642783,2.1193457,25.7559823),(53598,'hindlimb',41,10,534,22.3151561,96.340313,114.243798,1.8,96.3939482,114.3752986,1.0506493,3.3595363,4.7977344,51.2881322,76.3454794,2.8004902,15.9128189,15.2664319,26.5215706,6.875008,9.1049255,1.9074711,25.1483117),(53599,'hindlimb',41,10,535,21.2097153,96.3911602,114.4491404,1.8,96.464956,114.6309928,1.0225973,3.2799568,4.6646904,40.2614708,68.0243815,2.5748652,14.5828288,12.2750004,23.076121,6.44532,8.8582451,1.9693188,23.9329705),(53600,'hindlimb',41,10,536,20.1787986,96.4305132,114.6311795,1.8,96.4490416,114.7843856,1.0159212,3.3004808,4.63138,35.1534699,60.8212722,2.4296706,13.1324295,10.6510149,20.7215154,6.44532,8.9412281,2.1854593,23.8287107),(53601,'hindlimb',41,10,537,16.4534888,96.6319014,115.0841751,1.8,96.5735088,115.1134152,0.9746258,3.2244701,3.8961938,28.4692533,35.684887,1.8777346,9.1589097,8.8291262,16.3272541,6.44532,7.8997178,1.9614034,22.4659239),(53602,'hindlimb',41,10,538,15.0126336,96.6462996,115.2457222,1.8,96.7017727,115.3028685,0.8330389,3.408808,3.6561897,26.0859728,27.8826727,1.3700748,7.626156,7.6525205,14.2813168,6.44532,7.3926319,2.5213432,21.8582533),(53603,'hindlimb',41,10,539,14.0641858,96.6224803,115.3422656,1.8,96.5896186,115.3553136,-0.6375742,3.6700184,3.1619209,22.7007142,23.5126613,0.8305374,7.4361953,6.1854497,12.4730397,6.44532,7.1514336,2.5702552,21.3548425),(53604,'hindlimb',41,10,540,12.733662,96.5618668,115.3545309,1.8,96.5519814,115.3603498,-0.543276,3.5767183,3.1834361,20.2023251,21.7524934,0.5671364,6.8330235,5.6482853,11.622463,6.015632,7.1514336,2.5702552,20.9988773),(53605,'hindlimb',41,10,541,11.5380314,96.4638329,115.3198506,1.8,96.5217857,115.3005374,-0.5870834,3.4397999,3.2491566,17.2544434,19.5091566,0.5900628,6.0043755,5.0161184,10.473088,6.015632,6.9285108,2.6224465,20.3912067),(53606,'hindlimb',41,10,542,10.5370474,96.3834539,115.2783662,1.8,96.379607,115.2741067,-0.7498568,3.485172,3.3148383,15.1744993,17.2858063,0.815723,5.2146756,4.3540174,9.2223264,6.015632,6.7939638,2.536048,20.3912067),(53607,'hindlimb',41,10,543,9.2355053,96.2207963,115.1719477,1.8,96.2409044,115.1471764,-0.5399946,3.2443094,3.2013843,12.9202557,14.3137304,0.4068718,4.4711065,3.9824363,7.7981652,6.015632,6.9285108,0.5191461,19.8877959),(53608,'hindlimb',41,10,544,8.1906573,96.0738429,115.0984505,1.8,96.0467482,115.100623,-0.4466982,3.1960371,3.1518849,11.2875659,11.7089961,0.2547505,3.7149187,3.531738,6.9739636,5.9707924,6.5589027,0.551655,19.5318307),(53609,'hindlimb',41,10,545,7.0087342,95.9314973,114.9584469,1.8,95.9270133,114.9332127,0.0489104,2.8851195,3.12649,9.5466806,9.7198167,0.0027922,3.108859,3.3089377,5.9514266,5.585944,6.5589027,0.551655,18.9241602),(53610,'hindlimb',41,10,546,5.9685859,95.7616132,114.7906826,1.8,95.6933858,114.7752694,0.6223059,2.9325046,2.9098536,7.5939833,7.9815911,0.3380055,2.7429528,2.5895896,5.0585416,5.4919414,6.1970485,2.5535901,18.0647842),(53611,'hindlimb',41,10,547,4.772172,95.4389616,114.4770493,1.8,95.4027833,114.4616548,0.7343305,2.8477876,2.8469324,5.8648746,6.2023107,0.3571343,2.1785943,2.0594494,4.1289484,5.156256,5.8443887,2.5127964,17.4571136),(53612,'hindlimb',41,10,548,4.0019777,95.1937243,114.1877974,1.8,95.2077995,114.1821409,0.4573025,2.6816544,2.6634853,4.7054592,5.2430834,0.1300297,1.9685047,1.7546852,3.5166099,5.156256,5.7648695,2.677945,16.3460322),(53613,'hindlimb',41,10,549,3.3397091,94.7821385,113.7784771,1.8,94.8085781,113.8118764,0.6333947,2.2746274,2.5994458,3.4897324,4.5193223,0.1949985,1.7385715,1.5341996,2.9930447,4.7169615,5.6024461,2.5748634,15.3823964),(53614,'hindlimb',41,10,550,3.1942976,94.5030468,113.4853701,1.8,94.5206178,113.5074563,0.7277391,2.1953004,2.4160294,2.6059188,3.6857743,0.2355628,1.5255503,1.1870443,2.5373792,4.29688,5.2450105,2.5308667,14.1670552),(53615,'hindlimb',41,10,551,2.1054177,94.2990172,113.2483254,1.8,94.324189,113.25348,0.7663434,1.561013,1.8335733,1.1390417,1.5478243,0.1687667,0.8441573,0.7296811,1.3303644,3.6460236,4.29688,2.2142974,11.9448924),(53616,'hindlimb',41,10,552,1.0080336,94.1583611,113.1834013,1.8,94.155383,113.222788,0.565046,1.3037854,1.2742063,0.353141,0.3775503,0.0481692,0.2963024,0.2708582,0.5322852,2.578128,3.1281759,2.863293,8.654834),(53617,'hindlimb',41,10,553,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53618,'hindlimb',41,10,554,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53619,'hindlimb',41,10,555,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53620,'hindlimb',41,10,556,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53621,'hindlimb',41,10,557,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53622,'hindlimb',41,10,558,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53623,'hindlimb',41,10,559,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53624,'hindlimb',41,10,560,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53625,'hindlimb',41,10,561,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53626,'hindlimb',41,10,562,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53627,'hindlimb',41,10,563,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53628,'hindlimb',41,10,564,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53629,'hindlimb',41,10,565,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53630,'hindlimb',41,10,566,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53631,'hindlimb',41,10,567,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53632,'hindlimb',41,10,568,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53633,'hindlimb',41,10,569,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53634,'hindlimb',41,10,570,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53635,'hindlimb',41,10,571,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53636,'hindlimb',41,10,572,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53637,'humerus.tif',232,2,1,8.9732329,8.2662414,11.4411528,1.8,8.4110091,11.3899223,-0.0281995,3.8215211,6.5550237,36.3807637,83.8638439,0.0011889,12.7938277,9.5199692,16.8059362,2.9237725,7.3453864,1.5230067,18.4282597),(53638,'humerus.tif',232,2,2,9.1402697,8.5689798,11.4158146,1.8,8.6662462,11.3554885,-0.0391288,3.8619106,6.3793512,36.2131551,78.5273948,0.0023312,12.3096208,9.377005,16.4595573,4.0323349,7.3547317,1.501343,20.2186437),(53639,'humerus.tif',232,2,3,10.3289906,8.9556361,11.3100324,1.8,9.0331041,11.2815141,-0.0244562,4.0832906,6.1061918,38.5371889,76.9153009,0.0010294,12.5962799,9.4377777,17.2503998,4.4680785,7.44426,1.5150601,20.1999571),(53640,'humerus.tif',232,2,4,9.6252803,9.2270366,11.2800871,1.8,9.2746988,11.2402583,0.0034513,4.1997828,5.9793624,38.0515614,76.8507368,0.0000191,12.8526641,9.0603641,17.2779325,4.464022,7.6189597,1.4869597,20.8147364),(53641,'humerus.tif',232,2,5,9.9874623,9.3856999,11.1827078,1.8,9.4022747,11.1607726,0.0474531,4.4098957,5.7977343,38.6055198,78.9963189,0.0037455,13.6253776,8.7542931,18.1702982,4.3750831,7.834292,1.5015196,22.0875303),(53642,'humerus.tif',232,2,6,10.6606895,9.2897946,11.1093655,1.8,9.314161,11.1247148,0.1436187,4.6789019,5.6664422,38.8198656,78.7549021,0.0363972,13.8984745,8.2967899,17.878031,4.0606217,8.0375974,1.4833703,22.2479694),(53643,'humerus.tif',232,2,7,10.2665343,8.9707252,11.1841217,1.8,8.999573,11.2215406,0.3731124,4.8270753,5.7587665,37.9988295,72.7756878,0.2273549,12.6373744,7.8720193,16.3159945,4.0672885,8.2406413,1.5204513,23.5621205),(53644,'humerus.tif',232,2,8,10.1612046,8.7361956,11.3443276,1.8,8.7333627,11.396067,0.55963,5.572068,5.8789373,32.4596888,75.701178,0.4772815,12.8766772,5.8254294,15.5501721,4.2034055,8.3353669,1.4711277,24.4798693),(53645,'humerus.tif',232,2,9,9.7827174,8.555232,11.6033138,1.8,8.7069934,11.6662704,0.6854309,5.1763323,6.0028974,24.9350668,70.9108516,0.6533182,11.8127709,4.8171303,15.1100235,4.2647059,8.5007366,1.5107183,24.7769766),(53646,'humerus.tif',232,2,10,4.9966342,10.957584,10.3160902,1.8,10.9539906,10.3461563,0.1456454,2.5497101,2.4633877,1.8696081,6.5794569,0.0175407,2.6708978,0.733263,2.4364292,2.8737533,4.5475126,2.9937433,14.5017425),(53647,'humerus.tif',232,2,11,9.1433708,10.6432538,10.3856669,1.8,10.5735326,10.3719084,0.3367718,2.2386787,3.7076769,7.043034,23.1753149,0.166397,6.2506296,3.1460674,8.0201352,3.5512396,5.8310723,3.0484563,18.6359181),(53648,'humerus.tif',232,2,12,10.7234098,10.3428347,10.3386319,1.8,10.2769494,10.3204181,0.385237,2.3160081,3.5130265,14.0305798,40.8832141,0.2523749,11.6376049,6.0580875,15.5526507,4.3052347,6.6439362,3.0309354,21.825368),(53649,'humerus.tif',232,2,13,11.4835793,10.0165095,10.2581886,1.8,10.0126699,10.2578667,0.3679235,3.976363,5.1036341,21.1957689,53.6977876,0.2476028,10.5214807,5.3304412,14.5585551,4.9592164,7.2701214,2.9562447,23.0015229),(53650,'humerus.tif',232,2,14,12.0839446,9.7165463,10.1845194,1.8,9.6727046,10.2512592,0.2816989,4.4126943,4.0403543,29.8736607,63.7441412,0.1556359,15.776869,6.7699366,18.9927975,5.4188939,7.7249393,2.9798384,24.1344424),(53651,'humerus.tif',232,2,15,14.2754064,9.3311347,10.5473372,1.8,9.3526335,10.5634894,0.0114181,4.7588656,5.1561511,55.2461372,78.9906823,0.0003102,15.319699,11.6090981,21.9259226,7.1961381,8.220674,0.5697054,28.9047399),(53652,'humerus.tif',232,2,16,15.7615378,9.2611269,10.6772465,1.8,9.2729885,10.6309856,-0.0852696,4.2125374,4.7094695,69.4604855,94.6461767,0.0190538,20.0969933,16.4889894,29.7930938,7.5097964,8.5313866,0.5641482,29.2811277),(53653,'humerus.tif',232,2,17,16.3878575,9.3080495,10.6314299,1.8,9.3372537,10.6131555,0.0111281,4.3867836,4.7647835,76.9767544,109.3545663,0.0003382,22.9505846,17.5474244,33.1682691,7.768777,8.9221969,0.6177557,30.536563),(53654,'humerus.tif',232,2,18,16.8991432,9.3228856,10.6483977,1.8,9.3453957,10.6281275,0.0419475,4.556898,4.8474184,83.630798,118.540007,0.004953,24.4542555,18.352572,40.6407264,7.923428,8.9758688,2.91213,29.5969216),(53655,'humerus.tif',232,2,19,16.6666388,9.2186876,10.6237247,1.8,9.2732456,10.6061281,0.1294598,4.6540616,5.0173981,85.4450753,119.4363051,0.0462956,23.8044308,18.3592489,40.8340934,7.9991735,9.1296441,2.9016987,30.5488374),(53656,'humerus.tif',232,2,20,16.3238461,9.1596351,10.587073,1.8,9.223689,10.5972787,0.2097886,4.7359954,5.0544677,85.1515088,113.8972127,0.1179924,22.5339677,17.9796435,39.0253783,8.0240561,9.1770042,2.8814381,31.7391447),(53657,'humerus.tif',232,2,21,15.9664067,9.1179053,10.5535048,1.8,9.1708518,10.5714899,0.2689016,4.450885,5.1253801,82.724354,111.7880611,0.1878234,21.8106871,18.5860463,37.3618558,7.9404452,9.2369645,2.8580748,32.1825386),(53658,'humerus.tif',232,2,22,14.9728277,9.0856043,10.6290734,1.8,9.1120687,10.6513005,0.2553174,4.2520438,5.1749163,75.7384385,107.3773392,0.1591681,20.7495798,17.8122431,35.1671832,7.7646757,9.1974401,2.8604345,33.8722996),(53659,'humerus.tif',232,2,23,14.2356302,9.2104099,10.671754,1.8,9.1786378,10.675251,0.2302458,4.0723018,5.10102,69.6824098,101.4317012,0.1235722,19.884592,17.111308,33.432289,7.528415,9.1294769,2.8143173,33.9547862),(53660,'humerus.tif',232,2,24,13.3308778,9.3690005,10.7760955,1.8,9.3001902,10.7810047,0.2625543,3.8985507,4.8816065,62.5193431,93.3004039,0.149673,19.1126434,16.0365601,31.6005124,7.2571827,8.9788727,2.2832761,32.702557),(53661,'humerus.tif',232,2,25,12.8537972,9.6056138,10.8387242,1.8,9.522505,10.8616596,0.2279763,3.7816415,4.6480378,58.0795226,88.9369306,0.1094265,19.1342958,15.3582836,31.3205164,7.0120205,8.8132953,2.2381886,30.4340619),(53662,'humerus.tif',232,2,26,11.8295051,10.0131944,10.8810869,1.8,9.8959486,10.8932738,0.1276111,3.7721431,4.2639509,51.9008561,72.0414931,0.0319326,16.8954791,13.758984,28.8347846,6.7464753,8.4943897,2.2390857,29.8411753),(53663,'humerus.tif',232,2,27,11.3920223,10.288046,10.8651462,1.8,10.1708318,10.8627744,0.1030995,3.6327476,3.999625,46.2049879,61.8116384,0.0201105,15.4543583,12.7190194,26.0538022,6.6334757,8.1703866,2.2455373,29.1148265),(53664,'humerus.tif',232,2,28,10.2551424,10.6616879,11.1076058,1.8,10.5943006,11.1474934,-0.463848,3.7002897,3.9410261,39.2449859,48.5864717,0.3421121,12.3283809,10.6059225,22.0962794,0.1416451,0.2744142,0.9505468,0.6876475),(53665,'humerus.tif',232,2,29,9.6175527,11.04776,11.1209474,1.8,10.9936577,11.1878379,-0.8074011,3.398862,3.7695942,34.6094701,44.1597059,0.8367204,11.7147108,10.182664,20.4768447,6.1402378,7.5429843,0.6654942,24.6029351),(53666,'humerus.tif',232,2,30,9.6792291,11.2853603,11.0255425,1.8,11.2410844,11.0688813,-0.9879374,3.2122068,3.5060984,32.3060068,40.1985383,1.1244772,11.4653195,10.0572625,19.7219794,5.7710825,7.2252621,0.6947383,23.0845596),(53667,'humerus.tif',232,2,31,9.3650981,11.3968326,10.9333819,1.8,11.3473185,10.9686852,-1.1141417,2.9948128,3.4206359,30.5241112,37.4935132,1.2573657,10.9609776,10.1923271,19.2042358,5.580727,7.0469404,0.734161,23.6149742),(53668,'humerus.tif',232,2,32,9.2126713,11.57011,10.8778025,1.8,11.5462495,10.8797695,-1.3248633,2.7924526,3.3545777,28.6755177,36.3364075,1.4444341,10.8318871,10.2689364,18.2950088,5.4071177,7.0282152,0.8464156,24.3245144),(53669,'humerus.tif',232,2,33,9.1656473,11.6432276,10.8576226,1.8,11.6448157,10.8443219,-1.3123661,2.7606047,3.3721755,27.1984083,35.8189642,1.4278359,10.6219159,9.852337,17.1707636,0.1850977,0.8076435,1.7294516,1.8856951),(53670,'humerus.tif',232,2,34,9.0122523,11.733897,10.8193048,1.8,11.7676239,10.8110824,-1.3324987,2.7134025,3.4313308,26.1405446,34.8311481,1.4183498,10.1509151,9.6338617,16.1764865,5.1990594,6.8816811,1.2255897,22.7204461),(53671,'humerus.tif',232,2,35,9.0701805,11.8363469,10.7393311,1.8,11.8941597,10.7178451,-1.3319283,2.7266182,3.4542401,25.819165,34.1722048,1.4270706,9.8928283,9.4692996,15.8410225,5.2252293,6.9225206,1.2228127,22.6953473),(53672,'humerus.tif',232,2,36,8.9986209,11.9309531,10.7074543,1.8,12.01196,10.6959209,-1.3538398,2.6296715,3.5929983,25.1319826,33.5545306,1.4302765,9.3388663,9.5570805,15.2897016,5.0747197,6.9825305,1.2259285,21.8974583),(53673,'humerus.tif',232,2,37,9.0908231,11.9735886,10.6686323,1.8,12.0489928,10.6559442,-1.2803718,2.6382768,3.638672,24.8156258,33.590685,1.3908937,9.2315781,9.4059978,14.9374762,5.0174972,7.0495392,1.2003736,22.7094998),(53674,'humerus.tif',232,2,38,9.042222,12.0946397,10.6222351,1.8,12.1953265,10.6058586,-1.2873313,2.6593251,3.6114752,24.6354402,33.5570503,1.3891518,9.2917847,9.2637941,15.0068209,5.0613626,6.9372783,1.2039526,22.2319388),(53675,'humerus.tif',232,2,39,8.9232599,12.1814956,10.5237367,1.8,12.2756353,10.506548,-1.2333546,2.7039193,3.6077898,24.7491232,33.1963298,1.3241968,9.2012926,9.1530555,15.0833109,5.0487072,6.9670652,1.2055949,22.0031657),(53676,'humerus.tif',232,2,40,8.9945339,12.268728,10.4302062,1.8,12.3607077,10.4307705,-1.1456077,2.798442,3.6328464,24.8445235,33.3549285,1.2440188,9.1814861,8.8779839,15.3211454,5.0835942,6.9448286,1.1646983,21.7324852),(53677,'humerus.tif',232,2,41,9.0410328,12.3343302,10.376025,1.8,12.4330679,10.3793186,-1.0776377,2.8628226,3.6201412,25.0554463,33.0898973,1.1691298,9.140499,8.7520079,15.4669719,5.1814044,6.893427,1.1361261,22.9008998),(53678,'humerus.tif',232,2,42,9.051249,12.3769589,10.3514442,1.8,12.4734488,10.3730671,-1.0549989,2.88869,3.6313544,25.5745802,32.4977005,1.1415517,8.9491956,8.8533488,15.1994924,5.204768,6.927223,0.7006344,21.4695449),(53679,'humerus.tif',232,2,43,9.1820732,12.4293104,10.2991283,1.8,12.5114679,10.3417209,-0.9715926,2.9812682,3.6741603,26.2253224,32.4455955,1.0435745,8.8307511,8.7967002,15.6274223,5.2754343,6.9051528,0.6675261,21.5488254),(53680,'humerus.tif',232,2,44,9.5352287,12.498923,10.2574351,1.8,12.5715789,10.3072982,-0.8512662,3.0894561,3.6605919,27.1472973,33.3446891,0.8989777,9.1090976,8.7870799,16.2949743,5.3328404,6.8745056,0.5905766,21.5333449),(53681,'humerus.tif',232,2,45,9.622078,12.553996,10.2153148,1.8,12.6397899,10.2715027,-0.7569835,3.119674,3.6566975,27.5736623,32.7999181,0.7562964,8.96982,8.8386357,16.3437951,5.3778443,6.8391845,0.582828,21.3432729),(53682,'humerus.tif',232,2,46,9.4761515,12.5606259,10.163392,1.8,12.6299837,10.2219333,-0.6384156,3.0915436,3.6804973,27.5481882,31.6946964,0.5608701,8.6115256,8.9108199,16.0920878,5.4738342,6.8067455,0.5581025,21.4148132),(53683,'humerus.tif',232,2,47,9.5062331,12.5397604,10.1504127,1.8,12.6052504,10.2303944,-0.4358185,3.2639419,3.7056171,27.4528615,31.7385218,0.2823554,8.5649762,8.4109529,15.9085575,5.4409937,6.8015858,0.5203096,21.4895595),(53684,'humerus.tif',232,2,48,9.5542318,12.5574594,10.1267388,1.8,12.6220187,10.2085913,-0.1654898,3.417189,3.5902364,27.7201475,31.5242198,0.0432134,8.7805417,8.1119737,15.9414159,5.5308131,6.7949996,0.4993467,20.8438193),(53685,'humerus.tif',232,2,49,9.9306051,12.5638241,10.1299741,1.8,12.632418,10.2061331,0.102688,3.2153193,3.3986248,27.9508612,32.4591082,0.0173915,9.5506595,8.6930281,16.154215,5.6613167,6.740267,0.4191854,21.1892461),(53686,'humerus.tif',232,2,50,10.1790705,12.6310002,10.0968799,1.8,12.7156868,10.1781096,0.2256444,3.499489,3.2581651,28.0920816,34.0684274,0.0849225,10.4563233,8.0274811,16.8352012,5.5957189,6.6586236,0.3066002,21.2343595),(53687,'humerus.tif',232,2,51,10.3504651,12.7248534,10.0564855,1.8,12.827372,10.1358725,0.4082811,2.8977954,3.0057959,26.5363648,35.5245199,0.271932,11.8186732,9.1574321,17.2059635,5.5007736,6.5332727,0.2769583,21.6526546),(53688,'humerus.tif',232,2,52,10.3671051,12.7716518,10.015088,1.8,12.8815879,10.1080818,0.5297966,2.8113638,3.1149707,25.3198712,36.2681358,0.4412699,11.6431709,9.0062592,17.2805069,5.4018602,6.4138836,0.2461849,20.4345925),(53689,'humerus.tif',232,2,53,10.6079968,12.8244898,9.9788805,1.8,12.9517232,10.0755223,0.5432465,2.7196003,3.1782878,24.4271625,37.7176294,0.4724167,11.8672794,8.9818943,17.6418999,5.3101834,6.445537,2.0942395,21.1190339),(53690,'humerus.tif',232,2,54,10.6914253,12.8664096,9.9548823,1.8,13.0212553,10.075698,0.5641588,2.6143548,3.2429721,23.8130936,39.0430628,0.5094636,12.0392841,9.1085929,17.8769048,5.1491217,6.4829246,2.1137475,20.8825205),(53691,'humerus.tif',232,2,55,10.5546408,12.9208499,9.9317217,1.8,13.0903441,10.0559155,0.6024685,2.6664638,3.3326327,22.5219348,40.0978342,0.5648915,12.0318791,8.4463683,17.9503678,4.9531045,6.5398113,2.1371514,22.2468692),(53692,'humerus.tif',232,2,56,10.6367826,12.9572488,9.8991995,1.8,13.1309077,10.0439012,0.6173263,2.4663901,3.3876081,21.6251349,41.4898921,0.5940207,12.2475479,8.7679298,18.1370923,4.7505641,6.6352768,2.656443,22.3152034),(53693,'humerus.tif',232,2,57,10.4499923,12.9454104,9.8262911,1.8,13.1433862,9.9679809,0.6312993,2.3378971,3.3788214,20.3771829,41.378227,0.6066728,12.2463492,8.7160308,17.3548129,4.6568132,6.7979193,2.6317594,20.1852546),(53694,'humerus.tif',232,2,58,10.4728985,12.9653145,9.8089735,1.8,13.1638901,9.9545895,0.6688546,2.7742827,3.436488,19.5091781,43.0126854,0.6711538,12.5164659,7.0321522,17.3785841,4.4767145,6.878945,2.1948194,19.9300546),(53695,'humerus.tif',232,2,59,10.5150118,12.9800198,9.761405,1.8,13.1861852,9.9164658,0.675785,2.1718682,3.4752177,18.7764325,44.3495255,0.6856887,12.7616538,8.645291,17.3504755,4.3138541,7.0371864,2.2179239,19.9223144),(53696,'humerus.tif',232,2,60,10.6723528,13.0116898,9.7275085,1.8,13.2195919,9.8805313,0.6739126,2.1385086,3.5362895,18.2045956,46.7992331,0.6926995,13.2339936,8.512753,17.6339311,4.2338292,7.1690593,2.2490119,20.166568),(53697,'humerus.tif',232,2,61,10.6705231,12.9729324,9.6777481,1.8,13.177207,9.8294497,0.6992711,2.0497659,3.772272,17.3716405,47.3977327,0.7367965,12.5647707,8.4749389,17.048393,4.0691937,7.319295,2.4518767,20.4978424),(53698,'humerus.tif',232,2,62,11.0115808,13.0170372,9.6634466,1.8,13.217486,9.8187591,0.7072364,2.0191114,3.806614,16.7826945,50.775591,0.7747678,13.3387812,8.3119209,17.5730374,4.0287424,7.4831173,2.4588625,21.2415497),(53699,'humerus.tif',232,2,63,11.0606504,13.004525,9.5861383,1.8,13.2193077,9.7600086,0.6968953,2.2905653,3.942146,16.1082886,52.1397311,0.7594216,13.2262304,7.032451,17.1217374,3.9482324,7.6435623,2.5072733,21.5231765),(53700,'humerus.tif',232,2,64,11.0006896,12.9582702,9.4884987,1.8,13.1618431,9.6568721,0.6894267,2.0633164,4.1672015,15.4074744,51.7723475,0.7418439,12.4237688,7.4673346,15.9559336,3.9107771,7.8322134,2.5298657,23.5068387),(53701,'humerus.tif',232,2,65,11.2937095,12.9760468,9.4386136,1.8,13.1917818,9.6160492,0.6802149,2.2978331,4.1853811,14.7963653,53.5698908,0.7446147,12.7992863,6.4392689,16.2334154,3.8511357,7.873357,2.508626,21.6694631),(53702,'humerus.tif',232,2,66,11.671994,12.9888378,9.3773847,1.8,13.1944086,9.552584,0.6685735,1.9817064,4.1934287,14.387258,55.505549,0.7474656,13.2363165,7.2600352,16.6027234,3.8213439,7.9048304,2.4964773,21.3395168),(53703,'humerus.tif',232,2,67,11.81785,12.9736517,9.2980313,1.8,13.1633496,9.455963,0.6582072,1.9142149,4.2044998,13.6862147,56.8356573,0.7369934,13.5178167,7.1497797,16.7094643,3.783678,7.9179502,2.5077609,23.3496057),(53704,'humerus.tif',232,2,68,11.8935008,12.9300496,9.1923124,1.8,13.0764452,9.3032275,0.6408277,1.9013438,4.1744686,12.9737942,56.2726052,0.7085266,13.480184,6.8234867,16.547387,3.758771,7.8476594,2.5062214,20.0840814),(53705,'humerus.tif',232,2,69,12.0718061,12.8865156,9.1000795,1.8,12.9981629,9.1762611,0.6269165,1.8899986,4.0558239,12.4077423,55.3605263,0.6924362,13.6496375,6.564948,16.117043,3.7301699,7.7138,2.4881663,19.3918997),(53706,'humerus.tif',232,2,70,11.9400041,12.7526678,8.9550854,1.8,12.8291935,9.0035139,0.6219199,1.8799177,4.1887902,11.9354055,50.7450472,0.6754438,12.1144875,6.3488979,14.3044932,3.7012312,7.5056573,2.5252957,18.8692254),(53707,'humerus.tif',232,2,71,11.5386787,12.5630533,8.7884432,1.8,12.6112834,8.8238625,0.6337695,1.8832875,3.8070607,11.4698888,43.1252422,0.6744064,11.3277001,6.0903547,14.2889775,3.6802475,7.1763658,2.5363291,17.9482705),(53708,'humerus.tif',232,2,72,11.1351814,12.3827849,8.6244489,1.8,12.3996784,8.6440569,0.6447215,1.8749305,4.1034414,11.158195,36.6812394,0.6702859,8.9391405,5.9512579,11.6339482,3.6619084,6.6901838,2.5324292,17.0460023),(53709,'humerus.tif',232,2,73,10.8476292,12.2611517,8.5077987,1.8,12.2637023,8.5180897,0.6506431,1.8668115,3.268691,10.8587038,32.717849,0.6632789,10.0094652,5.8167113,13.3238338,3.6294392,6.3353433,2.4990986,16.4034681),(53710,'humerus.tif',232,2,74,10.6809127,12.1588861,8.395729,1.8,12.1564641,8.40176,0.6562117,1.8708427,3.1626507,10.6764342,30.2616702,0.6626546,9.5684515,5.7067515,12.9412862,3.6194751,6.1442084,2.488746,16.0689876),(53711,'humerus.tif',232,2,75,10.5782515,12.0726052,8.2937784,1.8,12.0690579,8.298507,0.6597763,1.8569274,3.0749153,10.5319808,28.4658191,0.6623671,9.2574319,5.6717244,12.6722312,3.6017762,5.9985574,2.4768182,15.824734),(53712,'humerus.tif',232,2,76,10.6306522,11.973062,8.1492173,1.8,11.9699592,8.1321423,0.7214846,2.9167749,3.9053285,11.146038,28.4502025,0.7729554,7.2849703,3.821357,8.1693636,3.5925242,5.8838857,2.4753189,15.6255938),(53713,'humerus.tif',232,2,77,10.8817957,11.8610642,7.9364725,1.8,11.8524518,7.8973815,0.8721606,2.6009136,4.189627,12.5561031,31.412396,1.0633829,7.4976593,4.8275741,9.1469342,3.5786426,5.7841131,2.4616838,15.4451401),(53714,'humerus.tif',232,2,78,11.0222262,11.7673797,7.7536353,1.8,11.7606556,7.7157318,0.988234,2.4593333,4.3983412,13.5022825,33.7853273,1.2809994,7.6813793,5.4902207,9.6957944,3.5717689,5.7059105,2.4432753,15.3362267),(53715,'humerus.tif',232,2,79,11.1547175,11.6799167,7.5531217,1.8,11.6765352,7.5051762,1.0957158,2.236511,4.5280082,14.1847887,36.9946276,1.4701472,8.1701768,6.3423737,10.5251294,3.5635476,5.6201971,2.4526683,15.2163669),(53716,'humerus.tif',232,2,80,11.4872559,11.6000768,7.3526153,1.8,11.5920571,7.3023689,1.1952639,2.1294308,4.6193673,14.8816554,40.946715,1.6570009,8.8641393,6.9885603,11.4625194,3.5747077,5.5550899,2.4578833,15.1603072),(53717,'humerus.tif',232,2,81,11.6883028,11.5302602,7.2040526,1.8,11.5239002,7.1534473,1.2451272,2.1533315,4.6248689,15.0696019,42.7740841,1.7486414,9.2487127,6.9982731,11.940972,3.5971743,5.5187923,2.4298316,15.2395876),(53718,'humerus.tif',232,2,82,11.9240139,11.4577433,7.041121,1.8,11.4527423,6.985426,1.286228,2.1756491,4.6125868,15.0776713,44.9914093,1.8307004,9.7540516,6.9301943,12.4668069,3.592546,5.4850379,2.3191744,15.2363815),(53719,'humerus.tif',232,2,83,12.4385846,11.3828862,6.8556081,1.8,11.381554,6.7965633,1.3276392,2.169475,4.5090801,15.2194575,48.4345325,1.9529215,10.7415551,7.0152722,13.4204522,3.6376713,5.6296045,1.9786643,15.5831364),(53720,'humerus.tif',232,2,84,13.0858399,11.3035711,6.6347587,1.8,11.2967345,6.5494425,1.3650619,2.1592597,4.4007849,15.2953764,52.4195698,2.0899551,11.9114139,7.0836205,14.5785947,4.1353746,7.719866,1.6618303,21.9871351),(53721,'humerus.tif',232,2,85,13.3911056,11.2446351,6.5008609,1.8,11.235743,6.4059717,1.3906004,2.1453911,4.3525523,15.1589664,53.1443537,2.1601625,12.2099288,7.0658289,14.7962602,4.1135473,7.6921346,1.6039792,21.4689948),(53722,'humerus.tif',232,2,86,13.5924939,11.2075701,6.4003761,1.8,11.2001276,6.3128021,1.4222146,2.1494225,4.366182,15.0502365,53.9816184,2.2157701,12.363575,7.0019908,14.9949966,4.1228499,7.695904,1.6164078,21.280801),(53723,'humerus.tif',232,2,87,13.3635927,11.1869619,6.3229726,1.8,11.1902655,6.2253404,1.451795,2.1669434,4.3996777,14.791449,53.5709852,2.195873,12.1761159,6.8259509,14.8591619,4.1140458,7.7048242,1.5045036,21.1828339),(53724,'humerus.tif',232,2,88,13.0645091,11.1629387,6.256948,1.8,11.1682444,6.1597274,1.482471,2.1771644,4.4461427,14.31791,52.3508685,2.1604755,11.7744463,6.5764027,14.4245917,4.0849558,7.7570149,1.5337762,21.025601),(53725,'humerus.tif',232,2,89,12.8037329,11.1405472,6.2237208,1.8,11.1492955,6.1275241,1.5129548,2.1778564,4.507926,13.9025133,50.3427729,2.126824,11.1676131,6.3835766,13.7592758,4.069884,7.7779109,1.4886769,21.0365473),(53726,'humerus.tif',232,2,90,12.4785416,11.1196929,6.2000917,1.8,11.1299168,6.1048374,1.5440115,2.1735071,4.5472709,13.3877967,48.1221994,2.0782652,10.582655,6.1595365,13.1188459,4.047494,7.7642268,1.4637689,21.153201),(53727,'humerus.tif',232,2,91,12.2125865,11.0924169,6.1975786,1.8,11.1013981,6.0927446,-1.5657288,2.1907177,4.6082219,12.973487,45.8128567,2.0353788,9.9415475,5.922026,12.4070448,4.0426398,7.7788921,1.4474586,20.9089473),(53728,'humerus.tif',232,2,92,12.0882757,11.0632355,6.2315059,1.8,11.0715797,6.119557,-1.5299939,2.1819463,4.7103109,12.7626645,44.2137666,2.0113603,9.386592,5.8492112,11.8230529,4.0140595,7.782881,1.443391,21.1983144),(53729,'humerus.tif',232,2,93,12.2180075,11.0337859,6.2864649,1.8,11.0423333,6.1756861,-1.5013088,2.1768289,4.8052414,12.4749202,43.2350186,2.0265179,8.9974706,5.7307767,11.344611,3.9875,7.7983595,1.4022852,20.5448339),(53730,'humerus.tif',232,2,94,11.5410579,11.0134746,6.2862654,1.8,11.0215115,6.1765749,-1.4665825,2.1807019,4.8711295,11.982487,41.6060605,1.9026948,8.5413579,5.4947846,10.8330688,3.9556,7.8139375,1.3693976,20.48424),(53731,'humerus.tif',232,2,95,11.3309257,11.000246,6.2457945,1.8,11.0176513,6.118405,-1.4380127,2.1903675,4.8954589,11.5418421,40.1606685,1.855386,8.2036576,5.2693633,10.4231768,3.9237,7.864822,1.3582866,21.6790814),(53732,'humerus.tif',232,2,96,11.052699,10.9474672,6.2343366,1.8,10.9651729,6.1155149,-1.4008802,2.1558486,4.9562379,11.1127575,39.1108709,1.7894418,7.8912416,5.1547023,10.0345698,3.9012285,7.9094634,1.3013607,20.4017534),(53733,'humerus.tif',232,2,97,10.8662098,10.9117211,6.2226646,1.8,10.9359071,6.0990061,-1.3662971,2.1316431,5.0356881,10.7629174,39.1571158,1.7363475,7.7759215,5.0491179,9.8543499,3.8936722,7.993417,1.3083945,20.5074607),(53734,'humerus.tif',232,2,98,10.570749,10.8809693,6.2282926,1.8,10.9076751,6.1000186,-1.3328149,2.1213231,5.0940773,10.4328613,39.5432585,1.6638816,7.762595,4.9180917,9.7572311,3.8710688,8.0515753,1.2690932,20.5261473),(53735,'humerus.tif',232,2,99,10.4122799,10.8719343,6.209515,1.8,10.9057458,6.0760333,-1.3020885,2.1272621,5.1177703,10.051522,40.2348168,1.6130657,7.8617864,4.725098,9.7823784,3.8419749,8.1105084,1.2465582,20.5635205),(53736,'humerus.tif',232,2,100,10.2678609,10.8536696,6.1617605,1.8,10.8863272,6.0325953,-1.2692307,2.1031578,5.1191219,9.6948154,41.3038686,1.5603414,8.0685456,4.6096471,9.9262015,3.7736092,8.1766117,1.2120257,20.6537473),(53737,'humerus.tif',232,2,101,9.9317749,10.8496146,6.1075777,1.8,10.8868512,5.9821389,-1.2405583,2.0894865,5.0908209,9.2090845,42.3107504,1.4812417,8.3111843,4.4073434,10.0820367,3.7227786,8.2401474,1.1816633,20.7813473),(53738,'humerus.tif',232,2,102,10.1084733,10.8159753,6.067522,1.8,10.84832,5.9519176,-1.2123815,2.0578775,5.1054447,8.9675764,44.1012373,1.4774313,8.6380795,4.3576824,10.3724073,3.6830425,8.318747,1.1689257,20.7813473),(53739,'humerus.tif',232,2,103,10.1157601,10.80023,6.0532183,1.8,10.8438713,5.9318393,-1.1859305,2.0475138,5.1171173,8.7461089,45.6418475,1.4483218,8.9194452,4.2715751,10.6161532,3.6567971,8.3899427,1.1684008,20.8109802),(53740,'humerus.tif',232,2,104,10.4560548,10.7722042,6.0525445,1.8,10.8166168,5.9414746,-1.164656,2.0218221,5.1401948,8.4970293,47.9057048,1.4706832,9.3198229,4.2026593,10.9580729,3.6181555,8.4508514,1.1426068,20.961801),(53741,'humerus.tif',232,2,105,10.5601322,10.7245341,6.0100086,1.8,10.7744128,5.9003144,-1.14172,1.9667889,5.1634395,8.4344901,50.6883591,1.4553942,9.8167819,4.2884573,11.4214389,3.5611487,8.574694,1.1204591,21.0178607),(53742,'humerus.tif',232,2,106,10.9065312,10.6740449,6.0626775,1.8,10.726091,5.9460616,-1.1202571,1.9598897,5.2256388,8.3757253,54.035283,1.4730768,10.3404168,4.2735698,11.9295751,3.5109681,8.6604829,1.0923228,21.2060546),(53743,'humerus.tif',232,2,107,11.1987006,10.6435164,6.0925585,1.8,10.6993099,5.966111,-1.095528,1.9600793,5.2724214,8.364573,57.2392291,1.4756588,10.8563456,4.2674667,12.4256931,3.4838957,8.7782982,1.0746398,21.4625826),(53744,'humerus.tif',232,2,108,11.4662842,10.6428831,6.0541202,1.8,10.6966606,5.9377398,-1.0687709,1.9482906,5.2906037,8.3591011,60.9148182,1.468534,11.5137744,4.2904797,13.0804552,3.4532251,8.930291,1.0512071,22.240457),(53745,'humerus.tif',232,2,109,11.6666496,10.5956894,6.0126724,1.8,10.6613464,5.895806,-1.0482954,1.898396,5.3297757,8.4644373,63.9505867,1.4601788,11.9987387,4.4587312,13.5688479,3.4067627,9.0870218,1.0285707,22.9403789),(53746,'humerus.tif',232,2,110,11.33621,10.6316383,5.8953923,1.8,10.6790881,5.8218415,-1.0196327,1.8693363,5.2626054,8.3529646,66.8543508,1.3712288,12.7036603,4.4684118,14.2595203,3.3849758,9.2545194,0.9866178,26.0750971),(53747,'humerus.tif',232,2,111,10.7414845,10.69967,5.6964721,1.8,10.7636436,5.6032958,-0.9738588,1.7921542,5.106177,8.0603277,67.6043834,1.2245826,13.2397257,4.4975637,14.8049794,2.9549286,8.100402,0.8104626,19.5969021),(53748,'humerus.tif',232,2,112,10.7322891,10.7908671,5.5469849,1.8,10.8644372,5.4414447,-0.9308323,1.741593,4.9614171,7.8287426,71.1867027,1.150845,14.3480585,4.495162,15.9184015,2.9043684,8.2357004,0.7607456,20.7466302),(53749,'humerus.tif',232,2,113,11.0942301,10.9004928,5.4260699,1.8,10.9775444,5.3210885,-0.883361,1.7120346,4.8114967,7.6554099,78.5874239,1.1044995,16.3332596,4.4715275,17.8128119,2.8766975,8.3819338,0.7288547,21.7236448),(53750,'humerus.tif',232,2,114,11.0734824,10.9356899,5.4256302,1.8,11.0146257,5.3357586,-0.8426814,1.6861568,4.9337619,7.3238333,85.5414737,1.0282799,17.3379817,4.3435067,18.6632084,2.8243602,8.5739819,0.7090298,22.5156716),(53751,'humerus.tif',232,2,115,10.9583706,10.8632891,5.5321188,1.8,10.9401265,5.4373716,-0.8076797,1.7039206,4.920925,7.001201,92.2198911,0.953879,18.740357,4.1088775,19.9554495,2.7833475,8.7938761,0.6877714,22.304257),(53752,'humerus.tif',232,2,116,10.5774594,10.6550457,5.7901663,1.8,10.7590103,5.687054,-0.7828529,1.6889157,5.2666802,6.4557058,96.9648756,0.8769679,18.4110051,3.8223966,19.6120801,2.7604868,9.0475172,0.6830007,22.8584424),(53753,'humerus.tif',232,2,117,10.5370687,10.342167,6.1103708,1.8,10.4885779,5.9868533,-0.7618596,1.7009997,5.7383097,6.0535896,101.2732592,0.8367664,17.648622,3.5588422,18.7008729,2.7596695,9.3615496,0.6646295,25.2435912),(53754,'humerus.tif',232,2,118,10.8427007,10.1446965,6.3315687,1.8,10.2983527,6.2013871,-0.7442385,1.7088784,6.079158,5.8207536,113.2843608,0.829262,18.6348769,3.4061836,19.5895283,3.3315522,10.335797,0.8159563,28.9866764),(53755,'humerus.tif',232,2,119,10.895583,10.1952366,6.3073303,1.8,10.3548022,6.1663607,-0.7221293,1.7036189,6.0482265,5.9745136,124.4953421,0.7933797,20.5837764,3.5069543,21.5612822,3.3158359,10.4678674,0.8026378,29.4970764),(53756,'humerus.tif',232,2,120,10.51486,10.5377575,6.1010287,1.8,10.7466813,5.9385432,-0.680696,1.7008175,5.6888522,6.8027296,130.4084481,0.6940882,22.9235078,3.9996824,24.043374,3.3925312,10.6491547,0.7642149,31.0360167),(53757,'humerus.tif',232,2,121,11.694816,10.9643029,5.9613305,1.8,11.1184733,5.8323427,-0.620395,2.1713791,5.4830665,9.9935644,144.5388691,0.6587602,26.3609548,4.6024043,28.1463109,3.7889296,10.8836518,0.7397867,30.4140473),(53758,'humerus.tif',232,2,122,12.4293257,11.062137,5.8966569,1.8,11.1515757,5.8143675,-0.6039248,2.3231553,5.7705887,12.3717703,146.4695482,0.6680447,25.3820808,5.3254168,27.4918566,4.0694734,11.0446352,0.7343179,30.5307009),(53759,'humerus.tif',232,2,123,13.2661564,11.0932807,5.8845603,1.8,11.1267374,5.8459812,-0.5835976,2.4100086,5.920767,14.0554608,144.0124643,0.6713419,24.3232783,5.8321207,26.6754405,4.1879687,11.0445891,0.7036138,30.821396),(53760,'humerus.tif',232,2,124,13.9704995,10.9009199,5.9357748,1.8,10.9177863,5.917346,-0.5770706,2.3499589,5.8368647,15.697029,144.4908295,0.6930486,24.7548703,6.6797035,27.3904444,4.206657,11.0319131,0.6932573,29.9468826),(53761,'humerus.tif',232,2,125,14.9828507,10.8236202,6.0082435,1.8,10.7970526,6.0130939,-0.5762261,2.664397,5.8687848,16.4563127,143.9068505,0.7413415,24.5207237,6.1763741,27.3233186,4.1956504,10.9278805,0.4662586,29.4706496),(53762,'humerus.tif',232,2,126,15.4966965,10.6419289,6.1337926,1.8,10.608102,6.1437665,-0.5663768,2.2529024,5.7193621,15.9557199,137.1305518,0.7436247,23.9765465,7.0822953,26.7661815,4.0322807,10.9138102,0.4701835,28.971196),(53763,'humerus.tif',232,2,127,14.9080486,10.5098352,6.2315298,1.8,10.4932024,6.2323087,-0.5642821,2.1538238,5.5527736,13.8932012,121.6660811,0.7106692,21.9108665,6.4504819,24.4091958,4.0649353,10.7315413,0.4889082,28.3988741),(53764,'humerus.tif',232,2,128,13.5149551,10.378485,6.3112788,1.8,10.3478622,6.3171412,-0.5691282,2.1606605,5.2555158,10.4258857,109.8294083,0.6541483,20.8979313,4.8253233,22.8646131,4.0021275,10.3348124,0.5743048,28.0926985),(53765,'humerus.tif',232,2,129,11.118975,9.9625533,6.4756407,1.8,9.9409945,6.4782845,-0.5660725,2.0082586,5.0661309,6.4895039,88.9402527,0.5330448,17.5558536,3.2314085,18.8276745,3.6854346,5.6218264,0.6242072,16.5994023),(53766,'humerus.tif',232,2,130,6.9669034,8.8798576,7.0875554,1.8,9.0243271,7.0008237,-0.5856354,1.7722998,5.7006327,3.2839566,27.3399173,0.3547423,4.7959444,1.8529351,5.3682273,3.3516341,5.0083001,0.5721029,15.2641364),(53767,'humerus.tif',232,2,131,3.8157783,8.8798601,7.0188697,1.8,8.756116,7.1182162,-0.6930862,1.4946666,2.8355344,1.4140212,4.298111,0.2596075,1.5158028,0.9460446,1.9897299,2.6309284,3.0890337,0.6166481,10.5485706),(53768,'humerus.tif',232,2,132,1.3121728,9.2222293,6.684252,1.8,9.2286207,6.689835,0.9420453,1.4582523,1.0514198,0.103906,0.2981591,0.1430481,0.2835776,0.0712538,0.2588174,1.0827219,2.1375381,2.2292217,5.2742853),(53769,'humerus.tif',232,2,133,0.0347087,8.9896538,6.7130253,1.8,8.9936734,6.7134614,0.9297957,0.0900166,0.2667894,0.0000635,0.0005975,0.0037161,0.0022396,0.0007053,0.0024765,0.2030104,0.5679634,2.2367656,1.2212683),(53770,'humerus.tif',232,2,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53771,'humerus.tif',232,2,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53772,'humerus.tif',232,2,136,0.0003302,8.4854001,7.0818001,1.8,8.4854001,7.0818001,0.7853982,6.28e-16,6.28e-16,0.000000028,0.000000028,0.0000275,44579046.0281098,44579046.0339562,63044291.4947414,0.0319,0.0451134,2.3561945,0.0902268),(53773,'humerus.tif',232,2,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53774,'humerus.tif',232,2,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53775,'humerus.tif',232,2,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53776,'humerus.tif',232,2,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53777,'radius.tif',232,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53778,'radius.tif',232,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53779,'radius.tif',232,3,3,1.7175814,3.1072142,5.0048768,1.8,3.1312315,5.0224463,-0.9264701,0.7477715,1.3709188,0.1905444,0.7754846,0.1829819,0.5656677,0.2548163,0.6783166,1.7138343,2.9853274,1.3451951,9.202983),(53780,'radius.tif',232,3,4,3.0151207,3.4790893,5.2830937,1.8,3.4200624,5.3710815,-0.798478,1.4377964,2.2715702,0.824618,3.6374813,0.2578322,1.601307,0.5735291,1.9317232,2.7816326,4.9354732,1.1633665,13.893094),(53781,'radius.tif',232,3,5,3.7702145,3.6633791,5.6407347,1.8,3.595232,5.7301683,-0.7097201,1.7463433,2.5256114,1.4259067,6.2901451,0.2668122,2.4905435,0.81651,3.0188753,3.2801953,5.7740223,1.3458551,16.6848071),(53782,'radius.tif',232,3,6,3.8268255,3.5879255,5.8941293,1.8,3.5640342,5.9086239,-0.7321894,1.8462973,2.5772569,1.7776212,7.1828132,0.2850294,2.7869993,0.9628034,3.4765172,3.3286877,6.260295,1.3479952,17.4384134),(53783,'radius.tif',232,3,7,4.0821483,3.622798,5.9210919,1.8,3.6390391,5.8909247,-0.7857125,1.7901992,2.670678,1.6839717,7.9357178,0.3403929,2.9714244,0.9406617,3.5882302,3.0542878,6.3073655,1.1748417,17.3825297),(53784,'radius.tif',232,3,8,3.9988971,3.6384329,5.8858024,1.8,3.6690436,5.8311593,-0.7504025,1.7015923,2.7440616,1.323512,7.4557464,0.3099364,2.7170477,0.7778079,3.1921177,2.9220642,5.8701584,1.0708011,16.2473263),(53785,'radius.tif',232,3,9,3.7931739,3.7820455,5.6858331,1.8,3.8134326,5.6401825,-0.669248,1.5682957,2.5881565,1.0821743,6.4876227,0.2433268,2.5066578,0.6900321,2.9230596,2.7160652,5.4657221,1.0094218,14.3932382),(53786,'radius.tif',232,3,10,3.870306,3.8660462,5.5716719,1.8,3.9114355,5.5447839,-0.6205959,1.3522309,2.5711085,1.0088299,6.2083206,0.218134,2.4146474,0.7460486,2.8052947,2.4408705,5.3041066,0.8426603,13.6695595),(53787,'radius.tif',232,3,11,4.1267043,3.9872584,5.5693568,1.8,4.0365112,5.5525091,-0.573212,1.1936819,2.5896261,0.8842663,6.6870259,0.2022949,2.582236,0.7407889,2.9236309,2.2598259,5.2963796,0.7662922,14.4626814),(53788,'radius.tif',232,3,12,4.439766,4.0628527,5.6016062,1.8,4.1156156,5.5738454,-0.5632999,1.0790925,2.623287,0.7980087,7.6459582,0.2109878,2.9146479,0.7395184,3.0840516,2.1796729,5.2621166,0.7725784,13.6204557),(53789,'radius.tif',232,3,13,4.5386556,4.1733105,5.6228983,1.8,4.2073403,5.5943497,-0.5595503,1.0076334,2.5962634,0.7740605,8.8675198,0.2131308,3.4154932,0.7681966,3.7127824,2.2598259,5.2828303,0.6958943,13.6743536),(53790,'radius.tif',232,3,14,4.7096063,4.2362492,5.709834,1.8,4.2628115,5.692649,-0.5574039,1.0162748,2.7965444,0.8217005,9.930515,0.2196443,3.550995,0.8085417,3.7735242,2.057108,5.3866823,0.6913369,13.7649588),(53791,'radius.tif',232,3,15,4.9641787,4.2402236,5.843586,1.8,4.2645007,5.8322328,-0.5536974,1.0617661,2.801823,1.0007995,10.8131283,0.2287686,3.8593188,0.94258,4.1985953,2.1499837,5.5061595,0.6192424,15.0235034),(53792,'radius.tif',232,3,16,5.4396675,4.2398398,5.9554932,1.8,4.2512601,5.9544181,-0.5497766,1.1245351,2.9002546,1.4433374,13.0258279,0.2475074,4.4912705,1.2834969,4.9549154,2.4374811,5.7169974,0.6134601,15.8262134),(53793,'radius.tif',232,3,17,6.1360798,4.0813108,6.1524864,1.8,4.1088211,6.1473144,-0.5222387,1.4116256,3.2081272,2.4461945,16.6003313,0.2544664,5.1744617,1.7328918,5.8757673,2.9628629,6.0473298,0.5661243,17.4895029),(53794,'radius.tif',232,3,18,7.0335315,4.0742072,6.3799691,1.8,4.0565854,6.3957609,-0.5522199,1.9044686,3.4177658,4.4831514,19.9652789,0.3225842,5.841617,2.354017,7.1044854,3.7453735,6.52248,0.5981442,19.9439286),(53795,'radius.tif',232,3,19,8.7316183,4.0466591,6.6451456,1.8,4.030377,6.6757659,-0.5933227,2.4239514,3.6686988,9.256221,25.64683,0.4549376,6.9907156,3.8186495,9.4339895,4.501548,6.9988568,0.5766609,21.7517212),(53796,'radius.tif',232,3,20,10.0943132,4.1190259,6.9979268,1.8,4.1208572,7.0253263,-0.7757401,2.696781,3.9914256,11.4033769,31.3850627,0.8249451,7.8631211,4.2285142,10.7182299,4.6612286,7.136639,0.6287963,22.3308968),(53797,'radius.tif',232,3,21,9.3811387,4.2095922,6.7891058,1.8,4.1901255,6.8299894,-0.7410661,2.2871251,3.8198332,5.9560213,30.9610313,0.7125382,8.1053359,2.6041519,9.6638335,3.9592052,6.9741062,0.6544446,21.1976791),(53798,'radius.tif',232,3,22,7.204027,4.7217089,6.20967,1.8,4.6815189,6.2435006,-0.6505838,1.953561,3.1548327,2.970237,18.5559977,0.440422,5.8817692,1.520422,6.8177007,3.3709443,5.9072505,0.7454195,17.7014635),(53799,'radius.tif',232,3,23,6.1716554,5.0880987,5.8597076,1.8,5.0580843,5.8857553,-0.5651333,1.833415,2.7014393,2.1865157,13.87007,0.2949956,5.134326,1.1925918,5.904569,3.0985008,5.1639138,0.2046418,16.3590935),(53800,'radius.tif',232,3,24,5.9603931,5.2092882,5.7340901,1.8,5.1735359,5.7779621,-0.4870231,1.794411,2.5873088,2.3077769,13.7435468,0.2175756,5.3119081,1.2860916,5.5101925,3.1148325,5.2948759,0.1903285,16.5566719),(53801,'radius.tif',232,3,25,6.9246353,5.0472361,5.8040925,1.8,4.989336,5.8518181,-0.4124768,1.9600293,2.7989126,3.1646412,17.0887553,0.18547,6.105498,1.6145887,6.6043242,3.3246961,5.6101357,0.1022067,17.7641269),(53802,'radius.tif',232,3,26,7.7936784,4.815227,5.854697,1.8,4.7416988,5.9203252,-0.3114011,2.0886786,3.023533,4.7280326,22.6792229,0.1219405,7.5009015,2.2636478,8.0538489,3.8889744,6.2099374,0.0537942,20.3650415),(53803,'radius.tif',232,3,27,9.1351605,4.489936,6.0083692,1.8,4.4419102,6.091402,-0.2907519,2.548607,3.3921474,6.5053702,31.8099381,0.1251231,9.3775224,2.55252,10.9372127,4.3951266,6.790125,0.0703065,23.6964145),(53804,'radius.tif',232,3,28,10.3241636,4.4336865,6.1126281,1.8,4.3887558,6.1642417,-0.2571215,2.450489,3.4538481,7.6469953,35.8969168,0.1112727,10.3933109,3.1205998,11.9912399,4.3704245,7.402672,0.1683266,23.1336069),(53805,'radius.tif',232,3,29,2.8086126,4.3167229,8.1857576,1.8,4.3001989,8.2196909,-0.1477111,2.4440966,1.7516622,0.5643661,2.5513322,0.0101393,1.4565207,0.2309099,1.2738322,2.1416753,3.5184756,0.2745753,12.4110149),(53806,'radius.tif',232,3,30,7.0950151,4.2386567,9.2606562,1.8,4.2621489,9.201868,1.3913625,1.9274363,1.9000123,4.9513772,5.6456684,1.1448369,2.9713851,2.5688927,5.0239391,3.5087671,3.8373767,0.6086893,12.571886),(53807,'radius.tif',232,3,31,4.3602873,4.3354436,9.3580286,1.8,4.3258576,9.2716405,-0.3162813,2.1136032,1.6941403,3.0192134,3.0887996,0.0703042,1.8232253,1.4284675,2.6548275,3.1818952,3.5557841,1.4497691,11.3201212),(53808,'radius.tif',232,3,32,3.2556686,4.3719798,9.3514526,1.8,4.3828666,9.2908104,-1.2835144,1.6930948,1.7857188,1.8135566,2.5812901,0.4990477,1.4455188,1.0711489,2.0445086,2.7372767,3.3583398,1.3706153,10.3872902),(53809,'radius.tif',232,3,33,3.3191827,4.2350468,9.2396973,1.8,4.245194,9.2046124,-1.479337,1.3229036,1.6538243,1.6661412,2.5933375,0.5485826,1.5680852,1.2594577,2.3545537,2.6146652,3.2312771,1.4226363,9.9941192),(53810,'radius.tif',232,3,34,3.8003036,3.9480722,9.1194444,1.8,3.9332203,9.1013112,1.287448,1.2901894,1.840796,1.9865998,3.5536003,0.5838783,1.9304693,1.5397737,2.9999871,2.6096764,3.5317072,1.8583722,10.4200261),(53811,'radius.tif',232,3,35,4.0743672,3.7817384,9.1505126,1.8,3.7448386,9.1054041,1.1312096,1.3687876,2.1083646,2.4387466,4.2695843,0.5560791,2.0250693,1.7816838,3.1478148,2.7519869,3.8260946,2.1968428,11.2690317),(53812,'radius.tif',232,3,36,4.2287318,3.7663462,9.1986183,1.8,3.7085484,9.1533765,1.0564114,1.4644069,2.2873233,2.507153,4.9397828,0.5341851,2.1596347,1.7120603,3.2452054,2.7657571,4.0485735,2.1718701,11.6458348),(53813,'radius.tif',232,3,37,4.6517955,3.7267793,9.2388904,1.8,3.6730089,9.197273,0.9559961,1.4302062,2.2539523,2.6476812,5.5488309,0.5173627,2.4618227,1.8512584,3.6364874,2.7076428,4.0905056,2.1232153,11.8597811),(53814,'radius.tif',232,3,38,5.2376531,3.6956773,9.2184689,1.8,3.6362695,9.1843981,0.9225329,1.3909898,2.1321199,2.415487,6.1687607,0.5546866,2.8932523,1.7365238,4.0257775,2.5566864,4.1157362,2.1330811,11.617893),(53815,'radius.tif',232,3,39,5.8177697,3.7295717,9.348466,1.8,3.7032588,9.3326756,0.8741604,1.2320246,2.0509208,2.0000789,6.0665525,0.5704292,2.9579653,1.6234083,3.922804,2.4114835,4.1190518,2.065522,11.5456414),(53816,'radius.tif',232,3,40,4.2049937,4.1781931,9.8528378,1.8,4.1588685,9.8562836,1.2501114,1.1816759,1.9489571,1.2811987,2.5027457,0.6311965,1.2841461,1.0842217,1.7185981,2.1552018,3.1059761,1.7561443,9.4448711),(53817,'radius.tif',232,3,41,3.685495,4.3485226,10.0187461,1.8,4.3469394,10.0213109,1.5343458,1.0425719,1.4790785,0.9220435,1.8172648,0.6134334,1.2286466,0.8843932,1.8515575,2.0821665,2.8718992,1.4876551,8.5004663),(53818,'radius.tif',232,3,42,3.565016,4.4607431,10.1528583,1.8,4.4614634,10.1573433,-1.5016146,1.0022108,1.4562057,0.7770494,1.719561,0.5913301,1.1808503,0.7753353,1.6967906,1.9605462,2.9186573,1.3734008,8.3819192),(53819,'radius.tif',232,3,43,3.5246484,4.5566654,10.2523156,1.8,4.5571446,10.2537498,-1.4521416,0.9336755,1.4495839,0.7066457,1.7296175,0.5792096,1.193182,0.756843,1.6798648,1.8602863,2.9411775,1.4243121,8.151605),(53820,'radius.tif',232,3,44,3.591389,4.6360361,10.3282117,1.8,4.6368515,10.3296147,-1.4368528,0.9143014,1.473656,0.6922389,1.8132459,0.5878901,1.2304404,0.7571233,1.6991524,1.8125866,2.9883744,1.4266419,8.2470042),(53821,'radius.tif',232,3,45,3.6005465,4.712374,10.3977572,1.8,4.7138428,10.3952755,-1.4212402,0.9273932,1.5313879,0.6799676,1.8720136,0.5867686,1.2224294,0.7332031,1.6643996,1.8125866,3.0898182,1.4157996,8.3376095),(53822,'radius.tif',232,3,46,3.691108,4.7889039,10.4482186,1.8,4.7896012,10.4433873,-1.437537,0.9109101,1.5313303,0.7045587,2.0164983,0.6043247,1.3168278,0.7734668,1.7745031,1.8125866,3.0898182,1.4157996,8.291314),(53823,'radius.tif',232,3,47,3.8117915,4.8596824,10.4982614,1.8,4.8597616,10.4928074,-1.4510336,0.9448173,1.5791976,0.748095,2.1990531,0.6262299,1.3925129,0.7917881,1.8633256,1.8602863,3.1841079,1.4204249,8.5727178),(53824,'radius.tif',232,3,48,3.9018707,4.9282705,10.5416024,1.8,4.9278262,10.5337609,-1.4585621,0.9595935,1.620546,0.7848471,2.3850695,0.6421545,1.4717691,0.8178954,1.9522201,1.8602863,3.2857407,1.4104209,8.6729112),(53825,'radius.tif',232,3,49,4.0450654,4.9975764,10.5797593,1.8,4.9971524,10.5703978,-1.4759533,0.9795177,1.6919468,0.8497838,2.5930184,0.6681314,1.532565,0.8675533,2.0136707,1.9079859,3.3607102,1.4570043,9.1239516),(53826,'radius.tif',232,3,50,4.1698765,5.0649136,10.602004,1.8,5.0643844,10.5870776,-1.4990007,1.0134258,1.7282069,0.918805,2.8480059,0.6914032,1.6479543,0.9066327,2.1691705,1.9556856,3.4270795,1.4170888,9.1894233),(53827,'radius.tif',232,3,51,4.298701,5.1341158,10.6346675,1.8,5.1361278,10.6200989,-1.5186008,1.0303167,1.8513349,0.9873864,3.1419637,0.7145001,1.6971341,0.958333,2.2205979,2.0033852,3.5378222,1.5033313,9.5450645),(53828,'radius.tif',232,3,52,4.4638675,5.2053642,10.6635745,1.8,5.2081519,10.6423338,-1.5366815,1.043404,1.9299511,1.090344,3.4700635,0.7431124,1.7980059,1.0449874,2.3541236,2.0824834,3.6330102,1.5051015,9.8081146),(53829,'radius.tif',232,3,53,4.525489,5.2763848,10.6949149,1.8,5.2824021,10.6759527,-1.5544907,1.0728045,1.9659159,1.172191,3.7705526,0.7540476,1.9179623,1.0926417,2.4912366,2.1304846,3.692643,1.4672717,10.0779446),(53830,'radius.tif',232,3,54,4.6313139,5.3420079,10.715866,1.8,5.3468488,10.69781,1.5608024,1.0948409,2.037285,1.2695378,4.2131138,0.7718086,2.0680041,1.1595637,2.6685907,2.1592585,3.8400439,1.6828253,10.1501961),(53831,'radius.tif',232,3,55,4.7754324,5.4084766,10.7439976,1.8,5.4125891,10.7362127,1.5340302,1.117273,2.0724646,1.3737134,4.6932536,0.79483,2.264576,1.2295235,2.9097703,2.2097843,3.982278,1.6788081,10.5780888),(53832,'radius.tif',232,3,56,5.1122384,5.4750804,10.7876656,1.8,5.4815784,10.7852206,1.5042003,1.1308924,2.1200153,1.4950415,5.2343674,0.8482665,2.4690234,1.3220016,3.1678068,2.1930352,4.129809,1.6865555,10.7804613),(53833,'radius.tif',232,3,57,5.2637846,5.5354687,10.8186868,1.8,5.5470332,10.8312752,1.4826204,1.1511495,2.1460526,1.6446178,5.7970487,0.8704941,2.7012613,1.4286744,3.4676003,2.2494676,4.2623847,1.660443,11.2690317),(53834,'radius.tif',232,3,58,5.623074,5.6068851,10.8513033,1.8,5.63407,10.8769102,1.4594779,1.261676,2.2227285,1.8504201,6.5857572,0.9256136,2.9629157,1.4666366,3.7930636,2.3903934,4.401052,1.646737,11.7017184),(53835,'radius.tif',232,3,59,5.7726561,5.664936,10.828412,1.8,5.7069076,10.8662428,1.430141,1.4356756,2.3060933,2.0711263,7.1440359,0.9432002,3.0978955,1.4426144,3.9951077,2.4702531,4.5377386,1.6233794,12.4996344),(53836,'radius.tif',232,3,60,6.0577257,5.6908026,10.8353533,1.8,5.725231,10.8778389,1.4203501,1.3687119,2.377703,2.1102883,8.0090961,0.986941,3.3684174,1.541806,4.2553408,2.5789591,4.6818608,1.7242202,13.9489776),(53837,'radius.tif',232,3,61,6.3608651,5.7241384,10.8260031,1.8,5.7520689,10.8630505,1.3932188,1.3598244,2.4131283,2.1903099,8.7978051,1.0270637,3.6458092,1.6107299,4.5526746,2.3299353,4.7616101,1.762298,12.7694644),(53838,'radius.tif',232,3,62,6.4695577,5.7568653,10.7665954,1.8,5.7879515,10.7872438,1.3811234,1.494485,2.3890908,2.2249505,9.0547877,1.0399313,3.7900559,1.488774,4.713973,2.2858695,4.7996846,1.7506498,12.6509173),(53839,'radius.tif',232,3,63,6.4957814,5.7820445,10.7165729,1.8,5.8044382,10.7263164,1.3624694,1.699643,2.3891158,2.128139,9.095756,1.0363198,3.8071641,1.2521094,4.6883054,2.2651442,4.7909067,1.7916251,12.7694644),(53840,'radius.tif',232,3,64,6.5937384,5.8094591,10.6536676,1.8,5.8245827,10.6658423,1.3379988,1.5551289,2.3871866,2.0333179,8.9812053,1.040467,3.7622552,1.3074915,4.6066617,2.2421324,4.752762,1.7524452,12.5950337),(53841,'radius.tif',232,3,65,6.566966,5.8327364,10.5845782,1.8,5.8442806,10.5790298,1.3264893,1.1712098,2.3240677,1.9889197,8.8287366,1.0304578,3.7988294,1.6981754,4.6481025,2.2346374,4.6307982,1.7782926,12.2298045),(53842,'radius.tif',232,3,66,6.5410693,5.8513755,10.4947692,1.8,5.8597877,10.475765,1.3191415,1.1857289,2.297523,1.961835,8.6458205,1.0225823,3.7631051,1.6545393,4.5872345,2.2496222,4.6049311,1.8007008,12.2529522),(53843,'radius.tif',232,3,67,6.4379014,5.8522798,10.3819699,1.8,5.8602076,10.3632073,1.3262705,1.1929681,2.3058549,1.9624013,8.2472706,1.0100954,3.5766651,1.6449738,4.3790371,2.279138,4.5744436,1.7702369,12.1228313),(53844,'radius.tif',232,3,68,6.3515301,5.8491796,10.2638743,1.8,5.8540168,10.2369021,1.3346395,1.2198911,2.3416687,1.9804381,8.0073325,1.0006402,3.4194984,1.6234548,4.2619988,2.3123697,4.6157883,1.886011,11.9088849),(53845,'radius.tif',232,3,69,6.2375205,5.8428424,10.1539488,1.8,5.8481249,10.1252143,1.3456772,1.2437945,2.3017586,2.0167597,7.5871624,0.9877859,3.296246,1.6214573,4.1719384,2.3630969,4.6012239,1.9089389,11.9088849),(53846,'radius.tif',232,3,70,6.1337839,5.8397713,10.0466766,1.8,5.844765,10.01707,1.3615483,1.2467448,2.2490236,2.0533369,7.2656016,0.9781858,3.2305582,1.6469585,4.1381063,2.3849824,4.495423,1.9059689,11.8366334),(53847,'radius.tif',232,3,71,5.9940218,5.8383628,9.957269,1.8,5.843607,9.927275,1.3769573,1.2562941,2.2653309,2.0757345,6.8673733,0.9619353,3.03151,1.6522679,3.9473044,2.4261755,4.4819906,1.8622531,11.7017184),(53848,'radius.tif',232,3,72,5.8884266,5.8332815,9.8705208,1.8,5.8361183,9.8388972,1.3941599,1.2854731,2.2564827,2.1127197,6.528243,0.9511013,2.8931057,1.6435347,3.8257949,2.4667858,4.4309354,1.8209969,11.4993459),(53849,'radius.tif',232,3,73,5.8197173,5.8309727,9.790587,1.8,5.8356522,9.757742,1.4073597,1.3112552,2.2253982,2.1573936,6.3192748,0.9442738,2.8396153,1.6452889,3.8074257,2.5280814,4.3618453,1.8025132,11.482978),(53850,'radius.tif',232,3,74,5.7241081,5.8273184,9.7213288,1.8,5.8301231,9.6885135,1.4259624,1.3111783,2.2112492,2.2031314,6.0927848,0.9341453,2.7553588,1.6802684,3.7514856,2.5280814,4.2924384,1.8292513,11.4877721),(53851,'radius.tif',232,3,75,5.6569215,5.8186231,9.6467898,1.8,5.8217507,9.6133906,1.4496777,1.3224478,2.2182136,2.2173527,5.9017919,0.9290568,2.6606058,1.6767033,3.6598725,2.5267759,4.2581121,1.7967555,11.2806055),(53852,'radius.tif',232,3,76,5.5897951,5.8181616,9.5736605,1.8,5.8212219,9.5353114,1.4676553,1.3205839,2.2830421,2.2334755,5.7677944,0.9217568,2.5263636,1.6912788,3.503951,2.5280814,4.2844801,1.7725587,11.4039466),(53853,'radius.tif',232,3,77,5.5960892,5.8135503,9.5117321,1.8,5.8186937,9.4798687,1.4861377,1.347572,2.2133335,2.2899942,5.5882575,0.9260129,2.524815,1.6993484,3.5559731,2.575781,4.1641001,1.7434778,11.1456906),(53854,'radius.tif',232,3,78,5.6543963,5.8141328,9.4473442,1.8,5.8201867,9.4102766,1.5010643,1.3468776,2.2079117,2.3629625,5.6019783,0.9378243,2.5372293,1.7544003,3.6051105,2.5965724,4.1910595,1.7771202,11.0319376),(53855,'radius.tif',232,3,79,5.7586477,5.8051992,9.3919898,1.8,5.8103118,9.3575497,1.5151503,1.3858524,2.1931254,2.4651293,5.5740164,0.9568058,2.5415858,1.7787821,3.665593,2.6451846,4.117118,1.7454685,11.0550853),(53856,'radius.tif',232,3,80,5.7838554,5.7980339,9.3416314,1.8,5.8053934,9.3100596,1.5369419,1.3727417,2.1402661,2.5192155,5.5305821,0.9628715,2.5840628,1.8351708,3.7611189,2.6610157,4.0701526,1.7475052,11.1456906),(53857,'radius.tif',232,3,81,5.8628396,5.7876314,9.2833793,1.8,5.7958585,9.2475269,1.5696685,1.3995522,2.1285024,2.5842844,5.5581667,0.9771387,2.6113039,1.8465081,3.8238526,2.6850156,4.0149959,1.7378981,11.2015742),(53858,'radius.tif',232,3,82,5.917337,5.7773602,9.2278579,1.8,5.7893892,9.1955559,-1.5404711,1.3846768,2.9603554,2.6556659,5.6053867,0.9853162,1.8934844,1.9178959,2.6682295,2.6668083,3.9762743,1.7517228,11.1504846),(53859,'radius.tif',232,3,83,6.0070298,5.7685774,9.1781822,1.8,5.7847467,9.1516327,-1.5130914,1.4101716,2.0365508,2.7514203,5.6754797,0.9978416,2.7868097,1.9511245,4.1231318,2.7062517,3.891543,1.7681919,11.1900003),(53860,'radius.tif',232,3,84,6.1131988,5.7630182,9.1058164,1.8,5.7889726,9.0550282,-1.4711551,1.400581,2.7488977,2.8497237,5.9441728,1.0087842,2.1623842,2.0346725,3.1021097,2.71888,3.9058411,1.0743736,12.0437999),(53861,'radius.tif',232,3,85,6.2646403,5.7675149,9.0398982,1.8,5.816237,8.9747635,-1.4183746,1.4104995,2.8644548,3.019734,6.2328902,1.0200369,2.1759429,2.1408969,3.1664162,2.7598755,3.8447811,1.770625,12.6740651),(53862,'radius.tif',232,3,86,6.3209361,5.748614,8.9968313,1.8,5.7918725,8.9417491,-1.409569,1.4108416,2.884694,3.1006367,6.2756366,1.0263411,2.1754947,2.1977213,3.17838,2.7907113,3.8613153,1.0960994,12.2741142),(53863,'radius.tif',232,3,87,6.3406257,5.7304216,8.9473468,1.8,5.7704422,8.8928399,-1.4020526,1.4366357,2.154216,3.143143,6.273696,1.0269645,2.9122873,2.1878498,4.0751656,2.8054909,3.8616099,1.1237218,12.0437999),(53864,'radius.tif',232,3,88,6.3781296,5.7083482,8.9119354,1.8,5.7452892,8.8686452,-1.3980431,1.4153461,1.9788729,3.195416,6.2511165,1.0316115,3.1589277,2.2576923,4.7736384,2.8111032,3.792647,1.4573613,11.9599745),(53865,'radius.tif',232,3,89,6.3695757,5.6810606,8.8724921,1.8,5.7165048,8.8341088,-1.3987008,1.4371334,1.9671683,3.2554118,6.259481,1.030464,3.1819753,2.265212,4.8300079,2.8388556,3.7875443,1.4698745,11.9320327),(53866,'radius.tif',232,3,90,6.3503775,5.6540361,8.8210588,1.8,5.6885565,8.7829074,-1.3996597,1.4653718,1.9989471,3.3115873,6.3100801,1.0276997,3.1567019,2.2598956,4.7496823,2.8801722,3.8350043,1.4711277,11.8482073),(53867,'radius.tif',232,3,91,6.2786132,5.6220164,8.7815761,1.8,5.651798,8.7534804,-1.3997614,1.4352538,1.9898642,3.3432284,6.2299369,1.0161215,3.1308353,2.3293639,4.8109623,2.8633635,3.8456686,1.4464413,11.8086916),(53868,'radius.tif',232,3,92,6.2416638,5.5905271,8.7401598,1.8,5.6156019,8.7171069,-1.3925491,1.4498333,1.9753636,3.4051166,6.247015,1.0075741,3.1624633,2.3486263,4.7843965,2.8941347,3.8355975,1.2018368,11.5436557),(53869,'radius.tif',232,3,93,6.1978536,5.5568812,8.7025572,1.8,5.5807017,8.684166,-1.388989,1.4642371,1.975575,3.4626731,6.2498569,0.9992063,3.1635634,2.3648308,4.8450015,2.9151454,3.8293639,1.3318599,11.6901445),(53870,'radius.tif',232,3,94,6.1459934,5.5257289,8.6557097,1.8,5.5478483,8.6339061,-1.3911044,1.4813961,1.9642068,3.5037936,6.3563263,0.9916118,3.2360779,2.365197,4.954997,2.9506125,3.8293639,1.3318599,11.7971177),(53871,'radius.tif',232,3,95,6.1539736,5.4960451,8.6065903,1.8,5.5181392,8.5814433,-1.396079,1.4867749,3.1160452,3.6024076,6.5283824,0.99467,2.0950859,2.4229678,3.1501475,2.9618065,3.8447811,1.3709677,12.0948895),(53872,'radius.tif',232,3,96,6.1712941,5.4718202,8.5510828,1.8,5.502678,8.5192658,-1.3821192,1.5013417,1.9608734,3.7640662,6.6961752,0.9923661,3.4148941,2.5071348,5.0531998,2.9881021,3.9348596,1.0366138,12.8764376),(53873,'radius.tif',232,3,97,6.1027207,5.4218171,8.5294938,1.8,5.4395867,8.5065528,-1.4217908,1.4676033,2.3948742,3.8286832,6.6570255,0.994704,2.7796973,2.6087997,4.0924885,2.9571037,3.8824701,1.4723502,12.0765358),(53874,'radius.tif',232,3,98,6.0840055,5.3899134,8.5069587,1.8,5.4113383,8.4963064,-1.4691987,1.5061837,2.88086,4.0385442,6.7685593,1.0035703,2.3494926,2.6813092,3.4243464,3.0078097,3.9046759,1.1290032,12.3810874),(53875,'radius.tif',232,3,99,6.0424931,5.344609,8.464215,1.8,5.3630629,8.4502136,-1.4692582,2.0176731,1.9487486,4.2053581,6.7071646,0.9967348,3.4417803,2.0842613,5.3410807,0.1430989,0.2133193,2.677945,0.5001442),(53876,'radius.tif',232,3,100,5.9555661,5.2815405,8.4221566,1.8,5.2921312,8.4051777,-1.5037826,1.5212633,1.9806345,4.182357,6.7489116,0.9881434,3.4074493,2.7492657,5.3948178,3.0527775,3.9038017,1.1016843,12.4601187),(53877,'radius.tif',232,3,101,5.9062784,5.2234315,8.3881522,1.8,5.2341721,8.3737053,-1.5491551,1.574687,2.0135201,4.3031653,6.7671214,0.9839188,3.3608412,2.7327116,5.3216327,3.1004772,4.0104598,1.1018296,13.3023445),(53878,'radius.tif',232,3,102,5.8496776,5.1642143,8.3675982,1.8,5.1786671,8.3544001,-1.5591576,1.5633164,2.0331555,4.3964956,6.8196855,0.9748142,3.354237,2.8122878,5.3348278,3.1004772,4.0319608,1.1177303,13.0836041),(53879,'radius.tif',232,3,103,5.7902989,5.1051745,8.3542966,1.8,5.1277204,8.3545683,1.5580218,1.6963245,1.9975662,4.5573527,6.8637719,0.9648923,3.4360673,2.6866043,4.847025,3.1481768,3.9383275,1.7658166,12.4437508),(53880,'radius.tif',232,3,104,5.7581257,5.0288094,8.3116124,1.8,5.0524948,8.2982065,1.5605393,2.0764937,2.0384061,4.7615586,6.874811,0.9595866,3.3726405,2.2930764,5.1551282,3.1958765,4.0036461,1.8360034,12.2577463),(53881,'radius.tif',232,3,105,5.7014134,4.951648,8.2865796,1.8,4.9727212,8.2754291,1.5419302,2.1813509,2.0214744,4.9377731,6.9293345,0.949444,3.4278617,2.2636307,5.0447694,3.2524285,4.0838254,1.8186078,12.2461724),(53882,'radius.tif',232,3,106,5.6992478,4.8758712,8.2627847,1.8,4.891746,8.2518105,1.5652531,1.8081929,2.0407786,5.1546175,7.1087312,0.9498455,3.4833426,2.8507011,5.1195288,3.3012984,4.1079895,1.7932436,14.0954664),(53883,'radius.tif',232,3,107,5.5564149,4.8060407,8.2346694,1.8,4.8177806,8.2239269,-1.5421212,1.7925036,2.0768444,5.2996948,7.1844253,0.9253079,3.4592988,2.956588,5.0774597,3.3470337,4.1829084,1.6965657,12.8880114),(53884,'radius.tif',232,3,108,5.4919112,4.7305047,8.1928783,1.8,4.7431506,8.1860837,-1.5347427,1.808272,2.1637176,5.4730262,7.4527645,0.9141293,3.4444257,3.026661,5.1998819,3.4343747,4.3193869,1.6814535,12.9554689),(53885,'radius.tif',232,3,109,5.518894,4.64341,8.1559814,1.8,4.6571783,8.1351858,-1.5116308,1.9157109,2.1948007,5.7535724,7.9574211,0.9165996,3.6255779,3.0033616,5.3592678,3.5108698,4.4319622,1.7111713,13.3206982),(53886,'radius.tif',232,3,110,5.5661554,4.5444276,8.1317225,1.8,4.5486092,8.1133684,-1.5158819,1.9395502,2.2190856,6.1148245,8.4379953,0.9248978,3.802465,3.1527023,5.4305183,3.5902183,4.5404955,1.7290367,13.5789543),(53887,'radius.tif',232,3,111,5.6523774,4.4520373,8.0661731,1.8,4.4573251,8.0414053,-1.5022089,1.9580732,2.2836425,6.6073337,9.1201175,0.9376382,3.9936712,3.3744058,5.9744491,3.7053602,4.6209612,1.7053942,14.281471),(53888,'radius.tif',232,3,112,5.4573024,4.3474111,8.0425874,1.8,4.3534178,8.0196756,-1.4487582,2.0823168,2.3682685,6.91465,9.14868,0.8960713,3.8630249,3.3206523,5.8715201,3.7867061,4.7628045,1.7013624,14.281471),(53889,'radius.tif',232,3,113,5.5803827,4.259542,7.9988773,1.8,4.2625528,7.9911391,-1.3383539,2.0538054,2.4727193,7.5934505,9.764685,0.8807114,3.9489663,3.697259,6.145013,3.8255137,4.9361647,1.6675804,14.7257316),(53890,'radius.tif',232,3,114,6.1022523,4.1513249,7.857519,1.8,4.1398007,7.8527293,-1.2378998,2.0955199,2.5266774,8.637363,10.5756113,0.9084358,4.1855803,4.1218233,7.2036893,3.9316501,5.0642562,1.6273398,15.2817594),(53891,'radius.tif',232,3,115,5.9075097,4.0432798,7.7871885,1.8,4.0244593,7.769102,-1.0113033,2.0296729,2.7174241,8.5079585,11.216737,0.7072249,4.1277094,4.191788,6.5000164,4.0365135,5.0617846,1.6179312,15.9283925),(53892,'radius.tif',232,3,116,6.0488353,3.9885888,7.6361158,1.8,3.9377755,7.589747,-0.9887578,2.1090363,2.4718863,8.9519424,11.7888394,0.7034787,4.7691674,4.2445654,7.8503802,4.1546496,5.2132465,1.4975332,16.2425322),(53893,'radius.tif',232,3,117,7.7830534,3.7607492,7.3797741,1.8,3.7563563,7.4155197,-0.9806385,2.4066822,2.6400083,10.3117989,13.7842668,0.8954617,5.2212967,4.2846534,8.5548007,4.2301672,5.2780906,1.4621351,16.2752681),(53894,'radius.tif',232,3,118,8.3369169,3.8840053,7.4111712,1.8,3.9183559,7.4853567,-0.860682,2.190854,2.6695225,9.7454107,15.4770179,0.7989541,5.7976728,4.4482245,9.4384056,4.2872496,5.1832643,1.4601391,17.1965252),(53895,'radius.tif',232,3,119,8.7308585,3.7910481,7.3868805,1.8,3.8005556,7.4121326,-1.0926741,2.2335576,2.6809766,8.8147952,16.3353825,1.1470838,6.0930717,3.9465269,9.3505812,4.0518559,5.0911415,1.3439975,16.3822413),(53896,'radius.tif',232,3,120,6.0796285,3.6095417,7.8036619,1.8,3.5868036,7.753233,-0.5950478,1.7742316,2.2574478,3.0080774,6.8575268,0.3183845,3.0377344,1.6954254,3.9741532,3.0285618,4.1902451,0.3974181,16.0074239),(53897,'radius.tif',232,3,121,2.8517583,2.9807298,8.4070149,1.8,2.9473897,8.3787797,0.2762438,0.9962199,1.3030834,0.6514158,1.0436713,0.0353567,0.8009244,0.6538875,1.2615464,1.9791856,2.5598318,2.677945,8.1679729),(53898,'radius.tif',232,3,122,2.1130419,2.9972172,8.44772,1.8,2.9777794,8.4330735,0.3010391,0.7924403,1.2003979,0.2652335,0.5958716,0.030963,0.4963951,0.3347047,0.7170952,1.589406,2.3739862,2.7498927,6.9672977),(53899,'radius.tif',232,3,123,1.1329358,2.8078123,8.376744,1.8,2.8012364,8.3772508,0.4465962,0.5470178,0.9254189,0.0646874,0.2034481,0.0352222,0.2198443,0.1182546,0.2716214,1.1014533,1.8815683,2.6098686,5.0389723),(53900,'radius.tif',232,3,124,0.056788,2.5028864,8.4402648,1.8,2.5026416,8.4444278,0.6195162,0.1732938,0.3494859,0.0004312,0.0011932,0.003191,0.0034141,0.0024883,0.004617,0.3843117,0.6200954,2.7468015,1.9331195),(53901,'radius.tif',232,3,125,6.0099983,4.2886295,6.3113775,1.8,4.2474939,6.3401828,-1.0497864,1.7527981,2.8503271,2.664722,13.205885,0.7534922,4.6331122,1.5202675,5.4391556,2.890517,7.3908293,1.159125,24.2081326),(53902,'radius.tif',232,3,126,4.6900478,4.4013619,5.6142184,1.8,4.3562728,5.6245315,-0.6518017,2.0420745,3.3888049,0.9899498,9.4912827,0.2876465,2.8007758,0.4847765,3.0843687,5.3294343,7.5289933,1.0021235,32.9225453),(53903,'radius.tif',232,3,127,0.0428366,4.2071896,4.2395897,1.8,4.1196597,4.2818385,-0.4614652,0.1483356,1.5685564,0.0001747,0.005411,0.0014154,0.0034496,0.0011777,0.0035563,2.7672661,4.715515,3.0097096,13.4420535),(53904,'radius.tif',232,3,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53905,'radius.tif',232,3,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53906,'radius.tif',232,3,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53907,'radius.tif',232,3,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53908,'radius.tif',232,3,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53909,'radius.tif',232,3,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53910,'radius.tif',232,3,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53911,'ulna.tif',232,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53912,'ulna.tif',232,4,2,0.0008282,3.2912758,3.8636715,1.8,3.2912758,3.8636715,0.7853982,0,0,0.0000002,0.0000002,0.000069,0,0,0,0.0476996,0.0674575,2.3561945,0.134915),(53913,'ulna.tif',232,4,3,2.13043,3.1604153,4.7869128,1.8,3.1832052,4.7864202,-1.0898707,0.8914432,1.6105152,0.272152,1.1897626,0.2790868,0.7387466,0.3052937,0.9032359,1.7138343,2.9853274,1.3451951,9.202983),(53914,'ulna.tif',232,4,4,5.1391392,3.5718682,4.5473124,1.8,3.5244194,4.6579199,-1.1574486,1.4443137,2.9850902,2.2876529,7.3165414,0.7183277,2.4510286,1.583903,3.2105405,2.7816326,4.9354732,1.1633665,13.893094),(53915,'ulna.tif',232,4,5,6.547213,3.7246044,4.600741,1.8,3.6586166,4.7477221,-1.2710185,1.6947454,3.4175636,5.0913101,14.5482211,0.9960419,4.2568984,3.0041741,5.7018741,3.2801953,5.7740223,1.3458551,16.6848071),(53916,'ulna.tif',232,4,6,6.1288873,3.7390518,4.8129947,1.8,3.6936685,4.9027694,-1.237621,1.7252181,3.4552325,5.3136099,18.1975011,0.9122249,5.2666502,3.0799641,6.7319796,3.3286877,6.260295,1.3479952,17.4384134),(53917,'ulna.tif',232,4,7,6.1609021,3.8656307,4.9992564,1.8,3.8527233,5.0218117,-1.1135687,1.6307688,3.5063949,4.0180352,18.3285378,0.8267018,5.2271745,2.4638902,6.3636759,3.0542878,6.3073655,1.1748417,17.3825297),(53918,'ulna.tif',232,4,8,5.7625654,3.8992592,5.1264592,1.8,3.9177997,5.099394,-1.0094359,2.1909537,3.1901662,3.0611347,15.4569666,0.6882576,4.8451917,1.3971699,5.8047265,2.9220642,5.8701584,1.0708011,16.2473263),(53919,'ulna.tif',232,4,9,5.1794417,4.0216932,5.1162437,1.8,4.0367054,5.0873677,-0.8927826,1.3400764,3.0240494,2.2015487,11.5703429,0.5236077,3.8261091,1.6428531,4.5539307,2.7160652,5.4657221,1.0094218,14.3932382),(53920,'ulna.tif',232,4,10,5.0452744,4.1120194,5.1286458,1.8,4.1380692,5.1231251,-0.8000023,1.2773196,2.9246493,1.6897599,10.2616703,0.4327181,3.508684,1.3228952,4.0861731,2.4408705,5.3041066,0.8426603,13.6695595),(53921,'ulna.tif',232,4,11,5.1596157,4.2213246,5.2041129,1.8,4.2482831,5.2089341,-0.7319365,1.1990969,2.9145616,1.4234562,10.2907374,0.3840819,3.5308011,1.1871069,4.0180972,2.2598259,5.2963796,0.7662922,14.4626814),(53922,'ulna.tif',232,4,12,5.3133725,4.2748141,5.3020115,1.8,4.309434,5.2906956,-0.6906854,1.149387,3.038563,1.2368244,11.0131018,0.3594077,3.6244441,1.076073,3.946201,2.1796729,5.2621166,0.7725784,13.6204557),(53923,'ulna.tif',232,4,13,5.3683948,4.3729377,5.3408163,1.8,4.3914043,5.3256346,-0.6717527,1.1781173,2.8794067,1.2193611,12.0636873,0.3465572,4.1896434,1.0350082,4.6128225,2.2598259,5.2828303,0.6958943,13.7022954),(53924,'ulna.tif',232,4,14,5.4614705,4.421169,5.4478251,1.8,4.4300925,5.4496931,-0.6620773,1.1180026,3.0310921,1.2691796,13.1004757,0.344005,4.3220315,1.1352206,4.6046406,2.057108,5.3866823,0.6913369,13.7929006),(53925,'ulna.tif',232,4,15,5.6871433,4.4197185,5.5882599,1.8,4.426451,5.5929908,-0.6592063,1.1991671,3.1138519,1.4881416,14.3656154,0.3555825,4.6134549,1.2409794,4.7789077,2.1499837,5.5061595,0.6192424,15.0514452),(53926,'ulna.tif',232,4,16,6.1520757,4.4176515,5.7075399,1.8,4.4189553,5.7146467,-0.6530021,1.2637391,2.9284382,1.9859665,16.9373126,0.378502,5.7837358,1.5715004,6.2652994,2.4374811,5.7169974,0.6134601,15.8541552),(53927,'ulna.tif',232,4,17,6.8713925,4.2451068,5.9194592,1.8,4.2548537,5.9238377,-0.616877,1.5037379,3.0343453,3.1452737,21.7137637,0.3832535,7.1559964,2.0916369,7.9715733,2.9628629,6.0473298,0.5661243,17.5174447),(53928,'ulna.tif',232,4,18,8.1685595,4.0671919,6.1796823,1.8,4.0324747,6.21058,-0.5778663,1.9373623,3.3702905,6.1111776,28.7597829,0.4062168,8.5333245,3.1543804,10.0700823,3.7453735,6.52248,0.5981442,19.9439286),(53929,'ulna.tif',232,4,19,9.5949024,4.1177053,6.4749919,1.8,4.0798743,6.5221996,-0.6663673,2.4385957,3.6401491,10.1684404,34.0761492,0.6110198,9.3611961,4.1697935,11.9380685,4.501548,6.9988568,0.5766609,21.7517212),(53930,'ulna.tif',232,4,20,10.7967331,4.2047593,6.8311698,1.8,4.1873248,6.8775061,-0.8205995,2.662739,3.9339787,11.950405,39.8186554,0.9630188,10.1217262,4.4880122,13.0621109,4.6612286,7.136639,0.6287963,22.3308968),(53931,'ulna.tif',232,4,21,9.9424289,4.3248231,6.6239834,1.8,4.2941615,6.6794575,-0.7858607,2.2782585,3.717176,6.2446258,37.3845802,0.8293022,10.0572533,2.7409646,11.6230134,3.9592052,6.9741062,0.6544446,21.1976791),(53932,'ulna.tif',232,4,22,7.7350216,4.8311809,6.0505905,1.8,4.7837897,6.0954607,-0.7104844,1.9876499,2.9860279,3.3087529,22.1561132,0.5483695,7.4199284,1.6646557,8.4798138,3.3709443,5.9072505,0.7454195,17.7014635),(53933,'ulna.tif',232,4,23,6.6898892,5.1884225,5.7085208,1.8,5.1541649,5.7410541,-0.635095,1.9013205,2.5461577,2.5763657,16.1498443,0.392418,6.3428295,1.3550402,6.7504206,3.0985008,5.1639138,0.2046418,16.3590935),(53934,'ulna.tif',232,4,24,6.480426,5.3100584,5.5885457,1.8,5.2735132,5.6341327,-0.5583914,1.8799264,2.6433382,2.758618,15.6784778,0.3031888,5.9313173,1.4674075,6.161439,3.1148325,5.2948759,0.1903285,16.5566719),(53935,'ulna.tif',232,4,25,7.46199,5.1592844,5.6740338,1.8,5.1044851,5.7227248,-0.4787067,2.0428556,2.7319532,3.7041525,19.5027284,0.2638827,7.138749,1.8132228,7.3848064,3.3246961,5.6101357,0.1022067,17.7641269),(53936,'ulna.tif',232,4,26,8.3796062,4.9510148,5.7314072,1.8,4.8786111,5.7986834,-0.3751366,2.1833429,2.9879592,5.4147465,25.9326414,0.1874919,8.679048,2.4800257,8.9605824,3.8889744,6.2099374,0.0537942,20.3650415),(53937,'ulna.tif',232,4,27,9.8765437,4.6320602,5.8780812,1.8,4.5736144,5.9607826,-0.3359425,2.6683877,3.3797644,7.5347578,37.6262409,0.1788892,11.1328,2.8237118,12.4056335,4.3951266,6.790125,0.0703065,23.6964145),(53938,'ulna.tif',232,4,28,11.9355568,4.3721056,5.9885003,1.8,4.3007726,6.0402385,-0.2602946,2.5903387,3.7401937,9.6461512,51.4176431,0.1317624,13.747321,3.7238957,16.2855892,4.3704245,7.402672,0.1683266,23.1336069),(53939,'ulna.tif',232,4,29,11.1540836,4.5272966,5.8427546,1.8,4.5051464,5.8775215,-0.258399,2.4463486,4.0492085,6.9748086,48.745014,0.1213883,12.0381587,2.8511099,13.7503353,4.0225589,7.7186521,0.2689621,21.8519146),(53940,'ulna.tif',232,4,30,9.3017812,5.2379602,5.6774335,1.8,5.1830615,5.7249382,-0.3628683,2.2859087,3.6941039,5.4541203,25.9825406,0.1953291,7.0335164,2.3859747,8.2167352,3.6801523,6.7829169,0.2125668,18.9436401),(53941,'ulna.tif',232,4,31,8.5585664,5.5494126,5.558634,1.8,5.4868376,5.6074214,-0.4251142,1.7672662,4.4207907,4.3096953,18.5884879,0.2426271,4.204788,2.4386226,5.1343398,3.1264457,5.8318551,0.2648173,15.9447605),(53942,'ulna.tif',232,4,32,8.4652292,5.7016628,5.4557438,1.8,5.6513042,5.4751574,-0.4013518,1.4092418,2.7295145,3.7278303,16.0452723,0.2153239,5.8784345,2.6452737,7.1579219,2.6681851,5.3553345,0.307667,14.3537225),(53943,'ulna.tif',232,4,33,8.5693273,5.8116147,5.3722313,1.8,5.7798382,5.3808499,-0.3542227,1.381145,2.7407958,3.3374233,14.633285,0.1718333,5.3390643,2.4164178,6.5493823,2.6182462,5.2499959,0.3045109,14.0675246),(53944,'ulna.tif',232,4,34,8.3340856,5.9406987,5.2848564,1.8,5.9125112,5.2905168,-0.2957936,1.386724,2.7001574,3.0891433,12.8514829,0.1180269,4.759531,2.2276555,5.9019026,2.6031237,5.1040853,0.2744486,13.4324654),(53945,'ulna.tif',232,4,35,7.9208378,6.0694601,5.2193698,1.8,6.0529201,5.2223984,-0.2527705,1.4258561,2.665613,2.9341763,11.0795176,0.0825664,4.1564614,2.0578347,5.2399369,2.7050398,4.9772475,0.212432,13.0836041),(53946,'ulna.tif',232,4,36,7.66146,6.171705,5.1850223,1.8,6.1504557,5.1906818,-0.2203477,1.4535373,2.6388757,2.8406173,10.0023759,0.061001,3.790393,1.9542789,4.8641598,2.7081645,4.8480305,0.2282738,12.690433),(53947,'ulna.tif',232,4,37,7.3338143,6.2588987,5.1787877,1.8,6.2426778,5.1859767,-0.2063722,1.4500709,2.5397141,2.6914267,8.9797557,0.0513224,3.5357349,1.8560655,4.5952753,2.6665214,4.677485,0.2053954,12.6345494),(53948,'ulna.tif',232,4,38,7.2394887,6.2980897,5.1969766,1.8,6.2801718,5.2054738,-0.2100456,1.4343247,2.4708998,2.6757909,8.6229063,0.0524551,3.4897839,1.8655406,4.569971,2.6287371,4.5841323,0.2096398,12.5902397),(53949,'ulna.tif',232,4,39,7.0552279,6.3070801,5.2488459,1.8,6.2919528,5.2554933,-0.2087287,1.3914924,2.395497,2.6068082,8.2682755,0.0504903,3.4515909,1.8733902,4.5396157,2.5498201,4.5234259,0.2449787,12.1228313),(53950,'ulna.tif',232,4,40,6.8400031,6.3182401,5.3147046,1.8,6.3077763,5.3206003,-0.2240301,1.3667044,2.2981185,2.5246374,7.9911332,0.0562652,3.4772503,1.8472447,4.5711485,2.4995967,4.4193667,0.2397431,11.9436066),(53951,'ulna.tif',232,4,41,6.7389854,6.3198657,5.3678294,1.8,6.3074885,5.3756312,-0.2314557,1.3762484,2.2293096,2.5724013,7.6887553,0.059103,3.4489401,1.8691402,4.5828361,2.4897926,4.3618453,0.2317168,11.8318393),(53952,'ulna.tif',232,4,42,6.5729766,6.3329467,5.4131983,1.8,6.3236302,5.4192492,-0.2390288,1.3953805,2.1369471,2.5813431,7.2543811,0.0614079,3.3947405,1.8499205,4.5715237,2.5282838,4.2690519,0.2368488,11.7759557),(53953,'ulna.tif',232,4,43,6.4054992,6.3335705,5.4685615,1.8,6.3242463,5.4757598,-0.2460123,1.4066432,2.0654879,2.575143,6.8824733,0.0633193,3.3321296,1.830701,4.5156212,2.5741539,4.1910595,0.2063239,11.5783773),(53954,'ulna.tif',232,4,44,6.2572136,6.3379347,5.5251921,1.8,6.3294575,5.5323927,-0.2651961,1.4073082,2.0786636,2.5454983,6.5893644,0.0716406,3.1700003,1.808771,4.3801985,2.5914616,4.1300845,0.2449787,11.6294669),(53955,'ulna.tif',232,4,45,6.1342099,6.3437939,5.5752311,1.8,6.3384156,5.5855161,-0.2903694,1.3770937,2.031602,2.4974458,6.2335116,0.0838048,3.068274,1.8135627,4.2882816,2.5760748,4.0036461,0.2652071,11.4107265),(53956,'ulna.tif',232,4,46,6.1345825,6.3405105,5.6223441,1.8,6.3356683,5.6331099,-0.3189056,1.3675661,2.0524818,2.5367634,6.0831471,0.1005044,2.9638008,1.8549475,4.1926505,2.5789821,3.9705481,0.2799498,11.461816),(53957,'ulna.tif',232,4,47,6.0833506,6.329738,5.6620884,1.8,6.3268702,5.6711363,-0.3464616,1.3243002,2.0499556,2.5276018,5.9666741,0.1169108,2.9106358,1.908632,4.1314342,2.6108466,3.8991363,0.2598144,11.3153272),(53958,'ulna.tif',232,4,48,6.0608777,6.3210445,5.6945172,1.8,6.3189691,5.702966,-0.3627347,1.3149922,2.0657043,2.5265903,5.8643601,0.1271834,2.8389155,1.9213728,4.0620285,2.5862006,3.8789523,0.2867454,11.4666101),(53959,'ulna.tif',232,4,49,6.0045969,6.3064232,5.7293032,1.8,6.3039695,5.7383045,-0.3704791,1.2885376,2.0819498,2.5160492,5.6747124,0.1311894,2.725672,1.9526393,3.9278572,2.5938874,3.8409326,0.2510027,11.2410899),(53960,'ulna.tif',232,4,50,5.9682137,6.2857144,5.7699237,1.8,6.282874,5.7792041,-0.384837,1.2725669,2.0473603,2.5147193,5.5501643,0.1401846,2.7108879,1.9761,3.9208402,2.5766681,3.8474431,0.7503248,11.0714533),(53961,'ulna.tif',232,4,51,5.9505976,6.2660793,5.8122055,1.8,6.2637684,5.8222689,-0.4004608,1.5320675,2.0729107,2.5470503,5.3817218,0.150726,2.596215,1.6624922,3.8239611,2.6094506,3.8293639,0.6883588,11.094601),(53962,'ulna.tif',232,4,52,5.8347192,6.2462796,5.8463643,1.8,6.2430443,5.8516215,-0.3978847,1.303045,2.0163241,2.4521685,5.1503123,0.1459967,2.5543078,1.8818755,3.7645398,2.5908945,3.7694796,0.6688122,11.0435114),(53963,'ulna.tif',232,4,53,5.7759479,6.223586,5.8827206,1.8,6.2196669,5.8901009,-0.4032123,1.324805,1.9642887,2.4023133,4.9154899,0.1482091,2.5024274,1.8133335,3.7124411,2.6049844,3.7024884,0.6666928,10.9433181),(53964,'ulna.tif',232,4,54,5.7068638,6.1935282,5.9203423,1.8,6.1920161,5.9268793,-0.4044121,1.3109332,1.9506147,2.3546997,4.6953372,0.1472611,2.4071065,1.7962011,3.6129182,2.5865579,3.6840066,0.721266,10.9317442),(53965,'ulna.tif',232,4,55,5.6557482,6.1570847,5.9552701,1.8,6.1538215,5.9625978,-0.4118641,1.319392,1.8727238,2.3153503,4.4356262,0.1510601,2.3685426,1.7548615,3.6048725,2.5934127,3.5493795,0.71883,10.5780888),(53966,'ulna.tif',232,4,56,5.5880097,6.1285765,5.9831821,1.8,6.1250089,5.9878791,-0.4155304,1.3156848,1.8664456,2.2680104,4.2126341,0.1517645,2.2570356,1.7238251,3.471632,2.5918349,3.5599408,0.614019,10.6012366),(53967,'ulna.tif',232,4,57,5.5679696,6.1004348,6.0159534,1.8,6.0950456,6.021443,-0.4146303,1.3148279,1.8425002,2.2389744,4.0301037,0.1506038,2.1873016,1.7028649,3.4020567,2.5947123,3.4938161,0.5614937,10.4595418),(53968,'ulna.tif',232,4,58,5.5137291,6.0801139,6.0418624,1.8,6.0757519,6.0485521,-0.4116189,1.3376758,1.7950562,2.2007671,3.8802793,0.1471015,2.1616478,1.6452172,3.3795467,2.591586,3.4663568,0.5994525,10.3477746),(53969,'ulna.tif',232,4,59,5.4802324,6.0612656,6.0616989,1.8,6.0601198,6.06741,-0.4049512,1.3139158,1.7959359,2.1386215,3.7533708,0.1417694,2.0899247,1.6276701,3.2799602,2.5639907,3.4439675,0.637961,10.2523753),(53970,'ulna.tif',232,4,60,5.4085714,6.0395407,6.0763893,1.8,6.034238,6.0825513,-0.3969166,1.3281744,1.7708033,2.0851568,3.5938395,0.1347107,2.0294967,1.569942,3.2013546,2.5573522,3.403095,0.5452272,10.156976),(53971,'ulna.tif',232,4,61,5.3518354,6.0135759,6.0890772,1.8,6.0092888,6.0956419,-0.3860116,1.3256455,1.7624627,2.0349812,3.4454071,0.1264367,1.9548823,1.535087,3.1087732,2.5530171,3.3786035,0.5331557,9.9198819),(53972,'ulna.tif',232,4,62,5.3351591,5.9858502,6.1020289,1.8,5.9826157,6.1088961,-0.3770621,1.3239202,1.7482474,2.0225774,3.3084405,0.1205428,1.8924326,1.5277185,3.0466628,2.5350905,3.3311298,0.5084893,9.8244826),(53973,'ulna.tif',232,4,63,5.2380867,5.9581685,6.1035639,1.8,5.9540091,6.1116931,-0.3367187,1.3136022,1.6939571,1.9609777,3.1176126,0.0952972,1.8404318,1.4928246,2.9960627,2.5391621,3.2662942,0.5028432,9.9102938),(53974,'ulna.tif',232,4,64,5.1537508,5.9276016,6.1043778,1.8,5.9243706,6.1123162,-0.283969,1.2885073,1.6587541,1.9233606,2.958911,0.0674231,1.7838153,1.4927045,2.9367766,2.5431584,3.1830358,0.5172874,9.8755721),(53975,'ulna.tif',232,4,65,5.0944089,5.889218,6.1057188,1.8,5.8862115,6.1102797,-0.2315769,1.2863286,1.5981185,1.9050519,2.7858943,0.0447256,1.7432339,1.4809995,2.9145168,2.5500345,3.119134,0.4089078,9.5498585),(53976,'ulna.tif',232,4,66,5.0098941,5.8583776,6.1031831,1.8,5.8544133,6.1077862,-0.1534903,1.2656959,1.5822927,1.8208602,2.6612105,0.0195176,1.6818699,1.4386238,2.8130221,2.5319247,3.0754254,0.4150747,9.4660331),(53977,'ulna.tif',232,4,67,4.9156354,5.8304773,6.1009128,1.8,5.8279905,6.1081512,-0.0714854,1.2230857,1.5790864,1.73675,2.5342142,0.0041795,1.6048611,1.4199741,2.6893112,2.4803817,3.0337127,0.2869388,9.5614324),(53978,'ulna.tif',232,4,68,4.8209587,5.7969722,6.0920286,1.8,5.7943866,6.098663,0.0297389,1.219002,1.5428178,1.6654914,2.4424531,0.0007104,1.5831118,1.3662745,2.6351796,2.4287376,2.9654454,0.194241,9.0497143),(53979,'ulna.tif',232,4,69,4.7797854,5.7672444,6.0789859,1.8,5.7654616,6.0817264,0.1174818,1.2436857,1.4954093,1.6094604,2.3634565,0.0109446,1.5804746,1.2941054,2.5707979,2.4193967,2.9345947,0.1304033,9.1287457),(53980,'ulna.tif',232,4,70,4.7187399,5.740263,6.067538,1.8,5.7391195,6.068673,0.1982756,1.2286172,1.4597986,1.5559863,2.3339293,0.0305151,1.5988022,1.2664533,2.5418605,2.3685388,2.8873067,3.0090411,9.0776561),(53981,'ulna.tif',232,4,71,4.6039954,5.7086656,6.0615039,1.8,5.705189,6.0641409,0.2835696,1.2171588,1.4199496,1.4737936,2.2660499,0.0600663,1.5958665,1.2108474,2.4823361,2.3221273,2.8813904,3.025451,9.1403196),(53982,'ulna.tif',232,4,72,4.5301367,5.6823808,6.0527604,1.8,5.6800439,6.0574991,0.3403343,1.2030381,1.3960396,1.4009492,2.2091549,0.0841276,1.5824443,1.1645094,2.4323081,2.3041862,2.8576031,2.888517,8.8984314),(53983,'ulna.tif',232,4,73,4.4714516,5.6576055,6.0394694,1.8,5.6557027,6.0455807,0.3961793,1.1987579,1.4071486,1.328927,2.1513714,0.1109785,1.5288871,1.1085867,2.3872414,2.2768936,2.8623764,2.7301364,8.9774628),(53984,'ulna.tif',232,4,74,4.4041094,5.6344104,6.0197474,1.8,5.6315412,6.0245872,0.458023,1.1889137,1.4159354,1.2697022,2.1073003,0.1435148,1.4882744,1.0679515,2.2920881,2.2537887,2.8627738,2.9572682,9.0054046),(53985,'ulna.tif',232,4,75,4.3532164,5.6120035,5.9989301,1.8,5.611576,6.0054461,0.5039559,1.1741389,1.4432293,1.2183999,2.0826783,0.1691849,1.4430682,1.0376965,2.2452014,2.2234658,2.8718992,2.5812328,8.8030321),(53986,'ulna.tif',232,4,76,4.3622145,5.5888072,5.9753674,1.8,5.588192,5.9806153,0.5533669,1.1772424,1.4482849,1.2070049,2.0823074,0.2008128,1.4377747,1.0252816,2.2401595,2.2228817,2.8722953,2.5213432,8.6960589),(53987,'ulna.tif',232,4,77,4.3402011,5.5689537,5.9504058,1.8,5.5689514,5.9553302,0.6003149,1.1655344,1.4545015,1.1785773,2.0931551,0.230837,1.4390876,1.0111906,2.2206732,2.2234658,2.8829693,2.4616838,8.798238),(53988,'ulna.tif',232,4,78,4.3337525,5.5484838,5.924786,1.8,5.5457277,5.9301771,0.6462961,1.1649824,1.4499245,1.16791,2.0931203,0.2619647,1.4436064,1.002513,2.2161356,2.2333221,2.8766487,2.274027,8.7192067),(53989,'ulna.tif',232,4,79,4.3264845,5.538746,5.9030546,1.8,5.5421334,5.912739,0.6981095,1.172609,1.4634111,1.1565657,2.0825203,0.2979174,1.4230589,0.9863183,2.1814695,2.2598259,2.950446,2.5401379,8.8425478),(53990,'ulna.tif',232,4,80,4.2716924,5.5218149,5.8797758,1.8,5.5252522,5.8906376,0.7544788,1.200788,1.451131,1.140948,2.0342246,0.3339754,1.4018201,0.9501661,2.1701158,2.2719611,2.920216,2.4719537,8.5775119),(53991,'ulna.tif',232,4,81,4.1995801,5.5016406,5.8504546,1.8,5.5004074,5.8621297,0.8182058,1.1952853,1.4562421,1.1107695,1.9737223,0.3729116,1.3553532,0.9292924,2.1046116,2.2569378,2.8766487,2.274027,8.6681171),(53992,'ulna.tif',232,4,82,4.111218,5.4875535,5.8146996,1.8,5.4876788,5.8238686,0.8678905,1.1419275,1.4626586,1.0502078,1.9303093,0.3988694,1.3197265,0.9196799,2.0318775,2.1971386,2.8829693,2.4616838,8.8309739),(53993,'ulna.tif',232,4,83,4.0525263,5.4722422,5.7838163,1.8,5.4735285,5.7937941,0.902335,1.1506004,1.4397641,1.0271972,1.8805971,0.4159741,1.3061842,0.8927488,2.012582,2.2188101,2.8532206,2.2377045,8.6633231),(53994,'ulna.tif',232,4,84,3.9831167,5.4593202,5.7593321,1.8,5.4615973,5.7730289,0.9317915,1.1690081,1.9520574,0.9910209,1.8516878,0.4277275,0.9485826,0.8477451,1.4531793,2.2061594,2.907723,2.4258491,8.5890858),(53995,'ulna.tif',232,4,85,3.9376544,5.4603477,5.7314708,1.8,5.4787702,5.7496423,0.9288245,1.1103912,1.4412527,0.9658865,1.8200289,0.4209795,1.2628104,0.8698614,1.789906,2.13882,3.0171677,2.4569755,8.8589157),(53996,'ulna.tif',232,4,86,3.8719673,5.4544579,5.7105243,1.8,5.4777841,5.7317347,0.9597659,1.084337,1.4318354,0.9480031,1.7539441,0.4329213,1.224962,0.8742698,1.6957607,2.1269818,2.9803693,2.4468544,8.9263732),(53997,'ulna.tif',232,4,87,3.8000432,5.44824,5.6889521,1.8,5.4718824,5.7130448,0.9946726,1.0976441,1.9232167,0.923924,1.7341881,0.4453762,0.9017123,0.8417336,1.3450061,2.1128771,2.8829693,2.4616838,8.6122335),(53998,'ulna.tif',232,4,88,3.7491352,5.4380202,5.6612238,1.8,5.4590233,5.6805473,1.0134846,1.1458466,1.4377199,0.9036881,1.6535871,0.4500573,1.1501455,0.7886641,1.6554552,2.1041376,2.8718992,2.4149503,8.7076328),(53999,'ulna.tif',232,4,89,3.6827887,5.4350444,5.6396956,1.8,5.4570095,5.6589972,1.0410138,1.1634333,1.3917824,0.8737346,1.5878733,0.4570499,1.1408919,0.7509968,1.633748,2.08748,2.7731511,2.4292351,8.2633722),(54000,'ulna.tif',232,4,90,3.6518125,5.4335442,5.6169514,1.8,5.4574135,5.6353045,1.0349082,1.0973478,1.3874837,0.8580969,1.5535333,0.4499536,1.1196768,0.7819734,1.574499,2.0778104,2.9014564,2.3794461,9.1566875),(54001,'ulna.tif',232,4,91,3.5862082,5.4328245,5.5989813,1.8,5.4559145,5.6187102,1.0632247,1.1524625,1.3952165,0.8254289,1.4909399,0.4564939,1.0686083,0.7162306,1.5496313,2.0536335,2.8829693,2.2507052,9.4217234),(54002,'ulna.tif',232,4,92,3.5379775,5.4334591,5.5852756,1.8,5.4583699,5.6147278,1.064687,1.0270677,1.6705736,0.800049,1.4799761,0.4510864,0.885909,0.7789643,1.3578271,2.0546594,2.9940792,2.1057514,9.2800286),(54003,'ulna.tif',232,4,93,3.4688341,5.4257198,5.5553673,1.8,5.4449316,5.5757442,1.0637241,1.1008173,1.3577854,0.7908981,1.3918019,0.4417984,1.0250529,0.7184644,1.4608245,2.0742861,2.6617943,2.2035452,8.5842917),(54004,'ulna.tif',232,4,94,3.4079647,5.4275379,5.5320807,1.8,5.4480757,5.5539031,1.0573274,1.0961322,1.3258369,0.7728928,1.3643899,0.430949,1.0290782,0.7051091,1.4789852,2.0556819,2.712177,1.9872349,8.7635164),(54005,'ulna.tif',232,4,95,3.3024603,5.4291019,5.5058889,1.8,5.456528,5.5281352,1.0357674,1.1348835,1.2731031,0.7577385,1.3119253,0.4073237,1.0304941,0.6676796,1.4604999,2.0422772,2.6234807,2.4980915,8.6960589),(54006,'ulna.tif',232,4,96,3.2326654,5.4238901,5.4798349,1.8,5.4462798,5.5055654,1.0547674,1.1474289,1.3078485,0.7388511,1.2513542,0.4075996,0.9568037,0.6439189,1.4032064,2.0076784,2.6239143,2.0425738,8.1795468),(54007,'ulna.tif',232,4,97,3.2203007,5.4256156,5.4455458,1.8,5.456472,5.4727903,1.0059071,1.174869,1.4293253,0.7527673,1.2005318,0.3829099,0.839929,0.6407245,1.267292,2.0174208,2.6308421,2.7509856,8.798238),(54008,'ulna.tif',232,4,98,3.1660642,5.4092677,5.409196,1.8,5.4268811,5.4336654,1.0724673,1.1925387,1.362843,0.7329108,1.1467609,0.4071325,0.8414475,0.6145803,1.1773193,2.0122862,2.5009358,2.5324292,8.3096677),(54009,'ulna.tif',232,4,99,3.1662938,5.4099085,5.377618,1.8,5.4325423,5.4062171,1.1168323,1.0923177,1.2970547,0.7466528,1.1211949,0.4262307,0.864416,0.6835491,1.2786895,2.0574534,2.4702708,1.7454685,8.01669),(54010,'ulna.tif',232,4,100,3.1202863,5.4088381,5.3401932,1.8,5.43098,5.3666605,1.1645695,1.064611,1.304438,0.7487942,1.0946065,0.4388473,0.8391403,0.7033501,1.2664971,2.0439495,2.4619674,2.5213432,8.0793534),(54011,'ulna.tif',232,4,101,3.0848806,5.4059322,5.3018707,1.8,5.4279099,5.3278896,1.2181381,1.2975681,1.2007235,0.7686122,1.0624841,0.4528107,0.8848699,0.5923482,1.2831998,2.0702894,2.442017,1.7873466,7.8769809),(54012,'ulna.tif',232,4,102,3.0571903,5.403575,5.2720529,1.8,5.4253922,5.3008601,1.3485869,1.149484,1.2274083,0.7946614,1.0572913,0.4847839,0.8614015,0.6913201,1.2712566,2.111199,2.4322144,1.7681919,8.2026945),(54013,'ulna.tif',232,4,103,3.0779986,5.4101308,5.2389826,1.8,5.4360435,5.2716845,1.4036774,1.1150871,1.6530442,0.8478226,1.1026958,0.4988052,0.6670698,0.7603196,1.0463127,2.1548385,2.4624294,1.7263912,8.000322),(54014,'ulna.tif',232,4,104,3.0204567,5.4050288,5.1965328,1.8,5.4226177,5.2254305,-1.5608635,1.1808082,1.5187677,0.8752574,1.1214376,0.5033598,0.7383865,0.7412358,1.0658796,2.2093901,2.4702708,1.7454685,7.7863757),(54015,'ulna.tif',232,4,105,3.0211549,5.4144273,5.161016,1.8,5.4301244,5.1873976,-1.3860261,1.3243944,1.3457158,0.9551788,1.1978924,0.4865302,0.8901526,0.7212193,1.1835439,2.2862676,2.5095637,1.7234457,8.3212416),(54016,'ulna.tif',232,4,106,2.9468159,5.430573,5.0998293,1.8,5.4341956,5.1241324,-1.2231891,1.5433206,1.2973501,1.0213479,1.2626315,0.4341437,0.9732388,0.661786,1.2281321,2.2218027,2.5393064,1.6648576,8.000322),(54017,'ulna.tif',232,4,107,3.0411691,5.436953,5.0567199,1.8,5.4283206,5.0860786,-0.9198492,1.8069949,1.3413692,1.1917193,1.4388399,0.3207605,1.0726651,0.6595034,1.3905036,2.2598259,2.5973324,1.4418856,8.2306363),(54018,'ulna.tif',232,4,108,2.9385461,5.487514,4.9906565,1.8,5.4831623,5.025028,-1.0075292,1.7503961,1.3703844,1.2248001,1.5321662,0.3501257,1.1180558,0.6997274,1.4563605,2.3520278,2.6728833,1.5350972,8.6353813),(54019,'ulna.tif',232,4,109,3.0018593,5.5145925,4.9171351,1.8,5.5061797,4.9500991,-0.844256,1.8412177,1.4582405,1.3383511,1.7482277,0.2795342,1.1988611,0.7268836,1.6255308,2.3885678,2.8877006,0.3897086,9.32153),(54020,'ulna.tif',232,4,110,3.2643359,5.538917,4.8361766,1.8,5.5123779,4.880746,-0.7659578,1.8446092,1.9894601,1.5247369,2.1429695,0.261454,1.0771613,0.8265907,1.8043509,2.5095767,3.0081049,0.2565166,9.8101004),(54021,'ulna.tif',232,4,111,3.2995227,5.6248895,4.7145787,1.8,5.5988972,4.7584676,-0.7494454,1.2807436,1.6107848,1.6806784,2.2528521,0.2552061,1.3986052,1.3122677,2.372204,2.5902101,3.0898182,0.1549967,9.7194952),(54022,'ulna.tif',232,4,112,3.3322844,5.6475363,4.6345228,1.8,5.6446926,4.6748232,-0.7616695,2.053441,1.68801,1.9127095,2.5079475,0.2645169,1.485742,0.9314655,2.0663189,2.6645709,3.2732526,0.3263588,10.7640934),(54023,'ulna.tif',232,4,113,3.6855768,5.6768992,4.6036842,1.8,5.6684673,4.6446681,-0.7071125,1.9477121,1.7693456,2.2876016,3.0925329,0.2592397,1.7478399,1.1745071,2.6477311,2.7940272,3.4134423,0.9944211,11.4666101),(54024,'ulna.tif',232,4,114,4.6784829,5.7783389,4.5080494,1.8,5.7489158,4.5343887,-0.7131184,2.2852366,1.7218929,2.6900613,3.4903537,0.3337097,2.0270446,1.1771479,2.4617882,3.0665067,3.4518862,2.9469071,12.0621536),(54025,'ulna.tif',232,4,115,4.1777254,5.8088051,4.4914849,1.8,5.7831512,4.5399825,-0.4428995,1.9623197,1.6751163,2.3146819,3.0154769,0.1278833,1.8001597,1.1795642,2.7143036,2.8639578,3.3960676,0.1836223,11.1129547),(54026,'ulna.tif',232,4,116,3.2198341,5.8657709,4.5937846,1.8,5.8824304,4.6109229,-0.4780722,1.8587808,1.4805404,1.1382788,1.8919342,0.1135866,1.2778674,0.6123793,1.5893017,2.4668674,3.0126397,0.4069708,9.8380422),(54027,'ulna.tif',232,4,117,2.1212672,5.8233173,4.5955238,1.8,5.8266167,4.6020933,-0.3942989,1.6456374,1.0578624,0.4230327,0.5586964,0.052176,0.5281372,0.2570631,0.5911116,1.8125866,2.142771,0.293589,6.8766925),(54028,'ulna.tif',232,4,118,1.368408,5.7286419,4.4225751,1.8,5.7193936,4.4300888,-0.630448,0.7072965,0.8604698,0.1361783,0.2074894,0.0792578,0.241135,0.1925336,0.3990004,1.3939743,1.7343267,0.5498532,5.3088023),(54029,'ulna.tif',232,4,119,1.3787124,5.6416117,4.3040572,1.8,5.6395213,4.3131445,-0.5888763,1.0947604,0.8418998,0.168726,0.2437317,0.0708886,0.2895021,0.1541214,0.374359,1.4914796,1.7538947,0.390607,5.5111747),(54030,'ulna.tif',232,4,120,0.939597,5.6398751,4.3404881,1.8,5.6314063,4.3250944,-0.6009291,0.6154403,0.7076338,0.075537,0.0924787,0.0500629,0.1306872,0.1227365,0.2152981,1.2142348,1.506131,0.1911845,4.6410072),(54031,'ulna.tif',232,4,121,12.756372,4.0041743,4.540129,1.8,3.9722208,4.5299357,-1.490127,3.731654,4.8983544,29.289999,66.8088027,2.1122566,13.63903,7.8490661,19.4558691,3.1099782,6.87173,2.5940304,19.8581174),(54032,'ulna.tif',232,4,122,10.7044705,3.8824192,4.7130444,1.8,3.8360498,4.6071392,-1.5157155,3.5415549,4.5397261,22.5028059,58.6941054,1.7786712,12.9289969,6.353934,17.6627065,3.4929181,6.5501535,2.6974865,24.2428543),(54033,'ulna.tif',232,4,123,9.6144041,3.8402844,4.8820448,1.8,3.7968758,4.8884244,1.5371102,3.2853118,4.0678939,19.6286771,42.9323313,1.600583,10.5539458,5.974677,13.551572,2.0901771,3.9636657,0.8791397,14.1234082),(54034,'ulna.tif',232,4,124,9.4528645,4.0916189,4.8413865,1.8,4.0125416,4.8006437,1.1461256,3.1693045,4.3877652,17.968563,33.7804613,1.3080226,7.6987851,5.6695603,10.9345124,2.5034783,4.4157613,1.1119796,13.7350312),(54035,'ulna.tif',232,4,125,11.3679901,4.0746125,4.627907,1.8,4.0236095,4.6593969,1.4585041,3.1714422,3.8581324,24.5602266,49.3742654,1.8708744,12.7974524,7.7441824,16.5414933,2.890517,7.3908293,1.159125,24.2081326),(54036,'ulna.tif',232,4,126,10.7314965,4.4869406,4.0155202,1.8,4.4149132,4.0252975,-1.2507366,3.6404063,4.4855625,15.5765978,29.5177881,1.6115348,6.5806213,4.2788075,9.6670881,5.3294343,7.5289933,1.0021235,32.9225453),(54037,'ulna.tif',232,4,127,5.2849633,4.5442758,2.6486647,1.8,4.5502213,2.6375428,0.0409242,2.2875739,2.6886272,2.3054582,5.9307204,0.0014744,2.2058545,1.007818,2.8985611,2.7672661,4.715515,3.0097096,13.4420535),(54038,'ulna.tif',232,4,128,1.1135924,2.8468392,2.3150276,1.8,2.8240377,2.3174747,-0.1945372,0.445266,1.3670539,0.0411867,0.3874577,0.0069358,0.2834253,0.0924992,0.3133526,0.9194738,2.5819569,0.2046418,6.3534005),(54039,'ulna.tif',232,4,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54040,'ulna.tif',232,4,130,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54041,'ulna.tif',232,4,131,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54042,'ulna.tif',232,4,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54043,'ulna.tif',232,4,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54044,'ulna.tif',232,4,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54045,'metacarpal.tif',232,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54046,'metacarpal.tif',232,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54047,'metacarpal.tif',232,5,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54048,'metacarpal.tif',232,5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54049,'metacarpal.tif',232,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54050,'metacarpal.tif',232,5,6,0.0076235,3.3703793,9.1171848,1.8,3.3730715,9.1175145,0.097202,0.0348077,0.1268101,0.0000033,0.0000505,0.000012,0.0003981,0.0000952,0.0004238,0.0954,0.2901478,2.976444,0.62349),(54051,'metacarpal.tif',232,5,7,0.0868265,2.9985746,8.929496,1.8,3.0059086,8.9352613,-0.0626107,0.1396201,0.3737392,0.0003071,0.00295,0.0000567,0.0078931,0.0021995,0.0086809,0.2803106,0.7764998,0.1853479,1.7914379),(54052,'metacarpal.tif',232,5,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54053,'metacarpal.tif',232,5,9,0.3752957,3.6426923,8.3352741,1.8,3.6726843,8.3423201,-0.1571794,0.2098764,1.2430545,0.0023652,0.1244999,0.0015326,0.1001564,0.0112694,0.1020251,0.4144116,2.1422559,0.2017623,5.0206557),(54054,'metacarpal.tif',232,5,10,1.3387966,3.8615486,8.2862622,1.8,3.8653102,8.3005382,-0.157126,0.4456644,1.2599083,0.0504986,0.6548504,0.0054636,0.5197604,0.1133109,0.5399262,0.9041185,2.6493905,0.4072558,7.1445895),(54055,'metacarpal.tif',232,5,11,2.0746195,3.8803718,8.347641,1.8,3.8990303,8.3463988,-0.1557879,0.7633374,1.3526446,0.2305563,1.2559475,0.0083241,0.9285126,0.3020371,1.0278758,1.4314599,3.0516819,0.4356829,9.8688653),(54056,'metacarpal.tif',232,5,12,2.9443457,3.9249184,8.2932039,1.8,3.9395653,8.2912865,-0.2399931,1.0575601,1.4470966,0.8112712,1.8166244,0.0277256,1.2553581,0.7671159,1.7374837,1.9448433,3.3515828,0.4254496,10.2851872),(54057,'metacarpal.tif',232,5,13,3.7383918,3.9857407,8.200293,1.8,3.988667,8.1987188,-0.482392,1.3809309,1.6070019,1.5893634,2.0726119,0.1340854,1.2897383,1.1509362,2.2710767,2.4327001,3.561884,0.3556359,9.9758392),(54058,'metacarpal.tif',232,5,14,3.4526086,3.9297867,8.2237515,1.8,3.9363076,8.2056195,-1.0219049,1.4413013,2.1959467,1.5642017,1.6470403,0.4187931,0.7500365,1.0852704,1.4205668,2.6645906,3.551969,0.3854939,12.7551765),(54059,'metacarpal.tif',232,5,15,3.2858728,3.854844,8.0862023,1.8,3.8682807,8.058818,-1.0739735,1.3444356,2.4678604,1.1968194,2.4698557,0.4232309,1.0008085,0.8902021,1.396446,2.6119259,3.2968259,0.5478635,12.6741588),(54060,'metacarpal.tif',232,5,16,3.4513444,3.8131513,7.8563268,1.8,3.8625111,7.8311232,-0.8231429,1.7548623,2.8475568,1.0450035,3.411174,0.3093031,1.1979301,0.5954903,1.5528346,2.2900184,5.1252536,0.6732875,17.0761186),(54061,'metacarpal.tif',232,5,17,5.2043357,4.2197902,7.798333,1.8,4.2163469,7.7948499,-0.9600591,1.598025,2.7534501,2.7308203,5.8696188,0.5821313,2.1317324,1.7088721,3.1031121,3.028254,5.4480418,0.7048276,19.3070264),(54062,'metacarpal.tif',232,5,18,6.8267228,4.4067068,7.6498721,1.8,4.3803433,7.6648057,-1.2008679,1.6862859,2.6766651,3.525008,9.6680771,0.9890585,3.6119861,2.0903976,4.7301019,3.2343915,5.7843013,0.7095207,24.5040998),(54063,'metacarpal.tif',232,5,19,7.7479115,4.5771348,7.4888965,1.8,4.5504215,7.5260256,-1.1962665,1.7135049,3.0231694,3.8692701,14.5704595,1.1184947,4.8195975,2.2581027,5.8401871,2.8005711,5.314431,1.0750313,18.5110902),(54064,'metacarpal.tif',232,5,20,8.8921809,4.6465099,7.4077489,1.8,4.6181921,7.4375168,-1.207193,1.7448677,3.1581341,4.481871,18.7637781,1.2945787,5.9414127,2.5686021,7.0406581,2.866998,5.5449072,1.1918874,17.3902607),(54065,'metacarpal.tif',232,5,21,9.4003575,4.5982586,7.3698338,1.8,4.5930179,7.4068764,-1.1753786,1.8001484,3.2732292,4.8086563,19.667596,1.3342645,6.0086217,2.6712555,7.3022051,4.0864669,7.1938497,0.8369955,30.5481993),(54066,'metacarpal.tif',232,5,22,1.1261067,5.2547381,7.0906171,1.8,5.2410221,7.1105383,-0.9978967,1.2515759,1.6328999,0.1109182,1.6488851,0.1325351,1.0097894,0.0886228,1.0449484,0,0,0,0),(54067,'metacarpal.tif',232,5,23,3.6672165,5.1822331,7.0853112,1.8,5.1636309,7.1088745,-1.1232312,1.2720105,2.1573771,0.961751,4.2623001,0.4967297,1.9756862,0.7560873,2.291421,1.6695,2.2500046,2.5829933,7.2351954),(54068,'metacarpal.tif',232,5,24,5.6509359,5.0593186,7.059879,1.8,5.059958,7.0717265,-1.1699827,1.4225701,2.0145587,2.4683381,4.765668,0.7984483,2.3656138,1.7351258,3.3670325,2.7102222,3.8895249,1.1675148,11.964857),(54069,'metacarpal.tif',232,5,25,4.6701561,5.0705426,7.1095806,1.8,5.0810863,7.1015157,-1.0511926,1.5046668,1.9829713,2.4436072,4.2790395,0.5864563,2.1578928,1.6240188,3.2064996,2.7384793,3.9521977,1.1611502,11.841515),(54070,'metacarpal.tif',232,5,26,3.935148,5.1638887,7.1226391,1.8,5.157341,7.1063926,-0.956912,1.651726,2.0110192,1.9721248,4.0262273,0.4382246,2.002083,1.1939782,2.9423772,2.7013177,3.8895249,1.1675148,11.6950251),(54071,'metacarpal.tif',232,5,27,3.6209327,5.2562285,7.1819462,1.8,5.2411889,7.1716039,-0.8688005,1.4615346,2.0117582,1.5883701,3.7377158,0.3518437,1.857935,1.0867824,2.6472447,2.6329402,3.7980705,1.1296168,11.3317789),(54072,'metacarpal.tif',232,5,28,3.3846531,5.3033358,7.2373015,1.8,5.2903047,7.2330004,-0.8622531,1.4001838,1.9504796,1.3671234,3.235667,0.3252385,1.6589084,0.9763886,2.359062,2.5382824,3.6583133,1.1830262,10.7478049),(54073,'metacarpal.tif',232,5,29,3.3063515,5.2943214,7.2741381,1.8,5.2910664,7.2561492,-0.8561751,1.2620014,2.1592522,1.294382,2.9450331,0.3144014,1.3639134,1.0256582,1.95747,2.4541608,3.6327239,1.1659045,10.6803469),(54074,'metacarpal.tif',232,5,30,3.256518,5.2197444,7.3434334,1.8,5.2054262,7.3270042,-0.7120286,1.2948609,1.8978844,1.3531828,2.4735647,0.2316977,1.3033274,1.0450411,1.9982637,2.4679548,3.5094366,0.5427505,10.2013611),(54075,'metacarpal.tif',232,5,31,3.1913571,5.1679256,7.4220484,1.8,5.1453125,7.4014169,-0.5539953,1.3384402,1.6677281,1.3375439,1.9882342,0.1472118,1.1921813,0.9993303,1.9109331,2.4775412,3.2816076,0.567844,9.4988392),(54076,'metacarpal.tif',232,5,32,3.2578595,5.1541721,7.4859596,1.8,5.132543,7.4725247,-0.3601261,1.358412,1.5495921,1.312921,1.6900794,0.067427,1.0906608,0.9665117,1.9180703,2.4306053,3.0186979,0.5485494,9.4313812),(54077,'metacarpal.tif',232,5,33,3.3598807,5.144424,7.5361476,1.8,5.1270223,7.5262988,-0.0203075,1.2969501,1.4770413,1.2551579,1.5064799,0.0002309,1.0199308,0.9677765,1.8420941,2.4115525,2.8400534,0.5087298,8.8869232),(54078,'metacarpal.tif',232,5,34,3.2024542,5.1668603,7.5967907,1.8,5.1585389,7.5904279,0.3181607,1.5050973,1.272591,1.1360484,1.3408887,0.0522301,1.0536682,0.7548006,1.3572577,2.3329948,2.6856414,0.3442187,8.5168972),(54079,'metacarpal.tif',232,5,35,3.0314932,5.2003586,7.6535183,1.8,5.1941632,7.6442203,0.3230517,1.1670065,1.2147553,0.9819708,1.1995836,0.05092,0.9875105,0.8414441,1.6780838,2.2735136,2.5244975,0.3875238,8.1680333),(54080,'metacarpal.tif',232,5,36,2.9217595,5.2314489,7.7143288,1.8,5.2283001,7.7088669,0.3929848,1.1749532,1.2132959,0.8960828,1.0818741,0.071412,0.891682,0.7626541,1.5429916,2.1895612,2.4642949,0.2543681,7.7353433),(54081,'metacarpal.tif',232,5,37,2.8675644,5.2590733,7.7666408,1.8,5.2575926,7.7593473,0.4987426,1.1668236,1.1865835,0.8420521,1.0045387,0.1093458,0.8465807,0.7216619,1.5209916,2.1532906,2.3850001,2.2142974,7.6120013),(54082,'metacarpal.tif',232,5,38,2.8167173,5.282745,7.8201395,1.8,5.284658,7.8166285,0.6487174,1.1399491,1.1420955,0.7922465,0.9367207,0.1713574,0.8201772,0.694984,1.4365471,2.077579,2.3416766,2.1531493,7.3142273),(54083,'metacarpal.tif',232,5,39,2.7841661,5.2999385,7.8702074,1.8,5.3054025,7.8693662,0.7367572,1.1162037,1.094854,0.7603851,0.889805,0.2094787,0.8127156,0.6812243,1.3466143,2.0574687,2.275645,2.1471715,7.1793114),(54084,'metacarpal.tif',232,5,40,2.7759293,5.31074,7.9103344,1.8,5.3160499,7.9092277,0.825246,1.1017709,1.0894931,0.7526874,0.8566697,0.2497437,0.7863011,0.6831615,1.3459656,2.0574687,2.2616039,2.0533096,7.3653173),(54085,'metacarpal.tif',232,5,41,2.7725931,5.322957,7.9524194,1.8,5.3323711,7.9513705,0.9340527,1.0934122,1.1214085,0.7467974,0.8374612,0.298735,0.746794,0.6829972,1.3224987,2.0574687,2.2515209,2.2058231,7.1793114),(54086,'metacarpal.tif',232,5,42,2.8042198,5.3356662,8.010212,1.8,5.3454143,8.0157031,1.0500503,1.0811955,1.1952875,0.7347617,0.8690104,0.3516802,0.7270305,0.6795827,1.3137342,2.0237397,2.2905936,2.1183586,7.1513694),(54087,'metacarpal.tif',232,5,43,2.8604679,5.3498484,8.0678358,1.8,5.3607516,8.0719537,1.0964956,1.0651753,1.2270661,0.7404247,0.9238279,0.3773005,0.7528755,0.6951201,1.3382712,2.0177984,2.3290109,2.1815223,7.2978593),(54088,'metacarpal.tif',232,5,44,2.8841105,5.3618672,8.1207917,1.8,5.3718589,8.1251957,1.1271112,1.0496133,1.2218406,0.7426543,0.9676642,0.3921076,0.7919726,0.7075504,1.3848787,2.018871,2.3416766,2.1531493,7.3932593),(54089,'metacarpal.tif',232,5,45,2.9160755,5.3746813,8.1619441,1.8,5.3872529,8.1657445,1.0951848,1.0633479,1.2603909,0.7562853,1.0172617,0.3841171,0.8071002,0.7112303,1.3989017,2.0130673,2.3907172,2.070143,7.2862853),(54090,'metacarpal.tif',232,5,46,2.9008256,5.3843488,8.2113373,1.8,5.3943139,8.2174461,1.0812019,1.0380214,1.2339807,0.7544924,1.0387925,0.3765504,0.8418223,0.7268563,1.4532491,2.0211094,2.3763986,1.7524452,7.4212013),(54091,'metacarpal.tif',232,5,47,2.8661968,5.3845444,8.2434798,1.8,5.394901,8.2439388,1.1179076,1.0248752,1.2065463,0.7395832,1.0206525,0.3862377,0.845929,0.7216324,1.4467737,1.9905474,2.3562063,1.943784,7.2862853),(54092,'metacarpal.tif',232,5,48,2.8391736,5.3794488,8.2723493,1.8,5.3878089,8.2702568,1.1233039,1.0607436,1.1852747,0.7414657,0.9887922,0.384597,0.8342304,0.6990056,1.4308485,2.0237397,2.3290109,2.1815223,7.2188273),(54093,'metacarpal.tif',232,5,49,2.7935347,5.3746147,8.3018093,1.8,5.3796724,8.300223,1.1519999,1.0369183,1.1667137,0.7348725,0.9556165,0.3885931,0.8190668,0.7087081,1.4302646,2.0214135,2.3138188,1.7156088,7.1793114),(54094,'metacarpal.tif',232,5,50,2.751201,5.3760256,8.3336363,1.8,5.3818995,8.3338921,1.1617694,1.0359733,1.176685,0.7252092,0.9237486,0.3860033,0.7850432,0.7000269,1.3982258,2.0462431,2.3074182,1.6951513,7.2024593),(54095,'metacarpal.tif',232,5,51,2.7780959,5.3754164,8.3603542,1.8,5.3806238,8.3569059,1.1341326,1.0446119,1.1501045,0.734668,0.920219,0.3802009,0.8001178,0.7032928,1.4335522,2.0228214,2.2826332,2.0250984,7.1513694),(54096,'metacarpal.tif',232,5,52,2.7851316,5.3700146,8.3863829,1.8,5.3740354,8.3857379,1.1329175,1.0347543,1.1314485,0.729788,0.9111075,0.380731,0.8052576,0.7052766,1.4299158,2.0322098,2.2676322,1.8259787,7.1234273),(54097,'metacarpal.tif',232,5,53,2.7862494,5.3673982,8.412493,1.8,5.3708082,8.4096516,1.1096691,1.0519086,1.1256958,0.7370483,0.9056258,0.3724345,0.8045031,0.7006771,1.4445321,2.0387618,2.2515209,2.2058231,7.1118534),(54098,'metacarpal.tif',232,5,54,2.8018971,5.3659651,8.4417336,1.8,5.3708454,8.441782,1.1250545,1.0427583,1.1434052,0.743871,0.914294,0.3801844,0.7996238,0.7133686,1.4491362,2.0643768,2.2861193,1.9784278,7.1397954),(54099,'metacarpal.tif',232,5,55,2.7953531,5.3644077,8.4731344,1.8,5.3687672,8.4709922,1.113726,1.0398264,1.1370981,0.7537692,0.9136455,0.375153,0.8034887,0.7248991,1.4601244,2.0518461,2.2861193,1.9784278,7.1513694),(54100,'metacarpal.tif',232,5,56,2.8040148,5.3628138,8.5078802,1.8,5.3660054,8.5074211,1.137907,1.0748281,1.1317308,0.7678914,0.9176218,0.3850958,0.8108128,0.7144318,1.4802563,2.0911977,2.2801399,1.8462224,7.2351954),(54101,'metacarpal.tif',232,5,57,2.8103718,5.3609126,8.5403378,1.8,5.3629025,8.5381268,1.2128027,1.0607459,1.1303655,0.7874708,0.9361378,0.410887,0.8281727,0.7423746,1.508161,2.0988001,2.2900969,2.1934671,7.2631374),(54102,'metacarpal.tif',232,5,58,2.7816152,5.3546654,8.5688728,1.8,5.3541233,8.5670115,1.2355633,1.0856497,1.1443577,0.7922226,0.9336046,0.413425,0.8158329,0.7297221,1.5070579,2.0988001,2.3054452,1.9974238,7.3816853),(54103,'metacarpal.tif',232,5,59,2.7623175,5.353531,8.604632,1.8,5.3526541,8.6036034,1.3125537,1.0599341,1.1590725,0.8048121,0.9409552,0.4303599,0.8118174,0.759304,1.5059134,2.0988001,2.3299876,1.9703118,7.2910794),(54104,'metacarpal.tif',232,5,60,2.7287316,5.3484619,8.640311,1.8,5.3477313,8.6409955,1.3988851,1.0857699,1.1611742,0.8115089,0.951888,0.4414799,0.8197633,0.7474041,1.4845482,2.1256105,2.3533075,1.8797271,7.3701114),(54105,'metacarpal.tif',232,5,61,2.6751096,5.3389772,8.6744664,1.8,5.3374203,8.6752466,1.4823381,1.0815856,1.1379452,0.8104357,0.9650177,0.442372,0.8480353,0.7493033,1.4972524,2.1465001,2.3682462,1.8989162,7.4655114),(54106,'metacarpal.tif',232,5,62,2.6874833,5.329604,8.7202837,1.8,5.3283852,8.7207053,1.5563355,1.0850078,1.2006863,0.8160201,0.999811,0.4478202,0.8326996,0.7520869,1.5108966,2.1422098,2.3494369,1.6724852,7.4934534),(54107,'metacarpal.tif',232,5,63,2.7114053,5.3200861,8.7603536,1.8,5.3148556,8.758865,-1.5329303,1.0806161,1.2530953,0.8316725,1.0278793,0.4512532,0.8202722,0.7696281,1.4774816,2.1244272,2.4153351,1.7294516,7.6794593),(54108,'metacarpal.tif',232,5,64,2.6849661,5.3089923,8.7909555,1.8,5.3036988,8.7854123,-1.4604079,1.0903063,1.1569826,0.8338607,1.0323433,0.4420635,0.8922721,0.7647949,1.5358823,2.0988001,2.3763986,1.7524452,7.4423635),(54109,'metacarpal.tif',232,5,65,2.6717919,5.2948319,8.8279488,1.8,5.2950186,8.8250664,-1.4410721,1.1069701,1.1667367,0.8368968,1.0593662,0.4378469,0.9079737,0.7560248,1.5114331,2.1465001,2.3840459,1.9178579,7.6399433),(54110,'metacarpal.tif',232,5,66,2.6839126,5.2834331,8.8655832,1.8,5.2819052,8.864221,-1.4078658,1.0697355,1.1814085,0.8440859,1.1023267,0.4355488,0.9330614,0.7890604,1.5553404,2.1251001,2.4006895,0.8557046,7.6167954),(54111,'metacarpal.tif',232,5,67,2.7136378,5.2698095,8.9032324,1.8,5.2674331,8.9002999,-1.388368,1.0823677,1.2141885,0.8483937,1.1883503,0.4373875,0.9787198,0.7838313,1.5766301,2.1251001,2.4735107,0.8809963,7.8586853),(54112,'metacarpal.tif',232,5,68,2.7407165,5.2528427,8.9505157,1.8,5.2497474,8.9489186,-1.3450177,1.0993846,1.2366051,0.8396772,1.2958828,0.4338939,1.0479358,0.7637702,1.6312954,2.0988001,2.5429067,1.1659045,7.8750534),(54113,'metacarpal.tif',232,5,69,2.8023649,5.2315351,9.0004287,1.8,5.2287157,8.9968821,-1.3027172,1.0734165,1.3246403,0.8464025,1.4656456,0.4342912,1.106448,0.7885127,1.6620076,2.0783747,2.6919879,1.0516502,8.0658534),(54114,'metacarpal.tif',232,5,70,2.9168136,5.1884312,9.0690707,1.8,5.1879911,9.0797742,-1.3001785,1.0916179,1.4155525,0.8982682,1.7015481,0.4513946,1.2020381,0.8228779,1.7720824,2.0988001,2.8592162,1.0847644,8.7009173),(54115,'metacarpal.tif',232,5,71,2.9614509,5.1261597,9.097757,1.8,5.1241572,9.1019346,-1.2534354,1.0723211,1.4729392,0.9211133,1.8728198,0.44551,1.2714848,0.8589902,1.8636707,2.114532,2.937716,1.0053124,8.5264854),(54116,'metacarpal.tif',232,5,72,3.0458526,5.0768516,9.1087894,1.8,5.0757327,9.1105514,-1.233593,1.0588332,1.5177029,0.9870644,2.0764073,0.452075,1.368125,0.932219,1.9756114,2.1359746,3.0186979,1.0222469,8.8869232),(54117,'metacarpal.tif',232,5,73,3.1131038,5.0263115,9.1302977,1.8,5.0167418,9.1407315,-1.2060666,1.0680061,1.5659594,1.0388981,2.305835,0.4528359,1.4724743,0.9727455,2.0924509,2.1573453,3.1773357,0.9453113,9.2010653),(54118,'metacarpal.tif',232,5,74,3.3134288,4.9486559,9.1889228,1.8,4.9430168,9.1974559,-1.1583639,1.364539,1.6743402,1.1684648,2.7223602,0.463509,1.6259301,0.8563074,2.322221,2.1876161,3.3061297,0.8058035,9.7802451),(54119,'metacarpal.tif',232,5,75,3.4615588,4.8636325,9.2382224,1.8,4.8590945,9.2347104,-1.1201056,1.1136827,2.1558047,1.2864603,3.1027098,0.4674625,1.4392351,1.1551407,1.9731159,2.207296,3.4742502,0.7756897,9.9874132),(54120,'metacarpal.tif',232,5,76,3.8008652,4.8100592,9.2342173,1.8,4.8085279,9.2283692,-1.1342503,1.1548035,2.299423,1.4436438,3.3563833,0.5202308,1.4596633,1.2501207,2.0465829,2.3312589,3.4755597,0.7562802,10.8412191),(54121,'metacarpal.tif',232,5,77,4.0543968,4.8015903,9.18908,1.8,4.8001519,9.1715509,-1.2166212,1.1561533,1.7919966,1.4611989,3.5071333,0.5944544,1.9571093,1.2638454,2.7086171,2.2277707,3.5181783,0.8621701,10.7573931),(54122,'metacarpal.tif',232,5,78,4.7997784,4.7309192,9.1221813,1.8,4.7258009,9.1056197,-1.1791377,1.5017276,1.7640929,1.8661139,3.646347,0.6833991,2.0669813,1.2426448,3.073788,2.5378769,3.5752734,0.7853982,11.0435931),(54123,'metacarpal.tif',232,5,79,4.8137884,4.6942171,9.0787637,1.8,4.6868029,9.0689741,-1.2047008,1.4484922,4.0726886,2.0502737,3.7299619,0.6994882,0.9158476,1.4154537,1.4191506,2.6078279,3.5181783,0.8621701,10.7901292),(54124,'metacarpal.tif',232,5,80,4.5802423,4.6345945,9.1278995,1.8,4.6231129,9.1245047,-1.2409846,1.4000524,1.6636049,1.9446903,3.2613524,0.6833046,1.9604129,1.3890125,2.8107545,2.5818631,3.4640843,0.9025069,10.4480452),(54125,'metacarpal.tif',232,5,81,4.1559689,4.6028568,9.1601167,1.8,4.589279,9.1613828,-1.2334319,1.3645029,1.6360331,1.5973141,2.7655251,0.6167722,1.6903845,1.1706198,2.5000495,2.453552,3.4031201,1.0255692,10.673567),(54126,'metacarpal.tif',232,5,82,3.5515793,4.6226366,9.0186108,1.8,4.6171055,9.0243358,-1.1129361,1.2372251,1.6619839,1.0802267,1.6983845,0.4762725,1.0219019,0.8731044,1.599731,2.1842764,3.1384281,1.1479424,9.6173871),(54127,'metacarpal.tif',232,5,83,2.6431278,4.643375,8.7810811,1.8,4.6356809,8.7841946,-0.6929267,1.0587386,1.2545017,0.5092022,0.9075759,0.1797568,0.7234553,0.4809517,1.1149629,1.8380266,2.579772,0.3392926,8.7472132),(54128,'metacarpal.tif',232,5,84,1.5064001,4.7122698,8.5996594,1.8,4.7016032,8.6199023,-0.768064,0.8169072,1.1653873,0.1393434,0.4457531,0.1211822,0.3824935,0.1705743,0.4958301,1.5218804,2.2841279,0.5010134,7.7728735),(54129,'metacarpal.tif',232,5,85,0.3579645,4.8959173,8.2534998,1.8,4.9098304,8.245176,0.4873789,0.4791916,0.6071013,0.0147063,0.0188947,0.0130845,0.0311229,0.0306898,0.0521611,0.8861887,1.0719242,2.5782764,3.0499918),(54130,'metacarpal.tif',232,5,86,8.4472906,4.62339,8.3105135,1.8,4.6104003,8.3122735,-1.4207922,1.4157952,3.3981629,3.2815386,23.9324546,1.3764396,7.0427626,2.317806,8.0067994,2.8225462,3.505869,2.1625725,11.2555552),(54131,'metacarpal.tif',232,5,87,7.3847637,4.6538077,8.0726362,1.8,4.6377639,8.0951976,-1.4382938,1.3993439,3.1566267,2.7175157,19.2244743,1.2093112,6.0901956,1.9419927,6.9452377,2.7815036,3.3755967,2.3162158,10.7717754),(54132,'metacarpal.tif',232,5,88,6.5703519,4.5848503,7.587839,1.8,4.5339432,7.5790937,-1.5279305,1.3368407,2.6770749,2.7927064,14.9735589,1.0930477,5.5932537,2.0890345,5.9912609,0.7777175,2.5442485,1.6835239,6.7138853),(54133,'metacarpal.tif',232,5,89,6.3274966,4.4767032,7.2317443,1.8,4.4393426,7.2081648,1.5216726,1.5018267,2.6018409,2.8766687,12.8116223,1.05204,4.9240605,1.9154465,5.5895687,2.4390737,3.2562021,1.0153026,14.8288429),(54134,'metacarpal.tif',232,5,90,6.1424814,4.4047459,7.0239506,1.8,4.383053,6.9988101,1.4690863,1.2410615,2.4868574,2.5953138,11.1226469,1.0131928,4.4725712,2.0912049,5.0400879,2.4405019,3.240793,2.3145519,11.6159931),(54135,'metacarpal.tif',232,5,91,5.88252,4.3626141,6.8058547,1.8,4.3491122,6.7864022,1.4485449,1.2464346,2.4478439,2.2524202,8.9988754,0.9658401,3.6762456,1.8070906,4.2410687,2.4134046,3.2086894,2.4087776,10.2109493),(54136,'metacarpal.tif',232,5,92,5.1199527,4.3013441,6.5273847,1.8,4.2904009,6.5324444,1.446785,1.2033693,2.4437801,1.805353,5.3075953,0.8402694,2.1718792,1.5002485,2.7288533,2.344827,3.0843132,2.257614,9.9247493),(54137,'metacarpal.tif',232,5,93,4.1492737,4.1799873,6.2867394,1.8,4.2085127,6.3143676,1.4991373,1.1653329,2.4034371,1.2468359,2.4654331,0.6880006,1.0257947,1.0699396,1.5183115,2.2021646,2.9346164,1.7011996,9.4477493),(54138,'metacarpal.tif',232,5,94,3.8431034,4.1518701,6.2655838,1.8,4.1844247,6.2766487,1.4893802,1.1132627,1.393755,1.0039459,1.8917568,0.6362809,1.3573094,0.9018051,2.000597,2.0770506,2.8719204,1.4876551,8.6893434),(54139,'metacarpal.tif',232,5,95,3.799831,4.2288111,6.2593407,1.8,4.2220686,6.2618127,1.4579066,1.0246178,1.347525,1.0098698,1.8028958,0.6252685,1.3379313,0.9856063,1.9887103,2.0121942,2.7455484,1.7102364,8.3289055),(54140,'metacarpal.tif',232,5,96,3.3877884,4.2236585,6.247996,1.8,4.2186653,6.2593982,1.5037864,0.9606289,1.2711914,0.8051716,1.5026209,0.5620998,1.1820572,0.8381713,1.6495329,1.8964061,2.6665111,1.1071487,8.2730215),(54141,'metacarpal.tif',232,5,97,3.0290886,4.1993488,6.2677332,1.8,4.1951029,6.2738304,1.4897961,0.8864579,1.2054432,0.588159,1.2119232,0.501543,1.0053756,0.6634935,1.3778989,1.7457121,2.5186323,1.141034,7.7285635),(54142,'metacarpal.tif',232,5,98,2.5813684,4.165506,6.2608101,1.8,4.16141,6.2514173,1.4609925,0.7966901,1.1356028,0.3956051,0.9094726,0.4250617,0.8008721,0.4965608,1.0575305,1.5636108,2.3687265,1.1341692,7.2168416),(54143,'metacarpal.tif',232,5,99,1.994986,4.1200056,6.1316677,1.8,4.1210059,6.1181863,1.4276305,1.3156934,0.9798149,0.2395622,0.5289725,0.3257291,0.5398698,0.1820806,0.5375327,1.3607642,2.0906536,2.177784,6.2165457),(54144,'metacarpal.tif',232,5,100,1.4914032,4.0400235,5.9921513,1.8,4.0418358,5.9783145,1.371041,1.4426953,0.8310034,0.1553428,0.2751177,0.23878,0.3310669,0.1076754,0.2911994,1.2600509,1.8554013,2.3380147,5.4812877),(54145,'metacarpal.tif',232,5,101,1.19274,3.9171786,5.8505924,1.8,3.9031895,5.8455961,0.8879727,0.739222,0.8261786,0.1030836,0.1485145,0.1196431,0.1797607,0.1394487,0.3005583,1.2470475,1.7231522,2.4149503,5.1112616),(54146,'metacarpal.tif',232,5,102,1.1018133,3.7630022,5.7349286,1.8,3.750067,5.7189882,0.2416632,0.6117287,0.7955712,0.0730199,0.1495732,0.0105174,0.1880073,0.1193664,0.2789768,1.096621,1.6225014,2.7173982,4.7623977),(54147,'metacarpal.tif',232,5,103,0.873205,3.6521011,5.6440729,1.8,3.6794867,5.6271129,0.045124,0.3954551,1.4560783,0.028341,0.1830402,0.0002961,0.1257077,0.0716668,0.1450401,0.802595,1.6468594,2.9669205,4.3297078),(54148,'metacarpal.tif',232,5,104,0.3882006,3.5726359,5.5284113,1.8,3.6313549,5.5169338,-0.0159568,0.2404538,1.3886722,0.0036331,0.1115879,0.0000165,0.0803558,0.0151093,0.0829628,0.4702322,1.628101,0.0880074,3.8179859),(54149,'metacarpal.tif',232,5,105,0.0506715,3.3942837,5.3554552,1.8,3.4480287,5.3464887,-0.090139,0.086954,1.3798942,0.0000803,0.0144448,0.0000684,0.0104681,0.0009236,0.0105256,0.1908,0.5802956,0.1651487,1.2749219),(54150,'metacarpal.tif',232,5,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54151,'metacarpal.tif',232,5,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54152,'metacarpal.tif',232,5,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54153,'femur.tif',232,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54154,'femur.tif',232,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54155,'femur.tif',232,7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54156,'femur.tif',232,7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54157,'femur.tif',232,7,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54158,'femur.tif',232,7,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54159,'femur.tif',232,7,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54160,'femur.tif',232,7,8,0.0028722,23.6830959,20.5588429,1.8,23.6830507,20.5587006,0.9586552,0.019564,0.0528858,0.0000012,0.0000047,0.0003206,0.0000889,0.0000611,0.0001102,0.0954,0.1719848,2.1587989,0.365232),(54161,'femur.tif',232,7,9,0.0035334,23.208882,20.1574303,1.8,23.2108206,20.1580206,0.342399,0.0306011,0.6296368,0.0000023,0.0003463,0.0000664,0.00055,0.0000741,0.0005536,0,0,0,0),(54162,'femur.tif',232,7,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54163,'femur.tif',232,7,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54164,'femur.tif',232,7,12,0.0097634,20.7390323,17.5395717,1.8,20.7392792,17.5399719,1.2854457,0.0872519,0.5870273,0.000015,0.0006647,0.0014983,0.0011323,0.0001721,0.0011453,0.1057768,0.407549,1.929567,0.8817479),(54165,'femur.tif',232,7,13,1.03547,20.300673,13.2674284,1.8,20.3790871,13.9315965,1.44814,0.7982234,5.585802,0.1247487,6.2150073,0.169995,1.1126437,0.156283,1.1298523,0,0,0,0),(54166,'femur.tif',232,7,14,5.5415254,20.2515704,12.5812957,1.8,20.3426571,13.0769058,1.319708,2.5937256,10.5785505,6.0515122,27.1443116,0.8665731,2.5659765,2.3331351,3.0916792,2.7995065,4.6160689,0.4035349,11.936915),(54167,'femur.tif',232,7,15,11.1975658,19.8171495,13.5593341,1.8,19.7839777,13.4842346,-1.4945019,3.9037906,4.7743627,23.5853794,74.997601,1.8554188,15.7084003,6.0416609,17.1084426,3.7707955,6.767351,0.3752708,17.8460985),(54168,'femur.tif',232,7,16,17.8961901,19.6619973,14.4583688,1.8,19.6155868,14.4665198,-1.5320741,8.0742038,5.1514789,63.1835443,141.8656858,2.9782283,27.538827,7.8253591,22.6193241,7.8315993,10.4071303,1.0476707,34.8874953),(54169,'femur.tif',232,7,17,21.7783318,19.6509081,14.7307869,1.8,19.581141,14.764262,-1.5650882,5.3993624,5.683495,115.3767861,200.3680379,3.6296037,35.2543704,21.3685945,49.6880585,9.0670976,11.6248143,1.022636,38.4520173),(54170,'femur.tif',232,7,18,23.9641542,19.5995747,14.8834683,1.8,19.542107,14.9205516,-1.5020575,5.9644299,6.2677972,180.2430084,250.9457021,3.9751836,40.0373038,30.2196542,62.6832918,9.963661,12.6040879,0.9439477,41.5954233),(54171,'femur.tif',232,7,19,25.6409006,19.4759494,14.9358433,1.8,19.4116676,15.0230521,-1.5584092,6.1019878,6.3457957,247.9614101,304.2630423,4.2728277,47.947185,40.6361693,75.9583009,10.6681644,13.4134575,0.9216054,44.2223133),(54172,'femur.tif',232,7,20,27.8781,19.3767214,14.9333331,1.8,19.2998643,14.9741653,1.4626019,6.0533593,6.2550653,311.8487391,362.8791871,4.5921715,58.013653,51.5166416,89.7742219,11.2468548,14.0424462,0.8912809,46.2999512),(54173,'femur.tif',232,7,21,29.1881708,19.3950589,15.0251581,1.8,19.2911324,15.0713356,1.516755,6.4485575,6.4492109,355.5367706,392.5684952,4.8505018,60.8707792,55.1343106,96.645852,11.6998324,14.5178149,0.866803,48.2127453),(54174,'femur.tif',232,7,22,31.0855903,19.282697,15.1182628,1.8,19.1575252,15.203973,-1.2310818,7.043255,7.7626693,417.1308903,437.9926278,4.6056712,56.4229401,59.2241644,107.48068,12.0202289,14.839301,0.8513615,144.5894726),(54175,'femur.tif',232,7,23,34.6791763,19.0855941,15.0812299,1.8,18.9898612,15.0981509,-0.8650514,7.7356088,8.0190684,455.4250249,498.3227593,3.3483715,62.1422261,58.8738438,118.3112345,12.2686698,15.0457782,0.8549487,51.471891),(54176,'femur.tif',232,7,24,37.5012625,19.1637803,14.9554166,1.8,18.9780365,14.9977542,-0.8545876,8.3708957,7.8011363,493.6758968,537.0969488,3.5561747,68.8485531,58.9752772,122.9781332,12.4608247,15.3356803,2.6278477,52.184001),(54177,'femur.tif',232,7,25,39.4510428,19.1975948,15.0574344,1.8,19.08229,15.1171409,1.1793846,7.4166032,7.5592707,538.7193477,550.080323,5.6182395,72.7689675,72.6369377,126.6372958,12.5928004,15.6823503,2.6575397,52.442259),(54178,'femur.tif',232,7,26,40.9696262,19.2451204,15.1497065,1.8,19.1920849,15.2286289,1.1092856,7.642574,7.7010495,549.0113994,603.6384661,5.474271,78.3839222,71.8359283,134.9430491,12.7003823,15.7467812,2.6562682,52.4027431),(54179,'femur.tif',232,7,27,37.8755891,18.9227382,15.0261734,1.8,18.8966279,15.1050123,-0.7873863,7.3320224,7.4073448,460.2370411,498.7505601,3.1688495,67.3318949,62.7708173,126.6445352,11.9492965,14.8101399,0.7648999,52.6234709),(54180,'femur.tif',232,7,28,33.5464088,18.5770487,15.0962641,1.8,18.54594,15.1229688,-0.3857015,5.6763651,7.1911956,359.5351928,412.1433451,0.7913226,57.3122142,63.3389828,106.2496944,10.7504866,14.1440759,0.7448476,50.5574069),(54181,'femur.tif',232,7,29,27.4079926,17.676964,15.371151,1.8,17.8146742,15.2298331,0.5107999,8.1508835,6.6701282,268.2747163,307.6016741,1.0917469,46.116306,32.9135752,69.8345032,10.3943932,14.3742512,0.7572366,56.1312863),(54182,'femur.tif',232,7,30,22.3408349,16.6185338,15.5348633,1.8,16.6926899,15.5274582,0.8471359,7.7584533,7.0350154,183.4487267,212.9533467,2.0910312,30.2704877,23.6450127,49.9036064,9.8049207,11.1435411,2.7507528,36.4534113),(54183,'femur.tif',232,7,31,19.7967261,16.1675116,15.4640601,1.8,16.2054168,15.4926435,0.9964358,8.1889822,4.8473004,157.2775318,167.509521,2.3255452,34.5572811,19.2059927,37.8648921,9.3824479,10.4967102,2.7695249,34.9741297),(54184,'femur.tif',232,7,32,18.2833617,15.8089789,15.4163804,1.8,15.8492076,15.4658376,-1.4616029,5.6258909,4.7922287,139.4019564,145.5356953,3.0110384,30.3691048,24.7786457,50.6304585,8.9287305,10.0904389,2.7435288,98.6926243),(54185,'femur.tif',232,7,33,18.1771929,15.6412647,15.3761967,1.8,15.696921,15.4379158,-1.2986714,5.1497157,4.6886968,128.4514995,140.4734128,2.8106726,29.9600122,24.9434158,49.5051014,8.7067844,9.7347745,2.7547169,30.4372538),(54186,'femur.tif',232,7,34,17.4182925,15.4866719,15.3472367,1.8,15.5280232,15.3693638,-1.1214188,4.8961557,4.6844858,117.9965485,126.6333605,2.3552213,27.0324995,24.0998356,49.2016707,8.4239822,9.424825,2.7686049,30.3745899),(54187,'femur.tif',232,7,35,17.2584194,15.3149146,15.32878,1.8,15.3651645,15.3282737,-1.0471917,6.9001076,4.646345,113.3205064,122.8688796,2.1572878,26.4442009,16.4230057,29.837771,8.2400181,9.1506955,2.7736703,28.852984),(54188,'femur.tif',232,7,36,17.0158574,15.1844473,15.3173401,1.8,15.250324,15.3373616,-1.3045105,7.8859109,4.3538474,105.7393631,115.9271538,2.6395908,26.6263708,13.4086429,27.0697161,8.0591959,8.9010043,0.933726,28.1504621),(54189,'femur.tif',232,7,37,16.7536764,15.046644,15.3219765,1.8,15.1148828,15.3392373,-1.2878562,8.0132027,4.2787362,99.133461,110.802028,2.574645,25.8959709,12.3712659,25.3490112,7.9028715,8.676288,2.7937611,28.0618419),(54190,'femur.tif',232,7,38,16.7369807,14.9146522,15.3433074,1.8,14.9600768,15.403082,-1.1219321,4.8851462,4.2849855,95.2817372,105.9642684,2.2642174,24.7292014,19.5043778,39.5254185,7.7468068,8.4644321,2.7966733,27.370894),(54191,'femur.tif',232,7,39,16.4391485,14.7991732,15.3418078,1.8,14.8462458,15.3980051,-1.2924982,4.3109624,4.0694561,92.3290781,100.0657524,2.5330786,24.589466,21.4172775,44.3781707,7.6289116,8.2911604,2.7707014,26.6124881),(54192,'femur.tif',232,7,40,15.9019804,14.6766955,15.3237565,1.8,14.719697,15.3852213,-1.3048823,4.2743761,3.9920587,86.9750461,94.8522883,2.4673002,23.7602437,20.3480095,42.4079068,7.5374165,8.1509798,2.782822,25.8820241),(54193,'femur.tif',232,7,41,15.5001619,14.5280798,15.3059858,1.8,14.5755648,15.3455268,-1.3635889,4.2687413,3.9170464,82.200088,90.6850777,2.4740223,23.151392,19.2562826,40.4989414,7.4356526,8.0073514,2.7632987,25.3144182),(54194,'femur.tif',232,7,42,15.4028064,14.419699,15.306407,1.8,14.4784101,15.3377048,-1.3859009,4.2269739,3.8571278,79.7260638,86.1032812,2.480369,22.3231602,18.8612626,39.2050953,7.3032765,7.8775798,2.7892004,24.9096703),(54195,'femur.tif',232,7,43,15.1969222,14.314379,15.3280614,1.8,14.3851245,15.3356702,-1.4188474,4.1891415,3.8198124,76.9729846,81.9919617,2.4747901,21.4649183,18.3744053,37.9458835,7.1954673,7.7682202,2.7576655,24.5560123),(54196,'femur.tif',232,7,44,15.1879039,14.196997,15.3228174,1.8,14.2746715,15.3304082,-1.3676433,4.1593489,3.7671904,74.4881512,79.6799656,2.4282763,21.1510322,17.9086086,37.0653679,7.1143917,7.6619032,2.7587741,24.1792064),(54197,'femur.tif',232,7,45,15.3342277,14.1231436,15.31782,1.8,14.2042273,15.3253332,-1.4385999,4.0898573,3.7565577,73.5223671,77.6931119,2.511301,20.6819964,17.9767561,36.9724583,7.0390301,7.5476115,2.7458292,23.9325223),(54198,'femur.tif',232,7,46,15.3002545,14.0302225,15.3097797,1.8,14.100068,15.3121169,-1.4021187,4.0480273,3.7058874,72.2672059,74.9732965,2.4781738,20.2308623,17.8524504,36.3696141,6.9550558,7.4537262,2.7266172,23.6511164),(54199,'femur.tif',232,7,47,15.2590497,13.933746,15.3048428,1.8,13.9871252,15.3108829,-1.400704,4.0189743,3.6701882,70.9969303,72.7921811,2.4703042,19.8333648,17.6654351,35.7755479,6.9120041,7.3861107,2.7154996,23.4998324),(54200,'femur.tif',232,7,48,15.3106823,13.8538827,15.2984575,1.8,13.9057867,15.3029593,-1.3713623,3.967228,3.6312234,70.0716386,71.1391761,2.4516246,19.5909663,17.6626196,35.5942215,6.8648581,7.3229989,2.7187387,23.2415744),(54201,'femur.tif',232,7,49,15.1482584,13.7704917,15.298982,1.8,13.8169621,15.3063686,0.7416228,3.5830317,3.550786,68.2619104,68.9648891,1.151976,19.4224291,19.0514392,35.1442655,6.8054649,7.2283997,2.748832,22.9996845),(54202,'femur.tif',232,7,50,14.8491565,13.6974393,15.2824137,1.8,13.737738,15.2894575,0.5912857,3.5479625,3.6856602,65.6735309,67.2865702,0.7690055,18.2563143,18.5102101,34.8268805,6.7626554,7.15341,2.6331988,22.7973105),(54203,'femur.tif',232,7,51,14.7373399,13.6231702,15.2755711,1.8,13.6624576,15.2844974,0.4806135,3.5038492,3.758918,64.0368812,66.2071484,0.5250001,17.6133526,18.2761519,34.269334,6.7141883,7.15341,2.7226913,22.6460265),(54204,'femur.tif',232,7,52,14.6808276,13.5449565,15.2676985,1.8,13.5768519,15.2660581,0.4305643,3.470392,3.6949145,62.9631706,64.8202346,0.4262558,17.5430944,18.1429563,34.5766656,6.6701523,7.0655602,2.6417071,22.4995365),(54205,'femur.tif',232,7,53,14.737272,13.4430549,15.2459611,1.8,13.4621592,15.2398262,0.5901157,3.4765759,3.5882853,62.3615274,63.9864186,0.7605527,17.8320319,17.9376286,34.615697,6.6348325,7.0120624,2.4912889,22.4320785),(54206,'femur.tif',232,7,54,14.6894714,13.3587123,15.233535,1.8,13.3728346,15.2202518,0.4484438,3.4446118,3.5796227,61.5226056,62.7341324,0.460215,17.5253476,17.8605336,34.4668405,6.6303002,6.9211042,1.1595698,22.1574525),(54207,'femur.tif',232,7,55,14.6030581,13.2951529,15.2274548,1.8,13.2981222,15.2241092,0.1044037,3.3553641,3.5396763,60.7857881,61.6286345,0.026433,17.410811,18.1160035,34.5033794,6.6133067,6.8470689,1.1851154,21.9945945),(54208,'femur.tif',232,7,56,14.5041116,13.2435615,15.2241531,1.8,13.2494506,15.2303572,-0.0967092,3.2944904,3.426858,59.8547517,60.8435076,0.0225383,17.7548961,18.1681365,34.5847923,6.5826002,6.7957019,1.1668262,21.9271365),(54209,'femur.tif',232,7,57,14.4981621,13.1901383,15.2306918,1.8,13.2029653,15.243565,-0.3109218,3.3396305,3.3054938,59.3026256,60.529892,0.2261642,18.3119059,17.7572419,33.4065439,6.5769563,6.8470689,1.0291821,22.0109626),(54210,'femur.tif',232,7,58,14.4639123,13.129879,15.2117027,1.8,13.1460758,15.22173,0.0934006,3.3152717,3.4045301,58.3982894,59.7926706,0.0209687,17.5626794,17.6149332,34.2985935,6.5349002,6.7067288,2.2199873,21.7922205),(54211,'femur.tif',232,7,59,14.4369617,13.0718433,15.2112746,1.8,13.0820601,15.2236051,0.0463949,3.2806209,3.3557219,57.8592856,59.2413649,0.0051755,17.6538361,17.6366875,34.1205282,6.4872002,6.6715235,2.7836588,21.6293625),(54212,'femur.tif',232,7,60,14.5185595,13.0180785,15.2017646,1.8,13.0273599,15.2078449,0.0366017,3.2802437,3.3111019,57.9035399,58.9454091,0.0032403,17.8023545,17.6522068,34.0794767,6.4872002,6.6638455,0.7094027,21.7247625),(54213,'femur.tif',232,7,61,14.5319602,12.9625786,15.185141,1.8,12.9717644,15.1864676,0.0117046,3.2805381,3.2611466,57.723965,58.4984145,0.0003318,17.93799,17.5958833,33.7305757,6.4872002,6.7567519,2.2411272,21.8365306),(54214,'femur.tif',232,7,62,14.6409145,12.8910726,15.1991794,1.8,12.8948184,15.2052698,-0.1435766,3.2302663,3.2572534,57.7021552,58.4415492,0.0499572,17.9419719,17.8629719,32.7860473,6.4395002,6.6780002,2.2142974,21.6062146),(54215,'femur.tif',232,7,63,14.6178562,12.828059,15.1941473,1.8,12.8321789,15.205485,-0.0897014,3.2182246,3.2574412,56.7892542,58.3872877,0.0195509,17.9242799,17.646144,33.8906121,6.3918002,6.6590637,0.7195039,21.5387566),(54216,'femur.tif',232,7,64,14.6064503,12.7728123,15.1882148,1.8,12.7763157,15.1985689,-0.1200979,3.1963407,3.2373742,56.2717602,57.8456943,0.0349442,17.86809,17.6050571,33.6077314,6.3918002,6.659747,0.6277431,21.4549306),(54217,'femur.tif',232,7,65,14.5739083,12.7053845,15.1753747,1.8,12.7047358,15.1843563,-0.1664455,3.2015268,3.2390586,55.7171895,57.6051659,0.0666737,17.7845395,17.4033181,33.4744112,6.3441002,6.6328734,0.7039461,21.3874726),(54218,'femur.tif',232,7,66,14.4857831,12.6543328,15.1627171,1.8,12.6548652,15.1727764,-0.1711722,3.1979994,3.2241981,55.1768748,56.8064867,0.0700506,17.6187956,17.2535603,33.2003026,6.3441002,6.6227462,0.6679919,21.3595306),(54219,'femur.tif',232,7,67,14.2719025,12.6014322,15.1486291,1.8,12.5937807,15.1580788,-0.1434895,3.1753038,3.2261507,54.2684874,55.9743019,0.0486394,17.3501822,17.0908016,32.6093454,6.3441002,6.5933067,0.6623122,21.3315886),(54220,'femur.tif',232,7,68,14.1499749,12.5292695,15.1431593,1.8,12.5216847,15.1486734,-0.1516477,3.17564,3.2430872,53.4255512,55.7951386,0.0538201,17.2043286,16.823554,32.4822755,6.2964002,6.5933067,0.6623122,21.2641306),(54221,'femur.tif',232,7,69,14.0363578,12.4765574,15.1424592,1.8,12.4693161,15.1481419,-0.1291206,3.1690262,3.2541608,52.4861935,55.6578541,0.0387864,17.1035968,16.5622467,32.2913827,6.2964002,6.5781052,0.6826683,21.2246146),(54222,'femur.tif',232,7,70,13.8793985,12.4303663,15.1320081,1.8,12.4153355,15.1369137,-0.0832015,3.1753822,3.2486404,51.6724438,55.1513872,0.0159764,16.9767596,16.2728268,31.9929741,6.2763028,6.5730879,0.6464039,21.1687306),(54223,'femur.tif',232,7,71,13.8026429,12.3835438,15.1234851,1.8,12.36486,15.1254968,-0.0753957,3.159627,3.2449423,51.1105192,54.9849611,0.0130521,16.9448196,16.1761244,31.7730804,6.2487002,6.5730879,0.6464039,21.1292146),(54224,'femur.tif',232,7,72,13.8269785,12.338114,15.1161513,1.8,12.3205814,15.1218831,-0.1188393,3.1552515,3.2645084,50.9685705,55.1152558,0.032393,16.8831718,16.1535683,31.7984624,6.2487002,6.5936518,0.5478635,21.1407886),(54225,'femur.tif',232,7,73,13.8747694,12.2963785,15.1083933,1.8,12.2835552,15.117667,-0.1338339,3.1465365,3.2803396,50.8190724,55.6603348,0.041173,16.9678574,16.1507969,31.8239499,6.2487002,6.6083011,0.3925701,21.1687306),(54226,'femur.tif',232,7,74,13.9876128,12.2534047,15.0971761,1.8,12.2409506,15.1074675,-0.0992768,3.1568508,3.2922066,50.8966421,56.3042373,0.0229014,17.1022797,16.1225996,32.182579,6.2217514,6.6206846,0.4152982,21.1407886),(54227,'femur.tif',232,7,75,14.0741957,12.216421,15.0904204,1.8,12.2086974,15.0976246,-0.1028575,3.1417535,3.314559,50.7205527,57.0270222,0.0247294,17.2050106,16.1440266,32.4517627,6.2064058,6.6453823,0.4058343,21.1803045),(54228,'femur.tif',232,7,76,14.1803827,12.1836475,15.0784545,1.8,12.179546,15.0805678,-0.0960404,3.1494008,3.3160454,50.5632047,57.8155468,0.0217325,17.4350891,16.0548651,32.5423429,6.1913687,6.6643577,0.4124104,21.1407886),(54229,'femur.tif',232,7,77,14.3794451,12.1390393,15.0705896,1.8,12.1372495,15.072829,-0.1059444,3.1508637,3.3422909,50.8980837,58.8684334,0.0267992,17.6131985,16.1536924,32.7133776,6.182672,6.6786816,0.3805064,21.1918785),(54230,'femur.tif',232,7,78,14.5989125,12.1097151,15.0539897,1.8,12.114172,15.0570434,-0.1143348,3.1583084,3.7203408,51.4101127,59.884478,0.0316689,16.0965033,16.2777365,29.3219468,6.185953,6.6965434,0.38712,21.1803045),(54231,'femur.tif',232,7,79,14.6716364,12.0902924,15.0385413,1.8,12.0951098,15.0393625,-0.1486692,3.1396809,3.3669373,51.46448,60.4866757,0.0536497,17.964895,16.3916276,33.2067052,6.1881233,6.6997704,0.348771,21.2757045),(54232,'femur.tif',232,7,80,14.7437359,12.0857418,15.0199354,1.8,12.0927424,15.0179744,-0.1750523,3.1274173,3.3555782,51.7452929,60.708279,0.0745334,18.0917494,16.5456949,33.4435424,6.2009412,6.7162212,0.2880554,21.2757045),(54233,'femur.tif',232,7,81,14.7563905,12.0768787,14.9946485,1.8,12.0873209,14.9924834,-0.1722496,3.1243874,3.351294,51.8950308,60.8245538,0.0722513,18.1495726,16.609666,33.4557085,6.1897747,6.7229933,0.2656298,21.2361886),(54234,'femur.tif',232,7,82,14.7029586,12.0684577,14.9653308,1.8,12.0818973,14.9611321,-0.168165,3.1319916,3.3542042,51.4965853,61.1195786,0.0686478,18.2217821,16.4421214,33.2757741,6.1923511,6.7619694,0.2860514,21.3036466),(54235,'femur.tif',232,7,83,14.7286919,12.0546238,14.9442381,1.8,12.0667094,14.9423287,-0.1755983,3.1268551,3.3564229,51.4868006,61.5176065,0.0749178,18.3283238,16.4660014,33.3481367,6.1880048,6.7770943,0.3974982,21.3315886),(54236,'femur.tif',232,7,84,14.8565736,12.0556219,14.9192755,1.8,12.0797625,14.9157255,-0.1873296,3.1327323,3.3683315,51.4243168,62.6854546,0.0858804,18.6102391,16.4151645,33.4161092,6.1806521,6.7957019,0.4039701,21.3431625),(54237,'femur.tif',232,7,85,14.9280236,12.0496649,14.9031713,1.8,12.0785238,14.8964663,-0.1932642,3.1287185,3.3986887,51.2131579,63.6110694,0.0917783,18.7163567,16.3687329,33.4852375,6.1533002,6.8490625,0.2534244,21.3315886),(54238,'femur.tif',232,7,86,15.1041542,12.0385455,14.891528,1.8,12.0725177,14.8831579,-0.2070628,3.1173207,3.3937792,51.5147444,64.6911973,0.106398,19.061699,16.525327,33.8686056,6.1533002,6.8532138,0.4231713,21.3990466),(54239,'femur.tif',232,7,87,15.2343462,12.034271,14.8763455,1.8,12.0670949,14.8681467,-0.2200522,3.1168137,3.4086972,51.8170476,65.6214299,0.120977,19.2511759,16.6250064,33.9908565,6.1533002,6.9006918,0.3676701,21.4549306),(54240,'femur.tif',232,7,88,15.3484503,12.036657,14.8631643,1.8,12.0696586,14.8578245,-0.2237579,3.1060351,3.4367444,51.9864647,66.8630382,0.1259534,19.4553422,16.7372434,34.2703437,6.1533002,6.9283328,0.3587707,21.4665045),(54241,'femur.tif',232,7,89,15.5412771,12.0388113,14.84181,1.8,12.0845018,14.8303719,-0.233011,3.1093783,3.4637944,52.1361338,68.743578,0.1381065,19.8463219,16.767382,34.6650353,6.1533002,6.9858928,0.2979969,21.5619046),(54242,'femur.tif',232,7,90,15.765595,12.0615873,14.8242225,1.8,12.1043326,14.8169793,-0.2263752,3.1116688,3.4926665,52.221863,70.5026978,0.1323687,20.1859234,16.7825902,35.0640907,6.1533002,7.0276203,0.4120218,21.6409365),(54243,'femur.tif',232,7,91,15.8746121,12.0722477,14.8026637,1.8,12.1076937,14.7914084,-0.2136542,3.1272751,3.5188659,52.2311525,71.8572218,0.1189478,20.4205626,16.7018093,35.1797627,6.1533002,7.0964073,0.4004788,21.7363365),(54244,'femur.tif',232,7,92,15.8325933,12.0541451,14.7889133,1.8,12.083538,14.7812721,-0.2021432,3.1317547,3.5700598,52.3399433,72.7350907,0.1063643,20.3736339,16.7126572,34.9528129,6.1550126,7.1653277,0.3112246,21.9387105),(54245,'femur.tif',232,7,93,15.8299858,12.0476321,14.777017,1.8,12.086259,14.7665323,-0.2032877,3.1343705,3.6677495,52.4323236,74.2963625,0.1075376,20.2566623,16.7281829,34.4968372,6.1498209,7.2599653,0.2864222,22.0177424),(54246,'femur.tif',232,7,94,16.1375978,12.0911738,14.7607997,1.8,12.1324088,14.7443331,-0.2070411,3.1387393,3.7527966,52.3830997,78.0787776,0.1136544,20.8054916,16.6892167,34.7162931,6.1491661,7.4088713,0.3482209,22.2480584),(54247,'femur.tif',232,7,95,16.5143421,12.145663,14.7272719,1.8,12.2265895,14.6946199,-0.2247571,3.1099573,3.8397385,52.6461889,81.4564154,0.1367136,21.2140531,16.9282672,34.8595803,6.1533002,7.5650758,0.3676265,22.5063164),(54248,'femur.tif',232,7,96,16.5654246,12.1470511,14.7207963,1.8,12.2421736,14.6840515,-0.2340232,3.0974144,3.9052691,52.72958,83.0744589,0.1484658,21.2724031,17.0237409,34.4549816,6.1391207,7.6725864,0.4024428,22.6065105),(54249,'femur.tif',232,7,97,17.0329413,12.198663,14.7129335,1.8,12.301021,14.6725689,-0.2250661,3.0866551,3.9205227,52.9034211,86.0039533,0.1413882,21.9368589,17.1394017,35.1370341,6.1056002,7.7421084,0.3919475,22.8204584),(54250,'femur.tif',232,7,98,17.0431889,12.1965077,14.6958466,1.8,12.2913159,14.660954,-0.2247637,3.0827547,3.9466134,52.6119996,85.1052166,0.1410997,21.5641127,17.0665539,34.3333939,6.1056002,7.7978926,0.4089078,22.8252525),(54251,'femur.tif',232,7,99,16.6227537,12.0884182,14.7365724,1.8,12.1622774,14.7149566,-0.1691364,3.0796146,3.7617475,51.9142171,78.8170122,0.0785019,20.9522338,16.8573744,34.2614504,6.0579002,7.493608,0.3781423,22.2923685),(54252,'femur.tif',232,7,100,15.889656,11.9391041,14.7882892,1.8,11.9779481,14.7866038,-0.075635,3.0856808,3.5453904,51.3628119,70.7073129,0.015121,19.9434493,16.6455366,34.3392723,6.1000108,7.0576661,0.1629265,21.5686844),(54253,'femur.tif',232,7,101,15.6722847,11.8666082,14.7988778,1.8,11.8873058,14.7993143,-0.0333359,3.0856733,3.4944272,51.376075,67.7610384,0.0029016,19.391172,16.6498753,34.0933421,6.1056002,6.945225,2.863293,21.3778844),(54254,'femur.tif',232,7,102,15.6791223,11.8206976,14.7919841,1.8,11.8398391,14.7907559,-0.0124218,3.0930181,3.4442841,51.8976895,65.6677413,0.0004032,19.0657154,16.77898,33.5780923,6.1056002,6.9184737,2.904975,21.2429684),(54255,'femur.tif',232,7,103,15.7680565,11.8010664,14.7700667,1.8,11.8233041,14.7661123,-0.0239738,3.106931,3.4138467,52.2782452,64.6302048,0.0015101,18.9317832,16.8263294,33.2680762,6.1056002,6.896734,2.9184226,21.4732844),(54256,'femur.tif',232,7,104,15.8576838,11.7924528,14.7556532,1.8,11.8109397,14.7585425,0.0029961,3.0867375,3.4254982,52.5423189,63.7649895,0.0000237,18.6148075,17.0219589,33.1933483,6.0579002,6.8535458,2.8594689,21.0685365),(54257,'femur.tif',232,7,105,15.8704202,11.7767458,14.7364994,1.8,11.7976354,14.7358058,0.0453352,3.134467,3.4707356,52.708947,63.0358983,0.0054326,18.162115,16.8159205,32.8464306,6.0579002,6.837259,2.8949219,21.1359945),(54258,'femur.tif',232,7,106,15.9313599,11.7828512,14.7256631,1.8,11.8003011,14.7272473,0.0497941,3.1435636,3.4631111,52.5741322,62.3882843,0.0065781,18.0150974,16.7243735,32.8424764,6.1056002,6.7931903,2.9221621,21.1639365),(54259,'femur.tif',232,7,107,15.8845974,11.7643549,14.7294848,1.8,11.7772133,14.7288119,0.0869157,3.1508805,3.4626385,52.9243805,61.8496267,0.0199493,17.8619934,16.7966958,32.739749,6.1056002,6.7755833,2.8487872,21.0521684),(54260,'femur.tif',232,7,108,15.8238354,11.7615227,14.7269487,1.8,11.7802936,14.7247404,0.1519948,3.1605456,3.4924462,52.9222566,61.3345188,0.0604604,17.5620509,16.7446586,32.5602206,6.1056002,6.7735681,2.8042532,20.9451945),(54261,'femur.tif',232,7,109,15.9176937,11.7446313,14.7201271,1.8,11.7551671,14.7191548,0.1591982,3.1633302,3.4727256,53.2868087,60.6098187,0.0666704,17.4530974,16.8451616,32.580186,6.132462,6.7299276,2.8467414,20.9683424),(54262,'femur.tif',232,7,110,15.7762791,11.7414799,14.7349709,1.8,11.7488595,14.7345429,0.2087799,3.1504371,3.4678868,52.5692992,60.253389,0.1129565,17.3746703,16.6863508,32.41756,6.1387052,6.7128326,2.8086066,20.9288264),(54263,'femur.tif',232,7,111,15.8081697,11.752303,14.7487123,1.8,11.7640578,14.7471015,0.2331484,3.15258,3.4382653,52.3739294,60.3477575,0.1406409,17.5518035,16.6130374,32.7690839,6.1056002,6.676978,2.8740875,20.8777365),(54264,'femur.tif',232,7,112,15.5007457,11.738687,14.7563567,1.8,11.7477647,14.7556435,0.3249607,3.1533904,3.4443904,51.7193687,59.5606262,0.2633429,17.2920663,16.4011943,32.2452733,6.1056002,6.6570133,2.8583718,20.8382205),(54265,'femur.tif',232,7,113,15.2419718,11.7462675,14.7697206,1.8,11.7584367,14.7720748,0.3994123,3.1533221,3.4173813,51.1528334,58.8472302,0.3841619,17.2199779,16.2218865,32.0335403,6.1533002,6.6387024,2.7971187,20.8777365),(54266,'femur.tif',232,7,114,15.180076,11.7558987,14.7701661,1.8,11.7649393,14.7696327,0.4406504,3.164865,3.3917044,51.2845118,58.9040979,0.4602751,17.3671083,16.2043285,32.088077,6.172406,6.6268676,2.7811371,20.8777365),(54267,'femur.tif',232,7,115,15.0632164,11.7707613,14.7743377,1.8,11.7816008,14.7740286,0.4967443,3.1690088,3.3710397,51.2074453,59.0966071,0.5701804,17.5306768,16.1588209,32.0557317,6.172406,6.6438414,2.7744188,20.9056785),(54268,'femur.tif',232,7,116,15.1046793,11.7918889,14.7755257,1.8,11.8004021,14.772317,0.5065767,3.1791908,3.3653698,51.7375949,59.7682407,0.5926223,17.7597839,16.2738253,32.2905304,6.172406,6.6715235,2.7836588,20.9731365),(54269,'femur.tif',232,7,117,15.1108766,11.8245064,14.7807159,1.8,11.8367557,14.7803303,0.5372567,3.1852169,3.3548163,52.0402703,60.7408317,0.6596399,18.1055612,16.3380619,32.8665836,6.206135,6.6715235,2.7836588,21.0685365),(54270,'femur.tif',232,7,118,15.2026209,11.8522204,14.7758264,1.8,11.8652292,14.7749485,0.568606,3.2004646,3.3634616,53.0327703,61.6057477,0.7346336,18.3161737,16.5703348,33.4365453,6.2452146,6.6997704,2.7928217,21.1918785),(54271,'femur.tif',232,7,119,15.2720147,11.8858516,14.771725,1.8,11.9040341,14.7741547,0.565723,3.237074,3.3669374,54.0091886,62.5369253,0.7313366,18.5738304,16.6845702,34.0756068,6.270042,6.7055413,2.770333,21.2872785),(54272,'femur.tif',232,7,120,15.2776777,11.9056632,14.7767983,1.8,11.9271836,14.7791586,0.5965714,3.2383691,3.3823771,54.8794291,63.5335202,0.8036817,18.7836891,16.9466259,34.5620905,6.2806014,6.7263768,2.512275,21.3942525),(54273,'femur.tif',232,7,121,15.3624252,11.9326145,14.7768131,1.8,11.9578862,14.7807685,0.6345623,3.2587468,3.3974614,56.3388497,64.5478294,0.8998324,18.9988409,17.2885019,34.9077269,6.3053748,6.7607916,2.5418489,21.5850525),(54274,'femur.tif',232,7,122,15.5627285,11.9801665,14.7733886,1.8,12.0116826,14.7845362,0.676142,3.3295884,3.3922608,58.5190196,65.52017,1.0157565,19.3146028,17.5754515,36.3710276,6.3507811,6.7983798,2.4306833,21.7758525),(54275,'femur.tif',232,7,123,15.5346096,12.0161036,14.7724328,1.8,12.0473222,14.7794137,0.6998064,3.2998293,3.4135892,59.8731669,66.5158915,1.0740257,19.485617,18.1443225,36.9773943,6.4038465,6.8465705,2.4548828,21.9387105),(54276,'femur.tif',232,7,124,15.5621437,12.0575683,14.7744302,1.8,12.0843996,14.784784,0.7345696,3.3240057,3.4196728,61.5986647,67.871693,1.1652388,19.8474231,18.5314561,37.7019006,6.4327299,6.9018457,2.2779233,22.2528525),(54277,'femur.tif',232,7,125,15.844741,12.0957087,14.7859732,1.8,12.1267229,14.8019025,0.8755628,3.3555622,3.4675749,64.6815755,70.1071924,1.5572126,20.2179317,19.2759283,38.8633854,6.4672245,6.9722001,2.1663889,22.3761945),(54278,'femur.tif',232,7,126,16.1997282,12.1467055,14.7866014,1.8,12.1768962,14.8021667,1.1107341,3.3197943,3.485611,68.0783236,72.9863825,2.1676871,20.9393367,20.5067896,40.0008601,6.5089385,7.050086,2.2170038,22.6508206),(54279,'femur.tif',232,7,127,16.5181554,12.1912765,14.7601775,1.8,12.2080056,14.7688503,1.3278952,3.3194675,3.5832085,71.1009122,76.6390247,2.5937642,21.38838,21.419373,40.7670637,6.5677981,7.1678676,1.5108682,22.9996845),(54280,'femur.tif',232,7,128,16.8566063,12.2258669,14.718504,1.8,12.2544084,14.7345101,1.4539563,3.3721497,3.7112878,73.6850195,81.0158604,2.7712553,21.8295816,21.8510521,41.3827353,6.6071511,7.3306072,1.0460006,23.3138265),(54281,'femur.tif',232,7,129,17.3554969,12.2744355,14.6680084,1.8,12.3346711,14.6259007,-1.541067,3.4170452,3.8497003,77.1557061,88.0398339,2.890027,22.8692696,22.5796564,42.6748264,6.6762684,7.6727346,1.3514531,25.3307863),(54282,'femur.tif',232,7,130,18.1153022,12.3398227,14.6263312,1.8,12.4218578,14.5730225,-1.4064548,3.5140686,3.9985246,81.3623657,96.3067486,2.938405,24.0855709,23.1533233,43.8158131,6.7671663,8.0617236,1.2078706,25.6612964),(54283,'femur.tif',232,7,131,18.6835276,12.3937549,14.6112762,1.8,12.4779282,14.5569549,-1.3661438,3.5806806,4.1678771,86.2250178,103.1006713,2.9853126,24.7369748,24.0806228,44.1843738,6.8704076,8.4418222,1.2007827,28.0925923),(54284,'femur.tif',232,7,132,19.0946626,12.4500761,14.6051021,1.8,12.548356,14.5578984,-1.3426518,3.6349043,4.4360222,90.8810855,108.1732656,3.0196519,24.3851951,25.0023325,43.5257936,6.9830429,8.7957043,1.1872688,28.1947721),(54285,'femur.tif',232,7,133,19.1984138,12.5189354,14.6016763,1.8,12.6453453,14.55275,-1.3051384,3.7162291,4.8017027,95.9039721,112.958121,2.9791796,23.5245972,25.8067978,42.4117044,7.1132501,9.2574877,1.1740234,27.5924443),(54286,'femur.tif',232,7,134,19.950233,12.6254155,14.5649712,1.8,12.7642602,14.5347758,-1.1359165,3.8375816,5.1790681,102.1373839,125.6441075,2.7348615,24.2599835,26.6150393,43.9338197,7.2961358,9.7066866,1.1181373,28.2370964),(54287,'femur.tif',232,7,135,21.1779108,12.7709451,14.5138778,1.8,12.9038215,14.4995769,-1.0659257,3.9789876,5.3416631,109.9247459,142.2229786,2.7038542,26.6252245,27.62631,47.1186543,7.3953372,10.0904389,1.1727325,29.4677083),(54288,'femur.tif',232,7,136,21.4727435,12.7699444,14.5232206,1.8,12.927135,14.5301925,-1.1547022,3.9771063,5.5173999,110.9639218,155.6685436,2.9941224,28.2141128,27.9006678,48.2036811,7.4158691,10.3845872,1.1646983,29.8445142),(54289,'femur.tif',232,7,137,21.3518489,12.7020204,14.6241857,1.8,12.8838094,14.6291288,-1.2276396,3.9306622,5.7621154,110.6643251,164.2071971,3.1557808,28.4977279,28.1541173,46.9239368,7.3489091,10.7858975,1.1566133,35.6698717),(54290,'femur.tif',232,7,138,21.6746205,12.6489857,14.6784343,1.8,12.8223019,14.7064633,-1.2408657,3.9032175,5.9532892,111.6011045,181.8968684,3.2332705,30.554012,28.5920794,48.1408966,7.394655,11.1491547,1.156916,33.0266136),(54291,'femur.tif',232,7,139,22.5208234,12.7016019,14.789097,1.8,12.8884418,14.8591496,-1.3165101,3.9420934,6.0655388,114.181213,202.7263437,3.515952,33.4226441,28.9646137,49.9480207,7.4405099,11.9650963,1.2250907,39.1613191),(54292,'femur.tif',232,7,140,23.823673,12.7078671,14.9071888,1.8,12.8619265,15.0302504,-1.3586796,3.9593442,6.2089959,115.9087497,229.023379,3.7946237,36.8857353,29.2747341,52.2687945,7.4623204,12.3919059,1.1881456,38.0261072),(54293,'femur.tif',232,7,141,25.0536719,12.6285431,14.961659,1.8,12.7680084,15.0750678,-1.3820226,3.8966525,6.3000363,114.9204783,247.8609866,4.0285711,39.3427867,29.4921031,53.4005036,7.4843114,12.5867461,1.1902899,37.5211652),(54294,'femur.tif',232,7,142,24.6106175,12.4626579,14.8875932,1.8,12.6148324,14.9505613,-1.3786368,3.7699598,6.3799198,115.3024876,268.2519106,3.9521656,42.0462822,30.5845404,55.3188623,7.505895,12.8648593,1.1668783,44.6022682),(54295,'femur.tif',232,7,143,23.832351,12.2993626,14.7942043,1.8,12.4521763,14.8884662,-1.4223032,3.8926289,6.2787236,113.4143592,279.7328366,3.8851157,44.5525002,29.1356719,55.986503,7.5191721,12.9297803,1.0873493,48.5060659),(54296,'femur.tif',232,7,144,23.7824062,12.2372916,14.6135757,1.8,12.3972134,14.6604424,-1.4051686,4.002707,6.4017332,115.4326021,293.8033556,3.8559897,45.8943459,28.8386338,58.6959649,7.5514883,13.1406361,1.103902,48.1176861),(54297,'femur.tif',232,7,145,22.8864257,12.1290052,14.549292,1.8,12.2784856,14.5806507,-1.4436966,4.2125432,6.4318258,111.2533204,301.0208573,3.7531162,46.8017739,26.4100127,58.6857316,7.5444378,13.1908401,1.0731812,48.4366222),(54298,'femur.tif',232,7,146,23.9257415,12.0735399,14.3158602,1.8,12.2022118,14.3749977,-1.4419832,4.1701683,6.6332445,117.7047643,330.3708586,3.9218228,49.8053187,28.2254228,65.496037,7.566443,13.1764293,1.0601817,50.060408),(54299,'femur.tif',232,7,147,24.3269095,11.9920829,14.0946319,1.8,12.0672563,14.2022436,-1.4831933,4.539062,6.753682,122.1890512,358.6900753,4.0234491,53.1103001,26.9194495,71.1377714,7.6339483,13.0234981,1.066188,51.1561039),(54300,'femur.tif',232,7,148,25.3663894,11.7363984,13.5981649,1.8,11.760033,13.6155594,1.537834,5.0152525,7.2669754,129.585575,432.2432364,4.2231397,59.4804873,25.8382953,73.3038052,8.1090002,14.483923,1.7029126,53.7079335),(54301,'femur.tif',232,7,149,26.3353878,11.3353014,12.9044569,1.8,11.3467076,12.7326633,1.3980219,5.5697293,7.9094934,143.6818215,526.078848,4.259507,66.5123317,25.7969127,83.8227721,9.0007616,15.6067232,1.820964,57.3139572),(54302,'femur.tif',232,7,150,26.4808311,11.0930301,12.5770658,1.8,11.0956465,12.4571451,1.3619583,5.7084715,7.9423859,137.989441,574.990859,4.2237677,72.3952304,24.1727476,89.7617211,9.2115069,15.8149065,1.8113858,57.3630614),(54303,'femur.tif',232,7,151,27.0255122,10.9313155,12.1765805,1.8,10.9872525,12.0975342,1.3284272,5.6171543,8.0853063,142.8038368,580.5247041,4.2448003,71.7999644,25.4228082,88.9086838,9.2115825,15.7240795,1.8003237,57.6907631),(54304,'femur.tif',232,7,152,27.1322165,10.6705604,11.8659404,1.8,10.724617,11.7863772,1.3137762,5.5634384,8.3277599,133.6853283,604.1508052,4.2298334,72.5466169,24.0292636,88.3518912,9.1073522,15.7597801,1.7966877,58.909801),(54305,'femur.tif',232,7,153,27.6986875,10.5239541,11.6572283,1.8,10.5906398,11.6671196,1.3054024,5.2854363,8.4509748,129.0690302,605.1175885,4.2988559,71.6032886,24.4197493,86.4447718,8.8360924,15.7254541,1.7723561,57.2165714),(54306,'femur.tif',232,7,154,28.0819535,10.4260766,11.6359088,1.8,10.5384656,11.702267,1.3178782,4.9635061,8.4048159,125.9438286,601.4678296,4.3872661,71.5622852,25.3739645,86.1353772,8.4832872,15.5385637,1.7748143,55.1225655),(54307,'femur.tif',232,7,155,28.5711048,10.4023745,11.6704849,1.8,10.4793573,11.7730038,1.3288137,4.622934,8.2771944,124.1705286,585.9907435,4.488418,70.7958176,26.8596802,85.4290242,8.1911147,15.3517695,1.7773324,51.558866),(54308,'femur.tif',232,7,156,27.9973193,10.3842655,11.6596436,1.8,10.4405836,11.7810872,1.3378473,4.3484168,8.4943764,114.8051747,545.0304133,4.4175535,64.1636761,26.4016029,77.612292,7.972464,14.9470829,1.815775,49.1535263),(54309,'femur.tif',232,7,157,26.9052196,10.3360769,11.5469775,1.8,10.3669604,11.738124,1.3763187,4.0443702,8.4078928,101.2130033,476.4041116,4.3167312,56.6615351,25.0256525,68.2444954,8.1268968,14.5660059,1.7585583,47.0479464),(54310,'femur.tif',232,7,158,25.5846324,10.3121786,11.6515526,1.8,10.329502,11.8960385,1.3947404,4.0671191,7.9718036,81.8145296,413.7815106,4.1332964,51.9056326,20.1160888,62.1449653,8.0324726,14.1456041,1.7814186,44.5539866),(54311,'femur.tif',232,7,159,22.8466703,10.3155915,12.269062,1.8,10.3066818,12.4821534,1.4169111,4.1765259,7.2486049,65.2636532,321.4691736,3.7183172,44.3491098,15.6263015,53.3456397,7.7982209,13.4349829,1.7528728,50.1210861),(54312,'femur.tif',232,7,160,14.9219209,10.5727031,14.5074801,1.8,10.4988803,14.2914924,1.3786962,4.0417401,7.7252309,54.1192952,106.8886314,2.3963342,13.8363025,13.3900978,20.7335208,7.0993694,9.0193374,1.7194248,31.6323213),(54313,'femur.tif',232,7,161,10.4961335,10.887603,15.7790179,1.8,10.828295,15.7824157,0.4547442,6.0672143,4.9871442,31.3671291,46.4941261,0.3374947,9.3227957,5.1699392,9.9342486,6.4775769,7.8647163,0.1032896,27.9963697),(54314,'femur.tif',232,7,162,8.8785941,10.9436101,16.4050146,1.8,10.8775114,16.4466952,0.1817418,2.9602014,3.794211,21.5723511,37.2933608,0.048341,9.829016,7.2874607,15.4475533,0.3816,0.7542032,1.2490458,1.9379278),(54315,'femur.tif',232,7,163,8.0530435,10.9101759,16.5677206,1.8,10.9271826,16.6192254,0.0337772,2.6018612,3.6769443,16.0769764,30.0259062,0.0015307,8.1659942,6.1790292,12.4657063,4.9733936,6.896734,0.22317,20.4729885),(54316,'femur.tif',232,7,164,7.4950073,10.8887317,16.6970297,1.8,10.9191114,16.7422565,-0.0590985,2.8933348,3.5444575,11.7741684,26.3783622,0.0043578,7.4421438,4.069411,10.7071533,4.4795326,6.7486652,0.2792705,19.1537566),(54317,'femur.tif',232,7,165,7.1355381,10.8099524,16.6192951,1.8,10.7432703,16.626918,-0.1495453,2.502471,3.3204677,8.9952374,23.0833037,0.0263986,6.951823,3.5945421,9.6238388,3.911399,6.6843004,0.296925,18.1602406),(54318,'femur.tif',232,7,166,6.8897755,10.7880111,16.4077998,1.8,10.744125,16.3767163,-0.1615301,2.3224856,3.3222192,7.7664666,20.2914265,0.0297016,6.1077928,3.3440322,8.2303971,3.9041748,6.4147192,0.2864711,22.8340182),(54319,'femur.tif',232,7,167,6.9241426,10.7626415,16.2001796,1.8,10.7871495,16.1925397,-0.1642221,2.2389117,3.1142916,5.5287748,17.2265509,0.030844,5.5314509,2.4694028,7.2873687,3.4372331,5.9001643,0.2449787,17.6648867),(54320,'femur.tif',232,7,168,6.6660348,10.781902,15.981278,1.8,10.7031403,15.9904863,-0.2383653,1.6149637,2.7519824,2.7126742,11.3846553,0.0619386,4.1368925,1.6797122,5.0668439,2.640797,5.1438652,0.330548,13.6752772),(54321,'femur.tif',232,7,169,2.3698484,10.6807485,15.9233623,1.8,10.6950493,15.8828895,-0.1526413,1.6193642,2.3799249,0.8401582,2.3634555,0.0091314,0.9930799,0.5188198,1.2825744,0.6994734,1.7706919,1.0951011,5.5834676),(54322,'femur.tif',232,7,170,0.4949135,10.1136363,15.9490136,1.8,10.0978798,15.9425329,-0.8918423,0.8837619,1.117935,0.0681563,0.1516801,0.0499567,0.1356788,0.0771207,0.1770119,1.594463,2.2600943,0.8003224,8.4214972),(54323,'femur.tif',232,7,171,0.0006912,9.9693003,16.0272004,1.8,9.9693003,16.0272004,0.7853982,0.000000000000003768,0.000000000000001256,0.0000001,0.0000001,0.0000576,104341313.009636,34780437.6698788,65991240.6326018,0.0477,0.067458,2.3561945,0.134916),(54324,'femur.tif',232,7,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54325,'femur.tif',232,7,173,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54326,'femur.tif',232,7,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54327,'femur.tif',232,7,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54328,'femur.tif',232,7,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54329,'femur.tif',232,7,177,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54330,'femur.tif',232,7,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54331,'femur.tif',232,7,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54332,'femur.tif',232,7,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54333,'femur.tif',232,7,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54334,'femur.tif',232,7,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54335,'femur.tif',232,7,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54336,'femur.tif',232,7,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54337,'tibia-fibula.tif',232,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54338,'tibia-fibula.tif',232,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54339,'tibia-fibula.tif',232,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54340,'tibia-fibula.tif',232,8,4,0.0108804,14.5207904,14.347838,1.8,14.1775006,14.8088006,-0.9302636,0.059058,5.4412003,0.0000167,0.1559395,0.0011657,0.028659,0.0002829,0.0286618,0,0,0,0),(54341,'tibia-fibula.tif',232,8,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54342,'tibia-fibula.tif',232,8,6,0.0046905,14.7231749,18.3293433,1.8,14.7232006,18.3291008,-0.1023498,0.0332639,0.0660001,0.0000041,0.0000087,0.0000082,0.0001324,0.000122,0.0001894,0.107,0.192897,0.5880026,0.3783021),(54343,'tibia-fibula.tif',232,8,7,0.0076786,16.0430185,9.678085,1.8,16.0433132,9.6768129,1.3252443,0.0594443,0.1617406,0.0000104,0.0000965,0.0012041,0.0005967,0.0001751,0.0006603,0,0,0,0),(54344,'tibia-fibula.tif',232,8,8,0.0122595,16.606558,12.5237021,1.8,16.6044552,12.5238642,0.381902,0.0732557,0.0974737,0.0000228,0.0000403,0.0002838,0.0004137,0.0003114,0.0006416,0.1605,0.2675,2.4980915,0.5923022),(54345,'tibia-fibula.tif',232,8,9,0.0060898,14.1242654,17.253048,1.8,14.1240006,17.2537507,0.1895659,0.037092,0.0577098,0.0000061,0.0000124,0.000036,0.0002148,0.000164,0.0003061,0.107,0.192897,2.5535901,0.4096417),(54346,'tibia-fibula.tif',232,8,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54347,'tibia-fibula.tif',232,8,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54348,'tibia-fibula.tif',232,8,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54349,'tibia-fibula.tif',232,8,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54350,'tibia-fibula.tif',232,8,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54351,'tibia-fibula.tif',232,8,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54352,'tibia-fibula.tif',232,8,16,0.14955,12.9354917,14.7114705,1.8,12.9257295,14.719591,-0.7865461,4.866486,5.6437937,0.1047248,1.5085116,0.0124911,0.2672868,0.0215196,0.2506523,0,0,0,0),(54353,'tibia-fibula.tif',232,8,17,2.79732,12.7695004,12.1438709,1.8,13.0662892,12.9452016,1.5264633,4.5005135,4.1963639,10.0798099,21.2523384,0.4653043,5.0644651,2.2397022,6.1066694,1.077574,4.1115021,1.0080591,9.8788719),(54354,'tibia-fibula.tif',232,8,18,10.9200258,13.0139499,11.6002344,1.8,13.0930474,11.6523668,0.9327063,4.206642,4.0115625,25.9845955,46.1089291,1.1742418,11.4940075,6.1770399,16.9275456,3.1716529,8.092837,2.1202859,22.3646878),(54355,'tibia-fibula.tif',232,8,19,19.2949658,13.1269664,11.5994669,1.8,13.1191164,11.680283,0.39572,5.2558239,4.1533205,64.7072761,91.7250549,0.4778371,22.0847524,12.311538,29.4657217,7.7045786,8.8858334,2.080234,30.7379553),(54356,'tibia-fibula.tif',232,8,20,23.6679453,12.5708255,11.6800824,1.8,12.6284362,11.7594047,-0.2489498,5.4826583,5.1363803,132.8107075,176.7784679,0.2394651,34.4169352,24.2237798,54.7018948,8.955075,10.103713,0.3854228,38.1244876),(54357,'tibia-fibula.tif',232,8,21,26.8123427,12.4154435,11.9088643,1.8,12.4246124,11.973884,-0.6966296,5.0806365,6.2803917,220.6385439,252.0200015,1.8397604,40.1280704,43.4273428,74.3317003,9.9412058,11.5699862,1.0264117,43.2595652),(54358,'tibia-fibula.tif',232,8,22,33.1638994,12.4889677,11.7356045,1.8,12.4587577,11.8123113,-0.8599693,6.1577458,6.3291714,298.4374727,345.2556463,3.1743104,54.5498963,48.4653769,93.5558076,10.7301641,12.2799696,1.2008074,41.7723192),(54359,'tibia-fibula.tif',232,8,23,35.2793473,12.0016752,11.4238085,1.8,12.0627892,11.4532681,-1.4293846,6.762512,6.6860626,320.3249791,397.1102352,5.763091,59.3937361,47.3677504,105.5467205,11.4700594,12.6678697,1.2036225,42.5839984),(54360,'tibia-fibula.tif',232,8,24,36.7315393,11.5056075,11.3198474,1.8,11.5715634,11.2857306,1.3949745,6.0175286,7.1275969,314.7901612,436.659924,5.9346163,61.2632745,52.3122003,105.4225729,11.3569603,12.955951,1.2947655,45.2137551),(54361,'tibia-fibula.tif',232,8,25,32.6308581,11.4190591,11.4246307,1.8,11.4871492,11.3058724,1.1093473,6.5222705,6.9770738,295.6540877,452.2225861,4.3603308,64.8155084,45.3299335,104.2339753,11.2863234,13.0281019,1.2360595,45.370453),(54362,'tibia-fibula.tif',232,8,26,29.0366458,11.6766925,11.7296652,1.8,11.7221198,11.5873892,1.1456803,6.291754,6.7806861,248.4634654,431.8432847,4.0162732,63.6872553,39.4903335,98.2818749,10.9161506,12.8268417,1.2701508,48.243322),(54363,'tibia-fibula.tif',232,8,27,23.6602036,12.4654476,12.2680637,1.8,12.4601646,12.0825265,1.4810895,5.6525801,6.3489366,164.0638961,325.7981827,3.9117188,51.3153938,29.0246035,72.4486203,10.1567329,12.5609985,1.2140197,41.1572043),(54364,'tibia-fibula.tif',232,8,28,19.2802706,12.9565459,12.2964561,1.8,12.9921354,12.2715251,-1.4627867,5.5664165,6.5753827,122.7150742,206.2143519,3.1760365,31.3615743,22.045615,48.7666343,9.3848495,11.3320279,1.2983332,36.9667684),(54365,'tibia-fibula.tif',232,8,29,17.0615819,13.3656339,12.5333805,1.8,13.4005767,12.5210816,-1.4792495,5.1270923,6.3844038,94.8758966,175.6572685,2.8198318,27.5134958,18.5048153,41.6075387,8.7041592,11.1025073,1.2216136,36.5333913),(54366,'tibia-fibula.tif',232,8,30,16.6141555,13.5630661,13.036912,1.8,13.595308,13.0017755,-1.4667068,4.8915977,5.7435476,79.4430205,186.1978332,2.7391328,32.4186107,16.2407103,45.6822764,8.2223869,11.5056105,1.234341,34.3025223),(54367,'tibia-fibula.tif',232,8,31,15.7933961,13.7680809,13.1990776,1.8,13.8175129,13.0966461,-1.4535748,4.7050608,5.712246,67.3240557,181.1642554,2.5962288,31.7150655,14.3088598,42.7927407,7.848034,11.4384957,1.2667954,33.5275597),(54368,'tibia-fibula.tif',232,8,32,15.4196614,13.8749383,13.2666266,1.8,13.8771292,13.2645783,-1.4626942,4.4809976,5.8086458,60.5280652,173.5810437,2.5400279,29.8832207,13.507721,39.7113351,7.4900003,11.4866885,1.3020933,34.5554661),(54369,'tibia-fibula.tif',232,8,33,14.8259736,14.0474392,13.3651652,1.8,14.0684685,13.4160956,-1.4698694,4.3751127,5.8274875,53.3419498,162.8185416,2.4459108,27.9397496,12.1921315,36.3780865,7.2225003,11.4069232,1.2757457,32.1992388),(54370,'tibia-fibula.tif',232,8,34,14.1962259,14.1885106,13.5058728,1.8,14.2082143,13.5617113,-1.4776302,4.2506827,5.8361995,48.1068412,151.9318843,2.3455599,26.0326748,11.3174388,33.589879,7.0049101,11.3249535,1.2834119,31.5129179),(54371,'tibia-fibula.tif',232,8,35,14.1906498,14.2724201,13.6494675,1.8,14.2885376,13.6808101,-1.4840683,4.0647549,5.7853567,45.2557974,149.801391,2.3473631,25.8931989,11.1337088,32.9873052,6.7905916,11.2534556,1.2264932,31.4188992),(54372,'tibia-fibula.tif',232,8,36,14.2248084,14.4342442,13.7952807,1.8,14.4442738,13.8261281,-1.4862171,4.0166835,5.7578693,41.928661,147.0269818,2.3538819,25.5349632,10.4386271,31.9791734,6.65255,11.2183012,1.2656355,31.1789366),(54373,'tibia-fibula.tif',232,8,37,13.9339568,14.5404258,13.8286333,1.8,14.55379,13.8830811,-1.4916104,3.9505993,5.8197508,40.3583494,142.5418616,2.3077946,24.4927775,10.2157538,30.6652172,6.5585568,11.1775321,1.2944691,31.1919179),(54374,'tibia-fibula.tif',232,8,38,13.7178666,14.6188428,13.8284057,1.8,14.6353893,13.9364063,-1.4998881,3.9023143,5.9061625,38.9468601,138.5379186,2.2748348,23.4565032,9.9804519,29.3971858,6.4680992,11.1711284,1.2793395,31.24922),(54375,'tibia-fibula.tif',232,8,39,14.0615686,14.6621822,13.8758523,1.8,14.6740281,13.9930618,-1.5061462,3.8333812,5.9503787,39.2130303,140.5279474,2.333813,23.6166394,10.2293584,29.6605026,6.3963443,11.1922465,1.2898703,31.2989179),(54376,'tibia-fibula.tif',232,8,40,14.3299204,14.7527047,13.9229787,1.8,14.7550303,14.004655,-1.5021867,3.8318205,5.974663,38.8583171,143.283613,2.3770952,23.9818735,10.1409543,29.7968417,6.3441268,11.2585413,1.2866221,31.5129179),(54377,'tibia-fibula.tif',232,8,41,14.4139659,14.8162726,14.0218574,1.8,14.8204439,14.1214827,-1.5030249,3.782546,5.9289851,37.6831298,143.7335475,2.3913107,24.2425212,9.9623719,29.8773826,6.2674604,11.2693408,1.2670618,31.4188992),(54378,'tibia-fibula.tif',232,8,42,14.4488265,14.8973678,14.0493394,1.8,14.9080136,14.1583728,-1.5062021,3.6520543,5.8956953,36.8631425,141.3025978,2.3981039,23.9670794,10.0938102,29.4455723,6.1141028,11.2002993,1.2399826,31.1346158),(54379,'tibia-fibula.tif',232,8,43,14.4601344,14.9508908,14.0646858,1.8,14.9506111,14.1614348,-1.5090631,3.5932917,5.8331256,36.6882508,143.0203374,2.4008495,24.5186452,10.2102065,29.8513461,6.0607888,11.0663562,1.2306992,31.1713324),(54380,'tibia-fibula.tif',232,8,44,14.6068362,15.0343551,14.1258457,1.8,15.0382363,14.2486137,-1.5125805,3.5685739,5.8250707,36.6401311,142.6582875,2.4262314,24.4903961,10.2674436,29.6933292,6.000438,11.0486248,1.2352641,30.9519554),(54381,'tibia-fibula.tif',232,8,45,14.813844,15.1095245,14.1448229,1.8,15.1217628,14.260897,-1.5143584,3.5336519,5.801491,36.2177754,146.034115,2.4611181,25.171825,10.2493898,30.3235325,5.9463957,11.0143759,1.259798,30.6309553),(54382,'tibia-fibula.tif',232,8,46,15.1303502,15.19278,14.1705138,1.8,15.204754,14.2779541,-1.5215248,3.4886896,5.7658947,36.2350241,146.859676,2.515608,25.4704055,10.3864281,30.5228874,6.0218803,10.9821054,1.2690739,30.8762949),(54383,'tibia-fibula.tif',232,8,47,15.6817559,15.2629891,14.2408122,1.8,15.2788579,14.3222445,-1.5191063,3.4612254,5.7005097,36.4435878,153.2154977,2.606649,26.8775083,10.5290997,31.8872193,5.962893,10.9821054,1.2690739,30.9779179),(54384,'tibia-fibula.tif',232,8,48,15.9587391,15.3503087,14.2464714,1.8,15.3582113,14.3699759,-1.528729,3.4629778,5.7223477,36.357004,155.238328,2.6550857,27.1284335,10.4987689,32.014311,5.8721148,11.0332,1.2705149,31.1346158),(54385,'tibia-fibula.tif',232,8,49,15.9193951,15.4362275,14.2441214,1.8,15.4592174,14.3821937,-1.5446937,3.4156428,5.708353,36.3925974,153.8441353,2.6514252,26.9507045,10.654685,31.6873939,5.9886722,11.0532869,1.281194,32.7288618),(54386,'tibia-fibula.tif',232,8,50,15.5915478,15.5000599,14.1863161,1.8,15.5316634,14.3289691,-1.5594935,3.3333919,5.8390752,35.5044519,154.9252505,2.5982593,26.5324979,10.6511484,31.586007,5.816055,11.0831553,1.3070845,33.6994661),(54387,'tibia-fibula.tif',232,8,51,15.5863186,15.6152751,14.1257216,1.8,15.6774008,14.2548597,1.5551148,3.3247433,5.7614127,35.2849539,151.0545354,2.597081,26.2183156,10.6128356,31.0911971,6.2401749,10.8998295,1.3329604,33.3395223),(54388,'tibia-fibula.tif',232,8,52,15.4132084,15.7145698,14.0446786,1.8,15.7765286,14.163053,1.5110613,3.254915,5.7400353,34.0582223,140.1027884,2.5597125,24.4080013,10.4636288,29.5704687,5.6460017,10.6426015,1.3990362,28.8724072),(54389,'tibia-fibula.tif',232,8,53,15.3804905,15.7848446,13.9693194,1.8,15.8392013,14.0771776,1.482298,3.1605342,5.6488098,33.0944325,135.8048899,2.5433909,24.0413281,10.4711516,29.1226479,5.5959606,10.3984243,1.3845002,29.7910864),(54390,'tibia-fibula.tif',232,8,54,15.3966645,15.8662635,13.912103,1.8,15.9233261,13.9788927,1.4522935,3.111011,5.4535381,32.3066361,128.9721728,2.5302434,23.6492661,10.38461,29.1999889,5.6638915,9.9827334,1.4038855,29.4257655),(54391,'tibia-fibula.tif',232,8,55,14.8069941,15.9388487,13.6977978,1.8,15.9982498,13.7664064,1.4075947,3.0083918,5.1635407,31.4239086,111.451293,2.4026837,21.5842769,10.4454175,27.1712999,5.4548,9.4651166,1.468878,26.1302734),(54392,'tibia-fibula.tif',232,8,56,14.4105497,16.0019885,13.5184063,1.8,16.0532518,13.5876445,1.3684637,3.0228319,4.8372366,30.8565532,98.2108454,2.3047683,20.3030892,10.2078297,26.1250189,5.4040836,8.9125287,1.4866581,24.88299),(54393,'tibia-fibula.tif',232,8,57,14.0843691,16.0363869,13.4159572,1.8,16.0556721,13.4751402,1.335033,2.9088974,4.5786064,29.6286356,89.3072473,2.2193162,19.5053342,10.1855209,25.4664865,5.3310958,8.4910083,1.4761433,24.0453483),(54394,'tibia-fibula.tif',232,8,58,14.0033196,16.0645147,13.3572107,1.8,16.0587244,13.4122648,1.3192781,2.8198017,4.5468545,29.0675374,84.8280976,2.1893289,18.6564353,10.3083624,24.0929034,5.2889307,8.2066283,1.4990244,23.1947252),(54395,'tibia-fibula.tif',232,8,59,13.7653507,16.1101129,13.2470914,1.8,16.1076287,13.2921568,1.2913678,2.7949066,4.2355566,28.7018461,78.0436459,2.1197053,18.4258298,10.26934,24.7289832,5.2335393,7.9398401,1.4966084,22.5397439),(54396,'tibia-fibula.tif',232,8,60,13.718714,16.1360843,13.1697611,1.8,16.130609,13.1907424,1.2695313,2.7446949,4.0940214,28.6981691,74.1235741,2.0851352,18.1053215,10.4558686,24.581032,5.1988273,7.7225544,1.6401295,22.0674231),(54397,'tibia-fibula.tif',232,8,61,13.6779843,16.1627086,13.0994483,1.8,16.1573485,13.1148802,1.245163,2.7069906,3.9614758,28.6416535,70.4664591,2.0463594,17.7879315,10.5806253,24.4795577,5.1532601,7.5090831,1.6421038,21.6707626),(54398,'tibia-fibula.tif',232,8,62,13.6483413,16.1849062,13.0237985,1.8,16.1809512,13.0325872,1.2206574,2.6576661,3.8437518,28.6360266,67.1897638,2.0070604,17.4802557,10.7748776,24.4299699,5.1083596,7.2997611,1.651503,21.1671022),(54399,'tibia-fibula.tif',232,8,63,13.7292182,16.2087402,12.9628281,1.8,16.2074858,12.9705982,1.1952967,2.6151997,3.7446726,28.6139026,64.6135147,1.9804481,17.2547835,10.9413834,24.4014683,5.0948224,7.131773,1.6383625,21.0157813),(54400,'tibia-fibula.tif',232,8,64,13.8013889,16.2331523,12.9164111,1.8,16.2287335,12.9258573,1.1778864,2.5834705,3.6586865,28.4109105,62.3132726,1.9630274,17.0315967,10.9971879,24.3242582,5.0505853,6.979854,1.6552106,20.6061396),(54401,'tibia-fibula.tif',232,8,65,13.7885979,16.2515699,12.8577389,1.8,16.2501912,12.8635608,1.1526313,2.5824543,3.5414744,28.1499476,59.2925604,1.9191328,16.7423376,10.9004629,24.232186,5.0193691,6.8954841,2.3013046,20.2981209),(54402,'tibia-fibula.tif',232,8,66,13.6619058,16.2660788,12.7881367,1.8,16.2654012,12.7880073,1.1227652,2.5709386,3.4526265,27.8722099,55.7660179,1.8496964,16.1517667,10.8412585,23.718306,4.9747585,6.7843825,2.4175698,19.831177),(54403,'tibia-fibula.tif',232,8,67,13.5435888,16.2852611,12.7274682,1.8,16.2860611,12.7300109,1.0946425,2.5761308,3.3660703,27.6497812,52.6301413,1.7830186,15.635485,10.7330659,23.0200743,4.9444842,6.7443963,2.4123153,19.617177),(54404,'tibia-fibula.tif',232,8,68,13.5266085,16.3013472,12.6696357,1.8,16.2968944,12.6750422,1.0701173,2.5597969,3.3088433,27.3642185,50.1187709,1.7349668,15.1469157,10.689996,22.4031541,4.9276548,6.7088662,2.4182616,19.2702144),(54405,'tibia-fibula.tif',232,8,69,13.5026705,16.3117148,12.6199552,1.8,16.3034503,12.6227763,1.0459514,2.5680292,3.2686669,27.1317889,47.9614062,1.6854034,14.6730784,10.5652184,21.8127763,4.9163841,6.6735758,2.4242709,19.2205166),(54406,'tibia-fibula.tif',232,8,70,13.4665328,16.320595,12.5665512,1.8,16.3182269,12.5667606,1.0102846,2.5703481,3.2307881,26.747757,46.2830904,1.6101047,14.3256347,10.4062779,21.3275427,4.8958352,6.6175848,2.4592761,18.8605727),(54407,'tibia-fibula.tif',232,8,71,13.4169078,16.3201681,12.5173608,1.8,16.3208369,12.5192702,0.9802277,2.5655903,3.2205237,26.2952796,44.7474189,1.5428024,13.8944542,10.2492124,20.859444,4.8690895,6.6102278,2.4478906,18.6962706),(54408,'tibia-fibula.tif',232,8,72,13.3013197,16.3165286,12.4656152,1.8,16.3172782,12.4676547,0.9409637,2.5700987,3.1984574,25.7783461,43.199252,1.4477773,13.5062772,10.0300998,20.2993091,4.8449943,6.5761492,2.4541459,18.5449497),(54409,'tibia-fibula.tif',232,8,73,13.1530513,16.3034304,12.4164669,1.8,16.3050588,12.4124015,0.906497,2.5730101,3.1961837,25.1891814,41.8943015,1.3589697,13.1076012,9.7897716,19.919888,4.8303423,6.5423306,2.4604661,18.4249684),(54410,'tibia-fibula.tif',232,8,74,13.0506879,16.2911289,12.3731744,1.8,16.2931439,12.3747867,0.8723477,2.5792282,3.1633327,24.6069948,40.6910835,1.2757308,12.863359,9.5404489,19.4494689,4.8079178,6.5087761,2.4668517,18.3179684),(54411,'tibia-fibula.tif',232,8,75,12.9809572,16.2793178,12.3279094,1.8,16.2814459,12.3325926,0.8382395,2.5688009,3.1606168,24.1319091,39.518061,1.1958556,12.5032749,9.3942309,19.1173414,4.7945245,6.4754896,2.4733032,18.1979872),(54412,'tibia-fibula.tif',232,8,76,12.7976072,16.2677515,12.2818518,1.8,16.2696987,12.2809881,0.8106791,2.5491394,3.1453167,23.5414284,38.120233,1.1203668,12.1196804,9.2350495,18.702309,4.7861871,6.4097379,2.4864059,18.0466663),(54413,'tibia-fibula.tif',232,8,77,12.7489195,16.2536043,12.2454208,1.8,16.2575456,12.2433248,0.791823,2.5379423,3.1235945,23.137247,37.0474001,1.0760612,11.8605024,9.116538,18.4207885,4.7818408,6.3347256,2.4879568,17.8640059),(54414,'tibia-fibula.tif',232,8,78,12.7244064,16.2363673,12.218044,1.8,16.2453237,12.2193151,0.7759855,2.5324807,3.1055142,22.6903002,36.3398726,1.0404066,11.7017247,8.9597131,18.2241585,4.7642928,6.2816385,2.5134225,17.7256663),(54415,'tibia-fibula.tif',232,8,79,12.7517284,16.2151928,12.1913843,1.8,16.2217186,12.197056,0.7658941,2.4942004,3.119466,22.3041032,35.7878484,1.0212027,11.4724279,8.9423861,17.8447535,4.7254271,6.2631573,2.5322663,17.6629871),(54416,'tibia-fibula.tif',232,8,80,12.7885937,16.2032535,12.1729314,1.8,16.2140936,12.1785692,0.7574819,2.488922,3.0690734,22.0868474,35.2757976,1.0062455,11.4939569,8.8740615,17.8405,4.7145203,6.1886808,2.5344078,17.4360058),(54417,'tibia-fibula.tif',232,8,81,12.768756,16.1763016,12.1570913,1.8,16.1858051,12.1606903,0.7449355,2.4607741,3.0833914,21.7099265,34.8319175,0.9780474,11.2966255,8.8223972,17.634093,4.6707735,6.1448194,2.5294402,17.4176475),(54418,'tibia-fibula.tif',232,8,82,12.6069919,16.1348297,12.1297171,1.8,16.1361325,12.1279439,0.7256596,2.4604906,3.0578629,21.2098398,34.0492022,0.9253604,11.1349669,8.620167,17.3540479,4.6539148,6.0985309,2.5560231,17.2220058),(54419,'tibia-fibula.tif',232,8,83,12.5687648,16.1006819,12.1084869,1.8,16.1014093,12.1050489,0.7072181,2.4354661,3.0684498,20.8055724,33.6273125,0.8842924,10.9590556,8.5427475,17.154515,4.6195896,6.0691267,2.5633697,17.1593267),(54420,'tibia-fibula.tif',232,8,84,12.551323,16.0584491,12.0918496,1.8,16.0555121,12.0906492,0.6986128,2.4400282,3.0794455,20.5411674,33.2019713,0.8653085,10.7818019,8.418414,16.8388702,4.5774559,6.0740765,2.5951309,17.0523267),(54421,'tibia-fibula.tif',232,8,85,12.595182,16.0155477,12.0729016,1.8,16.0139221,12.0705279,0.6828051,2.4365843,3.1223418,20.3118913,33.1129819,0.8357435,10.6051754,8.3362154,16.6130632,4.5691557,6.1020499,2.5876401,17.1409684),(54422,'tibia-fibula.tif',232,8,86,12.5781594,15.9690567,12.0470005,1.8,15.9662973,12.043311,0.6619581,2.4407682,3.1602026,19.9925231,32.9491498,0.7920259,10.4262778,8.1910783,16.3494727,4.5396257,6.1139994,2.5681521,17.0966475),(54423,'tibia-fibula.tif',232,8,87,12.5427199,15.9165724,12.0163596,1.8,15.9109205,12.0143186,0.6414677,2.4383835,3.1669481,19.6871361,32.6012117,0.7484849,10.2942046,8.0738475,16.0973669,4.521525,6.1020499,2.5876401,17.065308),(54424,'tibia-fibula.tif',232,8,88,12.5155693,15.8714325,11.9846363,1.8,15.86252,11.982111,0.6237594,2.4059241,3.1309672,19.2831773,32.3138488,0.7116395,10.3207242,8.0148736,16.1123488,4.5017955,6.0464471,2.6026906,17.0026288),(54425,'tibia-fibula.tif',232,8,89,12.3863098,15.833843,11.9562753,1.8,15.8223665,11.9517266,0.6093757,2.3845985,3.160754,18.7694521,31.7393335,0.6762739,10.0416969,7.8711162,15.691465,4.4639653,6.0464471,2.6026906,16.8069871),(54426,'tibia-fibula.tif',232,8,90,12.3283601,15.7916534,11.9270268,1.8,15.7834202,11.9231892,0.594687,2.3666539,3.1623388,18.3155793,31.3567845,0.6449367,9.9156941,7.739019,15.4384128,4.4261351,6.0386313,2.6224465,16.8199684),(54427,'tibia-fibula.tif',232,8,91,12.2459045,15.7541703,11.9005224,1.8,15.7416699,11.8931137,0.5862364,2.3350587,3.1509472,17.914114,30.7385934,0.62467,9.7553503,7.6718045,15.2322609,4.3883049,5.9922391,2.6180169,16.6373079),(54428,'tibia-fibula.tif',232,8,92,12.1753768,15.7134868,11.8775113,1.8,15.6976359,11.8703045,0.5731206,2.2943386,3.1268154,17.5214687,30.3058837,0.5966793,9.6922522,7.6368276,15.0622305,4.3883049,5.9606302,2.6458276,16.6502892),(54429,'tibia-fibula.tif',232,8,93,12.0459473,15.6804203,11.8538207,1.8,15.6633723,11.8471267,0.5607397,2.2748023,3.1212709,17.3020879,29.5198545,0.5678155,9.4576395,7.6059742,14.832795,4.3504747,5.9191896,2.6213255,16.4103267),(54430,'tibia-fibula.tif',232,8,94,11.8529003,15.6611328,11.8324777,1.8,15.648914,11.8232438,0.5500927,2.2546893,3.1264801,17.1091263,28.5364293,0.5398692,9.1273344,7.5882412,14.4484857,4.3644854,5.8813514,2.596493,16.4859871),(54431,'tibia-fibula.tif',232,8,95,11.9306741,15.6124445,11.8008582,1.8,15.6030581,11.7951797,0.5430742,2.2521793,3.0893463,16.9819667,28.2884795,0.5310176,9.1567848,7.5402375,14.4980583,4.3504747,5.8462065,2.6247167,16.3346662),(54432,'tibia-fibula.tif',232,8,96,12.0341246,15.5579821,11.7710356,1.8,15.5480499,11.7677603,0.5322838,2.2441522,3.0673578,16.9505966,28.0458028,0.5165825,9.1433098,7.5532296,14.5603133,4.3883049,5.7997556,2.6201582,16.2903454),(54433,'tibia-fibula.tif',232,8,97,12.0825513,15.5207084,11.7491097,1.8,15.5157908,11.7474645,0.5269724,2.2432854,3.0640868,16.7953521,27.601972,0.5093346,9.0082213,7.4869439,14.3774678,4.3126444,5.7732923,2.6281936,16.2093079),(54434,'tibia-fibula.tif',232,8,98,12.1188198,15.4785514,11.7268101,1.8,15.4729707,11.7211437,0.5253673,2.2254015,3.0438745,16.6840315,27.2709154,0.5080476,8.9592772,7.4970882,14.319342,4.3385728,5.7267498,2.6236053,16.1649871),(54435,'tibia-fibula.tif',232,8,99,12.2693052,15.4323805,11.7119479,1.8,15.4258947,11.7097547,0.5179291,2.2265781,3.0452573,16.6470137,27.1277348,0.5012136,8.9081913,7.4765012,14.2939404,4.3126444,5.7004497,2.6317594,16.1779683),(54436,'tibia-fibula.tif',232,8,100,12.3629096,15.3872114,11.6879292,1.8,15.3816459,11.685358,0.4998024,2.2223816,3.0464347,16.5836719,27.0123308,0.4732575,8.8668668,7.4621171,14.2001984,4.3443834,5.6803298,2.6189419,16.1779683),(54437,'tibia-fibula.tif',232,8,101,12.4242849,15.3379133,11.6660234,1.8,15.3280206,11.660402,0.4821068,2.2173622,3.0447273,16.5324311,26.6217312,0.4451381,8.7435519,7.4559,14.0737387,4.3126444,5.6745322,2.6399886,16.0266475),(54438,'tibia-fibula.tif',232,8,102,12.4640098,15.288192,11.6497244,1.8,15.2766375,11.6465899,0.4606168,2.218467,3.0457824,16.4686931,26.2648983,0.4104416,8.6233665,7.4234565,13.9964713,4.3504747,5.6490024,2.6482927,15.9693454),(54439,'tibia-fibula.tif',232,8,103,12.4222662,15.2416268,11.6368915,1.8,15.2280358,11.6321906,0.4349428,2.2023049,3.0060239,16.3434087,25.7187414,0.3675811,8.5557342,7.4210472,13.9461544,4.3504747,5.5788986,2.7165525,15.8753266),(54440,'tibia-fibula.tif',232,8,104,12.4330254,15.2023112,11.6267148,1.8,15.1889959,11.620106,0.418924,2.2070507,2.9695165,16.3980435,25.3267875,0.3428783,8.5289262,7.4298443,14.0221641,4.3549508,5.5294265,2.6476513,15.8753266),(54441,'tibia-fibula.tif',232,8,105,12.4065622,15.1614371,11.618488,1.8,15.1490832,11.6126429,0.3981243,2.2111048,2.9605483,16.3897842,24.9475759,0.3107917,8.4266742,7.4124865,13.9338606,4.3549508,5.4815968,2.7085032,15.7683266),(54442,'tibia-fibula.tif',232,8,106,12.3999036,15.106624,11.5984804,1.8,15.0912288,11.592712,0.3640614,2.1944228,3.4924918,16.3322027,24.8561165,0.2620255,7.117015,7.442596,10.4118621,4.3310792,5.4375587,2.7263653,15.6926662),(54443,'tibia-fibula.tif',232,8,107,12.4142783,15.0619476,11.5806738,1.8,15.0460578,11.5744484,0.3215195,2.1798925,2.877104,16.3397432,24.5426826,0.2066179,8.5303426,7.4956646,14.1538247,4.3309434,5.3662929,2.7851557,15.6613266),(54444,'tibia-fibula.tif',232,8,108,12.4169938,15.0107586,11.5642215,1.8,14.9928649,11.5564158,0.2784512,2.1821064,2.8537306,16.4125696,24.3553516,0.1563543,8.5345659,7.521434,14.2309655,4.3310792,5.3140343,2.8453143,15.6429683),(54445,'tibia-fibula.tif',232,8,109,12.4287138,14.9640732,11.5522064,1.8,14.9463441,11.5448041,0.2231936,2.1718696,2.8316886,16.4759511,24.1017832,0.1014881,8.5114526,7.5860684,14.2686534,4.3315907,5.2691391,2.9163159,15.6429683),(54446,'tibia-fibula.tif',232,8,110,12.4452092,14.9200098,11.5429946,1.8,14.9021723,11.5392061,0.1647346,2.1693164,2.823671,16.5049718,24.0068464,0.0557813,8.5019984,7.6083747,14.2841374,4.3335002,5.2432732,2.9982526,15.5673079),(54447,'tibia-fibula.tif',232,8,111,12.4550371,14.8815671,11.5366978,1.8,14.8668073,11.5339823,0.1133902,2.1511349,2.800729,16.420805,24.0100097,0.0265756,8.5727714,7.6335544,14.4314212,4.3335002,5.2356251,0.1953916,15.5986475),(54448,'tibia-fibula.tif',232,8,112,12.4133128,14.8405738,11.529384,1.8,14.8236074,11.5249694,0.0668666,2.1501491,2.8057549,16.3704976,24.1485095,0.0092365,8.6067781,7.6136569,14.3453193,4.3335002,5.2691391,0.2252768,15.629987),(54449,'tibia-fibula.tif',232,8,113,12.4658822,14.8023489,11.5215607,1.8,14.7829493,11.5173418,0.0191025,2.1202253,2.8635132,16.3970931,24.3703666,0.000758,8.5106529,7.733656,14.0150116,4.2800002,5.3854602,0.2305218,15.8126475),(54450,'tibia-fibula.tif',232,8,114,12.4092277,14.7699297,11.5141785,1.8,14.745136,11.5107545,-0.018766,2.1419285,2.8507572,16.4263381,24.4665198,0.0007283,8.5824635,7.668948,14.0595332,4.2800002,5.401381,0.2810207,15.9250245),(54451,'tibia-fibula.tif',232,8,115,12.3179038,14.7355242,11.519719,1.8,14.7037117,11.5184671,-0.0440135,2.1526682,2.8926612,16.2464494,24.4818747,0.0039745,8.4634436,7.5471218,13.671602,4.2800002,5.4815968,0.3279233,16.2773641),(54452,'tibia-fibula.tif',232,8,116,12.2882357,14.7198426,11.5118571,1.8,14.6996475,11.5094319,-0.0603316,2.1650337,2.7285102,16.1726634,24.245946,0.0074456,8.8861481,7.4699362,14.3696007,4.2265002,5.3180725,0.4141386,15.8417598),(54453,'tibia-fibula.tif',232,8,117,12.2716386,14.7025743,11.5142093,1.8,14.6802257,11.5126417,-0.085525,2.1716303,2.7365929,16.2484106,24.2039482,0.0149238,8.8445557,7.4821255,14.2953039,4.2265002,5.3598886,0.4770397,15.797439),(54454,'tibia-fibula.tif',232,8,118,12.2910041,14.6759872,11.5143141,1.8,14.6564988,11.5102436,-0.0909237,2.1615727,2.7188119,16.2610931,24.3564158,0.0168886,8.9584777,7.5228065,14.3865509,4.2680396,5.3628249,0.4993467,15.7660994),(54455,'tibia-fibula.tif',232,8,119,12.2330211,14.6583404,11.5140768,1.8,14.6397178,11.512472,-0.1028345,2.1409175,2.7156452,16.1469044,24.3519316,0.0214847,8.967273,7.5420489,14.328299,4.1730002,5.3628249,0.4993467,15.9227973),(54456,'tibia-fibula.tif',232,8,120,12.2073994,14.6530635,11.5049322,1.8,14.6380236,11.5012773,-0.1222128,2.1475132,2.7327224,16.1585024,23.9712261,0.0302372,8.7719212,7.5242856,14.1019217,4.2265002,5.3886481,0.5080628,15.9227973),(54457,'tibia-fibula.tif',232,8,121,12.219924,14.6329869,11.499218,1.8,14.6174263,11.4951511,-0.1343793,2.1532721,2.7302159,16.2379136,24.0670756,0.0365566,8.8150814,7.5410412,14.1359101,4.2265002,5.422536,0.5387275,15.909816),(54458,'tibia-fibula.tif',232,8,122,12.1195929,14.6280378,11.4858584,1.8,14.6138445,11.4790202,-0.1606843,2.1480279,2.6867709,16.1496877,23.7815045,0.0517062,8.8513333,7.5183788,14.3562332,4.1730002,5.3590875,0.5575411,15.9724951),(54459,'tibia-fibula.tif',232,8,123,11.9705429,14.6393956,11.476632,1.8,14.6337678,11.4730428,-0.2029993,2.1607633,2.6553442,16.0180441,23.318582,0.081092,8.781755,7.4131416,14.1979268,4.1730002,5.3612235,0.62953,15.6698534),(54460,'tibia-fibula.tif',232,8,124,11.9132112,14.6317869,11.4677416,1.8,14.6260144,11.4629381,-0.2218126,2.1658759,2.6642839,15.9168554,23.3967159,0.0960983,8.7816153,7.3489232,14.2023076,4.2244056,5.3734887,0.6156199,15.7455139),(54461,'tibia-fibula.tif',232,8,125,11.8581308,14.6376896,11.4499157,1.8,14.6308767,11.4421662,-0.2462099,2.1849021,2.6918815,15.9207265,23.440278,0.1174039,8.7077674,7.2867001,14.1493535,4.1730002,5.4045595,0.6237017,15.9908534),(54462,'tibia-fibula.tif',232,8,126,11.5842229,14.6926119,11.4289541,1.8,14.6920284,11.4233952,-0.2998499,2.2006509,2.6820659,15.7038404,22.2471774,0.168449,8.2947915,7.135998,13.8176285,4.1730002,5.3398255,0.6575282,15.5812117),(54463,'tibia-fibula.tif',232,8,127,11.6287123,14.7022234,11.4100658,1.8,14.7007553,11.4051168,-0.3107088,2.2029931,2.7032592,15.71718,22.5249,0.1811618,8.3324972,7.1344664,13.8343671,4.2224255,5.3398255,0.6575282,15.808193),(54464,'tibia-fibula.tif',232,8,128,11.6342475,14.7177644,11.3881976,1.8,14.714103,11.3831001,-0.3070282,2.2020057,2.7387075,15.8268161,22.849123,0.1771145,8.3430315,7.1874546,13.734955,4.206708,5.3867887,0.6017758,15.7325326),(54465,'tibia-fibula.tif',232,8,129,11.4464602,14.7859997,11.3646677,1.8,14.7869998,11.3631576,-0.327892,2.1907301,2.7732982,15.7855516,22.2416049,0.1978615,8.0199112,7.2056123,13.3867246,4.2309647,5.3734887,0.6156199,15.7455139),(54466,'tibia-fibula.tif',232,8,130,11.4260771,14.8318657,11.3363195,1.8,14.8315707,11.3297844,-0.3245606,2.1846868,2.6716251,15.8122019,22.1504417,0.1936574,8.2909993,7.2377431,13.761084,4.2246172,5.2813472,0.6921442,15.802816),(54467,'tibia-fibula.tif',232,8,131,11.5574675,14.8648881,11.3159047,1.8,14.8661248,11.3118066,-0.3198757,2.1590741,2.689318,15.9438126,22.6712822,0.1904631,8.4301231,7.38456,13.9468849,4.2044976,5.3048699,0.7283174,15.909816),(54468,'tibia-fibula.tif',232,8,132,11.5938411,14.8887581,11.2959848,1.8,14.8879625,11.2885005,-0.3093962,2.1525997,2.6947834,16.0273656,23.3258403,0.1791446,8.6559238,7.4455857,14.1996575,4.1966057,5.3048699,0.7283174,16.0297973),(54469,'tibia-fibula.tif',232,8,133,11.2107431,14.989508,11.2732811,1.8,14.9949481,11.2703712,-0.3386108,2.1562767,2.6814952,15.9330413,22.0711002,0.2061686,8.2308929,7.3891451,13.7620601,4.197321,5.2650635,0.735081,15.6514951),(54470,'tibia-fibula.tif',232,8,134,11.1306372,15.0362752,11.2618946,1.8,15.0352968,11.2605303,-0.3195262,2.1542675,2.6995841,16.012978,22.5420327,0.1830421,8.3501872,7.4331428,13.8775645,4.1871623,5.2759249,0.5317241,15.8157973),(54471,'tibia-fibula.tif',232,8,135,11.1295096,15.0785669,11.2458337,1.8,15.0797535,11.2406893,-0.2980102,2.1550761,2.7142731,16.1319715,23.2361929,0.159916,8.5607423,7.4855694,14.0862073,4.178612,5.3221075,0.5266273,15.8157973),(54472,'tibia-fibula.tif',232,8,136,11.0500892,15.1260347,11.2329516,1.8,15.1213101,11.2302339,-0.2735769,2.1475045,2.731919,16.203856,23.9106065,0.1344347,8.7523116,7.5454353,14.2485543,4.1901266,5.368426,0.5216183,16.0557598),(54473,'tibia-fibula.tif',232,8,137,10.6930112,15.2495846,11.2116399,1.8,15.2490896,11.2089617,-0.2961985,2.1519211,2.7331024,16.1109286,22.8881056,0.1518366,8.3744046,7.4867655,13.8222246,4.2014581,5.3419692,0.512935,15.8914577),(54474,'tibia-fibula.tif',232,8,138,10.6873806,15.2954071,11.2030037,1.8,15.2916113,11.2044564,-0.2721438,2.1355047,2.7475372,16.2899015,23.8247955,0.1286971,8.6713279,7.6281272,14.1351129,4.2073719,5.3886481,0.5080628,16.0427786),(54475,'tibia-fibula.tif',232,8,139,10.7918834,15.3483542,11.1926426,1.8,15.3366042,11.1912254,-0.256588,2.1303963,2.789994,16.5441811,24.977254,0.1158422,8.9524401,7.7657765,14.3722241,4.2251459,5.4823799,0.4985679,16.1497786),(54476,'tibia-fibula.tif',232,8,140,10.7998479,15.4212751,11.1831927,1.8,15.4090563,11.1869045,-0.2434597,2.1345224,2.8010356,16.8342188,25.5650609,0.1045979,9.1270031,7.8866443,14.5674139,4.2473924,5.5294265,0.4939414,16.2567786),(54477,'tibia-fibula.tif',232,8,141,10.9019255,15.4795416,11.1782653,1.8,15.4594939,11.1849813,-0.2300345,2.1360792,2.9245085,17.1908855,26.858039,0.0944635,9.1837786,8.0478691,14.379128,4.2803123,5.7267498,0.5179874,16.6847786),(54478,'tibia-fibula.tif',232,8,142,10.938741,15.5812601,11.1679362,1.8,15.5680306,11.1719632,-0.2270726,2.1439769,2.7825378,17.6623827,26.9965319,0.0923993,9.702126,8.2381403,15.4048348,4.3186844,5.5549905,0.5024213,16.5594203),(54479,'tibia-fibula.tif',232,8,143,11.0626416,15.6817506,11.1595176,1.8,15.6667081,11.1641475,-0.2212211,2.1469182,2.7810973,18.2147707,27.4840691,0.0887696,9.882455,8.4841475,15.6166493,4.3460781,5.5878697,0.5322095,16.6977599),(54480,'tibia-fibula.tif',232,8,144,11.2704611,15.7498048,11.1555128,1.8,15.7224647,11.1668361,-0.2219827,2.1738608,2.849031,18.9805167,29.2124526,0.0910507,10.2534695,8.7312476,16.1396058,4.4044717,5.6803298,0.5226508,17.2770807),(54481,'tibia-fibula.tif',232,8,145,11.334968,15.8588434,11.1578893,1.8,15.8318048,11.1730147,-0.2345705,2.1926785,3.0420909,19.4988103,29.99963,0.1020554,9.8615165,8.8926901,15.6131253,4.4428045,5.8813514,0.5450997,17.290062),(54482,'tibia-fibula.tif',232,8,146,11.4774457,15.947885,11.1631778,1.8,15.9118366,11.1808187,-0.2212447,2.2223864,3.1678346,20.2865043,31.2018833,0.0921175,9.8495935,9.1282525,15.6392698,4.4802725,6.033178,0.4993467,17.5797224),(54483,'tibia-fibula.tif',232,8,147,11.6660129,16.0475381,11.1536909,1.8,15.9984504,11.170557,-0.2195779,2.2585962,3.0395452,21.2865085,32.3697485,0.0922481,10.6495368,9.4246634,16.5917243,4.5549183,5.9951044,0.575627,17.718062),(54484,'tibia-fibula.tif',232,8,148,11.8145288,16.162323,11.1576395,1.8,16.1054307,11.1790852,-0.2219087,2.28086,3.0539241,22.2130409,33.5835039,0.0953835,10.9968363,9.7388884,17.3886562,4.6190648,5.9958205,0.607802,18.5373455),(54485,'tibia-fibula.tif',232,8,149,11.914213,16.2981917,11.1488603,1.8,16.2477988,11.170204,-0.2216641,2.3191287,3.1007081,23.2050539,34.8380206,0.0959798,11.2355049,10.0059361,17.9635083,4.6941053,6.0284319,0.5510736,18.3179684),(54486,'tibia-fibula.tif',232,8,150,12.0831008,16.4262402,11.1764832,1.8,16.3763157,11.2177001,-0.2454463,2.3830035,3.1304217,24.7039771,36.2055695,0.1189053,11.5657165,10.3667396,18.8216007,4.7987671,6.0740765,0.5464617,18.7276102),(54487,'tibia-fibula.tif',232,8,151,12.1777656,16.5606881,11.1644187,1.8,16.5129954,11.1976487,-0.2393235,2.6017646,3.1675469,26.3373885,37.6232218,0.1140459,11.8777157,10.1228946,19.4288171,5.0691265,6.1590099,0.5687279,19.403177),(54488,'tibia-fibula.tif',232,8,152,11.9523675,16.7073881,11.1959652,1.8,16.6494907,11.2432482,-0.2456246,2.6292611,3.2947516,27.7093631,39.6300769,0.1177863,12.0282443,10.5388403,19.9172177,5.245491,6.2850549,0.53604,20.1911209),(54489,'tibia-fibula.tif',232,8,153,12.1311023,16.8539911,11.1970668,1.8,16.7972992,11.2298043,-0.2356253,2.7955514,3.4168064,29.9636491,42.0991857,0.1101896,12.3212091,10.7183324,20.6565072,5.4543121,6.4175477,0.5046694,21.211423),(54490,'tibia-fibula.tif',232,8,154,12.0197256,17.0484228,11.2134187,1.8,16.9954687,11.2564149,-0.2289369,2.7638814,3.4934593,31.4379734,43.777632,0.103175,12.531313,11.3745738,21.1208465,5.4622252,6.5191021,0.4048918,20.9844417),(54491,'tibia-fibula.tif',232,8,155,12.1206634,17.2324689,11.2187209,1.8,17.1776767,11.2687469,-0.1837378,2.8034921,3.560437,33.3135934,46.4218037,0.067434,13.038232,11.8828918,22.040242,5.4753967,6.6067629,0.3729877,21.2611209),(54492,'tibia-fibula.tif',232,8,156,12.3096713,17.4218426,11.2037402,1.8,17.3683997,11.2685174,-0.1594096,2.9796918,3.6251402,36.0575654,49.2456559,0.0516943,13.5844831,12.1011059,23.1710628,5.7297216,6.7099327,0.6610432,21.8664043),(54493,'tibia-fibula.tif',232,8,157,12.6492073,17.6325795,11.1578574,1.8,17.5848911,11.2103798,-0.0929432,3.0633093,3.6965088,39.4206697,52.2720732,0.0181592,14.1409305,12.8686546,23.9761395,5.8210432,6.8563546,0.4007934,22.4143856),(54494,'tibia-fibula.tif',232,8,158,12.749663,17.7940883,11.1933126,1.8,17.7745426,11.242903,-0.1324192,3.1519824,3.9154692,41.7206621,55.0161344,0.0370433,14.0509686,13.2363245,23.6325095,5.9570689,7.2357641,0.670122,23.3590274),(54495,'tibia-fibula.tif',232,8,159,13.0047628,17.9237227,11.2314206,1.8,17.9170431,11.2672123,-0.1862167,3.2030314,3.9099367,44.6114033,58.1858171,0.0742955,14.8815239,13.9278693,26.0090452,6.111563,7.3091655,0.7387998,23.4476691),(54496,'tibia-fibula.tif',232,8,160,13.6695677,18.0631114,11.2204922,1.8,18.0320007,11.2442397,-0.2151433,3.2370091,4.1466172,48.5097899,63.1389149,0.103836,15.2266082,14.9859913,26.13794,6.2009173,7.7286674,0.6725788,24.7133108),(54497,'tibia-fibula.tif',232,8,161,14.8096005,18.2761053,11.233316,1.8,18.2380277,11.2368702,-0.3065213,3.2329841,4.3872192,53.087691,72.6176221,0.2247342,16.5520844,16.4206472,28.3585995,6.4539669,8.0294574,0.6768221,25.626613),(54498,'tibia-fibula.tif',232,8,162,16.68662,18.4477574,11.2219938,1.8,18.4020515,11.2284682,-0.3027193,3.3759561,4.4849851,60.125533,81.2591239,0.2471671,18.1180366,17.8099275,31.2684395,6.7368413,8.0834591,0.7057548,27.1657841),(54499,'tibia-fibula.tif',232,8,163,18.2924876,18.6244342,11.2511803,1.8,18.5690009,11.2749114,-0.2501804,3.4734877,4.5100514,65.4135875,89.7653832,0.1868738,19.9034057,18.8322496,33.6034509,6.8380549,8.2155172,0.510261,26.4458964),(54500,'tibia-fibula.tif',232,8,164,20.7234114,18.7904134,11.3100125,1.8,18.6954795,11.3164796,-0.1123647,3.6781078,4.430403,69.2167558,102.9832898,0.0434251,23.2446774,18.8185774,36.2382092,6.8039194,8.3214434,0.1810036,26.0049151),(54501,'tibia-fibula.tif',232,8,165,21.8396623,18.701508,11.3644467,1.8,18.6286926,11.3686239,-0.1467062,3.4198123,4.3320896,65.8388392,103.6069778,0.077781,23.916167,19.2521794,36.1522202,6.4243104,8.5399143,0.266252,26.1302734),(54502,'tibia-fibula.tif',232,8,166,19.6110521,18.5921327,11.4543167,1.8,18.5503943,11.4732446,-0.1966929,3.1800135,4.5592204,56.6105061,108.8389811,0.12483,23.8722789,17.8019702,36.2352159,6.3032022,8.92296,0.3615777,26.905236),(54503,'tibia-fibula.tif',232,8,167,18.6000152,18.836867,11.5685178,1.8,18.7887247,11.575472,-0.236994,2.9848477,4.6195708,48.2647238,114.7833021,0.1708797,24.847179,16.1699116,35.2542695,5.979931,9.0129642,0.2032162,26.1692173),(54504,'tibia-fibula.tif',232,8,168,21.6214189,18.9362416,11.5669001,1.8,18.9611551,11.6356924,-0.2447145,2.8964828,4.8602482,41.6843397,123.0023401,0.2115269,25.3078311,14.3913644,32.9796988,5.4949767,9.5770981,0.4261652,29.2798217),(54505,'tibia-fibula.tif',232,8,169,20.4316413,19.3431664,11.8866804,1.8,19.3930022,11.8959546,-0.2664962,2.6392094,5.3378959,30.5577357,127.4911215,0.236172,23.8841529,11.5783673,29.3200051,5.135925,9.958045,0.4324078,29.4647093),(54506,'tibia-fibula.tif',232,8,170,13.8277319,20.2454097,12.1534167,1.8,20.2309486,12.1989641,-0.398862,2.377678,5.8846887,13.0712138,94.6404529,0.3476088,16.082491,5.4974702,18.2824944,2.105589,5.0734817,0.2449787,12.8824763),(54507,'tibia-fibula.tif',232,8,171,5.714791,21.8777298,11.3595256,1.8,21.8848186,11.3457542,-1.1847433,1.1275597,2.908447,1.3953825,10.3377627,0.8174261,3.5543926,1.2375242,3.8345618,2.1916673,5.514654,1.0420236,14.351364),(54508,'tibia-fibula.tif',232,8,172,1.5571218,21.8879502,11.9748479,1.8,22.0735183,11.8280559,-0.8813218,1.3828638,2.993445,0.2729521,1.668078,0.1545018,0.5572436,0.1973818,0.625801,1.0370325,2.3029871,1.0343609,5.5317381),(54509,'tibia-fibula.tif',232,8,173,20.1779478,18.0124018,11.4141943,1.8,18.0151746,11.3751902,-0.389481,5.0882851,5.7895788,49.5202624,109.1878907,0.4848707,18.8593842,9.7322107,26.8182927,5.0809806,9.444228,0.2930846,30.5347094),(54510,'tibia-fibula.tif',232,8,174,26.3339633,18.4026371,11.6918856,1.8,18.3466275,11.6705715,-0.0799397,5.6197004,5.9842254,71.44273,152.7800987,0.0279876,25.5304721,12.7129073,37.4049261,6.2060003,9.1872138,0.235092,34.3835598),(54511,'tibia-fibula.tif',232,8,175,31.8577777,18.4264619,11.8975934,1.8,18.4104243,11.7642229,0.0845853,6.9269556,5.5633258,106.6623178,208.9205871,0.0378981,37.5531819,15.3981523,37.6652201,7.3208646,10.3522159,2.980692,36.301033),(54512,'tibia-fibula.tif',232,8,176,35.7172317,18.011086,11.0125614,1.8,18.0796643,11.0249217,0.669963,5.2039202,7.1714108,148.3752461,318.7876694,2.2953534,44.4525739,28.5122061,61.8728587,9.2257445,15.9793142,2.0853744,54.8253972),(54513,'tibia-fibula.tif',232,8,177,39.4306979,18.189042,10.9579944,1.8,18.247727,10.9833482,0.7993592,5.9568519,7.5384803,139.3210229,502.854653,3.3776287,66.7050433,23.3883643,74.7606452,8.5967172,12.7560207,1.3380246,48.9789587),(54514,'tibia-fibula.tif',232,8,178,47.5286576,18.4938883,12.1836836,1.8,18.5246302,12.1389311,0.9100123,5.5041871,8.8139381,187.4049474,690.5972376,4.9376576,78.3528573,34.0477067,99.1633652,10.2854441,19.2250455,1.7867487,78.7852535),(54515,'tibia-fibula.tif',232,8,179,54.1870776,18.6547549,13.4562196,1.8,18.6358566,13.3298335,1.0453923,5.3591472,10.1090643,263.6326196,931.7061001,6.7592507,92.1654142,49.1930171,118.244233,8.3991833,19.434129,1.7843892,60.4682077),(54516,'tibia-fibula.tif',232,8,180,55.7180648,18.6973272,14.5784526,1.8,18.7059684,14.4703467,1.1644761,5.8166449,10.9800628,350.8608582,1021.0510804,7.8357413,92.9913699,60.3201438,124.7917743,10.5368831,22.4640132,1.7990232,75.7167428),(54517,'tibia-fibula.tif',232,8,181,50.2443699,18.869002,14.9535616,1.8,18.8078475,14.8640284,1.2168456,5.636603,11.3107239,317.9081091,943.6462371,7.3680358,83.4293403,56.4006569,111.0583983,10.5476834,24.9457494,1.706324,86.0571815),(54518,'tibia-fibula.tif',232,8,182,44.9267849,18.9894671,15.1382067,1.8,18.8723834,14.9927294,1.249998,5.3653632,11.4322985,279.6376439,872.1408323,6.7432906,76.287444,52.1190525,100.0744821,9.2048725,25.6667341,1.7829087,89.1503502),(54519,'tibia-fibula.tif',232,8,183,44.0871663,19.0695499,15.0860729,1.8,18.9332807,14.8361226,1.2372066,5.1961859,11.372763,275.3118944,875.4519531,6.5600603,76.9779477,52.9834575,100.696137,9.8924162,25.5750716,1.8137456,94.5652568),(54520,'tibia-fibula.tif',232,8,184,42.0585425,18.9691435,14.8354571,1.8,18.8432095,14.6056853,1.2211597,5.2356836,10.9911851,219.8374144,902.3638973,6.1871977,82.0988718,41.9882928,101.958191,9.8143521,25.1329322,1.8467568,107.8121314),(54521,'tibia-fibula.tif',232,8,185,33.3491356,19.0359025,15.9801891,1.8,19.0207163,15.7256432,1.2584192,4.8676731,11.72652,195.1793937,555.617328,5.0332373,47.381263,40.0970625,63.9939922,5.0950272,20.6787025,1.6225635,56.1138517),(54522,'tibia-fibula.tif',232,8,186,21.1344711,19.4185882,17.5729054,1.8,19.4711578,17.7237841,0.0731498,10.758684,5.0446326,87.07658,156.5557258,0.0188144,31.0341183,8.0936089,22.2149673,4.8685002,12.4094636,1.6614562,38.4755225),(54523,'tibia-fibula.tif',232,8,187,14.0792106,19.4315534,17.4934821,1.8,19.4100782,17.6074027,0.1273111,4.4484233,5.1931419,46.2781181,103.8326832,0.0378279,19.9941933,10.4032632,25.5769363,5.8258932,11.5486915,2.3135973,59.4568144),(54524,'tibia-fibula.tif',232,8,188,11.346875,19.5372664,18.0450158,1.8,19.5524247,18.1272296,0.2114097,3.5563216,5.0731112,27.7096777,83.9006061,0.0832712,16.5382944,7.7916682,21.0695446,5.0928075,8.8824506,1.8830234,41.0761668),(54525,'tibia-fibula.tif',232,8,189,7.4106381,19.1044459,18.9979709,1.8,19.1235572,19.0335412,0.1251788,2.9197384,5.0712507,5.1005728,43.7624303,0.0192529,8.6295142,1.746928,9.5908666,3.5934799,8.4076747,1.4495984,41.0663354),(54526,'tibia-fibula.tif',232,8,190,6.3620687,18.7641634,19.2753505,1.8,18.592232,19.2802794,0.0326695,2.2249132,3.4964629,5.0348502,27.0518722,0.0011313,7.7369253,2.2629423,9.0966928,2.790087,8.9829037,1.7868813,23.590081),(54527,'tibia-fibula.tif',232,8,191,3.2281483,19.3790228,19.9211515,1.8,19.2104853,19.9380481,-0.0934768,1.2486463,3.1196101,0.7172967,7.779656,0.0046875,2.4937912,0.5744595,2.6061834,1.0736724,3.9142848,1.7494273,9.2086821),(54528,'tibia-fibula.tif',232,8,192,0.2708407,19.4435952,20.6794475,1.8,19.4130301,20.6657013,-0.0986564,0.4348793,1.0528156,0.0057071,0.0880833,0.0004379,0.0836645,0.0131234,0.0888146,1.1271986,2.1533336,0.4636476,5.683059),(54529,'tibia-fibula.tif',232,8,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54530,'tibia-fibula.tif',232,8,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54531,'metatarsal.tif',232,10,1,18.2925592,3.4252013,4.7153932,1.8,3.4217333,4.7764386,1.4549592,3.6094085,4.2019141,38.1727757,84.7675654,3.0080335,20.17356,10.575909,27.7861604,6.9542001,9.8687074,1.5222907,46.1279897),(54532,'metatarsal.tif',232,10,2,17.9303418,3.4223086,4.615302,1.8,3.4163503,4.7071193,1.4066337,3.5393214,4.1960104,36.8964078,88.2037816,2.9085759,21.0208681,10.4247123,28.3147396,6.8585001,10.2797225,1.4525998,56.1106506),(54533,'metatarsal.tif',232,10,3,16.491598,3.55658,4.6544728,1.8,3.5196665,4.7109047,1.4402152,3.2964476,4.1287485,34.7986803,79.3179732,2.7019979,19.2111418,10.5564184,26.2367349,6.7628001,9.7269896,2.1860897,64.0367811),(54534,'metatarsal.tif',232,10,4,15.3778903,3.6430834,4.7315105,1.8,3.6213207,4.8051809,1.417878,4.0111657,4.148884,34.6004335,72.0916459,2.5035146,17.3761537,8.6260294,23.9218645,3.0338238,8.9675321,1.6598459,24.3456292),(54535,'metatarsal.tif',232,10,5,15.0711662,3.6614978,4.8005364,1.8,3.6600571,4.8854258,1.4362652,3.1431156,4.2697084,35.4789034,69.5349934,2.4666734,16.285654,11.2878137,22.8494163,3.1550611,9.3981646,1.6353324,24.5493035),(54536,'metatarsal.tif',232,10,6,15.270561,3.6811939,4.84138,1.8,3.6959223,4.9147222,1.4540907,3.0519108,4.2852916,36.7565682,69.3065823,2.5105859,16.1731312,12.0437886,22.7754785,3.2660226,9.5956983,1.6439986,25.9155304),(54537,'metatarsal.tif',232,10,7,15.4630808,3.8218277,5.0047112,1.8,3.8468527,5.0898889,1.5383476,3.0983245,4.3263191,37.5486433,68.4858123,2.5744675,15.8300417,12.1190158,21.9029206,3.2674465,9.563884,1.6442426,29.8873888),(54538,'metatarsal.tif',232,10,8,15.5903822,4.0621171,5.140728,1.8,4.0966563,5.1911676,-1.4717111,3.0910886,4.3687506,32.3596453,69.1890129,2.5729696,15.8372541,10.4686891,20.4153794,4.3564343,8.1219807,1.9111783,20.7116852),(54539,'metatarsal.tif',232,10,9,16.6727629,4.1473072,5.0534474,1.8,4.1606016,5.076719,-1.4298465,3.1361374,4.164616,34.1361312,68.9782531,2.7239525,16.5629326,10.8847691,23.5767777,4.5279967,7.8301344,1.9157386,20.6697779),(54540,'metatarsal.tif',232,10,10,17.4905585,4.2021224,4.9231004,1.8,4.2225299,4.9269148,-1.404236,3.0518257,3.9483032,33.9348996,65.1812983,2.8349666,16.5086861,11.1195406,22.2699558,5.776925,10.2955491,1.7013004,39.9250093),(54541,'metatarsal.tif',232,10,11,15.563884,3.9412229,4.5946658,1.8,3.9755794,4.6042144,-1.2685299,3.7287517,4.3574374,26.7973976,58.2737522,2.364112,13.3733997,7.1866941,18.6694139,5.5327233,10.272444,1.7078625,49.6428519),(54542,'metatarsal.tif',232,10,12,14.5402995,3.7650042,4.4205053,1.8,3.7860954,4.4279492,-1.2461614,4.1549122,4.495014,22.1604831,59.3454193,2.1768348,13.2024992,5.3335623,17.5856331,5.3482338,10.2684808,1.6454238,48.0297154),(54543,'metatarsal.tif',232,10,13,16.0090527,3.9998297,4.3223363,1.8,4.0181843,4.3359172,-1.2731537,3.9875388,4.6287709,27.5179007,66.4386139,2.4386971,14.3534028,6.9009739,19.5100096,5.303133,10.1806991,1.6554988,50.7693592),(54544,'metatarsal.tif',232,10,14,19.0058385,4.3103804,4.2731549,1.8,4.3563038,4.2925856,-1.1549496,4.0965652,4.9236527,38.8762273,82.7796546,2.6507208,16.8126512,9.4899568,24.1768553,5.7104249,6.8060727,0.8550527,32.4067777),(54545,'metatarsal.tif',232,10,15,18.2514608,4.5390265,4.3370054,1.8,4.5435685,4.2981862,-1.2049625,4.3095081,4.8877635,37.6635043,84.695064,2.6526387,17.3279793,8.7396296,23.905296,5.6782001,7.0032671,1.7958881,34.6848911),(54546,'metatarsal.tif',232,10,16,17.7287076,4.6470187,4.4365686,1.8,4.6946647,4.4169299,-1.4847262,3.195916,4.1279457,42.9386841,86.8992178,2.9329494,21.0514439,13.4354857,27.6821285,5.5614592,7.8666332,2.2094313,26.734762),(54547,'metatarsal.tif',232,10,17,16.9066176,4.7860274,4.8455312,1.8,4.8295861,4.7759108,1.5329256,3.2409129,4.1120706,45.4750186,86.5436789,2.8137303,21.0462531,14.0315462,28.7109546,5.9137036,9.6032248,1.6873229,41.4666056),(54548,'metatarsal.tif',232,10,18,15.9433629,4.8912196,5.0619556,1.8,4.9226993,5.0185877,1.4733831,3.2836561,4.303487,44.3748085,78.7169865,2.6320915,18.2914429,13.5138417,27.7143619,6.0609253,9.2971401,1.670465,40.2183605),(54549,'metatarsal.tif',232,10,19,16.1574825,4.8681545,5.1091958,1.8,4.9043305,5.1058181,1.3805515,3.4211909,4.3704905,43.0892926,77.3281869,2.5966191,17.6932512,12.5948226,27.0964712,6.1176074,9.1265784,1.7181308,50.1502737),(54550,'metatarsal.tif',232,10,20,16.2457295,4.7775487,5.0827578,1.8,4.7949114,5.1076918,1.306854,3.43403,4.3695905,41.1135974,81.0203683,2.5233334,18.5418677,11.9724047,27.6662895,6.2559244,9.0782828,1.676409,60.9430979),(54551,'metatarsal.tif',232,10,21,16.7374553,4.6747644,5.0380826,1.8,4.6932727,5.0411088,1.3226219,3.9781266,4.3681928,40.2039735,89.8841538,2.6212628,20.5769659,10.1062579,24.7588486,5.0378845,9.0852299,1.6833923,28.8345277),(54552,'metatarsal.tif',232,10,22,17.7130337,4.6307259,4.9372404,1.8,4.6447901,4.9086773,1.4629355,4.5320428,4.2972417,44.9965733,101.7640157,2.9179598,23.6812411,9.9285412,29.1990053,4.6480485,9.1646875,1.6160616,29.5801131),(54553,'metatarsal.tif',232,10,23,18.7577588,4.6226367,4.5648063,1.8,4.6427199,4.5073843,-1.4405158,4.318695,4.2201963,45.5164135,114.9299591,3.07353,27.2333206,10.5393907,32.7977484,4.9369532,7.3561844,0.7025116,29.7482924),(54554,'metatarsal.tif',232,10,24,21.4194347,4.781235,4.2907559,1.8,4.8047202,4.238962,-1.3190276,4.2756287,4.5418459,51.307638,126.982667,3.3483595,27.9583831,12.0000219,35.2686959,5.897104,7.5290083,0.6562123,33.7361814),(54555,'metatarsal.tif',232,10,25,23.7741965,4.7921213,4.2051549,1.8,4.8263632,4.2019842,-1.3201868,4.2272695,4.6101044,58.6129637,127.4170994,3.7186755,27.6386583,13.8654428,35.6872682,5.8214652,7.6873706,0.6825178,37.2427533),(54556,'metatarsal.tif',232,10,26,24.5992593,4.8420174,4.3791239,1.8,4.9061285,4.3686188,-1.293775,4.1912898,4.4620119,67.2701017,129.1373337,3.793215,28.941504,16.0499763,38.4822121,5.6971459,7.8301344,0.8661471,37.1525265),(54557,'metatarsal.tif',232,10,27,2.9448957,3.9016615,3.1148392,1.8,3.8925209,3.1175503,1.4787684,0.8660696,2.2620167,0.444735,1.8040867,0.4866709,0.7975567,0.5135095,0.9808883,1.6372409,3.2351382,1.7894653,8.5699926),(54558,'metatarsal.tif',232,10,28,9.75855,4.527873,4.3771921,1.8,4.5870964,4.4628461,0.9309763,1.7751707,3.7879384,5.0988806,38.7687877,1.0466534,10.2347989,2.8723326,11.1331684,3.2580861,6.9721755,2.2719786,22.5773657),(54559,'metatarsal.tif',232,10,29,13.9977443,4.4386007,4.8165257,1.8,4.4908622,4.8474089,0.9507423,2.8815702,3.5981925,11.659291,47.673777,1.5452275,13.2493681,4.046159,15.1605615,3.8658215,7.0761219,2.2892022,20.4970644),(54560,'metatarsal.tif',232,10,30,13.9275176,4.3415583,5.0232031,1.8,4.3891998,5.0180634,0.9905683,2.2783988,3.6095542,16.7190188,44.5514131,1.6236251,12.3426358,7.3380564,15.422698,4.4049078,7.1690593,2.2490119,20.8830706),(54561,'metatarsal.tif',232,10,31,12.0484681,4.2838803,5.1242118,1.8,4.3227194,5.1255506,0.9686457,2.7381802,3.6284671,16.4114516,36.6267756,1.3638319,10.0942836,5.9935615,13.377463,4.6239881,6.9410912,2.287897,21.950312),(54562,'metatarsal.tif',232,10,32,10.2965164,4.2733419,5.1384226,1.8,4.2968735,5.1540935,0.9820509,2.5547137,3.4061501,13.1611147,30.3563522,1.1868826,8.9122179,5.1516986,11.4095224,4.2182542,6.750827,2.3127436,19.2229425),(54563,'metatarsal.tif',232,10,33,8.6635402,4.1214806,5.1010963,1.8,4.1282253,5.1250439,1.1214109,2.1648833,3.0971934,10.0965528,22.398201,1.1714351,7.2317735,4.6637862,9.1340705,4.0800735,6.3078974,2.2881991,18.2349816),(54564,'metatarsal.tif',232,10,34,8.1585966,4.0408089,5.0770505,1.8,4.0476586,5.0721665,1.2327521,2.1449702,3.0684809,8.8037755,19.5943311,1.2102097,6.385678,4.1043812,8.9681299,3.9103381,5.5871464,1.6852366,16.0986206),(54565,'metatarsal.tif',232,10,35,8.2812158,4.1039921,5.1333164,1.8,4.1134264,5.1294383,1.2554792,2.1234241,2.9932537,9.0537295,19.3045618,1.2474642,6.4493571,4.2637406,9.3522123,3.8964038,5.6158499,1.5935197,16.208862),(54566,'metatarsal.tif',232,10,36,8.3792809,4.1462102,5.1504719,1.8,4.1683139,5.1562838,1.2791703,2.1009005,2.9530173,9.487489,19.5818259,1.2811054,6.6311247,4.5159155,9.7059857,3.9043937,5.752712,1.5097611,17.0646888),(54567,'metatarsal.tif',232,10,37,8.5262609,4.1642826,5.2040154,1.8,4.1891433,5.2196219,1.3135459,2.1308991,2.9295703,9.873427,20.1566832,1.3290582,6.8804232,4.633456,10.1511688,3.9285404,5.7190037,1.5149884,16.464062),(54568,'metatarsal.tif',232,10,38,8.5403,4.1866785,5.2251789,1.8,4.2140921,5.2388988,1.3188095,2.0952476,2.910341,10.0124041,20.2559793,1.3348991,6.9600021,4.7786256,10.3406426,3.8939281,5.6217359,1.5197045,16.1592145),(54569,'metatarsal.tif',232,10,39,8.6334302,4.2176419,5.2358292,1.8,4.249584,5.2483313,1.3033504,2.1068512,2.8759822,9.879478,20.1668698,1.3384146,7.0121678,4.6892148,10.3554157,3.8918,5.5782147,2.0267715,15.8743815),(54570,'metatarsal.tif',232,10,40,8.6742289,4.2832304,5.2268907,1.8,4.3207729,5.2392887,1.2894334,2.0675806,2.82755,9.9116271,19.4234963,1.3342439,6.8693733,4.7938287,10.3128836,3.8950353,5.579218,2.0139864,16.1341157),(54571,'metatarsal.tif',232,10,41,8.4902261,4.288763,5.2062723,1.8,4.3257461,5.2083844,1.2881696,2.052648,2.7169951,9.5641334,17.6854763,1.3049852,6.5092043,4.6594124,9.7538777,3.8599,5.4414519,1.9872349,15.4200413),(54572,'metatarsal.tif',232,10,42,8.1721206,4.2944172,5.2064855,1.8,4.3260469,5.2014164,1.2748267,2.0397035,2.632689,9.2687476,16.1820028,1.2461532,6.1465683,4.5441642,9.5920748,3.8588544,5.2149428,1.9797042,15.0746145),(54573,'metatarsal.tif',232,10,43,7.9141731,4.3250593,5.1918517,1.8,4.3590164,5.1853162,1.2682809,2.0465641,2.5652632,9.1101932,14.9024416,1.2019549,5.8093227,4.4514575,9.3230652,3.8521858,5.0560243,1.9864582,14.5938474),(54574,'metatarsal.tif',232,10,44,8.2030726,4.3313772,5.139807,1.8,4.3662036,5.1244548,1.2978386,2.0229481,2.4655068,9.0428232,14.0646787,1.2678207,5.7045791,4.4701211,9.3273531,3.8535773,4.8932979,1.6425683,14.3044803),(54575,'metatarsal.tif',232,10,45,7.7442019,4.3281904,5.1820136,1.8,4.360211,5.1777855,1.2913111,2.0121413,2.4643724,8.9408794,13.2211068,1.192479,5.3648981,4.443465,8.945837,3.828,4.8274514,1.6369249,14.1846206),(54576,'metatarsal.tif',232,10,46,7.5447266,4.344217,5.1759923,1.8,4.3721111,5.1631463,1.2716553,1.9671472,2.4180036,8.7236572,12.5561107,1.1482473,5.1927593,4.4346744,8.7310785,3.8170332,4.8274514,1.6369249,14.2374742),(54577,'metatarsal.tif',232,10,47,7.4456547,4.3588513,5.1681003,1.8,4.3869814,5.1581406,1.2902115,1.9183446,2.3890752,8.5109551,12.1510984,1.1457828,5.0861096,4.4366143,8.6067934,3.7724755,4.7342223,1.6449842,14.102134),(54578,'metatarsal.tif',232,10,48,7.3708674,4.360281,5.1637128,1.8,4.3823823,5.1573748,1.2947091,2.3491207,2.3468915,8.3849699,11.7927878,1.1371933,5.0248542,3.5694079,8.5514396,3.7289223,4.6731051,1.6528038,13.9667937),(54579,'metatarsal.tif',232,10,49,7.2564857,4.3721872,5.1410004,1.8,4.3936228,5.1294511,1.3056587,1.8458227,2.3446941,8.1454473,11.3254487,1.1263686,4.8302457,4.4129088,8.2492817,3.701085,4.636487,1.6396528,13.7940803),(54580,'metatarsal.tif',232,10,50,7.2298695,4.3760901,5.1272719,1.8,4.3963539,5.1146079,1.3194396,2.1509761,2.5504862,8.0264942,11.0089505,1.1304374,4.3164125,3.731559,7.2956595,3.6673226,4.5070535,1.6345396,13.4705462),(54581,'metatarsal.tif',232,10,51,7.2349104,4.3856794,5.1162852,1.8,4.4022849,5.10633,1.3251621,2.2170338,2.5452676,7.9185055,10.7519509,1.1345154,4.224291,3.5716666,7.184923,3.6416692,4.4455601,1.642615,13.2604596),(54582,'metatarsal.tif',232,10,52,7.3022576,4.3877369,5.1186264,1.8,4.4010427,5.1116207,1.3256366,2.4891523,2.5482863,7.9118739,10.6463105,1.1453485,4.1778314,3.1785415,7.1350516,3.621102,4.3721624,1.5999851,13.3771132),(54583,'metatarsal.tif',232,10,53,7.2385832,4.3928248,5.0983684,1.8,4.4028051,5.0874694,1.333178,2.4170396,2.5411602,7.7468959,10.317938,1.1395849,4.0603257,3.2051175,6.9947288,3.6194879,4.3330018,1.6814535,13.0986925),(54584,'metatarsal.tif',232,10,54,7.2374112,4.4066305,5.0917109,1.8,4.4204466,5.080786,1.3356657,1.7908229,2.7251745,7.5924486,10.2050486,1.1407667,3.7447322,4.2396422,6.4300345,3.600862,4.3049639,1.6896367,13.0535791),(54585,'metatarsal.tif',232,10,55,7.1678715,4.4119506,5.0741979,1.8,4.4240095,5.0533506,1.3778366,1.799856,2.8018508,7.4650779,9.9990361,1.1507138,3.5687254,4.1475973,6.1952597,3.5917565,4.3797202,1.6363955,13.1328596),(54586,'metatarsal.tif',232,10,56,7.1553579,4.4208216,5.0725479,1.8,4.4324315,5.0540582,1.3993542,1.8102458,2.7817697,7.3895046,9.7973039,1.1578495,3.5219681,4.0820449,6.1618666,3.5916419,4.3525677,1.651503,13.0426328),(54587,'metatarsal.tif',232,10,57,7.0637307,4.4225868,5.0511967,1.8,4.4317567,5.028826,1.4633491,1.8238611,2.6763393,7.2435215,9.4503354,1.163749,3.5310678,3.9715312,6.2373866,3.5914129,4.4711239,1.6995761,13.2946267),(54588,'metatarsal.tif',232,10,58,7.041534,4.4374941,5.0514287,1.8,4.4473942,5.0324483,1.4642793,1.8125966,2.5410833,7.1695643,9.3321574,1.1603239,3.6725114,3.955411,6.4930107,3.5818635,4.3295952,1.6741307,13.2043998),(54589,'metatarsal.tif',232,10,59,7.0846876,4.4518089,5.0401584,1.8,4.4624865,5.0128992,1.4830933,1.8198562,2.5314828,7.1540672,9.3795485,1.1717222,3.7051599,3.9311168,6.5310074,3.5831136,4.4633789,1.6853999,13.8127669),(54590,'metatarsal.tif',232,10,60,7.0784619,4.4505648,5.0339652,1.8,4.4548228,5.0075505,1.4922884,2.1633528,2.5249261,7.0660652,9.2818353,1.1724872,3.6760819,3.2662565,6.4737154,3.5815199,4.5625923,1.7393933,13.4222267),(54591,'metatarsal.tif',232,10,61,7.0583583,4.4590235,5.0314681,1.8,4.4681779,5.0138198,1.528161,1.821886,2.4545641,6.989922,9.0960839,1.1742559,3.7057838,3.8366406,6.5467201,3.5728,4.4892947,1.7277676,13.3584267),(54592,'metatarsal.tif',232,10,62,7.0424262,4.457512,5.0237406,1.8,4.463877,5.0081358,-1.5627953,2.1237628,2.0260267,6.9620703,8.8633891,1.1736626,4.3747642,3.278177,7.0752879,3.5781756,4.1190547,1.7028361,12.6366121),(54593,'metatarsal.tif',232,10,63,7.0872698,4.4643072,5.0175873,1.8,4.4727072,5.0012741,-1.5526128,1.8589581,2.0163642,6.9357117,8.8800403,1.1808211,4.4039864,3.7309672,7.6126442,3.5819716,4.0917891,1.7115908,12.8357523),(54594,'metatarsal.tif',232,10,64,7.1224197,4.4706642,5.0151133,1.8,4.4777284,5.0040825,-1.5356401,1.8598536,2.0779074,6.8906885,8.931683,1.1856034,4.2984027,3.704963,7.5153535,3.5715692,4.1274459,1.4934317,12.8248059),(54595,'metatarsal.tif',232,10,65,7.1614059,4.4802065,4.9972341,1.8,4.4885206,4.9797608,-1.5073947,1.8592808,2.0059816,6.8686655,8.9789264,1.1887762,4.4760761,3.6942593,7.405324,3.5646675,4.1160891,1.821414,12.8544389),(54596,'metatarsal.tif',232,10,66,7.1975568,4.4876605,4.996683,1.8,4.4948743,4.9806493,-1.5109297,1.8526793,2.1107033,6.8595529,9.1157271,1.1952986,4.3188104,3.7025042,7.1851348,3.5409,4.2167167,1.8231143,13.3133132),(54597,'metatarsal.tif',232,10,67,7.1289766,4.495524,4.9877392,1.8,4.5033514,4.9709737,-1.4779366,1.8561501,1.9926214,6.8089764,8.8839,1.1779467,4.4583982,3.668333,7.4282884,3.5409,4.0794601,1.7835281,12.6366121),(54598,'metatarsal.tif',232,10,68,7.1521271,4.5033497,4.9904456,1.8,4.5109232,4.9757671,-1.4814637,1.8470574,2.0232693,6.8285236,8.9218482,1.1825337,4.4096196,3.6969742,7.292759,3.5409,4.0883058,1.929567,12.9259791),(54599,'metatarsal.tif',232,10,69,7.1110405,4.5071835,4.9874758,1.8,4.5149739,4.9718923,-1.4898775,1.8950104,2.0254842,6.8051274,8.8589914,1.17743,4.3737647,3.5910766,7.1989961,3.5889266,4.1071792,1.9195673,13.0162059),(54600,'metatarsal.tif',232,10,70,7.1422857,4.5006305,4.9865519,1.8,4.5025138,4.969496,-1.4713645,2.0734683,2.3198062,6.8266472,8.9658597,1.1786508,3.8649176,3.2923808,6.3820004,3.509,4.1160891,1.821414,13.0986925),(54601,'metatarsal.tif',232,10,71,7.0844898,4.5106535,4.980471,1.8,4.515133,4.96323,-1.495004,1.8362867,2.0568,6.7320482,8.9302242,1.1739785,4.3418049,3.6661203,7.128878,3.509,4.19579,1.7234457,13.3584267),(54602,'metatarsal.tif',232,10,72,7.1193593,4.5114851,4.987851,1.8,4.5130886,4.9782821,-1.4860338,1.8668614,2.5007926,6.6958823,9.1850386,1.1780552,3.672851,3.5867056,6.3270787,3.51975,4.19579,1.7234457,12.9337194),(54603,'metatarsal.tif',232,10,73,7.0675043,4.5136119,4.9775484,1.8,4.5172603,4.9588127,-1.495132,1.8262805,2.3828252,6.6500411,8.9763274,1.1711866,3.7670943,3.6413032,6.5303891,3.4771,4.260412,1.7667235,12.9524059),(54604,'metatarsal.tif',232,10,74,7.0203014,4.5167835,4.9684658,1.8,4.517286,4.950854,-1.5018395,1.8220625,2.0878364,6.6515101,8.9011789,1.1644954,4.2633508,3.6505389,6.8239603,3.4771,4.2732905,1.7813683,13.3474803),(54605,'metatarsal.tif',232,10,75,7.0452611,4.5144191,4.9692993,1.8,4.5140506,4.9569943,-1.4787706,1.8299872,2.148571,6.7407137,9.0275538,1.1642942,4.2016549,3.6834758,7.0761047,3.4771,4.2556322,1.8285016,13.4409132),(54606,'metatarsal.tif',232,10,76,7.0483942,4.5279066,4.9654704,1.8,4.5323902,4.9549109,-1.525432,1.8043089,2.1634104,6.7013178,9.0625709,1.1723165,4.1890207,3.7140635,6.987986,3.4751821,4.3230091,1.7638504,13.0348925),(54607,'metatarsal.tif',232,10,77,7.0320279,4.5289234,4.9592094,1.8,4.5321225,4.9485181,-1.5200956,1.8052511,2.3416893,6.6951999,9.123325,1.1689945,3.8960441,3.708736,6.6135671,3.4452,4.3170024,1.7565982,13.3242596),(54608,'metatarsal.tif',232,10,78,7.0415254,4.5361707,4.9631904,1.8,4.5415794,4.9557967,-1.5410636,1.7891187,2.4780909,6.7184741,9.3409584,1.1725504,3.7694172,3.7551864,6.447365,3.4452,4.3564236,1.7997906,13.2681998),(54609,'metatarsal.tif',232,10,79,6.9949105,4.5383568,4.9588657,1.8,4.5390226,4.9489934,-1.5398913,1.8228274,2.4620746,6.7575224,9.3826386,1.1647053,3.810867,3.7071654,6.4509499,3.4452,4.3721624,1.5999851,13.6104206),(54610,'metatarsal.tif',232,10,80,6.9774583,4.5404183,4.9492485,1.8,4.5394017,4.9341225,-1.5414721,1.8302276,2.2562023,6.8193383,9.5413465,1.16191,4.228941,3.7259509,7.0851374,3.4452,4.3735587,1.7839274,13.0007255),(54611,'metatarsal.tif',232,10,81,6.9094917,4.5514102,4.9335365,1.8,4.5545604,4.9178982,-1.5570627,1.7971091,2.2136445,6.7595802,9.7273479,1.1513648,4.3942683,3.7613632,7.16658,3.4771,4.4314601,1.7371284,13.0986925),(54612,'metatarsal.tif',232,10,82,6.9076504,4.554413,4.9273986,1.8,4.5559831,4.9126982,-1.5499073,1.7969845,2.2374657,6.8185155,9.9609824,1.1507728,4.451904,3.7944208,7.1872854,3.4771,4.3947967,1.805212,13.1889194),(54613,'metatarsal.tif',232,10,83,6.9111697,4.5600253,4.9208147,1.8,4.5630532,4.9047371,-1.5482877,3.7725186,2.6457597,6.9042765,10.2131114,1.1512781,3.860181,1.8301504,3.7158096,3.4771,4.5994668,1.7450668,13.9139401),(54614,'metatarsal.tif',232,10,84,6.9329966,4.5690956,4.9182866,1.8,4.5729546,4.9079408,-1.5519375,1.8116784,2.4204915,6.9467423,10.4722849,1.1550885,4.3265117,3.8344236,7.0138675,3.509,4.4293929,1.7738415,13.0007255),(54615,'metatarsal.tif',232,10,85,6.9614589,4.5819161,4.9074051,1.8,4.5883894,4.9000673,-1.5639372,1.7993902,2.5114252,7.0491212,10.8003102,1.1601886,4.3004706,3.9175057,6.9618907,3.509,4.516977,1.7626518,13.2108121),(54616,'metatarsal.tif',232,10,86,6.9650752,4.5900605,4.9026711,1.8,4.5966951,4.9047099,-1.5588481,1.7937418,2.5043171,7.1554485,11.0904715,1.1606802,4.4285413,3.9891184,7.1420693,3.509,4.4483061,1.7583469,13.0832121),(54617,'metatarsal.tif',232,10,87,6.9864393,4.6016744,4.8867949,1.8,4.6086468,4.8891414,-1.5653282,1.8105142,2.395724,7.2374304,11.4597939,1.1643717,4.7834367,3.9974448,7.5304418,3.5373513,4.4919007,1.7709774,13.2714059),(54618,'metatarsal.tif',232,10,88,6.9982836,4.6145276,4.8675662,1.8,4.6232254,4.8710106,-1.5684243,1.7980796,2.5057745,7.3322434,11.827295,1.166374,4.7200157,4.0778192,7.4952352,3.5409,4.5231681,1.769575,13.2746121),(54619,'metatarsal.tif',232,10,89,7.0492781,4.6270836,4.8540488,1.8,4.6365129,4.8558155,-1.5664489,1.8170926,2.4274,7.4918434,12.2330195,1.1748575,5.0395565,4.1229839,7.9439438,3.5409,4.5796225,1.7599953,13.4208986),(54620,'metatarsal.tif',232,10,90,7.1357693,4.6436477,4.8426059,1.8,4.6534903,4.8463034,-1.5591563,1.8290299,2.5890161,7.6976527,12.7173765,1.1891338,4.91205,4.2085986,7.7390369,3.5612256,4.6344015,1.6327858,13.7257462),(54621,'metatarsal.tif',232,10,91,7.1773554,4.6613086,4.8247209,1.8,4.6765896,4.8220419,-1.5478595,1.8475216,2.5523791,7.9232113,13.06805,1.1955967,5.1199487,4.2885622,7.9449002,3.5728,4.6922287,1.7761917,13.6915791),(54622,'metatarsal.tif',232,10,92,7.2421604,4.6753495,4.8170365,1.8,4.6930094,4.8109612,-1.5424679,2.0011494,2.4723728,8.1672346,13.4139503,1.2060584,5.4255371,4.0812718,8.3314124,3.6142291,4.7369084,1.7126934,14.2142535),(54623,'metatarsal.tif',232,10,93,7.257709,4.6768271,4.8287683,1.8,4.6907679,4.8287586,-1.5459043,1.9845972,2.5195848,8.2426684,13.6434474,1.2088688,5.4149587,4.1533207,8.5011168,3.6269402,4.742276,1.6651103,13.8907194),(54624,'metatarsal.tif',232,10,94,7.3267342,4.6813172,4.8251481,1.8,4.693659,4.8196671,-1.5542782,1.8986462,2.5834958,8.3939879,14.0822819,1.2207892,5.450863,4.4210386,8.4923649,3.668078,4.9815096,1.6927685,14.6685937),(54625,'metatarsal.tif',232,10,95,7.3889048,4.698571,4.8109468,1.8,4.7120486,4.8067499,-1.5597266,1.9695337,2.5720363,8.5448474,14.5535972,1.2313332,5.6583949,4.3385129,8.7617142,3.6544844,4.9866139,1.6348113,14.262573),(54626,'metatarsal.tif',232,10,96,7.3555347,4.7138465,4.8182198,1.8,4.7318516,4.8141299,-1.5481774,1.8939908,2.6376863,8.6428711,14.9039793,1.2252953,5.6503988,4.563312,8.7328262,3.6691846,5.0448416,1.6912298,14.3527998),(54627,'metatarsal.tif',232,10,97,7.5184926,4.7287314,4.8356846,1.8,4.7506846,4.8332186,-1.5371414,2.0462389,2.6805022,8.8611673,15.6536691,1.2516633,5.8398269,4.3304657,8.922139,3.6921542,5.0946208,1.6648576,14.5783669),(54628,'metatarsal.tif',232,10,98,7.5378111,4.7554497,4.7861989,1.8,4.7779818,4.7884718,-1.5275153,2.0898624,2.6588634,9.098051,16.2464078,1.25395,6.1102829,4.3534211,9.2647924,3.7315547,5.1437205,1.6951513,14.6795401),(54629,'metatarsal.tif',232,10,99,7.7103526,4.7676683,4.7517863,1.8,4.7921092,4.7487097,-1.5153367,2.0628897,2.6786881,9.3221652,17.3681501,1.2811103,6.483827,4.5189838,9.689103,3.7340192,5.2669789,1.6071439,14.9875937),(54630,'metatarsal.tif',232,10,100,7.9029308,4.776408,4.7002067,1.8,4.7924181,4.6950489,-1.5104185,1.987889,2.7286325,9.5569234,18.7720078,1.3123593,6.8796394,4.8075739,10.1753115,3.7541494,5.3434167,1.648484,15.122934),(54631,'metatarsal.tif',232,10,101,8.0331719,4.800044,4.668769,1.8,4.8217001,4.6439775,-1.4979166,2.2586116,2.7619166,9.8805853,20.0671697,1.3317633,7.2656683,4.3746279,10.6022944,3.7686735,5.4305945,1.6236881,15.3362267),(54632,'metatarsal.tif',232,10,102,8.0932773,4.8139904,4.64789,1.8,4.8310231,4.6287854,-1.5052708,2.4076019,2.8826937,9.962631,21.3117757,1.3430963,7.3930075,4.1379893,10.8148481,3.7761409,5.5298446,1.6342947,15.6069072),(54633,'metatarsal.tif',232,10,103,8.1516894,4.8241852,4.6241018,1.8,4.838245,4.6028013,-1.4977142,2.031316,2.9227104,10.126948,22.5701398,1.3513714,7.722332,4.9854125,11.0907648,3.802232,5.6754216,1.4694498,15.8775876),(54634,'metatarsal.tif',232,10,104,8.0951354,4.8497756,4.5902372,1.8,4.8643467,4.5648965,-1.4973766,2.0494135,2.9847565,10.3378443,23.6462375,1.3419296,7.922334,5.0442939,11.3401348,3.8344798,5.8023812,1.4716747,16.0535072),(54635,'metatarsal.tif',232,10,105,8.6001842,4.8779771,4.561645,1.8,4.8868795,4.5372966,-1.4937231,2.2439526,3.0265706,11.1703376,25.7994499,1.4248663,8.5243178,4.9779739,12.1937208,3.8959792,5.9183743,1.4952646,16.4969011),(54636,'metatarsal.tif',232,10,106,8.6012729,4.9290236,4.5450446,1.8,4.9249336,4.5230305,-1.4879998,2.4510982,3.0736578,11.5078173,26.7381463,1.4237406,8.6991291,4.6949638,12.4134395,3.9343507,6.0102513,1.4484163,16.8004206),(54637,'metatarsal.tif',232,10,107,8.743744,4.9546165,4.5815112,1.8,4.9601991,4.5532851,-1.473034,2.1275473,3.1742041,11.9554469,27.9176945,1.443407,8.7951795,5.6193565,12.5384002,3.9911984,6.1052467,1.4503298,17.1194206),(54638,'metatarsal.tif',232,10,108,8.5611706,5.0123085,4.5723883,1.8,5.0233431,4.5336922,-1.4678107,2.146062,3.231446,12.120815,27.9610815,1.4117818,8.6528079,5.6479334,12.3850006,4.0321691,6.2166545,1.431802,17.4461608),(54639,'metatarsal.tif',232,10,109,8.5958874,5.0667918,4.5424679,1.8,5.0828053,4.5019592,-1.479071,2.1642067,3.2678322,12.3028032,28.9442638,1.420628,8.8573287,5.684671,12.6113795,4.0677502,6.3199045,1.4645984,17.8521816),(54640,'metatarsal.tif',232,10,110,9.0143083,5.1159503,4.5620107,1.8,5.1411916,4.5153472,-1.4610542,2.2165499,3.3315801,13.0641641,30.1217479,1.4843635,9.0412799,5.8939182,12.9606154,4.1675345,6.3979982,1.4458229,19.4001901),(54641,'metatarsal.tif',232,10,111,9.1461538,5.2307168,4.5091216,1.8,5.2577545,4.464614,-1.4663207,2.182153,3.4056965,13.6476782,30.8703351,1.5077808,9.0643237,6.2542261,13.0356566,4.1796318,6.5751929,1.3705464,19.1185632),(54642,'metatarsal.tif',232,10,112,9.6749443,5.3165527,4.478558,1.8,5.3411537,4.4532415,-1.4782007,2.5705727,3.4017414,14.6739898,33.2880652,1.5987048,9.7855955,5.7084515,14.0545486,4.2238315,6.6064585,1.3715068,19.2042559),(54643,'metatarsal.tif',232,10,113,11.017921,5.4768905,4.4317214,1.8,5.4974435,4.4122304,-1.5041918,2.6667371,3.3127939,17.2014628,37.0259287,1.828186,11.1766471,6.4503782,16.138769,4.7901322,6.6609156,1.218752,21.1492169),(54644,'metatarsal.tif',232,10,114,12.2144752,5.5062207,4.4615114,1.8,5.5229729,4.4546789,-1.5213705,2.6842854,3.377792,18.205024,40.7243716,2.0307768,12.0565068,6.7820746,16.9102943,4.7932317,6.8067455,1.3678861,22.7372546),(54645,'metatarsal.tif',232,10,115,14.8630626,5.6134627,4.4229862,1.8,5.6289016,4.422115,-1.4732534,2.6271278,3.3618249,20.1352678,43.2780445,2.4536823,12.8733783,7.6643656,18.4047144,4.7073003,6.8364313,1.1781588,23.037568),(54646,'metatarsal.tif',232,10,116,14.7309763,5.6221869,4.6452744,1.8,5.6545761,4.6267318,-1.4068429,2.6169038,3.4780942,19.7749966,42.2295769,2.3897554,12.1415851,7.5566389,16.907451,4.6047583,6.5472759,1.2382604,21.4521864),(54647,'metatarsal.tif',232,10,117,13.5980571,5.6417426,4.5989352,1.8,5.6769407,4.5878008,-1.3936918,2.4842267,3.2205579,17.8370271,33.8570805,2.1959968,10.5127998,7.1801125,15.4524032,0.0638,0.1150171,0.9827937,0.2442537),(54648,'metatarsal.tif',232,10,118,13.319584,5.6191905,4.4760141,1.8,5.6594826,4.4887835,-1.4522569,2.5862342,3.0247266,15.3526355,29.0350876,2.188883,9.5992435,5.9362898,13.4736105,4.3113634,6.0209085,1.1213658,19.6244291),(54649,'metatarsal.tif',232,10,119,12.3740699,5.587435,4.4862524,1.8,5.6334995,4.4910432,-1.4858941,2.6132689,3.2300562,11.8589418,25.725528,2.0475145,7.9644213,4.5379722,10.8798612,4.0516176,5.7082285,1.1321435,17.6845523),(54650,'metatarsal.tif',232,10,120,11.1394302,5.5661547,4.4902206,1.8,5.6024041,4.4694715,-1.4871426,2.141425,3.2473873,7.7730597,22.1922778,1.8436098,6.833887,3.6298537,8.7999064,3.6727551,5.7848168,1.1564914,17.1522596),(54651,'metatarsal.tif',232,10,121,8.4717989,5.5249681,4.5008987,1.8,5.5466591,4.4862989,-1.4977066,1.6703979,2.6672568,3.241045,14.4894027,1.404437,5.4323238,1.9402833,6.5026176,2.9014599,5.2032216,1.4540457,14.3282511),(54652,'metatarsal.tif',232,10,122,3.2474192,5.5184028,4.4215192,1.8,5.5072808,4.4522157,-1.4770057,0.8608732,2.0223275,0.4108552,2.7499642,0.5364894,1.3598016,0.4772541,1.5612609,1.6178569,3.9711337,1.4823183,9.6076011),(54653,'metatarsal.tif',232,10,123,11.7595898,7.8385751,4.4735156,1.8,7.8420428,4.4611011,1.5617829,1.6960987,3.1978812,9.3510765,37.1188488,1.9597724,11.6073256,5.5132855,14.5309872,3.5031451,6.3182136,1.5455492,18.1402206),(54654,'metatarsal.tif',232,10,124,12.311067,7.6233767,4.4343316,1.8,7.6361157,4.4284691,1.5493909,2.4290635,3.0897105,12.3965412,36.6067921,2.0509045,11.8479682,5.1034242,15.3346041,3.9046957,6.1864621,1.6689257,17.9861938),(54655,'metatarsal.tif',232,10,125,12.094599,7.4351271,4.4315863,1.8,7.4837248,4.4285342,-1.5570389,2.0112063,3.0709734,14.2104982,32.8732718,2.015385,10.704512,7.0656593,14.355298,4.33732,6.0662026,1.6814535,18.0326352),(54656,'metatarsal.tif',232,10,126,10.629556,7.4470739,4.4545623,1.8,7.4845296,4.4631105,-1.5508442,2.0129052,3.0002824,12.7013766,28.4202266,1.7708875,9.4725172,6.3099725,12.888446,4.4341001,5.8717668,1.5436291,18.8492108),(54657,'metatarsal.tif',232,10,127,9.1003542,7.4809245,4.4851749,1.8,7.5096691,4.4905263,-1.5705744,1.9301022,2.8903481,10.2734848,24.449023,1.5167256,8.4588507,5.3227673,11.3335067,4.4341001,5.5833203,1.5879375,17.3012023),(54658,'metatarsal.tif',232,10,128,7.9110008,7.5373255,4.4686781,1.8,7.5598461,4.4763374,-1.553451,1.9121298,2.6702962,8.0211663,19.4986727,1.3181035,7.3020635,4.1948859,9.3667149,4.4341001,5.255761,1.7169852,16.5793877),(54659,'metatarsal.tif',232,10,129,7.1396114,7.6552921,4.4437691,1.8,7.6791568,4.4648945,-1.5266588,1.8501915,2.6583501,6.19145,15.831078,1.1876186,5.955227,3.3463834,7.5941743,4.4737041,4.9584751,0.6988569,16.1624206),(54660,'metatarsal.tif',232,10,130,6.4404297,7.7704587,4.4537106,1.8,7.7923374,4.4774531,-1.4986067,1.7885123,2.3948824,4.6901413,12.4590809,1.0678208,5.2023768,2.6223702,6.2701136,4.4156093,4.8361916,0.6355857,15.5463133),(54661,'metatarsal.tif',232,10,131,6.1543783,7.8321516,4.49119,1.8,7.8525995,4.5155908,-1.4747318,1.764479,2.3234236,3.9557709,9.5948916,1.016293,4.1296351,2.2418918,5.0614537,4.2746001,4.8715176,0.4109106,14.9379462),(54662,'metatarsal.tif',232,10,132,5.4670399,8.0052053,4.5248363,1.8,8.0255996,4.546909,-1.4901485,1.5578897,2.2386168,2.9221649,7.1251025,0.9052598,3.1828147,1.87572,3.9342972,4.1059559,4.6871295,0.4057854,14.5287194),(54663,'metatarsal.tif',232,10,133,4.7883813,8.2256842,4.5464243,1.8,8.2412594,4.5632081,-1.5184471,1.2791352,2.1174006,1.7603221,5.244142,0.7958785,2.4766886,1.3761814,2.9493915,3.9743803,4.51416,0.3686959,14.0215255),(54664,'metatarsal.tif',232,10,134,4.0771356,8.4272415,4.5552537,1.8,8.4310412,4.5594782,-1.5318207,1.0511284,1.9762942,1.0574728,3.7569073,0.6784909,1.9009859,1.0060358,2.2140574,3.8641347,4.3272442,0.4174758,13.5330182),(54665,'metatarsal.tif',232,10,135,3.4930096,8.643221,4.5440416,1.8,8.6419231,4.5445225,-1.532501,0.9281744,1.8286974,0.6285495,2.6387151,0.5813149,1.442948,0.677189,1.6692704,3.7642,4.1906937,0.5351976,13.9048718),(54666,'metatarsal.tif',232,10,136,2.8446574,8.8400864,4.5447492,1.8,8.8342839,4.5460667,-1.5471132,0.8317958,1.6867877,0.3458049,1.6757679,0.4738437,0.993467,0.4157329,1.1432436,3.4771,4.0456445,0.6624263,12.9233231),(54667,'metatarsal.tif',232,10,137,2.0356023,9.0068029,4.5431972,1.8,8.9924697,4.5368491,-1.5556756,0.6510605,1.4867318,0.1528321,0.8728217,0.3391895,0.5870741,0.2347433,0.6682483,3.1262,3.8313215,0.9689378,12.089389),(54668,'metatarsal.tif',232,10,138,1.1622952,9.1402724,4.5407568,1.8,9.1259367,4.5294926,-1.5611464,0.4644799,1.257606,0.0410605,0.351093,0.1936978,0.2791757,0.0884009,0.3054586,2.8072,3.7714921,1.4265069,15.1170718),(54669,'metatarsal.tif',232,10,139,0.4651578,9.2740152,4.5553486,1.8,9.2615535,4.5453903,1.5683476,0.2465643,0.9503115,0.0048075,0.0820863,0.0775258,0.0863784,0.019498,0.0904771,2.4563,3.7170003,1.6653412,13.145684),(54670,'metatarsal.tif',232,10,140,0.0330518,9.3893891,4.522019,1.8,9.3856289,4.5173645,1.5501606,0.0454734,0.4228267,0.0000214,0.0012227,0.0055063,0.0028918,0.0004696,0.0029411,2.1373,3.5182678,1.4981969,11.166556),(54671,'metatarsal.tif',232,10,141,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54672,'metatarsal.tif',232,10,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54673,'metatarsal.tif',232,10,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54674,'metatarsal.tif',232,10,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54675,'metatarsal.tif',232,10,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54676,'metatarsal.tif',232,10,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54677,'metatarsal.tif',232,10,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54678,'metatarsal.tif',232,10,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54679,'metatarsal.tif',232,10,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54680,'metatarsal.tif',232,10,150,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54681,'metatarsal.tif',232,10,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54823,'okapi_humerus.tif',236,2,142,615.77169,82.383481,107.731213,1.8,88.165468,107.156762,-0.084635,16.526732,35.401287,30422.562366,126675.157452,0.733382,3578.264202,1840.809325,4423.854914,29.262063,57.627231,0.153113,182.937931),(54824,'okapi_humerus.tif',236,2,143,616.804689,82.357094,107.869554,1.8,88.189883,107.307925,-0.081226,23.223708,35.608331,30376.027114,126363.939859,0.676751,3548.718424,1307.974912,4400.277869,29.31567,57.652962,0.109984,181.325742),(54825,'okapi_humerus.tif',236,2,144,616.684839,82.386569,107.987702,1.8,88.242776,107.448326,-0.082484,23.206674,35.589821,30340.059039,126276.369891,0.697697,3548.103501,1307.385055,4397.799509,29.29712,57.652962,0.109984,182.32011);
/*!40000 ALTER TABLE `slices_w` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2017-11-24 12:50:52
